C--------------------------------------------------------------
      REAL*8 FUNCTION A172_HATTBB_SIG(HMASS, AMASS,c2b)
c
c     Mods:
c     - define diffmass, Pedro TD, 27-May-1999.
c
c

      IMPLICIT REAL*8(A-H,O-Z)

      REAL*8 XMASS(60),SIGEXP(60)

      DATA XMASS /
     &   0.4500E+02, 0.4550E+02, 0.4600E+02, 0.4650E+02, 0.4700E+02,
     &   0.4750E+02, 0.4800E+02, 0.4850E+02, 0.4900E+02, 0.4950E+02,
     &   0.5000E+02, 0.5050E+02, 0.5100E+02, 0.5150E+02, 0.5200E+02,
     &   0.5250E+02, 0.5300E+02, 0.5350E+02, 0.5400E+02, 0.5450E+02,
     &   0.5500E+02, 0.5550E+02, 0.5600E+02, 0.5650E+02, 0.5700E+02,
     &   0.5750E+02, 0.5800E+02, 0.5850E+02, 0.5900E+02, 0.5950E+02,
     &   0.6000E+02, 0.6050E+02, 0.6100E+02, 0.6150E+02, 0.6200E+02,
     &   0.6250E+02, 0.6300E+02, 0.6350E+02, 0.6400E+02, 0.6450E+02,
     &   0.6500E+02, 0.6550E+02, 0.6600E+02, 0.6650E+02, 0.6700E+02,
     &   0.6750E+02, 0.6800E+02, 0.6850E+02, 0.6900E+02, 0.6950E+02,
     &   0.7000E+02, 0.7050E+02, 0.7100E+02, 0.7150E+02, 0.7200E+02,
     &   0.7250E+02, 0.7300E+02, 0.7350E+02, 0.7400E+02, 0.7450E+02/

      DATA SIGEXP /
     &   0.1094E+01, 0.1084E+01, 0.1052E+01, 0.1029E+01, 0.1013E+01,
     &   0.9973E+00, 0.9827E+00, 0.9694E+00, 0.9568E+00, 0.9438E+00,
     &   0.9314E+00, 0.9193E+00, 0.8879E+00, 0.8576E+00, 0.8291E+00,
     &   0.8000E+00, 0.7722E+00, 0.7452E+00, 0.7187E+00, 0.6931E+00,
     &   0.6679E+00, 0.6431E+00, 0.6197E+00, 0.5967E+00, 0.5740E+00,
     &   0.5522E+00, 0.5298E+00, 0.5087E+00, 0.4880E+00, 0.4677E+00,
     &   0.4479E+00, 0.4288E+00, 0.4106E+00, 0.3938E+00, 0.3775E+00,
     &   0.3616E+00, 0.3462E+00, 0.3313E+00, 0.3168E+00, 0.3028E+00,
     &   0.2892E+00, 0.2763E+00, 0.2639E+00, 0.2416E+00, 0.2200E+00,
     &   0.2001E+00, 0.1813E+00, 0.1636E+00, 0.1468E+00, 0.1311E+00,
     &   0.1164E+00, 0.1026E+00, 0.8982E-01, 0.7761E-01, 0.6589E-01,
     &   0.5514E-01, 0.4532E-01, 0.3642E-01, 0.2842E-01, 0.2128E-01/

      sigtmp = 0.

      diffmass = abs(amass-hmass)
      summass = amass+hmass

      if (summass.gt.149.) goto 999
      if (summass.lt.90.) goto 999
      if (amass.lt.10.) goto 999
      if (hmass.lt.10.) goto 999
      if (diffmass.gt.30.) goto 999
      if (c2b.le.0.) goto 999

      do i = 1,59
        if ((summass.gt.(2.*xmass(i))).and.
     &      (summass.le.(2.*xmass(i+1)))) then
          sigtmp = sigexp(i) +
     &            (summass/2.-xmass(i))*
     &            (sigexp(i+1)-sigexp(i))/0.5
        endif
      enddo

      sigtmp = sigtmp * c2b

 999  A172_hattbb_sig = sigtmp

      RETURN
      END

C---------------------------------------------------------------------
C---------------------------------------------------------------------

      REAL*8 FUNCTION A172_HATTBB_BKG()
C
C Bkg is not a function of the mass
C
      A172_HATTBB_BKG = 0.04D0
      RETURN
      END

C---------------------------------------------------------------------
C---------------------------------------------------------------------

      INTEGER FUNCTION A172_HATTBB_NUMCAND()

      A172_HATTBB_NUMCAND = 0

      END

C---------------------------------------------------------------------
C---------------------------------------------------------------------

      REAL*8 FUNCTION A172_HATTBB_MASS_CAND(ICAND)

      A172_HATTBB_MASS_CAND = 0D0

      END

C---------------------------------------------------------------------
C---------------------------------------------------------------------
      REAL*8 FUNCTION A172_HATTBB_MASS_BKG(X)
C X:  reconstructed mass
C
C 1st degree polynomial + 1 Gaussian fit to reconstructed distribution
C
      IMPLICIT NONE       

      REAL*8 X, XMIN, XMAX
      PARAMETER ( XMIN = 40D0, XMAX = 70D0 )                           

      IF ( X .LE. XMAX .AND. X .GE. XMIN ) THEN                         
        A172_HATTBB_MASS_BKG = 10.
      ELSE                                                              
        A172_HATTBB_MASS_BKG = 1D-10
      ENDIF
C
      RETURN                                                            
      END  
C---------------------------------------------------------------------
C---------------------------------------------------------------------
      REAL*8 FUNCTION A172_HATTBB_MASS_SIG(X, HMASS, AMASS)
C X: reconstructed mass
C HMASS: Higgs mass hypothesis
C
C  A reasonably accurate signal mass distribution to be used
C    until one which matches the one used is found.
C
      IMPLICIT NONE                                          

      REAL*8 X, XMIN, XMAX
      PARAMETER ( XMIN = 40.D0, XMAX = 70.D0 )                           

      REAL*8 HMASS,AMASS,SUMMASS 
      REAL*8 WEIGHT, SIGMASS

      SUMMASS = (HMASS+AMASS)/2.

      SIGMASS =
     .     100.*EXP(-0.5*((x - SUMMASS + 0.25)/1.7)**2.)
C                                                                      
      IF ( X .LE. XMAX .AND. X .GE. XMIN .AND. SIGMASS .GE. 0 ) THEN      
        A172_HATTBB_MASS_SIG = SIGMASS            
      ELSE                                                              
        A172_HATTBB_MASS_SIG = 1D-10
      ENDIF                                                             
C                                                                       
      RETURN                                                            
      END                                                               
C---------------------------------------------------------------------
C---------------------------------------------------------------------

