C--------------------------------------------------------------
      REAL*8 FUNCTION A183_HATTBB_EFF(HMASS, AMASS)
      IMPLICIT NONE
      REAL*8 DELTAM, SIGMAM,HMASS,AMASS
      REAL*8 UPPER_WEIGHT, DELTAMTERM, SIGMAMTERM
      INTEGER LOWER_INDEX
      REAL*8 SIGE_REF(8), DELE_REF(5), NORM_FACTOR

*Efficiency for \sigma= 90  110  130  140  150  160  170  180 \delta m=0
      DATA SIGE_REF / 4.95, 24.0,29.4,27.6,28.6,23.1,19.1,14.8  /
*Effic for \delta m   =  0    5    10   20   40 , \sigma m = 140
      DATA DELE_REF / 27.6, 28.1, 23.8, 15.6, 2.64 /
      NORM_FACTOR = 27.6

      SIGMAM = HMASS+AMASS
      DELTAM = ABS(HMASS-AMASS)
*
      IF (DELTAM .GE. 0. .AND. DELTAM .LT. 5.) THEN
         UPPER_WEIGHT = (DELTAM - 0.)/5.
         LOWER_INDEX = 1
      ELSE IF (DELTAM .GE. 5. .AND. DELTAM .LT. 10.) THEN
         UPPER_WEIGHT = (DELTAM - 5.)/5.
         LOWER_INDEX = 2
      ELSE IF (DELTAM .GE. 10. .AND. DELTAM .LT. 20.) THEN
         UPPER_WEIGHT = (DELTAM - 10.)/10.
         LOWER_INDEX = 3
      ELSE IF (DELTAM .GE. 20. .AND. DELTAM .LE. 40.) THEN
         UPPER_WEIGHT = (DELTAM - 20.)/20.
         LOWER_INDEX = 4
      ELSE 
         LOWER_INDEX = -1
      ENDIF

      IF (LOWER_INDEX .GT. 0) THEN
         DELTAMTERM = (1- UPPER_WEIGHT) * DELE_REF(LOWER_INDEX) +
     .        UPPER_WEIGHT * DELE_REF(LOWER_INDEX + 1)
      ELSE
         DELTAMTERM = 0.
      ENDIF


      IF (SIGMAM .GE. 90. .AND. SIGMAM .LT. 110.) THEN
         UPPER_WEIGHT = (SIGMAM - 90.)/20.
         LOWER_INDEX = 1
      ELSE IF (SIGMAM .GE. 110. .AND. SIGMAM .LT. 130.) THEN
         UPPER_WEIGHT = (SIGMAM - 110.)/20.
         LOWER_INDEX = 2
      ELSE IF (SIGMAM .GE. 130. .AND. SIGMAM .LT. 140.) THEN
         UPPER_WEIGHT = (SIGMAM - 130.)/10.
         LOWER_INDEX = 3
      ELSE IF (SIGMAM .GE. 140. .AND. SIGMAM .LT. 150.) THEN
         UPPER_WEIGHT = (SIGMAM - 140.)/10.
         LOWER_INDEX = 4
      ELSE IF (SIGMAM .GE. 150. .AND. SIGMAM .LT. 160.) THEN
         UPPER_WEIGHT = (SIGMAM - 150.)/10.
         LOWER_INDEX = 5
      ELSE IF (SIGMAM .GE. 160. .AND. SIGMAM .LT. 170.) THEN
         UPPER_WEIGHT = (SIGMAM - 160.)/10.
         LOWER_INDEX = 6
      ELSE IF (SIGMAM .GE. 170. .AND. SIGMAM .LE. 180.) THEN
         UPPER_WEIGHT = (SIGMAM - 170.)/10.
         LOWER_INDEX = 7
      ELSE 
         LOWER_INDEX = -1
      ENDIF

      IF (LOWER_INDEX .GT. 0) THEN
         SIGMAMTERM = (1 - UPPER_WEIGHT) * SIGE_REF(LOWER_INDEX) +
     .        UPPER_WEIGHT * SIGE_REF(LOWER_INDEX + 1)
      ELSE
         SIGMAMTERM = 0.
      ENDIF


      A183_HATTBB_EFF = SIGMAMTERM * DELTAMTERM / NORM_FACTOR

      RETURN
      END

C---------------------------------------------------------------------
C---------------------------------------------------------------------

      REAL*8 FUNCTION A183_HATTBB_BKG()
C
C Bkg is not a function of the mass
C
      A183_HATTBB_BKG = 0.0728D0
      RETURN
      END

C---------------------------------------------------------------------
C---------------------------------------------------------------------

      INTEGER FUNCTION A183_HATTBB_NUMCAND()

      A183_HATTBB_NUMCAND = 0

      END

C---------------------------------------------------------------------
C---------------------------------------------------------------------

      INTEGER FUNCTION A183_HATTBB_MASS_CAND(ICAND)

      A183_HATTBB_MASS_CAND = 0D0

      END

C---------------------------------------------------------------------
C---------------------------------------------------------------------
      REAL*8 FUNCTION A183_HATTBB_MASS_BKG(X)
C X:  reconstructed mass
C
C 1st degree polynomial + 1 Gaussian fit to reconstructed distribution
C
      IMPLICIT NONE       

      REAL*8 X, XMIN, XMAX
      PARAMETER ( XMIN = 50D0, XMAX = 92D0 )                           

      REAL*8 PBAK_COEFF(5)
      DATA PBAK_COEFF / 0.5235E-01, 73.72, 2.249,
     .     -0.2007E-01, 0.5927E-03 /
C                                                                       
      IF ( X .LE. XMAX .AND. X .GE. XMIN ) THEN                         
         A183_HATTBB_MASS_BKG =
     .        PBAK_COEFF(1)*
     .        EXP(-0.5*((X-PBAK_COEFF(2))/PBAK_COEFF(3))**2.) +
     .        PBAK_COEFF(4) + PBAK_COEFF(5)*X
      ELSE                                                              
         A183_HATTBB_MASS_BKG= 0.
      ENDIF
C
      RETURN                                                            
      END  
C---------------------------------------------------------------------
C---------------------------------------------------------------------
      REAL*8 FUNCTION A183_HATTBB_MASS_SIG(X, HMASS, AMASS)
C X: reconstructed mass
C HMASS: Higgs mass hypothesis
C
C Signal mass distribution is fit to a single Gaussian for some masses.
C In between these masses, a Gaussian is constructed by linearly
C interpolating the means and widths of the two nearest Gaussians.
C
      IMPLICIT NONE                                          

      REAL*8 X, XMIN, XMAX
      PARAMETER ( XMIN = 50.D0, XMAX = 92.D0 )                           

      REAL*8 SIGPAR(28), QNEWPAR(4)
      REAL*8 HMASS,AMASS,SUMMASS 
      REAL*8 WEIGHT, SIGMASS
      DATA  SIGPAR
     .     / 94.77    , 60.17    , 2.418     , 0.0     ,
     .       110.8    , 64.97    , 1.921     , 0.0     ,
     .       133.1    , 69.71    , 1.761     , 0.0     ,
     .       125.7    , 74.66    , 1.728     , 0.0     ,
     .       127.3    , 79.34    , 1.339     , 0.0     ,
     .       104.2    , 84.17    , 1.381     , 0.0     ,
     .         1.     , 90.00    , 1.4       , 0.0       /
C
C  Interpolation of fit parameters between two nearest fitted masses

      SUMMASS = (HMASS+AMASS)/2.

      IF ( SUMMASS .GE. 60.0 .AND. SUMMASS .LT. 65.0) THEN
         WEIGHT = (SUMMASS - 60.0)/5.0
         QNEWPAR(4) = (1.0 - WEIGHT)*SIGPAR(4) + WEIGHT*SIGPAR(8)
         QNEWPAR(1) = (1.0 - WEIGHT)*SIGPAR(1) + WEIGHT*SIGPAR(5)
         QNEWPAR(2) = (1.0 - WEIGHT)*SIGPAR(2) + WEIGHT*SIGPAR(6)
         QNEWPAR(3) = (1.0 - WEIGHT)*SIGPAR(3) + WEIGHT*SIGPAR(7)
      ELSE IF ( SUMMASS .GE. 65.0 .AND. SUMMASS .LT. 70.0) THEN
         WEIGHT = (SUMMASS - 65.0)/5.0
         QNEWPAR(4) = (1.0 - WEIGHT)*SIGPAR(8) + WEIGHT*SIGPAR(12)
         QNEWPAR(1) = (1.0 - WEIGHT)*SIGPAR(5) + WEIGHT*SIGPAR(9)
         QNEWPAR(2) = (1.0 - WEIGHT)*SIGPAR(6) + WEIGHT*SIGPAR(10)
         QNEWPAR(3) = (1.0 - WEIGHT)*SIGPAR(7) + WEIGHT*SIGPAR(11)
      ELSE IF ( SUMMASS .GE. 70.0 .AND. SUMMASS .LT. 75.0) THEN
         WEIGHT = (SUMMASS - 70.0)/5.0
         QNEWPAR(4) = (1.0 - WEIGHT)*SIGPAR(12) + WEIGHT*SIGPAR(16)
         QNEWPAR(1) = (1.0 - WEIGHT)*SIGPAR(9) + WEIGHT*SIGPAR(13)
         QNEWPAR(2) = (1.0 - WEIGHT)*SIGPAR(10) + WEIGHT*SIGPAR(14)
         QNEWPAR(3) = (1.0 - WEIGHT)*SIGPAR(11) + WEIGHT*SIGPAR(15)
      ELSE IF ( SUMMASS .GE. 75.0 .AND. SUMMASS .LT. 80.0) THEN
         WEIGHT = (SUMMASS - 75.0)/5.0
         QNEWPAR(4) = (1.0 - WEIGHT)*SIGPAR(16) + WEIGHT*SIGPAR(20)
         QNEWPAR(1) = (1.0 - WEIGHT)*SIGPAR(13) + WEIGHT*SIGPAR(17)
         QNEWPAR(2) = (1.0 - WEIGHT)*SIGPAR(14) + WEIGHT*SIGPAR(18)
         QNEWPAR(3) = (1.0 - WEIGHT)*SIGPAR(15) + WEIGHT*SIGPAR(19)
      ELSE IF ( SUMMASS .GE. 80.0 .AND. SUMMASS .LT. 85.0) THEN
         WEIGHT = (SUMMASS - 80.0)/5.0
         QNEWPAR(4) = (1.0 - WEIGHT)*SIGPAR(20) + WEIGHT*SIGPAR(24)
         QNEWPAR(1) = (1.0 - WEIGHT)*SIGPAR(17) + WEIGHT*SIGPAR(21)
         QNEWPAR(2) = (1.0 - WEIGHT)*SIGPAR(18) + WEIGHT*SIGPAR(22)
         QNEWPAR(3) = (1.0 - WEIGHT)*SIGPAR(19) + WEIGHT*SIGPAR(23)
      ELSE IF ( SUMMASS .GE. 85.0 .AND. SUMMASS .LE. 90.0) THEN
         WEIGHT = (SUMMASS - 85.0)/5.0
         QNEWPAR(4) = (1.0 - WEIGHT)*SIGPAR(24) + WEIGHT*SIGPAR(28)
         QNEWPAR(1) = (1.0 - WEIGHT)*SIGPAR(21) + WEIGHT*SIGPAR(25)
         QNEWPAR(2) = (1.0 - WEIGHT)*SIGPAR(22) + WEIGHT*SIGPAR(26)
         QNEWPAR(3) = (1.0 - WEIGHT)*SIGPAR(23) + WEIGHT*SIGPAR(27)
      ELSE
         WRITE(6,*) 'This cannot be happening to me!'
      ENDIF
C
      SIGMASS = QNEWPAR(4) +
     .     QNEWPAR(1)*EXP(-0.5*((x - QNEWPAR(2))/QNEWPAR(3))**2.)
C                                                                      
      IF ( X .LE. XMAX .AND. X .GE. XMIN .AND. SIGMASS .GE. 0 ) THEN      
        A183_HATTBB_MASS_SIG = SIGMASS            
      ELSE                                                              
        A183_HATTBB_MASS_SIG = 0.
      ENDIF                                                             
C                                                                       
      RETURN                                                            
      END                                                               
C---------------------------------------------------------------------
C---------------------------------------------------------------------

