C----------------------------------------------------------------------
C----------------------------------------------------------------------
      real*8 FUNCTION A183_hll_eff(HMASS)

      implicit none

      real*8 HMASS

      real*8 m, b

      m = 0.d0
      b = 0.d0

      if ((HMASS.ge.60.).and.(HMASS.le.70.)) then
        m = -0.0018d0
        b = 0.904d0
      elseif ((HMASS.gt.70.).and.(HMASS.le.80.0)) then
        m = 0.0005d0
        b = 0.743d0
      elseif ((HMASS.gt.80.).and.(HMASS.le.85.0)) then
        m = -0.0042d0
        b = 1.119d0
      elseif ((HMASS.gt.85.).and.(HMASS.le.90.0)) then
        m = -0.0086d0
        b = 1.493d0
      elseif ((HMASS.gt.90.).and.(HMASS.le.95.0)) then
        m = -0.0816d0
        b = 8.063d0
      elseif ((HMASS.gt.95.).and.(HMASS.le.100.0)) then
        m = -0.0542d0
        b = 5.46d0
      endif

      A183_hll_eff = m*HMASS + b
      
      return
      end
C----------------------------------------------------------------------
C----------------------------------------------------------------------
      DOUBLE PRECISION FUNCTION A183_hll_bkg()

      IMPLICIT DOUBLE PRECISION(A-H,O-Z)

      A183_hll_bkg = 2.000D0

      END

C----------------------------------------------------------------------
C----------------------------------------------------------------------
      INTEGER FUNCTION A183_HLL_NUMCAND()

      IMPLICIT DOUBLE PRECISION(A-H,O-Z)

      A183_HLL_NUMCAND = 3

      END
C----------------------------------------------------------------------
C----------------------------------------------------------------------

      DOUBLE PRECISION FUNCTION A183_HLL_MASS_CAND(ICAND)

      IMPLICIT DOUBLE PRECISION(A-H,O-Z)

      A183_HLL_MASS_CAND = 0D0
      IF (ICAND.EQ.1) THEN
        A183_HLL_MASS_CAND = 82.2D0
      ELSE IF (ICAND.EQ.2) THEN
        A183_HLL_MASS_CAND = 96.5D0
      ELSE IF (ICAND.EQ.3) THEN
        A183_HLL_MASS_CAND = 67.0D0
      ENDIF
      END

C----------------------------------------------------------------------
C----------------------------------------------------------------------

      DOUBLE PRECISION FUNCTION A183_HLL_BTAG_CAND(ICAND)

      IMPLICIT DOUBLE PRECISION(A-H,O-Z)

      A183_HLL_BTAG_CAND = 0D0
      IF (ICAND.EQ.1) THEN
        A183_HLL_BTAG_CAND = 0.94D0
      ELSE IF (ICAND.EQ.2) THEN
        A183_HLL_BTAG_CAND = 1.89D0
      ELSE IF (ICAND.EQ.3) THEN
        A183_HLL_BTAG_CAND = 1.07D0
      ENDIF
      END

C----------------------------------------------------------------------
C----------------------------------------------------------------------

      DOUBLE PRECISION FUNCTION A183_hll_mass_bkg(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  16, 1)
      DOUBLE PRECISION SIGDEL(  16)
      DOUBLE PRECISION SIGA(  16)
      DATA NPAR, NDIM, IMQFUN /   16,    1,    1/
      DATA VCONST / 0.0000000000000E+00/
      DATA SIGVMI /  65.00000000000    /
      DATA SIGVT /  40.00000000000    /
      DATA SIGV / 0.6250000000000E-01
     +, 0.2374999970198    
     +, 0.2874999940395    
     +, 0.3125000000000    
     +, 0.4875000119209    
     +, 0.5375000238419    
     +, 0.5625000000000    
     +, 0.6125000119209    
     +, 0.6374999880791    
     +, 0.6625000238419    
     +, 0.7624999880791    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.1749999970198    
     +, 0.4250000119209    
     +, 0.8249999880791    
     +/
      DATA SIGDEL / 0.8999999612570E-01
     +, 0.8999999612570E-01
     +, 0.8999999612570E-01
     +, 0.8999999612570E-01
     +, 0.8999999612570E-01
     +, 0.8999999612570E-01
     +, 0.8999999612570E-01
     +, 0.8999999612570E-01
     +, 0.8999999612570E-01
     +, 0.8999999612570E-01
     +, 0.8999999612570E-01
     +, 0.3599999899961E-05
     +, 0.3599999899961E-05
     +, 0.1799999922514    
     +, 0.1799999922514    
     +, 0.1799999922514    
     +/
      DATA SIGA / -2.869954798215    
     +, -1.407277787162    
     +,-0.8758854636614    
     +, -1.593235154513    
     +, -16.68853094850    
     +,  72.95644365997    
     +, -106.6083494808    
     +,  165.9983145543    
     +, -195.0647707508    
     +,  75.28660964646    
     +,-0.6933093302730    
     +, 0.5435745272463E-01
     +,-0.3415617434758    
     +,  4.310707469556    
     +,  7.661193533291    
     +,-0.6664778719620    
     +/
      DOUBLE PRECISION xmin,xmax
      PARAMETER (xmin=65D0,xmax=130D0)
      A183_hll_mass_bkg = 0.
      IF ((V(1).LE.XMAX).AND.(V(1).GE.XMIN)) THEN
        DO 20 J = 1, NPAR
           HQDJ = 0.
           DO 10 I = 1, NDIM
              VV = (V (I) - SIGVMI (I)) / SIGVT (I)
              HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10      CONTINUE
           HQDJ = HQDJ + SIGDEL (J) ** 2
           HQDJ = SQRT (HQDJ)
           A183_hll_mass_bkg = A183_hll_mass_bkg + SIGA (J) * HQDJ
   20   CONTINUE
        IF (IMQFUN .EQ. 2) A183_hll_mass_bkg = VCONST *
     &                     EXP (A183_hll_mass_bkg)

        if (A183_hll_mass_bkg.le.0.002d0) A183_hll_mass_bkg = 0.002d0
      ENDIF
      END
C----------------------------------------------------------------------
C----------------------------------------------------------------------

      real*8 FUNCTION A183_hll_mass_sig(x, HMASS)

      implicit none

      real*8 x, HMASS

      real*8 sig, offset

      real*8 XMIN,XMAX
      PARAMETER (XMIN=65D0,XMAX=130D0)

      A183_HLL_MASS_SIG = 0

      IF ((X.LE.XMAX).AND.(X.GE.XMIN)) THEN
        if (HMASS.le.90.0d0) then
          sig = 12.7d0 - 0.117d0*HMASS
        else
          sig = -1.907d0 + 0.0453d0*HMASS
        endif

        offset = 7.29d0 - 0.0825d0*HMASS

        A183_hll_mass_sig = exp(-0.5d0*((x-HMASS-offset)/sig)**2)
      ENDIF
      return
      end
C----------------------------------------------------------------------
C----------------------------------------------------------------------

      DOUBLE PRECISION FUNCTION A183_hll_btag_bkg(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  23, 1)
      DOUBLE PRECISION SIGDEL(  23)
      DOUBLE PRECISION SIGA(  23)
      DATA NPAR, NDIM, IMQFUN /   23,    1,    1/
      DATA VCONST / 0.0000000000000E+00/
      DATA SIGVMI /-0.2500000037253E-01/
      DATA SIGVT /  2.050000190735    /
      DATA SIGV / 0.6097560748458E-01
     +, 0.8536584675312E-01
     +, 0.1097560971975    
     +, 0.1585365831852    
     +, 0.2560975551605    
     +, 0.2804878056049    
     +, 0.3048780262470    
     +, 0.3292682766914    
     +, 0.3780487775803    
     +, 0.4024389982224    
     +, 0.4268292486668    
     +, 0.5243902206421    
     +, 0.5487804412842    
     +, 0.5731707215309    
     +, 0.5975609421730    
     +, 0.7439023852348    
     +, 0.7682926654816    
     +, 0.8658536076546    
     +, 0.9146341085434    
     +, 0.9390243291855    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.6585365533829    
     +/
      DATA SIGDEL / 0.4878048598766E-01
     +, 0.4878048598766E-01
     +, 0.4878048598766E-01
     +, 0.4878048598766E-01
     +, 0.4878048598766E-01
     +, 0.4878048598766E-01
     +, 0.4878048598766E-01
     +, 0.4878048598766E-01
     +, 0.4878048598766E-01
     +, 0.4878048598766E-01
     +, 0.4878048598766E-01
     +, 0.4878048598766E-01
     +, 0.4878048598766E-01
     +, 0.4878048598766E-01
     +, 0.4878048598766E-01
     +, 0.4878048598766E-01
     +, 0.4878048598766E-01
     +, 0.4878048598766E-01
     +, 0.4878048598766E-01
     +, 0.4878048598766E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.9756097197533E-01
     +/
      DATA SIGA /  4.976915397493    
     +, -17.69363005178    
     +,  12.08879379737    
     +,-0.6816600152073    
     +,-0.2443672608434    
     +,  2.570648944877    
     +, -6.474005064874    
     +,  3.536896728772    
     +,  6.359084494650    
     +, -12.37623210747    
     +,  7.852695123220    
     +, -9.030721752785    
     +,  13.96598841996    
     +, -8.185506893045    
     +,  2.367659633715    
     +,  1.503132996518    
     +, -1.686009678101    
     +,  3.205134934401    
     +, -12.51974559317    
     +,  13.05711637325    
     +,  1.493397622962    
     +, -3.070223234152    
     +,-0.8660600576620    
     +/
      DOUBLE PRECISION xmin,xmax
      PARAMETER (xmin=0D0,xmax=2D0)
      A183_hll_btag_bkg = 0.
      IF ((V(1).LE.XMAX).AND.(V(1).GE.XMIN)) THEN
        DO 20 J = 1, NPAR
           HQDJ = 0.
           DO 10 I = 1, NDIM
              VV = (V (I) - SIGVMI (I)) / SIGVT (I)
              HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10      CONTINUE
           HQDJ = HQDJ + SIGDEL (J) ** 2
           HQDJ = SQRT (HQDJ)
           A183_hll_btag_bkg = A183_hll_btag_bkg + SIGA (J) * HQDJ
   20   CONTINUE
        IF (IMQFUN .EQ. 2) A183_hll_btag_bkg = VCONST *
     &                     EXP (A183_hll_btag_bkg)
      ENDIF

      if (A183_hll_btag_bkg.le.0.005d0) A183_hll_btag_bkg = 0.005d0
      END

C----------------------------------------------------------------------
C----------------------------------------------------------------------

      DOUBLE PRECISION FUNCTION A183_hll_btag_sig(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  13, 1)
      DOUBLE PRECISION SIGDEL(  13)
      DOUBLE PRECISION SIGA(  13)
      DATA NPAR, NDIM, IMQFUN /   13,    1,    1/
      DATA VCONST / 0.0000000000000E+00/
      DATA SIGVMI /-0.2500000037253E-01/
      DATA SIGVT /  2.050000190735    /
      DATA SIGV / 0.6097560748458E-01
     +, 0.8536584675312E-01
     +, 0.3292682766914    
     +, 0.3536585271358    
     +, 0.4999999701977    
     +, 0.5243902206421    
     +, 0.6951219439507    
     +, 0.9390243291855    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.4146341383457    
     +, 0.6097560524940    
     +, 0.7560975551605    
     +/
      DATA SIGDEL / 0.4878048598766E-01
     +, 0.4878048598766E-01
     +, 0.4878048598766E-01
     +, 0.4878048598766E-01
     +, 0.4878048598766E-01
     +, 0.4878048598766E-01
     +, 0.4878048598766E-01
     +, 0.4878048598766E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.9756097197533E-01
     +, 0.9756097197533E-01
     +, 0.9756097197533E-01
     +/
      DATA SIGA / 0.5975254107392    
     +,-0.4251713759226    
     +, 0.1706941157578    
     +,-0.6603714911174    
     +,-0.3575513933177    
     +,-0.8424242447001E-01
     +,-0.2892124746398    
     +, 0.8414874631359    
     +,-0.1443307440689    
     +,-0.8029450605321    
     +, 0.9474057526062    
     +, 0.1163638596479    
     +, 0.2023692656150    
     +/
      DOUBLE PRECISION xmin,xmax
      PARAMETER (xmin=0D0,xmax=2D0)
      A183_hll_btag_sig = 0.
      IF ((V(1).LE.XMAX).AND.(V(1).GE.XMIN)) THEN
        DO 20 J = 1, NPAR
           HQDJ = 0.
           DO 10 I = 1, NDIM
              VV = (V (I) - SIGVMI (I)) / SIGVT (I)
              HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10      CONTINUE
           HQDJ = HQDJ + SIGDEL (J) ** 2
           HQDJ = SQRT (HQDJ)
           A183_hll_btag_sig = A183_hll_btag_sig + SIGA (J) * HQDJ
   20   CONTINUE
        IF (IMQFUN .EQ. 2) A183_hll_btag_sig = VCONST *
     &                     EXP (A183_hll_btag_sig)
      ENDIF

      if (A183_hll_btag_sig.le.0.005d0) A183_hll_btag_sig = 0.005d0
      END
