      REAL*8 FUNCTION A183_HNN_EFF(HMASS,IANA)

      IMPLICIT REAL*8(A-H,O-Z)
c
c---- Return the efficiency for HZ + WW --> Hvv 
c     Mods:
c

      efficiency = 0.
      IF (IANA.EQ.1) THEN ! NN and CUT
        IF (HMASS .LT. 70.) THEN
           efficiency = .01*(HMASS-76)+.22+
     .           (abs(70.-HMASS))**(1.2)/600.

        ELSEIF (HMASS .LT. 81.) THEN
           efficiency =.01*(HMASS-76.)+.224-
     .              exp((HMASS-88.1)/4.)*.4 

        ELSEIF (HMASS .LT. 85.) THEN
           efficiency =-.007*(HMASS-82.8)+.194
        ELSEIF (HMASS .LT. 90.) THEN
           efficiency = -.007*(HMASS-82.8)+.194-
     .             (abs(85.-HMASS))**(1.2)/150.
        ELSE
           efficiency =-.007*(HMASS-82.8)+.19-
     .             (abs(85.-HMASS))**(1.2)/150.+
     .             (abs(89.-HMASS))**(1.2)/110.
        ENDIF

      ELSE IF (IANA.EQ.2) THEN ! NN only
        IF (HMASS .LT. 70.) THEN
           efficiency = .006*(HMASS-80.)+0.137+
     .     (abs(70.-HMASS))**(1.2)/600.
        ELSEIF (HMASS .LT. 85.) THEN
           efficiency = .006*(HMASS-80)+0.137-
     .     exp((HMASS-85.)/2.)*.05
        ELSEIF (HMASS .LT. 87.3) THEN
           efficiency =.12-.019*(HMASS-85)
        ELSEIF (HMASS .LT. 90.) THEN
           efficiency =.12-.019*(HMASS-85)+
     .     (abs(87.3-HMASS))**(1.32)/100.
        ELSE
           efficiency =.061-.0015*(HMASS-90)
        ENDIF

      ELSE IF (IANA.EQ.3) THEN ! Cut only
        IF (HMASS .LT. 75.) THEN
           efficiency = 0.09-0.0045*(HMASS-60.)
        ELSEIF (HMASS .LT. 80.) THEN
           efficiency =0.09-0.0045*(HMASS-60.)+
     .     (abs(75.-HMASS))**(1.2)/250.
       ELSEIF (HMASS .LT. 91.5) THEN
           efficiency =0.09-0.0045*(HMASS-60.)+
     .     (abs(75.-HMASS))**(1.2)/250.-
     .     exp((HMASS-95.)/1.)*.4
        ELSEIF (HMASS .LT. 95.) THEN
           efficiency =.052-.0063*(HMASS-91.5)
        ELSE
           efficiency = .052-.0063*(HMASS-91.5)+
     .     (abs(95.-HMASS))**(1.2)/340.
        ENDIF
      ENDIF

      if ((HMASS.GE.60.).and.(HMASS.LE.100)) then
        A183_HNN_EFF = EFFICIENCY
      else
        A183_HNN_EFF = 0.
      end if
      END

c---------------------------------------------------------------------
c---------------------------------------------------------------------

      REAL*8 FUNCTION A183_HNN_WWF_EFF(HMASS,IANA)
c
c---- Return the efficiency for e+e--->Hvv (WW fusion ONLY)
c     Mods:
c     - return eff in [0.,1.] rather than in %; PTD, 28-May-1999.
c

      IMPLICIT REAL*8(A-H,O-Z)

      effw = 0.

      IF (IANA.EQ.1) THEN

        IF (HMASS .lt. 80.) THEN 
           effw = 10.46
        ELSEIF (HMASS .lt. 90.) THEN
           effw = 10.46-0.109*(HMASS-80.)
        ELSE
           effw = 9.37-0.574*(HMASS-90.)
        ENDIF

      ELSE IF (IANA.EQ.2) THEN

        IF (HMASS .lt. 80.) THEN 
           effw = 9.69
        ELSEIF (HMASS .lt. 90.) THEN
           effw = 9.69-0.302*(HMASS-80.)
        ELSE
           effw = 6.47-0.248*(HMASS-90.)
        ENDIF

      ELSE IF (IANA.EQ.3) THEN

        IF (HMASS .lt. 80.) THEN
           effw = 2.13
        ELSEIF (HMASS .lt. 90.) THEN
           effw = 2.13-0.1*(HMASS-80.)
        ELSE
           effw = 1.12-0.016*(HMASS-90.)
        ENDIF

      ENDIF

      if ((HMASS.GE.60.).AND.(HMASS.LE.100.)) THEN
        A183_HNN_WWF_EFF = EFFW / 1.E2
      else
        A183_HNN_WWF_EFF = 0.
      endif

      END

c---------------------------------------------------------------------
c---------------------------------------------------------------------

      REAL*8 FUNCTION A183_HNN_BKG(IANA)

      IMPLICIT REAL*8 (A-H,O-Z)

      IF (IANA.EQ.1) A183_HNN_BKG = 0.159275
      IF (IANA.EQ.2) A183_HNN_BKG = 0.184062
      IF (IANA.EQ.3) A183_HNN_BKG = 0.0775769

      END

c---------------------------------------------------------------------
c---------------------------------------------------------------------

      DOUBLE PRECISION FUNCTION A183_HNN_MASS_SIG(x,hmass,iana)

      IMPLICIT REAL*8(A-H,O-Z)

      IF (iana.eq.1) THEN
        A183_HNN_MASS_SIG = A183_HNNBOTHMASS_SIG(x,hmass)
      ELSE IF (iana.eq.2) THEN
        A183_HNN_MASS_SIG = A183_HNNNNMASS_SIG(x,hmass)
      ELSE IF (iana.eq.3) THEN
        A183_HNN_MASS_SIG = A183_HNNCUTMASS_SIG(x,hmass)
      ENDIF

      END

c---------------------------------------------------------------------
c---------------------------------------------------------------------

      DOUBLE PRECISION FUNCTION A183_HNN_MASS_BKG(x,iana)

      IMPLICIT REAL*8(A-H,O-Z)

      IF (iana.eq.1) THEN
        A183_HNN_MASS_BKG = A183_HNNBOTHMASS_BKG(x)
      ELSE IF (iana.eq.2) THEN
        A183_HNN_MASS_BKG = A183_HNNNNMASS_BKG(x)
      ELSE IF (iana.eq.3) THEN
        A183_HNN_MASS_BKG = A183_HNNCUTMASS_BKG(x)
      ENDIF

      END

c---------------------------------------------------------------------
c---------------------------------------------------------------------

      INTEGER FUNCTION A183_HNN_NUMCAND(iana)

      IMPLICIT REAL*8 (A-H,O-Z)

      IF (IANA.EQ.1) THEN
        A183_HNN_NUMCAND = 0
      ELSE IF (IANA.EQ.2) THEN
        A183_HNN_NUMCAND = 0
      ELSE IF (IANA.EQ.3) THEN
        A183_HNN_NUMCAND = 0
      ENDIF
      END

c---------------------------------------------------------------------
c---------------------------------------------------------------------

      DOUBLE PRECISION FUNCTION A183_HNN_MASS_CAND(IANA,ICAND)

      IMPLICIT REAL*8 (A-H,O-Z)

      IF (IANA.EQ.1) THEN
        A183_HNN_MASS_CAND = 0.
      ELSE IF (IANA.EQ.2) THEN
        A183_HNN_MASS_CAND = 0.
      ELSE IF (IANA.EQ.3) THEN
        A183_HNN_MASS_CAND = 0.
      ENDIF
      END

c---------------------------------------------------------------------
c---------------------------------------------------------------------

      DOUBLE PRECISION FUNCTION A183_HNN_BTAG_CAND(IANA,ICAND)

      IMPLICIT REAL*8 (A-H,O-Z)

      IF (IANA.EQ.1) THEN
        A183_HNN_BTAG_CAND = 0.
      ELSE IF (IANA.EQ.2) THEN
        A183_HNN_BTAG_CAND = 0.
      ELSE IF (IANA.EQ.3) THEN
        A183_HNN_BTAG_CAND = 0.
      ENDIF
      END

c---------------------------------------------------------------------
c---------------------------------------------------------------------

      DOUBLE PRECISION FUNCTION A183_HNN_BTAG_SIG(x,hmass,iana)

      IMPLICIT REAL*8(A-H,O-Z)

      IF (iana.eq.1) THEN
        A183_HNN_BTAG_SIG = A183_HNNBOTHNN_SIG(x,hmass)
      ELSE IF (iana.eq.2) THEN
        A183_HNN_BTAG_SIG = A183_HNNNNNN_SIG(x,hmass)
      ELSE IF (iana.eq.3) THEN
        A183_HNN_BTAG_SIG = A183_HNNCUTBTAG_SIG(x,hmass)
      ENDIF

      END
c---------------------------------------------------------------------
c---------------------------------------------------------------------

      DOUBLE PRECISION FUNCTION A183_HNN_BTAG_BKG(x,iana)

      IMPLICIT REAL*8(A-H,O-Z)

      IF (iana.eq.1) THEN
        A183_HNN_BTAG_BKG = A183_HNNBOTHNN_BKG(x)
      ELSE IF (iana.eq.2) THEN
        A183_HNN_BTAG_BKG = A183_HNNNNNN_BKG(x)
      ELSE IF (iana.eq.3) THEN
        A183_HNN_BTAG_BKG = A183_HNNCUTBTAG_BKG(x)
      ENDIF

      END


c---------------------------------------------------------------------
c---------------------------------------------------------------------

      DOUBLE PRECISION FUNCTION A183_HNNBOTHMASS_SIG(x,hmass)
      IMPLICIT REAL*8(A-H,O-Z)
      PARAMETER (xmin=35D0 ,xmax = 91.5D0)

      IF ( x .LE. xmax .AND. x .GE. xmin ) THEN
        rt2pi=(2.*3.141593)**0.5
        xm = hmass/5.0 - 13.0
        sigma1 = 2.531 + 0.4226*xm - 0.1235*xm**2
        sigma2 = 10.53 - 2.0810*xm + 0.1763*xm**2
        gmean1 = 64.19 + 6.4710*xm - 0.2859*xm**2
        gmean2 = 69.40 + 2.2530*xm + 0.1216*xm**2
        A183_hnnbothmass_sig =
     .    (exp(-(x-gmean1)**2/2/sigma1**2)*0.7/sigma1
     .   + exp(-(x-gmean2)**2/2/sigma2**2)*0.3/sigma2)/rt2pi
      ELSE
          A183_hnnbothmass_sig = 0.
      ENDIF
      IF (A183_hnnbothmass_sig .le. 0D0) 
     .    A183_hnnbothmass_sig = 0.00000001
      RETURN
      END

c---------------------------------------------------------------------
c---------------------------------------------------------------------

      DOUBLE PRECISION FUNCTION A183_HNNBOTHMASS_BKG(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   7, 1)
      DOUBLE PRECISION SIGDEL(   7)
      DOUBLE PRECISION SIGA(   7)
      DATA NPAR, NDIM, IMQFUN /    7,    1,    2/
      DATA VCONST /  1.600000023842    /
      DATA SIGVMI /  20.00000000000    /
      DATA SIGVT /  80.00000000000    /
      DATA SIGV / 0.8700000047684
     +, 0.9099999666214
     +, 0.0000000000000E+00
     +,  1.000000000000
     +, 0.5799999833107
     +, 0.6999999880791
     +, 0.7799999713898
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +/
      DATA SIGA /  81.00853513455
     +, -409.3624745298
     +, -19.95674714346
     +,  287.4308289036
     +,  19.39587905485
     +, -23.30872787102
     +,  20.89415285264
     +/
      DOUBLE PRECISION xmin,xmax
      PARAMETER (xmin=35D0,xmax=91.5D0)
      A183_HNNBOTHMASS_BKG = 0.
      IF ((V(1).le.XMAX).and.(V(1).ge.XMIN)) THEN
        DO 20 J = 1, NPAR
           HQDJ = 0.
           DO 10 I = 1, NDIM
              VV = (V (I) - SIGVMI (I)) / SIGVT (I)
              HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10      CONTINUE
           HQDJ = HQDJ + SIGDEL (J) ** 2
           HQDJ = SQRT (HQDJ)
           A183_HNNBOTHMASS_BKG =
     .          A183_HNNBOTHMASS_BKG + SIGA (J) * HQDJ
   20   CONTINUE
        IF (IMQFUN .EQ. 2) A183_HNNBOTHMASS_BKG=
     .          VCONST*EXP(A183_HNNBOTHMASS_BKG)
      ENDIF
      END

c---------------------------------------------------------------------
c---------------------------------------------------------------------

      DOUBLE PRECISION FUNCTION A183_HNNNNMASS_SIG(x,hmass)
      IMPLICIT REAL*8(A-H,O-Z)
      PARAMETER (xmin=35D0,xmax = 91.5D0)

      IF ( x .LE. xmax .AND. x .GE. xmin ) THEN
        rt2pi=(2.*3.141593)**0.5
        xm = hmass/5.0 - 13.0
        sigma1 = 2.531 + 0.4226*xm - 0.1235*xm**2
        sigma2 = 10.53 - 2.0810*xm + 0.1763*xm**2
        gmean1 = 64.19 + 6.4710*xm - 0.2859*xm**2
        gmean2 = 69.40 + 2.2530*xm + 0.1216*xm**2
        A183_hnnnnmass_sig =
     .    (exp(-(x-gmean1)**2/2/sigma1**2)*0.7/sigma1
     .   + exp(-(x-gmean2)**2/2/sigma2**2)*0.3/sigma2)/rt2pi
      ELSE
          A183_hnnnnmass_sig = 0.
      ENDIF
      IF (A183_hnnnnmass_sig .le. 0D0)
     .     A183_hnnnnmass_sig = 0.00000001
      RETURN
      END

c---------------------------------------------------------------------
c---------------------------------------------------------------------

      DOUBLE PRECISION FUNCTION A183_HNNNNMASS_BKG(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   7, 1)
      DOUBLE PRECISION SIGDEL(   7)
      DOUBLE PRECISION SIGA(   7)
      DATA NPAR, NDIM, IMQFUN /    7,    1,    2/
      DATA VCONST /  1.600000023842    /
      DATA SIGVMI /  20.00000000000    /
      DATA SIGVT /  80.00000000000    /
      DATA SIGV / 0.8700000047684
     +, 0.9099999666214
     +, 0.0000000000000E+00
     +,  1.000000000000
     +, 0.5799999833107
     +, 0.6999999880791
     +, 0.7799999713898
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +/
      DATA SIGA /  81.00853513455
     +, -409.3624745298
     +, -19.95674714346
     +,  287.4308289036
     +,  19.39587905485
     +, -23.30872787102
     +,  20.89415285264
     +/
      DOUBLE PRECISION xmin,xmax
      PARAMETER (xmin=35D0,xmax = 91.5D0)
      A183_HNNNNMASS_BKG = 0.
      IF ((V(1).LE.XMAX).AND.(V(1).GE.XMIN)) THEN
        DO 20 J = 1, NPAR
           HQDJ = 0.
           DO 10 I = 1, NDIM
              VV = (V (I) - SIGVMI (I)) / SIGVT (I)
              HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10      CONTINUE
           HQDJ = HQDJ + SIGDEL (J) ** 2
           HQDJ = SQRT (HQDJ)
           A183_HNNNNMASS_BKG = A183_HNNNNMASS_BKG+SIGA(J)*HQDJ
   20   CONTINUE
        IF (IMQFUN.EQ.2)
     .         A183_HNNNNMASS_BKG=VCONST*EXP(A183_HNNNNMASS_BKG)
      ENDIF
      END

c---------------------------------------------------------------------
c---------------------------------------------------------------------

      DOUBLE PRECISION FUNCTION A183_HNNCUTMASS_SIG(x,hmass)
      IMPLICIT REAL*8(A-H,O-Z)
      PARAMETER (xmin = 35D0,xmax = 91.5D0)

      IF ( x .LE. xmax .AND. x .GE. xmin ) THEN
        rt2pi=(2.*3.141593)**0.5
        xm = hmass/5.0 - 13.0
        sigma1 = 2.531 + 0.4226*xm - 0.1235*xm**2
        sigma2 = 10.53 - 2.0810*xm + 0.1763*xm**2
        gmean1 = 64.19 + 6.4710*xm - 0.2859*xm**2
        gmean2 = 69.40 + 2.2530*xm + 0.1216*xm**2
        A183_hnncutmass_sig =
     .    (exp(-(x-gmean1)**2/2/sigma1**2)*0.7/sigma1
     .   + exp(-(x-gmean2)**2/2/sigma2**2)*0.3/sigma2)/rt2pi
      ELSE
          A183_hnncutmass_sig = 0.
      ENDIF
      IF (A183_hnncutmass_sig .le. 0D0)
     .    A183_hnncutmass_sig = 0.00000001
      RETURN
      END

c---------------------------------------------------------------------
c---------------------------------------------------------------------

      DOUBLE PRECISION FUNCTION A183_HNNCUTMASS_BKG(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   7, 1)
      DOUBLE PRECISION SIGDEL(   7)
      DOUBLE PRECISION SIGA(   7)
      DATA NPAR, NDIM, IMQFUN /    7,    1,    2/
      DATA VCONST /  1.600000023842    /
      DATA SIGVMI /  20.00000000000    /
      DATA SIGVT /  80.00000000000    /
      DATA SIGV / 0.8700000047684
     +, 0.9099999666214
     +, 0.0000000000000E+00
     +,  1.000000000000
     +, 0.5799999833107
     +, 0.6999999880791
     +, 0.7799999713898
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +/
      DATA SIGA /  81.00853513455
     +, -409.3624745298
     +, -19.95674714346
     +,  287.4308289036
     +,  19.39587905485
     +, -23.30872787102
     +,  20.89415285264
     +/
      DOUBLE PRECISION xmin,xmax
      PARAMETER (xmin = 35D0,xmax = 91.5D0)
      A183_HNNCUTMASS_BKG = 0.
      IF ((V(1).LE.XMAX).AND.(V(1).GE.XMIN)) THEN
        DO 20 J = 1, NPAR
           HQDJ = 0.
           DO 10 I = 1, NDIM
             VV = (V (I) - SIGVMI (I)) / SIGVT (I)
             HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10      CONTINUE
           HQDJ = HQDJ + SIGDEL (J) ** 2
           HQDJ = SQRT (HQDJ)
           A183_HNNCUTMASS_BKG = A183_HNNCUTMASS_BKG+SIGA(J)*HQDJ
   20   CONTINUE
        IF (IMQFUN.EQ.2) A183_HNNCUTMASS_BKG=
     .                   VCONST*EXP(A183_HNNCUTMASS_BKG)
      ENDIF
      END

c---------------------------------------------------------------------
c---------------------------------------------------------------------

      DOUBLE PRECISION FUNCTION A183_HNNBOTHNN_SIG(x,hmass)
      IMPLICIT REAL*8(A-H,O-Z)
      PARAMETER (XMIN=0.983D0,XMAX=1D0)

      IF ((X.LT.XMAX).AND.(X.GE.XMIN)) THEN
        shift = hmass-80D0
        if(shift.lt.-20.0) then
          A183_HNNBOTHNN_SIG = A183_HNN_SIG60(x)
        elseif(shift.le.-10.0.and.shift.ge.-20.0) then
          A183_HNNBOTHNN_SIG =
     .            (20.+shift)*A183_HNN_SIG70(x)+
     .           (-10.-shift)*A183_HNN_SIG60(x)
        elseif(shift.le.0.0.and.shift.gt.-10.0) then
          A183_HNNBOTHNN_SIG =
     .            (10.+shift)*A183_HNN_SIG80(x)+
     .               (-shift)*A183_HNN_SIG70(x)
        elseif(shift.le.5.0.and.shift.gt.0.0) then
          A183_HNNBOTHNN_SIG =
     .                  shift*A183_HNN_SIG85(x)+
     .             (5.-shift)*A183_HNN_SIG80(x)
        elseif(shift.le.10.0.and.shift.gt.5.0) then
          A183_HNNBOTHNN_SIG =
     .             (shift-5.)*A183_HNN_SIG90(x)+
     .            (10.-shift)*A183_HNN_SIG85(x)
        elseif(shift.le.15.0.and.shift.gt.10.0) then
          A183_HNNBOTHNN_SIG =
     .             (shift-10.)*A183_HNN_SIG95(x)+
     .             (15.-shift)*A183_HNN_SIG90(x)
        elseif(shift.ge.15.0) then
          A183_HNNBOTHNN_SIG = A183_HNN_SIG95(x)
        else
          A183_HNNBOTHNN_SIG = 0.0
        endif
      ENDIF
      RETURN
      END

c---------------------------------------------------------------------
c---------------------------------------------------------------------

       DOUBLE PRECISION FUNCTION A183_HNNBOTHNN_BKG(x)
       IMPLICIT REAL*8(A-H,O-Z)
       PARAMETER (XMIN=0.983D0,XMAX = 1D0)
       IF ( x .LT. xmax .AND. x .GE. xmin ) THEN
          A183_hnnbothnn_bkg = 1.
       ELSE
          A183_hnnbothnn_bkg = 0.00000001
       ENDIF
       IF (A183_hnnbothnn_bkg.eq.0.) A183_hnnbothnn_bkg=1.D-10
       RETURN
       END

c---------------------------------------------------------------------
c---------------------------------------------------------------------

      DOUBLE PRECISION FUNCTION A183_HNNNNNN_SIG(x,hmass)
      IMPLICIT REAL*8(A-H,O-Z)

      PARAMETER (XMIN=0.983D0,XMAX=1D0)

      IF ((X.LT.XMAX).AND.(X.GE.XMIN)) THEN
        shift = hmass-80D0
        if(shift.lt.-20.0) then
          A183_HNNNNNN_SIG = A183_HNN_SIG60(x)
        elseif(shift.le.-10.0.and.shift.ge.-20.0) then
          A183_HNNNNNN_SIG =
     .          (20.+shift)*A183_HNN_SIG70(x)+
     .         (-10.-shift)*A183_HNN_SIG60(x)
        elseif(shift.le.0.0.and.shift.gt.-10.0) then
          A183_HNNNNNN_SIG =
     .          (10.+shift)*A183_HNN_SIG80(x)+
     .             (-shift)*A183_HNN_SIG70(x)
        elseif(shift.le.5.0.and.shift.gt.0.0) then
          A183_HNNNNNN_SIG =
     .                shift*A183_HNN_SIG85(x)+
     .           (5.-shift)*A183_HNN_SIG80(x)
        elseif(shift.le.10.0.and.shift.gt.5.0) then
          A183_HNNNNNN_SIG =
     .           (shift-5.)*A183_HNN_SIG90(x)+
     .          (10.-shift)*A183_HNN_SIG85(x)
        elseif(shift.le.15.0.and.shift.gt.10.0) then
          A183_HNNNNNN_SIG =
     .          (shift-10.)*A183_HNN_SIG95(x)+
     .          (15.-shift)*A183_HNN_SIG90(x)
        elseif(shift.ge.15.0) then
          A183_HNNNNNN_SIG = A183_HNN_SIG95(x)
        else
          A183_HNNNNNN_SIG = 0.0
        endif
      ENDIF
      RETURN
      END

c---------------------------------------------------------------------
c---------------------------------------------------------------------

      DOUBLE PRECISION FUNCTION A183_HNNNNNN_BKG(x)
      IMPLICIT REAL*8(A-H,O-Z)
      PARAMETER (XMIN=0.983D0,XMAX=1D0)

      IF ((X.LT.XMAX).AND.(X.GE.XMIN)) THEN
        A183_hnnnnnn_bkg = 1.
      ELSE
        A183_hnnnnnn_bkg = 0.00000001
      ENDIF
      IF (A183_hnnnnnn_bkg.eq.0.) A183_hnnnnnn_bkg=1.D-10
      RETURN
      END

c---------------------------------------------------------------------
c---------------------------------------------------------------------

      DOUBLE PRECISION FUNCTION A183_HNNCUTBTAG_SIG(V,HMASS)
      DOUBLE PRECISION V( 1),HMASS
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   8, 1)
      DOUBLE PRECISION SIGDEL(   8)
      DOUBLE PRECISION SIGA(   8)
      DATA NPAR, NDIM, IMQFUN /    8,    1,    2/
      DATA VCONST / 0.1999999955297E-01/
      DATA SIGVMI / 0.0000000000000E+00/
      DATA SIGVT /  2.000000000000    /
      DATA SIGV / 0.9399999976158
     +, 0.0000000000000E+00
     +,  1.000000000000
     +, 0.3599999845028
     +, 0.4399999976158
     +, 0.5199999809265
     +, 0.5999999642372
     +, 0.8399999737740
     +/
      DATA SIGDEL / 0.7999999821186E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.1599999964237
     +, 0.1599999964237
     +, 0.1599999964237
     +, 0.1599999964237
     +, 0.1599999964237
     +/
      DATA SIGA /  22.36116430516
     +,  12.67473431933
     +, -8.394535134744
     +, -52.73753182130
     +,  129.5553218669
     +, -125.2169845597
     +,  46.44185643346
     +, -8.385513785130
     +/
      DOUBLE PRECISION XMIN,XMAX
      PARAMETER (XMIN=1.63D0,XMAX=2D0)
      A183_HNNCUTBTAG_SIG = 0.

      IF ((V(1).LT.XMAX).AND.(V(1).GE.XMIN)) THEN
        DO 20 J = 1, NPAR
           HQDJ = 0.
           DO 10 I = 1, NDIM
              VV = (V (I) - SIGVMI (I)) / SIGVT (I)
              HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10      CONTINUE
           HQDJ = HQDJ + SIGDEL (J) ** 2
           HQDJ = SQRT (HQDJ)
           A183_HNNCUTBTAG_SIG = A183_HNNCUTBTAG_SIG+SIGA(J)*HQDJ
   20   CONTINUE
        IF (IMQFUN .EQ. 2) A183_HNNCUTBTAG_SIG=
     .          VCONST*EXP(A183_HNNCUTBTAG_SIG)
      ENDIF
      END

c---------------------------------------------------------------------
c---------------------------------------------------------------------

      DOUBLE PRECISION FUNCTION A183_HNNCUTBTAG_BKG(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  12, 1)
      DOUBLE PRECISION SIGDEL(  12)
      DOUBLE PRECISION SIGA(  12)
      DATA NPAR, NDIM, IMQFUN /   12,    1,    2/
      DATA VCONST / 0.1999999955297E-01/
      DATA SIGVMI / 0.0000000000000E+00/
      DATA SIGVT /  2.000000000000    /
      DATA SIGV / 0.4650000035763
     +, 0.4749999940395
     +, 0.6649999618530
     +, 0.9849999547005
     +, 0.0000000000000E+00
     +,  1.000000000000
     +, 0.3100000023842
     +, 0.5999999865890E-01
     +, 0.9999999403954E-01
     +, 0.4199999868870
     +, 0.5799999833107
     +, 0.8399999737740
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999989901E-05
     +, 0.3999999989901E-05
     +, 0.7999999821186E-01
     +, 0.1599999964237
     +, 0.1599999964237
     +, 0.1599999964237
     +, 0.1599999964237
     +, 0.3199999928474
     +/
      DATA SIGA /  82.28457982678
     +, -84.81073203476
     +, -8.289376210161
     +,  20.73208494395
     +,  71.39776833201
     +, -13.25757720723
     +, -5.379036321196
     +, -258.0680630781
     +,  197.9288041012
     +, -15.60517555230
     +,  28.36612679575
     +,  3.300766976776
     +/
      DOUBLE PRECISION XMIN,XMAX
      PARAMETER (XMIN=1.63D0,XMAX=2D0)
      A183_HNNCUTBTAG_BKG = 0.

      IF ((V(1).LT.XMAX).AND.(V(1).GE.XMIN)) THEN
        DO 20 J = 1, NPAR
           HQDJ = 0.
           DO 10 I = 1, NDIM
              VV = (V (I) - SIGVMI (I)) / SIGVT (I)
              HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10      CONTINUE
           HQDJ = HQDJ + SIGDEL (J) ** 2
           HQDJ = SQRT (HQDJ)
           A183_HNNCUTBTAG_BKG = A183_HNNCUTBTAG_BKG+SIGA(J)*HQDJ
   20   CONTINUE
        IF (IMQFUN .EQ. 2) A183_HNNCUTBTAG_BKG=
     .          VCONST*EXP(A183_HNNCUTBTAG_BKG)
      ENDIF
      END

      DOUBLE PRECISION FUNCTION A183_HNN_SIG60(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   9, 1)
      DOUBLE PRECISION SIGDEL(   9)
      DOUBLE PRECISION SIGA(   9)
      DATA NPAR, NDIM, IMQFUN /    9,    1,    2/
      DATA VCONST / 0.2999999560416E-02/
      DATA SIGVMI / 0.8500000238419    /
      DATA SIGVT / 0.1499999761581    /
      DATA SIGV / 0.4999999701977E-01
     +, 0.1700000017881    
     +, 0.4499999880791    
     +, 0.6899999976158    
     +, 0.7099999785423    
     +, 0.9699999690056    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.8999999761581    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +/
      DATA SIGA /  12.00034896645    
     +, -3.358634981735    
     +, 0.6384378616960    
     +,  2.234383182367    
     +, 0.6426721829073E-01
     +, -227.6509754751    
     +, -2.485727419955    
     +,  201.1497433207    
     +,  28.23991145319    
     +/
      A183_HNN_SIG60 = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         A183_HNN_SIG60 = A183_HNN_SIG60 + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) A183_HNN_SIG60 = VCONST*EXP(A183_HNN_SIG60)
      END
c---------------------------------------------------------------------
      DOUBLE PRECISION FUNCTION A183_HNN_SIG70(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  13, 1)
      DOUBLE PRECISION SIGDEL(  13)
      DOUBLE PRECISION SIGA(  13)
      DATA NPAR, NDIM, IMQFUN /   13,    1,    2/
      DATA VCONST / 0.2999999560416E-02/
      DATA SIGVMI / 0.8500000238419    /
      DATA SIGVT / 0.1499999761581    /
      DATA SIGV / 0.2999999932945E-01
     +, 0.4999999701977E-01
     +, 0.3299999833107    
     +, 0.3499999940395    
     +, 0.3700000047684    
     +, 0.4299999773502    
     +, 0.9300000071526    
     +, 0.9499999880791    
     +, 0.9699999690056    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.8599999547005    
     +, 0.6800000071526    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.1599999964237    
     +/
      DATA SIGA / -36.99972720697    
     +,  24.84308048244    
     +,  10.69320204542    
     +, -10.99561861954    
     +, -6.405305899865    
     +,  7.918598423476    
     +,  297.5011024502    
     +, -963.6442877060    
     +,  714.6004002472    
     +,  17.08664871895    
     +, -56.80928412224    
     +,  11.50627673868    
     +, -1.462566206354    
     +/
      A183_HNN_SIG70 = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         A183_HNN_SIG70 = A183_HNN_SIG70 + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) A183_HNN_SIG70 = VCONST*EXP(A183_HNN_SIG70)
      END
c---------------------------------------------------------------------
      DOUBLE PRECISION FUNCTION A183_HNN_SIG80(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   7, 1)
      DOUBLE PRECISION SIGDEL(   7)
      DOUBLE PRECISION SIGA(   7)
      DATA NPAR, NDIM, IMQFUN /    7,    1,    2/
      DATA VCONST / 0.2999999560416E-02/
      DATA SIGVMI / 0.8500000238419    /
      DATA SIGVT / 0.1499999761581    /
      DATA SIGV / 0.9099999666214    
     +, 0.9300000071526    
     +, 0.9699999690056    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.8599999547005    
     +, 0.7599999904633    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.1599999964237    
     +/
      DATA SIGA /  171.1526312369    
     +, -243.4692792706    
     +,  3.145150368933    
     +,  7.485805582952    
     +,  76.85317341331    
     +, -8.774321494572    
     +,  6.911784726190    
     +/
      A183_HNN_SIG80 = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         A183_HNN_SIG80 = A183_HNN_SIG80 + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) A183_HNN_SIG80 = VCONST*EXP(A183_HNN_SIG80)
      END
c---------------------------------------------------------------------
      DOUBLE PRECISION FUNCTION A183_HNN_SIG85(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   8, 1)
      DOUBLE PRECISION SIGDEL(   8)
      DOUBLE PRECISION SIGA(   8)
      DATA NPAR, NDIM, IMQFUN /    8,    1,    2/
      DATA VCONST / 0.2999999560416E-02/
      DATA SIGVMI / 0.8500000238419    /
      DATA SIGVT / 0.1499999761581    /
      DATA SIGV / 0.9099999666214    
     +, 0.9300000071526    
     +, 0.9499999880791    
     +, 0.9699999690056    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.8599999547005    
     +, 0.7599999904633    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.1599999964237    
     +/
      DATA SIGA / -52.49717649998    
     +,  416.1338850445    
     +, -879.1989478939    
     +,  520.1257524182    
     +,  6.410493270719    
     +, -9.864928964849    
     +,  8.443143043964    
     +,  1.492782091601    
     +/
      A183_HNN_SIG85 = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         A183_HNN_SIG85 = A183_HNN_SIG85 + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) A183_HNN_SIG85 = VCONST*EXP(A183_HNN_SIG85)
      END
c---------------------------------------------------------------------
      DOUBLE PRECISION FUNCTION A183_HNN_SIG90(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   6, 1)
      DOUBLE PRECISION SIGDEL(   6)
      DOUBLE PRECISION SIGA(   6)
      DATA NPAR, NDIM, IMQFUN /    6,    1,    2/
      DATA VCONST / 0.2999999560416E-02/
      DATA SIGVMI / 0.8500000238419    /
      DATA SIGVT / 0.1499999761581    /
      DATA SIGV / 0.9300000071526    
     +, 0.9699999690056    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.7599999904633    
     +, 0.8399999737740    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.1599999964237    
     +, 0.1599999964237    
     +/
      DATA SIGA /  28.38827238180    
     +, -196.0720524861    
     +,  7.046548261597    
     +,  152.7714476772    
     +, -13.16232140696    
     +,  33.70823555315    
     +/
      A183_HNN_SIG90 = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         A183_HNN_SIG90 = A183_HNN_SIG90 + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) A183_HNN_SIG90 = VCONST*EXP(A183_HNN_SIG90)
      END
c---------------------------------------------------------------------
      DOUBLE PRECISION FUNCTION A183_HNN_SIG95(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   6, 1)
      DOUBLE PRECISION SIGDEL(   6)
      DOUBLE PRECISION SIGA(   6)
      DATA NPAR, NDIM, IMQFUN /    6,    1,    2/
      DATA VCONST / 0.2999999560416E-02/
      DATA SIGVMI / 0.8500000238419    /
      DATA SIGVT / 0.1499999761581    /
      DATA SIGV / 0.9300000071526    
     +, 0.9699999690056    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.8599999547005    
     +, 0.7599999904633    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.1599999964237    
     +/
      DATA SIGA /  22.79308140439    
     +, -179.4573652958    
     +,  8.232161736532    
     +,  144.3385319756    
     +,  17.49346582419    
     +, 0.9307955584125    
     +/
      A183_HNN_SIG95 = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         A183_HNN_SIG95 = A183_HNN_SIG95 + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) A183_HNN_SIG95 = VCONST*EXP(A183_HNN_SIG95)
      END
