C Author: Pete McNamara;
C Mods:
c - add a few variable declarations, correct typos;
c
c
c     PTD, 31-May-1999.
C---------------------------------------------------------------------
C---------------------------------------------------------------------
      real*8 function A189_HLL_EFF(hmass,isig)
      implicit none

      real*8 hmass,adiff
      integer isig,ilow,ihigh
      real*8 mmeff(9),eeeff(9),zzeff(9)
      data mmeff / 0.8471, 0.8406, 0.8473, 0.8345, 0.8169,
     &             0.7436, 0.6025, 0.2992, 0.0755/
      data eeeff / 0.7803, 0.7789, 0.7773, 0.7862, 0.7724,
     &             0.6980, 0.5519, 0.2721, 0.0716/
      data zzeff / 0.4674, 0.4273, 0.3829, 0.3120, 0.2529,
     &             0.2199, 0.1833, 0.1009, 0.0346/

      A189_HLL_EFF = 0.
      if (hmass.lt.75.) goto 999
      if (hmass.ge.110.) goto 999
      if ((hmass.ge.75.).AND.(hmass.lt.80.)) then
        ilow = 1
        ihigh = 2
        adiff = (hmass-75.)/(80.-75.)
      endif
      if ((hmass.ge.80.).AND.(hmass.lt.85.)) then
        ilow = 2
        ihigh = 3
        adiff = (hmass-80.)/(85.-80.)
      endif
      if ((hmass.ge.85.).AND.(hmass.lt.90.)) then
        ilow = 3
        ihigh = 4
        adiff = (hmass-85.)/(90.-85.)
      endif
      if ((hmass.ge.90.).AND.(hmass.lt.95.)) then
        ilow = 4
        ihigh = 5
        adiff = (hmass-90.)/(95.-90.)
      endif
      if ((hmass.ge.95.).AND.(hmass.lt.97.5)) then
        ilow = 5
        ihigh = 6
        adiff = (hmass-95.)/(97.5-95.)
      endif
      if ((hmass.ge.97.5).AND.(hmass.lt.100.)) then
        ilow = 6
        ihigh = 7
        adiff = (hmass-97.5)/(100.-97.5)
      endif
      if ((hmass.ge.100.).AND.(hmass.lt.105.)) then
        ilow = 7
        ihigh = 8
        adiff = (hmass-100.)/(105.-100.)
      endif
      if ((hmass.ge.105.).AND.(hmass.lt.110.)) then
        ilow = 8
        ihigh = 9
        adiff = (hmass-105.)/(110.-105.)
      endif

      if (isig.eq.1) then
        A189_HLL_EFF = mmeff(ilow)+
     &                 (mmeff(ihigh)-mmeff(ilow))*adiff
      else if (isig.eq.2) then
        A189_HLL_EFF = eeeff(ilow)+
     &                 (eeeff(ihigh)-eeeff(ilow))*adiff
      else if (isig.eq.3) then
        A189_HLL_EFF = zzeff(ilow)+
     &                 (zzeff(ihigh)-zzeff(ilow))*adiff
      endif

 999  return
      end

C---------------------------------------------------------------------
C---------------------------------------------------------------------
      real*8 function A189_HLL_BKG(ibkg)

      implicit none
      integer ibkg

      A189_HLL_BKG = -1.

      if (ibkg.eq.1) A189_HLL_BKG = 10.79 ! ZZ
      if (ibkg.eq.2) A189_HLL_BKG = 1.96  ! eeZ
      if (ibkg.eq.3) A189_HLL_BKG = 1.32  ! other

      end
C---------------------------------------------------------------------
C---------------------------------------------------------------------
      integer function A189_HLL_NUMCAND()
      implicit none

      A189_HLL_NUMCAND = 14
      end
C---------------------------------------------------------------------
C---------------------------------------------------------------------
      real*8 function A189_HLL_MASS_CAND(icand)
      implicit none
      integer icand

      A189_HLL_MASS_CAND = 10000.

      if (icand.eq.1)  A189_HLL_MASS_CAND = 62.5
      if (icand.eq.2)  A189_HLL_MASS_CAND = 90.0
      if (icand.eq.3)  A189_HLL_MASS_CAND = 95.8
      if (icand.eq.4)  A189_HLL_MASS_CAND = 90.7
      if (icand.eq.5)  A189_HLL_MASS_CAND = 94.8
      if (icand.eq.6)  A189_HLL_MASS_CAND = 90.9
      if (icand.eq.7)  A189_HLL_MASS_CAND = 93.0
      if (icand.eq.8)  A189_HLL_MASS_CAND = 90.0
      if (icand.eq.9)  A189_HLL_MASS_CAND = 98.4
      if (icand.eq.10) A189_HLL_MASS_CAND = 90.6
      if (icand.eq.11) A189_HLL_MASS_CAND = 91.4
      if (icand.eq.12) A189_HLL_MASS_CAND = 89.6
      if (icand.eq.13) A189_HLL_MASS_CAND = 80.0
      if (icand.eq.14) A189_HLL_MASS_CAND = 92.2

      end
C---------------------------------------------------------------------
C---------------------------------------------------------------------
      real*8 function A189_HLL_BTAG_CAND(icand)
      implicit none
      integer icand

      A189_HLL_BTAG_CAND = 10000.

      if (icand.eq.1)  A189_HLL_BTAG_CAND = 0.17
      if (icand.eq.2)  A189_HLL_BTAG_CAND = 2.00
      if (icand.eq.3)  A189_HLL_BTAG_CAND = 1.10
      if (icand.eq.4)  A189_HLL_BTAG_CAND = 0.00
      if (icand.eq.5)  A189_HLL_BTAG_CAND = 1.14
      if (icand.eq.6)  A189_HLL_BTAG_CAND = 0.31
      if (icand.eq.7)  A189_HLL_BTAG_CAND = 0.20
      if (icand.eq.8)  A189_HLL_BTAG_CAND = 0.23
      if (icand.eq.9)  A189_HLL_BTAG_CAND = 0.97
      if (icand.eq.10) A189_HLL_BTAG_CAND = 0.41
      if (icand.eq.11) A189_HLL_BTAG_CAND = 0.42
      if (icand.eq.12) A189_HLL_BTAG_CAND = 0.36
      if (icand.eq.13) A189_HLL_BTAG_CAND = 0.40
      if (icand.eq.14) A189_HLL_BTAG_CAND = 0.24

      end
C---------------------------------------------------------------------
C---------------------------------------------------------------------
      real*8 function A189_HLL_MASS_BKG(x,ibkg)

      implicit none
      real*8 x
      real*8 A189_HLL_MASS_ZZ,A189_HLL_MASS_EEZ,A189_HLL_MASS_BKGTOT
      external A189_HLL_MASS_ZZ,A189_HLL_MASS_EEZ,A189_HLL_MASS_BKGTOT
      integer ibkg

      A189_HLL_MASS_BKG = -1000.

      if (ibkg.eq.1) A189_HLL_MASS_BKG = A189_HLL_MASS_ZZ(x)
      if (ibkg.eq.2) A189_HLL_MASS_BKG = A189_HLL_MASS_EEZ(x)
      if (ibkg.eq.3) A189_HLL_MASS_BKG = A189_HLL_MASS_BKGTOT(x) -
     &                                   A189_HLL_MASS_ZZ(x) -
     &                                   A189_HLL_MASS_EEZ(x)

      if ((A189_HLL_MASS_BKG.GT.-999.).AND.
     &    (A189_HLL_MASS_BKG.LT.1D-6)) A189_HLL_MASS_BKG = 1D-6

      end
C---------------------------------------------------------------------
C---------------------------------------------------------------------
      real*8 function A189_HLL_BTAG_BKG(x,ibkg)

      implicit none
      real*8 x
      real*8 A189_HLL_BTAG_ZZ,A189_HLL_BTAG_EEZ,A189_HLL_BTAG_BKGOTH
      external A189_HLL_BTAG_ZZ,A189_HLL_BTAG_EEZ,A189_HLL_BTAG_BKGOTH
      integer ibkg

      A189_HLL_BTAG_BKG = -1000.

      if (ibkg.eq.1) A189_HLL_BTAG_BKG = A189_HLL_BTAG_ZZ(x)
      if (ibkg.eq.2) A189_HLL_BTAG_BKG = A189_HLL_BTAG_EEZ(x)
      if (ibkg.eq.3) A189_HLL_BTAG_BKG = A189_HLL_BTAG_BKGOTH(x)

      if ((A189_HLL_BTAG_BKG.GT.-999.).AND.
     &    (A189_HLL_BTAG_BKG.LT.1D-6)) A189_HLL_BTAG_BKG = 1D-6

      end
C---------------------------------------------------------------------
C---------------------------------------------------------------------
      real*8 function A189_HLL_MASS_SIG(x, higgsmss)

      implicit none

      real*8 x, higgsmss

      real*8 width1(9), width2(9), mean1(9), mean2(9), mass(9)
      real*8 intvl(8)
      real*8 weight, m1, m2, w1, w2

      integer index

      data mean1 /84.73, 86.96, 89.21, 92.82, 96.84, 98.34,
     &     98.99, 101.2, 102.0/
      data width1 /7.124, 7.355, 6.318, 5.658, 4.975, 5.049,
     &     4.774, 4.268, 0.097/
      data mean2 /75.77, 80.74, 85.65, 90.48, 95.13, 97.33,
     &     99.72, 104.6, 108.7/
      data width2 /3.601, 3.067, 2.697, 2.280, 1.873, 1.968,
     &     2.240, 1.975, 2.876/
      data mass /75.0, 80.0, 85.0, 90.0, 95.0, 97.5, 100.0,
     &     105.0, 110.0/
      data intvl /5.0, 5.0, 5.0, 5.0, 2.5, 2.5, 5.0, 5.0/

      index = int((higgsmss - 75.0d0)/5.d0 + 1)

      if (higgsmss.ge.97.5) index = index + 1

      if (index.le.0) then
        m1 = mean1(1)
        m2 = mean2(1)
        w1 = width1(1)
        w2 = width2(1)
      elseif (index.ge.9) then
        m1 = mean1(9)
        m2 = mean2(9)
        w1 = width1(9)
        w2 = width2(9)
      else
        weight = (higgsmss-mass(index))/intvl(index)

        m1 = (mean1(index+1) - mean1(index))*weight + mean1(index)
        m2 = (mean2(index+1) - mean2(index))*weight + mean2(index)
        w1 = (width1(index+1)- width1(index))*weight+ width1(index)
        w2 = (width2(index+1)- width2(index))*weight+ width2(index)
      endif

      A189_HLL_MASS_SIG = exp(-0.5d0*((x-m1)/w1)**2)*0.2d0/w1 +
     &            exp(-0.5d0*((x-m2)/w2)**2)*0.8d0/w2

      return
      end
C---------------------------------------------------------------------
C---------------------------------------------------------------------
      DOUBLE PRECISION FUNCTION A189_HLL_MASS_BKGTOT(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  11, 1)
      DOUBLE PRECISION SIGDEL(  11)
      DOUBLE PRECISION SIGA(  11)
      DATA NPAR, NDIM, IMQFUN /   11,    1,    1/
      DATA VCONST / 0.0000000000000E+00/
      DATA SIGVMI /  55.00000000000    /
      DATA SIGVT /  70.00000000000    /
      DATA SIGV / 0.2142857164145    
     +, 0.3000000119209    
     +, 0.3285714387894    
     +, 0.4714285731316    
     +, 0.5000000000000    
     +, 0.5285714268684    
     +, 0.5857142806053    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.8571428805590E-01
     +, 0.6571428775787    
     +/
      DATA SIGDEL / 0.5714285746217E-01
     +, 0.5714285746217E-01
     +, 0.5714285746217E-01
     +, 0.5714285746217E-01
     +, 0.5714285746217E-01
     +, 0.5714285746217E-01
     +, 0.5714285746217E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.1142857149243    
     +, 0.1142857149243    
     +/
      DATA SIGA / -2.589752605049    
     +,  2.937514432800    
     +, -1.561396345111    
     +,  109.1225249008    
     +, -152.3091582172    
     +,  6.256816377761    
     +,  38.38258239186    
     +, -1.040850833987    
     +, 0.7387738139748E-01
     +,  2.520978973539    
     +, -1.796518556378    
     +/
      A189_HLL_MASS_BKGTOT = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         A189_HLL_MASS_BKGTOT = A189_HLL_MASS_BKGTOT + SIGA (J)*HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) A189_HLL_MASS_BKGTOT =
     &                   VCONST * EXP (A189_HLL_MASS_BKGTOT)
      END
C---------------------------------------------------------------------
C---------------------------------------------------------------------
      DOUBLE PRECISION FUNCTION A189_HLL_MASS_ZZ(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  17, 1)
      DOUBLE PRECISION SIGDEL(  17)
      DOUBLE PRECISION SIGA(  17)
      DATA NPAR, NDIM, IMQFUN /   17,    1,    1/
      DATA VCONST / 0.0000000000000E+00/
      DATA SIGVMI /  55.00000000000    /
      DATA SIGVT /  70.00000000000    /
      DATA SIGV / 0.4285714402795E-01
     +, 0.3000000119209    
     +, 0.3285714387894    
     +, 0.4142857193947    
     +, 0.4428571462631    
     +, 0.4714285731316    
     +, 0.5000000000000    
     +, 0.5285714268684    
     +, 0.5571428537369    
     +, 0.5857142806053    
     +, 0.6142857074738    
     +, 0.6428571343422    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.1428571492434    
     +, 0.2000000029802    
     +, 0.7142857313156    
     +/
      DATA SIGDEL / 0.5714285746217E-01
     +, 0.5714285746217E-01
     +, 0.5714285746217E-01
     +, 0.5714285746217E-01
     +, 0.5714285746217E-01
     +, 0.5714285746217E-01
     +, 0.5714285746217E-01
     +, 0.5714285746217E-01
     +, 0.5714285746217E-01
     +, 0.5714285746217E-01
     +, 0.5714285746217E-01
     +, 0.5714285746217E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.1142857149243    
     +, 0.1142857149243    
     +, 0.1142857149243    
     +/
      DATA SIGA / -3.301823873340    
     +,-0.9288084442318E-01
     +,  2.513282482217    
     +,  11.14735582648    
     +, -82.71815667881    
     +,  260.1395102265    
     +, -236.5041898721    
     +, -29.68861920688    
     +,  56.52571086583    
     +,  24.64305250750    
     +,-0.6239992316057    
     +, -3.883425988812    
     +,  1.142966000429    
     +,-0.1685813785249E-01
     +,  7.782517979826    
     +, -6.944295420492    
     +,-0.1200915858165    
     +/
      A189_HLL_MASS_ZZ = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         A189_HLL_MASS_ZZ = A189_HLL_MASS_ZZ + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) A189_HLL_MASS_ZZ =
     &                   VCONST * EXP (A189_HLL_MASS_ZZ )
      END
C---------------------------------------------------------------------
C---------------------------------------------------------------------
      DOUBLE PRECISION FUNCTION A189_HLL_MASS_EEZ(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  14, 1)
      DOUBLE PRECISION SIGDEL(  14)
      DOUBLE PRECISION SIGA(  14)
      DATA NPAR, NDIM, IMQFUN /   14,    1,    1/
      DATA VCONST / 0.0000000000000E+00/
      DATA SIGVMI /  55.00000000000    /
      DATA SIGVT /  70.00000000000    /
      DATA SIGV / 0.4285714402795E-01
     +, 0.7142857462168E-01
     +, 0.1571428626776    
     +, 0.3285714387894    
     +, 0.3571428656578    
     +, 0.3857142925262    
     +, 0.4428571462631    
     +, 0.4714285731316    
     +, 0.5857142806053    
     +, 0.6999999880791    
     +, 0.8428571224213    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.2571428716183    
     +/
      DATA SIGDEL / 0.1142857149243    
     +, 0.1142857149243    
     +, 0.1142857149243    
     +, 0.1142857149243    
     +, 0.1142857149243    
     +, 0.1142857149243    
     +, 0.1142857149243    
     +, 0.1142857149243    
     +, 0.1142857149243    
     +, 0.1142857149243    
     +, 0.1142857149243    
     +, 0.3999999989901E-05
     +, 0.3999999989901E-05
     +, 0.2285714298487    
     +/
      DATA SIGA /  33.30384593961    
     +, -31.32817603213    
     +,  16.02971124184    
     +, -21.72879854671    
     +,  120.6746742937    
     +, -141.2631110416    
     +,  145.4607322344    
     +, -99.76506304786    
     +,  13.80399088969    
     +, -1.766291327865    
     +, 0.6593234681287    
     +, -1.760531204487    
     +,  1.484936487592    
     +, -31.73850639487    
     +/
      A189_HLL_MASS_EEZ = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         A189_HLL_MASS_EEZ = A189_HLL_MASS_EEZ + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) A189_HLL_MASS_EEZ =
     &                   VCONST * EXP (A189_HLL_MASS_EEZ)
      END
C---------------------------------------------------------------------
C---------------------------------------------------------------------
      DOUBLE PRECISION FUNCTION A189_HLL_BTAG_SIG(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  10, 1)
      DOUBLE PRECISION SIGDEL(  10)
      DOUBLE PRECISION SIGA(  10)
      DATA NPAR, NDIM, IMQFUN /   10,    1,    1/
      DATA VCONST / 0.0000000000000E+00/
      DATA SIGVMI /-0.2500000037253E-01/
      DATA SIGVT /  2.050000190735    /
      DATA SIGV / 0.3658536449075E-01
     +, 0.9634146094322    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.5609756112099    
     +, 0.8536584973335    
     +, 0.9024389982224    
     +, 0.3414633870125    
     +, 0.4390243887901    
     +, 0.7317072749138    
     +/
      DATA SIGDEL / 0.4878048598766E-01
     +, 0.4878048598766E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.9756097197533E-01
     +, 0.9756097197533E-01
     +, 0.9756097197533E-01
     +, 0.1951219439507    
     +, 0.1951219439507    
     +, 0.1951219439507    
     +/
      DATA SIGA / 0.8949497366185E-02
     +,  2.449382584878    
     +, 0.7378219786708E-01
     +, -2.538543612918    
     +,-0.6475106216744    
     +,-0.7671219446420    
     +, 0.6523384324781    
     +,-0.5946364498563    
     +,  1.030169891550    
     +, 0.4716952171575    
     +/
      A189_HLL_BTAG_SIG = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         A189_HLL_BTAG_SIG = A189_HLL_BTAG_SIG + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) A189_HLL_BTAG_SIG = 
     &                   VCONST * EXP (A189_HLL_BTAG_SIG)
      END
C---------------------------------------------------------------------
C---------------------------------------------------------------------
      DOUBLE PRECISION FUNCTION A189_HLL_BTAG_BKGOTH(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  11, 1)
      DOUBLE PRECISION SIGDEL(  11)
      DOUBLE PRECISION SIGA(  11)
      DATA NPAR, NDIM, IMQFUN /   11,    1,    1/
      DATA VCONST / 0.0000000000000E+00/
      DATA SIGVMI /-0.2500000037253E-01/
      DATA SIGVT /  2.050000190735    /
      DATA SIGV / 0.1097560971975    
     +, 0.1341463327408    
     +, 0.2317073047161    
     +, 0.2560975551605    
     +, 0.2804878056049    
     +, 0.4999999701977    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.5609756112099    
     +, 0.6585365533829    
     +, 0.9024389982224    
     +/
      DATA SIGDEL / 0.1219512149692    
     +, 0.1219512149692    
     +, 0.1219512149692    
     +, 0.1219512149692    
     +, 0.1219512149692    
     +, 0.1219512149692    
     +, 0.4999999873689E-05
     +, 0.4999999873689E-05
     +, 0.2439024299383    
     +, 0.2439024299383    
     +, 0.2439024299383    
     +/
      DATA SIGA / -38.12620760946    
     +,  48.81054571343    
     +, -74.99451350826    
     +,  98.07531647392    
     +, -35.37161967271    
     +,  2.537484267047    
     +,  2.425234973075    
     +, 0.3855397557603    
     +, -7.841390622922    
     +,  5.077129211102    
     +,-0.4339455862338    
     +/
      A189_HLL_BTAG_BKGOTH = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         A189_HLL_BTAG_BKGOTH = A189_HLL_BTAG_BKGOTH + SIGA (J)*HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) A189_HLL_BTAG_BKGOTH =
     &                   VCONST * EXP (A189_HLL_BTAG_BKGOTH)
      END
C---------------------------------------------------------------------
C---------------------------------------------------------------------
      DOUBLE PRECISION FUNCTION A189_HLL_BTAG_ZZ(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  17, 1)
      DOUBLE PRECISION SIGDEL(  17)
      DOUBLE PRECISION SIGA(  17)
      DATA NPAR, NDIM, IMQFUN /   17,    1,    1/
      DATA VCONST / 0.0000000000000E+00/
      DATA SIGVMI /-0.2500000037253E-01/
      DATA SIGVT /  2.050000190735    /
      DATA SIGV / 0.8536584675312E-01
     +, 0.1585365831852    
     +, 0.3780487775803    
     +, 0.4024389982224    
     +, 0.4268292486668    
     +, 0.4512194991112    
     +, 0.4756097495556    
     +, 0.4999999701977    
     +, 0.5243902206421    
     +, 0.6707316637039    
     +, 0.8414633870125    
     +, 0.8658536076546    
     +, 0.9390243291855    
     +, 0.9634146094322    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.6097560524940    
     +/
      DATA SIGDEL / 0.4878048598766E-01
     +, 0.4878048598766E-01
     +, 0.4878048598766E-01
     +, 0.4878048598766E-01
     +, 0.4878048598766E-01
     +, 0.4878048598766E-01
     +, 0.4878048598766E-01
     +, 0.4878048598766E-01
     +, 0.4878048598766E-01
     +, 0.4878048598766E-01
     +, 0.4878048598766E-01
     +, 0.4878048598766E-01
     +, 0.4878048598766E-01
     +, 0.4878048598766E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.9756097197533E-01
     +/
      DATA SIGA / -15.20352274371    
     +,  6.306108501636    
     +, -8.051629215006    
     +,  22.74762201054    
     +, -34.26913096675    
     +,  49.27895522124    
     +, -63.48951272302    
     +,  54.12083508877    
     +, -23.49131604570    
     +, -2.977098988861    
     +,  1.200889942199    
     +, -1.248904316237    
     +, -6.790214674039    
     +,  17.18094862790    
     +,  8.532185524273    
     +, -10.11512459054    
     +,  6.575266464061    
     +/
      A189_HLL_BTAG_ZZ = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         A189_HLL_BTAG_ZZ = A189_HLL_BTAG_ZZ + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) A189_HLL_BTAG_ZZ =
     &                   VCONST * EXP (A189_HLL_BTAG_ZZ)
      END
C---------------------------------------------------------------------
C---------------------------------------------------------------------
      DOUBLE PRECISION FUNCTION A189_HLL_BTAG_EEZ(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  16, 1)
      DOUBLE PRECISION SIGDEL(  16)
      DOUBLE PRECISION SIGA(  16)
      DATA NPAR, NDIM, IMQFUN /   16,    1,    1/
      DATA VCONST / 0.0000000000000E+00/
      DATA SIGVMI /-0.2500000037253E-01/
      DATA SIGVT /  2.050000190735    /
      DATA SIGV / 0.3658536449075E-01
     +, 0.8536584675312E-01
     +, 0.1585365831852    
     +, 0.2073170691729    
     +, 0.4999999701977    
     +, 0.5243902206421    
     +, 0.5487804412842    
     +, 0.5731707215309    
     +, 0.6463414430618    
     +, 0.6707316637039    
     +, 0.6951219439507    
     +, 0.9634146094322    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.9024389982224    
     +, 0.3414633870125    
     +/
      DATA SIGDEL / 0.9756097197533E-01
     +, 0.9756097197533E-01
     +, 0.9756097197533E-01
     +, 0.9756097197533E-01
     +, 0.9756097197533E-01
     +, 0.9756097197533E-01
     +, 0.9756097197533E-01
     +, 0.9756097197533E-01
     +, 0.9756097197533E-01
     +, 0.9756097197533E-01
     +, 0.9756097197533E-01
     +, 0.9756097197533E-01
     +, 0.3999999989901E-05
     +, 0.3999999989901E-05
     +, 0.1951219439507    
     +, 0.3902438879013    
     +/
      DATA SIGA /  23.24052354155    
     +, -35.08514763861    
     +,  25.43779728266    
     +, -14.35034702983    
     +, -19.50461648525    
     +,  53.32386969722    
     +, -69.36502863467    
     +,  38.29729311325    
     +, -10.41136183509    
     +,  2.570980461702    
     +,  2.315198986040    
     +,  2.326438395809    
     +, -6.206329972640    
     +, -2.247909583609    
     +, -3.628908432263    
     +,  10.41247643168    
     +/
      A189_HLL_BTAG_EEZ = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         A189_HLL_BTAG_EEZ = A189_HLL_BTAG_EEZ + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) A189_HLL_BTAG_EEZ =
     &                   VCONST * EXP (A189_HLL_BTAG_EEZ)
      END


