      double precision function A189_HNN_EFF(hmass,iana,br)
c
c--- Returns the HZ ---> Hnn efficiency;
c
      integer iana,br
      real*8 hmass, andeffhz, wiseffhz,orseffhz
      if (iana.eq.1) then
         A189_HNN_EFF = andeffhz(hmass,br)*0.96
      elseif (iana.eq.2) then
         A189_HNN_EFF = wiseffhz(hmass,br)*1.00
      elseif (iana.eq.3) then
         A189_HNN_EFF = orseffhz(hmass,br)*1.06
      endif
      end

      double precision function A189_HNN_WWF_EFF(hmass,iana,br)
c
c--- Returns the WW ---> Hnn efficiency;
c
      integer iana,br
      real*8 hmass, andeffww, wiseffww,orseffww
      if (iana.eq.1) then
         A189_HNN_WWF_EFF = andeffww(hmass,br)*0.92
      elseif (iana.eq.2) then
         A189_HNN_WWF_EFF = wiseffww(hmass,br)*1.00
      elseif (iana.eq.3) then
         A189_HNN_WWF_EFF = orseffww(hmass,br)*1.2
      endif
      end




      double precision function andeffhz(hmass,br)
      integer br, i
      real*8 hmass, effhzbb(9),effhztt(9),effhzcc(9),effhzgg(9),eff(9)
      data effhzbb/0.184556,0.261513,0.339167,0.406773,0.379981,
     &     0.30993,0.305966,0.237948,0.170317/
      data effhztt/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/
      data effhzcc/0.00293255,0.00526316,0.00600601,0.0344828
     &     ,0.0451807,0.0483871,0.0198413,0.0110497,0.0/
      data effhzgg/0.0,0.00287356,0.00694444,0.0175439,0.0296128
     &     ,0.00744417,0.0119048,0.0116732,0.005/
      if (br.eq.1) then
         do i = 1, 9
            eff(i)=effhzbb(i)
         enddo
      elseif (br.eq.2) then
         do i = 1, 9
         eff(i)=effhztt(i)
         enddo
      elseif(br.eq.3) then
         do i = 1, 9
         eff(i)=effhzcc(i)
         enddo
      elseif(br.eq.4) then
         do i = 1, 9
         eff(i)=effhzgg(i)
         enddo
      endif
      if (br.eq.1.0.or.br.eq.2.0.or.br.eq.3.0.or.br.eq.4.0) then
         if(hmass.lt.80.0.and.hmass.ge.75) then
            effmh = (eff(1)*(80.0-hmass)+eff(2)*(hmass-75.0))/5.0
         elseif(hmass.lt.85.0.and.hmass.ge.80.0) then
            effmh = (eff(2)*(85.0-hmass)+eff(3)*(hmass-80.0))/5.0
         elseif(hmass.lt.90.0.and.hmass.ge.85.0) then
            effmh = (eff(3)*(90.0-hmass)+eff(4)*(hmass-85.0))/5.0
         elseif(hmass.lt.95.0.and.hmass.ge.90.0) then
            effmh = (eff(4)*(95.0-hmass)+eff(5)*(hmass-90.0))/5.0
         elseif(hmass.lt.97.5.and.hmass.ge.95.0) then
            effmh = (eff(5)*(97.5-hmass)+eff(6)*(hmass-95.0))/2.5
         elseif(hmass.lt.100.0.and.hmass.ge.97.5) then
            effmh = (eff(6)*(100.0-hmass)+eff(7)*(hmass-97.5))/2.5
         elseif(hmass.lt.105.0.and.hmass.ge.100.0) then
            effmh = (eff(7)*(105.0-hmass)+eff(8)*(hmass-100.0))/5.0
         elseif(hmass.lt.110.0.and.hmass.ge.105.0) then
            effmh = (eff(8)*(110.0-hmass)+eff(9)*(hmass-105.0))/5.0
         elseif(hmass.ge.110.0) then
            effmh = eff(9)
         endif
      else
         effmh = 0.0
      endif
      andeffhz=effmh
      end

      



      double precision function wiseffhz(hmass,br)
      integer br, i
      real*8 hmass, effhzbb(9),effhztt(9),effhzcc(9),effhzgg(9),eff(9)
      data effhzbb/0.0554792,0.0672606,0.0598011,0.045197,
     &     0.0376558,0.0450352,0.0706832,0.0936002,0.0978097/
      data effhztt/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/
      data effhzcc/0.00293255,0.00789474,0.00600601,0.0114943
     &     ,0.0240964,0.0258065,0.00396825,0.0110497,0.0/
      data effhzgg/0.0,0.00862069,0.00231481,0.00250627,0.00455581,
     &     0.00992556,0.014881,0.00389105,0.0/
      if (br.eq.1) then
         do i = 1, 9
            eff(i)=effhzbb(i)
         enddo
      elseif (br.eq.2) then
         do i = 1, 9
         eff(i)=effhztt(i)
         enddo
      elseif(br.eq.3) then
         do i = 1, 9
         eff(i)=effhzcc(i)
         enddo
      elseif(br.eq.4) then
         do i = 1, 9
         eff(i)=effhzgg(i)
         enddo
      endif
      if (br.eq.1.0.or.br.eq.2.0.or.br.eq.3.0.or.br.eq.4.0) then
         if(hmass.lt.80.0.and.hmass.ge.75) then
            effmh = (eff(1)*(80.0-hmass)+eff(2)*(hmass-75.0))/5.0
         elseif(hmass.lt.85.0.and.hmass.ge.80.0) then
            effmh = (eff(2)*(85.0-hmass)+eff(3)*(hmass-80.0))/5.0
         elseif(hmass.lt.90.0.and.hmass.ge.85.0) then
            effmh = (eff(3)*(90.0-hmass)+eff(4)*(hmass-85.0))/5.0
         elseif(hmass.lt.95.0.and.hmass.ge.90.0) then
            effmh = (eff(4)*(95.0-hmass)+eff(5)*(hmass-90.0))/5.0
         elseif(hmass.lt.97.5.and.hmass.ge.95.0) then
            effmh = (eff(5)*(97.5-hmass)+eff(6)*(hmass-95.0))/2.5
         elseif(hmass.lt.100.0.and.hmass.ge.97.5) then
            effmh = (eff(6)*(100.0-hmass)+eff(7)*(hmass-97.5))/2.5
         elseif(hmass.lt.105.0.and.hmass.ge.100.0) then
            effmh = (eff(7)*(105.0-hmass)+eff(8)*(hmass-100.0))/5.0
         elseif(hmass.lt.110.0.and.hmass.ge.105.0) then
            effmh = (eff(8)*(110.0-hmass)+eff(9)*(hmass-105.0))/5.0
         elseif(hmass.ge.110.0) then
            effmh = eff(9)
         endif
      else
         effmh = 0.0
      endif
      wiseffhz=effmh
      end



      double precision function orseffhz(hmass,br)
      integer br, i
      real*8 hmass, effhzbb(9),effhztt(9),effhzcc(9),effhzgg(9),eff(9)
      data effhzbb/0.134699,0.128372,0.12703,0.138166,
     &     0.133918,0.111962,0.0974601,0.0690725,0.0517372/
      data effhztt/0.0,0.0,0.0,0.00131579,0.0,0.0,0.0,0.0,0.0/
      data effhzcc/0.00879765,0.00789474,0.033033,
     &     0.0201149,0.0150602,0.0129032,0.00793651,0.0110497,0.0/
      data effhzgg/0.0,0.00287356,0.00462963,0.0150376,
     &     0.00683371,0.00496278,0.00297619,0.0,0.01/
      if (br.eq.1) then
         do i = 1, 9
            eff(i)=effhzbb(i)
         enddo
      elseif (br.eq.2) then
         do i = 1, 9
         eff(i)=effhztt(i)
         enddo
      elseif(br.eq.3) then
         do i = 1, 9
         eff(i)=effhzcc(i)
         enddo
      elseif(br.eq.4) then
         do i = 1, 9
         eff(i)=effhzgg(i)
         enddo
      endif
      if (br.eq.1.0.or.br.eq.2.0.or.br.eq.3.0.or.br.eq.4.0) then
         if(hmass.lt.80.0.and.hmass.ge.75) then
            effmh = (eff(1)*(80.0-hmass)+eff(2)*(hmass-75.0))/5.0
         elseif(hmass.lt.85.0.and.hmass.ge.80.0) then
            effmh = (eff(2)*(85.0-hmass)+eff(3)*(hmass-80.0))/5.0
         elseif(hmass.lt.90.0.and.hmass.ge.85.0) then
            effmh = (eff(3)*(90.0-hmass)+eff(4)*(hmass-85.0))/5.0
         elseif(hmass.lt.95.0.and.hmass.ge.90.0) then
            effmh = (eff(4)*(95.0-hmass)+eff(5)*(hmass-90.0))/5.0
         elseif(hmass.lt.97.5.and.hmass.ge.95.0) then
            effmh = (eff(5)*(97.5-hmass)+eff(6)*(hmass-95.0))/2.5
         elseif(hmass.lt.100.0.and.hmass.ge.97.5) then
            effmh = (eff(6)*(100.0-hmass)+eff(7)*(hmass-97.5))/2.5
         elseif(hmass.lt.105.0.and.hmass.ge.100.0) then
            effmh = (eff(7)*(105.0-hmass)+eff(8)*(hmass-100.0))/5.0
         elseif(hmass.lt.110.0.and.hmass.ge.105.0) then
            effmh = (eff(8)*(110.0-hmass)+eff(9)*(hmass-105.0))/5.0
         elseif(hmass.ge.110.0) then
            effmh = eff(9)
         endif
      else
         effmh = 0.0
      endif
      orseffhz=effmh
      end




      double precision function andeffww(hmass,br)
      integer br, i
      real*8 hmass, effwwbb(9),effwwtt(9),effwwcc(9),effwwgg(9),eff(9)
      data effwwbb/0.165957,0.164474,0.184035,0.166951,
     &     0.222103,0.199561,0.183912,0.173318,0.142802/
      data effwwtt/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/
      data effwwcc/0.0,0.0,0.0,0.0416667,0.0,0.0253165,
     &     0.0136986,0.0137615,0.00396825/
      data effwwgg/0.0,0.0,0.0,0.0,0.0,0.008,0.0046729,0.0,0.0/

      if (br.eq.1) then
         do i = 1, 9
            eff(i)=effwwbb(i)
         enddo
      elseif (br.eq.2) then
         do i = 1, 9
         eff(i)=effwwtt(i)
         enddo
      elseif(br.eq.3) then
         do i = 1, 9
         eff(i)=effwwcc(i)
         enddo
      elseif(br.eq.4) then
         do i = 1, 9
         eff(i)=effwwgg(i)
         enddo
      endif
      if (br.eq.1.0.or.br.eq.2.0.or.br.eq.3.0.or.br.eq.4.0) then
         if(hmass.lt.80.0.and.hmass.ge.75) then
            effmh = (eff(1)*(80.0-hmass)+eff(2)*(hmass-75.0))/5.0
         elseif(hmass.lt.85.0.and.hmass.ge.80.0) then
            effmh = (eff(2)*(85.0-hmass)+eff(3)*(hmass-80.0))/5.0
         elseif(hmass.lt.90.0.and.hmass.ge.85.0) then
            effmh = (eff(3)*(90.0-hmass)+eff(4)*(hmass-85.0))/5.0
         elseif(hmass.lt.95.0.and.hmass.ge.90.0) then
            effmh = (eff(4)*(95.0-hmass)+eff(5)*(hmass-90.0))/5.0
         elseif(hmass.lt.97.5.and.hmass.ge.95.0) then
            effmh = (eff(5)*(97.5-hmass)+eff(6)*(hmass-95.0))/2.5
         elseif(hmass.lt.100.0.and.hmass.ge.97.5) then
            effmh = (eff(6)*(100.0-hmass)+eff(7)*(hmass-97.5))/2.5
         elseif(hmass.lt.105.0.and.hmass.ge.100.0) then
            effmh = (eff(7)*(105.0-hmass)+eff(8)*(hmass-100.0))/5.0
         elseif(hmass.lt.110.0.and.hmass.ge.105.0) then
            effmh = (eff(8)*(110.0-hmass)+eff(9)*(hmass-105.0))/5.0
         elseif(hmass.ge.110.0) then
            effmh = eff(9)
         endif
      else
         effmh = 0.0
      endif
      andeffww=effmh
      end

      



      double precision function wiseffww(hmass,br)
      integer br, i
      real*8 hmass, effwwbb(9),effwwtt(9),effwwcc(9),effwwgg(9),eff(9)
      data effwwbb/0.0723404,0.109649,0.0709534,0.0954003,
     &     0.111588,0.100329,0.120337,0.105381,0.108155/
      data effwwtt/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/
      data effwwcc/0.0,0.0555556,0.0,0.0,0.0,0.0126582,
     &     0.0136986,0.00917431,0.0/
      data effwwgg/0.0,0.0,0.0,0.0,0.0,0.0,0.0046729,0.0,0.00218818/
      if (br.eq.1) then
         do i = 1, 9
            eff(i)=effwwbb(i)
         enddo
      elseif (br.eq.2) then
         do i = 1, 9
         eff(i)=effwwtt(i)
         enddo
      elseif(br.eq.3) then
         do i = 1, 9
         eff(i)=effwwcc(i)
         enddo
      elseif(br.eq.4) then
         do i = 1, 9
         eff(i)=effwwgg(i)
         enddo
      endif
      if (br.eq.1.0.or.br.eq.2.0.or.br.eq.3.0.or.br.eq.4.0) then
         if(hmass.lt.80.0.and.hmass.ge.75) then
            effmh = (eff(1)*(80.0-hmass)+eff(2)*(hmass-75.0))/5.0
         elseif(hmass.lt.85.0.and.hmass.ge.80.0) then
            effmh = (eff(2)*(85.0-hmass)+eff(3)*(hmass-80.0))/5.0
         elseif(hmass.lt.90.0.and.hmass.ge.85.0) then
            effmh = (eff(3)*(90.0-hmass)+eff(4)*(hmass-85.0))/5.0
         elseif(hmass.lt.95.0.and.hmass.ge.90.0) then
            effmh = (eff(4)*(95.0-hmass)+eff(5)*(hmass-90.0))/5.0
         elseif(hmass.lt.97.5.and.hmass.ge.95.0) then
            effmh = (eff(5)*(97.5-hmass)+eff(6)*(hmass-95.0))/2.5
         elseif(hmass.lt.100.0.and.hmass.ge.97.5) then
            effmh = (eff(6)*(100.0-hmass)+eff(7)*(hmass-97.5))/2.5
         elseif(hmass.lt.105.0.and.hmass.ge.100.0) then
            effmh = (eff(7)*(105.0-hmass)+eff(8)*(hmass-100.0))/5.0
         elseif(hmass.lt.110.0.and.hmass.ge.105.0) then
            effmh = (eff(8)*(110.0-hmass)+eff(9)*(hmass-105.0))/5.0
         elseif(hmass.ge.110.0) then
            effmh = eff(9)
         endif
      else
         effmh = 0.0
      endif
      wiseffww=effmh
      end



      double precision function orseffww(hmass,br)
      integer br, i
      real*8 hmass, effwwbb(9),effwwtt(9),effwwcc(9),effwwgg(9),eff(9)
      data effwwbb/0.0978723,0.109649,0.0554324,0.0698467,
     &     0.0515021,0.0559211,0.0574116,0.0461883,0.0359877/
      data effwwtt/0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/
      data effwwcc/0.0,0.0,0.0,0.0,0.0,0.0,0.00684932,0.0,0.0/
      data effwwgg/0.0,0.0,0.04,0.0,0.0,0.008,0.0,0.00292398,0.0/
      if (br.eq.1) then
         do i = 1, 9
            eff(i)=effwwbb(i)
         enddo
      elseif (br.eq.2) then
         do i = 1, 9
         eff(i)=effwwtt(i)
         enddo
      elseif(br.eq.3) then
         do i = 1, 9
         eff(i)=effwwcc(i)
         enddo
      elseif(br.eq.4) then
         do i = 1, 9
         eff(i)=effwwgg(i)
         enddo
      endif
      if (br.eq.1.0.or.br.eq.2.0.or.br.eq.3.0.or.br.eq.4.0) then
         if(hmass.lt.80.0.and.hmass.ge.75) then
            effmh = (eff(1)*(80.0-hmass)+eff(2)*(hmass-75.0))/5.0
         elseif(hmass.lt.85.0.and.hmass.ge.80.0) then
            effmh = (eff(2)*(85.0-hmass)+eff(3)*(hmass-80.0))/5.0
         elseif(hmass.lt.90.0.and.hmass.ge.85.0) then
            effmh = (eff(3)*(90.0-hmass)+eff(4)*(hmass-85.0))/5.0
         elseif(hmass.lt.95.0.and.hmass.ge.90.0) then
            effmh = (eff(4)*(95.0-hmass)+eff(5)*(hmass-90.0))/5.0
         elseif(hmass.lt.97.5.and.hmass.ge.95.0) then
            effmh = (eff(5)*(97.5-hmass)+eff(6)*(hmass-95.0))/2.5
         elseif(hmass.lt.100.0.and.hmass.ge.97.5) then
            effmh = (eff(6)*(100.0-hmass)+eff(7)*(hmass-97.5))/2.5
         elseif(hmass.lt.105.0.and.hmass.ge.100.0) then
            effmh = (eff(7)*(105.0-hmass)+eff(8)*(hmass-100.0))/5.0
         elseif(hmass.lt.110.0.and.hmass.ge.105.0) then
            effmh = (eff(8)*(110.0-hmass)+eff(9)*(hmass-105.0))/5.0
         elseif(hmass.ge.110.0) then
            effmh = eff(9)
         endif
      else
         effmh = 0.0
      endif
      orseffww=effmh
      end



C iana=1 : AND
C iana=2 : Wis. Ex.
C iana=3 : Ors. Ex.
C bkg=1 : QQ
C bkg=2 : WW
C bkg=3 : ZZ

      DOUBLE PRECISION function A189_HNN_BKG(iana,bkg)
      integer iana, bkg
      REAL*8 andbkg(3), wisbkg(3), orsbkg(3)
      data andbkg/0.17, 0.17, 2.74/
      data wisbkg/0.03, 0.30, 0.41/
      data orsbkg/0.91, 0.23, 1.27/
      if (iana.eq.1.0) then 
         A189_HNN_BKG=andbkg(bkg) 
      elseif (iana.eq.2.0) then 
         A189_HNN_BKG=wisbkg(bkg)      
      elseif (iana.eq.3.0) then 
         A189_HNN_BKG=orsbkg(bkg)
      else 
         A189_HNN_BKG=0.0
      endif
      end
      

      integer function A189_HNN_NUMCAND(iana)
      integer iana
      INTEGER numcand(3)
      data numcand/5,0,4/
      if (iana.eq.1.0.or.iana.eq.2.0.or.iana.eq.3.0) then
         A189_HNN_NUMCAND = numcand(iana)
      else 
         A189_HNN_NUMCAND = 0
      endif
      end
      
      DOUBLE PRECISION function A189_HNN_MASS_CAND(iana,icand)
      integer iana,icand
      REAL*8 andmass(5), orsmass(4)
      data andmass/94.3006, 89.4338, 87.7919, 91.3491, 86.1753/
      data orsmass/89.6255, 88.1427, 90.1162, 96.078/
      if (iana.eq.1.0) then 
         A189_HNN_MASS_CAND=andmass(icand)
      elseif(iana.eq.3.0) then
         A189_HNN_MASS_CAND=orsmass(icand)
      else
         A189_HNN_MASS_CAND=0.0   
      endif
      
      end

      DOUBLE PRECISION Function A189_HNN_MASS_SIG(x,hmass,iana)
      Implicit none
      REAL*8        x
      REAL*8 hmass
      REAL*8 cr_wao75, cr_wao80, cr_wao85, cr_wao90 , 
     &     cr_wao95, cr_wao975, cr_wao100, cr_wao105, 
     &     cr_wao110, cr_wano75, cr_wano80, cr_wano85, 
     &     cr_wano90 , cr_wano95, cr_wano975, cr_wano100, 
     &     cr_wano105, cr_wano110, cr_nwao75, cr_nwao80, 
     &     cr_nwao85, cr_nwao90 , cr_nwao95, cr_nwao975, 
     &     cr_nwao100, cr_nwao105, cr_nwao110
      Integer       iana

      REAL*8        mfunc_wao75,mfunc_wao80, 
     &              mfunc_wao85, mfunc_wao90,  
     &              mfunc_wao95, mfunc_wao975,  
     &              mfunc_wao100, mfunc_wao105, 
     &              mfunc_wao110,cr, p1, p2
      REAL*8        mfunc_wano75,mfunc_wano80, 
     &              mfunc_wano85, mfunc_wano90,  
     &              mfunc_wano95, mfunc_wano975,  
     &              mfunc_wano100, mfunc_wano105, 
     &              mfunc_wano110
      REAL*8        mfunc_nwao75,mfunc_nwao80, 
     &              mfunc_nwao85, mfunc_nwao90,  
     &              mfunc_nwao95, mfunc_nwao975,  
     &              mfunc_nwao100, mfunc_nwao105, 
     &              mfunc_nwao110
      External      mfunc_wao75,mfunc_wao80, 
     &              mfunc_wao85, mfunc_wao90, mfunc_wao95, 
     &              mfunc_wao975, mfunc_wao100, 
     &              mfunc_wao105,mfunc_wao110
      External      mfunc_wano75,mfunc_wano80, 
     &              mfunc_wano85, mfunc_wano90, mfunc_wano95, 
     &              mfunc_wano975, mfunc_wano100, 
     &              mfunc_wano105,mfunc_wano110
      External      mfunc_nwao75,mfunc_nwao80, 
     &              mfunc_nwao85, mfunc_nwao90, mfunc_nwao95, 
     &              mfunc_nwao975, mfunc_nwao100, 
     &              mfunc_nwao105,mfunc_nwao110
      cr_wao75 = 77.31
      cr_wao80 = 81.48
      cr_wao85 = 85.31
      cr_wao90 = 89.20
      cr_wao95 = 92.24
      cr_wao975 = 91.51
      cr_wao100 = 90.34
      cr_wao105 = 89.68
      cr_wao110 = 90.08
      cr_wano75 = 73.29
      cr_wano80 = 77.95
      cr_wano85 = 81.91
      cr_wano90 = 85.53
      cr_wano95 = 88.85
      cr_wano975 = 84.65
      cr_wano100 = 84.47
      cr_wano105 = 85.18
      cr_wano110 = 86.30
      cr_nwao75 = 77.36
      cr_nwao80 = 81.23
      cr_nwao85 = 85.44
      cr_nwao90 = 88.55
      cr_nwao95 = 91.56
      cr_nwao975 = 91.05
      cr_nwao100 = 90.60
      cr_nwao105 = 90.79
      cr_nwao110 = 90.52
      if    ( iana.eq.1 ) then
        if(hmass.lt.80.0.and.hmass.ge.75.0) then 
           cr=(cr_wao80*(hmass-75.0)+cr_wao75*(80.0-hmass))/5
           p1=x-cr+cr_wao75
           p2=x-cr+cr_wao80
          A189_HNN_MASS_SIG = mfunc_wao75(p1)*(80.0-hmass)+
     &          mfunc_wao80(p2)*(hmass-75.0)
        elseif(hmass.lt.85.0.and.hmass.ge.80.0) then
           cr=(cr_wao85*(hmass-80)+cr_wao80*(85-hmass))/5
           p1=x-cr+cr_wao80
           p2=x-cr+cr_wao85
          A189_HNN_MASS_SIG = mfunc_wao80(p1)*(85.0-hmass)+
     &          mfunc_wao85(p2)*(hmass-80.0)
        elseif(hmass.lt.90.0.and.hmass.ge.85.0) then
           cr=(cr_wao90*(hmass-85.0)+cr_wao85*(90.0-hmass))/5
           p1=x-cr+cr_wao85
           p2=x-cr+cr_wao90
          A189_HNN_MASS_SIG = mfunc_wao85(p1)*(90.0-hmass)+
     &          mfunc_wao90(p2)*(hmass-85.0)
        elseif(hmass.lt.95.0.and.hmass.ge.90.0) then
           cr=(cr_wao95*(hmass-90.0)+cr_wao90*(95.0-hmass))/5
           p1=x-cr+cr_wao90
           p2=x-cr+cr_wao95
          A189_HNN_MASS_SIG = mfunc_wao90(p1)*(95.0-hmass)+
     &          mfunc_wao95(p2)*(hmass-90.0)
        elseif(hmass.lt.97.5.and.hmass.ge.95) then
           cr=(cr_wao975*(hmass-95.0)+cr_wao95*(97.5-hmass))/2.5
           p1=x-cr+cr_wao95
           p2=x-cr+cr_wao975
          A189_HNN_MASS_SIG=mfunc_wao95(p1)*(97.5-hmass)+
     &          mfunc_wao975(p2)*(hmass-95.0)
        elseif(hmass.lt.100.0.and.hmass.ge.97.5) then
           cr=(cr_wao100*(hmass-97.5)+cr_wao975*(100.0-hmass))/2.5
           p1=x-cr+cr_wao975
           p2=x-cr+cr_wao100
        A189_HNN_MASS_SIG=mfunc_wao975(p1)*(100.0-hmass)+
     &          mfunc_wao100(p2)*(hmass-97.5)
        elseif(hmass.lt.105.0.and.hmass.ge.100.0) then
           cr=(cr_wao105*(hmass-100.0)+cr_wao100*(105.0-hmass))/5
           p1=x-cr+cr_wao100
           p2=x-cr+cr_wao105
        A189_HNN_MASS_SIG=mfunc_wao100(p1)*(105.0-hmass)+
     &          mfunc_wao105(p2)*(hmass-100.0)
        elseif(hmass.lt.110.0.and.hmass.ge.105.0) then
           cr=(cr_wao110*(hmass-105.0)+cr_wao105*(110.0-hmass))/5
           p1=x-cr+cr_wao105
           p2=x-cr+cr_wao110
        A189_HNN_MASS_SIG=mfunc_wao105(p1)*(110.0-hmass)+
     &          mfunc_wao110(p2)*(hmass-105.0)
        else 
           A189_HNN_MASS_SIG = mfunc_wao110(x)
        endif

      elseif( iana.eq.2 ) then
        if(hmass.lt.80.0.and.hmass.ge.75.0) then 
           cr=(cr_wano80*(hmass-75.0)+cr_wano75*(80.0-hmass))/5
           p1=x-cr+cr_wano75
           p2=x-cr+cr_wano80
          A189_HNN_MASS_SIG = mfunc_wano75(p1)*(80.0-hmass)+
     &          mfunc_wano80(p2)*(hmass-75.0)
        elseif(hmass.lt.85.0.and.hmass.ge.80.0) then
           cr=(cr_wano85*(hmass-80)+cr_wano80*(85-hmass))/5
           p1=x-cr+cr_wano80
           p2=x-cr+cr_wano85
          A189_HNN_MASS_SIG = mfunc_wano80(p1)*(85.0-hmass)+
     &          mfunc_wano85(p2)*(hmass-80.0)
        elseif(hmass.lt.90.0.and.hmass.ge.85.0) then
           cr=(cr_wano90*(hmass-85.0)+cr_wano85*(90.0-hmass))/5
           p1=x-cr+cr_wano85
           p2=x-cr+cr_wano90
          A189_HNN_MASS_SIG = mfunc_wano85(p1)*(90.0-hmass)+
     &          mfunc_wano90(p2)*(hmass-85.0)
        elseif(hmass.lt.95.0.and.hmass.ge.90.0) then
           cr=(cr_wano95*(hmass-90.0)+cr_wano90*(95.0-hmass))/5
           p1=x-cr+cr_wano90
           p2=x-cr+cr_wano95
          A189_HNN_MASS_SIG = mfunc_wano90(p1)*(95.0-hmass)+
     &          mfunc_wano95(p2)*(hmass-90.0)
        elseif(hmass.lt.97.5.and.hmass.ge.95) then
           cr=(cr_wano975*(hmass-95.0)+cr_wano95*(97.5-hmass))/2.5
           p1=x-cr+cr_wano95
           p2=x-cr+cr_wano975
          A189_HNN_MASS_SIG=mfunc_wano95(p1)*(97.5-hmass)+
     &          mfunc_wano975(p2)*(hmass-95.0)
        elseif(hmass.lt.100.0.and.hmass.ge.97.5) then
           cr=(cr_wano100*(hmass-97.5)+cr_wano975*(100.0-hmass))/2.5
           p1=x-cr+cr_wano975
           p2=x-cr+cr_wano100
        A189_HNN_MASS_SIG=mfunc_wano975(p1)*(100.0-hmass)+
     &          mfunc_wano100(p2)*(hmass-97.5)
        elseif(hmass.lt.105.0.and.hmass.ge.100.0) then
           cr=(cr_wano105*(hmass-100.0)+cr_wano100*(105.0-hmass))/5
           p1=x-cr+cr_wano100
           p2=x-cr+cr_wano105
        A189_HNN_MASS_SIG=mfunc_wano100(p1)*(105.0-hmass)+
     &          mfunc_wano105(p2)*(hmass-100.0)
        elseif(hmass.lt.110.0.and.hmass.ge.105.0) then
           cr=(cr_wano110*(hmass-105.0)+cr_wano105*(110.0-hmass))/5
           p1=x-cr+cr_wano105
           p2=x-cr+cr_wano110
        A189_HNN_MASS_SIG=mfunc_wano105(p1)*(110.0-hmass)+
     &          mfunc_wano110(p2)*(hmass-105.0)
        else 
           A189_HNN_MASS_SIG = mfunc_wano110(x)
        endif
 
      elseif ( iana.eq.3 ) then
        if(hmass.lt.80.0.and.hmass.ge.75.0) then 
           cr=(cr_nwao80*(hmass-75.0)+cr_nwao75*(80.0-hmass))/5
           p1=x-cr+cr_nwao75
           p2=x-cr+cr_nwao80
          A189_HNN_MASS_SIG = mfunc_nwao75(p1)*(80.0-hmass)+
     &          mfunc_nwao80(p2)*(hmass-75.0)
        elseif(hmass.lt.85.0.and.hmass.ge.80.0) then
           cr=(cr_nwao85*(hmass-80)+cr_nwao80*(85-hmass))/5
           p1=x-cr+cr_nwao80
           p2=x-cr+cr_nwao85
          A189_HNN_MASS_SIG = mfunc_nwao80(p1)*(85.0-hmass)+
     &          mfunc_nwao85(p2)*(hmass-80.0)
        elseif(hmass.lt.90.0.and.hmass.ge.85.0) then
           cr=(cr_nwao90*(hmass-85.0)+cr_nwao85*(90.0-hmass))/5
           p1=x-cr+cr_nwao85
           p2=x-cr+cr_nwao90
          A189_HNN_MASS_SIG = mfunc_nwao85(p1)*(90.0-hmass)+
     &          mfunc_nwao90(p2)*(hmass-85.0)
        elseif(hmass.lt.95.0.and.hmass.ge.90.0) then
           cr=(cr_nwao95*(hmass-90.0)+cr_nwao90*(95.0-hmass))/5
           p1=x-cr+cr_nwao90
           p2=x-cr+cr_nwao95
          A189_HNN_MASS_SIG = mfunc_nwao90(p1)*(95.0-hmass)+
     &          mfunc_nwao95(p2)*(hmass-90.0)
        elseif(hmass.lt.97.5.and.hmass.ge.95) then
           cr=(cr_nwao975*(hmass-95.0)+cr_nwao95*(97.5-hmass))/2.5
           p1=x-cr+cr_nwao95
           p2=x-cr+cr_nwao975
          A189_HNN_MASS_SIG=mfunc_nwao95(p1)*(97.5-hmass)+
     &          mfunc_nwao975(p2)*(hmass-95.0)
        elseif(hmass.lt.100.0.and.hmass.ge.97.5) then
           cr=(cr_nwao100*(hmass-97.5)+cr_nwao975*(100.0-hmass))/2.5
           p1=x-cr+cr_nwao975
           p2=x-cr+cr_nwao100
        A189_HNN_MASS_SIG=mfunc_nwao975(p1)*(100.0-hmass)+
     &          mfunc_nwao100(p2)*(hmass-97.5)
        elseif(hmass.lt.105.0.and.hmass.ge.100.0) then
           cr=(cr_nwao105*(hmass-100.0)+cr_nwao100*(105.0-hmass))/5
           p1=x-cr+cr_nwao100
           p2=x-cr+cr_nwao105
        A189_HNN_MASS_SIG=mfunc_nwao100(p1)*(105.0-hmass)+
     &          mfunc_nwao105(p2)*(hmass-100.0)
        elseif(hmass.lt.110.0.and.hmass.ge.105.0) then
           cr=(cr_nwao110*(hmass-105.0)+cr_nwao105*(110.0-hmass))/5
           p1=x-cr+cr_nwao105
           p2=x-cr+cr_nwao110
        A189_HNN_MASS_SIG=mfunc_nwao105(p1)*(110.0-hmass)+
     &          mfunc_nwao110(p2)*(hmass-105.0)
        else 
           A189_HNN_MASS_SIG = mfunc_nwao110(x)
        endif
      else
          write(*,*) 'unknown Hvv sig, stop ', iana
          stop

      endif
      end
     

      DOUBLE PRECISION Function A189_HNN_MASS_BKG(x,iana,ibkg)
      Integer       iana,ibkg
      REAL*8 x

      REAL*8        mfunc_waozz,mfunc_waoqq,mfunc_waoww,
     &     mfunc_wanozz,mfunc_wanoqq,mfunc_wanoww,
     &     mfunc_nwaozz,mfunc_nwaoqq,mfunc_nwaoww 
      External       mfunc_waozz,mfunc_waoqq,mfunc_waoww,
     &     mfunc_wanozz,mfunc_wanoqq,mfunc_wanoww,
     &     mfunc_nwaozz,mfunc_nwaoqq,mfunc_nwaoww

      if (iana.eq.1) then
         if    ( ibkg.eq.1 ) then
            A189_HNN_MASS_BKG = mfunc_waoqq(x)
         elseif( ibkg.eq.2 ) then
            A189_HNN_MASS_BKG = mfunc_waoww(x)
         elseif( ibkg.eq.3 ) then
            A189_HNN_MASS_BKG = mfunc_waozz(x)
         endif
      elseif (iana.eq.2) then
         if    ( ibkg.eq.1 ) then
            A189_HNN_MASS_BKG = mfunc_wanoqq(x)
         elseif( ibkg.eq.2 ) then
            A189_HNN_MASS_BKG = mfunc_wanoww(x)
         elseif( ibkg.eq.3 ) then
            A189_HNN_MASS_BKG = mfunc_wanozz(x)
         endif
      elseif (iana.eq.3) then
         if    ( ibkg.eq.1 ) then
            A189_HNN_MASS_BKG = mfunc_nwaoqq(x)
         elseif( ibkg.eq.2 ) then
            A189_HNN_MASS_BKG = mfunc_nwaoww(x)
         elseif( ibkg.eq.3 ) then
            A189_HNN_MASS_BKG = mfunc_nwaozz(x)
         endif

      else
          write(*,*) 'unknown Hvv channel, stop ', iana
          stop
      endif
      end
     







      DOUBLE PRECISION FUNCTION mfunc_wao75(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  10, 1)
      DOUBLE PRECISION SIGDEL(  10)
      DOUBLE PRECISION SIGA(  10)
      DATA NPAR, NDIM, IMQFUN /   10,    1,    1/
      DATA VCONST / 0.0000000000000E+00/
      DATA SIGVMI /  50.00000000000    /
      DATA SIGVT /  50.00000000000    /
      DATA SIGV / 0.2833333611488    
     +, 0.3500000238419    
     +, 0.4833333492279    
     +, 0.5166667103767    
     +, 0.5500000119209    
     +, 0.9500000476837    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.1666666716337    
     +, 0.6333333849907    
     +/
      DATA SIGDEL / 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.1333333402872    
     +, 0.1333333402872    
     +/
      DATA SIGA / -122.5727072891    
     +,  476.4461639404    
     +,  6630.713337073    
     +, -14643.55853422    
     +,  7616.145345144    
     +,  104.1501329673    
     +, -12.53990591535    
     +, -31.66719398422    
     +,  32.10729108884    
     +, -52.56688184966    
     +/
      mfunc_wao75 = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         mfunc_wao75 = mfunc_wao75 + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) mfunc_wao75 = VCONST * EXP (mfunc_wao75)
      if (mfunc_wao75.le.0.0) mfunc_wao75 = 0.0001
      END

      DOUBLE PRECISION FUNCTION mfunc_wao80(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  10, 1)
      DOUBLE PRECISION SIGDEL(  10)
      DOUBLE PRECISION SIGA(  10)
      DATA NPAR, NDIM, IMQFUN /   10,    1,    1/
      DATA VCONST / 0.0000000000000E+00/
      DATA SIGVMI /  50.00000000000    /
      DATA SIGVT /  50.00000000000    /
      DATA SIGV / 0.4833333492279    
     +, 0.5166667103767    
     +, 0.5833333730698    
     +, 0.6166666746140    
     +, 0.9500000476837    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.3666666746140    
     +, 0.7000000476837    
     +, 0.7666667103767    
     +/
      DATA SIGDEL / 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.1333333402872    
     +, 0.1333333402872    
     +, 0.1333333402872    
     +/
      DATA SIGA / -719.6375102928    
     +,  2514.009171716    
     +, -605.6100391020    
     +, -4288.019022502    
     +,  241.2070423690    
     +, -72.00707001788    
     +, -170.2175168381    
     +, -112.7435205220    
     +,  5994.940149116    
     +, -2865.588893694    
     +/
      mfunc_wao80 = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         mfunc_wao80 = mfunc_wao80 + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) mfunc_wao80 = VCONST * EXP (mfunc_wao80)
      if (mfunc_wao80.le.0.0) mfunc_wao80 = 0.0001
      END



      DOUBLE PRECISION FUNCTION mfunc_wao85(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  18, 1)
      DOUBLE PRECISION SIGDEL(  18)
      DOUBLE PRECISION SIGA(  18)
      DATA NPAR, NDIM, IMQFUN /   18,    1,    1/
      DATA VCONST / 0.0000000000000E+00/
      DATA SIGVMI /  50.00000000000    /
      DATA SIGVT /  50.00000000000    /
      DATA SIGV / 0.2500000000000    
     +, 0.2833333611488    
     +, 0.3166666924953    
     +, 0.3500000238419    
     +, 0.4166666865349    
     +, 0.5166667103767    
     +, 0.5500000119209    
     +, 0.6166666746140    
     +, 0.6500000357628    
     +, 0.6833333969116    
     +, 0.7166666984558    
     +, 0.7833333611488    
     +, 0.8166667222977    
     +, 0.8833333849907    
     +, 0.9500000476837    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.1666666716337    
     +/
      DATA SIGDEL / 0.2000000141561E-01
     +, 0.2000000141561E-01
     +, 0.2000000141561E-01
     +, 0.2000000141561E-01
     +, 0.2000000141561E-01
     +, 0.2000000141561E-01
     +, 0.2000000141561E-01
     +, 0.2000000141561E-01
     +, 0.2000000141561E-01
     +, 0.2000000141561E-01
     +, 0.2000000141561E-01
     +, 0.2000000141561E-01
     +, 0.2000000141561E-01
     +, 0.2000000141561E-01
     +, 0.2000000141561E-01
     +, 0.6000000212225E-06
     +, 0.6000000212225E-06
     +, 0.4000000283122E-01
     +/
      DATA SIGA /  21.13031003820    
     +, -64.33325151080    
     +,  98.98075830802    
     +, -62.12546458884    
     +,  51.29584259629    
     +,  39.01879723833    
     +,  112.8680128268    
     +,  927.5572239174    
     +, -227.1343690961    
     +,  6.698282655284    
     +, -2129.947841746    
     +,  937.2350845073    
     +, -19.19327378565    
     +,  161.2750832547    
     +,  187.8438179979    
     +,-0.4626816734895E-01
     +, -42.43027970552    
     +,  1.553929465647    
     +/
      mfunc_wao85 = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         mfunc_wao85 = mfunc_wao85 + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) mfunc_wao85 = VCONST * EXP (mfunc_wao85)
      if (mfunc_wao85.le.0.0) mfunc_wao85 = 0.0001
      END


      DOUBLE PRECISION FUNCTION mfunc_wao90(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  12, 1)
      DOUBLE PRECISION SIGDEL(  12)
      DOUBLE PRECISION SIGA(  12)
      DATA NPAR, NDIM, IMQFUN /   12,    1,    1/
      DATA VCONST / 0.0000000000000E+00/
      DATA SIGVMI /  50.00000000000    /
      DATA SIGVT /  50.00000000000    /
      DATA SIGV / 0.3833333551884    
     +, 0.5833333730698    
     +, 0.6500000357628    
     +, 0.7166666984558    
     +, 0.7500000596046    
     +, 0.7833333611488    
     +, 0.8166667222977    
     +, 0.8500000238419    
     +, 0.9166666865349    
     +, 0.9500000476837    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +/
      DATA SIGDEL / 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +/
      DATA SIGA /  6.870957453457    
     +, -59.50466150465    
     +,  975.1268658620    
     +, -8345.015375179    
     +,  26496.29695866    
     +, -28310.52994846    
     +,  6468.367178615    
     +,  1914.904952820    
     +, -30.67545218226    
     +,  1393.020817120    
     +, -18.23799041972    
     +, -523.2787976866    
     +/
      mfunc_wao90 = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         mfunc_wao90 = mfunc_wao90 + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) mfunc_wao90 = VCONST * EXP (mfunc_wao90)
      if (mfunc_wao90.le.0.0) mfunc_wao90 = 0.0001
      END


      DOUBLE PRECISION FUNCTION mfunc_wao95(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  14, 1)
      DOUBLE PRECISION SIGDEL(  14)
      DOUBLE PRECISION SIGA(  14)
      DATA NPAR, NDIM, IMQFUN /   14,    1,    1/
      DATA VCONST / 0.0000000000000E+00/
      DATA SIGVMI /  50.00000000000    /
      DATA SIGVT /  50.00000000000    /
      DATA SIGV / 0.3500000238419    
     +, 0.3833333551884    
     +, 0.4166666865349    
     +, 0.4500000178814    
     +, 0.4833333492279    
     +, 0.7166666984558    
     +, 0.7833333611488    
     +, 0.8166667222977    
     +, 0.8500000238419    
     +, 0.8833333849907    
     +, 0.9166666865349    
     +, 0.9500000476837    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +/
      DATA SIGDEL / 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +/
      DATA SIGA / -81.56976292587    
     +,  154.0847968942    
     +, -134.7816827958    
     +,  63.89080563873    
     +, -2.337164078084    
     +, -142.1821911874    
     +,  2126.135110834    
     +, -9442.757069210    
     +,  25663.74487458    
     +, -11275.47091836    
     +, -47102.17012409    
     +,  49499.05835454    
     +, -275.6515954241    
     +, -9575.089191250    
     +/
      mfunc_wao95 = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         mfunc_wao95 = mfunc_wao95 + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) mfunc_wao95 = VCONST * EXP (mfunc_wao95)
      if (mfunc_wao95.le.0.0) mfunc_wao95 = 0.0001
      END

      DOUBLE PRECISION FUNCTION mfunc_wao975(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   9, 1)
      DOUBLE PRECISION SIGDEL(   9)
      DOUBLE PRECISION SIGA(   9)
      DATA NPAR, NDIM, IMQFUN /    9,    1,    1/
      DATA VCONST / 0.0000000000000E+00/
      DATA SIGVMI /  50.00000000000    /
      DATA SIGVT /  50.00000000000    /
      DATA SIGV / 0.6833333969116    
     +, 0.8500000238419    
     +, 0.8833333849907    
     +, 0.9166666865349    
     +, 0.9500000476837    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.3666666746140    
     +, 0.5666667222977    
     +/
      DATA SIGDEL / 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.1333333402872    
     +, 0.1333333402872    
     +/
      DATA SIGA /  201.6480258796    
     +, -9677.259121080    
     +,  54772.56140329    
     +, -108630.5429792    
     +,  75102.35772040    
     +, -358.2934066492    
     +, -12088.99647135    
     +, -13.88726824249    
     +,  9.921484683522    
     +/
      mfunc_wao975 = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         mfunc_wao975 = mfunc_wao975 + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) mfunc_wao975 = VCONST * EXP (mfunc_wao975)
      if (mfunc_wao975.le.0.0) mfunc_wao975 = 0.0001
      END

      DOUBLE PRECISION FUNCTION mfunc_wao100(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   8, 1)
      DOUBLE PRECISION SIGDEL(   8)
      DOUBLE PRECISION SIGA(   8)
      DATA NPAR, NDIM, IMQFUN /    8,    1,    1/
      DATA VCONST / 0.0000000000000E+00/
      DATA SIGVMI /  50.00000000000    /
      DATA SIGVT /  50.00000000000    /
      DATA SIGV / 0.4166666865349    
     +, 0.5166667103767    
     +, 0.8833333849907    
     +, 0.9166666865349    
     +, 0.9500000476837    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.6333333849907    
     +/
      DATA SIGDEL / 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.1333333402872    
     +/
      DATA SIGA / -43.22715705978    
     +,  111.4779474545    
     +,  12519.51451224    
     +, -40900.24170337    
     +,  34244.29944405    
     +, -188.0250293092    
     +, -6254.755402296    
     +,  160.9403533110    
     +/
      mfunc_wao100 = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         mfunc_wao100 = mfunc_wao100 + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) mfunc_wao100 = VCONST * EXP (mfunc_wao100)
       if (mfunc_wao100.le.0.0) mfunc_wao100 = 0.0001
      END

      DOUBLE PRECISION FUNCTION mfunc_wao105(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   9, 1)
      DOUBLE PRECISION SIGDEL(   9)
      DOUBLE PRECISION SIGA(   9)
      DATA NPAR, NDIM, IMQFUN /    9,    1,    1/
      DATA VCONST / 0.0000000000000E+00/
      DATA SIGVMI /  50.00000000000    /
      DATA SIGVT /  50.00000000000    /
      DATA SIGV / 0.4166666865349    
     +, 0.4500000178814    
     +, 0.7833333611488    
     +, 0.8833333849907    
     +, 0.9166666865349    
     +, 0.9500000476837    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.5666667222977    
     +/
      DATA SIGDEL / 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.1333333402872    
     +/
      DATA SIGA / -119.8552608868    
     +,  101.9731635819    
     +,  246.8763991235    
     +,  6038.684626655    
     +, -25814.57036434    
     +,  23797.28883974    
     +, -142.5496565957    
     +, -4626.101843486    
     +,  258.5681257009    
     +/
      mfunc_wao105 = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         mfunc_wao105 = mfunc_wao105 + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) mfunc_wao105 = VCONST * EXP (mfunc_wao105)
      if (mfunc_wao105.le.0.0) mfunc_wao105 = 0.0001
      END

      DOUBLE PRECISION FUNCTION mfunc_wao110(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   8, 1)
      DOUBLE PRECISION SIGDEL(   8)
      DOUBLE PRECISION SIGA(   8)
      DATA NPAR, NDIM, IMQFUN /    8,    1,    1/
      DATA VCONST / 0.0000000000000E+00/
      DATA SIGVMI /  50.00000000000    /
      DATA SIGVT /  50.00000000000    /
      DATA SIGV / 0.6500000357628    
     +, 0.8166667222977    
     +, 0.8833333849907    
     +, 0.9166666865349    
     +, 0.9500000476837    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.5000000000000    
     +/
      DATA SIGDEL / 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.1333333402872    
     +/
      DATA SIGA /  445.4522749040    
     +,  214.6165947157    
     +,  2263.266092427    
     +, -17563.88529258    
     +,  18269.36609562    
     +, -109.3454986524    
     +, -3729.366174094    
     +,  3.862932543882    
     +/
      mfunc_wao110 = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         mfunc_wao110 = mfunc_wao110 + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) mfunc_wao110 = VCONST * EXP (mfunc_wao110)
      if (mfunc_wao110.le.0.0) mfunc_wao110 = 0.0001
      END


      DOUBLE PRECISION FUNCTION mfunc_waoqq(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   5, 1)
      DOUBLE PRECISION SIGDEL(   5)
      DOUBLE PRECISION SIGA(   5)
      DATA NPAR, NDIM, IMQFUN /    5,    1,    2/
      DATA VCONST /  1.666666626930    /
      DATA SIGVMI /  50.00000000000    /
      DATA SIGVT /  50.00000000000    /
      DATA SIGV / 0.9166666865349    
     +, 0.9500000476837    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.8333333730698    
     +/
      DATA SIGDEL / 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.1333333402872    
     +/
      DATA SIGA /  267.3383429755    
     +, -533.3890551074    
     +,  3.872226138019    
     +,  244.9908766588    
     +,  3.120282897290    
     +/
      mfunc_waoqq = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         mfunc_waoqq = mfunc_waoqq + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) mfunc_waoqq = VCONST * EXP (mfunc_waoqq)
      if (mfunc_waoqq.le.0.0) mfunc_waoqq = 0.0001
      END

      DOUBLE PRECISION FUNCTION mfunc_waoww(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   6, 1)
      DOUBLE PRECISION SIGDEL(   6)
      DOUBLE PRECISION SIGA(   6)
      DATA NPAR, NDIM, IMQFUN /    6,    1,    1/
      DATA VCONST /  1.666666626930    /
      DATA SIGVMI /  50.00000000000    /
      DATA SIGVT /  50.00000000000    /
      DATA SIGV / 0.7166666984558    
     +, 0.7833333611488    
     +, 0.8166667222977    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.5666667222977    
     +/
      DATA SIGDEL / 0.2000000141561E-01
     +, 0.2000000141561E-01
     +, 0.2000000141561E-01
     +, 0.6000000212225E-06
     +, 0.6000000212225E-06
     +, 0.4000000283122E-01
     +/
      DATA SIGA / 0.3912228580580E-01
     +, 0.3969095089106    
     +,-0.5774376313511    
     +,-0.2466120524133E-02
     +, 0.1279650010010    
     +, 0.7223428648511E-02
     +/
      mfunc_waoww = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         mfunc_waoww = mfunc_waoww + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) mfunc_waoww = VCONST * EXP (mfunc_waoww)
      if (mfunc_waoww.le.0.0) mfunc_waoww = 0.0001
      END


      DOUBLE PRECISION FUNCTION mfunc_waozz(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  11, 1)
      DOUBLE PRECISION SIGDEL(  11)
      DOUBLE PRECISION SIGA(  11)
      DATA NPAR, NDIM, IMQFUN /   11,    1,    1/
      DATA VCONST /  1.666666626930    /
      DATA SIGVMI /  50.00000000000    /
      DATA SIGVT /  50.00000000000    /
      DATA SIGV / 0.5500000119209    
     +, 0.5833333730698    
     +, 0.6166666746140    
     +, 0.8166667222977    
     +, 0.8833333849907    
     +, 0.9166666865349    
     +, 0.9500000476837    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.3000000119209    
     +, 0.7000000476837    
     +/
      DATA SIGDEL / 0.2000000178814    
     +, 0.2000000178814    
     +, 0.2000000178814    
     +, 0.2000000178814    
     +, 0.2000000178814    
     +, 0.2000000178814    
     +, 0.2000000178814    
     +, 0.6000000212225E-05
     +, 0.6000000212225E-05
     +, 0.4000000357628    
     +, 0.4000000357628    
     +/
      DATA SIGA / -103.9523614511    
     +,  232.7156677497    
     +, -174.9291229872    
     +,  326.1779553164    
     +, -1479.741543321    
     +,  1701.317808699    
     +, -537.2578818949    
     +, -8.849777845037    
     +, -25.95866619836    
     +, -10.68571623494    
     +,  66.14588853090    
     +/
      mfunc_waozz = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         mfunc_waozz = mfunc_waozz + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) mfunc_waozz = VCONST * EXP (mfunc_waozz)
      if (mfunc_waozz.le.0.0) mfunc_waozz = 0.0001
      END

      DOUBLE PRECISION FUNCTION mfunc_wano75(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  13, 1)
      DOUBLE PRECISION SIGDEL(  13)
      DOUBLE PRECISION SIGA(  13)
      DATA NPAR, NDIM, IMQFUN /   13,    1,    1/
      DATA VCONST / 0.0000000000000E+00/
      DATA SIGVMI /  50.00000000000    /
      DATA SIGVT /  50.00000000000    /
      DATA SIGV / 0.4166666865349    
     +, 0.4833333492279    
     +, 0.6833333969116    
     +, 0.7166666984558    
     +, 0.7500000596046    
     +, 0.7833333611488    
     +, 0.8166667222977    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.1666666716337    
     +, 0.2333333492279    
     +, 0.5666667222977    
     +, 0.9000000357628    
     +/
      DATA SIGDEL / 0.2000000141561E-01
     +, 0.2000000141561E-01
     +, 0.2000000141561E-01
     +, 0.2000000141561E-01
     +, 0.2000000141561E-01
     +, 0.2000000141561E-01
     +, 0.2000000141561E-01
     +, 0.6000000212225E-06
     +, 0.6000000212225E-06
     +, 0.4000000283122E-01
     +, 0.4000000283122E-01
     +, 0.4000000283122E-01
     +, 0.4000000283122E-01
     +/
      DATA SIGA /  763.2220543375    
     +, -2068.536578981    
     +,  542.6536861894    
     +, -995.7321622765    
     +,  696.2759368821    
     +,  55.10708028641    
     +, -243.9420793309    
     +, -5.177121131154    
     +, -13.34447377853    
     +,  52.04369144474    
     +,  156.1390177980    
     +,  981.3539193978    
     +,  76.45809005647    
     +/
      mfunc_wano75 = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         mfunc_wano75 = mfunc_wano75 + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) mfunc_wano75 = VCONST * EXP (mfunc_wano75)
      if (mfunc_wano75.le.0.0001) mfunc_wano75 = 0.0001
      END


      DOUBLE PRECISION FUNCTION mfunc_wano80(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  15, 1)
      DOUBLE PRECISION SIGDEL(  15)
      DOUBLE PRECISION SIGA(  15)
      DATA NPAR, NDIM, IMQFUN /   15,    1,    1/
      DATA VCONST / 0.0000000000000E+00/
      DATA SIGVMI /  50.00000000000    /
      DATA SIGVT /  50.00000000000    /
      DATA SIGV / 0.1833333373070    
     +, 0.2500000000000    
     +, 0.2833333611488    
     +, 0.3500000238419    
     +, 0.3833333551884    
     +, 0.4166666865349    
     +, 0.5833333730698    
     +, 0.6500000357628    
     +, 0.6833333969116    
     +, 0.7166666984558    
     +, 0.7500000596046    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.5000000000000    
     +, 0.8333333730698    
     +/
      DATA SIGDEL / 0.2000000178814    
     +, 0.2000000178814    
     +, 0.2000000178814    
     +, 0.2000000178814    
     +, 0.2000000178814    
     +, 0.2000000178814    
     +, 0.2000000178814    
     +, 0.2000000178814    
     +, 0.2000000178814    
     +, 0.2000000178814    
     +, 0.2000000178814    
     +, 0.6000000212225E-05
     +, 0.6000000212225E-05
     +, 0.4000000357628    
     +, 0.4000000357628    
     +/
      DATA SIGA / -24882.67785731    
     +,  222611.2151854    
     +, -411324.6282762    
     +,  798080.8922983    
     +, -976034.6498947    
     +,  399608.1481546    
     +,  49260.42172430    
     +, -707089.3782040    
     +,  1383500.948459    
     +, -1037772.560669    
     +,  294849.4786659    
     +, -1173.477996674    
     +,  1354.809969320    
     +,  23542.90838337    
     +, -15106.11198070    
     +/
      mfunc_wano80 = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         mfunc_wano80 = mfunc_wano80 + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) mfunc_wano80 = VCONST * EXP (mfunc_wano80)
      if (mfunc_wano80.le.0.0001) mfunc_wano80 = 0.0001
      END


      DOUBLE PRECISION FUNCTION mfunc_wano85(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  11, 1)
      DOUBLE PRECISION SIGDEL(  11)
      DOUBLE PRECISION SIGA(  11)
      DATA NPAR, NDIM, IMQFUN /   11,    1,    1/
      DATA VCONST / 0.0000000000000E+00/
      DATA SIGVMI /  50.00000000000    /
      DATA SIGVT /  50.00000000000    /
      DATA SIGV / 0.3833333551884    
     +, 0.4833333492279    
     +, 0.5500000119209    
     +, 0.6833333969116    
     +, 0.7833333611488    
     +, 0.8500000238419    
     +, 0.8833333849907    
     +, 0.9166666865349    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.3000000119209    
     +/
      DATA SIGDEL / 0.1333333402872    
     +, 0.1333333402872    
     +, 0.1333333402872    
     +, 0.1333333402872    
     +, 0.1333333402872    
     +, 0.1333333402872    
     +, 0.1333333402872    
     +, 0.1333333402872    
     +, 0.3999999989901E-05
     +, 0.3999999989901E-05
     +, 0.2666666805744    
     +/
      DATA SIGA /  1089.449891071    
     +, -5173.563465089    
     +,  8947.446694256    
     +, -12478.76737311    
     +,  17052.83656857    
     +, -20917.69401698    
     +,  14259.81822673    
     +, -2451.377105790    
     +,  20.23620779710    
     +, -171.6893892568    
     +, -184.0658223548    
     +/
      mfunc_wano85 = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         mfunc_wano85 = mfunc_wano85 + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) mfunc_wano85 = VCONST * EXP (mfunc_wano85)
      if (mfunc_wano85.le.0.0001) mfunc_wano85 = 0.0001
      END


      DOUBLE PRECISION FUNCTION mfunc_wano90(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  13, 1)
      DOUBLE PRECISION SIGDEL(  13)
      DOUBLE PRECISION SIGA(  13)
      DATA NPAR, NDIM, IMQFUN /   13,    1,    1/
      DATA VCONST / 0.0000000000000E+00/
      DATA SIGVMI /  50.00000000000    /
      DATA SIGVT /  50.00000000000    /
      DATA SIGV / 0.2833333611488    
     +, 0.3500000238419    
     +, 0.5166667103767    
     +, 0.5500000119209    
     +, 0.6500000357628    
     +, 0.7500000596046    
     +, 0.7833333611488    
     +, 0.8833333849907    
     +, 0.9500000476837    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.1666666716337    
     +, 0.4333333671093    
     +/
      DATA SIGDEL / 0.2000000141561E-01
     +, 0.2000000141561E-01
     +, 0.2000000141561E-01
     +, 0.2000000141561E-01
     +, 0.2000000141561E-01
     +, 0.2000000141561E-01
     +, 0.2000000141561E-01
     +, 0.2000000141561E-01
     +, 0.2000000141561E-01
     +, 0.6000000212225E-06
     +, 0.6000000212225E-06
     +, 0.4000000283122E-01
     +, 0.4000000283122E-01
     +/
      DATA SIGA / -26.35531733037    
     +,  196.9999240306    
     +,  179.9935178918    
     +, -8.984141762967    
     +,  226.8126456571    
     +,  438.3941291190    
     +, -1590.121420919    
     +,  730.3627057028    
     +, -57.57828333505    
     +,-0.6686639467056    
     +,  126.9799985525    
     +,  8.101518034672    
     +, -228.0330319345    
     +/
      mfunc_wano90 = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         mfunc_wano90 = mfunc_wano90 + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) mfunc_wano90 = VCONST * EXP (mfunc_wano90)
      if (mfunc_wano90.le.0.0001) mfunc_wano90 = 0.0001
      END


      DOUBLE PRECISION FUNCTION mfunc_wano95(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  10, 1)
      DOUBLE PRECISION SIGDEL(  10)
      DOUBLE PRECISION SIGA(  10)
      DATA NPAR, NDIM, IMQFUN /   10,    1,    1/
      DATA VCONST / 0.0000000000000E+00/
      DATA SIGVMI /  50.00000000000    /
      DATA SIGVT /  50.00000000000    /
      DATA SIGV / 0.2500000000000    
     +, 0.3833333551884    
     +, 0.4166666865349    
     +, 0.6833333969116    
     +, 0.7833333611488    
     +, 0.8166667222977    
     +, 0.8833333849907    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.5000000000000    
     +/
      DATA SIGDEL / 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.1333333402872    
     +/
      DATA SIGA /  86.23456605403    
     +, -609.5832180729    
     +,  1257.899675174    
     +,  88.88817437298    
     +, -1156.111436172    
     +,  3322.583170353    
     +, -3276.934747661    
     +,  25.43613495415    
     +,  1170.405032150    
     +, -885.4009651456    
     +/
      mfunc_wano95 = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         mfunc_wano95 = mfunc_wano95 + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) mfunc_wano95 = VCONST * EXP (mfunc_wano95)
      if (mfunc_wano95.le.0.0001) mfunc_wano95 = 0.0001
      END


      DOUBLE PRECISION FUNCTION mfunc_wano975(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  13, 1)
      DOUBLE PRECISION SIGDEL(  13)
      DOUBLE PRECISION SIGA(  13)
      DATA NPAR, NDIM, IMQFUN /   13,    1,    1/
      DATA VCONST / 0.0000000000000E+00/
      DATA SIGVMI /  50.00000000000    /
      DATA SIGVT /  50.00000000000    /
      DATA SIGV / 0.2166666835546    
     +, 0.2500000000000    
     +, 0.5500000119209    
     +, 0.5833333730698    
     +, 0.6500000357628    
     +, 0.6833333969116    
     +, 0.7166666984558    
     +, 0.8833333849907    
     +, 0.9166666865349    
     +, 0.9500000476837    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.3666666746140    
     +/
      DATA SIGDEL / 0.2000000178814    
     +, 0.2000000178814    
     +, 0.2000000178814    
     +, 0.2000000178814    
     +, 0.2000000178814    
     +, 0.2000000178814    
     +, 0.2000000178814    
     +, 0.2000000178814    
     +, 0.2000000178814    
     +, 0.2000000178814    
     +, 0.6000000212225E-05
     +, 0.6000000212225E-05
     +, 0.4000000357628    
     +/
      DATA SIGA / -418.8446088286    
     +,  401.1028754451    
     +, -7237.219887407    
     +,  37316.15176812    
     +, -208518.3492907    
     +,  351467.1940945    
     +, -189240.9286144    
     +, -6218.976386832    
     +,  160681.4501450    
     +, -154908.4438164    
     +,  2501.370273996    
     +,  18584.03037892    
     +,  493.4666831867    
     +/
      mfunc_wano975 = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         mfunc_wano975 = mfunc_wano975 + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) mfunc_wano975 = VCONST * EXP (mfunc_wano975)
      if (mfunc_wano975.le.0.0001) mfunc_wano975 = 0.0001
      END


      DOUBLE PRECISION FUNCTION mfunc_wano100(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  13, 1)
      DOUBLE PRECISION SIGDEL(  13)
      DOUBLE PRECISION SIGA(  13)
      DATA NPAR, NDIM, IMQFUN /   13,    1,    1/
      DATA VCONST / 0.0000000000000E+00/
      DATA SIGVMI /  50.00000000000    /
      DATA SIGVT /  50.00000000000    /
      DATA SIGV / 0.1833333373070    
     +, 0.2833333611488    
     +, 0.4166666865349    
     +, 0.4500000178814    
     +, 0.5833333730698    
     +, 0.6166666746140    
     +, 0.8500000238419    
     +, 0.8833333849907    
     +, 0.9166666865349    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.7000000476837    
     +, 0.7666667103767    
     +/
      DATA SIGDEL / 0.1333333402872    
     +, 0.1333333402872    
     +, 0.1333333402872    
     +, 0.1333333402872    
     +, 0.1333333402872    
     +, 0.1333333402872    
     +, 0.1333333402872    
     +, 0.1333333402872    
     +, 0.1333333402872    
     +, 0.3999999989901E-05
     +, 0.3999999989901E-05
     +, 0.2666666805744    
     +, 0.2666666805744    
     +/
      DATA SIGA /  89.58206649439    
     +, -148.9041014086    
     +,  2494.104845133    
     +, -2201.071733324    
     +,  5994.845421809    
     +, -3818.088552915    
     +, -29331.04484685    
     +,  55341.29381627    
     +, -35888.10937441    
     +, -371.9368762630    
     +,  957.7315100677    
     +, -29842.96487513    
     +,  36007.53917355    
     +/
      mfunc_wano100 = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         mfunc_wano100 = mfunc_wano100 + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) mfunc_wano100 = VCONST * EXP (mfunc_wano100)
      if (mfunc_wano100.le.0.0001) mfunc_wano100 = 0.0001
      END


      DOUBLE PRECISION FUNCTION mfunc_wano105(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  10, 1)
      DOUBLE PRECISION SIGDEL(  10)
      DOUBLE PRECISION SIGA(  10)
      DATA NPAR, NDIM, IMQFUN /   10,    1,    1/
      DATA VCONST / 0.0000000000000E+00/
      DATA SIGVMI /  50.00000000000    /
      DATA SIGVT /  50.00000000000    /
      DATA SIGV / 0.3166666924953    
     +, 0.3833333551884    
     +, 0.4833333492279    
     +, 0.5833333730698    
     +, 0.9166666865349    
     +, 0.9500000476837    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.7000000476837    
     +, 0.8333333730698    
     +/
      DATA SIGDEL / 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.1333333402872    
     +, 0.1333333402872    
     +/
      DATA SIGA /  17.00790449773    
     +,  40.63714854810    
     +,  261.3141525060    
     +,  781.8742629007    
     +, -2744.433861459    
     +,  2153.576659313    
     +, -18.25265687639    
     +, -384.3429836062    
     +, -2930.944391158    
     +,  2768.090872505    
     +/
      mfunc_wano105 = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         mfunc_wano105 = mfunc_wano105 + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) mfunc_wano105 = VCONST * EXP (mfunc_wano105)
      if (mfunc_wano105.le.0.0001) mfunc_wano105 = 0.0001
      END


      DOUBLE PRECISION FUNCTION mfunc_wano110(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  12, 1)
      DOUBLE PRECISION SIGDEL(  12)
      DOUBLE PRECISION SIGA(  12)
      DATA NPAR, NDIM, IMQFUN /   12,    1,    1/
      DATA VCONST / 0.0000000000000E+00/
      DATA SIGVMI /  50.00000000000    /
      DATA SIGVT /  50.00000000000    /
      DATA SIGV / 0.3166666924953    
     +, 0.4833333492279    
     +, 0.5166667103767    
     +, 0.5500000119209    
     +, 0.7166666984558    
     +, 0.7500000596046    
     +, 0.9166666865349    
     +, 0.9500000476837    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.6333333849907    
     +, 0.8333333730698    
     +/
      DATA SIGDEL / 0.7333333790302E-01
     +, 0.7333333790302E-01
     +, 0.7333333790302E-01
     +, 0.7333333790302E-01
     +, 0.7333333790302E-01
     +, 0.7333333790302E-01
     +, 0.7333333790302E-01
     +, 0.7333333790302E-01
     +, 0.2200000153607E-05
     +, 0.2200000153607E-05
     +, 0.1466666758060    
     +, 0.1466666758060    
     +/
      DATA SIGA /  103.8079397825    
     +,  1404.716090854    
     +, -3116.250819835    
     +,  4326.059245924    
     +,  7446.132493405    
     +, -10997.56849819    
     +, -14030.90685313    
     +,  10572.95951385    
     +, -319.7030222574    
     +, -3167.997784669    
     +, -6930.840036066    
     +,  14100.11901924    
     +/
      mfunc_wano110 = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         mfunc_wano110 = mfunc_wano110 + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) mfunc_wano110 = VCONST * EXP (mfunc_wano110)
      if (mfunc_wano110.le.0.0001) mfunc_wano110 = 0.0001
      END


      DOUBLE PRECISION FUNCTION mfunc_wanoww(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  11, 1)
      DOUBLE PRECISION SIGDEL(  11)
      DOUBLE PRECISION SIGA(  11)
      DATA NPAR, NDIM, IMQFUN /   11,    1,    1/
      DATA VCONST /  1.666666626930    /
      DATA SIGVMI /  50.00000000000    /
      DATA SIGVT /  50.00000000000    /
      DATA SIGV / 0.3000000119209    
     +, 0.3666666746140    
     +, 0.4333333671093    
     +, 0.5000000000000    
     +, 0.5666667222977    
     +, 0.6333333849907    
     +, 0.7666667103767    
     +, 0.8333333730698    
     +, 0.9000000357628    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +/
      DATA SIGDEL / 0.2666666805744    
     +, 0.2666666805744    
     +, 0.2666666805744    
     +, 0.2666666805744    
     +, 0.2666666805744    
     +, 0.2666666805744    
     +, 0.2666666805744    
     +, 0.2666666805744    
     +, 0.2666666805744    
     +, 0.3999999989901E-05
     +, 0.3999999989901E-05
     +/
      DATA SIGA /  1.004621989431    
     +, -6.964957419795    
     +,  27.26814329444    
     +, -73.42310165818    
     +,  126.4171956049    
     +, -113.2308204012    
     +,  112.6532615409    
     +, -107.5039490256    
     +,  33.07979728173    
     +, 0.2128349956653E-02
     +, 0.6926636108292    
     +/
      mfunc_wanoww = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         mfunc_wanoww = mfunc_wanoww + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) mfunc_wanoww = VCONST * EXP (mfunc_wanoww)
      if (mfunc_wanoww.le.0.0001) mfunc_wanoww = 0.0001
      END


      DOUBLE PRECISION FUNCTION mfunc_wanoqq(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   7, 1)
      DOUBLE PRECISION SIGDEL(   7)
      DOUBLE PRECISION SIGA(   7)
      DATA NPAR, NDIM, IMQFUN /    7,    1,    2/
      DATA VCONST /  1.666666626930    /
      DATA SIGVMI /  50.00000000000    /
      DATA SIGVT /  50.00000000000    /
      DATA SIGV / 0.8500000238419    
     +, 0.8833333849907    
     +, 0.9500000476837    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.5000000000000    
     +, 0.7666667103767    
     +/
      DATA SIGDEL / 0.2000000178814    
     +, 0.2000000178814    
     +, 0.2000000178814    
     +, 0.6000000212225E-05
     +, 0.6000000212225E-05
     +, 0.4000000357628    
     +, 0.4000000357628    
     +/
      DATA SIGA / -7228.228596486    
     +,  11182.30506450    
     +, -5657.975192542    
     +,  72.38259980760    
     +,  530.3090299427    
     +, -929.0580519806    
     +,  1945.120692820    
     +/
      mfunc_wanoqq = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         mfunc_wanoqq = mfunc_wanoqq + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) mfunc_wanoqq = VCONST * EXP (mfunc_wanoqq)
      if (mfunc_wanoqq.le.0.0001) mfunc_wanoqq = 0.0001
      END


      DOUBLE PRECISION FUNCTION mfunc_wanozz(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   5, 1)
      DOUBLE PRECISION SIGDEL(   5)
      DOUBLE PRECISION SIGA(   5)
      DATA NPAR, NDIM, IMQFUN /    5,    1,    1/
      DATA VCONST /  1.666666626930    /
      DATA SIGVMI /  50.00000000000    /
      DATA SIGVT /  50.00000000000    /
      DATA SIGV / 0.3666666746140    
     +, 0.4333333671093    
     +, 0.9000000357628    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +/
      DATA SIGDEL / 0.2666666805744    
     +, 0.2666666805744    
     +, 0.2666666805744    
     +, 0.3999999989901E-05
     +, 0.3999999989901E-05
     +/
      DATA SIGA /-0.8610799876840    
     +,  1.304488850808    
     +, -1.340872570433    
     +, 0.1286387931148    
     +, 0.9850444289148    
     +/
      mfunc_wanozz = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         mfunc_wanozz = mfunc_wanozz + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) mfunc_wanozz = VCONST * EXP (mfunc_wanozz)
      if (mfunc_wanozz.le.0.0001) mfunc_wanozz = 0.0001
      END


      DOUBLE PRECISION FUNCTION mfunc_nwaoqq(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   8, 1)
      DOUBLE PRECISION SIGDEL(   8)
      DOUBLE PRECISION SIGA(   8)
      DATA NPAR, NDIM, IMQFUN /    8,    1,    2/
      DATA VCONST /  1.666666626930    /
      DATA SIGVMI /  50.00000000000    /
      DATA SIGVT /  50.00000000000    /
      DATA SIGV / 0.5500000119209    
     +, 0.6166666746140    
     +, 0.6500000357628    
     +, 0.6833333969116    
     +, 0.9166666865349    
     +, 0.9500000476837    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +/
      DATA SIGDEL / 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +/
      DATA SIGA / -12.59963091274    
     +,  46.25235261713    
     +, -37.30789121774    
     +,  9.357676536405    
     +,  232.6076603083    
     +, -502.8050719196    
     +,  2.919560729247    
     +,  255.6286222788    
     +/
      mfunc_nwaoqq = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         mfunc_nwaoqq = mfunc_nwaoqq + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) mfunc_nwaoqq = VCONST * EXP (mfunc_nwaoqq)
      if (mfunc_nwaoqq.le.0.0) mfunc_nwaoqq = 0.001
      END


      DOUBLE PRECISION FUNCTION mfunc_nwaoww(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  11, 1)
      DOUBLE PRECISION SIGDEL(  11)
      DOUBLE PRECISION SIGA(  11)
      DATA NPAR, NDIM, IMQFUN /   11,    1,    1/
      DATA VCONST / 0.0000000000000E+00/
      DATA SIGVMI /  50.00000000000    /
      DATA SIGVT /  50.00000000000    /
      DATA SIGV / 0.3500000238419    
     +, 0.6166666746140    
     +, 0.6500000357628    
     +, 0.6833333969116    
     +, 0.7166666984558    
     +, 0.7500000596046    
     +, 0.7833333611488    
     +, 0.8500000238419    
     +, 0.9500000476837    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +/
      DATA SIGDEL / 0.2000000178814    
     +, 0.2000000178814    
     +, 0.2000000178814    
     +, 0.2000000178814    
     +, 0.2000000178814    
     +, 0.2000000178814    
     +, 0.2000000178814    
     +, 0.2000000178814    
     +, 0.2000000178814    
     +, 0.6000000212225E-05
     +, 0.6000000212225E-05
     +/
      DATA SIGA /-0.1120427802334E-01
     +,  26.20054372030    
     +, -200.7953871956    
     +,  660.3987867265    
     +, -1190.952531877    
     +,  1204.691483169    
     +, -572.8951879766    
     +,  77.11009927438    
     +, -2.949675858268    
     +,-0.1145098448305    
     +,-0.8985290722612    
     +/
      mfunc_nwaoww = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         mfunc_nwaoww = mfunc_nwaoww + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) mfunc_nwaoww = VCONST * EXP (mfunc_nwaoww)
      if (mfunc_nwaoww.le.0.0) mfunc_nwaoww = 0.001
      END


      DOUBLE PRECISION FUNCTION mfunc_nwaozz(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   6, 1)
      DOUBLE PRECISION SIGDEL(   6)
      DOUBLE PRECISION SIGA(   6)
      DATA NPAR, NDIM, IMQFUN /    6,    1,    1/
      DATA VCONST /  1.666666626930    /
      DATA SIGVMI /  50.00000000000    /
      DATA SIGVT /  50.00000000000    /
      DATA SIGV / 0.7833333611488    
     +, 0.8500000238419    
     +, 0.9500000476837    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.7000000476837    
     +/
      DATA SIGDEL / 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.1333333402872    
     +/
      DATA SIGA /  2.467821805642    
     +, -6.826344691141    
     +,  5.588496076638    
     +,-0.6955275758205E-01
     +, -1.849988431403    
     +, 0.5753735125623    
     +/
      mfunc_nwaozz = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         mfunc_nwaozz = mfunc_nwaozz + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) mfunc_nwaozz = VCONST * EXP (mfunc_nwaozz)
      if (mfunc_nwaozz.le.0.0) mfunc_nwaozz = 0.001
      END


      DOUBLE PRECISION FUNCTION mfunc_nwao75(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  16, 1)
      DOUBLE PRECISION SIGDEL(  16)
      DOUBLE PRECISION SIGA(  16)
      DATA NPAR, NDIM, IMQFUN /   16,    1,    1/
      DATA VCONST / 0.0000000000000E+00/
      DATA SIGVMI /  50.00000000000    /
      DATA SIGVT /  50.00000000000    /
      DATA SIGV / 0.1833333373070    
     +, 0.2166666835546    
     +, 0.2500000000000    
     +, 0.3833333551884    
     +, 0.4166666865349    
     +, 0.5166667103767    
     +, 0.5500000119209    
     +, 0.6500000357628    
     +, 0.7500000596046    
     +, 0.8500000238419    
     +, 0.8833333849907    
     +, 0.9166666865349    
     +, 0.9500000476837    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.1000000089407    
     +/
      DATA SIGDEL / 0.2000000141561E-01
     +, 0.2000000141561E-01
     +, 0.2000000141561E-01
     +, 0.2000000141561E-01
     +, 0.2000000141561E-01
     +, 0.2000000141561E-01
     +, 0.2000000141561E-01
     +, 0.2000000141561E-01
     +, 0.2000000141561E-01
     +, 0.2000000141561E-01
     +, 0.2000000141561E-01
     +, 0.2000000141561E-01
     +, 0.2000000141561E-01
     +, 0.6000000212225E-06
     +, 0.6000000212225E-06
     +, 0.4000000283122E-01
     +/
      DATA SIGA /  16.01255294291    
     +,  113.4307131092    
     +, -110.8653296100    
     +,  401.5902412388    
     +,  236.8555858279    
     +, -1708.501838295    
     +,  767.8006878892    
     +,  188.8288136892    
     +, -57.63899872402    
     +,  50.14847809013    
     +,  225.7637129017    
     +, -245.0824232559    
     +,  142.3168903519    
     +,-0.6288769600360    
     +, -24.67367608234    
     +,  4.877316976819    
     +/
      mfunc_nwao75 = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         mfunc_nwao75 = mfunc_nwao75 + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) mfunc_nwao75 = VCONST * EXP (mfunc_nwao75)
      if (mfunc_nwao75.le.0.0) mfunc_nwao75 = 0.001
      END




      DOUBLE PRECISION FUNCTION mfunc_nwao80(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  14, 1)
      DOUBLE PRECISION SIGDEL(  14)
      DOUBLE PRECISION SIGA(  14)
      DATA NPAR, NDIM, IMQFUN /   14,    1,    1/
      DATA VCONST / 0.0000000000000E+00/
      DATA SIGVMI /  50.00000000000    /
      DATA SIGVT /  50.00000000000    /
      DATA SIGV / 0.1166666746140    
     +, 0.1833333373070    
     +, 0.2500000000000    
     +, 0.3166666924953    
     +, 0.4500000178814    
     +, 0.4833333492279    
     +, 0.5833333730698    
     +, 0.6166666746140    
     +, 0.6833333969116    
     +, 0.7166666984558    
     +, 0.8166667222977    
     +, 0.9500000476837    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +/
      DATA SIGDEL / 0.4666666686535E-01
     +, 0.4666666686535E-01
     +, 0.4666666686535E-01
     +, 0.4666666686535E-01
     +, 0.4666666686535E-01
     +, 0.4666666686535E-01
     +, 0.4666666686535E-01
     +, 0.4666666686535E-01
     +, 0.4666666686535E-01
     +, 0.4666666686535E-01
     +, 0.4666666686535E-01
     +, 0.4666666686535E-01
     +, 0.1399999973728E-05
     +, 0.1399999973728E-05
     +/
      DATA SIGA /  1.099530071119    
     +,  53.19004348316    
     +, -115.9899660675    
     +,  138.5033207875    
     +, -250.7027614447    
     +,  775.4861406608    
     +,  1052.143405503    
     +, -2587.844403055    
     +,  111.6225050724    
     +,  634.1989523223    
     +,  92.82039187359    
     +,  150.8745785871    
     +, -2.722916475602    
     +, -54.79237305459    
     +/
      mfunc_nwao80 = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         mfunc_nwao80 = mfunc_nwao80 + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) mfunc_nwao80 = VCONST * EXP (mfunc_nwao80)
      if (mfunc_nwao80.le.0.0) mfunc_nwao80 = 0.001
      END

      DOUBLE PRECISION FUNCTION mfunc_nwao85(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  12, 1)
      DOUBLE PRECISION SIGDEL(  12)
      DOUBLE PRECISION SIGA(  12)
      DATA NPAR, NDIM, IMQFUN /   12,    1,    1/
      DATA VCONST / 0.0000000000000E+00/
      DATA SIGVMI /  50.00000000000    /
      DATA SIGVT /  50.00000000000    /
      DATA SIGV / 0.4500000178814    
     +, 0.5833333730698    
     +, 0.6166666746140    
     +, 0.6833333969116    
     +, 0.7166666984558    
     +, 0.8166667222977    
     +, 0.8500000238419    
     +, 0.8833333849907    
     +, 0.9500000476837    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.3000000119209    
     +/
      DATA SIGDEL / 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.1333333402872    
     +/
      DATA SIGA /  66.99631266095    
     +, -1158.485287639    
     +,  3480.578808997    
     +, -2501.292526617    
     +, -1027.779526635    
     +,  1563.489357225    
     +, -1918.947098194    
     +,  1674.067726561    
     +, -180.2784593319    
     +, -5.741084939405    
     +, -13.38553770025    
     +,  16.25090441872    
     +/
      mfunc_nwao85 = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         mfunc_nwao85 = mfunc_nwao85 + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) mfunc_nwao85 = VCONST * EXP (mfunc_nwao85)
      if (mfunc_nwao85.le.0.0) mfunc_nwao85 = 0.001
      END


      DOUBLE PRECISION FUNCTION mfunc_nwao90(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  10, 1)
      DOUBLE PRECISION SIGDEL(  10)
      DOUBLE PRECISION SIGA(  10)
      DATA NPAR, NDIM, IMQFUN /   10,    1,    1/
      DATA VCONST / 0.0000000000000E+00/
      DATA SIGVMI /  50.00000000000    /
      DATA SIGVT /  50.00000000000    /
      DATA SIGV / 0.5500000119209    
     +, 0.7166666984558    
     +, 0.8166667222977    
     +, 0.8833333849907    
     +, 0.9166666865349    
     +, 0.9500000476837    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.3000000119209    
     +, 0.6333333849907    
     +/
      DATA SIGDEL / 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.1333333402872    
     +, 0.1333333402872    
     +/
      DATA SIGA /  573.1222461465    
     +,  3167.614064882    
     +, -7134.791750456    
     +,  6423.017222051    
     +, -2319.534612366    
     +,  869.0185651459    
     +,  15.82778220597    
     +, -265.1618023918    
     +,  67.09716553582    
     +, -1380.722699506    
     +/
      mfunc_nwao90 = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         mfunc_nwao90 = mfunc_nwao90 + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) mfunc_nwao90 = VCONST * EXP (mfunc_nwao90)
      if (mfunc_nwao90.le.0.0) mfunc_nwao90 = 0.001
      END


      DOUBLE PRECISION FUNCTION mfunc_nwao95(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   7, 1)
      DOUBLE PRECISION SIGDEL(   7)
      DOUBLE PRECISION SIGA(   7)
      DATA NPAR, NDIM, IMQFUN /    7,    1,    2/
      DATA VCONST /  1.666666626930    /
      DATA SIGVMI /  50.00000000000    /
      DATA SIGVT /  50.00000000000    /
      DATA SIGV / 0.5833333730698    
     +, 0.8166667222977    
     +, 0.8833333849907    
     +, 0.9500000476837    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.7000000476837    
     +/
      DATA SIGDEL / 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.1333333402872    
     +/
      DATA SIGA /  5.043054646101    
     +,  10.27873081097    
     +,  32.89993230807    
     +, -216.3922304374    
     +,  2.999947544822    
     +,  163.3064689868    
     +, -4.416854206246    
     +/
      mfunc_nwao95 = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         mfunc_nwao95 = mfunc_nwao95 + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) mfunc_nwao95 = VCONST * EXP (mfunc_nwao95)
      if (mfunc_nwao95.le.0.0) mfunc_nwao95 = 0.001
      END




      DOUBLE PRECISION FUNCTION mfunc_nwao975(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  11, 1)
      DOUBLE PRECISION SIGDEL(  11)
      DOUBLE PRECISION SIGA(  11)
      DATA NPAR, NDIM, IMQFUN /   11,    1,    1/
      DATA VCONST /  1.666666626930    /
      DATA SIGVMI /  50.00000000000    /
      DATA SIGVT /  50.00000000000    /
      DATA SIGV / 0.4500000178814    
     +, 0.5500000119209    
     +, 0.5833333730698    
     +, 0.8833333849907    
     +, 0.9166666865349    
     +, 0.9500000476837    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.3000000119209    
     +, 0.3666666746140    
     +, 0.7666667103767    
     +/
      DATA SIGDEL / 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.1333333402872    
     +, 0.1333333402872    
     +, 0.1333333402872    
     +/
      DATA SIGA /  92.54842263852    
     +, -202.2704979799    
     +,  248.6237814133    
     +,  16960.94085419    
     +, -52498.85948775    
     +,  42300.41744418    
     +, -226.3316735624    
     +, -7359.888789078    
     +,  81.95304066491    
     +, -160.2258298386    
     +,  336.7633867904    
     +/
      mfunc_nwao975 = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         mfunc_nwao975 = mfunc_nwao975 + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) mfunc_nwao975 = VCONST * EXP (mfunc_nwao975)
      if (mfunc_nwao975.le.0.0) mfunc_nwao975 = 0.001
      END


      DOUBLE PRECISION FUNCTION mfunc_nwao100(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   8, 1)
      DOUBLE PRECISION SIGDEL(   8)
      DOUBLE PRECISION SIGA(   8)
      DATA NPAR, NDIM, IMQFUN /    8,    1,    1/
      DATA VCONST /  1.666666626930    /
      DATA SIGVMI /  50.00000000000    /
      DATA SIGVT /  50.00000000000    /
      DATA SIGV / 0.7166666984558    
     +, 0.7500000596046    
     +, 0.9166666865349    
     +, 0.9500000476837    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.6333333849907    
     +, 0.8333333730698    
     +/
      DATA SIGDEL / 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.1333333402872    
     +, 0.1333333402872    
     +/
      DATA SIGA /  592.9389062229    
     +,  150.2753076371    
     +, -14844.80538056    
     +,  17095.56744668    
     +, -121.0993920090    
     +, -3625.557204378    
     +, -6.682396186316    
     +,  537.3698635856    
     +/
      mfunc_nwao100 = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         mfunc_nwao100 = mfunc_nwao100 + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) mfunc_nwao100 = VCONST * EXP (mfunc_nwao100)
      if (mfunc_nwao100.le.0.0) mfunc_nwao100 = 0.001
      END





      DOUBLE PRECISION FUNCTION mfunc_nwao105(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   6, 1)
      DOUBLE PRECISION SIGDEL(   6)
      DOUBLE PRECISION SIGA(   6)
      DATA NPAR, NDIM, IMQFUN /    6,    1,    1/
      DATA VCONST /  1.666666626930    /
      DATA SIGVMI /  50.00000000000    /
      DATA SIGVT /  50.00000000000    /
      DATA SIGV / 0.8833333849907    
     +, 0.9500000476837    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.6333333849907    
     +, 0.7000000476837    
     +/
      DATA SIGDEL / 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.1333333402872    
     +, 0.1333333402872    
     +/
      DATA SIGA / -6064.923458719    
     +,  6178.536762426    
     +, -89.90708414609    
     +, -1644.946721139    
     +, -1271.407497914    
     +,  2747.200257684    
     +/
      mfunc_nwao105 = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         mfunc_nwao105 = mfunc_nwao105 + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) mfunc_nwao105 = VCONST * EXP (mfunc_nwao105)
      if (mfunc_nwao105.le.0.0) mfunc_nwao105 = 0.001
      END




      DOUBLE PRECISION FUNCTION mfunc_nwao110(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   8, 1)
      DOUBLE PRECISION SIGDEL(   8)
      DOUBLE PRECISION SIGA(   8)
      DATA NPAR, NDIM, IMQFUN /    8,    1,    1/
      DATA VCONST /  1.666666626930    /
      DATA SIGVMI /  50.00000000000    /
      DATA SIGVT /  50.00000000000    /
      DATA SIGV / 0.6166666746140    
     +, 0.8833333849907    
     +, 0.9166666865349    
     +, 0.9500000476837    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.7000000476837    
     +, 0.7666667103767    
     +/
      DATA SIGDEL / 0.2666666917503E-01
     +, 0.2666666917503E-01
     +, 0.2666666917503E-01
     +, 0.2666666917503E-01
     +, 0.8000000093489E-06
     +, 0.8000000093489E-06
     +, 0.5333333835006E-01
     +, 0.5333333835006E-01
     +/
      DATA SIGA /  279.9170437187    
     +, -7492.454223017    
     +,  6933.735698840    
     +, -717.3371343945    
     +, -4.613444388251    
     +, -95.17936225583    
     +, -475.5037193589    
     +,  1561.844565694    
     +/
      mfunc_nwao110 = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         mfunc_nwao110 = mfunc_nwao110 + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) mfunc_nwao110 = VCONST * EXP (mfunc_nwao110)
      if (mfunc_nwao110.le.0.0) mfunc_nwao110 = 0.001
      END
























































































