c-*-FORTRAN-*-
c
      real*8 function a2000_hll_bkg_level(ecms,ibkg)
c
c Returns the normalized backgrounds expected in the hll searches at 
c different energies in the year 2000 runs; 
c FOR 1 pb LUMINOSITY, at a given ECM=ener.
c
c ener = centre-of-mass energy (GeV)
c ibkg = bgd type: 1 (ZZ), 2 (eeZ), 3 (WW), 4 (qqg)
c
c Created:                             Pedro Teixeira-Dias, 15-Jun-2000.
c
      implicit none
      integer ibkg
      real*8 bglevel,ecms
c
      real*8 al_xsect_dd,al_xsect_uu,al_xsect_ss,al_xsect_cc,
     +     al_xsect_bb,al_xsect_zz,al_xsect_ww,al_xsect_zee
      external al_xsect_dd,al_xsect_uu,al_xsect_ss,al_xsect_cc,
     +     al_xsect_bb,al_xsect_zz,al_xsect_ww,al_xsect_zee
c
      real*8 a2000_hll_bkg_eff_eez
      real*8 a2000_hll_bkg_eff_qqg
      real*8 a2000_hll_bkg_eff_ww
      real*8 a2000_hll_bkg_eff_zz
c
      external a2000_hll_bkg_eff_eez
      external a2000_hll_bkg_eff_qqg
      external a2000_hll_bkg_eff_ww
      external a2000_hll_bkg_eff_zz
c
      bglevel = -1.D0
c
      IF (IBKG .EQ. 1) THEN     ! ZZ
         bglevel = al_xsect_zz(ecms) * a2000_hll_bkg_eff_zz(ecms)
      ELSE IF (IBKG .EQ. 2) THEN     ! eeZ
         bglevel = al_xsect_zee(ecms) * a2000_hll_bkg_eff_eez(ecms)
      ELSE IF (IBKG .EQ. 3) THEN     ! WW
         bglevel = al_xsect_ww(ecms) * a2000_hll_bkg_eff_ww(ecms)
      ELSE IF (IBKG .EQ. 4) THEN     ! qqg
         bglevel = ( al_xsect_dd(ecms) + al_xsect_uu(ecms) + 
     +               al_xsect_ss(ecms) + al_xsect_cc(ecms) + 
     +               al_xsect_bb(ecms) ) *
     +               a2000_hll_bkg_eff_qqg(ecms)
      END IF
c
      a2000_hll_bkg_level = bglevel
c
      if (a2000_hll_bkg_level.lt.0.D0) then
         write (6,*) '<a2000_hll_bkg_level> Error! Invalid IBKG.',
     +        ecms,ibkg
         a2000_hll_bkg_level = 0.D0
      end if
c
      end

