      real*8 FUNCTION a2000_hll_bkg_eff_eez(ecm)

      implicit none

      real*8 ecm
      real*8 m, b

      m = 0.6848d-4
      b = -0.1102d-1

      a2000_hll_bkg_eff_eez = m*ecm + b

      return
      end



      real*8 FUNCTION a2000_hll_bkg_eff_qqg(ecm)

      implicit none

      real*8 ecm
      real*8 m, b

       m = -0.1395d-5
       b = 0.3909d-3

c      m = -0.1979d-5
c      b = 0.4602d-3

      a2000_hll_bkg_eff_qqg = m*ecm + b

      return
      end



      real*8 FUNCTION a2000_hll_bkg_eff_ww(ecm)

      implicit none

      real*8 ecm
      real*8 m, b

      m = 0.2287d-4
      b = -0.4075d-2

      a2000_hll_bkg_eff_ww = m*ecm + b

      return
      end



      real*8 FUNCTION a2000_hll_bkg_eff_zz(ecm)

      implicit none

      real*8 ecm
      real*8 m, b

      m = 0.1249d-3
      b = 0.9796d-2

      a2000_hll_bkg_eff_zz = m*ecm + b

      return
      end



      real*8 FUNCTION a2000_hll_sig_eff_bb(higgsmss, ecm)

      implicit none

      real*8 higgsmss, ecm
      real*8 m, b, eff(22), thresh(22), distance

      data eff / 0.8268, 0.8299, 0.8330, 0.8350, 0.8416,
     &           0.8343, 0.8365, 0.8361, 0.8334, 0.8282,
     &           0.8220, 0.8207, 0.8100, 0.7973, 0.7843,
     &           0.7449, 0.6740, 0.6325, 0.5732, 0.5149,
     &           0.4614, 0.4022 /

      data thresh / -41.8, -36.8, -31.8, -26.8, -21.8,
     &              -16.8, -12.8, -10.8,  -8.8,  -6.8,
     &               -4.8,  -3.8,  -2.8,  -1.8,  -0.8,
     &                0.0,   1.2,   2.2,   3.2,   5.2,
     &                7.2,   11.7 /

      distance = higgsmss + 91.2d0 - ecm

      m = 0.d0
      b = 0.d0

      if ((distance.ge.thresh(1)).and.(distance.le.thresh(2))) then
        m = (eff(2) - eff(1))/(thresh(2)-thresh(1))
        b = eff(1) - m*thresh(1)
      elseif ((distance.ge.thresh(2)).and.(distance.le.thresh(3))) then
        m = (eff(3) - eff(2))/(thresh(3)-thresh(2))
        b = eff(2) - m*thresh(2)
      elseif ((distance.ge.thresh(3)).and.(distance.le.thresh(4))) then
        m = (eff(4) - eff(3))/(thresh(4)-thresh(3))
        b = eff(3) - m*thresh(3)
      elseif ((distance.ge.thresh(4)).and.(distance.le.thresh(5))) then
        m = (eff(5) - eff(4))/(thresh(5)-thresh(4))
        b = eff(4) - m*thresh(4)
      elseif ((distance.ge.thresh(5)).and.(distance.le.thresh(6))) then
        m = (eff(6) - eff(5))/(thresh(6)-thresh(5))
        b = eff(5) - m*thresh(5)
      elseif ((distance.ge.thresh(6)).and.(distance.le.thresh(7))) then
        m = (eff(7) - eff(6))/(thresh(7)-thresh(6))
        b = eff(6) - m*thresh(6)
      elseif ((distance.ge.thresh(7)).and.(distance.le.thresh(8))) then
        m = (eff(8) - eff(7))/(thresh(8)-thresh(7))
        b = eff(7) - m*thresh(7)
      elseif ((distance.ge.thresh(8)).and.(distance.le.thresh(9))) then
        m = (eff(9) - eff(8))/(thresh(9)-thresh(8))
        b = eff(8) - m*thresh(8)
      elseif ((distance.ge.thresh(9)).and.(distance.le.thresh(10))) then
        m = (eff(10) - eff(9))/(thresh(10)-thresh(9))
        b = eff(9) - m*thresh(9)
      elseif ((distance.ge.thresh(10)).and.
     &       (distance.le.thresh(11))) then
        m = (eff(11) - eff(10))/(thresh(11)-thresh(10))
        b = eff(10) - m*thresh(10)
      elseif ((distance.ge.thresh(11)).and.
     &       (distance.le.thresh(12))) then
        m = (eff(12) - eff(11))/(thresh(12)-thresh(11))
        b = eff(11) - m*thresh(11)
      elseif ((distance.ge.thresh(12)).and.
     &       (distance.le.thresh(13))) then
        m = (eff(13) - eff(12))/(thresh(13)-thresh(12))
        b = eff(12) - m*thresh(12)
      elseif ((distance.ge.thresh(13)).and.
     &       (distance.le.thresh(14))) then
        m = (eff(14) - eff(13))/(thresh(14)-thresh(13))
        b = eff(13) - m*thresh(13)
      elseif ((distance.ge.thresh(14)).and.
     &       (distance.le.thresh(15))) then
        m = (eff(15) - eff(14))/(thresh(15)-thresh(14))
        b = eff(14) - m*thresh(14)
      elseif ((distance.ge.thresh(15)).and.
     &       (distance.le.thresh(16))) then
        m = (eff(16) - eff(15))/(thresh(16)-thresh(15))
        b = eff(15) - m*thresh(15)
      elseif ((distance.ge.thresh(16)).and.
     &       (distance.le.thresh(17))) then
        m = (eff(17) - eff(16))/(thresh(17)-thresh(16))
        b = eff(16) - m*thresh(16)
      elseif ((distance.ge.thresh(17)).and.
     &       (distance.le.thresh(18))) then
        m = (eff(18) - eff(17))/(thresh(18)-thresh(17))
        b = eff(17) - m*thresh(17)
      elseif ((distance.ge.thresh(18)).and.
     &       (distance.le.thresh(19))) then
        m = (eff(19) - eff(18))/(thresh(19)-thresh(18))
        b = eff(18) - m*thresh(18)
      elseif ((distance.ge.thresh(19)).and.
     &       (distance.le.thresh(20))) then
        m = (eff(20) - eff(19))/(thresh(20)-thresh(19))
        b = eff(19) - m*thresh(19)
      elseif ((distance.ge.thresh(20)).and.
     &       (distance.le.thresh(21))) then
        m = (eff(21) - eff(20))/(thresh(21)-thresh(20))
        b = eff(20) - m*thresh(20)
      elseif ((distance.ge.thresh(21)).and.
     &       (distance.le.thresh(22))) then
        m = (eff(22) - eff(21))/(thresh(22)-thresh(21))
        b = eff(21) - m*thresh(21)
      endif

      a2000_hll_sig_eff_bb = m*distance + b
      
      return
      end


      real*8 FUNCTION a2000_hll_sig_eff_other(higgsmss, ecm)

      implicit none

      real*8 higgsmss, ecm
      real*8 m, b, eff(22), thresh(22), distance

      data eff / 0.7954, 0.8175, 0.8106, 0.8349, 0.8278,
     &           0.8383, 0.8184, 0.8106, 0.8057, 0.7931,
     &           0.7962, 0.7966, 0.7887, 0.7733, 0.7573,
     &           0.7327, 0.6708, 0.6080, 0.5745, 0.4873,
     &           0.4694, 0.4071 /

      data thresh / -41.8, -36.8, -31.8, -26.8, -21.8,
     &              -16.8, -12.8, -10.8,  -8.8,  -6.8,
     &               -4.8,  -3.8,  -2.8,  -1.8,  -0.8,
     &                0.0,   1.2,   2.2,   3.2,   5.2,
     &                7.2,   11.7 /

      distance = higgsmss + 91.2 - ecm

      m = 0.d0
      b = 0.d0

      if ((distance.ge.thresh(1)).and.(distance.le.thresh(2))) then
        m = (eff(2) - eff(1))/(thresh(2)-thresh(1))
        b = eff(1) - m*thresh(1)
      elseif ((distance.ge.thresh(2)).and.(distance.le.thresh(3))) then
        m = (eff(3) - eff(2))/(thresh(3)-thresh(2))
        b = eff(2) - m*thresh(2)
      elseif ((distance.ge.thresh(3)).and.(distance.le.thresh(4))) then
        m = (eff(4) - eff(3))/(thresh(4)-thresh(3))
        b = eff(3) - m*thresh(3)
      elseif ((distance.ge.thresh(4)).and.(distance.le.thresh(5))) then
        m = (eff(5) - eff(4))/(thresh(5)-thresh(4))
        b = eff(4) - m*thresh(4)
      elseif ((distance.ge.thresh(5)).and.(distance.le.thresh(6))) then
        m = (eff(6) - eff(5))/(thresh(6)-thresh(5))
        b = eff(5) - m*thresh(5)
      elseif ((distance.ge.thresh(6)).and.(distance.le.thresh(7))) then
        m = (eff(7) - eff(6))/(thresh(7)-thresh(6))
        b = eff(6) - m*thresh(6)
      elseif ((distance.ge.thresh(7)).and.(distance.le.thresh(8))) then
        m = (eff(8) - eff(7))/(thresh(8)-thresh(7))
        b = eff(7) - m*thresh(7)
      elseif ((distance.ge.thresh(8)).and.(distance.le.thresh(9))) then
        m = (eff(9) - eff(8))/(thresh(9)-thresh(8))
        b = eff(8) - m*thresh(8)
      elseif ((distance.ge.thresh(9)).and.(distance.le.thresh(10))) then
        m = (eff(10) - eff(9))/(thresh(10)-thresh(9))
        b = eff(9) - m*thresh(9)
      elseif ((distance.ge.thresh(10)).and.
     &       (distance.le.thresh(11))) then
        m = (eff(11) - eff(10))/(thresh(11)-thresh(10))
        b = eff(10) - m*thresh(10)
      elseif ((distance.ge.thresh(11)).and.
     &       (distance.le.thresh(12))) then
        m = (eff(12) - eff(11))/(thresh(12)-thresh(11))
        b = eff(11) - m*thresh(11)
      elseif ((distance.ge.thresh(12)).and.
     &       (distance.le.thresh(13))) then
        m = (eff(13) - eff(12))/(thresh(13)-thresh(12))
        b = eff(12) - m*thresh(12)
      elseif ((distance.ge.thresh(13)).and.
     &       (distance.le.thresh(14))) then
        m = (eff(14) - eff(13))/(thresh(14)-thresh(13))
        b = eff(13) - m*thresh(13)
      elseif ((distance.ge.thresh(14)).and.
     &       (distance.le.thresh(15))) then
        m = (eff(15) - eff(14))/(thresh(15)-thresh(14))
        b = eff(14) - m*thresh(14)
      elseif ((distance.ge.thresh(15)).and.
     &       (distance.le.thresh(16))) then
        m = (eff(16) - eff(15))/(thresh(16)-thresh(15))
        b = eff(15) - m*thresh(15)
      elseif ((distance.ge.thresh(16)).and.
     &       (distance.le.thresh(17))) then
        m = (eff(17) - eff(16))/(thresh(17)-thresh(16))
        b = eff(16) - m*thresh(16)
      elseif ((distance.ge.thresh(17)).and.
     &       (distance.le.thresh(18))) then
        m = (eff(18) - eff(17))/(thresh(18)-thresh(17))
        b = eff(17) - m*thresh(17)
      elseif ((distance.ge.thresh(18)).and.
     &       (distance.le.thresh(19))) then
        m = (eff(19) - eff(18))/(thresh(19)-thresh(18))
        b = eff(18) - m*thresh(18)
      elseif ((distance.ge.thresh(19)).and.
     &       (distance.le.thresh(20))) then
        m = (eff(20) - eff(19))/(thresh(20)-thresh(19))
        b = eff(19) - m*thresh(19)
      elseif ((distance.ge.thresh(20)).and.
     &       (distance.le.thresh(21))) then
        m = (eff(21) - eff(20))/(thresh(21)-thresh(20))
        b = eff(20) - m*thresh(20)
      elseif ((distance.ge.thresh(21)).and.
     &       (distance.le.thresh(22))) then
        m = (eff(22) - eff(21))/(thresh(22)-thresh(21))
        b = eff(21) - m*thresh(21)
      endif

      a2000_hll_sig_eff_other = m*distance + b
      
      return
      end


      real*8 FUNCTION a2000_hll_sig_eff_tt(higgsmss, ecm)

      implicit none

      real*8 higgsmss, ecm
      real*8 m, b, eff(22), thresh(22), distance

      data eff / 0.6003, 0.5785, 0.6472, 0.6465, 0.6909,
     &           0.6530, 0.6529, 0.6909, 0.6889, 0.6502,
     &           0.6390, 0.7023, 0.6940, 0.6772, 0.6704,
     &           0.6098, 0.5761, 0.5245, 0.4879, 0.4616,
     &           0.4232, 0.3436 /

      data thresh / -41.8, -36.8, -31.8, -26.8, -21.8,
     &              -16.8, -12.8, -10.8,  -8.8,  -6.8,
     &               -4.8,  -3.8,  -2.8,  -1.8,  -0.8,
     &                0.0,   1.2,   2.2,   3.2,   5.2,
     &                7.2,   11.7 /

      distance = higgsmss + 91.2 - ecm

      m = 0.d0
      b = 0.d0

      if ((distance.ge.thresh(1)).and.(distance.le.thresh(2))) then
        m = (eff(2) - eff(1))/(thresh(2)-thresh(1))
        b = eff(1) - m*thresh(1)
      elseif ((distance.ge.thresh(2)).and.(distance.le.thresh(3))) then
        m = (eff(3) - eff(2))/(thresh(3)-thresh(2))
        b = eff(2) - m*thresh(2)
      elseif ((distance.ge.thresh(3)).and.(distance.le.thresh(4))) then
        m = (eff(4) - eff(3))/(thresh(4)-thresh(3))
        b = eff(3) - m*thresh(3)
      elseif ((distance.ge.thresh(4)).and.(distance.le.thresh(5))) then
        m = (eff(5) - eff(4))/(thresh(5)-thresh(4))
        b = eff(4) - m*thresh(4)
      elseif ((distance.ge.thresh(5)).and.(distance.le.thresh(6))) then
        m = (eff(6) - eff(5))/(thresh(6)-thresh(5))
        b = eff(5) - m*thresh(5)
      elseif ((distance.ge.thresh(6)).and.(distance.le.thresh(7))) then
        m = (eff(7) - eff(6))/(thresh(7)-thresh(6))
        b = eff(6) - m*thresh(6)
      elseif ((distance.ge.thresh(7)).and.(distance.le.thresh(8))) then
        m = (eff(8) - eff(7))/(thresh(8)-thresh(7))
        b = eff(7) - m*thresh(7)
      elseif ((distance.ge.thresh(8)).and.(distance.le.thresh(9))) then
        m = (eff(9) - eff(8))/(thresh(9)-thresh(8))
        b = eff(8) - m*thresh(8)
      elseif ((distance.ge.thresh(9)).and.(distance.le.thresh(10))) then
        m = (eff(10) - eff(9))/(thresh(10)-thresh(9))
        b = eff(9) - m*thresh(9)
      elseif ((distance.ge.thresh(10)).and.
     &       (distance.le.thresh(11))) then
        m = (eff(11) - eff(10))/(thresh(11)-thresh(10))
        b = eff(10) - m*thresh(10)
      elseif ((distance.ge.thresh(11)).and.
     &       (distance.le.thresh(12))) then
        m = (eff(12) - eff(11))/(thresh(12)-thresh(11))
        b = eff(11) - m*thresh(11)
      elseif ((distance.ge.thresh(12)).and.
     &       (distance.le.thresh(13))) then
        m = (eff(13) - eff(12))/(thresh(13)-thresh(12))
        b = eff(12) - m*thresh(12)
      elseif ((distance.ge.thresh(13)).and.
     &       (distance.le.thresh(14))) then
        m = (eff(14) - eff(13))/(thresh(14)-thresh(13))
        b = eff(13) - m*thresh(13)
      elseif ((distance.ge.thresh(14)).and.
     &       (distance.le.thresh(15))) then
        m = (eff(15) - eff(14))/(thresh(15)-thresh(14))
        b = eff(14) - m*thresh(14)
      elseif ((distance.ge.thresh(15)).and.
     &       (distance.le.thresh(16))) then
        m = (eff(16) - eff(15))/(thresh(16)-thresh(15))
        b = eff(15) - m*thresh(15)
      elseif ((distance.ge.thresh(16)).and.
     &       (distance.le.thresh(17))) then
        m = (eff(17) - eff(16))/(thresh(17)-thresh(16))
        b = eff(16) - m*thresh(16)
      elseif ((distance.ge.thresh(17)).and.
     &       (distance.le.thresh(18))) then
        m = (eff(18) - eff(17))/(thresh(18)-thresh(17))
        b = eff(17) - m*thresh(17)
      elseif ((distance.ge.thresh(18)).and.
     &       (distance.le.thresh(19))) then
        m = (eff(19) - eff(18))/(thresh(19)-thresh(18))
        b = eff(18) - m*thresh(18)
      elseif ((distance.ge.thresh(19)).and.
     &       (distance.le.thresh(20))) then
        m = (eff(20) - eff(19))/(thresh(20)-thresh(19))
        b = eff(19) - m*thresh(19)
      elseif ((distance.ge.thresh(20)).and.
     &       (distance.le.thresh(21))) then
        m = (eff(21) - eff(20))/(thresh(21)-thresh(20))
        b = eff(20) - m*thresh(20)
      elseif ((distance.ge.thresh(21)).and.
     &       (distance.le.thresh(22))) then
        m = (eff(22) - eff(21))/(thresh(22)-thresh(21))
        b = eff(21) - m*thresh(21)
      endif

      a2000_hll_sig_eff_tt = m*distance + b
      
      return
      end


