      real*8 FUNCTION a2000_hll_bkg_sys_eez(ecm)

      implicit none

      real*8 ecm
      real*8 m, b

      m = -0.8439d-3
      b = 0.2354d0

      a2000_hll_bkg_sys_eez = m*ecm + b

      return
      end



      real*8 FUNCTION a2000_hll_bkg_sys_qqg(ecm)

      implicit none

      real*8 ecm
      real*8 m, b

      m = 0.18651d-2
      b = -0.99614d-1
c      m = 0.1565d-2
c      b = -0.4787d-1

      a2000_hll_bkg_sys_qqg = m*ecm + b

      return
      end



      real*8 FUNCTION a2000_hll_bkg_sys_ww(ecm)

      implicit none

      real*8 ecm
      real*8 m, b

      m = -0.1857d-3
      b = 0.1340d0

      a2000_hll_bkg_sys_ww = m*ecm + b

      return
      end



      real*8 FUNCTION a2000_hll_bkg_sys_zz(ecm)

      implicit none

      real*8 ecm
      real*8 m, b

      m = 0.2373d-3
      b = -0.1808d-1

      a2000_hll_bkg_sys_zz = m*ecm + b

      return
      end



      real*8 FUNCTION a2000_hll_sig_sys_bb(higgsmss, ecm)

      implicit none

      real*8 higgsmss, ecm
      real*8 m, b, eff(22), thresh(22), distance

      data eff / 0.00563, 0.00553, 0.00553, 0.00559, 0.00564,
     &           0.00566, 0.00558, 0.00583, 0.00562, 0.00576,
     &           0.00600, 0.00597, 0.00621, 0.00647, 0.00686,
     &           0.00729, 0.00864, 0.00948, 0.01046, 0.01180,
     &           0.01302, 0.01460 /

      data thresh / -41.8, -36.8, -31.8, -26.8, -21.8,
     &              -16.8, -12.8, -10.8,  -8.8,  -6.8,
     &               -4.8,  -3.8,  -2.8,  -1.8,  -0.8,
     &                0.0,   1.2,   2.2,   3.2,   5.2,
     &                7.2,   11.7 /

      distance = higgsmss + 91.2d0 - ecm

      m = 0.d0
      b = 0.d0

      if ((distance.ge.thresh(1)).and.(distance.le.thresh(2))) then
        m = (eff(2) - eff(1))/(thresh(2)-thresh(1))
        b = eff(1) - m*thresh(1)
      elseif ((distance.ge.thresh(2)).and.(distance.le.thresh(3))) then
        m = (eff(3) - eff(2))/(thresh(3)-thresh(2))
        b = eff(2) - m*thresh(2)
      elseif ((distance.ge.thresh(3)).and.(distance.le.thresh(4))) then
        m = (eff(4) - eff(3))/(thresh(4)-thresh(3))
        b = eff(3) - m*thresh(3)
      elseif ((distance.ge.thresh(4)).and.(distance.le.thresh(5))) then
        m = (eff(5) - eff(4))/(thresh(5)-thresh(4))
        b = eff(4) - m*thresh(4)
      elseif ((distance.ge.thresh(5)).and.(distance.le.thresh(6))) then
        m = (eff(6) - eff(5))/(thresh(6)-thresh(5))
        b = eff(5) - m*thresh(5)
      elseif ((distance.ge.thresh(6)).and.(distance.le.thresh(7))) then
        m = (eff(7) - eff(6))/(thresh(7)-thresh(6))
        b = eff(6) - m*thresh(6)
      elseif ((distance.ge.thresh(7)).and.(distance.le.thresh(8))) then
        m = (eff(8) - eff(7))/(thresh(8)-thresh(7))
        b = eff(7) - m*thresh(7)
      elseif ((distance.ge.thresh(8)).and.(distance.le.thresh(9))) then
        m = (eff(9) - eff(8))/(thresh(9)-thresh(8))
        b = eff(8) - m*thresh(8)
      elseif ((distance.ge.thresh(9)).and.(distance.le.thresh(10))) then
        m = (eff(10) - eff(9))/(thresh(10)-thresh(9))
        b = eff(9) - m*thresh(9)
      elseif ((distance.ge.thresh(10)).and.
     &       (distance.le.thresh(11))) then
        m = (eff(11) - eff(10))/(thresh(11)-thresh(10))
        b = eff(10) - m*thresh(10)
      elseif ((distance.ge.thresh(11)).and.
     &       (distance.le.thresh(12))) then
        m = (eff(12) - eff(11))/(thresh(12)-thresh(11))
        b = eff(11) - m*thresh(11)
      elseif ((distance.ge.thresh(12)).and.
     &       (distance.le.thresh(13))) then
        m = (eff(13) - eff(12))/(thresh(13)-thresh(12))
        b = eff(12) - m*thresh(12)
      elseif ((distance.ge.thresh(13)).and.
     &       (distance.le.thresh(14))) then
        m = (eff(14) - eff(13))/(thresh(14)-thresh(13))
        b = eff(13) - m*thresh(13)
      elseif ((distance.ge.thresh(14)).and.
     &       (distance.le.thresh(15))) then
        m = (eff(15) - eff(14))/(thresh(15)-thresh(14))
        b = eff(14) - m*thresh(14)
      elseif ((distance.ge.thresh(15)).and.
     &       (distance.le.thresh(16))) then
        m = (eff(16) - eff(15))/(thresh(16)-thresh(15))
        b = eff(15) - m*thresh(15)
      elseif ((distance.ge.thresh(16)).and.
     &       (distance.le.thresh(17))) then
        m = (eff(17) - eff(16))/(thresh(17)-thresh(16))
        b = eff(16) - m*thresh(16)
      elseif ((distance.ge.thresh(17)).and.
     &       (distance.le.thresh(18))) then
        m = (eff(18) - eff(17))/(thresh(18)-thresh(17))
        b = eff(17) - m*thresh(17)
      elseif ((distance.ge.thresh(18)).and.
     &       (distance.le.thresh(19))) then
        m = (eff(19) - eff(18))/(thresh(19)-thresh(18))
        b = eff(18) - m*thresh(18)
      elseif ((distance.ge.thresh(19)).and.
     &       (distance.le.thresh(20))) then
        m = (eff(20) - eff(19))/(thresh(20)-thresh(19))
        b = eff(19) - m*thresh(19)
      elseif ((distance.ge.thresh(20)).and.
     &       (distance.le.thresh(21))) then
        m = (eff(21) - eff(20))/(thresh(21)-thresh(20))
        b = eff(20) - m*thresh(20)
      elseif ((distance.ge.thresh(21)).and.
     &       (distance.le.thresh(22))) then
        m = (eff(22) - eff(21))/(thresh(22)-thresh(21))
        b = eff(21) - m*thresh(21)
      endif

      a2000_hll_sig_sys_bb = m*distance + b
      
      return
      end


      real*8 FUNCTION a2000_hll_sig_sys_other(higgsmss, ecm)

      implicit none

      real*8 higgsmss, ecm
      real*8 m, b, eff(22), thresh(22), distance

      data eff / 0.01679, 0.01639, 0.01596, 0.01580, 0.01527,
     &           0.01520, 0.01389, 0.01376, 0.01342, 0.01260,
     &           0.01273, 0.01272, 0.01326, 0.01226, 0.01280,
     &           0.01280, 0.01470, 0.01633, 0.01768, 0.02143,
     &           0.02178, 0.02693 /

      data thresh / -41.8, -36.8, -31.8, -26.8, -21.8,
     &              -16.8, -12.8, -10.8,  -8.8,  -6.8,
     &               -4.8,  -3.8,  -2.8,  -1.8,  -0.8,
     &                0.0,   1.2,   2.2,   3.2,   5.2,
     &                7.2,   11.7 /

      distance = higgsmss + 91.2 - ecm

      m = 0.d0
      b = 0.d0

      if ((distance.ge.thresh(1)).and.(distance.le.thresh(2))) then
        m = (eff(2) - eff(1))/(thresh(2)-thresh(1))
        b = eff(1) - m*thresh(1)
      elseif ((distance.ge.thresh(2)).and.(distance.le.thresh(3))) then
        m = (eff(3) - eff(2))/(thresh(3)-thresh(2))
        b = eff(2) - m*thresh(2)
      elseif ((distance.ge.thresh(3)).and.(distance.le.thresh(4))) then
        m = (eff(4) - eff(3))/(thresh(4)-thresh(3))
        b = eff(3) - m*thresh(3)
      elseif ((distance.ge.thresh(4)).and.(distance.le.thresh(5))) then
        m = (eff(5) - eff(4))/(thresh(5)-thresh(4))
        b = eff(4) - m*thresh(4)
      elseif ((distance.ge.thresh(5)).and.(distance.le.thresh(6))) then
        m = (eff(6) - eff(5))/(thresh(6)-thresh(5))
        b = eff(5) - m*thresh(5)
      elseif ((distance.ge.thresh(6)).and.(distance.le.thresh(7))) then
        m = (eff(7) - eff(6))/(thresh(7)-thresh(6))
        b = eff(6) - m*thresh(6)
      elseif ((distance.ge.thresh(7)).and.(distance.le.thresh(8))) then
        m = (eff(8) - eff(7))/(thresh(8)-thresh(7))
        b = eff(7) - m*thresh(7)
      elseif ((distance.ge.thresh(8)).and.(distance.le.thresh(9))) then
        m = (eff(9) - eff(8))/(thresh(9)-thresh(8))
        b = eff(8) - m*thresh(8)
      elseif ((distance.ge.thresh(9)).and.(distance.le.thresh(10))) then
        m = (eff(10) - eff(9))/(thresh(10)-thresh(9))
        b = eff(9) - m*thresh(9)
      elseif ((distance.ge.thresh(10)).and.
     &       (distance.le.thresh(11))) then
        m = (eff(11) - eff(10))/(thresh(11)-thresh(10))
        b = eff(10) - m*thresh(10)
      elseif ((distance.ge.thresh(11)).and.
     &       (distance.le.thresh(12))) then
        m = (eff(12) - eff(11))/(thresh(12)-thresh(11))
        b = eff(11) - m*thresh(11)
      elseif ((distance.ge.thresh(12)).and.
     &       (distance.le.thresh(13))) then
        m = (eff(13) - eff(12))/(thresh(13)-thresh(12))
        b = eff(12) - m*thresh(12)
      elseif ((distance.ge.thresh(13)).and.
     &       (distance.le.thresh(14))) then
        m = (eff(14) - eff(13))/(thresh(14)-thresh(13))
        b = eff(13) - m*thresh(13)
      elseif ((distance.ge.thresh(14)).and.
     &       (distance.le.thresh(15))) then
        m = (eff(15) - eff(14))/(thresh(15)-thresh(14))
        b = eff(14) - m*thresh(14)
      elseif ((distance.ge.thresh(15)).and.
     &       (distance.le.thresh(16))) then
        m = (eff(16) - eff(15))/(thresh(16)-thresh(15))
        b = eff(15) - m*thresh(15)
      elseif ((distance.ge.thresh(16)).and.
     &       (distance.le.thresh(17))) then
        m = (eff(17) - eff(16))/(thresh(17)-thresh(16))
        b = eff(16) - m*thresh(16)
      elseif ((distance.ge.thresh(17)).and.
     &       (distance.le.thresh(18))) then
        m = (eff(18) - eff(17))/(thresh(18)-thresh(17))
        b = eff(17) - m*thresh(17)
      elseif ((distance.ge.thresh(18)).and.
     &       (distance.le.thresh(19))) then
        m = (eff(19) - eff(18))/(thresh(19)-thresh(18))
        b = eff(18) - m*thresh(18)
      elseif ((distance.ge.thresh(19)).and.
     &       (distance.le.thresh(20))) then
        m = (eff(20) - eff(19))/(thresh(20)-thresh(19))
        b = eff(19) - m*thresh(19)
      elseif ((distance.ge.thresh(20)).and.
     &       (distance.le.thresh(21))) then
        m = (eff(21) - eff(20))/(thresh(21)-thresh(20))
        b = eff(20) - m*thresh(20)
      elseif ((distance.ge.thresh(21)).and.
     &       (distance.le.thresh(22))) then
        m = (eff(22) - eff(21))/(thresh(22)-thresh(21))
        b = eff(21) - m*thresh(21)
      endif

      a2000_hll_sig_sys_other = m*distance + b
      
      return
      end


      real*8 FUNCTION a2000_hll_sig_sys_tt(higgsmss, ecm)

      implicit none

      real*8 higgsmss, ecm
      real*8 m, b, eff(22), thresh(22), distance

      data eff / 0.02762, 0.02621, 0.02635, 0.02662, 0.02549,
     &           0.02586, 0.02639, 0.02353, 0.02483, 0.02569,
     &           0.02512, 0.02534, 0.02389, 0.02716, 0.02782,
     &           0.02750, 0.03068, 0.03516, 0.03922, 0.04072,
     &           0.04324, 0.05294 /

      data thresh / -41.8, -36.8, -31.8, -26.8, -21.8,
     &              -16.8, -12.8, -10.8,  -8.8,  -6.8,
     &               -4.8,  -3.8,  -2.8,  -1.8,  -0.8,
     &                0.0,   1.2,   2.2,   3.2,   5.2,
     &                7.2,   11.7 /

      distance = higgsmss + 91.2d0 - ecm

      m = 0.d0
      b = 0.d0

      if ((distance.ge.thresh(1)).and.(distance.le.thresh(2))) then
        m = (eff(2) - eff(1))/(thresh(2)-thresh(1))
        b = eff(1) - m*thresh(1)
      elseif ((distance.ge.thresh(2)).and.(distance.le.thresh(3))) then
        m = (eff(3) - eff(2))/(thresh(3)-thresh(2))
        b = eff(2) - m*thresh(2)
      elseif ((distance.ge.thresh(3)).and.(distance.le.thresh(4))) then
        m = (eff(4) - eff(3))/(thresh(4)-thresh(3))
        b = eff(3) - m*thresh(3)
      elseif ((distance.ge.thresh(4)).and.(distance.le.thresh(5))) then
        m = (eff(5) - eff(4))/(thresh(5)-thresh(4))
        b = eff(4) - m*thresh(4)
      elseif ((distance.ge.thresh(5)).and.(distance.le.thresh(6))) then
        m = (eff(6) - eff(5))/(thresh(6)-thresh(5))
        b = eff(5) - m*thresh(5)
      elseif ((distance.ge.thresh(6)).and.(distance.le.thresh(7))) then
        m = (eff(7) - eff(6))/(thresh(7)-thresh(6))
        b = eff(6) - m*thresh(6)
      elseif ((distance.ge.thresh(7)).and.(distance.le.thresh(8))) then
        m = (eff(8) - eff(7))/(thresh(8)-thresh(7))
        b = eff(7) - m*thresh(7)
      elseif ((distance.ge.thresh(8)).and.(distance.le.thresh(9))) then
        m = (eff(9) - eff(8))/(thresh(9)-thresh(8))
        b = eff(8) - m*thresh(8)
      elseif ((distance.ge.thresh(9)).and.(distance.le.thresh(10))) then
        m = (eff(10) - eff(9))/(thresh(10)-thresh(9))
        b = eff(9) - m*thresh(9)
      elseif ((distance.ge.thresh(10)).and.
     &       (distance.le.thresh(11))) then
        m = (eff(11) - eff(10))/(thresh(11)-thresh(10))
        b = eff(10) - m*thresh(10)
      elseif ((distance.ge.thresh(11)).and.
     &       (distance.le.thresh(12))) then
        m = (eff(12) - eff(11))/(thresh(12)-thresh(11))
        b = eff(11) - m*thresh(11)
      elseif ((distance.ge.thresh(12)).and.
     &       (distance.le.thresh(13))) then
        m = (eff(13) - eff(12))/(thresh(13)-thresh(12))
        b = eff(12) - m*thresh(12)
      elseif ((distance.ge.thresh(13)).and.
     &       (distance.le.thresh(14))) then
        m = (eff(14) - eff(13))/(thresh(14)-thresh(13))
        b = eff(13) - m*thresh(13)
      elseif ((distance.ge.thresh(14)).and.
     &       (distance.le.thresh(15))) then
        m = (eff(15) - eff(14))/(thresh(15)-thresh(14))
        b = eff(14) - m*thresh(14)
      elseif ((distance.ge.thresh(15)).and.
     &       (distance.le.thresh(16))) then
        m = (eff(16) - eff(15))/(thresh(16)-thresh(15))
        b = eff(15) - m*thresh(15)
      elseif ((distance.ge.thresh(16)).and.
     &       (distance.le.thresh(17))) then
        m = (eff(17) - eff(16))/(thresh(17)-thresh(16))
        b = eff(16) - m*thresh(16)
      elseif ((distance.ge.thresh(17)).and.
     &       (distance.le.thresh(18))) then
        m = (eff(18) - eff(17))/(thresh(18)-thresh(17))
        b = eff(17) - m*thresh(17)
      elseif ((distance.ge.thresh(18)).and.
     &       (distance.le.thresh(19))) then
        m = (eff(19) - eff(18))/(thresh(19)-thresh(18))
        b = eff(18) - m*thresh(18)
      elseif ((distance.ge.thresh(19)).and.
     &       (distance.le.thresh(20))) then
        m = (eff(20) - eff(19))/(thresh(20)-thresh(19))
        b = eff(19) - m*thresh(19)
      elseif ((distance.ge.thresh(20)).and.
     &       (distance.le.thresh(21))) then
        m = (eff(21) - eff(20))/(thresh(21)-thresh(20))
        b = eff(20) - m*thresh(20)
      elseif ((distance.ge.thresh(21)).and.
     &       (distance.le.thresh(22))) then
        m = (eff(22) - eff(21))/(thresh(22)-thresh(21))
        b = eff(21) - m*thresh(21)
      endif

      a2000_hll_sig_sys_tt = m*distance + b
      
      return
      end


