C-*-FORTRAN-*-
c-------------------------------------------------------------------------
c Flavour blind search
c-------------------------------------------------------------------------
C
c
c Total branching fraction of Higgs into hadrons:
      brh = bhbb + bhcc + bhss + bhglgl
c
C For testing purposes ONLY, can activate the h->hadrons BR by hand:
C
      if (.TRUE.) then
       brh = 1.0
       write (6,*) '+------------------------------------------------+'
       write (6,*) '| Flavour-blind Higgs search / ALEPH             |'
       write (6,*) '| WARNING! For TESTing purposes only,            |'
       write (6,*) '|          you have activated the h->hadrons BR  |'
       write (6,*) '|          by hand: BR(h->hadrons) = ' , brh   
       write (6,*) '| BEWARE! This option should usually be OFF!     |'
       write (6,*) '+------------------------------------------------+'
      end if
c
      amass = xmass(1)          ! Standard Model Higgs boson mass
c
      If (amass.lt.60.) GOTO 562
      If (firstind) then
        firstind = .FALSE.
c Channels definitions
        switchind(1) = .false.     ! Check counting only
        switchind(2) = .false.     ! Check with one discriminating variable
c 4jets channels
        switchind(3) = .true.     ! 4jets_flavind_189
        switchind(4) = .true.     ! 4jets_flavind_192
        switchind(5) = .true.     ! 4jets_flavind_196
        switchind(6) = .true.     ! 4jets_flavind_200
        switchind(7) = .true.     ! 4jets_flavind_202
        switchind(8) = .true.     ! 4jets_flavind_201.3 - y2k
        switchind(9) = .true.     ! 4jets_flavind_204.0 - y2k
        switchind(10) = .true.    ! 4jets_flavind_205.0 - y2k
        switchind(11) = .true.    ! 4jets_flavind_205.8 - y2k
        switchind(12) = .true.    ! 4jets_flavind_206.5 - y2k
        switchind(13) = .true.    ! 4jets_flavind_207.3 - y2k
        switchind(14) = .true.    ! 4jets_flavind_208.2 - y2k
        switchind(15) = .false.    ! 4jets_flavind_189-208.2 - All ecms 
c hvv channels
        switchind(16) = .true.     ! hvv_flavind_189
        switchind(17) = .true.     ! hvv_flavind_192
        switchind(18) = .true.     ! hvv_flavind_196
        switchind(19) = .true.     ! hvv_flavind_200
        switchind(20) = .true.  ! hvv_flavind_202
        switchind(21) = .false. ! hvv_flavind_189-202
c 4jets-hvv sliding :
c 4jets 189-208.2
c hvv   189-202
        switchind(22) = .false.    ! 4jets_flavind_189-208.2_and_hvv_189-202
c hvv y2k energies
        switchind(23) = .true.    ! hvv_flavind_201.3 - y2k
        switchind(24) = .true.    ! hvv_flavind_204.0 - y2k
        switchind(25) = .true.    ! hvv_flavind_205.0 - y2k
        switchind(26) = .true.    ! hvv_flavind_205.8 - y2k
        switchind(27) = .true.    ! hvv_flavind_206.5 - y2k
        switchind(28) = .true.    ! hvv_flavind_207.3 - y2k
        switchind(29) = .true.    ! hvv_flavind_208.2 - y2k
c hll channels
        switchind(30) = .true.    ! hll_flavind_189
        switchind(31) = .true.    ! hll_flavind_192
        switchind(32) = .true.    ! hll_flavind_196
        switchind(33) = .true.    ! hll_flavind_200
        switchind(34) = .true.    ! hll_flavind_202
c hll y2k energies
        switchind(35) = .true.    ! hll_flavind_201.3 - y2k
        switchind(36) = .true.    ! hll_flavind_204.0 - y2k
        switchind(37) = .true.    ! hll_flavind_205.0 - y2k
        switchind(38) = .true.    ! hll_flavind_205.8 - y2k
        switchind(39) = .true.    ! hll_flavind_206.5 - y2k
        switchind(40) = .true.    ! hll_flavind_207.3 - y2k
        switchind(41) = .true.    ! hll_flavind_208.2 - y2k
c
        ECM(1) = 201.3
        ECM(2) = 204.0
        ECM(3) = 205.0
        ECM(4) = 205.8
        ECM(5) = 206.5
        ECM(6) = 207.3
        ECM(7) = 208.2
        ECM(8) = 209.0
c
      Endif
c
      If (switchind(3)) then
c 4jets_flavind_189
c channel3
        nchan = nchan + 1
        Call CheckNchan(nchan,a_maxnchan)
        channame(nchan) = 'ALEPH flavour ind 4jets 189'
        chanlumi(nchan) = ah0_lumi(2)
	if (dbg_flavind) write (6,561) nchan,channame(nchan),chanlumi(nchan)
        xhzind = xsec(1,15)        ! cross section hz, 188.6GeV
        xbr = brh*zthad         ! Branching ratio of the Higgs * Z in quarks
        eff = A189_HGG_EFF(amass,.false.)
        nsig = eff*xbr*xhzind*ah0_lumi(2) ! Expected signal
        nbkg = A189_HGG_BACKG(amass,1,.false.)
        nobs = A189_HGG_CAND(amass,1,warning) ! .true. to write warning
c Systematics
        nerrch(nchan) = 2
        sysname(1,nchan) = 'ALEPH 4jets 189 Signal'
        sysname(2,nchan) = 'ALEPH 4jets 189 Background'
        if (nsig.ne.0.) then
          dsig(1,nchan) = A189_HGG_EFF(amass,.true.)**2
          dback(2,nchan) = A189_HGG_BACKG(amass,1,.true.)**2
          dsig(1,nchan) = dsig(1,nchan) + 0.08**2
          dback(2,nchan)= dback(2,nchan) + 0.13**2
          dsig(1,nchan) = sqrt(dsig(1,nchan))
          dback(2,nchan) = sqrt(dback(2,nchan))
        Endif
c
        sig(nbins+1)      = nsig
        backg(nbins+1)    = nbkg ! bruit de fond que l''on soustrait
        backw(nbins+1)    = nbkg ! bruit de fond total
        ncand(nbins+1)    = nobs
c
        ifirst(nchan) = nbins + 1
        nbins = nbins + 1
        Call CheckNbins(nbins,a_maxnbin)
      Endif
      If (switchind(4)) then
c 4jets_flavind_192
c channel4
        nchan = nchan + 1
        Call CheckNchan(nchan,a_maxnchan)
        channame(nchan) = 'ALEPH flavour ind 4jets 192'
        chanlumi(nchan) = ah0_lumi(3)
	if (dbg_flavind) write (6,561) nchan,channame(nchan),chanlumi(nchan)
        xhzind = xsec(1,16)        ! cross section hz, 191.6GeV
        xbr = brh*zthad         ! Branching ratio of the Higgs * Z in quarks
        eff = A192_HGG_EFF(amass,.false.)
        nsig = eff*xbr*xhzind*ah0_lumi(3) ! Expected signal
        nbkg = A192_HGG_BACKG(amass,1,.false.)
        nobs = A192_HGG_CAND(amass,1,warning) ! .true. to write warning
c Systematics
        nerrch(nchan) = 2
        sysname(1,nchan) = 'ALEPH 4jets 192 Signal'
        sysname(2,nchan) = 'ALEPH 4jets 192 Background'
        if (nsig.ne.0.) then
          dsig(1,nchan) = A192_HGG_EFF(amass,.true.)**2
          dback(2,nchan) = A192_HGG_BACKG(amass,1,.true.)**2
          dsig(1,nchan) = dsig(1,nchan) + 0.08**2
          dback(2,nchan)= dback(2,nchan) + 0.13**2
          dsig(1,nchan) = sqrt(dsig(1,nchan))
          dback(2,nchan) = sqrt(dback(2,nchan))
        Endif
c
        sig(nbins+1)      = nsig
        backg(nbins+1)    = nbkg ! bruit de fond que l''on soustrait
        backw(nbins+1)    = nbkg ! bruit de fond total
        ncand(nbins+1)    = nobs
c
        ifirst(nchan) = nbins + 1
        nbins = nbins + 1
        Call CheckNbins(nbins,a_maxnbin)
      Endif
      If (switchind(5)) then
c 4jets_flavind_196
c channel5
        nchan = nchan + 1
        Call CheckNchan(nchan,a_maxnchan)
        channame(nchan) = 'ALEPH flavour ind 4jets 196'
        chanlumi(nchan) = ah0_lumi(4)
	if (dbg_flavind) write (6,561) nchan,channame(nchan),chanlumi(nchan)
        xhzind = xsec(1,17)        ! cross section hz, 195.5GeV
        xbr = brh*zthad         ! Branching ratio of the Higgs * Z in quarks
        eff = A196_HGG_EFF(amass,.false.)
        nsig = eff*xbr*xhzind*ah0_lumi(4) ! Expected signal
        nbkg = A196_HGG_BACKG(amass,1,.false.)
        nobs = A196_HGG_CAND(amass,1,warning) ! .true. to write warning
c Systematics
        nerrch(nchan) = 2
        sysname(1,nchan) = 'ALEPH 4jets 196 Signal'
        sysname(2,nchan) = 'ALEPH 4jets 196 Background'
        if (nsig.ne.0.) then
          dsig(1,nchan) = A196_HGG_EFF(amass,.true.)**2
          dback(2,nchan) = A196_HGG_BACKG(amass,1,.true.)**2
          dsig(1,nchan) = dsig(1,nchan) + 0.08**2
          dback(2,nchan)= dback(2,nchan) + 0.13**2
          dsig(1,nchan) = sqrt(dsig(1,nchan))
          dback(2,nchan) = sqrt(dback(2,nchan))
        Endif
c
        sig(nbins+1)      = nsig
        backg(nbins+1)    = nbkg ! bruit de fond que l''on soustrait
        backw(nbins+1)    = nbkg ! bruit de fond total
        ncand(nbins+1)    = nobs
c
        ifirst(nchan) = nbins + 1
        nbins = nbins + 1
        Call CheckNbins(nbins,a_maxnbin)
      Endif
      If (switchind(6)) then
c 4jets_flavind_200
c channel6
        nchan = nchan + 1
        Call CheckNchan(nchan,a_maxnchan)
        channame(nchan) = 'ALEPH flavour ind 4jets 200'
        chanlumi(nchan) = ah0_lumi(5)
	if (dbg_flavind) write (6,561) nchan,channame(nchan),chanlumi(nchan)
        xhzind = xsec(1,18)        ! cross section hz, 199.5GeV
        xbr = brh*zthad         ! Branching ratio of the Higgs * Z in quarks
        eff = A200_HGG_EFF(amass,.false.)
        nsig = eff*xbr*xhzind*ah0_lumi(5) ! Expected signal
        nbkg = A200_HGG_BACKG(amass,1,.false.)
        nobs = A200_HGG_CAND(amass,1,warning) ! .true. to write warning
c Systematics
        nerrch(nchan) = 2
        sysname(1,nchan) = 'ALEPH 4jets 200 Signal'
        sysname(2,nchan) = 'ALEPH 4jets 200 Background'
        if (nsig.ne.0.) then
          dsig(1,nchan) = A200_HGG_EFF(amass,.true.)**2
          dback(2,nchan) = A200_HGG_BACKG(amass,1,.true.)**2
          dsig(1,nchan) = dsig(1,nchan) + 0.08**2
          dback(2,nchan)= dback(2,nchan) + 0.13**2
          dsig(1,nchan) = sqrt(dsig(1,nchan))
          dback(2,nchan) = sqrt(dback(2,nchan))
        Endif
c
        sig(nbins+1)      = nsig
        backg(nbins+1)    = nbkg ! bruit de fond que l''on soustrait
        backw(nbins+1)    = nbkg ! bruit de fond total
        ncand(nbins+1)    = nobs
c
        ifirst(nchan) = nbins + 1
        nbins = nbins + 1
        Call CheckNbins(nbins,a_maxnbin)
      Endif
      If (switchind(7)) then
c 4jets_flavind_202
c channel7
        nchan = nchan + 1
        Call CheckNchan(nchan,a_maxnchan)
        channame(nchan) = 'ALEPH flavour ind 4jets 202'
        chanlumi(nchan) = ah0_lumi(6)
	if (dbg_flavind) write (6,561) nchan,channame(nchan),chanlumi(nchan)
        xhzind = xsec(1,19)        ! cross section hz, 201.6GeV
        xbr = brh*zthad         ! Branching ratio of the Higgs * Z in quarks
        eff = A202_HGG_EFF(amass,.false.)
        nsig = eff*xbr*xhzind*ah0_lumi(6) ! Expected signal
        nbkg = A202_HGG_BACKG(amass,1,.false.)
        nobs = A202_HGG_CAND(amass,1,warning) ! .true. to write warning
c Systematics
        nerrch(nchan) = 2
        sysname(1,nchan) = 'ALEPH 4jets 202 Signal'
        sysname(2,nchan) = 'ALEPH 4jets 202 Background'
        if (nsig.ne.0.) then
          dsig(1,nchan) = A202_HGG_EFF(amass,.true.)**2
          dback(2,nchan) = A202_HGG_BACKG(amass,1,.true.)**2
          dsig(1,nchan) = dsig(1,nchan) + 0.08**2
          dback(2,nchan)= dback(2,nchan) + 0.13**2
          dsig(1,nchan) = sqrt(dsig(1,nchan))
          dback(2,nchan) = sqrt(dback(2,nchan))
        Endif
c
        sig(nbins+1)      = nsig
        backg(nbins+1)    = nbkg ! bruit de fond que l''on soustrait
        backw(nbins+1)    = nbkg ! bruit de fond total
        ncand(nbins+1)    = nobs
c
        ifirst(nchan) = nbins + 1
        nbins = nbins + 1
        Call CheckNbins(nbins,a_maxnbin)
      Endif
c channel8-14
      do 34 iebin = 1,n_ebins_2000-1 ! 1 canal pour chaque bin d''energie
        If (.not. switchind(7+iebin)) goto 34
        nchan = nchan + 1
        Call CheckNchan(nchan,a_maxnchan)
        channame(nchan) = 
     &       'ALEPH flavour ind 4jets '//ename(iebin)
        chanlumi(nchan) = lumi_in_bin(iebin)
	if (dbg_flavind) write (6,561) nchan,channame(nchan),chanlumi(nchan)
        xhzind = XSEC_INTERP(1,xsec,ecm(iebin)) ! cross section hz, 201.3GeV
        xbr = brh*zthad         ! Branching ratio of the Higgs * Z in quarks
        eff = A2000_HGG_EFF(amass,ecm(iebin),1,.false.)
        nsig = eff*xbr*xhzind*lumi_in_bin(iebin) ! Expected signal
        nbkg = A2000_HGG_BACKG(amass,ecm(iebin),1,.false.) ! Expected background
     &       *lumi_in_bin(iebin) 
        nobs = A2000_HGG_CAND(amass,iebin,warning) ! .true. to write warning
c Systematics
        nerrch(nchan) = 2
        sysname(1,nchan) = 'ALEPH 4jets '//ename(iebin)//' Signal'
        sysname(2,nchan) = 'ALEPH 4jets '//ename(iebin)//' Background'
        if (nsig.ne.0.) then
          dsig(1,nchan) = A2000_HGG_EFF(amass,ecm(iebin),1,.true.)**2
          dback(2,nchan) = A2000_HGG_BACKG(amass,ecm(iebin),1,.true.)**2
          dsig(1,nchan) = dsig(1,nchan) + 0.08**2
          dback(2,nchan)= dback(2,nchan) + 0.13**2
          dsig(1,nchan) = sqrt(dsig(1,nchan))
          dback(2,nchan) = sqrt(dback(2,nchan))
        Endif
c
        sig(nbins+1)      = nsig
        backg(nbins+1)    = nbkg ! bruit de fond que l''on soustrait
        backw(nbins+1)    = nbkg ! bruit de fond total
        ncand(nbins+1)    = nobs
c
        ifirst(nchan) = nbins + 1
        nbins = nbins + 1
        Call CheckNbins(nbins,a_maxnbin)
 34   continue
      If (switchind(15)) then
c 4jets_flavind_189-208.2 - All energies
c channel15
        nchan = nchan + 1
        Call CheckNchan(nchan,a_maxnchan)
        channame(nchan) =
     &'ALEPH flavour ind 4jets 189-208.2'
        chanlumi(nchan) = 0.
	if (dbg_flavind) write (6,561) nchan,channame(nchan),chanlumi(nchan)
        xbr = brh*zthad         ! Branching ratio of the Higgs * Z in quarks
        nsigtot = 0.
        nbkgtot = 0.
        nobs = 0
c Systematics
        esig = 0.
        ebkg = 0.
        nerrch(nchan) = 2
        sysname(1,nchan) = 'ALEPH 4jets 189-208.2 Signal'
        sysname(2,nchan) = 'ALEPH 4jets 189-208.2 Background'
c 
        chanlumi(nchan) = chanlumi(nchan) + ah0_lumi(2)
        xhzind = xsec(1,15)        ! cross section hz, 188.6GeV
        eff = A189_HGG_EFF(amass,.false.)
        nsig = eff*xbr*xhzind*ah0_lumi(2) ! Expected signal
        nbkg = A189_HGG_BACKG(amass,1,.false.)
        nobs = nobs + A189_HGG_CAND(amass,1,warning) ! .true. to write warning
        esig = esig + (A189_HGG_EFF(amass,.true.)*nsig)**2
        ebkg = ebkg + (A189_HGG_BACKG(amass,1,.true.)*nbkg)**2
        esig = esig + (nsig*0.08)**2
        ebkg = ebkg + (nbkg*0.13)**2
        nsigtot = nsigtot + nsig
        nbkgtot = nbkgtot + nbkg
c
        chanlumi(nchan) = chanlumi(nchan) + ah0_lumi(3)
        xhzind = xsec(1,16)        ! cross section hz, 191.6GeV
        xbr = brh*zthad         ! Branching ratio of the Higgs * Z in quarks
        eff = A192_HGG_EFF(amass,.false.)
        nsig = eff*xbr*xhzind*ah0_lumi(3) ! Expected signal
        nbkg = A192_HGG_BACKG(amass,1,.false.)
        nobs = nobs + A192_HGG_CAND(amass,1,warning) ! .true. to write warning
        esig = esig + (A192_HGG_EFF(amass,.true.)*nsig)**2
        ebkg = ebkg + (A192_HGG_BACKG(amass,1,.true.)*nbkg)**2
        esig = esig + (nsig*0.08)**2
        ebkg = ebkg + (nbkg*0.13)**2
        nsigtot = nsigtot + nsig
        nbkgtot = nbkgtot + nbkg
c
        chanlumi(nchan) = chanlumi(nchan) + ah0_lumi(4)
        xhzind = xsec(1,17)        ! cross section hz, 195.5GeV
        xbr = brh*zthad         ! Branching ratio of the Higgs * Z in quarks
        eff = A196_HGG_EFF(amass,.false.)
        nsig = eff*xbr*xhzind*ah0_lumi(4) ! Expected signal
        nbkg = A196_HGG_BACKG(amass,1,.false.)
        nobs = nobs + A196_HGG_CAND(amass,1,warning) ! .true. to write warning
        esig = esig + (A196_HGG_EFF(amass,.true.)*nsig)**2
        ebkg = ebkg + (A196_HGG_BACKG(amass,1,.true.)*nbkg)**2
        esig = esig + (nsig*0.08)**2
        ebkg = ebkg + (nbkg*0.13)**2
        nsigtot = nsigtot + nsig
        nbkgtot = nbkgtot + nbkg
c
        chanlumi(nchan) = chanlumi(nchan) + ah0_lumi(5)
        xhzind = xsec(1,18)        ! cross section hz, 199.5GeV
        xbr = brh*zthad         ! Branching ratio of the Higgs * Z in quarks
        eff = A200_HGG_EFF(amass,.false.)
        nsig = eff*xbr*xhzind*ah0_lumi(5) ! Expected signal
        nbkg = A200_HGG_BACKG(amass,1,.false.)
        nobs = nobs + A200_HGG_CAND(amass,1,warning) ! .true. to write warning
        esig = esig + (A200_HGG_EFF(amass,.true.)*nsig)**2
        ebkg = ebkg + (A200_HGG_BACKG(amass,1,.true.)*nbkg)**2
        esig = esig + (nsig*0.08)**2
        ebkg = ebkg + (nbkg*0.13)**2
        nsigtot = nsigtot + nsig
        nbkgtot = nbkgtot + nbkg
c
        chanlumi(nchan) = chanlumi(nchan) + ah0_lumi(6)
        xhzind = xsec(1,19)        ! cross section hz, 201.6GeV
        xbr = brh*zthad         ! Branching ratio of the Higgs * Z in quarks
        eff = A202_HGG_EFF(amass,.false.)
        nsig = eff*xbr*xhzind*ah0_lumi(6) ! Expected signal
        nbkg = A202_HGG_BACKG(amass,1,.false.)
        nobs = nobs + A202_HGG_CAND(amass,1,warning) ! .true. to write warning
        esig = esig + (A202_HGG_EFF(amass,.true.)*nsig)**2
        ebkg = ebkg + (A202_HGG_BACKG(amass,1,.true.)*nbkg)**2
        esig = esig + (nsig*0.08)**2
        ebkg = ebkg + (nbkg*0.13)**2
        nsigtot = nsigtot + nsig
        nbkgtot = nbkgtot + nbkg
c
        do iebin=1,n_ebins_2000-1
          chanlumi(nchan) = chanlumi(nchan) + lumi_in_bin(iebin)
          xhzind = XSEC_INTERP(1,xsec,ecm(iebin)) ! cross section hz, 201.3GeV
          xbr = brh*zthad       ! Branching ratio of the Higgs * Z in quarks
          eff = A2000_HGG_EFF(amass,ecm(iebin),1,.false.)
          nsig = eff*xbr*xhzind*lumi_in_bin(iebin) ! Expected signal
          nbkg = A2000_HGG_BACKG(amass,ecm(iebin),1,.false.) ! Expected background
     &         *lumi_in_bin(iebin) 
          nobs = nobs + A2000_HGG_CAND(amass,iebin,warning) ! .true. to write warning
          esig = esig + (A2000_HGG_EFF(amass,ecm(iebin),1,.true.)*nsig)
     &         **2
          ebkg = ebkg + (A2000_HGG_BACKG(amass,ecm(iebin),1,.true.)*nbkg
     &         )**2
          esig = esig + (nsig*0.08)**2
          ebkg = ebkg + (nbkg*0.13)**2
          nsigtot = nsigtot + nsig
          nbkgtot = nbkgtot + nbkg
        Enddo
c
        sig(nbins+1)      = nsigtot
        backg(nbins+1)    = nbkgtot ! bruit de fond que l''on soustrait
        backw(nbins+1)    = nbkgtot ! bruit de fond total
        ncand(nbins+1)    = nobs
        If (nsigtot.ne.0.) dsig(1,nchan)  = sqrt(esig)/nsigtot
        If (nbkgtot.ne.0.) dback(2,nchan) = sqrt(ebkg)/nbkgtot
c
        ifirst(nchan) = nbins + 1
        nbins = nbins + 1
        Call CheckNbins(nbins,a_maxnbin)
      Endif
      If (switchind(16)) then
c hvv_flavind_189
c channel16
        nchan = nchan + 1
        Call CheckNchan(nchan,a_maxnchan)
        channame(nchan) = 'ALEPH flavour ind hnn 189'
        chanlumi(nchan) = ah0_lumi(2)
	if (dbg_flavind) write (6,561) nchan,channame(nchan),chanlumi(nchan)
        xhzind = xsec(1,15)        ! cross section hz, 188.6GeV
        xbr = brh*znunu         ! Branching ratio of the Higgs * Z in neutrinos
        eff = A189_HVV_HGG_EFF(amass)
        nsig = eff*xbr*xhzind*ah0_lumi(2) ! Expected signal
        nbkg = A189_HVV_HGG_BACKG(amass)
        nobs = A189_HVV_HGG_CAND(amass,warning)
c Systematics
        nerrch(nchan) = 2
        sysname(1,nchan) = 'ALEPH hvv 189 Signal'
        sysname(2,nchan) = 'ALEPH hvv 189 Background'
        if (nsig.ne.0.) then
          dsig(1,nchan)  = 0.05
          dback(2,nchan) = 0.10
        Endif
c
        sig(nbins+1)      = nsig
        backg(nbins+1)    = nbkg ! bruit de fond que l''on soustrait
        backw(nbins+1)    = nbkg ! bruit de fond total
        ncand(nbins+1)    = nobs
c
        ifirst(nchan) = nbins + 1
        nbins = nbins + 1
        Call CheckNbins(nbins,a_maxnbin)
      Endif
      If (switchind(17)) then
c hvv_flavind_192
c channel17
        nchan = nchan + 1
        Call CheckNchan(nchan,a_maxnchan)
        channame(nchan) = 'ALEPH flavour ind hnn 192'
        chanlumi(nchan) = ah0_lumi(3)
	if (dbg_flavind) write (6,561) nchan,channame(nchan),chanlumi(nchan)
        xhzind = xsec(1,16)        ! cross section hz, 188.6GeV
        xbr = brh*znunu         ! Branching ratio of the Higgs * Z in neutrinos
        eff = A192_HVV_HGG_EFF(amass)
        nsig = eff*xbr*xhzind*ah0_lumi(3) ! Expected signal
        nbkg = A192_HVV_HGG_BACKG(amass)
        nobs = A192_HVV_HGG_CAND(amass,warning)
c Systematics
        nerrch(nchan) = 2
        sysname(1,nchan) = 'ALEPH hvv 192 Signal'
        sysname(2,nchan) = 'ALEPH hvv 192 Background'
        if (nsig.ne.0.) then
          dsig(1,nchan)  = 0.05
          dback(2,nchan) = 0.10
        Endif
c
        sig(nbins+1)      = nsig
        backg(nbins+1)    = nbkg ! bruit de fond que l''on soustrait
        backw(nbins+1)    = nbkg ! bruit de fond total
        ncand(nbins+1)    = nobs
c
        ifirst(nchan) = nbins + 1
        nbins = nbins + 1
        Call CheckNbins(nbins,a_maxnbin)
      Endif
      If (switchind(18)) then
c hvv_flavind_196
c channel18
        nchan = nchan + 1
        Call CheckNchan(nchan,a_maxnchan)
        channame(nchan) = 'ALEPH flavour ind hnn 196'
        chanlumi(nchan) = ah0_lumi(4)
	if (dbg_flavind) write (6,561) nchan,channame(nchan),chanlumi(nchan)
        xhzind = xsec(1,17)        ! cross section hz, 195.5GeV
        xbr = brh*znunu         ! Branching ratio of the Higgs * Z in neutrinos
        eff = A196_HVV_HGG_EFF(amass)
        nsig = eff*xbr*xhzind*ah0_lumi(4) ! Expected signal
        nbkg = A196_HVV_HGG_BACKG(amass)
        nobs = A196_HVV_HGG_CAND(amass,warning)
c Systematics
        nerrch(nchan) = 2
        sysname(1,nchan) = 'ALEPH hvv 196 Signal'
        sysname(2,nchan) = 'ALEPH hvv 196 Background'
        if (nsig.ne.0.) then
          dsig(1,nchan)  = 0.05
          dback(2,nchan) = 0.10
        Endif
c
        sig(nbins+1)      = nsig
        backg(nbins+1)    = nbkg ! bruit de fond que l''on soustrait
        backw(nbins+1)    = nbkg ! bruit de fond total
        ncand(nbins+1)    = nobs
c
        ifirst(nchan) = nbins + 1
        nbins = nbins + 1
        Call CheckNbins(nbins,a_maxnbin)
      Endif
      If (switchind(19)) then
c hvv_flavind_200
c channel19
        nchan = nchan + 1
        Call CheckNchan(nchan,a_maxnchan)
        channame(nchan) = 'ALEPH flavour ind hnn 200'
        chanlumi(nchan) = ah0_lumi(5)
	if (dbg_flavind) write (6,561) nchan,channame(nchan),chanlumi(nchan)
        xhzind = xsec(1,18)        ! cross section hz, 199.5GeV
        xbr = brh*znunu         ! Branching ratio of the Higgs * Z in neutrinos
        eff = A200_HVV_HGG_EFF(amass)
        nsig = eff*xbr*xhzind*ah0_lumi(5) ! Expected signal
        nbkg = A200_HVV_HGG_BACKG(amass)
        nobs = A200_HVV_HGG_CAND(amass,warning)
c Systematics
        nerrch(nchan) = 2
        sysname(1,nchan) = 'ALEPH hvv 200 Signal'
        sysname(2,nchan) = 'ALEPH hvv 200 Background'
        if (nsig.ne.0.) then
          dsig(1,nchan)  = 0.05
          dback(2,nchan) = 0.10
        Endif
c
        sig(nbins+1)      = nsig
        backg(nbins+1)    = nbkg ! bruit de fond que l''on soustrait
        backw(nbins+1)    = nbkg ! bruit de fond total
        ncand(nbins+1)    = nobs
c
        ifirst(nchan) = nbins + 1
        nbins = nbins + 1
        Call CheckNbins(nbins,a_maxnbin)
      Endif
      If (switchind(20)) then
c hvv_flavind_202
c channel20
        nchan = nchan + 1
        Call CheckNchan(nchan,a_maxnchan)
        channame(nchan) = 'ALEPH flavour ind hnn 202'
        chanlumi(nchan) = ah0_lumi(6)
	if (dbg_flavind) write (6,561) nchan,channame(nchan),chanlumi(nchan)
        xhzind = xsec(1,19)        ! cross section hz, 201.6GeV
        xbr = brh*znunu         ! Branching ratio of the Higgs * Z in neutrinos
        eff = A202_HVV_HGG_EFF(amass)
        nsig = eff*xbr*xhzind*ah0_lumi(6) ! Expected signal
        nbkg = A202_HVV_HGG_BACKG(amass)
        nobs = A202_HVV_HGG_CAND(amass,warning)
c Systematics
        nerrch(nchan) = 2
        sysname(1,nchan) = 'ALEPH hvv 202 Signal'
        sysname(2,nchan) = 'ALEPH hvv 202 Background'
        if (nsig.ne.0.) then
          dsig(1,nchan)  = 0.05
          dback(2,nchan) = 0.10
        Endif
c
        sig(nbins+1)      = nsig
        backg(nbins+1)    = nbkg ! bruit de fond que l''on soustrait
        backw(nbins+1)    = nbkg ! bruit de fond total
        ncand(nbins+1)    = nobs
c
        ifirst(nchan) = nbins + 1
        nbins = nbins + 1
        Call CheckNbins(nbins,a_maxnbin)
      Endif
      If (switchind(21)) then
c hvv_flavind_189-202
c channel21
        nchan = nchan + 1
        Call CheckNchan(nchan,a_maxnchan)
        channame(nchan) = 'ALEPH flavour ind hnn 189-202'
        chanlumi(nchan) = 0.
	if (dbg_flavind) write (6,561) nchan,channame(nchan),chanlumi(nchan)
        xbr = brh*zthad         ! Branching ratio of the Higgs * Z in quarks
        nsigtot = 0.
        nbkgtot = 0.
        nobs = 0
        esig = 0.
        ebkg = 0.
c Systematics
        nerrch(nchan) = 2
        sysname(1,nchan) = 'ALEPH hvv 189-202 Signal'
        sysname(2,nchan) = 'ALEPH hvv 189-202 Background'
c
        chanlumi(nchan) = chanlumi(nchan) + ah0_lumi(2)
        xhzind = xsec(1,15)        ! cross section hz, 188.6GeV
        xbr = brh*znunu         ! Branching ratio of the Higgs * Z in neutrinos
        eff = A189_HVV_HGG_EFF(amass)
        If (eff.gt.0.) then
          nsig = eff*xbr*xhzind*ah0_lumi(2) ! Expected signal
          nbkg = A189_HVV_HGG_BACKG(amass)
          nobs = nobs + A189_HVV_HGG_CAND(amass,warning)
          nsigtot = nsigtot + nsig
          nbkgtot = nbkgtot + nbkg
          esig = esig + (nsig*0.05)**2
          ebkg = ebkg + (nbkg*0.10)**2
        Endif
c
        chanlumi(nchan) = chanlumi(nchan) + ah0_lumi(3)
        xhzind = xsec(1,16)        ! cross section hz, 191.5GeV
        xbr = brh*znunu         ! Branching ratio of the Higgs * Z in neutrinos
        eff = A192_HVV_HGG_EFF(amass)
        If (eff.gt.0.) then
          nsig = eff*xbr*xhzind*ah0_lumi(3) ! Expected signal
          nbkg = A192_HVV_HGG_BACKG(amass)
          nobs = nobs + A192_HVV_HGG_CAND(amass,warning)
          nsigtot = nsigtot + nsig
          nbkgtot = nbkgtot + nbkg
          esig = esig + (nsig*0.05)**2
          ebkg = ebkg + (nbkg*0.10)**2
        Endif
c
        chanlumi(nchan) = chanlumi(nchan) + ah0_lumi(4)
        xhzind = xsec(1,17)        ! cross section hz, 195.5GeV
        xbr = brh*znunu         ! Branching ratio of the Higgs * Z in neutrinos
        eff = A196_HVV_HGG_EFF(amass)
        If (eff.gt.0.) then
          nsig = eff*xbr*xhzind*ah0_lumi(4) ! Expected signal
          nbkg = A196_HVV_HGG_BACKG(amass)
          nobs = nobs + A196_HVV_HGG_CAND(amass,warning)
          nsigtot = nsigtot + nsig
          nbkgtot = nbkgtot + nbkg
          esig = esig + (nsig*0.05)**2
          ebkg = ebkg + (nbkg*0.10)**2
        Endif
c
        chanlumi(nchan) = chanlumi(nchan) + ah0_lumi(5)
        xhzind = xsec(1,18)        ! cross section hz, 199.5GeV
        xbr = brh*znunu         ! Branching ratio of the Higgs * Z in neutrinos
        eff = A200_HVV_HGG_EFF(amass)
        If (eff.gt.0.) then
          nsig = eff*xbr*xhzind*ah0_lumi(5) ! Expected signal
          nbkg = A200_HVV_HGG_BACKG(amass)
          nobs = nobs + A200_HVV_HGG_CAND(amass,warning)
          nsigtot = nsigtot + nsig
          nbkgtot = nbkgtot + nbkg
          esig = esig + (nsig*0.05)**2
          ebkg = ebkg + (nbkg*0.10)**2
        Endif
c
        chanlumi(nchan) = chanlumi(nchan) + ah0_lumi(6)
        xhzind = xsec(1,19)        ! cross section hz, 201.6GeV
        xbr = brh*znunu         ! Branching ratio of the Higgs * Z in neutrinos
        eff = A202_HVV_HGG_EFF(amass)
        If (eff.gt.0.) then
          nsig = eff*xbr*xhzind*ah0_lumi(6) ! Expected signal
          nbkg = A202_HVV_HGG_BACKG(amass)
          nobs = nobs + A202_HVV_HGG_CAND(amass,warning)
          nsigtot = nsigtot + nsig
          nbkgtot = nbkgtot + nbkg
          esig = esig + (nsig*0.05)**2
          ebkg = ebkg + (nbkg*0.10)**2
        Endif
c
        sig(nbins+1)      = nsigtot
        backg(nbins+1)    = nbkgtot ! bruit de fond que l''on soustrait
        backw(nbins+1)    = nbkgtot ! bruit de fond total
        ncand(nbins+1)    = nobs
        If (nsigtot.ne.0.) dsig(1,nchan)  = sqrt(esig)/nsigtot
        If (nbkgtot.ne.0.) dback(2,nchan) = sqrt(ebkg)/nbkgtot
c
        ifirst(nchan) = nbins + 1
        nbins = nbins + 1
        Call CheckNbins(nbins,a_maxnbin)
      Endif
      If (switchind(22)) then
c 4jets_flavind_189-208.2 - All energies
c hvv_flavind_189-202
c channel22
        nchan = nchan + 1
        Call CheckNchan(nchan,a_maxnchan)
        channame(nchan) =
     &       'ALEPH flavour ind 4jets_189-208.2 '//
     &       'hnn_189-202'
        chanlumi(nchan) = -1.
	if (dbg_flavind) write (6,561) nchan,channame(nchan),chanlumi(nchan)
        xbr = brh*zthad         ! Branching ratio of the Higgs * Z in quarks
        nsig = 0.
        nbkg = 0.
        nobs = 0
        nsigtot = 0.
        nbkgtot = 0.
        esig = 0.
        ebkg = 0.
c Systematics
        nerrch(nchan) = 2
        sysname(1,nchan) = 'ALEPH 4jets(189-210)-hvv(189-202) Signal'
        sysname(2,nchan) ='ALEPH 4jets(189-210)-hvv(189-202) Background'
c 4jets
        xhzind = xsec(1,15)        ! cross section hz, 188.6GeV
        eff = A189_HGG_EFF(amass,.false.)
        nsig = eff*xbr*xhzind*ah0_lumi(2) ! Expected signal
        nbkg = A189_HGG_BACKG(amass,1,.false.)
        nobs = nobs + A189_HGG_CAND(amass,1,warning) ! .true. to write warning
        esig = esig + (A189_HGG_EFF(amass,.true.)*nsig)**2
        ebkg = ebkg + (A189_HGG_BACKG(amass,1,.true.)*nbkg)**2
        esig = esig + (nsig*0.08)**2
        ebkg = ebkg + (nbkg*0.13)**2
        nsigtot = nsigtot + nsig
        nbkgtot = nbkgtot + nbkg
c
        xhzind = xsec(1,16)        ! cross section hz, 191.6GeV
        xbr = brh*zthad         ! Branching ratio of the Higgs * Z in quarks
        eff = A192_HGG_EFF(amass,.false.)
        nsig = eff*xbr*xhzind*ah0_lumi(3) ! Expected signal
        nbkg = A192_HGG_BACKG(amass,1,.false.)
        nobs = nobs + A192_HGG_CAND(amass,1,warning) ! .true. to write warning
        esig = esig + (A192_HGG_EFF(amass,.true.)*nsig)**2
        ebkg = ebkg + (A192_HGG_BACKG(amass,1,.true.)*nbkg)**2
        esig = esig + (nsig*0.08)**2
        ebkg = ebkg + (nbkg*0.13)**2
        nsigtot = nsigtot + nsig
        nbkgtot = nbkgtot + nbkg
c
        xhzind = xsec(1,17)        ! cross section hz, 195.5GeV
        xbr = brh*zthad         ! Branching ratio of the Higgs * Z in quarks
        eff = A196_HGG_EFF(amass,.false.)
        nsig = eff*xbr*xhzind*ah0_lumi(4) ! Expected signal
        nbkg = A196_HGG_BACKG(amass,1,.false.)
        nobs = nobs + A196_HGG_CAND(amass,1,warning) ! .true. to write warning
        esig = esig + (A196_HGG_EFF(amass,.true.)*nsig)**2
        ebkg = ebkg + (A196_HGG_BACKG(amass,1,.true.)*nbkg)**2
        esig = esig + (nsig*0.08)**2
        ebkg = ebkg + (nbkg*0.13)**2
        nsigtot = nsigtot + nsig
        nbkgtot = nbkgtot + nbkg
c
        xhzind = xsec(1,18)        ! cross section hz, 199.5GeV
        xbr = brh*zthad         ! Branching ratio of the Higgs * Z in quarks
        eff = A200_HGG_EFF(amass,.false.)
        nsig = eff*xbr*xhzind*ah0_lumi(5) ! Expected signal
        nbkg = A200_HGG_BACKG(amass,1,.false.)
        nobs = nobs + A200_HGG_CAND(amass,1,warning) ! .true. to write warning
        esig = esig + (A200_HGG_EFF(amass,.true.)*nsig)**2
        ebkg = ebkg + (A200_HGG_BACKG(amass,1,.true.)*nbkg)**2
        esig = esig + (nsig*0.08)**2
        ebkg = ebkg + (nbkg*0.13)**2
        nsigtot = nsigtot + nsig
        nbkgtot = nbkgtot + nbkg
c
        xhzind = xsec(1,19)        ! cross section hz, 201.6GeV
        xbr = brh*zthad         ! Branching ratio of the Higgs * Z in quarks
        eff = A202_HGG_EFF(amass,.false.)
        nsig = eff*xbr*xhzind*ah0_lumi(6) ! Expected signal
        nbkg = A202_HGG_BACKG(amass,1,.false.)
        nobs = nobs + A202_HGG_CAND(amass,1,warning) ! .true. to write warning
        esig = esig + (A202_HGG_EFF(amass,.true.)*nsig)**2
        ebkg = ebkg + (A202_HGG_BACKG(amass,1,.true.)*nbkg)**2
        esig = esig + (nsig*0.08)**2
        ebkg = ebkg + (nbkg*0.13)**2
        nsigtot = nsigtot + nsig
        nbkgtot = nbkgtot + nbkg
c
        do iebin=1,7
          xhzind = XSEC_INTERP(1,xsec,ecm(iebin)) ! cross section hz, 201.3GeV
          xbr = brh*zthad       ! Branching ratio of the Higgs * Z in quarks
          eff = A2000_HGG_EFF(amass,ecm(iebin),1,.false.)
          nsig = eff*xbr*xhzind*lumi_in_bin(iebin) ! Expected signal
          nbkg = A2000_HGG_BACKG(amass,ecm(iebin),1,.false.) ! Expected background
     &         *lumi_in_bin(iebin) 
          nobs = nobs + A2000_HGG_CAND(amass,iebin,warning) ! .true. to write warning
          esig=esig+(A2000_HGG_EFF(amass,ecm(iebin),1,.true.)*nsig)**2
          ebkg=ebkg+(A2000_HGG_BACKG(amass,ecm(iebin),1,.true.)*nbkg)**2
          esig = esig + (nsig*0.08)**2
          ebkg = ebkg + (nbkg*0.13)**2
          nsigtot = nsigtot + nsig
          nbkgtot = nbkgtot + nbkg
        Enddo
c
c hvv
        xhzind = xsec(1,15)        ! cross section hz, 188.6GeV
        xbr = brh*znunu         ! Branching ratio of the Higgs * Z in neutrinos
        eff = A189_HVV_HGG_EFF(amass)
        If (eff.gt.0.) then
          nsig = eff*xbr*xhzind*ah0_lumi(2) ! Expected signal
          nbkg = A189_HVV_HGG_BACKG(amass)
          nobs = nobs + A189_HVV_HGG_CAND(amass,warning)
          nsigtot = nsigtot + nsig
          nbkgtot = nbkgtot + nbkg
          esig = esig + (nsig*0.05)**2
          ebkg = ebkg + (nbkg*0.10)**2
        Endif
c
        xhzind = xsec(1,16)        ! cross section hz, 188.6GeV
        xbr = brh*znunu         ! Branching ratio of the Higgs * Z in neutrinos
        eff = A192_HVV_HGG_EFF(amass)
        If (eff.gt.0.) then
          nsig = eff*xbr*xhzind*ah0_lumi(3) ! Expected signal
          nbkg = A192_HVV_HGG_BACKG(amass)
          nobs = nobs + A192_HVV_HGG_CAND(amass,warning)
          nsigtot = nsigtot + nsig
          nbkgtot = nbkgtot + nbkg
          esig = esig + (nsig*0.05)**2
          ebkg = ebkg + (nbkg*0.10)**2
        Endif
c
        xhzind = xsec(1,17)        ! cross section hz, 195.5GeV
        xbr = brh*znunu         ! Branching ratio of the Higgs * Z in neutrinos
        eff = A196_HVV_HGG_EFF(amass)
        If (eff.gt.0.) then
          nsig = eff*xbr*xhzind*ah0_lumi(4) ! Expected signal
          nbkg = A196_HVV_HGG_BACKG(amass)
          nobs = nobs + A196_HVV_HGG_CAND(amass,warning)
          nsigtot = nsigtot + nsig
          nbkgtot = nbkgtot + nbkg
          esig = esig + (nsig*0.05)**2
          ebkg = ebkg + (nbkg*0.10)**2
        Endif
c
        xhzind = xsec(1,18)        ! cross section hz, 199.5GeV
        xbr = brh*znunu         ! Branching ratio of the Higgs * Z in neutrinos
        eff = A200_HVV_HGG_EFF(amass)
        If (eff.gt.0.) then
          nsig = eff*xbr*xhzind*ah0_lumi(5) ! Expected signal
          nbkg = A200_HVV_HGG_BACKG(amass)
          nobs = nobs + A200_HVV_HGG_CAND(amass,warning)
          nsigtot = nsigtot + nsig
          nbkgtot = nbkgtot + nbkg
          esig = esig + (nsig*0.05)**2
          ebkg = ebkg + (nbkg*0.10)**2
        Endif
c
        xhzind = xsec(1,19)        ! cross section hz, 201.6GeV
        xbr = brh*znunu         ! Branching ratio of the Higgs * Z in neutrinos
        eff = A202_HVV_HGG_EFF(amass)
        If (eff.gt.0.) then
          nsig = eff*xbr*xhzind*ah0_lumi(6) ! Expected signal
          nbkg = A202_HVV_HGG_BACKG(amass)
          nobs = nobs + A202_HVV_HGG_CAND(amass,warning)
          nsigtot = nsigtot + nsig
          nbkgtot = nbkgtot + nbkg
          esig = esig + (nsig*0.05)**2
          ebkg = ebkg + (nbkg*0.10)**2
        Endif
c
        sig(nbins+1)      = nsigtot
        backg(nbins+1)    = nbkgtot ! bruit de fond que l''on soustrait
        backw(nbins+1)    = nbkgtot ! bruit de fond total
        ncand(nbins+1)    = nobs
        If (nsigtot.ne.0.) dsig(1,nchan)  = sqrt(esig)/nsigtot
        If (nbkgtot.ne.0.) dback(2,nchan) = sqrt(ebkg)/nbkgtot
c
        ifirst(nchan) = nbins + 1
        nbins = nbins + 1
        Call CheckNbins(nbins,a_maxnbin)
      Endif
c channel23-29
c hvv flavour ind y2k energies
      do 23 iebin = 1,n_ebins_2000-1 ! 1 canal pour chaque bin d''energie
        If (.not. switchind(22+iebin)) goto 23
        nchan = nchan + 1
        Call CheckNchan(nchan,a_maxnchan)
        channame(nchan) = 
     &       'ALEPH flavour ind hnn '//ENAME(iebin)
        chanlumi(nchan) = 0.
	if (dbg_flavind) write (6,561) nchan,channame(nchan),chanlumi(nchan)
c        
        ener_max = 199.+0.1*(ihigh_energy(iebin))
        ener_min = 199.+0.1*(ilow_energy(iebin)-1)
c
c create binned shape info
        xl1 = 50.
        xu1 = ener_max-91.2
        damass = Dble(amass)
c        
        Call vzero(sighist,nb1d)
        Call vzero(bkghist,nb1d)
c Systematics
        nerrch(nchan) = 12
        sysname(1,nchan)='A'//ENAME(iebin)//'-hnn-e12-sig'
        sysname(2,nchan)='A'//ENAME(iebin)//'-hnn-e12-bkg'
        sysname(3,nchan)='A20x-b-b'
        sysname(4,nchan)='A20x-b-lt'
        sysname(5,nchan)='WWXSECT'
        sysname(6,nchan)='ZZXSECT'
        sysname(7,nchan)='A20x-hnn-QQXSECT'
        sysname(8,nchan)='A20x-ISR'
        sysname(9,nchan)='A'//ENAME(iebin)//'-hnn-etau-sig'
        sysname(10,nchan)='A'//ENAME(iebin)//'-hnn-etau-bkg'
        sysname(11,nchan)='A20x-ilpe'
        sysname(12,nchan)='A'//ENAME(iebin)//'-hnn-mc-sig'
        sysname(13,nchan)='A'//ENAME(iebin)//'-hnn-mc-bkg'
        sysname(14,nchan)='A'//ENAME(iebin)//'-hnn-jet-sig'
        sysname(15,nchan)='A'//ENAME(iebin)//'-hnn-jet-bkg'
c
        bkgstat(1) = 0.204
        bkgstat(2) = 0.277
        bkgstat(3) = 0.333
        bkgstat(4) = 0.288
        bkgstat(5) = 0.447
        bkgstat(6) = 0.042
        bkgstat(7) = 0.025
        bkgstat(8) = 0.031
        bkgstat(9) = 0.710
        bkgstat(10)= 0.014
        do ibkg = 1,10
          bkgstaterr(ibkg) = 0.
        enddo
c
        nbkgtot = 0.
        do 32 iener = ilow_energy(iebin),ihigh_energy(iebin)
          ener = 199D0 + 0.1D0*(iener-0.5)
          if (ener.lt.199.5D0) goto 32
          if (ener.gt.210.0D0) goto 32
          if (lumi_2000(iener).eq.0.) goto 32
          if (amass.lt.75.) goto 32
          if (amass.gt.120.) goto 32
c
          xhzind = xsec_interp(1,xsec,Real(ener))
          xbr = brh*znunu       ! Branching ratio of the Higgs * Z in quarks
          eff = A2000_hvv_hgg_eff(Real(ener),amass)
          nsig = eff*xbr*xhzind*lumi_2000(iener) ! Expected signal
          chanlumi(nchan) = chanlumi(nchan) + lumi_2000(iener)
c Signal
          Call ascreateD(xl1,xu1,nb1d,A2000_nn_mrec_sig,
     >         damass,1,ener,sighist1)
          Call ahistscal2(nb1d,sighist1,nsig) ! Normalisation
          Call amerge1(nb1d,sighist1,sighist)
c Background
          do ibkg = 1,10
            Call abhcreateD(xl1,xu1,nb1d,A2000_nn_mrec_bkg,
     >           A2000_nn_bkg,ibkg,ener,bkghist1)
            nbkg = Real(A2000_nn_bkg(ener,ibkg))*lumi_2000(iener)
            bkgstaterr(ibkg) = bkgstaterr(ibkg) + nbkg*bkgstat(ibkg)
            nbkgtot = nbkgtot + nbkg
            Call ahistscal2(nb1d,bkghist1,nbkg) ! Normalisation
            Call amerge1(nb1d,bkghist1,bkghist) ! Merge
          enddo
c          
 32     continue                ! Sur les energies de ce bin d''energie
c Systematics
        dsig(1,nchan) = 0.05
        do ibkg = 1,10
          dback(2,nchan) = dback(2,nchan) + bkgstaterr(ibkg)**2
        enddo
        if (nbkgtot.gt.0.) then
          dback(2,nchan) = sqrt(dback(2,nchan))/nbkgtot
        endif
c Candidates
        nobs = A2000_nn_NCAND()
        do i=1,nobs
          Call A2000_nn_mhcand(i,candmass,candbtag,ener_cand)
          if ((ener_cand.ge.ener_min).and.
     &         (ener_cand.lt.ener_max)) then
            Call abin1(candmass,xl1,xu1,nb1d,ibin) ! trouver le bin ibin de la valeur candmass
            If (ibin.ge.1 .and. ibin.le.nb1d) 
     &           ncand(nbins+ibin) = ncand(nbins+ibin) + 1
          endif
        enddo
c
        Call ucopy(sighist(1),sig(nbins+1),nb1d)
        Call ucopy(bkghist(1),backw(nbins+1),nb1d)
        Call ucopy(bkghist(1),backg(nbins+1),nb1d)
c        
        ifirst(nchan) = nbins + 1
        nbins = nbins + nb1d
        Call CheckNbins(nbins,a_maxnbin)
 23   continue
c
      If (switchind(30)) then
c hll_flavind_189
c channel30
        nchan = nchan + 1
        Call CheckNchan(nchan,a_maxnchan)
        channame(nchan) = 'ALEPH flavour ind hll 189'
        chanlumi(nchan) = ah0_lumi(2)
	if (dbg_flavind) write (6,561) nchan,channame(nchan),chanlumi(nchan)
        nerrch(nchan) = 2
        sysname(1,nchan) = 'ALEPH hll 189 Signal'
        sysname(2,nchan) = 'ALEPH hll 189 Background'
c
        xl1 = 55.
        xu1 = 115.
c
        xhzind = xsec(1,15)        ! hZ cross section
        xbr = brh*(zee+zmumu)
        eff = A189_HLL_HGG_EFF(amass)
        nsig = eff*xbr*xhzind*ah0_lumi(2)
        dsig(1,nchan) = 0.006
        dback(2,nchan) = sqrt(
     >       (A189_HLL_BKG(1)*0.016)**2 +
     >       (A189_HLL_BKG(2)*0.075)**2 +
     >       (A189_HLL_BKG(3)*0.404)**2 )/
     >       (A189_HLL_BKG(1)+
     >       A189_HLL_BKG(2)+
     >       A189_HLL_BKG(3))
c Signal histogram
        Call ascreate3(xl1,xu1,nb1d,A189_HLL_MASS_SIG,amass,sighist)
        Call ahistscal2(nb1d,sighist,nsig) ! Normalisation
c Background histogram
        Call vzero(bkghist,nb1d)
        Do ibkg=1,3
          Call ascreate7(xl1,xu1,nb1d,A189_HLL_MASS_BKG,ibkg,bkghist1)
          nbkg = Real(a189_hll_bkg(ibkg))*176.2/175.5
          Call ahistscal2(nb1d,bkghist1,nbkg) ! Normalisation
          Call amerge1(nb1d,bkghist1,bkghist) ! Merge
        Enddo
c Candidates
        nobs = A189_hll_NUMCAND()
        do i=1,nobs
          candmass = Real(A189_hll_mass_CAND(i))
          Call abin1(candmass,xl1,xu1,nb1d,ibin)
          if (ibin.gt.0 .and. ibin.le.nb1d)
     &         ncand(nbins+ibin) = ncand(nbins+ibin) + 1
        enddo
c
        Call ucopy(sighist(1),sig(nbins+1),nb1d)
        Call ucopy(bkghist(1),backw(nbins+1),nb1d)
        Call ucopy(bkghist(1),backg(nbins+1),nb1d)
c
        ifirst(nchan) = nbins + 1
        nbins = nbins + nb1d
        Call CheckNbins(nbins,a_maxnbin)
      Endif
      do 40 iener = 3,6         ! 1 canal pour chaque energie 192,196,200,202
        If (.not. switchind(30+(iener-2))) goto 40
        nchan = nchan + 1
        Call CheckNchan(nchan,a_maxnchan)
        If (iener.eq.3) then
          channame(nchan) = 'ALEPH flavour ind hll 192'
          lumi = ah0_lumi(3)
        Endif
        If (iener.eq.4) then
          channame(nchan) = 'ALEPH flavour ind hll 196'
          lumi = ah0_lumi(4)
        Endif
        If (iener.eq.5) then
          channame(nchan) = 'ALEPH flavour ind hll 200'
          lumi = ah0_lumi(5)
        Endif
        If (iener.eq.6) then
          channame(nchan) = 'ALEPH flavour ind hll 202'
          lumi = ah0_lumi(6)
        Endif
        chanlumi(nchan) = lumi
	if (dbg_flavind) write (6,561) nchan,channame(nchan),chanlumi(nchan)
c
        xl1 = 50.
        xu1 = 114.
c
        xhzind = xsec(1,16+(iener-3))        ! hZ cross section
        xbr = brh*(zee+zmumu)
        eff = A99_HLL_HGG_EFF(amass,iener)
        nsig = eff*xbr*xhzind*lumi
c Signal histogram
        Call ascreate2(xl1,xu1,nb1d,a_hll_sig_h0mass,amass,iener,sighist
     &       )
        Call ahistscal2(nb1d,sighist,nsig) ! Normalisation
c Background histogram
        Call vzero(bkghist,nb1d)
        Do ibkg=1,3
          Call ascreate10(xl1,xu1,nb1d,a_hll_bkg_mass,iener,ibkg
     &         ,bkghist1)
          nbkg = Real(a_hll_bkg_level(iener,ibkg))
          ratebgd(ibkg) = nbkg
          Call ahistscal2(nb1d,bkghist1,nbkg) ! Normalisation
          Call amerge1(nb1d,bkghist1,bkghist) ! Merge
        Enddo
c Systematcis
        Call A_HLL_SYSTEMATICS_flavind(iener,ratebgd, ! input
     +       dsig(1,nchan),dback(1,nchan),sysname(1,nchan), ! output
     +       nerrch(nchan))     ! output
c Candidates
        nobs = a_hll_numcand(iener)
        do i=1,nobs
          candmass = Real(a_hll_mass_cand(iener,i))
          Call abin1(candmass,xl1,xu1,nb1d,ibin)
          if (ibin.gt.0 .and. ibin.le.nb1d)
     &         ncand(nbins+ibin) = ncand(nbins+ibin) + 1
        enddo
c      
        Call ucopy(sighist(1),sig(nbins+1),nb1d)
        Call ucopy(bkghist(1),backw(nbins+1),nb1d)
        Call ucopy(bkghist(1),backg(nbins+1),nb1d)
c        
        ifirst(nchan) = nbins + 1
        nbins = nbins + nb1d
        Call CheckNbins(nbins,a_maxnbin)
 40   continue
c channel35-41
c hll flavour independent y2k energies
      do 53 iebin = 1,n_ebins_2000-1 ! 1 canal pour chaque bin d''energie
        If (.not. switchind(34+iebin)) goto 53
        nchan = nchan + 1
        Call CheckNchan(nchan,a_maxnchan)
        channame(nchan) = 
     &       'ALEPH flavour ind hll '//ENAME(iebin)
        chanlumi(nchan) = 0.
	if (dbg_flavind) write (6,561) nchan,channame(nchan),chanlumi(nchan)
c        
c create binned shape info
        xl1 = 50.
        xu1 = 125.
        damass = Dble(amass)
c        
        Call vzero(sighist,nb1d)
        Call vzero(bkghist,nb1d)
        nsigtot = 0.
        nbkgtot = 0.
        nbkg1 = 0.
        nbkg2 = 0.
        nbkg3 = 0.
        nbkg4 = 0.
c Systematics
        nerrch(nchan) = 2
        sysname(1,nchan) = 'ALEPH '//ENAME(iebin)//' hll Signal'
        sysname(2,nchan) = 'ALEPH '//ENAME(iebin)//' hll Background'
        Call vzero(auxll,5)
c
        do 54 iener = ilow_energy(iebin),ihigh_energy(iebin)
          ener = 199D0 + 0.1D0*(iener-0.5)
          if (ener.lt.199.5D0) goto 54
          if (ener.gt.210.0D0) goto 54
          if (lumi_2000(iener).eq.0.) goto 54
          if (amass.lt.75.) goto 54
          if (amass.gt.120.) goto 54
c
          xhzind = xsec_interp(1,xsec,Real(ener))
          xbr = brh*(zee+zmumu)       ! Branching ratio of the Higgs * Z in quarks
          eff = Real(a2000_hll_sig_eff_bb(damass,ener))
          nsig = eff*xbr*xhzind*lumi_2000(iener) ! Expected signal
          nsigtot = nsigtot + nsig
          chanlumi(nchan) = chanlumi(nchan) + lumi_2000(iener)
c Signal
          Call ascreate2F(xl1,xu1,nb1d,a2000_hll_sig_h0mass,
     &         amass,ener,sighist1)
          Call ahistscal2(nb1d,sighist1,nsig) ! Normalisation
          Call amerge1(nb1d,sighist1,sighist)
c Background
c 1
          Call ascreate3(xl1,xu1,nb1d,a2000_hll_bkg_zz_h0mass, ! ZZ background
     &         ener,bkghist1)
          nbkg = Real(a2000_hll_bkg_level(ener,1))*lumi_2000(iener
     &         )
          ratebgd(1) = nbkg
          nbkg1 = nbkg1 + nbkg
          Call ahistscal2(nb1d,bkghist1,nbkg) ! Normalisation
          Call amerge1(nb1d,bkghist1,bkghist) ! Merge
c 2
          Call ascreate3(xl1,xu1,nb1d,a2000_hll_bkg_eez_h0mass,
     &                   ener,bkghist1)
          nbkg = Real(a2000_hll_bkg_level(ener,2))*lumi_2000(iener ! Zee background
     &         )
          ratebgd(2) = nbkg
          nbkg2 = nbkg2 + nbkg
          Call ahistscal2(nb1d,bkghist1,nbkg) ! Normalisation
          Call amerge1(nb1d,bkghist1,bkghist) ! Merge
c 3
          call ascreate3(xl1,xu1,nb1d,a2000_hll_bkg_other_h0mass,
     &         ener,bkghist1)
          nbkg = Real(a2000_hll_bkg_level(ener,3)) ! WW+qqg background
     &         * lumi_2000(iener) 
          ratebgd(3) = nbkg
          nbkg3 = nbkg3 + nbkg
          Call ahistscal2(nb1d,bkghist1,nbkg) ! Normalisation
          Call amerge1(nb1d,bkghist1,bkghist) ! Merge
c 4
          call ascreate3(xl1,xu1,nb1d,a2000_hll_bkg_other_h0mass,
     &         ener,bkghist1)
          nbkg = Real(a2000_hll_bkg_level(ener,4) ) ! WW+qqg background
     &         * lumi_2000(iener) 
          ratebgd(4) = nbkg
          nbkg4 = nbkg4 + nbkg
          Call ahistscal2(nb1d,bkghist1,nbkg) ! Normalisation
          Call amerge1(nb1d,bkghist1,bkghist) ! Merge
c Systematics
          auxll(1) = auxll(1) + nsig*Real(a2000_hll_sig_sys_bb(damass
     &         ,ener))
          auxll(2) = auxll(2) + ratebgd(1)
     &         *Real(a2000_hll_bkg_sys_zz(ener))
          auxll(3) = auxll(3) + ratebgd(2)
     &         *Real(a2000_hll_bkg_sys_eez(ener)) 
          auxll(4) = auxll(4) + ratebgd(3)
     &         *Real(a2000_hll_bkg_sys_ww(ener))
          auxll(5) = auxll(5) + ratebgd(4)
     &         *Real(a2000_hll_bkg_sys_qqg(ener))
c          
 54     continue                ! Sur les energies de ce bin d''energie
c
        nbkgtot = nbkg1+nbkg2+nbkg3+nbkg4
c     Finish off systematics calculation:
        If (nsigtot.gt.0.) dsig(1,nchan)   = auxll(1)/nsigtot
        If (nbkgtot.gt.0.) dback(2,nchan)  = sqrt(auxll(2)**2+auxll(3)
     &       **2+auxll(4)**2+auxll(5)**2)/ nbkgtot
c Candidates
        Call a2000_hll_cand(iebin,nobs,themass,thebtag)
        Do i=1,nobs
          Call abin1(themass(i),xl1,xu1,nb1d,ibin)
          If (ibin.ge.1 .and. ibin.le.nb1d) 
     &         ncand(nbins+ibin) = ncand(nbins+ibin) + 1
        Enddo
c
        Call ucopy(sighist(1),sig(nbins+1),nb1d)
        Call ucopy(bkghist(1),backw(nbins+1),nb1d)
        Call ucopy(bkghist(1),backg(nbins+1),nb1d)
c        
        ifirst(nchan) = nbins + 1
        nbins = nbins + nb1d
        Call CheckNbins(nbins,a_maxnbin)
 53   continue
c
 561  format(1x,i4,1x,a40,1x,'L(/pb)=',f7.1)
 562  continue
