C-*-FORTRAN-*-
C
c            ener_max = 199.+0.1*(ihigh_energy(iebin))
c            ener_min = 199.+0.1*(ilow_energy(iebin)-1)
c     ener = REAL*8 (declared in hqqhvv_decl.inc (1st used in 1999)
c
c     Mods:
c     - protect agains calculating pdfs if signal rate is zero; PTD, 28 Aug 00
c
c
c TO BE DONE:
c
c
      switch = .true.
      dosyst = .true.
      subbg = .true.
      if (switch) then
c
c     Loop over the LARGE energy bins:
c
         DO IEBIN = 1,N_EBINS_2000
c     
            nchan = nchan + 1 
            channame(nchan) = 'ALEPH '//ename(iebin)//' Hll'
            if (XTESTY2K) write (6,*) 
     +           ' ** Preparing ',channame(nchan)
c
c     Create binned pdf info:
c     Upper and lower bounds for the 1st (m) and 2nd (btau-tag) discriminant,
c     and nos. of bins:
c     
            xl1 = 50.
            xu1 = 125.
            xl2 = 0.0
            xu2 = 2.
c
            nbinsint1 = 100
            nbinsint2 = 100
            nbinsint  = 100
c
c     Reset the pdf histograms:
c
            call vzero(sighist3,nbinsint1)
            call vzero(sighist3s,nbinsint2)
            call a2dzero1(nbinsint1,nbinsint2,sighist2d)
            call a2dzero1(nbinsint1,nbinsint2,bkghist2d)
c
            if (XTESTY2K) write (6,*) ' Hll Y2000, IEBIN=',iebin
c     
c     Now loop over the SMALL energy bins (within this large energy bin/IEBIN), 
c     to build up the shapes:
c
            DO IENER = ilow_energy(iebin),ihigh_energy(iebin)
               ener = DBLE(199. + 0.1 * (iener-0.5))
c
c     Check ener is within bounds:
c
               IF (ENER.LT.199.0 .OR. ENER.GT.210.0) THEN
                  WRITE (6,*) ' Hll2000: invalid ENER requested!',ENER
                  GOTO 1968
               END IF
c
               if (XTESTY2K) write (6,*) ' SMALL BIN --> ',iener,ener
c
               xxll = (xsec_interp(6,xsec,SNGL(ener)) + ! hee total xsec
     +              xsec_interp(1,xsec,SNGL(ener))*z0tomumu) ! hz xsec
     +              * lumi_2000(iener)
               chanlumi(nchan) = chanlumi(nchan) + lumi_2000(iener)
c
               IF (LUMI_2000(IENER).EQ.0.0) GOTO 1968 ! do not bother about pdfs
               IF (XXLL.EQ.0.0) GOTO 1968 ! do not bother about pdfs
c
               xdouble = mh
c
               if (XTESTY2K) write (6,*) ' Hll effs (bb/tt/other)',
     +              SNGL(a2000_hll_sig_eff_bb(xdouble,ener)),
     +              SNGL(a2000_hll_sig_eff_tt(xdouble,ener)),
     +              SNGL(a2000_hll_sig_eff_other(xdouble,ener))  

               ratech = xxll * bhbb *
     +              SNGL(a2000_hll_sig_eff_bb(xdouble,ener))
               rate2ch = xxll * bhtata *
     +              SNGL(a2000_hll_sig_eff_tt(xdouble,ener)) 
               rate3ch = xxll * (bhcc+bhglgl) * 
     +              SNGL(a2000_hll_sig_eff_other(xdouble,ener))  
c     
               if (ratech.lt.0.0) ratech=0.0
               if (rate2ch.lt.0.0) rate2ch=0.0
               if (rate3ch.lt.0.0) rate3ch=0.0
c
c---- Prepare binned SIGNAL pdf:
c
         if (XTESTY2K) write (6,*) 'Hll 2000 sig-pdfs: iebin,iener',
     +              iebin,iener
c
c     Same mass shape for the 3 signal types:
c
         call ascreate2F(xl1,xu1,nbinsint1,a2000_hll_sig_h0mass,
     >        mh,ener,sighist1)
c         call ascreate2F_fancy(xl1,xu1,nbinsint1,115.,
c     >        a2000_hll_sig_h0mass,
c     >        mh,ener,sighist1) 
c
c     b-tau tag shapes:
c
c     h --> bb
         call ascreate5_fancy(xl2,xu2,nbinsint2,0.9,
     >        a2000_hll_sig_btag_bb,
     >        sighist2)
         call a2dadd1(nbinsint1,nbinsint2,ratech,
     >                sighist1,sighist2,sighist2d)
c     h --> tau tau
         call ascreate5_fancy(xl2,xu2,nbinsint2,0.9,
     >        a2000_hll_sig_btag_tt,
     >        sighist2)
         call a2dadd1(nbinsint1,nbinsint2,rate2ch,
     >                sighist1,sighist2,sighist2d)
c     h --> cc + gg
         call ascreate5_fancy(xl2,xu2,nbinsint2,0.9,
     >        a2000_hll_sig_btag_other, 
     >        sighist2)
         call a2dadd1(nbinsint1,nbinsint2,rate3ch,
     >                sighist1,sighist2,sighist2d)
c
c---- Prepare binned BACKGROUND shape:
c
         if (xtesty2k) write (6,*) 'Hll 2000 bgd-pdfs: iebin,iener',
     +              iebin,iener
c
c-- ZZ (ibkg=1)
c
         ratebgd(1)=SNGL(a2000_hll_bkg_level(ener,1)) * lumi_2000(iener)
         call ascreate3(xl1,xu1,nbinsint1,a2000_hll_bkg_zz_h0mass,
     >                   SNGL(ener),backhist1)
c         call ascreate3_fancy(xl1,xu1,nbinsint1,115.,
c     >                   a2000_hll_bkg_zz_h0mass,
c     >                   SNGL(ener),backhist1)
         call ascreate5_fancy(xl2,xu2,nbinsint2,0.9,
     >                  a2000_hll_bkg_zz_btag,
     >                  backhist2)
         call a2dadd1(nbinsint1,nbinsint2,ratebgd(1),
     >                backhist1,backhist2,bkghist2d)
c
c-- eeZ (ibkg=2)
c
         ratebgd(2)=SNGL(a2000_hll_bkg_level(ener,2)) * lumi_2000(iener)
         call ascreate3(xl1,xu1,nbinsint1,a2000_hll_bkg_eez_h0mass,
     >                   SNGL(ener),backhist1)
c         call ascreate3_fancy(xl1,xu1,nbinsint1,115.,
c     >                   a2000_hll_bkg_eez_h0mass,
c     >                   SNGL(ener),backhist1)
         call ascreate5_fancy(xl2,xu2,nbinsint2,0.9,
     >                  a2000_hll_bkg_eez_btag,
     >                  backhist2)
         call a2dadd1(nbinsint1,nbinsint2,ratebgd(2),
     >                backhist1,backhist2,bkghist2d)
c
c-- WW (ibkg=3) + qqg (ibkg=4), [same shape]
c
         ratebgd(3)=SNGL(a2000_hll_bkg_level(ener,3)*lumi_2000(iener))
         ratebgd(4)=SNGL(a2000_hll_bkg_level(ener,4)*lumi_2000(iener))
         bkglevel = ratebgd(3) + ratebgd(4)
         call ascreate3(xl1,xu1,nbinsint1,a2000_hll_bkg_other_h0mass,
     >                   SNGL(ener),backhist1)
c         call ascreate3_fancy(xl1,xu1,nbinsint1,115.,
c     >                   a2000_hll_bkg_other_h0mass,
c     >                   SNGL(ener),backhist1)
         call ascreate5_fancy(xl2,xu2,nbinsint2,0.9,
     >                  a2000_hll_bkg_other_btag,
     >                  backhist2)
         call a2dadd1(nbinsint1,nbinsint2,bkglevel,
     >                backhist1,backhist2,bkghist2d)
c
c     Fill in the SYSTEMATIC ERROR information:
c     (a single error is reported for each LARGE energy-bin, 
c      but it is calculated by 
C      adding together the error information small-bin by small-bin)
c
c NB Tom G has combined all systematics and MC stats into a single no.
c    The stats error dominates; so for a given signal/bgd type the total 
c    error in the small bins is largely correlated (because stats component
c    is strongly correlated between SMALL bins). Therefore, for a 
c    given s/b type add SMALL bin errors 100% correlated. Errors from 
c    different types are not correlated, therefore added in quadrature.
c
c     If this is the FIRST small-bin in this large bin, set the NAME,
c     and initialize errors:
c
        if (iener .eq. ilow_energy(iebin)) then
           nerrch(nchan) = 2
           sysname(1,nchan) = 'A'//ENAME(iebin)//'-HLL-SIG'
           sysname(2,nchan) = 'A'//ENAME(iebin)//'-HLL-BKG'
           dsig(1,nchan) = 0.00
           dsig(2,nchan) = 0.00
           dback(1,nchan) = 0.00
           dback(2,nchan) = 0.00
           call vzero(aux,10)
           sigtotal = 0.0
           bkgtotal = 0.0
        end if
c
c add error on signal types (assume 100% correlation):
        aux(1) = aux(1) + ratech*a2000_hll_sig_sys_bb(xdouble,ener)
        aux(2) = aux(2) + rate2ch*a2000_hll_sig_sys_tt(xdouble,ener)
        aux(3) = aux(3) + rate3ch*a2000_hll_sig_sys_other(xdouble,ener)
        sigtotal = sigtotal + ratech + rate2ch + rate3ch
c
c add error on bgd types (assume 100% correlation):
        aux(4) = aux(4) + ratebgd(1)*a2000_hll_bkg_sys_zz(ener) 
        aux(5) = aux(5) + ratebgd(2)*a2000_hll_bkg_sys_eez(ener) 
        aux(6) = aux(6) + ratebgd(3)*a2000_hll_bkg_sys_ww(ener) 
        aux(7) = aux(7) + ratebgd(4)*a2000_hll_bkg_sys_qqg(ener) 
        bkgtotal = bkgtotal + ratebgd(1) + ratebgd(2) + 
     .                        ratebgd(3) + ratebgd(4)
c
 1968 continue
      end do                    ! IENER, loop over SMALL energy bins
c
c     Finish off systematics calculation:
c     (report fractional errors:)
      if (sigtotal.gt.0.0)
     + dsig(1,nchan) = sqrt(aux(1)**2+aux(2)**2+aux(3)**2) / sigtotal
      if (bkgtotal.gt.0.0)
     + dback(2,nchan) = sqrt(aux(4)**2+aux(5)**2+aux(6)**2+aux(7)**2)
     .                 / bkgtotal
c
c---- Prepare histogram with the CANDIDATES in this LARGE energy bin:
c
         call a2dzero2(nbinsint1,nbinsint2,candhist2d)
         call a2000_hll_cand(iebin,nacand,themass,thebtag)
c
         do i=1,nacand

            call abin1(themass(i),xl1,xu1,nbinsint1,ibin1)
c            call abin_fancy(themass(i),xl1,xu1,nbinsint1,115.,ibin1)
            call abin_fancy(thebtag(i),xl2,xu2,nbinsint2,0.9,ibin2)
            
            if (ibin1.gt.0 .AND. ibin2.gt.0 .AND. 
     +          ibin1.le.nbinsint1 .AND. ibin2.le.nbinsint2) then
               candhist2d(ibin1,ibin2) = candhist2d(ibin1,ibin2)+1
            else 
               write (6,*) 'Hll 2000 candidate out of bounds!',
     +              i,ibin1,ibin2
            end if
                  
         end do
c
c     Fold it all into an s/b 1D distribution:
c
        call arebin3(nbinsint1,nbinsint2,
     >                sighist2d,bkghist2d,candhist2d,
     >                nbinsint,
     >                sig(nbins+1),backw(nbins+1),ncand(nbins+1))
c
c     systematics
c
         if (.not.subbg) then
            call vzero(backg(nbins+1),nbinsint)
         elseif (dosyst) then
            call vscale(backw(nbins+1),1.0,backg(nbins+1),nbinsint)
         else
            call vscale(backw(nbins+1),1.0,backg(nbins+1),nbinsint)
         endif
         ifirst(nchan) = nbins + 1
         nbins = nbins + nbinsint
c
      END DO                    ! IEBIN, loop over LARGE energy bins
c
      endif                     ! (switch)
      
