C-*-FORTRAN-*-
c
c       Functions for hll efficiencies in the 1999 data (192 - 202 GeV)
c
	real*8 function a_hll_eff_bb_1999(dmass,iener)
c
	implicit none
	integer iener
	real eff
	real*8 dmass
      real*8 a192_hll_eff_bb,a196_hll_eff_bb,a200_hll_eff_bb,
     +       a202_hll_eff_bb
      external a192_hll_eff_bb,a196_hll_eff_bb,a200_hll_eff_bb,
     +         a202_hll_eff_bb
c
	eff = 0.0
	if (iener.lt.3 .or. iener.gt.6) then
	   write (6,*) '<a_hll_eff_bb_1999> invalid IENER!'
	   return
	end if
c
	if (iener.eq.3) then
	   eff = a192_hll_eff_bb(dmass)
	else if (iener.eq.4) then
	   eff = a196_hll_eff_bb(dmass)
	else if (iener.eq.5) then
	   eff = a200_hll_eff_bb(dmass)
	else if (iener.eq.6) then
	   eff = a202_hll_eff_bb(dmass)
	end if
c
	a_hll_eff_bb_1999 = eff
	return
	end
c--------
	real*8 function a_hll_eff_tt_1999(dmass,iener)
c
	implicit none
	integer iener
	real eff,amass
	real*8 dmass
      real*8 a192_hll_eff_tt,a196_hll_eff_tt,a200_hll_eff_tt,
     +       a202_hll_eff_tt
      external a192_hll_eff_tt,a196_hll_eff_tt,a200_hll_eff_tt,
     +         a202_hll_eff_tt
c
	eff = 0.0
	if (iener.lt.3 .or. iener.gt.6) then
	   write (6,*) '<a_hll_eff_tt_1999> invalid IENER!'
	   return
	end if
c
	dmass = amass
	if (iener.eq.3) then
	   eff = a192_hll_eff_tt(dmass)
	else if (iener.eq.4) then
	   eff = a196_hll_eff_tt(dmass)
	else if (iener.eq.5) then
	   eff = a200_hll_eff_tt(dmass)
	else if (iener.eq.6) then
	   eff = a202_hll_eff_tt(dmass)
	end if
c
	a_hll_eff_tt_1999 = eff
	return
	end
c--------
	real*8 function a_hll_eff_other_1999(dmass,iener)
c
	implicit none
	integer iener
	real eff,amass
	real*8 dmass
      real*8 a192_hll_eff_other,a196_hll_eff_other,a200_hll_eff_other,
     +       a202_hll_eff_other
      external a192_hll_eff_other,a196_hll_eff_other,a200_hll_eff_other,
     +         a202_hll_eff_other
c
	eff = 0.0
	if (iener.lt.3 .or. iener.gt.6) then
	   write (6,*) '<a_hll_eff_other_1999> invalid IENER!'
	   return
	end if
c
	dmass = amass
	if (iener.eq.3) then
	   eff = a192_hll_eff_other(dmass)
	else if (iener.eq.4) then
	   eff = a196_hll_eff_other(dmass)
	else if (iener.eq.5) then
	   eff = a200_hll_eff_other(dmass)
	else if (iener.eq.6) then
	   eff = a202_hll_eff_other(dmass)
	end if
c
	a_hll_eff_other_1999 = eff
	return
	end
c
