C-*-FORTRAN-*-
C
c tt -- three analyses / 
c IENER = 3,4,5,6 (192, 196, 200 and 202 GeV)
c ICHAN = 1 (hA only), 2 (hZ only), 3 (hZ/hA overlap treated as hA), 
c                                  4 (idem, as hz).
c
c NB need to deal with overlap treated as hA / hZ separately (opt 1 / opt 2)
c
c     Author: Pedro Teixeira-Dias
c
c     Mods:
c
c
c
c
      DO IENER=3,6
C
      switch = .true.
      dosyst = .true.
      subbg = .true.
      if (SWITCH) then
        DO 523 ICHAN=1,4
c
          IF (IENER.EQ.3) THEN
          if (ichan.eq.1) then
            nchan = nchan + 1 
            channame(nchan) = 'ALEPH 192 Xtt hA only'
          else if (ichan.eq.2) then
            nchan = nchan + 1 
            channame(nchan) = 'ALEPH 192 Xtt hZ only'
          else if (ichan.eq.3 .and. iopt.eq.2) then ! treat as hA
            nchan = nchan + 1 
            channame(nchan) = 'ALEPH 192 Xtt hZ/hA overlap (opt 1)' 
          else if (ichan.eq.4 .and. iopt.eq.1) then ! treat as hZ
            nchan = nchan + 1 
            channame(nchan) = 'ALEPH 192 Xtt hZ/hA overlap (opt 2)' 
          else if (ichan.eq.3 .and. iopt.eq.0) then ! automatic hZ/hA choice
            nchan = nchan + 1 
            channame(nchan) = 'ALEPH 192 Xtt hZ/hA overlap (automatic)' 
          endif
          ELSE IF (IENER.EQ.4) THEN
          if (ichan.eq.1) then
            nchan = nchan + 1 
            channame(nchan) = 'ALEPH 196 Xtt hA only'
          else if (ichan.eq.2) then
            nchan = nchan + 1 
            channame(nchan) = 'ALEPH 196 Xtt hZ only'
          else if (ichan.eq.3 .and. iopt.eq.2) then ! treat as hA
            nchan = nchan + 1 
            channame(nchan) = 'ALEPH 196 Xtt hZ/hA overlap (opt 1)' 
          else if (ichan.eq.4 .and. iopt.eq.1) then ! treat as hZ
            nchan = nchan + 1 
            channame(nchan) = 'ALEPH 196 Xtt hZ/hA overlap (opt 2)' 
          else if (ichan.eq.3 .and. iopt.eq.0) then ! automatic hZ/hA choice
            nchan = nchan + 1 
            channame(nchan) = 'ALEPH 196 Xtt hZ/hA overlap (automatic)' 
          endif
          ELSE IF (IENER.EQ.5) THEN
          if (ichan.eq.1) then
            nchan = nchan + 1 
            channame(nchan) = 'ALEPH 200 Xtt hA only'
          else if (ichan.eq.2) then  
            nchan = nchan + 1 
            channame(nchan) = 'ALEPH 200 Xtt hZ only'
          else if (ichan.eq.3 .and. iopt.eq.2) then ! treat as hA
            nchan = nchan + 1 
            channame(nchan) = 'ALEPH 200 Xtt hZ/hA overlap (opt 1)' 
          else if (ichan.eq.4 .and. iopt.eq.1) then ! treat as hZ
            nchan = nchan + 1 
            channame(nchan) = 'ALEPH 200 Xtt hZ/hA overlap (opt 2)' 
          else if (ichan.eq.3 .and. iopt.eq.0) then ! automatic hZ/hA choice
            nchan = nchan + 1 
            channame(nchan) = 'ALEPH 200 Xtt hZ/hA overlap (automatic)' 
          endif
          ELSE IF (IENER.EQ.6) THEN
          if (ichan.eq.1) then
            nchan = nchan + 1 
            channame(nchan) = 'ALEPH 202 Xtt hA only'
          else if (ichan.eq.2) then  
            nchan = nchan + 1 
            channame(nchan) = 'ALEPH 202 Xtt hZ only'
          else if (ichan.eq.3 .and. iopt.eq.2) then ! treat as hA
            nchan = nchan + 1 
            channame(nchan) = 'ALEPH 202 Xtt hZ/hA overlap (opt 1)' 
          else if (ichan.eq.4 .and. iopt.eq.1) then ! treat as hZ
            nchan = nchan + 1 
            channame(nchan) = 'ALEPH 202 Xtt hZ/hA overlap (opt 2)' 
          else if (ichan.eq.3 .and. iopt.eq.0) then ! automatic hZ/hA choice
            nchan = nchan + 1 
            channame(nchan) = 'ALEPH 202 Xtt hZ/hA overlap (automatic)' 
          endif
          END IF
c
c     Protection barrier: shall only pass here three times! (per IENER)
c     hA-only branch (ichan = 1)
c     hZ-only branch (ichan = 2)
c     the chosen overlap treatment (ichan=3 and iopt2=2)OR(ichan=4 and iopt2=1);
c
          if ( (ichan.eq.3 .and. iopt2.ne.2) .OR.
     +         (ichan.eq.4 .and. iopt2.ne.1) ) goto 523
c
c set analysis index (1-3)
c (NB ichan 3 and 4 are the same event selection)
c
          iana = min(ichan,3)
c
          xlzh = xhz(13+IENER)*ah0_lumi(IENER)
          xlah = xha(13+IENER)*ah0_lumi(IENER)
          chanlumi(nchan) = ah0_lumi(IENER)
          xdouble = mh
          ydouble = mapole
          xl = 50.
          xu = 115.
          nbinsint = 65
          IF (CHANLUMI(NCHAN).EQ.0.0) GOTO 1924 ! NEXT CHANNEL
c
          if (xtest19x) then
             write (6,*) 'Debug: Xtt channels 192 - 202 GeV:'
             write (6,'(a,4f)') 'mh,mA,xsc(hZ),xsc(hA)',
     +  xdouble,ydouble,xhz(13+IENER),xha(13+IENER)
             write (6,'(a,i,f)') 'iener,Lumi:',iener,ah0_lumi(IENER)
          end if
c
c
c compute signal rates for all 9 different signal types:
c
C     ITYP defines the signal 
C       1=HZ->bbtt, 2=HZ->tttt, 3=HZ->cctt, 4=HZ->(other)tt,
C       5=ttZ
C       6=hA->bbtt, 7=hA->tttt, 8=hA->cctt, 9=hA->(other)tt 
c
          DO ITYP=1,9
          ratesig(ityp) = 0.0
c hZ signals
          if (ityp.eq.1) ratesig(ityp) = bhbb * z0totata
C     Set this equal to zero, or else 4t state will be double-counted
          if (ityp.eq.2) ratesig(ityp) = 0.0
          if (ityp.eq.3) ratesig(ityp) = bhcc * z0totata
          if (ityp.eq.4) ratesig(ityp) = (1.-bhbb-bhtata-bhcc)* z0totata
          if (ityp.eq.5) ratesig(ityp) = bhtata
c hA signals                               
          if (ityp.eq.6) ratesig(ityp) = bhtata*babb + bhbb*batata
          if (ityp.eq.7) ratesig(ityp) = bhtata*batata
          if (ityp.eq.8) ratesig(ityp) = bhtata*bacc + bhcc*batata
          if (ityp.eq.9) ratesig(ityp) = bhtata*(1.-babb-batata-bacc) + 
     +                                   batata*(1.-bhbb-bhtata-bhcc)
c
          if (ityp.ge.1 .and. ityp.le.5) then ! hZ signal
c
             ratesig(ityp) = ratesig(ityp) * xlzh * 
     +         SNGL(a_xtt_eff(xdouble,iana,ityp,iener))
c
          else if (ityp.ge.6 .and. ityp.le.9) then ! hA signal
c
             ratesig(ityp) = ratesig(ityp) * xlah * 
     +         SNGL(a_xtt_eff((xdouble+ydouble)/2D0,iana,ityp,iener) * 
     +         htt_eff_map(xdouble,ydouble)) ! scale eff, depending on |mh-mA|
c
          end if
c
c
          ratesig(ityp) = max(0.0,ratesig(ityp))
c
          if (xtest19x) write (6,'(a,3i3,f10.6)') 
     +         'Xtt 19x/iener,istyp,ichan,ratesig:',
     +         iener,ityp,ichan,ratesig(ityp)
c
c Prepare the SIGNAL binned pdf:
c (create histo for each signal class, scale accordingly, and
c update final shape)
c
          if (ityp.ge.1 .and. ityp.le.5) then ! hZ signal
             call ascreate8(xl,xu,nbinsint,a_xtt_sig_mass,
     +            xdouble,ichan,ityp,iener,sighist1)
c
          elseif (ityp.ge.6 .and. ityp.le.9) then ! hA signal
             call ascreate8(xl,xu,nbinsint,a_xtt_sig_mass,
     +            (xdouble+ydouble)/2D0,ichan,ityp,iener,sighist1)
          end if
          call ahistscal1(nbinsint,sighist1,sighist1s,ratesig(ityp))
          call amerge1(nbinsint,sighist1s,sig(nbins+1))
c
          END DO                   ! ITYP, signal
c
c     Compute the background rate (4 different bgd types):
c     ITYP=1 (eeZ+Wenu), 2 (qq), 3 (WW), 4 (ZZ)
c
          DO ITYP=1,4
             ratebgd(ityp) = a_xtt_bkg_level(iana,ityp,iener)
             if (xtest19x) write (6,*) 'Xtt 19x/iener,ibtyp,ratebgd:',
     +         iener,ityp,ratebgd(ityp)
c
c Prepare the BACKGROUND binned pdf:
c (create histo for each backgd class, scale accordingly, and
c update final shape)
c
             call abcreate8(xl,xu,nbinsint,a_xtt_bkg_mass,
     +            ichan,ityp,iener,backhist1)
             call ahistscal1(nbinsint,backhist1,backhist2,ratebgd(ityp))
             call amerge1(nbinsint,backhist2,backw(nbins+1))
c
          END DO                ! ITYP, bgd
c
c Prepare the histogram with the CANDIDATES mass information:
c
          nacand = a_xtt_numcand(iana,iener)
          do i=1,nacand
            candmass = a_xtt_mass_cand(iana,iener,i)
            call abin1(candmass,xl,xu,nbinsint,ibin)
            if (ibin.gt.0.and.ibin.le.nbinsint) then
              ncand(nbins+ibin) = ncand(nbins+ibin) + 1
            endif
          enddo
c
c Fill in the SYSTEMATIC ERROR information:
c
          CALL A_XTT_SYSTEMATICS(IENER,IANA,NCHAN,RATESIG,RATEBGD, ! input
     +         dsig(1,nchan),dback(1,nchan),sysname(1,nchan), ! output
     +         nerrch(nchan))   ! output
c
c        write (6,*) 'returned from A_XTT_SYSTEMATICS'
c        write (6,*) 'nerrch_aux',nerrch_aux
c        write (6,*) 'dsig_aux',dsig_aux
c        write (6,*) 'dback_aux',dback_aux
c        write (6,*) 'sysname_aux',sysname_aux
cc
c        nerrch(nchan) = nerrch_aux
c        do i=1,nerrch_aux
c           dsig(i,nchan) = dsig_aux(i)
c           dback(i,nchan) = dback_aux(i)
c           sysname(i,nchan) = sysname_aux(i)
c        end do
cc
c        write (6,*) 'copied/from A_XTT_SYSTEMATICS'
c        write (6,*) 'nerrch(nchan)',nerrch(nchan)
c        write (6,*) 'dsig(1,nchan)',(dsig(i,nchan),i=1,nerrch(nchan))
c        write (6,*) 'dback(1,nchan)',(dback(i,nchan),i=1,nerrch(nchan))
c        write (6,*) 'sysname(1,nchan)',
c     +       (sysname(i,nchan),i=1,nerrch(nchan))
c
c systematics
c
          if (.not.subbg) then
            call vzero(backg(nbins+1),nbinsint)
          elseif (dosyst) then
            call vscale(backw(nbins+1),1.0,backg(nbins+1),nbinsint)
          else
            call vscale(backw(nbins+1),1.0,backg(nbins+1),nbinsint)
          endif
 1924     ifirst(nchan) = nbins + 1
          nbins = nbins + nbinsint
 523    END DO                  ! ICHAN
      ENDIF                     ! SWITCH
C
      END DO                    ! IENER
c----------- end marker / ptd -----------
cx STILL NEED TO FILL IN THE ERRROR ARRAYS !!


