C-*-FORTRAN-*-
C
c Xtt -- three analyses , Y2000
c IEBIN = Large energy-bins in Y2000 (as defined in a_setup_2000.inc)
C IENER = Small energy-bins in Y2000
c
c ICHAN (analysis branch) = 
c           1 (hA only), 2 (ovlap as hA), 3 (overlap as hZ), 
c           4 (hZ only).
c
c IBKG (bgd types): 1,2,3,4 (eeZ, qq, WW, ZZ, resp.)
c
c NB need to deal with overlap treated as hA / hZ separately (opt 1 / opt 2)
c
c     Author: Pedro Teixeira-Dias
c
c     Mods:
c     - protect agains calculating pdfs if signal rate is zero; PTD, 28 Aug 00
c
c TO BE DONE:
c
      switch = .true.
      dosyst = .true.
      subbg = .true.
      if (SWITCH) then
c     
c     Loop over the LARGE energy bins:
c     
         DO IEBIN = 1,N_EBINS_2000
c     
            DO 525 ICHAN=1,4
c     
               if (ichan.eq.1) then
                nchan = nchan + 1 
                channame(nchan)='ALEPH '//ename(iebin)//' Xtt hA only'
               else if (ichan.eq.4) then
                nchan = nchan + 1 
                channame(nchan)='ALEPH '//ename(iebin)//' Xtt hZ only'
               else if (ichan.eq.2 .and. iopt.eq.2) then ! treat as hA
                nchan = nchan + 1 
                channame(nchan) = 
     +            'ALEPH '//ename(iebin)//' Xtt hZ/hA overlap (opt 1)' 
               else if (ichan.eq.3 .and. iopt.eq.1) then ! treat as hZ
                nchan = nchan + 1 
                channame(nchan) = 
     +            'ALEPH '//ename(iebin)//' Xtt hZ/hA overlap (opt 2)' 
               else if (ichan.eq.2 .and. iopt.eq.0) then ! automatic hZ/hA choice
c Must increment on FIRST ichan of choice (PM)
                nchan = nchan + 1 
                channame(nchan) = 
     +            'ALEPH '//ename(iebin)//' Xtt hZ/hA overlap (auto)' 
               endif
c
c     Protection barrier: shall only pass here three times! (per IEBIN)
c     hA-only branch (ichan = 1)
c     hZ-only branch (ichan = 4)
c     the chosen overlap treatment (ichan=2 and iopt2=2)OR(ichan=3 and iopt2=1);
c
          if ( (ichan.eq.2 .and. iopt2.ne.2) .OR.
     +         (ichan.eq.3 .and. iopt2.ne.1) ) goto 525
c
          if (XTESTY2K) write (6,*) 
     +         ' ** Preparing ',channame(nchan)
c
c     
c     Now loop over the SMALL energy bins (within this large energy bin/IEBIN), 
c     to build up the shapes:
c
          ave_ener = 0.
          tot_lumi = 0.
          DO IENER = ilow_energy(iebin),ihigh_energy(iebin)
             ener = DBLE(199. + 0.1 * (iener-0.5))

             ave_ener = ave_ener + ener*lumi_2000(iener)
             tot_lumi = tot_lumi + lumi_2000(iener)
          ENDDO
          ener = ave_ener/tot_lumi
c
c     Check ener is within bounds:
c
          IF (ENER.LT.199.0 .OR. ENER.GT.210.0) THEN
             WRITE (6,*) ' Xtt2000: invalid ENER requested!',ENER
             GOTO 1943
          END IF
c
          IF (TOT_LUMI.EQ.0.0) GOTO 1943 ! do not bother about pdfs
c     
          xlzh = xsec_interp(1,xsec,SNGL(ener)) * tot_lumi ! hZ xsec
          xlah = xsec_interp(2,xsec,SNGL(ener)) * tot_lumi ! hA xsec
          chanlumi(nchan) = tot_lumi
c
          IF (XLZH.EQ.0.0 .and. XLAH.EQ.0.0) GOTO 1943 ! do not bother about pdfs
c
          xdouble = mh
          ydouble = mapole
          xl = 60.
          xu = 120.
          nbinsint = 100
c
c compute signal rates for all 11 different signal types:
c
C     ITYP defines the signal: (new definitions in Y2000!)
c
C 1=(H->bb)tt, 2=(H->cc)tt, 3=(H->tt)tt, 4=(H->WW)tt, 5=(H->gg)tt
C 6=ttZ.
C 7=hA->bbtt, 8=hA->cctt, 9=hA->tttt, 10=hA->WWtt, 11=hA->ggtt
c
          DO ITYP=1,11
          ratextt(ityp) = 0.0
c hZ signals:
c============
c    h(Z-tt):
          if (ityp.eq.1) ratextt(ityp) = bhbb * z0totata
          if (ityp.eq.2) ratextt(ityp) = bhcc * z0totata
          if (ityp.eq.3) ratextt(ityp) = 0.0 ! do not double count 4 tau !
          if (ityp.eq.4) ratextt(ityp) = bhWW * z0totata
          if (ityp.eq.5) ratextt(ityp) = bhglgl * z0totata
c    (h-tt)Z:
          if (ityp.eq.6) ratextt(ityp) = bhtata
c hA signals:
c============
          if (ityp.eq.7) ratextt(ityp) = bhtata*babb + bhbb*batata
          if (ityp.eq.8) ratextt(ityp) = bhtata*bacc + bhcc*batata
          if (ityp.eq.9) ratextt(ityp) = bhtata*batata
          if (ityp.eq.10) ratextt(ityp) = 0.0
          if (ityp.eq.11) ratextt(ityp) = bhglgl*batata+bhtata*baglgl
c
c     Convert ITYP index into the corresponding ISIG & IDECAY indices
c     that are required by the signal efficiency and shape functions:
c
          call xtt_convert(ityp,isig,idecay)
c
          if (ityp.ge.1 .and. ityp.le.6) then ! hZ signal
c
             ratextt(ityp) = ratextt(ityp) * xlzh * 
     +            SNGL(a_2000_tt_signal_effs(ener,
     +                 xdouble,ichan,isig,idecay))
c
          else if (ityp.ge.7 .and. ityp.le.11) then ! hA signal
c
             ratextt(ityp) = ratextt(ityp) * xlah * 
     +       SNGL(a_2000_tt_signal_effs(
     +        ener,(xdouble+ydouble)/2D0,ichan,isig,idecay) * 
     +        htt_eff_map(xdouble,ydouble)) ! scale eff, depending on |mh-mA|
c
          end if
c
          ratextt(ityp) = max(0.0,ratextt(ityp))
c
c Prepare the SIGNAL binned pdf:
c (create histo for each signal class, scale accordingly, and
c update final shape)
c
          if (ratextt(ityp).gt.0.) then
            if (ityp.ge.1 .and. ityp.le.6) then ! hZ signal
               call ascreateF(xl,xu,nbinsint,a_2000_tt_signal_mass,
     +              xdouble,ener,ichan,isig,sighist1)
c
            elseif (ityp.ge.7 .and. ityp.le.11) then ! hA signal
               call ascreateF(xl,xu,nbinsint,a_2000_tt_signal_mass,
     +              (xdouble+ydouble)/2D0,ener,ichan,isig,sighist1)
            end if
            call ahistscal1(nbinsint,sighist1,sighist1s,ratextt(ityp))
            call amerge1(nbinsint,sighist1s,sig(nbins+1))
          endif
c
          END DO                   ! ITYP, signal
c
c     Compute the background rate (4 different bgd types) and bin the pdfs:
c     ITYP=1 (eeZ), 2 (qq), 3 (WW), 4 (ZZ)
c
          DO ITYP=1,4
c             call vzero 
             ratebgd(ityp) = a_2000_tt_background_effs(ener,ichan,ityp) 
     +                       * tot_lumi
             if (ityp.eq.1) then
               ratebgd(ityp) = ratebgd(ityp)*al_xsect_zee(ener)
             else if (ityp.eq.2) then
               ratebgd(ityp) = ratebgd(ityp)*(al_xsect_dd(ener)+
     +                      al_xsect_uu(ener)+al_xsect_ss(ener)+
     +                      al_xsect_cc(ener)+al_xsect_bb(ener))
             else if (ityp.eq.3) then
               ratebgd(ityp) = ratebgd(ityp)*al_xsect_ww(ener)
             else if (ityp.eq.4) then
               ratebgd(ityp) = ratebgd(ityp)*al_xsect_zz(ener)
             else
               ratebgd(ityp) = 0.
             endif

c
c Prepare the BACKGROUND binned pdf:
c (create histo for each backgd class, scale accordingly, and
c update final shape)
c
             if (ratebgd(ityp).gt.0.) then
               call abcreateF(xl,xu,nbinsint,a_2000_tt_background_mass,
     +              ener,ichan,ityp,backhist1)
               call ahistscal1(nbinsint,backhist1,
     +                         backhist2,ratebgd(ityp))
               call amerge1(nbinsint,backhist2,backw(nbins+1))
             endif
c
          END DO                ! ITYP, bgd
c
 1943  CONTINUE
c
c Prepare the histogram with the CANDIDATES mass information:
c
          call a2000_xtt_cand(iebin,nacand,themass,ichan)
          do i=1,nacand

            call abin1(themass(i),xl,xu,nbinsint,ibin) 
            if (ibin.gt.0.and.ibin.le.nbinsint) then
              ncand(nbins+ibin) = ncand(nbins+ibin) + 1
            endif
          enddo
c
c systematics
c
          if (.not.subbg) then
            call vzero(backg(nbins+1),nbinsint)
          elseif (dosyst) then
            call vscale(backw(nbins+1),1.0,backg(nbins+1),nbinsint)
          else
            call vscale(backw(nbins+1),1.0,backg(nbins+1),nbinsint)
          endif
          ifirst(nchan) = nbins + 1
          nbins = nbins + nbinsint
 525   END DO                   ! ICHAN
c
      END DO                    ! IEBIN, large energy bins loop
c
      ENDIF                     ! SWITCH
C


