C-*-FORTRAN-*-
C
C This file was prepared by PTD on Sun Feb  6 16:15:07 MET 2000
C This file collects the following inputs:
C
C -rw-r--r--   1 ptd      xu         10319 Feb  4 19:07 A192_tt_sig_eff_flav.F
C -rw-r--r--   1 ptd      xu         10335 Feb  4 19:07 A196_tt_sig_eff_flav.F
C -rw-r--r--   1 ptd      xu         10406 Feb  4 19:07 A200_tt_sig_eff_flav.F
C -rw-r--r--   1 ptd      xu         10350 Feb  4 19:07 A202_tt_sig_eff_flav.F
C
C Mods: 
C     - in A200_tt_hzonly_eff() ; typo corrected by Jason (0.988 --> 0.0988)
C     - in A200_tt_haonly_eff() ; typo corrected by Jason (0.114 --> 0.0114)
C                                                    J Nielsen, 08-Feb-2000.
C     - in A200_tt_overlap_eff(); typo corrected by Jason (see "cptd")
C
C---- New file --- 
C 
      real*8 function A192_tt_haonly_eff(mh, ityp)
C Uses the CERNLIB interpolation routine FINT
C ITYP: 1=HZ->bbtt, 2=HZ->tttt, 3=HZ->cctt, 4=HZ->(other)tt,
C       5=ttZ
C       6=hA->bbtt, 7=hA->tttt, 8=hA->cctt, 9=hA->(other)tt 
      implicit none
      real*8 mh
      integer ityp
      integer nmasshyp
      parameter (nmasshyp=14)
      real xmh, masshyp(nmasshyp), fint
      real haonly_htt_eff_bb(nmasshyp), haonly_htt_eff_tt(nmasshyp),
     $     haonly_htt_eff_cc(nmasshyp), haonly_htt_eff_ot(nmasshyp)
      real haonly_ttz_eff(nmasshyp)
      real haonly_hatt_eff_bb(nmasshyp), haonly_hatt_eff_tt(nmasshyp),
     $     haonly_hatt_eff_cc(nmasshyp), haonly_hatt_eff_ot(nmasshyp)
      
      data masshyp / 60., 65., 70., 75., 80., 85., 90., 95., 100.,
     $     105., 107., 110., 115., 120. /

      data haonly_htt_eff_bb / 0.007758, 0.009118, 0.009582, 0.008195,
     $     0.008185, 0.01117, 0.01447, 0.01489, 0.01298, 0.01231,
     $     0.01066, 0.007152, 0.004006, 0.001768 /
      data haonly_htt_eff_tt / 0., 0.001266, 0., 0., 0., 0., 0., 0.,
     $     0.001174, 0., 0., 0., 0.001294, 0. /
      data haonly_htt_eff_cc / 0., 0., 0.006369, 0.01235, 0., 0., 0.,
     $     0., 0.007813, 0., 0.007407, 0., 0., 0. /
      data haonly_htt_eff_ot / 0., 0., 0., 0.002849, 0.002242,
     $     0.006173, 0.003738, 0., 0.001431, 0.001214, 0.002215,
     $     0.001847, 0.0007246, 0.0005737 /
      data haonly_ttz_eff / 0.0047, 0.0068, 0.0094, 0.0079, 0.0052,
     $     0.0044, 0.0035, 0.0045, 0.0036, 0.0027, 0.0022, 0.0024,
     $     0.0023, 0.0028 / 
      data haonly_hatt_eff_bb / 0.1947, 0.1745, 0.1437, 0.09791,
     $     0.04012, 0.02000, 0.01290, 0.01811, 0.01308, 0.009394,
     $     0.008566, 0.007408, 0.006158, 0.005285 /
      data haonly_hatt_eff_tt / 0.002509, 0.001190, 0.002353, 0.001172,
     $     0.001148, 0.001151, 0.002212, 0., 0., 0.001002, 0., 0., 0.,
     $     0. /
      data haonly_hatt_eff_cc / 0., 0., 0., 0., 0., 0., 0., 0.,
     $     0., 0., 0., 0., 0., 0. /
      data haonly_hatt_eff_ot / 0.07895, 0.07692, 0.07407, 0.07692,
     $     0.03226, 0., 0., 0., 0., 0., 0., 0., 0., 0. /

      xmh = mh
      if (ityp.eq.1) then
         A192_tt_haonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        haonly_htt_eff_bb)
      else if (ityp.eq.2) then
         A192_tt_haonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        haonly_hatt_eff_tt)
      else if (ityp.eq.3) then
         A192_tt_haonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        haonly_hatt_eff_cc)
      else if (ityp.eq.4) then
         A192_tt_haonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        haonly_hatt_eff_ot)
      else if (ityp.eq.5) then
         A192_tt_haonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        haonly_ttz_eff)
      else if (ityp.eq.6) then
         A192_tt_haonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        haonly_hatt_eff_bb)
      else if (ityp.eq.7) then
         A192_tt_haonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        haonly_hatt_eff_tt)
      else if (ityp.eq.8) then
         A192_tt_haonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        haonly_hatt_eff_cc)
      else if (ityp.eq.9) then
         A192_tt_haonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        haonly_hatt_eff_ot)
      endif

      return
      end

C------------------------------------------------------------------

      real*8 function A192_tt_hzonly_eff(mh, ityp)
C Uses the CERNLIB interpolation routine FINT
C ITYP: 1=HZ->bbtt, 2=HZ->tttt, 3=HZ->cctt, 4=HZ->(other)tt,
C       5=ttZ
C       6=hA->bbtt, 7=hA->tttt, 8=hA->cctt, 9=hA->(other)tt 
      implicit none
      real*8 mh
      integer ityp
      integer nmasshyp
      parameter (nmasshyp=14)
      real xmh, masshyp(nmasshyp), fint
      real hzonly_htt_eff_bb(nmasshyp), hzonly_htt_eff_tt(nmasshyp),
     $     hzonly_htt_eff_cc(nmasshyp), hzonly_htt_eff_ot(nmasshyp) 
      real hzonly_ttz_eff(nmasshyp)
      real hzonly_hatt_eff_bb(nmasshyp), hzonly_hatt_eff_tt(nmasshyp),
     $     hzonly_hatt_eff_cc(nmasshyp), hzonly_hatt_eff_ot(nmasshyp)
      
      data masshyp / 60., 65., 70., 75., 80., 85., 90., 95., 100.,
     $     105., 107., 110., 115., 120. /

      data hzonly_htt_eff_bb / 0.1978, 0.1747, 0.1344, 0.1137, 0.0968,
     $     0.09515, 0.09891, 0.1009, 0.1077, 0.1155, 0.1178, 0.1270,
     $     0.1305, 0.1205 /
      data hzonly_htt_eff_tt / 0.01346, 0.006329, 0.008353, 0.02187,
     $     0.03717, 0.03664, 0.05630, 0.04954, 0.04695, 0.03249,
     $     0.03121, 0.02107, 0.01811, 0.01062 /
      data hzonly_htt_eff_cc / 0.1509, 0.1699, 0.1401, 0.1728, 0.1964,
     $     0.2530, 0.2276, 0.2324, 0.3203, 0.1928, 0.1556, 0.1357,
     $     0.07339, 0.03268 /
      data hzonly_htt_eff_ot / 0.1776, 0.1872, 0.2041, 0.1937, 0.2108,
     $     0.2428, 0.2224, 0.2374, 0.2532, 0.1723, 0.1196, 0.1108,
     $     0.04492, 0.04246 /
      data hzonly_ttz_eff / 0.1021, 0.1169, 0.1369, 0.1470, 0.1700,
     $     0.1868, 0.1894, 0.1959, 0.1879, 0.1506, 0.1399, 0.1126,
     $     0.0869, 0.0626 / 
      data hzonly_hatt_eff_bb / 0.02117, 0.02291, 0.02720, 0.03596,
     $     0.05430, 0.07361, 0.09341, 0.1013, 0.1255, 0.1289, 0.1213,
     $     0.1219, 0.1096, 0.09839 /
      data hzonly_hatt_eff_tt / 0.01882, 0.01548, 0.01176, 0.01407,
     $     0.02067, 0.03107, 0.04093, 0.04357, 0.01296, 0.01002,
     $     0.007353, 0.006744, 0.003976, 0.001929 /
      data hzonly_hatt_eff_cc / 0., 0., 0., 0., 0., 0., 0., 0.,
     $     0., 0., 0., 0., 0., 0. /
      data hzonly_hatt_eff_ot / 0., 0.02564, 0., 0., 0.1935, 0.1379,
     $     0.1429, 0.1429, 0.03846, 0., 0., 0., 0., 0. /

      xmh = mh
      if (ityp.eq.1) then
         A192_tt_hzonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        hzonly_htt_eff_bb)
      else if (ityp.eq.2) then
         A192_tt_hzonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        hzonly_htt_eff_tt)
      else if (ityp.eq.3) then
         A192_tt_hzonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        hzonly_htt_eff_cc)
      else if (ityp.eq.4) then
         A192_tt_hzonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        hzonly_htt_eff_ot)
      else if (ityp.eq.5) then
         A192_tt_hzonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        hzonly_ttz_eff)
      else if (ityp.eq.6) then
         A192_tt_hzonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        hzonly_hatt_eff_bb)
      else if (ityp.eq.7) then
         A192_tt_hzonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        hzonly_hatt_eff_tt)
      else if (ityp.eq.8) then
         A192_tt_hzonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        hzonly_hatt_eff_cc)
      else if (ityp.eq.9) then
         A192_tt_hzonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        hzonly_hatt_eff_ot)
      endif

      return
      end

C------------------------------------------------------------------

      real*8 function A192_tt_overlap_eff(mh, ityp)
C Uses the CERNLIB interpolation routine FINT
C ITYP: 1=HZ->bbtt, 2=HZ->tttt, 3=HZ->cctt, 4=HZ->(other)tt,
C       5=ttZ
C       6=hA->bbtt, 7=hA->tttt, 8=hA->cctt, 9=hA->(other)tt 
      implicit none
      real*8 mh
      integer ityp
      integer nmasshyp
      parameter (nmasshyp=14)
      real xmh, masshyp(nmasshyp), fint
      real overlap_htt_eff_bb(nmasshyp), overlap_htt_eff_tt(nmasshyp),
     $     overlap_htt_eff_cc(nmasshyp), overlap_htt_eff_ot(nmasshyp)
      real overlap_ttz_eff(nmasshyp)
      real overlap_hatt_eff_bb(nmasshyp), overlap_hatt_eff_tt(nmasshyp),
     $     overlap_hatt_eff_cc(nmasshyp), overlap_hatt_eff_ot(nmasshyp)
      
      data masshyp / 60., 65., 70., 75., 80., 85., 90., 95., 100.,
     $     105., 107., 110., 115., 120. /

      data overlap_htt_eff_bb / 0.2139, 0.2570, 0.3027, 0.3175, 0.3506,
     $     0.3540, 0.3518, 0.3285, 0.3246, 0.2400, 0.2235, 0.1676,
     $     0.1221, 0.07971 /
      data overlap_htt_eff_tt / 0.001224, 0., 0., 0.001215, 0.002398,
     $     0.002364, 0.001224, 0.002394, 0.002347, 0., 0.002497,
     $     0.001239, 0.001294, 0. /
      data overlap_htt_eff_cc / 0.02516, 0.05229, 0.08280, 0.08642,
     $     0.1548, 0.08434, 0.1103, 0.1268, 0.07813, 0.06429, 0.07407,
     $     0.04286, 0.009174, 0. /
      data overlap_htt_eff_ot / 0.007722, 0.03180, 0.03499, 0.05413,
     $     0.08072, 0.1008, 0.07664, 0.07239, 0.05007, 0.03398, 0.02879,
     $     0.02031, 0.01232, 0.009180 /
      data overlap_ttz_eff / 0.0278, 0.0408, 0.0532, 0.0751, 0.0848,
     $     0.0940, 0.0920, 0.0778, 0.0704, 0.0512, 0.0420, 0.0335,
     $     0.0245, 0.0174 / 
      data overlap_hatt_eff_bb / 0.1828, 0.2214, 0.2584, 0.3263,
     $     0.3966, 0.4021, 0.4000, 0.3505, 0.1775, 0.1108, 0.09656,
     $     0.07476, 0.05251, 0.03745 /
      data overlap_hatt_eff_tt / 0., 0., 0.002353, 0., 0.001148,
     $     0.001151, 0.003319, 0.001089, 0., 0., 0., 0.009634, 0., 0. /
      data overlap_hatt_eff_cc / 0., 0., 0., 0., 0., 0., 0., 0.,
     $     0., 0., 0., 0., 0., 0. /
      data overlap_hatt_eff_ot / 0., 0.02564, 0., 0., 0.1290, 0.1724,
     $     0.1071, 0.1429, 0., 0.01667, 0., 0., 0., 0. /

      xmh = mh
      if (ityp.eq.1) then
         A192_tt_overlap_eff = fint(1, xmh, nmasshyp, masshyp,
     $        overlap_htt_eff_bb)
      else if (ityp.eq.2) then
         A192_tt_overlap_eff = fint(1, xmh, nmasshyp, masshyp,
     $        overlap_htt_eff_tt)
      else if (ityp.eq.3) then
         A192_tt_overlap_eff = fint(1, xmh, nmasshyp, masshyp,
     $        overlap_htt_eff_cc)
      else if (ityp.eq.4) then
         A192_tt_overlap_eff = fint(1, xmh, nmasshyp, masshyp,
     $        overlap_htt_eff_ot)
      else if (ityp.eq.5) then
         A192_tt_overlap_eff = fint(1, xmh, nmasshyp, masshyp,
     $        overlap_ttz_eff)
      else if (ityp.eq.6) then
         A192_tt_overlap_eff = fint(1, xmh, nmasshyp, masshyp,
     $        overlap_hatt_eff_bb)
      else if (ityp.eq.7) then
         A192_tt_overlap_eff = fint(1, xmh, nmasshyp, masshyp,
     $        overlap_hatt_eff_tt)
      else if (ityp.eq.8) then
         A192_tt_overlap_eff = fint(1, xmh, nmasshyp, masshyp,
     $        overlap_hatt_eff_cc)
      else if (ityp.eq.9) then
         A192_tt_overlap_eff = fint(1, xmh, nmasshyp, masshyp,
     $        overlap_hatt_eff_ot)
      endif

      return
      end


C 
C---- New file --- 
C 
      real*8 function A196_tt_haonly_eff(mh, ityp)
C Uses the CERNLIB interpolation routine FINT
C ITYP: 1=HZ->bbtt, 2=HZ->tttt, 3=HZ->cctt, 4=HZ->(other)tt,
C       5=ttZ
C       6=hA->bbtt, 7=hA->tttt, 8=hA->cctt, 9=hA->(other)tt 
      implicit none
      real*8 mh
      integer ityp
      integer nmasshyp
      parameter (nmasshyp=14)
      real xmh, masshyp(nmasshyp), fint
      real haonly_htt_eff_bb(nmasshyp), haonly_htt_eff_tt(nmasshyp),
     $     haonly_htt_eff_cc(nmasshyp), haonly_htt_eff_ot(nmasshyp)
      real haonly_ttz_eff(nmasshyp)
      real haonly_hatt_eff_bb(nmasshyp), haonly_hatt_eff_tt(nmasshyp),
     $     haonly_hatt_eff_cc(nmasshyp), haonly_hatt_eff_ot(nmasshyp)
      
      data masshyp / 60., 65., 70., 75., 80., 85., 90., 95., 100.,
     $     105., 107., 110., 115., 120. /

      data haonly_htt_eff_bb / 0.01065, 0.008944, 0.008893, 0.007416,
     $     0.008557, 0.009686, 0.01402, 0.01561, 0.009123, 0.009249,
     $     0.007324, 0.006440, 0.002488, 0.001102 /
      data haonly_htt_eff_tt / 0.001302, 0., 0., 0., 0., 0., 0.001140,
     $     0., 0., 0., 0.001155, 0., 0., 0. /
      data haonly_htt_eff_cc / 0., 0.01333, 0., 0., 0.006944, 0.,
     $     0.006711, 0., 0., 0., 0., 0., 0., 0./
      data haonly_htt_eff_ot / 0., 0.003356, 0.008850, 0.005128,
     $     0.007634, 0.004464, 0.001795, 0., 0., 0.001211, 0., 0.,
     $     0.0007153, 0.0005426 /
      data haonly_ttz_eff / 0.0054, 0.0076, 0.0075, 0.0073, 0.0046,
     $     0.0038, 0.0036, 0.0041, 0.0025, 0.0033, 0.0027, 0.0023,
     $     0.0028, 0.0015 / 
      data haonly_hatt_eff_bb / 0.1949, 0.1657, 0.1357, 0.09185,
     $     0.03489, 0.01888, 0.01364, 0.01588, 0.01252, 0.01022,
     $     0.008609, 0.007356, 0.006136, 0.004053 /
      data haonly_hatt_eff_tt / 0.003731, 0.001196, 0., 0.003480,
     $     0., 0.001178, 0., 0.001100, 0.001067, 0., 0., 0.001034,
     $     0., 0. /
      data haonly_hatt_eff_cc / 0., 0., 0., 0., 0., 0., 0., 0.,
     $     0., 0., 0., 0., 0., 0. /
      data haonly_hatt_eff_ot / 0., 0.05556, 0., 0.1600, 0.,
     $     0., 0., 0., 0., 0., 0., 0., 0., 0. /

      xmh = mh
      if (ityp.eq.1) then
         A196_tt_haonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        haonly_htt_eff_bb)
      else if (ityp.eq.2) then
         A196_tt_haonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        haonly_htt_eff_tt)
      else if (ityp.eq.3) then
         A196_tt_haonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        haonly_htt_eff_cc)
      else if (ityp.eq.4) then
         A196_tt_haonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        haonly_htt_eff_ot)
      else if (ityp.eq.5) then
         A196_tt_haonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        haonly_ttz_eff)
      else if (ityp.eq.6) then
         A196_tt_haonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        haonly_hatt_eff_bb)
      else if (ityp.eq.7) then
         A196_tt_haonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        haonly_hatt_eff_tt)
      else if (ityp.eq.8) then
         A196_tt_haonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        haonly_hatt_eff_cc)
      else if (ityp.eq.9) then
         A196_tt_haonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        haonly_hatt_eff_ot)
      endif

      return
      end

C------------------------------------------------------------------

      real*8 function A196_tt_hzonly_eff(mh, ityp)
C Uses the CERNLIB interpolation routine FINT
C ITYP: 1=HZ->bbtt, 2=HZ->tttt, 3=HZ->cctt, 4=HZ->(other)tt,
C       5=ttZ
C       6=hA->bbtt, 7=hA->tttt, 8=hA->cctt, 9=hA->(other)tt 

      implicit none
      real*8 mh
      integer ityp
      integer nmasshyp
      parameter (nmasshyp=14)
      real xmh, masshyp(nmasshyp), fint
      real hzonly_htt_eff_bb(nmasshyp), hzonly_htt_eff_tt(nmasshyp),
     $     hzonly_htt_eff_cc(nmasshyp), hzonly_htt_eff_ot(nmasshyp)
      real hzonly_ttz_eff(nmasshyp)
      real hzonly_hatt_eff_bb(nmasshyp), hzonly_hatt_eff_tt(nmasshyp),
     $     hzonly_hatt_eff_cc(nmasshyp), hzonly_hatt_eff_ot(nmasshyp)
      
      data masshyp / 60., 65., 70., 75., 80., 85., 90., 95., 100.,
     $     105., 107., 110., 115., 120. /

      data hzonly_htt_eff_bb / 0.1962, 0.1628, 0.1343, 0.1152, 0.09794,
     $     0.09231, 0.09445, 0.09817, 0.1071, 0.1151, 0.1221, 0.1408,
     $     0.1392, 0.1384 /
      data hzonly_htt_eff_tt / 0.01042, 0.01685, 0.02228, 0.02979,
     $     0.03067, 0.02401, 0.03991, 0.05576, 0.05569, 0.04774,
     $     0.04503, 0.03581, 0.02029, 0.01398 /
      data hzonly_htt_eff_cc / 0.1034, 0.1667, 0.2047, 0.2057, 0.2292,
     $     0.2733, 0.2550, 0.2941, 0.2398, 0.2143, 0.1806, 0.1333,
     $     0.0866, 0.0909 /
      data hzonly_htt_eff_ot / 0.1521, 0.1611, 0.2065, 0.2231, 0.2137,
     $     0.2009, 0.2603, 0.2752, 0.2202, 0.1864, 0.1274, 0.1178,
     $     0.0937, 0.06348 /
      data hzonly_ttz_eff / 0.1260, 0.1382, 0.1413, 0.1636, 0.1700,
     $     0.1775, 0.1943, 0.1947, 0.1941, 0.1869, 0.1655, 0.1462,
     $     0.1095, 0.0888 / 
      data hzonly_hatt_eff_bb / 0.02372, 0.02531, 0.02915, 0.03731,
     $     0.05606, 0.07058, 0.07868, 0.09923, 0.1237, 0.1302,
     $     0.1332, 0.1229, 0.1192, 0.1045 /
      data hzonly_hatt_eff_tt / 0.01492, 0.01316, 0.01250, 0.01392,
     $     0.01891, 0.02473, 0.03833, 0.05281, 0.01494, 0.01151,
     $     0.009970, 0.01344, 0.01127, 0.001919 /
      data hzonly_hatt_eff_cc / 0., 0., 0., 0., 0., 0., 0., 0.,
     $     0., 0., 0., 0., 0., 0. /
      data hzonly_hatt_eff_ot / 0.02128, 0.05556, 0., 0.1600, 0.1282,
     $     0.07317, 0.2400, 0.2500, 0.07692, 0.07317, 0.03774,
     $     0.01667, 0., 0.01351 /

      xmh = mh
      if (ityp.eq.1) then
         A196_tt_hzonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        hzonly_htt_eff_bb)
      else if (ityp.eq.2) then
         A196_tt_hzonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        hzonly_htt_eff_tt)
      else if (ityp.eq.3) then
         A196_tt_hzonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        hzonly_htt_eff_cc)
      else if (ityp.eq.4) then
         A196_tt_hzonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        hzonly_htt_eff_ot)
      else if (ityp.eq.5) then
         A196_tt_hzonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        hzonly_ttz_eff)
      else if (ityp.eq.6) then
         A196_tt_hzonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        hzonly_hatt_eff_bb)
      else if (ityp.eq.7) then
         A196_tt_hzonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        hzonly_hatt_eff_tt)
      else if (ityp.eq.8) then
         A196_tt_hzonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        hzonly_hatt_eff_cc)
      else if (ityp.eq.9) then
         A196_tt_hzonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        hzonly_hatt_eff_ot)
      endif

      return
      end

C------------------------------------------------------------------

      real*8 function A196_tt_overlap_eff(mh, ityp)
C Uses the CERNLIB interpolation routine FINT
C ITYP: 1=HZ->bbtt, 2=HZ->tttt, 3=HZ->cctt, 4=HZ->(other)tt,
C       5=ttZ
C       6=hA->bbtt, 7=hA->tttt, 8=hA->cctt, 9=hA->(other)tt 
      implicit none
      real*8 mh
      integer ityp
      integer nmasshyp
      parameter (nmasshyp=14)
      real xmh, masshyp(nmasshyp), fint
      real overlap_htt_eff_bb(nmasshyp), overlap_htt_eff_tt(nmasshyp),
     $     overlap_htt_eff_cc(nmasshyp), overlap_htt_eff_ot(nmasshyp)
      real overlap_ttz_eff(nmasshyp)
      real overlap_hatt_eff_bb(nmasshyp), overlap_hatt_eff_tt(nmasshyp),
     $     overlap_hatt_eff_cc(nmasshyp), overlap_hatt_eff_ot(nmasshyp)
      
      data masshyp / 60., 65., 70., 75., 80., 85., 90., 95., 100.,
     $     105., 107., 110., 115., 120. /

      data overlap_htt_eff_bb / 0.2125, 0.2643, 0.2994, 0.3388, 0.3567,
     $     0.3718, 0.3584, 0.3519, 0.3453, 0.3046, 0.2738, 0.2177,
     $     0.1484, 0.1042 /
      data overlap_htt_eff_tt / 0.001302, 0., 0., 0.002384, 0.002454,
     $     0.006002, 0.007982, 0.003717, 0., 0.002448, 0., 0.001326,
     $     0.001193, 0. /
      data overlap_htt_eff_cc / 0.01379, 0.04, 0.07087, 0.08511,
     $     0.1458, 0.14, 0.1275, 0.1503, 0.08772, 0.07143, 0.02778,
     $     0.02222, 0.01575, 0.01818 /
      data overlap_htt_eff_ot / 0.02662, 0.01007, 0.02950, 0.07949,
     $     0.05852, 0.1183, 0.09515, 0.08718, 0.07143, 0.05327,
     $     0.03640, 0.02606, 0.01574, 0.01356 /
      data overlap_ttz_eff / 0.0257, 0.0359, 0.0567, 0.0764, 0.0832,
     $     0.0987, 0.0961, 0.0961, 0.0846, 0.0620, 0.0553, 0.0432,
     $     0.0275, 0.0207 /
      data overlap_hatt_eff_bb / 0.1685, 0.2168, 0.2809, 0.3372, 0.3941,
     $     0.4093, 0.3996, 0.3836, 0.2084, 0.1371, 0.1155, 0.09251,
     $     0.06615, 0.04266 /
      data overlap_hatt_eff_tt / 0., 0.002392, 0.001136, 0., 0.004728,
     $     0.003534, 0.001127, 0.001100, 0.002134, 0., 0., 0.001034,
     $     0.001025, 0. /
      data overlap_hatt_eff_cc / 0., 0., 0., 0., 0., 0., 0., 0.,
     $     0., 0., 0., 0., 0., 0. /
      data overlap_hatt_eff_ot / 0.02128, 0., 0.03571, 0., 0.07692,
     $     0.1707, 0.16, 0.1, 0., 0., 0.01887, 0., 0., 0. /

      xmh = mh
      if (ityp.eq.1) then
         A196_tt_overlap_eff = fint(1, xmh, nmasshyp, masshyp,
     $        overlap_htt_eff_bb)
      else if (ityp.eq.2) then
         A196_tt_overlap_eff = fint(1, xmh, nmasshyp, masshyp,
     $        overlap_htt_eff_tt)
      else if (ityp.eq.3) then
         A196_tt_overlap_eff = fint(1, xmh, nmasshyp, masshyp,
     $        overlap_htt_eff_cc)
      else if (ityp.eq.4) then
         A196_tt_overlap_eff = fint(1, xmh, nmasshyp, masshyp,
     $        overlap_htt_eff_ot)
      else if (ityp.eq.5) then
         A196_tt_overlap_eff = fint(1, xmh, nmasshyp, masshyp,
     $        overlap_ttz_eff)
      else if (ityp.eq.6) then
         A196_tt_overlap_eff = fint(1, xmh, nmasshyp, masshyp,
     $        overlap_hatt_eff_bb)
      else if (ityp.eq.7) then
         A196_tt_overlap_eff = fint(1, xmh, nmasshyp, masshyp,
     $        overlap_hatt_eff_tt)
      else if (ityp.eq.8) then
         A196_tt_overlap_eff = fint(1, xmh, nmasshyp, masshyp,
     $        overlap_hatt_eff_cc)
      else if (ityp.eq.9) then
         A196_tt_overlap_eff = fint(1, xmh, nmasshyp, masshyp,
     $        overlap_hatt_eff_ot)
      endif
      return
      end


C 
C---- New file --- 
C 
      real*8 function A200_tt_haonly_eff(mh, ityp)
C Uses the CERNLIB interpolation routine FINT
C ITYP: 1=HZ->bbtt, 2=HZ->tttt, 3=HZ->cctt, 4=HZ->(other)tt,
C       5=ttZ
C       6=hA->bbtt, 7=hA->tttt, 8=hA->cctt, 9=hA->(other)tt 
      implicit none
      real*8 mh
      integer ityp
      integer nmasshyp
      parameter (nmasshyp=14)
      real xmh, masshyp(nmasshyp), fint
      real haonly_htt_eff_bb(nmasshyp), haonly_htt_eff_tt(nmasshyp),
     $     haonly_htt_eff_cc(nmasshyp), haonly_htt_eff_ot(nmasshyp) 
      real haonly_ttz_eff(nmasshyp)
      real haonly_hatt_eff_bb(nmasshyp), haonly_hatt_eff_tt(nmasshyp),
     $     haonly_hatt_eff_cc(nmasshyp), haonly_hatt_eff_ot(nmasshyp)
      
      data masshyp / 60., 65., 70., 75., 80., 85., 90., 95., 100.,
     $     105., 107., 110., 115., 120. /

      data haonly_htt_eff_bb / 0.01133, 0.009865, 0.008885, 0.008940,
     $     0.008092, 0.009355, 0.01180, 0.01269, 0.01035, 0.006216,
     $     0.006060, 0.005712, 0.004300, 0.001924 /
      data haonly_htt_eff_tt / 0., 0., 0., 0., 0., 0., 0., 0.,
     $     0.001212, 0.002257, 0., 0., 0.001277, 0. /
      data haonly_htt_eff_cc / 0.006369, 0., 0.06419, 0.007143,
     $     0.006098, 0.005714, 0.007092, 0., 0., 0., 0.007194, 0.,
     $     0., 0.007752 /
      data haonly_htt_eff_ot / 0., 0.003460, 0.008671, 0.005420,
     $     0.002625, 0.002096, 0., 0.001675, 0.004098, 0., 0.002062,
     $     0.001862, 0.0007158, 0. /
      data haonly_ttz_eff / 0.0054, 0.0069, 0.0086, 0.0062, 0.0040,
     $     0.0047, 0.0037, 0.0045, 0.0029, 0.0031, 0.0024, 0.0021,
     $     0.0021, 0.0027 / 
      data haonly_hatt_eff_bb / 0.1866, 0.1655, 0.1425, 0.09503,
     $     0.03660, 0.01574, 0.01189, 0.01345, 0.01144, 0.008650,
     $     0.006331, 0.006272, 0.003117, 0.003375 /
      data haonly_hatt_eff_tt / 0.002342, 0.002334, 0.005708,
     $     0.002460, 0.001155, 0., 0., 0., 0., 0., 0., 0., 0.,
     $     0.01874 /
      data haonly_hatt_eff_cc / 0., 0., 0., 0., 0., 0., 0., 0.,
     $     0., 0., 0., 0., 0., 0. /
      data haonly_hatt_eff_ot / 0.05714, 0.09524, 0.09756, 0., 0.,
     $     0., 0., 0., 0., 0., 0., 0., 0., 0. /

      xmh = mh
      if (ityp.eq.1) then
         A200_tt_haonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        haonly_htt_eff_bb)
      else if (ityp.eq.2) then
         A200_tt_haonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        haonly_htt_eff_tt)
      else if (ityp.eq.3) then
         A200_tt_haonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        haonly_htt_eff_cc)
      else if (ityp.eq.4) then
         A200_tt_haonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        haonly_htt_eff_ot)
      else if (ityp.eq.5) then
         A200_tt_haonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        haonly_ttz_eff)
      else if (ityp.eq.6) then
         A200_tt_haonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        haonly_hatt_eff_bb)
      else if (ityp.eq.7) then
         A200_tt_haonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        haonly_hatt_eff_tt)
      else if (ityp.eq.8) then
         A200_tt_haonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        haonly_hatt_eff_cc)
      else if (ityp.eq.9) then
         A200_tt_haonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        haonly_hatt_eff_ot)
      endif

      return
      end

C------------------------------------------------------------------

      real*8 function A200_tt_hzonly_eff(mh, ityp)
C Uses the CERNLIB interpolation routine FINT
C ITYP: 1=HZ->bbtt, 2=HZ->tttt, 3=HZ->cctt, 4=HZ->(other)tt,
C       5=ttZ
C       6=hA->bbtt, 7=hA->tttt, 8=hA->cctt, 9=hA->(other)tt 
      implicit none
      real*8 mh
      integer ityp
      integer nmasshyp
      parameter (nmasshyp=14)
      real xmh, masshyp(nmasshyp), fint
      real hzonly_htt_eff_bb(nmasshyp), hzonly_htt_eff_tt(nmasshyp),
     $     hzonly_htt_eff_cc(nmasshyp), hzonly_htt_eff_ot(nmasshyp)
      real hzonly_ttz_eff(nmasshyp)
      real hzonly_hatt_eff_bb(nmasshyp), hzonly_hatt_eff_tt(nmasshyp),
     $     hzonly_hatt_eff_cc(nmasshyp), hzonly_hatt_eff_ot(nmasshyp)
      
      data masshyp / 60., 65., 70., 75., 80., 85., 90., 95., 100.,
     $     105., 107., 110., 115., 120. /

      data hzonly_htt_eff_bb / 0.1894, 0.1618, 0.1287, 0.1101,
     $     0.09456, 0.08489, 0.08802, 0.09490, 0.09888, 0.1113,
     $     0.1192, 0.1339, 0.1514, 0.1586 /
      data hzonly_htt_eff_tt / 0.01595, 0.02041, 0.02524, 0.03645,
     $     0.03234, 0.03267, 0.04835, 0.04311, 0.05454, 0.05530,
     $     0.04845, 0.04903, 0.03321, 0.01405 /
      data hzonly_htt_eff_cc / 0.1529, 0.2188, 0.2179, 0.2571, 0.2317,
     $     0.2800, 0.2979, 0.2174, 0.2231, 0.2946, 0.2734, 0.1754,
     $     0.1438, 0.1008 /
      data hzonly_htt_eff_ot / 0.1512, 0.1765, 0.1965, 0.2547, 0.2152,
     $     0.2327, 0.2239, 0.2647, 0.2309, 0.2192, 0.2196, 0.1667,
     $     0.1238, 0.07726 /
      data hzonly_ttz_eff / 0.1440, 0.1547, 0.1675, 0.1762, 0.1775,
     $     0.1879, 0.1869, 0.2019, 0.2004, 0.2082, 0.1996, 0.1841,
     $     0.1394, 0.1069 / 
      data hzonly_hatt_eff_bb / 0.02546, 0.02934, 0.03028, 0.03779,
     $     0.05440, 0.06855, 0.08391, 0.09438, 0.1123, 0.1309, 0.1313,
     $     0.1318, 0.1263, 0.1145 /
      data hzonly_hatt_eff_tt / 0.01874, 0.00335, 0.01370, 0.01845,
     $     0.03118, 0.02941, 0.04617, 0.05463, 0.03313, 0.02128,
     $     0.01893, 0.02137, 0.01336, 0.009569 /
      data hzonly_hatt_eff_cc / 0., 0., 0., 0., 0., 0., 0., 0.,
     $     0., 0., 0., 0., 0., 0. /
      data hzonly_hatt_eff_ot / 0.05714, 0.04762, 0.07317, 0.06250,
     $     0.2286, 0.1429, 0.2581, 0.3030, 0.2333, 0.1395, 0.04444, 0.,
     $     0.02273, 0.03030 /

      xmh = mh
      if (ityp.eq.1) then
         A200_tt_hzonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        hzonly_htt_eff_bb)
      else if (ityp.eq.2) then
         A200_tt_hzonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        hzonly_htt_eff_tt)
      else if (ityp.eq.3) then
         A200_tt_hzonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        hzonly_htt_eff_cc)
      else if (ityp.eq.4) then
         A200_tt_hzonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        hzonly_htt_eff_ot)
      else if (ityp.eq.5) then
         A200_tt_hzonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        hzonly_ttz_eff)
      else if (ityp.eq.6) then
         A200_tt_hzonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        hzonly_hatt_eff_bb)
      else if (ityp.eq.7) then
         A200_tt_hzonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        hzonly_hatt_eff_tt)
      else if (ityp.eq.8) then
         A200_tt_hzonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        hzonly_hatt_eff_cc)
      else if (ityp.eq.9) then
         A200_tt_hzonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        hzonly_hatt_eff_ot)
      endif

      return
      end

C------------------------------------------------------------------

      real*8 function A200_tt_overlap_eff(mh, ityp)
C Uses the CERNLIB interpolation routine FINT
C ITYP: 1=HZ->bbtt, 2=HZ->tttt, 3=HZ->cctt, 4=HZ->(other)tt,
C       5=ttZ
C       6=hA->bbtt, 7=hA->tttt, 8=hA->cctt, 9=hA->(other)tt 
      implicit none
      real*8 mh
      integer ityp
      integer nmasshyp
      parameter (nmasshyp=14)
      real xmh, masshyp(nmasshyp), fint
      real overlap_htt_eff_bb(nmasshyp), overlap_htt_eff_tt(nmasshyp),
     $     overlap_htt_eff_cc(nmasshyp), overlap_htt_eff_ot(nmasshyp)
      real overlap_ttz_eff(nmasshyp)
      real overlap_hatt_eff_bb(nmasshyp), overlap_hatt_eff_tt(nmasshyp),
     $     overlap_hatt_eff_cc(nmasshyp), overlap_hatt_eff_ot(nmasshyp)
      
      data masshyp / 60., 65., 70., 75., 80., 85., 90., 95., 100.,
     $     105., 107., 110., 115., 120. /

      data overlap_htt_eff_bb / 0.2103, 0.2553, 0.3043, 0.3319, 0.3604,
     $     0.3634, 0.3763, 0.3656, 0.3527, 0.3466, 0.3219, 0.2808,
     $     0.2039, 0.1306 /
      data overlap_htt_eff_tt / 0.001227, 0.002401, 0.006010, 0.006834,
cptd     $     0.001244, 0.001256, 0.002358, 0.003593, 0.1846, 0.1318,
     $     0.001244, 0.001256, 0.002358, 0.003593, 0., 0.,
     $     0.003727, 0.004561, 0., 0. /
      data overlap_htt_eff_cc / 0.03822, 0.05625, 0.08974, 0.06429,
     $     0.1585, 0.1257, 0.1135, 0.1304, 0.1846, 0.1317, 0.07914,
     $     0.05263, 0.04110, 0.007752 /
      data overlap_htt_eff_ot / 0.02749, 0.02768, 0.02023, 0.06233,
     $     0.08924, 0.1174, 0.1045, 0.09715, 0.06967, 0.05385, 0.06082,
     $     0.03631, 0.01933, 0.01876 /
      data overlap_ttz_eff / 0.0266, 0.0387, 0.0539, 0.0734, 0.0883,
     $     0.1023, 0.1033, 0.1008, 0.0879, 0.0765, 0.0721, 0.0555,
     $     0.0400, 0.0237 /
      data overlap_hatt_eff_bb / 0.1816, 0.2258, 0.2756, 0.3478,
     $     0.4000, 0.4302, 0.4179, 0.3959, 0.3251, 0.1632, 0.1508,
     $     0.1144, 0.07548, 0.05974 /
      data overlap_hatt_eff_tt / 0.002342, 0.001167, 0.001142,
     $     0.007380, 0.004619, 0.001131, 0.002252, 0.003344, 0.002070,
     $     0., 0.001052, 0., 0., 0. /
      data overlap_hatt_eff_cc / 0., 0., 0., 0., 0., 0., 0., 0.,
     $     0., 0., 0., 0., 0., 0. /
      data overlap_hatt_eff_ot / 0., 0.02381, 0., 0., 0.1143, 0.03571,
     $     0.03226, 0.06061, 0.1333, 0., 0., 0., 0., 0. /

      xmh = mh
      if (ityp.eq.1) then
         A200_tt_overlap_eff = fint(1, xmh, nmasshyp, masshyp,
     $        overlap_htt_eff_bb)
      else if (ityp.eq.2) then
         A200_tt_overlap_eff = fint(1, xmh, nmasshyp, masshyp,
     $        overlap_htt_eff_tt)
      else if (ityp.eq.3) then
         A200_tt_overlap_eff = fint(1, xmh, nmasshyp, masshyp,
     $        overlap_htt_eff_cc)
      else if (ityp.eq.4) then
         A200_tt_overlap_eff = fint(1, xmh, nmasshyp, masshyp,
     $        overlap_htt_eff_ot)
      else if (ityp.eq.5) then
         A200_tt_overlap_eff = fint(1, xmh, nmasshyp, masshyp,
     $        overlap_ttz_eff)
      else if (ityp.eq.6) then
         A200_tt_overlap_eff = fint(1, xmh, nmasshyp, masshyp,
     $        overlap_hatt_eff_bb)
      else if (ityp.eq.7) then
         A200_tt_overlap_eff = fint(1, xmh, nmasshyp, masshyp,
     $        overlap_hatt_eff_tt)
      else if (ityp.eq.8) then
         A200_tt_overlap_eff = fint(1, xmh, nmasshyp, masshyp,
     $        overlap_hatt_eff_cc)
      else if (ityp.eq.9) then
         A200_tt_overlap_eff = fint(1, xmh, nmasshyp, masshyp,
     $        overlap_hatt_eff_ot)
      endif

      return
      end


C 
C---- New file --- 
C 
      real*8 function A202_tt_haonly_eff(mh, ityp)
C Uses the CERNLIB interpolation routine FINT
C ITYP: 1=HZ->bbtt, 2=HZ->tttt, 3=HZ->cctt, 4=HZ->(other)tt,
C       5=ttZ
C       6=hA->bbtt, 7=hA->tttt, 8=hA->cctt, 9=hA->(other)tt 
      implicit none
      real*8 mh
      integer ityp
      integer nmasshyp
      parameter (nmasshyp=14)
      real xmh, masshyp(nmasshyp), fint
      real haonly_htt_eff_bb(nmasshyp), haonly_htt_eff_tt(nmasshyp),
     $     haonly_htt_eff_cc(nmasshyp), haonly_htt_eff_ot(nmasshyp)
      real haonly_ttz_eff(nmasshyp)
      real haonly_hatt_eff_bb(nmasshyp), haonly_hatt_eff_tt(nmasshyp),
     $     haonly_hatt_eff_cc(nmasshyp), haonly_hatt_eff_ot(nmasshyp)
      
      data masshyp / 60., 65., 70., 75., 80., 85., 90., 95., 100.,
     $     105., 107., 110., 115., 120. /

      data haonly_htt_eff_bb / 0.009051, 0.009782, 0.007452, 0.007773,
     $     0.007348, 0.007678, 0.01302, 0.01138, 0.009282, 0.005863,
     $     0.005890, 0.004608, 0.004116, 0.001502 /
      data haonly_htt_eff_tt / 0., 0., 0., 0., 0., 0., 0., 0.,
     $     0., 0., 0., 0., 0., 0. /
      data haonly_htt_eff_cc / 0., 0.01852, 0., 0.006667, 0., 0.,
     $     0.006410, 0., 0.007813, 0.006494, 0.006289, 0., 0., 0. /
      data haonly_htt_eff_ot / 0., 0.007576, 0., 0.005168, 0.002232,
     $     0.004329, 0.001866, 0.001698, 0.004298, 0., 0., 0.001925,
     $     0.001514, 0. /
      data haonly_ttz_eff / 0.0046, 0.0053, 0.0065, 0.0065, 0.0059,
     $     0.0056, 0.0053, 0.0039, 0.0043, 0.0032, 0.0030, 0.0024,
     $     0.0021, 0.0022 / 
      data haonly_hatt_eff_bb / 0.1842, 0.1661, 0.1399, 0.08951,
     $     0.03321, 0.01600, 0.01187, 0.01311, 0.01156, 0.01047,
     $     0.009089, 0.005466, 0.004902, 0.004260 /
      data haonly_hatt_eff_tt / 0.003681, 0.001116, 0.006904, 0.005605,
     $     0., 0., 0., 0., 0.001019, 0., 0., 0., 0., 0./
      data haonly_hatt_eff_cc / 0., 0., 0., 0., 0., 0., 0., 0.,
     $     0., 0., 0., 0., 0., 0. /
      data haonly_hatt_eff_ot / 0.1429, 0.05455, 0.1333, 0.08000, 0.,
     $     0.06250, 0., 0., 0., 0., 0., 0., 0., 0. /

      xmh = mh
      if (ityp.eq.1) then
         A202_tt_haonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        haonly_htt_eff_bb)
      else if (ityp.eq.2) then
         A202_tt_haonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        haonly_htt_eff_tt)
      else if (ityp.eq.3) then
         A202_tt_haonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        haonly_htt_eff_cc)
      else if (ityp.eq.4) then
         A202_tt_haonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        haonly_htt_eff_ot)
      else if (ityp.eq.5) then
         A202_tt_haonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        haonly_ttz_eff)
      else if (ityp.eq.6) then
         A202_tt_haonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        haonly_hatt_eff_bb)
      else if (ityp.eq.7) then
         A202_tt_haonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        haonly_hatt_eff_tt)
      else if (ityp.eq.8) then
         A202_tt_haonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        haonly_hatt_eff_cc)
      else if (ityp.eq.9) then
         A202_tt_haonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        haonly_hatt_eff_ot)
      endif

      return
      end

C------------------------------------------------------------------

      real*8 function A202_tt_hzonly_eff(mh, ityp)
C Uses the CERNLIB interpolation routine FINT
C ITYP: 1=HZ->bbtt, 2=HZ->tttt, 3=HZ->cctt, 4=HZ->(other)tt,
C       5=ttZ
C       6=hA->bbtt, 7=hA->tttt, 8=hA->cctt, 9=hA->(other)tt 
      implicit none
      real*8 mh
      integer ityp
      integer nmasshyp
      parameter (nmasshyp=14)
      real xmh, masshyp(nmasshyp), fint
      real hzonly_htt_eff_bb(nmasshyp), hzonly_htt_eff_tt(nmasshyp),
     $     hzonly_htt_eff_cc(nmasshyp), hzonly_htt_eff_ot(nmasshyp)
      real hzonly_ttz_eff(nmasshyp)
      real hzonly_hatt_eff_bb(nmasshyp), hzonly_hatt_eff_tt(nmasshyp),
     $     hzonly_hatt_eff_cc(nmasshyp), hzonly_hatt_eff_ot(nmasshyp)
      
      data masshyp / 60., 65., 70., 75., 80., 85., 90., 95., 100.,
     $     105., 107., 110., 115., 120. /

      data hzonly_htt_eff_bb / 0.1978, 0.1639, 0.1264, 0.1077, 0.08771,
     $     0.08190, 0.08142, 0.08755, 0.09716, 0.1068, 0.1137, 0.1301,
     $     0.1504, 0.1626 /
      data hzonly_htt_eff_tt / 0.01684, 0.03069, 0.02049, 0.03084,
     $     0.05168, 0.04523, 0.04662, 0.04380, 0.04328, 0.05919,
     $     0.03965, 0.04282, 0.03342, 0.02766 /
      data hzonly_htt_eff_cc / 0.2026, 0.2716, 0.1469, 0.2933, 0.1233,
     $     0.2581, 0.2436, 0.2432, 0.2500, 0.2403, 0.2453, 0.1971,
     $     0.1587, 0.1154 /
      data hzonly_htt_eff_ot / 0.1822, 0.1174, 0.1983, 0.2377, 0.2478,
     $     0.2208, 0.2407, 0.2292, 0.2120, 0.2208, 0.1946, 0.2031,
     $     0.1257, 0.07405 /
      data hzonly_ttz_eff / 0.1536, 0.1673, 0.1709, 0.1760, 0.1881,
     $     0.1836, 0.1800, 0.1952, 0.1966, 0.2000, 0.2048, 0.1957,
     $     0.1539, 0.1187 / 
      data hzonly_hatt_eff_bb / 0.02712, 0.02796, 0.03219, 0.03853,
     $     0.05667, 0.07062, 0.07617, 0.09000, 0.1049, 0.1310,
     $     0.1354, 0.1401, 0.1312, 0.1228 /
      data hzonly_hatt_eff_tt / 0.01963, 0.02344, 0.01611, 0.02242,
     $     0.02579, 0.02759, 0.04114, 0.04153, 0.05287, 0.01937,
     $     0.01293, 0.01220, 0.01445, 0.008806 /
      data hzonly_hatt_eff_cc / 0., 0., 0., 0., 0., 0., 0., 0.,
     $     0., 0., 0., 0., 0., 0. /
      data hzonly_hatt_eff_ot / 0.02381, 0.03636, 0.1000, 0., 0.1667,
     $     0.1250, 0.07407, 0.2258, 0.3333, 0.1111, 0.04000, 0.03922,
     $     0., 0.01724 /

      xmh = mh
      if (ityp.eq.1) then
         A202_tt_hzonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        hzonly_htt_eff_bb)
      else if (ityp.eq.2) then
         A202_tt_hzonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        hzonly_htt_eff_tt)
      else if (ityp.eq.3) then
         A202_tt_hzonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        hzonly_htt_eff_cc)
      else if (ityp.eq.4) then
         A202_tt_hzonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        hzonly_htt_eff_ot)
      else if (ityp.eq.5) then
         A202_tt_hzonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        hzonly_ttz_eff)
      else if (ityp.eq.6) then
         A202_tt_hzonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        hzonly_hatt_eff_bb)
      else if (ityp.eq.7) then
         A202_tt_hzonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        hzonly_hatt_eff_tt)
      else if (ityp.eq.8) then
         A202_tt_hzonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        hzonly_hatt_eff_cc)
      else if (ityp.eq.9) then
         A202_tt_hzonly_eff = fint(1, xmh, nmasshyp, masshyp,
     $        hzonly_hatt_eff_ot)
      endif

      return
      end

C------------------------------------------------------------------

      real*8 function A202_tt_overlap_eff(mh, ityp)
C Uses the CERNLIB interpolation routine FINT
C ITYP: 1=HZ->bbtt, 2=HZ->tttt, 3=HZ->cctt, 4=HZ->(other)tt,
C       5=ttZ
C       6=hA->bbtt, 7=hA->tttt, 8=hA->cctt, 9=hA->(other)tt 
      implicit none
      real*8 mh
      integer ityp
      integer nmasshyp
      parameter (nmasshyp=14)
      real xmh, masshyp(nmasshyp), fint
      real overlap_htt_eff_bb(nmasshyp), overlap_htt_eff_tt(nmasshyp),
     $     overlap_htt_eff_cc(nmasshyp), overlap_htt_eff_ot(nmasshyp)
      real overlap_ttz_eff(nmasshyp)
      real overlap_hatt_eff_bb(nmasshyp), overlap_hatt_eff_tt(nmasshyp),
     $     overlap_hatt_eff_cc(nmasshyp), overlap_hatt_eff_ot(nmasshyp)
      
      data masshyp / 60., 65., 70., 75., 80., 85., 90., 95., 100.,
     $     105., 107., 110., 115., 120. /

      data overlap_htt_eff_bb / 0.2148, 0.2642, 0.3110, 0.3432,
     $     0.3642, 0.3782, 0.3643, 0.3632, 0.3573, 0.3443, 0.3356,
     $     0.3209, 0.2189, 0.1473 /
      data overlap_htt_eff_tt / 0., 0.002558, 0.002561, 0.003559,
     $     0.001202, 0.002445, 0.002331, 0.002433, 0.001139, 0.003699,
     $     0.008674, 0.001259, 0.002571, 0.001383 /
      data overlap_htt_eff_cc / 0.02614, 0.04938, 0.04196, 0.1067,
     $     0.1644, 0.1129, 0.1987, 0.1554, 0.1328, 0.1104, 0.08805,
     $     0.05839, 0.05556, 0.03077 /
      data overlap_htt_eff_ot / 0.01695, 0.01515, 0.04533, 0.04134,
     $     0.1071, 0.1342, 0.1119, 0.1070, 0.08166, 0.06494, 0.05204,
     $     0.04139, 0.03331, 0.01591 /
      data overlap_ttz_eff / 0.0275, 0.0437, 0.0556, 0.0736, 0.0973,
     $     0.1154, 0.1089, 0.1060, 0.0922, 0.0813, 0.0737, 0.0650,
     $     0.0445, 0.0298 /
      data overlap_hatt_eff_bb / 0.1792, 0.2309, 0.2913, 0.3540,
     $     0.4073, 0.4274, 0.4243, 0.4066, 0.3651, 0.1888, 0.1567,
     $     0.1233, 0.08879, 0.06312 /
      data overlap_hatt_eff_tt / 0., 0.002232, 0., 0.002242, 0.002345,
     $     0.008830, 0.01029, 0.004489, 0.002250, 0., 0.002155,
     $     0.002033, 0., 0. /
      data overlap_hatt_eff_cc / 0., 0., 0., 0., 0., 0., 0., 0.,
     $     0., 0., 0., 0., 0., 0. /
      data overlap_hatt_eff_ot / 0., 0.01818, 0., 0.0800, 0.1250,
     $     0.09375, 0.07407, 0.06452, 0., 0.02222, 0., 0., 0., 0. /

      xmh = mh
      if (ityp.eq.1) then
         A202_tt_overlap_eff = fint(1, xmh, nmasshyp, masshyp,
     $        overlap_htt_eff_bb)
      else if (ityp.eq.2) then
         A202_tt_overlap_eff = fint(1, xmh, nmasshyp, masshyp,
     $        overlap_htt_eff_tt)
      else if (ityp.eq.3) then
         A202_tt_overlap_eff = fint(1, xmh, nmasshyp, masshyp,
     $        overlap_htt_eff_cc)
      else if (ityp.eq.4) then
         A202_tt_overlap_eff = fint(1, xmh, nmasshyp, masshyp,
     $        overlap_htt_eff_ot)
      else if (ityp.eq.5) then
         A202_tt_overlap_eff = fint(1, xmh, nmasshyp, masshyp,
     $        overlap_ttz_eff)
      else if (ityp.eq.6) then
         A202_tt_overlap_eff = fint(1, xmh, nmasshyp, masshyp,
     $        overlap_hatt_eff_bb)
      else if (ityp.eq.7) then
         A202_tt_overlap_eff = fint(1, xmh, nmasshyp, masshyp,
     $        overlap_hatt_eff_tt)
      else if (ityp.eq.8) then
         A202_tt_overlap_eff = fint(1, xmh, nmasshyp, masshyp,
     $        overlap_hatt_eff_cc)
      else if (ityp.eq.9) then
         A202_tt_overlap_eff = fint(1, xmh, nmasshyp, masshyp,
     $        overlap_hatt_eff_ot)
      endif

      return
      end


