C++++++++++++++++++++++++++++++++++++++++++++++++
C-           External functions                 +
C++++++++++++++++++++++++++++++++++++++++++++++++
C        The sigmoid function is also define here
C------------------------------------------------
C-           Candidates functions
C------------------------------------------------
      INTEGER FUNCTION A_ZHGG_NUMCAND(SQRTS)
      IMPLICIT NONE
      DOUBLE PRECISION SQRTS
      INTEGER I
      include 'a_zhgg_candid.inc'
      include 'a_zhgg_91_210_decl.inc'
      include 'a_zhgg_ext_shape.inc'
      include 'a_inputs.inc'
      a_zhgg_numcand = 0 
      if ( sqrts.LE.189.5D0 ) then
        do i = 1,numcand
          if ( energy_cand(i).LE.189.5D0 ) THEN
            a_zhgg_numcand = a_zhgg_numcand + 1
          endif
        enddo
      else
        do i = 1,numcand
          if ( abs(sqrts-energy_cand(i)).le.0.25D0 ) then
            a_zhgg_numcand = a_zhgg_numcand + 1
          endif
        enddo
      endif
      RETURN
      END
*
      REAL FUNCTION A_ZHGG_MASS_CAND(SQRTS,NUM)
      IMPLICIT NONE
      INTEGER NUM
      DOUBLE PRECISION SQRTS
      INTEGER I,NUMC
      include 'a_zhgg_candid.inc'
      include 'a_zhgg_91_210_decl.inc'
      include 'a_zhgg_ext_shape.inc'
      include 'a_inputs.inc'
      numc = 0
      if ( sqrts.LE.189.5D0 ) then
        do i = 1,numcand
          if ( energy_cand(i).LE.189.5D0 ) THEN
            numc = numc + 1
            if ( numc.EQ.num ) a_zhgg_mass_cand = mass_cand(i)
          endif
        enddo
      else
        do i = 1,numcand
          if ( abs(sqrts-energy_cand(i)).le.0.25D0 ) then
            numc = numc + 1
            if ( numc.EQ.num ) a_zhgg_mass_cand = mass_cand(i)
          endif
        enddo
      endif
      RETURN
      END
C------------------------------------------------
C           Signal efficiency and shape
C------------------------------------------------
C
C         Efficiency from sqrts= 88 -> 210. using linear interpolation
C           and mh=1.->130
C
      REAL FUNCTION A_ZHGG_EFF_88_210(X,Y)
C           Make a linear interpolation to
C               compute the efficiency at different
C               LEP energies. Efficiency in %
C           X = Higgs mass in GeV
C           Y = SQRTS in GeV
      IMPLICIT NONE
      include 'a_zhgg_ext_shape.inc'
      REAL X,Y,YL,YH,EL,EH
      IF ( Y.LE.95. ) THEN
        A_ZHGG_EFF_88_210 = EFF_91(X)
      ELSEIF ( Y.LT.120. ) THEN
        YL = 91.
        YH = 133.
        EL = EFF_91(X)
        EH = EFF_133(X)
        A_ZHGG_EFF_88_210 = (EL-EH)/(YL-YH)*(Y-YL)+EL
      ELSEIF ( Y.LE.129. ) THEN
        YL = 133.
        YH = 161.
        EL = EFF_133(X)
        EH = EFF_161(X)
        A_ZHGG_EFF_88_210 = (EL-EH)/(YL-YH)*(Y-YL)+EL
      ELSEIF ( Y.LE.136. ) THEN
        A_ZHGG_EFF_88_210 = EFF_133(X)
      ELSEIF ( Y.LE.160. ) THEN
        YL = 133.
        YH = 161.
        EL = EFF_133(X)
        EH = EFF_161(X)
        A_ZHGG_EFF_88_210 = (EL-EH)/(YL-YH)*(Y-YL)+EL
      ELSEIF ( Y.LT.170. ) THEN
        YL = 161.
        YH = 172.
        EL = EFF_161(X)
        EH = EFF_172(X)
        A_ZHGG_EFF_88_210 = (EL-EH)/(YL-YH)*(Y-YL)+EL
      ELSEIF ( Y.LE.183. ) THEN
        YL = 172.
        YH = 183.
        EL = EFF_172(X)
        EH = EFF_183(X)
        A_ZHGG_EFF_88_210 = (EL-EH)/(YL-YH)*(Y-YL)+EL
      ELSEIF ( Y.LE.188. ) THEN
        YL = 183.
        YH = 189.
        EL = EFF_183(X)
        EH = EFF_189(X)
        A_ZHGG_EFF_88_210 = (EL-EH)/(YL-YH)*(Y-YL)+EL
      ELSEIF ( Y.LE.192. ) THEN
        YL = 189.
        YH = 192.
        EL = EFF_189(X)
        EH = EFF_192(X)
        A_ZHGG_EFF_88_210 = (EL-EH)/(YL-YH)*(Y-YL)+EL
      ELSEIF ( Y.LE.196. ) THEN
        YL = 192.
        YH = 196.
        EL = EFF_192(X)
        EH = EFF_196(X)
        A_ZHGG_EFF_88_210 = (EL-EH)/(YL-YH)*(Y-YL)+EL
      ELSEIF ( Y.LE.200. ) THEN
        YL = 196.
        YH = 200.
        EL = EFF_196(X)
        EH = EFF_200(X)
        A_ZHGG_EFF_88_210 = (EL-EH)/(YL-YH)*(Y-YL)+EL
      ELSEIF (Y.LE.202. ) THEN
        YL = 200.
        YH = 202.
        EL = EFF_200(X)
        EH = EFF_202(X)
        A_ZHGG_EFF_88_210 = (EL-EH)/(YL-YH)*(Y-YL)+EL
      ELSEIF ( Y.LE.204. ) THEN
        YL = 202.
        YH = 204.
        EL = EFF_202(X)
        EH = EFF_204(X)
        A_ZHGG_EFF_88_210 = (EL-EH)/(YL-YH)*(Y-YL)+EL
      ELSEIF ( Y.LE.206. ) THEN
        YL = 204.
        YH = 206.
        EL = EFF_204(X)
        EH = EFF_206(X)
        A_ZHGG_EFF_88_210 = (EL-EH)/(YL-YH)*(Y-YL)+EL
      ELSE
        A_ZHGG_EFF_88_210 = EFF_206(X)
      ENDIF
      RETURN
      END
C
C          Signal shape
C
      DOUBLE PRECISION FUNCTION A_ZHGG_SIG_SHAPE(X,MH,SQRTS)
      IMPLICIT NONE
      DOUBLE PRECISION MH,SQRTS,X
      REAl SIGMA,DELTAM
      include 'a_zhgg_ext_shape.inc'

      IF ( SQRTS.LE.189.5D0 ) THEN
        sigma = 0.0726423+0.0326745*real(mh)
        deltam = 0.
      ELSEIF ( SQRTS.LE.192.D0 ) THEN
        sigma = sigma_192(real(mh))
        deltam = mean_192(real(mh))
      ELSEIF ( SQRTS.LE.197.D0 ) THEN
        sigma = sigma_196(real(mh))
        deltam = mean_196(real(mh))
      ELSEIF ( SQRTS.LE.200.D0 ) THEN
        sigma = sigma_200(real(mh))
        deltam = mean_200(real(mh))
      ELSE
        sigma = sigma_202(real(mh))
        deltam = mean_202(real(mh))
      ENDIF
      IF ( sigma.LE.0.01 ) sigma = 0.1
      if ( (abs(real(x-mh)+deltam))/sigma.LE.5. ) THEN
      A_ZHGG_SIG_SHAPE=DBLE(exp(-(real(x-mh)+deltam)**2/(2.*sigma**2))
     &                /(sigma*sqrt(2.*3.1415926)))       
      else
         A_ZHGG_SIG_SHAPE = 0.D0
      ENDIF
      RETURN
      END
C
C               Background shape
C
      REAL FUNCTION a_zhgg_bkg(mh)
C             Return the number of expected bkg events
C             for a given higgs mass ( summed over all
C             LEP energy since 1991)
      include 'a_zhgg_91_210_decl.inc'
      include 'a_zhgg_ext_shape.inc'
      include 'a_inputs.inc'
      real mh
      integer i
C            total background shape      
      a_zhgg_bkg = 0.
      do i = 1,a_maxnener
        if ( i.le.35 ) THEN
          if ( A_HZGG_GSQRTS(i).LE.189.5 ) then
            a_zhgg_bkg = a_zhgg_bkg +
     &       A_HZGG_GLUMI(i)*A_HZGG_GBKG(i)*bkg_91_98(mh)
          elseif ( A_HZGG_GSQRTS(i).LE.192.5 ) then
            a_zhgg_bkg = a_zhgg_bkg +
     &       A_HZGG_GLUMI(i)*A_HZGG_GBKG(i)*bkg_192_cut(mh)
          elseif ( A_HZGG_GSQRTS(i).LE.196.5 ) then
            a_zhgg_bkg = a_zhgg_bkg +
     &       A_HZGG_GLUMI(i)*A_HZGG_GBKG(i)*bkg_196_cut(mh)
          elseif ( A_HZGG_GSQRTS(i).LE.200.5 ) then
            a_zhgg_bkg = a_zhgg_bkg +
     &       A_HZGG_GLUMI(i)*A_HZGG_GBKG(i)*bkg_200_cut(mh)
          elseif ( A_HZGG_GSQRTS(i).LE.202.5 ) then
            a_zhgg_bkg = a_zhgg_bkg +
     &       A_HZGG_GLUMI(i)*A_HZGG_GBKG(i)*bkg_202_cut(mh)
          elseif ( A_HZGG_GSQRTS(i).LE.209.5 ) then              ! bug: was 206.5 ???
            a_zhgg_bkg = a_zhgg_bkg +
     &       A_HZGG_GLUMI(i)*A_HZGG_GBKG(i)*bkg_2000(mh)
          endif
        endif
      enddo
      RETURN
      END
C
      DOUBLE PRECISION FUNCTION a_zhgg_bkg_mass(sqrts,mh,iana,ibkg)
C             shape of expected bkg events
C             for a given higgs mass and for a given
C             LEP energy. From 88 up to 189 is one point
C             iana,ibkg dummy
      IMPLICIT NONE
      include 'a_zhgg_91_210_decl.inc'
      include 'a_zhgg_ext_shape.inc'
      include 'a_inputs.inc'
      double precision mh,sqrts
      double precision sqrtsi
      integer i,iana,ibkg
C            total background shape      
      a_zhgg_bkg_mass = 0.D0
      if ( sqrts.LE.189.5D0 ) then
         do i = 1,15
            a_zhgg_bkg_mass = a_zhgg_bkg_mass +
     &          DBLE(A_HZGG_GLUMI(i)*A_HZGG_GBKG(i)*bkg_91_98(real(mh)))
         enddo
      elseif ( dabs(sqrts-191.6D0).le.1.D0 ) then
          a_zhgg_bkg_mass =
     &    DBLE(A_HZGG_GLUMI(16)*A_HZGG_GBKG(16)*bkg_192_cut(real(mh)))
      elseif ( dabs(sqrts-195.5D0).le.1.D0 ) then
          a_zhgg_bkg_mass = 
     &    DBLE(A_HZGG_GLUMI(17)*A_HZGG_GBKG(17)*bkg_196_cut(real(mh)))
      elseif ( dabs(sqrts-199.5D0).le.1.D0 ) then
          a_zhgg_bkg_mass =
     &    DBLE(A_HZGG_GLUMI(18)*A_HZGG_GBKG(18)*bkg_200_cut(real(mh)))
      elseif ( dabs(sqrts-201.6D0).le.0.25D0 ) then
          a_zhgg_bkg_mass =
     &    DBLE(A_HZGG_GLUMI(19)*A_HZGG_GBKG(19)*bkg_202_cut(real(mh)))
      elseif ( dabs(sqrts-202.5D0).le.0.25D0 ) then
          a_zhgg_bkg_mass =
     &    DBLE(A_HZGG_GLUMI(20)*A_HZGG_GBKG(20)*bkg_2000(real(mh)))
      elseif ( dabs(sqrts-203.D0).le.0.25D0 ) then
          a_zhgg_bkg_mass =
     &    DBLE(A_HZGG_GLUMI(21)*A_HZGG_GBKG(21)*bkg_2000(real(mh)))
      elseif ( dabs(sqrts-203.5D0).le.0.25D0 ) then
          a_zhgg_bkg_mass =
     &    DBLE(A_HZGG_GLUMI(22)*A_HZGG_GBKG(22)*bkg_2000(real(mh)))
      elseif ( dabs(sqrts-204.D0).le.0.25D0 ) then
          a_zhgg_bkg_mass =
     &    DBLE(A_HZGG_GLUMI(23)*A_HZGG_GBKG(23)*bkg_2000(real(mh)))
      elseif ( dabs(sqrts-204.5D0).le.0.25D0 ) then
          a_zhgg_bkg_mass =
     &    DBLE(A_HZGG_GLUMI(24)*A_HZGG_GBKG(24)*bkg_2000(real(mh)))
      elseif ( dabs(sqrts-205.D0).le.0.25D0 ) then
          a_zhgg_bkg_mass =
     &    DBLE(A_HZGG_GLUMI(25)*A_HZGG_GBKG(25)*bkg_2000(real(mh)))
      elseif ( dabs(sqrts-205.5D0).le.0.25D0 ) then
          a_zhgg_bkg_mass =
     &    DBLE(A_HZGG_GLUMI(26)*A_HZGG_GBKG(26)*bkg_2000(real(mh)))
      elseif ( dabs(sqrts-206.D0).le.0.25D0 ) then
          a_zhgg_bkg_mass =
     &    DBLE(A_HZGG_GLUMI(27)*A_HZGG_GBKG(27)*bkg_2000(real(mh)))
      elseif ( dabs(sqrts-206.5D0).le.0.25D0 ) then
          a_zhgg_bkg_mass =
     &    DBLE(A_HZGG_GLUMI(28)*A_HZGG_GBKG(28)*bkg_2000(real(mh)))
      elseif ( dabs(sqrts-207.D0).le.0.25D0 ) then
          a_zhgg_bkg_mass =
     &    DBLE(A_HZGG_GLUMI(29)*A_HZGG_GBKG(29)*bkg_2000(real(mh)))
      elseif ( dabs(sqrts-207.5D0).le.0.25D0 ) then
          a_zhgg_bkg_mass =
     &    DBLE(A_HZGG_GLUMI(30)*A_HZGG_GBKG(30)*bkg_2000(real(mh)))
      elseif ( dabs(sqrts-208.D0).le.0.25D0 ) then
          a_zhgg_bkg_mass =
     &    DBLE(A_HZGG_GLUMI(31)*A_HZGG_GBKG(31)*bkg_2000(real(mh)))
      elseif ( dabs(sqrts-208.5D0).le.0.25D0 ) then
          a_zhgg_bkg_mass =
     &    DBLE(A_HZGG_GLUMI(32)*A_HZGG_GBKG(32)*bkg_2000(real(mh)))
      elseif ( dabs(sqrts-209.D0).le.0.25D0 ) then
          a_zhgg_bkg_mass =
     &    DBLE(A_HZGG_GLUMI(33)*A_HZGG_GBKG(33)*bkg_2000(real(mh)))
      elseif ( dabs(sqrts-209.5D0).le.0.25D0 ) then
          a_zhgg_bkg_mass =
     &    DBLE(A_HZGG_GLUMI(34)*A_HZGG_GBKG(34)*bkg_2000(real(mh)))
      elseif ( dabs(sqrts-210.D0).le.0.25D0 ) then
          a_zhgg_bkg_mass =
     &    DBLE(A_HZGG_GLUMI(35)*A_HZGG_GBKG(35)*bkg_2000(real(mh)))
      endif
      RETURN
      END
      DOUBLE PRECISION FUNCTION a_zhgg_bkg_n(sqrts,iana,ibkg)
C             Return the number of expected bkg events
C             for a given higgs mass and for a given
C             LEP energy. From 88 up to 189 is one point
C             iana,ibkg dummy
      IMPLICIT NONE
      include 'a_zhgg_91_210_decl.inc'
      include 'a_zhgg_ext_shape.inc'
      include 'a_inputs.inc'
      double precision mh,sqrts
      real sqrtsi
      integer i,iana,ibkg
C            total background shape      
      a_zhgg_bkg_n = 0.D0
      if ( sqrts.LE.189.5D0 ) then
         do i = 1,15
            a_zhgg_bkg_n = a_zhgg_bkg_n +
     &          A_HZGG_GLUMI(i)*A_HZGG_GBKG(i)
         enddo
      elseif ( dabs(sqrts-191.6D0).le.1.D0 ) then
          a_zhgg_bkg_n =
     &       A_HZGG_GLUMI(16)*A_HZGG_GBKG(16)
      elseif ( dabs(sqrts-195.5D0).le.1.D0 ) then
          a_zhgg_bkg_n = 
     &       A_HZGG_GLUMI(17)*A_HZGG_GBKG(17)
      elseif ( dabs(sqrts-199.5D0).le.1.D0 ) then
          a_zhgg_bkg_n =
     &       A_HZGG_GLUMI(18)*A_HZGG_GBKG(18)
      elseif ( dabs(sqrts-201.6D0).le.0.25D0 ) then
          a_zhgg_bkg_n =
     &       A_HZGG_GLUMI(19)*A_HZGG_GBKG(19)
      elseif ( dabs(sqrts-202.5D0).le.0.25D0 ) then
          a_zhgg_bkg_n =
     &       A_HZGG_GLUMI(20)*A_HZGG_GBKG(20)
      elseif ( dabs(sqrts-203.D0).le.0.25D0 ) then
          a_zhgg_bkg_n =
     &       A_HZGG_GLUMI(21)*A_HZGG_GBKG(21)
      elseif ( dabs(sqrts-203.5D0).le.0.25D0 ) then
          a_zhgg_bkg_n =
     &       A_HZGG_GLUMI(22)*A_HZGG_GBKG(22)
      elseif ( dabs(sqrts-204.D0).le.0.25D0 ) then
          a_zhgg_bkg_n =
     &       A_HZGG_GLUMI(23)*A_HZGG_GBKG(23)
      elseif ( dabs(sqrts-204.5D0).le.0.25D0 ) then
          a_zhgg_bkg_n =
     &       A_HZGG_GLUMI(24)*A_HZGG_GBKG(24)
      elseif ( dabs(sqrts-205.D0).le.0.25D0 ) then
          a_zhgg_bkg_n =
     &       A_HZGG_GLUMI(25)*A_HZGG_GBKG(25)
      elseif ( abs(sqrts-205.5D0).le.0.25D0 ) then
          a_zhgg_bkg_n =
     &       A_HZGG_GLUMI(26)*A_HZGG_GBKG(26)
      elseif ( dabs(sqrts-206.D0).le.0.25D0 ) then
          a_zhgg_bkg_n =
     &       A_HZGG_GLUMI(27)*A_HZGG_GBKG(27)
      elseif ( dabs(sqrts-206.5D0).le.0.25D0 ) then
          a_zhgg_bkg_n =
     &       A_HZGG_GLUMI(28)*A_HZGG_GBKG(28)
      elseif ( dabs(sqrts-207.D0).le.0.25D0 ) then
          a_zhgg_bkg_n =
     &       A_HZGG_GLUMI(29)*A_HZGG_GBKG(29)
      elseif ( dabs(sqrts-207.5D0).le.0.25D0 ) then
          a_zhgg_bkg_n =
     &       A_HZGG_GLUMI(30)*A_HZGG_GBKG(30)
      elseif ( dabs(sqrts-208.D0).le.0.25D0 ) then
          a_zhgg_bkg_n =
     &       A_HZGG_GLUMI(31)*A_HZGG_GBKG(31)
      elseif ( dabs(sqrts-208.5D0).le.0.25D0 ) then
          a_zhgg_bkg_n =
     &       A_HZGG_GLUMI(32)*A_HZGG_GBKG(32)
      elseif ( dabs(sqrts-209.D0).le.0.25D0 ) then
          a_zhgg_bkg_n =
     &       A_HZGG_GLUMI(33)*A_HZGG_GBKG(33)
      elseif ( dabs(sqrts-209.5D0).le.0.25D0 ) then
          a_zhgg_bkg_n =
     &       A_HZGG_GLUMI(34)*A_HZGG_GBKG(34)
      elseif ( dabs(sqrts-210.D0).le.0.25D0 ) then
          a_zhgg_bkg_n =
     &       A_HZGG_GLUMI(35)*A_HZGG_GBKG(35)
      endif
      RETURN
      END
C============================================================
C
C          /home/tilquin/zhphot/clfft/shape/mean_192.f 
C
      REAL FUNCTION mean_192(x)
C         Mean reconstructed mass at 192 GeV
      IMPLICIT NONE
      REAL P(4),X
      DATA P/0.421462,-0.0340262,0.00075413,-5.32383E-06/
      mean_192 = p(1)+p(2)*x+p(3)*x**2+p(4)*x**3
      RETURN
      END
C
C          /home/tilquin/zhphot/clfft/shape/sigma_192.f      
C
      real function sigma_192(x)
C         x = higgs mass in GeV
      IMPLICIT NONE
      REAL X
      sigma_192 = 0.298595+0.0168062*X+0.000158919*x**2
      return
      end
C
C          /home/tilquin/zhphot/clfft/shape/mean_196.f
C
      REAL FUNCTION mean_196(x)
C         Mean reconstructed mass at 196 GeV
C
      REAL SIGMOID
      EXTERNAL SIGMOID
      REAL X
      OUT1 = X
C
C     layer 2
      IF ( X.LE.110 ) THEN
      RIN1 = 0.444379
     > +(-0.905419) * OUT1
      RIN2 = 0.013291
     > +(1.109289) * OUT1
      RIN3 = -20.996146
     > +(0.147874) * OUT1
      RIN4 = 0.127270
     > +(-1.011455) * OUT1
C
      OUT1 = SIGMOID(RIN1)
      OUT2 = SIGMOID(RIN2)
      OUT3 = SIGMOID(RIN3)
      OUT4 = SIGMOID(RIN4)
C
C     layer 3
      mean_196 = -0.075827
     > +(-0.212275) * OUT1
     > +(0.228494) * OUT2
     > +(-151.892420) * OUT3
     > +(0.109026) * OUT4
C
      ELSE
        mean_196 = -1.3
      ENDIF
      END
C
C          /home/tilquin/zhphot/clfft/shape/sigma_196.f
C
      real function sigma_196(x)
C         x = higgs mass in GeV
      real x
      sigma_196 = -0.0274326+0.0358658*x-1.37211E-05*x**2
      return
      end
C
C          /home/tilquin/zhphot/clfft/shape/mean_200.f
C
      REAL FUNCTION mean_200(x)
C         Mean reconstructed mass at 200 GeV
C
      REAL SIGMOID
      EXTERNAL SIGMOID
      REAL X
C
      if ( x.le.115. ) then
      OUT1 = X
C
C     layer 2
      RIN1 = -0.022037
     > +(-18.812353) * OUT1
      RIN2 = 0.063406
     > +(3.506408) * OUT1
      RIN3 = -15.459688
     > +(0.109367) * OUT1
      RIN4 = 33.593444
     > +(-2.031647) * OUT1
C
      OUT1 = SIGMOID(RIN1)
      OUT2 = SIGMOID(RIN2)
      OUT3 = SIGMOID(RIN3)
      OUT4 = SIGMOID(RIN4)
C
C     layer 3
      PAWMLP = 0.009906
     > +(1.116158) * OUT1
     > +(0.182738) * OUT2
     > +(-29.062800) * OUT3
     > +(-98.537121) * OUT4
C
      else
        pawmlp = -1.4
      endif
      if ( x.le.22.5 ) pawmlp = 0.2
      mean_200 = pawmlp
      END
C
C          /home/tilquin/zhphot/clfft/shape/sigma_200.f
C                
      real function sigma_200(x)
C         x = higgs mass in GeV
      sigma_200 = 0.0666385+0.0329802*x-4.95821E-06*x**2
      return
      end
C
C          /home/tilquin/zhphot/clfft/shape/low_mean_202.f
C
      REAL FUNCTION mean_202(x)
C         Mean reconstructed mass at 202 GeV
C
      REAL SIGMOID
      EXTERNAL SIGMOID
      mean_202 = -1.5
      IF ( X.GE.120. ) GOTO 100
      OUT1 = X
C
C     layer 2
      RIN1 = -0.932516
     > +(-0.413048) * OUT1
      RIN2 = -35.941396
     > +(0.285890) * OUT1
      RIN3 = -1.510620
     > +(0.035058) * OUT1
      RIN4 = -1.062878
     > +(-0.458529) * OUT1
      RIN5 = -2.527047
     > +(0.020730) * OUT1
C
      OUT1 = SIGMOID(RIN1)
      OUT2 = SIGMOID(RIN2)
      OUT3 = SIGMOID(RIN3)
      OUT4 = SIGMOID(RIN4)
      OUT5 = SIGMOID(RIN5)
C
C     layer 3
      PAWMLP = -0.038862
     > +(0.040279) * OUT1
     > +(-16.898842) * OUT2
     > +(2.923536) * OUT3
     > +(0.087346) * OUT4
     > +(-7.095140) * OUT5
C
      mean_202 = pawmlp
C
 100  IF ( mean_202.LE.-1.5 ) mean_202 = -1.5
      END
C
C          /home/tilquin/zhphot/clfft/shape/low_sigma_202.f
C      
      real function sigma_202(x)
C         x = higgs mass in GeV
      sigma_202 = 0.0417886+0.0331488*x+3.47739E-06*x**2
      IF ( sigma_202.LE.0.1 ) sigma_202 = 0.1
      return
      end
C
C          /home/tilquin/zhphot/clfft/shape/low_eff_cut_91.f
C
      REAL FUNCTION EFF_91(X)
C      Efficiency in %
      REAL SIGMOID
      EXTERNAL SIGMOID
      EFF_91 = 0.
      IF ( X.GE.80. ) GOTO 100
      OUT1 = X/100.
C
C     layer 2
      RIN1 = -2.172310
     > +(13.042145) * OUT1
      RIN2 = -9.183799
     > +(17.922772) * OUT1
      RIN3 = 18.834434
     > +(27.717532) * OUT1
      RIN4 = -27.927489
     > +(36.925129) * OUT1
      RIN5 = -21.373223
     > +(22.303830) * OUT1
C
      OUT1 = SIGMOID(RIN1)
      OUT2 = SIGMOID(RIN2)
      OUT3 = SIGMOID(RIN3)
      OUT4 = SIGMOID(RIN4)
      OUT5 = SIGMOID(RIN5)
C
C     layer 3
      PAWMLP = -10.066311
     > +(23.135197) * OUT1
     > +(17.872816) * OUT2
     > +(7.483115) * OUT3
     > +(-44.417135) * OUT4
     > +(-22.570626) * OUT5
C
      EFF_91 = PAWMLP
 100  CONTINUE
      END
C
C          /home/tilquin/zhphot/clfft/shape/low_eff_133.f
C
      REAL FUNCTION EFF_133(X)
C
      REAL SIGMOID
      EXTERNAL SIGMOID
      eff_133 = 0.
      OUT1 = X/100.
      IF ( X.GE.100. ) GOTO 100
C
C     layer 2
      RIN1 = -6.943129
     > +(10.247818) * OUT1
      RIN2 = -8.673043
     > +(21.426288) * OUT1
      RIN3 = -3.531758
     > +(6.087699) * OUT1
      RIN4 = 1.226304
     > +(-0.786576) * OUT1
C
      OUT1 = SIGMOID(RIN1)
      OUT2 = SIGMOID(RIN2)
      OUT3 = SIGMOID(RIN3)
      OUT4 = SIGMOID(RIN4)
C
C     layer 3
      PAWMLP = -0.215860
     > +(-10.167708) * OUT1
     > +(1.079175) * OUT2
     > +(1.341192) * OUT3
     > +(0.242939) * OUT4
C
      eff_133 = pawmlp*100.
 100  IF ( EFF_133.LE.0. ) EFF_133 = 0.
      END
C
C          /home/tilquin/zhphot/clfft/shape/low_eff_161.f
C
      REAL FUNCTION EFF_161(X)
C
      REAL SIGMOID
      EXTERNAL SIGMOID
      EFF_161 = 0.
      OUT1 = X/100.
      IF ( X.GE.90. ) GOTO 100
C
C     layer 2
      RIN1 = 0.965046
     > +(21.776667) * OUT1
      RIN2 = 4.570700
     > +(-4.186398) * OUT1
      RIN3 = -7.222734
     > +(10.557616) * OUT1
      RIN4 = -7.310049
     > +(9.850099) * OUT1
C
      OUT1 = SIGMOID(RIN1)
      OUT2 = SIGMOID(RIN2)
      OUT3 = SIGMOID(RIN3)
      OUT4 = SIGMOID(RIN4)
C
C     layer 3
      PAWMLP = 0.460796
     > +(0.181984) * OUT1
     > +(-0.598305) * OUT2
     > +(4.603055) * OUT3
     > +(-5.721402) * OUT4
C
      eff_161 = pawmlp*100.
 100  IF ( EFF_161.LE.0. ) EFF_161 = 0.
      END
C
C          /home/tilquin/zhphot/clfft/shape/low_eff_172.f
C
      REAL FUNCTION eff_172(X)
C
      REAL SIGMOID
      EXTERNAL SIGMOID
      OUT1 = X/100.
      eff_172 = 0.
      IF ( x.GE.100. ) GOTO 100
C
C     layer 2
      RIN1 = 4.223240
     > +(14.337096) * OUT1
      RIN2 = -4.000871
     > +(7.506401) * OUT1
      RIN3 = -11.501129
     > +(9.691816) * OUT1
      RIN4 = 4.011741
     > +(-7.870448) * OUT1
C
      OUT1 = SIGMOID(RIN1)
      OUT2 = SIGMOID(RIN2)
      OUT3 = SIGMOID(RIN3)
      OUT4 = SIGMOID(RIN4)
C
C     layer 3
      PAWMLP = -8.756136
     > +(3.520145) * OUT1
     > +(6.052999) * OUT2
     > +(-8.549561) * OUT3
     > +(5.272139) * OUT4
C
      eff_172 = pawmlp*100.
 100  IF ( eff_172.LE.0. ) eff_172 = 0.
      END
C
C          /home/tilquin/zhphot/clfft/shape/low_eff_183.f
C
      REAL FUNCTION EFF_183(X)
C
      REAL SIGMOID
      EXTERNAL SIGMOID
      OUT1 = X/100.
C
C     layer 2
      RIN1 = -2.771258
     > +(0.364648) * OUT1
      RIN2 = -0.082102
     > +(4.609135) * OUT1
      RIN3 = -1.067338
     > +(3.065771) * OUT1
      RIN4 = 9.046925
     > +(-6.763436) * OUT1
      RIN5 = -2.460005
     > +(3.586113) * OUT1
      RIN6 = 2.566418
     > +(-0.119263) * OUT1
C
      OUT1 = SIGMOID(RIN1)
      OUT2 = SIGMOID(RIN2)
      OUT3 = SIGMOID(RIN3)
      OUT4 = SIGMOID(RIN4)
      OUT5 = SIGMOID(RIN5)
      OUT6 = SIGMOID(RIN6)
C
C     layer 3
      PAWMLP = -3.419264
     > +(4.827691) * OUT1
     > +(2.949874) * OUT2
     > +(-7.498965) * OUT3
     > +(6.722356) * OUT4
     > +(5.831666) * OUT5
     > +(-3.812381) * OUT6
C
      eff_183 = pawmlp*100.
      if ( eff_183.LE.0. ) eff_183 = 0.
      END
C
C          /home/tilquin/zhphot/clfft/shape/low_eff_189.f
C
      REAL FUNCTION EFF_189(X)
C
      REAL SIGMOID
      EXTERNAL SIGMOID
      OUT1 = X/100.
      EFF_189 = 0.
      IF ( X.GE.120. ) GOTO 100
C
C     layer 2
      RIN1 = 4.899660
     > +(-8.767165) * OUT1
      RIN2 = 13.542937
     > +(-9.642278) * OUT1
      RIN3 = -1.610190
     > +(-4.283064) * OUT1
      RIN4 = 4.508217
     > +(-7.855025) * OUT1
      RIN5 = 0.568565
     > +(2.725297) * OUT1
      RIN6 = 3.528855
     > +(1.448215) * OUT1
C
      OUT1 = SIGMOID(RIN1)
      OUT2 = SIGMOID(RIN2)
      OUT3 = SIGMOID(RIN3)
      OUT4 = SIGMOID(RIN4)
      OUT5 = SIGMOID(RIN5)
      OUT6 = SIGMOID(RIN6)
C
C     layer 3
      PAWMLP = -4.719958
     > +(3.888098) * OUT1
     > +(7.097845) * OUT2
     > +(-4.671977) * OUT3
     > +(-4.827792) * OUT4
     > +(-3.494916) * OUT5
     > +(1.593133) * OUT6
      eff_189 = pawmlp*100.
      IF ( eff_189.LE.0. ) eff_189 = 0.
C
 100  CONTINUE
      END
C
C          /home/tilquin/zhphot/clfft/shape/low_eff_cut_192.f
C
      REAL FUNCTION EFF_192(X)
C         efficiency in % (0.->100.) at 192 GeV for ZH->gamma-gamma
C            x=hmass in GeV
      REAL SIGMOID
      EXTERNAL SIGMOID
      OUT1 = X/100.
C
C
C     layer 2
      RIN1 = 16.577931
     > +(13.623383) * OUT1
      RIN2 = -6.834861
     > +(9.898988) * OUT1
      RIN3 = 3.453527
     > +(6.747552) * OUT1
      RIN4 = 41.741583
     > +(-38.579242) * OUT1
      RIN5 = -2.060784
     > +(0.234964) * OUT1
      RIN6 = 42.929621
     > +(-39.742075) * OUT1
C
      OUT1 = SIGMOID(RIN1)
      OUT2 = SIGMOID(RIN2)
      OUT3 = SIGMOID(RIN3)
      OUT4 = SIGMOID(RIN4)
      OUT5 = SIGMOID(RIN5)
      OUT6 = SIGMOID(RIN6)
C
C     layer 3
      PAWMLP = -3.930176
     > +(-0.391944) * OUT1
     > +(0.369531) * OUT2
     > +(4.476975) * OUT3
     > +(-5.611198) * OUT4
     > +(-3.554393) * OUT5
     > +(5.994602) * OUT6
C
      IF ( X.GE.111. ) PAWMLP = 0.
      IF ( PAWMLP.LE.0 ) PAWMLP = 0.000001
      EFF_192 = PAWMLP*100.
      END
C
C          /home/tilquin/zhphot/clfft/shape/low_eff_cut_196.f
C
      REAL FUNCTION EFF_196(X)
C         efficiency in % (0.->100.) at 192 GeV for ZH->gamma-gamma
C            x=hmass in GeV Using cut analysis
      REAL SIGMOID
      EXTERNAL SIGMOID
      OUT1 = X/100.
C
C     layer 2
      RIN1 = 9.413273
     > +(-7.738463) * OUT1
      RIN2 = 7.217487
     > +(-7.407793) * OUT1
      RIN3 = -2.392783
     > +(-6.249240) * OUT1
      RIN4 = 19.988614
     > +(-17.200236) * OUT1
      RIN5 = 2.607419
     > +(1.934472) * OUT1
      RIN6 = 28.477238
     > +(-25.000101) * OUT1

      OUT1 = SIGMOID(RIN1)
      OUT2 = SIGMOID(RIN2)
      OUT3 = SIGMOID(RIN3)
      OUT4 = SIGMOID(RIN4)
      OUT5 = SIGMOID(RIN5)
      OUT6 = SIGMOID(RIN6)
C
C     layer 3
      PAWMLP = -0.706882
     > +(10.769105) * OUT1
     > +(-2.907170) * OUT2
     > +(-1.947679) * OUT3
     > +(-10.208887) * OUT4
     > +(-1.985363) * OUT5
     > +(5.078641) * OUT6
C
      IF ( X.GE.120. ) PAWMLP = 0.
      IF ( PAWMLP.LE.0. ) PAWMLP = 0.000001
      EFF_196 = PAWMLP*100.

      END
      REAL FUNCTION EFF_200(X)
C         efficiency in % (0.->100.) at 192 GeV for ZH->gamma-gamma
C            x=hmass in GeV Using cut analysis
      REAL SIGMOID
      EXTERNAL SIGMOID
      OUT1 = X/100.
C
C     layer 2
      RIN1 = 22.209426
     > +(-18.545794) * OUT1
      RIN2 = 2.486637
     > +(-4.557403) * OUT1
      RIN3 = -1.665803
     > +(-2.755518) * OUT1
      RIN4 = -15.521598
     > +(10.087374) * OUT1
      RIN5 = 14.791593
     > +(-8.610189) * OUT1
      RIN6 = -2.544344
     > +(5.390451) * OUT1
C
      OUT1 = SIGMOID(RIN1)
      OUT2 = SIGMOID(RIN2)
      OUT3 = SIGMOID(RIN3)
      OUT4 = SIGMOID(RIN4)
      OUT5 = SIGMOID(RIN5)
      OUT6 = SIGMOID(RIN6)
C
C     layer 3
      PAWMLP = 1.024965
     > +(1.567570) * OUT1
     > +(-2.279256) * OUT2
     > +(-2.268075) * OUT3
     > +(10.426459) * OUT4
     > +(-0.023568) * OUT5
     > +(-2.006865) * OUT6
C
      IF ( X.GE.130. ) PAWMLP = 0.
      EFF_200 = PAWMLP*100.
      IF ( EFF_200.LE.0. ) EFF_200 = 0.00001
C
      END
      REAL FUNCTION EFF_202(X)
C        Efficiency at 202 ( using full sim and standard cut anlysis)
C        X = mass in GeV  Efficiency in % (0->100)
      REAL SIGMOID
      EXTERNAL SIGMOID
      OUT1 = X/100.
C
C     layer 2
      RIN1 = 2.845797
     > +(3.448352) * OUT1
      RIN2 = -8.370972
     > +(9.391223) * OUT1
      RIN3 = -33.086690
     > +(28.450301) * OUT1
      RIN4 = -4.755095
     > +(-0.632312) * OUT1
C
      OUT1 = SIGMOID(RIN1)
      OUT2 = SIGMOID(RIN2)
      OUT3 = SIGMOID(RIN3)
      OUT4 = SIGMOID(RIN4)
C
C     layer 3
      PAWMLP = -3.018315
     > +(3.167835) * OUT1
     > +(0.343876) * OUT2
     > +(-0.496868) * OUT3
     > +(2.847808) * OUT4
C
      IF ( PAWMLP.LE.0. ) PAWMLP=0.
      IF ( X.GT.140. ) PAWMLP=0.
      EFF_202 = PAWMLP*100.
      END
      REAL FUNCTION EFF_204(X)
C        Efficiency at 204 ( using full sim and standard cut anlysis)
C        X = mass in GeV  Efficiency in % (0->100)
C        Last version of the y2k analysis
      REAL SIGMOID
      EXTERNAL SIGMOID
      OUT1 = X/100.
C
C     layer 2
      RIN1 = -1.345603
     > +(1.206928) * OUT1
      RIN2 = -2.954049
     > +(1.379173) * OUT1
      RIN3 = -29.472735
     > +(24.691240) * OUT1
      RIN4 = 3.561436
     > +(9.478902) * OUT1
C
      OUT1 = SIGMOID(RIN1)
      OUT2 = SIGMOID(RIN2)
      OUT3 = SIGMOID(RIN3)
      OUT4 = SIGMOID(RIN4)
C
C     layer 3
      PAWMLP = -2.389344
     > +(-4.055567) * OUT1
     > +(10.362691) * OUT2
     > +(-0.638491) * OUT3
     > +(2.790803) * OUT4
C
      IF ( PAWMLP.LE.0. ) PAWMLP=0.
      IF ( X.GT.140. ) PAWMLP=0.
      EFF_204 = PAWMLP*100.
      END

      REAL FUNCTION EFF_206(X)
C        Efficiency at 206 ( using full sim and standard cut anlysis)
C        X = mass in GeV  Efficiency in % (0->100)
C        Last version of the y2k analysis
      REAL SIGMOID
      EXTERNAL SIGMOID
      OUT1 = X/100.
C
C     layer 2
      RIN1 = -0.793361
     > +(0.982844) * OUT1
      RIN2 = -4.343185
     > +(1.876966) * OUT1
      RIN3 = -23.885668
     > +(19.598349) * OUT1
      RIN4 = 1.800064
     > +(2.474230) * OUT1
C
      OUT1 = SIGMOID(RIN1)
      OUT2 = SIGMOID(RIN2)
      OUT3 = SIGMOID(RIN3)
      OUT4 = SIGMOID(RIN4)
C
C     layer 3
      PAWMLP = -1.373840
     > +(-4.336543) * OUT1
     > +(14.368414) * OUT2
     > +(-0.854228) * OUT3
     > +(2.959951) * OUT4
C
      IF ( PAWMLP.LE.0. ) PAWMLP=0.
      IF ( X.GT.130. ) PAWMLP=0.
      EFF_206 = PAWMLP*100.
      END
C---------------------------------------------------
C-      This function is needed by pawmlp function
C---------------------------------------------------
c PTD (This function is already defined in the charged Higgs code)
c      REAL FUNCTION SIGMOID(X)
c      IF(X.GT.37.) THEN
c         SIGMOID = 1.
c      ELSE IF(X.LT.-37.) THEN
c         SIGMOID = 0.
c      ELSE
c         SIGMOID = 1./(1.+EXP(-X))
c      ENDIF
c      END
C------------------------------------------------
C          Expected background
C              a_zhgg_bkg.F
C------------------------------------------------
C
C          /home/tilquin/zhphot/clfft/shape/low_bkg_91_98.f
C
      REAL FUNCTION bkg_91_98(X)
C
C    Function generated by the PAW - MLPfit interface
C          Expected background from mphph 1.->120.
C          year 91 up to 98
C          Nb_expected = 22.16\Lum=435.5
C          Normalized to 1
      REAL SIGMOID
      EXTERNAL SIGMOID
      bkg_91_98 = 0.
      IF ( X.GE.120.) GOTO 100
      OUT1 = X
C
C     layer 2
      RIN1 = 2.314183e-01
     > +(-1.658067e+00) * OUT1
      RIN2 = -1.217808e+00
     > +(8.490150e-01) * OUT1
      RIN3 = -1.616773e+00
     > +(7.783825e-01) * OUT1
      RIN4 = 1.266957e+00
     > +(-6.733214e-01) * OUT1
      RIN5 = 5.728582e+00
     > +(-6.284904e-01) * OUT1
      RIN6 = -6.156023e-01
     > +(-2.145774e-02) * OUT1
C
      OUT1 = SIGMOID(RIN1)
      OUT2 = SIGMOID(RIN2)
      OUT3 = SIGMOID(RIN3)
      OUT4 = SIGMOID(RIN4)
      OUT5 = SIGMOID(RIN5)
      OUT6 = SIGMOID(RIN6)
C
C     layer 3
      pawmlp = 2.502041e+00
     > +(4.424411e-01) * OUT1
     > +(-1.225451e+00) * OUT2
     > +(-1.622664e+00) * OUT3
     > +(3.221721e+00) * OUT4
     > +(-3.626756e+00) * OUT5
     > +(9.510968e+00) * OUT6
C
C         Normalize to 1
      bkg_91_98 = pawmlp/108.6
      IF ( bkg_91_98.LE.0.0 ) bkg_91_98 = 0.0
 100  CONTINUE
      END
C-
C          /home/tilquin/zhphot/clfft/shape/low_bkg_192_cut.f
C
      REAL FUNCTION bkg_192_cut(X)
      REAL SIGMOID
      EXTERNAL SIGMOID
C
C    Function generated by the PAW - MLPfit interface
C       Background shape at 192 GeV from 1->120 GeV
C       Nexpected = 0.72
C       Normalize to 1
      bkg_192_cut = 0.
      IF ( x.LE.1.OR.x.GE.120. ) GOTO 100
      OUT1 = X
C
C     layer 2
      RIN1 = 8.914208e+00
     > +(-1.344572e-01) * OUT1
      RIN2 = 2.165893e-01
     > +(1.406627e+00) * OUT1
      RIN3 = -7.139399e+00
     > +(1.289263e-01) * OUT1
      RIN4 = -1.053788e-01
     > +(-1.198484e+00) * OUT1
      RIN5 = 7.494340e+00
     > +(-1.204842e-01) * OUT1
C
      OUT1 = SIGMOID(RIN1)
      OUT2 = SIGMOID(RIN2)
      OUT3 = SIGMOID(RIN3)
      OUT4 = SIGMOID(RIN4)
      OUT5 = SIGMOID(RIN5)
C
C     layer 3
      pawmlp = 7.625499e-01
     > +(1.934507e+00) * OUT1
     > +(2.316246e-01) * OUT2
     > +(-9.631395e-01) * OUT3
     > +(1.312525e-01) * OUT4
     > +(-2.926149e+00) * OUT5
C         Normalize to 1
      bkg_192_cut = pawmlp/3.316
C     
 100  CONTINUE
      END
C
C          /home/tilquin/zhphot/clfft/shape/low_bkg_196_cut.f
C
      REAL FUNCTION bkg_196_cut(X)
      REAL SIGMOID
      EXTERNAL SIGMOID
C
C    Function generated by the PAW - MLPfit interface
C       background shape at 196 GeV
C        Nexpected = 2.027 from (1.GeV->120. GEV)
C        Normalized to 1
      OUT1 = X
      bkg_196_cut = 0.
      IF ( x.LE.1.OR.X.GE.120. ) RETURN
C
C     layer 2
      RIN1 = 1.547119e+01
     > +(-1.432141e-01) * OUT1
      RIN2 = -1.028153e-01
     > +(5.233951e-01) * OUT1
      RIN3 = 5.839078e-02
     > +(9.042014e-01) * OUT1
      RIN4 = 9.790779e-01
     > +(-4.549473e-03) * OUT1
      RIN5 = 1.892304e+01
     > +(-1.792497e-01) * OUT1
      RIN6 = 2.289016e+01
     > +(-2.212275e-01) * OUT1
C
      OUT1 = SIGMOID(RIN1)
      OUT2 = SIGMOID(RIN2)
      OUT3 = SIGMOID(RIN3)
      OUT4 = SIGMOID(RIN4)
      OUT5 = SIGMOID(RIN5)
      OUT6 = SIGMOID(RIN6)
C
C     layer 3
      pawmlp = 1.018524e+00
     > +(5.775330e+00) * OUT1
     > +(-3.848425e-01) * OUT2
     > +(6.222250e-01) * OUT3
     > +(-2.436620e+00) * OUT4
     > +(-9.179520e+00) * OUT5
     > +(3.895532e+00) * OUT6
C         Normalized to 1
      bkg_196_cut = pawmlp/9.947
      if ( bkg_196_cut.LE.0. ) bkg_196_cut = 0.0
      END
C
C          /home/tilquin/zhphot/clfft/shape/low_bkg_200_cut.f
C
      REAL FUNCTION bkg_200_cut(X)
      REAL SIGMOID
      EXTERNAL SIGMOID
C
C    Function generated by the PAW - MLPfit interface
C         Background shape at 200 at low higgs mass
C         Nexpected = 2.074
C         Normalized to 1.
      OUT1 = X
      bkg_200_cut = 0.00001
      IF ( X.LE.1.OR.X.GE.130. ) RETURN
C
C     layer 2
      RIN1 = -6.896971e-02
     > +(-2.948253e+00) * OUT1
      RIN2 = 6.760967e-01
     > +(2.129745e+00) * OUT1
      RIN3 = 5.055861e-01
     > +(2.217861e+00) * OUT1
      RIN4 = 2.844652e+01
     > +(-2.532333e-02) * OUT1
      RIN5 = 6.443999e+00
     > +(-4.449150e-02) * OUT1
      RIN6 = 1.193629e+01
     > +(-1.284848e-01) * OUT1
      RIN7 = -2.395465e+01
     > +(2.162760e-01) * OUT1
      RIN8 = 8.687148e+00
     > +(-7.951012e-02) * OUT1
C
      OUT1 = SIGMOID(RIN1)
      OUT2 = SIGMOID(RIN2)
      OUT3 = SIGMOID(RIN3)
      OUT4 = SIGMOID(RIN4)
      OUT5 = SIGMOID(RIN5)
      OUT6 = SIGMOID(RIN6)
      OUT7 = SIGMOID(RIN7)
      OUT8 = SIGMOID(RIN8)
C
C     layer 3
      pawmlp = -3.479362e+00
     > +(-3.736804e-01) * OUT1
     > +(-2.705729e+00) * OUT2
     > +(-2.860171e+00) * OUT3
     > +(1.380595e+01) * OUT4
     > +(-1.628793e+01) * OUT5
     > +(-3.949275e+00) * OUT6
     > +(3.569134e+00) * OUT7
     > +(1.545670e+01) * OUT8
C
      IF ( pawmlp.LE.0. ) PAWMLP = 0.0
C             Normalised to 1
      bkg_200_cut = pawmlp/10.56
C      
 100  CONTINUE
      END
C
C         /home/tilquin/zhphot/clfft/shape/low_bkg_202_cut.f
C
      REAL FUNCTION BKG_202_CUT(X)
C         Background distribution at 202 GeV for ZH->gamma-gamma
C         using zhphut.for(99).ge.10.
C            x=hmass in GeV
C          Normalized to 1
      REAL SIGMOID
      EXTERNAL SIGMOID
      OUT1 = X/100.
C
C    Function generated by the PAW - MLPfit interface
C
C
C     layer 2
      RIN1 = 2.232033e+01
     > +(-1.888465e+01) * OUT1
      RIN2 = 1.634531e+01
     > +(-1.440855e+01) * OUT1
      RIN3 = 9.078928e-01
     > +(4.272859e-01) * OUT1
      RIN4 = -1.306197e+01
     > +(1.244717e+01) * OUT1
      RIN5 = 1.281644e+01
     > +(-1.324078e+01) * OUT1
C
      OUT1 = SIGMOID(RIN1)
      OUT2 = SIGMOID(RIN2)
      OUT3 = SIGMOID(RIN3)
      OUT4 = SIGMOID(RIN4)
      OUT5 = SIGMOID(RIN5)
C
C     layer 3
      pawmlp = 4.436227e+00
     > +(5.136759e+00) * OUT1
     > +(-1.037291e+01) * OUT2
     > +(4.406979e+00) * OUT3
     > +(-7.968455e+00) * OUT4
     > +(-2.369763e+00) * OUT5
C
      IF ( pawmlp.le.0.0 ) pawmlp = 0.0
      IF ( X.GE.130. ) pawmlp = 0.0
      BKG_202_CUT = PAWMLP/17.44
      END
C
C           /home/tilquin/zhphot/clfft/shape/bkg_2000.f
C
      REAL FUNCTION BKG_2000(X)
C        expected background at year 2000
C        Normalized to 1
      REAL SIGMOID
      EXTERNAL SIGMOID
      OUT1 = X
C
C     layer 2
      RIN1 = 2.578864e+00
     > +(-7.872562e-02) * OUT1
      RIN2 = -6.187211e+00
     > +(5.869631e-02) * OUT1
      RIN3 = -2.552447e+00
     > +(1.027557e-01) * OUT1
      RIN4 = 1.118125e+01
     > +(-9.816748e-02) * OUT1
      RIN5 = 3.899130e+00
     > +(-7.146563e-02) * OUT1
      RIN6 = 1.159512e+01
     > +(-1.594691e-01) * OUT1
      RIN7 = -7.678239e+00
     > +(1.052653e-01) * OUT1
C
      OUT1 = SIGMOID(RIN1)
      OUT2 = SIGMOID(RIN2)
      OUT3 = SIGMOID(RIN3)
      OUT4 = SIGMOID(RIN4)
      OUT5 = SIGMOID(RIN5)
      OUT6 = SIGMOID(RIN6)
      OUT7 = SIGMOID(RIN7)
C
C     layer 3
      pawmlp = -8.477911e-02
     > +(-2.125150e+00) * OUT1
     > +(-4.600820e+00) * OUT2
     > +(-8.253261e-01) * OUT3
     > +(-2.602389e+00) * OUT4
     > +(2.519185e+00) * OUT5
     > +(2.256514e+00) * OUT6
     > +(5.126921e+00) * OUT7
C
C
      BKG_2000 = PAWMLP/5.046
      IF ( BKG_2000.LE.0.0 ) BKG_2000 = 0.0
C
      END
