C-*-FORTRAN-*-----------------------------------------------------------
C
      real function ah0_lumi(iener)
c
c Return the luminosity (in pb) used for the ALEPH neutral Higgs searches;
c iener = centre-of-mass energy index
c iener = 1 (183 GeV), 2 (188.6), 3 (191.6), 4 (195.5),
c         5 (199.5), 6 (201.6).
c
c Created:                             Pedro Teixeira-Dias, 27-July-1999.
c
c Modified:
c
c     - Added in the new lumis (see below) for the Lepton-Photon '99 Conf.
c   192 Gev : 186 Runs (49434 to 50451)
c   Luminosity (xlumok selected) (29.042+-0.084 )pb**-1 
c   196 GeV : 331 Runs (up to Run 50551)
c   Luminosity (xlumok selected) (69.526+-0.132 )pb**-1
c
c   - Update: final luminosities for the 1999 data (192-202 GeV).
c                                                        PTD, 12-Feb-2000.
c
c--------------------------------------------------------------------------
c
      implicit none
      integer iener
c     
      ah0_lumi = 0.0
c     
      if (iener.eq.1) then      ! 183 GeV
         ah0_lumi = 57.0	! Final, publication
c     
      elseif (iener.eq.2) then  ! 189 GeV
         ah0_lumi = 176.2	! Final, publication
c     
      elseif (iener.eq.3) then  ! 192 GeV
         ah0_lumi = 28.893      ! Feb 2000, final.
c     ah0_lumi = 27.2875	! Tampere '99
c     ah0_lumi = 29.042	! Lepton-Photon '99
c     
      elseif (iener.eq.4) then  ! 196 GeV
         ah0_lumi = 79.753      ! Feb 2000, final.
c     ah0_lumi = 26.2340	! Tampere '99
c     ah0_lumi = 69.526	! Lepton-Photon '99
c     
      elseif (iener.eq.5) then  ! 200 GeV
         ah0_lumi = 86.165      ! Feb 2000, final.
c
      elseif (iener.eq.6) then  ! 202 GeV
         ah0_lumi = 41.838      ! Feb 2000, final.
c
      endif
c     
      end

