c
c Modified:
c     - subtracted WW background is reduced by 2.5% to account for
c       theoretical systematic on the cross section;        
c                                                P Seager, 16-Feb-2000.
c     - fixed wrong sign in one efficiency parameterization;
c     - luminosity uncertty. moved form UNCORrelated to CORrelated error array 
c                                                P Seager, 17-Feb-2000.
c
c     - update of 189, 192, 196, 200, 202 inputs
c     - new inputs from year 2000
c                                               E.Locci, 21-June-2000.  
C +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C +++ Luminosities
C +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      REAL FUNCTION AHC_LUMI(IE,C)
C------------------------------------------------------------------------------
C     Intergrated luminosity (pb-1) of the ALEPH data samples analyzed
C     in the charged Higgs search
C
C     Input:     IE    sqrt(s) index (1=130, 2=136, 3=161, 4=172, 
C                                     5=183, 6=189, 7=192, 8=196,
C                                     9=200, 10=202, 11=204, 12=205,
C                                     13=206, 14=207, 15=208)
C                 C    channel (1=tntn, 2=tncs, 3= cssc)
C
C------------------------------------------------------------------------------
      IMPLICIT   NONE
C - Parameters & Constants
C - Arguments
      INTEGER    IE,C
C - Common blocks
C - Auxiliary variables
      REAL       LUMI(15)
C - Data statements
      DATA       LUMI / 2.8, 2.8, 11.1, 10.7, 56.9, 176.4 ,28.9 ,
     +                  79.8, 86.3, 41.9, 7.2, 72.3, 19.1, 107.5, 7.8 /
C - Macros
C - Statements
      AHC_LUMI= 0.
      IF( IE.GE.1 .AND. IE.LE.15 ) AHC_LUMI= LUMI(IE)
C      IF (C.EQ.3.AND.IE.EQ.6) AHC_LUMI = 173.6
      IF (C.EQ.1.AND.IE.EQ.6) AHC_LUMI = 173.6
      IF (C.EQ.2.AND.IE.EQ.6) AHC_LUMI = 176.2
      IF ((C.EQ.1.OR.C.EQ.2).AND.IE.EQ.10) AHC_LUMI = 42.0
      IF ((C.EQ.1.OR.C.EQ.2).AND.IE.EQ.12) AHC_LUMI = 217.2
C - Over !
      RETURN
      END 
