#
#
# Compile all the support code into a single object file
#
# Use this file to compile and link the aleph program (aleph_test.f) 
# that TESTS the ALEPH inputs subroutine.
#
# If you wish to perform a combination you should not compile  the files 
# aleph_test.f and a_cross_sections.F (see below).
#
unlimit datasize 
echo ' *** limit datasize INCREASED: *** '
limit datasize

date
echo ' +---- Compiling supporting code ----+ '
f77 -o /scratch/week/mcnamara/support.a \
  -warn noinformational -g -static -G 0 -w1 -C -fpe2  -c \
 effic_aleph.f pjremt1.f \
 A172_habbbb_all.f A172_hattbb_all.f  \
 A183_hattbb_all.f A183_hqq_all.f A183_hll_all.f A183_htt_all.f \
 A183_habbbb_all.f A183_hnn_all.f A183_ttqq_all.f \
 A189_4jet_all.f A189_hnn_all.f A189_hll_all.f A189_tt_all.f \
 hbb_sm.f hhad_sm.f abb_mssm.f hbb_mssm.f 

echo ' +---- Compiling Version 3.0 (Y2000) ----+ '

echo ' Main code'
f77 -o /scratch/week/mcnamara/main.a \
  -warn noinformational -g -static -G 0 -w1 -C -fpe2  -c \
 a_inputs_vsn40.F aleph_test.f a_cross_sections.F \
 a_histogram.f ah0_lumi.f a_various.f \
 al_xsect_sm.F al_xsect_ha.F MSSM_A_br_hzha03.F MSSM_h_br_hzha03.F \
 init_lumi_2000.F a_interp_xsec.F a2000_allcand.F

echo ' H+H- 1999 & 2000'
f77 -o /scratch/week/mcnamara/hphm.a \
  -warn noinformational -g -static -G 0 -w1 -C -fpe2  -c \
 aleph_hc_vsn30.f a_hphm2000_pdfs.F

echo ' Xtt Hll 1999'
f77 -o /scratch/week/mcnamara/xtthll.a \
  -warn noinformational -g -static -G 0 -w1 -C -fpe2  -c \
 a_hll_eff.F a_hll_bkg_level.F a_hll_cand.F a_hll_pdfs.F \
 a_xtt_eff.F a_xtt_bkg_level.F a_xtt_cand.F a_xtt_pdfs.F \
 a_systematics_192_202.F a_xtt_sig_effs_192_202.F \
 a_xtt_sig_pdfs_192_202.F a_xtt_bkg_pdfs_192_202.F \
 a_hll_sig_pdfs_192_202.F a_hll_bkg_pdfs_192_202.F \
 a_hll_sig_effs_192_202.F

echo ' Hnn Hqq 1999'
f77 -o /scratch/week/mcnamara/hnn4j.a \
  -warn noinformational -g -static -G 0 -w1 -C -fpe2  -c \
 A_nn_code.F A_4j_code.F 

echo ' Hqq 2000'
f77 -o /scratch/week/mcnamara/hqq_2000.a \
  -warn noinformational -g -static -G 0 -w1 -C -fpe2  -c \
  A2000_hqq_effbkg.F A2000_hqq_pdfs.F a_hqq_corrfiles.F

echo ' Hnn 2000'
f77 -o /scratch/week/mcnamara/hnn_2000.a \
  -warn noinformational -g -static -G 0 -w1 -C -fpe2  -c \
  A2000_hnn_pdfs.F A2000_Hnn_update_3.F

echo ' +---- Hll 2000'
f77 -o /scratch/week/mcnamara/hll_2000.a \
  -warn noinformational -g -static -G 0 -w1 -C -fpe2  -c \
 a2000_hll_eff.F a2000_hll_pdfs.F a2000_hll_bkg_level.F \
 a2000_hll_sys.F

echo ' +---- Xtt 2000'
f77 -o /scratch/week/mcnamara/xtt_2000.a \
  -warn noinformational -g -static -G 0 -w1 -C -fpe2  -c \
 a2000_xtt.F a2000_xtt_effs.F a2000_xtt_pdfs.F

 echo ' +---- Fermiophobic Higgs (LEP1 - 2000) '
echo '                   and '
echo ' +---- Invisible Higgs (189 - 202 GeV) '
f77 -o /scratch/week/mcnamara/newcombs.a \
 -warn noinformational -warn argument_checking \
 -g -static -G 0 -w1 -C -fpe2  -c \
 a_zhgg_ext_func.F \
 a_invisible_main.F a_invisible_func.F \
 a_flavind_effs.F a_flavind_tools.F

#
# Link the code
#
echo ' Linking... '
f77 -o /scratch/week/mcnamara/aleph2000.exe \
                     /scratch/week/mcnamara/support.a \
                     /scratch/week/mcnamara/main.a \
                     /scratch/week/mcnamara/hphm.a \
                     /scratch/week/mcnamara/xtthll.a \
                     /scratch/week/mcnamara/hnn4j.a \
                     /scratch/week/mcnamara/hqq_2000.a \
                     /scratch/week/mcnamara/hnn_2000.a \
                     /scratch/week/mcnamara/hll_2000.a \
                     /scratch/week/mcnamara/xtt_2000.a \
                     /scratch/week/mcnamara/newcombs.a \
                        /cern/pro/lib/libmathlib.a \
                        /cern/pro/lib/libpacklib.a \
                        /cern/pro/lib/libkernlib.a  -G 0 -g -C -fpe2

date

#



