      SUBROUTINE PJREMT1(func,index,xmin,xmax,xnorm)                      
C-----------------------------------------------------------------------
C Numerical generation of signal and background masses according to 
C their expected distributions.
C-----------------------------------------------------------------------
      IMPLICIT REAL*8(A-H,O-Z)                                          
      DIMENSION X(1000,10),F(1000),A(1000),Y(1000),Z(1000),XNEW(1000)   

      EXTERNAL func                                                     
C                                                                       
      SAVE                                                              
C                                                                       
C Parameters of numerical integration step                              
      N    = 500                                                        
      ITER = 3                                                          
C                                                                       
      IT=0                                                              
      M=N-1                                                             
      DU=(xmax-xmin)/FLOAT(M)                                           
      X(1,index)=xmin                                                   
      DO 101 I=2,N                                                      
  101 X(I,INDEX)=X(I-1,INDEX)+DU                                        
C                                                                       
C Starting point for iterations                                         
C                                                                       
  100 CONTINUE                                                          
C                                                                       
C Calculate function values                                             
C                                                                       
      DO 102 I=1,N                                                      
  102 F(I)=func(X(I,INDEX))                                             
C                                                                       
C CALCULATE BIN AREAS                                                   
      DO 103 I=1,M                                                      
  103 A(I)=(X(I+1,INDEX)-X(I,INDEX))*(F(I+1)+F(I))/2.                   
C                                                                       
C CALCULATE CUMULATIVE SPECTRUM Y VALUES                                
      Y(1)=0.D0                                                         
      DO 104 I=2,N                                                      
  104 Y(I)=Y(I-1)+A(I-1)                                                
C                                                                       
C PUT EQUIDISTANT POINTS ON Y SCALE                                     
      DZ=Y(N)/FLOAT(M)                                                  
      Z(1)=0.D0                                                         
      DO 105 I=2,N                                                      
  105 Z(I)=Z(I-1)+DZ                                                    
C                                                                       
C DETERMINE SPACING OF Z POINTS IN BETWEEN Y POINTS                     
C FROM THIS, DETERMINE NEW X VALUES AND FINALLY REPLACE OLD VALUES      
      XNEW(1)=X(1,INDEX)                                                
      XNEW(N)=X(N,INDEX)                                                
      K=1                                                               
      DO 108 I=2,M                                                      
  106 IF( Y(K+1) .GT. Z(I) ) GOTO 107                                   
      K=K+1                                                             
      GOTO 106                                                          
  107 R= ( Z(I) - Y(K) ) / ( Y(K+1) - Y(K) )                            
  108 XNEW(I) = X(K,INDEX) + ( X(K+1,INDEX)-X(K,INDEX) )*R              
      DO 109 I=1,N                                                      
  109 X(I,INDEX)=XNEW(I)                                                
C                                                                       
C CHECK ON END OF ITERATIONS AND RETURN                                 
      IT=IT+1                                                           
      SIG1 = Y(M)                                                       
C     PRINT 3,IT,SIG1                                                   
    3 FORMAT(' Iteration # ',i3,'  Integral =',e15.6)                   
      IF(IT.LT.ITER) GOTO 100                                           
      xnorm = Y(M)                                                      
      RETURN                                                            

      END
