C---------------------------------------------------------------------
C---------------------------------------------------------------------
      double precision function A189_4jet_eff(hmass,iana,isig)

      double precision hmass
c

******************************************
******************************************

      double precision A189_4jet_eff_1_ha
      double precision A189_4jet_eff_2_hz
      double precision A189_4jet_eff_2_ha
      double precision A189_4jet_eff_3_hz
      double precision A189_4jet_eff_3_ha
      double precision A189_4jet_eff_1_hz
c
      external A189_4jet_eff_1_hz
      external A189_4jet_eff_1_ha
      external A189_4jet_eff_2_hz
      external A189_4jet_eff_2_ha
      external A189_4jet_eff_3_hz
      external A189_4jet_eff_3_ha

******************************************
******************************************

      integer iana,isig

      A189_4jet_eff = 0.
      if (iana.eq.1) then
        if (isig.eq.1) then
          A189_4jet_eff = A189_4jet_eff_1_hz(hmass)
        else if (isig.eq.2) then
          A189_4jet_eff = A189_4jet_eff_1_ha(hmass)
        endif
      else if (iana.eq.2) then
        if (isig.eq.1) then
          A189_4jet_eff = A189_4jet_eff_2_hz(hmass)
        else if (isig.eq.2) then
          A189_4jet_eff = A189_4jet_eff_2_ha(hmass)
        endif
      else if (iana.eq.3) then
        if (isig.eq.1) then
          A189_4jet_eff = A189_4jet_eff_3_hz(hmass)
        else if (isig.eq.2) then
          A189_4jet_eff = A189_4jet_eff_3_ha(hmass)
        endif
      endif
      end
C---------------------------------------------------------------------
C---------------------------------------------------------------------
      double precision function A189_4jet_bkg(iana,ibkg)

      integer iana,ibkg

      A189_4jet_bkg = 0.

      if (iana.eq.1) then
        if (ibkg.eq.1) then
          A189_4jet_bkg = 0.8026
        else if (ibkg.eq.2) then
          A189_4jet_bkg = 0.05813
        else if (ibkg.eq.3) then
          A189_4jet_bkg = 1.700
      endif
      else if (iana.eq.2) then
        if (ibkg.eq.1) then
          A189_4jet_bkg = 1.890
        else if (ibkg.eq.2) then
          A189_4jet_bkg = 0.05813
        else if (ibkg.eq.3) then
          A189_4jet_bkg = 0.2808
        endif
      else if (iana.eq.3) then
        if (ibkg.eq.1) then
          A189_4jet_bkg = 5.512
        else if (ibkg.eq.2) then
          A189_4jet_bkg = 4.089
        else if (ibkg.eq.3) then
          A189_4jet_bkg = 9.279
        endif
      endif
      end
C---------------------------------------------------------------------
C---------------------------------------------------------------------
      integer function A189_4jet_numcand(iana)

      integer iana

      A189_4jet_numcand = 0
      if (iana.eq.1) then
        A189_4jet_numcand = 4
      else if (iana.eq.2) then
        A189_4jet_numcand = 3
      else if (iana.eq.3) then
        A189_4jet_numcand = 24
      endif
      end
C---------------------------------------------------------------------
C---------------------------------------------------------------------
      double precision function A189_4jet_mh_cand(iana,icand)

      integer iana,icand

      A189_4jet_mh_cand = 10000.

      if (iana.eq.1) then
        if (icand.eq.1) A189_4jet_mh_cand = 50.99
        if (icand.eq.2) A189_4jet_mh_cand = 61.78
        if (icand.eq.3) A189_4jet_mh_cand = 94.30
        if (icand.eq.4) A189_4jet_mh_cand = 78.39
      else if (iana.eq.3) then
        if (icand.eq.1) A189_4jet_mh_cand = 54.20
        if (icand.eq.2) A189_4jet_mh_cand = 78.41
        if (icand.eq.3) A189_4jet_mh_cand = 66.53
        if (icand.eq.4) A189_4jet_mh_cand = 95.36
        if (icand.eq.5) A189_4jet_mh_cand = 87.21
        if (icand.eq.6) A189_4jet_mh_cand = 59.76
        if (icand.eq.7) A189_4jet_mh_cand = 91.80
        if (icand.eq.8) A189_4jet_mh_cand = 95.07
        if (icand.eq.9) A189_4jet_mh_cand = 85.23
        if (icand.eq.10) A189_4jet_mh_cand = 80.42
        if (icand.eq.11) A189_4jet_mh_cand = 95.53
        if (icand.eq.12) A189_4jet_mh_cand = 74.56
        if (icand.eq.13) A189_4jet_mh_cand = 92.53
        if (icand.eq.14) A189_4jet_mh_cand = 90.39
        if (icand.eq.15) A189_4jet_mh_cand = 62.69
        if (icand.eq.16) A189_4jet_mh_cand = 88.71
        if (icand.eq.17) A189_4jet_mh_cand = 81.86
        if (icand.eq.18) A189_4jet_mh_cand = 87.03
        if (icand.eq.19) A189_4jet_mh_cand = 36.36
        if (icand.eq.20) A189_4jet_mh_cand = 42.03
        if (icand.eq.21) A189_4jet_mh_cand = 86.69
        if (icand.eq.22) A189_4jet_mh_cand = 93.70
        if (icand.eq.23) A189_4jet_mh_cand = 62.80
        if (icand.eq.24) A189_4jet_mh_cand = 93.29

      endif
      end
C---------------------------------------------------------------------
C---------------------------------------------------------------------
      double precision function A189_4jet_nn_cand(iana,icand)

      integer iana,icand

      A189_4jet_nn_cand = 10000.

      if (iana.eq.1) then
        if (icand.eq.1) A189_4jet_nn_cand = 0.9967
        if (icand.eq.2) A189_4jet_nn_cand = 0.9963
        if (icand.eq.3) A189_4jet_nn_cand = 0.9954
        if (icand.eq.4) A189_4jet_nn_cand = 0.9984
      else if (iana.eq.3) then
        if (icand.eq.1) A189_4jet_nn_cand = 0.9779
        if (icand.eq.2) A189_4jet_nn_cand = 0.9674
        if (icand.eq.3) A189_4jet_nn_cand = 0.9523
        if (icand.eq.4) A189_4jet_nn_cand = 0.9986
        if (icand.eq.5) A189_4jet_nn_cand = 0.9697
        if (icand.eq.6) A189_4jet_nn_cand = 0.9554
        if (icand.eq.7) A189_4jet_nn_cand = 0.9887
        if (icand.eq.8) A189_4jet_nn_cand = 0.9928
        if (icand.eq.9) A189_4jet_nn_cand = 0.9885
        if (icand.eq.10) A189_4jet_nn_cand = 0.9882
        if (icand.eq.11) A189_4jet_nn_cand = 0.9929
        if (icand.eq.12) A189_4jet_nn_cand = 0.9953
        if (icand.eq.13) A189_4jet_nn_cand = 0.9614
        if (icand.eq.14) A189_4jet_nn_cand = 0.9892
        if (icand.eq.15) A189_4jet_nn_cand = 0.9972
        if (icand.eq.16) A189_4jet_nn_cand = 0.9655
        if (icand.eq.17) A189_4jet_nn_cand = 0.9768
        if (icand.eq.18) A189_4jet_nn_cand = 0.9911
        if (icand.eq.19) A189_4jet_nn_cand = 0.9894
        if (icand.eq.20) A189_4jet_nn_cand = 0.9576
        if (icand.eq.21) A189_4jet_nn_cand = 0.9511
        if (icand.eq.22) A189_4jet_nn_cand = 0.9937
        if (icand.eq.23) A189_4jet_nn_cand = 0.9824
        if (icand.eq.24) A189_4jet_nn_cand = 0.9600
      endif
      end
C---------------------------------------------------------------------
C---------------------------------------------------------------------
      double precision function A189_4jet_msum_cand(iana,icand)

      integer iana,icand

      A189_4jet_msum_cand = 10000.

      if (iana.eq.1) then
        if (icand.eq.1) A189_4jet_msum_cand = 176.0949
        if (icand.eq.2) A189_4jet_msum_cand = 179.6007
        if (icand.eq.3) A189_4jet_msum_cand = 165.0569
        if (icand.eq.4) A189_4jet_msum_cand = 169.5864
      else if (iana.eq.2) then
        if (icand.eq.1) A189_4jet_msum_cand = 101.8622
        if (icand.eq.2) A189_4jet_msum_cand =  93.9256
        if (icand.eq.3) A189_4jet_msum_cand =  95.8994
      endif
      end
C---------------------------------------------------------------------
C---------------------------------------------------------------------
      double precision function A189_4jet_fvar_cand(iana,icand)

      integer iana,icand

      A189_4jet_fvar_cand = 10000.

      if (iana.eq.1) then
        if (icand.eq.1) A189_4jet_fvar_cand = 169.9533
        if (icand.eq.2) A189_4jet_fvar_cand = 156.8251
        if (icand.eq.3) A189_4jet_fvar_cand = 261.9423
        if (icand.eq.4) A189_4jet_fvar_cand =  80.0758
      else if (iana.eq.2) then
        if (icand.eq.1) A189_4jet_fvar_cand = 181.6161
        if (icand.eq.2) A189_4jet_fvar_cand =  48.7837
        if (icand.eq.3) A189_4jet_fvar_cand = 260.8168
      endif
      end
C---------------------------------------------------------------------
C---------------------------------------------------------------------
      double precision function A189_4jet_bkg_mh(hmass,iana,ibkg)

      integer iana,ibkg
      double precision hmass
      double precision A189_4jet_1_qq_mh
      double precision A189_4jet_1_ww_mh
      double precision A189_4jet_1_zz_mh
      double precision A189_4jet_3_qq_mh
      double precision A189_4jet_3_ww_mh
      double precision A189_4jet_3_zz_mh
      external A189_4jet_1_qq_mh
      external A189_4jet_1_ww_mh
      external A189_4jet_1_zz_mh
      external A189_4jet_3_qq_mh
      external A189_4jet_3_ww_mh
      external A189_4jet_3_zz_mh

      if (iana.eq.1) then
        if (ibkg.eq.1) A189_4jet_bkg_mh = A189_4jet_1_qq_mh(hmass)
        if (ibkg.eq.2) A189_4jet_bkg_mh = A189_4jet_1_ww_mh(hmass)
        if (ibkg.eq.3) A189_4jet_bkg_mh = A189_4jet_1_zz_mh(hmass)
      else if (iana.eq.3) then
        if (ibkg.eq.1) A189_4jet_bkg_mh = A189_4jet_3_qq_mh(hmass)
        if (ibkg.eq.2) A189_4jet_bkg_mh = A189_4jet_3_ww_mh(hmass)
        if (ibkg.eq.3) A189_4jet_bkg_mh = A189_4jet_3_zz_mh(hmass)
      endif
      end
C---------------------------------------------------------------------
C---------------------------------------------------------------------
      double precision function A189_4jet_bkg_nn(nnval,iana,ibkg)

      integer iana,ibkg
      double precision nnval
      double precision A189_4jet_1_qq_nn
      double precision A189_4jet_1_ww_nn
      double precision A189_4jet_1_zz_nn
      double precision A189_4jet_3_qq_nn
      double precision A189_4jet_3_ww_nn
      double precision A189_4jet_3_zz_nn
      external A189_4jet_1_qq_nn
      external A189_4jet_1_ww_nn
      external A189_4jet_1_zz_nn
      external A189_4jet_3_qq_nn
      external A189_4jet_3_ww_nn
      external A189_4jet_3_zz_nn

      if (iana.eq.1) then
        if (ibkg.eq.1) A189_4jet_bkg_nn = A189_4jet_1_qq_nn(nnval)
        if (ibkg.eq.2) A189_4jet_bkg_nn = A189_4jet_1_ww_nn(nnval)
        if (ibkg.eq.3) A189_4jet_bkg_nn = A189_4jet_1_zz_nn(nnval)
      else if (iana.eq.3) then
        if (ibkg.eq.1) A189_4jet_bkg_nn = A189_4jet_3_qq_nn(nnval)
        if (ibkg.eq.2) A189_4jet_bkg_nn = A189_4jet_3_ww_nn(nnval)
        if (ibkg.eq.3) A189_4jet_bkg_nn = A189_4jet_3_zz_nn(nnval)
      endif
      end
C---------------------------------------------------------------------
C---------------------------------------------------------------------
      double precision function A189_4jet_bkg_msum(hmass,iana,ibkg)

      integer iana,ibkg
      double precision hmass
      double precision A189_4jet_1_qq_msum
      double precision A189_4jet_1_ww_msum
      double precision A189_4jet_1_zz_msum
      double precision A189_4jet_2_qq_msum
      double precision A189_4jet_2_ww_msum
      double precision A189_4jet_2_zz_msum
      external A189_4jet_1_qq_msum
      external A189_4jet_1_ww_msum
      external A189_4jet_1_zz_msum
      external A189_4jet_2_qq_msum
      external A189_4jet_2_ww_msum
      external A189_4jet_2_zz_msum

      if (iana.eq.1) then
        if (ibkg.eq.1) A189_4jet_bkg_msum = A189_4jet_1_qq_msum(hmass)
        if (ibkg.eq.2) A189_4jet_bkg_msum = A189_4jet_1_ww_msum(hmass)
        if (ibkg.eq.3) A189_4jet_bkg_msum = A189_4jet_1_zz_msum(hmass)
      else if (iana.eq.2) then
        if (ibkg.eq.1) A189_4jet_bkg_msum = A189_4jet_2_qq_msum(hmass)
        if (ibkg.eq.2) A189_4jet_bkg_msum = A189_4jet_2_ww_msum(hmass)
        if (ibkg.eq.3) A189_4jet_bkg_msum = A189_4jet_2_zz_msum(hmass)
      endif
      end
C---------------------------------------------------------------------
C---------------------------------------------------------------------
      double precision function A189_4jet_bkg_fvar(vfvar,iana,ibkg)

      integer iana,ibkg
      double precision vfvar
      double precision A189_4jet_1_qq_fvar
      double precision A189_4jet_1_ww_fvar
      double precision A189_4jet_1_zz_fvar
      double precision A189_4jet_2_qq_fvar
      double precision A189_4jet_2_ww_fvar
      double precision A189_4jet_2_zz_fvar
      external A189_4jet_1_qq_fvar
      external A189_4jet_1_ww_fvar
      external A189_4jet_1_zz_fvar
      external A189_4jet_2_qq_fvar
      external A189_4jet_2_ww_fvar
      external A189_4jet_2_zz_fvar

      if (iana.eq.1) then
        if (ibkg.eq.1) A189_4jet_bkg_fvar = A189_4jet_1_qq_fvar(vfvar)
        if (ibkg.eq.2) A189_4jet_bkg_fvar = A189_4jet_1_ww_fvar(vfvar)
        if (ibkg.eq.3) A189_4jet_bkg_fvar = A189_4jet_1_zz_fvar(vfvar)
      else if (iana.eq.2) then
        if (ibkg.eq.1) A189_4jet_bkg_fvar = A189_4jet_2_qq_fvar(vfvar)
        if (ibkg.eq.2) A189_4jet_bkg_fvar = A189_4jet_2_ww_fvar(vfvar)
        if (ibkg.eq.3) A189_4jet_bkg_fvar = A189_4jet_2_zz_fvar(vfvar)
      endif
      end
C---------------------------------------------------------------------
C---------------------------------------------------------------------
      double precision function A189_4jet_sig_mh(rm,hm,iana,isig)

      double precision rm,hm,rmh
      integer iana,isig

      double precision A189_4jet_1_hz_mh
      double precision A189_4jet_1_ha_mh
      double precision A189_4jet_3_hz_mh
      double precision A189_4jet_3_ha_mh
      external A189_4jet_1_hz_mh
      external A189_4jet_1_ha_mh
      external A189_4jet_3_hz_mh
      external A189_4jet_3_ha_mh

      common /mass/ rmh

      rmh = hm

      A189_4jet_sig_mh = -100.
      if (iana.eq.1) then
        if (isig.eq.1) A189_4jet_sig_mh = A189_4jet_1_hz_mh(rm)
        if (isig.eq.2) A189_4jet_sig_mh = A189_4jet_1_ha_mh(rm)
      else if (iana.eq.3) then
        if (isig.eq.1) A189_4jet_sig_mh = A189_4jet_3_hz_mh(rm)
        if (isig.eq.2) A189_4jet_sig_mh = A189_4jet_3_ha_mh(rm)
      endif
      end
C---------------------------------------------------------------------
C---------------------------------------------------------------------
      double precision function A189_4jet_sig_nn(nn,hm,iana,isig)

      double precision nn,hm,rmh
      integer iana,isig

      double precision A189_4jet_1_hz_nn
      double precision A189_4jet_1_ha_nn
      double precision A189_4jet_3_hz_nn
      double precision A189_4jet_3_ha_nn
      external A189_4jet_1_hz_nn
      external A189_4jet_1_ha_nn
      external A189_4jet_3_hz_nn
      external A189_4jet_3_ha_nn

      common /mass/ rmh

      rmh = hm

      A189_4jet_sig_mh = -100.
      if (iana.eq.1) then
        if (isig.eq.1) A189_4jet_sig_nn = A189_4jet_1_hz_nn(nn)
        if (isig.eq.2) A189_4jet_sig_nn = A189_4jet_1_ha_nn(nn)
      else if (iana.eq.3) then
        if (isig.eq.1) A189_4jet_sig_nn = A189_4jet_3_hz_nn(nn)
        if (isig.eq.2) A189_4jet_sig_nn = A189_4jet_3_ha_nn(nn)
      endif
      end
C---------------------------------------------------------------------
C---------------------------------------------------------------------
      double precision function A189_4jet_sig_msum(msum,hm,iana,isig)

      double precision msum,hm,rmh
      integer iana,isig

      double precision A189_4jet_1_hz_msum
      double precision A189_4jet_1_ha_msum
      double precision A189_4jet_2_hz_msum
      double precision A189_4jet_2_ha_msum
      external A189_4jet_1_hz_msum
      external A189_4jet_1_ha_msum
      external A189_4jet_2_hz_msum
      external A189_4jet_2_ha_msum

      common /mass/ rmh

      rmh = hm

      A189_4jet_sig_mh = -100.
      if (iana.eq.1) then
        if (isig.eq.1) A189_4jet_sig_msum = A189_4jet_1_hz_msum(msum)
        if (isig.eq.2) A189_4jet_sig_msum = A189_4jet_1_ha_msum(msum)
      else if (iana.eq.2) then
        if (isig.eq.1) A189_4jet_sig_msum = A189_4jet_2_hz_msum(msum)
        if (isig.eq.2) A189_4jet_sig_msum = A189_4jet_2_ha_msum(msum)
      endif
      end
C---------------------------------------------------------------------
C---------------------------------------------------------------------
      double precision function A189_4jet_sig_fvar(fvar,hm,iana,isig)

      double precision fvar,hm,rmh
      integer iana,isig

      double precision A189_4jet_1_hz_fvar
      double precision A189_4jet_1_ha_fvar
      double precision A189_4jet_2_hz_fvar
      double precision A189_4jet_2_ha_fvar
      external A189_4jet_1_hz_fvar
      external A189_4jet_1_ha_fvar
      external A189_4jet_2_hz_fvar
      external A189_4jet_2_ha_fvar

      common /mass/ rmh

      rmh = hm

      A189_4jet_sig_mh = -100.
      if (iana.eq.1) then
        if (isig.eq.1) A189_4jet_sig_fvar = A189_4jet_1_hz_fvar(fvar)
        if (isig.eq.2) A189_4jet_sig_fvar = A189_4jet_1_ha_fvar(fvar)
      else if (iana.eq.2) then
        if (isig.eq.1) A189_4jet_sig_fvar = A189_4jet_2_hz_fvar(fvar)
        if (isig.eq.2) A189_4jet_sig_fvar = A189_4jet_2_ha_fvar(fvar)
      endif
      end

C------------------------ Instructions for the user -------------------------
C
C This function is used to interpolate between the signal mass shapes obtained 
C at different mH values, when computing sensitivity curves 
C at 188.6 GeV, CL(mH). The user has to provide the signal shapes at 
C
C     mH=75, 80, 85, 90, 95, 97.5, 100, 105 and 110 GeV
C     
C as DOUBLE PRECISION FORTRAN FUNCTIONS named ha75_1_fvar, ..., SMH975,..., SMH110,
C respectively.
C
C The mass at which the user wishes to obtain the interpolated shape is
C passed using the variable RMH in common MASS.
C
C-----------------------------------------------------------------------------
C
C     Author: Pedro Teixeira-Dias.
C     Mods:
C     - The input shapes (provided by the user) are now automatically
C     normalized, upon the first call to this function;
C     - For interpolation in the range 95 <= mH <= 97.5 (threshold), do not 
C     move the 97.5 shape downwards (keep it fixed) as this effectively shifts
C     the very sharp threshold cut-off downwards.           PTD, 13-Nov-1998.
C     - Adapt to 188.6 GeV situation: KL=97.4 GeV and the 97 Gev sample 
C     becomes the 97.5 GeV sample.                          PTD, 04-Feb-1999.
C     - Use the old REMT1 subroutine (not the one in the new library)
C     it is here renamed PJREMT1;                           PTD, 09-Feb-1999.
C
      DOUBLE PRECISION FUNCTION A189_4jet_1_ha_fvar(X)
C
      DOUBLE PRECISION X,DELTA1,DELTA2,REFMH1,REFMH2,F1,F2,
     .     SINT65haf,SINT70haf,SINT75haf,SINT80haf,SINT85haf,
     .     SINT90haf,SINT95haf,XKL,XMIN,XMAX
      REAL*8   ha65_1_fvar,ha70_1_fvar,ha75_1_fvar,
     .         ha80_1_fvar,ha85_1_fvar,ha90_1_fvar,ha95_1_fvar
      EXTERNAL ha65_1_fvar,ha70_1_fvar,ha75_1_fvar,
     .         ha80_1_fvar,ha85_1_fvar,ha90_1_fvar,ha95_1_fvar
      LOGICAL FIRST
      DATA FIRST /.TRUE./
c
c Kinematic Limit
c
      PARAMETER(XKL=300D0,XMIN=-100D0,XMAX=266D0)
C
      DOUBLE PRECISION RMH
      COMMON /MASS/ RMH
C
      IF (FIRST) THEN
         FIRST = .FALSE.
c         WRITE (6,'(a,2f6.2)') 
c     +    ' Integrating the input SIGNAL functions between:',xmin,xmax
         CALL pjremt1(ha65_1_fvar,10,xmin,xmax,sint65haf) 
         CALL pjremt1(ha70_1_fvar,10,xmin,xmax,sint70haf) 
         CALL pjremt1(ha75_1_fvar,10,xmin,xmax,sint75haf) 
         CALL pjremt1(ha80_1_fvar,10,xmin,xmax,sint80haf) 
         CALL pjremt1(ha85_1_fvar,10,xmin,xmax,sint85haf) 
         CALL pjremt1(ha90_1_fvar,10,xmin,xmax,sint90haf) 
         CALL pjremt1(ha95_1_fvar,10,xmin,xmax,sint95haf) 
C        write (6,*) '================================================'
C        write (6,*) 'The integrals of the signal functions are:'
C        WRITE (6,'((a7,f8.2,a7,f8.2,a7,f8.2))') 
c     &        '  65-->',SINT65haf,'| 70-->',SINT70haf,
c     &        '| 75-->',SINT75haf,
c     &        '  80-->',SINT80haf,'| 85-->',SINT85haf,
c     &        '| 90-->',SINT90haf
C        WRITE (6,'((a7,f8.2))')
c     &        '  95-->',SINT95haf
C        write (6,*) '================================================'
C        write (6,*) 'The kinematic boundary is set at ',sngl(XKL)
      END IF
C
      IF (RMH.GE.65D0 .AND. RMH.LE.70D0) THEN
         REFMH1 = 65D0
         REFMH2 = 70D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = ha65_1_fvar(X) / SINT65haf
         F2 = ha70_1_fvar(X) / SINT70haf
      ELSE IF (RMH.GT.70D0 .AND. RMH.LE.75D0) THEN
         REFMH1 = 70D0
         REFMH2 = 75D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = ha70_1_fvar(X) / SINT70haf
         F2 = ha75_1_fvar(X) / SINT75haf
      ELSE IF (RMH.GT.75D0 .AND. RMH.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = ha75_1_fvar(X) / SINT75haf
         F2 = ha80_1_fvar(X) / SINT80haf
      ELSE IF (RMH.GT.80D0 .AND. RMH.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = ha80_1_fvar(X) / SINT80haf
         F2 = ha85_1_fvar(X) / SINT85haf
      ELSE IF (RMH.GT.85D0 .AND. RMH.LE.90D0) THEN
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = ha85_1_fvar(X) / SINT85haf
         F2 = ha90_1_fvar(X) / SINT90haf
      ELSE IF (RMH.GT.90D0 .AND. RMH.LE.95D0) THEN
c
c     Special treatment: only shift the 90 GeV shape upwards, while keeping 
C     the 95 GeV shape fixed; [i.e., same weights as before, but fix 95 shape]
c
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = ha90_1_fvar(X) / SINT90haf
         F2 = ha95_1_fvar(X) / SINT95haf
      ELSE
         A189_4jet_1_ha_fvar = 0D0
         RETURN
      END IF
C
      A189_4jet_1_ha_fvar = 
     &       (DELTA2 * F1 + DELTA1 * F2) / (REFMH2 - REFMH1)
      IF (A189_4jet_1_ha_fvar.LT.1.D-5) A189_4jet_1_ha_fvar = 1.D-5
c
c NB all the INPUT functions vanish at the kinematic 
c limit x = 188.6 - 91.2 = 97.4; The interpolated functions may (because of 
c the TRANSLATION involved) have a tiny tail of non-zero values beyond the KL.
c This is not physical and is corrected here:
c
c      if (x.gt.xkl) A189_4jet = 1.D-5
C
      RETURN
      END


C------------------------ Instructions for the user -------------------------
C
C This function is used to interpolate between the signal mass shapes obtained 
C at different mH values, when computing sensitivity curves 
C at 188.6 GeV, CL(mH). The user has to provide the signal shapes at 
C
C     mH=75, 80, 85, 90, 95, 97.5, 100, 105 and 110 GeV
C     
C as DOUBLE PRECISION FORTRAN FUNCTIONS named ha75_1_msum, ..., SMH975,..., SMH110,
C respectively.
C
C The mass at which the user wishes to obtain the interpolated shape is
C passed using the variable RMH in common MASS.
C
C-----------------------------------------------------------------------------
C
C     Author: Pedro Teixeira-Dias.
C     Mods:
C     - The input shapes (provided by the user) are now automatically
C     normalized, upon the first call to this function;
C     - For interpolation in the range 95 <= mH <= 97.5 (threshold), do not 
C     move the 97.5 shape downwards (keep it fixed) as this effectively shifts
C     the very sharp threshold cut-off downwards.           PTD, 13-Nov-1998.
C     - Adapt to 188.6 GeV situation: KL=97.4 GeV and the 97 Gev sample 
C     becomes the 97.5 GeV sample.                          PTD, 04-Feb-1999.
C     - Use the old REMT1 subroutine (not the one in the new library)
C     it is here renamed PJREMT1;                           PTD, 09-Feb-1999.
C
      DOUBLE PRECISION FUNCTION A189_4jet_1_ha_msum(X)
C
      DOUBLE PRECISION X,DELTA1,DELTA2,REFMH1,REFMH2,F1,F2,
     .     SINT65ham,SINT70ham,SINT75ham,SINT80ham,SINT85ham,
     .     SINT90ham,SINT95ham,XKL,XMIN,XMAX
      REAL*8   ha65_1_msum,ha70_1_msum,ha75_1_msum,
     .         ha80_1_msum,ha85_1_msum,ha90_1_msum,ha95_1_msum
      EXTERNAL ha65_1_msum,ha70_1_msum,ha75_1_msum,
     .         ha80_1_msum,ha85_1_msum,ha90_1_msum,ha95_1_msum
      LOGICAL FIRST
      DATA FIRST /.TRUE./
c
c Kinematic Limit
c
      PARAMETER(XKL=188.6D0,XMIN=40D0,XMAX=188.6D0)
C
      DOUBLE PRECISION RMH
      COMMON /MASS/ RMH
C
      IF (FIRST) THEN
         FIRST = .FALSE.
c         WRITE (6,'(a,2f6.2)') 
c     +      ' Integrating the input SIGNAL functions between:',xmin,xmax
         CALL pjremt1(ha65_1_msum,10,xmin,xmax,sint65ham) 
         CALL pjremt1(ha70_1_msum,10,xmin,xmax,sint70ham) 
         CALL pjremt1(ha75_1_msum,10,xmin,xmax,sint75ham) 
         CALL pjremt1(ha80_1_msum,10,xmin,xmax,sint80ham) 
         CALL pjremt1(ha85_1_msum,10,xmin,xmax,sint85ham) 
         CALL pjremt1(ha90_1_msum,10,xmin,xmax,sint90ham) 
         CALL pjremt1(ha95_1_msum,10,xmin,xmax,sint95ham) 
C        write (6,*) '================================================'
C        WRITE (6,*) 'The integrals of the signal functions are:'
C        WRITE (6,'((a7,f8.2,a7,f8.2,a7,f8.2))') 
c    &        '  65-->',SINT65ham,'| 70-->',SINT70ham,
C    &        '| 75-->',SINT75ham,
C    &        '  80-->',SINT80ham,'| 85-->',SINT85ham,
C    &        '| 90-->',SINT90ham
C        WRITE (6,'((a7,f8.2))')
C    &        '  95-->',SINT95ham
C        write (6,*) '================================================'
C        write (6,*) 'The kinematic boundary is set at ',sngl(XKL)
      END IF
C
      IF (RMH.GE.65D0 .AND. RMH.LE.70D0) THEN
         REFMH1 = 65D0
         REFMH2 = 70D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = ha65_1_msum(X-2*DELTA1) / SINT65ham
         F2 = ha70_1_msum(X+2*DELTA2) / SINT70ham
      ELSE IF (RMH.GT.70D0 .AND. RMH.LE.75D0) THEN
         REFMH1 = 70D0
         REFMH2 = 75D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = ha70_1_msum(X-2*DELTA1) / SINT70ham
         F2 = ha75_1_msum(X+2*DELTA2) / SINT75ham
      ELSE IF (RMH.GT.75D0 .AND. RMH.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = ha75_1_msum(X-2*DELTA1) / SINT75ham
         F2 = ha80_1_msum(X+2*DELTA2) / SINT80ham
      ELSE IF (RMH.GT.80D0 .AND. RMH.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = ha80_1_msum(X-2*DELTA1) / SINT80ham
         F2 = ha85_1_msum(X+2*DELTA2) / SINT85ham
      ELSE IF (RMH.GT.85D0 .AND. RMH.LE.90D0) THEN
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = ha85_1_msum(X-2*DELTA1) / SINT85ham
         F2 = ha90_1_msum(X+2*DELTA2) / SINT90ham
      ELSE IF (RMH.GT.90D0 .AND. RMH.LE.95D0) THEN
c
c     Special treatment: only shift the 90 GeV shape upwards, while keeping 
C     the 95 GeV shape fixed; [i.e., same weights as before, but fix 95 shape]
c
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = ha90_1_msum(X-2*DELTA1) / SINT90ham
         F2 = ha95_1_msum(X) / SINT95ham
      ELSE
         A189_4jet_1_ha_msum = 0D0
         RETURN
      END IF
C
      A189_4jet_1_ha_msum =
     &         (DELTA2 * F1 + DELTA1 * F2) / (REFMH2 - REFMH1)
      IF (A189_4jet_1_ha_msum.LT.1.D-5) A189_4jet_1_ha_msum = 1.D-5
c
c NB all the INPUT functions vanish at the kinematic 
c limit x = 188.6 - 91.2 = 97.4; The interpolated functions may (because of 
c the TRANSLATION involved) have a tiny tail of non-zero values beyond the KL.
c This is not physical and is corrected here:
c
      if (x.gt.xkl) A189_4jet_1_ha_msum = 1.D-5
C
      RETURN
      END


C------------------------ Instructions for the user -------------------------
C
C This function is used to interpolate between the signal mass shzpes obtained 
C at different mH values, when computing sensitivity curves 
C at 188.6 GeV, CL(mH). The user hzs to provide the signal shzpes at 
C
C     mH=75, 80, 85, 90, 95, 97.5, 100, 105 and 110 GeV
C     
C as DOUBLE PRECISION FORTRAN FUNCTIONS named hz75_1_fvar, ..., SMH975,..., SMH110,
C respectively.
C
C The mass at which the user wishes to obtain the interpolated shzpe is
C passed using the variable RMH in common MASS.
C
C-----------------------------------------------------------------------------
C
C     Author: Pedro Teixeira-Dias.
C     Mods:
C     - The input shzpes (provided by the user) are now automatically
C     normalized, upon the first call to this function;
C     - For interpolation in the range 95 <= mH <= 97.5 (threshold), do not 
C     move the 97.5 shzpe downwards (keep it fixed) as this effectively shifts
C     the very sharp threshold cut-off downwards.           PTD, 13-Nov-1998.
C     - Adapt to 188.6 GeV situation: KL=97.4 GeV and the 97 Gev sample 
C     becomes the 97.5 GeV sample.                          PTD, 04-Feb-1999.
C     - Use the old REMT1 subroutine (not the one in the new library)
C     it is here renamed PJREMT1;                           PTD, 09-Feb-1999.
C
      DOUBLE PRECISION FUNCTION A189_4jet_1_hz_fvar(X)
C
      DOUBLE PRECISION X,DELTA1,DELTA2,REFMH1,REFMH2,F1,F2,
     .     SINT75hzf,SINT80hzf,SINT85hzf,SINT90hzf,SINT95hzf,
     .     SINT975hzf,SINT100hzf,SINT105hzf,SINT110hzf,XKL,XMIN,XMAX
      REAL*8   hz75_1_fvar,hz80_1_fvar,hz85_1_fvar,
     .         hz90_1_fvar,hz95_1_fvar,hz975_1_fvar,
     .         hz100_1_fvar,hz105_1_fvar,hz110_1_fvar
      EXTERNAL hz75_1_fvar,hz80_1_fvar,hz85_1_fvar,
     .         hz90_1_fvar,hz95_1_fvar,hz975_1_fvar,
     .         hz100_1_fvar,hz105_1_fvar,hz110_1_fvar
      LOGICAL FIRST
      DATA FIRST /.TRUE./
c
c Kinematic Limit
c
      PARAMETER(XKL=300D0,XMIN=-100D0,XMAX=266D0)
C
      DOUBLE PRECISION RMH
      COMMON /MASS/ RMH
C
      IF (FIRST) THEN
         FIRST = .FALSE.
c         WRITE (6,'(a,2f6.2)') 
c     +      ' Integrating the input SIGNAL functions between:',xmin,xmax
         CALL pjremt1(hz75_1_fvar,10,xmin,xmax,sint75hzf) 
         CALL pjremt1(hz80_1_fvar,10,xmin,xmax,sint80hzf) 
         CALL pjremt1(hz85_1_fvar,10,xmin,xmax,sint85hzf) 
         CALL pjremt1(hz90_1_fvar,10,xmin,xmax,sint90hzf) 
         CALL pjremt1(hz95_1_fvar,10,xmin,xmax,sint95hzf) 
         CALL pjremt1(hz975_1_fvar,10,xmin,xmax,sint975hzf) 
         CALL pjremt1(hz100_1_fvar,10,xmin,xmax,sint100hzf) 
         CALL pjremt1(hz105_1_fvar,10,xmin,xmax,sint105hzf) 
         CALL pjremt1(hz110_1_fvar,10,xmin,xmax,sint110hzf) 
C        write (6,*) '================================================'
C        WRITE (6,*) 'The integrals of the signal functions are:'
C        WRITE (6,'((a7,f8.2,a7,f8.2,a7,f8.2))') 
c     &    '  75-->',SINT75hzf,'| 80-->',SINT80hzf,
c     &    '| 85-->',SINT85hzf,
c     &    '  90-->',SINT90hzf,'| 95-->',SINT95hzf,
c     &    '|975-->',SINT975hzf,
c     &    ' 100-->',SINT100hzf,'|105-->',SINT105hzf,
c     &    '|110-->',SINT110hzf 
C        write (6,*) '================================================'
C        write (6,*) 'The kinematic boundary is set at ',sngl(XKL)
      END IF
C
      IF (RMH.GE.75D0 .AND. RMH.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz75_1_fvar(X) / SINT75hzf
         F2 = hz80_1_fvar(X) / SINT80hzf
      ELSE IF (RMH.GT.80D0 .AND. RMH.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz80_1_fvar(X) / SINT80hzf
         F2 = hz85_1_fvar(X) / SINT85hzf
      ELSE IF (RMH.GT.85D0 .AND. RMH.LE.90D0) THEN
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz85_1_fvar(X) / SINT85hzf
         F2 = hz90_1_fvar(X) / SINT90hzf
      ELSE IF (RMH.GT.90D0 .AND. RMH.LE.95D0) THEN
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz90_1_fvar(X) / SINT90hzf
         F2 = hz95_1_fvar(X) / SINT95hzf
      ELSE IF (RMH.GT.95D0 .AND. RMH.LE.97.5D0) THEN
c
c     Special treatment: only shift the 95 GeV shape upwards, while keeping 
C     the 97.5 GeV shape fixed; [i.e., same weights as before, but fix 97.5 shape]
c
         REFMH1 = 95D0
         REFMH2 = 97.5D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz95_1_fvar(X) / SINT95hzf
         F2 = hz975_1_fvar(X) / SINT975hzf
      ELSE IF (RMH.GT.97.5D0 .AND. RMH.LE.100D0) THEN
         REFMH1 = 97.5D0
         REFMH2 = 100D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz975_1_fvar(X) / SINT975hzf
         F2 = hz100_1_fvar(X) / SINT100hzf
      ELSE IF (RMH.GT.100D0 .AND. RMH.LE.105D0) THEN
         REFMH1 = 100D0
         REFMH2 = 105D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz100_1_fvar(X) / SINT100hzf
         F2 = hz105_1_fvar(X) / SINT105hzf
      ELSE IF (RMH.GT.105D0 .AND. RMH.LE.110D0) THEN
         REFMH1 = 105D0
         REFMH2 = 110D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz105_1_fvar(X) / SINT105hzf
         F2 = hz110_1_fvar(X) / SINT110hzf
      ELSE
         A189_4jet_1_HZ_FVAR = 0D0
         RETURN
      END IF
C
      A189_4jet_1_HZ_FVAR =
     &        (DELTA2 * F1 + DELTA1 * F2) / (REFMH2 - REFMH1)
      IF (A189_4jet_1_HZ_FVAR.LT.1.D-5) A189_4jet_1_HZ_FVAR = 1.D-5
c
c NB all the INPUT functions vanish at the kinematic 
c limit x = 188.6 - 91.2 = 97.4; The interpolated functions may (because of 
c the TRANSLATION involved) have a tiny tail of non-zero values beyond the KL.
c This is not physical and is corrected here:
c
c      if (x.gt.xkl) A189_4jet_1_hz_fvar = 1.D-5
C
      RETURN
      END


C------------------------ Instructions for the user -------------------------
C
C This function is used to interpolate between the signal mass shzpes obtained 
C at different mH values, when computing sensitivity curves 
C at 188.6 GeV, CL(mH). The user hzs to provide the signal shzpes at 
C
C     mH=75, 80, 85, 90, 95, 97.5, 100, 105 and 110 GeV
C     
C as DOUBLE PRECISION FORTRAN FUNCTIONS named hz75_1_msum, ..., SMH975,..., SMH110,
C respectively.
C
C The mass at which the user wishes to obtain the interpolated shzpe is
C passed using the variable RMH in common MASS.
C
C-----------------------------------------------------------------------------
C
C     Author: Pedro Teixeira-Dias.
C     Mods:
C     - The input shzpes (provided by the user) are now automatically
C     normalized, upon the first call to this function;
C     - For interpolation in the range 95 <= mH <= 97.5 (threshold), do not 
C     move the 97.5 shzpe downwards (keep it fixed) as this effectively shifts
C     the very sharp threshold cut-off downwards.           PTD, 13-Nov-1998.
C     - Adapt to 188.6 GeV situation: KL=97.4 GeV and the 97 Gev sample 
C     becomes the 97.5 GeV sample.                          PTD, 04-Feb-1999.
C     - Use the old REMT1 subroutine (not the one in the new library)
C     it is here renamed PJREMT1;                           PTD, 09-Feb-1999.
C
      DOUBLE PRECISION FUNCTION A189_4jet_1_hz_msum(X)
C
      DOUBLE PRECISION X,DELTA1,DELTA2,REFMH1,REFMH2,F1,F2,
     .     SINT75hzm,SINT80hzm,SINT85hzm,SINT90hzm,SINT95hzm,
     .     SINT975hzm,SINT100hzm,SINT105hzm,SINT110hzm,XKL,XMIN,XMAX
      REAL*8   hz75_1_msum,hz80_1_msum,hz85_1_msum,
     .         hz90_1_msum,hz95_1_msum,hz975_1_msum,
     .         hz100_1_msum,hz105_1_msum,hz110_1_msum
      EXTERNAL hz75_1_msum,hz80_1_msum,hz85_1_msum,
     .         hz90_1_msum,hz95_1_msum,hz975_1_msum,
     .         hz100_1_msum,hz105_1_msum,hz110_1_msum
      LOGICAL FIRST
      DATA FIRST /.TRUE./
c
c Kinematic Limit
c
      PARAMETER(XKL=188.6D0,XMIN=40D0,XMAX=188.6D0)
C
      DOUBLE PRECISION RMH
      COMMON /MASS/ RMH
C
      IF (FIRST) THEN
         FIRST = .FALSE.
c         WRITE (6,'(a,2f6.2)') 
c     +      ' Integrating the input SIGNAL functions between:',xmin,xmax
         CALL pjremt1(hz75_1_msum,10,xmin,xmax,sint75hzm) 
         CALL pjremt1(hz80_1_msum,10,xmin,xmax,sint80hzm) 
         CALL pjremt1(hz85_1_msum,10,xmin,xmax,sint85hzm) 
         CALL pjremt1(hz90_1_msum,10,xmin,xmax,sint90hzm) 
         CALL pjremt1(hz95_1_msum,10,xmin,xmax,sint95hzm) 
         CALL pjremt1(hz975_1_msum,10,xmin,xmax,sint975hzm) 
         CALL pjremt1(hz100_1_msum,10,xmin,xmax,sint100hzm) 
         CALL pjremt1(hz105_1_msum,10,xmin,xmax,sint105hzm) 
         CALL pjremt1(hz110_1_msum,10,xmin,xmax,sint110hzm) 
C        write (6,*) '================================================'
C        WRITE (6,*) 'The integrals of the signal functions are:'
C        WRITE (6,'((a7,f8.2,a7,f8.2,a7,f8.2))') 
c     &    '  75-->',SINT75hzm,'| 80-->',SINT80hzm,
c     &    '| 85-->',SINT85hzm,
c     &    '  90-->',SINT90hzm,'| 95-->',SINT95hzm,
c     &    '|975-->',SINT975hzm,
c     &    ' 100-->',SINT100hzm,'|105-->',SINT105hzm,
c     &    '|110-->',SINT110hzm 
C        write (6,*) '================================================'
C        write (6,*) 'The kinematic boundary is set at ',sngl(XKL)
      END IF
C
      IF (RMH.GE.75D0 .AND. RMH.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz75_1_msum(X-DELTA1) / SINT75hzm
         F2 = hz80_1_msum(X+DELTA2) / SINT80hzm
      ELSE IF (RMH.GT.80D0 .AND. RMH.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz80_1_msum(X-DELTA1) / SINT80hzm
         F2 = hz85_1_msum(X+DELTA2) / SINT85hzm
      ELSE IF (RMH.GT.85D0 .AND. RMH.LE.90D0) THEN
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz85_1_msum(X-DELTA1) / SINT85hzm
         F2 = hz90_1_msum(X+DELTA2) / SINT90hzm
      ELSE IF (RMH.GT.90D0 .AND. RMH.LE.95D0) THEN
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz90_1_msum(X-DELTA1) / SINT90hzm
         F2 = hz95_1_msum(X+DELTA2) / SINT95hzm
      ELSE IF (RMH.GT.95D0 .AND. RMH.LE.97.5D0) THEN
c
c     Special treatment: only shift the 95 GeV shape upwards, while keeping 
C     the 97.5 GeV shape fixed; [i.e., same weights as before, but fix 97.5 shape]
c
         REFMH1 = 95D0
         REFMH2 = 97.5D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz95_1_msum(X-DELTA1) / SINT95hzm
         F2 = hz975_1_msum(X) / SINT975hzm
      ELSE IF (RMH.GT.97.5D0 .AND. RMH.LE.100D0) THEN
         REFMH1 = 97.5D0
         REFMH2 = 100D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz975_1_msum(X) / SINT975hzm
         F2 = hz100_1_msum(X) / SINT100hzm
      ELSE IF (RMH.GT.100D0 .AND. RMH.LE.105D0) THEN
         REFMH1 = 100D0
         REFMH2 = 105D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz100_1_msum(X) / SINT100hzm
         F2 = hz105_1_msum(X) / SINT105hzm
      ELSE IF (RMH.GT.105D0 .AND. RMH.LE.110D0) THEN
         REFMH1 = 105D0
         REFMH2 = 110D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz105_1_msum(X) / SINT105hzm
         F2 = hz110_1_msum(X) / SINT110hzm
      ELSE
         A189_4jet_1_hz_msum = 0D0
         RETURN
      END IF
C
      A189_4jet_1_hz_msum =
     &         (DELTA2 * F1 + DELTA1 * F2) / (REFMH2 - REFMH1)
      IF (A189_4jet_1_hz_msum.LT.1.D-5) A189_4jet_1_hz_msum = 1.D-5
c
c NB all the INPUT functions vanish at the kinematic 
c limit x = 188.6 - 91.2 = 97.4; The interpolated functions may (because of 
c the TRANSLATION involved) have a tiny tail of non-zero values beyond the KL.
c This is not physical and is corrected here:
c
      if (x.gt.xkl) A189_4jet_1_hz_msum = 1.D-5
C
      RETURN
      END


C------------------------ Instructions for the user -------------------------
C
C This function is used to interpolate between the signal mass shapes obtained 
C at different mH values, when computing sensitivity curves 
C at 188.6 GeV, CL(mH). The user has to provide the signal shapes at 
C
C     mH=75, 80, 85, 90, 95, 97.5, 100, 105 and 110 GeV
C     
C as DOUBLE PRECISION FORTRAN FUNCTIONS named ha75_1_mh, ..., SMH975,..., SMH110,
C respectively.
C
C The mass at which the user wishes to obtain the interpolated shape is
C passed using the variable RMH in common MASS.
C
C-----------------------------------------------------------------------------
C
C     Author: Pedro Teixeira-Dias.
C     Mods:
C     - The input shapes (provided by the user) are now automatically
C     normalized, upon the first call to this function;
C     - For interpolation in the range 95 <= mH <= 97.5 (threshold), do not 
C     move the 97.5 shape downwards (keep it fixed) as this effectively shifts
C     the very sharp threshold cut-off downwards.           PTD, 13-Nov-1998.
C     - Adapt to 188.6 GeV situation: KL=97.4 GeV and the 97 Gev sample 
C     becomes the 97.5 GeV sample.                          PTD, 04-Feb-1999.
C     - Use the old REMT1 subroutine (not the one in the new library)
C     it is here renamed PJREMT1;                           PTD, 09-Feb-1999.
C
      DOUBLE PRECISION FUNCTION A189_4jet_1_ha_mh(X)
C
      DOUBLE PRECISION X,DELTA1,DELTA2,REFMH1,REFMH2,F1,F2,
     .     SINT65hamh,SINT70hamh,SINT75hamh,SINT80hamh,SINT85hamh,
     .     SINT90hamh,SINT95hamh,XKL,XMIN,XMAX
      REAL*8   ha65_1_mh,ha70_1_mh,ha75_1_mh,
     .         ha80_1_mh,ha85_1_mh,ha90_1_mh,ha95_1_mh
      EXTERNAL ha65_1_mh,ha70_1_mh,ha75_1_mh,
     .         ha80_1_mh,ha85_1_mh,ha90_1_mh,ha95_1_mh
      LOGICAL FIRST
      DATA FIRST /.TRUE./
c
c Kinematic Limit
c
      PARAMETER(XKL=97.4D0,XMIN=40D0,XMAX=97.4D0)
C
      DOUBLE PRECISION RMH
      COMMON /MASS/ RMH
C
      IF (FIRST) THEN
         FIRST = .FALSE.
C        WRITE (6,'(a,2f6.2)') 
c     +      ' Integrating the input SIGNAL functions between:',xmin,xmax
         CALL pjremt1(ha65_1_mh,10,xmin,xmax,sint65hamh) 
         CALL pjremt1(ha70_1_mh,10,xmin,xmax,sint70hamh) 
         CALL pjremt1(ha75_1_mh,10,xmin,xmax,sint75hamh) 
         CALL pjremt1(ha80_1_mh,10,xmin,xmax,sint80hamh) 
         CALL pjremt1(ha85_1_mh,10,xmin,xmax,sint85hamh) 
         CALL pjremt1(ha90_1_mh,10,xmin,xmax,sint90hamh) 
         CALL pjremt1(ha95_1_mh,10,xmin,xmax,sint95hamh) 
C        write (6,*) '================================================'
C        WRITE (6,*) 'The integrals of the signal functions are:'
C        WRITE (6,'((a7,f8.2,a7,f8.2,a7,f8.2))') 
c     &        '  65-->',SINT65hamh,'| 70-->',SINT70hamh,
c     &        '| 75-->',SINT75hamh,
c     &        '  80-->',SINT80hamh,'| 85-->',SINT85hamh,
c     &        '| 90-->',SINT90hamh
C        WRITE (6,'((a7,f8.2))')
c     &        '  95-->',SINT95hamh
C        write (6,*) '================================================'
C        write (6,*) 'The kinematic boundary is set at ',sngl(XKL)
      END IF
C
      IF (RMH.GE.65D0 .AND. RMH.LE.70D0) THEN
         REFMH1 = 65D0
         REFMH2 = 70D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = ha65_1_mh(X-2*DELTA1) / SINT65hamh
         F2 = ha70_1_mh(X+2*DELTA2) / SINT70hamh
      ELSE IF (RMH.GT.70D0 .AND. RMH.LE.75D0) THEN
         REFMH1 = 70D0
         REFMH2 = 75D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = ha70_1_mh(X-2*DELTA1) / SINT70hamh
         F2 = ha75_1_mh(X+2*DELTA2) / SINT75hamh
      ELSE IF (RMH.GT.75D0 .AND. RMH.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = ha75_1_mh(X-2*DELTA1) / SINT75hamh
         F2 = ha80_1_mh(X+2*DELTA2) / SINT80hamh
      ELSE IF (RMH.GT.80D0 .AND. RMH.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = ha80_1_mh(X-2*DELTA1) / SINT80hamh
         F2 = ha85_1_mh(X+2*DELTA2) / SINT85hamh
      ELSE IF (RMH.GT.85D0 .AND. RMH.LE.90D0) THEN
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = ha85_1_mh(X-2*DELTA1) / SINT85hamh
         F2 = ha90_1_mh(X+2*DELTA2) / SINT90hamh
      ELSE IF (RMH.GT.90D0 .AND. RMH.LE.95D0) THEN
c
c     Special treatment: only shift the 90 GeV shape upwards, while keeping 
C     the 95 GeV shape fixed; [i.e., same weights as before, but fix 95 shape]
c
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = ha90_1_mh(X-2*DELTA1) / SINT90hamh
         F2 = ha95_1_mh(X) / SINT95hamh
      ELSE
         A189_4jet_1_ha_mh = 0D0
         RETURN
      END IF
C
      A189_4jet_1_ha_mh =
     &         (DELTA2 * F1 + DELTA1 * F2) / (REFMH2 - REFMH1)
      IF (A189_4jet_1_ha_mh.LT.1.D-5) A189_4jet_1_ha_mh = 1.D-5
c
c NB all the INPUT functions vanish at the kinematic 
c limit x = 188.6 - 91.2 = 97.4; The interpolated functions may (because of 
c the TRANSLATION involved) have a tiny tail of non-zero values beyond the KL.
c This is not physical and is corrected here:
c
      if (x.gt.xkl) A189_4jet_1_ha_mh = 1.D-5
C
      RETURN
      END


C------------------------ Instructions for the user -------------------------
C
C This function is used to interpolate between the signal mass shapes obtained 
C at different mH values, when computing sensitivity curves 
C at 188.6 GeV, CL(mH). The user has to provide the signal shapes at 
C
C     mH=75, 80, 85, 90, 95, 97.5, 100, 105 and 110 GeV
C     
C as DOUBLE PRECISION FORTRAN FUNCTIONS named ha75_1_fvar, ..., SMH975,..., SMH110,
C respectively.
C
C The mass at which the user wishes to obtain the interpolated shape is
C passed using the variable RMH in common MASS.
C
C-----------------------------------------------------------------------------
C
C     Author: Pedro Teixeira-Dias.
C     Mods:
C     - The input shapes (provided by the user) are now automatically
C     normalized, upon the first call to this function;
C     - For interpolation in the range 95 <= mH <= 97.5 (threshold), do not 
C     move the 97.5 shape downwards (keep it fixed) as this effectively shifts
C     the very sharp threshold cut-off downwards.           PTD, 13-Nov-1998.
C     - Adapt to 188.6 GeV situation: KL=97.4 GeV and the 97 Gev sample 
C     becomes the 97.5 GeV sample.                          PTD, 04-Feb-1999.
C     - Use the old REMT1 subroutine (not the one in the new library)
C     it is here renamed PJREMT1;                           PTD, 09-Feb-1999.
C
      DOUBLE PRECISION FUNCTION A189_4jet_1_ha_nn(X)
C
      DOUBLE PRECISION X,DELTA1,DELTA2,REFMH1,REFMH2,F1,F2,
     .     SINT65han,SINT70han,SINT75han,SINT80han,SINT85han,
     .     SINT90han,SINT95han,XKL,XMIN,XMAX
      REAL*8   ha65_1_nn,ha70_1_nn,ha75_1_nn,
     .         ha80_1_nn,ha85_1_nn,ha90_1_nn,ha95_1_nn
      EXTERNAL ha65_1_nn,ha70_1_nn,ha75_1_nn,
     .         ha80_1_nn,ha85_1_nn,ha90_1_nn,ha95_1_nn
      LOGICAL FIRST
      DATA FIRST /.TRUE./
c
c Kinematic Limit
c
      PARAMETER(XKL=300D0,XMIN=0.951D0,XMAX=1.00D0)
C
      DOUBLE PRECISION RMH
      COMMON /MASS/ RMH
C
      IF (FIRST) THEN
         FIRST = .FALSE.
C        WRITE (6,'(a,2f6.2)') 
c     +      ' Integrating the input SIGNAL functions between:',xmin,xmax
         CALL pjremt1(ha65_1_nn,10,xmin,xmax,sint65han) 
         CALL pjremt1(ha70_1_nn,10,xmin,xmax,sint70han) 
         CALL pjremt1(ha75_1_nn,10,xmin,xmax,sint75han) 
         CALL pjremt1(ha80_1_nn,10,xmin,xmax,sint80han) 
         CALL pjremt1(ha85_1_nn,10,xmin,xmax,sint85han) 
         CALL pjremt1(ha90_1_nn,10,xmin,xmax,sint90han) 
         CALL pjremt1(ha95_1_nn,10,xmin,xmax,sint95han) 
C        write (6,*) '================================================'
C        WRITE (6,*) 'The integrals of the signal functions are:'
C        WRITE (6,'((a7,f8.2,a7,f8.2,a7,f8.2))') 
c     &        '  65-->',SINT65han,'| 70-->',SINT70han,
c     &        '| 75-->',SINT75han,
c     &        '  80-->',SINT80han,'| 85-->',SINT85han,
c     &        '| 90-->',SINT90han
C        WRITE (6,'((a7,f8.2))')
c     &        '  95-->',SINT95han
C        write (6,*) '================================================'
C        write (6,*) 'The kinematic boundary is set at ',sngl(XKL)
      END IF
C
      IF (RMH.GE.65D0 .AND. RMH.LE.70D0) THEN
         REFMH1 = 65D0
         REFMH2 = 70D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = ha65_1_nn(X) / SINT65han
         F2 = ha70_1_nn(X) / SINT70han
      ELSE IF (RMH.GT.70D0 .AND. RMH.LE.75D0) THEN
         REFMH1 = 70D0
         REFMH2 = 75D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = ha70_1_nn(X) / SINT70han
         F2 = ha75_1_nn(X) / SINT75han
      ELSE IF (RMH.GT.75D0 .AND. RMH.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = ha75_1_nn(X) / SINT75han
         F2 = ha80_1_nn(X) / SINT80han
      ELSE IF (RMH.GT.80D0 .AND. RMH.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = ha80_1_nn(X) / SINT80han
         F2 = ha85_1_nn(X) / SINT85han
      ELSE IF (RMH.GT.85D0 .AND. RMH.LE.90D0) THEN
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = ha85_1_nn(X) / SINT85han
         F2 = ha90_1_nn(X) / SINT90han
      ELSE IF (RMH.GT.90D0 .AND. RMH.LE.95D0) THEN
c
c     Special treatment: only shift the 90 GeV shape upwards, while keeping 
C     the 95 GeV shape fixed; [i.e., same weights as before, but fix 95 shape]
c
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = ha90_1_nn(X) / SINT90han
         F2 = ha95_1_nn(X) / SINT95han
      ELSE
         A189_4jet_1_ha_nn = 0D0
         RETURN
      END IF
C
      A189_4jet_1_ha_nn = 
     &       (DELTA2 * F1 + DELTA1 * F2) / (REFMH2 - REFMH1)
      IF (A189_4jet_1_ha_nn.LT.1.D-5) A189_4jet_1_ha_nn = 1.D-5
c
c NB all the INPUT functions vanish at the kinematic 
c limit x = 188.6 - 91.2 = 97.4; The interpolated functions may (because of 
c the TRANSLATION involved) have a tiny tail of non-zero values beyond the KL.
c This is not physical and is corrected here:
c
c      if (x.gt.xkl) A189_4jet = 1.D-5
C
      RETURN
      END


C------------------------ Instructions for the user -------------------------
C
C This function is used to interpolate between the signal mass shzpes obtained 
C at different mH values, when computing sensitivity curves 
C at 188.6 GeV, CL(mH). The user hzs to provide the signal shzpes at 
C
C     mH=75, 80, 85, 90, 95, 97.5, 100, 105 and 110 GeV
C     
C as DOUBLE PRECISION FORTRAN FUNCTIONS named hz75_1_mh, ..., SMH975,..., SMH110,
C respectively.
C
C The mass at which the user wishes to obtain the interpolated shzpe is
C passed using the variable RMH in common MASS.
C
C-----------------------------------------------------------------------------
C
C     Author: Pedro Teixeira-Dias.
C     Mods:
C     - The input shzpes (provided by the user) are now automatically
C     normalized, upon the first call to this function;
C     - For interpolation in the range 95 <= mH <= 97.5 (threshold), do not 
C     move the 97.5 shzpe downwards (keep it fixed) as this effectively shifts
C     the very sharp threshold cut-off downwards.           PTD, 13-Nov-1998.
C     - Adapt to 188.6 GeV situation: KL=97.4 GeV and the 97 Gev sample 
C     becomes the 97.5 GeV sample.                          PTD, 04-Feb-1999.
C     - Use the old REMT1 subroutine (not the one in the new library)
C     it is here renamed PJREMT1;                           PTD, 09-Feb-1999.
C
      DOUBLE PRECISION FUNCTION A189_4jet_1_hz_mh(X)
C
      DOUBLE PRECISION X,DELTA1,DELTA2,REFMH1,REFMH2,F1,F2,
     .     SINT75hzmh,SINT80hzmh,SINT85hzmh,SINT90hzmh,SINT95hzmh,
     .     SINT975hzmh,SINT100hzmh,SINT105hzmh,SINT110hzmh,XKL,XMIN,XMAX
      REAL*8   hz75_1_mh,hz80_1_mh,hz85_1_mh,
     .         hz90_1_mh,hz95_1_mh,hz975_1_mh,
     .         hz100_1_mh,hz105_1_mh,hz110_1_mh
      EXTERNAL hz75_1_mh,hz80_1_mh,hz85_1_mh,
     .         hz90_1_mh,hz95_1_mh,hz975_1_mh,
     .         hz100_1_mh,hz105_1_mh,hz110_1_mh
      LOGICAL FIRST
      DATA FIRST /.TRUE./
c
c Kinematic Limit
c
      PARAMETER(XKL=97.4D0,XMIN=40D0,XMAX=97.4D0)
C
      DOUBLE PRECISION RMH
      COMMON /MASS/ RMH
C
      IF (FIRST) THEN
         FIRST = .FALSE.
C        WRITE (6,'(a,2f6.2)') 
c     +      ' Integrating the input SIGNAL functions between:',xmin,xmax
         CALL pjremt1(hz75_1_mh,10,xmin,xmax,sint75hzmh) 
         CALL pjremt1(hz80_1_mh,10,xmin,xmax,sint80hzmh) 
         CALL pjremt1(hz85_1_mh,10,xmin,xmax,sint85hzmh) 
         CALL pjremt1(hz90_1_mh,10,xmin,xmax,sint90hzmh) 
         CALL pjremt1(hz95_1_mh,10,xmin,xmax,sint95hzmh) 
         CALL pjremt1(hz975_1_mh,10,xmin,xmax,sint975hzmh) 
         CALL pjremt1(hz100_1_mh,10,xmin,xmax,sint100hzmh) 
         CALL pjremt1(hz105_1_mh,10,xmin,xmax,sint105hzmh) 
         CALL pjremt1(hz110_1_mh,10,xmin,xmax,sint110hzmh) 
C        write (6,*) '================================================'
C        WRITE (6,*) 'The integrals of the signal functions are:'
C        WRITE (6,'((a7,f8.2,a7,f8.2,a7,f8.2))') 
c     &    '  75-->',SINT75hzmh,'| 80-->',SINT80hzmh,
c     &    '| 85-->',SINT85hzmh,
c     &    '  90-->',SINT90hzmh,'| 95-->',SINT95hzmh,
c     &    '|975-->',SINT975hzmh,
c     &    ' 100-->',SINT100hzmh,'|105-->',SINT105hzmh,
c     &    '|110-->',SINT110hzmh 
C        write (6,*) '================================================'
C        write (6,*) 'The kinematic boundary is set at ',sngl(XKL)
      END IF
C
      IF (RMH.GE.75D0 .AND. RMH.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz75_1_mh(X-DELTA1) / SINT75hzmh
         F2 = hz80_1_mh(X+DELTA2) / SINT80hzmh
      ELSE IF (RMH.GT.80D0 .AND. RMH.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz80_1_mh(X-DELTA1) / SINT80hzmh
         F2 = hz85_1_mh(X+DELTA2) / SINT85hzmh
      ELSE IF (RMH.GT.85D0 .AND. RMH.LE.90D0) THEN
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz85_1_mh(X-DELTA1) / SINT85hzmh
         F2 = hz90_1_mh(X+DELTA2) / SINT90hzmh
      ELSE IF (RMH.GT.90D0 .AND. RMH.LE.95D0) THEN
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz90_1_mh(X-DELTA1) / SINT90hzmh
         F2 = hz95_1_mh(X+DELTA2) / SINT95hzmh
      ELSE IF (RMH.GT.95D0 .AND. RMH.LE.97.5D0) THEN
c
c     Special treatment: only shift the 95 GeV shape upwards, while keeping 
C     the 97.5 GeV shape fixed; [i.e., same weights as before, but fix 97.5 shape]
c
         REFMH1 = 95D0
         REFMH2 = 97.5D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz95_1_mh(X-DELTA1) / SINT95hzmh
         F2 = hz975_1_mh(X) / SINT975hzmh
      ELSE IF (RMH.GT.97.5D0 .AND. RMH.LE.100D0) THEN
         REFMH1 = 97.5D0
         REFMH2 = 100D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz975_1_mh(X) / SINT975hzmh
         F2 = hz100_1_mh(X) / SINT100hzmh
      ELSE IF (RMH.GT.100D0 .AND. RMH.LE.105D0) THEN
         REFMH1 = 100D0
         REFMH2 = 105D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz100_1_mh(X) / SINT100hzmh
         F2 = hz105_1_mh(X) / SINT105hzmh
      ELSE IF (RMH.GT.105D0 .AND. RMH.LE.110D0) THEN
         REFMH1 = 105D0
         REFMH2 = 110D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz105_1_mh(X) / SINT105hzmh
         F2 = hz110_1_mh(X) / SINT110hzmh
      ELSE
         A189_4jet_1_hz_mh = 0D0
         RETURN
      END IF
C
      A189_4jet_1_hz_mh =
     &         (DELTA2 * F1 + DELTA1 * F2) / (REFMH2 - REFMH1)
      IF (A189_4jet_1_hz_mh.LT.1.D-5) A189_4jet_1_hz_mh = 1.D-5
c
c NB all the INPUT functions vanish at the kinematic 
c limit x = 188.6 - 91.2 = 97.4; The interpolated functions may (because of 
c the TRANSLATION involved) have a tiny tail of non-zero values beyond the KL.
c This is not physical and is corrected here:
c
      if (x.gt.xkl) A189_4jet_1_hz_mh = 1.D-5
C
      RETURN
      END


C------------------------ Instructions for the user -------------------------
C
C This function is used to interpolate between the signal mass shzpes obtained 
C at different mH values, when computing sensitivity curves 
C at 188.6 GeV, CL(mH). The user hzs to provide the signal shzpes at 
C
C     mH=75, 80, 85, 90, 95, 97.5, 100, 105 and 110 GeV
C     
C as DOUBLE PRECISION FORTRAN FUNCTIONS named hz75_1_nn, ..., SMH975,..., SMH110,
C respectively.
C
C The mass at which the user wishes to obtain the interpolated shzpe is
C passed using the variable RMH in common MASS.
C
C-----------------------------------------------------------------------------
C
C     Author: Pedro Teixeira-Dias.
C     Mods:
C     - The input shzpes (provided by the user) are now automatically
C     normalized, upon the first call to this function;
C     - For interpolation in the range 95 <= mH <= 97.5 (threshold), do not 
C     move the 97.5 shzpe downwards (keep it fixed) as this effectively shifts
C     the very sharp threshold cut-off downwards.           PTD, 13-Nov-1998.
C     - Adapt to 188.6 GeV situation: KL=97.4 GeV and the 97 Gev sample 
C     becomes the 97.5 GeV sample.                          PTD, 04-Feb-1999.
C     - Use the old REMT1 subroutine (not the one in the new library)
C     it is here renamed PJREMT1;                           PTD, 09-Feb-1999.
C
      DOUBLE PRECISION FUNCTION A189_4jet_1_hz_nn(X)
C
      DOUBLE PRECISION X,DELTA1,DELTA2,REFMH1,REFMH2,F1,F2,
     .     SINT75hzn,SINT80hzn,SINT85hzn,SINT90hzn,SINT95hzn,
     .     SINT975hzn,SINT100hzn,SINT105hzn,SINT110hzn,XKL,XMIN,XMAX
      REAL*8   hz75_1_nn,hz80_1_nn,hz85_1_nn,
     .         hz90_1_nn,hz95_1_nn,hz975_1_nn,
     .         hz100_1_nn,hz105_1_nn,hz110_1_nn
      EXTERNAL hz75_1_nn,hz80_1_nn,hz85_1_nn,
     .         hz90_1_nn,hz95_1_nn,hz975_1_nn,
     .         hz100_1_nn,hz105_1_nn,hz110_1_nn
      LOGICAL FIRST
      DATA FIRST /.TRUE./
c
c Kinematic Limit
c
      PARAMETER(XKL=300D0,XMIN=0.951D0,XMAX=1.00D0)
C
      DOUBLE PRECISION RMH
      COMMON /MASS/ RMH
C
      IF (FIRST) THEN
         FIRST = .FALSE.
C        WRITE (6,'(a,2f6.2)') 
c    +      ' Integrating the input SIGNAL functions between:',xmin,xmax
         CALL pjremt1(hz75_1_nn,10,xmin,xmax,sint75hzn) 
         CALL pjremt1(hz80_1_nn,10,xmin,xmax,sint80hzn) 
         CALL pjremt1(hz85_1_nn,10,xmin,xmax,sint85hzn) 
         CALL pjremt1(hz90_1_nn,10,xmin,xmax,sint90hzn) 
         CALL pjremt1(hz95_1_nn,10,xmin,xmax,sint95hzn) 
         CALL pjremt1(hz975_1_nn,10,xmin,xmax,sint975hzn) 
         CALL pjremt1(hz100_1_nn,10,xmin,xmax,sint100hzn) 
         CALL pjremt1(hz105_1_nn,10,xmin,xmax,sint105hzn) 
         CALL pjremt1(hz110_1_nn,10,xmin,xmax,sint110hzn) 
C        write (6,*) '================================================'
C        WRITE (6,*) 'The integrals of the signal functions are:'
C        WRITE (6,'((a7,f8.2,a7,f8.2,a7,f8.2))') 
c     &    '  75-->',SINT75hzn,'| 80-->',SINT80hzn,
c     &    '| 85-->',SINT85hzn,
c     &    '  90-->',SINT90hzn,'| 95-->',SINT95hzn,
c     &    '|975-->',SINT975hzn,
c     &    ' 100-->',SINT100hzn,'|105-->',SINT105hzn,
c     &    '|110-->',SINT110hzn 
C        write (6,*) '================================================'
C        write (6,*) 'The kinematic boundary is set at ',sngl(XKL)
      END IF
C
      IF (RMH.GE.75D0 .AND. RMH.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz75_1_nn(X) / SINT75hzn
         F2 = hz80_1_nn(X) / SINT80hzn
      ELSE IF (RMH.GT.80D0 .AND. RMH.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz80_1_nn(X) / SINT80hzn
         F2 = hz85_1_nn(X) / SINT85hzn
      ELSE IF (RMH.GT.85D0 .AND. RMH.LE.90D0) THEN
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz85_1_nn(X) / SINT85hzn
         F2 = hz90_1_nn(X) / SINT90hzn
      ELSE IF (RMH.GT.90D0 .AND. RMH.LE.95D0) THEN
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz90_1_nn(X) / SINT90hzn
         F2 = hz95_1_nn(X) / SINT95hzn
      ELSE IF (RMH.GT.95D0 .AND. RMH.LE.97.5D0) THEN
c
c     Special treatment: only shift the 95 GeV shape upwards, while keeping 
C     the 97.5 GeV shape fixed; [i.e., same weights as before, but fix 97.5 shape]
c
         REFMH1 = 95D0
         REFMH2 = 97.5D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz95_1_nn(X) / SINT95hzn
         F2 = hz975_1_nn(X) / SINT975hzn
      ELSE IF (RMH.GT.97.5D0 .AND. RMH.LE.100D0) THEN
         REFMH1 = 97.5D0
         REFMH2 = 100D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz975_1_nn(X) / SINT975hzn
         F2 = hz100_1_nn(X) / SINT100hzn
      ELSE IF (RMH.GT.100D0 .AND. RMH.LE.105D0) THEN
         REFMH1 = 100D0
         REFMH2 = 105D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz100_1_nn(X) / SINT100hzn
         F2 = hz105_1_nn(X) / SINT105hzn
      ELSE IF (RMH.GT.105D0 .AND. RMH.LE.110D0) THEN
         REFMH1 = 105D0
         REFMH2 = 110D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz105_1_nn(X) / SINT105hzn
         F2 = hz110_1_nn(X) / SINT110hzn
      ELSE
         A189_4jet_1_HZ_NN = 0D0
         RETURN
      END IF
C
      A189_4jet_1_HZ_NN =
     &        (DELTA2 * F1 + DELTA1 * F2) / (REFMH2 - REFMH1)
      IF (A189_4jet_1_HZ_NN.LT.1.D-5) A189_4jet_1_HZ_NN = 1.D-5
c
c NB all the INPUT functions vanish at the kinematic 
c limit x = 188.6 - 91.2 = 97.4; The interpolated functions may (because of 
c the TRANSLATION involved) have a tiny tail of non-zero values beyond the KL.
c This is not physical and is corrected here:
c
c      if (x.gt.xkl) A189_4jet_1_hz_nn = 1.D-5
C
      RETURN
      END


C------------------------ Instructions for the user -------------------------
C
C This function is used to interpolate between the signal mass shapes obtained 
C at different mH values, when computing sensitivity curves 
C at 188.6 GeV, CL(mH). The user has to provide the signal shapes at 
C
C     mH=75, 80, 85, 90, 95, 97.5, 100, 105 and 110 GeV
C     
C as DOUBLE PRECISION FORTRAN FUNCTIONS named ha75_2_msum, ..., SMH975,..., SMH110,
C respectively.
C
C The mass at which the user wishes to obtain the interpolated shape is
C passed using the variable RMH in common MASS.
C
C-----------------------------------------------------------------------------
C
C     Author: Pedro Teixeira-Dias.
C     Mods:
C     - The input shapes (provided by the user) are now automatically
C     normalized, upon the first call to this function;
C     - For interpolation in the range 95 <= mH <= 97.5 (threshold), do not 
C     move the 97.5 shape downwards (keep it fixed) as this effectively shifts
C     the very sharp threshold cut-off downwards.           PTD, 13-Nov-1998.
C     - Adapt to 188.6 GeV situation: KL=97.4 GeV and the 97 Gev sample 
C     becomes the 97.5 GeV sample.                          PTD, 04-Feb-1999.
C     - Use the old REMT1 subroutine (not the one in the new library)
C     it is here renamed PJREMT1;                           PTD, 09-Feb-1999.
C
      DOUBLE PRECISION FUNCTION A189_4jet_2_ha_msum(X)
C
      DOUBLE PRECISION X,DELTA1,DELTA2,REFMH1,REFMH2,F1,F2,
     .     SINT65ham,SINT70ham,SINT75ham,SINT80ham,SINT85ham,
     .     SINT90ham,SINT95ham,XKL,XMIN,XMAX
      REAL*8   ha65_2_msum,ha70_2_msum,ha75_2_msum,
     .         ha80_2_msum,ha85_2_msum,ha90_2_msum,ha95_2_msum
      EXTERNAL ha65_2_msum,ha70_2_msum,ha75_2_msum,
     .         ha80_2_msum,ha85_2_msum,ha90_2_msum,ha95_2_msum
      LOGICAL FIRST
      DATA FIRST /.TRUE./
c
c Kinematic Limit
c
      PARAMETER(XKL=188.6D0,XMIN=40D0,XMAX=188.6D0)
C
      DOUBLE PRECISION RMH
      COMMON /MASS/ RMH
C
      IF (FIRST) THEN
         FIRST = .FALSE.
C        WRITE (6,'(a,2f6.2)') 
c    +      ' Integrating the input SIGNAL functions between:',xmin,xmax
         CALL pjremt1(ha65_2_msum,10,xmin,xmax,sint65ham) 
         CALL pjremt1(ha70_2_msum,10,xmin,xmax,sint70ham) 
         CALL pjremt1(ha75_2_msum,10,xmin,xmax,sint75ham) 
         CALL pjremt1(ha80_2_msum,10,xmin,xmax,sint80ham) 
         CALL pjremt1(ha85_2_msum,10,xmin,xmax,sint85ham) 
         CALL pjremt1(ha90_2_msum,10,xmin,xmax,sint90ham) 
         CALL pjremt1(ha95_2_msum,10,xmin,xmax,sint95ham) 
C        write (6,*) '================================================'
C        WRITE (6,*) 'The integrals of the signal functions are:'
C        WRITE (6,'((a7,f8.2,a7,f8.2,a7,f8.2))') 
C    &        '  65-->',SINT65ham,'| 70-->',SINT70ham,
C    &        '| 75-->',SINT75ham,
C    &        '  80-->',SINT80ham,'| 85-->',SINT85ham,
C    &        '| 90-->',SINT90ham
C        WRITE (6,'((a7,f8.2))')
C    &        '  95-->',SINT95ham
C        write (6,*) '================================================'
C        write (6,*) 'The kinematic boundary is set at ',sngl(XKL)
      END IF
C
      IF (RMH.GE.65D0 .AND. RMH.LE.70D0) THEN
         REFMH1 = 65D0
         REFMH2 = 70D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = ha65_2_msum(X-2*DELTA1) / SINT65ham
         F2 = ha70_2_msum(X+2*DELTA2) / SINT70ham
      ELSE IF (RMH.GT.70D0 .AND. RMH.LE.75D0) THEN
         REFMH1 = 70D0
         REFMH2 = 75D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = ha70_2_msum(X-2*DELTA1) / SINT70ham
         F2 = ha75_2_msum(X+2*DELTA2) / SINT75ham
      ELSE IF (RMH.GT.75D0 .AND. RMH.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = ha75_2_msum(X-2*DELTA1) / SINT75ham
         F2 = ha80_2_msum(X+2*DELTA2) / SINT80ham
      ELSE IF (RMH.GT.80D0 .AND. RMH.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = ha80_2_msum(X-2*DELTA1) / SINT80ham
         F2 = ha85_2_msum(X+2*DELTA2) / SINT85ham
      ELSE IF (RMH.GT.85D0 .AND. RMH.LE.90D0) THEN
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = ha85_2_msum(X-2*DELTA1) / SINT85ham
         F2 = ha90_2_msum(X+2*DELTA2) / SINT90ham
      ELSE IF (RMH.GT.90D0 .AND. RMH.LE.95D0) THEN
c
c     Special treatment: only shift the 90 GeV shape upwards, while keeping 
C     the 95 GeV shape fixed; [i.e., same weights as before, but fix 95 shape]
c
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = ha90_2_msum(X-2*DELTA1) / SINT90ham
         F2 = ha95_2_msum(X) / SINT95ham
      ELSE
         A189_4jet_2_ha_msum = 0D0
         RETURN
      END IF
C
      A189_4jet_2_ha_msum =
     &         (DELTA2 * F1 + DELTA1 * F2) / (REFMH2 - REFMH1)
      IF (A189_4jet_2_ha_msum.LT.1.D-5) A189_4jet_2_ha_msum = 1.D-5
c
c NB all the INPUT functions vanish at the kinematic 
c limit x = 188.6 - 91.2 = 97.4; The interpolated functions may (because of 
c the TRANSLATION involved) have a tiny tail of non-zero values beyond the KL.
c This is not physical and is corrected here:
c
      if (x.gt.xkl) A189_4jet_2_ha_msum = 1.D-5
C
      RETURN
      END


C------------------------ Instructions for the user -------------------------
C
C This function is used to interpolate between the signal mass shapes obtained 
C at different mH values, when computing sensitivity curves 
C at 188.6 GeV, CL(mH). The user has to provide the signal shapes at 
C
C     mH=75, 80, 85, 90, 95, 97.5, 100, 105 and 110 GeV
C     
C as DOUBLE PRECISION FORTRAN FUNCTIONS named ha75_2_fvar, ..., SMH975,..., SMH110,
C respectively.
C
C The mass at which the user wishes to obtain the interpolated shape is
C passed using the variable RMH in common MASS.
C
C-----------------------------------------------------------------------------
C
C     Author: Pedro Teixeira-Dias.
C     Mods:
C     - The input shapes (provided by the user) are now automatically
C     normalized, upon the first call to this function;
C     - For interpolation in the range 95 <= mH <= 97.5 (threshold), do not 
C     move the 97.5 shape downwards (keep it fixed) as this effectively shifts
C     the very sharp threshold cut-off downwards.           PTD, 13-Nov-1998.
C     - Adapt to 188.6 GeV situation: KL=97.4 GeV and the 97 Gev sample 
C     becomes the 97.5 GeV sample.                          PTD, 04-Feb-1999.
C     - Use the old REMT1 subroutine (not the one in the new library)
C     it is here renamed PJREMT1;                           PTD, 09-Feb-1999.
C
      DOUBLE PRECISION FUNCTION A189_4jet_2_ha_fvar(X)
C
      DOUBLE PRECISION X,DELTA1,DELTA2,REFMH1,REFMH2,F1,F2,
     .     SINT65haf,SINT70haf,SINT75haf,SINT80haf,SINT85haf,
     .     SINT90haf,SINT95haf,XKL,XMIN,XMAX
      REAL*8   ha65_2_fvar,ha70_2_fvar,ha75_2_fvar,
     .         ha80_2_fvar,ha85_2_fvar,ha90_2_fvar,ha95_2_fvar
      EXTERNAL ha65_2_fvar,ha70_2_fvar,ha75_2_fvar,
     .         ha80_2_fvar,ha85_2_fvar,ha90_2_fvar,ha95_2_fvar
      LOGICAL FIRST
      DATA FIRST /.TRUE./
c
c Kinematic Limit
c
      PARAMETER(XKL=300D0,XMIN=-100D0,XMAX=266D0)
C
      DOUBLE PRECISION RMH
      COMMON /MASS/ RMH
C
      IF (FIRST) THEN
         FIRST = .FALSE.
C        WRITE (6,'(a,2f6.2)') 
c    +      ' Integrating the input SIGNAL functions between:',xmin,xmax
         CALL pjremt1(ha65_2_fvar,10,xmin,xmax,sint65haf) 
         CALL pjremt1(ha70_2_fvar,10,xmin,xmax,sint70haf) 
         CALL pjremt1(ha75_2_fvar,10,xmin,xmax,sint75haf) 
         CALL pjremt1(ha80_2_fvar,10,xmin,xmax,sint80haf) 
         CALL pjremt1(ha85_2_fvar,10,xmin,xmax,sint85haf) 
         CALL pjremt1(ha90_2_fvar,10,xmin,xmax,sint90haf) 
         CALL pjremt1(ha95_2_fvar,10,xmin,xmax,sint95haf) 
C        write (6,*) '================================================'
C        WRITE (6,*) 'The integrals of the signal functions are:'
C        WRITE (6,'((a7,f8.2,a7,f8.2,a7,f8.2))') 
C    &        '  65-->',SINT65haf,'| 70-->',SINT70haf,
C    &        '| 75-->',SINT75haf,
C    &        '  80-->',SINT80haf,'| 85-->',SINT85haf,
C    &        '| 90-->',SINT90haf
C        WRITE (6,'((a7,f8.2))')
C    &        '  95-->',SINT95haf
C        write (6,*) '================================================'
C        write (6,*) 'The kinematic boundary is set at ',sngl(XKL)
      END IF
C
      IF (RMH.GE.65D0 .AND. RMH.LE.70D0) THEN
         REFMH1 = 65D0
         REFMH2 = 70D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = ha65_2_fvar(X) / SINT65haf
         F2 = ha70_2_fvar(X) / SINT70haf
      ELSE IF (RMH.GT.70D0 .AND. RMH.LE.75D0) THEN
         REFMH1 = 70D0
         REFMH2 = 75D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = ha70_2_fvar(X) / SINT70haf
         F2 = ha75_2_fvar(X) / SINT75haf
      ELSE IF (RMH.GT.75D0 .AND. RMH.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = ha75_2_fvar(X) / SINT75haf
         F2 = ha80_2_fvar(X) / SINT80haf
      ELSE IF (RMH.GT.80D0 .AND. RMH.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = ha80_2_fvar(X) / SINT80haf
         F2 = ha85_2_fvar(X) / SINT85haf
      ELSE IF (RMH.GT.85D0 .AND. RMH.LE.90D0) THEN
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = ha85_2_fvar(X) / SINT85haf
         F2 = ha90_2_fvar(X) / SINT90haf
      ELSE IF (RMH.GT.90D0 .AND. RMH.LE.95D0) THEN
c
c     Special treatment: only shift the 90 GeV shape upwards, while keeping 
C     the 95 GeV shape fixed; [i.e., same weights as before, but fix 95 shape]
c
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = ha90_2_fvar(X) / SINT90haf
         F2 = ha95_2_fvar(X) / SINT95haf
      ELSE
         A189_4jet_2_ha_fvar = 0D0
         RETURN
      END IF
C
      A189_4jet_2_ha_fvar = 
     &       (DELTA2 * F1 + DELTA1 * F2) / (REFMH2 - REFMH1)
      IF (A189_4jet_2_ha_fvar.LT.1.D-5) A189_4jet_2_ha_fvar = 1.D-5
c
c NB all the INPUT functions vanish at the kinematic 
c limit x = 188.6 - 91.2 = 97.4; The interpolated functions may (because of 
c the TRANSLATION involved) have a tiny tail of non-zero values beyond the KL.
c This is not physical and is corrected here:
c
c      if (x.gt.xkl) A189_4jet = 1.D-5
C
      RETURN
      END


C------------------------ Instructions for the user -------------------------
C
C This function is used to interpolate between the signal mass shzpes obtained 
C at different mH values, when computing sensitivity curves 
C at 188.6 GeV, CL(mH). The user hzs to provide the signal shzpes at 
C
C     mH=75, 80, 85, 90, 95, 97.5, 100, 105 and 110 GeV
C     
C as DOUBLE PRECISION FORTRAN FUNCTIONS named hz75_2_msum, ..., SMH975,..., SMH110,
C respectively.
C
C The mass at which the user wishes to obtain the interpolated shzpe is
C passed using the variable RMH in common MASS.
C
C-----------------------------------------------------------------------------
C
C     Author: Pedro Teixeira-Dias.
C     Mods:
C     - The input shzpes (provided by the user) are now automatically
C     normalized, upon the first call to this function;
C     - For interpolation in the range 95 <= mH <= 97.5 (threshold), do not 
C     move the 97.5 shzpe downwards (keep it fixed) as this effectively shifts
C     the very sharp threshold cut-off downwards.           PTD, 13-Nov-1998.
C     - Adapt to 188.6 GeV situation: KL=97.4 GeV and the 97 Gev sample 
C     becomes the 97.5 GeV sample.                          PTD, 04-Feb-1999.
C     - Use the old REMT1 subroutine (not the one in the new library)
C     it is here renamed PJREMT1;                           PTD, 09-Feb-1999.
C
      DOUBLE PRECISION FUNCTION A189_4jet_2_hz_msum(X)
C
      DOUBLE PRECISION X,DELTA1,DELTA2,REFMH1,REFMH2,F1,F2,
     .     SINT75hzm,SINT80hzm,SINT85hzm,SINT90hzm,SINT95hzm,
     .     SINT975hzm,SINT100hzm,SINT105hzm,SINT110hzm,XKL,XMIN,XMAX
      REAL*8   hz75_2_msum,hz80_2_msum,hz85_2_msum,
     .         hz90_2_msum,hz95_2_msum,hz975_2_msum,
     .         hz100_2_msum,hz105_2_msum,hz110_2_msum
      EXTERNAL hz75_2_msum,hz80_2_msum,hz85_2_msum,
     .         hz90_2_msum,hz95_2_msum,hz975_2_msum,
     .         hz100_2_msum,hz105_2_msum,hz110_2_msum
      LOGICAL FIRST
      DATA FIRST /.TRUE./
c
c Kinematic Limit
c
      PARAMETER(XKL=188.6D0,XMIN=40D0,XMAX=188.6D0)
C
      DOUBLE PRECISION RMH
      COMMON /MASS/ RMH
C
      IF (FIRST) THEN
         FIRST = .FALSE.
C        WRITE (6,'(a,2f6.2)') 
c    +      ' Integrating the input SIGNAL functions between:',xmin,xmax
         CALL pjremt1(hz75_2_msum,10,xmin,xmax,sint75hzm) 
         CALL pjremt1(hz80_2_msum,10,xmin,xmax,sint80hzm) 
         CALL pjremt1(hz85_2_msum,10,xmin,xmax,sint85hzm) 
         CALL pjremt1(hz90_2_msum,10,xmin,xmax,sint90hzm) 
         CALL pjremt1(hz95_2_msum,10,xmin,xmax,sint95hzm) 
         CALL pjremt1(hz975_2_msum,10,xmin,xmax,sint975hzm) 
         CALL pjremt1(hz100_2_msum,10,xmin,xmax,sint100hzm) 
         CALL pjremt1(hz105_2_msum,10,xmin,xmax,sint105hzm) 
         CALL pjremt1(hz110_2_msum,10,xmin,xmax,sint110hzm) 
C        write (6,*) '================================================'
C        WRITE (6,*) 'The integrals of the signal functions are:'
C        WRITE (6,'((a7,f8.2,a7,f8.2,a7,f8.2))') 
C    &    '  75-->',SINT75hzm,'| 80-->',SINT80hzm,
C    &    '| 85-->',SINT85hzm,
C    &    '  90-->',SINT90hzm,'| 95-->',SINT95hzm,
C    &    '|975-->',SINT975hzm,
C    &    ' 100-->',SINT100hzm,'|105-->',SINT105hzm,
C    &    '|110-->',SINT110hzm 
C        write (6,*) '================================================'
C        write (6,*) 'The kinematic boundary is set at ',sngl(XKL)
      END IF
C
      IF (RMH.GE.75D0 .AND. RMH.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz75_2_msum(X-DELTA1) / SINT75hzm
         F2 = hz80_2_msum(X+DELTA2) / SINT80hzm
      ELSE IF (RMH.GT.80D0 .AND. RMH.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz80_2_msum(X-DELTA1) / SINT80hzm
         F2 = hz85_2_msum(X+DELTA2) / SINT85hzm
      ELSE IF (RMH.GT.85D0 .AND. RMH.LE.90D0) THEN
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz85_2_msum(X-DELTA1) / SINT85hzm
         F2 = hz90_2_msum(X+DELTA2) / SINT90hzm
      ELSE IF (RMH.GT.90D0 .AND. RMH.LE.95D0) THEN
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz90_2_msum(X-DELTA1) / SINT90hzm
         F2 = hz95_2_msum(X) / SINT95hzm
      ELSE IF (RMH.GT.95D0 .AND. RMH.LE.97.5D0) THEN
c
c     Special treatment: only shift the 95 GeV shape upwards, while keeping 
C     the 97.5 GeV shape fixed; [i.e., same weights as before, but fix 97.5 shape]
c
         REFMH1 = 95D0
         REFMH2 = 97.5D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz95_2_msum(X) / SINT95hzm
         F2 = hz100_2_msum(X) / SINT100hzm
      ELSE IF (RMH.GT.97.5D0 .AND. RMH.LE.100D0) THEN
         REFMH1 = 97.5D0
         REFMH2 = 100D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz100_2_msum(X) / SINT100hzm
         F2 = hz100_2_msum(X) / SINT100hzm
      ELSE IF (RMH.GT.100D0 .AND. RMH.LE.105D0) THEN
         REFMH1 = 100D0
         REFMH2 = 105D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz100_2_msum(X) / SINT100hzm
         F2 = hz105_2_msum(X) / SINT105hzm
      ELSE IF (RMH.GT.105D0 .AND. RMH.LE.110D0) THEN
         REFMH1 = 105D0
         REFMH2 = 110D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz105_2_msum(X) / SINT105hzm
         F2 = hz110_2_msum(X) / SINT110hzm
      ELSE
         A189_4jet_2_hz_msum = 0D0
         RETURN
      END IF
C
      A189_4jet_2_hz_msum =
     &         (DELTA2 * F1 + DELTA1 * F2) / (REFMH2 - REFMH1)
      IF (A189_4jet_2_hz_msum.LT.1.D-5) A189_4jet_2_hz_msum = 1.D-5
c
c NB all the INPUT functions vanish at the kinematic 
c limit x = 188.6 - 91.2 = 97.4; The interpolated functions may (because of 
c the TRANSLATION involved) have a tiny tail of non-zero values beyond the KL.
c This is not physical and is corrected here:
c
      if (x.gt.xkl) A189_4jet_2_hz_msum = 1.D-5
C
      RETURN
      END


C------------------------ Instructions for the user -------------------------
C
C This function is used to interpolate between the signal mass shzpes obtained 
C at different mH values, when computing sensitivity curves 
C at 188.6 GeV, CL(mH). The user hzs to provide the signal shzpes at 
C
C     mH=75, 80, 85, 90, 95, 97.5, 100, 105 and 110 GeV
C     
C as DOUBLE PRECISION FORTRAN FUNCTIONS named hz75_2_fvar, ..., SMH975,..., SMH110,
C respectively.
C
C The mass at which the user wishes to obtain the interpolated shzpe is
C passed using the variable RMH in common MASS.
C
C-----------------------------------------------------------------------------
C
C     Author: Pedro Teixeira-Dias.
C     Mods:
C     - The input shzpes (provided by the user) are now automatically
C     normalized, upon the first call to this function;
C     - For interpolation in the range 95 <= mH <= 97.5 (threshold), do not 
C     move the 97.5 shzpe downwards (keep it fixed) as this effectively shifts
C     the very sharp threshold cut-off downwards.           PTD, 13-Nov-1998.
C     - Adapt to 188.6 GeV situation: KL=97.4 GeV and the 97 Gev sample 
C     becomes the 97.5 GeV sample.                          PTD, 04-Feb-1999.
C     - Use the old REMT1 subroutine (not the one in the new library)
C     it is here renamed PJREMT1;                           PTD, 09-Feb-1999.
C
      DOUBLE PRECISION FUNCTION A189_4jet_2_hz_fvar(X)
C
      DOUBLE PRECISION X,DELTA1,DELTA2,REFMH1,REFMH2,F1,F2,
     .     SINT75hzf,SINT80hzf,SINT85hzf,SINT90hzf,SINT95hzf,
     .     SINT975hzf,SINT100hzf,SINT105hzf,SINT110hzf,XKL,XMIN,XMAX
      REAL*8   hz75_2_fvar,hz80_2_fvar,hz85_2_fvar,
     .         hz90_2_fvar,hz95_2_fvar,hz975_2_fvar,
     .         hz100_2_fvar,hz105_2_fvar,hz110_2_fvar
      EXTERNAL hz75_2_fvar,hz80_2_fvar,hz85_2_fvar,
     .         hz90_2_fvar,hz95_2_fvar,hz975_2_fvar,
     .         hz100_2_fvar,hz105_2_fvar,hz110_2_fvar
      LOGICAL FIRST
      DATA FIRST /.TRUE./
c
c Kinematic Limit
c
      PARAMETER(XKL=300D0,XMIN=-100D0,XMAX=266D0)
C
      DOUBLE PRECISION RMH
      COMMON /MASS/ RMH
C
      IF (FIRST) THEN
         FIRST = .FALSE.
C        WRITE (6,'(a,2f6.2)') 
c    +      ' Integrating the input SIGNAL functions between:',xmin,xmax
         CALL pjremt1(hz75_2_fvar,10,xmin,xmax,sint75hzf) 
         CALL pjremt1(hz80_2_fvar,10,xmin,xmax,sint80hzf) 
         CALL pjremt1(hz85_2_fvar,10,xmin,xmax,sint85hzf) 
         CALL pjremt1(hz90_2_fvar,10,xmin,xmax,sint90hzf) 
         CALL pjremt1(hz95_2_fvar,10,xmin,xmax,sint95hzf) 
         CALL pjremt1(hz975_2_fvar,10,xmin,xmax,sint975hzf) 
         CALL pjremt1(hz100_2_fvar,10,xmin,xmax,sint100hzf) 
         CALL pjremt1(hz105_2_fvar,10,xmin,xmax,sint105hzf) 
         CALL pjremt1(hz110_2_fvar,10,xmin,xmax,sint110hzf) 
C        write (6,*) '================================================'
C        WRITE (6,*) 'The integrals of the signal functions are:'
C        WRITE (6,'((a7,f8.2,a7,f8.2,a7,f8.2))') 
C    &    '  75-->',SINT75hzf,'| 80-->',SINT80hzf,
C    &    '| 85-->',SINT85hzf,
C    &    '  90-->',SINT90hzf,'| 95-->',SINT95hzf,
C    &    '|975-->',SINT975hzf,
C    &    ' 100-->',SINT100hzf,'|105-->',SINT105hzf,
C    &    '|110-->',SINT110hzf 
C        write (6,*) '================================================'
C        write (6,*) 'The kinematic boundary is set at ',sngl(XKL)
      END IF
C
      IF (RMH.GE.75D0 .AND. RMH.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz75_2_fvar(X) / SINT75hzf
         F2 = hz80_2_fvar(X) / SINT80hzf
      ELSE IF (RMH.GT.80D0 .AND. RMH.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz80_2_fvar(X) / SINT80hzf
         F2 = hz85_2_fvar(X) / SINT85hzf
      ELSE IF (RMH.GT.85D0 .AND. RMH.LE.90D0) THEN
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz85_2_fvar(X) / SINT85hzf
         F2 = hz90_2_fvar(X) / SINT90hzf
      ELSE IF (RMH.GT.90D0 .AND. RMH.LE.95D0) THEN
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz90_2_fvar(X) / SINT90hzf
         F2 = hz95_2_fvar(X) / SINT95hzf
      ELSE IF (RMH.GT.95D0 .AND. RMH.LE.97.5D0) THEN
c
c     Special treatment: only shift the 95 GeV shape upwards, while keeping 
C     the 97.5 GeV shape fixed; [i.e., same weights as before, but fix 97.5 shape]
c
         REFMH1 = 95D0
         REFMH2 = 97.5D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz95_2_fvar(X) / SINT95hzf
         F2 = hz975_2_fvar(X) / SINT975hzf
      ELSE IF (RMH.GT.97.5D0 .AND. RMH.LE.100D0) THEN
         REFMH1 = 97.5D0
         REFMH2 = 100D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz975_2_fvar(X) / SINT975hzf
         F2 = hz100_2_fvar(X) / SINT100hzf
      ELSE IF (RMH.GT.100D0 .AND. RMH.LE.105D0) THEN
         REFMH1 = 100D0
         REFMH2 = 105D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz100_2_fvar(X) / SINT100hzf
         F2 = hz105_2_fvar(X) / SINT105hzf
      ELSE IF (RMH.GT.105D0 .AND. RMH.LE.110D0) THEN
         REFMH1 = 105D0
         REFMH2 = 110D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz105_2_fvar(X) / SINT105hzf
         F2 = hz110_2_fvar(X) / SINT110hzf
      ELSE
         A189_4jet_2_HZ_FVAR = 0D0
         RETURN
      END IF
C
      A189_4jet_2_HZ_FVAR =
     &        (DELTA2 * F1 + DELTA1 * F2) / (REFMH2 - REFMH1)
      IF (A189_4jet_2_HZ_FVAR.LT.1.D-5) A189_4jet_2_HZ_FVAR = 1.D-5
c
c NB all the INPUT functions vanish at the kinematic 
c limit x = 188.6 - 91.2 = 97.4; The interpolated functions may (because of 
c the TRANSLATION involved) have a tiny tail of non-zero values beyond the KL.
c This is not physical and is corrected here:
c
c      if (x.gt.xkl) A189_4jet_2_hz_fvar = 1.D-5
C
      RETURN
      END


C------------------------ Instructions for the user -------------------------
C
C This function is used to interpolate between the signal mass shapes obtained 
C at different mH values, when computing sensitivity curves 
C at 188.6 GeV, CL(mH). The user has to provide the signal shapes at 
C
C     mH=75, 80, 85, 90, 95, 97.5, 100, 105 and 110 GeV
C     
C as DOUBLE PRECISION FORTRAN FUNCTIONS named ha75_3_mh, ..., SMH975,..., SMH110,
C respectively.
C
C The mass at which the user wishes to obtain the interpolated shape is
C passed using the variable RMH in common MASS.
C
C-----------------------------------------------------------------------------
C
C     Author: Pedro Teixeira-Dias.
C     Mods:
C     - The input shapes (provided by the user) are now automatically
C     normalized, upon the first call to this function;
C     - For interpolation in the range 95 <= mH <= 97.5 (threshold), do not 
C     move the 97.5 shape downwards (keep it fixed) as this effectively shifts
C     the very sharp threshold cut-off downwards.           PTD, 13-Nov-1998.
C     - Adapt to 188.6 GeV situation: KL=97.4 GeV and the 97 Gev sample 
C     becomes the 97.5 GeV sample.                          PTD, 04-Feb-1999.
C     - Use the old REMT1 subroutine (not the one in the new library)
C     it is here renamed PJREMT1;                           PTD, 09-Feb-1999.
C
      DOUBLE PRECISION FUNCTION A189_4jet_3_ha_mh(X)
C
      DOUBLE PRECISION X,DELTA1,DELTA2,REFMH1,REFMH2,F1,F2,
     .     SINT65hamh,SINT70hamh,SINT75hamh,SINT80hamh,SINT85hamh,
     .     SINT90hamh,SINT95hamh,XKL,XMIN,XMAX
      REAL*8 ha65_3_mh,ha70_3_mh,ha75_3_mh,
     .         ha80_3_mh,ha85_3_mh,ha90_3_mh,ha95_3_mh
      EXTERNAL ha65_3_mh,ha70_3_mh,ha75_3_mh,
     .         ha80_3_mh,ha85_3_mh,ha90_3_mh,ha95_3_mh
      LOGICAL FIRST
      DATA FIRST /.TRUE./
c
c Kinematic Limit
c
      PARAMETER(XKL=97.4D0,XMIN=40D0,XMAX=97.4D0)
C
      DOUBLE PRECISION RMH
      COMMON /MASS/ RMH
C
      IF (FIRST) THEN
         FIRST = .FALSE.
C        WRITE (6,'(a,2f6.2)') 
c    +      ' Integrating the input SIGNAL functions between:',xmin,xmax
         CALL pjremt1(ha65_3_mh,10,xmin,xmax,sint65hamh) 
         CALL pjremt1(ha70_3_mh,10,xmin,xmax,sint70hamh) 
         CALL pjremt1(ha75_3_mh,10,xmin,xmax,sint75hamh) 
         CALL pjremt1(ha80_3_mh,10,xmin,xmax,sint80hamh) 
         CALL pjremt1(ha85_3_mh,10,xmin,xmax,sint85hamh) 
         CALL pjremt1(ha90_3_mh,10,xmin,xmax,sint90hamh) 
         CALL pjremt1(ha95_3_mh,10,xmin,xmax,sint95hamh) 
C        write (6,*) '================================================'
C        WRITE (6,*) 'The integrals of the signal functions are:'
C        WRITE (6,'((a7,f8.2,a7,f8.2,a7,f8.2))') 
C    &        '  65-->',SINT65hamh,'| 70-->',SINT70hamh,
C    &        '| 75-->',SINT75hamh,
C    &        '  80-->',SINT80hamh,'| 85-->',SINT85hamh,
C    &        '| 90-->',SINT90hamh
C        WRITE (6,'((a7,f8.2))')
C    &        '  95-->',SINT95hamh
C        write (6,*) '================================================'
C        write (6,*) 'The kinematic boundary is set at ',sngl(XKL)
      END IF
C
      IF (RMH.GE.65D0 .AND. RMH.LE.70D0) THEN
         REFMH1 = 65D0
         REFMH2 = 70D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = ha65_3_mh(X-2*DELTA1) / SINT65hamh
         F2 = ha70_3_mh(X+2*DELTA2) / SINT70hamh
      ELSE IF (RMH.GT.70D0 .AND. RMH.LE.75D0) THEN
         REFMH1 = 70D0
         REFMH2 = 75D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = ha70_3_mh(X-2*DELTA1) / SINT70hamh
         F2 = ha75_3_mh(X+2*DELTA2) / SINT75hamh
      ELSE IF (RMH.GT.75D0 .AND. RMH.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = ha75_3_mh(X-2*DELTA1) / SINT75hamh
         F2 = ha80_3_mh(X+2*DELTA2) / SINT80hamh
      ELSE IF (RMH.GT.80D0 .AND. RMH.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = ha80_3_mh(X-2*DELTA1) / SINT80hamh
         F2 = ha85_3_mh(X+2*DELTA2) / SINT85hamh
      ELSE IF (RMH.GT.85D0 .AND. RMH.LE.90D0) THEN
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = ha85_3_mh(X-2*DELTA1) / SINT85hamh
         F2 = ha90_3_mh(X+2*DELTA2) / SINT90hamh
      ELSE IF (RMH.GT.90D0 .AND. RMH.LE.95D0) THEN
c
c     Special treatment: only shift the 90 GeV shape upwards, while keeping 
C     the 95 GeV shape fixed; [i.e., same weights as before, but fix 95 shape]
c
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = ha90_3_mh(X-2*DELTA1) / SINT90hamh
         F2 = ha95_3_mh(X) / SINT95hamh
      ELSE
         A189_4jet_3_ha_mh = 0D0
         RETURN
      END IF
C
      A189_4jet_3_ha_mh =
     &         (DELTA2 * F1 + DELTA1 * F2) / (REFMH2 - REFMH1)
      IF (A189_4jet_3_ha_mh.LT.1.D-5) A189_4jet_3_ha_mh = 1.D-5
c
c NB all the INPUT functions vanish at the kinematic 
c limit x = 188.6 - 91.2 = 97.4; The interpolated functions may (because of 
c the TRANSLATION involved) have a tiny tail of non-zero values beyond the KL.
c This is not physical and is corrected here:
c
      if (x.gt.xkl) A189_4jet_3_ha_mh = 1.D-5
C
      RETURN
      END


C------------------------ Instructions for the user -------------------------
C
C This function is used to interpolate between the signal mass shapes obtained 
C at different mH values, when computing sensitivity curves 
C at 188.6 GeV, CL(mH). The user has to provide the signal shapes at 
C
C     mH=75, 80, 85, 90, 95, 97.5, 100, 105 and 110 GeV
C     
C as DOUBLE PRECISION FORTRAN FUNCTIONS named ha75_3_fvar, ..., SMH975,..., SMH110,
C respectively.
C
C The mass at which the user wishes to obtain the interpolated shape is
C passed using the variable RMH in common MASS.
C
C-----------------------------------------------------------------------------
C
C     Author: Pedro Teixeira-Dias.
C     Mods:
C     - The input shapes (provided by the user) are now automatically
C     normalized, upon the first call to this function;
C     - For interpolation in the range 95 <= mH <= 97.5 (threshold), do not 
C     move the 97.5 shape downwards (keep it fixed) as this effectively shifts
C     the very sharp threshold cut-off downwards.           PTD, 13-Nov-1998.
C     - Adapt to 188.6 GeV situation: KL=97.4 GeV and the 97 Gev sample 
C     becomes the 97.5 GeV sample.                          PTD, 04-Feb-1999.
C     - Use the old REMT1 subroutine (not the one in the new library)
C     it is here renamed PJREMT1;                           PTD, 09-Feb-1999.
C
      DOUBLE PRECISION FUNCTION A189_4jet_3_ha_nn(X)
C
      DOUBLE PRECISION X,DELTA1,DELTA2,REFMH1,REFMH2,F1,F2,
     .     SINT65han,SINT70han,SINT75han,SINT80han,SINT85han,
     .     SINT90han,SINT95han,XKL,XMIN,XMAX
      REAL*8 ha65_3_nn,ha70_3_nn,ha75_3_nn,
     .         ha80_3_nn,ha85_3_nn,ha90_3_nn,ha95_3_nn
      EXTERNAL ha65_3_nn,ha70_3_nn,ha75_3_nn,
     .         ha80_3_nn,ha85_3_nn,ha90_3_nn,ha95_3_nn
      LOGICAL FIRST
      DATA FIRST /.TRUE./
c
c Kinematic Limit
c
      PARAMETER(XKL=300D0,XMIN=0.951D0,XMAX=1.00D0)
C
      DOUBLE PRECISION RMH
      COMMON /MASS/ RMH
C
      IF (FIRST) THEN
         FIRST = .FALSE.
C        WRITE (6,'(a,2f6.2)') 
c    +      ' Integrating the input SIGNAL functions between:',xmin,xmax
         CALL pjremt1(ha65_3_nn,10,xmin,xmax,sint65han) 
         CALL pjremt1(ha70_3_nn,10,xmin,xmax,sint70han) 
         CALL pjremt1(ha75_3_nn,10,xmin,xmax,sint75han) 
         CALL pjremt1(ha80_3_nn,10,xmin,xmax,sint80han) 
         CALL pjremt1(ha85_3_nn,10,xmin,xmax,sint85han) 
         CALL pjremt1(ha90_3_nn,10,xmin,xmax,sint90han) 
         CALL pjremt1(ha95_3_nn,10,xmin,xmax,sint95han) 
C        write (6,*) '================================================'
C        WRITE (6,*) 'The integrals of the signal functions are:'
C        WRITE (6,'((a7,f8.2,a7,f8.2,a7,f8.2))') 
C    &        '  65-->',SINT65han,'| 70-->',SINT70han,
C    &        '| 75-->',SINT75han,
C    &        '  80-->',SINT80han,'| 85-->',SINT85han,
C    &        '| 90-->',SINT90han
C        WRITE (6,'((a7,f8.2))')
C    &        '  95-->',SINT95han
C        write (6,*) '================================================'
C        write (6,*) 'The kinematic boundary is set at ',sngl(XKL)
      END IF
C
      IF (RMH.GE.65D0 .AND. RMH.LE.70D0) THEN
         REFMH1 = 65D0
         REFMH2 = 70D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = ha65_3_nn(X) / SINT65han
         F2 = ha70_3_nn(X) / SINT70han
      ELSE IF (RMH.GT.70D0 .AND. RMH.LE.75D0) THEN
         REFMH1 = 70D0
         REFMH2 = 75D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = ha70_3_nn(X) / SINT70han
         F2 = ha75_3_nn(X) / SINT75han
      ELSE IF (RMH.GT.75D0 .AND. RMH.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = ha75_3_nn(X) / SINT75han
         F2 = ha80_3_nn(X) / SINT80han
      ELSE IF (RMH.GT.80D0 .AND. RMH.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = ha80_3_nn(X) / SINT80han
         F2 = ha85_3_nn(X) / SINT85han
      ELSE IF (RMH.GT.85D0 .AND. RMH.LE.90D0) THEN
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = ha85_3_nn(X) / SINT85han
         F2 = ha90_3_nn(X) / SINT90han
      ELSE IF (RMH.GT.90D0 .AND. RMH.LE.95D0) THEN
c
c     Special treatment: only shift the 90 GeV shape upwards, while keeping 
C     the 95 GeV shape fixed; [i.e., same weights as before, but fix 95 shape]
c
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = ha90_3_nn(X) / SINT90han
         F2 = ha95_3_nn(X) / SINT95han
      ELSE
         A189_4jet_3_ha_nn = 0D0
         RETURN
      END IF
C
      A189_4jet_3_ha_nn = 
     &       (DELTA2 * F1 + DELTA1 * F2) / (REFMH2 - REFMH1)
      IF (A189_4jet_3_ha_nn.LT.1.D-5) A189_4jet_3_ha_nn = 1.D-5
c
c NB all the INPUT functions vanish at the kinematic 
c limit x = 188.6 - 91.2 = 97.4; The interpolated functions may (because of 
c the TRANSLATION involved) have a tiny tail of non-zero values beyond the KL.
c This is not physical and is corrected here:
c
c      if (x.gt.xkl) A189_4jet = 1.D-5
C
      RETURN
      END


C------------------------ Instructions for the user -------------------------
C
C This function is used to interpolate between the signal mass shzpes obtained 
C at different mH values, when computing sensitivity curves 
C at 188.6 GeV, CL(mH). The user hzs to provide the signal shzpes at 
C
C     mH=75, 80, 85, 90, 95, 97.5, 100, 105 and 110 GeV
C     
C as DOUBLE PRECISION FORTRAN FUNCTIONS named hz75_3_mh, ..., SMH975,..., SMH110,
C respectively.
C
C The mass at which the user wishes to obtain the interpolated shzpe is
C passed using the variable RMH in common MASS.
C
C-----------------------------------------------------------------------------
C
C     Author: Pedro Teixeira-Dias.
C     Mods:
C     - The input shzpes (provided by the user) are now automatically
C     normalized, upon the first call to this function;
C     - For interpolation in the range 95 <= mH <= 97.5 (threshold), do not 
C     move the 97.5 shzpe downwards (keep it fixed) as this effectively shifts
C     the very sharp threshold cut-off downwards.           PTD, 13-Nov-1998.
C     - Adapt to 188.6 GeV situation: KL=97.4 GeV and the 97 Gev sample 
C     becomes the 97.5 GeV sample.                          PTD, 04-Feb-1999.
C     - Use the old REMT1 subroutine (not the one in the new library)
C     it is here renamed PJREMT1;                           PTD, 09-Feb-1999.
C
      DOUBLE PRECISION FUNCTION A189_4jet_3_hz_mh(X)
C
      DOUBLE PRECISION X,DELTA1,DELTA2,REFMH1,REFMH2,F1,F2,
     .     SINT75hzmh,SINT80hzmh,SINT85hzmh,SINT90hzmh,SINT95hzmh,
     .     SINT975hzmh,SINT100hzmh,SINT105hzmh,SINT110hzmh,XKL,XMIN,XMAX
      REAL*8   hz75_3_mh,hz80_3_mh,hz85_3_mh,
     .         hz90_3_mh,hz95_3_mh,hz975_3_mh,
     .         hz100_3_mh,hz105_3_mh,hz110_3_mh
      EXTERNAL hz75_3_mh,hz80_3_mh,hz85_3_mh,
     .         hz90_3_mh,hz95_3_mh,hz975_3_mh,
     .         hz100_3_mh,hz105_3_mh,hz110_3_mh
      LOGICAL FIRST
      DATA FIRST /.TRUE./
c
c Kinematic Limit
c
      PARAMETER(XKL=97.4D0,XMIN=40D0,XMAX=97.4D0)
C
      DOUBLE PRECISION RMH
      COMMON /MASS/ RMH
C
      IF (FIRST) THEN
         FIRST = .FALSE.
C        WRITE (6,'(a,2f6.2)') 
c    +      ' Integrating the input SIGNAL functions between:',xmin,xmax
         CALL pjremt1(hz75_3_mh,10,xmin,xmax,sint75hzmh) 
         CALL pjremt1(hz80_3_mh,10,xmin,xmax,sint80hzmh) 
         CALL pjremt1(hz85_3_mh,10,xmin,xmax,sint85hzmh) 
         CALL pjremt1(hz90_3_mh,10,xmin,xmax,sint90hzmh) 
         CALL pjremt1(hz95_3_mh,10,xmin,xmax,sint95hzmh) 
         CALL pjremt1(hz975_3_mh,10,xmin,xmax,sint975hzmh) 
         CALL pjremt1(hz100_3_mh,10,xmin,xmax,sint100hzmh) 
         CALL pjremt1(hz105_3_mh,10,xmin,xmax,sint105hzmh) 
         CALL pjremt1(hz110_3_mh,10,xmin,xmax,sint110hzmh) 
C        write (6,*) '================================================'
C        WRITE (6,*) 'The integrals of the signal functions are:'
C        WRITE (6,'((a7,f8.2,a7,f8.2,a7,f8.2))') 
C    &    '  75-->',SINT75hzmh,'| 80-->',SINT80hzmh,
C    &    '| 85-->',SINT85hzmh,
C    &    '  90-->',SINT90hzmh,'| 95-->',SINT95hzmh,
C    &    '|975-->',SINT975hzmh,
C    &    ' 100-->',SINT100hzmh,'|105-->',SINT105hzmh,
C    &    '|110-->',SINT110hzmh 
C        write (6,*) '================================================'
C        write (6,*) 'The kinematic boundary is set at ',sngl(XKL)
      END IF
C
      IF (RMH.GE.75D0 .AND. RMH.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz75_3_mh(X-DELTA1) / SINT75hzmh
         F2 = hz80_3_mh(X+DELTA2) / SINT80hzmh
      ELSE IF (RMH.GT.80D0 .AND. RMH.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz80_3_mh(X-DELTA1) / SINT80hzmh
         F2 = hz85_3_mh(X+DELTA2) / SINT85hzmh
      ELSE IF (RMH.GT.85D0 .AND. RMH.LE.90D0) THEN
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz85_3_mh(X-DELTA1) / SINT85hzmh
         F2 = hz90_3_mh(X+DELTA2) / SINT90hzmh
      ELSE IF (RMH.GT.90D0 .AND. RMH.LE.95D0) THEN
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz90_3_mh(X-DELTA1) / SINT90hzmh
         F2 = hz95_3_mh(X+DELTA2) / SINT95hzmh
      ELSE IF (RMH.GT.95D0 .AND. RMH.LE.97.5D0) THEN
c
c     Special treatment: only shift the 95 GeV shape upwards, while keeping 
C     the 97.5 GeV shape fixed; [i.e., same weights as before, but fix 97.5 shape]
c
         REFMH1 = 95D0
         REFMH2 = 97.5D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz95_3_mh(X-DELTA1) / SINT95hzmh
         F2 = hz975_3_mh(X) / SINT975hzmh
      ELSE IF (RMH.GT.97.5D0 .AND. RMH.LE.100D0) THEN
         REFMH1 = 97.5D0
         REFMH2 = 100D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz975_3_mh(X) / SINT975hzmh
         F2 = hz100_3_mh(X) / SINT100hzmh
      ELSE IF (RMH.GT.100D0 .AND. RMH.LE.105D0) THEN
         REFMH1 = 100D0
         REFMH2 = 105D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz100_3_mh(X) / SINT100hzmh
         F2 = hz105_3_mh(X) / SINT105hzmh
      ELSE IF (RMH.GT.105D0 .AND. RMH.LE.110D0) THEN
         REFMH1 = 105D0
         REFMH2 = 110D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz105_3_mh(X) / SINT105hzmh
         F2 = hz110_3_mh(X) / SINT110hzmh
      ELSE
         A189_4jet_3_hz_mh = 0D0
         RETURN
      END IF
C
      A189_4jet_3_hz_mh =
     &         (DELTA2 * F1 + DELTA1 * F2) / (REFMH2 - REFMH1)
      IF (A189_4jet_3_hz_mh.LT.1.D-5) A189_4jet_3_hz_mh = 1.D-5
c
c NB all the INPUT functions vanish at the kinematic 
c limit x = 188.6 - 91.2 = 97.4; The interpolated functions may (because of 
c the TRANSLATION involved) have a tiny tail of non-zero values beyond the KL.
c This is not physical and is corrected here:
c
      if (x.gt.xkl) A189_4jet_3_hz_mh = 1.D-5
C
      RETURN
      END


C------------------------ Instructions for the user -------------------------
C
C This function is used to interpolate between the signal mass shzpes obtained 
C at different mH values, when computing sensitivity curves 
C at 188.6 GeV, CL(mH). The user hzs to provide the signal shzpes at 
C
C     mH=75, 80, 85, 90, 95, 97.5, 100, 105 and 110 GeV
C     
C as DOUBLE PRECISION FORTRAN FUNCTIONS named hz75_3_nn, ..., SMH975,..., SMH110,
C respectively.
C
C The mass at which the user wishes to obtain the interpolated shzpe is
C passed using the variable RMH in common MASS.
C
C-----------------------------------------------------------------------------
C
C     Author: Pedro Teixeira-Dias.
C     Mods:
C     - The input shzpes (provided by the user) are now automatically
C     normalized, upon the first call to this function;
C     - For interpolation in the range 95 <= mH <= 97.5 (threshold), do not 
C     move the 97.5 shzpe downwards (keep it fixed) as this effectively shifts
C     the very sharp threshold cut-off downwards.           PTD, 13-Nov-1998.
C     - Adapt to 188.6 GeV situation: KL=97.4 GeV and the 97 Gev sample 
C     becomes the 97.5 GeV sample.                          PTD, 04-Feb-1999.
C     - Use the old REMT1 subroutine (not the one in the new library)
C     it is here renamed PJREMT1;                           PTD, 09-Feb-1999.
C
      DOUBLE PRECISION FUNCTION A189_4jet_3_hz_nn(X)
C
      DOUBLE PRECISION X,DELTA1,DELTA2,REFMH1,REFMH2,F1,F2,
     .     SINT75hzn,SINT80hzn,SINT85hzn,SINT90hzn,SINT95hzn,
     .     SINT975hzn,SINT100hzn,SINT105hzn,SINT110hzn,XKL,XMIN,XMAX
      REAL*8   hz75_3_nn,hz80_3_nn,hz85_3_nn,
     .         hz90_3_nn,hz95_3_nn,hz975_3_nn,
     .         hz100_3_nn,hz105_3_nn,hz110_3_nn
      EXTERNAL hz75_3_nn,hz80_3_nn,hz85_3_nn,
     .         hz90_3_nn,hz95_3_nn,hz975_3_nn,
     .         hz100_3_nn,hz105_3_nn,hz110_3_nn
      LOGICAL FIRST
      DATA FIRST /.TRUE./
c
c Kinematic Limit
c
      PARAMETER(XKL=300D0,XMIN=0.951D0,XMAX=1.00D0)
C
      DOUBLE PRECISION RMH
      COMMON /MASS/ RMH
C
      IF (FIRST) THEN
         FIRST = .FALSE.
C        WRITE (6,'(a,2f6.2)') 
c    +      ' Integrating the input SIGNAL functions between:',xmin,xmax
         CALL pjremt1(hz75_3_nn,10,xmin,xmax,sint75hzn) 
         CALL pjremt1(hz80_3_nn,10,xmin,xmax,sint80hzn) 
         CALL pjremt1(hz85_3_nn,10,xmin,xmax,sint85hzn) 
         CALL pjremt1(hz90_3_nn,10,xmin,xmax,sint90hzn) 
         CALL pjremt1(hz95_3_nn,10,xmin,xmax,sint95hzn) 
         CALL pjremt1(hz975_3_nn,10,xmin,xmax,sint975hzn) 
         CALL pjremt1(hz100_3_nn,10,xmin,xmax,sint100hzn) 
         CALL pjremt1(hz105_3_nn,10,xmin,xmax,sint105hzn) 
         CALL pjremt1(hz110_3_nn,10,xmin,xmax,sint110hzn) 
C        write (6,*) '================================================'
C        WRITE (6,*) 'The integrals of the signal functions are:'
C        WRITE (6,'((a7,f8.2,a7,f8.2,a7,f8.2))') 
C    &    '  75-->',SINT75hzn,'| 80-->',SINT80hzn,
C    &    '| 85-->',SINT85hzn,
C    &    '  90-->',SINT90hzn,'| 95-->',SINT95hzn,
C    &    '|975-->',SINT975hzn,
C    &    ' 100-->',SINT100hzn,'|105-->',SINT105hzn,
C    &    '|110-->',SINT110hzn 
C        write (6,*) '================================================'
C        write (6,*) 'The kinematic boundary is set at ',sngl(XKL)
      END IF
C
      IF (RMH.GE.75D0 .AND. RMH.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz75_3_nn(X) / SINT75hzn
         F2 = hz80_3_nn(X) / SINT80hzn
      ELSE IF (RMH.GT.80D0 .AND. RMH.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz80_3_nn(X) / SINT80hzn
         F2 = hz85_3_nn(X) / SINT85hzn
      ELSE IF (RMH.GT.85D0 .AND. RMH.LE.90D0) THEN
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz85_3_nn(X) / SINT85hzn
         F2 = hz90_3_nn(X) / SINT90hzn
      ELSE IF (RMH.GT.90D0 .AND. RMH.LE.95D0) THEN
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz90_3_nn(X) / SINT90hzn
         F2 = hz95_3_nn(X) / SINT95hzn
      ELSE IF (RMH.GT.95D0 .AND. RMH.LE.97.5D0) THEN
c
c     Special treatment: only shift the 95 GeV shape upwards, while keeping 
C     the 97.5 GeV shape fixed; [i.e., same weights as before, but fix 97.5 shape]
c
         REFMH1 = 95D0
         REFMH2 = 97.5D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz95_3_nn(X) / SINT95hzn
         F2 = hz975_3_nn(X) / SINT975hzn
      ELSE IF (RMH.GT.97.5D0 .AND. RMH.LE.100D0) THEN
         REFMH1 = 97.5D0
         REFMH2 = 100D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz975_3_nn(X) / SINT975hzn
         F2 = hz100_3_nn(X) / SINT100hzn
      ELSE IF (RMH.GT.100D0 .AND. RMH.LE.105D0) THEN
         REFMH1 = 100D0
         REFMH2 = 105D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz100_3_nn(X) / SINT100hzn
         F2 = hz105_3_nn(X) / SINT105hzn
      ELSE IF (RMH.GT.105D0 .AND. RMH.LE.110D0) THEN
         REFMH1 = 105D0
         REFMH2 = 110D0
         DELTA1 = RMH - REFMH1
         DELTA2 = REFMH2 - RMH
         F1 = hz105_3_nn(X) / SINT105hzn
         F2 = hz110_3_nn(X) / SINT110hzn
      ELSE
         A189_4jet_3_HZ_NN = 0D0
         RETURN
      END IF
C
      A189_4jet_3_HZ_NN =
     &        (DELTA2 * F1 + DELTA1 * F2) / (REFMH2 - REFMH1)
      IF (A189_4jet_3_HZ_NN.LT.1.D-5) A189_4jet_3_HZ_NN = 1.D-5
c
c NB all the INPUT functions vanish at the kinematic 
c limit x = 188.6 - 91.2 = 97.4; The interpolated functions may (because of 
c the TRANSLATION involved) have a tiny tail of non-zero values beyond the KL.
c This is not physical and is corrected here:
c
c      if (x.gt.xkl) A189_4jet_3_hz_nn = 1.D-5
C
      RETURN
      END


      Double Precision Function A189_4jet_eff_1_ha(amass)
****$****|****$****|****$****|****$****|****$****|****$****|****$****|**
*!  - 
*!
*!   Author   :- Y. Gao                 5-NOV-1997
*!
*!   Inputs:
*!        - amass ( REAL*8 ): Higgs mass
*!
*!   Outputs:
*!        - function return the four-jet braching ration of HZ process
*!
*!   Libraries required: 
*!
*!   Description
*!   ===========
*!   updated to use the new table upto Mh=120GeV    30/10/98
*!   use new tables, don't count h->WW as 4-jet
*!
****$****|****$****|****$****|****$****|****$****|****$****|****$****|**
      Implicit none
      Real*8        eff65,eff70,eff75,eff80,eff85,eff90,eff95
      Real*8        del1,del2

      Real*8        amass

      A189_4jet_eff_1_ha = 0D0

      if (amass.lt.65D0) goto 1000
      if (amass.gt.95D0) goto 1000

      if (amass.lt.70D0) then
        eff65 = 2681./8347.
        eff70 = 2576./8398.
        del1 = amass - 65D0
        del2 = 70D0 - amass
        A189_4jet_eff_1_ha = (eff65*del2+eff70*del1)/(del1+del2)
        goto 1000
      endif

      if (amass.lt.75D0) then
        eff70 = 2576./8398.
        eff75 = 2851./8377.
        del1 = amass - 70D0
        del2 = 75D0 - amass
        A189_4jet_eff_1_ha = (eff70*del2+eff75*del1)/(del1+del2)
        goto 1000
      endif

      if (amass.lt.80D0) then
        eff75 = 2851./8377.
        eff80 = 2979./8373.
        del1 = amass - 75D0
        del2 = 80D0 - amass
        A189_4jet_eff_1_ha = (eff75*del2+eff80*del1)/(del1+del2)
        goto 1000
      endif

      if (amass.lt.85D0) then
        eff80 = 2979./8373.
        eff85 = 3599./8467.
        del1 = amass - 80D0
        del2 = 85D0 - amass
        A189_4jet_eff_1_ha = (eff80*del2+eff85*del1)/(del1+del2)
        goto 1000
      endif

      if (amass.lt.90D0) then
        eff85 = 3599./8467.
        eff90 = 3735./8418.
        del1 = amass - 85D0
        del2 = 90D0 - amass
        A189_4jet_eff_1_ha = (eff85*del2+eff90*del1)/(del1+del2)
        goto 1000
      endif

      if (amass.le.95D0) then
        eff90 = 3735./8418.
        eff95 = 3524./8463.
        del1 = amass - 90D0
        del2 = 95D0 - amass
        A189_4jet_eff_1_ha = (eff90*del2+eff95*del1)/(del1+del2)
        goto 1000
      endif


 1000 RETURN
      END
      Double Precision Function A189_4jet_eff_1_hz(amass)
****$****|****$****|****$****|****$****|****$****|****$****|****$****|**
*!  - 
*!
*!   Author   :- Y. Gao                 5-NOV-1997
*!
*!   Inputs:
*!        - amass ( REAL*8 ): Higgs mass
*!
*!   Outputs:
*!        - function return the four-jet braching ration of HZ process
*!
*!   Libraries required: 
*!
*!   Description
*!   ===========
*!   updated to use the new table upto Mh=120GeV    30/10/98
*!   use new tables, don't count h->WW as 4-jet
*!
****$****|****$****|****$****|****$****|****$****|****$****|****$****|**
      Implicit none
      Real*8        eff75,eff80,eff85,eff90,eff95,eff975
      Real*8        eff_100,eff_105,eff_110
      Real*8        del1,del2

      Real*8        amass

      A189_4jet_eff_1_hz = 0D0

      if (amass.lt.75D0) goto 1000
      if (amass.gt.110D0) goto 1000

      if (amass.lt.80D0) then
        eff75 = 577./6304.
        eff80 = 570./6022.
        del1 = amass - 75D0
        del2 = 80D0 - amass
        A189_4jet_eff_1_hz = (eff75*del2+eff80*del1)/(del1+del2)
        goto 1000
      endif

      if (amass.lt.85D0) then
        eff80 = 570./6022.
        eff85 = 658./6353.
        del1 = amass - 80D0
        del2 = 85D0 - amass
        A189_4jet_eff_1_hz = (eff80*del2+eff85*del1)/(del1+del2)
        goto 1000
      endif

      if (amass.lt.90D0) then
        eff85 = 658./6353.
        eff90 = 549./5818.
        del1 = amass - 85D0
        del2 = 90D0 - amass
        A189_4jet_eff_1_hz = (eff85*del2+eff90*del1)/(del1+del2)
        goto 1000
      endif

      if (amass.lt.95D0) then
        eff90 = 549./5818.
        eff95 = 633./6209.
        del1 = amass - 90D0
        del2 = 95D0 - amass
        A189_4jet_eff_1_hz = (eff90*del2+eff95*del1)/(del1+del2)
        goto 1000
      endif

      if (amass.lt.97.5D0) then
        eff95 = 633./6209.
        eff975 = 648./6090.
        del1 = amass - 95D0
        del2 = 97.5D0 - amass
        A189_4jet_eff_1_hz = (eff95*del2+eff975*del1)/(del1+del2)
        goto 1000
      endif

      if (amass.le.100D0) then
        eff975 = 648./6090.
        eff_100 = 548./5652.
        del1 = amass - 97.5D0
        del2 = 100D0 - amass
        A189_4jet_eff_1_hz = (eff975*del2+eff_100*del1)/(del1+del2)
        goto 1000
      endif

      if (amass.le.105D0) then
        eff_100 = 548./5652.
        eff_105 = 400./4905.
        del1 = amass - 100D0
        del2 = 105D0 - amass
        A189_4jet_eff_1_hz = (eff_100*del2+eff_105*del1)/(del1+del2)
        goto 1000
      endif

      if (amass.le.110D0) then
        eff_105 = 400./4905.
        eff_110 = 346./4465.
        del1 = amass - 105D0
        del2 = 110D0 - amass
        A189_4jet_eff_1_hz = (eff_105*del2+eff_110*del1)/(del1+del2)
        goto 1000
      endif


 1000 RETURN
      END
      Double Precision Function A189_4jet_eff_2_ha(amass)
****$****|****$****|****$****|****$****|****$****|****$****|****$****|**
*!  - 
*!
*!   Author   :- Y. Gao                 5-NOV-1997
*!
*!   Inputs:
*!        - amass ( REAL*8 ): Higgs mass
*!
*!   Outputs:
*!        - function return the four-jet braching ration of HZ process
*!
*!   Libraries required: 
*!
*!   Description
*!   ===========
*!   updated to use the new table upto Mh=120GeV    30/10/98
*!   use new tables, don't count h->WW as 4-jet
*!
****$****|****$****|****$****|****$****|****$****|****$****|****$****|**
      Implicit none
      Real*8        eff65,eff70,eff75,eff80,eff85,eff90,eff95
      Real*8        del1,del2

      Real*8        amass

      A189_4jet_eff_2_ha = 0D0

      if (amass.lt.65D0) goto 1000
      if (amass.gt.95D0) goto 1000

      if (amass.lt.70D0) then
        eff65 = 1500./8347.
        eff70 = 1565./8398.
        del1 = amass - 65D0
        del2 = 70D0 - amass
        A189_4jet_eff_2_ha = (eff65*del2+eff70*del1)/(del1+del2)
        goto 1000
      endif

      if (amass.lt.75D0) then
        eff70 = 1565./8398.
        eff75 = 1479./8377.
        del1 = amass - 70D0
        del2 = 75D0 - amass
        A189_4jet_eff_2_ha = (eff70*del2+eff75*del1)/(del1+del2)
        goto 1000
      endif

      if (amass.lt.80D0) then
        eff75 = 1479./8377.
        eff80 = 1176./8373.
        del1 = amass - 75D0
        del2 = 80D0 - amass
        A189_4jet_eff_2_ha = (eff75*del2+eff80*del1)/(del1+del2)
        goto 1000
      endif

      if (amass.lt.85D0) then
        eff80 = 1176./8373.
        eff85 =  524./8467.
        del1 = amass - 80D0
        del2 = 85D0 - amass
        A189_4jet_eff_2_ha = (eff80*del2+eff85*del1)/(del1+del2)
        goto 1000
      endif

      if (amass.lt.90D0) then
        eff85 =  524./8467.
        eff90 =  318./8418.
        del1 = amass - 85D0
        del2 = 90D0 - amass
        A189_4jet_eff_2_ha = (eff85*del2+eff90*del1)/(del1+del2)
        goto 1000
      endif

      if (amass.le.95D0) then
        eff90 =  318./8418.
        eff95 =  369./8463.
        del1 = amass - 90D0
        del2 = 95D0 - amass
        A189_4jet_eff_2_ha = (eff90*del2+eff95*del1)/(del1+del2)
        goto 1000
      endif


 1000 RETURN
      END
      Double Precision Function A189_4jet_eff_2_hz(amass)
****$****|****$****|****$****|****$****|****$****|****$****|****$****|**
*!  - 
*!
*!   Author   :- Y. Gao                 5-NOV-1997
*!
*!   Inputs:
*!        - amass ( REAL*8 ): Higgs mass
*!
*!   Outputs:
*!        - function return the four-jet braching ration of HZ process
*!
*!   Libraries required: 
*!
*!   Description
*!   ===========
*!   updated to use the new table upto Mh=120GeV    30/10/98
*!   use new tables, don't count h->WW as 4-jet
*!
****$****|****$****|****$****|****$****|****$****|****$****|****$****|**
      Implicit none
      Real*8        eff75,eff80,eff85,eff90,eff95,eff975
      Real*8        eff_100,eff_105,eff_110
      Real*8        del1,del2

      Real*8        amass

      A189_4jet_eff_2_hz = 0D0

      if (amass.lt.75D0) goto 1000
      if (amass.gt.110D0) goto 1000

      if (amass.lt.80D0) then
        eff75 = 127./6304.
        eff80 =  82./6022.
        del1 = amass - 75D0
        del2 = 80D0 - amass
        A189_4jet_eff_2_hz = (eff75*del2+eff80*del1)/(del1+del2)
        goto 1000
      endif

      if (amass.lt.85D0) then
        eff80 =  82./6022.
        eff85 =  65./6353.
        del1 = amass - 80D0
        del2 = 85D0 - amass
        A189_4jet_eff_2_hz = (eff80*del2+eff85*del1)/(del1+del2)
        goto 1000
      endif

      if (amass.lt.90D0) then
        eff85 =  65./6353.
        eff90 =  44./5818.
        del1 = amass - 85D0
        del2 = 90D0 - amass
        A189_4jet_eff_2_hz = (eff85*del2+eff90*del1)/(del1+del2)
        goto 1000
      endif

      if (amass.lt.95D0) then
        eff90 =  44./5818.
        eff95 =  35./6209.
        del1 = amass - 90D0
        del2 = 95D0 - amass
        A189_4jet_eff_2_hz = (eff90*del2+eff95*del1)/(del1+del2)
        goto 1000
      endif

      if (amass.lt.97.5D0) then
        eff95 =  35./6209.
        eff975 = 48./6090.
        del1 = amass - 95D0
        del2 = 97.5D0 - amass
        A189_4jet_eff_2_hz = (eff95*del2+eff975*del1)/(del1+del2)
        goto 1000
      endif

      if (amass.le.100D0) then
        eff975 =  48./6090.
        eff_100 =  76./5652.
        del1 = amass - 97.5D0
        del2 = 100D0 - amass
        A189_4jet_eff_2_hz = (eff975*del2+eff_100*del1)/(del1+del2)
        goto 1000
      endif

      if (amass.le.105D0) then
        eff_100 =  76./5652.
        eff_105 =  90./4905.
        del1 = amass - 100D0
        del2 = 105D0 - amass
        A189_4jet_eff_2_hz = (eff_100*del2+eff_105*del1)/(del1+del2)
        goto 1000
      endif

      if (amass.le.110D0) then
        eff_105 =  90./4905.
        eff_110 = 108./4465.
        del1 = amass - 105D0
        del2 = 110D0 - amass
        A189_4jet_eff_2_hz = (eff_105*del2+eff_110*del1)/(del1+del2)
        goto 1000
      endif


 1000 RETURN
      END
      Double Precision Function A189_4jet_eff_3_ha(amass)
****$****|****$****|****$****|****$****|****$****|****$****|****$****|**
*!  - 
*!
*!   Author   :- Y. Gao                 5-NOV-1997
*!
*!   Inputs:
*!        - amass ( REAL*8 ): Higgs mass
*!
*!   Outputs:
*!        - function return the four-jet braching ration of HZ process
*!
*!   Libraries required: 
*!
*!   Description
*!   ===========
*!   updated to use the new table upto Mh=120GeV    30/10/98
*!   use new tables, don't count h->WW as 4-jet
*!
****$****|****$****|****$****|****$****|****$****|****$****|****$****|**
      Implicit none
      Real*8        eff65,eff70,eff75,eff80,eff85,eff90,eff95
      Real*8        del1,del2

      Real*8        amass

      A189_4jet_eff_3_ha = 0D0

      if (amass.lt.65D0) goto 1000
      if (amass.gt.95D0) goto 1000

      if (amass.lt.70D0) then
        eff65 =  688./8347.
        eff70 =  781./8398.
        del1 = amass - 65D0
        del2 = 70D0 - amass
        A189_4jet_eff_3_ha = (eff65*del2+eff70*del1)/(del1+del2)
        goto 1000
      endif

      if (amass.lt.75D0) then
        eff70 =  781./8398.
        eff75 =  776./8377.
        del1 = amass - 70D0
        del2 = 75D0 - amass
        A189_4jet_eff_3_ha = (eff70*del2+eff75*del1)/(del1+del2)
        goto 1000
      endif

      if (amass.lt.80D0) then
        eff75 =  776./8377.
        eff80 =  887./8373.
        del1 = amass - 75D0
        del2 = 80D0 - amass
        A189_4jet_eff_3_ha = (eff75*del2+eff80*del1)/(del1+del2)
        goto 1000
      endif

      if (amass.lt.85D0) then
        eff80 =  887./8373.
        eff85 = 1295./8467.
        del1 = amass - 80D0
        del2 = 85D0 - amass
        A189_4jet_eff_3_ha = (eff80*del2+eff85*del1)/(del1+del2)
        goto 1000
      endif

      if (amass.lt.90D0) then
        eff85 = 1295./8467.
        eff90 = 1926./8418.
        del1 = amass - 85D0
        del2 = 90D0 - amass
        A189_4jet_eff_3_ha = (eff85*del2+eff90*del1)/(del1+del2)
        goto 1000
      endif

      if (amass.le.95D0) then
        eff90 = 1926./8418.
        eff95 = 1957./8463.
        del1 = amass - 90D0
        del2 = 95D0 - amass
        A189_4jet_eff_3_ha = (eff90*del2+eff95*del1)/(del1+del2)
        goto 1000
      endif


 1000 RETURN
      END
      Double Precision Function A189_4jet_eff_3_hz(amass)
****$****|****$****|****$****|****$****|****$****|****$****|****$****|**
*!  - 
*!
*!   Author   :- Y. Gao                 5-NOV-1997
*!
*!   Inputs:
*!        - amass ( REAL*8 ): Higgs mass
*!
*!   Outputs:
*!        - function return the four-jet braching ration of HZ process
*!
*!   Libraries required: 
*!
*!   Description
*!   ===========
*!   updated to use the new table upto Mh=120GeV    30/10/98
*!   use new tables, don't count h->WW as 4-jet
*!
****$****|****$****|****$****|****$****|****$****|****$****|****$****|**
      Implicit none
      Real*8        eff75,eff80,eff85,eff90,eff95,eff975
      Real*8        eff_100,eff_105,eff_110
      Real*8        del1,del2

      Real*8        amass

      A189_4jet_eff_3_hz = 0D0

      if (amass.lt.75D0) goto 1000
      if (amass.gt.110D0) goto 1000

      if (amass.lt.80D0) then
        eff75 = 1529./6304.
        eff80 = 1741./6022.
        del1 = amass - 75D0
        del2 = 80D0 - amass
        A189_4jet_eff_3_hz = (eff75*del2+eff80*del1)/(del1+del2)
        goto 1000
      endif

      if (amass.lt.85D0) then
        eff80 = 1741./6022.
        eff85 = 2089./6353.
        del1 = amass - 80D0
        del2 = 85D0 - amass
        A189_4jet_eff_3_hz = (eff80*del2+eff85*del1)/(del1+del2)
        goto 1000
      endif

      if (amass.lt.90D0) then
        eff85 = 2089./6353.
        eff90 = 2068./5818.
        del1 = amass - 85D0
        del2 = 90D0 - amass
        A189_4jet_eff_3_hz = (eff85*del2+eff90*del1)/(del1+del2)
        goto 1000
      endif

      if (amass.lt.95D0) then
        eff90 = 2068./5818.
        eff95 = 2192./6209.
        del1 = amass - 90D0
        del2 = 95D0 - amass
        A189_4jet_eff_3_hz = (eff90*del2+eff95*del1)/(del1+del2)
        goto 1000
      endif

      if (amass.lt.97.5D0) then
        eff95 =  2192./6209.
        eff975 = 2018./6090.
        del1 = amass - 95D0
        del2 = 97.5D0 - amass
        A189_4jet_eff_3_hz = (eff95*del2+eff975*del1)/(del1+del2)
        goto 1000
      endif

      if (amass.le.100D0) then
        eff975 = 2018./6090.
        eff_100 = 1622./5652.
        del1 = amass - 97.5D0
        del2 = 100D0 - amass
        A189_4jet_eff_3_hz = (eff975*del2+eff_100*del1)/(del1+del2)
        goto 1000
      endif

      if (amass.le.105D0) then
        eff_100 = 1622./5652.
        eff_105 = 1116./4905.
        del1 = amass - 100D0
        del2 = 105D0 - amass
        A189_4jet_eff_3_hz = (eff_100*del2+eff_105*del1)/(del1+del2)
        goto 1000
      endif

      if (amass.le.110D0) then
        eff_105 = 1116./4905.
        eff_110 =  863./4465.
        del1 = amass - 105D0
        del2 = 110D0 - amass
        A189_4jet_eff_3_hz = (eff_105*del2+eff_110*del1)/(del1+del2)
        goto 1000
      endif


 1000 RETURN
      END
      DOUBLE PRECISION FUNCTION A189_4jet_1_qq_fvar(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   7, 1)
      DOUBLE PRECISION SIGDEL(   7)
      DOUBLE PRECISION SIGA(   7)
      DATA NPAR, NDIM, IMQFUN /    7,    1,    2/
      DATA VCONST /  28.00000000000    /
      DATA SIGVMI / -200.0000000000    /
      DATA SIGVT /  1400.000000000    /
      DATA SIGV / 0.2699999809265    
     +, 0.5299999713898    
     +, 0.5500000119209    
     +, 0.5699999928474    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.6800000071526    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.1599999964237    
     +/
      DATA SIGA / -9.600497991865    
     +,  19.81465876571    
     +, -53.94179449993    
     +,  36.27993296106    
     +, -2.436116592000    
     +,  32.53014343937    
     +, -59.37156481963    
     +/
      A189_4jet_1_qq_fvar = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         A189_4jet_1_qq_fvar = A189_4jet_1_qq_fvar + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) 
     +     A189_4jet_1_qq_fvar = VCONST * EXP (A189_4jet_1_qq_fvar)
      END
      DOUBLE PRECISION FUNCTION A189_4jet_1_qq_msum(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   5, 1)
      DOUBLE PRECISION SIGDEL(   5)
      DOUBLE PRECISION SIGA(   5)
      DATA NPAR, NDIM, IMQFUN /    5,    1,    2/
      DATA VCONST /  3.000000000000    /
      DATA SIGVMI /  20.00000000000    /
      DATA SIGVT /  180.0000000000    /
      DATA SIGV / 0.6833333969116    
     +, 0.7833333611488    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.9000000357628    
     +/
      DATA SIGDEL / 0.2000000178814    
     +, 0.2000000178814    
     +, 0.6000000212225E-05
     +, 0.6000000212225E-05
     +, 0.4000000357628    
     +/
      DATA SIGA /  6.266303233242    
     +,  315.3991892033    
     +,  183.0690950003    
     +,  366.3723847980    
     +, -687.8624173820    
     +/
      A189_4jet_1_qq_msum = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         A189_4jet_1_qq_msum = A189_4jet_1_qq_msum + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) 
     +     A189_4jet_1_qq_msum = VCONST * EXP (A189_4jet_1_qq_msum)
      END
      DOUBLE PRECISION FUNCTION A189_4jet_1_qq_mh(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   8, 1)
      DOUBLE PRECISION SIGDEL(   8)
      DOUBLE PRECISION SIGA(   8)
      DATA NPAR, NDIM, IMQFUN /    8,    1,    2/
      DATA VCONST /  1.750000000000    /
      DATA SIGVMI /  35.00000000000    /
      DATA SIGVT /  70.00000000000    /
      DATA SIGV / 0.6250000000000E-01
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.1250000000000    
     +, 0.4749999940395    
     +, 0.5250000357628    
     +, 0.9250000119209    
     +, 0.7500000000000    
     +/
      DATA SIGDEL / 0.5000000074506E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.1000000014901    
     +, 0.1000000014901    
     +, 0.1000000014901    
     +, 0.1000000014901    
     +, 0.2000000029802    
     +/
      DATA SIGA / -6.815318149532    
     +,  4.527312260900    
     +,  78.12291120285    
     +,  2.518852620827    
     +,  1.124403959900    
     +, -3.671412603782    
     +, -91.55777376812    
     +,  13.59578690683    
     +/
      A189_4jet_1_qq_mh = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         A189_4jet_1_qq_mh = A189_4jet_1_qq_mh + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) 
     +     A189_4jet_1_qq_mh = VCONST * EXP (A189_4jet_1_qq_mh)
      END
      DOUBLE PRECISION FUNCTION A189_4jet_1_qq_nn(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  10, 1)
      DOUBLE PRECISION SIGDEL(  10)
      DOUBLE PRECISION SIGA(  10)
      DATA NPAR, NDIM, IMQFUN /   10,    1,    2/
      DATA VCONST / 0.1999999955297E-01/
      DATA SIGVMI / 0.0000000000000E+00/
      DATA SIGVT /  1.000000000000    /
      DATA SIGV / 0.7000000029802E-01
     +, 0.3299999833107    
     +, 0.4099999964237    
     +, 0.7899999618530    
     +, 0.8100000023842    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.1999999880791    
     +, 0.5999999642372    
     +, 0.6800000071526    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.1599999964237    
     +, 0.1599999964237    
     +, 0.1599999964237    
     +/
      DATA SIGA /  3.640879627478    
     +, -1.052176253161    
     +, -3.505027945331    
     +,  3.981990844843    
     +,  1.972668483845    
     +, 0.3516809366723    
     +,  7.187574080984    
     +,  5.355084361040    
     +,  23.90830611658    
     +, -25.28296889124    
     +/
      A189_4jet_1_qq_nn = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         A189_4jet_1_qq_nn = A189_4jet_1_qq_nn + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) 
     +     A189_4jet_1_qq_nn = VCONST * EXP (A189_4jet_1_qq_nn)
      END
      DOUBLE PRECISION FUNCTION A189_4jet_2_qq_msum(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  12, 1)
      DOUBLE PRECISION SIGDEL(  12)
      DOUBLE PRECISION SIGA(  12)
      DATA NPAR, NDIM, IMQFUN /   12,    1,    2/
      DATA VCONST /  3.000000000000    /
      DATA SIGVMI /  20.00000000000    /
      DATA SIGVT /  180.0000000000    /
      DATA SIGV / 0.6083333492279    
     +, 0.6250000596046    
     +, 0.8250000476837    
     +, 0.9416667222977    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.1166666746140    
     +, 0.2166666835546    
     +, 0.2833333611488    
     +, 0.3166666924953    
     +, 0.3500000238419    
     +, 0.3833333551884    
     +/
      DATA SIGDEL / 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +/
      DATA SIGA /  1.856330958965    
     +, -2.236836356069    
     +, -2.087521082226    
     +, -127.6265363627    
     +,  137.0644005139    
     +,  113.2277797245    
     +, -194.5929849015    
     +,  78.39368163094    
     +, -163.5927767079    
     +,  273.5548469079    
     +, -193.9898675298    
     +,  44.48177576985    
     +/
      A189_4jet_2_qq_msum = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         A189_4jet_2_qq_msum = A189_4jet_2_qq_msum + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) 
     +     A189_4jet_2_qq_msum = VCONST * EXP (A189_4jet_2_qq_msum)
      END
      DOUBLE PRECISION FUNCTION A189_4jet_2_qq_fvar(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  14, 1)
      DOUBLE PRECISION SIGDEL(  14)
      DOUBLE PRECISION SIGA(  14)
      DATA NPAR, NDIM, IMQFUN /   14,    1,    2/
      DATA VCONST /  28.00000000000    /
      DATA SIGVMI / -200.0000000000    /
      DATA SIGVT /  1400.000000000    /
      DATA SIGV / 0.2099999934435    
     +, 0.5899999737740    
     +, 0.8100000023842    
     +, 0.8899999856949    
     +, 0.9099999666214    
     +, 0.9300000071526    
     +, 0.9499999880791    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.3400000035763    
     +, 0.3799999952316    
     +, 0.5000000000000    
     +, 0.1199999973178    
     +, 0.6800000071526    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.1599999964237    
     +, 0.1599999964237    
     +/
      DATA SIGA /  75.07495064280    
     +,  5.044818094588    
     +, -4.228148402936    
     +, -65.35854279415    
     +,  193.0436903948    
     +, -426.4711224907    
     +,  256.2220589002    
     +,  193.2504886851    
     +,  41.68480184791    
     +,  63.96100850647    
     +, -33.00406226034    
     +,  1.091923694903    
     +, -313.2847748811    
     +,  2.717575304117    
     +/
      A189_4jet_2_qq_fvar = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         A189_4jet_2_qq_fvar = A189_4jet_2_qq_fvar + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) 
     +     A189_4jet_2_qq_fvar = VCONST * EXP (A189_4jet_2_qq_fvar)
      END
      DOUBLE PRECISION FUNCTION A189_4jet_3_qq_mh(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   6, 1)
      DOUBLE PRECISION SIGDEL(   6)
      DOUBLE PRECISION SIGA(   6)
      DATA NPAR, NDIM, IMQFUN /    6,    1,    2/
      DATA VCONST /  1.750000000000    /
      DATA SIGVMI /  35.00000000000    /
      DATA SIGVT /  70.00000000000    /
      DATA SIGV / 0.5124999880791    
     +, 0.5375000238419    
     +, 0.7875000238419    
     +, 0.8125000000000    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +/
      DATA SIGDEL / 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +/
      DATA SIGA /  4.633119328194    
     +, -4.683512255534    
     +,  29.64006089826    
     +, -51.82863784049    
     +,-0.8016500304034    
     +,  17.66471414448    
     +/
      A189_4jet_3_qq_mh = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         A189_4jet_3_qq_mh = A189_4jet_3_qq_mh + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) 
     +     A189_4jet_3_qq_mh = VCONST * EXP (A189_4jet_3_qq_mh)
      END
      DOUBLE PRECISION FUNCTION A189_4jet_3_qq_nn(V)
      DOUBLE PRECISION V

      A189_4jet_3_qq_nn = 21.102D0 + 43.743D0*V

      RETURN
      END
      DOUBLE PRECISION FUNCTION A189_4jet_1_ww_msum(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   5, 1)
      DOUBLE PRECISION SIGDEL(   5)
      DOUBLE PRECISION SIGA(   5)
      DATA NPAR, NDIM, IMQFUN /    5,    1,    2/
      DATA VCONST /  3.000000000000    /
      DATA SIGVMI /  20.00000000000    /
      DATA SIGVT /  180.0000000000    /
      DATA SIGV / 0.9416667222977    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.8833333849907    
     +, 0.7000000476837    
     +/
      DATA SIGDEL / 0.3333333507180E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.6666667014360E-01
     +, 0.1333333402872    
     +/
      DATA SIGA / -148.0803731143    
     +, -2.698887541036    
     +,  121.9050986609    
     +,  10.00756597942    
     +, -2.089333796391    
     +/
      A189_4jet_1_ww_msum = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         A189_4jet_1_ww_msum = A189_4jet_1_ww_msum + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) 
     +  A189_4jet_1_ww_msum = VCONST * EXP (A189_4jet_1_ww_msum)
      END
      DOUBLE PRECISION FUNCTION A189_4jet_1_ww_fvar(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   9, 1)
      DOUBLE PRECISION SIGDEL(   9)
      DOUBLE PRECISION SIGA(   9)
      DATA NPAR, NDIM, IMQFUN /    9,    1,    2/
      DATA VCONST /  28.00000000000    /
      DATA SIGVMI / -200.0000000000    /
      DATA SIGVT /  1400.000000000    /
      DATA SIGV / 0.3100000023842    
     +, 0.3700000047684    
     +, 0.6499999761581    
     +, 0.6699999570847    
     +, 0.6899999976158    
     +, 0.7099999785423    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.5399999618530    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +/
      DATA SIGA / -29.97337675184    
     +,  17.42510960126    
     +,  851.1767442594    
     +, -3398.066048742    
     +,  5790.173341440    
     +, -4075.923665794    
     +, -192.4300457699    
     +,  619.1926832818    
     +, -20.70785303865    
     +/
      A189_4jet_1_ww_fvar = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         A189_4jet_1_ww_fvar = A189_4jet_1_ww_fvar + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) 
     +  A189_4jet_1_ww_fvar = VCONST * EXP (A189_4jet_1_ww_fvar)
      END
      DOUBLE PRECISION FUNCTION A189_4jet_1_ww_mh(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   7, 1)
      DOUBLE PRECISION SIGDEL(   7)
      DOUBLE PRECISION SIGA(   7)
      DATA NPAR, NDIM, IMQFUN /    7,    1,    2/
      DATA VCONST /  1.750000000000    /
      DATA SIGVMI /  35.00000000000    /
      DATA SIGVT /  70.00000000000    /
      DATA SIGV / 0.5124999880791    
     +, 0.8625000119209    
     +, 0.9125000238419    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.4250000119209    
     +, 0.5749999880791    
     +/
      DATA SIGDEL / 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.1000000014901    
     +, 0.1000000014901    
     +/
      DATA SIGA / -13.21264320739    
     +, -8.630314181534    
     +, -38.95650249759    
     +, 0.5450217385028    
     +,  45.57792425310    
     +,  3.653973681274    
     +,  8.967016824148    
     +/
      A189_4jet_1_ww_mh = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         A189_4jet_1_ww_mh = A189_4jet_1_ww_mh + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) 
     +  A189_4jet_1_ww_mh = VCONST * EXP (A189_4jet_1_ww_mh)
      END
      DOUBLE PRECISION FUNCTION A189_4jet_1_ww_nn(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  12, 1)
      DOUBLE PRECISION SIGDEL(  12)
      DOUBLE PRECISION SIGA(  12)
      DATA NPAR, NDIM, IMQFUN /   12,    1,    2/
      DATA VCONST / 0.1999999955297E-01/
      DATA SIGVMI / 0.0000000000000E+00/
      DATA SIGVT /  1.000000000000    /
      DATA SIGV / 0.2999999932945E-01
     +, 0.4999999701977E-01
     +, 0.7000000029802E-01
     +, 0.7699999809265    
     +, 0.7899999618530    
     +, 0.8700000047684    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.1999999880791    
     +, 0.2800000011921    
     +, 0.5199999809265    
     +, 0.6800000071526    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.1599999964237    
     +, 0.1599999964237    
     +, 0.1599999964237    
     +, 0.1599999964237    
     +/
      DATA SIGA / -164.7193818868    
     +,  165.5300335913    
     +, -57.48994205642    
     +,  12.26031713982    
     +, -12.88875897458    
     +,  4.284638719908    
     +,  55.57566363203    
     +,  6.019954411894    
     +,  20.04707418656    
     +, -12.05034059246    
     +,  2.228900365689    
     +, -1.797661843276    
     +/
      A189_4jet_1_ww_nn = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         A189_4jet_1_ww_nn = A189_4jet_1_ww_nn + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) 
     +     A189_4jet_1_ww_nn = VCONST * EXP (A189_4jet_1_ww_nn)
      END
      DOUBLE PRECISION FUNCTION A189_4jet_2_ww_msum(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  22, 1)
      DOUBLE PRECISION SIGDEL(  22)
      DOUBLE PRECISION SIGA(  22)
      DATA NPAR, NDIM, IMQFUN /   22,    1,    2/
      DATA VCONST /  3.000000000000    /
      DATA SIGVMI /  20.00000000000    /
      DATA SIGVT /  180.0000000000    /
      DATA SIGV / 0.2583333551884    
     +, 0.7083333730698    
     +, 0.7250000238419    
     +, 0.7416667342186    
     +, 0.7583333849907    
     +, 0.7750000357628    
     +, 0.7916666865349    
     +, 0.8083333969116    
     +, 0.8250000476837    
     +, 0.8416666984558    
     +, 0.8750000596046    
     +, 0.9416667222977    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.5000000447035E-01
     +, 0.8333333581686E-01
     +, 0.1833333373070    
     +, 0.2166666835546    
     +, 0.3500000238419    
     +, 0.4333333671093    
     +, 0.5666667222977    
     +, 0.6333333849907    
     +/
      DATA SIGDEL / 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.1333333402872    
     +, 0.1333333402872    
     +, 0.1333333402872    
     +/
      DATA SIGA /  20.24743626076    
     +,  6.801993788634    
     +,  8.721808646231    
     +, -53.29030753750    
     +,  169.2346190583    
     +, -137.6883472569    
     +, -108.5930212749    
     +,  154.0314318000    
     +, -88.86600933352    
     +,  53.64082916138    
     +, -14.71694803739    
     +, -58.87195837345    
     +,  83.98165720771    
     +,  64.18027635270    
     +, -5.070663926365    
     +, -100.7243504095    
     +,  74.86278593945    
     +, -77.30756785591    
     +,  3.874441892970    
     +, -5.076776978013    
     +, -1.864692015440    
     +,  3.088290686403    
     +/
      A189_4jet_2_ww_msum = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         A189_4jet_2_ww_msum = A189_4jet_2_ww_msum + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) 
     +  A189_4jet_2_ww_msum = VCONST * EXP (A189_4jet_2_ww_msum)
      END
      DOUBLE PRECISION FUNCTION A189_4jet_2_ww_fvar(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  20, 1)
      DOUBLE PRECISION SIGDEL(  20)
      DOUBLE PRECISION SIGA(  20)
      DATA NPAR, NDIM, IMQFUN /   20,    1,    2/
      DATA VCONST /  28.00000000000    /
      DATA SIGVMI / -200.0000000000    /
      DATA SIGVT /  1400.000000000    /
      DATA SIGV / 0.3299999833107    
     +, 0.3700000047684    
     +, 0.3899999856949    
     +, 0.4099999964237    
     +, 0.5699999928474    
     +, 0.6499999761581    
     +, 0.7899999618530    
     +, 0.8100000023842    
     +, 0.8299999833107    
     +, 0.8899999856949    
     +, 0.9099999666214    
     +, 0.9300000071526    
     +, 0.9499999880791    
     +, 0.9699999690056    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.4599999785423    
     +, 0.5000000000000    
     +, 0.6999999880791    
     +, 0.7400000095367    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +/
      DATA SIGA /  28.50043473888    
     +, -25.68391992021    
     +, -29.47258853154    
     +,  53.33377801005    
     +, -3.689849020826    
     +, -1.247606410009    
     +,  4.712927707968    
     +, -4.895463989147    
     +,  9.154020223680    
     +,  79.54282183264    
     +, -117.9959388816    
     +,  42.05652078966    
     +,  1952.911587022    
     +, -4163.523237581    
     +, -4.693072193896    
     +,  2160.773092039    
     +, -60.50052403618    
     +,  36.06800733561    
     +, -3.914449724171    
     +,  11.85006212412    
     +/
      A189_4jet_2_ww_fvar = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         A189_4jet_2_ww_fvar = A189_4jet_2_ww_fvar + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) 
     +  A189_4jet_2_ww_fvar = VCONST * EXP (A189_4jet_2_ww_fvar)
      END
      DOUBLE PRECISION FUNCTION A189_4jet_3_ww_mh(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   5, 1)
      DOUBLE PRECISION SIGDEL(   5)
      DOUBLE PRECISION SIGA(   5)
      DATA NPAR, NDIM, IMQFUN /    5,    1,    2/
      DATA VCONST /  1.750000000000    /
      DATA SIGVMI /  35.00000000000    /
      DATA SIGVT /  70.00000000000    /
      DATA SIGV / 0.7624999880791    
     +, 0.8625000119209    
     +, 0.8874999880791    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +/
      DATA SIGDEL / 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +/
      DATA SIGA /  2.051653049109    
     +,  276.2942551211    
     +, -540.4563316593    
     +, -17.04593057835    
     +,  238.6821178016    
     +/
      A189_4jet_3_ww_mh = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         A189_4jet_3_ww_mh = A189_4jet_3_ww_mh + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) 
     +  A189_4jet_3_ww_mh = VCONST * EXP (A189_4jet_3_ww_mh)
      END
      DOUBLE PRECISION FUNCTION A189_4jet_3_ww_nn(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   5, 1)
      DOUBLE PRECISION SIGDEL(   5)
      DOUBLE PRECISION SIGA(   5)
      DATA NPAR, NDIM, IMQFUN /    5,    1,    2/
      DATA VCONST / 0.2500000037253E-01/
      DATA SIGVMI / 0.5000000000000    /
      DATA SIGVT / 0.5000000000000    /
      DATA SIGV / 0.2750000059605    
     +, 0.9250000119209    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.7500000000000    
     +/
      DATA SIGDEL / 0.1000000014901    
     +, 0.1000000014901    
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.2000000029802    
     +/
      DATA SIGA / 0.1237440006477    
     +, -4.453523391464    
     +,  7.881467047041    
     +,  11.12849848566    
     +,  2.377942731239    
     +/
      A189_4jet_3_ww_nn = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         A189_4jet_3_ww_nn = A189_4jet_3_ww_nn + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) 
     +     A189_4jet_3_ww_nn = VCONST * EXP (A189_4jet_3_ww_nn)
      END
      DOUBLE PRECISION FUNCTION A189_4jet_1_zz_msum(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   8, 1)
      DOUBLE PRECISION SIGDEL(   8)
      DOUBLE PRECISION SIGA(   8)
      DATA NPAR, NDIM, IMQFUN /    8,    1,    2/
      DATA VCONST /  6.000000000000    /
      DATA SIGVMI /  20.00000000000    /
      DATA SIGVT /  180.0000000000    /
      DATA SIGV / 0.6166666746140    
     +, 0.6500000357628    
     +, 0.8500000238419    
     +, 0.8833333849907    
     +, 0.9500000476837    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.3000000119209    
     +/
      DATA SIGDEL / 0.2000000141561E-01
     +, 0.2000000141561E-01
     +, 0.2000000141561E-01
     +, 0.2000000141561E-01
     +, 0.2000000141561E-01
     +, 0.6000000212225E-06
     +, 0.6000000212225E-06
     +, 0.4000000283122E-01
     +/
      DATA SIGA /  3.320494587861    
     +, -2.187003289320    
     +,  30.01994402631    
     +, -12.32106392170    
     +, -669.7462690286    
     +,  139.7173941397    
     +,  551.6355868319    
     +, -239.6758348201    
     +/
      A189_4jet_1_zz_msum = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         A189_4jet_1_zz_msum = A189_4jet_1_zz_msum + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) 
     +     A189_4jet_1_zz_msum = VCONST * EXP (A189_4jet_1_zz_msum)
      END
      DOUBLE PRECISION FUNCTION A189_4jet_1_zz_fvar(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  12, 1)
      DOUBLE PRECISION SIGDEL(  12)
      DOUBLE PRECISION SIGA(  12)
      DATA NPAR, NDIM, IMQFUN /   12,    1,    2/
      DATA VCONST /  28.00000000000    /
      DATA SIGVMI / -200.0000000000    /
      DATA SIGVT /  1400.000000000    /
      DATA SIGV / 0.1099999994040    
     +, 0.1700000017881    
     +, 0.2699999809265    
     +, 0.2899999916553    
     +, 0.4099999964237    
     +, 0.4899999797344    
     +, 0.6499999761581    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.5399999618530    
     +, 0.5799999833107    
     +, 0.6999999880791    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +/
      DATA SIGA / -256.5942464147    
     +,  39.32981335554    
     +,  13.59225042939    
     +, -12.88070101362    
     +,  9.685872245810    
     +, -27.62271992093    
     +, -56.06628189497    
     +,  190.6762542894    
     +, -21.51925028082    
     +,  4.880722165283    
     +,  12.73686263009    
     +,  53.59763385552    
     +/
      A189_4jet_1_zz_fvar = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         A189_4jet_1_zz_fvar = A189_4jet_1_zz_fvar + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) 
     +  A189_4jet_1_zz_fvar = VCONST * EXP (A189_4jet_1_zz_fvar)
      END
      DOUBLE PRECISION FUNCTION A189_4jet_1_zz_mh(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  10, 1)
      DOUBLE PRECISION SIGDEL(  10)
      DOUBLE PRECISION SIGA(  10)
      DATA NPAR, NDIM, IMQFUN /   10,    1,    2/
      DATA VCONST /  1.750000000000    /
      DATA SIGVMI /  35.00000000000    /
      DATA SIGVT /  70.00000000000    /
      DATA SIGV / 0.3125000000000    
     +, 0.3375000059605    
     +, 0.8874999880791    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.7500000298023E-01
     +, 0.1250000000000    
     +, 0.6750000119209    
     +, 0.7750000357628    
     +, 0.8249999880791    
     +/
      DATA SIGDEL / 0.1000000014901    
     +, 0.1000000014901    
     +, 0.1000000014901    
     +, 0.3999999989901E-05
     +, 0.3999999989901E-05
     +, 0.2000000029802    
     +, 0.2000000029802    
     +, 0.2000000029802    
     +, 0.2000000029802    
     +, 0.2000000029802    
     +/
      DATA SIGA / -6.397707904828    
     +,-0.2726657389968    
     +, -52.59188424902    
     +,  22.08259720349    
     +,  148.4694523496    
     +, -123.1923573236    
     +,  116.9659921546    
     +, -105.1328402708    
     +,  661.6707426127    
     +, -655.1535293180    
     +/
      A189_4jet_1_zz_mh = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         A189_4jet_1_zz_mh = A189_4jet_1_zz_mh + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) 
     +  A189_4jet_1_zz_mh = VCONST * EXP (A189_4jet_1_zz_mh)
      END
      DOUBLE PRECISION FUNCTION A189_4jet_1_zz_nn(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   8, 1)
      DOUBLE PRECISION SIGDEL(   8)
      DOUBLE PRECISION SIGA(   8)
      DATA NPAR, NDIM, IMQFUN /    8,    1,    2/
      DATA VCONST / 0.9999999776483E-02/
      DATA SIGVMI / 0.5000000000000    /
      DATA SIGVT / 0.5000000000000    /
      DATA SIGV / 0.7299999594688    
     +, 0.9499999880791    
     +, 0.9699999690056    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.7799999713898    
     +, 0.8199999928474    
     +, 0.1999999880791    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.1599999964237    
     +/
      DATA SIGA /  5.635852840126    
     +, -91.44546579900    
     +,  190.9875878303    
     +,  9.577453270432    
     +, -100.4336798945    
     +, -9.656020218849    
     +,  10.72897087153    
     +, -3.620263014040    
     +/
      A189_4jet_1_zz_nn = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         A189_4jet_1_zz_nn = A189_4jet_1_zz_nn + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) 
     +  A189_4jet_1_zz_nn = VCONST * EXP (A189_4jet_1_zz_nn)
      END
      DOUBLE PRECISION FUNCTION A189_4jet_2_zz_msum(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  15, 1)
      DOUBLE PRECISION SIGDEL(  15)
      DOUBLE PRECISION SIGA(  15)
      DATA NPAR, NDIM, IMQFUN /   15,    1,    2/
      DATA VCONST /  3.000000000000    /
      DATA SIGVMI /  20.00000000000    /
      DATA SIGVT /  180.0000000000    /
      DATA SIGV / 0.3416666984558    
     +, 0.6250000596046    
     +, 0.6416667103767    
     +, 0.8583333492279    
     +, 0.8750000596046    
     +, 0.8916667103767    
     +, 0.9083333611488    
     +, 0.9250000715256    
     +, 0.9416667222977    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.2166666835546    
     +, 0.4166666865349    
     +, 0.1000000089407    
     +, 0.7666667103767    
     +/
      DATA SIGDEL / 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.1333333402872    
     +, 0.1333333402872    
     +/
      DATA SIGA / -1.829207259508    
     +,  7.735073545136    
     +, -7.798796227781    
     +, -45.12224606384    
     +,  168.9396230132    
     +, -82.24143845619    
     +, -40.69444053099    
     +, -348.4054799070    
     +,  371.1247292081    
     +,  81.12211873657    
     +, -21.24751991478    
     +,  39.52867066401    
     +, -4.834509226542    
     +, -116.5090359191    
     +, -1.236480054138    
     +/
      A189_4jet_2_zz_msum = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         A189_4jet_2_zz_msum = A189_4jet_2_zz_msum + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) 
     +  A189_4jet_2_zz_msum = VCONST * EXP (A189_4jet_2_zz_msum)
      END
      DOUBLE PRECISION FUNCTION A189_4jet_2_zz_fvar(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  15, 1)
      DOUBLE PRECISION SIGDEL(  15)
      DOUBLE PRECISION SIGA(  15)
      DATA NPAR, NDIM, IMQFUN /   15,    1,    2/
      DATA VCONST /  28.00000000000    /
      DATA SIGVMI / -200.0000000000    /
      DATA SIGVT /  1400.000000000    /
      DATA SIGV / 0.5299999713898    
     +, 0.7699999809265    
     +, 0.8299999833107    
     +, 0.9099999666214    
     +, 0.9300000071526    
     +, 0.9499999880791    
     +, 0.9699999690056    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.2999999821186    
     +, 0.3799999952316    
     +, 0.4199999868870    
     +, 0.6200000047684    
     +, 0.1199999973178    
     +, 0.1999999880791    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.1599999964237    
     +, 0.1599999964237    
     +/
      DATA SIGA / -3.560225150413    
     +,  3.936734950426    
     +,-0.2096684118660    
     +,  84.50349235923    
     +, -295.1009449299    
     +,  964.7514486017    
     +, -1573.014369886    
     +,  934.5745820657    
     +,  805.0018718842    
     +, -145.0989356590    
     +,  13.48534035052    
     +, -28.39340182003    
     +,  5.777931678877    
     +, -2352.203703084    
     +,  1565.335191590    
     +/
      A189_4jet_2_zz_fvar = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         A189_4jet_2_zz_fvar = A189_4jet_2_zz_fvar + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) 
     +     A189_4jet_2_zz_fvar = VCONST * EXP (A189_4jet_2_zz_fvar)
      END
      DOUBLE PRECISION FUNCTION A189_4jet_3_zz_mh(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   9, 1)
      DOUBLE PRECISION SIGDEL(   9)
      DOUBLE PRECISION SIGA(   9)
      DATA NPAR, NDIM, IMQFUN /    9,    1,    2/
      DATA VCONST /  1.750000000000    /
      DATA SIGVMI /  35.00000000000    /
      DATA SIGVT /  70.00000000000    /
      DATA SIGV / 0.1625000089407    
     +, 0.4375000000000    
     +, 0.6374999880791    
     +, 0.8125000000000    
     +, 0.8874999880791    
     +, 0.9125000238419    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.7250000238419    
     +/
      DATA SIGDEL / 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.1000000014901    
     +/
      DATA SIGA /  1.546611480334    
     +, -1.447239722443    
     +,  2.185582087148    
     +, -18.13327462752    
     +, -187.0036068676    
     +,  213.0195162128    
     +,  1.293194678320    
     +, -22.36374895861    
     +,  10.60958114301    
     +/
      A189_4jet_3_zz_mh = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         A189_4jet_3_zz_mh = A189_4jet_3_zz_mh + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) 
     +  A189_4jet_3_zz_mh = VCONST * EXP (A189_4jet_3_zz_mh)
      END
      DOUBLE PRECISION FUNCTION A189_4jet_3_zz_nn(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  10, 1)
      DOUBLE PRECISION SIGDEL(  10)
      DOUBLE PRECISION SIGA(  10)
      DATA NPAR, NDIM, IMQFUN /   10,    1,    2/
      DATA VCONST / 0.9999999776483E-02/
      DATA SIGVMI / 0.5000000000000    /
      DATA SIGVT / 0.5000000000000    /
      DATA SIGV / 0.6699999570847    
     +, 0.9300000071526    
     +, 0.9699999690056    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.1999999880791    
     +, 0.2800000011921    
     +, 0.5199999809265    
     +, 0.7599999904633    
     +, 0.8399999737740    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.1599999964237    
     +, 0.1599999964237    
     +, 0.1599999964237    
     +, 0.1599999964237    
     +, 0.1599999964237    
     +/
      DATA SIGA / -4.317037433144    
     +,  8.636101092339    
     +,  12.80037233111    
     +,  10.58727061287    
     +, -10.79317390565    
     +, -3.448151971975    
     +,  3.140988952917    
     +,-0.8683862802209    
     +,  20.45317687010    
     +, -16.58457296536    
     +/
      A189_4jet_3_zz_nn = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         A189_4jet_3_zz_nn = A189_4jet_3_zz_nn + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) 
     +     A189_4jet_3_zz_nn = VCONST * EXP (A189_4jet_3_zz_nn)
      END
      DOUBLE PRECISION FUNCTION ha65_1_fvar(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  12, 1)
      DOUBLE PRECISION SIGDEL(  12)
      DOUBLE PRECISION SIGA(  12)
      DATA NPAR, NDIM, IMQFUN /   12,    1,    2/
      DATA VCONST /  28.00000000000    /
      DATA SIGVMI / -200.0000000000    /
      DATA SIGVT /  1400.000000000    /
      DATA SIGV / 0.8999999612570E-01
     +, 0.1099999994040    
     +, 0.1499999910593    
     +, 0.2500000000000    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.2999999821186    
     +, 0.3400000035763    
     +, 0.5399999618530    
     +, 0.5799999833107    
     +, 0.4399999976158    
     +, 0.6800000071526    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.1599999964237    
     +, 0.1599999964237    
     +/
      DATA SIGA / -433.7960728131    
     +,  6.206678794359    
     +,  62.33820469998    
     +,  36.25965664986    
     +,  277.1951203207    
     +,  255.4248689742    
     +, -103.7137994515    
     +,  78.79804506307    
     +, -58.47753529950    
     +,  244.0107980750    
     +,  37.77549873153    
     +, -589.7893538985    
     +/
      ha65_1_fvar = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         ha65_1_fvar = ha65_1_fvar + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) ha65_1_fvar = VCONST * EXP (ha65_1_fvar)
      END
      DOUBLE PRECISION FUNCTION ha65_1_mh(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  11, 1)
      DOUBLE PRECISION SIGDEL(  11)
      DOUBLE PRECISION SIGA(  11)
      DATA NPAR, NDIM, IMQFUN /   11,    1,    2/
      DATA VCONST /  1.750000000000    /
      DATA SIGVMI /  35.00000000000    /
      DATA SIGVT /  70.00000000000    /
      DATA SIGV / 0.6250000000000E-01
     +, 0.2874999940395    
     +, 0.3125000000000    
     +, 0.4625000059605    
     +, 0.4875000119209    
     +, 0.9125000238419    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.1250000000000    
     +, 0.2250000089407    
     +, 0.8249999880791    
     +/
      DATA SIGDEL / 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.1000000014901    
     +, 0.1000000014901    
     +, 0.1000000014901    
     +/
      DATA SIGA / -32.35211232863    
     +,  7.564142101179    
     +,-0.8956983875598E-01
     +, 0.8878867014759    
     +, -2.876963301186    
     +, -91.23077278013    
     +,  4.299920950002    
     +,  80.09850963871    
     +,  40.46496166134    
     +, -19.40624366244    
     +,  7.439838671325    
     +/
      ha65_1_mh = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         ha65_1_mh = ha65_1_mh + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) ha65_1_mh = VCONST * EXP (ha65_1_mh)
      END
      DOUBLE PRECISION FUNCTION ha65_1_msum(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  17, 1)
      DOUBLE PRECISION SIGDEL(  17)
      DOUBLE PRECISION SIGA(  17)
      DATA NPAR, NDIM, IMQFUN /   17,    1,    2/
      DATA VCONST /  3.000000000000    /
      DATA SIGVMI /  20.00000000000    /
      DATA SIGVT /  180.0000000000    /
      DATA SIGV / 0.3583333492279    
     +, 0.5583333373070    
     +, 0.5750000476837    
     +, 0.5916666984558    
     +, 0.6083333492279    
     +, 0.6416667103767    
     +, 0.6583333611488    
     +, 0.7083333730698    
     +, 0.7250000238419    
     +, 0.8083333969116    
     +, 0.9416667222977    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.3166666924953    
     +, 0.5166667103767    
     +, 0.8500000238419    
     +, 0.4333333671093    
     +/
      DATA SIGDEL / 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.1333333402872    
     +/
      DATA SIGA /  42.68672556020    
     +,  61.64266985727    
     +, -147.0499040476    
     +,  392.6462264500    
     +, -489.3164412052    
     +,  310.0095507247    
     +, -163.3799695982    
     +,  81.25879061579    
     +, -50.48734850563    
     +,  11.62725472222    
     +, -106.6175422180    
     +,  34.12464959397    
     +,  89.59377052977    
     +, -68.79660596263    
     +,  15.37249109359    
     +, -8.064530018521    
     +, -40.88582500033    
     +/
      ha65_1_msum = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         ha65_1_msum = ha65_1_msum + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) ha65_1_msum = VCONST * EXP (ha65_1_msum)
      END
      DOUBLE PRECISION FUNCTION ha65_1_nn(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  11, 1)
      DOUBLE PRECISION SIGDEL(  11)
      DOUBLE PRECISION SIGA(  11)
      DATA NPAR, NDIM, IMQFUN /   11,    1,    2/
      DATA VCONST / 0.9999999776483E-02/
      DATA SIGVMI / 0.5000000000000    /
      DATA SIGVT / 0.5000000000000    /
      DATA SIGV / 0.8999999612570E-01
     +, 0.1099999994040    
     +, 0.2099999934435    
     +, 0.2299999892712    
     +, 0.5699999928474    
     +, 0.7500000000000    
     +, 0.9499999880791    
     +, 0.9699999690056    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.8999999761581    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +/
      DATA SIGA / -3.451192895658    
     +,  6.640115485067    
     +, -14.95219124689    
     +,  12.04017361587    
     +, 0.8450076277304    
     +,-0.7264982227847    
     +, -93.06378206725    
     +,  168.5938315927    
     +,  9.112788698597    
     +, -77.51892243614    
     +,  9.910826045687    
     +/
      ha65_1_nn = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         ha65_1_nn = ha65_1_nn + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) ha65_1_nn = VCONST * EXP (ha65_1_nn)
      END
      DOUBLE PRECISION FUNCTION ha70_1_fvar(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  16, 1)
      DOUBLE PRECISION SIGDEL(  16)
      DOUBLE PRECISION SIGA(  16)
      DATA NPAR, NDIM, IMQFUN /   16,    1,    2/
      DATA VCONST /  28.00000000000    /
      DATA SIGVMI / -200.0000000000    /
      DATA SIGVT /  1400.000000000    /
      DATA SIGV / 0.8999999612570E-01
     +, 0.1099999994040    
     +, 0.1299999952316    
     +, 0.1700000017881    
     +, 0.3100000023842    
     +, 0.3299999833107    
     +, 0.3499999940395    
     +, 0.3700000047684    
     +, 0.3899999856949    
     +, 0.4099999964237    
     +, 0.5500000119209    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.2199999988079    
     +, 0.2599999904633    
     +, 0.6800000071526    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.1599999964237    
     +/
      DATA SIGA / -194.6240343150    
     +, -407.6786403609    
     +,  316.5234529356    
     +, -91.67240571231    
     +, -9.957805499316    
     +,  121.5749838657    
     +, -264.2781985068    
     +,  340.3599551278    
     +, -239.3810415077    
     +,  105.3591640386    
     +,  107.7624942727    
     +,  194.0351517947    
     +,  347.9428758054    
     +,  189.1852827830    
     +, -132.8059175590    
     +, -638.6767785662    
     +/
      ha70_1_fvar = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         ha70_1_fvar = ha70_1_fvar + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) ha70_1_fvar = VCONST * EXP (ha70_1_fvar)
      END
      DOUBLE PRECISION FUNCTION ha70_1_mh(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  11, 1)
      DOUBLE PRECISION SIGDEL(  11)
      DOUBLE PRECISION SIGA(  11)
      DATA NPAR, NDIM, IMQFUN /   11,    1,    2/
      DATA VCONST /  1.750000000000    /
      DATA SIGVMI /  35.00000000000    /
      DATA SIGVT /  70.00000000000    /
      DATA SIGV / 0.6250000000000E-01
     +, 0.8749999850988E-01
     +, 0.3375000059605    
     +, 0.3625000119209    
     +, 0.8625000119209    
     +, 0.9125000238419    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.1749999970198    
     +, 0.2750000059605    
     +, 0.7500000000000    
     +/
      DATA SIGDEL / 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.1000000014901    
     +, 0.1000000014901    
     +, 0.2000000029802    
     +/
      DATA SIGA / -20.37169872704    
     +,  27.00881189857    
     +,  1.354912816466    
     +, -6.292054460041    
     +,  7.964503167279    
     +, -103.6243797036    
     +,  5.210764613261    
     +,  88.55644519107    
     +, -31.58025840228    
     +,  22.72447495054    
     +,  2.771530364898    
     +/
      ha70_1_mh = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         ha70_1_mh = ha70_1_mh + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) ha70_1_mh = VCONST * EXP (ha70_1_mh)
      END
      DOUBLE PRECISION FUNCTION ha70_1_msum(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  18, 1)
      DOUBLE PRECISION SIGDEL(  18)
      DOUBLE PRECISION SIGA(  18)
      DATA NPAR, NDIM, IMQFUN /   18,    1,    2/
      DATA VCONST /  3.000000000000    /
      DATA SIGVMI /  20.00000000000    /
      DATA SIGVT /  180.0000000000    /
      DATA SIGV / 0.5583333373070    
     +, 0.5750000476837    
     +, 0.6083333492279    
     +, 0.6250000596046    
     +, 0.6416667103767    
     +, 0.6583333611488    
     +, 0.6750000119209    
     +, 0.6916667222977    
     +, 0.7083333730698    
     +, 0.9416667222977    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.7500000596046    
     +, 0.7833333611488    
     +, 0.8166667222977    
     +, 0.3000000119209    
     +, 0.3666666746140    
     +, 0.4333333671093    
     +/
      DATA SIGDEL / 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.1333333402872    
     +, 0.1333333402872    
     +, 0.1333333402872    
     +/
      DATA SIGA /  4.123884788299    
     +, -23.19180659987    
     +,  140.9692019681    
     +, -372.5442757493    
     +,  742.4651110707    
     +, -833.0690349880    
     +,  320.3731557497    
     +,  1.346678671704    
     +, -10.79168664392    
     +, -93.76750255023    
     +, -5.957841366701    
     +,  84.81654976563    
     +,  81.61584157207    
     +, -88.32039283927    
     +,  31.44768707339    
     +,  106.5983720516    
     +, -157.5775549758    
     +,  55.44060412647    
     +/
      ha70_1_msum = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         ha70_1_msum = ha70_1_msum + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) ha70_1_msum = VCONST * EXP (ha70_1_msum)
      END
      DOUBLE PRECISION FUNCTION ha70_1_nn(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  11, 1)
      DOUBLE PRECISION SIGDEL(  11)
      DOUBLE PRECISION SIGA(  11)
      DATA NPAR, NDIM, IMQFUN /   11,    1,    2/
      DATA VCONST / 0.9999999776483E-02/
      DATA SIGVMI / 0.5000000000000    /
      DATA SIGVT / 0.5000000000000    /
      DATA SIGV / 0.4699999988079    
     +, 0.4899999797344    
     +, 0.5299999713898    
     +, 0.5500000119209    
     +, 0.7899999618530    
     +, 0.9499999880791    
     +, 0.9699999690056    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.7400000095367    
     +, 0.8599999547005    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +/
      DATA SIGA /  40.07253138693    
     +, -64.65743710355    
     +,  43.67670452236    
     +, -18.58790489532    
     +, -2.554419290168    
     +, -59.78923053820    
     +,  124.7494683429    
     +,  9.311976165863    
     +, -62.00682724154    
     +,  1.649845623164    
     +,  5.890150259563    
     +/
      ha70_1_nn = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         ha70_1_nn = ha70_1_nn + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) ha70_1_nn = VCONST * EXP (ha70_1_nn)
      END
      DOUBLE PRECISION FUNCTION ha75_1_fvar(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  11, 1)
      DOUBLE PRECISION SIGDEL(  11)
      DOUBLE PRECISION SIGA(  11)
      DATA NPAR, NDIM, IMQFUN /   11,    1,    2/
      DATA VCONST /  28.00000000000    /
      DATA SIGVMI / -200.0000000000    /
      DATA SIGVT /  1400.000000000    /
      DATA SIGV / 0.8999999612570E-01
     +, 0.1099999994040    
     +, 0.1499999910593    
     +, 0.3899999856949    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.2999999821186    
     +, 0.3400000035763    
     +, 0.5000000000000    
     +, 0.5999999642372    
     +, 0.6800000071526    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.1599999964237    
     +, 0.1599999964237    
     +/
      DATA SIGA /  185.4081065094    
     +, -331.3484007085    
     +,  57.69410110777    
     +,  30.19207628398    
     +,  7.842793525440    
     +,  261.6308093924    
     +,  28.19192714304    
     +, -67.11374147559    
     +, -117.8569803531    
     +,  734.4072044063    
     +, -948.3018963401    
     +/
      ha75_1_fvar = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         ha75_1_fvar = ha75_1_fvar + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) ha75_1_fvar = VCONST * EXP (ha75_1_fvar)
      END
      DOUBLE PRECISION FUNCTION ha75_1_mh(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  12, 1)
      DOUBLE PRECISION SIGDEL(  12)
      DOUBLE PRECISION SIGA(  12)
      DATA NPAR, NDIM, IMQFUN /   12,    1,    2/
      DATA VCONST /  1.750000000000    /
      DATA SIGVMI /  35.00000000000    /
      DATA SIGVT /  70.00000000000    /
      DATA SIGV / 0.8749999850988E-01
     +, 0.1125000044703    
     +, 0.2374999970198    
     +, 0.4124999940395    
     +, 0.4375000000000    
     +, 0.5124999880791    
     +, 0.8625000119209    
     +, 0.9125000238419    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.3250000178814    
     +, 0.7500000000000    
     +/
      DATA SIGDEL / 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.1000000014901    
     +, 0.2000000029802    
     +/
      DATA SIGA / -19.73605248693    
     +,  16.97424227607    
     +,  10.59124269880    
     +,  13.18161424885    
     +, -2.711135902731    
     +, 0.4734269340352    
     +,  60.67693436163    
     +, -266.0584729655    
     +, -2.996343640685    
     +,  189.3384947456    
     +, -25.56082246751    
     +,  6.761288922360    
     +/
      ha75_1_mh = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         ha75_1_mh = ha75_1_mh + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) ha75_1_mh = VCONST * EXP (ha75_1_mh)
      END
      DOUBLE PRECISION FUNCTION ha75_1_msum(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  12, 1)
      DOUBLE PRECISION SIGDEL(  12)
      DOUBLE PRECISION SIGA(  12)
      DATA NPAR, NDIM, IMQFUN /   12,    1,    2/
      DATA VCONST /  3.000000000000    /
      DATA SIGVMI /  20.00000000000    /
      DATA SIGVT /  180.0000000000    /
      DATA SIGV / 0.6750000119209    
     +, 0.6916667222977    
     +, 0.7083333730698    
     +, 0.7250000238419    
     +, 0.7416667342186    
     +, 0.7750000357628    
     +, 0.8083333969116    
     +, 0.9416667222977    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.3166666924953    
     +, 0.5666667222977    
     +/
      DATA SIGDEL / 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.6666667014360E-01
     +, 0.1333333402872    
     +/
      DATA SIGA / -89.85562462343    
     +,  400.6963987913    
     +, -399.7880533677    
     +, -93.88276690831    
     +,  209.5641229245    
     +, -58.53946551918    
     +,  30.82076097076    
     +, -93.29429626308    
     +,  18.04356622650    
     +,  78.55423116002    
     +, -26.53293286729    
     +,-0.9558855899637    
     +/
      ha75_1_msum = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         ha75_1_msum = ha75_1_msum + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) ha75_1_msum = VCONST * EXP (ha75_1_msum)
      END
      DOUBLE PRECISION FUNCTION ha75_1_nn(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  12, 1)
      DOUBLE PRECISION SIGDEL(  12)
      DOUBLE PRECISION SIGA(  12)
      DATA NPAR, NDIM, IMQFUN /   12,    1,    2/
      DATA VCONST / 0.9999999776483E-02/
      DATA SIGVMI / 0.5000000000000    /
      DATA SIGVT / 0.5000000000000    /
      DATA SIGV / 0.1899999976158    
     +, 0.2099999934435    
     +, 0.2299999892712    
     +, 0.2500000000000    
     +, 0.2699999809265    
     +, 0.9300000071526    
     +, 0.9699999690056    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.6800000071526    
     +, 0.7599999904633    
     +, 0.8399999737740    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.1599999964237    
     +, 0.1599999964237    
     +, 0.1599999964237    
     +/
      DATA SIGA /  29.37216453827    
     +, -68.91320429849    
     +,  31.16773907631    
     +,  37.14722000559    
     +, -26.54828896144    
     +, -11.31618681369    
     +,  62.29549490805    
     +,  8.486386625901    
     +, -45.70375935243    
     +, -5.951592751501    
     +,  11.03420032896    
     +, -2.871040159963    
     +/
      ha75_1_nn = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         ha75_1_nn = ha75_1_nn + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) ha75_1_nn = VCONST * EXP (ha75_1_nn)
      END
      DOUBLE PRECISION FUNCTION ha80_1_fvar(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  10, 1)
      DOUBLE PRECISION SIGDEL(  10)
      DOUBLE PRECISION SIGA(  10)
      DATA NPAR, NDIM, IMQFUN /   10,    1,    2/
      DATA VCONST /  28.00000000000    /
      DATA SIGVMI / -200.0000000000    /
      DATA SIGVT /  1400.000000000    /
      DATA SIGV / 0.8999999612570E-01
     +, 0.1099999994040    
     +, 0.2099999934435    
     +, 0.2299999892712    
     +, 0.5299999713898    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.2999999821186    
     +, 0.3799999952316    
     +, 0.6800000071526    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.1599999964237    
     +/
      DATA SIGA / -3679.405795086    
     +,  1708.576188985    
     +,  27.55357415825    
     +,  19.59201760611    
     +, -7.336029872805    
     +,  1773.119622766    
     +, -74.91753161289    
     +, -21.91503024218    
     +,  24.04293268599    
     +, -62.44108228562    
     +/
      ha80_1_fvar = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         ha80_1_fvar = ha80_1_fvar + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) ha80_1_fvar = VCONST * EXP (ha80_1_fvar)
      END
      DOUBLE PRECISION FUNCTION ha80_1_mh(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   8, 1)
      DOUBLE PRECISION SIGDEL(   8)
      DOUBLE PRECISION SIGA(   8)
      DATA NPAR, NDIM, IMQFUN /    8,    1,    2/
      DATA VCONST /  1.750000000000    /
      DATA SIGVMI /  35.00000000000    /
      DATA SIGVT /  70.00000000000    /
      DATA SIGV / 0.1125000044703    
     +, 0.4625000059605    
     +, 0.7375000119209    
     +, 0.9125000238419    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.3750000000000    
     +, 0.5749999880791    
     +/
      DATA SIGDEL / 0.1500000059605E-01
     +, 0.1500000059605E-01
     +, 0.1500000059605E-01
     +, 0.1500000059605E-01
     +, 0.6000000212225E-06
     +, 0.6000000212225E-06
     +, 0.3000000119209E-01
     +, 0.3000000119209E-01
     +/
      DATA SIGA /-0.8245994910626    
     +, -12.77415199207    
     +,-0.7663301923904    
     +, -237.0127488689    
     +, -14.17866720430    
     +,  219.6253317191    
     +,  5.182333768222    
     +,  5.375285196729    
     +/
      ha80_1_mh = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         ha80_1_mh = ha80_1_mh + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) ha80_1_mh = VCONST * EXP (ha80_1_mh)
      END
      DOUBLE PRECISION FUNCTION ha80_1_msum(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  15, 1)
      DOUBLE PRECISION SIGDEL(  15)
      DOUBLE PRECISION SIGA(  15)
      DATA NPAR, NDIM, IMQFUN /   15,    1,    2/
      DATA VCONST /  3.000000000000    /
      DATA SIGVMI /  20.00000000000    /
      DATA SIGVT /  180.0000000000    /
      DATA SIGV / 0.3916666805744    
     +, 0.7250000238419    
     +, 0.7416667342186    
     +, 0.7583333849907    
     +, 0.7750000357628    
     +, 0.7916666865349    
     +, 0.8083333969116    
     +, 0.8250000476837    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.3500000238419    
     +, 0.6500000357628    
     +, 0.8833333849907    
     +, 0.9500000476837    
     +, 0.5666667222977    
     +/
      DATA SIGDEL / 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.1333333402872    
     +/
      DATA SIGA / -7.940567481055    
     +, -15.53370385693    
     +,  112.0278830709    
     +,  149.6784823633    
     +, -688.1162093183    
     +,  584.8137653871    
     +, -168.5421216953    
     +,  8.106005998345    
     +,  14.64817664985    
     +,  180.7341035705    
     +, -11.58500105033    
     +,  2.790322349675    
     +,  97.02660183986    
     +, -272.4166324141    
     +, -5.320783316651    
     +/
      ha80_1_msum = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         ha80_1_msum = ha80_1_msum + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) ha80_1_msum = VCONST * EXP (ha80_1_msum)
      END
      DOUBLE PRECISION FUNCTION ha80_1_nn(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  12, 1)
      DOUBLE PRECISION SIGDEL(  12)
      DOUBLE PRECISION SIGA(  12)
      DATA NPAR, NDIM, IMQFUN /   12,    1,    2/
      DATA VCONST / 0.9999999776483E-02/
      DATA SIGVMI / 0.5000000000000    /
      DATA SIGVT / 0.5000000000000    /
      DATA SIGV / 0.2999999932945E-01
     +, 0.5099999904633    
     +, 0.5299999713898    
     +, 0.7699999809265    
     +, 0.9099999666214    
     +, 0.9699999690056    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.1400000005960    
     +, 0.2999999821186    
     +, 0.4599999785423    
     +, 0.8199999928474    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +/
      DATA SIGA / -35.19093215389    
     +, -34.56680589411    
     +,  15.73135683424    
     +, -8.761466101629    
     +, -20.62574694853    
     +,  62.56537866928    
     +,  30.35494418971    
     +, -46.03487675917    
     +,  22.81050602662    
     +, -16.12333560915    
     +,  27.79769437745    
     +,  18.91150709756    
     +/
      ha80_1_nn = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         ha80_1_nn = ha80_1_nn + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) ha80_1_nn = VCONST * EXP (ha80_1_nn)
      END
      DOUBLE PRECISION FUNCTION ha85_1_fvar(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  12, 1)
      DOUBLE PRECISION SIGDEL(  12)
      DOUBLE PRECISION SIGA(  12)
      DATA NPAR, NDIM, IMQFUN /   12,    1,    2/
      DATA VCONST /  28.00000000000    /
      DATA SIGVMI / -200.0000000000    /
      DATA SIGVT /  1400.000000000    /
      DATA SIGV / 0.8999999612570E-01
     +, 0.1099999994040    
     +, 0.1499999910593    
     +, 0.4899999797344    
     +, 0.5699999928474    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.2199999988079    
     +, 0.2999999821186    
     +, 0.3799999952316    
     +, 0.4199999868870    
     +, 0.6200000047684    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +/
      DATA SIGA / -13.53094910734    
     +, -131.7885724321    
     +, -14.00360705333    
     +, -12.08434651820    
     +,  1.505299075665    
     +,  118.4467971972    
     +, -5.718064248620    
     +,  44.81475404751    
     +, -41.63752514873    
     +,  12.54146904403    
     +,  2.792400975169    
     +, 0.7088444983058    
     +/
      ha85_1_fvar = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         ha85_1_fvar = ha85_1_fvar + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) ha85_1_fvar = VCONST * EXP (ha85_1_fvar)
      END
      DOUBLE PRECISION FUNCTION ha85_1_mh(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  13, 1)
      DOUBLE PRECISION SIGDEL(  13)
      DOUBLE PRECISION SIGA(  13)
      DATA NPAR, NDIM, IMQFUN /   13,    1,    2/
      DATA VCONST /  1.750000000000    /
      DATA SIGVMI /  35.00000000000    /
      DATA SIGVT /  70.00000000000    /
      DATA SIGV / 0.1875000000000    
     +, 0.5625000000000    
     +, 0.5875000357628    
     +, 0.6125000119209    
     +, 0.7375000119209    
     +, 0.8874999880791    
     +, 0.9125000238419    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.7500000298023E-01
     +, 0.4749999940395    
     +, 0.6750000119209    
     +, 0.3499999940395    
     +/
      DATA SIGDEL / 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.1000000014901    
     +, 0.1000000014901    
     +, 0.1000000014901    
     +, 0.2000000029802    
     +/
      DATA SIGA / -9.373223601426    
     +,  48.82984663524    
     +, -81.15940059171    
     +,  19.97660670288    
     +,  7.268205247994    
     +,  62.97045510679    
     +, -207.2383798226    
     +, -15.36294931535    
     +,  132.6433971128    
     +,  19.27520514311    
     +, -2.316565447227    
     +,  6.834778974528    
     +,  3.257446568475    
     +/
      ha85_1_mh = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         ha85_1_mh = ha85_1_mh + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) ha85_1_mh = VCONST * EXP (ha85_1_mh)
      END
      DOUBLE PRECISION FUNCTION ha85_1_msum(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  14, 1)
      DOUBLE PRECISION SIGDEL(  14)
      DOUBLE PRECISION SIGA(  14)
      DATA NPAR, NDIM, IMQFUN /   14,    1,    2/
      DATA VCONST /  3.000000000000    /
      DATA SIGVMI /  20.00000000000    /
      DATA SIGVT /  180.0000000000    /
      DATA SIGV / 0.3583333492279    
     +, 0.4083333611488    
     +, 0.6083333492279    
     +, 0.7750000357628    
     +, 0.7916666865349    
     +, 0.8250000476837    
     +, 0.8416666984558    
     +, 0.8583333492279    
     +, 0.8750000596046    
     +, 0.9416667222977    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.2833333611488    
     +, 0.6833333969116    
     +/
      DATA SIGDEL / 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +/
      DATA SIGA / -15.01236026111    
     +, -5.913842688230    
     +, -3.743809504681    
     +, -67.09996515666    
     +,  234.0007355414    
     +, -528.6463447924    
     +,  537.0110580647    
     +, -341.6197238226    
     +,  202.3942377115    
     +, -244.2583329666    
     +,  17.38358504181    
     +,  185.0176757547    
     +, -13.67890616922    
     +,  5.668946386171    
     +/
      ha85_1_msum = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         ha85_1_msum = ha85_1_msum + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) ha85_1_msum = VCONST * EXP (ha85_1_msum)
      END
      DOUBLE PRECISION FUNCTION ha85_1_nn(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  12, 1)
      DOUBLE PRECISION SIGDEL(  12)
      DOUBLE PRECISION SIGA(  12)
      DATA NPAR, NDIM, IMQFUN /   12,    1,    2/
      DATA VCONST / 0.9999999776483E-02/
      DATA SIGVMI / 0.5000000000000    /
      DATA SIGVT / 0.5000000000000    /
      DATA SIGV / 0.4899999797344    
     +, 0.9499999880791    
     +, 0.9699999690056    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.3799999952316    
     +, 0.4199999868870    
     +, 0.5399999618530    
     +, 0.7400000095367    
     +, 0.7799999713898    
     +, 0.8199999928474    
     +, 0.8999999761581    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +/
      DATA SIGA /-0.9477566279379    
     +, -87.63072677305    
     +,  144.5501508108    
     +,  9.949976049705    
     +, -71.87912415849    
     +, -42.96870571236    
     +,  57.42663268192    
     +, -17.33789355428    
     +,  39.95254660590    
     +, -64.92424142812    
     +,  26.30541388193    
     +,  22.88292005026    
     +/
      ha85_1_nn = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         ha85_1_nn = ha85_1_nn + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) ha85_1_nn = VCONST * EXP (ha85_1_nn)
      END
      DOUBLE PRECISION FUNCTION ha90_1_fvar(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  10, 1)
      DOUBLE PRECISION SIGDEL(  10)
      DOUBLE PRECISION SIGA(  10)
      DATA NPAR, NDIM, IMQFUN /   10,    1,    2/
      DATA VCONST /  28.00000000000    /
      DATA SIGVMI / -200.0000000000    /
      DATA SIGVT /  1400.000000000    /
      DATA SIGV / 0.8999999612570E-01
     +, 0.1099999994040    
     +, 0.1499999910593    
     +, 0.3299999833107    
     +, 0.3899999856949    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.5000000000000    
     +, 0.5799999833107    
     +, 0.6800000071526    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.1599999964237    
     +/
      DATA SIGA /  690.7070611647    
     +, -727.0933249179    
     +,  95.73313039219    
     +, -13.06345371787    
     +,  7.673085411166    
     +, -65.18425766045    
     +, -8.548501843842    
     +, -16.50359782700    
     +, -16.94064093700    
     +,  37.35067474467    
     +/
      ha90_1_fvar = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         ha90_1_fvar = ha90_1_fvar + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) ha90_1_fvar = VCONST * EXP (ha90_1_fvar)
      END
      DOUBLE PRECISION FUNCTION ha90_1_mh(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  13, 1)
      DOUBLE PRECISION SIGDEL(  13)
      DOUBLE PRECISION SIGA(  13)
      DATA NPAR, NDIM, IMQFUN /   13,    1,    2/
      DATA VCONST /  1.750000000000    /
      DATA SIGVMI /  35.00000000000    /
      DATA SIGVT /  70.00000000000    /
      DATA SIGV / 0.3125000000000    
     +, 0.4375000000000    
     +, 0.4625000059605    
     +, 0.6875000000000    
     +, 0.7125000357628    
     +, 0.7375000119209    
     +, 0.7624999880791    
     +, 0.7875000238419    
     +, 0.8874999880791    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.6250000000000    
     +, 0.1500000059605    
     +/
      DATA SIGDEL / 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.1000000014901    
     +, 0.2000000029802    
     +/
      DATA SIGA / -5.695543029627    
     +,  1.819360769622    
     +, -2.892927644560    
     +,  14.34349931261    
     +,  76.83237522597    
     +, -231.0883379246    
     +,  146.8524637060    
     +, -17.51528835093    
     +, -39.27027245715    
     +, -4.090850894504    
     +,  40.16204892908    
     +,  6.795610705645    
     +,  8.952818145327    
     +/
      ha90_1_mh = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         ha90_1_mh = ha90_1_mh + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) ha90_1_mh = VCONST * EXP (ha90_1_mh)
      END
      DOUBLE PRECISION FUNCTION ha90_1_msum(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  15, 1)
      DOUBLE PRECISION SIGDEL(  15)
      DOUBLE PRECISION SIGA(  15)
      DATA NPAR, NDIM, IMQFUN /   15,    1,    2/
      DATA VCONST /  3.000000000000    /
      DATA SIGVMI /  20.00000000000    /
      DATA SIGVT /  180.0000000000    /
      DATA SIGV / 0.3583333492279    
     +, 0.4250000119209    
     +, 0.7083333730698    
     +, 0.8416666984558    
     +, 0.8583333492279    
     +, 0.8750000596046    
     +, 0.8916667103767    
     +, 0.9083333611488    
     +, 0.9250000715256    
     +, 0.9416667222977    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.7833333611488    
     +, 0.2333333492279    
     +, 0.5666667222977    
     +/
      DATA SIGDEL / 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.6666667014360E-01
     +, 0.1333333402872    
     +, 0.1333333402872    
     +/
      DATA SIGA / -40.99292343830    
     +, -6.811677192631    
     +,-0.4302946583043    
     +, -100.2626215040    
     +,  679.8563409376    
     +, -1104.319399066    
     +,  402.1777973667    
     +,  439.4071928391    
     +, -621.0961585208    
     +,  268.7754121133    
     +, -20.46837934401    
     +,  26.39443191952    
     +,  2.387826669697    
     +,  67.55521964025    
     +, -6.239631969481    
     +/
      ha90_1_msum = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         ha90_1_msum = ha90_1_msum + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) ha90_1_msum = VCONST * EXP (ha90_1_msum)
      END
      DOUBLE PRECISION FUNCTION ha90_1_nn(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   9, 1)
      DOUBLE PRECISION SIGDEL(   9)
      DOUBLE PRECISION SIGA(   9)
      DATA NPAR, NDIM, IMQFUN /    9,    1,    2/
      DATA VCONST / 0.9999999776483E-02/
      DATA SIGVMI / 0.5000000000000    /
      DATA SIGVT / 0.5000000000000    /
      DATA SIGV / 0.2899999916553    
     +, 0.8100000023842    
     +, 0.9499999880791    
     +, 0.9699999690056    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.3400000035763    
     +, 0.7400000095367    
     +, 0.8999999761581    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +/
      DATA SIGA / -7.826257412242    
     +, -10.48388146119    
     +, -140.2019021742    
     +,  247.2287502425    
     +,  9.084691638276    
     +, -118.4708213062    
     +,  7.301255806070    
     +,  7.350315831159    
     +,  20.17917885805    
     +/
      ha90_1_nn = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         ha90_1_nn = ha90_1_nn + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) ha90_1_nn = VCONST * EXP (ha90_1_nn)
      END
      DOUBLE PRECISION FUNCTION ha95_1_fvar(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  11, 1)
      DOUBLE PRECISION SIGDEL(  11)
      DOUBLE PRECISION SIGA(  11)
      DATA NPAR, NDIM, IMQFUN /   11,    1,    2/
      DATA VCONST /  28.00000000000    /
      DATA SIGVMI / -200.0000000000    /
      DATA SIGVT /  1400.000000000    /
      DATA SIGV / 0.8999999612570E-01
     +, 0.1099999994040    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.1799999922514    
     +, 0.2599999904633    
     +, 0.2999999821186    
     +, 0.3799999952316    
     +, 0.5399999618530    
     +, 0.5799999833107    
     +, 0.6599999666214    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +/
      DATA SIGA / -1917.258587976    
     +,  818.5343506060    
     +,  948.7626313632    
     +,  13.51522660359    
     +,  21.88931171516    
     +,  72.30702105332    
     +, -77.61090477702    
     +,  27.78675881225    
     +, -82.65268192751    
     +,  151.3635965943    
     +, -190.2223469486    
     +/
      ha95_1_fvar = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         ha95_1_fvar = ha95_1_fvar + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) ha95_1_fvar = VCONST * EXP (ha95_1_fvar)
      END
      DOUBLE PRECISION FUNCTION ha95_1_mh(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  10, 1)
      DOUBLE PRECISION SIGDEL(  10)
      DOUBLE PRECISION SIGA(  10)
      DATA NPAR, NDIM, IMQFUN /   10,    1,    2/
      DATA VCONST /  1.750000000000    /
      DATA SIGVMI /  35.00000000000    /
      DATA SIGVT /  70.00000000000    /
      DATA SIGV / 0.1875000000000    
     +, 0.8125000000000    
     +, 0.8375000357628    
     +, 0.8625000119209    
     +, 0.8874999880791    
     +, 0.9125000238419    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.3499999940395    
     +, 0.5500000119209    
     +/
      DATA SIGDEL / 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.2000000029802    
     +, 0.2000000029802    
     +/
      DATA SIGA / 0.6888287788055    
     +, -42.55369692349    
     +,  258.3950677324    
     +, -76.98431209049    
     +, -824.8677010910    
     +,  770.6197223871    
     +,  2.188434579110    
     +, -82.58179454252    
     +,  2.394206932684    
     +, -5.709607024160    
     +/
      ha95_1_mh = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         ha95_1_mh = ha95_1_mh + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) ha95_1_mh = VCONST * EXP (ha95_1_mh)
      END
      DOUBLE PRECISION FUNCTION ha95_1_msum(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   8, 1)
      DOUBLE PRECISION SIGDEL(   8)
      DOUBLE PRECISION SIGA(   8)
      DATA NPAR, NDIM, IMQFUN /    8,    1,    2/
      DATA VCONST /  3.000000000000    /
      DATA SIGVMI /  20.00000000000    /
      DATA SIGVT /  180.0000000000    /
      DATA SIGV / 0.6416667103767    
     +, 0.8916667103767    
     +, 0.9250000715256    
     +, 0.9416667222977    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.3166666924953    
     +, 0.3500000238419    
     +/
      DATA SIGDEL / 0.3000000119209E-01
     +, 0.3000000119209E-01
     +, 0.3000000119209E-01
     +, 0.3000000119209E-01
     +, 0.1799999949981E-05
     +, 0.1799999949981E-05
     +, 0.6000000238419E-01
     +, 0.6000000238419E-01
     +/
      DATA SIGA /  1.010359168351    
     +,  66.53189916140    
     +,  191.0316130969    
     +, -657.5535925624    
     +,  41.86218602060    
     +,  362.1928115710    
     +, -82.51244471768    
     +,  4.460736187380    
     +/
      ha95_1_msum = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         ha95_1_msum = ha95_1_msum + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) ha95_1_msum = VCONST * EXP (ha95_1_msum)
      END
      DOUBLE PRECISION FUNCTION ha95_1_nn(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  12, 1)
      DOUBLE PRECISION SIGDEL(  12)
      DOUBLE PRECISION SIGA(  12)
      DATA NPAR, NDIM, IMQFUN /   12,    1,    2/
      DATA VCONST / 0.9999999776483E-02/
      DATA SIGVMI / 0.5000000000000    /
      DATA SIGVT / 0.5000000000000    /
      DATA SIGV / 0.2099999934435    
     +, 0.3899999856949    
     +, 0.4899999797344    
     +, 0.5099999904633    
     +, 0.9099999666214    
     +, 0.9499999880791    
     +, 0.9699999690056    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.2599999904633    
     +, 0.8599999547005    
     +, 0.7599999904633    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.1599999964237    
     +/
      DATA SIGA /  6.297226900410    
     +,  3.490595190477    
     +,  23.82242421393    
     +, -26.87789719412    
     +,  21.46412039619    
     +, -180.1855587003    
     +,  285.8244432733    
     +,  7.926904444900    
     +, -123.0962066826    
     +, -10.06741179851    
     +, -7.438763796821    
     +,  14.16738637753    
     +/
      ha95_1_nn = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         ha95_1_nn = ha95_1_nn + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) ha95_1_nn = VCONST * EXP (ha95_1_nn)
      END
      DOUBLE PRECISION FUNCTION ha65_2_fvar(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  10, 1)
      DOUBLE PRECISION SIGDEL(  10)
      DOUBLE PRECISION SIGA(  10)
      DATA NPAR, NDIM, IMQFUN /   10,    1,    2/
      DATA VCONST /  28.00000000000    /
      DATA SIGVMI / -200.0000000000    /
      DATA SIGVT /  1400.000000000    /
      DATA SIGV / 0.1099999994040    
     +, 0.2699999809265    
     +, 0.3299999833107    
     +, 0.4499999880791    
     +, 0.4699999988079    
     +, 0.7299999594688    
     +, 0.7500000000000    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.6599999666214    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +/
      DATA SIGA / -87.96053061107    
     +,  5.339918823995    
     +, -9.661245907944    
     +, -3.349915063365    
     +,  1.327160179650    
     +,  60.82874193663    
     +, -50.07855065077    
     +,  76.93374650238    
     +,  1.377145769133    
     +, -21.41963678955    
     +/
      ha65_2_fvar = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         ha65_2_fvar = ha65_2_fvar + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) ha65_2_fvar = VCONST * EXP (ha65_2_fvar)
      END
      DOUBLE PRECISION FUNCTION ha65_2_msum(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  15, 1)
      DOUBLE PRECISION SIGDEL(  15)
      DOUBLE PRECISION SIGA(  15)
      DATA NPAR, NDIM, IMQFUN /   15,    1,    2/
      DATA VCONST /  3.000000000000    /
      DATA SIGVMI /  20.00000000000    /
      DATA SIGVT /  180.0000000000    /
      DATA SIGV / 0.3916666805744    
     +, 0.4083333611488    
     +, 0.4250000119209    
     +, 0.5750000476837    
     +, 0.6083333492279    
     +, 0.6416667103767    
     +, 0.6750000119209    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.5166667103767    
     +, 0.7166666984558    
     +, 0.9500000476837    
     +, 0.1666666716337    
     +, 0.2333333492279    
     +, 0.3000000119209    
     +/
      DATA SIGDEL / 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.1333333402872    
     +, 0.1333333402872    
     +, 0.1333333402872    
     +/
      DATA SIGA /  139.5433926609    
     +, -149.5263576723    
     +,  86.26372389666    
     +,  53.19028498896    
     +, -107.1247656723    
     +,  53.99823389487    
     +, -1.776923538422    
     +,  1593.377598745    
     +, -9.332688727475    
     +,  26.87322233180    
     +,  15.33556148159    
     +, -85.97699900608    
     +, -4474.336380918    
     +,  3621.351226214    
     +, -982.3225351362    
     +/
      ha65_2_msum = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         ha65_2_msum = ha65_2_msum + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) ha65_2_msum = VCONST * EXP (ha65_2_msum)
      END
      DOUBLE PRECISION FUNCTION ha70_2_fvar(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  12, 1)
      DOUBLE PRECISION SIGDEL(  12)
      DOUBLE PRECISION SIGA(  12)
      DATA NPAR, NDIM, IMQFUN /   12,    1,    2/
      DATA VCONST /  28.00000000000    /
      DATA SIGVMI / -200.0000000000    /
      DATA SIGVT /  1400.000000000    /
      DATA SIGV / 0.1299999952316    
     +, 0.2099999934435    
     +, 0.2699999809265    
     +, 0.2899999916553    
     +, 0.6699999570847    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.3400000035763    
     +, 0.5399999618530    
     +, 0.4399999976158    
     +, 0.7599999904633    
     +, 0.8399999737740    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.1599999964237    
     +, 0.1599999964237    
     +, 0.1599999964237    
     +/
      DATA SIGA / -87.17234105720    
     +,-0.1987687204749    
     +,  35.99343783658    
     +, -38.68232119812    
     +,  11.22078526901    
     +,  68.04184687324    
     +,  64.22872565849    
     +,  8.145354781953    
     +,  5.667159282884    
     +, -10.51230990318    
     +, -32.02274056415    
     +, -64.74212261093    
     +/
      ha70_2_fvar = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         ha70_2_fvar = ha70_2_fvar + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) ha70_2_fvar = VCONST * EXP (ha70_2_fvar)
      END
      DOUBLE PRECISION FUNCTION ha70_2_msum(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  18, 1)
      DOUBLE PRECISION SIGDEL(  18)
      DOUBLE PRECISION SIGA(  18)
      DATA NPAR, NDIM, IMQFUN /   18,    1,    2/
      DATA VCONST /  3.000000000000    /
      DATA SIGVMI /  20.00000000000    /
      DATA SIGVT /  180.0000000000    /
      DATA SIGV / 0.3250000178814    
     +, 0.5250000357628    
     +, 0.6083333492279    
     +, 0.6250000596046    
     +, 0.6583333611488    
     +, 0.6750000119209    
     +, 0.6916667222977    
     +, 0.7083333730698    
     +, 0.7750000357628    
     +, 0.7916666865349    
     +, 0.8250000476837    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.2500000000000    
     +, 0.2833333611488    
     +, 0.4500000178814    
     +, 0.8833333849907    
     +, 0.9500000476837    
     +/
      DATA SIGDEL / 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +/
      DATA SIGA /  39.23181800288    
     +, 0.9939312886339    
     +, -24.03001168780    
     +,  69.60446001814    
     +,  17.64271823586    
     +, -293.7360150476    
     +,  310.9082377285    
     +, -97.54249969037    
     +,  71.92691453647    
     +, -90.63106204045    
     +,  49.34893087639    
     +,  6.581974307826    
     +, -44.72864995551    
     +,  95.05210406497    
     +, -144.0300838948    
     +,  1.123763348537    
     +, -113.5334621056    
     +,  134.3533470212    
     +/
      ha70_2_msum = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         ha70_2_msum = ha70_2_msum + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) ha70_2_msum = VCONST * EXP (ha70_2_msum)
      END
      DOUBLE PRECISION FUNCTION ha75_2_fvar(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  11, 1)
      DOUBLE PRECISION SIGDEL(  11)
      DOUBLE PRECISION SIGA(  11)
      DATA NPAR, NDIM, IMQFUN /   11,    1,    2/
      DATA VCONST /  28.00000000000    /
      DATA SIGVMI / -200.0000000000    /
      DATA SIGVT /  1400.000000000    /
      DATA SIGV / 0.1099999994040    
     +, 0.1700000017881    
     +, 0.1899999976158    
     +, 0.2500000000000    
     +, 0.3299999833107    
     +, 0.4099999964237    
     +, 0.7699999809265    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.5399999618530    
     +, 0.6999999880791    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +/
      DATA SIGA / -340.9970554260    
     +,  16.77086539162    
     +,  22.76261513423    
     +,  1.124616842911    
     +, -9.228277100586    
     +,  1.075342529193    
     +, -8.797792083352    
     +,  270.2825703355    
     +, -16.14600939147    
     +, -5.801606404490    
     +,-0.8035850728121    
     +/
      ha75_2_fvar = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         ha75_2_fvar = ha75_2_fvar + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) ha75_2_fvar = VCONST * EXP (ha75_2_fvar)
      END
      DOUBLE PRECISION FUNCTION ha75_2_msum(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  14, 1)
      DOUBLE PRECISION SIGDEL(  14)
      DOUBLE PRECISION SIGA(  14)
      DATA NPAR, NDIM, IMQFUN /   14,    1,    2/
      DATA VCONST /  3.000000000000    /
      DATA SIGVMI /  20.00000000000    /
      DATA SIGVT /  180.0000000000    /
      DATA SIGV / 0.3250000178814    
     +, 0.6083333492279    
     +, 0.6750000119209    
     +, 0.6916667222977    
     +, 0.7083333730698    
     +, 0.7250000238419    
     +, 0.7416667342186    
     +, 0.8250000476837    
     +, 0.9250000715256    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.7833333611488    
     +, 0.8833333849907    
     +, 0.2333333492279    
     +/
      DATA SIGDEL / 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.1333333402872    
     +/
      DATA SIGA / -10.84236269517    
     +,  5.069044930355    
     +, -68.20331189729    
     +,  287.0033341174    
     +, -337.6140935730    
     +,  53.02015991832    
     +,  50.64438515749    
     +, -14.74034734412    
     +, -78.84284923637    
     +,  19.66595768964    
     +,  55.39641895880    
     +, 0.2085028115617    
     +,  35.31631837261    
     +, -18.47160380829    
     +/
      ha75_2_msum = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         ha75_2_msum = ha75_2_msum + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) ha75_2_msum = VCONST * EXP (ha75_2_msum)
      END
      DOUBLE PRECISION FUNCTION ha80_2_fvar(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  12, 1)
      DOUBLE PRECISION SIGDEL(  12)
      DOUBLE PRECISION SIGA(  12)
      DATA NPAR, NDIM, IMQFUN /   12,    1,    2/
      DATA VCONST /  28.00000000000    /
      DATA SIGVMI / -200.0000000000    /
      DATA SIGVT /  1400.000000000    /
      DATA SIGV / 0.2699999809265    
     +, 0.4299999773502    
     +, 0.4499999880791    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.9999999403954E-01
     +, 0.1400000005960    
     +, 0.3799999952316    
     +, 0.5399999618530    
     +, 0.6200000047684    
     +, 0.6999999880791    
     +, 0.8399999737740    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.1599999964237    
     +/
      DATA SIGA /-0.8433831413170    
     +,  19.18589553599    
     +, -14.00594705627    
     +,  625.9038555945    
     +,  110.1486814331    
     +, -1322.875176555    
     +,  649.3282230826    
     +, -5.588339855898    
     +,  2.544413315018    
     +,  6.489627458043    
     +,  42.87144556612    
     +, -202.3328571658    
     +/
      ha80_2_fvar = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         ha80_2_fvar = ha80_2_fvar + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) ha80_2_fvar = VCONST * EXP (ha80_2_fvar)
      END
      DOUBLE PRECISION FUNCTION ha80_2_msum(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  19, 1)
      DOUBLE PRECISION SIGDEL(  19)
      DOUBLE PRECISION SIGA(  19)
      DATA NPAR, NDIM, IMQFUN /   19,    1,    2/
      DATA VCONST /  3.000000000000    /
      DATA SIGVMI /  20.00000000000    /
      DATA SIGVT /  180.0000000000    /
      DATA SIGV / 0.2750000059605    
     +, 0.3916666805744    
     +, 0.4083333611488    
     +, 0.4750000238419    
     +, 0.7250000238419    
     +, 0.7416667342186    
     +, 0.7583333849907    
     +, 0.7750000357628    
     +, 0.7916666865349    
     +, 0.8250000476837    
     +, 0.8416666984558    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.3500000238419    
     +, 0.5166667103767    
     +, 0.5500000119209    
     +, 0.6833333969116    
     +, 0.9166666865349    
     +, 0.9500000476837    
     +/
      DATA SIGDEL / 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +/
      DATA SIGA / -20.16835238571    
     +, -98.52489071905    
     +,  58.99095482528    
     +, -4.156328509929    
     +, -44.87571228836    
     +,  179.3395402538    
     +, -72.27641497685    
     +, -304.4974214570    
     +,  307.0776885215    
     +, -256.9741297843    
     +,  245.0031445241    
     +,  8.775597440042    
     +,  8.237223478608    
     +,  51.68830322466    
     +,  1.530788147240    
     +, -5.257286149201    
     +,  7.574508437255    
     +, -315.5724708945    
     +,  236.1094435059    
     +/
      ha80_2_msum = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         ha80_2_msum = ha80_2_msum + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) ha80_2_msum = VCONST * EXP (ha80_2_msum)
      END
      DOUBLE PRECISION FUNCTION ha85_2_fvar(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  12, 1)
      DOUBLE PRECISION SIGDEL(  12)
      DOUBLE PRECISION SIGA(  12)
      DATA NPAR, NDIM, IMQFUN /   12,    1,    2/
      DATA VCONST /  28.00000000000    /
      DATA SIGVMI / -200.0000000000    /
      DATA SIGVT /  1400.000000000    /
      DATA SIGV / 0.2500000000000    
     +, 0.2899999916553    
     +, 0.3499999940395    
     +, 0.3700000047684    
     +, 0.4499999880791    
     +, 0.5500000119209    
     +, 0.6499999761581    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.1400000005960    
     +, 0.1799999922514    
     +, 0.7799999713898    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +/
      DATA SIGA /  45.00746678630    
     +, -5.583042102609    
     +, -35.37468622425    
     +,  27.23438879923    
     +, -6.497539724983    
     +,  2.269562884535    
     +,-0.8039533731905    
     +,  65.11337707221    
     +,  38.05576116725    
     +, -35.45353931411    
     +, -84.99628002200    
     +, -57.55598235542    
     +/
      ha85_2_fvar = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         ha85_2_fvar = ha85_2_fvar + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) ha85_2_fvar = VCONST * EXP (ha85_2_fvar)
      END
      DOUBLE PRECISION FUNCTION ha85_2_msum(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  17, 1)
      DOUBLE PRECISION SIGDEL(  17)
      DOUBLE PRECISION SIGA(  17)
      DATA NPAR, NDIM, IMQFUN /   17,    1,    2/
      DATA VCONST /  3.000000000000    /
      DATA SIGVMI /  20.00000000000    /
      DATA SIGVT /  180.0000000000    /
      DATA SIGV / 0.3583333492279    
     +, 0.4250000119209    
     +, 0.4416666924953    
     +, 0.5416666865349    
     +, 0.5750000476837    
     +, 0.7750000357628    
     +, 0.8083333969116    
     +, 0.8250000476837    
     +, 0.8416666984558    
     +, 0.8583333492279    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.2833333611488    
     +, 0.4833333492279    
     +, 0.9166666865349    
     +, 0.9500000476837    
     +, 0.7000000476837    
     +/
      DATA SIGDEL / 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.1333333402872    
     +/
      DATA SIGA /  5.181990758687    
     +, -35.69654297413    
     +,  28.83782177485    
     +,  10.61169981082    
     +, -6.290617149868    
     +,  7.445775316003    
     +,  158.5663764781    
     +, -328.1787808974    
     +,  85.59185856161    
     +,  100.4460577049    
     +,  6.419676874532    
     +,  525.7953158849    
     +, -4.455571270578    
     +, -12.06084548230    
     +,  393.9182619559    
     +, -968.2160103582    
     +,  14.56753358419    
     +/
      ha85_2_msum = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         ha85_2_msum = ha85_2_msum + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) ha85_2_msum = VCONST * EXP (ha85_2_msum)
      END
      DOUBLE PRECISION FUNCTION ha90_2_fvar(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  12, 1)
      DOUBLE PRECISION SIGDEL(  12)
      DOUBLE PRECISION SIGA(  12)
      DATA NPAR, NDIM, IMQFUN /   12,    1,    2/
      DATA VCONST /  28.00000000000    /
      DATA SIGVMI / -200.0000000000    /
      DATA SIGVT /  1400.000000000    /
      DATA SIGV / 0.2899999916553    
     +, 0.3100000023842    
     +, 0.4299999773502    
     +, 0.5299999713898    
     +, 0.5500000119209    
     +, 0.6699999570847    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.1199999973178    
     +, 0.1999999880791    
     +, 0.7599999904633    
     +, 0.8399999737740    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.1599999964237    
     +, 0.1599999964237    
     +, 0.1599999964237    
     +, 0.1599999964237    
     +/
      DATA SIGA /  28.42511743675    
     +, -58.96875558893    
     +, -5.167273026051    
     +, -13.02445351222    
     +,  12.07131344599    
     +,  10.25165573588    
     +,  263.9985889143    
     +, -19.69564675169    
     +, -651.8400277115    
     +,  417.4612579143    
     +, -118.8271702011    
     +,  123.7117894708    
     +/
      ha90_2_fvar = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         ha90_2_fvar = ha90_2_fvar + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) ha90_2_fvar = VCONST * EXP (ha90_2_fvar)
      END
      DOUBLE PRECISION FUNCTION ha90_2_msum(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  11, 1)
      DOUBLE PRECISION SIGDEL(  11)
      DOUBLE PRECISION SIGA(  11)
      DATA NPAR, NDIM, IMQFUN /   11,    1,    2/
      DATA VCONST /  3.000000000000    /
      DATA SIGVMI /  20.00000000000    /
      DATA SIGVT /  180.0000000000    /
      DATA SIGV / 0.3083333373070    
     +, 0.8416666984558    
     +, 0.8750000596046    
     +, 0.8916667103767    
     +, 0.9250000715256    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.3500000238419    
     +, 0.4166666865349    
     +, 0.2333333492279    
     +, 0.7666667103767    
     +/
      DATA SIGDEL / 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.1333333402872    
     +, 0.1333333402872    
     +/
      DATA SIGA /  29.88058532518    
     +,  72.45623977608    
     +, -174.9199890619    
     +,  54.58685749476    
     +,  6.915860803099    
     +,-0.7190499472944E-01
     +,  38.10285671423    
     +, -58.96110439949    
     +,  8.565040450106    
     +,  15.47034032544    
     +, -3.689428981637    
     +/
      ha90_2_msum = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         ha90_2_msum = ha90_2_msum + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) ha90_2_msum = VCONST * EXP (ha90_2_msum)
      END
      DOUBLE PRECISION FUNCTION ha95_2_fvar(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  14, 1)
      DOUBLE PRECISION SIGDEL(  14)
      DOUBLE PRECISION SIGA(  14)
      DATA NPAR, NDIM, IMQFUN /   14,    1,    2/
      DATA VCONST /  28.00000000000    /
      DATA SIGVMI / -200.0000000000    /
      DATA SIGVT /  1400.000000000    /
      DATA SIGV / 0.2099999934435    
     +, 0.2699999809265    
     +, 0.6899999976158    
     +, 0.7099999785423    
     +, 0.7899999618530    
     +, 0.8100000023842    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.9999999403954E-01
     +, 0.1400000005960    
     +, 0.3400000035763    
     +, 0.4399999976158    
     +, 0.5199999809265    
     +, 0.5999999642372    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.1599999964237    
     +, 0.1599999964237    
     +, 0.1599999964237    
     +/
      DATA SIGA /  54.57779835578    
     +,-0.9008437360829    
     +, -73.13746870176    
     +,  82.64085469828    
     +, -7.279137797457    
     +, -70.71616861126    
     +,  640.3455254798    
     +,  10.84742921810    
     +, -1200.965788620    
     +,  447.2473442286    
     +, -16.10360174725    
     +,  82.73390747919    
     +, -135.6517145603    
     +,  87.80203015490    
     +/
      ha95_2_fvar = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         ha95_2_fvar = ha95_2_fvar + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) ha95_2_fvar = VCONST * EXP (ha95_2_fvar)
      END
      DOUBLE PRECISION FUNCTION ha95_2_msum(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  15, 1)
      DOUBLE PRECISION SIGDEL(  15)
      DOUBLE PRECISION SIGA(  15)
      DATA NPAR, NDIM, IMQFUN /   15,    1,    2/
      DATA VCONST /  3.000000000000    /
      DATA SIGVMI /  20.00000000000    /
      DATA SIGVT /  180.0000000000    /
      DATA SIGV / 0.4083333611488    
     +, 0.4250000119209    
     +, 0.4416666924953    
     +, 0.4583333432674    
     +, 0.4750000238419    
     +, 0.8416666984558    
     +, 0.8583333492279    
     +, 0.9250000715256    
     +, 0.9416667222977    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.3500000238419    
     +, 0.7500000596046    
     +, 0.7833333611488    
     +, 0.2333333492279    
     +/
      DATA SIGDEL / 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.1333333402872    
     +/
      DATA SIGA / -116.9040635013    
     +,  180.5467005302    
     +, -114.8519696991    
     +,  25.06862242052    
     +,  2.711008021474    
     +, -17.02589659137    
     +,  12.53956156745    
     +,  437.5066082692    
     +, -824.8843497919    
     +,  5.518343856881    
     +,  369.1991943717    
     +,  24.40325496631    
     +, -2.993589681596    
     +,  7.590050565605    
     +, -22.52722982448    
     +/
      ha95_2_msum = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         ha95_2_msum = ha95_2_msum + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) ha95_2_msum = VCONST * EXP (ha95_2_msum)
      END
      DOUBLE PRECISION FUNCTION ha65_3_mh(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   8, 1)
      DOUBLE PRECISION SIGDEL(   8)
      DOUBLE PRECISION SIGA(   8)
      DATA NPAR, NDIM, IMQFUN /    8,    1,    2/
      DATA VCONST /  1.750000000000    /
      DATA SIGVMI /  35.00000000000    /
      DATA SIGVT /  70.00000000000    /
      DATA SIGV / 0.1125000044703    
     +, 0.2625000178814    
     +, 0.9125000238419    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.4250000119209    
     +, 0.8249999880791    
     +, 0.5500000119209    
     +/
      DATA SIGDEL / 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.1000000014901    
     +, 0.1000000014901    
     +, 0.2000000029802    
     +/
      DATA SIGA /  5.733950772678    
     +,-0.3265679758335    
     +, -151.6658196924    
     +, -11.81653962051    
     +,  127.6918624858    
     +,  1.579562058103    
     +,  14.11314399256    
     +, 0.9029077701552E-01
     +/
      ha65_3_mh = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         ha65_3_mh = ha65_3_mh + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) ha65_3_mh = VCONST * EXP (ha65_3_mh)
      END
      DOUBLE PRECISION FUNCTION ha65_3_nn(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  10, 1)
      DOUBLE PRECISION SIGDEL(  10)
      DOUBLE PRECISION SIGA(  10)
      DATA NPAR, NDIM, IMQFUN /   10,    1,    2/
      DATA VCONST / 0.9999999776483E-02/
      DATA SIGVMI / 0.5000000000000    /
      DATA SIGVT / 0.5000000000000    /
      DATA SIGV / 0.1299999952316    
     +, 0.3100000023842    
     +, 0.4499999880791    
     +, 0.4699999988079    
     +, 0.6100000143051    
     +, 0.6299999952316    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.2599999904633    
     +, 0.8999999761581    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +/
      DATA SIGA /-0.1550757083446    
     +, 0.3691055175304    
     +,-0.5499449979779    
     +, 0.1204401033500    
     +,  3.680996324192    
     +, -3.507730387173    
     +,  8.121724205877    
     +,  2.633793143644    
     +,  1.648962034882    
     +,  5.177010731647    
     +/
      ha65_3_nn = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         ha65_3_nn = ha65_3_nn + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) ha65_3_nn = VCONST * EXP (ha65_3_nn)
      END
      DOUBLE PRECISION FUNCTION ha70_3_mh(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  10, 1)
      DOUBLE PRECISION SIGDEL(  10)
      DOUBLE PRECISION SIGA(  10)
      DATA NPAR, NDIM, IMQFUN /   10,    1,    2/
      DATA VCONST /  1.750000000000    /
      DATA SIGVMI /  35.00000000000    /
      DATA SIGVT /  70.00000000000    /
      DATA SIGV / 0.8749999850988E-01
     +, 0.2625000178814    
     +, 0.6125000119209    
     +, 0.7875000238419    
     +, 0.8125000000000    
     +, 0.8375000357628    
     +, 0.9125000238419    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.4500000178814    
     +/
      DATA SIGDEL / 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.2000000029802    
     +/
      DATA SIGA / -14.76758091169    
     +, -2.127400558616    
     +, -2.165568212795    
     +, -24.50912253047    
     +,  49.93641835976    
     +,  22.83284217472    
     +, -333.2373077547    
     +, -4.428635424138    
     +,  261.5911976473    
     +,  11.77552404980    
     +/
      ha70_3_mh = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         ha70_3_mh = ha70_3_mh + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) ha70_3_mh = VCONST * EXP (ha70_3_mh)
      END
      DOUBLE PRECISION FUNCTION ha70_3_nn(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  11, 1)
      DOUBLE PRECISION SIGDEL(  11)
      DOUBLE PRECISION SIGA(  11)
      DATA NPAR, NDIM, IMQFUN /   11,    1,    2/
      DATA VCONST / 0.9999999776483E-02/
      DATA SIGVMI / 0.5000000000000    /
      DATA SIGVT / 0.5000000000000    /
      DATA SIGV / 0.7000000029802E-01
     +, 0.3700000047684    
     +, 0.5899999737740    
     +, 0.6100000143051    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.1799999922514    
     +, 0.2199999988079    
     +, 0.4599999785423    
     +, 0.7599999904633    
     +, 0.8399999737740    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.1599999964237    
     +, 0.1599999964237    
     +/
      DATA SIGA / -10.18997166750    
     +,  3.552104454809    
     +,  4.265217547452    
     +, -6.194891533529    
     +,  13.18581771415    
     +,  1.975171847262    
     +,  25.68676219701    
     +, -22.98601751603    
     +, 0.2291987778486    
     +,-0.6700757486410    
     +,  7.863215554217    
     +/
      ha70_3_nn = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         ha70_3_nn = ha70_3_nn + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) ha70_3_nn = VCONST * EXP (ha70_3_nn)
      END
      DOUBLE PRECISION FUNCTION ha75_3_mh(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  12, 1)
      DOUBLE PRECISION SIGDEL(  12)
      DOUBLE PRECISION SIGA(  12)
      DATA NPAR, NDIM, IMQFUN /   12,    1,    2/
      DATA VCONST /  1.750000000000    /
      DATA SIGVMI /  35.00000000000    /
      DATA SIGVT /  70.00000000000    /
      DATA SIGV / 0.8749999850988E-01
     +, 0.1125000044703    
     +, 0.2625000178814    
     +, 0.6374999880791    
     +, 0.7875000238419    
     +, 0.8125000000000    
     +, 0.9125000238419    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.3250000178814    
     +, 0.3750000000000    
     +, 0.5250000357628    
     +/
      DATA SIGDEL / 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.1000000014901    
     +, 0.1000000014901    
     +, 0.1000000014901    
     +/
      DATA SIGA /  32.41205565830    
     +, -19.03425263761    
     +,  39.79707492312    
     +,-0.5423037554880    
     +, -16.75850686836    
     +,  47.51896851203    
     +, -239.3105549534    
     +, -17.44001162285    
     +,  194.1394174870    
     +, -142.0573686508    
     +,  103.4801068193    
     +, -5.165187271250    
     +/
      ha75_3_mh = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         ha75_3_mh = ha75_3_mh + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) ha75_3_mh = VCONST * EXP (ha75_3_mh)
      END
      DOUBLE PRECISION FUNCTION ha75_3_nn(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  10, 1)
      DOUBLE PRECISION SIGDEL(  10)
      DOUBLE PRECISION SIGA(  10)
      DATA NPAR, NDIM, IMQFUN /   10,    1,    2/
      DATA VCONST / 0.9999999776483E-02/
      DATA SIGVMI / 0.5000000000000    /
      DATA SIGVT / 0.5000000000000    /
      DATA SIGV / 0.2999999932945E-01
     +, 0.2299999892712    
     +, 0.3700000047684    
     +, 0.4699999988079    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.9999999403954E-01
     +, 0.4199999868870    
     +, 0.8599999547005    
     +, 0.6800000071526    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.1599999964237    
     +/
      DATA SIGA / -5.441605815018    
     +,  1.811295022112    
     +,  12.96301323692    
     +,  13.83902107697    
     +,  13.96206359436    
     +,  4.699398819563    
     +, 0.1281124492864    
     +, -28.39205180575    
     +,  3.010874578334    
     +,  1.234666288863    
     +/
      ha75_3_nn = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         ha75_3_nn = ha75_3_nn + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) ha75_3_nn = VCONST * EXP (ha75_3_nn)
      END
      DOUBLE PRECISION FUNCTION ha80_3_mh(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   9, 1)
      DOUBLE PRECISION SIGDEL(   9)
      DOUBLE PRECISION SIGA(   9)
      DATA NPAR, NDIM, IMQFUN /    9,    1,    2/
      DATA VCONST /  1.750000000000    /
      DATA SIGVMI /  35.00000000000    /
      DATA SIGVT /  70.00000000000    /
      DATA SIGV / 0.3750000149012E-01
     +, 0.2625000178814    
     +, 0.2874999940395    
     +, 0.5375000238419    
     +, 0.9125000238419    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.4749999940395    
     +, 0.7500000000000    
     +/
      DATA SIGDEL / 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.1000000014901    
     +, 0.2000000029802    
     +/
      DATA SIGA / -2.644640882532    
     +, -32.98475631773    
     +,  40.54990920355    
     +,  11.69529432506    
     +, -86.62516012635    
     +,  1.391210147349    
     +,  77.94000581369    
     +, -22.93038242785    
     +,  4.315994114787    
     +/
      ha80_3_mh = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         ha80_3_mh = ha80_3_mh + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) ha80_3_mh = VCONST * EXP (ha80_3_mh)
      END
      DOUBLE PRECISION FUNCTION ha80_3_nn(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   9, 1)
      DOUBLE PRECISION SIGDEL(   9)
      DOUBLE PRECISION SIGA(   9)
      DATA NPAR, NDIM, IMQFUN /    9,    1,    2/
      DATA VCONST / 0.9999999776483E-02/
      DATA SIGVMI / 0.5000000000000    /
      DATA SIGVT / 0.5000000000000    /
      DATA SIGV / 0.8999999612570E-01
     +, 0.5699999928474    
     +, 0.5899999737740    
     +, 0.6699999570847    
     +, 0.8499999642372    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.3400000035763    
     +, 0.1999999880791    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.1599999964237    
     +/
      DATA SIGA / 0.6112318330011    
     +,  2.029323240973    
     +, -2.835020304286    
     +,  2.148149431250    
     +, 0.9931321749599    
     +,  7.857102499204    
     +,  5.598441357181    
     +,-0.9441994403935    
     +,  2.131495092242    
     +/
      ha80_3_nn = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         ha80_3_nn = ha80_3_nn + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) ha80_3_nn = VCONST * EXP (ha80_3_nn)
      END
      DOUBLE PRECISION FUNCTION ha85_3_mh(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  10, 1)
      DOUBLE PRECISION SIGDEL(  10)
      DOUBLE PRECISION SIGA(  10)
      DATA NPAR, NDIM, IMQFUN /   10,    1,    2/
      DATA VCONST /  1.750000000000    /
      DATA SIGVMI /  35.00000000000    /
      DATA SIGVT /  70.00000000000    /
      DATA SIGV / 0.3375000059605    
     +, 0.6125000119209    
     +, 0.6374999880791    
     +, 0.7375000119209    
     +, 0.8375000357628    
     +, 0.9125000238419    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.4749999940395    
     +, 0.5250000357628    
     +/
      DATA SIGDEL / 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.1000000014901    
     +, 0.1000000014901    
     +/
      DATA SIGA / -1.172921159785    
     +, -90.44464970718    
     +,  57.45190172047    
     +, 0.2749318328912    
     +,  34.85168987787    
     +, -246.7277731554    
     +, -10.21871702335    
     +,  196.0087938391    
     +, -27.90304911769    
     +,  61.68858430410    
     +/
      ha85_3_mh = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         ha85_3_mh = ha85_3_mh + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) ha85_3_mh = VCONST * EXP (ha85_3_mh)
      END
      DOUBLE PRECISION FUNCTION ha85_3_nn(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   7, 1)
      DOUBLE PRECISION SIGDEL(   7)
      DOUBLE PRECISION SIGA(   7)
      DATA NPAR, NDIM, IMQFUN /    7,    1,    2/
      DATA VCONST / 0.9999999776483E-02/
      DATA SIGVMI / 0.5000000000000    /
      DATA SIGVT / 0.5000000000000    /
      DATA SIGV / 0.2899999916553    
     +, 0.4299999773502    
     +, 0.7699999809265    
     +, 0.7899999618530    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.5799999833107    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +/
      DATA SIGA / -1.621537526561    
     +,  3.026079420275    
     +, 0.1715843833476    
     +,  2.546497463071    
     +,  9.900322981150    
     +,  4.791330485557    
     +, -1.196884336786    
     +/
      ha85_3_nn = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         ha85_3_nn = ha85_3_nn + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) ha85_3_nn = VCONST * EXP (ha85_3_nn)
      END
      DOUBLE PRECISION FUNCTION ha90_3_mh(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  13, 1)
      DOUBLE PRECISION SIGDEL(  13)
      DOUBLE PRECISION SIGA(  13)
      DATA NPAR, NDIM, IMQFUN /   13,    1,    2/
      DATA VCONST /  1.750000000000    /
      DATA SIGVMI /  35.00000000000    /
      DATA SIGVT /  70.00000000000    /
      DATA SIGV / 0.1375000029802    
     +, 0.4124999940395    
     +, 0.4875000119209    
     +, 0.5875000357628    
     +, 0.6125000119209    
     +, 0.6875000000000    
     +, 0.7125000357628    
     +, 0.7375000119209    
     +, 0.9125000238419    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.8249999880791    
     +, 0.2500000000000    
     +/
      DATA SIGDEL / 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.1000000014901    
     +, 0.2000000029802    
     +/
      DATA SIGA / 0.6087967956756    
     +, 0.2795756747228    
     +, -6.000524242703    
     +,  40.99227700202    
     +, -53.25324497847    
     +,  100.7725540774    
     +, -97.82163656189    
     +, -30.82175829356    
     +, -264.9372600963    
     +, -12.85773497167    
     +,  192.8838064715    
     +,  101.7326428080    
     +, 0.7511079637826    
     +/
      ha90_3_mh = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         ha90_3_mh = ha90_3_mh + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) ha90_3_mh = VCONST * EXP (ha90_3_mh)
      END
      DOUBLE PRECISION FUNCTION ha90_3_nn(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  13, 1)
      DOUBLE PRECISION SIGDEL(  13)
      DOUBLE PRECISION SIGA(  13)
      DATA NPAR, NDIM, IMQFUN /   13,    1,    2/
      DATA VCONST / 0.9999999776483E-02/
      DATA SIGVMI / 0.5000000000000    /
      DATA SIGVT / 0.5000000000000    /
      DATA SIGV / 0.2999999932945E-01
     +, 0.1700000017881    
     +, 0.3299999833107    
     +, 0.3499999940395    
     +, 0.4699999988079    
     +, 0.6499999761581    
     +, 0.6699999570847    
     +, 0.9300000071526    
     +, 0.9699999690056    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.7799999713898    
     +, 0.8599999547005    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +/
      DATA SIGA /  13.94722125080    
     +, 0.6512922169556    
     +,  5.932942879639    
     +, -8.012247045666    
     +,  1.789185365225    
     +,  2.962147699100    
     +, -1.493535447484    
     +,  2.859996528864    
     +,  10.22471857154    
     +, -3.817231713211    
     +, -7.979979143819    
     +, 0.7193656371450E-01
     +,  1.645877695578    
     +/
      ha90_3_nn = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         ha90_3_nn = ha90_3_nn + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) ha90_3_nn = VCONST * EXP (ha90_3_nn)
      END
      DOUBLE PRECISION FUNCTION ha95_3_mh(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  15, 1)
      DOUBLE PRECISION SIGDEL(  15)
      DOUBLE PRECISION SIGA(  15)
      DATA NPAR, NDIM, IMQFUN /   15,    1,    2/
      DATA VCONST /  1.750000000000    /
      DATA SIGVMI /  35.00000000000    /
      DATA SIGVT /  70.00000000000    /
      DATA SIGV / 0.1125000044703    
     +, 0.1875000000000    
     +, 0.2125000059605    
     +, 0.3875000178814    
     +, 0.4124999940395    
     +, 0.4375000000000    
     +, 0.5875000357628    
     +, 0.6374999880791    
     +, 0.7125000357628    
     +, 0.8125000000000    
     +, 0.8625000119209    
     +, 0.8874999880791    
     +, 0.9125000238419    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +/
      DATA SIGDEL / 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +/
      DATA SIGA / -4.181898966884    
     +,  24.86553560670    
     +, -22.44923511586    
     +,  46.34007690420    
     +, -90.72247286138    
     +,  48.08325079070    
     +, -8.659532234756    
     +,  14.55269137064    
     +, -12.67288003811    
     +,  25.00531041767    
     +,  388.9442382951    
     +, -1309.332509699    
     +,  999.9721807670    
     +,  1.272328458793    
     +, -101.3109959057    
     +/
      ha95_3_mh = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         ha95_3_mh = ha95_3_mh + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) ha95_3_mh = VCONST * EXP (ha95_3_mh)
      END
      DOUBLE PRECISION FUNCTION ha95_3_nn(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   9, 1)
      DOUBLE PRECISION SIGDEL(   9)
      DOUBLE PRECISION SIGA(   9)
      DATA NPAR, NDIM, IMQFUN /    9,    1,    2/
      DATA VCONST / 0.9999999776483E-02/
      DATA SIGVMI / 0.5000000000000    /
      DATA SIGVT / 0.5000000000000    /
      DATA SIGV / 0.1299999952316    
     +, 0.9499999880791    
     +, 0.9699999690056    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.6599999666214    
     +, 0.8199999928474    
     +, 0.8999999761581    
     +, 0.4399999976158    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.1599999964237    
     +/
      DATA SIGA /-0.7248801807117    
     +,  5.894569167422    
     +,  10.32534910008    
     +,  9.826172646615    
     +, -11.67044307343    
     +, -1.100375993123    
     +,  2.806368422782    
     +, 0.3964305264654    
     +,  2.390852723200    
     +/
      ha95_3_nn = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         ha95_3_nn = ha95_3_nn + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) ha95_3_nn = VCONST * EXP (ha95_3_nn)
      END
      DOUBLE PRECISION FUNCTION hz100_1_fvar(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   8, 1)
      DOUBLE PRECISION SIGDEL(   8)
      DOUBLE PRECISION SIGA(   8)
      DATA NPAR, NDIM, IMQFUN /    8,    1,    2/
      DATA VCONST /  28.00000000000    /
      DATA SIGVMI / -200.0000000000    /
      DATA SIGVT /  1400.000000000    /
      DATA SIGV / 0.1099999994040    
     +, 0.2299999892712    
     +, 0.5099999904633    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.3799999952316    
     +, 0.5799999833107    
     +, 0.6999999880791    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +/
      DATA SIGA / -96.17989627117    
     +,  3.688025825968    
     +, -31.30493835112    
     +,  37.33846013565    
     +,  118.9418917499    
     +,  6.467821182441    
     +,  65.50926843818    
     +, -216.6608444343    
     +/
      hz100_1_fvar = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz100_1_fvar = hz100_1_fvar + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz100_1_fvar = VCONST * EXP (hz100_1_fvar)
      END
      DOUBLE PRECISION FUNCTION hz100_1_mh(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   9, 1)
      DOUBLE PRECISION SIGDEL(   9)
      DOUBLE PRECISION SIGA(   9)
      DATA NPAR, NDIM, IMQFUN /    9,    1,    2/
      DATA VCONST /  1.750000000000    /
      DATA SIGVMI /  35.00000000000    /
      DATA SIGVT /  70.00000000000    /
      DATA SIGV / 0.8749999850988E-01
     +, 0.3875000178814    
     +, 0.4124999940395    
     +, 0.6374999880791    
     +, 0.9125000238419    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.7250000238419    
     +, 0.7750000357628    
     +/
      DATA SIGDEL / 0.8000000566244E-01
     +, 0.8000000566244E-01
     +, 0.8000000566244E-01
     +, 0.8000000566244E-01
     +, 0.8000000566244E-01
     +, 0.3200000037396E-05
     +, 0.3200000037396E-05
     +, 0.1600000113249    
     +, 0.1600000113249    
     +/
      DATA SIGA /  6.048003252087    
     +,  14.90777837321    
     +, -17.47125196597    
     +,  4.588229486754    
     +, -132.7028790760    
     +, -7.356525564855    
     +,  91.47128218047    
     +, -51.33599409630    
     +,  84.51452938663    
     +/
      hz100_1_mh = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz100_1_mh = hz100_1_mh + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz100_1_mh = VCONST * EXP (hz100_1_mh)
      END
      DOUBLE PRECISION FUNCTION hz100_1_msum(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   8, 1)
      DOUBLE PRECISION SIGDEL(   8)
      DOUBLE PRECISION SIGA(   8)
      DATA NPAR, NDIM, IMQFUN /    8,    1,    2/
      DATA VCONST /  3.000000000000    /
      DATA SIGVMI /  20.00000000000    /
      DATA SIGVT /  180.0000000000    /
      DATA SIGV / 0.5583333373070    
     +, 0.5750000476837    
     +, 0.9416667222977    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.8500000238419    
     +, 0.8833333849907    
     +, 0.3000000119209    
     +/
      DATA SIGDEL / 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.3999999989901E-05
     +, 0.3999999989901E-05
     +, 0.1333333402872    
     +, 0.1333333402872    
     +, 0.2666666805744    
     +/
      DATA SIGA /  38.15790856153    
     +, -35.26364547092    
     +, -419.3756288973    
     +,  31.95914211762    
     +,  154.8328363698    
     +, -353.7689318774    
     +,  615.6299898999    
     +, -65.16723841080    
     +/
      hz100_1_msum = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz100_1_msum = hz100_1_msum + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz100_1_msum = VCONST * EXP (hz100_1_msum)
      END
      DOUBLE PRECISION FUNCTION hz100_1_nn(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   6, 1)
      DOUBLE PRECISION SIGDEL(   6)
      DOUBLE PRECISION SIGA(   6)
      DATA NPAR, NDIM, IMQFUN /    6,    1,    2/
      DATA VCONST / 0.9999999776483E-02/
      DATA SIGVMI / 0.5000000000000    /
      DATA SIGVT / 0.5000000000000    /
      DATA SIGV / 0.8499999642372    
     +, 0.8700000047684    
     +, 0.9699999690056    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.7599999904633    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.1599999964237    
     +/
      DATA SIGA /  27.86615557604    
     +, -36.46950092787    
     +,  81.27260138941    
     +,  7.658098300485    
     +, -69.50767761463    
     +,  2.483042369174    
     +/
      hz100_1_nn = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz100_1_nn = hz100_1_nn + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz100_1_nn = VCONST * EXP (hz100_1_nn)
      END
      DOUBLE PRECISION FUNCTION hz105_1_fvar(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  12, 1)
      DOUBLE PRECISION SIGDEL(  12)
      DOUBLE PRECISION SIGA(  12)
      DATA NPAR, NDIM, IMQFUN /   12,    1,    2/
      DATA VCONST /  28.00000000000    /
      DATA SIGVMI / -200.0000000000    /
      DATA SIGVT /  1400.000000000    /
      DATA SIGV / 0.1099999994040    
     +, 0.2299999892712    
     +, 0.2500000000000    
     +, 0.3100000023842    
     +, 0.5299999713898    
     +, 0.5500000119209    
     +, 0.6100000143051    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.4199999868870    
     +, 0.4599999785423    
     +, 0.7599999904633    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.1599999964237    
     +/
      DATA SIGA / -87.27308753090    
     +,  23.99288594162    
     +, -10.86649770991    
     +, -8.831404122431    
     +, -44.74790333391    
     +,  52.06787844528    
     +,  17.99462545683    
     +,  39.23846595201    
     +,  183.5164583416    
     +,  45.18135421273    
     +, -27.62276787335    
     +, -273.7594983540    
     +/
      hz105_1_fvar = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz105_1_fvar = hz105_1_fvar + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz105_1_fvar = VCONST * EXP (hz105_1_fvar)
      END
      DOUBLE PRECISION FUNCTION hz105_1_mh(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   5, 1)
      DOUBLE PRECISION SIGDEL(   5)
      DOUBLE PRECISION SIGA(   5)
      DATA NPAR, NDIM, IMQFUN /    5,    1,    2/
      DATA VCONST /  1.750000000000    /
      DATA SIGVMI /  35.00000000000    /
      DATA SIGVT /  70.00000000000    /
      DATA SIGV / 0.8625000119209    
     +, 0.8874999880791    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.7500000000000    
     +/
      DATA SIGDEL / 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.2000000029802    
     +/
      DATA SIGA / -16.14378150651    
     +, -12.28545220515    
     +, 0.4851369192353    
     +,  24.57095006833    
     +, 0.3766449702771    
     +/
      hz105_1_mh = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz105_1_mh = hz105_1_mh + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz105_1_mh = VCONST * EXP (hz105_1_mh)
      END
      DOUBLE PRECISION FUNCTION hz105_1_msum(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   5, 1)
      DOUBLE PRECISION SIGDEL(   5)
      DOUBLE PRECISION SIGA(   5)
      DATA NPAR, NDIM, IMQFUN /    5,    1,    2/
      DATA VCONST /  3.000000000000    /
      DATA SIGVMI /  20.00000000000    /
      DATA SIGVT /  180.0000000000    /
      DATA SIGV / 0.9250000715256    
     +, 0.9416667222977    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.3500000238419    
     +/
      DATA SIGDEL / 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.6666667014360E-01
     +/
      DATA SIGA /  243.6310452306    
     +, -484.7857889742    
     +,  14.89747281354    
     +,  220.5762248327    
     +, -33.48868506827    
     +/
      hz105_1_msum = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz105_1_msum = hz105_1_msum + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz105_1_msum = VCONST * EXP (hz105_1_msum)
      END
      DOUBLE PRECISION FUNCTION hz105_1_nn(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  11, 1)
      DOUBLE PRECISION SIGDEL(  11)
      DOUBLE PRECISION SIGA(  11)
      DATA NPAR, NDIM, IMQFUN /   11,    1,    2/
      DATA VCONST / 0.9999999776483E-02/
      DATA SIGVMI / 0.5000000000000    /
      DATA SIGVT / 0.5000000000000    /
      DATA SIGV / 0.7899999618530    
     +, 0.9499999880791    
     +, 0.9699999690056    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.6599999666214    
     +, 0.8999999761581    
     +, 0.1199999973178    
     +, 0.2800000011921    
     +, 0.3599999845028    
     +, 0.4399999976158    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.1599999964237    
     +, 0.1599999964237    
     +, 0.1599999964237    
     +, 0.1599999964237    
     +/
      DATA SIGA /  4.149943572809    
     +, -48.48534909065    
     +,  117.9444639884    
     +,  42.00652850265    
     +, -68.30104490963    
     +, -6.122282801711    
     +,  2.610162141913    
     +, -88.07965052799    
     +,  143.4443915250    
     +, -133.9202884791    
     +,  49.44836653356    
     +/
      hz105_1_nn = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz105_1_nn = hz105_1_nn + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz105_1_nn = VCONST * EXP (hz105_1_nn)
      END
      DOUBLE PRECISION FUNCTION hz110_1_fvar(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   8, 1)
      DOUBLE PRECISION SIGDEL(   8)
      DOUBLE PRECISION SIGA(   8)
      DATA NPAR, NDIM, IMQFUN /    8,    1,    2/
      DATA VCONST /  28.00000000000    /
      DATA SIGVMI / -200.0000000000    /
      DATA SIGVT /  1400.000000000    /
      DATA SIGV / 0.8999999612570E-01
     +, 0.5099999904633    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.4199999868870    
     +, 0.4599999785423    
     +, 0.5799999833107    
     +, 0.6599999666214    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +/
      DATA SIGA / -109.7893120735    
     +, -14.54254426452    
     +,  79.26693698415    
     +,  35.95771403246    
     +,  33.14421157172    
     +, -39.59391110640    
     +,  43.83683095927    
     +, -88.13188066277    
     +/
      hz110_1_fvar = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz110_1_fvar = hz110_1_fvar + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz110_1_fvar = VCONST * EXP (hz110_1_fvar)
      END
      DOUBLE PRECISION FUNCTION hz110_1_mh(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   5, 1)
      DOUBLE PRECISION SIGDEL(   5)
      DOUBLE PRECISION SIGA(   5)
      DATA NPAR, NDIM, IMQFUN /    5,    1,    2/
      DATA VCONST /  1.750000000000    /
      DATA SIGVMI /  35.00000000000    /
      DATA SIGVT /  70.00000000000    /
      DATA SIGV / 0.3875000178814    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.9250000119209    
     +, 0.7500000000000    
     +/
      DATA SIGDEL / 0.2500000037253E-01
     +, 0.9999999974752E-06
     +, 0.9999999974752E-06
     +, 0.5000000074506E-01
     +, 0.1000000014901    
     +/
      DATA SIGA / -1.469574208453    
     +, -6.727481508923    
     +,  157.4109059406    
     +, -174.4846552251    
     +,  5.862601221957    
     +/
      hz110_1_mh = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz110_1_mh = hz110_1_mh + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz110_1_mh = VCONST * EXP (hz110_1_mh)
      END
      DOUBLE PRECISION FUNCTION hz110_1_msum(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   7, 1)
      DOUBLE PRECISION SIGDEL(   7)
      DOUBLE PRECISION SIGA(   7)
      DATA NPAR, NDIM, IMQFUN /    7,    1,    2/
      DATA VCONST /  3.000000000000    /
      DATA SIGVMI /  20.00000000000    /
      DATA SIGVT /  180.0000000000    /
      DATA SIGV / 0.3583333492279    
     +, 0.5083333849907    
     +, 0.7083333730698    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.7500000596046    
     +, 0.9500000476837    
     +/
      DATA SIGDEL / 0.5666667222977E-01
     +, 0.5666667222977E-01
     +, 0.5666667222977E-01
     +, 0.3400000196052E-05
     +, 0.3400000196052E-05
     +, 0.1133333444595    
     +, 0.1133333444595    
     +/
      DATA SIGA / -44.27211637728    
     +, 0.9429778540565E-01
     +, -11.57054187339    
     +,  30.38067615562    
     +,  61.35925354978    
     +,  26.59836383994    
     +, -91.73255045370    
     +/
      hz110_1_msum = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz110_1_msum = hz110_1_msum + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz110_1_msum = VCONST * EXP (hz110_1_msum)
      END
      DOUBLE PRECISION FUNCTION hz110_1_nn(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  12, 1)
      DOUBLE PRECISION SIGDEL(  12)
      DOUBLE PRECISION SIGA(  12)
      DATA NPAR, NDIM, IMQFUN /   12,    1,    2/
      DATA VCONST / 0.9999999776483E-02/
      DATA SIGVMI / 0.5000000000000    /
      DATA SIGVT / 0.5000000000000    /
      DATA SIGV / 0.5699999928474    
     +, 0.7899999618530    
     +, 0.8100000023842    
     +, 0.9699999690056    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.4599999785423    
     +, 0.5000000000000    
     +, 0.1199999973178    
     +, 0.1999999880791    
     +, 0.2800000011921    
     +, 0.6800000071526    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.1599999964237    
     +, 0.1599999964237    
     +, 0.1599999964237    
     +, 0.1599999964237    
     +/
      DATA SIGA / -77.26252886658    
     +, -11.00580028629    
     +,  6.116500962530    
     +,  49.67321476290    
     +, -35.46047680318    
     +, -50.40548232468    
     +, -311.1600110835    
     +,  335.1071859025    
     +,  239.2116703114    
     +, -435.2727771046    
     +,  298.8943936406    
     +, -2.135295715635    
     +/
      hz110_1_nn = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz110_1_nn = hz110_1_nn + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz110_1_nn = VCONST * EXP (hz110_1_nn)
      END
      DOUBLE PRECISION FUNCTION hz75_1_fvar(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   9, 1)
      DOUBLE PRECISION SIGDEL(   9)
      DOUBLE PRECISION SIGA(   9)
      DATA NPAR, NDIM, IMQFUN /    9,    1,    2/
      DATA VCONST /  28.00000000000    /
      DATA SIGVMI / -200.0000000000    /
      DATA SIGVT /  1400.000000000    /
      DATA SIGV / 0.1099999994040    
     +, 0.4899999797344    
     +, 0.6699999570847    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.5799999833107    
     +, 0.7400000095367    
     +, 0.2800000011921    
     +, 0.3599999845028    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.1599999964237    
     +, 0.1599999964237    
     +/
      DATA SIGA / -84.09842659094    
     +, -18.78229931455    
     +,  10.55218974011    
     +,  47.03581359839    
     +,  80.25764186223    
     +,  8.905845003760    
     +, -130.2603140281    
     +, -12.91227865024    
     +,  25.66422628150    
     +/
      hz75_1_fvar = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz75_1_fvar = hz75_1_fvar + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz75_1_fvar = VCONST * EXP (hz75_1_fvar)
      END
      DOUBLE PRECISION FUNCTION hz75_1_mh(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   8, 1)
      DOUBLE PRECISION SIGDEL(   8)
      DOUBLE PRECISION SIGA(   8)
      DATA NPAR, NDIM, IMQFUN /    8,    1,    2/
      DATA VCONST /  1.750000000000    /
      DATA SIGVMI /  35.00000000000    /
      DATA SIGVT /  70.00000000000    /
      DATA SIGV / 0.8749999850988E-01
     +, 0.4625000059605    
     +, 0.8625000119209    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.3750000000000    
     +, 0.5749999880791    
     +, 0.7500000000000    
     +/
      DATA SIGDEL / 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.1000000014901    
     +, 0.1000000014901    
     +, 0.2000000029802    
     +/
      DATA SIGA /  11.38851971672    
     +,  12.56163700374    
     +, -50.78555438730    
     +, -11.86592220565    
     +,  28.15002213054    
     +, -5.883705086435    
     +, -32.60870224329    
     +,  40.24480551194    
     +/
      hz75_1_mh = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz75_1_mh = hz75_1_mh + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz75_1_mh = VCONST * EXP (hz75_1_mh)
      END
      DOUBLE PRECISION FUNCTION hz75_1_msum(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   8, 1)
      DOUBLE PRECISION SIGDEL(   8)
      DOUBLE PRECISION SIGA(   8)
      DATA NPAR, NDIM, IMQFUN /    8,    1,    2/
      DATA VCONST /  3.000000000000    /
      DATA SIGVMI /  20.00000000000    /
      DATA SIGVT /  180.0000000000    /
      DATA SIGV / 0.6916667222977    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.7500000596046    
     +, 0.8166667222977    
     +, 0.8500000238419    
     +, 0.9500000476837    
     +, 0.3000000119209    
     +/
      DATA SIGDEL / 0.1000000070781E-01
     +, 0.6000000212225E-06
     +, 0.6000000212225E-06
     +, 0.2000000141561E-01
     +, 0.2000000141561E-01
     +, 0.2000000141561E-01
     +, 0.2000000141561E-01
     +, 0.4000000283122E-01
     +/
      DATA SIGA / -2.471634778405    
     +,  119.1250255538    
     +,  169.4499205729    
     +,  21.83079859341    
     +, -57.95963630847    
     +,  36.76615585801    
     +, -233.3651004592    
     +, -183.3621529078    
     +/
      hz75_1_msum = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz75_1_msum = hz75_1_msum + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz75_1_msum = VCONST * EXP (hz75_1_msum)
      END
      DOUBLE PRECISION FUNCTION hz75_1_nn(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   9, 1)
      DOUBLE PRECISION SIGDEL(   9)
      DOUBLE PRECISION SIGA(   9)
      DATA NPAR, NDIM, IMQFUN /    9,    1,    2/
      DATA VCONST / 0.9999999776483E-02/
      DATA SIGVMI / 0.5000000000000    /
      DATA SIGVT / 0.5000000000000    /
      DATA SIGV / 0.6499999761581    
     +, 0.9699999690056    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.6999999880791    
     +, 0.7400000095367    
     +, 0.8999999761581    
     +, 0.3599999845028    
     +, 0.4399999976158    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.1599999964237    
     +, 0.1599999964237    
     +/
      DATA SIGA /  55.31547076840    
     +,  66.36792386424    
     +,  29.98503881401    
     +, -57.32483093375    
     +, -163.4130882808    
     +,  121.0326620991    
     +, -22.85310842491    
     +, -49.47277967132    
     +,  20.72370175086    
     +/
      hz75_1_nn = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz75_1_nn = hz75_1_nn + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz75_1_nn = VCONST * EXP (hz75_1_nn)
      END
      DOUBLE PRECISION FUNCTION hz80_1_fvar(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  10, 1)
      DOUBLE PRECISION SIGDEL(  10)
      DOUBLE PRECISION SIGA(  10)
      DATA NPAR, NDIM, IMQFUN /   10,    1,    2/
      DATA VCONST /  28.00000000000    /
      DATA SIGVMI / -200.0000000000    /
      DATA SIGVT /  1400.000000000    /
      DATA SIGV / 0.1099999994040    
     +, 0.1700000017881    
     +, 0.1899999976158    
     +, 0.4499999880791    
     +, 0.4699999988079    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.6200000047684    
     +, 0.6999999880791    
     +, 0.3599999845028    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.1599999964237    
     +/
      DATA SIGA / -324.4152503094    
     +,  78.00511844838    
     +, -10.61947541620    
     +,  39.24351263107    
     +, -48.21783716984    
     +,  210.2875519991    
     +,  43.63590764026    
     +,  32.63374154269    
     +, -115.4358340846    
     +, -2.032135943131    
     +/
      hz80_1_fvar = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz80_1_fvar = hz80_1_fvar + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz80_1_fvar = VCONST * EXP (hz80_1_fvar)
      END
      DOUBLE PRECISION FUNCTION hz80_1_mh(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   6, 1)
      DOUBLE PRECISION SIGDEL(   6)
      DOUBLE PRECISION SIGA(   6)
      DATA NPAR, NDIM, IMQFUN /    6,    1,    2/
      DATA VCONST /  1.750000000000    /
      DATA SIGVMI /  35.00000000000    /
      DATA SIGVT /  70.00000000000    /
      DATA SIGV / 0.8375000357628    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.6750000119209    
     +, 0.9250000119209    
     +, 0.5500000119209    
     +/
      DATA SIGDEL / 0.1500000059605    
     +, 0.6000000212225E-05
     +, 0.6000000212225E-05
     +, 0.3000000119209    
     +, 0.3000000119209    
     +, 0.6000000238419    
     +/
      DATA SIGA /  1396.651446398    
     +,  386.0638799400    
     +,  1953.668716065    
     +,  759.7889921489    
     +, -3980.426479991    
     +,  204.9701047087    
     +/
      hz80_1_mh = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz80_1_mh = hz80_1_mh + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz80_1_mh = VCONST * EXP (hz80_1_mh)
      END
      DOUBLE PRECISION FUNCTION hz80_1_msum(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   7, 1)
      DOUBLE PRECISION SIGDEL(   7)
      DOUBLE PRECISION SIGA(   7)
      DATA NPAR, NDIM, IMQFUN /    7,    1,    2/
      DATA VCONST /  3.000000000000    /
      DATA SIGVMI /  20.00000000000    /
      DATA SIGVT /  180.0000000000    /
      DATA SIGV / 0.7833333611488    
     +, 0.8500000238419    
     +, 0.8833333849907    
     +, 0.9500000476837    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.3000000119209    
     +/
      DATA SIGDEL / 0.2000000141561E-01
     +, 0.2000000141561E-01
     +, 0.2000000141561E-01
     +, 0.2000000141561E-01
     +, 0.6000000212225E-06
     +, 0.6000000212225E-06
     +, 0.4000000283122E-01
     +/
      DATA SIGA /  26.06064810814    
     +, -71.66202653150    
     +,  92.24354999896    
     +, -1143.117320640    
     +,  161.6844623850    
     +,  957.7323318385    
     +, -299.6775487790    
     +/
      hz80_1_msum = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz80_1_msum = hz80_1_msum + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz80_1_msum = VCONST * EXP (hz80_1_msum)
      END
      DOUBLE PRECISION FUNCTION hz80_1_nn(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   6, 1)
      DOUBLE PRECISION SIGDEL(   6)
      DOUBLE PRECISION SIGA(   6)
      DATA NPAR, NDIM, IMQFUN /    6,    1,    2/
      DATA VCONST / 0.9999999776483E-02/
      DATA SIGVMI / 0.5000000000000    /
      DATA SIGVT / 0.5000000000000    /
      DATA SIGV / 0.7699999809265    
     +, 0.9499999880791    
     +, 0.9699999690056    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.6999999880791    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +/
      DATA SIGA /-0.1573821426002    
     +, -32.54403852329    
     +,  103.0628521068    
     +,  8.079067878990    
     +, -68.59174833762    
     +,  2.056884655231    
     +/
      hz80_1_nn = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz80_1_nn = hz80_1_nn + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz80_1_nn = VCONST * EXP (hz80_1_nn)
      END
      DOUBLE PRECISION FUNCTION hz85_1_fvar(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  14, 1)
      DOUBLE PRECISION SIGDEL(  14)
      DOUBLE PRECISION SIGA(  14)
      DATA NPAR, NDIM, IMQFUN /   14,    1,    2/
      DATA VCONST /  28.00000000000    /
      DATA SIGVMI / -200.0000000000    /
      DATA SIGVT /  1400.000000000    /
      DATA SIGV / 0.1099999994040    
     +, 0.5899999737740    
     +, 0.6100000143051    
     +, 0.6299999952316    
     +, 0.6699999570847    
     +, 0.7099999785423    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.3400000035763    
     +, 0.3799999952316    
     +, 0.4199999868870    
     +, 0.4599999785423    
     +, 0.5000000000000    
     +, 0.1999999880791    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.1599999964237    
     +/
      DATA SIGA / -179.3844639566    
     +, -32.58304660788    
     +,  136.3716742154    
     +, -171.6574838079    
     +,  274.5340401832    
     +, -626.1920722827    
     +,  19.37144463955    
     +,  291.3270240967    
     +, -28.43752536529    
     +, -16.80027785355    
     +,  116.0772168176    
     +, -125.4163671344    
     +,  32.39548601101    
     +,  48.61564849760    
     +/
      hz85_1_fvar = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz85_1_fvar = hz85_1_fvar + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz85_1_fvar = VCONST * EXP (hz85_1_fvar)
      END
      DOUBLE PRECISION FUNCTION hz85_1_mh(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  12, 1)
      DOUBLE PRECISION SIGDEL(  12)
      DOUBLE PRECISION SIGA(  12)
      DATA NPAR, NDIM, IMQFUN /   12,    1,    2/
      DATA VCONST /  1.750000000000    /
      DATA SIGVMI /  35.00000000000    /
      DATA SIGVT /  70.00000000000    /
      DATA SIGV / 0.3750000149012E-01
     +, 0.6250000000000E-01
     +, 0.2125000059605    
     +, 0.2625000178814    
     +, 0.2874999940395    
     +, 0.8125000000000    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.5749999880791    
     +, 0.7250000238419    
     +, 0.8750000000000    
     +, 0.9250000119209    
     +/
      DATA SIGDEL / 0.1500000059605    
     +, 0.1500000059605    
     +, 0.1500000059605    
     +, 0.1500000059605    
     +, 0.1500000059605    
     +, 0.1500000059605    
     +, 0.6000000212225E-05
     +, 0.6000000212225E-05
     +, 0.3000000119209    
     +, 0.3000000119209    
     +, 0.3000000119209    
     +, 0.3000000119209    
     +/
      DATA SIGA /  108.8005814157    
     +, -151.7823081091    
     +,  336.7109496235    
     +, -784.5480509891    
     +,  559.4424358901    
     +,  2007.703753833    
     +, -168.6071125511    
     +, -1286.281552730    
     +, -544.8083352893    
     +,  5940.608146609    
     +, -32468.92028123    
     +,  26047.23989556    
     +/
      hz85_1_mh = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz85_1_mh = hz85_1_mh + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz85_1_mh = VCONST * EXP (hz85_1_mh)
      END
      DOUBLE PRECISION FUNCTION hz85_1_msum(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   7, 1)
      DOUBLE PRECISION SIGDEL(   7)
      DOUBLE PRECISION SIGA(   7)
      DATA NPAR, NDIM, IMQFUN /    7,    1,    2/
      DATA VCONST /  3.000000000000    /
      DATA SIGVMI /  20.00000000000    /
      DATA SIGVT /  180.0000000000    /
      DATA SIGV / 0.8250000476837    
     +, 0.8750000596046    
     +, 0.9083333611488    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.3500000238419    
     +, 0.9500000476837    
     +/
      DATA SIGDEL / 0.1000000070781E-01
     +, 0.1000000070781E-01
     +, 0.1000000070781E-01
     +, 0.6000000212225E-06
     +, 0.6000000212225E-06
     +, 0.2000000141561E-01
     +, 0.2000000141561E-01
     +/
      DATA SIGA /  23.70116091050    
     +, -53.89293608754    
     +,  48.76018392912    
     +,  65.87942378444    
     +,  423.7343088653    
     +, -132.5407636047    
     +, -512.6770497011    
     +/
      hz85_1_msum = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz85_1_msum = hz85_1_msum + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz85_1_msum = VCONST * EXP (hz85_1_msum)
      END
      DOUBLE PRECISION FUNCTION hz85_1_nn(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  10, 1)
      DOUBLE PRECISION SIGDEL(  10)
      DOUBLE PRECISION SIGA(  10)
      DATA NPAR, NDIM, IMQFUN /   10,    1,    2/
      DATA VCONST / 0.9999999776483E-02/
      DATA SIGVMI / 0.5000000000000    /
      DATA SIGVT / 0.5000000000000    /
      DATA SIGV / 0.7099999785423    
     +, 0.7299999594688    
     +, 0.7500000000000    
     +, 0.8299999833107    
     +, 0.9300000071526    
     +, 0.9699999690056    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.3599999845028    
     +, 0.4399999976158    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.1599999964237    
     +, 0.1599999964237    
     +/
      DATA SIGA / -44.54310233225    
     +,  80.72846003454    
     +, -50.23626780355    
     +,  21.36747384998    
     +, -41.89159363137    
     +,  115.9986903693    
     +,  84.51213338665    
     +, -103.2608748144    
     +, -246.1616267448    
     +,  150.3568389244    
     +/
      hz85_1_nn = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz85_1_nn = hz85_1_nn + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz85_1_nn = VCONST * EXP (hz85_1_nn)
      END
      DOUBLE PRECISION FUNCTION hz90_1_fvar(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  10, 1)
      DOUBLE PRECISION SIGDEL(  10)
      DOUBLE PRECISION SIGA(  10)
      DATA NPAR, NDIM, IMQFUN /   10,    1,    2/
      DATA VCONST /  28.00000000000    /
      DATA SIGVMI / -200.0000000000    /
      DATA SIGVT /  1400.000000000    /
      DATA SIGV / 0.1099999994040    
     +, 0.4899999797344    
     +, 0.5699999928474    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.1799999922514    
     +, 0.2599999904633    
     +, 0.6599999666214    
     +, 0.6999999880791    
     +, 0.3599999845028    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.1599999964237    
     +/
      DATA SIGA / -246.7066273286    
     +, -18.91431713915    
     +,  7.844522974691    
     +,  138.8380061064    
     +,  82.86491579073    
     +,  74.93696897580    
     +, -31.45016711979    
     +,  87.68104026294    
     +, -229.1454639136    
     +,  23.10708863524    
     +/
      hz90_1_fvar = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz90_1_fvar = hz90_1_fvar + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz90_1_fvar = VCONST * EXP (hz90_1_fvar)
      END
      DOUBLE PRECISION FUNCTION hz90_1_mh(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   8, 1)
      DOUBLE PRECISION SIGDEL(   8)
      DOUBLE PRECISION SIGA(   8)
      DATA NPAR, NDIM, IMQFUN /    8,    1,    2/
      DATA VCONST /  1.750000000000    /
      DATA SIGVMI /  35.00000000000    /
      DATA SIGVT /  70.00000000000    /
      DATA SIGV / 0.6125000119209    
     +, 0.7875000238419    
     +, 0.8874999880791    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.1250000000000    
     +, 0.7250000238419    
     +, 0.3499999940395    
     +/
      DATA SIGDEL / 0.4000000283122E-01
     +, 0.4000000283122E-01
     +, 0.4000000283122E-01
     +, 0.1600000018698E-05
     +, 0.1600000018698E-05
     +, 0.8000000566244E-01
     +, 0.8000000566244E-01
     +, 0.1600000113249    
     +/
      DATA SIGA / -6.571800150564    
     +, -41.36466629658    
     +, -15.88710431137    
     +, 0.3245785024294    
     +,  26.88217265423    
     +,-0.2683115747112    
     +,  32.42044680168    
     +, -1.397961453693    
     +/
      hz90_1_mh = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz90_1_mh = hz90_1_mh + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz90_1_mh = VCONST * EXP (hz90_1_mh)
      END
      DOUBLE PRECISION FUNCTION hz90_1_msum(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   6, 1)
      DOUBLE PRECISION SIGDEL(   6)
      DOUBLE PRECISION SIGA(   6)
      DATA NPAR, NDIM, IMQFUN /    6,    1,    2/
      DATA VCONST /  3.000000000000    /
      DATA SIGVMI /  20.00000000000    /
      DATA SIGVT /  180.0000000000    /
      DATA SIGV / 0.8916667103767    
     +, 0.9250000715256    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.8500000238419    
     +, 0.3000000119209    
     +/
      DATA SIGDEL / 0.1000000070781E-01
     +, 0.1000000070781E-01
     +, 0.6000000212225E-06
     +, 0.6000000212225E-06
     +, 0.2000000141561E-01
     +, 0.4000000283122E-01
     +/
      DATA SIGA / -48.71847644876    
     +, -116.0890736229    
     +,  155.5267524580    
     +,  60.53614494955    
     +,  27.03438375976    
     +, -233.8288460416    
     +/
      hz90_1_msum = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz90_1_msum = hz90_1_msum + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz90_1_msum = VCONST * EXP (hz90_1_msum)
      END
      DOUBLE PRECISION FUNCTION hz90_1_nn(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   7, 1)
      DOUBLE PRECISION SIGDEL(   7)
      DOUBLE PRECISION SIGA(   7)
      DATA NPAR, NDIM, IMQFUN /    7,    1,    2/
      DATA VCONST / 0.9999999776483E-02/
      DATA SIGVMI / 0.5000000000000    /
      DATA SIGVT / 0.5000000000000    /
      DATA SIGV / 0.9499999880791    
     +, 0.9699999690056    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.5000000000000    
     +, 0.5399999618530    
     +, 0.8399999737740    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.1599999964237    
     +/
      DATA SIGA / -140.9541440648    
     +,  263.9521217551    
     +,  5.624731491249    
     +, -130.3534647586    
     +,  25.28096937294    
     +, -29.37241348623    
     +,  16.20811721145    
     +/
      hz90_1_nn = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz90_1_nn = hz90_1_nn + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz90_1_nn = VCONST * EXP (hz90_1_nn)
      END
      DOUBLE PRECISION FUNCTION hz95_1_fvar(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  12, 1)
      DOUBLE PRECISION SIGDEL(  12)
      DOUBLE PRECISION SIGA(  12)
      DATA NPAR, NDIM, IMQFUN /   12,    1,    2/
      DATA VCONST /  28.00000000000    /
      DATA SIGVMI / -200.0000000000    /
      DATA SIGVT /  1400.000000000    /
      DATA SIGV / 0.1099999994040    
     +, 0.2500000000000    
     +, 0.3899999856949    
     +, 0.4499999880791    
     +, 0.4699999988079    
     +, 0.6499999761581    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.3400000035763    
     +, 0.5399999618530    
     +, 0.5799999833107    
     +, 0.6999999880791    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +/
      DATA SIGA / -108.1396083548    
     +,  16.32690910315    
     +,  13.17059040586    
     +,  34.35524016514    
     +, -42.19700055461    
     +, -73.58554280264    
     +,  73.00930025216    
     +,  32.25409695452    
     +, -23.55461497524    
     +, -52.70181345060    
     +,  84.11610440687    
     +, -14.13603450349    
     +/
      hz95_1_fvar = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz95_1_fvar = hz95_1_fvar + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz95_1_fvar = VCONST * EXP (hz95_1_fvar)
      END
      DOUBLE PRECISION FUNCTION hz95_1_mh(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   5, 1)
      DOUBLE PRECISION SIGDEL(   5)
      DOUBLE PRECISION SIGA(   5)
      DATA NPAR, NDIM, IMQFUN /    5,    1,    2/
      DATA VCONST /  1.750000000000    /
      DATA SIGVMI /  35.00000000000    /
      DATA SIGVT /  70.00000000000    /
      DATA SIGV / 0.8750000000000    
     +, 0.9250000119209    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.7500000000000    
     +/
      DATA SIGDEL / 0.7000000029802E-01
     +, 0.7000000029802E-01
     +, 0.1399999973728E-05
     +, 0.1399999973728E-05
     +, 0.1400000005960    
     +/
      DATA SIGA /  637.7926723177    
     +, -1868.378192433    
     +, -35.95518380762    
     +,  1132.580711485    
     +,  52.79447979109    
     +/
      hz95_1_mh = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz95_1_mh = hz95_1_mh + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz95_1_mh = VCONST * EXP (hz95_1_mh)
      END
      DOUBLE PRECISION FUNCTION hz95_1_msum(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   6, 1)
      DOUBLE PRECISION SIGDEL(   6)
      DOUBLE PRECISION SIGA(   6)
      DATA NPAR, NDIM, IMQFUN /    6,    1,    2/
      DATA VCONST /  3.000000000000    /
      DATA SIGVMI /  20.00000000000    /
      DATA SIGVT /  180.0000000000    /
      DATA SIGV / 0.8750000596046    
     +, 0.9250000715256    
     +, 0.9416667222977    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.3000000119209    
     +/
      DATA SIGDEL / 0.1000000070781E-01
     +, 0.1000000070781E-01
     +, 0.1000000070781E-01
     +, 0.6000000212225E-06
     +, 0.6000000212225E-06
     +, 0.4000000283122E-01
     +/
      DATA SIGA /  22.50233174147    
     +,  115.7682520585    
     +, -1018.986014267    
     +,  111.8981487109    
     +,  768.4792628978    
     +, -225.0282631362    
     +/
      hz95_1_msum = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz95_1_msum = hz95_1_msum + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz95_1_msum = VCONST * EXP (hz95_1_msum)
      END
      DOUBLE PRECISION FUNCTION hz95_1_nn(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   6, 1)
      DOUBLE PRECISION SIGDEL(   6)
      DOUBLE PRECISION SIGA(   6)
      DATA NPAR, NDIM, IMQFUN /    6,    1,    2/
      DATA VCONST / 0.9999999776483E-02/
      DATA SIGVMI / 0.5000000000000    /
      DATA SIGVT / 0.5000000000000    /
      DATA SIGV / 0.9499999880791    
     +, 0.9699999690056    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.7400000095367    
     +, 0.8999999761581    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +/
      DATA SIGA / -91.97472285483    
     +,  175.2624972353    
     +,  7.830033144628    
     +, -96.93573216556    
     +, -2.523224473789    
     +,  17.43570901532    
     +/
      hz95_1_nn = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz95_1_nn = hz95_1_nn + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz95_1_nn = VCONST * EXP (hz95_1_nn)
      END
      DOUBLE PRECISION FUNCTION hz975_1_fvar(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  11, 1)
      DOUBLE PRECISION SIGDEL(  11)
      DOUBLE PRECISION SIGA(  11)
      DATA NPAR, NDIM, IMQFUN /   11,    1,    2/
      DATA VCONST /  28.00000000000    /
      DATA SIGVMI / -200.0000000000    /
      DATA SIGVT /  1400.000000000    /
      DATA SIGV / 0.1099999994040    
     +, 0.3100000023842    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.2599999904633    
     +, 0.4199999868870    
     +, 0.4599999785423    
     +, 0.5000000000000    
     +, 0.5799999833107    
     +, 0.6599999666214    
     +, 0.6999999880791    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +/
      DATA SIGA / -189.8378500150    
     +, -29.41158106572    
     +,  104.1834911257    
     +,  133.5385931532    
     +,  41.36990824031    
     +,  67.62721248828    
     +, -81.04564532540    
     +,  9.983425262095    
     +,  12.40730212320    
     +,  140.8286040951    
     +, -348.4141963681    
     +/
      hz975_1_fvar = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz975_1_fvar = hz975_1_fvar + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz975_1_fvar = VCONST * EXP (hz975_1_fvar)
      END
      DOUBLE PRECISION FUNCTION hz975_1_mh(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   5, 1)
      DOUBLE PRECISION SIGDEL(   5)
      DOUBLE PRECISION SIGA(   5)
      DATA NPAR, NDIM, IMQFUN /    5,    1,    2/
      DATA VCONST /  1.750000000000    /
      DATA SIGVMI /  35.00000000000    /
      DATA SIGVT /  70.00000000000    /
      DATA SIGV / 0.8625000119209    
     +, 0.9125000238419    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.7500000000000    
     +/
      DATA SIGDEL / 0.8500000089407E-01
     +, 0.8500000089407E-01
     +, 0.3400000196052E-05
     +, 0.3400000196052E-05
     +, 0.3400000035763    
     +/
      DATA SIGA /  358.9882510506    
     +, -762.0215430014    
     +, -8.920153273220    
     +,  376.2602182898    
     +,  13.26204477568    
     +/
      hz975_1_mh = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz975_1_mh = hz975_1_mh + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz975_1_mh = VCONST * EXP (hz975_1_mh)
      END
      DOUBLE PRECISION FUNCTION hz975_1_msum(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   9, 1)
      DOUBLE PRECISION SIGDEL(   9)
      DOUBLE PRECISION SIGA(   9)
      DATA NPAR, NDIM, IMQFUN /    9,    1,    2/
      DATA VCONST /  3.000000000000    /
      DATA SIGVMI /  20.00000000000    /
      DATA SIGVT /  180.0000000000    /
      DATA SIGV / 0.5750000476837    
     +, 0.5916666984558    
     +, 0.9250000715256    
     +, 0.9416667222977    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.3500000238419    
     +, 0.7000000476837    
     +, 0.8333333730698    
     +/
      DATA SIGDEL / 0.1666666753590E-01
     +, 0.1666666753590E-01
     +, 0.1666666753590E-01
     +, 0.1666666753590E-01
     +, 0.9999999974752E-06
     +, 0.9999999974752E-06
     +, 0.3333333507180E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +/
      DATA SIGA / -1.725174644744    
     +,  2.251736542664    
     +, -55.64306040660    
     +, -11.58295867182    
     +,  20.00147600397    
     +,  42.51932537706    
     +, -32.25087669683    
     +, -7.290434989890    
     +,  16.55397722606    
     +/
      hz975_1_msum = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz975_1_msum = hz975_1_msum + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz975_1_msum = VCONST * EXP (hz975_1_msum)
      END
      DOUBLE PRECISION FUNCTION hz975_1_nn(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   9, 1)
      DOUBLE PRECISION SIGDEL(   9)
      DOUBLE PRECISION SIGA(   9)
      DATA NPAR, NDIM, IMQFUN /    9,    1,    2/
      DATA VCONST / 0.9999999776483E-02/
      DATA SIGVMI / 0.5000000000000    /
      DATA SIGVT / 0.5000000000000    /
      DATA SIGV / 0.7899999618530    
     +, 0.9499999880791    
     +, 0.9699999690056    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.5799999833107    
     +, 0.6999999880791    
     +, 0.8599999547005    
     +, 0.8999999761581    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +/
      DATA SIGA / -14.24700749682    
     +, -97.72416814418    
     +,  170.0649467619    
     +,  6.541489069776    
     +, -95.73408560395    
     +,-0.5896718005354    
     +,  7.879489290699    
     +, -6.945300044831    
     +,  42.60299003289    
     +/
      hz975_1_nn = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz975_1_nn = hz975_1_nn + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz975_1_nn = VCONST * EXP (hz975_1_nn)
      END
      DOUBLE PRECISION FUNCTION hz100_2_fvar(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  13, 1)
      DOUBLE PRECISION SIGDEL(  13)
      DOUBLE PRECISION SIGA(  13)
      DATA NPAR, NDIM, IMQFUN /   13,    1,    2/
      DATA VCONST /  28.00000000000    /
      DATA SIGVMI / -200.0000000000    /
      DATA SIGVT /  1400.000000000    /
      DATA SIGV / 0.2099999934435    
     +, 0.2299999892712    
     +, 0.3700000047684    
     +, 0.6100000143051    
     +, 0.6699999570847    
     +, 0.6899999976158    
     +, 0.7099999785423    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.5399999618530    
     +, 0.8199999928474    
     +, 0.8999999761581    
     +, 0.1199999973178    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.1599999964237    
     +/
      DATA SIGA / -43.26303026519    
     +,  42.76254104179    
     +,  4.781377500741    
     +,  4.031290851695    
     +, -21.05223990933    
     +,  34.82572575980    
     +, -16.90378105058    
     +,  90.49614891899    
     +,  85.23169229567    
     +, -6.360944479561    
     +,  18.43117546890    
     +, -113.8604267711    
     +, -108.3841937383    
     +/
      hz100_2_fvar = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz100_2_fvar = hz100_2_fvar + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz100_2_fvar = VCONST * EXP (hz100_2_fvar)
      END
      DOUBLE PRECISION FUNCTION hz100_2_msum(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   7, 1)
      DOUBLE PRECISION SIGDEL(   7)
      DOUBLE PRECISION SIGA(   7)
      DATA NPAR, NDIM, IMQFUN /    7,    1,    2/
      DATA VCONST /  6.000000000000    /
      DATA SIGVMI /  20.00000000000    /
      DATA SIGVT /  180.0000000000    /
      DATA SIGV / 0.3833333551884    
     +, 0.4166666865349    
     +, 0.8166667222977    
     +, 0.9166666865349    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.3000000119209    
     +/
      DATA SIGDEL / 0.5333333835006E-01
     +, 0.5333333835006E-01
     +, 0.5333333835006E-01
     +, 0.5333333835006E-01
     +, 0.1600000018698E-05
     +, 0.1600000018698E-05
     +, 0.1066666767001    
     +/
      DATA SIGA /  2.302199351401    
     +, -6.643272071100    
     +, 0.2311162510463    
     +, -43.88100326582    
     +,  13.34742840211    
     +,  34.68278695207    
     +, -17.56884301630    
     +/
      hz100_2_msum = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz100_2_msum = hz100_2_msum + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz100_2_msum = VCONST * EXP (hz100_2_msum)
      END
      DOUBLE PRECISION FUNCTION hz105_2_fvar(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  11, 1)
      DOUBLE PRECISION SIGDEL(  11)
      DOUBLE PRECISION SIGA(  11)
      DATA NPAR, NDIM, IMQFUN /   11,    1,    2/
      DATA VCONST /  28.00000000000    /
      DATA SIGVMI / -200.0000000000    /
      DATA SIGVT /  1400.000000000    /
      DATA SIGV / 0.4899999797344    
     +, 0.6100000143051    
     +, 0.6499999761581    
     +, 0.7699999809265    
     +, 0.7899999618530    
     +, 0.8700000047684    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.1400000005960    
     +, 0.2599999904633    
     +, 0.3400000035763    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +/
      DATA SIGA / -6.648481954420    
     +,  5.231779145528    
     +, -8.044432088666    
     +,  21.26647984696    
     +, -36.22521636422    
     +, -13.15140750023    
     +,  63.29440088642    
     +,  19.04179440564    
     +, -95.06125779545    
     +,  33.72093337674    
     +, -12.05095087358    
     +/
      hz105_2_fvar = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz105_2_fvar = hz105_2_fvar + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz105_2_fvar = VCONST * EXP (hz105_2_fvar)
      END
      DOUBLE PRECISION FUNCTION hz105_2_msum(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   8, 1)
      DOUBLE PRECISION SIGDEL(   8)
      DOUBLE PRECISION SIGA(   8)
      DATA NPAR, NDIM, IMQFUN /    8,    1,    2/
      DATA VCONST /  6.000000000000    /
      DATA SIGVMI /  20.00000000000    /
      DATA SIGVT /  180.0000000000    /
      DATA SIGV / 0.3833333551884    
     +, 0.4166666865349    
     +, 0.7833333611488    
     +, 0.8166667222977    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.3000000119209    
     +, 0.5000000000000    
     +/
      DATA SIGDEL / 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.1333333402872    
     +, 0.1333333402872    
     +/
      DATA SIGA / -18.04137740434    
     +, -3.919308506945    
     +, -6.129633888811    
     +, -7.188511323151    
     +,  10.48759866748    
     +,  4.288085643042    
     +, 0.5528485659382    
     +,  6.297097421245    
     +/
      hz105_2_msum = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz105_2_msum = hz105_2_msum + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz105_2_msum = VCONST * EXP (hz105_2_msum)
      END
      DOUBLE PRECISION FUNCTION hz110_2_fvar(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  10, 1)
      DOUBLE PRECISION SIGDEL(  10)
      DOUBLE PRECISION SIGA(  10)
      DATA NPAR, NDIM, IMQFUN /   10,    1,    2/
      DATA VCONST /  28.00000000000    /
      DATA SIGVMI / -200.0000000000    /
      DATA SIGVT /  1400.000000000    /
      DATA SIGV / 0.2500000000000    
     +, 0.2899999916553    
     +, 0.6100000143051    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.6999999880791    
     +, 0.7400000095367    
     +, 0.8599999547005    
     +, 0.1199999973178    
     +, 0.5199999809265    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.1599999964237    
     +, 0.1599999964237    
     +/
      DATA SIGA / 0.4586486377080    
     +,  4.306227164403    
     +, 0.7740826675604    
     +,  31.61706459526    
     +,  26.87163191651    
     +,  8.498338067054    
     +, -7.589349789051    
     +, -29.22392880494    
     +, -37.80613398036    
     +, -12.93281080868    
     +/
      hz110_2_fvar = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz110_2_fvar = hz110_2_fvar + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz110_2_fvar = VCONST * EXP (hz110_2_fvar)
      END
      DOUBLE PRECISION FUNCTION hz110_2_msum(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   7, 1)
      DOUBLE PRECISION SIGDEL(   7)
      DOUBLE PRECISION SIGA(   7)
      DATA NPAR, NDIM, IMQFUN /    7,    1,    2/
      DATA VCONST /  6.000000000000    /
      DATA SIGVMI /  20.00000000000    /
      DATA SIGVT /  180.0000000000    /
      DATA SIGV / 0.7500000596046    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.3666666746140    
     +, 0.4333333671093    
     +, 0.5000000000000    
     +, 0.9000000357628    
     +/
      DATA SIGDEL / 0.6666667014360E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.1333333402872    
     +, 0.1333333402872    
     +, 0.1333333402872    
     +, 0.1333333402872    
     +/
      DATA SIGA /  10.79585457992    
     +,  25.36940299138    
     +,  52.07560858365    
     +, -79.66160814958    
     +,  60.56116143586    
     +, -13.89385975238    
     +, -77.17552066506    
     +/
      hz110_2_msum = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz110_2_msum = hz110_2_msum + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz110_2_msum = VCONST * EXP (hz110_2_msum)
      END
      DOUBLE PRECISION FUNCTION hz75_2_fvar(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  12, 1)
      DOUBLE PRECISION SIGDEL(  12)
      DOUBLE PRECISION SIGA(  12)
      DATA NPAR, NDIM, IMQFUN /   12,    1,    2/
      DATA VCONST /  28.00000000000    /
      DATA SIGVMI / -200.0000000000    /
      DATA SIGVT /  1400.000000000    /
      DATA SIGV / 0.4299999773502    
     +, 0.4499999880791    
     +, 0.5299999713898    
     +, 0.6499999761581    
     +, 0.8100000023842    
     +, 0.8499999642372    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.2199999988079    
     +, 0.3799999952316    
     +, 0.8999999761581    
     +, 0.1199999973178    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.1599999964237    
     +/
      DATA SIGA / -18.91939879582    
     +,  7.604322879672    
     +, -4.398169488490    
     +, -7.839277255978    
     +,  1.988108089066    
     +, -99.13806415947    
     +,  17.82412112387    
     +, -19.02883393933    
     +, -42.77627658082    
     +,  15.50672577770    
     +,  111.4926697318    
     +,  10.08986581175    
     +/
      hz75_2_fvar = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz75_2_fvar = hz75_2_fvar + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz75_2_fvar = VCONST * EXP (hz75_2_fvar)
      END
      DOUBLE PRECISION FUNCTION hz75_2_msum(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  14, 1)
      DOUBLE PRECISION SIGDEL(  14)
      DOUBLE PRECISION SIGA(  14)
      DATA NPAR, NDIM, IMQFUN /   14,    1,    2/
      DATA VCONST /  6.000000000000    /
      DATA SIGVMI /  20.00000000000    /
      DATA SIGVT /  180.0000000000    /
      DATA SIGV / 0.4833333492279    
     +, 0.5166667103767    
     +, 0.5500000119209    
     +, 0.6166666746140    
     +, 0.7166666984558    
     +, 0.7500000596046    
     +, 0.7833333611488    
     +, 0.8166667222977    
     +, 0.8500000238419    
     +, 0.8833333849907    
     +, 0.9500000476837    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.3000000119209    
     +/
      DATA SIGDEL / 0.2000000178814    
     +, 0.2000000178814    
     +, 0.2000000178814    
     +, 0.2000000178814    
     +, 0.2000000178814    
     +, 0.2000000178814    
     +, 0.2000000178814    
     +, 0.2000000178814    
     +, 0.2000000178814    
     +, 0.2000000178814    
     +, 0.2000000178814    
     +, 0.6000000212225E-05
     +, 0.6000000212225E-05
     +, 0.4000000357628    
     +/
      DATA SIGA / -3105.125035229    
     +,  8368.027915787    
     +, -7126.158587892    
     +,  2363.862456929    
     +,  11331.64519731    
     +, -57528.22004535    
     +,  104781.9148305    
     +, -61322.53934395    
     +, -57398.03628870    
     +,  86752.20719156    
     +, -30825.50032375    
     +,  597.9480191836    
     +,  4126.052851759    
     +,  40.25884962051    
     +/
      hz75_2_msum = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz75_2_msum = hz75_2_msum + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz75_2_msum = VCONST * EXP (hz75_2_msum)
      END
      DOUBLE PRECISION FUNCTION hz80_2_fvar(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  12, 1)
      DOUBLE PRECISION SIGDEL(  12)
      DOUBLE PRECISION SIGA(  12)
      DATA NPAR, NDIM, IMQFUN /   12,    1,    2/
      DATA VCONST /  28.00000000000    /
      DATA SIGVMI / -200.0000000000    /
      DATA SIGVT /  1400.000000000    /
      DATA SIGV / 0.2099999934435    
     +, 0.2899999916553    
     +, 0.3299999833107    
     +, 0.3499999940395    
     +, 0.6699999570847    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.5000000000000    
     +, 0.8599999547005    
     +, 0.8999999761581    
     +, 0.1199999973178    
     +, 0.7599999904633    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.1599999964237    
     +, 0.1599999964237    
     +/
      DATA SIGA /  61.45094913274    
     +,  79.40088686149    
     +, -99.01824866474    
     +,  69.29750713223    
     +, -10.51940618886    
     +,  235.1007309189    
     +,  187.8370297111    
     +,  3.630843142994    
     +,  102.4675490901    
     +, -322.8150157625    
     +, -375.2701259892    
     +,  39.86046300700    
     +/
      hz80_2_fvar = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz80_2_fvar = hz80_2_fvar + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz80_2_fvar = VCONST * EXP (hz80_2_fvar)
      END
      DOUBLE PRECISION FUNCTION hz80_2_msum(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   7, 1)
      DOUBLE PRECISION SIGDEL(   7)
      DOUBLE PRECISION SIGA(   7)
      DATA NPAR, NDIM, IMQFUN /    7,    1,    2/
      DATA VCONST /  6.000000000000    /
      DATA SIGVMI /  20.00000000000    /
      DATA SIGVT /  180.0000000000    /
      DATA SIGV / 0.3500000238419    
     +, 0.6833333969116    
     +, 0.8166667222977    
     +, 0.8833333849907    
     +, 0.9166666865349    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +/
      DATA SIGDEL / 0.1333333402872    
     +, 0.1333333402872    
     +, 0.1333333402872    
     +, 0.1333333402872    
     +, 0.1333333402872    
     +, 0.3999999989901E-05
     +, 0.3999999989901E-05
     +/
      DATA SIGA / -26.93697517293    
     +,  13.25923761094    
     +,  73.26032938259    
     +,  1.549295162672    
     +, -239.3363554525    
     +,  19.79976168956    
     +,  145.0142475627    
     +/
      hz80_2_msum = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz80_2_msum = hz80_2_msum + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz80_2_msum = VCONST * EXP (hz80_2_msum)
      END
      DOUBLE PRECISION FUNCTION hz85_2_fvar(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  11, 1)
      DOUBLE PRECISION SIGDEL(  11)
      DOUBLE PRECISION SIGA(  11)
      DATA NPAR, NDIM, IMQFUN /   11,    1,    2/
      DATA VCONST /  28.00000000000    /
      DATA SIGVMI / -200.0000000000    /
      DATA SIGVT /  1400.000000000    /
      DATA SIGV / 0.2299999892712    
     +, 0.5099999904633    
     +, 0.7699999809265    
     +, 0.7899999618530    
     +, 0.8899999856949    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.3799999952316    
     +, 0.6999999880791    
     +, 0.1199999973178    
     +, 0.5999999642372    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.1599999964237    
     +, 0.1599999964237    
     +/
      DATA SIGA /  47.44172255679    
     +, -2.082319975037    
     +,  22.10231495843    
     +, -32.36517606821    
     +, -10.85118727869    
     +,  124.2189330194    
     +,  24.64766370153    
     +,  6.934434883908    
     +, -6.507477272842    
     +, -188.3942160230    
     +,  1.565346578329    
     +/
      hz85_2_fvar = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz85_2_fvar = hz85_2_fvar + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz85_2_fvar = VCONST * EXP (hz85_2_fvar)
      END
      DOUBLE PRECISION FUNCTION hz85_2_msum(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   5, 1)
      DOUBLE PRECISION SIGDEL(   5)
      DOUBLE PRECISION SIGA(   5)
      DATA NPAR, NDIM, IMQFUN /    5,    1,    2/
      DATA VCONST /  6.000000000000    /
      DATA SIGVMI /  20.00000000000    /
      DATA SIGVT /  180.0000000000    /
      DATA SIGV / 0.9166666865349    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.4333333671093    
     +, 0.8333333730698    
     +/
      DATA SIGDEL / 0.9333333373070E-01
     +, 0.2799999947456E-05
     +, 0.2799999947456E-05
     +, 0.1866666674614    
     +, 0.1866666674614    
     +/
      DATA SIGA / -129.9743484847    
     +,  4.046177377316    
     +,  75.40308979040    
     +, -17.49973293205    
     +,  52.87721524912    
     +/
      hz85_2_msum = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz85_2_msum = hz85_2_msum + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz85_2_msum = VCONST * EXP (hz85_2_msum)
      END
      DOUBLE PRECISION FUNCTION hz90_2_fvar(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  10, 1)
      DOUBLE PRECISION SIGDEL(  10)
      DOUBLE PRECISION SIGA(  10)
      DATA NPAR, NDIM, IMQFUN /   10,    1,    2/
      DATA VCONST /  28.00000000000    /
      DATA SIGVMI / -200.0000000000    /
      DATA SIGVT /  1400.000000000    /
      DATA SIGV / 0.2699999809265    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.4199999868870    
     +, 0.8599999547005    
     +, 0.8999999761581    
     +, 0.1199999973178    
     +, 0.5199999809265    
     +, 0.5999999642372    
     +, 0.7599999904633    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.1599999964237    
     +, 0.1599999964237    
     +, 0.1599999964237    
     +, 0.1599999964237    
     +/
      DATA SIGA /  45.73698947583    
     +,  172.7009239833    
     +,  42.52682836476    
     +,  2.417650053381    
     +, -42.22929032107    
     +, -15.58725078131    
     +, -239.6218299639    
     +,  10.35620532880    
     +, -16.57936527024    
     +,  17.32224236321    
     +/
      hz90_2_fvar = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz90_2_fvar = hz90_2_fvar + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz90_2_fvar = VCONST * EXP (hz90_2_fvar)
      END
      DOUBLE PRECISION FUNCTION hz90_2_msum(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   6, 1)
      DOUBLE PRECISION SIGDEL(   6)
      DOUBLE PRECISION SIGA(   6)
      DATA NPAR, NDIM, IMQFUN /    6,    1,    2/
      DATA VCONST /  6.000000000000    /
      DATA SIGVMI /  20.00000000000    /
      DATA SIGVT /  180.0000000000    /
      DATA SIGV / 0.8166667222977    
     +, 0.8833333849907    
     +, 0.9166666865349    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.2333333492279    
     +/
      DATA SIGDEL / 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.1333333402872    
     +/
      DATA SIGA /  6.098716486227    
     +,  317.3775776358    
     +, -590.2327877586    
     +,  24.67742451229    
     +,  249.0552650279    
     +, -41.01338592343    
     +/
      hz90_2_msum = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz90_2_msum = hz90_2_msum + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz90_2_msum = VCONST * EXP (hz90_2_msum)
      END
      DOUBLE PRECISION FUNCTION hz95_2_fvar(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   9, 1)
      DOUBLE PRECISION SIGDEL(   9)
      DOUBLE PRECISION SIGA(   9)
      DATA NPAR, NDIM, IMQFUN /    9,    1,    2/
      DATA VCONST /  28.00000000000    /
      DATA SIGVMI / -200.0000000000    /
      DATA SIGVT /  1400.000000000    /
      DATA SIGV / 0.2299999892712    
     +, 0.4299999773502    
     +, 0.4499999880791    
     +, 0.5299999713898    
     +, 0.6299999952316    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.8599999547005    
     +, 0.8999999761581    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +/
      DATA SIGA / -5.007245361394    
     +, -4.174538033067    
     +,-0.9966804222117    
     +, -3.737601673762    
     +,  1.417657398167    
     +, -6.772821727531    
     +,  323.6911689943    
     +,  306.4121407267    
     +, -656.9377937279    
     +/
      hz95_2_fvar = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz95_2_fvar = hz95_2_fvar + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz95_2_fvar = VCONST * EXP (hz95_2_fvar)
      END
      DOUBLE PRECISION FUNCTION hz95_2_msum(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   5, 1)
      DOUBLE PRECISION SIGDEL(   5)
      DOUBLE PRECISION SIGA(   5)
      DATA NPAR, NDIM, IMQFUN /    5,    1,    2/
      DATA VCONST /  6.000000000000    /
      DATA SIGVMI /  20.00000000000    /
      DATA SIGVT /  180.0000000000    /
      DATA SIGV / 0.9166666865349    
     +, 0.9500000476837    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.3000000119209    
     +/
      DATA SIGDEL / 0.3333333507180E-01
     +, 0.3333333507180E-01
     +, 0.9999999974752E-06
     +, 0.9999999974752E-06
     +, 0.6666667014360E-01
     +/
      DATA SIGA /  170.6723244922    
     +, -502.0146171774    
     +,  27.08149162617    
     +,  306.9312410684    
     +, -51.71186839040    
     +/
      hz95_2_msum = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz95_2_msum = hz95_2_msum + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz95_2_msum = VCONST * EXP (hz95_2_msum)
      END
      DOUBLE PRECISION FUNCTION hz975_2_fvar(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  11, 1)
      DOUBLE PRECISION SIGDEL(  11)
      DOUBLE PRECISION SIGA(  11)
      DATA NPAR, NDIM, IMQFUN /   11,    1,    2/
      DATA VCONST /  28.00000000000    /
      DATA SIGVMI / -200.0000000000    /
      DATA SIGVT /  1400.000000000    /
      DATA SIGV / 0.2699999809265    
     +, 0.4299999773502    
     +, 0.4899999797344    
     +, 0.7099999785423    
     +, 0.8299999833107    
     +, 0.8899999856949    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.2199999988079    
     +, 0.1199999973178    
     +, 0.5999999642372    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.1599999964237    
     +, 0.1599999964237    
     +/
      DATA SIGA /  55.55072304590    
     +,  16.12006511589    
     +, -4.359047114823    
     +, -2.110135070346    
     +,  21.29194230520    
     +, -190.2038451056    
     +,  357.5581531872    
     +,  157.4833057540    
     +,  100.0465114085    
     +, -565.8767630489    
     +,  12.20706205718    
     +/
      hz975_2_fvar = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz975_2_fvar = hz975_2_fvar + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz975_2_fvar = VCONST * EXP (hz975_2_fvar)
      END
      DOUBLE PRECISION FUNCTION hz975_2_msum(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   7, 1)
      DOUBLE PRECISION SIGDEL(   7)
      DOUBLE PRECISION SIGA(   7)
      DATA NPAR, NDIM, IMQFUN /    7,    1,    2/
      DATA VCONST /  6.000000000000    /
      DATA SIGVMI /  20.00000000000    /
      DATA SIGVT /  180.0000000000    /
      DATA SIGV / 0.4166666865349    
     +, 0.7500000596046    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.5000000000000    
     +, 0.8333333730698    
     +, 0.9000000357628    
     +/
      DATA SIGDEL / 0.6666667014360E-01
     +, 0.6666667014360E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.1333333402872    
     +, 0.1333333402872    
     +, 0.1333333402872    
     +/
      DATA SIGA / -15.96851243697    
     +,  8.058449746949    
     +,  6.926163751960    
     +,  49.47882675432    
     +,  8.143480816023    
     +,  15.49653549318    
     +, -80.79428091711    
     +/
      hz975_2_msum = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz975_2_msum = hz975_2_msum + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz975_2_msum = VCONST * EXP (hz975_2_msum)
      END
      DOUBLE PRECISION FUNCTION hz100_3_mh(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   7, 1)
      DOUBLE PRECISION SIGDEL(   7)
      DOUBLE PRECISION SIGA(   7)
      DATA NPAR, NDIM, IMQFUN /    7,    1,    2/
      DATA VCONST /  1.750000000000    /
      DATA SIGVMI /  35.00000000000    /
      DATA SIGVT /  70.00000000000    /
      DATA SIGV / 0.8625000119209    
     +, 0.9125000238419    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.5500000119209    
     +, 0.6500000357628    
     +, 0.7500000000000    
     +/
      DATA SIGDEL / 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.2000000029802    
     +, 0.2000000029802    
     +, 0.2000000029802    
     +/
      DATA SIGA / -11.39304546376    
     +, -102.9805090993    
     +, -4.003714750660    
     +,  86.12178723511    
     +,  9.669695602723    
     +, -33.20277213359    
     +,  45.30284312359    
     +/
      hz100_3_mh = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz100_3_mh = hz100_3_mh + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz100_3_mh = VCONST * EXP (hz100_3_mh)
      END
      DOUBLE PRECISION FUNCTION hz100_3_nn(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  11, 1)
      DOUBLE PRECISION SIGDEL(  11)
      DOUBLE PRECISION SIGA(  11)
      DATA NPAR, NDIM, IMQFUN /   11,    1,    2/
      DATA VCONST / 0.9999999776483E-02/
      DATA SIGVMI / 0.5000000000000    /
      DATA SIGVT / 0.5000000000000    /
      DATA SIGV / 0.1899999976158    
     +, 0.6499999761581    
     +, 0.6699999570847    
     +, 0.6899999976158    
     +, 0.9499999880791    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.2999999821186    
     +, 0.7400000095367    
     +, 0.8199999928474    
     +, 0.8999999761581    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +/
      DATA SIGA / 0.3181209578249    
     +, -19.98250470524    
     +,  44.96596940478    
     +, -36.50882664670    
     +, -2.142418348690    
     +,  8.720942031281    
     +, -2.299083898414    
     +, 0.9246555236639    
     +,  23.79894993921    
     +, -19.24586165507    
     +,  19.53254562142    
     +/
      hz100_3_nn = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz100_3_nn = hz100_3_nn + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz100_3_nn = VCONST * EXP (hz100_3_nn)
      END
      DOUBLE PRECISION FUNCTION hz105_3_mh(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  14, 1)
      DOUBLE PRECISION SIGDEL(  14)
      DOUBLE PRECISION SIGA(  14)
      DATA NPAR, NDIM, IMQFUN /   14,    1,    2/
      DATA VCONST /  1.750000000000    /
      DATA SIGVMI /  35.00000000000    /
      DATA SIGVT /  70.00000000000    /
      DATA SIGV / 0.3750000149012E-01
     +, 0.2625000178814    
     +, 0.2874999940395    
     +, 0.3125000000000    
     +, 0.3375000059605    
     +, 0.4625000059605    
     +, 0.4875000119209    
     +, 0.8625000119209    
     +, 0.9125000238419    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.1500000059605    
     +, 0.6500000357628    
     +, 0.7500000000000    
     +/
      DATA SIGDEL / 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.2000000029802    
     +, 0.2000000029802    
     +, 0.2000000029802    
     +/
      DATA SIGA /  124.8824417912    
     +,  154.2768083635    
     +, -137.2120774737    
     +, -17.40026109500    
     +,  61.79169835403    
     +, -7.528987018439    
     +,  9.964950196870    
     +, -19.89645550036    
     +, -60.85770545927    
     +, -37.83112445552    
     +,  73.28473540418    
     +, -152.3086399085    
     +, -1.243163077698    
     +,  18.94141134432    
     +/
      hz105_3_mh = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz105_3_mh = hz105_3_mh + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz105_3_mh = VCONST * EXP (hz105_3_mh)
      END
      DOUBLE PRECISION FUNCTION hz105_3_nn(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   5, 1)
      DOUBLE PRECISION SIGDEL(   5)
      DOUBLE PRECISION SIGA(   5)
      DATA NPAR, NDIM, IMQFUN /    5,    1,    2/
      DATA VCONST / 0.9999999776483E-02/
      DATA SIGVMI / 0.5000000000000    /
      DATA SIGVT / 0.5000000000000    /
      DATA SIGV / 0.5099999904633    
     +, 0.6100000143051    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.8399999737740    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.1599999964237    
     +/
      DATA SIGA /  1.670915076527    
     +, -1.391506996587    
     +,  8.945090725701    
     +,  2.471811207254    
     +,  5.553623012815    
     +/
      hz105_3_nn = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz105_3_nn = hz105_3_nn + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz105_3_nn = VCONST * EXP (hz105_3_nn)
      END
      DOUBLE PRECISION FUNCTION hz110_3_mh(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   6, 1)
      DOUBLE PRECISION SIGDEL(   6)
      DOUBLE PRECISION SIGA(   6)
      DATA NPAR, NDIM, IMQFUN /    6,    1,    2/
      DATA VCONST /  1.750000000000    /
      DATA SIGVMI /  35.00000000000    /
      DATA SIGVT /  70.00000000000    /
      DATA SIGV / 0.5875000357628    
     +, 0.6875000000000    
     +, 0.8625000119209    
     +, 0.9125000238419    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +/
      DATA SIGDEL / 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +/
      DATA SIGA / 0.6627421392053    
     +,  1.966121806827    
     +, -32.29935017516    
     +,  6.576487863613    
     +,  1.728664898533    
     +,  19.64096259399    
     +/
      hz110_3_mh = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz110_3_mh = hz110_3_mh + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz110_3_mh = VCONST * EXP (hz110_3_mh)
      END
      DOUBLE PRECISION FUNCTION hz110_3_nn(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   7, 1)
      DOUBLE PRECISION SIGDEL(   7)
      DOUBLE PRECISION SIGA(   7)
      DATA NPAR, NDIM, IMQFUN /    7,    1,    2/
      DATA VCONST / 0.9999999776483E-02/
      DATA SIGVMI / 0.5000000000000    /
      DATA SIGVT / 0.5000000000000    /
      DATA SIGV / 0.1299999952316    
     +, 0.1899999976158    
     +, 0.2099999934435    
     +, 0.8700000047684    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.7599999904633    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.1599999964237    
     +/
      DATA SIGA / 0.9190318412875    
     +,  2.551999034137    
     +, -1.738994645566    
     +,  1.676718824046    
     +,  7.839678472746    
     +,  4.009225669463    
     +,  2.119110833479    
     +/
      hz110_3_nn = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz110_3_nn = hz110_3_nn + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz110_3_nn = VCONST * EXP (hz110_3_nn)
      END
      DOUBLE PRECISION FUNCTION hz75_3_mh(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  11, 1)
      DOUBLE PRECISION SIGDEL(  11)
      DOUBLE PRECISION SIGA(  11)
      DATA NPAR, NDIM, IMQFUN /   11,    1,    2/
      DATA VCONST /  1.750000000000    /
      DATA SIGVMI /  35.00000000000    /
      DATA SIGVT /  70.00000000000    /
      DATA SIGV / 0.3125000000000    
     +, 0.3375000059605    
     +, 0.5124999880791    
     +, 0.5625000000000    
     +, 0.6625000238419    
     +, 0.9125000238419    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.7500000298023E-01
     +, 0.4250000119209    
     +, 0.7750000357628    
     +/
      DATA SIGDEL / 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.1000000014901    
     +, 0.1000000014901    
     +, 0.1000000014901    
     +/
      DATA SIGA /  11.60784595437    
     +, -17.27211479900    
     +,  16.38625900674    
     +, -40.97909746196    
     +,  10.89130910796    
     +, -38.70928482881    
     +,  13.13560830308    
     +,  39.30434465978    
     +, -16.17420200697    
     +,  19.02356682536    
     +, -2.760697667102    
     +/
      hz75_3_mh = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz75_3_mh = hz75_3_mh + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz75_3_mh = VCONST * EXP (hz75_3_mh)
      END
      DOUBLE PRECISION FUNCTION hz75_3_nn(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   9, 1)
      DOUBLE PRECISION SIGDEL(   9)
      DOUBLE PRECISION SIGA(   9)
      DATA NPAR, NDIM, IMQFUN /    9,    1,    2/
      DATA VCONST / 0.9999999776483E-02/
      DATA SIGVMI / 0.5000000000000    /
      DATA SIGVT / 0.5000000000000    /
      DATA SIGV / 0.6499999761581    
     +, 0.6699999570847    
     +, 0.9699999690056    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.2599999904633    
     +, 0.4599999785423    
     +, 0.8999999761581    
     +, 0.7599999904633    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.1599999964237    
     +/
      DATA SIGA / -1.580973612000    
     +, 0.6553856777178    
     +,  8.929193403732    
     +,  9.352629998109    
     +, -6.040181310617    
     +, 0.1977689452933    
     +, 0.5193835979796    
     +,  2.931662886125    
     +,  3.231464797283    
     +/
      hz75_3_nn = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz75_3_nn = hz75_3_nn + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz75_3_nn = VCONST * EXP (hz75_3_nn)
      END
      DOUBLE PRECISION FUNCTION hz80_3_mh(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   8, 1)
      DOUBLE PRECISION SIGDEL(   8)
      DOUBLE PRECISION SIGA(   8)
      DATA NPAR, NDIM, IMQFUN /    8,    1,    2/
      DATA VCONST /  1.750000000000    /
      DATA SIGVMI /  35.00000000000    /
      DATA SIGVT /  70.00000000000    /
      DATA SIGV / 0.3875000178814    
     +, 0.5625000000000    
     +, 0.6374999880791    
     +, 0.7125000357628    
     +, 0.9125000238419    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.7750000357628    
     +/
      DATA SIGDEL / 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.1000000014901    
     +/
      DATA SIGA / -1.109501533106    
     +,  21.72552097286    
     +, -41.46074859980    
     +,  8.213176457669    
     +, -106.8412321831    
     +, -3.072617109245    
     +,  93.61663280232    
     +,  15.34576372415    
     +/
      hz80_3_mh = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz80_3_mh = hz80_3_mh + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz80_3_mh = VCONST * EXP (hz80_3_mh)
      END
      DOUBLE PRECISION FUNCTION hz80_3_nn(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   7, 1)
      DOUBLE PRECISION SIGDEL(   7)
      DOUBLE PRECISION SIGA(   7)
      DATA NPAR, NDIM, IMQFUN /    7,    1,    2/
      DATA VCONST / 0.9999999776483E-02/
      DATA SIGVMI / 0.5000000000000    /
      DATA SIGVT / 0.5000000000000    /
      DATA SIGV / 0.2899999916553    
     +, 0.7299999594688    
     +, 0.9699999690056    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.6599999666214    
     +, 0.8999999761581    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +/
      DATA SIGA / 0.2116498816480    
     +,  1.168311776737    
     +,  16.30350683496    
     +,  9.753947487700    
     +, -12.95773761556    
     +, 0.2130933418432    
     +,  3.764460923693    
     +/
      hz80_3_nn = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz80_3_nn = hz80_3_nn + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz80_3_nn = VCONST * EXP (hz80_3_nn)
      END
      DOUBLE PRECISION FUNCTION hz85_3_mh(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   9, 1)
      DOUBLE PRECISION SIGDEL(   9)
      DOUBLE PRECISION SIGA(   9)
      DATA NPAR, NDIM, IMQFUN /    9,    1,    2/
      DATA VCONST /  1.750000000000    /
      DATA SIGVMI /  35.00000000000    /
      DATA SIGVT /  70.00000000000    /
      DATA SIGV / 0.6625000238419    
     +, 0.7125000357628    
     +, 0.7624999880791    
     +, 0.9125000238419    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.5749999880791    
     +, 0.8249999880791    
     +, 0.4500000178814    
     +/
      DATA SIGDEL / 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.1000000014901    
     +, 0.1000000014901    
     +, 0.2000000029802    
     +/
      DATA SIGA /  35.04261169402    
     +, -75.97165256437    
     +,  58.25307789135    
     +,  9.556969215627    
     +,  2.065292054768    
     +,  27.68087314187    
     +,  5.984401030484    
     +, -64.29253222219    
     +,-0.3894674292343    
     +/
      hz85_3_mh = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz85_3_mh = hz85_3_mh + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz85_3_mh = VCONST * EXP (hz85_3_mh)
      END
      DOUBLE PRECISION FUNCTION hz85_3_nn(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   9, 1)
      DOUBLE PRECISION SIGDEL(   9)
      DOUBLE PRECISION SIGA(   9)
      DATA NPAR, NDIM, IMQFUN /    9,    1,    2/
      DATA VCONST / 0.9999999776483E-02/
      DATA SIGVMI / 0.5000000000000    /
      DATA SIGVT / 0.5000000000000    /
      DATA SIGV / 0.4099999964237    
     +, 0.7299999594688    
     +, 0.9300000071526    
     +, 0.9699999690056    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.4599999785423    
     +, 0.5000000000000    
     +, 0.8399999737740    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.1599999964237    
     +/
      DATA SIGA / -6.109133209372    
     +,  2.964909875063    
     +,  2.573711211035    
     +,  20.74542397935    
     +,  9.296228793070    
     +, -16.53268538583    
     +,  23.28790038442    
     +, -16.55561140762    
     +,-0.7051921265944    
     +/
      hz85_3_nn = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz85_3_nn = hz85_3_nn + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz85_3_nn = VCONST * EXP (hz85_3_nn)
      END
      DOUBLE PRECISION FUNCTION hz90_3_mh(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  12, 1)
      DOUBLE PRECISION SIGDEL(  12)
      DOUBLE PRECISION SIGA(  12)
      DATA NPAR, NDIM, IMQFUN /   12,    1,    2/
      DATA VCONST /  1.750000000000    /
      DATA SIGVMI /  35.00000000000    /
      DATA SIGVT /  70.00000000000    /
      DATA SIGV / 0.1375000029802    
     +, 0.3625000119209    
     +, 0.7375000119209    
     +, 0.7875000238419    
     +, 0.8375000357628    
     +, 0.8874999880791    
     +, 0.9125000238419    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.2250000089407    
     +, 0.6250000000000    
     +, 0.6750000119209    
     +/
      DATA SIGDEL / 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.1000000014901    
     +, 0.1000000014901    
     +, 0.1000000014901    
     +/
      DATA SIGA / -25.87361380664    
     +, -7.212718040872    
     +,  37.94732737733    
     +, -89.25850510610    
     +,  110.9153241132    
     +, -381.7966747163    
     +,  358.0385435465    
     +,  10.07326525196    
     +, -38.15740471843    
     +,  24.10893951583    
     +,  10.41787761527    
     +, -11.78199826305    
     +/
      hz90_3_mh = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz90_3_mh = hz90_3_mh + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz90_3_mh = VCONST * EXP (hz90_3_mh)
      END
      DOUBLE PRECISION FUNCTION hz90_3_nn(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  13, 1)
      DOUBLE PRECISION SIGDEL(  13)
      DOUBLE PRECISION SIGA(  13)
      DATA NPAR, NDIM, IMQFUN /   13,    1,    2/
      DATA VCONST / 0.9999999776483E-02/
      DATA SIGVMI / 0.5000000000000    /
      DATA SIGVT / 0.5000000000000    /
      DATA SIGV / 0.2999999932945E-01
     +, 0.4999999701977E-01
     +, 0.7000000029802E-01
     +, 0.4699999988079    
     +, 0.5699999928474    
     +, 0.6499999761581    
     +, 0.8700000047684    
     +, 0.9699999690056    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.2599999904633    
     +, 0.2999999821186    
     +, 0.7799999713898    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +/
      DATA SIGA /  69.47314565869    
     +, -58.10390768091    
     +,  10.77461001937    
     +, -3.651905216519    
     +,  6.896983404123    
     +, -6.384685425929    
     +, -1.289921195498    
     +,  23.99960506916    
     +, -11.65906830573    
     +, -18.70349682336    
     +, -10.78050024550    
     +,  11.54436796716    
     +,  6.130952198893    
     +/
      hz90_3_nn = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz90_3_nn = hz90_3_nn + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz90_3_nn = VCONST * EXP (hz90_3_nn)
      END
      DOUBLE PRECISION FUNCTION hz95_3_mh(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  15, 1)
      DOUBLE PRECISION SIGDEL(  15)
      DOUBLE PRECISION SIGA(  15)
      DATA NPAR, NDIM, IMQFUN /   15,    1,    2/
      DATA VCONST /  1.750000000000    /
      DATA SIGVMI /  35.00000000000    /
      DATA SIGVT /  70.00000000000    /
      DATA SIGV / 0.1625000089407    
     +, 0.2374999970198    
     +, 0.2625000178814    
     +, 0.3625000119209    
     +, 0.6125000119209    
     +, 0.7624999880791    
     +, 0.8125000000000    
     +, 0.8375000357628    
     +, 0.8625000119209    
     +, 0.8874999880791    
     +, 0.9125000238419    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.4250000119209    
     +, 0.4749999940395    
     +/
      DATA SIGDEL / 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.1000000014901    
     +, 0.1000000014901    
     +/
      DATA SIGA / -9.456249371208    
     +,  53.02738480746    
     +, -51.38045514043    
     +,  51.69501128113    
     +, -7.076550934195    
     +,  17.71786247875    
     +, -54.26889789807    
     +,  178.3917088295    
     +, -150.7823951489    
     +, -311.1654922839    
     +,  338.9947049183    
     +,  3.914988247908    
     +, -21.50731688489    
     +, -130.4830525061    
     +,  92.03947561724    
     +/
      hz95_3_mh = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz95_3_mh = hz95_3_mh + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz95_3_mh = VCONST * EXP (hz95_3_mh)
      END
      DOUBLE PRECISION FUNCTION hz95_3_nn(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  10, 1)
      DOUBLE PRECISION SIGDEL(  10)
      DOUBLE PRECISION SIGA(  10)
      DATA NPAR, NDIM, IMQFUN /   10,    1,    2/
      DATA VCONST / 0.9999999776483E-02/
      DATA SIGVMI / 0.5000000000000    /
      DATA SIGVT / 0.5000000000000    /
      DATA SIGV / 0.6499999761581    
     +, 0.6699999570847    
     +, 0.9300000071526    
     +, 0.9499999880791    
     +, 0.9699999690056    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.7799999713898    
     +, 0.8599999547005    
     +, 0.1199999973178    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.1599999964237    
     +/
      DATA SIGA /  7.731069486248    
     +, -8.483028236526    
     +,  4.023454988230    
     +, -2.057066817596    
     +,  21.85536356635    
     +,  9.595313054009    
     +, -17.80676923815    
     +,  4.157117759591    
     +,-0.6666054144513    
     +, 0.3985145199177    
     +/
      hz95_3_nn = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz95_3_nn = hz95_3_nn + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz95_3_nn = VCONST * EXP (hz95_3_nn)
      END
      DOUBLE PRECISION FUNCTION hz975_3_mh(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  13, 1)
      DOUBLE PRECISION SIGDEL(  13)
      DOUBLE PRECISION SIGA(  13)
      DATA NPAR, NDIM, IMQFUN /   13,    1,    2/
      DATA VCONST /  1.750000000000    /
      DATA SIGVMI /  35.00000000000    /
      DATA SIGVT /  70.00000000000    /
      DATA SIGV / 0.1375000029802    
     +, 0.2125000059605    
     +, 0.2374999970198    
     +, 0.4375000000000    
     +, 0.4625000059605    
     +, 0.7125000357628    
     +, 0.7624999880791    
     +, 0.8625000119209    
     +, 0.8874999880791    
     +, 0.9125000238419    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.5250000357628    
     +/
      DATA SIGDEL / 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.5000000074506E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.1000000014901    
     +/
      DATA SIGA / -5.693930053806    
     +,  26.89066122060    
     +, -21.93473994573    
     +,  11.84734425050    
     +, -16.29637083891    
     +,  9.645580556786    
     +, -12.89284529624    
     +,  295.5623235498    
     +, -799.4166086633    
     +,  533.5141993764    
     +,  1.459328850804    
     +, -29.89024581136    
     +,  6.742412556767    
     +/
      hz975_3_mh = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz975_3_mh = hz975_3_mh + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz975_3_mh = VCONST * EXP (hz975_3_mh)
      END
      DOUBLE PRECISION FUNCTION hz975_3_nn(V)
      DOUBLE PRECISION V( 1)
      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  15, 1)
      DOUBLE PRECISION SIGDEL(  15)
      DOUBLE PRECISION SIGA(  15)
      DATA NPAR, NDIM, IMQFUN /   15,    1,    2/
      DATA VCONST / 0.9999999776483E-02/
      DATA SIGVMI / 0.5000000000000    /
      DATA SIGVT / 0.5000000000000    /
      DATA SIGV / 0.2999999932945E-01
     +, 0.4999999701977E-01
     +, 0.5099999904633    
     +, 0.5299999713898    
     +, 0.5500000119209    
     +, 0.5899999737740    
     +, 0.6100000143051    
     +, 0.9499999880791    
     +, 0.9699999690056    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.9999999403954E-01
     +, 0.1400000005960    
     +, 0.8199999928474    
     +, 0.8999999761581    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +, 0.7999999821186E-01
     +/
      DATA SIGA /  38.24334358555    
     +, -59.60505751164    
     +,  69.92111177711    
     +, -166.0877193215    
     +,  124.7412653963    
     +, -49.23939931806    
     +,  23.64813872283    
     +, -30.36978633897    
     +,  42.24254671945    
     +,  8.212656808697    
     +, -19.92854500779    
     +,  44.07069864450    
     +, -22.51167767531    
     +, -8.035933653155    
     +,  21.68033409371    
     +/
      hz975_3_nn = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         hz975_3_nn = hz975_3_nn + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) hz975_3_nn = VCONST * EXP (hz975_3_nn)
      END
