C      integer function A2000_nn_ncand()
C      implicit none
C      A2000_nn_ncand = 28
C      end
C 
C      subroutine A2000_nn_mhcand(icand,massc,btagc,ecmc)
C      implicit none
C      integer icand,i
C      integer maxcand
C      real massc,btagc,ecmc
C      parameter (maxcand=28)
C      real*8 mass(maxcand),btag(maxcand),ecm(maxcand)
C      data (mass(i),btag(i),ecm(i), i=1,maxcand)
C     & /  98.0332, 0.8320, 201.7700,
C     &   101.4746, 0.0287, 204.0720,
CC Candidate removed due to data quality
CC     &    94.8574, 0.2801, 203.6720,
C     &    90.9562, 0.0015, 204.8120,
C     &    98.0265, 0.0202, 205.2140,
C     &    89.6768, 0.2596, 205.2180,
C     &   105.7925, 0.3317, 205.2220,
C     &    96.6951, 0.5244, 205.2420,
C     &    97.3649, 0.0727, 205.2120,
C     &    93.7178, 0.0000, 205.2140,
C     &   102.8765, 0.1231, 205.2180,
C     &    89.2855, 0.0024, 205.2280,
C     &    98.8318, 0.0290, 205.2140,
C     &   108.0364, 0.1090, 205.2200, ! 7 Aug update
C     &    97.8051, 0.1234, 205.2140, ! 7 Aug update
C     &   100.2479, 0.3986, 205.3360, ! 9 Aug update
Cc     &   104.6708, 0.2401, 205.3280, ! 6 Sep update
C     &    97.6981, 0.0935, 206.2260,
C     &   105.7657, 0.0684, 206.4100,
C     &   101.2373, 0.0000, 206.3380,
C     &   106.8274, 0.0244, 206.61,
C     &   112.3819, 0.0024, 206.8010, ! energy bumped up to assure bin
C     &   104.3084, 0.0006, 206.7960, ! energy bumped down to assure bin
C     &    97.0189, 0.1710, 206.7320, ! 7 Aug update
C     &   109.2570, 0.0531, 206.5240, ! 7 Aug update
C     &    95.7562, 0.0925, 206.5160,
C     &    98.3791, 0.0370, 206.7340, ! 24 Aug update
C     &   104.8389, 0.0034, 206.5260, ! 20 Aug update
C     &    99.8036, 0.0541, 206.6580, ! 20 Aug update
C     &    92.2557, 0.8626, 206.5340  ! 20 Aug update
C     &   /
C
C      if (icand.gt.maxcand) then
C         massc=0.d0
C         btagc=0.d0
C         ecmc=0.d0
C      else 
C         massc=mass(icand)
C         btagc=btag(icand)
C         ecmc=ecm(icand)
C      endif
C      end

      double precision function A2000_nn_bkg(ecm,ibkg)
      implicit none
      integer ibkg
      real*8 ecm,xsect
      real*8 al_xsect_dd,al_xsect_uu,al_xsect_ss,
     & al_xsect_cc,al_xsect_bb,al_xsect_ww,al_xsect_ewnu,
     & al_xsect_zz, al_xsect_zee,al_xsect_znn
      external al_xsect_dd,al_xsect_uu,al_xsect_ss,
     & al_xsect_cc,al_xsect_bb,al_xsect_ww,al_xsect_ewnu,
     & al_xsect_zz,al_xsect_znn
     & ,al_xsect_zee
      real*8 A2000_nn_bkg_eff
      external A2000_nn_bkg_eff
      if (ecm.lt.199.5d0.or.ecm.gt.210.d0) then
         A2000_nn_bkg=0.d0
      else
         if(ibkg.lt.1.or.ibkg.gt.10) then
            A2000_nn_bkg =0.d0
         else
            if (ibkg.eq.1) then
               xsect=al_xsect_bb(ecm)
            elseif (ibkg.eq.2) then
               xsect=al_xsect_cc(ecm)
            elseif (ibkg.eq.3) then
               xsect=al_xsect_dd(ecm)
            elseif (ibkg.eq.4) then
               xsect=al_xsect_ss(ecm)
            elseif (ibkg.eq.5) then
               xsect=al_xsect_uu(ecm)
            elseif (ibkg.eq.6) then
               xsect=al_xsect_ww(ecm)
            elseif (ibkg.eq.7) then
               xsect=al_xsect_ewnu(ecm)
            elseif (ibkg.eq.8) then
               xsect=al_xsect_zz(ecm)
            elseif (ibkg.eq.9) then
               xsect=al_xsect_zee(ecm)
            elseif (ibkg.eq.10) then
               xsect=al_xsect_znn(ecm)
            else
               xsect=0.d0
            endif
            A2000_nn_bkg = A2000_nn_bkg_eff(ecm,ibkg)*xsect
         endif
      endif
      end


      double precision function A2000_nn_bkg_eff(ecm,ibkg)
*ibkg:1-5:bb,cc,dd,ss,uu;6:ww;7:eWv;8:ZZ;9:eeZ;10:Zvv
      implicit none
      real*8 ecm
      integer ibkg,i
      integer numecm,numqqecm,iecm,ecmindx
      parameter(numecm=9)
      parameter(numqqecm=6)
      real*8 qqecm(numqqecm),wwecm(numecm),bkgecm(numecm)
*      real*8 bb(numqqecm),cc(numqqecm),dd(numqqecm),
*     &     ss(numqqecm),uu(numqqecm),
      real*8 qq(numqqecm,5),
     &     ww(numecm),ewnu(numecm),
     &     zz(numecm),eez(numecm),znn(numecm)
      data (qqecm(iecm),(qq(iecm,i), i=1,5),iecm=1,numqqecm)
     & /200.00,0.000245,0.00011,0.000075,0.00011,0.00007
     & ,202.00,0.00025,0.00009,0.00011,0.00012,0.00006
     & ,204.00,0.00028,0.00003,0.00008,0.0001,0.00005   
     & ,206.00,0.00024,0.00013,0.00009,0.00012,0.00005 
     & ,208.00,0.00021,0.00011,0.00008,0.00005,0.00004
     & ,210.00,0.00019,0.00011,0.00005,0.00006,0.00009/
       data(wwecm(iecm),ww(iecm),ewnu(iecm),iecm=1,numecm)
     & /200.00,0.002596,0.0974
     & ,202.00,0.002376,0.08855
     & ,204.00,0.002276,0.08155
     & ,205.00,0.00214,0.0779
     & ,206.00,0.002192,0.077
     & ,207.00,0.001976,0.0673
     & ,208.00,0.00186,0.0658
     & ,209.00,0.001924,0.064
     & ,210.00,0.001944,0.0582/
       data(bkgecm(iecm),zz(iecm),eez(iecm),znn(iecm),iecm=1,numecm)
     & /199.50,0.03998,0.0,0.28365
     & ,201.60,0.03234,0.00002,0.27015
     & ,204.00,0.026,0.00002,0.2657
     & ,205.00,0.02278,0.00002,0.2583
     & ,206.00,0.02112,0.00002,0.254
     & ,207.00,0.0175,0.00001,0.24825
     & ,208.00,0.017,0.00004,0.2396
     & ,209.00,0.01406,0.00003,0.22975
     & ,210.00,0.01272,0.00001,0.22195/
       ecmindx = 0
       if(ibkg.le.5) then
          do i=1,numqqecm
             if (qqecm(i).le.ecm) ecmindx = i
          enddo
          if (ecmindx.eq.numqqecm) then 
             A2000_nn_bkg_eff = qq(numqqecm,ibkg)
          elseif (ecmindx.eq.0) then
             A2000_nn_bkg_eff = qq(1,ibkg)
          else
             A2000_nn_bkg_eff = ((ecm-qqecm(ecmindx))
     &            *qq(ecmindx+1,ibkg)+
     &            (qqecm(ecmindx+1)-ecm)*qq(ecmindx,ibkg))/
     &            (qqecm(ecmindx+1)-qqecm(ecmindx))
          endif
       elseif (ibkg.eq.6) then
          do i=1,numecm
             if (wwecm(i).le.ecm) ecmindx = i
          enddo
          if (ecmindx.eq.numecm) then
             A2000_nn_bkg_eff = ww(numecm)
          elseif (ecmindx.eq.0) then
             A2000_nn_bkg_eff = ww(1)
          else
             A2000_nn_bkg_eff = ((ecm-wwecm(ecmindx))*ww(ecmindx+1)+
     &            (wwecm(ecmindx+1)-ecm)*ww(ecmindx))/
     &            (wwecm(ecmindx+1)-wwecm(ecmindx))
          endif
       elseif (ibkg.eq.7) then
          do i=1,numecm
             if (wwecm(i).le.ecm) ecmindx = i
          enddo
          if (ecmindx.eq.numecm) then
             A2000_nn_bkg_eff = ewnu(numecm)
          elseif (ecmindx.eq.0) then
             A2000_nn_bkg_eff = ewnu(1)
          else
             A2000_nn_bkg_eff = ((ecm-wwecm(ecmindx))*ewnu(ecmindx+1)+
     &            (wwecm(ecmindx+1)-ecm)*ewnu(ecmindx))/
     &            (wwecm(ecmindx+1)-wwecm(ecmindx))
          endif
       elseif (ibkg.eq.8) then
          do i=1,numecm
             if (bkgecm(i).le.ecm) ecmindx = i
          enddo
          if (ecmindx.eq.numecm) then
             A2000_nn_bkg_eff = zz(numecm)
          elseif (ecmindx.eq.0) then
             A2000_nn_bkg_eff = zz(1)
          else
             A2000_nn_bkg_eff = ((ecm-bkgecm(ecmindx))*zz(ecmindx+1)+
     &            (bkgecm(ecmindx+1)-ecm)*zz(ecmindx))/
     &            (bkgecm(ecmindx+1)-bkgecm(ecmindx))
          endif
       elseif (ibkg.eq.9) then
          do i=1,numecm
             if (bkgecm(i).le.ecm) ecmindx = i
          enddo
          if (ecmindx.eq.numecm) then
             A2000_nn_bkg_eff = eez(numecm)
          elseif (ecmindx.eq.0) then
             A2000_nn_bkg_eff = eez(1)
          else
             A2000_nn_bkg_eff = ((ecm-bkgecm(ecmindx))*eez(ecmindx+1)+
     &            (bkgecm(ecmindx+1)-ecm)*eez(ecmindx))/
     &            (bkgecm(ecmindx+1)-bkgecm(ecmindx))
          endif
       elseif (ibkg.eq.10) then
          do i=1,numecm
             if (bkgecm(i).le.ecm) ecmindx = i
          enddo
          if (ecmindx.eq.numecm) then
             A2000_nn_bkg_eff = znn(numecm)
          elseif (ecmindx.eq.0) then
             A2000_nn_bkg_eff = znn(1)
          else
             A2000_nn_bkg_eff = ((ecm-bkgecm(ecmindx))*znn(ecmindx+1)+
     &            (bkgecm(ecmindx+1)-ecm)*znn(ecmindx))/
     &            (bkgecm(ecmindx+1)-bkgecm(ecmindx))
          endif
       else
          A2000_nn_bkg_eff = 0.d0
       endif
       if (ecm.lt.199.5d0.or.ecm.gt.210.d0) then
          A2000_nn_bkg_eff = 0.d0
       endif
       end

              
      double precision function A2000_nn_sig_eff(ecm,isig,mh)
*isig:1-5:nu_mu & nu_tau; 6-10:nu_e
*isig in order H-> bb,tautau,cc,gg,WW
      implicit none
      real*8 ecm,mh
      real*8 A2000_nn_sig_eff_1995, A2000_nn_sig_eff_2016
     & ,A2000_nn_sig_eff_204,A2000_nn_sig_eff_206,A2000_nn_sig_eff_208
     & ,A2000_nn_sig_eff_210
      external A2000_nn_sig_eff_1995, A2000_nn_sig_eff_2016
     & ,A2000_nn_sig_eff_204,A2000_nn_sig_eff_206,A2000_nn_sig_eff_208
     & ,A2000_nn_sig_eff_210
      integer isig,i,ecmindx
      integer numecm
      parameter (numecm=6)
      real*8 sigecm(numecm)
      real*8 func, val1,val2
      data sigecm /199.5d0, 201.6d0, 204.d0, 206.d0, 208.d0,210.d0/
      ecmindx = 0
      do i=1,numecm
         if (sigecm(i).le.ecm) ecmindx =i
      enddo
c Switched off this protection--- interpolate only! (PM)
c      if (ecmindx.eq.numecm) then
c         A2000_nn_sig_eff = A2000_nn_sig_eff_210(isig,mh-ecm+210.d0)
c      elseif (ecmindx.eq.0) then
c         A2000_nn_sig_eff = A2000_nn_sig_eff_1995(isig,mh)
c      else
       if (ecmindx.eq.1) then
          val1=A2000_nn_sig_eff_1995(isig,mh-ecm+199.5d0)
          val2=A2000_nn_sig_eff_2016(isig,mh-ecm+201.6d0)
       elseif (ecmindx.eq.2) then
          val1=A2000_nn_sig_eff_2016(isig,mh-ecm+201.6d0)
          val2=A2000_nn_sig_eff_204(isig,mh-ecm+204.d0)
       elseif (ecmindx.eq.3) then
          val1=A2000_nn_sig_eff_204(isig,mh-ecm+204.d0)
          val2=A2000_nn_sig_eff_206(isig,mh-ecm+206.d0)
       elseif (ecmindx.eq.4) then
          val1=A2000_nn_sig_eff_206(isig,mh-ecm+206.d0)
          val2=A2000_nn_sig_eff_208(isig,mh-ecm+208.d0)
       elseif (ecmindx.eq.5) then
          val1=A2000_nn_sig_eff_208(isig,mh-ecm+208.d0)
          val2=A2000_nn_sig_eff_210(isig,mh-ecm+210.d0)
       else
          val1=0.d0
          val2=0.d0
       endif
        
         A2000_nn_sig_eff = (val2*(ecm-sigecm(ecmindx))
     &        +val1*(sigecm(ecmindx+1)-ecm))
     &        /(sigecm(ecmindx+1)-sigecm(ecmindx))
c      endif
      if (ecm.lt.199.5d0.or.ecm.gt.210.d0.or.mh.lt.75.d0.or.
     &     mh.gt.120.d0) A2000_nn_sig_eff=0.d0
      end
      

      double precision function A2000_nn_sig_eff_1995(isig,mh)
      implicit none
      integer isig, i, j
      real*8 mh
      integer nummass, numtyp,mhindx
      parameter (nummass=14)
      parameter (numtyp=10)
      real*8 eff(numtyp,nummass), massh(nummass)
*nu_blah nu_blah sig
      data (massh(j), (eff(i,j), i=1,numtyp/2), j=1,nummass)
     & /60.d0,0.0053,0.0000,0.0157,0.0065,0.0000
     & ,65.d0,0.0139,0.0000,0.0165,0.0189,0.0000
     & ,70.d0,0.0242,0.0000,0.0174,0.0119,0.0000
     & ,75.d0,0.0480,0.0000,0.0683,0.0479,0.0000
     & ,80.d0,0.1002,0.0000,0.1156,0.0748,0.0000
     & ,85.d0,0.2101,0.0000,0.1688,0.1445,0.1250
     & ,90.d0,0.4407,0.0000,0.4796,0.3712,0.0000
     & ,95.d0,0.6036,0.0000,0.5714,0.6159,0.0833
     & ,100.d0,0.6510,0.0000,0.6667,0.6601,0.3667
     & ,105.d0,0.5623,0.0000,0.5936,0.5863,0.2857
     & ,107.d0,0.4726,0.0000,0.4844,0.4377,0.2358
     & ,110.d0,0.4161,0.0000,0.4336,0.3400,0.1803
     & ,115.d0,0.3221,0.0000,0.2222,0.2868,0.1636
     & ,120.d0,0.2475,0.0000,0.1458,0.2056,0.1200/
      data ((eff(i,j), i=numtyp/2+1,numtyp), j=1,nummass)
     & /0.0091,0.0000,0.0071,0.0000,0.0000
     & ,0.0176,0.0000,0.0066,0.0094,0.0000
     & ,0.0300,0.0000,0.0452,0.0248,0.0000
     & ,0.0547,0.0000,0.0621,0.0574,0.0000
     & ,0.0923,0.0000,0.0769,0.0809,0.0000
     & ,0.1706,0.0000,0.1329,0.1280,0.2857
     & ,0.3533,0.0000,0.3286,0.3538,0.0000
     & ,0.4976,0.0000,0.5811,0.4729,0.4000
     & ,0.5223,0.0000,0.5849,0.5230,0.2500
     & ,0.4679,0.0000,0.4368,0.4319,0.1765
     & ,0.4220,0.0000,0.3553,0.3594,0.2556
     & ,0.3318,0.0000,0.3125,0.2719,0.2031
     & ,0.2614,0.0000,0.2191,0.1846,0.0995
     & ,0.2080,0.0000,0.1395,0.1248,0.0779/
      do i = 1, nummass
         if (massh(i).le.mh) then
            mhindx=i
         endif
      enddo
      if (mhindx.eq.0) then
c         A2000_nn_sig_eff_1995=eff(isig,1)
         A2000_nn_sig_eff_1995=0.
      elseif(mhindx.eq.nummass) then
c         A2000_nn_sig_eff_1995=eff(isig,nummass)
         A2000_nn_sig_eff_1995=0.
      else
         A2000_nn_sig_eff_1995=(eff(isig,mhindx)*(massh(mhindx+1)-mh)+
     &        eff(isig,mhindx+1)*(mh-massh(mhindx)))/(massh(mhindx+1)-
     &        massh(mhindx))
      endif
      end




      double precision function A2000_nn_sig_eff_2016(isig,mh)
      implicit none
      integer isig, i, j
      real*8 mh
      integer nummass, numtyp,mhindx
      parameter (nummass=14)
      parameter (numtyp=10)
      real*8 eff(numtyp,nummass), massh(nummass)
*nu_blah nu_blah sig
      data (massh(j), (eff(i,j), i=1,numtyp/2), j=1,nummass)
     & /60.d0,0.0051,0.0000,0.0130,0.0070,0.0000
     & ,65.d0,0.0077,0.0000,0.0119,0.0072,0.0000
     & ,70.d0,0.0152,0.0000,0.0297,0.0237,0.0000
     & ,75.d0,0.0328,0.0000,0.0674,0.0443,0.0000
     & ,80.d0,0.0741,0.0000,0.1111,0.0829,0.1250
     & ,85.d0,0.1463,0.0000,0.1036,0.1417,0.0000
     & ,90.d0,0.3366,0.0000,0.3558,0.2609,0.0000
     & ,95.d0,0.5313,0.0000,0.5708,0.5345,0.2667
     & ,100.d0,0.6274,0.0000,0.6233,0.5994,0.3684
     & ,105.d0,0.6112,0.0000,0.5265,0.6290,0.4286
     & ,107.d0,0.5647,0.0000,0.5806,0.5202,0.2596
     & ,110.d0,0.4260,0.0000,0.4400,0.4653,0.2562
     & ,115.d0,0.3888,0.0000,0.3151,0.3020,0.0680
     & ,120.d0,0.2771,0.0000,0.2000,0.1795,0.1557 /
      data ((eff(i,j), i=numtyp/2+1,numtyp), j=1,nummass)
     &     /0.0054,0.0000,0.0076,0.0097,0.0000
     & ,0.0099,0.0000,0.0159,0.0111,0.0000
     & ,0.0197,0.0000,0.0189,0.0463,0.0000
     & ,0.0422,0.0000,0.0621,0.0420,0.0000
     & ,0.0672,0.0000,0.0882,0.0987,0.0000
     & ,0.1457,0.0000,0.1324,0.0921,0.0000
     & ,0.2589,0.0000,0.2667,0.2216,0.3333
     & ,0.4208,0.0000,0.4726,0.3846,0.3333
     & ,0.5250,0.0000,0.6000,0.5161,0.1667
     & ,0.5157,0.0000,0.5974,0.5038,0.2632
     & ,0.4728,0.0000,0.5093,0.4592,0.2125
     & ,0.3790,0.0000,0.3317,0.3651,0.2270
     & ,0.2898,0.0000,0.3036,0.2119,0.1297
     & ,0.2283,0.0000,0.1924,0.1081,0.0793/
      do i = 1, nummass
         if (massh(i).le.mh) then
            mhindx=i
         endif
      enddo
      if (mhindx.eq.0) then
c         A2000_nn_sig_eff_2016=eff(isig,1)
         A2000_nn_sig_eff_2016=0.
      elseif(mhindx.eq.nummass) then
c         A2000_nn_sig_eff_2016=eff(isig,nummass)
         A2000_nn_sig_eff_2016=0.
      else
         A2000_nn_sig_eff_2016=(eff(isig,mhindx)*(massh(mhindx+1)-mh)+
     &        eff(isig,mhindx+1)*(mh-massh(mhindx)))/(massh(mhindx+1)-
     &        massh(mhindx))
      endif
      end








      double precision function A2000_nn_sig_eff_204(isig,mh)
      implicit none
      integer isig, i, j
      real*8 mh
      integer nummass, numtyp,mhindx
      parameter (nummass=19)
      parameter (numtyp=10)
      real*8 eff(numtyp,nummass), massh(nummass)
*nu_blah nu_blah sig
      data (massh(j), (eff(i,j), i=1,numtyp/2), j=1,nummass)
     & /75.d0,0.0233,0.0000,0.0235,0.0243,0.0000
     & ,80.d0,0.0519,0.0000,0.0591,0.0328,0.0000
     & ,85.d0,0.1032,0.0000,0.1266,0.0760,0.3000
     & ,90.d0,0.2279,0.0000,0.2372,0.1943,0.1429
     & ,95.d0,0.4521,0.0000,0.4279,0.3933,0.1481
     & ,100.d0,0.6068,0.0000,0.6160,0.6416,0.3016
     & ,102.d0,0.6235,0.0000,0.5668,0.6695,0.2805
     & ,104.d0,0.6474,0.0000,0.6765,0.6568,0.3077
     & ,106.d0,0.6175,0.0000,0.6392,0.6379,0.3415
     & ,108.d0,0.5962,0.0000,0.5497,0.6547,0.2995
     & ,110.d0,0.5391,0.0000,0.5749,0.5322,0.3226
     & ,111.d0,0.4879,0.0000,0.4824,0.4564,0.2612
     & ,112.d0,0.4381,0.0000,0.4545,0.4164,0.2539
     & ,112.8d0,0.4351,0.0000,0.4266,0.3875,0.2190
     & ,114.d0,0.4242,0.0000,0.3333,0.4098,0.2328
     & ,115.d0,0.4107,0.0000,0.3214,0.3480,0.1905
     & ,116.d0,0.3959,0.0000,0.3176,0.2600,0.1690
     & ,118.d0,0.3743,0.0000,0.2258,0.2517,0.1675
     & ,120.d0,0.3134,0.0000,0.2034,0.2324,0.1215/
      data ((eff(i,j), i=numtyp/2+1,numtyp), j=1,nummass)
     &     /0.0266,0.0000,0.0392,0.0200,0.3333
     & ,0.0573,0.0000,0.0581,0.0640,0.0000
     & ,0.0895,0.0000,0.1329,0.0893,0.0000
     & ,0.1870,0.0000,0.1316,0.1538,0.0000
     & ,0.3737,0.0000,0.2824,0.3472,0.1176
     & ,0.4994,0.0000,0.4899,0.4155,0.3061
     & ,0.5121,0.0000,0.4885,0.5336,0.2745
     & ,0.5413,0.0000,0.4748,0.4800,0.3059
     & ,0.5178,0.0000,0.5284,0.4577,0.2745
     & ,0.5092,0.0000,0.5324,0.5442,0.2133
     & ,0.4478,0.0000,0.3988,0.4396,0.2047
     & ,0.4152,0.0000,0.3591,0.4029,0.1725
     & ,0.3802,0.0000,0.3692,0.3729,0.1920
     & ,0.3545,0.0000,0.3270,0.2983,0.1458
     & ,0.3265,0.0000,0.2944,0.2692,0.1368
     & ,0.3165,0.0000,0.2581,0.2723,0.1547
     & ,0.2971,0.0000,0.2955,0.2261,0.1197
     & ,0.2725,0.0000,0.2247,0.1830,0.0808
     & ,0.2592,0.0000,0.1952,0.1421,0.0809/
      do i = 1, nummass
         if (massh(i).le.mh) then
            mhindx=i
         endif
      enddo
      if (mhindx.eq.0) then
c         A2000_nn_sig_eff_204=eff(isig,1)
         A2000_nn_sig_eff_204=0.
      elseif(mhindx.eq.nummass) then
c         A2000_nn_sig_eff_204=eff(isig,nummass)
         A2000_nn_sig_eff_204=0.
      else
         A2000_nn_sig_eff_204=(eff(isig,mhindx)*(massh(mhindx+1)-mh)+
     &        eff(isig,mhindx+1)*(mh-massh(mhindx)))/(massh(mhindx+1)-
     &        massh(mhindx))
      endif
      end








      double precision function A2000_nn_sig_eff_206(isig,mh)
      implicit none
      integer isig, i, j
      real*8 mh
      integer nummass, numtyp,mhindx
      parameter (nummass=19)
      parameter (numtyp=10)
      real*8 eff(numtyp,nummass), massh(nummass)
*nu_blah nu_blah sig
      data (massh(j), (eff(i,j), i=1,numtyp/2), j=1,nummass)
     & /75.d0,0.0188,0.0000,0.0169,0.0154,0.0000
     & ,80.d0,0.0399,0.0000,0.0290,0.0431,0.0000
     & ,85.d0,0.0762,0.0000,0.0925,0.0789,0.0000
     & ,90.d0,0.1717,0.0000,0.1467,0.1406,0.1111
     & ,95.d0,0.3451,0.0000,0.3816,0.3427,0.0357
     & ,100.d0,0.5564,0.0000,0.5847,0.5296,0.1846
     & ,104.d0,0.6297,0.0000,0.6410,0.6215,0.3197
     & ,106.d0,0.6250,0.0000,0.6425,0.6571,0.3521
     & ,108.d0,0.6185,0.0000,0.6650,0.6424,0.3209
     & ,110.d0,0.5847,0.0000,0.5641,0.6272,0.2561
     & ,112.d0,0.5365,0.0000,0.5503,0.5606,0.2939
     & ,113.d0,0.4844,0.0000,0.4600,0.4969,0.2189
     & ,114.d0,0.4387,0.0000,0.4122,0.4565,0.2328
     & ,114.8d0,0.4050,0.0000,0.4286,0.4576,0.1778
     & ,116.d0,0.4154,0.0000,0.4184,0.4126,0.1799
     & ,117.d0,0.3978,0.0000,0.3780,0.3333,0.1599
     & ,118.d0,0.4026,0.0000,0.3134,0.3333,0.1802
     & ,119.d0,0.3529,0.0000,0.3421,0.2986,0.1609
     & ,120.d0,0.3293,0.0000,0.3235,0.3212,0.1292/
      data ((eff(i,j), i=numtyp/2+1,numtyp), j=1,nummass)
     & /0.0183,0.0000,0.0059,0.0244,0.0000
     & ,0.0399,0.0000,0.0397,0.0629,0.0000
     & ,0.0790,0.0000,0.0643,0.0559,0.0000
     & ,0.1375,0.0000,0.1284,0.1236,0.0000
     & ,0.2862,0.0000,0.2656,0.2066,0.0952
     & ,0.4513,0.0000,0.3478,0.4390,0.1250
     & ,0.5112,0.0000,0.4589,0.5141,0.2656
     & ,0.5264,0.0000,0.4902,0.5224,0.2549
     & ,0.5287,0.0000,0.4720,0.5464,0.2374
     & ,0.4860,0.0000,0.4533,0.4882,0.2607
     & ,0.4562,0.0000,0.4830,0.4071,0.2050
     & ,0.4183,0.0000,0.3588,0.3565,0.1958
     & ,0.3694,0.0000,0.2670,0.3250,0.1671
     & ,0.3612,0.0000,0.3367,0.2560,0.1359
     & ,0.3369,0.0000,0.3834,0.2628,0.1373
     & ,0.3073,0.0000,0.3260,0.2639,0.1273
     & ,0.2939,0.0000,0.2778,0.2206,0.1140
     & ,0.2781,0.0000,0.2143,0.2153,0.0983
     & ,0.2771,0.0000,0.2121,0.2123,0.0936/
      do i = 1, nummass
         if (massh(i).le.mh) then
            mhindx=i
         endif
      enddo
      if (mhindx.eq.0) then
c         A2000_nn_sig_eff_206=eff(isig,1)
         A2000_nn_sig_eff_206=0.
      elseif(mhindx.eq.nummass) then
c         A2000_nn_sig_eff_206=eff(isig,nummass)
         A2000_nn_sig_eff_206=0.
      else
         A2000_nn_sig_eff_206=(eff(isig,mhindx)*(massh(mhindx+1)-mh)+
     &        eff(isig,mhindx+1)*(mh-massh(mhindx)))/(massh(mhindx+1)-
     &        massh(mhindx))
      endif
      end






      double precision function A2000_nn_sig_eff_208(isig,mh)
      implicit none
      integer isig, i, j
      real*8 mh
      integer nummass, numtyp,mhindx
      parameter (nummass=19)
      parameter (numtyp=10)
      real*8 eff(numtyp,nummass), massh(nummass)
*nu_blah nu_blah sig
      data (massh(j), (eff(i,j), i=1,numtyp/2), j=1,nummass)
     & /75.d0,0.0128,0.0000,0.0039,0.0146,0.0000
     & ,80.d0,0.0278,0.0000,0.0400,0.0214,0.0000
     & ,85.d0,0.0625,0.0000,0.0420,0.0706,0.0000
     & ,90.d0,0.1249,0.0000,0.1403,0.1153,0.0000
     & ,95.d0,0.2649,0.0000,0.2800,0.2053,0.0690
     & ,100.d0,0.4761,0.0000,0.4626,0.4537,0.2931
     & ,104.d0,0.5946,0.0000,0.5789,0.6225,0.2114
     & ,106.d0,0.6064,0.0000,0.6396,0.6006,0.3462
     & ,108.d0,0.6312,0.0000,0.6440,0.6608,0.2961
     & ,110.d0,0.6114,0.0000,0.6733,0.6230,0.2992
     & ,112.d0,0.5792,0.0000,0.5397,0.5836,0.3110
     & ,113.d0,0.5582,0.0000,0.5889,0.5503,0.2555
     & ,114.d0,0.5270,0.0000,0.5222,0.5481,0.2274
     & ,115.d0,0.4751,0.0000,0.4812,0.4700,0.2610
     & ,116.d0,0.4200,0.0000,0.3660,0.4589,0.2408
     & ,116.8d0,0.4100,0.0000,0.3878,0.4183,0.2067
     & ,118.d0,0.4128,0.0000,0.4636,0.3775,0.1979
     & ,119.d0,0.3947,0.0000,0.3289,0.3053,0.2129
     & ,120.d0,0.4011,0.0000,0.4684,0.3609,0.1554/
      data ((eff(i,j), i=numtyp/2+1,numtyp), j=1,nummass)
     & /0.0193,0.0000,0.0199,0.0362,0.0000
     & ,0.0376,0.0000,0.0357,0.0462,0.0000
     & ,0.0545,0.0000,0.0353,0.0947,0.0000
     & ,0.1062,0.0000,0.1030,0.1223,0.0000
     & ,0.2153,0.0000,0.2152,0.1702,0.0000
     & ,0.3702,0.0000,0.3664,0.3229,0.0870
     & ,0.4796,0.0000,0.4898,0.4672,0.2476
     & ,0.5080,0.0000,0.4750,0.4588,0.2243
     & ,0.5333,0.0000,0.4079,0.4964,0.2925
     & ,0.5211,0.0000,0.5130,0.5156,0.2056
     & ,0.4876,0.0000,0.4734,0.4590,0.2282
     & ,0.4639,0.0000,0.3878,0.4677,0.2597
     & ,0.4516,0.0000,0.4331,0.4561,0.1898
     & ,0.4067,0.0000,0.3274,0.3802,0.2050
     & ,0.3747,0.0000,0.3333,0.3315,0.1477
     & ,0.3530,0.0000,0.2620,0.3168,0.1669
     & ,0.3312,0.0000,0.2736,0.2557,0.1526
     & ,0.3114,0.0000,0.2808,0.2303,0.1478
     & ,0.3059,0.0000,0.2427,0.2309,0.1217/
      do i = 1, nummass
         if (massh(i).le.mh) then
            mhindx=i
         endif
      enddo
      if (mhindx.eq.0) then
c         A2000_nn_sig_eff_208=eff(isig,1)
         A2000_nn_sig_eff_208=0.
      elseif(mhindx.eq.nummass) then
c         A2000_nn_sig_eff_208=eff(isig,nummass)
         A2000_nn_sig_eff_208=0.
      else
         A2000_nn_sig_eff_208=(eff(isig,mhindx)*(massh(mhindx+1)-mh)+
     &        eff(isig,mhindx+1)*(mh-massh(mhindx)))/(massh(mhindx+1)-
     &        massh(mhindx))
      endif
      end




      double precision function A2000_nn_sig_eff_210(isig,mh)
      implicit none
      integer isig, i, j
      real*8 mh
      integer nummass, numtyp,mhindx
      parameter (nummass=19)
      parameter (numtyp=10)
      real*8 eff(numtyp,nummass), massh(nummass)
*nu_blah nu_blah sig
      data (massh(j), (eff(i,j), i=1,numtyp/2), j=1,nummass)
     & /75.d0,0.0097,0.0000,0.0132,0.0200,0.0000
     & ,80.d0,0.0209,0.0000,0.0330,0.0138,0.0000
     & ,85.d0,0.0465,0.0000,0.0670,0.0335,0.0000
     & ,90.d0,0.0870,0.0000,0.1102,0.0726,0.0833
     & ,95.d0,0.1982,0.0000,0.1610,0.1794,0.0455
     & ,100.d0,0.3889,0.0000,0.4009,0.3081,0.1967
     & ,104.d0,0.5450,0.0000,0.5551,0.4933,0.2547
     & ,106.d0,0.5838,0.0000,0.5344,0.5391,0.2692
     & ,108.d0,0.6143,0.0000,0.6000,0.6208,0.3286
     & ,110.d0,0.6124,0.0000,0.6714,0.6152,0.2908
     & ,112.d0,0.5998,0.0000,0.6224,0.6414,0.2831
     & ,113.d0,0.5901,0.0000,0.5904,0.6221,0.3150
     & ,114.d0,0.5686,0.0000,0.5622,0.5580,0.3023
     & ,115.d0,0.5462,0.0000,0.5427,0.5449,0.2408
     & ,116.d0,0.5296,0.0000,0.5625,0.5540,0.2836
     & ,117.d0,0.4887,0.0000,0.4277,0.5032,0.2428
     & ,118.d0,0.4213,0.0000,0.4275,0.4230,0.1957
     & ,118.8d0,0.4076,0.0000,0.3333,0.4160,0.2169
     & ,120.d0,0.5998,0.0000,0.6224,0.6414,0.2831
     & /
      data ((eff(i,j), i=numtyp/2+1,numtyp), j=1,nummass)
     & /0.0147,0.0000,0.0195,0.0145,0.0000
     & ,0.0289,0.0000,0.0188,0.0201,0.0000
     & ,0.0487,0.0000,0.0500,0.0116,0.0000
     & ,0.0822,0.0000,0.0752,0.0973,0.1111
     & ,0.1550,0.0000,0.1643,0.1892,0.1000
     & ,0.3104,0.0000,0.2837,0.2936,0.1190
     & ,0.4512,0.0000,0.4074,0.4103,0.1529
     & ,0.4935,0.0000,0.4630,0.4683,0.2478
     & ,0.5053,0.0000,0.5033,0.4898,0.2105
     & ,0.5219,0.0000,0.4867,0.5346,0.2412
     & ,0.5114,0.0000,0.5802,0.4833,0.2424
     & ,0.4862,0.0000,0.5068,0.4981,0.2063
     & ,0.4803,0.0000,0.4934,0.4625,0.2304
     & ,0.4583,0.0000,0.5338,0.4277,0.2337
     & ,0.4369,0.0000,0.4074,0.4242,0.2148
     & ,0.4014,0.0000,0.3758,0.4106,0.1761
     & ,0.3505,0.0000,0.3295,0.3158,0.1645
     & ,0.3411,0.0000,0.3369,0.2545,0.1408
     & ,0.5114,0.0000,0.5802,0.4833,0.2424
     & /
      do i = 1, nummass
         if (massh(i).le.mh) then
            mhindx=i
         endif
      enddo
      if (mhindx.eq.0) then
c         A2000_nn_sig_eff_210=eff(isig,1)
         A2000_nn_sig_eff_210=0.
      elseif(mhindx.eq.nummass) then
c         A2000_nn_sig_eff_210=eff(isig,nummass)
         A2000_nn_sig_eff_210=0.
      else
         A2000_nn_sig_eff_210=(eff(isig,mhindx)*(massh(mhindx+1)-mh)+
     &        eff(isig,mhindx+1)*(mh-massh(mhindx)))/(massh(mhindx+1)-
     &        massh(mhindx))
      endif
      end









      double precision function A2000_nn_btag_bkg(ecm,ibkg,x)
      implicit none
      real*8 ecm,x
      integer ibkg
      integer i,j, ecmindx,numecm
      parameter (numecm=9)
      
      real*8 a2000_hnn_qq_btag, a200_hnn_ww_btag, a202_hnn_ww_btag, 
     &     a204_hnn_ww_btag, a205_hnn_ww_btag, a206_hnn_ww_btag, 
     &     a207_hnn_ww_btag, a208_hnn_ww_btag,A200_hnn_ewnu_btag,
     &     A202_hnn_ewnu_btag,A204_hnn_ewnu_btag,A206_hnn_ewnu_btag,
     &     A208_hnn_ewnu_btag,A200_hnn_zz_btag,A205_hnn_ewnu_btag,
     &     A202_hnn_zz_btag,A204_hnn_zz_btag,A206_hnn_zz_btag,
     &     A208_hnn_zz_btag,A200_hnn_znn_btag,
     &     A202_hnn_znn_btag,A204_hnn_znn_btag,A206_hnn_znn_btag,
     &     A208_hnn_znn_btag,A207_hnn_zz_btag,A207_hnn_znn_btag,
     &     A207_hnn_ewnu_btag,A205_hnn_zz_btag,A205_hnn_znn_btag,
     &     A209_hnn_ww_btag,A209_hnn_ewnu_btag,A209_hnn_zz_btag,
     &     A209_hnn_znn_btag,A210_hnn_ww_btag,A210_hnn_ewnu_btag,
     &     A210_hnn_zz_btag,A210_hnn_znn_btag
      external a2000_hnn_qq_btag, a200_hnn_ww_btag, a202_hnn_ww_btag, 
     &     a204_hnn_ww_btag, a205_hnn_ww_btag, a206_hnn_ww_btag, 
     &     a207_hnn_ww_btag, a208_hnn_ww_btag,A200_hnn_ewnu_btag,
     &     A202_hnn_ewnu_btag,A204_hnn_ewnu_btag,A206_hnn_ewnu_btag,
     &     A208_hnn_ewnu_btag,A200_hnn_zz_btag,A205_hnn_ewnu_btag,
     &     A202_hnn_zz_btag,A204_hnn_zz_btag,A206_hnn_zz_btag,
     &     A208_hnn_zz_btag,A200_hnn_znn_btag,
     &     A202_hnn_znn_btag,A204_hnn_znn_btag,A206_hnn_znn_btag,
     &     A208_hnn_znn_btag,A207_hnn_zz_btag,A207_hnn_znn_btag,
     &     A207_hnn_ewnu_btag,A205_hnn_zz_btag,A205_hnn_znn_btag,
     &     A209_hnn_ww_btag,A209_hnn_ewnu_btag,A209_hnn_zz_btag,
     &     A209_hnn_znn_btag,A210_hnn_ww_btag,A210_hnn_ewnu_btag,
     &     A210_hnn_zz_btag,A210_hnn_znn_btag
      real*8 wwecm(numecm)
      real*8 bkgecm(numecm)
      data wwecm/200.d0,202.d0,204.d0,205.d0,206.d0,207.d0,208.d0
     & ,209.d0,210.d0/
      data bkgecm/199.5d0,201.6d0,204.d0,205.d0,206.d0,207.d0,208.d0
     & ,209.d0,210.d0/

      if (ibkg.lt.6) then
         a2000_nn_btag_bkg=a2000_hnn_qq_btag(x)
      elseif (ibkg.eq.6.or.ibkg.eq.7) then
         do i = 1, numecm
            if (wwecm(i).lt.ecm) then
               ecmindx=i
            endif
         enddo
         if (ibkg.eq.6) then
            if (ecmindx.eq.0) then
               a2000_nn_btag_bkg=a200_hnn_ww_btag(x)
            elseif(ecmindx.eq.numecm) then
               a2000_nn_btag_bkg=a210_hnn_ww_btag(x)
            elseif(ecmindx.eq.1) then
               a2000_nn_btag_bkg=(a200_hnn_ww_btag(x)
     &              *(wwecm(ecmindx+1)-ecm)+A202_hnn_ww_btag(x)
     &              *(ecm-wwecm(ecmindx)))/(wwecm(ecmindx+1)
     &              -wwecm(ecmindx))
            elseif(ecmindx.eq.2) then
               a2000_nn_btag_bkg=(a202_hnn_ww_btag(x)
     &              *(wwecm(ecmindx+1)-ecm)+A204_hnn_ww_btag(x)
     &              *(ecm-wwecm(ecmindx)))/(wwecm(ecmindx+1)
     &              -wwecm(ecmindx))
            elseif(ecmindx.eq.3) then
               a2000_nn_btag_bkg=(a204_hnn_ww_btag(x)
     &              *(wwecm(ecmindx+1)-ecm)+A205_hnn_ww_btag(x)
     &              *(ecm-wwecm(ecmindx)))/(wwecm(ecmindx+1)
     &              -wwecm(ecmindx))
            elseif(ecmindx.eq.4) then
               a2000_nn_btag_bkg=(a205_hnn_ww_btag(x)
     &              *(wwecm(ecmindx+1)-ecm)+A206_hnn_ww_btag(x)
     &              *(ecm-wwecm(ecmindx)))/(wwecm(ecmindx+1)
     &              -wwecm(ecmindx))
            elseif(ecmindx.eq.5) then
               a2000_nn_btag_bkg=(a206_hnn_ww_btag(x)
     &              *(wwecm(ecmindx+1)-ecm)+A207_hnn_ww_btag(x)
     &              *(ecm-wwecm(ecmindx)))/(wwecm(ecmindx+1)
     &              -wwecm(ecmindx))
            elseif(ecmindx.eq.6) then
               a2000_nn_btag_bkg=(a207_hnn_ww_btag(x)
     &              *(wwecm(ecmindx+1)-ecm)+A208_hnn_ww_btag(x)
     &              *(ecm-wwecm(ecmindx)))/(wwecm(ecmindx+1)
     &              -wwecm(ecmindx))
            elseif(ecmindx.eq.7) then
               a2000_nn_btag_bkg=(a208_hnn_ww_btag(x)
     &              *(wwecm(ecmindx+1)-ecm)+A209_hnn_ww_btag(x)
     &              *(ecm-wwecm(ecmindx)))/(wwecm(ecmindx+1)
     &              -wwecm(ecmindx))
            elseif(ecmindx.eq.8) then
               a2000_nn_btag_bkg=(a209_hnn_ww_btag(x)
     &              *(wwecm(ecmindx+1)-ecm)+A210_hnn_ww_btag(x)
     &              *(ecm-wwecm(ecmindx)))/(wwecm(ecmindx+1)
     &              -wwecm(ecmindx))
            else
               a2000_nn_btag_bkg=0.d0
            endif
            
         elseif (ibkg.eq.7) then
            if (ecmindx.eq.0) then
               a2000_nn_btag_bkg=a200_hnn_ewnu_btag(x)
            elseif(ecmindx.eq.numecm) then
               a2000_nn_btag_bkg=a210_hnn_ewnu_btag(x)
            elseif(ecmindx.eq.1) then
               a2000_nn_btag_bkg=(a200_hnn_ewnu_btag(x)
     &              *(wwecm(ecmindx+1)-ecm)+A202_hnn_ewnu_btag(x)
     &              *(ecm-wwecm(ecmindx)))/(wwecm(ecmindx+1)
     &              -wwecm(ecmindx))
            elseif(ecmindx.eq.2) then
               a2000_nn_btag_bkg=(a202_hnn_ewnu_btag(x)
     &              *(wwecm(ecmindx+1)-ecm)+A204_hnn_ewnu_btag(x)
     &              *(ecm-wwecm(ecmindx)))/(wwecm(ecmindx+1)
     &              -wwecm(ecmindx))
            elseif(ecmindx.eq.3) then
               a2000_nn_btag_bkg=(a204_hnn_ewnu_btag(x)
     &              *(wwecm(ecmindx+1)-ecm)+A205_hnn_ewnu_btag(x)
     &              *(ecm-wwecm(ecmindx)))/(wwecm(ecmindx+1)
     &              -wwecm(ecmindx))
            elseif(ecmindx.eq.4) then
               a2000_nn_btag_bkg=(a205_hnn_ewnu_btag(x)
     &              *(wwecm(ecmindx+1)-ecm)+A206_hnn_ewnu_btag(x)
     &              *(ecm-wwecm(ecmindx)))/(wwecm(ecmindx+1)
     &              -wwecm(ecmindx))
            elseif(ecmindx.eq.5) then
               a2000_nn_btag_bkg=(a206_hnn_ewnu_btag(x)
     &              *(wwecm(ecmindx+1)-ecm)+A207_hnn_ewnu_btag(x)
     &              *(ecm-wwecm(ecmindx)))/(wwecm(ecmindx+1)
     &              -wwecm(ecmindx))
            elseif(ecmindx.eq.6) then
               a2000_nn_btag_bkg=(a207_hnn_ewnu_btag(x)
     &              *(wwecm(ecmindx+1)-ecm)+A208_hnn_ewnu_btag(x)
     &              *(ecm-wwecm(ecmindx)))/(wwecm(ecmindx+1)
     &              -wwecm(ecmindx))
            elseif(ecmindx.eq.7) then
               a2000_nn_btag_bkg=(a208_hnn_ewnu_btag(x)
     &              *(wwecm(ecmindx+1)-ecm)+A209_hnn_ewnu_btag(x)
     &              *(ecm-wwecm(ecmindx)))/(wwecm(ecmindx+1)
     &              -wwecm(ecmindx))
            elseif(ecmindx.eq.8) then
               a2000_nn_btag_bkg=(a209_hnn_ewnu_btag(x)
     &              *(wwecm(ecmindx+1)-ecm)+A210_hnn_ewnu_btag(x)
     &              *(ecm-wwecm(ecmindx)))/(wwecm(ecmindx+1)
     &              -wwecm(ecmindx))
            else
               a2000_nn_btag_bkg=0.d0
            endif
         endif
      elseif (ibkg.gt.7.and.ibkg.lt.11) then
         do i = 1, numecm
            if (bkgecm(i).lt.ecm) then
               ecmindx=i
            endif
         enddo
         if(ibkg.eq.8.or.ibkg.eq.9) then
            if (ecmindx.eq.0) then
               a2000_nn_btag_bkg=a200_hnn_zz_btag(x)
            elseif(ecmindx.eq.numecm) then
               a2000_nn_btag_bkg=a210_hnn_zz_btag(x)
            elseif(ecmindx.eq.1) then
               a2000_nn_btag_bkg=(a200_hnn_zz_btag(x)
     &              *(bkgecm(ecmindx+1)-ecm)+A202_hnn_zz_btag(x)
     &              *(ecm-bkgecm(ecmindx)))/(bkgecm(ecmindx+1)
     &              -bkgecm(ecmindx))
            elseif(ecmindx.eq.2) then
               a2000_nn_btag_bkg=(a202_hnn_zz_btag(x)
     &              *(bkgecm(ecmindx+1)-ecm)+A204_hnn_zz_btag(x)
     &              *(ecm-bkgecm(ecmindx)))/(bkgecm(ecmindx+1)
     &              -bkgecm(ecmindx))
            elseif(ecmindx.eq.3) then
               a2000_nn_btag_bkg=(a204_hnn_zz_btag(x)
     &              *(bkgecm(ecmindx+1)-ecm)+A205_hnn_zz_btag(x)
     &              *(ecm-bkgecm(ecmindx)))/(bkgecm(ecmindx+1)
     &              -bkgecm(ecmindx))
            elseif(ecmindx.eq.4) then
               a2000_nn_btag_bkg=(a205_hnn_zz_btag(x)
     &              *(bkgecm(ecmindx+1)-ecm)+A206_hnn_zz_btag(x)
     &              *(ecm-bkgecm(ecmindx)))/(bkgecm(ecmindx+1)
     &              -bkgecm(ecmindx))
            elseif(ecmindx.eq.5) then
               a2000_nn_btag_bkg=(a206_hnn_zz_btag(x)
     &              *(bkgecm(ecmindx+1)-ecm)+A207_hnn_zz_btag(x)
     &              *(ecm-bkgecm(ecmindx)))/(bkgecm(ecmindx+1)
     &              -bkgecm(ecmindx))
            elseif(ecmindx.eq.6) then
               a2000_nn_btag_bkg=(a207_hnn_zz_btag(x)
     &              *(bkgecm(ecmindx+1)-ecm)+A208_hnn_zz_btag(x)
     &              *(ecm-bkgecm(ecmindx)))/(bkgecm(ecmindx+1)
     &              -bkgecm(ecmindx))
            elseif(ecmindx.eq.7) then
               a2000_nn_btag_bkg=(a208_hnn_zz_btag(x)
     &              *(bkgecm(ecmindx+1)-ecm)+A209_hnn_zz_btag(x)
     &              *(ecm-bkgecm(ecmindx)))/(bkgecm(ecmindx+1)
     &              -bkgecm(ecmindx))
            elseif(ecmindx.eq.8) then
               a2000_nn_btag_bkg=(a209_hnn_zz_btag(x)
     &              *(bkgecm(ecmindx+1)-ecm)+A210_hnn_zz_btag(x)
     &              *(ecm-bkgecm(ecmindx)))/(bkgecm(ecmindx+1)
     &              -bkgecm(ecmindx))
            else
               a2000_nn_btag_bkg=0.d0
            endif
         elseif(ibkg.eq.10) then
            if (ecmindx.eq.0) then
               a2000_nn_btag_bkg=a200_hnn_znn_btag(x)
            elseif(ecmindx.eq.numecm) then
               a2000_nn_btag_bkg=a210_hnn_znn_btag(x)
            elseif(ecmindx.eq.1) then
               a2000_nn_btag_bkg=(a200_hnn_znn_btag(x)
     &              *(bkgecm(ecmindx+1)-ecm)+A202_hnn_znn_btag(x)
     &              *(ecm-bkgecm(ecmindx)))/(bkgecm(ecmindx+1)
     &              -bkgecm(ecmindx))
            elseif(ecmindx.eq.2) then
               a2000_nn_btag_bkg=(a202_hnn_znn_btag(x)
     &              *(bkgecm(ecmindx+1)-ecm)+A204_hnn_znn_btag(x)
     &              *(ecm-bkgecm(ecmindx)))/(bkgecm(ecmindx+1)
     &              -bkgecm(ecmindx))
            elseif(ecmindx.eq.3) then
               a2000_nn_btag_bkg=(a204_hnn_znn_btag(x)
     &              *(bkgecm(ecmindx+1)-ecm)+A205_hnn_znn_btag(x)
     &              *(ecm-bkgecm(ecmindx)))/(bkgecm(ecmindx+1)
     &              -bkgecm(ecmindx))
            elseif(ecmindx.eq.4) then
               a2000_nn_btag_bkg=(a205_hnn_znn_btag(x)
     &              *(bkgecm(ecmindx+1)-ecm)+A206_hnn_znn_btag(x)
     &              *(ecm-bkgecm(ecmindx)))/(bkgecm(ecmindx+1)
     &              -bkgecm(ecmindx))
            elseif(ecmindx.eq.5) then
               a2000_nn_btag_bkg=(a206_hnn_znn_btag(x)
     &              *(bkgecm(ecmindx+1)-ecm)+A207_hnn_znn_btag(x)
     &              *(ecm-bkgecm(ecmindx)))/(bkgecm(ecmindx+1)
     &              -bkgecm(ecmindx))
            elseif(ecmindx.eq.6) then
               a2000_nn_btag_bkg=(a207_hnn_znn_btag(x)
     &              *(bkgecm(ecmindx+1)-ecm)+A208_hnn_znn_btag(x)
     &              *(ecm-bkgecm(ecmindx)))/(bkgecm(ecmindx+1)
     &              -bkgecm(ecmindx))
            elseif(ecmindx.eq.7) then
               a2000_nn_btag_bkg=(a208_hnn_znn_btag(x)
     &              *(bkgecm(ecmindx+1)-ecm)+A209_hnn_znn_btag(x)
     &              *(ecm-bkgecm(ecmindx)))/(bkgecm(ecmindx+1)
     &              -bkgecm(ecmindx))
            elseif(ecmindx.eq.8) then
               a2000_nn_btag_bkg=(a209_hnn_znn_btag(x)
     &              *(bkgecm(ecmindx+1)-ecm)+A210_hnn_znn_btag(x)
     &              *(ecm-bkgecm(ecmindx)))/(bkgecm(ecmindx+1)
     &              -bkgecm(ecmindx))
            else
               a2000_nn_btag_bkg=0.d0
            endif
         else
            a2000_nn_btag_bkg=0.d0
         endif
         
      else
         a2000_nn_btag_bkg=0.d0
      endif
      if(ecm.lt.198.d0.or.ecm.gt.210.d0) a2000_nn_btag_bkg=1.d0
      end



      double precision function A2000_nn_btag_sig(ecm,isig,hmass,x)
      implicit none
      real*8 ecm,x,hmass,ecmdif,ecmw1,ecmw2
      integer isig,i,j
      real*8 A2000_1995_nn_btag_sig,A2000_2016_nn_btag_sig,
     & A2000_204_nn_btag_sig,A2000_206_nn_btag_sig,
     & A2000_208_nn_btag_sig,A2000_210_nn_btag_sig
      external A2000_1995_nn_btag_sig,A2000_2016_nn_btag_sig,
     & A2000_204_nn_btag_sig,A2000_206_nn_btag_sig,
     & A2000_208_nn_btag_sig,A2000_210_nn_btag_sig
      integer numecm,ecmindx
      parameter (numecm=6)
      real*8 sigecm(numecm)
      data sigecm /199.5,201.6,204.,206.,208.,210./
      ecmindx=0
      do i=1,numecm
         if (sigecm(i).lt.ecm) then
            ecmindx =i
         endif
      enddo
      if(ecmindx.gt.0.and.ecmindx.lt.numecm) then
         ecmdif=sigecm(ecmindx+1)-sigecm(ecmindx)
         ecmw1=sigecm(ecmindx+1)-ecm
         ecmw2=ecm-sigecm(ecmindx)
      elseif(ecmindx.eq.0) then
         ecmdif=1.d0
         A2000_nn_btag_sig=A2000_1995_nn_btag_sig(x,hmass,isig)
      elseif(ecmindx.eq.numecm) then
         ecmdif=1.d0
         A2000_nn_btag_sig=a2000_210_nn_btag_sig(x,hmass,isig)
      else
         A2000_nn_btag_sig=0.d0
      endif
      if (ecmindx.eq.1) then
         A2000_nn_btag_sig=(a2000_1995_nn_btag_sig(x,hmass,isig)*ecmw1
     &        +A2000_2016_nn_btag_sig(x,hmass,isig)*ecmw2)/ecmdif
      elseif(ecmindx.eq.2) then
         A2000_nn_btag_sig=(a2000_2016_nn_btag_sig(x,hmass,isig)*ecmw1
     &        +A2000_204_nn_btag_sig(x,hmass,isig)*ecmw2)/ecmdif
      elseif(ecmindx.eq.3) then
         A2000_nn_btag_sig=(a2000_204_nn_btag_sig(x,hmass,isig)*ecmw1
     &        +A2000_206_nn_btag_sig(x,hmass,isig)*ecmw2)/ecmdif
      elseif(ecmindx.eq.4) then
         A2000_nn_btag_sig=(a2000_206_nn_btag_sig(x,hmass,isig)*ecmw1
     &        +A2000_208_nn_btag_sig(x,hmass,isig)*ecmw2)/ecmdif
      elseif(ecmindx.eq.5) then
         A2000_nn_btag_sig=(a2000_208_nn_btag_sig(x,hmass,isig)*ecmw1
     &        +A2000_210_nn_btag_sig(x,hmass,isig)*ecmw2)/ecmdif
      endif
      if(ecm.lt.198.d0.or.ecm.gt.210.d0.or.hmass.lt.75.d0.
     &     or.hmass.gt.120.d0) a2000_nn_btag_sig=1.d0
      end


      double precision function a2000_1995_nn_btag_sig(x,hmass,isig)
      implicit none
      real*8 x,hmass
      integer isig
      real*8 A2000_hnn_75_btag_nulnul_bb
     & ,A2000_hnn_75_btag_nulnul_cc, A2000_hnn_75_btag_nulnul_gg
      real*8 A2000_hnn_80_btag_nulnul_bb
     & ,A2000_hnn_80_btag_nulnul_cc, A2000_hnn_80_btag_nulnul_gg
      real*8 A2000_hnn_85_btag_nulnul_bb
     & ,A2000_hnn_85_btag_nulnul_cc, A2000_hnn_85_btag_nulnul_gg
      real*8 A2000_hnn_90_btag_nulnul_bb
     & ,A2000_hnn_90_btag_nulnul_cc, A2000_hnn_90_btag_nulnul_gg
      real*8 A2000_hnn_95_btag_nulnul_bb
     & ,A2000_hnn_95_btag_nulnul_cc, A2000_hnn_95_btag_nulnul_gg
      real*8 A1995_hnn_100_btag_nulnul_bb
     & ,A1995_hnn_100_btag_nulnul_cc, A1995_hnn_100_btag_nulnul_gg
     & ,A1995_hnn_100_btag_nulnul_ww
      real*8 A1995_hnn_105_btag_nulnul_bb
     & ,A1995_hnn_105_btag_nulnul_cc, A1995_hnn_105_btag_nulnul_gg
     & ,A1995_hnn_105_btag_nulnul_ww
      real*8 A1995_hnn_107_btag_nulnul_bb
     & ,A1995_hnn_107_btag_nulnul_cc, A1995_hnn_107_btag_nulnul_gg
     & ,A1995_hnn_107_btag_nulnul_ww
      real*8 A1995_hnn_110_btag_nulnul_bb
     & ,A1995_hnn_110_btag_nulnul_cc, A1995_hnn_110_btag_nulnul_gg
     & ,A1995_hnn_110_btag_nulnul_ww
      real*8 A1995_hnn_115_btag_nulnul_bb
     & ,A1995_hnn_115_btag_nulnul_cc, A1995_hnn_115_btag_nulnul_gg
     & ,A1995_hnn_115_btag_nulnul_ww
      real*8 A1995_hnn_120_btag_nulnul_bb
     & ,A1995_hnn_120_btag_nulnul_cc, A1995_hnn_120_btag_nulnul_gg
     & ,A1995_hnn_120_btag_nulnul_ww

      external A2000_hnn_75_btag_nulnul_bb
     & ,A2000_hnn_75_btag_nulnul_cc, A2000_hnn_75_btag_nulnul_gg
      external A2000_hnn_80_btag_nulnul_bb
     & ,A2000_hnn_80_btag_nulnul_cc, A2000_hnn_80_btag_nulnul_gg
      external A2000_hnn_85_btag_nulnul_bb
     & ,A2000_hnn_85_btag_nulnul_cc, A2000_hnn_85_btag_nulnul_gg
      external A2000_hnn_90_btag_nulnul_bb
     & ,A2000_hnn_90_btag_nulnul_cc, A2000_hnn_90_btag_nulnul_gg
      external A2000_hnn_95_btag_nulnul_bb
     & ,A2000_hnn_95_btag_nulnul_cc, A2000_hnn_95_btag_nulnul_gg
      external A1995_hnn_100_btag_nulnul_bb
     & ,A1995_hnn_100_btag_nulnul_cc, A1995_hnn_100_btag_nulnul_gg
     & ,A1995_hnn_100_btag_nulnul_ww
      external A1995_hnn_105_btag_nulnul_bb
     & ,A1995_hnn_105_btag_nulnul_cc, A1995_hnn_105_btag_nulnul_gg
     & ,A1995_hnn_105_btag_nulnul_ww
      external A1995_hnn_107_btag_nulnul_bb
     & ,A1995_hnn_107_btag_nulnul_cc, A1995_hnn_107_btag_nulnul_gg
     & ,A1995_hnn_107_btag_nulnul_ww
      external A1995_hnn_110_btag_nulnul_bb
     & ,A1995_hnn_110_btag_nulnul_cc, A1995_hnn_110_btag_nulnul_gg
     & ,A1995_hnn_110_btag_nulnul_ww
      external A1995_hnn_115_btag_nulnul_bb
     & ,A1995_hnn_115_btag_nulnul_cc, A1995_hnn_115_btag_nulnul_gg
     & ,A1995_hnn_115_btag_nulnul_ww
      external A1995_hnn_120_btag_nulnul_bb
     & ,A1995_hnn_120_btag_nulnul_cc, A1995_hnn_120_btag_nulnul_gg
     & ,A1995_hnn_120_btag_nulnul_ww


      real*8 A2000_hnn_75_btag_nuenue_bb
     & ,A2000_hnn_75_btag_nuenue_cc, A2000_hnn_75_btag_nuenue_gg
      real*8 A2000_hnn_80_btag_nuenue_bb
     & ,A2000_hnn_80_btag_nuenue_cc, A2000_hnn_80_btag_nuenue_gg
      real*8 A2000_hnn_85_btag_nuenue_bb
     & ,A2000_hnn_85_btag_nuenue_cc, A2000_hnn_85_btag_nuenue_gg
      real*8 A2000_hnn_90_btag_nuenue_bb
     & ,A2000_hnn_90_btag_nuenue_cc, A2000_hnn_90_btag_nuenue_gg
      real*8 A2000_hnn_95_btag_nuenue_bb
     & ,A2000_hnn_95_btag_nuenue_cc, A2000_hnn_95_btag_nuenue_gg
      real*8 A1995_hnn_100_btag_nuenue_bb
     & ,A1995_hnn_100_btag_nuenue_cc, A1995_hnn_100_btag_nuenue_gg
     & ,A1995_hnn_100_btag_nuenue_ww
      real*8 A1995_hnn_105_btag_nuenue_bb
     & ,A1995_hnn_105_btag_nuenue_cc, A1995_hnn_105_btag_nuenue_gg
     & ,A1995_hnn_105_btag_nuenue_ww
      real*8 A1995_hnn_107_btag_nuenue_bb
     & ,A1995_hnn_107_btag_nuenue_cc, A1995_hnn_107_btag_nuenue_gg
     & ,A1995_hnn_107_btag_nuenue_ww
      real*8 A1995_hnn_110_btag_nuenue_bb
     & ,A1995_hnn_110_btag_nuenue_cc, A1995_hnn_110_btag_nuenue_gg
     & ,A1995_hnn_110_btag_nuenue_ww
      real*8 A1995_hnn_115_btag_nuenue_bb
     & ,A1995_hnn_115_btag_nuenue_cc, A1995_hnn_115_btag_nuenue_gg
     & ,A1995_hnn_115_btag_nuenue_ww
      real*8 A1995_hnn_120_btag_nuenue_bb
     & ,A1995_hnn_120_btag_nuenue_cc, A1995_hnn_120_btag_nuenue_gg
     & ,A1995_hnn_120_btag_nuenue_ww

      external A2000_hnn_75_btag_nuenue_bb
     & ,A2000_hnn_75_btag_nuenue_cc, A2000_hnn_75_btag_nuenue_gg
      external A2000_hnn_80_btag_nuenue_bb
     & ,A2000_hnn_80_btag_nuenue_cc, A2000_hnn_80_btag_nuenue_gg
      external A2000_hnn_85_btag_nuenue_bb
     & ,A2000_hnn_85_btag_nuenue_cc, A2000_hnn_85_btag_nuenue_gg
      external A2000_hnn_90_btag_nuenue_bb
     & ,A2000_hnn_90_btag_nuenue_cc, A2000_hnn_90_btag_nuenue_gg
      external A2000_hnn_95_btag_nuenue_bb
     & ,A2000_hnn_95_btag_nuenue_cc, A2000_hnn_95_btag_nuenue_gg
      external A1995_hnn_100_btag_nuenue_bb
     & ,A1995_hnn_100_btag_nuenue_cc, A1995_hnn_100_btag_nuenue_gg
     & ,A1995_hnn_100_btag_nuenue_ww
      external A1995_hnn_105_btag_nuenue_bb
     & ,A1995_hnn_105_btag_nuenue_cc, A1995_hnn_105_btag_nuenue_gg
     & ,A1995_hnn_105_btag_nuenue_ww
      external A1995_hnn_107_btag_nuenue_bb
     & ,A1995_hnn_107_btag_nuenue_cc, A1995_hnn_107_btag_nuenue_gg
     & ,A1995_hnn_107_btag_nuenue_ww
      external A1995_hnn_110_btag_nuenue_bb
     & ,A1995_hnn_110_btag_nuenue_cc, A1995_hnn_110_btag_nuenue_gg
     & ,A1995_hnn_110_btag_nuenue_ww
      external A1995_hnn_115_btag_nuenue_bb
     & ,A1995_hnn_115_btag_nuenue_cc, A1995_hnn_115_btag_nuenue_gg
     & ,A1995_hnn_115_btag_nuenue_ww
      external A1995_hnn_120_btag_nuenue_bb
     & ,A1995_hnn_120_btag_nuenue_cc, A1995_hnn_120_btag_nuenue_gg
     & ,A1995_hnn_120_btag_nuenue_ww


      integer nummass,i,j,mhindx
      parameter (nummass=11) 
      real*8 sigmass(nummass),mhdif,val1,val2,w1,w2
      data sigmass /75.d0,80.d0,85.d0,90.d0,95.d0,100.d0
     &     ,105.d0,107.d0,110.d0,115.d0,120.d0/
      mhindx=0
      do i= 1,nummass
         if (sigmass(i).lt.hmass) mhindx=i
      enddo
      if (mhindx.gt.0.and.mhindx.lt.nummass) then
         w1=sigmass(mhindx+1)-hmass
         w2=hmass-sigmass(mhindx)
         mhdif=sigmass(mhindx+1)-sigmass(mhindx)
      endif
      if (isig.eq.1) then
         if (mhindx.eq.0) then
            val1=A2000_hnn_75_btag_nulnul_bb(x)
            val2=A2000_hnn_75_btag_nulnul_bb(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         elseif (mhindx.eq.1) then
            val1=A2000_hnn_75_btag_nulnul_bb(x)
            val2=A2000_hnn_80_btag_nulnul_bb(x)
         elseif (mhindx.eq.2) then
            val1=A2000_hnn_80_btag_nulnul_bb(x)
            val2=A2000_hnn_85_btag_nulnul_bb(x)
         elseif (mhindx.eq.3) then
            val1=A2000_hnn_85_btag_nulnul_bb(x)
            val2=A2000_hnn_90_btag_nulnul_bb(x)
         elseif (mhindx.eq.4) then
            val1=A2000_hnn_90_btag_nulnul_bb(x)
            val2=A2000_hnn_95_btag_nulnul_bb(x)
         elseif (mhindx.eq.5) then
            val1=A2000_hnn_95_btag_nulnul_bb(x)
            val2=A1995_hnn_100_btag_nulnul_bb(x)
         elseif (mhindx.eq.6) then
            val1=A1995_hnn_100_btag_nulnul_bb(x)
            val2=A1995_hnn_105_btag_nulnul_bb(x)
         elseif (mhindx.eq.7) then
            val1=A1995_hnn_105_btag_nulnul_bb(x)
            val2=A1995_hnn_107_btag_nulnul_bb(x)
         elseif (mhindx.eq.8) then
            val1=A1995_hnn_107_btag_nulnul_bb(x)
            val2=A1995_hnn_110_btag_nulnul_bb(x)
         elseif (mhindx.eq.9) then
            val1=A1995_hnn_110_btag_nulnul_bb(x)
            val2=A1995_hnn_115_btag_nulnul_bb(x)
         elseif (mhindx.eq.10) then
            val1=A1995_hnn_115_btag_nulnul_bb(x)
            val2=A1995_hnn_120_btag_nulnul_bb(x)
         elseif (mhindx.eq.nummass) then
            val1=A1995_hnn_120_btag_nulnul_bb(x)
            val2=A1995_hnn_120_btag_nulnul_bb(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         endif
      elseif (isig.eq.3) then
         if (mhindx.eq.0) then
            val1=A2000_hnn_75_btag_nulnul_cc(x)
            val2=A2000_hnn_75_btag_nulnul_cc(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         elseif (mhindx.eq.1) then
            val1=A2000_hnn_75_btag_nulnul_cc(x)
            val2=A2000_hnn_80_btag_nulnul_cc(x)
         elseif (mhindx.eq.2) then
            val1=A2000_hnn_80_btag_nulnul_cc(x)
            val2=A2000_hnn_85_btag_nulnul_cc(x)
         elseif (mhindx.eq.3) then
            val1=A2000_hnn_85_btag_nulnul_cc(x)
            val2=A2000_hnn_90_btag_nulnul_cc(x)
         elseif (mhindx.eq.4) then
            val1=A2000_hnn_90_btag_nulnul_cc(x)
            val2=A2000_hnn_95_btag_nulnul_cc(x)
         elseif (mhindx.eq.5) then
            val1=A2000_hnn_95_btag_nulnul_cc(x)
            val2=A1995_hnn_100_btag_nulnul_cc(x)
         elseif (mhindx.eq.6) then
            val1=A1995_hnn_100_btag_nulnul_cc(x)
            val2=A1995_hnn_105_btag_nulnul_cc(x)
         elseif (mhindx.eq.7) then
            val1=A1995_hnn_105_btag_nulnul_cc(x)
            val2=A1995_hnn_107_btag_nulnul_cc(x)
         elseif (mhindx.eq.8) then
            val1=A1995_hnn_107_btag_nulnul_cc(x)
            val2=A1995_hnn_110_btag_nulnul_cc(x)
         elseif (mhindx.eq.9) then
            val1=A1995_hnn_110_btag_nulnul_cc(x)
            val2=A1995_hnn_115_btag_nulnul_cc(x)
         elseif (mhindx.eq.10) then
            val1=A1995_hnn_115_btag_nulnul_cc(x)
            val2=A1995_hnn_120_btag_nulnul_cc(x)
         elseif (mhindx.eq.nummass) then
            val1=A1995_hnn_120_btag_nulnul_cc(x)
            val2=A1995_hnn_120_btag_nulnul_cc(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         endif
      elseif (isig.eq.4) then
         if (mhindx.eq.0) then
            val1=A2000_hnn_75_btag_nulnul_gg(x)
            val2=A2000_hnn_75_btag_nulnul_gg(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         elseif (mhindx.eq.1) then
            val1=A2000_hnn_75_btag_nulnul_gg(x)
            val2=A2000_hnn_80_btag_nulnul_gg(x)
         elseif (mhindx.eq.2) then
            val1=A2000_hnn_80_btag_nulnul_gg(x)
            val2=A2000_hnn_85_btag_nulnul_gg(x)
         elseif (mhindx.eq.3) then
            val1=A2000_hnn_85_btag_nulnul_gg(x)
            val2=A2000_hnn_90_btag_nulnul_gg(x)
         elseif (mhindx.eq.4) then
            val1=A2000_hnn_90_btag_nulnul_gg(x)
            val2=A2000_hnn_95_btag_nulnul_gg(x)
         elseif (mhindx.eq.5) then
            val1=A2000_hnn_95_btag_nulnul_gg(x)
            val2=A1995_hnn_100_btag_nulnul_gg(x)
         elseif (mhindx.eq.6) then
            val1=A1995_hnn_100_btag_nulnul_gg(x)
            val2=A1995_hnn_105_btag_nulnul_gg(x)
         elseif (mhindx.eq.7) then
            val1=A1995_hnn_105_btag_nulnul_gg(x)
            val2=A1995_hnn_107_btag_nulnul_gg(x)
         elseif (mhindx.eq.8) then
            val1=A1995_hnn_107_btag_nulnul_gg(x)
            val2=A1995_hnn_110_btag_nulnul_gg(x)
         elseif (mhindx.eq.9) then
            val1=A1995_hnn_110_btag_nulnul_gg(x)
            val2=A1995_hnn_115_btag_nulnul_gg(x)
         elseif (mhindx.eq.10) then
            val1=A1995_hnn_115_btag_nulnul_gg(x)
            val2=A1995_hnn_120_btag_nulnul_gg(x)
         elseif (mhindx.eq.nummass) then
            val1=A1995_hnn_120_btag_nulnul_gg(x)
            val2=A1995_hnn_120_btag_nulnul_gg(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         endif
      elseif (isig.eq.5.or.isig.eq.2) then
         if (mhindx.eq.0) then
            val1=A2000_hnn_75_btag_nulnul_cc(x)
            val2=A2000_hnn_75_btag_nulnul_cc(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         elseif (mhindx.eq.1) then
            val1=A2000_hnn_75_btag_nulnul_cc(x)
            val2=A2000_hnn_80_btag_nulnul_cc(x)
         elseif (mhindx.eq.2) then
            val1=A2000_hnn_80_btag_nulnul_cc(x)
            val2=A2000_hnn_85_btag_nulnul_cc(x)
         elseif (mhindx.eq.3) then
            val1=A2000_hnn_85_btag_nulnul_cc(x)
            val2=A2000_hnn_90_btag_nulnul_cc(x)
         elseif (mhindx.eq.4) then
            val1=A2000_hnn_90_btag_nulnul_cc(x)
            val2=A2000_hnn_95_btag_nulnul_cc(x)
         elseif (mhindx.eq.5) then
            val1=A2000_hnn_95_btag_nulnul_cc(x)
            val2=A1995_hnn_100_btag_nulnul_ww(x)
         elseif (mhindx.eq.6) then
            val1=A1995_hnn_100_btag_nulnul_ww(x)
            val2=A1995_hnn_105_btag_nulnul_ww(x)
         elseif (mhindx.eq.7) then
            val1=A1995_hnn_105_btag_nulnul_ww(x)
            val2=A1995_hnn_107_btag_nulnul_ww(x)
         elseif (mhindx.eq.8) then
            val1=A1995_hnn_107_btag_nulnul_ww(x)
            val2=A1995_hnn_110_btag_nulnul_ww(x)
         elseif (mhindx.eq.9) then
            val1=A1995_hnn_110_btag_nulnul_ww(x)
            val2=A1995_hnn_115_btag_nulnul_ww(x)
         elseif (mhindx.eq.10) then
            val1=A1995_hnn_115_btag_nulnul_ww(x)
            val2=A1995_hnn_120_btag_nulnul_ww(x)
         elseif (mhindx.eq.nummass) then
            val1=A1995_hnn_120_btag_nulnul_ww(x)
            val2=A1995_hnn_120_btag_nulnul_ww(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         endif

      elseif (isig.eq.6) then
         if (mhindx.eq.0) then
            val1=A2000_hnn_75_btag_nuenue_bb(x)
            val2=A2000_hnn_75_btag_nuenue_bb(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         elseif (mhindx.eq.1) then
            val1=A2000_hnn_75_btag_nuenue_bb(x)
            val2=A2000_hnn_80_btag_nuenue_bb(x)
         elseif (mhindx.eq.2) then
            val1=A2000_hnn_80_btag_nuenue_bb(x)
            val2=A2000_hnn_85_btag_nuenue_bb(x)
         elseif (mhindx.eq.3) then
            val1=A2000_hnn_85_btag_nuenue_bb(x)
            val2=A2000_hnn_90_btag_nuenue_bb(x)
         elseif (mhindx.eq.4) then
            val1=A2000_hnn_90_btag_nuenue_bb(x)
            val2=A2000_hnn_95_btag_nuenue_bb(x)
         elseif (mhindx.eq.5) then
            val1=A2000_hnn_95_btag_nuenue_bb(x)
            val2=A1995_hnn_100_btag_nuenue_bb(x)
         elseif (mhindx.eq.6) then
            val1=A1995_hnn_100_btag_nuenue_bb(x)
            val2=A1995_hnn_105_btag_nuenue_bb(x)
         elseif (mhindx.eq.7) then
            val1=A1995_hnn_105_btag_nuenue_bb(x)
            val2=A1995_hnn_107_btag_nuenue_bb(x)
         elseif (mhindx.eq.8) then
            val1=A1995_hnn_107_btag_nuenue_bb(x)
            val2=A1995_hnn_110_btag_nuenue_bb(x)
         elseif (mhindx.eq.9) then
            val1=A1995_hnn_110_btag_nuenue_bb(x)
            val2=A1995_hnn_115_btag_nuenue_bb(x)
         elseif (mhindx.eq.10) then
            val1=A1995_hnn_115_btag_nuenue_bb(x)
            val2=A1995_hnn_120_btag_nuenue_bb(x)
         elseif (mhindx.eq.nummass) then
            val1=A1995_hnn_120_btag_nuenue_bb(x)
            val2=A1995_hnn_120_btag_nuenue_bb(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         endif
      elseif (isig.eq.8) then
         if (mhindx.eq.0) then
            val1=A2000_hnn_75_btag_nuenue_cc(x)
            val2=A2000_hnn_75_btag_nuenue_cc(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         elseif (mhindx.eq.1) then
            val1=A2000_hnn_75_btag_nuenue_cc(x)
            val2=A2000_hnn_80_btag_nuenue_cc(x)
         elseif (mhindx.eq.2) then
            val1=A2000_hnn_80_btag_nuenue_cc(x)
            val2=A2000_hnn_85_btag_nuenue_cc(x)
         elseif (mhindx.eq.3) then
            val1=A2000_hnn_85_btag_nuenue_cc(x)
            val2=A2000_hnn_90_btag_nuenue_cc(x)
         elseif (mhindx.eq.4) then
            val1=A2000_hnn_90_btag_nuenue_cc(x)
            val2=A2000_hnn_95_btag_nuenue_cc(x)
         elseif (mhindx.eq.5) then
            val1=A2000_hnn_95_btag_nuenue_cc(x)
            val2=A1995_hnn_100_btag_nuenue_cc(x)
         elseif (mhindx.eq.6) then
            val1=A1995_hnn_100_btag_nuenue_cc(x)
            val2=A1995_hnn_105_btag_nuenue_cc(x)
         elseif (mhindx.eq.7) then
            val1=A1995_hnn_105_btag_nuenue_cc(x)
            val2=A1995_hnn_107_btag_nuenue_cc(x)
         elseif (mhindx.eq.8) then
            val1=A1995_hnn_107_btag_nuenue_cc(x)
            val2=A1995_hnn_110_btag_nuenue_cc(x)
         elseif (mhindx.eq.9) then
            val1=A1995_hnn_110_btag_nuenue_cc(x)
            val2=A1995_hnn_115_btag_nuenue_cc(x)
         elseif (mhindx.eq.10) then
            val1=A1995_hnn_115_btag_nuenue_cc(x)
            val2=A1995_hnn_120_btag_nuenue_cc(x)
         elseif (mhindx.eq.nummass) then
            val1=A1995_hnn_120_btag_nuenue_cc(x)
            val2=A1995_hnn_120_btag_nuenue_cc(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         endif
      elseif (isig.eq.9) then
         if (mhindx.eq.0) then
            val1=A2000_hnn_75_btag_nuenue_gg(x)
            val2=A2000_hnn_75_btag_nuenue_gg(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         elseif (mhindx.eq.1) then
            val1=A2000_hnn_75_btag_nuenue_gg(x)
            val2=A2000_hnn_80_btag_nuenue_gg(x)
         elseif (mhindx.eq.2) then
            val1=A2000_hnn_80_btag_nuenue_gg(x)
            val2=A2000_hnn_85_btag_nuenue_gg(x)
         elseif (mhindx.eq.3) then
            val1=A2000_hnn_85_btag_nuenue_gg(x)
            val2=A2000_hnn_90_btag_nuenue_gg(x)
         elseif (mhindx.eq.4) then
            val1=A2000_hnn_90_btag_nuenue_gg(x)
            val2=A2000_hnn_95_btag_nuenue_gg(x)
         elseif (mhindx.eq.5) then
            val1=A2000_hnn_95_btag_nuenue_gg(x)
            val2=A1995_hnn_100_btag_nuenue_gg(x)
         elseif (mhindx.eq.6) then
            val1=A1995_hnn_100_btag_nuenue_gg(x)
            val2=A1995_hnn_105_btag_nuenue_gg(x)
         elseif (mhindx.eq.7) then
            val1=A1995_hnn_105_btag_nuenue_gg(x)
            val2=A1995_hnn_107_btag_nuenue_gg(x)
         elseif (mhindx.eq.8) then
            val1=A1995_hnn_107_btag_nuenue_gg(x)
            val2=A1995_hnn_110_btag_nuenue_gg(x)
         elseif (mhindx.eq.9) then
            val1=A1995_hnn_110_btag_nuenue_gg(x)
            val2=A1995_hnn_115_btag_nuenue_gg(x)
         elseif (mhindx.eq.10) then
            val1=A1995_hnn_115_btag_nuenue_gg(x)
            val2=A1995_hnn_120_btag_nuenue_gg(x)
         elseif (mhindx.eq.nummass) then
            val1=A1995_hnn_120_btag_nuenue_gg(x)
            val2=A1995_hnn_120_btag_nuenue_gg(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         endif
      elseif (isig.eq.10.or.isig.eq.7) then
         if (mhindx.eq.0) then
            val1=A2000_hnn_75_btag_nuenue_cc(x)
            val2=A2000_hnn_75_btag_nuenue_cc(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         elseif (mhindx.eq.1) then
            val1=A2000_hnn_75_btag_nuenue_cc(x)
            val2=A2000_hnn_80_btag_nuenue_cc(x)
         elseif (mhindx.eq.2) then
            val1=A2000_hnn_80_btag_nuenue_cc(x)
            val2=A2000_hnn_85_btag_nuenue_cc(x)
         elseif (mhindx.eq.3) then
            val1=A2000_hnn_85_btag_nuenue_cc(x)
            val2=A2000_hnn_90_btag_nuenue_cc(x)
         elseif (mhindx.eq.4) then
            val1=A2000_hnn_90_btag_nuenue_cc(x)
            val2=A2000_hnn_95_btag_nuenue_cc(x)
         elseif (mhindx.eq.5) then
            val1=A2000_hnn_95_btag_nuenue_cc(x)
            val2=A1995_hnn_100_btag_nuenue_ww(x)
         elseif (mhindx.eq.6) then
            val1=A1995_hnn_100_btag_nuenue_ww(x)
            val2=A1995_hnn_105_btag_nuenue_ww(x)
         elseif (mhindx.eq.7) then
            val1=A1995_hnn_105_btag_nuenue_ww(x)
            val2=A1995_hnn_107_btag_nuenue_ww(x)
         elseif (mhindx.eq.8) then
            val1=A1995_hnn_107_btag_nuenue_ww(x)
            val2=A1995_hnn_110_btag_nuenue_ww(x)
         elseif (mhindx.eq.9) then
            val1=A1995_hnn_110_btag_nuenue_ww(x)
            val2=A1995_hnn_115_btag_nuenue_ww(x)
         elseif (mhindx.eq.10) then
            val1=A1995_hnn_115_btag_nuenue_ww(x)
            val2=A1995_hnn_120_btag_nuenue_ww(x)
         elseif (mhindx.eq.nummass) then
            val1=A1995_hnn_120_btag_nuenue_ww(x)
            val2=A1995_hnn_120_btag_nuenue_ww(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         endif
      else
         val1=0.d0
         val2=0.d0
         w1=1.d0
         w2=1.d0
         mhdif=1.d0
      endif
      A2000_1995_nn_btag_sig=(val1*w1+val2*w2)/mhdif
      end


      double precision function a2000_2016_nn_btag_sig(x,hmass,isig)
      implicit none
      real*8 x,hmass
      integer isig
      real*8 A2000_hnn_75_btag_nulnul_bb
     & ,A2000_hnn_75_btag_nulnul_cc, A2000_hnn_75_btag_nulnul_gg
      real*8 A2000_hnn_80_btag_nulnul_bb
     & ,A2000_hnn_80_btag_nulnul_cc, A2000_hnn_80_btag_nulnul_gg
      real*8 A2000_hnn_85_btag_nulnul_bb
     & ,A2000_hnn_85_btag_nulnul_cc, A2000_hnn_85_btag_nulnul_gg
      real*8 A2000_hnn_90_btag_nulnul_bb
     & ,A2000_hnn_90_btag_nulnul_cc, A2000_hnn_90_btag_nulnul_gg
      real*8 A2000_hnn_95_btag_nulnul_bb
     & ,A2000_hnn_95_btag_nulnul_cc, A2000_hnn_95_btag_nulnul_gg
      real*8 A2016_hnn_100_btag_nulnul_bb
     & ,A2016_hnn_100_btag_nulnul_cc, A2016_hnn_100_btag_nulnul_gg
     & ,A2016_hnn_100_btag_nulnul_ww
      real*8 A2016_hnn_105_btag_nulnul_bb
     & ,A2016_hnn_105_btag_nulnul_cc, A2016_hnn_105_btag_nulnul_gg
     & ,A2016_hnn_105_btag_nulnul_ww
      real*8 A2016_hnn_107_btag_nulnul_bb
     & ,A2016_hnn_107_btag_nulnul_cc, A2016_hnn_107_btag_nulnul_gg
     & ,A2016_hnn_107_btag_nulnul_ww
      real*8 A2016_hnn_110_btag_nulnul_bb
     & ,A2016_hnn_110_btag_nulnul_cc, A2016_hnn_110_btag_nulnul_gg
     & ,A2016_hnn_110_btag_nulnul_ww
      real*8 A2016_hnn_115_btag_nulnul_bb
     & ,A2016_hnn_115_btag_nulnul_cc, A2016_hnn_115_btag_nulnul_gg
     & ,A2016_hnn_115_btag_nulnul_ww
      real*8 A2016_hnn_120_btag_nulnul_bb
     & ,A2016_hnn_120_btag_nulnul_cc, A2016_hnn_120_btag_nulnul_gg
     & ,A2016_hnn_120_btag_nulnul_ww

      external A2000_hnn_75_btag_nulnul_bb
     & ,A2000_hnn_75_btag_nulnul_cc, A2000_hnn_75_btag_nulnul_gg
      external A2000_hnn_80_btag_nulnul_bb
     & ,A2000_hnn_80_btag_nulnul_cc, A2000_hnn_80_btag_nulnul_gg
      external A2000_hnn_85_btag_nulnul_bb
     & ,A2000_hnn_85_btag_nulnul_cc, A2000_hnn_85_btag_nulnul_gg
      external A2000_hnn_90_btag_nulnul_bb
     & ,A2000_hnn_90_btag_nulnul_cc, A2000_hnn_90_btag_nulnul_gg
      external A2000_hnn_95_btag_nulnul_bb
     & ,A2000_hnn_95_btag_nulnul_cc, A2000_hnn_95_btag_nulnul_gg
      external A2016_hnn_100_btag_nulnul_bb
     & ,A2016_hnn_100_btag_nulnul_cc, A2016_hnn_100_btag_nulnul_gg
     & ,A2016_hnn_100_btag_nulnul_ww
      external A2016_hnn_105_btag_nulnul_bb
     & ,A2016_hnn_105_btag_nulnul_cc, A2016_hnn_105_btag_nulnul_gg
     & ,A2016_hnn_105_btag_nulnul_ww
      external A2016_hnn_107_btag_nulnul_bb
     & ,A2016_hnn_107_btag_nulnul_cc, A2016_hnn_107_btag_nulnul_gg
     & ,A2016_hnn_107_btag_nulnul_ww
      external A2016_hnn_110_btag_nulnul_bb
     & ,A2016_hnn_110_btag_nulnul_cc, A2016_hnn_110_btag_nulnul_gg
     & ,A2016_hnn_110_btag_nulnul_ww
      external A2016_hnn_115_btag_nulnul_bb
     & ,A2016_hnn_115_btag_nulnul_cc, A2016_hnn_115_btag_nulnul_gg
     & ,A2016_hnn_115_btag_nulnul_ww
      external A2016_hnn_120_btag_nulnul_bb
     & ,A2016_hnn_120_btag_nulnul_cc, A2016_hnn_120_btag_nulnul_gg
     & ,A2016_hnn_120_btag_nulnul_ww

      real*8 A2000_hnn_75_btag_nuenue_bb
     & ,A2000_hnn_75_btag_nuenue_cc, A2000_hnn_75_btag_nuenue_gg
      real*8 A2000_hnn_80_btag_nuenue_bb
     & ,A2000_hnn_80_btag_nuenue_cc, A2000_hnn_80_btag_nuenue_gg
      real*8 A2000_hnn_85_btag_nuenue_bb
     & ,A2000_hnn_85_btag_nuenue_cc, A2000_hnn_85_btag_nuenue_gg
      real*8 A2000_hnn_90_btag_nuenue_bb
     & ,A2000_hnn_90_btag_nuenue_cc, A2000_hnn_90_btag_nuenue_gg
      real*8 A2000_hnn_95_btag_nuenue_bb
     & ,A2000_hnn_95_btag_nuenue_cc, A2000_hnn_95_btag_nuenue_gg
      real*8 A2016_hnn_100_btag_nuenue_bb
     & ,A2016_hnn_100_btag_nuenue_cc, A2016_hnn_100_btag_nuenue_gg
     & ,A2016_hnn_100_btag_nuenue_ww
      real*8 A2016_hnn_105_btag_nuenue_bb
     & ,A2016_hnn_105_btag_nuenue_cc, A2016_hnn_105_btag_nuenue_gg
     & ,A2016_hnn_105_btag_nuenue_ww
      real*8 A2016_hnn_107_btag_nuenue_bb
     & ,A2016_hnn_107_btag_nuenue_cc, A2016_hnn_107_btag_nuenue_gg
     & ,A2016_hnn_107_btag_nuenue_ww
      real*8 A2016_hnn_110_btag_nuenue_bb
     & ,A2016_hnn_110_btag_nuenue_cc, A2016_hnn_110_btag_nuenue_gg
     & ,A2016_hnn_110_btag_nuenue_ww
      real*8 A2016_hnn_115_btag_nuenue_bb
     & ,A2016_hnn_115_btag_nuenue_cc, A2016_hnn_115_btag_nuenue_gg
     & ,A2016_hnn_115_btag_nuenue_ww
      real*8 A2016_hnn_120_btag_nuenue_bb
     & ,A2016_hnn_120_btag_nuenue_cc, A2016_hnn_120_btag_nuenue_gg
     & ,A2016_hnn_120_btag_nuenue_ww

      external A2000_hnn_75_btag_nuenue_bb
     & ,A2000_hnn_75_btag_nuenue_cc, A2000_hnn_75_btag_nuenue_gg
      external A2000_hnn_80_btag_nuenue_bb
     & ,A2000_hnn_80_btag_nuenue_cc, A2000_hnn_80_btag_nuenue_gg
      external A2000_hnn_85_btag_nuenue_bb
     & ,A2000_hnn_85_btag_nuenue_cc, A2000_hnn_85_btag_nuenue_gg
      external A2000_hnn_90_btag_nuenue_bb
     & ,A2000_hnn_90_btag_nuenue_cc, A2000_hnn_90_btag_nuenue_gg
      external A2000_hnn_95_btag_nuenue_bb
     & ,A2000_hnn_95_btag_nuenue_cc, A2000_hnn_95_btag_nuenue_gg
      external A2016_hnn_100_btag_nuenue_bb
     & ,A2016_hnn_100_btag_nuenue_cc, A2016_hnn_100_btag_nuenue_gg
     & ,A2016_hnn_100_btag_nuenue_ww
      external A2016_hnn_105_btag_nuenue_bb
     & ,A2016_hnn_105_btag_nuenue_cc, A2016_hnn_105_btag_nuenue_gg
     & ,A2016_hnn_105_btag_nuenue_ww
      external A2016_hnn_107_btag_nuenue_bb
     & ,A2016_hnn_107_btag_nuenue_cc, A2016_hnn_107_btag_nuenue_gg
     & ,A2016_hnn_107_btag_nuenue_ww
      external A2016_hnn_110_btag_nuenue_bb
     & ,A2016_hnn_110_btag_nuenue_cc, A2016_hnn_110_btag_nuenue_gg
     & ,A2016_hnn_110_btag_nuenue_ww
      external A2016_hnn_115_btag_nuenue_bb
     & ,A2016_hnn_115_btag_nuenue_cc, A2016_hnn_115_btag_nuenue_gg
     & ,A2016_hnn_115_btag_nuenue_ww
      external A2016_hnn_120_btag_nuenue_bb
     & ,A2016_hnn_120_btag_nuenue_cc, A2016_hnn_120_btag_nuenue_gg
     & ,A2016_hnn_120_btag_nuenue_ww



      integer nummass,i,j,mhindx
      parameter (nummass=11) 
      real*8 sigmass(nummass),mhdif,val1,val2,w1,w2
      data sigmass /75.d0,80.d0,85.d0,90.d0,95.d0,100.d0
     &     ,105.d0,107.d0,110.d0,115.d0,120.d0/
      mhindx=0
      do i= 1,nummass
         if (sigmass(i).lt.hmass) mhindx=i
      enddo
      if (mhindx.gt.0.and.mhindx.lt.nummass) then
         w1=sigmass(mhindx+1)-hmass
         w2=hmass-sigmass(mhindx)
         mhdif=sigmass(mhindx+1)-sigmass(mhindx)
      endif
      if (isig.eq.1) then
         if (mhindx.eq.0) then
            val1=A2000_hnn_75_btag_nulnul_bb(x)
            val2=A2000_hnn_75_btag_nulnul_bb(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         elseif (mhindx.eq.1) then
            val1=A2000_hnn_75_btag_nulnul_bb(x)
            val2=A2000_hnn_80_btag_nulnul_bb(x)
         elseif (mhindx.eq.2) then
            val1=A2000_hnn_80_btag_nulnul_bb(x)
            val2=A2000_hnn_85_btag_nulnul_bb(x)
         elseif (mhindx.eq.3) then
            val1=A2000_hnn_85_btag_nulnul_bb(x)
            val2=A2000_hnn_90_btag_nulnul_bb(x)
         elseif (mhindx.eq.4) then
            val1=A2000_hnn_90_btag_nulnul_bb(x)
            val2=A2000_hnn_95_btag_nulnul_bb(x)
         elseif (mhindx.eq.5) then
            val1=A2000_hnn_95_btag_nulnul_bb(x)
            val2=A2016_hnn_100_btag_nulnul_bb(x)
         elseif (mhindx.eq.6) then
            val1=A2016_hnn_100_btag_nulnul_bb(x)
            val2=A2016_hnn_105_btag_nulnul_bb(x)
         elseif (mhindx.eq.7) then
            val1=A2016_hnn_105_btag_nulnul_bb(x)
            val2=A2016_hnn_107_btag_nulnul_bb(x)
         elseif (mhindx.eq.8) then
            val1=A2016_hnn_107_btag_nulnul_bb(x)
            val2=A2016_hnn_110_btag_nulnul_bb(x)
         elseif (mhindx.eq.9) then
            val1=A2016_hnn_110_btag_nulnul_bb(x)
            val2=A2016_hnn_115_btag_nulnul_bb(x)
         elseif (mhindx.eq.10) then
            val1=A2016_hnn_115_btag_nulnul_bb(x)
            val2=A2016_hnn_120_btag_nulnul_bb(x)
         elseif (mhindx.eq.nummass) then
            val1=A2016_hnn_120_btag_nulnul_bb(x)
            val2=A2016_hnn_120_btag_nulnul_bb(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         endif
      elseif (isig.eq.3) then
         if (mhindx.eq.0) then
            val1=A2000_hnn_75_btag_nulnul_cc(x)
            val2=A2000_hnn_75_btag_nulnul_cc(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         elseif (mhindx.eq.1) then
            val1=A2000_hnn_75_btag_nulnul_cc(x)
            val2=A2000_hnn_80_btag_nulnul_cc(x)
         elseif (mhindx.eq.2) then
            val1=A2000_hnn_80_btag_nulnul_cc(x)
            val2=A2000_hnn_85_btag_nulnul_cc(x)
         elseif (mhindx.eq.3) then
            val1=A2000_hnn_85_btag_nulnul_cc(x)
            val2=A2000_hnn_90_btag_nulnul_cc(x)
         elseif (mhindx.eq.4) then
            val1=A2000_hnn_90_btag_nulnul_cc(x)
            val2=A2000_hnn_95_btag_nulnul_cc(x)
         elseif (mhindx.eq.5) then
            val1=A2000_hnn_95_btag_nulnul_cc(x)
            val2=A2016_hnn_100_btag_nulnul_cc(x)
         elseif (mhindx.eq.6) then
            val1=A2016_hnn_100_btag_nulnul_cc(x)
            val2=A2016_hnn_105_btag_nulnul_cc(x)
         elseif (mhindx.eq.7) then
            val1=A2016_hnn_105_btag_nulnul_cc(x)
            val2=A2016_hnn_107_btag_nulnul_cc(x)
         elseif (mhindx.eq.8) then
            val1=A2016_hnn_107_btag_nulnul_cc(x)
            val2=A2016_hnn_110_btag_nulnul_cc(x)
         elseif (mhindx.eq.9) then
            val1=A2016_hnn_110_btag_nulnul_cc(x)
            val2=A2016_hnn_115_btag_nulnul_cc(x)
         elseif (mhindx.eq.10) then
            val1=A2016_hnn_115_btag_nulnul_cc(x)
            val2=A2016_hnn_120_btag_nulnul_cc(x)
         elseif (mhindx.eq.nummass) then
            val1=A2016_hnn_120_btag_nulnul_cc(x)
            val2=A2016_hnn_120_btag_nulnul_cc(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         endif
      elseif (isig.eq.4) then
         if (mhindx.eq.0) then
            val1=A2000_hnn_75_btag_nulnul_gg(x)
            val2=A2000_hnn_75_btag_nulnul_gg(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         elseif (mhindx.eq.1) then
            val1=A2000_hnn_75_btag_nulnul_gg(x)
            val2=A2000_hnn_80_btag_nulnul_gg(x)
         elseif (mhindx.eq.2) then
            val1=A2000_hnn_80_btag_nulnul_gg(x)
            val2=A2000_hnn_85_btag_nulnul_gg(x)
         elseif (mhindx.eq.3) then
            val1=A2000_hnn_85_btag_nulnul_gg(x)
            val2=A2000_hnn_90_btag_nulnul_gg(x)
         elseif (mhindx.eq.4) then
            val1=A2000_hnn_90_btag_nulnul_gg(x)
            val2=A2000_hnn_95_btag_nulnul_gg(x)
         elseif (mhindx.eq.5) then
            val1=A2000_hnn_95_btag_nulnul_gg(x)
            val2=A2016_hnn_100_btag_nulnul_gg(x)
         elseif (mhindx.eq.6) then
            val1=A2016_hnn_100_btag_nulnul_gg(x)
            val2=A2016_hnn_105_btag_nulnul_gg(x)
         elseif (mhindx.eq.7) then
            val1=A2016_hnn_105_btag_nulnul_gg(x)
            val2=A2016_hnn_107_btag_nulnul_gg(x)
         elseif (mhindx.eq.8) then
            val1=A2016_hnn_107_btag_nulnul_gg(x)
            val2=A2016_hnn_110_btag_nulnul_gg(x)
         elseif (mhindx.eq.9) then
            val1=A2016_hnn_110_btag_nulnul_gg(x)
            val2=A2016_hnn_115_btag_nulnul_gg(x)
         elseif (mhindx.eq.10) then
            val1=A2016_hnn_115_btag_nulnul_gg(x)
            val2=A2016_hnn_120_btag_nulnul_gg(x)
         elseif (mhindx.eq.nummass) then
            val1=A2016_hnn_120_btag_nulnul_gg(x)
            val2=A2016_hnn_120_btag_nulnul_gg(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         endif
      elseif (isig.eq.5.or.isig.eq.2) then
         if (mhindx.eq.0) then
            val1=A2000_hnn_75_btag_nulnul_cc(x)
            val2=A2000_hnn_75_btag_nulnul_cc(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         elseif (mhindx.eq.1) then
            val1=A2000_hnn_75_btag_nulnul_cc(x)
            val2=A2000_hnn_80_btag_nulnul_cc(x)
         elseif (mhindx.eq.2) then
            val1=A2000_hnn_80_btag_nulnul_cc(x)
            val2=A2000_hnn_85_btag_nulnul_cc(x)
         elseif (mhindx.eq.3) then
            val1=A2000_hnn_85_btag_nulnul_cc(x)
            val2=A2000_hnn_90_btag_nulnul_cc(x)
         elseif (mhindx.eq.4) then
            val1=A2000_hnn_90_btag_nulnul_cc(x)
            val2=A2000_hnn_95_btag_nulnul_cc(x)
         elseif (mhindx.eq.5) then
            val1=A2000_hnn_95_btag_nulnul_cc(x)
            val2=A2016_hnn_100_btag_nulnul_ww(x)
         elseif (mhindx.eq.6) then
            val1=A2016_hnn_100_btag_nulnul_ww(x)
            val2=A2016_hnn_105_btag_nulnul_ww(x)
         elseif (mhindx.eq.7) then
            val1=A2016_hnn_105_btag_nulnul_ww(x)
            val2=A2016_hnn_107_btag_nulnul_ww(x)
         elseif (mhindx.eq.8) then
            val1=A2016_hnn_107_btag_nulnul_ww(x)
            val2=A2016_hnn_110_btag_nulnul_ww(x)
         elseif (mhindx.eq.9) then
            val1=A2016_hnn_110_btag_nulnul_ww(x)
            val2=A2016_hnn_115_btag_nulnul_ww(x)
         elseif (mhindx.eq.10) then
            val1=A2016_hnn_115_btag_nulnul_ww(x)
            val2=A2016_hnn_120_btag_nulnul_ww(x)
         elseif (mhindx.eq.nummass) then
            val1=A2016_hnn_120_btag_nulnul_ww(x)
            val2=A2016_hnn_120_btag_nulnul_ww(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         endif

      elseif (isig.eq.6) then
         if (mhindx.eq.0) then
            val1=A2000_hnn_75_btag_nuenue_bb(x)
            val2=A2000_hnn_75_btag_nuenue_bb(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         elseif (mhindx.eq.1) then
            val1=A2000_hnn_75_btag_nuenue_bb(x)
            val2=A2000_hnn_80_btag_nuenue_bb(x)
         elseif (mhindx.eq.2) then
            val1=A2000_hnn_80_btag_nuenue_bb(x)
            val2=A2000_hnn_85_btag_nuenue_bb(x)
         elseif (mhindx.eq.3) then
            val1=A2000_hnn_85_btag_nuenue_bb(x)
            val2=A2000_hnn_90_btag_nuenue_bb(x)
         elseif (mhindx.eq.4) then
            val1=A2000_hnn_90_btag_nuenue_bb(x)
            val2=A2000_hnn_95_btag_nuenue_bb(x)
         elseif (mhindx.eq.5) then
            val1=A2000_hnn_95_btag_nuenue_bb(x)
            val2=A2016_hnn_100_btag_nuenue_bb(x)
         elseif (mhindx.eq.6) then
            val1=A2016_hnn_100_btag_nuenue_bb(x)
            val2=A2016_hnn_105_btag_nuenue_bb(x)
         elseif (mhindx.eq.7) then
            val1=A2016_hnn_105_btag_nuenue_bb(x)
            val2=A2016_hnn_107_btag_nuenue_bb(x)
         elseif (mhindx.eq.8) then
            val1=A2016_hnn_107_btag_nuenue_bb(x)
            val2=A2016_hnn_110_btag_nuenue_bb(x)
         elseif (mhindx.eq.9) then
            val1=A2016_hnn_110_btag_nuenue_bb(x)
            val2=A2016_hnn_115_btag_nuenue_bb(x)
         elseif (mhindx.eq.10) then
            val1=A2016_hnn_115_btag_nuenue_bb(x)
            val2=A2016_hnn_120_btag_nuenue_bb(x)
         elseif (mhindx.eq.nummass) then
            val1=A2016_hnn_120_btag_nuenue_bb(x)
            val2=A2016_hnn_120_btag_nuenue_bb(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         endif
      elseif (isig.eq.8) then
         if (mhindx.eq.0) then
            val1=A2000_hnn_75_btag_nuenue_cc(x)
            val2=A2000_hnn_75_btag_nuenue_cc(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         elseif (mhindx.eq.1) then
            val1=A2000_hnn_75_btag_nuenue_cc(x)
            val2=A2000_hnn_80_btag_nuenue_cc(x)
         elseif (mhindx.eq.2) then
            val1=A2000_hnn_80_btag_nuenue_cc(x)
            val2=A2000_hnn_85_btag_nuenue_cc(x)
         elseif (mhindx.eq.3) then
            val1=A2000_hnn_85_btag_nuenue_cc(x)
            val2=A2000_hnn_90_btag_nuenue_cc(x)
         elseif (mhindx.eq.4) then
            val1=A2000_hnn_90_btag_nuenue_cc(x)
            val2=A2000_hnn_95_btag_nuenue_cc(x)
         elseif (mhindx.eq.5) then
            val1=A2000_hnn_95_btag_nuenue_cc(x)
            val2=A2016_hnn_100_btag_nuenue_cc(x)
         elseif (mhindx.eq.6) then
            val1=A2016_hnn_100_btag_nuenue_cc(x)
            val2=A2016_hnn_105_btag_nuenue_cc(x)
         elseif (mhindx.eq.7) then
            val1=A2016_hnn_105_btag_nuenue_cc(x)
            val2=A2016_hnn_107_btag_nuenue_cc(x)
         elseif (mhindx.eq.8) then
            val1=A2016_hnn_107_btag_nuenue_cc(x)
            val2=A2016_hnn_110_btag_nuenue_cc(x)
         elseif (mhindx.eq.9) then
            val1=A2016_hnn_110_btag_nuenue_cc(x)
            val2=A2016_hnn_115_btag_nuenue_cc(x)
         elseif (mhindx.eq.10) then
            val1=A2016_hnn_115_btag_nuenue_cc(x)
            val2=A2016_hnn_120_btag_nuenue_cc(x)
         elseif (mhindx.eq.nummass) then
            val1=A2016_hnn_120_btag_nuenue_cc(x)
            val2=A2016_hnn_120_btag_nuenue_cc(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         endif
      elseif (isig.eq.9) then
         if (mhindx.eq.0) then
            val1=A2000_hnn_75_btag_nuenue_gg(x)
            val2=A2000_hnn_75_btag_nuenue_gg(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         elseif (mhindx.eq.1) then
            val1=A2000_hnn_75_btag_nuenue_gg(x)
            val2=A2000_hnn_80_btag_nuenue_gg(x)
         elseif (mhindx.eq.2) then
            val1=A2000_hnn_80_btag_nuenue_gg(x)
            val2=A2000_hnn_85_btag_nuenue_gg(x)
         elseif (mhindx.eq.3) then
            val1=A2000_hnn_85_btag_nuenue_gg(x)
            val2=A2000_hnn_90_btag_nuenue_gg(x)
         elseif (mhindx.eq.4) then
            val1=A2000_hnn_90_btag_nuenue_gg(x)
            val2=A2000_hnn_95_btag_nuenue_gg(x)
         elseif (mhindx.eq.5) then
            val1=A2000_hnn_95_btag_nuenue_gg(x)
            val2=A2016_hnn_100_btag_nuenue_gg(x)
         elseif (mhindx.eq.6) then
            val1=A2016_hnn_100_btag_nuenue_gg(x)
            val2=A2016_hnn_105_btag_nuenue_gg(x)
         elseif (mhindx.eq.7) then
            val1=A2016_hnn_105_btag_nuenue_gg(x)
            val2=A2016_hnn_107_btag_nuenue_gg(x)
         elseif (mhindx.eq.8) then
            val1=A2016_hnn_107_btag_nuenue_gg(x)
            val2=A2016_hnn_110_btag_nuenue_gg(x)
         elseif (mhindx.eq.9) then
            val1=A2016_hnn_110_btag_nuenue_gg(x)
            val2=A2016_hnn_115_btag_nuenue_gg(x)
         elseif (mhindx.eq.10) then
            val1=A2016_hnn_115_btag_nuenue_gg(x)
            val2=A2016_hnn_120_btag_nuenue_gg(x)
         elseif (mhindx.eq.nummass) then
            val1=A2016_hnn_120_btag_nuenue_gg(x)
            val2=A2016_hnn_120_btag_nuenue_gg(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         endif
      elseif (isig.eq.10.or.isig.eq.7) then
         if (mhindx.eq.0) then
            val1=A2000_hnn_75_btag_nuenue_cc(x)
            val2=A2000_hnn_75_btag_nuenue_cc(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         elseif (mhindx.eq.1) then
            val1=A2000_hnn_75_btag_nuenue_cc(x)
            val2=A2000_hnn_80_btag_nuenue_cc(x)
         elseif (mhindx.eq.2) then
            val1=A2000_hnn_80_btag_nuenue_cc(x)
            val2=A2000_hnn_85_btag_nuenue_cc(x)
         elseif (mhindx.eq.3) then
            val1=A2000_hnn_85_btag_nuenue_cc(x)
            val2=A2000_hnn_90_btag_nuenue_cc(x)
         elseif (mhindx.eq.4) then
            val1=A2000_hnn_90_btag_nuenue_cc(x)
            val2=A2000_hnn_95_btag_nuenue_cc(x)
         elseif (mhindx.eq.5) then
            val1=A2000_hnn_95_btag_nuenue_cc(x)
            val2=A2016_hnn_100_btag_nuenue_ww(x)
         elseif (mhindx.eq.6) then
            val1=A2016_hnn_100_btag_nuenue_ww(x)
            val2=A2016_hnn_105_btag_nuenue_ww(x)
         elseif (mhindx.eq.7) then
            val1=A2016_hnn_105_btag_nuenue_ww(x)
            val2=A2016_hnn_107_btag_nuenue_ww(x)
         elseif (mhindx.eq.8) then
            val1=A2016_hnn_107_btag_nuenue_ww(x)
            val2=A2016_hnn_110_btag_nuenue_ww(x)
         elseif (mhindx.eq.9) then
            val1=A2016_hnn_110_btag_nuenue_ww(x)
            val2=A2016_hnn_115_btag_nuenue_ww(x)
         elseif (mhindx.eq.10) then
            val1=A2016_hnn_115_btag_nuenue_ww(x)
            val2=A2016_hnn_120_btag_nuenue_ww(x)
         elseif (mhindx.eq.nummass) then
            val1=A2016_hnn_120_btag_nuenue_ww(x)
            val2=A2016_hnn_120_btag_nuenue_ww(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         endif
      else
         val1=0.d0
         val2=0.d0
         w1=1.d0
         w2=1.d0
         mhdif=1.d0
      endif
      A2000_2016_nn_btag_sig=(val1*w1+val2*w2)/mhdif
      end

      double precision function a2000_204_nn_btag_sig(x,hmass,isig)
      implicit none
      real*8 x,hmass
      integer isig
      real*8 A2000_hnn_75_btag_nulnul_bb
     & ,A2000_hnn_75_btag_nulnul_cc, A2000_hnn_75_btag_nulnul_gg
      real*8 A2000_hnn_80_btag_nulnul_bb
     & ,A2000_hnn_80_btag_nulnul_cc, A2000_hnn_80_btag_nulnul_gg
      real*8 A2000_hnn_85_btag_nulnul_bb
     & ,A2000_hnn_85_btag_nulnul_cc, A2000_hnn_85_btag_nulnul_gg
      real*8 A2000_hnn_90_btag_nulnul_bb
     & ,A2000_hnn_90_btag_nulnul_cc, A2000_hnn_90_btag_nulnul_gg
      real*8 A2000_hnn_95_btag_nulnul_bb
     & ,A2000_hnn_95_btag_nulnul_cc, A2000_hnn_95_btag_nulnul_gg
      real*8 A204_hnn_100_btag_nulnul_bb
     & ,A204_hnn_100_btag_nulnul_cc, A204_hnn_100_btag_nulnul_gg
     & ,A204_hnn_100_btag_nulnul_ww
      real*8 A204_hnn_102_btag_nulnul_bb
     & ,A204_hnn_102_btag_nulnul_cc, A204_hnn_102_btag_nulnul_gg
     & ,A204_hnn_102_btag_nulnul_ww
      real*8 A204_hnn_104_btag_nulnul_bb
     & ,A204_hnn_104_btag_nulnul_cc, A204_hnn_104_btag_nulnul_gg
     & ,A204_hnn_104_btag_nulnul_ww
      real*8 A204_hnn_106_btag_nulnul_bb
     & ,A204_hnn_106_btag_nulnul_cc, A204_hnn_106_btag_nulnul_gg
     & ,A204_hnn_106_btag_nulnul_ww
      real*8 A204_hnn_108_btag_nulnul_bb
     & ,A204_hnn_108_btag_nulnul_cc, A204_hnn_108_btag_nulnul_gg
     & ,A204_hnn_108_btag_nulnul_ww
      real*8 A204_hnn_110_btag_nulnul_bb
     & ,A204_hnn_110_btag_nulnul_cc, A204_hnn_110_btag_nulnul_gg
     & ,A204_hnn_110_btag_nulnul_ww
      real*8 A204_hnn_111_btag_nulnul_bb
     & ,A204_hnn_111_btag_nulnul_cc, A204_hnn_111_btag_nulnul_gg
     & ,A204_hnn_111_btag_nulnul_ww
      real*8 A204_hnn_112_btag_nulnul_bb
     & ,A204_hnn_112_btag_nulnul_cc, A204_hnn_112_btag_nulnul_gg
     & ,A204_hnn_112_btag_nulnul_ww
      real*8 A204_hnn_1128_btag_nulnul_bb
     & ,A204_hnn_1128_btag_nulnul_cc, A204_hnn_1128_btag_nulnul_gg
     & ,A204_hnn_1128_btag_nulnul_ww
      real*8 A204_hnn_114_btag_nulnul_bb
     & ,A204_hnn_114_btag_nulnul_cc, A204_hnn_114_btag_nulnul_gg
     & ,A204_hnn_114_btag_nulnul_ww
      real*8 A204_hnn_115_btag_nulnul_bb
     & ,A204_hnn_115_btag_nulnul_cc, A204_hnn_115_btag_nulnul_gg
     & ,A204_hnn_115_btag_nulnul_ww
      real*8 A204_hnn_116_btag_nulnul_bb
     & ,A204_hnn_116_btag_nulnul_cc, A204_hnn_116_btag_nulnul_gg
     & ,A204_hnn_116_btag_nulnul_ww
      real*8 A204_hnn_118_btag_nulnul_bb
     & ,A204_hnn_118_btag_nulnul_cc, A204_hnn_118_btag_nulnul_gg
     & ,A204_hnn_118_btag_nulnul_ww
      real*8 A204_hnn_120_btag_nulnul_bb
     & ,A204_hnn_120_btag_nulnul_cc, A204_hnn_120_btag_nulnul_gg
     & ,A204_hnn_120_btag_nulnul_ww

      external A2000_hnn_75_btag_nulnul_bb
     & ,A2000_hnn_75_btag_nulnul_cc, A2000_hnn_75_btag_nulnul_gg
      external A2000_hnn_80_btag_nulnul_bb
     & ,A2000_hnn_80_btag_nulnul_cc, A2000_hnn_80_btag_nulnul_gg
      external A2000_hnn_85_btag_nulnul_bb
     & ,A2000_hnn_85_btag_nulnul_cc, A2000_hnn_85_btag_nulnul_gg
      external A2000_hnn_90_btag_nulnul_bb
     & ,A2000_hnn_90_btag_nulnul_cc, A2000_hnn_90_btag_nulnul_gg
      external A2000_hnn_95_btag_nulnul_bb
     & ,A2000_hnn_95_btag_nulnul_cc, A2000_hnn_95_btag_nulnul_gg
      external A204_hnn_100_btag_nulnul_bb
     & ,A204_hnn_100_btag_nulnul_cc, A204_hnn_100_btag_nulnul_gg
     & ,A204_hnn_100_btag_nulnul_ww
      external A204_hnn_102_btag_nulnul_bb
     & ,A204_hnn_102_btag_nulnul_cc, A204_hnn_102_btag_nulnul_gg
     & ,A204_hnn_102_btag_nulnul_ww
      external A204_hnn_104_btag_nulnul_bb
     & ,A204_hnn_104_btag_nulnul_cc, A204_hnn_104_btag_nulnul_gg
     & ,A204_hnn_104_btag_nulnul_ww
      external A204_hnn_106_btag_nulnul_bb
     & ,A204_hnn_106_btag_nulnul_cc, A204_hnn_106_btag_nulnul_gg
     & ,A204_hnn_106_btag_nulnul_ww
      external A204_hnn_108_btag_nulnul_bb
     & ,A204_hnn_108_btag_nulnul_cc, A204_hnn_108_btag_nulnul_gg
     & ,A204_hnn_108_btag_nulnul_ww
      external A204_hnn_110_btag_nulnul_bb
     & ,A204_hnn_110_btag_nulnul_cc, A204_hnn_110_btag_nulnul_gg
     & ,A204_hnn_110_btag_nulnul_ww
      external A204_hnn_111_btag_nulnul_bb
     & ,A204_hnn_111_btag_nulnul_cc, A204_hnn_111_btag_nulnul_gg
     & ,A204_hnn_111_btag_nulnul_ww
      external A204_hnn_112_btag_nulnul_bb
     & ,A204_hnn_112_btag_nulnul_cc, A204_hnn_112_btag_nulnul_gg
     & ,A204_hnn_112_btag_nulnul_ww
      external A204_hnn_1128_btag_nulnul_bb
     & ,A204_hnn_1128_btag_nulnul_cc, A204_hnn_1128_btag_nulnul_gg
     & ,A204_hnn_1128_btag_nulnul_ww
      external A204_hnn_114_btag_nulnul_bb
     & ,A204_hnn_114_btag_nulnul_cc, A204_hnn_114_btag_nulnul_gg
     & ,A204_hnn_114_btag_nulnul_ww
      external A204_hnn_115_btag_nulnul_bb
     & ,A204_hnn_115_btag_nulnul_cc, A204_hnn_115_btag_nulnul_gg
     & ,A204_hnn_115_btag_nulnul_ww
      external A204_hnn_116_btag_nulnul_bb
     & ,A204_hnn_116_btag_nulnul_cc, A204_hnn_116_btag_nulnul_gg
     & ,A204_hnn_116_btag_nulnul_ww
      external A204_hnn_118_btag_nulnul_bb
     & ,A204_hnn_118_btag_nulnul_cc, A204_hnn_118_btag_nulnul_gg
     & ,A204_hnn_118_btag_nulnul_ww
      external A204_hnn_120_btag_nulnul_bb
     & ,A204_hnn_120_btag_nulnul_cc, A204_hnn_120_btag_nulnul_gg
     & ,A204_hnn_120_btag_nulnul_ww

      real*8 A2000_hnn_75_btag_nuenue_bb
     & ,A2000_hnn_75_btag_nuenue_cc, A2000_hnn_75_btag_nuenue_gg
      real*8 A2000_hnn_80_btag_nuenue_bb
     & ,A2000_hnn_80_btag_nuenue_cc, A2000_hnn_80_btag_nuenue_gg
      real*8 A2000_hnn_85_btag_nuenue_bb
     & ,A2000_hnn_85_btag_nuenue_cc, A2000_hnn_85_btag_nuenue_gg
      real*8 A2000_hnn_90_btag_nuenue_bb
     & ,A2000_hnn_90_btag_nuenue_cc, A2000_hnn_90_btag_nuenue_gg
      real*8 A2000_hnn_95_btag_nuenue_bb
     & ,A2000_hnn_95_btag_nuenue_cc, A2000_hnn_95_btag_nuenue_gg
      real*8 A204_hnn_100_btag_nuenue_bb
     & ,A204_hnn_100_btag_nuenue_cc, A204_hnn_100_btag_nuenue_gg
     & ,A204_hnn_100_btag_nuenue_ww
      real*8 A204_hnn_102_btag_nuenue_bb
     & ,A204_hnn_102_btag_nuenue_cc, A204_hnn_102_btag_nuenue_gg
     & ,A204_hnn_102_btag_nuenue_ww
      real*8 A204_hnn_104_btag_nuenue_bb
     & ,A204_hnn_104_btag_nuenue_cc, A204_hnn_104_btag_nuenue_gg
     & ,A204_hnn_104_btag_nuenue_ww
      real*8 A204_hnn_106_btag_nuenue_bb
     & ,A204_hnn_106_btag_nuenue_cc, A204_hnn_106_btag_nuenue_gg
     & ,A204_hnn_106_btag_nuenue_ww
      real*8 A204_hnn_108_btag_nuenue_bb
     & ,A204_hnn_108_btag_nuenue_cc, A204_hnn_108_btag_nuenue_gg
     & ,A204_hnn_108_btag_nuenue_ww
      real*8 A204_hnn_110_btag_nuenue_bb
     & ,A204_hnn_110_btag_nuenue_cc, A204_hnn_110_btag_nuenue_gg
     & ,A204_hnn_110_btag_nuenue_ww
      real*8 A204_hnn_111_btag_nuenue_bb
     & ,A204_hnn_111_btag_nuenue_cc, A204_hnn_111_btag_nuenue_gg
     & ,A204_hnn_111_btag_nuenue_ww
      real*8 A204_hnn_112_btag_nuenue_bb
     & ,A204_hnn_112_btag_nuenue_cc, A204_hnn_112_btag_nuenue_gg
     & ,A204_hnn_112_btag_nuenue_ww
      real*8 A204_hnn_1128_btag_nuenue_bb
     & ,A204_hnn_1128_btag_nuenue_cc, A204_hnn_1128_btag_nuenue_gg
     & ,A204_hnn_1128_btag_nuenue_ww
      real*8 A204_hnn_114_btag_nuenue_bb
     & ,A204_hnn_114_btag_nuenue_cc, A204_hnn_114_btag_nuenue_gg
     & ,A204_hnn_114_btag_nuenue_ww
      real*8 A204_hnn_115_btag_nuenue_bb
     & ,A204_hnn_115_btag_nuenue_cc, A204_hnn_115_btag_nuenue_gg
     & ,A204_hnn_115_btag_nuenue_ww
      real*8 A204_hnn_116_btag_nuenue_bb
     & ,A204_hnn_116_btag_nuenue_cc, A204_hnn_116_btag_nuenue_gg
     & ,A204_hnn_116_btag_nuenue_ww
      real*8 A204_hnn_118_btag_nuenue_bb
     & ,A204_hnn_118_btag_nuenue_cc, A204_hnn_118_btag_nuenue_gg
     & ,A204_hnn_118_btag_nuenue_ww
      real*8 A204_hnn_120_btag_nuenue_bb
     & ,A204_hnn_120_btag_nuenue_cc, A204_hnn_120_btag_nuenue_gg
     & ,A204_hnn_120_btag_nuenue_ww

      external A2000_hnn_75_btag_nuenue_bb
     & ,A2000_hnn_75_btag_nuenue_cc, A2000_hnn_75_btag_nuenue_gg
      external A2000_hnn_80_btag_nuenue_bb
     & ,A2000_hnn_80_btag_nuenue_cc, A2000_hnn_80_btag_nuenue_gg
      external A2000_hnn_85_btag_nuenue_bb
     & ,A2000_hnn_85_btag_nuenue_cc, A2000_hnn_85_btag_nuenue_gg
      external A2000_hnn_90_btag_nuenue_bb
     & ,A2000_hnn_90_btag_nuenue_cc, A2000_hnn_90_btag_nuenue_gg
      external A2000_hnn_95_btag_nuenue_bb
     & ,A2000_hnn_95_btag_nuenue_cc, A2000_hnn_95_btag_nuenue_gg
      external A204_hnn_100_btag_nuenue_bb
     & ,A204_hnn_100_btag_nuenue_cc, A204_hnn_100_btag_nuenue_gg
     & ,A204_hnn_100_btag_nuenue_ww
      external A204_hnn_102_btag_nuenue_bb
     & ,A204_hnn_102_btag_nuenue_cc, A204_hnn_102_btag_nuenue_gg
     & ,A204_hnn_102_btag_nuenue_ww
      external A204_hnn_104_btag_nuenue_bb
     & ,A204_hnn_104_btag_nuenue_cc, A204_hnn_104_btag_nuenue_gg
     & ,A204_hnn_104_btag_nuenue_ww
      external A204_hnn_106_btag_nuenue_bb
     & ,A204_hnn_106_btag_nuenue_cc, A204_hnn_106_btag_nuenue_gg
     & ,A204_hnn_106_btag_nuenue_ww
      external A204_hnn_108_btag_nuenue_bb
     & ,A204_hnn_108_btag_nuenue_cc, A204_hnn_108_btag_nuenue_gg
     & ,A204_hnn_108_btag_nuenue_ww
      external A204_hnn_110_btag_nuenue_bb
     & ,A204_hnn_110_btag_nuenue_cc, A204_hnn_110_btag_nuenue_gg
     & ,A204_hnn_110_btag_nuenue_ww
      external A204_hnn_111_btag_nuenue_bb
     & ,A204_hnn_111_btag_nuenue_cc, A204_hnn_111_btag_nuenue_gg
     & ,A204_hnn_111_btag_nuenue_ww
      external A204_hnn_112_btag_nuenue_bb
     & ,A204_hnn_112_btag_nuenue_cc, A204_hnn_112_btag_nuenue_gg
     & ,A204_hnn_112_btag_nuenue_ww
      external A204_hnn_1128_btag_nuenue_bb
     & ,A204_hnn_1128_btag_nuenue_cc, A204_hnn_1128_btag_nuenue_gg
     & ,A204_hnn_1128_btag_nuenue_ww
      external A204_hnn_114_btag_nuenue_bb
     & ,A204_hnn_114_btag_nuenue_cc, A204_hnn_114_btag_nuenue_gg
     & ,A204_hnn_114_btag_nuenue_ww
      external A204_hnn_115_btag_nuenue_bb
     & ,A204_hnn_115_btag_nuenue_cc, A204_hnn_115_btag_nuenue_gg
     & ,A204_hnn_115_btag_nuenue_ww
      external A204_hnn_116_btag_nuenue_bb
     & ,A204_hnn_116_btag_nuenue_cc, A204_hnn_116_btag_nuenue_gg
     & ,A204_hnn_116_btag_nuenue_ww
      external A204_hnn_118_btag_nuenue_bb
     & ,A204_hnn_118_btag_nuenue_cc, A204_hnn_118_btag_nuenue_gg
     & ,A204_hnn_118_btag_nuenue_ww
      external A204_hnn_120_btag_nuenue_bb
     & ,A204_hnn_120_btag_nuenue_cc, A204_hnn_120_btag_nuenue_gg
     & ,A204_hnn_120_btag_nuenue_ww


      integer nummass,i,j,mhindx
      parameter (nummass=19) 
      real*8 sigmass(nummass),mhdif,val1,val2,w1,w2
      data sigmass /75.d0,80.d0,85.d0,90.d0,95.d0,100.d0
     &     ,102.d0,104.d0,106.d0,108.d0,110.d0
     &     ,111.d0,112.d0,112.8d0,114.d0,115.d0,116.d0,118.d0,120.d0/
      mhindx=0
      do i= 1,nummass
         if (sigmass(i).lt.hmass) mhindx=i
      enddo
      if (mhindx.gt.0.and.mhindx.lt.nummass) then
         w1=sigmass(mhindx+1)-hmass
         w2=hmass-sigmass(mhindx)
         mhdif=sigmass(mhindx+1)-sigmass(mhindx)
      endif
      if (isig.eq.1) then
         if (mhindx.eq.0) then
            val1=A2000_hnn_75_btag_nulnul_bb(x)
            val2=A2000_hnn_75_btag_nulnul_bb(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         elseif (mhindx.eq.1) then
            val1=A2000_hnn_75_btag_nulnul_bb(x)
            val2=A2000_hnn_80_btag_nulnul_bb(x)
         elseif (mhindx.eq.2) then
            val1=A2000_hnn_80_btag_nulnul_bb(x)
            val2=A2000_hnn_85_btag_nulnul_bb(x)
         elseif (mhindx.eq.3) then
            val1=A2000_hnn_85_btag_nulnul_bb(x)
            val2=A2000_hnn_90_btag_nulnul_bb(x)
         elseif (mhindx.eq.4) then
            val1=A2000_hnn_90_btag_nulnul_bb(x)
            val2=A2000_hnn_95_btag_nulnul_bb(x)
         elseif (mhindx.eq.5) then
            val1=A2000_hnn_95_btag_nulnul_bb(x)
            val2=A204_hnn_100_btag_nulnul_bb(x)
         elseif (mhindx.eq.6) then
            val1=A204_hnn_100_btag_nulnul_bb(x)
            val2=A204_hnn_102_btag_nulnul_bb(x)
         elseif (mhindx.eq.7) then
            val1=A204_hnn_102_btag_nulnul_bb(x)
            val2=A204_hnn_104_btag_nulnul_bb(x)
         elseif (mhindx.eq.8) then
            val1=A204_hnn_104_btag_nulnul_bb(x)
            val2=A204_hnn_106_btag_nulnul_bb(x)
         elseif (mhindx.eq.9) then
            val1=A204_hnn_106_btag_nulnul_bb(x)
            val2=A204_hnn_108_btag_nulnul_bb(x)
         elseif (mhindx.eq.10) then
            val1=A204_hnn_108_btag_nulnul_bb(x)
            val2=A204_hnn_110_btag_nulnul_bb(x)
         elseif (mhindx.eq.11) then
            val1=A204_hnn_110_btag_nulnul_bb(x)
            val2=A204_hnn_111_btag_nulnul_bb(x)
         elseif (mhindx.eq.12) then
            val1=A204_hnn_111_btag_nulnul_bb(x)
            val2=A204_hnn_112_btag_nulnul_bb(x)
         elseif (mhindx.eq.13) then
            val1=A204_hnn_112_btag_nulnul_bb(x)
            val2=A204_hnn_1128_btag_nulnul_bb(x)
         elseif (mhindx.eq.14) then
            val1=A204_hnn_1128_btag_nulnul_bb(x)
            val2=A204_hnn_114_btag_nulnul_bb(x)
         elseif (mhindx.eq.15) then
            val1=A204_hnn_114_btag_nulnul_bb(x)
            val2=A204_hnn_115_btag_nulnul_bb(x)
         elseif (mhindx.eq.16) then
            val1=A204_hnn_115_btag_nulnul_bb(x)
            val2=A204_hnn_116_btag_nulnul_bb(x)
         elseif (mhindx.eq.17) then
            val1=A204_hnn_116_btag_nulnul_bb(x)
            val2=A204_hnn_118_btag_nulnul_bb(x)
         elseif (mhindx.eq.18) then
            val1=A204_hnn_118_btag_nulnul_bb(x)
            val2=A204_hnn_120_btag_nulnul_bb(x)
         elseif (mhindx.eq.nummass) then
            val1=A204_hnn_120_btag_nulnul_bb(x)
            val2=A204_hnn_120_btag_nulnul_bb(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         endif
      elseif (isig.eq.3) then
         if (mhindx.eq.0) then
            val1=A2000_hnn_75_btag_nulnul_cc(x)
            val2=A2000_hnn_75_btag_nulnul_cc(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         elseif (mhindx.eq.1) then
            val1=A2000_hnn_75_btag_nulnul_cc(x)
            val2=A2000_hnn_80_btag_nulnul_cc(x)
         elseif (mhindx.eq.2) then
            val1=A2000_hnn_80_btag_nulnul_cc(x)
            val2=A2000_hnn_85_btag_nulnul_cc(x)
         elseif (mhindx.eq.3) then
            val1=A2000_hnn_85_btag_nulnul_cc(x)
            val2=A2000_hnn_90_btag_nulnul_cc(x)
         elseif (mhindx.eq.4) then
            val1=A2000_hnn_90_btag_nulnul_cc(x)
            val2=A2000_hnn_95_btag_nulnul_cc(x)
         elseif (mhindx.eq.5) then
            val1=A2000_hnn_95_btag_nulnul_cc(x)
            val2=A204_hnn_100_btag_nulnul_cc(x)
         elseif (mhindx.eq.6) then
            val1=A204_hnn_100_btag_nulnul_cc(x)
            val2=A204_hnn_102_btag_nulnul_cc(x)
         elseif (mhindx.eq.7) then
            val1=A204_hnn_102_btag_nulnul_cc(x)
            val2=A204_hnn_104_btag_nulnul_cc(x)
         elseif (mhindx.eq.8) then
            val1=A204_hnn_104_btag_nulnul_cc(x)
            val2=A204_hnn_106_btag_nulnul_cc(x)
         elseif (mhindx.eq.9) then
            val1=A204_hnn_106_btag_nulnul_cc(x)
            val2=A204_hnn_108_btag_nulnul_cc(x)
         elseif (mhindx.eq.10) then
            val1=A204_hnn_108_btag_nulnul_cc(x)
            val2=A204_hnn_110_btag_nulnul_cc(x)
         elseif (mhindx.eq.11) then
            val1=A204_hnn_110_btag_nulnul_cc(x)
            val2=A204_hnn_111_btag_nulnul_cc(x)
         elseif (mhindx.eq.12) then
            val1=A204_hnn_111_btag_nulnul_cc(x)
            val2=A204_hnn_112_btag_nulnul_cc(x)
         elseif (mhindx.eq.13) then
            val1=A204_hnn_112_btag_nulnul_cc(x)
            val2=A204_hnn_1128_btag_nulnul_cc(x)
         elseif (mhindx.eq.14) then
            val1=A204_hnn_1128_btag_nulnul_cc(x)
            val2=A204_hnn_114_btag_nulnul_cc(x)
         elseif (mhindx.eq.15) then
            val1=A204_hnn_114_btag_nulnul_cc(x)
            val2=A204_hnn_115_btag_nulnul_cc(x)
         elseif (mhindx.eq.16) then
            val1=A204_hnn_115_btag_nulnul_cc(x)
            val2=A204_hnn_116_btag_nulnul_cc(x)
         elseif (mhindx.eq.17) then
            val1=A204_hnn_116_btag_nulnul_cc(x)
            val2=A204_hnn_118_btag_nulnul_cc(x)
         elseif (mhindx.eq.18) then
            val1=A204_hnn_118_btag_nulnul_cc(x)
            val2=A204_hnn_120_btag_nulnul_cc(x)
         elseif (mhindx.eq.nummass) then
            val1=A204_hnn_120_btag_nulnul_cc(x)
            val2=A204_hnn_120_btag_nulnul_cc(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         endif
      elseif (isig.eq.4) then
         if (mhindx.eq.0) then
            val1=A2000_hnn_75_btag_nulnul_gg(x)
            val2=A2000_hnn_75_btag_nulnul_gg(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         elseif (mhindx.eq.1) then
            val1=A2000_hnn_75_btag_nulnul_gg(x)
            val2=A2000_hnn_80_btag_nulnul_gg(x)
         elseif (mhindx.eq.2) then
            val1=A2000_hnn_80_btag_nulnul_gg(x)
            val2=A2000_hnn_85_btag_nulnul_gg(x)
         elseif (mhindx.eq.3) then
            val1=A2000_hnn_85_btag_nulnul_gg(x)
            val2=A2000_hnn_90_btag_nulnul_gg(x)
         elseif (mhindx.eq.4) then
            val1=A2000_hnn_90_btag_nulnul_gg(x)
            val2=A2000_hnn_95_btag_nulnul_gg(x)
         elseif (mhindx.eq.5) then
            val1=A2000_hnn_95_btag_nulnul_gg(x)
            val2=A204_hnn_100_btag_nulnul_gg(x)
         elseif (mhindx.eq.6) then
            val1=A204_hnn_100_btag_nulnul_gg(x)
            val2=A204_hnn_102_btag_nulnul_gg(x)
         elseif (mhindx.eq.7) then
            val1=A204_hnn_102_btag_nulnul_gg(x)
            val2=A204_hnn_104_btag_nulnul_gg(x)
         elseif (mhindx.eq.8) then
            val1=A204_hnn_104_btag_nulnul_gg(x)
            val2=A204_hnn_106_btag_nulnul_gg(x)
         elseif (mhindx.eq.9) then
            val1=A204_hnn_106_btag_nulnul_gg(x)
            val2=A204_hnn_108_btag_nulnul_gg(x)
         elseif (mhindx.eq.10) then
            val1=A204_hnn_108_btag_nulnul_gg(x)
            val2=A204_hnn_110_btag_nulnul_gg(x)
         elseif (mhindx.eq.11) then
            val1=A204_hnn_110_btag_nulnul_gg(x)
            val2=A204_hnn_111_btag_nulnul_gg(x)
         elseif (mhindx.eq.12) then
            val1=A204_hnn_111_btag_nulnul_gg(x)
            val2=A204_hnn_112_btag_nulnul_gg(x)
         elseif (mhindx.eq.13) then
            val1=A204_hnn_112_btag_nulnul_gg(x)
            val2=A204_hnn_1128_btag_nulnul_gg(x)
         elseif (mhindx.eq.14) then
            val1=A204_hnn_1128_btag_nulnul_gg(x)
            val2=A204_hnn_114_btag_nulnul_gg(x)
         elseif (mhindx.eq.15) then
            val1=A204_hnn_114_btag_nulnul_gg(x)
            val2=A204_hnn_115_btag_nulnul_gg(x)
         elseif (mhindx.eq.16) then
            val1=A204_hnn_115_btag_nulnul_gg(x)
            val2=A204_hnn_116_btag_nulnul_gg(x)
         elseif (mhindx.eq.17) then
            val1=A204_hnn_116_btag_nulnul_gg(x)
            val2=A204_hnn_118_btag_nulnul_gg(x)
         elseif (mhindx.eq.18) then
            val1=A204_hnn_118_btag_nulnul_gg(x)
            val2=A204_hnn_120_btag_nulnul_gg(x)
         elseif (mhindx.eq.nummass) then
            val1=A204_hnn_120_btag_nulnul_gg(x)
            val2=A204_hnn_120_btag_nulnul_gg(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         endif
      elseif (isig.eq.5.or.isig.eq.2) then
         if (mhindx.eq.0) then
            val1=A2000_hnn_75_btag_nulnul_cc(x)
            val2=A2000_hnn_75_btag_nulnul_cc(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         elseif (mhindx.eq.1) then
            val1=A2000_hnn_75_btag_nulnul_cc(x)
            val2=A2000_hnn_80_btag_nulnul_cc(x)
         elseif (mhindx.eq.2) then
            val1=A2000_hnn_80_btag_nulnul_cc(x)
            val2=A2000_hnn_85_btag_nulnul_cc(x)
         elseif (mhindx.eq.3) then
            val1=A2000_hnn_85_btag_nulnul_cc(x)
            val2=A2000_hnn_90_btag_nulnul_cc(x)
         elseif (mhindx.eq.4) then
            val1=A2000_hnn_90_btag_nulnul_cc(x)
            val2=A2000_hnn_95_btag_nulnul_cc(x)
         elseif (mhindx.eq.5) then
            val1=A2000_hnn_95_btag_nulnul_cc(x)
            val2=A204_hnn_100_btag_nulnul_ww(x)
         elseif (mhindx.eq.6) then
            val1=A204_hnn_100_btag_nulnul_ww(x)
            val2=A204_hnn_102_btag_nulnul_ww(x)
         elseif (mhindx.eq.7) then
            val1=A204_hnn_102_btag_nulnul_ww(x)
            val2=A204_hnn_104_btag_nulnul_ww(x)
         elseif (mhindx.eq.8) then
            val1=A204_hnn_104_btag_nulnul_ww(x)
            val2=A204_hnn_106_btag_nulnul_ww(x)
         elseif (mhindx.eq.9) then
            val1=A204_hnn_106_btag_nulnul_ww(x)
            val2=A204_hnn_108_btag_nulnul_ww(x)
         elseif (mhindx.eq.10) then
            val1=A204_hnn_108_btag_nulnul_ww(x)
            val2=A204_hnn_110_btag_nulnul_ww(x)
         elseif (mhindx.eq.11) then
            val1=A204_hnn_110_btag_nulnul_ww(x)
            val2=A204_hnn_111_btag_nulnul_ww(x)
         elseif (mhindx.eq.12) then
            val1=A204_hnn_111_btag_nulnul_ww(x)
            val2=A204_hnn_112_btag_nulnul_ww(x)
         elseif (mhindx.eq.13) then
            val1=A204_hnn_112_btag_nulnul_ww(x)
            val2=A204_hnn_1128_btag_nulnul_ww(x)
         elseif (mhindx.eq.14) then
            val1=A204_hnn_1128_btag_nulnul_ww(x)
            val2=A204_hnn_114_btag_nulnul_ww(x)
         elseif (mhindx.eq.15) then
            val1=A204_hnn_114_btag_nulnul_ww(x)
            val2=A204_hnn_115_btag_nulnul_ww(x)
         elseif (mhindx.eq.16) then
            val1=A204_hnn_115_btag_nulnul_ww(x)
            val2=A204_hnn_116_btag_nulnul_ww(x)
         elseif (mhindx.eq.17) then
            val1=A204_hnn_116_btag_nulnul_ww(x)
            val2=A204_hnn_118_btag_nulnul_ww(x)
         elseif (mhindx.eq.18) then
            val1=A204_hnn_118_btag_nulnul_ww(x)
            val2=A204_hnn_120_btag_nulnul_ww(x)
         elseif (mhindx.eq.nummass) then
            val1=A204_hnn_120_btag_nulnul_ww(x)
            val2=A204_hnn_120_btag_nulnul_ww(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         endif
      elseif (isig.eq.6) then
         if (mhindx.eq.0) then
            val1=A2000_hnn_75_btag_nuenue_bb(x)
            val2=A2000_hnn_75_btag_nuenue_bb(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         elseif (mhindx.eq.1) then
            val1=A2000_hnn_75_btag_nuenue_bb(x)
            val2=A2000_hnn_80_btag_nuenue_bb(x)
         elseif (mhindx.eq.2) then
            val1=A2000_hnn_80_btag_nuenue_bb(x)
            val2=A2000_hnn_85_btag_nuenue_bb(x)
         elseif (mhindx.eq.3) then
            val1=A2000_hnn_85_btag_nuenue_bb(x)
            val2=A2000_hnn_90_btag_nuenue_bb(x)
         elseif (mhindx.eq.4) then
            val1=A2000_hnn_90_btag_nuenue_bb(x)
            val2=A2000_hnn_95_btag_nuenue_bb(x)
         elseif (mhindx.eq.5) then
            val1=A2000_hnn_95_btag_nuenue_bb(x)
            val2=A204_hnn_100_btag_nuenue_bb(x)
         elseif (mhindx.eq.6) then
            val1=A204_hnn_100_btag_nuenue_bb(x)
            val2=A204_hnn_102_btag_nuenue_bb(x)
         elseif (mhindx.eq.7) then
            val1=A204_hnn_102_btag_nuenue_bb(x)
            val2=A204_hnn_104_btag_nuenue_bb(x)
         elseif (mhindx.eq.8) then
            val1=A204_hnn_104_btag_nuenue_bb(x)
            val2=A204_hnn_106_btag_nuenue_bb(x)
         elseif (mhindx.eq.9) then
            val1=A204_hnn_106_btag_nuenue_bb(x)
            val2=A204_hnn_108_btag_nuenue_bb(x)
         elseif (mhindx.eq.10) then
            val1=A204_hnn_108_btag_nuenue_bb(x)
            val2=A204_hnn_110_btag_nuenue_bb(x)
         elseif (mhindx.eq.11) then
            val1=A204_hnn_110_btag_nuenue_bb(x)
            val2=A204_hnn_111_btag_nuenue_bb(x)
         elseif (mhindx.eq.12) then
            val1=A204_hnn_111_btag_nuenue_bb(x)
            val2=A204_hnn_112_btag_nuenue_bb(x)
         elseif (mhindx.eq.13) then
            val1=A204_hnn_112_btag_nuenue_bb(x)
            val2=A204_hnn_1128_btag_nuenue_bb(x)
         elseif (mhindx.eq.14) then
            val1=A204_hnn_1128_btag_nuenue_bb(x)
            val2=A204_hnn_114_btag_nuenue_bb(x)
         elseif (mhindx.eq.15) then
            val1=A204_hnn_114_btag_nuenue_bb(x)
            val2=A204_hnn_115_btag_nuenue_bb(x)
         elseif (mhindx.eq.16) then
            val1=A204_hnn_115_btag_nuenue_bb(x)
            val2=A204_hnn_116_btag_nuenue_bb(x)
         elseif (mhindx.eq.17) then
            val1=A204_hnn_116_btag_nuenue_bb(x)
            val2=A204_hnn_118_btag_nuenue_bb(x)
         elseif (mhindx.eq.18) then
            val1=A204_hnn_118_btag_nuenue_bb(x)
            val2=A204_hnn_120_btag_nuenue_bb(x)
         elseif (mhindx.eq.nummass) then
            val1=A204_hnn_120_btag_nuenue_bb(x)
            val2=A204_hnn_120_btag_nuenue_bb(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         endif
      elseif (isig.eq.8) then
         if (mhindx.eq.0) then
            val1=A2000_hnn_75_btag_nuenue_cc(x)
            val2=A2000_hnn_75_btag_nuenue_cc(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         elseif (mhindx.eq.1) then
            val1=A2000_hnn_75_btag_nuenue_cc(x)
            val2=A2000_hnn_80_btag_nuenue_cc(x)
         elseif (mhindx.eq.2) then
            val1=A2000_hnn_80_btag_nuenue_cc(x)
            val2=A2000_hnn_85_btag_nuenue_cc(x)
         elseif (mhindx.eq.3) then
            val1=A2000_hnn_85_btag_nuenue_cc(x)
            val2=A2000_hnn_90_btag_nuenue_cc(x)
         elseif (mhindx.eq.4) then
            val1=A2000_hnn_90_btag_nuenue_cc(x)
            val2=A2000_hnn_95_btag_nuenue_cc(x)
         elseif (mhindx.eq.5) then
            val1=A2000_hnn_95_btag_nuenue_cc(x)
            val2=A204_hnn_100_btag_nuenue_cc(x)
         elseif (mhindx.eq.6) then
            val1=A204_hnn_100_btag_nuenue_cc(x)
            val2=A204_hnn_102_btag_nuenue_cc(x)
         elseif (mhindx.eq.7) then
            val1=A204_hnn_102_btag_nuenue_cc(x)
            val2=A204_hnn_104_btag_nuenue_cc(x)
         elseif (mhindx.eq.8) then
            val1=A204_hnn_104_btag_nuenue_cc(x)
            val2=A204_hnn_106_btag_nuenue_cc(x)
         elseif (mhindx.eq.9) then
            val1=A204_hnn_106_btag_nuenue_cc(x)
            val2=A204_hnn_108_btag_nuenue_cc(x)
         elseif (mhindx.eq.10) then
            val1=A204_hnn_108_btag_nuenue_cc(x)
            val2=A204_hnn_110_btag_nuenue_cc(x)
         elseif (mhindx.eq.11) then
            val1=A204_hnn_110_btag_nuenue_cc(x)
            val2=A204_hnn_111_btag_nuenue_cc(x)
         elseif (mhindx.eq.12) then
            val1=A204_hnn_111_btag_nuenue_cc(x)
            val2=A204_hnn_112_btag_nuenue_cc(x)
         elseif (mhindx.eq.13) then
            val1=A204_hnn_112_btag_nuenue_cc(x)
            val2=A204_hnn_1128_btag_nuenue_cc(x)
         elseif (mhindx.eq.14) then
            val1=A204_hnn_1128_btag_nuenue_cc(x)
            val2=A204_hnn_114_btag_nuenue_cc(x)
         elseif (mhindx.eq.15) then
            val1=A204_hnn_114_btag_nuenue_cc(x)
            val2=A204_hnn_115_btag_nuenue_cc(x)
         elseif (mhindx.eq.16) then
            val1=A204_hnn_115_btag_nuenue_cc(x)
            val2=A204_hnn_116_btag_nuenue_cc(x)
         elseif (mhindx.eq.17) then
            val1=A204_hnn_116_btag_nuenue_cc(x)
            val2=A204_hnn_118_btag_nuenue_cc(x)
         elseif (mhindx.eq.18) then
            val1=A204_hnn_118_btag_nuenue_cc(x)
            val2=A204_hnn_120_btag_nuenue_cc(x)
         elseif (mhindx.eq.nummass) then
            val1=A204_hnn_120_btag_nuenue_cc(x)
            val2=A204_hnn_120_btag_nuenue_cc(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         endif
      elseif (isig.eq.9) then
         if (mhindx.eq.0) then
            val1=A2000_hnn_75_btag_nuenue_gg(x)
            val2=A2000_hnn_75_btag_nuenue_gg(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         elseif (mhindx.eq.1) then
            val1=A2000_hnn_75_btag_nuenue_gg(x)
            val2=A2000_hnn_80_btag_nuenue_gg(x)
         elseif (mhindx.eq.2) then
            val1=A2000_hnn_80_btag_nuenue_gg(x)
            val2=A2000_hnn_85_btag_nuenue_gg(x)
         elseif (mhindx.eq.3) then
            val1=A2000_hnn_85_btag_nuenue_gg(x)
            val2=A2000_hnn_90_btag_nuenue_gg(x)
         elseif (mhindx.eq.4) then
            val1=A2000_hnn_90_btag_nuenue_gg(x)
            val2=A2000_hnn_95_btag_nuenue_gg(x)
         elseif (mhindx.eq.5) then
            val1=A2000_hnn_95_btag_nuenue_gg(x)
            val2=A204_hnn_100_btag_nuenue_gg(x)
         elseif (mhindx.eq.6) then
            val1=A204_hnn_100_btag_nuenue_gg(x)
            val2=A204_hnn_102_btag_nuenue_gg(x)
         elseif (mhindx.eq.7) then
            val1=A204_hnn_102_btag_nuenue_gg(x)
            val2=A204_hnn_104_btag_nuenue_gg(x)
         elseif (mhindx.eq.8) then
            val1=A204_hnn_104_btag_nuenue_gg(x)
            val2=A204_hnn_106_btag_nuenue_gg(x)
         elseif (mhindx.eq.9) then
            val1=A204_hnn_106_btag_nuenue_gg(x)
            val2=A204_hnn_108_btag_nuenue_gg(x)
         elseif (mhindx.eq.10) then
            val1=A204_hnn_108_btag_nuenue_gg(x)
            val2=A204_hnn_110_btag_nuenue_gg(x)
         elseif (mhindx.eq.11) then
            val1=A204_hnn_110_btag_nuenue_gg(x)
            val2=A204_hnn_111_btag_nuenue_gg(x)
         elseif (mhindx.eq.12) then
            val1=A204_hnn_111_btag_nuenue_gg(x)
            val2=A204_hnn_112_btag_nuenue_gg(x)
         elseif (mhindx.eq.13) then
            val1=A204_hnn_112_btag_nuenue_gg(x)
            val2=A204_hnn_1128_btag_nuenue_gg(x)
         elseif (mhindx.eq.14) then
            val1=A204_hnn_1128_btag_nuenue_gg(x)
            val2=A204_hnn_114_btag_nuenue_gg(x)
         elseif (mhindx.eq.15) then
            val1=A204_hnn_114_btag_nuenue_gg(x)
            val2=A204_hnn_115_btag_nuenue_gg(x)
         elseif (mhindx.eq.16) then
            val1=A204_hnn_115_btag_nuenue_gg(x)
            val2=A204_hnn_116_btag_nuenue_gg(x)
         elseif (mhindx.eq.17) then
            val1=A204_hnn_116_btag_nuenue_gg(x)
            val2=A204_hnn_118_btag_nuenue_gg(x)
         elseif (mhindx.eq.18) then
            val1=A204_hnn_118_btag_nuenue_gg(x)
            val2=A204_hnn_120_btag_nuenue_gg(x)
         elseif (mhindx.eq.nummass) then
            val1=A204_hnn_120_btag_nuenue_gg(x)
            val2=A204_hnn_120_btag_nuenue_gg(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         endif
      elseif (isig.eq.10.or.isig.eq.7) then
         if (mhindx.eq.0) then
            val1=A2000_hnn_75_btag_nuenue_cc(x)
            val2=A2000_hnn_75_btag_nuenue_cc(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         elseif (mhindx.eq.1) then
            val1=A2000_hnn_75_btag_nuenue_cc(x)
            val2=A2000_hnn_80_btag_nuenue_cc(x)
         elseif (mhindx.eq.2) then
            val1=A2000_hnn_80_btag_nuenue_cc(x)
            val2=A2000_hnn_85_btag_nuenue_cc(x)
         elseif (mhindx.eq.3) then
            val1=A2000_hnn_85_btag_nuenue_cc(x)
            val2=A2000_hnn_90_btag_nuenue_cc(x)
         elseif (mhindx.eq.4) then
            val1=A2000_hnn_90_btag_nuenue_cc(x)
            val2=A2000_hnn_95_btag_nuenue_cc(x)
         elseif (mhindx.eq.5) then
            val1=A2000_hnn_95_btag_nuenue_cc(x)
            val2=A204_hnn_100_btag_nuenue_ww(x)
         elseif (mhindx.eq.6) then
            val1=A204_hnn_100_btag_nuenue_ww(x)
            val2=A204_hnn_102_btag_nuenue_ww(x)
         elseif (mhindx.eq.7) then
            val1=A204_hnn_102_btag_nuenue_ww(x)
            val2=A204_hnn_104_btag_nuenue_ww(x)
         elseif (mhindx.eq.8) then
            val1=A204_hnn_104_btag_nuenue_ww(x)
            val2=A204_hnn_106_btag_nuenue_ww(x)
         elseif (mhindx.eq.9) then
            val1=A204_hnn_106_btag_nuenue_ww(x)
            val2=A204_hnn_108_btag_nuenue_ww(x)
         elseif (mhindx.eq.10) then
            val1=A204_hnn_108_btag_nuenue_ww(x)
            val2=A204_hnn_110_btag_nuenue_ww(x)
         elseif (mhindx.eq.11) then
            val1=A204_hnn_110_btag_nuenue_ww(x)
            val2=A204_hnn_111_btag_nuenue_ww(x)
         elseif (mhindx.eq.12) then
            val1=A204_hnn_111_btag_nuenue_ww(x)
            val2=A204_hnn_112_btag_nuenue_ww(x)
         elseif (mhindx.eq.13) then
            val1=A204_hnn_112_btag_nuenue_ww(x)
            val2=A204_hnn_1128_btag_nuenue_ww(x)
         elseif (mhindx.eq.14) then
            val1=A204_hnn_1128_btag_nuenue_ww(x)
            val2=A204_hnn_114_btag_nuenue_ww(x)
         elseif (mhindx.eq.15) then
            val1=A204_hnn_114_btag_nuenue_ww(x)
            val2=A204_hnn_115_btag_nuenue_ww(x)
         elseif (mhindx.eq.16) then
            val1=A204_hnn_115_btag_nuenue_ww(x)
            val2=A204_hnn_116_btag_nuenue_ww(x)
         elseif (mhindx.eq.17) then
            val1=A204_hnn_116_btag_nuenue_ww(x)
            val2=A204_hnn_118_btag_nuenue_ww(x)
         elseif (mhindx.eq.18) then
            val1=A204_hnn_118_btag_nuenue_ww(x)
            val2=A204_hnn_120_btag_nuenue_ww(x)
         elseif (mhindx.eq.nummass) then
            val1=A204_hnn_120_btag_nuenue_ww(x)
            val2=A204_hnn_120_btag_nuenue_ww(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         endif
         
      else
         val1=0.d0
         val2=0.d0
         w1=1.d0
         w2=1.d0
         mhdif=1.d0
      endif
      A2000_204_nn_btag_sig=(val1*w1+val2*w2)/mhdif
      end

      double precision function a2000_206_nn_btag_sig(x,hmass,isig)
      implicit none
      real*8 x,hmass
      integer isig
      real*8 A2000_hnn_75_btag_nulnul_bb
     & ,A2000_hnn_75_btag_nulnul_cc, A2000_hnn_75_btag_nulnul_gg
      real*8 A2000_hnn_80_btag_nulnul_bb
     & ,A2000_hnn_80_btag_nulnul_cc, A2000_hnn_80_btag_nulnul_gg
      real*8 A2000_hnn_85_btag_nulnul_bb
     & ,A2000_hnn_85_btag_nulnul_cc, A2000_hnn_85_btag_nulnul_gg
      real*8 A2000_hnn_90_btag_nulnul_bb
     & ,A2000_hnn_90_btag_nulnul_cc, A2000_hnn_90_btag_nulnul_gg
      real*8 A2000_hnn_95_btag_nulnul_bb
     & ,A2000_hnn_95_btag_nulnul_cc, A2000_hnn_95_btag_nulnul_gg
      real*8 A206_hnn_100_btag_nulnul_bb
     & ,A206_hnn_100_btag_nulnul_cc, A206_hnn_100_btag_nulnul_gg
     & ,A206_hnn_100_btag_nulnul_ww
      real*8 A206_hnn_104_btag_nulnul_bb
     & ,A206_hnn_104_btag_nulnul_cc, A206_hnn_104_btag_nulnul_gg
     & ,A206_hnn_104_btag_nulnul_ww
      real*8 A206_hnn_106_btag_nulnul_bb
     & ,A206_hnn_106_btag_nulnul_cc, A206_hnn_106_btag_nulnul_gg
     & ,A206_hnn_106_btag_nulnul_ww
      real*8 A206_hnn_108_btag_nulnul_bb
     & ,A206_hnn_108_btag_nulnul_cc, A206_hnn_108_btag_nulnul_gg
     & ,A206_hnn_108_btag_nulnul_ww
      real*8 A206_hnn_110_btag_nulnul_bb
     & ,A206_hnn_110_btag_nulnul_cc, A206_hnn_110_btag_nulnul_gg
     & ,A206_hnn_110_btag_nulnul_ww
      real*8 A206_hnn_112_btag_nulnul_bb
     & ,A206_hnn_112_btag_nulnul_cc, A206_hnn_112_btag_nulnul_gg
     & ,A206_hnn_112_btag_nulnul_ww
      real*8 A206_hnn_113_btag_nulnul_bb
     & ,A206_hnn_113_btag_nulnul_cc, A206_hnn_113_btag_nulnul_gg
     & ,A206_hnn_113_btag_nulnul_ww
      real*8 A206_hnn_114_btag_nulnul_bb
     & ,A206_hnn_114_btag_nulnul_cc, A206_hnn_114_btag_nulnul_gg
     & ,A206_hnn_114_btag_nulnul_ww
      real*8 A206_hnn_1148_btag_nulnul_bb
     & ,A206_hnn_1148_btag_nulnul_cc, A206_hnn_1148_btag_nulnul_gg
     & ,A206_hnn_1148_btag_nulnul_ww
      real*8 A206_hnn_116_btag_nulnul_bb
     & ,A206_hnn_116_btag_nulnul_cc, A206_hnn_116_btag_nulnul_gg
     & ,A206_hnn_116_btag_nulnul_ww
      real*8 A206_hnn_117_btag_nulnul_bb
     & ,A206_hnn_117_btag_nulnul_cc, A206_hnn_117_btag_nulnul_gg
     & ,A206_hnn_117_btag_nulnul_ww
      real*8 A206_hnn_118_btag_nulnul_bb
     & ,A206_hnn_118_btag_nulnul_cc, A206_hnn_118_btag_nulnul_gg
     & ,A206_hnn_118_btag_nulnul_ww
      real*8 A206_hnn_119_btag_nulnul_bb
     & ,A206_hnn_119_btag_nulnul_cc, A206_hnn_119_btag_nulnul_gg
     & ,A206_hnn_119_btag_nulnul_ww
      real*8 A206_hnn_120_btag_nulnul_bb
     & ,A206_hnn_120_btag_nulnul_cc, A206_hnn_120_btag_nulnul_gg
     & ,A206_hnn_120_btag_nulnul_ww

      external A2000_hnn_75_btag_nulnul_bb
     & ,A2000_hnn_75_btag_nulnul_cc, A2000_hnn_75_btag_nulnul_gg
      external A2000_hnn_80_btag_nulnul_bb
     & ,A2000_hnn_80_btag_nulnul_cc, A2000_hnn_80_btag_nulnul_gg
      external A2000_hnn_85_btag_nulnul_bb
     & ,A2000_hnn_85_btag_nulnul_cc, A2000_hnn_85_btag_nulnul_gg
      external A2000_hnn_90_btag_nulnul_bb
     & ,A2000_hnn_90_btag_nulnul_cc, A2000_hnn_90_btag_nulnul_gg
      external A2000_hnn_95_btag_nulnul_bb
     & ,A2000_hnn_95_btag_nulnul_cc, A2000_hnn_95_btag_nulnul_gg
      external A206_hnn_100_btag_nulnul_bb
     & ,A206_hnn_100_btag_nulnul_cc, A206_hnn_100_btag_nulnul_gg
     & ,A206_hnn_100_btag_nulnul_ww
      external A206_hnn_104_btag_nulnul_bb
     & ,A206_hnn_104_btag_nulnul_cc, A206_hnn_104_btag_nulnul_gg
     & ,A206_hnn_104_btag_nulnul_ww
      external A206_hnn_106_btag_nulnul_bb
     & ,A206_hnn_106_btag_nulnul_cc, A206_hnn_106_btag_nulnul_gg
     & ,A206_hnn_106_btag_nulnul_ww
      external A206_hnn_108_btag_nulnul_bb
     & ,A206_hnn_108_btag_nulnul_cc, A206_hnn_108_btag_nulnul_gg
     & ,A206_hnn_108_btag_nulnul_ww
      external A206_hnn_110_btag_nulnul_bb
     & ,A206_hnn_110_btag_nulnul_cc, A206_hnn_110_btag_nulnul_gg
     & ,A206_hnn_110_btag_nulnul_ww
      external A206_hnn_112_btag_nulnul_bb
     & ,A206_hnn_112_btag_nulnul_cc, A206_hnn_112_btag_nulnul_gg
     & ,A206_hnn_112_btag_nulnul_ww
      external A206_hnn_113_btag_nulnul_bb
     & ,A206_hnn_113_btag_nulnul_cc, A206_hnn_113_btag_nulnul_gg
     & ,A206_hnn_113_btag_nulnul_ww
c Fixed 206 114 gg here (PM)
      external A206_hnn_114_btag_nulnul_bb
     & ,A206_hnn_114_btag_nulnul_cc, A206_hnn_114_btag_nulnul_gg
     & ,A206_hnn_114_btag_nulnul_ww
      external A206_hnn_1148_btag_nulnul_bb
     & ,A206_hnn_1148_btag_nulnul_cc, A206_hnn_1148_btag_nulnul_gg
     & ,A206_hnn_1148_btag_nulnul_ww
      external A206_hnn_116_btag_nulnul_bb
     & ,A206_hnn_116_btag_nulnul_cc, A206_hnn_116_btag_nulnul_gg
     & ,A206_hnn_116_btag_nulnul_ww
      external A206_hnn_117_btag_nulnul_bb
     & ,A206_hnn_117_btag_nulnul_cc, A206_hnn_117_btag_nulnul_gg
     & ,A206_hnn_117_btag_nulnul_ww
      external A206_hnn_118_btag_nulnul_bb
     & ,A206_hnn_118_btag_nulnul_cc, A206_hnn_118_btag_nulnul_gg
     & ,A206_hnn_118_btag_nulnul_ww
      external A206_hnn_119_btag_nulnul_bb
     & ,A206_hnn_119_btag_nulnul_cc, A206_hnn_119_btag_nulnul_gg
     & ,A206_hnn_119_btag_nulnul_ww
      external A206_hnn_120_btag_nulnul_bb
     & ,A206_hnn_120_btag_nulnul_cc, A206_hnn_120_btag_nulnul_gg
     & ,A206_hnn_120_btag_nulnul_ww


      real*8 A2000_hnn_75_btag_nuenue_bb
     & ,A2000_hnn_75_btag_nuenue_cc, A2000_hnn_75_btag_nuenue_gg
      real*8 A2000_hnn_80_btag_nuenue_bb
     & ,A2000_hnn_80_btag_nuenue_cc, A2000_hnn_80_btag_nuenue_gg
      real*8 A2000_hnn_85_btag_nuenue_bb
     & ,A2000_hnn_85_btag_nuenue_cc, A2000_hnn_85_btag_nuenue_gg
      real*8 A2000_hnn_90_btag_nuenue_bb
     & ,A2000_hnn_90_btag_nuenue_cc, A2000_hnn_90_btag_nuenue_gg
      real*8 A2000_hnn_95_btag_nuenue_bb
     & ,A2000_hnn_95_btag_nuenue_cc, A2000_hnn_95_btag_nuenue_gg
      real*8 A206_hnn_100_btag_nuenue_bb
     & ,A206_hnn_100_btag_nuenue_cc, A206_hnn_100_btag_nuenue_gg
     & ,A206_hnn_100_btag_nuenue_ww
      real*8 A206_hnn_104_btag_nuenue_bb
     & ,A206_hnn_104_btag_nuenue_cc, A206_hnn_104_btag_nuenue_gg
     & ,A206_hnn_104_btag_nuenue_ww
      real*8 A206_hnn_106_btag_nuenue_bb
     & ,A206_hnn_106_btag_nuenue_cc, A206_hnn_106_btag_nuenue_gg
     & ,A206_hnn_106_btag_nuenue_ww
      real*8 A206_hnn_108_btag_nuenue_bb
     & ,A206_hnn_108_btag_nuenue_cc, A206_hnn_108_btag_nuenue_gg
     & ,A206_hnn_108_btag_nuenue_ww
      real*8 A206_hnn_110_btag_nuenue_bb
     & ,A206_hnn_110_btag_nuenue_cc, A206_hnn_110_btag_nuenue_gg
     & ,A206_hnn_110_btag_nuenue_ww
      real*8 A206_hnn_112_btag_nuenue_bb
     & ,A206_hnn_112_btag_nuenue_cc, A206_hnn_112_btag_nuenue_gg
     & ,A206_hnn_112_btag_nuenue_ww
      real*8 A206_hnn_113_btag_nuenue_bb
     & ,A206_hnn_113_btag_nuenue_cc, A206_hnn_113_btag_nuenue_gg
     & ,A206_hnn_113_btag_nuenue_ww
      real*8 A206_hnn_114_btag_nuenue_bb
     & ,A206_hnn_114_btag_nuenue_cc, A206_hnn_114_btag_nuenue_gg
     & ,A206_hnn_114_btag_nuenue_ww
      real*8 A206_hnn_1148_btag_nuenue_bb
     & ,A206_hnn_1148_btag_nuenue_cc, A206_hnn_1148_btag_nuenue_gg
     & ,A206_hnn_1148_btag_nuenue_ww
      real*8 A206_hnn_116_btag_nuenue_bb
     & ,A206_hnn_116_btag_nuenue_cc, A206_hnn_116_btag_nuenue_gg
     & ,A206_hnn_116_btag_nuenue_ww
      real*8 A206_hnn_117_btag_nuenue_bb
     & ,A206_hnn_117_btag_nuenue_cc, A206_hnn_117_btag_nuenue_gg
     & ,A206_hnn_117_btag_nuenue_ww
      real*8 A206_hnn_118_btag_nuenue_bb
     & ,A206_hnn_118_btag_nuenue_cc, A206_hnn_118_btag_nuenue_gg
     & ,A206_hnn_118_btag_nuenue_ww
      real*8 A206_hnn_119_btag_nuenue_bb
     & ,A206_hnn_119_btag_nuenue_cc, A206_hnn_119_btag_nuenue_gg
     & ,A206_hnn_119_btag_nuenue_ww
      real*8 A206_hnn_120_btag_nuenue_bb
     & ,A206_hnn_120_btag_nuenue_cc, A206_hnn_120_btag_nuenue_gg
     & ,A206_hnn_120_btag_nuenue_ww

      external A2000_hnn_75_btag_nuenue_bb
     & ,A2000_hnn_75_btag_nuenue_cc, A2000_hnn_75_btag_nuenue_gg
      external A2000_hnn_80_btag_nuenue_bb
     & ,A2000_hnn_80_btag_nuenue_cc, A2000_hnn_80_btag_nuenue_gg
      external A2000_hnn_85_btag_nuenue_bb
     & ,A2000_hnn_85_btag_nuenue_cc, A2000_hnn_85_btag_nuenue_gg
      external A2000_hnn_90_btag_nuenue_bb
     & ,A2000_hnn_90_btag_nuenue_cc, A2000_hnn_90_btag_nuenue_gg
      external A2000_hnn_95_btag_nuenue_bb
     & ,A2000_hnn_95_btag_nuenue_cc, A2000_hnn_95_btag_nuenue_gg
      external A206_hnn_100_btag_nuenue_bb
     & ,A206_hnn_100_btag_nuenue_cc, A206_hnn_100_btag_nuenue_gg
     & ,A206_hnn_100_btag_nuenue_ww
      external A206_hnn_104_btag_nuenue_bb
     & ,A206_hnn_104_btag_nuenue_cc, A206_hnn_104_btag_nuenue_gg
     & ,A206_hnn_104_btag_nuenue_ww
      external A206_hnn_106_btag_nuenue_bb
     & ,A206_hnn_106_btag_nuenue_cc, A206_hnn_106_btag_nuenue_gg
     & ,A206_hnn_106_btag_nuenue_ww
      external A206_hnn_108_btag_nuenue_bb
     & ,A206_hnn_108_btag_nuenue_cc, A206_hnn_108_btag_nuenue_gg
     & ,A206_hnn_108_btag_nuenue_ww
      external A206_hnn_110_btag_nuenue_bb
     & ,A206_hnn_110_btag_nuenue_cc, A206_hnn_110_btag_nuenue_gg
     & ,A206_hnn_110_btag_nuenue_ww
      external A206_hnn_112_btag_nuenue_bb
     & ,A206_hnn_112_btag_nuenue_cc, A206_hnn_112_btag_nuenue_gg
     & ,A206_hnn_112_btag_nuenue_ww
      external A206_hnn_113_btag_nuenue_bb
     & ,A206_hnn_113_btag_nuenue_cc, A206_hnn_113_btag_nuenue_gg
     & ,A206_hnn_113_btag_nuenue_ww
C Fixed 206 114 gg here (PM)
      external A206_hnn_114_btag_nuenue_bb
     & ,A206_hnn_114_btag_nuenue_cc, A206_hnn_114_btag_nuenue_gg
     & ,A206_hnn_114_btag_nuenue_ww
      external A206_hnn_1148_btag_nuenue_bb
     & ,A206_hnn_1148_btag_nuenue_cc, A206_hnn_1148_btag_nuenue_gg
     & ,A206_hnn_1148_btag_nuenue_ww
      external A206_hnn_116_btag_nuenue_bb
     & ,A206_hnn_116_btag_nuenue_cc, A206_hnn_116_btag_nuenue_gg
     & ,A206_hnn_116_btag_nuenue_ww
      external A206_hnn_117_btag_nuenue_bb
     & ,A206_hnn_117_btag_nuenue_cc, A206_hnn_117_btag_nuenue_gg
     & ,A206_hnn_117_btag_nuenue_ww
      external A206_hnn_118_btag_nuenue_bb
     & ,A206_hnn_118_btag_nuenue_cc, A206_hnn_118_btag_nuenue_gg
     & ,A206_hnn_118_btag_nuenue_ww
      external A206_hnn_119_btag_nuenue_bb
     & ,A206_hnn_119_btag_nuenue_cc, A206_hnn_119_btag_nuenue_gg
     & ,A206_hnn_119_btag_nuenue_ww
      external A206_hnn_120_btag_nuenue_bb
     & ,A206_hnn_120_btag_nuenue_cc, A206_hnn_120_btag_nuenue_gg
     & ,A206_hnn_120_btag_nuenue_ww




      integer nummass,i,j,mhindx
      parameter (nummass=19) 
      real*8 sigmass(nummass),mhdif,val1,val2,w1,w2
      data sigmass /75.d0,80.d0,85.d0,90.d0,95.d0,100.d0
     &     ,104.d0,106.d0,108.d0,110.d0,112.d0,113.d0,114.d0,1148.d0
     &     ,116.d0,117.d0,118.d0,119.d0,120.d0/
      mhindx=0
      do i= 1,nummass
         if (sigmass(i).lt.hmass) mhindx=i
      enddo
      if (mhindx.gt.0.and.mhindx.lt.nummass) then
         w1=sigmass(mhindx+1)-hmass
         w2=hmass-sigmass(mhindx)
         mhdif=sigmass(mhindx+1)-sigmass(mhindx)
      endif
      if (isig.eq.1) then
         if (mhindx.eq.0) then
            val1=A2000_hnn_75_btag_nulnul_bb(x)
            val2=A2000_hnn_75_btag_nulnul_bb(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         elseif (mhindx.eq.1) then
            val1=A2000_hnn_75_btag_nulnul_bb(x)
            val2=A2000_hnn_80_btag_nulnul_bb(x)
         elseif (mhindx.eq.2) then
            val1=A2000_hnn_80_btag_nulnul_bb(x)
            val2=A2000_hnn_85_btag_nulnul_bb(x)
         elseif (mhindx.eq.3) then
            val1=A2000_hnn_85_btag_nulnul_bb(x)
            val2=A2000_hnn_90_btag_nulnul_bb(x)
         elseif (mhindx.eq.4) then
            val1=A2000_hnn_90_btag_nulnul_bb(x)
            val2=A2000_hnn_95_btag_nulnul_bb(x)
         elseif (mhindx.eq.5) then
            val1=A2000_hnn_95_btag_nulnul_bb(x)
            val2=A206_hnn_100_btag_nulnul_bb(x)
         elseif (mhindx.eq.6) then
            val1=A206_hnn_100_btag_nulnul_bb(x)
            val2=A206_hnn_104_btag_nulnul_bb(x)
         elseif (mhindx.eq.7) then
            val1=A206_hnn_104_btag_nulnul_bb(x)
            val2=A206_hnn_106_btag_nulnul_bb(x)
         elseif (mhindx.eq.8) then
            val1=A206_hnn_106_btag_nulnul_bb(x)
            val2=A206_hnn_108_btag_nulnul_bb(x)
         elseif (mhindx.eq.9) then
            val1=A206_hnn_108_btag_nulnul_bb(x)
            val2=A206_hnn_110_btag_nulnul_bb(x)
         elseif (mhindx.eq.10) then
            val1=A206_hnn_110_btag_nulnul_bb(x)
            val2=A206_hnn_112_btag_nulnul_bb(x)
         elseif (mhindx.eq.11) then
            val1=A206_hnn_112_btag_nulnul_bb(x)
            val2=A206_hnn_113_btag_nulnul_bb(x)
         elseif (mhindx.eq.12) then
            val1=A206_hnn_113_btag_nulnul_bb(x)
            val2=A206_hnn_114_btag_nulnul_bb(x)
         elseif (mhindx.eq.13) then
            val1=A206_hnn_114_btag_nulnul_bb(x)
            val2=A206_hnn_1148_btag_nulnul_bb(x)
         elseif (mhindx.eq.14) then
            val1=A206_hnn_1148_btag_nulnul_bb(x)
            val2=A206_hnn_116_btag_nulnul_bb(x)
         elseif (mhindx.eq.15) then
            val1=A206_hnn_116_btag_nulnul_bb(x)
            val2=A206_hnn_117_btag_nulnul_bb(x)
         elseif (mhindx.eq.16) then
            val1=A206_hnn_117_btag_nulnul_bb(x)
            val2=A206_hnn_118_btag_nulnul_bb(x)
         elseif (mhindx.eq.17) then
            val1=A206_hnn_118_btag_nulnul_bb(x)
            val2=A206_hnn_119_btag_nulnul_bb(x)
         elseif (mhindx.eq.18) then
            val1=A206_hnn_119_btag_nulnul_bb(x)
            val2=A206_hnn_120_btag_nulnul_bb(x)
         elseif (mhindx.eq.nummass) then
            val1=A206_hnn_120_btag_nulnul_bb(x)
            val2=A206_hnn_120_btag_nulnul_bb(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         endif
      elseif (isig.eq.3) then
         if (mhindx.eq.0) then
            val1=A2000_hnn_75_btag_nulnul_cc(x)
            val2=A2000_hnn_75_btag_nulnul_cc(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         elseif (mhindx.eq.1) then
            val1=A2000_hnn_75_btag_nulnul_cc(x)
            val2=A2000_hnn_80_btag_nulnul_cc(x)
         elseif (mhindx.eq.2) then
            val1=A2000_hnn_80_btag_nulnul_cc(x)
            val2=A2000_hnn_85_btag_nulnul_cc(x)
         elseif (mhindx.eq.3) then
            val1=A2000_hnn_85_btag_nulnul_cc(x)
            val2=A2000_hnn_90_btag_nulnul_cc(x)
         elseif (mhindx.eq.4) then
            val1=A2000_hnn_90_btag_nulnul_cc(x)
            val2=A2000_hnn_95_btag_nulnul_cc(x)
         elseif (mhindx.eq.5) then
            val1=A2000_hnn_95_btag_nulnul_cc(x)
            val2=A206_hnn_100_btag_nulnul_cc(x)
         elseif (mhindx.eq.6) then
            val1=A206_hnn_100_btag_nulnul_cc(x)
            val2=A206_hnn_104_btag_nulnul_cc(x)
         elseif (mhindx.eq.7) then
            val1=A206_hnn_104_btag_nulnul_cc(x)
            val2=A206_hnn_106_btag_nulnul_cc(x)
         elseif (mhindx.eq.8) then
            val1=A206_hnn_106_btag_nulnul_cc(x)
            val2=A206_hnn_108_btag_nulnul_cc(x)
         elseif (mhindx.eq.9) then
            val1=A206_hnn_108_btag_nulnul_cc(x)
            val2=A206_hnn_110_btag_nulnul_cc(x)
         elseif (mhindx.eq.10) then
            val1=A206_hnn_110_btag_nulnul_cc(x)
            val2=A206_hnn_112_btag_nulnul_cc(x)
         elseif (mhindx.eq.11) then
            val1=A206_hnn_112_btag_nulnul_cc(x)
            val2=A206_hnn_113_btag_nulnul_cc(x)
         elseif (mhindx.eq.12) then
            val1=A206_hnn_113_btag_nulnul_cc(x)
            val2=A206_hnn_114_btag_nulnul_cc(x)
         elseif (mhindx.eq.13) then
            val1=A206_hnn_114_btag_nulnul_cc(x)
            val2=A206_hnn_1148_btag_nulnul_cc(x)
         elseif (mhindx.eq.14) then
            val1=A206_hnn_1148_btag_nulnul_cc(x)
            val2=A206_hnn_116_btag_nulnul_cc(x)
         elseif (mhindx.eq.15) then
            val1=A206_hnn_116_btag_nulnul_cc(x)
            val2=A206_hnn_117_btag_nulnul_cc(x)
         elseif (mhindx.eq.16) then
            val1=A206_hnn_117_btag_nulnul_cc(x)
            val2=A206_hnn_118_btag_nulnul_cc(x)
         elseif (mhindx.eq.17) then
            val1=A206_hnn_118_btag_nulnul_cc(x)
            val2=A206_hnn_119_btag_nulnul_cc(x)
         elseif (mhindx.eq.18) then
            val1=A206_hnn_119_btag_nulnul_cc(x)
            val2=A206_hnn_120_btag_nulnul_cc(x)
         elseif (mhindx.eq.nummass) then
            val1=A206_hnn_120_btag_nulnul_cc(x)
            val2=A206_hnn_120_btag_nulnul_cc(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         endif
      elseif (isig.eq.4) then
         if (mhindx.eq.0) then
            val1=A2000_hnn_75_btag_nulnul_gg(x)
            val2=A2000_hnn_75_btag_nulnul_gg(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         elseif (mhindx.eq.1) then
            val1=A2000_hnn_75_btag_nulnul_gg(x)
            val2=A2000_hnn_80_btag_nulnul_gg(x)
         elseif (mhindx.eq.2) then
            val1=A2000_hnn_80_btag_nulnul_gg(x)
            val2=A2000_hnn_85_btag_nulnul_gg(x)
         elseif (mhindx.eq.3) then
            val1=A2000_hnn_85_btag_nulnul_gg(x)
            val2=A2000_hnn_90_btag_nulnul_gg(x)
         elseif (mhindx.eq.4) then
            val1=A2000_hnn_90_btag_nulnul_gg(x)
            val2=A2000_hnn_95_btag_nulnul_gg(x)
         elseif (mhindx.eq.5) then
            val1=A2000_hnn_95_btag_nulnul_gg(x)
            val2=A206_hnn_100_btag_nulnul_gg(x)
         elseif (mhindx.eq.6) then
            val1=A206_hnn_100_btag_nulnul_gg(x)
            val2=A206_hnn_104_btag_nulnul_gg(x)
         elseif (mhindx.eq.7) then
            val1=A206_hnn_104_btag_nulnul_gg(x)
            val2=A206_hnn_106_btag_nulnul_gg(x)
         elseif (mhindx.eq.8) then
            val1=A206_hnn_106_btag_nulnul_gg(x)
            val2=A206_hnn_108_btag_nulnul_gg(x)
         elseif (mhindx.eq.9) then
            val1=A206_hnn_108_btag_nulnul_gg(x)
            val2=A206_hnn_110_btag_nulnul_gg(x)
         elseif (mhindx.eq.10) then
            val1=A206_hnn_110_btag_nulnul_gg(x)
            val2=A206_hnn_112_btag_nulnul_gg(x)
         elseif (mhindx.eq.11) then
            val1=A206_hnn_112_btag_nulnul_gg(x)
            val2=A206_hnn_113_btag_nulnul_gg(x)
         elseif (mhindx.eq.12) then
            val1=A206_hnn_113_btag_nulnul_gg(x)
            val2=A206_hnn_114_btag_nulnul_gg(x)
         elseif (mhindx.eq.13) then
            val1=A206_hnn_114_btag_nulnul_gg(x)
            val2=A206_hnn_1148_btag_nulnul_gg(x)
         elseif (mhindx.eq.14) then
            val1=A206_hnn_1148_btag_nulnul_gg(x)
            val2=A206_hnn_116_btag_nulnul_gg(x)
         elseif (mhindx.eq.15) then
            val1=A206_hnn_116_btag_nulnul_gg(x)
            val2=A206_hnn_117_btag_nulnul_gg(x)
         elseif (mhindx.eq.16) then
            val1=A206_hnn_117_btag_nulnul_gg(x)
            val2=A206_hnn_118_btag_nulnul_gg(x)
         elseif (mhindx.eq.17) then
            val1=A206_hnn_118_btag_nulnul_gg(x)
            val2=A206_hnn_119_btag_nulnul_gg(x)
         elseif (mhindx.eq.18) then
            val1=A206_hnn_119_btag_nulnul_gg(x)
            val2=A206_hnn_120_btag_nulnul_gg(x)
         elseif (mhindx.eq.nummass) then
            val1=A206_hnn_120_btag_nulnul_gg(x)
            val2=A206_hnn_120_btag_nulnul_gg(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         endif
      elseif (isig.eq.5.or.isig.eq.2) then
         if (mhindx.eq.0) then
            val1=A2000_hnn_75_btag_nulnul_cc(x)
            val2=A2000_hnn_75_btag_nulnul_cc(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         elseif (mhindx.eq.1) then
            val1=A2000_hnn_75_btag_nulnul_cc(x)
            val2=A2000_hnn_80_btag_nulnul_cc(x)
         elseif (mhindx.eq.2) then
            val1=A2000_hnn_80_btag_nulnul_cc(x)
            val2=A2000_hnn_85_btag_nulnul_cc(x)
         elseif (mhindx.eq.3) then
            val1=A2000_hnn_85_btag_nulnul_cc(x)
            val2=A2000_hnn_90_btag_nulnul_cc(x)
         elseif (mhindx.eq.4) then
            val1=A2000_hnn_90_btag_nulnul_cc(x)
            val2=A2000_hnn_95_btag_nulnul_cc(x)
         elseif (mhindx.eq.5) then
            val1=A2000_hnn_95_btag_nulnul_cc(x)
            val2=A206_hnn_100_btag_nulnul_ww(x)
         elseif (mhindx.eq.6) then
            val1=A206_hnn_100_btag_nulnul_ww(x)
            val2=A206_hnn_104_btag_nulnul_ww(x)
         elseif (mhindx.eq.7) then
            val1=A206_hnn_104_btag_nulnul_ww(x)
            val2=A206_hnn_106_btag_nulnul_ww(x)
         elseif (mhindx.eq.8) then
            val1=A206_hnn_106_btag_nulnul_ww(x)
            val2=A206_hnn_108_btag_nulnul_ww(x)
         elseif (mhindx.eq.9) then
            val1=A206_hnn_108_btag_nulnul_ww(x)
            val2=A206_hnn_110_btag_nulnul_ww(x)
         elseif (mhindx.eq.10) then
            val1=A206_hnn_110_btag_nulnul_ww(x)
            val2=A206_hnn_112_btag_nulnul_ww(x)
         elseif (mhindx.eq.11) then
            val1=A206_hnn_112_btag_nulnul_ww(x)
            val2=A206_hnn_113_btag_nulnul_ww(x)
         elseif (mhindx.eq.12) then
            val1=A206_hnn_113_btag_nulnul_ww(x)
            val2=A206_hnn_114_btag_nulnul_ww(x)
         elseif (mhindx.eq.13) then
            val1=A206_hnn_114_btag_nulnul_ww(x)
            val2=A206_hnn_1148_btag_nulnul_ww(x)
         elseif (mhindx.eq.14) then
            val1=A206_hnn_1148_btag_nulnul_ww(x)
            val2=A206_hnn_116_btag_nulnul_ww(x)
         elseif (mhindx.eq.15) then
            val1=A206_hnn_116_btag_nulnul_ww(x)
            val2=A206_hnn_117_btag_nulnul_ww(x)
         elseif (mhindx.eq.16) then
            val1=A206_hnn_117_btag_nulnul_ww(x)
            val2=A206_hnn_118_btag_nulnul_ww(x)
         elseif (mhindx.eq.17) then
            val1=A206_hnn_118_btag_nulnul_ww(x)
            val2=A206_hnn_119_btag_nulnul_ww(x)
         elseif (mhindx.eq.18) then
            val1=A206_hnn_119_btag_nulnul_ww(x)
            val2=A206_hnn_120_btag_nulnul_ww(x)
         elseif (mhindx.eq.nummass) then
            val1=A206_hnn_120_btag_nulnul_ww(x)
            val2=A206_hnn_120_btag_nulnul_ww(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         endif
      elseif (isig.eq.6) then
         if (mhindx.eq.0) then
            val1=A2000_hnn_75_btag_nuenue_bb(x)
            val2=A2000_hnn_75_btag_nuenue_bb(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         elseif (mhindx.eq.1) then
            val1=A2000_hnn_75_btag_nuenue_bb(x)
            val2=A2000_hnn_80_btag_nuenue_bb(x)
         elseif (mhindx.eq.2) then
            val1=A2000_hnn_80_btag_nuenue_bb(x)
            val2=A2000_hnn_85_btag_nuenue_bb(x)
         elseif (mhindx.eq.3) then
            val1=A2000_hnn_85_btag_nuenue_bb(x)
            val2=A2000_hnn_90_btag_nuenue_bb(x)
         elseif (mhindx.eq.4) then
            val1=A2000_hnn_90_btag_nuenue_bb(x)
            val2=A2000_hnn_95_btag_nuenue_bb(x)
         elseif (mhindx.eq.5) then
            val1=A2000_hnn_95_btag_nuenue_bb(x)
            val2=A206_hnn_100_btag_nuenue_bb(x)
         elseif (mhindx.eq.6) then
            val1=A206_hnn_100_btag_nuenue_bb(x)
            val2=A206_hnn_104_btag_nuenue_bb(x)
         elseif (mhindx.eq.7) then
            val1=A206_hnn_104_btag_nuenue_bb(x)
            val2=A206_hnn_106_btag_nuenue_bb(x)
         elseif (mhindx.eq.8) then
            val1=A206_hnn_106_btag_nuenue_bb(x)
            val2=A206_hnn_108_btag_nuenue_bb(x)
         elseif (mhindx.eq.9) then
            val1=A206_hnn_108_btag_nuenue_bb(x)
            val2=A206_hnn_110_btag_nuenue_bb(x)
         elseif (mhindx.eq.10) then
            val1=A206_hnn_110_btag_nuenue_bb(x)
            val2=A206_hnn_112_btag_nuenue_bb(x)
         elseif (mhindx.eq.11) then
            val1=A206_hnn_112_btag_nuenue_bb(x)
            val2=A206_hnn_113_btag_nuenue_bb(x)
         elseif (mhindx.eq.12) then
            val1=A206_hnn_113_btag_nuenue_bb(x)
            val2=A206_hnn_114_btag_nuenue_bb(x)
         elseif (mhindx.eq.13) then
            val1=A206_hnn_114_btag_nuenue_bb(x)
            val2=A206_hnn_1148_btag_nuenue_bb(x)
         elseif (mhindx.eq.14) then
            val1=A206_hnn_1148_btag_nuenue_bb(x)
            val2=A206_hnn_116_btag_nuenue_bb(x)
         elseif (mhindx.eq.15) then
            val1=A206_hnn_116_btag_nuenue_bb(x)
            val2=A206_hnn_117_btag_nuenue_bb(x)
         elseif (mhindx.eq.16) then
            val1=A206_hnn_117_btag_nuenue_bb(x)
            val2=A206_hnn_118_btag_nuenue_bb(x)
         elseif (mhindx.eq.17) then
            val1=A206_hnn_118_btag_nuenue_bb(x)
            val2=A206_hnn_119_btag_nuenue_bb(x)
         elseif (mhindx.eq.18) then
            val1=A206_hnn_119_btag_nuenue_bb(x)
            val2=A206_hnn_120_btag_nuenue_bb(x)
         elseif (mhindx.eq.nummass) then
            val1=A206_hnn_120_btag_nuenue_bb(x)
            val2=A206_hnn_120_btag_nuenue_bb(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         endif
      elseif (isig.eq.8) then
         if (mhindx.eq.0) then
            val1=A2000_hnn_75_btag_nuenue_cc(x)
            val2=A2000_hnn_75_btag_nuenue_cc(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         elseif (mhindx.eq.1) then
            val1=A2000_hnn_75_btag_nuenue_cc(x)
            val2=A2000_hnn_80_btag_nuenue_cc(x)
         elseif (mhindx.eq.2) then
            val1=A2000_hnn_80_btag_nuenue_cc(x)
            val2=A2000_hnn_85_btag_nuenue_cc(x)
         elseif (mhindx.eq.3) then
            val1=A2000_hnn_85_btag_nuenue_cc(x)
            val2=A2000_hnn_90_btag_nuenue_cc(x)
         elseif (mhindx.eq.4) then
            val1=A2000_hnn_90_btag_nuenue_cc(x)
            val2=A2000_hnn_95_btag_nuenue_cc(x)
         elseif (mhindx.eq.5) then
            val1=A2000_hnn_95_btag_nuenue_cc(x)
            val2=A206_hnn_100_btag_nuenue_cc(x)
         elseif (mhindx.eq.6) then
            val1=A206_hnn_100_btag_nuenue_cc(x)
            val2=A206_hnn_104_btag_nuenue_cc(x)
         elseif (mhindx.eq.7) then
            val1=A206_hnn_104_btag_nuenue_cc(x)
            val2=A206_hnn_106_btag_nuenue_cc(x)
         elseif (mhindx.eq.8) then
            val1=A206_hnn_106_btag_nuenue_cc(x)
            val2=A206_hnn_108_btag_nuenue_cc(x)
         elseif (mhindx.eq.9) then
            val1=A206_hnn_108_btag_nuenue_cc(x)
            val2=A206_hnn_110_btag_nuenue_cc(x)
         elseif (mhindx.eq.10) then
            val1=A206_hnn_110_btag_nuenue_cc(x)
            val2=A206_hnn_112_btag_nuenue_cc(x)
         elseif (mhindx.eq.11) then
            val1=A206_hnn_112_btag_nuenue_cc(x)
            val2=A206_hnn_113_btag_nuenue_cc(x)
         elseif (mhindx.eq.12) then
            val1=A206_hnn_113_btag_nuenue_cc(x)
            val2=A206_hnn_114_btag_nuenue_cc(x)
         elseif (mhindx.eq.13) then
            val1=A206_hnn_114_btag_nuenue_cc(x)
            val2=A206_hnn_1148_btag_nuenue_cc(x)
         elseif (mhindx.eq.14) then
            val1=A206_hnn_1148_btag_nuenue_cc(x)
            val2=A206_hnn_116_btag_nuenue_cc(x)
         elseif (mhindx.eq.15) then
            val1=A206_hnn_116_btag_nuenue_cc(x)
            val2=A206_hnn_117_btag_nuenue_cc(x)
         elseif (mhindx.eq.16) then
            val1=A206_hnn_117_btag_nuenue_cc(x)
            val2=A206_hnn_118_btag_nuenue_cc(x)
         elseif (mhindx.eq.17) then
            val1=A206_hnn_118_btag_nuenue_cc(x)
            val2=A206_hnn_119_btag_nuenue_cc(x)
         elseif (mhindx.eq.18) then
            val1=A206_hnn_119_btag_nuenue_cc(x)
            val2=A206_hnn_120_btag_nuenue_cc(x)
         elseif (mhindx.eq.nummass) then
            val1=A206_hnn_120_btag_nuenue_cc(x)
            val2=A206_hnn_120_btag_nuenue_cc(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         endif
      elseif (isig.eq.9) then
         if (mhindx.eq.0) then
            val1=A2000_hnn_75_btag_nuenue_gg(x)
            val2=A2000_hnn_75_btag_nuenue_gg(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         elseif (mhindx.eq.1) then
            val1=A2000_hnn_75_btag_nuenue_gg(x)
            val2=A2000_hnn_80_btag_nuenue_gg(x)
         elseif (mhindx.eq.2) then
            val1=A2000_hnn_80_btag_nuenue_gg(x)
            val2=A2000_hnn_85_btag_nuenue_gg(x)
         elseif (mhindx.eq.3) then
            val1=A2000_hnn_85_btag_nuenue_gg(x)
            val2=A2000_hnn_90_btag_nuenue_gg(x)
         elseif (mhindx.eq.4) then
            val1=A2000_hnn_90_btag_nuenue_gg(x)
            val2=A2000_hnn_95_btag_nuenue_gg(x)
         elseif (mhindx.eq.5) then
            val1=A2000_hnn_95_btag_nuenue_gg(x)
            val2=A206_hnn_100_btag_nuenue_gg(x)
         elseif (mhindx.eq.6) then
            val1=A206_hnn_100_btag_nuenue_gg(x)
            val2=A206_hnn_104_btag_nuenue_gg(x)
         elseif (mhindx.eq.7) then
            val1=A206_hnn_104_btag_nuenue_gg(x)
            val2=A206_hnn_106_btag_nuenue_gg(x)
         elseif (mhindx.eq.8) then
            val1=A206_hnn_106_btag_nuenue_gg(x)
            val2=A206_hnn_108_btag_nuenue_gg(x)
         elseif (mhindx.eq.9) then
            val1=A206_hnn_108_btag_nuenue_gg(x)
            val2=A206_hnn_110_btag_nuenue_gg(x)
         elseif (mhindx.eq.10) then
            val1=A206_hnn_110_btag_nuenue_gg(x)
            val2=A206_hnn_112_btag_nuenue_gg(x)
         elseif (mhindx.eq.11) then
            val1=A206_hnn_112_btag_nuenue_gg(x)
            val2=A206_hnn_113_btag_nuenue_gg(x)
         elseif (mhindx.eq.12) then
            val1=A206_hnn_113_btag_nuenue_gg(x)
            val2=A206_hnn_114_btag_nuenue_gg(x)
         elseif (mhindx.eq.13) then
            val1=A206_hnn_114_btag_nuenue_gg(x)
            val2=A206_hnn_1148_btag_nuenue_gg(x)
         elseif (mhindx.eq.14) then
            val1=A206_hnn_1148_btag_nuenue_gg(x)
            val2=A206_hnn_116_btag_nuenue_gg(x)
         elseif (mhindx.eq.15) then
            val1=A206_hnn_116_btag_nuenue_gg(x)
            val2=A206_hnn_117_btag_nuenue_gg(x)
         elseif (mhindx.eq.16) then
            val1=A206_hnn_117_btag_nuenue_gg(x)
            val2=A206_hnn_118_btag_nuenue_gg(x)
         elseif (mhindx.eq.17) then
            val1=A206_hnn_118_btag_nuenue_gg(x)
            val2=A206_hnn_119_btag_nuenue_gg(x)
         elseif (mhindx.eq.18) then
            val1=A206_hnn_119_btag_nuenue_gg(x)
            val2=A206_hnn_120_btag_nuenue_gg(x)
         elseif (mhindx.eq.nummass) then
            val1=A206_hnn_120_btag_nuenue_gg(x)
            val2=A206_hnn_120_btag_nuenue_gg(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         endif
      elseif (isig.eq.10.or.isig.eq.7) then
         if (mhindx.eq.0) then
            val1=A2000_hnn_75_btag_nuenue_cc(x)
            val2=A2000_hnn_75_btag_nuenue_cc(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         elseif (mhindx.eq.1) then
            val1=A2000_hnn_75_btag_nuenue_cc(x)
            val2=A2000_hnn_80_btag_nuenue_cc(x)
         elseif (mhindx.eq.2) then
            val1=A2000_hnn_80_btag_nuenue_cc(x)
            val2=A2000_hnn_85_btag_nuenue_cc(x)
         elseif (mhindx.eq.3) then
            val1=A2000_hnn_85_btag_nuenue_cc(x)
            val2=A2000_hnn_90_btag_nuenue_cc(x)
         elseif (mhindx.eq.4) then
            val1=A2000_hnn_90_btag_nuenue_cc(x)
            val2=A2000_hnn_95_btag_nuenue_cc(x)
         elseif (mhindx.eq.5) then
            val1=A2000_hnn_95_btag_nuenue_cc(x)
            val2=A206_hnn_100_btag_nuenue_ww(x)
         elseif (mhindx.eq.6) then
            val1=A206_hnn_100_btag_nuenue_ww(x)
            val2=A206_hnn_104_btag_nuenue_ww(x)
         elseif (mhindx.eq.7) then
            val1=A206_hnn_104_btag_nuenue_ww(x)
            val2=A206_hnn_106_btag_nuenue_ww(x)
         elseif (mhindx.eq.8) then
            val1=A206_hnn_106_btag_nuenue_ww(x)
            val2=A206_hnn_108_btag_nuenue_ww(x)
         elseif (mhindx.eq.9) then
            val1=A206_hnn_108_btag_nuenue_ww(x)
            val2=A206_hnn_110_btag_nuenue_ww(x)
         elseif (mhindx.eq.10) then
            val1=A206_hnn_110_btag_nuenue_ww(x)
            val2=A206_hnn_112_btag_nuenue_ww(x)
         elseif (mhindx.eq.11) then
            val1=A206_hnn_112_btag_nuenue_ww(x)
            val2=A206_hnn_113_btag_nuenue_ww(x)
         elseif (mhindx.eq.12) then
            val1=A206_hnn_113_btag_nuenue_ww(x)
            val2=A206_hnn_114_btag_nuenue_ww(x)
         elseif (mhindx.eq.13) then
            val1=A206_hnn_114_btag_nuenue_ww(x)
            val2=A206_hnn_1148_btag_nuenue_ww(x)
         elseif (mhindx.eq.14) then
            val1=A206_hnn_1148_btag_nuenue_ww(x)
            val2=A206_hnn_116_btag_nuenue_ww(x)
         elseif (mhindx.eq.15) then
            val1=A206_hnn_116_btag_nuenue_ww(x)
            val2=A206_hnn_117_btag_nuenue_ww(x)
         elseif (mhindx.eq.16) then
            val1=A206_hnn_117_btag_nuenue_ww(x)
            val2=A206_hnn_118_btag_nuenue_ww(x)
         elseif (mhindx.eq.17) then
            val1=A206_hnn_118_btag_nuenue_ww(x)
            val2=A206_hnn_119_btag_nuenue_ww(x)
         elseif (mhindx.eq.18) then
            val1=A206_hnn_119_btag_nuenue_ww(x)
            val2=A206_hnn_120_btag_nuenue_ww(x)
         elseif (mhindx.eq.nummass) then
            val1=A206_hnn_120_btag_nuenue_ww(x)
            val2=A206_hnn_120_btag_nuenue_ww(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         endif
      else
         val1=0.d0
         val2=0.d0
         w1=1.d0
         w2=1.d0
         mhdif=1.d0
      endif
      A2000_206_nn_btag_sig=(val1*w1+val2*w2)/mhdif
      end

      double precision function a2000_208_nn_btag_sig(x,hmass,isig)
      implicit none
      real*8 x,hmass
      integer isig
      real*8 A2000_hnn_75_btag_nulnul_bb
     & ,A2000_hnn_75_btag_nulnul_cc, A2000_hnn_75_btag_nulnul_gg
      real*8 A2000_hnn_80_btag_nulnul_bb
     & ,A2000_hnn_80_btag_nulnul_cc, A2000_hnn_80_btag_nulnul_gg
      real*8 A2000_hnn_85_btag_nulnul_bb
     & ,A2000_hnn_85_btag_nulnul_cc, A2000_hnn_85_btag_nulnul_gg
      real*8 A2000_hnn_90_btag_nulnul_bb
     & ,A2000_hnn_90_btag_nulnul_cc, A2000_hnn_90_btag_nulnul_gg
      real*8 A2000_hnn_95_btag_nulnul_bb
     & ,A2000_hnn_95_btag_nulnul_cc, A2000_hnn_95_btag_nulnul_gg
      real*8 A208_hnn_100_btag_nulnul_bb
     & ,A208_hnn_100_btag_nulnul_cc, A208_hnn_100_btag_nulnul_gg
     & ,A208_hnn_100_btag_nulnul_ww
      real*8 A208_hnn_104_btag_nulnul_bb
     & ,A208_hnn_104_btag_nulnul_cc, A208_hnn_104_btag_nulnul_gg
     & ,A208_hnn_104_btag_nulnul_ww
      real*8 A208_hnn_106_btag_nulnul_bb
     & ,A208_hnn_106_btag_nulnul_cc, A208_hnn_106_btag_nulnul_gg
     & ,A208_hnn_106_btag_nulnul_ww
      real*8 A208_hnn_108_btag_nulnul_bb
     & ,A208_hnn_108_btag_nulnul_cc, A208_hnn_108_btag_nulnul_gg
     & ,A208_hnn_108_btag_nulnul_ww
      real*8 A208_hnn_110_btag_nulnul_bb
     & ,A208_hnn_110_btag_nulnul_cc, A208_hnn_110_btag_nulnul_gg
     & ,A208_hnn_110_btag_nulnul_ww
      real*8 A208_hnn_112_btag_nulnul_bb
     & ,A208_hnn_112_btag_nulnul_cc, A208_hnn_112_btag_nulnul_gg
     & ,A208_hnn_112_btag_nulnul_ww
      real*8 A208_hnn_113_btag_nulnul_bb
     & ,A208_hnn_113_btag_nulnul_cc, A208_hnn_113_btag_nulnul_gg
     & ,A208_hnn_113_btag_nulnul_ww
      real*8 A208_hnn_114_btag_nulnul_bb
     & ,A208_hnn_114_btag_nulnul_cc, A208_hnn_114_btag_nulnul_gg
     & ,A208_hnn_114_btag_nulnul_ww
      real*8 A208_hnn_115_btag_nulnul_bb
     & ,A208_hnn_115_btag_nulnul_cc, A208_hnn_115_btag_nulnul_gg
     & ,A208_hnn_115_btag_nulnul_ww
      real*8 A208_hnn_116_btag_nulnul_bb
     & ,A208_hnn_116_btag_nulnul_cc, A208_hnn_116_btag_nulnul_gg
     & ,A208_hnn_116_btag_nulnul_ww
      real*8 A208_hnn_1168_btag_nulnul_bb
     & ,A208_hnn_1168_btag_nulnul_cc, A208_hnn_1168_btag_nulnul_gg
     & ,A208_hnn_1168_btag_nulnul_ww
      real*8 A208_hnn_118_btag_nulnul_bb
     & ,A208_hnn_118_btag_nulnul_cc, A208_hnn_118_btag_nulnul_gg
     & ,A208_hnn_118_btag_nulnul_ww
      real*8 A208_hnn_119_btag_nulnul_bb
     & ,A208_hnn_119_btag_nulnul_cc, A208_hnn_119_btag_nulnul_gg
     & ,A208_hnn_119_btag_nulnul_ww
      real*8 A208_hnn_120_btag_nulnul_bb
     & ,A208_hnn_120_btag_nulnul_cc, A208_hnn_120_btag_nulnul_gg
     & ,A208_hnn_120_btag_nulnul_ww

      external A2000_hnn_75_btag_nulnul_bb
     & ,A2000_hnn_75_btag_nulnul_cc, A2000_hnn_75_btag_nulnul_gg
      external A2000_hnn_80_btag_nulnul_bb
     & ,A2000_hnn_80_btag_nulnul_cc, A2000_hnn_80_btag_nulnul_gg
      external A2000_hnn_85_btag_nulnul_bb
     & ,A2000_hnn_85_btag_nulnul_cc, A2000_hnn_85_btag_nulnul_gg
      external A2000_hnn_90_btag_nulnul_bb
     & ,A2000_hnn_90_btag_nulnul_cc, A2000_hnn_90_btag_nulnul_gg
      external A2000_hnn_95_btag_nulnul_bb
     & ,A2000_hnn_95_btag_nulnul_cc, A2000_hnn_95_btag_nulnul_gg
      external A208_hnn_100_btag_nulnul_bb
     & ,A208_hnn_100_btag_nulnul_cc, A208_hnn_100_btag_nulnul_gg
     & ,A208_hnn_100_btag_nulnul_ww
      external A208_hnn_104_btag_nulnul_bb
     & ,A208_hnn_104_btag_nulnul_cc, A208_hnn_104_btag_nulnul_gg
     & ,A208_hnn_104_btag_nulnul_ww
      external A208_hnn_106_btag_nulnul_bb
     & ,A208_hnn_106_btag_nulnul_cc, A208_hnn_106_btag_nulnul_gg
     & ,A208_hnn_106_btag_nulnul_ww
      external A208_hnn_108_btag_nulnul_bb
     & ,A208_hnn_108_btag_nulnul_cc, A208_hnn_108_btag_nulnul_gg
     & ,A208_hnn_108_btag_nulnul_ww
      external A208_hnn_110_btag_nulnul_bb
     & ,A208_hnn_110_btag_nulnul_cc, A208_hnn_110_btag_nulnul_gg
     & ,A208_hnn_110_btag_nulnul_ww
      external A208_hnn_112_btag_nulnul_bb
     & ,A208_hnn_112_btag_nulnul_cc, A208_hnn_112_btag_nulnul_gg
     & ,A208_hnn_112_btag_nulnul_ww
      external A208_hnn_113_btag_nulnul_bb
     & ,A208_hnn_113_btag_nulnul_cc, A208_hnn_113_btag_nulnul_gg
     & ,A208_hnn_113_btag_nulnul_ww
      external A208_hnn_114_btag_nulnul_bb
     & ,A208_hnn_114_btag_nulnul_cc, A208_hnn_114_btag_nulnul_gg
     & ,A208_hnn_114_btag_nulnul_ww
      external A208_hnn_115_btag_nulnul_bb
     & ,A208_hnn_115_btag_nulnul_cc, A208_hnn_115_btag_nulnul_gg
     & ,A208_hnn_115_btag_nulnul_ww
      external A208_hnn_116_btag_nulnul_bb
     & ,A208_hnn_116_btag_nulnul_cc, A208_hnn_116_btag_nulnul_gg
     & ,A208_hnn_116_btag_nulnul_ww
      external A208_hnn_1168_btag_nulnul_bb
     & ,A208_hnn_1168_btag_nulnul_cc, A208_hnn_1168_btag_nulnul_gg
     & ,A208_hnn_1168_btag_nulnul_ww
      external A208_hnn_118_btag_nulnul_bb
     & ,A208_hnn_118_btag_nulnul_cc, A208_hnn_118_btag_nulnul_gg
     & ,A208_hnn_118_btag_nulnul_ww
      external A208_hnn_119_btag_nulnul_bb
     & ,A208_hnn_119_btag_nulnul_cc, A208_hnn_119_btag_nulnul_gg
     & ,A208_hnn_119_btag_nulnul_ww
      external A208_hnn_120_btag_nulnul_bb
     & ,A208_hnn_120_btag_nulnul_cc, A208_hnn_120_btag_nulnul_gg
     & ,A208_hnn_120_btag_nulnul_ww



      real*8 A2000_hnn_75_btag_nuenue_bb
     & ,A2000_hnn_75_btag_nuenue_cc, A2000_hnn_75_btag_nuenue_gg
      real*8 A2000_hnn_80_btag_nuenue_bb
     & ,A2000_hnn_80_btag_nuenue_cc, A2000_hnn_80_btag_nuenue_gg
      real*8 A2000_hnn_85_btag_nuenue_bb
     & ,A2000_hnn_85_btag_nuenue_cc, A2000_hnn_85_btag_nuenue_gg
      real*8 A2000_hnn_90_btag_nuenue_bb
     & ,A2000_hnn_90_btag_nuenue_cc, A2000_hnn_90_btag_nuenue_gg
      real*8 A2000_hnn_95_btag_nuenue_bb
     & ,A2000_hnn_95_btag_nuenue_cc, A2000_hnn_95_btag_nuenue_gg
      real*8 A208_hnn_100_btag_nuenue_bb
     & ,A208_hnn_100_btag_nuenue_cc, A208_hnn_100_btag_nuenue_gg
     & ,A208_hnn_100_btag_nuenue_ww
      real*8 A208_hnn_104_btag_nuenue_bb
     & ,A208_hnn_104_btag_nuenue_cc, A208_hnn_104_btag_nuenue_gg
     & ,A208_hnn_104_btag_nuenue_ww
      real*8 A208_hnn_106_btag_nuenue_bb
     & ,A208_hnn_106_btag_nuenue_cc, A208_hnn_106_btag_nuenue_gg
     & ,A208_hnn_106_btag_nuenue_ww
      real*8 A208_hnn_108_btag_nuenue_bb
     & ,A208_hnn_108_btag_nuenue_cc, A208_hnn_108_btag_nuenue_gg
     & ,A208_hnn_108_btag_nuenue_ww
      real*8 A208_hnn_110_btag_nuenue_bb
     & ,A208_hnn_110_btag_nuenue_cc, A208_hnn_110_btag_nuenue_gg
     & ,A208_hnn_110_btag_nuenue_ww
      real*8 A208_hnn_112_btag_nuenue_bb
     & ,A208_hnn_112_btag_nuenue_cc, A208_hnn_112_btag_nuenue_gg
     & ,A208_hnn_112_btag_nuenue_ww
      real*8 A208_hnn_113_btag_nuenue_bb
     & ,A208_hnn_113_btag_nuenue_cc, A208_hnn_113_btag_nuenue_gg
     & ,A208_hnn_113_btag_nuenue_ww
      real*8 A208_hnn_114_btag_nuenue_bb
     & ,A208_hnn_114_btag_nuenue_cc, A208_hnn_114_btag_nuenue_gg
     & ,A208_hnn_114_btag_nuenue_ww
      real*8 A208_hnn_115_btag_nuenue_bb
     & ,A208_hnn_115_btag_nuenue_cc, A208_hnn_115_btag_nuenue_gg
     & ,A208_hnn_115_btag_nuenue_ww
      real*8 A208_hnn_116_btag_nuenue_bb
     & ,A208_hnn_116_btag_nuenue_cc, A208_hnn_116_btag_nuenue_gg
     & ,A208_hnn_116_btag_nuenue_ww
      real*8 A208_hnn_1168_btag_nuenue_bb
     & ,A208_hnn_1168_btag_nuenue_cc, A208_hnn_1168_btag_nuenue_gg
     & ,A208_hnn_1168_btag_nuenue_ww
      real*8 A208_hnn_118_btag_nuenue_bb
     & ,A208_hnn_118_btag_nuenue_cc, A208_hnn_118_btag_nuenue_gg
     & ,A208_hnn_118_btag_nuenue_ww
      real*8 A208_hnn_119_btag_nuenue_bb
     & ,A208_hnn_119_btag_nuenue_cc, A208_hnn_119_btag_nuenue_gg
     & ,A208_hnn_119_btag_nuenue_ww
      real*8 A208_hnn_120_btag_nuenue_bb
     & ,A208_hnn_120_btag_nuenue_cc, A208_hnn_120_btag_nuenue_gg
     & ,A208_hnn_120_btag_nuenue_ww

      external A2000_hnn_75_btag_nuenue_bb
     & ,A2000_hnn_75_btag_nuenue_cc, A2000_hnn_75_btag_nuenue_gg
      external A2000_hnn_80_btag_nuenue_bb
     & ,A2000_hnn_80_btag_nuenue_cc, A2000_hnn_80_btag_nuenue_gg
      external A2000_hnn_85_btag_nuenue_bb
     & ,A2000_hnn_85_btag_nuenue_cc, A2000_hnn_85_btag_nuenue_gg
      external A2000_hnn_90_btag_nuenue_bb
     & ,A2000_hnn_90_btag_nuenue_cc, A2000_hnn_90_btag_nuenue_gg
      external A2000_hnn_95_btag_nuenue_bb
     & ,A2000_hnn_95_btag_nuenue_cc, A2000_hnn_95_btag_nuenue_gg
      external A208_hnn_100_btag_nuenue_bb
     & ,A208_hnn_100_btag_nuenue_cc, A208_hnn_100_btag_nuenue_gg
     & ,A208_hnn_100_btag_nuenue_ww
      external A208_hnn_104_btag_nuenue_bb
     & ,A208_hnn_104_btag_nuenue_cc, A208_hnn_104_btag_nuenue_gg
     & ,A208_hnn_104_btag_nuenue_ww
      external A208_hnn_106_btag_nuenue_bb
     & ,A208_hnn_106_btag_nuenue_cc, A208_hnn_106_btag_nuenue_gg
     & ,A208_hnn_106_btag_nuenue_ww
      external A208_hnn_108_btag_nuenue_bb
     & ,A208_hnn_108_btag_nuenue_cc, A208_hnn_108_btag_nuenue_gg
     & ,A208_hnn_108_btag_nuenue_ww
      external A208_hnn_110_btag_nuenue_bb
     & ,A208_hnn_110_btag_nuenue_cc, A208_hnn_110_btag_nuenue_gg
     & ,A208_hnn_110_btag_nuenue_ww
      external A208_hnn_112_btag_nuenue_bb
     & ,A208_hnn_112_btag_nuenue_cc, A208_hnn_112_btag_nuenue_gg
     & ,A208_hnn_112_btag_nuenue_ww
      external A208_hnn_113_btag_nuenue_bb
     & ,A208_hnn_113_btag_nuenue_cc, A208_hnn_113_btag_nuenue_gg
     & ,A208_hnn_113_btag_nuenue_ww
      external A208_hnn_114_btag_nuenue_bb
     & ,A208_hnn_114_btag_nuenue_cc, A208_hnn_114_btag_nuenue_gg
     & ,A208_hnn_114_btag_nuenue_ww
      external A208_hnn_115_btag_nuenue_bb
     & ,A208_hnn_115_btag_nuenue_cc, A208_hnn_115_btag_nuenue_gg
     & ,A208_hnn_115_btag_nuenue_ww
      external A208_hnn_116_btag_nuenue_bb
     & ,A208_hnn_116_btag_nuenue_cc, A208_hnn_116_btag_nuenue_gg
     & ,A208_hnn_116_btag_nuenue_ww
      external A208_hnn_1168_btag_nuenue_bb
     & ,A208_hnn_1168_btag_nuenue_cc, A208_hnn_1168_btag_nuenue_gg
     & ,A208_hnn_1168_btag_nuenue_ww
      external A208_hnn_118_btag_nuenue_bb
     & ,A208_hnn_118_btag_nuenue_cc, A208_hnn_118_btag_nuenue_gg
     & ,A208_hnn_118_btag_nuenue_ww
      external A208_hnn_119_btag_nuenue_bb
     & ,A208_hnn_119_btag_nuenue_cc, A208_hnn_119_btag_nuenue_gg
     & ,A208_hnn_119_btag_nuenue_ww
      external A208_hnn_120_btag_nuenue_bb
     & ,A208_hnn_120_btag_nuenue_cc, A208_hnn_120_btag_nuenue_gg
     & ,A208_hnn_120_btag_nuenue_ww




      integer nummass,i,j,mhindx
      parameter (nummass=19) 
      real*8 sigmass(nummass),mhdif,val1,val2,w1,w2
      data sigmass /75.d0,80.d0,85.d0,90.d0,95.d0,100.d0
     &     ,104.d0,106.d0,108.d0,110.d0,112.d0,113.d0,114.d0,115.d0
     &     ,116.d0,116.8d0,118.d0,119.d0,120.d0/
      mhindx=0
      do i= 1,nummass
         if (sigmass(i).lt.hmass) mhindx=i
      enddo
      if (mhindx.gt.0.and.mhindx.lt.nummass) then
         w1=sigmass(mhindx+1)-hmass
         w2=hmass-sigmass(mhindx)
         mhdif=sigmass(mhindx+1)-sigmass(mhindx)
      endif
      if (isig.eq.1) then
         if (mhindx.eq.0) then
            val1=A2000_hnn_75_btag_nulnul_bb(x)
            val2=A2000_hnn_75_btag_nulnul_bb(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         elseif (mhindx.eq.1) then
            val1=A2000_hnn_75_btag_nulnul_bb(x)
            val2=A2000_hnn_80_btag_nulnul_bb(x)
         elseif (mhindx.eq.2) then
            val1=A2000_hnn_80_btag_nulnul_bb(x)
            val2=A2000_hnn_85_btag_nulnul_bb(x)
         elseif (mhindx.eq.3) then
            val1=A2000_hnn_85_btag_nulnul_bb(x)
            val2=A2000_hnn_90_btag_nulnul_bb(x)
         elseif (mhindx.eq.4) then
            val1=A2000_hnn_90_btag_nulnul_bb(x)
            val2=A2000_hnn_95_btag_nulnul_bb(x)
         elseif (mhindx.eq.5) then
            val1=A2000_hnn_95_btag_nulnul_bb(x)
            val2=A208_hnn_100_btag_nulnul_bb(x)
         elseif (mhindx.eq.6) then
            val1=A208_hnn_100_btag_nulnul_bb(x)
            val2=A208_hnn_104_btag_nulnul_bb(x)
         elseif (mhindx.eq.7) then
            val1=A208_hnn_104_btag_nulnul_bb(x)
            val2=A208_hnn_106_btag_nulnul_bb(x)
         elseif (mhindx.eq.8) then
            val1=A208_hnn_106_btag_nulnul_bb(x)
            val2=A208_hnn_108_btag_nulnul_bb(x)
         elseif (mhindx.eq.9) then
            val1=A208_hnn_108_btag_nulnul_bb(x)
            val2=A208_hnn_110_btag_nulnul_bb(x)
         elseif (mhindx.eq.10) then
            val1=A208_hnn_110_btag_nulnul_bb(x)
            val2=A208_hnn_112_btag_nulnul_bb(x)
         elseif (mhindx.eq.11) then
            val1=A208_hnn_112_btag_nulnul_bb(x)
            val2=A208_hnn_113_btag_nulnul_bb(x)
         elseif (mhindx.eq.12) then
            val1=A208_hnn_113_btag_nulnul_bb(x)
            val2=A208_hnn_114_btag_nulnul_bb(x)
         elseif (mhindx.eq.13) then
            val1=A208_hnn_114_btag_nulnul_bb(x)
            val2=A208_hnn_115_btag_nulnul_bb(x)
         elseif (mhindx.eq.14) then
            val1=A208_hnn_115_btag_nulnul_bb(x)
            val2=A208_hnn_116_btag_nulnul_bb(x)
         elseif (mhindx.eq.15) then
            val1=A208_hnn_116_btag_nulnul_bb(x)
            val2=A208_hnn_1168_btag_nulnul_bb(x)
         elseif (mhindx.eq.16) then
            val1=A208_hnn_1168_btag_nulnul_bb(x)
            val2=A208_hnn_118_btag_nulnul_bb(x)
         elseif (mhindx.eq.17) then
            val1=A208_hnn_118_btag_nulnul_bb(x)
            val2=A208_hnn_119_btag_nulnul_bb(x)
         elseif (mhindx.eq.18) then
            val1=A208_hnn_119_btag_nulnul_bb(x)
            val2=A208_hnn_120_btag_nulnul_bb(x)
         elseif (mhindx.eq.nummass) then
            val1=A208_hnn_120_btag_nulnul_bb(x)
            val2=A208_hnn_120_btag_nulnul_bb(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         endif
      elseif (isig.eq.3) then
         if (mhindx.eq.0) then
            val1=A2000_hnn_75_btag_nulnul_cc(x)
            val2=A2000_hnn_75_btag_nulnul_cc(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         elseif (mhindx.eq.1) then
            val1=A2000_hnn_75_btag_nulnul_cc(x)
            val2=A2000_hnn_80_btag_nulnul_cc(x)
         elseif (mhindx.eq.2) then
            val1=A2000_hnn_80_btag_nulnul_cc(x)
            val2=A2000_hnn_85_btag_nulnul_cc(x)
         elseif (mhindx.eq.3) then
            val1=A2000_hnn_85_btag_nulnul_cc(x)
            val2=A2000_hnn_90_btag_nulnul_cc(x)
         elseif (mhindx.eq.4) then
            val1=A2000_hnn_90_btag_nulnul_cc(x)
            val2=A2000_hnn_95_btag_nulnul_cc(x)
         elseif (mhindx.eq.5) then
            val1=A2000_hnn_95_btag_nulnul_cc(x)
            val2=A208_hnn_100_btag_nulnul_cc(x)
         elseif (mhindx.eq.6) then
            val1=A208_hnn_100_btag_nulnul_cc(x)
            val2=A208_hnn_104_btag_nulnul_cc(x)
         elseif (mhindx.eq.7) then
            val1=A208_hnn_104_btag_nulnul_cc(x)
            val2=A208_hnn_106_btag_nulnul_cc(x)
         elseif (mhindx.eq.8) then
            val1=A208_hnn_106_btag_nulnul_cc(x)
            val2=A208_hnn_108_btag_nulnul_cc(x)
         elseif (mhindx.eq.9) then
            val1=A208_hnn_108_btag_nulnul_cc(x)
            val2=A208_hnn_110_btag_nulnul_cc(x)
         elseif (mhindx.eq.10) then
            val1=A208_hnn_110_btag_nulnul_cc(x)
            val2=A208_hnn_112_btag_nulnul_cc(x)
         elseif (mhindx.eq.11) then
            val1=A208_hnn_112_btag_nulnul_cc(x)
            val2=A208_hnn_113_btag_nulnul_cc(x)
         elseif (mhindx.eq.12) then
            val1=A208_hnn_113_btag_nulnul_cc(x)
            val2=A208_hnn_114_btag_nulnul_cc(x)
         elseif (mhindx.eq.13) then
            val1=A208_hnn_114_btag_nulnul_cc(x)
            val2=A208_hnn_115_btag_nulnul_cc(x)
         elseif (mhindx.eq.14) then
            val1=A208_hnn_115_btag_nulnul_cc(x)
            val2=A208_hnn_116_btag_nulnul_cc(x)
         elseif (mhindx.eq.15) then
            val1=A208_hnn_116_btag_nulnul_cc(x)
            val2=A208_hnn_1168_btag_nulnul_cc(x)
         elseif (mhindx.eq.16) then
            val1=A208_hnn_1168_btag_nulnul_cc(x)
            val2=A208_hnn_118_btag_nulnul_cc(x)
         elseif (mhindx.eq.17) then
            val1=A208_hnn_118_btag_nulnul_cc(x)
            val2=A208_hnn_119_btag_nulnul_cc(x)
         elseif (mhindx.eq.18) then
            val1=A208_hnn_119_btag_nulnul_cc(x)
            val2=A208_hnn_120_btag_nulnul_cc(x)
         elseif (mhindx.eq.nummass) then
            val1=A208_hnn_120_btag_nulnul_cc(x)
            val2=A208_hnn_120_btag_nulnul_cc(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         endif
      elseif (isig.eq.4) then
         if (mhindx.eq.0) then
            val1=A2000_hnn_75_btag_nulnul_gg(x)
            val2=A2000_hnn_75_btag_nulnul_gg(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         elseif (mhindx.eq.1) then
            val1=A2000_hnn_75_btag_nulnul_gg(x)
            val2=A2000_hnn_80_btag_nulnul_gg(x)
         elseif (mhindx.eq.2) then
            val1=A2000_hnn_80_btag_nulnul_gg(x)
            val2=A2000_hnn_85_btag_nulnul_gg(x)
         elseif (mhindx.eq.3) then
            val1=A2000_hnn_85_btag_nulnul_gg(x)
            val2=A2000_hnn_90_btag_nulnul_gg(x)
         elseif (mhindx.eq.4) then
            val1=A2000_hnn_90_btag_nulnul_gg(x)
            val2=A2000_hnn_95_btag_nulnul_gg(x)
         elseif (mhindx.eq.5) then
            val1=A2000_hnn_95_btag_nulnul_gg(x)
            val2=A208_hnn_100_btag_nulnul_gg(x)
         elseif (mhindx.eq.6) then
            val1=A208_hnn_100_btag_nulnul_gg(x)
            val2=A208_hnn_104_btag_nulnul_gg(x)
         elseif (mhindx.eq.7) then
            val1=A208_hnn_104_btag_nulnul_gg(x)
            val2=A208_hnn_106_btag_nulnul_gg(x)
         elseif (mhindx.eq.8) then
            val1=A208_hnn_106_btag_nulnul_gg(x)
            val2=A208_hnn_108_btag_nulnul_gg(x)
         elseif (mhindx.eq.9) then
            val1=A208_hnn_108_btag_nulnul_gg(x)
            val2=A208_hnn_110_btag_nulnul_gg(x)
         elseif (mhindx.eq.10) then
            val1=A208_hnn_110_btag_nulnul_gg(x)
            val2=A208_hnn_112_btag_nulnul_gg(x)
         elseif (mhindx.eq.11) then
            val1=A208_hnn_112_btag_nulnul_gg(x)
            val2=A208_hnn_113_btag_nulnul_gg(x)
         elseif (mhindx.eq.12) then
            val1=A208_hnn_113_btag_nulnul_gg(x)
            val2=A208_hnn_114_btag_nulnul_gg(x)
         elseif (mhindx.eq.13) then
            val1=A208_hnn_114_btag_nulnul_gg(x)
            val2=A208_hnn_115_btag_nulnul_gg(x)
         elseif (mhindx.eq.14) then
            val1=A208_hnn_115_btag_nulnul_gg(x)
            val2=A208_hnn_116_btag_nulnul_gg(x)
         elseif (mhindx.eq.15) then
            val1=A208_hnn_116_btag_nulnul_gg(x)
            val2=A208_hnn_1168_btag_nulnul_gg(x)
         elseif (mhindx.eq.16) then
            val1=A208_hnn_1168_btag_nulnul_gg(x)
            val2=A208_hnn_118_btag_nulnul_gg(x)
         elseif (mhindx.eq.17) then
            val1=A208_hnn_118_btag_nulnul_gg(x)
            val2=A208_hnn_119_btag_nulnul_gg(x)
         elseif (mhindx.eq.18) then
            val1=A208_hnn_119_btag_nulnul_gg(x)
            val2=A208_hnn_120_btag_nulnul_gg(x)
         elseif (mhindx.eq.nummass) then
            val1=A208_hnn_120_btag_nulnul_gg(x)
            val2=A208_hnn_120_btag_nulnul_gg(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         endif
      elseif (isig.eq.5.or.isig.eq.2) then
         if (mhindx.eq.0) then
            val1=A2000_hnn_75_btag_nulnul_cc(x)
            val2=A2000_hnn_75_btag_nulnul_cc(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         elseif (mhindx.eq.1) then
            val1=A2000_hnn_75_btag_nulnul_cc(x)
            val2=A2000_hnn_80_btag_nulnul_cc(x)
         elseif (mhindx.eq.2) then
            val1=A2000_hnn_80_btag_nulnul_cc(x)
            val2=A2000_hnn_85_btag_nulnul_cc(x)
         elseif (mhindx.eq.3) then
            val1=A2000_hnn_85_btag_nulnul_cc(x)
            val2=A2000_hnn_90_btag_nulnul_cc(x)
         elseif (mhindx.eq.4) then
            val1=A2000_hnn_90_btag_nulnul_cc(x)
            val2=A2000_hnn_95_btag_nulnul_cc(x)
         elseif (mhindx.eq.5) then
            val1=A2000_hnn_95_btag_nulnul_cc(x)
            val2=A208_hnn_100_btag_nulnul_ww(x)
         elseif (mhindx.eq.6) then
            val1=A208_hnn_100_btag_nulnul_ww(x)
            val2=A208_hnn_104_btag_nulnul_ww(x)
         elseif (mhindx.eq.7) then
            val1=A208_hnn_104_btag_nulnul_ww(x)
            val2=A208_hnn_106_btag_nulnul_ww(x)
         elseif (mhindx.eq.8) then
            val1=A208_hnn_106_btag_nulnul_ww(x)
            val2=A208_hnn_108_btag_nulnul_ww(x)
         elseif (mhindx.eq.9) then
            val1=A208_hnn_108_btag_nulnul_ww(x)
            val2=A208_hnn_110_btag_nulnul_ww(x)
         elseif (mhindx.eq.10) then
            val1=A208_hnn_110_btag_nulnul_ww(x)
            val2=A208_hnn_112_btag_nulnul_ww(x)
         elseif (mhindx.eq.11) then
            val1=A208_hnn_112_btag_nulnul_ww(x)
            val2=A208_hnn_113_btag_nulnul_ww(x)
         elseif (mhindx.eq.12) then
            val1=A208_hnn_113_btag_nulnul_ww(x)
            val2=A208_hnn_114_btag_nulnul_ww(x)
         elseif (mhindx.eq.13) then
            val1=A208_hnn_114_btag_nulnul_ww(x)
            val2=A208_hnn_115_btag_nulnul_ww(x)
         elseif (mhindx.eq.14) then
            val1=A208_hnn_115_btag_nulnul_ww(x)
            val2=A208_hnn_116_btag_nulnul_ww(x)
         elseif (mhindx.eq.15) then
            val1=A208_hnn_116_btag_nulnul_ww(x)
            val2=A208_hnn_1168_btag_nulnul_ww(x)
         elseif (mhindx.eq.16) then
            val1=A208_hnn_1168_btag_nulnul_ww(x)
            val2=A208_hnn_118_btag_nulnul_ww(x)
         elseif (mhindx.eq.17) then
            val1=A208_hnn_118_btag_nulnul_ww(x)
            val2=A208_hnn_119_btag_nulnul_ww(x)
         elseif (mhindx.eq.18) then
            val1=A208_hnn_119_btag_nulnul_ww(x)
            val2=A208_hnn_120_btag_nulnul_ww(x)
         elseif (mhindx.eq.nummass) then
            val1=A208_hnn_120_btag_nulnul_ww(x)
            val2=A208_hnn_120_btag_nulnul_ww(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         endif
      elseif (isig.eq.6) then
         if (mhindx.eq.0) then
            val1=A2000_hnn_75_btag_nuenue_bb(x)
            val2=A2000_hnn_75_btag_nuenue_bb(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         elseif (mhindx.eq.1) then
            val1=A2000_hnn_75_btag_nuenue_bb(x)
            val2=A2000_hnn_80_btag_nuenue_bb(x)
         elseif (mhindx.eq.2) then
            val1=A2000_hnn_80_btag_nuenue_bb(x)
            val2=A2000_hnn_85_btag_nuenue_bb(x)
         elseif (mhindx.eq.3) then
            val1=A2000_hnn_85_btag_nuenue_bb(x)
            val2=A2000_hnn_90_btag_nuenue_bb(x)
         elseif (mhindx.eq.4) then
            val1=A2000_hnn_90_btag_nuenue_bb(x)
            val2=A2000_hnn_95_btag_nuenue_bb(x)
         elseif (mhindx.eq.5) then
            val1=A2000_hnn_95_btag_nuenue_bb(x)
            val2=A208_hnn_100_btag_nuenue_bb(x)
         elseif (mhindx.eq.6) then
            val1=A208_hnn_100_btag_nuenue_bb(x)
            val2=A208_hnn_104_btag_nuenue_bb(x)
         elseif (mhindx.eq.7) then
            val1=A208_hnn_104_btag_nuenue_bb(x)
            val2=A208_hnn_106_btag_nuenue_bb(x)
         elseif (mhindx.eq.8) then
            val1=A208_hnn_106_btag_nuenue_bb(x)
            val2=A208_hnn_108_btag_nuenue_bb(x)
         elseif (mhindx.eq.9) then
            val1=A208_hnn_108_btag_nuenue_bb(x)
            val2=A208_hnn_110_btag_nuenue_bb(x)
         elseif (mhindx.eq.10) then
            val1=A208_hnn_110_btag_nuenue_bb(x)
            val2=A208_hnn_112_btag_nuenue_bb(x)
         elseif (mhindx.eq.11) then
            val1=A208_hnn_112_btag_nuenue_bb(x)
            val2=A208_hnn_113_btag_nuenue_bb(x)
         elseif (mhindx.eq.12) then
            val1=A208_hnn_113_btag_nuenue_bb(x)
            val2=A208_hnn_114_btag_nuenue_bb(x)
         elseif (mhindx.eq.13) then
            val1=A208_hnn_114_btag_nuenue_bb(x)
            val2=A208_hnn_115_btag_nuenue_bb(x)
         elseif (mhindx.eq.14) then
            val1=A208_hnn_115_btag_nuenue_bb(x)
            val2=A208_hnn_116_btag_nuenue_bb(x)
         elseif (mhindx.eq.15) then
            val1=A208_hnn_116_btag_nuenue_bb(x)
            val2=A208_hnn_1168_btag_nuenue_bb(x)
         elseif (mhindx.eq.16) then
            val1=A208_hnn_1168_btag_nuenue_bb(x)
            val2=A208_hnn_118_btag_nuenue_bb(x)
         elseif (mhindx.eq.17) then
            val1=A208_hnn_118_btag_nuenue_bb(x)
            val2=A208_hnn_119_btag_nuenue_bb(x)
         elseif (mhindx.eq.18) then
            val1=A208_hnn_119_btag_nuenue_bb(x)
            val2=A208_hnn_120_btag_nuenue_bb(x)
         elseif (mhindx.eq.nummass) then
            val1=A208_hnn_120_btag_nuenue_bb(x)
            val2=A208_hnn_120_btag_nuenue_bb(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         endif
      elseif (isig.eq.8) then
         if (mhindx.eq.0) then
            val1=A2000_hnn_75_btag_nuenue_cc(x)
            val2=A2000_hnn_75_btag_nuenue_cc(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         elseif (mhindx.eq.1) then
            val1=A2000_hnn_75_btag_nuenue_cc(x)
            val2=A2000_hnn_80_btag_nuenue_cc(x)
         elseif (mhindx.eq.2) then
            val1=A2000_hnn_80_btag_nuenue_cc(x)
            val2=A2000_hnn_85_btag_nuenue_cc(x)
         elseif (mhindx.eq.3) then
            val1=A2000_hnn_85_btag_nuenue_cc(x)
            val2=A2000_hnn_90_btag_nuenue_cc(x)
         elseif (mhindx.eq.4) then
            val1=A2000_hnn_90_btag_nuenue_cc(x)
            val2=A2000_hnn_95_btag_nuenue_cc(x)
         elseif (mhindx.eq.5) then
            val1=A2000_hnn_95_btag_nuenue_cc(x)
            val2=A208_hnn_100_btag_nuenue_cc(x)
         elseif (mhindx.eq.6) then
            val1=A208_hnn_100_btag_nuenue_cc(x)
            val2=A208_hnn_104_btag_nuenue_cc(x)
         elseif (mhindx.eq.7) then
            val1=A208_hnn_104_btag_nuenue_cc(x)
            val2=A208_hnn_106_btag_nuenue_cc(x)
         elseif (mhindx.eq.8) then
            val1=A208_hnn_106_btag_nuenue_cc(x)
            val2=A208_hnn_108_btag_nuenue_cc(x)
         elseif (mhindx.eq.9) then
            val1=A208_hnn_108_btag_nuenue_cc(x)
            val2=A208_hnn_110_btag_nuenue_cc(x)
         elseif (mhindx.eq.10) then
            val1=A208_hnn_110_btag_nuenue_cc(x)
            val2=A208_hnn_112_btag_nuenue_cc(x)
         elseif (mhindx.eq.11) then
            val1=A208_hnn_112_btag_nuenue_cc(x)
            val2=A208_hnn_113_btag_nuenue_cc(x)
         elseif (mhindx.eq.12) then
            val1=A208_hnn_113_btag_nuenue_cc(x)
            val2=A208_hnn_114_btag_nuenue_cc(x)
         elseif (mhindx.eq.13) then
            val1=A208_hnn_114_btag_nuenue_cc(x)
            val2=A208_hnn_115_btag_nuenue_cc(x)
         elseif (mhindx.eq.14) then
            val1=A208_hnn_115_btag_nuenue_cc(x)
            val2=A208_hnn_116_btag_nuenue_cc(x)
         elseif (mhindx.eq.15) then
            val1=A208_hnn_116_btag_nuenue_cc(x)
            val2=A208_hnn_1168_btag_nuenue_cc(x)
         elseif (mhindx.eq.16) then
            val1=A208_hnn_1168_btag_nuenue_cc(x)
            val2=A208_hnn_118_btag_nuenue_cc(x)
         elseif (mhindx.eq.17) then
            val1=A208_hnn_118_btag_nuenue_cc(x)
            val2=A208_hnn_119_btag_nuenue_cc(x)
         elseif (mhindx.eq.18) then
            val1=A208_hnn_119_btag_nuenue_cc(x)
            val2=A208_hnn_120_btag_nuenue_cc(x)
         elseif (mhindx.eq.nummass) then
            val1=A208_hnn_120_btag_nuenue_cc(x)
            val2=A208_hnn_120_btag_nuenue_cc(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         endif
      elseif (isig.eq.9) then
         if (mhindx.eq.0) then
            val1=A2000_hnn_75_btag_nuenue_gg(x)
            val2=A2000_hnn_75_btag_nuenue_gg(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         elseif (mhindx.eq.1) then
            val1=A2000_hnn_75_btag_nuenue_gg(x)
            val2=A2000_hnn_80_btag_nuenue_gg(x)
         elseif (mhindx.eq.2) then
            val1=A2000_hnn_80_btag_nuenue_gg(x)
            val2=A2000_hnn_85_btag_nuenue_gg(x)
         elseif (mhindx.eq.3) then
            val1=A2000_hnn_85_btag_nuenue_gg(x)
            val2=A2000_hnn_90_btag_nuenue_gg(x)
         elseif (mhindx.eq.4) then
            val1=A2000_hnn_90_btag_nuenue_gg(x)
            val2=A2000_hnn_95_btag_nuenue_gg(x)
         elseif (mhindx.eq.5) then
            val1=A2000_hnn_95_btag_nuenue_gg(x)
            val2=A208_hnn_100_btag_nuenue_gg(x)
         elseif (mhindx.eq.6) then
            val1=A208_hnn_100_btag_nuenue_gg(x)
            val2=A208_hnn_104_btag_nuenue_gg(x)
         elseif (mhindx.eq.7) then
            val1=A208_hnn_104_btag_nuenue_gg(x)
            val2=A208_hnn_106_btag_nuenue_gg(x)
         elseif (mhindx.eq.8) then
            val1=A208_hnn_106_btag_nuenue_gg(x)
            val2=A208_hnn_108_btag_nuenue_gg(x)
         elseif (mhindx.eq.9) then
            val1=A208_hnn_108_btag_nuenue_gg(x)
            val2=A208_hnn_110_btag_nuenue_gg(x)
         elseif (mhindx.eq.10) then
            val1=A208_hnn_110_btag_nuenue_gg(x)
            val2=A208_hnn_112_btag_nuenue_gg(x)
         elseif (mhindx.eq.11) then
            val1=A208_hnn_112_btag_nuenue_gg(x)
            val2=A208_hnn_113_btag_nuenue_gg(x)
         elseif (mhindx.eq.12) then
            val1=A208_hnn_113_btag_nuenue_gg(x)
            val2=A208_hnn_114_btag_nuenue_gg(x)
         elseif (mhindx.eq.13) then
            val1=A208_hnn_114_btag_nuenue_gg(x)
            val2=A208_hnn_115_btag_nuenue_gg(x)
         elseif (mhindx.eq.14) then
            val1=A208_hnn_115_btag_nuenue_gg(x)
            val2=A208_hnn_116_btag_nuenue_gg(x)
         elseif (mhindx.eq.15) then
            val1=A208_hnn_116_btag_nuenue_gg(x)
            val2=A208_hnn_1168_btag_nuenue_gg(x)
         elseif (mhindx.eq.16) then
            val1=A208_hnn_1168_btag_nuenue_gg(x)
            val2=A208_hnn_118_btag_nuenue_gg(x)
         elseif (mhindx.eq.17) then
            val1=A208_hnn_118_btag_nuenue_gg(x)
            val2=A208_hnn_119_btag_nuenue_gg(x)
         elseif (mhindx.eq.18) then
            val1=A208_hnn_119_btag_nuenue_gg(x)
            val2=A208_hnn_120_btag_nuenue_gg(x)
         elseif (mhindx.eq.nummass) then
            val1=A208_hnn_120_btag_nuenue_gg(x)
            val2=A208_hnn_120_btag_nuenue_gg(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         endif
      elseif (isig.eq.10.or.isig.eq.7) then
         if (mhindx.eq.0) then
            val1=A2000_hnn_75_btag_nuenue_cc(x)
            val2=A2000_hnn_75_btag_nuenue_cc(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         elseif (mhindx.eq.1) then
            val1=A2000_hnn_75_btag_nuenue_cc(x)
            val2=A2000_hnn_80_btag_nuenue_cc(x)
         elseif (mhindx.eq.2) then
            val1=A2000_hnn_80_btag_nuenue_cc(x)
            val2=A2000_hnn_85_btag_nuenue_cc(x)
         elseif (mhindx.eq.3) then
            val1=A2000_hnn_85_btag_nuenue_cc(x)
            val2=A2000_hnn_90_btag_nuenue_cc(x)
         elseif (mhindx.eq.4) then
            val1=A2000_hnn_90_btag_nuenue_cc(x)
            val2=A2000_hnn_95_btag_nuenue_cc(x)
         elseif (mhindx.eq.5) then
            val1=A2000_hnn_95_btag_nuenue_cc(x)
            val2=A208_hnn_100_btag_nuenue_ww(x)
         elseif (mhindx.eq.6) then
            val1=A208_hnn_100_btag_nuenue_ww(x)
            val2=A208_hnn_104_btag_nuenue_ww(x)
         elseif (mhindx.eq.7) then
            val1=A208_hnn_104_btag_nuenue_ww(x)
            val2=A208_hnn_106_btag_nuenue_ww(x)
         elseif (mhindx.eq.8) then
            val1=A208_hnn_106_btag_nuenue_ww(x)
            val2=A208_hnn_108_btag_nuenue_ww(x)
         elseif (mhindx.eq.9) then
            val1=A208_hnn_108_btag_nuenue_ww(x)
            val2=A208_hnn_110_btag_nuenue_ww(x)
         elseif (mhindx.eq.10) then
            val1=A208_hnn_110_btag_nuenue_ww(x)
            val2=A208_hnn_112_btag_nuenue_ww(x)
         elseif (mhindx.eq.11) then
            val1=A208_hnn_112_btag_nuenue_ww(x)
            val2=A208_hnn_113_btag_nuenue_ww(x)
         elseif (mhindx.eq.12) then
            val1=A208_hnn_113_btag_nuenue_ww(x)
            val2=A208_hnn_114_btag_nuenue_ww(x)
         elseif (mhindx.eq.13) then
            val1=A208_hnn_114_btag_nuenue_ww(x)
            val2=A208_hnn_115_btag_nuenue_ww(x)
         elseif (mhindx.eq.14) then
            val1=A208_hnn_115_btag_nuenue_ww(x)
            val2=A208_hnn_116_btag_nuenue_ww(x)
         elseif (mhindx.eq.15) then
            val1=A208_hnn_116_btag_nuenue_ww(x)
            val2=A208_hnn_1168_btag_nuenue_ww(x)
         elseif (mhindx.eq.16) then
            val1=A208_hnn_1168_btag_nuenue_ww(x)
            val2=A208_hnn_118_btag_nuenue_ww(x)
         elseif (mhindx.eq.17) then
            val1=A208_hnn_118_btag_nuenue_ww(x)
            val2=A208_hnn_119_btag_nuenue_ww(x)
         elseif (mhindx.eq.18) then
            val1=A208_hnn_119_btag_nuenue_ww(x)
            val2=A208_hnn_120_btag_nuenue_ww(x)
         elseif (mhindx.eq.nummass) then
            val1=A208_hnn_120_btag_nuenue_ww(x)
            val2=A208_hnn_120_btag_nulnul_ww(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         endif

      else
         val1=0.d0
         val2=0.d0
         w1=1.d0
         w2=1.d0
         mhdif=1.d0
      endif
      A2000_208_nn_btag_sig=(val1*w1+val2*w2)/mhdif
      end





      double precision function a2000_210_nn_btag_sig(x,hmass,isig)
      implicit none
      real*8 x,hmass
      integer isig
      real*8 A2000_hnn_75_btag_nulnul_bb
     & ,A2000_hnn_75_btag_nulnul_cc, A2000_hnn_75_btag_nulnul_gg
      real*8 A2000_hnn_80_btag_nulnul_bb
     & ,A2000_hnn_80_btag_nulnul_cc, A2000_hnn_80_btag_nulnul_gg
      real*8 A2000_hnn_85_btag_nulnul_bb
     & ,A2000_hnn_85_btag_nulnul_cc, A2000_hnn_85_btag_nulnul_gg
      real*8 A2000_hnn_90_btag_nulnul_bb
     & ,A2000_hnn_90_btag_nulnul_cc, A2000_hnn_90_btag_nulnul_gg
      real*8 A2000_hnn_95_btag_nulnul_bb
     & ,A2000_hnn_95_btag_nulnul_cc, A2000_hnn_95_btag_nulnul_gg
      real*8 A210_hnn_100_btag_nulnul_bb
     & ,A210_hnn_100_btag_nulnul_cc, A210_hnn_100_btag_nulnul_gg
     & ,A210_hnn_100_btag_nulnul_ww
      real*8 A210_hnn_104_btag_nulnul_bb
     & ,A210_hnn_104_btag_nulnul_cc, A210_hnn_104_btag_nulnul_gg
     & ,A210_hnn_104_btag_nulnul_ww
      real*8 A210_hnn_106_btag_nulnul_bb
     & ,A210_hnn_106_btag_nulnul_cc, A210_hnn_106_btag_nulnul_gg
     & ,A210_hnn_106_btag_nulnul_ww
      real*8 A210_hnn_108_btag_nulnul_bb
     & ,A210_hnn_108_btag_nulnul_cc, A210_hnn_108_btag_nulnul_gg
     & ,A210_hnn_108_btag_nulnul_ww
      real*8 A210_hnn_110_btag_nulnul_bb
     & ,A210_hnn_110_btag_nulnul_cc, A210_hnn_110_btag_nulnul_gg
     & ,A210_hnn_110_btag_nulnul_ww
      real*8 A210_hnn_112_btag_nulnul_bb
     & ,A210_hnn_112_btag_nulnul_cc, A210_hnn_112_btag_nulnul_gg
     & ,A210_hnn_112_btag_nulnul_ww
      real*8 A210_hnn_113_btag_nulnul_bb
     & ,A210_hnn_113_btag_nulnul_cc, A210_hnn_113_btag_nulnul_gg
     & ,A210_hnn_113_btag_nulnul_ww
      real*8 A210_hnn_114_btag_nulnul_bb
     & ,A210_hnn_114_btag_nulnul_cc, A210_hnn_114_btag_nulnul_gg
     & ,A210_hnn_114_btag_nulnul_ww
      real*8 A210_hnn_115_btag_nulnul_bb
     & ,A210_hnn_115_btag_nulnul_cc, A210_hnn_115_btag_nulnul_gg
     & ,A210_hnn_115_btag_nulnul_ww
      real*8 A210_hnn_116_btag_nulnul_bb
     & ,A210_hnn_116_btag_nulnul_cc, A210_hnn_116_btag_nulnul_gg
     & ,A210_hnn_116_btag_nulnul_ww
      real*8 A210_hnn_117_btag_nulnul_bb
     & ,A210_hnn_117_btag_nulnul_cc, A210_hnn_117_btag_nulnul_gg
     & ,A210_hnn_117_btag_nulnul_ww
      real*8 A210_hnn_118_btag_nulnul_bb
     & ,A210_hnn_118_btag_nulnul_cc, A210_hnn_118_btag_nulnul_gg
     & ,A210_hnn_118_btag_nulnul_ww
      real*8 A210_hnn_1188_btag_nulnul_bb
     & ,A210_hnn_1188_btag_nulnul_cc, A210_hnn_1188_btag_nulnul_gg
     & ,A210_hnn_1188_btag_nulnul_ww
      real*8 A210_hnn_120_btag_nulnul_bb
     & ,A210_hnn_120_btag_nulnul_cc, A210_hnn_120_btag_nulnul_gg
     & ,A210_hnn_120_btag_nulnul_ww

      external A2000_hnn_75_btag_nulnul_bb
     & ,A2000_hnn_75_btag_nulnul_cc, A2000_hnn_75_btag_nulnul_gg
      external A2000_hnn_80_btag_nulnul_bb
     & ,A2000_hnn_80_btag_nulnul_cc, A2000_hnn_80_btag_nulnul_gg
      external A2000_hnn_85_btag_nulnul_bb
     & ,A2000_hnn_85_btag_nulnul_cc, A2000_hnn_85_btag_nulnul_gg
      external A2000_hnn_90_btag_nulnul_bb
     & ,A2000_hnn_90_btag_nulnul_cc, A2000_hnn_90_btag_nulnul_gg
      external A2000_hnn_95_btag_nulnul_bb
     & ,A2000_hnn_95_btag_nulnul_cc, A2000_hnn_95_btag_nulnul_gg
      external A210_hnn_100_btag_nulnul_bb
     & ,A210_hnn_100_btag_nulnul_cc, A210_hnn_100_btag_nulnul_gg
     & ,A210_hnn_100_btag_nulnul_ww
      external A210_hnn_104_btag_nulnul_bb
     & ,A210_hnn_104_btag_nulnul_cc, A210_hnn_104_btag_nulnul_gg
     & ,A210_hnn_104_btag_nulnul_ww
      external A210_hnn_106_btag_nulnul_bb
     & ,A210_hnn_106_btag_nulnul_cc, A210_hnn_106_btag_nulnul_gg
     & ,A210_hnn_106_btag_nulnul_ww
      external A210_hnn_108_btag_nulnul_bb
     & ,A210_hnn_108_btag_nulnul_cc, A210_hnn_108_btag_nulnul_gg
     & ,A210_hnn_108_btag_nulnul_ww
      external A210_hnn_110_btag_nulnul_bb
     & ,A210_hnn_110_btag_nulnul_cc, A210_hnn_110_btag_nulnul_gg
     & ,A210_hnn_110_btag_nulnul_ww
      external A210_hnn_112_btag_nulnul_bb
     & ,A210_hnn_112_btag_nulnul_cc, A210_hnn_112_btag_nulnul_gg
     & ,A210_hnn_112_btag_nulnul_ww
      external A210_hnn_113_btag_nulnul_bb
     & ,A210_hnn_113_btag_nulnul_cc, A210_hnn_113_btag_nulnul_gg
     & ,A210_hnn_113_btag_nulnul_ww
      external A210_hnn_114_btag_nulnul_bb
     & ,A210_hnn_114_btag_nulnul_cc, A210_hnn_114_btag_nulnul_gg
     & ,A210_hnn_114_btag_nulnul_ww
      external A210_hnn_115_btag_nulnul_bb
     & ,A210_hnn_115_btag_nulnul_cc, A210_hnn_115_btag_nulnul_gg
     & ,A210_hnn_115_btag_nulnul_ww
      external A210_hnn_116_btag_nulnul_bb
     & ,A210_hnn_116_btag_nulnul_cc, A210_hnn_116_btag_nulnul_gg
     & ,A210_hnn_116_btag_nulnul_ww
      external A210_hnn_117_btag_nulnul_bb
     & ,A210_hnn_117_btag_nulnul_cc, A210_hnn_117_btag_nulnul_gg
     & ,A210_hnn_117_btag_nulnul_ww
      external A210_hnn_118_btag_nulnul_bb
     & ,A210_hnn_118_btag_nulnul_cc, A210_hnn_118_btag_nulnul_gg
     & ,A210_hnn_118_btag_nulnul_ww
      external A210_hnn_1188_btag_nulnul_bb
     & ,A210_hnn_1188_btag_nulnul_cc, A210_hnn_1188_btag_nulnul_gg
     & ,A210_hnn_1188_btag_nulnul_ww
      external A210_hnn_120_btag_nulnul_bb
     & ,A210_hnn_120_btag_nulnul_cc, A210_hnn_120_btag_nulnul_gg
     & ,A210_hnn_120_btag_nulnul_ww



      real*8 A2000_hnn_75_btag_nuenue_bb
     & ,A2000_hnn_75_btag_nuenue_cc, A2000_hnn_75_btag_nuenue_gg
      real*8 A2000_hnn_80_btag_nuenue_bb
     & ,A2000_hnn_80_btag_nuenue_cc, A2000_hnn_80_btag_nuenue_gg
      real*8 A2000_hnn_85_btag_nuenue_bb
     & ,A2000_hnn_85_btag_nuenue_cc, A2000_hnn_85_btag_nuenue_gg
      real*8 A2000_hnn_90_btag_nuenue_bb
     & ,A2000_hnn_90_btag_nuenue_cc, A2000_hnn_90_btag_nuenue_gg
      real*8 A2000_hnn_95_btag_nuenue_bb
     & ,A2000_hnn_95_btag_nuenue_cc, A2000_hnn_95_btag_nuenue_gg
      real*8 A210_hnn_100_btag_nuenue_bb
     & ,A210_hnn_100_btag_nuenue_cc, A210_hnn_100_btag_nuenue_gg
     & ,A210_hnn_100_btag_nuenue_ww
      real*8 A210_hnn_104_btag_nuenue_bb
     & ,A210_hnn_104_btag_nuenue_cc, A210_hnn_104_btag_nuenue_gg
     & ,A210_hnn_104_btag_nuenue_ww
      real*8 A210_hnn_106_btag_nuenue_bb
     & ,A210_hnn_106_btag_nuenue_cc, A210_hnn_106_btag_nuenue_gg
     & ,A210_hnn_106_btag_nuenue_ww
      real*8 A210_hnn_108_btag_nuenue_bb
     & ,A210_hnn_108_btag_nuenue_cc, A210_hnn_108_btag_nuenue_gg
     & ,A210_hnn_108_btag_nuenue_ww
      real*8 A210_hnn_110_btag_nuenue_bb
     & ,A210_hnn_110_btag_nuenue_cc, A210_hnn_110_btag_nuenue_gg
     & ,A210_hnn_110_btag_nuenue_ww
      real*8 A210_hnn_112_btag_nuenue_bb
     & ,A210_hnn_112_btag_nuenue_cc, A210_hnn_112_btag_nuenue_gg
     & ,A210_hnn_112_btag_nuenue_ww
      real*8 A210_hnn_113_btag_nuenue_bb
     & ,A210_hnn_113_btag_nuenue_cc, A210_hnn_113_btag_nuenue_gg
     & ,A210_hnn_113_btag_nuenue_ww
      real*8 A210_hnn_114_btag_nuenue_bb
     & ,A210_hnn_114_btag_nuenue_cc, A210_hnn_114_btag_nuenue_gg
     & ,A210_hnn_114_btag_nuenue_ww
      real*8 A210_hnn_115_btag_nuenue_bb
     & ,A210_hnn_115_btag_nuenue_cc, A210_hnn_115_btag_nuenue_gg
     & ,A210_hnn_115_btag_nuenue_ww
      real*8 A210_hnn_116_btag_nuenue_bb
     & ,A210_hnn_116_btag_nuenue_cc, A210_hnn_116_btag_nuenue_gg
     & ,A210_hnn_116_btag_nuenue_ww
      real*8 A210_hnn_117_btag_nuenue_bb
     & ,A210_hnn_117_btag_nuenue_cc, A210_hnn_117_btag_nuenue_gg
     & ,A210_hnn_117_btag_nuenue_ww
      real*8 A210_hnn_118_btag_nuenue_bb
     & ,A210_hnn_118_btag_nuenue_cc, A210_hnn_118_btag_nuenue_gg
     & ,A210_hnn_118_btag_nuenue_ww
      real*8 A210_hnn_1188_btag_nuenue_bb
     & ,A210_hnn_1188_btag_nuenue_cc, A210_hnn_1188_btag_nuenue_gg
     & ,A210_hnn_1188_btag_nuenue_ww
      real*8 A210_hnn_120_btag_nuenue_bb
     & ,A210_hnn_120_btag_nuenue_cc, A210_hnn_120_btag_nuenue_gg
     & ,A210_hnn_120_btag_nuenue_ww

      external A2000_hnn_75_btag_nuenue_bb
     & ,A2000_hnn_75_btag_nuenue_cc, A2000_hnn_75_btag_nuenue_gg
      external A2000_hnn_80_btag_nuenue_bb
     & ,A2000_hnn_80_btag_nuenue_cc, A2000_hnn_80_btag_nuenue_gg
      external A2000_hnn_85_btag_nuenue_bb
     & ,A2000_hnn_85_btag_nuenue_cc, A2000_hnn_85_btag_nuenue_gg
      external A2000_hnn_90_btag_nuenue_bb
     & ,A2000_hnn_90_btag_nuenue_cc, A2000_hnn_90_btag_nuenue_gg
      external A2000_hnn_95_btag_nuenue_bb
     & ,A2000_hnn_95_btag_nuenue_cc, A2000_hnn_95_btag_nuenue_gg
      external A210_hnn_100_btag_nuenue_bb
     & ,A210_hnn_100_btag_nuenue_cc, A210_hnn_100_btag_nuenue_gg
     & ,A210_hnn_100_btag_nuenue_ww
      external A210_hnn_104_btag_nuenue_bb
     & ,A210_hnn_104_btag_nuenue_cc, A210_hnn_104_btag_nuenue_gg
     & ,A210_hnn_104_btag_nuenue_ww
      external A210_hnn_106_btag_nuenue_bb
     & ,A210_hnn_106_btag_nuenue_cc, A210_hnn_106_btag_nuenue_gg
     & ,A210_hnn_106_btag_nuenue_ww
      external A210_hnn_108_btag_nuenue_bb
     & ,A210_hnn_108_btag_nuenue_cc, A210_hnn_108_btag_nuenue_gg
     & ,A210_hnn_108_btag_nuenue_ww
      external A210_hnn_110_btag_nuenue_bb
     & ,A210_hnn_110_btag_nuenue_cc, A210_hnn_110_btag_nuenue_gg
     & ,A210_hnn_110_btag_nuenue_ww
      external A210_hnn_112_btag_nuenue_bb
     & ,A210_hnn_112_btag_nuenue_cc, A210_hnn_112_btag_nuenue_gg
     & ,A210_hnn_112_btag_nuenue_ww
      external A210_hnn_113_btag_nuenue_bb
     & ,A210_hnn_113_btag_nuenue_cc, A210_hnn_113_btag_nuenue_gg
     & ,A210_hnn_113_btag_nuenue_ww
      external A210_hnn_114_btag_nuenue_bb
     & ,A210_hnn_114_btag_nuenue_cc, A210_hnn_114_btag_nuenue_gg
     & ,A210_hnn_114_btag_nuenue_ww
      external A210_hnn_115_btag_nuenue_bb
     & ,A210_hnn_115_btag_nuenue_cc, A210_hnn_115_btag_nuenue_gg
     & ,A210_hnn_115_btag_nuenue_ww
      external A210_hnn_116_btag_nuenue_bb
     & ,A210_hnn_116_btag_nuenue_cc, A210_hnn_116_btag_nuenue_gg
     & ,A210_hnn_116_btag_nuenue_ww
      external A210_hnn_117_btag_nuenue_bb
     & ,A210_hnn_117_btag_nuenue_cc, A210_hnn_117_btag_nuenue_gg
     & ,A210_hnn_117_btag_nuenue_ww
      external A210_hnn_118_btag_nuenue_bb
     & ,A210_hnn_118_btag_nuenue_cc, A210_hnn_118_btag_nuenue_gg
     & ,A210_hnn_118_btag_nuenue_ww
      external A210_hnn_1188_btag_nuenue_bb
     & ,A210_hnn_1188_btag_nuenue_cc, A210_hnn_1188_btag_nuenue_gg
     & ,A210_hnn_1188_btag_nuenue_ww
      external A210_hnn_120_btag_nuenue_bb
     & ,A210_hnn_120_btag_nuenue_cc, A210_hnn_120_btag_nuenue_gg
     & ,A210_hnn_120_btag_nuenue_ww




      integer nummass,i,j,mhindx
      parameter (nummass=19) 
      real*8 sigmass(nummass),mhdif,val1,val2,w1,w2
      data sigmass /75.d0,80.d0,85.d0,90.d0,95.d0,100.d0
     &     ,104.d0,106.d0,108.d0,110.d0,112.d0,113.d0,114.d0,115.d0
     &     ,116.d0,117.d0,118.d0,118.8d0,120.d0/
      mhindx=0
      do i= 1,nummass
         if (sigmass(i).lt.hmass) mhindx=i
      enddo
      if (mhindx.gt.0.and.mhindx.lt.nummass) then
         w1=sigmass(mhindx+1)-hmass
         w2=hmass-sigmass(mhindx)
         mhdif=sigmass(mhindx+1)-sigmass(mhindx)
      endif
      if (isig.eq.1) then
         if (mhindx.eq.0) then
            val1=A2000_hnn_75_btag_nulnul_bb(x)
            val2=A2000_hnn_75_btag_nulnul_bb(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         elseif (mhindx.eq.1) then
            val1=A2000_hnn_75_btag_nulnul_bb(x)
            val2=A2000_hnn_80_btag_nulnul_bb(x)
         elseif (mhindx.eq.2) then
            val1=A2000_hnn_80_btag_nulnul_bb(x)
            val2=A2000_hnn_85_btag_nulnul_bb(x)
         elseif (mhindx.eq.3) then
            val1=A2000_hnn_85_btag_nulnul_bb(x)
            val2=A2000_hnn_90_btag_nulnul_bb(x)
         elseif (mhindx.eq.4) then
            val1=A2000_hnn_90_btag_nulnul_bb(x)
            val2=A2000_hnn_95_btag_nulnul_bb(x)
         elseif (mhindx.eq.5) then
            val1=A2000_hnn_95_btag_nulnul_bb(x)
            val2=A210_hnn_100_btag_nulnul_bb(x)
         elseif (mhindx.eq.6) then
            val1=A210_hnn_100_btag_nulnul_bb(x)
            val2=A210_hnn_104_btag_nulnul_bb(x)
         elseif (mhindx.eq.7) then
            val1=A210_hnn_104_btag_nulnul_bb(x)
            val2=A210_hnn_106_btag_nulnul_bb(x)
         elseif (mhindx.eq.8) then
            val1=A210_hnn_106_btag_nulnul_bb(x)
            val2=A210_hnn_108_btag_nulnul_bb(x)
         elseif (mhindx.eq.9) then
            val1=A210_hnn_108_btag_nulnul_bb(x)
            val2=A210_hnn_110_btag_nulnul_bb(x)
         elseif (mhindx.eq.10) then
            val1=A210_hnn_110_btag_nulnul_bb(x)
            val2=A210_hnn_112_btag_nulnul_bb(x)
         elseif (mhindx.eq.11) then
            val1=A210_hnn_112_btag_nulnul_bb(x)
            val2=A210_hnn_113_btag_nulnul_bb(x)
         elseif (mhindx.eq.12) then
            val1=A210_hnn_113_btag_nulnul_bb(x)
            val2=A210_hnn_114_btag_nulnul_bb(x)
         elseif (mhindx.eq.13) then
            val1=A210_hnn_114_btag_nulnul_bb(x)
            val2=A210_hnn_115_btag_nulnul_bb(x)
         elseif (mhindx.eq.14) then
            val1=A210_hnn_115_btag_nulnul_bb(x)
            val2=A210_hnn_116_btag_nulnul_bb(x)
         elseif (mhindx.eq.15) then
            val1=A210_hnn_116_btag_nulnul_bb(x)
            val2=A210_hnn_117_btag_nulnul_bb(x)
         elseif (mhindx.eq.16) then
            val1=A210_hnn_117_btag_nulnul_bb(x)
            val2=A210_hnn_118_btag_nulnul_bb(x)
         elseif (mhindx.eq.17) then
            val1=A210_hnn_118_btag_nulnul_bb(x)
            val2=A210_hnn_1188_btag_nulnul_bb(x)
         elseif (mhindx.eq.18) then
            val1=A210_hnn_1188_btag_nulnul_bb(x)
            val2=A210_hnn_120_btag_nulnul_bb(x)
         elseif (mhindx.eq.nummass) then
            val1=A210_hnn_120_btag_nulnul_bb(x)
            val2=A210_hnn_120_btag_nulnul_bb(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         endif
      elseif (isig.eq.3) then
         if (mhindx.eq.0) then
            val1=A2000_hnn_75_btag_nulnul_cc(x)
            val2=A2000_hnn_75_btag_nulnul_cc(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         elseif (mhindx.eq.1) then
            val1=A2000_hnn_75_btag_nulnul_cc(x)
            val2=A2000_hnn_80_btag_nulnul_cc(x)
         elseif (mhindx.eq.2) then
            val1=A2000_hnn_80_btag_nulnul_cc(x)
            val2=A2000_hnn_85_btag_nulnul_cc(x)
         elseif (mhindx.eq.3) then
            val1=A2000_hnn_85_btag_nulnul_cc(x)
            val2=A2000_hnn_90_btag_nulnul_cc(x)
         elseif (mhindx.eq.4) then
            val1=A2000_hnn_90_btag_nulnul_cc(x)
            val2=A2000_hnn_95_btag_nulnul_cc(x)
         elseif (mhindx.eq.5) then
            val1=A2000_hnn_95_btag_nulnul_cc(x)
            val2=A210_hnn_100_btag_nulnul_cc(x)
         elseif (mhindx.eq.6) then
            val1=A210_hnn_100_btag_nulnul_cc(x)
            val2=A210_hnn_104_btag_nulnul_cc(x)
         elseif (mhindx.eq.7) then
            val1=A210_hnn_104_btag_nulnul_cc(x)
            val2=A210_hnn_106_btag_nulnul_cc(x)
         elseif (mhindx.eq.8) then
            val1=A210_hnn_106_btag_nulnul_cc(x)
            val2=A210_hnn_108_btag_nulnul_cc(x)
         elseif (mhindx.eq.9) then
            val1=A210_hnn_108_btag_nulnul_cc(x)
            val2=A210_hnn_110_btag_nulnul_cc(x)
         elseif (mhindx.eq.10) then
            val1=A210_hnn_110_btag_nulnul_cc(x)
            val2=A210_hnn_112_btag_nulnul_cc(x)
         elseif (mhindx.eq.11) then
            val1=A210_hnn_112_btag_nulnul_cc(x)
            val2=A210_hnn_113_btag_nulnul_cc(x)
         elseif (mhindx.eq.12) then
            val1=A210_hnn_113_btag_nulnul_cc(x)
            val2=A210_hnn_114_btag_nulnul_cc(x)
         elseif (mhindx.eq.13) then
            val1=A210_hnn_114_btag_nulnul_cc(x)
            val2=A210_hnn_115_btag_nulnul_cc(x)
         elseif (mhindx.eq.14) then
            val1=A210_hnn_115_btag_nulnul_cc(x)
            val2=A210_hnn_116_btag_nulnul_cc(x)
         elseif (mhindx.eq.15) then
            val1=A210_hnn_116_btag_nulnul_cc(x)
            val2=A210_hnn_117_btag_nulnul_cc(x)
         elseif (mhindx.eq.16) then
            val1=A210_hnn_117_btag_nulnul_cc(x)
            val2=A210_hnn_118_btag_nulnul_cc(x)
         elseif (mhindx.eq.17) then
            val1=A210_hnn_118_btag_nulnul_cc(x)
            val2=A210_hnn_1188_btag_nulnul_cc(x)
         elseif (mhindx.eq.18) then
            val1=A210_hnn_1188_btag_nulnul_cc(x)
            val2=A210_hnn_120_btag_nulnul_cc(x)
         elseif (mhindx.eq.nummass) then
            val1=A210_hnn_120_btag_nulnul_cc(x)
            val2=A210_hnn_120_btag_nulnul_cc(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         endif
      elseif (isig.eq.4) then
         if (mhindx.eq.0) then
            val1=A2000_hnn_75_btag_nulnul_gg(x)
            val2=A2000_hnn_75_btag_nulnul_gg(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         elseif (mhindx.eq.1) then
            val1=A2000_hnn_75_btag_nulnul_gg(x)
            val2=A2000_hnn_80_btag_nulnul_gg(x)
         elseif (mhindx.eq.2) then
            val1=A2000_hnn_80_btag_nulnul_gg(x)
            val2=A2000_hnn_85_btag_nulnul_gg(x)
         elseif (mhindx.eq.3) then
            val1=A2000_hnn_85_btag_nulnul_gg(x)
            val2=A2000_hnn_90_btag_nulnul_gg(x)
         elseif (mhindx.eq.4) then
            val1=A2000_hnn_90_btag_nulnul_gg(x)
            val2=A2000_hnn_95_btag_nulnul_gg(x)
         elseif (mhindx.eq.5) then
            val1=A2000_hnn_95_btag_nulnul_gg(x)
            val2=A210_hnn_100_btag_nulnul_gg(x)
         elseif (mhindx.eq.6) then
            val1=A210_hnn_100_btag_nulnul_gg(x)
            val2=A210_hnn_104_btag_nulnul_gg(x)
         elseif (mhindx.eq.7) then
            val1=A210_hnn_104_btag_nulnul_gg(x)
            val2=A210_hnn_106_btag_nulnul_gg(x)
         elseif (mhindx.eq.8) then
            val1=A210_hnn_106_btag_nulnul_gg(x)
            val2=A210_hnn_108_btag_nulnul_gg(x)
         elseif (mhindx.eq.9) then
            val1=A210_hnn_108_btag_nulnul_gg(x)
            val2=A210_hnn_110_btag_nulnul_gg(x)
         elseif (mhindx.eq.10) then
            val1=A210_hnn_110_btag_nulnul_gg(x)
            val2=A210_hnn_112_btag_nulnul_gg(x)
         elseif (mhindx.eq.11) then
            val1=A210_hnn_112_btag_nulnul_gg(x)
            val2=A210_hnn_113_btag_nulnul_gg(x)
         elseif (mhindx.eq.12) then
            val1=A210_hnn_113_btag_nulnul_gg(x)
            val2=A210_hnn_114_btag_nulnul_gg(x)
         elseif (mhindx.eq.13) then
            val1=A210_hnn_114_btag_nulnul_gg(x)
            val2=A210_hnn_115_btag_nulnul_gg(x)
         elseif (mhindx.eq.14) then
            val1=A210_hnn_115_btag_nulnul_gg(x)
            val2=A210_hnn_116_btag_nulnul_gg(x)
         elseif (mhindx.eq.15) then
            val1=A210_hnn_116_btag_nulnul_gg(x)
            val2=A210_hnn_117_btag_nulnul_gg(x)
         elseif (mhindx.eq.16) then
            val1=A210_hnn_117_btag_nulnul_gg(x)
            val2=A210_hnn_118_btag_nulnul_gg(x)
         elseif (mhindx.eq.17) then
            val1=A210_hnn_118_btag_nulnul_gg(x)
            val2=A210_hnn_1188_btag_nulnul_gg(x)
         elseif (mhindx.eq.18) then
            val1=A210_hnn_1188_btag_nulnul_gg(x)
            val2=A210_hnn_120_btag_nulnul_gg(x)
         elseif (mhindx.eq.nummass) then
            val1=A210_hnn_120_btag_nulnul_gg(x)
            val2=A210_hnn_120_btag_nulnul_gg(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         endif
      elseif (isig.eq.5.or.isig.eq.2) then
         if (mhindx.eq.0) then
            val1=A2000_hnn_75_btag_nulnul_cc(x)
            val2=A2000_hnn_75_btag_nulnul_cc(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         elseif (mhindx.eq.1) then
            val1=A2000_hnn_75_btag_nulnul_cc(x)
            val2=A2000_hnn_80_btag_nulnul_cc(x)
         elseif (mhindx.eq.2) then
            val1=A2000_hnn_80_btag_nulnul_cc(x)
            val2=A2000_hnn_85_btag_nulnul_cc(x)
         elseif (mhindx.eq.3) then
            val1=A2000_hnn_85_btag_nulnul_cc(x)
            val2=A2000_hnn_90_btag_nulnul_cc(x)
         elseif (mhindx.eq.4) then
            val1=A2000_hnn_90_btag_nulnul_cc(x)
            val2=A2000_hnn_95_btag_nulnul_cc(x)
         elseif (mhindx.eq.5) then
            val1=A2000_hnn_95_btag_nulnul_cc(x)
            val2=A210_hnn_100_btag_nulnul_ww(x)
         elseif (mhindx.eq.6) then
            val1=A210_hnn_100_btag_nulnul_ww(x)
            val2=A210_hnn_104_btag_nulnul_ww(x)
         elseif (mhindx.eq.7) then
            val1=A210_hnn_104_btag_nulnul_ww(x)
            val2=A210_hnn_106_btag_nulnul_ww(x)
         elseif (mhindx.eq.8) then
            val1=A210_hnn_106_btag_nulnul_ww(x)
            val2=A210_hnn_108_btag_nulnul_ww(x)
         elseif (mhindx.eq.9) then
            val1=A210_hnn_108_btag_nulnul_ww(x)
            val2=A210_hnn_110_btag_nulnul_ww(x)
         elseif (mhindx.eq.10) then
            val1=A210_hnn_110_btag_nulnul_ww(x)
            val2=A210_hnn_112_btag_nulnul_ww(x)
         elseif (mhindx.eq.11) then
            val1=A210_hnn_112_btag_nulnul_ww(x)
            val2=A210_hnn_113_btag_nulnul_ww(x)
         elseif (mhindx.eq.12) then
            val1=A210_hnn_113_btag_nulnul_ww(x)
            val2=A210_hnn_114_btag_nulnul_ww(x)
         elseif (mhindx.eq.13) then
            val1=A210_hnn_114_btag_nulnul_ww(x)
            val2=A210_hnn_115_btag_nulnul_ww(x)
         elseif (mhindx.eq.14) then
            val1=A210_hnn_115_btag_nulnul_ww(x)
            val2=A210_hnn_116_btag_nulnul_ww(x)
         elseif (mhindx.eq.15) then
            val1=A210_hnn_116_btag_nulnul_ww(x)
            val2=A210_hnn_117_btag_nulnul_ww(x)
         elseif (mhindx.eq.16) then
            val1=A210_hnn_117_btag_nulnul_ww(x)
            val2=A210_hnn_118_btag_nulnul_ww(x)
         elseif (mhindx.eq.17) then
            val1=A210_hnn_118_btag_nulnul_ww(x)
            val2=A210_hnn_1188_btag_nulnul_ww(x)
         elseif (mhindx.eq.18) then
            val1=A210_hnn_1188_btag_nulnul_ww(x)
            val2=A210_hnn_120_btag_nulnul_ww(x)
         elseif (mhindx.eq.nummass) then
            val1=A210_hnn_120_btag_nulnul_ww(x)
            val2=A210_hnn_120_btag_nulnul_ww(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         endif
      elseif (isig.eq.6) then
         if (mhindx.eq.0) then
            val1=A2000_hnn_75_btag_nuenue_bb(x)
            val2=A2000_hnn_75_btag_nuenue_bb(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         elseif (mhindx.eq.1) then
            val1=A2000_hnn_75_btag_nuenue_bb(x)
            val2=A2000_hnn_80_btag_nuenue_bb(x)
         elseif (mhindx.eq.2) then
            val1=A2000_hnn_80_btag_nuenue_bb(x)
            val2=A2000_hnn_85_btag_nuenue_bb(x)
         elseif (mhindx.eq.3) then
            val1=A2000_hnn_85_btag_nuenue_bb(x)
            val2=A2000_hnn_90_btag_nuenue_bb(x)
         elseif (mhindx.eq.4) then
            val1=A2000_hnn_90_btag_nuenue_bb(x)
            val2=A2000_hnn_95_btag_nuenue_bb(x)
         elseif (mhindx.eq.5) then
            val1=A2000_hnn_95_btag_nuenue_bb(x)
            val2=A210_hnn_100_btag_nuenue_bb(x)
         elseif (mhindx.eq.6) then
            val1=A210_hnn_100_btag_nuenue_bb(x)
            val2=A210_hnn_104_btag_nuenue_bb(x)
         elseif (mhindx.eq.7) then
            val1=A210_hnn_104_btag_nuenue_bb(x)
            val2=A210_hnn_106_btag_nuenue_bb(x)
         elseif (mhindx.eq.8) then
            val1=A210_hnn_106_btag_nuenue_bb(x)
            val2=A210_hnn_108_btag_nuenue_bb(x)
         elseif (mhindx.eq.9) then
            val1=A210_hnn_108_btag_nuenue_bb(x)
            val2=A210_hnn_110_btag_nuenue_bb(x)
         elseif (mhindx.eq.10) then
            val1=A210_hnn_110_btag_nuenue_bb(x)
            val2=A210_hnn_112_btag_nuenue_bb(x)
         elseif (mhindx.eq.11) then
            val1=A210_hnn_112_btag_nuenue_bb(x)
            val2=A210_hnn_113_btag_nuenue_bb(x)
         elseif (mhindx.eq.12) then
            val1=A210_hnn_113_btag_nuenue_bb(x)
            val2=A210_hnn_114_btag_nuenue_bb(x)
         elseif (mhindx.eq.13) then
            val1=A210_hnn_114_btag_nuenue_bb(x)
            val2=A210_hnn_115_btag_nuenue_bb(x)
         elseif (mhindx.eq.14) then
            val1=A210_hnn_115_btag_nuenue_bb(x)
            val2=A210_hnn_116_btag_nuenue_bb(x)
         elseif (mhindx.eq.15) then
            val1=A210_hnn_116_btag_nuenue_bb(x)
            val2=A210_hnn_117_btag_nuenue_bb(x)
         elseif (mhindx.eq.16) then
            val1=A210_hnn_117_btag_nuenue_bb(x)
            val2=A210_hnn_118_btag_nuenue_bb(x)
         elseif (mhindx.eq.17) then
            val1=A210_hnn_118_btag_nuenue_bb(x)
            val2=A210_hnn_1188_btag_nuenue_bb(x)
         elseif (mhindx.eq.18) then
            val1=A210_hnn_1188_btag_nuenue_bb(x)
            val2=A210_hnn_120_btag_nuenue_bb(x)
         elseif (mhindx.eq.nummass) then
            val1=A210_hnn_120_btag_nuenue_bb(x)
            val2=A210_hnn_120_btag_nuenue_bb(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         endif
      elseif (isig.eq.8) then
         if (mhindx.eq.0) then
            val1=A2000_hnn_75_btag_nuenue_cc(x)
            val2=A2000_hnn_75_btag_nuenue_cc(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         elseif (mhindx.eq.1) then
            val1=A2000_hnn_75_btag_nuenue_cc(x)
            val2=A2000_hnn_80_btag_nuenue_cc(x)
         elseif (mhindx.eq.2) then
            val1=A2000_hnn_80_btag_nuenue_cc(x)
            val2=A2000_hnn_85_btag_nuenue_cc(x)
         elseif (mhindx.eq.3) then
            val1=A2000_hnn_85_btag_nuenue_cc(x)
            val2=A2000_hnn_90_btag_nuenue_cc(x)
         elseif (mhindx.eq.4) then
            val1=A2000_hnn_90_btag_nuenue_cc(x)
            val2=A2000_hnn_95_btag_nuenue_cc(x)
         elseif (mhindx.eq.5) then
            val1=A2000_hnn_95_btag_nuenue_cc(x)
            val2=A210_hnn_100_btag_nuenue_cc(x)
         elseif (mhindx.eq.6) then
            val1=A210_hnn_100_btag_nuenue_cc(x)
            val2=A210_hnn_104_btag_nuenue_cc(x)
         elseif (mhindx.eq.7) then
            val1=A210_hnn_104_btag_nuenue_cc(x)
            val2=A210_hnn_106_btag_nuenue_cc(x)
         elseif (mhindx.eq.8) then
            val1=A210_hnn_106_btag_nuenue_cc(x)
            val2=A210_hnn_108_btag_nuenue_cc(x)
         elseif (mhindx.eq.9) then
            val1=A210_hnn_108_btag_nuenue_cc(x)
            val2=A210_hnn_110_btag_nuenue_cc(x)
         elseif (mhindx.eq.10) then
            val1=A210_hnn_110_btag_nuenue_cc(x)
            val2=A210_hnn_112_btag_nuenue_cc(x)
         elseif (mhindx.eq.11) then
            val1=A210_hnn_112_btag_nuenue_cc(x)
            val2=A210_hnn_113_btag_nuenue_cc(x)
         elseif (mhindx.eq.12) then
            val1=A210_hnn_113_btag_nuenue_cc(x)
            val2=A210_hnn_114_btag_nuenue_cc(x)
         elseif (mhindx.eq.13) then
            val1=A210_hnn_114_btag_nuenue_cc(x)
            val2=A210_hnn_115_btag_nuenue_cc(x)
         elseif (mhindx.eq.14) then
            val1=A210_hnn_115_btag_nuenue_cc(x)
            val2=A210_hnn_116_btag_nuenue_cc(x)
         elseif (mhindx.eq.15) then
            val1=A210_hnn_116_btag_nuenue_cc(x)
            val2=A210_hnn_117_btag_nuenue_cc(x)
         elseif (mhindx.eq.16) then
            val1=A210_hnn_117_btag_nuenue_cc(x)
            val2=A210_hnn_118_btag_nuenue_cc(x)
         elseif (mhindx.eq.17) then
            val1=A210_hnn_118_btag_nuenue_cc(x)
            val2=A210_hnn_1188_btag_nuenue_cc(x)
         elseif (mhindx.eq.18) then
            val1=A210_hnn_1188_btag_nuenue_cc(x)
            val2=A210_hnn_120_btag_nuenue_cc(x)
         elseif (mhindx.eq.nummass) then
            val1=A210_hnn_120_btag_nuenue_cc(x)
            val2=A210_hnn_120_btag_nuenue_cc(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         endif
      elseif (isig.eq.9) then
         if (mhindx.eq.0) then
            val1=A2000_hnn_75_btag_nuenue_gg(x)
            val2=A2000_hnn_75_btag_nuenue_gg(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         elseif (mhindx.eq.1) then
            val1=A2000_hnn_75_btag_nuenue_gg(x)
            val2=A2000_hnn_80_btag_nuenue_gg(x)
         elseif (mhindx.eq.2) then
            val1=A2000_hnn_80_btag_nuenue_gg(x)
            val2=A2000_hnn_85_btag_nuenue_gg(x)
         elseif (mhindx.eq.3) then
            val1=A2000_hnn_85_btag_nuenue_gg(x)
            val2=A2000_hnn_90_btag_nuenue_gg(x)
         elseif (mhindx.eq.4) then
            val1=A2000_hnn_90_btag_nuenue_gg(x)
            val2=A2000_hnn_95_btag_nuenue_gg(x)
         elseif (mhindx.eq.5) then
            val1=A2000_hnn_95_btag_nuenue_gg(x)
            val2=A210_hnn_100_btag_nuenue_gg(x)
         elseif (mhindx.eq.6) then
            val1=A210_hnn_100_btag_nuenue_gg(x)
            val2=A210_hnn_104_btag_nuenue_gg(x)
         elseif (mhindx.eq.7) then
            val1=A210_hnn_104_btag_nuenue_gg(x)
            val2=A210_hnn_106_btag_nuenue_gg(x)
         elseif (mhindx.eq.8) then
            val1=A210_hnn_106_btag_nuenue_gg(x)
            val2=A210_hnn_108_btag_nuenue_gg(x)
         elseif (mhindx.eq.9) then
            val1=A210_hnn_108_btag_nuenue_gg(x)
            val2=A210_hnn_110_btag_nuenue_gg(x)
         elseif (mhindx.eq.10) then
            val1=A210_hnn_110_btag_nuenue_gg(x)
            val2=A210_hnn_112_btag_nuenue_gg(x)
         elseif (mhindx.eq.11) then
            val1=A210_hnn_112_btag_nuenue_gg(x)
            val2=A210_hnn_113_btag_nuenue_gg(x)
         elseif (mhindx.eq.12) then
            val1=A210_hnn_113_btag_nuenue_gg(x)
            val2=A210_hnn_114_btag_nuenue_gg(x)
         elseif (mhindx.eq.13) then
            val1=A210_hnn_114_btag_nuenue_gg(x)
            val2=A210_hnn_115_btag_nuenue_gg(x)
         elseif (mhindx.eq.14) then
            val1=A210_hnn_115_btag_nuenue_gg(x)
            val2=A210_hnn_116_btag_nuenue_gg(x)
         elseif (mhindx.eq.15) then
            val1=A210_hnn_116_btag_nuenue_gg(x)
            val2=A210_hnn_117_btag_nuenue_gg(x)
         elseif (mhindx.eq.16) then
            val1=A210_hnn_117_btag_nuenue_gg(x)
            val2=A210_hnn_118_btag_nuenue_gg(x)
         elseif (mhindx.eq.17) then
            val1=A210_hnn_118_btag_nuenue_gg(x)
            val2=A210_hnn_1188_btag_nuenue_gg(x)
         elseif (mhindx.eq.18) then
            val1=A210_hnn_1188_btag_nuenue_gg(x)
            val2=A210_hnn_120_btag_nuenue_gg(x)
         elseif (mhindx.eq.nummass) then
            val1=A210_hnn_120_btag_nuenue_gg(x)
            val2=A210_hnn_120_btag_nuenue_gg(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         endif
      elseif (isig.eq.10.or.isig.eq.7) then
         if (mhindx.eq.0) then
            val1=A2000_hnn_75_btag_nuenue_cc(x)
            val2=A2000_hnn_75_btag_nuenue_cc(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         elseif (mhindx.eq.1) then
            val1=A2000_hnn_75_btag_nuenue_cc(x)
            val2=A2000_hnn_80_btag_nuenue_cc(x)
         elseif (mhindx.eq.2) then
            val1=A2000_hnn_80_btag_nuenue_cc(x)
            val2=A2000_hnn_85_btag_nuenue_cc(x)
         elseif (mhindx.eq.3) then
            val1=A2000_hnn_85_btag_nuenue_cc(x)
            val2=A2000_hnn_90_btag_nuenue_cc(x)
         elseif (mhindx.eq.4) then
            val1=A2000_hnn_90_btag_nuenue_cc(x)
            val2=A2000_hnn_95_btag_nuenue_cc(x)
         elseif (mhindx.eq.5) then
            val1=A2000_hnn_95_btag_nuenue_cc(x)
            val2=A210_hnn_100_btag_nuenue_ww(x)
         elseif (mhindx.eq.6) then
            val1=A210_hnn_100_btag_nuenue_ww(x)
            val2=A210_hnn_104_btag_nuenue_ww(x)
         elseif (mhindx.eq.7) then
            val1=A210_hnn_104_btag_nuenue_ww(x)
            val2=A210_hnn_106_btag_nuenue_ww(x)
         elseif (mhindx.eq.8) then
            val1=A210_hnn_106_btag_nuenue_ww(x)
            val2=A210_hnn_108_btag_nuenue_ww(x)
         elseif (mhindx.eq.9) then
            val1=A210_hnn_108_btag_nuenue_ww(x)
            val2=A210_hnn_110_btag_nuenue_ww(x)
         elseif (mhindx.eq.10) then
            val1=A210_hnn_110_btag_nuenue_ww(x)
            val2=A210_hnn_112_btag_nuenue_ww(x)
         elseif (mhindx.eq.11) then
            val1=A210_hnn_112_btag_nuenue_ww(x)
            val2=A210_hnn_113_btag_nuenue_ww(x)
         elseif (mhindx.eq.12) then
            val1=A210_hnn_113_btag_nuenue_ww(x)
            val2=A210_hnn_114_btag_nuenue_ww(x)
         elseif (mhindx.eq.13) then
            val1=A210_hnn_114_btag_nuenue_ww(x)
            val2=A210_hnn_115_btag_nuenue_ww(x)
         elseif (mhindx.eq.14) then
            val1=A210_hnn_115_btag_nuenue_ww(x)
            val2=A210_hnn_116_btag_nuenue_ww(x)
         elseif (mhindx.eq.15) then
            val1=A210_hnn_116_btag_nuenue_ww(x)
            val2=A210_hnn_117_btag_nuenue_ww(x)
         elseif (mhindx.eq.16) then
            val1=A210_hnn_117_btag_nuenue_ww(x)
            val2=A210_hnn_118_btag_nuenue_ww(x)
         elseif (mhindx.eq.17) then
            val1=A210_hnn_118_btag_nuenue_ww(x)
            val2=A210_hnn_1188_btag_nuenue_ww(x)
         elseif (mhindx.eq.18) then
            val1=A210_hnn_1188_btag_nuenue_ww(x)
            val2=A210_hnn_120_btag_nuenue_ww(x)
         elseif (mhindx.eq.nummass) then
            val1=A210_hnn_120_btag_nuenue_ww(x)
            val2=A210_hnn_120_btag_nulnul_ww(x)
            w1=1.d0
            w2=1.d0
            mhdif=2.d0
         endif

      else
         val1=0.d0
         val2=0.d0
         w1=1.d0
         w2=1.d0
         mhdif=1.d0
      endif
      A2000_210_nn_btag_sig=(val1*w1+val2*w2)/mhdif
      end










      double precision function A2000_nn_mrec_bkg(ecm,ibkg,x)
      implicit none
      real*8 ecm,x
      integer ibkg
      integer i,j, ecmindx,numecm
      parameter (numecm=9)
      
      real*8 a2000_hnn_qq_mrec, a200_hnn_ww_mrec, a202_hnn_ww_mrec, 
     &     a204_hnn_ww_mrec, a205_hnn_ww_mrec, a206_hnn_ww_mrec, 
     &     a207_hnn_ww_mrec, a208_hnn_ww_mrec,A200_hnn_ewnu_mrec,
     &     A202_hnn_ewnu_mrec,A204_hnn_ewnu_mrec,A206_hnn_ewnu_mrec,
     &     A208_hnn_ewnu_mrec,A200_hnn_zz_mrec,
     &     A202_hnn_zz_mrec,A204_hnn_zz_mrec,A206_hnn_zz_mrec,
     &     A208_hnn_zz_mrec,A200_hnn_znn_mrec,
     &     A202_hnn_znn_mrec,A204_hnn_znn_mrec,A206_hnn_znn_mrec,
     &     A208_hnn_znn_mrec,
     &     A207_hnn_ewnu_mrec,A205_hnn_ewnu_mrec,A205_hnn_zz_mrec,
     &     A207_hnn_zz_mrec,A205_hnn_znn_mrec,A207_hnn_znn_mrec,
     &     A209_hnn_ww_mrec, A209_hnn_ewnu_mrec, A209_hnn_zz_mrec,
     &     A209_hnn_znn_mrec, A210_hnn_ww_mrec, A210_hnn_ewnu_mrec,
     &     A210_hnn_zz_mrec, A210_hnn_znn_mrec
      external a2000_hnn_qq_mrec, a200_hnn_ww_mrec, a202_hnn_ww_mrec, 
     &     a204_hnn_ww_mrec, a205_hnn_ww_mrec, a206_hnn_ww_mrec, 
     &     a207_hnn_ww_mrec, a208_hnn_ww_mrec,A200_hnn_ewnu_mrec,
     &     A202_hnn_ewnu_mrec,A204_hnn_ewnu_mrec,A206_hnn_ewnu_mrec,
     &     A208_hnn_ewnu_mrec,A200_hnn_zz_mrec,
     &     A202_hnn_zz_mrec,A204_hnn_zz_mrec,A206_hnn_zz_mrec,
     &     A208_hnn_zz_mrec,A200_hnn_znn_mrec,
     &     A202_hnn_znn_mrec,A204_hnn_znn_mrec,A206_hnn_znn_mrec,
     &     A208_hnn_znn_mrec,
     &     A207_hnn_ewnu_mrec,A205_hnn_ewnu_mrec,A205_hnn_zz_mrec,
     &     A207_hnn_zz_mrec,A205_hnn_znn_mrec,A207_hnn_znn_mrec,
     &     A209_hnn_ww_mrec, A209_hnn_ewnu_mrec, A209_hnn_zz_mrec,
     &     A209_hnn_znn_mrec, A210_hnn_ww_mrec, A210_hnn_ewnu_mrec,
     &     A210_hnn_zz_mrec, A210_hnn_znn_mrec
      real*8 wwecm(numecm),w1,w2,val1,val2,wdif,sh1,sh2
      real*8 bkgecm(numecm)
      data wwecm/200.d0,202.d0,204.d0,205.d0,206.d0,207.d0,208.d0,
     &     209.d0,210.d0/
      data bkgecm/199.5d0,201.6d0,204.d0,205.d0,206.d0,207.d0,208.d0,
     &     209.d0,210.d0/
      ecmindx=0
      if (ibkg.lt.6) then
         a2000_nn_mrec_bkg=a2000_hnn_qq_mrec(x-ecm+200.d0)
      elseif (ibkg.eq.6.or.ibkg.eq.7) then
         do i = 1, numecm
            if (wwecm(i).lt.ecm) then
               ecmindx=i
            endif
         enddo
         
         if (ibkg.eq.6) then
            if (ecmindx.eq.0) then
               val1=A200_hnn_ww_mrec(x-ecm+200.d0)
               val2=A200_hnn_ww_mrec(x-ecm+200.d0)
               w1=1.d0
               w2=1.d0
               wdif=2.d0
            elseif(ecmindx.eq.numecm) then
               val1=a210_hnn_ww_mrec(x-ecm+210.d0)
               val2=a210_hnn_ww_mrec(x-ecm+210.d0)
               w1=1.d0
               w2=1.d0
               wdif=2.d0
            else
               w1=wwecm(ecmindx+1)-ecm
               w2=ecm-wwecm(ecmindx)
               wdif=w1+w2
               sh1=x-ecm+wwecm(ecmindx)
               sh2=x-ecm+wwecm(ecmindx+1)
               if (ecmindx.eq.1) then
                  val1=a200_hnn_ww_mrec(sh1)
                  val2=A202_hnn_ww_mrec(sh2)
               elseif (ecmindx.eq.2) then
                  val1=a202_hnn_ww_mrec(sh1)
                  val2=a204_hnn_ww_mrec(sh2)
               elseif (ecmindx.eq.3) then
                  val1=a204_hnn_ww_mrec(sh1)
                  val2=a205_hnn_ww_mrec(sh2)
               elseif (ecmindx.eq.4) then
                  val1=a205_hnn_ww_mrec(sh1)
                  val2=a206_hnn_ww_mrec(sh2)
               elseif (ecmindx.eq.5) then
                  val1=a206_hnn_ww_mrec(sh1)
                  val2=a207_hnn_ww_mrec(sh2)
               elseif (ecmindx.eq.6) then
                  val1=a207_hnn_ww_mrec(sh1)
                  val2=a208_hnn_ww_mrec(sh2)
               elseif (ecmindx.eq.7) then
                  val1=a208_hnn_ww_mrec(sh1)
                  val2=a209_hnn_ww_mrec(sh2)
               elseif (ecmindx.eq.8) then
                  val1=a209_hnn_ww_mrec(sh1)
                  val2=a210_hnn_ww_mrec(sh2)
               else
                  val1=0.d0
                  val2=0.d0
               endif
            endif
            a2000_nn_mrec_bkg=(val1*w1+val2*w2)/wdif
         else
            if (ecmindx.eq.0) then
               val1=a200_hnn_ewnu_mrec(x-ecm+200.d0)
               val2=a200_hnn_ewnu_mrec(x-ecm+200.d0)
               w1=1.d0
               w2=1.d0
               wdif=2.d0
            elseif(ecmindx.eq.numecm) then
               val1=a210_hnn_ewnu_mrec(x-ecm+210.d0)
               val2=a210_hnn_ewnu_mrec(x-ecm+210.d0)
               w1=1.d0
               w2=1.d0
               wdif=2.d0
            else
               w1=wwecm(ecmindx+1)-ecm
               w2=ecm-wwecm(ecmindx)
               wdif=w1+w2
               sh1=x-ecm+wwecm(ecmindx)
               sh2=x-ecm+wwecm(ecmindx+1)
               if (ecmindx.eq.1) then
                  val1=a200_hnn_ewnu_mrec(sh1)
                  val2=A202_hnn_ewnu_mrec(sh2)
               elseif (ecmindx.eq.2) then
                  val1=a202_hnn_ewnu_mrec(sh1)
                  val2=a204_hnn_ewnu_mrec(sh2)
               elseif (ecmindx.eq.3) then
                  val1=a204_hnn_ewnu_mrec(sh1)
                  val2=a205_hnn_ewnu_mrec(sh2)
               elseif (ecmindx.eq.4) then
                  val1=a205_hnn_ewnu_mrec(sh1)
                  val2=a206_hnn_ewnu_mrec(sh2)
               elseif (ecmindx.eq.5) then
                  val1=a206_hnn_ewnu_mrec(sh1)
                  val2=a207_hnn_ewnu_mrec(sh2)
               elseif (ecmindx.eq.6) then
                  val1=a207_hnn_ewnu_mrec(sh1)
                  val2=a208_hnn_ewnu_mrec(sh2)
               elseif (ecmindx.eq.7) then
                  val1=a208_hnn_ewnu_mrec(sh1)
                  val2=a209_hnn_ewnu_mrec(sh2)
               elseif (ecmindx.eq.8) then
                  val1=a209_hnn_ewnu_mrec(sh1)
                  val2=a210_hnn_ewnu_mrec(sh2)
               else
                  val1=0.d0
                  val2=0.d0
               endif
            endif
            A2000_nn_mrec_bkg=(val1*w1+val2*w2)/wdif
         endif
      elseif(ibkg.eq.8.or.ibkg.eq.9) then
         do i = 1, numecm
            if (bkgecm(i).lt.ecm) then
               ecmindx=i
            endif
         enddo
         
         if (ecmindx.eq.0) then
            val1=A200_hnn_zz_mrec(x-ecm+200.d0)
            val2=A200_hnn_zz_mrec(x-ecm+200.d0)
            w1=1.d0
            w2=1.d0
            wdif=2.d0
         elseif(ecmindx.eq.numecm) then
            val1=a210_hnn_zz_mrec(x-ecm+210.d0)
            val2=a210_hnn_zz_mrec(x-ecm+210.d0)
            w1=1.d0
            w2=1.d0
            wdif=2.d0
         else
            w1=bkgecm(ecmindx+1)-ecm
            w2=ecm-bkgecm(ecmindx)
            wdif=w1+w2
            sh1=x-ecm+bkgecm(ecmindx)
            sh2=x-ecm+bkgecm(ecmindx+1)
            if (ecmindx.eq.1) then
               val1=a200_hnn_zz_mrec(sh1)
               val2=A202_hnn_zz_mrec(sh2)
            elseif (ecmindx.eq.2) then
               val1=a202_hnn_zz_mrec(sh1)
               val2=a204_hnn_zz_mrec(sh2)
            elseif (ecmindx.eq.3) then
               val1=a204_hnn_zz_mrec(sh1)
               val2=a205_hnn_zz_mrec(sh2)
            elseif (ecmindx.eq.4) then
               val1=a205_hnn_zz_mrec(sh1)
               val2=a206_hnn_zz_mrec(sh2)
            elseif (ecmindx.eq.5) then
               val1=a206_hnn_zz_mrec(sh1)
               val2=a207_hnn_zz_mrec(sh2)
            elseif (ecmindx.eq.6) then
               val1=a207_hnn_zz_mrec(sh1)
               val2=a208_hnn_zz_mrec(sh2)
            elseif (ecmindx.eq.7) then
               val1=a208_hnn_zz_mrec(sh1)
               val2=a209_hnn_zz_mrec(sh2)
            elseif (ecmindx.eq.8) then
               val1=a209_hnn_zz_mrec(sh1)
               val2=a210_hnn_zz_mrec(sh2)
            else
               val1=0.d0
               val2=0.d0
            endif
         endif
         a2000_nn_mrec_bkg=(val1*w1+val2*w2)/wdif
         
         
      elseif(ibkg.eq.10) then
         do i = 1, numecm
            if (bkgecm(i).lt.ecm) then
               ecmindx=i
            endif
         enddo
         
         if (ecmindx.eq.0) then
            val1=A200_hnn_znn_mrec(x-ecm+200.d0)
            val2=A200_hnn_znn_mrec(x-ecm+200.d0)
            w1=1.d0
            w2=1.d0
            wdif=2.d0
         elseif(ecmindx.eq.numecm) then
            val1=a210_hnn_znn_mrec(x-ecm+210.d0)
            val2=a210_hnn_znn_mrec(x-ecm+210.d0)
            w1=1.d0
            w2=1.d0
            wdif=2.d0
         else
            w1=bkgecm(ecmindx+1)-ecm
            w2=ecm-bkgecm(ecmindx)
            wdif=w1+w2
            sh1=x-ecm+bkgecm(ecmindx)
            sh2=x-ecm+bkgecm(ecmindx+1)
            if (ecmindx.eq.1) then
               val1=a200_hnn_znn_mrec(sh1)
               val2=A202_hnn_znn_mrec(sh2)
            elseif (ecmindx.eq.2) then
               val1=a202_hnn_znn_mrec(sh1)
               val2=a204_hnn_znn_mrec(sh2)
            elseif (ecmindx.eq.3) then
               val1=a204_hnn_znn_mrec(sh1)
               val2=a205_hnn_znn_mrec(sh2)
            elseif (ecmindx.eq.4) then
               val1=a205_hnn_znn_mrec(sh1)
               val2=a206_hnn_znn_mrec(sh2)
            elseif (ecmindx.eq.5) then
               val1=a206_hnn_znn_mrec(sh1)
               val2=a207_hnn_znn_mrec(sh2)
            elseif (ecmindx.eq.6) then
               val1=a207_hnn_znn_mrec(sh1)
               val2=a208_hnn_znn_mrec(sh2)
            elseif (ecmindx.eq.7) then
               val1=a208_hnn_znn_mrec(sh1)
               val2=a209_hnn_znn_mrec(sh2)
            elseif (ecmindx.eq.8) then
               val1=a209_hnn_znn_mrec(sh1)
               val2=a210_hnn_znn_mrec(sh2)
            else
               val1=0.d0
               val2=0.d0
            endif
         endif
         a2000_nn_mrec_bkg=(val1*w1+val2*w2)/wdif
      endif
      if(ecm.lt.198.d0.or.ecm.gt.210.d0) 
     &     a2000_nn_mrec_bkg=1.d0
      end





      double precision function A2000_nn_mrec_sig(ecm,isig,hmass,x)
      implicit none
      real*8 ecm,x,hmass,ecmdif,ecmw1,ecmw2,sh1,sh2,hmsh1,hmsh2
      integer isig,i,j
      real*8 A2000_1995_nn_mrec_sig,A2000_2016_nn_mrec_sig,
     & A2000_204_nn_mrec_sig,A2000_206_nn_mrec_sig,
     & A2000_208_nn_mrec_sig,A2000_210_nn_mrec_sig
      external A2000_1995_nn_mrec_sig,A2000_2016_nn_mrec_sig,
     & A2000_204_nn_mrec_sig,A2000_206_nn_mrec_sig,
     & A2000_208_nn_mrec_sig,A2000_210_nn_mrec_sig
      integer numecm,ecmindx
      parameter (numecm=6)
      real*8 sigecm(numecm)
      data sigecm /199.5,201.6,204.,206.,208.,210./
      ecmindx=0
      do i=1,numecm
         if (sigecm(i).lt.ecm) then
            ecmindx =i
         endif
      enddo
      if(ecmindx.gt.0.and.ecmindx.lt.numecm) then
         ecmdif=sigecm(ecmindx+1)-sigecm(ecmindx)
         ecmw1=sigecm(ecmindx+1)-ecm
         ecmw2=ecm-sigecm(ecmindx)
         sh1=x-ecm+sigecm(ecmindx)
         sh2=x-ecm+sigecm(ecmindx+1)
         hmsh1=hmass-ecm+sigecm(ecmindx)
         hmsh2=hmass-ecm+sigecm(ecmindx+1)
      elseif(ecmindx.eq.0) then
         ecmdif=1.d0
         A2000_nn_mrec_sig=A2000_1995_nn_mrec_sig
     &        (x-ecm+199.5d0,hmass-ecm+199.5d0,isig)
      elseif(ecmindx.eq.numecm) then
         ecmdif=1.d0
         A2000_nn_mrec_sig=a2000_210_nn_mrec_sig
     &        (x-ecm+210.d0,hmass-ecm+210.d0,isig)
      else
         A2000_nn_mrec_sig=0.d0
      endif
      if (ecmindx.eq.1) then
         A2000_nn_mrec_sig=(a2000_1995_nn_mrec_sig
     &        (sh1,hmsh1,isig)*ecmw1
     &        +A2000_2016_nn_mrec_sig(sh2,hmsh2,isig)*ecmw2)/ecmdif
      elseif(ecmindx.eq.2) then
         A2000_nn_mrec_sig=(a2000_2016_nn_mrec_sig
     &        (sh1,hmsh1,isig)*ecmw1
     &        +A2000_204_nn_mrec_sig(sh2,hmsh2,isig)*ecmw2)/ecmdif
      elseif(ecmindx.eq.3) then
         A2000_nn_mrec_sig=(a2000_204_nn_mrec_sig
     &        (sh1,hmsh1,isig)*ecmw1
     &        +A2000_206_nn_mrec_sig(sh2,hmsh2,isig)*ecmw2)/ecmdif
      elseif(ecmindx.eq.4) then
         A2000_nn_mrec_sig=(a2000_206_nn_mrec_sig
     &        (sh1,hmsh1,isig)*ecmw1
     &        +A2000_208_nn_mrec_sig(sh2,hmsh2,isig)*ecmw2)/ecmdif
      elseif(ecmindx.eq.5) then
         A2000_nn_mrec_sig=(a2000_208_nn_mrec_sig
     &        (sh1,hmsh1,isig)*ecmw1
     &        +A2000_210_nn_mrec_sig(sh2,hmsh2,isig)*ecmw2)/ecmdif
      endif
      if(hmass.lt.75.d0.or.hmass.gt.120.d0.or.ecm.lt.198.d0.
     &     or.ecm.gt.210.d0) 
     &     a2000_nn_mrec_sig=1.d0
      end
      


      double precision function a2000_1995_nn_mrec_sig(x,hmass,isig)
*Approximations made in mass shapes:  below 100 GeV, all H dec's 
*are used in shapes--no separation is done.  Above 100 GeV,
*gg,tautau,&&WW dec modes all use cc shape.  Shapes always separated
*by production mechanism.
      Implicit none
      Integer       isig,isig2
      Real*8        x, hmass
      logical first
      data first /.true./

      Real*8        massl, massh
      Data          massl, massh/ 50.0 ,108.3/

      Integer       mpnt, msig, jpnt, jsig
      Parameter   ( mpnt = 11 , msig = 4)
      Real*8        masst(mpnt), corpk(msig,mpnt)
      Data         (masst(jpnt), (corpk(jsig,jpnt),jsig=1,msig)
     &                                            ,jpnt=1,mpnt)
     & /75.00,88.5864,88.5864,90.1043,90.1043
     & ,80.00,89.4298,89.4298,89.7769,89.7769
     & ,85.00,90.5924,90.5924,91.0195,91.0195
     & ,90.00,92.1940,92.1940,92.2145,92.2145
     & ,95.00,95.5795,95.5795,95.0086,95.0086
     & ,100.00,98.9838,99.6213,98.3634,97.8760
     & ,105.00,102.3720,102.9160,101.2020,102.0610
     & ,107.00,102.8770,103.3720,101.2260,101.6760
     & ,110.00,102.0040,102.4600,99.9038,101.2220
     & ,115.00,100.8490,101.2760,99.9228,101.1430
     & ,120.00,101.4420,102.9000,100.3720,100.1430/
      Integer       i , i1, i2
      Real*8        c , c1, c2
     &            , d , d1, d2
     &            , f , f1, f2
     &            ,     p1, p2
     &            ,     n1, n2
      REAL*8 A1995_hnn_75_mrec_nulnul,A1995_hnn_75_mrec_nuenue
     & ,A1995_hnn_80_mrec_nulnul,A1995_hnn_80_mrec_nuenue
     & ,A1995_hnn_85_mrec_nulnul,A1995_hnn_85_mrec_nuenue
     & ,A1995_hnn_90_mrec_nulnul,A1995_hnn_90_mrec_nuenue
     & ,A1995_hnn_95_mrec_nulnul,A1995_hnn_95_mrec_nuenue
     & ,A1995_hnn_100_mrec_nulnul_bb,A1995_hnn_100_mrec_nuenue_bb
     & ,A1995_hnn_100_mrec_nulnul_cc,A1995_hnn_100_mrec_nuenue_cc
     & ,A1995_hnn_105_mrec_nulnul_bb,A1995_hnn_105_mrec_nuenue_bb
     & ,A1995_hnn_105_mrec_nulnul_cc,A1995_hnn_105_mrec_nuenue_cc
     & ,A1995_hnn_107_mrec_nulnul_bb,A1995_hnn_107_mrec_nuenue_bb
     & ,A1995_hnn_107_mrec_nulnul_cc,A1995_hnn_107_mrec_nuenue_cc
     & ,A1995_hnn_110_mrec_nulnul_bb,A1995_hnn_110_mrec_nuenue_bb
     & ,A1995_hnn_110_mrec_nulnul_cc,A1995_hnn_110_mrec_nuenue_cc
     & ,A1995_hnn_115_mrec_nulnul_bb,A1995_hnn_115_mrec_nuenue_bb
     & ,A1995_hnn_115_mrec_nulnul_cc,A1995_hnn_115_mrec_nuenue_cc
     & ,A1995_hnn_120_mrec_nulnul_bb,A1995_hnn_120_mrec_nuenue_bb
     & ,A1995_hnn_120_mrec_nulnul_cc,A1995_hnn_120_mrec_nuenue_cc
      external A1995_hnn_75_mrec_nulnul,A1995_hnn_75_mrec_nuenue
     & ,A1995_hnn_80_mrec_nulnul,A1995_hnn_80_mrec_nuenue
     & ,A1995_hnn_85_mrec_nulnul,A1995_hnn_85_mrec_nuenue
     & ,A1995_hnn_90_mrec_nulnul,A1995_hnn_90_mrec_nuenue
     & ,A1995_hnn_95_mrec_nulnul,A1995_hnn_95_mrec_nuenue
     & ,A1995_hnn_100_mrec_nulnul_bb,A1995_hnn_100_mrec_nuenue_bb
     & ,A1995_hnn_100_mrec_nulnul_cc,A1995_hnn_100_mrec_nuenue_cc
     & ,A1995_hnn_105_mrec_nulnul_bb,A1995_hnn_105_mrec_nuenue_bb
     & ,A1995_hnn_105_mrec_nulnul_cc,A1995_hnn_105_mrec_nuenue_cc
     & ,A1995_hnn_107_mrec_nulnul_bb,A1995_hnn_107_mrec_nuenue_bb
     & ,A1995_hnn_107_mrec_nulnul_cc,A1995_hnn_107_mrec_nuenue_cc
     & ,A1995_hnn_110_mrec_nulnul_bb,A1995_hnn_110_mrec_nuenue_bb
     & ,A1995_hnn_110_mrec_nulnul_cc,A1995_hnn_110_mrec_nuenue_cc
     & ,A1995_hnn_115_mrec_nulnul_bb,A1995_hnn_115_mrec_nuenue_bb
     & ,A1995_hnn_115_mrec_nulnul_cc,A1995_hnn_115_mrec_nuenue_cc
     & ,A1995_hnn_120_mrec_nulnul_bb,A1995_hnn_120_mrec_nuenue_bb
     & ,A1995_hnn_120_mrec_nulnul_cc,A1995_hnn_120_mrec_nuenue_cc
      if    ( hmass.lt.masst(1   ) ) then
          i1 = 1
          i2 = 1
          d1 = 0.0
          d2 = 1.0
      elseif( hmass.ge.masst(mpnt) ) then
          i1 = mpnt
          i2 = mpnt
          d1 = 1.0
          d2 = 0.0
      else
          do i = 1, mpnt-1
          if( hmass.ge.masst(i) .and. hmass.lt.masst(i+1) ) then
          i1 = i
          i2 = i + 1
          endif
          enddo
          d  = masst(i2) - masst(i1)
          d1 = (hmass - masst(i1))/d
          d2 = (masst(i2) - hmass)/d
      endif
      if (isig.eq.1) then
         isig2=1
      elseif(isig.eq.2.or.isig.eq.3.or.isig.eq.4.or.isig.eq.5) then
         isig2=2
      elseif(isig.eq.6) then
         isig2=3
      elseif(isig.eq.7.or.isig.eq.8.or.isig.eq.9.or.isig.eq.10) then
         isig2=4
      else
         isig2=2
      endif
      c1 = corpk(isig2,i1)
      c2 = corpk(isig2,i2)
      c  = c1*d2 + c2*d1

* very painful procedure to get function values
* =============================================
      if(hmass.le.75.0) then
         if (x.ge.c) then
            p1 = x - c + corpk(isig2,i1)
            p2 = x - c + corpk(isig2,i2)
         else
            p1 = corpk(isig2,i1)-(c-x)/(c-massl)*(corpk(isig2,i1)-massl)
            p2 = corpk(isig2,i2)-(c-x)/(c-massl)*(corpk(isig2,i2)-massl)
         endif
      elseif(hmass.ge.massh) then
         if (x.le.c) then
            p1 = x - c + corpk(isig2,i1)
            p2 = x - c + corpk(isig2,i2)
         else
            p1 = corpk(isig2,i1)+(x-c)/(massh-c)*(massh-corpk(isig2,i1))
            p2 = corpk(isig2,i2)+(x-c)/(massh-c)*(massh-corpk(isig2,i2))
         endif
      else
         p1 = x - c + corpk(isig2,i1)
         p2 = x - c + corpk(isig2,i2)
      endif
      if (isig.eq.1) then
         if (i1.eq.1) then 
            f1=A1995_hnn_75_mrec_nulnul(p1)
         elseif(i1.eq.2) then
            f1=A1995_hnn_80_mrec_nulnul(p1)
         elseif(i1.eq.3) then
            f1=A1995_hnn_85_mrec_nulnul(p1)
         elseif(i1.eq.4) then
            f1=A1995_hnn_90_mrec_nulnul(p1)
         elseif(i1.eq.5) then
            f1=A1995_hnn_95_mrec_nulnul(p1)
         elseif(i1.eq.6) then
            f1=A1995_hnn_100_mrec_nulnul_bb(p1)
         elseif(i1.eq.7) then
            f1=A1995_hnn_105_mrec_nulnul_bb(p1)
         elseif(i1.eq.8) then
            f1=A1995_hnn_107_mrec_nulnul_bb(p1)
         elseif(i1.eq.9) then
            f1=A1995_hnn_110_mrec_nulnul_bb(p1)
         elseif(i1.eq.10) then
            f1=A1995_hnn_115_mrec_nulnul_bb(p1)
         elseif(i1.eq.11) then
            f1=A1995_hnn_120_mrec_nulnul_bb(p1)
         endif
         if (i2.eq.1) then
            f2=A1995_hnn_75_mrec_nulnul(p2)
         elseif(i2.eq.2) then
            f2=A1995_hnn_80_mrec_nulnul(p2)
         elseif(i2.eq.3) then
            f2=A1995_hnn_85_mrec_nulnul(p2)
         elseif(i2.eq.4) then
            f2=A1995_hnn_90_mrec_nulnul(p2)
         elseif(i2.eq.5) then
            f2=A1995_hnn_95_mrec_nulnul(p2)
         elseif(i2.eq.6) then
            f2=A1995_hnn_100_mrec_nulnul_bb(p2)
         elseif(i2.eq.7) then
            f2=A1995_hnn_105_mrec_nulnul_bb(p2)
         elseif(i2.eq.8) then
            f2=A1995_hnn_107_mrec_nulnul_bb(p2)
         elseif(i2.eq.9) then
            f2=A1995_hnn_110_mrec_nulnul_bb(p2)
         elseif(i2.eq.10) then
            f2=A1995_hnn_115_mrec_nulnul_bb(p2)
         elseif(i2.eq.11) then
            f2=A1995_hnn_120_mrec_nulnul_bb(p2)
         endif
      elseif(isig.eq.2.or.isig.eq.3.or.isig.eq.4.or.isig.eq.5) then
         if (i1.eq.1) then 
            f1=A1995_hnn_75_mrec_nulnul(p1)
         elseif(i1.eq.2) then
            f1=A1995_hnn_80_mrec_nulnul(p1)
         elseif(i1.eq.3) then
            f1=A1995_hnn_85_mrec_nulnul(p1)
         elseif(i1.eq.4) then
            f1=A1995_hnn_90_mrec_nulnul(p1)
         elseif(i1.eq.5) then
            f1=A1995_hnn_95_mrec_nulnul(p1)
         elseif(i1.eq.6) then
            f1=A1995_hnn_100_mrec_nulnul_cc(p1)
         elseif(i1.eq.7) then
            f1=A1995_hnn_105_mrec_nulnul_cc(p1)
         elseif(i1.eq.8) then
            f1=A1995_hnn_107_mrec_nulnul_cc(p1)
         elseif(i1.eq.9) then
            f1=A1995_hnn_110_mrec_nulnul_cc(p1)
         elseif(i1.eq.10) then
            f1=A1995_hnn_115_mrec_nulnul_cc(p1)
         elseif(i1.eq.11) then
            f1=A1995_hnn_120_mrec_nulnul_cc(p1)
         endif
         if (i2.eq.1) then
            f2=A1995_hnn_75_mrec_nulnul(p2)
         elseif(i2.eq.2) then
            f2=A1995_hnn_80_mrec_nulnul(p2)
         elseif(i2.eq.3) then
            f2=A1995_hnn_85_mrec_nulnul(p2)
         elseif(i2.eq.4) then
            f2=A1995_hnn_90_mrec_nulnul(p2)
         elseif(i2.eq.5) then
            f2=A1995_hnn_95_mrec_nulnul(p2)
         elseif(i2.eq.6) then
            f2=A1995_hnn_100_mrec_nulnul_cc(p2)
         elseif(i2.eq.7) then
            f2=A1995_hnn_105_mrec_nulnul_cc(p2)
         elseif(i2.eq.8) then
            f2=A1995_hnn_107_mrec_nulnul_cc(p2)
         elseif(i2.eq.9) then
            f2=A1995_hnn_110_mrec_nulnul_cc(p2)
         elseif(i2.eq.10) then
            f2=A1995_hnn_115_mrec_nulnul_cc(p2)
         elseif(i2.eq.11) then
            f2=A1995_hnn_120_mrec_nulnul_cc(p2)
         endif
      elseif (isig.eq.6) then
         if (i1.eq.1) then 
            f1=A1995_hnn_75_mrec_nuenue(p1)
         elseif(i1.eq.2) then
            f1=A1995_hnn_80_mrec_nuenue(p1)
         elseif(i1.eq.3) then
            f1=A1995_hnn_85_mrec_nuenue(p1)
         elseif(i1.eq.4) then
            f1=A1995_hnn_90_mrec_nuenue(p1)
         elseif(i1.eq.5) then
            f1=A1995_hnn_95_mrec_nuenue(p1)
         elseif(i1.eq.6) then
            f1=A1995_hnn_100_mrec_nuenue_bb(p1)
         elseif(i1.eq.7) then
            f1=A1995_hnn_105_mrec_nuenue_bb(p1)
         elseif(i1.eq.8) then
            f1=A1995_hnn_107_mrec_nuenue_bb(p1)
         elseif(i1.eq.9) then
            f1=A1995_hnn_110_mrec_nuenue_bb(p1)
         elseif(i1.eq.10) then
            f1=A1995_hnn_115_mrec_nuenue_bb(p1)
         elseif(i1.eq.11) then
            f1=A1995_hnn_120_mrec_nuenue_bb(p1)
         endif
         if (i2.eq.1) then
            f2=A1995_hnn_75_mrec_nuenue(p2)
         elseif(i2.eq.2) then
            f2=A1995_hnn_80_mrec_nuenue(p2)
         elseif(i2.eq.3) then
            f2=A1995_hnn_85_mrec_nuenue(p2)
         elseif(i2.eq.4) then
            f2=A1995_hnn_90_mrec_nuenue(p2)
         elseif(i2.eq.5) then
            f2=A1995_hnn_95_mrec_nuenue(p2)
         elseif(i2.eq.6) then
            f2=A1995_hnn_100_mrec_nuenue_bb(p2)
         elseif(i2.eq.7) then
            f2=A1995_hnn_105_mrec_nuenue_bb(p2)
         elseif(i2.eq.8) then
            f2=A1995_hnn_107_mrec_nuenue_bb(p2)
         elseif(i2.eq.9) then
            f2=A1995_hnn_110_mrec_nuenue_bb(p2)
         elseif(i2.eq.10) then
            f2=A1995_hnn_115_mrec_nuenue_bb(p2)
         elseif(i2.eq.11) then
            f2=A1995_hnn_120_mrec_nuenue_bb(p2)
         endif
      elseif(isig.eq.7.or.isig.eq.8.or.isig.eq.9.or.isig.eq.10) then
         if (i1.eq.1) then 
            f1=A1995_hnn_75_mrec_nuenue(p1)
         elseif(i1.eq.2) then
            f1=A1995_hnn_80_mrec_nuenue(p1)
         elseif(i1.eq.3) then
            f1=A1995_hnn_85_mrec_nuenue(p1)
         elseif(i1.eq.4) then
            f1=A1995_hnn_90_mrec_nuenue(p1)
         elseif(i1.eq.5) then
            f1=A1995_hnn_95_mrec_nuenue(p1)
         elseif(i1.eq.6) then
            f1=A1995_hnn_100_mrec_nuenue_cc(p1)
         elseif(i1.eq.7) then
            f1=A1995_hnn_105_mrec_nuenue_cc(p1)
         elseif(i1.eq.8) then
            f1=A1995_hnn_107_mrec_nuenue_cc(p1)
         elseif(i1.eq.9) then
            f1=A1995_hnn_110_mrec_nuenue_cc(p1)
         elseif(i1.eq.10) then
            f1=A1995_hnn_115_mrec_nuenue_cc(p1)
         elseif(i1.eq.11) then
            f1=A1995_hnn_120_mrec_nuenue_cc(p1)
         endif
         if (i2.eq.1) then
            f2=A1995_hnn_75_mrec_nuenue(p2)
         elseif(i2.eq.2) then
            f2=A1995_hnn_80_mrec_nuenue(p2)
         elseif(i2.eq.3) then
            f2=A1995_hnn_85_mrec_nuenue(p2)
         elseif(i2.eq.4) then
            f2=A1995_hnn_90_mrec_nuenue(p2)
         elseif(i2.eq.5) then
            f2=A1995_hnn_95_mrec_nuenue(p2)
         elseif(i2.eq.6) then
            f2=A1995_hnn_100_mrec_nuenue_cc(p2)
         elseif(i2.eq.7) then
            f2=A1995_hnn_105_mrec_nuenue_cc(p2)
         elseif(i2.eq.8) then
            f2=A1995_hnn_107_mrec_nuenue_cc(p2)
         elseif(i2.eq.9) then
            f2=A1995_hnn_110_mrec_nuenue_cc(p2)
         elseif(i2.eq.10) then
            f2=A1995_hnn_115_mrec_nuenue_cc(p2)
         elseif(i2.eq.11) then
            f2=A1995_hnn_120_mrec_nuenue_cc(p2)
         endif
      else
         f1=0.d0
         f2=0.d0
      endif
      f = f1*d2 + f2*d1
      if( f.lt.1.0D-09 ) f = 1.0d-09
      if    ( x.lt.massl .or. x.gt.massh ) then
         f = 0.0d0
      endif

      a2000_1995_nn_mrec_sig = f
      end
      




      double precision function a2000_2016_nn_mrec_sig(x,hmass,isig)
*Approximations made in mass shapes:  below 100 GeV, all H dec's 
*are used in shapes--no separation is done.  Above 100 GeV,
*gg,tautau,&&WW dec modes all use cc shape.  Shapes always separated
*by production mechanism.
      Implicit none
      Integer       isig,isig2
      Real*8        x, hmass
      logical first
      data first /.true./

      Real*8        massl, massh
      Data          massl, massh/ 50.0 ,110.4/

      Integer       mpnt, msig, jpnt, jsig
      Parameter   ( mpnt = 11 , msig = 4)
      Real*8        masst(mpnt), corpk(msig,mpnt)
      Data         (masst(jpnt), (corpk(jsig,jpnt),jsig=1,msig)
     &                                            ,jpnt=1,mpnt)
     & /75.00,89.9260,89.9260,92.7092,92.7092
     & ,80.00,90.2637,90.2637,91.4198,91.4198
     & ,85.00,92.1010,92.1010,92.3992,92.3992
     & ,90.00,93.4972,93.4972,93.6817,93.6817
     & ,95.00,96.1282,96.1282,95.8221,95.8221
     & ,100.00,99.4897,99.6617,99.0265,99.7421
     & ,105.00,103.1920,103.5890,102.2040,103.5260
     & ,107.00,104.4070,105.0220,102.9330,103.9030
     & ,110.00,104.8750,105.5950,103.0530,103.5420
     & ,115.00,103.4780,105.7300,102.0390,102.8390
     & ,120.00,103.0010,101.3600,102.2140,102.4080/
      Integer       i , i1, i2
      Real*8        c , c1, c2
     &            , d , d1, d2
     &            , f , f1, f2
     &            ,     p1, p2
     &            ,     n1, n2
      REAL*8 A2016_hnn_75_mrec_nulnul,A2016_hnn_75_mrec_nuenue
     & ,A2016_hnn_80_mrec_nulnul,A2016_hnn_80_mrec_nuenue
     & ,A2016_hnn_85_mrec_nulnul,A2016_hnn_85_mrec_nuenue
     & ,A2016_hnn_90_mrec_nulnul,A2016_hnn_90_mrec_nuenue
     & ,A2016_hnn_95_mrec_nulnul,A2016_hnn_95_mrec_nuenue
     & ,A2016_hnn_100_mrec_nulnul_bb,A2016_hnn_100_mrec_nuenue_bb
     & ,A2016_hnn_100_mrec_nulnul_cc,A2016_hnn_100_mrec_nuenue_cc
     & ,A2016_hnn_105_mrec_nulnul_bb,A2016_hnn_105_mrec_nuenue_bb
     & ,A2016_hnn_105_mrec_nulnul_cc,A2016_hnn_105_mrec_nuenue_cc
     & ,A2016_hnn_107_mrec_nulnul_bb,A2016_hnn_107_mrec_nuenue_bb
     & ,A2016_hnn_107_mrec_nulnul_cc,A2016_hnn_107_mrec_nuenue_cc
     & ,A2016_hnn_110_mrec_nulnul_bb,A2016_hnn_110_mrec_nuenue_bb
     & ,A2016_hnn_110_mrec_nulnul_cc,A2016_hnn_110_mrec_nuenue_cc
     & ,A2016_hnn_115_mrec_nulnul_bb,A2016_hnn_115_mrec_nuenue_bb
     & ,A2016_hnn_115_mrec_nulnul_cc,A2016_hnn_115_mrec_nuenue_cc
     & ,A2016_hnn_120_mrec_nulnul_bb,A2016_hnn_120_mrec_nuenue_bb
     & ,A2016_hnn_120_mrec_nulnul_cc,A2016_hnn_120_mrec_nuenue_cc
      external A2016_hnn_75_mrec_nulnul,A2016_hnn_75_mrec_nuenue
     & ,A2016_hnn_80_mrec_nulnul,A2016_hnn_80_mrec_nuenue
     & ,A2016_hnn_85_mrec_nulnul,A2016_hnn_85_mrec_nuenue
     & ,A2016_hnn_90_mrec_nulnul,A2016_hnn_90_mrec_nuenue
     & ,A2016_hnn_95_mrec_nulnul,A2016_hnn_95_mrec_nuenue
     & ,A2016_hnn_100_mrec_nulnul_bb,A2016_hnn_100_mrec_nuenue_bb
     & ,A2016_hnn_100_mrec_nulnul_cc,A2016_hnn_100_mrec_nuenue_cc
     & ,A2016_hnn_105_mrec_nulnul_bb,A2016_hnn_105_mrec_nuenue_bb
     & ,A2016_hnn_105_mrec_nulnul_cc,A2016_hnn_105_mrec_nuenue_cc
     & ,A2016_hnn_107_mrec_nulnul_bb,A2016_hnn_107_mrec_nuenue_bb
     & ,A2016_hnn_107_mrec_nulnul_cc,A2016_hnn_107_mrec_nuenue_cc
     & ,A2016_hnn_110_mrec_nulnul_bb,A2016_hnn_110_mrec_nuenue_bb
     & ,A2016_hnn_110_mrec_nulnul_cc,A2016_hnn_110_mrec_nuenue_cc
     & ,A2016_hnn_115_mrec_nulnul_bb,A2016_hnn_115_mrec_nuenue_bb
     & ,A2016_hnn_115_mrec_nulnul_cc,A2016_hnn_115_mrec_nuenue_cc
     & ,A2016_hnn_120_mrec_nulnul_bb,A2016_hnn_120_mrec_nuenue_bb
     & ,A2016_hnn_120_mrec_nulnul_cc,A2016_hnn_120_mrec_nuenue_cc
      if    ( hmass.lt.masst(1   ) ) then
          i1 = 1
          i2 = 1
          d1 = 0.0
          d2 = 1.0
      elseif( hmass.ge.masst(mpnt) ) then
          i1 = mpnt
          i2 = mpnt
          d1 = 1.0
          d2 = 0.0
      else
          do i = 1, mpnt-1
          if( hmass.ge.masst(i) .and. hmass.lt.masst(i+1) ) then
          i1 = i
          i2 = i + 1
          endif
          enddo
          d  = masst(i2) - masst(i1)
          d1 = (hmass - masst(i1))/d
          d2 = (masst(i2) - hmass)/d
      endif
      if (isig.eq.1) then
         isig2=1
      elseif(isig.eq.2.or.isig.eq.3.or.isig.eq.4.or.isig.eq.5) then
         isig2=2
      elseif(isig.eq.6) then
         isig2=3
      elseif(isig.eq.7.or.isig.eq.8.or.isig.eq.9.or.isig.eq.10) then
         isig2=4
      else
         isig2=2
      endif
      c1 = corpk(isig2,i1)
      c2 = corpk(isig2,i2)
      c  = c1*d2 + c2*d1

* very painful procedure to get function values
* =============================================
      if(hmass.le.75.0) then
         if (x.ge.c) then
            p1 = x - c + corpk(isig2,i1)
            p2 = x - c + corpk(isig2,i2)
         else
            p1 = corpk(isig2,i1)-(c-x)/(c-massl)*(corpk(isig2,i1)-massl)
            p2 = corpk(isig2,i2)-(c-x)/(c-massl)*(corpk(isig2,i2)-massl)
         endif
      elseif(hmass.ge.massh) then
         if (x.le.c) then
            p1 = x - c + corpk(isig2,i1)
            p2 = x - c + corpk(isig2,i2)
         else
            p1 = corpk(isig2,i1)+(x-c)/(massh-c)*(massh-corpk(isig2,i1))
            p2 = corpk(isig2,i2)+(x-c)/(massh-c)*(massh-corpk(isig2,i2))
         endif
      else
         p1 = x - c + corpk(isig2,i1)
         p2 = x - c + corpk(isig2,i2)
      endif
      if (isig.eq.1) then
         if (i1.eq.1) then 
            f1=A2016_hnn_75_mrec_nulnul(p1)
         elseif(i1.eq.2) then
            f1=A2016_hnn_80_mrec_nulnul(p1)
         elseif(i1.eq.3) then
            f1=A2016_hnn_85_mrec_nulnul(p1)
         elseif(i1.eq.4) then
            f1=A2016_hnn_90_mrec_nulnul(p1)
         elseif(i1.eq.5) then
            f1=A2016_hnn_95_mrec_nulnul(p1)
         elseif(i1.eq.6) then
            f1=A2016_hnn_100_mrec_nulnul_bb(p1)
         elseif(i1.eq.7) then
            f1=A2016_hnn_105_mrec_nulnul_bb(p1)
         elseif(i1.eq.8) then
            f1=A2016_hnn_107_mrec_nulnul_bb(p1)
         elseif(i1.eq.9) then
            f1=A2016_hnn_110_mrec_nulnul_bb(p1)
         elseif(i1.eq.10) then
            f1=A2016_hnn_115_mrec_nulnul_bb(p1)
         elseif(i1.eq.11) then
            f1=A2016_hnn_120_mrec_nulnul_bb(p1)
         endif
         if (i2.eq.1) then
            f2=A2016_hnn_75_mrec_nulnul(p2)
         elseif(i2.eq.2) then
            f2=A2016_hnn_80_mrec_nulnul(p2)
         elseif(i2.eq.3) then
            f2=A2016_hnn_85_mrec_nulnul(p2)
         elseif(i2.eq.4) then
            f2=A2016_hnn_90_mrec_nulnul(p2)
         elseif(i2.eq.5) then
            f2=A2016_hnn_95_mrec_nulnul(p2)
         elseif(i2.eq.6) then
            f2=A2016_hnn_100_mrec_nulnul_bb(p2)
         elseif(i2.eq.7) then
            f2=A2016_hnn_105_mrec_nulnul_bb(p2)
         elseif(i2.eq.8) then
            f2=A2016_hnn_107_mrec_nulnul_bb(p2)
         elseif(i2.eq.9) then
            f2=A2016_hnn_110_mrec_nulnul_bb(p2)
         elseif(i2.eq.10) then
            f2=A2016_hnn_115_mrec_nulnul_bb(p2)
         elseif(i2.eq.11) then
            f2=A2016_hnn_120_mrec_nulnul_bb(p2)
         endif
      elseif(isig.eq.2.or.isig.eq.3.or.isig.eq.4.or.isig.eq.5) then
         if (i1.eq.1) then 
            f1=A2016_hnn_75_mrec_nulnul(p1)
         elseif(i1.eq.2) then
            f1=A2016_hnn_80_mrec_nulnul(p1)
         elseif(i1.eq.3) then
            f1=A2016_hnn_85_mrec_nulnul(p1)
         elseif(i1.eq.4) then
            f1=A2016_hnn_90_mrec_nulnul(p1)
         elseif(i1.eq.5) then
            f1=A2016_hnn_95_mrec_nulnul(p1)
         elseif(i1.eq.6) then
            f1=A2016_hnn_100_mrec_nulnul_cc(p1)
         elseif(i1.eq.7) then
            f1=A2016_hnn_105_mrec_nulnul_cc(p1)
         elseif(i1.eq.8) then
            f1=A2016_hnn_107_mrec_nulnul_cc(p1)
         elseif(i1.eq.9) then
            f1=A2016_hnn_110_mrec_nulnul_cc(p1)
         elseif(i1.eq.10) then
            f1=A2016_hnn_115_mrec_nulnul_cc(p1)
         elseif(i1.eq.11) then
            f1=A2016_hnn_120_mrec_nulnul_cc(p1)
         endif
         if (i2.eq.1) then
            f2=A2016_hnn_75_mrec_nulnul(p2)
         elseif(i2.eq.2) then
            f2=A2016_hnn_80_mrec_nulnul(p2)
         elseif(i2.eq.3) then
            f2=A2016_hnn_85_mrec_nulnul(p2)
         elseif(i2.eq.4) then
            f2=A2016_hnn_90_mrec_nulnul(p2)
         elseif(i2.eq.5) then
            f2=A2016_hnn_95_mrec_nulnul(p2)
         elseif(i2.eq.6) then
            f2=A2016_hnn_100_mrec_nulnul_cc(p2)
         elseif(i2.eq.7) then
            f2=A2016_hnn_105_mrec_nulnul_cc(p2)
         elseif(i2.eq.8) then
            f2=A2016_hnn_107_mrec_nulnul_cc(p2)
         elseif(i2.eq.9) then
            f2=A2016_hnn_110_mrec_nulnul_cc(p2)
         elseif(i2.eq.10) then
            f2=A2016_hnn_115_mrec_nulnul_cc(p2)
         elseif(i2.eq.11) then
            f2=A2016_hnn_120_mrec_nulnul_cc(p2)
         endif
      elseif (isig.eq.6) then
         if (i1.eq.1) then 
            f1=A2016_hnn_75_mrec_nuenue(p1)
         elseif(i1.eq.2) then
            f1=A2016_hnn_80_mrec_nuenue(p1)
         elseif(i1.eq.3) then
            f1=A2016_hnn_85_mrec_nuenue(p1)
         elseif(i1.eq.4) then
            f1=A2016_hnn_90_mrec_nuenue(p1)
         elseif(i1.eq.5) then
            f1=A2016_hnn_95_mrec_nuenue(p1)
         elseif(i1.eq.6) then
            f1=A2016_hnn_100_mrec_nuenue_bb(p1)
         elseif(i1.eq.7) then
            f1=A2016_hnn_105_mrec_nuenue_bb(p1)
         elseif(i1.eq.8) then
            f1=A2016_hnn_107_mrec_nuenue_bb(p1)
         elseif(i1.eq.9) then
            f1=A2016_hnn_110_mrec_nuenue_bb(p1)
         elseif(i1.eq.10) then
            f1=A2016_hnn_115_mrec_nuenue_bb(p1)
         elseif(i1.eq.11) then
            f1=A2016_hnn_120_mrec_nuenue_bb(p1)
         endif
         if (i2.eq.1) then
            f2=A2016_hnn_75_mrec_nuenue(p2)
         elseif(i2.eq.2) then
            f2=A2016_hnn_80_mrec_nuenue(p2)
         elseif(i2.eq.3) then
            f2=A2016_hnn_85_mrec_nuenue(p2)
         elseif(i2.eq.4) then
            f2=A2016_hnn_90_mrec_nuenue(p2)
         elseif(i2.eq.5) then
            f2=A2016_hnn_95_mrec_nuenue(p2)
         elseif(i2.eq.6) then
            f2=A2016_hnn_100_mrec_nuenue_bb(p2)
         elseif(i2.eq.7) then
            f2=A2016_hnn_105_mrec_nuenue_bb(p2)
         elseif(i2.eq.8) then
            f2=A2016_hnn_107_mrec_nuenue_bb(p2)
         elseif(i2.eq.9) then
            f2=A2016_hnn_110_mrec_nuenue_bb(p2)
         elseif(i2.eq.10) then
            f2=A2016_hnn_115_mrec_nuenue_bb(p2)
         elseif(i2.eq.11) then
            f2=A2016_hnn_120_mrec_nuenue_bb(p2)
         endif
      elseif(isig.eq.7.or.isig.eq.8.or.isig.eq.9.or.isig.eq.10) then
         if (i1.eq.1) then 
            f1=A2016_hnn_75_mrec_nuenue(p1)
         elseif(i1.eq.2) then
            f1=A2016_hnn_80_mrec_nuenue(p1)
         elseif(i1.eq.3) then
            f1=A2016_hnn_85_mrec_nuenue(p1)
         elseif(i1.eq.4) then
            f1=A2016_hnn_90_mrec_nuenue(p1)
         elseif(i1.eq.5) then
            f1=A2016_hnn_95_mrec_nuenue(p1)
         elseif(i1.eq.6) then
            f1=A2016_hnn_100_mrec_nuenue_cc(p1)
         elseif(i1.eq.7) then
            f1=A2016_hnn_105_mrec_nuenue_cc(p1)
         elseif(i1.eq.8) then
            f1=A2016_hnn_107_mrec_nuenue_cc(p1)
         elseif(i1.eq.9) then
            f1=A2016_hnn_110_mrec_nuenue_cc(p1)
         elseif(i1.eq.10) then
            f1=A2016_hnn_115_mrec_nuenue_cc(p1)
         elseif(i1.eq.11) then
            f1=A2016_hnn_120_mrec_nuenue_cc(p1)
         endif
         if (i2.eq.1) then
            f2=A2016_hnn_75_mrec_nuenue(p2)
         elseif(i2.eq.2) then
            f2=A2016_hnn_80_mrec_nuenue(p2)
         elseif(i2.eq.3) then
            f2=A2016_hnn_85_mrec_nuenue(p2)
         elseif(i2.eq.4) then
            f2=A2016_hnn_90_mrec_nuenue(p2)
         elseif(i2.eq.5) then
            f2=A2016_hnn_95_mrec_nuenue(p2)
         elseif(i2.eq.6) then
            f2=A2016_hnn_100_mrec_nuenue_cc(p2)
         elseif(i2.eq.7) then
            f2=A2016_hnn_105_mrec_nuenue_cc(p2)
         elseif(i2.eq.8) then
            f2=A2016_hnn_107_mrec_nuenue_cc(p2)
         elseif(i2.eq.9) then
            f2=A2016_hnn_110_mrec_nuenue_cc(p2)
         elseif(i2.eq.10) then
            f2=A2016_hnn_115_mrec_nuenue_cc(p2)
         elseif(i2.eq.11) then
            f2=A2016_hnn_120_mrec_nuenue_cc(p2)
         endif
      else
         f1=0.d0
         f2=0.d0
      endif
      f = f1*d2 + f2*d1
      if( f.lt.1.0D-09 ) f = 1.0d-09
      if    ( x.lt.massl .or. x.gt.massh ) then
         f = 0.0d0
      endif

      a2000_2016_nn_mrec_sig = f
      end

      double precision function a2000_204_nn_mrec_sig(x,hmass,isig)
*Approximations made in mass shapes:  below 100 GeV, all H dec's 
*are used in shapes--no separation is done.  Above 100 GeV,
*gg,tautau,&&WW dec modes all use cc shape.  Shapes always separated
*by production mechanism.
      Implicit none
      Integer       isig,isig2
      Real*8        x, hmass
      logical first
      data first /.true./

      Real*8        massl, massh
      Data          massl, massh/ 50.0 ,112.8/

      Integer       mpnt, msig, jpnt, jsig
      Parameter   ( mpnt = 19 , msig = 4)
      Real*8        masst(mpnt), corpk(msig,mpnt)
      Data         (masst(jpnt), (corpk(jsig,jpnt),jsig=1,msig)
     &                                            ,jpnt=1,mpnt)
     & /75.00,92.5280,92.5280,94.4423,94.4423
     & ,80.00,93.2640,93.2640,93.2334,93.2334
     & ,85.00,94.2641,94.2641,95.2342,95.2342
     & ,90.00,95.4793,95.4793,95.1522,95.1522
     & ,95.00,97.0929,97.0929,97.2774,97.2774
     & ,100.00,100.1140,100.7060,99.7774,99.6220
     & ,102.00,101.6270,101.8800,101.1060,101.1720
     & ,104.00,103.0940,103.9370,102.2740,102.8980
     & ,106.00,104.6160,105.3650,103.7280,104.8040
     & ,108.00,106.0080,106.0700,104.9370,105.0970
     & ,110.00,107.1210,107.7890,105.6170,106.5280
     & ,111.00,107.2530,107.7890,105.7370,106.3670
     & ,112.00,107.2320,107.9610,105.7120,106.5750
     & ,112.80,106.8970,107.2110,105.1110,106.1850
     & ,114.00,106.5120,107.4300,104.6920,105.9870
     & ,115.00,106.2230,107.9580,104.5570,104.6920
     & ,116.00,105.8480,107.3690,104.2230,104.9530
     & ,118.00,105.9380,104.8750,104.4260,105.5530
     & ,120.00,105.7840,106.1890,104.3910,104.3860/
      Integer       i , i1, i2
      Real*8        c , c1, c2
     &            , d , d1, d2
     &            , f , f1, f2
     &            ,     p1, p2
     &            ,     n1, n2
      REAL*8 A204_hnn_75_mrec_nulnul,A204_hnn_75_mrec_nuenue
     & ,A204_hnn_80_mrec_nulnul,A204_hnn_80_mrec_nuenue
     & ,A204_hnn_85_mrec_nulnul,A204_hnn_85_mrec_nuenue
     & ,A204_hnn_90_mrec_nulnul,A204_hnn_90_mrec_nuenue
     & ,A204_hnn_95_mrec_nulnul,A204_hnn_95_mrec_nuenue
     & ,A204_hnn_100_mrec_nulnul_bb,A204_hnn_100_mrec_nuenue_bb
     & ,A204_hnn_100_mrec_nulnul_cc,A204_hnn_100_mrec_nuenue_cc
     & ,A204_hnn_102_mrec_nulnul_bb,A204_hnn_102_mrec_nuenue_bb
     & ,A204_hnn_102_mrec_nulnul_cc,A204_hnn_102_mrec_nuenue_cc
     & ,A204_hnn_104_mrec_nulnul_bb,A204_hnn_104_mrec_nuenue_bb
     & ,A204_hnn_104_mrec_nulnul_cc,A204_hnn_104_mrec_nuenue_cc
     & ,A204_hnn_106_mrec_nulnul_bb,A204_hnn_106_mrec_nuenue_bb
     & ,A204_hnn_106_mrec_nulnul_cc,A204_hnn_106_mrec_nuenue_cc
     & ,A204_hnn_108_mrec_nulnul_bb,A204_hnn_108_mrec_nuenue_bb
     & ,A204_hnn_108_mrec_nulnul_cc,A204_hnn_108_mrec_nuenue_cc
     & ,A204_hnn_110_mrec_nulnul_bb,A204_hnn_110_mrec_nuenue_bb
     & ,A204_hnn_110_mrec_nulnul_cc,A204_hnn_110_mrec_nuenue_cc
     & ,A204_hnn_111_mrec_nulnul_bb,A204_hnn_111_mrec_nuenue_bb
     & ,A204_hnn_111_mrec_nulnul_cc,A204_hnn_111_mrec_nuenue_cc
     & ,A204_hnn_112_mrec_nulnul_bb,A204_hnn_112_mrec_nuenue_bb
     & ,A204_hnn_112_mrec_nulnul_cc,A204_hnn_112_mrec_nuenue_cc
     & ,A204_hnn_1128_mrec_nulnul_bb,A204_hnn_1128_mrec_nuenue_bb
     & ,A204_hnn_1128_mrec_nulnul_cc,A204_hnn_1128_mrec_nuenue_cc
     & ,A204_hnn_114_mrec_nulnul_bb,A204_hnn_114_mrec_nuenue_bb
     & ,A204_hnn_114_mrec_nulnul_cc,A204_hnn_114_mrec_nuenue_cc
     & ,A204_hnn_115_mrec_nulnul_bb,A204_hnn_115_mrec_nuenue_bb
     & ,A204_hnn_115_mrec_nulnul_cc,A204_hnn_115_mrec_nuenue_cc
     & ,A204_hnn_116_mrec_nulnul_bb,A204_hnn_116_mrec_nuenue_bb
     & ,A204_hnn_116_mrec_nulnul_cc,A204_hnn_116_mrec_nuenue_cc
     & ,A204_hnn_118_mrec_nulnul_bb,A204_hnn_118_mrec_nuenue_bb
     & ,A204_hnn_118_mrec_nulnul_cc,A204_hnn_118_mrec_nuenue_cc
     & ,A204_hnn_120_mrec_nulnul_bb,A204_hnn_120_mrec_nuenue_bb
     & ,A204_hnn_120_mrec_nulnul_cc,A204_hnn_120_mrec_nuenue_cc
      external A204_hnn_75_mrec_nulnul,A204_hnn_75_mrec_nuenue
     & ,A204_hnn_80_mrec_nulnul,A204_hnn_80_mrec_nuenue
     & ,A204_hnn_85_mrec_nulnul,A204_hnn_85_mrec_nuenue
     & ,A204_hnn_90_mrec_nulnul,A204_hnn_90_mrec_nuenue
     & ,A204_hnn_95_mrec_nulnul,A204_hnn_95_mrec_nuenue
     & ,A204_hnn_100_mrec_nulnul_bb,A204_hnn_100_mrec_nuenue_bb
     & ,A204_hnn_100_mrec_nulnul_cc,A204_hnn_100_mrec_nuenue_cc
     & ,A204_hnn_102_mrec_nulnul_bb,A204_hnn_102_mrec_nuenue_bb
     & ,A204_hnn_102_mrec_nulnul_cc,A204_hnn_102_mrec_nuenue_cc
     & ,A204_hnn_104_mrec_nulnul_bb,A204_hnn_104_mrec_nuenue_bb
     & ,A204_hnn_104_mrec_nulnul_cc,A204_hnn_104_mrec_nuenue_cc
     & ,A204_hnn_106_mrec_nulnul_bb,A204_hnn_106_mrec_nuenue_bb
     & ,A204_hnn_106_mrec_nulnul_cc,A204_hnn_106_mrec_nuenue_cc
     & ,A204_hnn_108_mrec_nulnul_bb,A204_hnn_108_mrec_nuenue_bb
     & ,A204_hnn_108_mrec_nulnul_cc,A204_hnn_108_mrec_nuenue_cc
     & ,A204_hnn_110_mrec_nulnul_bb,A204_hnn_110_mrec_nuenue_bb
     & ,A204_hnn_110_mrec_nulnul_cc,A204_hnn_110_mrec_nuenue_cc
     & ,A204_hnn_111_mrec_nulnul_bb,A204_hnn_111_mrec_nuenue_bb
     & ,A204_hnn_111_mrec_nulnul_cc,A204_hnn_111_mrec_nuenue_cc
     & ,A204_hnn_112_mrec_nulnul_bb,A204_hnn_112_mrec_nuenue_bb
     & ,A204_hnn_112_mrec_nulnul_cc,A204_hnn_112_mrec_nuenue_cc
     & ,A204_hnn_1128_mrec_nulnul_bb,A204_hnn_1128_mrec_nuenue_bb
     & ,A204_hnn_1128_mrec_nulnul_cc,A204_hnn_1128_mrec_nuenue_cc
     & ,A204_hnn_114_mrec_nulnul_bb,A204_hnn_114_mrec_nuenue_bb
     & ,A204_hnn_114_mrec_nulnul_cc,A204_hnn_114_mrec_nuenue_cc
     & ,A204_hnn_115_mrec_nulnul_bb,A204_hnn_115_mrec_nuenue_bb
     & ,A204_hnn_115_mrec_nulnul_cc,A204_hnn_115_mrec_nuenue_cc
     & ,A204_hnn_116_mrec_nulnul_bb,A204_hnn_116_mrec_nuenue_bb
     & ,A204_hnn_116_mrec_nulnul_cc,A204_hnn_116_mrec_nuenue_cc
     & ,A204_hnn_118_mrec_nulnul_bb,A204_hnn_118_mrec_nuenue_bb
     & ,A204_hnn_118_mrec_nulnul_cc,A204_hnn_118_mrec_nuenue_cc
     & ,A204_hnn_120_mrec_nulnul_bb,A204_hnn_120_mrec_nuenue_bb
     & ,A204_hnn_120_mrec_nulnul_cc,A204_hnn_120_mrec_nuenue_cc
      if    ( hmass.lt.masst(1   ) ) then
          i1 = 1
          i2 = 1
          d1 = 0.0
          d2 = 1.0
      elseif( hmass.ge.masst(mpnt) ) then
          i1 = mpnt
          i2 = mpnt
          d1 = 1.0
          d2 = 0.0
      else
          do i = 1, mpnt-1
          if( hmass.ge.masst(i) .and. hmass.lt.masst(i+1) ) then
          i1 = i
          i2 = i + 1
          endif
          enddo
          d  = masst(i2) - masst(i1)
          d1 = (hmass - masst(i1))/d
          d2 = (masst(i2) - hmass)/d
      endif
      if (isig.eq.1) then
         isig2=1
      elseif(isig.eq.2.or.isig.eq.3.or.isig.eq.4.or.isig.eq.5) then
         isig2=2
      elseif(isig.eq.6) then
         isig2=3
      elseif(isig.eq.7.or.isig.eq.8.or.isig.eq.9.or.isig.eq.10) then
         isig2=4
      else
         isig2=2
      endif
      c1 = corpk(isig2,i1)
      c2 = corpk(isig2,i2)
      c  = c1*d2 + c2*d1
* very painful procedure to get function values
* =============================================
      if(hmass.le.75.0) then
         if (x.ge.c) then
            p1 = x - c + corpk(isig2,i1)
            p2 = x - c + corpk(isig2,i2)
         else
            p1 = corpk(isig2,i1)-(c-x)/(c-massl)*(corpk(isig2,i1)-massl)
            p2 = corpk(isig2,i2)-(c-x)/(c-massl)*(corpk(isig2,i2)-massl)
         endif
      elseif(hmass.ge.massh) then
         if (x.le.c) then
            p1 = x - c + corpk(isig2,i1)
            p2 = x - c + corpk(isig2,i2)
         else
            p1 = corpk(isig2,i1)+(x-c)/(massh-c)*(massh-corpk(isig2,i1))
            p2 = corpk(isig2,i2)+(x-c)/(massh-c)*(massh-corpk(isig2,i2))
         endif
      else
         p1 = x - c + corpk(isig2,i1)
         p2 = x - c + corpk(isig2,i2)
      endif
      if (isig.eq.1) then
         if (i1.eq.1) then 
            f1=A204_hnn_75_mrec_nulnul(p1)
         elseif(i1.eq.2) then
            f1=A204_hnn_80_mrec_nulnul(p1)
         elseif(i1.eq.3) then
            f1=A204_hnn_85_mrec_nulnul(p1)
         elseif(i1.eq.4) then
            f1=A204_hnn_90_mrec_nulnul(p1)
         elseif(i1.eq.5) then
            f1=A204_hnn_95_mrec_nulnul(p1)
         elseif(i1.eq.6) then
            f1=A204_hnn_100_mrec_nulnul_bb(p1)
         elseif(i1.eq.7) then
            f1=A204_hnn_102_mrec_nulnul_bb(p1)
         elseif(i1.eq.8) then
            f1=A204_hnn_104_mrec_nulnul_bb(p1)
         elseif(i1.eq.9) then
            f1=A204_hnn_106_mrec_nulnul_bb(p1)
         elseif(i1.eq.10) then
            f1=A204_hnn_108_mrec_nulnul_bb(p1)
         elseif(i1.eq.11) then
            f1=A204_hnn_110_mrec_nulnul_bb(p1)
         elseif(i1.eq.12) then
            f1=A204_hnn_111_mrec_nulnul_bb(p1)
         elseif(i1.eq.13) then
            f1=A204_hnn_112_mrec_nulnul_bb(p1)
         elseif(i1.eq.14) then
            f1=A204_hnn_1128_mrec_nulnul_bb(p1)
         elseif(i1.eq.15) then
            f1=A204_hnn_114_mrec_nulnul_bb(p1)
         elseif(i1.eq.16) then
            f1=A204_hnn_115_mrec_nulnul_bb(p1)
         elseif(i1.eq.17) then
            f1=A204_hnn_116_mrec_nulnul_bb(p1)
         elseif(i1.eq.18) then
            f1=A204_hnn_118_mrec_nulnul_bb(p1)
         elseif(i1.eq.19) then
            f1=A204_hnn_120_mrec_nulnul_bb(p1)
         endif
         if (i2.eq.1) then
            f2=A204_hnn_75_mrec_nulnul(p2)
         elseif(i2.eq.2) then
            f2=A204_hnn_80_mrec_nulnul(p2)
         elseif(i2.eq.3) then
            f2=A204_hnn_85_mrec_nulnul(p2)
         elseif(i2.eq.4) then
            f2=A204_hnn_90_mrec_nulnul(p2)
         elseif(i2.eq.5) then
            f2=A204_hnn_95_mrec_nulnul(p2)
         elseif(i2.eq.6) then
            f2=A204_hnn_100_mrec_nulnul_bb(p2)
         elseif(i2.eq.7) then
            f2=A204_hnn_102_mrec_nulnul_bb(p2)
         elseif(i2.eq.8) then
            f2=A204_hnn_104_mrec_nulnul_bb(p2)
         elseif(i2.eq.9) then
            f2=A204_hnn_106_mrec_nulnul_bb(p2)
         elseif(i2.eq.10) then
            f2=A204_hnn_108_mrec_nulnul_bb(p2)
         elseif(i2.eq.11) then
            f2=A204_hnn_110_mrec_nulnul_bb(p2)
         elseif(i2.eq.12) then
            f2=A204_hnn_111_mrec_nulnul_bb(p2)
         elseif(i2.eq.13) then
            f2=A204_hnn_112_mrec_nulnul_bb(p2)
         elseif(i2.eq.14) then
            f2=A204_hnn_1128_mrec_nulnul_bb(p2)
         elseif(i2.eq.15) then
            f2=A204_hnn_114_mrec_nulnul_bb(p2)
         elseif(i2.eq.16) then
            f2=A204_hnn_115_mrec_nulnul_bb(p2)
         elseif(i2.eq.17) then
            f2=A204_hnn_116_mrec_nulnul_bb(p2)
         elseif(i2.eq.18) then
            f2=A204_hnn_118_mrec_nulnul_bb(p2)
         elseif(i2.eq.19) then
            f2=A204_hnn_120_mrec_nulnul_bb(p2)
         endif
      elseif(isig.eq.2.or.isig.eq.3.or.isig.eq.4.or.isig.eq.5) then
         if (i1.eq.1) then 
            f1=A204_hnn_75_mrec_nulnul(p1)
         elseif(i1.eq.2) then
            f1=A204_hnn_80_mrec_nulnul(p1)
         elseif(i1.eq.3) then
            f1=A204_hnn_85_mrec_nulnul(p1)
         elseif(i1.eq.4) then
            f1=A204_hnn_90_mrec_nulnul(p1)
         elseif(i1.eq.5) then
            f1=A204_hnn_95_mrec_nulnul(p1)
         elseif(i1.eq.6) then
            f1=A204_hnn_100_mrec_nulnul_cc(p1)
         elseif(i1.eq.7) then
            f1=A204_hnn_102_mrec_nulnul_cc(p1)
         elseif(i1.eq.8) then
            f1=A204_hnn_104_mrec_nulnul_cc(p1)
         elseif(i1.eq.9) then
            f1=A204_hnn_106_mrec_nulnul_cc(p1)
         elseif(i1.eq.10) then
            f1=A204_hnn_108_mrec_nulnul_cc(p1)
         elseif(i1.eq.11) then
            f1=A204_hnn_110_mrec_nulnul_cc(p1)
         elseif(i1.eq.12) then
            f1=A204_hnn_111_mrec_nulnul_cc(p1)
         elseif(i1.eq.13) then
            f1=A204_hnn_112_mrec_nulnul_cc(p1)
         elseif(i1.eq.14) then
            f1=A204_hnn_1128_mrec_nulnul_cc(p1)
         elseif(i1.eq.15) then
            f1=A204_hnn_114_mrec_nulnul_cc(p1)
         elseif(i1.eq.16) then
            f1=A204_hnn_115_mrec_nulnul_cc(p1)
         elseif(i1.eq.17) then
            f1=A204_hnn_116_mrec_nulnul_cc(p1)
         elseif(i1.eq.18) then
            f1=A204_hnn_118_mrec_nulnul_cc(p1)
         elseif(i1.eq.19) then
            f1=A204_hnn_120_mrec_nulnul_cc(p1)
         endif
         if (i2.eq.1) then
            f2=A204_hnn_75_mrec_nulnul(p2)
         elseif(i2.eq.2) then
            f2=A204_hnn_80_mrec_nulnul(p2)
         elseif(i2.eq.3) then
            f2=A204_hnn_85_mrec_nulnul(p2)
         elseif(i2.eq.4) then
            f2=A204_hnn_90_mrec_nulnul(p2)
         elseif(i2.eq.5) then
            f2=A204_hnn_95_mrec_nulnul(p2)
         elseif(i2.eq.6) then
            f2=A204_hnn_100_mrec_nulnul_cc(p2)
         elseif(i2.eq.7) then
            f2=A204_hnn_102_mrec_nulnul_cc(p2)
         elseif(i2.eq.8) then
            f2=A204_hnn_104_mrec_nulnul_cc(p2)
         elseif(i2.eq.9) then
            f2=A204_hnn_106_mrec_nulnul_cc(p2)
         elseif(i2.eq.10) then
            f2=A204_hnn_108_mrec_nulnul_cc(p2)
         elseif(i2.eq.11) then
            f2=A204_hnn_110_mrec_nulnul_cc(p2)
         elseif(i2.eq.12) then
            f2=A204_hnn_111_mrec_nulnul_cc(p2)
         elseif(i2.eq.13) then
            f2=A204_hnn_112_mrec_nulnul_cc(p2)
         elseif(i2.eq.14) then
            f2=A204_hnn_1128_mrec_nulnul_cc(p2)
         elseif(i2.eq.15) then
            f2=A204_hnn_114_mrec_nulnul_cc(p2)
         elseif(i2.eq.16) then
            f2=A204_hnn_115_mrec_nulnul_cc(p2)
         elseif(i2.eq.17) then
            f2=A204_hnn_116_mrec_nulnul_cc(p2)
         elseif(i2.eq.18) then
            f2=A204_hnn_118_mrec_nulnul_cc(p2)
         elseif(i2.eq.19) then
            f2=A204_hnn_120_mrec_nulnul_cc(p2)
         endif
      elseif (isig.eq.6) then
         if (i1.eq.1) then 
            f1=A204_hnn_75_mrec_nuenue(p1)
         elseif(i1.eq.2) then
            f1=A204_hnn_80_mrec_nuenue(p1)
         elseif(i1.eq.3) then
            f1=A204_hnn_85_mrec_nuenue(p1)
         elseif(i1.eq.4) then
            f1=A204_hnn_90_mrec_nuenue(p1)
         elseif(i1.eq.5) then
            f1=A204_hnn_95_mrec_nuenue(p1)
         elseif(i1.eq.6) then
            f1=A204_hnn_100_mrec_nuenue_bb(p1)
         elseif(i1.eq.7) then
            f1=A204_hnn_102_mrec_nuenue_bb(p1)
         elseif(i1.eq.8) then
            f1=A204_hnn_104_mrec_nuenue_bb(p1)
         elseif(i1.eq.9) then
            f1=A204_hnn_106_mrec_nuenue_bb(p1)
         elseif(i1.eq.10) then
            f1=A204_hnn_108_mrec_nuenue_bb(p1)
         elseif(i1.eq.11) then
            f1=A204_hnn_110_mrec_nuenue_bb(p1)
         elseif(i1.eq.12) then
            f1=A204_hnn_111_mrec_nuenue_bb(p1)
         elseif(i1.eq.13) then
            f1=A204_hnn_112_mrec_nuenue_bb(p1)
         elseif(i1.eq.14) then
            f1=A204_hnn_1128_mrec_nuenue_bb(p1)
         elseif(i1.eq.15) then
            f1=A204_hnn_114_mrec_nuenue_bb(p1)
         elseif(i1.eq.16) then
            f1=A204_hnn_115_mrec_nuenue_bb(p1)
         elseif(i1.eq.17) then
            f1=A204_hnn_116_mrec_nuenue_bb(p1)
         elseif(i1.eq.18) then
            f1=A204_hnn_118_mrec_nuenue_bb(p1)
         elseif(i1.eq.19) then
            f1=A204_hnn_120_mrec_nuenue_bb(p1)
         endif
         if (i2.eq.1) then
            f2=A204_hnn_75_mrec_nuenue(p2)
         elseif(i2.eq.2) then
            f2=A204_hnn_80_mrec_nuenue(p2)
         elseif(i2.eq.3) then
            f2=A204_hnn_85_mrec_nuenue(p2)
         elseif(i2.eq.4) then
            f2=A204_hnn_90_mrec_nuenue(p2)
         elseif(i2.eq.5) then
            f2=A204_hnn_95_mrec_nuenue(p2)
         elseif(i2.eq.6) then
            f2=A204_hnn_100_mrec_nuenue_bb(p2)
         elseif(i2.eq.7) then
            f2=A204_hnn_102_mrec_nuenue_bb(p2)
         elseif(i2.eq.8) then
            f2=A204_hnn_104_mrec_nuenue_bb(p2)
         elseif(i2.eq.9) then
            f2=A204_hnn_106_mrec_nuenue_bb(p2)
         elseif(i2.eq.10) then
            f2=A204_hnn_108_mrec_nuenue_bb(p2)
         elseif(i2.eq.11) then
            f2=A204_hnn_110_mrec_nuenue_bb(p2)
         elseif(i2.eq.12) then
            f2=A204_hnn_111_mrec_nuenue_bb(p2)
         elseif(i2.eq.13) then
            f2=A204_hnn_112_mrec_nuenue_bb(p2)
         elseif(i2.eq.14) then
            f2=A204_hnn_1128_mrec_nuenue_bb(p2)
         elseif(i2.eq.15) then
            f2=A204_hnn_114_mrec_nuenue_bb(p2)
         elseif(i2.eq.16) then
            f2=A204_hnn_115_mrec_nuenue_bb(p2)
         elseif(i2.eq.17) then
            f2=A204_hnn_116_mrec_nuenue_bb(p2)
         elseif(i2.eq.18) then
            f2=A204_hnn_118_mrec_nuenue_bb(p2)
         elseif(i2.eq.19) then
            f2=A204_hnn_120_mrec_nuenue_bb(p2)
         endif
      elseif(isig.eq.7.or.isig.eq.8.or.isig.eq.9.or.isig.eq.10) then
         if (i1.eq.1) then 
            f1=A204_hnn_75_mrec_nuenue(p1)
         elseif(i1.eq.2) then
            f1=A204_hnn_80_mrec_nuenue(p1)
         elseif(i1.eq.3) then
            f1=A204_hnn_85_mrec_nuenue(p1)
         elseif(i1.eq.4) then
            f1=A204_hnn_90_mrec_nuenue(p1)
         elseif(i1.eq.5) then
            f1=A204_hnn_95_mrec_nuenue(p1)
         elseif(i1.eq.6) then
            f1=A204_hnn_100_mrec_nuenue_cc(p1)
         elseif(i1.eq.7) then
            f1=A204_hnn_102_mrec_nuenue_cc(p1)
         elseif(i1.eq.8) then
            f1=A204_hnn_104_mrec_nuenue_cc(p1)
         elseif(i1.eq.9) then
            f1=A204_hnn_106_mrec_nuenue_cc(p1)
         elseif(i1.eq.10) then
            f1=A204_hnn_108_mrec_nuenue_cc(p1)
         elseif(i1.eq.11) then
            f1=A204_hnn_110_mrec_nuenue_cc(p1)
         elseif(i1.eq.12) then
            f1=A204_hnn_111_mrec_nuenue_cc(p1)
         elseif(i1.eq.13) then
            f1=A204_hnn_112_mrec_nuenue_cc(p1)
         elseif(i1.eq.14) then
            f1=A204_hnn_1128_mrec_nuenue_cc(p1)
         elseif(i1.eq.15) then
            f1=A204_hnn_114_mrec_nuenue_cc(p1)
         elseif(i1.eq.16) then
            f1=A204_hnn_115_mrec_nuenue_cc(p1)
         elseif(i1.eq.17) then
            f1=A204_hnn_116_mrec_nuenue_cc(p1)
         elseif(i1.eq.18) then
            f1=A204_hnn_118_mrec_nuenue_cc(p1)
         elseif(i1.eq.19) then
            f1=A204_hnn_120_mrec_nuenue_cc(p1)
         endif
         if (i2.eq.1) then
            f2=A204_hnn_75_mrec_nuenue(p2)
         elseif(i2.eq.2) then
            f2=A204_hnn_80_mrec_nuenue(p2)
         elseif(i2.eq.3) then
            f2=A204_hnn_85_mrec_nuenue(p2)
         elseif(i2.eq.4) then
            f2=A204_hnn_90_mrec_nuenue(p2)
         elseif(i2.eq.5) then
            f2=A204_hnn_95_mrec_nuenue(p2)
         elseif(i2.eq.6) then
            f2=A204_hnn_100_mrec_nuenue_cc(p2)
         elseif(i2.eq.7) then
            f2=A204_hnn_102_mrec_nuenue_cc(p2)
         elseif(i2.eq.8) then
            f2=A204_hnn_104_mrec_nuenue_cc(p2)
         elseif(i2.eq.9) then
            f2=A204_hnn_106_mrec_nuenue_cc(p2)
         elseif(i2.eq.10) then
            f2=A204_hnn_108_mrec_nuenue_cc(p2)
         elseif(i2.eq.11) then
            f2=A204_hnn_110_mrec_nuenue_cc(p2)
         elseif(i2.eq.12) then
            f2=A204_hnn_111_mrec_nuenue_cc(p2)
         elseif(i2.eq.13) then
            f2=A204_hnn_112_mrec_nuenue_cc(p2)
         elseif(i2.eq.14) then
            f2=A204_hnn_1128_mrec_nuenue_cc(p2)
         elseif(i2.eq.15) then
            f2=A204_hnn_114_mrec_nuenue_cc(p2)
         elseif(i2.eq.16) then
            f2=A204_hnn_115_mrec_nuenue_cc(p2)
         elseif(i2.eq.17) then
            f2=A204_hnn_116_mrec_nuenue_cc(p2)
         elseif(i2.eq.18) then
            f2=A204_hnn_118_mrec_nuenue_cc(p2)
         elseif(i2.eq.19) then
            f2=A204_hnn_120_mrec_nuenue_cc(p2)
         endif
      else
         f1=0.d0
         f2=0.d0
      endif
      f = f1*d2 + f2*d1
      if( f.lt.1.0D-09 ) f = 1.0d-09
      if    ( x.lt.massl .or. x.gt.massh ) then
         f = 0.0d0
      endif

      a2000_204_nn_mrec_sig = f
      end

      double precision function a2000_206_nn_mrec_sig(x,hmass,isig)
*Approximations made in mass shapes:  below 100 GeV, all H dec's 
*are used in shapes--no separation is done.  Above 100 GeV,
*gg,tautau,&&WW dec modes all use cc shape.  Shapes always separated
*by production mechanism.
      Implicit none
      Integer       isig,isig2
      Real*8        x, hmass
      logical first
      data first /.true./

      Real*8        massl, massh
      Data          massl, massh/ 50.0 ,114.8/

      Integer       mpnt, msig, jpnt, jsig
      Parameter   ( mpnt = 19 , msig = 4)
      Real*8        masst(mpnt), corpk(msig,mpnt)
      Data         (masst(jpnt), (corpk(jsig,jpnt),jsig=1,msig)
     &                                            ,jpnt=1,mpnt)
     & /75.d0,96.4483,96.4483,97.6878,97.6878
     $ ,80.d0,95.3457,95.3457,97.4379,97.4379
     $ ,85.d0,95.5870,95.5870,96.1862,96.1862
     $ ,90.d0,96.9369,96.9369,97.1497,97.1497
     $ ,95.d0,98.2610,98.2610,98.2139,98.2139
     $ ,100.d0,100.9300,101.2940,100.5940,100.3240
     $ ,104.d0,103.7480,103.9330,103.1430,103.3790
     $ ,106.d0,105.0400,105.3290,104.4190,105.2200
     $ ,108.d0,106.4670,106.6300,105.5830,106.4700
     $ ,110.d0,108.0680,108.4180,106.8970,107.1890
     $ ,112.d0,109.0040,109.9310,107.6050,108.9390
     $ ,113.d0,109.4580,109.9340,107.8360,107.4610
     $ ,114.d0,109.3800,110.8680,107.4480,106.8060
     $ ,114.8d0,108.8630,109.3120,107.0710,107.3380
     $ ,116.d0,108.1980,108.3860,106.4890,107.0530
     $ ,117.d0,108.0960,107.8910,106.2350,105.8330
     $ ,118.d0,107.9290,107.4820,106.2430,107.5340
     $ ,119.d0,107.7480,109.2090,106.3770,107.3690
     $ ,120.d0,107.4650,108.1330,106.3150,106.2500/
      Integer       i , i1, i2
      Real*8        c , c1, c2
     &            , d , d1, d2
     &            , f , f1, f2
     &            ,     p1, p2
     &            ,     n1, n2
      REAL*8 A206_hnn_75_mrec_nulnul,A206_hnn_75_mrec_nuenue
     & ,A206_hnn_80_mrec_nulnul,A206_hnn_80_mrec_nuenue
     & ,A206_hnn_85_mrec_nulnul,A206_hnn_85_mrec_nuenue
     & ,A206_hnn_90_mrec_nulnul,A206_hnn_90_mrec_nuenue
     & ,A206_hnn_95_mrec_nulnul,A206_hnn_95_mrec_nuenue
     & ,A206_hnn_100_mrec_nulnul_bb,A206_hnn_100_mrec_nuenue_bb
     & ,A206_hnn_100_mrec_nulnul_cc,A206_hnn_100_mrec_nuenue_cc
     & ,A206_hnn_104_mrec_nulnul_bb,A206_hnn_104_mrec_nuenue_bb
     & ,A206_hnn_104_mrec_nulnul_cc,A206_hnn_104_mrec_nuenue_cc
     & ,A206_hnn_106_mrec_nulnul_bb,A206_hnn_106_mrec_nuenue_bb
     & ,A206_hnn_106_mrec_nulnul_cc,A206_hnn_106_mrec_nuenue_cc
     & ,A206_hnn_108_mrec_nulnul_bb,A206_hnn_108_mrec_nuenue_bb
     & ,A206_hnn_108_mrec_nulnul_cc,A206_hnn_108_mrec_nuenue_cc
     & ,A206_hnn_110_mrec_nulnul_bb,A206_hnn_110_mrec_nuenue_bb
     & ,A206_hnn_110_mrec_nulnul_cc,A206_hnn_110_mrec_nuenue_cc
     & ,A206_hnn_112_mrec_nulnul_bb,A206_hnn_112_mrec_nuenue_bb
     & ,A206_hnn_112_mrec_nulnul_cc,A206_hnn_112_mrec_nuenue_cc
     & ,A206_hnn_113_mrec_nulnul_bb,A206_hnn_113_mrec_nuenue_bb
     & ,A206_hnn_113_mrec_nulnul_cc,A206_hnn_113_mrec_nuenue_cc
     & ,A206_hnn_114_mrec_nulnul_bb,A206_hnn_114_mrec_nuenue_bb
     & ,A206_hnn_114_mrec_nulnul_cc,A206_hnn_114_mrec_nuenue_cc
     & ,A206_hnn_1148_mrec_nulnul_bb,A206_hnn_1148_mrec_nuenue_bb
     & ,A206_hnn_1148_mrec_nulnul_cc,A206_hnn_1148_mrec_nuenue_cc
     & ,A206_hnn_116_mrec_nulnul_bb,A206_hnn_116_mrec_nuenue_bb
     & ,A206_hnn_116_mrec_nulnul_cc,A206_hnn_116_mrec_nuenue_cc
     & ,A206_hnn_117_mrec_nulnul_bb,A206_hnn_117_mrec_nuenue_bb
     & ,A206_hnn_117_mrec_nulnul_cc,A206_hnn_117_mrec_nuenue_cc
     & ,A206_hnn_118_mrec_nulnul_bb,A206_hnn_118_mrec_nuenue_bb
     & ,A206_hnn_118_mrec_nulnul_cc,A206_hnn_118_mrec_nuenue_cc
     & ,A206_hnn_119_mrec_nulnul_bb,A206_hnn_119_mrec_nuenue_bb
     & ,A206_hnn_119_mrec_nulnul_cc,A206_hnn_119_mrec_nuenue_cc
     & ,A206_hnn_120_mrec_nulnul_bb,A206_hnn_120_mrec_nuenue_bb
     & ,A206_hnn_120_mrec_nulnul_cc,A206_hnn_120_mrec_nuenue_cc
      external  A206_hnn_75_mrec_nulnul,A206_hnn_75_mrec_nuenue
     & ,A206_hnn_80_mrec_nulnul,A206_hnn_80_mrec_nuenue
     & ,A206_hnn_85_mrec_nulnul,A206_hnn_85_mrec_nuenue
     & ,A206_hnn_90_mrec_nulnul,A206_hnn_90_mrec_nuenue
     & ,A206_hnn_95_mrec_nulnul,A206_hnn_95_mrec_nuenue
     & ,A206_hnn_100_mrec_nulnul_bb,A206_hnn_100_mrec_nuenue_bb
     & ,A206_hnn_100_mrec_nulnul_cc,A206_hnn_100_mrec_nuenue_cc
     & ,A206_hnn_104_mrec_nulnul_bb,A206_hnn_104_mrec_nuenue_bb
     & ,A206_hnn_104_mrec_nulnul_cc,A206_hnn_104_mrec_nuenue_cc
     & ,A206_hnn_106_mrec_nulnul_bb,A206_hnn_106_mrec_nuenue_bb
     & ,A206_hnn_106_mrec_nulnul_cc,A206_hnn_106_mrec_nuenue_cc
     & ,A206_hnn_108_mrec_nulnul_bb,A206_hnn_108_mrec_nuenue_bb
     & ,A206_hnn_108_mrec_nulnul_cc,A206_hnn_108_mrec_nuenue_cc
     & ,A206_hnn_110_mrec_nulnul_bb,A206_hnn_110_mrec_nuenue_bb
     & ,A206_hnn_110_mrec_nulnul_cc,A206_hnn_110_mrec_nuenue_cc
     & ,A206_hnn_112_mrec_nulnul_bb,A206_hnn_112_mrec_nuenue_bb
     & ,A206_hnn_112_mrec_nulnul_cc,A206_hnn_112_mrec_nuenue_cc
     & ,A206_hnn_113_mrec_nulnul_bb,A206_hnn_113_mrec_nuenue_bb
     & ,A206_hnn_113_mrec_nulnul_cc,A206_hnn_113_mrec_nuenue_cc
     & ,A206_hnn_114_mrec_nulnul_bb,A206_hnn_114_mrec_nuenue_bb
     & ,A206_hnn_114_mrec_nulnul_cc,A206_hnn_114_mrec_nuenue_cc
     & ,A206_hnn_1148_mrec_nulnul_bb,A206_hnn_1148_mrec_nuenue_bb
     & ,A206_hnn_1148_mrec_nulnul_cc,A206_hnn_1148_mrec_nuenue_cc
     & ,A206_hnn_116_mrec_nulnul_bb,A206_hnn_116_mrec_nuenue_bb
     & ,A206_hnn_116_mrec_nulnul_cc,A206_hnn_116_mrec_nuenue_cc
     & ,A206_hnn_117_mrec_nulnul_bb,A206_hnn_117_mrec_nuenue_bb
     & ,A206_hnn_117_mrec_nulnul_cc,A206_hnn_117_mrec_nuenue_cc
     & ,A206_hnn_118_mrec_nulnul_bb,A206_hnn_118_mrec_nuenue_bb
     & ,A206_hnn_118_mrec_nulnul_cc,A206_hnn_118_mrec_nuenue_cc
     & ,A206_hnn_119_mrec_nulnul_bb,A206_hnn_119_mrec_nuenue_bb
     & ,A206_hnn_119_mrec_nulnul_cc,A206_hnn_119_mrec_nuenue_cc
     & ,A206_hnn_120_mrec_nulnul_bb,A206_hnn_120_mrec_nuenue_bb
     & ,A206_hnn_120_mrec_nulnul_cc,A206_hnn_120_mrec_nuenue_cc
      if    ( hmass.lt.masst(1   ) ) then
          i1 = 1
          i2 = 1
          d1 = 0.0
          d2 = 1.0
      elseif( hmass.ge.masst(mpnt) ) then
          i1 = mpnt
          i2 = mpnt
          d1 = 1.0
          d2 = 0.0
      else
          do i = 1, mpnt-1
          if( hmass.ge.masst(i) .and. hmass.lt.masst(i+1) ) then
          i1 = i
          i2 = i + 1
          endif
          enddo
          d  = masst(i2) - masst(i1)
          d1 = (hmass - masst(i1))/d
          d2 = (masst(i2) - hmass)/d
      endif
      if (isig.eq.1) then
         isig2=1
      elseif(isig.eq.2.or.isig.eq.3.or.isig.eq.4.or.isig.eq.5) then
         isig2=2
      elseif(isig.eq.6) then
         isig2=3
      elseif(isig.eq.7.or.isig.eq.8.or.isig.eq.9.or.isig.eq.10) then
         isig2=4
      else
         isig2=2
      endif
      c1 = corpk(isig2,i1)
      c2 = corpk(isig2,i2)
      c  = c1*d2 + c2*d1

* very painful procedure to get function values
* =============================================
      if(hmass.le.75.0) then
         if (x.ge.c) then
            p1 = x - c + corpk(isig2,i1)
            p2 = x - c + corpk(isig2,i2)
         else
            p1 = corpk(isig2,i1)-(c-x)/(c-massl)*(corpk(isig2,i1)-massl)
            p2 = corpk(isig2,i2)-(c-x)/(c-massl)*(corpk(isig2,i2)-massl)
         endif
      elseif(hmass.ge.massh) then
         if (x.le.c) then
            p1 = x - c + corpk(isig2,i1)
            p2 = x - c + corpk(isig2,i2)
         else
            p1 = corpk(isig2,i1)+(x-c)/(massh-c)*(massh-corpk(isig2,i1))
            p2 = corpk(isig2,i2)+(x-c)/(massh-c)*(massh-corpk(isig2,i2))
         endif
      else
         p1 = x - c + corpk(isig2,i1)
         p2 = x - c + corpk(isig2,i2)
      endif
      if (isig.eq.1) then
         if (i1.eq.1) then 
            f1=A206_hnn_75_mrec_nulnul(p1)
         elseif(i1.eq.2) then
            f1=A206_hnn_80_mrec_nulnul(p1)
         elseif(i1.eq.3) then
            f1=A206_hnn_85_mrec_nulnul(p1)
         elseif(i1.eq.4) then
            f1=A206_hnn_90_mrec_nulnul(p1)
         elseif(i1.eq.5) then
            f1=A206_hnn_95_mrec_nulnul(p1)
         elseif(i1.eq.6) then
            f1=A206_hnn_100_mrec_nulnul_bb(p1)
         elseif(i1.eq.7) then
            f1=A206_hnn_104_mrec_nulnul_bb(p1)
         elseif(i1.eq.8) then
            f1=A206_hnn_106_mrec_nulnul_bb(p1)
         elseif(i1.eq.9) then
            f1=A206_hnn_108_mrec_nulnul_bb(p1)
         elseif(i1.eq.10) then
            f1=A206_hnn_110_mrec_nulnul_bb(p1)
         elseif(i1.eq.11) then
            f1=A206_hnn_112_mrec_nulnul_bb(p1)
         elseif(i1.eq.12) then
            f1=A206_hnn_113_mrec_nulnul_bb(p1)
         elseif(i1.eq.13) then
            f1=A206_hnn_114_mrec_nulnul_bb(p1)
         elseif(i1.eq.14) then
            f1=A206_hnn_1148_mrec_nulnul_bb(p1)
         elseif(i1.eq.15) then
            f1=A206_hnn_116_mrec_nulnul_bb(p1)
         elseif(i1.eq.16) then
            f1=A206_hnn_117_mrec_nulnul_bb(p1)
         elseif(i1.eq.17) then
            f1=A206_hnn_118_mrec_nulnul_bb(p1)
         elseif(i1.eq.18) then
            f1=A206_hnn_119_mrec_nulnul_bb(p1)
         elseif(i1.eq.19) then
            f1=A206_hnn_120_mrec_nulnul_bb(p1)
         endif
         if (i2.eq.1) then
            f2=A206_hnn_75_mrec_nulnul(p2)
         elseif(i2.eq.2) then
            f2=A206_hnn_80_mrec_nulnul(p2)
         elseif(i2.eq.3) then
            f2=A206_hnn_85_mrec_nulnul(p2)
         elseif(i2.eq.4) then
            f2=A206_hnn_90_mrec_nulnul(p2)
         elseif(i2.eq.5) then
            f2=A206_hnn_95_mrec_nulnul(p2)
         elseif(i2.eq.6) then
            f2=A206_hnn_100_mrec_nulnul_bb(p2)
         elseif(i2.eq.7) then
            f2=A206_hnn_104_mrec_nulnul_bb(p2)
         elseif(i2.eq.8) then
            f2=A206_hnn_106_mrec_nulnul_bb(p2)
         elseif(i2.eq.9) then
            f2=A206_hnn_108_mrec_nulnul_bb(p2)
         elseif(i2.eq.10) then
            f2=A206_hnn_110_mrec_nulnul_bb(p2)
         elseif(i2.eq.11) then
            f2=A206_hnn_112_mrec_nulnul_bb(p2)
         elseif(i2.eq.12) then
            f2=A206_hnn_113_mrec_nulnul_bb(p2)
         elseif(i2.eq.13) then
            f2=A206_hnn_114_mrec_nulnul_bb(p2)
         elseif(i2.eq.14) then
            f2=A206_hnn_1148_mrec_nulnul_bb(p2)
         elseif(i2.eq.15) then
            f2=A206_hnn_116_mrec_nulnul_bb(p2)
         elseif(i2.eq.16) then
            f2=A206_hnn_117_mrec_nulnul_bb(p2)
         elseif(i2.eq.17) then
            f2=A206_hnn_118_mrec_nulnul_bb(p2)
         elseif(i2.eq.18) then
            f2=A206_hnn_119_mrec_nulnul_bb(p2)
         elseif(i2.eq.19) then
            f2=A206_hnn_120_mrec_nulnul_bb(p2)
         endif
      elseif(isig.eq.2.or.isig.eq.3.or.isig.eq.4.or.isig.eq.5) then
         if (i1.eq.1) then 
            f1=A206_hnn_75_mrec_nulnul(p1)
         elseif(i1.eq.2) then
            f1=A206_hnn_80_mrec_nulnul(p1)
         elseif(i1.eq.3) then
            f1=A206_hnn_85_mrec_nulnul(p1)
         elseif(i1.eq.4) then
            f1=A206_hnn_90_mrec_nulnul(p1)
         elseif(i1.eq.5) then
            f1=A206_hnn_95_mrec_nulnul(p1)
         elseif(i1.eq.6) then
            f1=A206_hnn_100_mrec_nulnul_cc(p1)
         elseif(i1.eq.7) then
            f1=A206_hnn_104_mrec_nulnul_cc(p1)
         elseif(i1.eq.8) then
            f1=A206_hnn_106_mrec_nulnul_cc(p1)
         elseif(i1.eq.9) then
            f1=A206_hnn_108_mrec_nulnul_cc(p1)
         elseif(i1.eq.10) then
            f1=A206_hnn_110_mrec_nulnul_cc(p1)
         elseif(i1.eq.11) then
            f1=A206_hnn_112_mrec_nulnul_cc(p1)
         elseif(i1.eq.12) then
            f1=A206_hnn_113_mrec_nulnul_cc(p1)
         elseif(i1.eq.13) then
            f1=A206_hnn_114_mrec_nulnul_cc(p1)
         elseif(i1.eq.14) then
            f1=A206_hnn_1148_mrec_nulnul_cc(p1)
         elseif(i1.eq.15) then
            f1=A206_hnn_116_mrec_nulnul_cc(p1)
         elseif(i1.eq.16) then
            f1=A206_hnn_117_mrec_nulnul_cc(p1)
         elseif(i1.eq.17) then
            f1=A206_hnn_118_mrec_nulnul_cc(p1)
         elseif(i1.eq.18) then
            f1=A206_hnn_119_mrec_nulnul_cc(p1)
         elseif(i1.eq.19) then
            f1=A206_hnn_120_mrec_nulnul_cc(p1)
         endif
         if (i2.eq.1) then
            f2=A206_hnn_75_mrec_nulnul(p2)
         elseif(i2.eq.2) then
            f2=A206_hnn_80_mrec_nulnul(p2)
         elseif(i2.eq.3) then
            f2=A206_hnn_85_mrec_nulnul(p2)
         elseif(i2.eq.4) then
            f2=A206_hnn_90_mrec_nulnul(p2)
         elseif(i2.eq.5) then
            f2=A206_hnn_95_mrec_nulnul(p2)
         elseif(i2.eq.6) then
            f2=A206_hnn_100_mrec_nulnul_cc(p2)
         elseif(i2.eq.7) then
            f2=A206_hnn_104_mrec_nulnul_cc(p2)
         elseif(i2.eq.8) then
            f2=A206_hnn_106_mrec_nulnul_cc(p2)
         elseif(i2.eq.9) then
            f2=A206_hnn_108_mrec_nulnul_cc(p2)
         elseif(i2.eq.10) then
            f2=A206_hnn_110_mrec_nulnul_cc(p2)
         elseif(i2.eq.11) then
            f2=A206_hnn_112_mrec_nulnul_cc(p2)
         elseif(i2.eq.12) then
            f2=A206_hnn_113_mrec_nulnul_cc(p2)
         elseif(i2.eq.13) then
            f2=A206_hnn_114_mrec_nulnul_cc(p2)
         elseif(i2.eq.14) then
            f2=A206_hnn_1148_mrec_nulnul_cc(p2)
         elseif(i2.eq.15) then
            f2=A206_hnn_116_mrec_nulnul_cc(p2)
         elseif(i2.eq.16) then
            f2=A206_hnn_117_mrec_nulnul_cc(p2)
         elseif(i2.eq.17) then
            f2=A206_hnn_118_mrec_nulnul_cc(p2)
         elseif(i2.eq.18) then
            f2=A206_hnn_119_mrec_nulnul_cc(p2)
         elseif(i2.eq.19) then
            f2=A206_hnn_120_mrec_nulnul_cc(p2)
         endif
      elseif (isig.eq.6) then
         if (i1.eq.1) then 
            f1=A206_hnn_75_mrec_nuenue(p1)
         elseif(i1.eq.2) then
            f1=A206_hnn_80_mrec_nuenue(p1)
         elseif(i1.eq.3) then
            f1=A206_hnn_85_mrec_nuenue(p1)
         elseif(i1.eq.4) then
            f1=A206_hnn_90_mrec_nuenue(p1)
         elseif(i1.eq.5) then
            f1=A206_hnn_95_mrec_nuenue(p1)
         elseif(i1.eq.6) then
            f1=A206_hnn_100_mrec_nuenue_bb(p1)
         elseif(i1.eq.7) then
            f1=A206_hnn_104_mrec_nuenue_bb(p1)
         elseif(i1.eq.8) then
            f1=A206_hnn_106_mrec_nuenue_bb(p1)
         elseif(i1.eq.9) then
            f1=A206_hnn_108_mrec_nuenue_bb(p1)
         elseif(i1.eq.10) then
            f1=A206_hnn_110_mrec_nuenue_bb(p1)
         elseif(i1.eq.11) then
            f1=A206_hnn_112_mrec_nuenue_bb(p1)
         elseif(i1.eq.12) then
            f1=A206_hnn_113_mrec_nuenue_bb(p1)
         elseif(i1.eq.13) then
            f1=A206_hnn_114_mrec_nuenue_bb(p1)
         elseif(i1.eq.14) then
            f1=A206_hnn_1148_mrec_nuenue_bb(p1)
         elseif(i1.eq.15) then
            f1=A206_hnn_116_mrec_nuenue_bb(p1)
         elseif(i1.eq.16) then
            f1=A206_hnn_117_mrec_nuenue_bb(p1)
         elseif(i1.eq.17) then
            f1=A206_hnn_118_mrec_nuenue_bb(p1)
         elseif(i1.eq.18) then
            f1=A206_hnn_119_mrec_nuenue_bb(p1)
         elseif(i1.eq.19) then
            f1=A206_hnn_120_mrec_nuenue_bb(p1)
         endif
         if (i2.eq.1) then
            f2=A206_hnn_75_mrec_nuenue(p2)
         elseif(i2.eq.2) then
            f2=A206_hnn_80_mrec_nuenue(p2)
         elseif(i2.eq.3) then
            f2=A206_hnn_85_mrec_nuenue(p2)
         elseif(i2.eq.4) then
            f2=A206_hnn_90_mrec_nuenue(p2)
         elseif(i2.eq.5) then
            f2=A206_hnn_95_mrec_nuenue(p2)
         elseif(i2.eq.6) then
            f2=A206_hnn_100_mrec_nuenue_bb(p2)
         elseif(i2.eq.7) then
            f2=A206_hnn_104_mrec_nuenue_bb(p2)
         elseif(i2.eq.8) then
            f2=A206_hnn_106_mrec_nuenue_bb(p2)
         elseif(i2.eq.9) then
            f2=A206_hnn_108_mrec_nuenue_bb(p2)
         elseif(i2.eq.10) then
            f2=A206_hnn_110_mrec_nuenue_bb(p2)
         elseif(i2.eq.11) then
            f2=A206_hnn_112_mrec_nuenue_bb(p2)
         elseif(i2.eq.12) then
            f2=A206_hnn_113_mrec_nuenue_bb(p2)
         elseif(i2.eq.13) then
            f2=A206_hnn_114_mrec_nuenue_bb(p2)
         elseif(i2.eq.14) then
            f2=A206_hnn_1148_mrec_nuenue_bb(p2)
         elseif(i2.eq.15) then
            f2=A206_hnn_116_mrec_nuenue_bb(p2)
         elseif(i2.eq.16) then
            f2=A206_hnn_117_mrec_nuenue_bb(p2)
         elseif(i2.eq.17) then
            f2=A206_hnn_118_mrec_nuenue_bb(p2)
         elseif(i2.eq.18) then
            f2=A206_hnn_119_mrec_nuenue_bb(p2)
         elseif(i2.eq.19) then
            f2=A206_hnn_120_mrec_nuenue_bb(p2)
         endif
      elseif(isig.eq.7.or.isig.eq.8.or.isig.eq.9.or.isig.eq.10) then
         if (i1.eq.1) then 
            f1=A206_hnn_75_mrec_nuenue(p1)
         elseif(i1.eq.2) then
            f1=A206_hnn_80_mrec_nuenue(p1)
         elseif(i1.eq.3) then
            f1=A206_hnn_85_mrec_nuenue(p1)
         elseif(i1.eq.4) then
            f1=A206_hnn_90_mrec_nuenue(p1)
         elseif(i1.eq.5) then
            f1=A206_hnn_95_mrec_nuenue(p1)
         elseif(i1.eq.6) then
            f1=A206_hnn_100_mrec_nuenue_cc(p1)
         elseif(i1.eq.7) then
            f1=A206_hnn_104_mrec_nuenue_cc(p1)
         elseif(i1.eq.8) then
            f1=A206_hnn_106_mrec_nuenue_cc(p1)
         elseif(i1.eq.9) then
            f1=A206_hnn_108_mrec_nuenue_cc(p1)
         elseif(i1.eq.10) then
            f1=A206_hnn_110_mrec_nuenue_cc(p1)
         elseif(i1.eq.11) then
            f1=A206_hnn_112_mrec_nuenue_cc(p1)
         elseif(i1.eq.12) then
            f1=A206_hnn_113_mrec_nuenue_cc(p1)
         elseif(i1.eq.13) then
            f1=A206_hnn_114_mrec_nuenue_cc(p1)
         elseif(i1.eq.14) then
            f1=A206_hnn_1148_mrec_nuenue_cc(p1)
         elseif(i1.eq.15) then
            f1=A206_hnn_116_mrec_nuenue_cc(p1)
         elseif(i1.eq.16) then
            f1=A206_hnn_117_mrec_nuenue_cc(p1)
         elseif(i1.eq.17) then
            f1=A206_hnn_118_mrec_nuenue_cc(p1)
         elseif(i1.eq.18) then
            f1=A206_hnn_119_mrec_nuenue_cc(p1)
         elseif(i1.eq.19) then
            f1=A206_hnn_120_mrec_nuenue_cc(p1)
         endif
         if (i2.eq.1) then
            f2=A206_hnn_75_mrec_nuenue(p2)
         elseif(i2.eq.2) then
            f2=A206_hnn_80_mrec_nuenue(p2)
         elseif(i2.eq.3) then
            f2=A206_hnn_85_mrec_nuenue(p2)
         elseif(i2.eq.4) then
            f2=A206_hnn_90_mrec_nuenue(p2)
         elseif(i2.eq.5) then
            f2=A206_hnn_95_mrec_nuenue(p2)
         elseif(i2.eq.6) then
            f2=A206_hnn_100_mrec_nuenue_cc(p2)
         elseif(i2.eq.7) then
            f2=A206_hnn_104_mrec_nuenue_cc(p2)
         elseif(i2.eq.8) then
            f2=A206_hnn_106_mrec_nuenue_cc(p2)
         elseif(i2.eq.9) then
            f2=A206_hnn_108_mrec_nuenue_cc(p2)
         elseif(i2.eq.10) then
            f2=A206_hnn_110_mrec_nuenue_cc(p2)
         elseif(i2.eq.11) then
            f2=A206_hnn_112_mrec_nuenue_cc(p2)
         elseif(i2.eq.12) then
            f2=A206_hnn_113_mrec_nuenue_cc(p2)
         elseif(i2.eq.13) then
            f2=A206_hnn_114_mrec_nuenue_cc(p2)
         elseif(i2.eq.14) then
            f2=A206_hnn_1148_mrec_nuenue_cc(p2)
         elseif(i2.eq.15) then
            f2=A206_hnn_116_mrec_nuenue_cc(p2)
         elseif(i2.eq.16) then
            f2=A206_hnn_117_mrec_nuenue_cc(p2)
         elseif(i2.eq.17) then
            f2=A206_hnn_118_mrec_nuenue_cc(p2)
         elseif(i2.eq.18) then
            f2=A206_hnn_119_mrec_nuenue_cc(p2)
         elseif(i2.eq.19) then
            f2=A206_hnn_120_mrec_nuenue_cc(p2)
         endif
      else
         f1=0.d0
         f2=0.d0
      endif
      f = f1*d2 + f2*d1
      if( f.lt.1.0D-09 ) f = 1.0d-09
      if    ( x.lt.massl .or. x.gt.massh ) then
         f = 0.0d0
      endif

      a2000_206_nn_mrec_sig = f
      end

      double precision function a2000_208_nn_mrec_sig(x,hmass,isig)
*Approximations made in mass shapes:  below 100 GeV, all H dec's 
*are used in shapes--no separation is done.  Above 100 GeV,
*gg,tautau,&&WW dec modes all use cc shape.  Shapes always separated
*by production mechanism.
      Implicit none
      Integer       isig,isig2
      Real*8        x, hmass
      logical first
      data first /.true./

      Real*8        massl, massh
      Data          massl, massh/ 50.0 ,116.8/

      Integer       mpnt, msig, jpnt, jsig
      Parameter   ( mpnt = 19 , msig = 4)
      Real*8        masst(mpnt), corpk(msig,mpnt)
      Data         (masst(jpnt), (corpk(jsig,jpnt),jsig=1,msig)
     &                                            ,jpnt=1,mpnt)
     & /75.d0,98.2741,98.2741,100.2920,100.2920
     $ ,80.d0,97.9497,97.9497,99.2481,99.2481
     $ ,85.d0,97.8300,97.8300,98.5149,98.5149
     $ ,90.d0,98.4393,98.4393,99.1834,99.1834
     $ ,95.d0,99.8121,99.8121,99.7251,99.7251
     $ ,100.d0,101.7160,102.6490,101.5110,101.1160
     $ ,104.d0,104.1770,105.1160,103.8360,104.0340
     $ ,106.d0,105.5970,105.9400,105.0250,105.9010
     $ ,108.d0,107.0500,107.5200,106.5050,107.2610
     $ ,110.d0,108.6710,109.4670,107.7510,108.1820
     $ ,112.d0,109.8510,110.2120,108.8190,108.9120
     $ ,113.d0,110.4650,111.3970,109.2550,110.0050
     $ ,114.d0,110.9480,111.9110,109.6460,110.6830
     $ ,115.d0,111.3180,111.6660,109.7470,111.5670
     $ ,116.d0,111.1850,112.4180,109.4790,111.2860
     $ ,116.8d0,111.1650,111.1920,109.0550,110.7310
     $ ,118.d0,110.4990,112.1960,108.4330,110.3620
     $ ,119.d0,110.2050,111.0600,108.6540,108.5320
     $ ,120.d0,110.0320,110.6040,108.2730,108.0620/
      Integer       i , i1, i2
      Real*8        c , c1, c2
     &            , d , d1, d2
     &            , f , f1, f2
     &            ,     p1, p2
     &            ,     n1, n2
      REAL*8 A208_hnn_75_mrec_nulnul,A208_hnn_75_mrec_nuenue
     & ,A208_hnn_80_mrec_nulnul,A208_hnn_80_mrec_nuenue
     & ,A208_hnn_85_mrec_nulnul,A208_hnn_85_mrec_nuenue
     & ,A208_hnn_90_mrec_nulnul,A208_hnn_90_mrec_nuenue
     & ,A208_hnn_95_mrec_nulnul,A208_hnn_95_mrec_nuenue
     & ,A208_hnn_100_mrec_nulnul_bb,A208_hnn_100_mrec_nuenue_bb
     & ,A208_hnn_100_mrec_nulnul_cc,A208_hnn_100_mrec_nuenue_cc
     & ,A208_hnn_104_mrec_nulnul_bb,A208_hnn_104_mrec_nuenue_bb
     & ,A208_hnn_104_mrec_nulnul_cc,A208_hnn_104_mrec_nuenue_cc
     & ,A208_hnn_106_mrec_nulnul_bb,A208_hnn_106_mrec_nuenue_bb
     & ,A208_hnn_106_mrec_nulnul_cc,A208_hnn_106_mrec_nuenue_cc
     & ,A208_hnn_108_mrec_nulnul_bb,A208_hnn_108_mrec_nuenue_bb
     & ,A208_hnn_108_mrec_nulnul_cc,A208_hnn_108_mrec_nuenue_cc
     & ,A208_hnn_110_mrec_nulnul_bb,A208_hnn_110_mrec_nuenue_bb
     & ,A208_hnn_110_mrec_nulnul_cc,A208_hnn_110_mrec_nuenue_cc
     & ,A208_hnn_112_mrec_nulnul_bb,A208_hnn_112_mrec_nuenue_bb
     & ,A208_hnn_112_mrec_nulnul_cc,A208_hnn_112_mrec_nuenue_cc
     & ,A208_hnn_113_mrec_nulnul_bb,A208_hnn_113_mrec_nuenue_bb
     & ,A208_hnn_113_mrec_nulnul_cc,A208_hnn_113_mrec_nuenue_cc
     & ,A208_hnn_114_mrec_nulnul_bb,A208_hnn_114_mrec_nuenue_bb
     & ,A208_hnn_114_mrec_nulnul_cc,A208_hnn_114_mrec_nuenue_cc
     & ,A208_hnn_115_mrec_nulnul_bb,A208_hnn_115_mrec_nuenue_bb
     & ,A208_hnn_115_mrec_nulnul_cc,A208_hnn_115_mrec_nuenue_cc
     & ,A208_hnn_116_mrec_nulnul_bb,A208_hnn_116_mrec_nuenue_bb
     & ,A208_hnn_116_mrec_nulnul_cc,A208_hnn_116_mrec_nuenue_cc
     & ,A208_hnn_1168_mrec_nulnul_bb,A208_hnn_1168_mrec_nuenue_bb
     & ,A208_hnn_1168_mrec_nulnul_cc,A208_hnn_1168_mrec_nuenue_cc
     & ,A208_hnn_118_mrec_nulnul_bb,A208_hnn_118_mrec_nuenue_bb
     & ,A208_hnn_118_mrec_nulnul_cc,A208_hnn_118_mrec_nuenue_cc
     & ,A208_hnn_119_mrec_nulnul_bb,A208_hnn_119_mrec_nuenue_bb
     & ,A208_hnn_119_mrec_nulnul_cc,A208_hnn_119_mrec_nuenue_cc
     & ,A208_hnn_120_mrec_nulnul_bb,A208_hnn_120_mrec_nuenue_bb
     & ,A208_hnn_120_mrec_nulnul_cc,A208_hnn_120_mrec_nuenue_cc
      external  A208_hnn_75_mrec_nulnul,A208_hnn_75_mrec_nuenue
     & ,A208_hnn_80_mrec_nulnul,A208_hnn_80_mrec_nuenue
     & ,A208_hnn_85_mrec_nulnul,A208_hnn_85_mrec_nuenue
     & ,A208_hnn_90_mrec_nulnul,A208_hnn_90_mrec_nuenue
     & ,A208_hnn_95_mrec_nulnul,A208_hnn_95_mrec_nuenue
     & ,A208_hnn_100_mrec_nulnul_bb,A208_hnn_100_mrec_nuenue_bb
     & ,A208_hnn_100_mrec_nulnul_cc,A208_hnn_100_mrec_nuenue_cc
     & ,A208_hnn_104_mrec_nulnul_bb,A208_hnn_104_mrec_nuenue_bb
     & ,A208_hnn_104_mrec_nulnul_cc,A208_hnn_104_mrec_nuenue_cc
     & ,A208_hnn_106_mrec_nulnul_bb,A208_hnn_106_mrec_nuenue_bb
     & ,A208_hnn_106_mrec_nulnul_cc,A208_hnn_106_mrec_nuenue_cc
     & ,A208_hnn_108_mrec_nulnul_bb,A208_hnn_108_mrec_nuenue_bb
     & ,A208_hnn_108_mrec_nulnul_cc,A208_hnn_108_mrec_nuenue_cc
     & ,A208_hnn_110_mrec_nulnul_bb,A208_hnn_110_mrec_nuenue_bb
     & ,A208_hnn_110_mrec_nulnul_cc,A208_hnn_110_mrec_nuenue_cc
     & ,A208_hnn_112_mrec_nulnul_bb,A208_hnn_112_mrec_nuenue_bb
     & ,A208_hnn_112_mrec_nulnul_cc,A208_hnn_112_mrec_nuenue_cc
     & ,A208_hnn_113_mrec_nulnul_bb,A208_hnn_113_mrec_nuenue_bb
     & ,A208_hnn_113_mrec_nulnul_cc,A208_hnn_113_mrec_nuenue_cc
     & ,A208_hnn_114_mrec_nulnul_bb,A208_hnn_114_mrec_nuenue_bb
     & ,A208_hnn_114_mrec_nulnul_cc,A208_hnn_114_mrec_nuenue_cc
     & ,A208_hnn_115_mrec_nulnul_bb,A208_hnn_115_mrec_nuenue_bb
     & ,A208_hnn_115_mrec_nulnul_cc,A208_hnn_115_mrec_nuenue_cc
     & ,A208_hnn_116_mrec_nulnul_bb,A208_hnn_116_mrec_nuenue_bb
     & ,A208_hnn_116_mrec_nulnul_cc,A208_hnn_116_mrec_nuenue_cc
     & ,A208_hnn_1168_mrec_nulnul_bb,A208_hnn_1168_mrec_nuenue_bb
     & ,A208_hnn_1168_mrec_nulnul_cc,A208_hnn_1168_mrec_nuenue_cc
     & ,A208_hnn_118_mrec_nulnul_bb,A208_hnn_118_mrec_nuenue_bb
     & ,A208_hnn_118_mrec_nulnul_cc,A208_hnn_118_mrec_nuenue_cc
     & ,A208_hnn_119_mrec_nulnul_bb,A208_hnn_119_mrec_nuenue_bb
     & ,A208_hnn_119_mrec_nulnul_cc,A208_hnn_119_mrec_nuenue_cc
     & ,A208_hnn_120_mrec_nulnul_bb,A208_hnn_120_mrec_nuenue_bb
     & ,A208_hnn_120_mrec_nulnul_cc,A208_hnn_120_mrec_nuenue_cc
      if    ( hmass.lt.masst(1   ) ) then
          i1 = 1
          i2 = 1
          d1 = 0.0
          d2 = 1.0
      elseif( hmass.ge.masst(mpnt) ) then
          i1 = mpnt
          i2 = mpnt
          d1 = 1.0
          d2 = 0.0
      else
          do i = 1, mpnt-1
          if( hmass.ge.masst(i) .and. hmass.lt.masst(i+1) ) then
          i1 = i
          i2 = i + 1
          endif
          enddo
          d  = masst(i2) - masst(i1)
          d1 = (hmass - masst(i1))/d
          d2 = (masst(i2) - hmass)/d
      endif
      if (isig.eq.1) then
         isig2=1
      elseif(isig.eq.2.or.isig.eq.3.or.isig.eq.4.or.isig.eq.5) then
         isig2=2
      elseif(isig.eq.6) then
         isig2=3
      elseif(isig.eq.7.or.isig.eq.8.or.isig.eq.9.or.isig.eq.10) then
         isig2=4
      else
         isig2=2
      endif
      c1 = corpk(isig2,i1)
      c2 = corpk(isig2,i2)
      c  = c1*d2 + c2*d1

* very painful procedure to get function values
* =============================================
      if(hmass.le.75.0) then
         if (x.ge.c) then
            p1 = x - c + corpk(isig2,i1)
            p2 = x - c + corpk(isig2,i2)
         else
            p1 = corpk(isig2,i1)-(c-x)/(c-massl)*(corpk(isig2,i1)-massl)
            p2 = corpk(isig2,i2)-(c-x)/(c-massl)*(corpk(isig2,i2)-massl)
         endif
      elseif(hmass.ge.massh) then
         if (x.le.c) then
            p1 = x - c + corpk(isig2,i1)
            p2 = x - c + corpk(isig2,i2)
         else
            p1 = corpk(isig2,i1)+(x-c)/(massh-c)*(massh-corpk(isig2,i1))
            p2 = corpk(isig2,i2)+(x-c)/(massh-c)*(massh-corpk(isig2,i2))
         endif
      else
         p1 = x - c + corpk(isig2,i1)
         p2 = x - c + corpk(isig2,i2)
      endif
      if (isig.eq.1) then
         if (i1.eq.1) then 
            f1=A208_hnn_75_mrec_nulnul(p1)
         elseif(i1.eq.2) then
            f1=A208_hnn_80_mrec_nulnul(p1)
         elseif(i1.eq.3) then
            f1=A208_hnn_85_mrec_nulnul(p1)
         elseif(i1.eq.4) then
            f1=A208_hnn_90_mrec_nulnul(p1)
         elseif(i1.eq.5) then
            f1=A208_hnn_95_mrec_nulnul(p1)
         elseif(i1.eq.6) then
            f1=A208_hnn_100_mrec_nulnul_bb(p1)
         elseif(i1.eq.7) then
            f1=A208_hnn_104_mrec_nulnul_bb(p1)
         elseif(i1.eq.8) then
            f1=A208_hnn_106_mrec_nulnul_bb(p1)
         elseif(i1.eq.9) then
            f1=A208_hnn_108_mrec_nulnul_bb(p1)
         elseif(i1.eq.10) then
            f1=A208_hnn_110_mrec_nulnul_bb(p1)
         elseif(i1.eq.11) then
            f1=A208_hnn_112_mrec_nulnul_bb(p1)
         elseif(i1.eq.12) then
            f1=A208_hnn_113_mrec_nulnul_bb(p1)
         elseif(i1.eq.13) then
            f1=A208_hnn_114_mrec_nulnul_bb(p1)
         elseif(i1.eq.14) then
            f1=A208_hnn_115_mrec_nulnul_bb(p1)
         elseif(i1.eq.15) then
            f1=A208_hnn_116_mrec_nulnul_bb(p1)
         elseif(i1.eq.16) then
            f1=A208_hnn_1168_mrec_nulnul_bb(p1)
         elseif(i1.eq.17) then
            f1=A208_hnn_118_mrec_nulnul_bb(p1)
         elseif(i1.eq.18) then
            f1=A208_hnn_119_mrec_nulnul_bb(p1)
         elseif(i1.eq.19) then
            f1=A208_hnn_120_mrec_nulnul_bb(p1)
         endif
         if (i2.eq.1) then
            f2=A208_hnn_75_mrec_nulnul(p2)
         elseif(i2.eq.2) then
            f2=A208_hnn_80_mrec_nulnul(p2)
         elseif(i2.eq.3) then
            f2=A208_hnn_85_mrec_nulnul(p2)
         elseif(i2.eq.4) then
            f2=A208_hnn_90_mrec_nulnul(p2)
         elseif(i2.eq.5) then
            f2=A208_hnn_95_mrec_nulnul(p2)
         elseif(i2.eq.6) then
            f2=A208_hnn_100_mrec_nulnul_bb(p2)
         elseif(i2.eq.7) then
            f2=A208_hnn_104_mrec_nulnul_bb(p2)
         elseif(i2.eq.8) then
            f2=A208_hnn_106_mrec_nulnul_bb(p2)
         elseif(i2.eq.9) then
            f2=A208_hnn_108_mrec_nulnul_bb(p2)
         elseif(i2.eq.10) then
            f2=A208_hnn_110_mrec_nulnul_bb(p2)
         elseif(i2.eq.11) then
            f2=A208_hnn_112_mrec_nulnul_bb(p2)
         elseif(i2.eq.12) then
            f2=A208_hnn_113_mrec_nulnul_bb(p2)
         elseif(i2.eq.13) then
            f2=A208_hnn_114_mrec_nulnul_bb(p2)
         elseif(i2.eq.14) then
            f2=A208_hnn_115_mrec_nulnul_bb(p2)
         elseif(i2.eq.15) then
            f2=A208_hnn_116_mrec_nulnul_bb(p2)
         elseif(i2.eq.16) then
            f2=A208_hnn_1168_mrec_nulnul_bb(p2)
         elseif(i2.eq.17) then
            f2=A208_hnn_118_mrec_nulnul_bb(p2)
         elseif(i2.eq.18) then
            f2=A208_hnn_119_mrec_nulnul_bb(p2)
         elseif(i2.eq.19) then
            f2=A208_hnn_120_mrec_nulnul_bb(p2)
         endif
      elseif(isig.eq.2.or.isig.eq.3.or.isig.eq.4.or.isig.eq.5) then
         if (i1.eq.1) then 
            f1=A208_hnn_75_mrec_nulnul(p1)
         elseif(i1.eq.2) then
            f1=A208_hnn_80_mrec_nulnul(p1)
         elseif(i1.eq.3) then
            f1=A208_hnn_85_mrec_nulnul(p1)
         elseif(i1.eq.4) then
            f1=A208_hnn_90_mrec_nulnul(p1)
         elseif(i1.eq.5) then
            f1=A208_hnn_95_mrec_nulnul(p1)
         elseif(i1.eq.6) then
            f1=A208_hnn_100_mrec_nulnul_cc(p1)
         elseif(i1.eq.7) then
            f1=A208_hnn_104_mrec_nulnul_cc(p1)
         elseif(i1.eq.8) then
            f1=A208_hnn_106_mrec_nulnul_cc(p1)
         elseif(i1.eq.9) then
            f1=A208_hnn_108_mrec_nulnul_cc(p1)
         elseif(i1.eq.10) then
            f1=A208_hnn_110_mrec_nulnul_cc(p1)
         elseif(i1.eq.11) then
            f1=A208_hnn_112_mrec_nulnul_cc(p1)
         elseif(i1.eq.12) then
            f1=A208_hnn_113_mrec_nulnul_cc(p1)
         elseif(i1.eq.13) then
            f1=A208_hnn_114_mrec_nulnul_cc(p1)
         elseif(i1.eq.14) then
            f1=A208_hnn_115_mrec_nulnul_cc(p1)
         elseif(i1.eq.15) then
            f1=A208_hnn_116_mrec_nulnul_cc(p1)
         elseif(i1.eq.16) then
            f1=A208_hnn_1168_mrec_nulnul_cc(p1)
         elseif(i1.eq.17) then
            f1=A208_hnn_118_mrec_nulnul_cc(p1)
         elseif(i1.eq.18) then
            f1=A208_hnn_119_mrec_nulnul_cc(p1)
         elseif(i1.eq.19) then
            f1=A208_hnn_120_mrec_nulnul_cc(p1)
         endif
         if (i2.eq.1) then
            f2=A208_hnn_75_mrec_nulnul(p2)
         elseif(i2.eq.2) then
            f2=A208_hnn_80_mrec_nulnul(p2)
         elseif(i2.eq.3) then
            f2=A208_hnn_85_mrec_nulnul(p2)
         elseif(i2.eq.4) then
            f2=A208_hnn_90_mrec_nulnul(p2)
         elseif(i2.eq.5) then
            f2=A208_hnn_95_mrec_nulnul(p2)
         elseif(i2.eq.6) then
            f2=A208_hnn_100_mrec_nulnul_cc(p2)
         elseif(i2.eq.7) then
            f2=A208_hnn_104_mrec_nulnul_cc(p2)
         elseif(i2.eq.8) then
            f2=A208_hnn_106_mrec_nulnul_cc(p2)
         elseif(i2.eq.9) then
            f2=A208_hnn_108_mrec_nulnul_cc(p2)
         elseif(i2.eq.10) then
            f2=A208_hnn_110_mrec_nulnul_cc(p2)
         elseif(i2.eq.11) then
            f2=A208_hnn_112_mrec_nulnul_cc(p2)
         elseif(i2.eq.12) then
            f2=A208_hnn_113_mrec_nulnul_cc(p2)
         elseif(i2.eq.13) then
            f2=A208_hnn_114_mrec_nulnul_cc(p2)
         elseif(i2.eq.14) then
            f2=A208_hnn_115_mrec_nulnul_cc(p2)
         elseif(i2.eq.15) then
            f2=A208_hnn_116_mrec_nulnul_cc(p2)
         elseif(i2.eq.16) then
            f2=A208_hnn_1168_mrec_nulnul_cc(p2)
         elseif(i2.eq.17) then
            f2=A208_hnn_118_mrec_nulnul_cc(p2)
         elseif(i2.eq.18) then
            f2=A208_hnn_119_mrec_nulnul_cc(p2)
         elseif(i2.eq.19) then
            f2=A208_hnn_120_mrec_nulnul_cc(p2)
         endif
      elseif (isig.eq.6) then
         if (i1.eq.1) then 
            f1=A208_hnn_75_mrec_nuenue(p1)
         elseif(i1.eq.2) then
            f1=A208_hnn_80_mrec_nuenue(p1)
         elseif(i1.eq.3) then
            f1=A208_hnn_85_mrec_nuenue(p1)
         elseif(i1.eq.4) then
            f1=A208_hnn_90_mrec_nuenue(p1)
         elseif(i1.eq.5) then
            f1=A208_hnn_95_mrec_nuenue(p1)
         elseif(i1.eq.6) then
            f1=A208_hnn_100_mrec_nuenue_bb(p1)
         elseif(i1.eq.7) then
            f1=A208_hnn_104_mrec_nuenue_bb(p1)
         elseif(i1.eq.8) then
            f1=A208_hnn_106_mrec_nuenue_bb(p1)
         elseif(i1.eq.9) then
            f1=A208_hnn_108_mrec_nuenue_bb(p1)
         elseif(i1.eq.10) then
            f1=A208_hnn_110_mrec_nuenue_bb(p1)
         elseif(i1.eq.11) then
            f1=A208_hnn_112_mrec_nuenue_bb(p1)
         elseif(i1.eq.12) then
            f1=A208_hnn_113_mrec_nuenue_bb(p1)
         elseif(i1.eq.13) then
            f1=A208_hnn_114_mrec_nuenue_bb(p1)
         elseif(i1.eq.14) then
            f1=A208_hnn_115_mrec_nuenue_bb(p1)
         elseif(i1.eq.15) then
            f1=A208_hnn_116_mrec_nuenue_bb(p1)
         elseif(i1.eq.16) then
            f1=A208_hnn_1168_mrec_nuenue_bb(p1)
         elseif(i1.eq.17) then
            f1=A208_hnn_118_mrec_nuenue_bb(p1)
         elseif(i1.eq.18) then
            f1=A208_hnn_119_mrec_nuenue_bb(p1)
         elseif(i1.eq.19) then
            f1=A208_hnn_120_mrec_nuenue_bb(p1)
         endif
         if (i2.eq.1) then
            f2=A208_hnn_75_mrec_nuenue(p2)
         elseif(i2.eq.2) then
            f2=A208_hnn_80_mrec_nuenue(p2)
         elseif(i2.eq.3) then
            f2=A208_hnn_85_mrec_nuenue(p2)
         elseif(i2.eq.4) then
            f2=A208_hnn_90_mrec_nuenue(p2)
         elseif(i2.eq.5) then
            f2=A208_hnn_95_mrec_nuenue(p2)
         elseif(i2.eq.6) then
            f2=A208_hnn_100_mrec_nuenue_bb(p2)
         elseif(i2.eq.7) then
            f2=A208_hnn_104_mrec_nuenue_bb(p2)
         elseif(i2.eq.8) then
            f2=A208_hnn_106_mrec_nuenue_bb(p2)
         elseif(i2.eq.9) then
            f2=A208_hnn_108_mrec_nuenue_bb(p2)
         elseif(i2.eq.10) then
            f2=A208_hnn_110_mrec_nuenue_bb(p2)
         elseif(i2.eq.11) then
            f2=A208_hnn_112_mrec_nuenue_bb(p2)
         elseif(i2.eq.12) then
            f2=A208_hnn_113_mrec_nuenue_bb(p2)
         elseif(i2.eq.13) then
            f2=A208_hnn_114_mrec_nuenue_bb(p2)
         elseif(i2.eq.14) then
            f2=A208_hnn_115_mrec_nuenue_bb(p2)
         elseif(i2.eq.15) then
            f2=A208_hnn_116_mrec_nuenue_bb(p2)
         elseif(i2.eq.16) then
            f2=A208_hnn_1168_mrec_nuenue_bb(p2)
         elseif(i2.eq.17) then
            f2=A208_hnn_118_mrec_nuenue_bb(p2)
         elseif(i2.eq.18) then
            f2=A208_hnn_119_mrec_nuenue_bb(p2)
         elseif(i2.eq.19) then
            f2=A208_hnn_120_mrec_nuenue_bb(p2)
         endif
      elseif(isig.eq.7.or.isig.eq.8.or.isig.eq.9.or.isig.eq.10) then
         if (i1.eq.1) then 
            f1=A208_hnn_75_mrec_nuenue(p1)
         elseif(i1.eq.2) then
            f1=A208_hnn_80_mrec_nuenue(p1)
         elseif(i1.eq.3) then
            f1=A208_hnn_85_mrec_nuenue(p1)
         elseif(i1.eq.4) then
            f1=A208_hnn_90_mrec_nuenue(p1)
         elseif(i1.eq.5) then
            f1=A208_hnn_95_mrec_nuenue(p1)
         elseif(i1.eq.6) then
            f1=A208_hnn_100_mrec_nuenue_cc(p1)
         elseif(i1.eq.7) then
            f1=A208_hnn_104_mrec_nuenue_cc(p1)
         elseif(i1.eq.8) then
            f1=A208_hnn_106_mrec_nuenue_cc(p1)
         elseif(i1.eq.9) then
            f1=A208_hnn_108_mrec_nuenue_cc(p1)
         elseif(i1.eq.10) then
            f1=A208_hnn_110_mrec_nuenue_cc(p1)
         elseif(i1.eq.11) then
            f1=A208_hnn_112_mrec_nuenue_cc(p1)
         elseif(i1.eq.12) then
            f1=A208_hnn_113_mrec_nuenue_cc(p1)
         elseif(i1.eq.13) then
            f1=A208_hnn_114_mrec_nuenue_cc(p1)
         elseif(i1.eq.14) then
            f1=A208_hnn_115_mrec_nuenue_cc(p1)
         elseif(i1.eq.15) then
            f1=A208_hnn_116_mrec_nuenue_cc(p1)
         elseif(i1.eq.16) then
            f1=A208_hnn_1168_mrec_nuenue_cc(p1)
         elseif(i1.eq.17) then
            f1=A208_hnn_118_mrec_nuenue_cc(p1)
         elseif(i1.eq.18) then
            f1=A208_hnn_119_mrec_nuenue_cc(p1)
         elseif(i1.eq.19) then
            f1=A208_hnn_120_mrec_nuenue_cc(p1)
         endif
         if (i2.eq.1) then
            f2=A208_hnn_75_mrec_nuenue(p2)
         elseif(i2.eq.2) then
            f2=A208_hnn_80_mrec_nuenue(p2)
         elseif(i2.eq.3) then
            f2=A208_hnn_85_mrec_nuenue(p2)
         elseif(i2.eq.4) then
            f2=A208_hnn_90_mrec_nuenue(p2)
         elseif(i2.eq.5) then
            f2=A208_hnn_95_mrec_nuenue(p2)
         elseif(i2.eq.6) then
            f2=A208_hnn_100_mrec_nuenue_cc(p2)
         elseif(i2.eq.7) then
            f2=A208_hnn_104_mrec_nuenue_cc(p2)
         elseif(i2.eq.8) then
            f2=A208_hnn_106_mrec_nuenue_cc(p2)
         elseif(i2.eq.9) then
            f2=A208_hnn_108_mrec_nuenue_cc(p2)
         elseif(i2.eq.10) then
            f2=A208_hnn_110_mrec_nuenue_cc(p2)
         elseif(i2.eq.11) then
            f2=A208_hnn_112_mrec_nuenue_cc(p2)
         elseif(i2.eq.12) then
            f2=A208_hnn_113_mrec_nuenue_cc(p2)
         elseif(i2.eq.13) then
            f2=A208_hnn_114_mrec_nuenue_cc(p2)
         elseif(i2.eq.14) then
            f2=A208_hnn_115_mrec_nuenue_cc(p2)
         elseif(i2.eq.15) then
            f2=A208_hnn_116_mrec_nuenue_cc(p2)
         elseif(i2.eq.16) then
            f2=A208_hnn_1168_mrec_nuenue_cc(p2)
         elseif(i2.eq.17) then
            f2=A208_hnn_118_mrec_nuenue_cc(p2)
         elseif(i2.eq.18) then
            f2=A208_hnn_119_mrec_nuenue_cc(p2)
         elseif(i2.eq.19) then
            f2=A208_hnn_120_mrec_nuenue_cc(p2)
         endif
      else
         f1=0.d0
         f2=0.d0
      endif
      f = f1*d2 + f2*d1
      if( f.lt.1.0D-09 ) f = 1.0d-09
      if    ( x.lt.massl .or. x.gt.massh ) then
         f = 0.0d0
      endif

      a2000_208_nn_mrec_sig = f
      end



      double precision function a2000_210_nn_mrec_sig(x,hmass,isig)
*Approximations made in mass shapes:  below 100 GeV, all H dec's 
*are used in shapes--no separation is done.  Above 100 GeV,
*gg,tautau,&&WW dec modes all use cc shape.  Shapes always separated
*by production mechanism.
      Implicit none
      Integer       isig,isig2
      Real*8        x, hmass
      logical first
      data first /.true./

      Real*8        massl, massh
      Data          massl, massh/ 50.0 ,118.8/

      Integer       mpnt, msig, jpnt, jsig
      Parameter   ( mpnt = 19 , msig = 4)
      Real*8        masst(mpnt), corpk(msig,mpnt)
      Data         (masst(jpnt), (corpk(jsig,jpnt),jsig=1,msig)
     &                                            ,jpnt=1,mpnt)
     & /75.d0,101.2280,101.2280,100.5600,100.5600
     $ ,80.d0,99.4835,99.4835,101.2470,101.2470
     $ ,85.d0,100.0800,100.0800,100.1490,100.1490
     $ ,90.d0,100.7290,100.7290,101.3940,101.3940
     $ ,95.d0,101.1850,101.1850,101.6250,101.6250
     $ ,100.d0,102.8180,102.7930,102.7570,102.5460
     $ ,104.d0,105.0680,105.6390,104.5520,105.6900
     $ ,106.d0,106.3330,106.5780,105.8210,105.5090
     $ ,108.d0,107.6850,107.8690,107.0290,107.6090
     $ ,110.d0,109.1380,109.8650,108.2880,109.3990
     $ ,112.d0,110.5670,110.4220,109.7180,109.8740
     $ ,113.d0,111.2300,112.0930,110.3840,111.4060
     $ ,114.d0,111.9530,112.5420,110.8380,111.6860
     $ ,115.d0,112.5210,111.9620,111.3810,111.9880
     $ ,116.d0,112.9000,112.8420,111.2540,112.5980
     $ ,117.d0,113.0490,113.9730,111.7130,113.2630
     $ ,118.d0,113.2170,113.3210,111.4830,113.6760
     $ ,118.8d0,112.9850,113.9870,111.0260,111.0480
     $ ,120.d0,110.5670,110.4220,109.7180,109.8740/
      Integer       i , i1, i2
      Real*8        c , c1, c2
     &            , d , d1, d2
     &            , f , f1, f2
     &            ,     p1, p2
     &            ,     n1, n2
      REAL*8 A210_hnn_75_mrec_nulnul,A210_hnn_75_mrec_nuenue
     & ,A210_hnn_80_mrec_nulnul,A210_hnn_80_mrec_nuenue
     & ,A210_hnn_85_mrec_nulnul,A210_hnn_85_mrec_nuenue
     & ,A210_hnn_90_mrec_nulnul,A210_hnn_90_mrec_nuenue
     & ,A210_hnn_95_mrec_nulnul,A210_hnn_95_mrec_nuenue
     & ,A210_hnn_100_mrec_nulnul_bb,A210_hnn_100_mrec_nuenue_bb
     & ,A210_hnn_100_mrec_nulnul_cc,A210_hnn_100_mrec_nuenue_cc
     & ,A210_hnn_104_mrec_nulnul_bb,A210_hnn_104_mrec_nuenue_bb
     & ,A210_hnn_104_mrec_nulnul_cc,A210_hnn_104_mrec_nuenue_cc
     & ,A210_hnn_106_mrec_nulnul_bb,A210_hnn_106_mrec_nuenue_bb
     & ,A210_hnn_106_mrec_nulnul_cc,A210_hnn_106_mrec_nuenue_cc
     & ,A210_hnn_108_mrec_nulnul_bb,A210_hnn_108_mrec_nuenue_bb
     & ,A210_hnn_108_mrec_nulnul_cc,A210_hnn_108_mrec_nuenue_cc
     & ,A210_hnn_110_mrec_nulnul_bb,A210_hnn_110_mrec_nuenue_bb
     & ,A210_hnn_110_mrec_nulnul_cc,A210_hnn_110_mrec_nuenue_cc
     & ,A210_hnn_112_mrec_nulnul_bb,A210_hnn_112_mrec_nuenue_bb
     & ,A210_hnn_112_mrec_nulnul_cc,A210_hnn_112_mrec_nuenue_cc
     & ,A210_hnn_113_mrec_nulnul_bb,A210_hnn_113_mrec_nuenue_bb
     & ,A210_hnn_113_mrec_nulnul_cc,A210_hnn_113_mrec_nuenue_cc
     & ,A210_hnn_114_mrec_nulnul_bb,A210_hnn_114_mrec_nuenue_bb
     & ,A210_hnn_114_mrec_nulnul_cc,A210_hnn_114_mrec_nuenue_cc
     & ,A210_hnn_115_mrec_nulnul_bb,A210_hnn_115_mrec_nuenue_bb
     & ,A210_hnn_115_mrec_nulnul_cc,A210_hnn_115_mrec_nuenue_cc
     & ,A210_hnn_116_mrec_nulnul_bb,A210_hnn_116_mrec_nuenue_bb
     & ,A210_hnn_116_mrec_nulnul_cc,A210_hnn_116_mrec_nuenue_cc
     & ,A210_hnn_117_mrec_nulnul_bb,A210_hnn_117_mrec_nuenue_bb
     & ,A210_hnn_117_mrec_nulnul_cc,A210_hnn_117_mrec_nuenue_cc
     & ,A210_hnn_118_mrec_nulnul_bb,A210_hnn_118_mrec_nuenue_bb
     & ,A210_hnn_118_mrec_nulnul_cc,A210_hnn_118_mrec_nuenue_cc
     & ,A210_hnn_1188_mrec_nulnul_bb,A210_hnn_1188_mrec_nuenue_bb
     & ,A210_hnn_1188_mrec_nulnul_cc,A210_hnn_1188_mrec_nuenue_cc
     & ,A210_hnn_120_mrec_nulnul_bb,A210_hnn_120_mrec_nuenue_bb
     & ,A210_hnn_120_mrec_nulnul_cc,A210_hnn_120_mrec_nuenue_cc
      external  A210_hnn_75_mrec_nulnul,A210_hnn_75_mrec_nuenue
     & ,A210_hnn_80_mrec_nulnul,A210_hnn_80_mrec_nuenue
     & ,A210_hnn_85_mrec_nulnul,A210_hnn_85_mrec_nuenue
     & ,A210_hnn_90_mrec_nulnul,A210_hnn_90_mrec_nuenue
     & ,A210_hnn_95_mrec_nulnul,A210_hnn_95_mrec_nuenue
     & ,A210_hnn_100_mrec_nulnul_bb,A210_hnn_100_mrec_nuenue_bb
     & ,A210_hnn_100_mrec_nulnul_cc,A210_hnn_100_mrec_nuenue_cc
     & ,A210_hnn_104_mrec_nulnul_bb,A210_hnn_104_mrec_nuenue_bb
     & ,A210_hnn_104_mrec_nulnul_cc,A210_hnn_104_mrec_nuenue_cc
     & ,A210_hnn_106_mrec_nulnul_bb,A210_hnn_106_mrec_nuenue_bb
     & ,A210_hnn_106_mrec_nulnul_cc,A210_hnn_106_mrec_nuenue_cc
     & ,A210_hnn_108_mrec_nulnul_bb,A210_hnn_108_mrec_nuenue_bb
     & ,A210_hnn_108_mrec_nulnul_cc,A210_hnn_108_mrec_nuenue_cc
     & ,A210_hnn_110_mrec_nulnul_bb,A210_hnn_110_mrec_nuenue_bb
     & ,A210_hnn_110_mrec_nulnul_cc,A210_hnn_110_mrec_nuenue_cc
     & ,A210_hnn_112_mrec_nulnul_bb,A210_hnn_112_mrec_nuenue_bb
     & ,A210_hnn_112_mrec_nulnul_cc,A210_hnn_112_mrec_nuenue_cc
     & ,A210_hnn_113_mrec_nulnul_bb,A210_hnn_113_mrec_nuenue_bb
     & ,A210_hnn_113_mrec_nulnul_cc,A210_hnn_113_mrec_nuenue_cc
     & ,A210_hnn_114_mrec_nulnul_bb,A210_hnn_114_mrec_nuenue_bb
     & ,A210_hnn_114_mrec_nulnul_cc,A210_hnn_114_mrec_nuenue_cc
     & ,A210_hnn_115_mrec_nulnul_bb,A210_hnn_115_mrec_nuenue_bb
     & ,A210_hnn_115_mrec_nulnul_cc,A210_hnn_115_mrec_nuenue_cc
     & ,A210_hnn_116_mrec_nulnul_bb,A210_hnn_116_mrec_nuenue_bb
     & ,A210_hnn_116_mrec_nulnul_cc,A210_hnn_116_mrec_nuenue_cc
     & ,A210_hnn_117_mrec_nulnul_bb,A210_hnn_117_mrec_nuenue_bb
     & ,A210_hnn_117_mrec_nulnul_cc,A210_hnn_117_mrec_nuenue_cc
     & ,A210_hnn_118_mrec_nulnul_bb,A210_hnn_118_mrec_nuenue_bb
     & ,A210_hnn_118_mrec_nulnul_cc,A210_hnn_118_mrec_nuenue_cc
     & ,A210_hnn_1188_mrec_nulnul_bb,A210_hnn_1188_mrec_nuenue_bb
     & ,A210_hnn_1188_mrec_nulnul_cc,A210_hnn_1188_mrec_nuenue_cc
     & ,A210_hnn_120_mrec_nulnul_bb,A210_hnn_120_mrec_nuenue_bb
     & ,A210_hnn_120_mrec_nulnul_cc,A210_hnn_120_mrec_nuenue_cc
      if    ( hmass.lt.masst(1   ) ) then
          i1 = 1
          i2 = 1
          d1 = 0.0
          d2 = 1.0
      elseif( hmass.ge.masst(mpnt) ) then
          i1 = mpnt
          i2 = mpnt
          d1 = 1.0
          d2 = 0.0
      else
          do i = 1, mpnt-1
          if( hmass.ge.masst(i) .and. hmass.lt.masst(i+1) ) then
          i1 = i
          i2 = i + 1
          endif
          enddo
          d  = masst(i2) - masst(i1)
          d1 = (hmass - masst(i1))/d
          d2 = (masst(i2) - hmass)/d
      endif
      if (isig.eq.1) then
         isig2=1
      elseif(isig.eq.2.or.isig.eq.3.or.isig.eq.4.or.isig.eq.5) then
         isig2=2
      elseif(isig.eq.6) then
         isig2=3
      elseif(isig.eq.7.or.isig.eq.8.or.isig.eq.9.or.isig.eq.10) then
         isig2=4
      else
         isig2=2
      endif
      c1 = corpk(isig2,i1)
      c2 = corpk(isig2,i2)
      c  = c1*d2 + c2*d1

* very painful procedure to get function values
* =============================================
      if(hmass.le.75.0) then
         if (x.ge.c) then
            p1 = x - c + corpk(isig2,i1)
            p2 = x - c + corpk(isig2,i2)
         else
            p1 = corpk(isig2,i1)-(c-x)/(c-massl)*(corpk(isig2,i1)-massl)
            p2 = corpk(isig2,i2)-(c-x)/(c-massl)*(corpk(isig2,i2)-massl)
         endif
      elseif(hmass.ge.massh) then
         if (x.le.c) then
            p1 = x - c + corpk(isig2,i1)
            p2 = x - c + corpk(isig2,i2)
         else
            p1 = corpk(isig2,i1)+(x-c)/(massh-c)*(massh-corpk(isig2,i1))
            p2 = corpk(isig2,i2)+(x-c)/(massh-c)*(massh-corpk(isig2,i2))
         endif
      else
         p1 = x - c + corpk(isig2,i1)
         p2 = x - c + corpk(isig2,i2)
      endif
      if (isig.eq.1) then
         if (i1.eq.1) then 
            f1=A210_hnn_75_mrec_nulnul(p1)
         elseif(i1.eq.2) then
            f1=A210_hnn_80_mrec_nulnul(p1)
         elseif(i1.eq.3) then
            f1=A210_hnn_85_mrec_nulnul(p1)
         elseif(i1.eq.4) then
            f1=A210_hnn_90_mrec_nulnul(p1)
         elseif(i1.eq.5) then
            f1=A210_hnn_95_mrec_nulnul(p1)
         elseif(i1.eq.6) then
            f1=A210_hnn_100_mrec_nulnul_bb(p1)
         elseif(i1.eq.7) then
            f1=A210_hnn_104_mrec_nulnul_bb(p1)
         elseif(i1.eq.8) then
            f1=A210_hnn_106_mrec_nulnul_bb(p1)
         elseif(i1.eq.9) then
            f1=A210_hnn_108_mrec_nulnul_bb(p1)
         elseif(i1.eq.10) then
            f1=A210_hnn_110_mrec_nulnul_bb(p1)
         elseif(i1.eq.11) then
            f1=A210_hnn_112_mrec_nulnul_bb(p1)
         elseif(i1.eq.12) then
            f1=A210_hnn_113_mrec_nulnul_bb(p1)
         elseif(i1.eq.13) then
            f1=A210_hnn_114_mrec_nulnul_bb(p1)
         elseif(i1.eq.14) then
            f1=A210_hnn_115_mrec_nulnul_bb(p1)
         elseif(i1.eq.15) then
            f1=A210_hnn_116_mrec_nulnul_bb(p1)
         elseif(i1.eq.16) then
            f1=A210_hnn_117_mrec_nulnul_bb(p1)
         elseif(i1.eq.17) then
            f1=A210_hnn_118_mrec_nulnul_bb(p1)
         elseif(i1.eq.18) then
            f1=A210_hnn_1188_mrec_nulnul_bb(p1)
         elseif(i1.eq.19) then
            f1=A210_hnn_120_mrec_nulnul_bb(p1)
         endif
         if (i2.eq.1) then
            f2=A210_hnn_75_mrec_nulnul(p2)
         elseif(i2.eq.2) then
            f2=A210_hnn_80_mrec_nulnul(p2)
         elseif(i2.eq.3) then
            f2=A210_hnn_85_mrec_nulnul(p2)
         elseif(i2.eq.4) then
            f2=A210_hnn_90_mrec_nulnul(p2)
         elseif(i2.eq.5) then
            f2=A210_hnn_95_mrec_nulnul(p2)
         elseif(i2.eq.6) then
            f2=A210_hnn_100_mrec_nulnul_bb(p2)
         elseif(i2.eq.7) then
            f2=A210_hnn_104_mrec_nulnul_bb(p2)
         elseif(i2.eq.8) then
            f2=A210_hnn_106_mrec_nulnul_bb(p2)
         elseif(i2.eq.9) then
            f2=A210_hnn_108_mrec_nulnul_bb(p2)
         elseif(i2.eq.10) then
            f2=A210_hnn_110_mrec_nulnul_bb(p2)
         elseif(i2.eq.11) then
            f2=A210_hnn_112_mrec_nulnul_bb(p2)
         elseif(i2.eq.12) then
            f2=A210_hnn_113_mrec_nulnul_bb(p2)
         elseif(i2.eq.13) then
            f2=A210_hnn_114_mrec_nulnul_bb(p2)
         elseif(i2.eq.14) then
            f2=A210_hnn_115_mrec_nulnul_bb(p2)
         elseif(i2.eq.15) then
            f2=A210_hnn_116_mrec_nulnul_bb(p2)
         elseif(i2.eq.16) then
            f2=A210_hnn_117_mrec_nulnul_bb(p2)
         elseif(i2.eq.17) then
            f2=A210_hnn_118_mrec_nulnul_bb(p2)
         elseif(i2.eq.18) then
            f2=A210_hnn_1188_mrec_nulnul_bb(p2)
         elseif(i2.eq.19) then
            f2=A210_hnn_120_mrec_nulnul_bb(p2)
         endif
      elseif(isig.eq.2.or.isig.eq.3.or.isig.eq.4.or.isig.eq.5) then
         if (i1.eq.1) then 
            f1=A210_hnn_75_mrec_nulnul(p1)
         elseif(i1.eq.2) then
            f1=A210_hnn_80_mrec_nulnul(p1)
         elseif(i1.eq.3) then
            f1=A210_hnn_85_mrec_nulnul(p1)
         elseif(i1.eq.4) then
            f1=A210_hnn_90_mrec_nulnul(p1)
         elseif(i1.eq.5) then
            f1=A210_hnn_95_mrec_nulnul(p1)
         elseif(i1.eq.6) then
            f1=A210_hnn_100_mrec_nulnul_cc(p1)
         elseif(i1.eq.7) then
            f1=A210_hnn_104_mrec_nulnul_cc(p1)
         elseif(i1.eq.8) then
            f1=A210_hnn_106_mrec_nulnul_cc(p1)
         elseif(i1.eq.9) then
            f1=A210_hnn_108_mrec_nulnul_cc(p1)
         elseif(i1.eq.10) then
            f1=A210_hnn_110_mrec_nulnul_cc(p1)
         elseif(i1.eq.11) then
            f1=A210_hnn_112_mrec_nulnul_cc(p1)
         elseif(i1.eq.12) then
            f1=A210_hnn_113_mrec_nulnul_cc(p1)
         elseif(i1.eq.13) then
            f1=A210_hnn_114_mrec_nulnul_cc(p1)
         elseif(i1.eq.14) then
            f1=A210_hnn_115_mrec_nulnul_cc(p1)
         elseif(i1.eq.15) then
            f1=A210_hnn_116_mrec_nulnul_cc(p1)
         elseif(i1.eq.16) then
            f1=A210_hnn_116_mrec_nulnul_cc(p1)
         elseif(i1.eq.17) then
            f1=A210_hnn_118_mrec_nulnul_cc(p1)
         elseif(i1.eq.18) then
            f1=A210_hnn_1188_mrec_nulnul_cc(p1)
         elseif(i1.eq.19) then
            f1=A210_hnn_120_mrec_nulnul_cc(p1)
         endif
         if (i2.eq.1) then
            f2=A210_hnn_75_mrec_nulnul(p2)
         elseif(i2.eq.2) then
            f2=A210_hnn_80_mrec_nulnul(p2)
         elseif(i2.eq.3) then
            f2=A210_hnn_85_mrec_nulnul(p2)
         elseif(i2.eq.4) then
            f2=A210_hnn_90_mrec_nulnul(p2)
         elseif(i2.eq.5) then
            f2=A210_hnn_95_mrec_nulnul(p2)
         elseif(i2.eq.6) then
            f2=A210_hnn_100_mrec_nulnul_cc(p2)
         elseif(i2.eq.7) then
            f2=A210_hnn_104_mrec_nulnul_cc(p2)
         elseif(i2.eq.8) then
            f2=A210_hnn_106_mrec_nulnul_cc(p2)
         elseif(i2.eq.9) then
            f2=A210_hnn_108_mrec_nulnul_cc(p2)
         elseif(i2.eq.10) then
            f2=A210_hnn_110_mrec_nulnul_cc(p2)
         elseif(i2.eq.11) then
            f2=A210_hnn_112_mrec_nulnul_cc(p2)
         elseif(i2.eq.12) then
            f2=A210_hnn_113_mrec_nulnul_cc(p2)
         elseif(i2.eq.13) then
            f2=A210_hnn_114_mrec_nulnul_cc(p2)
         elseif(i2.eq.14) then
            f2=A210_hnn_115_mrec_nulnul_cc(p2)
         elseif(i2.eq.15) then
            f2=A210_hnn_116_mrec_nulnul_cc(p2)
         elseif(i2.eq.16) then
            f2=A210_hnn_116_mrec_nulnul_cc(p2)
         elseif(i2.eq.17) then
            f2=A210_hnn_118_mrec_nulnul_cc(p2)
         elseif(i2.eq.18) then
            f2=A210_hnn_1188_mrec_nulnul_cc(p2)
         elseif(i2.eq.19) then
            f2=A210_hnn_120_mrec_nulnul_cc(p2)
         endif
      elseif (isig.eq.6) then
         if (i1.eq.1) then 
            f1=A210_hnn_75_mrec_nuenue(p1)
         elseif(i1.eq.2) then
            f1=A210_hnn_80_mrec_nuenue(p1)
         elseif(i1.eq.3) then
            f1=A210_hnn_85_mrec_nuenue(p1)
         elseif(i1.eq.4) then
            f1=A210_hnn_90_mrec_nuenue(p1)
         elseif(i1.eq.5) then
            f1=A210_hnn_95_mrec_nuenue(p1)
         elseif(i1.eq.6) then
            f1=A210_hnn_100_mrec_nuenue_bb(p1)
         elseif(i1.eq.7) then
            f1=A210_hnn_104_mrec_nuenue_bb(p1)
         elseif(i1.eq.8) then
            f1=A210_hnn_106_mrec_nuenue_bb(p1)
         elseif(i1.eq.9) then
            f1=A210_hnn_108_mrec_nuenue_bb(p1)
         elseif(i1.eq.10) then
            f1=A210_hnn_110_mrec_nuenue_bb(p1)
         elseif(i1.eq.11) then
            f1=A210_hnn_112_mrec_nuenue_bb(p1)
         elseif(i1.eq.12) then
            f1=A210_hnn_113_mrec_nuenue_bb(p1)
         elseif(i1.eq.13) then
            f1=A210_hnn_114_mrec_nuenue_bb(p1)
         elseif(i1.eq.14) then
            f1=A210_hnn_115_mrec_nuenue_bb(p1)
         elseif(i1.eq.15) then
            f1=A210_hnn_116_mrec_nuenue_bb(p1)
         elseif(i1.eq.16) then
            f1=A210_hnn_117_mrec_nuenue_bb(p1)
         elseif(i1.eq.17) then
            f1=A210_hnn_118_mrec_nuenue_bb(p1)
         elseif(i1.eq.18) then
            f1=A210_hnn_1188_mrec_nuenue_bb(p1)
         elseif(i1.eq.19) then
            f1=A210_hnn_120_mrec_nuenue_bb(p1)
         endif
         if (i2.eq.1) then
            f2=A210_hnn_75_mrec_nuenue(p2)
         elseif(i2.eq.2) then
            f2=A210_hnn_80_mrec_nuenue(p2)
         elseif(i2.eq.3) then
            f2=A210_hnn_85_mrec_nuenue(p2)
         elseif(i2.eq.4) then
            f2=A210_hnn_90_mrec_nuenue(p2)
         elseif(i2.eq.5) then
            f2=A210_hnn_95_mrec_nuenue(p2)
         elseif(i2.eq.6) then
            f2=A210_hnn_100_mrec_nuenue_bb(p2)
         elseif(i2.eq.7) then
            f2=A210_hnn_104_mrec_nuenue_bb(p2)
         elseif(i2.eq.8) then
            f2=A210_hnn_106_mrec_nuenue_bb(p2)
         elseif(i2.eq.9) then
            f2=A210_hnn_108_mrec_nuenue_bb(p2)
         elseif(i2.eq.10) then
            f2=A210_hnn_110_mrec_nuenue_bb(p2)
         elseif(i2.eq.11) then
            f2=A210_hnn_112_mrec_nuenue_bb(p2)
         elseif(i2.eq.12) then
            f2=A210_hnn_113_mrec_nuenue_bb(p2)
         elseif(i2.eq.13) then
            f2=A210_hnn_114_mrec_nuenue_bb(p2)
         elseif(i2.eq.14) then
            f2=A210_hnn_115_mrec_nuenue_bb(p2)
         elseif(i2.eq.15) then
            f2=A210_hnn_116_mrec_nuenue_bb(p2)
         elseif(i2.eq.16) then
            f2=A210_hnn_117_mrec_nuenue_bb(p2)
         elseif(i2.eq.17) then
            f2=A210_hnn_118_mrec_nuenue_bb(p2)
         elseif(i2.eq.18) then
            f2=A210_hnn_1188_mrec_nuenue_bb(p2)
         elseif(i2.eq.19) then
            f2=A210_hnn_120_mrec_nuenue_bb(p2)
         endif
      elseif(isig.eq.7.or.isig.eq.8.or.isig.eq.9.or.isig.eq.10) then
         if (i1.eq.1) then 
            f1=A210_hnn_75_mrec_nuenue(p1)
         elseif(i1.eq.2) then
            f1=A210_hnn_80_mrec_nuenue(p1)
         elseif(i1.eq.3) then
            f1=A210_hnn_85_mrec_nuenue(p1)
         elseif(i1.eq.4) then
            f1=A210_hnn_90_mrec_nuenue(p1)
         elseif(i1.eq.5) then
            f1=A210_hnn_95_mrec_nuenue(p1)
         elseif(i1.eq.6) then
            f1=A210_hnn_100_mrec_nuenue_cc(p1)
         elseif(i1.eq.7) then
            f1=A210_hnn_104_mrec_nuenue_cc(p1)
         elseif(i1.eq.8) then
            f1=A210_hnn_106_mrec_nuenue_cc(p1)
         elseif(i1.eq.9) then
            f1=A210_hnn_108_mrec_nuenue_cc(p1)
         elseif(i1.eq.10) then
            f1=A210_hnn_110_mrec_nuenue_cc(p1)
         elseif(i1.eq.11) then
            f1=A210_hnn_112_mrec_nuenue_cc(p1)
         elseif(i1.eq.12) then
            f1=A210_hnn_113_mrec_nuenue_cc(p1)
         elseif(i1.eq.13) then
            f1=A210_hnn_114_mrec_nuenue_cc(p1)
         elseif(i1.eq.14) then
            f1=A210_hnn_115_mrec_nuenue_cc(p1)
         elseif(i1.eq.15) then
            f1=A210_hnn_116_mrec_nuenue_cc(p1)
         elseif(i1.eq.16) then
            f1=A210_hnn_117_mrec_nuenue_cc(p1)
         elseif(i1.eq.17) then
            f1=A210_hnn_118_mrec_nuenue_cc(p1)
         elseif(i1.eq.18) then
            f1=A210_hnn_1188_mrec_nuenue_cc(p1)
         elseif(i1.eq.19) then
            f1=A210_hnn_120_mrec_nuenue_cc(p1)
         endif
         if (i2.eq.1) then
            f2=A210_hnn_75_mrec_nuenue(p2)
         elseif(i2.eq.2) then
            f2=A210_hnn_80_mrec_nuenue(p2)
         elseif(i2.eq.3) then
            f2=A210_hnn_85_mrec_nuenue(p2)
         elseif(i2.eq.4) then
            f2=A210_hnn_90_mrec_nuenue(p2)
         elseif(i2.eq.5) then
            f2=A210_hnn_95_mrec_nuenue(p2)
         elseif(i2.eq.6) then
            f2=A210_hnn_100_mrec_nuenue_cc(p2)
         elseif(i2.eq.7) then
            f2=A210_hnn_104_mrec_nuenue_cc(p2)
         elseif(i2.eq.8) then
            f2=A210_hnn_106_mrec_nuenue_cc(p2)
         elseif(i2.eq.9) then
            f2=A210_hnn_108_mrec_nuenue_cc(p2)
         elseif(i2.eq.10) then
            f2=A210_hnn_110_mrec_nuenue_cc(p2)
         elseif(i2.eq.11) then
            f2=A210_hnn_112_mrec_nuenue_cc(p2)
         elseif(i2.eq.12) then
            f2=A210_hnn_113_mrec_nuenue_cc(p2)
         elseif(i2.eq.13) then
            f2=A210_hnn_114_mrec_nuenue_cc(p2)
         elseif(i2.eq.14) then
            f2=A210_hnn_115_mrec_nuenue_cc(p2)
         elseif(i2.eq.15) then
            f2=A210_hnn_116_mrec_nuenue_cc(p2)
         elseif(i2.eq.16) then
            f2=A210_hnn_117_mrec_nuenue_cc(p2)
         elseif(i2.eq.17) then
            f2=A210_hnn_118_mrec_nuenue_cc(p2)
         elseif(i2.eq.18) then
            f2=A210_hnn_1188_mrec_nuenue_cc(p2)
         elseif(i2.eq.19) then
            f2=A210_hnn_120_mrec_nuenue_cc(p2)
         endif
      else
         f1=0.d0
         f2=0.d0
      endif
      f = f1*d2 + f2*d1
      if( f.lt.1.0D-09 ) f = 1.0d-09
      if    ( x.lt.massl .or. x.gt.massh ) then
         f = 0.0d0
      endif

      a2000_210_nn_mrec_sig = f
      end




