      integer function A_nn_ncand(ecm,iana)
      implicit none
      real*8 ecm
      integer iana
      integer A1916_hnn_numcand, A1955_hnn_numcand, 
     &     A1995_hnn_numcand, A2016_hnn_numcand
      external A1916_hnn_numcand, A1955_hnn_numcand, 
     &     A1995_hnn_numcand, A2016_hnn_numcand
      if (ecm.ge.191.5.and.ecm.le.191.7) then
         A_nn_ncand=A1916_hnn_numcand(iana)
      elseif (ecm.ge.195.4.and.ecm.le.195.6) then
         A_nn_ncand=A1955_hnn_numcand(iana)
      elseif (ecm.ge.199.4.and.ecm.le.199.6) then
         A_nn_ncand=A1995_hnn_numcand(iana)
      elseif (ecm.ge.201.5.and.ecm.le.201.7) then
         A_nn_ncand=A2016_hnn_numcand(iana)
      else
         A_nn_ncand = 0
      endif
      end

      double precision function A_nn_mass_cand(ecm,iana,icand)
      implicit none
      real*8 ecm
      integer iana,icand
      real*8 A1916_hnn_mass_cand, A1955_hnn_mass_cand, 
     &     A1995_hnn_mass_cand, A2016_hnn_mass_cand
      external A1916_hnn_mass_cand, A1955_hnn_mass_cand, 
     &     A1995_hnn_mass_cand, A2016_hnn_mass_cand
      if (ecm.ge.191.5.and.ecm.le.191.7) then
         A_nn_mass_cand=A1916_hnn_mass_cand(iana,icand)
      elseif (ecm.ge.195.4.and.ecm.le.195.6) then
         A_nn_mass_cand=A1955_hnn_mass_cand(iana,icand)
      elseif (ecm.ge.199.4.and.ecm.le.199.6) then
         A_nn_mass_cand=A1995_hnn_mass_cand(iana,icand)
      elseif (ecm.ge.201.5.and.ecm.le.201.7) then
         A_nn_mass_cand=A2016_hnn_mass_cand(iana,icand)
      else
         A_nn_mass_cand = 0.d0
      endif
      end

      double precision function A_nn_bkg(ecm,iana,ibkg)
      implicit none
      real*8 ecm
      integer iana,ibkg
      real*8 A1916_hnn_bkg, A1955_hnn_bkg, 
     &     A1995_hnn_bkg, A2016_hnn_bkg
      external A1916_hnn_bkg, A1955_hnn_bkg, 
     &     A1995_hnn_bkg, A2016_hnn_bkg
      if (ecm.ge.191.5.and.ecm.le.191.7) then
         A_nn_bkg=A1916_hnn_bkg(iana,ibkg)
      elseif (ecm.ge.195.4.and.ecm.le.195.6) then
         A_nn_bkg=A1955_hnn_bkg(iana,ibkg)
      elseif (ecm.ge.199.4.and.ecm.le.199.6) then
         A_nn_bkg=A1995_hnn_bkg(iana,ibkg)
      elseif (ecm.ge.201.5.and.ecm.le.201.7) then
         A_nn_bkg=A2016_hnn_bkg(iana,ibkg)
      else
         A_nn_bkg = 0.d0
      endif
      end


      double precision function A_nn_mass_sig(ecm,iana,hmass,x)
      implicit none
      real*8 ecm,hmass,x
      integer iana
      real*8 A1916_hnn_mass_sig, A1955_hnn_mass_sig, 
     &     A1995_hnn_mass_sig, A2016_hnn_mass_sig
      external A1916_hnn_mass_sig, A1955_hnn_mass_sig, 
     &     A1995_hnn_mass_sig, A2016_hnn_mass_sig
c	write (6,*) 'a_nn_mass_sig',ecm,iana,hmass,x
      if (ecm.ge.191.5.and.ecm.le.191.7) then
c	write (6,*) 'a_nn_mass_sig:1'
         A_nn_mass_sig=A1916_hnn_mass_sig(x,hmass,iana)
c	write (6,*) 'a_nn_mass_sig:2'
      elseif (ecm.ge.195.4.and.ecm.le.195.6) then
         A_nn_mass_sig=A1955_hnn_mass_sig(x,hmass,iana)
      elseif (ecm.ge.199.4.and.ecm.le.199.6) then
         A_nn_mass_sig=A1995_hnn_mass_sig(x,hmass,iana)
      elseif (ecm.ge.201.5.and.ecm.le.201.7) then
         A_nn_mass_sig=A2016_hnn_mass_sig(x,hmass,iana)
      else
         A_nn_mass_sig = 0.d0
      endif
      end


      double precision function A_nn_nuenue_mass_sig(ecm,iana,hmass,x)
      implicit none
      real*8 ecm,hmass,x
      integer iana
      real*8 A1916_hnn_fus_mass_sig, A1955_hnn_fus_mass_sig, 
     &     A1995_hnn_fus_mass_sig, A2016_hnn_fus_mass_sig
      external A1916_hnn_fus_mass_sig, A1955_hnn_fus_mass_sig, 
     &     A1995_hnn_fus_mass_sig, A2016_hnn_fus_mass_sig
      if (ecm.ge.191.5.and.ecm.le.191.7) then
         A_nn_nuenue_mass_sig=A1916_hnn_fus_mass_sig(x,hmass,iana)
      elseif (ecm.ge.195.4.and.ecm.le.195.6) then
         A_nn_nuenue_mass_sig=A1955_hnn_fus_mass_sig(x,hmass,iana)
      elseif (ecm.ge.199.4.and.ecm.le.199.6) then
         A_nn_nuenue_mass_sig=A1995_hnn_fus_mass_sig(x,hmass,iana)
      elseif (ecm.ge.201.5.and.ecm.le.201.7) then
         A_nn_nuenue_mass_sig=A2016_hnn_fus_mass_sig(x,hmass,iana)
      else
         A_nn_nuenue_mass_sig = 0.d0
      endif
      end


      double precision function A_nn_mass_bkg(ecm,ibkg,iana,x)
      implicit none
      real*8 ecm,hmass,x
      integer iana,ibkg
      real*8 A1916_hnn_mass_bkg, A1955_hnn_mass_bkg, 
     &     A1995_hnn_mass_bkg, A2016_hnn_mass_bkg
      external A1916_hnn_mass_bkg, A1955_hnn_mass_bkg, 
     &     A1995_hnn_mass_bkg, A2016_hnn_mass_bkg
      if (ecm.ge.191.5.and.ecm.le.191.7) then
         A_nn_mass_bkg=A1916_hnn_mass_bkg(x,iana,ibkg)
      elseif (ecm.ge.195.4.and.ecm.le.195.6) then
         A_nn_mass_bkg=A1955_hnn_mass_bkg(x,iana,ibkg)
      elseif (ecm.ge.199.4.and.ecm.le.199.6) then
         A_nn_mass_bkg=A1995_hnn_mass_bkg(x,iana,ibkg)
      elseif (ecm.ge.201.5.and.ecm.le.201.7) then
         A_nn_mass_bkg=A2016_hnn_mass_bkg(x,iana,ibkg)
      else
         A_nn_mass_bkg = 0.d0
      endif
      end



      double precision function A_nn_hz_eff(ecm,iana,br,hmass)
      implicit none
      real*8 ecm,hmass,x
      integer iana,ibkg,br
      real*8 A1916_hnn_hz_eff, A1955_hnn_hz_eff, 
     &     A1995_hnn_hz_eff, A2016_hnn_hz_eff
      external A1916_hnn_hz_eff, A1955_hnn_hz_eff, 
     &     A1995_hnn_hz_eff, A2016_hnn_hz_eff
      if (ecm.ge.191.5.and.ecm.le.191.7) then
         A_nn_hz_eff=A1916_hnn_hz_eff(hmass,br,iana)
      elseif (ecm.ge.195.4.and.ecm.le.195.6) then
         A_nn_hz_eff=A1955_hnn_hz_eff(hmass,br,iana)
      elseif (ecm.ge.199.4.and.ecm.le.199.6) then
         A_nn_hz_eff=A1995_hnn_hz_eff(hmass,br,iana)
      elseif (ecm.ge.201.5.and.ecm.le.201.7) then
         A_nn_hz_eff=A2016_hnn_hz_eff(hmass,br,iana)
      else
         A_nn_hz_eff = 0.d0
      endif
      end


      double precision function A_nn_nuenue_eff(ecm,iana,br,hmass)
      implicit none
      real*8 ecm,hmass,x
      integer iana,ibkg,br
      real*8 A1916_hnn_wwf_eff, A1955_hnn_wwf_eff, 
     &     A1995_hnn_wwf_eff, A2016_hnn_wwf_eff
      external A1916_hnn_wwf_eff, A1955_hnn_wwf_eff, 
     &     A1995_hnn_wwf_eff, A2016_hnn_wwf_eff
      if (ecm.ge.191.5.and.ecm.le.191.7) then
         A_nn_nuenue_eff=A1916_hnn_wwf_eff(hmass,br,iana)
      elseif (ecm.ge.195.4.and.ecm.le.195.6) then
         A_nn_nuenue_eff=A1955_hnn_wwf_eff(hmass,br,iana)
      elseif (ecm.ge.199.4.and.ecm.le.199.6) then
         A_nn_nuenue_eff=A1995_hnn_wwf_eff(hmass,br,iana)
      elseif (ecm.ge.201.5.and.ecm.le.201.7) then
         A_nn_nuenue_eff=A2016_hnn_wwf_eff(hmass,br,iana)
      else
         A_nn_nuenue_eff = 0.d0
      endif
      end


C iana=1 : AND
C iana=2 : Wis. Ex.
C iana=3 : Ors. Ex.
C bkg=1 : QQ    based on lumi = 1 pb**-1
C bkg=2 : WW
C bkg=3 : ZZ
*1916

      integer function A1916_HNN_NUMCAND(iana)
      implicit none
      integer iana
      INTEGER numcand(3)
      data numcand/1,0,0/
      if (iana.eq.1.0.or.iana.eq.2.0.or.iana.eq.3.0) then
         A1916_HNN_NUMCAND = numcand(iana)
      else 
         A1916_HNN_NUMCAND = 0
      endif
      end


      DOUBLE PRECISION function A1916_HNN_MASS_CAND(iana,icand)
      implicit none
      integer iana,icand
      REAL*8 andmass(1)
      data andmass/89.4176/
      if (iana.eq.1) then 
         A1916_HNN_MASS_CAND=andmass(icand)
      else
         A1916_HNN_MASS_CAND=0.0   
      endif
      end

      


      DOUBLE PRECISION function A1916_HNN_BKG(iana,bkg)
      Implicit none 
      Integer       iana, bkg
      Real          andbkg(3), wisbkg(3), orsbkg(3)
      data          andbkg/0.00316598,0.000718424,0.0174856/
      data          wisbkg/0.00394583,0.00485388,0.0112392/
      data          orsbkg/0.00751328,0.000237696,0.00290476/
      SAVE
*--------------------------------------------------------
      if (iana.eq.1.0) then 
         A1916_HNN_BKG=andbkg(bkg) 
      elseif (iana.eq.2.0) then 
         A1916_HNN_BKG=wisbkg(bkg)      
      elseif (iana.eq.3.0) then 
         A1916_HNN_BKG=orsbkg(bkg)
      else 
         A1916_HNN_BKG=0.0
      endif
      end


CCCCCC
CCCCCC
CCCCCC
      DOUBLE PRECISION Function A1916_HNN_MASS_SIG(x,hmass,iana)
      Implicit none
      Integer       iana
      Real*8        x, hmass
      Real*8        massl, massh
      logical first
      data first /.true./
      Data          massl, massh/ 50.0 ,100.4/
      Integer       mpnt, mana, jpnt, jana
      Parameter   ( mpnt = 14 , mana = 3)
      Real*8        masst(mpnt), corpk(mana,mpnt)
      Data         (masst(jpnt), (corpk(jana,jpnt),jana=1,mana)
     &                                            ,jpnt=1,mpnt)
     &             / 60.00, 78.39, 63.36, 79.40
     &             ,65.00, 83.98, 67.52, 75.85
     &             ,70.00, 87.67, 71.77, 80.55
     &             ,75.00, 88.38, 76.02, 86.86
     &             ,80.00, 88.67, 79.97, 88.19
     &             ,85.00, 89.42, 83.59, 89.88
     &             ,90.00, 91.21, 87.26, 91.20
     &             ,95.00, 94.15, 91.59, 92.73
     &             ,100.00, 95.93, 94.57, 93.69
     &             ,105.00, 94.52, 91.81, 93.36
     &             ,107.00, 94.56, 91.36, 92.80
     &             ,110.00, 94.25, 90.47, 93.56
     &             ,115.00, 93.92, 91.45, 93.06
     &             ,120.00, 94.62, 91.96, 93.05/

      Integer       i , i1, i2
      Real*8        c , c1, c2
     &            , d , d1, d2
     &            , f , f1, f2
     &            ,     p1, p2
     &            ,     n1, n2
     &            ,n60wao,n65wao,n70wao,n75wao,n80wao
     &            ,n85wao,n90wao,n95wao,n100wao,n105wao
     &            ,n107wao,n110wao,n115wao,n120wao
     &            ,n60wano,n65wano,n70wano,n75wano,n80wano
     &            ,n85wano,n90wano,n95wano,n100wano,n105wano
     &            ,n107wano,n110wano,n115wano,n120wano
     &            ,n60nwao,n65nwao,n70nwao,n75nwao,n80nwao
     &            ,n85nwao,n90nwao,n95nwao,n100nwao,n105nwao
     &            ,n107nwao,n110nwao,n115nwao,n120nwao
      SAVE
      Real*8        A1916_HNN_WAO_HZ_60
     &            , A1916_HNN_WAO_HZ_65
     &            , A1916_HNN_WAO_HZ_70
     &            , A1916_HNN_WAO_HZ_75
     &            , A1916_HNN_WAO_HZ_80
     &            , A1916_HNN_WAO_HZ_85
     &            , A1916_HNN_WAO_HZ_90
     &            , A1916_HNN_WAO_HZ_95
     &            , A1916_HNN_WAO_HZ_100
     &            , A1916_HNN_WAO_HZ_105
     &            , A1916_HNN_WAO_HZ_107
     &            , A1916_HNN_WAO_HZ_110
     &            , A1916_HNN_WAO_HZ_115
     &            , A1916_HNN_WAO_HZ_120
     &            , A1916_HNN_WANO_HZ_60
     &            , A1916_HNN_WANO_HZ_65
     &            , A1916_HNN_WANO_HZ_70
     &            , A1916_HNN_WANO_HZ_75
     &            , A1916_HNN_WANO_HZ_80
     &            , A1916_HNN_WANO_HZ_85
     &            , A1916_HNN_WANO_HZ_90
     &            , A1916_HNN_WANO_HZ_95
     &            , A1916_HNN_WANO_HZ_100
     &            , A1916_HNN_WANO_HZ_105
     &            , A1916_HNN_WANO_HZ_107
     &            , A1916_HNN_WANO_HZ_110
     &            , A1916_HNN_WANO_HZ_115
     &            , A1916_HNN_WANO_HZ_120
     &            , A1916_HNN_NWAO_HZ_60
     &            , A1916_HNN_NWAO_HZ_65
     &            , A1916_HNN_NWAO_HZ_70
     &            , A1916_HNN_NWAO_HZ_75
     &            , A1916_HNN_NWAO_HZ_80
     &            , A1916_HNN_NWAO_HZ_85
     &            , A1916_HNN_NWAO_HZ_90
     &            , A1916_HNN_NWAO_HZ_95
     &            , A1916_HNN_NWAO_HZ_100
     &            , A1916_HNN_NWAO_HZ_105
     &            , A1916_HNN_NWAO_HZ_107
     &            , A1916_HNN_NWAO_HZ_110
     &            , A1916_HNN_NWAO_HZ_115
     &            , A1916_HNN_NWAO_HZ_120
     &            , A1999_Hnn_normsh
      External        A1916_HNN_WAO_HZ_60
     &            , A1916_HNN_WAO_HZ_65
     &            , A1916_HNN_WAO_HZ_70
     &            , A1916_HNN_WAO_HZ_75
     &            , A1916_HNN_WAO_HZ_80
     &            , A1916_HNN_WAO_HZ_85
     &            , A1916_HNN_WAO_HZ_90
     &            , A1916_HNN_WAO_HZ_95
     &            , A1916_HNN_WAO_HZ_100
     &            , A1916_HNN_WAO_HZ_105
     &            , A1916_HNN_WAO_HZ_107
     &            , A1916_HNN_WAO_HZ_110
     &            , A1916_HNN_WAO_HZ_115
     &            , A1916_HNN_WAO_HZ_120
     &            , A1916_HNN_WANO_HZ_60
     &            , A1916_HNN_WANO_HZ_65
     &            , A1916_HNN_WANO_HZ_70
     &            , A1916_HNN_WANO_HZ_75
     &            , A1916_HNN_WANO_HZ_80
     &            , A1916_HNN_WANO_HZ_85
     &            , A1916_HNN_WANO_HZ_90
     &            , A1916_HNN_WANO_HZ_95
     &            , A1916_HNN_WANO_HZ_100
     &            , A1916_HNN_WANO_HZ_105
     &            , A1916_HNN_WANO_HZ_107
     &            , A1916_HNN_WANO_HZ_110
     &            , A1916_HNN_WANO_HZ_115
     &            , A1916_HNN_WANO_HZ_120
     &            , A1916_HNN_NWAO_HZ_60
     &            , A1916_HNN_NWAO_HZ_65
     &            , A1916_HNN_NWAO_HZ_70
     &            , A1916_HNN_NWAO_HZ_75
     &            , A1916_HNN_NWAO_HZ_80
     &            , A1916_HNN_NWAO_HZ_85
     &            , A1916_HNN_NWAO_HZ_90
     &            , A1916_HNN_NWAO_HZ_95
     &            , A1916_HNN_NWAO_HZ_100
     &            , A1916_HNN_NWAO_HZ_105
     &            , A1916_HNN_NWAO_HZ_107
     &            , A1916_HNN_NWAO_HZ_110
     &            , A1916_HNN_NWAO_HZ_115
     &            , A1916_HNN_NWAO_HZ_120
     &            , A1999_Hnn_normsh
c	write (6,*) 'in a1916_hnn_mass_sig',1
      if (first) then
         n60wao=A1999_Hnn_normsh(A1916_HNN_WAO_HZ_60,
     &             massl,massh,500)
         n65wao=A1999_Hnn_normsh(A1916_HNN_WAO_HZ_65,
     &             massl,massh,500)
         n70wao=A1999_Hnn_normsh(A1916_HNN_WAO_HZ_70,
     &             massl,massh,500)
         n75wao=A1999_Hnn_normsh(A1916_HNN_WAO_HZ_75,
     &             massl,massh,500)
         n80wao=A1999_Hnn_normsh(A1916_HNN_WAO_HZ_80,
     &             massl,massh,500)
         n85wao=A1999_Hnn_normsh(A1916_HNN_WAO_HZ_85,
     &             massl,massh,500)
         n90wao=A1999_Hnn_normsh(A1916_HNN_WAO_HZ_90,
     &             massl,massh,500)
         n95wao=A1999_Hnn_normsh(A1916_HNN_WAO_HZ_95,
     &             massl,massh,500)
         n100wao=A1999_Hnn_normsh(A1916_HNN_WAO_HZ_100,
     &             massl,massh,500)
         n105wao=A1999_Hnn_normsh(A1916_HNN_WAO_HZ_105,
     &             massl,massh,500)
         n107wao=A1999_Hnn_normsh(A1916_HNN_WAO_HZ_107,
     &             massl,massh,500)
         n110wao=A1999_Hnn_normsh(A1916_HNN_WAO_HZ_110,
     &             massl,massh,500)
         n115wao=A1999_Hnn_normsh(A1916_HNN_WAO_HZ_115,
     &             massl,massh,500)
         n120wao=A1999_Hnn_normsh(A1916_HNN_WAO_HZ_120,
     &             massl,massh,500)
         n60wano=A1999_Hnn_normsh(A1916_HNN_WANO_HZ_60,
     &             massl,massh,500)
         n65wano=A1999_Hnn_normsh(A1916_HNN_WANO_HZ_65,
     &             massl,massh,500)
         n70wano=A1999_Hnn_normsh(A1916_HNN_WANO_HZ_70,
     &             massl,massh,500)
         n75wano=A1999_Hnn_normsh(A1916_HNN_WANO_HZ_75,
     &             massl,massh,500)
         n80wano=A1999_Hnn_normsh(A1916_HNN_WANO_HZ_80,
     &             massl,massh,500)
         n85wano=A1999_Hnn_normsh(A1916_HNN_WANO_HZ_85,
     &             massl,massh,500)
         n90wano=A1999_Hnn_normsh(A1916_HNN_WANO_HZ_90,
     &             massl,massh,500)
         n95wano=A1999_Hnn_normsh(A1916_HNN_WANO_HZ_95,
     &             massl,massh,500)
         n100wano=A1999_Hnn_normsh(A1916_HNN_WANO_HZ_100,
     &             massl,massh,500)
         n105wano=A1999_Hnn_normsh(A1916_HNN_WANO_HZ_105,
     &             massl,massh,500)
         n107wano=A1999_Hnn_normsh(A1916_HNN_WANO_HZ_107,
     &             massl,massh,500)
         n110wano=A1999_Hnn_normsh(A1916_HNN_WANO_HZ_110,
     &             massl,massh,500)
         n115wano=A1999_Hnn_normsh(A1916_HNN_WANO_HZ_115,
     &             massl,massh,500)
         n120wano=A1999_Hnn_normsh(A1916_HNN_WANO_HZ_120,
     &             massl,massh,500)
         n60nwao=A1999_Hnn_normsh(A1916_HNN_NWAO_HZ_60,
     &             massl,massh,500)
         n65nwao=A1999_Hnn_normsh(A1916_HNN_NWAO_HZ_65,
     &             massl,massh,500)
         n70nwao=A1999_Hnn_normsh(A1916_HNN_NWAO_HZ_70,
     &             massl,massh,500)
         n75nwao=A1999_Hnn_normsh(A1916_HNN_NWAO_HZ_75,
     &             massl,massh,500)
         n80nwao=A1999_Hnn_normsh(A1916_HNN_NWAO_HZ_80,
     &             massl,massh,500)
         n85nwao=A1999_Hnn_normsh(A1916_HNN_NWAO_HZ_85,
     &             massl,massh,500)
         n90nwao=A1999_Hnn_normsh(A1916_HNN_NWAO_HZ_90,
     &             massl,massh,500)
         n95nwao=A1999_Hnn_normsh(A1916_HNN_NWAO_HZ_95,
     &             massl,massh,500)
         n100nwao=A1999_Hnn_normsh(A1916_HNN_NWAO_HZ_100,
     &             massl,massh,500)
         n105nwao=A1999_Hnn_normsh(A1916_HNN_NWAO_HZ_105,
     &             massl,massh,500)
         n107nwao=A1999_Hnn_normsh(A1916_HNN_NWAO_HZ_107,
     &             massl,massh,500)
         n110nwao=A1999_Hnn_normsh(A1916_HNN_NWAO_HZ_110,
     &             massl,massh,500)
         n115nwao=A1999_Hnn_normsh(A1916_HNN_NWAO_HZ_115,
     &             massl,massh,500)
         n120nwao=A1999_Hnn_normsh(A1916_HNN_NWAO_HZ_120,
     &             massl,massh,500)
         first = .false.
      endif
c	write (6,*) 'in a1916_hnn_mass_sig',2,n60wao,n60wano,n60nwao

      
*------------------------------------
* find position
* =============
      if    ( hmass.lt.masst(1   ) ) then
          i1 = 1
          i2 = 1
          d1 = 0.0
          d2 = 1.0
      elseif( hmass.ge.masst(mpnt) ) then
          i1 = mpnt
          i2 = mpnt
          d1 = 1.0
          d2 = 0.0
      else
          do i = 1, mpnt-1
          if( hmass.ge.masst(i) .and. hmass.lt.masst(i+1) ) then
          i1 = i
          i2 = i + 1
          endif
          enddo
          d  = masst(i2) - masst(i1)
          d1 = (hmass - masst(i1))/d
          d2 = (masst(i2) - hmass)/d
      endif
c	write (6,*) 'in a1916_hnn_mass_sig',3
      c1 = corpk(iana,i1)
      c2 = corpk(iana,i2)
      c  = c1*d2 + c2*d1
c	write (6,*) 'in a1916_hnn_mass_sig',4

* very painful procedure to get function values
* =============================================
      if(hmass.le.75.0) then
         if (x.ge.c) then
            p1 = x - c + corpk(iana,i1)
            p2 = x - c + corpk(iana,i2)
         else
            p1 = corpk(iana,i1)-(c-x)/(c-massl)*(corpk(iana,i1)-massl)
            p2 = corpk(iana,i2)-(c-x)/(c-massl)*(corpk(iana,i2)-massl)
         endif
      elseif(hmass.ge.massh) then
         if (x.le.c) then
            p1 = x - c + corpk(iana,i1)
            p2 = x - c + corpk(iana,i2)
         else
            p1 = corpk(iana,i1)+(x-c)/(massh-c)*(massh-corpk(iana,i1))
            p2 = corpk(iana,i2)+(x-c)/(massh-c)*(massh-corpk(iana,i2))
         endif
      else
         p1 = x - c + corpk(iana,i1)
         p2 = x - c + corpk(iana,i2)
      endif
c	write (6,*) 'in a1916_hnn_mass_sig',5

         
      if( iana.eq.1 ) then
          if( i1.eq.1 ) then
              f1 = A1916_HNN_WAO_HZ_60(p1)
              n1 = n60wao
          elseif( i1.eq.2 ) then
              f1 = A1916_HNN_WAO_HZ_65(p1)
              n1 = n65wao
          elseif( i1.eq.3 ) then
              f1 = A1916_HNN_WAO_HZ_70(p1)
              n1 = n70wao
          elseif( i1.eq.4 ) then
              f1 = A1916_HNN_WAO_HZ_75(p1)
              n1 = n75wao
          elseif( i1.eq.5 ) then
              f1 = A1916_HNN_WAO_HZ_80(p1)
              n1 = n80wao
          elseif( i1.eq.6 ) then
              f1 = A1916_HNN_WAO_HZ_85(p1)
              n1 = n85wao
          elseif( i1.eq.7 ) then
              f1 = A1916_HNN_WAO_HZ_90(p1)
              n1 = n90wao
          elseif( i1.eq.8 ) then
              f1 = A1916_HNN_WAO_HZ_95(p1)
              n1 = n95wao
          elseif( i1.eq.9 ) then
              f1 = A1916_HNN_WAO_HZ_100(p1)
              n1 = n100wao
          elseif( i1.eq.10 ) then
              f1 = A1916_HNN_WAO_HZ_105(p1)
              n1 = n105wao
          elseif( i1.eq.11 ) then
              f1 = A1916_HNN_WAO_HZ_107(p1)
              n1 = n107wao
          elseif( i1.eq.12 ) then
              f1 = A1916_HNN_WAO_HZ_110(p1)
              n1 = n110wao
          elseif( i1.eq.13 ) then
              f1 = A1916_HNN_WAO_HZ_115(p1)
              n1 = n115wao
          elseif( i1.eq.14 ) then
              f1 = A1916_HNN_WAO_HZ_120(p1)
              n1 = n120wao
          endif
          if( i2.eq.1 ) then
              f2 = A1916_HNN_WAO_HZ_60(p2)
              n2 = n60wao
          elseif( i2.eq.2 ) then
              f2 = A1916_HNN_WAO_HZ_65(p2)
              n2 = n65wao
          elseif( i2.eq.3 ) then
              f2 = A1916_HNN_WAO_HZ_70(p2)
              n2 = n70wao
          elseif( i2.eq.4 ) then
              f2 = A1916_HNN_WAO_HZ_75(p2)
              n2 = n75wao
          elseif( i2.eq.5 ) then
              f2 = A1916_HNN_WAO_HZ_80(p2)
              n2 = n80wao
          elseif( i2.eq.6 ) then
              f2 = A1916_HNN_WAO_HZ_85(p2)
              n2 = n85wao
          elseif( i2.eq.7 ) then
              f2 = A1916_HNN_WAO_HZ_90(p2)
              n2 = n90wao
          elseif( i2.eq.8 ) then
               f2 = A1916_HNN_WAO_HZ_95(p2)
              n2 = n95wao
          elseif( i2.eq.9 ) then
              f2 = A1916_HNN_WAO_HZ_100(p2)
              n2 = n100wao
          elseif( i2.eq.10 ) then
              f2 = A1916_HNN_WAO_HZ_105(p2)
              n2 = n105wao
          elseif( i2.eq.11 ) then
              f2 = A1916_HNN_WAO_HZ_107(p2)
              n2 = n107wao
          elseif( i2.eq.12 ) then
              f2 = A1916_HNN_WAO_HZ_110(p2)
              n2 = n110wao
          elseif( i2.eq.13 ) then
              f2 = A1916_HNN_WAO_HZ_115(p2)
              n2 = n115wao
          elseif( i2.eq.14 ) then
              f2 = A1916_HNN_WAO_HZ_120(p2)
              n2 = n120wao
          endif

      elseif( iana.eq.2 ) then
          if( i1.eq.1 ) then
              f1 = A1916_HNN_WANO_HZ_60(p1)
              n1 = n60wano
          elseif( i1.eq.2 ) then
              f1 = A1916_HNN_WANO_HZ_65(p1)
              n1 = n65wano
          elseif( i1.eq.3 ) then
              f1 = A1916_HNN_WANO_HZ_70(p1)
              n1 = n70wano
          elseif( i1.eq.4 ) then
              f1 = A1916_HNN_WANO_HZ_75(p1)
              n1 = n75wano
          elseif( i1.eq.5 ) then
              f1 = A1916_HNN_WANO_HZ_80(p1)
              n1 = n80wano
          elseif( i1.eq.6 ) then
              f1 = A1916_HNN_WANO_HZ_85(p1)
              n1 = n85wano
          elseif( i1.eq.7 ) then
              f1 = A1916_HNN_WANO_HZ_90(p1)
              n1 = n90wano
          elseif( i1.eq.8 ) then
              f1 = A1916_HNN_WANO_HZ_95(p1)
              n1 = n95wano
          elseif( i1.eq.9 ) then
              f1 = A1916_HNN_WANO_HZ_100(p1)
              n1 = n100wano
          elseif( i1.eq.10 ) then
              f1 = A1916_HNN_WANO_HZ_105(p1)
              n1 = n105wano
          elseif( i1.eq.11 ) then
              f1 = A1916_HNN_WANO_HZ_107(p1)
              n1 = n107wano
          elseif( i1.eq.12 ) then
              f1 = A1916_HNN_WANO_HZ_110(p1)
              n1 = n110wano
          elseif( i1.eq.13 ) then
              f1 = A1916_HNN_WANO_HZ_115(p1)
              n1 = n115wano
          elseif( i1.eq.14 ) then
              f1 = A1916_HNN_WANO_HZ_120(p1)
              n1 = n120wano
          endif
          if( i2.eq.1 ) then
              f2 = A1916_HNN_WANO_HZ_60(p2)
              n2 = n60wano
          elseif( i2.eq.2 ) then
              f2 = A1916_HNN_WANO_HZ_65(p2)
              n2 = n65wano
          elseif( i2.eq.3 ) then
              f2 = A1916_HNN_WANO_HZ_70(p2)
              n2 = n70wano
          elseif( i2.eq.4 ) then
              f2 = A1916_HNN_WANO_HZ_75(p2)
              n2 = n75wano
          elseif( i2.eq.5 ) then
              f2 = A1916_HNN_WANO_HZ_80(p2)
              n2 = n80wano
          elseif( i2.eq.6 ) then
              f2 = A1916_HNN_WANO_HZ_85(p2)
              n2 = n85wano
          elseif( i2.eq.7 ) then
              f2 = A1916_HNN_WANO_HZ_90(p2)
              n2 = n90wano
          elseif( i2.eq.8 ) then
              f2 = A1916_HNN_WANO_HZ_95(p2)
              n2 = n95wano
          elseif( i2.eq.9 ) then
              f2 = A1916_HNN_WANO_HZ_100(p2)
              n2 = n100wano
          elseif( i2.eq.10 ) then
              f2 = A1916_HNN_WANO_HZ_105(p2)
              n2 = n105wano
          elseif( i2.eq.11 ) then
              f2 = A1916_HNN_WANO_HZ_107(p2)
              n2 = n107wano
          elseif( i2.eq.12 ) then
              f2 = A1916_HNN_WANO_HZ_110(p2)
              n2 = n110wano
          elseif( i2.eq.13 ) then
              f2 = A1916_HNN_WANO_HZ_115(p2)
              n2 = n115wano
          elseif( i2.eq.14 ) then
              f2 = A1916_HNN_WANO_HZ_120(p2)
              n2 = n120wano
          endif

      elseif( iana.eq.3 ) then
          if( i1.eq.1 ) then
              f1 = A1916_HNN_NWAO_HZ_60(p1)
              n1 = n60nwao
          elseif( i1.eq.2 ) then
              f1 = A1916_HNN_NWAO_HZ_65(p1)
              n1 = n65nwao
          elseif( i1.eq.3 ) then
              f1 = A1916_HNN_NWAO_HZ_70(p1)
              n1 = n70nwao
          elseif( i1.eq.4 ) then
              f1 = A1916_HNN_NWAO_HZ_75(p1)
              n1 = n75nwao
          elseif( i1.eq.5 ) then
              f1 = A1916_HNN_NWAO_HZ_80(p1)
              n1 = n80nwao
          elseif( i1.eq.6 ) then
              f1 = A1916_HNN_NWAO_HZ_85(p1)
              n1 = n85nwao
          elseif( i1.eq.7 ) then
              f1 = A1916_HNN_NWAO_HZ_90(p1)
              n1 = n90nwao
          elseif( i1.eq.8 ) then
              f1 = A1916_HNN_NWAO_HZ_95(p1)
              n1 = n95nwao
          elseif( i1.eq.9 ) then
              f1 = A1916_HNN_NWAO_HZ_100(p1)
              n1 = n100nwao
          elseif( i1.eq.10 ) then
              f1 = A1916_HNN_NWAO_HZ_105(p1)
              n1 = n105nwao
          elseif( i1.eq.11 ) then
              f1 = A1916_HNN_NWAO_HZ_107(p1)
              n1 = n107nwao
          elseif( i1.eq.12 ) then
              f1 = A1916_HNN_NWAO_HZ_110(p1)
              n1 = n110nwao
          elseif( i1.eq.13 ) then
              f1 = A1916_HNN_NWAO_HZ_115(p1)
              n1 = n115nwao
          elseif( i1.eq.14 ) then
              f1 = A1916_HNN_NWAO_HZ_120(p1)
              n1 = n120nwao
          endif
          if( i2.eq.1 ) then
              f2 = A1916_HNN_NWAO_HZ_60(p2)
              n2 = n60nwao
          elseif( i2.eq.2 ) then
              f2 = A1916_HNN_NWAO_HZ_65(p2)
              n2 = n65nwao
          elseif( i2.eq.3 ) then
              f2 = A1916_HNN_NWAO_HZ_70(p2)
              n2 = n70nwao
          elseif( i2.eq.4 ) then
              f2 = A1916_HNN_NWAO_HZ_75(p2)
              n2 = n75nwao
          elseif( i2.eq.5 ) then
              f2 = A1916_HNN_NWAO_HZ_80(p2)
              n2 = n80nwao
          elseif( i2.eq.6 ) then
              f2 = A1916_HNN_NWAO_HZ_85(p2)
              n2 = n85nwao
          elseif( i2.eq.7 ) then
              f2 = A1916_HNN_NWAO_HZ_90(p2)
              n2 = n90nwao
          elseif( i2.eq.8 ) then
              f2 = A1916_HNN_NWAO_HZ_95(p2)
              n2 = n95nwao
          elseif( i2.eq.9 ) then
              f2 = A1916_HNN_NWAO_HZ_100(p2)
              n2 = n100nwao
          elseif( i2.eq.10 ) then
              f2 = A1916_HNN_NWAO_HZ_105(p2)
              n2 = n105nwao
          elseif( i2.eq.11 ) then
              f2 = A1916_HNN_NWAO_HZ_107(p2)
              n2 = n107nwao
          elseif( i2.eq.12 ) then
              f2 = A1916_HNN_NWAO_HZ_110(p2)
              n2 = n110nwao
          elseif( i2.eq.13 ) then
              f2 = A1916_HNN_NWAO_HZ_115(p2)
              n2 = n115nwao
          elseif( i2.eq.14 ) then
              f2 = A1916_HNN_NWAO_HZ_120(p2)
              n2 = n120nwao
          endif
       endif

      f = f1*d2/n1 + f2*d1/n2
      if( f.lt.1.0D-06 ) f = 1.0d-06
      if    ( x.lt.massl .or. x.gt.massh ) then
         f = 0.0d0
      endif

      A1916_HNN_MASS_SIG = f
      end


      DOUBLE PRECISION Function A1916_hnn_fus_mass_sig(x,hmass,iana)
      Implicit none
      Integer       iana
      Real*8        x, hmass
      logical first
      data first /.true./

      Real*8        massl, massh
      Data          massl, massh/ 50.0 ,100.4/

      Integer       mpnt, mana, jpnt, jana
      Parameter   ( mpnt = 14 , mana = 3)
      Real*8        masst(mpnt), corpk(mana,mpnt)
      Data         (masst(jpnt), (corpk(jana,jpnt),jana=1,mana)
     &                                            ,jpnt=1,mpnt)
     &             / 60.00, 82.20, 64.09, 81.92
     &             ,65.00, 83.44, 66.99, 82.90
     &             ,70.00, 86.68, 71.41, 80.56
     &             ,75.00, 88.43, 75.48, 85.58
     &             ,80.00, 89.45, 79.25, 87.51
     &             ,85.00, 89.66, 82.89, 88.96
     &             ,90.00, 91.00, 85.23, 91.04
     &             ,95.00, 93.49, 88.10, 93.05
     &             ,100.00, 94.72, 90.04, 92.91
     &             ,105.00, 93.83, 88.16, 92.89
     &             ,107.00, 93.49, 88.44, 93.04
     &             ,110.00, 93.58, 89.33, 92.86
     &             ,115.00, 93.77, 90.23, 92.61
     &             ,120.00, 94.16, 91.02, 93.97/

      Integer       i , i1, i2
      Real*8        c , c1, c2
     &            , d , d1, d2
     &            , f , f1, f2
     &            ,     p1, p2
     &            ,     n1, n2
     &            ,n60wao,n65wao,n70wao,n75wao,n80wao
     &            ,n85wao,n90wao,n95wao,n100wao,n105wao
     &            ,n107wao,n110wao,n115wao,n120wao
     &            ,n60wano,n65wano,n70wano,n75wano,n80wano
     &            ,n85wano,n90wano,n95wano,n100wano,n105wano
     &            ,n107wano,n110wano,n115wano,n120wano
     &            ,n60nwao,n65nwao,n70nwao,n75nwao,n80nwao
     &            ,n85nwao,n90nwao,n95nwao,n100nwao,n105nwao
     &            ,n107nwao,n110nwao,n115nwao,n120nwao
      SAVE
      Real*8        A1916_HNN_WAO_FUS_60
     &            , A1916_HNN_WAO_FUS_65
     &            , A1916_HNN_WAO_FUS_70
     &            , A1916_HNN_WAO_FUS_75
     &            , A1916_HNN_WAO_FUS_80
     &            , A1916_HNN_WAO_FUS_85
     &            , A1916_HNN_WAO_FUS_90
     &            , A1916_HNN_WAO_FUS_95
     &            , A1916_HNN_WAO_FUS_100
     &            , A1916_HNN_WAO_FUS_105
     &            , A1916_HNN_WAO_FUS_107
     &            , A1916_HNN_WAO_FUS_110
     &            , A1916_HNN_WAO_FUS_115
     &            , A1916_HNN_WAO_FUS_120
     &            , A1916_HNN_WANO_FUS_60
     &            , A1916_HNN_WANO_FUS_65
     &            , A1916_HNN_WANO_FUS_70
     &            , A1916_HNN_WANO_FUS_75
     &            , A1916_HNN_WANO_FUS_80
     &            , A1916_HNN_WANO_FUS_85
     &            , A1916_HNN_WANO_FUS_90
     &            , A1916_HNN_WANO_FUS_95
     &            , A1916_HNN_WANO_FUS_100
     &            , A1916_HNN_WANO_FUS_105
     &            , A1916_HNN_WANO_FUS_107
     &            , A1916_HNN_WANO_FUS_110
     &            , A1916_HNN_WANO_FUS_115
     &            , A1916_HNN_WANO_FUS_120
     &            , A1916_HNN_NWAO_FUS_60
     &            , A1916_HNN_NWAO_FUS_65
     &            , A1916_HNN_NWAO_FUS_70
     &            , A1916_HNN_NWAO_FUS_75
     &            , A1916_HNN_NWAO_FUS_80
     &            , A1916_HNN_NWAO_FUS_85
     &            , A1916_HNN_NWAO_FUS_90
     &            , A1916_HNN_NWAO_FUS_95
     &            , A1916_HNN_NWAO_FUS_100
     &            , A1916_HNN_NWAO_FUS_105
     &            , A1916_HNN_NWAO_FUS_107
     &            , A1916_HNN_NWAO_FUS_110
     &            , A1916_HNN_NWAO_FUS_115
     &            , A1916_HNN_NWAO_FUS_120
     &            , A1999_Hnn_normsh
      External        A1916_HNN_WAO_FUS_60
     &            , A1916_HNN_WAO_FUS_65
     &            , A1916_HNN_WAO_FUS_70
     &            , A1916_HNN_WAO_FUS_75
     &            , A1916_HNN_WAO_FUS_80
     &            , A1916_HNN_WAO_FUS_85
     &            , A1916_HNN_WAO_FUS_90
     &            , A1916_HNN_WAO_FUS_95
     &            , A1916_HNN_WAO_FUS_100
     &            , A1916_HNN_WAO_FUS_105
     &            , A1916_HNN_WAO_FUS_107
     &            , A1916_HNN_WAO_FUS_110
     &            , A1916_HNN_WAO_FUS_115
     &            , A1916_HNN_WAO_FUS_120
     &            , A1916_HNN_WANO_FUS_60
     &            , A1916_HNN_WANO_FUS_65
     &            , A1916_HNN_WANO_FUS_70
     &            , A1916_HNN_WANO_FUS_75
     &            , A1916_HNN_WANO_FUS_80
     &            , A1916_HNN_WANO_FUS_85
     &            , A1916_HNN_WANO_FUS_90
     &            , A1916_HNN_WANO_FUS_95
     &            , A1916_HNN_WANO_FUS_100
     &            , A1916_HNN_WANO_FUS_105
     &            , A1916_HNN_WANO_FUS_107
     &            , A1916_HNN_WANO_FUS_110
     &            , A1916_HNN_WANO_FUS_115
     &            , A1916_HNN_WANO_FUS_120
     &            , A1916_HNN_NWAO_FUS_60
     &            , A1916_HNN_NWAO_FUS_65
     &            , A1916_HNN_NWAO_FUS_70
     &            , A1916_HNN_NWAO_FUS_75
     &            , A1916_HNN_NWAO_FUS_80
     &            , A1916_HNN_NWAO_FUS_85
     &            , A1916_HNN_NWAO_FUS_90
     &            , A1916_HNN_NWAO_FUS_95
     &            , A1916_HNN_NWAO_FUS_100
     &            , A1916_HNN_NWAO_FUS_105
     &            , A1916_HNN_NWAO_FUS_107
     &            , A1916_HNN_NWAO_FUS_110
     &            , A1916_HNN_NWAO_FUS_115
     &            , A1916_HNN_NWAO_FUS_120
     &            , A1999_Hnn_normsh
      if (first) then
         n60wao=A1999_Hnn_normsh(A1916_HNN_WAO_fus_60,
     &             massl,massh,500)
         n65wao=A1999_Hnn_normsh(A1916_HNN_WAO_fus_65,
     &             massl,massh,500)
         n70wao=A1999_Hnn_normsh(A1916_HNN_WAO_fus_70,
     &             massl,massh,500)
         n75wao=A1999_Hnn_normsh(A1916_HNN_WAO_fus_75,
     &             massl,massh,500)
         n80wao=A1999_Hnn_normsh(A1916_HNN_WAO_fus_80,
     &             massl,massh,500)
         n85wao=A1999_Hnn_normsh(A1916_HNN_WAO_fus_85,
     &             massl,massh,500)
         n90wao=A1999_Hnn_normsh(A1916_HNN_WAO_fus_90,
     &             massl,massh,500)
         n95wao=A1999_Hnn_normsh(A1916_HNN_WAO_fus_95,
     &             massl,massh,500)
         n100wao=A1999_Hnn_normsh(A1916_HNN_WAO_fus_100,
     &             massl,massh,500)
         n105wao=A1999_Hnn_normsh(A1916_HNN_WAO_fus_105,
     &             massl,massh,500)
         n107wao=A1999_Hnn_normsh(A1916_HNN_WAO_fus_107,
     &             massl,massh,500)
         n110wao=A1999_Hnn_normsh(A1916_HNN_WAO_fus_110,
     &             massl,massh,500)
         n115wao=A1999_Hnn_normsh(A1916_HNN_WAO_fus_115,
     &             massl,massh,500)
         n120wao=A1999_Hnn_normsh(A1916_HNN_WAO_fus_120,
     &             massl,massh,500)
         n60wano=A1999_Hnn_normsh(A1916_HNN_WANO_fus_60,
     &             massl,massh,500)
         n65wano=A1999_Hnn_normsh(A1916_HNN_WANO_fus_65,
     &             massl,massh,500)
         n70wano=A1999_Hnn_normsh(A1916_HNN_WANO_fus_70,
     &             massl,massh,500)
         n75wano=A1999_Hnn_normsh(A1916_HNN_WANO_fus_75,
     &             massl,massh,500)
         n80wano=A1999_Hnn_normsh(A1916_HNN_WANO_fus_80,
     &             massl,massh,500)
         n85wano=A1999_Hnn_normsh(A1916_HNN_WANO_fus_85,
     &             massl,massh,500)
         n90wano=A1999_Hnn_normsh(A1916_HNN_WANO_fus_90,
     &             massl,massh,500)
         n95wano=A1999_Hnn_normsh(A1916_HNN_WANO_fus_95,
     &             massl,massh,500)
         n100wano=A1999_Hnn_normsh(A1916_HNN_WANO_fus_100,
     &             massl,massh,500)
         n105wano=A1999_Hnn_normsh(A1916_HNN_WANO_fus_105,
     &             massl,massh,500)
         n107wano=A1999_Hnn_normsh(A1916_HNN_WANO_fus_107,
     &             massl,massh,500)
         n110wano=A1999_Hnn_normsh(A1916_HNN_WANO_fus_110,
     &             massl,massh,500)
         n115wano=A1999_Hnn_normsh(A1916_HNN_WANO_fus_115,
     &             massl,massh,500)
         n120wano=A1999_Hnn_normsh(A1916_HNN_WANO_fus_120,
     &             massl,massh,500)
         n60nwao=A1999_Hnn_normsh(A1916_HNN_NWAO_fus_60,
     &             massl,massh,500)
         n65nwao=A1999_Hnn_normsh(A1916_HNN_NWAO_fus_65,
     &             massl,massh,500)
         n70nwao=A1999_Hnn_normsh(A1916_HNN_NWAO_fus_70,
     &             massl,massh,500)
         n75nwao=A1999_Hnn_normsh(A1916_HNN_NWAO_fus_75,
     &             massl,massh,500)
         n80nwao=A1999_Hnn_normsh(A1916_HNN_NWAO_fus_80,
     &             massl,massh,500)
         n85nwao=A1999_Hnn_normsh(A1916_HNN_NWAO_fus_85,
     &             massl,massh,500)
         n90nwao=A1999_Hnn_normsh(A1916_HNN_NWAO_fus_90,
     &             massl,massh,500)
         n95nwao=A1999_Hnn_normsh(A1916_HNN_NWAO_fus_95,
     &             massl,massh,500)
         n100nwao=A1999_Hnn_normsh(A1916_HNN_NWAO_fus_100,
     &             massl,massh,500)
         n105nwao=A1999_Hnn_normsh(A1916_HNN_NWAO_fus_105,
     &             massl,massh,500)
         n107nwao=A1999_Hnn_normsh(A1916_HNN_NWAO_fus_107,
     &             massl,massh,500)
         n110nwao=A1999_Hnn_normsh(A1916_HNN_NWAO_fus_110,
     &             massl,massh,500)
         n115nwao=A1999_Hnn_normsh(A1916_HNN_NWAO_fus_115,
     &             massl,massh,500)
         n120nwao=A1999_Hnn_normsh(A1916_HNN_NWAO_fus_120,
     &             massl,massh,500)
         first = .false.
      endif

*------------------------------------
* find position
* =============
      if    ( hmass.lt.masst(1   ) ) then
          i1 = 1
          i2 = 1
          d1 = 0.0
          d2 = 1.0
      elseif( hmass.ge.masst(mpnt) ) then
          i1 = mpnt
          i2 = mpnt
          d1 = 1.0
          d2 = 0.0
      else
          do i = 1, mpnt-1
          if( hmass.ge.masst(i) .and. hmass.lt.masst(i+1) ) then
          i1 = i
          i2 = i + 1
          endif
          enddo
          d  = masst(i2) - masst(i1)
          d1 = (hmass - masst(i1))/d
          d2 = (masst(i2) - hmass)/d
      endif
      c1 = corpk(iana,i1)
      c2 = corpk(iana,i2)
      c  = c1*d2 + c2*d1

* very painful procedure to get function values
* =============================================
      if(hmass.le.75.0) then
         if (x.ge.c) then
            p1 = x - c + corpk(iana,i1)
            p2 = x - c + corpk(iana,i2)
         else
            p1 = corpk(iana,i1)-(c-x)/(c-massl)*(corpk(iana,i1)-massl)
            p2 = corpk(iana,i2)-(c-x)/(c-massl)*(corpk(iana,i2)-massl)
         endif
      elseif(hmass.ge.massh) then
         if (x.le.c) then
            p1 = x - c + corpk(iana,i1)
            p2 = x - c + corpk(iana,i2)
         else
            p1 = corpk(iana,i1)+(x-c)/(massh-c)*(massh-corpk(iana,i1))
            p2 = corpk(iana,i2)+(x-c)/(massh-c)*(massh-corpk(iana,i2))
         endif
      else
         p1 = x - c + corpk(iana,i1)
         p2 = x - c + corpk(iana,i2)
      endif
      if( iana.eq.1 ) then
          if( i1.eq.1 ) then
              f1 = A1916_HNN_WAO_FUS_60(p1)
              n1 = n60wao
          elseif( i1.eq.2 ) then
              f1 = A1916_HNN_WAO_FUS_65(p1)
              n1 = n65wao
          elseif( i1.eq.3 ) then
              f1 = A1916_HNN_WAO_FUS_70(p1)
              n1 = n70wao
          elseif( i1.eq.4 ) then
              f1 = A1916_HNN_WAO_FUS_75(p1)
              n1 = n75wao
          elseif( i1.eq.5 ) then
              f1 = A1916_HNN_WAO_FUS_80(p1)
              n1 = n80wao
          elseif( i1.eq.6 ) then
              f1 = A1916_HNN_WAO_FUS_85(p1)
              n1 = n85wao
          elseif( i1.eq.7 ) then
              f1 = A1916_HNN_WAO_FUS_90(p1)
              n1 = n90wao
          elseif( i1.eq.8 ) then
              f1 = A1916_HNN_WAO_FUS_95(p1)
              n1 = n95wao
          elseif( i1.eq.9 ) then
              f1 = A1916_HNN_WAO_FUS_100(p1)
              n1 = n100wao
          elseif( i1.eq.10 ) then
              f1 = A1916_HNN_WAO_FUS_105(p1)
              n1 = n105wao
          elseif( i1.eq.11 ) then
              f1 = A1916_HNN_WAO_FUS_107(p1)
              n1 = n107wao
          elseif( i1.eq.12 ) then
              f1 = A1916_HNN_WAO_FUS_110(p1)
              n1 = n110wao
          elseif( i1.eq.13 ) then
              f1 = A1916_HNN_WAO_FUS_115(p1)
              n1 = n115wao
          elseif( i1.eq.14 ) then
              f1 = A1916_HNN_WAO_FUS_120(p1)
              n1 = n120wao
          endif
          if( i2.eq.1 ) then
              f2 = A1916_HNN_WAO_FUS_60(p2)
              n2 = n60wao
          elseif( i2.eq.2 ) then
              f2 = A1916_HNN_WAO_FUS_65(p2)
              n2 = n65wao
          elseif( i2.eq.3 ) then
              f2 = A1916_HNN_WAO_FUS_70(p2)
              n2 = n70wao
          elseif( i2.eq.4 ) then
              f2 = A1916_HNN_WAO_FUS_75(p2)
              n2 = n75wao
          elseif( i2.eq.5 ) then
              f2 = A1916_HNN_WAO_FUS_80(p2)
              n2 = n80wao
          elseif( i2.eq.6 ) then
              f2 = A1916_HNN_WAO_FUS_85(p2)
              n2 = n85wao
          elseif( i2.eq.7 ) then
              f2 = A1916_HNN_WAO_FUS_90(p2)
              n2 = n90wao
          elseif( i2.eq.8 ) then
              f2 = A1916_HNN_WAO_FUS_95(p2)
              n2 = n95wao
          elseif( i2.eq.9 ) then
              f2 = A1916_HNN_WAO_FUS_100(p2)
              n2 = n100wao
          elseif( i2.eq.10 ) then
              f2 = A1916_HNN_WAO_FUS_105(p2)
              n2 = n105wao
          elseif( i2.eq.11 ) then
              f2 = A1916_HNN_WAO_FUS_107(p2)
              n2 = n107wao
          elseif( i2.eq.12 ) then
              f2 = A1916_HNN_WAO_FUS_110(p2)
              n2 = n110wao
          elseif( i2.eq.13 ) then
              f2 = A1916_HNN_WAO_FUS_115(p2)
              n2 = n115wao
          elseif( i2.eq.14 ) then
              f2 = A1916_HNN_WAO_FUS_120(p2)
              n2 = n120wao
          endif

      elseif( iana.eq.2 ) then
          if( i1.eq.1 ) then
              f1 = A1916_HNN_WANO_FUS_60(p1)
              n1 = n60wano
          elseif( i1.eq.2 ) then
              f1 = A1916_HNN_WANO_FUS_65(p1)
              n1 = n65wano
          elseif( i1.eq.3 ) then
              f1 = A1916_HNN_WANO_FUS_70(p1)
              n1 = n70wano
          elseif( i1.eq.4 ) then
              f1 = A1916_HNN_WANO_FUS_75(p1)
              n1 = n75wano
          elseif( i1.eq.5 ) then
              f1 = A1916_HNN_WANO_FUS_80(p1)
              n1 = n80wano
          elseif( i1.eq.6 ) then
              f1 = A1916_HNN_WANO_FUS_85(p1)
              n1 = n85wano
          elseif( i1.eq.7 ) then
              f1 = A1916_HNN_WANO_FUS_90(p1)
              n1 = n90wano
          elseif( i1.eq.8 ) then
              f1 = A1916_HNN_WANO_FUS_95(p1)
              n1 = n95wano
          elseif( i1.eq.9 ) then
              f1 = A1916_HNN_WANO_FUS_100(p1)
              n1 = n100wano
          elseif( i1.eq.10 ) then
              f1 = A1916_HNN_WANO_FUS_105(p1)
              n1 = n105wano
          elseif( i1.eq.11 ) then
              f1 = A1916_HNN_WANO_FUS_107(p1)
              n1 = n107wano
          elseif( i1.eq.12 ) then
              f1 = A1916_HNN_WANO_FUS_110(p1)
              n1 = n110wano
          elseif( i1.eq.13 ) then
              f1 = A1916_HNN_WANO_FUS_115(p1)
              n1 = n115wano
          elseif( i1.eq.14 ) then
              f1 = A1916_HNN_WANO_FUS_120(p1)
              n1 = n120wano
          endif
          if( i2.eq.1 ) then
              f2 = A1916_HNN_WANO_FUS_60(p2)
              n2 = n60wano
          elseif( i2.eq.2 ) then
              f2 = A1916_HNN_WANO_FUS_65(p2)
              n2 = n65wano
          elseif( i2.eq.3 ) then
              f2 = A1916_HNN_WANO_FUS_70(p2)
              n2 = n70wano
          elseif( i2.eq.4 ) then
              f2 = A1916_HNN_WANO_FUS_75(p2)
              n2 = n75wano
          elseif( i2.eq.5 ) then
              f2 = A1916_HNN_WANO_FUS_80(p2)
              n2 = n80wano
          elseif( i2.eq.6 ) then
              f2 = A1916_HNN_WANO_FUS_85(p2)
              n2 = n85wano
          elseif( i2.eq.7 ) then
              f2 = A1916_HNN_WANO_FUS_90(p2)
              n2 = n90wano
          elseif( i2.eq.8 ) then
              f2 = A1916_HNN_WANO_FUS_95(p2)
              n2 = n95wano
          elseif( i2.eq.9 ) then
              f2 = A1916_HNN_WANO_FUS_100(p2)
              n2 = n100wano
          elseif( i2.eq.10 ) then
              f2 = A1916_HNN_WANO_FUS_105(p2)
              n2 = n105wano
          elseif( i2.eq.11 ) then
              f2 = A1916_HNN_WANO_FUS_107(p2)
              n2 = n107wano
          elseif( i2.eq.12 ) then
              f2 = A1916_HNN_WANO_FUS_110(p2)
              n2 = n110wano
          elseif( i2.eq.13 ) then
              f2 = A1916_HNN_WANO_FUS_115(p2)
              n2 = n115wano
          elseif( i2.eq.14 ) then
              f2 = A1916_HNN_WANO_FUS_120(p2)
              n2 = n120wano
          endif

      elseif( iana.eq.3 ) then
          if( i1.eq.1 ) then
              f1 = A1916_HNN_NWAO_FUS_60(p1)
              n1 = n60nwao
          elseif( i1.eq.2 ) then
              f1 = A1916_HNN_NWAO_FUS_65(p1)
              n1 = n65nwao
          elseif( i1.eq.3 ) then
              f1 = A1916_HNN_NWAO_FUS_70(p1)
              n1 = n70nwao
          elseif( i1.eq.4 ) then
              f1 = A1916_HNN_NWAO_FUS_75(p1)
              n1 = n75nwao
          elseif( i1.eq.5 ) then
              f1 = A1916_HNN_NWAO_FUS_80(p1)
              n1 = n80nwao
          elseif( i1.eq.6 ) then
              f1 = A1916_HNN_NWAO_FUS_85(p1)
              n1 = n85nwao
          elseif( i1.eq.7 ) then
              f1 = A1916_HNN_NWAO_FUS_90(p1)
              n1 = n90nwao
          elseif( i1.eq.8 ) then
              f1 = A1916_HNN_NWAO_FUS_95(p1)
              n1 = n95nwao
          elseif( i1.eq.9 ) then
              f1 = A1916_HNN_NWAO_FUS_100(p1)
              n1 = n100nwao
          elseif( i1.eq.10 ) then
              f1 = A1916_HNN_NWAO_FUS_105(p1)
              n1 = n105nwao
          elseif( i1.eq.11 ) then
              f1 = A1916_HNN_NWAO_FUS_107(p1)
              n1 = n107nwao
          elseif( i1.eq.12 ) then
              f1 = A1916_HNN_NWAO_FUS_110(p1)
              n1 = n110nwao
          elseif( i1.eq.13 ) then
              f1 = A1916_HNN_NWAO_FUS_115(p1)
              n1 = n115nwao
          elseif( i1.eq.14 ) then
              f1 = A1916_HNN_NWAO_FUS_120(p1)
              n1 = n120nwao
          endif
          if( i2.eq.1 ) then
              f2 = A1916_HNN_NWAO_FUS_60(p2)
              n2 = n60nwao
          elseif( i2.eq.2 ) then
              f2 = A1916_HNN_NWAO_FUS_65(p2)
              n2 = n65nwao
          elseif( i2.eq.3 ) then
              f2 = A1916_HNN_NWAO_FUS_70(p2)
              n2 = n70nwao
          elseif( i2.eq.4 ) then
              f2 = A1916_HNN_NWAO_FUS_75(p2)
              n2 = n75nwao
          elseif( i2.eq.5 ) then
              f2 = A1916_HNN_NWAO_FUS_80(p2)
              n2 = n80nwao
          elseif( i2.eq.6 ) then
              f2 = A1916_HNN_NWAO_FUS_85(p2)
              n2 = n85nwao
          elseif( i2.eq.7 ) then
              f2 = A1916_HNN_NWAO_FUS_90(p2)
              n2 = n90nwao
          elseif( i2.eq.8 ) then
              f2 = A1916_HNN_NWAO_FUS_95(p2)
              n2 = n95nwao
          elseif( i2.eq.9 ) then
              f2 = A1916_HNN_NWAO_FUS_100(p2)
              n2 = n100nwao
          elseif( i2.eq.10 ) then
              f2 = A1916_HNN_NWAO_FUS_105(p2)
              n2 = n105nwao
          elseif( i2.eq.11 ) then
              f2 = A1916_HNN_NWAO_FUS_107(p2)
              n2 = n107nwao
          elseif( i2.eq.12 ) then
              f2 = A1916_HNN_NWAO_FUS_110(p2)
              n2 = n110nwao
          elseif( i2.eq.13 ) then
              f2 = A1916_HNN_NWAO_FUS_115(p2)
              n2 = n115nwao
          elseif( i2.eq.14 ) then
              f2 = A1916_HNN_NWAO_FUS_120(p2)
              n2 = n120nwao
          endif
       endif
      f = f1*d2/n1 + f2*d1/n2

      if( f.lt.1.0D-06 ) f = 1.0d-06
      if    ( x.lt.massl .or. x.gt.massh ) then
         f = 0.0d0
      endif

      A1916_hnn_fus_mass_sig = f
      end





CCCCCC
CCCCCC
CCCCCC
      DOUBLE PRECISION Function A1916_HNN_MASS_BKG(x,iana,ibkg)
      Implicit none 
      Integer       iana,ibkg
      Real*8        x

      Real*8        A1916_HNN_WAO_QQ
     &            , A1916_HNN_WAO_WW
     &            , A1916_HNN_WAO_ZZ
     &            , A1916_HNN_WANO_QQ
     &            , A1916_HNN_WANO_WW
     &            , A1916_HNN_WANO_ZZ
     &            , A1916_HNN_NWAO_QQ
     &            , A1916_HNN_NWAO_WW
     &            , A1916_HNN_NWAO_ZZ
      External      A1916_HNN_WAO_QQ
     &            , A1916_HNN_WAO_WW
     &            , A1916_HNN_WAO_ZZ
     &            , A1916_HNN_WANO_QQ
     &            , A1916_HNN_WANO_WW
     &            , A1916_HNN_WANO_ZZ
     &            , A1916_HNN_NWAO_QQ
     &            , A1916_HNN_NWAO_WW
     &            , A1916_HNN_NWAO_ZZ
*-----------------------------------
      if     (iana.eq.1) then
         if    ( ibkg.eq.1 ) then
            A1916_HNN_MASS_BKG = A1916_HNN_WAO_QQ(x)
         elseif( ibkg.eq.2 ) then
            A1916_HNN_MASS_BKG = A1916_HNN_WAO_WW(x)
         elseif( ibkg.eq.3 ) then
            A1916_HNN_MASS_BKG = A1916_HNN_WAO_ZZ(x)
         endif
      elseif (iana.eq.2) then
         if    ( ibkg.eq.1 ) then
            A1916_HNN_MASS_BKG = A1916_HNN_WANO_QQ(x)
         elseif( ibkg.eq.2 ) then
            A1916_HNN_MASS_BKG = A1916_HNN_WANO_WW(x)
         elseif( ibkg.eq.3 ) then
            A1916_HNN_MASS_BKG = A1916_HNN_WANO_ZZ(x)
         endif
      elseif (iana.eq.3) then
         if    ( ibkg.eq.1 ) then
            A1916_HNN_MASS_BKG = A1916_HNN_NWAO_QQ(x)
         elseif( ibkg.eq.2 ) then
            A1916_HNN_MASS_BKG = A1916_HNN_NWAO_WW(x)
         elseif( ibkg.eq.3 ) then
            A1916_HNN_MASS_BKG = A1916_HNN_NWAO_ZZ(x)
         endif
      else
c          write(*,*) 'unknown Hvv channel, stop ', iana
          stop
      endif
      end



*Efficiencies




      double precision function A1916_HNN_HZ_EFF(hmass,br,iana)
      Implicit none 
      Integer       br,iana
      Real*8        hmass

      Integer       mpnt, ipnt
      Parameter   ( mpnt = 14 )
      Real*8        masst(mpnt)
      real*8        effbband(mpnt),effbbwis(mpnt),effbbors(mpnt)
     &            , eff  (mpnt)
      data        ( masst(ipnt), effbband(ipnt), effbbwis(ipnt)
     &            , effbbors(ipnt), ipnt=1,mpnt)
     &            /  60.0, 0.0047, 0.0800, 0.0026
     &            ,  65.0, 0.0074, 0.1077, 0.0033
     &            ,  70.0, 0.0124, 0.1621, 0.0036
     &            ,  75.0, 0.0237, 0.2201, 0.0081
     &            ,  80.0, 0.0514, 0.2965, 0.0147
     &            ,  85.0, 0.1475, 0.3107, 0.0210
     &            ,  90.0, 0.3450, 0.1779, 0.0463
     &            ,  95.0, 0.4335, 0.1340, 0.0524
     &            , 100.0, 0.3148, 0.1646, 0.0412
     &            , 105.0, 0.2203, 0.2067, 0.0261
     &            , 107.0, 0.1967, 0.2250, 0.0234
     &            , 110.0, 0.1593, 0.2096, 0.0245
     &            , 115.0, 0.0991, 0.1921, 0.0202
     &            , 120.0, 0.0731, 0.1550, 0.0177 /

      Integer       i, i1, i2
      Real*8        d, d1, d2, effmh
      Save
*--------------------
      if (br.eq.1) then
         if(iana.eq.1) then
            do i = 1, mpnt
               eff(i)=effbband(i)
            enddo
         elseif(iana.eq.2) then
            do i = 1, mpnt
               eff(i)=effbbwis(i)
            enddo
         elseif(iana.eq.3) then
            do i = 1, mpnt
               eff(i)=effbbors(i)
            enddo
         else
            do i = 1, mpnt
               eff(i)=0.d0
            enddo
            
         endif
      else
         do i = 1, mpnt
            eff(i)=0.d0
         enddo
      endif
*     interpolations
*     ==============
      if    ( hmass.lt.masst(1   ) ) then
        effmh = 0.
      elseif( hmass.gt.masst(mpnt) ) then
        effmh = 0.
      else
        do i = 1, mpnt-1
           if( hmass.ge.masst(i) .and. hmass.le.masst(i+1) ) then
               i1 = i
               i2 = i + 1
           endif
        enddo
        d1 = hmass - masst(i1)
        d2 = masst(i2) - hmass
        d  = masst(i2) - masst(i1)
        effmh = ( eff(i1)*d2 + eff(i2)*d1 )/d
      endif

      A1916_HNN_HZ_EFF = effmh
      end

      double precision function A1916_HNN_WWF_EFF(hmass,br,iana)
      Implicit none 
      Integer       br,iana
      Real*8        hmass

      Integer       mpnt, ipnt
      Parameter   ( mpnt = 14 )
      Real*8        masst(mpnt)
      real*8        effbband(mpnt),effbbwis(mpnt),effbbors(mpnt)
     &            , eff  (mpnt)
      data        ( masst(ipnt), effbband(ipnt), effbbwis(ipnt)
     &            , effbbors(ipnt), ipnt=1,mpnt)
     &            /  60.0, 0.0066, 0.0783, 0.0044
     &            ,  65.0, 0.0100, 0.1071, 0.0075
     &            ,  70.0, 0.0148, 0.1433, 0.0049
     &            ,  75.0, 0.0222, 0.2135, 0.0077
     &            ,  80.0, 0.0392, 0.2806, 0.0092
     &            ,  85.0, 0.1053, 0.3055, 0.0165
     &            ,  90.0, 0.2671, 0.2097, 0.0370
     &            ,  95.0, 0.3353, 0.1707, 0.0432
     &            , 100.0, 0.2312, 0.1916, 0.0311
     &            , 105.0, 0.1554, 0.2286, 0.0213
     &            , 107.0, 0.1436, 0.2170, 0.0165
     &            , 110.0, 0.1200, 0.2217, 0.0144
     &            , 115.0, 0.0930, 0.1886, 0.0135
     &            , 120.0, 0.0695, 0.1603, 0.0083 /

      Integer       i, i1, i2
      Real*8        d, d1, d2, effmh
      Save
*--------------------
      if (br.eq.1) then
         if(iana.eq.1) then
            do i = 1, mpnt
               eff(i)=effbband(i)
            enddo
         elseif(iana.eq.2) then
            do i = 1, mpnt
               eff(i)=effbbwis(i)
            enddo
         elseif(iana.eq.3) then
            do i = 1, mpnt
               eff(i)=effbbors(i)
            enddo
         else
            do i = 1, mpnt
               eff(i)=0.d0
            enddo
            
         endif
      else
         do i = 1, mpnt
            eff(i)=0.d0
         enddo
      endif
*     interpolations
*     ==============
      if    ( hmass.lt.masst(1   ) ) then
        effmh = 0.
      elseif( hmass.gt.masst(mpnt) ) then
        effmh = 0.
      else
        do i = 1, mpnt-1
           if( hmass.ge.masst(i) .and. hmass.le.masst(i+1) ) then
               i1 = i
               i2 = i + 1
           endif
        enddo
        d1 = hmass - masst(i1)
        d2 = masst(i2) - hmass
        d  = masst(i2) - masst(i1)
        effmh = ( eff(i1)*d2 + eff(i2)*d1 )/d
      endif

      A1916_HNN_WWF_EFF = effmh
      end



      integer function A1955_HNN_NUMCAND(iana)
      implicit none
      integer iana
      INTEGER numcand(3)
      data numcand/1,2,1/
      if (iana.eq.1.0.or.iana.eq.2.0.or.iana.eq.3.0) then
         A1955_HNN_NUMCAND = numcand(iana)
      else 
         A1955_HNN_NUMCAND = 0
      endif
      end


      DOUBLE PRECISION function A1955_HNN_MASS_CAND(iana,icand)
      implicit none
      integer iana,icand
      REAL*8 andmass(1), wismass(2), orsmass(1)
      data andmass/94.9868/
      data wismass/92.0913,89.39/
      data orsmass/95.0963/
      if (iana.eq.1) then 
         A1955_HNN_MASS_CAND=andmass(icand)
      elseif (iana.eq.2) then 
         A1955_HNN_MASS_CAND=wismass(icand)
      elseif (iana.eq.3) then 
         A1955_HNN_MASS_CAND=orsmass(icand)
      else
         A1955_HNN_MASS_CAND=0.0   
      endif
      end
*1955
      DOUBLE PRECISION function A1955_HNN_BKG(iana,bkg)
      Implicit none 
      Integer       iana, bkg
      Real          andbkg(3), wisbkg(3), orsbkg(3)
      data          andbkg/0.00124873,0.000668706,0.0137768/
      data          wisbkg/0.00251354,0.005086,0.0158394/
      data          orsbkg/0.00608938,0.000325166,0.00245738/
      SAVE
*--------------------------------------------------------
      if (iana.eq.1.0) then 
         A1955_HNN_BKG=andbkg(bkg) 
      elseif (iana.eq.2.0) then 
         A1955_HNN_BKG=wisbkg(bkg)      
      elseif (iana.eq.3.0) then 
         A1955_HNN_BKG=orsbkg(bkg)
      else 
         A1955_HNN_BKG=0.0
      endif
      end


CCCCCC
CCCCCC
CCCCCC
      DOUBLE PRECISION Function A1955_HNN_MASS_SIG(x,hmass,iana)
      Implicit none
      Integer       iana
      Real*8        x, hmass

      Real*8        massl, massh
      logical first
      data first /.true./
      Data          massl, massh/ 50.0 ,104.3/

      Integer       mpnt, mana, jpnt, jana
      Parameter   ( mpnt = 14 , mana = 3)
      Real*8        masst(mpnt), corpk(mana,mpnt)
      Data         (masst(jpnt), (corpk(jana,jpnt),jana=1,mana)
     &                                            ,jpnt=1,mpnt)
     &             / 60.00, 83.10, 63.02, 79.49
     &             ,65.00, 84.60, 68.06, 81.36
     &             ,70.00, 90.13, 72.45, 86.55
     &             ,75.00, 91.30, 76.73, 88.18
     &             ,80.00, 91.69, 80.93, 87.46
     &             ,85.00, 92.67, 84.92, 92.73
     &             ,90.00, 93.69, 88.08, 93.67
     &             ,95.00, 95.46, 91.65, 95.19
     &             ,100.00, 98.55, 96.15, 97.01
     &             ,105.00, 99.44, 96.65, 96.79
     &             ,107.00, 98.57, 95.05, 97.42
     &             ,110.00, 98.32, 94.38, 96.16
     &             ,115.00, 98.30, 94.09, 96.92
     &             ,120.00, 98.28, 94.80, 96.28/

      Integer       i , i1, i2
      Real*8        c , c1, c2
     &            , d , d1, d2
     &            , f , f1, f2
     &            ,     p1, p2
     &            ,     n1, n2
     &            ,n60wao,n65wao,n70wao,n75wao,n80wao
     &            ,n85wao,n90wao,n95wao,n100wao,n105wao
     &            ,n107wao,n110wao,n115wao,n120wao
     &            ,n60wano,n65wano,n70wano,n75wano,n80wano
     &            ,n85wano,n90wano,n95wano,n100wano,n105wano
     &            ,n107wano,n110wano,n115wano,n120wano
     &            ,n60nwao,n65nwao,n70nwao,n75nwao,n80nwao
     &            ,n85nwao,n90nwao,n95nwao,n100nwao,n105nwao
     &            ,n107nwao,n110nwao,n115nwao,n120nwao
      SAVE
      Real*8        A1955_HNN_WAO_HZ_60
     &            , A1955_HNN_WAO_HZ_65
     &            , A1955_HNN_WAO_HZ_70
     &            , A1955_HNN_WAO_HZ_75
     &            , A1955_HNN_WAO_HZ_80
     &            , A1955_HNN_WAO_HZ_85
     &            , A1955_HNN_WAO_HZ_90
     &            , A1955_HNN_WAO_HZ_95
     &            , A1955_HNN_WAO_HZ_100
     &            , A1955_HNN_WAO_HZ_105
     &            , A1955_HNN_WAO_HZ_107
     &            , A1955_HNN_WAO_HZ_110
     &            , A1955_HNN_WAO_HZ_115
     &            , A1955_HNN_WAO_HZ_120
     &            , A1955_HNN_WANO_HZ_60
     &            , A1955_HNN_WANO_HZ_65
     &            , A1955_HNN_WANO_HZ_70
     &            , A1955_HNN_WANO_HZ_75
     &            , A1955_HNN_WANO_HZ_80
     &            , A1955_HNN_WANO_HZ_85
     &            , A1955_HNN_WANO_HZ_90
     &            , A1955_HNN_WANO_HZ_95
     &            , A1955_HNN_WANO_HZ_100
     &            , A1955_HNN_WANO_HZ_105
     &            , A1955_HNN_WANO_HZ_107
     &            , A1955_HNN_WANO_HZ_110
     &            , A1955_HNN_WANO_HZ_115
     &            , A1955_HNN_WANO_HZ_120
     &            , A1955_HNN_NWAO_HZ_60
     &            , A1955_HNN_NWAO_HZ_65
     &            , A1955_HNN_NWAO_HZ_70
     &            , A1955_HNN_NWAO_HZ_75
     &            , A1955_HNN_NWAO_HZ_80
     &            , A1955_HNN_NWAO_HZ_85
     &            , A1955_HNN_NWAO_HZ_90
     &            , A1955_HNN_NWAO_HZ_95
     &            , A1955_HNN_NWAO_HZ_100
     &            , A1955_HNN_NWAO_HZ_105
     &            , A1955_HNN_NWAO_HZ_107
     &            , A1955_HNN_NWAO_HZ_110
     &            , A1955_HNN_NWAO_HZ_115
     &            , A1955_HNN_NWAO_HZ_120
     &            , A1999_Hnn_normsh
      External        A1955_HNN_WAO_HZ_60
     &            , A1955_HNN_WAO_HZ_65
     &            , A1955_HNN_WAO_HZ_70
     &            , A1955_HNN_WAO_HZ_75
     &            , A1955_HNN_WAO_HZ_80
     &            , A1955_HNN_WAO_HZ_85
     &            , A1955_HNN_WAO_HZ_90
     &            , A1955_HNN_WAO_HZ_95
     &            , A1955_HNN_WAO_HZ_100
     &            , A1955_HNN_WAO_HZ_105
     &            , A1955_HNN_WAO_HZ_107
     &            , A1955_HNN_WAO_HZ_110
     &            , A1955_HNN_WAO_HZ_115
     &            , A1955_HNN_WAO_HZ_120
     &            , A1955_HNN_WANO_HZ_60
     &            , A1955_HNN_WANO_HZ_65
     &            , A1955_HNN_WANO_HZ_70
     &            , A1955_HNN_WANO_HZ_75
     &            , A1955_HNN_WANO_HZ_80
     &            , A1955_HNN_WANO_HZ_85
     &            , A1955_HNN_WANO_HZ_90
     &            , A1955_HNN_WANO_HZ_95
     &            , A1955_HNN_WANO_HZ_100
     &            , A1955_HNN_WANO_HZ_105
     &            , A1955_HNN_WANO_HZ_107
     &            , A1955_HNN_WANO_HZ_110
     &            , A1955_HNN_WANO_HZ_115
     &            , A1955_HNN_WANO_HZ_120
     &            , A1955_HNN_NWAO_HZ_60
     &            , A1955_HNN_NWAO_HZ_65
     &            , A1955_HNN_NWAO_HZ_70
     &            , A1955_HNN_NWAO_HZ_75
     &            , A1955_HNN_NWAO_HZ_80
     &            , A1955_HNN_NWAO_HZ_85
     &            , A1955_HNN_NWAO_HZ_90
     &            , A1955_HNN_NWAO_HZ_95
     &            , A1955_HNN_NWAO_HZ_100
     &            , A1955_HNN_NWAO_HZ_105
     &            , A1955_HNN_NWAO_HZ_107
     &            , A1955_HNN_NWAO_HZ_110
     &            , A1955_HNN_NWAO_HZ_115
     &            , A1955_HNN_NWAO_HZ_120
     &            , A1999_Hnn_normsh
      if (first) then
         n60wao=A1999_Hnn_normsh(A1955_HNN_WAO_HZ_60,
     &             massl,massh,500)
         n65wao=A1999_Hnn_normsh(A1955_HNN_WAO_HZ_65,
     &             massl,massh,500)
         n70wao=A1999_Hnn_normsh(A1955_HNN_WAO_HZ_70,
     &             massl,massh,500)
         n75wao=A1999_Hnn_normsh(A1955_HNN_WAO_HZ_75,
     &             massl,massh,500)
         n80wao=A1999_Hnn_normsh(A1955_HNN_WAO_HZ_80,
     &             massl,massh,500)
         n85wao=A1999_Hnn_normsh(A1955_HNN_WAO_HZ_85,
     &             massl,massh,500)
         n90wao=A1999_Hnn_normsh(A1955_HNN_WAO_HZ_90,
     &             massl,massh,500)
         n95wao=A1999_Hnn_normsh(A1955_HNN_WAO_HZ_95,
     &             massl,massh,500)
         n100wao=A1999_Hnn_normsh(A1955_HNN_WAO_HZ_100,
     &             massl,massh,500)
         n105wao=A1999_Hnn_normsh(A1955_HNN_WAO_HZ_105,
     &             massl,massh,500)
         n107wao=A1999_Hnn_normsh(A1955_HNN_WAO_HZ_107,
     &             massl,massh,500)
         n110wao=A1999_Hnn_normsh(A1955_HNN_WAO_HZ_110,
     &             massl,massh,500)
         n115wao=A1999_Hnn_normsh(A1955_HNN_WAO_HZ_115,
     &             massl,massh,500)
         n120wao=A1999_Hnn_normsh(A1955_HNN_WAO_HZ_120,
     &             massl,massh,500)
         n60wano=A1999_Hnn_normsh(A1955_HNN_WANO_HZ_60,
     &             massl,massh,500)
         n65wano=A1999_Hnn_normsh(A1955_HNN_WANO_HZ_65,
     &             massl,massh,500)
         n70wano=A1999_Hnn_normsh(A1955_HNN_WANO_HZ_70,
     &             massl,massh,500)
         n75wano=A1999_Hnn_normsh(A1955_HNN_WANO_HZ_75,
     &             massl,massh,500)
         n80wano=A1999_Hnn_normsh(A1955_HNN_WANO_HZ_80,
     &             massl,massh,500)
         n85wano=A1999_Hnn_normsh(A1955_HNN_WANO_HZ_85,
     &             massl,massh,500)
         n90wano=A1999_Hnn_normsh(A1955_HNN_WANO_HZ_90,
     &             massl,massh,500)
         n95wano=A1999_Hnn_normsh(A1955_HNN_WANO_HZ_95,
     &             massl,massh,500)
         n100wano=A1999_Hnn_normsh(A1955_HNN_WANO_HZ_100,
     &             massl,massh,500)
         n105wano=A1999_Hnn_normsh(A1955_HNN_WANO_HZ_105,
     &             massl,massh,500)
         n107wano=A1999_Hnn_normsh(A1955_HNN_WANO_HZ_107,
     &             massl,massh,500)
         n110wano=A1999_Hnn_normsh(A1955_HNN_WANO_HZ_110,
     &             massl,massh,500)
         n115wano=A1999_Hnn_normsh(A1955_HNN_WANO_HZ_115,
     &             massl,massh,500)
         n120wano=A1999_Hnn_normsh(A1955_HNN_WANO_HZ_120,
     &             massl,massh,500)
         n60nwao=A1999_Hnn_normsh(A1955_HNN_NWAO_HZ_60,
     &             massl,massh,500)
         n65nwao=A1999_Hnn_normsh(A1955_HNN_NWAO_HZ_65,
     &             massl,massh,500)
         n70nwao=A1999_Hnn_normsh(A1955_HNN_NWAO_HZ_70,
     &             massl,massh,500)
         n75nwao=A1999_Hnn_normsh(A1955_HNN_NWAO_HZ_75,
     &             massl,massh,500)
         n80nwao=A1999_Hnn_normsh(A1955_HNN_NWAO_HZ_80,
     &             massl,massh,500)
         n85nwao=A1999_Hnn_normsh(A1955_HNN_NWAO_HZ_85,
     &             massl,massh,500)
         n90nwao=A1999_Hnn_normsh(A1955_HNN_NWAO_HZ_90,
     &             massl,massh,500)
         n95nwao=A1999_Hnn_normsh(A1955_HNN_NWAO_HZ_95,
     &             massl,massh,500)
         n100nwao=A1999_Hnn_normsh(A1955_HNN_NWAO_HZ_100,
     &             massl,massh,500)
         n105nwao=A1999_Hnn_normsh(A1955_HNN_NWAO_HZ_105,
     &             massl,massh,500)
         n107nwao=A1999_Hnn_normsh(A1955_HNN_NWAO_HZ_107,
     &             massl,massh,500)
         n110nwao=A1999_Hnn_normsh(A1955_HNN_NWAO_HZ_110,
     &             massl,massh,500)
         n115nwao=A1999_Hnn_normsh(A1955_HNN_NWAO_HZ_115,
     &             massl,massh,500)
         n120nwao=A1999_Hnn_normsh(A1955_HNN_NWAO_HZ_120,
     &             massl,massh,500)
         first = .false.
      endif




*------------------------------------
* find position
* =============
      if    ( hmass.lt.masst(1   ) ) then
          i1 = 1
          i2 = 1
          d1 = 0.0
          d2 = 1.0
      elseif( hmass.ge.masst(mpnt) ) then
          i1 = mpnt
          i2 = mpnt
          d1 = 1.0
          d2 = 0.0
      else
          do i = 1, mpnt-1
          if( hmass.ge.masst(i) .and. hmass.lt.masst(i+1) ) then
          i1 = i
          i2 = i + 1
          endif
          enddo
          d  = masst(i2) - masst(i1)
          d1 = (hmass - masst(i1))/d
          d2 = (masst(i2) - hmass)/d
      endif
      c1 = corpk(iana,i1)
      c2 = corpk(iana,i2)
      c  = c1*d2 + c2*d1

* very painful procedure to get function values
* =============================================
      if(hmass.le.75.0) then
         if (x.ge.c) then
            p1 = x - c + corpk(iana,i1)
            p2 = x - c + corpk(iana,i2)
         else
            p1 = corpk(iana,i1)-(c-x)/(c-massl)*(corpk(iana,i1)-massl)
            p2 = corpk(iana,i2)-(c-x)/(c-massl)*(corpk(iana,i2)-massl)
         endif
      elseif(hmass.ge.massh) then
         if (x.le.c) then
            p1 = x - c + corpk(iana,i1)
            p2 = x - c + corpk(iana,i2)
         else
            p1 = corpk(iana,i1)+(x-c)/(massh-c)*(massh-corpk(iana,i1))
            p2 = corpk(iana,i2)+(x-c)/(massh-c)*(massh-corpk(iana,i2))
         endif
      else
         p1 = x - c + corpk(iana,i1)
         p2 = x - c + corpk(iana,i2)
      endif

      if( iana.eq.1 ) then
          if( i1.eq.1 ) then
              f1 = A1955_HNN_WAO_HZ_60(p1)
              n1 = n60wao
          elseif( i1.eq.2 ) then
              f1 = A1955_HNN_WAO_HZ_65(p1)
              n1 = n65wao
          elseif( i1.eq.3 ) then
              f1 = A1955_HNN_WAO_HZ_70(p1)
              n1 = n70wao
          elseif( i1.eq.4 ) then
              f1 = A1955_HNN_WAO_HZ_75(p1)
              n1 = n75wao
          elseif( i1.eq.5 ) then
              f1 = A1955_HNN_WAO_HZ_80(p1)
              n1 = n80wao
          elseif( i1.eq.6 ) then
              f1 = A1955_HNN_WAO_HZ_85(p1)
              n1 = n85wao
          elseif( i1.eq.7 ) then
              f1 = A1955_HNN_WAO_HZ_90(p1)
              n1 = n90wao
          elseif( i1.eq.8 ) then
              f1 = A1955_HNN_WAO_HZ_95(p1)
              n1 = n95wao
          elseif( i1.eq.9 ) then
              f1 = A1955_HNN_WAO_HZ_100(p1)
              n1 = n100wao
          elseif( i1.eq.10 ) then
              f1 = A1955_HNN_WAO_HZ_105(p1)
              n1 = n105wao
          elseif( i1.eq.11 ) then
              f1 = A1955_HNN_WAO_HZ_107(p1)
              n1 = n107wao
          elseif( i1.eq.12 ) then
              f1 = A1955_HNN_WAO_HZ_110(p1)
              n1 = n110wao
          elseif( i1.eq.13 ) then
              f1 = A1955_HNN_WAO_HZ_115(p1)
              n1 = n115wao
          elseif( i1.eq.14 ) then
              f1 = A1955_HNN_WAO_HZ_120(p1)
              n1 = n120wao
          endif
          if( i2.eq.1 ) then
              f2 = A1955_HNN_WAO_HZ_60(p2)
              n2 = n60wao
          elseif( i2.eq.2 ) then
              f2 = A1955_HNN_WAO_HZ_65(p2)
              n2 = n65wao
          elseif( i2.eq.3 ) then
              f2 = A1955_HNN_WAO_HZ_70(p2)
              n2 = n70wao
          elseif( i2.eq.4 ) then
              f2 = A1955_HNN_WAO_HZ_75(p2)
              n2 = n75wao
          elseif( i2.eq.5 ) then
              f2 = A1955_HNN_WAO_HZ_80(p2)
              n2 = n80wao
          elseif( i2.eq.6 ) then
              f2 = A1955_HNN_WAO_HZ_85(p2)
              n2 = n85wao
          elseif( i2.eq.7 ) then
              f2 = A1955_HNN_WAO_HZ_90(p2)
              n2 = n90wao
          elseif( i2.eq.8 ) then
              f2 = A1955_HNN_WAO_HZ_95(p2)
              n2 = n95wao
          elseif( i2.eq.9 ) then
              f2 = A1955_HNN_WAO_HZ_100(p2)
              n2 = n100wao
          elseif( i2.eq.10 ) then
              f2 = A1955_HNN_WAO_HZ_105(p2)
              n2 = n105wao
          elseif( i2.eq.11 ) then
              f2 = A1955_HNN_WAO_HZ_107(p2)
              n2 = n107wao
          elseif( i2.eq.12 ) then
              f2 = A1955_HNN_WAO_HZ_110(p2)
              n2 = n110wao
          elseif( i2.eq.13 ) then
              f2 = A1955_HNN_WAO_HZ_115(p2)
              n2 = n115wao
          elseif( i2.eq.14 ) then
              f2 = A1955_HNN_WAO_HZ_120(p2)
              n2 = n120wao
          endif

      elseif( iana.eq.2 ) then
          if( i1.eq.1 ) then
              f1 = A1955_HNN_WANO_HZ_60(p1)
              n1 = n60wano
          elseif( i1.eq.2 ) then
              f1 = A1955_HNN_WANO_HZ_65(p1)
              n1 = n65wano
          elseif( i1.eq.3 ) then
              f1 = A1955_HNN_WANO_HZ_70(p1)
              n1 = n70wano
          elseif( i1.eq.4 ) then
              f1 = A1955_HNN_WANO_HZ_75(p1)
              n1 = n75wano
          elseif( i1.eq.5 ) then
              f1 = A1955_HNN_WANO_HZ_80(p1)
              n1 = n80wano
          elseif( i1.eq.6 ) then
              f1 = A1955_HNN_WANO_HZ_85(p1)
              n1 = n85wano
          elseif( i1.eq.7 ) then
              f1 = A1955_HNN_WANO_HZ_90(p1)
              n1 = n90wano
          elseif( i1.eq.8 ) then
              f1 = A1955_HNN_WANO_HZ_95(p1)
              n1 = n95wano
          elseif( i1.eq.9 ) then
              f1 = A1955_HNN_WANO_HZ_100(p1)
              n1 = n100wano
          elseif( i1.eq.10 ) then
              f1 = A1955_HNN_WANO_HZ_105(p1)
              n1 = n105wano
          elseif( i1.eq.11 ) then
              f1 = A1955_HNN_WANO_HZ_107(p1)
              n1 = n107wano
          elseif( i1.eq.12 ) then
              f1 = A1955_HNN_WANO_HZ_110(p1)
              n1 = n110wano
          elseif( i1.eq.13 ) then
              f1 = A1955_HNN_WANO_HZ_115(p1)
              n1 = n115wano
          elseif( i1.eq.14 ) then
              f1 = A1955_HNN_WANO_HZ_120(p1)
              n1 = n120wano
          endif
          if( i2.eq.1 ) then
              f2 = A1955_HNN_WANO_HZ_60(p2)
              n2 = n60wano
          elseif( i2.eq.2 ) then
              f2 = A1955_HNN_WANO_HZ_65(p2)
              n2 = n65wano
          elseif( i2.eq.3 ) then
              f2 = A1955_HNN_WANO_HZ_70(p2)
              n2 = n70wano
          elseif( i2.eq.4 ) then
              f2 = A1955_HNN_WANO_HZ_75(p2)
              n2 = n75wano
          elseif( i2.eq.5 ) then
              f2 = A1955_HNN_WANO_HZ_80(p2)
              n2 = n80wano
          elseif( i2.eq.6 ) then
              f2 = A1955_HNN_WANO_HZ_85(p2)
              n2 = n85wano
          elseif( i2.eq.7 ) then
              f2 = A1955_HNN_WANO_HZ_90(p2)
              n2 = n90wano
          elseif( i2.eq.8 ) then
              f2 = A1955_HNN_WANO_HZ_95(p2)
              n2 = n95wano
          elseif( i2.eq.9 ) then
              f2 = A1955_HNN_WANO_HZ_100(p2)
              n2 = n100wano
          elseif( i2.eq.10 ) then
              f2 = A1955_HNN_WANO_HZ_105(p2)
              n2 = n105wano
          elseif( i2.eq.11 ) then
              f2 = A1955_HNN_WANO_HZ_107(p2)
              n2 = n107wano
          elseif( i2.eq.12 ) then
              f2 = A1955_HNN_WANO_HZ_110(p2)
              n2 = n110wano
          elseif( i2.eq.13 ) then
              f2 = A1955_HNN_WANO_HZ_115(p2)
              n2 = n115wano
          elseif( i2.eq.14 ) then
              f2 = A1955_HNN_WANO_HZ_120(p2)
              n2 = n120wano
          endif

      elseif( iana.eq.3 ) then
          if( i1.eq.1 ) then
              f1 = A1955_HNN_NWAO_HZ_60(p1)
              n1 = n60nwao
          elseif( i1.eq.2 ) then
              f1 = A1955_HNN_NWAO_HZ_65(p1)
              n1 = n65nwao
          elseif( i1.eq.3 ) then
              f1 = A1955_HNN_NWAO_HZ_70(p1)
              n1 = n70nwao
          elseif( i1.eq.4 ) then
              f1 = A1955_HNN_NWAO_HZ_75(p1)
              n1 = n75nwao
          elseif( i1.eq.5 ) then
              f1 = A1955_HNN_NWAO_HZ_80(p1)
              n1 = n80nwao
          elseif( i1.eq.6 ) then
              f1 = A1955_HNN_NWAO_HZ_85(p1)
              n1 = n85nwao
          elseif( i1.eq.7 ) then
              f1 = A1955_HNN_NWAO_HZ_90(p1)
              n1 = n90nwao
          elseif( i1.eq.8 ) then
              f1 = A1955_HNN_NWAO_HZ_95(p1)
              n1 = n95nwao
          elseif( i1.eq.9 ) then
              f1 = A1955_HNN_NWAO_HZ_100(p1)
              n1 = n100nwao
          elseif( i1.eq.10 ) then
              f1 = A1955_HNN_NWAO_HZ_105(p1)
              n1 = n105nwao
          elseif( i1.eq.11 ) then
              f1 = A1955_HNN_NWAO_HZ_107(p1)
              n1 = n107nwao
          elseif( i1.eq.12 ) then
              f1 = A1955_HNN_NWAO_HZ_110(p1)
              n1 = n110nwao
          elseif( i1.eq.13 ) then
              f1 = A1955_HNN_NWAO_HZ_115(p1)
              n1 = n115nwao
          elseif( i1.eq.14 ) then
              f1 = A1955_HNN_NWAO_HZ_120(p1)
              n1 = n120nwao
          endif
          if( i2.eq.1 ) then
              f2 = A1955_HNN_NWAO_HZ_60(p2)
              n2 = n60nwao
          elseif( i2.eq.2 ) then
              f2 = A1955_HNN_NWAO_HZ_65(p2)
              n2 = n65nwao
          elseif( i2.eq.3 ) then
              f2 = A1955_HNN_NWAO_HZ_70(p2)
              n2 = n70nwao
          elseif( i2.eq.4 ) then
              f2 = A1955_HNN_NWAO_HZ_75(p2)
              n2 = n75nwao
          elseif( i2.eq.5 ) then
              f2 = A1955_HNN_NWAO_HZ_80(p2)
              n2 = n80nwao
          elseif( i2.eq.6 ) then
              f2 = A1955_HNN_NWAO_HZ_85(p2)
              n2 = n85nwao
          elseif( i2.eq.7 ) then
              f2 = A1955_HNN_NWAO_HZ_90(p2)
              n2 = n90nwao
          elseif( i2.eq.8 ) then
              f2 = A1955_HNN_NWAO_HZ_95(p2)
              n2 = n95nwao
          elseif( i2.eq.9 ) then
              f2 = A1955_HNN_NWAO_HZ_100(p2)
              n2 = n100nwao
          elseif( i2.eq.10 ) then
              f2 = A1955_HNN_NWAO_HZ_105(p2)
              n2 = n105nwao
          elseif( i2.eq.11 ) then
              f2 = A1955_HNN_NWAO_HZ_107(p2)
              n2 = n107nwao
          elseif( i2.eq.12 ) then
              f2 = A1955_HNN_NWAO_HZ_110(p2)
              n2 = n110nwao
          elseif( i2.eq.13 ) then
              f2 = A1955_HNN_NWAO_HZ_115(p2)
              n2 = n115nwao
          elseif( i2.eq.14 ) then
              f2 = A1955_HNN_NWAO_HZ_120(p2)
              n2 = n120nwao
          endif
       endif
      f = f1*d2/n1 + f2*d1/n2
      if( f.lt.1.0D-06 ) f = 1.0d-06
      if    ( x.lt.massl .or. x.gt.massh ) then
         f = 0.0d0
      endif

      A1955_HNN_MASS_SIG = f
      end


      DOUBLE PRECISION Function A1955_hnn_fus_mass_sig(x,hmass,iana)
      Implicit none
      Integer       iana
      Real*8        x, hmass

      Real*8        massl, massh
      logical first
      data first /.true./
      Data          massl, massh/ 50.0 ,104.3/

      Integer       mpnt, mana, jpnt, jana
      Parameter   ( mpnt = 14 , mana = 3)
      Real*8        masst(mpnt), corpk(mana,mpnt)
      Data         (masst(jpnt), (corpk(jana,jpnt),jana=1,mana)
     &                                            ,jpnt=1,mpnt)
     &             / 60.00, 85.01, 64.09, 71.27
     &             ,65.00, 85.23, 66.99, 83.49
     &             ,70.00, 88.44, 71.41, 87.36
     &             ,75.00, 91.60, 75.48, 87.75
     &             ,80.00, 93.35, 79.25, 88.82
     &             ,85.00, 92.96, 82.89, 92.74
     &             ,90.00, 93.74, 85.23, 93.15
     &             ,95.00, 95.40, 88.10, 95.11
     &             ,100.00, 98.04, 90.04, 96.79
     &             ,105.00, 98.15, 88.16, 96.48
     &             ,107.00, 97.67, 88.44, 96.73
     &             ,110.00, 97.39, 89.33, 96.54
     &             ,115.00, 97.66, 90.23, 96.68
     &             ,120.00, 97.77, 91.02, 97.00/

      Integer       i , i1, i2
      Real*8        c , c1, c2
     &            , d , d1, d2
     &            , f , f1, f2
     &            ,     p1, p2
     &            ,     n1, n2
     &            ,n60wao,n65wao,n70wao,n75wao,n80wao
     &            ,n85wao,n90wao,n95wao,n100wao,n105wao
     &            ,n107wao,n110wao,n115wao,n120wao
     &            ,n60wano,n65wano,n70wano,n75wano,n80wano
     &            ,n85wano,n90wano,n95wano,n100wano,n105wano
     &            ,n107wano,n110wano,n115wano,n120wano
     &            ,n60nwao,n65nwao,n70nwao,n75nwao,n80nwao
     &            ,n85nwao,n90nwao,n95nwao,n100nwao,n105nwao
     &            ,n107nwao,n110nwao,n115nwao,n120nwao
      SAVE
      Real*8        A1955_HNN_WAO_FUS_60
     &            , A1955_HNN_WAO_FUS_65
     &            , A1955_HNN_WAO_FUS_70
     &            , A1955_HNN_WAO_FUS_75
     &            , A1955_HNN_WAO_FUS_80
     &            , A1955_HNN_WAO_FUS_85
     &            , A1955_HNN_WAO_FUS_90
     &            , A1955_HNN_WAO_FUS_95
     &            , A1955_HNN_WAO_FUS_100
     &            , A1955_HNN_WAO_FUS_105
     &            , A1955_HNN_WAO_FUS_107
     &            , A1955_HNN_WAO_FUS_110
     &            , A1955_HNN_WAO_FUS_115
     &            , A1955_HNN_WAO_FUS_120
     &            , A1955_HNN_WANO_FUS_60
     &            , A1955_HNN_WANO_FUS_65
     &            , A1955_HNN_WANO_FUS_70
     &            , A1955_HNN_WANO_FUS_75
     &            , A1955_HNN_WANO_FUS_80
     &            , A1955_HNN_WANO_FUS_85
     &            , A1955_HNN_WANO_FUS_90
     &            , A1955_HNN_WANO_FUS_95
     &            , A1955_HNN_WANO_FUS_100
     &            , A1955_HNN_WANO_FUS_105
     &            , A1955_HNN_WANO_FUS_107
     &            , A1955_HNN_WANO_FUS_110
     &            , A1955_HNN_WANO_FUS_115
     &            , A1955_HNN_WANO_FUS_120
     &            , A1955_HNN_NWAO_FUS_60
     &            , A1955_HNN_NWAO_FUS_65
     &            , A1955_HNN_NWAO_FUS_70
     &            , A1955_HNN_NWAO_FUS_75
     &            , A1955_HNN_NWAO_FUS_80
     &            , A1955_HNN_NWAO_FUS_85
     &            , A1955_HNN_NWAO_FUS_90
     &            , A1955_HNN_NWAO_FUS_95
     &            , A1955_HNN_NWAO_FUS_100
     &            , A1955_HNN_NWAO_FUS_105
     &            , A1955_HNN_NWAO_FUS_107
     &            , A1955_HNN_NWAO_FUS_110
     &            , A1955_HNN_NWAO_FUS_115
     &            , A1955_HNN_NWAO_FUS_120
     &            , A1999_Hnn_normsh
      External        A1955_HNN_WAO_FUS_60
     &            , A1955_HNN_WAO_FUS_65
     &            , A1955_HNN_WAO_FUS_70
     &            , A1955_HNN_WAO_FUS_75
     &            , A1955_HNN_WAO_FUS_80
     &            , A1955_HNN_WAO_FUS_85
     &            , A1955_HNN_WAO_FUS_90
     &            , A1955_HNN_WAO_FUS_95
     &            , A1955_HNN_WAO_FUS_100
     &            , A1955_HNN_WAO_FUS_105
     &            , A1955_HNN_WAO_FUS_107
     &            , A1955_HNN_WAO_FUS_110
     &            , A1955_HNN_WAO_FUS_115
     &            , A1955_HNN_WAO_FUS_120
     &            , A1955_HNN_WANO_FUS_60
     &            , A1955_HNN_WANO_FUS_65
     &            , A1955_HNN_WANO_FUS_70
     &            , A1955_HNN_WANO_FUS_75
     &            , A1955_HNN_WANO_FUS_80
     &            , A1955_HNN_WANO_FUS_85
     &            , A1955_HNN_WANO_FUS_90
     &            , A1955_HNN_WANO_FUS_95
     &            , A1955_HNN_WANO_FUS_100
     &            , A1955_HNN_WANO_FUS_105
     &            , A1955_HNN_WANO_FUS_107
     &            , A1955_HNN_WANO_FUS_110
     &            , A1955_HNN_WANO_FUS_115
     &            , A1955_HNN_WANO_FUS_120
     &            , A1955_HNN_NWAO_FUS_60
     &            , A1955_HNN_NWAO_FUS_65
     &            , A1955_HNN_NWAO_FUS_70
     &            , A1955_HNN_NWAO_FUS_75
     &            , A1955_HNN_NWAO_FUS_80
     &            , A1955_HNN_NWAO_FUS_85
     &            , A1955_HNN_NWAO_FUS_90
     &            , A1955_HNN_NWAO_FUS_95
     &            , A1955_HNN_NWAO_FUS_100
     &            , A1955_HNN_NWAO_FUS_105
     &            , A1955_HNN_NWAO_FUS_107
     &            , A1955_HNN_NWAO_FUS_110
     &            , A1955_HNN_NWAO_FUS_115
     &            , A1955_HNN_NWAO_FUS_120
     &            , A1999_Hnn_normsh
      if (first) then
         n60wao=A1999_Hnn_normsh(A1955_HNN_WAO_FUS_60,
     &             massl,massh,500)
         n65wao=A1999_Hnn_normsh(A1955_HNN_WAO_FUS_65,
     &             massl,massh,500)
         n70wao=A1999_Hnn_normsh(A1955_HNN_WAO_FUS_70,
     &             massl,massh,500)
         n75wao=A1999_Hnn_normsh(A1955_HNN_WAO_FUS_75,
     &             massl,massh,500)
         n80wao=A1999_Hnn_normsh(A1955_HNN_WAO_FUS_80,
     &             massl,massh,500)
         n85wao=A1999_Hnn_normsh(A1955_HNN_WAO_FUS_85,
     &             massl,massh,500)
         n90wao=A1999_Hnn_normsh(A1955_HNN_WAO_FUS_90,
     &             massl,massh,500)
         n95wao=A1999_Hnn_normsh(A1955_HNN_WAO_FUS_95,
     &             massl,massh,500)
         n100wao=A1999_Hnn_normsh(A1955_HNN_WAO_FUS_100,
     &             massl,massh,500)
         n105wao=A1999_Hnn_normsh(A1955_HNN_WAO_FUS_105,
     &             massl,massh,500)
         n107wao=A1999_Hnn_normsh(A1955_HNN_WAO_FUS_107,
     &             massl,massh,500)
         n110wao=A1999_Hnn_normsh(A1955_HNN_WAO_FUS_110,
     &             massl,massh,500)
         n115wao=A1999_Hnn_normsh(A1955_HNN_WAO_FUS_115,
     &             massl,massh,500)
         n120wao=A1999_Hnn_normsh(A1955_HNN_WAO_FUS_120,
     &             massl,massh,500)
         n60wano=A1999_Hnn_normsh(A1955_HNN_WANO_FUS_60,
     &             massl,massh,500)
         n65wano=A1999_Hnn_normsh(A1955_HNN_WANO_FUS_65,
     &             massl,massh,500)
         n70wano=A1999_Hnn_normsh(A1955_HNN_WANO_FUS_70,
     &             massl,massh,500)
         n75wano=A1999_Hnn_normsh(A1955_HNN_WANO_FUS_75,
     &             massl,massh,500)
         n80wano=A1999_Hnn_normsh(A1955_HNN_WANO_FUS_80,
     &             massl,massh,500)
         n85wano=A1999_Hnn_normsh(A1955_HNN_WANO_FUS_85,
     &             massl,massh,500)
         n90wano=A1999_Hnn_normsh(A1955_HNN_WANO_FUS_90,
     &             massl,massh,500)
         n95wano=A1999_Hnn_normsh(A1955_HNN_WANO_FUS_95,
     &             massl,massh,500)
         n100wano=A1999_Hnn_normsh(A1955_HNN_WANO_FUS_100,
     &             massl,massh,500)
         n105wano=A1999_Hnn_normsh(A1955_HNN_WANO_FUS_105,
     &             massl,massh,500)
         n107wano=A1999_Hnn_normsh(A1955_HNN_WANO_FUS_107,
     &             massl,massh,500)
         n110wano=A1999_Hnn_normsh(A1955_HNN_WANO_FUS_110,
     &             massl,massh,500)
         n115wano=A1999_Hnn_normsh(A1955_HNN_WANO_FUS_115,
     &             massl,massh,500)
         n120wano=A1999_Hnn_normsh(A1955_HNN_WANO_FUS_120,
     &             massl,massh,500)
         n60nwao=A1999_Hnn_normsh(A1955_HNN_NWAO_FUS_60,
     &             massl,massh,500)
         n65nwao=A1999_Hnn_normsh(A1955_HNN_NWAO_FUS_65,
     &             massl,massh,500)
         n70nwao=A1999_Hnn_normsh(A1955_HNN_NWAO_FUS_70,
     &             massl,massh,500)
         n75nwao=A1999_Hnn_normsh(A1955_HNN_NWAO_FUS_75,
     &             massl,massh,500)
         n80nwao=A1999_Hnn_normsh(A1955_HNN_NWAO_FUS_80,
     &             massl,massh,500)
         n85nwao=A1999_Hnn_normsh(A1955_HNN_NWAO_FUS_85,
     &             massl,massh,500)
         n90nwao=A1999_Hnn_normsh(A1955_HNN_NWAO_FUS_90,
     &             massl,massh,500)
         n95nwao=A1999_Hnn_normsh(A1955_HNN_NWAO_FUS_95,
     &             massl,massh,500)
         n100nwao=A1999_Hnn_normsh(A1955_HNN_NWAO_FUS_100,
     &             massl,massh,500)
         n105nwao=A1999_Hnn_normsh(A1955_HNN_NWAO_FUS_105,
     &             massl,massh,500)
         n107nwao=A1999_Hnn_normsh(A1955_HNN_NWAO_FUS_107,
     &             massl,massh,500)
         n110nwao=A1999_Hnn_normsh(A1955_HNN_NWAO_FUS_110,
     &             massl,massh,500)
         n115nwao=A1999_Hnn_normsh(A1955_HNN_NWAO_FUS_115,
     &             massl,massh,500)
         n120nwao=A1999_Hnn_normsh(A1955_HNN_NWAO_FUS_120,
     &             massl,massh,500)
         first = .false.
      endif

*------------------------------------
* find position
* =============
      if    ( hmass.lt.masst(1   ) ) then
          i1 = 1
          i2 = 1
          d1 = 0.0
          d2 = 1.0
      elseif( hmass.ge.masst(mpnt) ) then
          i1 = mpnt
          i2 = mpnt
          d1 = 1.0
          d2 = 0.0
      else
          do i = 1, mpnt-1
          if( hmass.ge.masst(i) .and. hmass.lt.masst(i+1) ) then
          i1 = i
          i2 = i + 1
          endif
          enddo
          d  = masst(i2) - masst(i1)
          d1 = (hmass - masst(i1))/d
          d2 = (masst(i2) - hmass)/d
      endif
      c1 = corpk(iana,i1)
      c2 = corpk(iana,i2)
      c  = c1*d2 + c2*d1

* very painful procedure to get function values
* =============================================
      if(hmass.le.75.0) then
         if (x.ge.c) then
            p1 = x - c + corpk(iana,i1)
            p2 = x - c + corpk(iana,i2)
         else
            p1 = corpk(iana,i1)-(c-x)/(c-massl)*(corpk(iana,i1)-massl)
            p2 = corpk(iana,i2)-(c-x)/(c-massl)*(corpk(iana,i2)-massl)
         endif
      elseif(hmass.ge.massh) then
         if (x.le.c) then
            p1 = x - c + corpk(iana,i1)
            p2 = x - c + corpk(iana,i2)
         else
            p1 = corpk(iana,i1)+(x-c)/(massh-c)*(massh-corpk(iana,i1))
            p2 = corpk(iana,i2)+(x-c)/(massh-c)*(massh-corpk(iana,i2))
         endif
      else
         p1 = x - c + corpk(iana,i1)
         p2 = x - c + corpk(iana,i2)
      endif

      if( iana.eq.1 ) then
          if( i1.eq.1 ) then
              f1 = A1955_HNN_WAO_FUS_60(p1)
              n1 = n60wao
          elseif( i1.eq.2 ) then
              f1 = A1955_HNN_WAO_FUS_65(p1)
              n1 = n65wao
          elseif( i1.eq.3 ) then
              f1 = A1955_HNN_WAO_FUS_70(p1)
              n1 = n70wao
          elseif( i1.eq.4 ) then
              f1 = A1955_HNN_WAO_FUS_75(p1)
              n1 = n75wao
          elseif( i1.eq.5 ) then
              f1 = A1955_HNN_WAO_FUS_80(p1)
              n1 = n80wao
          elseif( i1.eq.6 ) then
              f1 = A1955_HNN_WAO_FUS_85(p1)
              n1 = n85wao
          elseif( i1.eq.7 ) then
              f1 = A1955_HNN_WAO_FUS_90(p1)
              n1 = n90wao
          elseif( i1.eq.8 ) then
              f1 = A1955_HNN_WAO_FUS_95(p1)
              n1 = n95wao
          elseif( i1.eq.9 ) then
              f1 = A1955_HNN_WAO_FUS_100(p1)
              n1 = n100wao
          elseif( i1.eq.10 ) then
              f1 = A1955_HNN_WAO_FUS_105(p1)
              n1 = n105wao
          elseif( i1.eq.11 ) then
              f1 = A1955_HNN_WAO_FUS_107(p1)
              n1 = n107wao
          elseif( i1.eq.12 ) then
              f1 = A1955_HNN_WAO_FUS_110(p1)
              n1 = n110wao
          elseif( i1.eq.13 ) then
              f1 = A1955_HNN_WAO_FUS_115(p1)
              n1 = n115wao
          elseif( i1.eq.14 ) then
              f1 = A1955_HNN_WAO_FUS_120(p1)
              n1 = n120wao
          endif
          if( i2.eq.1 ) then
              f2 = A1955_HNN_WAO_FUS_60(p2)
              n2 = n60wao
          elseif( i2.eq.2 ) then
              f2 = A1955_HNN_WAO_FUS_65(p2)
              n2 = n65wao
          elseif( i2.eq.3 ) then
              f2 = A1955_HNN_WAO_FUS_70(p2)
              n2 = n70wao
          elseif( i2.eq.4 ) then
              f2 = A1955_HNN_WAO_FUS_75(p2)
              n2 = n75wao
          elseif( i2.eq.5 ) then
              f2 = A1955_HNN_WAO_FUS_80(p2)
              n2 = n80wao
          elseif( i2.eq.6 ) then
              f2 = A1955_HNN_WAO_FUS_85(p2)
              n2 = n85wao
          elseif( i2.eq.7 ) then
              f2 = A1955_HNN_WAO_FUS_90(p2)
              n2 = n90wao
          elseif( i2.eq.8 ) then
              f2 = A1955_HNN_WAO_FUS_95(p2)
              n2 = n95wao
          elseif( i2.eq.9 ) then
              f2 = A1955_HNN_WAO_FUS_100(p2)
              n2 = n100wao
          elseif( i2.eq.10 ) then
              f2 = A1955_HNN_WAO_FUS_105(p2)
              n2 = n105wao
          elseif( i2.eq.11 ) then
              f2 = A1955_HNN_WAO_FUS_107(p2)
              n2 = n107wao
          elseif( i2.eq.12 ) then
              f2 = A1955_HNN_WAO_FUS_110(p2)
              n2 = n110wao
          elseif( i2.eq.13 ) then
              f2 = A1955_HNN_WAO_FUS_115(p2)
              n2 = n115wao
          elseif( i2.eq.14 ) then
              f2 = A1955_HNN_WAO_FUS_120(p2)
              n2 = n120wao
          endif

      elseif( iana.eq.2 ) then
          if( i1.eq.1 ) then
              f1 = A1955_HNN_WANO_FUS_60(p1)
              n1 = n60wano
          elseif( i1.eq.2 ) then
              f1 = A1955_HNN_WANO_FUS_65(p1)
              n1 = n65wano
          elseif( i1.eq.3 ) then
              f1 = A1955_HNN_WANO_FUS_70(p1)
              n1 = n70wano
          elseif( i1.eq.4 ) then
              f1 = A1955_HNN_WANO_FUS_75(p1)
              n1 = n75wano
          elseif( i1.eq.5 ) then
              f1 = A1955_HNN_WANO_FUS_80(p1)
              n1 = n80wano
          elseif( i1.eq.6 ) then
              f1 = A1955_HNN_WANO_FUS_85(p1)
              n1 = n85wano
          elseif( i1.eq.7 ) then
              f1 = A1955_HNN_WANO_FUS_90(p1)
              n1 = n90wano
          elseif( i1.eq.8 ) then
              f1 = A1955_HNN_WANO_FUS_95(p1)
              n1 = n95wano
          elseif( i1.eq.9 ) then
              f1 = A1955_HNN_WANO_FUS_100(p1)
              n1 = n100wano
          elseif( i1.eq.10 ) then
              f1 = A1955_HNN_WANO_FUS_105(p1)
              n1 = n105wano
          elseif( i1.eq.11 ) then
              f1 = A1955_HNN_WANO_FUS_107(p1)
              n1 = n107wano
          elseif( i1.eq.12 ) then
              f1 = A1955_HNN_WANO_FUS_110(p1)
              n1 = n110wano
          elseif( i1.eq.13 ) then
              f1 = A1955_HNN_WANO_FUS_115(p1)
              n1 = n115wano
          elseif( i1.eq.14 ) then
              f1 = A1955_HNN_WANO_FUS_120(p1)
              n1 = n120wano
          endif
          if( i2.eq.1 ) then
              f2 = A1955_HNN_WANO_FUS_60(p2)
              n2 = n60wano
          elseif( i2.eq.2 ) then
              f2 = A1955_HNN_WANO_FUS_65(p2)
              n2 = n65wano
          elseif( i2.eq.3 ) then
              f2 = A1955_HNN_WANO_FUS_70(p2)
              n2 = n70wano
          elseif( i2.eq.4 ) then
              f2 = A1955_HNN_WANO_FUS_75(p2)
              n2 = n75wano
          elseif( i2.eq.5 ) then
              f2 = A1955_HNN_WANO_FUS_80(p2)
              n2 = n80wano
          elseif( i2.eq.6 ) then
              f2 = A1955_HNN_WANO_FUS_85(p2)
              n2 = n85wano
          elseif( i2.eq.7 ) then
              f2 = A1955_HNN_WANO_FUS_90(p2)
              n2 = n90wano
          elseif( i2.eq.8 ) then
              f2 = A1955_HNN_WANO_FUS_95(p2)
              n2 = n95wano
          elseif( i2.eq.9 ) then
              f2 = A1955_HNN_WANO_FUS_100(p2)
              n2 = n100wano
          elseif( i2.eq.10 ) then
              f2 = A1955_HNN_WANO_FUS_105(p2)
              n2 = n105wano
          elseif( i2.eq.11 ) then
              f2 = A1955_HNN_WANO_FUS_107(p2)
              n2 = n107wano
          elseif( i2.eq.12 ) then
              f2 = A1955_HNN_WANO_FUS_110(p2)
              n2 = n110wano
          elseif( i2.eq.13 ) then
              f2 = A1955_HNN_WANO_FUS_115(p2)
              n2 = n115wano
          elseif( i2.eq.14 ) then
              f2 = A1955_HNN_WANO_FUS_120(p2)
              n2 = n120wano
          endif

      elseif( iana.eq.3 ) then
          if( i1.eq.1 ) then
              f1 = A1955_HNN_NWAO_FUS_60(p1)
              n1 = n60nwao
          elseif( i1.eq.2 ) then
              f1 = A1955_HNN_NWAO_FUS_65(p1)
              n1 = n65nwao
          elseif( i1.eq.3 ) then
              f1 = A1955_HNN_NWAO_FUS_70(p1)
              n1 = n70nwao
          elseif( i1.eq.4 ) then
              f1 = A1955_HNN_NWAO_FUS_75(p1)
              n1 = n75nwao
          elseif( i1.eq.5 ) then
              f1 = A1955_HNN_NWAO_FUS_80(p1)
              n1 = n80nwao
          elseif( i1.eq.6 ) then
              f1 = A1955_HNN_NWAO_FUS_85(p1)
              n1 = n85nwao
          elseif( i1.eq.7 ) then
              f1 = A1955_HNN_NWAO_FUS_90(p1)
              n1 = n90nwao
          elseif( i1.eq.8 ) then
              f1 = A1955_HNN_NWAO_FUS_95(p1)
              n1 = n95nwao
          elseif( i1.eq.9 ) then
              f1 = A1955_HNN_NWAO_FUS_100(p1)
              n1 = n100nwao
          elseif( i1.eq.10 ) then
              f1 = A1955_HNN_NWAO_FUS_105(p1)
              n1 = n105nwao
          elseif( i1.eq.11 ) then
              f1 = A1955_HNN_NWAO_FUS_107(p1)
              n1 = n107nwao
          elseif( i1.eq.12 ) then
              f1 = A1955_HNN_NWAO_FUS_110(p1)
              n1 = n110nwao
          elseif( i1.eq.13 ) then
              f1 = A1955_HNN_NWAO_FUS_115(p1)
              n1 = n115nwao
          elseif( i1.eq.14 ) then
              f1 = A1955_HNN_NWAO_FUS_120(p1)
              n1 = n120nwao
          endif
          if( i2.eq.1 ) then
              f2 = A1955_HNN_NWAO_FUS_60(p2)
              n2 = n60nwao
          elseif( i2.eq.2 ) then
              f2 = A1955_HNN_NWAO_FUS_65(p2)
              n2 = n65nwao
          elseif( i2.eq.3 ) then
              f2 = A1955_HNN_NWAO_FUS_70(p2)
              n2 = n70nwao
          elseif( i2.eq.4 ) then
              f2 = A1955_HNN_NWAO_FUS_75(p2)
              n2 = n75nwao
          elseif( i2.eq.5 ) then
              f2 = A1955_HNN_NWAO_FUS_80(p2)
              n2 = n80nwao
          elseif( i2.eq.6 ) then
              f2 = A1955_HNN_NWAO_FUS_85(p2)
              n2 = n85nwao
          elseif( i2.eq.7 ) then
              f2 = A1955_HNN_NWAO_FUS_90(p2)
              n2 = n90nwao
          elseif( i2.eq.8 ) then
              f2 = A1955_HNN_NWAO_FUS_95(p2)
              n2 = n95nwao
          elseif( i2.eq.9 ) then
              f2 = A1955_HNN_NWAO_FUS_100(p2)
              n2 = n100nwao
          elseif( i2.eq.10 ) then
              f2 = A1955_HNN_NWAO_FUS_105(p2)
              n2 = n105nwao
          elseif( i2.eq.11 ) then
              f2 = A1955_HNN_NWAO_FUS_107(p2)
              n2 = n107nwao
          elseif( i2.eq.12 ) then
              f2 = A1955_HNN_NWAO_FUS_110(p2)
              n2 = n110nwao
          elseif( i2.eq.13 ) then
              f2 = A1955_HNN_NWAO_FUS_115(p2)
              n2 = n115nwao
          elseif( i2.eq.14 ) then
              f2 = A1955_HNN_NWAO_FUS_120(p2)
              n2 = n120nwao
          endif
       endif
      f = f1*d2/n1 + f2*d1/n2
      if( f.lt.1.0D-06 ) f = 1.0d-06
      if    ( x.lt.massl .or. x.gt.massh ) then
         f = 0.0d0
      endif

      A1955_hnn_fus_mass_sig = f
      end

      DOUBLE PRECISION Function A1955_HNN_MASS_BKG(x,iana,ibkg)
      Implicit none 
      Integer       iana,ibkg
      Real*8        x,hmass

      Real*8        A1955_HNN_WAO_QQ
     &            , A1955_HNN_WAO_WW
     &            , A1955_HNN_WAO_ZZ
     &            , A1955_HNN_WANO_QQ
     &            , A1955_HNN_WANO_WW
     &            , A1955_HNN_WANO_ZZ
     &            , A1955_HNN_NWAO_QQ
     &            , A1955_HNN_NWAO_WW
     &            , A1955_HNN_NWAO_ZZ
      External      A1955_HNN_WAO_QQ
     &            , A1955_HNN_WAO_WW
     &            , A1955_HNN_WAO_ZZ
     &            , A1955_HNN_WANO_QQ
     &            , A1955_HNN_WANO_WW
     &            , A1955_HNN_WANO_ZZ
     &            , A1955_HNN_NWAO_QQ
     &            , A1955_HNN_NWAO_WW
     &            , A1955_HNN_NWAO_ZZ
*-----------------------------------
      if     (iana.eq.1) then
         if    ( ibkg.eq.1 ) then
            A1955_HNN_MASS_BKG = A1955_HNN_WAO_QQ(x)
         elseif( ibkg.eq.2 ) then
            A1955_HNN_MASS_BKG = A1955_HNN_WAO_WW(x)
         elseif( ibkg.eq.3 ) then
            A1955_HNN_MASS_BKG = A1955_HNN_WAO_ZZ(x)
         endif
      elseif (iana.eq.2) then
         if    ( ibkg.eq.1 ) then
            A1955_HNN_MASS_BKG = A1955_HNN_WANO_QQ(x)
         elseif( ibkg.eq.2 ) then
            A1955_HNN_MASS_BKG = A1955_HNN_WANO_WW(x)
         elseif( ibkg.eq.3 ) then
            A1955_HNN_MASS_BKG = A1955_HNN_WANO_ZZ(x)
         endif
      elseif (iana.eq.3) then
         if    ( ibkg.eq.1 ) then
            A1955_HNN_MASS_BKG = A1955_HNN_NWAO_QQ(x)
         elseif( ibkg.eq.2 ) then
            A1955_HNN_MASS_BKG = A1955_HNN_NWAO_WW(x)
         elseif( ibkg.eq.3 ) then
            A1955_HNN_MASS_BKG = A1955_HNN_NWAO_ZZ(x)
         endif
      else
          write(*,*) 'unknown Hvv channel, stop ', iana
          stop
      endif
      end



      double precision function A1955_HNN_HZ_EFF(hmass,br,iana)
      Implicit none 
      Integer       br,iana
      Real*8        hmass

      Integer       mpnt, ipnt
      Parameter   ( mpnt = 14 )
      Real*8        masst(mpnt)
      real*8        effbband(mpnt),effbbwis(mpnt),effbbors(mpnt)
     &            , eff  (mpnt)
      data        ( masst(ipnt), effbband(ipnt), effbbwis(ipnt)
     &            , effbbors(ipnt), ipnt=1,mpnt)
     &            /  60.0, 0.0052, 0.0637, 0.0042
     &            ,  65.0, 0.0064, 0.0802, 0.0054
     &            ,  70.0, 0.0130, 0.1276, 0.0067
     &            ,  75.0, 0.0135, 0.1781, 0.0088
     &            ,  80.0, 0.0303, 0.2537, 0.0106
     &            ,  85.0, 0.0594, 0.3133, 0.0164
     &            ,  90.0, 0.1742, 0.2982, 0.0244
     &            ,  95.0, 0.3788, 0.1588, 0.0520
     &            , 100.0, 0.4314, 0.1252, 0.0670
     &            , 105.0, 0.2922, 0.1733, 0.0485
     &            , 107.0, 0.2543, 0.2126, 0.0368
     &            , 110.0, 0.2160, 0.1935, 0.0305
     &            , 115.0, 0.1485, 0.2047, 0.0218
     &            , 120.0, 0.1066, 0.1952, 0.0149 /

      Integer       i, i1, i2
      Real*8        d, d1, d2, effmh
      Save
*--------------------
      if (br.eq.1) then
         if(iana.eq.1) then
            do i = 1, mpnt
               eff(i)=effbband(i)
            enddo
         elseif(iana.eq.2) then
            do i = 1, mpnt
               eff(i)=effbbwis(i)
            enddo
         elseif(iana.eq.3) then
            do i = 1, mpnt
               eff(i)=effbbors(i)
            enddo
         else
            do i = 1, mpnt
               eff(i)=0.d0
            enddo
            
         endif
      else
         do i = 1, mpnt
            eff(i)=0.d0
         enddo
      endif
*     interpolations
*     ==============
      if    ( hmass.lt.masst(1   ) ) then
        effmh = 0.
      elseif( hmass.gt.masst(mpnt) ) then
        effmh = 0.
      else
        do i = 1, mpnt-1
           if( hmass.ge.masst(i) .and. hmass.le.masst(i+1) ) then
               i1 = i
               i2 = i + 1
           endif
        enddo
        d1 = hmass - masst(i1)
        d2 = masst(i2) - hmass
        d  = masst(i2) - masst(i1)
        effmh = ( eff(i1)*d2 + eff(i2)*d1 )/d
      endif

      A1955_HNN_HZ_EFF = effmh
      end

      double precision function A1955_HNN_WWF_EFF(hmass,br,iana)
      Implicit none 
      Integer       br,iana
      Real*8        hmass

      Integer       mpnt, ipnt
      Parameter   ( mpnt = 14 )
      Real*8        masst(mpnt)
      real*8        effbband(mpnt),effbbwis(mpnt),effbbors(mpnt)
     &            , eff  (mpnt)
      data        ( masst(ipnt), effbband(ipnt), effbbwis(ipnt)
     &            , effbbors(ipnt), ipnt=1,mpnt)
     &            /  60.0, 0.0060, 0.0650, 0.0063
     &            ,  65.0, 0.0079, 0.0849, 0.0055
     &            ,  70.0, 0.0108, 0.1153, 0.0067
     &            ,  75.0, 0.0184, 0.1704, 0.0089
     &            ,  80.0, 0.0283, 0.2285, 0.0120
     &            ,  85.0, 0.0496, 0.2846, 0.0133
     &            ,  90.0, 0.1344, 0.3018, 0.0230
     &            ,  95.0, 0.2986, 0.1791, 0.0343
     &            , 100.0, 0.3399, 0.1639, 0.0440
     &            , 105.0, 0.2183, 0.1957, 0.0316
     &            , 107.0, 0.1880, 0.2168, 0.0259
     &            , 110.0, 0.1610, 0.2201, 0.0201
     &            , 115.0, 0.1211, 0.2076, 0.0153
     &            , 120.0, 0.0900, 0.1799, 0.0123   /

      Integer       i, i1, i2
      Real*8        d, d1, d2, effmh
      Save
*--------------------
      if (br.eq.1) then
         if(iana.eq.1) then
            do i = 1, mpnt
               eff(i)=effbband(i)
            enddo
         elseif(iana.eq.2) then
            do i = 1, mpnt
               eff(i)=effbbwis(i)
            enddo
         elseif(iana.eq.3) then
            do i = 1, mpnt
               eff(i)=effbbors(i)
            enddo
         else
            do i = 1, mpnt
               eff(i)=0.d0
            enddo
            
         endif
      else
         do i = 1, mpnt
            eff(i)=0.d0
         enddo
      endif
*     interpolations
*     ==============
      if    ( hmass.lt.masst(1   ) ) then
        effmh = 0.
      elseif( hmass.gt.masst(mpnt) ) then
        effmh = 0.
      else
        do i = 1, mpnt-1
           if( hmass.ge.masst(i) .and. hmass.le.masst(i+1) ) then
               i1 = i
               i2 = i + 1
           endif
        enddo
        d1 = hmass - masst(i1)
        d2 = masst(i2) - hmass
        d  = masst(i2) - masst(i1)
        effmh = ( eff(i1)*d2 + eff(i2)*d1 )/d
      endif

      A1955_HNN_WWF_EFF = effmh
      end
      integer function A1995_HNN_NUMCAND(iana)
      implicit none
      integer iana
      INTEGER numcand(3)
      data numcand/1,0,0/
      if (iana.eq.1.0.or.iana.eq.2.0.or.iana.eq.3.0) then
         A1995_HNN_NUMCAND = numcand(iana)
      else 
         A1995_HNN_NUMCAND = 0
      endif
      end


      DOUBLE PRECISION function A1995_HNN_MASS_CAND(iana,icand)
      implicit none
      integer iana,icand
      REAL*8 andmass(1)
      data andmass/103.235/
      if (iana.eq.1) then 
         A1995_HNN_MASS_CAND=andmass(icand)
      else
         A1995_HNN_MASS_CAND=0.0   
      endif
      end

*1995
      DOUBLE PRECISION function A1995_HNN_BKG(iana,bkg)
      Implicit none 
      Integer       iana, bkg
      Real          andbkg(3), wisbkg(3), orsbkg(3)
      data          andbkg/0.00216063,0.00107229,0.00831809/
      data          wisbkg/0.0016984,0.00343179,0.0199899/
      data          orsbkg/0.005666,0.000237779,0.00183176/
      SAVE
*--------------------------------------------------------
      if (iana.eq.1.0) then 
         A1995_HNN_BKG=andbkg(bkg) 
      elseif (iana.eq.2.0) then 
         A1995_HNN_BKG=wisbkg(bkg)      
      elseif (iana.eq.3.0) then 
         A1995_HNN_BKG=orsbkg(bkg)
      else 
         A1995_HNN_BKG=0.0
      endif
      end



      DOUBLE PRECISION Function A1995_HNN_MASS_SIG(x,hmass,iana)
      Implicit none
      Integer       iana
      Real*8        x, hmass
      logical first
      data first /.true./

      Real*8        massl, massh
      Data          massl, massh/ 50.0 ,108.3/

      Integer       mpnt, mana, jpnt, jana
      Parameter   ( mpnt = 14 , mana = 3)
      Real*8        masst(mpnt), corpk(mana,mpnt)
      Data         (masst(jpnt), (corpk(jana,jpnt),jana=1,mana)
     &                                            ,jpnt=1,mpnt)
     &             /60.00, 78.44, 62.78, 78.71
     &             ,65.00, 86.97, 68.28, 83.77
     &             ,70.00, 88.27, 72.60, 87.03
     &             ,75.00, 94.09, 77.08, 88.21
     &             ,80.00, 94.81, 81.84, 90.46
     &             ,85.00, 96.00, 85.38, 93.69
     &             ,90.00, 97.02, 89.32, 95.34
     &             ,95.00, 97.93, 92.82, 97.77
     &             ,100.00, 100.1, 96.42, 99.46
     &             ,105.00, 103.2, 101.4, 101.3
     &             ,107.00, 103.8, 102.3, 101.2
     &             ,110.00, 103.0, 99.64, 101.2
     &             ,115.00, 102.3, 97.57, 101.5
     &             ,120.00, 102.2, 98.07, 101.0/ 

      Integer       i , i1, i2
      Real*8        c , c1, c2
     &            , d , d1, d2
     &            , f , f1, f2
     &            ,     p1, p2
     &            ,     n1, n2
     &            ,n60wao,n65wao,n70wao,n75wao,n80wao
     &            ,n85wao,n90wao,n95wao,n100wao,n105wao
     &            ,n107wao,n110wao,n115wao,n120wao
     &            ,n60wano,n65wano,n70wano,n75wano,n80wano
     &            ,n85wano,n90wano,n95wano,n100wano,n105wano
     &            ,n107wano,n110wano,n115wano,n120wano
     &            ,n60nwao,n65nwao,n70nwao,n75nwao,n80nwao
     &            ,n85nwao,n90nwao,n95nwao,n100nwao,n105nwao
     &            ,n107nwao,n110nwao,n115nwao,n120nwao
      SAVE

      Real*8        A1995_HNN_WAO_HZ_60
     &            , A1995_HNN_WAO_HZ_65
     &            , A1995_HNN_WAO_HZ_70
     &            , A1995_HNN_WAO_HZ_75
     &            , A1995_HNN_WAO_HZ_80
     &            , A1995_HNN_WAO_HZ_85
     &            , A1995_HNN_WAO_HZ_90
     &            , A1995_HNN_WAO_HZ_95
     &            , A1995_HNN_WAO_HZ_100
     &            , A1995_HNN_WAO_HZ_105
     &            , A1995_HNN_WAO_HZ_107
     &            , A1995_HNN_WAO_HZ_110
     &            , A1995_HNN_WAO_HZ_115
     &            , A1995_HNN_WAO_HZ_120
     &            , A1995_HNN_WANO_HZ_60
     &            , A1995_HNN_WANO_HZ_65
     &            , A1995_HNN_WANO_HZ_70
     &            , A1995_HNN_WANO_HZ_75
     &            , A1995_HNN_WANO_HZ_80
     &            , A1995_HNN_WANO_HZ_85
     &            , A1995_HNN_WANO_HZ_90
     &            , A1995_HNN_WANO_HZ_95
     &            , A1995_HNN_WANO_HZ_100
     &            , A1995_HNN_WANO_HZ_105
     &            , A1995_HNN_WANO_HZ_107
     &            , A1995_HNN_WANO_HZ_110
     &            , A1995_HNN_WANO_HZ_115
     &            , A1995_HNN_WANO_HZ_120
     &            , A1995_HNN_NWAO_HZ_60
     &            , A1995_HNN_NWAO_HZ_65
     &            , A1995_HNN_NWAO_HZ_70
     &            , A1995_HNN_NWAO_HZ_75
     &            , A1995_HNN_NWAO_HZ_80
     &            , A1995_HNN_NWAO_HZ_85
     &            , A1995_HNN_NWAO_HZ_90
     &            , A1995_HNN_NWAO_HZ_95
     &            , A1995_HNN_NWAO_HZ_100
     &            , A1995_HNN_NWAO_HZ_105
     &            , A1995_HNN_NWAO_HZ_107
     &            , A1995_HNN_NWAO_HZ_110
     &            , A1995_HNN_NWAO_HZ_115
     &            , A1995_HNN_NWAO_HZ_120
     &            , A1999_HNN_NORMSH
      External        A1995_HNN_WAO_HZ_60
     &            , A1995_HNN_WAO_HZ_65
     &            , A1995_HNN_WAO_HZ_70
     &            , A1995_HNN_WAO_HZ_75
     &            , A1995_HNN_WAO_HZ_80
     &            , A1995_HNN_WAO_HZ_85
     &            , A1995_HNN_WAO_HZ_90
     &            , A1995_HNN_WAO_HZ_95
     &            , A1995_HNN_WAO_HZ_100
     &            , A1995_HNN_WAO_HZ_105
     &            , A1995_HNN_WAO_HZ_107
     &            , A1995_HNN_WAO_HZ_110
     &            , A1995_HNN_WAO_HZ_115
     &            , A1995_HNN_WAO_HZ_120
     &            , A1995_HNN_WANO_HZ_60
     &            , A1995_HNN_WANO_HZ_65
     &            , A1995_HNN_WANO_HZ_70
     &            , A1995_HNN_WANO_HZ_75
     &            , A1995_HNN_WANO_HZ_80
     &            , A1995_HNN_WANO_HZ_85
     &            , A1995_HNN_WANO_HZ_90
     &            , A1995_HNN_WANO_HZ_95
     &            , A1995_HNN_WANO_HZ_100
     &            , A1995_HNN_WANO_HZ_105
     &            , A1995_HNN_WANO_HZ_107
     &            , A1995_HNN_WANO_HZ_110
     &            , A1995_HNN_WANO_HZ_115
     &            , A1995_HNN_WANO_HZ_120
     &            , A1995_HNN_NWAO_HZ_60
     &            , A1995_HNN_NWAO_HZ_65
     &            , A1995_HNN_NWAO_HZ_70
     &            , A1995_HNN_NWAO_HZ_75
     &            , A1995_HNN_NWAO_HZ_80
     &            , A1995_HNN_NWAO_HZ_85
     &            , A1995_HNN_NWAO_HZ_90
     &            , A1995_HNN_NWAO_HZ_95
     &            , A1995_HNN_NWAO_HZ_100
     &            , A1995_HNN_NWAO_HZ_105
     &            , A1995_HNN_NWAO_HZ_107
     &            , A1995_HNN_NWAO_HZ_110
     &            , A1995_HNN_NWAO_HZ_115
     &            , A1995_HNN_NWAO_HZ_120
     &            , A1999_HNN_NORMSH
      if (first) then
         n60wao=A1999_Hnn_normsh(A1995_HNN_WAO_HZ_60,
     &             massl,massh,500)
         n65wao=A1999_Hnn_normsh(A1995_HNN_WAO_HZ_65,
     &             massl,massh,500)
         n70wao=A1999_Hnn_normsh(A1995_HNN_WAO_HZ_70,
     &             massl,massh,500)
         n75wao=A1999_Hnn_normsh(A1995_HNN_WAO_HZ_75,
     &             massl,massh,500)
         n80wao=A1999_Hnn_normsh(A1995_HNN_WAO_HZ_80,
     &             massl,massh,500)
         n85wao=A1999_Hnn_normsh(A1995_HNN_WAO_HZ_85,
     &             massl,massh,500)
         n90wao=A1999_Hnn_normsh(A1995_HNN_WAO_HZ_90,
     &             massl,massh,500)
         n95wao=A1999_Hnn_normsh(A1995_HNN_WAO_HZ_95,
     &             massl,massh,500)
         n100wao=A1999_Hnn_normsh(A1995_HNN_WAO_HZ_100,
     &             massl,massh,500)
         n105wao=A1999_Hnn_normsh(A1995_HNN_WAO_HZ_105,
     &             massl,massh,500)
         n107wao=A1999_Hnn_normsh(A1995_HNN_WAO_HZ_107,
     &             massl,massh,500)
         n110wao=A1999_Hnn_normsh(A1995_HNN_WAO_HZ_110,
     &             massl,massh,500)
         n115wao=A1999_Hnn_normsh(A1995_HNN_WAO_HZ_115,
     &             massl,massh,500)
         n120wao=A1999_Hnn_normsh(A1995_HNN_WAO_HZ_120,
     &             massl,massh,500)
         n60wano=A1999_Hnn_normsh(A1995_HNN_WANO_HZ_60,
     &             massl,massh,500)
         n65wano=A1999_Hnn_normsh(A1995_HNN_WANO_HZ_65,
     &             massl,massh,500)
         n70wano=A1999_Hnn_normsh(A1995_HNN_WANO_HZ_70,
     &             massl,massh,500)
         n75wano=A1999_Hnn_normsh(A1995_HNN_WANO_HZ_75,
     &             massl,massh,500)
         n80wano=A1999_Hnn_normsh(A1995_HNN_WANO_HZ_80,
     &             massl,massh,500)
         n85wano=A1999_Hnn_normsh(A1995_HNN_WANO_HZ_85,
     &             massl,massh,500)
         n90wano=A1999_Hnn_normsh(A1995_HNN_WANO_HZ_90,
     &             massl,massh,500)
         n95wano=A1999_Hnn_normsh(A1995_HNN_WANO_HZ_95,
     &             massl,massh,500)
         n100wano=A1999_Hnn_normsh(A1995_HNN_WANO_HZ_100,
     &             massl,massh,500)
         n105wano=A1999_Hnn_normsh(A1995_HNN_WANO_HZ_105,
     &             massl,massh,500)
         n107wano=A1999_Hnn_normsh(A1995_HNN_WANO_HZ_107,
     &             massl,massh,500)
         n110wano=A1999_Hnn_normsh(A1995_HNN_WANO_HZ_110,
     &             massl,massh,500)
         n115wano=A1999_Hnn_normsh(A1995_HNN_WANO_HZ_115,
     &             massl,massh,500)
         n120wano=A1999_Hnn_normsh(A1995_HNN_WANO_HZ_120,
     &             massl,massh,500)
         n60nwao=A1999_Hnn_normsh(A1995_HNN_NWAO_HZ_60,
     &             massl,massh,500)
         n65nwao=A1999_Hnn_normsh(A1995_HNN_NWAO_HZ_65,
     &             massl,massh,500)
         n70nwao=A1999_Hnn_normsh(A1995_HNN_NWAO_HZ_70,
     &             massl,massh,500)
         n75nwao=A1999_Hnn_normsh(A1995_HNN_NWAO_HZ_75,
     &             massl,massh,500)
         n80nwao=A1999_Hnn_normsh(A1995_HNN_NWAO_HZ_80,
     &             massl,massh,500)
         n85nwao=A1999_Hnn_normsh(A1995_HNN_NWAO_HZ_85,
     &             massl,massh,500)
         n90nwao=A1999_Hnn_normsh(A1995_HNN_NWAO_HZ_90,
     &             massl,massh,500)
         n95nwao=A1999_Hnn_normsh(A1995_HNN_NWAO_HZ_95,
     &             massl,massh,500)
         n100nwao=A1999_Hnn_normsh(A1995_HNN_NWAO_HZ_100,
     &             massl,massh,500)
         n105nwao=A1999_Hnn_normsh(A1995_HNN_NWAO_HZ_105,
     &             massl,massh,500)
         n107nwao=A1999_Hnn_normsh(A1995_HNN_NWAO_HZ_107,
     &             massl,massh,500)
         n110nwao=A1999_Hnn_normsh(A1995_HNN_NWAO_HZ_110,
     &             massl,massh,500)
         n115nwao=A1999_Hnn_normsh(A1995_HNN_NWAO_HZ_115,
     &             massl,massh,500)
         n120nwao=A1999_Hnn_normsh(A1995_HNN_NWAO_HZ_120,
     &             massl,massh,500)
         first = .false.
      endif

*------------------------------------
* find position
* =============
      if    ( hmass.lt.masst(1   ) ) then
          i1 = 1
          i2 = 1
          d1 = 0.0
          d2 = 1.0
      elseif( hmass.ge.masst(mpnt) ) then
          i1 = mpnt
          i2 = mpnt
          d1 = 1.0
          d2 = 0.0
      else
          do i = 1, mpnt-1
          if( hmass.ge.masst(i) .and. hmass.lt.masst(i+1) ) then
          i1 = i
          i2 = i + 1
          endif
          enddo
          d  = masst(i2) - masst(i1)
          d1 = (hmass - masst(i1))/d
          d2 = (masst(i2) - hmass)/d
      endif
      c1 = corpk(iana,i1)
      c2 = corpk(iana,i2)
      c  = c1*d2 + c2*d1

* very painful procedure to get function values
* =============================================
      if(hmass.le.75.0) then
         if (x.ge.c) then
            p1 = x - c + corpk(iana,i1)
            p2 = x - c + corpk(iana,i2)
         else
            p1 = corpk(iana,i1)-(c-x)/(c-massl)*(corpk(iana,i1)-massl)
            p2 = corpk(iana,i2)-(c-x)/(c-massl)*(corpk(iana,i2)-massl)
         endif
      elseif(hmass.ge.massh) then
         if (x.le.c) then
            p1 = x - c + corpk(iana,i1)
            p2 = x - c + corpk(iana,i2)
         else
            p1 = corpk(iana,i1)+(x-c)/(massh-c)*(massh-corpk(iana,i1))
            p2 = corpk(iana,i2)+(x-c)/(massh-c)*(massh-corpk(iana,i2))
         endif
      else
         p1 = x - c + corpk(iana,i1)
         p2 = x - c + corpk(iana,i2)
      endif
      


      if( iana.eq.1 ) then
          if( i1.eq.1 ) then
              f1 = A1995_HNN_WAO_HZ_60(p1)
              n1 = n60wao
          elseif( i1.eq.2 ) then
              f1 = A1995_HNN_WAO_HZ_65(p1)
              n1 = n65wao
          elseif( i1.eq.3 ) then
              f1 = A1995_HNN_WAO_HZ_70(p1)
              n1 = n70wao
          elseif( i1.eq.4 ) then
              f1 = A1995_HNN_WAO_HZ_75(p1)
              n1 = n75wao
          elseif( i1.eq.5 ) then
              f1 = A1995_HNN_WAO_HZ_80(p1)
              n1 = n80wao
          elseif( i1.eq.6 ) then
              f1 = A1995_HNN_WAO_HZ_85(p1)
              n1 = n85wao
          elseif( i1.eq.7 ) then
              f1 = A1995_HNN_WAO_HZ_90(p1)
              n1 = n90wao
          elseif( i1.eq.8 ) then
              f1 = A1995_HNN_WAO_HZ_95(p1)
              n1 = n95wao
          elseif( i1.eq.9 ) then
              f1 = A1995_HNN_WAO_HZ_100(p1)
              n1 = n100wao
          elseif( i1.eq.10 ) then
              f1 = A1995_HNN_WAO_HZ_105(p1)
              n1 = n105wao
          elseif( i1.eq.11 ) then
              f1 = A1995_HNN_WAO_HZ_107(p1)
              n1 = n107wao
          elseif( i1.eq.12 ) then
              f1 = A1995_HNN_WAO_HZ_110(p1)
              n1 = n110wao
          elseif( i1.eq.13 ) then
              f1 = A1995_HNN_WAO_HZ_115(p1)
              n1 = n115wao
          elseif( i1.eq.14 ) then
              f1 = A1995_HNN_WAO_HZ_120(p1)
              n1 = n120wao
          endif
          if( i2.eq.1 ) then
              f2 = A1995_HNN_WAO_HZ_60(p2)
              n2 = n60wao
          elseif( i2.eq.2 ) then
              f2 = A1995_HNN_WAO_HZ_65(p2)
              n2 = n65wao
          elseif( i2.eq.3 ) then
              f2 = A1995_HNN_WAO_HZ_70(p2)
              n2 = n70wao
          elseif( i2.eq.4 ) then
              f2 = A1995_HNN_WAO_HZ_75(p2)
              n2 = n75wao
          elseif( i2.eq.5 ) then
              f2 = A1995_HNN_WAO_HZ_80(p2)
              n2 = n80wao
          elseif( i2.eq.6 ) then
              f2 = A1995_HNN_WAO_HZ_85(p2)
              n2 = n85wao
          elseif( i2.eq.7 ) then
              f2 = A1995_HNN_WAO_HZ_90(p2)
              n2 = n90wao
          elseif( i2.eq.8 ) then
              f2 = A1995_HNN_WAO_HZ_95(p2)
              n2 = n95wao
          elseif( i2.eq.9 ) then
              f2 = A1995_HNN_WAO_HZ_100(p2)
              n2 = n100wao
          elseif( i2.eq.10 ) then
              f2 = A1995_HNN_WAO_HZ_105(p2)
              n2 = n105wao
          elseif( i2.eq.11 ) then
              f2 = A1995_HNN_WAO_HZ_107(p2)
              n2 = n107wao
          elseif( i2.eq.12 ) then
              f2 = A1995_HNN_WAO_HZ_110(p2)
              n2 = n110wao
          elseif( i2.eq.13 ) then
              f2 = A1995_HNN_WAO_HZ_115(p2)
              n2 = n115wao
          elseif( i2.eq.14 ) then
              f2 = A1995_HNN_WAO_HZ_120(p2)
              n2 = n120wao
          endif

      elseif( iana.eq.2 ) then
          if( i1.eq.1 ) then
              f1 = A1995_HNN_WANO_HZ_60(p1)
              n1 = n60wano
          elseif( i1.eq.2 ) then
              f1 = A1995_HNN_WANO_HZ_65(p1)
              n1 = n65wano
          elseif( i1.eq.3 ) then
              f1 = A1995_HNN_WANO_HZ_70(p1)
              n1 = n70wano
          elseif( i1.eq.4 ) then
              f1 = A1995_HNN_WANO_HZ_75(p1)
              n1 = n75wano
          elseif( i1.eq.5 ) then
              f1 = A1995_HNN_WANO_HZ_80(p1)
              n1 = n80wano
          elseif( i1.eq.6 ) then
              f1 = A1995_HNN_WANO_HZ_85(p1)
              n1 = n85wano
          elseif( i1.eq.7 ) then
              f1 = A1995_HNN_WANO_HZ_90(p1)
              n1 = n90wano
          elseif( i1.eq.8 ) then
              f1 = A1995_HNN_WANO_HZ_95(p1)
              n1 = n95wano
          elseif( i1.eq.9 ) then
              f1 = A1995_HNN_WANO_HZ_100(p1)
              n1 = n100wano
          elseif( i1.eq.10 ) then
              f1 = A1995_HNN_WANO_HZ_105(p1)
              n1 = n105wano
          elseif( i1.eq.11 ) then
              f1 = A1995_HNN_WANO_HZ_107(p1)
              n1 = n107wano
          elseif( i1.eq.12 ) then
              f1 = A1995_HNN_WANO_HZ_110(p1)
              n1 = n110wano
          elseif( i1.eq.13 ) then
              f1 = A1995_HNN_WANO_HZ_115(p1)
              n1 = n115wano
          elseif( i1.eq.14 ) then
              f1 = A1995_HNN_WANO_HZ_120(p1)
              n1 = n120wano
          endif
          if( i2.eq.1 ) then
              f2 = A1995_HNN_WANO_HZ_60(p2)
              n2 = n60wano
          elseif( i2.eq.2 ) then
              f2 = A1995_HNN_WANO_HZ_65(p2)
              n2 = n65wano
          elseif( i2.eq.3 ) then
              f2 = A1995_HNN_WANO_HZ_70(p2)
              n2 = n70wano
          elseif( i2.eq.4 ) then
              f2 = A1995_HNN_WANO_HZ_75(p2)
              n2 = n75wano
          elseif( i2.eq.5 ) then
              f2 = A1995_HNN_WANO_HZ_80(p2)
              n2 = n80wano
          elseif( i2.eq.6 ) then
              f2 = A1995_HNN_WANO_HZ_85(p2)
              n2 = n85wano
          elseif( i2.eq.7 ) then
              f2 = A1995_HNN_WANO_HZ_90(p2)
              n2 = n90wano
          elseif( i2.eq.8 ) then
              f2 = A1995_HNN_WANO_HZ_95(p2)
              n2 = n95wano
          elseif( i2.eq.9 ) then
              f2 = A1995_HNN_WANO_HZ_100(p2)
              n2 = n100wano
          elseif( i2.eq.10 ) then
              f2 = A1995_HNN_WANO_HZ_105(p2)
              n2 = n105wano
          elseif( i2.eq.11 ) then
              f2 = A1995_HNN_WANO_HZ_107(p2)
              n2 = n107wano
          elseif( i2.eq.12 ) then
              f2 = A1995_HNN_WANO_HZ_110(p2)
              n2 = n110wano
          elseif( i2.eq.13 ) then
              f2 = A1995_HNN_WANO_HZ_115(p2)
              n2 = n115wano
          elseif( i2.eq.14 ) then
              f2 = A1995_HNN_WANO_HZ_120(p2)
              n2 = n120wano
          endif

      elseif( iana.eq.3 ) then
          if( i1.eq.1 ) then
              f1 = A1995_HNN_NWAO_HZ_60(p1)
              n1 = n60nwao
          elseif( i1.eq.2 ) then
              f1 = A1995_HNN_NWAO_HZ_65(p1)
              n1 = n65nwao
          elseif( i1.eq.3 ) then
              f1 = A1995_HNN_NWAO_HZ_70(p1)
              n1 = n70nwao
          elseif( i1.eq.4 ) then
              f1 = A1995_HNN_NWAO_HZ_75(p1)
              n1 = n75nwao
          elseif( i1.eq.5 ) then
              f1 = A1995_HNN_NWAO_HZ_80(p1)
              n1 = n80nwao
          elseif( i1.eq.6 ) then
              f1 = A1995_HNN_NWAO_HZ_85(p1)
              n1 = n85nwao
          elseif( i1.eq.7 ) then
              f1 = A1995_HNN_NWAO_HZ_90(p1)
              n1 = n90nwao
          elseif( i1.eq.8 ) then
              f1 = A1995_HNN_NWAO_HZ_95(p1)
              n1 = n95nwao
          elseif( i1.eq.9 ) then
              f1 = A1995_HNN_NWAO_HZ_100(p1)
              n1 = n100nwao
          elseif( i1.eq.10 ) then
              f1 = A1995_HNN_NWAO_HZ_105(p1)
              n1 = n105nwao
          elseif( i1.eq.11 ) then
              f1 = A1995_HNN_NWAO_HZ_107(p1)
              n1 = n107nwao
          elseif( i1.eq.12 ) then
              f1 = A1995_HNN_NWAO_HZ_110(p1)
              n1 = n110nwao
          elseif( i1.eq.13 ) then
              f1 = A1995_HNN_NWAO_HZ_115(p1)
              n1 = n115nwao
          elseif( i1.eq.14 ) then
              f1 = A1995_HNN_NWAO_HZ_120(p1)
              n1 = n120nwao
          endif
          if( i2.eq.1 ) then
              f2 = A1995_HNN_NWAO_HZ_60(p2)
              n2 = n60nwao
          elseif( i2.eq.2 ) then
              f2 = A1995_HNN_NWAO_HZ_65(p2)
              n2 = n65nwao
          elseif( i2.eq.3 ) then
              f2 = A1995_HNN_NWAO_HZ_70(p2)
              n2 = n70nwao
          elseif( i2.eq.4 ) then
              f2 = A1995_HNN_NWAO_HZ_75(p2)
              n2 = n75nwao
          elseif( i2.eq.5 ) then
              f2 = A1995_HNN_NWAO_HZ_80(p2)
              n2 = n80nwao
          elseif( i2.eq.6 ) then
              f2 = A1995_HNN_NWAO_HZ_85(p2)
              n2 = n85nwao
          elseif( i2.eq.7 ) then
              f2 = A1995_HNN_NWAO_HZ_90(p2)
              n2 = n90nwao
          elseif( i2.eq.8 ) then
              f2 = A1995_HNN_NWAO_HZ_95(p2)
              n2 = n95nwao
          elseif( i2.eq.9 ) then
              f2 = A1995_HNN_NWAO_HZ_100(p2)
              n2 = n100nwao
          elseif( i2.eq.10 ) then
              f2 = A1995_HNN_NWAO_HZ_105(p2)
              n2 = n105nwao
          elseif( i2.eq.11 ) then
              f2 = A1995_HNN_NWAO_HZ_107(p2)
              n2 = n107nwao
          elseif( i2.eq.12 ) then
              f2 = A1995_HNN_NWAO_HZ_110(p2)
              n2 = n110nwao
          elseif( i2.eq.13 ) then
              f2 = A1995_HNN_NWAO_HZ_115(p2)
              n2 = n115nwao
          elseif( i2.eq.14 ) then
              f2 = A1995_HNN_NWAO_HZ_120(p2)
              n2 = n120nwao
          endif
       endif
      f = f1*d2/n1 + f2*d1/n2
      if( f.lt.1.0D-06 ) f = 1.0d-06
      if    ( x.lt.massl .or. x.gt.massh ) then
         f = 0.0d0
      endif

      A1995_HNN_MASS_SIG = f
      end


      DOUBLE PRECISION Function A1995_hnn_fus_mass_sig(x,hmass,iana)
      Implicit none
      Integer       iana
      Real*8        x, hmass
      logical first
      data first /.true./

      Real*8        massl, massh
      Data          massl, massh/ 50.0 ,108.3/

      Integer       mpnt, mana, jpnt, jana
      Parameter   ( mpnt = 14 , mana = 3)
      Real*8        masst(mpnt), corpk(mana,mpnt)
      Data         (masst(jpnt), (corpk(jana,jpnt),jana=1,mana)
     &                                            ,jpnt=1,mpnt)
     &             /60.00, 81.13, 63.29, 78.31
     &             ,65.00, 90.63, 67.96, 84.72 
     &             ,70.00, 91.58, 72.61, 87.08
     &             ,75.00, 97.00, 76.87, 86.99
     &             ,80.00, 96.01, 80.57, 92.19
     &             ,85.00, 96.33, 84.62, 95.88
     &             ,90.00, 97.26, 88.40, 94.09
     &             ,95.00, 97.68, 91.56, 96.00
     &             ,100.00, 99.75, 93.58, 99.45
     &             ,105.00, 102.3, 96.94, 101.33
     &             ,107.00, 102.9, 96.86, 101.2
     &             ,110.00, 101.5, 94.90, 100.8
     &             ,115.00, 101.4, 95.89, 100.7
     &             ,120.00, 101.5, 96.92, 100.3/ 

      Integer       i , i1, i2
      Real*8        c , c1, c2
     &            , d , d1, d2
     &            , f , f1, f2
     &            ,     p1, p2
     &            ,     n1, n2
     &            ,n60wao,n65wao,n70wao,n75wao,n80wao
     &            ,n85wao,n90wao,n95wao,n100wao,n105wao
     &            ,n107wao,n110wao,n115wao,n120wao
     &            ,n60wano,n65wano,n70wano,n75wano,n80wano
     &            ,n85wano,n90wano,n95wano,n100wano,n105wano
     &            ,n107wano,n110wano,n115wano,n120wano
     &            ,n60nwao,n65nwao,n70nwao,n75nwao,n80nwao
     &            ,n85nwao,n90nwao,n95nwao,n100nwao,n105nwao
     &            ,n107nwao,n110nwao,n115nwao,n120nwao
      SAVE
      Real*8        A1995_HNN_WAO_FUS_60
     &            , A1995_HNN_WAO_FUS_65
     &            , A1995_HNN_WAO_FUS_70
     &            , A1995_HNN_WAO_FUS_75
     &            , A1995_HNN_WAO_FUS_80
     &            , A1995_HNN_WAO_FUS_85
     &            , A1995_HNN_WAO_FUS_90
     &            , A1995_HNN_WAO_FUS_95
     &            , A1995_HNN_WAO_FUS_100
     &            , A1995_HNN_WAO_FUS_105
     &            , A1995_HNN_WAO_FUS_107
     &            , A1995_HNN_WAO_FUS_110
     &            , A1995_HNN_WAO_FUS_115
     &            , A1995_HNN_WAO_FUS_120
     &            , A1995_HNN_WANO_FUS_60
     &            , A1995_HNN_WANO_FUS_65
     &            , A1995_HNN_WANO_FUS_70
     &            , A1995_HNN_WANO_FUS_75
     &            , A1995_HNN_WANO_FUS_80
     &            , A1995_HNN_WANO_FUS_85
     &            , A1995_HNN_WANO_FUS_90
     &            , A1995_HNN_WANO_FUS_95
     &            , A1995_HNN_WANO_FUS_100
     &            , A1995_HNN_WANO_FUS_105
     &            , A1995_HNN_WANO_FUS_107
     &            , A1995_HNN_WANO_FUS_110
     &            , A1995_HNN_WANO_FUS_115
     &            , A1995_HNN_WANO_FUS_120
     &            , A1995_HNN_NWAO_FUS_60
     &            , A1995_HNN_NWAO_FUS_65
     &            , A1995_HNN_NWAO_FUS_70
     &            , A1995_HNN_NWAO_FUS_75
     &            , A1995_HNN_NWAO_FUS_80
     &            , A1995_HNN_NWAO_FUS_85
     &            , A1995_HNN_NWAO_FUS_90
     &            , A1995_HNN_NWAO_FUS_95
     &            , A1995_HNN_NWAO_FUS_100
     &            , A1995_HNN_NWAO_FUS_105
     &            , A1995_HNN_NWAO_FUS_107
     &            , A1995_HNN_NWAO_FUS_110
     &            , A1995_HNN_NWAO_FUS_115
     &            , A1995_HNN_NWAO_FUS_120
     &            , A1999_Hnn_normsh
      External        A1995_HNN_WAO_FUS_60
     &            , A1995_HNN_WAO_FUS_65
     &            , A1995_HNN_WAO_FUS_70
     &            , A1995_HNN_WAO_FUS_75
     &            , A1995_HNN_WAO_FUS_80
     &            , A1995_HNN_WAO_FUS_85
     &            , A1995_HNN_WAO_FUS_90
     &            , A1995_HNN_WAO_FUS_95
     &            , A1995_HNN_WAO_FUS_100
     &            , A1995_HNN_WAO_FUS_105
     &            , A1995_HNN_WAO_FUS_107
     &            , A1995_HNN_WAO_FUS_110
     &            , A1995_HNN_WAO_FUS_115
     &            , A1995_HNN_WAO_FUS_120
     &            , A1995_HNN_WANO_FUS_60
     &            , A1995_HNN_WANO_FUS_65
     &            , A1995_HNN_WANO_FUS_70
     &            , A1995_HNN_WANO_FUS_75
     &            , A1995_HNN_WANO_FUS_80
     &            , A1995_HNN_WANO_FUS_85
     &            , A1995_HNN_WANO_FUS_90
     &            , A1995_HNN_WANO_FUS_95
     &            , A1995_HNN_WANO_FUS_100
     &            , A1995_HNN_WANO_FUS_105
     &            , A1995_HNN_WANO_FUS_107
     &            , A1995_HNN_WANO_FUS_110
     &            , A1995_HNN_WANO_FUS_115
     &            , A1995_HNN_WANO_FUS_120
     &            , A1995_HNN_NWAO_FUS_60
     &            , A1995_HNN_NWAO_FUS_65
     &            , A1995_HNN_NWAO_FUS_70
     &            , A1995_HNN_NWAO_FUS_75
     &            , A1995_HNN_NWAO_FUS_80
     &            , A1995_HNN_NWAO_FUS_85
     &            , A1995_HNN_NWAO_FUS_90
     &            , A1995_HNN_NWAO_FUS_95
     &            , A1995_HNN_NWAO_FUS_100
     &            , A1995_HNN_NWAO_FUS_105
     &            , A1995_HNN_NWAO_FUS_107
     &            , A1995_HNN_NWAO_FUS_110
     &            , A1995_HNN_NWAO_FUS_115
     &            , A1995_HNN_NWAO_FUS_120
     &            , A1999_Hnn_normsh
      if (first) then
         n60wao=A1999_Hnn_normsh(A1995_HNN_WAO_fus_60,
     &             massl,massh,500)
         n65wao=A1999_Hnn_normsh(A1995_HNN_WAO_fus_65,
     &             massl,massh,500)
         n70wao=A1999_Hnn_normsh(A1995_HNN_WAO_fus_70,
     &             massl,massh,500)
         n75wao=A1999_Hnn_normsh(A1995_HNN_WAO_fus_75,
     &             massl,massh,500)
         n80wao=A1999_Hnn_normsh(A1995_HNN_WAO_fus_80,
     &             massl,massh,500)
         n85wao=A1999_Hnn_normsh(A1995_HNN_WAO_fus_85,
     &             massl,massh,500)
         n90wao=A1999_Hnn_normsh(A1995_HNN_WAO_fus_90,
     &             massl,massh,500)
         n95wao=A1999_Hnn_normsh(A1995_HNN_WAO_fus_95,
     &             massl,massh,500)
         n100wao=A1999_Hnn_normsh(A1995_HNN_WAO_fus_100,
     &             massl,massh,500)
         n105wao=A1999_Hnn_normsh(A1995_HNN_WAO_fus_105,
     &             massl,massh,500)
         n107wao=A1999_Hnn_normsh(A1995_HNN_WAO_fus_107,
     &             massl,massh,500)
         n110wao=A1999_Hnn_normsh(A1995_HNN_WAO_fus_110,
     &             massl,massh,500)
         n115wao=A1999_Hnn_normsh(A1995_HNN_WAO_fus_115,
     &             massl,massh,500)
         n120wao=A1999_Hnn_normsh(A1995_HNN_WAO_fus_120,
     &             massl,massh,500)
         n60wano=A1999_Hnn_normsh(A1995_HNN_WANO_fus_60,
     &             massl,massh,500)
         n65wano=A1999_Hnn_normsh(A1995_HNN_WANO_fus_65,
     &             massl,massh,500)
         n70wano=A1999_Hnn_normsh(A1995_HNN_WANO_fus_70,
     &             massl,massh,500)
         n75wano=A1999_Hnn_normsh(A1995_HNN_WANO_fus_75,
     &             massl,massh,500)
         n80wano=A1999_Hnn_normsh(A1995_HNN_WANO_fus_80,
     &             massl,massh,500)
         n85wano=A1999_Hnn_normsh(A1995_HNN_WANO_fus_85,
     &             massl,massh,500)
         n90wano=A1999_Hnn_normsh(A1995_HNN_WANO_fus_90,
     &             massl,massh,500)
         n95wano=A1999_Hnn_normsh(A1995_HNN_WANO_fus_95,
     &             massl,massh,500)
         n100wano=A1999_Hnn_normsh(A1995_HNN_WANO_fus_100,
     &             massl,massh,500)
         n105wano=A1999_Hnn_normsh(A1995_HNN_WANO_fus_105,
     &             massl,massh,500)
         n107wano=A1999_Hnn_normsh(A1995_HNN_WANO_fus_107,
     &             massl,massh,500)
         n110wano=A1999_Hnn_normsh(A1995_HNN_WANO_fus_110,
     &             massl,massh,500)
         n115wano=A1999_Hnn_normsh(A1995_HNN_WANO_fus_115,
     &             massl,massh,500)
         n120wano=A1999_Hnn_normsh(A1995_HNN_WANO_fus_120,
     &             massl,massh,500)
         n60nwao=A1999_Hnn_normsh(A1995_HNN_NWAO_fus_60,
     &             massl,massh,500)
         n65nwao=A1999_Hnn_normsh(A1995_HNN_NWAO_fus_65,
     &             massl,massh,500)
         n70nwao=A1999_Hnn_normsh(A1995_HNN_NWAO_fus_70,
     &             massl,massh,500)
         n75nwao=A1999_Hnn_normsh(A1995_HNN_NWAO_fus_75,
     &             massl,massh,500)
         n80nwao=A1999_Hnn_normsh(A1995_HNN_NWAO_fus_80,
     &             massl,massh,500)
         n85nwao=A1999_Hnn_normsh(A1995_HNN_NWAO_fus_85,
     &             massl,massh,500)
         n90nwao=A1999_Hnn_normsh(A1995_HNN_NWAO_fus_90,
     &             massl,massh,500)
         n95nwao=A1999_Hnn_normsh(A1995_HNN_NWAO_fus_95,
     &             massl,massh,500)
         n100nwao=A1999_Hnn_normsh(A1995_HNN_NWAO_fus_100,
     &             massl,massh,500)
         n105nwao=A1999_Hnn_normsh(A1995_HNN_NWAO_fus_105,
     &             massl,massh,500)
         n107nwao=A1999_Hnn_normsh(A1995_HNN_NWAO_fus_107,
     &             massl,massh,500)
         n110nwao=A1999_Hnn_normsh(A1995_HNN_NWAO_fus_110,
     &             massl,massh,500)
         n115nwao=A1999_Hnn_normsh(A1995_HNN_NWAO_fus_115,
     &             massl,massh,500)
         n120nwao=A1999_Hnn_normsh(A1995_HNN_NWAO_fus_120,
     &             massl,massh,500)
         first = .false.
      endif

*------------------------------------
* find position
* =============
      if    ( hmass.lt.masst(1   ) ) then
          i1 = 1
          i2 = 1
          d1 = 0.0
          d2 = 1.0
      elseif( hmass.ge.masst(mpnt) ) then
          i1 = mpnt
          i2 = mpnt
          d1 = 1.0
          d2 = 0.0
      else
          do i = 1, mpnt-1
          if( hmass.ge.masst(i) .and. hmass.lt.masst(i+1) ) then
          i1 = i
          i2 = i + 1
          endif
          enddo
          d  = masst(i2) - masst(i1)
          d1 = (hmass - masst(i1))/d
          d2 = (masst(i2) - hmass)/d
      endif
      c1 = corpk(iana,i1)
      c2 = corpk(iana,i2)
      c  = c1*d2 + c2*d1

* very painful procedure to get function values
* =============================================
      if(hmass.le.75.0) then
         if (x.ge.c) then
            p1 = x - c + corpk(iana,i1)
            p2 = x - c + corpk(iana,i2)
         else
            p1 = corpk(iana,i1)-(c-x)/(c-massl)*(corpk(iana,i1)-massl)
            p2 = corpk(iana,i2)-(c-x)/(c-massl)*(corpk(iana,i2)-massl)
         endif
      elseif(hmass.ge.massh) then
         if (x.le.c) then
            p1 = x - c + corpk(iana,i1)
            p2 = x - c + corpk(iana,i2)
         else
            p1 = corpk(iana,i1)+(x-c)/(massh-c)*(massh-corpk(iana,i1))
            p2 = corpk(iana,i2)+(x-c)/(massh-c)*(massh-corpk(iana,i2))
         endif
      else
         p1 = x - c + corpk(iana,i1)
         p2 = x - c + corpk(iana,i2)
      endif

      if( iana.eq.1 ) then
          if( i1.eq.1 ) then
              f1 = A1995_HNN_WAO_FUS_60(p1)
              n1 = n60wao
          elseif( i1.eq.2 ) then
              f1 = A1995_HNN_WAO_FUS_65(p1)
              n1 = n65wao
          elseif( i1.eq.3 ) then
              f1 = A1995_HNN_WAO_FUS_70(p1)
              n1 = n70wao
          elseif( i1.eq.4 ) then
              f1 = A1995_HNN_WAO_FUS_75(p1)
              n1 = n75wao
          elseif( i1.eq.5 ) then
              f1 = A1995_HNN_WAO_FUS_80(p1)
              n1 = n80wao
          elseif( i1.eq.6 ) then
              f1 = A1995_HNN_WAO_FUS_85(p1)
              n1 = n85wao
          elseif( i1.eq.7 ) then
              f1 = A1995_HNN_WAO_FUS_90(p1)
              n1 = n90wao
          elseif( i1.eq.8 ) then
              f1 = A1995_HNN_WAO_FUS_95(p1)
              n1 = n95wao
          elseif( i1.eq.9 ) then
              f1 = A1995_HNN_WAO_FUS_100(p1)
              n1 = n100wao
          elseif( i1.eq.10 ) then
              f1 = A1995_HNN_WAO_FUS_105(p1)
              n1 = n105wao
          elseif( i1.eq.11 ) then
              f1 = A1995_HNN_WAO_FUS_107(p1)
              n1 = n107wao
          elseif( i1.eq.12 ) then
              f1 = A1995_HNN_WAO_FUS_110(p1)
              n1 = n110wao
          elseif( i1.eq.13 ) then
              f1 = A1995_HNN_WAO_FUS_115(p1)
              n1 = n115wao
          elseif( i1.eq.14 ) then
              f1 = A1995_HNN_WAO_FUS_120(p1)
              n1 = n120wao
          endif
          if( i2.eq.1 ) then
              f2 = A1995_HNN_WAO_FUS_60(p2)
              n2 = n60wao
          elseif( i2.eq.2 ) then
              f2 = A1995_HNN_WAO_FUS_65(p2)
              n2 = n65wao
          elseif( i2.eq.3 ) then
              f2 = A1995_HNN_WAO_FUS_70(p2)
              n2 = n70wao
          elseif( i2.eq.4 ) then
              f2 = A1995_HNN_WAO_FUS_75(p2)
              n2 = n75wao
          elseif( i2.eq.5 ) then
              f2 = A1995_HNN_WAO_FUS_80(p2)
              n2 = n80wao
          elseif( i2.eq.6 ) then
              f2 = A1995_HNN_WAO_FUS_85(p2)
              n2 = n85wao
          elseif( i2.eq.7 ) then
              f2 = A1995_HNN_WAO_FUS_90(p2)
              n2 = n90wao
          elseif( i2.eq.8 ) then
              f2 = A1995_HNN_WAO_FUS_95(p2)
              n2 = n95wao
          elseif( i2.eq.9 ) then
              f2 = A1995_HNN_WAO_FUS_100(p2)
              n2 = n100wao
          elseif( i2.eq.10 ) then
              f2 = A1995_HNN_WAO_FUS_105(p2)
              n2 = n105wao
          elseif( i2.eq.11 ) then
              f2 = A1995_HNN_WAO_FUS_107(p2)
              n2 = n107wao
          elseif( i2.eq.12 ) then
              f2 = A1995_HNN_WAO_FUS_110(p2)
              n2 = n110wao
          elseif( i2.eq.13 ) then
              f2 = A1995_HNN_WAO_FUS_115(p2)
              n2 = n115wao
          elseif( i2.eq.14 ) then
              f2 = A1995_HNN_WAO_FUS_120(p2)
              n2 = n120wao
          endif

      elseif( iana.eq.2 ) then
          if( i1.eq.1 ) then
              f1 = A1995_HNN_WANO_FUS_60(p1)
              n1 = n60wano
          elseif( i1.eq.2 ) then
              f1 = A1995_HNN_WANO_FUS_65(p1)
              n1 = n65wano
          elseif( i1.eq.3 ) then
              f1 = A1995_HNN_WANO_FUS_70(p1)
              n1 = n70wano
          elseif( i1.eq.4 ) then
              f1 = A1995_HNN_WANO_FUS_75(p1)
              n1 = n75wano
          elseif( i1.eq.5 ) then
              f1 = A1995_HNN_WANO_FUS_80(p1)
              n1 = n80wano
          elseif( i1.eq.6 ) then
              f1 = A1995_HNN_WANO_FUS_85(p1)
              n1 = n85wano
          elseif( i1.eq.7 ) then
              f1 = A1995_HNN_WANO_FUS_90(p1)
              n1 = n90wano
          elseif( i1.eq.8 ) then
              f1 = A1995_HNN_WANO_FUS_95(p1)
              n1 = n95wano
          elseif( i1.eq.9 ) then
              f1 = A1995_HNN_WANO_FUS_100(p1)
              n1 = n100wano
          elseif( i1.eq.10 ) then
              f1 = A1995_HNN_WANO_FUS_105(p1)
              n1 = n105wano
          elseif( i1.eq.11 ) then
              f1 = A1995_HNN_WANO_FUS_107(p1)
              n1 = n107wano
          elseif( i1.eq.12 ) then
              f1 = A1995_HNN_WANO_FUS_110(p1)
              n1 = n110wano
          elseif( i1.eq.13 ) then
              f1 = A1995_HNN_WANO_FUS_115(p1)
              n1 = n115wano
          elseif( i1.eq.14 ) then
              f1 = A1995_HNN_WANO_FUS_120(p1)
              n1 = n120wano
          endif
          if( i2.eq.1 ) then
              f2 = A1995_HNN_WANO_FUS_60(p2)
              n2 = n60wano
          elseif( i2.eq.2 ) then
              f2 = A1995_HNN_WANO_FUS_65(p2)
              n2 = n65wano
          elseif( i2.eq.3 ) then
              f2 = A1995_HNN_WANO_FUS_70(p2)
              n2 = n70wano
          elseif( i2.eq.4 ) then
              f2 = A1995_HNN_WANO_FUS_75(p2)
              n2 = n75wano
          elseif( i2.eq.5 ) then
              f2 = A1995_HNN_WANO_FUS_80(p2)
              n2 = n80wano
          elseif( i2.eq.6 ) then
              f2 = A1995_HNN_WANO_FUS_85(p2)
              n2 = n85wano
          elseif( i2.eq.7 ) then
              f2 = A1995_HNN_WANO_FUS_90(p2)
              n2 = n90wano
          elseif( i2.eq.8 ) then
              f2 = A1995_HNN_WANO_FUS_95(p2)
              n2 = n95wano
          elseif( i2.eq.9 ) then
              f2 = A1995_HNN_WANO_FUS_100(p2)
              n2 = n100wano
          elseif( i2.eq.10 ) then
              f2 = A1995_HNN_WANO_FUS_105(p2)
              n2 = n105wano
          elseif( i2.eq.11 ) then
              f2 = A1995_HNN_WANO_FUS_107(p2)
              n2 = n107wano
          elseif( i2.eq.12 ) then
              f2 = A1995_HNN_WANO_FUS_110(p2)
              n2 = n110wano
          elseif( i2.eq.13 ) then
              f2 = A1995_HNN_WANO_FUS_115(p2)
              n2 = n115wano
          elseif( i2.eq.14 ) then
              f2 = A1995_HNN_WANO_FUS_120(p2)
              n2 = n120wano
          endif

      elseif( iana.eq.3 ) then
          if( i1.eq.1 ) then
              f1 = A1995_HNN_NWAO_FUS_60(p1)
              n1 = n60nwao
          elseif( i1.eq.2 ) then
              f1 = A1995_HNN_NWAO_FUS_65(p1)
              n1 = n65nwao
          elseif( i1.eq.3 ) then
              f1 = A1995_HNN_NWAO_FUS_70(p1)
              n1 = n70nwao
          elseif( i1.eq.4 ) then
              f1 = A1995_HNN_NWAO_FUS_75(p1)
              n1 = n75nwao
          elseif( i1.eq.5 ) then
              f1 = A1995_HNN_NWAO_FUS_80(p1)
              n1 = n80nwao
          elseif( i1.eq.6 ) then
              f1 = A1995_HNN_NWAO_FUS_85(p1)
              n1 = n85nwao
          elseif( i1.eq.7 ) then
              f1 = A1995_HNN_NWAO_FUS_90(p1)
              n1 = n90nwao
          elseif( i1.eq.8 ) then
              f1 = A1995_HNN_NWAO_FUS_95(p1)
              n1 = n95nwao
          elseif( i1.eq.9 ) then
              f1 = A1995_HNN_NWAO_FUS_100(p1)
              n1 = n100nwao
          elseif( i1.eq.10 ) then
              f1 = A1995_HNN_NWAO_FUS_105(p1)
              n1 = n105nwao
          elseif( i1.eq.11 ) then
              f1 = A1995_HNN_NWAO_FUS_107(p1)
              n1 = n107nwao
          elseif( i1.eq.12 ) then
              f1 = A1995_HNN_NWAO_FUS_110(p1)
              n1 = n110nwao
          elseif( i1.eq.13 ) then
              f1 = A1995_HNN_NWAO_FUS_115(p1)
              n1 = n115nwao
          elseif( i1.eq.14 ) then
              f1 = A1995_HNN_NWAO_FUS_120(p1)
              n1 = n120nwao
          endif
          if( i2.eq.1 ) then
              f2 = A1995_HNN_NWAO_FUS_60(p2)
              n2 = n60nwao
          elseif( i2.eq.2 ) then
              f2 = A1995_HNN_NWAO_FUS_65(p2)
              n2 = n65nwao
          elseif( i2.eq.3 ) then
              f2 = A1995_HNN_NWAO_FUS_70(p2)
              n2 = n70nwao
          elseif( i2.eq.4 ) then
              f2 = A1995_HNN_NWAO_FUS_75(p2)
              n2 = n75nwao
          elseif( i2.eq.5 ) then
              f2 = A1995_HNN_NWAO_FUS_80(p2)
              n2 = n80nwao
          elseif( i2.eq.6 ) then
              f2 = A1995_HNN_NWAO_FUS_85(p2)
              n2 = n85nwao
          elseif( i2.eq.7 ) then
              f2 = A1995_HNN_NWAO_FUS_90(p2)
              n2 = n90nwao
          elseif( i2.eq.8 ) then
              f2 = A1995_HNN_NWAO_FUS_95(p2)
              n2 = n95nwao
          elseif( i2.eq.9 ) then
              f2 = A1995_HNN_NWAO_FUS_100(p2)
              n2 = n100nwao
          elseif( i2.eq.10 ) then
              f2 = A1995_HNN_NWAO_FUS_105(p2)
              n2 = n105nwao
          elseif( i2.eq.11 ) then
              f2 = A1995_HNN_NWAO_FUS_107(p2)
              n2 = n107nwao
          elseif( i2.eq.12 ) then
              f2 = A1995_HNN_NWAO_FUS_110(p2)
              n2 = n110nwao
          elseif( i2.eq.13 ) then
              f2 = A1995_HNN_NWAO_FUS_115(p2)
              n2 = n115nwao
          elseif( i2.eq.14 ) then
              f2 = A1995_HNN_NWAO_FUS_120(p2)
              n2 = n120nwao
          endif
       endif
      f = f1*d2/n1 + f2*d1/n2
      if( f.lt.1.0D-06 ) f = 1.0d-06
      if    ( x.lt.massl .or. x.gt.massh ) then
         f = 0.0d0
      endif

      A1995_hnn_fus_mass_sig = f
      end




      DOUBLE PRECISION Function A1995_HNN_MASS_BKG(x,iana,ibkg)
      Implicit none 
      Integer       iana,ibkg
      Real*8        x,hmass

      Real*8        A1995_HNN_WAO_QQ
     &            , A1995_HNN_WAO_WW
     &            , A1995_HNN_WAO_ZZ
     &            , A1995_HNN_WANO_QQ
     &            , A1995_HNN_WANO_WW
     &            , A1995_HNN_WANO_ZZ
     &            , A1995_HNN_NWAO_QQ
     &            , A1995_HNN_NWAO_WW
     &            , A1995_HNN_NWAO_ZZ
      External      A1995_HNN_WAO_QQ
     &            , A1995_HNN_WAO_WW
     &            , A1995_HNN_WAO_ZZ
     &            , A1995_HNN_WANO_QQ
     &            , A1995_HNN_WANO_WW
     &            , A1995_HNN_WANO_ZZ
     &            , A1995_HNN_NWAO_QQ
     &            , A1995_HNN_NWAO_WW
     &            , A1995_HNN_NWAO_ZZ
*-----------------------------------
      if     (iana.eq.1) then
         if    ( ibkg.eq.1 ) then
            A1995_HNN_MASS_BKG = A1995_HNN_WAO_QQ(x)
         elseif( ibkg.eq.2 ) then
            A1995_HNN_MASS_BKG = A1995_HNN_WAO_WW(x)
         elseif( ibkg.eq.3 ) then
            A1995_HNN_MASS_BKG = A1995_HNN_WAO_ZZ(x)
         endif
      elseif (iana.eq.2) then
         if    ( ibkg.eq.1 ) then
            A1995_HNN_MASS_BKG = A1995_HNN_WANO_QQ(x)
         elseif( ibkg.eq.2 ) then
            A1995_HNN_MASS_BKG = A1995_HNN_WANO_WW(x)
         elseif( ibkg.eq.3 ) then
            A1995_HNN_MASS_BKG = A1995_HNN_WANO_ZZ(x)
         endif
      elseif (iana.eq.3) then
         if    ( ibkg.eq.1 ) then
            A1995_HNN_MASS_BKG = A1995_HNN_NWAO_QQ(x)
         elseif( ibkg.eq.2 ) then
            A1995_HNN_MASS_BKG = A1995_HNN_NWAO_WW(x)
         elseif( ibkg.eq.3 ) then
            A1995_HNN_MASS_BKG = A1995_HNN_NWAO_ZZ(x)
         endif
      else
          write(*,*) 'unknown Hvv channel, stop ', iana
          stop
      endif
      end


      double precision function A1995_HNN_HZ_EFF(hmass,br,iana)
      Implicit none 
      Integer       br,iana
      Real*8        hmass

      Integer       mpnt, ipnt
      Parameter   ( mpnt = 14 )
      Real*8        masst(mpnt)
      real*8        effbband(mpnt),effbbwis(mpnt),effbbors(mpnt)
     &            , eff  (mpnt)
      data        ( masst(ipnt), effbband(ipnt), effbbwis(ipnt)
     &            , effbbors(ipnt), ipnt=1,mpnt)
     &            /  60.0, 0.0042, 0.0558, 0.0076
     &            ,  65.0, 0.0080, 0.0761, 0.0063
     &            ,  70.0, 0.0099, 0.1074, 0.0051
     &            ,  75.0, 0.0123, 0.1450, 0.0071
     &            ,  80.0, 0.0173, 0.1986, 0.0084
     &            ,  85.0, 0.0349, 0.2863, 0.0114
     &            ,  90.0, 0.0804, 0.3296, 0.0163
     &            ,  95.0, 0.2264, 0.2760, 0.0324
     &            , 100.0, 0.4024, 0.1397, 0.0572
     &            , 105.0, 0.4149, 0.1290, 0.0629
     &            , 107.0, 0.3520, 0.1386, 0.0535
     &            , 110.0, 0.2754, 0.1879, 0.0473
     &            , 115.0, 0.1948, 0.2011, 0.0384
     &            , 120.0, 0.1435, 0.1849, 0.0340  /

      Integer       i, i1, i2
      Real*8        d, d1, d2, effmh
      Save
*--------------------
      if (br.eq.1) then
         if(iana.eq.1) then
            do i = 1, mpnt
               eff(i)=effbband(i)
            enddo
         elseif(iana.eq.2) then
            do i = 1, mpnt
               eff(i)=effbbwis(i)
            enddo
         elseif(iana.eq.3) then
            do i = 1, mpnt
               eff(i)=effbbors(i)
            enddo
         else
            do i = 1, mpnt
               eff(i)=0.d0
            enddo
            
         endif
      else
         do i = 1, mpnt
            eff(i)=0.d0
         enddo
      endif
*     interpolations
*     ==============
      if    ( hmass.lt.masst(1   ) ) then
        effmh = 0.
      elseif( hmass.gt.masst(mpnt) ) then
        effmh = 0.
      else
        do i = 1, mpnt-1
           if( hmass.ge.masst(i) .and. hmass.le.masst(i+1) ) then
               i1 = i
               i2 = i + 1
           endif
        enddo
        d1 = hmass - masst(i1)
        d2 = masst(i2) - hmass
        d  = masst(i2) - masst(i1)
        effmh = ( eff(i1)*d2 + eff(i2)*d1 )/d
      endif

      A1995_HNN_HZ_EFF = effmh
      end

      double precision function A1995_HNN_WWF_EFF(hmass,br,iana)
      Implicit none 
      Integer       br,iana
      Real*8        hmass

      Integer       mpnt, ipnt
      Parameter   ( mpnt = 14 )
      Real*8        masst(mpnt)
      real*8        effbband(mpnt),effbbwis(mpnt),effbbors(mpnt)
     &            , eff  (mpnt)
      data        ( masst(ipnt), effbband(ipnt), effbbwis(ipnt)
     &            , effbbors(ipnt), ipnt=1,mpnt)
     &            /  60.0, 0.0081, 0.0646, 0.0045
     &            ,  65.0, 0.0111, 0.0745, 0.0066
     &            ,  70.0, 0.0087, 0.0973, 0.0093
     &            ,  75.0, 0.0145, 0.1432, 0.0091
     &            ,  80.0, 0.0197, 0.2029, 0.0060
     &            ,  85.0, 0.0299, 0.2567, 0.0083
     &            ,  90.0, 0.0695, 0.3097, 0.0150
     &            ,  95.0, 0.1676, 0.2711, 0.0302
     &            , 100.0, 0.3150, 0.1734, 0.0460
     &            , 105.0, 0.3088, 0.1657, 0.0498
     &            , 107.0, 0.2673, 0.1817, 0.0468
     &            , 110.0, 0.1967, 0.2146, 0.0270
     &            , 115.0, 0.1554, 0.2137, 0.0214
     &            , 120.0, 0.1216, 0.2044, 0.0175   /

      Integer       i, i1, i2
      Real*8        d, d1, d2, effmh
      Save
*--------------------
      if (br.eq.1) then
         if(iana.eq.1) then
            do i = 1, mpnt
               eff(i)=effbband(i)
            enddo
         elseif(iana.eq.2) then
            do i = 1, mpnt
               eff(i)=effbbwis(i)
            enddo
         elseif(iana.eq.3) then
            do i = 1, mpnt
               eff(i)=effbbors(i)
            enddo
         else
            do i = 1, mpnt
               eff(i)=0.d0
            enddo
            
         endif
      else
         do i = 1, mpnt
            eff(i)=0.d0
         enddo
      endif
*     interpolations
*     ==============
      if    ( hmass.lt.masst(1   ) ) then
        effmh = 0.
      elseif( hmass.gt.masst(mpnt) ) then
        effmh = 0.
      else
        do i = 1, mpnt-1
           if( hmass.ge.masst(i) .and. hmass.le.masst(i+1) ) then
               i1 = i
               i2 = i + 1
           endif
        enddo
        d1 = hmass - masst(i1)
        d2 = masst(i2) - hmass
        d  = masst(i2) - masst(i1)
        effmh = ( eff(i1)*d2 + eff(i2)*d1 )/d
      endif

      A1995_HNN_WWF_EFF = effmh
      end

      integer function A2016_HNN_NUMCAND(iana)
      implicit none
      integer iana
      INTEGER numcand(3)
      data numcand/0,1,0/
      if (iana.eq.1.0.or.iana.eq.2.0.or.iana.eq.3.0) then
         A2016_HNN_NUMCAND = numcand(iana)
      else 
         A2016_HNN_NUMCAND = 0
      endif
      end


      DOUBLE PRECISION function A2016_HNN_MASS_CAND(iana,icand)
      implicit none
      integer iana,icand
      REAL*8 wismass(1)
      data wismass/87.0932/
      if (iana.eq.2) then 
         A2016_HNN_MASS_CAND=wismass(icand)
      else
         A2016_HNN_MASS_CAND=0.0   
      endif
      end

*2016
      DOUBLE PRECISION function A2016_HNN_BKG(iana,bkg)
      Implicit none 
      Integer       iana, bkg
      Real          andbkg(3), wisbkg(3), orsbkg(3)
      data          andbkg/0.00198156,0.000445,0.0048823/
      data          wisbkg/0.00331079,0.00366675,0.0204369/
      data          orsbkg/0.00563899,0.00040355,0.00158611/
      SAVE
*--------------------------------------------------------
      if (iana.eq.1.0) then 
         A2016_HNN_BKG=andbkg(bkg) 
      elseif (iana.eq.2.0) then 
         A2016_HNN_BKG=wisbkg(bkg)      
      elseif (iana.eq.3.0) then 
         A2016_HNN_BKG=orsbkg(bkg)
      else 
         A2016_HNN_BKG=0.0
      endif
      end



      DOUBLE PRECISION Function A2016_HNN_MASS_SIG(x,hmass,iana)
      Implicit none
      Integer       iana
      Real*8        x, hmass

      Real*8        massl, massh
      logical first
      data first /.true./
      Data          massl, massh/ 50.0 ,110.4/

      Integer       mpnt, mana, jpnt, jana
      Parameter   ( mpnt = 14 , mana = 3)
      Real*8        masst(mpnt), corpk(mana,mpnt)
      Data         (masst(jpnt), (corpk(jana,jpnt),jana=1,mana)
     &                                            ,jpnt=1,mpnt)
     &             /60.00, 74.59, 62.27, 73.98 
     &             ,65.00, 86.55, 68.26, 80.25
     &             ,70.00, 96.07, 73.03, 83.49
     &             ,75.00, 92.37, 77.36, 85.61
     &             ,80.00, 95.45, 81.51, 90.10
     &             ,85.00, 97.71, 85.93, 93.85
     &             ,90.00, 98.65, 90.05, 97.03
     &             ,95.00, 99.63, 93.54, 99.46
     &             ,100.00, 101.0, 95.96, 100.3
     &             ,105.00, 104.1, 101.0, 102.9
     &             ,107.00, 105.2, 103.0, 103.5
     &             ,110.00, 105.8, 103.7, 103.9
     &             ,115.00, 104.4, 101.0, 102.0
     &             ,120.00, 104.0, 99.93, 103.0/

      Integer       i , i1, i2
      Real*8        c , c1, c2
     &            , d , d1, d2
     &            , f , f1, f2
     &            ,     p1, p2
     &            ,     n1, n2
     &            ,n60wao,n65wao,n70wao,n75wao,n80wao
     &            ,n85wao,n90wao,n95wao,n100wao,n105wao
     &            ,n107wao,n110wao,n115wao,n120wao
     &            ,n60wano,n65wano,n70wano,n75wano,n80wano
     &            ,n85wano,n90wano,n95wano,n100wano,n105wano
     &            ,n107wano,n110wano,n115wano,n120wano
     &            ,n60nwao,n65nwao,n70nwao,n75nwao,n80nwao
     &            ,n85nwao,n90nwao,n95nwao,n100nwao,n105nwao
     &            ,n107nwao,n110nwao,n115nwao,n120nwao
      SAVE
      Real*8        A2016_HNN_WAO_HZ_60
     &            , A2016_HNN_WAO_HZ_65
     &            , A2016_HNN_WAO_HZ_70
     &            , A2016_HNN_WAO_HZ_75
     &            , A2016_HNN_WAO_HZ_80
     &            , A2016_HNN_WAO_HZ_85
     &            , A2016_HNN_WAO_HZ_90
     &            , A2016_HNN_WAO_HZ_95
     &            , A2016_HNN_WAO_HZ_100
     &            , A2016_HNN_WAO_HZ_105
     &            , A2016_HNN_WAO_HZ_107
     &            , A2016_HNN_WAO_HZ_110
     &            , A2016_HNN_WAO_HZ_115
     &            , A2016_HNN_WAO_HZ_120
     &            , A2016_HNN_WANO_HZ_60
     &            , A2016_HNN_WANO_HZ_65
     &            , A2016_HNN_WANO_HZ_70
     &            , A2016_HNN_WANO_HZ_75
     &            , A2016_HNN_WANO_HZ_80
     &            , A2016_HNN_WANO_HZ_85
     &            , A2016_HNN_WANO_HZ_90
     &            , A2016_HNN_WANO_HZ_95
     &            , A2016_HNN_WANO_HZ_100
     &            , A2016_HNN_WANO_HZ_105
     &            , A2016_HNN_WANO_HZ_107
     &            , A2016_HNN_WANO_HZ_110
     &            , A2016_HNN_WANO_HZ_115
     &            , A2016_HNN_WANO_HZ_120
     &            , A2016_HNN_NWAO_HZ_60
     &            , A2016_HNN_NWAO_HZ_65
     &            , A2016_HNN_NWAO_HZ_70
     &            , A2016_HNN_NWAO_HZ_75
     &            , A2016_HNN_NWAO_HZ_80
     &            , A2016_HNN_NWAO_HZ_85
     &            , A2016_HNN_NWAO_HZ_90
     &            , A2016_HNN_NWAO_HZ_95
     &            , A2016_HNN_NWAO_HZ_100
     &            , A2016_HNN_NWAO_HZ_105
     &            , A2016_HNN_NWAO_HZ_107
     &            , A2016_HNN_NWAO_HZ_110
     &            , A2016_HNN_NWAO_HZ_115
     &            , A2016_HNN_NWAO_HZ_120
     &            , A1999_Hnn_normsh
      External        A2016_HNN_WAO_HZ_60
     &            , A2016_HNN_WAO_HZ_65
     &            , A2016_HNN_WAO_HZ_70
     &            , A2016_HNN_WAO_HZ_75
     &            , A2016_HNN_WAO_HZ_80
     &            , A2016_HNN_WAO_HZ_85
     &            , A2016_HNN_WAO_HZ_90
     &            , A2016_HNN_WAO_HZ_95
     &            , A2016_HNN_WAO_HZ_100
     &            , A2016_HNN_WAO_HZ_105
     &            , A2016_HNN_WAO_HZ_107
     &            , A2016_HNN_WAO_HZ_110
     &            , A2016_HNN_WAO_HZ_115
     &            , A2016_HNN_WAO_HZ_120
     &            , A2016_HNN_WANO_HZ_60
     &            , A2016_HNN_WANO_HZ_65
     &            , A2016_HNN_WANO_HZ_70
     &            , A2016_HNN_WANO_HZ_75
     &            , A2016_HNN_WANO_HZ_80
     &            , A2016_HNN_WANO_HZ_85
     &            , A2016_HNN_WANO_HZ_90
     &            , A2016_HNN_WANO_HZ_95
     &            , A2016_HNN_WANO_HZ_100
     &            , A2016_HNN_WANO_HZ_105
     &            , A2016_HNN_WANO_HZ_107
     &            , A2016_HNN_WANO_HZ_110
     &            , A2016_HNN_WANO_HZ_115
     &            , A2016_HNN_WANO_HZ_120
     &            , A2016_HNN_NWAO_HZ_60
     &            , A2016_HNN_NWAO_HZ_65
     &            , A2016_HNN_NWAO_HZ_70
     &            , A2016_HNN_NWAO_HZ_75
     &            , A2016_HNN_NWAO_HZ_80
     &            , A2016_HNN_NWAO_HZ_85
     &            , A2016_HNN_NWAO_HZ_90
     &            , A2016_HNN_NWAO_HZ_95
     &            , A2016_HNN_NWAO_HZ_100
     &            , A2016_HNN_NWAO_HZ_105
     &            , A2016_HNN_NWAO_HZ_107
     &            , A2016_HNN_NWAO_HZ_110
     &            , A2016_HNN_NWAO_HZ_115
     &            , A2016_HNN_NWAO_HZ_120
     &            , A1999_Hnn_normsh
      if (first) then
         n60wao=A1999_Hnn_normsh(A2016_HNN_WAO_HZ_60,
     &             massl,massh,500)
         n65wao=A1999_Hnn_normsh(A2016_HNN_WAO_HZ_65,
     &             massl,massh,500)
         n70wao=A1999_Hnn_normsh(A2016_HNN_WAO_HZ_70,
     &             massl,massh,500)
         n75wao=A1999_Hnn_normsh(A2016_HNN_WAO_HZ_75,
     &             massl,massh,500)
         n80wao=A1999_Hnn_normsh(A2016_HNN_WAO_HZ_80,
     &             massl,massh,500)
         n85wao=A1999_Hnn_normsh(A2016_HNN_WAO_HZ_85,
     &             massl,massh,500)
         n90wao=A1999_Hnn_normsh(A2016_HNN_WAO_HZ_90,
     &             massl,massh,500)
         n95wao=A1999_Hnn_normsh(A2016_HNN_WAO_HZ_95,
     &             massl,massh,500)
         n100wao=A1999_Hnn_normsh(A2016_HNN_WAO_HZ_100,
     &             massl,massh,500)
         n105wao=A1999_Hnn_normsh(A2016_HNN_WAO_HZ_105,
     &             massl,massh,500)
         n107wao=A1999_Hnn_normsh(A2016_HNN_WAO_HZ_107,
     &             massl,massh,500)
         n110wao=A1999_Hnn_normsh(A2016_HNN_WAO_HZ_110,
     &             massl,massh,500)
         n115wao=A1999_Hnn_normsh(A2016_HNN_WAO_HZ_115,
     &             massl,massh,500)
         n120wao=A1999_Hnn_normsh(A2016_HNN_WAO_HZ_120,
     &             massl,massh,500)
         n60wano=A1999_Hnn_normsh(A2016_HNN_WANO_HZ_60,
     &             massl,massh,500)
         n65wano=A1999_Hnn_normsh(A2016_HNN_WANO_HZ_65,
     &             massl,massh,500)
         n70wano=A1999_Hnn_normsh(A2016_HNN_WANO_HZ_70,
     &             massl,massh,500)
         n75wano=A1999_Hnn_normsh(A2016_HNN_WANO_HZ_75,
     &             massl,massh,500)
         n80wano=A1999_Hnn_normsh(A2016_HNN_WANO_HZ_80,
     &             massl,massh,500)
         n85wano=A1999_Hnn_normsh(A2016_HNN_WANO_HZ_85,
     &             massl,massh,500)
         n90wano=A1999_Hnn_normsh(A2016_HNN_WANO_HZ_90,
     &             massl,massh,500)
         n95wano=A1999_Hnn_normsh(A2016_HNN_WANO_HZ_95,
     &             massl,massh,500)
         n100wano=A1999_Hnn_normsh(A2016_HNN_WANO_HZ_100,
     &             massl,massh,500)
         n105wano=A1999_Hnn_normsh(A2016_HNN_WANO_HZ_105,
     &             massl,massh,500)
         n107wano=A1999_Hnn_normsh(A2016_HNN_WANO_HZ_107,
     &             massl,massh,500)
         n110wano=A1999_Hnn_normsh(A2016_HNN_WANO_HZ_110,
     &             massl,massh,500)
         n115wano=A1999_Hnn_normsh(A2016_HNN_WANO_HZ_115,
     &             massl,massh,500)
         n120wano=A1999_Hnn_normsh(A2016_HNN_WANO_HZ_120,
     &             massl,massh,500)
         n60nwao=A1999_Hnn_normsh(A2016_HNN_NWAO_HZ_60,
     &             massl,massh,500)
         n65nwao=A1999_Hnn_normsh(A2016_HNN_NWAO_HZ_65,
     &             massl,massh,500)
         n70nwao=A1999_Hnn_normsh(A2016_HNN_NWAO_HZ_70,
     &             massl,massh,500)
         n75nwao=A1999_Hnn_normsh(A2016_HNN_NWAO_HZ_75,
     &             massl,massh,500)
         n80nwao=A1999_Hnn_normsh(A2016_HNN_NWAO_HZ_80,
     &             massl,massh,500)
         n85nwao=A1999_Hnn_normsh(A2016_HNN_NWAO_HZ_85,
     &             massl,massh,500)
         n90nwao=A1999_Hnn_normsh(A2016_HNN_NWAO_HZ_90,
     &             massl,massh,500)
         n95nwao=A1999_Hnn_normsh(A2016_HNN_NWAO_HZ_95,
     &             massl,massh,500)
         n100nwao=A1999_Hnn_normsh(A2016_HNN_NWAO_HZ_100,
     &             massl,massh,500)
         n105nwao=A1999_Hnn_normsh(A2016_HNN_NWAO_HZ_105,
     &             massl,massh,500)
         n107nwao=A1999_Hnn_normsh(A2016_HNN_NWAO_HZ_107,
     &             massl,massh,500)
         n110nwao=A1999_Hnn_normsh(A2016_HNN_NWAO_HZ_110,
     &             massl,massh,500)
         n115nwao=A1999_Hnn_normsh(A2016_HNN_NWAO_HZ_115,
     &             massl,massh,500)
         n120nwao=A1999_Hnn_normsh(A2016_HNN_NWAO_HZ_120,
     &             massl,massh,500)
         first = .false.
      endif
*------------------------------------
* find position
* =============
      if    ( hmass.lt.masst(1   ) ) then
          i1 = 1
          i2 = 1
          d1 = 0.0
          d2 = 1.0
      elseif( hmass.ge.masst(mpnt) ) then
          i1 = mpnt
          i2 = mpnt
          d1 = 1.0
          d2 = 0.0
      else
          do i = 1, mpnt-1
          if( hmass.ge.masst(i) .and. hmass.lt.masst(i+1) ) then
          i1 = i
          i2 = i + 1
          endif
          enddo
          d  = masst(i2) - masst(i1)
          d1 = (hmass - masst(i1))/d
          d2 = (masst(i2) - hmass)/d
      endif
      c1 = corpk(iana,i1)
      c2 = corpk(iana,i2)
      c  = c1*d2 + c2*d1

* very painful procedure to get function values
* =============================================
      if(hmass.le.75.0) then
         if (x.ge.c) then
            p1 = x - c + corpk(iana,i1)
            p2 = x - c + corpk(iana,i2)
         else
            p1 = corpk(iana,i1)-(c-x)/(c-massl)*(corpk(iana,i1)-massl)
            p2 = corpk(iana,i2)-(c-x)/(c-massl)*(corpk(iana,i2)-massl)
         endif
      elseif(hmass.ge.massh) then
         if (x.le.c) then
            p1 = x - c + corpk(iana,i1)
            p2 = x - c + corpk(iana,i2)
         else
            p1 = corpk(iana,i1)+(x-c)/(massh-c)*(massh-corpk(iana,i1))
            p2 = corpk(iana,i2)+(x-c)/(massh-c)*(massh-corpk(iana,i2))
         endif
      else
         p1 = x - c + corpk(iana,i1)
         p2 = x - c + corpk(iana,i2)
      endif
      if( iana.eq.1 ) then
          if( i1.eq.1 ) then
              f1 = A2016_HNN_WAO_HZ_60(p1)
              n1 = n60wao
          elseif( i1.eq.2 ) then
              f1 = A2016_HNN_WAO_HZ_65(p1)
              n1 = n65wao
          elseif( i1.eq.3 ) then
              f1 = A2016_HNN_WAO_HZ_70(p1)
              n1 = n70wao
          elseif( i1.eq.4 ) then
              f1 = A2016_HNN_WAO_HZ_75(p1)
              n1 = n75wao
          elseif( i1.eq.5 ) then
              f1 = A2016_HNN_WAO_HZ_80(p1)
              n1 = n80wao
          elseif( i1.eq.6 ) then
              f1 = A2016_HNN_WAO_HZ_85(p1)
              n1 = n85wao
          elseif( i1.eq.7 ) then
              f1 = A2016_HNN_WAO_HZ_90(p1)
              n1 = n90wao
          elseif( i1.eq.8 ) then
              f1 = A2016_HNN_WAO_HZ_95(p1)
              n1 = n95wao
          elseif( i1.eq.9 ) then
              f1 = A2016_HNN_WAO_HZ_100(p1)
              n1 = n100wao
          elseif( i1.eq.10 ) then
              f1 = A2016_HNN_WAO_HZ_105(p1)
              n1 = n105wao
          elseif( i1.eq.11 ) then
              f1 = A2016_HNN_WAO_HZ_107(p1)
              n1 = n107wao
          elseif( i1.eq.12 ) then
              f1 = A2016_HNN_WAO_HZ_110(p1)
              n1 = n110wao
          elseif( i1.eq.13 ) then
              f1 = A2016_HNN_WAO_HZ_115(p1)
              n1 = n115wao
          elseif( i1.eq.14 ) then
              f1 = A2016_HNN_WAO_HZ_120(p1)
              n1 = n120wao
          endif
          if( i2.eq.1 ) then
              f2 = A2016_HNN_WAO_HZ_60(p2)
              n2 = n60wao
          elseif( i2.eq.2 ) then
              f2 = A2016_HNN_WAO_HZ_65(p2)
              n2 = n65wao
          elseif( i2.eq.3 ) then
              f2 = A2016_HNN_WAO_HZ_70(p2)
              n2 = n70wao
          elseif( i2.eq.4 ) then
              f2 = A2016_HNN_WAO_HZ_75(p2)
              n2 = n75wao
          elseif( i2.eq.5 ) then
              f2 = A2016_HNN_WAO_HZ_80(p2)
              n2 = n80wao
          elseif( i2.eq.6 ) then
              f2 = A2016_HNN_WAO_HZ_85(p2)
              n2 = n85wao
          elseif( i2.eq.7 ) then
              f2 = A2016_HNN_WAO_HZ_90(p2)
              n2 = n90wao
          elseif( i2.eq.8 ) then
              f2 = A2016_HNN_WAO_HZ_95(p2)
              n2 = n95wao
          elseif( i2.eq.9 ) then
              f2 = A2016_HNN_WAO_HZ_100(p2)
              n2 = n100wao
          elseif( i2.eq.10 ) then
              f2 = A2016_HNN_WAO_HZ_105(p2)
              n2 = n105wao
          elseif( i2.eq.11 ) then
              f2 = A2016_HNN_WAO_HZ_107(p2)
              n2 = n107wao
          elseif( i2.eq.12 ) then
              f2 = A2016_HNN_WAO_HZ_110(p2)
              n2 = n110wao
          elseif( i2.eq.13 ) then
              f2 = A2016_HNN_WAO_HZ_115(p2)
              n2 = n115wao
          elseif( i2.eq.14 ) then
              f2 = A2016_HNN_WAO_HZ_120(p2)
              n2 = n120wao
          endif

      elseif( iana.eq.2 ) then
          if( i1.eq.1 ) then
              f1 = A2016_HNN_WANO_HZ_60(p1)
              n1 = n60wano
          elseif( i1.eq.2 ) then
              f1 = A2016_HNN_WANO_HZ_65(p1)
              n1 = n65wano
          elseif( i1.eq.3 ) then
              f1 = A2016_HNN_WANO_HZ_70(p1)
              n1 = n70wano
          elseif( i1.eq.4 ) then
              f1 = A2016_HNN_WANO_HZ_75(p1)
              n1 = n75wano
          elseif( i1.eq.5 ) then
              f1 = A2016_HNN_WANO_HZ_80(p1)
              n1 = n80wano
          elseif( i1.eq.6 ) then
              f1 = A2016_HNN_WANO_HZ_85(p1)
              n1 = n85wano
          elseif( i1.eq.7 ) then
              f1 = A2016_HNN_WANO_HZ_90(p1)
              n1 = n90wano
          elseif( i1.eq.8 ) then
              f1 = A2016_HNN_WANO_HZ_95(p1)
              n1 = n95wano
          elseif( i1.eq.9 ) then
              f1 = A2016_HNN_WANO_HZ_100(p1)
              n1 = n100wano
          elseif( i1.eq.10 ) then
              f1 = A2016_HNN_WANO_HZ_105(p1)
              n1 = n105wano
          elseif( i1.eq.11 ) then
              f1 = A2016_HNN_WANO_HZ_107(p1)
              n1 = n107wano
          elseif( i1.eq.12 ) then
              f1 = A2016_HNN_WANO_HZ_110(p1)
              n1 = n110wano
          elseif( i1.eq.13 ) then
              f1 = A2016_HNN_WANO_HZ_115(p1)
              n1 = n115wano
          elseif( i1.eq.14 ) then
              f1 = A2016_HNN_WANO_HZ_120(p1)
              n1 = n120wano
          endif
          if( i2.eq.1 ) then
              f2 = A2016_HNN_WANO_HZ_60(p2)
              n2 = n60wano
          elseif( i2.eq.2 ) then
              f2 = A2016_HNN_WANO_HZ_65(p2)
              n2 = n65wano
          elseif( i2.eq.3 ) then
              f2 = A2016_HNN_WANO_HZ_70(p2)
              n2 = n70wano
          elseif( i2.eq.4 ) then
              f2 = A2016_HNN_WANO_HZ_75(p2)
              n2 = n75wano
          elseif( i2.eq.5 ) then
              f2 = A2016_HNN_WANO_HZ_80(p2)
              n2 = n80wano
          elseif( i2.eq.6 ) then
              f2 = A2016_HNN_WANO_HZ_85(p2)
              n2 = n85wano
          elseif( i2.eq.7 ) then
              f2 = A2016_HNN_WANO_HZ_90(p2)
              n2 = n90wano
          elseif( i2.eq.8 ) then
              f2 = A2016_HNN_WANO_HZ_95(p2)
              n2 = n95wano
          elseif( i2.eq.9 ) then
              f2 = A2016_HNN_WANO_HZ_100(p2)
              n2 = n100wano
          elseif( i2.eq.10 ) then
              f2 = A2016_HNN_WANO_HZ_105(p2)
              n2 = n105wano
          elseif( i2.eq.11 ) then
              f2 = A2016_HNN_WANO_HZ_107(p2)
              n2 = n107wano
          elseif( i2.eq.12 ) then
              f2 = A2016_HNN_WANO_HZ_110(p2)
              n2 = n110wano
          elseif( i2.eq.13 ) then
              f2 = A2016_HNN_WANO_HZ_115(p2)
              n2 = n115wano
          elseif( i2.eq.14 ) then
              f2 = A2016_HNN_WANO_HZ_120(p2)
              n2 = n120wano
          endif

      elseif( iana.eq.3 ) then
          if( i1.eq.1 ) then
              f1 = A2016_HNN_NWAO_HZ_60(p1)
              n1 = n60nwao
          elseif( i1.eq.2 ) then
              f1 = A2016_HNN_NWAO_HZ_65(p1)
              n1 = n65nwao
          elseif( i1.eq.3 ) then
              f1 = A2016_HNN_NWAO_HZ_70(p1)
              n1 = n70nwao
          elseif( i1.eq.4 ) then
              f1 = A2016_HNN_NWAO_HZ_75(p1)
              n1 = n75nwao
          elseif( i1.eq.5 ) then
              f1 = A2016_HNN_NWAO_HZ_80(p1)
              n1 = n80nwao
          elseif( i1.eq.6 ) then
              f1 = A2016_HNN_NWAO_HZ_85(p1)
              n1 = n85nwao
          elseif( i1.eq.7 ) then
              f1 = A2016_HNN_NWAO_HZ_90(p1)
              n1 = n90nwao
          elseif( i1.eq.8 ) then
              f1 = A2016_HNN_NWAO_HZ_95(p1)
              n1 = n95nwao
          elseif( i1.eq.9 ) then
              f1 = A2016_HNN_NWAO_HZ_100(p1)
              n1 = n100nwao
          elseif( i1.eq.10 ) then
              f1 = A2016_HNN_NWAO_HZ_105(p1)
              n1 = n105nwao
          elseif( i1.eq.11 ) then
              f1 = A2016_HNN_NWAO_HZ_107(p1)
              n1 = n107nwao
          elseif( i1.eq.12 ) then
              f1 = A2016_HNN_NWAO_HZ_110(p1)
              n1 = n110nwao
          elseif( i1.eq.13 ) then
              f1 = A2016_HNN_NWAO_HZ_115(p1)
              n1 = n115nwao
          elseif( i1.eq.14 ) then
              f1 = A2016_HNN_NWAO_HZ_120(p1)
              n1 = n120nwao
          endif
          if( i2.eq.1 ) then
              f2 = A2016_HNN_NWAO_HZ_60(p2)
              n2 = n60nwao
          elseif( i2.eq.2 ) then
              f2 = A2016_HNN_NWAO_HZ_65(p2)
              n2 = n65nwao
          elseif( i2.eq.3 ) then
              f2 = A2016_HNN_NWAO_HZ_70(p2)
              n2 = n70nwao
          elseif( i2.eq.4 ) then
              f2 = A2016_HNN_NWAO_HZ_75(p2)
              n2 = n75nwao
          elseif( i2.eq.5 ) then
              f2 = A2016_HNN_NWAO_HZ_80(p2)
              n2 = n80nwao
          elseif( i2.eq.6 ) then
              f2 = A2016_HNN_NWAO_HZ_85(p2)
              n2 = n85nwao
          elseif( i2.eq.7 ) then
              f2 = A2016_HNN_NWAO_HZ_90(p2)
              n2 = n90nwao
          elseif( i2.eq.8 ) then
              f2 = A2016_HNN_NWAO_HZ_95(p2)
              n2 = n95nwao
          elseif( i2.eq.9 ) then
              f2 = A2016_HNN_NWAO_HZ_100(p2)
              n2 = n100nwao
          elseif( i2.eq.10 ) then
              f2 = A2016_HNN_NWAO_HZ_105(p2)
              n2 = n105nwao
          elseif( i2.eq.11 ) then
              f2 = A2016_HNN_NWAO_HZ_107(p2)
              n2 = n107nwao
          elseif( i2.eq.12 ) then
              f2 = A2016_HNN_NWAO_HZ_110(p2)
              n2 = n110nwao
          elseif( i2.eq.13 ) then
              f2 = A2016_HNN_NWAO_HZ_115(p2)
              n2 = n115nwao
          elseif( i2.eq.14 ) then
              f2 = A2016_HNN_NWAO_HZ_120(p2)
              n2 = n120nwao
          endif
       endif
      f = f1*d2/n1 + f2*d1/n2

      if( f.lt.1.0D-06 ) f = 1.0d-06
      if    ( x.lt.massl .or. x.gt.massh ) then
         f = 0.0d0
      endif

      A2016_HNN_MASS_SIG = f
      end


      DOUBLE PRECISION Function A2016_hnn_fus_mass_sig(x,hmass,iana)
      Implicit none
      Integer       iana
      logical first
      data first /.true./
      Real*8        x, hmass

      Real*8        massl, massh
      Data          massl, massh/ 50.0 ,110.4/

      Integer       mpnt, mana, jpnt, jana
      Parameter   ( mpnt = 14 , mana = 3)
      Real*8        masst(mpnt), corpk(mana,mpnt)
      Data         (masst(jpnt), (corpk(jana,jpnt),jana=1,mana)
     &                                            ,jpnt=1,mpnt)
     &             /60.00, 80.98, 62.18, 82.24
     &             ,65.00, 87.56, 68.29, 85.37
     &             ,70.00, 93.24, 73.00, 82.77
     &             ,75.00, 94.68, 77.03, 90.81
     &             ,80.00, 96.75, 81.15, 94.27
     &             ,85.00, 97.38, 85.57, 95.08
     &             ,90.00, 99.24, 88.67, 97.17
     &             ,95.00, 99.66, 92.02, 98.12
     &             ,100.00, 100.8, 94.28, 100.7
     &             ,105.00, 103.6, 97.05, 102.8
     &             ,107.00, 104.4, 98.08, 103.5
     &             ,110.00, 105.0, 98.18, 102.9
     &             ,115.00, 103.7, 96.97, 102.8 
     &             ,120.00, 103.7, 98.26, 102.7/

      Integer       i , i1, i2
      Real*8        c , c1, c2
     &            , d , d1, d2
     &            , f , f1, f2
     &            ,     p1, p2
     &            ,     n1, n2
     &            ,n60wao,n65wao,n70wao,n75wao,n80wao
     &            ,n85wao,n90wao,n95wao,n100wao,n105wao
     &            ,n107wao,n110wao,n115wao,n120wao
     &            ,n60wano,n65wano,n70wano,n75wano,n80wano
     &            ,n85wano,n90wano,n95wano,n100wano,n105wano
     &            ,n107wano,n110wano,n115wano,n120wano
     &            ,n60nwao,n65nwao,n70nwao,n75nwao,n80nwao
     &            ,n85nwao,n90nwao,n95nwao,n100nwao,n105nwao
     &            ,n107nwao,n110nwao,n115nwao,n120nwao
      SAVE
      Real*8        A2016_HNN_WAO_FUS_60
     &            , A2016_HNN_WAO_FUS_65
     &            , A2016_HNN_WAO_FUS_70
     &            , A2016_HNN_WAO_FUS_75
     &            , A2016_HNN_WAO_FUS_80
     &            , A2016_HNN_WAO_FUS_85
     &            , A2016_HNN_WAO_FUS_90
     &            , A2016_HNN_WAO_FUS_95
     &            , A2016_HNN_WAO_FUS_100
     &            , A2016_HNN_WAO_FUS_105
     &            , A2016_HNN_WAO_FUS_107
     &            , A2016_HNN_WAO_FUS_110
     &            , A2016_HNN_WAO_FUS_115
     &            , A2016_HNN_WAO_FUS_120
     &            , A2016_HNN_WANO_FUS_60
     &            , A2016_HNN_WANO_FUS_65
     &            , A2016_HNN_WANO_FUS_70
     &            , A2016_HNN_WANO_FUS_75
     &            , A2016_HNN_WANO_FUS_80
     &            , A2016_HNN_WANO_FUS_85
     &            , A2016_HNN_WANO_FUS_90
     &            , A2016_HNN_WANO_FUS_95
     &            , A2016_HNN_WANO_FUS_100
     &            , A2016_HNN_WANO_FUS_105
     &            , A2016_HNN_WANO_FUS_107
     &            , A2016_HNN_WANO_FUS_110
     &            , A2016_HNN_WANO_FUS_115
     &            , A2016_HNN_WANO_FUS_120
     &            , A2016_HNN_NWAO_FUS_60
     &            , A2016_HNN_NWAO_FUS_65
     &            , A2016_HNN_NWAO_FUS_70
     &            , A2016_HNN_NWAO_FUS_75
     &            , A2016_HNN_NWAO_FUS_80
     &            , A2016_HNN_NWAO_FUS_85
     &            , A2016_HNN_NWAO_FUS_90
     &            , A2016_HNN_NWAO_FUS_95
     &            , A2016_HNN_NWAO_FUS_100
     &            , A2016_HNN_NWAO_FUS_105
     &            , A2016_HNN_NWAO_FUS_107
     &            , A2016_HNN_NWAO_FUS_110
     &            , A2016_HNN_NWAO_FUS_115
     &            , A2016_HNN_NWAO_FUS_120
     &            , A1999_Hnn_normsh
      External        A2016_HNN_WAO_FUS_60
     &            , A2016_HNN_WAO_FUS_65
     &            , A2016_HNN_WAO_FUS_70
     &            , A2016_HNN_WAO_FUS_75
     &            , A2016_HNN_WAO_FUS_80
     &            , A2016_HNN_WAO_FUS_85
     &            , A2016_HNN_WAO_FUS_90
     &            , A2016_HNN_WAO_FUS_95
     &            , A2016_HNN_WAO_FUS_100
     &            , A2016_HNN_WAO_FUS_105
     &            , A2016_HNN_WAO_FUS_107
     &            , A2016_HNN_WAO_FUS_110
     &            , A2016_HNN_WAO_FUS_115
     &            , A2016_HNN_WAO_FUS_120
     &            , A2016_HNN_WANO_FUS_60
     &            , A2016_HNN_WANO_FUS_65
     &            , A2016_HNN_WANO_FUS_70
     &            , A2016_HNN_WANO_FUS_75
     &            , A2016_HNN_WANO_FUS_80
     &            , A2016_HNN_WANO_FUS_85
     &            , A2016_HNN_WANO_FUS_90
     &            , A2016_HNN_WANO_FUS_95
     &            , A2016_HNN_WANO_FUS_100
     &            , A2016_HNN_WANO_FUS_105
     &            , A2016_HNN_WANO_FUS_107
     &            , A2016_HNN_WANO_FUS_110
     &            , A2016_HNN_WANO_FUS_115
     &            , A2016_HNN_WANO_FUS_120
     &            , A2016_HNN_NWAO_FUS_60
     &            , A2016_HNN_NWAO_FUS_65
     &            , A2016_HNN_NWAO_FUS_70
     &            , A2016_HNN_NWAO_FUS_75
     &            , A2016_HNN_NWAO_FUS_80
     &            , A2016_HNN_NWAO_FUS_85
     &            , A2016_HNN_NWAO_FUS_90
     &            , A2016_HNN_NWAO_FUS_95
     &            , A2016_HNN_NWAO_FUS_100
     &            , A2016_HNN_NWAO_FUS_105
     &            , A2016_HNN_NWAO_FUS_107
     &            , A2016_HNN_NWAO_FUS_110
     &            , A2016_HNN_NWAO_FUS_115
     &            , A2016_HNN_NWAO_FUS_120
     &            , A1999_Hnn_normsh
      if (first) then
         n60wao=A1999_Hnn_normsh(A2016_HNN_WAO_fus_60,
     &             massl,massh,500)
         n65wao=A1999_Hnn_normsh(A2016_HNN_WAO_fus_65,
     &             massl,massh,500)
         n70wao=A1999_Hnn_normsh(A2016_HNN_WAO_fus_70,
     &             massl,massh,500)
         n75wao=A1999_Hnn_normsh(A2016_HNN_WAO_fus_75,
     &             massl,massh,500)
         n80wao=A1999_Hnn_normsh(A2016_HNN_WAO_fus_80,
     &             massl,massh,500)
         n85wao=A1999_Hnn_normsh(A2016_HNN_WAO_fus_85,
     &             massl,massh,500)
         n90wao=A1999_Hnn_normsh(A2016_HNN_WAO_fus_90,
     &             massl,massh,500)
         n95wao=A1999_Hnn_normsh(A2016_HNN_WAO_fus_95,
     &             massl,massh,500)
         n100wao=A1999_Hnn_normsh(A2016_HNN_WAO_fus_100,
     &             massl,massh,500)
         n105wao=A1999_Hnn_normsh(A2016_HNN_WAO_fus_105,
     &             massl,massh,500)
         n107wao=A1999_Hnn_normsh(A2016_HNN_WAO_fus_107,
     &             massl,massh,500)
         n110wao=A1999_Hnn_normsh(A2016_HNN_WAO_fus_110,
     &             massl,massh,500)
         n115wao=A1999_Hnn_normsh(A2016_HNN_WAO_fus_115,
     &             massl,massh,500)
         n120wao=A1999_Hnn_normsh(A2016_HNN_WAO_fus_120,
     &             massl,massh,500)
         n60wano=A1999_Hnn_normsh(A2016_HNN_WANO_fus_60,
     &             massl,massh,500)
         n65wano=A1999_Hnn_normsh(A2016_HNN_WANO_fus_65,
     &             massl,massh,500)
         n70wano=A1999_Hnn_normsh(A2016_HNN_WANO_fus_70,
     &             massl,massh,500)
         n75wano=A1999_Hnn_normsh(A2016_HNN_WANO_fus_75,
     &             massl,massh,500)
         n80wano=A1999_Hnn_normsh(A2016_HNN_WANO_fus_80,
     &             massl,massh,500)
         n85wano=A1999_Hnn_normsh(A2016_HNN_WANO_fus_85,
     &             massl,massh,500)
         n90wano=A1999_Hnn_normsh(A2016_HNN_WANO_fus_90,
     &             massl,massh,500)
         n95wano=A1999_Hnn_normsh(A2016_HNN_WANO_fus_95,
     &             massl,massh,500)
         n100wano=A1999_Hnn_normsh(A2016_HNN_WANO_fus_100,
     &             massl,massh,500)
         n105wano=A1999_Hnn_normsh(A2016_HNN_WANO_fus_105,
     &             massl,massh,500)
         n107wano=A1999_Hnn_normsh(A2016_HNN_WANO_fus_107,
     &             massl,massh,500)
         n110wano=A1999_Hnn_normsh(A2016_HNN_WANO_fus_110,
     &             massl,massh,500)
         n115wano=A1999_Hnn_normsh(A2016_HNN_WANO_fus_115,
     &             massl,massh,500)
         n120wano=A1999_Hnn_normsh(A2016_HNN_WANO_fus_120,
     &             massl,massh,500)
         n60nwao=A1999_Hnn_normsh(A2016_HNN_NWAO_fus_60,
     &             massl,massh,500)
         n65nwao=A1999_Hnn_normsh(A2016_HNN_NWAO_fus_65,
     &             massl,massh,500)
         n70nwao=A1999_Hnn_normsh(A2016_HNN_NWAO_fus_70,
     &             massl,massh,500)
         n75nwao=A1999_Hnn_normsh(A2016_HNN_NWAO_fus_75,
     &             massl,massh,500)
         n80nwao=A1999_Hnn_normsh(A2016_HNN_NWAO_fus_80,
     &             massl,massh,500)
         n85nwao=A1999_Hnn_normsh(A2016_HNN_NWAO_fus_85,
     &             massl,massh,500)
         n90nwao=A1999_Hnn_normsh(A2016_HNN_NWAO_fus_90,
     &             massl,massh,500)
         n95nwao=A1999_Hnn_normsh(A2016_HNN_NWAO_fus_95,
     &             massl,massh,500)
         n100nwao=A1999_Hnn_normsh(A2016_HNN_NWAO_fus_100,
     &             massl,massh,500)
         n105nwao=A1999_Hnn_normsh(A2016_HNN_NWAO_fus_105,
     &             massl,massh,500)
         n107nwao=A1999_Hnn_normsh(A2016_HNN_NWAO_fus_107,
     &             massl,massh,500)
         n110nwao=A1999_Hnn_normsh(A2016_HNN_NWAO_fus_110,
     &             massl,massh,500)
         n115nwao=A1999_Hnn_normsh(A2016_HNN_NWAO_fus_115,
     &             massl,massh,500)
         n120nwao=A1999_Hnn_normsh(A2016_HNN_NWAO_fus_120,
     &             massl,massh,500)
         first = .false.
      endif


*------------------------------------
* find position
* =============
      if    ( hmass.lt.masst(1   ) ) then
          i1 = 1
          i2 = 1
          d1 = 0.0
          d2 = 1.0
      elseif( hmass.ge.masst(mpnt) ) then
          i1 = mpnt
          i2 = mpnt
          d1 = 1.0
          d2 = 0.0
      else
          do i = 1, mpnt-1
          if( hmass.ge.masst(i) .and. hmass.lt.masst(i+1) ) then
          i1 = i
          i2 = i + 1
          endif
          enddo
          d  = masst(i2) - masst(i1)
          d1 = (hmass - masst(i1))/d
          d2 = (masst(i2) - hmass)/d
      endif
      c1 = corpk(iana,i1)
      c2 = corpk(iana,i2)
      c  = c1*d2 + c2*d1

* very painful procedure to get function values
* =============================================
      if(hmass.le.75.0) then
         if (x.ge.c) then
            p1 = x - c + corpk(iana,i1)
            p2 = x - c + corpk(iana,i2)
         else
            p1 = corpk(iana,i1)-(c-x)/(c-massl)*(corpk(iana,i1)-massl)
            p2 = corpk(iana,i2)-(c-x)/(c-massl)*(corpk(iana,i2)-massl)
         endif
      elseif(hmass.ge.massh) then
         if (x.le.c) then
            p1 = x - c + corpk(iana,i1)
            p2 = x - c + corpk(iana,i2)
         else
            p1 = corpk(iana,i1)+(x-c)/(massh-c)*(massh-corpk(iana,i1))
            p2 = corpk(iana,i2)+(x-c)/(massh-c)*(massh-corpk(iana,i2))
         endif
      else
         p1 = x - c + corpk(iana,i1)
         p2 = x - c + corpk(iana,i2)
      endif
      if( iana.eq.1 ) then
          if( i1.eq.1 ) then
              f1 = A2016_HNN_WAO_FUS_60(p1)
              n1 = n60wao
          elseif( i1.eq.2 ) then
              f1 = A2016_HNN_WAO_FUS_65(p1)
              n1 = n65wao
          elseif( i1.eq.3 ) then
              f1 = A2016_HNN_WAO_FUS_70(p1)
              n1 = n70wao
          elseif( i1.eq.4 ) then
              f1 = A2016_HNN_WAO_FUS_75(p1)
              n1 = n75wao
          elseif( i1.eq.5 ) then
              f1 = A2016_HNN_WAO_FUS_80(p1)
              n1 = n80wao
          elseif( i1.eq.6 ) then
              f1 = A2016_HNN_WAO_FUS_85(p1)
              n1 = n85wao
          elseif( i1.eq.7 ) then
              f1 = A2016_HNN_WAO_FUS_90(p1)
              n1 = n90wao
          elseif( i1.eq.8 ) then
              f1 = A2016_HNN_WAO_FUS_95(p1)
              n1 = n95wao
          elseif( i1.eq.9 ) then
              f1 = A2016_HNN_WAO_FUS_100(p1)
              n1 = n100wao
          elseif( i1.eq.10 ) then
              f1 = A2016_HNN_WAO_FUS_105(p1)
              n1 = n105wao
          elseif( i1.eq.11 ) then
              f1 = A2016_HNN_WAO_FUS_107(p1)
              n1 = n107wao
          elseif( i1.eq.12 ) then
              f1 = A2016_HNN_WAO_FUS_110(p1)
              n1 = n110wao
          elseif( i1.eq.13 ) then
              f1 = A2016_HNN_WAO_FUS_115(p1)
              n1 = n115wao
          elseif( i1.eq.14 ) then
              f1 = A2016_HNN_WAO_FUS_120(p1)
              n1 = n120wao
          endif
          if( i2.eq.1 ) then
              f2 = A2016_HNN_WAO_FUS_60(p2)
              n2 = n60wao
          elseif( i2.eq.2 ) then
              f2 = A2016_HNN_WAO_FUS_65(p2)
              n2 = n65wao
          elseif( i2.eq.3 ) then
              f2 = A2016_HNN_WAO_FUS_70(p2)
              n2 = n70wao
          elseif( i2.eq.4 ) then
              f2 = A2016_HNN_WAO_FUS_75(p2)
              n2 = n75wao
          elseif( i2.eq.5 ) then
              f2 = A2016_HNN_WAO_FUS_80(p2)
              n2 = n80wao
          elseif( i2.eq.6 ) then
              f2 = A2016_HNN_WAO_FUS_85(p2)
              n2 = n85wao
          elseif( i2.eq.7 ) then
              f2 = A2016_HNN_WAO_FUS_90(p2)
              n2 = n90wao
          elseif( i2.eq.8 ) then
              f2 = A2016_HNN_WAO_FUS_95(p2)
              n2 = n95wao
          elseif( i2.eq.9 ) then
              f2 = A2016_HNN_WAO_FUS_100(p2)
              n2 = n100wao
          elseif( i2.eq.10 ) then
              f2 = A2016_HNN_WAO_FUS_105(p2)
              n2 = n105wao
          elseif( i2.eq.11 ) then
              f2 = A2016_HNN_WAO_FUS_107(p2)
              n2 = n107wao
          elseif( i2.eq.12 ) then
              f2 = A2016_HNN_WAO_FUS_110(p2)
              n2 = n110wao
          elseif( i2.eq.13 ) then
              f2 = A2016_HNN_WAO_FUS_115(p2)
              n2 = n115wao
          elseif( i2.eq.14 ) then
              f2 = A2016_HNN_WAO_FUS_120(p2)
              n2 = n120wao
          endif

      elseif( iana.eq.2 ) then
          if( i1.eq.1 ) then
              f1 = A2016_HNN_WANO_FUS_60(p1)
              n1 = n60wano
          elseif( i1.eq.2 ) then
              f1 = A2016_HNN_WANO_FUS_65(p1)
              n1 = n65wano
          elseif( i1.eq.3 ) then
              f1 = A2016_HNN_WANO_FUS_70(p1)
              n1 = n70wano
          elseif( i1.eq.4 ) then
              f1 = A2016_HNN_WANO_FUS_75(p1)
              n1 = n75wano
          elseif( i1.eq.5 ) then
              f1 = A2016_HNN_WANO_FUS_80(p1)
              n1 = n80wano
          elseif( i1.eq.6 ) then
              f1 = A2016_HNN_WANO_FUS_85(p1)
              n1 = n85wano
          elseif( i1.eq.7 ) then
              f1 = A2016_HNN_WANO_FUS_90(p1)
              n1 = n90wano
          elseif( i1.eq.8 ) then
              f1 = A2016_HNN_WANO_FUS_95(p1)
              n1 = n95wano
          elseif( i1.eq.9 ) then
              f1 = A2016_HNN_WANO_FUS_100(p1)
              n1 = n100wano
          elseif( i1.eq.10 ) then
              f1 = A2016_HNN_WANO_FUS_105(p1)
              n1 = n105wano
          elseif( i1.eq.11 ) then
              f1 = A2016_HNN_WANO_FUS_107(p1)
              n1 = n107wano
          elseif( i1.eq.12 ) then
              f1 = A2016_HNN_WANO_FUS_110(p1)
              n1 = n110wano
          elseif( i1.eq.13 ) then
              f1 = A2016_HNN_WANO_FUS_115(p1)
              n1 = n115wano
          elseif( i1.eq.14 ) then
              f1 = A2016_HNN_WANO_FUS_120(p1)
              n1 = n120wano
          endif
          if( i2.eq.1 ) then
              f2 = A2016_HNN_WANO_FUS_60(p2)
              n2 = n60wano
          elseif( i2.eq.2 ) then
              f2 = A2016_HNN_WANO_FUS_65(p2)
              n2 = n65wano
          elseif( i2.eq.3 ) then
              f2 = A2016_HNN_WANO_FUS_70(p2)
              n2 = n70wano
          elseif( i2.eq.4 ) then
              f2 = A2016_HNN_WANO_FUS_75(p2)
              n2 = n75wano
          elseif( i2.eq.5 ) then
              f2 = A2016_HNN_WANO_FUS_80(p2)
              n2 = n80wano
          elseif( i2.eq.6 ) then
              f2 = A2016_HNN_WANO_FUS_85(p2)
              n2 = n85wano
          elseif( i2.eq.7 ) then
              f2 = A2016_HNN_WANO_FUS_90(p2)
              n2 = n90wano
          elseif( i2.eq.8 ) then
              f2 = A2016_HNN_WANO_FUS_95(p2)
              n2 = n95wano
          elseif( i2.eq.9 ) then
              f2 = A2016_HNN_WANO_FUS_100(p2)
              n2 = n100wano
          elseif( i2.eq.10 ) then
              f2 = A2016_HNN_WANO_FUS_105(p2)
              n2 = n105wano
          elseif( i2.eq.11 ) then
              f2 = A2016_HNN_WANO_FUS_107(p2)
              n2 = n107wano
          elseif( i2.eq.12 ) then
              f2 = A2016_HNN_WANO_FUS_110(p2)
              n2 = n110wano
          elseif( i2.eq.13 ) then
              f2 = A2016_HNN_WANO_FUS_115(p2)
              n2 = n115wano
          elseif( i2.eq.14 ) then
              f2 = A2016_HNN_WANO_FUS_120(p2)
              n2 = n120wano
          endif

      elseif( iana.eq.3 ) then
          if( i1.eq.1 ) then
              f1 = A2016_HNN_NWAO_FUS_60(p1)
              n1 = n60nwao
          elseif( i1.eq.2 ) then
              f1 = A2016_HNN_NWAO_FUS_65(p1)
              n1 = n65nwao
          elseif( i1.eq.3 ) then
              f1 = A2016_HNN_NWAO_FUS_70(p1)
              n1 = n70nwao
          elseif( i1.eq.4 ) then
              f1 = A2016_HNN_NWAO_FUS_75(p1)
              n1 = n75nwao
          elseif( i1.eq.5 ) then
              f1 = A2016_HNN_NWAO_FUS_80(p1)
              n1 = n80nwao
          elseif( i1.eq.6 ) then
              f1 = A2016_HNN_NWAO_FUS_85(p1)
              n1 = n85nwao
          elseif( i1.eq.7 ) then
              f1 = A2016_HNN_NWAO_FUS_90(p1)
              n1 = n90nwao
          elseif( i1.eq.8 ) then
              f1 = A2016_HNN_NWAO_FUS_95(p1)
              n1 = n95nwao
          elseif( i1.eq.9 ) then
              f1 = A2016_HNN_NWAO_FUS_100(p1)
              n1 = n100nwao
          elseif( i1.eq.10 ) then
              f1 = A2016_HNN_NWAO_FUS_105(p1)
              n1 = n105nwao
          elseif( i1.eq.11 ) then
              f1 = A2016_HNN_NWAO_FUS_107(p1)
              n1 = n107nwao
          elseif( i1.eq.12 ) then
              f1 = A2016_HNN_NWAO_FUS_110(p1)
              n1 = n110nwao
          elseif( i1.eq.13 ) then
              f1 = A2016_HNN_NWAO_FUS_115(p1)
              n1 = n115nwao
          elseif( i1.eq.14 ) then
              f1 = A2016_HNN_NWAO_FUS_120(p1)
              n1 = n120nwao
          endif
          if( i2.eq.1 ) then
              f2 = A2016_HNN_NWAO_FUS_60(p2)
              n2 = n60nwao
          elseif( i2.eq.2 ) then
              f2 = A2016_HNN_NWAO_FUS_65(p2)
              n2 = n65nwao
          elseif( i2.eq.3 ) then
              f2 = A2016_HNN_NWAO_FUS_70(p2)
              n2 = n70nwao
          elseif( i2.eq.4 ) then
              f2 = A2016_HNN_NWAO_FUS_75(p2)
              n2 = n75nwao
          elseif( i2.eq.5 ) then
              f2 = A2016_HNN_NWAO_FUS_80(p2)
              n2 = n80nwao
          elseif( i2.eq.6 ) then
              f2 = A2016_HNN_NWAO_FUS_85(p2)
              n2 = n85nwao
          elseif( i2.eq.7 ) then
              f2 = A2016_HNN_NWAO_FUS_90(p2)
              n2 = n90nwao
          elseif( i2.eq.8 ) then
              f2 = A2016_HNN_NWAO_FUS_95(p2)
              n2 = n95nwao
          elseif( i2.eq.9 ) then
              f2 = A2016_HNN_NWAO_FUS_100(p2)
              n2 = n100nwao
          elseif( i2.eq.10 ) then
              f2 = A2016_HNN_NWAO_FUS_105(p2)
              n2 = n105nwao
          elseif( i2.eq.11 ) then
              f2 = A2016_HNN_NWAO_FUS_107(p2)
              n2 = n107nwao
          elseif( i2.eq.12 ) then
              f2 = A2016_HNN_NWAO_FUS_110(p2)
              n2 = n110nwao
          elseif( i2.eq.13 ) then
              f2 = A2016_HNN_NWAO_FUS_115(p2)
              n2 = n115nwao
          elseif( i2.eq.14 ) then
              f2 = A2016_HNN_NWAO_FUS_120(p2)
              n2 = n120nwao
          endif
       endif
      f = f1*d2/n1 + f2*d1/n2
      if( f.lt.1.0D-06 ) f = 1.0d-06
      if    ( x.lt.massl .or. x.gt.massh ) then
         f = 0.0d0
      endif

      A2016_hnn_fus_mass_sig = f
      end

      DOUBLE PRECISION Function A2016_HNN_MASS_BKG(x,iana,ibkg)
      Implicit none 
      Integer       iana,ibkg
      Real*8        x,hmass

      Real*8        A2016_HNN_WAO_QQ
     &            , A2016_HNN_WAO_WW
     &            , A2016_HNN_WAO_ZZ
     &            , A2016_HNN_WANO_QQ
     &            , A2016_HNN_WANO_WW
     &            , A2016_HNN_WANO_ZZ
     &            , A2016_HNN_NWAO_QQ
     &            , A2016_HNN_NWAO_WW
     &            , A2016_HNN_NWAO_ZZ
      External      A2016_HNN_WAO_QQ
     &            , A2016_HNN_WAO_WW
     &            , A2016_HNN_WAO_ZZ
     &            , A2016_HNN_WANO_QQ
     &            , A2016_HNN_WANO_WW
     &            , A2016_HNN_WANO_ZZ
     &            , A2016_HNN_NWAO_QQ
     &            , A2016_HNN_NWAO_WW
     &            , A2016_HNN_NWAO_ZZ
*-----------------------------------
      if     (iana.eq.1) then
         if    ( ibkg.eq.1 ) then
            A2016_HNN_MASS_BKG = A2016_HNN_WAO_QQ(x)
         elseif( ibkg.eq.2 ) then
            A2016_HNN_MASS_BKG = A2016_HNN_WAO_WW(x)
         elseif( ibkg.eq.3 ) then
            A2016_HNN_MASS_BKG = A2016_HNN_WAO_ZZ(x)
         endif
      elseif (iana.eq.2) then
         if    ( ibkg.eq.1 ) then
            A2016_HNN_MASS_BKG = A2016_HNN_WANO_QQ(x)
         elseif( ibkg.eq.2 ) then
            A2016_HNN_MASS_BKG = A2016_HNN_WANO_WW(x)
         elseif( ibkg.eq.3 ) then
            A2016_HNN_MASS_BKG = A2016_HNN_WANO_ZZ(x)
         endif
      elseif (iana.eq.3) then
         if    ( ibkg.eq.1 ) then
            A2016_HNN_MASS_BKG = A2016_HNN_NWAO_QQ(x)
         elseif( ibkg.eq.2 ) then
            A2016_HNN_MASS_BKG = A2016_HNN_NWAO_WW(x)
         elseif( ibkg.eq.3 ) then
            A2016_HNN_MASS_BKG = A2016_HNN_NWAO_ZZ(x)
         endif
      else
          write(*,*) 'unknown Hvv channel, stop ', iana
          stop
      endif
      end




      double precision function A2016_HNN_HZ_EFF(hmass,br,iana)
      Implicit none 
      Integer       br,iana
      Real*8        hmass

      Integer       mpnt, ipnt
      Parameter   ( mpnt = 14 )
      Real*8        masst(mpnt)
      real*8        effbband(mpnt),effbbwis(mpnt),effbbors(mpnt)
     &            , eff  (mpnt)
      data        ( masst(ipnt), effbband(ipnt), effbbwis(ipnt)
     &            , effbbors(ipnt), ipnt=1,mpnt)
     &            /  60.0, 0.0053, 0.0540, 0.0089
     &            ,  65.0, 0.0043, 0.0711, 0.0075
     &            ,  70.0, 0.0050, 0.0909, 0.0071
     &            ,  75.0, 0.0111, 0.1261, 0.0083
     &            ,  80.0, 0.0150, 0.1757, 0.0104
     &            ,  85.0, 0.0239, 0.2436, 0.0105
     &            ,  90.0, 0.0558, 0.3135, 0.0168
     &            ,  95.0, 0.1418, 0.3103, 0.0285
     &            , 100.0, 0.3451, 0.1767, 0.0465
     &            , 105.0, 0.4332, 0.1223, 0.0641
     &            , 107.0, 0.4091, 0.1265, 0.0662
     &            , 110.0, 0.3220, 0.1438, 0.0529
     &            , 115.0, 0.2527, 0.1881, 0.0343
     &            , 120.0, 0.1695, 0.2263, 0.0267 /

      Integer       i, i1, i2
      Real*8        d, d1, d2, effmh
      Save
*--------------------
      if (br.eq.1) then
         if(iana.eq.1) then
            do i = 1, mpnt
               eff(i)=effbband(i)
            enddo
         elseif(iana.eq.2) then
            do i = 1, mpnt
               eff(i)=effbbwis(i)
            enddo
         elseif(iana.eq.3) then
            do i = 1, mpnt
               eff(i)=effbbors(i)
            enddo
         else
            do i = 1, mpnt
               eff(i)=0.d0
            enddo
            
         endif
      else
         do i = 1, mpnt
            eff(i)=0.d0
         enddo
      endif
*     interpolations
*     ==============
      if    ( hmass.lt.masst(1   ) ) then
        effmh = 0.
      elseif( hmass.gt.masst(mpnt) ) then
        effmh = 0.
      else
        do i = 1, mpnt-1
           if( hmass.ge.masst(i) .and. hmass.le.masst(i+1) ) then
               i1 = i
               i2 = i + 1
           endif
        enddo
        d1 = hmass - masst(i1)
        d2 = masst(i2) - hmass
        d  = masst(i2) - masst(i1)
        effmh = ( eff(i1)*d2 + eff(i2)*d1 )/d
      endif

      A2016_HNN_HZ_EFF = effmh
      end

      double precision function A2016_HNN_WWF_EFF(hmass,br,iana)
      Implicit none 
      Integer       br,iana
      Real*8        hmass

      Integer       mpnt, ipnt
      Parameter   ( mpnt = 14 )
      Real*8        masst(mpnt)
      real*8        effbband(mpnt),effbbwis(mpnt),effbbors(mpnt)
     &            , eff  (mpnt)
      data        ( masst(ipnt), effbband(ipnt), effbbwis(ipnt)
     &            , effbbors(ipnt), ipnt=1,mpnt)
     &            /  60.0, 0.0054, 0.0502, 0.0129
     &            ,  65.0, 0.0078, 0.0601, 0.0129
     &            ,  70.0, 0.0119, 0.0870, 0.0080
     &            ,  75.0, 0.0130, 0.1263, 0.0109
     &            ,  80.0, 0.0191, 0.1787, 0.0112
     &            ,  85.0, 0.0278, 0.2416, 0.0084
     &            ,  90.0, 0.0446, 0.2842, 0.0180
     &            ,  95.0, 0.0957, 0.3027, 0.0210
     &            , 100.0, 0.2567, 0.2097, 0.0413
     &            , 105.0, 0.3357, 0.1646, 0.0522
     &            , 107.0, 0.3163, 0.1665, 0.0556
     &            , 110.0, 0.2378, 0.1918, 0.0427
     &            , 115.0, 0.1735, 0.2159, 0.0225
     &            , 120.0, 0.1374, 0.1930, 0.0218  /

      Integer       i, i1, i2
      Real*8        d, d1, d2, effmh
      Save
*--------------------
      if (br.eq.1) then
         if(iana.eq.1) then
            do i = 1, mpnt
               eff(i)=effbband(i)
            enddo
         elseif(iana.eq.2) then
            do i = 1, mpnt
               eff(i)=effbbwis(i)
            enddo
         elseif(iana.eq.3) then
            do i = 1, mpnt
               eff(i)=effbbors(i)
            enddo
         else
            do i = 1, mpnt
               eff(i)=0.d0
            enddo
            
         endif
      else
         do i = 1, mpnt
            eff(i)=0.d0
         enddo
      endif
*     interpolations
*     ==============
      if    ( hmass.lt.masst(1   ) ) then
        effmh = 0.
      elseif( hmass.gt.masst(mpnt) ) then
        effmh = 0.
      else
        do i = 1, mpnt-1
           if( hmass.ge.masst(i) .and. hmass.le.masst(i+1) ) then
               i1 = i
               i2 = i + 1
           endif
        enddo
        d1 = hmass - masst(i1)
        d2 = masst(i2) - hmass
        d  = masst(i2) - masst(i1)
        effmh = ( eff(i1)*d2 + eff(i2)*d1 )/d
      endif

      A2016_HNN_WWF_EFF = effmh
      end


      double precision function A1999_Hnn_normsh(func,min,max,npts)
      implicit none	
      real*8 min,max,sum
      integer i,npts
      real*8 x,y
      real*8 func
      external func
      sum=0.d0
      x=0.d0
      y=0.d0
c	write (6,*)  'a1999_hnn_normsh',1
      do i = 1, npts
         x=min+dble(i)*(max-min)/npts
c	write (6,*)  'a1999_hnn_normsh i,x',i,x
         y=func(x)
c	write (6,*)  'a1999_hnn_normsh y',y
         sum=sum+y*(max-min)/npts
c	write (6,*)  'a1999_hnn_normsh sum',sum
      enddo
c	write (6,*)  'a1999_hnn_normsh outofloop'
      A1999_Hnn_normsh = sum
      end
      DOUBLE PRECISION FUNCTION A1916_hnn_nwao_fus_100(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  2.9583832E-11,   3.5412492E-11
     +,   4.2337422E-11,   5.0554564E-11,   6.0292271E-11
     +,   7.1817177E-11,   8.5440210E-11,   1.0152271E-10
     +,   1.2048486E-10,   1.4281275E-10,   1.6907091E-10
     +,   1.9991178E-10,   2.3608870E-10,   2.7847100E-10
     +,   3.2806094E-10,   3.8600706E-10,   4.5363274E-10
     +,   5.3245364E-10,   6.2420558E-10,   7.3087686E-10
     +,   8.5472857E-10,   9.9834740E-10,   1.1646740E-09
     +,   1.3570521E-09,   1.5792845E-09,   1.8356621E-09
     +,   2.1310580E-09,   2.4709759E-09,   2.8616334E-09
     +,   3.3100069E-09,   3.8239780E-09,   4.4123807E-09
     +,   5.0851336E-09,   5.8533405E-09,   6.7294459E-09
     +,   7.7272597E-09,   8.8622683E-09,   1.0151658E-08
     +,   1.1614562E-08,   1.3272214E-08,   1.5148055E-08
     +,   1.7268095E-08,   1.9661051E-08,   2.2358577E-08
     +,   2.5395478E-08,   2.8810190E-08,   3.2644497E-08
     +,   3.6944542E-08,   4.1760742E-08,   4.7147864E-08
     +,   5.3165895E-08,   5.9880016E-08,   6.7361036E-08
     +,   7.5685719E-08,   8.4937248E-08,   9.5205408E-08
     +,   1.0658735E-07,   1.1918695E-07,   1.3311659E-07
     +,   1.4849695E-07,   1.6545633E-07,   1.8413267E-07
     +,   2.0467290E-07,   2.2723367E-07,   2.5198122E-07
     +,   2.7909169E-07,   3.0875296E-07,   3.4116030E-07
     +,   3.7652254E-07,   4.1505822E-07,   4.5699761E-07
     +,   5.0257927E-07,   5.5205459E-07,   6.0568539E-07
     +,   6.6374332E-07,   7.2651090E-07,   7.9428025E-07
     +,   8.6735025E-07,   9.4603109E-07,   1.0306402E-06
     +,   1.1215022E-06,   1.2189506E-06,   1.3233163E-06
     +,   1.4349425E-06,   1.5541714E-06,   1.6813483E-06
     +,   1.8168183E-06,   1.9609238E-06,   2.1140058E-06
     +,   2.2764066E-06,   2.4484393E-06,   2.6304308E-06
     +,   2.8226898E-06,   3.0255108E-06,   3.2391729E-06
     +,   3.4639377E-06,   3.7000589E-06,   3.9477318E-06
     +,   4.2071624E-06,   4.4785143E-06,   4.7619246E-06
     +,   5.0574959E-06,   5.3652952E-06,   5.6853560E-06
     +,   6.0176653E-06,   6.3621733E-06,   6.7187843E-06
     +,   7.0873566E-06,   7.4677027E-06,   7.8595813E-06
     +,   8.2627030E-06,   8.6767459E-06,   9.1012753E-06
     +,   9.5358619E-06,   9.9799990E-06,   1.0433129E-05
     +,   1.0894640E-05,   1.1363861E-05,   1.1840093E-05
     +,   1.2322520E-05,   1.2810337E-05,   1.3302665E-05
     +,   1.3798586E-05,   1.4297128E-05,   1.4797281E-05
     +,   1.5297994E-05,   1.5798172E-05,   1.6296708E-05
     +,   1.6792443E-05,   1.7284203E-05,   1.7770793E-05
     +,   1.8251027E-05,   1.8723636E-05,   1.9187417E-05
     +,   1.9641144E-05,   2.0083588E-05,   2.0513542E-05
     +,   2.0929805E-05,   2.1331209E-05,   2.1716625E-05
     +,   2.2084905E-05,   2.2434999E-05,   2.2765884E-05
     +,   2.3076595E-05,   2.3366223E-05,   2.3633937E-05
     +,   2.3878974E-05,   2.4100667E-05,   2.4298435E-05
     +,   2.4471810E-05,   2.4620447E-05,   2.4744124E-05
     +,   2.4842760E-05,   2.4916450E-05,   2.4965466E-05
     +,   2.4990279E-05,   2.4991579E-05,   2.4970313E-05
     +,   2.4927704E-05,   2.4865270E-05,   2.4784880E-05
     +,   2.4688750E-05,   2.4579527E-05,   2.4460283E-05
     +,   2.4334560E-05,   2.4206422E-05,   2.4080473E-05
     +,   2.3961895E-05,   2.3856506E-05,   2.3770761E-05
     +,   2.3711807E-05,   2.3687528E-05,   2.3706558E-05
     +,   2.3778366E-05,   2.3913257E-05,   2.4122495E-05
     +,   2.4418341E-05,   2.4814170E-05,   2.5324620E-05
     +,   2.5965763E-05,   2.6755188E-05,   2.7712666E-05
     +,   2.8859975E-05,   3.0221863E-05,   3.1826388E-05
     +,   3.3705779E-05,   3.5897334E-05,   3.8444625E-05
     +,   4.1398816E-05,   4.4820245E-05,   4.8780170E-05
     +,   5.3362626E-05,   5.8666406E-05,   6.4805427E-05
     +,   7.1912691E-05,   8.0136371E-05,   8.9644207E-05
     +,   1.0061626E-04,   1.1324248E-04,   1.2772034E-04
     +,   1.4423777E-04,   1.6297246E-04,   1.8406748E-04
     +,   2.0762425E-04,   2.3368161E-04,   2.6219949E-04
     +,   2.9304228E-04,   3.2596430E-04,   3.6059969E-04
     +,   3.9645837E-04,   4.3292899E-04,   4.6929321E-04
     +,   5.0475053E-04,   5.3845643E-04,   5.6957308E-04
     +,   5.9732370E-04,   6.2107516E-04,   6.4038980E-04
     +,   6.5510487E-04,   6.6537957E-04,   6.7172659E-04
     +,   6.7502103E-04,   6.7646778E-04,   6.7754160E-04
     +,   6.7989051E-04,   6.8521261E-04,   6.9511682E-04
     +,   7.1097660E-04,   7.3380105E-04,   7.6413265E-04
     +,   8.0199901E-04,   8.4692583E-04,   8.9801650E-04
     +,   9.5409382E-04,   1.0138652E-03,   1.0760840E-03
     +,   1.1396526E-03,   1.2036324E-03,   1.2672014E-03
     +,   1.3295509E-03,   1.3898520E-03,   1.4473438E-03
     +,   1.5015800E-03,   1.5528142E-03,   1.6023219E-03
     +,   1.6525133E-03,   1.7066441E-03,   1.7681009E-03
     +,   1.8393988E-03,   1.9211661E-03,   2.0114530E-03
     +,   2.1055993E-03,   2.1967448E-03,   2.2768897E-03
     +,   2.3382739E-03,   2.3748232E-03,   2.3833560E-03
     +,   2.3642939E-03,   2.3216559E-03,   2.2622673E-03
     +,   2.1943464E-03,   2.1259214E-03,   2.0635831E-03
     +,   2.0120249E-03,   1.9743550E-03,   1.9528666E-03
     +,   1.9496627E-03,   1.9666206E-03,   2.0046239E-03
     +,   2.0623878E-03,   2.1354936E-03,   2.2161931E-03
     +,   2.2942144E-03,   2.3583607E-03,   2.3984043E-03
     +,   2.4066975E-03,   2.3791152E-03,   2.3152221E-03
     +,   2.2178220E-03,   2.0921093E-03,   1.9447408E-03
     +,   1.7829665E-03,   1.6138847E-03,   1.4439201E-03
     +,   1.2783938E-03,   1.1213437E-03,   9.7547850E-04
     +,   8.4228319E-04,   7.2223431E-04,   6.1507517E-04
     +,   5.2009709E-04,   4.3638074E-04,   3.6297206E-04
     +,   2.9898138E-04,   2.4361527E-04,   1.9616279E-04
     +,   1.5595961E-04,   1.2234990E-04,   9.4669660E-05
     +,   7.2226379E-05,   5.4327000E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_nwao_fus_100 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_nwao_fus_105(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  7.0400019E-09,   8.0176878E-09
     +,   9.1207726E-09,   1.0363856E-08,   1.1762932E-08
     +,   1.3335709E-08,   1.5101584E-08,   1.7081865E-08
     +,   1.9299883E-08,   2.1781068E-08,   2.4553282E-08
     +,   2.7646873E-08,   3.1094846E-08,   3.4933080E-08
     +,   3.9200575E-08,   4.3939277E-08,   4.9194806E-08
     +,   5.5016358E-08,   6.1456866E-08,   6.8573428E-08
     +,   7.6426922E-08,   8.5082988E-08,   9.4611785E-08
     +,   1.0508813E-07,   1.1659210E-07,   1.2920809E-07
     +,   1.4302640E-07,   1.5814257E-07,   1.7465790E-07
     +,   1.9267829E-07,   2.1231624E-07,   2.3368973E-07
     +,   2.5692259E-07,   2.8214393E-07,   3.0948965E-07
     +,   3.3909913E-07,   3.7111892E-07,   4.0570063E-07
     +,   4.4300054E-07,   4.8318066E-07,   5.2640513E-07
     +,   5.7284439E-07,   6.2267185E-07,   6.7606391E-07
     +,   7.3319973E-07,   7.9426178E-07,   8.5942935E-07
     +,   9.2888655E-07,   1.0028180E-06,   1.0814006E-06
     +,   1.1648153E-06,   1.2532382E-06,   1.3468407E-06
     +,   1.4457889E-06,   1.5502416E-06,   1.6603512E-06
     +,   1.7762628E-06,   1.8981031E-06,   2.0259954E-06
     +,   2.1600490E-06,   2.3003515E-06,   2.4469819E-06
     +,   2.6000000E-06,   2.7594465E-06,   2.9253417E-06
     +,   3.0976846E-06,   3.2764563E-06,   3.4616005E-06
     +,   3.6530496E-06,   3.8507051E-06,   4.0544442E-06
     +,   4.2641059E-06,   4.4795111E-06,   4.7004482E-06
     +,   4.9266746E-06,   5.1579186E-06,   5.3938838E-06
     +,   5.6342255E-06,   5.8785859E-06,   6.1265719E-06
     +,   6.3777607E-06,   6.6317070E-06,   6.8879176E-06
     +,   7.1458944E-06,   7.4051059E-06,   7.6649967E-06
     +,   7.9249885E-06,   8.1844855E-06,   8.4428702E-06
     +,   8.6995224E-06,   8.9537753E-06,   9.2049813E-06
     +,   9.4524794E-06,   9.6955964E-06,   9.9336621E-06
     +,   1.0166006E-05,   1.0391968E-05,   1.0610867E-05
     +,   1.0822063E-05,   1.1024918E-05,   1.1218812E-05
     +,   1.1403144E-05,   1.1577334E-05,   1.1740834E-05
     +,   1.1893117E-05,   1.2033695E-05,   1.2162111E-05
     +,   1.2277948E-05,   1.2380828E-05,   1.2470417E-05
     +,   1.2546420E-05,   1.2608598E-05,   1.2656748E-05
     +,   1.2690733E-05,   1.2710453E-05,   1.2715872E-05
     +,   1.2707003E-05,   1.2683916E-05,   1.2646730E-05
     +,   1.2595637E-05,   1.2530870E-05,   1.2452729E-05
     +,   1.2361567E-05,   1.2257803E-05,   1.2141910E-05
     +,   1.2014419E-05,   1.1875926E-05,   1.1727089E-05
     +,   1.1568624E-05,   1.1401309E-05,   1.1225990E-05
     +,   1.1043570E-05,   1.0855041E-05,   1.0661436E-05
     +,   1.0463880E-05,   1.0263557E-05,   1.0061738E-05
     +,   9.8597693E-06,   9.6590802E-06,   9.4611760E-06
     +,   9.2676846E-06,   9.0802987E-06,   8.9008163E-06
     +,   8.7311419E-06,   8.5732863E-06,   8.4293688E-06
     +,   8.3016275E-06,   8.1924145E-06,   8.1042026E-06
     +,   8.0395939E-06,   8.0013069E-06,   7.9921874E-06
     +,   8.0152086E-06,   8.0734617E-06,   8.1701537E-06
     +,   8.3086097E-06,   8.4922531E-06,   8.7246044E-06
     +,   9.0092681E-06,   9.3499093E-06,   9.7502461E-06
     +,   1.0214040E-05,   1.0744983E-05,   1.1346804E-05
     +,   1.2023127E-05,   1.2777480E-05,   1.3613215E-05
     +,   1.4533483E-05,   1.5541149E-05,   1.6638740E-05
     +,   1.7828361E-05,   1.9111620E-05,   2.0489530E-05
     +,   2.1962489E-05,   2.3529923E-05,   2.5190557E-05
     +,   2.6942078E-05,   2.8781094E-05,   3.0703035E-05
     +,   3.2702184E-05,   3.4771154E-05,   3.6901882E-05
     +,   3.9084331E-05,   4.1307605E-05,   4.3559608E-05
     +,   4.5827404E-05,   4.8097500E-05,   5.0356437E-05
     +,   5.2591360E-05,   5.4791020E-05,   5.6946865E-05
     +,   5.9054506E-05,   6.1115679E-05,   6.3139989E-05
     +,   6.5148590E-05,   6.7176115E-05,   6.9275688E-05
     +,   7.1522161E-05,   7.4017189E-05,   7.6895383E-05
     +,   8.0327969E-05,   8.4530264E-05,   8.9764057E-05
     +,   9.6342461E-05,   1.0462957E-04,   1.1503684E-04
     +,   1.2801398E-04,   1.4403232E-04,   1.6355976E-04
     +,   1.8702676E-04,   2.1478494E-04,   2.4705980E-04
     +,   2.8390414E-04,   3.2515844E-04,   3.7042936E-04
     +,   4.1908087E-04,   4.7029188E-04,   5.2309426E-04
     +,   5.7649805E-04,   6.2960002E-04,   6.8169186E-04
     +,   7.3237490E-04,   7.8156381E-04,   8.2947890E-04
     +,   8.7652425E-04,   9.2312775E-04,   9.6955773E-04
     +,   1.0157689E-03,   1.0613385E-03,   1.1055121E-03
     +,   1.1473839E-03,   1.1861557E-03,   1.2214204E-03
     +,   1.2533691E-03,   1.2828403E-03,   1.3111706E-03
     +,   1.3398563E-03,   1.3701040E-03,   1.4024134E-03
     +,   1.4363027E-03,   1.4703070E-03,   1.5022705E-03
     +,   1.5298805E-03,   1.5513292E-03,   1.5659143E-03
     +,   1.5744130E-03,   1.5791131E-03,   1.5834307E-03
     +,   1.5911720E-03,   1.6055892E-03,   1.6284497E-03
     +,   1.6594365E-03,   1.6960965E-03,   1.7344818E-03
     +,   1.7703496E-03,   1.8005902E-03,   1.8243658E-03
     +,   1.8435230E-03,   1.8620617E-03,   1.8848290E-03
     +,   1.9159161E-03,   1.9573788E-03,   2.0087501E-03
     +,   2.0674593E-03,   2.1299177E-03,   2.1926933E-03
     +,   2.2533026E-03,   2.3102853E-03,   2.3626755E-03
     +,   2.4092037E-03,   2.4476992E-03,   2.4749781E-03
     +,   2.4872476E-03,   2.4808107E-03,   2.4527428E-03
     +,   2.4013571E-03,   2.3263793E-03,   2.2289264E-03
     +,   2.1114289E-03,   1.9774432E-03,   1.8314273E-03
     +,   1.6783390E-03,   1.5230848E-03,   1.3699788E-03
     +,   1.2222542E-03,   1.0819123E-03,   9.4984483E-04
     +,   8.2619616E-04,   7.1081036E-04,   6.0360978E-04
     +,   5.0479482E-04,   4.1484740E-04,   3.3438276E-04
     +,   2.6393592E-04,   2.0376539E-04,   1.5373471E-04
     +,   1.1328953E-04,   8.1518097E-05,   5.7272508E-05
     +,   3.9288112E-05,   2.6319829E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_nwao_fus_105 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_nwao_fus_110(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  1.2652241E-13,   1.5879851E-13
     +,   1.9903023E-13,   2.4910762E-13,   3.1134798E-13
     +,   3.8859638E-13,   4.8433414E-13,   6.0281538E-13
     +,   7.4923780E-13,   9.2992118E-13,   1.1525673E-12
     +,   1.4265273E-12,   1.7631377E-12,   2.1761384E-12
     +,   2.6821462E-12,   3.3011766E-12,   4.0574120E-12
     +,   4.9799336E-12,   6.1036610E-12,   7.4705632E-12
     +,   9.1307621E-12,   1.1144353E-11,   1.3582991E-11
     +,   1.6532163E-11,   2.0093704E-11,   2.4388252E-11
     +,   2.9559417E-11,   3.5776927E-11,   4.3242101E-11
     +,   5.2191772E-11,   6.2905722E-11,   7.5713248E-11
     +,   9.1001151E-11,   1.0922336E-10,   1.3091200E-10
     +,   1.5668758E-10,   1.8727668E-10,   2.2352502E-10
     +,   2.6641686E-10,   3.1709710E-10,   3.7689010E-10
     +,   4.4733298E-10,   5.3020072E-10,   6.2754218E-10
     +,   7.4171863E-10,   8.7544877E-10,   1.0318426E-09
     +,   1.2144797E-09,   1.4274535E-09,   1.6754258E-09
     +,   1.9637296E-09,   2.2984330E-09,   2.6864306E-09
     +,   3.1355425E-09,   3.6546259E-09,   4.2537032E-09
     +,   4.9440811E-09,   5.7384733E-09,   6.6512120E-09
     +,   7.6983859E-09,   8.8979633E-09,   1.0270115E-08
     +,   1.1837306E-08,   1.3624618E-08,   1.5659900E-08
     +,   1.7974097E-08,   2.0601556E-08,   2.3580057E-08
     +,   2.6951520E-08,   3.0762042E-08,   3.5062399E-08
     +,   3.9908038E-08,   4.5359926E-08,   5.1484680E-08
     +,   5.8354839E-08,   6.6049445E-08,   7.4654565E-08
     +,   8.4262737E-08,   9.4974773E-08,   1.0689912E-07
     +,   1.2015282E-07,   1.3486149E-07,   1.5115917E-07
     +,   1.6918980E-07,   1.8910694E-07,   2.1107383E-07
     +,   2.3526363E-07,   2.6185961E-07,   2.9105553E-07
     +,   3.2305664E-07,   3.5807415E-07,   3.9633372E-07
     +,   4.3806898E-07,   4.8352365E-07,   5.3295031E-07
     +,   5.8660976E-07,   6.4477422E-07,   7.0771426E-07
     +,   7.7571525E-07,   8.4906480E-07,   9.2805465E-07
     +,   1.0129795E-06,   1.1041359E-06,   1.2018187E-06
     +,   1.3063232E-06,   1.4179394E-06,   1.5369527E-06
     +,   1.6636408E-06,   1.7982709E-06,   1.9411007E-06
     +,   2.0923715E-06,   2.2523179E-06,   2.4211333E-06
     +,   2.5990123E-06,   2.7861186E-06,   2.9825933E-06
     +,   3.1885493E-06,   3.4040718E-06,   3.6292254E-06
     +,   3.8640137E-06,   4.1084377E-06,   4.3624564E-06
     +,   4.6259961E-06,   4.8989477E-06,   5.1811735E-06
     +,   5.4725024E-06,   5.7727343E-06,   6.0816446E-06
     +,   6.3989833E-06,   6.7244814E-06,   7.0578540E-06
     +,   7.3988235E-06,   7.7470595E-06,   8.1022827E-06
     +,   8.4642033E-06,   8.8325542E-06,   9.2070923E-06
     +,   9.5876067E-06,   9.9739391E-06,   1.0365990E-05
     +,   1.0763685E-05,   1.1167073E-05,   1.1576267E-05
     +,   1.1991485E-05,   1.2413043E-05,   1.2841389E-05
     +,   1.3277088E-05,   1.3720854E-05,   1.4173549E-05
     +,   1.4636190E-05,   1.5109971E-05,   1.5596290E-05
     +,   1.6096661E-05,   1.6612861E-05,   1.7146855E-05
     +,   1.7700821E-05,   1.8277149E-05,   1.8878458E-05
     +,   1.9507595E-05,   2.0167638E-05,   2.0861897E-05
     +,   2.1593944E-05,   2.2367472E-05,   2.3186491E-05
     +,   2.4055169E-05,   2.4977868E-05,   2.5959065E-05
     +,   2.7003376E-05,   2.8115466E-05,   2.9299998E-05
     +,   3.0561569E-05,   3.1904634E-05,   3.3333403E-05
     +,   3.4851819E-05,   3.6463160E-05,   3.8170376E-05
     +,   3.9975654E-05,   4.1880478E-05,   4.3885473E-05
     +,   4.5990524E-05,   4.8194281E-05,   5.0495313E-05
     +,   5.2890846E-05,   5.5378194E-05,   5.7954494E-05
     +,   6.0617371E-05,   6.3365507E-05,   6.6199333E-05
     +,   6.9121983E-05,   7.2140050E-05,   7.5264761E-05
     +,   7.8512909E-05,   8.1908001E-05,   8.5480213E-05
     +,   8.9268906E-05,   9.3320290E-05,   9.7690143E-05
     +,   1.0244067E-04,   1.0764016E-04,   1.1336274E-04
     +,   1.1968248E-04,   1.2667455E-04,   1.3440737E-04
     +,   1.4294214E-04,   1.5232750E-04,   1.6259594E-04
     +,   1.7376081E-04,   1.8581359E-04,   1.9872277E-04
     +,   2.1243322E-04,   2.2686744E-04,   2.4192815E-04
     +,   2.5750196E-04,   2.7346442E-04,   2.8968774E-04
     +,   3.0604433E-04,   3.2242489E-04,   3.3873855E-04
     +,   3.5493347E-04,   3.7100856E-04,   3.8702649E-04
     +,   4.0313805E-04,   4.1958943E-04,   4.3674518E-04
     +,   4.5509572E-04,   4.7526165E-04,   4.9798511E-04
     +,   5.2410358E-04,   5.5449730E-04,   5.9000670E-04
     +,   6.3131656E-04,   6.7881058E-04,   7.3241361E-04
     +,   7.9144817E-04,   8.5454341E-04,   9.1963744E-04
     +,   9.8410668E-04,   1.0450148E-03,   1.0995042E-03
     +,   1.1452088E-03,   1.1806516E-03,   1.2055200E-03
     +,   1.2207302E-03,   1.2282797E-03,   1.2308775E-03
     +,   1.2314615E-03,   1.2327073E-03,   1.2366493E-03
     +,   1.2444984E-03,   1.2566725E-03,   1.2729915E-03
     +,   1.2929492E-03,   1.3159582E-03,   1.3415141E-03
     +,   1.3692682E-03,   1.3990352E-03,   1.4308107E-03
     +,   1.4648011E-03,   1.5014594E-03,   1.5414781E-03
     +,   1.5856574E-03,   1.6346318E-03,   1.6885065E-03
     +,   1.7464904E-03,   1.8066921E-03,   1.8661226E-03
     +,   1.9209457E-03,   1.9669000E-03,   1.9997805E-03
     +,   2.0158796E-03,   2.0123636E-03,   1.9875565E-03
     +,   1.9411605E-03,   1.8743797E-03,   1.7898803E-03
     +,   1.6915448E-03,   1.5839956E-03,   1.4719607E-03
     +,   1.3596658E-03,   1.2503216E-03,   1.1459336E-03
     +,   1.0473670E-03,   9.5463137E-04,   8.6727075E-04
     +,   7.8468834E-04,   7.0640218E-04,   6.3214713E-04
     +,   5.6187651E-04,   4.9569993E-04,   4.3380336E-04
     +,   3.7638014E-04,   3.2358564E-04,   2.7551348E-04
     +,   2.3218807E-04,   1.9356434E-04,   1.5953029E-04
     +,   1.2991054E-04,   1.0446968E-04,   8.2923638E-05
     +,   6.4937492E-05,   5.0151273E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_nwao_fus_110 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_nwao_fus_115(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  8.4372158E-18,   1.1632692E-17
     +,   1.6009129E-17,   2.1992011E-17,   3.0155356E-17
     +,   4.1273417E-17,   5.6387612E-17,   7.6895788E-17
     +,   1.0467196E-16,   1.4222074E-16,   1.9288618E-16
     +,   2.6112287E-16,   3.5285407E-16,   4.7594051E-16
     +,   6.4079371E-16,   8.6116776E-16,   1.1552153E-15
     +,   1.5468400E-15,   2.0674425E-15,   2.7582347E-15
     +,   3.6730881E-15,   4.8824597E-15,   6.4781719E-15
     +,   8.5796958E-15,   1.1342299E-14,   1.4966952E-14
     +,   1.9713879E-14,   2.5918942E-14,   3.4015071E-14
     +,   4.4558297E-14,   5.8262917E-14,   7.6043542E-14
     +,   9.9069251E-14,   1.2883143E-13,   1.6722984E-13
     +,   2.1667500E-13,   2.8022775E-13,   3.6175807E-13
     +,   4.6615733E-13,   5.9959204E-13,   7.6980918E-13
     +,   9.8654277E-13,   1.2619879E-12,   1.6113909E-12
     +,   2.0537760E-12,   2.6128483E-12,   3.3180186E-12
     +,   4.2058080E-12,   5.3214386E-12,   6.7206696E-12
     +,   8.4723235E-12,   1.0661015E-11,   1.3390629E-11
     +,   1.6788421E-11,   2.1009937E-11,   2.6244971E-11
     +,   3.2724722E-11,   4.0729566E-11,   5.0599937E-11
     +,   6.2747842E-11,   7.7669676E-11,   9.5964514E-11
     +,   1.1835206E-10,   1.4569608E-10,   1.7903005E-10
     +,   2.1958871E-10,   2.6884539E-10,   3.2854858E-10
     +,   4.0077716E-10,   4.8799215E-10,   5.9310329E-10
     +,   7.1953560E-10,   8.7132579E-10,   1.0532110E-09
     +,   1.2707384E-09,   1.5303959E-09,   1.8397512E-09
     +,   2.2075941E-09,   2.6441458E-09,   3.1612437E-09
     +,   3.7725640E-09,   4.4938990E-09,   5.3433649E-09
     +,   6.3417995E-09,   7.5130533E-09,   8.8843759E-09
     +,   1.0486812E-08,   1.2355667E-08,   1.4530999E-08
     +,   1.7058234E-08,   1.9988301E-08,   2.3378886E-08
     +,   2.7294698E-08,   3.1808188E-08,   3.7000351E-08
     +,   4.2961474E-08,   4.9792241E-08,   5.7603316E-08
     +,   6.6518083E-08,   7.6672251E-08,   8.8215103E-08
     +,   1.0131041E-07,   1.1613723E-07,   1.3289080E-07
     +,   1.5178362E-07,   1.7304588E-07,   1.9692632E-07
     +,   2.2369318E-07,   2.5363425E-07,   2.8705779E-07
     +,   3.2429259E-07,   3.6569034E-07,   4.1161746E-07
     +,   4.6246672E-07,   5.1864879E-07,   5.8059408E-07
     +,   6.4875127E-07,   7.2358603E-07,   8.0558306E-07
     +,   8.9523036E-07,   9.9303713E-07,   1.0995184E-06
     +,   1.2151946E-06,   1.3405885E-06,   1.4762209E-06
     +,   1.6226077E-06,   1.7802547E-06,   1.9496511E-06
     +,   2.1312683E-06,   2.3255491E-06,   2.5329070E-06
     +,   2.7537276E-06,   2.9883211E-06,   3.2369787E-06
     +,   3.4999250E-06,   3.7773214E-06,   4.0692603E-06
     +,   4.3757582E-06,   4.6967502E-06,   5.0320987E-06
     +,   5.3815311E-06,   5.7447201E-06,   6.1212222E-06
     +,   6.5104914E-06,   6.9118719E-06,   7.3245992E-06
     +,   7.7477989E-06,   8.1804874E-06,   8.6215678E-06
     +,   9.0698404E-06,   9.5240002E-06,   9.9826602E-06
     +,   1.0444281E-05,   1.0907297E-05,   1.1370041E-05
     +,   1.1830775E-05,   1.2287703E-05,   1.2738975E-05
     +,   1.3182706E-05,   1.3616985E-05,   1.4039887E-05
     +,   1.4449512E-05,   1.4843914E-05,   1.5221239E-05
     +,   1.5579655E-05,   1.5917396E-05,   1.6232765E-05
     +,   1.6524156E-05,   1.6790063E-05,   1.7029100E-05
     +,   1.7240007E-05,   1.7421653E-05,   1.7573071E-05
     +,   1.7693445E-05,   1.7782108E-05,   1.7838589E-05
     +,   1.7862574E-05,   1.7853941E-05,   1.7812743E-05
     +,   1.7739210E-05,   1.7633782E-05,   1.7497061E-05
     +,   1.7329887E-05,   1.7133307E-05,   1.6908638E-05
     +,   1.6657550E-05,   1.6382161E-05,   1.6085256E-05
     +,   1.5770584E-05,   1.5443329E-05,   1.5110800E-05
     +,   1.4783419E-05,   1.4476081E-05,   1.4210046E-05
     +,   1.4015197E-05,   1.3933119E-05,   1.4020482E-05
     +,   1.4353001E-05,   1.5029330E-05,   1.6175101E-05
     +,   1.7945171E-05,   2.0525613E-05,   2.4131061E-05
     +,   2.9000634E-05,   3.5388086E-05,   4.3547680E-05
     +,   5.3715263E-05,   6.6085522E-05,   8.0787300E-05
     +,   9.7860036E-05,   1.1723550E-04,   1.3872985E-04
     +,   1.6205163E-04,   1.8683040E-04,   2.1267105E-04
     +,   2.3922509E-04,   2.6630118E-04,   2.9395614E-04
     +,   3.2260953E-04,   3.5311424E-04,   3.8677207E-04
     +,   4.2529573E-04,   4.7063536E-04,   5.2473811E-04
     +,   5.8918766E-04,   6.6479098E-04,   7.5117615E-04
     +,   8.4649428E-04,   9.4734278E-04,   1.0490064E-03
     +,   1.1460538E-03,   1.2332322E-03,   1.3064772E-03
     +,   1.3637671E-03,   1.4055213E-03,   1.4343443E-03
     +,   1.4540933E-03,   1.4685118E-03,   1.4798588E-03
     +,   1.4880110E-03,   1.4904179E-03,   1.4829872E-03
     +,   1.4616709E-03,   1.4242483E-03,   1.3717506E-03
     +,   1.3090661E-03,   1.2445298E-03,   1.1885815E-03
     +,   1.1517954E-03,   1.1427316E-03,   1.1660326E-03
     +,   1.2211634E-03,   1.3020620E-03,   1.3978168E-03
     +,   1.4943373E-03,   1.5767574E-03,   1.6321556E-03
     +,   1.6520325E-03,   1.6339852E-03,   1.5821576E-03
     +,   1.5063150E-03,   1.4197519E-03,   1.3365471E-03
     +,   1.2688582E-03,   1.2248437E-03,   1.2076843E-03
     +,   1.2157197E-03,   1.2434887E-03,   1.2832538E-03
     +,   1.3265675E-03,   1.3655629E-03,   1.3937986E-03
     +,   1.4066753E-03,   1.4015120E-03,   1.3774150E-03
     +,   1.3350388E-03,   1.2762803E-03,   1.2039365E-03
     +,   1.1213491E-03,   1.0320150E-03,   9.3927403E-04
     +,   8.4606081E-04,   7.5476564E-04,   6.6721812E-04
     +,   5.8471086E-04,   5.0810201E-04,   4.3790528E-04
     +,   3.7436836E-04,   3.1753033E-04,   2.6726193E-04
     +,   2.2329635E-04,   1.8525576E-04,   1.5267964E-04
     +,   1.2505273E-04,   1.0183240E-04,   8.2473598E-05
     +,   6.6449822E-05,   5.3268523E-05,   4.2484902E-05
     +,   3.3702134E-05,   2.6579974E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_nwao_fus_115 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_nwao_fus_120(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   2.0379022E-38,   4.7414105E-38,   1.0979706E-37
     +,   2.5306740E-37,   5.8055562E-37,   1.3256343E-36
     +,   3.0127234E-36,   6.8147577E-36,   1.5342889E-35
     +,   3.4381867E-35,   7.6686215E-35,   1.7023968E-34
     +,   3.7615760E-34,   8.2724570E-34,   1.8107761E-33
     +,   3.9450935E-33,   8.5550392E-33,   1.8464490E-32
     +,   3.9665840E-32,   8.4813469E-32,   1.8049643E-31
     +,   3.8232672E-31,   8.0605190E-31,   1.6914216E-30
     +,   3.5326968E-30,   7.3437815E-30,   1.5194874E-29
     +,   3.1292720E-29,   6.4142152E-29,   1.3086073E-28
     +,   2.6573006E-28,   5.3706795E-28,   1.0803807E-27
     +,   2.1631666E-27,   4.3108579E-27,   8.5506606E-27
     +,   1.6881055E-26,   3.3171626E-26,   6.4877055E-26
     +,   1.2629208E-25,   2.4469403E-25,   4.7188870E-25
     +,   9.0575629E-25,   1.7303889E-24,   3.2903467E-24
     +,   6.2273066E-24,   1.1730623E-23,   2.1994247E-23
     +,   4.1044603E-23,   7.6236616E-23,   1.4093920E-22
     +,   2.5933665E-22,   4.7496681E-22,   8.6580445E-22
     +,   1.5708643E-21,   2.8367309E-21,   5.0987247E-21
     +,   9.1214846E-21,   1.6241772E-20,   2.8784712E-20
     +,   5.0776679E-20,   8.9149500E-20,   1.5578806E-19
     +,   2.7096408E-19,   4.6908668E-19,   8.0826904E-19
     +,   1.3861820E-18,   2.3662333E-18,   4.0201879E-18
     +,   6.7982550E-18,   1.1442253E-17,   1.9168457E-17
     +,   3.1961336E-17,   5.3042527E-17,   8.7616631E-17
     +,   1.4404929E-16,   2.3572083E-16,   3.8392494E-16
     +,   6.2238403E-16,   1.0042255E-15,   1.6127503E-15
     +,   2.5778904E-15,   4.1014170E-15,   6.4946374E-15
     +,   1.0236205E-14,   1.6057805E-14,   2.5072333E-14
     +,   3.8964190E-14,   6.0269660E-14,   9.2790257E-14
     +,   1.4218703E-13,   2.1685977E-13,   3.2920099E-13
     +,   4.9739873E-13,   7.4801672E-13,   1.1196426E-12
     +,   1.6680525E-12,   2.4734500E-12,   3.6505508E-12
     +,   5.3625962E-12,   7.8407003E-12,   1.1410284E-11
     +,   1.6527509E-11,   2.3827228E-11,   3.4190192E-11
     +,   4.8830610E-11,   6.9413614E-11,   9.8210842E-11
     +,   1.3830455E-10,   1.9385446E-10,   2.7044819E-10
     +,   3.7553255E-10,   5.1900717E-10,   7.1393963E-10
     +,   9.7748909E-10,   1.3320631E-09,   1.8067582E-09
     +,   2.4391458E-09,   3.2774643E-09,   4.3832920E-09
     +,   5.8347944E-09,   7.7306144E-09,   1.0194605E-08
     +,   1.3380872E-08,   1.7480827E-08,   2.2730216E-08
     +,   2.9417734E-08,   3.7894790E-08,   4.8586465E-08
     +,   6.2003693E-08,   7.8756571E-08,   9.9569156E-08
     +,   1.2529603E-07,   1.5693405E-07,   1.9564607E-07
     +,   2.4277392E-07,   2.9985640E-07,   3.6864526E-07
     +,   4.5112060E-07,   5.4950436E-07,   6.6627058E-07
     +,   8.0415282E-07,   9.6614951E-07,   1.1555218E-06
     +,   1.3758004E-06,   1.6307365E-06,   1.9243414E-06
     +,   2.2608372E-06,   2.6446353E-06,   3.0803158E-06
     +,   3.5726202E-06,   4.1263042E-06,   4.7463795E-06
     +,   5.4377351E-06,   6.2054023E-06,   7.0544152E-06
     +,   7.9898255E-06,   9.0167132E-06,   1.0140191E-05
     +,   1.1365443E-05,   1.2697742E-05,   1.4142497E-05
     +,   1.5705291E-05,   1.7392003E-05,   1.9208448E-05
     +,   2.1161282E-05,   2.3256764E-05,   2.5502151E-05
     +,   2.7904362E-05,   3.0470399E-05,   3.3208002E-05
     +,   3.6123824E-05,   3.9225233E-05,   4.2518161E-05
     +,   4.6008372E-05,   4.9700564E-05,   5.3598407E-05
     +,   5.7704361E-05,   6.2019833E-05,   6.6545283E-05
     +,   7.1280600E-05,   7.6225719E-05,   8.1381440E-05
     +,   8.6750428E-05,   9.2338363E-05,   9.8155564E-05
     +,   1.0421668E-04,   1.1054482E-04,   1.1716786E-04
     +,   1.2412157E-04,   1.3144735E-04,   1.3918885E-04
     +,   1.4739299E-04,   1.5610141E-04,   1.6535066E-04
     +,   1.7516695E-04,   1.8556346E-04,   1.9653916E-04
     +,   2.0807868E-04,   2.2015514E-04,   2.3273478E-04
     +,   2.4578514E-04,   2.5928646E-04,   2.7324754E-04
     +,   2.8772460E-04,   3.0284291E-04,   3.1881500E-04
     +,   3.3595087E-04,   3.5464452E-04,   3.7534087E-04
     +,   3.9846142E-04,   4.2430512E-04,   4.5293738E-04
     +,   4.8408977E-04,   5.1713485E-04,   5.5114535E-04
     +,   5.8508985E-04,   6.1814819E-04,   6.5010309E-04
     +,   6.8170892E-04,   7.1491004E-04,   7.5276161E-04
     +,   7.9895090E-04,   8.5689104E-04,   9.2850067E-04
     +,   1.0129339E-03,   1.1056791E-03,   1.1984841E-03
     +,   1.2804678E-03,   1.3404428E-03,   1.3701040E-03
     +,   1.3671530E-03,   1.3373572E-03,   1.2945858E-03
     +,   1.2584500E-03,   1.2498838E-03,   1.2857768E-03
     +,   1.3741062E-03,   1.5109812E-03,   1.6805204E-03
     +,   1.8577148E-03,   2.0136363E-03,   2.1216981E-03
     +,   2.1633743E-03,   2.1318649E-03,   2.0327477E-03
     +,   1.8815502E-03,   1.6990993E-03,   1.5062162E-03
     +,   1.3194367E-03,   1.1487339E-03,   9.9762098E-04
     +,   8.6489780E-04,   7.4705295E-04,   6.4040523E-04
     +,   5.4236437E-04,   4.5184296E-04,   3.6898075E-04
     +,   2.9456886E-04,   2.2947017E-04,   1.7420787E-04
     +,   1.2877393E-04,   9.2624206E-05,   6.4793101E-05
     +,   4.4059296E-05,   2.9111172E-05,   1.8681527E-05
     +,   1.1639137E-05,   7.0373658E-06,   4.1281587E-06
     +,   2.3484019E-06,   1.2952432E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_nwao_fus_120 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_nwao_fus_60(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  5.2720196E-07,   5.7964019E-07
     +,   6.3662162E-07,   6.9847113E-07,   7.6552669E-07
     +,   8.3814723E-07,   9.1670807E-07,   1.0016014E-06
     +,   1.0932398E-06,   1.1920480E-06,   1.2984742E-06
     +,   1.4129847E-06,   1.5360629E-06,   1.6682111E-06
     +,   1.8099553E-06,   1.9618276E-06,   2.1243904E-06
     +,   2.2982213E-06,   2.4839164E-06,   2.6820937E-06
     +,   2.8933789E-06,   3.1184259E-06,   3.3579024E-06
     +,   3.6124964E-06,   3.8829148E-06,   4.1698672E-06
     +,   4.4740959E-06,   4.7963499E-06,   5.1374068E-06
     +,   5.4980333E-06,   5.8790292E-06,   6.2812064E-06
     +,   6.7053838E-06,   7.1523923E-06,   7.6230863E-06
     +,   8.1182934E-06,   8.6388791E-06,   9.1857091E-06
     +,   9.7596485E-06,   1.0361576E-05,   1.0992336E-05
     +,   1.1652800E-05,   1.2343826E-05,   1.3066263E-05
     +,   1.3820943E-05,   1.4608702E-05,   1.5430303E-05
     +,   1.6286531E-05,   1.7178141E-05,   1.8105808E-05
     +,   1.9070203E-05,   2.0071942E-05,   2.1111586E-05
     +,   2.2189630E-05,   2.3306500E-05,   2.4462555E-05
     +,   2.5658077E-05,   2.6893196E-05,   2.8168002E-05
     +,   2.9482499E-05,   3.0836454E-05,   3.2229633E-05
     +,   3.3661596E-05,   3.5131783E-05,   3.6639482E-05
     +,   3.8183796E-05,   3.9763734E-05,   4.1377982E-05
     +,   4.3025182E-05,   4.4703731E-05,   4.6411882E-05
     +,   4.8147576E-05,   4.9908671E-05,   5.1692787E-05
     +,   5.3497348E-05,   5.5319571E-05,   5.7156532E-05
     +,   5.9004986E-05,   6.0861636E-05,   6.2722967E-05
     +,   6.4585285E-05,   6.6444809E-05,   6.8297486E-05
     +,   7.0139264E-05,   7.1965937E-05,   7.3773226E-05
     +,   7.5556767E-05,   7.7312165E-05,   7.9035002E-05
     +,   8.0720929E-05,   8.2365419E-05,   8.3964202E-05
     +,   8.5513006E-05,   8.7007706E-05,   8.8444271E-05
     +,   8.9818874E-05,   9.1127869E-05,   9.2367700E-05
     +,   9.3535200E-05,   9.4627423E-05,   9.5641684E-05
     +,   9.6575612E-05,   9.7427161E-05,   9.8194592E-05
     +,   9.8876561E-05,   9.9472069E-05,   9.9980447E-05
     +,   1.0040145E-04,   1.0073521E-04,   1.0098219E-04
     +,   1.0114326E-04,   1.0121964E-04,   1.0121294E-04
     +,   1.0112506E-04,   1.0095829E-04,   1.0071515E-04
     +,   1.0039850E-04,   1.0001146E-04,   9.9557386E-05
     +,   9.9039869E-05,   9.8462609E-05,   9.7829528E-05
     +,   9.7144672E-05,   9.6412114E-05,   9.5636031E-05
     +,   9.4820622E-05,   9.3970055E-05,   9.3088500E-05
     +,   9.2179995E-05,   9.1248527E-05,   9.0297937E-05
     +,   8.9331879E-05,   8.8353947E-05,   8.7367414E-05
     +,   8.6375367E-05,   8.5380685E-05,   8.4385960E-05
     +,   8.3393548E-05,   8.2405539E-05,   8.1423736E-05
     +,   8.0449747E-05,   7.9484809E-05,   7.8529949E-05
     +,   7.7585937E-05,   7.6653283E-05,   7.5732285E-05
     +,   7.4823038E-05,   7.3925439E-05,   7.3039220E-05
     +,   7.2163952E-05,   7.1299131E-05,   7.0444097E-05
     +,   6.9598289E-05,   6.8760928E-05,   6.7931374E-05
     +,   6.7108995E-05,   6.6293214E-05,   6.5483560E-05
     +,   6.4679749E-05,   6.3881656E-05,   6.3089312E-05
     +,   6.2303021E-05,   6.1523409E-05,   6.0751321E-05
     +,   5.9987924E-05,   5.9234742E-05,   5.8493661E-05
     +,   5.7766909E-05,   5.7057143E-05,   5.6367360E-05
     +,   5.5700995E-05,   5.5061875E-05,   5.4454184E-05
     +,   5.3882486E-05,   5.3351796E-05,   5.2867385E-05
     +,   5.2434865E-05,   5.2060161E-05,   5.1749437E-05
     +,   5.1509080E-05,   5.1345676E-05,   5.1265870E-05
     +,   5.1276453E-05,   5.1384181E-05,   5.1595758E-05
     +,   5.1917799E-05,   5.2356725E-05,   5.2918731E-05
     +,   5.3609645E-05,   5.4434957E-05,   5.5399640E-05
     +,   5.6508190E-05,   5.7764537E-05,   5.9171703E-05
     +,   6.0732422E-05,   6.2448104E-05,   6.4319916E-05
     +,   6.6347689E-05,   6.8530280E-05,   7.0866176E-05
     +,   7.3352086E-05,   7.5984579E-05,   7.8758458E-05
     +,   8.1667968E-05,   8.4706291E-05,   8.7865614E-05
     +,   9.1137306E-05,   9.4511692E-05,   9.7978424E-05
     +,   1.0152633E-04,   1.0514355E-04,   1.0881764E-04
     +,   1.1253561E-04,   1.1628403E-04,   1.2004932E-04
     +,   1.2381694E-04,   1.2757344E-04,   1.3130414E-04
     +,   1.3499506E-04,   1.3863244E-04,   1.4220207E-04
     +,   1.4569124E-04,   1.4908663E-04,   1.5237588E-04
     +,   1.5554737E-04,   1.5858992E-04,   1.6149317E-04
     +,   1.6424751E-04,   1.6684414E-04,   1.6927510E-04
     +,   1.7153342E-04,   1.7361286E-04,   1.7550820E-04
     +,   1.7721497E-04,   1.7872977E-04,   1.8004987E-04
     +,   1.8117351E-04,   1.8209952E-04,   1.8282776E-04
     +,   1.8335864E-04,   1.8369328E-04,   1.8383343E-04
     +,   1.8378148E-04,   1.8354019E-04,   1.8311304E-04
     +,   1.8250376E-04,   1.8171650E-04,   1.8075583E-04
     +,   1.7962657E-04,   1.7833381E-04,   1.7688291E-04
     +,   1.7527943E-04,   1.7352906E-04,   1.7163763E-04
     +,   1.6961122E-04,   1.6745582E-04,   1.6517771E-04
     +,   1.6278306E-04,   1.6027840E-04,   1.5767007E-04
     +,   1.5496444E-04,   1.5216804E-04,   1.4928727E-04
     +,   1.4632894E-04,   1.4329950E-04,   1.4020549E-04
     +,   1.3705350E-04,   1.3385012E-04,   1.3060182E-04
     +,   1.2731522E-04,   1.2399672E-04,   1.2065273E-04
     +,   1.1728963E-04,   1.1391366E-04,   1.1053097E-04
     +,   1.0714759E-04,   1.0376940E-04,   1.0040203E-04
     +,   9.7051343E-05,   9.3722570E-05,   9.0420923E-05
     +,   8.7151355E-05,   8.3918480E-05,   8.0727092E-05
     +,   7.7581302E-05,   7.4485106E-05,   7.1442220E-05
     +,   6.8456095E-05,   6.5529908E-05,   6.2666535E-05
     +,   5.9868573E-05,   5.7138350E-05,   5.4477903E-05
     +,   5.1888976E-05,   4.9373059E-05,   4.6931371E-05
     +,   4.4564869E-05,   4.2274154E-05,   4.0059997E-05
     +,   3.7922229E-05,   3.5861161E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_nwao_fus_60 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_nwao_fus_65(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  1.8484678E-07,   2.0745469E-07
     +,   2.3250914E-07,   2.6023434E-07,   2.9086877E-07
     +,   3.2466812E-07,   3.6190465E-07,   4.0286804E-07
     +,   4.4786665E-07,   4.9722365E-07,   5.5128470E-07
     +,   6.1041203E-07,   6.7498883E-07,   7.4541600E-07
     +,   8.2211790E-07,   9.0553158E-07,   9.9612066E-07
     +,   1.0943660E-06,   1.2007695E-06,   1.3158550E-06
     +,   1.4401584E-06,   1.5742431E-06,   1.7186902E-06
     +,   1.8740989E-06,   2.0410930E-06,   2.2203035E-06
     +,   2.4123906E-06,   2.6180319E-06,   2.8379275E-06
     +,   3.0727806E-06,   3.3233289E-06,   3.5903252E-06
     +,   3.8745393E-06,   4.1767626E-06,   4.4978106E-06
     +,   4.8385009E-06,   5.1996903E-06,   5.5822511E-06
     +,   5.9870767E-06,   6.4150954E-06,   6.8672225E-06
     +,   7.3444348E-06,   7.8477215E-06,   8.3780933E-06
     +,   8.9365885E-06,   9.5242867E-06,   1.0142251E-05
     +,   1.0791615E-05,   1.1473528E-05,   1.2189128E-05
     +,   1.2939619E-05,   1.3726210E-05,   1.4550124E-05
     +,   1.5412601E-05,   1.6314894E-05,   1.7258255E-05
     +,   1.8243967E-05,   1.9273230E-05,   2.0347294E-05
     +,   2.1467396E-05,   2.2634653E-05,   2.3850227E-05
     +,   2.5115181E-05,   2.6430520E-05,   2.7797149E-05
     +,   2.9215897E-05,   3.0687494E-05,   3.2212432E-05
     +,   3.3791177E-05,   3.5423971E-05,   3.7110927E-05
     +,   3.8851824E-05,   4.0646355E-05,   4.2493910E-05
     +,   4.4393641E-05,   4.6344416E-05,   4.8344868E-05
     +,   5.0393181E-05,   5.2487354E-05,   5.4625045E-05
     +,   5.6803528E-05,   5.9019840E-05,   6.1270483E-05
     +,   6.3551764E-05,   6.5859633E-05,   6.8189678E-05
     +,   7.0537193E-05,   7.2897121E-05,   7.5264186E-05
     +,   7.7632896E-05,   7.9997240E-05,   8.2351333E-05
     +,   8.4689018E-05,   8.7004009E-05,   8.9289999E-05
     +,   9.1540620E-05,   9.3749637E-05,   9.5910662E-05
     +,   9.8017728E-05,   1.0006501E-04,   1.0204695E-04
     +,   1.0395836E-04,   1.0579447E-04,   1.0755094E-04
     +,   1.0922399E-04,   1.1081049E-04,   1.1230785E-04
     +,   1.1371422E-04,   1.1502851E-04,   1.1625030E-04
     +,   1.1738004E-04,   1.1841896E-04,   1.1936895E-04
     +,   1.2023280E-04,   1.2101409E-04,   1.2171706E-04
     +,   1.2234667E-04,   1.2290846E-04,   1.2340861E-04
     +,   1.2385374E-04,   1.2425086E-04,   1.2460735E-04
     +,   1.2493075E-04,   1.2522872E-04,   1.2550890E-04
     +,   1.2577882E-04,   1.2604581E-04,   1.2631679E-04
     +,   1.2659829E-04,   1.2689631E-04,   1.2721613E-04
     +,   1.2756239E-04,   1.2793888E-04,   1.2834853E-04
     +,   1.2879336E-04,   1.2927447E-04,   1.2979202E-04
     +,   1.3034506E-04,   1.3093183E-04,   1.3154958E-04
     +,   1.3219455E-04,   1.3286226E-04,   1.3354745E-04
     +,   1.3424396E-04,   1.3494519E-04,   1.3564393E-04
     +,   1.3633250E-04,   1.3700292E-04,   1.3764703E-04
     +,   1.3825650E-04,   1.3882304E-04,   1.3933859E-04
     +,   1.3979517E-04,   1.4018534E-04,   1.4050207E-04
     +,   1.4073899E-04,   1.4089046E-04,   1.4095163E-04
     +,   1.4091864E-04,   1.4078867E-04,   1.4056003E-04
     +,   1.4023230E-04,   1.3980633E-04,   1.3928440E-04
     +,   1.3867025E-04,   1.3796920E-04,   1.3718809E-04
     +,   1.3633541E-04,   1.3542129E-04,   1.3445756E-04
     +,   1.3345771E-04,   1.3243683E-04,   1.3141170E-04
     +,   1.3040045E-04,   1.2942297E-04,   1.2850019E-04
     +,   1.2765442E-04,   1.2690884E-04,   1.2628756E-04
     +,   1.2581519E-04,   1.2551672E-04,   1.2541702E-04
     +,   1.2554081E-04,   1.2591197E-04,   1.2655336E-04
     +,   1.2748635E-04,   1.2873035E-04,   1.3030249E-04
     +,   1.3221704E-04,   1.3448505E-04,   1.3711389E-04
     +,   1.4010693E-04,   1.4346314E-04,   1.4717627E-04
     +,   1.5123609E-04,   1.5562585E-04,   1.6032501E-04
     +,   1.6530656E-04,   1.7053820E-04,   1.7598404E-04
     +,   1.8160160E-04,   1.8734614E-04,   1.9316757E-04
     +,   1.9901362E-04,   2.0482973E-04,   2.1055994E-04
     +,   2.1614783E-04,   2.2153780E-04,   2.2667575E-04
     +,   2.3151055E-04,   2.3599497E-04,   2.4008664E-04
     +,   2.4374924E-04,   2.4695313E-04,   2.4967681E-04
     +,   2.5190614E-04,   2.5363680E-04,   2.5487290E-04
     +,   2.5562782E-04,   2.5592424E-04,   2.5579330E-04
     +,   2.5527444E-04,   2.5441471E-04,   2.5326747E-04
     +,   2.5189156E-04,   2.5035001E-04,   2.4870850E-04
     +,   2.4703413E-04,   2.4539372E-04,   2.4385222E-04
     +,   2.4247132E-04,   2.4130788E-04,   2.4041263E-04
     +,   2.3982886E-04,   2.3959148E-04,   2.3972576E-04
     +,   2.4024720E-04,   2.4116047E-04,   2.4245966E-04
     +,   2.4412804E-04,   2.4613834E-04,   2.4845361E-04
     +,   2.5102714E-04,   2.5380426E-04,   2.5672285E-04
     +,   2.5971499E-04,   2.6270808E-04,   2.6562635E-04
     +,   2.6839235E-04,   2.7092887E-04,   2.7315988E-04
     +,   2.7501260E-04,   2.7641829E-04,   2.7731422E-04
     +,   2.7764443E-04,   2.7736070E-04,   2.7642358E-04
     +,   2.7480282E-04,   2.7247818E-04,   2.6943930E-04
     +,   2.6568561E-04,   2.6122679E-04,   2.5608155E-04
     +,   2.5027819E-04,   2.4385293E-04,   2.3684945E-04
     +,   2.2931802E-04,   2.2131452E-04,   2.1289925E-04
     +,   2.0413581E-04,   1.9509012E-04,   1.8582919E-04
     +,   1.7642003E-04,   1.6692869E-04,   1.5741936E-04
     +,   1.4795335E-04,   1.3858858E-04,   1.2937842E-04
     +,   1.2037271E-04,   1.1161505E-04,   1.0314414E-04
     +,   9.4993113E-05,   8.7189226E-05,   7.9755271E-05
     +,   7.2707575E-05,   6.6057713E-05,   5.9812341E-05
     +,   5.3973603E-05,   4.8539529E-05,   4.3504424E-05
     +,   3.8859336E-05,   3.4592471E-05,   3.0689687E-05
     +,   2.7134904E-05,   2.3910545E-05,   2.0997926E-05
     +,   1.8377619E-05,   1.6029708E-05,   1.3934580E-05
     +,   1.2072116E-05,   1.0423236E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_nwao_fus_65 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_nwao_fus_70(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  6.4805130E-07,   7.0568137E-07
     +,   7.6763803E-07,   8.3416865E-07,   9.0552226E-07
     +,   9.8195994E-07,   1.0637460E-06,   1.1511503E-06
     +,   1.2444489E-06,   1.3439154E-06,   1.4498330E-06
     +,   1.5624839E-06,   1.6821519E-06,   1.8091212E-06
     +,   1.9436775E-06,   2.0860955E-06,   2.2366553E-06
     +,   2.3956297E-06,   2.5632864E-06,   2.7398887E-06
     +,   2.9256812E-06,   3.1209095E-06,   3.3258054E-06
     +,   3.5405881E-06,   3.7654686E-06,   4.0006285E-06
     +,   4.2462484E-06,   4.5024876E-06,   4.7694971E-06
     +,   5.0473850E-06,   5.3362614E-06,   5.6362132E-06
     +,   5.9473059E-06,   6.2695826E-06,   6.6030757E-06
     +,   6.9477728E-06,   7.3036663E-06,   7.6707202E-06
     +,   8.0488808E-06,   8.4380827E-06,   8.8382203E-06
     +,   9.2491955E-06,   9.6708882E-06,   1.0103167E-05
     +,   1.0545889E-05,   1.0998911E-05,   1.1462048E-05
     +,   1.1935148E-05,   1.2418053E-05,   1.2910568E-05
     +,   1.3412535E-05,   1.3923784E-05,   1.4444148E-05
     +,   1.4973471E-05,   1.5511599E-05,   1.6058384E-05
     +,   1.6613702E-05,   1.7177397E-05,   1.7749357E-05
     +,   1.8329480E-05,   1.8917630E-05,   1.9513716E-05
     +,   2.0117628E-05,   2.0729256E-05,   2.1348491E-05
     +,   2.1975211E-05,   2.2609289E-05,   2.3250541E-05
     +,   2.3898800E-05,   2.4553850E-05,   2.5215451E-05
     +,   2.5883279E-05,   2.6557003E-05,   2.7236210E-05
     +,   2.7920434E-05,   2.8609129E-05,   2.9301695E-05
     +,   2.9997393E-05,   3.0695468E-05,   3.1395033E-05
     +,   3.2095133E-05,   3.2794745E-05,   3.3492688E-05
     +,   3.4187775E-05,   3.4878714E-05,   3.5564146E-05
     +,   3.6242687E-05,   3.6912887E-05,   3.7573307E-05
     +,   3.8222523E-05,   3.8859074E-05,   3.9481656E-05
     +,   4.0089006E-05,   4.0680028E-05,   4.1253781E-05
     +,   4.1809555E-05,   4.2346921E-05,   4.2865693E-05
     +,   4.3366119E-05,   4.3848835E-05,   4.4314940E-05
     +,   4.4766064E-05,   4.5204361E-05,   4.5632623E-05
     +,   4.6054276E-05,   4.6473404E-05,   4.6894809E-05
     +,   4.7323996E-05,   4.7767207E-05,   4.8231377E-05
     +,   4.8724134E-05,   4.9253787E-05,   4.9829145E-05
     +,   5.0459628E-05,   5.1155057E-05,   5.1925570E-05
     +,   5.2781470E-05,   5.3733143E-05,   5.4790871E-05
     +,   5.5964480E-05,   5.7263471E-05,   5.8696580E-05
     +,   6.0271635E-05,   6.1995372E-05,   6.3873187E-05
     +,   6.5908971E-05,   6.8104906E-05,   7.0461341E-05
     +,   7.2976560E-05,   7.5646829E-05,   7.8466190E-05
     +,   8.1426653E-05,   8.4517662E-05,   8.7726963E-05
     +,   9.1040209E-05,   9.4441311E-05,   9.7912634E-05
     +,   1.0143530E-04,   1.0498960E-04,   1.0855538E-04
     +,   1.1211203E-04,   1.1563973E-04,   1.1911935E-04
     +,   1.2253311E-04,   1.2586494E-04,   1.2910107E-04
     +,   1.3223029E-04,   1.3524441E-04,   1.3813848E-04
     +,   1.4091107E-04,   1.4356431E-04,   1.4610415E-04
     +,   1.4853975E-04,   1.5088398E-04,   1.5315269E-04
     +,   1.5536453E-04,   1.5754026E-04,   1.5970238E-04
     +,   1.6187440E-04,   1.6408008E-04,   1.6634277E-04
     +,   1.6868478E-04,   1.7112608E-04,   1.7368431E-04
     +,   1.7637371E-04,   1.7920460E-04,   1.8218283E-04
     +,   1.8530956E-04,   1.8858082E-04,   1.9198754E-04
     +,   1.9551557E-04,   1.9914590E-04,   2.0285489E-04
     +,   2.0661502E-04,   2.1039482E-04,   2.1416054E-04
     +,   2.1787628E-04,   2.2150509E-04,   2.2500969E-04
     +,   2.2835372E-04,   2.3150176E-04,   2.3442171E-04
     +,   2.3708362E-04,   2.3946182E-04,   2.4153489E-04
     +,   2.4328592E-04,   2.4470309E-04,   2.4577937E-04
     +,   2.4651308E-04,   2.4690694E-04,   2.4696847E-04
     +,   2.4670907E-04,   2.4614373E-04,   2.4529040E-04
     +,   2.4416918E-04,   2.4280205E-04,   2.4121143E-04
     +,   2.3942042E-04,   2.3745175E-04,   2.3532659E-04
     +,   2.3306547E-04,   2.3068632E-04,   2.2820554E-04
     +,   2.2563682E-04,   2.2299154E-04,   2.2027851E-04
     +,   2.1750425E-04,   2.1467303E-04,   2.1178716E-04
     +,   2.0884746E-04,   2.0585317E-04,   2.0280281E-04
     +,   1.9969420E-04,   1.9652511E-04,   1.9329319E-04
     +,   1.8999718E-04,   1.8663563E-04,   1.8320912E-04
     +,   1.7971874E-04,   1.7616696E-04,   1.7255826E-04
     +,   1.6889727E-04,   1.6519120E-04,   1.6144765E-04
     +,   1.5767569E-04,   1.5388508E-04,   1.5008636E-04
     +,   1.4629049E-04,   1.4250864E-04,   1.3875193E-04
     +,   1.3503128E-04,   1.3135704E-04,   1.2773891E-04
     +,   1.2418572E-04,   1.2070528E-04,   1.1730422E-04
     +,   1.1398785E-04,   1.1076060E-04,   1.0762519E-04
     +,   1.0458321E-04,   1.0163503E-04,   9.8779703E-05
     +,   9.6015596E-05,   9.3339790E-05,   9.0748581E-05
     +,   8.8237713E-05,   8.5802232E-05,   8.3436891E-05
     +,   8.1136168E-05,   7.8894394E-05,   7.6705968E-05
     +,   7.4565367E-05,   7.2467359E-05,   7.0406990E-05
     +,   6.8379770E-05,   6.6381581E-05,   6.4408960E-05
     +,   6.2458748E-05,   6.0528699E-05,   5.8616806E-05
     +,   5.6721732E-05,   5.4842618E-05,   5.2979038E-05
     +,   5.1131265E-05,   4.9299721E-05,   4.7485279E-05
     +,   4.5689121E-05,   4.3912682E-05,   4.2157597E-05
     +,   4.0425686E-05,   3.8718848E-05,   3.7039052E-05
     +,   3.5388301E-05,   3.3768571E-05,   3.2181801E-05
     +,   3.0629839E-05,   2.9114432E-05,   2.7637145E-05
     +,   2.6199603E-05,   2.4803070E-05,   2.3448712E-05
     +,   2.2137534E-05,   2.0870313E-05,   1.9647816E-05
     +,   1.8470468E-05,   1.7338583E-05,   1.6252312E-05
     +,   1.5211640E-05,   1.4216409E-05,   1.3266310E-05
     +,   1.2360902E-05,   1.1499608E-05,   1.0681739E-05
     +,   9.9065028E-06,   9.1729889E-06,   8.4802177E-06
     +,   7.8271114E-06,   7.2125017E-06,   6.6352673E-06
     +,   6.0940429E-06,   5.5876026E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_nwao_fus_70 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_nwao_fus_75(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  1.2989715E-13,   1.6903629E-13
     +,   2.1956517E-13,   2.8467766E-13,   3.6842063E-13
     +,   4.7592496E-13,   6.1367177E-13,   7.8983749E-13
     +,   1.0147170E-12,   1.3012287E-12,   1.6655829E-12
     +,   2.1280510E-12,   2.7139443E-12,   3.4548100E-12
     +,   4.3898843E-12,   5.5677923E-12,   7.0488272E-12
     +,   8.9074598E-12,   1.1235563E-11,   1.4146253E-11
     +,   1.7778251E-11,   2.2301836E-11,   2.7925166E-11
     +,   3.4902331E-11,   4.3543079E-11,   5.4223119E-11
     +,   6.7399045E-11,   8.3623164E-11,   1.0356319E-10
     +,   1.2802209E-10,   1.5796789E-10,   1.9456098E-10
     +,   2.3919206E-10,   2.9352212E-10,   3.5953476E-10
     +,   4.3958462E-10,   5.3647259E-10,   6.5351596E-10
     +,   7.9463552E-10,   9.6446351E-10,   1.1684363E-09
     +,   1.4129535E-09,   1.7055096E-09,   2.0548707E-09
     +,   2.4712572E-09,   2.9665865E-09,   3.5546552E-09
     +,   4.2514983E-09,   5.0756448E-09,   6.0484320E-09
     +,   7.1944553E-09,   8.5419396E-09,   1.0123215E-08
     +,   1.1975239E-08,   1.4140131E-08,   1.6665810E-08
     +,   1.9606686E-08,   2.3024185E-08,   2.6987815E-08
     +,   3.1575958E-08,   3.6876287E-08,   4.2987427E-08
     +,   5.0019491E-08,   5.8095246E-08,   6.7351209E-08
     +,   7.7938857E-08,   9.0025942E-08,   1.0379665E-07
     +,   1.1945451E-07,   1.3722250E-07,   1.5734504E-07
     +,   1.8008734E-07,   2.0573898E-07,   2.3461388E-07
     +,   2.6705109E-07,   3.0341607E-07,   3.4410235E-07
     +,   3.8952822E-07,   4.4014297E-07,   4.9642352E-07
     +,   5.5887477E-07,   6.2803133E-07,   7.0445037E-07
     +,   7.8872074E-07,   8.8145384E-07,   9.8328530E-07
     +,   1.0948711E-06,   1.2168863E-06,   1.3500219E-06
     +,   1.4949854E-06,   1.6524743E-06,   1.8232070E-06
     +,   2.0078949E-06,   2.2072390E-06,   2.4219289E-06
     +,   2.6526322E-06,   2.9000000E-06,   3.1646143E-06
     +,   3.4470459E-06,   3.7478046E-06,   4.0673390E-06
     +,   4.4060298E-06,   4.7641779E-06,   5.1420011E-06
     +,   5.5396190E-06,   5.9570498E-06,   6.3941984E-06
     +,   6.8508530E-06,   7.3266733E-06,   7.8211851E-06
     +,   8.3337773E-06,   8.8637216E-06,   9.4100687E-06
     +,   9.9717918E-06,   1.0547694E-05,   1.1136425E-05
     +,   1.1736491E-05,   1.2346253E-05,   1.2963965E-05
     +,   1.3587660E-05,   1.4215351E-05,   1.4844907E-05
     +,   1.5474108E-05,   1.6100666E-05,   1.6722248E-05
     +,   1.7336495E-05,   1.7941056E-05,   1.8533639E-05
     +,   1.9112038E-05,   1.9674191E-05,   2.0218242E-05
     +,   2.0742627E-05,   2.1246056E-05,   2.1727767E-05
     +,   2.2187505E-05,   2.2625689E-05,   2.3043511E-05
     +,   2.3443112E-05,   2.3827706E-05,   2.4201770E-05
     +,   2.4571153E-05,   2.4943325E-05,   2.5327476E-05
     +,   2.5734691E-05,   2.6178062E-05,   2.6672773E-05
     +,   2.7236156E-05,   2.7887645E-05,   2.8648703E-05
     +,   2.9542638E-05,   3.0594347E-05,   3.1829997E-05
     +,   3.3276388E-05,   3.4960703E-05,   3.6909780E-05
     +,   3.9149556E-05,   4.1704494E-05,   4.4597182E-05
     +,   4.7848007E-05,   5.1475115E-05,   5.5494718E-05
     +,   5.9921971E-05,   6.4771244E-05,   7.0058835E-05
     +,   7.5804135E-05,   8.2031969E-05,   8.8774977E-05
     +,   9.6075666E-05,   1.0398820E-04,   1.1257914E-04
     +,   1.2192715E-04,   1.3212110E-04,   1.4325614E-04
     +,   1.5542842E-04,   1.6872519E-04,   1.8321800E-04
     +,   1.9895009E-04,   2.1592542E-04,   2.3409777E-04
     +,   2.5336241E-04,   2.7354568E-04,   2.9441275E-04
     +,   3.1565776E-04,   3.3692273E-04,   3.5780726E-04
     +,   3.7788917E-04,   3.9674860E-04,   4.1399372E-04
     +,   4.2928825E-04,   4.4237493E-04,   4.5309693E-04
     +,   4.6141015E-04,   4.6738889E-04,   4.7122053E-04
     +,   4.7319342E-04,   4.7367226E-04,   4.7307101E-04
     +,   4.7181826E-04,   4.7032372E-04,   4.6894501E-04
     +,   4.6796203E-04,   4.6755595E-04,   4.6780077E-04
     +,   4.6866265E-04,   4.7001077E-04,   4.7163581E-04
     +,   4.7327537E-04,   4.7464282E-04,   4.7545659E-04
     +,   4.7546803E-04,   4.7448388E-04,   4.7238270E-04
     +,   4.6912307E-04,   4.6474510E-04,   4.5936255E-04
     +,   4.5315333E-04,   4.4633864E-04,   4.3916816E-04
     +,   4.3189805E-04,   4.2477305E-04,   4.1801296E-04
     +,   4.1179699E-04,   4.0626005E-04,   4.0148618E-04
     +,   3.9750908E-04,   3.9431540E-04,   3.9184970E-04
     +,   3.9002165E-04,   3.8871350E-04,   3.8778852E-04
     +,   3.8709835E-04,   3.8649054E-04,   3.8581510E-04
     +,   3.8492962E-04,   3.8370461E-04,   3.8202666E-04
     +,   3.7980144E-04,   3.7695598E-04,   3.7343919E-04
     +,   3.6922243E-04,   3.6429841E-04,   3.5867974E-04
     +,   3.5239742E-04,   3.4549602E-04,   3.3803150E-04
     +,   3.3006695E-04,   3.2166808E-04,   3.1290023E-04
     +,   3.0382420E-04,   2.9449389E-04,   2.8495412E-04
     +,   2.7523973E-04,   2.6537554E-04,   2.5537724E-04
     +,   2.4525294E-04,   2.3500607E-04,   2.2463745E-04
     +,   2.1414815E-04,   2.0354392E-04,   1.9283500E-04
     +,   1.8203958E-04,   1.7118460E-04,   1.6030573E-04
     +,   1.4944896E-04,   1.3866654E-04,   1.2801739E-04
     +,   1.1756448E-04,   1.0737241E-04,   9.7505123E-05
     +,   8.8023167E-05,   7.8981800E-05,   7.0428927E-05
     +,   6.2403662E-05,   5.4935430E-05,   4.8043312E-05
     +,   4.1736123E-05,   3.6012734E-05,   3.0862611E-05
     +,   2.6267775E-05,   2.2202621E-05,   1.8636232E-05
     +,   1.5533551E-05,   1.2856614E-05,   1.0566337E-05
     +,   8.6228956E-06,   6.9872731E-06,   5.6219183E-06
     +,   4.4913972E-06,   3.5628486E-06,   2.8062886E-06
     +,   2.1947612E-06,   1.7043694E-06,   1.3142070E-06
     +,   1.0062132E-06,   7.6497213E-07,   5.7747570E-07
     +,   4.3287025E-07,   3.2219259E-07,   2.3813789E-07
     +,   1.7477358E-07,   1.2737365E-07
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_nwao_fus_75 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_nwao_fus_80(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  5.9313327E-30,   1.1643993E-29
     +,   2.2767241E-29,   4.4338666E-29,   8.6000710E-29
     +,   1.6614233E-28,   3.1968013E-28,   6.1264164E-28
     +,   1.1693905E-27,   2.2231292E-27,   4.2094504E-27
     +,   7.9385869E-27,   1.4911335E-26,   2.7896433E-26
     +,   5.1980597E-26,   9.6468611E-26,   1.7831434E-25
     +,   3.2827941E-25,   6.0194697E-25,   1.0993473E-24
     +,   1.9996875E-24,   3.6228035E-24,   6.5371180E-24
     +,   1.1748523E-23,   2.1030151E-23,   3.7493303E-23
     +,   6.6576427E-23,   1.1774553E-22,   2.0741038E-22
     +,   3.6388742E-22,   6.3585895E-22,   1.1066536E-21
     +,   1.9183068E-21,   3.3119332E-21,   5.6951777E-21
     +,   9.7540160E-21,   1.6638602E-20,   2.8268797E-20
     +,   4.7835835E-20,   8.0623472E-20,   1.3533864E-19
     +,   2.2627645E-19,   3.7680124E-19,   6.2494488E-19
     +,   1.0323550E-18,   1.6985411E-18,   2.7834032E-18
     +,   4.5429024E-18,   7.3850123E-18,   1.1956973E-17
     +,   1.9281803E-17,   3.0969295E-17,   4.9541749E-17
     +,   7.8934828E-17,   1.2526266E-16,   1.9798481E-16
     +,   3.1167612E-16,   4.8868348E-16,   7.6314725E-16
     +,   1.1870018E-15,   1.8388454E-15,   2.8372491E-15
     +,   4.3601999E-15,   6.6737713E-15,   1.0174072E-14
     +,   1.5448102E-14,   2.3362405E-14,   3.5189425E-14
     +,   5.2791599E-14,   7.8881603E-14,   1.1739442E-13
     +,   1.7400977E-13,   2.5689669E-13,   3.7774742E-13
     +,   5.5322641E-13,   8.0698181E-13,   1.1724296E-12
     +,   1.6965498E-12,   2.4451485E-12,   3.5099881E-12
     +,   5.0184093E-12,   7.1464657E-12,   1.0136192E-11
     +,   1.4319290E-11,   2.0147960E-11,   2.8236104E-11
     +,   3.9413327E-11,   5.4795859E-11,   7.5878463E-11
     +,   1.0465610E-10,   1.4377151E-10,   1.9672169E-10
     +,   2.6810387E-10,   3.6393863E-10,   4.9207166E-10
     +,   6.6268396E-10,   8.8893393E-10,   1.1877048E-09
     +,   1.5806342E-09,   2.0952746E-09,   2.7665608E-09
     +,   3.6385808E-09,   4.7667199E-09,   6.2202248E-09
     +,   8.0852862E-09,   1.0468659E-08,   1.3501996E-08
     +,   1.7346823E-08,   2.2200432E-08,   2.8302667E-08
     +,   3.5943728E-08,   4.5473481E-08,   5.7309808E-08
     +,   7.1952456E-08,   8.9994167E-08,   1.1213501E-07
     +,   1.3919775E-07,   1.7214485E-07,   2.1209834E-07
     +,   2.6035133E-07,   3.1839994E-07,   3.8795656E-07
     +,   4.7097376E-07,   5.6966661E-07,   6.8653287E-07
     +,   8.2437481E-07,   9.8631801E-07,   1.1758273E-06
     +,   1.3967225E-06,   1.6531849E-06,   1.9497647E-06
     +,   2.2913916E-06,   2.6833054E-06,   3.1311245E-06
     +,   3.6407596E-06,   4.2183901E-06,   4.8704037E-06
     +,   5.6033327E-06,   6.4237734E-06,   7.3383221E-06
     +,   8.3533023E-06,   9.4748711E-06,   1.0708721E-05
     +,   1.2059950E-05,   1.3532892E-05,   1.5130931E-05
     +,   1.6856317E-05,   1.8709961E-05,   2.0691255E-05
     +,   2.2797873E-05,   2.5025622E-05,   2.7368375E-05
     +,   2.9817560E-05,   3.2362695E-05,   3.4990946E-05
     +,   3.7687263E-05,   4.0434472E-05,   4.3213480E-05
     +,   4.6003512E-05,   4.8782516E-05,   5.1527641E-05
     +,   5.4215961E-05,   5.6824749E-05,   5.9333055E-05
     +,   6.1722232E-05,   6.3977255E-05,   6.6087843E-05
     +,   6.8049936E-05,   6.9866983E-05,   7.1551323E-05
     +,   7.3125506E-05,   7.4623385E-05,   7.6090859E-05
     +,   7.7586410E-05,   7.9180587E-05,   8.0955557E-05
     +,   8.3003091E-05,   8.5422129E-05,   8.8315144E-05
     +,   9.1783928E-05,   9.5923548E-05,   1.0081854E-04
     +,   1.0653442E-04,   1.1311415E-04,   1.2057237E-04
     +,   1.2889216E-04,   1.3802358E-04,   1.4788467E-04
     +,   1.5836545E-04,   1.6933480E-04,   1.8065050E-04
     +,   1.9217166E-04,   2.0377360E-04,   2.1536071E-04
     +,   2.2688680E-04,   2.3836052E-04,   2.4986305E-04
     +,   2.6154591E-04,   2.7363267E-04,   2.8641350E-04
     +,   3.0022161E-04,   3.1541870E-04,   3.3235466E-04
     +,   3.5133862E-04,   3.7259670E-04,   3.9623433E-04
     +,   4.2220333E-04,   4.5027983E-04,   4.8005878E-04
     +,   5.1096838E-04,   5.4230844E-04,   5.7331019E-04
     +,   6.0321315E-04,   6.3134701E-04,   6.5720867E-04
     +,   6.8050681E-04,   7.0118892E-04,   7.1939448E-04
     +,   7.3539221E-04,   7.4946758E-04,   7.6180499E-04
     +,   7.7239552E-04,   7.8097859E-04,   7.8706385E-04
     +,   7.9002080E-04,   7.8923185E-04,   7.8427838E-04
     +,   7.7511737E-04,   7.6220458E-04,   7.4652571E-04
     +,   7.2951918E-04,   7.1289466E-04,   6.9837418E-04
     +,   6.8740617E-04,   6.8090484E-04,   6.7906611E-04
     +,   6.8129716E-04,   6.8627117E-04,   6.9210009E-04
     +,   6.9659104E-04,   6.9754187E-04,   6.9302763E-04
     +,   6.8163325E-04,   6.6260021E-04,   6.3587498E-04
     +,   6.0206343E-04,   5.6230638E-04,   5.1810854E-04
     +,   4.7114896E-04,   4.2310217E-04,   3.7549314E-04
     +,   3.2959608E-04,   2.8638224E-04,   2.4651131E-04
     +,   2.1035608E-04,   1.7804885E-04,   1.4953794E-04
     +,   1.2464231E-04,   1.0310534E-04,   8.4627136E-05
     +,   6.8896858E-05,   5.5609591E-05,   4.4475626E-05
     +,   3.5226924E-05,   2.7615308E-05,   2.1414238E-05
     +,   1.6417354E-05,   1.2437766E-05,   9.3075005E-06
     +,   6.8771892E-06,   5.0157159E-06,   3.6097372E-06
     +,   2.5629033E-06,   1.7947806E-06,   1.2394632E-06
     +,   8.4397550E-07,   5.6655222E-07,   3.7488772E-07
     +,   2.4450179E-07,   1.5715572E-07,   9.9541928E-08
     +,   6.2125835E-08,   3.8201865E-08,   2.3143542E-08
     +,   1.3812381E-08,   8.1203089E-09,   4.7023572E-09
     +,   2.6820832E-09,   1.5066756E-09,   8.3355911E-10
     +,   4.5415327E-10,   2.4366867E-10,   1.2873907E-10
     +,   6.6976029E-11,   3.4309350E-11,   1.7305211E-11
     +,   8.5941167E-12,   4.2020432E-12,   2.0229582E-12
     +,   9.5877332E-13,   4.4738684E-13
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_nwao_fus_80 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_nwao_fus_85(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  4.2106313E-07,   4.6013625E-07
     +,   5.0228061E-07,   5.4768122E-07,   5.9652569E-07
     +,   6.4900951E-07,   7.0533247E-07,   7.6569745E-07
     +,   8.3031364E-07,   8.9938771E-07,   9.7313352E-07
     +,   1.0517643E-06,   1.1354954E-06,   1.2245397E-06
     +,   1.3191126E-06,   1.4194194E-06,   1.5256694E-06
     +,   1.6380632E-06,   1.7567975E-06,   1.8820630E-06
     +,   2.0140326E-06,   2.1528783E-06,   2.2987581E-06
     +,   2.4518147E-06,   2.6121822E-06,   2.7799651E-06
     +,   2.9552609E-06,   3.1381448E-06,   3.3286758E-06
     +,   3.5268761E-06,   3.7327545E-06,   3.9462939E-06
     +,   4.1674471E-06,   4.3961395E-06,   4.6322716E-06
     +,   4.8756979E-06,   5.1262546E-06,   5.3837430E-06
     +,   5.6479280E-06,   5.9185472E-06,   6.1952851E-06
     +,   6.4778096E-06,   6.7657475E-06,   7.0586893E-06
     +,   7.3561914E-06,   7.6577835E-06,   7.9629399E-06
     +,   8.2711231E-06,   8.5817646E-06,   8.8942425E-06
     +,   9.2079317E-06,   9.5221694E-06,   9.8362698E-06
     +,   1.0149522E-05,   1.0461199E-05,   1.0770555E-05
     +,   1.1076832E-05,   1.1379248E-05,   1.1677024E-05
     +,   1.1969383E-05,   1.2255522E-05,   1.2534659E-05
     +,   1.2806013E-05,   1.3068810E-05,   1.3322287E-05
     +,   1.3565703E-05,   1.3798333E-05,   1.4019467E-05
     +,   1.4228433E-05,   1.4424585E-05,   1.4607316E-05
     +,   1.4776038E-05,   1.4930225E-05,   1.5069380E-05
     +,   1.5193054E-05,   1.5300848E-05,   1.5392410E-05
     +,   1.5467440E-05,   1.5525689E-05,   1.5566970E-05
     +,   1.5591142E-05,   1.5598127E-05,   1.5587902E-05
     +,   1.5560501E-05,   1.5516016E-05,   1.5454592E-05
     +,   1.5376432E-05,   1.5281792E-05,   1.5170980E-05
     +,   1.5044355E-05,   1.4902336E-05,   1.4745374E-05
     +,   1.4573973E-05,   1.4388675E-05,   1.4190063E-05
     +,   1.3978756E-05,   1.3755398E-05,   1.3520686E-05
     +,   1.3275319E-05,   1.3020031E-05,   1.2755564E-05
     +,   1.2482685E-05,   1.2202171E-05,   1.1914803E-05
     +,   1.1621370E-05,   1.1322659E-05,   1.1019458E-05
     +,   1.0712548E-05,   1.0402698E-05,   1.0090668E-05
     +,   9.7772008E-06,   9.4630068E-06,   9.1488209E-06
     +,   8.8353108E-06,   8.5231313E-06,   8.2129127E-06
     +,   7.9052570E-06,   7.6007327E-06,   7.2998632E-06
     +,   7.0031842E-06,   6.7111509E-06,   6.4242031E-06
     +,   6.1427399E-06,   5.8671294E-06,   5.5977039E-06
     +,   5.3347599E-06,   5.0785593E-06,   4.8293309E-06
     +,   4.5872666E-06,   4.3525297E-06,   4.1252488E-06
     +,   3.9055144E-06,   3.6934143E-06,   3.4889795E-06
     +,   3.2922260E-06,   3.1031409E-06,   2.9216906E-06
     +,   2.7478147E-06,   2.5814365E-06,   2.4224510E-06
     +,   2.2707566E-06,   2.1262144E-06,   1.9886786E-06
     +,   1.8579909E-06,   1.7339829E-06,   1.6164756E-06
     +,   1.5052852E-06,   1.4002238E-06,   1.3011017E-06
     +,   1.2077342E-06,   1.1199440E-06,   1.0375677E-06
     +,   9.6047984E-07,   8.8858422E-07,   8.2185062E-07
     +,   7.6033808E-07,   7.0423192E-07,   6.5389725E-07
     +,   6.0994552E-07,   5.7332613E-07,   5.4544279E-07
     +,   5.2830222E-07,   5.2470301E-07,   5.3845855E-07
     +,   5.7467332E-07,   6.4006150E-07,   7.4330677E-07
     +,   8.9546074E-07,   1.1103572E-06,   1.4050291E-06
     +,   1.8000850E-06,   2.3200171E-06,   2.9933758E-06
     +,   3.8528092E-06,   4.9346422E-06,   6.2785484E-06
     +,   7.9264964E-06,   9.9214685E-06,   1.2305796E-05
     +,   1.5119289E-05,   1.8396337E-05,   2.2165272E-05
     +,   2.6444308E-05,   3.1241987E-05,   3.6556146E-05
     +,   4.2375446E-05,   4.8682788E-05,   5.5461333E-05
     +,   6.2703082E-05,   7.0420472E-05,   7.8660370E-05
     +,   8.7519678E-05,   9.7161916E-05,   1.0782974E-04
     +,   1.1986164E-04,   1.3368989E-04,   1.4984701E-04
     +,   1.6894453E-04,   1.9165062E-04,   2.1865978E-04
     +,   2.5062775E-04,   2.8813066E-04,   3.3157592E-04
     +,   3.8115002E-04,   4.3674529E-04,   4.9791014E-04
     +,   5.6381943E-04,   6.3327322E-04,   7.0473272E-04
     +,   7.7639386E-04,   8.4629236E-04,   9.1243809E-04
     +,   9.7295572E-04,   1.0262209E-03,   1.0709687E-03
     +,   1.1063527E-03,   1.1319795E-03,   1.1478604E-03
     +,   1.1543578E-03,   1.1521017E-03,   1.1419138E-03
     +,   1.1247568E-03,   1.1017227E-03,   1.0740422E-03
     +,   1.0431200E-03,   1.0105538E-03,   9.7812165E-04
     +,   9.4771548E-04,   9.2121371E-04,   9.0030447E-04
     +,   8.8629086E-04,   8.7991112E-04,   8.8121439E-04
     +,   8.8952534E-04,   9.0350490E-04,   9.2130905E-04
     +,   9.4081601E-04,   9.5988013E-04,   9.7658194E-04
     +,   9.8941894E-04,   9.9741749E-04,   1.0001563E-03
     +,   9.9770178E-04,   9.9048147E-04,   9.7912271E-04
     +,   9.6429227E-04,   9.4656408E-04,   9.2633598E-04
     +,   9.0380543E-04,   8.7899761E-04,   8.5183268E-04
     +,   8.2221342E-04,   7.9011027E-04,   7.5562677E-04
     +,   7.1903481E-04,   6.8077398E-04,   6.4141868E-04
     +,   6.0162292E-04,   5.6206319E-04,   5.2336429E-04
     +,   4.8605626E-04,   4.5053984E-04,   4.1707113E-04
     +,   3.8577366E-04,   3.5664713E-04,   3.2960201E-04
     +,   3.0448785E-04,   2.8112304E-04,   2.5931926E-04
     +,   2.3890013E-04,   2.1971315E-04,   2.0163588E-04
     +,   1.8457652E-04,   1.6847173E-04,   1.5328155E-04
     +,   1.3898348E-04,   1.2556641E-04,   1.1302414E-04
     +,   1.0135322E-04,   9.0545473E-05,   8.0588150E-05
     +,   7.1461793E-05,   6.3139574E-05,   5.5589127E-05
     +,   4.8771180E-05,   4.2642412E-05,   3.7156467E-05
     +,   3.2265412E-05,   2.7920991E-05,   2.4075774E-05
     +,   2.0684021E-05,   1.7702316E-05,   1.5089939E-05
     +,   1.2809111E-05,   1.0825004E-05,   9.1056972E-06
     +,   7.6220190E-06,   6.3473190E-06,   5.2575392E-06
     +,   4.3304462E-06,   3.5461594E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_nwao_fus_85 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_nwao_fus_90(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  9.9024015E-17,   1.3692507E-16
     +,   1.8894792E-16,   2.6020982E-16,   3.5761747E-16
     +,   4.9049253E-16,   6.7137435E-16,   9.1709697E-16
     +,   1.2502220E-15,   1.7008854E-15,   2.3093055E-15
     +,   3.1290183E-15,   4.2310875E-15,   5.7097436E-15
     +,   7.6895989E-15,   1.0334934E-14,   1.3862174E-14
     +,   1.8555592E-14,   2.4787911E-14,   3.3046675E-14
     +,   4.3967603E-14,   5.8379456E-14,   7.7358692E-14
     +,   1.0230067E-13,   1.3501209E-13,   1.7782257E-13
     +,   2.3373458E-13,   3.0660649E-13,   4.0138910E-13
     +,   5.2440897E-13,   6.8375205E-13,   8.8971435E-13
     +,   1.1553860E-12,   1.4973652E-12,   1.9366720E-12
     +,   2.4998061E-12,   3.2201982E-12,   4.1398512E-12
     +,   5.3114557E-12,   6.8009760E-12,   8.6906671E-12
     +,   1.1083141E-11,   1.4105893E-11,   1.7917036E-11
     +,   2.2712294E-11,   2.8733411E-11,   3.6277804E-11
     +,   4.5711407E-11,   5.7483251E-11,   7.2141827E-11
     +,   9.0357499E-11,   1.1294668E-10,   1.4090130E-10
     +,   1.7542466E-10,   2.1797125E-10,   2.7029781E-10
     +,   3.3452088E-10,   4.1317735E-10,   5.0931476E-10
     +,   6.2657746E-10,   7.6930412E-10,   9.4266983E-10
     +,   1.1528143E-09,   1.4070143E-09,   1.7138655E-09
     +,   2.0835125E-09,   2.5278903E-09,   3.0609768E-09
     +,   3.6991699E-09,   4.4616102E-09,   5.3706191E-09
     +,   6.4520846E-09,   7.7360767E-09,   9.2573575E-09
     +,   1.1056048E-08,   1.3178326E-08,   1.5677250E-08
     +,   1.8613441E-08,   2.2056293E-08,   2.6084880E-08
     +,   3.0789000E-08,   3.6270681E-08,   4.2644800E-08
     +,   5.0041379E-08,   5.8606581E-08,   6.8504264E-08
     +,   7.9917818E-08,   9.3051987E-08,   1.0813439E-07
     +,   1.2541852E-07,   1.4518251E-07,   1.6773571E-07
     +,   1.9341735E-07,   2.2259987E-07,   2.5569048E-07
     +,   2.9313304E-07,   3.3541244E-07,   3.8304768E-07
     +,   4.3660498E-07,   4.9669256E-07,   5.6396226E-07
     +,   6.3911097E-07,   7.2288134E-07,   8.1606100E-07
     +,   9.1948249E-07,   1.0340226E-06,   1.1606000E-06
     +,   1.3001739E-06,   1.4537414E-06,   1.6223325E-06
     +,   1.8070067E-06,   2.0088587E-06,   2.2289714E-06
     +,   2.4684693E-06,   2.7284705E-06,   3.0100873E-06
     +,   3.3144190E-06,   3.6425417E-06,   3.9955116E-06
     +,   4.3742907E-06,   4.7798271E-06,   5.2129840E-06
     +,   5.6745380E-06,   6.1651695E-06,   6.6854473E-06
     +,   7.2358143E-06,   7.8165767E-06,   8.4278945E-06
     +,   9.0697667E-06,   9.7420234E-06,   1.0444321E-05
     +,   1.1176164E-05,   1.1936777E-05,   1.2725296E-05
     +,   1.3540644E-05,   1.4381567E-05,   1.5246656E-05
     +,   1.6134343E-05,   1.7042936E-05,   1.7970689E-05
     +,   1.8915644E-05,   1.9875937E-05,   2.0849660E-05
     +,   2.1834956E-05,   2.2830049E-05,   2.3833316E-05
     +,   2.4843332E-05,   2.5858923E-05,   2.6879225E-05
     +,   2.7903734E-05,   2.8932376E-05,   2.9965569E-05
     +,   3.1004110E-05,   3.2049480E-05,   3.3103654E-05
     +,   3.4169214E-05,   3.5249304E-05,   3.6347665E-05
     +,   3.7468581E-05,   3.8616861E-05,   3.9797833E-05
     +,   4.1017302E-05,   4.2281335E-05,   4.3596516E-05
     +,   4.4969704E-05,   4.6408055E-05,   4.7919002E-05
     +,   4.9510272E-05,   5.1189858E-05,   5.2966116E-05
     +,   5.4847780E-05,   5.6844008E-05,   5.8964488E-05
     +,   6.1219565E-05,   6.3619875E-05,   6.6176959E-05
     +,   6.8902853E-05,   7.1810013E-05,   7.4911171E-05
     +,   7.8219295E-05,   8.1746388E-05,   8.5504893E-05
     +,   8.9504982E-05,   9.3755953E-05,   9.8265009E-05
     +,   1.0303717E-04,   1.0807529E-04,   1.1338018E-04
     +,   1.1895136E-04,   1.2478804E-04,   1.3089065E-04
     +,   1.3726286E-04,   1.4391419E-04,   1.5086083E-04
     +,   1.5813157E-04,   1.6576496E-04,   1.7381601E-04
     +,   1.8235191E-04,   1.9145350E-04,   2.0121700E-04
     +,   2.1174706E-04,   2.2316311E-04,   2.3559263E-04
     +,   2.4917838E-04,   2.6407832E-04,   2.8046782E-04
     +,   2.9853880E-04,   3.1849375E-04,   3.4053207E-04
     +,   3.6483002E-04,   3.9151692E-04,   4.2065364E-04
     +,   4.5222658E-04,   4.8616290E-04,   5.2238203E-04
     +,   5.6086737E-04,   6.0178805E-04,   6.4557267E-04
     +,   6.9299416E-04,   7.4516051E-04,   8.0342009E-04
     +,   8.6923403E-04,   9.4395038E-04,   1.0286606E-03
     +,   1.1240597E-03,   1.2303466E-03,   1.3470827E-03
     +,   1.4729345E-03,   1.6052899E-03,   1.7398928E-03
     +,   1.8707351E-03,   1.9905032E-03,   2.0916893E-03
     +,   2.1681893E-03,   2.2169163E-03,   2.2387914E-03
     +,   2.2386517E-03,   2.2240372E-03,   2.2032389E-03
     +,   2.1833743E-03,   2.1691343E-03,   2.1625781E-03
     +,   2.1637746E-03,   2.1717446E-03,   2.1850949E-03
     +,   2.2020121E-03,   2.2197617E-03,   2.2342028E-03
     +,   2.2398357E-03,   2.2306601E-03,   2.2016389E-03
     +,   2.1502380E-03,   2.0774554E-03,   1.9879485E-03
     +,   1.8892385E-03,   1.7902618E-03,   1.6997021E-03
     +,   1.6245424E-03,   1.5691415E-03,   1.5348968E-03
     +,   1.5205026E-03,   1.5225527E-03,   1.5363011E-03
     +,   1.5563712E-03,   1.5773283E-03,   1.5940721E-03
     +,   1.6021041E-03,   1.5977098E-03,   1.5781106E-03
     +,   1.5416003E-03,   1.4876592E-03,   1.4170052E-03
     +,   1.3315590E-03,   1.2342855E-03,   1.1289120E-03
     +,   1.0195512E-03,   9.1027806E-04,   8.0473075E-04
     +,   7.0582371E-04,   6.1554444E-04,   5.3494447E-04
     +,   4.6423115E-04,   4.0294733E-04,   3.5020249E-04
     +,   3.0486987E-04,   2.6577665E-04,   2.3182787E-04
     +,   2.0208111E-04,   1.7577704E-04,   1.5233710E-04
     +,   1.3134151E-04,   1.1249744E-04,   9.5605021E-05
     +,   8.0526079E-05,   6.7157700E-05,   5.5412191E-05
     +,   4.5202876E-05,   3.6435318E-05,   2.9005343E-05
     +,   2.2795044E-05,   1.7679895E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_nwao_fus_90 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_nwao_fus_95(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  1.0464460E-19,   1.4920560E-19
     +,   2.1232982E-19,   3.0157958E-19,   4.2751160E-19
     +,   6.0485871E-19,   8.5412064E-19,   1.2037705E-18
     +,   1.6932908E-18,   2.3772617E-18,   3.3310406E-18
     +,   4.6584752E-18,   6.5022985E-18,   9.0583507E-18
     +,   1.2594904E-17,   1.7478191E-17,   2.4207955E-17
     +,   3.3464085E-17,   4.6169999E-17,   6.3577360E-17
     +,   8.7378119E-17,   1.1985664E-16,   1.6408949E-16
     +,   2.2421187E-16,   3.0577410E-16,   4.1619668E-16
     +,   5.6540005E-16,   7.6660606E-16,   1.0374139E-15
     +,   1.4011626E-15,   1.8887926E-15,   2.5412022E-15
     +,   3.4123554E-15,   4.5732876E-15,   6.1173774E-15
     +,   8.1669290E-15,   1.0882091E-14,   1.4471888E-14
     +,   1.9208664E-14,   2.5446716E-14,   3.3645260E-14
     +,   4.4399204E-14,   5.8477095E-14,   7.6869907E-14
     +,   1.0085240E-13,   1.3206198E-13,   1.7259482E-13
     +,   2.2513141E-13,   2.9309405E-13,   3.8083374E-13
     +,   4.9388185E-13,   6.3924891E-13,   8.2580400E-13
     +,   1.0647389E-12,   1.3701512E-12,   1.7597653E-12
     +,   2.2558071E-12,   2.8860686E-12,   3.6852843E-12
     +,   4.6967508E-12,   5.9742133E-12,   7.5844418E-12
     +,   9.6100688E-12,   1.2153156E-11,   1.5339473E-11
     +,   1.9323789E-11,   2.4296036E-11,   3.0488497E-11
     +,   3.8185316E-11,   4.7732741E-11,   5.9552176E-11
     +,   7.4154391E-11,   9.2158482E-11,   1.1431242E-10
     +,   1.4151783E-10,   1.7485922E-10,   2.1563916E-10
     +,   2.6541427E-10,   3.2604727E-10,   3.9975701E-10
     +,   4.8918336E-10,   5.9745897E-10,   7.2828765E-10
     +,   8.8604746E-10,   1.0758969E-09,   1.3039004E-09
     +,   1.5771647E-09,   1.9040118E-09,   2.2941506E-09
     +,   2.7589073E-09,   3.3113738E-09,   3.9667878E-09
     +,   4.7427409E-09,   5.6595204E-09,   6.7404562E-09
     +,   8.0123250E-09,   9.5058494E-09,   1.1255875E-08
     +,   1.3302316E-08,   1.5690432E-08,   1.8471493E-08
     +,   2.1703457E-08,   2.5451598E-08,   2.9789353E-08
     +,   3.4798994E-08,   4.0572498E-08,   4.7212467E-08
     +,   5.4832874E-08,   6.3560158E-08,   7.3534075E-08
     +,   8.4908635E-08,   9.7853750E-08,   1.1255366E-07
     +,   1.2921160E-07,   1.4804822E-07,   1.6930291E-07
     +,   1.9323458E-07,   2.2012298E-07,   2.5026935E-07
     +,   2.8399273E-07,   3.2163720E-07,   3.6356752E-07
     +,   4.1016946E-07,   4.6185042E-07,   5.1903777E-07
     +,   5.8217853E-07,   6.5173816E-07,   7.2819853E-07
     +,   8.1205644E-07,   9.0382082E-07,   1.0040112E-06
     +,   1.1131576E-06,   1.2317796E-06,   1.3604098E-06
     +,   1.4995716E-06,   1.6497781E-06,   1.8115294E-06
     +,   1.9853060E-06,   2.1715630E-06,   2.3707360E-06
     +,   2.5831976E-06,   2.8093070E-06,   3.0493711E-06
     +,   3.3036483E-06,   3.5723458E-06,   3.8556173E-06
     +,   4.1535650E-06,   4.4662402E-06,   4.7936496E-06
     +,   5.1357629E-06,   5.4925231E-06,   5.8638843E-06
     +,   6.2497625E-06,   6.6501657E-06,   7.0651649E-06
     +,   7.4949530E-06,   7.9398933E-06,   8.4005842E-06
     +,   8.8779288E-06,   9.3732160E-06,   9.8882119E-06
     +,   1.0425288E-05,   1.0987421E-05,   1.1578473E-05
     +,   1.2203212E-05,   1.2867458E-05,   1.3578233E-05
     +,   1.4343867E-05,   1.5174151E-05,   1.6080436E-05
     +,   1.7075758E-05,   1.8174926E-05,   1.9394602E-05
     +,   2.0753414E-05,   2.2271744E-05,   2.3972067E-05
     +,   2.5878689E-05,   2.8017694E-05,   3.0416804E-05
     +,   3.3105294E-05,   3.6113041E-05,   3.9471597E-05
     +,   4.3211778E-05,   4.7364629E-05,   5.1959945E-05
     +,   5.7025572E-05,   6.2586485E-05,   6.8663619E-05
     +,   7.5272881E-05,   8.2424049E-05,   9.0119756E-05
     +,   9.8354947E-05,   1.0711678E-04,   1.1638289E-04
     +,   1.2612689E-04,   1.3631363E-04,   1.4690892E-04
     +,   1.5787646E-04,   1.6918487E-04,   1.8081516E-04
     +,   1.9275851E-04,   2.0502866E-04,   2.1765663E-04
     +,   2.3069831E-04,   2.4423032E-04,   2.5834693E-04
     +,   2.7315298E-04,   2.8875552E-04,   3.0525337E-04
     +,   3.2272638E-04,   3.4122661E-04,   3.6077262E-04
     +,   3.8134807E-04,   4.0290630E-04,   4.2538103E-04
     +,   4.4869559E-04,   4.7279077E-04,   4.9762521E-04
     +,   5.2319857E-04,   5.4954935E-04,   5.7674095E-04
     +,   6.0485530E-04,   6.3394447E-04,   6.6400820E-04
     +,   6.9495087E-04,   7.2655827E-04,   7.5848965E-04
     +,   7.9030060E-04,   8.2150055E-04,   8.5164816E-04
     +,   8.8048505E-04,   9.0809638E-04,   9.3507860E-04
     +,   9.6267840E-04,   9.9284272E-04,   1.0281162E-03
     +,   1.0713225E-03,   1.1250050E-03,   1.1907249E-03
     +,   1.2683877E-03,   1.3559066E-03,   1.4494978E-03
     +,   1.5447023E-03,   1.6380189E-03,   1.7284981E-03
     +,   1.8185804E-03,   1.9134838E-03,   2.0189916E-03
     +,   2.1382782E-03,   2.2691400E-03,   2.4032407E-03
     +,   2.5283140E-03,   2.6329260E-03,   2.7116928E-03
     +,   2.7681713E-03,   2.8134277E-03,   2.8607501E-03
     +,   2.9194104E-03,   2.9910638E-03,   3.0706646E-03
     +,   3.1507157E-03,   3.2259042E-03,   3.2954675E-03
     +,   3.3624086E-03,   3.4302871E-03,   3.4988320E-03
     +,   3.5601782E-03,   3.5980283E-03,   3.5916327E-03
     +,   3.5240077E-03,   3.3905427E-03,   3.2027459E-03
     +,   2.9843403E-03,   2.7617333E-03,   2.5542029E-03
     +,   2.3687950E-03,   2.2014829E-03,   2.0425459E-03
     +,   1.8826515E-03,   1.7167534E-03,   1.5450723E-03
     +,   1.3717187E-03,   1.2023764E-03,   1.0422813E-03
     +,   8.9503312E-04,   7.6242344E-04,   6.4482796E-04
     +,   5.4179074E-04,   4.5248482E-04,   3.7595283E-04
     +,   3.1116584E-04,   2.5700891E-04,   2.1227211E-04
     +,   1.7568163E-04,   1.4596319E-04,   1.2191199E-04
     +,   1.0244762E-04,   8.6643449E-05,   7.3736024E-05
     +,   6.3107473E-05,   5.4274187E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_nwao_fus_95 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_nwao_hz_100(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  1.2463597E-15,   1.6627408E-15
     +,   2.2142921E-15,   2.9435945E-15,   3.9061217E-15
     +,   5.1741999E-15,   6.8418019E-15,   9.0308180E-15
     +,   1.1899137E-14,   1.5650601E-14,   2.0548313E-14
     +,   2.6930972E-14,   3.5233745E-14,   4.6014526E-14
     +,   5.9988066E-14,   7.8066155E-14,   1.0141252E-13
     +,   1.3150821E-13,   1.7023301E-13,   2.1997336E-13
     +,   2.8374270E-13,   3.6535301E-13,   4.6960396E-13
     +,   6.0253712E-13,   7.7173950E-13,   9.8670789E-13
     +,   1.2593267E-12,   1.6044348E-12,   2.0405249E-12
     +,   2.5905515E-12,   3.2830503E-12,   4.1533292E-12
     +,   5.2450561E-12,   6.6120776E-12,   8.3207738E-12
     +,   1.0452541E-11,   1.3107371E-11,   1.6407585E-11
     +,   2.0502645E-11,   2.5574869E-11,   3.1845748E-11
     +,   3.9584547E-11,   4.9117575E-11,   6.0839535E-11
     +,   7.5226735E-11,   9.2853461E-11,   1.1440909E-10
     +,   1.4072160E-10,   1.7278330E-10,   2.1177769E-10
     +,   2.5911781E-10,   3.1648589E-10,   3.8587858E-10
     +,   4.6966481E-10,   5.7064381E-10,   6.9212280E-10
     +,   8.3800034E-10,   1.0128496E-09,   1.2220437E-09
     +,   1.4718812E-09,   1.7696987E-09,   2.1240694E-09
     +,   2.5449609E-09,   3.0439418E-09,   3.6344252E-09
     +,   4.3319055E-09,   5.1542881E-09,   6.1221068E-09
     +,   7.2590289E-09,   8.5921403E-09,   1.0152477E-08
     +,   1.1975307E-08,   1.4100945E-08,   1.6575120E-08
     +,   1.9449679E-08,   2.2783267E-08,   2.6642139E-08
     +,   3.1100612E-08,   3.6242493E-08,   4.2161499E-08
     +,   4.8962576E-08,   5.6762801E-08,   6.5692021E-08
     +,   7.5894846E-08,   8.7531333E-08,   1.0077823E-07
     +,   1.1583037E-07,   1.3290182E-07,   1.5222749E-07
     +,   1.7406502E-07,   1.9869272E-07,   2.2641609E-07
     +,   2.5756592E-07,   2.9249972E-07,   3.3160367E-07
     +,   3.7529315E-07,   4.2401592E-07,   4.7824466E-07
     +,   5.3848959E-07,   6.0529140E-07,   6.7922332E-07
     +,   7.6089043E-07,   8.5093052E-07,   9.5001224E-07
     +,   1.0588350E-06,   1.1781279E-06,   1.3086469E-06
     +,   1.4511734E-06,   1.6065129E-06,   1.7754896E-06
     +,   1.9589445E-06,   2.1577412E-06,   2.3727241E-06
     +,   2.6047680E-06,   2.8547358E-06,   3.1234865E-06
     +,   3.4118623E-06,   3.7206862E-06,   4.0507712E-06
     +,   4.4028502E-06,   4.7776580E-06,   5.1758670E-06
     +,   5.5980927E-06,   6.0448865E-06,   6.5167274E-06
     +,   7.0140122E-06,   7.5370563E-06,   8.0860736E-06
     +,   8.6611817E-06,   9.2623895E-06,   9.8895953E-06
     +,   1.0542606E-05,   1.1221019E-05,   1.1924400E-05
     +,   1.2652155E-05,   1.3403562E-05,   1.4177774E-05
     +,   1.4973821E-05,   1.5790605E-05,   1.6626958E-05
     +,   1.7481478E-05,   1.8352779E-05,   1.9239338E-05
     +,   2.0139549E-05,   2.1051734E-05,   2.1974152E-05
     +,   2.2905024E-05,   2.3842536E-05,   2.4784864E-05
     +,   2.5730187E-05,   2.6676707E-05,   2.7622713E-05
     +,   2.8566421E-05,   2.9506258E-05,   3.0440704E-05
     +,   3.1368356E-05,   3.2287950E-05,   3.3198365E-05
     +,   3.4098644E-05,   3.4988021E-05,   3.5865920E-05
     +,   3.6732017E-05,   3.7586098E-05,   3.8428305E-05
     +,   3.9259001E-05,   4.0078834E-05,   4.0888732E-05
     +,   4.1689967E-05,   4.2484160E-05,   4.3273340E-05
     +,   4.4059969E-05,   4.4847013E-05,   4.5638008E-05
     +,   4.6437162E-05,   4.7249301E-05,   4.8080168E-05
     +,   4.8936356E-05,   4.9825499E-05,   5.0756284E-05
     +,   5.1738647E-05,   5.2783569E-05,   5.3903699E-05
     +,   5.5112636E-05,   5.6425521E-05,   5.7858728E-05
     +,   5.9429862E-05,   6.1157545E-05,   6.3061409E-05
     +,   6.5161737E-05,   6.7479319E-05,   7.0035218E-05
     +,   7.2850402E-05,   7.5945725E-05,   7.9340854E-05
     +,   8.3055740E-05,   8.7108019E-05,   9.1515707E-05
     +,   9.6294614E-05,   1.0145954E-04,   1.0702615E-04
     +,   1.1300835E-04,   1.1942339E-04,   1.2628938E-04
     +,   1.3363035E-04,   1.4147761E-04,   1.4987298E-04
     +,   1.5887250E-04,   1.6854976E-04,   1.7899919E-04
     +,   1.9033824E-04,   2.0270780E-04,   2.1627062E-04
     +,   2.3120645E-04,   2.4770439E-04,   2.6595307E-04
     +,   2.8612319E-04,   3.0836329E-04,   3.3277294E-04
     +,   3.5940169E-04,   3.8823721E-04,   4.1919568E-04
     +,   4.5213578E-04,   4.8684236E-04,   5.2304519E-04
     +,   5.6041346E-04,   5.9855747E-04,   6.3702744E-04
     +,   6.7531184E-04,   7.1284326E-04,   7.4901484E-04
     +,   7.8321336E-04,   8.1487378E-04,   8.4355200E-04
     +,   8.6901285E-04,   8.9132239E-04,   9.1093907E-04
     +,   9.2878583E-04,   9.4629690E-04,   9.6543506E-04
     +,   9.8865083E-04,   1.0187781E-03,   1.0588354E-03
     +,   1.1117082E-03,   1.1797363E-03,   1.2642072E-03
     +,   1.3648595E-03,   1.4795045E-03,   1.6039282E-03
     +,   1.7322095E-03,   1.8575581E-03,   1.9736383E-03
     +,   2.0762077E-03,   2.1646891E-03,   2.2431193E-03
     +,   2.3198803E-03,   2.4057650E-03,   2.5104622E-03
     +,   2.6382662E-03,   2.7845807E-03,   2.9350289E-03
     +,   3.0682010E-03,   3.1617356E-03,   3.1996977E-03
     +,   3.1784128E-03,   3.1083163E-03,   3.0110623E-03
     +,   2.9130206E-03,   2.8377189E-03,   2.7999687E-03
     +,   2.8034712E-03,   2.8422286E-03,   2.9045134E-03
     +,   2.9774092E-03,   3.0500528E-03,   3.1146980E-03
     +,   3.1658346E-03,   3.1984516E-03,   3.2066114E-03
     +,   3.1831951E-03,   3.1209872E-03,   3.0146535E-03
     +,   2.8627815E-03,   2.6690923E-03,   2.4423215E-03
     +,   2.1946698E-03,   1.9395415E-03,   1.6892399E-03
     +,   1.4533415E-03,   1.2380431E-03,   1.0463672E-03
     +,   8.7889202E-04,   7.3460699E-04,   6.1164290E-04
     +,   5.0776225E-04,   4.2063970E-04,   3.4800387E-04
     +,   2.8770944E-04,   2.3778260E-04,   1.9646659E-04
     +,   1.6222450E-04,   1.3377467E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_nwao_hz_100 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_nwao_hz_105(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  6.4150847E-18,   8.8265904E-18
     +,   1.2123062E-17,   1.6621099E-17,   2.2747356E-17
     +,   3.1076295E-17,   4.2379394E-17,   5.7690792E-17
     +,   7.8394924E-17,   1.0633937E-16,   1.4398779E-16
     +,   1.9461863E-16,   2.6258524E-16,   3.5365722E-16
     +,   4.7547231E-16,   6.3810195E-16,   8.5483788E-16
     +,   1.1431491E-15,   1.5259785E-15,   2.0334070E-15
     +,   2.7047310E-15,   3.5912804E-15,   4.7599618E-15
     +,   6.2977141E-15,   8.3174875E-15,   1.0965439E-14
     +,   1.4430633E-14,   1.8957097E-14,   2.4859294E-14
     +,   3.2540841E-14,   4.2520176E-14,   5.5461207E-14
     +,   7.2212229E-14,   9.3855052E-14,   1.2176806E-13
     +,   1.5770103E-13,   2.0387411E-13,   2.6309751E-13
     +,   3.3892041E-13,   4.3582038E-13,   5.5942512E-13
     +,   7.1680915E-13,   9.1683573E-13,   1.1705949E-12
     +,   1.4919284E-12,   1.8980960E-12,   2.4105303E-12
     +,   3.0558683E-12,   3.8670967E-12,   4.8849544E-12
     +,   6.1597398E-12,   7.7533761E-12,   9.7419650E-12
     +,   1.2218800E-11,   1.5298093E-11,   1.9119350E-11
     +,   2.3852717E-11,   2.9704812E-11,   3.6926906E-11
     +,   4.5823411E-11,   5.6761904E-11,   7.0186378E-11
     +,   8.6631508E-11,   1.0673951E-10,   1.3128093E-10
     +,   1.6117770E-10,   1.9753177E-10,   2.4165359E-10
     +,   2.9510505E-10,   3.5973813E-10,   4.3774923E-10
     +,   5.3172744E-10,   6.4473227E-10,   7.8036200E-10
     +,   9.4284414E-10,   1.1371311E-09,   1.3690203E-09
     +,   1.6452562E-09,   1.9737143E-09,   2.3635360E-09
     +,   2.8253098E-09,   3.3713132E-09,   4.0156594E-09
     +,   4.7746473E-09,   5.6669904E-09,   6.7141430E-09
     +,   7.9406393E-09,   9.3744719E-09,   1.1047523E-08
     +,   1.2996102E-08,   1.5261067E-08,   1.7888892E-08
     +,   2.0931894E-08,   2.4448978E-08,   2.8506195E-08
     +,   3.3177582E-08,   3.8546045E-08,   4.4703214E-08
     +,   5.1751673E-08,   5.9804911E-08,   6.8988385E-08
     +,   7.9440483E-08,   9.1313375E-08,   1.0477407E-07
     +,   1.2000520E-07,   1.3720593E-07,   1.5659310E-07
     +,   1.7840168E-07,   2.0288604E-07,   2.3032013E-07
     +,   2.6099883E-07,   2.9523952E-07,   3.3337608E-07
     +,   3.7576933E-07,   4.2279990E-07,   4.7487060E-07
     +,   5.3240518E-07,   5.9584892E-07,   6.6566986E-07
     +,   7.4234566E-07,   8.2638104E-07,   9.1829264E-07
     +,   1.0186119E-06,   1.1278801E-06,   1.2466485E-06
     +,   1.3754719E-06,   1.5149084E-06,   1.6655111E-06
     +,   1.8278290E-06,   2.0023979E-06,   2.1897367E-06
     +,   2.3903526E-06,   2.6046955E-06,   2.8332095E-06
     +,   3.0762892E-06,   3.3342824E-06,   3.6074839E-06
     +,   3.8961275E-06,   4.2003803E-06,   4.5203524E-06
     +,   4.8560287E-06,   5.2073524E-06,   5.5741589E-06
     +,   5.9561899E-06,   6.3530824E-06,   6.7643673E-06
     +,   7.1894656E-06,   7.6276856E-06,   8.0782211E-06
     +,   8.5401480E-06,   9.0124286E-06,   9.4939305E-06
     +,   9.9833414E-06,   1.0479308E-05,   1.0980347E-05
     +,   1.1484875E-05,   1.1991218E-05,   1.2497611E-05
     +,   1.3002227E-05,   1.3503155E-05,   1.3998449E-05
     +,   1.4486128E-05,   1.4964127E-05,   1.5430436E-05
     +,   1.5883023E-05,   1.6319886E-05,   1.6739057E-05
     +,   1.7138647E-05,   1.7516850E-05,   1.7871982E-05
     +,   1.8202514E-05,   1.8507120E-05,   1.8784718E-05
     +,   1.9034545E-05,   1.9256189E-05,   1.9449744E-05
     +,   1.9615896E-05,   1.9756049E-05,   1.9872503E-05
     +,   1.9968667E-05,   2.0049263E-05,   2.0120640E-05
     +,   2.0191039E-05,   2.0270947E-05,   2.0373469E-05
     +,   2.0514668E-05,   2.0713931E-05,   2.0994283E-05
     +,   2.1382630E-05,   2.1909887E-05,   2.2610984E-05
     +,   2.3524593E-05,   2.4692772E-05,   2.6159865E-05
     +,   2.7972143E-05,   3.0175321E-05,   3.2814143E-05
     +,   3.5929064E-05,   3.9554379E-05,   4.3717046E-05
     +,   4.8431997E-05,   5.3703061E-05,   5.9518243E-05
     +,   6.5851360E-05,   7.2661001E-05,   7.9892183E-05
     +,   8.7479180E-05,   9.5349955E-05,   1.0343220E-04
     +,   1.1166068E-04,   1.1998594E-04,   1.2838334E-04
     +,   1.3686188E-04,   1.4547197E-04,   1.5431085E-04
     +,   1.6352229E-04,   1.7329754E-04,   1.8386068E-04
     +,   1.9545743E-04,   2.0833236E-04,   2.2269927E-04
     +,   2.3871861E-04,   2.5645812E-04,   2.7587428E-04
     +,   2.9679027E-04,   3.1888994E-04,   3.4172562E-04
     +,   3.6474274E-04,   3.8731936E-04,   4.0881839E-04
     +,   4.2864567E-04,   4.4630782E-04,   4.6146082E-04
     +,   4.7394121E-04,   4.8377670E-04,   4.9117382E-04
     +,   4.9648690E-04,   5.0017581E-04,   5.0276652E-04
     +,   5.0482235E-04,   5.0694088E-04,   5.0977390E-04
     +,   5.1406806E-04,   5.2070763E-04,   5.3073413E-04
     +,   5.4531789E-04,   5.6566362E-04,   5.9285149E-04
     +,   6.2763761E-04,   6.7026104E-04,   7.2031812E-04
     +,   7.7675004E-04,   8.3796441E-04,   9.0207136E-04
     +,   9.6716970E-04,   1.0316077E-03,   1.0941551E-03
     +,   1.1540608E-03,   1.2109965E-03,   1.2649794E-03
     +,   1.3162509E-03,   1.3651768E-03,   1.4121188E-03
     +,   1.4572486E-03,   1.5003174E-03,   1.5404073E-03
     +,   1.5757867E-03,   1.6039679E-03,   1.6220263E-03
     +,   1.6271257E-03,   1.6170985E-03,   1.5909031E-03
     +,   1.5488026E-03,   1.4922365E-03,   1.4234686E-03
     +,   1.3451553E-03,   1.2599853E-03,   1.1704614E-03
     +,   1.0788358E-03,   9.8707934E-04,   8.9690101E-04
     +,   8.0971472E-04,   7.2659343E-04,   6.4825726E-04
     +,   5.7506684E-04,   5.0710805E-04,   4.4429090E-04
     +,   3.8645443E-04,   3.3344529E-04,   2.8515552E-04
     +,   2.4151956E-04,   2.0248559E-04,   1.6797747E-04
     +,   1.3786294E-04,   1.1193640E-04,   8.9918423E-05
     +,   7.1469083E-05,   5.6208239E-05,   4.3742071E-05
     +,   3.3677366E-05,   2.5645906E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_nwao_hz_105 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_nwao_hz_110(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  7.3189418E-29,   1.2373096E-28
     +,   2.0863965E-28,   3.5092579E-28,   5.8872895E-28
     +,   9.8516103E-28,   1.6443303E-27,   2.7375424E-27
     +,   4.5459993E-27,   7.5298476E-27,   1.2440266E-26
     +,   2.0500598E-26,   3.3697035E-26,   5.5246986E-26
     +,   9.0348036E-26,   1.4737222E-25,   2.3977513E-25
     +,   3.8911930E-25,   6.2987294E-25,   1.0169895E-24
     +,   1.6378222E-24,   2.6309263E-24,   4.2154013E-24
     +,   6.7369108E-24,   1.0739384E-23,   1.7075876E-23
     +,   2.7081743E-23,   4.2841064E-23,   6.7598778E-23
     +,   1.0639122E-22,   1.6701715E-22,   2.6152191E-22
     +,   4.0845577E-22,   6.3631722E-22,   9.8877083E-22
     +,   1.5325194E-21,   2.3692159E-21,   3.6533676E-21
     +,   5.6192112E-21,   8.6208626E-21,   1.3192063E-20
     +,   2.0135610E-20,   3.0655504E-20,   4.6552235E-20
     +,   7.0512475E-20,   1.0653311E-19,   1.6054251E-19
     +,   2.4131562E-19,   3.6180536E-19,   5.4106933E-19
     +,   8.0708638E-19,   1.2008223E-18,   1.7820814E-18
     +,   2.6379487E-18,   3.8948970E-18,   5.7360964E-18
     +,   8.4261853E-18,   1.2346197E-17,   1.8043655E-17
     +,   2.6303333E-17,   3.8245877E-17,   5.5468763E-17
     +,   8.0242091E-17,   1.1578379E-16,   1.6664156E-16
     +,   2.3922669E-16,   3.4255487E-16,   4.8925639E-16
     +,   6.9700155E-16,   9.9042737E-16,   1.4038015E-15
     +,   1.9846071E-15,   2.7985634E-15,   3.9362773E-15
     +,   5.5223905E-15,   7.7278475E-15,   1.0786588E-14
     +,   1.5017484E-14,   2.0854566E-14,   2.8886510E-14
     +,   3.9909831E-14,   5.4999401E-14,   7.5600313E-14
     +,   1.0365257E-13,   1.4175141E-13,   1.9335912E-13
     +,   2.6308304E-13,   3.5703588E-13,   4.8330448E-13
     +,   6.5257028E-13,   8.7885482E-13,   1.1805888E-12
     +,   1.5818679E-12,   2.1141301E-12,   2.8182851E-12
     +,   3.7473839E-12,   4.9701280E-12,   6.5749437E-12
     +,   8.6757398E-12,   1.1418585E-11,   1.4990236E-11
     +,   1.9628856E-11,   2.5637310E-11,   3.3399526E-11
     +,   4.3400880E-11,   5.6253256E-11,   7.2725583E-11
     +,   9.3781496E-11,   1.2062527E-10,   1.5475675E-10
     +,   1.9803922E-10,   2.5278349E-10,   3.2183375E-10
     +,   4.0870066E-10,   5.1768961E-10,   6.5406974E-10
     +,   8.2426921E-10,   1.0361079E-09,   1.2990810E-09
     +,   1.6246241E-09,   2.0265662E-09,   2.5214990E-09
     +,   3.1293028E-09,   3.8737076E-09,   4.7829611E-09
     +,   5.8905645E-09,   7.2361614E-09,   8.8664462E-09
     +,   1.0836324E-08,   1.3210052E-08,   1.6062678E-08
     +,   1.9481650E-08,   2.3567853E-08,   2.8438386E-08
     +,   3.4227938E-08,   4.1091013E-08,   4.9204370E-08
     +,   5.8769352E-08,   7.0014629E-08,   8.3199474E-08
     +,   9.8614251E-08,   1.1658677E-07,   1.3748313E-07
     +,   1.6171124E-07,   1.8972362E-07,   2.2202060E-07
     +,   2.5915276E-07,   3.0172336E-07,   3.5039059E-07
     +,   4.0586968E-07,   4.6893368E-07,   5.4041760E-07
     +,   6.2120569E-07,   7.1224895E-07,   8.1455210E-07
     +,   9.2917276E-07,   1.0572182E-06,   1.1998402E-06
     +,   1.3582285E-06,   1.5336021E-06,   1.7272021E-06
     +,   1.9402892E-06,   2.1740927E-06,   2.4298547E-06
     +,   2.7087758E-06,   3.0120100E-06,   3.3406445E-06
     +,   3.6956833E-06,   4.0780242E-06,   4.4884400E-06
     +,   4.9275563E-06,   5.3958320E-06,   5.8935339E-06
     +,   6.4207447E-06,   6.9772427E-06,   7.5626299E-06
     +,   8.1762191E-06,   8.8170382E-06,   9.4838242E-06
     +,   1.0175042E-05,   1.0888720E-05,   1.1622797E-05
     +,   1.2374670E-05,   1.3141575E-05,   1.3920399E-05
     +,   1.4707771E-05,   1.5500038E-05,   1.6293321E-05
     +,   1.7083543E-05,   1.7866441E-05,   1.8637636E-05
     +,   1.9392673E-05,   2.0127112E-05,   2.0836449E-05
     +,   2.1516542E-05,   2.2163271E-05,   2.2773145E-05
     +,   2.3343082E-05,   2.3870829E-05,   2.4355391E-05
     +,   2.4797084E-05,   2.5198364E-05,   2.5564139E-05
     +,   2.5902698E-05,   2.6226457E-05,   2.6552971E-05
     +,   2.6905976E-05,   2.7316490E-05,   2.7823822E-05
     +,   2.8476470E-05,   2.9332696E-05,   3.0460678E-05
     +,   3.1938107E-05,   3.3851135E-05,   3.6292840E-05
     +,   3.9360311E-05,   4.3153574E-05,   4.7771075E-05
     +,   5.3309403E-05,   5.9861894E-05,   6.7517823E-05
     +,   7.6368568E-05,   8.6506785E-05,   9.8035795E-05
     +,   1.1107289E-04,   1.2575308E-04,   1.4222847E-04
     +,   1.6066150E-04,   1.8120995E-04,   2.0400312E-04
     +,   2.2910895E-04,   2.5649468E-04,   2.8598451E-04
     +,   3.1722005E-04,   3.4963051E-04,   3.8242093E-04
     +,   4.1458735E-04,   4.4495799E-04,   4.7228645E-04
     +,   4.9536995E-04,   5.1320641E-04,   5.2517297E-04
     +,   5.3120143E-04,   5.3192920E-04,   5.2878400E-04
     +,   5.2397797E-04,   5.2038196E-04,   5.2127510E-04
     +,   5.2998029E-04,   5.4943014E-04,   5.8172637E-04
     +,   6.2778505E-04,   6.8715290E-04,   7.5806043E-04
     +,   8.3772518E-04,   9.2283718E-04,   1.0100979E-03
     +,   1.0966357E-03,   1.1801403E-03,   1.2587174E-03
     +,   1.3304789E-03,   1.3931253E-03,   1.4437498E-03
     +,   1.4790175E-03,   1.4957653E-03,   1.4918037E-03
     +,   1.4666464E-03,   1.4218842E-03,   1.3610151E-03
     +,   1.2888005E-03,   1.2103360E-03,   1.1301544E-03
     +,   1.0516075E-03,   9.7665866E-04,   9.0605358E-04
     +,   8.3972176E-04,   7.7723153E-04,   7.1814342E-04
     +,   6.6221063E-04,   6.0939195E-04,   5.5978884E-04
     +,   5.1353138E-04,   4.7068292E-04,   4.3119545E-04
     +,   3.9488898E-04,   3.6148212E-04,   3.3062766E-04
     +,   3.0195329E-04,   2.7509939E-04,   2.4974911E-04
     +,   2.2565172E-04,   2.0263671E-04,   1.8061903E-04
     +,   1.5959403E-04,   1.3962411E-04,   1.2081801E-04
     +,   1.0330663E-04,   8.7217843E-05,   7.2659255E-05
     +,   5.9695183E-05,   4.8347465E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_nwao_hz_110 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_nwao_hz_115(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   1.7468636E-38
     +,   5.2674748E-38,   1.5757602E-37,   4.6765460E-37
     +,   1.3769694E-36,   4.0220206E-36,   1.1654897E-35
     +,   3.3505799E-35,   9.5559890E-35,   2.7038058E-34
     +,   7.5896087E-34,   2.1136217E-33,   5.8392810E-33
     +,   1.6004263E-32,   4.3516713E-32,   1.1738760E-31
     +,   3.1414553E-31,   8.3403694E-31,   2.1967659E-30
     +,   5.7401924E-30,   1.4880353E-29,   3.8268878E-29
     +,   9.7638798E-29,   2.4714010E-28,   6.2059245E-28
     +,   1.5460214E-27,   3.8211009E-27,   9.3688387E-27
     +,   2.2789185E-26,   5.4993873E-26,   1.3165750E-25
     +,   3.1269505E-25,   7.3678455E-25,   1.7223604E-24
     +,   3.9942027E-24,   9.1893255E-24,   2.0973921E-23
     +,   4.7492282E-23,   1.0668637E-22,   2.3776008E-22
     +,   5.2567187E-22,   1.1530142E-21,   2.5089790E-21
     +,   5.4163516E-21,   1.1599985E-20,   2.4646417E-20
     +,   5.1953030E-20,   1.0864144E-19,   2.2538547E-19
     +,   4.6387441E-19,   9.4715075E-19,   1.9185921E-18
     +,   3.8555782E-18,   7.6867256E-18,   1.5203773E-17
     +,   2.9832623E-17,   5.8073294E-17,   1.1215165E-16
     +,   2.1487151E-16,   4.0841144E-16,   7.7012320E-16
     +,   1.4406770E-15,   2.6737330E-15,   4.9228250E-15
     +,   8.9919349E-15,   1.6294378E-14,   2.9294014E-14
     +,   5.2245839E-14,   9.2441855E-14,   1.6226743E-13
     +,   2.8257735E-13,   4.8818843E-13,   8.3672620E-13
     +,   1.4227276E-12,   2.3999702E-12,   4.0163740E-12
     +,   6.6683204E-12,   1.0983324E-11,   1.7947123E-11
     +,   2.9093793E-11,   4.6789770E-11,   7.4652555E-11
     +,   1.1816376E-10,   1.8555266E-10,   2.8906466E-10
     +,   4.4675241E-10,   6.8498801E-10,   1.0419432E-09
     +,   1.5723782E-09,   2.3540012E-09,   3.4962373E-09
     +,   5.1515614E-09,   7.5304571E-09,   1.0920660E-08
     +,   1.5711842E-08,   2.2425180E-08,   3.1754372E-08
     +,   4.4607539E-08,   6.2166741E-08,   8.5951285E-08
     +,   1.1789401E-07,   1.6042657E-07,   2.1657395E-07
     +,   2.9005633E-07,   3.8539409E-07,   5.0801350E-07
     +,   6.6434626E-07,   8.6192455E-07,   1.1093971E-06
     +,   1.4166765E-06,   1.7947568E-06,   2.2558791E-06
     +,   2.8131931E-06,   3.4806383E-06,   4.2729066E-06
     +,   5.2046803E-06,   6.2908375E-06,   7.5454159E-06
     +,   8.9816849E-06,   1.0611512E-05,   1.2445079E-05
     +,   1.4490668E-05,   1.6754619E-05,   1.9241503E-05
     +,   2.1954573E-05,   2.4896453E-05,   2.8070159E-05
     +,   3.1480296E-05,   3.5134435E-05,   3.9044633E-05
     +,   4.3227727E-05,   4.7708065E-05,   5.2515148E-05
     +,   5.7684869E-05,   6.3257168E-05,   6.9272028E-05
     +,   7.5768650E-05,   8.2776962E-05,   9.0316069E-05
     +,   9.8388547E-05,   1.0697799E-04,   1.1604877E-04
     +,   1.2554950E-04,   1.3542085E-04,   1.4560850E-04
     +,   1.5608090E-04,   1.6685104E-04,   1.7800063E-04
     +,   1.8970332E-04,   2.0224419E-04,   2.1603014E-04
     +,   2.3158861E-04,   2.4954625E-04,   2.7059502E-04
     +,   2.9543249E-04,   3.2468792E-04,   3.5883734E-04
     +,   3.9810635E-04,   4.4239618E-04,   4.9121212E-04
     +,   5.4363057E-04,   5.9830467E-04,   6.5351627E-04
     +,   7.0727454E-04,   7.5745588E-04,   8.0197293E-04
     +,   8.3895394E-04,   8.6691231E-04,   8.8488625E-04
     +,   8.9252525E-04,   8.9011644E-04,   8.7854016E-04
     +,   8.5916306E-04,   8.3368598E-04,   8.0395286E-04
     +,   7.7176653E-04,   7.3871936E-04,   7.0606644E-04
     +,   6.7466003E-04,   6.4492912E-04,   6.1692880E-04
     +,   5.9042312E-04,   5.6499493E-04,   5.4015854E-04
     +,   5.1546120E-04,   4.9055833E-04,   4.6525590E-04
     +,   4.3952093E-04,   4.1346269E-04,   3.8729687E-04
     +,   3.6129905E-04,   3.3575986E-04,   3.1094594E-04
     +,   2.8707911E-04,   2.6431723E-04,   2.4275760E-04
     +,   2.2244392E-04,   2.0337731E-04,   1.8553411E-04
     +,   1.6887217E-04,   1.5334394E-04,   1.3890094E-04
     +,   1.2549643E-04,   1.1308534E-04,   1.0162347E-04
     +,   9.1065995E-05,   8.1366627E-05,   7.2477313E-05
     +,   6.4348766E-05,   5.6931472E-05,   5.0176910E-05
     +,   4.4038828E-05,   3.8473827E-05,   3.3443117E-05
     +,   2.8909852E-05,   2.4842009E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_nwao_hz_115 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_nwao_hz_120(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   1.2507588E-38
     +,   3.6353522E-38,   1.0488308E-37,   3.0036570E-37
     +,   8.5386232E-37,   2.4093771E-36,   6.7485587E-36
     +,   1.8764042E-35,   5.1785468E-35,   1.4186397E-34
     +,   3.8576754E-34,   1.0412744E-33,   2.7899135E-33
     +,   7.4200282E-33,   1.9589632E-32,   5.1334749E-32
     +,   1.3353217E-31,   3.4478343E-31,   8.8367562E-31
     +,   2.2481589E-30,   5.6773695E-30,   1.4231586E-29
     +,   3.5411725E-29,   8.7463496E-29,   2.1443513E-28
     +,   5.2185243E-28,   1.2606334E-27,   3.0228451E-27
     +,   7.1949977E-27,   1.6999963E-26,   3.9868944E-26
     +,   9.2813066E-26,   2.1447144E-25,   4.9194618E-25
     +,   1.1200823E-24,   2.5314633E-24,   5.6792929E-24
     +,   1.2647014E-23,   2.7955634E-23,   6.1338990E-23
     +,   1.3359496E-22,   2.8882250E-22,   6.1981162E-22
     +,   1.3203002E-21,   2.7917404E-21,   5.8595152E-21
     +,   1.2207762E-20,   2.5246316E-20,   5.1825799E-20
     +,   1.0560712E-19,   2.1360669E-19,   4.2886688E-19
     +,   8.5470484E-19,   1.6908206E-18,   3.3202105E-18
     +,   6.4717217E-18,   1.2521630E-17,   2.4049277E-17
     +,   4.5847528E-17,   8.6759606E-17,   1.6296909E-16
     +,   3.0386500E-16,   5.6239594E-16,   1.0332167E-15
     +,   1.8841990E-15,   3.4107372E-15,   6.1285608E-15
     +,   1.0930853E-14,   1.9352487E-14,   3.4010843E-14
     +,   5.9330037E-14,   1.0273515E-13,   1.7658385E-13
     +,   3.0127948E-13,   5.1024267E-13,   8.5777034E-13
     +,   1.4313746E-12,   2.3709585E-12,   3.8983643E-12
     +,   6.3626821E-12,   1.0308063E-11,   1.6576934E-11
     +,   2.6461918E-11,   4.1930400E-11,   6.5952153E-11
     +,   1.0297239E-10,   1.5959037E-10,   2.4552013E-10
     +,   3.7494163E-10,   5.6837907E-10,   8.5528723E-10
     +,   1.2776005E-09,   1.8944091E-09,   2.7884293E-09
     +,   4.0743169E-09,   5.9096696E-09,   8.5091916E-09
     +,   1.2163029E-08,   1.7258719E-08,   2.4311996E-08
     +,   3.3998898E-08,   4.7201404E-08,   6.5057684E-08
     +,   8.9023601E-08,   1.2094402E-07,   1.6313520E-07
     +,   2.1847757E-07,   2.9051986E-07,   3.8359181E-07
     +,   5.0292579E-07,   6.5479094E-07,   8.4658393E-07
     +,   1.0870455E-06,   1.3862426E-06,   1.7558575E-06
     +,   2.2090996E-06,   2.7608205E-06,   3.4277341E-06
     +,   4.2280376E-06,   5.1818620E-06,   6.3106504E-06
     +,   7.6374463E-06,   9.1865186E-06,   1.0983157E-05
     +,   1.3053404E-05,   1.5423750E-05,   1.8120789E-05
     +,   2.1170863E-05,   2.4599691E-05,   2.8432047E-05
     +,   3.2691431E-05,   3.7399794E-05,   4.2577634E-05
     +,   4.8242593E-05,   5.4412340E-05,   6.1100953E-05
     +,   6.8322253E-05,   7.6089105E-05,   8.4412401E-05
     +,   9.3305724E-05,   1.0278058E-04,   1.1285114E-04
     +,   1.2353265E-04,   1.3484173E-04,   1.4679588E-04
     +,   1.5941265E-04,   1.7270778E-04,   1.8669271E-04
     +,   2.0137169E-04,   2.1673767E-04,   2.3276813E-04
     +,   2.4942085E-04,   2.6662945E-04,   2.8430007E-04
     +,   3.0230978E-04,   3.2050256E-04,   3.3869603E-04
     +,   3.5668173E-04,   3.7423248E-04,   3.9111191E-04
     +,   4.0708241E-04,   4.2192164E-04,   4.3543248E-04
     +,   4.4745597E-04,   4.5788172E-04,   4.6665646E-04
     +,   4.7378772E-04,   4.7934480E-04,   4.8345415E-04
     +,   4.8629037E-04,   4.8806425E-04,   4.8900611E-04
     +,   4.8934930E-04,   4.8931135E-04,   4.8907730E-04
     +,   4.8878527E-04,   4.8851554E-04,   4.8828364E-04
     +,   4.8803983E-04,   4.8767199E-04,   4.8701430E-04
     +,   4.8585990E-04,   4.8397545E-04,   4.8111854E-04
     +,   4.7705459E-04,   4.7157361E-04,   4.6450400E-04
     +,   4.5572445E-04,   4.4517158E-04,   4.3284395E-04
     +,   4.1880284E-04,   4.0316815E-04,   3.8611321E-04
     +,   3.6785461E-04,   3.4864261E-04,   3.2874834E-04
     +,   3.0845613E-04,   2.8804585E-04,   2.6778714E-04
     +,   2.4792869E-04,   2.2869075E-04,   2.1026285E-04
     +,   1.9279528E-04,   1.7640095E-04,   1.6115482E-04
     +,   1.4709547E-04,   1.3422834E-04,   1.2252957E-04
     +,   1.1195079E-04,   1.0242417E-04,   9.3867675E-05
     +,   8.6190033E-05,   7.9295583E-05,   7.3088391E-05
     +,   6.7475761E-05,   6.2370978E-05,   5.7696383E-05
     +,   5.3382482E-05,   4.9371563E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_nwao_hz_120 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_nwao_hz_60(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  9.0916120E-07,   1.0110444E-06
     +,   1.1229371E-06,   1.2456521E-06,   1.3800413E-06
     +,   1.5270095E-06,   1.6875059E-06,   1.8625262E-06
     +,   2.0531149E-06,   2.2603494E-06,   2.4853634E-06
     +,   2.7293274E-06,   2.9934506E-06,   3.2789819E-06
     +,   3.5872076E-06,   3.9194251E-06,   4.2769771E-06
     +,   4.6612199E-06,   5.0735257E-06,   5.5152850E-06
     +,   5.9878603E-06,   6.4926389E-06,   7.0309848E-06
     +,   7.6042425E-06,   8.2137349E-06,   8.8607094E-06
     +,   9.5463965E-06,   1.0271959E-05,   1.1038499E-05
     +,   1.1846980E-05,   1.2698334E-05,   1.3593356E-05
     +,   1.4532724E-05,   1.5516993E-05,   1.6546583E-05
     +,   1.7621700E-05,   1.8742454E-05,   1.9908743E-05
     +,   2.1120293E-05,   2.2376646E-05,   2.3677061E-05
     +,   2.5020663E-05,   2.6406335E-05,   2.7832719E-05
     +,   2.9298246E-05,   3.0801126E-05,   3.2339241E-05
     +,   3.3910357E-05,   3.5511981E-05,   3.7141297E-05
     +,   3.8795370E-05,   4.0471034E-05,   4.2164887E-05
     +,   4.3873359E-05,   4.5592686E-05,   4.7318954E-05
     +,   4.9048129E-05,   5.0775936E-05,   5.2498119E-05
     +,   5.4210326E-05,   5.5908044E-05,   5.7586840E-05
     +,   5.9242200E-05,   6.0869690E-05,   6.2464867E-05
     +,   6.4023399E-05,   6.5541069E-05,   6.7013687E-05
     +,   6.8437344E-05,   6.9808280E-05,   7.1122937E-05
     +,   7.2377952E-05,   7.3570285E-05,   7.4697156E-05
     +,   7.5756077E-05,   7.6744887E-05,   7.7661782E-05
     +,   7.8505233E-05,   7.9274156E-05,   7.9967751E-05
     +,   8.0585662E-05,   8.1127866E-05,   8.1594684E-05
     +,   8.1986866E-05,   8.2305465E-05,   8.2551916E-05
     +,   8.2727973E-05,   8.2835722E-05,   8.2877523E-05
     +,   8.2856059E-05,   8.2774248E-05,   8.2635248E-05
     +,   8.2442442E-05,   8.2199382E-05,   8.1909762E-05
     +,   8.1577440E-05,   8.1206330E-05,   8.0800470E-05
     +,   8.0363883E-05,   7.9900645E-05,   7.9414793E-05
     +,   7.8910300E-05,   7.8391131E-05,   7.7861092E-05
     +,   7.7323923E-05,   7.6783217E-05,   7.6242402E-05
     +,   7.5704731E-05,   7.5173317E-05,   7.4651027E-05
     +,   7.4140575E-05,   7.3644413E-05,   7.3164891E-05
     +,   7.2704046E-05,   7.2263771E-05,   7.1845730E-05
     +,   7.1451432E-05,   7.1082206E-05,   7.0739174E-05
     +,   7.0423375E-05,   7.0135684E-05,   6.9876878E-05
     +,   6.9647649E-05,   6.9448608E-05,   6.9280344E-05
     +,   6.9143396E-05,   6.9038324E-05,   6.8965746E-05
     +,   6.8926296E-05,   6.8920664E-05,   6.8949681E-05
     +,   6.9014241E-05,   6.9115384E-05,   6.9254296E-05
     +,   6.9432303E-05,   6.9650880E-05,   6.9911650E-05
     +,   7.0216411E-05,   7.0567134E-05,   7.0965885E-05
     +,   7.1414877E-05,   7.1916416E-05,   7.2472925E-05
     +,   7.3086863E-05,   7.3760712E-05,   7.4496973E-05
     +,   7.5298063E-05,   7.6166318E-05,   7.7103978E-05
     +,   7.8113058E-05,   7.9195386E-05,   8.0352576E-05
     +,   8.1585713E-05,   8.2895749E-05,   8.4283129E-05
     +,   8.5747924E-05,   8.7289685E-05,   8.8907465E-05
     +,   9.0599795E-05,   9.2364673E-05,   9.4199560E-05
     +,   9.6101430E-05,   9.8066426E-05,   1.0009047E-04
     +,   1.0216884E-04,   1.0429636E-04,   1.0646739E-04
     +,   1.0867589E-04,   1.1091549E-04,   1.1317951E-04
     +,   1.1546106E-04,   1.1775308E-04,   1.2004840E-04
     +,   1.2233996E-04,   1.2462048E-04,   1.2688305E-04
     +,   1.2912093E-04,   1.3132756E-04,   1.3349677E-04
     +,   1.3562289E-04,   1.3770023E-04,   1.3972430E-04
     +,   1.4169044E-04,   1.4359492E-04,   1.4543440E-04
     +,   1.4720618E-04,   1.4890802E-04,   1.5053828E-04
     +,   1.5209573E-04,   1.5357976E-04,   1.5499005E-04
     +,   1.5632674E-04,   1.5759029E-04,   1.5878130E-04
     +,   1.5990090E-04,   1.6094997E-04,   1.6192981E-04
     +,   1.6284155E-04,   1.6368624E-04,   1.6446516E-04
     +,   1.6517902E-04,   1.6582871E-04,   1.6641468E-04
     +,   1.6693721E-04,   1.6739636E-04,   1.6779179E-04
     +,   1.6812296E-04,   1.6838903E-04,   1.6858893E-04
     +,   1.6872122E-04,   1.6878436E-04,   1.6877650E-04
     +,   1.6869578E-04,   1.6854005E-04,   1.6830716E-04
     +,   1.6799496E-04,   1.6760131E-04,   1.6712403E-04
     +,   1.6656106E-04,   1.6591056E-04,   1.6517089E-04
     +,   1.6434040E-04,   1.6341795E-04,   1.6240255E-04
     +,   1.6129341E-04,   1.6009020E-04,   1.5879281E-04
     +,   1.5740145E-04,   1.5591666E-04,   1.5433932E-04
     +,   1.5267065E-04,   1.5091206E-04,   1.4906537E-04
     +,   1.4713261E-04,   1.4511612E-04,   1.4301843E-04
     +,   1.4084230E-04,   1.3859083E-04,   1.3626718E-04
     +,   1.3387470E-04,   1.3141692E-04,   1.2889743E-04
     +,   1.2632021E-04,   1.2368915E-04,   1.2100823E-04
     +,   1.1828163E-04,   1.1551351E-04,   1.1270820E-04
     +,   1.0987005E-04,   1.0700351E-04,   1.0411300E-04
     +,   1.0120308E-04,   9.8278251E-05,   9.5343108E-05
     +,   9.2402210E-05,   8.9460140E-05,   8.6521453E-05
     +,   8.3590567E-05,   8.0672260E-05,   7.7770812E-05
     +,   7.4890631E-05,   7.2036026E-05,   6.9211048E-05
     +,   6.6420042E-05,   6.3666826E-05,   6.0955223E-05
     +,   5.8288846E-05,   5.5671157E-05,   5.3105428E-05
     +,   5.0594714E-05,   4.8141846E-05,   4.5749432E-05
     +,   4.3419830E-05,   4.1155163E-05,   3.8957289E-05
     +,   3.6827809E-05,   3.4768069E-05,   3.2779062E-05
     +,   3.0861778E-05,   2.9016692E-05,   2.7244112E-05
     +,   2.5544106E-05,   2.3916420E-05,   2.2360797E-05
     +,   2.0876538E-05,   1.9462817E-05,   1.8118611E-05
     +,   1.6842710E-05,   1.5633750E-05,   1.4490211E-05
     +,   1.3410433E-05,   1.2392637E-05,   1.1434945E-05
     +,   1.0535380E-05,   9.6918957E-06,   8.9023797E-06
     +,   8.1646785E-06,   7.4765703E-06,   6.8359413E-06
     +,   6.2404579E-06,   5.6879890E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_nwao_hz_60 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_nwao_hz_65(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  5.4597085E-06,   5.8587084E-06
     +,   6.2798581E-06,   6.7237911E-06,   7.1910813E-06
     +,   7.6822917E-06,   8.1979342E-06,   8.7384751E-06
     +,   9.3043436E-06,   9.8958699E-06,   1.0513372E-05
     +,   1.1157080E-05,   1.1827162E-05,   1.2523713E-05
     +,   1.3246764E-05,   1.3996225E-05,   1.4771969E-05
     +,   1.5573767E-05,   1.6401305E-05,   1.7254200E-05
     +,   1.8131925E-05,   1.9033920E-05,   1.9959514E-05
     +,   2.0907950E-05,   2.1878410E-05,   2.2869919E-05
     +,   2.3881492E-05,   2.4912038E-05,   2.5960424E-05
     +,   2.7025373E-05,   2.8105616E-05,   2.9199800E-05
     +,   3.0306532E-05,   3.1424363E-05,   3.2551852E-05
     +,   3.3687433E-05,   3.4829627E-05,   3.5976893E-05
     +,   3.7127720E-05,   3.8280625E-05,   3.9434060E-05
     +,   4.0586616E-05,   4.1736886E-05,   4.2883526E-05
     +,   4.4025270E-05,   4.5160952E-05,   4.6289424E-05
     +,   4.7409718E-05,   4.8521004E-05,   4.9622482E-05
     +,   5.0713581E-05,   5.1793861E-05,   5.2863048E-05
     +,   5.3921030E-05,   5.4967903E-05,   5.6003933E-05
     +,   5.7029640E-05,   5.8045665E-05,   5.9052945E-05
     +,   6.0052658E-05,   6.1046121E-05,   6.2034960E-05
     +,   6.3021020E-05,   6.4006381E-05,   6.4993343E-05
     +,   6.5984437E-05,   6.6982459E-05,   6.7990310E-05
     +,   6.9011199E-05,   7.0048467E-05,   7.1105649E-05
     +,   7.2186362E-05,   7.3294395E-05,   7.4433628E-05
     +,   7.5607997E-05,   7.6821423E-05,   7.8077916E-05
     +,   7.9381265E-05,   8.0735314E-05,   8.2143692E-05
     +,   8.3609870E-05,   8.5137086E-05,   8.6728178E-05
     +,   8.8385794E-05,   9.0112109E-05,   9.1908863E-05
     +,   9.3777307E-05,   9.5718162E-05,   9.7731536E-05
     +,   9.9817007E-05,   1.0197325E-04,   1.0419847E-04
     +,   1.0649008E-04,   1.0884475E-04,   1.1125836E-04
     +,   1.1372606E-04,   1.1624238E-04,   1.1880066E-04
     +,   1.2139395E-04,   1.2401436E-04,   1.2665345E-04
     +,   1.2930203E-04,   1.3195038E-04,   1.3458828E-04
     +,   1.3720496E-04,   1.3978935E-04,   1.4233001E-04
     +,   1.4481529E-04,   1.4723343E-04,   1.4957253E-04
     +,   1.5182083E-04,   1.5396673E-04,   1.5599864E-04
     +,   1.5790548E-04,   1.5967664E-04,   1.6130193E-04
     +,   1.6277179E-04,   1.6407728E-04,   1.6521037E-04
     +,   1.6616363E-04,   1.6693075E-04,   1.6750631E-04
     +,   1.6788585E-04,   1.6806609E-04,   1.6804470E-04
     +,   1.6782052E-04,   1.6739358E-04,   1.6676504E-04
     +,   1.6593712E-04,   1.6491328E-04,   1.6369803E-04
     +,   1.6229700E-04,   1.6071706E-04,   1.5896581E-04
     +,   1.5705203E-04,   1.5498536E-04,   1.5277637E-04
     +,   1.5043636E-04,   1.4797742E-04,   1.4541215E-04
     +,   1.4275411E-04,   1.4001697E-04,   1.3721494E-04
     +,   1.3436262E-04,   1.3147466E-04,   1.2856610E-04
     +,   1.2565182E-04,   1.2274667E-04,   1.1986549E-04
     +,   1.1702274E-04,   1.1423259E-04,   1.1150871E-04
     +,   1.0886458E-04,   1.0631276E-04,   1.0386518E-04
     +,   1.0153318E-04,   9.9327124E-05,   9.7256576E-05
     +,   9.5330142E-05,   9.3555434E-05,   9.1939037E-05
     +,   9.0486385E-05,   8.9201989E-05,   8.8089073E-05
     +,   8.7149725E-05,   8.6384920E-05,   8.5794483E-05
     +,   8.5377105E-05,   8.5130327E-05,   8.5050648E-05
     +,   8.5133463E-05,   8.5373184E-05,   8.5763248E-05
     +,   8.6296248E-05,   8.6963802E-05,   8.7756867E-05
     +,   8.8665700E-05,   8.9679917E-05,   9.0788635E-05
     +,   9.1980546E-05,   9.3243842E-05,   9.4566814E-05
     +,   9.5937197E-05,   9.7342920E-05,   9.8771918E-05
     +,   1.0021219E-04,   1.0165204E-04,   1.0308005E-04
     +,   1.0448523E-04,   1.0585707E-04,   1.0718562E-04
     +,   1.0846162E-04,   1.0967652E-04,   1.1082234E-04
     +,   1.1189233E-04,   1.1288017E-04,   1.1378083E-04
     +,   1.1458993E-04,   1.1530409E-04,   1.1592105E-04
     +,   1.1643933E-04,   1.1685855E-04,   1.1717914E-04
     +,   1.1740247E-04,   1.1753085E-04,   1.1756734E-04
     +,   1.1751580E-04,   1.1738078E-04,   1.1716752E-04
     +,   1.1688178E-04,   1.1652985E-04,   1.1611839E-04
     +,   1.1565445E-04,   1.1514526E-04,   1.1459819E-04
     +,   1.1402073E-04,   1.1342022E-04,   1.1280400E-04
     +,   1.1217912E-04,   1.1155233E-04,   1.1093008E-04
     +,   1.1031827E-04,   1.0972241E-04,   1.0914736E-04
     +,   1.0859738E-04,   1.0807604E-04,   1.0758628E-04
     +,   1.0713026E-04,   1.0670943E-04,   1.0632448E-04
     +,   1.0597538E-04,   1.0566134E-04,   1.0538090E-04
     +,   1.0513189E-04,   1.0491151E-04,   1.0471635E-04
     +,   1.0454248E-04,   1.0438546E-04,   1.0424043E-04
     +,   1.0410215E-04,   1.0396511E-04,   1.0382355E-04
     +,   1.0367161E-04,   1.0350332E-04,   1.0331268E-04
     +,   1.0309379E-04,   1.0284090E-04,   1.0254844E-04
     +,   1.0221109E-04,   1.0182388E-04,   1.0138217E-04
     +,   1.0088181E-04,   1.0031900E-04,   9.9690544E-05
     +,   9.8993696E-05,   9.8226250E-05,   9.7386597E-05
     +,   9.6473603E-05,   9.5486845E-05,   9.4426330E-05
     +,   9.3292627E-05,   9.2086877E-05,   9.0810630E-05
     +,   8.9466106E-05,   8.8055807E-05,   8.6582695E-05
     +,   8.5050124E-05,   8.3461746E-05,   8.1821563E-05
     +,   8.0133788E-05,   7.8402882E-05,   7.6633427E-05
     +,   7.4830161E-05,   7.2997900E-05,   7.1141476E-05
     +,   6.9265734E-05,   6.7375484E-05,   6.5475382E-05
     +,   6.3570216E-05,   6.1664410E-05,   5.9762286E-05
     +,   5.7867997E-05,   5.5985416E-05,   5.4118427E-05
     +,   5.2270425E-05,   5.0444665E-05,   4.8644150E-05
     +,   4.6871599E-05,   4.5129487E-05,   4.3420034E-05
     +,   4.1745188E-05,   4.0106686E-05,   3.8505972E-05
     +,   3.6944268E-05,   3.5422599E-05,   3.3941738E-05
     +,   3.2502281E-05,   3.1104566E-05,   2.9748999E-05
     +,   2.8435399E-05,   2.7163855E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_nwao_hz_65 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_nwao_hz_70(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  2.5359504E-12,   3.4631493E-12
     +,   4.7159381E-12,   6.4037712E-12,   8.6709702E-12
     +,   1.1707580E-11,   1.5762867E-11,   2.1162761E-11
     +,   2.8332269E-11,   3.7823158E-11,   5.0350540E-11
     +,   6.6837764E-11,   8.8473090E-11,   1.1678128E-10
     +,   1.5371325E-10,   2.0175298E-10,   2.6406025E-10
     +,   3.4463665E-10,   4.4853485E-10,   5.8211758E-10
     +,   7.5335577E-10,   9.7222952E-10,   1.2511734E-09
     +,   1.6056348E-09,   2.0547593E-09,   2.6221403E-09
     +,   3.3368375E-09,   4.2344799E-09,   5.3586340E-09
     +,   6.7622961E-09,   8.5098968E-09,   1.0679368E-08
     +,   1.3364708E-08,   1.6678912E-08,   2.0757462E-08
     +,   2.5761794E-08,   3.1884348E-08,   3.9353260E-08
     +,   4.8438046E-08,   5.9456596E-08,   7.2781141E-08
     +,   8.8847820E-08,   1.0816497E-07,   1.3132279E-07
     +,   1.5900466E-07,   1.9199943E-07,   2.3121136E-07
     +,   2.7767831E-07,   3.3258496E-07,   3.9727411E-07
     +,   4.7327023E-07,   5.6229266E-07,   6.6627382E-07
     +,   7.8737742E-07,   9.2801690E-07,   1.0908743E-06
     +,   1.2789212E-06,   1.4954202E-06,   1.7439646E-06
     +,   2.0284833E-06,   2.3532336E-06,   2.7228443E-06
     +,   3.1423031E-06,   3.6169617E-06,   4.1525377E-06
     +,   4.7551043E-06,   5.4311017E-06,   6.1872474E-06
     +,   7.0306141E-06,   7.9685278E-06,   9.0085796E-06
     +,   1.0158468E-05,   1.1426098E-05,   1.2819416E-05
     +,   1.4346360E-05,   1.6014776E-05,   1.7832384E-05
     +,   1.9806484E-05,   2.1944121E-05,   2.4251802E-05
     +,   2.6735397E-05,   2.9400117E-05,   3.2250100E-05
     +,   3.5288675E-05,   3.8517956E-05,   4.1938816E-05
     +,   4.5550740E-05,   4.9351696E-05,   5.3338052E-05
     +,   5.7504647E-05,   6.1843988E-05,   6.6347238E-05
     +,   7.1003509E-05,   7.5799944E-05,   8.0721780E-05
     +,   8.5752341E-05,   9.0873284E-05,   9.6063821E-05
     +,   1.0130218E-04,   1.0656482E-04,   1.1182681E-04
     +,   1.1706207E-04,   1.2224354E-04,   1.2734353E-04
     +,   1.3233381E-04,   1.3718609E-04,   1.4187218E-04
     +,   1.4636446E-04,   1.5063606E-04,   1.5466126E-04
     +,   1.5841576E-04,   1.6187724E-04,   1.6502493E-04
     +,   1.6784093E-04,   1.7030977E-04,   1.7241882E-04
     +,   1.7415841E-04,   1.7552219E-04,   1.7650699E-04
     +,   1.7711300E-04,   1.7734390E-04,   1.7720678E-04
     +,   1.7671194E-04,   1.7587308E-04,   1.7470695E-04
     +,   1.7323310E-04,   1.7147399E-04,   1.6945440E-04
     +,   1.6720148E-04,   1.6474408E-04,   1.6211274E-04
     +,   1.5933919E-04,   1.5645630E-04,   1.5349730E-04
     +,   1.5049560E-04,   1.4748453E-04,   1.4449692E-04
     +,   1.4156470E-04,   1.3871861E-04,   1.3598771E-04
     +,   1.3339962E-04,   1.3097939E-04,   1.2874971E-04
     +,   1.2673062E-04,   1.2493909E-04,   1.2338898E-04
     +,   1.2209074E-04,   1.2105131E-04,   1.2027395E-04
     +,   1.1975825E-04,   1.1950007E-04,   1.1949155E-04
     +,   1.1972121E-04,   1.2017418E-04,   1.2083227E-04
     +,   1.2167442E-04,   1.2267687E-04,   1.2381378E-04
     +,   1.2505750E-04,   1.2637922E-04,   1.2774958E-04
     +,   1.2913921E-04,   1.3051940E-04,   1.3186288E-04
     +,   1.3314438E-04,   1.3434146E-04,   1.3543497E-04
     +,   1.3640980E-04,   1.3725544E-04,   1.3796629E-04
     +,   1.3854224E-04,   1.3898881E-04,   1.3931730E-04
     +,   1.3954502E-04,   1.3969486E-04,   1.3979535E-04
     +,   1.3987992E-04,   1.3998675E-04,   1.4015786E-04
     +,   1.4043837E-04,   1.4087559E-04,   1.4151822E-04
     +,   1.4241494E-04,   1.4361365E-04,   1.4516020E-04
     +,   1.4709725E-04,   1.4946319E-04,   1.5229103E-04
     +,   1.5560759E-04,   1.5943241E-04,   1.6377713E-04
     +,   1.6864484E-04,   1.7402980E-04,   1.7991597E-04
     +,   1.8627965E-04,   1.9308546E-04,   2.0029134E-04
     +,   2.0784448E-04,   2.1568386E-04,   2.2374303E-04
     +,   2.3194618E-04,   2.4021497E-04,   2.4846388E-04
     +,   2.5660597E-04,   2.6455193E-04,   2.7221211E-04
     +,   2.7949779E-04,   2.8632270E-04,   2.9260427E-04
     +,   2.9826502E-04,   3.0323412E-04,   3.0744792E-04
     +,   3.1085181E-04,   3.1340035E-04,   3.1505889E-04
     +,   3.1580310E-04,   3.1562053E-04,   3.1450976E-04
     +,   3.1248108E-04,   3.0955570E-04,   3.0576639E-04
     +,   3.0115483E-04,   2.9577332E-04,   2.8968163E-04
     +,   2.8294709E-04,   2.7564290E-04,   2.6784683E-04
     +,   2.5963993E-04,   2.5110494E-04,   2.4232484E-04
     +,   2.3338168E-04,   2.2435501E-04,   2.1532076E-04
     +,   2.0635009E-04,   1.9750846E-04,   1.8885474E-04
     +,   1.8044043E-04,   1.7231055E-04,   1.6450095E-04
     +,   1.5704011E-04,   1.4994858E-04,   1.4323900E-04
     +,   1.3691775E-04,   1.3098354E-04,   1.2542927E-04
     +,   1.2024253E-04,   1.1540623E-04,   1.1089945E-04
     +,   1.0669824E-04,   1.0277645E-04,   9.9106488E-05
     +,   9.5659991E-05,   9.2408671E-05,   8.9324771E-05
     +,   8.6381682E-05,   8.3554427E-05,   8.0819998E-05
     +,   7.8157500E-05,   7.5548967E-05,   7.2978663E-05
     +,   7.0433663E-05,   6.7903711E-05,   6.5381057E-05
     +,   6.2860803E-05,   6.0340004E-05,   5.7818001E-05
     +,   5.5296005E-05,   5.2776875E-05,   5.0264887E-05
     +,   4.7765439E-05,   4.5284814E-05,   4.2829921E-05
     +,   4.0408046E-05,   3.8026628E-05,   3.5693120E-05
     +,   3.3414690E-05,   3.1198168E-05,   2.9049786E-05
     +,   2.6975433E-05,   2.4980029E-05,   2.3067822E-05
     +,   2.1242267E-05,   1.9505944E-05,   1.7860848E-05
     +,   1.6307953E-05,   1.4847540E-05,   1.3479189E-05
     +,   1.2201800E-05,   1.1013681E-05,   9.9125955E-06
     +,   8.8958386E-06,   7.9603042E-06,   7.1025547E-06
     +,   6.3188922E-06,   5.6054159E-06,   4.9580981E-06
     +,   4.3728273E-06,   3.8454473E-06,   3.3719143E-06
     +,   2.9480905E-06,   2.5700867E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_nwao_hz_70 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_nwao_hz_75(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  3.1159401E-29,   6.2120196E-29
     +,   1.2330995E-28,   2.4372042E-28,   4.7962223E-28
     +,   9.3978901E-28,   1.8335050E-27,   3.5616904E-27
     +,   6.8890268E-27,   1.3267041E-26,   2.5439872E-26
     +,   4.8571223E-26,   9.2334696E-26,   1.7477308E-25
     +,   3.2939200E-25,   6.1811492E-25,   1.1549146E-24
     +,   2.1486072E-24,   3.9800273E-24,   7.3408351E-24
     +,   1.3481114E-23,   2.4650870E-23,   4.4881121E-23
     +,   8.1362098E-23,   1.4686321E-22,   2.6395306E-22
     +,   4.7235163E-22,   8.4165920E-22,   1.4932752E-21
     +,   2.6379499E-21,   4.6400612E-21,   8.1266246E-21
     +,   1.4171963E-20,   2.4608226E-20,   4.2546949E-20
     +,   7.3245932E-20,   1.2555464E-19,   2.1429749E-19
     +,   3.6419759E-19,   6.1630901E-19,   1.0384621E-18
     +,   1.7422918E-18,   2.9106399E-18,   4.8416875E-18
     +,   8.0194581E-18,   1.3226324E-17,   2.1720555E-17
     +,   3.5517693E-17,   5.7832002E-17,   9.3763199E-17
     +,   1.5137125E-16,   2.4333274E-16,   3.8949995E-16
     +,   6.2081692E-16,   9.8530165E-16,   1.5571386E-15
     +,   2.4504386E-15,   3.8398062E-15,   5.9914219E-15
     +,   9.3092030E-15,   1.4402853E-14,   2.2189285E-14
     +,   3.4040665E-14,   5.2001382E-14,   7.9103208E-14
     +,   1.1982235E-13,   1.8073841E-13,   2.7147208E-13
     +,   4.0603919E-13,   6.0475453E-13,   8.9694327E-13
     +,   1.3246994E-12,   1.9482395E-12,   2.8532534E-12
     +,   4.1611441E-12,   6.0431053E-12,   8.7395291E-12
     +,   1.2586041E-11,   1.8049631E-11,   2.5776650E-11
     +,   3.6657639E-11,   5.1914254E-11,   7.3212596E-11
     +,   1.0281742E-10,   1.4379051E-10,   2.0025169E-10
     +,   2.7771874E-10,   3.8354653E-10,   5.2748972E-10
     +,   7.2243767E-10,   9.8528974E-10,   1.3381731E-09
     +,   1.8098580E-09,   2.4375890E-09,   3.2693472E-09
     +,   4.3666142E-09,   5.8078875E-09,   7.6925266E-09
     +,   1.0146191E-08,   1.3326618E-08,   1.7430869E-08
     +,   2.2703903E-08,   2.9448579E-08,   3.8037282E-08
     +,   4.8925624E-08,   6.2667809E-08,   7.9934445E-08
     +,   1.0153239E-07,   1.2842712E-07,   1.6176732E-07
     +,   2.0291158E-07,   2.5346029E-07,   3.1527682E-07
     +,   3.9053404E-07,   4.8173871E-07,   5.9176830E-07
     +,   7.2390378E-07,   8.8186397E-07,   1.0698428E-06
     +,   1.2925018E-06,   1.5550427E-06,   1.8631894E-06
     +,   2.2232045E-06,   2.6418838E-06,   3.1265481E-06
     +,   3.6850115E-06,   4.3255450E-06,   5.0568178E-06
     +,   5.8878290E-06,   6.8278114E-06,   7.8861394E-06
     +,   9.0722442E-06,   1.0395272E-05,   1.1864240E-05
     +,   1.3487661E-05,   1.5273437E-05,   1.7228649E-05
     +,   1.9359384E-05,   2.1670550E-05,   2.4165813E-05
     +,   2.6846963E-05,   2.9714445E-05,   3.2766777E-05
     +,   3.6000543E-05,   3.9410334E-05,   4.2988660E-05
     +,   4.6725992E-05,   5.0610728E-05,   5.4629290E-05
     +,   5.8766189E-05,   6.3004198E-05,   6.7324647E-05
     +,   7.1706891E-05,   7.6129742E-05,   8.0570891E-05
     +,   8.5007436E-05,   8.9416339E-05,   9.3774703E-05
     +,   9.8060438E-05,   1.0225270E-04,   1.0633267E-04
     +,   1.1028447E-04,   1.1409541E-04,   1.1775806E-04
     +,   1.2127060E-04,   1.2463835E-04,   1.2787485E-04
     +,   1.3100319E-04,   1.3405696E-04,   1.3708128E-04
     +,   1.4013331E-04,   1.4328241E-04,   1.4660963E-04
     +,   1.5020675E-04,   1.5417377E-04,   1.5861708E-04
     +,   1.6364518E-04,   1.6936447E-04,   1.7587442E-04
     +,   1.8326259E-04,   1.9159811E-04,   2.0093159E-04
     +,   2.1128786E-04,   2.2267082E-04,   2.3506557E-04
     +,   2.4844761E-04,   2.6279569E-04,   2.7810916E-04
     +,   2.9442742E-04,   3.1184891E-04,   3.3054641E-04
     +,   3.5077339E-04,   3.7285741E-04,   3.9717171E-04
     +,   4.2410477E-04,   4.5398471E-04,   4.8703077E-04
     +,   5.2326429E-04,   5.6245609E-04,   6.0410280E-04
     +,   6.4739649E-04,   6.9129077E-04,   7.3454197E-04
     +,   7.7583065E-04,   8.1386283E-04,   8.4747834E-04
     +,   8.7573577E-04,   8.9796254E-04,   9.1377046E-04
     +,   9.2304201E-04,   9.2589954E-04,   9.2267728E-04
     +,   9.1390603E-04,   9.0031902E-04,   8.8287209E-04
     +,   8.6276565E-04,   8.4143237E-04,   8.2050153E-04
     +,   8.0168468E-04,   7.8662077E-04,   7.7668246E-04
     +,   7.7277090E-04,   7.7515660E-04,   7.8338565E-04
     +,   7.9629122E-04,   8.1211101E-04,   8.2869956E-04
     +,   8.4380369E-04,   8.5535122E-04,   8.6170650E-04
     +,   8.6185167E-04,   8.5546478E-04,   8.4289041E-04
     +,   8.2501635E-04,   8.0308411E-04,   7.7847473E-04
     +,   7.5250311E-04,   7.2626193E-04,   7.0051383E-04
     +,   6.7566341E-04,   6.5178319E-04,   6.2868244E-04
     +,   6.0600525E-04,   5.8332353E-04,   5.6022708E-04
     +,   5.3638860E-04,   5.1160314E-04,   4.8580286E-04
     +,   4.5905230E-04,   4.3152808E-04,   4.0349166E-04
     +,   3.7525804E-04,   3.4716682E-04,   3.1955604E-04
     +,   2.9274236E-04,   2.6700529E-04,   2.4257839E-04
     +,   2.1964306E-04,   1.9833178E-04,   1.7872429E-04
     +,   1.6085571E-04,   1.4472110E-04,   1.3028157E-04
     +,   1.1747276E-04,   1.0620748E-04,   9.6383978E-05
     +,   8.7890294E-05,   8.0608734E-05,   7.4419477E-05
     +,   6.9203546E-05,   6.4845204E-05,   6.1233761E-05
     +,   5.8264963E-05,   5.5841905E-05,   5.3875614E-05
     +,   5.2285366E-05,   5.0998766E-05,   4.9951574E-05
     +,   4.9087586E-05,   4.8358033E-05,   4.7721289E-05
     +,   4.7142334E-05,   4.6592158E-05,   4.6047335E-05
     +,   4.5489258E-05,   4.4903765E-05,   4.4280470E-05
     +,   4.3612286E-05,   4.2894950E-05,   4.2126547E-05
     +,   4.1307056E-05,   4.0438052E-05,   3.9522271E-05
     +,   3.8563408E-05,   3.7565806E-05,   3.6534231E-05
     +,   3.5473746E-05,   3.4389450E-05,   3.3286637E-05
     +,   3.2170141E-05,   3.1044980E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_nwao_hz_75 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_nwao_hz_80(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  1.2189128E-29,   2.4558550E-29
     +,   4.9262829E-29,   9.8385800E-29,   1.9562547E-28
     +,   3.8726347E-28,   7.6326876E-28,   1.4977349E-27
     +,   2.9260867E-27,   5.6914250E-27,   1.1021557E-26
     +,   2.1249713E-26,   4.0789782E-26,   7.7953897E-26
     +,   1.4832605E-25,   2.8098308E-25,   5.2994339E-25
     +,   9.9510445E-25,   1.8603555E-24,   3.4627116E-24
     +,   6.4167966E-24,   1.1838821E-23,   2.1746451E-23
     +,   3.9769782E-23,   7.2412654E-23,   1.3126750E-22
     +,   2.3691263E-22,   4.2570357E-22,   7.6158712E-22
     +,   1.3564851E-21,   2.4054630E-21,   4.2468680E-21
     +,   7.4649811E-21,   1.3064020E-20,   2.2762316E-20
     +,   3.9485793E-20,   6.8194896E-20,   1.1726030E-19
     +,   2.0074204E-19,   3.4215171E-19,   5.8060717E-19
     +,   9.8092133E-19,   1.6499658E-18,   2.7631356E-18
     +,   4.6070035E-18,   7.6476338E-18,   1.2639205E-17
     +,   2.0796915E-17,   3.4069988E-17,   5.5568558E-17
     +,   9.0234354E-17,   1.4588324E-16,   2.3481474E-16
     +,   3.7630013E-16,   6.0038622E-16,   9.5370574E-16
     +,   1.5083149E-15,   2.3749370E-15,   3.7230766E-15
     +,   5.8108997E-15,   9.0295889E-15,   1.3969499E-14
     +,   2.1517005E-14,   3.2996744E-14,   5.0378891E-14
     +,   7.6579835E-14,   1.1589689E-13,   1.7462809E-13
     +,   2.6196544E-13,   3.9125785E-13,   5.8180018E-13
     +,   8.6132886E-13,   1.2695560E-12,   1.8630483E-12
     +,   2.7219813E-12,   3.9594435E-12,   5.7342399E-12
     +,   8.2680477E-12,   1.1869155E-11,   1.6963903E-11
     +,   2.4139106E-11,   3.4198758E-11,   4.8237671E-11
     +,   6.7741250E-11,   9.4713341E-11,   1.3184435E-10
     +,   1.8272768E-10,   2.5213912E-10,   3.4639455E-10
     +,   4.7380894E-10,   6.4524674E-10,   8.7487717E-10
     +,   1.1810506E-09,   1.5874189E-09,   2.1243145E-09
     +,   2.8304339E-09,   3.7549310E-09,   4.9597371E-09
     +,   6.5227743E-09,   8.5413587E-09,   1.1136481E-08
     +,   1.4457743E-08,   1.8689210E-08,   2.4056163E-08
     +,   3.0832918E-08,   3.9351789E-08,   5.0013305E-08
     +,   6.3297861E-08,   7.9778715E-08,   1.0013661E-07
     +,   1.2517596E-07,   1.5584469E-07,   1.9324790E-07
     +,   2.3867850E-07,   2.9363542E-07,   3.5985053E-07
     +,   4.3931840E-07,   5.3432541E-07,   6.4748957E-07
     +,   7.8177612E-07,   9.4056475E-07,   1.1276759E-06
     +,   1.3474184E-06,   1.6046387E-06,   1.9047764E-06
     +,   2.2539155E-06,   2.6588482E-06,   3.1271336E-06
     +,   3.6671581E-06,   4.2882052E-06,   5.0005046E-06
     +,   5.8153382E-06,   6.7449250E-06,   7.8026751E-06
     +,   9.0030644E-06,   1.0361657E-05,   1.1895057E-05
     +,   1.3620837E-05,   1.5557396E-05,   1.7723891E-05
     +,   2.0139589E-05,   2.2824142E-05,   2.5796837E-05
     +,   2.9076220E-05,   3.2679611E-05,   3.6622499E-05
     +,   4.0917905E-05,   4.5575751E-05,   5.0602121E-05
     +,   5.5998618E-05,   6.1761668E-05,   6.7882276E-05
     +,   7.4344323E-05,   8.1125909E-05,   8.8198023E-05
     +,   9.5524767E-05,   1.0306351E-04,   1.1076537E-04
     +,   1.1857564E-04,   1.2643487E-04,   1.3427976E-04
     +,   1.4204491E-04,   1.4966290E-04,   1.5706795E-04
     +,   1.6419640E-04,   1.7098896E-04,   1.7739253E-04
     +,   1.8336237E-04,   1.8886394E-04,   1.9387485E-04
     +,   1.9838702E-04,   2.0240816E-04,   2.0596385E-04
     +,   2.0909897E-04,   2.1187897E-04,   2.1439140E-04
     +,   2.1674659E-04,   2.1907761E-04,   2.2153993E-04
     +,   2.2430954E-04,   2.2757964E-04,   2.3155633E-04
     +,   2.3645042E-04,   2.4246948E-04,   2.4980659E-04
     +,   2.5862784E-04,   2.6906136E-04,   2.8118631E-04
     +,   2.9502681E-04,   3.1055088E-04,   3.2767782E-04
     +,   3.4629402E-04,   3.6628003E-04,   3.8753959E-04
     +,   4.1005094E-04,   4.3389411E-04,   4.5930647E-04
     +,   4.8669532E-04,   5.1665289E-04,   5.4994592E-04
     +,   5.8744213E-04,   6.3004013E-04,   6.7851070E-04
     +,   7.3335262E-04,   7.9460634E-04,   8.6169865E-04
     +,   9.3333604E-04,   1.0074885E-03,   1.0814887E-03
     +,   1.1522585E-03,   1.2166377E-03,   1.2717793E-03
     +,   1.3155346E-03,   1.3467583E-03,   1.3654702E-03
     +,   1.3728226E-03,   1.3708890E-03,   1.3622922E-03
     +,   1.3497556E-03,   1.3356645E-03,   1.3217176E-03
     +,   1.3087314E-03,   1.2966500E-03,   1.2847238E-03
     +,   1.2718292E-03,   1.2568509E-03,   1.2390384E-03
     +,   1.2182471E-03,   1.1950234E-03,   1.1704975E-03
     +,   1.1461211E-03,   1.1233144E-03,   1.1031076E-03
     +,   1.0858584E-03,   1.0711297E-03,   1.0577359E-03
     +,   1.0439573E-03,   1.0278665E-03,   1.0076935E-03
     +,   9.8215276E-04,   9.5068046E-04,   9.1353222E-04
     +,   8.7176083E-04,   8.2705729E-04,   7.8153401E-04
     +,   7.3746563E-04,   6.9703796E-04,   6.6213513E-04
     +,   6.3418486E-04,   6.1406894E-04,   6.0209585E-04
     +,   5.9802772E-04,   6.0114672E-04,   6.1035092E-04
     +,   6.2426215E-04,   6.4133765E-04,   6.5997720E-04
     +,   6.7861710E-04,   6.9580617E-04,   7.1026996E-04
     +,   7.2094903E-04,   7.2702387E-04,   7.2792231E-04
     +,   7.2331412E-04,   7.1309728E-04,   6.9737528E-04
     +,   6.7643105E-04,   6.5069762E-04,   6.2072993E-04
     +,   5.8717444E-04,   5.5074075E-04,   5.1217381E-04
     +,   4.7222717E-04,   4.3163894E-04,   3.9110924E-04
     +,   3.5128082E-04,   3.1272336E-04,   2.7591997E-04
     +,   2.4126684E-04,   2.0905965E-04,   1.7950161E-04
     +,   1.5270674E-04,   1.2870657E-04,   1.0746445E-04
     +,   8.8880675E-05,   7.2809205E-05,   5.9068745E-05
     +,   4.7454378E-05,   3.7748101E-05,   2.9728086E-05
     +,   2.3176299E-05,   1.7884622E-05,   1.3659279E-05
     +,   1.0323893E-05,   7.7211898E-06,   5.7135981E-06
     +,   4.1829394E-06,   3.0294109E-06,   2.1703295E-06
     +,   1.5378984E-06,   1.0778451E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_nwao_hz_80 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_nwao_hz_85(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  5.5144240E-09,   6.2725820E-09
     +,   7.1273116E-09,   8.0898355E-09,   9.1724504E-09
     +,   1.0388777E-08,   1.1753762E-08,   1.3283798E-08
     +,   1.4996935E-08,   1.6912766E-08,   1.9052870E-08
     +,   2.1440721E-08,   2.4101920E-08,   2.7064367E-08
     +,   3.0358372E-08,   3.4016693E-08,   3.8074916E-08
     +,   4.2571585E-08,   4.7548234E-08,   5.3049870E-08
     +,   5.9124485E-08,   6.5824018E-08,   7.3204205E-08
     +,   8.1324600E-08,   9.0249351E-08,   1.0004603E-07
     +,   1.1078752E-07,   1.2255114E-07,   1.3541930E-07
     +,   1.4947838E-07,   1.6482107E-07,   1.8154476E-07
     +,   1.9975238E-07,   2.1955204E-07,   2.4105819E-07
     +,   2.6438951E-07,   2.8967114E-07,   3.1703419E-07
     +,   3.4661497E-07,   3.7855648E-07,   4.1300481E-07
     +,   4.5011393E-07,   4.9004223E-07,   5.3295395E-07
     +,   5.7901792E-07,   6.2840900E-07,   6.8130373E-07
     +,   7.3788624E-07,   7.9834518E-07,   8.6286877E-07
     +,   9.3165329E-07,   1.0048969E-06,   1.0828002E-06
     +,   1.1655668E-06,   1.2534025E-06,   1.3465153E-06
     +,   1.4451164E-06,   1.5494123E-06,   1.6596173E-06
     +,   1.7759459E-06,   1.8986051E-06,   2.0278114E-06
     +,   2.1637779E-06,   2.3067191E-06,   2.4568471E-06
     +,   2.6143762E-06,   2.7795249E-06,   2.9524992E-06
     +,   3.1335187E-06,   3.3228002E-06,   3.5205667E-06
     +,   3.7270288E-06,   3.9424144E-06,   4.1669509E-06
     +,   4.4008680E-06,   4.6444038E-06,   4.8978036E-06
     +,   5.1613065E-06,   5.4351740E-06,   5.7196703E-06
     +,   6.0150692E-06,   6.3216630E-06,   6.6397297E-06
     +,   6.9695830E-06,   7.3115375E-06,   7.6659235E-06
     +,   8.0330738E-06,   8.4133444E-06,   8.8070838E-06
     +,   9.2146847E-06,   9.6364802E-06,   1.0072865E-05
     +,   1.0524214E-05,   1.0990908E-05,   1.1473316E-05
     +,   1.1971799E-05,   1.2486730E-05,   1.3018387E-05
     +,   1.3567094E-05,   1.4133121E-05,   1.4716698E-05
     +,   1.5318003E-05,   1.5937167E-05,   1.6574249E-05
     +,   1.7229244E-05,   1.7902063E-05,   1.8592522E-05
     +,   1.9300345E-05,   2.0025145E-05,   2.0766418E-05
     +,   2.1523540E-05,   2.2295782E-05,   2.3082173E-05
     +,   2.3881705E-05,   2.4693176E-05,   2.5515235E-05
     +,   2.6346370E-05,   2.7184904E-05,   2.8029044E-05
     +,   2.8876715E-05,   2.9725805E-05,   3.0574018E-05
     +,   3.1418891E-05,   3.2257845E-05,   3.3088167E-05
     +,   3.3907028E-05,   3.4711495E-05,   3.5498560E-05
     +,   3.6265126E-05,   3.7008071E-05,   3.7724232E-05
     +,   3.8410464E-05,   3.9063554E-05,   3.9680417E-05
     +,   4.0257990E-05,   4.0793304E-05,   4.1283503E-05
     +,   4.1725867E-05,   4.2117827E-05,   4.2456999E-05
     +,   4.2741183E-05,   4.2968437E-05,   4.3137050E-05
     +,   4.3245571E-05,   4.3292821E-05,   4.3277931E-05
     +,   4.3200333E-05,   4.3059776E-05,   4.2856340E-05
     +,   4.2590451E-05,   4.2262887E-05,   4.1874762E-05
     +,   4.1427615E-05,   4.0923336E-05,   4.0364233E-05
     +,   3.9753031E-05,   3.9092920E-05,   3.8387589E-05
     +,   3.7641250E-05,   3.6858710E-05,   3.6045436E-05
     +,   3.5207526E-05,   3.4352051E-05,   3.3486747E-05
     +,   3.2620395E-05,   3.1762727E-05,   3.0924548E-05
     +,   3.0117737E-05,   2.9355280E-05,   2.8651239E-05
     +,   2.8020726E-05,   2.7479873E-05,   2.7045813E-05
     +,   2.6736700E-05,   2.6571959E-05,   2.6572559E-05
     +,   2.6761800E-05,   2.7166423E-05,   2.7818363E-05
     +,   2.8757242E-05,   3.0033443E-05,   3.1712785E-05
     +,   3.3880737E-05,   3.6648671E-05,   4.0159353E-05
     +,   4.4592500E-05,   5.0169023E-05,   5.7153291E-05
     +,   6.5851971E-05,   7.6608725E-05,   8.9793772E-05
     +,   1.0578785E-04,   1.2496182E-04,   1.4764618E-04
     +,   1.7411365E-04,   2.0453516E-04,   2.3897449E-04
     +,   2.7735194E-04,   3.1944242E-04,   3.6489152E-04
     +,   4.1320224E-04,   4.6379073E-04,   5.1598315E-04
     +,   5.6906824E-04,   6.2230870E-04,   6.7495479E-04
     +,   7.2624400E-04,   7.7538658E-04,   8.2154706E-04
     +,   8.6382712E-04,   9.0126460E-04,   9.3285763E-04
     +,   9.5762330E-04,   9.7469444E-04,   9.8344951E-04
     +,   9.8365475E-04,   9.7560976E-04,   9.6025469E-04
     +,   9.3922223E-04,   9.1480731E-04,   8.8985497E-04
     +,   8.6754648E-04,   8.5115311E-04,   8.4373838E-04
     +,   8.4789703E-04,   8.6554617E-04,   8.9779519E-04
     +,   9.4490382E-04,   1.0062956E-03,   1.0806056E-03
     +,   1.1657294E-03,   1.2588575E-03,   1.3565301E-03
     +,   1.4547437E-03,   1.5491745E-03,   1.6355384E-03
     +,   1.7100733E-03,   1.7700308E-03,   1.8141009E-03
     +,   1.8425607E-03,   1.8571051E-03,   1.8603735E-03
     +,   1.8552702E-03,   1.8442882E-03,   1.8290478E-03
     +,   1.8101681E-03,   1.7875116E-03,   1.7606704E-03
     +,   1.7295216E-03,   1.6946313E-03,   1.6573940E-03
     +,   1.6198461E-03,   1.5842647E-03,   1.5526640E-03
     +,   1.5263594E-03,   1.5057066E-03,   1.4900594E-03
     +,   1.4779232E-03,   1.4672590E-03,   1.4558331E-03
     +,   1.4415644E-03,   1.4227830E-03,   1.3983852E-03
     +,   1.3678743E-03,   1.3312749E-03,   1.2889870E-03
     +,   1.2416010E-03,   1.1897314E-03,   1.1339025E-03
     +,   1.0745141E-03,   1.0118780E-03,   9.4630383E-04
     +,   8.7820354E-04,   8.0817402E-04,   7.3703576E-04
     +,   6.6581438E-04,   5.9567310E-04,   5.2780862E-04
     +,   4.6335289E-04,   4.0325531E-04,   3.4822605E-04
     +,   2.9869864E-04,   2.5482944E-04,   2.1653659E-04
     +,   1.8353714E-04,   1.5541306E-04,   1.3166582E-04
     +,   1.1176539E-04,   9.5188261E-05,   8.1443504E-05
     +,   7.0087866E-05,   6.0731909E-05,   5.3040221E-05
     +,   4.6727382E-05,   4.1552285E-05,   3.7311827E-05
     +,   3.3834938E-05,   3.0977382E-05,   2.8618153E-05
     +,   2.6654810E-05,   2.5002348E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_nwao_hz_85 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_nwao_hz_90(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  1.0999003E-15,   1.5761757E-15
     +,   2.2527540E-15,   3.2113289E-15,   4.5657333E-15
     +,   6.4743374E-15,   9.1566947E-15,   1.2916379E-14
     +,   1.8172155E-14,   2.5499241E-14,   3.5686826E-14
     +,   4.9813665E-14,   6.9350247E-14,   9.6296059E-14
     +,   1.3336200E-13,   1.8420945E-13,   2.5377717E-13
     +,   3.4870132E-13,   4.7787463E-13,   6.5318844E-13
     +,   8.9047200E-13,   1.2107712E-12,   1.6419653E-12
     +,   2.2208906E-12,   2.9960765E-12,   4.0312142E-12
     +,   5.4097707E-12,   7.2407315E-12,   9.6660301E-12
     +,   1.2869789E-11,   1.7090464E-11,   2.2635815E-11
     +,   2.9901855E-11,   3.9396590E-11,   5.1770341E-11
     +,   6.7851509E-11,   8.8694510E-11,   1.1563576E-10
     +,   1.5036447E-10,   1.9501095E-10,   2.5224775E-10
     +,   3.2542655E-10,   4.1873116E-10,   5.3737120E-10
     +,   6.8781147E-10,   8.7805652E-10,   1.1179666E-09
     +,   1.4196786E-09,   1.7980756E-09,   2.2713176E-09
     +,   2.8615508E-09,   3.5956591E-09,   4.5061763E-09
     +,   5.6323564E-09,   7.0214043E-09,   8.7299021E-09
     +,   1.0825488E-08,   1.3388565E-08,   1.6514678E-08
     +,   2.0316914E-08,   2.4928260E-08,   3.0505234E-08
     +,   3.7230969E-08,   4.5319116E-08,   5.5017999E-08
     +,   6.6615350E-08,   8.0443456E-08,   9.6883561E-08
     +,   1.1637329E-07,   1.3941197E-07,   1.6656799E-07
     +,   1.9848289E-07,   2.3588294E-07,   2.7958296E-07
     +,   3.3049523E-07,   3.8963614E-07,   4.5813562E-07
     +,   5.3723642E-07,   6.2831106E-07,   7.3285980E-07
     +,   8.5251776E-07,   9.8906128E-07,   1.1443966E-06
     +,   1.3205794E-06,   1.5197985E-06,   1.7443789E-06
     +,   1.9967697E-06,   2.2795391E-06,   2.5953586E-06
     +,   2.9470036E-06,   3.3372708E-06,   3.7690463E-06
     +,   4.2452207E-06,   4.7686681E-06,   5.3422168E-06
     +,   5.9686040E-06,   6.6504740E-06,   7.3901970E-06
     +,   8.1900162E-06,   9.0518679E-06,   9.9773697E-06
     +,   1.0967753E-05,   1.2023827E-05,   1.3145919E-05
     +,   1.4333815E-05,   1.5586736E-05,   1.6903272E-05
     +,   1.8281358E-05,   1.9718243E-05,   2.1210459E-05
     +,   2.2753811E-05,   2.4343446E-05,   2.5973568E-05
     +,   2.7637878E-05,   2.9329327E-05,   3.1040236E-05
     +,   3.2762313E-05,   3.4486769E-05,   3.6204434E-05
     +,   3.7905549E-05,   3.9580340E-05,   4.1218806E-05
     +,   4.2810931E-05,   4.4346783E-05,   4.5816683E-05
     +,   4.7211324E-05,   4.8521873E-05,   4.9740185E-05
     +,   5.0858867E-05,   5.1871444E-05,   5.2772455E-05
     +,   5.3557636E-05,   5.4223859E-05,   5.4769433E-05
     +,   5.5194050E-05,   5.5498876E-05,   5.5686571E-05
     +,   5.5761353E-05,   5.5728953E-05,   5.5596665E-05
     +,   5.5373283E-05,   5.5069013E-05,   5.4695491E-05
     +,   5.4265620E-05,   5.3793516E-05,   5.3294374E-05
     +,   5.2784348E-05,   5.2280408E-05,   5.1800180E-05
     +,   5.1361792E-05,   5.0983719E-05,   5.0684554E-05
     +,   5.0482882E-05,   5.0397030E-05,   5.0444894E-05
     +,   5.0643706E-05,   5.1009876E-05,   5.1558683E-05
     +,   5.2304113E-05,   5.3258645E-05,   5.4432930E-05
     +,   5.5835728E-05,   5.7473328E-05,   5.9349790E-05
     +,   6.1466410E-05,   6.3821666E-05,   6.6410990E-05
     +,   6.9226706E-05,   7.2257928E-05,   7.5490592E-05
     +,   7.8907520E-05,   8.2488586E-05,   8.6211083E-05
     +,   9.0050307E-05,   9.3979499E-05,   9.7971671E-05
     +,   1.0199996E-04,   1.0603906E-04,   1.1006660E-04
     +,   1.1406530E-04,   1.1802374E-04,   1.2194085E-04
     +,   1.2582573E-04,   1.2970214E-04,   1.3361032E-04
     +,   1.3760982E-04,   1.4178205E-04,   1.4623230E-04
     +,   1.5109160E-04,   1.5651759E-04,   1.6269449E-04
     +,   1.6983144E-04,   1.7816015E-04,   1.8792666E-04
     +,   1.9938819E-04,   2.1279469E-04,   2.2838244E-04
     +,   2.4634777E-04,   2.6682959E-04,   2.8989429E-04
     +,   3.1550284E-04,   3.4351405E-04,   3.7366347E-04
     +,   4.0558903E-04,   4.3885509E-04,   4.7300835E-04
     +,   5.0765113E-04,   5.4253027E-04,   5.7762844E-04
     +,   6.1324192E-04,   6.5001938E-04,   6.8894622E-04
     +,   7.3125277E-04,   7.7824789E-04,   8.3108811E-04
     +,   8.9050765E-04,   9.5661636E-04,   1.0287320E-03
     +,   1.1054557E-03,   1.1849217E-03,   1.2652626E-03
     +,   1.3452662E-03,   1.4249319E-03,   1.5058855E-03
     +,   1.5913472E-03,   1.6856216E-03,   1.7932155E-03
     +,   1.9178246E-03,   2.0615130E-03,   2.2243101E-03
     +,   2.4042167E-03,   2.5974640E-03,   2.7988111E-03
     +,   3.0018897E-03,   3.1997599E-03,   3.3858621E-03
     +,   3.5552173E-03,   3.7053127E-03,   3.8361151E-03
     +,   3.9488641E-03,   4.0442757E-03,   4.1211369E-03
     +,   4.1760835E-03,   4.2047920E-03,   4.2039631E-03
     +,   4.1734064E-03,   4.1175503E-03,   4.0459200E-03
     +,   3.9721713E-03,   3.9113928E-03,   3.8760095E-03
     +,   3.8715170E-03,   3.8938567E-03,   3.9301566E-03
     +,   3.9631207E-03,   3.9775884E-03,   3.9663394E-03
     +,   3.9322935E-03,   3.8859725E-03,   3.8394330E-03
     +,   3.7998476E-03,   3.7657924E-03,   3.7278405E-03
     +,   3.6726580E-03,   3.5883193E-03,   3.4683300E-03
     +,   3.3129209E-03,   3.1277265E-03,   2.9210448E-03
     +,   2.7011759E-03,   2.4748754E-03,   2.2471261E-03
     +,   2.0218100E-03,   1.8025703E-03,   1.5932977E-03
     +,   1.3980451E-03,   1.2204823E-03,   1.0632090E-03
     +,   9.2728500E-04,   8.1204798E-04,   7.1539229E-04
     +,   6.3426647E-04,   5.6527549E-04,   5.0522684E-04
     +,   4.5148301E-04,   4.0214995E-04,   3.5607521E-04
     +,   3.1273166E-04,   2.7204063E-04,   2.3418500E-04
     +,   1.9944705E-04,   1.6808798E-04,   1.4027167E-04
     +,   1.1603077E-04,   9.5264026E-05,   7.7754950E-05
     +,   6.3202693E-05,   5.1255422E-05,   4.1544801E-05
     +,   3.3707172E-05,   2.7408740E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_nwao_hz_90 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_nwao_hz_95(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  1.7608301E-06,   1.8635966E-06
     +,   1.9705869E-06,   2.0818500E-06,   2.1974181E-06
     +,   2.3173218E-06,   2.4415790E-06,   2.5701970E-06
     +,   2.7031756E-06,   2.8404938E-06,   2.9821263E-06
     +,   3.1280347E-06,   3.2781654E-06,   3.4324539E-06
     +,   3.5908238E-06,   3.7531761E-06,   3.9194060E-06
     +,   4.0893942E-06,   4.2630058E-06,   4.4400954E-06
     +,   4.6204923E-06,   4.8040242E-06,   4.9905020E-06
     +,   5.1797206E-06,   5.3714684E-06,   5.5655109E-06
     +,   5.7616089E-06,   5.9595127E-06,   6.1589649E-06
     +,   6.3596854E-06,   6.5613972E-06,   6.7638134E-06
     +,   6.9666385E-06,   7.1695727E-06,   7.3723145E-06
     +,   7.5745452E-06,   7.7759605E-06,   7.9762467E-06
     +,   8.1750932E-06,   8.3721943E-06,   8.5672336E-06
     +,   8.7599146E-06,   8.9499399E-06,   9.1370193E-06
     +,   9.3208737E-06,   9.5012338E-06,   9.6778322E-06
     +,   9.8504270E-06,   1.0018783E-05,   1.0182677E-05
     +,   1.0341910E-05,   1.0496293E-05,   1.0645655E-05
     +,   1.0789848E-05,   1.0928738E-05,   1.1062212E-05
     +,   1.1190185E-05,   1.1312575E-05,   1.1429338E-05
     +,   1.1540446E-05,   1.1645885E-05,   1.1745670E-05
     +,   1.1839832E-05,   1.1928427E-05,   1.2011527E-05
     +,   1.2089220E-05,   1.2161622E-05,   1.2228854E-05
     +,   1.2291059E-05,   1.2348399E-05,   1.2401044E-05
     +,   1.2449179E-05,   1.2492997E-05,   1.2532709E-05
     +,   1.2568525E-05,   1.2600663E-05,   1.2629353E-05
     +,   1.2654819E-05,   1.2677293E-05,   1.2697002E-05
     +,   1.2714172E-05,   1.2729030E-05,   1.2741792E-05
     +,   1.2752670E-05,   1.2761867E-05,   1.2769574E-05
     +,   1.2775975E-05,   1.2781237E-05,   1.2785515E-05
     +,   1.2788948E-05,   1.2791658E-05,   1.2793757E-05
     +,   1.2795330E-05,   1.2796448E-05,   1.2797167E-05
     +,   1.2797516E-05,   1.2797516E-05,   1.2797159E-05
     +,   1.2796424E-05,   1.2795269E-05,   1.2793640E-05
     +,   1.2791460E-05,   1.2788642E-05,   1.2785081E-05
     +,   1.2780657E-05,   1.2775246E-05,   1.2768703E-05
     +,   1.2760886E-05,   1.2751641E-05,   1.2740807E-05
     +,   1.2728227E-05,   1.2713742E-05,   1.2697195E-05
     +,   1.2678434E-05,   1.2657320E-05,   1.2633715E-05
     +,   1.2607507E-05,   1.2578592E-05,   1.2546882E-05
     +,   1.2512326E-05,   1.2474885E-05,   1.2434551E-05
     +,   1.2391350E-05,   1.2345337E-05,   1.2296610E-05
     +,   1.2245301E-05,   1.2191587E-05,   1.2135692E-05
     +,   1.2077876E-05,   1.2018460E-05,   1.1957811E-05
     +,   1.1896350E-05,   1.1834558E-05,   1.1772965E-05
     +,   1.1712167E-05,   1.1652814E-05,   1.1595622E-05
     +,   1.1541368E-05,   1.1490891E-05,   1.1445099E-05
     +,   1.1404963E-05,   1.1371522E-05,   1.1345882E-05
     +,   1.1329215E-05,   1.1322766E-05,   1.1327847E-05
     +,   1.1345848E-05,   1.1378224E-05,   1.1426505E-05
     +,   1.1492309E-05,   1.1577318E-05,   1.1683310E-05
     +,   1.1812137E-05,   1.1965752E-05,   1.2146202E-05
     +,   1.2355648E-05,   1.2596362E-05,   1.2870744E-05
     +,   1.3181344E-05,   1.3530868E-05,   1.3922207E-05
     +,   1.4358471E-05,   1.4842949E-05,   1.5379226E-05
     +,   1.5971165E-05,   1.6622940E-05,   1.7339053E-05
     +,   1.8124376E-05,   1.8984163E-05,   1.9924053E-05
     +,   2.0950085E-05,   2.2068700E-05,   2.3286706E-05
     +,   2.4611325E-05,   2.6049931E-05,   2.7610360E-05
     +,   2.9300671E-05,   3.1129166E-05,   3.3104454E-05
     +,   3.5235596E-05,   3.7531761E-05,   4.0003582E-05
     +,   4.2661977E-05,   4.5519875E-05,   4.8592166E-05
     +,   5.1896590E-05,   5.5454530E-05,   5.9291986E-05
     +,   6.3440508E-05,   6.7938272E-05,   7.2830924E-05
     +,   7.8172496E-05,   8.4026302E-05,   9.0464004E-05
     +,   9.7568940E-05,   1.0543175E-04,   1.1415543E-04
     +,   1.2385023E-04,   1.3463544E-04,   1.4664253E-04
     +,   1.6000838E-04,   1.7488426E-04,   1.9142704E-04
     +,   2.0980615E-04,   2.3019937E-04,   2.5279087E-04
     +,   2.7776702E-04,   3.0530916E-04,   3.3558317E-04
     +,   3.6872664E-04,   4.0483332E-04,   4.4393609E-04
     +,   4.8599092E-04,   5.3086190E-04,   5.7831570E-04
     +,   6.2800752E-04,   6.7951332E-04,   7.3231664E-04
     +,   7.8586186E-04,   8.3958369E-04,   8.9294510E-04
     +,   9.4551157E-04,   9.9696731E-04,   1.0471855E-03
     +,   1.0962531E-03,   1.1445067E-03,   1.1925607E-03
     +,   1.2413261E-03,   1.2920252E-03,   1.3461659E-03
     +,   1.4054744E-03,   1.4717554E-03,   1.5466936E-03
     +,   1.6316194E-03,   1.7272847E-03,   1.8336890E-03
     +,   1.9499698E-03,   2.0742880E-03,   2.2037842E-03
     +,   2.3345212E-03,   2.4616278E-03,   2.5797656E-03
     +,   2.6839708E-03,   2.7707624E-03,   2.8390384E-03
     +,   2.8904022E-03,   2.9287040E-03,   2.9590845E-03
     +,   2.9870791E-03,   3.0183455E-03,   3.0590377E-03
     +,   3.1162419E-03,   3.1976642E-03,   3.3100219E-03
     +,   3.4566172E-03,   3.6352726E-03,   3.8381624E-03
     +,   4.0542395E-03,   4.2734379E-03,   4.4906912E-03
     +,   4.7068181E-03,   4.9246759E-03,   5.1414738E-03
     +,   5.3412179E-03,   5.4928879E-03,   5.5575832E-03
     +,   5.5029546E-03,   5.3181420E-03,   5.0211898E-03
     +,   4.6549183E-03,   4.2733690E-03,   3.9254129E-03
     +,   3.6424447E-03,   3.4338017E-03,   3.2895214E-03
     +,   3.1873106E-03,   3.1003132E-03,   3.0033702E-03
     +,   2.8771944E-03,   2.7106092E-03,   2.5013119E-03
     +,   2.2552486E-03,   1.9846449E-03,   1.7051068E-03
     +,   1.4322995E-03,   1.1792579E-03,   9.5476682E-04
     +,   7.6302339E-04,   6.0430821E-04,   4.7618241E-04
     +,   3.7474025E-04,   2.9560909E-04,   2.3458959E-04
     +,   1.8796892E-04,   1.5261221E-04,   1.2593687E-04
     +,   1.0584483E-04,   9.0651680E-05,   7.9029298E-05
     +,   6.9948161E-05,   6.2638348E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_nwao_hz_95 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_nwao_qq(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  1.1220774E-36,   2.4199432E-36
     +,   5.1978234E-36,   1.1119410E-35,   2.3690411E-35
     +,   5.0269057E-35,   1.0623383E-34,   2.2359503E-34
     +,   4.6871492E-34,   9.7854918E-34,   2.0346692E-33
     +,   4.2134926E-33,   8.6901630E-33,   1.7850456E-32
     +,   3.6518630E-32,   7.4406412E-32,   1.5098721E-31
     +,   3.0514686E-31,   6.1420722E-31,   1.2313026E-30
     +,   2.4583501E-30,   4.8883228E-30,   9.6808080E-30
     +,   1.9094164E-29,   3.7508837E-29,   7.3383293E-29
     +,   1.4298695E-28,   2.7748076E-28,   5.3630663E-28
     +,   1.0323434E-27,   1.9791139E-27,   3.7788067E-27
     +,   7.1857848E-27,   1.3609148E-26,   2.5670340E-26
     +,   4.8223964E-26,   9.0225602E-26,   1.6812566E-25
     +,   3.1201497E-25,   5.7671442E-25,   1.0616307E-24
     +,   1.9463758E-24,   3.5539714E-24,   6.4630885E-24
     +,   1.1705820E-23,   2.1115637E-23,   3.7935179E-23
     +,   6.7875656E-23,   1.2095622E-22,   2.1467079E-22
     +,   3.7945333E-22,   6.6799934E-22,   1.1712042E-21
     +,   2.0451566E-21,   3.5567716E-21,   6.1605968E-21
     +,   1.0627477E-20,   1.8258771E-20,   3.1242573E-20
     +,   5.3243629E-20,   9.0368590E-20,   1.5275824E-19
     +,   2.5717518E-19,   4.3121192E-19,   7.2009216E-19
     +,   1.1976302E-18,   1.9838043E-18,   3.2727080E-18
     +,   5.3771504E-18,   8.7990395E-18,   1.4340294E-17
     +,   2.3276265E-17,   3.7627619E-17,   6.0580908E-17
     +,   9.7140756E-17,   1.5513341E-16,   2.4674594E-16
     +,   3.9086523E-16,   6.1665285E-16,   9.6893084E-16
     +,   1.5162844E-15,   2.3632484E-15,   3.6683642E-15
     +,   5.6711655E-15,   8.7318890E-15,   1.3390038E-14
     +,   2.0450003E-14,   3.1105842E-14,   4.7122530E-14
     +,   7.1098556E-14,   1.0683709E-13,   1.5989045E-13
     +,   2.3831921E-13,   3.5378146E-13,   5.2305805E-13
     +,   7.7019755E-13,   1.1295388E-12,   1.6498037E-12
     +,   2.3999466E-12,   3.4770576E-12,   5.0171959E-12
     +,   7.2102632E-12,   1.0320059E-11,   1.4711427E-11
     +,   2.0886676E-11,   2.9534288E-11,   4.1593604E-11
     +,   5.8340568E-11,   8.1500376E-11,   1.1339512E-10
     +,   1.5713604E-10,   2.1687574E-10,   2.9811911E-10
     +,   4.0814854E-10,   5.5654209E-10,   7.5584311E-10
     +,   1.0223988E-09,   1.3774190E-09,   1.8483161E-09
     +,   2.4702556E-09,   3.2883014E-09,   4.3598076E-09
     +,   5.7574701E-09,   7.5730071E-09,   9.9215827E-09
     +,   1.2947095E-08,   1.6828549E-08,   2.1787535E-08
     +,   2.8097082E-08,   3.6091961E-08,   4.6180777E-08
     +,   5.8860461E-08,   7.4729840E-08,   9.4511151E-08
     +,   1.1906874E-07,   1.4943245E-07,   1.8682353E-07
     +,   2.3268363E-07,   2.8870625E-07,   3.5687415E-07
     +,   4.3948424E-07,   5.3920542E-07,   6.5911036E-07
     +,   8.0272139E-07,   9.7405962E-07,   1.1776890E-06
     +,   1.4187690E-06,   1.7031011E-06,   2.0371765E-06
     +,   2.4282215E-06,   2.8842435E-06,   3.4140921E-06
     +,   4.0273903E-06,   4.7347094E-06,   5.5474916E-06
     +,   6.4780702E-06,   7.5396729E-06,   8.7463950E-06
     +,   1.0113153E-05,   1.1655637E-05,   1.3390219E-05
     +,   1.5333950E-05,   1.7504060E-05,   1.9918341E-05
     +,   2.2594602E-05,   2.5550527E-05,   2.8803453E-05
     +,   3.2370073E-05,   3.6266105E-05,   4.0505984E-05
     +,   4.5102490E-05,   5.0066323E-05,   5.5405759E-05
     +,   6.1126426E-05,   6.7229921E-05,   7.3714858E-05
     +,   8.0575570E-05,   8.7801898E-05,   9.5378964E-05
     +,   1.0328725E-04,   1.1150059E-04,   1.1999017E-04
     +,   1.2871936E-04,   1.3764789E-04,   1.4673045E-04
     +,   1.5591730E-04,   1.6515491E-04,   1.7438675E-04
     +,   1.8355418E-04,   1.9259728E-04,   2.0145637E-04
     +,   2.1007280E-04,   2.1839114E-04,   2.2635836E-04
     +,   2.3392934E-04,   2.4106297E-04,   2.4772860E-04
     +,   2.5390272E-04,   2.5957177E-04,   2.6473420E-04
     +,   2.6939737E-04,   2.7358066E-04,   2.7731282E-04
     +,   2.8063258E-04,   2.8358705E-04,   2.8623032E-04
     +,   2.8862187E-04,   2.9082483E-04,   2.9290403E-04
     +,   2.9492442E-04,   2.9694918E-04,   2.9903807E-04
     +,   3.0124674E-04,   3.0362525E-04,   3.0621808E-04
     +,   3.0906315E-04,   3.1219347E-04,   3.1563538E-04
     +,   3.1941105E-04,   3.2353873E-04,   3.2803282E-04
     +,   3.3290806E-04,   3.3817830E-04,   3.4386149E-04
     +,   3.4998223E-04,   3.5657611E-04,   3.6369494E-04
     +,   3.7141229E-04,   3.7982923E-04,   3.8907956E-04
     +,   3.9933276E-04,   4.1079472E-04,   4.2370515E-04
     +,   4.3833055E-04,   4.5495309E-04,   4.7385672E-04
     +,   4.9531169E-04,   5.1955431E-04,   5.4677809E-04
     +,   5.7711819E-04,   6.1064697E-04,   6.4737303E-04
     +,   6.8723969E-04,   7.3014369E-04,   7.7594223E-04
     +,   8.2447170E-04,   8.7556889E-04,   9.2909473E-04
     +,   9.8495872E-04,   1.0431441E-03,   1.1037274E-03
     +,   1.1668934E-03,   1.2329401E-03,   1.3022767E-03
     +,   1.3754109E-03,   1.4529285E-03,   1.5354577E-03
     +,   1.6236182E-03,   1.7179098E-03,   1.8185945E-03
     +,   1.9254762E-03,   2.0376493E-03,   2.1532297E-03
     +,   2.2690964E-03,   2.3807997E-03,   2.4826082E-03
     +,   2.5678340E-03,   2.6294116E-03,   2.6606908E-03
     +,   2.6563250E-03,   2.6131219E-03,   2.5306644E-03
     +,   2.4115935E-03,   2.2614605E-03,   2.0881686E-03
     +,   1.9010900E-03,   1.7100122E-03,   1.5240788E-03
     +,   1.3509444E-03,   1.1961237E-03,   1.0627703E-03
     +,   9.5173507E-04,   8.6189184E-04,   7.9064915E-04
     +,   7.3448982E-04,   6.8953179E-04,   6.5198122E-04
     +,   6.1847747E-04,   5.8630866E-04,   5.5351236E-04
     +,   5.1888102E-04,   4.8189564E-04,   4.4261408E-04
     +,   4.0153228E-04,   3.5943964E-04,   3.1728056E-04
     +,   2.7603158E-04,   2.3660100E-04,   1.9976487E-04
     +,   1.6610335E-04,   1.3600467E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_nwao_qq = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_nwao_ww(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  1.5738144E-07,   1.6454608E-07
     +,   1.7200479E-07,   1.7976809E-07,   1.8784657E-07
     +,   1.9625145E-07,   2.0499411E-07,   2.1408623E-07
     +,   2.2354000E-07,   2.3336770E-07,   2.4358181E-07
     +,   2.5419575E-07,   2.6522255E-07,   2.7667625E-07
     +,   2.8857087E-07,   3.0092076E-07,   3.1374066E-07
     +,   3.2704580E-07,   3.4085178E-07,   3.5517465E-07
     +,   3.7003016E-07,   3.8543547E-07,   4.0140736E-07
     +,   4.1796352E-07,   4.3512199E-07,   4.5290037E-07
     +,   4.7131743E-07,   4.9039227E-07,   5.1014513E-07
     +,   5.3059443E-07,   5.5176110E-07,   5.7366566E-07
     +,   5.9632919E-07,   6.1977312E-07,   6.4402008E-07
     +,   6.6909092E-07,   6.9500902E-07,   7.2179728E-07
     +,   7.4947934E-07,   7.7807977E-07,   8.0762140E-07
     +,   8.3812932E-07,   8.6962893E-07,   9.0214547E-07
     +,   9.3570520E-07,   9.7033444E-07,   1.0060591E-06
     +,   1.0429060E-06,   1.0809033E-06,   1.1200777E-06
     +,   1.1604576E-06,   1.2020718E-06,   1.2449482E-06
     +,   1.2891167E-06,   1.3346056E-06,   1.3814453E-06
     +,   1.4296663E-06,   1.4792975E-06,   1.5303697E-06
     +,   1.5829147E-06,   1.6369618E-06,   1.6925424E-06
     +,   1.7496883E-06,   1.8084315E-06,   1.8688033E-06
     +,   1.9308357E-06,   1.9945621E-06,   2.0600119E-06
     +,   2.1272187E-06,   2.1962153E-06,   2.2670349E-06
     +,   2.3397085E-06,   2.4142678E-06,   2.4907467E-06
     +,   2.5691775E-06,   2.6495932E-06,   2.7320270E-06
     +,   2.8165073E-06,   2.9030691E-06,   2.9917437E-06
     +,   3.0825624E-06,   3.1755606E-06,   3.2707630E-06
     +,   3.3682049E-06,   3.4679156E-06,   3.5699259E-06
     +,   3.6742661E-06,   3.7809652E-06,   3.8900534E-06
     +,   4.0015643E-06,   4.1155154E-06,   4.2319393E-06
     +,   4.3508649E-06,   4.4723160E-06,   4.5963207E-06
     +,   4.7229041E-06,   4.8520960E-06,   4.9839077E-06
     +,   5.1183697E-06,   5.2555038E-06,   5.3953308E-06
     +,   5.5378709E-06,   5.6831432E-06,   5.8311684E-06
     +,   5.9819617E-06,   6.1355418E-06,   6.2919216E-06
     +,   6.4511169E-06,   6.6131406E-06,   6.7780047E-06
     +,   6.9457183E-06,   7.1163008E-06,   7.2897433E-06
     +,   7.4660611E-06,   7.6452607E-06,   7.8273415E-06
     +,   8.0123109E-06,   8.2001661E-06,   8.3909181E-06
     +,   8.5845468E-06,   8.7810549E-06,   8.9804398E-06
     +,   9.1826914E-06,   9.3878034E-06,   9.5957648E-06
     +,   9.8065639E-06,   1.0020183E-05,   1.0236612E-05
     +,   1.0455829E-05,   1.0677815E-05,   1.0902550E-05
     +,   1.1130020E-05,   1.1360176E-05,   1.1593006E-05
     +,   1.1828478E-05,   1.2066561E-05,   1.2307222E-05
     +,   1.2550427E-05,   1.2796134E-05,   1.3044319E-05
     +,   1.3294916E-05,   1.3547893E-05,   1.3803205E-05
     +,   1.4060802E-05,   1.4320639E-05,   1.4582656E-05
     +,   1.4846805E-05,   1.5113028E-05,   1.5381263E-05
     +,   1.5651456E-05,   1.5923541E-05,   1.6197462E-05
     +,   1.6473137E-05,   1.6750499E-05,   1.7029484E-05
     +,   1.7310018E-05,   1.7592021E-05,   1.7875425E-05
     +,   1.8160143E-05,   1.8446099E-05,   1.8733206E-05
     +,   1.9021396E-05,   1.9310553E-05,   1.9600608E-05
     +,   1.9891464E-05,   2.0183032E-05,   2.0475218E-05
     +,   2.0767928E-05,   2.1061063E-05,   2.1354530E-05
     +,   2.1648219E-05,   2.1942036E-05,   2.2235878E-05
     +,   2.2529652E-05,   2.2823224E-05,   2.3116505E-05
     +,   2.3409386E-05,   2.3701752E-05,   2.3993503E-05
     +,   2.4284531E-05,   2.4574687E-05,   2.4863915E-05
     +,   2.5152058E-05,   2.5439016E-05,   2.5724670E-05
     +,   2.6008911E-05,   2.6291615E-05,   2.6572670E-05
     +,   2.6851958E-05,   2.7129361E-05,   2.7404765E-05
     +,   2.7678039E-05,   2.7949094E-05,   2.8217768E-05
     +,   2.8483995E-05,   2.8747603E-05,   2.9008528E-05
     +,   2.9266628E-05,   2.9521763E-05,   2.9773866E-05
     +,   3.0022773E-05,   3.0268415E-05,   3.0510650E-05
     +,   3.0749365E-05,   3.0984465E-05,   3.1215819E-05
     +,   3.1443338E-05,   3.1666903E-05,   3.1886408E-05
     +,   3.2101747E-05,   3.2312815E-05,   3.2519518E-05
     +,   3.2721746E-05,   3.2919404E-05,   3.3112403E-05
     +,   3.3300621E-05,   3.3484001E-05,   3.3662425E-05
     +,   3.3835808E-05,   3.4004079E-05,   3.4167126E-05
     +,   3.4324898E-05,   3.4477289E-05,   3.4624234E-05
     +,   3.4765661E-05,   3.4901488E-05,   3.5031655E-05
     +,   3.5156088E-05,   3.5274727E-05,   3.5387511E-05
     +,   3.5494377E-05,   3.5595280E-05,   3.5690155E-05
     +,   3.5778961E-05,   3.5861649E-05,   3.5938174E-05
     +,   3.6008503E-05,   3.6072594E-05,   3.6130412E-05
     +,   3.6181929E-05,   3.6227117E-05,   3.6265956E-05
     +,   3.6298421E-05,   3.6324491E-05,   3.6344161E-05
     +,   3.6357418E-05,   3.6364250E-05,   3.6364665E-05
     +,   3.6358655E-05,   3.6346217E-05,   3.6327368E-05
     +,   3.6302117E-05,   3.6270467E-05,   3.6232450E-05
     +,   3.6188074E-05,   3.6137364E-05,   3.6080357E-05
     +,   3.6017067E-05,   3.5947538E-05,   3.5871803E-05
     +,   3.5789904E-05,   3.5701880E-05,   3.5607773E-05
     +,   3.5507641E-05,   3.5401536E-05,   3.5289511E-05
     +,   3.5171615E-05,   3.5047924E-05,   3.4918488E-05
     +,   3.4783381E-05,   3.4642671E-05,   3.4496428E-05
     +,   3.4344728E-05,   3.4187648E-05,   3.4025266E-05
     +,   3.3857665E-05,   3.3684933E-05,   3.3507142E-05
     +,   3.3324402E-05,   3.3136796E-05,   3.2944408E-05
     +,   3.2747346E-05,   3.2545689E-05,   3.2339554E-05
     +,   3.2129039E-05,   3.1914238E-05,   3.1695261E-05
     +,   3.1472213E-05,   3.1245199E-05,   3.1014326E-05
     +,   3.0779702E-05,   3.0541440E-05,   3.0299650E-05
     +,   3.0054449E-05,   2.9805948E-05,   2.9554254E-05
     +,   2.9299492E-05,   2.9041765E-05,   2.8781220E-05
     +,   2.8517925E-05,   2.8252041E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_nwao_ww = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wano_fus_100(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  2.4908317E-07,   2.7384226E-07
     +,   3.0089058E-07,   3.3042295E-07,   3.6264652E-07
     +,   3.9778624E-07,   4.3608290E-07,   4.7779429E-07
     +,   5.2319814E-07,   5.7258825E-07,   6.2628186E-07
     +,   6.8461719E-07,   7.4795457E-07,   8.1667810E-07
     +,   8.9119857E-07,   9.7194732E-07,   1.0593877E-06
     +,   1.1540087E-06,   1.2563293E-06,   1.3668999E-06
     +,   1.4862940E-06,   1.6151250E-06,   1.7540349E-06
     +,   1.9036989E-06,   2.0648304E-06,   2.2381628E-06
     +,   2.4244773E-06,   2.6245830E-06,   2.8393299E-06
     +,   3.0695835E-06,   3.3162612E-06,   3.5803032E-06
     +,   3.8626827E-06,   4.1644030E-06,   4.4864992E-06
     +,   4.8300158E-06,   5.1960369E-06,   5.5856631E-06
     +,   6.0000125E-06,   6.4402284E-06,   6.9074317E-06
     +,   7.4027826E-06,   7.9274332E-06,   8.4825306E-06
     +,   9.0692183E-06,   9.6886379E-06,   1.0341872E-05
     +,   1.1030020E-05,   1.1754149E-05,   1.2515248E-05
     +,   1.3314309E-05,   1.4152260E-05,   1.5029968E-05
     +,   1.5948253E-05,   1.6907858E-05,   1.7909451E-05
     +,   1.8953662E-05,   2.0040972E-05,   2.1171832E-05
     +,   2.2346627E-05,   2.3565577E-05,   2.4828894E-05
     +,   2.6136684E-05,   2.7488972E-05,   2.8885706E-05
     +,   3.0326790E-05,   3.1812069E-05,   3.3341294E-05
     +,   3.4914228E-05,   3.6530637E-05,   3.8190305E-05
     +,   3.9892959E-05,   4.1638465E-05,   4.3426764E-05
     +,   4.5257901E-05,   4.7132071E-05,   4.9049711E-05
     +,   5.1011360E-05,   5.3017993E-05,   5.5070799E-05
     +,   5.7171434E-05,   5.9321970E-05,   6.1524850E-05
     +,   6.3783242E-05,   6.6100860E-05,   6.8482099E-05
     +,   7.0932132E-05,   7.3456940E-05,   7.6063450E-05
     +,   7.8759651E-05,   8.1554252E-05,   8.4457453E-05
     +,   8.7480570E-05,   9.0636211E-05,   9.3938412E-05
     +,   9.7402524E-05,   1.0104572E-04,   1.0488622E-04
     +,   1.0894427E-04,   1.1324175E-04,   1.1780212E-04
     +,   1.2265047E-04,   1.2781363E-04,   1.3331989E-04
     +,   1.3919895E-04,   1.4548191E-04,   1.5220094E-04
     +,   1.5938900E-04,   1.6707955E-04,   1.7530617E-04
     +,   1.8410219E-04,   1.9350056E-04,   2.0353138E-04
     +,   2.1422401E-04,   2.2560479E-04,   2.3769624E-04
     +,   2.5051681E-04,   2.6407983E-04,   2.7839336E-04
     +,   2.9345669E-04,   3.0926414E-04,   3.2580105E-04
     +,   3.4304470E-04,   3.6096343E-04,   3.7951695E-04
     +,   3.9865609E-04,   4.1832376E-04,   4.3845543E-04
     +,   4.5897966E-04,   4.7982100E-04,   5.0089951E-04
     +,   5.2213593E-04,   5.4344937E-04,   5.6476548E-04
     +,   5.8601669E-04,   6.0714484E-04,   6.2810682E-04
     +,   6.4887415E-04,   6.6944008E-04,   6.8982091E-04
     +,   7.1005517E-04,   7.3021132E-04,   7.5038563E-04
     +,   7.7070261E-04,   7.9131400E-04,   8.1239856E-04
     +,   8.3415763E-04,   8.5681339E-04,   8.8060030E-04
     +,   9.0576429E-04,   9.3255163E-04,   9.6120842E-04
     +,   9.9196692E-04,   1.0250462E-03,   1.0606447E-03
     +,   1.0989364E-03,   1.1400661E-03,   1.1841541E-03
     +,   1.2312905E-03,   1.2815419E-03,   1.3349538E-03
     +,   1.3915548E-03,   1.4513546E-03,   1.5143671E-03
     +,   1.5805952E-03,   1.6500460E-03,   1.7227246E-03
     +,   1.7986287E-03,   1.8777444E-03,   1.9600228E-03
     +,   2.0453637E-03,   2.1335892E-03,   2.2244116E-03
     +,   2.3174076E-03,   2.4119737E-03,   2.5073448E-03
     +,   2.6025632E-03,   2.6965116E-03,   2.7879460E-03
     +,   2.8755753E-03,   2.9581131E-03,   3.0344175E-03
     +,   3.1035391E-03,   3.1648369E-03,   3.2180217E-03
     +,   3.2631850E-03,   3.3007811E-03,   3.3315716E-03
     +,   3.3565380E-03,   3.3767791E-03,   3.3934137E-03
     +,   3.4074844E-03,   3.4199215E-03,   3.4315235E-03
     +,   3.4429955E-03,   3.4550175E-03,   3.4683140E-03
     +,   3.4837336E-03,   3.5022846E-03,   3.5251302E-03
     +,   3.5535377E-03,   3.5887579E-03,   3.6318719E-03
     +,   3.6836325E-03,   3.7443060E-03,   3.8135340E-03
     +,   3.8902806E-03,   3.9728298E-03,   4.0588556E-03
     +,   4.1455547E-03,   4.2298278E-03,   4.3084756E-03
     +,   4.3784049E-03,   4.4368147E-03,   4.4813575E-03
     +,   4.5102476E-03,   4.5223534E-03,   4.5172316E-03
     +,   4.4951229E-03,   4.4569215E-03,   4.4041076E-03
     +,   4.3386118E-03,   4.2627440E-03,   4.1789575E-03
     +,   4.0897722E-03,   3.9975694E-03,   3.9044826E-03
     +,   3.8122968E-03,   3.7224106E-03,   3.6358202E-03
     +,   3.5531635E-03,   3.4747983E-03,   3.4008911E-03
     +,   3.3314852E-03,   3.2665946E-03,   3.2062263E-03
     +,   3.1504096E-03,   3.0992031E-03,   3.0526489E-03
     +,   3.0107831E-03,   2.9736296E-03,   2.9412187E-03
     +,   2.9136233E-03,   2.8910115E-03,   2.8737066E-03
     +,   2.8622267E-03,   2.8573042E-03,   2.8598562E-03
     +,   2.8709087E-03,   2.8914891E-03,   2.9224681E-03
     +,   2.9644091E-03,   3.0174165E-03,   3.0810437E-03
     +,   3.1542445E-03,   3.2354265E-03,   3.3225541E-03
     +,   3.4133447E-03,   3.5054558E-03,   3.5967471E-03
     +,   3.6854381E-03,   3.7702469E-03,   3.8504645E-03
     +,   3.9258758E-03,   3.9967326E-03,   4.0635625E-03
     +,   4.1270643E-03,   4.1879793E-03,   4.2470391E-03
     +,   4.3050158E-03,   4.3628248E-03,   4.4217380E-03
     +,   4.4835960E-03,   4.5509902E-03,   4.6273684E-03
     +,   4.7169859E-03,   4.8246393E-03,   4.9552955E-03
     +,   5.1134927E-03,   5.3028297E-03,   5.5253962E-03
     +,   5.7814112E-03,   6.0689580E-03,   6.3838153E-03
     +,   6.7194980E-03,   7.0671034E-03,   7.4152360E-03
     +,   7.7499351E-03,   8.0547510E-03,   8.3111525E-03
     +,   8.4994184E-03,   8.6000413E-03,   8.5956473E-03
     +,   8.4730675E-03,   8.2253143E-03,   7.8530516E-03
     +,   7.3652212E-03,   6.7786467E-03,   6.1168335E-03
     +,   5.4074423E-03,   4.6801376E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wano_fus_100 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wano_fus_105(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  1.4422284E-06,   1.4899462E-06
     +,   1.5391685E-06,   1.5899540E-06,   1.6423604E-06
     +,   1.6964523E-06,   1.7522965E-06,   1.8099631E-06
     +,   1.8695266E-06,   1.9310639E-06,   1.9946558E-06
     +,   2.0603895E-06,   2.1283556E-06,   2.1986486E-06
     +,   2.2713702E-06,   2.3466234E-06,   2.4245198E-06
     +,   2.5051756E-06,   2.5887143E-06,   2.6752666E-06
     +,   2.7649630E-06,   2.8579495E-06,   2.9543746E-06
     +,   3.0543974E-06,   3.1581853E-06,   3.2659084E-06
     +,   3.3777528E-06,   3.4939114E-06,   3.6145898E-06
     +,   3.7399982E-06,   3.8703611E-06,   4.0059167E-06
     +,   4.1469161E-06,   4.2936190E-06,   4.4463059E-06
     +,   4.6052628E-06,   4.7707958E-06,   4.9432315E-06
     +,   5.1229085E-06,   5.3101890E-06,   5.5054434E-06
     +,   5.7090760E-06,   5.9215035E-06,   6.1431770E-06
     +,   6.3745579E-06,   6.6161529E-06,   6.8684726E-06
     +,   7.1320769E-06,   7.4075597E-06,   7.6955303E-06
     +,   7.9966521E-06,   8.3116256E-06,   8.6411947E-06
     +,   8.9861460E-06,   9.3473272E-06,   9.7256316E-06
     +,   1.0122026E-05,   1.0537523E-05,   1.0973228E-05
     +,   1.1430324E-05,   1.1910071E-05,   1.2413831E-05
     +,   1.2943090E-05,   1.3499430E-05,   1.4084585E-05
     +,   1.4700426E-05,   1.5349007E-05,   1.6032516E-05
     +,   1.6753384E-05,   1.7514247E-05,   1.8318020E-05
     +,   1.9167817E-05,   2.0067120E-05,   2.1019703E-05
     +,   2.2029724E-05,   2.3101717E-05,   2.4240664E-05
     +,   2.5451951E-05,   2.6741525E-05,   2.8115837E-05
     +,   2.9581917E-05,   3.1147425E-05,   3.2820524E-05
     +,   3.4610170E-05,   3.6525915E-05,   3.8578037E-05
     +,   4.0777461E-05,   4.3135824E-05,   4.5665420E-05
     +,   4.8379276E-05,   5.1290670E-05,   5.4413726E-05
     +,   5.7762922E-05,   6.1353072E-05,   6.5199201E-05
     +,   6.9316440E-05,   7.3720017E-05,   7.8424375E-05
     +,   8.3444102E-05,   8.8792840E-05,   9.4483577E-05
     +,   1.0052809E-04,   1.0693692E-04,   1.1371920E-04
     +,   1.2088212E-04,   1.2843132E-04,   1.3637012E-04
     +,   1.4469986E-04,   1.5341968E-04,   1.6252644E-04
     +,   1.7201480E-04,   1.8187797E-04,   1.9210570E-04
     +,   2.0268775E-04,   2.1361203E-04,   2.2486584E-04
     +,   2.3643608E-04,   2.4831016E-04,   2.6047681E-04
     +,   2.7292530E-04,   2.8564854E-04,   2.9864255E-04
     +,   3.1190756E-04,   3.2544837E-04,   3.3927543E-04
     +,   3.5340548E-04,   3.6786246E-04,   3.8267716E-04
     +,   3.9788795E-04,   4.1354159E-04,   4.2969198E-04
     +,   4.4640183E-04,   4.6373912E-04,   4.8178073E-04
     +,   5.0060998E-04,   5.2031502E-04,   5.4099079E-04
     +,   5.6273508E-04,   5.8565184E-04,   6.0984929E-04
     +,   6.3543714E-04,   6.6253450E-04,   6.9126603E-04
     +,   7.2176801E-04,   7.5418985E-04,   7.8870106E-04
     +,   8.2549645E-04,   8.6480210E-04,   9.0688228E-04
     +,   9.5204200E-04,   1.0006316E-03,   1.0530456E-03
     +,   1.1097044E-03,   1.1710572E-03,   1.2375449E-03
     +,   1.3095798E-03,   1.3875081E-03,   1.4715708E-03
     +,   1.5618720E-03,   1.6583442E-03,   1.7607320E-03
     +,   1.8685958E-03,   1.9813047E-03,   2.0981070E-03
     +,   2.2181603E-03,   2.3406132E-03,   2.4646756E-03
     +,   2.5896828E-03,   2.7151639E-03,   2.8408675E-03
     +,   2.9667688E-03,   3.0930517E-03,   3.2200543E-03
     +,   3.3482048E-03,   3.4779264E-03,   3.6095886E-03
     +,   3.7434211E-03,   3.8794624E-03,   4.0175566E-03
     +,   4.1573490E-03,   4.2982814E-03,   4.4397376E-03
     +,   4.5810076E-03,   4.7214623E-03,   4.8606475E-03
     +,   4.9984194E-03,   5.1351395E-03,   5.2718343E-03
     +,   5.4104328E-03,   5.5538192E-03,   5.7058190E-03
     +,   5.8709118E-03,   6.0536461E-03,   6.2577473E-03
     +,   6.4853649E-03,   6.7360648E-03,   7.0067132E-03
     +,   7.2915596E-03,   7.5831665E-03,   7.8735240E-03
     +,   8.1548309E-03,   8.4200026E-03,   8.6622173E-03
     +,   8.8745719E-03,   9.0500265E-03,   9.1824941E-03
     +,   9.2690410E-03,   9.3124267E-03,   9.3226144E-03
     +,   9.3159452E-03,   9.3116937E-03,   9.3267057E-03
     +,   9.3700690E-03,   9.4399918E-03,   9.5242001E-03
     +,   9.6038086E-03,   9.6591944E-03,   9.6756825E-03
     +,   9.6473787E-03,   9.5779765E-03,   9.4792098E-03
     +,   9.3675368E-03,   9.2606889E-03,   9.1744242E-03
     +,   9.1200862E-03,   9.1028931E-03,   9.1211861E-03
     +,   9.1666635E-03,   9.2257475E-03,   9.2820711E-03
     +,   9.3194405E-03,   9.3246670E-03,   9.2894668E-03
     +,   9.2111956E-03,   9.0924157E-03,   8.9397309E-03
     +,   8.7623838E-03,   8.5709449E-03,   8.3759883E-03
     +,   8.1869783E-03,   8.0110887E-03,   7.8522591E-03
     +,   7.7106473E-03,   7.5827981E-03,   7.4626100E-03
     +,   7.3428899E-03,   7.2171846E-03,   7.0812036E-03
     +,   6.9337566E-03,   6.7768404E-03,   6.6150036E-03
     +,   6.4544817E-03,   6.3021267E-03,   6.1645573E-03
     +,   6.0473885E-03,   5.9547150E-03,   5.8885668E-03
     +,   5.8484874E-03,   5.8312877E-03,   5.8311028E-03
     +,   5.8398899E-03,   5.8484152E-03,   5.8475654E-03
     +,   5.8297771E-03,   5.7902699E-03,   5.7277894E-03
     +,   5.6447499E-03,   5.5467319E-03,   5.4415222E-03
     +,   5.3378339E-03,   5.2440874E-03,   5.1674023E-03
     +,   5.1128794E-03,   5.0832825E-03,   5.0790063E-03
     +,   5.0982637E-03,   5.1373648E-03,   5.1910486E-03
     +,   5.2528740E-03,   5.3156060E-03,   5.3716628E-03
     +,   5.4135947E-03,   5.4345741E-03,   5.4288460E-03
     +,   5.3920783E-03,   5.3215753E-03,   5.2163014E-03
     +,   5.0767623E-03,   4.9047782E-03,   4.7031618E-03
     +,   4.4754460E-03,   4.2256080E-03,   3.9578965E-03
     +,   3.6766930E-03,   3.3864391E-03,   3.0915821E-03
     +,   2.7965049E-03,   2.5054414E-03,   2.2224395E-03
     +,   1.9511051E-03,   1.6946701E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wano_fus_105 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wano_fus_110(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  2.1399703E-06,   2.1747830E-06
     +,   2.2097001E-06,   2.2447111E-06,   2.2798040E-06
     +,   2.3149694E-06,   2.3501973E-06,   2.3854777E-06
     +,   2.4208034E-06,   2.4561639E-06,   2.4915521E-06
     +,   2.5269610E-06,   2.5623849E-06,   2.5978195E-06
     +,   2.6332616E-06,   2.6687080E-06,   2.7041597E-06
     +,   2.7396179E-06,   2.7750871E-06,   2.8105746E-06
     +,   2.8460886E-06,   2.8816416E-06,   2.9172502E-06
     +,   2.9529347E-06,   2.9887201E-06,   3.0246338E-06
     +,   3.0607132E-06,   3.0969979E-06,   3.1335387E-06
     +,   3.1703873E-06,   3.2076100E-06,   3.2452801E-06
     +,   3.2834805E-06,   3.3223073E-06,   3.3618685E-06
     +,   3.4022844E-06,   3.4436921E-06,   3.4862460E-06
     +,   3.5301186E-06,   3.5755036E-06,   3.6226136E-06
     +,   3.6716899E-06,   3.7229995E-06,   3.7768384E-06
     +,   3.8335356E-06,   3.8934554E-06,   3.9569973E-06
     +,   4.0246073E-06,   4.0967743E-06,   4.1740354E-06
     +,   4.2569836E-06,   4.3462678E-06,   4.4426006E-06
     +,   4.5467600E-06,   4.6595983E-06,   4.7820431E-06
     +,   4.9151099E-06,   5.0598933E-06,   5.2175888E-06
     +,   5.3894978E-06,   5.5770111E-06,   5.7816469E-06
     +,   6.0050374E-06,   6.2489371E-06,   6.5152312E-06
     +,   6.8059417E-06,   7.1232375E-06,   7.4694108E-06
     +,   7.8469266E-06,   8.2583938E-06,   8.7065919E-06
     +,   9.1944257E-06,   9.7249904E-06,   1.0301541E-05
     +,   1.0927481E-05,   1.1606379E-05,   1.2341978E-05
     +,   1.3138123E-05,   1.3998849E-05,   1.4928330E-05
     +,   1.5930853E-05,   1.7010871E-05,   1.8172863E-05
     +,   1.9421506E-05,   2.0761518E-05,   2.2197721E-05
     +,   2.3734992E-05,   2.5378265E-05,   2.7132548E-05
     +,   2.9002931E-05,   3.0994324E-05,   3.3111875E-05
     +,   3.5360707E-05,   3.7745951E-05,   4.0272775E-05
     +,   4.2946402E-05,   4.5772242E-05,   4.8755392E-05
     +,   5.1901461E-05,   5.5216060E-05,   5.8704994E-05
     +,   6.2374325E-05,   6.6230350E-05,   7.0279770E-05
     +,   7.4529686E-05,   7.8987607E-05,   8.3661653E-05
     +,   8.8560482E-05,   9.3693496E-05,   9.9070756E-05
     +,   1.0470316E-04,   1.1060263E-04,   1.1678127E-04
     +,   1.2325274E-04,   1.3003149E-04,   1.3713281E-04
     +,   1.4457286E-04,   1.5236881E-04,   1.6053882E-04
     +,   1.6910087E-04,   1.7807455E-04,   1.8747963E-04
     +,   1.9733635E-04,   2.0766501E-04,   2.1848563E-04
     +,   2.2981850E-04,   2.4168268E-04,   2.5409641E-04
     +,   2.6707674E-04,   2.8063875E-04,   2.9479509E-04
     +,   3.0955646E-04,   3.2492870E-04,   3.4091517E-04
     +,   3.5751527E-04,   3.7472419E-04,   3.9253244E-04
     +,   4.1092702E-04,   4.2989114E-04,   4.4940657E-04
     +,   4.6945090E-04,   4.9000478E-04,   5.1105133E-04
     +,   5.3257844E-04,   5.5458304E-04,   5.7707389E-04
     +,   6.0007669E-04,   6.2363548E-04,   6.4781873E-04
     +,   6.7272160E-04,   6.9846836E-04,   7.2521716E-04
     +,   7.5315405E-04,   7.8250095E-04,   8.1350910E-04
     +,   8.4645645E-04,   8.8164065E-04,   9.1937516E-04
     +,   9.5997792E-04,   1.0037591E-03,   1.0510115E-03
     +,   1.1019971E-03,   1.1569220E-03,   1.2159426E-03
     +,   1.2791412E-03,   1.3465214E-03,   1.4180122E-03
     +,   1.4934671E-03,   1.5726910E-03,   1.6554556E-03
     +,   1.7415353E-03,   1.8307552E-03,   1.9230195E-03
     +,   2.0183683E-03,   2.1169835E-03,   2.2192379E-03
     +,   2.3256722E-03,   2.4369769E-03,   2.5539368E-03
     +,   2.6773503E-03,   2.8079026E-03,   2.9461179E-03
     +,   3.0921693E-03,   3.2458799E-03,   3.4066665E-03
     +,   3.5736205E-03,   3.7456201E-03,   3.9215428E-03
     +,   4.1004596E-03,   4.2817909E-03,   4.4653844E-03
     +,   4.6514408E-03,   4.8403488E-03,   5.0323703E-03
     +,   5.2274857E-03,   5.4251235E-03,   5.6242272E-03
     +,   5.8232672E-03,   6.0204240E-03,   6.2138853E-03
     +,   6.4018760E-03,   6.5829977E-03,   6.7563262E-03
     +,   6.9217957E-03,   7.0804623E-03,   7.2347145E-03
     +,   7.3881391E-03,   7.5449571E-03,   7.7092065E-03
     +,   7.8836707E-03,   8.0691762E-03,   8.2643982E-03
     +,   8.4663704E-03,   8.6717512E-03,   8.8782907E-03
     +,   9.0862038E-03,   9.2988536E-03,   9.5218187E-03
     +,   9.7608101E-03,   1.0018338E-02,   1.0290811E-02
     +,   1.0567416E-02,   1.0831675E-02,   1.1065699E-02
     +,   1.1255299E-02,   1.1393673E-02,   1.1482323E-02
     +,   1.1528540E-02,   1.1540923E-02,   1.1524861E-02
     +,   1.1480167E-02,   1.1401744E-02,   1.1283271E-02
     +,   1.1122047E-02,   1.0922903E-02,   1.0698746E-02
     +,   1.0467366E-02,   1.0245577E-02,   1.0043129E-02
     +,   9.8596746E-03,   9.6860640E-03,   9.5096724E-03
     +,   9.3212873E-03,   9.1205388E-03,   8.9174621E-03
     +,   8.7295352E-03,   8.5755745E-03,   8.4690563E-03
     +,   8.4135057E-03,   8.4015559E-03,   8.4176371E-03
     +,   8.4429467E-03,   8.4605841E-03,   8.4592123E-03
     +,   8.4343096E-03,   8.3872546E-03,   8.3231842E-03
     +,   8.2487073E-03,   8.1702303E-03,   8.0931075E-03
     +,   8.0213733E-03,   7.9576634E-03,   7.9030441E-03
     +,   7.8568244E-03,   7.8164786E-03,   7.7779517E-03
     +,   7.7363206E-03,   7.6866481E-03,   7.6248529E-03
     +,   7.5481520E-03,   7.4553802E-03,   7.3469519E-03
     +,   7.2248657E-03,   7.0925811E-03,   6.9549270E-03
     +,   6.8177460E-03,   6.6872151E-03,   6.5689310E-03
     +,   6.4667370E-03,   6.3817855E-03,   6.3118902E-03
     +,   6.2515172E-03,   6.1923051E-03,   6.1241398E-03
     +,   6.0364590E-03,   5.9196651E-03,   5.7663587E-03
     +,   5.5721989E-03,   5.3363368E-03,   5.0613503E-03
     +,   4.7527510E-03,   4.4181920E-03,   4.0664948E-03
     +,   3.7067339E-03,   3.3474276E-03,   2.9959884E-03
     +,   2.6584109E-03,   2.3391892E-03,   2.0414654E-03
     +,   1.7670863E-03,   1.5170120E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wano_fus_110 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wano_fus_115(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  4.8653196E-06,   4.9420860E-06
     +,   5.0192693E-06,   5.0968779E-06,   5.1749198E-06
     +,   5.2534110E-06,   5.3323683E-06,   5.4118113E-06
     +,   5.4917673E-06,   5.5722608E-06,   5.6533249E-06
     +,   5.7349985E-06,   5.8173209E-06,   5.9003419E-06
     +,   5.9841136E-06,   6.0686903E-06,   6.1541396E-06
     +,   6.2405297E-06,   6.3279394E-06,   6.4164542E-06
     +,   6.5061627E-06,   6.5971644E-06,   6.6895682E-06
     +,   6.7834894E-06,   6.8790546E-06,   6.9763942E-06
     +,   7.0756523E-06,   7.1769837E-06,   7.2805556E-06
     +,   7.3865358E-06,   7.4951145E-06,   7.6064885E-06
     +,   7.7208670E-06,   7.8384728E-06,   7.9595429E-06
     +,   8.0843220E-06,   8.2130746E-06,   8.3460754E-06
     +,   8.4836183E-06,   8.6260125E-06,   8.7735743E-06
     +,   8.9266441E-06,   9.0855792E-06,   9.2507544E-06
     +,   9.4225588E-06,   9.6014064E-06,   9.7877173E-06
     +,   9.9819463E-06,   1.0184563E-05,   1.0396049E-05
     +,   1.0616920E-05,   1.0847708E-05,   1.1088969E-05
     +,   1.1341280E-05,   1.1605242E-05,   1.1881482E-05
     +,   1.2170658E-05,   1.2473428E-05,   1.2790500E-05
     +,   1.3122607E-05,   1.3470487E-05,   1.3834916E-05
     +,   1.4216702E-05,   1.4616669E-05,   1.5035668E-05
     +,   1.5474579E-05,   1.5934304E-05,   1.6415754E-05
     +,   1.6919876E-05,   1.7447641E-05,   1.8000046E-05
     +,   1.8578065E-05,   1.9182740E-05,   1.9815101E-05
     +,   2.0476205E-05,   2.1167110E-05,   2.1888916E-05
     +,   2.2642673E-05,   2.3429495E-05,   2.4250492E-05
     +,   2.5106785E-05,   2.5999523E-05,   2.6929813E-05
     +,   2.7898841E-05,   2.8907800E-05,   2.9957899E-05
     +,   3.1050415E-05,   3.2186643E-05,   3.3367967E-05
     +,   3.4595902E-05,   3.5871886E-05,   3.7197660E-05
     +,   3.8575061E-05,   4.0006100E-05,   4.1492985E-05
     +,   4.3038224E-05,   4.4644665E-05,   4.6315261E-05
     +,   4.8053578E-05,   4.9863600E-05,   5.1749721E-05
     +,   5.3716976E-05,   5.5770932E-05,   5.7917860E-05
     +,   6.0164726E-05,   6.2519277E-05,   6.4990025E-05
     +,   6.7586385E-05,   7.0318602E-05,   7.3197800E-05
     +,   7.6235992E-05,   7.9446232E-05,   8.2841871E-05
     +,   8.6437620E-05,   9.0248592E-05,   9.4290568E-05
     +,   9.8579803E-05,   1.0313283E-04,   1.0796660E-04
     +,   1.1309729E-04,   1.1854153E-04,   1.2431524E-04
     +,   1.3043350E-04,   1.3691049E-04,   1.4375908E-04
     +,   1.5099061E-04,   1.5861473E-04,   1.6663894E-04
     +,   1.7506861E-04,   1.8390662E-04,   1.9315326E-04
     +,   2.0280654E-04,   2.1286035E-04,   2.2330706E-04
     +,   2.3413563E-04,   2.4533222E-04,   2.5688042E-04
     +,   2.6876098E-04,   2.8095228E-04,   2.9343131E-04
     +,   3.0617119E-04,   3.1914536E-04,   3.3232546E-04
     +,   3.4568206E-04,   3.5918615E-04,   3.7280851E-04
     +,   3.8652093E-04,   4.0029778E-04,   4.1411479E-04
     +,   4.2795273E-04,   4.4179641E-04,   4.5563743E-04
     +,   4.6947360E-04,   4.8331285E-04,   4.9717375E-04
     +,   5.1108695E-04,   5.2509760E-04,   5.3926604E-04
     +,   5.5367191E-04,   5.6841352E-04,   5.8361230E-04
     +,   5.9941516E-04,   6.1599532E-04,   6.3356047E-04
     +,   6.5235636E-04,   6.7267311E-04,   6.9485372E-04
     +,   7.1930303E-04,   7.4649649E-04,   7.7698583E-04
     +,   8.1140880E-04,   8.5048156E-04,   8.9499151E-04
     +,   9.4577938E-04,   1.0036947E-03,   1.0695638E-03
     +,   1.1441238E-03,   1.2279619E-03,   1.3214541E-03
     +,   1.4247171E-03,   1.5375534E-03,   1.6595004E-03
     +,   1.7897830E-03,   1.9274293E-03,   2.0713208E-03
     +,   2.2202758E-03,   2.3731294E-03,   2.5287750E-03
     +,   2.6861771E-03,   2.8443432E-03,   3.0022894E-03
     +,   3.1589924E-03,   3.3134066E-03,   3.4644934E-03
     +,   3.6114331E-03,   3.7537047E-03,   3.8913831E-03
     +,   4.0251748E-03,   4.1564829E-03,   4.2873379E-03
     +,   4.4200891E-03,   4.5572538E-03,   4.7012097E-03
     +,   4.8541501E-03,   5.0180331E-03,   5.1945345E-03
     +,   5.3848666E-03,   5.5893650E-03,   5.8067706E-03
     +,   6.0334904E-03,   6.2630870E-03,   6.4864485E-03
     +,   6.6928212E-03,   6.8716267E-03,   7.0147668E-03
     +,   7.1186121E-03,   7.1852417E-03,   7.2223172E-03
     +,   7.2419848E-03,   7.2590602E-03,   7.2892038E-03
     +,   7.3475023E-03,   7.4472409E-03,   7.5985026E-03
     +,   7.8061935E-03,   8.0675175E-03,   8.3697829E-03
     +,   8.6899456E-03,   8.9967791E-03,   9.2560016E-03
     +,   9.4370879E-03,   9.5198834E-03,   9.4991019E-03
     +,   9.3855802E-03,   9.2041986E-03,   8.9896359E-03
     +,   8.7806508E-03,   8.6140903E-03,   8.5189808E-03
     +,   8.5119158E-03,   8.5945409E-03,   8.7541761E-03
     +,   8.9675281E-03,   9.2064347E-03,   9.4434982E-03
     +,   9.6562970E-03,   9.8294783E-03,   9.9554574E-03
     +,   1.0034235E-02,   1.0072605E-02,   1.0082010E-02
     +,   1.0074910E-02,   1.0060521E-02,   1.0041659E-02
     +,   1.0014443E-02,   9.9711362E-03,   9.9047376E-03
     +,   9.8130926E-03,   9.7007770E-03,   9.5779486E-03
     +,   9.4569288E-03,   9.3477517E-03,   9.2542954E-03
     +,   9.1723409E-03,   9.0901889E-03,   8.9919958E-03
     +,   8.8625560E-03,   8.6921919E-03,   8.4797852E-03
     +,   8.2331449E-03,   7.9665687E-03,   7.6969927E-03
     +,   7.4399705E-03,   7.2069322E-03,   7.0038890E-03
     +,   6.8315743E-03,   6.6863890E-03,   6.5616365E-03
     +,   6.4488575E-03,   6.3389558E-03,   6.2233070E-03
     +,   6.0945549E-03,   5.9470488E-03,   5.7769916E-03
     +,   5.5822926E-03,   5.3623421E-03,   5.1178378E-03
     +,   4.8506605E-03,   4.5638508E-03,   4.2614904E-03
     +,   3.9485018E-03,   3.6303012E-03,   3.3123519E-03
     +,   2.9997341E-03,   2.6968077E-03,   2.4070253E-03
     +,   2.1329250E-03,   1.8762014E-03,   1.6379448E-03
     +,   1.4186795E-03,   1.2186504E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wano_fus_115 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wano_fus_120(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  4.2999181E-06,   4.4652002E-06
     +,   4.6347527E-06,   4.8085899E-06,   4.9867076E-06
     +,   5.1691090E-06,   5.3557874E-06,   5.5467294E-06
     +,   5.7419220E-06,   5.9413301E-06,   6.1449286E-06
     +,   6.3526800E-06,   6.5645399E-06,   6.7804585E-06
     +,   7.0003825E-06,   7.2242387E-06,   7.4519603E-06
     +,   7.6834694E-06,   7.9186793E-06,   8.1575045E-06
     +,   8.3998330E-06,   8.6455639E-06,   8.8945844E-06
     +,   9.1467691E-06,   9.4019988E-06,   9.6601225E-06
     +,   9.9210065E-06,   1.0184496E-05,   1.0450444E-05
     +,   1.0718673E-05,   1.0989017E-05,   1.1261300E-05
     +,   1.1535337E-05,   1.1810939E-05,   1.2087918E-05
     +,   1.2366055E-05,   1.2645152E-05,   1.2924999E-05
     +,   1.3205375E-05,   1.3486064E-05,   1.3766833E-05
     +,   1.4047452E-05,   1.4327692E-05,   1.4607319E-05
     +,   1.4886092E-05,   1.5163781E-05,   1.5440131E-05
     +,   1.5714912E-05,   1.5987889E-05,   1.6258813E-05
     +,   1.6527456E-05,   1.6793589E-05,   1.7056986E-05
     +,   1.7317427E-05,   1.7574706E-05,   1.7828619E-05
     +,   1.8078990E-05,   1.8325625E-05,   1.8568382E-05
     +,   1.8807124E-05,   1.9041723E-05,   1.9272102E-05
     +,   1.9498202E-05,   1.9719990E-05,   1.9937484E-05
     +,   2.0150736E-05,   2.0359861E-05,   2.0564999E-05
     +,   2.0766387E-05,   2.0964300E-05,   2.1159112E-05
     +,   2.1351265E-05,   2.1541300E-05,   2.1729858E-05
     +,   2.1917698E-05,   2.2105698E-05,   2.2294878E-05
     +,   2.2486383E-05,   2.2681546E-05,   2.2881854E-05
     +,   2.3088996E-05,   2.3304852E-05,   2.3531518E-05
     +,   2.3771325E-05,   2.4026851E-05,   2.4300940E-05
     +,   2.4596717E-05,   2.4917585E-05,   2.5267282E-05
     +,   2.5649881E-05,   2.6069731E-05,   2.6531601E-05
     +,   2.7040616E-05,   2.7602258E-05,   2.8222426E-05
     +,   2.8907392E-05,   2.9663888E-05,   3.0498930E-05
     +,   3.1420048E-05,   3.2435149E-05,   3.3552511E-05
     +,   3.4780816E-05,   3.6129091E-05,   3.7606707E-05
     +,   3.9223331E-05,   4.0988918E-05,   4.2913613E-05
     +,   4.5007757E-05,   4.7281781E-05,   4.9746155E-05
     +,   5.2411309E-05,   5.5287641E-05,   5.8384951E-05
     +,   6.1713086E-05,   6.5281289E-05,   6.9098242E-05
     +,   7.3171897E-05,   7.7509430E-05,   8.2117149E-05
     +,   8.6999768E-05,   9.2161266E-05,   9.7604112E-05
     +,   1.0332932E-04,   1.0933633E-04,   1.1562288E-04
     +,   1.2218507E-04,   1.2901716E-04,   1.3611185E-04
     +,   1.4345995E-04,   1.5105083E-04,   1.5887228E-04
     +,   1.6691121E-04,   1.7515243E-04,   1.8358098E-04
     +,   1.9218132E-04,   2.0093772E-04,   2.0983527E-04
     +,   2.1885980E-04,   2.2799885E-04,   2.3724252E-04
     +,   2.4658264E-04,   2.5601551E-04,   2.6554134E-04
     +,   2.7516484E-04,   2.8489629E-04,   2.9475131E-04
     +,   3.0475217E-04,   3.1492737E-04,   3.2531237E-04
     +,   3.3594892E-04,   3.4688591E-04,   3.5817851E-04
     +,   3.6988663E-04,   3.8207654E-04,   3.9481791E-04
     +,   4.0818422E-04,   4.2224961E-04,   4.3708924E-04
     +,   4.5277586E-04,   4.6937898E-04,   4.8696244E-04
     +,   5.0558243E-04,   5.2528264E-04,   5.4609636E-04
     +,   5.6804181E-04,   5.9111998E-04,   6.1531481E-04
     +,   6.4059178E-04,   6.6689920E-04,   6.9416960E-04
     +,   7.2232535E-04,   7.5128238E-04,   7.8095961E-04
     +,   8.1129058E-04,   8.4222760E-04,   8.7376515E-04
     +,   9.0594683E-04,   9.3887886E-04,   9.7274286E-04
     +,   1.0078084E-03,   1.0444293E-03,   1.0830670E-03
     +,   1.1242692E-03,   1.1686870E-03,   1.2170596E-03
     +,   1.2702135E-03,   1.3290504E-03,   1.3945319E-03
     +,   1.4676579E-03,   1.5494293E-03,   1.6407943E-03
     +,   1.7425691E-03,   1.8553489E-03,   1.9793494E-03
     +,   2.1143395E-03,   2.2594237E-03,   2.4130361E-03
     +,   2.5728019E-03,   2.7356185E-03,   2.8978307E-03
     +,   3.0553818E-03,   3.2042647E-03,   3.3408457E-03
     +,   3.4623528E-03,   3.5672549E-03,   3.6555456E-03
     +,   3.7288724E-03,   3.7904682E-03,   3.8448670E-03
     +,   3.8974299E-03,   3.9537605E-03,   4.0190956E-03
     +,   4.0977774E-03,   4.1929488E-03,   4.3064803E-03
     +,   4.4391598E-03,   4.5911865E-03,   4.7625923E-03
     +,   4.9537485E-03,   5.1655169E-03,   5.3990125E-03
     +,   5.6550219E-03,   5.9327628E-03,   6.2286966E-03
     +,   6.5353285E-03,   6.8407217E-03,   7.1290685E-03
     +,   7.3824818E-03,   7.5836941E-03,   7.7190907E-03
     +,   7.7812620E-03,   7.7703665E-03,   7.6941657E-03
     +,   7.5669303E-03,   7.4076266E-03,   7.2376467E-03
     +,   7.0784595E-03,   6.9491616E-03,   6.8640499E-03
     +,   6.8306779E-03,   6.8488130E-03,   6.9108158E-03
     +,   7.0036417E-03,   7.1123783E-03,   7.2243642E-03
     +,   7.3327716E-03,   7.4384534E-03,   7.5491890E-03
     +,   7.6766708E-03,   7.8321686E-03,   8.0222320E-03
     +,   8.2457894E-03,   8.4931087E-03,   8.7465411E-03
     +,   8.9829974E-03,   9.1775572E-03,   9.3081463E-03
     +,   9.3602017E-03,   9.3302857E-03,   9.2274304E-03
     +,   9.0712458E-03,   8.8875210E-03,   8.7026302E-03
     +,   8.5388124E-03,   8.4113721E-03,   8.3282525E-03
     +,   8.2908990E-03,   8.2951644E-03,   8.3319498E-03
     +,   8.3876913E-03,   8.4456606E-03,   8.4883496E-03
     +,   8.5006068E-03,   8.4722908E-03,   8.3994158E-03
     +,   8.2834158E-03,   8.1288498E-03,   7.9407040E-03
     +,   7.7224341E-03,   7.4752136E-03,   7.1987514E-03
     +,   6.8927961E-03,   6.5587382E-03,   6.2005967E-03
     +,   5.8248653E-03,   5.4396698E-03,   5.0534247E-03
     +,   4.6736044E-03,   4.3058973E-03,   3.9539374E-03
     +,   3.6194485E-03,   3.3026948E-03,   3.0030222E-03
     +,   2.7193706E-03,   2.4506836E-03,   2.1961718E-03
     +,   1.9554512E-03,   1.7285416E-03,   1.5158402E-03
     +,   1.3178822E-03,   1.1353247E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wano_fus_120 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wano_fus_60(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  3.1185092E-04,   3.2903923E-04
     +,   3.4673413E-04,   3.6491980E-04,   3.8358395E-04
     +,   4.0272236E-04,   4.2233823E-04,   4.4244391E-04
     +,   4.6306284E-04,   4.8422589E-04,   5.0597504E-04
     +,   5.2835775E-04,   5.5142492E-04,   5.7522790E-04
     +,   5.9981295E-04,   6.2521425E-04,   6.5145275E-04
     +,   6.7852659E-04,   7.0641073E-04,   7.3505082E-04
     +,   7.6436275E-04,   7.9423387E-04,   8.2452601E-04
     +,   8.5507933E-04,   8.8572316E-04,   9.1628416E-04
     +,   9.4660278E-04,   9.7655173E-04,   1.0060538E-03
     +,   1.0351033E-03,   1.0637925E-03,   1.0923321E-03
     +,   1.1210711E-03,   1.1505098E-03,   1.1813046E-03
     +,   1.2142558E-03,   1.2502816E-03,   1.2903763E-03
     +,   1.3355438E-03,   1.3867212E-03,   1.4446913E-03
     +,   1.5099996E-03,   1.5828706E-03,   1.6631577E-03
     +,   1.7503115E-03,   1.8433944E-03,   1.9411093E-03
     +,   2.0418933E-03,   2.1440072E-03,   2.2456290E-03
     +,   2.3449694E-03,   2.4403399E-03,   2.5302039E-03
     +,   2.6131840E-03,   2.6880638E-03,   2.7537472E-03
     +,   2.8092247E-03,   2.8535496E-03,   2.8858455E-03
     +,   2.9053313E-03,   2.9113842E-03,   2.9036414E-03
     +,   2.8820809E-03,   2.8471258E-03,   2.7996965E-03
     +,   2.7412439E-03,   2.6737072E-03,   2.5994512E-03
     +,   2.5211116E-03,   2.4414514E-03,   2.3631665E-03
     +,   2.2887161E-03,   2.2201554E-03,   2.1590139E-03
     +,   2.1062139E-03,   2.0620460E-03,   2.0261896E-03
     +,   1.9977819E-03,   1.9755322E-03,   1.9578456E-03
     +,   1.9429699E-03,   1.9291430E-03,   1.9147217E-03
     +,   1.8982696E-03,   1.8786405E-03,   1.8550018E-03
     +,   1.8268393E-03,   1.7939250E-03,   1.7562724E-03
     +,   1.7140820E-03,   1.6676876E-03,   1.6175016E-03
     +,   1.5639797E-03,   1.5076061E-03,   1.4488720E-03
     +,   1.3882836E-03,   1.3263545E-03,   1.2636229E-03
     +,   1.2006388E-03,   1.1379683E-03,   1.0761793E-03
     +,   1.0158333E-03,   9.5746282E-04,   9.0155768E-04
     +,   8.4854610E-04,   7.9878315E-04,   7.5253897E-04
     +,   7.0999749E-04,   6.7125552E-04,   6.3632702E-04
     +,   6.0515251E-04,   5.7760772E-04,   5.5352051E-04
     +,   5.3267676E-04,   5.1483553E-04,   4.9974077E-04
     +,   4.8712964E-04,   4.7674135E-04,   4.6832295E-04
     +,   4.6163573E-04,   4.5645595E-04,   4.5257862E-04
     +,   4.4981751E-04,   4.4800533E-04,   4.4699304E-04
     +,   4.4664796E-04,   4.4685224E-04,   4.4750146E-04
     +,   4.4850237E-04,   4.4977156E-04,   4.5123353E-04
     +,   4.5281960E-04,   4.5446694E-04,   4.5611747E-04
     +,   4.5771754E-04,   4.5921694E-04,   4.6056957E-04
     +,   4.6173271E-04,   4.6266685E-04,   4.6333650E-04
     +,   4.6370929E-04,   4.6375699E-04,   4.6345530E-04
     +,   4.6278356E-04,   4.6172546E-04,   4.6026829E-04
     +,   4.5840404E-04,   4.5612804E-04,   4.5343983E-04
     +,   4.5034231E-04,   4.4684284E-04,   4.4295113E-04
     +,   4.3868137E-04,   4.3404978E-04,   4.2907556E-04
     +,   4.2378058E-04,   4.1818887E-04,   4.1232616E-04
     +,   4.0622021E-04,   3.9989949E-04,   3.9339397E-04
     +,   3.8673362E-04,   3.7995001E-04,   3.7307339E-04
     +,   3.6613474E-04,   3.5916409E-04,   3.5219089E-04
     +,   3.4524387E-04,   3.3835034E-04,   3.3153620E-04
     +,   3.2482631E-04,   3.1824349E-04,   3.1180918E-04
     +,   3.0554252E-04,   2.9946183E-04,   2.9358242E-04
     +,   2.8791814E-04,   2.8248079E-04,   2.7728028E-04
     +,   2.7232431E-04,   2.6761933E-04,   2.6316865E-04
     +,   2.5897488E-04,   2.5503812E-04,   2.5135683E-04
     +,   2.4792770E-04,   2.4474555E-04,   2.4180386E-04
     +,   2.3909452E-04,   2.3660754E-04,   2.3433208E-04
     +,   2.3225557E-04,   2.3036446E-04,   2.2864436E-04
     +,   2.2707928E-04,   2.2565312E-04,   2.2434841E-04
     +,   2.2314765E-04,   2.2203288E-04,   2.2098541E-04
     +,   2.1998708E-04,   2.1901910E-04,   2.1806345E-04
     +,   2.1710209E-04,   2.1611749E-04,   2.1509266E-04
     +,   2.1401166E-04,   2.1285897E-04,   2.1162031E-04
     +,   2.1028245E-04,   2.0883320E-04,   2.0726171E-04
     +,   2.0555833E-04,   2.0371497E-04,   2.0172462E-04
     +,   1.9958225E-04,   1.9728349E-04,   1.9482616E-04
     +,   1.9220907E-04,   1.8943253E-04,   1.8649842E-04
     +,   1.8340939E-04,   1.8017004E-04,   1.7678575E-04
     +,   1.7326298E-04,   1.6960941E-04,   1.6583342E-04
     +,   1.6194444E-04,   1.5795245E-04,   1.5386811E-04
     +,   1.4970260E-04,   1.4546748E-04,   1.4117461E-04
     +,   1.3683605E-04,   1.3246392E-04,   1.2807036E-04
     +,   1.2366711E-04,   1.1926639E-04,   1.1487957E-04
     +,   1.1051774E-04,   1.0619168E-04,   1.0191139E-04
     +,   9.7686934E-05,   9.3527240E-05,   8.9440699E-05
     +,   8.5435131E-05,   8.1517639E-05,   7.7694553E-05
     +,   7.3971627E-05,   7.0353759E-05,   6.6845234E-05
     +,   6.3449566E-05,   6.0169659E-05,   5.7007685E-05
     +,   5.3965232E-05,   5.1043233E-05,   4.8242084E-05
     +,   4.5561508E-05,   4.3001048E-05,   4.0559495E-05
     +,   3.8235255E-05,   3.6026409E-05,   3.3930555E-05
     +,   3.1945281E-05,   3.0067620E-05,   2.8294478E-05
     +,   2.6622551E-05,   2.5048390E-05,   2.3568406E-05
     +,   2.2178918E-05,   2.0876185E-05,   1.9656418E-05
     +,   1.8515813E-05,   1.7450582E-05,   1.6456956E-05
     +,   1.5531206E-05,   1.4669687E-05,   1.3868771E-05
     +,   1.3125037E-05,   1.2435060E-05,   1.1795546E-05
     +,   1.1203320E-05,   1.0655306E-05,   1.0148618E-05
     +,   9.6804351E-06,   9.2480695E-06,   8.8489796E-06
     +,   8.4807443E-06,   8.1410735E-06,   7.8277990E-06
     +,   7.5388771E-06,   7.2723865E-06,   7.0265196E-06
     +,   6.7995848E-06,   6.5899976E-06,   6.3962821E-06
     +,   6.2170584E-06,   6.0510379E-06,   5.8970550E-06
     +,   5.7539778E-06,   5.6208073E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wano_fus_60 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wano_fus_65(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  1.4536179E-04,   1.5273903E-04
     +,   1.6034937E-04,   1.6818836E-04,   1.7624938E-04
     +,   1.8452451E-04,   1.9300373E-04,   2.0167467E-04
     +,   2.1052326E-04,   2.1953192E-04,   2.2868143E-04
     +,   2.3794975E-04,   2.4731242E-04,   2.5674235E-04
     +,   2.6621067E-04,   2.7568606E-04,   2.8513651E-04
     +,   2.9452940E-04,   3.0383232E-04,   3.1301475E-04
     +,   3.2204829E-04,   3.3090988E-04,   3.3958227E-04
     +,   3.4805640E-04,   3.5633371E-04,   3.6442670E-04
     +,   3.7236241E-04,   3.8018249E-04,   3.8794483E-04
     +,   3.9572289E-04,   4.0360651E-04,   4.1169918E-04
     +,   4.2011726E-04,   4.2898662E-04,   4.3844004E-04
     +,   4.4861480E-04,   4.5965114E-04,   4.7169335E-04
     +,   4.8489220E-04,   4.9941259E-04,   5.1544420E-04
     +,   5.3321914E-04,   5.5303227E-04,   5.7526643E-04
     +,   6.0041819E-04,   6.2912342E-04,   6.6217396E-04
     +,   7.0052908E-04,   7.4530527E-04,   7.9774181E-04
     +,   8.5915060E-04,   9.3082961E-04,   1.0139542E-03
     +,   1.1094499E-03,   1.2178555E-03,   1.3391954E-03
     +,   1.4728730E-03,   1.6175953E-03,   1.7713766E-03
     +,   1.9315865E-03,   2.0950530E-03,   2.2582700E-03
     +,   2.4176035E-03,   2.5695406E-03,   2.7109487E-03
     +,   2.8392985E-03,   2.9528525E-03,   3.0507960E-03
     +,   3.1333314E-03,   3.2016586E-03,   3.2579317E-03
     +,   3.3050992E-03,   3.3466953E-03,   3.3865343E-03
     +,   3.4283467E-03,   3.4753622E-03,   3.5299144E-03
     +,   3.5930779E-03,   3.6644740E-03,   3.7422061E-03
     +,   3.8230303E-03,   3.9027294E-03,   3.9766035E-03
     +,   4.0400601E-03,   4.0891399E-03,   4.1209157E-03
     +,   4.1336622E-03,   4.1268640E-03,   4.1009532E-03
     +,   4.0570064E-03,   3.9963857E-03,   3.9204326E-03
     +,   3.8303398E-03,   3.7271183E-03,   3.6117008E-03
     +,   3.4851471E-03,   3.3487859E-03,   3.2043972E-03
     +,   3.0542021E-03,   2.9008307E-03,   2.7471799E-03
     +,   2.5962002E-03,   2.4506811E-03,   2.3130451E-03
     +,   2.1851913E-03,   2.0683964E-03,   1.9632855E-03
     +,   1.8698627E-03,   1.7875924E-03,   1.7155248E-03
     +,   1.6524274E-03,   1.5969310E-03,   1.5476609E-03
     +,   1.5033237E-03,   1.4628005E-03,   1.4251785E-03
     +,   1.3897658E-03,   1.3560808E-03,   1.3238206E-03
     +,   1.2928277E-03,   1.2630410E-03,   1.2344626E-03
     +,   1.2071201E-03,   1.1810408E-03,   1.1562362E-03
     +,   1.1326851E-03,   1.1103335E-03,   1.0890925E-03
     +,   1.0688396E-03,   1.0494278E-03,   1.0306890E-03
     +,   1.0124471E-03,   9.9452271E-04,   9.7674062E-04
     +,   9.5894240E-04,   9.4098831E-04,   9.2276552E-04
     +,   9.0419140E-04,   8.8521757E-04,   8.6582761E-04
     +,   8.4604206E-04,   8.2591060E-04,   8.0551027E-04
     +,   7.8494364E-04,   7.6433120E-04,   7.4380590E-04
     +,   7.2350813E-04,   7.0357986E-04,   6.8415800E-04
     +,   6.6537072E-04,   6.4733217E-04,   6.3013926E-04
     +,   6.1387132E-04,   5.9858314E-04,   5.8430951E-04
     +,   5.7106279E-04,   5.5883417E-04,   5.4759660E-04
     +,   5.3730601E-04,   5.2790402E-04,   5.1932252E-04
     +,   5.1148457E-04,   5.0431042E-04,   4.9771805E-04
     +,   4.9162767E-04,   4.8596322E-04,   4.8065497E-04
     +,   4.7564157E-04,   4.7086997E-04,   4.6629776E-04
     +,   4.6189249E-04,   4.5763160E-04,   4.5350273E-04
     +,   4.4950264E-04,   4.4563657E-04,   4.4191699E-04
     +,   4.3836169E-04,   4.3499385E-04,   4.3183952E-04
     +,   4.2892675E-04,   4.2628450E-04,   4.2394004E-04
     +,   4.2191934E-04,   4.2024470E-04,   4.1893462E-04
     +,   4.1800167E-04,   4.1745318E-04,   4.1728956E-04
     +,   4.1750428E-04,   4.1808363E-04,   4.1900633E-04
     +,   4.2024389E-04,   4.2176087E-04,   4.2351484E-04
     +,   4.2545761E-04,   4.2753518E-04,   4.2968936E-04
     +,   4.3185768E-04,   4.3397507E-04,   4.3597538E-04
     +,   4.3779102E-04,   4.3935562E-04,   4.4060429E-04
     +,   4.4147452E-04,   4.4190823E-04,   4.4185171E-04
     +,   4.4125703E-04,   4.4008269E-04,   4.3829391E-04
     +,   4.3586397E-04,   4.3277344E-04,   4.2901174E-04
     +,   4.2457588E-04,   4.1947112E-04,   4.1371028E-04
     +,   4.0731489E-04,   4.0031108E-04,   3.9273396E-04
     +,   3.8462307E-04,   3.7602225E-04,   3.6698161E-04
     +,   3.5755150E-04,   3.4778749E-04,   3.3774503E-04
     +,   3.2748069E-04,   3.1705067E-04,   3.0651054E-04
     +,   2.9591398E-04,   2.8531250E-04,   2.7475489E-04
     +,   2.6428647E-04,   2.5394911E-04,   2.4378051E-04
     +,   2.3381448E-04,   2.2408050E-04,   2.1460373E-04
     +,   2.0540477E-04,   1.9650131E-04,   1.8790584E-04
     +,   1.7962755E-04,   1.7167220E-04,   1.6404194E-04
     +,   1.5673709E-04,   1.4975425E-04,   1.4308834E-04
     +,   1.3673217E-04,   1.3067693E-04,   1.2491261E-04
     +,   1.1942809E-04,   1.1421152E-04,   1.0925048E-04
     +,   1.0453226E-04,   1.0004407E-04,   9.5773212E-05
     +,   9.1707101E-05,   8.7833607E-05,   8.4140898E-05
     +,   8.0617625E-05,   7.7253411E-05,   7.4038027E-05
     +,   7.0962058E-05,   6.8016758E-05,   6.5193846E-05
     +,   6.2486171E-05,   5.9886745E-05,   5.7389323E-05
     +,   5.4988301E-05,   5.2678522E-05,   5.0455401E-05
     +,   4.8314796E-05,   4.6252968E-05,   4.4266588E-05
     +,   4.2352665E-05,   4.0508505E-05,   3.8731690E-05
     +,   3.7020018E-05,   3.5371508E-05,   3.3784258E-05
     +,   3.2256721E-05,   3.0787254E-05,   2.9374378E-05
     +,   2.8016668E-05,   2.6712711E-05,   2.5461288E-05
     +,   2.4261042E-05,   2.3110684E-05,   2.2008919E-05
     +,   2.0954465E-05,   1.9946028E-05,   1.8982293E-05
     +,   1.8061946E-05,   1.7183662E-05,   1.6346090E-05
     +,   1.5547881E-05,   1.4787680E-05,   1.4064113E-05
     +,   1.3375822E-05,   1.2721409E-05,   1.2099599E-05
     +,   1.1508937E-05,   1.0948168E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wano_fus_65 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wano_fus_70(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  3.4785211E-05,   3.6485973E-05
     +,   3.8297203E-05,   4.0226176E-05,   4.2280506E-05
     +,   4.4468376E-05,   4.6798388E-05,   4.9279683E-05
     +,   5.1921972E-05,   5.4735327E-05,   5.7730536E-05
     +,   6.0918901E-05,   6.4312218E-05,   6.7922818E-05
     +,   7.1763570E-05,   7.5847507E-05,   8.0188191E-05
     +,   8.4799445E-05,   8.9695081E-05,   9.4889059E-05
     +,   1.0039481E-04,   1.0622576E-04,   1.1239461E-04
     +,   1.1891344E-04,   1.2579348E-04,   1.3304436E-04
     +,   1.4067486E-04,   1.4869218E-04,   1.5710194E-04
     +,   1.6590758E-04,   1.7511137E-04,   1.8471330E-04
     +,   1.9471177E-04,   2.0510351E-04,   2.1588386E-04
     +,   2.2704614E-04,   2.3858344E-04,   2.5048779E-04
     +,   2.6275095E-04,   2.7536514E-04,   2.8832228E-04
     +,   3.0161589E-04,   3.1524076E-04,   3.2919383E-04
     +,   3.4347345E-04,   3.5808087E-04,   3.7301893E-04
     +,   3.8829370E-04,   4.0391332E-04,   4.1988690E-04
     +,   4.3622588E-04,   4.5294268E-04,   4.7004959E-04
     +,   4.8756017E-04,   5.0548685E-04,   5.2384345E-04
     +,   5.4264505E-04,   5.6190870E-04,   5.8165810E-04
     +,   6.0192653E-04,   6.2275911E-04,   6.4422155E-04
     +,   6.6640385E-04,   6.8942609E-04,   7.1344449E-04
     +,   7.3865312E-04,   7.6528592E-04,   7.9360994E-04
     +,   8.2392205E-04,   8.5653155E-04,   8.9174451E-04
     +,   9.2983758E-04,   9.7103813E-04,   1.0154941E-03
     +,   1.0632569E-03,   1.1142611E-03,   1.1683221E-03
     +,   1.2251348E-03,   1.2842999E-03,   1.3453452E-03
     +,   1.4077640E-03,   1.4710575E-03,   1.5347686E-03
     +,   1.5985192E-03,   1.6620326E-03,   1.7251413E-03
     +,   1.7877857E-03,   1.8500097E-03,   1.9119438E-03
     +,   1.9738092E-03,   2.0358928E-03,   2.0985890E-03
     +,   2.1623883E-03,   2.2279043E-03,   2.2958948E-03
     +,   2.3672425E-03,   2.4429522E-03,   2.5240898E-03
     +,   2.6117268E-03,   2.7068437E-03,   2.8102184E-03
     +,   2.9223110E-03,   3.0431610E-03,   3.1723012E-03
     +,   3.3087276E-03,   3.4509285E-03,   3.5969701E-03
     +,   3.7446502E-03,   3.8916746E-03,   4.0358044E-03
     +,   4.1749454E-03,   4.3071555E-03,   4.4305539E-03
     +,   4.5432760E-03,   4.6434277E-03,   4.7292123E-03
     +,   4.7992063E-03,   4.8527434E-03,   4.8903441E-03
     +,   4.9139033E-03,   4.9266140E-03,   4.9325037E-03
     +,   4.9355878E-03,   4.9388693E-03,   4.9434365E-03
     +,   4.9478542E-03,   4.9481634E-03,   4.9384618E-03
     +,   4.9119988E-03,   4.8625651E-03,   4.7858343E-03
     +,   4.6803448E-03,   4.5478945E-03,   4.3932456E-03
     +,   4.2232736E-03,   4.0457216E-03,   3.8679542E-03
     +,   3.6959094E-03,   3.5335417E-03,   3.3827524E-03
     +,   3.2438340E-03,   3.1160722E-03,   2.9984862E-03
     +,   2.8903696E-03,   2.7915584E-03,   2.7024071E-03
     +,   2.6235161E-03,   2.5553629E-03,   2.4979457E-03
     +,   2.4505379E-03,   2.4116368E-03,   2.3790887E-03
     +,   2.3503273E-03,   2.3226908E-03,   2.2937292E-03
     +,   2.2614372E-03,   2.2244055E-03,   2.1818620E-03
     +,   2.1336372E-03,   2.0800696E-03,   2.0218783E-03
     +,   1.9600359E-03,   1.8956612E-03,   1.8299051E-03
     +,   1.7638898E-03,   1.6986484E-03,   1.6350936E-03
     +,   1.5739872E-03,   1.5159266E-03,   1.4613345E-03
     +,   1.4104649E-03,   1.3634036E-03,   1.3200864E-03
     +,   1.2803208E-03,   1.2438118E-03,   1.2101871E-03
     +,   1.1790285E-03,   1.1499027E-03,   1.1223800E-03
     +,   1.0960564E-03,   1.0705743E-03,   1.0456153E-03
     +,   1.0209244E-03,   9.9629408E-04,   9.7157154E-04
     +,   9.4664993E-04,   9.2146511E-04,   8.9598889E-04
     +,   8.7022560E-04,   8.4420451E-04,   8.1797806E-04
     +,   7.9161627E-04,   7.6520094E-04,   7.3883036E-04
     +,   7.1260176E-04,   6.8662484E-04,   6.6100102E-04
     +,   6.3583528E-04,   6.1122817E-04,   5.8726390E-04
     +,   5.6402670E-04,   5.4157828E-04,   5.1997550E-04
     +,   4.9925601E-04,   4.7944480E-04,   4.6055226E-04
     +,   4.4257593E-04,   4.2550146E-04,   4.0930349E-04
     +,   3.9394828E-04,   3.7939500E-04,   3.6559740E-04
     +,   3.5250618E-04,   3.4006996E-04,   3.2823684E-04
     +,   3.1695803E-04,   3.0618330E-04,   2.9586884E-04
     +,   2.8597270E-04,   2.7645688E-04,   2.6728929E-04
     +,   2.5843934E-04,   2.4988336E-04,   2.4160009E-04
     +,   2.3357235E-04,   2.2578596E-04,   2.1822964E-04
     +,   2.1089488E-04,   2.0377467E-04,   1.9686382E-04
     +,   1.9015829E-04,   1.8365485E-04,   1.7735110E-04
     +,   1.7124470E-04,   1.6533362E-04,   1.5961574E-04
     +,   1.5408863E-04,   1.4875039E-04,   1.4359817E-04
     +,   1.3862918E-04,   1.3384019E-04,   1.2922780E-04
     +,   1.2478883E-04,   1.2051935E-04,   1.1641546E-04
     +,   1.1247331E-04,   1.0868876E-04,   1.0505773E-04
     +,   1.0157609E-04,   9.8239761E-05,   9.5044517E-05
     +,   9.1986265E-05,   8.9060923E-05,   8.6264379E-05
     +,   8.3592502E-05,   8.1041297E-05,   7.8606630E-05
     +,   7.6284414E-05,   7.4070769E-05,   7.1961578E-05
     +,   6.9952781E-05,   6.8040354E-05,   6.6220171E-05
     +,   6.4488384E-05,   6.2840882E-05,   6.1273684E-05
     +,   5.9782811E-05,   5.8364349E-05,   5.7014400E-05
     +,   5.5729142E-05,   5.4504788E-05,   5.3337666E-05
     +,   5.2224164E-05,   5.1160765E-05,   5.0144070E-05
     +,   4.9170769E-05,   4.8237696E-05,   4.7341757E-05
     +,   4.6480112E-05,   4.5649940E-05,   4.4848610E-05
     +,   4.4073615E-05,   4.3322572E-05,   4.2593329E-05
     +,   4.1883814E-05,   4.1192077E-05,   4.0516374E-05
     +,   3.9855029E-05,   3.9206552E-05,   3.8569564E-05
     +,   3.7942809E-05,   3.7325161E-05,   3.6715584E-05
     +,   3.6113186E-05,   3.5517140E-05,   3.4926739E-05
     +,   3.4341352E-05,   3.3760422E-05,   3.3183551E-05
     +,   3.2610245E-05,   3.2040251E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wano_fus_70 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wano_fus_75(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  4.5397417E-05,   4.6805078E-05
     +,   4.8269838E-05,   4.9794860E-05,   5.1383362E-05
     +,   5.3038835E-05,   5.4764820E-05,   5.6565015E-05
     +,   5.8443227E-05,   6.0403250E-05,   6.2449049E-05
     +,   6.4584616E-05,   6.6813889E-05,   6.9140871E-05
     +,   7.1569491E-05,   7.4103467E-05,   7.6746546E-05
     +,   7.9502250E-05,   8.2373903E-05,   8.5364620E-05
     +,   8.8477093E-05,   9.1713788E-05,   9.5076852E-05
     +,   9.8567936E-05,   1.0218842E-04,   1.0593894E-04
     +,   1.0981995E-04,   1.1383128E-04,   1.1797243E-04
     +,   1.2224217E-04,   1.2663896E-04,   1.3116089E-04
     +,   1.3580565E-04,   1.4057050E-04,   1.4545268E-04
     +,   1.5044885E-04,   1.5555594E-04,   1.6077083E-04
     +,   1.6609048E-04,   1.7151234E-04,   1.7703383E-04
     +,   1.8265336E-04,   1.8836990E-04,   1.9418332E-04
     +,   2.0009447E-04,   2.0610550E-04,   2.1221940E-04
     +,   2.1844104E-04,   2.2477686E-04,   2.3123424E-04
     +,   2.3782293E-04,   2.4455393E-04,   2.5143995E-04
     +,   2.5849536E-04,   2.6573584E-04,   2.7317848E-04
     +,   2.8084152E-04,   2.8874347E-04,   2.9690377E-04
     +,   3.0534211E-04,   3.1407658E-04,   3.2312560E-04
     +,   3.3250512E-04,   3.4222944E-04,   3.5230932E-04
     +,   3.6275247E-04,   3.7356224E-04,   3.8473675E-04
     +,   3.9626882E-04,   4.0814627E-04,   4.2035055E-04
     +,   4.3285728E-04,   4.4563733E-04,   4.5865739E-04
     +,   4.7188127E-04,   4.8527180E-04,   4.9879419E-04
     +,   5.1241647E-04,   5.2611658E-04,   5.3988397E-04
     +,   5.5372389E-04,   5.6766410E-04,   5.8175577E-04
     +,   5.9608283E-04,   6.1076257E-04,   6.2595191E-04
     +,   6.4184971E-04,   6.5869838E-04,   6.7678496E-04
     +,   6.9644069E-04,   7.1803218E-04,   7.4196048E-04
     +,   7.6864404E-04,   7.9850608E-04,   8.3195308E-04
     +,   8.6934929E-04,   9.1099145E-04,   9.5707027E-04
     +,   1.0076528E-03,   1.0626493E-03,   1.1217984E-03
     +,   1.1846651E-03,   1.2506515E-03,   1.3190379E-03
     +,   1.3890360E-03,   1.4598715E-03,   1.5308823E-03
     +,   1.6016213E-03,   1.6719598E-03,   1.7421627E-03
     +,   1.8129327E-03,   1.8853938E-03,   1.9610014E-03
     +,   2.0414114E-03,   2.1282556E-03,   2.2229124E-03
     +,   2.3262766E-03,   2.4385925E-03,   2.5594225E-03
     +,   2.6877401E-03,   2.8222457E-03,   2.9617872E-03
     +,   3.1058176E-03,   3.2547910E-03,   3.4103154E-03
     +,   3.5749658E-03,   3.7517692E-03,   3.9434345E-03
     +,   4.1515799E-03,   4.3761935E-03,   4.6155765E-03
     +,   4.8667793E-03,   5.1263724E-03,   5.3913482E-03
     +,   5.6596114E-03,   5.9298999E-03,   6.2011294E-03
     +,   6.4712274E-03,   6.7361239E-03,   6.9892211E-03
     +,   7.2219465E-03,   7.4254670E-03,   7.5932238E-03
     +,   7.7235568E-03,   7.8213112E-03,   7.8975242E-03
     +,   7.9669300E-03,   8.0437809E-03,   8.1371861E-03
     +,   8.2477322E-03,   8.3664274E-03,   8.4763672E-03
     +,   8.5566789E-03,   8.5872170E-03,   8.5527413E-03
     +,   8.4454874E-03,   8.2658073E-03,   8.0211852E-03
     +,   7.7243582E-03,   7.3912200E-03,   7.0388457E-03
     +,   6.6839010E-03,   6.3413237E-03,   6.0230992E-03
     +,   5.7375021E-03,   5.4887063E-03,   5.2769780E-03
     +,   5.0993101E-03,   4.9504638E-03,   4.8240474E-03
     +,   4.7134589E-03,   4.6125636E-03,   4.5161257E-03
     +,   4.4199526E-03,   4.3209689E-03,   4.2171245E-03
     +,   4.1073356E-03,   3.9913720E-03,   3.8697347E-03
     +,   3.7434991E-03,   3.6141723E-03,   3.4834160E-03
     +,   3.3529352E-03,   3.2242138E-03,   3.0984089E-03
     +,   2.9762804E-03,   2.8581885E-03,   2.7441464E-03
     +,   2.6339246E-03,   2.5271520E-03,   2.4234247E-03
     +,   2.3223828E-03,   2.2237569E-03,   2.1274213E-03
     +,   2.0333531E-03,   1.9416842E-03,   1.8526140E-03
     +,   1.7664388E-03,   1.6834973E-03,   1.6041143E-03
     +,   1.5286264E-03,   1.4572921E-03,   1.3903213E-03
     +,   1.3278218E-03,   1.2698015E-03,   1.2161613E-03
     +,   1.1666950E-03,   1.1211013E-03,   1.0790037E-03
     +,   1.0399700E-03,   1.0035374E-03,   9.6924306E-04
     +,   9.3664922E-04,   9.0536254E-04,   8.7504915E-04
     +,   8.4545469E-04,   8.1638829E-04,   7.8774360E-04
     +,   7.5947359E-04,   7.3158834E-04,   7.0414337E-04
     +,   6.7721633E-04,   6.5091019E-04,   6.2532659E-04
     +,   6.0056534E-04,   5.7671225E-04,   5.5383734E-04
     +,   5.3198903E-04,   5.1119423E-04,   4.9145886E-04
     +,   4.7276844E-04,   4.5509113E-04,   4.3838110E-04
     +,   4.2258066E-04,   4.0762417E-04,   3.9344156E-04
     +,   3.7995933E-04,   3.6710699E-04,   3.5481437E-04
     +,   3.4301658E-04,   3.3165392E-04,   3.2067354E-04
     +,   3.1003047E-04,   2.9968604E-04,   2.8960907E-04
     +,   2.7977565E-04,   2.7016806E-04,   2.6077448E-04
     +,   2.5158812E-04,   2.4260656E-04,   2.3383072E-04
     +,   2.2526407E-04,   2.1691200E-04,   2.0878091E-04
     +,   2.0087769E-04,   1.9320911E-04,   1.8578133E-04
     +,   1.7859913E-04,   1.7166715E-04,   1.6498740E-04
     +,   1.5856067E-04,   1.5238620E-04,   1.4646119E-04
     +,   1.4078215E-04,   1.3534327E-04,   1.3013772E-04
     +,   1.2515753E-04,   1.2039379E-04,   1.1583682E-04
     +,   1.1147632E-04,   1.0730167E-04,   1.0330209E-04
     +,   9.9466648E-05,   9.5784730E-05,   9.2245820E-05
     +,   8.8839930E-05,   8.5557462E-05,   8.2389335E-05
     +,   7.9327474E-05,   7.6364042E-05,   7.3492069E-05
     +,   7.0705297E-05,   6.7998029E-05,   6.5365624E-05
     +,   6.2803767E-05,   6.0308874E-05,   5.7877915E-05
     +,   5.5508444E-05,   5.3198510E-05,   5.0946561E-05
     +,   4.8751459E-05,   4.6612378E-05,   4.4528781E-05
     +,   4.2500367E-05,   4.0526989E-05,   3.8608661E-05
     +,   3.6745492E-05,   3.4937548E-05,   3.3185253E-05
     +,   3.1488482E-05,   2.9847604E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wano_fus_75 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wano_fus_80(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  3.6637516E-06,   3.7661755E-06
     +,   3.8739868E-06,   3.9878910E-06,   4.1086728E-06
     +,   4.2372180E-06,   4.3745149E-06,   4.5216607E-06
     +,   4.6798768E-06,   4.8505008E-06,   5.0350172E-06
     +,   5.2350533E-06,   5.4523894E-06,   5.6889658E-06
     +,   5.9469035E-06,   6.2284789E-06,   6.5361755E-06
     +,   6.8726595E-06,   7.2407997E-06,   7.6436763E-06
     +,   8.0845548E-06,   8.5669390E-06,   9.0945477E-06
     +,   9.6713175E-06,   1.0301427E-05,   1.0989235E-05
     +,   1.1739380E-05,   1.2556708E-05,   1.3446317E-05
     +,   1.4413485E-05,   1.5463764E-05,   1.6602937E-05
     +,   1.7837005E-05,   1.9172196E-05,   2.0615007E-05
     +,   2.2172064E-05,   2.3850303E-05,   2.5656842E-05
     +,   2.7599028E-05,   2.9684439E-05,   3.1920677E-05
     +,   3.4315697E-05,   3.6877515E-05,   3.9614264E-05
     +,   4.2534150E-05,   4.5645524E-05,   4.8956430E-05
     +,   5.2475079E-05,   5.6209545E-05,   6.0167375E-05
     +,   6.4356027E-05,   6.8782480E-05,   7.3453142E-05
     +,   7.8373763E-05,   8.3549341E-05,   8.8983979E-05
     +,   9.4680930E-05,   1.0064197E-04,   1.0686811E-04
     +,   1.1335915E-04,   1.2011316E-04,   1.2712739E-04
     +,   1.3439779E-04,   1.4191902E-04,   1.4968473E-04
     +,   1.5768784E-04,   1.6592056E-04,   1.7437419E-04
     +,   1.8304067E-04,   1.9191171E-04,   2.0098018E-04
     +,   2.1023920E-04,   2.1968418E-04,   2.2931235E-04
     +,   2.3912347E-04,   2.4912041E-04,   2.5930977E-04
     +,   2.6970185E-04,   2.8031194E-04,   2.9116054E-04
     +,   3.0227337E-04,   3.1368280E-04,   3.2542681E-04
     +,   3.3755079E-04,   3.5010732E-04,   3.6315611E-04
     +,   3.7676407E-04,   3.9100638E-04,   4.0596494E-04
     +,   4.2172940E-04,   4.3839432E-04,   4.5606092E-04
     +,   4.7483528E-04,   4.9482583E-04,   5.1614246E-04
     +,   5.3889351E-04,   5.6318549E-04,   5.8911345E-04
     +,   6.1676576E-04,   6.4621522E-04,   6.7751581E-04
     +,   7.1069720E-04,   7.4576103E-04,   7.8267569E-04
     +,   8.2137046E-04,   8.6173136E-04,   9.0359902E-04
     +,   9.4676274E-04,   9.9096156E-04,   1.0358844E-03
     +,   1.0811728E-03,   1.1264293E-03,   1.1712185E-03
     +,   1.2150921E-03,   1.2575949E-03,   1.2982840E-03
     +,   1.3367494E-03,   1.3726329E-03,   1.4056461E-03
     +,   1.4355815E-03,   1.4623342E-03,   1.4859039E-03
     +,   1.5064013E-03,   1.5240489E-03,   1.5391813E-03
     +,   1.5522412E-03,   1.5637804E-03,   1.5744588E-03
     +,   1.5850425E-03,   1.5964089E-03,   1.6095397E-03
     +,   1.6255172E-03,   1.6455058E-03,   1.6707355E-03
     +,   1.7024653E-03,   1.7419372E-03,   1.7903296E-03
     +,   1.8486775E-03,   1.9177857E-03,   1.9981330E-03
     +,   2.0897491E-03,   2.1921620E-03,   2.3043766E-03
     +,   2.4250080E-03,   2.5525761E-03,   2.6859711E-03
     +,   2.8250499E-03,   2.9712045E-03,   3.1277221E-03
     +,   3.2997532E-03,   3.4936995E-03,   3.7160690E-03
     +,   3.9718505E-03,   4.2630238E-03,   4.5873942E-03
     +,   4.9384930E-03,   5.3066397E-03,   5.6810365E-03
     +,   6.0522160E-03,   6.4138803E-03,   6.7633376E-03
     +,   7.1004452E-03,   7.4256621E-03,   7.7386512E-03
     +,   8.0381231E-03,   8.3232196E-03,   8.5952990E-03
     +,   8.8585531E-03,   9.1185821E-03,   9.3789240E-03
     +,   9.6375672E-03,   9.8852273E-03,   1.0106958E-02
     +,   1.0286862E-02,   1.0413995E-02,   1.0488044E-02
     +,   1.0522616E-02,   1.0544797E-02,   1.0588931E-02
     +,   1.0683771E-02,   1.0836358E-02,   1.1020898E-02
     +,   1.1181170E-02,   1.1249385E-02,   1.1173768E-02
     +,   1.0941107E-02,   1.0582839E-02,   1.0162096E-02
     +,   9.7492319E-03,   9.3974974E-03,   9.1284765E-03
     +,   8.9312093E-03,   8.7728230E-03,   8.6143827E-03
     +,   8.4248623E-03,   8.1887627E-03,   7.9057747E-03
     +,   7.5851725E-03,   7.2384854E-03,   6.8742204E-03
     +,   6.4965044E-03,   6.1064013E-03,   5.7049589E-03
     +,   5.2952492E-03,   4.8831184E-03,   4.4764192E-03
     +,   4.0836651E-03,   3.7127086E-03,   3.3699183E-03
     +,   3.0597942E-03,   2.7848906E-03,   2.5458829E-03
     +,   2.3416991E-03,   2.1697318E-03,   2.0261642E-03
     +,   1.9064124E-03,   1.8055426E-03,   1.7188056E-03
     +,   1.6419393E-03,   1.5714330E-03,   1.5046276E-03
     +,   1.4396505E-03,   1.3753512E-03,   1.3111138E-03
     +,   1.2467186E-03,   1.1822050E-03,   1.1177713E-03
     +,   1.0537026E-03,   9.9032780E-04,   9.2799222E-04
     +,   8.6704345E-04,   8.0781686E-04,   7.5062853E-04
     +,   6.9576444E-04,   6.4347428E-04,   5.9396075E-04
     +,   5.4737570E-04,   5.0382386E-04,   4.6335143E-04
     +,   4.2595717E-04,   3.9159544E-04,   3.6018083E-04
     +,   3.3160060E-04,   3.0571310E-04,   2.8236062E-04
     +,   2.6137335E-04,   2.4257472E-04,   2.2578542E-04
     +,   2.1082745E-04,   1.9752621E-04,   1.8571322E-04
     +,   1.7522756E-04,   1.6591736E-04,   1.5764084E-04
     +,   1.5026687E-04,   1.4367563E-04,   1.3775846E-04
     +,   1.3241805E-04,   1.2756880E-04,   1.2313502E-04
     +,   1.1905148E-04,   1.1526231E-04,   1.1172008E-04
     +,   1.0838549E-04,   1.0522582E-04,   1.0221435E-04
     +,   9.9329671E-05,   9.6554555E-05,   9.3875591E-05
     +,   9.1282222E-05,   8.8766290E-05,   8.6321554E-05
     +,   8.3943196E-05,   8.1627455E-05,   7.9371341E-05
     +,   7.7172503E-05,   7.5028889E-05,   7.2938543E-05
     +,   7.0900038E-05,   6.8911642E-05,   6.6971807E-05
     +,   6.5078930E-05,   6.3231353E-05,   6.1427672E-05
     +,   5.9666225E-05,   5.7945475E-05,   5.6263903E-05
     +,   5.4620083E-05,   5.3012638E-05,   5.1440253E-05
     +,   4.9901730E-05,   4.8396018E-05,   4.6922094E-05
     +,   4.5479101E-05,   4.4066284E-05,   4.2682957E-05
     +,   4.1328578E-05,   4.0002622E-05,   3.8704886E-05
     +,   3.7434835E-05,   3.6192392E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wano_fus_80 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wano_fus_85(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  3.5807454E-06,   3.7722562E-06
     +,   3.9726069E-06,   4.1821522E-06,   4.4012454E-06
     +,   4.6302689E-06,   4.8696215E-06,   5.1197189E-06
     +,   5.3810031E-06,   5.6539188E-06,   5.9389604E-06
     +,   6.2366271E-06,   6.5474596E-06,   6.8720205E-06
     +,   7.2109146E-06,   7.5647590E-06,   7.9342199E-06
     +,   8.3200048E-06,   8.7228527E-06,   9.1435541E-06
     +,   9.5829128E-06,   1.0041808E-05,   1.0521146E-05
     +,   1.1021889E-05,   1.1545039E-05,   1.2091628E-05
     +,   1.2662749E-05,   1.3259533E-05,   1.3883169E-05
     +,   1.4534831E-05,   1.5215785E-05,   1.5927304E-05
     +,   1.6670683E-05,   1.7447250E-05,   1.8258364E-05
     +,   1.9105335E-05,   1.9989535E-05,   2.0912315E-05
     +,   2.1875017E-05,   2.2878994E-05,   2.3925490E-05
     +,   2.5015815E-05,   2.6151214E-05,   2.7332908E-05
     +,   2.8562061E-05,   2.9839859E-05,   3.1167358E-05
     +,   3.2545675E-05,   3.3975932E-05,   3.5459165E-05
     +,   3.6996516E-05,   3.8589154E-05,   4.0238338E-05
     +,   4.1945426E-05,   4.3711971E-05,   4.5539724E-05
     +,   4.7430745E-05,   4.9387309E-05,   5.1412229E-05
     +,   5.3508786E-05,   5.5680648E-05,   5.7932335E-05
     +,   6.0268972E-05,   6.2696476E-05,   6.5221720E-05
     +,   6.7852445E-05,   7.0597525E-05,   7.3466690E-05
     +,   7.6471013E-05,   7.9622587E-05,   8.2934719E-05
     +,   8.6421649E-05,   9.0098816E-05,   9.3982613E-05
     +,   9.8090219E-05,   1.0243949E-04,   1.0704896E-04
     +,   1.1193693E-04,   1.1712212E-04,   1.2262278E-04
     +,   1.2845649E-04,   1.3463997E-04,   1.4118821E-04
     +,   1.4811485E-04,   1.5543139E-04,   1.6314693E-04
     +,   1.7126800E-04,   1.7979820E-04,   1.8873825E-04
     +,   1.9808632E-04,   2.0783645E-04,   2.1798104E-04
     +,   2.2850995E-04,   2.3941105E-04,   2.5067103E-04
     +,   2.6227609E-04,   2.7421323E-04,   2.8646976E-04
     +,   2.9903688E-04,   3.1190921E-04,   3.2508673E-04
     +,   3.3857560E-04,   3.5238999E-04,   3.6655302E-04
     +,   3.8109743E-04,   3.9606736E-04,   4.1151780E-04
     +,   4.2751571E-04,   4.4413909E-04,   4.6147685E-04
     +,   4.7962667E-04,   4.9869460E-04,   5.1878800E-04
     +,   5.4001884E-04,   5.6249392E-04,   5.8631337E-04
     +,   6.1156321E-04,   6.3831219E-04,   6.6660461E-04
     +,   6.9645344E-04,   7.2783971E-04,   7.6070556E-04
     +,   7.9495291E-04,   8.3044148E-04,   8.6699158E-04
     +,   9.0438611E-04,   9.4237755E-04,   9.8069664E-04
     +,   1.0190617E-03,   1.0571916E-03,   1.0948210E-03
     +,   1.1317139E-03,   1.1676721E-03,   1.2025584E-03
     +,   1.2362975E-03,   1.2688892E-03,   1.3004083E-03
     +,   1.3310094E-03,   1.3609226E-03,   1.3904537E-03
     +,   1.4199762E-03,   1.4499371E-03,   1.4808533E-03
     +,   1.5133150E-03,   1.5479898E-03,   1.5856255E-03
     +,   1.6270383E-03,   1.6730989E-03,   1.7246859E-03
     +,   1.7826277E-03,   1.8476094E-03,   1.9200743E-03
     +,   2.0000939E-03,   2.0872909E-03,   2.1807568E-03
     +,   2.2790509E-03,   2.3802647E-03,   2.4821705E-03
     +,   2.5824429E-03,   2.6789429E-03,   2.7699887E-03
     +,   2.8546525E-03,   2.9329683E-03,   3.0061125E-03
     +,   3.0764723E-03,   3.1476882E-03,   3.2245649E-03
     +,   3.3128939E-03,   3.4190794E-03,   3.5494976E-03
     +,   3.7096005E-03,   3.9028621E-03,   4.1298065E-03
     +,   4.3875524E-03,   4.6701324E-03,   4.9698604E-03
     +,   5.2792984E-03,   5.5932119E-03,   5.9095183E-03
     +,   6.2285825E-03,   6.5508401E-03,   6.8740370E-03
     +,   7.1910359E-03,   7.4903779E-03,   7.7592223E-03
     +,   7.9879882E-03,   8.1746541E-03,   8.3270473E-03
     +,   8.4627075E-03,   8.6066071E-03,   8.7873312E-03
     +,   9.0313070E-03,   9.3559306E-03,   9.7639095E-03
     +,   1.0243698E-02,   1.0777618E-02,   1.1354349E-02
     +,   1.1973750E-02,   1.2636732E-02,   1.3323206E-02
     +,   1.3973864E-02,   1.4494941E-02,   1.4788469E-02
     +,   1.4793755E-02,   1.4515305E-02,   1.4023137E-02
     +,   1.3427961E-02,   1.2845752E-02,   1.2365797E-02
     +,   1.2030619E-02,   1.1830582E-02,   1.1714178E-02
     +,   1.1610428E-02,   1.1454934E-02,   1.1208429E-02
     +,   1.0861158E-02,   1.0424589E-02,   9.9193119E-03
     +,   9.3666269E-03,   8.7866224E-03,   8.1998780E-03
     +,   7.6275878E-03,   7.0890263E-03,   6.5965755E-03
     +,   6.1523882E-03,   5.7485076E-03,   5.3707575E-03
     +,   5.0043515E-03,   4.6388637E-03,   4.2706891E-03
     +,   3.9027373E-03,   3.5421562E-03,   3.1973873E-03
     +,   2.8757071E-03,   2.5818099E-03,   2.3175273E-03
     +,   2.0822820E-03,   1.8739630E-03,   1.6897040E-03
     +,   1.5265581E-03,   1.3818650E-03,   1.2533949E-03
     +,   1.1393612E-03,   1.0383066E-03,   9.4901654E-04
     +,   8.7042095E-04,   8.0152258E-04,   7.4135908E-04
     +,   6.8898615E-04,   6.4348202E-04,   6.0395786E-04
     +,   5.6957599E-04,   5.3956622E-04,   5.1323534E-04
     +,   4.8997672E-04,   4.6926920E-04,   4.5067506E-04
     +,   4.3383223E-04,   4.1844853E-04,   4.0428780E-04
     +,   3.9116293E-04,   3.7892672E-04,   3.6746293E-04
     +,   3.5668112E-04,   3.4650823E-04,   3.3688528E-04
     +,   3.2776323E-04,   3.1909999E-04,   3.1085804E-04
     +,   3.0300283E-04,   2.9550141E-04,   2.8832178E-04
     +,   2.8143247E-04,   2.7480206E-04,   2.6839940E-04
     +,   2.6219373E-04,   2.5615460E-04,   2.5025231E-04
     +,   2.4445896E-04,   2.3874731E-04,   2.3309223E-04
     +,   2.2747062E-04,   2.2186156E-04,   2.1624757E-04
     +,   2.1061319E-04,   2.0494616E-04,   1.9923714E-04
     +,   1.9348002E-04,   1.8767163E-04,   1.8181163E-04
     +,   1.7590239E-04,   1.6994895E-04,   1.6395860E-04
     +,   1.5794073E-04,   1.5190641E-04,   1.4586825E-04
     +,   1.3983998E-04,   1.3383589E-04,   1.2787193E-04
     +,   1.2196234E-04,   1.1612327E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wano_fus_85 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wano_fus_90(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  1.1556572E-05,   1.1868992E-05
     +,   1.2185484E-05,   1.2505989E-05,   1.2830432E-05
     +,   1.3158753E-05,   1.3490892E-05,   1.3826792E-05
     +,   1.4166409E-05,   1.4509677E-05,   1.4856563E-05
     +,   1.5207033E-05,   1.5561063E-05,   1.5918637E-05
     +,   1.6279751E-05,   1.6644408E-05,   1.7012633E-05
     +,   1.7384464E-05,   1.7759960E-05,   1.8139199E-05
     +,   1.8522262E-05,   1.8909277E-05,   1.9300391E-05
     +,   1.9695770E-05,   2.0095627E-05,   2.0500176E-05
     +,   2.0909689E-05,   2.1324468E-05,   2.1744861E-05
     +,   2.2171222E-05,   2.2603979E-05,   2.3043594E-05
     +,   2.3490575E-05,   2.3945475E-05,   2.4408895E-05
     +,   2.4881469E-05,   2.5363890E-05,   2.5856918E-05
     +,   2.6361338E-05,   2.6878006E-05,   2.7407790E-05
     +,   2.7951643E-05,   2.8510542E-05,   2.9085519E-05
     +,   2.9677640E-05,   3.0288036E-05,   3.0917814E-05
     +,   3.1568186E-05,   3.2240379E-05,   3.2935601E-05
     +,   3.3655138E-05,   3.4400313E-05,   3.5172445E-05
     +,   3.5972884E-05,   3.6803031E-05,   3.7664329E-05
     +,   3.8558235E-05,   3.9486247E-05,   4.0449973E-05
     +,   4.1451091E-05,   4.2491323E-05,   4.3572574E-05
     +,   4.4696859E-05,   4.5866422E-05,   4.7083668E-05
     +,   4.8351310E-05,   4.9672373E-05,   5.1050189E-05
     +,   5.2488525E-05,   5.3991691E-05,   5.5564509E-05
     +,   5.7212350E-05,   5.8941299E-05,   6.0758273E-05
     +,   6.2670886E-05,   6.4687694E-05,   6.6818240E-05
     +,   6.9072856E-05,   7.1463117E-05,   7.4001538E-05
     +,   7.6701770E-05,   7.9578502E-05,   8.2647326E-05
     +,   8.5925007E-05,   8.9429101E-05,   9.3178016E-05
     +,   9.7190881E-05,   1.0148724E-04,   1.0608708E-04
     +,   1.1101066E-04,   1.1627743E-04,   1.2190716E-04
     +,   1.2791867E-04,   1.3432972E-04,   1.4115682E-04
     +,   1.4841475E-04,   1.5611663E-04,   1.6427213E-04
     +,   1.7288941E-04,   1.8197307E-04,   1.9152481E-04
     +,   2.0154250E-04,   2.1202078E-04,   2.2295020E-04
     +,   2.3431811E-04,   2.4610778E-04,   2.5829941E-04
     +,   2.7086999E-04,   2.8379410E-04,   2.9704405E-04
     +,   3.1059116E-04,   3.2440660E-04,   3.3846058E-04
     +,   3.5272643E-04,   3.6717975E-04,   3.8179991E-04
     +,   3.9657153E-04,   4.1148506E-04,   4.2653928E-04
     +,   4.4173849E-04,   4.5709778E-04,   4.7264050E-04
     +,   4.8839918E-04,   5.0441478E-04,   5.2073598E-04
     +,   5.3741888E-04,   5.5452436E-04,   5.7211751E-04
     +,   5.9026439E-04,   6.0903118E-04,   6.2848133E-04
     +,   6.4867485E-04,   6.6966109E-04,   6.9148582E-04
     +,   7.1418285E-04,   7.3777675E-04,   7.6228054E-04
     +,   7.8769727E-04,   8.1401900E-04,   8.4122975E-04
     +,   8.6930202E-04,   8.9820399E-04,   9.2789595E-04
     +,   9.5833483E-04,   9.8947540E-04,   1.0212688E-03
     +,   1.0536697E-03,   1.0866361E-03,   1.1201330E-03
     +,   1.1541352E-03,   1.1886333E-03,   1.2236376E-03
     +,   1.2591790E-03,   1.2953200E-03,   1.3321517E-03
     +,   1.3697979E-03,   1.4084126E-03,   1.4481781E-03
     +,   1.4892942E-03,   1.5319709E-03,   1.5764120E-03
     +,   1.6228029E-03,   1.6712861E-03,   1.7219569E-03
     +,   1.7748412E-03,   1.8298891E-03,   1.8869716E-03
     +,   1.9458792E-03,   2.0063338E-03,   2.0679957E-03
     +,   2.1304877E-03,   2.1934151E-03,   2.2563885E-03
     +,   2.3190484E-03,   2.3810882E-03,   2.4422840E-03
     +,   2.5025024E-03,   2.5617105E-03,   2.6199704E-03
     +,   2.6774297E-03,   2.7342942E-03,   2.7908541E-03
     +,   2.8474517E-03,   2.9045606E-03,   2.9628500E-03
     +,   3.0232766E-03,   3.0871842E-03,   3.1563162E-03
     +,   3.2327403E-03,   3.3186143E-03,   3.4157736E-03
     +,   3.5252473E-03,   3.6467647E-03,   3.7783743E-03
     +,   3.9164419E-03,   4.0559326E-03,   4.1912231E-03
     +,   4.3170541E-03,   4.4296477E-03,   4.5275418E-03
     +,   4.6118456E-03,   4.6859304E-03,   4.7543910E-03
     +,   4.8217420E-03,   4.8911567E-03,   4.9637710E-03
     +,   5.0389217E-03,   5.1153237E-03,   5.1928670E-03
     +,   5.2742916E-03,   5.3660171E-03,   5.4774983E-03
     +,   5.6190491E-03,   5.7987673E-03,   6.0196496E-03
     +,   6.2778769E-03,   6.5632076E-03,   6.8608993E-03
     +,   7.1548801E-03,   7.4306759E-03,   7.6772291E-03
     +,   7.8875031E-03,   8.0577666E-03,   8.1865126E-03
     +,   8.2736202E-03,   8.3199963E-03,   8.3279731E-03
     +,   8.3016967E-03,   8.2471790E-03,   8.1714941E-03
     +,   8.0811540E-03,   7.9801641E-03,   7.8684585E-03
     +,   7.7415123E-03,   7.5913817E-03,   7.4090441E-03
     +,   7.1870950E-03,   6.9222697E-03,   6.6166497E-03
     +,   6.2775714E-03,   5.9161978E-03,   5.5452744E-03
     +,   5.1768953E-03,   4.8206444E-03,   4.4827792E-03
     +,   4.1662669E-03,   3.8714956E-03,   3.5973240E-03
     +,   3.3420173E-03,   3.1039449E-03,   2.8818822E-03
     +,   2.6750572E-03,   2.4829847E-03,   2.3052727E-03
     +,   2.1414533E-03,   1.9908720E-03,   1.8526788E-03
     +,   1.7258553E-03,   1.6092997E-03,   1.5018809E-03
     +,   1.4025263E-03,   1.3102699E-03,   1.2242810E-03
     +,   1.1438947E-03,   1.0685789E-03,   9.9793752E-04
     +,   9.3168189E-04,   8.6960272E-04,   8.1154442E-04
     +,   7.5737888E-04,   7.0698658E-04,   6.6023995E-04
     +,   6.1699364E-04,   5.7707983E-04,   5.4030650E-04
     +,   5.0646067E-04,   4.7531363E-04,   4.4662622E-04
     +,   4.2016184E-04,   3.9568511E-04,   3.7297371E-04
     +,   3.5182224E-04,   3.3204362E-04,   3.1347570E-04
     +,   2.9597574E-04,   2.7942381E-04,   2.6372020E-04
     +,   2.4878344E-04,   2.3454796E-04,   2.2096164E-04
     +,   2.0798328E-04,   1.9558061E-04,   1.8372803E-04
     +,   1.7240514E-04,   1.6159521E-04,   1.5128407E-04
     +,   1.4145947E-04,   1.3210962E-04,   1.2322492E-04
     +,   1.1479329E-04,   1.0680516E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wano_fus_90 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wano_fus_95(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  2.0348414E-06,   2.0741202E-06
     +,   2.1137178E-06,   2.1536312E-06,   2.1938558E-06
     +,   2.2343904E-06,   2.2752342E-06,   2.3163891E-06
     +,   2.3578573E-06,   2.3996424E-06,   2.4417518E-06
     +,   2.4841950E-06,   2.5269844E-06,   2.5701343E-06
     +,   2.6136659E-06,   2.6575995E-06,   2.7019651E-06
     +,   2.7467945E-06,   2.7921267E-06,   2.8380066E-06
     +,   2.8844852E-06,   2.9316220E-06,   2.9794853E-06
     +,   3.0281506E-06,   3.0777071E-06,   3.1282505E-06
     +,   3.1798922E-06,   3.2327553E-06,   3.2869787E-06
     +,   3.3427141E-06,   3.4001328E-06,   3.4594227E-06
     +,   3.5207936E-06,   3.5844753E-06,   3.6507226E-06
     +,   3.7198115E-06,   3.7920486E-06,   3.8677695E-06
     +,   3.9473402E-06,   4.0311620E-06,   4.1196681E-06
     +,   4.2133356E-06,   4.3126797E-06,   4.4182639E-06
     +,   4.5306961E-06,   4.6506416E-06,   4.7788121E-06
     +,   4.9159848E-06,   5.0630038E-06,   5.2207706E-06
     +,   5.3902731E-06,   5.5725682E-06,   5.7688035E-06
     +,   5.9802173E-06,   6.2081454E-06,   6.4540313E-06
     +,   6.7194360E-06,   7.0060291E-06,   7.3156289E-06
     +,   7.6501983E-06,   8.0118343E-06,   8.4028234E-06
     +,   8.8256202E-06,   9.2828741E-06,   9.7774437E-06
     +,   1.0312410E-05,   1.0891104E-05,   1.1517075E-05
     +,   1.2194178E-05,   1.2926555E-05,   1.3718661E-05
     +,   1.4575233E-05,   1.5501389E-05,   1.6502592E-05
     +,   1.7584682E-05,   1.8753863E-05,   2.0016780E-05
     +,   2.1380376E-05,   2.2852091E-05,   2.4439732E-05
     +,   2.6151498E-05,   2.7996006E-05,   2.9982109E-05
     +,   3.2119115E-05,   3.4416575E-05,   3.6884292E-05
     +,   3.9532250E-05,   4.2370535E-05,   4.5409295E-05
     +,   4.8658752E-05,   5.2128515E-05,   5.5828383E-05
     +,   5.9767564E-05,   6.3954765E-05,   6.8397996E-05
     +,   7.3104420E-05,   7.8080455E-05,   8.3330699E-05
     +,   8.8859131E-05,   9.4668037E-05,   1.0075814E-04
     +,   1.0712852E-04,   1.1377647E-04,   1.2069733E-04
     +,   1.2788472E-04,   1.3533029E-04,   1.4302392E-04
     +,   1.5095383E-04,   1.5910668E-04,   1.6746808E-04
     +,   1.7602254E-04,   1.8475462E-04,   1.9364778E-04
     +,   2.0268736E-04,   2.1185950E-04,   2.2115315E-04
     +,   2.3056012E-04,   2.4007639E-04,   2.4970449E-04
     +,   2.5945166E-04,   2.6933488E-04,   2.7938012E-04
     +,   2.8962380E-04,   3.0011451E-04,   3.1091407E-04
     +,   3.2209829E-04,   3.3375807E-04,   3.4599929E-04
     +,   3.5894325E-04,   3.7272600E-04,   3.8749698E-04
     +,   4.0341823E-04,   4.2065943E-04,   4.3939802E-04
     +,   4.5981392E-04,   4.8208563E-04,   5.0638441E-04
     +,   5.3287041E-04,   5.6168629E-04,   5.9295364E-04
     +,   6.2676024E-04,   6.6316465E-04,   7.0218591E-04
     +,   7.4379781E-04,   7.8792643E-04,   8.3444960E-04
     +,   8.8319130E-04,   9.3392492E-04,   9.8637235E-04
     +,   1.0402116E-03,   1.0950811E-03,   1.1505920E-03
     +,   1.2063321E-03,   1.2618970E-03,   1.3168954E-03
     +,   1.3709725E-03,   1.4238287E-03,   1.4752358E-03
     +,   1.5250505E-03,   1.5732236E-03,   1.6197937E-03
     +,   1.6648857E-03,   1.7086806E-03,   1.7513988E-03
     +,   1.7932589E-03,   1.8344388E-03,   1.8750384E-03
     +,   1.9150428E-03,   1.9543010E-03,   1.9925088E-03
     +,   2.0292155E-03,   2.0638437E-03,   2.0957286E-03
     +,   2.1241694E-03,   2.1484927E-03,   2.1681229E-03
     +,   2.1826515E-03,   2.1918910E-03,   2.1959306E-03
     +,   2.1951532E-03,   2.1902560E-03,   2.1822241E-03
     +,   2.1722997E-03,   2.1619282E-03,   2.1526930E-03
     +,   2.1462373E-03,   2.1442010E-03,   2.1481419E-03
     +,   2.1594788E-03,   2.1794382E-03,   2.2090056E-03
     +,   2.2488926E-03,   2.2994911E-03,   2.3608389E-03
     +,   2.4326060E-03,   2.5140278E-03,   2.6039346E-03
     +,   2.7007081E-03,   2.8023191E-03,   2.9064154E-03
     +,   3.0103517E-03,   3.1113909E-03,   3.2067976E-03
     +,   3.2940635E-03,   3.3710632E-03,   3.4362325E-03
     +,   3.4886880E-03,   3.5282967E-03,   3.5556727E-03
     +,   3.5720940E-03,   3.5793539E-03,   3.5795341E-03
     +,   3.5747651E-03,   3.5669827E-03,   3.5576783E-03
     +,   3.5477707E-03,   3.5375047E-03,   3.5264727E-03
     +,   3.5137022E-03,   3.4978185E-03,   3.4772407E-03
     +,   3.4504030E-03,   3.4159529E-03,   3.3729111E-03
     +,   3.3208036E-03,   3.2597303E-03,   3.1903791E-03
     +,   3.1140109E-03,   3.0323921E-03,   2.9477009E-03
     +,   2.8624127E-03,   2.7791609E-03,   2.7005812E-03
     +,   2.6291632E-03,   2.5670994E-03,   2.5161679E-03
     +,   2.4776435E-03,   2.4522806E-03,   2.4403527E-03
     +,   2.4417795E-03,   2.4563149E-03,   2.4837847E-03
     +,   2.5243247E-03,   2.5785952E-03,   2.6478972E-03
     +,   2.7341724E-03,   2.8398775E-03,   2.9677111E-03
     +,   3.1202713E-03,   3.2996344E-03,   3.5069420E-03
     +,   3.7420141E-03,   4.0030093E-03,   4.2860978E-03
     +,   4.5852647E-03,   4.8922072E-03,   5.1964158E-03
     +,   5.4856194E-03,   5.7464619E-03,   5.9656966E-03
     +,   6.1315214E-03,   6.2349346E-03,   6.2709530E-03
     +,   6.2392540E-03,   6.1442601E-03,   5.9944610E-03
     +,   5.8012977E-03,   5.5776606E-03,   5.3364662E-03
     +,   5.0893575E-03,   4.8458795E-03,   4.6130046E-03
     +,   4.3950514E-03,   4.1938992E-03,   4.0093618E-03
     +,   3.8396658E-03,   3.6819498E-03,   3.5327554E-03
     +,   3.3885450E-03,   3.2460303E-03,   3.1025442E-03
     +,   2.9562244E-03,   2.8060905E-03,   2.6520356E-03
     +,   2.4946744E-03,   2.3351728E-03,   2.1750440E-03
     +,   2.0159546E-03,   1.8595556E-03,   1.7073663E-03
     +,   1.5606963E-03,   1.4206055E-03,   1.2879015E-03
     +,   1.1631433E-03,   1.0466655E-03,   9.3860709E-04
     +,   8.3893770E-04,   7.4748567E-04,   6.6398393E-04
     +,   5.8805547E-04,   5.1929103E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wano_fus_95 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wano_hz_100(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  1.7533051E-06,   1.8146389E-06
     +,   1.8777662E-06,   1.9427271E-06,   2.0095576E-06
     +,   2.0782986E-06,   2.1489893E-06,   2.2216702E-06
     +,   2.2963818E-06,   2.3731611E-06,   2.4520498E-06
     +,   2.5330880E-06,   2.6163152E-06,   2.7017718E-06
     +,   2.7894991E-06,   2.8795341E-06,   2.9719170E-06
     +,   3.0666884E-06,   3.1638860E-06,   3.2635528E-06
     +,   3.3657216E-06,   3.4704331E-06,   3.5777252E-06
     +,   3.6876347E-06,   3.8002015E-06,   3.9154584E-06
     +,   4.0334398E-06,   4.1541853E-06,   4.2777292E-06
     +,   4.4041017E-06,   4.5333377E-06,   4.6654704E-06
     +,   4.8005336E-06,   4.9385549E-06,   5.0795711E-06
     +,   5.2236041E-06,   5.3706872E-06,   5.5208484E-06
     +,   5.6741155E-06,   5.8305204E-06,   5.9900822E-06
     +,   6.1528312E-06,   6.3187931E-06,   6.4879941E-06
     +,   6.6604580E-06,   6.8362165E-06,   7.0152873E-06
     +,   7.1976974E-06,   7.3834794E-06,   7.5726521E-06
     +,   7.7652458E-06,   7.9612892E-06,   8.1608150E-06
     +,   8.3638533E-06,   8.5704378E-06,   8.7806075E-06
     +,   8.9944024E-06,   9.2118607E-06,   9.4330289E-06
     +,   9.6579670E-06,   9.8867213E-06,   1.0119355E-05
     +,   1.0355940E-05,   1.0596548E-05,   1.0841262E-05
     +,   1.1090176E-05,   1.1343394E-05,   1.1601017E-05
     +,   1.1863173E-05,   1.2129996E-05,   1.2401643E-05
     +,   1.2678261E-05,   1.2960036E-05,   1.3247159E-05
     +,   1.3539850E-05,   1.3838334E-05,   1.4142872E-05
     +,   1.4453724E-05,   1.4771192E-05,   1.5095597E-05
     +,   1.5427282E-05,   1.5766627E-05,   1.6114012E-05
     +,   1.6469881E-05,   1.6834683E-05,   1.7208904E-05
     +,   1.7593067E-05,   1.7987726E-05,   1.8393461E-05
     +,   1.8810913E-05,   1.9240706E-05,   1.9683544E-05
     +,   2.0140158E-05,   2.0611325E-05,   2.1097840E-05
     +,   2.1600561E-05,   2.2120405E-05,   2.2658260E-05
     +,   2.3215132E-05,   2.3792058E-05,   2.4390116E-05
     +,   2.5010460E-05,   2.5654286E-05,   2.6322869E-05
     +,   2.7017550E-05,   2.7739756E-05,   2.8491007E-05
     +,   2.9272911E-05,   3.0087207E-05,   3.0935742E-05
     +,   3.1820524E-05,   3.2743741E-05,   3.3707645E-05
     +,   3.4714794E-05,   3.5767953E-05,   3.6870086E-05
     +,   3.8024446E-05,   3.9234579E-05,   4.0504365E-05
     +,   4.1837880E-05,   4.3239710E-05,   4.4714743E-05
     +,   4.6268276E-05,   4.7906007E-05,   4.9634018E-05
     +,   5.1458806E-05,   5.3387299E-05,   5.5426815E-05
     +,   5.7584999E-05,   5.9869912E-05,   6.2289851E-05
     +,   6.4853572E-05,   6.7569657E-05,   7.0447233E-05
     +,   7.3495445E-05,   7.6723518E-05,   8.0140730E-05
     +,   8.3756371E-05,   8.7579741E-05,   9.1620408E-05
     +,   9.5887437E-05,   1.0039065E-04,   1.0514002E-04
     +,   1.1014601E-04,   1.1541991E-04,   1.2097388E-04
     +,   1.2682177E-04,   1.3297904E-04,   1.3946343E-04
     +,   1.4629551E-04,   1.5349899E-04,   1.6110152E-04
     +,   1.6913383E-04,   1.7763204E-04,   1.8663653E-04
     +,   1.9619225E-04,   2.0634859E-04,   2.1715900E-04
     +,   2.2868031E-04,   2.4097168E-04,   2.5409338E-04
     +,   2.6810588E-04,   2.8306540E-04,   2.9902565E-04
     +,   3.1603279E-04,   3.3412411E-04,   3.5332516E-04
     +,   3.7364819E-04,   3.9508927E-04,   4.1762766E-04
     +,   4.4122426E-04,   4.6582066E-04,   4.9134187E-04
     +,   5.1769579E-04,   5.4477359E-04,   5.7245797E-04
     +,   6.0062413E-04,   6.2914536E-04,   6.5789866E-04
     +,   6.8677129E-04,   7.1566191E-04,   7.4449892E-04
     +,   7.7322818E-04,   8.0183090E-04,   8.3032018E-04
     +,   8.5874205E-04,   8.8717468E-04,   9.1572700E-04
     +,   9.4452978E-04,   9.7373186E-04,   1.0034906E-03
     +,   1.0339599E-03,   1.0652830E-03,   1.0975738E-03
     +,   1.1309196E-03,   1.1653538E-03,   1.2008663E-03
     +,   1.2373790E-03,   1.2747496E-03,   1.3127835E-03
     +,   1.3512127E-03,   1.3897320E-03,   1.4279879E-03
     +,   1.4656149E-03,   1.5022499E-03,   1.5375661E-03
     +,   1.5712919E-03,   1.6032474E-03,   1.6333633E-03
     +,   1.6616969E-03,   1.6884418E-03,   1.7139132E-03
     +,   1.7385343E-03,   1.7627899E-03,   1.7871845E-03
     +,   1.8121760E-03,   1.8381281E-03,   1.8652363E-03
     +,   1.8935007E-03,   1.9226848E-03,   1.9523104E-03
     +,   1.9816870E-03,   2.0099361E-03,   2.0360635E-03
     +,   2.0590259E-03,   2.0778202E-03,   2.0915484E-03
     +,   2.0994947E-03,   2.1011753E-03,   2.0963703E-03
     +,   2.0851386E-03,   2.0678153E-03,   2.0449874E-03
     +,   2.0174673E-03,   1.9862591E-03,   1.9525163E-03
     +,   1.9175096E-03,   1.8825948E-03,   1.8491824E-03
     +,   1.8187049E-03,   1.7925921E-03,   1.7722289E-03
     +,   1.7589281E-03,   1.7538766E-03,   1.7580962E-03
     +,   1.7723917E-03,   1.7973075E-03,   1.8330923E-03
     +,   1.8796737E-03,   1.9366469E-03,   2.0032790E-03
     +,   2.0785441E-03,   2.1611557E-03,   2.2496462E-03
     +,   2.3424488E-03,   2.4380081E-03,   2.5349029E-03
     +,   2.6319828E-03,   2.7284783E-03,   2.8241032E-03
     +,   2.9190914E-03,   3.0141508E-03,   3.1103659E-03
     +,   3.2089893E-03,   3.3112387E-03,   3.4180442E-03
     +,   3.5297952E-03,   3.6461779E-03,   3.7660708E-03
     +,   3.8876254E-03,   4.0086433E-03,   4.1272468E-03
     +,   4.2429497E-03,   4.3578348E-03,   4.4775866E-03
     +,   4.6118591E-03,   4.7737407E-03,   4.9782461E-03
     +,   5.2403188E-03,   5.5731507E-03,   5.9872996E-03
     +,   6.4908555E-03,   7.0901741E-03,   7.7901338E-03
     +,   8.5937344E-03,   9.5004849E-03,   1.0504019E-02
     +,   1.1589229E-02,   1.2728475E-02,   1.3876919E-02
     +,   1.4967714E-02,   1.5909646E-02,   1.6590932E-02
     +,   1.6892543E-02,   1.6710905E-02,   1.5985595E-02
     +,   1.4722841E-02,   1.3005316E-02,   1.0982562E-02
     +,   8.8417791E-03,   6.7710960E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wano_hz_100 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wano_hz_105(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  1.9576615E-07,   2.1124316E-07
     +,   2.2781001E-07,   2.4553236E-07,   2.6447771E-07
     +,   2.8471757E-07,   3.0632620E-07,   3.2938118E-07
     +,   3.5396371E-07,   3.8015656E-07,   4.0804736E-07
     +,   4.3772678E-07,   4.6928821E-07,   5.0282910E-07
     +,   5.3845037E-07,   5.7625454E-07,   6.1634881E-07
     +,   6.5884382E-07,   7.0385278E-07,   7.5149347E-07
     +,   8.0188369E-07,   8.5514654E-07,   9.1140805E-07
     +,   9.7079601E-07,   1.0334429E-06,   1.0994794E-06
     +,   1.1690424E-06,   1.2422697E-06,   1.3193026E-06
     +,   1.4002791E-06,   1.4853433E-06,   1.5746398E-06
     +,   1.6683127E-06,   1.7665080E-06,   1.8693737E-06
     +,   1.9770503E-06,   2.0896862E-06,   2.2074253E-06
     +,   2.3304112E-06,   2.4587889E-06,   2.5926922E-06
     +,   2.7322617E-06,   2.8776319E-06,   3.0289352E-06
     +,   3.1862987E-06,   3.3498504E-06,   3.5197029E-06
     +,   3.6959711E-06,   3.8787712E-06,   4.0681957E-06
     +,   4.2643464E-06,   4.4673120E-06,   4.6771765E-06
     +,   4.8940133E-06,   5.1178895E-06,   5.3488648E-06
     +,   5.5869941E-06,   5.8323062E-06,   6.0848397E-06
     +,   6.3446241E-06,   6.6116572E-06,   6.8859490E-06
     +,   7.1674940E-06,   7.4562740E-06,   7.7522609E-06
     +,   8.0554209E-06,   8.3657096E-06,   8.6830614E-06
     +,   9.0074145E-06,   9.3386952E-06,   9.6768281E-06
     +,   1.0021704E-05,   1.0373234E-05,   1.0731307E-05
     +,   1.1095814E-05,   1.1466634E-05,   1.1843651E-05
     +,   1.2226724E-05,   1.2615730E-05,   1.3010538E-05
     +,   1.3411021E-05,   1.3817061E-05,   1.4228511E-05
     +,   1.4645272E-05,   1.5067229E-05,   1.5494290E-05
     +,   1.5926376E-05,   1.6363425E-05,   1.6805396E-05
     +,   1.7252303E-05,   1.7704126E-05,   1.8160943E-05
     +,   1.8622868E-05,   1.9090052E-05,   1.9562718E-05
     +,   2.0041156E-05,   2.0525757E-05,   2.1016933E-05
     +,   2.1515269E-05,   2.2021437E-05,   2.2536235E-05
     +,   2.3060615E-05,   2.3595670E-05,   2.4142671E-05
     +,   2.4703075E-05,   2.5278541E-05,   2.5870953E-05
     +,   2.6482414E-05,   2.7115288E-05,   2.7772190E-05
     +,   2.8456021E-05,   2.9169976E-05,   2.9917454E-05
     +,   3.0702235E-05,   3.1528354E-05,   3.2400134E-05
     +,   3.3322172E-05,   3.4299330E-05,   3.5336743E-05
     +,   3.6439622E-05,   3.7613514E-05,   3.8864055E-05
     +,   4.0197006E-05,   4.1618179E-05,   4.3133441E-05
     +,   4.4748605E-05,   4.6469464E-05,   4.8301703E-05
     +,   5.0250896E-05,   5.2322463E-05,   5.4521712E-05
     +,   5.6853954E-05,   5.9324055E-05,   6.1937222E-05
     +,   6.4698623E-05,   6.7613604E-05,   7.0687922E-05
     +,   7.3927884E-05,   7.7340563E-05,   8.0934311E-05
     +,   8.4718326E-05,   8.8704044E-05,   9.2904826E-05
     +,   9.7336459E-05,   1.0201773E-04,   1.0697058E-04
     +,   1.1222086E-04,   1.1779825E-04,   1.2373713E-04
     +,   1.3007654E-04,   1.3686060E-04,   1.4413912E-04
     +,   1.5196617E-04,   1.6040234E-04,   1.6951330E-04
     +,   1.7936995E-04,   1.9004819E-04,   2.0162863E-04
     +,   2.1419588E-04,   2.2783797E-04,   2.4264574E-04
     +,   2.5871184E-04,   2.7612745E-04,   2.9498438E-04
     +,   3.1537027E-04,   3.3736750E-04,   3.6105051E-04
     +,   3.8648219E-04,   4.1371150E-04,   4.4276830E-04
     +,   4.7366144E-04,   5.0637266E-04,   5.4085377E-04
     +,   5.7702523E-04,   6.1476539E-04,   6.5391912E-04
     +,   6.9429155E-04,   7.3564978E-04,   7.7772758E-04
     +,   8.2023191E-04,   8.6284289E-04,   9.0524362E-04
     +,   9.4710873E-04,   9.8813931E-04,   1.0280693E-03
     +,   1.0666853E-03,   1.1038438E-03,   1.1394864E-03
     +,   1.1736542E-03,   1.2064960E-03,   1.2382745E-03
     +,   1.2693634E-03,   1.3002410E-03,   1.3314636E-03
     +,   1.3636517E-03,   1.3974333E-03,   1.4334202E-03
     +,   1.4721347E-03,   1.5139666E-03,   1.5591329E-03
     +,   1.6076143E-03,   1.6591630E-03,   1.7132733E-03
     +,   1.7692298E-03,   1.8261513E-03,   1.8830607E-03
     +,   1.9389762E-03,   1.9929872E-03,   2.0443352E-03
     +,   2.0924539E-03,   2.1369772E-03,   2.1777165E-03
     +,   2.2146050E-03,   2.2476122E-03,   2.2766676E-03
     +,   2.3015849E-03,   2.3220382E-03,   2.3375577E-03
     +,   2.3475939E-03,   2.3516158E-03,   2.3492328E-03
     +,   2.3403314E-03,   2.3251863E-03,   2.3045349E-03
     +,   2.2795910E-03,   2.2520002E-03,   2.2237233E-03
     +,   2.1968936E-03,   2.1736217E-03,   2.1558378E-03
     +,   2.1451369E-03,   2.1426850E-03,   2.1491742E-03
     +,   2.1648246E-03,   2.1894341E-03,   2.2224244E-03
     +,   2.2629024E-03,   2.3096874E-03,   2.3613332E-03
     +,   2.4161199E-03,   2.4720666E-03,   2.5269501E-03
     +,   2.5783696E-03,   2.6238856E-03,   2.6611735E-03
     +,   2.6882188E-03,   2.7035349E-03,   2.7063226E-03
     +,   2.6965737E-03,   2.6751019E-03,   2.6434625E-03
     +,   2.6038010E-03,   2.5586202E-03,   2.5105469E-03
     +,   2.4620697E-03,   2.4153395E-03,   2.3720295E-03
     +,   2.3332897E-03,   2.2997889E-03,   2.2718499E-03
     +,   2.2496618E-03,   2.2335227E-03,   2.2240737E-03
     +,   2.2224884E-03,   2.2305131E-03,   2.2504115E-03
     +,   2.2847278E-03,   2.3359598E-03,   2.4061590E-03
     +,   2.4965985E-03,   2.6075360E-03,   2.7381585E-03
     +,   2.8867272E-03,   3.0508360E-03,   3.2277731E-03
     +,   3.4147995E-03,   3.6093236E-03,   3.8089193E-03
     +,   4.0111514E-03,   4.2133923E-03,   4.4125719E-03
     +,   4.6050129E-03,   4.7863889E-03,   4.9516936E-03
     +,   5.0953883E-03,   5.2114823E-03,   5.2937046E-03
     +,   5.3357561E-03,   5.3316592E-03,   5.2762725E-03
     +,   5.1659108E-03,   4.9989582E-03,   4.7764080E-03
     +,   4.5021540E-03,   4.1829683E-03,   3.8281209E-03
     +,   3.4487250E-03,   3.0568426E-03,   2.6646522E-03
     +,   2.2833701E-03,   1.9227957E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wano_hz_105 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wano_hz_110(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  6.1810579E-06,   6.3265493E-06
     +,   6.4758142E-06,   6.6290095E-06,   6.7862888E-06
     +,   6.9478210E-06,   7.1137797E-06,   7.2843409E-06
     +,   7.4596910E-06,   7.6400111E-06,   7.8254980E-06
     +,   8.0163500E-06,   8.2127699E-06,   8.4149624E-06
     +,   8.6231466E-06,   8.8375245E-06,   9.0583171E-06
     +,   9.2857445E-06,   9.5200294E-06,   9.7613965E-06
     +,   1.0010059E-05,   1.0266242E-05,   1.0530170E-05
     +,   1.0802059E-05,   1.1082135E-05,   1.1370595E-05
     +,   1.1667653E-05,   1.1973510E-05,   1.2288372E-05
     +,   1.2612409E-05,   1.2945805E-05,   1.3288729E-05
     +,   1.3641338E-05,   1.4003770E-05,   1.4376165E-05
     +,   1.4758620E-05,   1.5151240E-05,   1.5554104E-05
     +,   1.5967271E-05,   1.6390783E-05,   1.6824648E-05
     +,   1.7268861E-05,   1.7723398E-05,   1.8188195E-05
     +,   1.8663171E-05,   1.9148232E-05,   1.9643212E-05
     +,   2.0147951E-05,   2.0662266E-05,   2.1185901E-05
     +,   2.1718604E-05,   2.2260085E-05,   2.2810014E-05
     +,   2.3368031E-05,   2.3933746E-05,   2.4506729E-05
     +,   2.5086541E-05,   2.5672662E-05,   2.6264583E-05
     +,   2.6861766E-05,   2.7463597E-05,   2.8069482E-05
     +,   2.8678778E-05,   2.9290821E-05,   2.9904917E-05
     +,   3.0520354E-05,   3.1136406E-05,   3.1752297E-05
     +,   3.2367261E-05,   3.2980523E-05,   3.3591292E-05
     +,   3.4198740E-05,   3.4802059E-05,   3.5400444E-05
     +,   3.5993078E-05,   3.6579146E-05,   3.7157861E-05
     +,   3.7728394E-05,   3.8289993E-05,   3.8841874E-05
     +,   3.9383303E-05,   3.9913582E-05,   4.0431987E-05
     +,   4.0937874E-05,   4.1430631E-05,   4.1909661E-05
     +,   4.2374435E-05,   4.2824471E-05,   4.3259308E-05
     +,   4.3678610E-05,   4.4081997E-05,   4.4469241E-05
     +,   4.4840155E-05,   4.5194611E-05,   4.5532586E-05
     +,   4.5854122E-05,   4.6159366E-05,   4.6448513E-05
     +,   4.6721911E-05,   4.6979989E-05,   4.7223290E-05
     +,   4.7452468E-05,   4.7668316E-05,   4.7871752E-05
     +,   4.8063834E-05,   4.8245769E-05,   4.8418922E-05
     +,   4.8584840E-05,   4.8745234E-05,   4.8902002E-05
     +,   4.9057260E-05,   4.9213319E-05,   4.9372731E-05
     +,   4.9538285E-05,   4.9713031E-05,   4.9900260E-05
     +,   5.0103579E-05,   5.0326878E-05,   5.0574370E-05
     +,   5.0850551E-05,   5.1160310E-05,   5.1508869E-05
     +,   5.1901803E-05,   5.2345102E-05,   5.2845109E-05
     +,   5.3408570E-05,   5.4042674E-05,   5.4754997E-05
     +,   5.5553559E-05,   5.6446843E-05,   5.7443762E-05
     +,   5.8553782E-05,   5.9786697E-05,   6.1152998E-05
     +,   6.2663668E-05,   6.4330357E-05,   6.6165332E-05
     +,   6.8181638E-05,   7.0393166E-05,   7.2814772E-05
     +,   7.5462100E-05,   7.8352183E-05,   8.1503240E-05
     +,   8.4934822E-05,   8.8667926E-05,   9.2725109E-05
     +,   9.7130411E-05,   1.0190941E-04,   1.0708911E-04
     +,   1.1269776E-04,   1.1876458E-04,   1.2531970E-04
     +,   1.3239241E-04,   1.4001243E-04,   1.4820792E-04
     +,   1.5700508E-04,   1.6642705E-04,   1.7649321E-04
     +,   1.8721820E-04,   1.9861075E-04,   2.1067356E-04
     +,   2.2340252E-04,   2.3678453E-04,   2.5080057E-04
     +,   2.6542362E-04,   2.8062001E-04,   2.9634981E-04
     +,   3.1256847E-04,   3.2922858E-04,   3.4628130E-04
     +,   3.6367905E-04,   3.8137811E-04,   3.9934149E-04
     +,   4.1754305E-04,   4.3596691E-04,   4.5461740E-04
     +,   4.7351894E-04,   4.9271988E-04,   5.1229814E-04
     +,   5.3236395E-04,   5.5305933E-04,   5.7456759E-04
     +,   5.9710158E-04,   6.2090915E-04,   6.4626127E-04
     +,   6.7344191E-04,   7.0273131E-04,   7.3438586E-04
     +,   7.6861167E-04,   8.0553663E-04,   8.4518135E-04
     +,   8.8743120E-04,   9.3201612E-04,   9.7848650E-04
     +,   1.0262375E-03,   1.0744911E-03,   1.1223654E-03
     +,   1.1688984E-03,   1.2131272E-03,   1.2541837E-03
     +,   1.2913554E-03,   1.3241954E-03,   1.3525706E-03
     +,   1.3767299E-03,   1.3973118E-03,   1.4153292E-03
     +,   1.4321142E-03,   1.4492245E-03,   1.4683215E-03
     +,   1.4910328E-03,   1.5188045E-03,   1.5527644E-03
     +,   1.5936116E-03,   1.6415361E-03,   1.6961906E-03
     +,   1.7566871E-03,   1.8216914E-03,   1.8894884E-03
     +,   1.9581490E-03,   2.0256760E-03,   2.0901456E-03
     +,   2.1498909E-03,   2.2035700E-03,   2.2502663E-03
     +,   2.2895078E-03,   2.3212363E-03,   2.3457545E-03
     +,   2.3636306E-03,   2.3756069E-03,   2.3825073E-03
     +,   2.3851658E-03,   2.3843753E-03,   2.3808689E-03
     +,   2.3753089E-03,   2.3682963E-03,   2.3603763E-03
     +,   2.3520647E-03,   2.3438612E-03,   2.3362737E-03
     +,   2.3298627E-03,   2.3252852E-03,   2.3233334E-03
     +,   2.3249655E-03,   2.3312899E-03,   2.3434921E-03
     +,   2.3627146E-03,   2.3898841E-03,   2.4255351E-03
     +,   2.4696593E-03,   2.5216481E-03,   2.5803212E-03
     +,   2.6440867E-03,   2.7111394E-03,   2.7796831E-03
     +,   2.8480855E-03,   2.9149242E-03,   2.9788858E-03
     +,   3.0386024E-03,   3.0924359E-03,   3.1383585E-03
     +,   3.1739457E-03,   3.1965524E-03,   3.2036395E-03
     +,   3.1931950E-03,   3.1641473E-03,   3.1166773E-03
     +,   3.0523711E-03,   2.9741684E-03,   2.8861074E-03
     +,   2.7929437E-03,   2.6996501E-03,   2.6109389E-03
     +,   2.5308211E-03,   2.4622632E-03,   2.4069799E-03
     +,   2.3653640E-03,   2.3365321E-03,   2.3184805E-03
     +,   2.3083126E-03,   2.3025179E-03,   2.2972706E-03
     +,   2.2887255E-03,   2.2733083E-03,   2.2479582E-03
     +,   2.2103286E-03,   2.1589203E-03,   2.0931500E-03
     +,   2.0133413E-03,   1.9206334E-03,   1.8168479E-03
     +,   1.7043010E-03,   1.5855952E-03,   1.4634168E-03
     +,   1.3403557E-03,   1.2187563E-03,   1.1006184E-03
     +,   9.8754407E-04,   8.8071811E-04,   7.8095507E-04
     +,   6.8869349E-04,   6.0411671E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wano_hz_110 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wano_hz_115(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  3.2723612E-08,   3.6212164E-08
     +,   4.0041268E-08,   4.4240828E-08,   4.8842658E-08
     +,   5.3881180E-08,   5.9393273E-08,   6.5418455E-08
     +,   7.1999196E-08,   7.9180396E-08,   8.7010619E-08
     +,   9.5541388E-08,   1.0482773E-07,   1.1492817E-07
     +,   1.2590523E-07,   1.3782473E-07,   1.5075695E-07
     +,   1.6477659E-07,   1.7996230E-07,   1.9639806E-07
     +,   2.1417111E-07,   2.3337489E-07,   2.5410742E-07
     +,   2.7647195E-07,   3.0057748E-07,   3.2653699E-07
     +,   3.5447050E-07,   3.8450338E-07,   4.1676745E-07
     +,   4.5139811E-07,   4.8853917E-07,   5.2833985E-07
     +,   5.7095480E-07,   6.1654572E-07,   6.6528105E-07
     +,   7.1733211E-07,   7.7287933E-07,   8.3210898E-07
     +,   8.9521279E-07,   9.6238932E-07,   1.0338393E-06
     +,   1.1097733E-06,   1.1904050E-06,   1.2759547E-06
     +,   1.3666460E-06,   1.4627109E-06,   1.5643777E-06
     +,   1.6718860E-06,   1.7854799E-06,   1.9053969E-06
     +,   2.0318869E-06,   2.1651988E-06,   2.3055825E-06
     +,   2.4532897E-06,   2.6085725E-06,   2.7716817E-06
     +,   2.9428738E-06,   3.1223892E-06,   3.3104782E-06
     +,   3.5073908E-06,   3.7133580E-06,   3.9286192E-06
     +,   4.1534063E-06,   4.3879436E-06,   4.6324471E-06
     +,   4.8871279E-06,   5.1521938E-06,   5.4278253E-06
     +,   5.7142101E-06,   6.0115194E-06,   6.3199218E-06
     +,   6.6395519E-06,   6.9705516E-06,   7.3130450E-06
     +,   7.6671440E-06,   8.0329464E-06,   8.4105404E-06
     +,   8.7999815E-06,   9.2013343E-06,   9.6146423E-06
     +,   1.0039937E-05,   1.0477246E-05,   1.0926557E-05
     +,   1.1387876E-05,   1.1861193E-05,   1.2346488E-05
     +,   1.2843739E-05,   1.3352911E-05,   1.3873976E-05
     +,   1.4406929E-05,   1.4951694E-05,   1.5508276E-05
     +,   1.6076667E-05,   1.6656866E-05,   1.7248884E-05
     +,   1.7852775E-05,   1.8468623E-05,   1.9096469E-05
     +,   1.9736461E-05,   2.0388776E-05,   2.1053604E-05
     +,   2.1731214E-05,   2.2421904E-05,   2.3126046E-05
     +,   2.3844061E-05,   2.4576439E-05,   2.5323741E-05
     +,   2.6086613E-05,   2.6865764E-05,   2.7661999E-05
     +,   2.8476197E-05,   2.9309376E-05,   3.0162522E-05
     +,   3.1036830E-05,   3.1933556E-05,   3.2854034E-05
     +,   3.3799723E-05,   3.4772151E-05,   3.5772999E-05
     +,   3.6803893E-05,   3.7866710E-05,   3.8963342E-05
     +,   4.0095783E-05,   4.1266121E-05,   4.2476498E-05
     +,   4.3729149E-05,   4.5026423E-05,   4.6370704E-05
     +,   4.7764464E-05,   4.9210299E-05,   5.0710823E-05
     +,   5.2268908E-05,   5.3887237E-05,   5.5568871E-05
     +,   5.7316938E-05,   5.9134698E-05,   6.1025603E-05
     +,   6.2993342E-05,   6.5041822E-05,   6.7175344E-05
     +,   6.9398251E-05,   7.1715534E-05,   7.4132542E-05
     +,   7.6655095E-05,   7.9289515E-05,   8.2042738E-05
     +,   8.4922329E-05,   8.7936525E-05,   9.1094247E-05
     +,   9.4405164E-05,   9.7879689E-05,   1.0152911E-04
     +,   1.0536487E-04,   1.0939958E-04,   1.1364623E-04
     +,   1.1811828E-04,   1.2282947E-04,   1.2779384E-04
     +,   1.3302543E-04,   1.3853825E-04,   1.4434611E-04
     +,   1.5046290E-04,   1.5690114E-04,   1.6367403E-04
     +,   1.7079397E-04,   1.7827304E-04,   1.8612313E-04
     +,   1.9435587E-04,   2.0298276E-04,   2.1201534E-04
     +,   2.2146484E-04,   2.3134222E-04,   2.4165770E-04
     +,   2.5242093E-04,   2.6363792E-04,   2.7531350E-04
     +,   2.8744806E-04,   3.0003671E-04,   3.1306900E-04
     +,   3.2652772E-04,   3.4038565E-04,   3.5461242E-04
     +,   3.6916643E-04,   3.8400313E-04,   3.9907455E-04
     +,   4.1433360E-04,   4.2973884E-04,   4.4525883E-04
     +,   4.6087970E-04,   4.7660954E-04,   4.9248501E-04
     +,   5.0857465E-04,   5.2498293E-04,   5.4184510E-04
     +,   5.5933348E-04,   5.7763740E-04,   5.9696595E-04
     +,   6.1752222E-04,   6.3949084E-04,   6.6302507E-04
     +,   6.8821601E-04,   7.1509258E-04,   7.4359472E-04
     +,   7.7358010E-04,   8.0482278E-04,   8.3702715E-04
     +,   8.6984783E-04,   9.0291805E-04,   9.3588000E-04
     +,   9.6841750E-04,   1.0002794E-03,   1.0313012E-03
     +,   1.0614085E-03,   1.0906118E-03,   1.1189881E-03
     +,   1.1466468E-03,   1.1737114E-03,   1.2002629E-03
     +,   1.2263295E-03,   1.2518574E-03,   1.2766960E-03
     +,   1.3006142E-03,   1.3232995E-03,   1.3443955E-03
     +,   1.3635341E-03,   1.3803833E-03,   1.3947034E-03
     +,   1.4064066E-03,   1.4156203E-03,   1.4227404E-03
     +,   1.4284669E-03,   1.4338087E-03,   1.4400434E-03
     +,   1.4486249E-03,   1.4610428E-03,   1.4786386E-03
     +,   1.5024091E-03,   1.5328154E-03,   1.5696496E-03
     +,   1.6119805E-03,   1.6582101E-03,   1.7062264E-03
     +,   1.7536589E-03,   1.7982081E-03,   1.8379610E-03
     +,   1.8716794E-03,   1.8989863E-03,   1.9204188E-03
     +,   1.9373497E-03,   1.9517692E-03,   1.9659880E-03
     +,   1.9823208E-03,   2.0028024E-03,   2.0290068E-03
     +,   2.0620031E-03,   2.1024588E-03,   2.1508541E-03
     +,   2.2077472E-03,   2.2739675E-03,   2.3506891E-03
     +,   2.4392186E-03,   2.5405611E-03,   2.6547667E-03
     +,   2.7802156E-03,   2.9131130E-03,   3.0473042E-03
     +,   3.1746235E-03,   3.2857652E-03,   3.3715388E-03
     +,   3.4242538E-03,   3.4389349E-03,   3.4141056E-03
     +,   3.3519457E-03,   3.2578334E-03,   3.1393790E-03
     +,   3.0051575E-03,   2.8633955E-03,   2.7208719E-03
     +,   2.5822122E-03,   2.4496191E-03,   2.3231131E-03
     +,   2.2011045E-03,   2.0811784E-03,   1.9609032E-03
     +,   1.8384469E-03,   1.7129885E-03,   1.5848200E-03
     +,   1.4552063E-03,   1.3260719E-03,   1.1996316E-03
     +,   1.0780300E-03,   9.6308044E-04,   8.5609884E-04
     +,   7.5785967E-04,   6.6863041E-04,   5.8826705E-04
     +,   5.1632844E-04,   4.5219058E-04,   3.9515895E-04
     +,   3.4451199E-04,   2.9958517E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wano_hz_115 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wano_hz_120(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  6.3021567E-08,   6.8927754E-08
     +,   7.5327954E-08,   8.2257614E-08,   8.9753577E-08
     +,   9.7855313E-08,   1.0660413E-07,   1.1604348E-07
     +,   1.2621912E-07,   1.3717828E-07,   1.4897138E-07
     +,   1.6165055E-07,   1.7527032E-07,   1.8988753E-07
     +,   2.0556178E-07,   2.2235372E-07,   2.4032744E-07
     +,   2.5954887E-07,   2.8008637E-07,   3.0201076E-07
     +,   3.2539364E-07,   3.5031002E-07,   3.7683662E-07
     +,   4.0505171E-07,   4.3503627E-07,   4.6687086E-07
     +,   5.0063932E-07,   5.3642634E-07,   5.7431845E-07
     +,   6.1440073E-07,   6.5676147E-07,   7.0148843E-07
     +,   7.4866961E-07,   7.9839339E-07,   8.5074845E-07
     +,   9.0581960E-07,   9.6369376E-07,   1.0244565E-06
     +,   1.0881902E-06,   1.1549779E-06,   1.2248945E-06
     +,   1.2980186E-06,   1.3744211E-06,   1.4541722E-06
     +,   1.5373356E-06,   1.6239738E-06,   1.7141377E-06
     +,   1.8078790E-06,   1.9052436E-06,   2.0062635E-06
     +,   2.1109715E-06,   2.2193906E-06,   2.3315354E-06
     +,   2.4474127E-06,   2.5670206E-06,   2.6903476E-06
     +,   2.8173763E-06,   2.9480696E-06,   3.0823899E-06
     +,   3.2202886E-06,   3.3616964E-06,   3.5065425E-06
     +,   3.6547410E-06,   3.8061955E-06,   3.9607962E-06
     +,   4.1184212E-06,   4.2789420E-06,   4.4422050E-06
     +,   4.6080554E-06,   4.7763233E-06,   4.9468304E-06
     +,   5.1193742E-06,   5.2937530E-06,   5.4697498E-06
     +,   5.6471345E-06,   5.8256678E-06,   6.0051038E-06
     +,   6.1851742E-06,   6.3656134E-06,   6.5461440E-06
     +,   6.7264791E-06,   6.9063281E-06,   7.0853816E-06
     +,   7.2633375E-06,   7.4398845E-06,   7.6147044E-06
     +,   7.7874774E-06,   7.9578813E-06,   8.1255948E-06
     +,   8.2902970E-06,   8.4516514E-06,   8.6093414E-06
     +,   8.7630506E-06,   8.9124596E-06,   9.0572576E-06
     +,   9.1971406E-06,   9.3318158E-06,   9.4609804E-06
     +,   9.5843579E-06,   9.7016773E-06,   9.8126775E-06
     +,   9.9171120E-06,   1.0014743E-05,   1.0105350E-05
     +,   1.0188724E-05,   1.0264675E-05,   1.0333026E-05
     +,   1.0393619E-05,   1.0446312E-05,   1.0490982E-05
     +,   1.0527525E-05,   1.0555855E-05,   1.0575904E-05
     +,   1.0587624E-05,   1.0590994E-05,   1.0586002E-05
     +,   1.0572661E-05,   1.0551012E-05,   1.0521100E-05
     +,   1.0483009E-05,   1.0436830E-05,   1.0382681E-05
     +,   1.0320703E-05,   1.0251052E-05,   1.0173912E-05
     +,   1.0089489E-05,   9.9980098E-06,   9.8997325E-06
     +,   9.7949369E-06,   9.6839385E-06,   9.5670857E-06
     +,   9.4447560E-06,   9.3173940E-06,   9.1854745E-06
     +,   9.0495378E-06,   8.9101968E-06,   8.7681401E-06
     +,   8.6241625E-06,   8.4791618E-06,   8.3341674E-06
     +,   8.1903863E-06,   8.0491782E-06,   7.9121246E-06
     +,   7.7810428E-06,   7.6580291E-06,   7.5454882E-06
     +,   7.4461723E-06,   7.3632323E-06,   7.3002452E-06
     +,   7.2612670E-06,   7.2508728E-06,   7.2741996E-06
     +,   7.3369761E-06,   7.4455670E-06,   7.6069991E-06
     +,   7.8289922E-06,   8.1199742E-06,   8.4891026E-06
     +,   8.9462683E-06,   9.5021060E-06,   1.0167999E-05
     +,   1.0956118E-05,   1.1879280E-05,   1.2951174E-05
     +,   1.4186228E-05,   1.5599702E-05,   1.7207685E-05
     +,   1.9027195E-05,   2.1076223E-05,   2.3373826E-05
     +,   2.5940255E-05,   2.8797012E-05,   3.1966996E-05
     +,   3.5474750E-05,   3.9345865E-05,   4.3608034E-05
     +,   4.8290400E-05,   5.3423701E-05,   5.9040249E-05
     +,   6.5174201E-05,   7.1860079E-05,   7.9136073E-05
     +,   8.7040287E-05,   9.5614392E-05,   1.0490305E-04
     +,   1.1495547E-04,   1.2582687E-04,   1.3758060E-04
     +,   1.5029003E-04,   1.6404082E-04,   1.7893250E-04
     +,   1.9507925E-04,   2.1260972E-04,   2.3166047E-04
     +,   2.5237951E-04,   2.7490457E-04,   2.9936730E-04
     +,   3.2586465E-04,   3.5444833E-04,   3.8511673E-04
     +,   4.1778001E-04,   4.5227047E-04,   4.8831134E-04
     +,   5.2553316E-04,   5.6347164E-04,   6.0158531E-04
     +,   6.3927588E-04,   6.7591749E-04,   7.1088801E-04
     +,   7.4360066E-04,   7.7353307E-04,   8.0025307E-04
     +,   8.2343566E-04,   8.4287411E-04,   8.5848570E-04
     +,   8.7030831E-04,   8.7850564E-04,   8.8335562E-04
     +,   8.8525418E-04,   8.8470965E-04,   8.8234118E-04
     +,   8.7887130E-04,   8.7511685E-04,   8.7196869E-04
     +,   8.7036722E-04,   8.7127078E-04,   8.7561825E-04
     +,   8.8429108E-04,   8.9807110E-04,   9.1759878E-04
     +,   9.4332575E-04,   9.7545813E-04,   1.0138958E-03
     +,   1.0581666E-03,   1.1073720E-03,   1.1601666E-03
     +,   1.2147981E-03,   1.2692182E-03,   1.3213154E-03
     +,   1.3691986E-03,   1.4115364E-03,   1.4478597E-03
     +,   1.4787479E-03,   1.5058375E-03,   1.5315856E-03
     +,   1.5588269E-03,   1.5901899E-03,   1.6274796E-03
     +,   1.6711948E-03,   1.7202686E-03,   1.7721229E-03
     +,   1.8230061E-03,   1.8685488E-03,   1.9044125E-03
     +,   1.9268945E-03,   1.9334119E-03,   1.9227966E-03
     +,   1.8954261E-03,   1.8531989E-03,   1.7993769E-03
     +,   1.7383272E-03,   1.6751570E-03,   1.6152274E-03
     +,   1.5636089E-03,   1.5244797E-03,   1.5006334E-03
     +,   1.4931204E-03,   1.5011486E-03,   1.5222469E-03
     +,   1.5526603E-03,   1.5879035E-03,   1.6233472E-03
     +,   1.6547417E-03,   1.6785957E-03,   1.6923827E-03
     +,   1.6945711E-03,   1.6845375E-03,   1.6624072E-03
     +,   1.6288711E-03,   1.5850215E-03,   1.5322181E-03
     +,   1.4719927E-03,   1.4059675E-03,   1.3357997E-03
     +,   1.2630968E-03,   1.1893580E-03,   1.1159024E-03
     +,   1.0438137E-03,   9.7390119E-04,   9.0668804E-04
     +,   8.4242958E-04,   7.8115100E-04,   7.2270795E-04
     +,   6.6685100E-04,   6.1329221E-04,   5.6176417E-04
     +,   5.1206461E-04,   4.6408252E-04,   4.1782012E-04
     +,   3.7336411E-04,   3.3089708E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wano_hz_120 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wano_hz_60(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  1.2185304E-04,   1.2773970E-04
     +,   1.3422809E-04,   1.4148151E-04,   1.4969413E-04
     +,   1.5909430E-04,   1.6994477E-04,   1.8254235E-04
     +,   1.9721684E-04,   2.1432579E-04,   2.3425078E-04
     +,   2.5738776E-04,   2.8413648E-04,   3.1488601E-04
     +,   3.4999914E-04,   3.8979013E-04,   4.3450884E-04
     +,   4.8431542E-04,   5.3926295E-04,   5.9928279E-04
     +,   6.6417007E-04,   7.3359418E-04,   8.0710958E-04
     +,   8.8418846E-04,   9.6427160E-04,   1.0468274E-03
     +,   1.1314395E-03,   1.2178827E-03,   1.3062038E-03
     +,   1.3967701E-03,   1.4903087E-03,   1.5878724E-03
     +,   1.6907677E-03,   1.8004173E-03,   1.9181763E-03
     +,   2.0451022E-03,   2.1817549E-03,   2.3280010E-03
     +,   2.4829172E-03,   2.6448055E-03,   2.8113364E-03
     +,   2.9798478E-03,   3.1477385E-03,   3.3128948E-03
     +,   3.4741131E-03,   3.6313571E-03,   3.7858430E-03
     +,   3.9398591E-03,   4.0963492E-03,   4.2582969E-03
     +,   4.4280742E-03,   4.6068383E-03,   4.7941478E-03
     +,   4.9878890E-03,   5.1845079E-03,   5.3794845E-03
     +,   5.5678985E-03,   5.7448940E-03,   5.9059761E-03
     +,   6.0470137E-03,   6.1639594E-03,   6.2526069E-03
     +,   6.3083540E-03,   6.3262619E-03,   6.3014678E-03
     +,   6.2298891E-03,   6.1091254E-03,   5.9392857E-03
     +,   5.7235751E-03,   5.4684407E-03,   5.1832204E-03
     +,   4.8793228E-03,   4.5690509E-03,   4.2643342E-03
     +,   3.9754971E-03,   3.7103631E-03,   3.4736991E-03
     +,   3.2671744E-03,   3.0896680E-03,   2.9379281E-03
     +,   2.8073792E-03,   2.6929216E-03,   2.5896702E-03
     +,   2.4934583E-03,   2.4011470E-03,   2.3107317E-03
     +,   2.2212567E-03,   2.1326316E-03,   2.0453660E-03
     +,   1.9603039E-03,   1.8783914E-03,   1.8004626E-03
     +,   1.7271257E-03,   1.6586871E-03,   1.5951521E-03
     +,   1.5362555E-03,   1.4815321E-03,   1.4304109E-03
     +,   1.3822842E-03,   1.3365960E-03,   1.2929025E-03
     +,   1.2509001E-03,   1.2104473E-03,   1.1715513E-03
     +,   1.1343438E-03,   1.0990418E-03,   1.0659066E-03
     +,   1.0351964E-03,   1.0071265E-03,   9.8184193E-04
     +,   9.5939561E-04,   9.3973812E-04,   9.2272589E-04
     +,   9.0812729E-04,   8.9564186E-04,   8.8492234E-04
     +,   8.7559910E-04,   8.6729828E-04,   8.5966289E-04
     +,   8.5236650E-04,   8.4512209E-04,   8.3769014E-04
     +,   8.2987628E-04,   8.2153478E-04,   8.1256049E-04
     +,   8.0288720E-04,   7.9247972E-04,   7.8132929E-04
     +,   7.6944777E-04,   7.5686350E-04,   7.4361666E-04
     +,   7.2975736E-04,   7.1534415E-04,   7.0043985E-04
     +,   6.8511255E-04,   6.6943292E-04,   6.5347587E-04
     +,   6.3731760E-04,   6.2103511E-04,   6.0470618E-04
     +,   5.8840914E-04,   5.7221827E-04,   5.5620656E-04
     +,   5.4044306E-04,   5.2499049E-04,   5.0990767E-04
     +,   4.9524539E-04,   4.8104802E-04,   4.6735184E-04
     +,   4.5418559E-04,   4.4157030E-04,   4.2951849E-04
     +,   4.1803764E-04,   4.0712691E-04,   3.9677930E-04
     +,   3.8698330E-04,   3.7772252E-04,   3.6897694E-04
     +,   3.6072361E-04,   3.5293720E-04,   3.4559137E-04
     +,   3.3865811E-04,   3.3211059E-04,   3.2592090E-04
     +,   3.2006245E-04,   3.1450950E-04,   3.0923789E-04
     +,   3.0422464E-04,   2.9944873E-04,   2.9489092E-04
     +,   2.9053350E-04,   2.8636120E-04,   2.8236015E-04
     +,   2.7851801E-04,   2.7482535E-04,   2.7127319E-04
     +,   2.6785483E-04,   2.6456456E-04,   2.6139841E-04
     +,   2.5835342E-04,   2.5542825E-04,   2.5262166E-04
     +,   2.4993392E-04,   2.4736585E-04,   2.4491886E-04
     +,   2.4259451E-04,   2.4039506E-04,   2.3832255E-04
     +,   2.3637939E-04,   2.3456755E-04,   2.3288895E-04
     +,   2.3134523E-04,   2.2993727E-04,   2.2866594E-04
     +,   2.2753095E-04,   2.2653176E-04,   2.2566665E-04
     +,   2.2493354E-04,   2.2432925E-04,   2.2384965E-04
     +,   2.2349009E-04,   2.2324467E-04,   2.2310695E-04
     +,   2.2306936E-04,   2.2312358E-04,   2.2326079E-04
     +,   2.2347122E-04,   2.2374419E-04,   2.2406905E-04
     +,   2.2443412E-04,   2.2482741E-04,   2.2523670E-04
     +,   2.2564927E-04,   2.2605241E-04,   2.2643326E-04
     +,   2.2677885E-04,   2.2707651E-04,   2.2731355E-04
     +,   2.2747781E-04,   2.2755716E-04,   2.2754035E-04
     +,   2.2741630E-04,   2.2717462E-04,   2.2680585E-04
     +,   2.2630095E-04,   2.2565199E-04,   2.2485167E-04
     +,   2.2389374E-04,   2.2277299E-04,   2.2148488E-04
     +,   2.2002617E-04,   2.1839453E-04,   2.1658876E-04
     +,   2.1460844E-04,   2.1245441E-04,   2.1012835E-04
     +,   2.0763282E-04,   2.0497173E-04,   2.0214956E-04
     +,   1.9917158E-04,   1.9604395E-04,   1.9277360E-04
     +,   1.8936825E-04,   1.8583599E-04,   1.8218563E-04
     +,   1.7842633E-04,   1.7456776E-04,   1.7061979E-04
     +,   1.6659270E-04,   1.6249680E-04,   1.5834262E-04
     +,   1.5414073E-04,   1.4990153E-04,   1.4563545E-04
     +,   1.4135272E-04,   1.3706335E-04,   1.3277710E-04
     +,   1.2850315E-04,   1.2425096E-04,   1.2002906E-04
     +,   1.1584554E-04,   1.1170820E-04,   1.0762409E-04
     +,   1.0360029E-04,   9.9642843E-05,   9.5757401E-05
     +,   9.1949121E-05,   8.8222536E-05,   8.4581734E-05
     +,   8.1030215E-05,   7.7571007E-05,   7.4206568E-05
     +,   7.0938957E-05,   6.7769688E-05,   6.4699903E-05
     +,   6.1730279E-05,   5.8861107E-05,   5.6092187E-05
     +,   5.3423395E-05,   5.0853818E-05,   4.8382492E-05
     +,   4.6008110E-05,   4.3729080E-05,   4.1543870E-05
     +,   3.9450504E-05,   3.7446905E-05,   3.5530877E-05
     +,   3.3700122E-05,   3.1952244E-05,   3.0284744E-05
     +,   2.8695102E-05,   2.7180768E-05,   2.5739111E-05
     +,   2.4367548E-05,   2.3063465E-05,   2.1824269E-05
     +,   2.0647391E-05,   1.9530244E-05,   1.8470475E-05
     +,   1.7465438E-05,   1.6512873E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wano_hz_60 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wano_hz_65(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  8.0444137E-05,   8.4489555E-05
     +,   8.8753404E-05,   9.3242146E-05,   9.7962053E-05
     +,   1.0292016E-04,   1.0812419E-04,   1.1358299E-04
     +,   1.1930711E-04,   1.2530888E-04,   1.3160355E-04
     +,   1.3820935E-04,   1.4514840E-04,   1.5244687E-04
     +,   1.6013590E-04,   1.6825119E-04,   1.7683444E-04
     +,   1.8593260E-04,   1.9559855E-04,   2.0589077E-04
     +,   2.1687264E-04,   2.2861341E-04,   2.4118721E-04
     +,   2.5467269E-04,   2.6915388E-04,   2.8471785E-04
     +,   3.0145777E-04,   3.1947086E-04,   3.3886082E-04
     +,   3.5973496E-04,   3.8220827E-04,   4.0640146E-04
     +,   4.3244168E-04,   4.6046148E-04,   4.9059931E-04
     +,   5.2299612E-04,   5.5779703E-04,   5.9514923E-04
     +,   6.3520041E-04,   6.7810027E-04,   7.2399515E-04
     +,   7.7303586E-04,   8.2536897E-04,   8.8113843E-04
     +,   9.4047660E-04,   1.0034984E-03,   1.0702790E-03
     +,   1.1408477E-03,   1.2151641E-03,   1.2930959E-03
     +,   1.3744228E-03,   1.4588315E-03,   1.5459406E-03
     +,   1.6353372E-03,   1.7266362E-03,   1.8195397E-03
     +,   1.9138987E-03,   2.0097415E-03,   2.1072815E-03
     +,   2.2068697E-03,   2.3088900E-03,   2.4136538E-03
     +,   2.5212748E-03,   2.6315886E-03,   2.7441704E-03
     +,   2.8584523E-03,   2.9739647E-03,   3.0906578E-03
     +,   3.2092656E-03,   3.3315595E-03,   3.4604501E-03
     +,   3.5997895E-03,   3.7538738E-03,   3.9266353E-03
     +,   4.1206530E-03,   4.3362025E-03,   4.5705987E-03
     +,   4.8180157E-03,   5.0700461E-03,   5.3168568E-03
     +,   5.5488478E-03,   5.7583759E-03,   5.9411069E-03
     +,   6.0967584E-03,   6.2287063E-03,   6.3428245E-03
     +,   6.4455955E-03,   6.5420652E-03,   6.6342456E-03
     +,   6.7203604E-03,   6.7951474E-03,   6.8512978E-03
     +,   6.8813828E-03,   6.8798484E-03,   6.8444018E-03
     +,   6.7763338E-03,   6.6798427E-03,   6.5606264E-03
     +,   6.4241900E-03,   6.2746322E-03,   6.1140764E-03
     +,   5.9428629E-03,   5.7603954E-03,   5.5661025E-03
     +,   5.3603193E-03,   5.1447074E-03,   4.9222298E-03
     +,   4.6967743E-03,   4.4725505E-03,   4.2535574E-03
     +,   4.0431498E-03,   3.8438353E-03,   3.6572972E-03
     +,   3.4844393E-03,   3.3255753E-03,   3.1805495E-03
     +,   3.0488481E-03,   2.9296556E-03,   2.8219123E-03
     +,   2.7243556E-03,   2.6355584E-03,   2.5539848E-03
     +,   2.4780734E-03,   2.4062835E-03,   2.3371733E-03
     +,   2.2694545E-03,   2.2020522E-03,   2.1341513E-03
     +,   2.0652337E-03,   1.9951037E-03,   1.9238887E-03
     +,   1.8520158E-03,   1.7801833E-03,   1.7092801E-03
     +,   1.6403199E-03,   1.5743586E-03,   1.5123999E-03
     +,   1.4553246E-03,   1.4038213E-03,   1.3583440E-03
     +,   1.3190919E-03,   1.2859984E-03,   1.2587575E-03
     +,   1.2368569E-03,   1.2196312E-03,   1.2063072E-03
     +,   1.1960670E-03,   1.1880979E-03,   1.1816373E-03
     +,   1.1760049E-03,   1.1706282E-03,   1.1650559E-03
     +,   1.1589570E-03,   1.1521165E-03,   1.1444211E-03
     +,   1.1358422E-03,   1.1264149E-03,   1.1162199E-03
     +,   1.1053607E-03,   1.0939501E-03,   1.0820917E-03
     +,   1.0698721E-03,   1.0573550E-03,   1.0445748E-03
     +,   1.0315367E-03,   1.0182224E-03,   1.0045909E-03
     +,   9.9058868E-04,   9.7615400E-04,   9.6122612E-04
     +,   9.4575272E-04,   9.2969404E-04,   9.1302872E-04
     +,   8.9575764E-04,   8.7790831E-04,   8.5952767E-04
     +,   8.4068783E-04,   8.2147995E-04,   8.0201111E-04
     +,   7.8240066E-04,   7.6277740E-04,   7.4326777E-04
     +,   7.2400086E-04,   7.0509670E-04,   6.8666670E-04
     +,   6.6880899E-04,   6.5160618E-04,   6.3512567E-04
     +,   6.1941677E-04,   6.0451165E-04,   5.9042568E-04
     +,   5.7715829E-04,   5.6469394E-04,   5.5300613E-04
     +,   5.4205343E-04,   5.3178886E-04,   5.2215392E-04
     +,   5.1308726E-04,   5.0452340E-04,   4.9639173E-04
     +,   4.8862392E-04,   4.8114904E-04,   4.7390052E-04
     +,   4.6681246E-04,   4.5982297E-04,   4.5287455E-04
     +,   4.4591402E-04,   4.3889420E-04,   4.3177293E-04
     +,   4.2451409E-04,   4.1708758E-04,   4.0946945E-04
     +,   4.0164156E-04,   3.9359188E-04,   3.8531347E-04
     +,   3.7680659E-04,   3.6807364E-04,   3.5912474E-04
     +,   3.4997278E-04,   3.4063437E-04,   3.3113128E-04
     +,   3.2148525E-04,   3.1172336E-04,   3.0187319E-04
     +,   2.9196369E-04,   2.8202496E-04,   2.7208749E-04
     +,   2.6218171E-04,   2.5233778E-04,   2.4258472E-04
     +,   2.3295076E-04,   2.2346230E-04,   2.1414402E-04
     +,   2.0501894E-04,   1.9610771E-04,   1.8742889E-04
     +,   1.7899821E-04,   1.7083017E-04,   1.6293577E-04
     +,   1.5532404E-04,   1.4800177E-04,   1.4097318E-04
     +,   1.3424127E-04,   1.2780623E-04,   1.2166670E-04
     +,   1.1581962E-04,   1.1026041E-04,   1.0498321E-04
     +,   9.9980934E-05,   9.5245494E-05,   9.0767935E-05
     +,   8.6538639E-05,   8.2547442E-05,   7.8783778E-05
     +,   7.5236792E-05,   7.1895520E-05,   6.8748916E-05
     +,   6.5785884E-05,   6.2995874E-05,   6.0368144E-05
     +,   5.7892383E-05,   5.5558601E-05,   5.3357096E-05
     +,   5.1278916E-05,   4.9315193E-05,   4.7457674E-05
     +,   4.5698562E-05,   4.4030523E-05,   4.2446725E-05
     +,   4.0940784E-05,   3.9506813E-05,   3.8139347E-05
     +,   3.6833375E-05,   3.5584271E-05,   3.4387838E-05
     +,   3.3240249E-05,   3.2138010E-05,   3.1077918E-05
     +,   3.0057241E-05,   2.9073357E-05,   2.8123974E-05
     +,   2.7207021E-05,   2.6320628E-05,   2.5463227E-05
     +,   2.4633313E-05,   2.3829589E-05,   2.3050892E-05
     +,   2.2296188E-05,   2.1564565E-05,   2.0855192E-05
     +,   2.0167341E-05,   1.9500345E-05,   1.8853616E-05
     +,   1.8226607E-05,   1.7618822E-05,   1.7029801E-05
     +,   1.6459122E-05,   1.5906357E-05,   1.5371197E-05
     +,   1.4853184E-05,   1.4352041E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wano_hz_65 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wano_hz_70(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  4.3182354E-05,   4.5397406E-05
     +,   4.7734778E-05,   5.0201732E-05,   5.2805881E-05
     +,   5.5555614E-05,   5.8459926E-05,   6.1528488E-05
     +,   6.4771797E-05,   6.8200832E-05,   7.1827570E-05
     +,   7.5664662E-05,   7.9725527E-05,   8.4024214E-05
     +,   8.8575558E-05,   9.3394556E-05,   9.8496988E-05
     +,   1.0389875E-04,   1.0961582E-04,   1.1566411E-04
     +,   1.2205885E-04,   1.2881489E-04,   1.3594601E-04
     +,   1.4346480E-04,   1.5138231E-04,   1.5970721E-04
     +,   1.6844647E-04,   1.7760429E-04,   1.8718239E-04
     +,   1.9717877E-04,   2.0758914E-04,   2.1840549E-04
     +,   2.2961691E-04,   2.4120935E-04,   2.5316630E-04
     +,   2.6546768E-04,   2.7809266E-04,   2.9101851E-04
     +,   3.0422196E-04,   3.1768021E-04,   3.3137060E-04
     +,   3.4527370E-04,   3.5937276E-04,   3.7365529E-04
     +,   3.8811465E-04,   4.0275077E-04,   4.1757044E-04
     +,   4.3259020E-04,   4.4783633E-04,   4.6334480E-04
     +,   4.7916514E-04,   4.9535878E-04,   5.1200221E-04
     +,   5.2918750E-04,   5.4702471E-04,   5.6564395E-04
     +,   5.8519887E-04,   6.0586748E-04,   6.2785984E-04
     +,   6.5141800E-04,   6.7682052E-04,   7.0438546E-04
     +,   7.3447078E-04,   7.6747261E-04,   8.0381887E-04
     +,   8.4396079E-04,   8.8835775E-04,   9.3745289E-04
     +,   9.9165551E-04,   1.0513058E-03,   1.1166523E-03
     +,   1.1878158E-03,   1.2647803E-03,   1.3473786E-03
     +,   1.4352985E-03,   1.5281080E-03,   1.6252960E-03
     +,   1.7263216E-03,   1.8306972E-03,   1.9380469E-03
     +,   2.0481790E-03,   2.1611338E-03,   2.2772001E-03
     +,   2.3969158E-03,   2.5210024E-03,   2.6502647E-03
     +,   2.7854673E-03,   2.9271804E-03,   3.0756441E-03
     +,   3.2306782E-03,   3.3916531E-03,   3.5576057E-03
     +,   3.7273674E-03,   3.8997764E-03,   4.0738122E-03
     +,   4.2486321E-03,   4.4234497E-03,   4.5972751E-03
     +,   4.7687343E-03,   4.9360567E-03,   5.0974796E-03
     +,   5.2520721E-03,   5.4008234E-03,   5.5476357E-03
     +,   5.6996536E-03,   5.8665858E-03,   6.0588988E-03
     +,   6.2852702E-03,   6.5501244E-03,   6.8520852E-03
     +,   7.1841436E-03,   7.5354427E-03,   7.8939432E-03
     +,   8.2488619E-03,   8.5916324E-03,   8.9149754E-03
     +,   9.2108008E-03,   9.4682230E-03,   9.6731838E-03
     +,   9.8101748E-03,   9.8657673E-03,   9.8322397E-03
     +,   9.7101266E-03,   9.5085520E-03,   9.2438217E-03
     +,   8.9365598E-03,   8.6087268E-03,   8.2806908E-03
     +,   7.9690050E-03,   7.6848036E-03,   7.4332212E-03
     +,   7.2138123E-03,   7.0220814E-03,   6.8513886E-03
     +,   6.6949516E-03,   6.5470613E-03,   6.4034224E-03
     +,   6.2607434E-03,   6.1160340E-03,   5.9660994E-03
     +,   5.8076433E-03,   5.6378343E-03,   5.4552020E-03
     +,   5.2603963E-03,   5.0564911E-03,   4.8486581E-03
     +,   4.6433397E-03,   4.4470904E-03,   4.2654071E-03
     +,   4.1018901E-03,   3.9577950E-03,   3.8321365E-03
     +,   3.7221615E-03,   3.6240646E-03,   3.5337654E-03
     +,   3.4475650E-03,   3.3625939E-03,   3.2770031E-03
     +,   3.1899454E-03,   3.1014071E-03,   3.0119682E-03
     +,   2.9225394E-03,   2.8341408E-03,   2.7477313E-03
     +,   2.6640950E-03,   2.5838001E-03,   2.5071721E-03
     +,   2.4343170E-03,   2.3651563E-03,   2.2994750E-03
     +,   2.2369681E-03,   2.1772953E-03,   2.1201228E-03
     +,   2.0651640E-03,   2.0122065E-03,   1.9611153E-03
     +,   1.9118451E-03,   1.8644187E-03,   1.8189104E-03
     +,   1.7754192E-03,   1.7340441E-03,   1.6948442E-03
     +,   1.6578401E-03,   1.6229841E-03,   1.5901604E-03
     +,   1.5591886E-03,   1.5298328E-03,   1.5018166E-03
     +,   1.4748356E-03,   1.4485811E-03,   1.4227543E-03
     +,   1.3970807E-03,   1.3713234E-03,   1.3452951E-03
     +,   1.3188525E-03,   1.2919143E-03,   1.2644406E-03
     +,   1.2364456E-03,   1.2079858E-03,   1.1791423E-03
     +,   1.1500324E-03,   1.1207781E-03,   1.0915194E-03
     +,   1.0623902E-03,   1.0335200E-03,   1.0050236E-03
     +,   9.7700220E-04,   9.4953517E-04,   9.2268217E-04
     +,   8.9648174E-04,   8.7095331E-04,   8.4609736E-04
     +,   8.2189939E-04,   7.9833250E-04,   7.7536050E-04
     +,   7.5294299E-04,   7.3103153E-04,   7.0958299E-04
     +,   6.8855210E-04,   6.6789752E-04,   6.4758677E-04
     +,   6.2758586E-04,   6.0787459E-04,   5.8843463E-04
     +,   5.6925591E-04,   5.5033382E-04,   5.3166918E-04
     +,   5.1326823E-04,   4.9514056E-04,   4.7729947E-04
     +,   4.5976086E-04,   4.4254214E-04,   4.2566191E-04
     +,   4.0913944E-04,   3.9299348E-04,   3.7724231E-04
     +,   3.6190214E-04,   3.4699007E-04,   3.3251874E-04
     +,   3.1850007E-04,   3.0494324E-04,   2.9185458E-04
     +,   2.7924002E-04,   2.6710119E-04,   2.5543806E-04
     +,   2.4424843E-04,   2.3352802E-04,   2.2327057E-04
     +,   2.1346820E-04,   2.0411145E-04,   1.9518951E-04
     +,   1.8669023E-04,   1.7860079E-04,   1.7090735E-04
     +,   1.6359542E-04,   1.5665013E-04,   1.5005622E-04
     +,   1.4379798E-04,   1.3786042E-04,   1.3222772E-04
     +,   1.2688461E-04,   1.2181584E-04,   1.1700640E-04
     +,   1.1244221E-04,   1.0810894E-04,   1.0399298E-04
     +,   1.0008124E-04,   9.6361116E-05,   9.2820621E-05
     +,   8.9448360E-05,   8.6233456E-05,   8.3165767E-05
     +,   8.0235674E-05,   7.7434175E-05,   7.4752941E-05
     +,   7.2184150E-05,   6.9720620E-05,   6.7355613E-05
     +,   6.5083223E-05,   6.2897772E-05,   6.0794184E-05
     +,   5.8767808E-05,   5.6814384E-05,   5.4930268E-05
     +,   5.3111988E-05,   5.1356441E-05,   4.9660895E-05
     +,   4.8022812E-05,   4.6440000E-05,   4.4910412E-05
     +,   4.3432254E-05,   4.2003834E-05,   4.0623672E-05
     +,   3.9290346E-05,   3.8002581E-05,   3.6759149E-05
     +,   3.5558900E-05,   3.4400688E-05,   3.3283577E-05
     +,   3.2206332E-05,   3.1168078E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wano_hz_70 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wano_hz_75(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  2.5635261E-05,   2.7508915E-05
     +,   2.9523862E-05,   3.1688502E-05,   3.4011184E-05
     +,   3.6500463E-05,   3.9164868E-05,   4.2012787E-05
     +,   4.5052537E-05,   4.8291928E-05,   5.1738640E-05
     +,   5.5399742E-05,   5.9281698E-05,   6.3390267E-05
     +,   6.7730391E-05,   7.2305746E-05,   7.7119126E-05
     +,   8.2171922E-05,   8.7464250E-05,   9.2994625E-05
     +,   9.8759643E-05,   1.0475450E-04,   1.1097245E-04
     +,   1.1740477E-04,   1.2404099E-04,   1.3086817E-04
     +,   1.3787182E-04,   1.4503545E-04,   1.5234078E-04
     +,   1.5976734E-04,   1.6729352E-04,   1.7489608E-04
     +,   1.8255055E-04,   1.9023157E-04,   1.9791325E-04
     +,   2.0556890E-04,   2.1317223E-04,   2.2069737E-04
     +,   2.2811913E-04,   2.3541403E-04,   2.4255965E-04
     +,   2.4953624E-04,   2.5632692E-04,   2.6291786E-04
     +,   2.6929888E-04,   2.7546452E-04,   2.8141323E-04
     +,   2.8714925E-04,   2.9268244E-04,   2.9802814E-04
     +,   3.0320857E-04,   3.0825241E-04,   3.1319534E-04
     +,   3.1808019E-04,   3.2295659E-04,   3.2788163E-04
     +,   3.3291947E-04,   3.3814044E-04,   3.4362165E-04
     +,   3.4944571E-04,   3.5569997E-04,   3.6247587E-04
     +,   3.6986775E-04,   3.7797089E-04,   3.8688118E-04
     +,   3.9669155E-04,   4.0749286E-04,   4.1936873E-04
     +,   4.3239651E-04,   4.4664429E-04,   4.6216999E-04
     +,   4.7901797E-04,   4.9722247E-04,   5.1680335E-04
     +,   5.3776940E-04,   5.6011922E-04,   5.8384356E-04
     +,   6.0892635E-04,   6.3535298E-04,   6.6311104E-04
     +,   6.9219735E-04,   7.2262232E-04,   7.5441052E-04
     +,   7.8760996E-04,   8.2228862E-04,   8.5853500E-04
     +,   8.9645624E-04,   9.3617110E-04,   9.7780221E-04
     +,   1.0214677E-03,   1.0672640E-03,   1.1152631E-03
     +,   1.1654930E-03,   1.2179335E-03,   1.2725072E-03
     +,   1.3290764E-03,   1.3874491E-03,   1.4473727E-03
     +,   1.5085607E-03,   1.5706981E-03,   1.6334557E-03
     +,   1.6965079E-03,   1.7595495E-03,   1.8223085E-03
     +,   1.8845560E-03,   1.9461197E-03,   2.0068896E-03
     +,   2.0668313E-03,   2.1260062E-03,   2.1846008E-03
     +,   2.2429659E-03,   2.3016785E-03,   2.3616033E-03
     +,   2.4239784E-03,   2.4904769E-03,   2.5632300E-03
     +,   2.6448118E-03,   2.7381182E-03,   2.8461590E-03
     +,   2.9717423E-03,   3.1171434E-03,   3.2838276E-03
     +,   3.4723091E-03,   3.6823761E-03,   3.9136331E-03
     +,   4.1663963E-03,   4.4426508E-03,   4.7466699E-03
     +,   5.0848261E-03,   5.4643098E-03,   5.8907978E-03
     +,   6.3657830E-03,   6.8845036E-03,   7.4357893E-03
     +,   8.0038421E-03,   8.5715828E-03,   9.1240108E-03
     +,   9.6501736E-03,   1.0143153E-02,   1.0598755E-02
     +,   1.1013929E-02,   1.1386439E-02,   1.1714958E-02
     +,   1.1999373E-02,   1.2240597E-02,   1.2439602E-02
     +,   1.2597064E-02,   1.2713530E-02,   1.2790419E-02
     +,   1.2830663E-02,   1.2838638E-02,   1.2819059E-02
     +,   1.2775952E-02,   1.2712045E-02,   1.2628257E-02
     +,   1.2523174E-02,   1.2392941E-02,   1.2232999E-02
     +,   1.2041771E-02,   1.1824292E-02,   1.1592515E-02
     +,   1.1361099E-02,   1.1140802E-02,   1.0933946E-02
     +,   1.0734623E-02,   1.0533403E-02,   1.0322930E-02
     +,   1.0101047E-02,   9.8702349E-03,   9.6347975E-03
     +,   9.3979882E-03,   9.1607505E-03,   8.9223506E-03
     +,   8.6815795E-03,   8.4377993E-03,   8.1908070E-03
     +,   7.9403808E-03,   7.6856166E-03,   7.4249385E-03
     +,   7.1565616E-03,   6.8793460E-03,   6.5934286E-03
     +,   6.3008685E-03,   6.0055098E-03,   5.7126465E-03
     +,   5.4282080E-03,   5.1577524E-03,   4.9056020E-03
     +,   4.6741543E-03,   4.4637979E-03,   4.2731464E-03
     +,   4.0996326E-03,   3.9401646E-03,   3.7917395E-03
     +,   3.6517454E-03,   3.5182070E-03,   3.3896803E-03
     +,   3.2652083E-03,   3.1441408E-03,   3.0259511E-03
     +,   2.9102243E-03,   2.7965088E-03,   2.6843937E-03
     +,   2.5734836E-03,   2.4634665E-03,   2.3541744E-03
     +,   2.2456232E-03,   2.1380296E-03,   2.0318015E-03
     +,   1.9274912E-03,   1.8257322E-03,   1.7271655E-03
     +,   1.6323675E-03,   1.5417916E-03,   1.4557325E-03
     +,   1.3743348E-03,   1.2975605E-03,   1.2252647E-03
     +,   1.1571952E-03,   1.0930417E-03,   1.0324857E-03
     +,   9.7519590E-04,   9.2088821E-04,   8.6931075E-04
     +,   8.2026148E-04,   7.7358424E-04,   7.2916556E-04
     +,   6.8692508E-04,   6.4680999E-04,   6.0878397E-04
     +,   5.7282037E-04,   5.3889677E-04,   5.0698762E-04
     +,   4.7706338E-04,   4.4908508E-04,   4.2300537E-04
     +,   3.9876602E-04,   3.7630249E-04,   3.5553845E-04
     +,   3.3639185E-04,   3.1877478E-04,   3.0259497E-04
     +,   2.8776008E-04,   2.7417473E-04,   2.6174547E-04
     +,   2.5038089E-04,   2.3999259E-04,   2.3049631E-04
     +,   2.2181228E-04,   2.1386558E-04,   2.0658628E-04
     +,   1.9990957E-04,   1.9377533E-04,   1.8812837E-04
     +,   1.8291760E-04,   1.7809622E-04,   1.7362094E-04
     +,   1.6945192E-04,   1.6555299E-04,   1.6189013E-04
     +,   1.5843227E-04,   1.5515077E-04,   1.5201911E-04
     +,   1.4901336E-04,   1.4611130E-04,   1.4329275E-04
     +,   1.4053949E-04,   1.3783512E-04,   1.3516509E-04
     +,   1.3251656E-04,   1.2987854E-04,   1.2724152E-04
     +,   1.2459773E-04,   1.2194089E-04,   1.1926614E-04
     +,   1.1657005E-04,   1.1385045E-04,   1.1110630E-04
     +,   1.0833796E-04,   1.0554643E-04,   1.0273376E-04
     +,   9.9902732E-05,   9.7056698E-05,   9.4199946E-05
     +,   9.1336871E-05,   8.8472305E-05,   8.5611427E-05
     +,   8.2759550E-05,   7.9922080E-05,   7.7104414E-05
     +,   7.4312018E-05,   7.1550079E-05,   6.8823741E-05
     +,   6.6137844E-05,   6.3497027E-05,   6.0905579E-05
     +,   5.8367481E-05,   5.5886252E-05,   5.3465479E-05
     +,   5.1107607E-05,   4.8815447E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wano_hz_75 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wano_hz_80(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  8.2130973E-06,   8.7139279E-06
     +,   9.2513574E-06,   9.8275341E-06,   1.0444584E-05
     +,   1.1104700E-05,   1.1810052E-05,   1.2562792E-05
     +,   1.3365070E-05,   1.4218936E-05,   1.5126416E-05
     +,   1.6089441E-05,   1.7109845E-05,   1.8189325E-05
     +,   1.9329462E-05,   2.0531603E-05,   2.1796970E-05
     +,   2.3126559E-05,   2.4521127E-05,   2.5981226E-05
     +,   2.7507040E-05,   2.9098539E-05,   3.0755400E-05
     +,   3.2476961E-05,   3.4262295E-05,   3.6110017E-05
     +,   3.8018519E-05,   3.9985862E-05,   4.2009800E-05
     +,   4.4087650E-05,   4.6216584E-05,   4.8393471E-05
     +,   5.0614952E-05,   5.2877491E-05,   5.5177414E-05
     +,   5.7510926E-05,   5.9874292E-05,   6.2263818E-05
     +,   6.4676002E-05,   6.7107612E-05,   6.9555725E-05
     +,   7.2017960E-05,   7.4492593E-05,   7.6978627E-05
     +,   7.9476049E-05,   8.1985912E-05,   8.4510393E-05
     +,   8.7053202E-05,   8.9619687E-05,   9.2216738E-05
     +,   9.4853298E-05,   9.7540302E-05,   1.0029093E-04
     +,   1.0312055E-04,   1.0604696E-04,   1.0909035E-04
     +,   1.1227348E-04,   1.1562118E-04,   1.1916086E-04
     +,   1.2292204E-04,   1.2693598E-04,   1.3123573E-04
     +,   1.3585571E-04,   1.4083108E-04,   1.4619736E-04
     +,   1.5198989E-04,   1.5824332E-04,   1.6499031E-04
     +,   1.7226160E-04,   1.8008477E-04,   1.8848381E-04
     +,   1.9747749E-04,   2.0707975E-04,   2.1729812E-04
     +,   2.2813382E-04,   2.3958059E-04,   2.5162529E-04
     +,   2.6424581E-04,   2.7741355E-04,   2.9109223E-04
     +,   3.0523870E-04,   3.1980436E-04,   3.3473474E-04
     +,   3.4997318E-04,   3.6546102E-04,   3.8114082E-04
     +,   3.9695794E-04,   4.1286362E-04,   4.2881773E-04
     +,   4.4479300E-04,   4.6077461E-04,   4.7676676E-04
     +,   4.9279357E-04,   5.0890108E-04,   5.2515842E-04
     +,   5.4165802E-04,   5.5851613E-04,   5.7586678E-04
     +,   5.9386418E-04,   6.1267189E-04,   6.3246058E-04
     +,   6.5339770E-04,   6.7563955E-04,   6.9932226E-04
     +,   7.2455412E-04,   7.5140630E-04,   7.7990966E-04
     +,   8.1005075E-04,   8.4177428E-04,   8.7498839E-04
     +,   9.0957631E-04,   9.4540842E-04,   9.8235882E-04
     +,   1.0203272E-03,   1.0592564E-03,   1.0991474E-03
     +,   1.1400719E-03,   1.1821811E-03,   1.2257078E-03
     +,   1.2709574E-03,   1.3183140E-03,   1.3682249E-03
     +,   1.4212001E-03,   1.4778072E-03,   1.5386733E-03
     +,   1.6044906E-03,   1.6760140E-03,   1.7540660E-03
     +,   1.8395284E-03,   1.9333252E-03,   2.0363915E-03
     +,   2.1496245E-03,   2.2737903E-03,   2.4094351E-03
     +,   2.5567161E-03,   2.7152325E-03,   2.8838292E-03
     +,   3.0604640E-03,   3.2421467E-03,   3.4250612E-03
     +,   3.6048447E-03,   3.7771580E-03,   3.9382940E-03
     +,   4.0858695E-03,   4.2194449E-03,   4.3409313E-03
     +,   4.4548595E-03,   4.5685433E-03,   4.6922085E-03
     +,   4.8389100E-03,   5.0240159E-03,   5.2635181E-03
     +,   5.5708517E-03,   5.9523960E-03,   6.4026569E-03
     +,   6.9015119E-03,   7.4157123E-03,   7.9060337E-03
     +,   8.3387420E-03,   8.6978376E-03,   8.9926422E-03
     +,   9.2572123E-03,   9.5415656E-03,   9.8992633E-03
     +,   1.0376908E-02,   1.1008326E-02,   1.1809737E-02
     +,   1.2770751E-02,   1.3843345E-02,   1.4942267E-02
     +,   1.5971262E-02,   1.6869402E-02,   1.7646344E-02
     +,   1.8371148E-02,   1.9114468E-02,   1.9884329E-02
     +,   2.0605408E-02,   2.1157712E-02,   2.1445042E-02
     +,   2.1447033E-02,   2.1225303E-02,   2.0889560E-02
     +,   2.0554543E-02,   2.0315500E-02,   2.0241491E-02
     +,   2.0359829E-02,   2.0619607E-02,   2.0868439E-02
     +,   2.0893356E-02,   2.0525735E-02,   1.9739401E-02
     +,   1.8663505E-02,   1.7501578E-02,   1.6422549E-02
     +,   1.5496720E-02,   1.4702800E-02,   1.3976078E-02
     +,   1.3258784E-02,   1.2525539E-02,   1.1782373E-02
     +,   1.1051587E-02,   1.0354369E-02,   9.7023025E-03
     +,   9.0971114E-03,   8.5360408E-03,   8.0167297E-03
     +,   7.5386660E-03,   7.1018361E-03,   6.7045838E-03
     +,   6.3425084E-03,   6.0089971E-03,   5.6965826E-03
     +,   5.3983661E-03,   5.1089805E-03,   4.8249806E-03
     +,   4.5448686E-03,   4.2686076E-03,   3.9972407E-03
     +,   3.7321683E-03,   3.4746944E-03,   3.2258346E-03
     +,   2.9861613E-03,   2.7561397E-03,   2.5362086E-03
     +,   2.3269742E-03,   2.1292353E-03,   1.9438966E-03
     +,   1.7718117E-03,   1.6136335E-03,   1.4696940E-03
     +,   1.3399441E-03,   1.2239689E-03,   1.1210395E-03
     +,   1.0301932E-03,   9.5032871E-04,   8.8028132E-04
     +,   8.1888825E-04,   7.6504669E-04,   7.1772240E-04
     +,   6.7598169E-04,   6.3899043E-04,   6.0601154E-04
     +,   5.7640707E-04,   5.4962118E-04,   5.2517897E-04
     +,   5.0267647E-04,   4.8177422E-04,   4.6218897E-04
     +,   4.4368804E-04,   4.2608182E-04,   4.0921906E-04
     +,   3.9298023E-04,   3.7727336E-04,   3.6202904E-04
     +,   3.4719636E-04,   3.3273929E-04,   3.1863354E-04
     +,   3.0486303E-04,   2.9142050E-04,   2.7830171E-04
     +,   2.6550615E-04,   2.5303612E-04,   2.4089435E-04
     +,   2.2908626E-04,   2.1761577E-04,   2.0648769E-04
     +,   1.9570631E-04,   1.8527592E-04,   1.7520023E-04
     +,   1.6548258E-04,   1.5612572E-04,   1.4713175E-04
     +,   1.3850219E-04,   1.3023765E-04,   1.2233786E-04
     +,   1.1480165E-04,   1.0762674E-04,   1.0080955E-04
     +,   9.4346105E-05,   8.8230438E-05,   8.2455736E-05
     +,   7.7013974E-05,   7.1895913E-05,   6.7091940E-05
     +,   6.2590872E-05,   5.8380981E-05,   5.4449876E-05
     +,   5.0784678E-05,   4.7372108E-05,   4.4198692E-05
     +,   4.1250831E-05,   3.8514987E-05,   3.5977777E-05
     +,   3.3626053E-05,   3.1447078E-05,   2.9428515E-05
     +,   2.7558546E-05,   2.5825830E-05,   2.4219942E-05
     +,   2.2730539E-05,   2.1348433E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wano_hz_80 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wano_hz_85(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  4.3294690E-06,   4.4876492E-06
     +,   4.6511927E-06,   4.8204029E-06,   4.9956070E-06
     +,   5.1771749E-06,   5.3655135E-06,   5.5610681E-06
     +,   5.7643292E-06,   5.9758231E-06,   6.1961400E-06
     +,   6.4259139E-06,   6.6658390E-06,   6.9166681E-06
     +,   7.1792238E-06,   7.4543686E-06,   7.7430632E-06
     +,   8.0463242E-06,   8.3652449E-06,   8.7010021E-06
     +,   9.0548292E-06,   9.4280576E-06,   9.8220962E-06
     +,   1.0238428E-05,   1.0678637E-05,   1.1144351E-05
     +,   1.1637312E-05,   1.2159322E-05,   1.2712281E-05
     +,   1.3298119E-05,   1.3918881E-05,   1.4576663E-05
     +,   1.5273607E-05,   1.6011936E-05,   1.6793923E-05
     +,   1.7621835E-05,   1.8498029E-05,   1.9424875E-05
     +,   2.0404763E-05,   2.1440121E-05,   2.2533315E-05
     +,   2.3686767E-05,   2.4902882E-05,   2.6184029E-05
     +,   2.7532573E-05,   2.8950866E-05,   3.0441121E-05
     +,   3.2005621E-05,   3.3646600E-05,   3.5366127E-05
     +,   3.7166315E-05,   3.9049221E-05,   4.1016825E-05
     +,   4.3071072E-05,   4.5213834E-05,   4.7446974E-05
     +,   4.9772359E-05,   5.2191652E-05,   5.4706696E-05
     +,   5.7319317E-05,   6.0031194E-05,   6.2844207E-05
     +,   6.5760243E-05,   6.8781308E-05,   7.1909526E-05
     +,   7.5147174E-05,   7.8496858E-05,   8.1961261E-05
     +,   8.5543667E-05,   8.9247784E-05,   9.3077964E-05
     +,   9.7039054E-05,   1.0113705E-04,   1.0537893E-04
     +,   1.0977298E-04,   1.1432901E-04,   1.1905870E-04
     +,   1.2397543E-04,   1.2909540E-04,   1.3443713E-04
     +,   1.4002220E-04,   1.4587547E-04,   1.5202479E-04
     +,   1.5850191E-04,   1.6534205E-04,   1.7258384E-04
     +,   1.8026918E-04,   1.8844292E-04,   1.9715204E-04
     +,   2.0644540E-04,   2.1637058E-04,   2.2697587E-04
     +,   2.3830589E-04,   2.5040130E-04,   2.6329604E-04
     +,   2.7701570E-04,   2.9157588E-04,   3.0697710E-04
     +,   3.2320753E-04,   3.4023792E-04,   3.5802141E-04
     +,   3.7649297E-04,   3.9556844E-04,   4.1514618E-04
     +,   4.3510794E-04,   4.5532169E-04,   4.7564425E-04
     +,   4.9592636E-04,   5.1601697E-04,   5.3576968E-04
     +,   5.5504846E-04,   5.7373528E-04,   5.9173297E-04
     +,   6.0897716E-04,   6.2543841E-04,   6.4112601E-04
     +,   6.5609365E-04,   6.7043921E-04,   6.8430568E-04
     +,   6.9787586E-04,   7.1137043E-04,   7.2504062E-04
     +,   7.3915860E-04,   7.5400586E-04,   7.6986395E-04
     +,   7.8700209E-04,   8.0566376E-04,   8.2605990E-04
     +,   8.4835681E-04,   8.7267562E-04,   8.9908578E-04
     +,   9.2761312E-04,   9.5823681E-04,   9.9090976E-04
     +,   1.0255619E-03,   1.0621179E-03,   1.1005094E-03
     +,   1.1406875E-03,   1.1826322E-03,   1.2263599E-03
     +,   1.2719169E-03,   1.3193866E-03,   1.3688725E-03
     +,   1.4204880E-03,   1.4743443E-03,   1.5305382E-03
     +,   1.5891383E-03,   1.6501843E-03,   1.7136876E-03
     +,   1.7796397E-03,   1.8480264E-03,   1.9188528E-03
     +,   1.9921446E-03,   2.0679785E-03,   2.1464776E-03
     +,   2.2277969E-03,   2.3121061E-03,   2.3995670E-03
     +,   2.4903149E-03,   2.5844756E-03,   2.6822337E-03
     +,   2.7839807E-03,   2.8905198E-03,   3.0033875E-03
     +,   3.1251565E-03,   3.2596940E-03,   3.4122223E-03
     +,   3.5890490E-03,   3.7968354E-03,   4.0414114E-03
     +,   4.3262239E-03,   4.6507819E-03,   5.0095553E-03
     +,   5.3918082E-03,   5.7826815E-03,   6.1656469E-03
     +,   6.5255980E-03,   6.8518384E-03,   7.1398611E-03
     +,   7.3912512E-03,   7.6118005E-03,   7.8092506E-03
     +,   7.9918718E-03,   8.1697050E-03,   8.3576888E-03
     +,   8.5784392E-03,   8.8617969E-03,   9.2396643E-03
     +,   9.7379610E-03,   1.0370320E-02,   1.1137535E-02
     +,   1.2032959E-02,   1.3048843E-02,   1.4176128E-02
     +,   1.5394959E-02,   1.6657991E-02,   1.7883139E-02
     +,   1.8966807E-02,   1.9821230E-02,   2.0412775E-02
     +,   2.0768935E-02,   2.0948322E-02,   2.1002404E-02
     +,   2.0970674E-02,   2.0911725E-02,   2.0929057E-02
     +,   2.1148998E-02,   2.1653138E-02,   2.2412676E-02
     +,   2.3275511E-02,   2.4016228E-02,   2.4416743E-02
     +,   2.4335215E-02,   2.3741039E-02,   2.2711787E-02
     +,   2.1392610E-02,   1.9932657E-02,   1.8436534E-02
     +,   1.6957790E-02,   1.5525202E-02,   1.4167166E-02
     +,   1.2914052E-02,   1.1788844E-02,   1.0797503E-02
     +,   9.9282097E-03,   9.1571053E-03,   8.4570656E-03
     +,   7.8051868E-03,   7.1858773E-03,   6.5899948E-03
     +,   6.0125478E-03,   5.4512536E-03,   4.9066651E-03
     +,   4.3826322E-03,   3.8859891E-03,   3.4250668E-03
     +,   3.0075591E-03,   2.6387514E-03,   2.3204426E-03
     +,   2.0510759E-03,   1.8264835E-03,   1.6409447E-03
     +,   1.4882184E-03,   1.3622361E-03,   1.2575753E-03
     +,   1.1696434E-03,   1.0947004E-03,   1.0297952E-03
     +,   9.7265828E-04,   9.2158763E-04,   8.7533926E-04
     +,   8.3302509E-04,   7.9402683E-04,   7.5791974E-04
     +,   7.2441204E-04,   6.9329434E-04,   6.6440366E-04
     +,   6.3759659E-04,   6.1273621E-04,   5.8967754E-04
     +,   5.6826655E-04,   5.4834032E-04,   5.2972831E-04
     +,   5.1225902E-04,   4.9575884E-04,   4.8006038E-04
     +,   4.6500456E-04,   4.5044362E-04,   4.3624445E-04
     +,   4.2229000E-04,   4.0848070E-04,   3.9473546E-04
     +,   3.8099216E-04,   3.6720705E-04,   3.5335452E-04
     +,   3.3942558E-04,   3.2542681E-04,   3.1137810E-04
     +,   2.9731283E-04,   2.8327209E-04,   2.6930522E-04
     +,   2.5546682E-04,   2.4181360E-04,   2.2840535E-04
     +,   2.1529871E-04,   2.0254825E-04,   1.9020453E-04
     +,   1.7831234E-04,   1.6691029E-04,   1.5602993E-04
     +,   1.4569533E-04,   1.3592298E-04,   1.2672205E-04
     +,   1.1809447E-04,   1.1003562E-04,   1.0253477E-04
     +,   9.5575844E-05,   8.9138106E-05,   8.3198036E-05
     +,   7.7727484E-05,   7.2697920E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wano_hz_85 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wano_hz_90(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  1.9626480E-06,   2.0417533E-06
     +,   2.1231338E-06,   2.2068111E-06,   2.2927986E-06
     +,   2.3811140E-06,   2.4717697E-06,   2.5647771E-06
     +,   2.6601467E-06,   2.7578787E-06,   2.8579809E-06
     +,   2.9604532E-06,   3.0652950E-06,   3.1725026E-06
     +,   3.2820726E-06,   3.3939925E-06,   3.5082537E-06
     +,   3.6248462E-06,   3.7437549E-06,   3.8649687E-06
     +,   3.9884658E-06,   4.1142321E-06,   4.2422525E-06
     +,   4.3725090E-06,   4.5049915E-06,   4.6396772E-06
     +,   4.7765593E-06,   4.9156315E-06,   5.0568915E-06
     +,   5.2003347E-06,   5.3459753E-06,   5.4938287E-06
     +,   5.6439230E-06,   5.7962961E-06,   5.9510053E-06
     +,   6.1081137E-06,   6.2677068E-06,   6.4298974E-06
     +,   6.5948138E-06,   6.7626220E-06,   6.9335006E-06
     +,   7.1076770E-06,   7.2854104E-06,   7.4670115E-06
     +,   7.6528213E-06,   7.8432486E-06,   8.0387408E-06
     +,   8.2398237E-06,   8.4470894E-06,   8.6611826E-06
     +,   8.8828529E-06,   9.1129223E-06,   9.3523067E-06
     +,   9.6020212E-06,   9.8631854E-06,   1.0137029E-05
     +,   1.0424907E-05,   1.0728286E-05,   1.1048771E-05
     +,   1.1388116E-05,   1.1748187E-05,   1.2131032E-05
     +,   1.2538831E-05,   1.2973933E-05,   1.3438844E-05
     +,   1.3936232E-05,   1.4468946E-05,   1.5039965E-05
     +,   1.5652477E-05,   1.6309807E-05,   1.7015476E-05
     +,   1.7773109E-05,   1.8586526E-05,   1.9459685E-05
     +,   2.0396672E-05,   2.1401709E-05,   2.2479142E-05
     +,   2.3633353E-05,   2.4868883E-05,   2.6190284E-05
     +,   2.7602187E-05,   2.9109262E-05,   3.0716066E-05
     +,   3.2427230E-05,   3.4247321E-05,   3.6180765E-05
     +,   3.8231919E-05,   4.0404968E-05,   4.2703916E-05
     +,   4.5132660E-05,   4.7694521E-05,   5.0392824E-05
     +,   5.3230520E-05,   5.6210167E-05,   5.9333939E-05
     +,   6.2603649E-05,   6.6020752E-05,   6.9585847E-05
     +,   7.3299503E-05,   7.7161683E-05,   8.1171835E-05
     +,   8.5329004E-05,   8.9631838E-05,   9.4078474E-05
     +,   9.8666802E-05,   1.0339447E-04,   1.0825884E-04
     +,   1.1325729E-04,   1.1838718E-04,   1.2364607E-04
     +,   1.2903185E-04,   1.3454320E-04,   1.4017869E-04
     +,   1.4593854E-04,   1.5182394E-04,   1.5783725E-04
     +,   1.6398246E-04,   1.7026528E-04,   1.7669369E-04
     +,   1.8327688E-04,   1.9002720E-04,   1.9695914E-04
     +,   2.0408940E-04,   2.1143742E-04,   2.1902469E-04
     +,   2.2687500E-04,   2.3501390E-04,   2.4346879E-04
     +,   2.5226784E-04,   2.6143980E-04,   2.7101344E-04
     +,   2.8101690E-04,   2.9147521E-04,   3.0241229E-04
     +,   3.1384805E-04,   3.2579829E-04,   3.3827368E-04
     +,   3.5127986E-04,   3.6481745E-04,   3.7888222E-04
     +,   3.9346534E-04,   4.0855762E-04,   4.2415122E-04
     +,   4.4024381E-04,   4.5684370E-04,   4.7397779E-04
     +,   4.9169792E-04,   5.1009044E-04,   5.2928453E-04
     +,   5.4946129E-04,   5.7086075E-04,   5.9378729E-04
     +,   6.1860622E-04,   6.4574642E-04,   6.7568285E-04
     +,   7.0892094E-04,   7.4596913E-04,   7.8730623E-04
     +,   8.3334051E-04,   8.8436680E-04,   9.4052404E-04
     +,   1.0017580E-03,   1.0677769E-03,   1.1380541E-03
     +,   1.2118065E-03,   1.2880238E-03,   1.3654935E-03
     +,   1.4428634E-03,   1.5187076E-03,   1.5916069E-03
     +,   1.6602437E-03,   1.7234843E-03,   1.7804647E-03
     +,   1.8306628E-03,   1.8739521E-03,   1.9106425E-03
     +,   1.9414909E-03,   1.9676962E-03,   1.9908675E-03
     +,   2.0129853E-03,   2.0363447E-03,   2.0635128E-03
     +,   2.0972758E-03,   2.1406137E-03,   2.1966710E-03
     +,   2.2687188E-03,   2.3600652E-03,   2.4738899E-03
     +,   2.6129400E-03,   2.7791022E-03,   2.9728797E-03
     +,   3.1928804E-03,   3.4355377E-03,   3.6951439E-03
     +,   3.9646020E-03,   4.2363396E-03,   4.5037698E-03
     +,   4.7621159E-03,   5.0086919E-03,   5.2422984E-03
     +,   5.4617114E-03,   5.6646913E-03,   5.8476659E-03
     +,   6.0071670E-03,   6.1421883E-03,   6.2564965E-03
     +,   6.3594822E-03,   6.4647440E-03,   6.5868273E-03
     +,   6.7372918E-03,   6.9218399E-03,   7.1393880E-03
     +,   7.3833955E-03,   7.6449676E-03,   7.9168407E-03
     +,   8.1965765E-03,   8.4875552E-03,   8.7954234E-03
     +,   9.1210091E-03,   9.4526326E-03,   9.7637931E-03
     +,   1.0020950E-02,   1.0199635E-02,   1.0301946E-02
     +,   1.0364014E-02,   1.0447206E-02,   1.0615074E-02
     +,   1.0905935E-02,   1.1313753E-02,   1.1786148E-02
     +,   1.2241011E-02,   1.2594845E-02,   1.2789847E-02
     +,   1.2807163E-02,   1.2661004E-02,   1.2380731E-02
     +,   1.1994092E-02,   1.1521609E-02,   1.0981378E-02
     +,   1.0396206E-02,   9.7950576E-03,   9.2076249E-03
     +,   8.6566266E-03,   8.1526088E-03,   7.6938649E-03
     +,   7.2701350E-03,   6.8679545E-03,   6.4753899E-03
     +,   6.0850158E-03,   5.6946529E-03,   5.3063608E-03
     +,   4.9244165E-03,   4.5534405E-03,   4.1972008E-03
     +,   3.8582494E-03,   3.5381804E-03,   3.2381183E-03
     +,   2.9590884E-03,   2.7022143E-03,   2.4684952E-03
     +,   2.2585555E-03,   2.0723552E-03,   1.9089949E-03
     +,   1.7667783E-03,   1.6433437E-03,   1.5359869E-03
     +,   1.4419449E-03,   1.3586557E-03,   1.2839170E-03
     +,   1.2159622E-03,   1.1534661E-03,   1.0954954E-03
     +,   1.0414408E-03,   9.9093630E-04,   9.4379025E-04
     +,   8.9991681E-04,   8.5928559E-04,   8.2187454E-04
     +,   7.8764191E-04,   7.5649499E-04,   7.2827894E-04
     +,   7.0277264E-04,   6.7968859E-04,   6.5868831E-04
     +,   6.3938933E-04,   6.2138954E-04,   6.0428341E-04
     +,   5.8768166E-04,   5.7122717E-04,   5.5460882E-04
     +,   5.3757057E-04,   5.1991735E-04,   5.0151761E-04
     +,   4.8230140E-04,   4.6225666E-04,   4.4142382E-04
     +,   4.1988725E-04,   3.9776659E-04,   3.7521284E-04
     +,   3.5238868E-04,   3.2947480E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wano_hz_90 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wano_hz_95(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  2.4014230E-06,   2.4739225E-06
     +,   2.5478737E-06,   2.6232792E-06,   2.7001329E-06
     +,   2.7784347E-06,   2.8581790E-06,   2.9393623E-06
     +,   3.0219780E-06,   3.1060147E-06,   3.1914649E-06
     +,   3.2783169E-06,   3.3665588E-06,   3.4561770E-06
     +,   3.5471585E-06,   3.6394824E-06,   3.7331340E-06
     +,   3.8280937E-06,   3.9243423E-06,   4.0218606E-06
     +,   4.1206222E-06,   4.2206061E-06,   4.3217892E-06
     +,   4.4241465E-06,   4.5276561E-06,   4.6322880E-06
     +,   4.7380195E-06,   4.8448255E-06,   4.9526843E-06
     +,   5.0615668E-06,   5.1714505E-06,   5.2823166E-06
     +,   5.3941421E-06,   5.5069099E-06,   5.6206068E-06
     +,   5.7352149E-06,   5.8507276E-06,   5.9671383E-06
     +,   6.0844459E-06,   6.2026597E-06,   6.3217817E-06
     +,   6.4418318E-06,   6.5628360E-06,   6.6848233E-06
     +,   6.8078375E-06,   6.9319294E-06,   7.0571582E-06
     +,   7.1835984E-06,   7.3113401E-06,   7.4404793E-06
     +,   7.5711341E-06,   7.7034365E-06,   7.8375342E-06
     +,   7.9735983E-06,   8.1118187E-06,   8.2524057E-06
     +,   8.3955947E-06,   8.5416405E-06,   8.6908312E-06
     +,   8.8434863E-06,   8.9999403E-06,   9.1605752E-06
     +,   9.3258004E-06,   9.4960660E-06,   9.6718559E-06
     +,   9.8537012E-06,   1.0042182E-05,   1.0237912E-05
     +,   1.0441569E-05,   1.0653890E-05,   1.0875669E-05
     +,   1.1107762E-05,   1.1351105E-05,   1.1606714E-05
     +,   1.1875693E-05,   1.2159233E-05,   1.2458650E-05
     +,   1.2775347E-05,   1.3110882E-05,   1.3466942E-05
     +,   1.3845374E-05,   1.4248197E-05,   1.4677598E-05
     +,   1.5135998E-05,   1.5626034E-05,   1.6150576E-05
     +,   1.6712776E-05,   1.7316072E-05,   1.7964201E-05
     +,   1.8661276E-05,   1.9411671E-05,   2.0220214E-05
     +,   2.1092101E-05,   2.2032942E-05,   2.3048755E-05
     +,   2.4145995E-05,   2.5331603E-05,   2.6612792E-05
     +,   2.7997330E-05,   2.9493356E-05,   3.1109350E-05
     +,   3.2854157E-05,   3.4736862E-05,   3.6766796E-05
     +,   3.8953407E-05,   4.1306197E-05,   4.3834607E-05
     +,   4.6547910E-05,   4.9455084E-05,   5.2564650E-05
     +,   5.5884506E-05,   5.9422015E-05,   6.3183084E-05
     +,   6.7173023E-05,   7.1395698E-05,   7.5853590E-05
     +,   8.0547587E-05,   8.5476888E-05,   9.0639034E-05
     +,   9.6029034E-05,   1.0164065E-04,   1.0746527E-04
     +,   1.1349251E-04,   1.1971000E-04,   1.2610371E-04
     +,   1.3265789E-04,   1.3935573E-04,   1.4617918E-04
     +,   1.5310971E-04,   1.6012853E-04,   1.6721712E-04
     +,   1.7435815E-04,   1.8153459E-04,   1.8873251E-04
     +,   1.9594000E-04,   2.0314855E-04,   2.1035319E-04
     +,   2.1755353E-04,   2.2475370E-04,   2.3196361E-04
     +,   2.3919746E-04,   2.4647627E-04,   2.5382653E-04
     +,   2.6127996E-04,   2.6887379E-04,   2.7664992E-04
     +,   2.8465418E-04,   2.9293555E-04,   3.0154499E-04
     +,   3.1053403E-04,   3.1995369E-04,   3.2985333E-04
     +,   3.4027683E-04,   3.5126490E-04,   3.6285081E-04
     +,   3.7506034E-04,   3.8791049E-04,   4.0140960E-04
     +,   4.1555625E-04,   4.3034082E-04,   4.4574519E-04
     +,   4.6174615E-04,   4.7831397E-04,   4.9541908E-04
     +,   5.1303266E-04,   5.3112995E-04,   5.4969435E-04
     +,   5.6872022E-04,   5.8821501E-04,   6.0820347E-04
     +,   6.2872685E-04,   6.4984401E-04,   6.7163218E-04
     +,   6.9418253E-04,   7.1759528E-04,   7.4197928E-04
     +,   7.6744205E-04,   7.9408538E-04,   8.2199695E-04
     +,   8.5124618E-04,   8.8187080E-04,   9.1389049E-04
     +,   9.4728218E-04,   9.8199677E-04,   1.0179544E-03
     +,   1.0550468E-03,   1.0931429E-03,   1.1320893E-03
     +,   1.1717128E-03,   1.2118199E-03,   1.2521920E-03
     +,   1.2925823E-03,   1.3327089E-03,   1.3722419E-03
     +,   1.4108212E-03,   1.4480365E-03,   1.4834660E-03
     +,   1.5166855E-03,   1.5473037E-03,   1.5750269E-03
     +,   1.5996780E-03,   1.6212708E-03,   1.6400227E-03
     +,   1.6563934E-03,   1.6710705E-03,   1.6849408E-03
     +,   1.6990391E-03,   1.7144734E-03,   1.7323360E-03
     +,   1.7536283E-03,   1.7791865E-03,   1.8096463E-03
     +,   1.8454273E-03,   1.8867536E-03,   1.9336967E-03
     +,   1.9862161E-03,   2.0442239E-03,   2.1075762E-03
     +,   2.1760797E-03,   2.2494360E-03,   2.3271476E-03
     +,   2.4084817E-03,   2.4923491E-03,   2.5773565E-03
     +,   2.6618566E-03,   2.7441308E-03,   2.8226520E-03
     +,   2.8963971E-03,   2.9651662E-03,   3.0298026E-03
     +,   3.0922825E-03,   3.1555376E-03,   3.2230739E-03
     +,   3.2983259E-03,   3.3839080E-03,   3.4809003E-03
     +,   3.5883628E-03,   3.7032480E-03,   3.8208540E-03
     +,   3.9357208E-03,   4.0428415E-03,   4.1388855E-03
     +,   4.2231446E-03,   4.2979633E-03,   4.3685180E-03
     +,   4.4420082E-03,   4.5264205E-03,   4.6290872E-03
     +,   4.7553023E-03,   4.9073962E-03,   5.0845342E-03
     +,   5.2835215E-03,   5.5004992E-03,   5.7329191E-03
     +,   5.9810281E-03,   6.2478562E-03,   6.5374197E-03
     +,   6.8515129E-03,   7.1864459E-03,   7.5312778E-03
     +,   7.8685172E-03,   8.1771826E-03,   8.4373001E-03
     +,   8.6341091E-03,   8.7607419E-03,   8.8185286E-03
     +,   8.8149877E-03,   8.7601086E-03,   8.6621484E-03
     +,   8.5245566E-03,   8.3454307E-03,   8.1200348E-03
     +,   7.8453748E-03,   7.5245337E-03,   7.1686883E-03
     +,   6.7956056E-03,   6.4252727E-03,   6.0746274E-03
     +,   5.7535567E-03,   5.4632956E-03,   5.1976922E-03
     +,   4.9462286E-03,   4.6976064E-03,   4.4428166E-03
     +,   4.1768118E-03,   3.8988939E-03,   3.6119439E-03
     +,   3.3210551E-03,   3.0320922E-03,   2.7505560E-03
     +,   2.4808962E-03,   2.2262556E-03,   1.9885565E-03
     +,   1.7687210E-03,   1.5669384E-03,   1.3828911E-03
     +,   1.2159164E-03,   1.0651171E-03,   9.2947081E-04
     +,   8.0783083E-04,   6.9906854E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wano_hz_95 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wano_qq(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   1.3875467E-38
     +,   2.9449313E-38,   6.2276215E-38,   1.3121059E-37
     +,   2.7543880E-37,   5.7609079E-37,   1.2005114E-36
     +,   2.4925924E-36,   5.1564684E-36,   1.0628038E-35
     +,   2.1825627E-35,   4.4657039E-35,   9.1038002E-35
     +,   1.8491056E-34,   3.7420563E-34,   7.5451024E-34
     +,   1.5157684E-33,   3.0339388E-33,   6.0505339E-33
     +,   1.2022461E-32,   2.3801048E-32,   4.6946873E-32
     +,   9.2264587E-32,   1.8066116E-31,   3.5245665E-31
     +,   6.8510096E-31,   1.3268179E-30,   2.5602316E-30
     +,   4.9221533E-30,   9.4286368E-30,   1.7994604E-29
     +,   3.4217254E-29,   6.4827253E-29,   1.2237320E-28
     +,   2.3015371E-28,   4.3127821E-28,   8.0520834E-28
     +,   1.4978452E-27,   2.7761005E-27,   5.1264646E-27
     +,   9.4319969E-27,   1.7290221E-26,   3.1579513E-26
     +,   5.7466736E-26,   1.0419505E-25,   1.8822571E-25
     +,   3.3878075E-25,   6.0753284E-25,   1.0855014E-24
     +,   1.9324008E-24,   3.4274827E-24,   6.0570736E-24
     +,   1.0665224E-23,   1.8710056E-23,   3.2703037E-23
     +,   5.6952438E-23,   9.8820284E-23,   1.7083930E-22
     +,   2.9426534E-22,   5.0502148E-22,   8.6353566E-22
     +,   1.4711554E-21,   2.4971508E-21,   4.2232062E-21
     +,   7.1162178E-21,   1.1947146E-20,   1.9984288E-20
     +,   3.3305891E-20,   5.5305031E-20,   9.1498971E-20
     +,   1.5082580E-19,   2.4771250E-19,   4.0534657E-19
     +,   6.6086789E-19,   1.0735501E-18,   1.7375189E-18
     +,   2.8018489E-18,   4.5016352E-18,   7.2061717E-18
     +,   1.1493398E-17,   1.8264217E-17,   2.8918218E-17
     +,   4.5618653E-17,   7.1700631E-17,   1.1228252E-16
     +,   1.7519033E-16,   2.7234388E-16,   4.2182736E-16
     +,   6.5096933E-16,   1.0009120E-15,   1.5333457E-15
     +,   2.3404200E-15,   3.5592244E-15,   5.3929626E-15
     +,   8.1417247E-15,   1.2246351E-14,   1.8352980E-14
     +,   2.7404025E-14,   4.0769153E-14,   6.0430841E-14
     +,   8.9247125E-14,   1.3132261E-13,   1.9253110E-13
     +,   2.8123182E-13,   4.0929524E-13,   5.9349699E-13
     +,   8.5745067E-13,   1.2342672E-12,   1.7701863E-12
     +,   2.5295111E-12,   3.6013438E-12,   5.1085837E-12
     +,   7.2201607E-12,   1.0167205E-11,   1.4265021E-11
     +,   1.9940933E-11,   2.7773358E-11,   3.8540719E-11
     +,   5.3286934E-11,   7.3405892E-11,   1.0075121E-10
     +,   1.3777754E-10,   1.8772245E-10,   2.5483771E-10
     +,   3.4468772E-10,   4.6450621E-10,   6.2368677E-10
     +,   8.3435520E-10,   1.1121025E-09,   1.4768901E-09
     +,   1.9541668E-09,   2.5762255E-09,   3.3838943E-09
     +,   4.4285269E-09,   5.7744676E-09,   7.5019626E-09
     +,   9.7107744E-09,   1.2523865E-08,   1.6092894E-08
     +,   2.0603546E-08,   2.6282192E-08,   3.3403669E-08
     +,   4.2300424E-08,   5.3370385E-08,   6.7093445E-08
     +,   8.4037225E-08,   1.0487715E-07,   1.3040942E-07
     +,   1.6156883E-07,   1.9944780E-07,   2.4531582E-07
     +,   3.0064177E-07,   3.6711592E-07,   4.4667451E-07
     +,   5.4152264E-07,   6.5416481E-07,   7.8740345E-07
     +,   9.4442265E-07,   1.1287202E-06,   1.3442444E-06
     +,   1.5952987E-06,   1.8865993E-06,   2.2233803E-06
     +,   2.6112041E-06,   3.0562219E-06,   3.5649073E-06
     +,   4.1442586E-06,   4.8016973E-06,   5.5450646E-06
     +,   6.3826110E-06,   7.3229562E-06,   8.3750747E-06
     +,   9.5482301E-06,   1.0851964E-05,   1.2296010E-05
     +,   1.3890256E-05,   1.5644657E-05,   1.7569262E-05
     +,   1.9673658E-05,   2.1967888E-05,   2.4460973E-05
     +,   2.7161870E-05,   3.0078952E-05,   3.3219210E-05
     +,   3.6589558E-05,   4.0194631E-05,   4.4038065E-05
     +,   4.8121485E-05,   5.2444295E-05,   5.7003326E-05
     +,   6.1792489E-05,   6.6802320E-05,   7.2019699E-05
     +,   7.7427387E-05,   8.3003826E-05,   8.8722758E-05
     +,   9.4553099E-05,   1.0045883E-04,   1.0639903E-04
     +,   1.1232827E-04,   1.1819589E-04,   1.2394811E-04
     +,   1.2952757E-04,   1.3487446E-04,   1.3992778E-04
     +,   1.4462572E-04,   1.4890831E-04,   1.5271820E-04
     +,   1.5600266E-04,   1.5871535E-04,   1.6081858E-04
     +,   1.6228556E-04,   1.6310281E-04,   1.6327275E-04
     +,   1.6281632E-04,   1.6177612E-04,   1.6021886E-04
     +,   1.5823878E-04,   1.5595974E-04,   1.5353817E-04
     +,   1.5116457E-04,   1.4906591E-04,   1.4750562E-04
     +,   1.4678431E-04,   1.4723958E-04,   1.4924545E-04
     +,   1.5321148E-04,   1.5958227E-04,   1.6883745E-04
     +,   1.8149175E-04,   1.9809607E-04,   2.1923741E-04
     +,   2.4553898E-04,   2.7765738E-04,   3.1627566E-04
     +,   3.6209114E-04,   4.1579496E-04,   4.7804209E-04
     +,   5.4941070E-04,   6.3035026E-04,   7.2112423E-04
     +,   8.2172279E-04,   9.3181490E-04,   1.0506598E-03
     +,   1.1770488E-03,   1.3092655E-03,   1.4450434E-03
     +,   1.5816140E-03,   1.7157369E-03,   1.8438011E-03
     +,   1.9619612E-03,   2.0663121E-03,   2.1530893E-03
     +,   2.2188826E-03,   2.2608463E-03,   2.2768895E-03
     +,   2.2658287E-03,   2.2274840E-03,   2.1627201E-03
     +,   2.0734109E-03,   1.9623407E-03,   1.8330743E-03
     +,   1.6896944E-03,   1.5366536E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wano_qq = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wano_ww(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  3.0125062E-09,   3.4297745E-09
     +,   3.9007082E-09,   4.4316253E-09,   5.0294657E-09
     +,   5.7019176E-09,   6.4574448E-09,   7.3053421E-09
     +,   8.2558635E-09,   9.3201580E-09,   1.0510529E-08
     +,   1.1840397E-08,   1.3324434E-08,   1.4978600E-08
     +,   1.6820366E-08,   1.8868574E-08,   2.1143801E-08
     +,   2.3668324E-08,   2.6466244E-08,   2.9563685E-08
     +,   3.2988648E-08,   3.6771457E-08,   4.0944673E-08
     +,   4.5543302E-08,   5.0605006E-08,   5.6169682E-08
     +,   6.2280286E-08,   6.8982686E-08,   7.6325691E-08
     +,   8.4360963E-08,   9.3143541E-08,   1.0273173E-07
     +,   1.1318721E-07,   1.2457495E-07,   1.3696383E-07
     +,   1.5042539E-07,   1.6503552E-07,   1.8087347E-07
     +,   1.9802209E-07,   2.1656817E-07,   2.3660081E-07
     +,   2.5821387E-07,   2.8150430E-07,   3.0657208E-07
     +,   3.3352063E-07,   3.6245700E-07,   3.9348907E-07
     +,   4.2672934E-07,   4.6229289E-07,   5.0029485E-07
     +,   5.4085410E-07,   5.8409086E-07,   6.3012646E-07
     +,   6.7908309E-07,   7.3108379E-07,   7.8625186E-07
     +,   8.4471156E-07,   9.0658313E-07,   9.7199018E-07
     +,   1.0410550E-06,   1.1138942E-06,   1.1906272E-06
     +,   1.2713701E-06,   1.3562370E-06,   1.4453400E-06
     +,   1.5387897E-06,   1.6366953E-06,   1.7391594E-06
     +,   1.8462889E-06,   1.9581876E-06,   2.0749619E-06
     +,   2.1967107E-06,   2.3235425E-06,   2.4555645E-06
     +,   2.5928914E-06,   2.7356389E-06,   2.8839388E-06
     +,   3.0379190E-06,   3.1977311E-06,   3.3635376E-06
     +,   3.5355190E-06,   3.7138821E-06,   3.8988414E-06
     +,   4.0906552E-06,   4.2896067E-06,   4.4960143E-06
     +,   4.7102358E-06,   4.9326704E-06,   5.1637639E-06
     +,   5.4040247E-06,   5.6539798E-06,   5.9142476E-06
     +,   6.1854930E-06,   6.4684486E-06,   6.7639071E-06
     +,   7.0727283E-06,   7.3958540E-06,   7.7342493E-06
     +,   8.0889877E-06,   8.4611911E-06,   8.8520428E-06
     +,   9.2627852E-06,   9.6947024E-06,   1.0149133E-05
     +,   1.0627442E-05,   1.1131028E-05,   1.1661297E-05
     +,   1.2219665E-05,   1.2807531E-05,   1.3426269E-05
     +,   1.4077216E-05,   1.4761679E-05,   1.5480793E-05
     +,   1.6235696E-05,   1.7027376E-05,   1.7856697E-05
     +,   1.8724366E-05,   1.9630916E-05,   2.0576748E-05
     +,   2.1561920E-05,   2.2586393E-05,   2.3649862E-05
     +,   2.4751756E-05,   2.5891250E-05,   2.7067255E-05
     +,   2.8278400E-05,   2.9523020E-05,   3.0799183E-05
     +,   3.2104657E-05,   3.3436940E-05,   3.4793240E-05
     +,   3.6170572E-05,   3.7565504E-05,   3.8974529E-05
     +,   4.0393872E-05,   4.1819527E-05,   4.3247306E-05
     +,   4.4672830E-05,   4.6091594E-05,   4.7499005E-05
     +,   4.8890193E-05,   5.0260413E-05,   5.1604791E-05
     +,   5.2918454E-05,   5.4196531E-05,   5.5434219E-05
     +,   5.6626799E-05,   5.7769666E-05,   5.8858404E-05
     +,   5.9888800E-05,   6.0856906E-05,   6.1759136E-05
     +,   6.2592153E-05,   6.3353196E-05,   6.4039916E-05
     +,   6.4650601E-05,   6.5184169E-05,   6.5640226E-05
     +,   6.6019245E-05,   6.6322566E-05,   6.6552529E-05
     +,   6.6712615E-05,   6.6807421E-05,   6.6842942E-05
     +,   6.6826644E-05,   6.6767527E-05,   6.6676475E-05
     +,   6.6566310E-05,   6.6452165E-05,   6.6351618E-05
     +,   6.6285196E-05,   6.6276618E-05,   6.6353299E-05
     +,   6.6546760E-05,   6.6893081E-05,   6.7433437E-05
     +,   6.8214453E-05,   6.9288559E-05,   7.0714130E-05
     +,   7.2555602E-05,   7.4882584E-05,   7.7770324E-05
     +,   8.1296959E-05,   8.5543244E-05,   9.0589710E-05
     +,   9.6514050E-05,   1.0338786E-04,   1.1127301E-04
     +,   1.2021747E-04,   1.3025137E-04,   1.4138254E-04
     +,   1.5359293E-04,   1.6683595E-04,   1.8103067E-04
     +,   1.9606753E-04,   2.1179854E-04,   2.2804929E-04
     +,   2.4461193E-04,   2.6125353E-04,   2.7772659E-04
     +,   2.9376519E-04,   3.0910494E-04,   3.2348098E-04
     +,   3.3664468E-04,   3.4836959E-04,   3.5846126E-04
     +,   3.6676551E-04,   3.7317598E-04,   3.7763972E-04
     +,   3.8016244E-04,   3.8080930E-04,   3.7970659E-04
     +,   3.7703844E-04,   3.7304265E-04,   3.6800426E-04
     +,   3.6224924E-04,   3.5613307E-04,   3.5003564E-04
     +,   3.4434954E-04,   3.3947357E-04,   3.3580564E-04
     +,   3.3373330E-04,   3.3362812E-04,   3.3583408E-04
     +,   3.4065661E-04,   3.4834698E-04,   3.5908425E-04
     +,   3.7295534E-04,   3.8993527E-04,   4.0987029E-04
     +,   4.3246668E-04,   4.5729103E-04,   4.8378136E-04
     +,   5.1127281E-04,   5.3903711E-04,   5.6633056E-04
     +,   5.9244974E-04,   6.1677711E-04,   6.3883403E-04
     +,   6.5830362E-04,   6.7504053E-04,   6.8906473E-04
     +,   7.0052949E-04,   7.0968736E-04,   7.1683945E-04
     +,   7.2229595E-04,   7.2633725E-04,   7.2919205E-04
     +,   7.3102699E-04,   7.3194760E-04,   7.3200662E-04
     +,   7.3121971E-04,   7.2957593E-04,   7.2705129E-04
     +,   7.2361657E-04,   7.1924535E-04,   7.1392133E-04
     +,   7.0764706E-04,   7.0045417E-04,   6.9241121E-04
     +,   6.8363093E-04,   6.7426969E-04,   6.6452043E-04
     +,   6.5459631E-04,   6.4470695E-04,   6.3503336E-04
     +,   6.2570319E-04,   6.1677326E-04,   6.0822064E-04
     +,   5.9994642E-04,   5.9178966E-04,   5.8355008E-04
     +,   5.7501299E-04,   5.6597654E-04,   5.5627106E-04
     +,   5.4577389E-04,   5.3441385E-04,   5.2216795E-04
     +,   5.0905475E-04,   4.9511890E-04,   4.8042004E-04
     +,   4.6502176E-04,   4.4898273E-04,   4.3235562E-04
     +,   4.1518357E-04,   3.9750617E-04,   3.7936389E-04
     +,   3.6080403E-04,   3.4188491E-04,   3.2268025E-04
     +,   3.0327972E-04,   2.8378802E-04,   2.6432268E-04
     +,   2.4500935E-04,   2.2597758E-04,   2.0735549E-04
     +,   1.8926535E-04,   1.7181892E-04,   1.5511816E-04
     +,   1.3924492E-04,   1.2427023E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wano_ww = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wao_fus_100(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  9.4997080E-11,   1.1050760E-10
     +,   1.2845074E-10,   1.4919115E-10,   1.7314460E-10
     +,   2.0078648E-10,   2.3265864E-10,   2.6937813E-10
     +,   3.1164815E-10,   3.6026512E-10,   4.1613657E-10
     +,   4.8029147E-10,   5.5389582E-10,   6.3827049E-10
     +,   7.3491269E-10,   8.4550583E-10,   9.7195962E-10
     +,   1.1164252E-09,   1.2813265E-09,   1.4693976E-09
     +,   1.6836972E-09,   1.9276785E-09,   2.2052085E-09
     +,   2.5206279E-09,   2.8787981E-09,   3.2851419E-09
     +,   3.7457415E-09,   4.2673678E-09,   4.8576028E-09
     +,   5.5248401E-09,   6.2784600E-09,   7.1288815E-09
     +,   8.0876656E-09,   9.1676382E-09,   1.0383036E-08
     +,   1.1749510E-08,   1.3284470E-08,   1.5007092E-08
     +,   1.6938515E-08,   1.9102073E-08,   2.1523302E-08
     +,   2.4230378E-08,   2.7254185E-08,   3.0628588E-08
     +,   3.4390627E-08,   3.8580929E-08,   4.3243539E-08
     +,   4.8426777E-08,   5.4183332E-08,   6.0570137E-08
     +,   6.7649360E-08,   7.5488401E-08,   8.4160206E-08
     +,   9.3743729E-08,   1.0432442E-07,   1.1599417E-07
     +,   1.2885261E-07,   1.4300582E-07,   1.5856882E-07
     +,   1.7566499E-07,   1.9442540E-07,   2.1499146E-07
     +,   2.3751377E-07,   2.6215287E-07,   2.8907974E-07
     +,   3.1847634E-07,   3.5053620E-07,   3.8546244E-07
     +,   4.2347210E-07,   4.6479363E-07,   5.0966901E-07
     +,   5.5834954E-07,   6.1110262E-07,   6.6820758E-07
     +,   7.2995647E-07,   7.9665500E-07,   8.6862292E-07
     +,   9.4618849E-07,   1.0296973E-06,   1.1195058E-06
     +,   1.2159823E-06,   1.3195094E-06,   1.4304742E-06
     +,   1.5492802E-06,   1.6763395E-06,   1.8120714E-06
     +,   1.9569047E-06,   2.1112744E-06,   2.2756205E-06
     +,   2.4503963E-06,   2.6360328E-06,   2.8329873E-06
     +,   3.0417073E-06,   3.2626392E-06,   3.4962243E-06
     +,   3.7428993E-06,   4.0031014E-06,   4.2772267E-06
     +,   4.5656884E-06,   4.8688767E-06,   5.1871630E-06
     +,   5.5208980E-06,   5.8704104E-06,   6.2360054E-06
     +,   6.6179578E-06,   7.0165129E-06,   7.4318864E-06
     +,   7.8642533E-06,   8.3137575E-06,   8.7804992E-06
     +,   9.2645378E-06,   9.7659113E-06,   1.0284544E-05
     +,   1.0820383E-05,   1.1373299E-05,   1.1943117E-05
     +,   1.2529608E-05,   1.3132495E-05,   1.3751473E-05
     +,   1.4386101E-05,   1.5035972E-05,   1.5700600E-05
     +,   1.6379443E-05,   1.7071923E-05,   1.7777398E-05
     +,   1.8495195E-05,   1.9224584E-05,   1.9964817E-05
     +,   2.0715088E-05,   2.1474576E-05,   2.2242424E-05
     +,   2.3017790E-05,   2.3799721E-05,   2.4587338E-05
     +,   2.5379737E-05,   2.6176027E-05,   2.6975309E-05
     +,   2.7776721E-05,   2.8579419E-05,   2.9382651E-05
     +,   3.0185591E-05,   3.0987598E-05,   3.1788055E-05
     +,   3.2586453E-05,   3.3382381E-05,   3.4175551E-05
     +,   3.4965811E-05,   3.5753164E-05,   3.6537811E-05
     +,   3.7320147E-05,   3.8100796E-05,   3.8880687E-05
     +,   3.9660928E-05,   4.0443083E-05,   4.1229025E-05
     +,   4.2021074E-05,   4.2821994E-05,   4.3635100E-05
     +,   4.4464308E-05,   4.5314202E-05,   4.6190129E-05
     +,   4.7098332E-05,   4.8045909E-05,   4.9041151E-05
     +,   5.0093531E-05,   5.1213916E-05,   5.2414682E-05
     +,   5.3709882E-05,   5.5115481E-05,   5.6649475E-05
     +,   5.8332178E-05,   6.0186296E-05,   6.2237261E-05
     +,   6.4513413E-05,   6.7045825E-05,   6.9869035E-05
     +,   7.3020761E-05,   7.6542172E-05,   8.0477788E-05
     +,   8.4875763E-05,   8.9786736E-05,   9.5265947E-05
     +,   1.0136994E-04,   1.0815873E-04,   1.1569414E-04
     +,   1.2403962E-04,   1.3325972E-04,   1.4341943E-04
     +,   1.5458406E-04,   1.6681865E-04,   1.8018798E-04
     +,   1.9475710E-04,   2.1059245E-04,   2.2775902E-04
     +,   2.4633048E-04,   2.6637886E-04,   2.8798927E-04
     +,   3.1124929E-04,   3.3625370E-04,   3.6311179E-04
     +,   3.9192784E-04,   4.2281565E-04,   4.5587259E-04
     +,   4.9118459E-04,   5.2880973E-04,   5.6876964E-04
     +,   6.1104365E-04,   6.5557042E-04,   7.0225744E-04
     +,   7.5100519E-04,   8.0174801E-04,   8.5450703E-04
     +,   9.0945867E-04,   9.6700242E-04,   1.0278312E-03
     +,   1.0929571E-03,   1.1637517E-03,   1.2418613E-03
     +,   1.3291446E-03,   1.4275230E-03,   1.5387862E-03
     +,   1.6644771E-03,   1.8056732E-03,   1.9629393E-03
     +,   2.1362281E-03,   2.3248096E-03,   2.5271778E-03
     +,   2.7409249E-03,   2.9626701E-03,   3.1881628E-03
     +,   3.4127207E-03,   3.6320304E-03,   3.8431808E-03
     +,   4.0456061E-03,   4.2414865E-03,   4.4352892E-03
     +,   4.6324469E-03,   4.8374897E-03,   5.0525055E-03
     +,   5.2763573E-03,   5.5053295E-03,   5.7348306E-03
     +,   5.9613655E-03,   6.1837500E-03,   6.4024711E-03
     +,   6.6174413E-03,   6.8251411E-03,   7.0169116E-03
     +,   7.1800975E-03,   7.3026875E-03,   7.3804990E-03
     +,   7.4240826E-03,   7.4608987E-03,   7.5294105E-03
     +,   7.6652826E-03,   7.8859273E-03,   8.1829298E-03
     +,   8.5283536E-03,   8.8912984E-03,   9.2517994E-03
     +,   9.6002333E-03,   9.9236956E-03,   1.0194764E-02
     +,   1.0378587E-02,   1.0457544E-02,   1.0453259E-02
     +,   1.0424838E-02,   1.0441368E-02,   1.0547202E-02
     +,   1.0743008E-02,   1.0993058E-02,   1.1254076E-02
     +,   1.1508970E-02,   1.1783444E-02,   1.2131076E-02
     +,   1.2592396E-02,   1.3152477E-02,   1.3724462E-02
     +,   1.4174130E-02,   1.4385427E-02,   1.4340091E-02
     +,   1.4155352E-02,   1.4031924E-02,   1.4136406E-02
     +,   1.4511403E-02,   1.5081287E-02,   1.5719786E-02
     +,   1.6296968E-02,   1.6677950E-02,   1.6717119E-02
     +,   1.6286626E-02,   1.5325163E-02,   1.3867109E-02
     +,   1.2034807E-02,   1.0004015E-02,   7.9613114E-03
     +,   6.0669244E-03,   4.4306214E-03,   3.1044162E-03
     +,   2.0891384E-03,   1.3512857E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wao_fus_100 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wao_fus_105(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  4.3642566E-29,   7.5977280E-29
     +,   1.3189286E-28,   2.2831071E-28,   3.9408244E-28
     +,   6.7828205E-28,   1.1641154E-27,   1.9922439E-27
     +,   3.3998237E-27,   5.7853021E-27,   9.8165728E-27
     +,   1.6609357E-26,   2.8022691E-26,   4.7144133E-26
     +,   7.9088421E-26,   1.3229820E-25,   2.2067721E-25
     +,   3.6704842E-25,   6.0876564E-25,   1.0068063E-24
     +,   1.6603420E-24,   2.7302971E-24,   4.4769935E-24
     +,   7.3201851E-24,   1.1935074E-23,   1.9403822E-23
     +,   3.1456485E-23,   5.0850353E-23,   8.1968151E-23
     +,   1.3175095E-22,   2.1116643E-22,   3.3748676E-22
     +,   5.3783744E-22,   8.5468518E-22,   1.3543480E-21
     +,   2.1399746E-21,   3.3717164E-21,   5.2972966E-21
     +,   8.2988882E-21,   1.2964369E-20,   2.0194907E-20
     +,   3.1368340E-20,   4.8585348E-20,   7.5037767E-20
     +,   1.1556250E-19,   1.7746785E-19,   2.7175752E-19
     +,   4.1495810E-19,   6.3181782E-19,   9.5926502E-19
     +,   1.4522686E-18,   2.1923897E-18,   3.3002691E-18
     +,   4.9538556E-18,   7.4148073E-18,   1.1066673E-17
     +,   1.6470281E-17,   2.4442310E-17,   3.6169796E-17
     +,   5.3372155E-17,   7.8531409E-17,   1.1522086E-16
     +,   1.6857106E-16,   2.4592151E-16,   3.5774275E-16
     +,   5.1892859E-16,   7.5060259E-16,   1.0826051E-15
     +,   1.5570168E-15,   2.2329413E-15,   3.1932134E-15
     +,   4.5533942E-15,   6.4744933E-15,   9.1799008E-15
     +,   1.2978717E-14,   1.8297345E-14,   2.5722271E-14
     +,   3.6056942E-14,   5.0399951E-14,   7.0247973E-14
     +,   9.7633754E-14,   1.3531014E-13,   1.8699063E-13
     +,   2.5767428E-13,   3.5406649E-13,   4.8513157E-13
     +,   6.6282320E-13,   9.0302055E-13,   1.2267594E-12
     +,   1.6618387E-12,   2.2447853E-12,   3.0235953E-12
     +,   4.0610102E-12,   5.4388508E-12,   7.2634485E-12
     +,   9.6725596E-12,   1.2844248E-11,   1.7007189E-11
     +,   2.2455340E-11,   2.9564538E-11,   3.8813713E-11
     +,   5.0811719E-11,   6.6329546E-11,   8.6340539E-11
     +,   1.1206964E-10,   1.4505318E-10,   1.8721164E-10
     +,   2.4093832E-10,   3.0920555E-10,   3.9569281E-10
     +,   5.0493892E-10,   6.4253491E-10,   8.1530999E-10
     +,   1.0316300E-09,   1.3016732E-09,   1.6377961E-09
     +,   2.0549407E-09,   2.5711273E-09,   3.2080429E-09
     +,   3.9915711E-09,   4.9527160E-09,   6.1283485E-09
     +,   7.5622077E-09,   9.3060413E-09,   1.1420850E-08
     +,   1.3978381E-08,   1.7062678E-08,   2.0771994E-08
     +,   2.5220832E-08,   3.0542257E-08,   3.6890473E-08
     +,   4.4444178E-08,   5.3408343E-08,   6.4019865E-08
     +,   7.6550414E-08,   9.1311215E-08,   1.0865809E-07
     +,   1.2899714E-07,   1.5279129E-07,   1.8056849E-07
     +,   2.1292435E-07,   2.5053913E-07,   2.9418220E-07
     +,   3.4472464E-07,   4.0315166E-07,   4.7057708E-07
     +,   5.4825711E-07,   6.3760984E-07,   7.4023234E-07
     +,   8.5792266E-07,   9.9270255E-07,   1.1468495E-06
     +,   1.3228959E-06,   1.5236992E-06,   1.7524458E-06
     +,   2.0126927E-06,   2.3083992E-06,   2.6439645E-06
     +,   3.0242661E-06,   3.4546965E-06,   3.9411980E-06
     +,   4.4903372E-06,   5.1092284E-06,   5.8057294E-06
     +,   6.5883783E-06,   7.4664472E-06,   8.4499907E-06
     +,   9.5498599E-06,   1.0777751E-05,   1.2146234E-05
     +,   1.3668783E-05,   1.5359827E-05,   1.7234777E-05
     +,   1.9310197E-05,   2.1603473E-05,   2.4133464E-05
     +,   2.6920250E-05,   2.9985358E-05,   3.3351964E-05
     +,   3.7045302E-05,   4.1092120E-05,   4.5523098E-05
     +,   5.0370763E-05,   5.5672252E-05,   6.1469218E-05
     +,   6.7808978E-05,   7.4745636E-05,   8.2341503E-05
     +,   9.0668233E-05,   9.9808334E-05,   1.0985629E-04
     +,   1.2091945E-04,   1.3311858E-04,   1.4658489E-04
     +,   1.6146456E-04,   1.7790656E-04,   1.9606976E-04
     +,   2.1610761E-04,   2.3816599E-04,   2.6238558E-04
     +,   2.8888340E-04,   3.1777116E-04,   3.4914332E-04
     +,   3.8310478E-04,   4.1978696E-04,   4.5938202E-04
     +,   5.0218281E-04,   5.4862612E-04,   5.9933198E-04
     +,   6.5512647E-04,   7.1703532E-04,   7.8623422E-04
     +,   8.6394284E-04,   9.5126557E-04,   1.0489855E-03
     +,   1.1573160E-03,   1.2757441E-03,   1.4028383E-03
     +,   1.5362981E-03,   1.6731066E-03,   1.8098394E-03
     +,   1.9432225E-03,   2.0706479E-03,   2.1908639E-03
     +,   2.3045721E-03,   2.4149225E-03,   2.5278004E-03
     +,   2.6517047E-03,   2.7970700E-03,   2.9749849E-03
     +,   3.1954616E-03,   3.4656462E-03,   3.7884144E-03
     +,   4.1616671E-03,   4.5784847E-03,   5.0282534E-03
     +,   5.4990849E-03,   5.9811724E-03,   6.4699110E-03
     +,   6.9656735E-03,   7.4691023E-03,   7.9745110E-03
     +,   8.4675625E-03,   8.9307902E-03,   9.3513168E-03
     +,   9.7210659E-03,   1.0026951E-02,   1.0242215E-02
     +,   1.0334237E-02,   1.0288348E-02,   1.0129209E-02
     +,   9.9200932E-03,   9.7396318E-03,   9.6525587E-03
     +,   9.6904840E-03,   9.8473104E-03,   1.0087495E-02
     +,   1.0365661E-02,   1.0654572E-02,   1.0968043E-02
     +,   1.1355320E-02,   1.1856131E-02,   1.2443574E-02
     +,   1.3009394E-02,   1.3418897E-02,   1.3596230E-02
     +,   1.3572766E-02,   1.3466869E-02,   1.3413379E-02
     +,   1.3485344E-02,   1.3652376E-02,   1.3798156E-02
     +,   1.3779310E-02,   1.3491459E-02,   1.2920281E-02
     +,   1.2159374E-02,   1.1376022E-02,   1.0733309E-02
     +,   1.0314437E-02,   1.0097279E-02,   9.9911531E-03
     +,   9.9015450E-03,   9.7728074E-03,   9.5869536E-03
     +,   9.3375342E-03,   9.0105915E-03,   8.5852714E-03
     +,   8.0462461E-03,   7.3951753E-03,   6.6544185E-03
     +,   5.8619478E-03,   5.0608786E-03,   4.2889272E-03
     +,   3.5723066E-03,   2.9252416E-03,   2.3531194E-03
     +,   1.8563517E-03,   1.4330280E-03,   1.0800866E-03
     +,   7.9318450E-04,   5.6668936E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wao_fus_105 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wao_fus_110(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  5.6426252E-06,   5.7478401E-06
     +,   5.8511209E-06,   5.9522977E-06,   6.0511929E-06
     +,   6.1476394E-06,   6.2414688E-06,   6.3325133E-06
     +,   6.4206160E-06,   6.5056097E-06,   6.5873442E-06
     +,   6.6656680E-06,   6.7404358E-06,   6.8115091E-06
     +,   6.8787535E-06,   6.9420389E-06,   7.0012461E-06
     +,   7.0562610E-06,   7.1069771E-06,   7.1532968E-06
     +,   7.1951281E-06,   7.2323883E-06,   7.2650073E-06
     +,   7.2929170E-06,   7.3160650E-06,   7.3344031E-06
     +,   7.3478959E-06,   7.3565152E-06,   7.3602473E-06
     +,   7.3590804E-06,   7.3530200E-06,   7.3420765E-06
     +,   7.3262727E-06,   7.3056399E-06,   7.2802177E-06
     +,   7.2500579E-06,   7.2152211E-06,   7.1757740E-06
     +,   7.1317954E-06,   7.0833694E-06,   7.0305937E-06
     +,   6.9735688E-06,   6.9124048E-06,   6.8472200E-06
     +,   6.7781370E-06,   6.7052861E-06,   6.6288062E-06
     +,   6.5488402E-06,   6.4655324E-06,   6.3790399E-06
     +,   6.2895174E-06,   6.1971259E-06,   6.1020305E-06
     +,   6.0043976E-06,   5.9043959E-06,   5.8021965E-06
     +,   5.6979725E-06,   5.5918986E-06,   5.4841503E-06
     +,   5.3748981E-06,   5.2643200E-06,   5.1525885E-06
     +,   5.0398735E-06,   4.9263449E-06,   4.8121724E-06
     +,   4.6975201E-06,   4.5825477E-06,   4.4674207E-06
     +,   4.3522905E-06,   4.2373108E-06,   4.1226249E-06
     +,   4.0083842E-06,   3.8947223E-06,   3.7817745E-06
     +,   3.6696695E-06,   3.5585308E-06,   3.4484763E-06
     +,   3.3396229E-06,   3.2320788E-06,   3.1259440E-06
     +,   3.0213191E-06,   2.9182938E-06,   2.8169604E-06
     +,   2.7173999E-06,   2.6196910E-06,   2.5239087E-06
     +,   2.4301216E-06,   2.3383986E-06,   2.2488025E-06
     +,   2.1613907E-06,   2.0762313E-06,   1.9933780E-06
     +,   1.9128890E-06,   1.8348219E-06,   1.7592367E-06
     +,   1.6861959E-06,   1.6157613E-06,   1.5480103E-06
     +,   1.4830164E-06,   1.4208640E-06,   1.3616475E-06
     +,   1.3054716E-06,   1.2524554E-06,   1.2027318E-06
     +,   1.1564523E-06,   1.1137869E-06,   1.0749291E-06
     +,   1.0400956E-06,   1.0095324E-06,   9.8351347E-07
     +,   9.6234783E-07,   9.4637954E-07,   9.3599255E-07
     +,   9.3161253E-07,   9.3370977E-07,   9.4280381E-07
     +,   9.5946427E-07,   9.8431553E-07,   1.0180391E-06
     +,   1.0613716E-06,   1.1151138E-06,   1.1801286E-06
     +,   1.2573421E-06,   1.3477451E-06,   1.4523931E-06
     +,   1.5724059E-06,   1.7089670E-06,   1.8633203E-06
     +,   2.0367684E-06,   2.2306688E-06,   2.4464289E-06
     +,   2.6855118E-06,   2.9493847E-06,   3.2395774E-06
     +,   3.5576279E-06,   3.9050874E-06,   4.2835045E-06
     +,   4.6944165E-06,   5.1393322E-06,   5.6197473E-06
     +,   6.1370320E-06,   6.6925531E-06,   7.2875710E-06
     +,   7.9232450E-06,   8.6006121E-06,   9.3205808E-06
     +,   1.0083910E-05,   1.0891197E-05,   1.1742857E-05
     +,   1.2639132E-05,   1.3580056E-05,   1.4565513E-05
     +,   1.5595047E-05,   1.6668128E-05,   1.7783976E-05
     +,   1.8941624E-05,   2.0139922E-05,   2.1377547E-05
     +,   2.2653057E-05,   2.3964876E-05,   2.5311378E-05
     +,   2.6690959E-05,   2.8101871E-05,   2.9542645E-05
     +,   3.1011903E-05,   3.2508568E-05,   3.4031898E-05
     +,   3.5581674E-05,   3.7158286E-05,   3.8762977E-05
     +,   4.0397965E-05,   4.2066706E-05,   4.3774176E-05
     +,   4.5527238E-05,   4.7334681E-05,   4.9208076E-05
     +,   5.1162027E-05,   5.3214648E-05,   5.5388296E-05
     +,   5.7710284E-05,   6.0213166E-05,   6.2936844E-05
     +,   6.5927874E-05,   6.9241847E-05,   7.2943949E-05
     +,   7.7110242E-05,   8.1828810E-05,   8.7200926E-05
     +,   9.3342031E-05,   1.0038260E-04,   1.0846855E-04
     +,   1.1776140E-04,   1.2843817E-04,   1.4068803E-04
     +,   1.5471625E-04,   1.7073340E-04,   1.8896283E-04
     +,   2.0962759E-04,   2.3295032E-04,   2.5915715E-04
     +,   2.8845906E-04,   3.2106799E-04,   3.5717501E-04
     +,   3.9696242E-04,   4.4059457E-04,   4.8821425E-04
     +,   5.3993869E-04,   5.9585279E-04,   6.5600895E-04
     +,   7.2043360E-04,   7.8915170E-04,   8.6224265E-04
     +,   9.3993853E-04,   1.0227656E-03,   1.1117307E-03
     +,   1.2084945E-03,   1.3155647E-03,   1.4362639E-03
     +,   1.5745802E-03,   1.7346796E-03,   1.9200769E-03
     +,   2.1327026E-03,   2.3717179E-03,   2.6328205E-03
     +,   2.9079940E-03,   3.1861910E-03,   3.4549099E-03
     +,   3.7024540E-03,   3.9202617E-03,   4.1046278E-03
     +,   4.2571556E-03,   4.3837018E-03,   4.4921609E-03
     +,   4.5899232E-03,   4.6820799E-03,   4.7711935E-03
     +,   4.8586577E-03,   4.9468470E-03,   5.0407797E-03
     +,   5.1482706E-03,   5.2786511E-03,   5.4412195E-03
     +,   5.6447559E-03,   5.8980649E-03,   6.2095504E-03
     +,   6.5833176E-03,   7.0118099E-03,   7.4693840E-03
     +,   7.9138437E-03,   8.2993889E-03,   8.5960235E-03
     +,   8.8040112E-03,   8.9530461E-03,   9.0854354E-03
     +,   9.2325378E-03,   9.3982937E-03,   9.5599080E-03
     +,   9.6852891E-03,   9.7552771E-03,   9.7750230E-03
     +,   9.7671403E-03,   9.7548710E-03,   9.7504491E-03
     +,   9.7571127E-03,   9.7776763E-03,   9.8168738E-03
     +,   9.8738344E-03,   9.9356994E-03,   9.9839605E-03
     +,   1.0009819E-02,   1.0021413E-02,   1.0031112E-02
     +,   1.0031634E-02,   9.9841971E-03,   9.8340018E-03
     +,   9.5467335E-03,   9.1414955E-03,   8.6969575E-03
     +,   8.3246445E-03,   8.1226639E-03,   8.1339451E-03
     +,   8.3275707E-03,   8.6097606E-03,   8.8570314E-03
     +,   8.9563392E-03,   8.8359639E-03,   8.4778201E-03
     +,   7.9105617E-03,   7.1908762E-03,   6.3829627E-03
     +,   5.5437610E-03,   4.7166324E-03,   3.9317668E-03
     +,   3.2095893E-03,   2.5638770E-03,   2.0031908E-03
     +,   1.5310356E-03,   1.1457504E-03,   8.4105623E-04
     +,   6.0708623E-04,   4.3218894E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wao_fus_110 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wao_fus_115(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  2.9716293E-10,   3.3858191E-10
     +,   3.8545148E-10,   4.3844434E-10,   4.9830490E-10
     +,   5.6586480E-10,   6.4204825E-10,   7.2788026E-10
     +,   8.2449914E-10,   9.3316144E-10,   1.0552627E-09
     +,   1.1923440E-09,   1.3461061E-09,   1.5184295E-09
     +,   1.7113860E-09,   1.9272464E-09,   2.1685234E-09
     +,   2.4379665E-09,   2.7386029E-09,   3.0737484E-09
     +,   3.4470191E-09,   3.8623895E-09,   4.3241988E-09
     +,   4.8371858E-09,   5.4065219E-09,   6.0378080E-09
     +,   6.7371713E-09,   7.5112654E-09,   8.3673317E-09
     +,   9.3131582E-09,   1.0357239E-08,   1.1508757E-08
     +,   1.2777615E-08,   1.4174520E-08,   1.5711056E-08
     +,   1.7399563E-08,   1.9253443E-08,   2.1287059E-08
     +,   2.3515822E-08,   2.5956304E-08,   2.8626069E-08
     +,   3.1544072E-08,   3.4730476E-08,   3.8206856E-08
     +,   4.1996092E-08,   4.6122672E-08,   5.0612343E-08
     +,   5.5492656E-08,   6.0792871E-08,   6.6543542E-08
     +,   7.2777404E-08,   7.9528796E-08,   8.6833893E-08
     +,   9.4730865E-08,   1.0325966E-07,   1.1246232E-07
     +,   1.2238316E-07,   1.3306762E-07,   1.4456411E-07
     +,   1.5692292E-07,   1.7019573E-07,   1.8443713E-07
     +,   1.9970319E-07,   2.1605227E-07,   2.3354467E-07
     +,   2.5224244E-07,   2.7221017E-07,   2.9351261E-07
     +,   3.1621798E-07,   3.4039519E-07,   3.6611561E-07
     +,   3.9344991E-07,   4.2247197E-07,   4.5325598E-07
     +,   4.8587697E-07,   5.2041082E-07,   5.5693448E-07
     +,   5.9552281E-07,   6.3625322E-07,   6.7920149E-07
     +,   7.2444334E-07,   7.7205453E-07,   8.2210664E-07
     +,   8.7467265E-07,   9.2982265E-07,   9.8762450E-07
     +,   1.0481438E-06,   1.1114421E-06,   1.1775794E-06
     +,   1.2466134E-06,   1.3185888E-06,   1.3935555E-06
     +,   1.4715548E-06,   1.5526218E-06,   1.6367870E-06
     +,   1.7240745E-06,   1.8145043E-06,   1.9080794E-06
     +,   2.0048046E-06,   2.1046756E-06,   2.2076777E-06
     +,   2.3137886E-06,   2.4229769E-06,   2.5352015E-06
     +,   2.6504138E-06,   2.7685519E-06,   2.8895486E-06
     +,   3.0133233E-06,   3.1397872E-06,   3.2688408E-06
     +,   3.4003756E-06,   3.5342798E-06,   3.6704141E-06
     +,   3.8086473E-06,   3.9488364E-06,   4.0908299E-06
     +,   4.2344695E-06,   4.3795912E-06,   4.5260354E-06
     +,   4.6736172E-06,   4.8221750E-06,   4.9715395E-06
     +,   5.1215438E-06,   5.2720311E-06,   5.4228531E-06
     +,   5.5738742E-06,   5.7249772E-06,   5.8760679E-06
     +,   6.0270754E-06,   6.1779679E-06,   6.3287475E-06
     +,   6.4794708E-06,   6.6302291E-06,   6.7811884E-06
     +,   6.9325856E-06,   7.0847336E-06,   7.2380312E-06
     +,   7.3929800E-06,   7.5501875E-06,   7.7103896E-06
     +,   7.8744361E-06,   8.0433338E-06,   8.2182469E-06
     +,   8.4005005E-06,   8.5915954E-06,   8.7932276E-06
     +,   9.0072908E-06,   9.2358869E-06,   9.4813413E-06
     +,   9.7462034E-06,   1.0033262E-05,   1.0345564E-05
     +,   1.0686362E-05,   1.1059199E-05,   1.1467871E-05
     +,   1.1916421E-05,   1.2409165E-05,   1.2950673E-05
     +,   1.3545788E-05,   1.4199612E-05,   1.4917515E-05
     +,   1.5705189E-05,   1.6568511E-05,   1.7513761E-05
     +,   1.8547535E-05,   1.9676823E-05,   2.0909061E-05
     +,   2.2252241E-05,   2.3715040E-05,   2.5306985E-05
     +,   2.7038701E-05,   2.8922186E-05,   3.0971190E-05
     +,   3.3201813E-05,   3.5632605E-05,   3.8285893E-05
     +,   4.1188174E-05,   4.4371078E-05,   4.7872425E-05
     +,   5.1737508E-05,   5.6019340E-05,   6.0781858E-05
     +,   6.6098415E-05,   7.2054958E-05,   7.8749814E-05
     +,   8.6294422E-05,   9.4813215E-05,   1.0444323E-04
     +,   1.1533267E-04,   1.2763863E-04,   1.4152404E-04
     +,   1.5715322E-04,   1.7468710E-04,   1.9427236E-04
     +,   2.1604277E-04,   2.4009630E-04,   2.6650148E-04
     +,   2.9527131E-04,   3.2635842E-04,   3.5965370E-04
     +,   3.9495673E-04,   4.3199287E-04,   4.7038414E-04
     +,   5.0966861E-04,   5.4929801E-04,   5.8865349E-04
     +,   6.2707067E-04,   6.6387351E-04,   6.9842237E-04
     +,   7.3017407E-04,   7.5875263E-04,   7.8402791E-04
     +,   8.0619863E-04,   8.2586904E-04,   8.4411498E-04
     +,   8.6251681E-04,   8.8316697E-04,   9.0860203E-04
     +,   9.4169169E-04,   9.8544476E-04,   1.0427460E-03
     +,   1.1160934E-03,   1.2072894E-03,   1.3172776E-03
     +,   1.4460741E-03,   1.5928884E-03,   1.7563646E-03
     +,   1.9348453E-03,   2.1264891E-03,   2.3290932E-03
     +,   2.5396261E-03,   2.7536401E-03,   2.9649232E-03
     +,   3.1658500E-03,   3.3486926E-03,   3.5079063E-03
     +,   3.6429425E-03,   3.7607013E-03,   3.8765527E-03
     +,   4.0126238E-03,   4.1927556E-03,   4.4345926E-03
     +,   4.7410727E-03,   5.0953804E-03,   5.4628723E-03
     +,   5.8010616E-03,   6.0741724E-03,   6.2657492E-03
     +,   6.3837105E-03,   6.4569144E-03,   6.5268427E-03
     +,   6.6386107E-03,   6.8322136E-03,   7.1320194E-03
     +,   7.5344057E-03,   7.9992283E-03,   8.4536076E-03
     +,   8.8104932E-03,   8.9937812E-03,   8.9576561E-03
     +,   8.6946692E-03,   8.2379607E-03,   7.6628509E-03
     +,   7.0827347E-03,   6.6275871E-03,   6.4038588E-03
     +,   6.4526554E-03,   6.7326040E-03,   7.1415910E-03
     +,   7.5666825E-03,   7.9327868E-03,   8.2229963E-03
     +,   8.4645674E-03,   8.6965812E-03,   8.9400532E-03
     +,   9.1809090E-03,   9.3676178E-03,   9.4263284E-03
     +,   9.2945937E-03,   8.9594992E-03,   8.4737195E-03
     +,   7.9339286E-03,   7.4342848E-03,   7.0257736E-03
     +,   6.7032590E-03,   6.4208745E-03,   6.1203912E-03
     +,   5.7565905E-03,   5.3108959E-03,   4.7921292E-03
     +,   4.2282250E-03,   3.6543759E-03,   3.1025861E-03
     +,   2.5954673E-03,   2.1447376E-03,   1.7531338E-03
     +,   1.4178221E-03,   1.1335873E-03,   8.9497300E-04
     +,   6.9697824E-04,   5.3519383E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wao_fus_115 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wao_fus_120(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   1.4929560E-38
     +,   3.7074137E-38,   9.1565645E-38,   2.2492015E-37
     +,   5.4949236E-37,   1.3351578E-36,   3.2264952E-36
     +,   7.7546783E-36,   1.8536768E-35,   4.4069541E-35
     +,   1.0420148E-34,   2.4505117E-34,   5.7313991E-34
     +,   1.3332217E-33,   3.0844994E-33,   7.0973241E-33
     +,   1.6242036E-32,   3.6967402E-32,   8.3682220E-32
     +,   1.8840038E-31,   4.2185638E-31,   9.3946740E-31
     +,   2.0808449E-30,   4.5837960E-30,   1.0042617E-29
     +,   2.1883206E-29,   4.7424319E-29,   1.0221756E-28
     +,   2.1912114E-28,   4.6717254E-28,   9.9061844E-28
     +,   2.0891510E-27,   4.3820018E-27,   9.1412662E-27
     +,   1.8965880E-26,   3.9135932E-26,   8.0319229E-26
     +,   1.6394237E-25,   3.3281088E-25,   6.7195216E-25
     +,   1.3493218E-24,   2.6947956E-24,   5.3527561E-24
     +,   1.0574520E-23,   2.0776730E-23,   4.0600257E-23
     +,   7.8906986E-23,   1.5252667E-22,   2.9322760E-22
     +,   5.6065993E-22,   1.0661745E-21,   2.0164908E-21
     +,   3.7931389E-21,   7.0964196E-21,   1.3204335E-20
     +,   2.4436689E-20,   4.4977523E-20,   8.2335038E-20
     +,   1.4990356E-19,   2.7144348E-19,   4.8886069E-19
     +,   8.7565319E-19,   1.5600226E-18,   2.7641278E-18
     +,   4.8711090E-18,   8.5376835E-18,   1.4883204E-17
     +,   2.5804655E-17,   4.4498396E-17,   7.6320077E-17
     +,   1.3019087E-16,   2.2088770E-16,   3.7274648E-16
     +,   6.2561885E-16,   1.0443846E-15,   1.7340740E-15
     +,   2.8637447E-15,   4.7040398E-15,   7.6853239E-15
     +,   1.2488764E-14,   2.0185840E-14,   3.2452390E-14
     +,   5.1894710E-14,   8.2542778E-14,   1.3059531E-13
     +,   2.0552020E-13,   3.2171732E-13,   5.0094634E-13
     +,   7.7590896E-13,   1.1954673E-12,   1.8322165E-12
     +,   2.7934241E-12,   4.2366401E-12,   6.3920319E-12
     +,   9.5939038E-12,   1.4325135E-11,   2.1279209E-11
     +,   3.1447213E-11,   4.6235012E-11,   6.7629846E-11
     +,   9.8422090E-11,   1.4250925E-10,   2.0530413E-10
     +,   2.9428418E-10,   4.1971973E-10,   5.9564986E-10
     +,   8.4112023E-10,   1.1818876E-09,   1.6525517E-09
     +,   2.2993443E-09,   3.1836955E-09,   4.3867936E-09
     +,   6.0153358E-09,   8.2087501E-09,   1.1148273E-08
     +,   1.5068123E-08,   2.0269328E-08,   2.7136949E-08
     +,   3.6159229E-08,   4.7954153E-08,   6.3297762E-08
     +,   8.3159378E-08,   1.0874272E-07,   1.4153389E-07
     +,   1.8335675E-07,   2.3643615E-07,   3.0346999E-07
     +,   3.8771404E-07,   4.9305527E-07,   6.2413255E-07
     +,   7.8642762E-07,   9.8638202E-07,   1.2315152E-06
     +,   1.5305460E-06,   1.8935149E-06,   2.3319033E-06
     +,   2.8587497E-06,   3.4887489E-06,   4.2383435E-06
     +,   5.1258326E-06,   6.1712522E-06,   7.3966239E-06
     +,   8.8257921E-06,   1.0484410E-05,   1.2399856E-05
     +,   1.4601245E-05,   1.7118760E-05,   1.9984718E-05
     +,   2.3231883E-05,   2.6894637E-05,   3.1008356E-05
     +,   3.5609573E-05,   4.0736075E-05,   4.6427169E-05
     +,   5.2724012E-05,   5.9670012E-05,   6.7311405E-05
     +,   7.5697659E-05,   8.4882282E-05,   9.4920899E-05
     +,   1.0587577E-04,   1.1780830E-04,   1.3078559E-04
     +,   1.4487113E-04,   1.6012503E-04,   1.7660543E-04
     +,   1.9435537E-04,   2.1341158E-04,   2.3379079E-04
     +,   2.5549869E-04,   2.7852750E-04,   3.0286366E-04
     +,   3.2849648E-04,   3.5543271E-04,   3.8371340E-04
     +,   4.1343286E-04,   4.4475764E-04,   4.7794075E-04
     +,   5.1332725E-04,   5.5134710E-04,   5.9249153E-04
     +,   6.3725893E-04,   6.8611011E-04,   7.3936395E-04
     +,   7.9713791E-04,   8.5927558E-04,   9.2530611E-04
     +,   9.9450722E-04,   1.0659678E-03,   1.1388115E-03
     +,   1.2124272E-03,   1.2867498E-03,   1.3624923E-03
     +,   1.4412596E-03,   1.5254483E-03,   1.6178825E-03
     +,   1.7211592E-03,   1.8367840E-03,   1.9642650E-03
     +,   2.1004332E-03,   2.2392983E-03,   2.3726937E-03
     +,   2.4918264E-03,   2.5895464E-03,   2.6630124E-03
     +,   2.7159720E-03,   2.7599544E-03,   2.8135655E-03
     +,   2.8992570E-03,   3.0378208E-03,   3.2418002E-03
     +,   3.5104018E-03,   3.8286601E-03,   4.1720211E-03
     +,   4.5144311E-03,   4.8354003E-03,   5.1219407E-03
     +,   5.3652199E-03,   5.5562728E-03,   5.6864633E-03
     +,   5.7541062E-03,   5.7721972E-03,   5.7696523E-03
     +,   5.7824077E-03,   5.8387965E-03,   5.9481943E-03
     +,   6.0996623E-03,   6.2709702E-03,   6.4419997E-03
     +,   6.6034258E-03,   6.7534824E-03,   6.8845609E-03
     +,   6.9729784E-03,   6.9865063E-03,   6.9088838E-03
     +,   6.7616808E-03,   6.6023669E-03,   6.4967996E-03
     +,   6.4853271E-03,   6.5643145E-03,   6.6910801E-03
     +,   6.8052816E-03,   6.8544596E-03,   6.8130502E-03
     +,   6.6887531E-03,   6.5151118E-03,   6.3344711E-03
     +,   6.1790366E-03,   6.0577900E-03,   5.9543313E-03
     +,   5.8357068E-03,   5.6673451E-03,   5.4264013E-03
     +,   5.1079225E-03,   4.7228718E-03,   4.2914185E-03
     +,   3.8358190E-03,   3.3756734E-03,   2.9260518E-03
     +,   2.4976244E-03,   2.0976919E-03,   1.7313254E-03
     +,   1.4021607E-03,   1.1127072E-03,   8.6430344E-04
     +,   6.5671455E-04,   4.8810992E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wao_fus_120 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wao_fus_60(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  3.2343833E-05,   3.2655422E-05
     +,   3.2973137E-05,   3.3297521E-05,   3.3629105E-05
     +,   3.3968416E-05,   3.4315985E-05,   3.4672317E-05
     +,   3.5037934E-05,   3.5413297E-05,   3.5798894E-05
     +,   3.6195164E-05,   3.6602538E-05,   3.7021422E-05
     +,   3.7452191E-05,   3.7895177E-05,   3.8350689E-05
     +,   3.8819006E-05,   3.9300354E-05,   3.9794948E-05
     +,   4.0302904E-05,   4.0824350E-05,   4.1359326E-05
     +,   4.1907861E-05,   4.2469910E-05,   4.3045355E-05
     +,   4.3634060E-05,   4.4235814E-05,   4.4850374E-05
     +,   4.5477394E-05,   4.6116507E-05,   4.6767280E-05
     +,   4.7429217E-05,   4.8101774E-05,   4.8784350E-05
     +,   4.9476253E-05,   5.0176786E-05,   5.0885155E-05
     +,   5.1600542E-05,   5.2322088E-05,   5.3048825E-05
     +,   5.3779797E-05,   5.4513977E-05,   5.5250319E-05
     +,   5.5987708E-05,   5.6725046E-05,   5.7461119E-05
     +,   5.8194753E-05,   5.8924765E-05,   5.9649883E-05
     +,   6.0368868E-05,   6.1080485E-05,   6.1783445E-05
     +,   6.2476494E-05,   6.3158412E-05,   6.3827902E-05
     +,   6.4483778E-05,   6.5124805E-05,   6.5749795E-05
     +,   6.6357628E-05,   6.6947148E-05,   6.7517307E-05
     +,   6.8067071E-05,   6.8595473E-05,   6.9101574E-05
     +,   6.9584545E-05,   7.0043585E-05,   7.0477960E-05
     +,   7.0887043E-05,   7.1270246E-05,   7.1627110E-05
     +,   7.1957220E-05,   7.2260271E-05,   7.2536051E-05
     +,   7.2784438E-05,   7.3005416E-05,   7.3199044E-05
     +,   7.3365532E-05,   7.3505129E-05,   7.3618241E-05
     +,   7.3705363E-05,   7.3767093E-05,   7.3804127E-05
     +,   7.3817268E-05,   7.3807445E-05,   7.3775678E-05
     +,   7.3723073E-05,   7.3650859E-05,   7.3560346E-05
     +,   7.3452953E-05,   7.3330186E-05,   7.3193631E-05
     +,   7.3044997E-05,   7.2885996E-05,   7.2718489E-05
     +,   7.2544375E-05,   7.2365605E-05,   7.2184230E-05
     +,   7.2002309E-05,   7.1821960E-05,   7.1645343E-05
     +,   7.1474635E-05,   7.1312024E-05,   7.1159746E-05
     +,   7.1019989E-05,   7.0894974E-05,   7.0786860E-05
     +,   7.0697824E-05,   7.0629947E-05,   7.0585316E-05
     +,   7.0565911E-05,   7.0573667E-05,   7.0610397E-05
     +,   7.0677852E-05,   7.0777671E-05,   7.0911345E-05
     +,   7.1080227E-05,   7.1285576E-05,   7.1528470E-05
     +,   7.1809794E-05,   7.2130300E-05,   7.2490526E-05
     +,   7.2890849E-05,   7.3331401E-05,   7.3812160E-05
     +,   7.4332864E-05,   7.4893018E-05,   7.5491946E-05
     +,   7.6128701E-05,   7.6802178E-05,   7.7510980E-05
     +,   7.8253564E-05,   7.9028061E-05,   7.9832484E-05
     +,   8.0664635E-05,   8.1522085E-05,   8.2402250E-05
     +,   8.3302344E-05,   8.4219428E-05,   8.5150517E-05
     +,   8.6092266E-05,   8.7041451E-05,   8.7994638E-05
     +,   8.8948378E-05,   8.9899142E-05,   9.0843387E-05
     +,   9.1777583E-05,   9.2698196E-05,   9.3601775E-05
     +,   9.4484909E-05,   9.5344345E-05,   9.6176933E-05
     +,   9.6979580E-05,   9.7749537E-05,   9.8484154E-05
     +,   9.9181059E-05,   9.9838122E-05,   1.0045350E-04
     +,   1.0102564E-04,   1.0155328E-04,   1.0203560E-04
     +,   1.0247203E-04,   1.0286242E-04,   1.0320701E-04
     +,   1.0350642E-04,   1.0376174E-04,   1.0397437E-04
     +,   1.0414623E-04,   1.0427962E-04,   1.0437726E-04
     +,   1.0444230E-04,   1.0447831E-04,   1.0448921E-04
     +,   1.0447937E-04,   1.0445349E-04,   1.0441668E-04
     +,   1.0437431E-04,   1.0433210E-04,   1.0429605E-04
     +,   1.0427240E-04,   1.0426762E-04,   1.0428832E-04
     +,   1.0434136E-04,   1.0443358E-04,   1.0457190E-04
     +,   1.0476336E-04,   1.0501481E-04,   1.0533320E-04
     +,   1.0572527E-04,   1.0619756E-04,   1.0675645E-04
     +,   1.0740803E-04,   1.0815814E-04,   1.0901210E-04
     +,   1.0997508E-04,   1.1105160E-04,   1.1224589E-04
     +,   1.1356149E-04,   1.1500136E-04,   1.1656823E-04
     +,   1.1826369E-04,   1.2008938E-04,   1.2204565E-04
     +,   1.2413258E-04,   1.2634946E-04,   1.2869498E-04
     +,   1.3116709E-04,   1.3376314E-04,   1.3647981E-04
     +,   1.3931307E-04,   1.4225836E-04,   1.4531049E-04
     +,   1.4846362E-04,   1.5171140E-04,   1.5504715E-04
     +,   1.5846298E-04,   1.6195163E-04,   1.6550432E-04
     +,   1.6911252E-04,   1.7276725E-04,   1.7645862E-04
     +,   1.8017752E-04,   1.8391338E-04,   1.8765622E-04
     +,   1.9139548E-04,   1.9512050E-04,   1.9882047E-04
     +,   2.0248456E-04,   2.0610170E-04,   2.0966091E-04
     +,   2.1315106E-04,   2.1656111E-04,   2.1988004E-04
     +,   2.2309688E-04,   2.2620083E-04,   2.2918114E-04
     +,   2.3202739E-04,   2.3472900E-04,   2.3727593E-04
     +,   2.3965840E-04,   2.4186684E-04,   2.4389225E-04
     +,   2.4572550E-04,   2.4735840E-04,   2.4878304E-04
     +,   2.4999198E-04,   2.5097842E-04,   2.5173611E-04
     +,   2.5225940E-04,   2.5254331E-04,   2.5258362E-04
     +,   2.5237678E-04,   2.5192005E-04,   2.5121149E-04
     +,   2.5025004E-04,   2.4903534E-04,   2.4756804E-04
     +,   2.4584963E-04,   2.4388246E-04,   2.4166981E-04
     +,   2.3921586E-04,   2.3652555E-04,   2.3360466E-04
     +,   2.3046024E-04,   2.2709962E-04,   2.2353118E-04
     +,   2.1976398E-04,   2.1580778E-04,   2.1167302E-04
     +,   2.0737073E-04,   2.0291247E-04,   1.9831033E-04
     +,   1.9357677E-04,   1.8872460E-04,   1.8376704E-04
     +,   1.7871727E-04,   1.7358888E-04,   1.6839513E-04
     +,   1.6315008E-04,   1.5786698E-04,   1.5255914E-04
     +,   1.4723976E-04,   1.4192142E-04,   1.3661719E-04
     +,   1.3133907E-04,   1.2609865E-04,   1.2090731E-04
     +,   1.1577566E-04,   1.1071393E-04,   1.0573160E-04
     +,   1.0083760E-04,   9.6040181E-05,   9.1346868E-05
     +,   8.6764594E-05,   8.2299513E-05,   7.7957084E-05
     +,   7.3742071E-05,   6.9658374E-05,   6.5709894E-05
     +,   6.1898652E-05,   5.8227219E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wao_fus_60 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wao_fus_65(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  7.6009539E-11,   9.8020127E-11
     +,   1.2610818E-10,   1.6186552E-10,   2.0727316E-10
     +,   2.6479652E-10,   3.3749042E-10,   4.2913123E-10
     +,   5.4437849E-10,   6.8895123E-10,   8.6987145E-10
     +,   1.0957222E-09,   1.3769703E-09,   1.7263420E-09
     +,   2.1592828E-09,   2.6944376E-09,   3.3543186E-09
     +,   4.1659916E-09,   5.1618980E-09,   6.3808714E-09
     +,   7.8691071E-09,   9.6816128E-09,   1.1883558E-08
     +,   1.4551980E-08,   1.7777706E-08,   2.1667246E-08
     +,   2.6345589E-08,   3.1958603E-08,   3.8676369E-08
     +,   4.6695742E-08,   5.6245078E-08,   6.7587685E-08
     +,   8.1026322E-08,   9.6908117E-08,   1.1563025E-07
     +,   1.3764374E-07,   1.6346212E-07,   1.9366603E-07
     +,   2.2891025E-07,   2.6993217E-07,   3.1755454E-07
     +,   3.7269882E-07,   4.3638934E-07,   5.0976132E-07
     +,   5.9406835E-07,   6.9069245E-07,   8.0114114E-07
     +,   9.2706750E-07,   1.0702706E-06,   1.2326890E-06
     +,   1.4164235E-06,   1.6237269E-06,   1.8570087E-06
     +,   2.1188343E-06,   2.4119188E-06,   2.7391268E-06
     +,   3.1034720E-06,   3.5080709E-06,   3.9561805E-06
     +,   4.4511676E-06,   4.9964406E-06,   5.5955065E-06
     +,   6.2518957E-06,   6.9691469E-06,   7.7507739E-06
     +,   8.6002337E-06,   9.5209116E-06,   1.0515996E-05
     +,   1.1588564E-05,   1.2741458E-05,   1.3977279E-05
     +,   1.5298250E-05,   1.6706332E-05,   1.8203045E-05
     +,   1.9789499E-05,   2.1466318E-05,   2.3233644E-05
     +,   2.5090980E-05,   2.7037337E-05,   2.9071123E-05
     +,   3.1190099E-05,   3.3391472E-05,   3.5671641E-05
     +,   3.8026526E-05,   4.0451381E-05,   4.2940865E-05
     +,   4.5489018E-05,   4.8089369E-05,   5.0734954E-05
     +,   5.3418433E-05,   5.6131750E-05,   5.8866852E-05
     +,   6.1615334E-05,   6.4368571E-05,   6.7117871E-05
     +,   6.9854526E-05,   7.2569979E-05,   7.5255535E-05
     +,   7.7903045E-05,   8.0504622E-05,   8.3052830E-05
     +,   8.5540705E-05,   8.7961918E-05,   9.0310794E-05
     +,   9.2582399E-05,   9.4772688E-05,   9.6878422E-05
     +,   9.8897304E-05,   1.0082802E-04,   1.0267027E-04
     +,   1.0442472E-04,   1.0609320E-04,   1.0767837E-04
     +,   1.0918410E-04,   1.1061520E-04,   1.1197750E-04
     +,   1.1327774E-04,   1.1452355E-04,   1.1572348E-04
     +,   1.1688662E-04,   1.1802296E-04,   1.1914302E-04
     +,   1.2025781E-04,   1.2137878E-04,   1.2251770E-04
     +,   1.2368656E-04,   1.2489746E-04,   1.2616253E-04
     +,   1.2749381E-04,   1.2890319E-04,   1.3040227E-04
     +,   1.3200239E-04,   1.3371417E-04,   1.3554793E-04
     +,   1.3751329E-04,   1.3961909E-04,   1.4187336E-04
     +,   1.4428317E-04,   1.4685449E-04,   1.4959223E-04
     +,   1.5249946E-04,   1.5557812E-04,   1.5882832E-04
     +,   1.6224815E-04,   1.6583373E-04,   1.6957865E-04
     +,   1.7347411E-04,   1.7750861E-04,   1.8166777E-04
     +,   1.8593440E-04,   1.9028841E-04,   1.9470703E-04
     +,   1.9916425E-04,   2.0363241E-04,   2.0808168E-04
     +,   2.1248077E-04,   2.1679784E-04,   2.2100119E-04
     +,   2.2506012E-04,   2.2894604E-04,   2.3263357E-04
     +,   2.3610162E-04,   2.3933430E-04,   2.4232236E-04
     +,   2.4506371E-04,   2.4756431E-04,   2.4983857E-04
     +,   2.5190975E-04,   2.5380935E-04,   2.5557727E-04
     +,   2.5726020E-04,   2.5891126E-04,   2.6058775E-04
     +,   2.6234932E-04,   2.6425591E-04,   2.6636559E-04
     +,   2.6873153E-04,   2.7140015E-04,   2.7440826E-04
     +,   2.7778136E-04,   2.8153069E-04,   2.8565401E-04
     +,   2.9013201E-04,   2.9493030E-04,   2.9999806E-04
     +,   3.0527016E-04,   3.1066817E-04,   3.1610229E-04
     +,   3.2147428E-04,   3.2668075E-04,   3.3161577E-04
     +,   3.3617500E-04,   3.4025864E-04,   3.4377462E-04
     +,   3.4664309E-04,   3.4879640E-04,   3.5018398E-04
     +,   3.5077170E-04,   3.5054429E-04,   3.4950464E-04
     +,   3.4767404E-04,   3.4509032E-04,   3.4180775E-04
     +,   3.3789375E-04,   3.3342713E-04,   3.2849578E-04
     +,   3.2319350E-04,   3.1761811E-04,   3.1186803E-04
     +,   3.0604049E-04,   3.0022906E-04,   2.9452186E-04
     +,   2.8899993E-04,   2.8373610E-04,   2.7879333E-04
     +,   2.7422566E-04,   2.7007514E-04,   2.6637444E-04
     +,   2.6314493E-04,   2.6039744E-04,   2.5813296E-04
     +,   2.5634200E-04,   2.5500645E-04,   2.5409926E-04
     +,   2.5358520E-04,   2.5342198E-04,   2.5356110E-04
     +,   2.5394841E-04,   2.5452566E-04,   2.5523119E-04
     +,   2.5600134E-04,   2.5677157E-04,   2.5747792E-04
     +,   2.5805796E-04,   2.5845249E-04,   2.5860619E-04
     +,   2.5846923E-04,   2.5799786E-04,   2.5715542E-04
     +,   2.5591312E-04,   2.5425025E-04,   2.5215434E-04
     +,   2.4962192E-04,   2.4665729E-04,   2.4327292E-04
     +,   2.3948871E-04,   2.3533095E-04,   2.3083210E-04
     +,   2.2602917E-04,   2.2096302E-04,   2.1567734E-04
     +,   2.1021755E-04,   2.0462944E-04,   1.9895869E-04
     +,   1.9324951E-04,   1.8754396E-04,   1.8188132E-04
     +,   1.7629705E-04,   1.7082352E-04,   1.6548790E-04
     +,   1.6031318E-04,   1.5531768E-04,   1.5051488E-04
     +,   1.4591437E-04,   1.4152075E-04,   1.3733473E-04
     +,   1.3335345E-04,   1.2957054E-04,   1.2597685E-04
     +,   1.2256071E-04,   1.1930839E-04,   1.1620476E-04
     +,   1.1323349E-04,   1.1037765E-04,   1.0762008E-04
     +,   1.0494373E-04,   1.0233209E-04,   9.9769306E-05
     +,   9.7240940E-05,   9.4733565E-05,   9.2235241E-05
     +,   8.9735731E-05,   8.7226348E-05,   8.4700529E-05
     +,   8.2153099E-05,   7.9580786E-05,   7.6981996E-05
     +,   7.4356729E-05,   7.1706512E-05,   6.9034249E-05
     +,   6.6344015E-05,   6.3641004E-05,   6.0931277E-05
     +,   5.8221620E-05,   5.5519380E-05,   5.2832274E-05
     +,   5.0168223E-05,   4.7535104E-05,   4.4941167E-05
     +,   4.2393618E-05,   3.9900122E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wao_fus_65 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wao_fus_70(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  1.2900871E-10,   1.5581823E-10
     +,   1.8791432E-10,   2.2627962E-10,   2.7206407E-10
     +,   3.2661734E-10,   3.9151607E-10,   4.6859949E-10
     +,   5.6001276E-10,   6.6824291E-10,   7.9618323E-10
     +,   9.4718222E-10,   1.1251138E-09,   1.3344480E-09
     +,   1.5803393E-09,   1.8687005E-09,   2.2063322E-09
     +,   2.6010245E-09,   3.0616809E-09,   3.5984860E-09
     +,   4.2229846E-09,   4.9483666E-09,   5.7895644E-09
     +,   6.7635142E-09,   7.8893807E-09,   9.1886898E-09
     +,   1.0685793E-08,   1.2408012E-08,   1.4386042E-08
     +,   1.6654097E-08,   1.9250564E-08,   2.2218169E-08
     +,   2.5604432E-08,   2.9462152E-08,   3.3849943E-08
     +,   3.8832248E-08,   4.4480529E-08,   5.0873300E-08
     +,   5.8096884E-08,   6.6246088E-08,   7.5423905E-08
     +,   8.5743501E-08,   9.7327856E-08,   1.1031045E-07
     +,   1.2483601E-07,   1.4106165E-07,   1.5915521E-07
     +,   1.7929908E-07,   2.0168868E-07,   2.2653209E-07
     +,   2.5405288E-07,   2.8448883E-07,   3.1809310E-07
     +,   3.5513341E-07,   3.9589298E-07,   4.4067093E-07
     +,   4.8978245E-07,   5.4355496E-07,   6.0233390E-07
     +,   6.6648062E-07,   7.3636579E-07,   8.1237846E-07
     +,   8.9491948E-07,   9.8440239E-07,   1.0812515E-06
     +,   1.1859025E-06,   1.2988032E-06,   1.4204022E-06
     +,   1.5511628E-06,   1.6915517E-06,   1.8420449E-06
     +,   2.0031116E-06,   2.1752332E-06,   2.3588884E-06
     +,   2.5545601E-06,   2.7627264E-06,   2.9838718E-06
     +,   3.2184628E-06,   3.4669799E-06,   3.7298953E-06
     +,   4.0076779E-06,   4.3008035E-06,   4.6097257E-06
     +,   4.9349155E-06,   5.2768401E-06,   5.6359681E-06
     +,   6.0127677E-06,   6.4077185E-06,   6.8213026E-06
     +,   7.2540338E-06,   7.7063751E-06,   8.1788648E-06
     +,   8.6720383E-06,   9.1864513E-06,   9.7226794E-06
     +,   1.0281328E-05,   1.0863055E-05,   1.1468468E-05
     +,   1.2098296E-05,   1.2753275E-05,   1.3434191E-05
     +,   1.4141874E-05,   1.4877215E-05,   1.5641161E-05
     +,   1.6434728E-05,   1.7259010E-05,   1.8115186E-05
     +,   1.9004532E-05,   1.9928435E-05,   2.0888392E-05
     +,   2.1886035E-05,   2.2923199E-05,   2.4001725E-05
     +,   2.5123767E-05,   2.6291624E-05,   2.7507776E-05
     +,   2.8774924E-05,   3.0095962E-05,   3.1474072E-05
     +,   3.2912456E-05,   3.4414690E-05,   3.5984522E-05
     +,   3.7625843E-05,   3.9342740E-05,   4.1139410E-05
     +,   4.3020187E-05,   4.4989480E-05,   4.7051755E-05
     +,   4.9211525E-05,   5.1473264E-05,   5.3841457E-05
     +,   5.6320634E-05,   5.8914939E-05,   6.1628758E-05
     +,   6.4466309E-05,   6.7431713E-05,   7.0529008E-05
     +,   7.3762159E-05,   7.7135053E-05,   8.0651625E-05
     +,   8.4315216E-05,   8.8129542E-05,   9.2097900E-05
     +,   9.6223339E-05,   1.0050862E-04,   1.0495595E-04
     +,   1.0956693E-04,   1.1434249E-04,   1.1928257E-04
     +,   1.2438608E-04,   1.2965062E-04,   1.3507283E-04
     +,   1.4064703E-04,   1.4636667E-04,   1.5222354E-04
     +,   1.5820781E-04,   1.6430834E-04,   1.7051287E-04
     +,   1.7680814E-04,   1.8318066E-04,   1.8961697E-04
     +,   1.9610461E-04,   2.0263178E-04,   2.0918994E-04
     +,   2.1577353E-04,   2.2238106E-04,   2.2901660E-04
     +,   2.3569037E-04,   2.4242012E-04,   2.4923158E-04
     +,   2.5615963E-04,   2.6324828E-04,   2.7055127E-04
     +,   2.7813140E-04,   2.8605893E-04,   2.9441161E-04
     +,   3.0327114E-04,   3.1272075E-04,   3.2284146E-04
     +,   3.3370775E-04,   3.4538101E-04,   3.5790922E-04
     +,   3.7131485E-04,   3.8559549E-04,   4.0071661E-04
     +,   4.1660946E-04,   4.3316802E-04,   4.5024979E-04
     +,   4.6767658E-04,   4.8523876E-04,   5.0269993E-04
     +,   5.1980541E-04,   5.3629017E-04,   5.5188523E-04
     +,   5.6633446E-04,   5.7939335E-04,   5.9084693E-04
     +,   6.0050742E-04,   6.0822262E-04,   6.1387994E-04
     +,   6.1740208E-04,   6.1875052E-04,   6.1792042E-04
     +,   6.1494001E-04,   6.0986850E-04,   6.0279353E-04
     +,   5.9383095E-04,   5.8312586E-04,   5.7085237E-04
     +,   5.5721641E-04,   5.4245582E-04,   5.2684016E-04
     +,   5.1067019E-04,   4.9427320E-04,   4.7799689E-04
     +,   4.6220305E-04,   4.4725044E-04,   4.3349058E-04
     +,   4.2124849E-04,   4.1081084E-04,   4.0241666E-04
     +,   3.9624260E-04,   3.9240005E-04,   3.9092806E-04
     +,   3.9179405E-04,   3.9489535E-04,   4.0006568E-04
     +,   4.0708287E-04,   4.1567930E-04,   4.2555301E-04
     +,   4.3638021E-04,   4.4782722E-04,   4.5956217E-04
     +,   4.7126628E-04,   4.8264349E-04,   4.9342896E-04
     +,   5.0339615E-04,   5.1235961E-04,   5.2018143E-04
     +,   5.2676990E-04,   5.3207832E-04,   5.3610362E-04
     +,   5.3887902E-04,   5.4046948E-04,   5.4096273E-04
     +,   5.4046133E-04,   5.3907296E-04,   5.3690234E-04
     +,   5.3404376E-04,   5.3057453E-04,   5.2655011E-04
     +,   5.2200281E-04,   5.1694078E-04,   5.1135017E-04
     +,   5.0519983E-04,   4.9844559E-04,   4.9103837E-04
     +,   4.8292984E-04,   4.7408117E-04,   4.6446768E-04
     +,   4.5408451E-04,   4.4295035E-04,   4.3110893E-04
     +,   4.1862999E-04,   4.0560498E-04,   3.9214475E-04
     +,   3.7837456E-04,   3.6442763E-04,   3.5043876E-04
     +,   3.3653851E-04,   3.2284670E-04,   3.0946799E-04
     +,   2.9648759E-04,   2.8396890E-04,   2.7195262E-04
     +,   2.6045673E-04,   2.4947821E-04,   2.3899475E-04
     +,   2.2897041E-04,   2.1935630E-04,   2.1009642E-04
     +,   2.0113162E-04,   1.9240260E-04,   1.8385489E-04
     +,   1.7543933E-04,   1.6711568E-04,   1.5885367E-04
     +,   1.5063371E-04,   1.4244714E-04,   1.3429557E-04
     +,   1.2619016E-04,   1.1815030E-04,   1.1020204E-04
     +,   1.0237641E-04,   9.4707815E-05,   8.7232082E-05
     +,   7.9985046E-05,   7.3000687E-05,   6.6311484E-05
     +,   5.9943912E-05,   5.3922024E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wao_fus_70 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wao_fus_75(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  5.9421293E-08,   6.5004023E-08
     +,   7.1056753E-08,   7.7613812E-08,   8.4710834E-08
     +,   9.2385996E-08,   1.0067944E-07,   1.0963333E-07
     +,   1.1929237E-07,   1.2970277E-07,   1.4091368E-07
     +,   1.5297641E-07,   1.6594446E-07,   1.7987409E-07
     +,   1.9482415E-07,   2.1085464E-07,   2.2802946E-07
     +,   2.4641437E-07,   2.6607776E-07,   2.8709053E-07
     +,   3.0952518E-07,   3.3345751E-07,   3.5896511E-07
     +,   3.8612799E-07,   4.1502892E-07,   4.4575069E-07
     +,   4.7838000E-07,   5.1300481E-07,   5.4971520E-07
     +,   5.8860053E-07,   6.2975408E-07,   6.7326891E-07
     +,   7.1923949E-07,   7.6776047E-07,   8.1892870E-07
     +,   8.7283644E-07,   9.2958089E-07,   9.8925614E-07
     +,   1.0519559E-06,   1.1177749E-06,   1.1868011E-06
     +,   1.2591247E-06,   1.3348334E-06,   1.4140103E-06
     +,   1.4967368E-06,   1.5830926E-06,   1.6731462E-06
     +,   1.7669689E-06,   1.8646263E-06,   1.9661725E-06
     +,   2.0716618E-06,   2.1811395E-06,   2.2946456E-06
     +,   2.4122110E-06,   2.5338595E-06,   2.6596065E-06
     +,   2.7894625E-06,   2.9234184E-06,   3.0614642E-06
     +,   3.2035832E-06,   3.3497363E-06,   3.4998839E-06
     +,   3.6539720E-06,   3.8119379E-06,   3.9737056E-06
     +,   4.1391881E-06,   4.3082946E-06,   4.4809076E-06
     +,   4.6569112E-06,   4.8361785E-06,   5.0185736E-06
     +,   5.2039404E-06,   5.3921276E-06,   5.5829714E-06
     +,   5.7763000E-06,   5.9719405E-06,   6.1697197E-06
     +,   6.3694461E-06,   6.5709487E-06,   6.7740493E-06
     +,   6.9785765E-06,   7.1843765E-06,   7.3912861E-06
     +,   7.5991757E-06,   7.8079329E-06,   8.0174614E-06
     +,   8.2277002E-06,   8.4386174E-06,   8.6502214E-06
     +,   8.8625720E-06,   9.0757512E-06,   9.2899272E-06
     +,   9.5053165E-06,   9.7222073E-06,   9.9409608E-06
     +,   1.0162021E-05,   1.0385930E-05,   1.0613296E-05
     +,   1.0844857E-05,   1.1081448E-05,   1.1324026E-05
     +,   1.1573662E-05,   1.1831557E-05,   1.2099048E-05
     +,   1.2377608E-05,   1.2668859E-05,   1.2974579E-05
     +,   1.3296700E-05,   1.3637326E-05,   1.3998734E-05
     +,   1.4383385E-05,   1.4793955E-05,   1.5233271E-05
     +,   1.5704427E-05,   1.6210744E-05,   1.6755788E-05
     +,   1.7343396E-05,   1.7977702E-05,   1.8663193E-05
     +,   1.9404593E-05,   2.0207113E-05,   2.1076319E-05
     +,   2.2018226E-05,   2.3039313E-05,   2.4146564E-05
     +,   2.5347488E-05,   2.6650148E-05,   2.8063198E-05
     +,   2.9595862E-05,   3.1257969E-05,   3.3059932E-05
     +,   3.5012828E-05,   3.7128000E-05,   3.9417504E-05
     +,   4.1893720E-05,   4.4569329E-05,   4.7457183E-05
     +,   5.0570161E-05,   5.3921005E-05,   5.7522258E-05
     +,   6.1385414E-05,   6.5521635E-05,   6.9940856E-05
     +,   7.4651653E-05,   7.9660909E-05,   8.4973653E-05
     +,   9.0592534E-05,   9.6517811E-05,   1.0274685E-04
     +,   1.0927397E-04,   1.1609018E-04,   1.2318350E-04
     +,   1.3053718E-04,   1.3813193E-04,   1.4594439E-04
     +,   1.5394758E-04,   1.6211116E-04,   1.7040138E-04
     +,   1.7878167E-04,   1.8721297E-04,   1.9565424E-04
     +,   2.0406372E-04,   2.1239788E-04,   2.2061479E-04
     +,   2.2867379E-04,   2.3653687E-04,   2.4417002E-04
     +,   2.5154464E-04,   2.5863876E-04,   2.6543878E-04
     +,   2.7194031E-04,   2.7814982E-04,   2.8408485E-04
     +,   2.8977537E-04,   2.9526226E-04,   3.0059851E-04
     +,   3.0584712E-04,   3.1107909E-04,   3.1637124E-04
     +,   3.2180359E-04,   3.2745392E-04,   3.3339733E-04
     +,   3.3969857E-04,   3.4641111E-04,   3.5357289E-04
     +,   3.6120386E-04,   3.6930482E-04,   3.7785675E-04
     +,   3.8682262E-04,   3.9614856E-04,   4.0576854E-04
     +,   4.1560794E-04,   4.2558968E-04,   4.3563725E-04
     +,   4.4568477E-04,   4.5567538E-04,   4.6557095E-04
     +,   4.7534925E-04,   4.8500608E-04,   4.9455621E-04
     +,   5.0402433E-04,   5.1344605E-04,   5.2285491E-04
     +,   5.3227949E-04,   5.4173253E-04,   5.5120414E-04
     +,   5.6065514E-04,   5.7001278E-04,   5.7916943E-04
     +,   5.8798358E-04,   5.9628621E-04,   6.0388912E-04
     +,   6.1059935E-04,   6.1623211E-04,   6.2063005E-04
     +,   6.2367885E-04,   6.2532484E-04,   6.2558625E-04
     +,   6.2456448E-04,   6.2244438E-04,   6.1949441E-04
     +,   6.1605347E-04,   6.1251689E-04,   6.0931459E-04
     +,   6.0688506E-04,   6.0564844E-04,   6.0598081E-04
     +,   6.0818822E-04,   6.1248877E-04,   6.1899790E-04
     +,   6.2772463E-04,   6.3857139E-04,   6.5134431E-04
     +,   6.6577189E-04,   6.8152382E-04,   6.9823826E-04
     +,   7.1554939E-04,   7.3311123E-04,   7.5062562E-04
     +,   7.6785771E-04,   7.8465044E-04,   8.0092915E-04
     +,   8.1669423E-04,   8.3201251E-04,   8.4699108E-04
     +,   8.6174998E-04,   8.7638514E-04,   8.9093199E-04
     +,   9.0533245E-04,   9.1940467E-04,   9.3282707E-04
     +,   9.4513618E-04,   9.5574046E-04,   9.6395332E-04
     +,   9.6903968E-04,   9.7027584E-04,   9.6701476E-04
     +,   9.5874839E-04,   9.4516564E-04,   9.2619023E-04
     +,   9.0200105E-04,   8.7302958E-04,   8.3993224E-04
     +,   8.0355274E-04,   7.6485216E-04,   7.2484626E-04
     +,   6.8453595E-04,   6.4484420E-04,   6.0656248E-04
     +,   5.7031697E-04,   5.3654605E-04,   5.0550012E-04
     +,   4.7725195E-04,   4.5172177E-04,   4.2870812E-04
     +,   4.0792345E-04,   3.8902985E-04,   3.7166997E-04
     +,   3.5549837E-04,   3.4019718E-04,   3.2549401E-04
     +,   3.1116931E-04,   2.9705800E-04,   2.8305023E-04
     +,   2.6908261E-04,   2.5513343E-04,   2.4121387E-04
     +,   2.2735955E-04,   2.1362309E-04,   2.0006669E-04
     +,   1.8675649E-04,   1.7375786E-04,   1.6113190E-04
     +,   1.4893326E-04,   1.3720844E-04,   1.2599523E-04
     +,   1.1532261E-04,   1.0521057E-04,   9.5673109E-05
     +,   8.6713924E-05,   7.8333578E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wao_fus_75 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wao_fus_80(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  5.6806346E-22,   9.0294428E-22
     +,   1.4311983E-21,   2.2621532E-21,   3.5654784E-21
     +,   5.6038849E-21,   8.7829391E-21,   1.3726771E-20
     +,   2.1393421E-20,   3.3247885E-20,   5.1526431E-20
     +,   7.9629492E-20,   1.2271496E-19,   1.8858318E-19
     +,   2.8899739E-19,   4.4163173E-19,   6.7299048E-19
     +,   1.0226815E-18,   1.5497244E-18,   2.3418321E-18
     +,   3.5288766E-18,   5.3027517E-18,   7.9460723E-18
     +,   1.1873738E-17,   1.7693514E-17,   2.6291972E-17
     +,   3.8960045E-17,   5.7570970E-17,   8.4836233E-17
     +,   1.2466468E-16,   1.8268263E-16,   2.6695734E-16
     +,   3.8902548E-16,   5.6533499E-16,   8.1927912E-16
     +,   1.1839915E-15,   1.7063193E-15,   2.4522720E-15
     +,   3.5145754E-15,   5.0231824E-15,   7.1594757E-15
     +,   1.0176120E-14,   1.4423963E-14,   2.0388659E-14
     +,   2.8740570E-14,   4.0402655E-14,   5.6640348E-14
     +,   7.9185871E-14,   1.1040296E-13,   1.5350327E-13
     +,   2.1284557E-13,   2.9432202E-13,   4.0587504E-13
     +,   5.5817964E-13,   7.6554556E-13,   1.0470860E-12
     +,   1.4282825E-12,   1.9429432E-12,   2.6358768E-12
     +,   3.5662595E-12,   4.8119304E-12,   6.4751351E-12
     +,   8.6896245E-12,   1.1629975E-11,   1.5523255E-11
     +,   2.0663957E-11,   2.7433155E-11,   3.6321619E-11
     +,   4.7960625E-11,   6.3159228E-11,   8.2951444E-11
     +,   1.0865326E-10,   1.4193721E-10,   1.8492076E-10
     +,   2.4027710E-10,   3.1136979E-10,   4.0242257E-10
     +,   5.1871052E-10,   6.6681938E-10,   8.5493351E-10
     +,   1.0931960E-09,   1.3941488E-09,   1.7732098E-09
     +,   2.2493403E-09,   2.8457319E-09,   3.5906815E-09
     +,   4.5186117E-09,   5.6712337E-09,   7.0989747E-09
     +,   8.8626377E-09,   1.1034973E-08,   1.3703287E-08
     +,   1.6971622E-08,   2.0963641E-08,   2.5825861E-08
     +,   3.1731233E-08,   3.8883652E-08,   4.7521088E-08
     +,   5.7922641E-08,   7.0412895E-08,   8.5368441E-08
     +,   1.0322449E-07,   1.2448230E-07,   1.4971685E-07
     +,   1.7958553E-07,   2.1483635E-07,   2.5631806E-07
     +,   3.0498899E-07,   3.6192722E-07,   4.2834023E-07
     +,   5.0557520E-07,   5.9513184E-07,   6.9865581E-07
     +,   8.1797003E-07,   9.5506664E-07,   1.1121169E-06
     +,   1.2914740E-06,   1.4956757E-06,   1.7274540E-06
     +,   1.9896879E-06,   2.2854613E-06,   2.6180071E-06
     +,   2.9907062E-06,   3.4070654E-06,   3.8706926E-06
     +,   4.3852665E-06,   4.9545038E-06,   5.5821170E-06
     +,   6.2717663E-06,   7.0270107E-06,   7.8512503E-06
     +,   8.7477047E-06,   9.7191878E-06,   1.0768272E-05
     +,   1.1897064E-05,   1.3107173E-05,   1.4399629E-05
     +,   1.5774809E-05,   1.7232376E-05,   1.8771269E-05
     +,   2.0389374E-05,   2.2083868E-05,   2.3850922E-05
     +,   2.5685713E-05,   2.7582408E-05,   2.9534158E-05
     +,   3.1533094E-05,   3.3570366E-05,   3.5636163E-05
     +,   3.7719787E-05,   3.9809707E-05,   4.1893778E-05
     +,   4.3958982E-05,   4.5992103E-05,   4.7979560E-05
     +,   4.9907652E-05,   5.1762814E-05,   5.3531843E-05
     +,   5.5202217E-05,   5.6762397E-05,   5.8202280E-05
     +,   5.9513670E-05,   6.0690603E-05,   6.1730359E-05
     +,   6.2633932E-05,   6.3407002E-05,   6.4060972E-05
     +,   6.4614047E-05,   6.5092681E-05,   6.5532942E-05
     +,   6.5982189E-05,   6.6500776E-05,   6.7163754E-05
     +,   6.8062662E-05,   6.9307054E-05,   7.1026057E-05
     +,   7.3369432E-05,   7.6508572E-05,   8.0637023E-05
     +,   8.5971420E-05,   9.2750764E-05,   1.0124092E-04
     +,   1.1173253E-04,   1.2454855E-04,   1.4004792E-04
     +,   1.5863252E-04,   1.8075391E-04,   2.0691787E-04
     +,   2.3768221E-04,   2.7364417E-04,   3.1541084E-04
     +,   3.6354852E-04,   4.1851067E-04,   4.8052793E-04
     +,   5.4952770E-04,   6.2498031E-04,   7.0586021E-04
     +,   7.9055491E-04,   8.7690860E-04,   9.6235209E-04
     +,   1.0440394E-03,   1.1191664E-03,   1.1852067E-03
     +,   1.2402276E-03,   1.2830821E-03,   1.3135126E-03
     +,   1.3321142E-03,   1.3401738E-03,   1.3394135E-03
     +,   1.3317097E-03,   1.3188419E-03,   1.3023494E-03
     +,   1.2835077E-03,   1.2634393E-03,   1.2433005E-03
     +,   1.2244964E-03,   1.2088300E-03,   1.1985705E-03
     +,   1.1963700E-03,   1.2050760E-03,   1.2274501E-03
     +,   1.2658647E-03,   1.3219747E-03,   1.3964609E-03
     +,   1.4888078E-03,   1.5971758E-03,   1.7183686E-03
     +,   1.8479320E-03,   1.9803836E-03,   2.1095648E-03
     +,   2.2290547E-03,   2.3326017E-03,   2.4144980E-03
     +,   2.4698891E-03,   2.4950409E-03,   2.4875947E-03
     +,   2.4468382E-03,   2.3739617E-03,   2.2721917E-03
     +,   2.1467227E-03,   2.0043419E-03,   1.8527677E-03
     +,   1.6998355E-03,   1.5525952E-03,   1.4166493E-03
     +,   1.2957646E-03,   1.1918318E-03,   1.1051277E-03
     +,   1.0347681E-03,   9.7921200E-04,   9.3670859E-04
     +,   9.0561254E-04,   8.8454748E-04,   8.7243115E-04
     +,   8.6841412E-04,   8.7176129E-04,   8.8173681E-04
     +,   8.9750858E-04,   9.1808912E-04,   9.4232633E-04
     +,   9.6892321E-04,   9.9648384E-04,   1.0235717E-03
     +,   1.0487587E-03,   1.0706849E-03,   1.0880923E-03
     +,   1.0998613E-03,   1.1050440E-03,   1.1028908E-03
     +,   1.0928828E-03,   1.0747585E-03,   1.0485330E-03
     +,   1.0145088E-03,   9.7326696E-04,   9.2564436E-04
     +,   8.7269139E-04,   8.1561675E-04,   7.5571908E-04
     +,   6.9433160E-04,   6.3273771E-04,   5.7212560E-04
     +,   5.1353913E-04,   4.5784234E-04,   4.0571185E-04
     +,   3.5761661E-04,   3.1383589E-04,   2.7447304E-04
     +,   2.3947940E-04,   2.0868164E-04,   1.8181159E-04
     +,   1.5853487E-04,   1.3847832E-04,   1.2125354E-04
     +,   1.0647670E-04,   9.3783943E-05,   8.2842525E-05
     +,   7.3357645E-05,   6.5075452E-05,   5.7785091E-05
     +,   5.1312836E-05,   4.5523062E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wao_fus_80 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wao_fus_85(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  3.9521137E-08,   4.3496641E-08
     +,   4.7831545E-08,   5.2554071E-08,   5.7693931E-08
     +,   6.3282862E-08,   6.9354478E-08,   7.5944357E-08
     +,   8.3090228E-08,   9.0831314E-08,   9.9209700E-08
     +,   1.0826917E-07,   1.1805597E-07,   1.2861850E-07
     +,   1.4000787E-07,   1.5227654E-07,   1.6548013E-07
     +,   1.7967652E-07,   1.9492576E-07,   2.1129068E-07
     +,   2.2883535E-07,   2.4762713E-07,   2.6773549E-07
     +,   2.8923176E-07,   3.1219022E-07,   3.3668545E-07
     +,   3.6279528E-07,   3.9059941E-07,   4.2017928E-07
     +,   4.5161605E-07,   4.8499419E-07,   5.2039871E-07
     +,   5.5791526E-07,   5.9763056E-07,   6.3963250E-07
     +,   6.8400590E-07,   7.3083913E-07,   7.8021827E-07
     +,   8.3222898E-07,   8.8695737E-07,   9.4448365E-07
     +,   1.0048902E-06,   1.0682555E-06,   1.1346558E-06
     +,   1.2041641E-06,   1.2768505E-06,   1.3527779E-06
     +,   1.4320077E-06,   1.5145976E-06,   1.6005934E-06
     +,   1.6900409E-06,   1.7829777E-06,   1.8794343E-06
     +,   1.9794331E-06,   2.0829889E-06,   2.1901087E-06
     +,   2.3007924E-06,   2.4150222E-06,   2.5327802E-06
     +,   2.6540361E-06,   2.7787421E-06,   2.9068483E-06
     +,   3.0382894E-06,   3.1729899E-06,   3.3108604E-06
     +,   3.4518030E-06,   3.5957075E-06,   3.7424438E-06
     +,   3.8918793E-06,   4.0438640E-06,   4.1982416E-06
     +,   4.3548325E-06,   4.5134561E-06,   4.6739146E-06
     +,   4.8360025E-06,   4.9995015E-06,   5.1641869E-06
     +,   5.3298145E-06,   5.4961420E-06,   5.6629133E-06
     +,   5.8298688E-06,   5.9967415E-06,   6.1632554E-06
     +,   6.3291332E-06,   6.4940959E-06,   6.6578641E-06
     +,   6.8201557E-06,   6.9806924E-06,   7.1391987E-06
     +,   7.2954117E-06,   7.4490540E-06,   7.5998792E-06
     +,   7.7476443E-06,   7.8921230E-06,   8.0331019E-06
     +,   8.1703856E-06,   8.3038112E-06,   8.4332160E-06
     +,   8.5584816E-06,   8.6795171E-06,   8.7962617E-06
     +,   8.9086889E-06,   9.0168114E-06,   9.1206848E-06
     +,   9.2204036E-06,   9.3161107E-06,   9.4080033E-06
     +,   9.4963234E-06,   9.5813739E-06,   9.6635131E-06
     +,   9.7431566E-06,   9.8207884E-06,   9.8969404E-06
     +,   9.9722265E-06,   1.0047313E-05,   1.0122939E-05
     +,   1.0199908E-05,   1.0279084E-05,   1.0361405E-05
     +,   1.0447856E-05,   1.0539496E-05,   1.0637433E-05
     +,   1.0742835E-05,   1.0856917E-05,   1.0980937E-05
     +,   1.1116197E-05,   1.1264029E-05,   1.1425795E-05
     +,   1.1602877E-05,   1.1796676E-05,   1.2008591E-05
     +,   1.2240044E-05,   1.2492413E-05,   1.2767090E-05
     +,   1.3065448E-05,   1.3388827E-05,   1.3738541E-05
     +,   1.4115873E-05,   1.4522067E-05,   1.4958353E-05
     +,   1.5425867E-05,   1.5925772E-05,   1.6459182E-05
     +,   1.7027191E-05,   1.7630871E-05,   1.8271303E-05
     +,   1.8949566E-05,   1.9666762E-05,   2.0424035E-05
     +,   2.1222570E-05,   2.2063618E-05,   2.2948549E-05
     +,   2.3878700E-05,   2.4855615E-05,   2.5880889E-05
     +,   2.6956210E-05,   2.8083332E-05,   2.9264051E-05
     +,   3.0500179E-05,   3.1793494E-05,   3.3145683E-05
     +,   3.4558347E-05,   3.6032685E-05,   3.7569840E-05
     +,   3.9170620E-05,   4.0835570E-05,   4.2565080E-05
     +,   4.4359538E-05,   4.6219706E-05,   4.8147169E-05
     +,   5.0145096E-05,   5.2219195E-05,   5.4379074E-05
     +,   5.6640005E-05,   5.9024627E-05,   6.1566046E-05
     +,   6.4310567E-05,   6.7321118E-05,   7.0681206E-05
     +,   7.4499207E-05,   7.8912024E-05,   8.4091407E-05
     +,   9.0245405E-05,   9.7624288E-05,   1.0652283E-04
     +,   1.1728318E-04,   1.3029791E-04,   1.4601437E-04
     +,   1.6494255E-04,   1.8766844E-04,   2.1487547E-04
     +,   2.4737601E-04,   2.8615180E-04,   3.3238548E-04
     +,   3.8751098E-04,   4.5317918E-04,   5.3123885E-04
     +,   6.2355783E-04,   7.3180080E-04,   8.5714593E-04
     +,   9.9985511E-04,   1.1590598E-03,   1.3325373E-03
     +,   1.5169788E-03,   1.7085623E-03,   1.9039705E-03
     +,   2.1015902E-03,   2.3024923E-03,   2.5106331E-03
     +,   2.7318813E-03,   2.9718627E-03,   3.2332053E-03
     +,   3.5132950E-03,   3.8035570E-03,   4.0906924E-03
     +,   4.3594260E-03,   4.5961556E-03,   4.7923978E-03
     +,   4.9482249E-03,   5.0744247E-03,   5.1918589E-03
     +,   5.3260108E-03,   5.4965150E-03,   5.7055820E-03
     +,   5.9314515E-03,   6.1319005E-03,   6.2578688E-03
     +,   6.2714745E-03,   6.1603449E-03,   5.9421868E-03
     +,   5.6583006E-03,   5.3597786E-03,   5.0926111E-03
     +,   4.8872177E-03,   4.7545768E-03,   4.6875831E-03
     +,   4.6649710E-03,   4.6564834E-03,   4.6295552E-03
     +,   4.5577455E-03,   4.4289571E-03,   4.2497329E-03
     +,   4.0428350E-03,   3.8384800E-03,   3.6631667E-03
     +,   3.5310548E-03,   3.4411945E-03,   3.3807836E-03
     +,   3.3319851E-03,   3.2788408E-03,   3.2117034E-03
     +,   3.1282138E-03,   3.0315311E-03,   2.9273741E-03
     +,   2.8213889E-03,   2.7176919E-03,   2.6186283E-03
     +,   2.5252751E-03,   2.4380398E-03,   2.3569663E-03
     +,   2.2817203E-03,   2.2114227E-03,   2.1445623E-03
     +,   2.0791658E-03,   2.0131716E-03,   1.9449304E-03
     +,   1.8736507E-03,   1.7996357E-03,   1.7242816E-03
     +,   1.6498130E-03,   1.5788586E-03,   1.5139511E-03
     +,   1.4570648E-03,   1.4092780E-03,   1.3706083E-03
     +,   1.3400288E-03,   1.3156370E-03,   1.2949309E-03
     +,   1.2751389E-03,   1.2535283E-03,   1.2276944E-03
     +,   1.1957597E-03,   1.1565001E-03,   1.1093958E-03
     +,   1.0545945E-03,   9.9283655E-04,   9.2532788E-04
     +,   8.5359736E-04,   7.7934464E-04,   7.0430245E-04
     +,   6.3011475E-04,   5.5824424E-04,   4.8990716E-04
     +,   4.2604178E-04,   3.6729907E-04,   3.1405792E-04
     +,   2.6645412E-04,   2.2441844E-04,   1.8772882E-04
     +,   1.5603522E-04,   1.2892316E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wao_fus_85 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wao_fus_90(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  5.4926040E-17,   7.2549265E-17
     +,   9.5683780E-17,   1.2600735E-16,   1.6569137E-16
     +,   2.1754768E-16,   2.8520550E-16,   3.7334642E-16
     +,   4.8799913E-16,   6.3690197E-16,   8.2999419E-16
     +,   1.0800107E-15,   1.4032391E-15,   1.8204762E-15
     +,   2.3582496E-15,   3.0503003E-15,   3.9395367E-15
     +,   5.0803948E-15,   6.5418218E-15,   8.4111202E-15
     +,   1.0798279E-14,   1.3842251E-14,   1.7717719E-14
     +,   2.2644325E-14,   2.8897640E-14,   3.6822518E-14
     +,   4.6850422E-14,   5.9520273E-14,   7.5503467E-14
     +,   9.5635034E-14,   1.2095330E-13,   1.5274509E-13
     +,   1.9260455E-13,   2.4250214E-13,   3.0487212E-13
     +,   3.8270689E-13,   4.7969522E-13,   6.0036351E-13
     +,   7.5026189E-13,   9.3618765E-13,   1.1664385E-12
     +,   1.4511412E-12,   1.8026344E-12,   2.2359154E-12
     +,   2.7691881E-12,   3.4245397E-12,   4.2286253E-12
     +,   5.2137036E-12,   6.4186742E-12,   7.8902718E-12
     +,   9.6847565E-12,   1.1869567E-11,   1.4525488E-11
     +,   1.7749135E-11,   2.1655740E-11,   2.6382658E-11
     +,   3.2093408E-11,   3.8981752E-11,   4.7277720E-11
     +,   5.7253702E-11,   6.9230559E-11,   8.3587769E-11
     +,   1.0077142E-10,   1.2130588E-10,   1.4580620E-10
     +,   1.7499271E-10,   2.0970839E-10,   2.5093394E-10
     +,   2.9981484E-10,   3.5768166E-10,   4.2608098E-10
     +,   5.0679860E-10,   6.0190636E-10,   7.1379302E-10
     +,   8.4521190E-10,   9.9933084E-10,   1.1797886E-09
     +,   1.3907447E-09,   1.6369714E-09,   1.9239128E-09
     +,   2.2577684E-09,   2.6456073E-09,   3.0954257E-09
     +,   3.6163124E-09,   4.2185389E-09,   4.9137006E-09
     +,   5.7148721E-09,   6.6367574E-09,   7.6958457E-09
     +,   8.9106837E-09,   1.0301839E-08,   1.1892441E-08
     +,   1.3708173E-08,   1.5777610E-08,   1.8132436E-08
     +,   2.0807745E-08,   2.3842469E-08,   2.7279100E-08
     +,   3.1164817E-08,   3.5551352E-08,   4.0495387E-08
     +,   4.6058926E-08,   5.2309701E-08,   5.9321437E-08
     +,   6.7174462E-08,   7.5955882E-08,   8.5760014E-08
     +,   9.6688900E-08,   1.0885267E-07,   1.2236993E-07
     +,   1.3736818E-07,   1.5398503E-07,   1.7236546E-07
     +,   1.9266731E-07,   2.1505758E-07,   2.3971501E-07
     +,   2.6682935E-07,   2.9660248E-07,   3.2925044E-07
     +,   3.6499713E-07,   4.0408463E-07,   4.4676722E-07
     +,   4.9331402E-07,   5.4400869E-07,   5.9915095E-07
     +,   6.5905687E-07,   7.2405959E-07,   7.9451030E-07
     +,   8.7077893E-07,   9.5325521E-07,   1.0423506E-06
     +,   1.1385021E-06,   1.2421584E-06,   1.3538055E-06
     +,   1.4739524E-06,   1.6031365E-06,   1.7419263E-06
     +,   1.8909221E-06,   2.0507623E-06,   2.2221286E-06
     +,   2.4057231E-06,   2.6023163E-06,   2.8127188E-06
     +,   3.0377967E-06,   3.2784753E-06,   3.5357430E-06
     +,   3.8106648E-06,   4.1043818E-06,   4.4181261E-06
     +,   4.7532299E-06,   5.1111397E-06,   5.4934426E-06
     +,   5.9018203E-06,   6.3381658E-06,   6.8045388E-06
     +,   7.3032079E-06,   7.8366775E-06,   8.4077174E-06
     +,   9.0193989E-06,   9.6751310E-06,   1.0378704E-05
     +,   1.1134359E-05,   1.1946691E-05,   1.2820908E-05
     +,   1.3762714E-05,   1.4778383E-05,   1.5874784E-05
     +,   1.7059376E-05,   1.8340199E-05,   1.9725840E-05
     +,   2.1225374E-05,   2.2848270E-05,   2.4604271E-05
     +,   2.6503350E-05,   2.8555201E-05,   3.0769588E-05
     +,   3.3155906E-05,   3.5723151E-05,   3.8480026E-05
     +,   4.1435291E-05,   4.4597618E-05,   4.7978174E-05
     +,   5.1590341E-05,   5.5454078E-05,   5.9599675E-05
     +,   6.4074316E-05,   6.8951864E-05,   7.4346652E-05
     +,   8.0432634E-05,   8.7468739E-05,   9.5831565E-05
     +,   1.0605451E-04,   1.1887364E-04,   1.3527155E-04
     +,   1.5652852E-04,   1.8424190E-04,   2.2035002E-04
     +,   2.6708824E-04,   3.2691532E-04,   4.0240405E-04
     +,   4.9601967E-04,   6.0997222E-04,   7.4596883E-04
     +,   9.0515893E-04,   1.0881448E-03,   1.2951788E-03
     +,   1.5264546E-03,   1.7823548E-03,   2.0634045E-03
     +,   2.3697494E-03,   2.7001002E-03,   3.0504365E-03
     +,   3.4130453E-03,   3.7766101E-03,   4.1278363E-03
     +,   4.4542961E-03,   4.7479272E-03,   5.0071268E-03
     +,   5.2370424E-03,   5.4472275E-03,   5.6477361E-03
     +,   5.8452394E-03,   6.0403445E-03,   6.2281955E-03
     +,   6.4037591E-03,   6.5736230E-03,   6.7720455E-03
     +,   7.0712380E-03,   7.5692083E-03,   8.3449045E-03
     +,   9.3952967E-03,   1.0597582E-02,   1.1742884E-02
     +,   1.2644927E-02,   1.3254383E-02,   1.3672558E-02
     +,   1.4034464E-02,   1.4379654E-02,   1.4658686E-02
     +,   1.4852034E-02,   1.5036745E-02,   1.5326147E-02
     +,   1.5759928E-02,   1.6230851E-02,   1.6499581E-02
     +,   1.6334033E-02,   1.5697910E-02,   1.4797979E-02
     +,   1.3918562E-02,   1.3207773E-02,   1.2613195E-02
     +,   1.1988698E-02,   1.1247496E-02,   1.0432580E-02
     +,   9.6659278E-03,   9.0386262E-03,   8.5412413E-03
     +,   8.0859205E-03,   7.5867558E-03,   7.0226779E-03
     +,   6.4405659E-03,   5.9153838E-03,   5.5094231E-03
     +,   5.2540135E-03,   5.1493300E-03,   5.1701223E-03
     +,   5.2716006E-03,   5.3972574E-03,   5.4903510E-03
     +,   5.5066287E-03,   5.4233223E-03,   5.2408222E-03
     +,   4.9771643E-03,   4.6589249E-03,   4.3126633E-03
     +,   3.9597051E-03,   3.6146052E-03,   3.2860779E-03
     +,   2.9788411E-03,   2.6951665E-03,   2.4359375E-03
     +,   2.2010901E-03,   1.9897064E-03,   1.8000857E-03
     +,   1.6297883E-03,   1.4759235E-03,   1.3355030E-03
     +,   1.2058211E-03,   1.0847530E-03,   9.7089563E-04
     +,   8.6354953E-04,   7.6256797E-04,   6.6814746E-04
     +,   5.8062188E-04,   5.0030026E-04,   4.2737173E-04
     +,   3.6186486E-04,   3.0364757E-04,   2.5246295E-04
     +,   2.0793287E-04,   1.6961856E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wao_fus_90 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wao_fus_95(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  5.1544082E-11,   6.0749419E-11
     +,   7.1524751E-11,   8.4124534E-11,   9.8841352E-11
     +,   1.1601269E-10,   1.3602680E-10,   1.5932911E-10
     +,   1.8643158E-10,   2.1791859E-10,   2.5446154E-10
     +,   2.9682670E-10,   3.4588923E-10,   4.0264667E-10
     +,   4.6823817E-10,   5.4395372E-10,   6.3126504E-10
     +,   7.3183942E-10,   8.4756807E-10,   9.8059538E-10
     +,   1.1333375E-09,   1.3085314E-09,   1.5092614E-09
     +,   1.7390067E-09,   2.0016835E-09,   2.3016793E-09
     +,   2.6439371E-09,   3.0339908E-09,   3.4780465E-09
     +,   3.9830241E-09,   4.5566759E-09,   5.2076414E-09
     +,   5.9455445E-09,   6.7811037E-09,   7.7262490E-09
     +,   8.7941521E-09,   9.9994875E-09,   1.1358484E-08
     +,   1.2889068E-08,   1.4611102E-08,   1.6546343E-08
     +,   1.8718898E-08,   2.1155220E-08,   2.3884368E-08
     +,   2.6938251E-08,   3.0351881E-08,   3.4163293E-08
     +,   3.8414306E-08,   4.3150635E-08,   4.8421597E-08
     +,   5.4281308E-08,   6.0788395E-08,   6.8006464E-08
     +,   7.6004440E-08,   8.4856737E-08,   9.4643923E-08
     +,   1.0545300E-07,   1.1737693E-07,   1.3051636E-07
     +,   1.4497944E-07,   1.6088110E-07,   1.7834526E-07
     +,   1.9750385E-07,   2.1849797E-07,   2.4147727E-07
     +,   2.6660126E-07,   2.9403955E-07,   3.2397011E-07
     +,   3.5658269E-07,   3.9207703E-07,   4.3066427E-07
     +,   4.7256412E-07,   5.1800919E-07,   5.6724218E-07
     +,   6.2051731E-07,   6.7809879E-07,   7.4026315E-07
     +,   8.0729330E-07,   8.7948649E-07,   9.5714779E-07
     +,   1.0405921E-06,   1.1301446E-06,   1.2261324E-06
     +,   1.3288960E-06,   1.4387804E-06,   1.5561349E-06
     +,   1.6813135E-06,   1.8146739E-06,   1.9565739E-06
     +,   2.1073786E-06,   2.2674319E-06,   2.4370934E-06
     +,   2.6167118E-06,   2.8066270E-06,   3.0071715E-06
     +,   3.2186654E-06,   3.4414245E-06,   3.6757203E-06
     +,   3.9218335E-06,   4.1800145E-06,   4.4504905E-06
     +,   4.7334606E-06,   5.0290973E-06,   5.3375393E-06
     +,   5.6588915E-06,   5.9932217E-06,   6.3405587E-06
     +,   6.7008896E-06,   7.0741539E-06,   7.4602463E-06
     +,   7.8590128E-06,   8.2702672E-06,   8.6937125E-06
     +,   9.1290503E-06,   9.5759133E-06,   1.0033875E-05
     +,   1.0502447E-05,   1.0981089E-05,   1.1469217E-05
     +,   1.1966126E-05,   1.2471115E-05,   1.2983412E-05
     +,   1.3502180E-05,   1.4026535E-05,   1.4555534E-05
     +,   1.5088192E-05,   1.5623475E-05,   1.6160309E-05
     +,   1.6697584E-05,   1.7234162E-05,   1.7768871E-05
     +,   1.8300550E-05,   1.8827961E-05,   1.9349920E-05
     +,   1.9865241E-05,   2.0372749E-05,   2.0871292E-05
     +,   2.1359760E-05,   2.1837097E-05,   2.2302338E-05
     +,   2.2754539E-05,   2.3192897E-05,   2.3616725E-05
     +,   2.4025465E-05,   2.4418710E-05,   2.4796227E-05
     +,   2.5157990E-05,   2.5504187E-05,   2.5835243E-05
     +,   2.6151878E-05,   2.6455089E-05,   2.6746215E-05
     +,   2.7026916E-05,   2.7299255E-05,   2.7565713E-05
     +,   2.7829192E-05,   2.8093065E-05,   2.8361226E-05
     +,   2.8638062E-05,   2.8928549E-05,   2.9238237E-05
     +,   2.9573346E-05,   2.9940700E-05,   3.0347881E-05
     +,   3.0803225E-05,   3.1315871E-05,   3.1895830E-05
     +,   3.2554079E-05,   3.3302618E-05,   3.4154567E-05
     +,   3.5124311E-05,   3.6227582E-05,   3.7481670E-05
     +,   3.8905568E-05,   4.0519990E-05,   4.2347874E-05
     +,   4.4414428E-05,   4.6747380E-05,   4.9377330E-05
     +,   5.2338164E-05,   5.5666824E-05,   5.9405247E-05
     +,   6.3598971E-05,   6.8299516E-05,   7.3564530E-05
     +,   7.9459067E-05,   8.6057000E-05,   9.3442723E-05
     +,   1.0171310E-04,   1.1097971E-04,   1.2137142E-04
     +,   1.3303701E-04,   1.4614873E-04,   1.6090223E-04
     +,   1.7752651E-04,   1.9627668E-04,   2.1744944E-04
     +,   2.4137380E-04,   2.6841727E-04,   2.9899480E-04
     +,   3.3354817E-04,   3.7256154E-04,   4.1652523E-04
     +,   4.6593268E-04,   5.2124239E-04,   5.8284303E-04
     +,   6.5101363E-04,   7.2588987E-04,   8.0744585E-04
     +,   8.9550839E-04,   9.8981766E-04,   1.0901411E-03
     +,   1.1964511E-03,   1.3091391E-03,   1.4292510E-03
     +,   1.5586435E-03,   1.7001260E-03,   1.8572926E-03
     +,   2.0343221E-03,   2.2355171E-03,   2.4647254E-03
     +,   2.7248950E-03,   3.0173992E-03,   3.3416087E-03
     +,   3.6942072E-03,   4.0684449E-03,   4.4534276E-03
     +,   4.8339111E-03,   5.1911706E-03,   5.5055097E-03
     +,   5.7602916E-03,   5.9467498E-03,   6.0679889E-03
     +,   6.1404817E-03,   6.1916602E-03,   6.2535945E-03
     +,   6.3545275E-03,   6.5113348E-03,   6.7259828E-03
     +,   6.9863852E-03,   7.2700717E-03,   7.5485464E-03
     +,   7.7938889E-03,   7.9909228E-03,   8.1537571E-03
     +,   8.3384756E-03,   8.6414162E-03,   9.1790762E-03
     +,   1.0050210E-02,   1.1278333E-02,   1.2745963E-02
     +,   1.4173705E-02,   1.5214759E-02,   1.5653653E-02
     +,   1.5570343E-02,   1.5327154E-02,   1.5385188E-02
     +,   1.6059685E-02,   1.7310489E-02,   1.8701069E-02
     +,   1.9674843E-02,   2.0011360E-02,   2.0003155E-02
     +,   2.0133281E-02,   2.0602070E-02,   2.1187257E-02
     +,   2.1505687E-02,   2.1335332E-02,   2.0696830E-02
     +,   1.9749897E-02,   1.8712107E-02,   1.7822595E-02
     +,   1.7249569E-02,   1.6964700E-02,   1.6734386E-02
     +,   1.6282108E-02,   1.5484727E-02,   1.4437178E-02
     +,   1.3360833E-02,   1.2445148E-02,   1.1735320E-02
     +,   1.1131625E-02,   1.0481464E-02,   9.6792979E-03
     +,   8.7074731E-03,   7.6182131E-03,   6.4939451E-03
     +,   5.4145115E-03,   4.4385949E-03,   3.5973440E-03
     +,   2.8970672E-03,   2.3271397E-03,   1.8687219E-03
     +,   1.5013171E-03,   1.2063399E-03,   9.6844207E-04
     +,   7.7560643E-04,   6.1869086E-04,   4.9085269E-04
     +,   3.8688350E-04,   3.0278007E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wao_fus_95 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wao_hz_100(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  5.7680655E-11,   6.5899723E-11
     +,   7.5233028E-11,   8.5823404E-11,   9.7830494E-11
     +,   1.1143296E-10,   1.2683074E-10,   1.4424717E-10
     +,   1.6393180E-10,   1.8616136E-10,   2.1124572E-10
     +,   2.3952890E-10,   2.7139418E-10,   3.0726610E-10
     +,   3.4761771E-10,   3.9297116E-10,   4.4390661E-10
     +,   5.0106619E-10,   5.6515925E-10,   6.3697242E-10
     +,   7.1736683E-10,   8.0730062E-10,   9.0782565E-10
     +,   1.0200982E-09,   1.1453987E-09,   1.2851170E-09
     +,   1.4407971E-09,   1.6141224E-09,   1.8069448E-09
     +,   2.0212787E-09,   2.2593418E-09,   2.5235500E-09
     +,   2.8165414E-09,   3.1411995E-09,   3.5006678E-09
     +,   3.8983443E-09,   4.3379549E-09,   4.8235425E-09
     +,   5.3594795E-09,   5.9505445E-09,   6.6018648E-09
     +,   7.3190245E-09,   8.1080582E-09,   8.9754932E-09
     +,   9.9283621E-09,   1.0974288E-08,   1.2121403E-08
     +,   1.3378537E-08,   1.4755187E-08,   1.6261469E-08
     +,   1.7908345E-08,   1.9707530E-08,   2.1671568E-08
     +,   2.3813891E-08,   2.6148872E-08,   2.8691852E-08
     +,   3.1459290E-08,   3.4468510E-08,   3.7738179E-08
     +,   4.1288196E-08,   4.5139441E-08,   4.9314362E-08
     +,   5.3836658E-08,   5.8731526E-08,   6.4025599E-08
     +,   6.9747053E-08,   7.5925840E-08,   8.2593161E-08
     +,   8.9782340E-08,   9.7528371E-08,   1.0586833E-07
     +,   1.1484062E-07,   1.2448611E-07,   1.3484758E-07
     +,   1.4597001E-07,   1.5790026E-07,   1.7068794E-07
     +,   1.8438396E-07,   1.9904236E-07,   2.1471929E-07
     +,   2.3147317E-07,   2.4936551E-07,   2.6845899E-07
     +,   2.8881988E-07,   3.1051655E-07,   3.3362022E-07
     +,   3.5820437E-07,   3.8434538E-07,   4.1212178E-07
     +,   4.4161652E-07,   4.7291090E-07,   5.0609248E-07
     +,   5.4125076E-07,   5.7847677E-07,   6.1786483E-07
     +,   6.5951139E-07,   7.0351700E-07,   7.4997865E-07
     +,   7.9900161E-07,   8.5069087E-07,   9.0515363E-07
     +,   9.6249823E-07,   1.0228360E-06,   1.0862781E-06
     +,   1.1529380E-06,   1.2229297E-06,   1.2963687E-06
     +,   1.3733702E-06,   1.4540503E-06,   1.5385250E-06
     +,   1.6269097E-06,   1.7193238E-06,   1.8158730E-06
     +,   1.9166739E-06,   2.0218365E-06,   2.1314702E-06
     +,   2.2456804E-06,   2.3645698E-06,   2.4882431E-06
     +,   2.6167827E-06,   2.7502849E-06,   2.8888333E-06
     +,   3.0325077E-06,   3.1813790E-06,   3.3355125E-06
     +,   3.4949655E-06,   3.6597869E-06,   3.8300177E-06
     +,   4.0056889E-06,   4.1868225E-06,   4.3734308E-06
     +,   4.5655252E-06,   4.7630797E-06,   4.9660875E-06
     +,   5.1745219E-06,   5.3883496E-06,   5.6075310E-06
     +,   5.8320197E-06,   6.0617704E-06,   6.2967479E-06
     +,   6.5368913E-06,   6.7821825E-06,   7.0326091E-06
     +,   7.2881885E-06,   7.5489711E-06,   7.8150524E-06
     +,   8.0865939E-06,   8.3638315E-06,   8.6471009E-06
     +,   8.9368541E-06,   9.2336895E-06,   9.5383912E-06
     +,   9.8519067E-06,   1.0175467E-05,   1.0510572E-05
     +,   1.0859044E-05,   1.1223083E-05,   1.1605311E-05
     +,   1.2008828E-05,   1.2437276E-05,   1.2894895E-05
     +,   1.3386603E-05,   1.3917985E-05,   1.4495474E-05
     +,   1.5126338E-05,   1.5818761E-05,   1.6581902E-05
     +,   1.7425959E-05,   1.8362221E-05,   1.9403118E-05
     +,   2.0562265E-05,   2.1854514E-05,   2.3296017E-05
     +,   2.4904310E-05,   2.6698115E-05,   2.8697812E-05
     +,   3.0925265E-05,   3.3404016E-05,   3.6159468E-05
     +,   3.9219223E-05,   4.2612726E-05,   4.6373236E-05
     +,   5.0536291E-05,   5.5142071E-05,   6.0235492E-05
     +,   6.5867280E-05,   7.2095245E-05,   7.8985562E-05
     +,   8.6614222E-05,   9.5068586E-05,   1.0444870E-04
     +,   1.1486861E-04,   1.2645792E-04,   1.3935876E-04
     +,   1.5373186E-04,   1.6974518E-04,   1.8758103E-04
     +,   2.0742127E-04,   2.2944339E-04,   2.5381774E-04
     +,   2.8068208E-04,   3.1014622E-04,   3.4226000E-04
     +,   3.7701265E-04,   4.1431349E-04,   4.5398166E-04
     +,   4.9573887E-04,   5.3920702E-04,   5.8391230E-04
     +,   6.2929641E-04,   6.7473698E-04,   7.1957498E-04
     +,   7.6315104E-04,   8.0484909E-04,   8.4414531E-04
     +,   8.8065240E-04,   9.1419060E-04,   9.4481558E-04
     +,   9.7288354E-04,   9.9908304E-04,   1.0244646E-03
     +,   1.0504753E-03,   1.0789558E-03,   1.1121534E-03
     +,   1.1527034E-03,   1.2036019E-03,   1.2681440E-03
     +,   1.3498463E-03,   1.4523332E-03,   1.5791911E-03
     +,   1.7337973E-03,   1.9190809E-03,   2.1372035E-03
     +,   2.3891060E-03,   2.6739109E-03,   2.9882272E-03
     +,   3.3255166E-03,   3.6756457E-03,   4.0251222E-03
     +,   4.3578688E-03,   4.6568550E-03,   4.9062837E-03
     +,   5.0939918E-03,   5.2137617E-03,   5.2668354E-03
     +,   5.2625407E-03,   5.2176788E-03,   5.1547685E-03
     +,   5.0991816E-03,   5.0755292E-03,   5.1039006E-03
     +,   5.1968386E-03,   5.3580226E-03,   5.5832239E-03
     +,   5.8629271E-03,   6.1850804E-03,   6.5362779E-03
     +,   6.9009163E-03,   7.2598928E-03,   7.5915968E-03
     +,   7.8761708E-03,   8.1021776E-03,   8.2726628E-03
     +,   8.4085390E-03,   8.5485103E-03,   8.7443823E-03
     +,   9.0496652E-03,   9.5017245E-03,   1.0106729E-02
     +,   1.0843794E-02,   1.1691016E-02,   1.2647938E-02
     +,   1.3726944E-02,   1.4924573E-02,   1.6204568E-02
     +,   1.7498298E-02,   1.8729877E-02,   1.9885397E-02
     +,   2.1039847E-02,   2.2207506E-02,   2.3177629E-02
     +,   2.3680683E-02,   2.3735346E-02,   2.3632567E-02
     +,   2.3590544E-02,   2.3634974E-02,   2.3754986E-02
     +,   2.3963099E-02,   2.4228817E-02,   2.4414835E-02
     +,   2.4234114E-02,   2.3353111E-02,   2.1639796E-02
     +,   1.9257046E-02,   1.6494013E-02,   1.3577316E-02
     +,   1.0649597E-02,   7.8525860E-03,   5.3688893E-03
     +,   3.3683390E-03,   1.9287312E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wao_hz_100 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wao_hz_105(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  1.3465709E-19,   1.8967099E-19
     +,   2.6667246E-19,   3.7425210E-19,   5.2426625E-19
     +,   7.3307243E-19,   1.0231677E-18,   1.4254518E-18
     +,   1.9822953E-18,   2.7516039E-18,   3.8124978E-18
     +,   5.2727875E-18,   7.2790761E-18,   1.0030428E-17
     +,   1.3796638E-17,   1.8942118E-17,   2.5959206E-17
     +,   3.5510837E-17,   4.8488342E-17,   6.6088224E-17
     +,   8.9911396E-17,   1.2209939E-16,   1.6550795E-16
     +,   2.2394053E-16,   3.0245283E-16,   4.0774292E-16
     +,   5.4868645E-16,   7.3700347E-16,   9.8816071E-16
     +,   1.3224859E-15,   1.7667032E-15,   2.3558381E-15
     +,   3.1357221E-15,   4.1661866E-15,   5.5252666E-15
     +,   7.3143345E-15,   9.6651347E-15,   1.2748265E-14
     +,   1.6784424E-14,   2.2058498E-14,   2.8937098E-14
     +,   3.7891904E-14,   4.9527988E-14,   6.4620171E-14
     +,   8.4158890E-14,   1.0940764E-13,   1.4197378E-13
     +,   1.8390049E-13,   2.3778055E-13,   3.0688985E-13
     +,   3.9537221E-13,   5.0844837E-13,   6.5268727E-13
     +,   8.3633632E-13,   1.0697374E-12,   1.3658157E-12
     +,   1.7407229E-12,   2.2145523E-12,   2.8123107E-12
     +,   3.5650502E-12,   4.5111631E-12,   5.6981590E-12
     +,   7.1846609E-12,   9.0427882E-12,   1.1361205E-11
     +,   1.4248649E-11,   1.7838285E-11,   2.2292482E-11
     +,   2.7809503E-11,   3.4630486E-11,   4.3048416E-11
     +,   5.3417708E-11,   6.6167814E-11,   8.1816734E-11
     +,   1.0098869E-10,   1.2443391E-10,   1.5305375E-10
     +,   1.8792515E-10,   2.3033721E-10,   2.8182776E-10
     +,   3.4422601E-10,   4.1970769E-10,   5.1084781E-10
     +,   6.2069699E-10,   7.5285683E-10,   9.1157132E-10
     +,   1.1018332E-09,   1.3294991E-09,   1.6014320E-09
     +,   1.9256727E-09,   2.3115474E-09,   2.7699614E-09
     +,   3.3135790E-09,   3.9570653E-09,   4.7173980E-09
     +,   5.6141789E-09,   6.6700441E-09,   7.9108515E-09
     +,   9.3664303E-09,   1.1070873E-08,   1.3063130E-08
     +,   1.5387593E-08,   1.8094756E-08,   2.1241906E-08
     +,   2.4893954E-08,   2.9124191E-08,   3.4015248E-08
     +,   3.9660090E-08,   4.6162995E-08,   5.3640775E-08
     +,   6.2223798E-08,   7.2057873E-08,   8.3303611E-08
     +,   9.6140610E-08,   1.1076701E-07,   1.2740136E-07
     +,   1.4628428E-07,   1.6767994E-07,   1.9187871E-07
     +,   2.1919426E-07,   2.4997155E-07,   2.8458427E-07
     +,   3.2343689E-07,   3.6696679E-07,   4.1564445E-07
     +,   4.6997553E-07,   5.3050144E-07,   5.9779984E-07
     +,   6.7248590E-07,   7.5521189E-07,   8.4666812E-07
     +,   9.4758695E-07,   1.0587244E-06,   1.1808858E-06
     +,   1.3149072E-06,   1.4616596E-06,   1.6220474E-06
     +,   1.7970031E-06,   1.9874897E-06,   2.1945068E-06
     +,   2.4190492E-06,   2.6621617E-06,   2.9248997E-06
     +,   3.2083356E-06,   3.5135590E-06,   3.8416733E-06
     +,   4.1937938E-06,   4.5710526E-06,   4.9745940E-06
     +,   5.4055781E-06,   5.8651885E-06,   6.3546499E-06
     +,   6.8751579E-06,   7.4280088E-06,   8.0145273E-06
     +,   8.6361033E-06,   9.2942018E-06,   9.9903855E-06
     +,   1.0726329E-05,   1.1503847E-05,   1.2324913E-05
     +,   1.3191727E-05,   1.4106588E-05,   1.5072152E-05
     +,   1.6091311E-05,   1.7167262E-05,   1.8303517E-05
     +,   1.9503952E-05,   2.0772804E-05,   2.2114709E-05
     +,   2.3534683E-05,   2.5038142E-05,   2.6630874E-05
     +,   2.8319098E-05,   3.0109115E-05,   3.2007698E-05
     +,   3.4021716E-05,   3.6158119E-05,   3.8423805E-05
     +,   4.0825613E-05,   4.3369579E-05,   4.6062036E-05
     +,   4.8907801E-05,   5.1911305E-05,   5.5075830E-05
     +,   5.8403471E-05,   6.1895058E-05,   6.5550172E-05
     +,   6.9367154E-05,   7.3343377E-05,   7.7475583E-05
     +,   8.1760474E-05,   8.6195738E-05,   9.0780173E-05
     +,   9.5517513E-05,   1.0041546E-04,   1.0549169E-04
     +,   1.1077475E-04,   1.1630996E-04,   1.2216730E-04
     +,   1.2844568E-04,   1.3528677E-04,   1.4288178E-04
     +,   1.5148669E-04,   1.6143217E-04,   1.7313343E-04
     +,   1.8709512E-04,   2.0390787E-04,   2.2423521E-04
     +,   2.4878679E-04,   2.7827857E-04,   3.1338204E-04
     +,   3.5466842E-04,   4.0255772E-04,   4.5728765E-04
     +,   5.1889743E-04,   5.8729306E-04,   6.6228415E-04
     +,   7.4371794E-04,   8.3157019E-04,   9.2598924E-04
     +,   1.0273174E-03,   1.1358892E-03,   1.2518129E-03
     +,   1.3745889E-03,   1.5027389E-03,   1.6335262E-03
     +,   1.7628837E-03,   1.8856385E-03,   1.9960469E-03
     +,   2.0885724E-03,   2.1587650E-03,   2.2040920E-03
     +,   2.2245438E-03,   2.2229878E-03,   2.2052687E-03
     +,   2.1800997E-03,   2.1587685E-03,   2.1544839E-03
     +,   2.1811707E-03,   2.2514304E-03,   2.3737249E-03
     +,   2.5492555E-03,   2.7697254E-03,   3.0171804E-03
     +,   3.2669522E-03,   3.4934706E-03,   3.6772848E-03
     +,   3.8106544E-03,   3.8992232E-03,   3.9588953E-03
     +,   4.0092291E-03,   4.0664161E-03,   4.1389130E-03
     +,   4.2270338E-03,   4.3255263E-03,   4.4267201E-03
     +,   4.5224139E-03,   4.6045971E-03,   4.6666521E-03
     +,   4.7060838E-03,   4.7278358E-03,   4.7453651E-03
     +,   4.7769384E-03,   4.8376461E-03,   4.9313493E-03
     +,   5.0482769E-03,   5.1716976E-03,   5.2911141E-03
     +,   5.4141879E-03,   5.5683851E-03,   5.7895198E-03
     +,   6.1032022E-03,   6.5112836E-03,   6.9912123E-03
     +,   7.5055421E-03,   8.0100670E-03,   8.4531102E-03
     +,   8.7729925E-03,   8.9087747E-03,   8.8266172E-03
     +,   8.5433936E-03,   8.1242789E-03,   7.6528033E-03
     +,   7.1955523E-03,   6.7846212E-03,   6.4201918E-03
     +,   6.0812682E-03,   5.7355873E-03,   5.3492184E-03
     +,   4.8980745E-03,   4.3779761E-03,   3.8072011E-03
     +,   3.2196182E-03,   2.6525462E-03,   2.1358973E-03
     +,   1.6867891E-03,   1.3098934E-03,   1.0012920E-03
     +,   7.5275719E-04,   5.5527966E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wao_hz_105 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wao_hz_110(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  3.9348251E-25,   6.0905416E-25
     +,   9.4073063E-25,   1.4499570E-24,   2.2300721E-24
     +,   3.4226300E-24,   5.2417519E-24,   8.0107271E-24
     +,   1.2216578E-23,   1.8590929E-23,   2.8231123E-23
     +,   4.2779346E-23,   6.4687042E-23,   9.7606277E-23
     +,   1.4696660E-22,   2.2081835E-22,   3.3107434E-22
     +,   4.9533210E-22,   7.3950810E-22,   1.1017210E-21
     +,   1.6378503E-21,   2.4297073E-21,   3.5967562E-21
     +,   5.3130663E-21,   7.8318010E-21,   1.1519942E-20
     +,   1.6908995E-20,   2.4766382E-20,   3.6198131E-20
     +,   5.2794095E-20,   7.6835476E-20,   1.1158788E-19
     +,   1.6171409E-19,   2.3386045E-19,   3.3747852E-19
     +,   4.8596995E-19,   6.9831414E-19,   1.0013120E-18
     +,   1.4327328E-18,   2.0456981E-18,   2.9146912E-18
     +,   4.1440028E-18,   5.8792987E-18,   8.3235595E-18
     +,   1.1758984E-17,   1.6577163E-17,   2.3319877E-17
     +,   3.2735540E-17,   4.5855604E-17,   6.4097352E-17
     +,   8.9405651E-17,   1.2444202E-16,   1.7284118E-16
     +,   2.3955418E-16,   3.3131352E-16,   4.5724707E-16
     +,   6.2971505E-16,   8.6538857E-16,   1.1867395E-15
     +,   1.6239785E-15,   2.2175824E-15,   3.0217358E-15
     +,   4.1087569E-15,   5.5749595E-15,   7.5483451E-15
     +,   1.0198525E-14,   1.3750052E-14,   1.8498871E-14
     +,   2.4834999E-14,   3.3270580E-14,   4.4477070E-14
     +,   5.9331805E-14,   7.8979825E-14,   1.0491124E-13
     +,   1.3906092E-13,   1.8393543E-13,   2.4277623E-13
     +,   3.1975822E-13,   4.2025731E-13,   5.5116968E-13
     +,   7.2132881E-13,   9.4202185E-13,   1.2276210E-12
     +,   1.5964082E-12,   2.0715799E-12,   2.6824779E-12
     +,   3.4661616E-12,   4.4692895E-12,   5.7505042E-12
     +,   7.3833847E-12,   9.4597004E-12,   1.2094193E-11
     +,   1.5429574E-11,   1.9643022E-11,   2.4954004E-11
     +,   3.1633630E-11,   4.0016657E-11,   5.0513142E-11
     +,   6.3627673E-11,   7.9977039E-11,   1.0031397E-10
     +,   1.2555533E-10,   1.5681459E-10,   1.9544073E-10
     +,   2.4306437E-10,   3.0165093E-10,   3.7356460E-10
     +,   4.6164056E-10,   5.6927207E-10,   7.0050776E-10
     +,   8.6016883E-10,   1.0539883E-09,   1.2887270E-09
     +,   1.5724028E-09,   1.9144508E-09,   2.3259581E-09
     +,   2.8199225E-09,   3.4115373E-09,   4.1185459E-09
     +,   4.9614806E-09,   5.9642535E-09,   7.1544868E-09
     +,   8.5640286E-09,   1.0229523E-08,   1.2192985E-08
     +,   1.4502474E-08,   1.7212797E-08,   2.0386301E-08
     +,   2.4093659E-08,   2.8414798E-08,   3.3439811E-08
     +,   3.9270219E-08,   4.6019025E-08,   5.3813210E-08
     +,   6.2793987E-08,   7.3117974E-08,   8.4958714E-08
     +,   9.8507464E-08,   1.1397452E-07,   1.3159109E-07
     +,   1.5160724E-07,   1.7429737E-07,   1.9995817E-07
     +,   2.2891005E-07,   2.6149780E-07,   2.9809084E-07
     +,   3.3908347E-07,   3.8489492E-07,   4.3596845E-07
     +,   4.9277122E-07,   5.5579312E-07,   6.2554795E-07
     +,   7.0255965E-07,   7.8737793E-07,   8.8056390E-07
     +,   9.8268868E-07,   1.0943304E-06,   1.2160698E-06
     +,   1.3484856E-06,   1.4921472E-06,   1.6476127E-06
     +,   1.8154255E-06,   1.9960803E-06,   2.1900632E-06
     +,   2.3978084E-06,   2.6197049E-06,   2.8560873E-06
     +,   3.1072295E-06,   3.3733388E-06,   3.6545505E-06
     +,   3.9509296E-06,   4.2624624E-06,   4.5890656E-06
     +,   4.9306050E-06,   5.2868418E-06,   5.6575436E-06
     +,   6.0424422E-06,   6.4412820E-06,   6.8538525E-06
     +,   7.2800590E-06,   7.7198802E-06,   8.1736553E-06
     +,   8.6418704E-06,   9.1254869E-06,   9.6259182E-06
     +,   1.0145152E-05,   1.0685867E-05,   1.1251524E-05
     +,   1.1846480E-05,   1.2476098E-05,   1.3146845E-05
     +,   1.3866412E-05,   1.4643892E-05,   1.5489750E-05
     +,   1.6416465E-05,   1.7438273E-05,   1.8572224E-05
     +,   1.9838171E-05,   2.1259710E-05,   2.2865568E-05
     +,   2.4689773E-05,   2.6774151E-05,   2.9168659E-05
     +,   3.1934054E-05,   3.5143486E-05,   3.8885126E-05
     +,   4.3265409E-05,   4.8413520E-05,   5.4487758E-05
     +,   6.1684397E-05,   7.0249727E-05,   8.0495622E-05
     +,   9.2818074E-05,   1.0771713E-04,   1.2581600E-04
     +,   1.4786729E-04,   1.7476091E-04,   2.0748469E-04
     +,   2.4708259E-04,   2.9456339E-04,   3.5076760E-04
     +,   4.1624607E-04,   4.9106241E-04,   5.7467545E-04
     +,   6.6581718E-04,   7.6246570E-04,   8.6191640E-04
     +,   9.6097618E-04,   1.0562742E-03,   1.1446546E-03
     +,   1.2235811E-03,   1.2914593E-03,   1.3477886E-03
     +,   1.3930722E-03,   1.4285197E-03,   1.4556346E-03
     +,   1.4758547E-03,   1.4904188E-03,   1.5005631E-03
     +,   1.5079747E-03,   1.5153245E-03,   1.5265902E-03
     +,   1.5468951E-03,   1.5817590E-03,   1.6358728E-03
     +,   1.7117751E-03,   1.8089644E-03,   1.9239637E-03
     +,   2.0515006E-03,   2.1864402E-03,   2.3256075E-03
     +,   2.4685906E-03,   2.6172725E-03,   2.7748318E-03
     +,   2.9454967E-03,   3.1355240E-03,   3.3538053E-03
     +,   3.6089958E-03,   3.9011443E-03,   4.2111524E-03
     +,   4.4961339E-03,   4.6989126E-03,   4.7710123E-03
     +,   4.6973163E-03,   4.5067258E-03,   4.2617046E-03
     +,   4.0336791E-03,   3.8786025E-03,   3.8228913E-03
     +,   3.8607554E-03,   3.9594336E-03,   4.0702759E-03
     +,   4.1449745E-03,   4.1529625E-03,   4.0919958E-03
     +,   3.9859596E-03,   3.8715631E-03,   3.7816905E-03
     +,   3.7329020E-03,   3.7204614E-03,   3.7212353E-03
     +,   3.7030969E-03,   3.6373159E-03,   3.5084346E-03
     +,   3.3171487E-03,   3.0761627E-03,   2.8029948E-03
     +,   2.5142820E-03,   2.2234099E-03,   1.9405275E-03
     +,   1.6731508E-03,   1.4264482E-03,   1.2032782E-03
     +,   1.0044319E-03,   8.2921609E-04,   6.7618716E-04
     +,   5.4374652E-04,   4.3042839E-04,   3.3493360E-04
     +,   2.5593981E-04,   1.9201163E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wao_hz_110 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wao_hz_115(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  2.6738072E-17,   3.5675029E-17
     +,   4.7525781E-17,   6.3215809E-17,   8.3955418E-17
     +,   1.1132727E-16,   1.4739554E-16,   1.9484769E-16
     +,   2.5718131E-16,   3.3892941E-16,   4.4597428E-16
     +,   5.8592138E-16,   7.6859574E-16,   1.0066703E-15
     +,   1.3164587E-15,   1.7189157E-15,   2.2409440E-15
     +,   2.9170059E-15,   3.7911645E-15,   4.9197279E-15
     +,   6.3743414E-15,   8.2463198E-15,   1.0651542E-14
     +,   1.3737137E-14,   1.7689304E-14,   2.2743299E-14
     +,   2.9196067E-14,   3.7421841E-14,   4.7891389E-14
     +,   6.1195278E-14,   7.8074178E-14,   9.9454861E-14
     +,   1.2649532E-13,   1.6063904E-13,   2.0368586E-13
     +,   2.5786789E-13,   3.2596002E-13,   4.1139555E-13
     +,   5.1842254E-13,   6.5228975E-13,   8.1945399E-13
     +,   1.0278707E-12,   1.2873023E-12,   1.6097282E-12
     +,   2.0098109E-12,   2.5054665E-12,   3.1185224E-12
     +,   3.8756012E-12,   4.8090663E-12,   5.9581337E-12
     +,   7.3703543E-12,   9.1032555E-12,   1.1226227E-11
     +,   1.3822946E-11,   1.6994069E-11,   2.0860426E-11
     +,   2.5567042E-11,   3.1287088E-11,   3.8227834E-11
     +,   4.6636438E-11,   5.6806549E-11,   6.9087722E-11
     +,   8.3894447E-11,   1.0171725E-10,   1.2313610E-10
     +,   1.4883536E-10,   1.7962133E-10,   2.1643977E-10
     +,   2.6040309E-10,   3.1281289E-10,   3.7519254E-10
     +,   4.4931572E-10,   5.3725197E-10,   6.4140798E-10
     +,   7.6457418E-10,   9.0998631E-10,   1.0813870E-09
     +,   1.2830856E-09,   1.5200532E-09,   1.7980104E-09
     +,   2.1235096E-09,   2.5040774E-09,   2.9482825E-09
     +,   3.4659309E-09,   4.0681800E-09,   4.7677142E-09
     +,   5.5789102E-09,   6.5180545E-09,   7.6035471E-09
     +,   8.8561825E-09,   1.0299206E-08,   1.1958875E-08
     +,   1.3864563E-08,   1.6049144E-08,   1.8549260E-08
     +,   2.1405778E-08,   2.4664228E-08,   2.8374673E-08
     +,   3.2592947E-08,   3.7380559E-08,   4.2805311E-08
     +,   4.8941665E-08,   5.5871364E-08,   6.3683878E-08
     +,   7.2476787E-08,   8.2356536E-08,   9.3438658E-08
     +,   1.0584847E-07,   1.1972146E-07,   1.3520375E-07
     +,   1.5245270E-07,   1.7163796E-07,   1.9293829E-07
     +,   2.1654759E-07,   2.4267078E-07,   2.7152578E-07
     +,   3.0334320E-07,   3.3836608E-07,   3.7685220E-07
     +,   4.1906611E-07,   4.6528970E-07,   5.1581480E-07
     +,   5.7094434E-07,   6.3099105E-07,   6.9627686E-07
     +,   7.6713229E-07,   8.4389416E-07,   9.2690505E-07
     +,   1.0165104E-06,   1.1130586E-06,   1.2168967E-06
     +,   1.3283743E-06,   1.4478213E-06,   1.5755750E-06
     +,   1.7119557E-06,   1.8572719E-06,   2.0118136E-06
     +,   2.1758535E-06,   2.3496384E-06,   2.5333975E-06
     +,   2.7273043E-06,   2.9315233E-06,   3.1461739E-06
     +,   3.3713322E-06,   3.6070317E-06,   3.8532562E-06
     +,   4.1099415E-06,   4.3769651E-06,   4.6541504E-06
     +,   4.9412611E-06,   5.2379996E-06,   5.5440205E-06
     +,   5.8588735E-06,   6.1820861E-06,   6.5131112E-06
     +,   6.8513377E-06,   7.1961003E-06,   7.5466787E-06
     +,   7.9023039E-06,   8.2621727E-06,   8.6254404E-06
     +,   8.9912728E-06,   9.3587751E-06,   9.7271222E-06
     +,   1.0095509E-05,   1.0463192E-05,   1.0829522E-05
     +,   1.1193977E-05,   1.1556206E-05,   1.1916068E-05
     +,   1.2273686E-05,   1.2629503E-05,   1.2984335E-05
     +,   1.3339456E-05,   1.3696605E-05,   1.4058148E-05
     +,   1.4427083E-05,   1.4807149E-05,   1.5202895E-05
     +,   1.5619789E-05,   1.6064214E-05,   1.6543794E-05
     +,   1.7067241E-05,   1.7644708E-05,   1.8287874E-05
     +,   1.9010196E-05,   1.9827117E-05,   2.0756437E-05
     +,   2.1818632E-05,   2.3037283E-05,   2.4439491E-05
     +,   2.6056394E-05,   2.7923616E-05,   3.0081237E-05
     +,   3.2575030E-05,   3.5455021E-05,   3.8777114E-05
     +,   4.2600856E-05,   4.6989087E-05,   5.2008239E-05
     +,   5.7723766E-05,   6.4202177E-05,   7.1505339E-05
     +,   7.9691948E-05,   8.8815097E-05,   9.8922421E-05
     +,   1.1005720E-04,   1.2226100E-04,   1.3557795E-04
     +,   1.5006063E-04,   1.6577703E-04,   1.8281743E-04
     +,   2.0130030E-04,   2.2137536E-04,   2.4322221E-04
     +,   2.6703640E-04,   2.9302368E-04,   3.2135850E-04
     +,   3.5216167E-04,   3.8545637E-04,   4.2111916E-04
     +,   4.5886071E-04,   4.9817713E-04,   5.3836108E-04
     +,   5.7851290E-04,   6.1758939E-04,   6.5448327E-04
     +,   6.8812550E-04,   7.1760308E-04,   7.4227684E-04
     +,   7.6187885E-04,   7.7657111E-04,   7.8694907E-04
     +,   7.9397782E-04,   7.9886941E-04,   8.0291182E-04
     +,   8.0728310E-04,   8.1289344E-04,   8.2030165E-04
     +,   8.2973950E-04,   8.4126461E-04,   8.5501850E-04
     +,   8.7152625E-04,   8.9195033E-04,   9.1818121E-04
     +,   9.5269678E-04,   9.9817629E-04,   1.0569538E-03
     +,   1.1304740E-03,   1.2189338E-03,   1.3212216E-03
     +,   1.4351280E-03,   1.5576434E-03,   1.6850982E-03
     +,   1.8129993E-03,   1.9356559E-03,   2.0459420E-03
     +,   2.1356505E-03,   2.1966454E-03,   2.2226819E-03
     +,   2.2111947E-03,   2.1643403E-03,   2.0887917E-03
     +,   1.9944001E-03,   1.8923142E-03,   1.7933887E-03
     +,   1.7073393E-03,   1.6425810E-03,   1.6062476E-03
     +,   1.6038164E-03,   1.6381029E-03,   1.7079185E-03
     +,   1.8070865E-03,   1.9245442E-03,   2.0458789E-03
     +,   2.1560430E-03,   2.2423996E-03,   2.2970466E-03
     +,   2.3176090E-03,   2.3063766E-03,   2.2682571E-03
     +,   2.2085197E-03,   2.1312220E-03,   2.0387748E-03
     +,   1.9324800E-03,   1.8135532E-03,   1.6839780E-03
     +,   1.5467915E-03,   1.4058006E-03,   1.2649535E-03
     +,   1.1277163E-03,   9.9669152E-04,   8.7355007E-04
     +,   7.5918809E-04,   6.5398705E-04,   5.5804453E-04
     +,   4.7132396E-04,   3.9371499E-04,   3.2505335E-04
     +,   2.6506468E-04,   2.1338541E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wao_hz_115 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wao_hz_120(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  1.3086150E-27,   2.1589001E-27
     +,   3.5529124E-27,   5.8327220E-27,   9.5517482E-27
     +,   1.5603696E-26,   2.5427301E-26,   4.1334031E-26
     +,   6.7026787E-26,   1.0842150E-25,   1.7495063E-25
     +,   2.8160720E-25,   4.5217349E-25,   7.2425729E-25
     +,   1.1572318E-24,   1.8444816E-24,   2.9326241E-24
     +,   4.6512702E-24,   7.3589600E-24,   1.1614427E-23
     +,   1.8285446E-23,   2.8717266E-23,   4.4989422E-23
     +,   7.0308983E-23,   1.0960851E-22,   1.7045349E-22
     +,   2.6442282E-22,   4.0918690E-22,   6.3165640E-22
     +,   9.7266868E-22,   1.4941023E-21,   2.2894287E-21
     +,   3.4994954E-21,   5.3359713E-21,   8.1162655E-21
     +,   1.2314794E-20,   1.8639224E-20,   2.8142323E-20
     +,   4.2386095E-20,   6.3682496E-20,   9.5443162E-20
     +,   1.4269189E-19,   2.1280748E-19,   3.1659389E-19
     +,   4.6984055E-19,   6.9555772E-19,   1.0271719E-18
     +,   1.5131559E-18,   2.2236120E-18,   3.2595734E-18
     +,   4.7664384E-18,   6.9527823E-18,   1.0117049E-17
     +,   1.4685166E-17,   2.1263523E-17,   3.0713117E-17
     +,   4.4253220E-17,   6.3605385E-17,   9.1195703E-17
     +,   1.3043339E-16,   1.8609351E-16,   2.6485214E-16
     +,   3.7601746E-16,   5.3252686E-16,   7.5232799E-16
     +,   1.0602384E-15,   1.4905062E-15,   2.0902205E-15
     +,   2.9240244E-15,   4.0803801E-15,   5.6800852E-15
     +,   7.8874310E-15,   1.0925683E-14,   1.5097054E-14
     +,   2.0809731E-14,   2.8613512E-14,   3.9247312E-14
     +,   5.3700307E-14,   7.3294974E-14,   9.9793675E-14
     +,   1.3553843E-13,   1.8363514E-13,   2.4818551E-13
     +,   3.3460200E-13,   4.4999865E-13,   6.0370572E-13
     +,   8.0792301E-13,   1.0785624E-12,   1.4363226E-12
     +,   1.9080698E-12,   2.5284980E-12,   3.3424242E-12
     +,   4.4074917E-12,   5.7976506E-12,   7.6075292E-12
     +,   9.9578635E-12,   1.3002437E-11,   1.6935908E-11
     +,   2.2005115E-11,   2.8521340E-11,   3.6876214E-11
     +,   4.7561389E-11,   6.1191760E-11,   7.8534845E-11
     +,   1.0054554E-10,   1.2840852E-10,   1.6358970E-10
     +,   2.0789717E-10,   2.6355559E-10,   3.3329386E-10
     +,   4.2044832E-10,   5.2909527E-10,   6.6417299E-10
     +,   8.3168628E-10,   1.0388873E-09,   1.2945187E-09
     +,   1.6090863E-09,   1.9951742E-09,   2.4678433E-09
     +,   3.0449570E-09,   3.7477905E-09,   4.6015067E-09
     +,   5.6358083E-09,   6.8856196E-09,   8.3919103E-09
     +,   1.0202572E-08,   1.2373401E-08,   1.4969231E-08
     +,   1.8065125E-08,   2.1747685E-08,   2.6116567E-08
     +,   3.1286248E-08,   3.7386801E-08,   4.4567020E-08
     +,   5.2995656E-08,   6.2863386E-08,   7.4385127E-08
     +,   8.7802121E-08,   1.0338443E-07,   1.2143367E-07
     +,   1.4228223E-07,   1.6630047E-07,   1.9389509E-07
     +,   2.2551276E-07,   2.6164145E-07,   3.0281160E-07
     +,   3.4959848E-07,   4.0262188E-07,   4.6254721E-07
     +,   5.3008523E-07,   6.0599092E-07,   6.9106704E-07
     +,   7.8614448E-07,   8.9210391E-07,   1.0098559E-06
     +,   1.1403398E-06,   1.2845173E-06,   1.4433663E-06
     +,   1.6178718E-06,   1.8090162E-06,   2.0177702E-06
     +,   2.2450913E-06,   2.4918686E-06,   2.7589722E-06
     +,   3.0471963E-06,   3.3572580E-06,   3.6897768E-06
     +,   4.0452655E-06,   4.4241046E-06,   4.8265388E-06
     +,   5.2526511E-06,   5.7023562E-06,   6.1753835E-06
     +,   6.6712969E-06,   7.1893865E-06,   7.7288078E-06
     +,   8.2884899E-06,   8.8671641E-06,   9.4633760E-06
     +,   1.0075537E-05,   1.0701806E-05,   1.1340457E-05
     +,   1.1989516E-05,   1.2647167E-05,   1.3311689E-05
     +,   1.3981593E-05,   1.4655760E-05,   1.5333611E-05
     +,   1.6015289E-05,   1.6701888E-05,   1.7395705E-05
     +,   1.8100536E-05,   1.8822042E-05,   1.9567909E-05
     +,   2.0348612E-05,   2.1177282E-05,   2.2070644E-05
     +,   2.3048864E-05,   2.4136036E-05,   2.5360723E-05
     +,   2.6755317E-05,   2.8356850E-05,   3.0205783E-05
     +,   3.2346132E-05,   3.4824316E-05,   3.7688045E-05
     +,   4.0984793E-05,   4.4760000E-05,   4.9054976E-05
     +,   5.3904580E-05,   5.9334805E-05,   6.5360393E-05
     +,   7.1982620E-05,   7.9187463E-05,   8.6944769E-05
     +,   9.5206065E-05,   1.0390950E-04,   1.1297704E-04
     +,   1.2232299E-04,   1.3185934E-04,   1.4150326E-04
     +,   1.5119418E-04,   1.6090203E-04,   1.7064839E-04
     +,   1.8052066E-04,   1.9068590E-04,   2.0140002E-04
     +,   2.1300669E-04,   2.2592586E-04,   2.4062741E-04
     +,   2.5759113E-04,   2.7725555E-04,   2.9996160E-04
     +,   3.2589908E-04,   3.5506691E-04,   3.8725635E-04
     +,   4.2206413E-04,   4.5892937E-04,   4.9720850E-04
     +,   5.3624820E-04,   5.7545665E-04,   6.1435637E-04
     +,   6.5259135E-04,   6.8992126E-04,   7.2617503E-04
     +,   7.6121854E-04,   7.9494453E-04,   8.2730374E-04
     +,   8.5836940E-04,   8.8840188E-04,   9.1786293E-04
     +,   9.4733085E-04,   9.7729557E-04,   1.0078633E-03
     +,   1.0384556E-03,   1.0676200E-03,   1.0930608E-03
     +,   1.1119484E-03,   1.1214758E-03,   1.1195699E-03
     +,   1.1055940E-03,   1.0809129E-03,   1.0491953E-03
     +,   1.0163739E-03,   9.9016808E-04,   9.7913179E-04
     +,   9.9121232E-04,   1.0319665E-03,   1.1027842E-03
     +,   1.1996517E-03,   1.3130156E-03,   1.4290939E-03
     +,   1.5325334E-03,   1.6098018E-03,   1.6523361E-03
     +,   1.6584429E-03,   1.6333448E-03,   1.5873482E-03
     +,   1.5327847E-03,   1.4806719E-03,   1.4381267E-03
     +,   1.4071557E-03,   1.3849705E-03,   1.3654950E-03
     +,   1.3414469E-03,   1.3063457E-03,   1.2559445E-03
     +,   1.1888627E-03,   1.1064566E-03,   1.0121405E-03
     +,   9.1045361E-04,   8.0613670E-04,   7.0341880E-04
     +,   6.0559140E-04,   5.1487505E-04,   4.3250818E-04
     +,   3.5896467E-04,   2.9420099E-04,   2.3788866E-04
     +,   1.8953356E-04,   1.4859225E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wao_hz_120 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wao_hz_60(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  3.5046211E-05,   3.5585392E-05
     +,   3.6122154E-05,   3.6656245E-05,   3.7187365E-05
     +,   3.7715272E-05,   3.8239737E-05,   3.8760543E-05
     +,   3.9277482E-05,   3.9790350E-05,   4.0298990E-05
     +,   4.0803239E-05,   4.1302970E-05,   4.1798066E-05
     +,   4.2288426E-05,   4.2773961E-05,   4.3254615E-05
     +,   4.3730346E-05,   4.4201119E-05,   4.4666936E-05
     +,   4.5127777E-05,   4.5583685E-05,   4.6034675E-05
     +,   4.6480814E-05,   4.6922160E-05,   4.7358753E-05
     +,   4.7790698E-05,   4.8218077E-05,   4.8640992E-05
     +,   4.9059527E-05,   4.9473801E-05,   4.9883925E-05
     +,   5.0290018E-05,   5.0692197E-05,   5.1090607E-05
     +,   5.1485356E-05,   5.1876574E-05,   5.2264426E-05
     +,   5.2649044E-05,   5.3030592E-05,   5.3409240E-05
     +,   5.3785156E-05,   5.4158554E-05,   5.4529653E-05
     +,   5.4898694E-05,   5.5265948E-05,   5.5631710E-05
     +,   5.5996341E-05,   5.6360223E-05,   5.6723791E-05
     +,   5.7087527E-05,   5.7452016E-05,   5.7817855E-05
     +,   5.8185775E-05,   5.8556529E-05,   5.8931011E-05
     +,   5.9310201E-05,   5.9695132E-05,   6.0087008E-05
     +,   6.0487095E-05,   6.0896797E-05,   6.1317631E-05
     +,   6.1751227E-05,   6.2199368E-05,   6.2663894E-05
     +,   6.3146806E-05,   6.3650281E-05,   6.4176464E-05
     +,   6.4727705E-05,   6.5306449E-05,   6.5915221E-05
     +,   6.6556589E-05,   6.7233224E-05,   6.7947847E-05
     +,   6.8703172E-05,   6.9501984E-05,   7.0347050E-05
     +,   7.1241062E-05,   7.2186747E-05,   7.3186682E-05
     +,   7.4243406E-05,   7.5359356E-05,   7.6536729E-05
     +,   7.7777629E-05,   7.9083948E-05,   8.0457336E-05
     +,   8.1899241E-05,   8.3410763E-05,   8.4992760E-05
     +,   8.6645807E-05,   8.8369954E-05,   9.0165049E-05
     +,   9.2030539E-05,   9.3965435E-05,   9.5968360E-05
     +,   9.8037483E-05,   1.0017070E-04,   1.0236512E-04
     +,   1.0461771E-04,   1.0692495E-04,   1.0928281E-04
     +,   1.1168692E-04,   1.1413240E-04,   1.1661408E-04
     +,   1.1912631E-04,   1.2166311E-04,   1.2421816E-04
     +,   1.2678483E-04,   1.2935617E-04,   1.3192504E-04
     +,   1.3448395E-04,   1.3702549E-04,   1.3954163E-04
     +,   1.4202463E-04,   1.4446654E-04,   1.4685937E-04
     +,   1.4919517E-04,   1.5146598E-04,   1.5366405E-04
     +,   1.5578148E-04,   1.5781076E-04,   1.5974458E-04
     +,   1.6157584E-04,   1.6329775E-04,   1.6490376E-04
     +,   1.6638773E-04,   1.6774393E-04,   1.6896697E-04
     +,   1.7005204E-04,   1.7099464E-04,   1.7179086E-04
     +,   1.7243743E-04,   1.7293137E-04,   1.7327045E-04
     +,   1.7345305E-04,   1.7347799E-04,   1.7334492E-04
     +,   1.7305392E-04,   1.7260583E-04,   1.7200205E-04
     +,   1.7124489E-04,   1.7033699E-04,   1.6928178E-04
     +,   1.6808342E-04,   1.6674674E-04,   1.6527715E-04
     +,   1.6368077E-04,   1.6196439E-04,   1.6013540E-04
     +,   1.5820189E-04,   1.5617243E-04,   1.5405625E-04
     +,   1.5186332E-04,   1.4960396E-04,   1.4728901E-04
     +,   1.4492983E-04,   1.4253821E-04,   1.4012629E-04
     +,   1.3770664E-04,   1.3529196E-04,   1.3289532E-04
     +,   1.3052975E-04,   1.2820870E-04,   1.2594527E-04
     +,   1.2375267E-04,   1.2164385E-04,   1.1963159E-04
     +,   1.1772830E-04,   1.1594596E-04,   1.1429600E-04
     +,   1.1278927E-04,   1.1143591E-04,   1.1024521E-04
     +,   1.0922561E-04,   1.0838465E-04,   1.0772871E-04
     +,   1.0726308E-04,   1.0699195E-04,   1.0691810E-04
     +,   1.0704328E-04,   1.0736771E-04,   1.0789048E-04
     +,   1.0860918E-04,   1.0952022E-04,   1.1061857E-04
     +,   1.1189807E-04,   1.1335131E-04,   1.1496969E-04
     +,   1.1674358E-04,   1.1866236E-04,   1.2071458E-04
     +,   1.2288793E-04,   1.2516974E-04,   1.2754626E-04
     +,   1.3000422E-04,   1.3252925E-04,   1.3510782E-04
     +,   1.3772582E-04,   1.4036939E-04,   1.4302571E-04
     +,   1.4568158E-04,   1.4832537E-04,   1.5094552E-04
     +,   1.5353164E-04,   1.5607438E-04,   1.5856538E-04
     +,   1.6099746E-04,   1.6336454E-04,   1.6566177E-04
     +,   1.6788555E-04,   1.7003344E-04,   1.7210418E-04
     +,   1.7409757E-04,   1.7601447E-04,   1.7785677E-04
     +,   1.7962688E-04,   1.8132839E-04,   1.8296512E-04
     +,   1.8454138E-04,   1.8606198E-04,   1.8753139E-04
     +,   1.8895468E-04,   1.9033616E-04,   1.9168000E-04
     +,   1.9298999E-04,   1.9426906E-04,   1.9551955E-04
     +,   1.9674271E-04,   1.9793898E-04,   1.9910764E-04
     +,   2.0024687E-04,   2.0135361E-04,   2.0242370E-04
     +,   2.0345171E-04,   2.0443108E-04,   2.0535420E-04
     +,   2.0621237E-04,   2.0699573E-04,   2.0769400E-04
     +,   2.0829579E-04,   2.0878944E-04,   2.0916268E-04
     +,   2.0940312E-04,   2.0949816E-04,   2.0943549E-04
     +,   2.0920295E-04,   2.0878896E-04,   2.0818251E-04
     +,   2.0737346E-04,   2.0635265E-04,   2.0511201E-04
     +,   2.0364483E-04,   2.0194576E-04,   2.0001097E-04
     +,   1.9783805E-04,   1.9542646E-04,   1.9277718E-04
     +,   1.8989277E-04,   1.8677791E-04,   1.8343855E-04
     +,   1.7988241E-04,   1.7611869E-04,   1.7215796E-04
     +,   1.6801267E-04,   1.6369601E-04,   1.5922240E-04
     +,   1.5460730E-04,   1.4986700E-04,   1.4501846E-04
     +,   1.4007915E-04,   1.3506688E-04,   1.2999964E-04
     +,   1.2489548E-04,   1.1977224E-04,   1.1464761E-04
     +,   1.0953877E-04,   1.0446232E-04,   9.9434008E-05
     +,   9.4469462E-05,   8.9582718E-05,   8.4787083E-05
     +,   8.0094862E-05,   7.5517004E-05,   7.1063980E-05
     +,   6.6744455E-05,   6.2566149E-05,   5.8535603E-05
     +,   5.4658161E-05,   5.0938084E-05,   4.7378464E-05
     +,   4.3981363E-05,   4.0747811E-05,   3.7677895E-05
     +,   3.4770779E-05,   3.2024818E-05,   2.9437608E-05
     +,   2.7006055E-05,   2.4726338E-05,   2.2594533E-05
     +,   2.0605541E-05,   1.8754548E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wao_hz_60 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wao_hz_65(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  9.7081261E-07,   1.0712843E-06
     +,   1.1807158E-06,   1.2997471E-06,   1.4290392E-06
     +,   1.5692883E-06,   1.7212171E-06,   1.8855743E-06
     +,   2.0631385E-06,   2.2547015E-06,   2.4610897E-06
     +,   2.6831474E-06,   2.9217376E-06,   3.1777411E-06
     +,   3.4520608E-06,   3.7455895E-06,   4.0592522E-06
     +,   4.3939672E-06,   4.7506592E-06,   5.1302586E-06
     +,   5.5336623E-06,   5.9617846E-06,   6.4155133E-06
     +,   6.8957193E-06,   7.4032587E-06,   7.9389238E-06
     +,   8.5035063E-06,   9.0977446E-06,   9.7223510E-06
     +,   1.0377938E-05,   1.1065113E-05,   1.1784399E-05
     +,   1.2536261E-05,   1.3321088E-05,   1.4139218E-05
     +,   1.4990856E-05,   1.5876167E-05,   1.6795226E-05
     +,   1.7748011E-05,   1.8734436E-05,   1.9754252E-05
     +,   2.0807187E-05,   2.1892844E-05,   2.3010742E-05
     +,   2.4160290E-05,   2.5340856E-05,   2.6551616E-05
     +,   2.7791757E-05,   2.9060366E-05,   3.0356397E-05
     +,   3.1678781E-05,   3.3026383E-05,   3.4397995E-05
     +,   3.5792367E-05,   3.7208185E-05,   3.8644132E-05
     +,   4.0098857E-05,   4.1570933E-05,   4.3059008E-05
     +,   4.4561712E-05,   4.6077606E-05,   4.7605372E-05
     +,   4.9143669E-05,   5.0691215E-05,   5.2246760E-05
     +,   5.3809090E-05,   5.5377102E-05,   5.6949655E-05
     +,   5.8525762E-05,   6.0104467E-05,   6.1684943E-05
     +,   6.3266285E-05,   6.4847816E-05,   6.6428831E-05
     +,   6.8008747E-05,   6.9586975E-05,   7.1163049E-05
     +,   7.2736424E-05,   7.4306678E-05,   7.5873417E-05
     +,   7.7436191E-05,   7.8994606E-05,   8.0548154E-05
     +,   8.2096383E-05,   8.3638770E-05,   8.5174717E-05
     +,   8.6703578E-05,   8.8224573E-05,   8.9736874E-05
     +,   9.1239577E-05,   9.2731490E-05,   9.4211493E-05
     +,   9.5678246E-05,   9.7130316E-05,   9.8566125E-05
     +,   9.9983976E-05,   1.0138212E-04,   1.0275849E-04
     +,   1.0411114E-04,   1.0543797E-04,   1.0673679E-04
     +,   1.0800541E-04,   1.0924153E-04,   1.1044295E-04
     +,   1.1160740E-04,   1.1273273E-04,   1.1381680E-04
     +,   1.1485758E-04,   1.1585320E-04,   1.1680185E-04
     +,   1.1770197E-04,   1.1855218E-04,   1.1935118E-04
     +,   1.2009807E-04,   1.2079201E-04,   1.2143255E-04
     +,   1.2201933E-04,   1.2255236E-04,   1.2303184E-04
     +,   1.2345817E-04,   1.2383200E-04,   1.2415420E-04
     +,   1.2442577E-04,   1.2464798E-04,   1.2482218E-04
     +,   1.2494992E-04,   1.2503273E-04,   1.2507239E-04
     +,   1.2507067E-04,   1.2502939E-04,   1.2495041E-04
     +,   1.2483571E-04,   1.2468718E-04,   1.2450681E-04
     +,   1.2429655E-04,   1.2405848E-04,   1.2379466E-04
     +,   1.2350726E-04,   1.2319854E-04,   1.2287086E-04
     +,   1.2252679E-04,   1.2216911E-04,   1.2180078E-04
     +,   1.2142510E-04,   1.2104564E-04,   1.2066637E-04
     +,   1.2029157E-04,   1.1992604E-04,   1.1957492E-04
     +,   1.1924379E-04,   1.1893875E-04,   1.1866614E-04
     +,   1.1843286E-04,   1.1824603E-04,   1.1811301E-04
     +,   1.1804140E-04,   1.1803889E-04,   1.1811304E-04
     +,   1.1827131E-04,   1.1852084E-04,   1.1886827E-04
     +,   1.1931960E-04,   1.1988007E-04,   1.2055390E-04
     +,   1.2134423E-04,   1.2225290E-04,   1.2328035E-04
     +,   1.2442550E-04,   1.2568575E-04,   1.2705680E-04
     +,   1.2853272E-04,   1.3010608E-04,   1.3176793E-04
     +,   1.3350810E-04,   1.3531507E-04,   1.3717687E-04
     +,   1.3908086E-04,   1.4101443E-04,   1.4296542E-04
     +,   1.4492279E-04,   1.4687645E-04,   1.4881929E-04
     +,   1.5074629E-04,   1.5265605E-04,   1.5455113E-04
     +,   1.5643869E-04,   1.5833093E-04,   1.6024550E-04
     +,   1.6220578E-04,   1.6424118E-04,   1.6638693E-04
     +,   1.6868413E-04,   1.7117916E-04,   1.7392279E-04
     +,   1.7697028E-04,   1.8037882E-04,   1.8420820E-04
     +,   1.8851728E-04,   1.9336317E-04,   1.9880106E-04
     +,   2.0487903E-04,   2.1164029E-04,   2.1911746E-04
     +,   2.2733389E-04,   2.3630088E-04,   2.4601686E-04
     +,   2.5646650E-04,   2.6762020E-04,   2.7943371E-04
     +,   2.9184940E-04,   3.0479551E-04,   3.1818889E-04
     +,   3.3193527E-04,   3.4593153E-04,   3.6006869E-04
     +,   3.7423056E-04,   3.8830287E-04,   4.0216761E-04
     +,   4.1571094E-04,   4.2882378E-04,   4.4140089E-04
     +,   4.5334882E-04,   4.6457927E-04,   4.7501604E-04
     +,   4.8459318E-04,   4.9325556E-04,   5.0095888E-04
     +,   5.0766964E-04,   5.1336456E-04,   5.1802996E-04
     +,   5.2166125E-04,   5.2426220E-04,   5.2584405E-04
     +,   5.2642450E-04,   5.2602822E-04,   5.2468461E-04
     +,   5.2242819E-04,   5.1929796E-04,   5.1533640E-04
     +,   5.1058939E-04,   5.0510524E-04,   4.9893442E-04
     +,   4.9212942E-04,   4.8474310E-04,   4.7682883E-04
     +,   4.6843980E-04,   4.5962838E-04,   4.5044548E-04
     +,   4.4093991E-04,   4.3115864E-04,   4.2114523E-04
     +,   4.1094076E-04,   4.0058279E-04,   3.9010562E-04
     +,   3.7954040E-04,   3.6891497E-04,   3.5825424E-04
     +,   3.4757977E-04,   3.3691226E-04,   3.2626864E-04
     +,   3.1566477E-04,   3.0511469E-04,   2.9463085E-04
     +,   2.8422652E-04,   2.7391256E-04,   2.6369980E-04
     +,   2.5359911E-04,   2.4362076E-04,   2.3377522E-04
     +,   2.2407281E-04,   2.1452381E-04,   2.0513839E-04
     +,   1.9592672E-04,   1.8689869E-04,   1.7806399E-04
     +,   1.6943204E-04,   1.6101185E-04,   1.5281145E-04
     +,   1.4483952E-04,   1.3710283E-04,   1.2960778E-04
     +,   1.2236003E-04,   1.1536378E-04,   1.0862332E-04
     +,   1.0214104E-04,   9.5918440E-05,   8.9956106E-05
     +,   8.4253457E-05,   7.8808996E-05,   7.3620140E-05
     +,   6.8683461E-05,   6.3994630E-05,   5.9548547E-05
     +,   5.5339402E-05,   5.1360825E-05,   4.7605881E-05
     +,   4.4067248E-05,   4.0737144E-05,   3.7608137E-05
     +,   3.4671626E-05,   3.1919928E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wao_hz_65 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wao_hz_70(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  2.3467701E-09,   2.7356493E-09
     +,   3.1850222E-09,   3.7036392E-09,   4.3013744E-09
     +,   4.9894107E-09,   5.7803717E-09,   6.6884871E-09
     +,   7.7297821E-09,   8.9222043E-09,   1.0285943E-08
     +,   1.1843609E-08,   1.3620482E-08,   1.5644810E-08
     +,   1.7948121E-08,   2.0565381E-08,   2.3535620E-08
     +,   2.6902056E-08,   3.0712673E-08,   3.5020612E-08
     +,   3.9884256E-08,   4.5368289E-08,   5.1543896E-08
     +,   5.8489320E-08,   6.6290575E-08,   7.5041307E-08
     +,   8.4844714E-08,   9.5813014E-08,   1.0806906E-07
     +,   1.2174557E-07,   1.3698755E-07,   1.5395206E-07
     +,   1.7280902E-07,   1.9374197E-07,   2.1694969E-07
     +,   2.4264401E-07,   2.7105455E-07,   3.0242668E-07
     +,   3.3702327E-07,   3.7512572E-07,   4.1703120E-07
     +,   4.6305843E-07,   5.1354471E-07,   5.6884716E-07
     +,   6.2934288E-07,   6.9543108E-07,   7.6752633E-07
     +,   8.4606847E-07,   9.3151709E-07,   1.0243465E-06
     +,   1.1250555E-06,   1.2341592E-06,   1.3521907E-06
     +,   1.4796985E-06,   1.6172477E-06,   1.7654140E-06
     +,   1.9247900E-06,   2.0959665E-06,   2.2795505E-06
     +,   2.4761546E-06,   2.6863800E-06,   2.9108364E-06
     +,   3.1501243E-06,   3.4048348E-06,   3.6755443E-06
     +,   3.9628121E-06,   4.2671786E-06,   4.5891384E-06
     +,   4.9291725E-06,   5.2877162E-06,   5.6651720E-06
     +,   6.0618672E-06,   6.4780979E-06,   6.9140965E-06
     +,   7.3700289E-06,   7.8459898E-06,   8.3420136E-06
     +,   8.8580182E-06,   9.3938761E-06,   9.9493600E-06
     +,   1.0524154E-05,   1.1117866E-05,   1.1729969E-05
     +,   1.2359880E-05,   1.3006915E-05,   1.3670303E-05
     +,   1.4349174E-05,   1.5042591E-05,   1.5749527E-05
     +,   1.6468925E-05,   1.7199571E-05,   1.7940294E-05
     +,   1.8689865E-05,   1.9447021E-05,   2.0210506E-05
     +,   2.0979067E-05,   2.1751528E-05,   2.2526654E-05
     +,   2.3303402E-05,   2.4080799E-05,   2.4857987E-05
     +,   2.5634286E-05,   2.6409209E-05,   2.7182456E-05
     +,   2.7954016E-05,   2.8724140E-05,   2.9493407E-05
     +,   3.0262749E-05,   3.1033480E-05,   3.1807354E-05
     +,   3.2586566E-05,   3.3373850E-05,   3.4172379E-05
     +,   3.4985998E-05,   3.5819132E-05,   3.6676844E-05
     +,   3.7564903E-05,   3.8489801E-05,   3.9458835E-05
     +,   4.0479979E-05,   4.1562176E-05,   4.2715197E-05
     +,   4.3949698E-05,   4.5277258E-05,   4.6710371E-05
     +,   4.8262445E-05,   4.9947765E-05,   5.1781470E-05
     +,   5.3779444E-05,   5.5958208E-05,   5.8334823E-05
     +,   6.0926741E-05,   6.3751097E-05,   6.6825167E-05
     +,   7.0165494E-05,   7.3787603E-05,   7.7705554E-05
     +,   8.1931379E-05,   8.6474560E-05,   9.1341644E-05
     +,   9.6534772E-05,   1.0205239E-04,   1.0788780E-04
     +,   1.1402898E-04,   1.2045808E-04,   1.2715119E-04
     +,   1.3407835E-04,   1.4120343E-04,   1.4848466E-04
     +,   1.5587494E-04,   1.6332301E-04,   1.7077447E-04
     +,   1.7817198E-04,   1.8545878E-04,   1.9257881E-04
     +,   1.9947939E-04,   2.0611273E-04,   2.1243794E-04
     +,   2.1842307E-04,   2.2404655E-04,   2.2929881E-04
     +,   2.3418367E-04,   2.3871806E-04,   2.4293375E-04
     +,   2.4687644E-04,   2.5060528E-04,   2.5419169E-04
     +,   2.5771791E-04,   2.6127495E-04,   2.6496011E-04
     +,   2.6887443E-04,   2.7311951E-04,   2.7779452E-04
     +,   2.8299299E-04,   2.8879847E-04,   2.9528275E-04
     +,   3.0250143E-04,   3.1049151E-04,   3.1926818E-04
     +,   3.2882340E-04,   3.3912127E-04,   3.5010226E-04
     +,   3.6167639E-04,   3.7372866E-04,   3.8611851E-04
     +,   3.9868284E-04,   4.1124024E-04,   4.2359505E-04
     +,   4.3554403E-04,   4.4688262E-04,   4.5741204E-04
     +,   4.6694643E-04,   4.7531971E-04,   4.8239069E-04
     +,   4.8805098E-04,   4.9222459E-04,   4.9487315E-04
     +,   4.9599400E-04,   4.9561972E-04,   4.9381482E-04
     +,   4.9067277E-04,   4.8630938E-04,   4.8086117E-04
     +,   4.7447858E-04,   4.6732518E-04,   4.5957361E-04
     +,   4.5140611E-04,   4.4301499E-04,   4.3460380E-04
     +,   4.2638919E-04,   4.1860368E-04,   4.1149592E-04
     +,   4.0533187E-04,   4.0039286E-04,   3.9697209E-04
     +,   3.9536989E-04,   3.9588529E-04,   3.9880854E-04
     +,   4.0440934E-04,   4.1292759E-04,   4.2455996E-04
     +,   4.3945393E-04,   4.5769082E-04,   4.7928284E-04
     +,   5.0416187E-04,   5.3217442E-04,   5.6307594E-04
     +,   5.9652689E-04,   6.3209323E-04,   6.6924549E-04
     +,   7.0736476E-04,   7.4574980E-04,   7.8363152E-04
     +,   8.2019134E-04,   8.5458456E-04,   8.8597153E-04
     +,   9.1355410E-04,   9.3660719E-04,   9.5452659E-04
     +,   9.6685928E-04,   9.7333500E-04,   9.7388955E-04
     +,   9.6867245E-04,   9.5804431E-04,   9.4255834E-04
     +,   9.2292734E-04,   8.9998002E-04,   8.7460998E-04
     +,   8.4772153E-04,   8.2017435E-04,   7.9273764E-04
     +,   7.6605246E-04,   7.4060576E-04,   7.1672199E-04
     +,   6.9456233E-04,   6.7414087E-04,   6.5534748E-04
     +,   6.3797639E-04,   6.2176044E-04,   6.0639851E-04
     +,   5.9158605E-04,   5.7703827E-04,   5.6250673E-04
     +,   5.4779329E-04,   5.3275336E-04,   5.1729812E-04
     +,   5.0139229E-04,   4.8504752E-04,   4.6831465E-04
     +,   4.5127503E-04,   4.3403025E-04,   4.1669328E-04
     +,   3.9937909E-04,   3.8219709E-04,   3.6524521E-04
     +,   3.4860452E-04,   3.3233681E-04,   3.1648274E-04
     +,   3.0106542E-04,   2.8608833E-04,   2.7154142E-04
     +,   2.5740443E-04,   2.4365082E-04,   2.3025408E-04
     +,   2.1718821E-04,   2.0443293E-04,   1.9197527E-04
     +,   1.7981061E-04,   1.6794304E-04,   1.5638462E-04
     +,   1.4515412E-04,   1.3427545E-04,   1.2377554E-04
     +,   1.1368254E-04,   1.0402378E-04,   9.4824267E-05
     +,   8.6105269E-05,   7.7883051E-05,   7.0170041E-05
     +,   6.2970634E-05,   5.6286051E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wao_hz_70 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wao_hz_75(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  4.0692789E-16,   5.7145967E-16
     +,   8.0071549E-16,   1.1194342E-15,   1.5615010E-15
     +,   2.1732475E-15,   3.0178886E-15,   4.1814133E-15
     +,   5.7805827E-15,   7.9733922E-15,   1.0973399E-14
     +,   1.5068352E-14,   2.0645108E-14,   2.8222458E-14
     +,   3.8494876E-14,   5.2388463E-14,   7.1136917E-14
     +,   9.6379054E-14,   1.3028580E-13,   1.7572836E-13
     +,   2.3648946E-13,   3.1754807E-13,   4.2543684E-13
     +,   5.6870638E-13,   7.5852893E-13,   1.0094430E-12
     +,   1.3403512E-12,   1.7757567E-12,   2.3473556E-12
     +,   3.0959931E-12,   4.0742592E-12,   5.3496478E-12
     +,   7.0085704E-12,   9.1613826E-12,   1.1948762E-11
     +,   1.5549248E-11,   2.0189392E-11,   2.6155567E-11
     +,   3.3808976E-11,   4.3604304E-11,   5.6111359E-11
     +,   7.2044114E-11,   9.2293777E-11,   1.1797031E-10
     +,   1.5045208E-10,   1.9144848E-10,   2.4306859E-10
     +,   3.0791439E-10,   3.8918702E-10,   4.9080534E-10
     +,   6.1756633E-10,   7.7532192E-10,   9.7118913E-10
     +,   1.2138038E-09,   1.5136169E-09,   1.8832398E-09
     +,   2.3378650E-09,   2.8956906E-09,   3.5785459E-09
     +,   4.4124873E-09,   5.4284839E-09,   6.6633619E-09
     +,   8.1607023E-09,   9.9719575E-09,   1.2157716E-08
     +,   1.4789091E-08,   1.7949407E-08,   2.1735707E-08
     +,   2.6261167E-08,   3.1657024E-08,   3.8075292E-08
     +,   4.5690896E-08,   5.4705414E-08,   6.5349880E-08
     +,   7.7888323E-08,   9.2621683E-08,   1.0989221E-07
     +,   1.3008605E-07,   1.5364054E-07,   1.8104694E-07
     +,   2.1285621E-07,   2.4968500E-07,   2.9221698E-07
     +,   3.4121388E-07,   3.9751669E-07,   4.6205207E-07
     +,   5.3583699E-07,   6.1998350E-07,   7.1570304E-07
     +,   8.2431393E-07,   9.4722628E-07,   1.0859701E-06
     +,   1.2421807E-06,   1.4176002E-06,   1.6140772E-06
     +,   1.8335620E-06,   2.0781154E-06,   2.3498542E-06
     +,   2.6510090E-06,   2.9838702E-06,   3.3507849E-06
     +,   3.7541397E-06,   4.1963440E-06,   4.6798045E-06
     +,   5.2069086E-06,   5.7799894E-06,   6.4013043E-06
     +,   7.0730002E-06,   7.7970817E-06,   8.5753718E-06
     +,   9.4094894E-06,   1.0300832E-05,   1.1250392E-05
     +,   1.2258953E-05,   1.3326893E-05,   1.4454188E-05
     +,   1.5640375E-05,   1.6884525E-05,   1.8185265E-05
     +,   1.9540515E-05,   2.0947831E-05,   2.2404134E-05
     +,   2.3905774E-05,   2.5448522E-05,   2.7027569E-05
     +,   2.8637534E-05,   3.0272482E-05,   3.1925952E-05
     +,   3.3590990E-05,   3.5260186E-05,   3.6925732E-05
     +,   3.8579550E-05,   4.0213086E-05,   4.1817788E-05
     +,   4.3384953E-05,   4.4905857E-05,   4.6371875E-05
     +,   4.7774603E-05,   4.9105987E-05,   5.0358532E-05
     +,   5.1525189E-05,   5.2599906E-05,   5.3577565E-05
     +,   5.4454260E-05,   5.5227498E-05,   5.5896435E-05
     +,   5.6462221E-05,   5.6928166E-05,   5.7300211E-05
     +,   5.7587178E-05,   5.7801280E-05,   5.7958434E-05
     +,   5.8078811E-05,   5.8187376E-05,   5.8314337E-05
     +,   5.8495785E-05,   5.8774225E-05,   5.9199170E-05
     +,   5.9827638E-05,   6.0724567E-05,   6.1963285E-05
     +,   6.3625623E-05,   6.5801716E-05,   6.8590110E-05
     +,   7.2097122E-05,   7.6436008E-05,   8.1726226E-05
     +,   8.8092311E-05,   9.5662894E-05,   1.0457014E-04
     +,   1.1494947E-04,   1.2694021E-04,   1.4068723E-04
     +,   1.5634455E-04,   1.7407615E-04,   1.9406498E-04
     +,   2.1651495E-04,   2.4165501E-04,   2.6974067E-04
     +,   3.0105232E-04,   3.3587927E-04,   3.7452026E-04
     +,   4.1723694E-04,   4.6423945E-04,   5.1563856E-04
     +,   5.7140266E-04,   6.3131348E-04,   6.9492462E-04
     +,   7.6152780E-04,   8.3013420E-04,   8.9947227E-04
     +,   9.6800498E-04,   1.0339760E-03,   1.0954577E-03
     +,   1.1504734E-03,   1.1970619E-03,   1.2334454E-03
     +,   1.2581318E-03,   1.2700730E-03,   1.2687868E-03
     +,   1.2544581E-03,   1.2280003E-03,   1.1910748E-03
     +,   1.1460371E-03,   1.0958303E-03,   1.0438220E-03
     +,   9.9359488E-04,   9.4871043E-04,   9.1246655E-04
     +,   8.8765740E-04,   8.7636564E-04,   8.7978289E-04
     +,   8.9808565E-04,   9.3037152E-04,   9.7467931E-04
     +,   1.0280936E-03,   1.0869907E-03,   1.1473467E-03
     +,   1.2051890E-03,   1.2570686E-03,   1.3005094E-03
     +,   1.3343988E-03,   1.3591403E-03,   1.3766203E-03
     +,   1.3898896E-03,   1.4026369E-03,   1.4185294E-03
     +,   1.4405538E-03,   1.4704723E-03,   1.5085117E-03
     +,   1.5533353E-03,   1.6022823E-03,   1.6518132E-03
     +,   1.6980497E-03,   1.7373095E-03,   1.7665369E-03
     +,   1.7835879E-03,   1.7873482E-03,   1.7777265E-03
     +,   1.7555325E-03,   1.7222981E-03,   1.6800745E-03
     +,   1.6312203E-03,   1.5781928E-03,   1.5233741E-03
     +,   1.4689289E-03,   1.4167122E-03,   1.3682112E-03
     +,   1.3245338E-03,   1.2864174E-03,   1.2542435E-03
     +,   1.2280393E-03,   1.2074786E-03,   1.1918688E-03
     +,   1.1801616E-03,   1.1709866E-03,   1.1627324E-03
     +,   1.1536732E-03,   1.1421280E-03,   1.1266287E-03
     +,   1.1060723E-03,   1.0798316E-03,   1.0478001E-03
     +,   1.0103848E-03,   9.6842123E-04,   9.2306262E-04
     +,   8.7564002E-04,   8.2752394E-04,   7.7999826E-04
     +,   7.3416549E-04,   6.9088262E-04,   6.5072789E-04
     +,   6.1399851E-04,   5.8072992E-04,   5.5073301E-04
     +,   5.2364211E-04,   4.9896893E-04,   4.7615624E-04
     +,   4.5463376E-04,   4.3385831E-04,   4.1335550E-04
     +,   3.9274577E-04,   3.7176025E-04,   3.5025037E-04
     +,   3.2817820E-04,   3.0560850E-04,   2.8268970E-04
     +,   2.5963181E-04,   2.3668437E-04,   2.1411339E-04
     +,   1.9218156E-04,   1.7113173E-04,   1.5117436E-04
     +,   1.3247918E-04,   1.1517112E-04,   9.9329372E-05
     +,   8.4989697E-05,   7.2147988E-05,   6.0768631E-05
     +,   5.0784925E-05,   4.2112835E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wao_hz_75 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wao_hz_80(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  2.2920509E-07,   2.4667273E-07
     +,   2.6528204E-07,   2.8509203E-07,   3.0616224E-07
     +,   3.2855561E-07,   3.5233586E-07,   3.7756871E-07
     +,   4.0432181E-07,   4.3266277E-07,   4.6266226E-07
     +,   4.9439149E-07,   5.2792331E-07,   5.6333147E-07
     +,   6.0069146E-07,   6.4007725E-07,   6.8156555E-07
     +,   7.2523369E-07,   7.7115862E-07,   8.1941869E-07
     +,   8.7008931E-07,   9.2324854E-07,   9.7897293E-07
     +,   1.0373391E-06,   1.0984236E-06,   1.1622975E-06
     +,   1.2290357E-06,   1.2987092E-06,   1.3713886E-06
     +,   1.4471387E-06,   1.5260262E-06,   1.6081134E-06
     +,   1.6934592E-06,   1.7821209E-06,   1.8741530E-06
     +,   1.9696008E-06,   2.0685109E-06,   2.1709250E-06
     +,   2.2768788E-06,   2.3864072E-06,   2.4995320E-06
     +,   2.6162754E-06,   2.7366555E-06,   2.8606803E-06
     +,   2.9883556E-06,   3.1196810E-06,   3.2546425E-06
     +,   3.3932295E-06,   3.5354217E-06,   3.6811853E-06
     +,   3.8304884E-06,   3.9832885E-06,   4.1395356E-06
     +,   4.2991737E-06,   4.4621388E-06,   4.6283603E-06
     +,   4.7977628E-06,   4.9702544E-06,   5.1457455E-06
     +,   5.3241406E-06,   5.5053260E-06,   5.6891899E-06
     +,   5.8756145E-06,   6.0644711E-06,   6.2556292E-06
     +,   6.4489482E-06,   6.6442858E-06,   6.8414852E-06
     +,   7.0403935E-06,   7.2408502E-06,   7.4426930E-06
     +,   7.6457436E-06,   7.8498333E-06,   8.0547816E-06
     +,   8.2604120E-06,   8.4665380E-06,   8.6729788E-06
     +,   8.8795396E-06,   9.0860367E-06,   9.2922792E-06
     +,   9.4980796E-06,   9.7032562E-06,   9.9076142E-06
     +,   1.0110971E-05,   1.0313149E-05,   1.0513972E-05
     +,   1.0713271E-05,   1.0910876E-05,   1.1106636E-05
     +,   1.1300410E-05,   1.1492041E-05,   1.1681419E-05
     +,   1.1868426E-05,   1.2052972E-05,   1.2234979E-05
     +,   1.2414390E-05,   1.2591182E-05,   1.2765331E-05
     +,   1.2936872E-05,   1.3105855E-05,   1.3272379E-05
     +,   1.3436573E-05,   1.3598622E-05,   1.3758754E-05
     +,   1.3917256E-05,   1.4074474E-05,   1.4230828E-05
     +,   1.4386803E-05,   1.4542969E-05,   1.4699985E-05
     +,   1.4858602E-05,   1.5019682E-05,   1.5184173E-05
     +,   1.5353164E-05,   1.5527854E-05,   1.5709582E-05
     +,   1.5899815E-05,   1.6100170E-05,   1.6312411E-05
     +,   1.6538430E-05,   1.6780299E-05,   1.7040227E-05
     +,   1.7320577E-05,   1.7623848E-05,   1.7952689E-05
     +,   1.8309864E-05,   1.8698256E-05,   1.9120842E-05
     +,   1.9580675E-05,   2.0080861E-05,   2.0624522E-05
     +,   2.1214817E-05,   2.1854768E-05,   2.2547409E-05
     +,   2.3295634E-05,   2.4102172E-05,   2.4969586E-05
     +,   2.5900190E-05,   2.6896043E-05,   2.7958973E-05
     +,   2.9090339E-05,   3.0291318E-05,   3.1562726E-05
     +,   3.2905034E-05,   3.4318451E-05,   3.5802899E-05
     +,   3.7358142E-05,   3.8983824E-05,   4.0679588E-05
     +,   4.2445237E-05,   4.4280889E-05,   4.6187222E-05
     +,   4.8165439E-05,   5.0217983E-05,   5.2348540E-05
     +,   5.4562421E-05,   5.6867004E-05,   5.9272101E-05
     +,   6.1790437E-05,   6.4438165E-05,   6.7235393E-05
     +,   7.0206988E-05,   7.3382616E-05,   7.6798358E-05
     +,   8.0496960E-05,   8.4528889E-05,   8.8953202E-05
     +,   9.3838724E-05,   9.9264696E-05,   1.0532177E-04
     +,   1.1211247E-04,   1.1975113E-04,   1.2836348E-04
     +,   1.3808552E-04,   1.4905985E-04,   1.6143524E-04
     +,   1.7536181E-04,   1.9098836E-04,   2.0845993E-04
     +,   2.2791771E-04,   2.4949462E-04,   2.7332813E-04
     +,   2.9954966E-04,   3.2829921E-04,   3.5972451E-04
     +,   3.9398627E-04,   4.3126653E-04,   4.7178386E-04
     +,   5.1582354E-04,   5.6378776E-04,   6.1626983E-04
     +,   6.7414634E-04,   7.3867926E-04,   8.1157149E-04
     +,   8.9500990E-04,   9.9151663E-04,   1.1037632E-03
     +,   1.2341215E-03,   1.3841572E-03,   1.5541244E-03
     +,   1.7424028E-03,   1.9454024E-03,   2.1575987E-03
     +,   2.3722022E-03,   2.5820096E-03,   2.7804093E-03
     +,   2.9621932E-03,   3.1239402E-03,   3.2638833E-03
     +,   3.3813857E-03,   3.4762970E-03,   3.5485073E-03
     +,   3.5978898E-03,   3.6246441E-03,   3.6298409E-03
     +,   3.6159025E-03,   3.5867428E-03,   3.5474659E-03
     +,   3.5036867E-03,   3.4606853E-03,   3.4227173E-03
     +,   3.3925718E-03,   3.3715863E-03,   3.3598430E-03
     +,   3.3564451E-03,   3.3596607E-03,   3.3669781E-03
     +,   3.3751903E-03,   3.3807638E-03,   3.3806013E-03
     +,   3.3729281E-03,   3.3578728E-03,   3.3372715E-03
     +,   3.3135582E-03,   3.2881671E-03,   3.2602372E-03
     +,   3.2263275E-03,   3.1814710E-03,   3.1210936E-03
     +,   3.0430637E-03,   2.9489114E-03,   2.8438233E-03
     +,   2.7354334E-03,   2.6318629E-03,   2.5397844E-03
     +,   2.4630155E-03,   2.4019768E-03,   2.3540775E-03
     +,   2.3147650E-03,   2.2789252E-03,   2.2421796E-03
     +,   2.2017765E-03,   2.1568751E-03,   2.1082440E-03
     +,   2.0575447E-03,   2.0064828E-03,   1.9560985E-03
     +,   1.9063806E-03,   1.8562843E-03,   1.8040473E-03
     +,   1.7477167E-03,   1.6856864E-03,   1.6171151E-03
     +,   1.5421619E-03,   1.4619752E-03,   1.3785254E-03
     +,   1.2942989E-03,   1.2119552E-03,   1.1339927E-03
     +,   1.0624902E-03,   9.9893357E-04,   9.4413728E-04
     +,   8.9824927E-04,   8.6081447E-04,   8.3088217E-04
     +,   8.0713298E-04,   7.8801136E-04,   7.7185949E-04
     +,   7.5704051E-04,   7.4203999E-04,   7.2555762E-04
     +,   7.0656970E-04,   6.8436831E-04,   6.5857789E-04
     +,   6.2913902E-04,   5.9627771E-04,   5.6045630E-04
     +,   5.2231248E-04,   4.8259454E-04,   4.4209819E-04
     +,   4.0161039E-04,   3.6186216E-04,   3.2349434E-04
     +,   2.8703557E-04,   2.5289060E-04,   2.2134116E-04
     +,   1.9255211E-04,   1.6658353E-04,   1.4341260E-04
     +,   1.2293867E-04,   1.0501542E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wao_hz_80 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wao_hz_85(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  3.4181798E-07,   3.6625113E-07
     +,   3.9217642E-07,   4.1966544E-07,   4.4878965E-07
     +,   4.7962396E-07,   5.1224515E-07,   5.4673086E-07
     +,   5.8316147E-07,   6.2161661E-07,   6.6217905E-07
     +,   7.0493235E-07,   7.4996132E-07,   7.9735133E-07
     +,   8.4718977E-07,   8.9956137E-07,   9.5455448E-07
     +,   1.0122566E-06,   1.0727550E-06,   1.1361387E-06
     +,   1.2024911E-06,   1.2719000E-06,   1.3444504E-06
     +,   1.4202259E-06,   1.4993112E-06,   1.5817828E-06
     +,   1.6677212E-06,   1.7572020E-06,   1.8503015E-06
     +,   1.9470856E-06,   2.0476234E-06,   2.1519791E-06
     +,   2.2602114E-06,   2.3723774E-06,   2.4885292E-06
     +,   2.6087089E-06,   2.7329600E-06,   2.8613190E-06
     +,   2.9938158E-06,   3.1304776E-06,   3.2713185E-06
     +,   3.4163520E-06,   3.5655862E-06,   3.7190189E-06
     +,   3.8766439E-06,   4.0384512E-06,   4.2044126E-06
     +,   4.3745044E-06,   4.5486968E-06,   4.7269418E-06
     +,   4.9091959E-06,   5.0954063E-06,   5.2855135E-06
     +,   5.4794532E-06,   5.6771541E-06,   5.8785427E-06
     +,   6.0835428E-06,   6.2920626E-06,   6.5040199E-06
     +,   6.7193296E-06,   6.9378939E-06,   7.1596228E-06
     +,   7.3844253E-06,   7.6122110E-06,   7.8428902E-06
     +,   8.0763757E-06,   8.3125942E-06,   8.5514539E-06
     +,   8.7928920E-06,   9.0368458E-06,   9.2832652E-06
     +,   9.5320993E-06,   9.7833181E-06,   1.0036904E-05
     +,   1.0292854E-05,   1.0551177E-05,   1.0811910E-05
     +,   1.1075084E-05,   1.1340770E-05,   1.1609060E-05
     +,   1.1880056E-05,   1.2153891E-05,   1.2430712E-05
     +,   1.2710701E-05,   1.2994054E-05,   1.3281003E-05
     +,   1.3571796E-05,   1.3866710E-05,   1.4166044E-05
     +,   1.4470138E-05,   1.4779312E-05,   1.5093954E-05
     +,   1.5414455E-05,   1.5741227E-05,   1.6074704E-05
     +,   1.6415337E-05,   1.6763597E-05,   1.7119939E-05
     +,   1.7484857E-05,   1.7858840E-05,   1.8242385E-05
     +,   1.8635978E-05,   1.9040121E-05,   1.9455289E-05
     +,   1.9881951E-05,   2.0320565E-05,   2.0771560E-05
     +,   2.1235350E-05,   2.1712318E-05,   2.2202812E-05
     +,   2.2707140E-05,   2.3225597E-05,   2.3758363E-05
     +,   2.4305633E-05,   2.4867535E-05,   2.5444133E-05
     +,   2.6035432E-05,   2.6641381E-05,   2.7261889E-05
     +,   2.7896716E-05,   2.8545635E-05,   2.9208333E-05
     +,   2.9884415E-05,   3.0573432E-05,   3.1274867E-05
     +,   3.1988126E-05,   3.2712582E-05,   3.3447537E-05
     +,   3.4192239E-05,   3.4945904E-05,   3.5707719E-05
     +,   3.6476860E-05,   3.7252412E-05,   3.8033548E-05
     +,   3.8819431E-05,   3.9609251E-05,   4.0402258E-05
     +,   4.1197760E-05,   4.1995176E-05,   4.2794079E-05
     +,   4.3594086E-05,   4.4395074E-05,   4.5197139E-05
     +,   4.6000583E-05,   4.6806010E-05,   4.7614307E-05
     +,   4.8426766E-05,   4.9245038E-05,   5.0071241E-05
     +,   5.0907991E-05,   5.1758467E-05,   5.2626514E-05
     +,   5.3516567E-05,   5.4433971E-05,   5.5384964E-05
     +,   5.6376779E-05,   5.7417838E-05,   5.8517875E-05
     +,   5.9688155E-05,   6.0941555E-05,   6.2292856E-05
     +,   6.3758860E-05,   6.5358327E-05,   6.7112378E-05
     +,   6.9044232E-05,   7.1179129E-05,   7.3544070E-05
     +,   7.6167358E-05,   7.9078040E-05,   8.2305138E-05
     +,   8.5876920E-05,   8.9819958E-05,   9.4158633E-05
     +,   9.8914948E-05,   1.0410812E-04,   1.0975726E-04
     +,   1.1588327E-04,   1.2251372E-04,   1.2968967E-04
     +,   1.3747560E-04,   1.4596974E-04,   1.5532340E-04
     +,   1.6575323E-04,   1.7756459E-04,   1.9116946E-04
     +,   2.0710457E-04,   2.2604500E-04,   2.4881188E-04
     +,   2.7637265E-04,   3.0983562E-04,   3.5044504E-04
     +,   3.9958535E-04,   4.5881004E-04,   5.2988052E-04
     +,   6.1487418E-04,   7.1620138E-04,   8.3668478E-04
     +,   9.7942050E-04,   1.1476366E-03,   1.3445973E-03
     +,   1.5735280E-03,   1.8381431E-03,   2.1431406E-03
     +,   2.4947659E-03,   2.9001136E-03,   3.3646198E-03
     +,   3.8876212E-03,   4.4573662E-03,   5.0482028E-03
     +,   5.6230146E-03,   6.1426614E-03,   6.5810103E-03
     +,   6.9398805E-03,   7.2553745E-03,   7.5882967E-03
     +,   7.9989806E-03,   8.5180625E-03,   9.1294581E-03
     +,   9.7774770E-03,   1.0392751E-02,   1.0919539E-02
     +,   1.1328042E-02,   1.1607696E-02,   1.1755061E-02
     +,   1.1771305E-02,   1.1673788E-02,   1.1507294E-02
     +,   1.1332721E-02,   1.1188610E-02,   1.1052791E-02
     +,   1.0844365E-02,   1.0476815E-02,   9.9249994E-03
     +,   9.2535261E-03,   8.5870121E-03,   8.0484301E-03
     +,   7.7075232E-03,   7.5632790E-03,   7.5586904E-03
     +,   7.6135690E-03,   7.6583698E-03,   7.6551381E-03
     +,   7.5983326E-03,   7.4994410E-03,   7.3684431E-03
     +,   7.2049485E-03,   7.0026331E-03,   6.7608510E-03
     +,   6.4931316E-03,   6.2261256E-03,   5.9895632E-03
     +,   5.8037327E-03,   5.6715193E-03,   5.5786455E-03
     +,   5.5006556E-03,   5.4120342E-03,   5.2933288E-03
     +,   5.1344032E-03,   4.9345479E-03,   4.7008148E-03
     +,   4.4457717E-03,   4.1848077E-03,   3.9330130E-03
     +,   3.7021576E-03,   3.4982963E-03,   3.3211103E-03
     +,   3.1650364E-03,   3.0217576E-03,   2.8831488E-03
     +,   2.7436158E-03,   2.6012193E-03,   2.4574886E-03
     +,   2.3162535E-03,   2.1821070E-03,   2.0589847E-03
     +,   1.9492535E-03,   1.8533650E-03,   1.7700267E-03
     +,   1.6966987E-03,   1.6301777E-03,   1.5671839E-03
     +,   1.5048016E-03,   1.4407629E-03,   1.3735822E-03
     +,   1.3025383E-03,   1.2275932E-03,   1.1492489E-03
     +,   1.0683828E-03,   9.8609622E-04,   9.0357778E-04
     +,   8.2200125E-04,   7.4244878E-04,   6.6586531E-04
     +,   5.9303181E-04,   5.2455533E-04,   4.6087164E-04
     +,   4.0225472E-04,   3.4882841E-04,   3.0059592E-04
     +,   2.5743467E-04,   2.1914762E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wao_hz_85 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wao_hz_90(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  1.3971692E-14,   1.8188620E-14
     +,   2.3644743E-14,   3.0694272E-14,   3.9788885E-14
     +,   5.1505339E-14,   6.6577420E-14,   8.5938276E-14
     +,   1.1077271E-13,   1.4258107E-13,   1.8326303E-13
     +,   2.3521856E-13,   3.0147599E-13,   3.8584804E-13
     +,   4.9313391E-13,   6.2935188E-13,   8.0205449E-13
     +,   1.0206904E-12,   1.2970746E-12,   1.6459539E-12
     +,   2.0856713E-12,   2.6390749E-12,   3.3345238E-12
     +,   4.2071823E-12,   5.3005989E-12,   6.6685234E-12
     +,   8.3773362E-12,   1.0508793E-11,   1.3163489E-11
     +,   1.6464732E-11,   2.0563865E-11,   2.5645984E-11
     +,   3.1937213E-11,   3.9713316E-11,   4.9310278E-11
     +,   6.1135638E-11,   7.5684674E-11,   9.3556961E-11
     +,   1.1547729E-10,   1.4232134E-10,   1.7514189E-10
     +,   2.1520739E-10,   2.6403948E-10,   3.2346215E-10
     +,   3.9565698E-10,   4.8323062E-10,   5.8928390E-10
     +,   7.1751199E-10,   8.7230395E-10,   1.0588500E-09
     +,   1.2833016E-09,   1.5529182E-09,   1.8762532E-09
     +,   2.2633688E-09,   2.7260760E-09,   3.2782135E-09
     +,   3.9359733E-09,   4.7182098E-09,   5.6469247E-09
     +,   6.7477006E-09,   8.0501348E-09,   9.5885575E-09
     +,   1.1402604E-08,   1.3537959E-08,   1.6047174E-08
     +,   1.8990571E-08,   2.2437325E-08,   2.6466243E-08
     +,   3.1167442E-08,   3.6643396E-08,   4.3010601E-08
     +,   5.0400558E-08,   5.8962396E-08,   6.8864047E-08
     +,   8.0294548E-08,   9.3466042E-08,   1.0861645E-07
     +,   1.2601049E-07,   1.4594430E-07,   1.6874661E-07
     +,   1.9478226E-07,   2.2445529E-07,   2.5820961E-07
     +,   2.9653597E-07,   3.3997216E-07,   3.8910721E-07
     +,   4.4458457E-07,   5.0710474E-07,   5.7742858E-07
     +,   6.5638409E-07,   7.4485433E-07,   8.4380184E-07
     +,   9.5425571E-07,   1.0773184E-06,   1.2141668E-06
     +,   1.3660531E-06,   1.5343132E-06,   1.7203372E-06
     +,   1.9256124E-06,   2.1516935E-06,   2.4002086E-06
     +,   2.6728546E-06,   2.9713967E-06,   3.2976593E-06
     +,   3.6535266E-06,   4.0409336E-06,   4.4618560E-06
     +,   4.9183091E-06,   5.4123325E-06,   5.9459853E-06
     +,   6.5213280E-06,   7.1404552E-06,   7.8053472E-06
     +,   8.5180509E-06,   9.2805358E-06,   1.0094715E-05
     +,   1.0962434E-05,   1.1885456E-05,   1.2865487E-05
     +,   1.3903988E-05,   1.5002431E-05,   1.6162105E-05
     +,   1.7384134E-05,   1.8669507E-05,   2.0019012E-05
     +,   2.1433269E-05,   2.2912707E-05,   2.4457544E-05
     +,   2.6067815E-05,   2.7743330E-05,   2.9483686E-05
     +,   3.1288375E-05,   3.3156415E-05,   3.5086847E-05
     +,   3.7078444E-05,   3.9129773E-05,   4.1239207E-05
     +,   4.3404933E-05,   4.5624944E-05,   4.7897163E-05
     +,   5.0219049E-05,   5.2588188E-05,   5.5001925E-05
     +,   5.7457451E-05,   5.9951799E-05,   6.2481849E-05
     +,   6.5044362E-05,   6.7635912E-05,   7.0252980E-05
     +,   7.2891795E-05,   7.5548473E-05,   7.8219047E-05
     +,   8.0898979E-05,   8.3583865E-05,   8.6268941E-05
     +,   8.8949186E-05,   9.1619309E-05,   9.4273710E-05
     +,   9.6906420E-05,   9.9511301E-05,   1.0208179E-04
     +,   1.0461122E-04,   1.0709231E-04,   1.0951808E-04
     +,   1.1188135E-04,   1.1417522E-04,   1.1639314E-04
     +,   1.1852953E-04,   1.2058001E-04,   1.2254232E-04
     +,   1.2441700E-04,   1.2620850E-04,   1.2792669E-04
     +,   1.2958849E-04,   1.3121977E-04,   1.3285853E-04
     +,   1.3455769E-04,   1.3638893E-04,   1.3844753E-04
     +,   1.4085748E-04,   1.4377739E-04,   1.4740863E-04
     +,   1.5200094E-04,   1.5786204E-04,   1.6536386E-04
     +,   1.7494931E-04,   1.8713561E-04,   2.0251397E-04
     +,   2.2174352E-04,   2.4553668E-04,   2.7463638E-04
     +,   3.0978097E-04,   3.5166307E-04,   4.0086557E-04
     +,   4.5782680E-04,   5.2275037E-04,   5.9559930E-04
     +,   6.7602872E-04,   7.6340570E-04,   8.5687876E-04
     +,   9.5541682E-04,   1.0580228E-03,   1.1638640E-03
     +,   1.2725571E-03,   1.3844025E-03,   1.5006395E-03
     +,   1.6236784E-03,   1.7572817E-03,   1.9067125E-03
     +,   2.0788186E-03,   2.2820286E-03,   2.5261540E-03
     +,   2.8218678E-03,   3.1798654E-03,   3.6099404E-03
     +,   4.1203299E-03,   4.7179847E-03,   5.4079150E-03
     +,   6.1906590E-03,   7.0555820E-03,   7.9731662E-03
     +,   8.8956710E-03,   9.7726723E-03,   1.0580174E-02
     +,   1.1340129E-02,   1.2107123E-02,   1.2923753E-02
     +,   1.3786126E-02,   1.4663014E-02,   1.5555082E-02
     +,   1.6525602E-02,   1.7663093E-02,   1.9016940E-02
     +,   2.0573262E-02,   2.2284482E-02,   2.4100566E-02
     +,   2.5935709E-02,   2.7599219E-02,   2.8848469E-02
     +,   2.9586133E-02,   2.9918801E-02,   2.9930267E-02
     +,   2.9496947E-02,   2.8470352E-02,   2.7044065E-02
     +,   2.5796207E-02,   2.5219373E-02,   2.5257908E-02
     +,   2.5422484E-02,   2.5305156E-02,   2.4878113E-02
     +,   2.4298741E-02,   2.3583023E-02,   2.2629522E-02
     +,   2.1481220E-02,   2.0355253E-02,   1.9402584E-02
     +,   1.8573511E-02,   1.7745664E-02,   1.6892819E-02
     +,   1.6084988E-02,   1.5364358E-02,   1.4672070E-02
     +,   1.3903959E-02,   1.3017917E-02,   1.2075965E-02
     +,   1.1191807E-02,   1.0448424E-02,   9.8567912E-03
     +,   9.3713040E-03,   8.9312643E-03,   8.4931403E-03
     +,   8.0398005E-03,   7.5726751E-03,   7.0992764E-03
     +,   6.6249277E-03,   6.1510205E-03,   5.6774220E-03
     +,   5.2057370E-03,   4.7407262E-03,   4.2900611E-03
     +,   3.8625728E-03,   3.4661635E-03,   3.1061615E-03
     +,   2.7842557E-03,   2.4985729E-03,   2.2444741E-03
     +,   2.0158845E-03,   1.8066841E-03,   1.6118396E-03
     +,   1.4280335E-03,   1.2537808E-03,   1.0891346E-03
     +,   9.3515764E-04,   7.9333782E-04,   6.6508091E-04
     +,   5.5135554E-04,   4.5250641E-04,   3.6824841E-04
     +,   2.9770544E-04,   2.3961069E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wao_hz_90 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wao_hz_95(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  3.5851521E-12,   4.2773849E-12
     +,   5.0986880E-12,   6.0722733E-12,   7.2253128E-12
     +,   8.5896863E-12,   1.0202714E-11,   1.2108016E-11
     +,   1.4356683E-11,   1.7008143E-11,   2.0131933E-11
     +,   2.3809028E-11,   2.8133697E-11,   3.3215739E-11
     +,   3.9182831E-11,   4.6182898E-11,   5.4388077E-11
     +,   6.3997689E-11,   7.5242909E-11,   8.8391440E-11
     +,   1.0375199E-10,   1.2168233E-10,   1.4259531E-10
     +,   1.6696666E-10,   1.9534607E-10,   2.2836369E-10
     +,   2.6674735E-10,   3.1133243E-10,   3.6307982E-10
     +,   4.2308809E-10,   4.9261961E-10,   5.7312022E-10
     +,   6.6624356E-10,   7.7387924E-10,   8.9818769E-10
     +,   1.0416273E-09,   1.2070057E-09,   1.3975185E-09
     +,   1.6167987E-09,   1.8689821E-09,   2.1587436E-09
     +,   2.4913995E-09,   2.8729723E-09,   3.3102676E-09
     +,   3.8109800E-09,   4.3838093E-09,   5.0385220E-09
     +,   5.7861596E-09,   6.6391461E-09,   7.6113889E-09
     +,   8.7185361E-09,   9.9781285E-09,   1.1409789E-08
     +,   1.3035447E-08,   1.4879601E-08,   1.6969562E-08
     +,   1.9335792E-08,   2.2012006E-08,   2.5035808E-08
     +,   2.8448930E-08,   3.2297329E-08,   3.6632063E-08
     +,   4.1509484E-08,   4.6991651E-08,   5.3146927E-08
     +,   6.0050439E-08,   6.7784875E-08,   7.6440259E-08
     +,   8.6115605E-08,   9.6919003E-08,   1.0896857E-07
     +,   1.2239202E-07,   1.3732918E-07,   1.5393128E-07
     +,   1.7236248E-07,   1.9280016E-07,   2.1543632E-07
     +,   2.4047645E-07,   2.6814322E-07,   2.9867510E-07
     +,   3.3232820E-07,   3.6937701E-07,   4.1011219E-07
     +,   4.5484654E-07,   5.0391196E-07,   5.5766100E-07
     +,   6.1646745E-07,   6.8072683E-07,   7.5085683E-07
     +,   8.2730213E-07,   9.1051862E-07,   1.0009962E-06
     +,   1.0992452E-06,   1.2057991E-06,   1.3212142E-06
     +,   1.4460710E-06,   1.5809785E-06,   1.7265510E-06
     +,   1.8834423E-06,   2.0523223E-06,   2.2338816E-06
     +,   2.4288333E-06,   2.6379073E-06,   2.8618558E-06
     +,   3.1014454E-06,   3.3574624E-06,   3.6307074E-06
     +,   3.9219995E-06,   4.2321672E-06,   4.5620568E-06
     +,   4.9125233E-06,   5.2844543E-06,   5.6786935E-06
     +,   6.0961506E-06,   6.5377230E-06,   7.0043234E-06
     +,   7.4968711E-06,   8.0163009E-06,   8.5635738E-06
     +,   9.1396023E-06,   9.7453731E-06,   1.0381872E-05
     +,   1.1050099E-05,   1.1751072E-05,   1.2485832E-05
     +,   1.3255445E-05,   1.4061004E-05,   1.4903632E-05
     +,   1.5784484E-05,   1.6704766E-05,   1.7665707E-05
     +,   1.8668645E-05,   1.9714822E-05,   2.0805661E-05
     +,   2.1942607E-05,   2.3127150E-05,   2.4360847E-05
     +,   2.5645300E-05,   2.6982189E-05,   2.8373281E-05
     +,   2.9820225E-05,   3.1324897E-05,   3.2889147E-05
     +,   3.4514858E-05,   3.6203914E-05,   3.7958245E-05
     +,   3.9779738E-05,   4.1670279E-05,   4.3631728E-05
     +,   4.5665882E-05,   4.7774527E-05,   4.9959453E-05
     +,   5.2222105E-05,   5.4564145E-05,   5.6987119E-05
     +,   5.9492519E-05,   6.2081861E-05,   6.4756685E-05
     +,   6.7518675E-05,   7.0369650E-05,   7.3311814E-05
     +,   7.6347831E-05,   7.9480582E-05,   8.2714039E-05
     +,   8.6053034E-05,   8.9503490E-05,   9.3072675E-05
     +,   9.6769654E-05,   1.0060520E-04,   1.0459243E-04
     +,   1.0874684E-04,   1.1308671E-04,   1.1763324E-04
     +,   1.2241110E-04,   1.2744775E-04,   1.3277486E-04
     +,   1.3842751E-04,   1.4444444E-04,   1.5086803E-04
     +,   1.5774441E-04,   1.6512156E-04,   1.7305254E-04
     +,   1.8159021E-04,   1.9079004E-04,   2.0070773E-04
     +,   2.1139810E-04,   2.2291396E-04,   2.3530419E-04
     +,   2.4861202E-04,   2.6287354E-04,   2.7811533E-04
     +,   2.9435332E-04,   3.1159181E-04,   3.2981994E-04
     +,   3.4902099E-04,   3.6916204E-04,   3.9021272E-04
     +,   4.1213859E-04,   4.3491545E-04,   4.5854721E-04
     +,   4.8306337E-04,   5.0855044E-04,   5.3514860E-04
     +,   5.6307524E-04,   5.9263030E-04,   6.2419922E-04
     +,   6.5825833E-04,   6.9537223E-04,   7.3619816E-04
     +,   7.8149792E-04,   8.3216128E-04,   8.8925165E-04
     +,   9.5406541E-04,   1.0282007E-03,   1.1136030E-03
     +,   1.2125436E-03,   1.3275630E-03,   1.4612038E-03
     +,   1.6157603E-03,   1.7929275E-03,   1.9935095E-03
     +,   2.2174299E-03,   2.4637331E-03,   2.7309798E-03
     +,   3.0174556E-03,   3.3212197E-03,   3.6398543E-03
     +,   3.9700652E-03,   4.3075327E-03,   4.6474445E-03
     +,   4.9858168E-03,   5.3211688E-03,   5.6556463E-03
     +,   5.9944121E-03,   6.3432078E-03,   6.7053437E-03
     +,   7.0810346E-03,   7.4714660E-03,   7.8868633E-03
     +,   8.3518326E-03,   8.8992799E-03,   9.5491847E-03
     +,   1.0281729E-02,   1.1025966E-02,   1.1681779E-02
     +,   1.2172983E-02,   1.2505476E-02,   1.2792867E-02
     +,   1.3222507E-02,   1.3965976E-02,   1.5082790E-02
     +,   1.6488269E-02,   1.8012574E-02,   1.9492418E-02
     +,   2.0819223E-02,   2.1945715E-02,   2.2881737E-02
     +,   2.3651753E-02,   2.4239821E-02,   2.4665480E-02
     +,   2.5159258E-02,   2.6121428E-02,   2.7812982E-02
     +,   3.0206822E-02,   3.3083156E-02,   3.5990685E-02
     +,   3.8277347E-02,   3.9532613E-02,   3.9969917E-02
     +,   4.0187553E-02,   4.0423062E-02,   4.0184792E-02
     +,   3.8913310E-02,   3.6795232E-02,   3.4518275E-02
     +,   3.2420829E-02,   3.0274726E-02,   2.7760863E-02
     +,   2.4926916E-02,   2.2218158E-02,   2.0077996E-02
     +,   1.8565416E-02,   1.7405363E-02,   1.6284831E-02
     +,   1.5039786E-02,   1.3665511E-02,   1.2238950E-02
     +,   1.0835698E-02,   9.4915032E-03,   8.2105221E-03
     +,   6.9885016E-03,   5.8278926E-03,   4.7429465E-03
     +,   3.7577495E-03,   2.8983769E-03,   2.1826427E-03
     +,   1.6133521E-03,   1.1782856E-03,   8.5560809E-04
     +,   6.2043208E-04,   4.5011885E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wao_hz_95 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wao_qq(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   1.3209369E-38,   2.6904639E-38
     +,   5.4620305E-38,   1.1052562E-37,   2.2291899E-37
     +,   4.4814606E-37,   8.9797457E-37,   1.7934683E-36
     +,   3.5702495E-36,   7.0841105E-36,   1.4010403E-35
     +,   2.7618774E-35,   5.4266295E-35,   1.0627579E-34
     +,   2.0745340E-34,   4.0363468E-34,   7.8277748E-34
     +,   1.5130854E-33,   2.9152135E-33,   5.5982540E-33
     +,   1.0715685E-32,   2.0444233E-32,   3.8877524E-32
     +,   7.3689102E-32,   1.3921514E-31,   2.6215501E-31
     +,   4.9204534E-31,   9.2051091E-31,   1.7164572E-30
     +,   3.1901950E-30,   5.9099440E-30,   1.0912720E-29
     +,   2.0084353E-29,   3.6843533E-29,   6.7366640E-29
     +,   1.2277513E-28,   2.2302885E-28,   4.0381768E-28
     +,   7.2876602E-28,   1.3109096E-27,   2.3503774E-27
     +,   4.2003068E-27,   7.4818896E-27,   1.3283578E-26
     +,   2.3507017E-26,   4.1463571E-26,   7.2897243E-26
     +,   1.2774164E-25,   2.2311942E-25,   3.8843716E-25
     +,   6.7403801E-25,   1.1658067E-24,   2.0097894E-24
     +,   3.4535025E-24,   5.9148112E-24,   1.0097267E-23
     +,   1.7181207E-23,   2.9139165E-23,   4.9258255E-23
     +,   8.2996775E-23,   1.3938742E-22,   2.3332761E-22
     +,   3.8930407E-22,   6.4743609E-22,   1.0731986E-21
     +,   1.7731352E-21,   2.9200063E-21,   4.7930379E-21
     +,   7.8417247E-21,   1.2787749E-20,   2.0785330E-20
     +,   3.3674274E-20,   5.4377774E-20,   8.7523864E-20
     +,   1.4041334E-19,   2.2452717E-19,   3.5785981E-19
     +,   5.6850438E-19,   9.0019843E-19,   1.4207591E-18
     +,   2.2350224E-18,   3.5044805E-18,   5.4770147E-18
     +,   8.5318899E-18,   1.3247282E-17,   2.0501595E-17
     +,   3.1625477E-17,   4.8624859E-17,   7.4517631E-17
     +,   1.1382537E-16,   1.7330033E-16,   2.6299089E-16
     +,   3.9779687E-16,   5.9974930E-16,   9.0126148E-16
     +,   1.3499276E-15,   2.0153531E-15,   2.9989640E-15
     +,   4.4480605E-15,   6.5758382E-15,   9.6897147E-15
     +,   1.4231485E-14,   2.0833897E-14,   3.0399758E-14
     +,   4.4213084E-14,   6.4092916E-14,   9.2608206E-14
     +,   1.3337337E-13,   1.9145928E-13,   2.7393959E-13
     +,   3.9067377E-13,   5.5533247E-13,   7.8681544E-13
     +,   1.1111464E-12,   1.5640503E-12,   2.1944061E-12
     +,   3.0687111E-12,   4.2773463E-12,   5.9425520E-12
     +,   8.2290893E-12,   1.1358235E-11,   1.5626035E-11
     +,   2.1427337E-11,   2.9286414E-11,   3.9897381E-11
     +,   5.4175529E-11,   7.3323118E-11,   9.8914356E-11
     +,   1.3300357E-10,   1.7825498E-10,   2.3812197E-10
     +,   3.1705708E-10,   4.2078005E-10,   5.5661270E-10
     +,   7.3388984E-10,   9.6447028E-10,   1.2633730E-09
     +,   1.6494864E-09,   2.1465771E-09,   2.7843514E-09
     +,   3.5998249E-09,   4.6389377E-09,   5.9584790E-09
     +,   7.6283913E-09,   9.7344159E-09,   1.2381321E-08
     +,   1.5696539E-08,   1.9834474E-08,   2.4981709E-08
     +,   3.1361648E-08,   3.9242384E-08,   4.8943164E-08
     +,   6.0842709E-08,   7.5388492E-08,   9.3106792E-08
     +,   1.1461405E-07,   1.4062877E-07,   1.7198488E-07
     +,   2.0964789E-07,   2.5472207E-07,   3.0847676E-07
     +,   3.7235597E-07,   4.4799629E-07,   5.3724222E-07
     +,   6.4216403E-07,   7.6507052E-07,   9.0852558E-07
     +,   1.0753575E-06,   1.2686698E-06,   1.4918465E-06
     +,   1.7485684E-06,   2.0427631E-06,   2.3786656E-06
     +,   2.7607621E-06,   3.1937759E-06,   3.6826482E-06
     +,   4.2325169E-06,   4.8485535E-06,   5.5361916E-06
     +,   6.3006910E-06,   7.1473628E-06,   8.0813597E-06
     +,   9.1076136E-06,   1.0230727E-05,   1.1454887E-05
     +,   1.2783754E-05,   1.4220346E-05,   1.5766946E-05
     +,   1.7424973E-05,   1.9194989E-05,   2.1076179E-05
     +,   2.3067205E-05,   2.5164842E-05,   2.7365395E-05
     +,   2.9663390E-05,   3.2052096E-05,   3.4524295E-05
     +,   3.7070833E-05,   3.9682553E-05,   4.2348736E-05
     +,   4.5058641E-05,   4.7801161E-05,   5.0565304E-05
     +,   5.3340500E-05,   5.6117045E-05,   5.8886508E-05
     +,   6.1642168E-05,   6.4379514E-05,   6.7096596E-05
     +,   6.9794565E-05,   7.2477909E-05,   7.5154974E-05
     +,   7.7837583E-05,   8.0542464E-05,   8.3289546E-05
     +,   8.6103260E-05,   8.9011686E-05,   9.2045731E-05
     +,   9.5240051E-05,   9.8630509E-05,   1.0225493E-04
     +,   1.0615172E-04,   1.1035903E-04,   1.1491415E-04
     +,   1.1985275E-04,   1.2520829E-04,   1.3101174E-04
     +,   1.3729150E-04,   1.4407384E-04,   1.5138327E-04
     +,   1.5924392E-04,   1.6768106E-04,   1.7672290E-04
     +,   1.8640337E-04,   1.9676305E-04,   2.0785427E-04
     +,   2.1974204E-04,   2.3250651E-04,   2.4624550E-04
     +,   2.6107233E-04,   2.7711916E-04,   2.9453266E-04
     +,   3.1347046E-04,   3.3409634E-04,   3.5657280E-04
     +,   3.8105209E-04,   4.0766640E-04,   4.3651729E-04
     +,   4.6766439E-04,   5.0111511E-04,   5.3681567E-04
     +,   5.7464425E-04,   6.1440590E-04,   6.5583229E-04
     +,   6.9858506E-04,   7.4225431E-04,   7.8637910E-04
     +,   8.3045149E-04,   8.7393192E-04,   9.1626693E-04
     +,   9.5689669E-04,   9.9528080E-04,   1.0309055E-03
     +,   1.0632965E-03,   1.0920289E-03,   1.1167339E-03
     +,   1.1371038E-03,   1.1528943E-03,   1.1639264E-03
     +,   1.1700846E-03,   1.1713160E-03,   1.1676284E-03
     +,   1.1590880E-03,   1.1458165E-03,   1.1279894E-03
     +,   1.1058331E-03,   1.0796195E-03,   1.0496641E-03
     +,   1.0163197E-03,   9.7996939E-04,   9.4102731E-04
     +,   8.9991948E-04,   8.5708406E-04,   8.1296050E-04
     +,   7.6798152E-04,   7.2256551E-04,   6.7710894E-04
     +,   6.3198089E-04,   5.8751786E-04,   5.4402050E-04
     +,   5.0175138E-04,   4.6093451E-04,   4.2175534E-04
     +,   3.8436227E-04,   3.4886730E-04,   3.1535616E-04
     +,   2.8387454E-04,   2.5445232E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wao_qq = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wao_ww(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   2.8208682E-38,   7.5267210E-38,   1.9955479E-37
     +,   5.2572472E-37,   1.3762728E-36,   3.5799536E-36
     +,   9.2530906E-36,   2.3764972E-35,   6.0650417E-35
     +,   1.5380129E-34,   3.8754850E-34,   9.7035121E-34
     +,   2.4141730E-33,   5.9682846E-33,   1.4661347E-32
     +,   3.5787250E-32,   8.6800295E-32,   2.0919633E-31
     +,   5.0098370E-31,   1.1921790E-30,   2.8189528E-30
     +,   6.6232467E-30,   1.5463010E-29,   3.5872004E-29
     +,   8.2690530E-29,   1.8940627E-28,   4.3109347E-28
     +,   9.7499414E-28,   2.1910696E-27,   4.8926860E-27
     +,   1.0856225E-26,   2.3935767E-26,   5.2439233E-26
     +,   1.1415696E-25,   2.4694618E-25,   5.3079423E-25
     +,   1.1336764E-24,   2.4059753E-24,   5.0737889E-24
     +,   1.0631949E-23,   2.2137715E-23,   4.5802826E-23
     +,   9.4165058E-23,   1.9236621E-22,   3.9048804E-22
     +,   7.8763548E-22,   1.5786404E-21,   3.1439942E-21
     +,   6.2218967E-21,   1.2235355E-20,   2.3907741E-20
     +,   4.6419699E-20,   8.9559116E-20,   1.7169456E-19
     +,   3.2707538E-19,   6.1912980E-19,   1.1645892E-18
     +,   2.1766821E-18,   4.0426223E-18,   7.4606281E-18
     +,   1.3681564E-17,   2.4931106E-17,   4.5143600E-17
     +,   8.1226734E-17,   1.4522846E-16,   2.5802169E-16
     +,   4.5552479E-16,   7.9913535E-16,   1.3931086E-15
     +,   2.4133199E-15,   4.1542485E-15,   7.1060686E-15
     +,   1.2078852E-14,   2.0402652E-14,   3.4246152E-14
     +,   5.7122086E-14,   9.4681492E-14,   1.5595844E-13
     +,   2.5528033E-13,   4.1524317E-13,   6.7122485E-13
     +,   1.0782443E-12,   1.7212831E-12,   2.7307304E-12
     +,   4.3052662E-12,   6.7455672E-12,   1.0503607E-11
     +,   1.6254227E-11,   2.4997962E-11,   3.8209172E-11
     +,   5.8042016E-11,   8.7628210E-11,   1.3148510E-10
     +,   1.9608574E-10,   2.9064223E-10,   4.2817383E-10
     +,   6.2695543E-10,   9.1246238E-10,   1.3199589E-09
     +,   1.8979638E-09,   2.7126184E-09,   3.8536996E-09
     +,   5.4420415E-09,   7.6391879E-09,   1.0659599E-08
     +,   1.4785993E-08,   2.0388343E-08,   2.7947481E-08
     +,   3.8083648E-08,   5.1591318E-08,   6.9480450E-08
     +,   9.3026863E-08,   1.2382495E-07,   1.6385991E-07
     +,   2.1557942E-07,   2.8197877E-07,   3.6669431E-07
     +,   4.7411007E-07,   6.0943773E-07,   7.7889246E-07
     +,   9.8971668E-07,   1.2503619E-06,   1.5705549E-06
     +,   1.9613885E-06,   2.4353817E-06,   3.0065107E-06
     +,   3.6901970E-06,   4.5032498E-06,   5.4637412E-06
     +,   6.5908225E-06,   7.9045158E-06,   9.4250536E-06
     +,   1.1173167E-05,   1.3168504E-05,   1.5430302E-05
     +,   1.7975510E-05,   2.0818485E-05,   2.3971110E-05
     +,   2.7440150E-05,   3.1228796E-05,   3.5333607E-05
     +,   3.9745701E-05,   4.4449476E-05,   4.9422411E-05
     +,   5.4635027E-05,   6.0050963E-05,   6.5627399E-05
     +,   7.1315684E-05,   7.7062294E-05,   8.2809907E-05
     +,   8.8498906E-05,   9.4068790E-05,   9.9460151E-05
     +,   1.0461522E-04,   1.0948207E-04,   1.1401290E-04
     +,   1.1816806E-04,   1.2191605E-04,   1.2523377E-04
     +,   1.2810867E-04,   1.3053670E-04,   1.3252343E-04
     +,   1.3408261E-04,   1.3523515E-04,   1.3600790E-04
     +,   1.3643176E-04,   1.3654021E-04,   1.3636739E-04
     +,   1.3594666E-04,   1.3530889E-04,   1.3448152E-04
     +,   1.3348750E-04,   1.3234490E-04,   1.3106687E-04
     +,   1.2966176E-04,   1.2813407E-04,   1.2648515E-04
     +,   1.2471453E-04,   1.2282128E-04,   1.2080530E-04
     +,   1.1866904E-04,   1.1641822E-04,   1.1406321E-04
     +,   1.1161959E-04,   1.0910867E-04,   1.0655751E-04
     +,   1.0399868E-04,   1.0146958E-04,   9.9011595E-05
     +,   9.6669050E-05,   9.4487768E-05,   9.2513830E-05
     +,   9.0792135E-05,   8.9365094E-05,   8.8271372E-05
     +,   8.7544824E-05,   8.7213739E-05,   8.7299930E-05
     +,   8.7818487E-05,   8.8777429E-05,   9.0177644E-05
     +,   9.2012669E-05,   9.4269162E-05,   9.6926822E-05
     +,   9.9958655E-05,   1.0333113E-04,   1.0700445E-04
     +,   1.1093268E-04,   1.1506400E-04,   1.1934100E-04
     +,   1.2370106E-04,   1.2807678E-04,   1.3239679E-04
     +,   1.3658646E-04,   1.4056914E-04,   1.4426750E-04
     +,   1.4760456E-04,   1.5050615E-04,   1.5290221E-04
     +,   1.5472883E-04,   1.5592996E-04,   1.5645906E-04
     +,   1.5628090E-04,   1.5537265E-04,   1.5372448E-04
     +,   1.5134054E-04,   1.4823866E-04,   1.4444999E-04
     +,   1.4001837E-04,   1.3499889E-04,   1.2945650E-04
     +,   1.2346407E-04,   1.1710041E-04,   1.1044817E-04
     +,   1.0359165E-04,   9.6614298E-05,   8.9598499E-05
     +,   8.2620179E-05,   7.5751770E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wao_ww = Yx
      RETURN
      END

      DOUBLE PRECISION FUNCTION A1916_hnn_nwao_zz(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  2.9656267E-08,   2.9954862E-08
     +,   3.0258466E-08,   3.0567168E-08,   3.0881044E-08
     +,   3.1200187E-08,   3.1524678E-08,   3.1854608E-08
     +,   3.2190062E-08,   3.2531123E-08,   3.2877871E-08
     +,   3.3230396E-08,   3.3588780E-08,   3.3953107E-08
     +,   3.4323474E-08,   3.4699930E-08,   3.5082582E-08
     +,   3.5471501E-08,   3.5866766E-08,   3.6268467E-08
     +,   3.6676660E-08,   3.7091432E-08,   3.7512855E-08
     +,   3.7941010E-08,   3.8375966E-08,   3.8817781E-08
     +,   3.9266538E-08,   3.9722295E-08,   4.0185135E-08
     +,   4.0655095E-08,   4.1132250E-08,   4.1616648E-08
     +,   4.2108365E-08,   4.2607443E-08,   4.3113946E-08
     +,   4.3627907E-08,   4.4149381E-08,   4.4678409E-08
     +,   4.5215039E-08,   4.5759315E-08,   4.6311253E-08
     +,   4.6870902E-08,   4.7438284E-08,   4.8013426E-08
     +,   4.8596352E-08,   4.9187097E-08,   4.9785651E-08
     +,   5.0392028E-08,   5.1006264E-08,   5.1628330E-08
     +,   5.2258230E-08,   5.2895970E-08,   5.3541541E-08
     +,   5.4194924E-08,   5.4856113E-08,   5.5525074E-08
     +,   5.6201792E-08,   5.6886218E-08,   5.7578326E-08
     +,   5.8278086E-08,   5.8985421E-08,   5.9700298E-08
     +,   6.0422657E-08,   6.1152427E-08,   6.1889544E-08
     +,   6.2633951E-08,   6.3385563E-08,   6.4144267E-08
     +,   6.4909990E-08,   6.5682642E-08,   6.6462121E-08
     +,   6.7248287E-08,   6.8041054E-08,   6.8840286E-08
     +,   6.9645857E-08,   7.0457631E-08,   7.1275487E-08
     +,   7.2099247E-08,   7.2928771E-08,   7.3763900E-08
     +,   7.4604458E-08,   7.5450288E-08,   7.6301177E-08
     +,   7.7156969E-08,   7.8017436E-08,   7.8882415E-08
     +,   7.9751672E-08,   8.0625000E-08,   8.1502179E-08
     +,   8.2383032E-08,   8.3267217E-08,   8.4154543E-08
     +,   8.5044768E-08,   8.5937650E-08,   8.6832884E-08
     +,   8.7730243E-08,   8.8629484E-08,   8.9530232E-08
     +,   9.0432252E-08,   9.1335238E-08,   9.2238899E-08
     +,   9.3142930E-08,   9.4047010E-08,   9.4950835E-08
     +,   9.5854077E-08,   9.6756402E-08,   9.7657470E-08
     +,   9.8556953E-08,   9.9454496E-08,   1.0034976E-07
     +,   1.0124238E-07,   1.0213205E-07,   1.0301831E-07
     +,   1.0390083E-07,   1.0477925E-07,   1.0565319E-07
     +,   1.0652228E-07,   1.0738611E-07,   1.0824437E-07
     +,   1.0909657E-07,   1.0994235E-07,   1.1078134E-07
     +,   1.1161315E-07,   1.1243735E-07,   1.1325360E-07
     +,   1.1406144E-07,   1.1486052E-07,   1.1565045E-07
     +,   1.1643085E-07,   1.1720134E-07,   1.1796153E-07
     +,   1.1871115E-07,   1.1944979E-07,   1.2017716E-07
     +,   1.2089302E-07,   1.2159713E-07,   1.2228935E-07
     +,   1.2296958E-07,   1.2363785E-07,   1.2429433E-07
     +,   1.2493928E-07,   1.2557319E-07,   1.2619687E-07
     +,   1.2681133E-07,   1.2741802E-07,   1.2801885E-07
     +,   1.2861631E-07,   1.2921350E-07,   1.2981441E-07
     +,   1.3042389E-07,   1.3104795E-07,   1.3169395E-07
     +,   1.3237060E-07,   1.3308846E-07,   1.3385993E-07
     +,   1.3469956E-07,   1.3562429E-07,   1.3665360E-07
     +,   1.3780979E-07,   1.3911806E-07,   1.4060666E-07
     +,   1.4230703E-07,   1.4425346E-07,   1.4648353E-07
     +,   1.4903748E-07,   1.5195806E-07,   1.5529014E-07
     +,   1.5908030E-07,   1.6337616E-07,   1.6822628E-07
     +,   1.7367995E-07,   1.7978817E-07,   1.8660587E-07
     +,   1.9419761E-07,   2.0264616E-07,   2.1207285E-07
     +,   2.2266786E-07,   2.3474259E-07,   2.4881365E-07
     +,   2.6573420E-07,   2.8688635E-07,   3.1447914E-07
     +,   3.5194290E-07,   4.0450007E-07,   4.7989886E-07
     +,   5.8935126E-07,   7.4866762E-07,   9.7955342E-07
     +,   1.3109868E-06,   1.7805369E-06,   2.4354081E-06
     +,   3.3329336E-06,   4.5402494E-06,   6.1323517E-06
     +,   8.1896533E-06,   1.0791892E-05,   1.4012940E-05
     +,   1.7911008E-05,   2.2519878E-05,   2.7841161E-05
     +,   3.3833086E-05,   4.0408780E-05,   4.7430505E-05
     +,   5.4716085E-05,   6.2046405E-05,   6.9180096E-05
     +,   7.5872653E-05,   8.1898332E-05,   8.7072585E-05
     +,   9.1272042E-05,   9.4449271E-05,   9.6639953E-05
     +,   9.7961230E-05,   9.8600591E-05,   9.8796918E-05
     +,   9.8815144E-05,   9.8918674E-05,   9.9341814E-05
     +,   1.0026610E-04,   1.0180294E-04,   1.0398260E-04
     +,   1.0675280E-04,   1.0998180E-04,   1.1347169E-04
     +,   1.1697783E-04,   1.2023850E-04,   1.2301731E-04
     +,   1.2515692E-04,   1.2664277E-04,   1.2766616E-04
     +,   1.2867466E-04,   1.3039753E-04,   1.3384561E-04
     +,   1.4029576E-04,   1.5127649E-04,   1.6854638E-04
     +,   1.9400622E-04,   2.2942515E-04,   2.7590463E-04
     +,   3.3309063E-04,   3.9840429E-04,   4.6670192E-04
     +,   5.3072465E-04,   5.8251538E-04,   6.1557122E-04
     +,   6.2733341E-04,   6.2125758E-04,   6.0728600E-04
     +,   5.9943215E-04,   6.1021821E-04,   6.4409693E-04
     +,   6.9408020E-04,   7.4500655E-04,   7.8240252E-04
     +,   8.0090953E-04,   8.0570654E-04,   8.0571638E-04
     +,   8.0428412E-04,   7.9501804E-04,   7.6588831E-04
     +,   7.0789235E-04,   6.2166038E-04,   5.1795912E-04
     +,   4.1293970E-04,   3.2183339E-04,   2.5457153E-04
     +,   2.1445024E-04,   1.9917834E-04,   2.0296147E-04
     +,   2.1857575E-04,   2.3895412E-04,   2.5821402E-04
     +,   2.7221974E-04,   2.7877142E-04,   2.7748710E-04
     +,   2.6943366E-04,   2.5658839E-04,   2.4124754E-04
     +,   2.2550405E-04,   2.1088085E-04,   1.9817363E-04
     +,   1.8748325E-04,   1.7838342E-04,   1.7015799E-04
     +,   1.6203150E-04,   1.5335443E-04,   1.4371325E-04
     +,   1.3296478E-04,   1.2121088E-04,   1.0873391E-04
     +,   9.5918243E-05,   8.3175852E-05,   7.0888738E-05
     +,   5.9372465E-05,   4.8858787E-05,   3.9493931E-05
     +,   3.1345866E-05,   2.4416153E-05,   1.8655159E-05
     +,   1.3972627E-05,   1.0254046E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_nwao_zz = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wano_zz(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  5.1915350E-08,   5.3976070E-08
     +,   5.6235958E-08,   5.8715834E-08,   6.1438250E-08
     +,   6.4428100E-08,   6.7712463E-08,   7.1320827E-08
     +,   7.5285413E-08,   7.9640913E-08,   8.4425167E-08
     +,   8.9679070E-08,   9.5446786E-08,   1.0177582E-07
     +,   1.0871761E-07,   1.1632670E-07,   1.2466207E-07
     +,   1.3378660E-07,   1.4376734E-07,   1.5467572E-07
     +,   1.6658714E-07,   1.7958179E-07,   1.9374421E-07
     +,   2.0916355E-07,   2.2593380E-07,   2.4415218E-07
     +,   2.6392127E-07,   2.8534780E-07,   3.0854270E-07
     +,   3.3361937E-07,   3.6069616E-07,   3.8989424E-07
     +,   4.2133743E-07,   4.5515185E-07,   4.9146655E-07
     +,   5.3040941E-07,   5.7211082E-07,   6.1670102E-07
     +,   6.6430852E-07,   7.1506236E-07,   7.6908509E-07
     +,   8.2649825E-07,   8.8741979E-07,   9.5196003E-07
     +,   1.0202241E-06,   1.0923095E-06,   1.1683018E-06
     +,   1.2482814E-06,   1.3323131E-06,   1.4204492E-06
     +,   1.5127306E-06,   1.6091841E-06,   1.7098172E-06
     +,   1.8146211E-06,   1.9235727E-06,   2.0366238E-06
     +,   2.1537141E-06,   2.2747490E-06,   2.3996256E-06
     +,   2.5282179E-06,   2.6603657E-06,   2.7959009E-06
     +,   2.9346243E-06,   3.0763213E-06,   3.2207417E-06
     +,   3.3676338E-06,   3.5167106E-06,   3.6676706E-06
     +,   3.8201979E-06,   3.9739566E-06,   4.1286003E-06
     +,   4.2837701E-06,   4.4391040E-06,   4.5942293E-06
     +,   4.7487806E-06,   4.9023979E-06,   5.0547269E-06
     +,   5.2054302E-06,   5.3542017E-06,   5.5007567E-06
     +,   5.6448598E-06,   5.7863267E-06,   5.9250228E-06
     +,   6.0608950E-06,   6.1939800E-06,   6.3244092E-06
     +,   6.4524274E-06,   6.5784229E-06,   6.7029159E-06
     +,   6.8266127E-06,   6.9503858E-06,   7.0753340E-06
     +,   7.2027460E-06,   7.3341894E-06,   7.4714594E-06
     +,   7.6166348E-06,   7.7720742E-06,   7.9403899E-06
     +,   8.1245371E-06,   8.3276973E-06,   8.5533648E-06
     +,   8.8052630E-06,   9.0873555E-06,   9.4037496E-06
     +,   9.7587481E-06,   1.0156652E-05,   1.0601816E-05
     +,   1.1098478E-05,   1.1650726E-05,   1.2262340E-05
     +,   1.2936701E-05,   1.3676747E-05,   1.4484645E-05
     +,   1.5361917E-05,   1.6309159E-05,   1.7326020E-05
     +,   1.8411014E-05,   1.9561534E-05,   2.0773750E-05
     +,   2.2042403E-05,   2.3361092E-05,   2.4722112E-05
     +,   2.6116477E-05,   2.7534126E-05,   2.8963950E-05
     +,   3.0393920E-05,   3.1811378E-05,   3.3203265E-05
     +,   3.4556266E-05,   3.5857069E-05,   3.7092770E-05
     +,   3.8251150E-05,   3.9320727E-05,   4.0291357E-05
     +,   4.1154304E-05,   4.1902505E-05,   4.2530770E-05
     +,   4.3035889E-05,   4.3416778E-05,   4.3674543E-05
     +,   4.3812321E-05,   4.3835389E-05,   4.3750995E-05
     +,   4.3568089E-05,   4.3297190E-05,   4.2950203E-05
     +,   4.2540065E-05,   4.2080737E-05,   4.1586747E-05
     +,   4.1073308E-05,   4.0556195E-05,   4.0052109E-05
     +,   3.9578907E-05,   3.9156250E-05,   3.8806473E-05
     +,   3.8555692E-05,   3.8435548E-05,   3.8484395E-05
     +,   3.8749571E-05,   3.9289211E-05,   4.0173858E-05
     +,   4.1488067E-05,   4.3330678E-05,   4.5814963E-05
     +,   4.9066792E-05,   5.3221400E-05,   5.8417965E-05
     +,   6.4792497E-05,   7.2468196E-05,   8.1544313E-05
     +,   9.2083137E-05,   1.0409770E-04,   1.1753859E-04
     +,   1.3228550E-04,   1.4813895E-04,   1.6482381E-04
     +,   1.8199456E-04,   1.9925289E-04,   2.1617033E-04
     +,   2.3232092E-04,   2.4731524E-04,   2.6084180E-04
     +,   2.7269509E-04,   2.8280876E-04,   2.9126677E-04
     +,   2.9830768E-04,   3.0430974E-04,   3.0976234E-04
     +,   3.1522269E-04,   3.2126496E-04,   3.2842139E-04
     +,   3.3712434E-04,   3.4765142E-04,   3.6008065E-04
     +,   3.7426775E-04,   3.8983481E-04,   4.0620897E-04
     +,   4.2267432E-04,   4.3847019E-04,   4.5291960E-04
     +,   4.6554444E-04,   4.7618017E-04,   4.8504226E-04
     +,   4.9272104E-04,   5.0012197E-04,   5.0833024E-04
     +,   5.1844429E-04,   5.3139875E-04,   5.4780714E-04
     +,   5.6782836E-04,   5.9110048E-04,   6.1672908E-04
     +,   6.4336107E-04,   6.6935399E-04,   6.9301506E-04
     +,   7.1288517E-04,   7.2802586E-04,   7.3821802E-04
     +,   7.4406585E-04,   7.4697618E-04,   7.4900227E-04
     +,   7.5256376E-04,   7.6005404E-04,   7.7340240E-04
     +,   7.9368742E-04,   8.2095672E-04,   8.5431291E-04
     +,   8.9221244E-04,   9.3281892E-04,   9.7414484E-04
     +,   1.0140142E-03,   1.0499040E-03,   1.0789495E-03
     +,   1.0982656E-03,   1.1055133E-03,   1.0994624E-03
     +,   1.0802859E-03,   1.0495026E-03,   1.0096406E-03
     +,   9.6390554E-04,   9.1594149E-04,   8.6972950E-04
     +,   8.2944421E-04,   7.9911074E-04,   7.8200235E-04
     +,   7.7988458E-04,   7.9234445E-04,   8.1651768E-04
     +,   8.4740209E-04,   8.7872904E-04,   9.0417406E-04
     +,   9.1854809E-04,   9.1864920E-04,   9.0364373E-04
     +,   8.7498059E-04,   8.3595875E-04,   7.9109502E-04
     +,   7.4538571E-04,   7.0355495E-04,   6.6934631E-04
     +,   6.4501591E-04,   6.3110323E-04,   6.2652747E-04
     +,   6.2897115E-04,   6.3542632E-04,   6.4277084E-04
     +,   6.4826658E-04,   6.4991339E-04,   6.4665370E-04
     +,   6.3842128E-04,   6.2605710E-04,   6.1108137E-04
     +,   5.9535261E-04,   5.8066298E-04,   5.6833489E-04
     +,   5.5891962E-04,   5.5207225E-04,   5.4663105E-04
     +,   5.4089603E-04,   5.3301215E-04,   5.2137539E-04
     +,   5.0494843E-04,   4.8341989E-04,   4.5720485E-04
     +,   4.2728375E-04,   3.9497504E-04,   3.6168477E-04
     +,   3.2869726E-04,   2.9703663E-04,   2.6740925E-04
     +,   2.4020991E-04,   2.1557316E-04,   1.9344303E-04
     +,   1.7364355E-04,   1.5593776E-04,   1.4007007E-04
     +,   1.2579448E-04,   1.1288792E-04,   1.0116022E-04
     +,   9.0449037E-05,   8.0626531E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wano_zz = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wao_zz(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  4.4346757E-09,   4.5470925E-09
     +,   4.6618842E-09,   4.7790918E-09,   4.8987481E-09
     +,   5.0208961E-09,   5.1455746E-09,   5.2728235E-09
     +,   5.4026863E-09,   5.5351999E-09,   5.6704086E-09
     +,   5.8083560E-09,   5.9490879E-09,   6.0926499E-09
     +,   6.2390932E-09,   6.3884653E-09,   6.5408226E-09
     +,   6.6962236E-09,   6.8547314E-09,   7.0164248E-09
     +,   7.1813711E-09,   7.3496653E-09,   7.5214119E-09
     +,   7.6967259E-09,   7.8757534E-09,   8.0586524E-09
     +,   8.2456211E-09,   8.4368921E-09,   8.6327550E-09
     +,   8.8335392E-09,   9.0396606E-09,   9.2516164E-09
     +,   9.4700097E-09,   9.6955741E-09,   9.9291997E-09
     +,   1.0171947E-08,   1.0425120E-08,   1.0690282E-08
     +,   1.0969317E-08,   1.1264494E-08,   1.1578520E-08
     +,   1.1914650E-08,   1.2276764E-08,   1.2669481E-08
     +,   1.3098286E-08,   1.3569687E-08,   1.4091334E-08
     +,   1.4672278E-08,   1.5323133E-08,   1.6056305E-08
     +,   1.6886309E-08,   1.7830036E-08,   1.8907080E-08
     +,   2.0140119E-08,   2.1555310E-08,   2.3182730E-08
     +,   2.5056904E-08,   2.7217149E-08,   2.9708399E-08
     +,   3.2581649E-08,   3.5894455E-08,   3.9711885E-08
     +,   4.4107040E-08,   4.9161812E-08,   5.4967622E-08
     +,   6.1626082E-08,   6.9250135E-08,   7.7963840E-08
     +,   8.7904269E-08,   9.9221495E-08,   1.1207967E-07
     +,   1.2665626E-07,   1.4314456E-07,   1.6175252E-07
     +,   1.8270360E-07,   2.0623642E-07,   2.3260577E-07
     +,   2.6207940E-07,   2.9494140E-07,   3.3148871E-07
     +,   3.7203108E-07,   4.1689026E-07,   4.6639462E-07
     +,   5.2088370E-07,   5.8070032E-07,   6.4619110E-07
     +,   7.1770188E-07,   7.9557577E-07,   8.8014895E-07
     +,   9.7175007E-07,   1.0706821E-06,   1.1772404E-06
     +,   1.2916934E-06,   1.4142812E-06,   1.5452123E-06
     +,   1.6846575E-06,   1.8327528E-06,   1.9895695E-06
     +,   2.1551471E-06,   2.3294663E-06,   2.5124500E-06
     +,   2.7039637E-06,   2.9038072E-06,   3.1117193E-06
     +,   3.3273739E-06,   3.5503783E-06,   3.7802793E-06
     +,   4.0165573E-06,   4.2586357E-06,   4.5058800E-06
     +,   4.7576036E-06,   5.0130834E-06,   5.2715209E-06
     +,   5.5321184E-06,   5.7940374E-06,   6.0564207E-06
     +,   6.3184016E-06,   6.5791091E-06,   6.8376953E-06
     +,   7.0932874E-06,   7.3450774E-06,   7.5922790E-06
     +,   7.8341500E-06,   8.0699974E-06,   8.2991892E-06
     +,   8.5211541E-06,   8.7354010E-06,   8.9415071E-06
     +,   9.1391312E-06,   9.3280196E-06,   9.5079986E-06
     +,   9.6789890E-06,   9.8409746E-06,   9.9940435E-06
     +,   1.0138357E-05,   1.0274150E-05,   1.0401733E-05
     +,   1.0521481E-05,   1.0633828E-05,   1.0739266E-05
     +,   1.0838317E-05,   1.0931559E-05,   1.1019592E-05
     +,   1.1103048E-05,   1.1182551E-05,   1.1258759E-05
     +,   1.1332314E-05,   1.1403848E-05,   1.1473988E-05
     +,   1.1543338E-05,   1.1612465E-05,   1.1681920E-05
     +,   1.1752197E-05,   1.1823775E-05,   1.1897071E-05
     +,   1.1972472E-05,   1.2050318E-05,   1.2130924E-05
     +,   1.2214573E-05,   1.2301529E-05,   1.2392075E-05
     +,   1.2486524E-05,   1.2585247E-05,   1.2688738E-05
     +,   1.2797661E-05,   1.2912911E-05,   1.3035722E-05
     +,   1.3167743E-05,   1.3311160E-05,   1.3468808E-05
     +,   1.3644340E-05,   1.3842322E-05,   1.4068400E-05
     +,   1.4329447E-05,   1.4633629E-05,   1.4990593E-05
     +,   1.5411471E-05,   1.5908987E-05,   1.6497457E-05
     +,   1.7192842E-05,   1.8012535E-05,   1.8975730E-05
     +,   2.0102860E-05,   2.1416001E-05,   2.2938593E-05
     +,   2.4695531E-05,   2.6713102E-05,   2.9019035E-05
     +,   3.1642609E-05,   3.4614790E-05,   3.7968694E-05
     +,   4.1740292E-05,   4.5969908E-05,   5.0703035E-05
     +,   5.5995395E-05,   6.1912979E-05,   6.8539601E-05
     +,   7.5976997E-05,   8.4348459E-05,   9.3801689E-05
     +,   1.0450033E-04,   1.1662480E-04,   1.3035466E-04
     +,   1.4586447E-04,   1.6331025E-04,   1.8282450E-04
     +,   2.0451414E-04,   2.2846379E-04,   2.5473753E-04
     +,   2.8337084E-04,   3.1434829E-04,   3.4756836E-04
     +,   3.8280716E-04,   4.1972220E-04,   4.5792060E-04
     +,   4.9711292E-04,   5.3734577E-04,   5.7915004E-04
     +,   6.2354538E-04,   6.7169714E-04,   7.2425569E-04
     +,   7.8061619E-04,   8.3843432E-04,   8.9399138E-04
     +,   9.4354199E-04,   9.8542648E-04,   1.0220680E-03
     +,   1.0607071E-03,   1.1121129E-03,   1.1873570E-03
     +,   1.2935702E-03,   1.4297798E-03,   1.5839747E-03
     +,   1.7335012E-03,   1.8520453E-03,   1.9239538E-03
     +,   1.9584391E-03,   1.9903758E-03,   2.0621351E-03
     +,   2.1981969E-03,   2.3910422E-03,   2.6056080E-03
     +,   2.7965815E-03,   2.9295022E-03,   2.9957539E-03
     +,   3.0118225E-03,   3.0026454E-03,   2.9831512E-03
     +,   2.9529266E-03,   2.9031697E-03,   2.8240161E-03
     +,   2.7070050E-03,   2.5475847E-03,   2.3499331E-03
     +,   2.1295385E-03,   1.9107199E-03,   1.7214840E-03
     +,   1.5884585E-03,   1.5316627E-03,   1.5584779E-03
     +,   1.6593907E-03,   1.8088870E-03,   1.9717615E-03
     +,   2.1108100E-03,   2.1928267E-03,   2.1939694E-03
     +,   2.1064628E-03,   1.9438389E-03,   1.7385596E-03
     +,   1.5305768E-03,   1.3527760E-03,   1.2218558E-03
     +,   1.1380677E-03,   1.0909862E-03,   1.0662735E-03
     +,   1.0503626E-03,   1.0326884E-03,   1.0062788E-03
     +,   9.6746063E-04,   9.1521954E-04,   8.5055403E-04
     +,   7.7603548E-04,   6.9540931E-04,   6.1310496E-04
     +,   5.3351285E-04,   4.6024792E-04,   3.9559329E-04
     +,   3.4031848E-04,   2.9388987E-04,   2.5493413E-04
     +,   2.2176754E-04,   1.9282987E-04,   1.6694187E-04
     +,   1.4337634E-04,   1.2180021E-04,   1.0214653E-04
     +,   8.4477229E-05,   6.8873007E-05,   5.5367786E-05
     +,   4.3913271E-05,   3.4388369E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wao_zz = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_nwao_fus_107(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   2.4943261E-38
     +,   8.5199843E-38,   2.8814770E-37,   9.6494641E-37
     +,   3.1997087E-36,   1.0505857E-35,   3.4156281E-35
     +,   1.0995852E-34,   3.5053462E-34,   1.1064397E-33
     +,   3.4582012E-33,   1.0702695E-32,   3.2799140E-32
     +,   9.9530470E-32,   2.9907388E-31,   8.8987198E-31
     +,   2.6218297E-30,   7.6491580E-30,   2.2098083E-29
     +,   6.3215749E-29,   1.7907428E-28,   5.0231166E-28
     +,   1.3952427E-27,   3.8378245E-27,   1.0452920E-26
     +,   2.8192163E-26,   7.5294123E-26,   1.9912951E-25
     +,   5.2149657E-25,   1.3524131E-24,   3.4732145E-24
     +,   8.8324511E-24,   2.2242017E-23,   5.5464596E-23
     +,   1.3696362E-22,   3.3492199E-22,   8.1101419E-22
     +,   1.9447620E-21,   4.6179797E-21,   1.0859020E-20
     +,   2.5286037E-20,   5.8307186E-20,   1.3314241E-19
     +,   3.0107808E-19,   6.7418503E-19,   1.4949732E-18
     +,   3.2827833E-18,   7.1384876E-18,   1.5371800E-17
     +,   3.2779275E-17,   6.9219559E-17,   1.4475407E-16
     +,   2.9975998E-16,   6.1471743E-16,   1.2483448E-15
     +,   2.5104515E-15,   4.9995256E-15,   9.8597532E-15
     +,   1.9255940E-14,   3.7241267E-14,   7.1326036E-14
     +,   1.3528061E-13,   2.5409040E-13,   4.7262986E-13
     +,   8.7058111E-13,   1.5880625E-12,   2.8687849E-12
     +,   5.1321807E-12,   9.0924620E-12,   1.5952888E-11
     +,   2.7718957E-11,   4.7697634E-11,   8.1283313E-11
     +,   1.3718389E-10,   2.2928916E-10,   3.7953848E-10
     +,   6.2218819E-10,   1.0101446E-09,   1.6242145E-09
     +,   2.5864455E-09,   4.0791037E-09,   6.3713106E-09
     +,   9.8559116E-09,   1.5099738E-08,   2.2911163E-08
     +,   3.4430023E-08,   5.1241646E-08,   7.5528654E-08
     +,   1.1025573E-07,   1.5940023E-07,   2.2822971E-07
     +,   3.2363351E-07,   4.5447297E-07,   6.3205903E-07
     +,   8.7051512E-07,   1.1873111E-06,   1.6036697E-06
     +,   2.1449648E-06,   2.8410079E-06,   3.7261823E-06
     +,   4.8393545E-06,   6.2235185E-06,   7.9250913E-06
     +,   9.9928520E-06,   1.2476597E-05,   1.5424699E-05
     +,   1.8883384E-05,   2.2892358E-05,   2.7485077E-05
     +,   3.2684326E-05,   3.8501668E-05,   4.4938817E-05
     +,   5.1984498E-05,   5.9621350E-05,   6.7824956E-05
     +,   7.6572709E-05,   8.5848558E-05,   9.5650335E-05
     +,   1.0599659E-04,   1.1693233E-04,   1.2853270E-04
     +,   1.4090409E-04,   1.5418191E-04,   1.6852553E-04
     +,   1.8411057E-04,   2.0111998E-04,   2.1973587E-04
     +,   2.4012831E-04,   2.6246195E-04,   2.8688647E-04
     +,   3.1355800E-04,   3.4265820E-04,   3.7442101E-04
     +,   4.0919185E-04,   4.4745480E-04,   4.8988988E-04
     +,   5.3738116E-04,   5.9098110E-04,   6.5179967E-04
     +,   7.2079425E-04,   7.9846650E-04,   8.8449073E-04
     +,   9.7734260E-04,   1.0740225E-03,   1.1699846E-03
     +,   1.2593654E-03,   1.3355514E-03,   1.3920510E-03
     +,   1.4235423E-03,   1.4268957E-03,   1.4019660E-03
     +,   1.3519309E-03,   1.2831012E-03,   1.2042027E-03
     +,   1.1252939E-03,   1.0565212E-03,   1.0070407E-03
     +,   9.8427385E-04,   9.9357148E-04,   1.0381381E-03
     +,   1.1189117E-03,   1.2341253E-03,   1.3785275E-03
     +,   1.5426681E-03,   1.7130143E-03,   1.8736216E-03
     +,   2.0094935E-03,   2.1107907E-03,   2.1762499E-03
     +,   2.2140830E-03,   2.2395377E-03,   2.2698052E-03
     +,   2.3181729E-03,   2.3895765E-03,   2.4789311E-03
     +,   2.5723772E-03,   2.6508356E-03,   2.6948489E-03
     +,   2.6897674E-03,   2.6300277E-03,   2.5210700E-03
     +,   2.3778565E-03,   2.2202129E-03,   2.0668043E-03
     +,   1.9301572E-03,   1.8145650E-03,   1.7171092E-03
     +,   1.6306496E-03,   1.5471523E-03,   1.4601365E-03
     +,   1.3658419E-03,   1.2632770E-03,   1.1536947E-03
     +,   1.0398487E-03,   9.2526787E-04,   8.1365881E-04
     +,   7.0836500E-04,   6.1199861E-04,   5.2619341E-04
     +,   4.5153950E-04,   3.8769399E-04,   3.3362376E-04
     +,   2.8791185E-04,   2.4904576E-04,   2.1563561E-04
     +,   1.8653757E-04,   1.6089146E-04,   1.3809674E-04
     +,   1.1775730E-04,   9.9617988E-05,   8.3512787E-05
     +,   6.9314272E-05,   5.6915713E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_nwao_fus_107 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_nwao_hz_107(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   2.4775758E-38
     +,   6.6120604E-38,   1.7504814E-37,   4.6049914E-37
     +,   1.2038091E-36,   3.1272132E-36,   8.0726881E-36
     +,   2.0707557E-35,   5.2784334E-35,   1.3370171E-34
     +,   3.3653861E-34,   8.4176857E-34,   2.0922516E-33
     +,   5.1678390E-33,   1.2683968E-32,   3.0936128E-32
     +,   7.4980847E-32,   1.8058798E-31,   4.3221028E-31
     +,   1.0279330E-30,   2.4294156E-30,   5.7056483E-30
     +,   1.3316087E-29,   3.0883439E-29,   7.1175612E-29
     +,   1.6300859E-28,   3.7098606E-28,   8.3904419E-28
     +,   1.8857098E-27,   4.2114996E-27,   9.3470118E-27
     +,   2.0614963E-26,   4.5182301E-26,   9.8409301E-26
     +,   2.1299710E-25,   4.5813156E-25,   9.7923128E-25
     +,   2.0799828E-24,   4.3906101E-24,   9.2100828E-24
     +,   1.9199294E-23,   3.9773559E-23,   8.1881528E-23
     +,   1.6752036E-22,   3.4059566E-22,   6.8817464E-22
     +,   1.3818605E-21,   2.7574593E-21,   5.4682471E-21
     +,   1.0776710E-20,   2.1106752E-20,   4.1082232E-20
     +,   7.9467377E-20,   1.5277051E-19,   2.9186533E-19
     +,   5.5415512E-19,   1.0456560E-18,   1.9609094E-18
     +,   3.6545758E-18,   6.7691192E-18,   1.2460665E-17
     +,   2.2796548E-17,   4.1449293E-17,   7.4900801E-17
     +,   1.3451810E-16,   2.4010446E-16,   4.2593954E-16
     +,   7.5097549E-16,   1.3159696E-15,   2.2918704E-15
     +,   3.9670674E-15,   6.8247460E-15,   1.1669265E-14
     +,   1.9830932E-14,   3.3495454E-14,   5.6232105E-14
     +,   9.3825148E-14,   1.5559777E-13,   2.5647084E-13
     +,   4.2016987E-13,   6.8417120E-13,   1.1072874E-12
     +,   1.7811927E-12,   2.8478671E-12,   4.5257058E-12
     +,   7.1484637E-12,   1.1222749E-11,   1.7512413E-11
     +,   2.7162050E-11,   4.1872880E-11,   6.4159976E-11
     +,   9.7714108E-11,   1.4791504E-10,   2.2255035E-10
     +,   3.3281680E-10,   4.9470050E-10,   7.3088074E-10
     +,   1.0732495E-09,   1.5664330E-09,   2.2723665E-09
     +,   3.2764167E-09,   4.6953845E-09,   6.6879591E-09
     +,   9.4681116E-09,   1.3322270E-08,   1.8630979E-08
     +,   2.5895998E-08,   3.5773926E-08,   4.9117961E-08
     +,   6.7025127E-08,   9.0899547E-08,   1.2252052E-07
     +,   1.6412508E-07,   2.1850256E-07,   2.8910074E-07
     +,   3.8014491E-07,   4.9676589E-07,   6.4513830E-07
     +,   8.3263217E-07,   1.0679182E-06,   1.3611574E-06
     +,   1.7240884E-06,   2.1701399E-06,   2.7144904E-06
     +,   3.3740976E-06,   4.1676572E-06,   5.1154993E-06
     +,   6.2393983E-06,   7.5622975E-06,   9.1079228E-06
     +,   1.0900397E-05,   1.2963303E-05,   1.5319500E-05
     +,   1.7990040E-05,   2.0993424E-05,   2.4344748E-05
     +,   2.8055038E-05,   3.2129581E-05,   3.6569207E-05
     +,   4.1367202E-05,   4.6511072E-05,   5.1981511E-05
     +,   5.7752899E-05,   6.3793865E-05,   7.0068199E-05
     +,   7.6536169E-05,   8.3156025E-05,   8.9885863E-05
     +,   9.6685442E-05,   1.0351851E-04,   1.1035304E-04
     +,   1.1716615E-04,   1.2394066E-04,   1.3067041E-04
     +,   1.3735592E-04,   1.4400529E-04,   1.5063415E-04
     +,   1.5725894E-04,   1.6389866E-04,   1.7056636E-04
     +,   1.7726884E-04,   1.8400107E-04,   1.9074319E-04
     +,   1.9745782E-04,   2.0408859E-04,   2.1056013E-04
     +,   2.1678001E-04,   2.2264200E-04,   2.2803179E-04
     +,   2.3283366E-04,   2.3693916E-04,   2.4025593E-04
     +,   2.4271653E-04,   2.4428824E-04,   2.4497905E-04
     +,   2.4484380E-04,   2.4398662E-04,   2.4256109E-04
     +,   2.4076663E-04,   2.3884313E-04,   2.3706206E-04
     +,   2.3571675E-04,   2.3511150E-04,   2.3555045E-04
     +,   2.3732768E-04,   2.4071835E-04,   2.4597169E-04
     +,   2.5330589E-04,   2.6290482E-04,   2.7491624E-04
     +,   2.8945095E-04,   3.0658321E-04,   3.2635027E-04
     +,   3.4875341E-04,   3.7375058E-04,   4.0125701E-04
     +,   4.3113035E-04,   4.6315542E-04,   4.9702468E-04
     +,   5.3230627E-04,   5.6842994E-04,   6.0466642E-04
     +,   6.4013281E-04,   6.7382463E-04,   7.0468697E-04
     +,   7.3172373E-04,   7.5414369E-04,   7.7152223E-04
     +,   7.8395382E-04,   7.9215772E-04,   7.9750142E-04
     +,   8.0191513E-04,   8.0769276E-04,   8.1719633E-04
     +,   8.3251548E-04,   8.5514144E-04,   8.8573218E-04
     +,   9.2400814E-04,   9.6880435E-04,   1.0182553E-03
     +,   1.0700504E-03,   1.1217206E-03,   1.1708563E-03
     +,   1.2152488E-03,   1.2529423E-03,   1.2822282E-03
     +,   1.3016202E-03,   1.3098504E-03,   1.3059122E-03
     +,   1.2891421E-03,   1.2593236E-03,   1.2167749E-03
     +,   1.1623928E-03,   1.0976283E-03,   1.0243914E-03
     +,   9.4491709E-04,   8.6156459E-04,   7.7665260E-04
     +,   6.9230108E-04,   6.1031978E-04,   5.3216639E-04
     +,   4.5891476E-04,   3.9130013E-04,   3.2976421E-04
     +,   2.7451219E-04,   2.2556462E-04,   1.8279756E-04
     +,   1.4597191E-04,   1.1475343E-04,   8.8728280E-05
     +,   6.7418405E-05,   5.0299259E-05,   3.6820591E-05
     +,   2.6428996E-05,   1.8589797E-05,   1.2807939E-05
     +,   8.6393839E-06,   5.7036782E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_nwao_hz_107 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wano_fus_107(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  3.5073683E-06,   3.6365632E-06
     +,   3.7697587E-06,   3.9070587E-06,   4.0485597E-06
     +,   4.1943717E-06,   4.3446043E-06,   4.4993735E-06
     +,   4.6587993E-06,   4.8230004E-06,   4.9921077E-06
     +,   5.1662582E-06,   5.3455933E-06,   5.5302612E-06
     +,   5.7204247E-06,   5.9162398E-06,   6.1178876E-06
     +,   6.3255543E-06,   6.5394388E-06,   6.7597571E-06
     +,   6.9867278E-06,   7.2205949E-06,   7.4616196E-06
     +,   7.7100813E-06,   7.9662823E-06,   8.2305360E-06
     +,   8.5031961E-06,   8.7846383E-06,   9.0752701E-06
     +,   9.3755198E-06,   9.6858648E-06,   1.0006819E-05
     +,   1.0338931E-05,   1.0682802E-05,   1.1039084E-05
     +,   1.1408457E-05,   1.1791686E-05,   1.2189584E-05
     +,   1.2603027E-05,   1.3032968E-05,   1.3480408E-05
     +,   1.3946446E-05,   1.4432258E-05,   1.4939102E-05
     +,   1.5468320E-05,   1.6021368E-05,   1.6599748E-05
     +,   1.7205110E-05,   1.7839195E-05,   1.8503823E-05
     +,   1.9200939E-05,   1.9932599E-05,   2.0700958E-05
     +,   2.1508278E-05,   2.2356933E-05,   2.3249388E-05
     +,   2.4188243E-05,   2.5176118E-05,   2.6215792E-05
     +,   2.7310134E-05,   2.8461998E-05,   2.9674395E-05
     +,   3.0950356E-05,   3.2292952E-05,   3.3705270E-05
     +,   3.5190442E-05,   3.6751582E-05,   3.8391718E-05
     +,   4.0113900E-05,   4.1921110E-05,   4.3816282E-05
     +,   4.5802088E-05,   4.7881214E-05,   5.0056151E-05
     +,   5.2329189E-05,   5.4702432E-05,   5.7177807E-05
     +,   5.9756814E-05,   6.2440820E-05,   6.5230881E-05
     +,   6.8127694E-05,   7.1131697E-05,   7.4242787E-05
     +,   7.7460623E-05,   8.0784477E-05,   8.4213170E-05
     +,   8.7745124E-05,   9.1378417E-05,   9.5110576E-05
     +,   9.8939046E-05,   1.0286021E-04,   1.0687063E-04
     +,   1.1096637E-04,   1.1514311E-04,   1.1939617E-04
     +,   1.2372065E-04,   1.2811153E-04,   1.3256307E-04
     +,   1.3707002E-04,   1.4162679E-04,   1.4622792E-04
     +,   1.5086796E-04,   1.5554183E-04,   1.6024476E-04
     +,   1.6497246E-04,   1.6972140E-04,   1.7448881E-04
     +,   1.7927322E-04,   1.8407422E-04,   1.8889316E-04
     +,   1.9373320E-04,   1.9859984E-04,   2.0350056E-04
     +,   2.0844630E-04,   2.1345126E-04,   2.1853299E-04
     +,   2.2371364E-04,   2.2901940E-04,   2.3448232E-04
     +,   2.4013878E-04,   2.4603205E-04,   2.5221126E-04
     +,   2.5873297E-04,   2.6566017E-04,   2.7306384E-04
     +,   2.8102248E-04,   2.8962243E-04,   2.9895804E-04
     +,   3.0913114E-04,   3.2025072E-04,   3.3243251E-04
     +,   3.4579835E-04,   3.6047242E-04,   3.7658279E-04
     +,   3.9425757E-04,   4.1362210E-04,   4.3479571E-04
     +,   4.5788882E-04,   4.8299794E-04,   5.1020412E-04
     +,   5.3956296E-04,   5.7110790E-04,   6.0484192E-04
     +,   6.4073596E-04,   6.7872653E-04,   7.1871397E-04
     +,   7.6056429E-04,   8.0410944E-04,   8.4915140E-04
     +,   8.9546607E-04,   9.4281125E-04,   9.9093642E-04
     +,   1.0395842E-03,   1.0885152E-03,   1.1375131E-03
     +,   1.1864032E-03,   1.2350690E-03,   1.2834703E-03
     +,   1.3316667E-03,   1.3798358E-03,   1.4282922E-03
     +,   1.4775110E-03,   1.5281274E-03,   1.5809627E-03
     +,   1.6370110E-03,   1.6974331E-03,   1.7635329E-03
     +,   1.8367291E-03,   1.9185208E-03,   2.0104276E-03
     +,   2.1139455E-03,   2.2304892E-03,   2.3613202E-03
     +,   2.5074822E-03,   2.6696853E-03,   2.8482459E-03
     +,   3.0429289E-03,   3.2528420E-03,   3.4762917E-03
     +,   3.7107242E-03,   3.9526373E-03,   4.1977665E-03
     +,   4.4411714E-03,   4.6776906E-03,   4.9024033E-03
     +,   5.1112142E-03,   5.3014336E-03,   5.4722582E-03
     +,   5.6249574E-03,   5.7627144E-03,   5.8901212E-03
     +,   6.0122903E-03,   6.1338404E-03,   6.2579550E-03
     +,   6.3858749E-03,   6.5167397E-03,   6.6481126E-03
     +,   6.7768199E-03,   6.8997531E-03,   7.0147021E-03
     +,   7.1203955E-03,   7.2166068E-03,   7.3037213E-03
     +,   7.3827673E-03,   7.4556964E-03,   7.5260852E-03
     +,   7.5999117E-03,   7.6857586E-03,   7.7941399E-03
     +,   7.9356283E-03,   8.1182243E-03,   8.3445711E-03
     +,   8.6101601E-03,   8.9029465E-03,   9.2048375E-03
     +,   9.4945850E-03,   9.7514512E-03,   9.9583939E-03
     +,   1.0104579E-02,   1.0186282E-02,   1.0206410E-02
     +,   1.0172878E-02,   1.0096357E-02,   9.9879093E-03
     +,   9.8571777E-03,   9.7113568E-03,   9.5550278E-03
     +,   9.3908263E-03,   9.2205545E-03,   9.0463860E-03
     +,   8.8717462E-03,   8.7016672E-03,   8.5424269E-03
     +,   8.4004570E-03,   8.2809487E-03,   8.1862491E-03
     +,   8.1148567E-03,   8.0612283E-03,   8.0167660E-03
     +,   7.9718940E-03,   7.9188161E-03,   7.8538759E-03
     +,   7.7790008E-03,   7.7013122E-03,   7.6312055E-03
     +,   7.5793555E-03,   7.5537334E-03,   7.5575458E-03
     +,   7.5885761E-03,   7.6400037E-03,   7.7020372E-03
     +,   7.7637946E-03,   7.8147519E-03,   7.8456802E-03
     +,   7.8491531E-03,   7.8198947E-03,   7.7552404E-03
     +,   7.6556448E-03,   7.5250249E-03,   7.3706601E-03
     +,   7.2023794E-03,   7.0311958E-03,   6.8675126E-03
     +,   6.7195343E-03,   6.5921596E-03,   6.4867013E-03
     +,   6.4015021E-03,   6.3330033E-03,   6.2770671E-03
     +,   6.2299962E-03,   6.1890236E-03,   6.1523020E-03
     +,   6.1183642E-03,   6.0854848E-03,   6.0511273E-03
     +,   6.0118334E-03,   5.9634512E-03,   5.9017735E-03
     +,   5.8233123E-03,   5.7259859E-03,   5.6094630E-03
     +,   5.4751444E-03,   5.3257374E-03,   5.1645711E-03
     +,   4.9948446E-03,   4.8189671E-03,   4.6382169E-03
     +,   4.4526267E-03,   4.2612478E-03,   4.0625501E-03
     +,   3.8549646E-03,   3.6373856E-03,   3.4095531E-03
     +,   3.1722756E-03,   2.9274605E-03,   2.6779720E-03
     +,   2.4273719E-03,   2.1795603E-03,   1.9384861E-03
     +,   1.7077043E-03,   1.4902839E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wano_fus_107 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wano_hz_107(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  3.4397799E-06,   3.5070602E-06
     +,   3.5743988E-06,   3.6417503E-06,   3.7090645E-06
     +,   3.7762948E-06,   3.8433914E-06,   3.9103047E-06
     +,   3.9769852E-06,   4.0433788E-06,   4.1094349E-06
     +,   4.1751014E-06,   4.2403258E-06,   4.3050536E-06
     +,   4.3692344E-06,   4.4328112E-06,   4.4957314E-06
     +,   4.5579409E-06,   4.6193863E-06,   4.6800151E-06
     +,   4.7397707E-06,   4.7986009E-06,   4.8564530E-06
     +,   4.9132741E-06,   4.9690129E-06,   5.0236158E-06
     +,   5.0770318E-06,   5.1292118E-06,   5.1801067E-06
     +,   5.2296659E-06,   5.2778423E-06,   5.3245890E-06
     +,   5.3698609E-06,   5.4136135E-06,   5.4558031E-06
     +,   5.4963875E-06,   5.5353266E-06,   5.5725814E-06
     +,   5.6081135E-06,   5.6418880E-06,   5.6738686E-06
     +,   5.7040243E-06,   5.7323241E-06,   5.7587372E-06
     +,   5.7832381E-06,   5.8058013E-06,   5.8264018E-06
     +,   5.8450191E-06,   5.8616351E-06,   5.8762298E-06
     +,   5.8887895E-06,   5.8992996E-06,   5.9077511E-06
     +,   5.9141339E-06,   5.9184417E-06,   5.9206691E-06
     +,   5.9208146E-06,   5.9188778E-06,   5.9148615E-06
     +,   5.9087683E-06,   5.9006056E-06,   5.8903820E-06
     +,   5.8781088E-06,   5.8637975E-06,   5.8474648E-06
     +,   5.8291271E-06,   5.8088026E-06,   5.7865154E-06
     +,   5.7622860E-06,   5.7361412E-06,   5.7081079E-06
     +,   5.6782151E-06,   5.6464946E-06,   5.6129802E-06
     +,   5.5777055E-06,   5.5407081E-06,   5.5020255E-06
     +,   5.4617003E-06,   5.4197749E-06,   5.3762933E-06
     +,   5.3313033E-06,   5.2848523E-06,   5.2369942E-06
     +,   5.1877832E-06,   5.1372745E-06,   5.0855310E-06
     +,   5.0326171E-06,   4.9786026E-06,   4.9235623E-06
     +,   4.8675738E-06,   4.8107318E-06,   4.7531316E-06
     +,   4.6948808E-06,   4.6361001E-06,   4.5769257E-06
     +,   4.5175107E-06,   4.4580270E-06,   4.3986779E-06
     +,   4.3396908E-06,   4.2813272E-06,   4.2238903E-06
     +,   4.1677308E-06,   4.1132535E-06,   4.0609266E-06
     +,   4.0112905E-06,   3.9649744E-06,   3.9227034E-06
     +,   3.8853109E-06,   3.8537610E-06,   3.8291619E-06
     +,   3.8127880E-06,   3.8060946E-06,   3.8107510E-06
     +,   3.8286585E-06,   3.8619846E-06,   3.9131883E-06
     +,   3.9850588E-06,   4.0807481E-06,   4.2038205E-06
     +,   4.3582700E-06,   4.5485986E-06,   4.7798467E-06
     +,   5.0576537E-06,   5.3883114E-06,   5.7788229E-06
     +,   6.2369713E-06,   6.7713859E-06,   7.3916008E-06
     +,   8.1081425E-06,   8.9325895E-06,   9.8776400E-06
     +,   1.0957237E-05,   1.2186438E-05,   1.3581742E-05
     +,   1.5160962E-05,   1.6943310E-05,   1.8949384E-05
     +,   2.1201204E-05,   2.3722159E-05,   2.6537095E-05
     +,   2.9671713E-05,   3.3153203E-05,   3.7009617E-05
     +,   4.1269755E-05,   4.5963010E-05,   5.1119005E-05
     +,   5.6767305E-05,   6.2937143E-05,   6.9656911E-05
     +,   7.6953846E-05,   8.4853564E-05,   9.3380091E-05
     +,   1.0255380E-04,   1.1239344E-04,   1.2291445E-04
     +,   1.3412916E-04,   1.4604670E-04,   1.5867357E-04
     +,   1.7201429E-04,   1.8607208E-04,   2.0085064E-04
     +,   2.1635648E-04,   2.3259840E-04,   2.4959448E-04
     +,   2.6737250E-04,   2.8597354E-04,   3.0545547E-04
     +,   3.2589596E-04,   3.4739525E-04,   3.7007729E-04
     +,   3.9409116E-04,   4.1960907E-04,   4.4682389E-04
     +,   4.7594603E-04,   5.0718960E-04,   5.4077158E-04
     +,   5.7689380E-04,   6.1572884E-04,   6.5740524E-04
     +,   7.0199039E-04,   7.4946252E-04,   7.9971628E-04
     +,   8.5252023E-04,   9.0753054E-04,   9.6427620E-04
     +,   1.0221727E-03,   1.0805386E-03,   1.1386275E-03
     +,   1.1956743E-03,   1.2509467E-03,   1.3038111E-03
     +,   1.3537918E-03,   1.4006317E-03,   1.4443204E-03
     +,   1.4851431E-03,   1.5236366E-03,   1.5605870E-03
     +,   1.5969350E-03,   1.6336998E-03,   1.6718812E-03
     +,   1.7123248E-03,   1.7556531E-03,   1.8021524E-03
     +,   1.8517453E-03,   1.9039607E-03,   1.9579649E-03
     +,   2.0126218E-03,   2.0666090E-03,   2.1185430E-03
     +,   2.1671541E-03,   2.2114501E-03,   2.2508895E-03
     +,   2.2855136E-03,   2.3160193E-03,   2.3437799E-03
     +,   2.3707531E-03,   2.3993212E-03,   2.4320337E-03
     +,   2.4713075E-03,   2.5190776E-03,   2.5764548E-03
     +,   2.6434576E-03,   2.7187704E-03,   2.7996721E-03
     +,   2.8820946E-03,   2.9608514E-03,   3.0300415E-03
     +,   3.0836200E-03,   3.1160519E-03,   3.1230228E-03
     +,   3.1020790E-03,   3.0531120E-03,   2.9785894E-03
     +,   2.8835204E-03,   2.7750793E-03,   2.6619919E-03
     +,   2.5537240E-03,   2.4596110E-03,   2.3879821E-03
     +,   2.3454637E-03,   2.3364422E-03,   2.3627521E-03
     +,   2.4235586E-03,   2.5154289E-03,   2.6325469E-03
     +,   2.7670895E-03,   2.9097542E-03,   3.0504970E-03
     +,   3.1794293E-03,   3.2878616E-03,   3.3693262E-03
     +,   3.4204465E-03,   3.4414027E-03,   3.4358946E-03
     +,   3.4105056E-03,   3.3735996E-03,   3.3339099E-03
     +,   3.2991534E-03,   3.2749469E-03,   3.2642127E-03
     +,   3.2671923E-03,   3.2819868E-03,   3.3053970E-03
     +,   3.3339071E-03,   3.3644929E-03,   3.3951658E-03
     +,   3.4251374E-03,   3.4546740E-03,   3.4847208E-03
     +,   3.5164412E-03,   3.5507684E-03,   3.5880653E-03
     +,   3.6279466E-03,   3.6692079E-03,   3.7099251E-03
     +,   3.7476553E-03,   3.7797466E-03,   3.8037193E-03
     +,   3.8176756E-03,   3.8206372E-03,   3.8126823E-03
     +,   3.7948671E-03,   3.7688331E-03,   3.7362513E-03
     +,   3.6981520E-03,   3.6544076E-03,   3.6034517E-03
     +,   3.5423487E-03,   3.4672183E-03,   3.3739049E-03
     +,   3.2587396E-03,   3.1192487E-03,   2.9546779E-03
     +,   2.7662322E-03,   2.5570404E-03,   2.3318566E-03
     +,   2.0965845E-03,   1.8576946E-03,   1.6216943E-03
     +,   1.3944915E-03,   1.1811403E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wano_hz_107 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wao_fus_107(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  3.0207244E-16,   3.9398313E-16
     +,   5.1310905E-16,   6.6728255E-16,   8.6650867E-16
     +,   1.1235759E-15,   1.4547779E-15,   1.8808640E-15
     +,   2.4282046E-15,   3.1302363E-15,   4.0293459E-15
     +,   5.1791402E-15,   6.6473299E-15,   8.5192541E-15
     +,   1.0902449E-14,   1.3931909E-14,   1.7777148E-14
     +,   2.2650622E-14,   2.8818002E-14,   3.6611369E-14
     +,   4.6444185E-14,   5.8831968E-14,   7.4415016E-14
     +,   9.3988443E-14,   1.1853759E-13,   1.4928011E-13
     +,   1.8772152E-13,   2.3571772E-13,   2.9555557E-13
     +,   3.7004105E-13,   4.6262272E-13,   5.7752571E-13
     +,   7.1991528E-13,   8.9610513E-13,   1.1137963E-12
     +,   1.3823466E-12,   1.7131488E-12,   2.1200220E-12
     +,   2.6197111E-12,   3.2324774E-12,   3.9827586E-12
     +,   4.9000422E-12,   6.0198283E-12,   7.3847699E-12
     +,   9.0460278E-12,   1.1064966E-11,   1.3514759E-11
     +,   1.6483013E-11,   2.0074119E-11,   2.4412075E-11
     +,   2.9644426E-11,   3.5946128E-11,   4.3524347E-11
     +,   5.2623992E-11,   6.3534233E-11,   7.6595660E-11
     +,   9.2209386E-11,   1.1084556E-10,   1.3305637E-10
     +,   1.5948855E-10,   1.9089609E-10,   2.2816062E-10
     +,   2.7230876E-10,   3.2453404E-10,   3.8622233E-10
     +,   4.5898063E-10,   5.4466937E-10,   6.4543365E-10
     +,   7.6375245E-10,   9.0248004E-10,   1.0648991E-09
     +,   1.2547695E-09,   1.4764087E-09,   1.7347532E-09
     +,   2.0354438E-09,   2.3849094E-09,   2.7904794E-09
     +,   3.2604637E-09,   3.8043115E-09,   4.4327222E-09
     +,   5.1578026E-09,   5.9932508E-09,   6.9544415E-09
     +,   8.0587501E-09,   9.3256975E-09,   1.0777168E-08
     +,   1.2437718E-08,   1.4334783E-08,   1.6499040E-08
     +,   1.8964823E-08,   2.1769992E-08,   2.4957025E-08
     +,   2.8572924E-08,   3.2669863E-08,   3.7305540E-08
     +,   4.2543732E-08,   4.8455149E-08,   5.5116871E-08
     +,   6.2614497E-08,   7.1041853E-08,   8.0501906E-08
     +,   9.1107559E-08,   1.0298221E-07,   1.1626071E-07
     +,   1.3109040E-07,   1.4763168E-07,   1.6605907E-07
     +,   1.8656246E-07,   2.0934789E-07,   2.3463878E-07
     +,   2.6267676E-07,   2.9372507E-07,   3.2806335E-07
     +,   3.6599789E-07,   4.0785702E-07,   4.5399449E-07
     +,   5.0479071E-07,   5.6065397E-07,   6.2202594E-07
     +,   6.8937067E-07,   7.6319435E-07,   8.4403530E-07
     +,   9.3247007E-07,   1.0291130E-06,   1.1346208E-06
     +,   1.2496931E-06,   1.3750762E-06,   1.5115641E-06
     +,   1.6600011E-06,   1.8212853E-06,   1.9963709E-06
     +,   2.1862782E-06,   2.3920634E-06,   2.6148721E-06
     +,   2.8559061E-06,   3.1164391E-06,   3.3978126E-06
     +,   3.7014440E-06,   4.0288255E-06,   4.3815439E-06
     +,   4.7612143E-06,   5.1695793E-06,   5.6084468E-06
     +,   6.0797056E-06,   6.5853210E-06,   7.1273380E-06
     +,   7.7078766E-06,   8.3291279E-06,   8.9933537E-06
     +,   9.7028760E-06,   1.0460084E-05,   1.1267447E-05
     +,   1.2127377E-05,   1.3042431E-05,   1.4015162E-05
     +,   1.5048148E-05,   1.6143984E-05,   1.7305269E-05
     +,   1.8534602E-05,   1.9834572E-05,   2.1207748E-05
     +,   2.2656734E-05,   2.4183897E-05,   2.5791738E-05
     +,   2.7482633E-05,   2.9258876E-05,   3.1122658E-05
     +,   3.3076063E-05,   3.5121044E-05,   3.7259437E-05
     +,   3.9492934E-05,   4.1823172E-05,   4.4251694E-05
     +,   4.6780238E-05,   4.9410417E-05,   5.2144598E-05
     +,   5.4985827E-05,   5.7938323E-05,   6.1008181E-05
     +,   6.4204178E-05,   6.7538116E-05,   7.1027564E-05
     +,   7.4695192E-05,   7.8572230E-05,   8.2699393E-05
     +,   8.7129432E-05,   9.1929352E-05,   9.7183227E-05
     +,   1.0299507E-04,   1.0949242E-04,   1.1683006E-04
     +,   1.2519497E-04,   1.3481236E-04,   1.4594992E-04
     +,   1.5893171E-04,   1.7413868E-04,   1.9202812E-04
     +,   2.1313285E-04,   2.3806962E-04,   2.6754744E-04
     +,   3.0234235E-04,   3.4329892E-04,   3.9127216E-04
     +,   4.4709712E-04,   5.1151961E-04,   5.8512954E-04
     +,   6.6829758E-04,   7.6112576E-04,   8.6342351E-04
     +,   9.7471545E-04,   1.0942810E-03,   1.2212096E-03
     +,   1.3544566E-03,   1.4928812E-03,   1.6352612E-03
     +,   1.7802668E-03,   1.9265718E-03,   2.0728975E-03
     +,   2.2183550E-03,   2.3628180E-03,   2.5073143E-03
     +,   2.6543327E-03,   2.8076014E-03,   2.9715160E-03
     +,   3.1500470E-03,   3.3455542E-03,   3.5579256E-03
     +,   3.7843250E-03,   4.0196227E-03,   4.2571016E-03
     +,   4.4892034E-03,   4.7080428E-03,   4.9062418E-03
     +,   5.0785444E-03,   5.2243224E-03,   5.3504021E-03
     +,   5.4729003E-03,   5.6168577E-03,   5.8129197E-03
     +,   6.0905088E-03,   6.4680516E-03,   6.9428217E-03
     +,   7.4856421E-03,   8.0463132E-03,   8.5696634E-03
     +,   9.0150191E-03,   9.3676588E-03,   9.6362578E-03
     +,   9.8402891E-03,   9.9969571E-03,   1.0115416E-02
     +,   1.0199880E-02,   1.0257404E-02,   1.0301709E-02
     +,   1.0345696E-02,   1.0386478E-02,   1.0399311E-02
     +,   1.0354708E-02,   1.0250216E-02,   1.0127677E-02
     +,   1.0053245E-02,   1.0071344E-02,   1.0172209E-02
     +,   1.0303382E-02,   1.0414212E-02,   1.0489875E-02
     +,   1.0544959E-02,   1.0591069E-02,   1.0618377E-02
     +,   1.0612285E-02,   1.0585474E-02,   1.0586296E-02
     +,   1.0666095E-02,   1.0829460E-02,   1.1014234E-02
     +,   1.1123885E-02,   1.1085330E-02,   1.0884327E-02
     +,   1.0558276E-02,   1.0167550E-02,   9.7744875E-03
     +,   9.4334399E-03,   9.1783833E-03,   9.0052718E-03
     +,   8.8649383E-03,   8.6798798E-03,   8.3772521E-03
     +,   7.9170102E-03,   7.3003573E-03,   6.5603028E-03
     +,   5.7457769E-03,   4.9083978E-03,   4.0942426E-03
     +,   3.3392480E-03,   2.6669777E-03,   2.0887482E-03
     +,   1.6057683E-03,   1.2123785E-03,   8.9924142E-04
     +,   6.5539131E-04,   4.6971568E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wao_fus_107 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1916_hnn_wao_hz_107(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 100.4/
      DATA y /  1.2478859E-15,   1.5900937E-15
     +,   2.0235340E-15,   2.5718267E-15,   3.2644654E-15
     +,   4.1383048E-15,   5.2393058E-15,   6.6247082E-15
     +,   8.3656980E-15,   1.0550595E-14,   1.3288980E-14
     +,   1.6716603E-14,   2.1001221E-14,   2.6350074E-14
     +,   3.3018954E-14,   4.1322099E-14,   5.1646665E-14
     +,   6.4467955E-14,   8.0368438E-14,   1.0006230E-13
     +,   1.2442129E-13,   1.5451084E-13,   1.9163024E-13
     +,   2.3736178E-13,   2.9362979E-13,   3.6276700E-13
     +,   4.4760642E-13,   5.5157756E-13,   6.7882727E-13
     +,   8.3435412E-13,   1.0241944E-12,   1.2556115E-12
     +,   1.5373397E-12,   1.8798552E-12,   2.2957380E-12
     +,   2.8000065E-12,   3.4106424E-12,   4.1491073E-12
     +,   5.0409681E-12,   6.1166744E-12,   7.4123659E-12
     +,   8.9709472E-12,   1.0843290E-11,   1.3089550E-11
     +,   1.5780792E-11,   1.9000971E-11,   2.2848749E-11
     +,   2.7440290E-11,   3.2912305E-11,   3.9424543E-11
     +,   4.7164665E-11,   5.6351687E-11,   6.7241643E-11
     +,   8.0132838E-11,   9.5372425E-11,   1.1336442E-10
     +,   1.3457777E-10,   1.5955449E-10,   1.8892317E-10
     +,   2.2341086E-10,   2.6385308E-10,   3.1121555E-10
     +,   3.6660716E-10,   4.3130233E-10,   5.0676091E-10
     +,   5.9465599E-10,   6.9690004E-10,   8.1566992E-10
     +,   9.5345376E-10,   1.1130772E-09,   1.2977572E-09
     +,   1.5111279E-09,   1.7573144E-09,   2.0409809E-09
     +,   2.3673854E-09,   2.7424596E-09,   3.1728766E-09
     +,   3.6661154E-09,   4.2305786E-09,   4.8756692E-09
     +,   5.6118932E-09,   6.4509997E-09,   7.4060074E-09
     +,   8.4914502E-09,   9.7234611E-09,   1.1119881E-08
     +,   1.2700495E-08,   1.4487128E-08,   1.6503821E-08
     +,   1.8777161E-08,   2.1336035E-08,   2.4212440E-08
     +,   2.7441272E-08,   3.1060654E-08,   3.5112205E-08
     +,   3.9641161E-08,   4.4696922E-08,   5.0332396E-08
     +,   5.6605487E-08,   6.3578462E-08,   7.1318574E-08
     +,   7.9898001E-08,   8.9394398E-08,   9.9890748E-08
     +,   1.1147594E-07,   1.2424475E-07,   1.3829799E-07
     +,   1.5374263E-07,   1.7069227E-07,   1.8926663E-07
     +,   2.0959217E-07,   2.3180304E-07,   2.5603651E-07
     +,   2.8243963E-07,   3.1116463E-07,   3.4236999E-07
     +,   3.7622002E-07,   4.1288493E-07,   4.5254203E-07
     +,   4.9536777E-07,   5.4154873E-07,   5.9127308E-07
     +,   6.4473249E-07,   7.0212110E-07,   7.6363426E-07
     +,   8.2946781E-07,   8.9981830E-07,   9.7487919E-07
     +,   1.0548432E-06,   1.1398984E-06,   1.2302280E-06
     +,   1.3260127E-06,   1.4274128E-06,   1.5345925E-06
     +,   1.6477007E-06,   1.7668744E-06,   1.8922373E-06
     +,   2.0238977E-06,   2.1619476E-06,   2.3064695E-06
     +,   2.4575063E-06,   2.6151040E-06,   2.7792807E-06
     +,   2.9500368E-06,   3.1273562E-06,   3.3112028E-06
     +,   3.5015296E-06,   3.6982772E-06,   3.9013830E-06
     +,   4.1107833E-06,   4.3264258E-06,   4.5482902E-06
     +,   4.7763588E-06,   5.0106955E-06,   5.2514297E-06
     +,   5.4987872E-06,   5.7531201E-06,   6.0149428E-06
     +,   6.2849772E-06,   6.5641902E-06,   6.8538598E-06
     +,   7.1556369E-06,   7.4715676E-06,   7.8042467E-06
     +,   8.1568433E-06,   8.5332040E-06,   8.9379473E-06
     +,   9.3765420E-06,   9.8554310E-06,   1.0382098E-05
     +,   1.0965186E-05,   1.1614560E-05,   1.2341397E-05
     +,   1.3158283E-05,   1.4079113E-05,   1.5119322E-05
     +,   1.6295775E-05,   1.7626757E-05,   1.9131954E-05
     +,   2.0832445E-05,   2.2750235E-05,   2.4909050E-05
     +,   2.7333015E-05,   3.0047520E-05,   3.3078646E-05
     +,   3.6453133E-05,   4.0198280E-05,   4.4341854E-05
     +,   4.8912036E-05,   5.3937329E-05,   5.9446527E-05
     +,   6.5468572E-05,   7.2032759E-05,   7.9166988E-05
     +,   8.6900793E-05,   9.5260017E-05,   1.0427158E-04
     +,   1.1395756E-04,   1.2433587E-04,   1.3542207E-04
     +,   1.4722101E-04,   1.5973333E-04,   1.7294605E-04
     +,   1.8683728E-04,   2.0137282E-04,   2.1650687E-04
     +,   2.3218317E-04,   2.4833772E-04,   2.6490304E-04
     +,   2.8181376E-04,   2.9901491E-04,   3.1647072E-04
     +,   3.3417507E-04,   3.5216194E-04,   3.7051563E-04
     +,   3.8937366E-04,   4.0893882E-04,   4.2946459E-04
     +,   4.5125454E-04,   4.7464357E-04,   4.9997069E-04
     +,   5.2756828E-04,   5.5772503E-04,   5.9068820E-04
     +,   6.2666414E-04,   6.6584960E-04,   7.0849009E-04
     +,   7.5496169E-04,   8.0587209E-04,   8.6214778E-04
     +,   9.2509238E-04,   9.9636440E-04,   1.0778641E-03
     +,   1.1715197E-03,   1.2790151E-03,   1.4015355E-03
     +,   1.5396244E-03,   1.6931728E-03,   1.8616099E-03
     +,   2.0440535E-03,   2.2393414E-03,   2.4457360E-03
     +,   2.6602498E-03,   2.8778862E-03,   3.0909919E-03
     +,   3.2893275E-03,   3.4612147E-03,   3.5957666E-03
     +,   3.6857477E-03,   3.7300705E-03,   3.7349747E-03
     +,   3.7134492E-03,   3.6835249E-03,   3.6664039E-03
     +,   3.6847773E-03,   3.7601830E-03,   3.9076228E-03
     +,   4.1274801E-03,   4.3982235E-03,   4.6762782E-03
     +,   4.9072793E-03,   5.0469586E-03,   5.0822282E-03
     +,   5.0399867E-03,   4.9761669E-03,   4.9491664E-03
     +,   4.9928236E-03,   5.1057995E-03,   5.2634282E-03
     +,   5.4419315E-03,   5.6350264E-03,   5.8491514E-03
     +,   6.0825963E-03,   6.3104802E-03,   6.4934008E-03
     +,   6.6032424E-03,   6.6395043E-03,   6.6189854E-03
     +,   6.5513467E-03,   6.4286101E-03,   6.2395767E-03
     +,   5.9923981E-03,   5.7216734E-03,   5.4743467E-03
     +,   5.2866498E-03,   5.1673595E-03,   5.0935084E-03
     +,   5.0177705E-03,   4.8842966E-03,   4.6478934E-03
     +,   4.2893537E-03,   3.8204703E-03,   3.2775358E-03
     +,   2.7079948E-03,   2.1571722E-03,   1.6596491E-03
     +,   1.2360965E-03,   8.9400465E-04,   6.3054409E-04
     +,   4.3597049E-04,   2.9730971E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1916_hnn_wao_hz_107 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_nwao_fus_100(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  4.2829220E-18,   5.8016504E-18
     +,   7.8463094E-18,   1.0594595E-17,   1.4282522E-17
     +,   1.9223380E-17,   2.5831990E-17,   3.4656737E-17
     +,   4.6421770E-17,   6.2081288E-17,   8.2890022E-17
     +,   1.1049596E-16,   1.4705919E-16,   1.9540792E-16
     +,   2.5923610E-16,   3.4336132E-16,   4.5405810E-16
     +,   5.9947910E-16,   7.9020551E-16,   1.0399426E-15
     +,   1.3664132E-15,   1.7924924E-15,   2.3476640E-15
     +,   3.0698727E-15,   4.0077978E-15,   5.2238864E-15
     +,   6.7980734E-15,   8.8324386E-15,   1.1457231E-14
     +,   1.4838203E-14,   1.9186055E-14,   2.4768148E-14
     +,   3.1923147E-14,   4.1079075E-14,   5.2776333E-14
     +,   6.7695774E-14,   8.6693565E-14,   1.1084519E-13
     +,   1.4149792E-13,   1.8033810E-13,   2.2947174E-13
     +,   2.9152603E-13,   3.6976515E-13,   4.6825678E-13
     +,   5.9203098E-13,   7.4732863E-13,   9.4185814E-13
     +,   1.1851294E-12,   1.4888636E-12,   1.8674643E-12
     +,   2.3386184E-12,   2.9240072E-12,   3.6501405E-12
     +,   4.5494207E-12,   5.6613720E-12,   7.0340257E-12
     +,   8.7258759E-12,   1.0807848E-11,   1.3365958E-11
     +,   1.6504185E-11,   2.0348324E-11,   2.5050023E-11
     +,   3.0792213E-11,   3.7794923E-11,   4.6322956E-11
     +,   5.6694219E-11,   6.9290337E-11,   8.4569074E-11
     +,   1.0307909E-10,   1.2547730E-10,   1.5255078E-10
     +,   1.8524177E-10,   2.2467812E-10,   2.7221081E-10
     +,   3.2945904E-10,   3.9835898E-10,   4.8123683E-10
     +,   5.8088190E-10,   7.0064277E-10,   8.4455287E-10
     +,   1.0174579E-09,   1.2252008E-09,   1.4748401E-09
     +,   1.7748686E-09,   2.1355648E-09,   2.5694333E-09
     +,   3.0915048E-09,   3.7200765E-09,   4.4773105E-09
     +,   5.3900990E-09,   6.4910530E-09,   7.8197422E-09
     +,   9.4241202E-09,   1.1362295E-08,   1.3704598E-08
     +,   1.6536022E-08,   1.9959201E-08,   2.4097766E-08
     +,   2.9100367E-08,   3.5145415E-08,   4.2446381E-08
     +,   5.1258059E-08,   6.1883775E-08,   7.4683349E-08
     +,   9.0082288E-08,   1.0858214E-07,   1.3077170E-07
     +,   1.5734099E-07,   1.8909029E-07,   2.2695015E-07
     +,   2.7200150E-07,   3.2547649E-07,   3.8879350E-07
     +,   4.6356701E-07,   5.5162712E-07,   6.5503917E-07
     +,   7.7612003E-07,   9.1745602E-07,   1.0819170E-06
     +,   1.2726695E-06,   1.4931851E-06,   1.7472460E-06
     +,   2.0389448E-06,   2.3726786E-06,   2.7531376E-06
     +,   3.1852821E-06,   3.6743172E-06,   4.2256493E-06
     +,   4.8448424E-06,   5.5375522E-06,   6.3094672E-06
     +,   7.1662143E-06,   8.1132757E-06,   9.1558850E-06
     +,   1.0298912E-05,   1.1546755E-05,   1.2903192E-05
     +,   1.4371285E-05,   1.5953214E-05,   1.7650167E-05
     +,   1.9462215E-05,   2.1388187E-05,   2.3425544E-05
     +,   2.5570329E-05,   2.7817063E-05,   3.0158779E-05
     +,   3.2586526E-05,   3.5090470E-05,   3.7658465E-05
     +,   4.0277300E-05,   4.2932239E-05,   4.5607256E-05
     +,   4.8285230E-05,   5.0948100E-05,   5.3577121E-05
     +,   5.6153091E-05,   5.8656664E-05,   6.1068575E-05
     +,   6.3370033E-05,   6.5542961E-05,   6.7570363E-05
     +,   6.9436574E-05,   7.1127608E-05,   7.2631403E-05
     +,   7.3938092E-05,   7.5040196E-05,   7.5932825E-05
     +,   7.6613840E-05,   7.7083925E-05,   7.7346653E-05
     +,   7.7408535E-05,   7.7278957E-05,   7.6970158E-05
     +,   7.6497097E-05,   7.5877273E-05,   7.5130716E-05
     +,   7.4279640E-05,   7.3348318E-05,   7.2362862E-05
     +,   7.1350980E-05,   7.0341805E-05,   6.9365604E-05
     +,   6.8453621E-05,   6.7637775E-05,   6.6950473E-05
     +,   6.6424327E-05,   6.6091903E-05,   6.5985405E-05
     +,   6.6136454E-05,   6.6575587E-05,   6.7332032E-05
     +,   6.8433277E-05,   6.9904716E-05,   7.1769413E-05
     +,   7.4047879E-05,   7.6758071E-05,   7.9915699E-05
     +,   8.3534680E-05,   8.7628199E-05,   9.2210124E-05
     +,   9.7297067E-05,   1.0291085E-04,   1.0908167E-04
     +,   1.1585160E-04,   1.2327856E-04,   1.3144000E-04
     +,   1.4043666E-04,   1.5039535E-04,   1.6147034E-04
     +,   1.7384312E-04,   1.8771617E-04,   2.0331077E-04
     +,   2.2084964E-04,   2.4054220E-04,   2.6256236E-04
     +,   2.8701749E-04,   3.1392337E-04,   3.4316999E-04
     +,   3.7449400E-04,   4.0746818E-04,   4.4148590E-04
     +,   4.7579425E-04,   5.0953327E-04,   5.4181210E-04
     +,   5.7181111E-04,   5.9889595E-04,   6.2275538E-04
     +,   6.4350112E-04,   6.6175510E-04,   6.7867176E-04
     +,   6.9589523E-04,   7.1544957E-04,   7.3956483E-04
     +,   7.7046844E-04,   8.1018562E-04,   8.6035230E-04
     +,   9.2211238E-04,   9.9605485E-04,   1.0821926E-03
     +,   1.1799367E-03,   1.2880171E-03,   1.4043271E-03
     +,   1.5257208E-03,   1.6478392E-03,   1.7651237E-03
     +,   1.8711783E-03,   1.9596098E-03,   2.0253246E-03
     +,   2.0660476E-03,   2.0835903E-03,   2.0842757E-03
     +,   2.0780524E-03,   2.0762673E-03,   2.0886208E-03
     +,   2.1203388E-03,   2.1707052E-03,   2.2336696E-03
     +,   2.3004706E-03,   2.3634001E-03,   2.4193558E-03
     +,   2.4718556E-03,   2.5306675E-03,   2.6089067E-03
     +,   2.7183634E-03,   2.8644809E-03,   3.0427969E-03
     +,   3.2383797E-03,   3.4287039E-03,   3.5890827E-03
     +,   3.6986899E-03,   3.7450646E-03,   3.7259185E-03
     +,   3.6483891E-03,   3.5266764E-03,   3.3790043E-03
     +,   3.2242821E-03,   3.0783971E-03,   2.9506206E-03
     +,   2.8411823E-03,   2.7411950E-03,   2.6355665E-03
     +,   2.5080652E-03,   2.3467559E-03,   2.1477703E-03
     +,   1.9162389E-03,   1.6644297E-03,   1.4081461E-03
     +,   1.1628474E-03,   9.4066653E-04,   7.4891315E-04
     +,   5.9007487E-04,   4.6274724E-04,   3.6305911E-04
     +,   2.8606897E-04,   2.2679094E-04,   1.8085360E-04
     +,   1.4476397E-04,   1.1593656E-04,   9.2561320E-05
     +,   7.3416872E-05,   5.7685073E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_nwao_fus_100 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_nwao_fus_105(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  3.7223820E-19,   5.1981984E-19
     +,   7.2463958E-19,   1.0083910E-18,   1.4008042E-18
     +,   1.9425210E-18,   2.6890438E-18,   3.7160001E-18
     +,   5.1262554E-18,   7.0595489E-18,   9.7051099E-18
     +,   1.3319203E-17,   1.8247900E-17,   2.4957751E-17
     +,   3.4076943E-17,   4.6449374E-17,   6.3207590E-17
     +,   8.5867680E-17,   1.1645716E-16,   1.5768249E-16
     +,   2.1314994E-16,   2.8765721E-16,   3.8757972E-16
     +,   5.2137191E-16,   7.0022477E-16,   9.3893803E-16
     +,   1.2570511E-15,   1.6803260E-15,   2.2426569E-15
     +,   2.9886048E-15,   3.9766609E-15,   5.2834633E-15
     +,   7.0093565E-15,   9.2854708E-15,   1.2282990E-14
     +,   1.6225072E-14,   2.1402322E-14,   2.8192546E-14
     +,   3.7086386E-14,   4.8720481E-14,   6.3919437E-14
     +,   8.3750965E-14,   1.0959308E-13,   1.4322884E-13
     +,   1.8695275E-13,   2.4372336E-13,   3.1734568E-13
     +,   4.1271191E-13,   5.3609873E-13,   6.9555505E-13
     +,   9.0138671E-13,   1.1667825E-12,   1.5085797E-12
     +,   1.9482799E-12,   2.5132869E-12,   3.2384421E-12
     +,   4.1680825E-12,   5.3584619E-12,   6.8809403E-12
     +,   8.8258047E-12,   1.1307226E-11,   1.4469324E-11
     +,   1.8493738E-11,   2.3609021E-11,   3.0102427E-11
     +,   3.8334082E-11,   4.8755097E-11,   6.1929295E-11
     +,   7.8560117E-11,   9.9523667E-11,   1.2590887E-10
     +,   1.5906700E-10,   2.0067076E-10,   2.5278662E-10
     +,   3.1796515E-10,   3.9933853E-10,   5.0075760E-10
     +,   6.2693684E-10,   7.8363438E-10,   9.7788244E-10
     +,   1.2182223E-09,   1.5150222E-09,   1.8808475E-09
     +,   2.3308202E-09,   2.8831728E-09,   3.5599006E-09
     +,   4.3871786E-09,   5.3964007E-09,   6.6249384E-09
     +,   8.1171976E-09,   9.9257944E-09,   1.2112891E-08
     +,   1.4751731E-08,   1.7928318E-08,   2.1743409E-08
     +,   2.6314632E-08,   3.1778914E-08,   3.8295134E-08
     +,   4.6047134E-08,   5.5246808E-08,   6.6137801E-08
     +,   7.8999150E-08,   9.4149478E-08,   1.1195134E-07
     +,   1.3281590E-07,   1.5720771E-07,   1.8564981E-07
     +,   2.1873061E-07,   2.5710310E-07,   3.0149712E-07
     +,   3.5272856E-07,   4.1168653E-07,   4.7935754E-07
     +,   5.5682091E-07,   6.4525375E-07,   7.4593476E-07
     +,   8.6024733E-07,   9.8967939E-07,   1.1358256E-06
     +,   1.3003843E-06,   1.4851562E-06,   1.6920395E-06
     +,   1.9230235E-06,   2.1801782E-06,   2.4656490E-06
     +,   2.7816347E-06,   3.1303816E-06,   3.5141561E-06
     +,   3.9352303E-06,   4.3958571E-06,   4.8982392E-06
     +,   5.4445072E-06,   6.0366870E-06,   6.6766611E-06
     +,   7.3661449E-06,   8.1066410E-06,   8.8994093E-06
     +,   9.7454249E-06,   1.0645345E-05,   1.1599470E-05
     +,   1.2607712E-05,   1.3669562E-05,   1.4784047E-05
     +,   1.5949734E-05,   1.7164673E-05,   1.8426455E-05
     +,   1.9731933E-05,   2.1077803E-05,   2.2459837E-05
     +,   2.3873510E-05,   2.5313740E-05,   2.6774955E-05
     +,   2.8251145E-05,   2.9735886E-05,   3.1222397E-05
     +,   3.2703621E-05,   3.4172237E-05,   3.5620807E-05
     +,   3.7041806E-05,   3.8427737E-05,   3.9771214E-05
     +,   4.1065090E-05,   4.2302567E-05,   4.3477292E-05
     +,   4.4583507E-05,   4.5616165E-05,   4.6571076E-05
     +,   4.7445064E-05,   4.8236092E-05,   4.8943482E-05
     +,   4.9567952E-05,   5.0111958E-05,   5.0579820E-05
     +,   5.0977946E-05,   5.1315012E-05,   5.1602226E-05
     +,   5.1853654E-05,   5.2086420E-05,   5.2321044E-05
     +,   5.2581720E-05,   5.2896601E-05,   5.3298128E-05
     +,   5.3823151E-05,   5.4513195E-05,   5.5414439E-05
     +,   5.6577624E-05,   5.8057809E-05,   5.9913800E-05
     +,   6.2207451E-05,   6.5002547E-05,   6.8363501E-05
     +,   7.2353731E-05,   7.7033896E-05,   8.2459825E-05
     +,   8.8680623E-05,   9.5736905E-05,   1.0365926E-04
     +,   1.1246747E-04,   1.2217036E-04,   1.3276673E-04
     +,   1.4424758E-04,   1.5659929E-04,   1.6980841E-04
     +,   1.8386688E-04,   1.9877841E-04,   2.1456438E-04
     +,   2.3126879E-04,   2.4896150E-04,   2.6773807E-04
     +,   2.8771622E-04,   3.0902241E-04,   3.3178530E-04
     +,   3.5610719E-04,   3.8204444E-04,   4.0958214E-04
     +,   4.3860596E-04,   4.6889103E-04,   5.0009089E-04
     +,   5.3174474E-04,   5.6331186E-04,   5.9420441E-04
     +,   6.2386651E-04,   6.5184693E-04,   6.7788357E-04
     +,   7.0198224E-04,   7.2446326E-04,   7.4599119E-04
     +,   7.6753640E-04,   7.9030904E-04,   8.1565621E-04
     +,   8.4494840E-04,   8.7950152E-04,   9.2054147E-04
     +,   9.6922379E-04,   1.0266920E-03,   1.0940615E-03
     +,   1.1723316E-03,   1.2620919E-03,   1.3630913E-03
     +,   1.4737888E-03,   1.5911182E-03,   1.7107317E-03
     +,   1.8278740E-03,   1.9387831E-03,   2.0421941E-03
     +,   2.1402556E-03,   2.2381833E-03,   2.3423636E-03
     +,   2.4572923E-03,   2.5824273E-03,   2.7104015E-03
     +,   2.8276802E-03,   2.9177724E-03,   2.9660079E-03
     +,   2.9640177E-03,   2.9122485E-03,   2.8196911E-03
     +,   2.7012296E-03,   2.5739239E-03,   2.4536001E-03
     +,   2.3526161E-03,   2.2789224E-03,   2.2360252E-03
     +,   2.2234705E-03,   2.2376282E-03,   2.2727344E-03
     +,   2.3220545E-03,   2.3789303E-03,   2.4374502E-03
     +,   2.4927475E-03,   2.5411684E-03,   2.5806080E-03
     +,   2.6109375E-03,   2.6341029E-03,   2.6533487E-03
     +,   2.6714287E-03,   2.6883602E-03,   2.6997258E-03
     +,   2.6965155E-03,   2.6668923E-03,   2.5993546E-03
     +,   2.4861710E-03,   2.3258838E-03,   2.1240441E-03
     +,   1.8920915E-03,   1.6449064E-03,   1.3978763E-03
     +,   1.1643320E-03,   9.5388707E-04,   7.7184936E-04
     +,   6.1959500E-04,   4.9547025E-04,   3.9597109E-04
     +,   3.1685526E-04,   2.5394076E-04,   2.0361465E-04
     +,   1.6301112E-04,   1.3000189E-04,   1.0305645E-04
     +,   8.1071281E-05,   6.3218286E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_nwao_fus_105 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_nwao_fus_110(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  2.9916368E-08,   3.3777201E-08
     +,   3.8089947E-08,   4.2901096E-08,   4.8261274E-08
     +,   5.4225133E-08,   6.0851917E-08,   6.8205566E-08
     +,   7.6354922E-08,   8.5374246E-08,   9.5342820E-08
     +,   1.0634587E-07,   1.1847453E-07,   1.3182597E-07
     +,   1.4650382E-07,   1.6261801E-07,   1.8028520E-07
     +,   1.9962891E-07,   2.2077938E-07,   2.4387398E-07
     +,   2.6905684E-07,   2.9647936E-07,   3.2629964E-07
     +,   3.5868348E-07,   3.9380134E-07,   4.3183186E-07
     +,   4.7295958E-07,   5.1737459E-07,   5.6527267E-07
     +,   6.1685449E-07,   6.7232463E-07,   7.3189244E-07
     +,   7.9576961E-07,   8.6416981E-07,   9.3730870E-07
     +,   1.0154019E-06,   1.0986646E-06,   1.1873096E-06
     +,   1.2815474E-06,   1.3815836E-06,   1.4876180E-06
     +,   1.5998457E-06,   1.7184434E-06,   1.8435949E-06
     +,   1.9754541E-06,   2.1141705E-06,   2.2598779E-06
     +,   2.4126907E-06,   2.5727059E-06,   2.7399992E-06
     +,   2.9146238E-06,   3.0966085E-06,   3.2859571E-06
     +,   3.4826458E-06,   3.6866254E-06,   3.8978037E-06
     +,   4.1160702E-06,   4.3412742E-06,   4.5732354E-06
     +,   4.8117340E-06,   5.0565172E-06,   5.3072940E-06
     +,   5.5637365E-06,   5.8254809E-06,   6.0921252E-06
     +,   6.3632292E-06,   6.6383200E-06,   6.9168836E-06
     +,   7.1983777E-06,   7.4822224E-06,   7.7678051E-06
     +,   8.0544860E-06,   8.3415953E-06,   8.6284381E-06
     +,   8.9143041E-06,   9.1984384E-06,   9.4800935E-06
     +,   9.7584962E-06,   1.0032861E-05,   1.0302409E-05
     +,   1.0566340E-05,   1.0823862E-05,   1.1074197E-05
     +,   1.1316539E-05,   1.1550121E-05,   1.1774219E-05
     +,   1.1988071E-05,   1.2190976E-05,   1.2382253E-05
     +,   1.2561253E-05,   1.2727361E-05,   1.2880005E-05
     +,   1.3018651E-05,   1.3142814E-05,   1.3252055E-05
     +,   1.3345990E-05,   1.3424287E-05,   1.3486669E-05
     +,   1.3532917E-05,   1.3562879E-05,   1.3576450E-05
     +,   1.3573597E-05,   1.3554345E-05,   1.3518780E-05
     +,   1.3467054E-05,   1.3399381E-05,   1.3316028E-05
     +,   1.3217326E-05,   1.3103673E-05,   1.2975515E-05
     +,   1.2833339E-05,   1.2677713E-05,   1.2509237E-05
     +,   1.2328561E-05,   1.2136383E-05,   1.1933437E-05
     +,   1.1720500E-05,   1.1498386E-05,   1.1267938E-05
     +,   1.1030031E-05,   1.0785565E-05,   1.0535462E-05
     +,   1.0280669E-05,   1.0022143E-05,   9.7608608E-06
     +,   9.4978086E-06,   9.2339815E-06,   8.9703735E-06
     +,   8.7079961E-06,   8.4478479E-06,   8.1909329E-06
     +,   7.9382498E-06,   7.6907918E-06,   7.4495415E-06
     +,   7.2154735E-06,   6.9895500E-06,   6.7727192E-06
     +,   6.5659128E-06,   6.3700454E-06,   6.1860087E-06
     +,   6.0146745E-06,   5.8568899E-06,   5.7134712E-06
     +,   5.5852097E-06,   5.4728607E-06,   5.3771410E-06
     +,   5.2987430E-06,   5.2382943E-06,   5.1963957E-06
     +,   5.1735869E-06,   5.1703587E-06,   5.1871398E-06
     +,   5.2243008E-06,   5.2821397E-06,   5.3608856E-06
     +,   5.4606917E-06,   5.5816281E-06,   5.7236789E-06
     +,   5.8867413E-06,   6.0706166E-06,   6.2750146E-06
     +,   6.4995447E-06,   6.7437195E-06,   7.0069532E-06
     +,   7.2885728E-06,   7.5878133E-06,   7.9038391E-06
     +,   8.2357519E-06,   8.5826141E-06,   8.9434971E-06
     +,   9.3174476E-06,   9.7036436E-06,   1.0101365E-05
     +,   1.0510162E-05,   1.0929863E-05,   1.1360690E-05
     +,   1.1803481E-05,   1.2259774E-05,   1.2732010E-05
     +,   1.3223735E-05,   1.3739808E-05,   1.4286647E-05
     +,   1.4872451E-05,   1.5507454E-05,   1.6204129E-05
     +,   1.6977410E-05,   1.7844857E-05,   1.8826782E-05
     +,   1.9946347E-05,   2.1229602E-05,   2.2705502E-05
     +,   2.4405910E-05,   2.6365587E-05,   2.8622277E-05
     +,   3.1216838E-05,   3.4193537E-05,   3.7600515E-05
     +,   4.1490501E-05,   4.5921690E-05,   5.0958828E-05
     +,   5.6674482E-05,   6.3150190E-05,   7.0477618E-05
     +,   7.8759120E-05,   8.8107750E-05,   9.8646437E-05
     +,   1.1050577E-04,   1.2382063E-04,   1.3872546E-04
     +,   1.5534884E-04,   1.7380297E-04,   1.9418365E-04
     +,   2.1655601E-04,   2.4095217E-04,   2.6736717E-04
     +,   2.9575231E-04,   3.2602105E-04,   3.5804597E-04
     +,   3.9165895E-04,   4.2666015E-04,   4.6280274E-04
     +,   4.9980631E-04,   5.3734944E-04,   5.7507318E-04
     +,   6.1259093E-04,   6.4949697E-04,   6.8540924E-04
     +,   7.1998726E-04,   7.5298263E-04,   7.8428222E-04
     +,   8.1394269E-04,   8.4223732E-04,   8.6968258E-04
     +,   8.9706434E-04,   9.2545594E-04,   9.5619168E-04
     +,   9.9081872E-04,   1.0309664E-03,   1.0781543E-03
     +,   1.1335525E-03,   1.1977418E-03,   1.2705289E-03
     +,   1.3508723E-03,   1.4369361E-03,   1.5262318E-03
     +,   1.6158037E-03,   1.7023908E-03,   1.7825633E-03
     +,   1.8528802E-03,   1.9101527E-03,   1.9518556E-03
     +,   1.9766614E-03,   1.9849385E-03,   1.9790337E-03
     +,   1.9631665E-03,   1.9429598E-03,   1.9247632E-03
     +,   1.9150315E-03,   1.9199266E-03,   1.9451216E-03
     +,   1.9955542E-03,   2.0748265E-03,   2.1840900E-03
     +,   2.3206049E-03,   2.4765793E-03,   2.6390392E-03
     +,   2.7912834E-03,   2.9158574E-03,   2.9982983E-03
     +,   3.0303355E-03,   3.0113747E-03,   2.9477070E-03
     +,   2.8498203E-03,   2.7289453E-03,   2.5941578E-03
     +,   2.4510226E-03,   2.3018748E-03,   2.1472706E-03
     +,   1.9877255E-03,   1.8248416E-03,   1.6615732E-03
     +,   1.5016210E-03,   1.3485329E-03,   1.2049109E-03
     +,   1.0720529E-03,   9.5007883E-04,   8.3835318E-04
     +,   7.3597615E-04,   6.4214406E-04,   5.5630645E-04
     +,   4.7816840E-04,   4.0756562E-04,   3.4434893E-04
     +,   2.8831454E-04,   2.3915702E-04,   1.9648350E-04
     +,   1.5982470E-04,   1.2867055E-04,   1.0248948E-04
     +,   8.0744489E-05,   6.2904088E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_nwao_fus_110 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_nwao_fus_115(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   1.6543158E-38,   3.5493133E-38,   7.5859550E-38
     +,   1.6151500E-37,   3.4256703E-37,   7.2379375E-37
     +,   1.5234357E-36,   3.1941856E-36,   6.6717455E-36
     +,   1.3882004E-35,   2.8774087E-35,   5.9412928E-35
     +,   1.2221006E-34,   2.5041464E-34,   5.1114696E-34
     +,   1.0393661E-33,   2.1053679E-33,   4.2483876E-33
     +,   8.5398842E-33,   1.7100866E-32,   3.4112820E-32
     +,   6.7787891E-32,   1.3419150E-31,   2.6462418E-31
     +,   5.1984126E-31,   1.0172991E-30,   1.9831697E-30
     +,   3.8512889E-30,   7.4505631E-30,   1.4358434E-29
     +,   2.7565441E-29,   5.2716669E-29,   1.0043366E-28
     +,   1.9060629E-28,   3.6035615E-28,   6.7867460E-28
     +,   1.2732822E-27,   2.3797210E-27,   4.4305988E-27
     +,   8.2173576E-27,   1.5182337E-26,   2.7943450E-26
     +,   5.1233795E-26,   9.3578175E-26,   1.7026395E-25
     +,   3.0860589E-25,   5.5721446E-25,   1.0022489E-24
     +,   1.7958241E-24,   3.2054473E-24,   5.6996325E-24
     +,   1.0095823E-23,   1.7814418E-23,   3.1313862E-23
     +,   5.4832516E-23,   9.5647391E-23,   1.6620464E-22
     +,   2.8770651E-22,   4.9612535E-22,   8.5225200E-22
     +,   1.4584103E-21,   2.4861541E-21,   4.2219343E-21
     +,   7.1422191E-21,   1.2036168E-20,   2.0205827E-20
     +,   3.3790926E-20,   5.6292885E-20,   9.3421888E-20
     +,   1.5444674E-19,   2.5435711E-19,   4.1730461E-19
     +,   6.8200881E-19,   1.1103296E-18,   1.8008030E-18
     +,   2.9094312E-18,   4.6825772E-18,   7.5075409E-18
     +,   1.1990723E-17,   1.9077796E-17,   3.0237564E-17
     +,   4.7741884E-17,   7.5091198E-17,   1.1765562E-16
     +,   1.8364242E-16,   2.8553984E-16,   4.4227971E-16
     +,   6.8243666E-16,   1.0489692E-15,   1.6061976E-15
     +,   2.4500276E-15,   3.7228576E-15,   5.6353297E-15
     +,   8.4975870E-15,   1.2764639E-14,   1.9100983E-14
     +,   2.8473846E-14,   4.2282912E-14,   6.2547691E-14
     +,   9.2173644E-14,   1.3531050E-13,   1.9787512E-13
     +,   2.8826101E-13,   4.1832748E-13,   6.0475735E-13
     +,   8.7092708E-13,   1.2494481E-12,   1.7856224E-12
     +,   2.5421204E-12,   3.6052751E-12,   5.0934881E-12
     +,   7.1684963E-12,   1.0050235E-11,   1.4036519E-11
     +,   1.9528892E-11,   2.7066446E-11,   3.7369764E-11
     +,   5.1397834E-11,   7.0421419E-11,   9.6116885E-11
     +,   1.3068630E-10,   1.7700903E-10,   2.3883426E-10
     +,   3.2102029E-10,   4.2983730E-10,   5.7333865E-10
     +,   7.6182094E-10,   1.0083945E-09,   1.3296685E-09
     +,   1.7465916E-09,   2.2854663E-09,   2.9791558E-09
     +,   3.8685437E-09,   5.0042197E-09,   6.4486025E-09
     +,   8.2779197E-09,   1.0585727E-08,   1.3485004E-08
     +,   1.7112633E-08,   2.1633056E-08,   2.7242937E-08
     +,   3.4176342E-08,   4.2710308E-08,   5.3170996E-08
     +,   6.5940519E-08,   8.1463931E-08,   1.0025668E-07
     +,   1.2291275E-07,   1.5011206E-07,   1.8262897E-07
     +,   2.2133950E-07,   2.6722904E-07,   3.2139832E-07
     +,   3.8506920E-07,   4.5958882E-07,   5.4643101E-07
     +,   6.4719694E-07,   7.6361249E-07,   8.9752740E-07
     +,   1.0508840E-06,   1.2257365E-06,   1.4242037E-06
     +,   1.6484860E-06,   1.9007991E-06,   2.1833337E-06
     +,   2.4982692E-06,   2.8476989E-06,   3.2335884E-06
     +,   3.6577278E-06,   4.1216849E-06,   4.6267460E-06
     +,   5.1738675E-06,   5.7636248E-06,   6.3961706E-06
     +,   7.0711985E-06,   7.7879231E-06,   8.5450829E-06
     +,   9.3409608E-06,   1.0173460E-05,   1.1040214E-05
     +,   1.1938749E-05,   1.2866731E-05,   1.3822295E-05
     +,   1.4804436E-05,   1.5813528E-05,   1.6851904E-05
     +,   1.7924500E-05,   1.9039582E-05,   2.0209449E-05
     +,   2.1451120E-05,   2.2786990E-05,   2.4245368E-05
     +,   2.5860983E-05,   2.7675496E-05,   2.9738132E-05
     +,   3.2106680E-05,   3.4849050E-05,   3.8045808E-05
     +,   4.1793937E-05,   4.6211066E-05,   5.1443589E-05
     +,   5.7672798E-05,   6.5124710E-05,   7.4080512E-05
     +,   8.4886524E-05,   9.7970180E-05,   1.1385523E-04
     +,   1.3318070E-04,   1.5672574E-04,   1.8541513E-04
     +,   2.2032377E-04,   2.6263221E-04,   3.1353338E-04
     +,   3.7407567E-04,   4.4493197E-04,   5.2618259E-04
     +,   6.1706890E-04,   7.1587955E-04,   8.1996544E-04
     +,   9.2589029E-04,   1.0297504E-03,   1.1275075E-03
     +,   1.2153219E-03,   1.2898466E-03,   1.3484135E-03
     +,   1.3892706E-03,   1.4117865E-03,   1.4166788E-03
     +,   1.4061736E-03,   1.3840074E-03,   1.3552016E-03
     +,   1.3255931E-03,   1.3011913E-03,   1.2874347E-03
     +,   1.2884403E-03,   1.3062906E-03,   1.3404338E-03
     +,   1.3873565E-03,   1.4407946E-03,   1.4927898E-03
     +,   1.5357605E-03,   1.5652657E-03,   1.5825612E-03
     +,   1.5955914E-03,   1.6173007E-03,   1.6611816E-03
     +,   1.7355415E-03,   1.8390359E-03,   1.9598485E-03
     +,   2.0792221E-03,   2.1777984E-03,   2.2417663E-03
     +,   2.2660589E-03,   2.2537147E-03,   2.2127137E-03
     +,   2.1526555E-03,   2.0830184E-03,   2.0129851E-03
     +,   1.9515054E-03,   1.9062853E-03,   1.8817075E-03
     +,   1.8769343E-03,   1.8856071E-03,   1.8975070E-03
     +,   1.9013364E-03,   1.8872916E-03,   1.8485637E-03
     +,   1.7817336E-03,   1.6865407E-03,   1.5654997E-03
     +,   1.4234402E-03,   1.2669745E-03,   1.1037509E-03
     +,   9.4155414E-04,   7.8742451E-04,   6.4694788E-04
     +,   5.2383955E-04,   4.1983795E-04,   3.3487589E-04
     +,   2.6747418E-04,   2.1521440E-04,   1.7525291E-04
     +,   1.4476394E-04,   1.2123739E-04,   1.0264849E-04
     +,   8.7490967E-05,   7.4731230E-05,   6.3711268E-05
     +,   5.4041273E-05,   4.5503246E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_nwao_fus_115 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_nwao_fus_120(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  9.6317184E-23,   1.4797402E-22
     +,   2.2680794E-22,   3.4683566E-22,   5.2914775E-22
     +,   8.0541785E-22,   1.2230850E-21,   1.8530397E-21
     +,   2.8009301E-21,   4.2238891E-21,   6.3549253E-21
     +,   9.5389273E-21,   1.4284981E-20,   2.1342693E-20
     +,   3.1813376E-20,   4.7310931E-20,   7.0194689E-20
     +,   1.0390537E-19,   1.5344801E-19,   2.2608697E-19
     +,   3.3233806E-19,   4.8738991E-19,   7.1311959E-19
     +,   1.0409804E-18,   1.5160368E-18,   2.2027683E-18
     +,   3.1931347E-18,   4.6180393E-18,   6.6632699E-18
     +,   9.5919789E-18,   1.3775877E-17,   1.9738867E-17
     +,   2.8217298E-17,   4.0243872E-17,   5.7262915E-17
     +,   8.1290202E-17,   1.1513147E-16,   1.6268254E-16
     +,   2.2933912E-16,   3.2255565E-16,   4.5260888E-16
     +,   6.3363025E-16,   8.8497775E-16,   1.2331755E-15
     +,   1.7143787E-15,   2.3778195E-15,   3.2903370E-15
     +,   4.5424890E-15,   6.2565873E-15,   8.5974852E-15
     +,   1.1786815E-14,   1.6121731E-14,   2.1999805E-14
     +,   2.9951278E-14,   4.0682295E-14,   5.5129617E-14
     +,   7.4533763E-14,   1.0053420E-13,   1.3528924E-13
     +,   1.8163711E-13,   2.4329659E-13,   3.2513125E-13
     +,   4.3348249E-13,   5.7660110E-13,   7.6519048E-13
     +,   1.0131058E-12,   1.3382286E-12,   1.7635867E-12
     +,   2.3187504E-12,   3.0415952E-12,   3.9805169E-12
     +,   5.1971955E-12,   6.7700025E-12,   8.7983032E-12
     +,   1.1407805E-11,   1.4756869E-11,   1.9044811E-11
     +,   2.4521654E-11,   3.1500032E-11,   4.0370617E-11
     +,   5.1619094E-11,   6.5848535E-11,   8.3806448E-11
     +,   1.0641293E-10,   1.3480249E-10,   1.7037284E-10
     +,   2.1482702E-10,   2.7025202E-10,   3.3918701E-10
     +,   4.2471790E-10,   5.3058158E-10,   6.6129424E-10
     +,   8.2229507E-10,   1.0201199E-09,   1.2626002E-09
     +,   1.5590897E-09,   1.9207311E-09,   2.3607671E-09
     +,   2.8948761E-09,   3.5415864E-09,   4.3227129E-09
     +,   5.2638751E-09,   6.3950654E-09,   7.7513205E-09
     +,   9.3733936E-09,   1.1308596E-08,   1.3611662E-08
     +,   1.6345853E-08,   1.9583547E-08,   2.3407901E-08
     +,   2.7914552E-08,   3.3211357E-08,   3.9421465E-08
     +,   4.6684207E-08,   5.5156605E-08,   6.5015378E-08
     +,   7.6458377E-08,   8.9706710E-08,   1.0500632E-07
     +,   1.2262998E-07,   1.4287893E-07,   1.6608512E-07
     +,   1.9261225E-07,   2.2285771E-07,   2.5725399E-07
     +,   2.9626969E-07,   3.4041051E-07,   3.9021998E-07
     +,   4.4627924E-07,   5.0920710E-07,   5.7965951E-07
     +,   6.5832751E-07,   7.4593635E-07,   8.4324222E-07
     +,   9.5102826E-07,   1.0701023E-06,   1.2012898E-06
     +,   1.3454292E-06,   1.5033661E-06,   1.6759432E-06
     +,   1.8639938E-06,   2.0683319E-06,   2.2897430E-06
     +,   2.5289719E-06,   2.7867100E-06,   3.0635999E-06
     +,   3.3601566E-06,   3.6768922E-06,   4.0141304E-06
     +,   4.3721252E-06,   4.7509930E-06,   5.1507077E-06
     +,   5.5710875E-06,   6.0117904E-06,   6.4722963E-06
     +,   6.9519006E-06,   7.4497098E-06,   7.9646352E-06
     +,   8.4953854E-06,   9.0404674E-06,   9.5981914E-06
     +,   1.0166666E-05,   1.0743813E-05,   1.1327366E-05
     +,   1.1914893E-05,   1.2503800E-05,   1.3091352E-05
     +,   1.3674698E-05,   1.4250878E-05,   1.4816882E-05
     +,   1.5369580E-05,   1.5905884E-05,   1.6422671E-05
     +,   1.6916909E-05,   1.7385588E-05,   1.7825758E-05
     +,   1.8234645E-05,   1.8609611E-05,   1.8948207E-05
     +,   1.9248188E-05,   1.9507546E-05,   1.9724535E-05
     +,   1.9897690E-05,   2.0025858E-05,   2.0108204E-05
     +,   2.0144253E-05,   2.0133886E-05,   2.0077403E-05
     +,   1.9975518E-05,   1.9829435E-05,   1.9640884E-05
     +,   1.9412202E-05,   1.9146444E-05,   1.8847491E-05
     +,   1.8520235E-05,   1.8170762E-05,   1.7806613E-05
     +,   1.7437058E-05,   1.7073427E-05,   1.6729504E-05
     +,   1.6421907E-05,   1.6170561E-05,   1.5999174E-05
     +,   1.5935786E-05,   1.6013386E-05,   1.6270620E-05
     +,   1.6752685E-05,   1.7512404E-05,   1.8611563E-05
     +,   2.0122636E-05,   2.2130296E-05,   2.4734238E-05
     +,   2.8050421E-05,   3.2213011E-05,   3.7375081E-05
     +,   4.3706499E-05,   5.1391409E-05,   6.0620270E-05
     +,   7.1578463E-05,   8.4433887E-05,   9.9314588E-05
     +,   1.1629616E-04,   1.3538600E-04,   1.5652001E-04
     +,   1.7957558E-04,   2.0439929E-04,   2.3087172E-04
     +,   2.5897103E-04,   2.8885808E-04,   3.2094592E-04
     +,   3.5592585E-04,   3.9474724E-04,   4.3850471E-04
     +,   4.8825060E-04,   5.4476148E-04,   6.0825876E-04
     +,   6.7822594E-04,   7.5330725E-04,   8.3137932E-04
     +,   9.0977462E-04,   9.8561076E-04,   1.0561212E-03
     +,   1.1188849E-03,   1.1718854E-03,   1.2134059E-03
     +,   1.2418728E-03,   1.2558242E-03,   1.2541974E-03
     +,   1.2370474E-03,   1.2066368E-03,   1.1685920E-03
     +,   1.1325638E-03,   1.1117242E-03,   1.1205733E-03
     +,   1.1710842E-03,   1.2680663E-03,   1.4054650E-03
     +,   1.5655897E-03,   1.7225645E-03,   1.8496264E-03
     +,   1.9279310E-03,   1.9533359E-03,   1.9380488E-03
     +,   1.9061598E-03,   1.8848190E-03,   1.8948010E-03
     +,   1.9441691E-03,   2.0269842E-03,   2.1265610E-03
     +,   2.2211785E-03,   2.2899706E-03,   2.3175438E-03
     +,   2.2967299E-03,   2.2292479E-03,   2.1242413E-03
     +,   1.9950450E-03,   1.8551279E-03,   1.7147009E-03
     +,   1.5791983E-03,   1.4497789E-03,   1.3252259E-03
     +,   1.2039487E-03,   1.0853014E-03,   9.6987525E-04
     +,   8.5909764E-04,   7.5460668E-04,   6.5776432E-04
     +,   5.6943105E-04,   4.8996002E-04,   4.1929868E-04
     +,   3.5712525E-04,   3.0293202E-04,   2.5609345E-04
     +,   2.1591586E-04,   1.8165738E-04,   1.5256666E-04
     +,   1.2790844E-04,   1.0700220E-04,   8.9246729E-05
     +,   7.4134150E-05,   6.1251027E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_nwao_fus_120 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_nwao_fus_60(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  2.4399200E-05,   2.5794887E-05
     +,   2.7249640E-05,   2.8764896E-05,   3.0342060E-05
     +,   3.1982505E-05,   3.3687564E-05,   3.5458514E-05
     +,   3.7296559E-05,   3.9202867E-05,   4.1178384E-05
     +,   4.3224070E-05,   4.5340712E-05,   4.7528942E-05
     +,   4.9789222E-05,   5.2121817E-05,   5.4526783E-05
     +,   5.7003948E-05,   5.9552822E-05,   6.2172679E-05
     +,   6.4862434E-05,   6.7620662E-05,   7.0445596E-05
     +,   7.3335075E-05,   7.6286342E-05,   7.9296398E-05
     +,   8.2361650E-05,   8.5478088E-05,   8.8641100E-05
     +,   9.1845577E-05,   9.5085867E-05,   9.8355791E-05
     +,   1.0164855E-04,   1.0495688E-04,   1.0827288E-04
     +,   1.1158818E-04,   1.1489390E-04,   1.1818068E-04
     +,   1.2143870E-04,   1.2465779E-04,   1.2782737E-04
     +,   1.3093671E-04,   1.3397456E-04,   1.3693003E-04
     +,   1.3979163E-04,   1.4254828E-04,   1.4518884E-04
     +,   1.4770245E-04,   1.5007859E-04,   1.5230710E-04
     +,   1.5437837E-04,   1.5628348E-04,   1.5801423E-04
     +,   1.5956312E-04,   1.6092381E-04,   1.6209080E-04
     +,   1.6305977E-04,   1.6382756E-04,   1.6439227E-04
     +,   1.6475328E-04,   1.6491130E-04,   1.6486838E-04
     +,   1.6462796E-04,   1.6419480E-04,   1.6357507E-04
     +,   1.6277617E-04,   1.6180672E-04,   1.6067666E-04
     +,   1.5939688E-04,   1.5797940E-04,   1.5643703E-04
     +,   1.5478340E-04,   1.5303284E-04,   1.5120012E-04
     +,   1.4930038E-04,   1.4734907E-04,   1.4536158E-04
     +,   1.4335335E-04,   1.4133951E-04,   1.3933478E-04
     +,   1.3735342E-04,   1.3540911E-04,   1.3351451E-04
     +,   1.3168185E-04,   1.2992209E-04,   1.2824497E-04
     +,   1.2665951E-04,   1.2517328E-04,   1.2379272E-04
     +,   1.2252301E-04,   1.2136815E-04,   1.2033081E-04
     +,   1.1941257E-04,   1.1861380E-04,   1.1793378E-04
     +,   1.1737075E-04,   1.1692200E-04,   1.1658395E-04
     +,   1.1635228E-04,   1.1622203E-04,   1.1618757E-04
     +,   1.1624295E-04,   1.1638182E-04,   1.1659759E-04
     +,   1.1688357E-04,   1.1723309E-04,   1.1763947E-04
     +,   1.1809629E-04,   1.1859726E-04,   1.1913649E-04
     +,   1.1970846E-04,   1.2030803E-04,   1.2093054E-04
     +,   1.2157181E-04,   1.2222817E-04,   1.2289641E-04
     +,   1.2357387E-04,   1.2425832E-04,   1.2494798E-04
     +,   1.2564147E-04,   1.2633779E-04,   1.2703621E-04
     +,   1.2773622E-04,   1.2843759E-04,   1.2914013E-04
     +,   1.2984370E-04,   1.3054824E-04,   1.3125353E-04
     +,   1.3195924E-04,   1.3266489E-04,   1.3336970E-04
     +,   1.3407269E-04,   1.3477248E-04,   1.3546748E-04
     +,   1.3615561E-04,   1.3683454E-04,   1.3750154E-04
     +,   1.3815355E-04,   1.3878723E-04,   1.3939884E-04
     +,   1.3998452E-04,   1.4054019E-04,   1.4106155E-04
     +,   1.4154431E-04,   1.4198413E-04,   1.4237668E-04
     +,   1.4271779E-04,   1.4300355E-04,   1.4323012E-04
     +,   1.4339418E-04,   1.4349268E-04,   1.4352301E-04
     +,   1.4348309E-04,   1.4337138E-04,   1.4318684E-04
     +,   1.4292913E-04,   1.4259841E-04,   1.4219554E-04
     +,   1.4172195E-04,   1.4117968E-04,   1.4057140E-04
     +,   1.3990031E-04,   1.3917017E-04,   1.3838518E-04
     +,   1.3755003E-04,   1.3666977E-04,   1.3574980E-04
     +,   1.3479579E-04,   1.3381364E-04,   1.3280938E-04
     +,   1.3178920E-04,   1.3075928E-04,   1.2972580E-04
     +,   1.2869478E-04,   1.2767219E-04,   1.2666386E-04
     +,   1.2567533E-04,   1.2471189E-04,   1.2377849E-04
     +,   1.2287979E-04,   1.2202006E-04,   1.2120310E-04
     +,   1.2043240E-04,   1.1971090E-04,   1.1904113E-04
     +,   1.1842511E-04,   1.1786435E-04,   1.1735985E-04
     +,   1.1691215E-04,   1.1652119E-04,   1.1618639E-04
     +,   1.1590665E-04,   1.1568036E-04,   1.1550532E-04
     +,   1.1537883E-04,   1.1529770E-04,   1.1525818E-04
     +,   1.1525606E-04,   1.1528665E-04,   1.1534478E-04
     +,   1.1542492E-04,   1.1552108E-04,   1.1562697E-04
     +,   1.1573595E-04,   1.1584111E-04,   1.1593533E-04
     +,   1.1601134E-04,   1.1606172E-04,   1.1607901E-04
     +,   1.1605579E-04,   1.1598473E-04,   1.1585854E-04
     +,   1.1567027E-04,   1.1541317E-04,   1.1508082E-04
     +,   1.1466723E-04,   1.1416687E-04,   1.1357471E-04
     +,   1.1288632E-04,   1.1209778E-04,   1.1120598E-04
     +,   1.1020839E-04,   1.0910324E-04,   1.0788947E-04
     +,   1.0656673E-04,   1.0513562E-04,   1.0359720E-04
     +,   1.0195343E-04,   1.0020699E-04,   9.8361168E-05
     +,   9.6420110E-05,   9.4388372E-05,   9.2271206E-05
     +,   9.0074442E-05,   8.7804023E-05,   8.5466861E-05
     +,   8.3069899E-05,   8.0620448E-05,   7.8126010E-05
     +,   7.5594326E-05,   7.3033167E-05,   7.0450405E-05
     +,   6.7853878E-05,   6.5251326E-05,   6.2650368E-05
     +,   6.0058414E-05,   5.7482659E-05,   5.4930006E-05
     +,   5.2407016E-05,   4.9919916E-05,   4.7474521E-05
     +,   4.5076253E-05,   4.2730040E-05,   4.0440420E-05
     +,   3.8211438E-05,   3.6046658E-05,   3.3949182E-05
     +,   3.1921645E-05,   2.9966213E-05,   2.8084591E-05
     +,   2.6278060E-05,   2.4547468E-05,   2.2893260E-05
     +,   2.1315504E-05,   1.9813897E-05,   1.8387822E-05
     +,   1.7036333E-05,   1.5758218E-05,   1.4552010E-05
     +,   1.3416008E-05,   1.2348321E-05,   1.1346880E-05
     +,   1.0409472E-05,   9.5337627E-06,   8.7172957E-06
     +,   7.9576312E-06,   7.2522143E-06,   6.5983968E-06
     +,   5.9936151E-06,   5.4352558E-06,   4.9207920E-06
     +,   4.4476669E-06,   4.0133909E-06,   3.6155357E-06
     +,   3.2517371E-06,   2.9197108E-06,   2.6172534E-06
     +,   2.3422485E-06,   2.0926723E-06,   1.8665884E-06
     +,   1.6621823E-06,   1.4777188E-06,   1.3115460E-06
     +,   1.1621321E-06,   1.0280295E-06,   9.0789985E-07
     +,   8.0048005E-07,   7.0460061E-07,   6.1917751E-07
     +,   5.4320884E-07,   4.7577100E-07
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_nwao_fus_60 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_nwao_fus_65(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  4.2156198E-06,   4.5133988E-06
     +,   4.8272996E-06,   5.1577817E-06,   5.5052778E-06
     +,   5.8702030E-06,   6.2529389E-06,   6.6538378E-06
     +,   7.0732176E-06,   7.5113639E-06,   7.9684951E-06
     +,   8.4448111E-06,   8.9404530E-06,   9.4555071E-06
     +,   9.9900071E-06,   1.0543923E-05,   1.1117169E-05
     +,   1.1709588E-05,   1.2320960E-05,   1.2950990E-05
     +,   1.3599315E-05,   1.4265496E-05,   1.4949020E-05
     +,   1.5649315E-05,   1.6365682E-05,   1.7097402E-05
     +,   1.7843653E-05,   1.8603549E-05,   1.9376124E-05
     +,   2.0160349E-05,   2.0955124E-05,   2.1759282E-05
     +,   2.2571605E-05,   2.3390819E-05,   2.4215602E-05
     +,   2.5044588E-05,   2.5876374E-05,   2.6709535E-05
     +,   2.7542626E-05,   2.8374194E-05,   2.9202778E-05
     +,   3.0026955E-05,   3.0845244E-05,   3.1656316E-05
     +,   3.2458771E-05,   3.3251319E-05,   3.4032731E-05
     +,   3.4801844E-05,   3.5557587E-05,   3.6298985E-05
     +,   3.7025180E-05,   3.7735434E-05,   3.8429123E-05
     +,   3.9105787E-05,   3.9765113E-05,   4.0406907E-05
     +,   4.1031180E-05,   4.1638108E-05,   4.2228017E-05
     +,   4.2801421E-05,   4.3359010E-05,   4.3901644E-05
     +,   4.4430362E-05,   4.4946370E-05,   4.5451026E-05
     +,   4.5945857E-05,   4.6432520E-05,   4.6912806E-05
     +,   4.7388639E-05,   4.7862024E-05,   4.8335063E-05
     +,   4.8809921E-05,   4.9288810E-05,   4.9773957E-05
     +,   5.0267616E-05,   5.0771989E-05,   5.1289247E-05
     +,   5.1821484E-05,   5.2370709E-05,   5.2938827E-05
     +,   5.3527598E-05,   5.4138593E-05,   5.4773263E-05
     +,   5.5432785E-05,   5.6118144E-05,   5.6830217E-05
     +,   5.7569458E-05,   5.8336205E-05,   5.9130503E-05
     +,   5.9952177E-05,   6.0800794E-05,   6.1675695E-05
     +,   6.2576000E-05,   6.3500614E-05,   6.4448286E-05
     +,   6.5417575E-05,   6.6406923E-05,   6.7414672E-05
     +,   6.8439091E-05,   6.9478425E-05,   7.0530936E-05
     +,   7.1594914E-05,   7.2668772E-05,   7.3751042E-05
     +,   7.4840442E-05,   7.5935881E-05,   7.7036602E-05
     +,   7.8142133E-05,   7.9252197E-05,   8.0367034E-05
     +,   8.1487349E-05,   8.2614017E-05,   8.3748535E-05
     +,   8.4892781E-05,   8.6049084E-05,   8.7220214E-05
     +,   8.8409324E-05,   8.9620029E-05,   9.0856251E-05
     +,   9.2122260E-05,   9.3422619E-05,   9.4762116E-05
     +,   9.6145646E-05,   9.7578217E-05,   9.9064833E-05
     +,   1.0061040E-04,   1.0221962E-04,   1.0389694E-04
     +,   1.0564639E-04,   1.0747149E-04,   1.0937524E-04
     +,   1.1135982E-04,   1.1342669E-04,   1.1557637E-04
     +,   1.1780840E-04,   1.2012121E-04,   1.2251214E-04
     +,   1.2497723E-04,   1.2751132E-04,   1.3010796E-04
     +,   1.3275935E-04,   1.3545637E-04,   1.3818867E-04
     +,   1.4094460E-04,   1.4371131E-04,   1.4647495E-04
     +,   1.4922021E-04,   1.5193166E-04,   1.5459229E-04
     +,   1.5718497E-04,   1.5969200E-04,   1.6209537E-04
     +,   1.6437698E-04,   1.6651899E-04,   1.6850379E-04
     +,   1.7031426E-04,   1.7193420E-04,   1.7334823E-04
     +,   1.7454222E-04,   1.7550345E-04,   1.7622064E-04
     +,   1.7668428E-04,   1.7688681E-04,   1.7682258E-04
     +,   1.7648806E-04,   1.7588197E-04,   1.7500528E-04
     +,   1.7386119E-04,   1.7245534E-04,   1.7079547E-04
     +,   1.6889177E-04,   1.6675649E-04,   1.6440399E-04
     +,   1.6185045E-04,   1.5911377E-04,   1.5621400E-04
     +,   1.5317215E-04,   1.5001059E-04,   1.4675281E-04
     +,   1.4342304E-04,   1.4004612E-04,   1.3664724E-04
     +,   1.3325168E-04,   1.2988462E-04,   1.2657083E-04
     +,   1.2333448E-04,   1.2019895E-04,   1.1718661E-04
     +,   1.1431857E-04,   1.1161460E-04,   1.0909287E-04
     +,   1.0676979E-04,   1.0466006E-04,   1.0277633E-04
     +,   1.0112926E-04,   9.9727411E-05,   9.8577264E-05
     +,   9.7683107E-05,   9.7047057E-05,   9.6669100E-05
     +,   9.6547177E-05,   9.6677169E-05,   9.7052995E-05
     +,   9.7666700E-05,   9.8508666E-05,   9.9567551E-05
     +,   1.0083057E-04,   1.0228357E-04,   1.0391130E-04
     +,   1.0569742E-04,   1.0762453E-04,   1.0967501E-04
     +,   1.1183038E-04,   1.1407186E-04,   1.1638070E-04
     +,   1.1873776E-04,   1.2112438E-04,   1.2352211E-04
     +,   1.2591285E-04,   1.2827947E-04,   1.3060491E-04
     +,   1.3287341E-04,   1.3506995E-04,   1.3718056E-04
     +,   1.3919229E-04,   1.4109317E-04,   1.4287274E-04
     +,   1.4452144E-04,   1.4603106E-04,   1.4739454E-04
     +,   1.4860595E-04,   1.4966064E-04,   1.5055505E-04
     +,   1.5128670E-04,   1.5185428E-04,   1.5225723E-04
     +,   1.5249613E-04,   1.5257226E-04,   1.5248783E-04
     +,   1.5224553E-04,   1.5184886E-04,   1.5130182E-04
     +,   1.5060877E-04,   1.4977460E-04,   1.4880441E-04
     +,   1.4770363E-04,   1.4647783E-04,   1.4513270E-04
     +,   1.4367401E-04,   1.4210759E-04,   1.4043920E-04
     +,   1.3867454E-04,   1.3681929E-04,   1.3487897E-04
     +,   1.3285894E-04,   1.3076450E-04,   1.2860076E-04
     +,   1.2637266E-04,   1.2408501E-04,   1.2174245E-04
     +,   1.1934949E-04,   1.1691052E-04,   1.1442979E-04
     +,   1.1191144E-04,   1.0935952E-04,   1.0677800E-04
     +,   1.0417075E-04,   1.0154162E-04,   9.8894408E-05
     +,   9.6232827E-05,   9.3560629E-05,   9.0881462E-05
     +,   8.8199042E-05,   8.5516978E-05,   8.2838829E-05
     +,   8.0168400E-05,   7.7509292E-05,   7.4864831E-05
     +,   7.2238632E-05,   6.9634058E-05,   6.7054731E-05
     +,   6.4503860E-05,   6.1984691E-05,   5.9500384E-05
     +,   5.7053963E-05,   5.4648342E-05,   5.2286294E-05
     +,   4.9970444E-05,   4.7703248E-05,   4.5486911E-05
     +,   4.3323718E-05,   4.1215590E-05,   3.9164050E-05
     +,   3.7170725E-05,   3.5236822E-05,   3.3363620E-05
     +,   3.1551921E-05,   2.9802393E-05,   2.8115524E-05
     +,   2.6491572E-05,   2.4930618E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_nwao_fus_65 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_nwao_fus_70(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  7.3537881E-10,   8.8026492E-10
     +,   1.0520412E-09,   1.2553649E-09,   1.4956300E-09
     +,   1.7790830E-09,   2.1129312E-09,   2.5054878E-09
     +,   2.9663112E-09,   3.5063865E-09,   4.1382724E-09
     +,   4.8763598E-09,   5.7370606E-09,   6.7390933E-09
     +,   7.9036928E-09,   9.2550057E-09,   1.0820333E-08
     +,   1.2630540E-08,   1.4720431E-08,   1.7129203E-08
     +,   1.9900813E-08,   2.3084576E-08,   2.6735631E-08
     +,   3.0915640E-08,   3.5692882E-08,   4.1143640E-08
     +,   4.7352316E-08,   5.4412304E-08,   6.2426722E-08
     +,   7.1509142E-08,   8.1784272E-08,   9.3388934E-08
     +,   1.0647279E-07,   1.2119909E-07,   1.3774556E-07
     +,   1.5630506E-07,   1.7708686E-07,   2.0031658E-07
     +,   2.2623753E-07,   2.5511167E-07,   2.8721905E-07
     +,   3.2286022E-07,   3.6235275E-07,   4.0603911E-07
     +,   4.5427683E-07,   5.0744751E-07,   5.6595104E-07
     +,   6.3020826E-07,   7.0065920E-07,   7.7776320E-07
     +,   8.6199606E-07,   9.5385121E-07,   1.0538378E-06
     +,   1.1624769E-06,   1.2803056E-06,   1.4078607E-06
     +,   1.5456943E-06,   1.6943580E-06,   1.8544062E-06
     +,   2.0263874E-06,   2.2108454E-06,   2.4083106E-06
     +,   2.6192995E-06,   2.8443080E-06,   3.0838060E-06
     +,   3.3382344E-06,   3.6079982E-06,   3.8934622E-06
     +,   4.1949475E-06,   4.5127204E-06,   4.8469951E-06
     +,   5.1979237E-06,   5.5655928E-06,   5.9500212E-06
     +,   6.3511661E-06,   6.7688761E-06,   7.2029557E-06
     +,   7.6531187E-06,   8.1189937E-06,   8.6001564E-06
     +,   9.0960793E-06,   9.6061767E-06,   1.0129820E-05
     +,   1.0666253E-05,   1.1214716E-05,   1.1774483E-05
     +,   1.2344666E-05,   1.2924467E-05,   1.3513074E-05
     +,   1.4109712E-05,   1.4713658E-05,   1.5324285E-05
     +,   1.5941076E-05,   1.6563659E-05,   1.7191849E-05
     +,   1.7825680E-05,   1.8465445E-05,   1.9111734E-05
     +,   1.9765492E-05,   2.0428035E-05,   2.1101123E-05
     +,   2.1786977E-05,   2.2488348E-05,   2.3208528E-05
     +,   2.3951407E-05,   2.4721492E-05,   2.5523947E-05
     +,   2.6364625E-05,   2.7249947E-05,   2.8187076E-05
     +,   2.9183962E-05,   3.0248935E-05,   3.1391075E-05
     +,   3.2619948E-05,   3.3945580E-05,   3.5378333E-05
     +,   3.6928839E-05,   3.8607810E-05,   4.0425915E-05
     +,   4.2393622E-05,   4.4520988E-05,   4.6817429E-05
     +,   4.9291571E-05,   5.1950989E-05,   5.4801967E-05
     +,   5.7849273E-05,   6.1095998E-05,   6.4543259E-05
     +,   6.8190071E-05,   7.2033166E-05,   7.6066855E-05
     +,   8.0282938E-05,   8.4670697E-05,   8.9216825E-05
     +,   9.3905561E-05,   9.8718752E-05,   1.0363608E-04
     +,   1.0863524E-04,   1.1369229E-04,   1.1878202E-04
     +,   1.2387821E-04,   1.2895424E-04,   1.3398344E-04
     +,   1.3893958E-04,   1.4379740E-04,   1.4853319E-04
     +,   1.5312436E-04,   1.5755191E-04,   1.6179806E-04
     +,   1.6584869E-04,   1.6969250E-04,   1.7332144E-04
     +,   1.7673062E-04,   1.7991831E-04,   1.8288565E-04
     +,   1.8563654E-04,   1.8817736E-04,   1.9051628E-04
     +,   1.9266317E-04,   1.9462887E-04,   1.9642482E-04
     +,   1.9806263E-04,   1.9955350E-04,   2.0090779E-04
     +,   2.0213489E-04,   2.0324274E-04,   2.0423766E-04
     +,   2.0512438E-04,   2.0590593E-04,   2.0658375E-04
     +,   2.0715772E-04,   2.0762687E-04,   2.0798905E-04
     +,   2.0824188E-04,   2.0838270E-04,   2.0840917E-04
     +,   2.0831965E-04,   2.0811350E-04,   2.0779150E-04
     +,   2.0735603E-04,   2.0681151E-04,   2.0616413E-04
     +,   2.0542234E-04,   2.0459671E-04,   2.0369980E-04
     +,   2.0274616E-04,   2.0175205E-04,   2.0073525E-04
     +,   1.9971472E-04,   1.9871033E-04,   1.9774256E-04
     +,   1.9683193E-04,   1.9599889E-04,   1.9526314E-04
     +,   1.9464352E-04,   1.9415744E-04,   1.9382050E-04
     +,   1.9364638E-04,   1.9364631E-04,   1.9382872E-04
     +,   1.9419938E-04,   1.9476090E-04,   1.9551271E-04
     +,   1.9645120E-04,   1.9756948E-04,   1.9885774E-04
     +,   2.0030345E-04,   2.0189161E-04,   2.0360507E-04
     +,   2.0542528E-04,   2.0733230E-04,   2.0930616E-04
     +,   2.1132681E-04,   2.1337502E-04,   2.1543303E-04
     +,   2.1748501E-04,   2.1951771E-04,   2.2152069E-04
     +,   2.2348703E-04,   2.2541343E-04,   2.2729953E-04
     +,   2.2914897E-04,   2.3096814E-04,   2.3276647E-04
     +,   2.3455539E-04,   2.3634774E-04,   2.3815723E-04
     +,   2.3999692E-04,   2.4187910E-04,   2.4381370E-04
     +,   2.4580737E-04,   2.4786338E-04,   2.4997978E-04
     +,   2.5214974E-04,   2.5436093E-04,   2.5659468E-04
     +,   2.5882683E-04,   2.6102757E-04,   2.6316178E-04
     +,   2.6519015E-04,   2.6706955E-04,   2.6875449E-04
     +,   2.7019787E-04,   2.7135285E-04,   2.7217343E-04
     +,   2.7261648E-04,   2.7264241E-04,   2.7221671E-04
     +,   2.7131083E-04,   2.6990302E-04,   2.6797896E-04
     +,   2.6553226E-04,   2.6256454E-04,   2.5908547E-04
     +,   2.5511227E-04,   2.5066949E-04,   2.4578813E-04
     +,   2.4050473E-04,   2.3486056E-04,   2.2890035E-04
     +,   2.2267121E-04,   2.1622166E-04,   2.0960030E-04
     +,   2.0285483E-04,   1.9603125E-04,   1.8917283E-04
     +,   1.8231958E-04,   1.7550756E-04,   1.6876860E-04
     +,   1.6213006E-04,   1.5561472E-04,   1.4924083E-04
     +,   1.4302225E-04,   1.3696887E-04,   1.3108658E-04
     +,   1.2537870E-04,   1.1984535E-04,   1.1448377E-04
     +,   1.0929019E-04,   1.0425903E-04,   9.9384539E-05
     +,   9.4659823E-05,   9.0078160E-05,   8.5633052E-05
     +,   8.1318496E-05,   7.7129233E-05,   7.3060764E-05
     +,   6.9109527E-05,   6.5272907E-05,   6.1549028E-05
     +,   5.7937377E-05,   5.4437874E-05,   5.1050793E-05
     +,   4.7777434E-05,   4.4619195E-05,   4.1578103E-05
     +,   3.8655893E-05,   3.5854406E-05,   3.3175322E-05
     +,   3.0620038E-05,   2.8189595E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_nwao_fus_70 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_nwao_fus_75(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  3.1446630E-15,   4.4772484E-15
     +,   6.3570606E-15,   9.0014056E-15,   1.2710759E-14
     +,   1.7899487E-14,   2.5137248E-14,   3.5204949E-14
     +,   4.9169714E-14,   6.8486056E-14,   9.5128651E-14
     +,   1.3177389E-13,   1.8203521E-13,   2.5077797E-13
     +,   3.4453357E-13,   4.7204309E-13,   6.4497024E-13
     +,   8.7883027E-13,   1.1942058E-12,   1.6183088E-12
     +,   2.1870184E-12,   2.9474793E-12,   3.9614770E-12
     +,   5.3097544E-12,   7.0973756E-12,   9.4608028E-12
     +,   1.2576724E-11,   1.6673024E-11,   2.2042975E-11
     +,   2.9062582E-11,   3.8212520E-11,   5.0105635E-11
     +,   6.5520096E-11,   8.5442119E-11,   1.1111614E-10
     +,   1.4410913E-10,   1.8638614E-10,   2.4040564E-10
     +,   3.0923233E-10,   3.9667383E-10,   5.0744808E-10
     +,   6.4738231E-10,   8.2363494E-10,   1.0450153E-09
     +,   1.3222645E-09,   1.6684909E-09,   2.0996151E-09
     +,   2.6349138E-09,   3.2976439E-09,   4.1157833E-09
     +,   5.1228728E-09,   6.3589742E-09,   7.8717912E-09
     +,   9.7179287E-09,   1.1964387E-08,   1.4689975E-08
     +,   1.7987382E-08,   2.1965077E-08,   2.6749548E-08
     +,   3.2487808E-08,   3.9350173E-08,   4.7533184E-08
     +,   5.7262849E-08,   6.8798165E-08,   8.2435065E-08
     +,   9.8509936E-08,   1.1740465E-07,   1.3955020E-07
     +,   1.6543197E-07,   1.9559447E-07,   2.3064644E-07
     +,   2.7126549E-07,   3.1820457E-07,   3.7229557E-07
     +,   4.3445760E-07,   5.0569633E-07,   5.8711646E-07
     +,   6.7992301E-07,   7.8542462E-07,   9.0504801E-07
     +,   1.0403298E-06,   1.1929295E-06,   1.3646401E-06
     +,   1.5573642E-06,   1.7731511E-06,   2.0142222E-06
     +,   2.2828904E-06,   2.5816562E-06,   2.9131704E-06
     +,   3.2802491E-06,   3.6858773E-06,   4.1332228E-06
     +,   4.6256414E-06,   5.1666821E-06,   5.7600982E-06
     +,   6.4098604E-06,   7.1201562E-06,   7.8954054E-06
     +,   8.7402532E-06,   9.6595913E-06,   1.0658540E-05
     +,   1.1742455E-05,   1.2916906E-05,   1.4187666E-05
     +,   1.5560689E-05,   1.7042061E-05,   1.8637982E-05
     +,   2.0354739E-05,   2.2198377E-05,   2.4174948E-05
     +,   2.6290565E-05,   2.8550485E-05,   3.0959854E-05
     +,   3.3523134E-05,   3.6244037E-05,   3.9125360E-05
     +,   4.2168831E-05,   4.5374934E-05,   4.8742753E-05
     +,   5.2269785E-05,   5.5951812E-05,   5.9782797E-05
     +,   6.3754720E-05,   6.7857509E-05,   7.2079056E-05
     +,   7.6405151E-05,   8.0819540E-05,   8.5304011E-05
     +,   8.9838533E-05,   9.4401483E-05,   9.8969896E-05
     +,   1.0351972E-04,   1.0802625E-04,   1.1246456E-04
     +,   1.1680986E-04,   1.2103814E-04,   1.2512674E-04
     +,   1.2905475E-04,   1.3280381E-04,   1.3635863E-04
     +,   1.3970747E-04,   1.4284287E-04,   1.4576217E-04
     +,   1.4846781E-04,   1.5096783E-04,   1.5327630E-04
     +,   1.5541280E-04,   1.5740359E-04,   1.5928023E-04
     +,   1.6108010E-04,   1.6284545E-04,   1.6462286E-04
     +,   1.6646224E-04,   1.6841567E-04,   1.7053616E-04
     +,   1.7287626E-04,   1.7548619E-04,   1.7841246E-04
     +,   1.8169590E-04,   1.8537018E-04,   1.8946003E-04
     +,   1.9397975E-04,   1.9893219E-04,   2.0430742E-04
     +,   2.1008257E-04,   2.1622123E-04,   2.2267397E-04
     +,   2.2937877E-04,   2.3626249E-04,   2.4324251E-04
     +,   2.5022766E-04,   2.5712239E-04,   2.6382779E-04
     +,   2.7024615E-04,   2.7628208E-04,   2.8184545E-04
     +,   2.8685579E-04,   2.9124328E-04,   2.9495120E-04
     +,   2.9793795E-04,   3.0017787E-04,   3.0166231E-04
     +,   3.0239939E-04,   3.0241418E-04,   3.0174735E-04
     +,   3.0045459E-04,   2.9860434E-04,   2.9627650E-04
     +,   2.9355954E-04,   2.9054924E-04,   2.8734541E-04
     +,   2.8405027E-04,   2.8076582E-04,   2.7759169E-04
     +,   2.7462348E-04,   2.7195076E-04,   2.6965555E-04
     +,   2.6781106E-04,   2.6648090E-04,   2.6571791E-04
     +,   2.6556448E-04,   2.6605179E-04,   2.6720038E-04
     +,   2.6902065E-04,   2.7151336E-04,   2.7467048E-04
     +,   2.7847651E-04,   2.8290908E-04,   2.8793988E-04
     +,   2.9353608E-04,   2.9965921E-04,   3.0626840E-04
     +,   3.1331761E-04,   3.2075666E-04,   3.2853111E-04
     +,   3.3657989E-04,   3.4483668E-04,   3.5322789E-04
     +,   3.6167185E-04,   3.7008044E-04,   3.7835550E-04
     +,   3.8639316E-04,   3.9408309E-04,   4.0131068E-04
     +,   4.0795933E-04,   4.1391255E-04,   4.1905892E-04
     +,   4.2329333E-04,   4.2652147E-04,   4.2866255E-04
     +,   4.2965182E-04,   4.2944343E-04,   4.2801132E-04
     +,   4.2535015E-04,   4.2147483E-04,   4.1642069E-04
     +,   4.1024046E-04,   4.0300362E-04,   3.9479230E-04
     +,   3.8569962E-04,   3.7582614E-04,   3.6527705E-04
     +,   3.5415927E-04,   3.4257965E-04,   3.3064259E-04
     +,   3.1844858E-04,   3.0609319E-04,   2.9366632E-04
     +,   2.8125211E-04,   2.6892856E-04,   2.5676802E-04
     +,   2.4483696E-04,   2.3319657E-04,   2.2190253E-04
     +,   2.1100551E-04,   2.0055081E-04,   1.9057833E-04
     +,   1.8112219E-04,   1.7221054E-04,   1.6386512E-04
     +,   1.5610094E-04,   1.4892610E-04,   1.4234141E-04
     +,   1.3634059E-04,   1.3091037E-04,   1.2603065E-04
     +,   1.2167512E-04,   1.1781188E-04,   1.1440407E-04
     +,   1.1141089E-04,   1.0878847E-04,   1.0649079E-04
     +,   1.0447083E-04,   1.0268130E-04,   1.0107570E-04
     +,   9.9609286E-05,   9.8239463E-05,   9.6926517E-05
     +,   9.5634357E-05,   9.4330615E-05,   9.2987219E-05
     +,   9.1580165E-05,   9.0089889E-05,   8.8501096E-05
     +,   8.6802604E-05,   8.4987259E-05,   8.3051578E-05
     +,   8.0995458E-05,   7.8821860E-05,   7.6536344E-05
     +,   7.4147072E-05,   7.1663970E-05,   6.9098271E-05
     +,   6.6462744E-05,   6.3770793E-05,   6.1036677E-05
     +,   5.8274556E-05,   5.5498655E-05,   5.2722939E-05
     +,   4.9960872E-05,   4.7225287E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_nwao_fus_75 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_nwao_fus_80(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  6.5819081E-06,   6.7288292E-06
     +,   6.8757217E-06,   7.0224501E-06,   7.1688778E-06
     +,   7.3148672E-06,   7.4602781E-06,   7.6049714E-06
     +,   7.7488085E-06,   7.8916555E-06,   8.0333666E-06
     +,   8.1738090E-06,   8.3128516E-06,   8.4503590E-06
     +,   8.5862048E-06,   8.7202652E-06,   8.8524175E-06
     +,   8.9825471E-06,   9.1105430E-06,   9.2362989E-06
     +,   9.3597191E-06,   9.4807083E-06,   9.5991863E-06
     +,   9.7150814E-06,   9.8283144E-06,   9.9388380E-06
     +,   1.0046601E-05,   1.0151570E-05,   1.0253716E-05
     +,   1.0353028E-05,   1.0449503E-05,   1.0543155E-05
     +,   1.0634004E-05,   1.0722091E-05,   1.0807470E-05
     +,   1.0890210E-05,   1.0970387E-05,   1.1048105E-05
     +,   1.1123478E-05,   1.1196632E-05,   1.1267716E-05
     +,   1.1336894E-05,   1.1404338E-05,   1.1470253E-05
     +,   1.1534846E-05,   1.1598349E-05,   1.1661008E-05
     +,   1.1723084E-05,   1.1784858E-05,   1.1846629E-05
     +,   1.1908702E-05,   1.1971410E-05,   1.2035094E-05
     +,   1.2100113E-05,   1.2166838E-05,   1.2235657E-05
     +,   1.2306968E-05,   1.2381187E-05,   1.2458739E-05
     +,   1.2540057E-05,   1.2625597E-05,   1.2715813E-05
     +,   1.2811173E-05,   1.2912155E-05,   1.3019242E-05
     +,   1.3132925E-05,   1.3253704E-05,   1.3382078E-05
     +,   1.3518552E-05,   1.3663633E-05,   1.3817833E-05
     +,   1.3981659E-05,   1.4155617E-05,   1.4340209E-05
     +,   1.4535940E-05,   1.4743295E-05,   1.4962758E-05
     +,   1.5194802E-05,   1.5439882E-05,   1.5698453E-05
     +,   1.5970934E-05,   1.6257738E-05,   1.6559257E-05
     +,   1.6875825E-05,   1.7207774E-05,   1.7555447E-05
     +,   1.7919067E-05,   1.8298884E-05,   1.8695093E-05
     +,   1.9107838E-05,   1.9537243E-05,   1.9983368E-05
     +,   2.0446236E-05,   2.0925827E-05,   2.1422065E-05
     +,   2.1934846E-05,   2.2463993E-05,   2.3009317E-05
     +,   2.3570572E-05,   2.4147481E-05,   2.4739733E-05
     +,   2.5346993E-05,   2.5968908E-05,   2.6605119E-05
     +,   2.7255248E-05,   2.7918944E-05,   2.8595861E-05
     +,   2.9285724E-05,   2.9988187E-05,   3.0703046E-05
     +,   3.1430234E-05,   3.2169588E-05,   3.2921151E-05
     +,   3.3685050E-05,   3.4461522E-05,   3.5250912E-05
     +,   3.6053738E-05,   3.6870628E-05,   3.7702375E-05
     +,   3.8549937E-05,   3.9414401E-05,   4.0297036E-05
     +,   4.1199273E-05,   4.2122712E-05,   4.3069085E-05
     +,   4.4040302E-05,   4.5038410E-05,   4.6065608E-05
     +,   4.7124264E-05,   4.8216873E-05,   4.9346105E-05
     +,   5.0514824E-05,   5.1726031E-05,   5.2983014E-05
     +,   5.4289299E-05,   5.5648710E-05,   5.7065503E-05
     +,   5.8544341E-05,   6.0090475E-05,   6.1709798E-05
     +,   6.3408996E-05,   6.5195622E-05,   6.7078297E-05
     +,   6.9066758E-05,   7.1172071E-05,   7.3406751E-05
     +,   7.5784410E-05,   7.8320867E-05,   8.1032740E-05
     +,   8.3938590E-05,   8.7058150E-05,   9.0412359E-05
     +,   9.4023009E-05,   9.7912438E-05,   1.0210295E-04
     +,   1.0661648E-04,   1.1147366E-04,   1.1669336E-04
     +,   1.2229173E-04,   1.2828159E-04,   1.3467137E-04
     +,   1.4146455E-04,   1.4865871E-04,   1.5624511E-04
     +,   1.6420805E-04,   1.7252449E-04,   1.8116421E-04
     +,   1.9008969E-04,   1.9925649E-04,   2.0861445E-04
     +,   2.1810699E-04,   2.2767461E-04,   2.3725424E-04
     +,   2.4678314E-04,   2.5619799E-04,   2.6543724E-04
     +,   2.7444435E-04,   2.8316799E-04,   2.9156366E-04
     +,   2.9959495E-04,   3.0723418E-04,   3.1446284E-04
     +,   3.2127131E-04,   3.2765878E-04,   3.3363205E-04
     +,   3.3920447E-04,   3.4439459E-04,   3.4922449E-04
     +,   3.5371826E-04,   3.5790069E-04,   3.6179629E-04
     +,   3.6542790E-04,   3.6881739E-04,   3.7198549E-04
     +,   3.7495286E-04,   3.7774167E-04,   3.8037758E-04
     +,   3.8289194E-04,   3.8532415E-04,   3.8772347E-04
     +,   3.9015131E-04,   3.9268125E-04,   3.9539952E-04
     +,   3.9840263E-04,   4.0179535E-04,   4.0568577E-04
     +,   4.1018042E-04,   4.1537682E-04,   4.2135720E-04
     +,   4.2818073E-04,   4.3587552E-04,   4.4443618E-04
     +,   4.5381614E-04,   4.6392778E-04,   4.7464282E-04
     +,   4.8579392E-04,   4.9718370E-04,   5.0859118E-04
     +,   5.1978172E-04,   5.3052092E-04,   5.4058217E-04
     +,   5.4976146E-04,   5.5788585E-04,   5.6482077E-04
     +,   5.7047576E-04,   5.7480467E-04,   5.7780714E-04
     +,   5.7952135E-04,   5.8001920E-04,   5.7939760E-04
     +,   5.7776854E-04,   5.7524949E-04,   5.7195517E-04
     +,   5.6798919E-04,   5.6343735E-04,   5.5836682E-04
     +,   5.5282167E-04,   5.4682588E-04,   5.4038549E-04
     +,   5.3349225E-04,   5.2612979E-04,   5.1827822E-04
     +,   5.0992012E-04,   5.0104462E-04,   4.9165223E-04
     +,   4.8175504E-04,   4.7138016E-04,   4.6056882E-04
     +,   4.4937461E-04,   4.3786180E-04,   4.2610228E-04
     +,   4.1417265E-04,   4.0215038E-04,   3.9011147E-04
     +,   3.7812660E-04,   3.6626015E-04,   3.5456772E-04
     +,   3.4309513E-04,   3.3187834E-04,   3.2094313E-04
     +,   3.1030597E-04,   2.9997449E-04,   2.8994872E-04
     +,   2.8022245E-04,   2.7078416E-04,   2.6161855E-04
     +,   2.5270760E-04,   2.4403131E-04,   2.3556915E-04
     +,   2.2730062E-04,   2.1920573E-04,   2.1126588E-04
     +,   2.0346422E-04,   1.9578592E-04,   1.8821823E-04
     +,   1.8075189E-04,   1.7337974E-04,   1.6609662E-04
     +,   1.5890105E-04,   1.5179363E-04,   1.4477817E-04
     +,   1.3785990E-04,   1.3104628E-04,   1.2434644E-04
     +,   1.1777069E-04,   1.1133037E-04,   1.0503724E-04
     +,   9.8903292E-05,   9.2940223E-05,   8.7159024E-05
     +,   8.1570513E-05,   7.6183904E-05,   7.1006696E-05
     +,   6.6045650E-05,   6.1305531E-05,   5.6790104E-05
     +,   5.2500953E-05,   4.8438320E-05,   4.4600965E-05
     +,   4.0986266E-05,   3.7590376E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_nwao_fus_80 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_nwao_fus_85(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  2.4980628E-14,   3.3580506E-14
     +,   4.5045876E-14,   6.0298798E-14,   8.0546640E-14
     +,   1.0736675E-13,   1.4281682E-13,   1.8957148E-13
     +,   2.5110431E-13,   3.3191158E-13,   4.3780030E-13
     +,   5.7625486E-13,   7.5690387E-13,   9.9209454E-13
     +,   1.2976352E-12,   1.6937153E-12,   2.2060485E-12
     +,   2.8673329E-12,   3.7190229E-12,   4.8135749E-12
     +,   6.2172160E-12,   8.0133261E-12,   1.0306673E-11
     +,   1.3228666E-11,   1.6943433E-11,   2.1655887E-11
     +,   2.7621119E-11,   3.5155816E-11,   4.4652275E-11
     +,   5.6595471E-11,   7.1583163E-11,   9.0350796E-11
     +,   1.1380078E-10,   1.4303786E-10,   1.7941106E-10
     +,   2.2456441E-10,   2.8049546E-10,   3.4962666E-10
     +,   4.3488771E-10,   5.3981469E-10,   6.6866279E-10
     +,   8.2654539E-10,   1.0195724E-09,   1.2550742E-09
     +,   1.5417537E-09,   1.8899800E-09,   2.3120483E-09
     +,   2.8225027E-09,   3.4385010E-09,   4.1802592E-09
     +,   5.0714881E-09,   6.1399863E-09,   7.4182100E-09
     +,   8.9439780E-09,   1.0761304E-08,   1.2921065E-08
     +,   1.5482224E-08,   1.8512722E-08,   2.2090708E-08
     +,   2.6305832E-08,   3.1260644E-08,   3.7072137E-08
     +,   4.3873445E-08,   5.1815608E-08,   6.1069585E-08
     +,   7.1828275E-08,   8.4308624E-08,   9.8754178E-08
     +,   1.1543739E-07,   1.3466206E-07,   1.5676628E-07
     +,   1.8212486E-07,   2.1115189E-07,   2.4430418E-07
     +,   2.8208419E-07,   3.2503968E-07,   3.7377120E-07
     +,   4.2893097E-07,   4.9122491E-07,   5.6142028E-07
     +,   6.4033856E-07,   7.2886257E-07,   8.2794003E-07
     +,   9.3856710E-07,   1.0618070E-06,   1.1988006E-06
     +,   1.3507135E-06,   1.5187884E-06,   1.7043141E-06
     +,   1.9086265E-06,   2.1331025E-06,   2.3791526E-06
     +,   2.6482169E-06,   2.9417506E-06,   3.2612186E-06
     +,   3.6080794E-06,   3.9837773E-06,   4.3897271E-06
     +,   4.8272937E-06,   5.2977875E-06,   5.8024357E-06
     +,   6.3423745E-06,   6.9186217E-06,   7.5320663E-06
     +,   8.1834432E-06,   8.8733195E-06,   9.6020667E-06
     +,   1.0369888E-05,   1.1176657E-05,   1.2022067E-05
     +,   1.2905665E-05,   1.3826506E-05,   1.4783504E-05
     +,   1.5775244E-05,   1.6800004E-05,   1.7855757E-05
     +,   1.8940167E-05,   2.0050584E-05,   2.1184056E-05
     +,   2.2337339E-05,   2.3506902E-05,   2.4688941E-05
     +,   2.5879419E-05,   2.7074058E-05,   2.8268390E-05
     +,   2.9457788E-05,   3.0637475E-05,   3.1802596E-05
     +,   3.2948232E-05,   3.4069461E-05,   3.5161385E-05
     +,   3.6219182E-05,   3.7238169E-05,   3.8213831E-05
     +,   3.9141873E-05,   4.0018265E-05,   4.0839292E-05
     +,   4.1601590E-05,   4.2302207E-05,   4.2938602E-05
     +,   4.3508699E-05,   4.4010936E-05,   4.4444245E-05
     +,   4.4808086E-05,   4.5102483E-05,   4.5327986E-05
     +,   4.5485678E-05,   4.5577213E-05,   4.5604716E-05
     +,   4.5570836E-05,   4.5478671E-05,   4.5331741E-05
     +,   4.5133958E-05,   4.4889548E-05,   4.4603028E-05
     +,   4.4279124E-05,   4.3922730E-05,   4.3538814E-05
     +,   4.3132379E-05,   4.2708380E-05,   4.2271648E-05
     +,   4.1826857E-05,   4.1378415E-05,   4.0930445E-05
     +,   4.0486699E-05,   4.0050520E-05,   3.9624796E-05
     +,   3.9211925E-05,   3.8813803E-05,   3.8431761E-05
     +,   3.8066632E-05,   3.7718699E-05,   3.7387748E-05
     +,   3.7073052E-05,   3.6773523E-05,   3.6487778E-05
     +,   3.6214187E-05,   3.5951110E-05,   3.5697056E-05
     +,   3.5450976E-05,   3.5212579E-05,   3.4982757E-05
     +,   3.4764096E-05,   3.4561519E-05,   3.4383032E-05
     +,   3.4240584E-05,   3.4151137E-05,   3.4137738E-05
     +,   3.4230816E-05,   3.4469424E-05,   3.4902532E-05
     +,   3.5590201E-05,   3.6604495E-05,   3.8030008E-05
     +,   3.9963845E-05,   4.2514843E-05,   4.5801811E-05
     +,   4.9950788E-05,   5.5091205E-05,   6.1351042E-05
     +,   6.8851303E-05,   7.7700293E-05,   8.7988141E-05
     +,   9.9782592E-05,   1.1312674E-04,   1.2803922E-04
     +,   1.4451763E-04,   1.6254497E-04,   1.8209909E-04
     +,   2.0316507E-04,   2.2574373E-04,   2.4987466E-04
     +,   2.7564060E-04,   3.0318566E-04,   3.3272887E-04
     +,   3.6457003E-04,   3.9910452E-04,   4.3681657E-04
     +,   4.7826124E-04,   5.2403234E-04,   5.7467166E-04
     +,   6.3058134E-04,   6.9187727E-04,   7.5824390E-04
     +,   8.2879752E-04,   9.0198475E-04,   9.7560545E-04
     +,   1.0468879E-03,   1.1127252E-03,   1.1699940E-03
     +,   1.2159219E-03,   1.2484647E-03,   1.2665790E-03
     +,   1.2703639E-03,   1.2610275E-03,   1.2406836E-03
     +,   1.2120195E-03,   1.1779056E-03,   1.1410237E-03
     +,   1.1035864E-03,   1.0671837E-03,   1.0327705E-03
     +,   1.0007645E-03,   9.7121263E-04,   9.4396394E-04
     +,   9.1880688E-04,   8.9554291E-04,   8.7399152E-04
     +,   8.5394486E-04,   8.3510409E-04,   8.1702432E-04
     +,   7.9910166E-04,   7.8060350E-04,   7.6074409E-04
     +,   7.3878793E-04,   7.1415585E-04,   6.8651506E-04
     +,   6.5583212E-04,   6.2238105E-04,   5.8670976E-04
     +,   5.4957025E-04,   5.1182864E-04,   4.7436889E-04
     +,   4.3800563E-04,   4.0341532E-04,   3.7109290E-04
     +,   3.4133441E-04,   3.1424445E-04,   2.8976132E-04
     +,   2.6769581E-04,   2.4777424E-04,   2.2968228E-04
     +,   2.1310241E-04,   1.9774400E-04,   1.8336305E-04
     +,   1.6977511E-04,   1.5685437E-04,   1.4452933E-04
     +,   1.3277624E-04,   1.2160449E-04,   1.1104637E-04
     +,   1.0114243E-04,   9.1933114E-05,   8.3450635E-05
     +,   7.5713680E-05,   6.8724694E-05,   6.2469306E-05
     +,   5.6917455E-05,   5.2025760E-05,   4.7740341E-05
     +,   4.4000906E-05,   4.0743136E-05,   3.7901824E-05
     +,   3.5414105E-05,   3.3220789E-05,   3.1268253E-05
     +,   2.9508858E-05,   2.7901709E-05,   2.6412617E-05
     +,   2.5013856E-05,   2.3683657E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_nwao_fus_85 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_nwao_fus_90(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  6.4568249E-09,   7.3646067E-09
     +,   8.3905256E-09,   9.5485619E-09,   1.0854148E-08
     +,   1.2324319E-08,   1.3977804E-08,   1.5835230E-08
     +,   1.7919199E-08,   2.0254593E-08,   2.2868420E-08
     +,   2.5790385E-08,   2.9052876E-08,   3.2691077E-08
     +,   3.6743323E-08,   4.1251219E-08,   4.6259888E-08
     +,   5.1818073E-08,   5.7978543E-08,   6.4798101E-08
     +,   7.2338025E-08,   8.0664094E-08,   8.9846893E-08
     +,   9.9962158E-08,   1.1109046E-07,   1.2331820E-07
     +,   1.3673726E-07,   1.5144525E-07,   1.6754585E-07
     +,   1.8514892E-07,   2.0437032E-07,   2.2533246E-07
     +,   2.4816418E-07,   2.7300078E-07,   2.9998390E-07
     +,   3.2926192E-07,   3.6098959E-07,   3.9532770E-07
     +,   4.3244344E-07,   4.7251004E-07,   5.1570635E-07
     +,   5.6221751E-07,   6.1222994E-07,   6.6594168E-07
     +,   7.2354743E-07,   7.8524977E-07,   8.5125339E-07
     +,   9.2176475E-07,   9.9699253E-07,   1.0771449E-06
     +,   1.1624307E-06,   1.2530570E-06,   1.3492289E-06
     +,   1.4511484E-06,   1.5590142E-06,   1.6730140E-06
     +,   1.7933327E-06,   1.9201480E-06,   2.0536243E-06
     +,   2.1939184E-06,   2.3411717E-06,   2.4955139E-06
     +,   2.6570581E-06,   2.8259017E-06,   3.0021224E-06
     +,   3.1857812E-06,   3.3769154E-06,   3.5755425E-06
     +,   3.7816567E-06,   3.9952270E-06,   4.2161982E-06
     +,   4.4444887E-06,   4.6799914E-06,   4.9225714E-06
     +,   5.1720699E-06,   5.4282877E-06,   5.6910108E-06
     +,   5.9599929E-06,   6.2349573E-06,   6.5156123E-06
     +,   6.8016298E-06,   7.0926590E-06,   7.3883366E-06
     +,   7.6882443E-06,   7.9919619E-06,   8.2990964E-06
     +,   8.6091595E-06,   8.9216974E-06,   9.2362370E-06
     +,   9.5522919E-06,   9.8693763E-06,   1.0186999E-05
     +,   1.0504665E-05,   1.0821895E-05,   1.1138207E-05
     +,   1.1453136E-05,   1.1766233E-05,   1.2077062E-05
     +,   1.2385213E-05,   1.2690304E-05,   1.2991975E-05
     +,   1.3289903E-05,   1.3583801E-05,   1.3873416E-05
     +,   1.4158544E-05,   1.4439021E-05,   1.4714721E-05
     +,   1.4985596E-05,   1.5251600E-05,   1.5512769E-05
     +,   1.5769227E-05,   1.6021086E-05,   1.6268556E-05
     +,   1.6511904E-05,   1.6751454E-05,   1.6987580E-05
     +,   1.7220736E-05,   1.7451426E-05,   1.7680226E-05
     +,   1.7907772E-05,   1.8134768E-05,   1.8361996E-05
     +,   1.8590297E-05,   1.8820589E-05,   1.9053863E-05
     +,   1.9291185E-05,   1.9533709E-05,   1.9782652E-05
     +,   2.0039330E-05,   2.0305135E-05,   2.0581547E-05
     +,   2.0870131E-05,   2.1172540E-05,   2.1490512E-05
     +,   2.1825866E-05,   2.2180504E-05,   2.2556398E-05
     +,   2.2955581E-05,   2.3380151E-05,   2.3832235E-05
     +,   2.4314000E-05,   2.4827605E-05,   2.5375197E-05
     +,   2.5958881E-05,   2.6580690E-05,   2.7242575E-05
     +,   2.7946229E-05,   2.8693375E-05,   2.9485282E-05
     +,   3.0323086E-05,   3.1207564E-05,   3.2139134E-05
     +,   3.3117787E-05,   3.4143068E-05,   3.5213998E-05
     +,   3.6329053E-05,   3.7486119E-05,   3.8682454E-05
     +,   3.9914670E-05,   4.1178690E-05,   4.2469768E-05
     +,   4.3782467E-05,   4.5110675E-05,   4.6447614E-05
     +,   4.7785888E-05,   4.9117523E-05,   5.0434028E-05
     +,   5.1726427E-05,   5.2985393E-05,   5.4201377E-05
     +,   5.5364504E-05,   5.6464967E-05,   5.7492980E-05
     +,   5.8439076E-05,   5.9294136E-05,   6.0049497E-05
     +,   6.0697490E-05,   6.1231542E-05,   6.1646584E-05
     +,   6.1939681E-05,   6.2110645E-05,   6.2163112E-05
     +,   6.2105792E-05,   6.1954241E-05,   6.1733059E-05
     +,   6.1478597E-05,   6.1242237E-05,   6.1094070E-05
     +,   6.1126826E-05,   6.1459694E-05,   6.2241612E-05
     +,   6.3653446E-05,   6.5908265E-05,   6.9249254E-05
     +,   7.3944524E-05,   8.0278733E-05,   8.8541754E-05
     +,   9.9014738E-05,   1.1195533E-04,   1.2758336E-04
     +,   1.4606887E-04,   1.6752428E-04,   1.9200140E-04
     +,   2.1949330E-04,   2.4993942E-04,   2.8323190E-04
     +,   3.1921960E-04,   3.5770709E-04,   3.9844777E-04
     +,   4.4113270E-04,   4.8536668E-04,   5.3067546E-04
     +,   5.7648733E-04,   6.2215852E-04,   6.6701358E-04
     +,   7.1039831E-04,   7.5177191E-04,   7.9079240E-04
     +,   8.2740607E-04,   8.6193008E-04,   8.9507789E-04
     +,   9.2796143E-04,   9.6200296E-04,   9.9877862E-04
     +,   1.0397841E-03,   1.0861428E-03,   1.1383310E-03
     +,   1.1959318E-03,   1.2575523E-03,   1.3209245E-03
     +,   1.3832134E-03,   1.4415234E-03,   1.4934511E-03
     +,   1.5375725E-03,   1.5737046E-03,   1.6028093E-03
     +,   1.6265749E-03,   1.6467180E-03,   1.6642370E-03
     +,   1.6788305E-03,   1.6886980E-03,   1.6908138E-03
     +,   1.6816319E-03,   1.6580380E-03,   1.6182788E-03
     +,   1.5626017E-03,   1.4934333E-03,   1.4150508E-03
     +,   1.3328500E-03,   1.2524272E-03,   1.1786931E-03
     +,   1.1152208E-03,   1.0639211E-03,   1.0250517E-03
     +,   9.9748268E-04,   9.7911432E-04,   9.6732978E-04
     +,   9.5940765E-04,   9.5284381E-04,   9.4556465E-04
     +,   9.3603827E-04,   9.2329603E-04,   9.0688537E-04
     +,   8.8677503E-04,   8.6323457E-04,   8.3670876E-04
     +,   8.0770906E-04,   7.7673059E-04,   7.4420613E-04
     +,   7.1049150E-04,   6.7587639E-04,   6.4061111E-04
     +,   6.0493482E-04,   5.6909799E-04,   5.3337030E-04
     +,   4.9804460E-04,   4.6341453E-04,   4.2975589E-04
     +,   3.9731266E-04,   3.6627325E-04,   3.3676773E-04
     +,   3.0885841E-04,   2.8255131E-04,   2.5780723E-04
     +,   2.3455691E-04,   2.1271629E-04,   1.9220119E-04
     +,   1.7293701E-04,   1.5486559E-04,   1.3794603E-04
     +,   1.2215656E-04,   1.0748666E-04,   9.3932162E-05
     +,   8.1492435E-05,   7.0162183E-05,   5.9929680E-05
     +,   5.0771123E-05,   4.2651198E-05,   3.5522600E-05
     +,   2.9327168E-05,   2.3997754E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_nwao_fus_90 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_nwao_fus_95(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  6.6751025E-34,   1.3952111E-33
     +,   2.9043358E-33,   6.0210551E-33,   1.2431474E-32
     +,   2.5561845E-32,   5.2346615E-32,   1.0675921E-31
     +,   2.1684344E-31,   4.3865194E-31,   8.8371164E-31
     +,   1.7730724E-30,   3.5429757E-30,   7.0507377E-30
     +,   1.3974221E-29,   2.7583494E-29,   5.4224642E-29
     +,   1.0616276E-28,   2.0700263E-28,   4.0198214E-28
     +,   7.7743995E-28,   1.4974695E-27,   2.8726150E-27
     +,   5.4882317E-27,   1.0442706E-26,   1.9788907E-26
     +,   3.7347806E-26,   7.0200288E-26,   1.3141501E-25
     +,   2.4500913E-25,   4.5494003E-25,   8.4131384E-25
     +,   1.5495145E-24,   2.8422944E-24,   5.1924698E-24
     +,   9.4474629E-24,   1.7119460E-23,   3.0895876E-23
     +,   5.5532444E-23,   9.9409809E-23,   1.7723381E-22
     +,   3.1470860E-22,   5.5653564E-22,   9.8022962E-22
     +,   1.7194591E-21,   3.0039676E-21,   5.2267891E-21
     +,   9.0576245E-21,   1.5632578E-20,   2.6871082E-20
     +,   4.6002018E-20,   7.8434804E-20,   1.3319252E-19
     +,   2.2526217E-19,   3.7943767E-19,   6.3654211E-19
     +,   1.0635362E-18,   1.7697664E-18,   2.9330540E-18
     +,   4.8413037E-18,   7.9587150E-18,   1.3030569E-17
     +,   2.1248212E-17,   3.4507990E-17,   5.5815726E-17
     +,   8.9914923E-17,   1.4425990E-16,   2.3051396E-16
     +,   3.6684891E-16,   5.8145397E-16,   9.1786925E-16
     +,   1.4430590E-15,   2.2595612E-15,   3.5237183E-15
     +,   5.4729242E-15,   8.4658250E-15,   1.3042336E-14
     +,   2.0011362E-14,   3.0579485E-14,   4.6539585E-14
     +,   7.0542049E-14,   1.0649001E-13,   1.6010694E-13
     +,   2.3973819E-13,   3.5751087E-13,   5.3099197E-13
     +,   7.8543752E-13,   1.1570867E-12,   1.6976587E-12
     +,   2.4806498E-12,   3.6100138E-12,   5.2321667E-12
     +,   7.5523589E-12,   1.0857028E-11,   1.5544125E-11
     +,   2.2163991E-11,   3.1474212E-11,   4.4512959E-11
     +,   6.2696404E-11,   8.7947288E-11,   1.2286393E-10
     +,   1.7094200E-10,   2.3686136E-10,   3.2685907E-10
     +,   4.4920703E-10,   6.1482525E-10,   8.3805951E-10
     +,   1.1376837E-09,   1.5380804E-09,   2.0708428E-09
     +,   2.7767786E-09,   3.7080399E-09,   4.9312985E-09
     +,   6.5311649E-09,   8.6145420E-09,   1.1315798E-08
     +,   1.4802948E-08,   1.9285054E-08,   2.5020869E-08
     +,   3.2328973E-08,   4.1599549E-08,   5.3307893E-08
     +,   6.8029934E-08,   8.6459650E-08,   1.0942858E-07
     +,   1.3792759E-07,   1.7313064E-07,   2.1642039E-07
     +,   2.6941603E-07,   3.3400164E-07,   4.1235666E-07
     +,   5.0698611E-07,   6.2074980E-07,   7.5689263E-07
     +,   9.1906924E-07,   1.1113680E-06,   1.3383278E-06
     +,   1.6049495E-06,   1.9166996E-06,   2.2795011E-06
     +,   2.6997177E-06,   3.1841168E-06,   3.7398288E-06
     +,   4.3742743E-06,   5.0950889E-06,   5.9100594E-06
     +,   6.8268164E-06,   7.8531157E-06,   8.9961341E-06
     +,   1.0262748E-05,   1.1659143E-05,   1.3190662E-05
     +,   1.4861614E-05,   1.6675071E-05,   1.8632694E-05
     +,   2.0734553E-05,   2.2978971E-05,   2.5362415E-05
     +,   2.7879398E-05,   3.0522475E-05,   3.3282220E-05
     +,   3.6147332E-05,   3.9104794E-05,   4.2140036E-05
     +,   4.5237288E-05,   4.8379887E-05,   5.1550698E-05
     +,   5.4732656E-05,   5.7909197E-05,   6.1065046E-05
     +,   6.4186213E-05,   6.7261361E-05,   7.0281756E-05
     +,   7.3242365E-05,   7.6141630E-05,   7.8981917E-05
     +,   8.1770260E-05,   8.4517982E-05,   8.7240813E-05
     +,   8.9958638E-05,   9.2695169E-05,   9.5477459E-05
     +,   9.8335287E-05,   1.0130050E-04,   1.0440619E-04
     +,   1.0768596E-04,   1.1117311E-04,   1.1489991E-04
     +,   1.1889690E-04,   1.2319231E-04,   1.2781148E-04
     +,   1.3277665E-04,   1.3810644E-04,   1.4381619E-04
     +,   1.4991786E-04,   1.5642110E-04,   1.6333487E-04
     +,   1.7067010E-04,   1.7844405E-04,   1.8668667E-04
     +,   1.9544903E-04,   2.0481397E-04,   2.1490802E-04
     +,   2.2591399E-04,   2.3808138E-04,   2.5173218E-04
     +,   2.6725844E-04,   2.8510811E-04,   3.0575672E-04
     +,   3.2966401E-04,   3.5721096E-04,   3.8864315E-04
     +,   4.2399287E-04,   4.6302768E-04,   5.0521863E-04
     +,   5.4973486E-04,   5.9550116E-04,   6.4128108E-04
     +,   6.8580837E-04,   7.2795193E-04,   7.6685828E-04
     +,   8.0210663E-04,   8.3378394E-04,   8.6249510E-04
     +,   8.8927196E-04,   9.1537402E-04,   9.4202306E-04
     +,   9.7007339E-04,   9.9972822E-04,   1.0303723E-03
     +,   1.0606081E-03,   1.0885660E-03,   1.1124702E-03
     +,   1.1313992E-03,   1.1460760E-03,   1.1594826E-03
     +,   1.1770941E-03,   1.2065450E-03,   1.2566636E-03
     +,   1.3359080E-03,   1.4503855E-03,   1.6017943E-03
     +,   1.7857328E-03,   1.9909272E-03,   2.1998894E-03
     +,   2.3912895E-03,   2.5438862E-03,   2.6412609E-03
     +,   2.6760635E-03,   2.6523136E-03,   2.5847328E-03
     +,   2.4950793E-03,   2.4065604E-03,   2.3382141E-03
     +,   2.3010559E-03,   2.2969118E-03,   2.3197827E-03
     +,   2.3586142E-03,   2.4002772E-03,   2.4319126E-03
     +,   2.4424740E-03,   2.4237016E-03,   2.3707892E-03
     +,   2.2828528E-03,   2.1630612E-03,   2.0182673E-03
     +,   1.8580951E-03,   1.6935819E-03,   1.5356358E-03
     +,   1.3935755E-03,   1.2739940E-03,   1.1801139E-03
     +,   1.1116877E-03,   1.0654180E-03,   1.0357859E-03
     +,   1.0161154E-03,   9.9966256E-04,   9.8055822E-04
     +,   9.5446617E-04,   9.1889146E-04,   8.7316585E-04
     +,   8.1816223E-04,   7.5586571E-04,   6.8888167E-04
     +,   6.1998388E-04,   5.5175257E-04,   4.8633222E-04
     +,   4.2531011E-04,   3.6969496E-04,   3.1996719E-04
     +,   2.7618371E-04,   2.3807999E-04,   2.0518413E-04
     +,   1.7692034E-04,   1.5267699E-04,   1.3186599E-04
     +,   1.1394954E-04,   9.8461351E-05,   8.5010244E-05
     +,   7.3276693E-05,   6.3004431E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_nwao_fus_95 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_nwao_hz_100(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  1.9972700E-14,   2.6459508E-14
     +,   3.4986930E-14,   4.6175113E-14,   6.0825775E-14
     +,   7.9973476E-14,   1.0495019E-13,   1.3746716E-13
     +,   1.7971830E-13,   2.3451312E-13,   3.0543409E-13
     +,   3.9705186E-13,   5.1517574E-13,   6.6717703E-13
     +,   8.6239593E-13,   1.1126265E-12,   1.4327555E-12
     +,   1.8415046E-12,   2.3623950E-12,   3.0248974E-12
     +,   3.8658729E-12,   4.9313153E-12,   6.2785224E-12
     +,   7.9787045E-12,   1.0120087E-11,   1.2811931E-11
     +,   1.6189161E-11,   2.0417957E-11,   2.5702765E-11
     +,   3.2294278E-11,   4.0499583E-11,   5.0693741E-11
     +,   6.3334060E-11,   7.8976700E-11,   9.8296885E-11
     +,   1.2211226E-10,   1.5141123E-10,   1.8738548E-10
     +,   2.3146891E-10,   2.8538330E-10,   3.5119127E-10
     +,   4.3135970E-10,   5.2882371E-10,   6.4709066E-10
     +,   7.9030871E-10,   9.6340125E-10,   1.1721877E-09
     +,   1.4235290E-09,   1.7254996E-09,   2.0875763E-09
     +,   2.5208649E-09,   3.0383351E-09,   3.6551162E-09
     +,   4.3887991E-09,   5.2598308E-09,   6.2918062E-09
     +,   7.5120488E-09,   8.9520116E-09,   1.0647862E-08
     +,   1.2641066E-08,   1.4979046E-08,   1.7715948E-08
     +,   2.0913369E-08,   2.4641274E-08,   2.8978887E-08
     +,   3.4015738E-08,   3.9852683E-08,   4.6603109E-08
     +,   5.4394111E-08,   6.3367757E-08,   7.3682486E-08
     +,   8.5514543E-08,   9.9059349E-08,   1.1453297E-07
     +,   1.3217411E-07,   1.5224420E-07,   1.7503093E-07
     +,   2.0084853E-07,   2.3003875E-07,   2.6297488E-07
     +,   3.0005944E-07,   3.4172766E-07,   3.8844988E-07
     +,   4.4072468E-07,   4.9908834E-07,   5.6412028E-07
     +,   6.3641966E-07,   7.1663055E-07,   8.0542833E-07
     +,   9.0352131E-07,   1.0116490E-06,   1.1305794E-06
     +,   1.2611087E-06,   1.4040534E-06,   1.5602521E-06
     +,   1.7305572E-06,   1.9158308E-06,   2.1169387E-06
     +,   2.3347454E-06,   2.5701047E-06,   2.8238535E-06
     +,   3.0968035E-06,   3.3897325E-06,   3.7033712E-06
     +,   4.0384007E-06,   4.3954351E-06,   4.7750145E-06
     +,   5.1776124E-06,   5.6035524E-06,   6.0530833E-06
     +,   6.5263989E-06,   7.0234451E-06,   7.5441108E-06
     +,   8.0881191E-06,   8.6550353E-06,   9.2442660E-06
     +,   9.8550508E-06,   1.0486454E-05,   1.1137367E-05
     +,   1.1806505E-05,   1.2492406E-05,   1.3193439E-05
     +,   1.3907808E-05,   1.4633551E-05,   1.5368569E-05
     +,   1.6110618E-05,   1.6857344E-05,   1.7606291E-05
     +,   1.8354933E-05,   1.9100680E-05,   1.9840938E-05
     +,   2.0573116E-05,   2.1294665E-05,   2.2003142E-05
     +,   2.2696202E-05,   2.3371702E-05,   2.4027704E-05
     +,   2.4662546E-05,   2.5274889E-05,   2.5863763E-05
     +,   2.6428645E-05,   2.6969499E-05,   2.7486825E-05
     +,   2.7981734E-05,   2.8455988E-05,   2.8912058E-05
     +,   2.9353101E-05,   2.9783194E-05,   3.0207089E-05
     +,   3.0630454E-05,   3.1059804E-05,   3.1502492E-05
     +,   3.1966712E-05,   3.2461459E-05,   3.2996486E-05
     +,   3.3582262E-05,   3.4229823E-05,   3.4950768E-05
     +,   3.5757068E-05,   3.6660978E-05,   3.7674865E-05
     +,   3.8811108E-05,   4.0081897E-05,   4.1499123E-05
     +,   4.3074218E-05,   4.4818044E-05,   4.6740821E-05
     +,   4.8851995E-05,   5.1160237E-05,   5.3673673E-05
     +,   5.6399324E-05,   5.9344031E-05,   6.2514038E-05
     +,   6.5915825E-05,   6.9555863E-05,   7.3440744E-05
     +,   7.7578530E-05,   8.1978425E-05,   8.6651438E-05
     +,   9.1610884E-05,   9.6872755E-05,   1.0245614E-04
     +,   1.0838361E-04,   1.1468132E-04,   1.2137921E-04
     +,   1.2851074E-04,   1.3611279E-04,   1.4422470E-04
     +,   1.5288766E-04,   1.6214309E-04,   1.7203105E-04
     +,   1.8258803E-04,   1.9384437E-04,   2.0582120E-04
     +,   2.1852732E-04,   2.3195545E-04,   2.4607897E-04
     +,   2.6084852E-04,   2.7618906E-04,   2.9199812E-04
     +,   3.0814466E-04,   3.2446993E-04,   3.4079002E-04
     +,   3.5690027E-04,   3.7258305E-04,   3.8761678E-04
     +,   4.0178874E-04,   4.1490915E-04,   4.2682746E-04
     +,   4.3745019E-04,   4.4675521E-04,   4.5481234E-04
     +,   4.6179083E-04,   4.6796951E-04,   4.7373775E-04
     +,   4.7958869E-04,   4.8610533E-04,   4.9393601E-04
     +,   5.0376373E-04,   5.1627046E-04,   5.3209212E-04
     +,   5.5178290E-04,   5.7577656E-04,   6.0436275E-04
     +,   6.3767808E-04,   6.7571411E-04,   7.1837410E-04
     +,   7.6553383E-04,   8.1715436E-04,   8.7340677E-04
     +,   9.3477970E-04,   1.0021642E-03,   1.0768184E-03
     +,   1.1601974E-03,   1.2536276E-03,   1.3577822E-03
     +,   1.4721575E-03,   1.5945715E-03,   1.7209423E-03
     +,   1.8454755E-03,   1.9613737E-03,   2.0620399E-03
     +,   2.1426240E-03,   2.2015900E-03,   2.2418718E-03
     +,   2.2711447E-03,   2.3008992E-03,   2.3443806E-03
     +,   2.4139718E-03,   2.5189978E-03,   2.6648797E-03
     +,   2.8539710E-03,   3.0874158E-03,   3.3666017E-03
     +,   3.6928011E-03,   4.0644929E-03,   4.4734823E-03
     +,   4.9018152E-03,   5.3211567E-03,   5.6949831E-03
     +,   5.9830453E-03,   6.1485753E-03,   6.1697769E-03
     +,   6.0547697E-03,   5.8530038E-03,   5.6510577E-03
     +,   5.5463566E-03,   5.6069493E-03,   5.8386135E-03
     +,   6.1791264E-03,   6.5233517E-03,   6.7652869E-03
     +,   6.8366067E-03,   6.7266556E-03,   6.4790086E-03
     +,   6.1681578E-03,   5.8658575E-03,   5.6112381E-03
     +,   5.3982185E-03,   5.1851687E-03,   4.9200612E-03
     +,   4.5660683E-03,   4.1155596E-03,   3.5891843E-03
     +,   3.0250293E-03,   2.4653892E-03,   1.9464715E-03
     +,   1.4929334E-03,   1.1167243E-03,   8.1879005E-04
     +,   5.9226347E-04,   4.2584396E-04,   3.0680760E-04
     +,   2.2315509E-04,   1.6476800E-04,   1.2383123E-04
     +,   9.4696581E-05,   7.3500167E-05,   5.7694444E-05
     +,   4.5630655E-05,   3.6239660E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_nwao_hz_100 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_nwao_hz_105(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  1.2057861E-20,   1.8275596E-20
     +,   2.7631215E-20,   4.1673117E-20,   6.2696219E-20
     +,   9.4092085E-20,   1.4086178E-19,   2.1035941E-19
     +,   3.1337275E-19,   4.6568511E-19,   6.9031769E-19
     +,   1.0207900E-18,   1.5057545E-18,   2.2156539E-18
     +,   3.2522260E-18,   4.7620267E-18,   6.9556038E-18
     +,   1.0134684E-17,   1.4730502E-17,   2.1357918E-17
     +,   3.0891083E-17,   4.4569970E-17,   6.4148571E-17
     +,   9.2101863E-17,   1.3191138E-16,   1.8846601E-16
     +,   2.6860950E-16,   3.8189539E-16,   5.4163628E-16
     +,   7.6631717E-16,   1.0815543E-15,   1.5227467E-15
     +,   2.1386824E-15,   2.9964464E-15,   4.1880130E-15
     +,   5.8391758E-15,   8.1215120E-15,   1.1268527E-14
     +,   1.5596951E-14,   2.1535635E-14,   2.9663402E-14
     +,   4.0759927E-14,   5.5870927E-14,   7.6399682E-14
     +,   1.0421799E-13,   1.4182163E-13,   1.9252701E-13
     +,   2.6073002E-13,   3.5224200E-13,   4.7472573E-13
     +,   6.3825843E-13,   8.5605806E-13,   1.1454166E-12
     +,   1.5288963E-12,   2.0358700E-12,   2.7044285E-12
     +,   3.5839086E-12,   4.7380021E-12,   6.2487233E-12
     +,   8.2213941E-12,   1.0790932E-11,   1.4129653E-11
     +,   1.8457132E-11,   2.4052375E-11,   3.1268890E-11
     +,   4.0553588E-11,   5.2469629E-11,   6.7725145E-11
     +,   8.7207637E-11,   1.1202724E-10,   1.4356782E-10
     +,   1.8355038E-10,   2.3410884E-10,   2.9788369E-10
     +,   3.7813219E-10,   4.7885584E-10,   6.0496752E-10
     +,   7.6247691E-10,   9.5870734E-10,   1.2025840E-09
     +,   1.5049171E-09,   1.8787882E-09,   2.3399958E-09
     +,   2.9074814E-09,   3.6039878E-09,   4.4568362E-09
     +,   5.4983840E-09,   6.7672596E-09,   8.3092120E-09
     +,   1.0178328E-08,   1.2438362E-08,   1.5164206E-08
     +,   1.8443632E-08,   2.2379151E-08,   2.7090174E-08
     +,   3.2715288E-08,   3.9414957E-08,   4.7374318E-08
     +,   5.6806350E-08,   6.7955284E-08,   8.1100360E-08
     +,   9.6559617E-08,   1.1469447E-07,   1.3591395E-07
     +,   1.6067985E-07,   1.8951121E-07,   2.2299024E-07
     +,   2.6176883E-07,   3.0656764E-07,   3.5818937E-07
     +,   4.1752907E-07,   4.8555790E-07,   5.6335290E-07
     +,   6.5208872E-07,   7.5304587E-07,   8.6761406E-07
     +,   9.9729664E-07,   1.1437127E-06,   1.3085994E-06
     +,   1.4938130E-06,   1.7013288E-06,   1.9332392E-06
     +,   2.1917506E-06,   2.4791798E-06,   2.7979465E-06
     +,   3.1505685E-06,   3.5396451E-06,   3.9678548E-06
     +,   4.4379331E-06,   4.9526593E-06,   5.5148403E-06
     +,   6.1272872E-06,   6.7927958E-06,   7.5141193E-06
     +,   8.2939478E-06,   9.1348729E-06,   1.0039366E-05
     +,   1.1009739E-05,   1.2048127E-05,   1.3156441E-05
     +,   1.4336351E-05,   1.5589236E-05,   1.6916176E-05
     +,   1.8317909E-05,   1.9794807E-05,   2.1346921E-05
     +,   2.2973622E-05,   2.4674342E-05,   2.6447578E-05
     +,   2.8291699E-05,   3.0204548E-05,   3.2183554E-05
     +,   3.4225748E-05,   3.6327780E-05,   3.8485974E-05
     +,   4.0696355E-05,   4.2954740E-05,   4.5256755E-05
     +,   4.7597969E-05,   4.9973914E-05,   5.2380219E-05
     +,   5.4812710E-05,   5.7267436E-05,   5.9740883E-05
     +,   6.2229941E-05,   6.4732070E-05,   6.7245375E-05
     +,   6.9768663E-05,   7.2301475E-05,   7.4844254E-05
     +,   7.7397955E-05,   7.9964637E-05,   8.2546903E-05
     +,   8.5148451E-05,   8.7773333E-05,   9.0425965E-05
     +,   9.3111419E-05,   9.5834948E-05,   9.8601791E-05
     +,   1.0141700E-04,   1.0428532E-04,   1.0721069E-04
     +,   1.1019626E-04,   1.1324397E-04,   1.1635438E-04
     +,   1.1952640E-04,   1.2275710E-04,   1.2604166E-04
     +,   1.2937322E-04,   1.3274301E-04,   1.3614050E-04
     +,   1.3955383E-04,   1.4297038E-04,   1.4637744E-04
     +,   1.4976354E-04,   1.5311975E-04,   1.5644108E-04
     +,   1.5972889E-04,   1.6299274E-04,   1.6625292E-04
     +,   1.6954289E-04,   1.7291140E-04,   1.7642476E-04
     +,   1.8016825E-04,   1.8424704E-04,   1.8878590E-04
     +,   1.9392809E-04,   1.9983319E-04,   2.0667397E-04
     +,   2.1463276E-04,   2.2389606E-04,   2.3465444E-04
     +,   2.4709752E-04,   2.6141584E-04,   2.7780372E-04
     +,   2.9646209E-04,   3.1760955E-04,   3.4148752E-04
     +,   3.6836416E-04,   3.9854023E-04,   4.3232593E-04
     +,   4.7003038E-04,   5.1191618E-04,   5.5814633E-04
     +,   6.0872134E-04,   6.6339597E-04,   7.2163704E-04
     +,   7.8255433E-04,   8.4489753E-04,   9.0708479E-04
     +,   9.6726889E-04,   1.0234767E-03,   1.0737627E-03
     +,   1.1163966E-03,   1.1500648E-03,   1.1740305E-03
     +,   1.1882944E-03,   1.1936767E-03,   1.1918446E-03
     +,   1.1852516E-03,   1.1769906E-03,   1.1705456E-03
     +,   1.1694643E-03,   1.1769676E-03,   1.1955521E-03
     +,   1.2266370E-03,   1.2703380E-03,   1.3254042E-03
     +,   1.3893590E-03,   1.4588233E-03,   1.5299883E-03
     +,   1.5991718E-03,   1.6634008E-03,   1.7209597E-03
     +,   1.7718396E-03,   1.8180083E-03,   1.8633606E-03
     +,   1.9132186E-03,   1.9732823E-03,   2.0481120E-03
     +,   2.1394566E-03,   2.2449601E-03,   2.3578580E-03
     +,   2.4680521E-03,   2.5644889E-03,   2.6381952E-03
     +,   2.6849017E-03,   2.7063238E-03,   2.7095557E-03
     +,   2.7048893E-03,   2.7029135E-03,   2.7119503E-03
     +,   2.7365198E-03,   2.7769697E-03,   2.8299021E-03
     +,   2.8888937E-03,   2.9452660E-03,   2.9888689E-03
     +,   3.0090755E-03,   2.9961215E-03,   2.9426059E-03
     +,   2.8447867E-03,   2.7032914E-03,   2.5230118E-03
     +,   2.3122677E-03,   2.0814911E-03,   1.8417937E-03
     +,   1.6036918E-03,   1.3761441E-03,   1.1659475E-03
     +,   9.7753340E-04,   8.1299723E-04,   6.7243056E-04
     +,   5.5444310E-04,   4.5667106E-04,   3.7630595E-04
     +,   3.1046980E-04,   2.5649735E-04,   2.1207622E-04
     +,   1.7529402E-04,   1.4462661E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_nwao_hz_105 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_nwao_hz_110(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  7.3843892E-15,   9.7422858E-15
     +,   1.2830292E-14,   1.6867075E-14,   2.2134601E-14
     +,   2.8995669E-14,   3.7916017E-14,   4.9492684E-14
     +,   6.4489545E-14,   8.3882066E-14,   1.0891198E-13
     +,   1.4115971E-13,   1.8263203E-13,   2.3586908E-13
     +,   3.0408542E-13,   3.9133703E-13,   5.0273067E-13
     +,   6.4468851E-13,   8.2526743E-13,   1.0545586E-12
     +,   1.3451677E-12,   1.7128244E-12,   2.1771133E-12
     +,   2.7623726E-12,   3.4987410E-12,   4.4235774E-12
     +,   5.5829811E-12,   7.0338206E-12,   8.8460394E-12
     +,   1.1105501E-11,   1.3917445E-11,   1.7410620E-11
     +,   2.1742099E-11,   2.7103276E-11,   3.3726851E-11
     +,   4.1895123E-11,   5.1949871E-11,   6.4304298E-11
     +,   7.9456670E-11,   9.8006415E-11,   1.2067422E-10
     +,   1.4832399E-10,   1.8198687E-10,   2.2289894E-10
     +,   2.7252811E-10,   3.3262151E-10,   4.0525383E-10
     +,   4.9287902E-10,   5.9840061E-10,   7.2523931E-10
     +,   8.7742302E-10,   1.0596839E-09,   1.2775624E-09
     +,   1.5375452E-09,   1.8472066E-09,   2.2153477E-09
     +,   2.6522213E-09,   3.1697045E-09,   3.7815489E-09
     +,   4.5036384E-09,   5.3542704E-09,   6.3544827E-09
     +,   7.5284330E-09,   8.9037657E-09,   1.0512061E-08
     +,   1.2389335E-08,   1.4576541E-08,   1.7120165E-08
     +,   2.0072868E-08,   2.3494092E-08,   2.7450927E-08
     +,   3.2018793E-08,   3.7282351E-08,   4.3336374E-08
     +,   5.0286896E-08,   5.8251644E-08,   6.7361967E-08
     +,   7.7763367E-08,   8.9616741E-08,   1.0310021E-07
     +,   1.1840957E-07,   1.3575965E-07,   1.5538717E-07
     +,   1.7754805E-07,   2.0252276E-07,   2.3062006E-07
     +,   2.6216784E-07,   2.9752530E-07,   3.3707894E-07
     +,   3.8124443E-07,   4.3046768E-07,   4.8522554E-07
     +,   5.4602634E-07,   6.1341098E-07,   6.8795231E-07
     +,   7.7025595E-07,   8.6095974E-07,   9.6073234E-07
     +,   1.0702739E-06,   1.1903136E-06,   1.3216087E-06
     +,   1.4649419E-06,   1.6211194E-06,   1.7909676E-06
     +,   1.9753295E-06,   2.1750623E-06,   2.3910304E-06
     +,   2.6241125E-06,   2.8751565E-06,   3.1450193E-06
     +,   3.4345817E-06,   3.7446332E-06,   4.0759828E-06
     +,   4.4293906E-06,   4.8055736E-06,   5.2051992E-06
     +,   5.6288673E-06,   6.0771163E-06,   6.5504009E-06
     +,   7.0490887E-06,   7.5734542E-06,   8.1236640E-06
     +,   8.6997707E-06,   9.3017052E-06,   9.9292729E-06
     +,   1.0582136E-05,   1.1259821E-05,   1.1961704E-05
     +,   1.2687003E-05,   1.3434783E-05,   1.4203955E-05
     +,   1.4993263E-05,   1.5801301E-05,   1.6626491E-05
     +,   1.7467120E-05,   1.8321312E-05,   1.9187060E-05
     +,   2.0062218E-05,   2.0944524E-05,   2.1831607E-05
     +,   2.2720998E-05,   2.3610160E-05,   2.4496485E-05
     +,   2.5377334E-05,   2.6250051E-05,   2.7112017E-05
     +,   2.7960505E-05,   2.8793085E-05,   2.9607159E-05
     +,   3.0400390E-05,   3.1170519E-05,   3.1915468E-05
     +,   3.2633321E-05,   3.3322380E-05,   3.3981181E-05
     +,   3.4608507E-05,   3.5203400E-05,   3.5765199E-05
     +,   3.6293524E-05,   3.6788304E-05,   3.7249771E-05
     +,   3.7678445E-05,   3.8075148E-05,   3.8440980E-05
     +,   3.8777311E-05,   3.9085724E-05,   3.9368053E-05
     +,   3.9626299E-05,   3.9862582E-05,   4.0079172E-05
     +,   4.0278373E-05,   4.0462550E-05,   4.0634033E-05
     +,   4.0795163E-05,   4.0948216E-05,   4.1095369E-05
     +,   4.1238804E-05,   4.1380637E-05,   4.1523035E-05
     +,   4.1668263E-05,   4.1818814E-05,   4.1977575E-05
     +,   4.2147996E-05,   4.2334363E-05,   4.2542080E-05
     +,   4.2778029E-05,   4.3050903E-05,   4.3371710E-05
     +,   4.3754168E-05,   4.4215205E-05,   4.4775450E-05
     +,   4.5459659E-05,   4.6297162E-05,   4.7322181E-05
     +,   4.8574118E-05,   5.0097584E-05,   5.1942392E-05
     +,   5.4163214E-05,   5.6819157E-05,   5.9972765E-05
     +,   6.3689004E-05,   6.8033783E-05,   7.3071998E-05
     +,   7.8865298E-05,   8.5469554E-05,   9.2931732E-05
     +,   1.0128674E-04,   1.1055405E-04,   1.2073408E-04
     +,   1.3180563E-04,   1.4372040E-04,   1.5640598E-04
     +,   1.6975975E-04,   1.8365166E-04,   1.9792594E-04
     +,   2.1240252E-04,   2.2688576E-04,   2.4116891E-04
     +,   2.5504251E-04,   2.6830664E-04,   2.8077434E-04
     +,   2.9228738E-04,   3.0272189E-04,   3.1199693E-04
     +,   3.2008183E-04,   3.2699967E-04,   3.3283557E-04
     +,   3.3773753E-04,   3.4192088E-04,   3.4567094E-04
     +,   3.4934201E-04,   3.5335548E-04,   3.5819024E-04
     +,   3.6436669E-04,   3.7242295E-04,   3.8287858E-04
     +,   3.9619603E-04,   4.1273533E-04,   4.3271310E-04
     +,   4.5617204E-04,   4.8296645E-04,   5.1277044E-04
     +,   5.4510788E-04,   5.7940109E-04,   6.1503163E-04
     +,   6.5140188E-04,   6.8799290E-04,   7.2440971E-04
     +,   7.6042005E-04,   7.9598348E-04,   8.3128101E-04
     +,   8.6673588E-04,   9.0301782E-04,   9.4100757E-04
     +,   9.8170224E-04,   1.0260405E-03,   1.0746629E-03
     +,   1.1276318E-03,   1.1841824E-03,   1.2425695E-03
     +,   1.3000974E-03,   1.3533476E-03,   1.3986110E-03
     +,   1.4324385E-03,   1.4522050E-03,   1.4565490E-03
     +,   1.4455845E-03,   1.4208310E-03,   1.3848807E-03
     +,   1.3408834E-03,   1.2919755E-03,   1.2407925E-03
     +,   1.1891492E-03,   1.1379482E-03,   1.0872920E-03
     +,   1.0367488E-03,   9.8565628E-04,   9.3341083E-04
     +,   8.7967818E-04,   8.2447234E-04,   7.6815183E-04
     +,   7.1131758E-04,   6.5470196E-04,   5.9904624E-04
     +,   5.4501323E-04,   4.9313583E-04,   4.4380402E-04
     +,   3.9727913E-04,   3.5372266E-04,   3.1322479E-04
     +,   2.7583609E-04,   2.4157352E-04,   2.1042637E-04
     +,   1.8236054E-04,   1.5730562E-04,   1.3515491E-04
     +,   1.1575640E-04,   9.8919438E-05,   8.4420419E-05
     +,   7.2013252E-05,   6.1442021E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_nwao_hz_110 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_nwao_hz_115(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   1.9613495E-38,   4.9881556E-38
     +,   1.2613723E-37,   3.1715494E-37,   7.9289906E-37
     +,   1.9709817E-36,   4.8716811E-36,   1.1972459E-35
     +,   2.9255629E-35,   7.1081592E-35,   1.7172088E-34
     +,   4.1248735E-34,   9.8518935E-34,   2.3396294E-33
     +,   5.5245380E-33,   1.2970693E-32,   3.0279956E-32
     +,   7.0285211E-32,   1.6221556E-31,   3.7225684E-31
     +,   8.4940103E-31,   1.9270934E-30,   4.3472309E-30
     +,   9.7508885E-30,   2.1746811E-29,   4.8224413E-29
     +,   1.0633219E-28,   2.3311894E-28,   5.0817154E-28
     +,   1.1014455E-27,   2.3737171E-27,   5.0865085E-27
     +,   1.0837659E-26,   2.2959696E-26,   4.8365423E-26
     +,   1.0129985E-25,   2.1095469E-25,   4.3683375E-25
     +,   8.9939698E-25,   1.8412234E-24,   3.7478592E-24
     +,   7.5853954E-24,   1.5264929E-23,   3.0544259E-23
     +,   6.0769540E-23,   1.2021647E-22,   2.3646135E-22
     +,   4.6246399E-22,   8.9932304E-22,   1.7388950E-21
     +,   3.3431248E-21,   6.3907239E-21,   1.2147004E-20
     +,   2.2956543E-20,   4.3138706E-20,   8.0602030E-20
     +,   1.4974298E-19,   2.7660935E-19,   5.0805087E-19
     +,   9.2785108E-19,   1.6848428E-18,   3.0419335E-18
     +,   5.4611283E-18,   9.7482152E-18,   1.7301627E-17
     +,   3.0533020E-17,   5.3576273E-17,   9.3475333E-17
     +,   1.6215862E-16,   2.7970852E-16,   4.7972219E-16
     +,   8.1807856E-16,   1.3871460E-15,   2.3386696E-15
     +,   3.9204590E-15,   6.5347084E-15,   1.0830173E-14
     +,   1.7847076E-14,   2.9242786E-14,   4.7642273E-14
     +,   7.7177055E-14,   1.2430985E-13,   1.9908788E-13
     +,   3.1703421E-13,   5.0198599E-13,   7.9031313E-13
     +,   1.2371746E-12,   1.9256957E-12,   2.9803551E-12
     +,   4.5864358E-12,   7.0179244E-12,   1.0677501E-11
     +,   1.6153204E-11,   2.4298390E-11,   3.6343525E-11
     +,   5.4051739E-11,   7.9933109E-11,   1.1754034E-10
     +,   1.7185889E-10,   2.4986851E-10,   3.6123413E-10
     +,   5.1929283E-10,   7.4231271E-10,   1.0551535E-09
     +,   1.4914325E-09,   2.0963049E-09,   2.9300509E-09
     +,   4.0725836E-09,   5.6292011E-09,   7.7377047E-09
     +,   1.0577269E-08,   1.4379373E-08,   1.9441108E-08
     +,   2.6141254E-08,   3.4959672E-08,   4.6500304E-08
     +,   6.1518286E-08,   8.0951850E-08,   1.0595887E-07
     +,   1.3795970E-07,   1.7868479E-07,   2.3023178E-07
     +,   2.9511691E-07,   3.7635473E-07,   4.7751871E-07
     +,   6.0283963E-07,   7.5727121E-07,   9.4656775E-07
     +,   1.1774075E-06,   1.4574629E-06,   1.7954909E-06
     +,   2.2014199E-06,   2.6864243E-06,   3.2629841E-06
     +,   3.9449269E-06,   4.7474432E-06,   5.6870676E-06
     +,   6.7816145E-06,   8.0500704E-06,   9.5124233E-06
     +,   1.1189409E-05,   1.3102207E-05,   1.5272019E-05
     +,   1.7719571E-05,   2.0464546E-05,   2.3524864E-05
     +,   2.6915959E-05,   3.0649921E-05,   3.4734629E-05
     +,   3.9172872E-05,   4.3961474E-05,   4.9090504E-05
     +,   5.4542590E-05,   6.0292481E-05,   6.6306740E-05
     +,   7.2543859E-05,   7.8954647E-05,   8.5483065E-05
     +,   9.2067443E-05,   9.8642187E-05,   1.0513985E-04
     +,   1.1149389E-04,   1.1764009E-04,   1.2352227E-04
     +,   1.2909259E-04,   1.3431595E-04,   1.3917280E-04
     +,   1.4366052E-04,   1.4779672E-04,   1.5161945E-04
     +,   1.5518755E-04,   1.5858081E-04,   1.6189672E-04
     +,   1.6524918E-04,   1.6876376E-04,   1.7257311E-04
     +,   1.7681127E-04,   1.8160611E-04,   1.8707453E-04
     +,   1.9331374E-04,   2.0039568E-04,   2.0836208E-04
     +,   2.1721931E-04,   2.2693913E-04,   2.3745827E-04
     +,   2.4868234E-04,   2.6049488E-04,   2.7276139E-04
     +,   2.8534443E-04,   2.9811211E-04,   3.1094768E-04
     +,   3.2375677E-04,   3.3647040E-04,   3.4904375E-04
     +,   3.6145060E-04,   3.7367409E-04,   3.8569598E-04
     +,   3.9748629E-04,   4.0899616E-04,   4.2015727E-04
     +,   4.3088748E-04,   4.4110473E-04,   4.5074645E-04
     +,   4.5979305E-04,   4.6828983E-04,   4.7636399E-04
     +,   4.8423233E-04,   4.9219653E-04,   5.0062581E-04
     +,   5.0992746E-04,   5.2050990E-04,   5.3274131E-04
     +,   5.4690958E-04,   5.6318921E-04,   5.8161496E-04
     +,   6.0206687E-04,   6.2426395E-04,   6.4776663E-04
     +,   6.7198504E-04,   6.9619209E-04,   7.1954256E-04
     +,   7.4109697E-04,   7.5985410E-04,   7.7479350E-04
     +,   7.8492524E-04,   7.8934990E-04,   7.8732288E-04
     +,   7.7831600E-04,   7.6207228E-04,   7.3864043E-04
     +,   7.0839387E-04,   6.7201618E-04,   6.3047226E-04
     +,   5.8493792E-04,   5.3672853E-04,   4.8721198E-04
     +,   4.3772033E-04,   3.8947302E-04,   3.4351164E-04
     +,   3.0065738E-04,   2.6148904E-04,   2.2634037E-04
     +,   1.9532384E-04,   1.6835421E-04,   1.4519093E-04
     +,   1.2548787E-04,   1.0883181E-04,   9.4785828E-05
     +,   8.2917912E-05,   7.2828574E-05,   6.4166401E-05
     +,   5.6636622E-05,   5.0003113E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_nwao_hz_115 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_nwao_hz_120(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   1.9264225E-38
     +,   5.7814699E-38,   1.7216138E-37,   5.0867968E-37
     +,   1.4913085E-36,   4.3381234E-36,   1.2521252E-35
     +,   3.5859876E-35,   1.0190180E-34,   2.8732101E-34
     +,   8.0383729E-34,   2.2314218E-33,   6.1462147E-33
     +,   1.6797698E-32,   4.5551426E-32,   1.2256689E-31
     +,   3.2724484E-31,   8.6690348E-31,   2.2785779E-30
     +,   5.9430380E-30,   1.5379723E-29,   3.9491657E-29
     +,   1.0061772E-28,   2.5436674E-28,   6.3805568E-28
     +,   1.5880842E-27,   3.9219545E-27,   9.6105206E-27
     +,   2.3367131E-26,   5.6374145E-26,   1.3494876E-25
     +,   3.2053216E-25,   7.5541858E-25,   1.7665343E-24
     +,   4.0989122E-24,   9.4369079E-24,   2.1557800E-23
     +,   4.8864493E-23,   1.0989992E-22,   2.4525357E-22
     +,   5.4305826E-22,   1.1931397E-21,   2.6010498E-21
     +,   5.6262572E-21,   1.2075438E-20,   2.5715832E-20
     +,   5.4338787E-20,   1.1392805E-19,   2.3700847E-19
     +,   4.8922646E-19,   1.0019944E-18,   2.0362610E-18
     +,   4.1059484E-18,   8.2149300E-18,   1.6308597E-17
     +,   3.2122924E-17,   6.2783915E-17,   1.2175323E-16
     +,   2.3427216E-16,   4.4727125E-16,   8.4728669E-16
     +,   1.5925727E-15,   2.9701375E-15,   5.4962075E-15
     +,   1.0091567E-14,   1.8384984E-14,   3.3233551E-14
     +,   5.9607193E-14,   1.0607913E-13,   1.8731422E-13
     +,   3.2818667E-13,   5.7053228E-13,   9.8412576E-13
     +,   1.6843487E-12,   2.8603877E-12,   4.8198134E-12
     +,   8.0584064E-12,   1.3368458E-11,   2.2005908E-11
     +,   3.5942208E-11,   5.8248989E-11,   9.3666484E-11
     +,   1.4945531E-10,   2.3663080E-10,   3.7174924E-10
     +,   5.7950778E-10,   8.9639962E-10,   1.3758807E-09
     +,   2.0955597E-09,   3.1671210E-09,   4.7498321E-09
     +,   7.0688073E-09,   1.0439362E-08,   1.5299157E-08
     +,   2.2250154E-08,   3.2112748E-08,   4.5994796E-08
     +,   6.5378337E-08,   9.2227786E-08,   1.2912247E-07
     +,   1.7941700E-07,   2.4743272E-07,   3.3868298E-07
     +,   4.6013369E-07,   6.2049855E-07,   8.3057074E-07
     +,   1.1035817E-06,   1.4555867E-06,   1.9058631E-06
     +,   2.4773067E-06,   3.1968145E-06,   4.0956238E-06
     +,   5.2095866E-06,   6.5793479E-06,   8.2503984E-06
     +,   1.0272955E-05,   1.2701657E-05,   1.5595015E-05
     +,   1.9014769E-05,   2.3024009E-05,   2.7687360E-05
     +,   3.3067729E-05,   3.9225113E-05,   4.6214540E-05
     +,   5.4082411E-05,   6.2865751E-05,   7.2588431E-05
     +,   8.3258528E-05,   9.4868374E-05,   1.0738789E-04
     +,   1.2076797E-04,   1.3493732E-04,   1.4980302E-04
     +,   1.6525216E-04,   1.8115061E-04,   1.9735229E-04
     +,   2.1369716E-04,   2.3001868E-04,   2.4614987E-04
     +,   2.6192653E-04,   2.7719751E-04,   2.9182792E-04
     +,   3.0570489E-04,   3.1874486E-04,   3.3089108E-04
     +,   3.4212077E-04,   3.5244221E-04,   3.6189330E-04
     +,   3.7053745E-04,   3.7845803E-04,   3.8575137E-04
     +,   3.9251911E-04,   3.9885996E-04,   4.0486149E-04
     +,   4.1059343E-04,   4.1610131E-04,   4.2140327E-04
     +,   4.2648727E-04,   4.3131196E-04,   4.3580894E-04
     +,   4.3988760E-04,   4.4344075E-04,   4.4635197E-04
     +,   4.4850347E-04,   4.4978346E-04,   4.5009365E-04
     +,   4.4935456E-04,   4.4751048E-04,   4.4453202E-04
     +,   4.4041680E-04,   4.3518908E-04,   4.2889727E-04
     +,   4.2161014E-04,   4.1341264E-04,   4.0440093E-04
     +,   3.9467719E-04,   3.8434498E-04,   3.7350503E-04
     +,   3.6225157E-04,   3.5066984E-04,   3.3883445E-04
     +,   3.2680843E-04,   3.1464352E-04,   3.0238047E-04
     +,   2.9005221E-04,   2.7768355E-04,   2.6529271E-04
     +,   2.5289628E-04,   2.4050864E-04,   2.2814644E-04
     +,   2.1582689E-04,   2.0357120E-04,   1.9140482E-04
     +,   1.7935771E-04,   1.6746440E-04,   1.5576354E-04
     +,   1.4429695E-04,   1.3310884E-04,   1.2224387E-04
     +,   1.1174770E-04,   1.0166319E-04,   9.2029193E-05
     +,   8.2881452E-05,   7.4249423E-05,   6.6157249E-05
     +,   5.8621117E-05,   5.1650255E-05,   4.5246667E-05
     +,   3.9405259E-05,   3.4114320E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_nwao_hz_120 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_nwao_hz_60(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  2.5776855E-05,   2.6574262E-05
     +,   2.7406897E-05,   2.8275845E-05,   2.9182118E-05
     +,   3.0126685E-05,   3.1110427E-05,   3.2134161E-05
     +,   3.3198608E-05,   3.4304419E-05,   3.5452071E-05
     +,   3.6642014E-05,   3.7874524E-05,   3.9149789E-05
     +,   4.0467825E-05,   4.1828527E-05,   4.3231634E-05
     +,   4.4676737E-05,   4.6163263E-05,   4.7690461E-05
     +,   4.9257422E-05,   5.0863066E-05,   5.2506108E-05
     +,   5.4185148E-05,   5.5898483E-05,   5.7644345E-05
     +,   5.9420752E-05,   6.1225517E-05,   6.3056301E-05
     +,   6.4910593E-05,   6.6785702E-05,   6.8678826E-05
     +,   7.0586917E-05,   7.2506897E-05,   7.4435491E-05
     +,   7.6369317E-05,   7.8304904E-05,   8.0238664E-05
     +,   8.2166975E-05,   8.4086118E-05,   8.5992331E-05
     +,   8.7881919E-05,   8.9750953E-05,   9.1595859E-05
     +,   9.3412782E-05,   9.5198098E-05,   9.6948199E-05
     +,   9.8659613E-05,   1.0032892E-04,   1.0195288E-04
     +,   1.0352839E-04,   1.0505252E-04,   1.0652254E-04
     +,   1.0793588E-04,   1.0929030E-04,   1.1058359E-04
     +,   1.1181396E-04,   1.1297983E-04,   1.1407988E-04
     +,   1.1511298E-04,   1.1607844E-04,   1.1697568E-04
     +,   1.1780450E-04,   1.1856495E-04,   1.1925736E-04
     +,   1.1988233E-04,   1.2044075E-04,   1.2093375E-04
     +,   1.2136273E-04,   1.2172935E-04,   1.2203549E-04
     +,   1.2228327E-04,   1.2247500E-04,   1.2261323E-04
     +,   1.2270075E-04,   1.2274041E-04,   1.2273535E-04
     +,   1.2268887E-04,   1.2260437E-04,   1.2248539E-04
     +,   1.2233571E-04,   1.2215912E-04,   1.2195960E-04
     +,   1.2174125E-04,   1.2150829E-04,   1.2126496E-04
     +,   1.2101572E-04,   1.2076508E-04,   1.2051765E-04
     +,   1.2027812E-04,   1.2005129E-04,   1.1984205E-04
     +,   1.1965536E-04,   1.1949622E-04,   1.1936972E-04
     +,   1.1928107E-04,   1.1923544E-04,   1.1923800E-04
     +,   1.1929405E-04,   1.1940877E-04,   1.1958736E-04
     +,   1.1983497E-04,   1.2015660E-04,   1.2055715E-04
     +,   1.2104145E-04,   1.2161394E-04,   1.2227903E-04
     +,   1.2304069E-04,   1.2390259E-04,   1.2486795E-04
     +,   1.2593974E-04,   1.2712018E-04,   1.2841111E-04
     +,   1.2981375E-04,   1.3132858E-04,   1.3295548E-04
     +,   1.3469347E-04,   1.3654091E-04,   1.3849520E-04
     +,   1.4055302E-04,   1.4270998E-04,   1.4496091E-04
     +,   1.4729970E-04,   1.4971923E-04,   1.5221156E-04
     +,   1.5476785E-04,   1.5737829E-04,   1.6003227E-04
     +,   1.6271844E-04,   1.6542454E-04,   1.6813779E-04
     +,   1.7084471E-04,   1.7353133E-04,   1.7618324E-04
     +,   1.7878563E-04,   1.8132353E-04,   1.8378181E-04
     +,   1.8614532E-04,   1.8839905E-04,   1.9052821E-04
     +,   1.9251833E-04,   1.9435544E-04,   1.9602619E-04
     +,   1.9751786E-04,   1.9881863E-04,   1.9991767E-04
     +,   2.0080493E-04,   2.0147185E-04,   2.0191076E-04
     +,   2.0211555E-04,   2.0208122E-04,   2.0180439E-04
     +,   2.0128299E-04,   2.0051657E-04,   1.9950609E-04
     +,   1.9825403E-04,   1.9676439E-04,   1.9504272E-04
     +,   1.9309597E-04,   1.9093243E-04,   1.8856193E-04
     +,   1.8599548E-04,   1.8324531E-04,   1.8032490E-04
     +,   1.7724857E-04,   1.7403184E-04,   1.7069081E-04
     +,   1.6724253E-04,   1.6370452E-04,   1.6009469E-04
     +,   1.5643169E-04,   1.5273404E-04,   1.4902061E-04
     +,   1.4530978E-04,   1.4162016E-04,   1.3797029E-04
     +,   1.3437796E-04,   1.3086051E-04,   1.2743479E-04
     +,   1.2411678E-04,   1.2092177E-04,   1.1786407E-04
     +,   1.1495705E-04,   1.1221301E-04,   1.0964308E-04
     +,   1.0725730E-04,   1.0506442E-04,   1.0307191E-04
     +,   1.0128604E-04,   9.9711760E-05,   9.8352626E-05
     +,   9.7210999E-05,   9.6287877E-05,   9.5583040E-05
     +,   9.5094925E-05,   9.4820913E-05,   9.4757081E-05
     +,   9.4898474E-05,   9.5239033E-05,   9.5771757E-05
     +,   9.6488628E-05,   9.7380871E-05,   9.8438846E-05
     +,   9.9652258E-05,   1.0101013E-04,   1.0250096E-04
     +,   1.0411277E-04,   1.0583325E-04,   1.0764968E-04
     +,   1.0954926E-04,   1.1151868E-04,   1.1354511E-04
     +,   1.1561532E-04,   1.1771625E-04,   1.1983512E-04
     +,   1.2195901E-04,   1.2407565E-04,   1.2617292E-04
     +,   1.2823904E-04,   1.3026300E-04,   1.3223372E-04
     +,   1.3414110E-04,   1.3597542E-04,   1.3772759E-04
     +,   1.3938926E-04,   1.4095241E-04,   1.4241014E-04
     +,   1.4375597E-04,   1.4498424E-04,   1.4608997E-04
     +,   1.4706887E-04,   1.4791741E-04,   1.4863281E-04
     +,   1.4921295E-04,   1.4965657E-04,   1.4996284E-04
     +,   1.5013177E-04,   1.5016399E-04,   1.5006070E-04
     +,   1.4982377E-04,   1.4945555E-04,   1.4895890E-04
     +,   1.4833723E-04,   1.4759436E-04,   1.4673447E-04
     +,   1.4576217E-04,   1.4468229E-04,   1.4350003E-04
     +,   1.4222073E-04,   1.4084991E-04,   1.3939326E-04
     +,   1.3785654E-04,   1.3624551E-04,   1.3456597E-04
     +,   1.3282365E-04,   1.3102425E-04,   1.2917331E-04
     +,   1.2727623E-04,   1.2533825E-04,   1.2336441E-04
     +,   1.2135948E-04,   1.1932806E-04,   1.1727442E-04
     +,   1.1520265E-04,   1.1311647E-04,   1.1101935E-04
     +,   1.0891450E-04,   1.0680485E-04,   1.0469298E-04
     +,   1.0258132E-04,   1.0047195E-04,   9.8366749E-05
     +,   9.6267344E-05,   9.4175179E-05,   9.2091403E-05
     +,   9.0017238E-05,   8.7953595E-05,   8.5901069E-05
     +,   8.3860410E-05,   8.1832091E-05,   7.9816768E-05
     +,   7.7814810E-05,   7.5826596E-05,   7.3852505E-05
     +,   7.1892900E-05,   6.9948197E-05,   6.8018759E-05
     +,   6.6105029E-05,   6.4207481E-05,   6.2326551E-05
     +,   6.0462960E-05,   5.8617323E-05,   5.6790166E-05
     +,   5.4982294E-05,   5.3194421E-05,   5.1427534E-05
     +,   4.9682429E-05,   4.7960020E-05,   4.6261273E-05
     +,   4.4587166E-05,   4.2938689E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_nwao_hz_60 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_nwao_hz_65(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  8.0930822E-06,   8.5085194E-06
     +,   8.9371069E-06,   9.3787030E-06,   9.8331257E-06
     +,   1.0300142E-05,   1.0779478E-05,   1.1270809E-05
     +,   1.1773764E-05,   1.2287932E-05,   1.2812819E-05
     +,   1.3347916E-05,   1.3892648E-05,   1.4446393E-05
     +,   1.5008477E-05,   1.5578176E-05,   1.6154716E-05
     +,   1.6737280E-05,   1.7324999E-05,   1.7916958E-05
     +,   1.8512206E-05,   1.9109739E-05,   1.9708523E-05
     +,   2.0307498E-05,   2.0905532E-05,   2.1501501E-05
     +,   2.2094242E-05,   2.2682563E-05,   2.3265260E-05
     +,   2.3841114E-05,   2.4408879E-05,   2.4967325E-05
     +,   2.5515203E-05,   2.6051272E-05,   2.6574293E-05
     +,   2.7083050E-05,   2.7576329E-05,   2.8052955E-05
     +,   2.8511760E-05,   2.8951630E-05,   2.9371475E-05
     +,   2.9770259E-05,   3.0146959E-05,   3.0500665E-05
     +,   3.0830477E-05,   3.1135580E-05,   3.1415217E-05
     +,   3.1668729E-05,   3.1895514E-05,   3.2095057E-05
     +,   3.2266937E-05,   3.2410844E-05,   3.2526543E-05
     +,   3.2613923E-05,   3.2672979E-05,   3.2703807E-05
     +,   3.2706663E-05,   3.2681895E-05,   3.2630000E-05
     +,   3.2551612E-05,   3.2447508E-05,   3.2318610E-05
     +,   3.2166005E-05,   3.1990941E-05,   3.1794822E-05
     +,   3.1579228E-05,   3.1345924E-05,   3.1096857E-05
     +,   3.0834148E-05,   3.0560135E-05,   3.0277341E-05
     +,   2.9988501E-05,   2.9696559E-05,   2.9404677E-05
     +,   2.9116231E-05,   2.8834855E-05,   2.8564389E-05
     +,   2.8308934E-05,   2.8072842E-05,   2.7860728E-05
     +,   2.7677488E-05,   2.7528298E-05,   2.7418642E-05
     +,   2.7354339E-05,   2.7341510E-05,   2.7386654E-05
     +,   2.7496639E-05,   2.7678710E-05,   2.7940547E-05
     +,   2.8290220E-05,   2.8736264E-05,   2.9287641E-05
     +,   2.9953755E-05,   3.0744439E-05,   3.1669948E-05
     +,   3.2740900E-05,   3.3968226E-05,   3.5363133E-05
     +,   3.6936959E-05,   3.8701095E-05,   4.0666833E-05
     +,   4.2845193E-05,   4.5246736E-05,   4.7881349E-05
     +,   5.0758030E-05,   5.3884589E-05,   5.7267407E-05
     +,   6.0911312E-05,   6.4818691E-05,   6.8989924E-05
     +,   7.3423464E-05,   7.8113895E-05,   8.3053623E-05
     +,   8.8231733E-05,   9.3634175E-05,   9.9243596E-05
     +,   1.0503952E-04,   1.1099831E-04,   1.1709347E-04
     +,   1.2329583E-04,   1.2957398E-04,   1.3589452E-04
     +,   1.4222265E-04,   1.4852284E-04,   1.5475907E-04
     +,   1.6089574E-04,   1.6689823E-04,   1.7273350E-04
     +,   1.7837083E-04,   1.8378238E-04,   1.8894381E-04
     +,   1.9383496E-04,   1.9844025E-04,   2.0274920E-04
     +,   2.0675690E-04,   2.1046438E-04,   2.1387869E-04
     +,   2.1701356E-04,   2.1988912E-04,   2.2253218E-04
     +,   2.2497613E-04,   2.2726107E-04,   2.2943293E-04
     +,   2.3154401E-04,   2.3365158E-04,   2.3581783E-04
     +,   2.3810838E-04,   2.4059224E-04,   2.4333927E-04
     +,   2.4641969E-04,   2.4990202E-04,   2.5385144E-04
     +,   2.5832761E-04,   2.6338268E-04,   2.6905921E-04
     +,   2.7538789E-04,   2.8238547E-04,   2.9005311E-04
     +,   2.9837457E-04,   3.0731465E-04,   3.1681880E-04
     +,   3.2681215E-04,   3.3720041E-04,   3.4786979E-04
     +,   3.5868920E-04,   3.6951172E-04,   3.8017769E-04
     +,   3.9051764E-04,   4.0035619E-04,   4.0951659E-04
     +,   4.1782329E-04,   4.2510929E-04,   4.3121807E-04
     +,   4.3600998E-04,   4.3936438E-04,   4.4118371E-04
     +,   4.4139693E-04,   4.3996130E-04,   4.3686351E-04
     +,   4.3212055E-04,   4.2577920E-04,   4.1791485E-04
     +,   4.0862939E-04,   3.9804887E-04,   3.8631976E-04
     +,   3.7360535E-04,   3.6008155E-04,   3.4593238E-04
     +,   3.3134560E-04,   3.1650829E-04,   3.0160285E-04
     +,   2.8680277E-04,   2.7226977E-04,   2.5815036E-04
     +,   2.4457398E-04,   2.3165115E-04,   2.1947247E-04
     +,   2.0810812E-04,   1.9760781E-04,   1.8800178E-04
     +,   1.7930182E-04,   1.7150251E-04,   1.6458347E-04
     +,   1.5851110E-04,   1.5324091E-04,   1.4871973E-04
     +,   1.4488820E-04,   1.4168258E-04,   1.3903709E-04
     +,   1.3688557E-04,   1.3516363E-04,   1.3380912E-04
     +,   1.3276427E-04,   1.3197596E-04,   1.3139652E-04
     +,   1.3098423E-04,   1.3070328E-04,   1.3052374E-04
     +,   1.3042141E-04,   1.3037739E-04,   1.3037758E-04
     +,   1.3041211E-04,   1.3047460E-04,   1.3056168E-04
     +,   1.3067208E-04,   1.3080610E-04,   1.3096516E-04
     +,   1.3115085E-04,   1.3136484E-04,   1.3160809E-04
     +,   1.3188091E-04,   1.3218228E-04,   1.3250996E-04
     +,   1.3286032E-04,   1.3322817E-04,   1.3360695E-04
     +,   1.3398874E-04,   1.3436435E-04,   1.3472355E-04
     +,   1.3505529E-04,   1.3534770E-04,   1.3558859E-04
     +,   1.3576556E-04,   1.3586620E-04,   1.3587835E-04
     +,   1.3579032E-04,   1.3559108E-04,   1.3527037E-04
     +,   1.3481904E-04,   1.3422886E-04,   1.3349303E-04
     +,   1.3260584E-04,   1.3156314E-04,   1.3036204E-04
     +,   1.2900110E-04,   1.2748029E-04,   1.2580099E-04
     +,   1.2396580E-04,   1.2197868E-04,   1.1984476E-04
     +,   1.1757029E-04,   1.1516248E-04,   1.1262951E-04
     +,   1.0998029E-04,   1.0722449E-04,   1.0437228E-04
     +,   1.0143432E-04,   9.8421588E-05,   9.5345305E-05
     +,   9.2216796E-05,   8.9047389E-05,   8.5848333E-05
     +,   8.2630737E-05,   7.9405378E-05,   7.6182630E-05
     +,   7.2972842E-05,   6.9785630E-05,   6.6629829E-05
     +,   6.3514140E-05,   6.0446382E-05,   5.7434179E-05
     +,   5.4484099E-05,   5.1602230E-05,   4.8793987E-05
     +,   4.6064146E-05,   4.3416832E-05,   4.0855550E-05
     +,   3.8383183E-05,   3.6002031E-05,   3.3713735E-05
     +,   3.1519667E-05,   2.9420480E-05,   2.7416190E-05
     +,   2.5506630E-05,   2.3691053E-05,   2.1968550E-05
     +,   2.0337637E-05,   1.8796594E-05,   1.7343418E-05
     +,   1.5975867E-05,   1.4691476E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_nwao_hz_65 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_nwao_hz_70(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  3.0869398E-07,   3.4347124E-07
     +,   3.8165459E-07,   4.2351661E-07,   4.6934508E-07
     +,   5.1944340E-07,   5.7413104E-07,   6.3374273E-07
     +,   6.9862966E-07,   7.6916047E-07,   8.4571536E-07
     +,   9.2869561E-07,   1.0185165E-06,   1.1156101E-06
     +,   1.2204235E-06,   1.3334211E-06,   1.4550818E-06
     +,   1.5859007E-06,   1.7263900E-06,   1.8770755E-06
     +,   2.0385003E-06,   2.2112235E-06,   2.3958205E-06
     +,   2.5928880E-06,   2.8030261E-06,   3.0268673E-06
     +,   3.2650560E-06,   3.5182607E-06,   3.7871657E-06
     +,   4.0724813E-06,   4.3749405E-06,   4.6953023E-06
     +,   5.0343515E-06,   5.3929052E-06,   5.7718094E-06
     +,   6.1719461E-06,   6.5942327E-06,   7.0396259E-06
     +,   7.5091230E-06,   8.0037616E-06,   8.5246302E-06
     +,   9.0728709E-06,   9.6496269E-06,   1.0256176E-05
     +,   1.0893758E-05,   1.1563714E-05,   1.2267414E-05
     +,   1.3006276E-05,   1.3781764E-05,   1.4595375E-05
     +,   1.5448646E-05,   1.6343127E-05,   1.7280401E-05
     +,   1.8262050E-05,   1.9289690E-05,   2.0364840E-05
     +,   2.1489073E-05,   2.2663895E-05,   2.3890761E-05
     +,   2.5171046E-05,   2.6506041E-05,   2.7896936E-05
     +,   2.9344787E-05,   3.0850511E-05,   3.2414860E-05
     +,   3.4038421E-05,   3.5721579E-05,   3.7464495E-05
     +,   3.9267125E-05,   4.1129191E-05,   4.3050171E-05
     +,   4.5029265E-05,   4.7065449E-05,   4.9157432E-05
     +,   5.1303716E-05,   5.3502430E-05,   5.5751570E-05
     +,   5.8048914E-05,   6.0391932E-05,   6.2778083E-05
     +,   6.5204535E-05,   6.7668327E-05,   7.0166512E-05
     +,   7.2695751E-05,   7.5252865E-05,   7.7834949E-05
     +,   8.0438527E-05,   8.3060506E-05,   8.5697822E-05
     +,   8.8347486E-05,   9.1006536E-05,   9.3672264E-05
     +,   9.6341966E-05,   9.9013145E-05,   1.0168339E-04
     +,   1.0435042E-04,   1.0701206E-04,   1.0966617E-04
     +,   1.1231070E-04,   1.1494356E-04,   1.1756267E-04
     +,   1.2016580E-04,   1.2275066E-04,   1.2531472E-04
     +,   1.2785522E-04,   1.3036914E-04,   1.3285306E-04
     +,   1.3530340E-04,   1.3771566E-04,   1.4008538E-04
     +,   1.4240768E-04,   1.4467677E-04,   1.4688680E-04
     +,   1.4903132E-04,   1.5110358E-04,   1.5309647E-04
     +,   1.5500253E-04,   1.5681439E-04,   1.5852432E-04
     +,   1.6012485E-04,   1.6160862E-04,   1.6296854E-04
     +,   1.6419817E-04,   1.6529154E-04,   1.6624364E-04
     +,   1.6705033E-04,   1.6770860E-04,   1.6821671E-04
     +,   1.6857441E-04,   1.6878289E-04,   1.6884513E-04
     +,   1.6876569E-04,   1.6855109E-04,   1.6820962E-04
     +,   1.6775135E-04,   1.6718835E-04,   1.6653429E-04
     +,   1.6580462E-04,   1.6501630E-04,   1.6418760E-04
     +,   1.6333806E-04,   1.6248801E-04,   1.6165864E-04
     +,   1.6087131E-04,   1.6014744E-04,   1.5950824E-04
     +,   1.5897409E-04,   1.5856435E-04,   1.5829696E-04
     +,   1.5818785E-04,   1.5825094E-04,   1.5849737E-04
     +,   1.5893536E-04,   1.5956999E-04,   1.6040272E-04
     +,   1.6143134E-04,   1.6264971E-04,   1.6404774E-04
     +,   1.6561132E-04,   1.6732236E-04,   1.6915906E-04
     +,   1.7109589E-04,   1.7310410E-04,   1.7515206E-04
     +,   1.7720574E-04,   1.7922922E-04,   1.8118536E-04
     +,   1.8303649E-04,   1.8474519E-04,   1.8627507E-04
     +,   1.8759130E-04,   1.8866209E-04,   1.8945889E-04
     +,   1.8995749E-04,   1.9013874E-04,   1.8998925E-04
     +,   1.8950204E-04,   1.8867706E-04,   1.8752167E-04
     +,   1.8605094E-04,   1.8428796E-04,   1.8226374E-04
     +,   1.8001730E-04,   1.7759531E-04,   1.7505183E-04
     +,   1.7244769E-04,   1.6984982E-04,   1.6733064E-04
     +,   1.6496677E-04,   1.6283819E-04,   1.6102701E-04
     +,   1.5961628E-04,   1.5868837E-04,   1.5832386E-04
     +,   1.5859969E-04,   1.5958813E-04,   1.6135494E-04
     +,   1.6395804E-04,   1.6744614E-04,   1.7185732E-04
     +,   1.7721800E-04,   1.8354179E-04,   1.9082874E-04
     +,   1.9906467E-04,   2.0822076E-04,   2.1825341E-04
     +,   2.2910464E-04,   2.4070247E-04,   2.5296153E-04
     +,   2.6578514E-04,   2.7906374E-04,   2.9268191E-04
     +,   3.0651534E-04,   3.2043527E-04,   3.3431075E-04
     +,   3.4800876E-04,   3.6140045E-04,   3.7436010E-04
     +,   3.8676837E-04,   3.9851593E-04,   4.0950053E-04
     +,   4.1963308E-04,   4.2883633E-04,   4.3704608E-04
     +,   4.4421144E-04,   4.5029368E-04,   4.5526831E-04
     +,   4.5912189E-04,   4.6185264E-04,   4.6346898E-04
     +,   4.6398840E-04,   4.6343630E-04,   4.6184534E-04
     +,   4.5925414E-04,   4.5570525E-04,   4.5124712E-04
     +,   4.4593049E-04,   4.3980981E-04,   4.3294212E-04
     +,   4.2538694E-04,   4.1720574E-04,   4.0846254E-04
     +,   3.9922280E-04,   3.8955366E-04,   3.7952335E-04
     +,   3.6920086E-04,   3.5865529E-04,   3.4795539E-04
     +,   3.3716831E-04,   3.2635930E-04,   3.1559033E-04
     +,   3.0491961E-04,   2.9440047E-04,   2.8408080E-04
     +,   2.7400200E-04,   2.6419896E-04,   2.5469935E-04
     +,   2.4552355E-04,   2.3668481E-04,   2.2818922E-04
     +,   2.2003634E-04,   2.1221969E-04,   2.0472752E-04
     +,   1.9754346E-04,   1.9064755E-04,   1.8401718E-04
     +,   1.7762787E-04,   1.7145436E-04,   1.6547130E-04
     +,   1.5965411E-04,   1.5397965E-04,   1.4842660E-04
     +,   1.4297622E-04,   1.3761238E-04,   1.3232171E-04
     +,   1.2709445E-04,   1.2192348E-04,   1.1680409E-04
     +,   1.1173493E-04,   1.0671675E-04,   1.0175312E-04
     +,   9.6848809E-05,   9.2010407E-05,   8.7245659E-05
     +,   8.2563194E-05,   7.7972218E-05,   7.3482057E-05
     +,   6.9102120E-05,   6.4841450E-05,   6.0708473E-05
     +,   5.6711382E-05,   5.2857205E-05,   4.9151724E-05
     +,   4.5600194E-05,   4.2206470E-05,   3.8973722E-05
     +,   3.5903628E-05,   3.2996912E-05,   3.0253266E-05
     +,   2.7671404E-05,   2.5249137E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_nwao_hz_70 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_nwao_hz_75(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  7.2050925E-06,   7.3537785E-06
     +,   7.5036328E-06,   7.6546585E-06,   7.8068597E-06
     +,   7.9602478E-06,   8.1148337E-06,   8.2706338E-06
     +,   8.4276689E-06,   8.5859638E-06,   8.7455428E-06
     +,   8.9064379E-06,   9.0686844E-06,   9.2323216E-06
     +,   9.3973940E-06,   9.5639452E-06,   9.7320271E-06
     +,   9.9016916E-06,   1.0072999E-05,   1.0246009E-05
     +,   1.0420787E-05,   1.0597397E-05,   1.0775917E-05
     +,   1.0956419E-05,   1.1138979E-05,   1.1323681E-05
     +,   1.1510607E-05,   1.1699851E-05,   1.1891500E-05
     +,   1.2085656E-05,   1.2282414E-05,   1.2481882E-05
     +,   1.2684169E-05,   1.2889387E-05,   1.3097658E-05
     +,   1.3309109E-05,   1.3523869E-05,   1.3742080E-05
     +,   1.3963888E-05,   1.4189451E-05,   1.4418933E-05
     +,   1.4652519E-05,   1.4890378E-05,   1.5132738E-05
     +,   1.5379796E-05,   1.5631787E-05,   1.5888963E-05
     +,   1.6151589E-05,   1.6419950E-05,   1.6694352E-05
     +,   1.6975126E-05,   1.7262626E-05,   1.7557233E-05
     +,   1.7859347E-05,   1.8169414E-05,   1.8487881E-05
     +,   1.8815252E-05,   1.9152047E-05,   1.9498824E-05
     +,   1.9856177E-05,   2.0224730E-05,   2.0605139E-05
     +,   2.0998090E-05,   2.1404316E-05,   2.1824564E-05
     +,   2.2259628E-05,   2.2710319E-05,   2.3177488E-05
     +,   2.3662000E-05,   2.4164750E-05,   2.4686646E-05
     +,   2.5228621E-05,   2.5791611E-05,   2.6376563E-05
     +,   2.6984437E-05,   2.7616154E-05,   2.8272654E-05
     +,   2.8954853E-05,   2.9663630E-05,   3.0399882E-05
     +,   3.1164403E-05,   3.1957974E-05,   3.2781354E-05
     +,   3.3635119E-05,   3.4519850E-05,   3.5436165E-05
     +,   3.6384354E-05,   3.7364771E-05,   3.8377610E-05
     +,   3.9422961E-05,   4.0500796E-05,   4.1610940E-05
     +,   4.2753090E-05,   4.3926793E-05,   4.5131448E-05
     +,   4.6366302E-05,   4.7630445E-05,   4.8922804E-05
     +,   5.0242132E-05,   5.1587031E-05,   5.2955944E-05
     +,   5.4347140E-05,   5.5758705E-05,   5.7188619E-05
     +,   5.8634669E-05,   6.0094502E-05,   6.1565624E-05
     +,   6.3045474E-05,   6.4531167E-05,   6.6019827E-05
     +,   6.7508663E-05,   6.8994363E-05,   7.0473834E-05
     +,   7.1943796E-05,   7.3400872E-05,   7.4841686E-05
     +,   7.6262717E-05,   7.7660457E-05,   7.9031335E-05
     +,   8.0371748E-05,   8.1678059E-05,   8.2946623E-05
     +,   8.4173800E-05,   8.5355976E-05,   8.6489512E-05
     +,   8.7570879E-05,   8.8596586E-05,   8.9563255E-05
     +,   9.0467627E-05,   9.1306647E-05,   9.2077498E-05
     +,   9.2777598E-05,   9.3404829E-05,   9.3957424E-05
     +,   9.4434261E-05,   9.4834802E-05,   9.5159339E-05
     +,   9.5409057E-05,   9.5586220E-05,   9.5694304E-05
     +,   9.5738193E-05,   9.5724281E-05,   9.5660704E-05
     +,   9.5557458E-05,   9.5426476E-05,   9.5281976E-05
     +,   9.5140298E-05,   9.5020121E-05,   9.4942414E-05
     +,   9.4930539E-05,   9.5010022E-05,   9.5208481E-05
     +,   9.5555479E-05,   9.6082236E-05,   9.6821321E-05
     +,   9.7806311E-05,   9.9071360E-05,   1.0065075E-04
     +,   1.0257851E-04,   1.0488783E-04,   1.0761069E-04
     +,   1.1077737E-04,   1.1441612E-04,   1.1855283E-04
     +,   1.2321078E-04,   1.2841044E-04,   1.3416950E-04
     +,   1.4050282E-04,   1.4742244E-04,   1.5493827E-04
     +,   1.6305689E-04,   1.7178355E-04,   1.8112088E-04
     +,   1.9107081E-04,   2.0163255E-04,   2.1280232E-04
     +,   2.2457518E-04,   2.3694275E-04,   2.4989297E-04
     +,   2.6340879E-04,   2.7746701E-04,   2.9203697E-04
     +,   3.0707914E-04,   3.2254335E-04,   3.3836713E-04
     +,   3.5447508E-04,   3.7077704E-04,   3.8716817E-04
     +,   4.0352839E-04,   4.1972398E-04,   4.3560783E-04
     +,   4.5102226E-04,   4.6580215E-04,   4.7977813E-04
     +,   4.9278163E-04,   5.0464971E-04,   5.1523000E-04
     +,   5.2438688E-04,   5.3200650E-04,   5.3800171E-04
     +,   5.4231664E-04,   5.4493005E-04,   5.4585788E-04
     +,   5.4515421E-04,   5.4291059E-04,   5.3925504E-04
     +,   5.3434767E-04,   5.2837783E-04,   5.2155706E-04
     +,   5.1411358E-04,   5.0628593E-04,   4.9831299E-04
     +,   4.9042999E-04,   4.8285993E-04,   4.7580744E-04
     +,   4.6945459E-04,   4.6395411E-04,   4.5942771E-04
     +,   4.5596383E-04,   4.5361507E-04,   4.5240019E-04
     +,   4.5230298E-04,   4.5327487E-04,   4.5523714E-04
     +,   4.5808402E-04,   4.6168524E-04,   4.6589159E-04
     +,   4.7053743E-04,   4.7544602E-04,   4.8043419E-04
     +,   4.8531653E-04,   4.8991130E-04,   4.9404509E-04
     +,   4.9755722E-04,   5.0030625E-04,   5.0217117E-04
     +,   5.0305849E-04,   5.0290313E-04,   5.0167099E-04
     +,   4.9936021E-04,   4.9600034E-04,   4.9165101E-04
     +,   4.8639893E-04,   4.8035392E-04,   4.7364392E-04
     +,   4.6640894E-04,   4.5879473E-04,   4.5094651E-04
     +,   4.4300279E-04,   4.3508905E-04,   4.2731327E-04
     +,   4.1976193E-04,   4.1249747E-04,   4.0555678E-04
     +,   3.9895190E-04,   3.9267048E-04,   3.8667920E-04
     +,   3.8092677E-04,   3.7534759E-04,   3.6986714E-04
     +,   3.6440583E-04,   3.5888399E-04,   3.5322498E-04
     +,   3.4736012E-04,   3.4122990E-04,   3.3478712E-04
     +,   3.2799775E-04,   3.2084130E-04,   3.1331056E-04
     +,   3.0541117E-04,   2.9715983E-04,   2.8858299E-04
     +,   2.7971499E-04,   2.7059612E-04,   2.6127027E-04
     +,   2.5178495E-04,   2.4218763E-04,   2.3252427E-04
     +,   2.2284040E-04,   2.1317825E-04,   2.0357792E-04
     +,   1.9407494E-04,   1.8470151E-04,   1.7548609E-04
     +,   1.6645341E-04,   1.5762486E-04,   1.4901855E-04
     +,   1.4064973E-04,   1.3253097E-04,   1.2467224E-04
     +,   1.1708232E-04,   1.0976750E-04,   1.0273189E-04
     +,   9.5978998E-05,   8.9510468E-05,   8.3327570E-05
     +,   7.7429671E-05,   7.1815353E-05,   6.6482273E-05
     +,   6.1427214E-05,   5.6646106E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_nwao_hz_75 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_nwao_hz_80(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  3.4120994E-08,   3.9436610E-08
     +,   4.5508653E-08,   5.2433272E-08,   6.0317220E-08
     +,   6.9278705E-08,   7.9448455E-08,   9.0970588E-08
     +,   1.0400403E-07,   1.1872357E-07,   1.3532031E-07
     +,   1.5400435E-07,   1.7500530E-07,   1.9857349E-07
     +,   2.2498203E-07,   2.5452778E-07,   2.8753325E-07
     +,   3.2434812E-07,   3.6535079E-07,   4.1095052E-07
     +,   4.6158840E-07,   5.1774003E-07,   5.7991724E-07
     +,   6.4867112E-07,   7.2458818E-07,   8.0830193E-07
     +,   9.0048769E-07,   1.0018674E-06,   1.1132112E-06
     +,   1.2353398E-06,   1.3691264E-06,   1.5154986E-06
     +,   1.6754420E-06,   1.8500003E-06,   2.0402786E-06
     +,   2.2474453E-06,   2.4727335E-06,   2.7174440E-06
     +,   2.9829430E-06,   3.2706726E-06,   3.5821395E-06
     +,   3.9189308E-06,   4.2826800E-06,   4.6751402E-06
     +,   5.0980816E-06,   5.5533801E-06,   6.0429652E-06
     +,   6.5688387E-06,   7.1330514E-06,   7.7377244E-06
     +,   8.3850136E-06,   9.0771291E-06,   9.8163064E-06
     +,   1.0604808E-05,   1.1444925E-05,   1.2338889E-05
     +,   1.3288976E-05,   1.4297397E-05,   1.5366319E-05
     +,   1.6497830E-05,   1.7693923E-05,   1.8956478E-05
     +,   2.0287209E-05,   2.1687676E-05,   2.3159224E-05
     +,   2.4702978E-05,   2.6319793E-05,   2.8010223E-05
     +,   2.9774521E-05,   3.1612562E-05,   3.3523851E-05
     +,   3.5507470E-05,   3.7562066E-05,   3.9685812E-05
     +,   4.1876443E-05,   4.4131048E-05,   4.6446330E-05
     +,   4.8818394E-05,   5.1242780E-05,   5.3714626E-05
     +,   5.6228364E-05,   5.8777972E-05,   6.1357008E-05
     +,   6.3958221E-05,   6.6574132E-05,   6.9197136E-05
     +,   7.1818620E-05,   7.4430085E-05,   7.7022640E-05
     +,   7.9587175E-05,   8.2114457E-05,   8.4595173E-05
     +,   8.7020024E-05,   8.9379770E-05,   9.1665359E-05
     +,   9.3867966E-05,   9.5979121E-05,   9.7990742E-05
     +,   9.9895224E-05,   1.0168553E-04,   1.0335525E-04
     +,   1.0489872E-04,   1.0631091E-04,   1.0758772E-04
     +,   1.0872581E-04,   1.0972278E-04,   1.1057705E-04
     +,   1.1128809E-04,   1.1185610E-04,   1.1228231E-04
     +,   1.1256887E-04,   1.1271871E-04,   1.1273562E-04
     +,   1.1262416E-04,   1.1238962E-04,   1.1203798E-04
     +,   1.1157575E-04,   1.1101002E-04,   1.1034827E-04
     +,   1.0959838E-04,   1.0876849E-04,   1.0786694E-04
     +,   1.0690220E-04,   1.0588275E-04,   1.0481705E-04
     +,   1.0371344E-04,   1.0258010E-04,   1.0142495E-04
     +,   1.0025566E-04,   9.9079502E-05,   9.7903430E-05
     +,   9.6733980E-05,   9.5577205E-05,   9.4438765E-05
     +,   9.3323804E-05,   9.2237009E-05,   9.1182621E-05
     +,   9.0164387E-05,   8.9185589E-05,   8.8249137E-05
     +,   8.7357505E-05,   8.6512817E-05,   8.5716842E-05
     +,   8.4971187E-05,   8.4277206E-05,   8.3636201E-05
     +,   8.3049548E-05,   8.2518680E-05,   8.2045481E-05
     +,   8.1632221E-05,   8.1281964E-05,   8.0998674E-05
     +,   8.0787540E-05,   8.0655256E-05,   8.0610291E-05
     +,   8.0663223E-05,   8.0827034E-05,   8.1117410E-05
     +,   8.1552971E-05,   8.2155464E-05,   8.2950006E-05
     +,   8.3964951E-05,   8.5231994E-05,   8.6785789E-05
     +,   8.8663750E-05,   9.0905407E-05,   9.3551796E-05
     +,   9.6644602E-05,   1.0022509E-04,   1.0433320E-04
     +,   1.0900576E-04,   1.1427597E-04,   1.2017168E-04
     +,   1.2671511E-04,   1.3392080E-04,   1.4179472E-04
     +,   1.5033536E-04,   1.5953233E-04,   1.6936712E-04
     +,   1.7981353E-04,   1.9083881E-04,   2.0240489E-04
     +,   2.1446979E-04,   2.2698918E-04,   2.3991802E-04
     +,   2.5321197E-04,   2.6682846E-04,   2.8072734E-04
     +,   2.9487177E-04,   3.0922805E-04,   3.2376513E-04
     +,   3.3845444E-04,   3.5326960E-04,   3.6818604E-04
     +,   3.8318150E-04,   3.9823691E-04,   4.1333749E-04
     +,   4.2847620E-04,   4.4365556E-04,   4.5889211E-04
     +,   4.7421840E-04,   4.8968592E-04,   5.0536566E-04
     +,   5.2134710E-04,   5.3773378E-04,   5.5463746E-04
     +,   5.7216652E-04,   5.9041521E-04,   6.0944800E-04
     +,   6.2928617E-04,   6.4988853E-04,   6.7114958E-04
     +,   6.9288287E-04,   7.1482366E-04,   7.3663349E-04
     +,   7.5790944E-04,   7.7820732E-04,   7.9706160E-04
     +,   8.1401400E-04,   8.2864513E-04,   8.4059563E-04
     +,   8.4959704E-04,   8.5548457E-04,   8.5820892E-04
     +,   8.5783727E-04,   8.5454457E-04,   8.4859825E-04
     +,   8.4033719E-04,   8.3014427E-04,   8.1841811E-04
     +,   8.0554897E-04,   7.9189084E-04,   7.7774416E-04
     +,   7.6334196E-04,   7.4884098E-04,   7.3432754E-04
     +,   7.1981485E-04,   7.0525898E-04,   6.9056969E-04
     +,   6.7562796E-04,   6.6030165E-04,   6.4446009E-04
     +,   6.2799035E-04,   6.1080710E-04,   5.9286226E-04
     +,   5.7414989E-04,   5.5470923E-04,   5.3462281E-04
     +,   5.1401352E-04,   4.9303833E-04,   4.7188063E-04
     +,   4.5074086E-04,   4.2982664E-04,   4.0934284E-04
     +,   3.8948178E-04,   3.7041513E-04,   3.5228612E-04
     +,   3.3520462E-04,   3.1924332E-04,   3.0443689E-04
     +,   2.9078234E-04,   2.7824205E-04,   2.6674781E-04
     +,   2.5620652E-04,   2.4650642E-04,   2.3752384E-04
     +,   2.2913021E-04,   2.2119806E-04,   2.1360657E-04
     +,   2.0624645E-04,   1.9902308E-04,   1.9185896E-04
     +,   1.8469471E-04,   1.7748940E-04,   1.7021903E-04
     +,   1.6287657E-04,   1.5546805E-04,   1.4801032E-04
     +,   1.4052987E-04,   1.3305878E-04,   1.2563390E-04
     +,   1.1829268E-04,   1.1107254E-04,   1.0400914E-04
     +,   9.7135053E-05,   9.0479007E-05,   8.4065265E-05
     +,   7.7913508E-05,   7.2038696E-05,   6.6451117E-05
     +,   6.1157501E-05,   5.6160337E-05,   5.1458359E-05
     +,   4.7048154E-05,   4.2923537E-05,   3.9076960E-05
     +,   3.5498881E-05,   3.2178839E-05,   2.9105626E-05
     +,   2.6267548E-05,   2.3652658E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_nwao_hz_80 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_nwao_hz_85(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  4.0892447E-15,   5.5382703E-15
     +,   7.4851387E-15,   1.0095398E-14,   1.3587619E-14
     +,   1.8249825E-14,   2.4460873E-14,   3.2717549E-14
     +,   4.3670180E-14,   5.8168849E-14,   7.7319329E-14
     +,   1.0256115E-13,   1.3576067E-13,   1.7933382E-13
     +,   2.3639914E-13,   3.1097534E-13,   4.0822833E-13
     +,   5.3478191E-13,   6.9911188E-13,   9.1203802E-13
     +,   1.1873438E-12,   1.5425399E-12,   1.9998248E-12
     +,   2.5873026E-12,   3.3403876E-12,   4.3037106E-12
     +,   5.5333199E-12,   7.0994556E-12,   9.0899389E-12
     +,   1.1614333E-11,   1.4808954E-11,   1.8843031E-11
     +,   2.3926243E-11,   3.0317613E-11,   3.8336542E-11
     +,   4.8375821E-11,   6.0917285E-11,   7.6551002E-11
     +,   9.5997016E-11,   1.2013320E-10,   1.5002580E-10
     +,   1.8696870E-10,   2.3252314E-10,   2.8857977E-10
     +,   3.5740652E-10,   4.4173060E-10,   5.4481863E-10
     +,   6.7057337E-10,   8.2364554E-10,   1.0095659E-09
     +,   1.2348934E-09,   1.5073925E-09,   1.8362188E-09
     +,   2.2321565E-09,   2.7078830E-09,   3.2782110E-09
     +,   3.9604888E-09,   4.7749165E-09,   5.7449854E-09
     +,   6.8979382E-09,   8.2652907E-09,   9.8834052E-09
     +,   1.1794129E-08,   1.4045504E-08,   1.6692548E-08
     +,   1.9798094E-08,   2.3433723E-08,   2.7680770E-08
     +,   3.2631487E-08,   3.8390056E-08,   4.5074064E-08
     +,   5.2815732E-08,   6.1763423E-08,   7.2083132E-08
     +,   8.3960487E-08,   9.7601387E-08,   1.1323532E-07
     +,   1.3111610E-07,   1.5152418E-07,   1.7476968E-07
     +,   2.0119275E-07,   2.3116658E-07,   2.6510156E-07
     +,   3.0344091E-07,   3.4667025E-07,   3.9532367E-07
     +,   4.4996827E-07,   5.1122572E-07,   5.7976479E-07
     +,   6.5630587E-07,   7.4162358E-07,   8.3654754E-07
     +,   9.4196628E-07,   1.0588277E-06,   1.1881424E-06
     +,   1.3309844E-06,   1.4884924E-06,   1.6618719E-06
     +,   1.8523964E-06,   2.0614068E-06,   2.2903116E-06
     +,   2.5405916E-06,   2.8137893E-06,   3.1115173E-06
     +,   3.4354507E-06,   3.7873260E-06,   4.1689373E-06
     +,   4.5821475E-06,   5.0288127E-06,   5.5108590E-06
     +,   6.0303073E-06,   6.5890708E-06,   7.1891532E-06
     +,   7.8325284E-06,   8.5211432E-06,   9.2569053E-06
     +,   1.0041657E-05,   1.0877155E-05,   1.1765043E-05
     +,   1.2706833E-05,   1.3703873E-05,   1.4757316E-05
     +,   1.5868092E-05,   1.7036884E-05,   1.8264082E-05
     +,   1.9549769E-05,   2.0893680E-05,   2.2295182E-05
     +,   2.3753239E-05,   2.5266407E-05,   2.6832793E-05
     +,   2.8450057E-05,   3.0115409E-05,   3.1825592E-05
     +,   3.3576889E-05,   3.5365156E-05,   3.7185822E-05
     +,   3.9033941E-05,   4.0904204E-05,   4.2791020E-05
     +,   4.4688561E-05,   4.6590842E-05,   4.8491795E-05
     +,   5.0385373E-05,   5.2265637E-05,   5.4126947E-05
     +,   5.5963719E-05,   5.7771369E-05,   5.9545386E-05
     +,   6.1282313E-05,   6.2979489E-05,   6.4635293E-05
     +,   6.6249217E-05,   6.7822082E-05,   6.9356065E-05
     +,   7.0854891E-05,   7.2323848E-05,   7.3769872E-05
     +,   7.5201671E-05,   7.6629643E-05,   7.8065939E-05
     +,   7.9524485E-05,   8.1020873E-05,   8.2572384E-05
     +,   8.4197869E-05,   8.5917753E-05,   8.7753870E-05
     +,   8.9729503E-05,   9.1869180E-05,   9.4198796E-05
     +,   9.6745054E-05,   9.9535864E-05,   1.0259979E-04
     +,   1.0596625E-04,   1.0966463E-04,   1.1372379E-04
     +,   1.1817214E-04,   1.2303649E-04,   1.2834118E-04
     +,   1.3410732E-04,   1.4035158E-04,   1.4708521E-04
     +,   1.5431293E-04,   1.6203191E-04,   1.7023107E-04
     +,   1.7889036E-04,   1.8798064E-04,   1.9746374E-04
     +,   2.0729324E-04,   2.1741529E-04,   2.2777032E-04
     +,   2.3829519E-04,   2.4892544E-04,   2.5959848E-04
     +,   2.7025657E-04,   2.8085028E-04,   2.9134162E-04
     +,   3.0170722E-04,   3.1194102E-04,   3.2205498E-04
     +,   3.3208015E-04,   3.4206512E-04,   3.5207265E-04
     +,   3.6217523E-04,   3.7244882E-04,   3.8296467E-04
     +,   3.9378225E-04,   4.0494121E-04,   4.1645579E-04
     +,   4.2831214E-04,   4.4046450E-04,   4.5284579E-04
     +,   4.6536754E-04,   4.7793615E-04,   4.9046532E-04
     +,   5.0289178E-04,   5.1519659E-04,   5.2742037E-04
     +,   5.3968077E-04,   5.5219169E-04,   5.6527014E-04
     +,   5.7935633E-04,   5.9502292E-04,   6.1298528E-04
     +,   6.3411123E-04,   6.5941177E-04,   6.9003028E-04
     +,   7.2718074E-04,   7.7206752E-04,   8.2575990E-04
     +,   8.8902627E-04,   9.6218067E-04,   1.0449180E-03
     +,   1.1362036E-03,   1.2342490E-03,   1.3365161E-03
     +,   1.4398898E-03,   1.5408734E-03,   1.6358702E-03
     +,   1.7215050E-03,   1.7949414E-03,   1.8541779E-03
     +,   1.8982503E-03,   1.9273355E-03,   1.9427004E-03
     +,   1.9465062E-03,   1.9414708E-03,   1.9304224E-03
     +,   1.9158118E-03,   1.8992519E-03,   1.8811814E-03
     +,   1.8607419E-03,   1.8359126E-03,   1.8039270E-03
     +,   1.7618876E-03,   1.7074583E-03,   1.6394665E-03
     +,   1.5582761E-03,   1.4658347E-03,   1.3653946E-03
     +,   1.2610008E-03,   1.1568667E-03,   1.0567929E-03
     +,   9.6373039E-04,   8.7955303E-04,   8.0503226E-04
     +,   7.3997938E-04,   6.8348745E-04,   6.3421344E-04
     +,   5.9064507E-04,   5.5132457E-04,   5.1500474E-04
     +,   4.8074091E-04,   4.4792015E-04,   4.1624127E-04
     +,   3.8566554E-04,   3.5633595E-04,   3.2849851E-04
     +,   3.0243251E-04,   2.7838454E-04,   2.5652861E-04
     +,   2.3693667E-04,   2.1957576E-04,   2.0431582E-04
     +,   1.9094856E-04,   1.7921234E-04,   1.6881883E-04
     +,   1.5947793E-04,   1.5091815E-04,   1.4290190E-04
     +,   1.3523566E-04,   1.2777257E-04,   1.2041144E-04
     +,   1.1309447E-04,   1.0579915E-04,   9.8532437E-05
     +,   9.1321243E-05,   8.4206375E-05,   7.7236014E-05
     +,   7.0460366E-05,   6.3927655E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_nwao_hz_85 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_nwao_hz_90(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   2.5405331E-38,   5.7808780E-38
     +,   1.3095472E-37,   2.9532724E-37,   6.6305690E-37
     +,   1.4824259E-36,   3.2987626E-36,   7.3076611E-36
     +,   1.6116414E-35,   3.5384885E-35,   7.7343987E-35
     +,   1.6830288E-34,   3.6460237E-34,   7.8633400E-34
     +,   1.6883185E-33,   3.6087632E-33,   7.6793422E-33
     +,   1.6268583E-32,   3.4311319E-32,   7.2041406E-32
     +,   1.5058983E-31,   3.1337537E-31,   6.4922196E-31
     +,   1.3390062E-30,   2.7493696E-30,   5.6201118E-30
     +,   1.1437164E-29,   2.3171555E-29,   4.6735901E-29
     +,   9.3844752E-29,   1.8760025E-28,   3.7335007E-28
     +,   7.3971372E-28,   1.4590639E-27,   2.8651584E-27
     +,   5.6012510E-27,   1.0901569E-26,   2.1122936E-26
     +,   4.0746564E-26,   7.8249769E-26,   1.4960662E-25
     +,   2.8475936E-25,   5.3960181E-25,   1.0179718E-24
     +,   1.9119020E-24,   3.5748825E-24,   6.6546681E-24
     +,   1.2332801E-23,   2.2754464E-23,   4.1796511E-23
     +,   7.6433863E-23,   1.3915742E-22,   2.5222938E-22
     +,   4.5515325E-22,   8.1769202E-22,   1.4625118E-21
     +,   2.6042574E-21,   4.6168137E-21,   8.1485247E-21
     +,   1.4318293E-20,   2.5048494E-20,   4.3626569E-20
     +,   7.5648510E-20,   1.3059618E-19,   2.2446259E-19
     +,   3.8409496E-19,   6.5436139E-19,   1.1098897E-18
     +,   1.8742583E-18,   3.1511191E-18,   5.2745929E-18
     +,   8.7903334E-18,   1.4585037E-17,   2.4093594E-17
     +,   3.9626554E-17,   6.4887488E-17,   1.0578729E-16
     +,   1.7171301E-16,   2.7750380E-16,   4.4651993E-16
     +,   7.1532520E-16,   1.1409253E-15,   1.8118812E-15
     +,   2.8648088E-15,   4.5098884E-15,   7.0687064E-15
     +,   1.1031146E-14,   1.7139864E-14,   2.6515675E-14
     +,   4.0841923E-14,   6.2635349E-14,   9.5641052E-14
     +,   1.4540528E-13,   2.2010434E-13,   3.3173429E-13
     +,   4.9781322E-13,   7.4380188E-13,   1.1065313E-12
     +,   1.6390277E-12,   2.4172721E-12,   3.5496200E-12
     +,   5.1898577E-12,   7.5552299E-12,   1.0951086E-11
     +,   1.5804904E-11,   2.2711118E-11,   3.2493504E-11
     +,   4.6289906E-11,   6.5657979E-11,   9.2727083E-11
     +,   1.3038971E-10,   1.8255651E-10,   2.5448813E-10
     +,   3.5322692E-10,   4.8815263E-10,   6.7169487E-10
     +,   9.2024066E-10,   1.2552906E-09,   1.7048993E-09
     +,   2.3054887E-09,   3.1041119E-09,   4.1612065E-09
     +,   5.5540288E-09,   7.3807844E-09,   9.7656416E-09
     +,   1.2864751E-08,   1.6873431E-08,   2.2034580E-08
     +,   2.8648691E-08,   3.7085247E-08,   4.7796156E-08
     +,   6.1330880E-08,   7.8353430E-08,   9.9661790E-08
     +,   1.2620902E-07,   1.5912636E-07,   1.9974837E-07
     +,   2.4963995E-07,   3.1062348E-07,   3.8480803E-07
     +,   4.7461870E-07,   5.8282342E-07,   7.1256841E-07
     +,   8.6736992E-07,   1.0512055E-06,   1.2684386E-06
     +,   1.5239027E-06,   1.8228709E-06,   2.1710564E-06
     +,   2.5745969E-06,   3.0400270E-06,   3.5742414E-06
     +,   4.1844401E-06,   4.8780685E-06,   5.6627309E-06
     +,   6.5461063E-06,   7.5358384E-06,   8.6394166E-06
     +,   9.8640530E-06,   1.1216544E-05,   1.2703122E-05
     +,   1.4329313E-05,   1.6099799E-05,   1.8018265E-05
     +,   2.0087278E-05,   2.2308202E-05,   2.4681192E-05
     +,   2.7204782E-05,   2.9876514E-05,   3.2692471E-05
     +,   3.5648074E-05,   3.8737751E-05,   4.1955234E-05
     +,   4.5294742E-05,   4.8751015E-05,   5.2320174E-05
     +,   5.6000463E-05,   5.9793118E-05,   6.3703133E-05
     +,   6.7740191E-05,   7.1919312E-05,   7.6261480E-05
     +,   8.0794147E-05,   8.5551408E-05,   9.0574060E-05
     +,   9.5909229E-05,   1.0161003E-04,   1.0773435E-04
     +,   1.1434401E-04,   1.2150319E-04,   1.2927703E-04
     +,   1.3773094E-04,   1.4693070E-04,   1.5694568E-04
     +,   1.6785534E-04,   1.7976188E-04,   1.9280870E-04
     +,   2.0720623E-04,   2.2326040E-04,   2.4140051E-04
     +,   2.6219568E-04,   2.8635075E-04,   3.1466916E-04
     +,   3.4797785E-04,   3.8701433E-04,   4.3229150E-04
     +,   4.8396923E-04,   5.4175901E-04,   6.0495635E-04
     +,   6.7257183E-04,   7.4367126E-04,   8.1787567E-04
     +,   8.9594605E-04,   9.8033389E-04,   1.0753822E-03
     +,   1.1869337E-03,   1.3211666E-03,   1.4826116E-03
     +,   1.6719244E-03,   1.8839670E-03,   2.1071108E-03
     +,   2.3242745E-03,   2.5155968E-03,   2.6622706E-03
     +,   2.7501467E-03,   2.7723878E-03,   2.7303568E-03
     +,   2.6327954E-03,   2.4936986E-03,   2.3296054E-03
     +,   2.1569957E-03,   1.9902538E-03,   1.8406594E-03
     +,   1.7161347E-03,   1.6217761E-03,   1.5605914E-03
     +,   1.5340252E-03,   1.5419595E-03,   1.5821733E-03
     +,   1.6495542E-03,   1.7356190E-03,   1.8288901E-03
     +,   1.9163925E-03,   1.9861443E-03,   2.0299535E-03
     +,   2.0456016E-03,   2.0375315E-03,   2.0156018E-03
     +,   1.9921267E-03,   1.9780551E-03,   1.9795103E-03
     +,   1.9958548E-03,   2.0199062E-03,   2.0402195E-03
     +,   2.0446084E-03,   2.0236601E-03,   1.9731205E-03
     +,   1.8944765E-03,   1.7938333E-03,   1.6797315E-03
     +,   1.5608059E-03,   1.4440560E-03,   1.3340672E-03
     +,   1.2331053E-03,   1.1417257E-03,   1.0594932E-03
     +,   9.8553882E-04,   9.1885834E-04,   8.5841032E-04
     +,   8.0311869E-04,   7.5187889E-04,   7.0360454E-04
     +,   6.5731903E-04,   6.1223685E-04,   5.6783058E-04
     +,   5.2386336E-04,   4.8035913E-04,   4.3755895E-04
     +,   3.9583797E-04,   3.5563813E-04,   3.1740026E-04
     +,   2.8151178E-04,   2.4827308E-04,   2.1788088E-04
     +,   1.9042537E-04,   1.6589889E-04,   1.4421029E-04
     +,   1.2520715E-04,   1.0869018E-04,   9.4432187E-05
     +,   8.2196311E-05,   7.1744937E-05,   6.2850791E-05
     +,   5.5300381E-05,   4.8899303E-05,   4.3473286E-05
     +,   3.8868387E-05,   3.4950339E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_nwao_hz_90 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_nwao_hz_95(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  4.7382711E-09,   5.4364091E-09
     +,   6.2298033E-09,   7.1302941E-09,   8.1509999E-09
     +,   9.3064720E-09,   1.0612793E-08,   1.2087740E-08
     +,   1.3750900E-08,   1.5623877E-08,   1.7730310E-08
     +,   2.0096218E-08,   2.2750100E-08,   2.5723107E-08
     +,   2.9049190E-08,   3.2765428E-08,   3.6912091E-08
     +,   4.1532921E-08,   4.6675350E-08,   5.2390671E-08
     +,   5.8734248E-08,   6.5765839E-08,   7.3549707E-08
     +,   8.2154962E-08,   9.1655302E-08,   1.0212992E-07
     +,   1.1366328E-07,   1.2634547E-07,   1.4027198E-07
     +,   1.5554451E-07,   1.7227039E-07,   1.9056333E-07
     +,   2.1054289E-07,   2.3233498E-07,   2.5607179E-07
     +,   2.8189163E-07,   3.0993874E-07,   3.4036375E-07
     +,   3.7332291E-07,   4.0897802E-07,   4.4749663E-07
     +,   4.8905207E-07,   5.3381837E-07,   5.8198123E-07
     +,   6.3372249E-07,   6.8923185E-07,   7.4869968E-07
     +,   8.1231957E-07,   8.8028509E-07,   9.5278995E-07
     +,   1.0300286E-06,   1.1121923E-06,   1.1994707E-06
     +,   1.2920492E-06,   1.3901117E-06,   1.4938277E-06
     +,   1.6033674E-06,   1.7188900E-06,   1.8405445E-06
     +,   1.9684699E-06,   2.1027911E-06,   2.2436211E-06
     +,   2.3910561E-06,   2.5451782E-06,   2.7060501E-06
     +,   2.8737156E-06,   3.0482011E-06,   3.2295090E-06
     +,   3.4176226E-06,   3.6124991E-06,   3.8140761E-06
     +,   4.0222635E-06,   4.2369493E-06,   4.4579938E-06
     +,   4.6852388E-06,   4.9184873E-06,   5.1575289E-06
     +,   5.4021252E-06,   5.6520084E-06,   5.9069034E-06
     +,   6.1664946E-06,   6.4304550E-06,   6.6984453E-06
     +,   6.9700736E-06,   7.2449561E-06,   7.5227267E-06
     +,   7.8029407E-06,   8.0851878E-06,   8.3690365E-06
     +,   8.6540531E-06,   8.9397990E-06,   9.2258388E-06
     +,   9.5117393E-06,   9.7970697E-06,   1.0081416E-05
     +,   1.0364372E-05,   1.0645545E-05,   1.0924567E-05
     +,   1.1201083E-05,   1.1474770E-05,   1.1745327E-05
     +,   1.2012485E-05,   1.2276004E-05,   1.2535678E-05
     +,   1.2791344E-05,   1.3042864E-05,   1.3290150E-05
     +,   1.3533158E-05,   1.3771860E-05,   1.4006286E-05
     +,   1.4236537E-05,   1.4462702E-05,   1.4684943E-05
     +,   1.4903465E-05,   1.5118500E-05,   1.5330324E-05
     +,   1.5539255E-05,   1.5745643E-05,   1.5949867E-05
     +,   1.6152339E-05,   1.6353506E-05,   1.6553831E-05
     +,   1.6753809E-05,   1.6953945E-05,   1.7154773E-05
     +,   1.7356826E-05,   1.7560655E-05,   1.7766824E-05
     +,   1.7975892E-05,   1.8188412E-05,   1.8404953E-05
     +,   1.8626062E-05,   1.8852284E-05,   1.9084149E-05
     +,   1.9322171E-05,   1.9566849E-05,   1.9818655E-05
     +,   2.0078051E-05,   2.0345449E-05,   2.0621253E-05
     +,   2.0905825E-05,   2.1199494E-05,   2.1502550E-05
     +,   2.1815244E-05,   2.2137785E-05,   2.2470345E-05
     +,   2.2812999E-05,   2.3165869E-05,   2.3528915E-05
     +,   2.3902110E-05,   2.4285353E-05,   2.4678482E-05
     +,   2.5081292E-05,   2.5493511E-05,   2.5914829E-05
     +,   2.6344895E-05,   2.6783326E-05,   2.7229724E-05
     +,   2.7683713E-05,   2.8144939E-05,   2.8613125E-05
     +,   2.9088116E-05,   2.9569919E-05,   3.0058765E-05
     +,   3.0555213E-05,   3.1060197E-05,   3.1575149E-05
     +,   3.2102093E-05,   3.2643769E-05,   3.3203771E-05
     +,   3.3786593E-05,   3.4397890E-05,   3.5044508E-05
     +,   3.5734716E-05,   3.6478225E-05,   3.7286307E-05
     +,   3.8172046E-05,   3.9150356E-05,   4.0238185E-05
     +,   4.1454594E-05,   4.2821088E-05,   4.4361768E-05
     +,   4.6103745E-05,   4.8077523E-05,   5.0317576E-05
     +,   5.2862975E-05,   5.5758141E-05,   5.9053695E-05
     +,   6.2807267E-05,   6.7084264E-05,   7.1958486E-05
     +,   7.7512406E-05,   8.3836887E-05,   9.1030437E-05
     +,   9.9197430E-05,   1.0844549E-04,   1.1888184E-04
     +,   1.3060846E-04,   1.4371629E-04,   1.5827858E-04
     +,   1.7434382E-04,   1.9192825E-04,   2.1100930E-04
     +,   2.3152045E-04,   2.5334911E-04,   2.7633950E-04
     +,   3.0030365E-04,   3.2504252E-04,   3.5038203E-04
     +,   3.7622536E-04,   4.0261523E-04,   4.2982187E-04
     +,   4.5840984E-04,   4.8930180E-04,   5.2379962E-04
     +,   5.6353852E-04,   6.1038544E-04,   6.6625443E-04
     +,   7.3288241E-04,   8.1161468E-04,   9.0317742E-04
     +,   1.0075645E-03,   1.1239197E-03,   1.2504479E-03
     +,   1.3843084E-03,   1.5214968E-03,   1.6569766E-03
     +,   1.7850838E-03,   1.9005943E-03,   2.0003493E-03
     +,   2.0850883E-03,   2.1609035E-03,   2.2393938E-03
     +,   2.3360178E-03,   2.4665624E-03,   2.6423268E-03
     +,   2.8656248E-03,   3.1272462E-03,   3.4075808E-03
     +,   3.6817647E-03,   3.9274576E-03,   4.1320920E-03
     +,   4.2959456E-03,   4.4290237E-03,   4.5430395E-03
     +,   4.6430454E-03,   4.7239196E-03,   4.7741639E-03
     +,   4.7848956E-03,   4.7588688E-03,   4.7144792E-03
     +,   4.6818289E-03,   4.6909158E-03,   4.7553605E-03
     +,   4.8592808E-03,   4.9567190E-03,   4.9881670E-03
     +,   4.9077347E-03,   4.7053951E-03,   4.4108573E-03
     +,   4.0782546E-03,   3.7631800E-03,   3.5057180E-03
     +,   3.3250835E-03,   3.2224532E-03,   3.1858720E-03
     +,   3.1942870E-03,   3.2215253E-03,   3.2414510E-03
     +,   3.2335755E-03,   3.1868634E-03,   3.1000620E-03
     +,   2.9788788E-03,   2.8318509E-03,   2.6669018E-03
     +,   2.4896562E-03,   2.3033710E-03,   2.1098806E-03
     +,   1.9108144E-03,   1.7084377E-03,   1.5060571E-03
     +,   1.3078236E-03,   1.1182519E-03,   9.4156695E-04
     +,   7.8113098E-04,   6.3908374E-04,   5.1624968E-04
     +,   4.1226984E-04,   3.2587865E-04,   2.5523046E-04
     +,   1.9822034E-04,   1.5271231E-04,   1.1670884E-04
     +,   8.8448440E-05,   6.6427536E-05,   4.9398765E-05
     +,   3.6338133E-05,   2.6414300E-05,   1.8953955E-05
     +,   1.3412765E-05,   9.3518420E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_nwao_hz_95 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_nwao_qq(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  3.0879782E-37,   6.5024307E-37
     +,   1.3641130E-36,   2.8509618E-36,   5.9361600E-36
     +,   1.2313824E-35,   2.5447596E-35,   5.2393052E-35
     +,   1.0746584E-34,   2.1960737E-34,   4.4707802E-34
     +,   9.0676091E-34,   1.8321964E-33,   3.6882847E-33
     +,   7.3968474E-33,   1.4778781E-32,   2.9417140E-32
     +,   5.8336052E-32,   1.1524936E-31,   2.2683740E-31
     +,   4.4479578E-31,   8.6891988E-31,   1.6910978E-30
     +,   3.2789318E-30,   6.3337742E-30,   1.2188801E-29
     +,   2.3368587E-29,   4.4634979E-29,   8.4935268E-29
     +,   1.6101658E-28,   3.0410571E-28,   5.7220289E-28
     +,   1.0726186E-27,   2.0031434E-27,   3.7269210E-27
     +,   6.9080935E-27,   1.2756631E-26,   2.3468584E-26
     +,   4.3013618E-26,   7.8541321E-26,   1.4287629E-25
     +,   2.5894066E-25,   4.6751644E-25,   8.4096231E-25
     +,   1.5070329E-24,   2.6905251E-24,   4.7854689E-24
     +,   8.4797246E-24,   1.4969609E-23,   2.6327562E-23
     +,   4.6129699E-23,   8.0523084E-23,   1.4003341E-22
     +,   2.4261315E-22,   4.1876642E-22,   7.2010500E-22
     +,   1.2336433E-21,   2.1055061E-21,   3.5800841E-21
     +,   6.0645425E-21,   1.0234721E-20,   1.7207740E-20
     +,   2.8823257E-20,   4.8098746E-20,   7.9964261E-20
     +,   1.3244216E-19,   2.1853853E-19,   3.5925509E-19
     +,   5.8836602E-19,   9.5997795E-19,   1.5604377E-18
     +,   2.5269822E-18,   4.0769019E-18,   6.5528057E-18
     +,   1.0493027E-17,   1.6739432E-17,   2.6604220E-17
     +,   4.2124202E-17,   6.6447498E-17,   1.0442439E-16
     +,   1.6349145E-16,   2.5501142E-16,   3.9628018E-16
     +,   6.1349103E-16,   9.4618578E-16,   1.4538882E-15
     +,   2.2256125E-15,   3.3942042E-15,   5.1570089E-15
     +,   7.8059956E-15,   1.1771436E-14,   1.7684843E-14
     +,   2.6469419E-14,   3.9469123E-14,   5.8632976E-14
     +,   8.6775483E-14,   1.2794509E-13,   1.8794035E-13
     +,   2.7503442E-13,   4.0098261E-13,   5.8241785E-13
     +,   8.4278044E-13,   1.2149679E-12,   1.7449613E-12
     +,   2.4967686E-12,   3.5591031E-12,   5.0544551E-12
     +,   7.1513125E-12,   1.0080015E-11,   1.4154698E-11
     +,   1.9802660E-11,   2.7600139E-11,   3.8323896E-11
     +,   5.3014988E-11,   7.3063208E-11,   1.0031581E-10
     +,   1.3721803E-10,   1.8699202E-10,   2.5386693E-10
     +,   3.4336828E-10,   4.6268434E-10,   6.2112604E-10
     +,   8.3070445E-10,   1.1068366E-09,   1.4692347E-09
     +,   1.9429849E-09,   2.5598750E-09,   3.3599985E-09
     +,   4.3936970E-09,   5.7238960E-09,   7.4288913E-09
     +,   9.6056629E-09,   1.2373761E-08,   1.5879849E-08
     +,   2.0303071E-08,   2.5861189E-08,   3.2817496E-08
     +,   4.1489049E-08,   5.2255537E-08,   6.5569523E-08
     +,   8.1967691E-08,   1.0208315E-07,   1.2665903E-07
     +,   1.5656303E-07,   1.9280284E-07,   2.3654412E-07
     +,   2.8911771E-07,   3.5205929E-07,   4.2709510E-07
     +,   5.1618457E-07,   6.2152264E-07,   7.4555703E-07
     +,   8.9099973E-07,   1.0608334E-06,   1.2583184E-06
     +,   1.4869910E-06,   1.7506596E-06,   2.0533930E-06
     +,   2.3995012E-06,   2.7935123E-06,   3.2401376E-06
     +,   3.7442342E-06,   4.3107520E-06,   4.9446826E-06
     +,   5.6509989E-06,   6.4345832E-06,   7.3001725E-06
     +,   8.2522638E-06,   9.2950813E-06,   1.0432546E-05
     +,   1.1668026E-05,   1.3004605E-05,   1.4444801E-05
     +,   1.5990880E-05,   1.7644566E-05,   1.9407111E-05
     +,   2.1279700E-05,   2.3263347E-05,   2.5359121E-05
     +,   2.7568340E-05,   2.9892841E-05,   3.2335225E-05
     +,   3.4899185E-05,   3.7589773E-05,   4.0413801E-05
     +,   4.3380107E-05,   4.6499972E-05,   4.9787352E-05
     +,   5.3259297E-05,   5.6936176E-05,   6.0842052E-05
     +,   6.5004868E-05,   6.9456750E-05,   7.4234238E-05
     +,   7.9378471E-05,   8.4935382E-05,   9.0955749E-05
     +,   9.7495140E-05,   1.0461381E-04,   1.1237609E-04
     +,   1.2084972E-04,   1.3010460E-04,   1.4021073E-04
     +,   1.5123594E-04,   1.6324224E-04,   1.7628176E-04
     +,   1.9039157E-04,   2.0558758E-04,   2.2185806E-04
     +,   2.3915721E-04,   2.5739500E-04,   2.7643799E-04
     +,   2.9609783E-04,   3.1613209E-04,   3.3624590E-04
     +,   3.5609317E-04,   3.7529221E-04,   3.9343798E-04
     +,   4.1012402E-04,   4.2497399E-04,   4.3766756E-04
     +,   4.4798467E-04,   4.5584052E-04,   4.6132490E-04
     +,   4.6473526E-04,   4.6660012E-04,   4.6769163E-04
     +,   4.6901632E-04,   4.7178721E-04,   4.7737037E-04
     +,   4.8720677E-04,   5.0271390E-04,   5.2516937E-04
     +,   5.5558566E-04,   5.9459597E-04,   6.4233236E-04
     +,   6.9836195E-04,   7.6163735E-04,   8.3050446E-04
     +,   9.0275996E-04,   9.7576284E-04,   1.0465913E-03
     +,   1.1122442E-03,   1.1698640E-03,   1.2169739E-03
     +,   1.2516998E-03,   1.2729657E-03,   1.2806280E-03
     +,   1.2755380E-03,   1.2595113E-03,   1.2351999E-03
     +,   1.2058688E-03,   1.1750966E-03,   1.1464289E-03
     +,   1.1230309E-03,   1.1073748E-03,   1.1010192E-03
     +,   1.1045035E-03,   1.1173781E-03,   1.1383654E-03
     +,   1.1656202E-03,   1.1970486E-03,   1.2306285E-03
     +,   1.2646697E-03,   1.2979787E-03,   1.3298913E-03
     +,   1.3601817E-03,   1.3888673E-03,   1.4159562E-03
     +,   1.4412011E-03,   1.4639080E-03,   1.4828534E-03
     +,   1.4963270E-03,   1.5023014E-03,   1.4986915E-03
     +,   1.4836611E-03,   1.4559155E-03,   1.4149192E-03
     +,   1.3610206E-03,   1.2954373E-03,   1.2201465E-03
     +,   1.1376536E-03,   1.0507391E-03,   9.6218497E-04
     +,   8.7453844E-04,   7.8993116E-04,   7.0997677E-04
     +,   6.3574087E-04,   5.6777353E-04,   5.0618564E-04
     +,   4.5076231E-04,   4.0106004E-04,   3.5651017E-04
     +,   3.1651359E-04,   2.8049244E-04,   2.4793774E-04
     +,   2.1841949E-04,   1.9159689E-04,   1.6720935E-04
     +,   1.4506250E-04,   1.2501139E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_nwao_qq = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_nwao_ww(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  3.8730846E-06,   3.8585049E-06
     +,   3.8433295E-06,   3.8275657E-06,   3.8112223E-06
     +,   3.7943062E-06,   3.7768261E-06,   3.7587904E-06
     +,   3.7402085E-06,   3.7210875E-06,   3.7014388E-06
     +,   3.6812714E-06,   3.6605938E-06,   3.6394172E-06
     +,   3.6177498E-06,   3.5956041E-06,   3.5729890E-06
     +,   3.5499149E-06,   3.5263940E-06,   3.5024357E-06
     +,   3.4780514E-06,   3.4532532E-06,   3.4280513E-06
     +,   3.4024574E-06,   3.3764834E-06,   3.3501408E-06
     +,   3.3234417E-06,   3.2963972E-06,   3.2690198E-06
     +,   3.2413211E-06,   3.2133134E-06,   3.1850091E-06
     +,   3.1564198E-06,   3.1275579E-06,   3.0984356E-06
     +,   3.0690651E-06,   3.0394588E-06,   3.0096287E-06
     +,   2.9795874E-06,   2.9493467E-06,   2.9189189E-06
     +,   2.8883157E-06,   2.8575512E-06,   2.8266350E-06
     +,   2.7955809E-06,   2.7643998E-06,   2.7331041E-06
     +,   2.7017056E-06,   2.6702160E-06,   2.6386469E-06
     +,   2.6070099E-06,   2.5753166E-06,   2.5435781E-06
     +,   2.5118056E-06,   2.4800102E-06,   2.4482031E-06
     +,   2.4163953E-06,   2.3845973E-06,   2.3528198E-06
     +,   2.3210730E-06,   2.2893671E-06,   2.2577124E-06
     +,   2.2261188E-06,   2.1945962E-06,   2.1631542E-06
     +,   2.1318019E-06,   2.1005490E-06,   2.0694044E-06
     +,   2.0383766E-06,   2.0074754E-06,   1.9767083E-06
     +,   1.9460840E-06,   1.9156107E-06,   1.8852965E-06
     +,   1.8551481E-06,   1.8251751E-06,   1.7953838E-06
     +,   1.7657816E-06,   1.7363764E-06,   1.7071733E-06
     +,   1.6781803E-06,   1.6494032E-06,   1.6208479E-06
     +,   1.5925231E-06,   1.5644347E-06,   1.5365849E-06
     +,   1.5089838E-06,   1.4816351E-06,   1.4545453E-06
     +,   1.4277197E-06,   1.4011644E-06,   1.3748844E-06
     +,   1.3488855E-06,   1.3231735E-06,   1.2977537E-06
     +,   1.2726325E-06,   1.2478156E-06,   1.2233089E-06
     +,   1.1991193E-06,   1.1752529E-06,   1.1517170E-06
     +,   1.1285192E-06,   1.1056670E-06,   1.0831693E-06
     +,   1.0610349E-06,   1.0392739E-06,   1.0178965E-06
     +,   9.9691374E-07,   9.7633961E-07,   9.5618827E-07
     +,   9.3647196E-07,   9.1720960E-07,   8.9841848E-07
     +,   8.8011802E-07,   8.6232995E-07,   8.4507803E-07
     +,   8.2838784E-07,   8.1228762E-07,   7.9680831E-07
     +,   7.8198337E-07,   7.6784960E-07,   7.5444660E-07
     +,   7.4181793E-07,   7.3001075E-07,   7.1907562E-07
     +,   7.0906754E-07,   7.0004660E-07,   6.9207607E-07
     +,   6.8522542E-07,   6.7956853E-07,   6.7518471E-07
     +,   6.7215893E-07,   6.7058164E-07,   6.7054958E-07
     +,   6.7216524E-07,   6.7553776E-07,   6.8078248E-07
     +,   6.8802137E-07,   6.9738275E-07,   7.0900245E-07
     +,   7.2302203E-07,   7.3959097E-07,   7.5886413E-07
     +,   7.8100453E-07,   8.0618065E-07,   8.3456933E-07
     +,   8.6634827E-07,   9.0171085E-07,   9.4084623E-07
     +,   9.8395503E-07,   1.0312413E-06,   1.0829147E-06
     +,   1.1391882E-06,   1.2002803E-06,   1.2664115E-06
     +,   1.3378068E-06,   1.4146932E-06,   1.4973003E-06
     +,   1.5858584E-06,   1.6806011E-06,   1.7817609E-06
     +,   1.8895718E-06,   2.0042683E-06,   2.1260835E-06
     +,   2.2552517E-06,   2.3920059E-06,   2.5365787E-06
     +,   2.6892028E-06,   2.8501101E-06,   3.0195404E-06
     +,   3.1977127E-06,   3.3848683E-06,   3.5812350E-06
     +,   3.7870698E-06,   4.0026175E-06,   4.2281108E-06
     +,   4.4638164E-06,   4.7099979E-06,   4.9669347E-06
     +,   5.2349160E-06,   5.5142491E-06,   5.8052569E-06
     +,   6.1082819E-06,   6.4236920E-06,   6.7518799E-06
     +,   7.0932665E-06,   7.4483055E-06,   7.8174817E-06
     +,   8.2013203E-06,   8.6003838E-06,   9.0152780E-06
     +,   9.4466532E-06,   9.8952041E-06,   1.0361677E-05
     +,   1.0846862E-05,   1.1351604E-05,   1.1876799E-05
     +,   1.2423387E-05,   1.2992363E-05,   1.3584771E-05
     +,   1.4201692E-05,   1.4844259E-05,   1.5513640E-05
     +,   1.6211035E-05,   1.6937671E-05,   1.7694803E-05
     +,   1.8483694E-05,   1.9305615E-05,   2.0161835E-05
     +,   2.1053642E-05,   2.1982145E-05,   2.2948660E-05
     +,   2.3954281E-05,   2.5000090E-05,   2.6087126E-05
     +,   2.7216212E-05,   2.8388195E-05,   2.9603743E-05
     +,   3.0863350E-05,   3.2167562E-05,   3.3516440E-05
     +,   3.4910066E-05,   3.6348272E-05,   3.7830683E-05
     +,   3.9356739E-05,   4.0925432E-05,   4.2535830E-05
     +,   4.4186527E-05,   4.5875888E-05,   4.7602080E-05
     +,   4.9362770E-05,   5.1155559E-05,   5.2977673E-05
     +,   5.4825996E-05,   5.6697423E-05,   5.8588103E-05
     +,   6.0494207E-05,   6.2411586E-05,   6.4335858E-05
     +,   6.6262335E-05,   6.8186178E-05,   7.0102309E-05
     +,   7.2005460E-05,   7.3890216E-05,   7.5751042E-05
     +,   7.7582248E-05,   7.9378100E-05,   8.1132799E-05
     +,   8.2840532E-05,   8.4495477E-05,   8.6091881E-05
     +,   8.7624052E-05,   8.9086374E-05,   9.0473433E-05
     +,   9.1779941E-05,   9.3000832E-05,   9.4131276E-05
     +,   9.5166710E-05,   9.6102885E-05,   9.6935801E-05
     +,   9.7661949E-05,   9.8278004E-05,   9.8781209E-05
     +,   9.9169112E-05,   9.9439741E-05,   9.9591532E-05
     +,   9.9623394E-05,   9.9534715E-05,   9.9325283E-05
     +,   9.8995479E-05,   9.8545985E-05,   9.7978053E-05
     +,   9.7293385E-05,   9.6494099E-05,   9.5582735E-05
     +,   9.4562311E-05,   9.3436254E-05,   9.2208196E-05
     +,   9.0882306E-05,   8.9462956E-05,   8.7954999E-05
     +,   8.6363441E-05,   8.4693485E-05,   8.2950646E-05
     +,   8.1140592E-05,   7.9269121E-05,   7.7342178E-05
     +,   7.5365773E-05,   7.3346004E-05,   7.1288858E-05
     +,   6.9200614E-05,   6.7087298E-05,   6.4954729E-05
     +,   6.2808860E-05,   6.0655380E-05,   5.8500056E-05
     +,   5.6348224E-05,   5.4205131E-05,   5.2075793E-05
     +,   4.9965005E-05,   4.7877285E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_nwao_ww = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_nwao_zz(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  6.2072559E-06,   6.2387103E-06
     +,   6.2648651E-06,   6.2856520E-06,   6.3010184E-06
     +,   6.3109237E-06,   6.3153407E-06,   6.3142602E-06
     +,   6.3076836E-06,   6.2956292E-06,   6.2781278E-06
     +,   6.2552267E-06,   6.2269837E-06,   6.1934729E-06
     +,   6.1547821E-06,   6.1110109E-06,   6.0622720E-06
     +,   6.0086904E-06,   5.9504009E-06,   5.8875535E-06
     +,   5.8203054E-06,   5.7488242E-06,   5.6732874E-06
     +,   5.5938795E-06,   5.5107962E-06,   5.4242396E-06
     +,   5.3344133E-06,   5.2415321E-06,   5.1458123E-06
     +,   5.0474773E-06,   4.9467521E-06,   4.8438615E-06
     +,   4.7390390E-06,   4.6325140E-06,   4.5245179E-06
     +,   4.4152821E-06,   4.3050377E-06,   4.1940157E-06
     +,   4.0824425E-06,   3.9705451E-06,   3.8585463E-06
     +,   3.7466648E-06,   3.6351246E-06,   3.5241303E-06
     +,   3.4139005E-06,   3.3046385E-06,   3.1965478E-06
     +,   3.0898284E-06,   2.9846756E-06,   2.8812824E-06
     +,   2.7798383E-06,   2.6805303E-06,   2.5835427E-06
     +,   2.4890574E-06,   2.3972539E-06,   2.3083162E-06
     +,   2.2224215E-06,   2.1397500E-06,   2.0604834E-06
     +,   1.9848039E-06,   1.9128968E-06,   1.8449520E-06
     +,   1.7811608E-06,   1.7217220E-06,   1.6668387E-06
     +,   1.6167207E-06,   1.5715854E-06,   1.5316571E-06
     +,   1.4971694E-06,   1.4683651E-06,   1.4454952E-06
     +,   1.4288224E-06,   1.4186182E-06,   1.4151647E-06
     +,   1.4187543E-06,   1.4296899E-06,   1.4482832E-06
     +,   1.4748562E-06,   1.5097372E-06,   1.5532664E-06
     +,   1.6057859E-06,   1.6676454E-06,   1.7392005E-06
     +,   1.8207990E-06,   1.9127940E-06,   2.0155487E-06
     +,   2.1293954E-06,   2.2546767E-06,   2.3917191E-06
     +,   2.5408351E-06,   2.7023195E-06,   2.8764459E-06
     +,   3.0634635E-06,   3.2635930E-06,   3.4770226E-06
     +,   3.7039042E-06,   3.9443507E-06,   4.1984313E-06
     +,   4.4661651E-06,   4.7475237E-06,   5.0424237E-06
     +,   5.3507247E-06,   5.6722265E-06,   6.0066659E-06
     +,   6.3537191E-06,   6.7129959E-06,   7.0840383E-06
     +,   7.4663449E-06,   7.8592966E-06,   8.2622437E-06
     +,   8.6745285E-06,   9.0953290E-06,   9.5238456E-06
     +,   9.9592062E-06,   1.0400493E-05,   1.0846750E-05
     +,   1.1297001E-05,   1.1750233E-05,   1.2205423E-05
     +,   1.2661543E-05,   1.3117570E-05,   1.3572484E-05
     +,   1.4025303E-05,   1.4475062E-05,   1.4920850E-05
     +,   1.5361804E-05,   1.5797119E-05,   1.6226062E-05
     +,   1.6647986E-05,   1.7062313E-05,   1.7468572E-05
     +,   1.7866376E-05,   1.8255441E-05,   1.8635590E-05
     +,   1.9006728E-05,   1.9368881E-05,   1.9722153E-05
     +,   2.0066744E-05,   2.0402933E-05,   2.0731075E-05
     +,   2.1051586E-05,   2.1364925E-05,   2.1671598E-05
     +,   2.1972111E-05,   2.2266990E-05,   2.2556755E-05
     +,   2.2841839E-05,   2.3122710E-05,   2.3399691E-05
     +,   2.3673059E-05,   2.3942974E-05,   2.4209501E-05
     +,   2.4472554E-05,   2.4731922E-05,   2.4987232E-05
     +,   2.5237985E-05,   2.5483521E-05,   2.5723026E-05
     +,   2.5955565E-05,   2.6180076E-05,   2.6395381E-05
     +,   2.6600248E-05,   2.6793354E-05,   2.6973403E-05
     +,   2.7139115E-05,   2.7289250E-05,   2.7422746E-05
     +,   2.7538685E-05,   2.7636401E-05,   2.7715545E-05
     +,   2.7776101E-05,   2.7818522E-05,   2.7843740E-05
     +,   2.7853253E-05,   2.7849141E-05,   2.7834159E-05
     +,   2.7811724E-05,   2.7785953E-05,   2.7761660E-05
     +,   2.7744340E-05,   2.7740110E-05,   2.7755648E-05
     +,   2.7798103E-05,   2.7874974E-05,   2.7993978E-05
     +,   2.8162884E-05,   2.8389302E-05,   2.8680557E-05
     +,   2.9043422E-05,   2.9483961E-05,   3.0007315E-05
     +,   3.0617575E-05,   3.1317544E-05,   3.2108717E-05
     +,   3.2991124E-05,   3.3963319E-05,   3.5022371E-05
     +,   3.6163961E-05,   3.7382422E-05,   3.8670965E-05
     +,   4.0021820E-05,   4.1426665E-05,   4.2876876E-05
     +,   4.4364107E-05,   4.5880752E-05,   4.7420828E-05
     +,   4.8980623E-05,   5.0559884E-05,   5.2162799E-05
     +,   5.3799278E-05,   5.5485943E-05,   5.7247802E-05
     +,   5.9118771E-05,   6.1142448E-05,   6.3372456E-05
     +,   6.5871529E-05,   6.8710688E-05,   7.1966679E-05
     +,   7.5718483E-05,   8.0044163E-05,   8.5014130E-05
     +,   9.0686750E-05,   9.7101998E-05,   1.0427558E-04
     +,   1.1219424E-04,   1.2080998E-04,   1.3004187E-04
     +,   1.3977225E-04,   1.4985193E-04,   1.6010650E-04
     +,   1.7034316E-04,   1.8036613E-04,   1.8998836E-04
     +,   1.9904788E-04,   2.0742476E-04,   2.1505164E-04
     +,   2.2192848E-04,   2.2812684E-04,   2.3379071E-04
     +,   2.3913059E-04,   2.4440902E-04,   2.4992193E-04
     +,   2.5597296E-04,   2.6284638E-04,   2.7077890E-04
     +,   2.7993330E-04,   2.9038003E-04,   3.0208207E-04
     +,   3.1489300E-04,   3.2856109E-04,   3.4274621E-04
     +,   3.5704116E-04,   3.7100067E-04,   3.8417213E-04
     +,   3.9612790E-04,   4.0649294E-04,   4.1496925E-04
     +,   4.2135126E-04,   4.2553587E-04,   4.2752016E-04
     +,   4.2739435E-04,   4.2532451E-04,   4.2153095E-04
     +,   4.1626347E-04,   4.0977407E-04,   4.0229631E-04
     +,   3.9402509E-04,   3.8510709E-04,   3.7563709E-04
     +,   3.6566454E-04,   3.5520419E-04,   3.4425280E-04
     +,   3.3280542E-04,   3.2087025E-04,   3.0847947E-04
     +,   2.9569477E-04,   2.8260361E-04,   2.6931195E-04
     +,   2.5593661E-04,   2.4259083E-04,   2.2937531E-04
     +,   2.1636768E-04,   2.0362029E-04,   1.9116022E-04
     +,   1.7899359E-04,   1.6711224E-04,   1.5550261E-04
     +,   1.4415305E-04,   1.3306054E-04,   1.2223453E-04
     +,   1.1169992E-04,   1.0149358E-04,   9.1661394E-05
     +,   8.2255749E-05,   7.3328658E-05,   6.4928914E-05
     +,   5.7095913E-05,   4.9858598E-05,   4.3233493E-05
     +,   3.7224505E-05,   3.1823678E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_nwao_zz = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_wano_fus_100(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  2.1740434E-06,   2.2766019E-06
     +,   2.3828238E-06,   2.4927731E-06,   2.6065100E-06
     +,   2.7240942E-06,   2.8455800E-06,   2.9710186E-06
     +,   3.1004599E-06,   3.2339497E-06,   3.3715235E-06
     +,   3.5132189E-06,   3.6590686E-06,   3.8090989E-06
     +,   3.9633296E-06,   4.1217786E-06,   4.2844549E-06
     +,   4.4513649E-06,   4.6225064E-06,   4.7978738E-06
     +,   4.9774521E-06,   5.1612219E-06,   5.3491576E-06
     +,   5.5412302E-06,   5.7373909E-06,   5.9375980E-06
     +,   6.1417973E-06,   6.3499297E-06,   6.5619265E-06
     +,   6.7777150E-06,   6.9972139E-06,   7.2203361E-06
     +,   7.4469895E-06,   7.6770721E-06,   7.9104793E-06
     +,   8.1471007E-06,   8.3868217E-06,   8.6295195E-06
     +,   8.8750703E-06,   9.1233451E-06,   9.3742156E-06
     +,   9.6275517E-06,   9.8832033E-06,   1.0141058E-05
     +,   1.0400963E-05,   1.0662797E-05,   1.0926425E-05
     +,   1.1191722E-05,   1.1458571E-05,   1.1726856E-05
     +,   1.1996472E-05,   1.2267325E-05,   1.2539324E-05
     +,   1.2812405E-05,   1.3086512E-05,   1.3361596E-05
     +,   1.3637636E-05,   1.3914632E-05,   1.4192603E-05
     +,   1.4471594E-05,   1.4751677E-05,   1.5032942E-05
     +,   1.5315525E-05,   1.5599580E-05,   1.5885307E-05
     +,   1.6172931E-05,   1.6462724E-05,   1.6754997E-05
     +,   1.7050101E-05,   1.7348437E-05,   1.7650449E-05
     +,   1.7956640E-05,   1.8267559E-05,   1.8583818E-05
     +,   1.8906090E-05,   1.9235096E-05,   1.9571655E-05
     +,   1.9916639E-05,   2.0271005E-05,   2.0635811E-05
     +,   2.1012189E-05,   2.1401389E-05,   2.1804779E-05
     +,   2.2223805E-05,   2.2660081E-05,   2.3115423E-05
     +,   2.3591705E-05,   2.4091047E-05,   2.4615758E-05
     +,   2.5168363E-05,   2.5751620E-05,   2.6368551E-05
     +,   2.7022485E-05,   2.7717044E-05,   2.8456205E-05
     +,   2.9244322E-05,   3.0086148E-05,   3.0986877E-05
     +,   3.1952201E-05,   3.2988275E-05,   3.4101846E-05
     +,   3.5300229E-05,   3.6591344E-05,   3.7983813E-05
     +,   3.9486942E-05,   4.1110772E-05,   4.2866181E-05
     +,   4.4764904E-05,   4.6819394E-05,   4.9043130E-05
     +,   5.1450919E-05,   5.4058073E-05,   5.6881363E-05
     +,   5.9938749E-05,   6.3249412E-05,   6.6833956E-05
     +,   7.0714494E-05,   7.4914642E-05,   7.9459787E-05
     +,   8.4377163E-05,   8.9695866E-05,   9.5447147E-05
     +,   1.0166436E-04,   1.0838310E-04,   1.1564126E-04
     +,   1.2347914E-04,   1.3193914E-04,   1.4106595E-04
     +,   1.5090610E-04,   1.6150773E-04,   1.7292013E-04
     +,   1.8519313E-04,   1.9837610E-04,   2.1251739E-04
     +,   2.2766268E-04,   2.4385378E-04,   2.6112725E-04
     +,   2.7951220E-04,   2.9902873E-04,   3.1968587E-04
     +,   3.4147946E-04,   3.6439070E-04,   3.8838363E-04
     +,   4.1340533E-04,   4.3938341E-04,   4.6622826E-04
     +,   4.9382763E-04,   5.2206125E-04,   5.5078673E-04
     +,   5.7985715E-04,   6.0911896E-04,   6.3842000E-04
     +,   6.6761667E-04,   6.9657870E-04,   7.2519993E-04
     +,   7.5340242E-04,   7.8114501E-04,   8.0842699E-04
     +,   8.3529227E-04,   8.6183212E-04,   8.8818220E-04
     +,   9.1452344E-04,   9.4107469E-04,   9.6808962E-04
     +,   9.9584775E-04,   1.0246484E-03,   1.0548031E-03
     +,   1.0866304E-03,   1.1204492E-03,   1.1565762E-03
     +,   1.1953173E-03,   1.2369709E-03,   1.2818206E-03
     +,   1.3301332E-03,   1.3821474E-03,   1.4380545E-03
     +,   1.4980012E-03,   1.5620508E-03,   1.6301691E-03
     +,   1.7021911E-03,   1.7777956E-03,   1.8564817E-03
     +,   1.9375518E-03,   2.0201078E-03,   2.1030765E-03
     +,   2.1852429E-03,   2.2653206E-03,   2.3420434E-03
     +,   2.4142605E-03,   2.4810554E-03,   2.5418340E-03
     +,   2.5964060E-03,   2.6449992E-03,   2.6882391E-03
     +,   2.7270641E-03,   2.7625863E-03,   2.7959144E-03
     +,   2.8279859E-03,   2.8593945E-03,   2.8902770E-03
     +,   2.9202702E-03,   2.9485414E-03,   2.9739032E-03
     +,   2.9949874E-03,   3.0104597E-03,   3.0192386E-03
     +,   3.0206826E-03,   3.0147417E-03,   3.0020368E-03
     +,   2.9838528E-03,   2.9620745E-03,   2.9390322E-03
     +,   2.9173396E-03,   2.8996337E-03,   2.8883596E-03
     +,   2.8855298E-03,   2.8925301E-03,   2.9099877E-03
     +,   2.9377099E-03,   2.9747251E-03,   3.0193974E-03
     +,   3.0696141E-03,   3.1230382E-03,   3.1773101E-03
     +,   3.2302635E-03,   3.2800196E-03,   3.3250463E-03
     +,   3.3640822E-03,   3.3960706E-03,   3.4200482E-03
     +,   3.4351028E-03,   3.4404064E-03,   3.4353188E-03
     +,   3.4196069E-03,   3.3936691E-03,   3.3587452E-03
     +,   3.3170390E-03,   3.2716629E-03,   3.2264567E-03
     +,   3.1856098E-03,   3.1531693E-03,   3.1325365E-03
     +,   3.1260042E-03,   3.1344255E-03,   3.1571016E-03
     +,   3.1918725E-03,   3.2354256E-03,   3.2837263E-03
     +,   3.3325544E-03,   3.3780143E-03,   3.4169862E-03
     +,   3.4474903E-03,   3.4689035E-03,   3.4820947E-03
     +,   3.4894159E-03,   3.4946268E-03,   3.5026609E-03
     +,   3.5193064E-03,   3.5506957E-03,   3.6027159E-03
     +,   3.6802867E-03,   3.7867096E-03,   3.9230827E-03
     +,   4.0879985E-03,   4.2775520E-03,   4.4856416E-03
     +,   4.7045397E-03,   4.9255509E-03,   5.1396666E-03
     +,   5.3380518E-03,   5.5124350E-03,   5.6553590E-03
     +,   5.7604406E-03,   5.8227153E-03,   5.8390214E-03
     +,   5.8083818E-03,   5.7322425E-03,   5.6144046E-03
     +,   5.4606367E-03,   5.2779773E-03,   5.0738589E-03
     +,   4.8552789E-03,   4.6281586E-03,   4.3970132E-03
     +,   4.1649113E-03,   3.9336961E-03,   3.7043018E-03
     +,   3.4771117E-03,   3.2522466E-03,   3.0297793E-03
     +,   2.8098829E-03,   2.5928719E-03,   2.3792416E-03
     +,   2.1697222E-03,   1.9652375E-03,   1.7669275E-03
     +,   1.5760448E-03,   1.3939247E-03,   1.2218769E-03
     +,   1.0611034E-03,   9.1260072E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wano_fus_100 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_wano_fus_105(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  1.7415131E-06,   1.8113418E-06
     +,   1.8841039E-06,   1.9599399E-06,   2.0389984E-06
     +,   2.1214341E-06,   2.2074105E-06,   2.2970964E-06
     +,   2.3906712E-06,   2.4883229E-06,   2.5902402E-06
     +,   2.6966293E-06,   2.8077002E-06,   2.9236724E-06
     +,   3.0447745E-06,   3.1712439E-06,   3.3033266E-06
     +,   3.4412776E-06,   3.5853607E-06,   3.7358498E-06
     +,   3.8930248E-06,   4.0571799E-06,   4.2286110E-06
     +,   4.4076332E-06,   4.5945530E-06,   4.7897029E-06
     +,   4.9934115E-06,   5.2060223E-06,   5.4278821E-06
     +,   5.6593462E-06,   5.9007757E-06,   6.1525398E-06
     +,   6.4150090E-06,   6.6885623E-06,   6.9735806E-06
     +,   7.2704534E-06,   7.5795647E-06,   7.9013080E-06
     +,   8.2360730E-06,   8.5842548E-06,   8.9462428E-06
     +,   9.3224380E-06,   9.7132024E-06,   1.0118954E-05
     +,   1.0540050E-05,   1.0976870E-05,   1.1429785E-05
     +,   1.1899155E-05,   1.2385332E-05,   1.2888659E-05
     +,   1.3409465E-05,   1.3948075E-05,   1.4504792E-05
     +,   1.5079913E-05,   1.5673728E-05,   1.6286478E-05
     +,   1.6918424E-05,   1.7569797E-05,   1.8240813E-05
     +,   1.8931669E-05,   1.9642548E-05,   2.0373616E-05
     +,   2.1125015E-05,   2.1896885E-05,   2.2689330E-05
     +,   2.3502451E-05,   2.4336337E-05,   2.5191057E-05
     +,   2.6066673E-05,   2.6963233E-05,   2.7880782E-05
     +,   2.8819355E-05,   2.9778987E-05,   3.0759715E-05
     +,   3.1761589E-05,   3.2784632E-05,   3.3828888E-05
     +,   3.4894456E-05,   3.5981393E-05,   3.7089849E-05
     +,   3.8219961E-05,   3.9371913E-05,   4.0545972E-05
     +,   4.1742333E-05,   4.2961325E-05,   4.4203527E-05
     +,   4.5469293E-05,   4.6759280E-05,   4.8074198E-05
     +,   4.9414924E-05,   5.0782459E-05,   5.2178024E-05
     +,   5.3603020E-05,   5.5059125E-05,   5.6548284E-05
     +,   5.8072797E-05,   5.9635324E-05,   6.1238992E-05
     +,   6.2887404E-05,   6.4584761E-05,   6.6335910E-05
     +,   6.8146423E-05,   7.0022732E-05,   7.1972172E-05
     +,   7.4003081E-05,   7.6124990E-05,   7.8348610E-05
     +,   8.0686121E-05,   8.3150830E-05,   8.5757791E-05
     +,   8.8524073E-05,   9.1467758E-05,   9.4609175E-05
     +,   9.7970398E-05,   1.0157536E-04,   1.0544989E-04
     +,   1.0962172E-04,   1.1412039E-04,   1.1897722E-04
     +,   1.2422529E-04,   1.2989923E-04,   1.3603513E-04
     +,   1.4267029E-04,   1.4984330E-04,   1.5759360E-04
     +,   1.6596133E-04,   1.7498755E-04,   1.8471354E-04
     +,   1.9518098E-04,   2.0643203E-04,   2.1850925E-04
     +,   2.3145598E-04,   2.4531674E-04,   2.6013760E-04
     +,   2.7596732E-04,   2.9285889E-04,   3.1087067E-04
     +,   3.3006875E-04,   3.5052915E-04,   3.7234125E-04
     +,   3.9561006E-04,   4.2046013E-04,   4.4703824E-04
     +,   4.7551692E-04,   5.0609547E-04,   5.3900282E-04
     +,   5.7448883E-04,   6.1283883E-04,   6.5434631E-04
     +,   6.9932116E-04,   7.4807461E-04,   8.0090459E-04
     +,   8.5808564E-04,   9.1985066E-04,   9.8637864E-04
     +,   1.0577817E-03,   1.1340934E-03,   1.2152637E-03
     +,   1.3011562E-03,   1.3915468E-03,   1.4861337E-03
     +,   1.5845405E-03,   1.6863232E-03,   1.7909835E-03
     +,   1.8979684E-03,   2.0066802E-03,   2.1164787E-03
     +,   2.2266842E-03,   2.3365854E-03,   2.4454531E-03
     +,   2.5525377E-03,   2.6571183E-03,   2.7584918E-03
     +,   2.8560315E-03,   2.9491507E-03,   3.0373407E-03
     +,   3.1201686E-03,   3.1972593E-03,   3.2683136E-03
     +,   3.3331222E-03,   3.3916316E-03,   3.4440355E-03
     +,   3.4909039E-03,   3.5333331E-03,   3.5730726E-03
     +,   3.6125977E-03,   3.6550811E-03,   3.7042222E-03
     +,   3.7639339E-03,   3.8378811E-03,   3.9289840E-03
     +,   4.0389001E-03,   4.1676085E-03,   4.3132566E-03
     +,   4.4721826E-03,   4.6392861E-03,   4.8085768E-03
     +,   4.9738977E-03,   5.1296609E-03,   5.2714851E-03
     +,   5.3967359E-03,   5.5047814E-03,   5.5971434E-03
     +,   5.6774253E-03,   5.7511032E-03,   5.8250986E-03
     +,   5.9071840E-03,   6.0050427E-03,   6.1250920E-03
     +,   6.2711309E-03,   6.4429673E-03,   6.6355709E-03
     +,   6.8387659E-03,   7.0379842E-03,   7.2160847E-03
     +,   7.3558758E-03,   7.4431980E-03,   7.4695563E-03
     +,   7.4340003E-03,   7.3435069E-03,   7.2119599E-03
     +,   7.0576943E-03,   6.9003203E-03,   6.7574200E-03
     +,   6.6418336E-03,   6.5600607E-03,   6.5118289E-03
     +,   6.4910138E-03,   6.4872964E-03,   6.4884135E-03
     +,   6.4823194E-03,   6.4590895E-03,   6.4121629E-03
     +,   6.3388757E-03,   6.2402315E-03,   6.1201509E-03
     +,   5.9843613E-03,   5.8392747E-03,   5.6911046E-03
     +,   5.5452972E-03,   5.4063802E-03,   5.2780388E-03
     +,   5.1632239E-03,   5.0642178E-03,   4.9824775E-03
     +,   4.9183574E-03,   4.8708506E-03,   4.8374292E-03
     +,   4.8141838E-03,   4.7962423E-03,   4.7784452E-03
     +,   4.7560842E-03,   4.7256020E-03,   4.6850671E-03
     +,   4.6343585E-03,   4.5750574E-03,   4.5100958E-03
     +,   4.4432287E-03,   4.3785293E-03,   4.3198555E-03
     +,   4.2704768E-03,   4.2328169E-03,   4.2083208E-03
     +,   4.1974219E-03,   4.1996138E-03,   4.2135231E-03
     +,   4.2370688E-03,   4.2676465E-03,   4.3023448E-03
     +,   4.3382361E-03,   4.3727187E-03,   4.4038375E-03
     +,   4.4306787E-03,   4.4536227E-03,   4.4744904E-03
     +,   4.4964924E-03,   4.5239506E-03,   4.5617442E-03
     +,   4.6145893E-03,   4.6861880E-03,   4.7783712E-03
     +,   4.8904605E-03,   5.0188364E-03,   5.1569734E-03
     +,   5.2958252E-03,   5.4245964E-03,   5.5317753E-03
     +,   5.6062597E-03,   5.6383926E-03,   5.6208191E-03
     +,   5.5490159E-03,   5.4215109E-03,   5.2397242E-03
     +,   5.0076740E-03,   4.7314386E-03,   4.4186525E-03
     +,   4.0778802E-03,   3.7181578E-03,   3.3485412E-03
     +,   2.9777428E-03,   2.6138201E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wano_fus_105 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_wano_fus_110(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  1.2160498E-06,   1.2752612E-06
     +,   1.3372487E-06,   1.4021526E-06,   1.4701199E-06
     +,   1.5413066E-06,   1.6158777E-06,   1.6940088E-06
     +,   1.7758854E-06,   1.8617042E-06,   1.9516701E-06
     +,   2.0460036E-06,   2.1449368E-06,   2.2487161E-06
     +,   2.3575994E-06,   2.4718615E-06,   2.5917909E-06
     +,   2.7176927E-06,   2.8498887E-06,   2.9887174E-06
     +,   3.1345348E-06,   3.2877163E-06,   3.4486561E-06
     +,   3.6177689E-06,   3.7954840E-06,   3.9822562E-06
     +,   4.1785615E-06,   4.3848963E-06,   4.6017781E-06
     +,   4.8297466E-06,   5.0693625E-06,   5.3212107E-06
     +,   5.5858964E-06,   5.8640471E-06,   6.1563132E-06
     +,   6.4633659E-06,   6.7858959E-06,   7.1246163E-06
     +,   7.4802574E-06,   7.8535732E-06,   8.2453334E-06
     +,   8.6563305E-06,   9.0873409E-06,   9.5392224E-06
     +,   1.0012773E-05,   1.0508847E-05,   1.1028298E-05
     +,   1.1571991E-05,   1.2140796E-05,   1.2735591E-05
     +,   1.3357252E-05,   1.4006672E-05,   1.4684735E-05
     +,   1.5392330E-05,   1.6130360E-05,   1.6899685E-05
     +,   1.7701195E-05,   1.8535777E-05,   1.9404313E-05
     +,   2.0307678E-05,   2.1246744E-05,   2.2222390E-05
     +,   2.3235487E-05,   2.4286910E-05,   2.5377543E-05
     +,   2.6508273E-05,   2.7679993E-05,   2.8893621E-05
     +,   3.0150086E-05,   3.1450338E-05,   3.2795353E-05
     +,   3.4186149E-05,   3.5623791E-05,   3.7109356E-05
     +,   3.8644037E-05,   4.0228984E-05,   4.1865500E-05
     +,   4.3554934E-05,   4.5298679E-05,   4.7098307E-05
     +,   4.8955397E-05,   5.0871648E-05,   5.2848962E-05
     +,   5.4889078E-05,   5.6994046E-05,   5.9166254E-05
     +,   6.1407722E-05,   6.3720930E-05,   6.6108434E-05
     +,   6.8572866E-05,   7.1117007E-05,   7.3743773E-05
     +,   7.6456199E-05,   7.9257457E-05,   8.2150815E-05
     +,   8.5139647E-05,   8.8227484E-05,   9.1417918E-05
     +,   9.4714655E-05,   9.8121447E-05,   1.0164218E-04
     +,   1.0528076E-04,   1.0904113E-04,   1.1292727E-04
     +,   1.1694317E-04,   1.2109285E-04,   1.2538025E-04
     +,   1.2980944E-04,   1.3438391E-04,   1.3910739E-04
     +,   1.4398406E-04,   1.4901671E-04,   1.5420883E-04
     +,   1.5956335E-04,   1.6508304E-04,   1.7077016E-04
     +,   1.7662681E-04,   1.8265452E-04,   1.8885442E-04
     +,   1.9522707E-04,   2.0177252E-04,   2.0849018E-04
     +,   2.1537872E-04,   2.2243637E-04,   2.2966068E-04
     +,   2.3704876E-04,   2.4459712E-04,   2.5230221E-04
     +,   2.6016051E-04,   2.6816915E-04,   2.7632571E-04
     +,   2.8463002E-04,   2.9308387E-04,   3.0169240E-04
     +,   3.1046517E-04,   3.1941733E-04,   3.2857113E-04
     +,   3.3795708E-04,   3.4761574E-04,   3.5759941E-04
     +,   3.6797355E-04,   3.7881843E-04,   3.9023039E-04
     +,   4.0232411E-04,   4.1523288E-04,   4.2911115E-04
     +,   4.4413185E-04,   4.6049437E-04,   4.7841590E-04
     +,   4.9813912E-04,   5.1992817E-04,   5.4406835E-04
     +,   5.7086570E-04,   6.0064241E-04,   6.3373480E-04
     +,   6.7048665E-04,   7.1124284E-04,   7.5634127E-04
     +,   8.0610090E-04,   8.6081272E-04,   9.2072808E-04
     +,   9.8604639E-04,   1.0569072E-03,   1.1333850E-03
     +,   1.2154862E-03,   1.3031510E-03,   1.3962633E-03
     +,   1.4946602E-03,   1.5981401E-03,   1.7064828E-03
     +,   1.8194331E-03,   1.9367167E-03,   2.0580129E-03
     +,   2.1829384E-03,   2.3109934E-03,   2.4415129E-03
     +,   2.5736678E-03,   2.7064155E-03,   2.8385192E-03
     +,   2.9686030E-03,   3.0952441E-03,   3.2171186E-03
     +,   3.3331709E-03,   3.4428334E-03,   3.5462074E-03
     +,   3.6442406E-03,   3.7388233E-03,   3.8327877E-03
     +,   3.9297868E-03,   4.0340181E-03,   4.1498360E-03
     +,   4.2812377E-03,   4.4313348E-03,   4.6018590E-03
     +,   4.7927848E-03,   5.0022677E-03,   5.2268156E-03
     +,   5.4618795E-03,   5.7025990E-03,   5.9447801E-03
     +,   6.1856080E-03,   6.4241360E-03,   6.6611231E-03
     +,   6.8983473E-03,   7.1373847E-03,   7.3782350E-03
     +,   7.6182350E-03,   7.8516146E-03,   8.0700833E-03
     +,   8.2644001E-03,   8.4266951E-03,   8.5529098E-03
     +,   8.6444616E-03,   8.7088300E-03,   8.7585170E-03
     +,   8.8089565E-03,   8.8759921E-03,   8.9734877E-03
     +,   9.1115450E-03,   9.2951385E-03,   9.5227864E-03
     +,   9.7855935E-03,   1.0066928E-02,   1.0343793E-02
     +,   1.0590234E-02,   1.0782224E-02,   1.0902815E-02
     +,   1.0945280E-02,   1.0913456E-02,   1.0819087E-02
     +,   1.0677495E-02,   1.0503459E-02,   1.0308784E-02
     +,   1.0102167E-02,   9.8906169E-03,   9.6814008E-03
     +,   9.4830245E-03,   9.3049575E-03,   9.1559933E-03
     +,   9.0421755E-03,   8.9649875E-03,   8.9206928E-03
     +,   8.9008454E-03,   8.8938540E-03,   8.8870758E-03
     +,   8.8687818E-03,   8.8297278E-03,   8.7639140E-03
     +,   8.6689712E-03,   8.5460665E-03,   8.3995378E-03
     +,   8.2360096E-03,   8.0631403E-03,   7.8880023E-03
     +,   7.7155787E-03,   7.5478707E-03,   7.3841237E-03
     +,   7.2220475E-03,   7.0595709E-03,   6.8964744E-03
     +,   6.7352662E-03,   6.5809325E-03,   6.4398265E-03
     +,   6.3179270E-03,   6.2192683E-03,   6.1448854E-03
     +,   6.0926424E-03,   6.0578184E-03,   6.0344166E-03
     +,   6.0167010E-03,   6.0004760E-03,   5.9839170E-03
     +,   5.9676040E-03,   5.9537520E-03,   5.9449496E-03
     +,   5.9426869E-03,   5.9462194E-03,   5.9520393E-03
     +,   5.9541920E-03,   5.9452909E-03,   5.9179128E-03
     +,   5.8660461E-03,   5.7860375E-03,   5.6769578E-03
     +,   5.5402704E-03,   5.3790086E-03,   5.1967637E-03
     +,   4.9968157E-03,   4.7815549E-03,   4.5524184E-03
     +,   4.3101772E-03,   4.0554116E-03,   3.7890486E-03
     +,   3.5128200E-03,   3.2293941E-03,   2.9423637E-03
     +,   2.6559189E-03,   2.3745138E-03,   2.1024593E-03
     +,   1.8435906E-03,   1.6010231E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wano_fus_110 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_wano_fus_115(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  2.2217482E-06,   2.3187004E-06
     +,   2.4189644E-06,   2.5226109E-06,   2.6297098E-06
     +,   2.7403310E-06,   2.8545439E-06,   2.9724181E-06
     +,   3.0940223E-06,   3.2194280E-06,   3.3486986E-06
     +,   3.4819047E-06,   3.6191134E-06,   3.7603918E-06
     +,   3.9058064E-06,   4.0554251E-06,   4.2093116E-06
     +,   4.3675336E-06,   4.5301558E-06,   4.6972427E-06
     +,   4.8688598E-06,   5.0450717E-06,   5.2259420E-06
     +,   5.4115399E-06,   5.6019230E-06,   5.7971597E-06
     +,   5.9973145E-06,   6.2024533E-06,   6.4126407E-06
     +,   6.6279454E-06,   6.8484342E-06,   7.0741758E-06
     +,   7.3052406E-06,   7.5416992E-06,   7.7836248E-06
     +,   8.0310929E-06,   8.2841789E-06,   8.5429647E-06
     +,   8.8075312E-06,   9.0779604E-06,   9.3543458E-06
     +,   9.6367821E-06,   9.9253466E-06,   1.0220165E-05
     +,   1.0521328E-05,   1.0828947E-05,   1.1143138E-05
     +,   1.1464028E-05,   1.1791742E-05,   1.2126421E-05
     +,   1.2468206E-05,   1.2817255E-05,   1.3173729E-05
     +,   1.3537804E-05,   1.3909676E-05,   1.4289521E-05
     +,   1.4677565E-05,   1.5074033E-05,   1.5479171E-05
     +,   1.5893234E-05,   1.6316506E-05,   1.6749282E-05
     +,   1.7191884E-05,   1.7644663E-05,   1.8107990E-05
     +,   1.8582263E-05,   1.9067913E-05,   1.9565407E-05
     +,   2.0075238E-05,   2.0597945E-05,   2.1134105E-05
     +,   2.1684340E-05,   2.2249324E-05,   2.2829772E-05
     +,   2.3426477E-05,   2.4040251E-05,   2.4671999E-05
     +,   2.5322708E-05,   2.5993402E-05,   2.6685240E-05
     +,   2.7399423E-05,   2.8137287E-05,   2.8900280E-05
     +,   2.9689882E-05,   3.0507770E-05,   3.1355863E-05
     +,   3.2236057E-05,   3.3150522E-05,   3.4101635E-05
     +,   3.5091951E-05,   3.6124300E-05,   3.7201757E-05
     +,   3.8327715E-05,   3.9505896E-05,   4.0740368E-05
     +,   4.2035623E-05,   4.3396605E-05,   4.4828728E-05
     +,   4.6337944E-05,   4.7930811E-05,   4.9614464E-05
     +,   5.1396739E-05,   5.3286225E-05,   5.5292236E-05
     +,   5.7424913E-05,   5.9695216E-05,   6.2115083E-05
     +,   6.4697342E-05,   6.7455549E-05,   7.0404283E-05
     +,   7.3559517E-05,   7.6937366E-05,   8.0555306E-05
     +,   8.4431515E-05,   8.8584929E-05,   9.3035160E-05
     +,   9.7802294E-05,   1.0290686E-04,   1.0836961E-04
     +,   1.1421135E-04,   1.2045261E-04,   1.2711353E-04
     +,   1.3421352E-04,   1.4177097E-04,   1.4980286E-04
     +,   1.5832439E-04,   1.6734871E-04,   1.7688631E-04
     +,   1.8694480E-04,   1.9752837E-04,   2.0863728E-04
     +,   2.2026761E-04,   2.3241050E-04,   2.4505224E-04
     +,   2.5817350E-04,   2.7174910E-04,   2.8574790E-04
     +,   3.0013270E-04,   3.1485999E-04,   3.2988025E-04
     +,   3.4513802E-04,   3.6057268E-04,   3.7611835E-04
     +,   3.9170528E-04,   4.0726078E-04,   4.2271064E-04
     +,   4.3797758E-04,   4.5299003E-04,   4.6767481E-04
     +,   4.8196592E-04,   4.9580395E-04,   5.0913834E-04
     +,   5.2193156E-04,   5.3415913E-04,   5.4581399E-04
     +,   5.5690913E-04,   5.6747918E-04,   5.7758449E-04
     +,   5.8731239E-04,   5.9677893E-04,   6.0613232E-04
     +,   6.1555213E-04,   6.2525191E-04,   6.3547655E-04
     +,   6.4650422E-04,   6.5864361E-04,   6.7223114E-04
     +,   6.8763125E-04,   7.0523185E-04,   7.2544586E-04
     +,   7.4870593E-04,   7.7547046E-04,   8.0622052E-04
     +,   8.4146857E-04,   8.8175293E-04,   9.2763908E-04
     +,   9.7972492E-04,   1.0386312E-03,   1.1049942E-03
     +,   1.1794510E-03,   1.2626289E-03,   1.3551250E-03
     +,   1.4574940E-03,   1.5702435E-03,   1.6938195E-03
     +,   1.8286231E-03,   1.9750053E-03,   2.1332873E-03
     +,   2.3037572E-03,   2.4866580E-03,   2.6821683E-03
     +,   2.8903391E-03,   3.1110123E-03,   3.3437139E-03
     +,   3.5875747E-03,   3.8412856E-03,   4.1031581E-03
     +,   4.3712994E-03,   4.6438994E-03,   4.9195616E-03
     +,   5.1974952E-03,   5.4775216E-03,   5.7597649E-03
     +,   6.0441229E-03,   6.3297153E-03,   6.6146199E-03
     +,   6.8960297E-03,   7.1708849E-03,   7.4366243E-03
     +,   7.6917876E-03,   7.9358630E-03,   8.1688538E-03
     +,   8.3903950E-03,   8.5993605E-03,   8.7941820E-03
     +,   8.9738015E-03,   9.1386707E-03,   9.2909858E-03
     +,   9.4337137E-03,   9.5686512E-03,   9.6942307E-03
     +,   9.8044463E-03,   9.8897871E-03,   9.9399174E-03
     +,   9.9477768E-03,   9.9132117E-03,   9.8449215E-03
     +,   9.7597791E-03,   9.6791284E-03,   9.6232872E-03
     +,   9.6058166E-03,   9.6296677E-03,   9.6871778E-03
     +,   9.7637763E-03,   9.8442696E-03,   9.9184224E-03
     +,   9.9831745E-03,   1.0040274E-02,   1.0090726E-02
     +,   1.0129527E-02,   1.0144204E-02,   1.0118527E-02
     +,   1.0039952E-02,   9.9067902E-03,   9.7314361E-03
     +,   9.5376121E-03,   9.3530035E-03,   9.2006680E-03
     +,   9.0925582E-03,   9.0274913E-03,   8.9932196E-03
     +,   8.9712767E-03,   8.9424588E-03,   8.8916607E-03
     +,   8.8110771E-03,   8.7015200E-03,   8.5716750E-03
     +,   8.4356200E-03,   8.3090588E-03,   8.2054185E-03
     +,   8.1328182E-03,   8.0927471E-03,   8.0805756E-03
     +,   8.0873957E-03,   8.1022158E-03,   8.1138853E-03
     +,   8.1124678E-03,   8.0900649E-03,   8.0416044E-03
     +,   7.9654446E-03,   7.8637935E-03,   7.7424133E-03
     +,   7.6094922E-03,   7.4737715E-03,   7.3424065E-03
     +,   7.2193393E-03,   7.1046040E-03,   6.9949417E-03
     +,   6.8852068E-03,   6.7700935E-03,   6.6453847E-03
     +,   6.5083569E-03,   6.3573564E-03,   6.1909435E-03
     +,   6.0070576E-03,   5.8027473E-03,   5.5745523E-03
     +,   5.3194338E-03,   5.0358325E-03,   4.7245175E-03
     +,   4.3890332E-03,   4.0353704E-03,   3.6712640E-03
     +,   3.3053055E-03,   2.9458448E-03,   2.6002687E-03
     +,   2.2743812E-03,   1.9722665E-03,   1.6963267E-03
     +,   1.4475195E-03,   1.2256756E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wano_fus_115 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_wano_fus_120(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  5.6380543E-07,   5.9483233E-07
     +,   6.2738195E-07,   6.6152501E-07,   6.9733596E-07
     +,   7.3489463E-07,   7.7428422E-07,   8.1559324E-07
     +,   8.5891554E-07,   9.0435168E-07,   9.5200522E-07
     +,   1.0019900E-06,   1.0544251E-06,   1.1094380E-06
     +,   1.1671640E-06,   1.2277480E-06,   1.2913445E-06
     +,   1.3581177E-06,   1.4282438E-06,   1.5019098E-06
     +,   1.5793163E-06,   1.6606778E-06,   1.7462226E-06
     +,   1.8361966E-06,   1.9308570E-06,   2.0304842E-06
     +,   2.1353746E-06,   2.2458444E-06,   2.3622317E-06
     +,   2.4848948E-06,   2.6142166E-06,   2.7506030E-06
     +,   2.8944864E-06,   3.0463239E-06,   3.2066005E-06
     +,   3.3758306E-06,   3.5545579E-06,   3.7433549E-06
     +,   3.9428273E-06,   4.1536118E-06,   4.3763780E-06
     +,   4.6118321E-06,   4.8606967E-06,   5.1237616E-06
     +,   5.4018128E-06,   5.6956956E-06,   6.0062785E-06
     +,   6.3344664E-06,   6.6811936E-06,   7.0474284E-06
     +,   7.4341647E-06,   7.8424273E-06,   8.2732677E-06
     +,   8.7277595E-06,   9.2070104E-06,   9.7121138E-06
     +,   1.0244211E-05,   1.0804442E-05,   1.1393965E-05
     +,   1.2013928E-05,   1.2665488E-05,   1.3349795E-05
     +,   1.4067993E-05,   1.4821201E-05,   1.5610529E-05
     +,   1.6437050E-05,   1.7301814E-05,   1.8205821E-05
     +,   1.9150035E-05,   2.0135365E-05,   2.1162658E-05
     +,   2.2232703E-05,   2.3346216E-05,   2.4503825E-05
     +,   2.5706113E-05,   2.6953485E-05,   2.8246330E-05
     +,   2.9584908E-05,   3.0969335E-05,   3.2399708E-05
     +,   3.3875916E-05,   3.5397745E-05,   3.6964935E-05
     +,   3.8576891E-05,   4.0232997E-05,   4.1932726E-05
     +,   4.3674998E-05,   4.5458870E-05,   4.7283189E-05
     +,   4.9146667E-05,   5.1047868E-05,   5.2985244E-05
     +,   5.4957105E-05,   5.6961628E-05,   5.8996888E-05
     +,   6.1060819E-05,   6.3151267E-05,   6.5265987E-05
     +,   6.7402623E-05,   6.9558788E-05,   7.1731964E-05
     +,   7.3919604E-05,   7.6119162E-05,   7.8328019E-05
     +,   8.0543563E-05,   8.2763210E-05,   8.4984335E-05
     +,   8.7204564E-05,   8.9421206E-05,   9.1631860E-05
     +,   9.3834533E-05,   9.6026772E-05,   9.8206663E-05
     +,   1.0037231E-04,   1.0252203E-04,   1.0465432E-04
     +,   1.0676791E-04,   1.0886172E-04,   1.1093493E-04
     +,   1.1298696E-04,   1.1501752E-04,   1.1702649E-04
     +,   1.1901412E-04,   1.2098088E-04,   1.2292751E-04
     +,   1.2485500E-04,   1.2676463E-04,   1.2865788E-04
     +,   1.3053657E-04,   1.3240267E-04,   1.3425849E-04
     +,   1.3610654E-04,   1.3794964E-04,   1.3979095E-04
     +,   1.4163397E-04,   1.4348271E-04,   1.4534163E-04
     +,   1.4721595E-04,   1.4911171E-04,   1.5103602E-04
     +,   1.5299716E-04,   1.5500515E-04,   1.5707190E-04
     +,   1.5921138E-04,   1.6144080E-04,   1.6378022E-04
     +,   1.6625338E-04,   1.6888911E-04,   1.7172056E-04
     +,   1.7478735E-04,   1.7813552E-04,   1.8181928E-04
     +,   1.8590127E-04,   1.9045486E-04,   1.9556486E-04
     +,   2.0132965E-04,   2.0786289E-04,   2.1529572E-04
     +,   2.2377881E-04,   2.3348421E-04,   2.4460739E-04
     +,   2.5736805E-04,   2.7201098E-04,   2.8880459E-04
     +,   3.0803823E-04,   3.3001797E-04,   3.5505884E-04
     +,   3.8347597E-04,   4.1557173E-04,   4.5162352E-04
     +,   4.9186143E-04,   5.3646177E-04,   5.8552268E-04
     +,   6.3906086E-04,   6.9699093E-04,   7.5912010E-04
     +,   8.2516007E-04,   8.9472579E-04,   9.6735283E-04
     +,   1.0425170E-03,   1.1196621E-03,   1.1982315E-03
     +,   1.2777000E-03,   1.3576116E-03,   1.4376171E-03
     +,   1.5175086E-03,   1.5972517E-03,   1.6770206E-03
     +,   1.7572255E-03,   1.8385357E-03,   1.9218883E-03
     +,   2.0084991E-03,   2.0998400E-03,   2.1976009E-03
     +,   2.3036292E-03,   2.4198233E-03,   2.5480085E-03
     +,   2.6897662E-03,   2.8462643E-03,   3.0180737E-03
     +,   3.2050114E-03,   3.4060508E-03,   3.6192944E-03
     +,   3.8420807E-03,   4.0711802E-03,   4.3030879E-03
     +,   4.5343675E-03,   4.7619217E-03,   4.9831211E-03
     +,   5.1957364E-03,   5.3976257E-03,   5.5864486E-03
     +,   5.7593714E-03,   5.9133018E-03,   6.0456186E-03
     +,   6.1553651E-03,   6.2446045E-03,   6.3192830E-03
     +,   6.3890098E-03,   6.4655025E-03,   6.5597929E-03
     +,   6.6791959E-03,   6.8252198E-03,   6.9934893E-03
     +,   7.1761250E-03,   7.3656677E-03,   7.5588967E-03
     +,   7.7581378E-03,   7.9690591E-03,   8.1952875E-03
     +,   8.4322747E-03,   8.6641833E-03,   8.8661555E-03
     +,   9.0125510E-03,   9.0878392E-03,   9.0953493E-03
     +,   9.0591386E-03,   9.0174666E-03,   9.0102348E-03
     +,   9.0656234E-03,   9.1911210E-03,   9.3720770E-03
     +,   9.5774364E-03,   9.7701028E-03,   9.9180834E-03
     +,   1.0002790E-02,   1.0021976E-02,   9.9864053E-03
     +,   9.9117849E-03,   9.8095350E-03,   9.6808244E-03
     +,   9.5170820E-03,   9.3068527E-03,   9.0461932E-03
     +,   8.7470254E-03,   8.4394468E-03,   8.1661474E-03
     +,   7.9709953E-03,   7.8860149E-03,   7.9216855E-03
     +,   8.0637028E-03,   8.2769133E-03,   8.5151242E-03
     +,   8.7334355E-03,   8.8997455E-03,   9.0017617E-03
     +,   9.0475539E-03,   9.0593109E-03,   9.0626581E-03
     +,   9.0755401E-03,   9.1012465E-03,   9.1278730E-03
     +,   9.1342889E-03,   9.0990458E-03,   9.0080043E-03
     +,   8.8576972E-03,   8.6536277E-03,   8.4056230E-03
     +,   8.1233066E-03,   7.8137284E-03,   7.4817603E-03
     +,   7.1318881E-03,   6.7698481E-03,   6.4029898E-03
     +,   6.0391314E-03,   5.6847860E-03,   5.3436426E-03
     +,   5.0160522E-03,   4.6995487E-03,   4.3901103E-03
     +,   4.0836618E-03,   3.7772008E-03,   3.4694530E-03
     +,   3.1610474E-03,   2.8541640E-03,   2.5520865E-03
     +,   2.2585909E-03,   1.9774968E-03,   1.7123015E-03
     +,   1.4659229E-03,   1.2405531E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wano_fus_120 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_wano_fus_60(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  2.5143311E-04,   2.5913882E-04
     +,   2.6725238E-04,   2.7582844E-04,   2.8492534E-04
     +,   2.9460446E-04,   3.0493076E-04,   3.1597269E-04
     +,   3.2780238E-04,   3.4049660E-04,   3.5413570E-04
     +,   3.6880540E-04,   3.8459484E-04,   4.0159692E-04
     +,   4.1990646E-04,   4.3961764E-04,   4.6082187E-04
     +,   4.8360354E-04,   5.0803786E-04,   5.3418695E-04
     +,   5.6209922E-04,   5.9180945E-04,   6.2334310E-04
     +,   6.5672473E-04,   6.9198600E-04,   7.2918658E-04
     +,   7.6842873E-04,   8.0987805E-04,   8.5378275E-04
     +,   9.0049027E-04,   9.5045712E-04,   1.0042489E-03
     +,   1.0625332E-03,   1.1260567E-03,   1.1956081E-03
     +,   1.2719752E-03,   1.3558794E-03,   1.4479108E-03
     +,   1.5484502E-03,   1.6575941E-03,   1.7750778E-03
     +,   1.9002197E-03,   2.0318534E-03,   2.1683450E-03
     +,   2.3075559E-03,   2.4469236E-03,   2.5835296E-03
     +,   2.7142223E-03,   2.8357713E-03,   2.9450457E-03
     +,   3.0391864E-03,   3.1157956E-03,   3.1730710E-03
     +,   3.2099260E-03,   3.2260476E-03,   3.2218907E-03
     +,   3.1986178E-03,   3.1580015E-03,   3.1022541E-03
     +,   3.0338608E-03,   2.9553929E-03,   2.8693413E-03
     +,   2.7779727E-03,   2.6832283E-03,   2.5866739E-03
     +,   2.4894818E-03,   2.3924685E-03,   2.2961402E-03
     +,   2.2007802E-03,   2.1065094E-03,   2.0133690E-03
     +,   1.9213681E-03,   1.8305329E-03,   1.7409252E-03
     +,   1.6526593E-03,   1.5659042E-03,   1.4808768E-03
     +,   1.3978402E-03,   1.3170921E-03,   1.2389553E-03
     +,   1.1637761E-03,   1.0919078E-03,   1.0236964E-03
     +,   9.5948193E-04,   8.9956931E-04,   8.4421306E-04
     +,   7.9363171E-04,   7.4797065E-04,   7.0731126E-04
     +,   6.7166513E-04,   6.4097537E-04,   6.1511929E-04
     +,   5.9391378E-04,   5.7712127E-04,   5.6445529E-04
     +,   5.5558712E-04,   5.5015221E-04,   5.4775545E-04
     +,   5.4797740E-04,   5.5038091E-04,   5.5451848E-04
     +,   5.5994035E-04,   5.6620134E-04,   5.7287188E-04
     +,   5.7954498E-04,   5.8584585E-04,   5.9143861E-04
     +,   5.9603335E-04,   5.9939030E-04,   6.0132315E-04
     +,   6.0170027E-04,   6.0044316E-04,   5.9752521E-04
     +,   5.9296604E-04,   5.8682752E-04,   5.7920726E-04
     +,   5.7023182E-04,   5.6005048E-04,   5.4882764E-04
     +,   5.3673680E-04,   5.2395451E-04,   5.1065587E-04
     +,   4.9700815E-04,   4.8316937E-04,   4.6928402E-04
     +,   4.5548179E-04,   4.4187557E-04,   4.2856182E-04
     +,   4.1562022E-04,   4.0311410E-04,   3.9109203E-04
     +,   3.7958831E-04,   3.6862536E-04,   3.5821472E-04
     +,   3.4835917E-04,   3.3905412E-04,   3.3028945E-04
     +,   3.2205071E-04,   3.1432041E-04,   3.0707961E-04
     +,   3.0030819E-04,   2.9398577E-04,   2.8809256E-04
     +,   2.8260937E-04,   2.7751789E-04,   2.7280077E-04
     +,   2.6844229E-04,   2.6442643E-04,   2.6073909E-04
     +,   2.5736607E-04,   2.5429361E-04,   2.5150797E-04
     +,   2.4899546E-04,   2.4674210E-04,   2.4473353E-04
     +,   2.4295475E-04,   2.4139041E-04,   2.4002454E-04
     +,   2.3884082E-04,   2.3782220E-04,   2.3695160E-04
     +,   2.3621162E-04,   2.3558491E-04,   2.3505426E-04
     +,   2.3460276E-04,   2.3421404E-04,   2.3387227E-04
     +,   2.3356262E-04,   2.3327113E-04,   2.3298478E-04
     +,   2.3269208E-04,   2.3238234E-04,   2.3204646E-04
     +,   2.3167665E-04,   2.3126605E-04,   2.3080941E-04
     +,   2.3030258E-04,   2.2974248E-04,   2.2912701E-04
     +,   2.2845509E-04,   2.2772630E-04,   2.2694100E-04
     +,   2.2609995E-04,   2.2520445E-04,   2.2425591E-04
     +,   2.2325595E-04,   2.2220628E-04,   2.2110835E-04
     +,   2.1996356E-04,   2.1877303E-04,   2.1753754E-04
     +,   2.1625745E-04,   2.1493270E-04,   2.1356280E-04
     +,   2.1214700E-04,   2.1068376E-04,   2.0917149E-04
     +,   2.0760811E-04,   2.0599124E-04,   2.0431809E-04
     +,   2.0258602E-04,   2.0079198E-04,   1.9893299E-04
     +,   1.9700617E-04,   1.9500873E-04,   1.9293799E-04
     +,   1.9079164E-04,   1.8856760E-04,   1.8626441E-04
     +,   1.8388069E-04,   1.8141611E-04,   1.7887031E-04
     +,   1.7624372E-04,   1.7353745E-04,   1.7075297E-04
     +,   1.6789269E-04,   1.6495930E-04,   1.6195614E-04
     +,   1.5888718E-04,   1.5575641E-04,   1.5256910E-04
     +,   1.4933030E-04,   1.4604564E-04,   1.4272107E-04
     +,   1.3936251E-04,   1.3597686E-04,   1.3257012E-04
     +,   1.2914905E-04,   1.2572018E-04,   1.2228994E-04
     +,   1.1886513E-04,   1.1545193E-04,   1.1205646E-04
     +,   1.0868482E-04,   1.0534225E-04,   1.0203459E-04
     +,   9.8766715E-05,   9.5543408E-05,   9.2369017E-05
     +,   8.9247544E-05,   8.6182656E-05,   8.3177583E-05
     +,   8.0235193E-05,   7.7358003E-05,   7.4548130E-05
     +,   7.1807372E-05,   6.9137146E-05,   6.6538545E-05
     +,   6.4012376E-05,   6.1559134E-05,   5.9179019E-05
     +,   5.6872028E-05,   5.4637869E-05,   5.2476080E-05
     +,   5.0385970E-05,   4.8366710E-05,   4.6417281E-05
     +,   4.4536555E-05,   4.2723270E-05,   4.0976069E-05
     +,   3.9293533E-05,   3.7674130E-05,   3.6116300E-05
     +,   3.4618435E-05,   3.3178894E-05,   3.1796004E-05
     +,   3.0468087E-05,   2.9193459E-05,   2.7970444E-05
     +,   2.6797356E-05,   2.5672538E-05,   2.4594347E-05
     +,   2.3561153E-05,   2.2571367E-05,   2.1623378E-05
     +,   2.0715719E-05,   1.9846882E-05,   1.9015319E-05
     +,   1.8219625E-05,   1.7458366E-05,   1.6730235E-05
     +,   1.6033862E-05,   1.5367958E-05,   1.4731256E-05
     +,   1.4122537E-05,   1.3540616E-05,   1.2984340E-05
     +,   1.2452596E-05,   1.1944311E-05,   1.1458423E-05
     +,   1.0993966E-05,   1.0549965E-05,   1.0125454E-05
     +,   9.7195489E-06,   9.3313665E-06,   8.9601081E-06
     +,   8.6049567E-06,   8.2651468E-06,   7.9399424E-06
     +,   7.6286401E-06,   7.3305691E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wano_fus_60 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_wano_fus_65(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  4.6707206E-05,   4.8984730E-05
     +,   5.1535433E-05,   5.4398639E-05,   5.7617959E-05
     +,   6.1241364E-05,   6.5321197E-05,   6.9914109E-05
     +,   7.5080839E-05,   8.0886020E-05,   8.7397268E-05
     +,   9.4685187E-05,   1.0282223E-04,   1.1188186E-04
     +,   1.2193737E-04,   1.3306069E-04,   1.4532098E-04
     +,   1.5878300E-04,   1.7350560E-04,   1.8953969E-04
     +,   2.0692678E-04,   2.2569692E-04,   2.4586715E-04
     +,   2.6744042E-04,   2.9040268E-04,   3.1472472E-04
     +,   3.4036042E-04,   3.6724799E-04,   3.9531128E-04
     +,   4.2446284E-04,   4.5460771E-04,   4.8564858E-04
     +,   5.1749119E-04,   5.5005180E-04,   5.8326375E-04
     +,   6.1708479E-04,   6.5150327E-04,   6.8654347E-04
     +,   7.2226831E-04,   7.5878168E-04,   7.9622923E-04
     +,   8.3479442E-04,   8.7469397E-04,   9.1618137E-04
     +,   9.5953105E-04,   1.0050429E-03,   1.0530304E-03
     +,   1.1038150E-03,   1.1577135E-03,   1.2150236E-03
     +,   1.2760003E-03,   1.3408340E-03,   1.4096213E-03
     +,   1.4823402E-03,   1.5588346E-03,   1.6388032E-03
     +,   1.7218294E-03,   1.8074106E-03,   1.8950248E-03
     +,   1.9842030E-03,   2.0746212E-03,   2.1661629E-03
     +,   2.2589758E-03,   2.3534708E-03,   2.4502738E-03
     +,   2.5501144E-03,   2.6536556E-03,   2.7612932E-03
     +,   2.8729287E-03,   2.9877701E-03,   3.1041829E-03
     +,   3.2196343E-03,   3.3307609E-03,   3.4335742E-03
     +,   3.5237686E-03,   3.5971322E-03,   3.6500061E-03
     +,   3.6796776E-03,   3.6847203E-03,   3.6651441E-03
     +,   3.6224036E-03,   3.5591875E-03,   3.4791015E-03
     +,   3.3862395E-03,   3.2847349E-03,   3.1783613E-03
     +,   3.0702502E-03,   2.9627162E-03,   2.8572171E-03
     +,   2.7544566E-03,   2.6545268E-03,   2.5571289E-03
     +,   2.4617708E-03,   2.3679542E-03,   2.2753058E-03
     +,   2.1836583E-03,   2.0930774E-03,   2.0038530E-03
     +,   1.9164549E-03,   1.8314583E-03,   1.7494913E-03
     +,   1.6711501E-03,   1.5969585E-03,   1.5273186E-03
     +,   1.4624874E-03,   1.4025788E-03,   1.3475667E-03
     +,   1.2973057E-03,   1.2515710E-03,   1.2100781E-03
     +,   1.1725165E-03,   1.1385899E-03,   1.1080242E-03
     +,   1.0805862E-03,   1.0560915E-03,   1.0343967E-03
     +,   1.0154012E-03,   9.9902449E-04,   9.8519877E-04
     +,   9.7385311E-04,   9.6489635E-04,   9.5820724E-04
     +,   9.5362391E-04,   9.5093984E-04,   9.4990048E-04
     +,   9.5020467E-04,   9.5151161E-04,   9.5344346E-04
     +,   9.5559971E-04,   9.5756631E-04,   9.5892756E-04
     +,   9.5928076E-04,   9.5824810E-04,   9.5548824E-04
     +,   9.5070968E-04,   9.4367826E-04,   9.3422475E-04
     +,   9.2225021E-04,   9.0772659E-04,   8.9069724E-04
     +,   8.7127223E-04,   8.4962248E-04,   8.2597160E-04
     +,   8.0058631E-04,   7.7376503E-04,   7.4582681E-04
     +,   7.1710401E-04,   6.8792060E-04,   6.5859867E-04
     +,   6.2943716E-04,   6.0071179E-04,   5.7266868E-04
     +,   5.4552086E-04,   5.1944715E-04,   4.9459160E-04
     +,   4.7106433E-04,   4.4894390E-04,   4.2827922E-04
     +,   4.0909360E-04,   3.9138689E-04,   3.7514017E-04
     +,   3.6031814E-04,   3.4687325E-04,   3.3474818E-04
     +,   3.2387846E-04,   3.1419549E-04,   3.0562753E-04
     +,   2.9810247E-04,   2.9154841E-04,   2.8589478E-04
     +,   2.8107414E-04,   2.7702126E-04,   2.7367470E-04
     +,   2.7097616E-04,   2.6887134E-04,   2.6730992E-04
     +,   2.6624463E-04,   2.6563182E-04,   2.6543098E-04
     +,   2.6560438E-04,   2.6611701E-04,   2.6693594E-04
     +,   2.6803024E-04,   2.6937036E-04,   2.7092831E-04
     +,   2.7267638E-04,   2.7458824E-04,   2.7663750E-04
     +,   2.7879793E-04,   2.8104321E-04,   2.8334733E-04
     +,   2.8568352E-04,   2.8802495E-04,   2.9034467E-04
     +,   2.9261530E-04,   2.9480961E-04,   2.9690037E-04
     +,   2.9886077E-04,   3.0066425E-04,   3.0228487E-04
     +,   3.0369827E-04,   3.0488055E-04,   3.0580981E-04
     +,   3.0646587E-04,   3.0683030E-04,   3.0688685E-04
     +,   3.0662204E-04,   3.0602454E-04,   3.0508603E-04
     +,   3.0380071E-04,   3.0216589E-04,   3.0018133E-04
     +,   2.9784991E-04,   2.9517719E-04,   2.9217111E-04
     +,   2.8884257E-04,   2.8520433E-04,   2.8127144E-04
     +,   2.7706096E-04,   2.7259073E-04,   2.6788117E-04
     +,   2.6295299E-04,   2.5782795E-04,   2.5252815E-04
     +,   2.4707595E-04,   2.4149443E-04,   2.3580532E-04
     +,   2.3003058E-04,   2.2419136E-04,   2.1830783E-04
     +,   2.1239980E-04,   2.0648536E-04,   2.0058155E-04
     +,   1.9470447E-04,   1.8886791E-04,   1.8308569E-04
     +,   1.7736947E-04,   1.7172977E-04,   1.6617577E-04
     +,   1.6071550E-04,   1.5535582E-04,   1.5010245E-04
     +,   1.4496017E-04,   1.3993279E-04,   1.3502329E-04
     +,   1.3023386E-04,   1.2556616E-04,   1.2102116E-04
     +,   1.1659940E-04,   1.1230092E-04,   1.0812550E-04
     +,   1.0407258E-04,   1.0014138E-04,   9.6330899E-05
     +,   9.2639973E-05,   8.9067340E-05,   8.5611653E-05
     +,   8.2271414E-05,   7.9045109E-05,   7.5931195E-05
     +,   7.2927993E-05,   7.0033806E-05,   6.7246918E-05
     +,   6.4565509E-05,   6.1987754E-05,   5.9511702E-05
     +,   5.7135403E-05,   5.4856777E-05,   5.2673739E-05
     +,   5.0584076E-05,   4.8585531E-05,   4.6675752E-05
     +,   4.4852346E-05,   4.3112857E-05,   4.1454663E-05
     +,   3.9875315E-05,   3.8372171E-05,   3.6942420E-05
     +,   3.5583405E-05,   3.4292356E-05,   3.3066623E-05
     +,   3.1903382E-05,   3.0799903E-05,   2.9753444E-05
     +,   2.8761289E-05,   2.7820770E-05,   2.6929254E-05
     +,   2.6084153E-05,   2.5282949E-05,   2.4523146E-05
     +,   2.3802429E-05,   2.3118473E-05,   2.2468997E-05
     +,   2.1851882E-05,   2.1265039E-05,   2.0706562E-05
     +,   2.0174533E-05,   1.9667179E-05,   1.9182808E-05
     +,   1.8719809E-05,   1.8276678E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wano_fus_65 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_wano_fus_70(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  3.3670251E-05,   3.5956891E-05
     +,   3.8387658E-05,   4.0971307E-05,   4.3717304E-05
     +,   4.6635869E-05,   4.9738064E-05,   5.3035812E-05
     +,   5.6542016E-05,   6.0270610E-05,   6.4236279E-05
     +,   6.8454901E-05,   7.2943250E-05,   7.7718891E-05
     +,   8.2800194E-05,   8.8205983E-05,   9.3955467E-05
     +,   1.0006786E-04,   1.0656197E-04,   1.1345597E-04
     +,   1.2076670E-04,   1.2850940E-04,   1.3669689E-04
     +,   1.4533944E-04,   1.5444326E-04,   1.6401123E-04
     +,   1.7404181E-04,   1.8452857E-04,   1.9546042E-04
     +,   2.0682132E-04,   2.1859069E-04,   2.3074419E-04
     +,   2.4325428E-04,   2.5609185E-04,   2.6922784E-04
     +,   2.8263527E-04,   2.9629222E-04,   3.1018452E-04
     +,   3.2430937E-04,   3.3867909E-04,   3.5332539E-04
     +,   3.6830336E-04,   3.8369480E-04,   3.9961486E-04
     +,   4.1621170E-04,   4.3367187E-04,   4.5222050E-04
     +,   4.7212053E-04,   4.9366982E-04,   5.1719637E-04
     +,   5.4304855E-04,   5.7158316E-04,   6.0314860E-04
     +,   6.3806697E-04,   6.7660905E-04,   7.1896799E-04
     +,   7.6523924E-04,   8.1538857E-04,   8.6923543E-04
     +,   9.2643389E-04,   9.8646502E-04,   1.0486390E-03
     +,   1.1121061E-03,   1.1758844E-03,   1.2388952E-03
     +,   1.3000093E-03,   1.3580988E-03,   1.4120955E-03
     +,   1.4610433E-03,   1.5041460E-03,   1.5408013E-03
     +,   1.5706263E-03,   1.5934617E-03,   1.6093676E-03
     +,   1.6186014E-03,   1.6215983E-03,   1.6189446E-03
     +,   1.6113581E-03,   1.5996769E-03,   1.5848583E-03
     +,   1.5679906E-03,   1.5502980E-03,   1.5331504E-03
     +,   1.5180547E-03,   1.5066192E-03,   1.5004964E-03
     +,   1.5012957E-03,   1.5104788E-03,   1.5292461E-03
     +,   1.5584418E-03,   1.5984932E-03,   1.6493999E-03
     +,   1.7107822E-03,   1.7819915E-03,   1.8622460E-03
     +,   1.9507894E-03,   2.0470163E-03,   2.1505335E-03
     +,   2.2611676E-03,   2.3788605E-03,   2.5035234E-03
     +,   2.6348506E-03,   2.7721636E-03,   2.9142897E-03
     +,   3.0595439E-03,   3.2057948E-03,   3.3506036E-03
     +,   3.4914140E-03,   3.6256863E-03,   3.7510647E-03
     +,   3.8654206E-03,   3.9668023E-03,   4.0534255E-03
     +,   4.1236007E-03,   4.1757156E-03,   4.2083175E-03
     +,   4.2202189E-03,   4.2107226E-03,   4.1797669E-03
     +,   4.1280752E-03,   4.0571587E-03,   3.9692330E-03
     +,   3.8669878E-03,   3.7533271E-03,   3.6310977E-03
     +,   3.5028507E-03,   3.3707279E-03,   3.2364156E-03
     +,   3.1012183E-03,   2.9661627E-03,   2.8321240E-03
     +,   2.6999363E-03,   2.5704596E-03,   2.4445918E-03
     +,   2.3232610E-03,   2.2073595E-03,   2.0976933E-03
     +,   1.9949239E-03,   1.8995268E-03,   1.8117700E-03
     +,   1.7317187E-03,   1.6592547E-03,   1.5941071E-03
     +,   1.5358924E-03,   1.4841390E-03,   1.4383205E-03
     +,   1.3978791E-03,   1.3622183E-03,   1.3307328E-03
     +,   1.3027979E-03,   1.2777846E-03,   1.2550708E-03
     +,   1.2340578E-03,   1.2141890E-03,   1.1949749E-03
     +,   1.1760116E-03,   1.1569980E-03,   1.1377484E-03
     +,   1.1181948E-03,   1.0983835E-03,   1.0784664E-03
     +,   1.0586820E-03,   1.0393325E-03,   1.0207626E-03
     +,   1.0033301E-03,   9.8738214E-04,   9.7323075E-04
     +,   9.6113374E-04,   9.5127505E-04,   9.4375503E-04
     +,   9.3858241E-04,   9.3566871E-04,   9.3483290E-04
     +,   9.3580678E-04,   9.3824335E-04,   9.4173138E-04
     +,   9.4581215E-04,   9.4999385E-04,   9.5377408E-04
     +,   9.5665740E-04,   9.5817266E-04,   9.5789187E-04
     +,   9.5544447E-04,   9.5052953E-04,   9.4292447E-04
     +,   9.3249104E-04,   9.1917888E-04,   9.0302102E-04
     +,   8.8413205E-04,   8.6269918E-04,   8.3897234E-04
     +,   8.1325340E-04,   7.8588037E-04,   7.5721828E-04
     +,   7.2764198E-04,   6.9752545E-04,   6.6723005E-04
     +,   6.3709449E-04,   6.0742587E-04,   5.7849620E-04
     +,   5.5053510E-04,   5.2372983E-04,   4.9822422E-04
     +,   4.7412020E-04,   4.5147966E-04,   4.3032947E-04
     +,   4.1066311E-04,   3.9244839E-04,   3.7563030E-04
     +,   3.6013540E-04,   3.4588011E-04,   3.3276828E-04
     +,   3.2070122E-04,   3.0957771E-04,   2.9929678E-04
     +,   2.8976225E-04,   2.8088072E-04,   2.7256567E-04
     +,   2.6473761E-04,   2.5732277E-04,   2.5025726E-04
     +,   2.4348317E-04,   2.3695025E-04,   2.3061542E-04
     +,   2.2444205E-04,   2.1840048E-04,   2.1246551E-04
     +,   2.0661778E-04,   2.0084241E-04,   1.9512836E-04
     +,   1.8946885E-04,   1.8385927E-04,   1.7829804E-04
     +,   1.7278580E-04,   1.6732400E-04,   1.6191701E-04
     +,   1.5656908E-04,   1.5128558E-04,   1.4607234E-04
     +,   1.4093537E-04,   1.3588082E-04,   1.3091472E-04
     +,   1.2604283E-04,   1.2127060E-04,   1.1660307E-04
     +,   1.1204477E-04,   1.0759971E-04,   1.0327138E-04
     +,   9.9062694E-05,   9.4975956E-05,   9.1013033E-05
     +,   8.7175154E-05,   8.3463041E-05,   7.9877020E-05
     +,   7.6416887E-05,   7.3082025E-05,   6.9871450E-05
     +,   6.6783847E-05,   6.3817512E-05,   6.0970520E-05
     +,   5.8240665E-05,   5.5625529E-05,   5.3122469E-05
     +,   5.0728730E-05,   4.8441376E-05,   4.6257384E-05
     +,   4.4173616E-05,   4.2186879E-05,   4.0293937E-05
     +,   3.8491504E-05,   3.6776306E-05,   3.5145040E-05
     +,   3.3594435E-05,   3.2121239E-05,   3.0722193E-05
     +,   2.9394248E-05,   2.8134280E-05,   2.6939151E-05
     +,   2.5805935E-05,   2.4731684E-05,   2.3713674E-05
     +,   2.2749118E-05,   2.1835358E-05,   2.0969839E-05
     +,   2.0150079E-05,   1.9373700E-05,   1.8638393E-05
     +,   1.7941964E-05,   1.7282300E-05,   1.6657345E-05
     +,   1.6065209E-05,   1.5504045E-05,   1.4972034E-05
     +,   1.4467518E-05,   1.3988877E-05,   1.3534623E-05
     +,   1.3103291E-05,   1.2693507E-05,   1.2303971E-05
     +,   1.1933450E-05,   1.1580781E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wano_fus_70 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_wano_fus_75(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  1.7141476E-05,   1.7917373E-05
     +,   1.8729575E-05,   1.9579787E-05,   2.0469823E-05
     +,   2.1401549E-05,   2.2376933E-05,   2.3398015E-05
     +,   2.4466919E-05,   2.5585878E-05,   2.6757110E-05
     +,   2.7983000E-05,   2.9265992E-05,   3.0608568E-05
     +,   3.2013293E-05,   3.3482789E-05,   3.5019741E-05
     +,   3.6626872E-05,   3.8306938E-05,   4.0062747E-05
     +,   4.1897150E-05,   4.3813012E-05,   4.5813231E-05
     +,   4.7900779E-05,   5.0078528E-05,   5.2349504E-05
     +,   5.4716747E-05,   5.7183359E-05,   5.9752510E-05
     +,   6.2427454E-05,   6.5211607E-05,   6.8108537E-05
     +,   7.1121998E-05,   7.4256037E-05,   7.7515018E-05
     +,   8.0903701E-05,   8.4427294E-05,   8.8091561E-05
     +,   9.1902897E-05,   9.5868389E-05,   9.9996010E-05
     +,   1.0429462E-04,   1.0877367E-04,   1.1344437E-04
     +,   1.1831810E-04,   1.2340782E-04,   1.2872719E-04
     +,   1.3429082E-04,   1.4011395E-04,   1.4621225E-04
     +,   1.5260145E-04,   1.5929721E-04,   1.6631429E-04
     +,   1.7366624E-04,   1.8136505E-04,   1.8941989E-04
     +,   1.9783746E-04,   2.0662101E-04,   2.1576996E-04
     +,   2.2527981E-04,   2.3514243E-04,   2.4534576E-04
     +,   2.5587523E-04,   2.6671440E-04,   2.7784670E-04
     +,   2.8925741E-04,   3.0093582E-04,   3.1287837E-04
     +,   3.2509118E-04,   3.3759369E-04,   3.5042135E-04
     +,   3.6362949E-04,   3.7729481E-04,   3.9151934E-04
     +,   4.0643074E-04,   4.2218374E-04,   4.3896149E-04
     +,   4.5697446E-04,   4.7645945E-04,   4.9768016E-04
     +,   5.2092277E-04,   5.4649496E-04,   5.7472551E-04
     +,   6.0595473E-04,   6.4053811E-04,   6.7884277E-04
     +,   7.2122848E-04,   7.6805352E-04,   8.1965356E-04
     +,   8.7632670E-04,   9.3830901E-04,   1.0057422E-03
     +,   1.0786364E-03,   1.1568217E-03,   1.2399008E-03
     +,   1.3272041E-03,   1.4177486E-03,   1.5102340E-03
     +,   1.6030563E-03,   1.6943794E-03,   1.7822504E-03
     +,   1.8647671E-03,   1.9402960E-03,   2.0076963E-03
     +,   2.0665531E-03,   2.1173661E-03,   2.1616532E-03
     +,   2.2019667E-03,   2.2417593E-03,   2.2851401E-03
     +,   2.3365200E-03,   2.4001342E-03,   2.4796005E-03
     +,   2.5774683E-03,   2.6949055E-03,   2.8315717E-03
     +,   2.9857070E-03,   3.1544636E-03,   3.3343919E-03
     +,   3.5220005E-03,   3.7142548E-03,   3.9088787E-03
     +,   4.1044587E-03,   4.3003070E-03,   4.4961902E-03
     +,   4.6920138E-03,   4.8874686E-03,   5.0817775E-03
     +,   5.2734837E-03,   5.4604360E-03,   5.6399903E-03
     +,   5.8094286E-03,   5.9664487E-03,   6.1094197E-03
     +,   6.2371013E-03,   6.3477829E-03,   6.4381957E-03
     +,   6.5027876E-03,   6.5340181E-03,   6.5239435E-03
     +,   6.4665200E-03,   6.3598864E-03,   6.2074829E-03
     +,   6.0176291E-03,   5.8017643E-03,   5.5720969E-03
     +,   5.3398162E-03,   5.1139854E-03,   4.9016653E-03
     +,   4.7082147E-03,   4.5376350E-03,   4.3925373E-03
     +,   4.2738412E-03,   4.1804672E-03,   4.1093579E-03
     +,   4.0558735E-03,   4.0144725E-03,   3.9794692E-03
     +,   3.9456459E-03,   3.9086742E-03,   3.8652937E-03
     +,   3.8133597E-03,   3.7517920E-03,   3.6804336E-03
     +,   3.5998565E-03,   3.5111313E-03,   3.4155422E-03
     +,   3.3143475E-03,   3.2085641E-03,   3.0988879E-03
     +,   2.9856910E-03,   2.8691075E-03,   2.7492079E-03
     +,   2.6261343E-03,   2.5002882E-03,   2.3724088E-03
     +,   2.2435940E-03,   2.1152815E-03,   1.9891562E-03
     +,   1.8670349E-03,   1.7507166E-03,   1.6418438E-03
     +,   1.5417811E-03,   1.4515232E-03,   1.3716427E-03
     +,   1.3022821E-03,   1.2431885E-03,   1.1937632E-03
     +,   1.1531464E-03,   1.1202971E-03,   1.0940785E-03
     +,   1.0733234E-03,   1.0568961E-03,   1.0437295E-03
     +,   1.0328580E-03,   1.0234303E-03,   1.0147174E-03
     +,   1.0061119E-03,   9.9712436E-04,   9.8737224E-04
     +,   9.7657216E-04,   9.6452684E-04,   9.5111254E-04
     +,   9.3626953E-04,   9.1998739E-04,   9.0229959E-04
     +,   8.8327029E-04,   8.6299016E-04,   8.4157003E-04
     +,   8.1913441E-04,   7.9582242E-04,   7.7177666E-04
     +,   7.4714789E-04,   7.2209112E-04,   6.9676037E-04
     +,   6.7131111E-04,   6.4589316E-04,   6.2065106E-04
     +,   5.9572194E-04,   5.7122821E-04,   5.4728688E-04
     +,   5.2399671E-04,   5.0144218E-04,   4.7969207E-04
     +,   4.5879791E-04,   4.3879921E-04,   4.1971487E-04
     +,   4.0155280E-04,   3.8430723E-04,   3.6796060E-04
     +,   3.5248685E-04,   3.3785068E-04,   3.2401111E-04
     +,   3.1092303E-04,   2.9853647E-04,   2.8680326E-04
     +,   2.7567300E-04,   2.6509681E-04,   2.5502747E-04
     +,   2.4542076E-04,   2.3623508E-04,   2.2743239E-04
     +,   2.1897825E-04,   2.1084197E-04,   2.0299639E-04
     +,   1.9541767E-04,   1.8808573E-04,   1.8098303E-04
     +,   1.7409527E-04,   1.6741031E-04,   1.6091851E-04
     +,   1.5461200E-04,   1.4848467E-04,   1.4253167E-04
     +,   1.3674941E-04,   1.3113514E-04,   1.2568687E-04
     +,   1.2040298E-04,   1.1528248E-04,   1.1032428E-04
     +,   1.0552759E-04,   1.0089149E-04,   9.6415031E-05
     +,   9.2097034E-05,   8.7936154E-05,   8.3930769E-05
     +,   8.0078971E-05,   7.6378565E-05,   7.2827053E-05
     +,   6.9421665E-05,   6.6159351E-05,   6.3036801E-05
     +,   6.0050475E-05,   5.7196634E-05,   5.4471242E-05
     +,   5.1870462E-05,   4.9390124E-05,   4.7025773E-05
     +,   4.4773195E-05,   4.2627988E-05,   4.0586019E-05
     +,   3.8642916E-05,   3.6794445E-05,   3.5036453E-05
     +,   3.3364893E-05,   3.1775795E-05,   3.0265343E-05
     +,   2.8829822E-05,   2.7465667E-05,   2.6169397E-05
     +,   2.4937848E-05,   2.3767871E-05,   2.2656381E-05
     +,   2.1600574E-05,   2.0597701E-05,   1.9645277E-05
     +,   1.8740815E-05,   1.7881994E-05,   1.7066610E-05
     +,   1.6292577E-05,   1.5557907E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wano_fus_75 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_wano_fus_80(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  1.6559869E-05,   1.7075448E-05
     +,   1.7602899E-05,   1.8142689E-05,   1.8695357E-05
     +,   1.9261526E-05,   1.9841897E-05,   2.0437286E-05
     +,   2.1048605E-05,   2.1676902E-05,   2.2323306E-05
     +,   2.2989123E-05,   2.3675793E-05,   2.4384895E-05
     +,   2.5118185E-05,   2.5877564E-05,   2.6665131E-05
     +,   2.7483138E-05,   2.8334029E-05,   2.9220431E-05
     +,   3.0145144E-05,   3.1111165E-05,   3.2121643E-05
     +,   3.3179920E-05,   3.4289442E-05,   3.5453846E-05
     +,   3.6676876E-05,   3.7962378E-05,   3.9314305E-05
     +,   4.0736606E-05,   4.2233311E-05,   4.3808392E-05
     +,   4.5465797E-05,   4.7209360E-05,   4.9042785E-05
     +,   5.0969604E-05,   5.2993099E-05,   5.5116292E-05
     +,   5.7341858E-05,   5.9672093E-05,   6.2108891E-05
     +,   6.4653723E-05,   6.7307323E-05,   7.0070317E-05
     +,   7.2942305E-05,   7.5922588E-05,   7.9009864E-05
     +,   8.2202168E-05,   8.5497035E-05,   8.8891531E-05
     +,   9.2382201E-05,   9.5965297E-05,   9.9636789E-05
     +,   1.0339246E-04,   1.0722830E-04,   1.1114016E-04
     +,   1.1512461E-04,   1.1917872E-04,   1.2330046E-04
     +,   1.2748897E-04,   1.3174482E-04,   1.3607039E-04
     +,   1.4047003E-04,   1.4495057E-04,   1.4952148E-04
     +,   1.5419532E-04,   1.5898787E-04,   1.6391848E-04
     +,   1.6901038E-04,   1.7429069E-04,   1.7979076E-04
     +,   1.8554601E-04,   1.9159628E-04,   1.9798543E-04
     +,   2.0476159E-04,   2.1197629E-04,   2.1968501E-04
     +,   2.2794616E-04,   2.3682066E-04,   2.4637158E-04
     +,   2.5666281E-04,   2.6775859E-04,   2.7972265E-04
     +,   2.9261506E-04,   3.0649343E-04,   3.2141260E-04
     +,   3.3741700E-04,   3.5454557E-04,   3.7282708E-04
     +,   3.9227938E-04,   4.1290687E-04,   4.3470055E-04
     +,   4.5763541E-04,   4.8166999E-04,   5.0674600E-04
     +,   5.3278659E-04,   5.5969704E-04,   5.8736565E-04
     +,   6.1566423E-04,   6.4445171E-04,   6.7357678E-04
     +,   7.0288469E-04,   7.3222542E-04,   7.6146435E-04
     +,   7.9049525E-04,   8.1925804E-04,   8.4775564E-04
     +,   8.7607838E-04,   9.0441643E-04,   9.3308603E-04
     +,   9.6254743E-04,   9.9339767E-04,   1.0263864E-03
     +,   1.0623904E-03,   1.1023908E-03,   1.1474249E-03
     +,   1.1985280E-03,   1.2566559E-03,   1.3226030E-03
     +,   1.3969127E-03,   1.4798002E-03,   1.5710905E-03
     +,   1.6701941E-03,   1.7761207E-03,   1.8875509E-03
     +,   2.0029477E-03,   2.1207235E-03,   2.2394103E-03
     +,   2.3578135E-03,   2.4751266E-03,   2.5909448E-03
     +,   2.7051929E-03,   2.8179579E-03,   2.9292842E-03
     +,   3.0389954E-03,   3.1466305E-03,   3.2515456E-03
     +,   3.3532334E-03,   3.4517739E-03,   3.5483018E-03
     +,   3.6453507E-03,   3.7468413E-03,   3.8577064E-03
     +,   3.9831218E-03,   4.1275602E-03,   4.2939442E-03
     +,   4.4830516E-03,   4.6935934E-03,   4.9225762E-03
     +,   5.1663169E-03,   5.4215733E-03,   5.6868331E-03
     +,   5.9634736E-03,   6.2563135E-03,   6.5730135E-03
     +,   6.9216420E-03,   7.3064612E-03,   7.7232020E-03
     +,   8.1559578E-03,   8.5782791E-03,   8.9590903E-03
     +,   9.2718797E-03,   9.5028644E-03,   9.6543338E-03
     +,   9.7412840E-03,   9.7830202E-03,   9.7938674E-03
     +,   9.7772321E-03,   9.7251218E-03,   9.6230181E-03
     +,   9.4570378E-03,   9.2202099E-03,   8.9154970E-03
     +,   8.5546691E-03,   8.1548421E-03,   7.7348268E-03
     +,   7.3127514E-03,   6.9054826E-03,   6.5285773E-03
     +,   6.1957128E-03,   5.9171687E-03,   5.6980513E-03
     +,   5.5368673E-03,   5.4252511E-03,   5.3488854E-03
     +,   5.2894633E-03,   5.2273055E-03,   5.1442184E-03
     +,   5.0261281E-03,   4.8650089E-03,   4.6597123E-03
     +,   4.4156522E-03,   4.1434052E-03,   3.8566717E-03
     +,   3.5699508E-03,   3.2964651E-03,   3.0466032E-03
     +,   2.8270613E-03,   2.6406979E-03,   2.4869824E-03
     +,   2.3627914E-03,   2.2633784E-03,   2.1832616E-03
     +,   2.1169605E-03,   2.0594862E-03,   2.0066290E-03
     +,   1.9550798E-03,   1.9024138E-03,   1.8470294E-03
     +,   1.7880402E-03,   1.7251704E-03,   1.6586100E-03
     +,   1.5889283E-03,   1.5169492E-03,   1.4436520E-03
     +,   1.3700883E-03,   1.2972901E-03,   1.2262171E-03
     +,   1.1577134E-03,   1.0924637E-03,   1.0310098E-03
     +,   9.7372005E-04,   9.2081487E-04,   8.7237562E-04
     +,   8.2836580E-04,   7.8865513E-04,   7.5302512E-04
     +,   7.2120392E-04,   6.9287297E-04,   6.6768425E-04
     +,   6.4527598E-04,   6.2527915E-04,   6.0732896E-04
     +,   5.9107470E-04,   5.7618256E-04,   5.6234660E-04
     +,   5.4928742E-04,   5.3675688E-04,   5.2454066E-04
     +,   5.1245716E-04,   5.0035812E-04,   4.8812747E-04
     +,   4.7567906E-04,   4.6295451E-04,   4.4992118E-04
     +,   4.3656805E-04,   4.2290418E-04,   4.0895425E-04
     +,   3.9475624E-04,   3.8035843E-04,   3.6581673E-04
     +,   3.5119214E-04,   3.3654855E-04,   3.2195056E-04
     +,   3.0746197E-04,   2.9314446E-04,   2.7905585E-04
     +,   2.6524990E-04,   2.5177511E-04,   2.3867450E-04
     +,   2.2598490E-04,   2.1373713E-04,   2.0195628E-04
     +,   1.9066111E-04,   1.7986486E-04,   1.6957539E-04
     +,   1.5979556E-04,   1.5052379E-04,   1.4175427E-04
     +,   1.3347779E-04,   1.2568204E-04,   1.1835208E-04
     +,   1.1147105E-04,   1.0502039E-04,   9.8980221E-05
     +,   9.3330520E-05,   8.8050459E-05,   8.3118619E-05
     +,   7.8514458E-05,   7.4217511E-05,   7.0208298E-05
     +,   6.6467677E-05,   6.2977437E-05,   5.9720336E-05
     +,   5.6680139E-05,   5.3841479E-05,   5.1190105E-05
     +,   4.8712649E-05,   4.6396694E-05,   4.4230612E-05
     +,   4.2203916E-05,   4.0306662E-05,   3.8529502E-05
     +,   3.6864010E-05,   3.5302204E-05,   3.3836870E-05
     +,   3.2461106E-05,   3.1168569E-05,   2.9953300E-05
     +,   2.8809774E-05,   2.7732820E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wano_fus_80 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_wano_fus_85(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  2.3646405E-06,   2.5831512E-06
     +,   2.8183415E-06,   3.0711253E-06,   3.3424337E-06
     +,   3.6332112E-06,   3.9444135E-06,   4.2770043E-06
     +,   4.6319497E-06,   5.0102281E-06,   5.4127854E-06
     +,   5.8405885E-06,   6.2945819E-06,   6.7756946E-06
     +,   7.2848366E-06,   7.8228913E-06,   8.3907162E-06
     +,   8.9891319E-06,   9.6189215E-06,   1.0280833E-05
     +,   1.0975561E-05,   1.1703753E-05,   1.2466007E-05
     +,   1.3262885E-05,   1.4094833E-05,   1.4962296E-05
     +,   1.5865624E-05,   1.6805134E-05,   1.7781049E-05
     +,   1.8793555E-05,   1.9842753E-05,   2.0928703E-05
     +,   2.2051385E-05,   2.3210747E-05,   2.4406667E-05
     +,   2.5638985E-05,   2.6907494E-05,   2.8211953E-05
     +,   2.9552091E-05,   3.0927618E-05,   3.2338241E-05
     +,   3.3783690E-05,   3.5263580E-05,   3.6777783E-05
     +,   3.8325994E-05,   3.9908100E-05,   4.1524014E-05
     +,   4.3173775E-05,   4.4857552E-05,   4.6575657E-05
     +,   4.8328595E-05,   5.0117080E-05,   5.1942108E-05
     +,   5.3804928E-05,   5.5707198E-05,   5.7650799E-05
     +,   5.9638180E-05,   6.1672195E-05,   6.3756233E-05
     +,   6.5894208E-05,   6.8090674E-05,   7.0350819E-05
     +,   7.2680472E-05,   7.5086231E-05,   7.7575409E-05
     +,   8.0156104E-05,   8.2837156E-05,   8.5628213E-05
     +,   8.8539680E-05,   9.1582740E-05,   9.4769326E-05
     +,   9.8112039E-05,   1.0162427E-04,   1.0531996E-04
     +,   1.0921388E-04,   1.1332116E-04,   1.1765782E-04
     +,   1.2224056E-04,   1.2708669E-04,   1.3221476E-04
     +,   1.3764424E-04,   1.4339596E-04,   1.4949281E-04
     +,   1.5595926E-04,   1.6282302E-04,   1.7011640E-04
     +,   1.7787424E-04,   1.8613863E-04,   1.9495771E-04
     +,   2.0438820E-04,   2.1449669E-04,   2.2536126E-04
     +,   2.3707336E-04,   2.4973982E-04,   2.6348428E-04
     +,   2.7844857E-04,   2.9479401E-04,   3.1270119E-04
     +,   3.3236950E-04,   3.5401504E-04,   3.7786626E-04
     +,   4.0415887E-04,   4.3312690E-04,   4.6499225E-04
     +,   4.9995177E-04,   5.3816027E-04,   5.7971408E-04
     +,   6.2463380E-04,   6.7283778E-04,   7.2413363E-04
     +,   7.7820750E-04,   8.3459588E-04,   8.9270330E-04
     +,   9.5179828E-04,   1.0110317E-03,   1.0694594E-03
     +,   1.1260803E-03,   1.1798770E-03,   1.2298640E-03
     +,   1.2751404E-03,   1.3149414E-03,   1.3486815E-03
     +,   1.3759951E-03,   1.3967617E-03,   1.4111223E-03
     +,   1.4194804E-03,   1.4224894E-03,   1.4210308E-03
     +,   1.4161844E-03,   1.4091902E-03,   1.4014122E-03
     +,   1.3942936E-03,   1.3893218E-03,   1.3879854E-03
     +,   1.3917381E-03,   1.4019542E-03,   1.4198927E-03
     +,   1.4466458E-03,   1.4830962E-03,   1.5298651E-03
     +,   1.5872641E-03,   1.6552487E-03,   1.7333813E-03
     +,   1.8208072E-03,   1.9162566E-03,   2.0180799E-03
     +,   2.1242981E-03,   2.2327707E-03,   2.3412982E-03
     +,   2.4478843E-03,   2.5509419E-03,   2.6495457E-03
     +,   2.7436588E-03,   2.8342938E-03,   2.9236092E-03
     +,   3.0148122E-03,   3.1118956E-03,   3.2191104E-03
     +,   3.3402387E-03,   3.4778125E-03,   3.6324735E-03
     +,   3.8028378E-03,   3.9860550E-03,   4.1790614E-03
     +,   4.3801912E-03,   4.5904801E-03,   4.8140436E-03
     +,   5.0572711E-03,   5.3270757E-03,   5.6290589E-03
     +,   5.9662568E-03,   6.3386564E-03,   6.7426707E-03
     +,   7.1699484E-03,   7.6054502E-03,   8.0270562E-03
     +,   8.4090969E-03,   8.7305019E-03,   8.9844270E-03
     +,   9.1835987E-03,   9.3566459E-03,   9.5368670E-03
     +,   9.7502153E-03,   1.0009869E-02,   1.0318935E-02
     +,   1.0676200E-02,   1.1078144E-02,   1.1514942E-02
     +,   1.1964397E-02,   1.2390422E-02,   1.2749461E-02
     +,   1.3003528E-02,   1.3133840E-02,   1.3147992E-02
     +,   1.3075394E-02,   1.2951439E-02,   1.2798613E-02
     +,   1.2616272E-02,   1.2386054E-02,   1.2089027E-02
     +,   1.1722107E-02,   1.1302156E-02,   1.0856583E-02
     +,   1.0408124E-02,   9.9645946E-03,   9.5188199E-03
     +,   9.0570208E-03,   8.5690450E-03,   8.0545014E-03
     +,   7.5223991E-03,   6.9864765E-03,   6.4593880E-03
     +,   5.9497920E-03,   5.4622716E-03,   4.9992660E-03
     +,   4.5632473E-03,   4.1575544E-03,   3.7862051E-03
     +,   3.4528431E-03,   3.1595952E-03,   2.9065353E-03
     +,   2.6914468E-03,   2.5102473E-03,   2.3575693E-03
     +,   2.2274242E-03,   2.1138247E-03,   2.0112121E-03
     +,   1.9148433E-03,   1.8209772E-03,   1.7269619E-03
     +,   1.6312397E-03,   1.5332188E-03,   1.4331252E-03
     +,   1.3317931E-03,   1.2304287E-03,   1.1304409E-03
     +,   1.0332292E-03,   9.4006496E-04,   8.5199834E-04
     +,   7.6981244E-04,   6.9400924E-04,   6.2482653E-04
     +,   5.6227209E-04,   5.0616649E-04,   4.5619131E-04
     +,   4.1193207E-04,   3.7291803E-04,   3.3865351E-04
     +,   3.0864213E-04,   2.8240445E-04,   2.5948920E-04
     +,   2.3947975E-04,   2.2199817E-04,   2.0670521E-04
     +,   1.9329968E-04,   1.8151691E-04,   1.7112588E-04
     +,   1.6192639E-04,   1.5374644E-04,   1.4643898E-04
     +,   1.3987918E-04,   1.3396151E-04,   1.2859752E-04
     +,   1.2371296E-04,   1.1924589E-04,   1.1514452E-04
     +,   1.1136549E-04,   1.0787236E-04,   1.0463418E-04
     +,   1.0162427E-04,   9.8819575E-05,   9.6199576E-05
     +,   9.3745846E-05,   9.1441616E-05,   8.9271285E-05
     +,   8.7220571E-05,   8.5275868E-05,   8.3424173E-05
     +,   8.1653598E-05,   7.9952712E-05,   7.8311052E-05
     +,   7.6718767E-05,   7.5166790E-05,   7.3646894E-05
     +,   7.2151655E-05,   7.0674469E-05,   6.9209549E-05
     +,   6.7751949E-05,   6.6297463E-05,   6.4842599E-05
     +,   6.3384774E-05,   6.1921943E-05,   6.0452585E-05
     +,   5.8975926E-05,   5.7491568E-05,   5.5999793E-05
     +,   5.4501113E-05,   5.2996453E-05,   5.1487041E-05
     +,   4.9974391E-05,   4.8460213E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wano_fus_85 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_wano_fus_90(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  5.3526423E-06,   5.5594487E-06
     +,   5.7774682E-06,   6.0073262E-06,   6.2496574E-06
     +,   6.5051158E-06,   6.7743672E-06,   7.0580859E-06
     +,   7.3569613E-06,   7.6716915E-06,   8.0029604E-06
     +,   8.3514769E-06,   8.7179369E-06,   9.1030424E-06
     +,   9.5074765E-06,   9.9319313E-06,   1.0377068E-05
     +,   1.0843545E-05,   1.1331998E-05,   1.1843047E-05
     +,   1.2377281E-05,   1.2935264E-05,   1.3517531E-05
     +,   1.4124600E-05,   1.4756912E-05,   1.5414907E-05
     +,   1.6098978E-05,   1.6809478E-05,   1.7546699E-05
     +,   1.8310919E-05,   1.9102343E-05,   1.9921146E-05
     +,   2.0767449E-05,   2.1641337E-05,   2.2542843E-05
     +,   2.3471954E-05,   2.4428624E-05,   2.5412754E-05
     +,   2.6424224E-05,   2.7462871E-05,   2.8528499E-05
     +,   2.9620922E-05,   3.0739819E-05,   3.1885029E-05
     +,   3.3056225E-05,   3.4253153E-05,   3.5475550E-05
     +,   3.6723148E-05,   3.7995724E-05,   3.9293038E-05
     +,   4.0614945E-05,   4.1961295E-05,   4.3332024E-05
     +,   4.4727123E-05,   4.6146684E-05,   4.7590860E-05
     +,   4.9059923E-05,   5.0554288E-05,   5.2074512E-05
     +,   5.3621286E-05,   5.5195524E-05,   5.6798275E-05
     +,   5.8430887E-05,   6.0094877E-05,   6.1792111E-05
     +,   6.3524691E-05,   6.5295084E-05,   6.7106099E-05
     +,   6.8960981E-05,   7.0863309E-05,   7.2817253E-05
     +,   7.4827367E-05,   7.6898832E-05,   7.9037323E-05
     +,   8.1249316E-05,   8.3541723E-05,   8.5922315E-05
     +,   8.8399611E-05,   9.0982918E-05,   9.3682451E-05
     +,   9.6509299E-05,   9.9475561E-05,   1.0259436E-04
     +,   1.0587955E-04,   1.0934637E-04,   1.1301161E-04
     +,   1.1689236E-04,   1.2100755E-04,   1.2537718E-04
     +,   1.3002261E-04,   1.3496635E-04,   1.4023237E-04
     +,   1.4584574E-04,   1.5183300E-04,   1.5822169E-04
     +,   1.6504068E-04,   1.7231962E-04,   1.8008921E-04
     +,   1.8838083E-04,   1.9722630E-04,   2.0665754E-04
     +,   2.1670636E-04,   2.2740393E-04,   2.3878034E-04
     +,   2.5086399E-04,   2.6368099E-04,   2.7725453E-04
     +,   2.9160461E-04,   3.0674462E-04,   3.2268369E-04
     +,   3.3942671E-04,   3.5696680E-04,   3.7529157E-04
     +,   3.9437885E-04,   4.1419617E-04,   4.3470087E-04
     +,   4.5583866E-04,   4.7754403E-04,   4.9974106E-04
     +,   5.2234280E-04,   5.4525380E-04,   5.6837127E-04
     +,   5.9158838E-04,   6.1479758E-04,   6.3789473E-04
     +,   6.6078478E-04,   6.8338739E-04,   7.0564362E-04
     +,   7.2752230E-04,   7.4902549E-04,   7.7019545E-04
     +,   7.9111737E-04,   8.1192225E-04,   8.3278690E-04
     +,   8.5392961E-04,   8.7560480E-04,   8.9809339E-04
     +,   9.2169107E-04,   9.4669248E-04,   9.7338029E-04
     +,   1.0020081E-03,   1.0327903E-03,   1.0658959E-03
     +,   1.1014462E-03,   1.1395185E-03,   1.1801638E-03
     +,   1.2234148E-03,   1.2693313E-03,   1.3180018E-03
     +,   1.3695874E-03,   1.4243313E-03,   1.4825669E-03
     +,   1.5447002E-03,   1.6111739E-03,   1.6824029E-03
     +,   1.7586917E-03,   1.8401311E-03,   1.9264955E-03
     +,   2.0171555E-03,   2.1110356E-03,   2.2066201E-03
     +,   2.3020485E-03,   2.3952839E-03,   2.4843570E-03
     +,   2.5676596E-03,   2.6442315E-03,   2.7139960E-03
     +,   2.7778831E-03,   2.8377960E-03,   2.8964202E-03
     +,   2.9568553E-03,   3.0222251E-03,   3.0952136E-03
     +,   3.1777751E-03,   3.2709280E-03,   3.3748066E-03
     +,   3.4888336E-03,   3.6120338E-03,   3.7433177E-03
     +,   3.8817492E-03,   4.0266793E-03,   4.1777412E-03
     +,   4.3347748E-03,   4.4976766E-03,   4.6662013E-03
     +,   4.8397980E-03,   5.0175507E-03,   5.1982272E-03
     +,   5.3804833E-03,   5.5632787E-03,   5.7461071E-03
     +,   5.9290486E-03,   6.1122826E-03,   6.2953550E-03
     +,   6.4766244E-03,   6.6538979E-03,   6.8265274E-03
     +,   6.9985306E-03,   7.1811234E-03,   7.3926565E-03
     +,   7.6550790E-03,   7.9883216E-03,   8.4053557E-03
     +,   8.9103980E-03,   9.4999736E-03,   1.0164131E-02
     +,   1.0885590E-02,   1.1637213E-02,   1.2381879E-02
     +,   1.3077807E-02,   1.3689729E-02,   1.4202405E-02
     +,   1.4629464E-02,   1.5009978E-02,   1.5387465E-02
     +,   1.5777066E-02,   1.6140835E-02,   1.6392274E-02
     +,   1.6434040E-02,   1.6207328E-02,   1.5722679E-02
     +,   1.5055079E-02,   1.4310242E-02,   1.3583332E-02
     +,   1.2930326E-02,   1.2360349E-02,   1.1844816E-02
     +,   1.1334890E-02,   1.0779397E-02,   1.0139802E-02
     +,   9.4003426E-03,   8.5710455E-03,   7.6833018E-03
     +,   6.7799473E-03,   5.9039742E-03,   5.0908043E-03
     +,   4.3640602E-03,   3.7355539E-03,   3.2070579E-03
     +,   2.7728090E-03,   2.4221211E-03,   2.1417818E-03
     +,   1.9180600E-03,   1.7381910E-03,   1.5912553E-03
     +,   1.4685142E-03,   1.3633500E-03,   1.2709672E-03
     +,   1.1880202E-03,   1.1122419E-03,   1.0421315E-03
     +,   9.7671582E-04,   9.1537659E-04,   8.5773191E-04
     +,   8.0355455E-04,   7.5271568E-04,   7.0514140E-04
     +,   6.6078105E-04,   6.1958074E-04,   5.8146706E-04
     +,   5.4633658E-04,   5.1405246E-04,   4.8444627E-04
     +,   4.5732508E-04,   4.3247914E-04,   4.0969171E-04
     +,   3.8874688E-04,   3.6943684E-04,   3.5156641E-04
     +,   3.3495703E-04,   3.1944748E-04,   3.0489490E-04
     +,   2.9117442E-04,   2.7817755E-04,   2.6581148E-04
     +,   2.5399865E-04,   2.4267397E-04,   2.3178302E-04
     +,   2.2128354E-04,   2.1114183E-04,   2.0133391E-04
     +,   1.9184145E-04,   1.8265290E-04,   1.7376164E-04
     +,   1.6516489E-04,   1.5686276E-04,   1.4885741E-04
     +,   1.4115190E-04,   1.3374985E-04,   1.2665419E-04
     +,   1.1986795E-04,   1.1339238E-04,   1.0722685E-04
     +,   1.0136983E-04,   9.5817719E-05,   9.0565896E-05
     +,   8.5607440E-05,   8.0934187E-05,   7.6536715E-05
     +,   7.2404378E-05,   6.8525755E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wano_fus_90 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_wano_fus_95(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  4.6726112E-09,   5.5204978E-09
     +,   6.5123968E-09,   7.6709279E-09,   9.0219432E-09
     +,   1.0594922E-08,   1.2423433E-08,   1.4545619E-08
     +,   1.7004750E-08,   1.9849871E-08,   2.3136243E-08
     +,   2.6926347E-08,   3.1290494E-08,   3.6307696E-08
     +,   4.2066546E-08,   4.8666301E-08,   5.6217807E-08
     +,   6.4844691E-08,   7.4684657E-08,   8.5890569E-08
     +,   9.8632043E-08,   1.1309683E-07,   1.2949222E-07
     +,   1.4804741E-07,   1.6901313E-07,   1.9266623E-07
     +,   2.1930960E-07,   2.4927476E-07,   2.8292354E-07
     +,   3.2065071E-07,   3.6288509E-07,   4.1009272E-07
     +,   4.6277825E-07,   5.2148744E-07,   5.8680928E-07
     +,   6.5937826E-07,   7.3987638E-07,   8.2903506E-07
     +,   9.2763804E-07,   1.0365223E-06,   1.1565810E-06
     +,   1.2887668E-06,   1.4340802E-06,   1.5936038E-06
     +,   1.7684597E-06,   1.9598456E-06,   2.1690216E-06
     +,   2.3973098E-06,   2.6461000E-06,   2.9168466E-06
     +,   3.2110675E-06,   3.5303481E-06,   3.8763346E-06
     +,   4.2507377E-06,   4.6553373E-06,   5.0919430E-06
     +,   5.5624514E-06,   6.0687980E-06,   6.6129714E-06
     +,   7.1970017E-06,   7.8229614E-06,   8.4929570E-06
     +,   9.2091204E-06,   9.9736062E-06,   1.0788583E-05
     +,   1.1656225E-05,   1.2578695E-05,   1.3558144E-05
     +,   1.4596700E-05,   1.5696442E-05,   1.6859402E-05
     +,   1.8087541E-05,   1.9382742E-05,   2.0746776E-05
     +,   2.2181337E-05,   2.3687890E-05,   2.5267820E-05
     +,   2.6922316E-05,   2.8652343E-05,   3.0458728E-05
     +,   3.2341981E-05,   3.4302364E-05,   3.6339945E-05
     +,   3.8454276E-05,   4.0644714E-05,   4.2910608E-05
     +,   4.5250425E-05,   4.7662692E-05,   5.0145478E-05
     +,   5.2696614E-05,   5.5313638E-05,   5.7993893E-05
     +,   6.0734525E-05,   6.3532643E-05,   6.6385306E-05
     +,   6.9289817E-05,   7.2243696E-05,   7.5244949E-05
     +,   7.8292265E-05,   8.1385275E-05,   8.4524727E-05
     +,   8.7712979E-05,   9.0954076E-05,   9.4254392E-05
     +,   9.7622775E-05,   1.0107113E-04,   1.0461475E-04
     +,   1.0827298E-04,   1.1206888E-04,   1.1603047E-04
     +,   1.2019130E-04,   1.2458916E-04,   1.2926792E-04
     +,   1.3427685E-04,   1.3967058E-04,   1.4550910E-04
     +,   1.5185688E-04,   1.5878271E-04,   1.6635850E-04
     +,   1.7465829E-04,   1.8375658E-04,   1.9372710E-04
     +,   2.0464083E-04,   2.1656380E-04,   2.2955549E-04
     +,   2.4366628E-04,   2.5893591E-04,   2.7539130E-04
     +,   2.9304589E-04,   3.1189833E-04,   3.3193233E-04
     +,   3.5311768E-04,   3.7541112E-04,   3.9875953E-04
     +,   4.2310232E-04,   4.4837638E-04,   4.7451977E-04
     +,   5.0147733E-04,   5.2920525E-04,   5.5767503E-04
     +,   5.8687764E-04,   6.1682495E-04,   6.4754987E-04
     +,   6.7910599E-04,   7.1156264E-04,   7.4500201E-04
     +,   7.7950617E-04,   8.1516564E-04,   8.5205422E-04
     +,   8.9023955E-04,   9.2977477E-04,   9.7070198E-04
     +,   1.0130560E-03,   1.0568732E-03,   1.1021993E-03
     +,   1.1490998E-03,   1.1976605E-03,   1.2479918E-03
     +,   1.3002150E-03,   1.3544414E-03,   1.4107410E-03
     +,   1.4691063E-03,   1.5294066E-03,   1.5913541E-03
     +,   1.6544792E-03,   1.7181268E-03,   1.7814825E-03
     +,   1.8436261E-03,   1.9036103E-03,   1.9605695E-03
     +,   2.0138074E-03,   2.0629151E-03,   2.1078184E-03
     +,   2.1488226E-03,   2.1865906E-03,   2.2220779E-03
     +,   2.2564556E-03,   2.2909758E-03,   2.3268599E-03
     +,   2.3651728E-03,   2.4067189E-03,   2.4519633E-03
     +,   2.5009669E-03,   2.5533582E-03,   2.6083286E-03
     +,   2.6646678E-03,   2.7208545E-03,   2.7751771E-03
     +,   2.8259221E-03,   2.8715818E-03,   2.9110736E-03
     +,   2.9439400E-03,   2.9704939E-03,   2.9918891E-03
     +,   3.0101407E-03,   3.0280238E-03,   3.0489764E-03
     +,   3.0769117E-03,   3.1159958E-03,   3.1703494E-03
     +,   3.2436701E-03,   3.3387623E-03,   3.4570456E-03
     +,   3.5981245E-03,   3.7595748E-03,   3.9370563E-03
     +,   4.1248305E-03,   4.3165605E-03,   4.5062187E-03
     +,   4.6887747E-03,   4.8603388E-03,   5.0177849E-03
     +,   5.1577962E-03,   5.2758879E-03,   5.3659035E-03
     +,   5.4204040E-03,   5.4322234E-03,   5.3968658E-03
     +,   5.3151776E-03,   5.1954221E-03,   5.0539128E-03
     +,   4.9136588E-03,   4.8009381E-03,   4.7404906E-03
     +,   4.7503137E-03,   4.8374436E-03,   4.9959668E-03
     +,   5.2079391E-03,   5.4471311E-03,   5.6846719E-03
     +,   5.8949580E-03,   6.0603805E-03,   6.1735064E-03
     +,   6.2364563E-03,   6.2579950E-03,   6.2495247E-03
     +,   6.2212842E-03,   6.1798971E-03,   6.1277337E-03
     +,   6.0639121E-03,   5.9862463E-03,   5.8931499E-03
     +,   5.7849241E-03,   5.6638615E-03,   5.5334251E-03
     +,   5.3969212E-03,   5.2562873E-03,   5.1115016E-03
     +,   4.9607316E-03,   4.8011816E-03,   4.6302089E-03
     +,   4.4463221E-03,   4.2497395E-03,   4.0423875E-03
     +,   3.8274287E-03,   3.6085700E-03,   3.3893816E-03
     +,   3.1728765E-03,   2.9613459E-03,   2.7564636E-03
     +,   2.5595061E-03,   2.3715545E-03,   2.1936232E-03
     +,   2.0266622E-03,   1.8714755E-03,   1.7286101E-03
     +,   1.5982555E-03,   1.4801980E-03,   1.3738413E-03
     +,   1.2782689E-03,   1.1923508E-03,   1.1148576E-03
     +,   1.0445622E-03,   9.8032586E-04,   9.2114910E-04
     +,   8.6620887E-04,   8.1485184E-04,   7.6658098E-04
     +,   7.2104263E-04,   6.7798869E-04,   6.3725375E-04
     +,   5.9872156E-04,   5.6230865E-04,   5.2794721E-04
     +,   4.9557217E-04,   4.6511539E-04,   4.3650091E-04
     +,   4.0964392E-04,   3.8445173E-04,   3.6082396E-04
     +,   3.3865901E-04,   3.1785158E-04,   2.9829555E-04
     +,   2.7989032E-04,   2.6253887E-04,   2.4615257E-04
     +,   2.3064844E-04,   2.1595228E-04,   2.0199883E-04
     +,   1.8873157E-04,   1.7610249E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wano_fus_95 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_wano_hz_100(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  8.5377218E-07,   8.8345803E-07
     +,   9.1390331E-07,   9.4511660E-07,   9.7710699E-07
     +,   1.0098839E-06,   1.0434555E-06,   1.0778314E-06
     +,   1.1130196E-06,   1.1490300E-06,   1.1858699E-06
     +,   1.2235486E-06,   1.2620753E-06,   1.3014591E-06
     +,   1.3417089E-06,   1.3828349E-06,   1.4248459E-06
     +,   1.4677527E-06,   1.5115666E-06,   1.5562970E-06
     +,   1.6019570E-06,   1.6485589E-06,   1.6961150E-06
     +,   1.7446415E-06,   1.7941499E-06,   1.8446576E-06
     +,   1.8961822E-06,   1.9487418E-06,   2.0023558E-06
     +,   2.0570455E-06,   2.1128335E-06,   2.1697444E-06
     +,   2.2278045E-06,   2.2870420E-06,   2.3474863E-06
     +,   2.4091717E-06,   2.4721314E-06,   2.5364031E-06
     +,   2.6020271E-06,   2.6690457E-06,   2.7375042E-06
     +,   2.8074523E-06,   2.8789377E-06,   2.9520215E-06
     +,   3.0267561E-06,   3.1032064E-06,   3.1814377E-06
     +,   3.2615189E-06,   3.3435244E-06,   3.4275333E-06
     +,   3.5136277E-06,   3.6018944E-06,   3.6924284E-06
     +,   3.7853290E-06,   3.8807016E-06,   3.9786560E-06
     +,   4.0793125E-06,   4.1827989E-06,   4.2892502E-06
     +,   4.3988139E-06,   4.5116471E-06,   4.6279183E-06
     +,   4.7478111E-06,   4.8715233E-06,   4.9992714E-06
     +,   5.1312895E-06,   5.2678342E-06,   5.4091879E-06
     +,   5.5556579E-06,   5.7075858E-06,   5.8653450E-06
     +,   6.0293492E-06,   6.2000577E-06,   6.3779717E-06
     +,   6.5636577E-06,   6.7577266E-06,   6.9608673E-06
     +,   7.1738386E-06,   7.3974747E-06,   7.6327124E-06
     +,   7.8805715E-06,   8.1421776E-06,   8.4187868E-06
     +,   8.7117432E-06,   9.0225403E-06,   9.3528597E-06
     +,   9.7044540E-06,   1.0079290E-05,   1.0479494E-05
     +,   1.0907378E-05,   1.1365435E-05,   1.1856365E-05
     +,   1.2383070E-05,   1.2948676E-05,   1.3556525E-05
     +,   1.4210180E-05,   1.4913458E-05,   1.5670397E-05
     +,   1.6485279E-05,   1.7362638E-05,   1.8307241E-05
     +,   1.9324119E-05,   2.0418531E-05,   2.1595997E-05
     +,   2.2862274E-05,   2.4223365E-05,   2.5685531E-05
     +,   2.7255335E-05,   2.8939394E-05,   3.0744690E-05
     +,   3.2678712E-05,   3.4748762E-05,   3.6962687E-05
     +,   3.9328570E-05,   4.1854761E-05,   4.4549928E-05
     +,   4.7423036E-05,   5.0483402E-05,   5.3740670E-05
     +,   5.7204787E-05,   6.0886079E-05,   6.4795182E-05
     +,   6.8943074E-05,   7.3340947E-05,   7.8000267E-05
     +,   8.2932645E-05,   8.8149791E-05,   9.3663337E-05
     +,   9.9484743E-05,   1.0562516E-04,   1.1209511E-04
     +,   1.1890438E-04,   1.2606171E-04,   1.3357449E-04
     +,   1.4144853E-04,   1.4968752E-04,   1.5829285E-04
     +,   1.6726329E-04,   1.7659452E-04,   1.8627869E-04
     +,   1.9630439E-04,   2.0665598E-04,   2.1731386E-04
     +,   2.2825389E-04,   2.3944743E-04,   2.5086210E-04
     +,   2.6245933E-04,   2.7420017E-04,   2.8603870E-04
     +,   2.9792884E-04,   3.0982192E-04,   3.2166910E-04
     +,   3.3342215E-04,   3.4503543E-04,   3.5646791E-04
     +,   3.6768481E-04,   3.7866013E-04,   3.8937977E-04
     +,   3.9984324E-04,   4.1006715E-04,   4.2008821E-04
     +,   4.2996561E-04,   4.3978443E-04,   4.4965788E-04
     +,   4.5972964E-04,   4.7017573E-04,   4.8120500E-04
     +,   4.9306004E-04,   5.0601491E-04,   5.2037340E-04
     +,   5.3646276E-04,   5.5462844E-04,   5.7522353E-04
     +,   5.9859920E-04,   6.2508677E-04,   6.5497885E-04
     +,   6.8851502E-04,   7.2585576E-04,   7.6706242E-04
     +,   8.1207522E-04,   8.6069450E-04,   9.1256713E-04
     +,   9.6717838E-04,   1.0238519E-03,   1.0817625E-03
     +,   1.1399542E-03,   1.1973786E-03,   1.2529326E-03
     +,   1.3055132E-03,   1.3540749E-03,   1.3976841E-03
     +,   1.4355771E-03,   1.4672070E-03,   1.4922755E-03
     +,   1.5107518E-03,   1.5228739E-03,   1.5291283E-03
     +,   1.5302124E-03,   1.5269790E-03,   1.5203813E-03
     +,   1.5113972E-03,   1.5009707E-03,   1.4899438E-03
     +,   1.4790222E-03,   1.4687371E-03,   1.4594417E-03
     +,   1.4513239E-03,   1.4444288E-03,   1.4387096E-03
     +,   1.4340791E-03,   1.4304686E-03,   1.4278804E-03
     +,   1.4264357E-03,   1.4264032E-03,   1.4282073E-03
     +,   1.4324118E-03,   1.4396880E-03,   1.4507500E-03
     +,   1.4662796E-03,   1.4868407E-03,   1.5127868E-03
     +,   1.5441886E-03,   1.5807626E-03,   1.6218527E-03
     +,   1.6664313E-03,   1.7131336E-03,   1.7603721E-03
     +,   1.8064386E-03,   1.8496641E-03,   1.8885823E-03
     +,   1.9220932E-03,   1.9496018E-03,   1.9711256E-03
     +,   1.9873476E-03,   1.9996080E-03,   2.0098302E-03
     +,   2.0203888E-03,   2.0339168E-03,   2.0530710E-03
     +,   2.0802896E-03,   2.1175635E-03,   2.1662542E-03
     +,   2.2269965E-03,   2.2997181E-03,   2.3837637E-03
     +,   2.4781229E-03,   2.5816914E-03,   2.6935155E-03
     +,   2.8129192E-03,   2.9395008E-03,   3.0729640E-03
     +,   3.2129255E-03,   3.3588130E-03,   3.5100351E-03
     +,   3.6665336E-03,   3.8295758E-03,   4.0024891E-03
     +,   4.1908096E-03,   4.4012773E-03,   4.6396130E-03
     +,   4.9074544E-03,   5.1997276E-03,   5.5038696E-03
     +,   5.8021243E-03,   6.0767927E-03,   6.3167606E-03
     +,   6.5226289E-03,   6.7078872E-03,   6.8952530E-03
     +,   7.1096309E-03,   7.3708952E-03,   7.6895114E-03
     +,   8.0662146E-03,   8.4942626E-03,   8.9617884E-03
     +,   9.4517786E-03,   9.9400571E-03,   1.0393147E-02
     +,   1.0768814E-02,   1.1021112E-02,   1.1109213E-02
     +,   1.1007315E-02,   1.0711851E-02,   1.0243181E-02
     +,   9.6406769E-03,   8.9528719E-03,   8.2262289E-03
     +,   7.4964873E-03,   6.7851623E-03,   6.1013550E-03
     +,   5.4469723E-03,   4.8220241E-03,   4.2281845E-03
     +,   3.6697504E-03,   3.1523581E-03,   2.6811960E-03
     +,   2.2593655E-03,   1.8873675E-03,   1.5633483E-03
     +,   1.2838335E-03,   1.0445777E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wano_hz_100 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_wano_hz_105(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  1.4489831E-06,   1.4857832E-06
     +,   1.5231177E-06,   1.5609805E-06,   1.5993642E-06
     +,   1.6382610E-06,   1.6776635E-06,   1.7175620E-06
     +,   1.7579480E-06,   1.7988114E-06,   1.8401407E-06
     +,   1.8819250E-06,   1.9241525E-06,   1.9668107E-06
     +,   2.0098869E-06,   2.0533671E-06,   2.0972366E-06
     +,   2.1414808E-06,   2.1860842E-06,   2.2310305E-06
     +,   2.2763027E-06,   2.3218836E-06,   2.3677555E-06
     +,   2.4138997E-06,   2.4602964E-06,   2.5069262E-06
     +,   2.5537690E-06,   2.6008033E-06,   2.6480086E-06
     +,   2.6953628E-06,   2.7428432E-06,   2.7904271E-06
     +,   2.8380907E-06,   2.8858115E-06,   2.9335633E-06
     +,   2.9813230E-06,   3.0290653E-06,   3.0767637E-06
     +,   3.1243940E-06,   3.1719294E-06,   3.2193443E-06
     +,   3.2666117E-06,   3.3137037E-06,   3.3605972E-06
     +,   3.4072621E-06,   3.4536731E-06,   3.4998029E-06
     +,   3.5456260E-06,   3.5911157E-06,   3.6362467E-06
     +,   3.6809945E-06,   3.7253335E-06,   3.7692421E-06
     +,   3.8126966E-06,   3.8556782E-06,   3.8981671E-06
     +,   3.9401466E-06,   3.9816041E-06,   4.0225277E-06
     +,   4.0629116E-06,   4.1027533E-06,   4.1420572E-06
     +,   4.1808325E-06,   4.2190986E-06,   4.2568799E-06
     +,   4.2942161E-06,   4.3311575E-06,   4.3677692E-06
     +,   4.4041344E-06,   4.4403573E-06,   4.4765638E-06
     +,   4.5129113E-06,   4.5495863E-06,   4.5868142E-06
     +,   4.6248633E-06,   4.6640516E-06,   4.7047533E-06
     +,   4.7474132E-06,   4.7925446E-06,   4.8407542E-06
     +,   4.8927391E-06,   4.9493101E-06,   5.0114063E-06
     +,   5.0800982E-06,   5.1566208E-06,   5.2423934E-06
     +,   5.3390122E-06,   5.4483066E-06,   5.5723426E-06
     +,   5.7134512E-06,   5.8742530E-06,   6.0576908E-06
     +,   6.2670424E-06,   6.5059662E-06,   6.7785127E-06
     +,   7.0891638E-06,   7.4428535E-06,   7.8449884E-06
     +,   8.3014866E-06,   8.8187753E-06,   9.4038260E-06
     +,   1.0064161E-05,   1.0807856E-05,   1.1643549E-05
     +,   1.2580424E-05,   1.3628211E-05,   1.4797150E-05
     +,   1.6098025E-05,   1.7541894E-05,   1.9140281E-05
     +,   2.0905281E-05,   2.2848792E-05,   2.4983163E-05
     +,   2.7320702E-05,   2.9873681E-05,   3.2654174E-05
     +,   3.5673933E-05,   3.8944254E-05,   4.2475815E-05
     +,   4.6278514E-05,   5.0361348E-05,   5.4732198E-05
     +,   5.9397709E-05,   6.4363136E-05,   6.9632188E-05
     +,   7.5206932E-05,   8.1087659E-05,   8.7272740E-05
     +,   9.3758739E-05,   1.0054015E-04,   1.0760954E-04
     +,   1.1495760E-04,   1.2257315E-04,   1.3044330E-04
     +,   1.3855351E-04,   1.4688799E-04,   1.5542975E-04
     +,   1.6416109E-04,   1.7306367E-04,   1.8211911E-04
     +,   1.9130929E-04,   2.0061663E-04,   2.1002469E-04
     +,   2.1951841E-04,   2.2908466E-04,   2.3871275E-04
     +,   2.4839293E-04,   2.5812094E-04,   2.6789232E-04
     +,   2.7770715E-04,   2.8756793E-04,   2.9747933E-04
     +,   3.0744838E-04,   3.1748341E-04,   3.2759397E-04
     +,   3.3778953E-04,   3.4807873E-04,   3.5846865E-04
     +,   3.6896326E-04,   3.7956316E-04,   3.9026351E-04
     +,   4.0105410E-04,   4.1191812E-04,   4.2283160E-04
     +,   4.3376337E-04,   4.4467484E-04,   4.5552058E-04
     +,   4.6624918E-04,   4.7680511E-04,   4.8712941E-04
     +,   4.9716257E-04,   5.0684769E-04,   5.1613431E-04
     +,   5.2498182E-04,   5.3336425E-04,   5.4127444E-04
     +,   5.4873206E-04,   5.5578776E-04,   5.6253106E-04
     +,   5.6909624E-04,   5.7566905E-04,   5.8249471E-04
     +,   5.8988080E-04,   5.9820391E-04,   6.0790946E-04
     +,   6.1951153E-04,   6.3358841E-04,   6.5077300E-04
     +,   6.7173823E-04,   6.9718022E-04,   7.2779023E-04
     +,   7.6422747E-04,   8.0708525E-04,   8.5685425E-04
     +,   9.1388472E-04,   9.7835052E-04,   1.0502134E-03
     +,   1.1291980E-03,   1.2147647E-03,   1.3061046E-03
     +,   1.4021343E-03,   1.5015110E-03,   1.6026618E-03
     +,   1.7038251E-03,   1.8031121E-03,   1.8985771E-03
     +,   1.9883094E-03,   2.0705250E-03,   2.1436703E-03
     +,   2.2065192E-03,   2.2582465E-03,   2.2985167E-03
     +,   2.3274939E-03,   2.3458572E-03,   2.3547609E-03
     +,   2.3557593E-03,   2.3507080E-03,   2.3416365E-03
     +,   2.3306229E-03,   2.3196721E-03,   2.3106171E-03
     +,   2.3050464E-03,   2.3042578E-03,   2.3092481E-03
     +,   2.3207073E-03,   2.3390178E-03,   2.3642653E-03
     +,   2.3962036E-03,   2.4342278E-03,   2.4773430E-03
     +,   2.5241240E-03,   2.5727211E-03,   2.6209084E-03
     +,   2.6661775E-03,   2.7059100E-03,   2.7375885E-03
     +,   2.7590361E-03,   2.7686721E-03,   2.7656965E-03
     +,   2.7502477E-03,   2.7234221E-03,   2.6872065E-03
     +,   2.6442946E-03,   2.5978249E-03,   2.5510329E-03
     +,   2.5069164E-03,   2.4679189E-03,   2.4356826E-03
     +,   2.4109157E-03,   2.3933963E-03,   2.3820945E-03
     +,   2.3754092E-03,   2.3714891E-03,   2.3685682E-03
     +,   2.3652900E-03,   2.3609616E-03,   2.3557018E-03
     +,   2.3504889E-03,   2.3471171E-03,   2.3480575E-03
     +,   2.3563011E-03,   2.3751885E-03,   2.4082386E-03
     +,   2.4589919E-03,   2.5308377E-03,   2.6267960E-03
     +,   2.7492454E-03,   2.8995774E-03,   3.0778204E-03
     +,   3.2822916E-03,   3.5093448E-03,   3.7533429E-03
     +,   4.0069059E-03,   4.2615095E-03,   4.5084110E-03
     +,   4.7397991E-03,   4.9501522E-03,   5.1374538E-03
     +,   5.3040734E-03,   5.4572034E-03,   5.6084315E-03
     +,   5.7726041E-03,   5.9657190E-03,   6.2023136E-03
     +,   6.4925593E-03,   6.8396768E-03,   7.2380276E-03
     +,   7.6723411E-03,   8.1180893E-03,   8.5428972E-03
     +,   8.9089647E-03,   9.1763521E-03,   9.3069561E-03
     +,   9.2690317E-03,   9.0419007E-03,   8.6199380E-03
     +,   8.0148885E-03,   7.2556776E-03,   6.3854516E-03
     +,   5.4561296E-03,   4.5216135E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wano_hz_105 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_wano_hz_110(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  1.0931579E-06,   1.1318621E-06
     +,   1.1715235E-06,   1.2121480E-06,   1.2537413E-06
     +,   1.2963063E-06,   1.3398470E-06,   1.3843659E-06
     +,   1.4298646E-06,   1.4763451E-06,   1.5238064E-06
     +,   1.5722480E-06,   1.6216694E-06,   1.6720684E-06
     +,   1.7234423E-06,   1.7757887E-06,   1.8291030E-06
     +,   1.8833813E-06,   1.9386187E-06,   1.9948109E-06
     +,   2.0519519E-06,   2.1100375E-06,   2.1690619E-06
     +,   2.2290214E-06,   2.2899096E-06,   2.3517234E-06
     +,   2.4144601E-06,   2.4781186E-06,   2.5426980E-06
     +,   2.6081993E-06,   2.6746275E-06,   2.7419878E-06
     +,   2.8102907E-06,   2.8795478E-06,   2.9497767E-06
     +,   3.0209985E-06,   3.0932401E-06,   3.1665340E-06
     +,   3.2409207E-06,   3.3164454E-06,   3.3931651E-06
     +,   3.4711445E-06,   3.5504547E-06,   3.6311869E-06
     +,   3.7134371E-06,   3.7973180E-06,   3.8829558E-06
     +,   3.9704946E-06,   4.0600944E-06,   4.1519374E-06
     +,   4.2462211E-06,   4.3431678E-06,   4.4430249E-06
     +,   4.5460624E-06,   4.6525788E-06,   4.7628955E-06
     +,   4.8773722E-06,   4.9963942E-06,   5.1203833E-06
     +,   5.2497926E-06,   5.3851145E-06,   5.5268765E-06
     +,   5.6756462E-06,   5.8320293E-06,   5.9966733E-06
     +,   6.1702690E-06,   6.3535422E-06,   6.5472700E-06
     +,   6.7522651E-06,   6.9693833E-06,   7.1995237E-06
     +,   7.4436225E-06,   7.7026571E-06,   7.9776391E-06
     +,   8.2696242E-06,   8.5796801E-06,   8.9089226E-06
     +,   9.2584842E-06,   9.6295162E-06,   1.0023206E-05
     +,   1.0440732E-05,   1.0883287E-05,   1.1352090E-05
     +,   1.1848294E-05,   1.2373077E-05,   1.2927676E-05
     +,   1.3513170E-05,   1.4130699E-05,   1.4781352E-05
     +,   1.5466178E-05,   1.6186177E-05,   1.6942307E-05
     +,   1.7735472E-05,   1.8566523E-05,   1.9436246E-05
     +,   2.0345375E-05,   2.1294585E-05,   2.2284485E-05
     +,   2.3315639E-05,   2.4388552E-05,   2.5503687E-05
     +,   2.6661472E-05,   2.7862290E-05,   2.9106506E-05
     +,   3.0394489E-05,   3.1726591E-05,   3.3103188E-05
     +,   3.4524732E-05,   3.5991543E-05,   3.7504109E-05
     +,   3.9063190E-05,   4.0669223E-05,   4.2323009E-05
     +,   4.4025393E-05,   4.5777313E-05,   4.7579859E-05
     +,   4.9434213E-05,   5.1341711E-05,   5.3303804E-05
     +,   5.5322085E-05,   5.7398280E-05,   5.9534217E-05
     +,   6.1731858E-05,   6.3993277E-05,   6.6320645E-05
     +,   6.8716254E-05,   7.1182512E-05,   7.3721909E-05
     +,   7.6337063E-05,   7.9030739E-05,   8.1805818E-05
     +,   8.4665458E-05,   8.7612927E-05,   9.0651854E-05
     +,   9.3786162E-05,   9.7020173E-05,   1.0035867E-04
     +,   1.0380696E-04,   1.0737102E-04,   1.1105742E-04
     +,   1.1487356E-04,   1.1882761E-04,   1.2292856E-04
     +,   1.2718626E-04,   1.3161132E-04,   1.3621543E-04
     +,   1.4101005E-04,   1.4600861E-04,   1.5122355E-04
     +,   1.5666820E-04,   1.6235570E-04,   1.6829866E-04
     +,   1.7450941E-04,   1.8099909E-04,   1.8777813E-04
     +,   1.9485566E-04,   2.0223972E-04,   2.0993763E-04
     +,   2.1795601E-04,   2.2630171E-04,   2.3498267E-04
     +,   2.4400921E-04,   2.5339564E-04,   2.6316239E-04
     +,   2.7333800E-04,   2.8396220E-04,   2.9508772E-04
     +,   3.0678377E-04,   3.1913756E-04,   3.3225739E-04
     +,   3.4627077E-04,   3.6132758E-04,   3.7759557E-04
     +,   3.9525962E-04,   4.1451294E-04,   4.3554892E-04
     +,   4.5855483E-04,   4.8369772E-04,   5.1111192E-04
     +,   5.4088642E-04,   5.7305233E-04,   6.0757098E-04
     +,   6.4432807E-04,   6.8312761E-04,   7.2369428E-04
     +,   7.6567888E-04,   8.0867129E-04,   8.5221702E-04
     +,   8.9583901E-04,   9.3906262E-04,   9.8144298E-04
     +,   1.0225860E-03,   1.0621739E-03,   1.0999752E-03
     +,   1.1358585E-03,   1.1697860E-03,   1.2018059E-03
     +,   1.2320306E-03,   1.2606139E-03,   1.2877198E-03
     +,   1.3134980E-03,   1.3380613E-03,   1.3614768E-03
     +,   1.3837684E-03,   1.4049393E-03,   1.4250084E-03
     +,   1.4440548E-03,   1.4622703E-03,   1.4800136E-03
     +,   1.4978419E-03,   1.5165207E-03,   1.5370218E-03
     +,   1.5604669E-03,   1.5880587E-03,   1.6209811E-03
     +,   1.6602761E-03,   1.7067355E-03,   1.7607691E-03
     +,   1.8223212E-03,   1.8908024E-03,   1.9650471E-03
     +,   2.0433601E-03,   2.1235861E-03,   2.2032631E-03
     +,   2.2798222E-03,   2.3508177E-03,   2.4142303E-03
     +,   2.4686770E-03,   2.5136149E-03,   2.5494313E-03
     +,   2.5773847E-03,   2.5994135E-03,   2.6178053E-03
     +,   2.6347546E-03,   2.6519254E-03,   2.6700490E-03
     +,   2.6886745E-03,   2.7061242E-03,   2.7196899E-03
     +,   2.7260350E-03,   2.7217746E-03,   2.7041056E-03
     +,   2.6713884E-03,   2.6235741E-03,   2.5623799E-03
     +,   2.4911934E-03,   2.4147024E-03,   2.3383296E-03
     +,   2.2675544E-03,   2.2072447E-03,   2.1611073E-03
     +,   2.1313301E-03,   2.1184816E-03,   2.1216408E-03
     +,   2.1387469E-03,   2.1670749E-03,   2.2037481E-03
     +,   2.2462204E-03,   2.2926154E-03,   2.3418996E-03
     +,   2.3938701E-03,   2.4489497E-03,   2.5078664E-03
     +,   2.5712822E-03,   2.6394317E-03,   2.7118707E-03
     +,   2.7873786E-03,   2.8640328E-03,   2.9394494E-03
     +,   3.0111095E-03,   3.0767056E-03,   3.1344141E-03
     +,   3.1830356E-03,   3.2219824E-03,   3.2511291E-03
     +,   3.2706179E-03,   3.2806792E-03,   3.2815398E-03
     +,   3.2734089E-03,   3.2565757E-03,   3.2314754E-03
     +,   3.1987270E-03,   3.1590583E-03,   3.1131585E-03
     +,   3.0614478E-03,   3.0039127E-03,   2.9400017E-03
     +,   2.8686461E-03,   2.7884310E-03,   2.6978338E-03
     +,   2.5955238E-03,   2.4806103E-03,   2.3528344E-03
     +,   2.2126974E-03,   2.0614692E-03,   1.9011482E-03
     +,   1.7343065E-03,   1.5639493E-03,   1.3933185E-03
     +,   1.2256869E-03,   1.0641614E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wano_hz_110 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_wano_hz_115(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  8.3957559E-07,   8.7881790E-07
     +,   9.1951171E-07,   9.6169128E-07,   1.0053910E-06
     +,   1.0506445E-06,   1.0974862E-06,   1.1459493E-06
     +,   1.1960674E-06,   1.2478750E-06,   1.3014032E-06
     +,   1.3566853E-06,   1.4137538E-06,   1.4726404E-06
     +,   1.5333770E-06,   1.5959944E-06,   1.6605227E-06
     +,   1.7269925E-06,   1.7954326E-06,   1.8658717E-06
     +,   1.9383385E-06,   2.0128596E-06,   2.0894624E-06
     +,   2.1681740E-06,   2.2490160E-06,   2.3320147E-06
     +,   2.4171939E-06,   2.5045751E-06,   2.5941808E-06
     +,   2.6860316E-06,   2.7801473E-06,   2.8765469E-06
     +,   2.9752471E-06,   3.0762656E-06,   3.1796180E-06
     +,   3.2853191E-06,   3.3933825E-06,   3.5038199E-06
     +,   3.6166441E-06,   3.7318648E-06,   3.8494909E-06
     +,   3.9695342E-06,   4.0919936E-06,   4.2168854E-06
     +,   4.3442078E-06,   4.4739672E-06,   4.6061668E-06
     +,   4.7408093E-06,   4.8778970E-06,   5.0174308E-06
     +,   5.1594102E-06,   5.3038361E-06,   5.4507077E-06
     +,   5.6000249E-06,   5.7517896E-06,   5.9059953E-06
     +,   6.0626458E-06,   6.2217400E-06,   6.3832808E-06
     +,   6.5472677E-06,   6.7137075E-06,   6.8826025E-06
     +,   7.0539622E-06,   7.2277940E-06,   7.4041118E-06
     +,   7.5829312E-06,   7.7642699E-06,   7.9481533E-06
     +,   8.1346061E-06,   8.3236655E-06,   8.5153652E-06
     +,   8.7097542E-06,   8.9068835E-06,   9.1068114E-06
     +,   9.3096114E-06,   9.5153491E-06,   9.7241191E-06
     +,   9.9360150E-06,   1.0151140E-05,   1.0369624E-05
     +,   1.0591594E-05,   1.0817198E-05,   1.1046604E-05
     +,   1.1279971E-05,   1.1517488E-05,   1.1759396E-05
     +,   1.2005890E-05,   1.2257228E-05,   1.2513679E-05
     +,   1.2775527E-05,   1.3043085E-05,   1.3316688E-05
     +,   1.3596691E-05,   1.3883483E-05,   1.4177475E-05
     +,   1.4479112E-05,   1.4788870E-05,   1.5107255E-05
     +,   1.5434811E-05,   1.5772124E-05,   1.6119820E-05
     +,   1.6478565E-05,   1.6849084E-05,   1.7232149E-05
     +,   1.7628598E-05,   1.8039327E-05,   1.8465314E-05
     +,   1.8907629E-05,   1.9367379E-05,   1.9845806E-05
     +,   2.0344321E-05,   2.0864347E-05,   2.1407515E-05
     +,   2.1975589E-05,   2.2570504E-05,   2.3194374E-05
     +,   2.3849521E-05,   2.4538482E-05,   2.5264029E-05
     +,   2.6029200E-05,   2.6837301E-05,   2.7691931E-05
     +,   2.8596996E-05,   2.9556724E-05,   3.0575691E-05
     +,   3.1658783E-05,   3.2811266E-05,   3.4038745E-05
     +,   3.5347159E-05,   3.6742807E-05,   3.8232312E-05
     +,   3.9822608E-05,   4.1520943E-05,   4.3334825E-05
     +,   4.5272031E-05,   4.7340560E-05,   4.9548649E-05
     +,   5.1904666E-05,   5.4417204E-05,   5.7094952E-05
     +,   5.9946749E-05,   6.2981519E-05,   6.6208275E-05
     +,   6.9636095E-05,   7.3274081E-05,   7.7131481E-05
     +,   8.1216785E-05,   8.5539534E-05,   9.0107766E-05
     +,   9.4929783E-05,   1.0001313E-04,   1.0536448E-04
     +,   1.1098939E-04,   1.1689204E-04,   1.2307479E-04
     +,   1.2953789E-04,   1.3627918E-04,   1.4329377E-04
     +,   1.5057386E-04,   1.5810863E-04,   1.6588451E-04
     +,   1.7388535E-04,   1.8209335E-04,   1.9049011E-04
     +,   1.9905790E-04,   2.0778192E-04,   2.1665230E-04
     +,   2.2566732E-04,   2.3483598E-04,   2.4418192E-04
     +,   2.5374515E-04,   2.6358693E-04,   2.7379056E-04
     +,   2.8446486E-04,   2.9574209E-04,   3.0777650E-04
     +,   3.2074333E-04,   3.3483174E-04,   3.5023736E-04
     +,   3.6715300E-04,   3.8575719E-04,   4.0620120E-04
     +,   4.2859701E-04,   4.5300394E-04,   4.7941785E-04
     +,   5.0776341E-04,   5.3789007E-04,   5.6957203E-04
     +,   6.0251617E-04,   6.3637196E-04,   6.7075307E-04
     +,   7.0525671E-04,   7.3949486E-04,   7.7312137E-04
     +,   8.0586266E-04,   8.3754468E-04,   8.6811616E-04
     +,   8.9766178E-04,   9.2640670E-04,   9.5470954E-04
     +,   9.8303938E-04,   1.0119417E-03,   1.0419909E-03
     +,   1.0737340E-03,   1.1076296E-03,   1.1439854E-03
     +,   1.1829087E-03,   1.2242682E-03,   1.2676804E-03
     +,   1.3125234E-03,   1.3579677E-03,   1.4030666E-03
     +,   1.4468235E-03,   1.4882998E-03,   1.5267166E-03
     +,   1.5615190E-03,   1.5924459E-03,   1.6195276E-03
     +,   1.6430611E-03,   1.6635422E-03,   1.6815641E-03
     +,   1.6977132E-03,   1.7124637E-03,   1.7261116E-03
     +,   1.7387321E-03,   1.7501962E-03,   1.7602509E-03
     +,   1.7686024E-03,   1.7750555E-03,   1.7796262E-03
     +,   1.7826378E-03,   1.7847662E-03,   1.7870240E-03
     +,   1.7906923E-03,   1.7971955E-03,   1.8079517E-03
     +,   1.8242241E-03,   1.8469965E-03,   1.8768879E-03
     +,   1.9141256E-03,   1.9585593E-03,   2.0097131E-03
     +,   2.0668427E-03,   2.1289880E-03,   2.1950086E-03
     +,   2.2636091E-03,   2.3333633E-03,   2.4027429E-03
     +,   2.4701816E-03,   2.5341434E-03,   2.5931878E-03
     +,   2.6459941E-03,   2.6913530E-03,   2.7281072E-03
     +,   2.7550797E-03,   2.7710639E-03,   2.7749003E-03
     +,   2.7656697E-03,   2.7429638E-03,   2.7072120E-03
     +,   2.6598941E-03,   2.6036031E-03,   2.5418892E-03
     +,   2.4788871E-03,   2.4187933E-03,   2.3653212E-03
     +,   2.3212091E-03,   2.2879043E-03,   2.2654496E-03
     +,   2.2525806E-03,   2.2469768E-03,   2.2456478E-03
     +,   2.2453328E-03,   2.2429028E-03,   2.2356824E-03
     +,   2.2216833E-03,   2.1997073E-03,   2.1693371E-03
     +,   2.1308230E-03,   2.0848971E-03,   2.0325675E-03
     +,   1.9748975E-03,   1.9128579E-03,   1.8472233E-03
     +,   1.7785458E-03,   1.7071749E-03,   1.6333206E-03
     +,   1.5571226E-03,   1.4787139E-03,   1.3982669E-03
     +,   1.3160346E-03,   1.2323492E-03,   1.1476210E-03
     +,   1.0623555E-03,   9.7712851E-04,   8.9259521E-04
     +,   8.0945488E-04,   7.2844338E-04,   6.5030169E-04
     +,   5.7574065E-04,   5.0540513E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wano_hz_115 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_wano_hz_120(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  1.7892551E-09,   2.0403872E-09
     +,   2.3244540E-09,   2.6454372E-09,   3.0077569E-09
     +,   3.4163030E-09,   3.8764885E-09,   4.3942934E-09
     +,   4.9763207E-09,   5.6298592E-09,   6.3628889E-09
     +,   7.1842248E-09,   8.1035312E-09,   9.1314103E-09
     +,   1.0279467E-08,   1.1560393E-08,   1.2988048E-08
     +,   1.4577560E-08,   1.6345394E-08,   1.8309471E-08
     +,   2.0489265E-08,   2.2905905E-08,   2.5582263E-08
     +,   2.8543173E-08,   3.1815279E-08,   3.5427515E-08
     +,   3.9410985E-08,   4.3799197E-08,   4.8628170E-08
     +,   5.3936475E-08,   5.9765497E-08,   6.6159615E-08
     +,   7.3166113E-08,   8.0835555E-08,   8.9221857E-08
     +,   9.8382209E-08,   1.0837761E-07,   1.1927280E-07
     +,   1.3113619E-07,   1.4404041E-07,   1.5806215E-07
     +,   1.7328277E-07,   1.8978641E-07,   2.0766443E-07
     +,   2.2701025E-07,   2.4792334E-07,   2.7050783E-07
     +,   2.9487256E-07,   3.2113155E-07,   3.4940402E-07
     +,   3.7981405E-07,   4.1249137E-07,   4.4757087E-07
     +,   4.8519280E-07,   5.2550422E-07,   5.6865457E-07
     +,   6.1480182E-07,   6.6410900E-07,   7.1674430E-07
     +,   7.7288320E-07,   8.3270515E-07,   8.9639730E-07
     +,   9.6415238E-07,   1.0361692E-06,   1.1126541E-06
     +,   1.1938189E-06,   1.2798823E-06,   1.3710712E-06
     +,   1.4676187E-06,   1.5697656E-06,   1.6777609E-06
     +,   1.7918612E-06,   1.9123329E-06,   2.0394509E-06
     +,   2.1735016E-06,   2.3147750E-06,   2.4635790E-06
     +,   2.6202306E-06,   2.7850554E-06,   2.9584044E-06
     +,   3.1406310E-06,   3.3321087E-06,   3.5332362E-06
     +,   3.7444061E-06,   3.9660454E-06,   4.1986350E-06
     +,   4.4426210E-06,   4.6985178E-06,   4.9668570E-06
     +,   5.2482042E-06,   5.5431610E-06,   5.8523674E-06
     +,   6.1765099E-06,   6.5163222E-06,   6.8725903E-06
     +,   7.2461621E-06,   7.6379465E-06,   8.0489253E-06
     +,   8.4801604E-06,   8.9327932E-06,   9.4080633E-06
     +,   9.9073031E-06,   1.0431962E-05,   1.0983603E-05
     +,   1.1563913E-05,   1.2174713E-05,   1.2817963E-05
     +,   1.3495809E-05,   1.4210467E-05,   1.4964363E-05
     +,   1.5760204E-05,   1.6600674E-05,   1.7488759E-05
     +,   1.8427601E-05,   1.9420509E-05,   2.0470983E-05
     +,   2.1582671E-05,   2.2759392E-05,   2.4005103E-05
     +,   2.5323894E-05,   2.6719945E-05,   2.8197528E-05
     +,   2.9760940E-05,   3.1414485E-05,   3.3162454E-05
     +,   3.5008976E-05,   3.6958096E-05,   3.9013619E-05
     +,   4.1179061E-05,   4.3457574E-05,   4.5851877E-05
     +,   4.8364185E-05,   5.0996052E-05,   5.3748387E-05
     +,   5.6621262E-05,   5.9613929E-05,   6.2724648E-05
     +,   6.5950670E-05,   6.9288166E-05,   7.2732160E-05
     +,   7.6276570E-05,   7.9914105E-05,   8.3636347E-05
     +,   8.7433800E-05,   9.1296046E-05,   9.5211915E-05
     +,   9.9168908E-05,   1.0315533E-04,   1.0715810E-04
     +,   1.1116503E-04,   1.1516433E-04,   1.1914522E-04
     +,   1.2309841E-04,   1.2701667E-04,   1.3089534E-04
     +,   1.3473281E-04,   1.3853119E-04,   1.4229688E-04
     +,   1.4604087E-04,   1.4977921E-04,   1.5353333E-04
     +,   1.5733013E-04,   1.6120206E-04,   1.6518687E-04
     +,   1.6932715E-04,   1.7366967E-04,   1.7826480E-04
     +,   1.8316507E-04,   1.8842437E-04,   1.9409624E-04
     +,   2.0023172E-04,   2.0687915E-04,   2.1408102E-04
     +,   2.2187416E-04,   2.3028640E-04,   2.3933560E-04
     +,   2.4902995E-04,   2.5936624E-04,   2.7032977E-04
     +,   2.8189458E-04,   2.9402410E-04,   3.0667239E-04
     +,   3.1978588E-04,   3.3330516E-04,   3.4716868E-04
     +,   3.6131474E-04,   3.7568572E-04,   3.9023132E-04
     +,   4.0491248E-04,   4.1970456E-04,   4.3460028E-04
     +,   4.4961236E-04,   4.6477406E-04,   4.8013937E-04
     +,   4.9578166E-04,   5.1178999E-04,   5.2826462E-04
     +,   5.4531038E-04,   5.6302873E-04,   5.8151025E-04
     +,   6.0082471E-04,   6.2101393E-04,   6.4208335E-04
     +,   6.6399836E-04,   6.8668055E-04,   7.1000808E-04
     +,   7.3382095E-04,   7.5792655E-04,   7.8211358E-04
     +,   8.0616656E-04,   8.2987919E-04,   8.5308700E-04
     +,   8.7567675E-04,   8.9761679E-04,   9.1897417E-04
     +,   9.3992788E-04,   9.6078217E-04,   9.8195847E-04
     +,   1.0039791E-03,   1.0274384E-03,   1.0529442E-03
     +,   1.0810634E-03,   1.1122444E-03,   1.1467420E-03
     +,   1.1845530E-03,   1.2253637E-03,   1.2685523E-03
     +,   1.3131972E-03,   1.3581533E-03,   1.4021525E-03
     +,   1.4439207E-03,   1.4823150E-03,   1.5164214E-03
     +,   1.5456231E-03,   1.5696225E-03,   1.5883973E-03
     +,   1.6021336E-03,   1.6111342E-03,   1.6157248E-03
     +,   1.6162045E-03,   1.6128316E-03,   1.6058581E-03
     +,   1.5956095E-03,   1.5825792E-03,   1.5675278E-03
     +,   1.5515584E-03,   1.5361564E-03,   1.5231969E-03
     +,   1.5148920E-03,   1.5137171E-03,   1.5222800E-03
     +,   1.5431589E-03,   1.5786878E-03,   1.6306903E-03
     +,   1.7001730E-03,   1.7869879E-03,   1.8895183E-03
     +,   2.0044569E-03,   2.1267675E-03,   2.2498991E-03
     +,   2.3663146E-03,   2.4683236E-03,   2.5491088E-03
     +,   2.6037833E-03,   2.6302594E-03,   2.6297283E-03
     +,   2.6065891E-03,   2.5678289E-03,   2.5219212E-03
     +,   2.4774631E-03,   2.4418123E-03,   2.4199609E-03
     +,   2.4138417E-03,   2.4221672E-03,   2.4407646E-03
     +,   2.4633522E-03,   2.4825467E-03,   2.4909999E-03
     +,   2.4824017E-03,   2.4522811E-03,   2.3984741E-03
     +,   2.3212032E-03,   2.2228400E-03,   2.1073655E-03
     +,   1.9796928E-03,   1.8449588E-03,   1.7079067E-03
     +,   1.5724499E-03,   1.4414517E-03,   1.3167035E-03
     +,   1.1990949E-03,   1.0888212E-03,   9.8565046E-04
     +,   8.8917499E-04,   7.9895707E-04,   7.1464735E-04
     +,   6.3599652E-04,   5.6285987E-04,   4.9515994E-04
     +,   4.3284689E-04,   3.7586375E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wano_hz_120 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_wano_hz_60(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  2.0840144E-04,   2.2507168E-04
     +,   2.4289583E-04,   2.6194516E-04,   2.8229438E-04
     +,   3.0402135E-04,   3.2720581E-04,   3.5192873E-04
     +,   3.7827151E-04,   4.0631645E-04,   4.3614540E-04
     +,   4.6784533E-04,   5.0150981E-04,   5.3724530E-04
     +,   5.7517545E-04,   6.1544916E-04,   6.5824401E-04
     +,   7.0376723E-04,   7.5225328E-04,   8.0395560E-04
     +,   8.5913029E-04,   9.1801828E-04,   9.8082470E-04
     +,   1.0477013E-03,   1.1187353E-03,   1.1939594E-03
     +,   1.2733710E-03,   1.3569678E-03,   1.4448026E-03
     +,   1.5370310E-03,   1.6339531E-03,   1.7360295E-03
     +,   1.8438556E-03,   1.9580880E-03,   2.0793302E-03
     +,   2.2079719E-03,   2.3440241E-03,   2.4869589E-03
     +,   2.6356226E-03,   2.7882208E-03,   2.9424375E-03
     +,   3.0956848E-03,   3.2454212E-03,   3.3895932E-03
     +,   3.5269556E-03,   3.6573543E-03,   3.7817541E-03
     +,   3.9020616E-03,   4.0207081E-03,   4.1401107E-03
     +,   4.2620944E-03,   4.3874448E-03,   4.5156260E-03
     +,   4.6447720E-03,   4.7718319E-03,   4.8928601E-03
     +,   5.0033103E-03,   5.0983233E-03,   5.1729726E-03
     +,   5.2225427E-03,   5.2429107E-03,   5.2309944E-03
     +,   5.1853252E-03,   5.1064929E-03,   4.9974280E-03
     +,   4.8632999E-03,   4.7110119E-03,   4.5483466E-03
     +,   4.3829149E-03,   4.2211278E-03,   4.0674168E-03
     +,   3.9238273E-03,   3.7900442E-03,   3.6637988E-03
     +,   3.5415257E-03,   3.4191571E-03,   3.2928234E-03
     +,   3.1594783E-03,   3.0172660E-03,   2.8656784E-03
     +,   2.7055263E-03,   2.5387239E-03,   2.3679724E-03
     +,   2.1964258E-03,   2.0273072E-03,   1.8635868E-03
     +,   1.7078241E-03,   1.5619466E-03,   1.4272385E-03
     +,   1.3043511E-03,   1.1933813E-03,   1.0939811E-03
     +,   1.0054865E-03,   9.2703401E-04,   8.5766759E-04
     +,   7.9642318E-04,   7.4238348E-04,   6.9471658E-04
     +,   6.5269024E-04,   6.1567430E-04,   5.8313127E-04
     +,   5.5460125E-04,   5.2968640E-04,   5.0803367E-04
     +,   4.8932096E-04,   4.7324676E-04,   4.5952131E-04
     +,   4.4786491E-04,   4.3800625E-04,   4.2968430E-04
     +,   4.2264830E-04,   4.1666668E-04,   4.1152522E-04
     +,   4.0703212E-04,   4.0301887E-04,   3.9934146E-04
     +,   3.9587906E-04,   3.9253393E-04,   3.8922776E-04
     +,   3.8590105E-04,   3.8250911E-04,   3.7901997E-04
     +,   3.7541206E-04,   3.7167175E-04,   3.6779122E-04
     +,   3.6376767E-04,   3.5960088E-04,   3.5529345E-04
     +,   3.5084944E-04,   3.4627409E-04,   3.4157370E-04
     +,   3.3675524E-04,   3.3182648E-04,   3.2679600E-04
     +,   3.2167314E-04,   3.1646830E-04,   3.1119288E-04
     +,   3.0585926E-04,   3.0048090E-04,   2.9507285E-04
     +,   2.8965084E-04,   2.8423194E-04,   2.7883422E-04
     +,   2.7347667E-04,   2.6817917E-04,   2.6296193E-04
     +,   2.5784664E-04,   2.5285329E-04,   2.4800393E-04
     +,   2.4331905E-04,   2.3881908E-04,   2.3452347E-04
     +,   2.3045079E-04,   2.2661818E-04,   2.2304134E-04
     +,   2.1973382E-04,   2.1670776E-04,   2.1397273E-04
     +,   2.1153608E-04,   2.0940263E-04,   2.0757483E-04
     +,   2.0605243E-04,   2.0483258E-04,   2.0391004E-04
     +,   2.0327677E-04,   2.0292256E-04,   2.0283478E-04
     +,   2.0299880E-04,   2.0339778E-04,   2.0401335E-04
     +,   2.0482547E-04,   2.0581273E-04,   2.0695268E-04
     +,   2.0822219E-04,   2.0959745E-04,   2.1105415E-04
     +,   2.1256813E-04,   2.1411532E-04,   2.1567197E-04
     +,   2.1721503E-04,   2.1872226E-04,   2.2017234E-04
     +,   2.2154524E-04,   2.2282216E-04,   2.2398571E-04
     +,   2.2502034E-04,   2.2591178E-04,   2.2664771E-04
     +,   2.2721756E-04,   2.2761250E-04,   2.2782561E-04
     +,   2.2785152E-04,   2.2768698E-04,   2.2733017E-04
     +,   2.2678087E-04,   2.2604071E-04,   2.2511248E-04
     +,   2.2400060E-04,   2.2271047E-04,   2.2124885E-04
     +,   2.1962330E-04,   2.1784245E-04,   2.1591545E-04
     +,   2.1385211E-04,   2.1166274E-04,   2.0935782E-04
     +,   2.0694829E-04,   2.0444486E-04,   2.0185823E-04
     +,   1.9919898E-04,   1.9647773E-04,   1.9370414E-04
     +,   1.9088777E-04,   1.8803759E-04,   1.8516196E-04
     +,   1.8226884E-04,   1.7936525E-04,   1.7645766E-04
     +,   1.7355187E-04,   1.7065259E-04,   1.6776440E-04
     +,   1.6489097E-04,   1.6203511E-04,   1.5919923E-04
     +,   1.5638494E-04,   1.5359372E-04,   1.5082592E-04
     +,   1.4808180E-04,   1.4536119E-04,   1.4266346E-04
     +,   1.3998791E-04,   1.3733341E-04,   1.3469857E-04
     +,   1.3208218E-04,   1.2948236E-04,   1.2689798E-04
     +,   1.2432740E-04,   1.2176911E-04,   1.1922179E-04
     +,   1.1668416E-04,   1.1415515E-04,   1.1163386E-04
     +,   1.0911953E-04,   1.0661170E-04,   1.0411003E-04
     +,   1.0161452E-04,   9.9125304E-05,   9.6642783E-05
     +,   9.4167604E-05,   9.1700604E-05,   8.9242814E-05
     +,   8.6795517E-05,   8.4360101E-05,   8.1938146E-05
     +,   7.9531383E-05,   7.7141682E-05,   7.4770956E-05
     +,   7.2421273E-05,   7.0094684E-05,   6.7793342E-05
     +,   6.5519409E-05,   6.3274994E-05,   6.1062266E-05
     +,   5.8883303E-05,   5.6740140E-05,   5.4634729E-05
     +,   5.2568965E-05,   5.0544597E-05,   4.8563299E-05
     +,   4.6626625E-05,   4.4735963E-05,   4.2892596E-05
     +,   4.1097639E-05,   3.9352082E-05,   3.7656671E-05
     +,   3.6012207E-05,   3.4419209E-05,   3.2877910E-05
     +,   3.1388565E-05,   2.9951198E-05,   2.8565833E-05
     +,   2.7232181E-05,   2.5949896E-05,   2.4718483E-05
     +,   2.3537332E-05,   2.2405737E-05,   2.1322854E-05
     +,   2.0287771E-05,   1.9299478E-05,   1.8356835E-05
     +,   1.7458773E-05,   1.6604050E-05,   1.5791316E-05
     +,   1.5019282E-05,   1.4286555E-05,   1.3591801E-05
     +,   1.2933578E-05,   1.2310454E-05,   1.1720989E-05
     +,   1.1163752E-05,   1.0637302E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wano_hz_60 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_wano_hz_65(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  5.1976578E-05,   5.5626722E-05
     +,   5.9626698E-05,   6.3999600E-05,   6.8768219E-05
     +,   7.3954870E-05,   7.9581107E-05,   8.5667401E-05
     +,   9.2233022E-05,   9.9295743E-05,   1.0687111E-04
     +,   1.1497291E-04,   1.2361247E-04,   1.3279846E-04
     +,   1.4253665E-04,   1.5283001E-04,   1.6367834E-04
     +,   1.7507873E-04,   1.8702568E-04,   1.9951207E-04
     +,   2.1252991E-04,   2.2607250E-04,   2.4013617E-04
     +,   2.5472415E-04,   2.6984885E-04,   2.8553887E-04
     +,   3.0184296E-04,   3.1883709E-04,   3.3663047E-04
     +,   3.5537203E-04,   3.7525626E-04,   3.9652686E-04
     +,   4.1947793E-04,   4.4445187E-04,   4.7183211E-04
     +,   5.0203147E-04,   5.3547393E-04,   5.7257363E-04
     +,   6.1370590E-04,   6.5918075E-04,   7.0921122E-04
     +,   7.6389068E-04,   8.2316657E-04,   8.8684587E-04
     +,   9.5458044E-04,   1.0259032E-03,   1.1002551E-03
     +,   1.1770428E-03,   1.2556998E-03,   1.3357598E-03
     +,   1.4169330E-03,   1.4991653E-03,   1.5826866E-03
     +,   1.6680219E-03,   1.7559794E-03,   1.8475777E-03
     +,   1.9439711E-03,   2.0463220E-03,   2.1556821E-03
     +,   2.2728732E-03,   2.3984110E-03,   2.5324593E-03
     +,   2.6748213E-03,   2.8249824E-03,   2.9821303E-03
     +,   3.1451888E-03,   3.3128064E-03,   3.4833262E-03
     +,   3.6547594E-03,   3.8248294E-03,   3.9910777E-03
     +,   4.1511171E-03,   4.3029399E-03,   4.4452371E-03
     +,   4.5776065E-03,   4.7004954E-03,   4.8149042E-03
     +,   4.9217790E-03,   5.0212890E-03,   5.1121912E-03
     +,   5.1914733E-03,   5.2544754E-03,   5.2955509E-03
     +,   5.3090989E-03,   5.2908012E-03,   5.2387007E-03
     +,   5.1538893E-03,   5.0405730E-03,   4.9055805E-03
     +,   4.7573773E-03,   4.6049040E-03,   4.4564609E-03
     +,   4.3188520E-03,   4.1969088E-03,   4.0933262E-03
     +,   4.0087346E-03,   3.9419173E-03,   3.8900422E-03
     +,   3.8489474E-03,   3.8134377E-03,   3.7777266E-03
     +,   3.7359791E-03,   3.6829291E-03,   3.6145204E-03
     +,   3.5283577E-03,   3.4240000E-03,   3.3028580E-03
     +,   3.1678728E-03,   3.0229699E-03,   2.8723935E-03
     +,   2.7201171E-03,   2.5694859E-03,   2.4229400E-03
     +,   2.2820502E-03,   2.1476746E-03,   2.0201982E-03
     +,   1.8997815E-03,   1.7865503E-03,   1.6807031E-03
     +,   1.5825389E-03,   1.4924031E-03,   1.4106085E-03
     +,   1.3373483E-03,   1.2726171E-03,   1.2161750E-03
     +,   1.1675452E-03,   1.1260388E-03,   1.0908120E-03
     +,   1.0609296E-03,   1.0354276E-03,   1.0133770E-03
     +,   9.9392503E-04,   9.7633083E-04,   9.5997716E-04
     +,   9.4437797E-04,   9.2917017E-04,   9.1410021E-04
     +,   8.9900941E-04,   8.8381523E-04,   8.6849654E-04
     +,   8.5307669E-04,   8.3761208E-04,   8.2218170E-04
     +,   8.0687838E-04,   7.9180242E-04,   7.7705598E-04
     +,   7.6274009E-04,   7.4894639E-04,   7.3576125E-04
     +,   7.2325801E-04,   7.1149733E-04,   7.0052815E-04
     +,   6.9038552E-04,   6.8109122E-04,   6.7265547E-04
     +,   6.6507800E-04,   6.5834931E-04,   6.5245182E-04
     +,   6.4736145E-04,   6.4304791E-04,   6.3947641E-04
     +,   6.3660718E-04,   6.3439645E-04,   6.3279481E-04
     +,   6.3174800E-04,   6.3119526E-04,   6.3107017E-04
     +,   6.3129858E-04,   6.3179940E-04,   6.3248409E-04
     +,   6.3325727E-04,   6.3401723E-04,   6.3465716E-04
     +,   6.3506688E-04,   6.3513406E-04,   6.3474709E-04
     +,   6.3379685E-04,   6.3217990E-04,   6.2979938E-04
     +,   6.2657043E-04,   6.2241906E-04,   6.1728596E-04
     +,   6.1112759E-04,   6.0391758E-04,   5.9564679E-04
     +,   5.8632478E-04,   5.7597790E-04,   5.6464912E-04
     +,   5.5239798E-04,   5.3929660E-04,   5.2543054E-04
     +,   5.1089429E-04,   4.9578998E-04,   4.8022557E-04
     +,   4.6431087E-04,   4.4815658E-04,   4.3187162E-04
     +,   4.1556082E-04,   3.9932370E-04,   3.8325257E-04
     +,   3.6743173E-04,   3.5193595E-04,   3.3683065E-04
     +,   3.2217105E-04,   3.0800226E-04,   2.9435960E-04
     +,   2.8126899E-04,   2.6874739E-04,   2.5680361E-04
     +,   2.4543868E-04,   2.3464920E-04,   2.2442313E-04
     +,   2.1474586E-04,   2.0559858E-04,   1.9695914E-04
     +,   1.8880457E-04,   1.8110916E-04,   1.7384697E-04
     +,   1.6699226E-04,   1.6051835E-04,   1.5440086E-04
     +,   1.4861531E-04,   1.4313875E-04,   1.3794955E-04
     +,   1.3302731E-04,   1.2835392E-04,   1.2391162E-04
     +,   1.1968491E-04,   1.1565942E-04,   1.1182201E-04
     +,   1.0816117E-04,   1.0466605E-04,   1.0132700E-04
     +,   9.8135213E-05,   9.5082338E-05,   9.2161295E-05
     +,   8.9365189E-05,   8.6687665E-05,   8.4122825E-05
     +,   8.1665086E-05,   7.9309204E-05,   7.7050150E-05
     +,   7.4883152E-05,   7.2803618E-05,   7.0807080E-05
     +,   6.8889341E-05,   6.7046247E-05,   6.5273860E-05
     +,   6.3568361E-05,   6.1926083E-05,   6.0343515E-05
     +,   5.8817313E-05,   5.7344248E-05,   5.5921275E-05
     +,   5.4545526E-05,   5.3214248E-05,   5.1924904E-05
     +,   5.0675051E-05,   4.9462476E-05,   4.8285037E-05
     +,   4.7140806E-05,   4.6027966E-05,   4.4944856E-05
     +,   4.3889919E-05,   4.2861742E-05,   4.1859003E-05
     +,   4.0880503E-05,   3.9925155E-05,   3.8991933E-05
     +,   3.8079899E-05,   3.7188234E-05,   3.6316131E-05
     +,   3.5462876E-05,   3.4627810E-05,   3.3810298E-05
     +,   3.3009837E-05,   3.2225918E-05,   3.1457985E-05
     +,   3.0705629E-05,   2.9968394E-05,   2.9245970E-05
     +,   2.8537954E-05,   2.7844013E-05,   2.7163818E-05
     +,   2.6497077E-05,   2.5843508E-05,   2.5202840E-05
     +,   2.4574823E-05,   2.3959215E-05,   2.3355760E-05
     +,   2.2764294E-05,   2.2184613E-05,   2.1616459E-05
     +,   2.1059677E-05,   2.0514051E-05,   1.9979461E-05
     +,   1.9455709E-05,   1.8942632E-05,   1.8440071E-05
     +,   1.7947868E-05,   1.7465874E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wano_hz_65 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_wano_hz_70(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  3.7912057E-05,   4.0628296E-05
     +,   4.3504071E-05,   4.6544930E-05,   4.9756254E-05
     +,   5.3143183E-05,   5.6710607E-05,   6.0463124E-05
     +,   6.4405052E-05,   6.8540467E-05,   7.2872848E-05
     +,   7.7405639E-05,   8.2141843E-05,   8.7084205E-05
     +,   9.2235190E-05,   9.7597011E-05,   1.0317176E-04
     +,   1.0896137E-04,   1.1496773E-04,   1.2119272E-04
     +,   1.2763841E-04,   1.3430695E-04,   1.4120077E-04
     +,   1.4832294E-04,   1.5567637E-04,   1.6326507E-04
     +,   1.7109349E-04,   1.7916688E-04,   1.8749131E-04
     +,   1.9607379E-04,   2.0492250E-04,   2.1404697E-04
     +,   2.2345797E-04,   2.3316826E-04,   2.4319257E-04
     +,   2.5354786E-04,   2.6425405E-04,   2.7533414E-04
     +,   2.8681479E-04,   2.9872698E-04,   3.1110627E-04
     +,   3.2399312E-04,   3.3743255E-04,   3.5147628E-04
     +,   3.6617919E-04,   3.8160145E-04,   3.9780664E-04
     +,   4.1486038E-04,   4.3282902E-04,   4.5177777E-04
     +,   4.7176937E-04,   4.9286231E-04,   5.1510980E-04
     +,   5.3855940E-04,   5.6325510E-04,   5.8923592E-04
     +,   6.1654398E-04,   6.4522540E-04,   6.7533646E-04
     +,   7.0695003E-04,   7.4015849E-04,   7.7508111E-04
     +,   8.1186183E-04,   8.5067219E-04,   8.9170603E-04
     +,   9.3517610E-04,   9.8130747E-04,   1.0303349E-03
     +,   1.0825023E-03,   1.1380685E-03,   1.1973163E-03
     +,   1.2605749E-03,   1.3282376E-03,   1.4007859E-03
     +,   1.4787990E-03,   1.5629490E-03,   1.6539843E-03
     +,   1.7526731E-03,   1.8597328E-03,   1.9757452E-03
     +,   2.1010581E-03,   2.2357218E-03,   2.3794761E-03
     +,   2.5317813E-03,   2.6919742E-03,   2.8594844E-03
     +,   3.0339977E-03,   3.2157183E-03,   3.4053971E-03
     +,   3.6041832E-03,   3.8132651E-03,   4.0332992E-03
     +,   4.2637871E-03,   4.5026154E-03,   4.7459197E-03
     +,   4.9884571E-03,   5.2245222E-03,   5.4491581E-03
     +,   5.6594610E-03,   5.8555254E-03,   6.0407277E-03
     +,   6.2211989E-03,   6.4045549E-03,   6.5981708E-03
     +,   6.8073380E-03,   7.0336997E-03,   7.2741462E-03
     +,   7.5203786E-03,   7.7592810E-03,   7.9743313E-03
     +,   8.1480630E-03,   8.2652876E-03,   8.3166268E-03
     +,   8.3010690E-03,   8.2265781E-03,   8.1083709E-03
     +,   7.9649882E-03,   7.8136185E-03,   7.6659373E-03
     +,   7.5258734E-03,   7.3895915E-03,   7.2474657E-03
     +,   7.0871334E-03,   6.8968693E-03,   6.6685053E-03
     +,   6.3994243E-03,   6.0934611E-03,   5.7605375E-03
     +,   5.4151267E-03,   5.0739469E-03,   4.7533652E-03
     +,   4.4670729E-03,   4.2245593E-03,   4.0304288E-03
     +,   3.8846002E-03,   3.7829925E-03,   3.7185824E-03
     +,   3.6824504E-03,   3.6648253E-03,   3.6560085E-03
     +,   3.6472217E-03,   3.6312772E-03,   3.6030784E-03
     +,   3.5598504E-03,   3.5011028E-03,   3.4283120E-03
     +,   3.3444236E-03,   3.2531815E-03,   3.1585454E-03
     +,   3.0641053E-03,   2.9727025E-03,   2.8862385E-03
     +,   2.8056335E-03,   2.7309554E-03,   2.6616405E-03
     +,   2.5967634E-03,   2.5352864E-03,   2.4762871E-03
     +,   2.4191006E-03,   2.3634124E-03,   2.3092423E-03
     +,   2.2568991E-03,   2.2068615E-03,   2.1596507E-03
     +,   2.1156974E-03,   2.0752144E-03,   2.0381194E-03
     +,   2.0039889E-03,   1.9720737E-03,   1.9413462E-03
     +,   1.9106078E-03,   1.8785866E-03,   1.8440753E-03
     +,   1.8060382E-03,   1.7637084E-03,   1.7166517E-03
     +,   1.6647828E-03,   1.6083680E-03,   1.5479786E-03
     +,   1.4844347E-03,   1.4187268E-03,   1.3519336E-03
     +,   1.2851498E-03,   1.2194159E-03,   1.1556643E-03
     +,   1.0946819E-03,   1.0370911E-03,   9.8334090E-04
     +,   9.3371212E-04,   8.8833214E-04,   8.4719906E-04
     +,   8.1020093E-04,   7.7714428E-04,   7.4777560E-04
     +,   7.2180433E-04,   6.9891883E-04,   6.7880226E-04
     +,   6.6114392E-04,   6.4564426E-04,   6.3202385E-04
     +,   6.2002341E-04,   6.0940621E-04,   5.9995754E-04
     +,   5.9148530E-04,   5.8381737E-04,   5.7680043E-04
     +,   5.7029852E-04,   5.6419056E-04,   5.5836991E-04
     +,   5.5274135E-04,   5.4722116E-04,   5.4173375E-04
     +,   5.3621229E-04,   5.3059717E-04,   5.2483450E-04
     +,   5.1887659E-04,   5.1268144E-04,   5.0621090E-04
     +,   4.9943326E-04,   4.9232010E-04,   4.8484982E-04
     +,   4.7700471E-04,   4.6877319E-04,   4.6014891E-04
     +,   4.5113111E-04,   4.4172636E-04,   4.3194409E-04
     +,   4.2180155E-04,   4.1132039E-04,   4.0052715E-04
     +,   3.8945375E-04,   3.7813518E-04,   3.6660989E-04
     +,   3.5491929E-04,   3.4310509E-04,   3.3121265E-04
     +,   3.1928590E-04,   3.0736913E-04,   2.9550548E-04
     +,   2.8373653E-04,   2.7210169E-04,   2.6063793E-04
     +,   2.4937917E-04,   2.3835612E-04,   2.2759597E-04
     +,   2.1712252E-04,   2.0695577E-04,   1.9711234E-04
     +,   1.8760507E-04,   1.7844360E-04,   1.6963440E-04
     +,   1.6118094E-04,   1.5308388E-04,   1.4534155E-04
     +,   1.3794994E-04,   1.3090322E-04,   1.2419382E-04
     +,   1.1781279E-04,   1.1175007E-04,   1.0599464E-04
     +,   1.0053485E-04,   9.5358555E-05,   9.0453213E-05
     +,   8.5806234E-05,   8.1404971E-05,   7.7236931E-05
     +,   7.3289870E-05,   6.9551796E-05,   6.6011096E-05
     +,   6.2656720E-05,   5.9477941E-05,   5.6464665E-05
     +,   5.3607258E-05,   5.0896720E-05,   4.8324375E-05
     +,   4.5882520E-05,   4.3563694E-05,   4.1360785E-05
     +,   3.9267463E-05,   3.7277696E-05,   3.5386140E-05
     +,   3.3587610E-05,   3.1877385E-05,   3.0251103E-05
     +,   2.8704759E-05,   2.7234581E-05,   2.5837120E-05
     +,   2.4509140E-05,   2.3247634E-05,   2.2049715E-05
     +,   2.0912828E-05,   1.9834455E-05,   1.8812121E-05
     +,   1.7843586E-05,   1.6926653E-05,   1.6059283E-05
     +,   1.5239426E-05,   1.4465114E-05,   1.3734440E-05
     +,   1.3045552E-05,   1.2396633E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wano_hz_70 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_wano_hz_75(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  9.4050474E-06,   9.8552682E-06
     +,   1.0324345E-05,   1.0813228E-05,   1.1322952E-05
     +,   1.1854628E-05,   1.2409473E-05,   1.2988785E-05
     +,   1.3593982E-05,   1.4226593E-05,   1.4888231E-05
     +,   1.5580661E-05,   1.6305756E-05,   1.7065533E-05
     +,   1.7862132E-05,   1.8697834E-05,   1.9575062E-05
     +,   2.0496385E-05,   2.1464530E-05,   2.2482367E-05
     +,   2.3552948E-05,   2.4679479E-05,   2.5865354E-05
     +,   2.7114169E-05,   2.8429657E-05,   2.9815827E-05
     +,   3.1276912E-05,   3.2817370E-05,   3.4441960E-05
     +,   3.6155740E-05,   3.7964091E-05,   3.9872779E-05
     +,   4.1887972E-05,   4.4016298E-05,   4.6264893E-05
     +,   4.8641414E-05,   5.1154166E-05,   5.3812058E-05
     +,   5.6624722E-05,   5.9602549E-05,   6.2756662E-05
     +,   6.6099121E-05,   6.9642534E-05,   7.3400872E-05
     +,   7.7388424E-05,   8.1620572E-05,   8.6113549E-05
     +,   9.0884234E-05,   9.5950258E-05,   1.0132990E-04
     +,   1.0704196E-04,   1.1310587E-04,   1.1954137E-04
     +,   1.2636880E-04,   1.3360908E-04,   1.4128312E-04
     +,   1.4941320E-04,   1.5802252E-04,   1.6713551E-04
     +,   1.7677878E-04,   1.8698155E-04,   1.9777671E-04
     +,   2.0920168E-04,   2.2129998E-04,   2.3412198E-04
     +,   2.4772680E-04,   2.6218331E-04,   2.7757161E-04
     +,   2.9398382E-04,   3.1152461E-04,   3.3031157E-04
     +,   3.5047438E-04,   3.7215414E-04,   3.9550051E-04
     +,   4.2067099E-04,   4.4782422E-04,   4.7712075E-04
     +,   5.0871627E-04,   5.4275856E-04,   5.7938549E-04
     +,   6.1871833E-04,   6.6085975E-04,   7.0589239E-04
     +,   7.5386412E-04,   8.0479449E-04,   8.5866731E-04
     +,   9.1540476E-04,   9.7487716E-04,   1.0368850E-03
     +,   1.1011552E-03,   1.1673383E-03,   1.2350216E-03
     +,   1.3037450E-03,   1.3730410E-03,   1.4424862E-03
     +,   1.5117638E-03,   1.5807503E-03,   1.6495971E-03
     +,   1.7188176E-03,   1.7893664E-03,   1.8626915E-03
     +,   1.9407514E-03,   2.0259826E-03,   2.1211896E-03
     +,   2.2293541E-03,   2.3533553E-03,   2.4955967E-03
     +,   2.6575932E-03,   2.8395292E-03,   3.0399689E-03
     +,   3.2557480E-03,   3.4820673E-03,   3.7130918E-03
     +,   3.9427946E-03,   4.1661011E-03,   4.3801358E-03
     +,   4.5852908E-03,   4.7858316E-03,   4.9897972E-03
     +,   5.2079502E-03,   5.4518334E-03,   5.7311920E-03
     +,   6.0512507E-03,   6.4105424E-03,   6.7999517E-03
     +,   7.2037135E-03,   7.6025524E-03,   7.9787429E-03
     +,   8.3220843E-03,   8.6347628E-03,   8.9328745E-03
     +,   9.2427814E-03,   9.5923003E-03,   9.9995248E-03
     +,   1.0463223E-02,   1.0959013E-02,   1.1443008E-02
     +,   1.1861475E-02,   1.2163055E-02,   1.2310033E-02
     +,   1.2286104E-02,   1.2099364E-02,   1.1780187E-02
     +,   1.1374838E-02,   1.0936200E-02,   1.0513764E-02
     +,   1.0144984E-02,   9.8489979E-03,   9.6245278E-03
     +,   9.4522182E-03,   9.3019875E-03,   9.1433609E-03
     +,   8.9555979E-03,   8.7333405E-03,   8.4863016E-03
     +,   8.2334876E-03,   7.9950402E-03,   7.7852863E-03
     +,   7.6087862E-03,   7.4599599E-03,   7.3253252E-03
     +,   7.1873353E-03,   7.0285089E-03,   6.8351971E-03
     +,   6.6002249E-03,   6.3239904E-03,   6.0139559E-03
     +,   5.6828330E-03,   5.3459234E-03,   5.0183726E-03
     +,   4.7128717E-03,   4.4380808E-03,   4.1981395E-03
     +,   3.9929328E-03,   3.8190421E-03,   3.6709709E-03
     +,   3.5423785E-03,   3.4271828E-03,   3.3203510E-03
     +,   3.2183146E-03,   3.1190445E-03,   3.0218414E-03
     +,   2.9269573E-03,   2.8351159E-03,   2.7471068E-03
     +,   2.6634489E-03,   2.5842404E-03,   2.5091118E-03
     +,   2.4373112E-03,   2.3678630E-03,   2.2997269E-03
     +,   2.2319688E-03,   2.1638747E-03,   2.0950160E-03
     +,   2.0252711E-03,   1.9547977E-03,   1.8839787E-03
     +,   1.8133583E-03,   1.7435702E-03,   1.6752817E-03
     +,   1.6091401E-03,   1.5457455E-03,   1.4856278E-03
     +,   1.4292335E-03,   1.3769224E-03,   1.3289660E-03
     +,   1.2855423E-03,   1.2467358E-03,   1.2125352E-03
     +,   1.1828255E-03,   1.1574008E-03,   1.1359490E-03
     +,   1.1180732E-03,   1.1032921E-03,   1.0910587E-03
     +,   1.0807766E-03,   1.0718178E-03,   1.0635471E-03
     +,   1.0553451E-03,   1.0466257E-03,   1.0368619E-03
     +,   1.0255948E-03,   1.0124531E-03,   9.9715730E-04
     +,   9.7952446E-04,   9.5947157E-04,   9.3700242E-04
     +,   9.1220718E-04,   8.8524801E-04,   8.5634564E-04
     +,   8.2576927E-04,   7.9381658E-04,   7.6080242E-04
     +,   7.2704913E-04,   6.9286564E-04,   6.5855391E-04
     +,   6.2438799E-04,   5.9061381E-04,   5.5744749E-04
     +,   5.2507187E-04,   4.9363822E-04,   4.6326633E-04
     +,   4.3404807E-04,   4.0604905E-04,   3.7931284E-04
     +,   3.5386343E-04,   3.2970859E-04,   3.0684320E-04
     +,   2.8525092E-04,   2.6490726E-04,   2.4578074E-04
     +,   2.2783513E-04,   2.1102987E-04,   1.9532166E-04
     +,   1.8066491E-04,   1.6701249E-04,   1.5431613E-04
     +,   1.4252712E-04,   1.3159636E-04,   1.2147503E-04
     +,   1.1211477E-04,   1.0346802E-04,   9.5488329E-05
     +,   8.8130706E-05,   8.1351660E-05,   7.5109550E-05
     +,   6.9364738E-05,   6.4079642E-05,   5.9218881E-05
     +,   5.4749220E-05,   5.0639690E-05,   4.6861463E-05
     +,   4.3387830E-05,   4.0194172E-05,   3.7257618E-05
     +,   3.4557528E-05,   3.2074684E-05,   2.9791292E-05
     +,   2.7691354E-05,   2.5760013E-05,   2.3983910E-05
     +,   2.2350567E-05,   2.0848614E-05,   1.9467625E-05
     +,   1.8198036E-05,   1.7031050E-05,   1.5958563E-05
     +,   1.4973147E-05,   1.4067940E-05,   1.3236580E-05
     +,   1.2473306E-05,   1.1772725E-05,   1.1129809E-05
     +,   1.0539985E-05,   9.9989911E-06,   9.5029427E-06
     +,   9.0481817E-06,   8.6313576E-06,   8.2493561E-06
     +,   7.8993053E-06,   7.5785406E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wano_hz_75 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_wano_hz_80(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  1.2339661E-05,   1.2909808E-05
     +,   1.3503553E-05,   1.4122110E-05,   1.4766796E-05
     +,   1.5439036E-05,   1.6140360E-05,   1.6872407E-05
     +,   1.7636947E-05,   1.8435880E-05,   1.9271185E-05
     +,   2.0145020E-05,   2.1059659E-05,   2.2017502E-05
     +,   2.3021077E-05,   2.4073042E-05,   2.5176176E-05
     +,   2.6333362E-05,   2.7547592E-05,   2.8821965E-05
     +,   3.0159654E-05,   3.1563890E-05,   3.3037955E-05
     +,   3.4585202E-05,   3.6208883E-05,   3.7912338E-05
     +,   3.9698818E-05,   4.1571486E-05,   4.3533419E-05
     +,   4.5587556E-05,   4.7736663E-05,   4.9983249E-05
     +,   5.2329648E-05,   5.4777862E-05,   5.7329598E-05
     +,   5.9986181E-05,   6.2748550E-05,   6.5617249E-05
     +,   6.8592337E-05,   7.1673385E-05,   7.4859483E-05
     +,   7.8149227E-05,   8.1540398E-05,   8.5030733E-05
     +,   8.8616849E-05,   9.2295137E-05,   9.6061362E-05
     +,   9.9910721E-05,   1.0383789E-04,   1.0783707E-04
     +,   1.1190205E-04,   1.1602617E-04,   1.2020242E-04
     +,   1.2442360E-04,   1.2868232E-04,   1.3297082E-04
     +,   1.3728163E-04,   1.4160722E-04,   1.4594024E-04
     +,   1.5027374E-04,   1.5460102E-04,   1.5891611E-04
     +,   1.6321351E-04,   1.6748866E-04,   1.7173793E-04
     +,   1.7595860E-04,   1.8014928E-04,   1.8430973E-04
     +,   1.8844132E-04,   1.9254680E-04,   1.9663066E-04
     +,   2.0069923E-04,   2.0476074E-04,   2.0882557E-04
     +,   2.1290642E-04,   2.1701839E-04,   2.2117957E-04
     +,   2.2541096E-04,   2.2973730E-04,   2.3418755E-04
     +,   2.3879514E-04,   2.4359893E-04,   2.4864444E-04
     +,   2.5398386E-04,   2.5967840E-04,   2.6579990E-04
     +,   2.7243019E-04,   2.7966473E-04,   2.8761392E-04
     +,   2.9640397E-04,   3.0617963E-04,   3.1710489E-04
     +,   3.2936531E-04,   3.4316781E-04,   3.5874150E-04
     +,   3.7633785E-04,   3.9622822E-04,   4.1870115E-04
     +,   4.4405853E-04,   4.7260881E-04,   5.0465902E-04
     +,   5.4050470E-04,   5.8041653E-04,   6.2462821E-04
     +,   6.7332067E-04,   7.2660559E-04,   7.8451302E-04
     +,   8.4697962E-04,   9.1382861E-04,   9.8478270E-04
     +,   1.0594670E-03,   1.1373988E-03,   1.2180408E-03
     +,   1.3008207E-03,   1.3851809E-03,   1.4706384E-03
     +,   1.5568441E-03,   1.6436481E-03,   1.7311570E-03
     +,   1.8197636E-03,   1.9101697E-03,   2.0033412E-03
     +,   2.1004463E-03,   2.2027348E-03,   2.3113985E-03
     +,   2.4274024E-03,   2.5513428E-03,   2.6833310E-03
     +,   2.8229409E-03,   2.9692368E-03,   3.1208764E-03
     +,   3.2762897E-03,   3.4339270E-03,   3.5925491E-03
     +,   3.7515180E-03,   3.9110687E-03,   4.0724399E-03
     +,   4.2378209E-03,   4.4100308E-03,   4.5919828E-03
     +,   4.7860770E-03,   4.9937963E-03,   5.2157668E-03
     +,   5.4524951E-03,   5.7057748E-03,   5.9803883E-03
     +,   6.2854541E-03,   6.6347080E-03,   7.0443684E-03
     +,   7.5286771E-03,   8.0931718E-03,   8.7280693E-03
     +,   9.4049713E-03,   1.0080272E-02,   1.0706197E-02
     +,   1.1247155E-02,   1.1694769E-02,   1.2074469E-02
     +,   1.2438518E-02,   1.2846161E-02,   1.3338222E-02
     +,   1.3917876E-02,   1.4549016E-02,   1.5174662E-02
     +,   1.5744556E-02,   1.6233508E-02,   1.6639274E-02
     +,   1.6966663E-02,   1.7214509E-02,   1.7374942E-02
     +,   1.7439831E-02,   1.7405210E-02,   1.7272720E-02
     +,   1.7051095E-02,   1.6755283E-02,   1.6398564E-02
     +,   1.5980732E-02,   1.5484656E-02,   1.4889384E-02
     +,   1.4192557E-02,   1.3425322E-02,   1.2646910E-02
     +,   1.1922095E-02,   1.1296056E-02,   1.0782022E-02
     +,   1.0365956E-02,   1.0021949E-02,   9.7267125E-03
     +,   9.4661573E-03,   9.2336806E-03,   9.0248687E-03
     +,   8.8332407E-03,   8.6489934E-03,   8.4601594E-03
     +,   8.2547646E-03,   8.0227396E-03,   7.7573028E-03
     +,   7.4557518E-03,   7.1199485E-03,   6.7563509E-03
     +,   6.3755796E-03,   5.9912759E-03,   5.6181471E-03
     +,   5.2696611E-03,   4.9559004E-03,   4.6822294E-03
     +,   4.4490588E-03,   4.2526387E-03,   4.0864390E-03
     +,   3.9426940E-03,   3.8137133E-03,   3.6926917E-03
     +,   3.5742274E-03,   3.4543998E-03,   3.3306896E-03
     +,   3.2017771E-03,   3.0672660E-03,   2.9274360E-03
     +,   2.7830263E-03,   2.6350396E-03,   2.4846888E-03
     +,   2.3332739E-03,   2.1821710E-03,   2.0328104E-03
     +,   1.8866230E-03,   1.7450283E-03,   1.6093040E-03
     +,   1.4805800E-03,   1.3597516E-03,   1.2474329E-03
     +,   1.1439590E-03,   1.0493608E-03,   9.6341409E-04
     +,   8.8568701E-04,   8.1557682E-04,   7.5240596E-04
     +,   6.9544639E-04,   6.4398150E-04,   5.9734139E-04
     +,   5.5492652E-04,   5.1621953E-04,   4.8078794E-04
     +,   4.4827923E-04,   4.1841026E-04,   3.9095493E-04
     +,   3.6573189E-04,   3.4259204E-04,   3.2140745E-04
     +,   3.0206359E-04,   2.8445301E-04,   2.6847018E-04
     +,   2.5401035E-04,   2.4096688E-04,   2.2923196E-04
     +,   2.1869679E-04,   2.0925222E-04,   2.0079056E-04
     +,   1.9320664E-04,   1.8639838E-04,   1.8026866E-04
     +,   1.7472573E-04,   1.6968382E-04,   1.6506399E-04
     +,   1.6079388E-04,   1.5680825E-04,   1.5304866E-04
     +,   1.4946349E-04,   1.4600753E-04,   1.4264189E-04
     +,   1.3933337E-04,   1.3605432E-04,   1.3278209E-04
     +,   1.2949864E-04,   1.2619016E-04,   1.2284645E-04
     +,   1.1946123E-04,   1.1603090E-04,   1.1255429E-04
     +,   1.0903294E-04,   1.0547008E-04,   1.0187112E-04
     +,   9.8242330E-05,   9.4591349E-05,   9.0926624E-05
     +,   8.7257285E-05,   8.3592888E-05,   7.9943246E-05
     +,   7.6318203E-05,   7.2727584E-05,   6.9180809E-05
     +,   6.5687418E-05,   6.2256229E-05,   5.8895232E-05
     +,   5.5612243E-05,   5.2414154E-05,   4.9307571E-05
     +,   4.6297926E-05,   4.3390068E-05,   4.0588049E-05
     +,   3.7895170E-05,   3.5313973E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wano_hz_80 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_wano_hz_85(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  4.5187885E-06,   4.7774606E-06
     +,   5.0478120E-06,   5.3301956E-06,   5.6249705E-06
     +,   5.9324971E-06,   6.2531421E-06,   6.5872728E-06
     +,   6.9352591E-06,   7.2974849E-06,   7.6743081E-06
     +,   8.0661175E-06,   8.4732928E-06,   8.8962188E-06
     +,   9.3352774E-06,   9.7908533E-06,   1.0263332E-05
     +,   1.0753098E-05,   1.1260535E-05,   1.1786025E-05
     +,   1.2329948E-05,   1.2892678E-05,   1.3474587E-05
     +,   1.4076052E-05,   1.4697409E-05,   1.5339014E-05
     +,   1.6001210E-05,   1.6684320E-05,   1.7388655E-05
     +,   1.8114515E-05,   1.8862176E-05,   1.9631894E-05
     +,   2.0423900E-05,   2.1238407E-05,   2.2075592E-05
     +,   2.2935601E-05,   2.3818544E-05,   2.4724499E-05
     +,   2.5653502E-05,   2.6605543E-05,   2.7580563E-05
     +,   2.8578475E-05,   2.9599061E-05,   3.0642193E-05
     +,   3.1707521E-05,   3.2794724E-05,   3.3903412E-05
     +,   3.5033114E-05,   3.6183272E-05,   3.7353293E-05
     +,   3.8542476E-05,   3.9750063E-05,   4.0975228E-05
     +,   4.2217045E-05,   4.3474571E-05,   4.4746674E-05
     +,   4.6032266E-05,   4.7330133E-05,   4.8639024E-05
     +,   4.9957609E-05,   5.1284511E-05,   5.2618328E-05
     +,   5.3957603E-05,   5.5300876E-05,   5.6646677E-05
     +,   5.7993584E-05,   5.9340193E-05,   6.0685175E-05
     +,   6.2027313E-05,   6.3365544E-05,   6.4698994E-05
     +,   6.6027045E-05,   6.7349392E-05,   6.8666086E-05
     +,   6.9977723E-05,   7.1285336E-05,   7.2590752E-05
     +,   7.3896488E-05,   7.5206022E-05,   7.6523895E-05
     +,   7.7855861E-05,   7.9209021E-05,   8.0592145E-05
     +,   8.2015613E-05,   8.3491825E-05,   8.5035645E-05
     +,   8.6663938E-05,   8.8396533E-05,   9.0256057E-05
     +,   9.2268368E-05,   9.4462739E-05,   9.6872129E-05
     +,   9.9533507E-05,   1.0248806E-04,   1.0578142E-04
     +,   1.0946417E-04,   1.1359180E-04,   1.1822517E-04
     +,   1.2343073E-04,   1.2928055E-04,   1.3585290E-04
     +,   1.4323198E-04,   1.5150808E-04,   1.6077764E-04
     +,   1.7114291E-04,   1.8271136E-04,   1.9559510E-04
     +,   2.0991024E-04,   2.2577318E-04,   2.4330088E-04
     +,   2.6261015E-04,   2.8380702E-04,   3.0699055E-04
     +,   3.3224435E-04,   3.5963207E-04,   3.8919173E-04
     +,   4.2093027E-04,   4.5481720E-04,   4.9077970E-04
     +,   5.2869751E-04,   5.6840060E-04,   6.0966675E-04
     +,   6.5222371E-04,   6.9575169E-04,   7.3989067E-04
     +,   7.8425044E-04,   8.2842354E-04,   8.7200035E-04
     +,   9.1458723E-04,   9.5582753E-04,   9.9542062E-04
     +,   1.0331400E-03,   1.0688553E-03,   1.1025449E-03
     +,   1.1343092E-03,   1.1643848E-03,   1.1931470E-03
     +,   1.2211226E-03,   1.2489932E-03,   1.2776069E-03
     +,   1.3079824E-03,   1.3413231E-03,   1.3790252E-03
     +,   1.4226773E-03,   1.4740595E-03,   1.5351308E-03
     +,   1.6079914E-03,   1.6948739E-03,   1.7980468E-03
     +,   1.9197718E-03,   2.0621573E-03,   2.2269974E-03
     +,   2.4155099E-03,   2.6280272E-03,   2.8636854E-03
     +,   3.1201199E-03,   3.3933877E-03,   3.6780888E-03
     +,   3.9678514E-03,   4.2560985E-03,   4.5370813E-03
     +,   4.8070401E-03,   5.0654868E-03,   5.3164260E-03
     +,   5.5694068E-03,   5.8397986E-03,   6.1474517E-03
     +,   6.5127481E-03,   6.9499430E-03,   7.4592899E-03
     +,   8.0215121E-03,   8.5991835E-03,   9.1472138E-03
     +,   9.6307024E-03,   1.0043158E-02,   1.0416438E-02
     +,   1.0816313E-02,   1.1322157E-02,   1.1995478E-02
     +,   1.2846369E-02,   1.3814974E-02,   1.4788894E-02
     +,   1.5663415E-02,   1.6415114E-02,   1.7130908E-02
     +,   1.7956790E-02,   1.8997259E-02,   2.0244343E-02
     +,   2.1582875E-02,   2.2843918E-02,   2.3853384E-02
     +,   2.4468644E-02,   2.4629937E-02,   2.4420895E-02
     +,   2.4069950E-02,   2.3829445E-02,   2.3789983E-02
     +,   2.3806741E-02,   2.3634680E-02,   2.3138372E-02
     +,   2.2363720E-02,   2.1439105E-02,   2.0459399E-02
     +,   1.9472590E-02,   1.8532777E-02,   1.7715700E-02
     +,   1.7069012E-02,   1.6558561E-02,   1.6075699E-02
     +,   1.5499038E-02,   1.4755965E-02,   1.3843352E-02
     +,   1.2811467E-02,   1.1734232E-02,   1.0682791E-02
     +,   9.7070104E-03,   8.8268304E-03,   8.0369618E-03
     +,   7.3212036E-03,   6.6673458E-03,   6.0739773E-03
     +,   5.5467780E-03,   5.0905761E-03,   4.7033494E-03
     +,   4.3753558E-03,   4.0924130E-03,   3.8400809E-03
     +,   3.6068878E-03,   3.3854202E-03,   3.1719853E-03
     +,   2.9655981E-03,   2.7667871E-03,   2.5767349E-03
     +,   2.3966783E-03,   2.2275378E-03,   2.0698602E-03
     +,   1.9237458E-03,   1.7889605E-03,   1.6650241E-03
     +,   1.5513075E-03,   1.4471107E-03,   1.3517058E-03
     +,   1.2643608E-03,   1.1843562E-03,   1.1109858E-03
     +,   1.0435670E-03,   9.8145229E-04,   9.2404056E-04
     +,   8.7078859E-04,   8.2122110E-04,   7.7493483E-04
     +,   7.3159748E-04,   6.9094135E-04,   6.5275450E-04
     +,   6.1686948E-04,   5.8315194E-04,   5.5149017E-04
     +,   5.2178639E-04,   4.9394963E-04,   4.6789137E-04
     +,   4.4352346E-04,   4.2075507E-04,   3.9949475E-04
     +,   3.7964937E-04,   3.6112647E-04,   3.4383420E-04
     +,   3.2768401E-04,   3.1259010E-04,   2.9847128E-04
     +,   2.8525133E-04,   2.7285889E-04,   2.6122815E-04
     +,   2.5029830E-04,   2.4001343E-04,   2.3032211E-04
     +,   2.2117830E-04,   2.1253919E-04,   2.0436481E-04
     +,   1.9661942E-04,   1.8926997E-04,   1.8228662E-04
     +,   1.7564105E-04,   1.6930758E-04,   1.6326238E-04
     +,   1.5748355E-04,   1.5195095E-04,   1.4664582E-04
     +,   1.4155099E-04,   1.3665066E-04,   1.3193005E-04
     +,   1.2737613E-04,   1.2297677E-04,   1.1872035E-04
     +,   1.1459686E-04,   1.1059699E-04,   1.0671272E-04
     +,   1.0293638E-04,   9.9261320E-05,   9.5681593E-05
     +,   9.2192015E-05,   8.8788016E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wano_hz_85 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_wano_hz_90(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  4.2568604E-06,   4.4392445E-06
     +,   4.6266296E-06,   4.8190200E-06,   5.0164113E-06
     +,   5.2188002E-06,   5.4261741E-06,   5.6385211E-06
     +,   5.8558230E-06,   6.0780649E-06,   6.3052144E-06
     +,   6.5372519E-06,   6.7741544E-06,   7.0158935E-06
     +,   7.2624475E-06,   7.5137928E-06,   7.7699078E-06
     +,   8.0307746E-06,   8.2963834E-06,   8.5667252E-06
     +,   8.8418019E-06,   9.1216198E-06,   9.4062007E-06
     +,   9.6955782E-06,   9.9897852E-06,   1.0288883E-05
     +,   1.0592950E-05,   1.0902075E-05,   1.1216374E-05
     +,   1.1535984E-05,   1.1861064E-05,   1.2191812E-05
     +,   1.2528441E-05,   1.2871216E-05,   1.3220422E-05
     +,   1.3576397E-05,   1.3939522E-05,   1.4310227E-05
     +,   1.4688992E-05,   1.5076364E-05,   1.5472950E-05
     +,   1.5879430E-05,   1.6296539E-05,   1.6725147E-05
     +,   1.7166156E-05,   1.7620599E-05,   1.8089613E-05
     +,   1.8574436E-05,   1.9076442E-05,   1.9597128E-05
     +,   2.0138130E-05,   2.0701240E-05,   2.1288401E-05
     +,   2.1901722E-05,   2.2543509E-05,   2.3216193E-05
     +,   2.3922450E-05,   2.4665114E-05,   2.5447240E-05
     +,   2.6272062E-05,   2.7143016E-05,   2.8063756E-05
     +,   2.9038098E-05,   3.0070058E-05,   3.1163836E-05
     +,   3.2323769E-05,   3.3554352E-05,   3.4860193E-05
     +,   3.6246016E-05,   3.7716567E-05,   3.9276660E-05
     +,   4.0931100E-05,   4.2684620E-05,   4.4541863E-05
     +,   4.6507394E-05,   4.8585422E-05,   5.0780051E-05
     +,   5.3095024E-05,   5.5533674E-05,   5.8099064E-05
     +,   6.0793649E-05,   6.3619336E-05,   6.6577668E-05
     +,   6.9669113E-05,   7.2893759E-05,   7.6251439E-05
     +,   7.9740399E-05,   8.3358747E-05,   8.7103741E-05
     +,   9.0971946E-05,   9.4959280E-05,   9.9061006E-05
     +,   1.0327199E-04,   1.0758651E-04,   1.1199866E-04
     +,   1.1650240E-04,   1.2109159E-04,   1.2576053E-04
     +,   1.3050387E-04,   1.3531714E-04,   1.4019701E-04
     +,   1.4514160E-04,   1.5015107E-04,   1.5522793E-04
     +,   1.6037788E-04,   1.6560993E-04,   1.7093764E-04
     +,   1.7637970E-04,   1.8195997E-04,   1.8770940E-04
     +,   1.9366728E-04,   1.9987984E-04,   2.0640359E-04
     +,   2.1330510E-04,   2.2066185E-04,   2.2856292E-04
     +,   2.3710921E-04,   2.4641407E-04,   2.5660248E-04
     +,   2.6781048E-04,   2.8018438E-04,   2.9387797E-04
     +,   3.0905049E-04,   3.2586296E-04,   3.4447311E-04
     +,   3.6503104E-04,   3.8767204E-04,   4.1251021E-04
     +,   4.3963105E-04,   4.6908302E-04,   5.0087075E-04
     +,   5.3494738E-04,   5.7120965E-04,   6.0949259E-04
     +,   6.4956892E-04,   6.9114927E-04,   7.3388760E-04
     +,   7.7738921E-04,   8.2122110E-04,   8.6492923E-04
     +,   9.0805429E-04,   9.5015264E-04,   9.9081884E-04
     +,   1.0297036E-03,   1.0665369E-03,   1.1011453E-03
     +,   1.1334608E-03,   1.1635465E-03,   1.1915852E-03
     +,   1.2178991E-03,   1.2429430E-03,   1.2673051E-03
     +,   1.2917063E-03,   1.3169999E-03,   1.3441729E-03
     +,   1.3743544E-03,   1.4088218E-03,   1.4490229E-03
     +,   1.4965775E-03,   1.5532875E-03,   1.6211198E-03
     +,   1.7021495E-03,   1.7984597E-03,   1.9119744E-03
     +,   2.0442277E-03,   2.1960684E-03,   2.3673396E-03
     +,   2.5565624E-03,   2.7606923E-03,   2.9750157E-03
     +,   3.1932034E-03,   3.4076928E-03,   3.6102480E-03
     +,   3.7928536E-03,   3.9486950E-03,   4.0732706E-03
     +,   4.1654049E-03,   4.2279358E-03,   4.2679412E-03
     +,   4.2963028E-03,   4.3265535E-03,   4.3730484E-03
     +,   4.4485824E-03,   4.5619197E-03,   4.7156275E-03
     +,   4.9049472E-03,   5.1182038E-03,   5.3391177E-03
     +,   5.5509321E-03,   5.7416540E-03,   5.9090108E-03
     +,   6.0636466E-03,   6.2291971E-03,   6.4391466E-03
     +,   6.7316703E-03,   7.1442300E-03,   7.7087171E-03
     +,   8.4458357E-03,   9.3578557E-03,   1.0421538E-02
     +,   1.1588092E-02,   1.2795125E-02,   1.3988986E-02
     +,   1.5145936E-02,   1.6275274E-02,   1.7393395E-02
     +,   1.8480713E-02,   1.9461455E-02,   2.0242549E-02
     +,   2.0787286E-02,   2.1141089E-02,   2.1368533E-02
     +,   2.1487044E-02,   2.1515779E-02,   2.1593103E-02
     +,   2.1967473E-02,   2.2794480E-02,   2.3946436E-02
     +,   2.5067914E-02,   2.5826795E-02,   2.6097359E-02
     +,   2.5935348E-02,   2.5440039E-02,   2.4658041E-02
     +,   2.3588728E-02,   2.2253260E-02,   2.0744151E-02
     +,   1.9198308E-02,   1.7718989E-02,   1.6327718E-02
     +,   1.4984941E-02,   1.3646645E-02,   1.2306064E-02
     +,   1.0995325E-02,   9.7604310E-03,   8.6358376E-03
     +,   7.6332469E-03,   6.7461999E-03,   5.9605376E-03
     +,   5.2631204E-03,   4.6456978E-03,   4.1044336E-03
     +,   3.6372850E-03,   3.2412594E-03,   2.9109053E-03
     +,   2.6382871E-03,   2.4140074E-03,   2.2284933E-03
     +,   2.0730305E-03,   1.9403169E-03,   1.8245601E-03
     +,   1.7213301E-03,   1.6273052E-03,   1.5400243E-03
     +,   1.4577005E-03,   1.3790696E-03,   1.3032922E-03
     +,   1.2298707E-03,   1.1585812E-03,   1.0894063E-03
     +,   1.0224818E-03,   9.5803774E-04,   8.9634972E-04
     +,   8.3769718E-04,   7.8232586E-04,   7.3042361E-04
     +,   6.8210438E-04,   6.3739944E-04,   5.9626001E-04
     +,   5.5856456E-04,   5.2413071E-04,   4.9273041E-04
     +,   4.6410516E-04,   4.3798125E-04,   4.1408205E-04
     +,   3.9214245E-04,   3.7191215E-04,   3.5316189E-04
     +,   3.3569123E-04,   3.1932513E-04,   3.0391724E-04
     +,   2.8934432E-04,   2.7550655E-04,   2.6232435E-04
     +,   2.4973435E-04,   2.3768772E-04,   2.2614641E-04
     +,   2.1508108E-04,   2.0446871E-04,   1.9429077E-04
     +,   1.8453290E-04,   1.7518201E-04,   1.6622551E-04
     +,   1.5765261E-04,   1.4945191E-04,   1.4161316E-04
     +,   1.3412474E-04,   1.2697527E-04,   1.2015321E-04
     +,   1.1364681E-04,   1.0744435E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wano_hz_90 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_wano_hz_95(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  1.0522697E-06,   1.0943535E-06
     +,   1.1378230E-06,   1.1827143E-06,   1.2290641E-06
     +,   1.2769102E-06,   1.3262910E-06,   1.3772458E-06
     +,   1.4298155E-06,   1.4840425E-06,   1.5399675E-06
     +,   1.5976352E-06,   1.6570910E-06,   1.7183814E-06
     +,   1.7815547E-06,   1.8466601E-06,   1.9137494E-06
     +,   1.9828756E-06,   2.0540933E-06,   2.1274611E-06
     +,   2.2030374E-06,   2.2808854E-06,   2.3610698E-06
     +,   2.4436608E-06,   2.5287259E-06,   2.6163420E-06
     +,   2.7065889E-06,   2.7995493E-06,   2.8953120E-06
     +,   2.9939711E-06,   3.0956255E-06,   3.2003813E-06
     +,   3.3083511E-06,   3.4196551E-06,   3.5344221E-06
     +,   3.6527911E-06,   3.7749082E-06,   3.9009324E-06
     +,   4.0310342E-06,   4.1653980E-06,   4.3042210E-06
     +,   4.4477169E-06,   4.5961069E-06,   4.7496483E-06
     +,   4.9085988E-06,   5.0732460E-06,   5.2438982E-06
     +,   5.4208876E-06,   5.6045706E-06,   5.7953289E-06
     +,   5.9935742E-06,   6.1997512E-06,   6.4143287E-06
     +,   6.6378170E-06,   6.8707609E-06,   7.1137310E-06
     +,   7.3673477E-06,   7.6322676E-06,   7.9091888E-06
     +,   8.1988483E-06,   8.5020292E-06,   8.8195593E-06
     +,   9.1523079E-06,   9.5011883E-06,   9.8671635E-06
     +,   1.0251235E-05,   1.0654449E-05,   1.1077896E-05
     +,   1.1522704E-05,   1.1990041E-05,   1.2481109E-05
     +,   1.2997139E-05,   1.3539396E-05,   1.4109164E-05
     +,   1.4707759E-05,   1.5336467E-05,   1.5996618E-05
     +,   1.6689535E-05,   1.7416498E-05,   1.8178825E-05
     +,   1.8977758E-05,   1.9814504E-05,   2.0690273E-05
     +,   2.1606078E-05,   2.2562941E-05,   2.3561912E-05
     +,   2.4603702E-05,   2.5689054E-05,   2.6818556E-05
     +,   2.7992639E-05,   2.9211576E-05,   3.0475449E-05
     +,   3.1784184E-05,   3.3137465E-05,   3.4534791E-05
     +,   3.5975401E-05,   3.7458318E-05,   3.8982304E-05
     +,   4.0545841E-05,   4.2147185E-05,   4.3784283E-05
     +,   4.5454821E-05,   4.7156249E-05,   4.8885726E-05
     +,   5.0640152E-05,   5.2416253E-05,   5.4210490E-05
     +,   5.6019297E-05,   5.7838741E-05,   5.9664984E-05
     +,   6.1494444E-05,   6.3323212E-05,   6.5147869E-05
     +,   6.6965367E-05,   6.8773137E-05,   7.0569331E-05
     +,   7.2353090E-05,   7.4124764E-05,   7.5886215E-05
     +,   7.7641169E-05,   7.9395606E-05,   8.1158214E-05
     +,   8.2940751E-05,   8.4758656E-05,   8.6631502E-05
     +,   8.8583489E-05,   9.0644098E-05,   9.2848415E-05
     +,   9.5237716E-05,   9.7859811E-05,   1.0076927E-04
     +,   1.0402763E-04,   1.0770330E-04,   1.1187138E-04
     +,   1.1661311E-04,   1.2201533E-04,   1.2816914E-04
     +,   1.3516888E-04,   1.4311048E-04,   1.5208966E-04
     +,   1.6219972E-04,   1.7352960E-04,   1.8616128E-04
     +,   2.0016775E-04,   2.1561068E-04,   2.3253911E-04
     +,   2.5098448E-04,   2.7096775E-04,   2.9248768E-04
     +,   3.1553017E-04,   3.4006525E-04,   3.6604915E-04
     +,   3.9342701E-04,   4.2213628E-04,   4.5210970E-04
     +,   4.8327967E-04,   5.1558204E-04,   5.4895936E-04
     +,   5.8336335E-04,   6.1875838E-04,   6.5511989E-04
     +,   6.9243467E-04,   7.3069846E-04,   7.6991098E-04
     +,   8.1007264E-04,   8.5117790E-04,   8.9321221E-04
     +,   9.3614846E-04,   9.7994646E-04,   1.0245607E-03
     +,   1.0699412E-03,   1.1160582E-03,   1.1629169E-03
     +,   1.2105916E-03,   1.2592460E-03,   1.3091662E-03
     +,   1.3607999E-03,   1.4147778E-03,   1.4719252E-03
     +,   1.5332698E-03,   1.6000185E-03,   1.6735180E-03
     +,   1.7551851E-03,   1.8464173E-03,   1.9484658E-03
     +,   2.0623098E-03,   2.1884986E-03,   2.3270065E-03
     +,   2.4770959E-03,   2.6372047E-03,   2.8048609E-03
     +,   2.9766604E-03,   3.1483064E-03,   3.3147391E-03
     +,   3.4703917E-03,   3.6096107E-03,   3.7272268E-03
     +,   3.8192957E-03,   3.8839332E-03,   3.9220415E-03
     +,   3.9378270E-03,   3.9388523E-03,   3.9354772E-03
     +,   3.9396510E-03,   3.9632320E-03,   4.0160813E-03
     +,   4.1043693E-03,   4.2295419E-03,   4.3881699E-03
     +,   4.5728246E-03,   4.7735428E-03,   4.9797008E-03
     +,   5.1813894E-03,   5.3702747E-03,   5.5397851E-03
     +,   5.6850323E-03,   5.8030896E-03,   5.8936873E-03
     +,   5.9602354E-03,   6.0104122E-03,   6.0554571E-03
     +,   6.1080274E-03,   6.1790519E-03,   6.2749665E-03
     +,   6.3966522E-03,   6.5403283E-03,   6.7000780E-03
     +,   6.8700761E-03,   7.0457682E-03,   7.2236424E-03
     +,   7.4004633E-03,   7.5732451E-03,   7.7399663E-03
     +,   7.9004858E-03,   8.0566462E-03,   8.2110818E-03
     +,   8.3656171E-03,   8.5200444E-03,   8.6716767E-03
     +,   8.8157933E-03,   8.9462595E-03,   9.0561751E-03
     +,   9.1384463E-03,   9.1860481E-03,   9.1916779E-03
     +,   9.1470508E-03,   9.0427930E-03,   8.8699842E-03
     +,   8.6237043E-03,   8.3071934E-03,   7.9341773E-03
     +,   7.5275381E-03,   7.1142260E-03,   6.7186272E-03
     +,   6.3572573E-03,   6.0367733E-03,   5.7555558E-03
     +,   5.5072904E-03,   5.2845892E-03,   5.0811949E-03
     +,   4.8924894E-03,   4.7148857E-03,   4.5449431E-03
     +,   4.3789148E-03,   4.2128740E-03,   4.0432727E-03
     +,   3.8676430E-03,   3.6850744E-03,   3.4963374E-03
     +,   3.3036715E-03,   3.1102654E-03,   2.9196902E-03
     +,   2.7353545E-03,   2.5601056E-03,   2.3960136E-03
     +,   2.2443330E-03,   2.1055222E-03,   1.9793643E-03
     +,   1.8651431E-03,   1.7617742E-03,   1.6679611E-03
     +,   1.5823004E-03,   1.5033876E-03,   1.4298906E-03
     +,   1.3605943E-03,   1.2944345E-03,   1.2305118E-03
     +,   1.1681003E-03,   1.1066481E-03,   1.0457693E-03
     +,   9.8524638E-04,   9.2500023E-04,   8.6507207E-04
     +,   8.0561492E-04,   7.4685586E-04,   6.8908412E-04
     +,   6.3261320E-04,   5.7776866E-04,   5.2486861E-04
     +,   4.7420737E-04,   4.2604396E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wano_hz_95 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_wano_qq(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  9.0068232E-16,   1.1629226E-15
     +,   1.4995297E-15,   1.9310024E-15,   2.4833369E-15
     +,   3.1894162E-15,   4.0908337E-15,   5.2400554E-15
     +,   6.7032455E-15,   8.5636606E-15,   1.0925881E-14
     +,   1.3921208E-14,   1.7714205E-14,   2.2510831E-14
     +,   2.8568331E-14,   3.6207765E-14,   4.5829256E-14
     +,   5.7930623E-14,   7.3130534E-14,   9.2195958E-14
     +,   1.1607807E-13,   1.4595264E-13,   1.8327279E-13
     +,   2.2983175E-13,   2.8783516E-13,   3.6000025E-13
     +,   4.4966098E-13,   5.6090836E-13,   6.9875047E-13
     +,   8.6931552E-13,   1.0800806E-12,   1.3401680E-12
     +,   1.6606824E-12,   2.0551213E-12,   2.5398763E-12
     +,   3.1348155E-12,   3.8639873E-12,   4.7564496E-12
     +,   5.8472979E-12,   7.1787927E-12,   8.8017918E-12
     +,   1.0777477E-11,   1.3179026E-11,   1.6094502E-11
     +,   1.9628828E-11,   2.3907508E-11,   2.9080328E-11
     +,   3.5325461E-11,   4.2854963E-11,   5.1920322E-11
     +,   6.2820187E-11,   7.5907329E-11,   9.1599450E-11
     +,   1.1038925E-10,   1.3285742E-10,   1.5968626E-10
     +,   1.9167838E-10,   2.2977537E-10,   2.7507888E-10
     +,   3.2887873E-10,   3.9267911E-10,   4.6823528E-10
     +,   5.5758925E-10,   6.6311573E-10,   7.8756834E-10
     +,   9.3413888E-10,   1.1065173E-09,   1.3089689E-09
     +,   1.5464106E-09,   1.8245030E-09,   2.1497517E-09
     +,   2.5296241E-09,   2.9726825E-09,   3.4887080E-09
     +,   4.0889025E-09,   4.7859889E-09,   5.5944911E-09
     +,   6.5309145E-09,   7.6139539E-09,   8.8648671E-09
     +,   1.0307616E-08,   1.1969304E-08,   1.3880560E-08
     +,   1.6075573E-08,   1.8592930E-08,   2.1476259E-08
     +,   2.4773753E-08,   2.8539688E-08,   3.2834592E-08
     +,   3.7725805E-08,   4.3288299E-08,   4.9605184E-08
     +,   5.6768705E-08,   6.4880695E-08,   7.4053844E-08
     +,   8.4412122E-08,   9.6092094E-08,   1.0924357E-07
     +,   1.2403090E-07,   1.4063382E-07,   1.5924860E-07
     +,   1.8008946E-07,   2.0338881E-07,   2.2939967E-07
     +,   2.5839603E-07,   2.9067400E-07,   3.2655333E-07
     +,   3.6638045E-07,   4.1052266E-07,   4.5937642E-07
     +,   5.1337423E-07,   5.7296376E-07,   6.3863251E-07
     +,   7.1089613E-07,   7.9030224E-07,   8.7743081E-07
     +,   9.7289490E-07,   1.0773419E-06,   1.1914520E-06
     +,   1.3159396E-06,   1.4515531E-06,   1.5990743E-06
     +,   1.7593190E-06,   1.9331349E-06,   2.1214007E-06
     +,   2.3250282E-06,   2.5449556E-06,   2.7821529E-06
     +,   3.0376120E-06,   3.3123533E-06,   3.6074161E-06
     +,   3.9238639E-06,   4.2627735E-06,   4.6252412E-06
     +,   5.0123731E-06,   5.4252873E-06,   5.8651062E-06
     +,   6.3329612E-06,   6.8299828E-06,   7.3573019E-06
     +,   7.9160436E-06,   8.5073352E-06,   9.1322872E-06
     +,   9.7920083E-06,   1.0487589E-05,   1.1220148E-05
     +,   1.1990662E-05,   1.2800317E-05,   1.3650054E-05
     +,   1.4540940E-05,   1.5473994E-05,   1.6450220E-05
     +,   1.7470624E-05,   1.8536190E-05,   1.9647907E-05
     +,   2.0806750E-05,   2.2013704E-05,   2.3269748E-05
     +,   2.4575862E-05,   2.5933037E-05,   2.7342259E-05
     +,   2.8804538E-05,   3.0320871E-05,   3.1892265E-05
     +,   3.3519733E-05,   3.5204292E-05,   3.6946931E-05
     +,   3.8748643E-05,   4.0610401E-05,   4.2533204E-05
     +,   4.4517772E-05,   4.6564997E-05,   4.8675516E-05
     +,   5.0850147E-05,   5.3089378E-05,   5.5393357E-05
     +,   5.7762361E-05,   6.0196326E-05,   6.2694940E-05
     +,   6.5257635E-05,   6.7883513E-05,   7.0571339E-05
     +,   7.3319468E-05,   7.6125849E-05,   7.8987963E-05
     +,   8.1902777E-05,   8.4866762E-05,   8.7875815E-05
     +,   9.0925241E-05,   9.4009767E-05,   9.7123433E-05
     +,   1.0025970E-04,   1.0341139E-04,   1.0657061E-04
     +,   1.0972891E-04,   1.1287719E-04,   1.1600574E-04
     +,   1.1910435E-04,   1.2216222E-04,   1.2516815E-04
     +,   1.2811049E-04,   1.3097726E-04,   1.3375624E-04
     +,   1.3643506E-04,   1.3900126E-04,   1.4144240E-04
     +,   1.4374618E-04,   1.4590051E-04,   1.4789382E-04
     +,   1.4971492E-04,   1.5135304E-04,   1.5279856E-04
     +,   1.5404250E-04,   1.5507679E-04,   1.5589467E-04
     +,   1.5649038E-04,   1.5685965E-04,   1.5699962E-04
     +,   1.5690898E-04,   1.5658792E-04,   1.5603854E-04
     +,   1.5526454E-04,   1.5427149E-04,   1.5306691E-04
     +,   1.5166003E-04,   1.5006239E-04,   1.4828703E-04
     +,   1.4634915E-04,   1.4426587E-04,   1.4205610E-04
     +,   1.3974079E-04,   1.3734261E-04,   1.3488585E-04
     +,   1.3239676E-04,   1.2990258E-04,   1.2743285E-04
     +,   1.2501795E-04,   1.2268974E-04,   1.2048120E-04
     +,   1.1842636E-04,   1.1656011E-04,   1.1491823E-04
     +,   1.1353692E-04,   1.1245298E-04,   1.1170341E-04
     +,   1.1132530E-04,   1.1135568E-04,   1.1183120E-04
     +,   1.1278805E-04,   1.1426168E-04,   1.1628645E-04
     +,   1.1889549E-04,   1.2212037E-04,   1.2599080E-04
     +,   1.3053430E-04,   1.3577586E-04,   1.4173755E-04
     +,   1.4843822E-04,   1.5589304E-04,   1.6411301E-04
     +,   1.7310474E-04,   1.8286986E-04,   1.9340462E-04
     +,   2.0469955E-04,   2.1673889E-04,   2.2950050E-04
     +,   2.4295512E-04,   2.5706642E-04,   2.7179060E-04
     +,   2.8707620E-04,   3.0286398E-04,   3.1908703E-04
     +,   3.3567083E-04,   3.5253333E-04,   3.6958614E-04
     +,   3.8673205E-04,   4.0386914E-04,   4.2089159E-04
     +,   4.3768692E-04,   4.5414027E-04,   4.7013257E-04
     +,   4.8554502E-04,   5.0025847E-04,   5.1415490E-04
     +,   5.2711903E-04,   5.3903967E-04,   5.4981123E-04
     +,   5.5933493E-04,   5.6752079E-04,   5.7428837E-04
     +,   5.7956734E-04,   5.8330008E-04,   5.8544206E-04
     +,   5.8596162E-04,   5.8484171E-04,   5.8207964E-04
     +,   5.7768752E-04,   5.7169178E-04,   5.6413352E-04
     +,   5.5506721E-04,   5.4456078E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wano_qq = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_wano_ww(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  3.5182541E-09,   4.0046073E-09
     +,   4.5533430E-09,   5.1717666E-09,   5.8679430E-09
     +,   6.6507626E-09,   7.5300184E-09,   8.5164693E-09
     +,   9.6219406E-09,   1.0859417E-08,   1.2243052E-08
     +,   1.3788383E-08,   1.5512375E-08,   1.7433493E-08
     +,   1.9571893E-08,   2.1949448E-08,   2.4589939E-08
     +,   2.7519144E-08,   3.0764998E-08,   3.4357647E-08
     +,   3.8329738E-08,   4.2716383E-08,   4.7555453E-08
     +,   5.2887739E-08,   5.8756683E-08,   6.5209278E-08
     +,   7.2295698E-08,   8.0069505E-08,   8.8587946E-08
     +,   9.7911993E-08,   1.0810657E-07,   1.1924084E-07
     +,   1.3138784E-07,   1.4462525E-07,   1.5903537E-07
     +,   1.7470482E-07,   1.9172525E-07,   2.1019335E-07
     +,   2.3021036E-07,   2.5188322E-07,   2.7532371E-07
     +,   3.0064962E-07,   3.2798198E-07,   3.5745103E-07
     +,   3.8918853E-07,   4.2333431E-07,   4.6003305E-07
     +,   4.9943475E-07,   5.4169510E-07,   5.8697532E-07
     +,   6.3544201E-07,   6.8726712E-07,   7.4262795E-07
     +,   8.0170622E-07,   8.6469169E-07,   9.3177266E-07
     +,   1.0031478E-06,   1.0790178E-06,   1.1595886E-06
     +,   1.2450685E-06,   1.3356705E-06,   1.4316109E-06
     +,   1.5331084E-06,   1.6403840E-06,   1.7536620E-06
     +,   1.8731666E-06,   1.9991251E-06,   2.1317649E-06
     +,   2.2713125E-06,   2.4179953E-06,   2.5720406E-06
     +,   2.7336725E-06,   2.9031150E-06,   3.0805875E-06
     +,   3.2663127E-06,   3.4604964E-06,   3.6633521E-06
     +,   3.8750859E-06,   4.0958935E-06,   4.3259774E-06
     +,   4.5655238E-06,   4.8147149E-06,   5.0737376E-06
     +,   5.3427398E-06,   5.6218855E-06,   5.9113640E-06
     +,   6.2112927E-06,   6.5218246E-06,   6.8431000E-06
     +,   7.1752515E-06,   7.5184057E-06,   7.8726871E-06
     +,   8.2382167E-06,   8.6151094E-06,   9.0034819E-06
     +,   9.4034513E-06,   9.8151249E-06,   1.0238621E-05
     +,   1.0674054E-05,   1.1121540E-05,   1.1581194E-05
     +,   1.2053133E-05,   1.2537480E-05,   1.3034345E-05
     +,   1.3543848E-05,   1.4066099E-05,   1.4601202E-05
     +,   1.5149274E-05,   1.5710353E-05,   1.6284501E-05
     +,   1.6871832E-05,   1.7472290E-05,   1.8085882E-05
     +,   1.8712550E-05,   1.9352197E-05,   2.0004676E-05
     +,   2.0669786E-05,   2.1347263E-05,   2.2036791E-05
     +,   2.2737986E-05,   2.3450400E-05,   2.4173529E-05
     +,   2.4906811E-05,   2.5649641E-05,   2.6401378E-05
     +,   2.7161352E-05,   2.7928922E-05,   2.8703433E-05
     +,   2.9484316E-05,   3.0271063E-05,   3.1063308E-05
     +,   3.1860844E-05,   3.2663669E-05,   3.3472057E-05
     +,   3.4286579E-05,   3.5108187E-05,   3.5938250E-05
     +,   3.6778656E-05,   3.7631791E-05,   3.8500697E-05
     +,   3.9389048E-05,   4.0301256E-05,   4.1242532E-05
     +,   4.2218908E-05,   4.3237316E-05,   4.4305703E-05
     +,   4.5432818E-05,   4.6628815E-05,   4.7904567E-05
     +,   4.9272363E-05,   5.0745570E-05,   5.2338804E-05
     +,   5.4067870E-05,   5.5949859E-05,   5.8002970E-05
     +,   6.0246606E-05,   6.2701125E-05,   6.5387729E-05
     +,   6.8328263E-05,   7.1544840E-05,   7.5059499E-05
     +,   7.8893660E-05,   8.3067651E-05,   8.7599969E-05
     +,   9.2506460E-05,   9.7799762E-05,   1.0348816E-04
     +,   1.0957487E-04,   1.1605717E-04,   1.2292591E-04
     +,   1.3016353E-04,   1.3774542E-04,   1.4563791E-04
     +,   1.5379993E-04,   1.6218124E-04,   1.7072311E-04
     +,   1.7936045E-04,   1.8802147E-04,   1.9662954E-04
     +,   2.0510440E-04,   2.1336401E-04,   2.2132647E-04
     +,   2.2891171E-04,   2.3604358E-04,   2.4265186E-04
     +,   2.4867366E-04,   2.5405537E-04,   2.5875380E-04
     +,   2.6273725E-04,   2.6598625E-04,   2.6849413E-04
     +,   2.7026737E-04,   2.7132523E-04,   2.7169948E-04
     +,   2.7143420E-04,   2.7058477E-04,   2.6921710E-04
     +,   2.6740687E-04,   2.6523817E-04,   2.6280258E-04
     +,   2.6019762E-04,   2.5752536E-04,   2.5489106E-04
     +,   2.5240093E-04,   2.5016043E-04,   2.4827188E-04
     +,   2.4683241E-04,   2.4593101E-04,   2.4564657E-04
     +,   2.4604515E-04,   2.4717732E-04,   2.4907704E-04
     +,   2.5175943E-04,   2.5522016E-04,   2.5943553E-04
     +,   2.6436202E-04,   2.6993934E-04,   2.7609186E-04
     +,   2.8273175E-04,   2.8976452E-04,   2.9709091E-04
     +,   3.0461510E-04,   3.1224851E-04,   3.1991553E-04
     +,   3.2755884E-04,   3.3514242E-04,   3.4265750E-04
     +,   3.5012045E-04,   3.5757499E-04,   3.6508814E-04
     +,   3.7274449E-04,   3.8063971E-04,   3.8886897E-04
     +,   3.9751621E-04,   4.0664215E-04,   4.1626926E-04
     +,   4.2637507E-04,   4.3688316E-04,   4.4766147E-04
     +,   4.5852561E-04,   4.6924828E-04,   4.7957635E-04
     +,   4.8925012E-04,   4.9802789E-04,   5.0571142E-04
     +,   5.1216717E-04,   5.1734468E-04,   5.2128453E-04
     +,   5.2412011E-04,   5.2606512E-04,   5.2739563E-04
     +,   5.2842085E-04,   5.2945339E-04,   5.3077610E-04
     +,   5.3261511E-04,   5.3511967E-04,   5.3835078E-04
     +,   5.4228411E-04,   5.4682075E-04,   5.5180863E-04
     +,   5.5706938E-04,   5.6242477E-04,   5.6772266E-04
     +,   5.7285465E-04,   5.7776598E-04,   5.8245420E-04
     +,   5.8695901E-04,   5.9134467E-04,   5.9567508E-04
     +,   5.9999153E-04,   6.0428877E-04,   6.0849905E-04
     +,   6.1248132E-04,   6.1602151E-04,   6.1883806E-04
     +,   6.2059838E-04,   6.2093948E-04,   6.1949162E-04
     +,   6.1590440E-04,   6.0987077E-04,   6.0114963E-04
     +,   5.8958074E-04,   5.7509699E-04,   5.5772788E-04
     +,   5.3760025E-04,   5.1493011E-04,   4.9001246E-04
     +,   4.6320647E-04,   4.3491775E-04,   4.0557975E-04
     +,   3.7563965E-04,   3.4553517E-04,   3.1567938E-04
     +,   2.8645326E-04,   2.5819064E-04,   2.3117602E-04
     +,   2.0563450E-04,   1.8173551E-04,   1.5959326E-04
     +,   1.3927060E-04,   1.2078426E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wano_ww = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_wano_zz(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  1.1124800E-07,   1.1268801E-07
     +,   1.1417033E-07,   1.1569778E-07,   1.1727349E-07
     +,   1.1890109E-07,   1.2058440E-07,   1.2232793E-07
     +,   1.2413658E-07,   1.2601598E-07,   1.2797229E-07
     +,   1.3001245E-07,   1.3214429E-07,   1.3437662E-07
     +,   1.3671904E-07,   1.3918252E-07,   1.4177921E-07
     +,   1.4452259E-07,   1.4742774E-07,   1.5051131E-07
     +,   1.5379190E-07,   1.5729002E-07,   1.6102838E-07
     +,   1.6503213E-07,   1.6932877E-07,   1.7394865E-07
     +,   1.7892519E-07,   1.8429498E-07,   1.9009798E-07
     +,   1.9637777E-07,   2.0318191E-07,   2.1056212E-07
     +,   2.1857447E-07,   2.2727960E-07,   2.3674305E-07
     +,   2.4703533E-07,   2.5823246E-07,   2.7041600E-07
     +,   2.8367279E-07,   2.9809607E-07,   3.1378480E-07
     +,   3.3084473E-07,   3.4938606E-07,   3.6952844E-07
     +,   3.9139493E-07,   4.1511626E-07,   4.4082958E-07
     +,   4.6867854E-07,   4.9881191E-07,   5.3138535E-07
     +,   5.6656012E-07,   6.0450225E-07,   6.4538403E-07
     +,   6.8938164E-07,   7.3667638E-07,   7.8745177E-07
     +,   8.4189639E-07,   9.0020080E-07,   9.6255849E-07
     +,   1.0291636E-06,   1.1002120E-06,   1.1758988E-06
     +,   1.2564201E-06,   1.3419702E-06,   1.4327412E-06
     +,   1.5289231E-06,   1.6307035E-06,   1.7382641E-06
     +,   1.8517853E-06,   1.9714394E-06,   2.0973960E-06
     +,   2.2298173E-06,   2.3688594E-06,   2.5146719E-06
     +,   2.6673999E-06,   2.8271745E-06,   2.9941245E-06
     +,   3.1683733E-06,   3.3500307E-06,   3.5392102E-06
     +,   3.7360112E-06,   3.9405249E-06,   4.1528510E-06
     +,   4.3730561E-06,   4.6012178E-06,   4.8374436E-06
     +,   5.0817798E-06,   5.3343110E-06,   5.5951186E-06
     +,   5.8642800E-06,   6.1418846E-06,   6.4280266E-06
     +,   6.7228189E-06,   7.0263873E-06,   7.3388765E-06
     +,   7.6604565E-06,   7.9913243E-06,   8.3317127E-06
     +,   8.6818936E-06,   9.0421927E-06,   9.4129709E-06
     +,   9.7946677E-06,   1.0187780E-05,   1.0592879E-05
     +,   1.1010628E-05,   1.1441775E-05,   1.1887171E-05
     +,   1.2347801E-05,   1.2824735E-05,   1.3319176E-05
     +,   1.3832562E-05,   1.4366381E-05,   1.4922351E-05
     +,   1.5502408E-05,   1.6108686E-05,   1.6743568E-05
     +,   1.7409717E-05,   1.8110099E-05,   1.8848046E-05
     +,   1.9627283E-05,   2.0452038E-05,   2.1327065E-05
     +,   2.2257831E-05,   2.3250497E-05,   2.4312223E-05
     +,   2.5451234E-05,   2.6677057E-05,   2.8000723E-05
     +,   2.9435003E-05,   3.0994688E-05,   3.2696713E-05
     +,   3.4560479E-05,   3.6607918E-05,   3.8863520E-05
     +,   4.1354222E-05,   4.4109263E-05,   4.7159632E-05
     +,   5.0537343E-05,   5.4274842E-05,   5.8403486E-05
     +,   6.2952997E-05,   6.7949419E-05,   7.3414310E-05
     +,   7.9363446E-05,   8.5805819E-05,   9.2743314E-05
     +,   1.0016858E-04,   1.0806923E-04,   1.1642293E-04
     +,   1.2520252E-04,   1.3437391E-04,   1.4389829E-04
     +,   1.5373083E-04,   1.6382089E-04,   1.7411036E-04
     +,   1.8453236E-04,   1.9500653E-04,   2.0543880E-04
     +,   2.1571796E-04,   2.2571367E-04,   2.3527886E-04
     +,   2.4425288E-04,   2.5246761E-04,   2.5975873E-04
     +,   2.6597732E-04,   2.7100611E-04,   2.7477404E-04
     +,   2.7727141E-04,   2.7856175E-04,   2.7879101E-04
     +,   2.7819019E-04,   2.7707385E-04,   2.7583304E-04
     +,   2.7492095E-04,   2.7483524E-04,   2.7609585E-04
     +,   2.7921580E-04,   2.8467178E-04,   2.9287755E-04
     +,   3.0415814E-04,   3.1873968E-04,   3.3675000E-04
     +,   3.5823166E-04,   3.8315571E-04,   4.1142089E-04
     +,   4.4281897E-04,   4.7696318E-04,   5.1319023E-04
     +,   5.5049208E-04,   5.8753532E-04,   6.2286336E-04
     +,   6.5531547E-04,   6.8463018E-04,   7.1208406E-04
     +,   7.4091798E-04,   7.7623833E-04,   8.2416821E-04
     +,   8.9031988E-04,   9.7788766E-04,   1.0859995E-03
     +,   1.2089203E-03,   1.3364573E-03,   1.4556105E-03
     +,   1.5532675E-03,   1.6195808E-03,   1.6514356E-03
     +,   1.6548455E-03,   1.6448192E-03,   1.6415439E-03
     +,   1.6634807E-03,   1.7200247E-03,   1.8076905E-03
     +,   1.9121771E-03,   2.0150894E-03,   2.1009524E-03
     +,   2.1604856E-03,   2.1900351E-03,   2.1901976E-03
     +,   2.1663909E-03,   2.1301636E-03,   2.0980258E-03
     +,   2.0864622E-03,   2.1056854E-03,   2.1553549E-03
     +,   2.2235583E-03,   2.2886563E-03,   2.3242354E-03
     +,   2.3068627E-03,   2.2244151E-03,   2.0805460E-03
     +,   1.8927768E-03,   1.6855411E-03,   1.4823593E-03
     +,   1.3004836E-03,   1.1490929E-03,   1.0302387E-03
     +,   9.4089273E-04,   8.7528862E-04,   8.2685676E-04
     +,   7.8960176E-04,   7.5886759E-04,   7.3157053E-04
     +,   7.0604437E-04,   6.8172108E-04,   6.5870892E-04
     +,   6.3742849E-04,   6.1827363E-04,   6.0137501E-04
     +,   5.8649830E-04,   5.7306240E-04,   5.6027167E-04
     +,   5.4729008E-04,   5.3341378E-04,   5.1819941E-04
     +,   5.0152733E-04,   4.8361049E-04,   4.6494798E-04
     +,   4.4624286E-04,   4.2829145E-04,   4.1186542E-04
     +,   3.9759593E-04,   3.8587992E-04,   3.7681728E-04
     +,   3.7019703E-04,   3.6552426E-04,   3.6209050E-04
     +,   3.5907154E-04,   3.5563437E-04,   3.5104313E-04
     +,   3.4473510E-04,   3.3637381E-04,   3.2586095E-04
     +,   3.1331921E-04,   2.9904989E-04,   2.8347565E-04
     +,   2.6708195E-04,   2.5035796E-04,   2.3375006E-04
     +,   2.1763516E-04,   2.0229825E-04,   1.8793433E-04
     +,   1.7464854E-04,   1.6247192E-04,   1.5137756E-04
     +,   1.4129690E-04,   1.3213535E-04,   1.2378559E-04
     +,   1.1613794E-04,   1.0908736E-04,   1.0253781E-04
     +,   9.6406242E-05,   9.0622081E-05,   8.5127009E-05
     +,   7.9875907E-05,   7.4834490E-05,   6.9978974E-05
     +,   6.5293505E-05,   6.0769748E-05,   5.6405137E-05
     +,   5.2201813E-05,   4.8164900E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wano_zz = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_wao_fus_100(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  9.9439771E-13,   1.2006155E-12
     +,   1.4480474E-12,   1.7446049E-12,   2.0996501E-12
     +,   2.5242467E-12,   3.0314611E-12,   3.6367049E-12
     +,   4.3581167E-12,   5.2170750E-12,   6.2386251E-12
     +,   7.4522298E-12,   8.8924016E-12,   1.0599548E-11
     +,   1.2620926E-11,   1.5011725E-11,   1.7836326E-11
     +,   2.1169745E-11,   2.5099327E-11,   2.9726482E-11
     +,   3.5169083E-11,   4.1563648E-11,   4.9068475E-11
     +,   5.7866611E-11,   6.8169186E-11,   8.0220219E-11
     +,   9.4300782E-11,   1.1073453E-10,   1.2989318E-10
     +,   1.5220372E-10,   1.7815598E-10,   2.0831055E-10
     +,   2.4330898E-10,   2.8388422E-10,   3.3087222E-10
     +,   3.8522605E-10,   4.4802972E-10,   5.2051619E-10
     +,   6.0408523E-10,   7.0032230E-10,   8.1102541E-10
     +,   9.3822838E-10,   1.0842179E-09,   1.2515946E-09
     +,   1.4432662E-09,   1.6625159E-09,   1.9130308E-09
     +,   2.1989479E-09,   2.5249038E-09,   2.8960891E-09
     +,   3.3183050E-09,   3.7980277E-09,   4.3424730E-09
     +,   4.9596860E-09,   5.6586122E-09,   6.4491497E-09
     +,   7.3423183E-09,   8.3503000E-09,   9.4865804E-09
     +,   1.0766037E-08,   1.2205088E-08,   1.3821819E-08
     +,   1.5636122E-08,   1.7669832E-08,   1.9946919E-08
     +,   2.2493643E-08,   2.5338689E-08,   2.8513435E-08
     +,   3.2052103E-08,   3.5991924E-08,   4.0373457E-08
     +,   4.5240714E-08,   5.0641436E-08,   5.6627382E-08
     +,   6.3254582E-08,   7.0583212E-08,   7.8678511E-08
     +,   8.7610665E-08,   9.7454809E-08,   1.0829246E-07
     +,   1.2021022E-07,   1.3330100E-07,   1.4766491E-07
     +,   1.6340675E-07,   1.8063933E-07,   1.9948533E-07
     +,   2.2007025E-07,   2.4253052E-07,   2.6700988E-07
     +,   2.9366038E-07,   3.2264239E-07,   3.5412540E-07
     +,   3.8828762E-07,   4.2531644E-07,   4.6540885E-07
     +,   5.0877071E-07,   5.5561799E-07,   6.0617629E-07
     +,   6.6068048E-07,   7.1937575E-07,   7.8251679E-07
     +,   8.5036805E-07,   9.2320363E-07,   1.0013069E-06
     +,   1.0849709E-06,   1.1744984E-06,   1.2701995E-06
     +,   1.3723995E-06,   1.4814171E-06,   1.5975872E-06
     +,   1.7212692E-06,   1.8527981E-06,   1.9925358E-06
     +,   2.1408450E-06,   2.2980939E-06,   2.4646545E-06
     +,   2.6409023E-06,   2.8272170E-06,   3.0239787E-06
     +,   3.2315679E-06,   3.4503676E-06,   3.6807551E-06
     +,   3.9231086E-06,   4.1777994E-06,   4.4451958E-06
     +,   4.7256576E-06,   5.0195349E-06,   5.3271697E-06
     +,   5.6488893E-06,   5.9850076E-06,   6.3358211E-06
     +,   6.7016099E-06,   7.0826291E-06,   7.4791137E-06
     +,   7.8912699E-06,   8.3192790E-06,   8.7632834E-06
     +,   9.2233995E-06,   9.6996982E-06,   1.0192214E-05
     +,   1.0700936E-05,   1.1225808E-05,   1.1766717E-05
     +,   1.2323503E-05,   1.2895945E-05,   1.3483786E-05
     +,   1.4086610E-05,   1.4704101E-05,   1.5335701E-05
     +,   1.5980886E-05,   1.6639025E-05,   1.7309409E-05
     +,   1.7991255E-05,   1.8683706E-05,   1.9385816E-05
     +,   2.0096570E-05,   2.0814872E-05,   2.1539567E-05
     +,   2.2269431E-05,   2.3003176E-05,   2.3739494E-05
     +,   2.4477044E-05,   2.5214476E-05,   2.5950485E-05
     +,   2.6683811E-05,   2.7413316E-05,   2.8138022E-05
     +,   2.8857185E-05,   2.9570379E-05,   3.0277635E-05
     +,   3.0979416E-05,   3.1676969E-05,   3.2372318E-05
     +,   3.3068613E-05,   3.3770175E-05,   3.4482775E-05
     +,   3.5214009E-05,   3.5973499E-05,   3.6773239E-05
     +,   3.7627924E-05,   3.8555394E-05,   3.9576997E-05
     +,   4.0718111E-05,   4.2008720E-05,   4.3484077E-05
     +,   4.5185712E-05,   4.7162532E-05,   4.9472437E-05
     +,   5.2184507E-05,   5.5381763E-05,   5.9165010E-05
     +,   6.3657404E-05,   6.9010479E-05,   7.5410790E-05
     +,   8.3087791E-05,   9.2321985E-05,   1.0345264E-04
     +,   1.1688444E-04,   1.3309131E-04,   1.5261616E-04
     +,   1.7606486E-04,   2.0409266E-04,   2.3738257E-04
     +,   2.7661433E-04,   3.2242446E-04,   3.7535952E-04
     +,   4.3582317E-04,   5.0402194E-04,   5.7991367E-04
     +,   6.6316465E-04,   7.5309823E-04,   8.4871153E-04
     +,   9.4864127E-04,   1.0512067E-03,   1.1544647E-03
     +,   1.2562772E-03,   1.3544561E-03,   1.4468986E-03
     +,   1.5317680E-03,   1.6077111E-03,   1.6740207E-03
     +,   1.7308551E-03,   1.7793584E-03,   1.8217443E-03
     +,   1.8613063E-03,   1.9023466E-03,   1.9500416E-03
     +,   2.0102537E-03,   2.0893717E-03,   2.1942852E-03
     +,   2.3325598E-03,   2.5128275E-03,   2.7449729E-03
     +,   3.0393919E-03,   3.4045510E-03,   3.8422404E-03
     +,   4.3421998E-03,   4.8785736E-03,   5.4119783E-03
     +,   5.8987713E-03,   6.3051106E-03,   6.6194437E-03
     +,   6.8566450E-03,   7.0510008E-03,   7.2412733E-03
     +,   7.4554235E-03,   7.7026309E-03,   7.9764919E-03
     +,   8.2679102E-03,   8.5809864E-03,   8.9424299E-03
     +,   9.3958536E-03,   9.9784648E-03,   1.0689125E-02
     +,   1.1469876E-02,   1.2221923E-02,   1.2852580E-02
     +,   1.3316078E-02,   1.3610754E-02,   1.3743227E-02
     +,   1.3716092E-02,   1.3575070E-02,   1.3466543E-02
     +,   1.3608148E-02,   1.4149547E-02,   1.5040590E-02
     +,   1.6064579E-02,   1.7036665E-02,   1.7961645E-02
     +,   1.8967280E-02,   2.0084914E-02,   2.1137925E-02
     +,   2.1891724E-02,   2.2291493E-02,   2.2484759E-02
     +,   2.2630926E-02,   2.2761175E-02,   2.2804905E-02
     +,   2.2667395E-02,   2.2237979E-02,   2.1400154E-02
     +,   2.0156799E-02,   1.8730832E-02,   1.7433677E-02
     +,   1.6408661E-02,   1.5532367E-02,   1.4544885E-02
     +,   1.3243781E-02,   1.1590907E-02,   9.7075915E-03
     +,   7.7982773E-03,   6.0540773E-03,   4.5877532E-03
     +,   3.4241674E-03,   2.5299448E-03,   1.8514112E-03
     +,   1.3385329E-03,   9.5289422E-04,   6.6620193E-04
     +,   4.5670220E-04,   3.0673196E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wao_fus_100 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_wao_fus_105(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  4.9920450E-09,   5.5156915E-09
     +,   6.0900609E-09,   6.7196160E-09,   7.4091298E-09
     +,   8.1637763E-09,   8.9890833E-09,   9.8910000E-09
     +,   1.0875915E-08,   1.1950683E-08,   1.3122593E-08
     +,   1.4399489E-08,   1.5789743E-08,   1.7302289E-08
     +,   1.8946672E-08,   2.0733019E-08,   2.2672152E-08
     +,   2.4775584E-08,   2.7055503E-08,   2.9524848E-08
     +,   3.2197391E-08,   3.5087616E-08,   3.8210960E-08
     +,   4.1583736E-08,   4.5222929E-08,   4.9146713E-08
     +,   5.3374158E-08,   5.7925245E-08,   6.2821130E-08
     +,   6.8083821E-08,   7.3736551E-08,   7.9803584E-08
     +,   8.6310216E-08,   9.3283106E-08,   1.0074984E-07
     +,   1.0873924E-07,   1.1728129E-07,   1.2640717E-07
     +,   1.3614934E-07,   1.4654123E-07,   1.5761763E-07
     +,   1.6941466E-07,   1.8196864E-07,   1.9531875E-07
     +,   2.0950351E-07,   2.2456349E-07,   2.4054029E-07
     +,   2.5747610E-07,   2.7541449E-07,   2.9439954E-07
     +,   3.1447652E-07,   3.3569103E-07,   3.5808995E-07
     +,   3.8171999E-07,   4.0662960E-07,   4.3286553E-07
     +,   4.6047674E-07,   4.8951165E-07,   5.2001877E-07
     +,   5.5204640E-07,   5.8564285E-07,   6.2085570E-07
     +,   6.5773219E-07,   6.9631926E-07,   7.3666195E-07
     +,   7.7880486E-07,   8.2279155E-07,   8.6866385E-07
     +,   9.1646194E-07,   9.6622375E-07,   1.0179863E-06
     +,   1.0717830E-06,   1.1276456E-06,   1.1856031E-06
     +,   1.2456825E-06,   1.3079043E-06,   1.3722890E-06
     +,   1.4388523E-06,   1.5076052E-06,   1.5785592E-06
     +,   1.6517164E-06,   1.7270767E-06,   1.8046385E-06
     +,   1.8843863E-06,   1.9663050E-06,   2.0503862E-06
     +,   2.1365956E-06,   2.2249064E-06,   2.3152850E-06
     +,   2.4076908E-06,   2.5020790E-06,   2.5983993E-06
     +,   2.6965963E-06,   2.7966100E-06,   2.8983741E-06
     +,   3.0018182E-06,   3.1068687E-06,   3.2134467E-06
     +,   3.3214678E-06,   3.4308475E-06,   3.5414964E-06
     +,   3.6533227E-06,   3.7662344E-06,   3.8801363E-06
     +,   3.9949346E-06,   4.1105359E-06,   4.2268503E-06
     +,   4.3437917E-06,   4.4612693E-06,   4.5792040E-06
     +,   4.6975401E-06,   4.8162019E-06,   4.9351456E-06
     +,   5.0543340E-06,   5.1737466E-06,   5.2933819E-06
     +,   5.4132565E-06,   5.5334158E-06,   5.6539297E-06
     +,   5.7748971E-06,   5.8964538E-06,   6.0187749E-06
     +,   6.1420737E-06,   6.2666172E-06,   6.3927178E-06
     +,   6.5207469E-06,   6.6511384E-06,   6.7843921E-06
     +,   6.9210814E-06,   7.0618562E-06,   7.2074508E-06
     +,   7.3586889E-06,   7.5164899E-06,   7.6818696E-06
     +,   7.8559515E-06,   8.0399659E-06,   8.2352635E-06
     +,   8.4433050E-06,   8.6656746E-06,   8.9040832E-06
     +,   9.1603588E-06,   9.4364532E-06,   9.7344455E-06
     +,   1.0056529E-05,   1.0405016E-05,   1.0782342E-05
     +,   1.1190977E-05,   1.1633609E-05,   1.2112875E-05
     +,   1.2631561E-05,   1.3192489E-05,   1.3798513E-05
     +,   1.4452523E-05,   1.5157404E-05,   1.5916041E-05
     +,   1.6731277E-05,   1.7605929E-05,   1.8542731E-05
     +,   1.9544363E-05,   2.0613408E-05,   2.1752372E-05
     +,   2.2963655E-05,   2.4249572E-05,   2.5612364E-05
     +,   2.7054204E-05,   2.8577217E-05,   3.0183533E-05
     +,   3.1875305E-05,   3.3654760E-05,   3.5524343E-05
     +,   3.7486479E-05,   3.9544098E-05,   4.1700274E-05
     +,   4.3958858E-05,   4.6324029E-05,   4.8800419E-05
     +,   5.1393654E-05,   5.4110147E-05,   5.6957262E-05
     +,   5.9943435E-05,   6.3078318E-05,   6.6372944E-05
     +,   6.9839778E-05,   7.3493014E-05,   7.7348675E-05
     +,   8.1424849E-05,   8.5741951E-05,   9.0322916E-05
     +,   9.5193616E-05,   1.0038305E-04,   1.0592384E-04
     +,   1.1185261E-04,   1.1821054E-04,   1.2504400E-04
     +,   1.3240542E-04,   1.4035443E-04,   1.4895956E-04
     +,   1.5830067E-04,   1.6847190E-04,   1.7958651E-04
     +,   1.9178272E-04,   2.0523166E-04,   2.2014782E-04
     +,   2.3680177E-04,   2.5553617E-04,   2.7678462E-04
     +,   3.0109345E-04,   3.2914456E-04,   3.6177869E-04
     +,   4.0001536E-04,   4.4505217E-04,   4.9827335E-04
     +,   5.6119502E-04,   6.3540344E-04,   7.2244613E-04
     +,   8.2366721E-04,   9.4005739E-04,   1.0720675E-03
     +,   1.2194698E-03,   1.3813374E-03,   1.5560392E-03
     +,   1.7415007E-03,   1.9354855E-03,   2.1359806E-03
     +,   2.3415803E-03,   2.5516935E-03,   2.7666669E-03
     +,   2.9874737E-03,   3.2152145E-03,   3.4503492E-03
     +,   3.6918260E-03,   3.9364859E-03,   4.1788877E-03
     +,   4.4119386E-03,   4.6283184E-03,   4.8223692E-03
     +,   4.9922317E-03,   5.1414780E-03,   5.2798833E-03
     +,   5.4227156E-03,   5.5881166E-03,   5.7926923E-03
     +,   6.0472633E-03,   6.3559781E-03,   6.7214714E-03
     +,   7.1534030E-03,   7.6719271E-03,   8.2972161E-03
     +,   9.0261512E-03,   9.8119881E-03,   1.0566534E-02
     +,   1.1190069E-02,   1.1611332E-02,   1.1810090E-02
     +,   1.1810271E-02,   1.1656040E-02,   1.1393758E-02
     +,   1.1068939E-02,   1.0728959E-02,   1.0421567E-02
     +,   1.0193101E-02,   1.0092924E-02,   1.0176565E-02
     +,   1.0490107E-02,   1.1034923E-02,   1.1738630E-02
     +,   1.2464382E-02,   1.3062146E-02,   1.3429126E-02
     +,   1.3538755E-02,   1.3428669E-02,   1.3174642E-02
     +,   1.2875050E-02,   1.2638190E-02,   1.2550120E-02
     +,   1.2634321E-02,   1.2848586E-02,   1.3135657E-02
     +,   1.3473716E-02,   1.3867167E-02,   1.4297612E-02
     +,   1.4709588E-02,   1.5050226E-02,   1.5305035E-02
     +,   1.5487969E-02,   1.5611435E-02,   1.5672868E-02
     +,   1.5653687E-02,   1.5514101E-02,   1.5188703E-02
     +,   1.4597006E-02,   1.3670911E-02,   1.2389437E-02
     +,   1.0803333E-02,   9.0318611E-03,   7.2306511E-03
     +,   5.5469084E-03,   4.0856409E-03,   2.8968945E-03
     +,   1.9821660E-03,   1.3109697E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wao_fus_105 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_wao_fus_110(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  1.5680610E-07,   1.6961663E-07
     +,   1.8332788E-07,   1.9798983E-07,   2.1365436E-07
     +,   2.3037477E-07,   2.4820619E-07,   2.6720511E-07
     +,   2.8742940E-07,   3.0893906E-07,   3.3179370E-07
     +,   3.5605561E-07,   3.8178780E-07,   4.0905397E-07
     +,   4.3791883E-07,   4.6844750E-07,   5.0070599E-07
     +,   5.3476015E-07,   5.7067626E-07,   6.0851983E-07
     +,   6.4835712E-07,   6.9025270E-07,   7.3427117E-07
     +,   7.8047634E-07,   8.2892814E-07,   8.7968772E-07
     +,   9.3281290E-07,   9.8835972E-07,   1.0463807E-06
     +,   1.1069269E-06,   1.1700452E-06,   1.2357787E-06
     +,   1.3041670E-06,   1.3752450E-06,   1.4490432E-06
     +,   1.5255874E-06,   1.6048973E-06,   1.6869875E-06
     +,   1.7718659E-06,   1.8595346E-06,   1.9499885E-06
     +,   2.0432178E-06,   2.1391977E-06,   2.2379090E-06
     +,   2.3393109E-06,   2.4433618E-06,   2.5500112E-06
     +,   2.6591988E-06,   2.7708561E-06,   2.8849051E-06
     +,   3.0012593E-06,   3.1198226E-06,   3.2404898E-06
     +,   3.3631475E-06,   3.4876741E-06,   3.6139318E-06
     +,   3.7417813E-06,   3.8710727E-06,   4.0016457E-06
     +,   4.1333324E-06,   4.2659576E-06,   4.3993350E-06
     +,   4.5332745E-06,   4.6675759E-06,   4.8020333E-06
     +,   4.9364353E-06,   5.0705612E-06,   5.2041896E-06
     +,   5.3370904E-06,   5.4690322E-06,   5.5997775E-06
     +,   5.7290877E-06,   5.8567216E-06,   5.9824374E-06
     +,   6.1059932E-06,   6.2271411E-06,   6.3456405E-06
     +,   6.4612523E-06,   6.5737345E-06,   6.6828579E-06
     +,   6.7883889E-06,   6.8901013E-06,   6.9877783E-06
     +,   7.0811998E-06,   7.1701588E-06,   7.2544667E-06
     +,   7.3339247E-06,   7.4083559E-06,   7.4775894E-06
     +,   7.5414669E-06,   7.5998400E-06,   7.6525730E-06
     +,   7.6995439E-06,   7.7406403E-06,   7.7757650E-06
     +,   7.8048370E-06,   7.8277881E-06,   7.8445601E-06
     +,   7.8551147E-06,   7.8594294E-06,   7.8574894E-06
     +,   7.8493040E-06,   7.8348885E-06,   7.8142821E-06
     +,   7.7875302E-06,   7.7546965E-06,   7.7158620E-06
     +,   7.6711158E-06,   7.6205647E-06,   7.5643320E-06
     +,   7.5025414E-06,   7.4353429E-06,   7.3628926E-06
     +,   7.2853554E-06,   7.2029120E-06,   7.1157501E-06
     +,   7.0240676E-06,   6.9280713E-06,   6.8279783E-06
     +,   6.7240094E-06,   6.6163975E-06,   6.5053787E-06
     +,   6.3911962E-06,   6.2740983E-06,   6.1543406E-06
     +,   6.0321809E-06,   5.9078820E-06,   5.7817138E-06
     +,   5.6539457E-06,   5.5248543E-06,   5.3947206E-06
     +,   5.2638293E-06,   5.1324696E-06,   5.0009357E-06
     +,   4.8695297E-06,   4.7385588E-06,   4.6083387E-06
     +,   4.4791950E-06,   4.3514624E-06,   4.2254878E-06
     +,   4.1016351E-06,   3.9802799E-06,   3.8618196E-06
     +,   3.7466689E-06,   3.6352694E-06,   3.5280832E-06
     +,   3.4256188E-06,   3.3283900E-06,   3.2369746E-06
     +,   3.1519762E-06,   3.0740473E-06,   3.0038921E-06
     +,   2.9422708E-06,   2.8900058E-06,   2.8479853E-06
     +,   2.8171789E-06,   2.7986382E-06,   2.7935102E-06
     +,   2.8030488E-06,   2.8286283E-06,   2.8717557E-06
     +,   2.9340913E-06,   3.0174679E-06,   3.1239140E-06
     +,   3.2556820E-06,   3.4152815E-06,   3.6055126E-06
     +,   3.8295102E-06,   4.0907953E-06,   4.3933373E-06
     +,   4.7415710E-06,   5.1405427E-06,   5.5959149E-06
     +,   6.1141568E-06,   6.7025439E-06,   7.3692445E-06
     +,   8.1235694E-06,   8.9759951E-06,   9.9383387E-06
     +,   1.1023887E-05,   1.2247564E-05,   1.3626085E-05
     +,   1.5178125E-05,   1.6924501E-05,   1.8888359E-05
     +,   2.1095373E-05,   2.3573988E-05,   2.6355652E-05
     +,   2.9475157E-05,   3.2971020E-05,   3.6885958E-05
     +,   4.1267504E-05,   4.6168807E-05,   5.1649658E-05
     +,   5.7777757E-05,   6.4630360E-05,   7.2296265E-05
     +,   8.0878308E-05,   9.0496265E-05,   1.0129028E-04
     +,   1.1342471E-04,   1.2709227E-04,   1.4251792E-04
     +,   1.5996305E-04,   1.7972795E-04,   2.0215442E-04
     +,   2.2762579E-04,   2.5656712E-04,   2.8944423E-04
     +,   3.2676611E-04,   3.6907953E-04,   4.1699564E-04
     +,   4.7119093E-04,   5.3244876E-04,   6.0171407E-04
     +,   6.8016100E-04,   7.6932285E-04,   8.7121350E-04
     +,   9.8845141E-04,   1.1243465E-03,   1.2827505E-03
     +,   1.4677739E-03,   1.6831341E-03,   1.9313078E-03
     +,   2.2126390E-03,   2.5246122E-03,   2.8618018E-03
     +,   3.2161982E-03,   3.5781753E-03,   3.9375154E-03
     +,   4.2841206E-03,   4.6085133E-03,   4.9022338E-03
     +,   5.1588546E-03,   5.3760279E-03,   5.5579757E-03
     +,   5.7174773E-03,   5.8753956E-03,   6.0567013E-03
     +,   6.2837279E-03,   6.5694847E-03,   6.9153314E-03
     +,   7.3153852E-03,   7.7644656E-03,   8.2611153E-03
     +,   8.7991180E-03,   9.3523441E-03,   9.8692430E-03
     +,   1.0289975E-02,   1.0579360E-02,   1.0750324E-02
     +,   1.0857034E-02,   1.0960877E-02,   1.1092253E-02
     +,   1.1232873E-02,   1.1331061E-02,   1.1344982E-02
     +,   1.1287613E-02,   1.1235238E-02,   1.1283566E-02
     +,   1.1484343E-02,   1.1817504E-02,   1.2213489E-02
     +,   1.2587539E-02,   1.2855159E-02,   1.2947273E-02
     +,   1.2843201E-02,   1.2586895E-02,   1.2247449E-02
     +,   1.1861330E-02,   1.1435059E-02,   1.1014734E-02
     +,   1.0734991E-02,   1.0773780E-02,   1.1238579E-02
     +,   1.2072601E-02,   1.3045837E-02,   1.3835928E-02
     +,   1.4161030E-02,   1.3903364E-02,   1.3157035E-02
     +,   1.2168572E-02,   1.1206327E-02,   1.0442660E-02
     +,   9.9139856E-03,   9.5578441E-03,   9.2760231E-03
     +,   8.9782346E-03,   8.5969353E-03,   8.0890702E-03
     +,   7.4386117E-03,   6.6600959E-03,   5.7960600E-03
     +,   4.9051940E-03,   4.0454911E-03,   3.2611459E-03
     +,   2.5771377E-03,   2.0013053E-03,   1.5295770E-03
     +,   1.1513083E-03,   8.5326779E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wao_fus_110 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_wao_fus_115(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   1.3487891E-38,   2.8451880E-38
     +,   5.9797189E-38,   1.2521705E-37,   2.6124170E-37
     +,   5.4303907E-37,   1.1246634E-36,   2.3207072E-36
     +,   4.7711274E-36,   9.7730015E-36,   1.9946779E-35
     +,   4.0559793E-35,   8.2171630E-35,   1.6586501E-34
     +,   3.3357299E-34,   6.6840078E-34,   1.3343912E-33
     +,   2.6542554E-33,   5.2602222E-33,   1.0386494E-32
     +,   2.0433485E-32,   4.0051714E-32,   7.8217723E-32
     +,   1.5219238E-31,   2.9504579E-31,   5.6988841E-31
     +,   1.0967245E-30,   2.1028701E-30,   4.0172901E-30
     +,   7.6464775E-30,   1.4500865E-29,   2.7399071E-29
     +,   5.1580105E-29,   9.6746792E-29,   1.8079955E-28
     +,   3.3664300E-28,   6.2451110E-28,   1.1543280E-27
     +,   2.1257897E-27,   3.9004696E-27,   7.1305684E-27
     +,   1.2987852E-26,   2.3570016E-26,   4.2617902E-26
     +,   7.6776941E-26,   1.3781017E-25,   2.4645565E-25
     +,   4.3914403E-25,   7.7963153E-25,   1.3790437E-24
     +,   2.4303937E-24,   4.2676168E-24,   7.4662900E-24
     +,   1.3014832E-23,   2.2603826E-23,   3.9114595E-23
     +,   6.7438501E-23,   1.1584877E-22,   1.9828341E-22
     +,   3.3814012E-22,   5.7454353E-22,   9.7266625E-22
     +,   1.6406659E-21,   2.7573642E-21,   4.6172632E-21
     +,   7.7036049E-21,   1.2806231E-20,   2.1211304E-20
     +,   3.5005482E-20,   5.7560332E-20,   9.4304645E-20
     +,   1.5394409E-19,   2.5038824E-19,   4.0578097E-19
     +,   6.5523142E-19,   1.0542023E-18,   1.6900112E-18
     +,   2.6994382E-18,   4.2961292E-18,   6.8128647E-18
     +,   1.0764744E-17,   1.6947705E-17,   2.6585868E-17
     +,   4.1555145E-17,   6.4719557E-17,   1.0043446E-16
     +,   1.5529912E-16,   2.3927320E-16,   3.6733180E-16
     +,   5.6191001E-16,   8.5648075E-16,   1.3008059E-15
     +,   1.9685848E-15,   2.9685369E-15,   4.4604492E-15
     +,   6.6782957E-15,   9.9633165E-15,   1.4811327E-14
     +,   2.1940068E-14,   3.2384431E-14,   4.7631150E-14
     +,   6.9808912E-14,   1.0194861E-13,   1.4835598E-13
     +,   2.1513147E-13,   3.1085434E-13,   4.4758254E-13
     +,   6.4217636E-13,   9.1812116E-13,   1.3080118E-12
     +,   1.8569042E-12,   2.6268495E-12,   3.7029598E-12
     +,   5.2015306E-12,   7.2808556E-12,   1.0155551E-11
     +,   1.4115448E-11,   1.9550412E-11,   2.6982824E-11
     +,   3.7109881E-11,   5.0858349E-11,   6.9455185E-11
     +,   9.4518629E-11,   1.2817394E-10,   1.7320118E-10
     +,   2.3322264E-10,   3.1293784E-10,   4.1842010E-10
     +,   5.5748456E-10,   7.4014689E-10,   9.7918962E-10
     +,   1.2908573E-09,   1.6957051E-09,   2.2196383E-09
     +,   2.8951550E-09,   3.7628536E-09,   4.8732325E-09
     +,   6.2888188E-09,   8.0866975E-09,   1.0361576E-08
     +,   1.3228710E-08,   1.6829116E-08,   2.1332495E-08
     +,   2.6943894E-08,   3.3909011E-08,   4.2520938E-08
     +,   5.3127739E-08,   6.6140522E-08,   8.2042490E-08
     +,   1.0139858E-07,   1.2486603E-07,   1.5320497E-07
     +,   1.8729004E-07,   2.2812186E-07,   2.7683839E-07
     +,   3.3472682E-07,   4.0323306E-07,   4.8397300E-07
     +,   5.7873854E-07,   6.8950573E-07,   8.1843768E-07
     +,   9.6788528E-07,   1.1403858E-06,   1.3386654E-06
     +,   1.5655946E-06,   1.8242260E-06,   2.1177316E-06
     +,   2.4494416E-06,   2.8227673E-06,   3.2411631E-06
     +,   3.7081902E-06,   4.2274455E-06,   4.8025713E-06
     +,   5.4372667E-06,   6.1353176E-06,   6.9006401E-06
     +,   7.7373752E-06,   8.6499813E-06,   9.6433914E-06
     +,   1.0723170E-05,   1.1895742E-05,   1.3168613E-05
     +,   1.4550630E-05,   1.6052274E-05,   1.7685961E-05
     +,   1.9466404E-05,   2.1411062E-05,   2.3540728E-05
     +,   2.5880410E-05,   2.8460623E-05,   3.1319298E-05
     +,   3.4504636E-05,   3.8078990E-05,   4.2124266E-05
     +,   4.6748821E-05,   5.2095900E-05,   5.8353762E-05
     +,   6.5766908E-05,   7.4648226E-05,   8.5391810E-05
     +,   9.8486031E-05,   1.1452745E-04,   1.3423561E-04
     +,   1.5847098E-04,   1.8824784E-04,   2.2476357E-04
     +,   2.6940129E-04,   3.2373430E-04,   3.8949921E-04
     +,   4.6851268E-04,   5.6255556E-04,   6.7316793E-04
     +,   8.0139539E-04,   9.4754307E-04,   1.1108749E-03
     +,   1.2895165E-03,   1.4804211E-03,   1.6795581E-03
     +,   1.8822997E-03,   2.0839325E-03,   2.2804528E-03
     +,   2.4692942E-03,   2.6502376E-03,   2.8261335E-03
     +,   3.0032040E-03,   3.1906138E-03,   3.3988704E-03
     +,   3.6371073E-03,   3.9098226E-03,   4.2139925E-03
     +,   4.5382832E-03,   4.8649912E-03,   5.1745926E-03
     +,   5.4512038E-03,   5.6866203E-03,   5.8812071E-03
     +,   6.0420549E-03,   6.1807847E-03,   6.3136476E-03
     +,   6.4634522E-03,   6.6583059E-03,   6.9212425E-03
     +,   7.2516943E-03,   7.6111387E-03,   7.9297200E-03
     +,   8.1385411E-03,   8.2101114E-03,   8.1781056E-03
     +,   8.1215221E-03,   8.1272079E-03,   8.2576247E-03
     +,   8.5370187E-03,   8.9481166E-03,   9.4319154E-03
     +,   9.8974863E-03,   1.0249009E-02,   1.0419302E-02
     +,   1.0392022E-02,   1.0207624E-02,   9.9569410E-03
     +,   9.7588580E-03,   9.7196046E-03,   9.8906793E-03
     +,   1.0253018E-02,   1.0735745E-02,   1.1250968E-02
     +,   1.1719826E-02,   1.2077319E-02,   1.2262163E-02
     +,   1.2212465E-02,   1.1883430E-02,   1.1279891E-02
     +,   1.0479105E-02,   9.6225226E-03,   8.8726785E-03
     +,   8.3503528E-03,   8.0855237E-03,   8.0146724E-03
     +,   8.0276290E-03,   8.0276225E-03,   7.9606511E-03
     +,   7.8042038E-03,   7.5423946E-03,   7.1564992E-03
     +,   6.6349078E-03,   5.9867045E-03,   5.2452227E-03
     +,   4.4601872E-03,   3.6843801E-03,   2.9621699E-03
     +,   2.3229462E-03,   1.7804086E-03,   1.3355281E-03
     +,   9.8102808E-04,   7.0551399E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wao_fus_115 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_wao_fus_120(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  5.7816501E-13,   6.9783665E-13
     +,   8.4137764E-13,   1.0133613E-12,   1.2191943E-12
     +,   1.4652688E-12,   1.7591291E-12,   2.1096649E-12
     +,   2.5273473E-12,   3.0245045E-12,   3.6155690E-12
     +,   4.3175290E-12,   5.1502695E-12,   6.1370488E-12
     +,   7.3050854E-12,   8.6861377E-12,   1.0317238E-11
     +,   1.2241547E-11,   1.4509246E-11,   1.7178653E-11
     +,   2.0317425E-11,   2.4004040E-11,   2.8329294E-11
     +,   3.3398281E-11,   3.9332041E-11,   4.6270546E-11
     +,   5.4374897E-11,   6.3830524E-11,   7.4850307E-11
     +,   8.7678788E-11,   1.0259629E-10,   1.1992342E-10
     +,   1.4002709E-10,   1.6332619E-10,   1.9029849E-10
     +,   2.2148816E-10,   2.5751437E-10,   2.9908048E-10
     +,   3.4698439E-10,   4.0213141E-10,   4.6554507E-10
     +,   5.3838445E-10,   6.2195071E-10,   7.1772438E-10
     +,   8.2736040E-10,   9.5272190E-10,   1.0959081E-09
     +,   1.2592671E-09,   1.4454292E-09,   1.6573399E-09
     +,   1.8982893E-09,   2.1719415E-09,   2.4823923E-09
     +,   2.8341833E-09,   3.2323806E-09,   3.6825736E-09
     +,   4.1909853E-09,   4.7644910E-09,   5.4106861E-09
     +,   6.1379626E-09,   6.9555544E-09,   7.8736218E-09
     +,   8.9033509E-09,   1.0056987E-08,   1.1347974E-08
     +,   1.2790990E-08,   1.4402096E-08,   1.6198806E-08
     +,   1.8200184E-08,   2.0426993E-08,   2.2901760E-08
     +,   2.5648914E-08,   2.8694894E-08,   3.2068318E-08
     +,   3.5800099E-08,   3.9923354E-08,   4.4473943E-08
     +,   4.9490250E-08,   5.5013402E-08,   6.1087775E-08
     +,   6.7760311E-08,   7.5081410E-08,   8.3104972E-08
     +,   9.1887316E-08,   1.0148868E-07,   1.1197451E-07
     +,   1.2341121E-07,   1.3587069E-07,   1.4942825E-07
     +,   1.6416304E-07,   1.8015807E-07,   1.9750031E-07
     +,   2.1628067E-07,   2.3659378E-07,   2.5853817E-07
     +,   2.8221615E-07,   3.0773353E-07,   3.3519979E-07
     +,   3.6472738E-07,   3.9643228E-07,   4.3043303E-07
     +,   4.6685091E-07,   5.0580940E-07,   5.4743379E-07
     +,   5.9185129E-07,   6.3918981E-07,   6.8957837E-07
     +,   7.4314801E-07,   8.0002263E-07,   8.6032952E-07
     +,   9.2420265E-07,   9.9175770E-07,   1.0631182E-06
     +,   1.1384019E-06,   1.2177219E-06,   1.3011855E-06
     +,   1.3888964E-06,   1.4809497E-06,   1.5774350E-06
     +,   1.6784327E-06,   1.7840157E-06,   1.8942472E-06
     +,   2.0091809E-06,   2.1288604E-06,   2.2533184E-06
     +,   2.3825758E-06,   2.5166432E-06,   2.6555192E-06
     +,   2.7991905E-06,   2.9476330E-06,   3.1008099E-06
     +,   3.2586756E-06,   3.4211728E-06,   3.5882349E-06
     +,   3.7597868E-06,   3.9357465E-06,   4.1160256E-06
     +,   4.3005316E-06,   4.4891694E-06,   4.6818418E-06
     +,   4.8784559E-06,   5.0789208E-06,   5.2831529E-06
     +,   5.4910779E-06,   5.7026323E-06,   5.9177773E-06
     +,   6.1364553E-06,   6.3586958E-06,   6.5844815E-06
     +,   6.8138679E-06,   7.0469218E-06,   7.2837479E-06
     +,   7.5244852E-06,   7.7693094E-06,   8.0184400E-06
     +,   8.2721381E-06,   8.5307147E-06,   8.7945300E-06
     +,   9.0640033E-06,   9.3396129E-06,   9.6219092E-06
     +,   9.9115177E-06,   1.0209156E-05,   1.0515648E-05
     +,   1.0831938E-05,   1.1159121E-05,   1.1498469E-05
     +,   1.1851471E-05,   1.2219867E-05,   1.2605736E-05
     +,   1.3011476E-05,   1.3439988E-05,   1.3894673E-05
     +,   1.4379630E-05,   1.4899657E-05,   1.5460399E-05
     +,   1.6068547E-05,   1.6731941E-05,   1.7459715E-05
     +,   1.8262466E-05,   1.9152405E-05,   2.0143490E-05
     +,   2.1251588E-05,   2.2494527E-05,   2.3892218E-05
     +,   2.5466607E-05,   2.7241729E-05,   2.9243491E-05
     +,   3.1499578E-05,   3.4039160E-05,   3.6892587E-05
     +,   4.0091039E-05,   4.3666179E-05,   4.7649821E-05
     +,   5.2073799E-05,   5.6970035E-05,   6.2370927E-05
     +,   6.8310444E-05,   7.4825686E-05,   8.1959544E-05
     +,   8.9764282E-05,   9.8306577E-05,   1.0767356E-04
     +,   1.1798047E-04,   1.2937935E-04,   1.4206863E-04
     +,   1.5630292E-04,   1.7240204E-04,   1.9075890E-04
     +,   2.1184482E-04,   2.3620641E-04,   2.6447146E-04
     +,   2.9733218E-04,   3.3553777E-04,   3.7988255E-04
     +,   4.3118090E-04,   4.9025990E-04,   5.5792811E-04
     +,   6.3493784E-04,   7.2195358E-04,   8.1945007E-04
     +,   9.2766667E-04,   1.0465141E-03,   1.1755270E-03
     +,   1.3138681E-03,   1.4603595E-03,   1.6136651E-03
     +,   1.7723769E-03,   1.9351778E-03,   2.1008970E-03
     +,   2.2684243E-03,   2.4365657E-03,   2.6037439E-03
     +,   2.7677282E-03,   2.9255603E-03,   3.0736784E-03
     +,   3.2085949E-03,   3.3278977E-03,   3.4315155E-03
     +,   3.5229030E-03,   3.6096566E-03,   3.7030769E-03
     +,   3.8164568E-03,   3.9622746E-03,   4.1488623E-03
     +,   4.3773116E-03,   4.6391594E-03,   4.9156505E-03
     +,   5.1795137E-03,   5.4003745E-03,   5.5531533E-03
     +,   5.6265774E-03,   5.6281993E-03,   5.5844206E-03
     +,   5.5372459E-03,   5.5394256E-03,   5.6464472E-03
     +,   5.9032338E-03,   6.3276961E-03,   6.8985648E-03
     +,   7.5543588E-03,   8.2052611E-03,   8.7573305E-03
     +,   9.1456026E-03,   9.3615511E-03,   9.4517665E-03
     +,   9.4825150E-03,   9.4992016E-03,   9.5150182E-03
     +,   9.5251417E-03,   9.5156943E-03,   9.4593847E-03
     +,   9.3231648E-03,   9.1009010E-03,   8.8394517E-03
     +,   8.6177373E-03,   8.4870076E-03,   8.4284330E-03
     +,   8.3701322E-03,   8.2477247E-03,   8.0562197E-03
     +,   7.8525450E-03,   7.7088098E-03,   7.6527959E-03
     +,   7.6406109E-03,   7.5794528E-03,   7.3789232E-03
     +,   6.9927201E-03,   6.4291651E-03,   5.7359668E-03
     +,   4.9770013E-03,   4.2133867E-03,   3.4925852E-03
     +,   2.8444636E-03,   2.2821149E-03,   1.8063405E-03
     +,   1.4108765E-03,   1.0867910E-03,   8.2481402E-04
     +,   6.1615178E-04,   4.5261779E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wao_fus_120 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_wao_fus_60(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  6.2170843E-06,   6.5894847E-06
     +,   6.9777284E-06,   7.3820142E-06,   7.8025123E-06
     +,   8.2393544E-06,   8.6926402E-06,   9.1624279E-06
     +,   9.6487365E-06,   1.0151550E-05,   1.0670786E-05
     +,   1.1206334E-05,   1.1758037E-05,   1.2325690E-05
     +,   1.2909029E-05,   1.3507756E-05,   1.4121510E-05
     +,   1.4749887E-05,   1.5392434E-05,   1.6048640E-05
     +,   1.6717962E-05,   1.7399796E-05,   1.8093499E-05
     +,   1.8798397E-05,   1.9513735E-05,   2.0238756E-05
     +,   2.0972660E-05,   2.1714613E-05,   2.2463750E-05
     +,   2.3219181E-05,   2.3980005E-05,   2.4745290E-05
     +,   2.5514104E-05,   2.6285508E-05,   2.7058559E-05
     +,   2.7832322E-05,   2.8605875E-05,   2.9378307E-05
     +,   3.0148736E-05,   3.0916297E-05,   3.1680174E-05
     +,   3.2439588E-05,   3.3193770E-05,   3.3942077E-05
     +,   3.4683846E-05,   3.5418507E-05,   3.6145560E-05
     +,   3.6864578E-05,   3.7575188E-05,   3.8277107E-05
     +,   3.8970134E-05,   3.9654136E-05,   4.0329083E-05
     +,   4.0995015E-05,   4.1652071E-05,   4.2300449E-05
     +,   4.2940443E-05,   4.3572451E-05,   4.4196928E-05
     +,   4.4814398E-05,   4.5425491E-05,   4.6030877E-05
     +,   4.6631299E-05,   4.7227557E-05,   4.7820504E-05
     +,   4.8411046E-05,   4.9000122E-05,   4.9588696E-05
     +,   5.0177761E-05,   5.0768336E-05,   5.1361443E-05
     +,   5.1958094E-05,   5.2559299E-05,   5.3166063E-05
     +,   5.3779357E-05,   5.4400105E-05,   5.5029213E-05
     +,   5.5667548E-05,   5.6315894E-05,   5.6975005E-05
     +,   5.7645571E-05,   5.8328187E-05,   5.9023419E-05
     +,   5.9731668E-05,   6.0453316E-05,   6.1188752E-05
     +,   6.1938066E-05,   6.2701438E-05,   6.3478896E-05
     +,   6.4270389E-05,   6.5075765E-05,   6.5894819E-05
     +,   6.6727240E-05,   6.7572626E-05,   6.8430512E-05
     +,   6.9300353E-05,   7.0181515E-05,   7.1073300E-05
     +,   7.1974944E-05,   7.2885603E-05,   7.3804375E-05
     +,   7.4730298E-05,   7.5662341E-05,   7.6599412E-05
     +,   7.7540346E-05,   7.8483979E-05,   7.9429024E-05
     +,   8.0374208E-05,   8.1318081E-05,   8.2259226E-05
     +,   8.3196283E-05,   8.4127583E-05,   8.5051593E-05
     +,   8.5966662E-05,   8.6871092E-05,   8.7763146E-05
     +,   8.8641013E-05,   8.9502806E-05,   9.0346686E-05
     +,   9.1170630E-05,   9.1972703E-05,   9.2750823E-05
     +,   9.3502968E-05,   9.4226998E-05,   9.4920826E-05
     +,   9.5582334E-05,   9.6209376E-05,   9.6799864E-05
     +,   9.7351658E-05,   9.7862787E-05,   9.8331198E-05
     +,   9.8755008E-05,   9.9132347E-05,   9.9461489E-05
     +,   9.9740872E-05,   9.9968995E-05,   1.0014462E-04
     +,   1.0026664E-04,   1.0033415E-04,   1.0034653E-04
     +,   1.0030337E-04,   1.0020452E-04,   1.0005016E-04
     +,   9.9840734E-05,   9.9577039E-05,   9.9260200E-05
     +,   9.8891724E-05,   9.8473363E-05,   9.8007375E-05
     +,   9.7496275E-05,   9.6943055E-05,   9.6350937E-05
     +,   9.5723633E-05,   9.5065174E-05,   9.4379873E-05
     +,   9.3672475E-05,   9.2947994E-05,   9.2211689E-05
     +,   9.1469170E-05,   9.0726302E-05,   8.9989109E-05
     +,   8.9263864E-05,   8.8556939E-05,   8.7874927E-05
     +,   8.7224464E-05,   8.6612250E-05,   8.6045067E-05
     +,   8.5529602E-05,   8.5072606E-05,   8.4680672E-05
     +,   8.4360407E-05,   8.4118146E-05,   8.3960127E-05
     +,   8.3892417E-05,   8.3920735E-05,   8.4050691E-05
     +,   8.4287480E-05,   8.4636056E-05,   8.5100975E-05
     +,   8.5686450E-05,   8.6396314E-05,   8.7233930E-05
     +,   8.8202221E-05,   8.9303649E-05,   9.0540183E-05
     +,   9.1913163E-05,   9.3423492E-05,   9.5071395E-05
     +,   9.6856573E-05,   9.8778000E-05,   1.0083405E-04
     +,   1.0302235E-04,   1.0533992E-04,   1.0778297E-04
     +,   1.1034701E-04,   1.1302684E-04,   1.1581653E-04
     +,   1.1870935E-04,   1.2169788E-04,   1.2477401E-04
     +,   1.2792900E-04,   1.3115341E-04,   1.3443730E-04
     +,   1.3777018E-04,   1.4114111E-04,   1.4453882E-04
     +,   1.4795181E-04,   1.5136831E-04,   1.5477656E-04
     +,   1.5816509E-04,   1.6152185E-04,   1.6483609E-04
     +,   1.6809687E-04,   1.7129394E-04,   1.7441782E-04
     +,   1.7745940E-04,   1.8041088E-04,   1.8326515E-04
     +,   1.8601614E-04,   1.8865927E-04,   1.9119018E-04
     +,   1.9360636E-04,   1.9590603E-04,   1.9808862E-04
     +,   2.0015457E-04,   2.0210493E-04,   2.0394202E-04
     +,   2.0566855E-04,   2.0728789E-04,   2.0880380E-04
     +,   2.1022017E-04,   2.1154109E-04,   2.1277042E-04
     +,   2.1391183E-04,   2.1496855E-04,   2.1594306E-04
     +,   2.1683714E-04,   2.1765161E-04,   2.1838647E-04
     +,   2.1904035E-04,   2.1961100E-04,   2.2009478E-04
     +,   2.2048698E-04,   2.2078180E-04,   2.2097230E-04
     +,   2.2105055E-04,   2.2100778E-04,   2.2083461E-04
     +,   2.2052103E-04,   2.2005671E-04,   2.1943125E-04
     +,   2.1863428E-04,   2.1765575E-04,   2.1648619E-04
     +,   2.1511677E-04,   2.1353978E-04,   2.1174857E-04
     +,   2.0973774E-04,   2.0750353E-04,   2.0504372E-04
     +,   2.0235778E-04,   1.9944698E-04,   1.9631436E-04
     +,   1.9296489E-04,   1.8940523E-04,   1.8564388E-04
     +,   1.8169094E-04,   1.7755809E-04,   1.7325845E-04
     +,   1.6880633E-04,   1.6421732E-04,   1.5950768E-04
     +,   1.5469456E-04,   1.4979561E-04,   1.4482852E-04
     +,   1.3981183E-04,   1.3476351E-04,   1.2970089E-04
     +,   1.2464146E-04,   1.1960175E-04,   1.1459817E-04
     +,   1.0964564E-04,   1.0475831E-04,   9.9949269E-05
     +,   9.5230527E-05,   9.0612877E-05,   8.6105923E-05
     +,   8.1718070E-05,   7.7456476E-05,   7.3326977E-05
     +,   6.9334739E-05,   6.5483466E-05,   6.1775499E-05
     +,   5.8212663E-05,   5.4795579E-05,   5.1524436E-05
     +,   4.8398215E-05,   4.5415371E-05,   4.2573742E-05
     +,   3.9870618E-05,   3.7302907E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wao_fus_60 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_wao_fus_65(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  2.3556358E-05,   2.4142315E-05
     +,   2.4731333E-05,   2.5323196E-05,   2.5917710E-05
     +,   2.6514690E-05,   2.7113976E-05,   2.7715418E-05
     +,   2.8318900E-05,   2.8924327E-05,   2.9531613E-05
     +,   3.0140691E-05,   3.0751544E-05,   3.1364161E-05
     +,   3.1978543E-05,   3.2594744E-05,   3.3212807E-05
     +,   3.3832817E-05,   3.4454879E-05,   3.5079109E-05
     +,   3.5705652E-05,   3.6334666E-05,   3.6966321E-05
     +,   3.7600821E-05,   3.8238348E-05,   3.8879127E-05
     +,   3.9523373E-05,   4.0171322E-05,   4.0823204E-05
     +,   4.1479263E-05,   4.2139720E-05,   4.2804819E-05
     +,   4.3474796E-05,   4.4149852E-05,   4.4830220E-05
     +,   4.5516088E-05,   4.6207635E-05,   4.6905036E-05
     +,   4.7608442E-05,   4.8317968E-05,   4.9033722E-05
     +,   4.9755814E-05,   5.0484225E-05,   5.1219053E-05
     +,   5.1960236E-05,   5.2707746E-05,   5.3461525E-05
     +,   5.4221469E-05,   5.4987435E-05,   5.5759254E-05
     +,   5.6536719E-05,   5.7319579E-05,   5.8107584E-05
     +,   5.8900416E-05,   5.9697759E-05,   6.0499209E-05
     +,   6.1304367E-05,   6.2112820E-05,   6.2924104E-05
     +,   6.3737731E-05,   6.4553213E-05,   6.5369983E-05
     +,   6.6187502E-05,   6.7005218E-05,   6.7822511E-05
     +,   6.8638801E-05,   6.9453454E-05,   7.0265851E-05
     +,   7.1075359E-05,   7.1881332E-05,   7.2683128E-05
     +,   7.3480085E-05,   7.4271571E-05,   7.5056909E-05
     +,   7.5835516E-05,   7.6606681E-05,   7.7369812E-05
     +,   7.8124271E-05,   7.8869431E-05,   7.9604724E-05
     +,   8.0329526E-05,   8.1043276E-05,   8.1745435E-05
     +,   8.2435385E-05,   8.3112594E-05,   8.3776635E-05
     +,   8.4426902E-05,   8.5062944E-05,   8.5684289E-05
     +,   8.6290478E-05,   8.6881068E-05,   8.7455635E-05
     +,   8.8013781E-05,   8.8555091E-05,   8.9079222E-05
     +,   8.9585774E-05,   9.0074420E-05,   9.0544854E-05
     +,   9.0996698E-05,   9.1429698E-05,   9.1843540E-05
     +,   9.2237955E-05,   9.2612674E-05,   9.2967457E-05
     +,   9.3302056E-05,   9.3616247E-05,   9.3909832E-05
     +,   9.4182622E-05,   9.4434392E-05,   9.4665018E-05
     +,   9.4874311E-05,   9.5062169E-05,   9.5228446E-05
     +,   9.5373027E-05,   9.5495838E-05,   9.5596799E-05
     +,   9.5675867E-05,   9.5732990E-05,   9.5768162E-05
     +,   9.5781405E-05,   9.5772739E-05,   9.5742209E-05
     +,   9.5689909E-05,   9.5615957E-05,   9.5520445E-05
     +,   9.5403571E-05,   9.5265503E-05,   9.5106465E-05
     +,   9.4926683E-05,   9.4726493E-05,   9.4506155E-05
     +,   9.4266034E-05,   9.4006500E-05,   9.3727969E-05
     +,   9.3430892E-05,   9.3115741E-05,   9.2783019E-05
     +,   9.2433278E-05,   9.2067079E-05,   9.1685055E-05
     +,   9.1287831E-05,   9.0876070E-05,   9.0450514E-05
     +,   9.0011825E-05,   8.9560817E-05,   8.9098234E-05
     +,   8.8624933E-05,   8.8141656E-05,   8.7649336E-05
     +,   8.7148808E-05,   8.6640961E-05,   8.6126711E-05
     +,   8.5606953E-05,   8.5082647E-05,   8.4554718E-05
     +,   8.4024134E-05,   8.3491854E-05,   8.2958868E-05
     +,   8.2426166E-05,   8.1894745E-05,   8.1365637E-05
     +,   8.0839862E-05,   8.0318481E-05,   7.9802550E-05
     +,   7.9293211E-05,   7.8791556E-05,   7.8298785E-05
     +,   7.7816097E-05,   7.7344768E-05,   7.6886106E-05
     +,   7.6441560E-05,   7.6012606E-05,   7.5600801E-05
     +,   7.5207841E-05,   7.4835516E-05,   7.4485804E-05
     +,   7.4160751E-05,   7.3862655E-05,   7.3593881E-05
     +,   7.3357092E-05,   7.3155104E-05,   7.2990944E-05
     +,   7.2867857E-05,   7.2789408E-05,   7.2759300E-05
     +,   7.2781593E-05,   7.2860545E-05,   7.3000701E-05
     +,   7.3206851E-05,   7.3484138E-05,   7.3837815E-05
     +,   7.4273499E-05,   7.4796975E-05,   7.5414253E-05
     +,   7.6131510E-05,   7.6955119E-05,   7.7891527E-05
     +,   7.8947342E-05,   8.0129095E-05,   8.1443402E-05
     +,   8.2896797E-05,   8.4495732E-05,   8.6246400E-05
     +,   8.8154862E-05,   9.0226793E-05,   9.2467621E-05
     +,   9.4882191E-05,   9.7474986E-05,   1.0024985E-04
     +,   1.0321016E-04,   1.0635808E-04,   1.0969579E-04
     +,   1.1322419E-04,   1.1694337E-04,   1.2085283E-04
     +,   1.2495050E-04,   1.2923386E-04,   1.3369934E-04
     +,   1.3834203E-04,   1.4315693E-04,   1.4813669E-04
     +,   1.5327393E-04,   1.5855984E-04,   1.6398483E-04
     +,   1.6953859E-04,   1.7520887E-04,   1.8098400E-04
     +,   1.8685062E-04,   1.9279469E-04,   1.9880183E-04
     +,   2.0485620E-04,   2.1094205E-04,   2.1704294E-04
     +,   2.2314151E-04,   2.2922114E-04,   2.3526314E-04
     +,   2.4124970E-04,   2.4716230E-04,   2.5298225E-04
     +,   2.5869068E-04,   2.6426860E-04,   2.6969702E-04
     +,   2.7495687E-04,   2.8002905E-04,   2.8489469E-04
     +,   2.8953498E-04,   2.9393140E-04,   2.9806569E-04
     +,   3.0191996E-04,   3.0547689E-04,   3.0871946E-04
     +,   3.1163151E-04,   3.1419756E-04,   3.1640287E-04
     +,   3.1823374E-04,   3.1967761E-04,   3.2072279E-04
     +,   3.2135923E-04,   3.2157818E-04,   3.2137218E-04
     +,   3.2073568E-04,   3.1966474E-04,   3.1815725E-04
     +,   3.1621289E-04,   3.1383336E-04,   3.1102233E-04
     +,   3.0778564E-04,   3.0413098E-04,   3.0006826E-04
     +,   2.9560924E-04,   2.9076787E-04,   2.8555974E-04
     +,   2.8000260E-04,   2.7411571E-04,   2.6791968E-04
     +,   2.6143738E-04,   2.5469263E-04,   2.4770960E-04
     +,   2.4051443E-04,   2.3313322E-04,   2.2559387E-04
     +,   2.1792347E-04,   2.1014965E-04,   2.0230006E-04
     +,   1.9440200E-04,   1.8648247E-04,   1.7856776E-04
     +,   1.7068336E-04,   1.6285389E-04,   1.5510245E-04
     +,   1.4745194E-04,   1.3992317E-04,   1.3253497E-04
     +,   1.2530554E-04,   1.1825078E-04,   1.1138598E-04
     +,   1.0472375E-04,   9.8275355E-05,   9.2050344E-05
     +,   8.6056600E-05,   8.0300408E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wao_fus_65 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_wao_fus_70(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  2.0592506E-06,   2.1864739E-06
     +,   2.3199327E-06,   2.4598241E-06,   2.6063494E-06
     +,   2.7597089E-06,   2.9201010E-06,   3.0877266E-06
     +,   3.2627840E-06,   3.4454742E-06,   3.6359866E-06
     +,   3.8345192E-06,   4.0412642E-06,   4.2564116E-06
     +,   4.4801482E-06,   4.7126587E-06,   4.9541227E-06
     +,   5.2047185E-06,   5.4646180E-06,   5.7339907E-06
     +,   6.0129992E-06,   6.3018038E-06,   6.6005559E-06
     +,   6.9094121E-06,   7.2285006E-06,   7.5579646E-06
     +,   7.8979319E-06,   8.2485285E-06,   8.6098707E-06
     +,   8.9820660E-06,   9.3652170E-06,   9.7594229E-06
     +,   1.0164770E-05,   1.0581335E-05,   1.1009197E-05
     +,   1.1448418E-05,   1.1899057E-05,   1.2361167E-05
     +,   1.2834794E-05,   1.3319969E-05,   1.3816726E-05
     +,   1.4325101E-05,   1.4845072E-05,   1.5376705E-05
     +,   1.5919959E-05,   1.6474856E-05,   1.7041390E-05
     +,   1.7619543E-05,   1.8209312E-05,   1.8810677E-05
     +,   1.9423616E-05,   2.0048114E-05,   2.0684138E-05
     +,   2.1331667E-05,   2.1990687E-05,   2.2661141E-05
     +,   2.3343015E-05,   2.4036281E-05,   2.4740910E-05
     +,   2.5456869E-05,   2.6184132E-05,   2.6922666E-05
     +,   2.7672437E-05,   2.8433415E-05,   2.9205557E-05
     +,   2.9988829E-05,   3.0783180E-05,   3.1588570E-05
     +,   3.2404925E-05,   3.3232172E-05,   3.4070254E-05
     +,   3.4919045E-05,   3.5778448E-05,   3.6648325E-05
     +,   3.7528531E-05,   3.8418857E-05,   3.9319104E-05
     +,   4.0229024E-05,   4.1148312E-05,   4.2076696E-05
     +,   4.3013777E-05,   4.3959146E-05,   4.4912376E-05
     +,   4.5872879E-05,   4.6840058E-05,   4.7813410E-05
     +,   4.8792113E-05,   4.9775441E-05,   5.0762566E-05
     +,   5.1752606E-05,   5.2744588E-05,   5.3737469E-05
     +,   5.4730172E-05,   5.5721532E-05,   5.6710338E-05
     +,   5.7695303E-05,   5.8675101E-05,   5.9648366E-05
     +,   6.0613667E-05,   6.1569568E-05,   6.2514584E-05
     +,   6.3447231E-05,   6.4366017E-05,   6.5269443E-05
     +,   6.6156012E-05,   6.7024310E-05,   6.7872897E-05
     +,   6.8700465E-05,   6.9505637E-05,   7.0287191E-05
     +,   7.1044102E-05,   7.1775219E-05,   7.2479670E-05
     +,   7.3156654E-05,   7.3805495E-05,   7.4425654E-05
     +,   7.5016760E-05,   7.5578559E-05,   7.6110991E-05
     +,   7.6614138E-05,   7.7088240E-05,   7.7533681E-05
     +,   7.7951045E-05,   7.8340985E-05,   7.8704405E-05
     +,   7.9042256E-05,   7.9355632E-05,   7.9645775E-05
     +,   7.9913989E-05,   8.0161677E-05,   8.0390280E-05
     +,   8.0601349E-05,   8.0796388E-05,   8.0976977E-05
     +,   8.1144652E-05,   8.1300954E-05,   8.1447361E-05
     +,   8.1585284E-05,   8.1716076E-05,   8.1840997E-05
     +,   8.1961174E-05,   8.2077648E-05,   8.2191291E-05
     +,   8.2302860E-05,   8.2412953E-05,   8.2522041E-05
     +,   8.2630380E-05,   8.2738145E-05,   8.2845305E-05
     +,   8.2951708E-05,   8.3057079E-05,   8.3160994E-05
     +,   8.3262967E-05,   8.3362422E-05,   8.3458719E-05
     +,   8.3551211E-05,   8.3639272E-05,   8.3722349E-05
     +,   8.3800027E-05,   8.3871972E-05,   8.3938205E-05
     +,   8.3998952E-05,   8.4054875E-05,   8.4107043E-05
     +,   8.4157044E-05,   8.4207095E-05,   8.4260042E-05
     +,   8.4319538E-05,   8.4390020E-05,   8.4476771E-05
     +,   8.4586012E-05,   8.4724881E-05,   8.4901440E-05
     +,   8.5124666E-05,   8.5404368E-05,   8.5751111E-05
     +,   8.6176093E-05,   8.6690961E-05,   8.7307715E-05
     +,   8.8038345E-05,   8.8894667E-05,   8.9888046E-05
     +,   9.1029011E-05,   9.2327158E-05,   9.3790673E-05
     +,   9.5426163E-05,   9.7238473E-05,   9.9230492E-05
     +,   1.0140301E-04,   1.0375489E-04,   1.0628301E-04
     +,   1.0898258E-04,   1.1184744E-04,   1.1487061E-04
     +,   1.1804476E-04,   1.2136295E-04,   1.2481949E-04
     +,   1.2841055E-04,   1.3213535E-04,   1.3599666E-04
     +,   1.4000179E-04,   1.4416322E-04,   1.4849899E-04
     +,   1.5303322E-04,   1.5779590E-04,   1.6282273E-04
     +,   1.6815453E-04,   1.7383636E-04,   1.7991618E-04
     +,   1.8644365E-04,   1.9346681E-04,   2.0103290E-04
     +,   2.0918349E-04,   2.1795335E-04,   2.2736882E-04
     +,   2.3744395E-04,   2.4818128E-04,   2.5956903E-04
     +,   2.7157977E-04,   2.8417332E-04,   2.9729120E-04
     +,   3.1086305E-04,   3.2480518E-04,   3.3902325E-04
     +,   3.5341515E-04,   3.6787058E-04,   3.8227998E-04
     +,   3.9653137E-04,   4.1051611E-04,   4.2413117E-04
     +,   4.3727944E-04,   4.4987397E-04,   4.6183719E-04
     +,   4.7310125E-04,   4.8361006E-04,   4.9331383E-04
     +,   5.0217268E-04,   5.1015272E-04,   5.1722460E-04
     +,   5.2336196E-04,   5.2854000E-04,   5.3273392E-04
     +,   5.3591817E-04,   5.3806638E-04,   5.3915102E-04
     +,   5.3914532E-04,   5.3802325E-04,   5.3576194E-04
     +,   5.3234398E-04,   5.2775920E-04,   5.2200700E-04
     +,   5.1509828E-04,   5.0705741E-04,   4.9792294E-04
     +,   4.8774839E-04,   4.7660226E-04,   4.6456666E-04
     +,   4.5173717E-04,   4.3821943E-04,   4.2412733E-04
     +,   4.0958056E-04,   3.9470039E-04,   3.7960790E-04
     +,   3.6442009E-04,   3.4924757E-04,   3.3419230E-04
     +,   3.1934501E-04,   3.0478474E-04,   2.9057721E-04
     +,   2.7677551E-04,   2.6341889E-04,   2.5053468E-04
     +,   2.3813870E-04,   2.2623688E-04,   2.1482602E-04
     +,   2.0389754E-04,   1.9343634E-04,   1.8342305E-04
     +,   1.7383709E-04,   1.6465629E-04,   1.5585932E-04
     +,   1.4742484E-04,   1.3933334E-04,   1.3156715E-04
     +,   1.2411087E-04,   1.1695128E-04,   1.1007737E-04
     +,   1.0347997E-04,   9.7151751E-05,   9.1086476E-05
     +,   8.5279789E-05,   7.9727572E-05,   7.4425770E-05
     +,   6.9371206E-05,   6.4560241E-05,   5.9989590E-05
     +,   5.5655091E-05,   5.1552226E-05,   4.7676011E-05
     +,   4.4020926E-05,   4.0580911E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wao_fus_70 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_wao_fus_75(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  1.4354291E-16,   2.1106595E-16
     +,   3.0948157E-16,   4.5251099E-16,   6.5978705E-16
     +,   9.5930462E-16,   1.3908774E-15,   2.0109416E-15
     +,   2.8992813E-15,   4.1683436E-15,   5.9760364E-15
     +,   8.5436292E-15,   1.2180103E-14,   1.7315693E-14
     +,   2.4547572E-14,   3.4702181E-14,   4.8919978E-14
     +,   6.8769433E-14,   9.6401816E-14,   1.3475827E-13
     +,   1.8784829E-13,   2.6112020E-13,   3.6195526E-13
     +,   5.0032716E-13,   6.8965455E-13,   9.4796339E-13
     +,   1.2993743E-12,   1.7760677E-12,   2.4208515E-12
     +,   3.2904851E-12,   4.4600079E-12,   6.0283107E-12
     +,   8.1253103E-12,   1.0921181E-11,   1.4638069E-11
     +,   1.9565221E-11,   2.6077843E-11,   3.4661371E-11
     +,   4.5941695E-11,   6.0723392E-11,   8.0037449E-11
     +,   1.0520158E-10,   1.3789110E-10,   1.8023756E-10
     +,   2.3493210E-10,   3.0537389E-10,   3.9583406E-10
     +,   5.1166738E-10,   6.5956290E-10,   8.4785073E-10
     +,   1.0868709E-09,   1.3894178E-09,   1.7712728E-09
     +,   2.2518316E-09,   2.8548783E-09,   3.6094197E-09
     +,   4.5508064E-09,   5.7219163E-09,   7.1746067E-09
     +,   8.9713694E-09,   1.1187299E-08,   1.3912284E-08
     +,   1.7253589E-08,   2.1338805E-08,   2.6319084E-08
     +,   3.2373059E-08,   3.9710912E-08,   4.8579214E-08
     +,   5.9266206E-08,   7.2107731E-08,   8.7493390E-08
     +,   1.0587407E-07,   1.2776927E-07,   1.5377542E-07
     +,   1.8457581E-07,   2.2094720E-07,   2.6377361E-07
     +,   3.1405474E-07,   3.7291562E-07,   4.4162371E-07
     +,   5.2159203E-07,   6.1439596E-07,   7.2178767E-07
     +,   8.4568927E-07,   9.8822193E-07,   1.1517312E-06
     +,   1.3387353E-06,   1.5519951E-06,   1.7944872E-06
     +,   2.0694129E-06,   2.3801988E-06,   2.7304941E-06
     +,   3.1241643E-06,   3.5652783E-06,   4.0581021E-06
     +,   4.6070741E-06,   5.2167852E-06,   5.8919513E-06
     +,   6.6373818E-06,   7.4579411E-06,   8.3585073E-06
     +,   9.3439248E-06,   1.0418951E-05,   1.1588203E-05
     +,   1.2856096E-05,   1.4226771E-05,   1.5704050E-05
     +,   1.7291406E-05,   1.8991641E-05,   2.0807140E-05
     +,   2.2739912E-05,   2.4790821E-05,   2.6960282E-05
     +,   2.9247849E-05,   3.1652191E-05,   3.4171073E-05
     +,   3.6801317E-05,   3.9538751E-05,   4.2378218E-05
     +,   4.5313551E-05,   4.8337584E-05,   5.1442174E-05
     +,   5.4618242E-05,   5.7855821E-05,   6.1144121E-05
     +,   6.4471606E-05,   6.7826120E-05,   7.1194954E-05
     +,   7.4565025E-05,   7.7922981E-05,   8.1255384E-05
     +,   8.4548832E-05,   8.7790177E-05,   9.0966641E-05
     +,   9.4066076E-05,   9.7077027E-05,   9.9989018E-05
     +,   1.0279263E-04,   1.0547967E-04,   1.0804333E-04
     +,   1.1047821E-04,   1.1278054E-04,   1.1494809E-04
     +,   1.1698026E-04,   1.1887807E-04,   1.2064413E-04
     +,   1.2228223E-04,   1.2379799E-04,   1.2519768E-04
     +,   1.2648871E-04,   1.2767919E-04,   1.2877762E-04
     +,   1.2979261E-04,   1.3073265E-04,   1.3160564E-04
     +,   1.3241885E-04,   1.3317837E-04,   1.3388912E-04
     +,   1.3455449E-04,   1.3517638E-04,   1.3575505E-04
     +,   1.3628929E-04,   1.3677654E-04,   1.3721318E-04
     +,   1.3759507E-04,   1.3791796E-04,   1.3817834E-04
     +,   1.3837406E-04,   1.3850548E-04,   1.3857622E-04
     +,   1.3859432E-04,   1.3857326E-04,   1.3853297E-04
     +,   1.3850065E-04,   1.3851152E-04,   1.3860929E-04
     +,   1.3884643E-04,   1.3928382E-04,   1.3999038E-04
     +,   1.4104188E-04,   1.4251957E-04,   1.4450832E-04
     +,   1.4709431E-04,   1.5036242E-04,   1.5439361E-04
     +,   1.5926191E-04,   1.6503198E-04,   1.7175628E-04
     +,   1.7947347E-04,   1.8820653E-04,   1.9796196E-04
     +,   2.0872979E-04,   2.2048355E-04,   2.3318175E-04
     +,   2.4676873E-04,   2.6117678E-04,   2.7632740E-04
     +,   2.9213258E-04,   3.0849621E-04,   3.2531423E-04
     +,   3.4247452E-04,   3.5985644E-04,   3.7733006E-04
     +,   3.9475501E-04,   4.1198058E-04,   4.2884584E-04
     +,   4.4518188E-04,   4.6081530E-04,   4.7557382E-04
     +,   4.8929505E-04,   5.0183269E-04,   5.1307445E-04
     +,   5.2294723E-04,   5.3143164E-04,   5.3857145E-04
     +,   5.4447888E-04,   5.4933719E-04,   5.5339705E-04
     +,   5.5696431E-04,   5.6038349E-04,   5.6401175E-04
     +,   5.6819007E-04,   5.7320995E-04,   5.7927921E-04
     +,   5.8649294E-04,   5.9480697E-04,   6.0402905E-04
     +,   6.1381486E-04,   6.2368647E-04,   6.3306233E-04
     +,   6.4130320E-04,   6.4777111E-04,   6.5189332E-04
     +,   6.5322756E-04,   6.5152091E-04,   6.4675743E-04
     +,   6.3918659E-04,   6.2932790E-04,   6.1795325E-04
     +,   6.0604332E-04,   5.9472362E-04,   5.8518391E-04
     +,   5.7859044E-04,   5.7599507E-04,   5.7825184E-04
     +,   5.8594899E-04,   5.9935777E-04,   6.1840611E-04
     +,   6.4267614E-04,   6.7142508E-04,   7.0362887E-04
     +,   7.3804037E-04,   7.7326363E-04,   8.0783101E-04
     +,   8.4028422E-04,   8.6925161E-04,   8.9351536E-04
     +,   9.1206731E-04,   9.2415081E-04,   9.2928356E-04
     +,   9.2726678E-04,   9.1817311E-04,   9.0232381E-04
     +,   8.8025228E-04,   8.5265742E-04,   8.2035584E-04
     +,   7.8422739E-04,   7.4516941E-04,   7.0405175E-04
     +,   6.6168309E-04,   6.1878545E-04,   5.7597773E-04
     +,   5.3377118E-04,   4.9257034E-04,   4.5268034E-04
     +,   4.1432626E-04,   3.7766036E-04,   3.4277758E-04
     +,   3.0973853E-04,   2.7857421E-04,   2.4930225E-04
     +,   2.2192566E-04,   1.9644204E-04,   1.7284324E-04
     +,   1.5111505E-04,   1.3123536E-04,   1.1317227E-04
     +,   9.6881835E-05,   8.2306891E-05,   6.9375885E-05
     +,   5.8005291E-05,   4.8098085E-05,   3.9546478E-05
     +,   3.2236454E-05,   2.6048863E-05,   2.0863918E-05
     +,   1.6562612E-05,   1.3030449E-05,   1.0159345E-05
     +,   7.8493149E-06,   6.0096095E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wao_fus_75 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_wao_fus_80(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  2.0757173E-20,   3.1167697E-20
     +,   4.6686804E-20,   6.9765376E-20,   1.0400127E-19
     +,   1.5466498E-19,   2.2945716E-19,   3.3959722E-19
     +,   5.0139749E-19,   7.3851300E-19,   1.0851369E-18
     +,   1.5906169E-18,   2.3259595E-18,   3.3930734E-18
     +,   4.9378625E-18,   7.1686698E-18,   1.0382281E-17
     +,   1.5000383E-17,   2.1620542E-17,   3.1087413E-17
     +,   4.4592030E-17,   6.3809374E-17,   9.1089281E-17
     +,   1.2972005E-16,   1.8428884E-16,   2.6118295E-16
     +,   3.6927097E-16,   5.2083505E-16,   7.3284242E-16
     +,   1.0286671E-15,   1.4404350E-15,   2.0121816E-15
     +,   2.8041117E-15,   3.8983247E-15,   5.4064999E-15
     +,   7.4801132E-15,   1.0324160E-14,   1.4215297E-14
     +,   1.9525931E-14,   2.6756061E-14,   3.6575320E-14
     +,   4.9878145E-14,   6.7855037E-14,   9.2090222E-14
     +,   1.2468009E-13,   1.6839736E-13,   2.2689663E-13
     +,   3.0498290E-13,   4.0895686E-13,   5.4705903E-13
     +,   7.3003794E-13,   9.7187536E-13,   1.2907171E-12
     +,   1.7100396E-12,   2.2601560E-12,   2.9800450E-12
     +,   3.9197816E-12,   5.1434568E-12,   6.7329172E-12
     +,   8.7923661E-12,   1.1454137E-11,   1.4885881E-11
     +,   1.9299269E-11,   2.4961016E-11,   3.2206075E-11
     +,   4.1454184E-11,   5.3229598E-11,   6.8185527E-11
     +,   8.7133800E-11,   1.1107985E-10,   1.4126644E-10
     +,   1.7922416E-10,   2.2683447E-10,   2.8640210E-10
     +,   3.6074477E-10,   4.5329032E-10,   5.6820804E-10
     +,   7.1054673E-10,   8.8640306E-10,   1.1031275E-09
     +,   1.3695414E-09,   1.6962072E-09,   2.0957593E-09
     +,   2.5831806E-09,   3.1762786E-09,   3.8962327E-09
     +,   4.7678403E-09,   5.8204095E-09,   7.0882602E-09
     +,   8.6115337E-09,   1.0437002E-08,   1.2619028E-08
     +,   1.5220554E-08,   1.8314271E-08,   2.1983842E-08
     +,   2.6325218E-08,   3.1448145E-08,   3.7477676E-08
     +,   4.4555890E-08,   5.2843554E-08,   6.2522062E-08
     +,   7.3795420E-08,   8.6892079E-08,   1.0206705E-07
     +,   1.1960390E-07,   1.3981699E-07,   1.6305316E-07
     +,   1.8969489E-07,   2.2015782E-07,   2.5489678E-07
     +,   2.9441142E-07,   3.3923206E-07,   3.8993633E-07
     +,   4.4714187E-07,   5.1150710E-07,   5.8373098E-07
     +,   6.6455129E-07,   7.5474333E-07,   8.5511584E-07
     +,   9.6650899E-07,   1.0897878E-06,   1.2258398E-06
     +,   1.3755655E-06,   1.5398747E-06,   1.7196742E-06
     +,   1.9158640E-06,   2.1293249E-06,   2.3609077E-06
     +,   2.6114265E-06,   2.8816435E-06,   3.1722630E-06
     +,   3.4839186E-06,   3.8171665E-06,   4.1724770E-06
     +,   4.5502311E-06,   4.9507198E-06,   5.3741410E-06
     +,   5.8206142E-06,   6.2901900E-06,   6.7828705E-06
     +,   7.2986422E-06,   7.8375124E-06,   8.3995610E-06
     +,   8.9850082E-06,   9.5942878E-06,   1.0228175E-05
     +,   1.0887755E-05,   1.1574856E-05,   1.2291803E-05
     +,   1.3041887E-05,   1.3829399E-05,   1.4659844E-05
     +,   1.5540132E-05,   1.6478782E-05,   1.7486098E-05
     +,   1.8574348E-05,   1.9757932E-05,   2.1053496E-05
     +,   2.2480010E-05,   2.4058772E-05,   2.5813413E-05
     +,   2.7769742E-05,   2.9955583E-05,   3.2400538E-05
     +,   3.5135632E-05,   3.8193011E-05,   4.1605526E-05
     +,   4.5406370E-05,   4.9628768E-05,   5.4305936E-05
     +,   5.9470145E-05,   6.5153923E-05,   7.1389179E-05
     +,   7.8208781E-05,   8.5645661E-05,   9.3732953E-05
     +,   1.0250593E-04,   1.1200071E-04,   1.2225409E-04
     +,   1.3330240E-04,   1.4517969E-04,   1.5791462E-04
     +,   1.7152687E-04,   1.8602243E-04,   2.0138874E-04
     +,   2.1758942E-04,   2.3456042E-04,   2.5220693E-04
     +,   2.7040404E-04,   2.8899955E-04,   3.0782205E-04
     +,   3.2669306E-04,   3.4544274E-04,   3.6393019E-04
     +,   3.8206371E-04,   3.9982100E-04,   4.1726491E-04
     +,   4.3455200E-04,   4.5193054E-04,   4.6972698E-04
     +,   4.8831687E-04,   5.0808617E-04,   5.2938034E-04
     +,   5.5244990E-04,   5.7739636E-04,   6.0412701E-04
     +,   6.3232356E-04,   6.6143280E-04,   6.9067971E-04
     +,   7.1910809E-04,   7.4563833E-04,   7.6916290E-04
     +,   7.8863290E-04,   8.0317364E-04,   8.1219437E-04
     +,   8.1549241E-04,   8.1334589E-04,   8.0657442E-04
     +,   7.9656008E-04,   7.8521005E-04,   7.7485340E-04
     +,   7.6805265E-04,   7.6735439E-04,   7.7498698E-04
     +,   7.9255446E-04,   8.2077243E-04,   8.5932005E-04
     +,   9.0682635E-04,   9.6104504E-04,   1.0191841E-03
     +,   1.0783356E-03,   1.1359503E-03,   1.1902160E-03
     +,   1.2402779E-03,   1.2862483E-03,   1.3289551E-03
     +,   1.3695539E-03,   1.4090247E-03,   1.4477216E-03
     +,   1.4850677E-03,   1.5194870E-03,   1.5485849E-03
     +,   1.5695345E-03,   1.5796046E-03,   1.5766768E-03
     +,   1.5596939E-03,   1.5289407E-03,   1.4861226E-03
     +,   1.4342584E-03,   1.3773986E-03,   1.3202040E-03
     +,   1.2674202E-03,   1.2233085E-03,   1.1910878E-03
     +,   1.1724669E-03,   1.1673613E-03,   1.1738585E-03
     +,   1.1884577E-03,   1.2065703E-03,   1.2231886E-03
     +,   1.2336092E-03,   1.2340808E-03,   1.2222652E-03
     +,   1.1974415E-03,   1.1604469E-03,   1.1133839E-03
     +,   1.0591774E-03,   1.0010656E-03,   9.4212143E-04
     +,   8.8487065E-04,   8.3105371E-04,   7.8154937E-04
     +,   7.3644036E-04,   6.9519045E-04,   6.5688172E-04
     +,   6.2047213E-04,   5.8500323E-04,   5.4975803E-04
     +,   5.1434524E-04,   4.7869812E-04,   4.4302782E-04
     +,   4.0772662E-04,   3.7327316E-04,   3.4013923E-04
     +,   3.0871961E-04,   2.7929255E-04,   2.5200576E-04
     +,   2.2688709E-04,   2.0386903E-04,   1.8281977E-04
     +,   1.6357783E-04,   1.4597396E-04,   1.2985028E-04
     +,   1.1507450E-04,   1.0153950E-04,   8.9164379E-05
     +,   7.7885670E-05,   6.7653142E-05,   5.8422509E-05
     +,   5.0150324E-05,   4.2790194E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wao_fus_80 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_wao_fus_85(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  1.2985668E-19,   1.9234398E-19
     +,   2.8422629E-19,   4.1900723E-19,   6.1624092E-19
     +,   9.0417510E-19,   1.3235115E-18,   1.9327462E-18
     +,   2.8157662E-18,   4.0925600E-18,   5.9342127E-18
     +,   8.5843381E-18,   1.2388677E-17,   1.7836836E-17
     +,   2.5620445E-17,   3.6713948E-17,   5.2486962E-17
     +,   7.4859998E-17,   1.0651827E-16,   1.5120862E-16
     +,   2.1414436E-16,   3.0256290E-16,   4.2648461E-16
     +,   5.9975555E-16,   8.4143517E-16,   1.1777360E-15
     +,   1.6445896E-15,   2.2911136E-15,   3.1843369E-15
     +,   4.4154447E-15,   6.1081824E-15,   8.4301013E-15
     +,   1.1607494E-14,   1.5945214E-14,   2.1852769E-14
     +,   2.9879219E-14,   4.0758517E-14,   5.5469531E-14
     +,   7.5314585E-14,   1.0202136E-13,   1.3787762E-13
     +,   1.8590426E-13,   2.5007489E-13,   3.3561847E-13
     +,   4.4937863E-13,   6.0030377E-13,   8.0006016E-13
     +,   1.0638192E-12,   1.4112657E-12,   1.8678579E-12
     +,   2.4664643E-12,   3.2493999E-12,   4.2709850E-12
     +,   5.6008093E-12,   7.3278163E-12,   9.5652219E-12
     +,   1.2457052E-11,   1.6185865E-11,   2.0982499E-11
     +,   2.7138137E-11,   3.5019133E-11,   4.5085078E-11
     +,   5.7911415E-11,   7.4216175E-11,   9.4893829E-11
     +,   1.2105461E-10,   1.5407407E-10,   1.9565195E-10
     +,   2.4788172E-10,   3.1333641E-10,   3.9517045E-10
     +,   4.9723886E-10,   6.2424171E-10,   7.8189438E-10
     +,   9.7713238E-10,   1.2183298E-09,   1.5155996E-09
     +,   1.8811011E-09,   2.3294144E-09,   2.8780058E-09
     +,   3.5476864E-09,   4.3632218E-09,   5.3540443E-09
     +,   6.5548234E-09,   8.0065403E-09,   9.7576374E-09
     +,   1.1864481E-08,   1.4393307E-08,   1.7421298E-08
     +,   2.1038170E-08,   2.5347928E-08,   3.0470829E-08
     +,   3.6545394E-08,   4.3730822E-08,   5.2209380E-08
     +,   6.2189272E-08,   7.3907344E-08,   8.7632486E-08
     +,   1.0366867E-07,   1.2235866E-07,   1.4408742E-07
     +,   1.6928632E-07,   1.9843641E-07,   2.3207313E-07
     +,   2.7078966E-07,   3.1524110E-07,   3.6614873E-07
     +,   4.2430557E-07,   4.9057013E-07,   5.6588146E-07
     +,   6.5126818E-07,   7.4781957E-07,   8.5672178E-07
     +,   9.7924101E-07,   1.1167275E-06,   1.2706139E-06
     +,   1.4424147E-06,   1.6337219E-06,   1.8462024E-06
     +,   2.0815919E-06,   2.3416865E-06,   2.6283392E-06
     +,   2.9434423E-06,   3.2889261E-06,   3.6667373E-06
     +,   4.0788318E-06,   4.5271536E-06,   5.0136241E-06
     +,   5.5401156E-06,   6.1084424E-06,   6.7203305E-06
     +,   7.3774031E-06,   8.0811551E-06,   8.8329307E-06
     +,   9.6339045E-06,   1.0485051E-05,   1.1387127E-05
     +,   1.2340647E-05,   1.3345866E-05,   1.4402751E-05
     +,   1.5510965E-05,   1.6669857E-05,   1.7878443E-05
     +,   1.9135397E-05,   2.0439042E-05,   2.1787420E-05
     +,   2.3178007E-05,   2.4608378E-05,   2.6075404E-05
     +,   2.7575967E-05,   2.9106715E-05,   3.0664229E-05
     +,   3.2245101E-05,   3.3846092E-05,   3.5464316E-05
     +,   3.7097412E-05,   3.8743830E-05,   4.0403072E-05
     +,   4.2076066E-05,   4.3765493E-05,   4.5476187E-05
     +,   4.7215603E-05,   4.8994181E-05,   5.0825849E-05
     +,   5.2728392E-05,   5.4723852E-05,   5.6838759E-05
     +,   5.9104317E-05,   6.1556493E-05,   6.4235814E-05
     +,   6.7186636E-05,   7.0457158E-05,   7.4097865E-05
     +,   7.8161116E-05,   8.2698913E-05,   8.7761116E-05
     +,   9.3394454E-05,   9.9639808E-05,   1.0653056E-04
     +,   1.1409070E-04,   1.2233357E-04,   1.3126121E-04
     +,   1.4086474E-04,   1.5112595E-04,   1.6202056E-04
     +,   1.7352318E-04,   1.8561409E-04,   1.9828715E-04
     +,   2.1155890E-04,   2.2547720E-04,   2.4012853E-04
     +,   2.5564258E-04,   2.7219314E-04,   2.8999514E-04
     +,   3.0929930E-04,   3.3038660E-04,   3.5356771E-04
     +,   3.7919218E-04,   4.0767176E-04,   4.3951845E-04
     +,   4.7539128E-04,   5.1613717E-04,   5.6280027E-04
     +,   6.1657128E-04,   6.7865092E-04,   7.5001788E-04
     +,   8.3112548E-04,   9.2158618E-04,   1.0199458E-03
     +,   1.1236600E-03,   1.2293317E-03,   1.3333395E-03
     +,   1.4326377E-03,   1.5257155E-03,   1.6133861E-03
     +,   1.6991160E-03,   1.7887008E-03,   1.8891016E-03
     +,   2.0065806E-03,   2.1445414E-03,   2.3015889E-03
     +,   2.4706640E-03,   2.6395961E-03,   2.7931766E-03
     +,   2.9162255E-03,   2.9966703E-03,   3.0277723E-03
     +,   3.0088197E-03,   2.9444960E-03,   2.8434405E-03
     +,   2.7167206E-03,   2.5765891E-03,   2.4356053E-03
     +,   2.3057258E-03,   2.1971483E-03,   2.1169749E-03
     +,   2.0679610E-03,   2.0480147E-03,   2.0507372E-03
     +,   2.0670486E-03,   2.0874576E-03,   2.1042812E-03
     +,   2.1131756E-03,   2.1135514E-03,   2.1078929E-03
     +,   2.1003056E-03,   2.0948104E-03,   2.0938513E-03
     +,   2.0973959E-03,   2.1028058E-03,   2.1054363E-03
     +,   2.0998074E-03,   2.0810184E-03,   2.0460226E-03
     +,   1.9944329E-03,   1.9286131E-03,   1.8530732E-03
     +,   1.7733537E-03,   1.6947461E-03,   1.6212162E-03
     +,   1.5547950E-03,   1.4955217E-03,   1.4418730E-03
     +,   1.3914686E-03,   1.3418110E-03,   1.2908835E-03
     +,   1.2374818E-03,   1.1812907E-03,   1.1227480E-03
     +,   1.0627998E-03,   1.0026299E-03,   9.4342395E-04
     +,   8.8620157E-04,   8.3172094E-04,   7.8044180E-04
     +,   7.3254691E-04,   6.8797224E-04,   6.4646703E-04
     +,   6.0766796E-04,   5.7115447E-04,   5.3651247E-04
     +,   5.0336868E-04,   4.7142577E-04,   4.4047431E-04
     +,   4.1039262E-04,   3.8113765E-04,   3.5272900E-04
     +,   3.2523117E-04,   2.9873522E-04,   2.7334265E-04
     +,   2.4915618E-04,   2.2626518E-04,   2.0473928E-04
     +,   1.8462887E-04,   1.6595853E-04,   1.4873102E-04
     +,   1.3292403E-04,   1.1849571E-04,   1.0538725E-04
     +,   9.3526774E-05,   8.2833125E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wao_fus_85 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_wao_fus_90(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  5.1830273E-11,   6.3136267E-11
     +,   7.6799692E-11,   9.3287489E-11,   1.1315365E-10
     +,   1.3705446E-10,   1.6576589E-10,   2.0020402E-10
     +,   2.4144883E-10,   2.9077160E-10,   3.4966172E-10
     +,   4.1986942E-10,   5.0344107E-10,   6.0276883E-10
     +,   7.2064049E-10,   8.6030327E-10,   1.0255298E-09
     +,   1.2206962E-09,   1.4508713E-09,   1.7219116E-09
     +,   2.0405762E-09,   2.4146465E-09,   2.8530731E-09
     +,   3.3661294E-09,   3.9655572E-09,   4.6648085E-09
     +,   5.4792175E-09,   6.4262573E-09,   7.5257836E-09
     +,   8.8003382E-09,   1.0275431E-08,   1.1979904E-08
     +,   1.3946295E-08,   1.6211244E-08,   1.8815909E-08
     +,   2.1806450E-08,   2.5234547E-08,   2.9157912E-08
     +,   3.3640877E-08,   3.8755051E-08,   4.4579878E-08
     +,   5.1203553E-08,   5.8722943E-08,   6.7246134E-08
     +,   7.6890814E-08,   8.7787036E-08,   1.0007719E-07
     +,   1.1391693E-07,   1.2947631E-07,   1.4694021E-07
     +,   1.6650974E-07,   1.8840277E-07,   2.1285479E-07
     +,   2.4011993E-07,   2.7047236E-07,   3.0420441E-07
     +,   3.4163077E-07,   3.8308721E-07,   4.2893126E-07
     +,   4.7954273E-07,   5.3532381E-07,   5.9669986E-07
     +,   6.6411855E-07,   7.3805035E-07,   8.1898770E-07
     +,   9.0744442E-07,   1.0039554E-06,   1.1090752E-06
     +,   1.2233770E-06,   1.3474499E-06,   1.4818993E-06
     +,   1.6273428E-06,   1.7844083E-06,   1.9537317E-06
     +,   2.1359579E-06,   2.3317207E-06,   2.5416639E-06
     +,   2.7664209E-06,   3.0066105E-06,   3.2628504E-06
     +,   3.5357261E-06,   3.8258027E-06,   4.1336280E-06
     +,   4.4596800E-06,   4.8044153E-06,   5.1682969E-06
     +,   5.5516471E-06,   5.9547897E-06,   6.3779753E-06
     +,   6.8213867E-06,   7.2851385E-06,   7.7692684E-06
     +,   8.2737306E-06,   8.7984026E-06,   9.3430699E-06
     +,   9.9074296E-06,   1.0491088E-05,   1.1093554E-05
     +,   1.1714246E-05,   1.2352481E-05,   1.3007484E-05
     +,   1.3678390E-05,   1.4364235E-05,   1.5063970E-05
     +,   1.5776457E-05,   1.6500484E-05,   1.7234755E-05
     +,   1.7977944E-05,   1.8728557E-05,   1.9485113E-05
     +,   2.0246182E-05,   2.1010097E-05,   2.1775299E-05
     +,   2.2540164E-05,   2.3303075E-05,   2.4062401E-05
     +,   2.4816531E-05,   2.5563872E-05,   2.6302865E-05
     +,   2.7031998E-05,   2.7749800E-05,   2.8454881E-05
     +,   2.9145909E-05,   2.9821644E-05,   3.0480929E-05
     +,   3.1122705E-05,   3.1746025E-05,   3.2350039E-05
     +,   3.2934033E-05,   3.3497392E-05,   3.4039629E-05
     +,   3.4560402E-05,   3.5059478E-05,   3.5536748E-05
     +,   3.5992234E-05,   3.6426096E-05,   3.6838610E-05
     +,   3.7230158E-05,   3.7601254E-05,   3.7952523E-05
     +,   3.8284696E-05,   3.8598591E-05,   3.8895130E-05
     +,   3.9175324E-05,   3.9440263E-05,   3.9691095E-05
     +,   3.9929015E-05,   4.0155322E-05,   4.0371309E-05
     +,   4.0578310E-05,   4.0777697E-05,   4.0970823E-05
     +,   4.1159066E-05,   4.1343770E-05,   4.1526269E-05
     +,   4.1707834E-05,   4.1889714E-05,   4.2073061E-05
     +,   4.2258991E-05,   4.2448493E-05,   4.2642529E-05
     +,   4.2841908E-05,   4.3047399E-05,   4.3259697E-05
     +,   4.3479427E-05,   4.3707230E-05,   4.3943786E-05
     +,   4.4189899E-05,   4.4446613E-05,   4.4715314E-05
     +,   4.4997923E-05,   4.5297089E-05,   4.5616438E-05
     +,   4.5960900E-05,   4.6336972E-05,   4.6753084E-05
     +,   4.7220081E-05,   4.7751560E-05,   4.8364309E-05
     +,   4.9078739E-05,   4.9919174E-05,   5.0914219E-05
     +,   5.2096930E-05,   5.3504951E-05,   5.5180564E-05
     +,   5.7170699E-05,   5.9527116E-05,   6.2306935E-05
     +,   6.5573891E-05,   6.9400936E-05,   7.3874922E-05
     +,   7.9104342E-05,   8.5231113E-05,   9.2447663E-05
     +,   1.0101929E-04,   1.1131208E-04,   1.2382453E-04
     +,   1.3921934E-04,   1.5835125E-04,   1.8228494E-04
     +,   2.1229820E-04,   2.4986797E-04,   2.9663942E-04
     +,   3.5438227E-04,   4.2493679E-04,   5.1014865E-04
     +,   6.1178347E-04,   7.3140051E-04,   8.7016652E-04
     +,   1.0286206E-03,   1.2063836E-03,   1.4020910E-03
     +,   1.6134839E-03,   1.8380965E-03,   2.0744635E-03
     +,   2.3236137E-03,   2.5904370E-03,   2.8840087E-03
     +,   3.2163279E-03,   3.5991017E-03,   4.0383129E-03
     +,   4.5277467E-03,   5.0431178E-03,   5.5410699E-03
     +,   5.9672068E-03,   6.2735570E-03,   6.4397324E-03
     +,   6.4859050E-03,   6.4691273E-03,   6.4624404E-03
     +,   6.5271594E-03,   6.6923127E-03,   6.9507225E-03
     +,   7.2707329E-03,   7.6134880E-03,   7.9434402E-03
     +,   8.2277786E-03,   8.4312009E-03,   8.5184723E-03
     +,   8.4684109E-03,   8.2882596E-03,   8.0135372E-03
     +,   7.6920316E-03,   7.3656552E-03,   7.0618414E-03
     +,   6.7922049E-03,   6.5516243E-03,   6.3197864E-03
     +,   6.0715294E-03,   5.7934155E-03,   5.4945946E-03
     +,   5.2034361E-03,   4.9532349E-03,   4.7669210E-03
     +,   4.6481444E-03,   4.5809131E-03,   4.5362250E-03
     +,   4.4828057E-03,   4.3978519E-03,   4.2733299E-03
     +,   4.1152416E-03,   3.9368612E-03,   3.7500218E-03
     +,   3.5592825E-03,   3.3614312E-03,   3.1495842E-03
     +,   2.9188166E-03,   2.6701489E-03,   2.4113264E-03
     +,   2.1546350E-03,   1.9133427E-03,   1.6984087E-03
     +,   1.5165036E-03,   1.3695741E-03,   1.2555735E-03
     +,   1.1697847E-03,   1.1061524E-03,   1.0583953E-03
     +,   1.0207571E-03,   9.8840729E-04,   9.5761183E-04
     +,   9.2572771E-04,   8.9110632E-04,   8.5293496E-04
     +,   8.1105571E-04,   7.6578249E-04,   7.1773748E-04
     +,   6.6771387E-04,   6.1657059E-04,   5.6515558E-04
     +,   5.1426492E-04,   4.6460168E-04,   4.1676080E-04
     +,   3.7123243E-04,   3.2839191E-04,   2.8851267E-04
     +,   2.5176344E-04,   2.1822499E-04,   1.8789922E-04
     +,   1.6072202E-04,   1.3657537E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wao_fus_90 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_wao_fus_95(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  2.1169342E-09,   2.4088234E-09
     +,   2.7381977E-09,   3.1094698E-09,   3.5275292E-09
     +,   3.9977590E-09,   4.5261035E-09,   5.1191136E-09
     +,   5.7839804E-09,   6.5286310E-09,   7.3617086E-09
     +,   8.2927230E-09,   9.3320578E-09,   1.0491076E-08
     +,   1.1782155E-08,   1.3218776E-08,   1.4815627E-08
     +,   1.6588647E-08,   1.8555120E-08,   2.0733795E-08
     +,   2.3144928E-08,   2.5810417E-08,   2.8753853E-08
     +,   3.2000763E-08,   3.5578331E-08,   3.9515989E-08
     +,   4.3845247E-08,   4.8599745E-08,   5.3815540E-08
     +,   5.9531008E-08,   6.5787127E-08,   7.2627422E-08
     +,   8.0098175E-08,   8.8248342E-08,   9.7129806E-08
     +,   1.0679736E-07,   1.1730889E-07,   1.2872506E-07
     +,   1.4110985E-07,   1.5453034E-07,   1.6905659E-07
     +,   1.8476238E-07,   2.0172295E-07,   2.2001926E-07
     +,   2.3973277E-07,   2.6094932E-07,   2.8375732E-07
     +,   3.0824773E-07,   3.3451451E-07,   3.6265359E-07
     +,   3.9276352E-07,   4.2494469E-07,   4.5929909E-07
     +,   4.9593064E-07,   5.3494495E-07,   5.7644593E-07
     +,   6.2054050E-07,   6.6733475E-07,   7.1693438E-07
     +,   7.6944423E-07,   8.2496786E-07,   8.8360650E-07
     +,   9.4545936E-07,   1.0106223E-06,   1.0791877E-06
     +,   1.1512434E-06,   1.2268723E-06,   1.3061522E-06
     +,   1.3891531E-06,   1.4759398E-06,   1.5665678E-06
     +,   1.6610846E-06,   1.7595291E-06,   1.8619294E-06
     +,   1.9683055E-06,   2.0786597E-06,   2.1929884E-06
     +,   2.3112734E-06,   2.4334811E-06,   2.5595705E-06
     +,   2.6894807E-06,   2.8231352E-06,   2.9604514E-06
     +,   3.1013114E-06,   3.2455932E-06,   3.3931767E-06
     +,   3.5438889E-06,   3.6975648E-06,   3.8540170E-06
     +,   4.0130399E-06,   4.1744129E-06,   4.3378982E-06
     +,   4.5032439E-06,   4.6701803E-06,   4.8384222E-06
     +,   5.0076742E-06,   5.1776228E-06,   5.3479448E-06
     +,   5.5183014E-06,   5.6883446E-06,   5.8577198E-06
     +,   6.0260581E-06,   6.1929859E-06,   6.3581238E-06
     +,   6.5210861E-06,   6.6814850E-06,   6.8389295E-06
     +,   6.9930365E-06,   7.1434019E-06,   7.2896428E-06
     +,   7.4313921E-06,   7.5682588E-06,   7.6998804E-06
     +,   7.8258981E-06,   7.9459669E-06,   8.0597529E-06
     +,   8.1669368E-06,   8.2672159E-06,   8.3603054E-06
     +,   8.4459434E-06,   8.5238835E-06,   8.5939046E-06
     +,   8.6558111E-06,   8.7094331E-06,   8.7546305E-06
     +,   8.7912867E-06,   8.8193237E-06,   8.8386896E-06
     +,   8.8493725E-06,   8.8513998E-06,   8.8448342E-06
     +,   8.8297857E-06,   8.8064098E-06,   8.7749168E-06
     +,   8.7355666E-06,   8.6886866E-06,   8.6346681E-06
     +,   8.5739866E-06,   8.5071961E-06,   8.4349513E-06
     +,   8.3580180E-06,   8.2772876E-06,   8.1937887E-06
     +,   8.1087219E-06,   8.0234695E-06,   7.9396232E-06
     +,   7.8590338E-06,   7.7838095E-06,   7.7163904E-06
     +,   7.6595697E-06,   7.6165452E-06,   7.5909770E-06
     +,   7.5870344E-06,   7.6094643E-06,   7.6636525E-06
     +,   7.7556933E-06,   7.8924568E-06,   8.0816744E-06
     +,   8.3320047E-06,   8.6531145E-06,   9.0557569E-06
     +,   9.5518444E-06,   1.0154530E-05,   1.0878258E-05
     +,   1.1738838E-05,   1.2753487E-05,   1.3940868E-05
     +,   1.5321093E-05,   1.6915743E-05,   1.8747887E-05
     +,   2.0841704E-05,   2.3222834E-05,   2.5917769E-05
     +,   2.8954184E-05,   3.2360083E-05,   3.6163285E-05
     +,   4.0391664E-05,   4.5072065E-05,   5.0229726E-05
     +,   5.5887544E-05,   6.2065206E-05,   6.8778318E-05
     +,   7.6037439E-05,   8.3847197E-05,   9.2205490E-05
     +,   1.0110282E-04,   1.1052192E-04,   1.2043783E-04
     +,   1.3081833E-04,   1.4162553E-04,   1.5281771E-04
     +,   1.6435304E-04,   1.7619409E-04,   1.8831428E-04
     +,   2.0070696E-04,   2.1339576E-04,   2.2644921E-04
     +,   2.3999755E-04,   2.5425284E-04,   2.6953232E-04
     +,   2.8628195E-04,   3.0509935E-04,   3.2675077E-04
     +,   3.5217684E-04,   3.8248010E-04,   4.1888998E-04
     +,   4.6269730E-04,   5.1516335E-04,   5.7740847E-04
     +,   6.5030257E-04,   7.3435740E-04,   8.2972646E-04
     +,   9.3623478E-04,   1.0535980E-03,   1.1818069E-03
     +,   1.3216897E-03,   1.4756966E-03,   1.6486546E-03
     +,   1.8482519E-03,   2.0848266E-03,   2.3698185E-03
     +,   2.7131743E-03,   3.1200880E-03,   3.5888143E-03
     +,   4.1109915E-03,   4.6742461E-03,   5.2651437E-03
     +,   5.8685155E-03,   6.4641964E-03,   7.0266449E-03
     +,   7.5339284E-03,   7.9835020E-03,   8.4000155E-03
     +,   8.8248448E-03,   9.2972796E-03,   9.8499209E-03
     +,   1.0523302E-02,   1.1368033E-02,   1.2398038E-02
     +,   1.3518101E-02,   1.4525236E-02,   1.5251958E-02
     +,   1.5748603E-02,   1.6297005E-02,   1.7184719E-02
     +,   1.8400740E-02,   1.9519873E-02,   1.9956885E-02
     +,   1.9461337E-02,   1.8379280E-02,   1.7345730E-02
     +,   1.6721956E-02,   1.6403347E-02,   1.6109189E-02
     +,   1.5698116E-02,   1.5199877E-02,   1.4709822E-02
     +,   1.4349868E-02,   1.4246516E-02,   1.4420629E-02
     +,   1.4676849E-02,   1.4669630E-02,   1.4133953E-02
     +,   1.3060588E-02,   1.1665499E-02,   1.0233146E-02
     +,   8.9900801E-03,   8.0610076E-03,   7.4744937E-03
     +,   7.1877972E-03,   7.1174921E-03,   7.1652653E-03
     +,   7.2345533E-03,   7.2434573E-03,   7.1378932E-03
     +,   6.9003236E-03,   6.5469192E-03,   6.1133630E-03
     +,   5.6376988E-03,   5.1489244E-03,   4.6647186E-03
     +,   4.1950522E-03,   3.7468488E-03,   3.3262814E-03
     +,   2.9385635E-03,   2.5866993E-03,   2.2707563E-03
     +,   1.9882026E-03,   1.7350871E-03,   1.5073424E-03
     +,   1.3017521E-03,   1.1162207E-03,   9.4959745E-04
     +,   8.0129004E-04,   6.7078765E-04,   5.5739318E-04
     +,   4.6006805E-04,   3.7747639E-04,   3.0808037E-04
     +,   2.5026480E-04,   2.0244309E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wao_fus_95 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_wao_hz_100(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  1.2121012E-11,   1.4043180E-11
     +,   1.6257252E-11,   1.8805471E-11,   2.1735834E-11
     +,   2.5102994E-11,   2.8968949E-11,   3.3403971E-11
     +,   3.8487803E-11,   4.4310940E-11,   5.0975175E-11
     +,   5.8596294E-11,   6.7304773E-11,   7.7248222E-11
     +,   8.8592779E-11,   1.0152612E-10,   1.1625923E-10
     +,   1.3303052E-10,   1.5210695E-10,   1.7378973E-10
     +,   1.9841669E-10,   2.2636724E-10,   2.5806712E-10
     +,   2.9399455E-10,   3.3468289E-10,   3.8073275E-10
     +,   4.3281326E-10,   4.9167592E-10,   5.5815907E-10
     +,   6.3320005E-10,   7.1784595E-10,   8.1326651E-10
     +,   9.2076452E-10,   1.0417954E-09,   1.1779820E-09
     +,   1.3311318E-09,   1.5032565E-09,   1.6966011E-09
     +,   1.9136619E-09,   2.1572122E-09,   2.4303435E-09
     +,   2.7364990E-09,   3.0794747E-09,   3.4635406E-09
     +,   3.8933856E-09,   4.3742512E-09,   4.9119442E-09
     +,   5.5129115E-09,   6.1843015E-09,   6.9340356E-09
     +,   7.7709013E-09,   8.7046335E-09,   9.7460173E-09
     +,   1.0906980E-08,   1.2200768E-08,   1.3641927E-08
     +,   1.5246632E-08,   1.7032715E-08,   1.9019906E-08
     +,   2.1229921E-08,   2.3686765E-08,   2.6416856E-08
     +,   2.9449312E-08,   3.2816196E-08,   3.6552741E-08
     +,   4.0697657E-08,   4.5293476E-08,   5.0386831E-08
     +,   5.6028863E-08,   6.2275468E-08,   6.9187870E-08
     +,   7.6832904E-08,   8.5283496E-08,   9.4619161E-08
     +,   1.0492666E-07,   1.1629963E-07,   1.2884033E-07
     +,   1.4265962E-07,   1.5787683E-07,   1.7462233E-07
     +,   1.9303556E-07,   2.1326720E-07,   2.3548036E-07
     +,   2.5984716E-07,   2.8655404E-07,   3.1580424E-07
     +,   3.4780737E-07,   3.8279197E-07,   4.2099992E-07
     +,   4.6268809E-07,   5.0812804E-07,   5.5760762E-07
     +,   6.1142964E-07,   6.6991316E-07,   7.3339248E-07
     +,   8.0221776E-07,   8.7675471E-07,   9.5738346E-07
     +,   1.0444990E-06,   1.1385098E-06,   1.2398366E-06
     +,   1.3489129E-06,   1.4661813E-06,   1.5920949E-06
     +,   1.7271124E-06,   1.8716993E-06,   2.0263237E-06
     +,   2.1914609E-06,   2.3675655E-06,   2.5550983E-06
     +,   2.7545382E-06,   2.9663070E-06,   3.1908419E-06
     +,   3.4285547E-06,   3.6798381E-06,   3.9450565E-06
     +,   4.2245460E-06,   4.5186089E-06,   4.8275078E-06
     +,   5.1514685E-06,   5.4906641E-06,   5.8452215E-06
     +,   6.2152112E-06,   6.6006473E-06,   7.0014817E-06
     +,   7.4176019E-06,   7.8488247E-06,   8.2949036E-06
     +,   8.7555154E-06,   9.2302671E-06,   9.7186921E-06
     +,   1.0220252E-05,   1.0734342E-05,   1.1260286E-05
     +,   1.1797348E-05,   1.2344736E-05,   1.2901613E-05
     +,   1.3467095E-05,   1.4040283E-05,   1.4620255E-05
     +,   1.5206103E-05,   1.5796939E-05,   1.6391925E-05
     +,   1.6990298E-05,   1.7591399E-05,   1.8194729E-05
     +,   1.8799878E-05,   1.9406825E-05,   2.0015643E-05
     +,   2.0626823E-05,   2.1241211E-05,   2.1860096E-05
     +,   2.2485267E-05,   2.3119084E-05,   2.3764564E-05
     +,   2.4425444E-05,   2.5106276E-05,   2.5812484E-05
     +,   2.6550482E-05,   2.7327729E-05,   2.8152821E-05
     +,   2.9035584E-05,   2.9987144E-05,   3.1020012E-05
     +,   3.2148149E-05,   3.3387063E-05,   3.4753841E-05
     +,   3.6267240E-05,   3.7947757E-05,   3.9817722E-05
     +,   4.1901039E-05,   4.4223721E-05,   4.6813409E-05
     +,   4.9699964E-05,   5.2914846E-05,   5.6490939E-05
     +,   6.0463135E-05,   6.4867534E-05,   6.9741378E-05
     +,   7.5122582E-05,   8.1049337E-05,   8.7559318E-05
     +,   9.4689101E-05,   1.0247310E-04,   1.1094263E-04
     +,   1.2012463E-04,   1.3004054E-04,   1.4070484E-04
     +,   1.5212380E-04,   1.6429437E-04,   1.7720289E-04
     +,   1.9082487E-04,   2.0512434E-04,   2.2005438E-04
     +,   2.3555843E-04,   2.5157223E-04,   2.6802695E-04
     +,   2.8485403E-04,   3.0199031E-04,   3.1938517E-04
     +,   3.3700929E-04,   3.5486397E-04,   3.7299166E-04
     +,   3.9148823E-04,   4.1051483E-04,   4.3031026E-04
     +,   4.5120335E-04,   4.7362354E-04,   4.9810699E-04
     +,   5.2530097E-04,   5.5595237E-04,   5.9090549E-04
     +,   6.3106616E-04,   6.7737163E-04,   7.3075399E-04
     +,   7.9208869E-04,   8.6218084E-04,   9.4174425E-04
     +,   1.0314186E-03,   1.1318312E-03,   1.2436219E-03
     +,   1.3675446E-03,   1.5045012E-03,   1.6555621E-03
     +,   1.8219826E-03,   2.0051571E-03,   2.2066890E-03
     +,   2.4283305E-03,   2.6719612E-03,   2.9394724E-03
     +,   3.2324286E-03,   3.5517048E-03,   3.8968888E-03
     +,   4.2656474E-03,   4.6531544E-03,   5.0513637E-03
     +,   5.4489556E-03,   5.8319247E-03,   6.1856895E-03
     +,   6.4986874E-03,   6.7668459E-03,   6.9971569E-03
     +,   7.2086863E-03,   7.4304068E-03,   7.6969480E-03
     +,   8.0434214E-03,   8.4992899E-03,   9.0801669E-03
     +,   9.7799348E-03,   1.0569811E-02,   1.1409950E-02
     +,   1.2267985E-02,   1.3129939E-02,   1.3994941E-02
     +,   1.4860854E-02,   1.5711268E-02,   1.6505357E-02
     +,   1.7179850E-02,   1.7690016E-02,   1.8094094E-02
     +,   1.8607710E-02,   1.9507175E-02,   2.0901738E-02
     +,   2.2651102E-02,   2.4585515E-02,   2.6638705E-02
     +,   2.8596399E-02,   3.0042667E-02,   3.0909760E-02
     +,   3.1708378E-02,   3.2825287E-02,   3.4073539E-02
     +,   3.5296343E-02,   3.6745597E-02,   3.8390763E-02
     +,   3.9449118E-02,   3.9214652E-02,   3.8340662E-02
     +,   3.8458325E-02,   3.9995711E-02,   4.1371610E-02
     +,   4.0799104E-02,   3.8107034E-02,   3.4428786E-02
     +,   3.0806504E-02,   2.7525609E-02,   2.4363087E-02
     +,   2.1145720E-02,   1.7990682E-02,   1.5097975E-02
     +,   1.2533200E-02,   1.0244550E-02,   8.1810821E-03
     +,   6.3523352E-03,   4.8018796E-03,   3.5553421E-03
     +,   2.5961660E-03,   1.8776043E-03,   1.3458540E-03
     +,   9.5486693E-04,   6.6972215E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wao_hz_100 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_wao_hz_105(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  4.4717847E-17,   5.8476329E-17
     +,   7.6362277E-17,   9.9581316E-17,   1.2968123E-16
     +,   1.6864561E-16,   2.1901507E-16,   2.8403484E-16
     +,   3.6784897E-16,   4.7574145E-16,   6.1442346E-16
     +,   7.9243876E-16,   1.0206173E-15,   1.3126827E-15
     +,   1.6859970E-15,   2.1624859E-15,   2.7698102E-15
     +,   3.5427970E-15,   4.5252435E-15,   5.7721535E-15
     +,   7.3524832E-15,   9.3525431E-15,   1.1880228E-14
     +,   1.5070298E-14,   1.9090506E-14,   2.4149699E-14
     +,   3.0507531E-14,   3.8485847E-14,   4.8483654E-14
     +,   6.0994267E-14,   7.6627208E-14,   9.6133862E-14
     +,   1.2043982E-13,   1.5068265E-13,   1.8825939E-13
     +,   2.3488186E-13,   2.9264547E-13,   3.6411146E-13
     +,   4.5240477E-13,   5.6133055E-13,   6.9552128E-13
     +,   8.6060705E-13,   1.0633933E-12,   1.3121616E-12
     +,   1.6168825E-12,   1.9896175E-12,   2.4448939E-12
     +,   3.0002040E-12,   3.6765578E-12,   4.4991558E-12
     +,   5.4982117E-12,   6.7098263E-12,   8.1771300E-12
     +,   9.9515439E-12,   1.2094320E-11,   1.4678115E-11
     +,   1.7789322E-11,   2.1530219E-11,   2.6021747E-11
     +,   3.1406908E-11,   3.7854102E-11,   4.5561818E-11
     +,   5.4763215E-11,   6.5731996E-11,   7.8788732E-11
     +,   9.4308616E-11,   1.1272972E-10,   1.3456307E-10
     +,   1.6040295E-10,   1.9094119E-10,   2.2697914E-10
     +,   2.6944638E-10,   3.1941780E-10,   3.7813405E-10
     +,   4.4702653E-10,   5.2774007E-10,   6.2216565E-10
     +,   7.3247453E-10,   8.6114749E-10,   1.0110309E-09
     +,   1.1853620E-09,   1.3878355E-09,   1.6226642E-09
     +,   1.8945951E-09,   2.2090316E-09,   2.5721356E-09
     +,   2.9907739E-09,   3.4727523E-09,   4.0268500E-09
     +,   4.6629238E-09,   5.3920339E-09,   6.2265610E-09
     +,   7.1803581E-09,   8.2688709E-09,   9.5093053E-09
     +,   1.0920804E-08,   1.2524595E-08,   1.4344208E-08
     +,   1.6405679E-08,   1.8737721E-08,   2.1372017E-08
     +,   2.4343345E-08,   2.7690007E-08,   3.1453894E-08
     +,   3.5680852E-08,   4.0421025E-08,   4.5728942E-08
     +,   5.1664433E-08,   5.8291505E-08,   6.5680155E-08
     +,   7.3907245E-08,   8.3053841E-08,   9.3208719E-08
     +,   1.0446745E-07,   1.1693264E-07,   1.3071457E-07
     +,   1.4593186E-07,   1.6271127E-07,   1.8118864E-07
     +,   2.0150934E-07,   2.2382838E-07,   2.4831161E-07
     +,   2.7513533E-07,   3.0448797E-07,   3.3656966E-07
     +,   3.7159404E-07,   4.0978827E-07,   4.5139419E-07
     +,   4.9666897E-07,   5.4588656E-07,   5.9933893E-07
     +,   6.5733695E-07,   7.2021186E-07,   7.8831721E-07
     +,   8.6203005E-07,   9.4175351E-07,   1.0279183E-06
     +,   1.1209852E-06,   1.2214472E-06,   1.3298328E-06
     +,   1.4467080E-06,   1.5726802E-06,   1.7084009E-06
     +,   1.8545670E-06,   2.0119296E-06,   2.1812991E-06
     +,   2.3635148E-06,   2.5595327E-06,   2.7703181E-06
     +,   2.9969394E-06,   3.2405298E-06,   3.5023027E-06
     +,   3.7835500E-06,   4.0856562E-06,   4.4100902E-06
     +,   4.7584217E-06,   5.1323154E-06,   5.5335463E-06
     +,   5.9639933E-06,   6.4256560E-06,   6.9206508E-06
     +,   7.4512245E-06,   8.0197560E-06,   8.6287682E-06
     +,   9.2809405E-06,   9.9791059E-06,   1.0726278E-05
     +,   1.1525656E-05,   1.2380649E-05,   1.3294921E-05
     +,   1.4272275E-05,   1.5316904E-05,   1.6433214E-05
     +,   1.7626104E-05,   1.8900784E-05,   2.0262791E-05
     +,   2.1718321E-05,   2.3274117E-05,   2.4937573E-05
     +,   2.6716833E-05,   2.8620914E-05,   3.0659798E-05
     +,   3.2844524E-05,   3.5187368E-05,   3.7701844E-05
     +,   4.0402927E-05,   4.3307045E-05,   4.6432160E-05
     +,   4.9797840E-05,   5.3425170E-05,   5.7336882E-05
     +,   6.1557228E-05,   6.6112014E-05,   7.1028699E-05
     +,   7.6336575E-05,   8.2067170E-05,   8.8254950E-05
     +,   9.4938572E-05,   1.0216254E-04,   1.0997984E-04
     +,   1.1845542E-04,   1.2767089E-04,   1.3773030E-04
     +,   1.4876734E-04,   1.6095400E-04,   1.7450936E-04
     +,   1.8970924E-04,   2.0689437E-04,   2.2647608E-04
     +,   2.4893798E-04,   2.7482395E-04,   3.0473110E-04
     +,   3.3926929E-04,   3.7902026E-04,   4.2447948E-04
     +,   4.7597545E-04,   5.3360319E-04,   5.9714087E-04
     +,   6.6599011E-04,   7.3916267E-04,   8.1526604E-04
     +,   8.9260796E-04,   9.6931402E-04,   1.0435223E-03
     +,   1.1136165E-03,   1.1784555E-03,   1.2376269E-03
     +,   1.2915761E-03,   1.3416965E-03,   1.3902864E-03
     +,   1.4403857E-03,   1.4955492E-03,   1.5595297E-03
     +,   1.6359605E-03,   1.7280516E-03,   1.8382564E-03
     +,   1.9680143E-03,   2.1174841E-03,   2.2853692E-03
     +,   2.4689583E-03,   2.6644492E-03,   2.8676416E-03
     +,   3.0748025E-03,   3.2834886E-03,   3.4929481E-03
     +,   3.7039786E-03,   3.9183209E-03,   4.1378043E-03
     +,   4.3633925E-03,   4.5941211E-03,   4.8259250E-03
     +,   5.0508529E-03,   5.2574617E-03,   5.4330975E-03
     +,   5.5676149E-03,   5.6570703E-03,   5.7054777E-03
     +,   5.7242517E-03,   5.7307566E-03,   5.7484470E-03
     +,   5.8093406E-03,   5.9556100E-03,   6.2341420E-03
     +,   6.6807200E-03,   7.2995713E-03,   8.0534890E-03
     +,   8.8779787E-03,   9.7164074E-03,   1.0551782E-02
     +,   1.1402655E-02,   1.2273200E-02,   1.3095421E-02
     +,   1.3729543E-02,   1.4045134E-02,   1.4021008E-02
     +,   1.3775732E-02,   1.3507019E-02,   1.3393950E-02
     +,   1.3521343E-02,   1.3849898E-02,   1.4245244E-02
     +,   1.4574016E-02,   1.4821408E-02,   1.5122389E-02
     +,   1.5632242E-02,   1.6331498E-02,   1.7004160E-02
     +,   1.7472021E-02,   1.7799415E-02,   1.8158542E-02
     +,   1.8506862E-02,   1.8505031E-02,   1.7775787E-02
     +,   1.6190680E-02,   1.3922644E-02,   1.1304759E-02
     +,   8.6691063E-03,   6.2673748E-03,   4.2581391E-03
     +,   2.7121250E-03,   1.6195354E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wao_hz_105 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_wao_hz_110(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  2.2286953E-25,   3.5502966E-25
     +,   5.6421516E-25,   8.9451561E-25,   1.4147963E-24
     +,   2.2323618E-24,   3.5139841E-24,   5.5182280E-24
     +,   8.6449815E-24,   1.3511226E-23,   2.1066310E-23
     +,   3.2767509E-23,   5.0846923E-23,   7.8714030E-23
     +,   1.2156292E-22,   1.8729001E-22,   2.8786759E-22
     +,   4.4140340E-22,   6.7521420E-22,   1.0304150E-21
     +,   1.5687273E-21,   2.3825889E-21,   3.6100416E-21
     +,   5.4568883E-21,   8.2288226E-21,   1.2379272E-20
     +,   1.8578788E-20,   2.7816627E-20,   4.1548452E-20
     +,   6.1911322E-20,   9.2034396E-20,   1.3648828E-19
     +,   2.0193216E-19,   2.9804362E-19,   4.3885158E-19
     +,   6.4464620E-19,   9.4469248E-19,   1.3810958E-18
     +,   2.0142923E-18,   2.9307977E-18,   4.2541597E-18
     +,   6.1604342E-18,   8.8995320E-18,   1.2826141E-17
     +,   1.8441019E-17,   2.6450912E-17,   3.7849690E-17
     +,   5.4031792E-17,   7.6948655E-17,   1.0932511E-16
     +,   1.5495491E-16,   2.1910727E-16,   3.0908298E-16
     +,   4.3497119E-16,   6.1068153E-16,   8.5532916E-16
     +,   1.1951445E-15,   1.6659953E-15,   2.3168412E-15
     +,   3.2143001E-15,   4.4488174E-15,   6.1428773E-15
     +,   8.4618964E-15,   1.1628758E-14,   1.5942964E-14
     +,   2.1805933E-14,   2.9754404E-14,   4.0504041E-14
     +,   5.5006929E-14,   7.4526187E-14,   1.0073316E-13
     +,   1.3583430E-13,   1.8273414E-13,   2.4524751E-13
     +,   3.2837294E-13,   4.3863453E-13,   5.8453985E-13
     +,   7.7714793E-13,   1.0307854E-12,   1.3639975E-12
     +,   1.8006894E-12,   2.3716144E-12,   3.1162802E-12
     +,   4.0851298E-12,   5.3426165E-12,   6.9710171E-12
     +,   9.0744278E-12,   1.1784985E-11,   1.5269567E-11
     +,   1.9738470E-11,   2.5456045E-11,   3.2753654E-11
     +,   4.2045742E-11,   5.3849133E-11,   6.8806780E-11
     +,   8.7716549E-11,   1.1156560E-10,   1.4157281E-10
     +,   1.7923857E-10,   2.2640531E-10,   2.8532951E-10
     +,   3.5876835E-10,   4.5008089E-10,   5.6334892E-10
     +,   7.0351941E-10,   8.7657487E-10,   1.0897269E-09
     +,   1.3516617E-09,   1.6727590E-09,   2.0654574E-09
     +,   2.5446583E-09,   3.1279814E-09,   3.8364130E-09
     +,   4.6947761E-09,   5.7323777E-09,   6.9837123E-09
     +,   8.4893008E-09,   1.0296573E-08,   1.2460933E-08
     +,   1.5046908E-08,   1.8129441E-08,   2.1795332E-08
     +,   2.6144836E-08,   3.1293464E-08,   3.7373837E-08
     +,   4.4537906E-08,   5.2959177E-08,   6.2835269E-08
     +,   7.4390549E-08,   8.7879002E-08,   1.0358755E-07
     +,   1.2183881E-07,   1.4299499E-07,   1.6746127E-07
     +,   1.9568957E-07,   2.2818220E-07,   2.6549603E-07
     +,   3.0824617E-07,   3.5711020E-07,   4.1283164E-07
     +,   4.7622427E-07,   5.4817514E-07,   6.2964847E-07
     +,   7.2168888E-07,   8.2542317E-07,   9.4206911E-07
     +,   1.0729109E-06,   1.2193580E-06,   1.3828700E-06
     +,   1.5650181E-06,   1.7674578E-06,   1.9919291E-06
     +,   2.2402583E-06,   2.5143529E-06,   2.8161983E-06
     +,   3.1478544E-06,   3.5114490E-06,   3.9091747E-06
     +,   4.3432801E-06,   4.8160650E-06,   5.3298791E-06
     +,   5.8871083E-06,   6.4901737E-06,   7.1415307E-06
     +,   7.8436633E-06,   8.5990787E-06,   9.4103143E-06
     +,   1.0279943E-05,   1.1210568E-05,   1.2204891E-05
     +,   1.3265540E-05,   1.4395347E-05,   1.5597147E-05
     +,   1.6874052E-05,   1.8229228E-05,   1.9665906E-05
     +,   2.1187698E-05,   2.2798407E-05,   2.4502137E-05
     +,   2.6303298E-05,   2.8206667E-05,   3.0217379E-05
     +,   3.2340969E-05,   3.4583340E-05,   3.6950765E-05
     +,   3.9449817E-05,   4.2087300E-05,   4.4870136E-05
     +,   4.7805217E-05,   5.0899213E-05,   5.4158343E-05
     +,   5.7588153E-05,   6.1193212E-05,   6.4976914E-05
     +,   6.8941263E-05,   7.3086769E-05,   7.7412536E-05
     +,   8.1916529E-05,   8.6596265E-05,   9.1449852E-05
     +,   9.6477561E-05,   1.0168402E-04,   1.0708106E-04
     +,   1.1269131E-04,   1.1855231E-04,   1.2472125E-04
     +,   1.3128016E-04,   1.3834100E-04,   1.4605057E-04
     +,   1.5459544E-04,   1.6420330E-04,   1.7514871E-04
     +,   1.8774971E-04,   2.0236769E-04,   2.1940346E-04
     +,   2.3928662E-04,   2.6246987E-04,   2.8941155E-04
     +,   3.2055934E-04,   3.5634008E-04,   3.9713352E-04
     +,   4.4328131E-04,   4.9509300E-04,   5.5287924E-04
     +,   6.1700644E-04,   6.8794447E-04,   7.6634192E-04
     +,   8.5299881E-04,   9.4879599E-04,   1.0544996E-03
     +,   1.1704381E-03,   1.2961607E-03,   1.4300715E-03
     +,   1.5692178E-03,   1.7093552E-03,   1.8452273E-03
     +,   1.9712665E-03,   2.0824408E-03,   2.1752412E-03
     +,   2.2485885E-03,   2.3044848E-03,   2.3481334E-03
     +,   2.3873684E-03,   2.4313109E-03,   2.4885572E-03
     +,   2.5654880E-03,   2.6654378E-03,   2.7890392E-03
     +,   2.9353339E-03,   3.1025121E-03,   3.2872297E-03
     +,   3.4825634E-03,   3.6761614E-03,   3.8508261E-03
     +,   3.9887629E-03,   4.0781428E-03,   4.1186684E-03
     +,   4.1228831E-03,   4.1125026E-03,   4.1120863E-03
     +,   4.1434639E-03,   4.2225393E-03,   4.3572965E-03
     +,   4.5453338E-03,   4.7717099E-03,   5.0111613E-03
     +,   5.2378164E-03,   5.4391897E-03,   5.6246598E-03
     +,   5.8199200E-03,   6.0487571E-03,   6.3135694E-03
     +,   6.5865484E-03,   6.8163578E-03,   6.9488785E-03
     +,   6.9560036E-03,   6.8594222E-03,   6.7300070E-03
     +,   6.6527249E-03,   6.6727037E-03,   6.7606224E-03
     +,   6.8272720E-03,   6.7798449E-03,   6.5787113E-03
     +,   6.2550693E-03,   5.8834441E-03,   5.5354051E-03
     +,   5.2466039E-03,   5.0112340E-03,   4.7972156E-03
     +,   4.5667458E-03,   4.2905603E-03,   3.9535300E-03
     +,   3.5549204E-03,   3.1065992E-03,   2.6304231E-03
     +,   2.1538630E-03,   1.7044293E-03,   1.3042105E-03
     +,   9.6645328E-04,   6.9501565E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wao_hz_110 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_wao_hz_115(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  9.3173598E-17,   1.2402495E-16
     +,   1.6482836E-16,   2.1870723E-16,   2.8973503E-16
     +,   3.8321769E-16,   5.0605391E-16,   6.6719779E-16
     +,   8.7825373E-16,   1.1542358E-15,   1.5145167E-15
     +,   1.9840849E-15,   2.5950944E-15,   3.3888530E-15
     +,   4.4183551E-15,   5.7514100E-15,   7.4747176E-15
     +,   9.6989033E-15,   1.2564847E-14,   1.6251718E-14
     +,   2.0986927E-14,   2.7058479E-14,   3.4831096E-14
     +,   4.4764976E-14,   5.7440021E-14,   7.3586529E-14
     +,   9.4121664E-14,   1.2019506E-13,   1.5324673E-13
     +,   1.9507540E-13,   2.4792551E-13,   3.1459069E-13
     +,   3.9854629E-13,   5.0410088E-13,   6.3659581E-13
     +,   8.0263395E-13,   1.0103624E-12,   1.2698259E-12
     +,   1.5933780E-12,   1.9961799E-12,   2.4968222E-12
     +,   3.1180618E-12,   3.8876246E-12,   4.8394453E-12
     +,   6.0146649E-12,   7.4633459E-12,   9.2462062E-12
     +,   1.1436688E-11,   1.4123556E-11,   1.7413822E-11
     +,   2.1436389E-11,   2.6346121E-11,   3.2328678E-11
     +,   3.9606526E-11,   4.8445505E-11,   5.9162480E-11
     +,   7.2134937E-11,   8.7811529E-11,   1.0672469E-10
     +,   1.2950464E-10,   1.5689623E-10,   1.8977839E-10
     +,   2.2918596E-10,   2.7633482E-10,   3.3265241E-10
     +,   3.9980924E-10,   4.7975779E-10,   5.7477456E-10
     +,   6.8751232E-10,   8.2105189E-10,   9.7896447E-10
     +,   1.1653886E-09,   1.3851017E-09,   1.6436119E-09
     +,   1.9472655E-09,   2.3033337E-09,   2.7201656E-09
     +,   3.2073122E-09,   3.7756536E-09,   4.4376329E-09
     +,   5.2073643E-09,   6.1008620E-09,   7.1363213E-09
     +,   8.3341591E-09,   9.7174686E-09,   1.1312463E-08
     +,   1.3148168E-08,   1.5257399E-08,   1.7676754E-08
     +,   2.0447093E-08,   2.3613877E-08,   2.7227660E-08
     +,   3.1344420E-08,   3.6026098E-08,   4.1340989E-08
     +,   4.7364381E-08,   5.4178837E-08,   6.1874871E-08
     +,   7.0551451E-08,   8.0316468E-08,   9.1287305E-08
     +,   1.0359118E-07,   1.1736600E-07,   1.3276045E-07
     +,   1.4993469E-07,   1.6906071E-07,   1.9032251E-07
     +,   2.1391760E-07,   2.4005331E-07,   2.6895151E-07
     +,   3.0085084E-07,   3.3599531E-07,   3.7464716E-07
     +,   4.1707918E-07,   4.6357664E-07,   5.1443612E-07
     +,   5.6996521E-07,   6.3048174E-07,   6.9631108E-07
     +,   7.6778753E-07,   8.4525146E-07,   9.2904691E-07
     +,   1.0195214E-06,   1.1170227E-06,   1.2218973E-06
     +,   1.3344867E-06,   1.4551269E-06,   1.5841434E-06
     +,   1.7218483E-06,   1.8685398E-06,   2.0244954E-06
     +,   2.1899698E-06,   2.3651924E-06,   2.5503618E-06
     +,   2.7456429E-06,   2.9511637E-06,   3.1670102E-06
     +,   3.3932242E-06,   3.6298002E-06,   3.8766780E-06
     +,   4.1337466E-06,   4.4008325E-06,   4.6777041E-06
     +,   4.9640676E-06,   5.2595624E-06,   5.5637747E-06
     +,   5.8761711E-06,   6.1962405E-06,   6.5233121E-06
     +,   6.8567006E-06,   7.1956365E-06,   7.5392891E-06
     +,   7.8867661E-06,   8.2371089E-06,   8.5893089E-06
     +,   8.9423047E-06,   9.2949867E-06,   9.6462090E-06
     +,   9.9947911E-06,   1.0339530E-05,   1.0679206E-05
     +,   1.1012597E-05,   1.1338485E-05,   1.1655677E-05
     +,   1.1963010E-05,   1.2259379E-05,   1.2543745E-05
     +,   1.2815167E-05,   1.3072813E-05,   1.3316006E-05
     +,   1.3544216E-05,   1.3757142E-05,   1.3954721E-05
     +,   1.4137189E-05,   1.4305100E-05,   1.4459379E-05
     +,   1.4601413E-05,   1.4733075E-05,   1.4856822E-05
     +,   1.4975745E-05,   1.5093664E-05,   1.5215234E-05
     +,   1.5346041E-05,   1.5492742E-05,   1.5663210E-05
     +,   1.5866712E-05,   1.6114125E-05,   1.6418187E-05
     +,   1.6793781E-05,   1.7258273E-05,   1.7831888E-05
     +,   1.8538100E-05,   1.9404066E-05,   2.0461011E-05
     +,   2.1744596E-05,   2.3295166E-05,   2.5157868E-05
     +,   2.7382541E-05,   3.0023357E-05,   3.3138116E-05
     +,   3.6787216E-05,   4.1032265E-05,   4.5934350E-05
     +,   5.1552146E-05,   5.7939909E-05,   6.5145570E-05
     +,   7.3209354E-05,   8.2162907E-05,   9.2029455E-05
     +,   1.0282554E-04,   1.1456128E-04,   1.2724892E-04
     +,   1.4090298E-04,   1.5554822E-04,   1.7122561E-04
     +,   1.8799432E-04,   2.0593937E-04,   2.2516979E-04
     +,   2.4581616E-04,   2.6802914E-04,   2.9196023E-04
     +,   3.1775658E-04,   3.4553956E-04,   3.7538589E-04
     +,   4.0731020E-04,   4.4124265E-04,   4.7703306E-04
     +,   5.1443832E-04,   5.5314286E-04,   5.9278635E-04
     +,   6.3299533E-04,   6.7343505E-04,   7.1384263E-04
     +,   7.5404951E-04,   7.9399208E-04,   8.3367067E-04
     +,   8.7312254E-04,   9.1236585E-04,   9.5137273E-04
     +,   9.9008554E-04,   1.0285071E-03,   1.0668825E-03
     +,   1.1059724E-03,   1.1473835E-03,   1.1938608E-03
     +,   1.2493875E-03,   1.3188933E-03,   1.4074313E-03
     +,   1.5188474E-03,   1.6542539E-03,   1.8108566E-03
     +,   1.9817234E-03,   2.1567629E-03,   2.3246941E-03
     +,   2.4752310E-03,   2.6007111E-03,   2.6966524E-03
     +,   2.7614099E-03,   2.7954634E-03,   2.8009161E-03
     +,   2.7815641E-03,   2.7435776E-03,   2.6966843E-03
     +,   2.6553955E-03,   2.6393577E-03,   2.6714299E-03
     +,   2.7724039E-03,   2.9528299E-03,   3.2047755E-03
     +,   3.4980746E-03,   3.7850079E-03,   4.0136348E-03
     +,   4.1449885E-03,   4.1661197E-03,   4.0923846E-03
     +,   3.9580450E-03,   3.8007295E-03,   3.6481533E-03
     +,   3.5130295E-03,   3.3960186E-03,   3.2923818E-03
     +,   3.1972621E-03,   3.1075943E-03,   3.0215268E-03
     +,   2.9373586E-03,   2.8530329E-03,   2.7660311E-03
     +,   2.6730634E-03,   2.5695814E-03,   2.4496729E-03
     +,   2.3069810E-03,   2.1366025E-03,   1.9373039E-03
     +,   1.7130380E-03,   1.4728580E-03,   1.2292955E-03
     +,   9.9563901E-04,   7.8329886E-04,   5.9994886E-04
     +,   4.4888115E-04,   3.2947265E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wao_hz_115 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_wao_hz_120(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   2.8599891E-38
     +,   1.0192905E-37,   3.5941768E-37,   1.2539072E-36
     +,   4.3287138E-36,   1.4783271E-35,   4.9951077E-35
     +,   1.6699825E-34,   5.5236457E-34,   1.8075336E-33
     +,   5.8527537E-33,   1.8749079E-32,   5.9424983E-32
     +,   1.8635006E-31,   5.7817174E-31,   1.7748364E-30
     +,   5.3905244E-30,   1.6198533E-29,   4.8160725E-29
     +,   1.4167139E-28,   4.1233207E-28,   1.1873780E-27
     +,   3.3830154E-27,   9.5367352E-27,   2.6599545E-26
     +,   7.3404993E-26,   2.0043048E-25,   5.4147955E-25
     +,   1.4473959E-24,   3.8280572E-24,   1.0017572E-23
     +,   2.5938034E-23,   6.6451996E-23,   1.6845162E-22
     +,   4.2251754E-22,   1.0486171E-21,   2.5751183E-21
     +,   6.2573592E-21,   1.5045314E-20,   3.5795827E-20
     +,   8.4273187E-20,   1.9632670E-19,   4.5258960E-19
     +,   1.0324610E-18,   2.3307272E-18,   5.2069254E-18
     +,   1.1510806E-17,   2.5184391E-17,   5.4528153E-17
     +,   1.1684199E-16,   2.4778432E-16,   5.2006171E-16
     +,   1.0803201E-15,   2.2211355E-15,   4.5199601E-15
     +,   9.1041973E-15,   1.8151206E-14,   3.5821023E-14
     +,   6.9976326E-14,   1.3531800E-13,   2.5903742E-13
     +,   4.9088983E-13,   9.2093650E-13,   1.7104564E-12
     +,   3.1451478E-12,   5.7256764E-12,   1.0319991E-11
     +,   1.8416530E-11,   3.2540248E-11,   5.6929333E-11
     +,   9.8614311E-11,   1.6914098E-10,   2.8724895E-10
     +,   4.8304905E-10,   8.0435986E-10,   1.3262295E-09
     +,   2.1652353E-09,   3.5003385E-09,   5.6031269E-09
     +,   8.8810417E-09,   1.3938161E-08,   2.1659577E-08
     +,   3.3326597E-08,   5.0771529E-08,   7.6582552E-08
     +,   1.1436936E-07,   1.6910239E-07,   2.4753626E-07
     +,   3.5872807E-07,   5.1465554E-07,   7.3093747E-07
     +,   1.0276435E-06,   1.4301772E-06,   1.9701922E-06
     +,   2.6864841E-06,   3.6257904E-06,   4.8433922E-06
     +,   6.4034007E-06,   8.3786117E-06,   1.0849763E-05
     +,   1.3904090E-05,   1.7633045E-05,   2.2129130E-05
     +,   2.7481832E-05,   3.3772736E-05,   4.1070001E-05
     +,   4.9422510E-05,   5.8854104E-05,   6.9358335E-05
     +,   8.0895014E-05,   9.3385424E-05,   1.0671746E-04
     +,   1.2074361E-04,   1.3528930E-04,   1.5016246E-04
     +,   1.6516293E-04,   1.8010080E-04,   1.9481005E-04
     +,   2.0916542E-04,   2.2310141E-04,   2.3662063E-04
     +,   2.4981090E-04,   2.6284825E-04,   2.7599747E-04
     +,   2.8960474E-04,   3.0407755E-04,   3.1986341E-04
     +,   3.3740728E-04,   3.5710784E-04,   3.7926793E-04
     +,   4.0403919E-04,   4.3138512E-04,   4.6105098E-04
     +,   4.9256335E-04,   5.2527094E-04,   5.5840280E-04
     +,   5.9119210E-04,   6.2300760E-04,   6.5350498E-04
     +,   6.8276178E-04,   7.1136787E-04,   7.4043422E-04
     +,   7.7151146E-04,   8.0641330E-04,   8.4697874E-04
     +,   8.9482544E-04,   9.5113186E-04,   1.0164664E-03
     +,   1.0906245E-03,   1.1724087E-03,   1.2593224E-03
     +,   1.3472514E-03,   1.4303562E-03,   1.5014781E-03
     +,   1.5532894E-03,   1.5801570E-03,   1.5802743E-03
     +,   1.5573434E-03,   1.5210395E-03,   1.4858395E-03
     +,   1.4683247E-03,   1.4836028E-03,   1.5417412E-03
     +,   1.6450461E-03,   1.7868162E-03,   1.9519012E-03
     +,   2.1191228E-03,   2.2652396E-03,   2.3696632E-03
     +,   2.4187998E-03,   2.4089082E-03,   2.3467226E-03
     +,   2.2478644E-03,   2.1334561E-03,   2.0257335E-03
     +,   1.9434756E-03,   1.8981468E-03,   1.8918469E-03
     +,   1.9178609E-03,   1.9639030E-03,   2.0170475E-03
     +,   2.0683396E-03,   2.1149570E-03,   2.1588504E-03
     +,   2.2025635E-03,   2.2444827E-03,   2.2761589E-03
     +,   2.2833152E-03,   2.2501969E-03,   2.1652237E-03
     +,   2.0253542E-03,   1.8373200E-03,   1.6155513E-03
     +,   1.3781056E-03,   1.1423146E-03,   9.2178117E-04
     +,   7.2512199E-04,   5.5637344E-04,   4.1616330E-04
     +,   3.0299969E-04,   2.1425322E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wao_hz_120 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_wao_hz_60(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  2.9474266E-05,   3.0386169E-05
     +,   3.1323721E-05,   3.2286604E-05,   3.3274424E-05
     +,   3.4286721E-05,   3.5322977E-05,   3.6382600E-05
     +,   3.7464939E-05,   3.8569309E-05,   3.9694893E-05
     +,   4.0840896E-05,   4.2006435E-05,   4.3190583E-05
     +,   4.4392382E-05,   4.5610814E-05,   4.6844842E-05
     +,   4.8093381E-05,   4.9355331E-05,   5.0629591E-05
     +,   5.1914998E-05,   5.3210428E-05,   5.4514723E-05
     +,   5.5826767E-05,   5.7145364E-05,   5.8469413E-05
     +,   5.9797818E-05,   6.1129496E-05,   6.2463390E-05
     +,   6.3798478E-05,   6.5133776E-05,   6.6468368E-05
     +,   6.7801353E-05,   6.9131871E-05,   7.0459151E-05
     +,   7.1782466E-05,   7.3101131E-05,   7.4414529E-05
     +,   7.5722084E-05,   7.7023331E-05,   7.8317804E-05
     +,   7.9605139E-05,   8.0884929E-05,   8.2157007E-05
     +,   8.3421073E-05,   8.4676984E-05,   8.5924563E-05
     +,   8.7163738E-05,   8.8394467E-05,   8.9616682E-05
     +,   9.0830399E-05,   9.2035596E-05,   9.3232316E-05
     +,   9.4420604E-05,   9.5600473E-05,   9.6771902E-05
     +,   9.7934972E-05,   9.9089637E-05,   1.0023591E-04
     +,   1.0137370E-04,   1.0250294E-04,   1.0362353E-04
     +,   1.0473529E-04,   1.0583804E-04,   1.0693153E-04
     +,   1.0801546E-04,   1.0908950E-04,   1.1015328E-04
     +,   1.1120631E-04,   1.1224815E-04,   1.1327826E-04
     +,   1.1429605E-04,   1.1530089E-04,   1.1629207E-04
     +,   1.1726902E-04,   1.1823086E-04,   1.1917688E-04
     +,   1.2010628E-04,   1.2101821E-04,   1.2191192E-04
     +,   1.2278651E-04,   1.2364116E-04,   1.2447505E-04
     +,   1.2528726E-04,   1.2607698E-04,   1.2684346E-04
     +,   1.2758584E-04,   1.2830335E-04,   1.2899526E-04
     +,   1.2966082E-04,   1.3029936E-04,   1.3091018E-04
     +,   1.3149272E-04,   1.3204636E-04,   1.3257051E-04
     +,   1.3306466E-04,   1.3352836E-04,   1.3396109E-04
     +,   1.3436245E-04,   1.3473201E-04,   1.3506938E-04
     +,   1.3537420E-04,   1.3564609E-04,   1.3588471E-04
     +,   1.3608970E-04,   1.3626073E-04,   1.3639740E-04
     +,   1.3649940E-04,   1.3656630E-04,   1.3659768E-04
     +,   1.3659314E-04,   1.3655220E-04,   1.3647442E-04
     +,   1.3635919E-04,   1.3620598E-04,   1.3601416E-04
     +,   1.3578315E-04,   1.3551224E-04,   1.3520067E-04
     +,   1.3484771E-04,   1.3445260E-04,   1.3401450E-04
     +,   1.3353264E-04,   1.3300608E-04,   1.3243404E-04
     +,   1.3181567E-04,   1.3115015E-04,   1.3043666E-04
     +,   1.2967439E-04,   1.2886272E-04,   1.2800095E-04
     +,   1.2708850E-04,   1.2612494E-04,   1.2510993E-04
     +,   1.2404319E-04,   1.2292470E-04,   1.2175457E-04
     +,   1.2053303E-04,   1.1926062E-04,   1.1793802E-04
     +,   1.1656618E-04,   1.1514635E-04,   1.1367997E-04
     +,   1.1216887E-04,   1.1061504E-04,   1.0902088E-04
     +,   1.0738929E-04,   1.0572307E-04,   1.0402586E-04
     +,   1.0230132E-04,   1.0055362E-04,   9.8787248E-05
     +,   9.7007076E-05,   9.5218304E-05,   9.3426534E-05
     +,   9.1637681E-05,   8.9857982E-05,   8.8094042E-05
     +,   8.6352717E-05,   8.4641208E-05,   8.2966930E-05
     +,   8.1337508E-05,   7.9760845E-05,   7.8244928E-05
     +,   7.6797951E-05,   7.5428143E-05,   7.4143798E-05
     +,   7.2953262E-05,   7.1864786E-05,   7.0886512E-05
     +,   7.0026566E-05,   6.9292779E-05,   6.8692774E-05
     +,   6.8233829E-05,   6.7922956E-05,   6.7766756E-05
     +,   6.7771354E-05,   6.7942376E-05,   6.8284950E-05
     +,   6.8803551E-05,   6.9502086E-05,   7.0383750E-05
     +,   7.1451068E-05,   7.2705807E-05,   7.4149000E-05
     +,   7.5780903E-05,   7.7601013E-05,   7.9607955E-05
     +,   8.1799648E-05,   8.4173160E-05,   8.6724816E-05
     +,   8.9450150E-05,   9.2343980E-05,   9.5400406E-05
     +,   9.8612822E-05,   1.0197407E-04,   1.0547631E-04
     +,   1.0911116E-04,   1.1286981E-04,   1.1674299E-04
     +,   1.2072102E-04,   1.2479391E-04,   1.2895140E-04
     +,   1.3318304E-04,   1.3747820E-04,   1.4182621E-04
     +,   1.4621625E-04,   1.5063766E-04,   1.5507970E-04
     +,   1.5953196E-04,   1.6398348E-04,   1.6842454E-04
     +,   1.7284484E-04,   1.7723454E-04,   1.8158421E-04
     +,   1.8588407E-04,   1.9012525E-04,   1.9429890E-04
     +,   1.9839624E-04,   2.0240950E-04,   2.0633001E-04
     +,   2.1015019E-04,   2.1386234E-04,   2.1745914E-04
     +,   2.2093346E-04,   2.2427783E-04,   2.2748583E-04
     +,   2.3055056E-04,   2.3346549E-04,   2.3622419E-04
     +,   2.3882014E-04,   2.4124728E-04,   2.4349950E-04
     +,   2.4557073E-04,   2.4745549E-04,   2.4914785E-04
     +,   2.5064248E-04,   2.5193402E-04,   2.5301753E-04
     +,   2.5388823E-04,   2.5454166E-04,   2.5497380E-04
     +,   2.5518090E-04,   2.5515957E-04,   2.5490715E-04
     +,   2.5442120E-04,   2.5370013E-04,   2.5274270E-04
     +,   2.5154845E-04,   2.5011768E-04,   2.4845125E-04
     +,   2.4655071E-04,   2.4441871E-04,   2.4205832E-04
     +,   2.3947362E-04,   2.3666947E-04,   2.3365147E-04
     +,   2.3042613E-04,   2.2700067E-04,   2.2338307E-04
     +,   2.1958203E-04,   2.1560707E-04,   2.1146824E-04
     +,   2.0717626E-04,   2.0274236E-04,   1.9817826E-04
     +,   1.9349616E-04,   1.8870861E-04,   1.8382834E-04
     +,   1.7886845E-04,   1.7384203E-04,   1.6876229E-04
     +,   1.6364247E-04,   1.5849562E-04,   1.5333437E-04
     +,   1.4817191E-04,   1.4302052E-04,   1.3789175E-04
     +,   1.3279732E-04,   1.2774805E-04,   1.2275485E-04
     +,   1.1782733E-04,   1.1297475E-04,   1.0820568E-04
     +,   1.0352801E-04,   9.8948884E-05,   9.4474759E-05
     +,   9.0111360E-05,   8.5863641E-05,   8.1735714E-05
     +,   7.7731464E-05,   7.3853756E-05,   7.0104434E-05
     +,   6.6485169E-05,   6.2996776E-05,   5.9639864E-05
     +,   5.6414090E-05,   5.3318694E-05,   5.0352515E-05
     +,   4.7513931E-05,   4.4800916E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wao_hz_60 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_wao_hz_65(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  2.2438493E-05,   2.2673563E-05
     +,   2.2903334E-05,   2.3127779E-05,   2.3346880E-05
     +,   2.3560640E-05,   2.3769067E-05,   2.3972196E-05
     +,   2.4170073E-05,   2.4362753E-05,   2.4550296E-05
     +,   2.4732792E-05,   2.4910338E-05,   2.5083036E-05
     +,   2.5251009E-05,   2.5414380E-05,   2.5573281E-05
     +,   2.5727868E-05,   2.5878282E-05,   2.6024696E-05
     +,   2.6167272E-05,   2.6306188E-05,   2.6441618E-05
     +,   2.6573762E-05,   2.6702794E-05,   2.6828922E-05
     +,   2.6952350E-05,   2.7073283E-05,   2.7191943E-05
     +,   2.7308548E-05,   2.7423335E-05,   2.7536547E-05
     +,   2.7648437E-05,   2.7759274E-05,   2.7869346E-05
     +,   2.7978951E-05,   2.8088421E-05,   2.8198112E-05
     +,   2.8308406E-05,   2.8419718E-05,   2.8532511E-05
     +,   2.8647279E-05,   2.8764573E-05,   2.8885015E-05
     +,   2.9009263E-05,   2.9138057E-05,   2.9272216E-05
     +,   2.9412640E-05,   2.9560319E-05,   2.9716331E-05
     +,   2.9881874E-05,   3.0058249E-05,   3.0246872E-05
     +,   3.0449286E-05,   3.0667179E-05,   3.0902356E-05
     +,   3.1156764E-05,   3.1432530E-05,   3.1731877E-05
     +,   3.2057218E-05,   3.2411110E-05,   3.2796244E-05
     +,   3.3215500E-05,   3.3671848E-05,   3.4168450E-05
     +,   3.4708562E-05,   3.5295601E-05,   3.5933062E-05
     +,   3.6624551E-05,   3.7373764E-05,   3.8184451E-05
     +,   3.9060396E-05,   4.0005430E-05,   4.1023355E-05
     +,   4.2117987E-05,   4.3292966E-05,   4.4551973E-05
     +,   4.5898469E-05,   4.7335780E-05,   4.8867103E-05
     +,   5.0495284E-05,   5.2222982E-05,   5.4052576E-05
     +,   5.5985871E-05,   5.8024441E-05,   6.0169670E-05
     +,   6.2421997E-05,   6.4781685E-05,   6.7248366E-05
     +,   6.9821130E-05,   7.2498478E-05,   7.5278243E-05
     +,   7.8157660E-05,   8.1133308E-05,   8.4201078E-05
     +,   8.7356202E-05,   9.0593167E-05,   9.3905866E-05
     +,   9.7287448E-05,   1.0073045E-04,   1.0422674E-04
     +,   1.0776761E-04,   1.1134368E-04,   1.1494513E-04
     +,   1.1856157E-04,   1.2218217E-04,   1.2579573E-04
     +,   1.2939078E-04,   1.3295522E-04,   1.3647700E-04
     +,   1.3994431E-04,   1.4334448E-04,   1.4666541E-04
     +,   1.4989497E-04,   1.5302113E-04,   1.5603223E-04
     +,   1.5891682E-04,   1.6166402E-04,   1.6426333E-04
     +,   1.6670482E-04,   1.6897928E-04,   1.7107822E-04
     +,   1.7299385E-04,   1.7471930E-04,   1.7624868E-04
     +,   1.7757685E-04,   1.7869985E-04,   1.7961471E-04
     +,   1.8031946E-04,   1.8081328E-04,   1.8109646E-04
     +,   1.8117036E-04,   1.8103745E-04,   1.8070127E-04
     +,   1.8016653E-04,   1.7943885E-04,   1.7852498E-04
     +,   1.7743256E-04,   1.7617022E-04,   1.7474734E-04
     +,   1.7317425E-04,   1.7146193E-04,   1.6962204E-04
     +,   1.6766677E-04,   1.6560890E-04,   1.6346147E-04
     +,   1.6123823E-04,   1.5895252E-04,   1.5661847E-04
     +,   1.5424992E-04,   1.5186073E-04,   1.4946467E-04
     +,   1.4707523E-04,   1.4470573E-04,   1.4236897E-04
     +,   1.4007739E-04,   1.3784287E-04,   1.3567678E-04
     +,   1.3358973E-04,   1.3159172E-04,   1.2969202E-04
     +,   1.2789910E-04,   1.2622065E-04,   1.2466362E-04
     +,   1.2323412E-04,   1.2193742E-04,   1.2077808E-04
     +,   1.1975990E-04,   1.1888595E-04,   1.1815856E-04
     +,   1.1757966E-04,   1.1715037E-04,   1.1687145E-04
     +,   1.1674326E-04,   1.1676575E-04,   1.1693859E-04
     +,   1.1726133E-04,   1.1773338E-04,   1.1835403E-04
     +,   1.1912268E-04,   1.2003870E-04,   1.2110162E-04
     +,   1.2231113E-04,   1.2366704E-04,   1.2516936E-04
     +,   1.2681822E-04,   1.2861390E-04,   1.3055677E-04
     +,   1.3264724E-04,   1.3488560E-04,   1.3727215E-04
     +,   1.3980684E-04,   1.4248934E-04,   1.4531893E-04
     +,   1.4829430E-04,   1.5141346E-04,   1.5467372E-04
     +,   1.5807158E-04,   1.6160260E-04,   1.6526133E-04
     +,   1.6904141E-04,   1.7293541E-04,   1.7693496E-04
     +,   1.8103066E-04,   1.8521235E-04,   1.8946909E-04
     +,   1.9378928E-04,   1.9816084E-04,   2.0257148E-04
     +,   2.0700887E-04,   2.1146022E-04,   2.1591394E-04
     +,   2.2035836E-04,   2.2478262E-04,   2.2917701E-04
     +,   2.3353226E-04,   2.3784090E-04,   2.4209637E-04
     +,   2.4629338E-04,   2.5042862E-04,   2.5449909E-04
     +,   2.5850357E-04,   2.6244184E-04,   2.6631460E-04
     +,   2.7012351E-04,   2.7386990E-04,   2.7755671E-04
     +,   2.8118584E-04,   2.8475936E-04,   2.8827882E-04
     +,   2.9174465E-04,   2.9515679E-04,   2.9851359E-04
     +,   3.0181231E-04,   3.0504883E-04,   3.0821687E-04
     +,   3.1130933E-04,   3.1431683E-04,   3.1722919E-04
     +,   3.2003422E-04,   3.2271896E-04,   3.2526909E-04
     +,   3.2766970E-04,   3.2990501E-04,   3.3195919E-04
     +,   3.3381590E-04,   3.3545928E-04,   3.3687369E-04
     +,   3.3804419E-04,   3.3895631E-04,   3.3959679E-04
     +,   3.3995326E-04,   3.4001452E-04,   3.3977072E-04
     +,   3.3921300E-04,   3.3833407E-04,   3.3712760E-04
     +,   3.3558861E-04,   3.3371337E-04,   3.3149906E-04
     +,   3.2894421E-04,   3.2604809E-04,   3.2281133E-04
     +,   3.1923509E-04,   3.1532190E-04,   3.1107513E-04
     +,   3.0649896E-04,   3.0159886E-04,   2.9638136E-04
     +,   2.9085414E-04,   2.8502609E-04,   2.7890739E-04
     +,   2.7250979E-04,   2.6584638E-04,   2.5893140E-04
     +,   2.5178163E-04,   2.4441487E-04,   2.3684966E-04
     +,   2.2910717E-04,   2.2120919E-04,   2.1317991E-04
     +,   2.0504366E-04,   1.9682609E-04,   1.8855365E-04
     +,   1.8025340E-04,   1.7195269E-04,   1.6367897E-04
     +,   1.5545952E-04,   1.4732107E-04,   1.3928945E-04
     +,   1.3139036E-04,   1.2364765E-04,   1.1608307E-04
     +,   1.0871762E-04,   1.0156992E-04,   9.4657480E-05
     +,   8.7994755E-05,   8.1594342E-05,   7.5466611E-05
     +,   6.9619644E-05,   6.4059313E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wao_hz_65 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_wao_hz_70(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  4.5922440E-07,   4.9714822E-07
     +,   5.3773221E-07,   5.8112198E-07,   6.2746824E-07
     +,   6.7692622E-07,   7.2965634E-07,   7.8582366E-07
     +,   8.4559878E-07,   9.0915762E-07,   9.7667737E-07
     +,   1.0483441E-06,   1.1243472E-06,   1.2048820E-06
     +,   1.2901469E-06,   1.3803476E-06,   1.4756930E-06
     +,   1.5763984E-06,   1.6826847E-06,   1.7947771E-06
     +,   1.9129079E-06,   2.0373159E-06,   2.1682449E-06
     +,   2.3059499E-06,   2.4506835E-06,   2.6027151E-06
     +,   2.7623194E-06,   2.9297807E-06,   3.1053908E-06
     +,   3.2894548E-06,   3.4822858E-06,   3.6842109E-06
     +,   3.8955682E-06,   4.1167100E-06,   4.3480031E-06
     +,   4.5898296E-06,   4.8425877E-06,   5.1066936E-06
     +,   5.3825797E-06,   5.6707008E-06,   5.9715298E-06
     +,   6.2855675E-06,   6.6133098E-06,   6.9553244E-06
     +,   7.3121514E-06,   7.6843862E-06,   8.0726368E-06
     +,   8.4775447E-06,   8.8997685E-06,   9.3399931E-06
     +,   9.7989341E-06,   1.0277329E-05,   1.0775940E-05
     +,   1.1295554E-05,   1.1836992E-05,   1.2401064E-05
     +,   1.2988633E-05,   1.3600578E-05,   1.4237786E-05
     +,   1.4901163E-05,   1.5591633E-05,   1.6310129E-05
     +,   1.7057588E-05,   1.7834956E-05,   1.8643183E-05
     +,   1.9483210E-05,   2.0355976E-05,   2.1262411E-05
     +,   2.2203416E-05,   2.3179895E-05,   2.4192695E-05
     +,   2.5242649E-05,   2.6330543E-05,   2.7457107E-05
     +,   2.8623050E-05,   2.9828934E-05,   3.1075320E-05
     +,   3.2362652E-05,   3.3691267E-05,   3.5061461E-05
     +,   3.6473331E-05,   3.7926875E-05,   3.9422008E-05
     +,   4.0958286E-05,   4.2535234E-05,   4.4152381E-05
     +,   4.5808676E-05,   4.7503101E-05,   4.9234386E-05
     +,   5.1001000E-05,   5.2801181E-05,   5.4632925E-05
     +,   5.6493987E-05,   5.8381866E-05,   6.0293798E-05
     +,   6.2226791E-05,   6.4177606E-05,   6.6142828E-05
     +,   6.8118781E-05,   7.0101662E-05,   7.2087503E-05
     +,   7.4072239E-05,   7.6051743E-05,   7.8021876E-05
     +,   7.9978512E-05,   8.1917649E-05,   8.3835439E-05
     +,   8.5728323E-05,   8.7592831E-05,   8.9425987E-05
     +,   9.1225498E-05,   9.2989132E-05,   9.4715528E-05
     +,   9.6403892E-05,   9.8054144E-05,   9.9666919E-05
     +,   1.0124366E-04,   1.0278661E-04,   1.0429882E-04
     +,   1.0578417E-04,   1.0724733E-04,   1.0869376E-04
     +,   1.1012956E-04,   1.1156144E-04,   1.1299667E-04
     +,   1.1444295E-04,   1.1590819E-04,   1.1740054E-04
     +,   1.1892800E-04,   1.2049854E-04,   1.2211966E-04
     +,   1.2379850E-04,   1.2554144E-04,   1.2735419E-04
     +,   1.2924142E-04,   1.3120694E-04,   1.3325342E-04
     +,   1.3538243E-04,   1.3759453E-04,   1.3988916E-04
     +,   1.4226495E-04,   1.4471973E-04,   1.4725064E-04
     +,   1.4985463E-04,   1.5252875E-04,   1.5527020E-04
     +,   1.5807667E-04,   1.6094750E-04,   1.6388290E-04
     +,   1.6688537E-04,   1.6995950E-04,   1.7311265E-04
     +,   1.7635504E-04,   1.7970010E-04,   1.8316464E-04
     +,   1.8676884E-04,   1.9053629E-04,   1.9449355E-04
     +,   1.9867020E-04,   2.0309789E-04,   2.0780996E-04
     +,   2.1284056E-04,   2.1822349E-04,   2.2399140E-04
     +,   2.3017432E-04,   2.3679834E-04,   2.4388457E-04
     +,   2.5144743E-04,   2.5949356E-04,   2.6802107E-04
     +,   2.7701695E-04,   2.8645829E-04,   2.9631009E-04
     +,   3.0652713E-04,   3.1705186E-04,   3.2781446E-04
     +,   3.3873654E-04,   3.4972985E-04,   3.6069888E-04
     +,   3.7154183E-04,   3.8215361E-04,   3.9242749E-04
     +,   4.0225769E-04,   4.1154178E-04,   4.2018318E-04
     +,   4.2809348E-04,   4.3519484E-04,   4.4142175E-04
     +,   4.4672351E-04,   4.5106461E-04,   4.5442721E-04
     +,   4.5681075E-04,   4.5823347E-04,   4.5873137E-04
     +,   4.5835893E-04,   4.5718745E-04,   4.5530405E-04
     +,   4.5281014E-04,   4.4981926E-04,   4.4645439E-04
     +,   4.4284566E-04,   4.3912668E-04,   4.3543198E-04
     +,   4.3189310E-04,   4.2863525E-04,   4.2577449E-04
     +,   4.2341452E-04,   4.2164372E-04,   4.2053362E-04
     +,   4.2013655E-04,   4.2048536E-04,   4.2159244E-04
     +,   4.2345090E-04,   4.2603471E-04,   4.2930173E-04
     +,   4.3319463E-04,   4.3764481E-04,   4.4257549E-04
     +,   4.4790434E-04,   4.5354958E-04,   4.5942969E-04
     +,   4.6547040E-04,   4.7160653E-04,   4.7778434E-04
     +,   4.8396550E-04,   4.9012544E-04,   4.9625902E-04
     +,   5.0237688E-04,   5.0850719E-04,   5.1469431E-04
     +,   5.2099640E-04,   5.2748434E-04,   5.3423876E-04
     +,   5.4134656E-04,   5.4889929E-04,   5.5698707E-04
     +,   5.6569825E-04,   5.7511445E-04,   5.8530760E-04
     +,   5.9633667E-04,   6.0824567E-04,   6.2105927E-04
     +,   6.3478138E-04,   6.4939185E-04,   6.6484383E-04
     +,   6.8106141E-04,   6.9793826E-04,   7.1533537E-04
     +,   7.3308061E-04,   7.5096841E-04,   7.6876220E-04
     +,   7.8619632E-04,   8.0298091E-04,   8.1880786E-04
     +,   8.3335850E-04,   8.4631395E-04,   8.5736351E-04
     +,   8.6621690E-04,   8.7261415E-04,   8.7633601E-04
     +,   8.7721233E-04,   8.7512855E-04,   8.7003002E-04
     +,   8.6192228E-04,   8.5087150E-04,   8.3699793E-04
     +,   8.2047086E-04,   8.0149987E-04,   7.8032422E-04
     +,   7.5720443E-04,   7.3241012E-04,   7.0621358E-04
     +,   6.7887956E-04,   6.5065990E-04,   6.2178902E-04
     +,   5.9248443E-04,   5.6294055E-04,   5.3332915E-04
     +,   5.0380698E-04,   4.7451138E-04,   4.4556896E-04
     +,   4.1709084E-04,   3.8917927E-04,   3.6192828E-04
     +,   3.3542523E-04,   3.0975085E-04,   2.8497991E-04
     +,   2.6118042E-04,   2.3841372E-04,   2.1673218E-04
     +,   1.9618255E-04,   1.7680017E-04,   1.5860891E-04
     +,   1.4162458E-04,   1.2585110E-04,   1.1128357E-04
     +,   9.7904725E-05,   8.5688203E-05,   7.4598618E-05
     +,   6.4592445E-05,   5.5619079E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wao_hz_70 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_wao_hz_75(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  5.4426433E-08,   6.1560144E-08
     +,   6.9544519E-08,   7.8469235E-08,   8.8431982E-08
     +,   9.9538887E-08,   1.1190500E-07,   1.2565496E-07
     +,   1.4092348E-07,   1.5785616E-07,   1.7660864E-07
     +,   1.9734951E-07,   2.2025887E-07,   2.4552986E-07
     +,   2.7336867E-07,   3.0399488E-07,   3.3764294E-07
     +,   3.7456087E-07,   4.1501190E-07,   4.5927450E-07
     +,   5.0764197E-07,   5.6042325E-07,   6.1794293E-07
     +,   6.8054209E-07,   7.4857314E-07,   8.2240734E-07
     +,   9.0242924E-07,   9.8903786E-07,   1.0826453E-06
     +,   1.1836764E-06,   1.2925677E-06,   1.4097666E-06
     +,   1.5357296E-06,   1.6709200E-06,   1.8158090E-06
     +,   1.9708721E-06,   2.1365845E-06,   2.3134246E-06
     +,   2.5018667E-06,   2.7023812E-06,   2.9154296E-06
     +,   3.1414700E-06,   3.3809249E-06,   3.6342353E-06
     +,   3.9017868E-06,   4.1839621E-06,   4.4811100E-06
     +,   4.7935487E-06,   5.1215629E-06,   5.4653942E-06
     +,   5.8252467E-06,   6.2012755E-06,   6.5935851E-06
     +,   7.0022247E-06,   7.4271984E-06,   7.8684197E-06
     +,   8.3257637E-06,   8.7990320E-06,   9.2879518E-06
     +,   9.7921838E-06,   1.0311307E-05,   1.0844825E-05
     +,   1.1392164E-05,   1.1952673E-05,   1.2525619E-05
     +,   1.3110188E-05,   1.3705489E-05,   1.4310550E-05
     +,   1.4924326E-05,   1.5545695E-05,   1.6173466E-05
     +,   1.6806378E-05,   1.7443110E-05,   1.8082275E-05
     +,   1.8722458E-05,   1.9362144E-05,   1.9999825E-05
     +,   2.0633945E-05,   2.1262906E-05,   2.1885140E-05
     +,   2.2499025E-05,   2.3102955E-05,   2.3695364E-05
     +,   2.4274623E-05,   2.4839192E-05,   2.5387639E-05
     +,   2.5918442E-05,   2.6430238E-05,   2.6921711E-05
     +,   2.7391628E-05,   2.7838854E-05,   2.8262340E-05
     +,   2.8661167E-05,   2.9034532E-05,   2.9381754E-05
     +,   2.9702291E-05,   2.9995732E-05,   3.0261835E-05
     +,   3.0500485E-05,   3.0711733E-05,   3.0895779E-05
     +,   3.1052994E-05,   3.1183878E-05,   3.1289102E-05
     +,   3.1369480E-05,   3.1425971E-05,   3.1459669E-05
     +,   3.1471805E-05,   3.1463718E-05,   3.1436874E-05
     +,   3.1392821E-05,   3.1333217E-05,   3.1259777E-05
     +,   3.1174295E-05,   3.1078609E-05,   3.0974628E-05
     +,   3.0864256E-05,   3.0749467E-05,   3.0632229E-05
     +,   3.0514570E-05,   3.0398529E-05,   3.0286203E-05
     +,   3.0179761E-05,   3.0081454E-05,   2.9993675E-05
     +,   2.9918994E-05,   2.9860224E-05,   2.9820487E-05
     +,   2.9803310E-05,   2.9812720E-05,   2.9853358E-05
     +,   2.9930607E-05,   3.0050727E-05,   3.0221006E-05
     +,   3.0449923E-05,   3.0747262E-05,   3.1124335E-05
     +,   3.1594045E-05,   3.2171065E-05,   3.2871889E-05
     +,   3.3714907E-05,   3.4720422E-05,   3.5910543E-05
     +,   3.7309113E-05,   3.8941438E-05,   4.0834115E-05
     +,   4.3014152E-05,   4.5509423E-05,   4.8346777E-05
     +,   5.1552310E-05,   5.5150111E-05,   5.9161386E-05
     +,   6.3603475E-05,   6.8488895E-05,   7.3824289E-05
     +,   7.9609425E-05,   8.5836327E-05,   9.2488517E-05
     +,   9.9540404E-05,   1.0695691E-04,   1.1469352E-04
     +,   1.2269635E-04,   1.3090292E-04,   1.3924304E-04
     +,   1.4764022E-04,   1.5601338E-04,   1.6427903E-04
     +,   1.7235357E-04,   1.8015590E-04,   1.8761065E-04
     +,   1.9464958E-04,   2.0121624E-04,   2.0726719E-04
     +,   2.1277541E-04,   2.1773110E-04,   2.2214311E-04
     +,   2.2604111E-04,   2.2947478E-04,   2.3251392E-04
     +,   2.3524772E-04,   2.3778281E-04,   2.4024161E-04
     +,   2.4275971E-04,   2.4548231E-04,   2.4856083E-04
     +,   2.5214840E-04,   2.5639511E-04,   2.6144271E-04
     +,   2.6741889E-04,   2.7443154E-04,   2.8256312E-04
     +,   2.9186544E-04,   3.0235582E-04,   3.1401488E-04
     +,   3.2678639E-04,   3.4057998E-04,   3.5527721E-04
     +,   3.7074109E-04,   3.8682789E-04,   4.0340214E-04
     +,   4.2035294E-04,   4.3761061E-04,   4.5516135E-04
     +,   4.7305893E-04,   4.9143186E-04,   5.1048351E-04
     +,   5.3048471E-04,   5.5175897E-04,   5.7466014E-04
     +,   5.9954426E-04,   6.2673236E-04,   6.5648736E-04
     +,   6.8897294E-04,   7.2423363E-04,   7.6217944E-04
     +,   8.0257352E-04,   8.4504799E-04,   8.8911277E-04
     +,   9.3417784E-04,   9.7958988E-04,   1.0246368E-03
     +,   1.0685885E-03,   1.1106998E-03,   1.1502177E-03
     +,   1.1863820E-03,   1.2184200E-03,   1.2455567E-03
     +,   1.2670211E-03,   1.2820755E-03,   1.2900592E-03
     +,   1.2904463E-03,   1.2829120E-03,   1.2673950E-03
     +,   1.2441539E-03,   1.2137907E-03,   1.1772591E-03
     +,   1.1358244E-03,   1.0909949E-03,   1.0444314E-03
     +,   9.9783367E-04,   9.5283025E-04,   9.1086840E-04
     +,   8.7313185E-04,   8.4047823E-04,   8.1340951E-04
     +,   7.9206825E-04,   7.7626144E-04,   7.6550146E-04
     +,   7.5906358E-04,   7.5604854E-04,   7.5544958E-04
     +,   7.5621693E-04,   7.5731880E-04,   7.5779489E-04
     +,   7.5679988E-04,   7.5363833E-04,   7.4778753E-04
     +,   7.3890801E-04,   7.2684477E-04,   7.1161764E-04
     +,   6.9340138E-04,   6.7250320E-04,   6.4933114E-04
     +,   6.2436378E-04,   5.9811841E-04,   5.7112199E-04
     +,   5.4388435E-04,   5.1687728E-04,   4.9051718E-04
     +,   4.6515311E-04,   4.4106055E-04,   4.1843846E-04
     +,   3.9741071E-04,   3.7803114E-04,   3.6028901E-04
     +,   3.4412168E-04,   3.2942003E-04,   3.1603943E-04
     +,   3.0381291E-04,   2.9255843E-04,   2.8208975E-04
     +,   2.7222245E-04,   2.6278215E-04,   2.5361046E-04
     +,   2.4456866E-04,   2.3554126E-04,   2.2643789E-04
     +,   2.1719380E-04,   2.0776954E-04,   1.9814938E-04
     +,   1.8834053E-04,   1.7836863E-04,   1.6827424E-04
     +,   1.5811155E-04,   1.4794257E-04,   1.3783593E-04
     +,   1.2786075E-04,   1.1808558E-04,   1.0857521E-04
     +,   9.9388730E-05,   9.0577923E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wao_hz_75 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_wao_hz_80(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  3.8538084E-07,   4.1541574E-07
     +,   4.4747509E-07,   4.8167004E-07,   5.1811617E-07
     +,   5.5693300E-07,   5.9824492E-07,   6.4218079E-07
     +,   6.8887368E-07,   7.3846263E-07,   7.9108793E-07
     +,   8.4689736E-07,   9.0604283E-07,   9.6868052E-07
     +,   1.0349715E-06,   1.1050809E-06,   1.1791786E-06
     +,   1.2574402E-06,   1.3400438E-06,   1.4271731E-06
     +,   1.5190160E-06,   1.6157644E-06,   1.7176144E-06
     +,   1.8247686E-06,   1.9374261E-06,   2.0557961E-06
     +,   2.1800902E-06,   2.3105208E-06,   2.4473063E-06
     +,   2.5906652E-06,   2.7408182E-06,   2.8979887E-06
     +,   3.0624017E-06,   3.2342814E-06,   3.4138545E-06
     +,   3.6013455E-06,   3.7969792E-06,   4.0009786E-06
     +,   4.2135634E-06,   4.4349522E-06,   4.6653577E-06
     +,   4.9049950E-06,   5.1540483E-06,   5.4127381E-06
     +,   5.6812341E-06,   5.9597214E-06,   6.2483691E-06
     +,   6.5473314E-06,   6.8567542E-06,   7.1767672E-06
     +,   7.5074845E-06,   7.8489993E-06,   8.2013921E-06
     +,   8.5647189E-06,   8.9390260E-06,   9.3243070E-06
     +,   9.7205566E-06,   1.0127740E-05,   1.0545788E-05
     +,   1.0974604E-05,   1.1414062E-05,   1.1864004E-05
     +,   1.2324237E-05,   1.2794542E-05,   1.3274651E-05
     +,   1.3764271E-05,   1.4263070E-05,   1.4770681E-05
     +,   1.5286694E-05,   1.5810674E-05,   1.6342139E-05
     +,   1.6880580E-05,   1.7425449E-05,   1.7976168E-05
     +,   1.8532139E-05,   1.9092700E-05,   1.9657205E-05
     +,   2.0224961E-05,   2.0795258E-05,   2.1367396E-05
     +,   2.1940639E-05,   2.2514248E-05,   2.3087514E-05
     +,   2.3659664E-05,   2.4229983E-05,   2.4797851E-05
     +,   2.5362537E-05,   2.5923431E-05,   2.6479958E-05
     +,   2.7031603E-05,   2.7577906E-05,   2.8118486E-05
     +,   2.8653059E-05,   2.9181450E-05,   2.9703588E-05
     +,   3.0219535E-05,   3.0729505E-05,   3.1233871E-05
     +,   3.1733180E-05,   3.2228170E-05,   3.2719807E-05
     +,   3.3209257E-05,   3.3697961E-05,   3.4187611E-05
     +,   3.4680179E-05,   3.5177934E-05,   3.5683479E-05
     +,   3.6199755E-05,   3.6729969E-05,   3.7277747E-05
     +,   3.7847138E-05,   3.8442417E-05,   3.9068316E-05
     +,   3.9729912E-05,   4.0432617E-05,   4.1182178E-05
     +,   4.1984651E-05,   4.2846343E-05,   4.3773798E-05
     +,   4.4773715E-05,   4.5852888E-05,   4.7018155E-05
     +,   4.8276266E-05,   4.9633829E-05,   5.1097144E-05
     +,   5.2672167E-05,   5.4364282E-05,   5.6178251E-05
     +,   5.8118017E-05,   6.0186627E-05,   6.2385989E-05
     +,   6.4716827E-05,   6.7178531E-05,   6.9768990E-05
     +,   7.2484581E-05,   7.5319949E-05,   7.8268138E-05
     +,   8.1320359E-05,   8.4466177E-05,   8.7693385E-05
     +,   9.0988222E-05,   9.4335424E-05,   9.7718366E-05
     +,   1.0111935E-04,   1.0451973E-04,   1.0790047E-04
     +,   1.1124167E-04,   1.1452442E-04,   1.1772937E-04
     +,   1.2083846E-04,   1.2383475E-04,   1.2670286E-04
     +,   1.2942943E-04,   1.3200341E-04,   1.3441632E-04
     +,   1.3666262E-04,   1.3873988E-04,   1.4064879E-04
     +,   1.4239344E-04,   1.4398117E-04,   1.4542250E-04
     +,   1.4673082E-04,   1.4792231E-04,   1.4901553E-04
     +,   1.5003083E-04,   1.5099019E-04,   1.5191648E-04
     +,   1.5283310E-04,   1.5376357E-04,   1.5473099E-04
     +,   1.5575801E-04,   1.5686663E-04,   1.5807831E-04
     +,   1.5941462E-04,   1.6089757E-04,   1.6255074E-04
     +,   1.6440115E-04,   1.6648060E-04,   1.6882863E-04
     +,   1.7149525E-04,   1.7454462E-04,   1.7805994E-04
     +,   1.8214839E-04,   1.8694800E-04,   1.9263485E-04
     +,   1.9943183E-04,   2.0761864E-04,   2.1754196E-04
     +,   2.2962730E-04,   2.4438911E-04,   2.6244184E-04
     +,   2.8450566E-04,   3.1140933E-04,   3.4408321E-04
     +,   3.8354142E-04,   4.3084790E-04,   4.8706136E-04
     +,   5.5315928E-04,   6.2993477E-04,   7.1787561E-04
     +,   8.1702380E-04,   9.2683750E-04,   1.0460637E-03
     +,   1.1726487E-03,   1.3037067E-03,   1.4355662E-03
     +,   1.5639097E-03,   1.6840101E-03,   1.7910459E-03
     +,   1.8804923E-03,   1.9485048E-03,   1.9923353E-03
     +,   2.0106051E-03,   2.0035151E-03,   1.9728818E-03
     +,   1.9220206E-03,   1.8554615E-03,   1.7785477E-03
     +,   1.6969574E-03,   1.6161783E-03,   1.5410952E-03
     +,   1.4756153E-03,   1.4225102E-03,   1.3834256E-03
     +,   1.3590623E-03,   1.3494887E-03,   1.3544889E-03
     +,   1.3738528E-03,   1.4075238E-03,   1.4555486E-03
     +,   1.5178209E-03,   1.5937279E-03,   1.6817773E-03
     +,   1.7793532E-03,   1.8827370E-03,   1.9873325E-03
     +,   2.0882208E-03,   2.1807519E-03,   2.2611627E-03
     +,   2.3270247E-03,   2.3774453E-03,   2.4130240E-03
     +,   2.4355841E-03,   2.4477590E-03,   2.4525118E-03
     +,   2.4526503E-03,   2.4504196E-03,   2.4471814E-03
     +,   2.4432358E-03,   2.4378009E-03,   2.4291393E-03
     +,   2.4148321E-03,   2.3921344E-03,   2.3583758E-03
     +,   2.3113445E-03,   2.2496015E-03,   2.1726876E-03
     +,   2.0812154E-03,   1.9768130E-03,   1.8619597E-03
     +,   1.7397163E-03,   1.6134118E-03,   1.4863176E-03
     +,   1.3613658E-03,   1.2409473E-03,   1.1268095E-03
     +,   1.0200456E-03,   9.2117256E-04,   8.3025289E-04
     +,   7.4703764E-04,   6.7110499E-04,   6.0196716E-04
     +,   5.3914427E-04,   4.8220079E-04,   4.3075066E-04
     +,   3.8445459E-04,   3.4298754E-04,   3.0602133E-04
     +,   2.7321992E-04,   2.4422677E-04,   2.1867527E-04
     +,   1.9619173E-04,   1.7641320E-04,   1.5899837E-04
     +,   1.4363715E-04,   1.3005611E-04,   1.1802015E-04
     +,   1.0733057E-04,   9.7820695E-05,   8.9350069E-05
     +,   8.1800179E-05,   7.5067423E-05,   6.9059330E-05
     +,   6.3692874E-05,   5.8891277E-05,   5.4584038E-05
     +,   5.0705428E-05,   4.7195444E-05,   4.3999775E-05
     +,   4.1070176E-05,   3.8364571E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wao_hz_80 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_wao_hz_85(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  1.6776681E-24,   2.7181739E-24
     +,   4.3922328E-24,   7.0783519E-24,   1.1376778E-23
     +,   1.8236509E-23,   2.9154201E-23,   4.6483550E-23
     +,   7.3915579E-23,   1.1722349E-22,   1.8540669E-22
     +,   2.9246560E-22,   4.6010952E-22,   7.2191527E-22
     +,   1.1296657E-21,   1.7629931E-21,   2.7440263E-21
     +,   4.2595589E-21,   6.5944410E-21,   1.0181928E-20
     +,   1.5679081E-20,   2.4079544E-20,   3.6881870E-20
     +,   5.6340357E-20,   8.5834425E-20,   1.3041889E-19
     +,   1.9763163E-19,   2.9868287E-19,   4.5019729E-19
     +,   6.7675771E-19,   1.0146133E-18,   1.5170705E-18
     +,   2.2623013E-18,   3.3645844E-18,   4.9905705E-18
     +,   7.3825721E-18,   1.0891864E-17,   1.6026351E-17
     +,   2.3518297E-17,   3.4420249E-17,   5.0241319E-17
     +,   7.3138899E-17,   1.0618598E-16,   1.5375545E-16
     +,   2.2203860E-16,   3.1979030E-16,   4.5934538E-16
     +,   6.5803877E-16,   9.4015977E-16,   1.3396458E-15
     +,   1.9037788E-15,   2.6982440E-15,   3.8140314E-15
     +,   5.3768216E-15,   7.5597716E-15,   1.0600515E-14
     +,   1.4824627E-14,   2.0676603E-14,   2.8761627E-14
     +,   3.9901252E-14,   5.5207466E-14,   7.6181432E-14
     +,   1.0484305E-13,   1.4390294E-13,   1.9698785E-13
     +,   2.6893554E-13,   3.6618272E-13,   4.9726423E-13
     +,   6.7347088E-13,   9.0968249E-13,   1.2254709E-12
     +,   1.6464823E-12,   2.2062469E-12,   2.9484470E-12
     +,   3.9298703E-12,   5.2240135E-12,   6.9258666E-12
     +,   9.1577622E-12,   1.2076694E-11,   1.5883803E-11
     +,   2.0835739E-11,   2.7259098E-11,   3.5568711E-11
     +,   4.6288164E-11,   6.0078373E-11,   7.7772837E-11
     +,   1.0041243E-10,   1.2930085E-10,   1.6606297E-10
     +,   2.1271720E-10,   2.7176392E-10,   3.4629294E-10
     +,   4.4010731E-10,   5.5787935E-10,   7.0532574E-10
     +,   8.8942581E-10,   1.1186716E-09,   1.4033662E-09
     +,   1.7559727E-09,   2.1915207E-09,   2.7280802E-09
     +,   3.3873209E-09,   4.1951358E-09,   5.1823834E-09
     +,   6.3857200E-09,   7.8485938E-09,   9.6222843E-09
     +,   1.1767309E-08,   1.4354392E-08,   1.7466473E-08
     +,   2.1200863E-08,   2.5669836E-08,   3.1004305E-08
     +,   3.7355409E-08,   4.4897561E-08,   5.3831148E-08
     +,   6.4385837E-08,   7.6824037E-08,   9.1444562E-08
     +,   1.0858663E-07,   1.2863427E-07,   1.5202072E-07
     +,   1.7923291E-07,   2.1081678E-07,   2.4738196E-07
     +,   2.8960739E-07,   3.3824554E-07,   3.9412890E-07
     +,   4.5817413E-07,   5.3138666E-07,   6.1486605E-07
     +,   7.0980940E-07,   8.1751472E-07,   9.3938434E-07
     +,   1.0769264E-06,   1.2317570E-06,   1.4055980E-06
     +,   1.6002780E-06,   1.8177298E-06,   2.0599844E-06
     +,   2.3291711E-06,   2.6275054E-06,   2.9572852E-06
     +,   3.3208828E-06,   3.7207337E-06,   4.1593462E-06
     +,   4.6391960E-06,   5.1629308E-06,   5.7330772E-06
     +,   6.3522625E-06,   7.0230990E-06,   7.7481991E-06
     +,   8.5301754E-06,   9.3716362E-06,   1.0275198E-05
     +,   1.1243475E-05,   1.2279113E-05,   1.3384789E-05
     +,   1.4563239E-05,   1.5817288E-05,   1.7149870E-05
     +,   1.8564067E-05,   2.0063138E-05,   2.1650540E-05
     +,   2.3329958E-05,   2.5105301E-05,   2.6980713E-05
     +,   2.8960518E-05,   3.1049178E-05,   3.3251312E-05
     +,   3.5571247E-05,   3.8013466E-05,   4.0582116E-05
     +,   4.3281565E-05,   4.6116125E-05,   4.9090460E-05
     +,   5.2211133E-05,   5.5487544E-05,   5.8934365E-05
     +,   6.2574763E-05,   6.6444903E-05,   7.0600021E-05
     +,   7.5122261E-05,   8.0130514E-05,   8.5792577E-05
     +,   9.2339382E-05,   1.0008122E-04,   1.0942529E-04
     +,   1.2089279E-04,   1.3513371E-04,   1.5293564E-04
     +,   1.7522206E-04,   2.0303490E-04,   2.3749775E-04
     +,   2.7975714E-04,   3.3090645E-04,   3.9190179E-04
     +,   4.6348912E-04,   5.4616219E-04,   6.4016879E-04
     +,   7.4557494E-04,   8.6238323E-04,   9.9071127E-04
     +,   1.1310407E-03,   1.2845666E-03,   1.4536295E-03
     +,   1.6420789E-03,   1.8552231E-03,   2.0988423E-03
     +,   2.3769322E-03,   2.6882263E-03,   3.0228337E-03
     +,   3.3603630E-03,   3.6717539E-03,   3.9252411E-03
     +,   4.0950775E-03,   4.1699666E-03,   4.1572754E-03
     +,   4.0810686E-03,   3.9747255E-03,   3.8716788E-03
     +,   3.7983418E-03,   3.7716515E-03,   3.8003917E-03
     +,   3.8873393E-03,   4.0292502E-03,   4.2142249E-03
     +,   4.4191331E-03,   4.6118493E-03,   4.7611664E-03
     +,   4.8515950E-03,   4.8944750E-03,   4.9257656E-03
     +,   4.9884394E-03,   5.1080403E-03,   5.2755233E-03
     +,   5.4473472E-03,   5.5618086E-03,   5.5625066E-03
     +,   5.4181796E-03,   5.1323608E-03,   4.7413413E-03
     +,   4.3026861E-03,   3.8789625E-03,   3.5221130E-03
     +,   3.2629552E-03,   3.1077876E-03,   3.0415363E-03
     +,   3.0354233E-03,   3.0565346E-03,   3.0765925E-03
     +,   3.0775496E-03,   3.0527187E-03,   3.0040282E-03
     +,   2.9374943E-03,   2.8593591E-03,   2.7742505E-03
     +,   2.6852561E-03,   2.5947588E-03,   2.5048684E-03
     +,   2.4170054E-03,   2.3310308E-03,   2.2446893E-03
     +,   2.1539817E-03,   2.0544957E-03,   1.9431524E-03
     +,   1.8196227E-03,   1.6867947E-03,   1.5501487E-03
     +,   1.4163456E-03,   1.2915967E-03,   1.1803666E-03
     +,   1.0847234E-03,   1.0043890E-03,   9.3729561E-04
     +,   8.8038907E-04,   8.3038589E-04,   7.8435778E-04
     +,   7.4007467E-04,   6.9609709E-04,   6.5172266E-04
     +,   6.0682104E-04,   5.6165969E-04,   5.1673141E-04
     +,   4.7261748E-04,   4.2989157E-04,   3.8905631E-04
     +,   3.5051053E-04,   3.1453572E-04,   2.8129641E-04
     +,   2.5085587E-04,   2.2318444E-04,   1.9818016E-04
     +,   1.7569287E-04,   1.5553735E-04,   1.3751401E-04
     +,   1.2141690E-04,   1.0704723E-04,   9.4219409E-05
     +,   8.2764971E-05,   7.2534298E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wao_hz_85 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_wao_hz_90(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  3.2368519E-09,   3.6313113E-09
     +,   4.0703778E-09,   4.5586499E-09,   5.1011559E-09
     +,   5.7033640E-09,   6.3712444E-09,   7.1112845E-09
     +,   7.9305265E-09,   8.8366425E-09,   9.8379083E-09
     +,   1.0943297E-08,   1.2162535E-08,   1.3506125E-08
     +,   1.4985382E-08,   1.6612518E-08,   1.8400661E-08
     +,   2.0363935E-08,   2.2517545E-08,   2.4877709E-08
     +,   2.7461873E-08,   3.0288721E-08,   3.3378111E-08
     +,   3.6751413E-08,   4.0431146E-08,   4.4441471E-08
     +,   4.8808030E-08,   5.3558054E-08,   5.8720332E-08
     +,   6.4325455E-08,   7.0405697E-08,   7.6995128E-08
     +,   8.4129653E-08,   9.1847063E-08,   1.0018719E-07
     +,   1.0919167E-07,   1.1890425E-07,   1.2937066E-07
     +,   1.4063860E-07,   1.5275798E-07,   1.6578065E-07
     +,   1.7976075E-07,   1.9475341E-07,   2.1081773E-07
     +,   2.2801271E-07,   2.4640036E-07,   2.6604454E-07
     +,   2.8701055E-07,   3.0936545E-07,   3.3317806E-07
     +,   3.5851849E-07,   3.8545815E-07,   4.1406975E-07
     +,   4.4442703E-07,   4.7660509E-07,   5.1067769E-07
     +,   5.4672103E-07,   5.8481083E-07,   6.2502284E-07
     +,   6.6743206E-07,   7.1211332E-07,   7.5914045E-07
     +,   8.0858609E-07,   8.6052086E-07,   9.1501386E-07
     +,   9.7213217E-07,   1.0319396E-06,   1.0944977E-06
     +,   1.1598646E-06,   1.2280938E-06,   1.2992355E-06
     +,   1.3733361E-06,   1.4504351E-06,   1.5305686E-06
     +,   1.6137683E-06,   1.7000547E-06,   1.7894470E-06
     +,   1.8819565E-06,   1.9775853E-06,   2.0763348E-06
     +,   2.1781932E-06,   2.2831434E-06,   2.3911637E-06
     +,   2.5022130E-06,   2.6162504E-06,   2.7332430E-06
     +,   2.8531201E-06,   2.9758235E-06,   3.1012837E-06
     +,   3.2294238E-06,   3.3601605E-06,   3.4934046E-06
     +,   3.6290628E-06,   3.7670350E-06,   3.9072197E-06
     +,   4.0495102E-06,   4.1938010E-06,   4.3399823E-06
     +,   4.4879462E-06,   4.6375867E-06,   4.7888002E-06
     +,   4.9414875E-06,   5.0955555E-06,   5.2509204E-06
     +,   5.4075031E-06,   5.5652399E-06,   5.7240773E-06
     +,   5.8839873E-06,   6.0449329E-06,   6.2069139E-06
     +,   6.3699699E-06,   6.5341237E-06,   6.6994498E-06
     +,   6.8660474E-06,   7.0340429E-06,   7.2036009E-06
     +,   7.3749188E-06,   7.5482394E-06,   7.7238474E-06
     +,   7.9020838E-06,   8.0833388E-06,   8.2680654E-06
     +,   8.4567937E-06,   8.6501241E-06,   8.8487550E-06
     +,   9.0534822E-06,   9.2652244E-06,   9.4850348E-06
     +,   9.7141165E-06,   9.9538711E-06,   1.0205907E-05
     +,   1.0472077E-05,   1.0754522E-05,   1.1055726E-05
     +,   1.1378553E-05,   1.1726318E-05,   1.2102862E-05
     +,   1.2512616E-05,   1.2960695E-05,   1.3452991E-05
     +,   1.3996281E-05,   1.4598330E-05,   1.5268010E-05
     +,   1.6015420E-05,   1.6852009E-05,   1.7790737E-05
     +,   1.8845973E-05,   2.0034066E-05,   2.1372800E-05
     +,   2.2881955E-05,   2.4583085E-05,   2.6499523E-05
     +,   2.8656295E-05,   3.1079988E-05,   3.3798435E-05
     +,   3.6840513E-05,   4.0235598E-05,   4.4013133E-05
     +,   4.8201975E-05,   5.2829699E-05,   5.7921719E-05
     +,   6.3500513E-05,   6.9584625E-05,   7.6187651E-05
     +,   8.3317456E-05,   9.0975089E-05,   9.9154022E-05
     +,   1.0783969E-04,   1.1700877E-04,   1.2662957E-04
     +,   1.3666046E-04,   1.4705272E-04,   1.5774924E-04
     +,   1.6868788E-04,   1.7980063E-04,   1.9101558E-04
     +,   2.0226109E-04,   2.1346644E-04,   2.2456476E-04
     +,   2.3549573E-04,   2.4620839E-04,   2.5666438E-04
     +,   2.6684071E-04,   2.7673386E-04,   2.8636333E-04
     +,   2.9577658E-04,   3.0505378E-04,   3.1431401E-04
     +,   3.2372112E-04,   3.3348988E-04,   3.4389106E-04
     +,   3.5525384E-04,   3.6796572E-04,   3.8246697E-04
     +,   3.9923983E-04,   4.1879193E-04,   4.4163663E-04
     +,   4.6827277E-04,   4.9917120E-04,   5.3477631E-04
     +,   5.7553063E-04,   6.2193483E-04,   6.7465106E-04
     +,   7.3465018E-04,   8.0340798E-04,   8.8313944E-04
     +,   9.7706879E-04,   1.0897388E-03,   1.2273875E-03
     +,   1.3984159E-03,   1.6138211E-03,   1.8874701E-03
     +,   2.2353616E-03,   2.6735666E-03,   3.2147644E-03
     +,   3.8644685E-03,   4.6191718E-03,   5.4665650E-03
     +,   6.3858875E-03,   7.3451223E-03,   8.2944203E-03
     +,   9.1644889E-03,   9.8785432E-03,   1.0380322E-02
     +,   1.0664468E-02,   1.0789980E-02,   1.0868973E-02
     +,   1.1036591E-02,   1.1406410E-02,   1.2012671E-02
     +,   1.2770142E-02,   1.3509174E-02,   1.4089160E-02
     +,   1.4487167E-02,   1.4756779E-02,   1.4906850E-02
     +,   1.4867292E-02,   1.4600151E-02,   1.4206682E-02
     +,   1.3872056E-02,   1.3701973E-02,   1.3638038E-02
     +,   1.3523587E-02,   1.3222818E-02,   1.2697037E-02
     +,   1.2029215E-02,   1.1401289E-02,   1.1003703E-02
     +,   1.0908171E-02,   1.1002132E-02,   1.1048403E-02
     +,   1.0827747E-02,   1.0261727E-02,   9.4402153E-03
     +,   8.5508171E-03,   7.7683683E-03,   7.1773455E-03
     +,   6.7634955E-03,   6.4587952E-03,   6.1968109E-03
     +,   5.9446087E-03,   5.7041971E-03,   5.4955590E-03
     +,   5.3371275E-03,   5.2333106E-03,   5.1715109E-03
     +,   5.1268055E-03,   5.0706915E-03,   4.9797874E-03
     +,   4.8413980E-03,   4.6544867E-03,   4.4267969E-03
     +,   4.1701999E-03,   3.8964914E-03,   3.6150424E-03
     +,   3.3325339E-03,   3.0537976E-03,   2.7829534E-03
     +,   2.5240451E-03,   2.2808746E-03,   2.0565179E-03
     +,   1.8527121E-03,   1.6696368E-03,   1.5060364E-03
     +,   1.3596499E-03,   1.2277621E-03,   1.1077130E-03
     +,   9.9724857E-04,   8.9469994E-04,   7.9899660E-04
     +,   7.0959225E-04,   6.2630483E-04,   5.4916757E-04
     +,   4.7831339E-04,   4.1385577E-04,   3.5583551E-04
     +,   3.0416896E-04,   2.5865101E-04,   2.1896092E-04
     +,   1.8468531E-04,   1.5534522E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wao_hz_90 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_wao_hz_95(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  5.4550508E-08,   6.0262884E-08
     +,   6.6514851E-08,   7.3350890E-08,   8.0818445E-08
     +,   8.8968008E-08,   9.7853366E-08,   1.0753167E-07
     +,   1.1806357E-07,   1.2951351E-07,   1.4194914E-07
     +,   1.5544259E-07,   1.7006965E-07,   1.8591031E-07
     +,   2.0304877E-07,   2.2157332E-07,   2.4157680E-07
     +,   2.6315632E-07,   2.8641358E-07,   3.1145461E-07
     +,   3.3839015E-07,   3.6733528E-07,   3.9840981E-07
     +,   4.3173847E-07,   4.6744859E-07,   5.0567382E-07
     +,   5.4655135E-07,   5.9022221E-07,   6.3683206E-07
     +,   6.8653003E-07,   7.3946865E-07,   7.9580394E-07
     +,   8.5569519E-07,   9.1930434E-07,   9.8679561E-07
     +,   1.0583362E-06,   1.1340941E-06,   1.2142391E-06
     +,   1.2989418E-06,   1.3883733E-06,   1.4827056E-06
     +,   1.5821103E-06,   1.6867509E-06,   1.7968041E-06
     +,   1.9124295E-06,   2.0337916E-06,   2.1610501E-06
     +,   2.2943607E-06,   2.4338749E-06,   2.5797374E-06
     +,   2.7320889E-06,   2.8910629E-06,   3.0567851E-06
     +,   3.2293744E-06,   3.4089460E-06,   3.5955936E-06
     +,   3.7894133E-06,   3.9904871E-06,   4.1988878E-06
     +,   4.4146773E-06,   4.6379059E-06,   4.8686134E-06
     +,   5.1068278E-06,   5.3525646E-06,   5.6058284E-06
     +,   5.8666105E-06,   6.1348919E-06,   6.4106412E-06
     +,   6.6938142E-06,   6.9843572E-06,   7.2822036E-06
     +,   7.5872772E-06,   7.8994899E-06,   8.2187462E-06
     +,   8.5449483E-06,   8.8779652E-06,   9.2176851E-06
     +,   9.5639780E-06,   9.9167019E-06,   1.0275734E-05
     +,   1.0640922E-05,   1.1012124E-05,   1.1389203E-05
     +,   1.1771985E-05,   1.2160317E-05,   1.2554107E-05
     +,   1.2953162E-05,   1.3357360E-05,   1.3766572E-05
     +,   1.4180666E-05,   1.4599530E-05,   1.5023050E-05
     +,   1.5451134E-05,   1.5883688E-05,   1.6320642E-05
     +,   1.6761926E-05,   1.7207498E-05,   1.7657316E-05
     +,   1.8111365E-05,   1.8569641E-05,   1.9032153E-05
     +,   1.9498933E-05,   1.9970024E-05,   2.0445486E-05
     +,   2.0925403E-05,   2.1409860E-05,   2.1898981E-05
     +,   2.2392902E-05,   2.2891732E-05,   2.3395629E-05
     +,   2.3904822E-05,   2.4419442E-05,   2.4939700E-05
     +,   2.5465813E-05,   2.5998008E-05,   2.6536503E-05
     +,   2.7081560E-05,   2.7633407E-05,   2.8192317E-05
     +,   2.8758552E-05,   2.9332377E-05,   2.9914079E-05
     +,   3.0503936E-05,   3.1102220E-05,   3.1709234E-05
     +,   3.2325279E-05,   3.2950637E-05,   3.3585617E-05
     +,   3.4230547E-05,   3.4885736E-05,   3.5551508E-05
     +,   3.6228219E-05,   3.6916212E-05,   3.7615871E-05
     +,   3.8327587E-05,   3.9051785E-05,   3.9788894E-05
     +,   4.0539413E-05,   4.1303851E-05,   4.2082775E-05
     +,   4.2876782E-05,   4.3686538E-05,   4.4512763E-05
     +,   4.5356239E-05,   4.6217810E-05,   4.7098449E-05
     +,   4.7999038E-05,   4.8920818E-05,   4.9864841E-05
     +,   5.0832426E-05,   5.1824936E-05,   5.2843858E-05
     +,   5.3890770E-05,   5.4967382E-05,   5.6075532E-05
     +,   5.7217210E-05,   5.8394555E-05,   5.9609883E-05
     +,   6.0865699E-05,   6.2164763E-05,   6.3510051E-05
     +,   6.4904860E-05,   6.6352797E-05,   6.7857865E-05
     +,   6.9424481E-05,   7.1057519E-05,   7.2762414E-05
     +,   7.4545111E-05,   7.6412209E-05,   7.8371013E-05
     +,   8.0429236E-05,   8.2595478E-05,   8.4878826E-05
     +,   8.7289292E-05,   8.9837282E-05,   9.2533475E-05
     +,   9.5389485E-05,   9.8417244E-05,   1.0162929E-04
     +,   1.0503888E-04,   1.0866030E-04,   1.1250923E-04
     +,   1.1660360E-04,   1.2096447E-04,   1.2561746E-04
     +,   1.3059462E-04,   1.3593660E-04,   1.4169562E-04
     +,   1.4793886E-04,   1.5475265E-04,   1.6224723E-04
     +,   1.7056246E-04,   1.7987452E-04,   1.9040378E-04
     +,   2.0242401E-04,   2.1627410E-04,   2.3237156E-04
     +,   2.5122889E-04,   2.7347269E-04,   2.9986424E-04
     +,   3.3132013E-04,   3.6893139E-04,   4.1397481E-04
     +,   4.6791605E-04,   5.3239986E-04,   6.0922781E-04
     +,   7.0032070E-04,   8.0767175E-04,   9.3328598E-04
     +,   1.0791016E-03,   1.2468520E-03,   1.4379920E-03
     +,   1.6534720E-03,   1.8936464E-03,   2.1581952E-03
     +,   2.4460969E-03,   2.7557286E-03,   3.0847287E-03
     +,   3.4295558E-03,   3.7847818E-03,   4.1422346E-03
     +,   4.4915988E-03,   4.8233801E-03,   5.1351595E-03
     +,   5.4394430E-03,   5.7684989E-03,   6.1714631E-03
     +,   6.7030364E-03,   7.4119060E-03,   8.3374493E-03
     +,   9.5102098E-03,   1.0937382E-02,   1.2562712E-02
     +,   1.4229264E-02,   1.5697306E-02,   1.6738847E-02
     +,   1.7268950E-02,   1.7423537E-02,   1.7515231E-02
     +,   1.7890042E-02,   1.8789357E-02,   2.0275647E-02
     +,   2.2217430E-02,   2.4395866E-02,   2.6688837E-02
     +,   2.9040286E-02,   3.1290721E-02,   3.3263579E-02
     +,   3.4849536E-02,   3.5895362E-02,   3.6420308E-02
     +,   3.6715064E-02,   3.6678534E-02,   3.5630561E-02
     +,   3.3251084E-02,   3.0192476E-02,   2.7503226E-02
     +,   2.5736902E-02,   2.4748549E-02,   2.4138430E-02
     +,   2.3688607E-02,   2.3394858E-02,   2.3216743E-02
     +,   2.2915859E-02,   2.2194402E-02,   2.0968234E-02
     +,   1.9426381E-02,   1.7821470E-02,   1.6273059E-02
     +,   1.4768976E-02,   1.3283832E-02,   1.1866716E-02
     +,   1.0630898E-02,   9.6735284E-03,   9.0074213E-03
     +,   8.5593583E-03,   8.2186963E-03,   7.8881327E-03
     +,   7.5081987E-03,   7.0567052E-03,   6.5371371E-03
     +,   5.9661949E-03,   5.3656292E-03,   4.7577261E-03
     +,   4.1630985E-03,   3.5992926E-03,   3.0798535E-03
     +,   2.6137084E-03,   2.2050911E-03,   1.8539362E-03
     +,   1.5568010E-03,   1.3079531E-03,   1.1005950E-03
     +,   9.2791655E-04,   7.8371441E-04,   6.6274044E-04
     +,   5.6071696E-04,   4.7426042E-04,   4.0071658E-04
     +,   3.3799876E-04,   2.8445059E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wao_hz_95 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_wao_qq(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  6.5480910E-21,   8.6624898E-21
     +,   1.1447794E-20,   1.5112919E-20,   1.9930872E-20
     +,   2.6257325E-20,   3.4556048E-20,   4.5430488E-20
     +,   5.9664912E-20,   7.8278667E-20,   1.0259222E-19
     +,   1.3431778E-19,   1.7567270E-19,   2.2952155E-19
     +,   2.9956434E-19,   3.9057933E-19,   5.0871814E-19
     +,   6.6190284E-19,   8.6032264E-19,   1.1170657E-18
     +,   1.4489231E-18,   1.8774239E-18,   2.4301278E-18
     +,   3.1423105E-18,   4.0589769E-18,   5.2376212E-18
     +,   6.7515342E-18,   8.6940281E-18,   1.1183833E-17
     +,   1.4371730E-17,   1.8449309E-17,   2.3659248E-17
     +,   3.0309105E-17,   3.8787809E-17,   4.9587105E-17
     +,   6.3327604E-17,   8.0792233E-17,   1.0296659E-16
     +,   1.3109141E-16,   1.6672598E-16,   2.1182863E-16
     +,   2.6885535E-16,   3.4087960E-16,   4.3175588E-16
     +,   5.4629258E-16,   6.9050168E-16,   8.7187674E-16
     +,   1.0997596E-15,   1.3857760E-15,   1.7443761E-15
     +,   2.1935081E-15,   2.7554365E-15,   3.4577626E-15
     +,   4.3346170E-15,   5.4282737E-15,   6.7908402E-15
     +,   8.4866747E-15,   1.0595087E-14,   1.3213680E-14
     +,   1.6462558E-14,   2.0489105E-14,   2.5474265E-14
     +,   3.1639818E-14,   3.9257199E-14,   4.8658482E-14
     +,   6.0249108E-14,   7.4524154E-14,   9.2086610E-14
     +,   1.1367109E-13,   1.4017073E-13,   1.7267080E-13
     +,   2.1248758E-13,   2.6121789E-13,   3.2079401E-13
     +,   3.9355552E-13,   4.8232349E-13,   5.9050757E-13
     +,   7.2221504E-13,   8.8239079E-13,   1.0769893E-12
     +,   1.3131574E-12,   1.5994755E-12,   1.9462400E-12
     +,   2.3657398E-12,   2.8727006E-12,   3.4847728E-12
     +,   4.2229093E-12,   5.1121507E-12,   6.1823216E-12
     +,   7.4688849E-12,   9.0139432E-12,   1.0867525E-11
     +,   1.3088864E-11,   1.5748149E-11,   1.8928364E-11
     +,   2.2727587E-11,   2.7261523E-11,   3.2666526E-11
     +,   3.9103248E-11,   4.6760529E-11,   5.5860202E-11
     +,   6.6662668E-11,   7.9473067E-11,   9.4648615E-11
     +,   1.1260719E-10,   1.3383659E-10,   1.5890633E-10
     +,   1.8848124E-10,   2.2333142E-10,   2.6435396E-10
     +,   3.1259792E-10,   3.6926767E-10,   4.3576687E-10
     +,   5.1371918E-10,   6.0500005E-10,   7.1177597E-10
     +,   8.3654583E-10,   9.8218844E-10,   1.1520157E-09
     +,   1.3498361E-09,   1.5800189E-09,   1.8475786E-09
     +,   2.1582529E-09,   2.5186118E-09,   2.9361571E-09
     +,   3.4194563E-09,   3.9782670E-09,   4.6237130E-09
     +,   5.3684297E-09,   6.2267831E-09,   7.2150619E-09
     +,   8.3517326E-09,   9.6576898E-09,   1.1156562E-08
     +,   1.2875010E-08,   1.4843135E-08,   1.7094802E-08
     +,   1.9668148E-08,   2.2606002E-08,   2.5956409E-08
     +,   2.9773297E-08,   3.4116955E-08,   3.9054836E-08
     +,   4.4662272E-08,   5.1023285E-08,   5.8231759E-08
     +,   6.6390896E-08,   7.5617727E-08,   8.6039570E-08
     +,   9.7799131E-08,   1.1105392E-07,   1.2597810E-07
     +,   1.4276402E-07,   1.6162362E-07,   1.8279047E-07
     +,   2.0652138E-07,   2.3309845E-07,   2.6283104E-07
     +,   2.9605815E-07,   3.3315058E-07,   3.7451335E-07
     +,   4.2058869E-07,   4.7185804E-07,   5.2884531E-07
     +,   5.9212005E-07,   6.6230001E-07,   7.4005436E-07
     +,   8.2610774E-07,   9.2124247E-07,   1.0263072E-06
     +,   1.1422032E-06,   1.2699127E-06,   1.4104803E-06
     +,   1.5650451E-06,   1.7348161E-06,   1.9210706E-06
     +,   2.1251917E-06,   2.3486493E-06,   2.5930065E-06
     +,   2.8599241E-06,   3.1511627E-06,   3.4685895E-06
     +,   3.8141764E-06,   4.1900053E-06,   4.5982683E-06
     +,   5.0412737E-06,   5.5214409E-06,   6.0413081E-06
     +,   6.6035277E-06,   7.2108683E-06,   7.8662179E-06
     +,   8.5725715E-06,   9.3330409E-06,   1.0150846E-05
     +,   1.1029316E-05,   1.1971876E-05,   1.2982050E-05
     +,   1.4063447E-05,   1.5219764E-05,   1.6454769E-05
     +,   1.7772300E-05,   1.9176237E-05,   2.0670514E-05
     +,   2.2259090E-05,   2.3945937E-05,   2.5735033E-05
     +,   2.7630333E-05,   2.9635778E-05,   3.1755229E-05
     +,   3.3992597E-05,   3.6351306E-05,   3.8835253E-05
     +,   4.1447795E-05,   4.4192253E-05,   4.7071881E-05
     +,   5.0089344E-05,   5.3247473E-05,   5.6548688E-05
     +,   5.9994974E-05,   6.3588632E-05,   6.7330708E-05
     +,   7.1222516E-05,   7.5264797E-05,   7.9457888E-05
     +,   8.3801882E-05,   8.8295674E-05,   9.2938797E-05
     +,   9.7729484E-05,   1.0266571E-04,   1.0774505E-04
     +,   1.1296392E-04,   1.1831880E-04,   1.2380532E-04
     +,   1.2941835E-04,   1.3515305E-04,   1.4100259E-04
     +,   1.4696042E-04,   1.5301922E-04,   1.5917097E-04
     +,   1.6540712E-04,   1.7171855E-04,   1.7809546E-04
     +,   1.8452760E-04,   1.9100412E-04,   1.9751365E-04
     +,   2.0404444E-04,   2.1058413E-04,   2.1712008E-04
     +,   2.2363913E-04,   2.3012789E-04,   2.3657258E-04
     +,   2.4295924E-04,   2.4927370E-04,   2.5550160E-04
     +,   2.6162842E-04,   2.6763970E-04,   2.7352094E-04
     +,   2.7925774E-04,   2.8483573E-04,   2.9024083E-04
     +,   2.9545912E-04,   3.0047706E-04,   3.0528134E-04
     +,   3.0985926E-04,   3.1419838E-04,   3.1828697E-04
     +,   3.2211377E-04,   3.2566822E-04,   3.2894040E-04
     +,   3.3192112E-04,   3.3460197E-04,   3.3697535E-04
     +,   3.3903460E-04,   3.4077369E-04,   3.4218779E-04
     +,   3.4327281E-04,   3.4402561E-04,   3.4444421E-04
     +,   3.4452730E-04,   3.4427483E-04,   3.4368760E-04
     +,   3.4276734E-04,   3.4151686E-04,   3.3993981E-04
     +,   3.3804090E-04,   3.3582567E-04,   3.3330044E-04
     +,   3.3047260E-04,   3.2735028E-04,   3.2394213E-04
     +,   3.2025808E-04,   3.1630858E-04,   3.1210409E-04
     +,   3.0765645E-04,   3.0297751E-04,   2.9808024E-04
     +,   2.9297746E-04,   2.8768257E-04,   2.8220925E-04
     +,   2.7657143E-04,   2.7078338E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wao_qq = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_wao_ww(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   1.3370796E-38
     +,   3.6731404E-38,   1.0022714E-37,   2.7165278E-37
     +,   7.3135314E-37,   1.9557248E-36,   5.1949930E-36
     +,   1.3706851E-35,   3.5922628E-35,   9.3519598E-35
     +,   2.4182150E-34,   6.2109058E-34,   1.5846345E-33
     +,   4.0157444E-33,   1.0108437E-32,   2.5274527E-32
     +,   6.2771357E-32,   1.5485410E-31,   3.7945764E-31
     +,   9.2360265E-31,   2.2330056E-30,   5.3625834E-30
     +,   1.2791985E-29,   3.0309918E-29,   7.1336957E-29
     +,   1.6677240E-28,   3.8726838E-28,   8.9327414E-28
     +,   2.0466214E-27,   4.6576882E-27,   1.0528992E-26
     +,   2.3642055E-26,   5.2730772E-26,   1.1682262E-25
     +,   2.5709016E-25,   5.6196824E-25,   1.2201294E-24
     +,   2.6315581E-24,   5.6375037E-24,   1.1996261E-23
     +,   2.5356377E-23,   5.3236897E-23,   1.1102553E-22
     +,   2.2999476E-22,   4.7325858E-22,   9.6730483E-22
     +,   1.9638859E-21,   3.9605420E-21,   7.9337889E-21
     +,   1.5786832E-20,   3.1203272E-20,   6.1262114E-20
     +,   1.1947479E-19,   2.3144658E-19,   4.4536883E-19
     +,   8.5129882E-19,   1.6163623E-18,   3.0485353E-18
     +,   5.7113992E-18,   1.0629008E-17,   1.9649166E-17
     +,   3.6082674E-17,   6.5819933E-17,   1.1926805E-16
     +,   2.1468382E-16,   3.8387178E-16,   6.8184628E-16
     +,   1.2031056E-15,   2.1088257E-15,   3.6719755E-15
     +,   6.3516354E-15,   1.0914406E-14,   1.8631882E-14
     +,   3.1595928E-14,   5.3230986E-14,   8.9091156E-14
     +,   1.4813320E-13,   2.4469440E-13,   4.0156358E-13
     +,   6.5470865E-13,   1.0604976E-12,   1.7066530E-12
     +,   2.7287246E-12,   4.3347006E-12,   6.8414588E-12
     +,   1.0728396E-11,   1.6715632E-11,   2.5877316E-11
     +,   3.9804261E-11,   6.0835961E-11,   9.2388430E-11
     +,   1.3941402E-10,   2.0904212E-10,   3.1146186E-10
     +,   4.6113263E-10,   6.7842537E-10,   9.9184838E-10
     +,   1.4409419E-09,   2.0802624E-09,   2.9843996E-09
     +,   4.2548183E-09,   6.0282641E-09,   8.4875413E-09
     +,   1.1875681E-08,   1.6512907E-08,   2.2818057E-08
     +,   3.1334618E-08,   4.2762320E-08,   5.7994630E-08
     +,   7.8163318E-08,   1.0468995E-07,   1.3934489E-07
     +,   1.8431373E-07,   2.4227052E-07,   3.1645769E-07
     +,   4.1076837E-07,   5.2983302E-07,   6.7910202E-07
     +,   8.6492435E-07,   1.0946134E-06,   1.3764961E-06
     +,   1.7199385E-06,   2.1353364E-06,   2.6340654E-06
     +,   3.2283879E-06,   3.9312940E-06,   4.7562930E-06
     +,   5.7171278E-06,   6.8274367E-06,   8.1003373E-06
     +,   9.5479763E-06,   1.1181014E-05,   1.3008122E-05
     +,   1.5035449E-05,   1.7266155E-05,   1.9699992E-05
     +,   2.2333121E-05,   2.5157393E-05,   2.8161519E-05
     +,   3.1330186E-05,   3.4645105E-05,   3.8085782E-05
     +,   4.1629926E-05,   4.5255489E-05,   4.8941452E-05
     +,   5.2669264E-05,   5.6425091E-05,   6.0199589E-05
     +,   6.3990592E-05,   6.7803157E-05,   7.1650000E-05
     +,   7.5551492E-05,   7.9533915E-05,   8.3629682E-05
     +,   8.7873566E-05,   9.2300834E-05,   9.6944357E-05
     +,   1.0183047E-04,   1.0697696E-04,   1.1238947E-04
     +,   1.1805901E-04,   1.2396165E-04,   1.3005556E-04
     +,   1.3628382E-04,   1.4257504E-04,   1.4884607E-04
     +,   1.5500575E-04,   1.6095894E-04,   1.6661103E-04
     +,   1.7187248E-04,   1.7666278E-04,   1.8091398E-04
     +,   1.8457307E-04,   1.8760409E-04,   1.8998850E-04
     +,   1.9172534E-04,   1.9283066E-04,   1.9333656E-04
     +,   1.9328999E-04,   1.9275198E-04,   1.9179660E-04
     +,   1.9051020E-04,   1.8899071E-04,   1.8734692E-04
     +,   1.8569661E-04,   1.8416460E-04,   1.8287920E-04
     +,   1.8196781E-04,   1.8155108E-04,   1.8173621E-04
     +,   1.8260968E-04,   1.8422960E-04,   1.8661891E-04
     +,   1.8975974E-04,   1.9358948E-04,   1.9799951E-04
     +,   2.0283688E-04,   2.0790836E-04,   2.1298815E-04
     +,   2.1782734E-04,   2.2216591E-04,   2.2574559E-04
     +,   2.2832230E-04,   2.2967989E-04,   2.2964051E-04
     +,   2.2807356E-04,   2.2490199E-04,   2.2010604E-04
     +,   2.1372263E-04,   2.0584281E-04,   1.9660615E-04
     +,   1.8619286E-04,   1.7481452E-04,   1.6270348E-04
     +,   1.5010241E-04,   1.3725391E-04,   1.2439050E-04
     +,   1.1172881E-04,   9.9460172E-05,   8.7746223E-05
     +,   7.6718592E-05,   6.6475324E-05,   5.7083711E-05
     +,   4.8579492E-05,   4.0971630E-05,   3.4245531E-05
     +,   2.8367156E-05,   2.3287348E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wao_ww = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1955_hnn_wao_zz(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  4.7811136E-20,   6.3666256E-20
     +,   8.4654814E-20,   1.1239782E-19,   1.4901372E-19
     +,   1.9726884E-19,   2.6076812E-19,   3.4420146E-19
     +,   4.5366442E-19,   5.9706481E-19,   7.8463970E-19
     +,   1.0296283E-18,   1.3491321E-18,   1.7651904E-18
     +,   2.3061800E-18,   3.0085487E-18,   3.9190779E-18
     +,   5.0976941E-18,   6.6210456E-18,   8.5870521E-18
     +,   1.1120485E-17,   1.4380250E-17,   1.8568299E-17
     +,   2.3941052E-17,   3.0823062E-17,   3.9625181E-17
     +,   5.0866251E-17,   6.5200679E-17,   8.3451976E-17
     +,   1.0665591E-16,   1.3611196E-16,   1.7344888E-16
     +,   2.2070289E-16,   2.8042066E-16,   3.5577337E-16
     +,   4.5071359E-16,   5.7015233E-16,   7.2018521E-16
     +,   9.0836692E-16,   1.1440408E-15,   1.4387480E-15
     +,   1.8067308E-15,   2.2654851E-15,   2.8365876E-15
     +,   3.5464399E-15,   4.4274353E-15,   5.5191866E-15
     +,   6.8700843E-15,   8.5390908E-15,   1.0598030E-14
     +,   1.3134187E-14,   1.6253436E-14,   2.0084056E-14
     +,   2.4781219E-14,   3.0532360E-14,   3.7563207E-14
     +,   4.6145789E-14,   5.6606931E-14,   6.9338849E-14
     +,   8.4811674E-14,   1.0358800E-13,   1.2633978E-13
     +,   1.5387015E-13,   1.8713552E-13,   2.2727618E-13
     +,   2.7564927E-13,   3.3386949E-13,   4.0385899E-13
     +,   4.8790556E-13,   5.8873159E-13,   7.0959113E-13
     +,   8.5436687E-13,   1.0277208E-12,   1.2352633E-12
     +,   1.4837865E-12,   1.7815398E-12,   2.1386595E-12
     +,   2.5676581E-12,   3.0841313E-12,   3.7077455E-12
     +,   4.4634669E-12,   5.3833765E-12,   6.5090988E-12
     +,   7.8949130E-12,   9.6124636E-12,   1.1757107E-11
     +,   1.4455499E-11,   1.7877802E-11,   2.2252568E-11
     +,   2.7887569E-11,   3.5197390E-11,   4.4740676E-11
     +,   5.7269182E-11,   7.3792833E-11,   9.5665365E-11
     +,   1.2469621E-10,   1.6329596E-10,   2.1466444E-10
     +,   2.8303329E-10,   3.7397427E-10,   4.9479237E-10
     +,   6.5502348E-10,   8.6705226E-10,   1.1468942E-09
     +,   1.5151492E-09,   1.9981881E-09,   2.6295892E-09
     +,   3.4519392E-09,   4.5187818E-09,   5.8972871E-09
     +,   7.6714404E-09,   9.9449213E-09,   1.2845893E-08
     +,   1.6531409E-08,   2.1192923E-08,   2.7062566E-08
     +,   3.4419969E-08,   4.3600242E-08,   5.5002356E-08
     +,   6.9098512E-08,   8.6444281E-08,   1.0768884E-07
     +,   1.3358640E-07,   1.6500702E-07,   2.0294830E-07
     +,   2.4854566E-07,   3.0308291E-07,   3.6800120E-07
     +,   4.4490633E-07,   5.3557420E-07,   6.4195331E-07
     +,   7.6616453E-07,   9.1049651E-07,   1.0773978E-06
     +,   1.2694624E-06,   1.4894126E-06,   1.7400747E-06
     +,   2.0243508E-06,   2.3451805E-06,   2.7055055E-06
     +,   3.1082213E-06,   3.5561254E-06,   4.0518717E-06
     +,   4.5979036E-06,   5.1964030E-06,   5.8492610E-06
     +,   6.5578715E-06,   7.3234023E-06,   8.1463168E-06
     +,   9.0266749E-06,   9.9639237E-06,   1.0956915E-05
     +,   1.2003842E-05,   1.3102268E-05,   1.4249086E-05
     +,   1.5440521E-05,   1.6672153E-05,   1.7938921E-05
     +,   1.9235147E-05,   2.0554586E-05,   2.1890428E-05
     +,   2.3235385E-05,   2.4581714E-05,   2.5921283E-05
     +,   2.7245635E-05,   2.8546063E-05,   2.9813682E-05
     +,   3.1039526E-05,   3.2214652E-05,   3.3330285E-05
     +,   3.4377787E-05,   3.5349025E-05,   3.6236361E-05
     +,   3.7032969E-05,   3.7732825E-05,   3.8330938E-05
     +,   3.8823597E-05,   3.9208498E-05,   3.9484883E-05
     +,   3.9653612E-05,   3.9717295E-05,   3.9680264E-05
     +,   3.9548559E-05,   3.9329778E-05,   3.9032922E-05
     +,   3.8668139E-05,   3.8246490E-05,   3.7779653E-05
     +,   3.7279813E-05,   3.6759746E-05,   3.6233345E-05
     +,   3.5716868E-05,   3.5231209E-05,   3.4805526E-05
     +,   3.4482808E-05,   3.4327324E-05,   3.4434255E-05
     +,   3.4941051E-05,   3.6039735E-05,   3.7988739E-05
     +,   4.1122235E-05,   4.5854369E-05,   5.2674430E-05
     +,   6.2129286E-05,   7.4788441E-05,   9.1189002E-05
     +,   1.1176318E-04,   1.3675862E-04,   1.6617450E-04
     +,   1.9974522E-04,   2.3698938E-04,   2.7736233E-04
     +,   3.2042645E-04,   3.6601911E-04,   4.1431253E-04
     +,   4.6573681E-04,   5.2085944E-04,   5.8028102E-04
     +,   6.4461725E-04,   7.1447564E-04,   7.9022930E-04
     +,   8.7174488E-04,   9.5823506E-04,   1.0484757E-03
     +,   1.1411211E-03,   1.2345036E-03,   1.3258703E-03
     +,   1.4106922E-03,   1.4834828E-03,   1.5408670E-03
     +,   1.5857712E-03,   1.6290835E-03,   1.6850054E-03
     +,   1.7618157E-03,   1.8575209E-03,   1.9675293E-03
     +,   2.0956346E-03,   2.2480940E-03,   2.4090235E-03
     +,   2.5291371E-03,   2.5579387E-03,   2.4954441E-03
     +,   2.4008816E-03,   2.3378588E-03,   2.3140691E-03
     +,   2.2838626E-03,   2.2068033E-03,   2.0919524E-03
     +,   1.9832768E-03,   1.9146816E-03,   1.8879976E-03
     +,   1.8861825E-03,   1.8933855E-03,   1.9001538E-03
     +,   1.8997233E-03,   1.8881189E-03,   1.8667828E-03
     +,   1.8391393E-03,   1.8019039E-03,   1.7414647E-03
     +,   1.6414161E-03,   1.4954807E-03,   1.3151298E-03
     +,   1.1264734E-03,   9.5912354E-04,   8.3429069E-04
     +,   7.5829867E-04,   7.2361273E-04,   7.1504829E-04
     +,   7.1697001E-04,   7.1813480E-04,   7.1317336E-04
     +,   7.0149871E-04,   6.8517809E-04,   6.6698116E-04
     +,   6.4920128E-04,   6.3323649E-04,   6.1961322E-04
     +,   6.0814817E-04,   5.9806439E-04,   5.8807043E-04
     +,   5.7647476E-04,   5.6141586E-04,   5.4119283E-04
     +,   5.1461835E-04,   4.8128952E-04,   4.4169559E-04
     +,   3.9713614E-04,   3.4948476E-04,   3.0087089E-04
     +,   2.5337352E-04,   2.0876469E-04,   1.6835854E-04
     +,   1.3297029E-04,   1.0293353E-04,   7.8183919E-05
     +,   5.8353329E-05,   4.2880441E-05,   3.1105701E-05
     +,   2.2350278E-05,   1.5974230E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wao_zz = Yx
      RETURN
      END

      DOUBLE PRECISION FUNCTION A1955_hnn_wao_hz_107(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  8.7016677E-15,   1.0803632E-14
     +,   1.3398234E-14,   1.6597235E-14,   2.0536876E-14
     +,   2.5383033E-14,   3.1337343E-14,   3.8644825E-14
     +,   4.7602713E-14,   5.8571102E-14,   7.1985319E-14
     +,   8.8371862E-14,   1.0836638E-13,   1.3273528E-13
     +,   1.6240065E-13,   1.9847221E-13,   2.4228295E-13
     +,   2.9543010E-13,   3.5983049E-13,   4.3777479E-13
     +,   5.3200397E-13,   6.4578600E-13,   7.8302127E-13
     +,   9.4835262E-13,   1.1472934E-12,   1.3864033E-12
     +,   1.6734590E-12,   2.0176742E-12,   2.4299506E-12
     +,   2.9231717E-12,   3.5125362E-12,   4.2159800E-12
     +,   5.0545891E-12,   6.0531814E-12,   7.2408906E-12
     +,   8.6518830E-12,   1.0326172E-11,   1.2310581E-11
     +,   1.4659805E-11,   1.7437661E-11,   2.0718502E-11
     +,   2.4588956E-11,   2.9149384E-11,   3.4516955E-11
     +,   4.0826668E-11,   4.8235395E-11,   5.6924361E-11
     +,   6.7102789E-11,   7.9012054E-11,   9.2930066E-11
     +,   1.0917668E-10,   1.2811903E-10,   1.5017868E-10
     +,   1.7583790E-10,   2.0564984E-10,   2.4024452E-10
     +,   2.8034283E-10,   3.2676459E-10,   3.8044459E-10
     +,   4.4244364E-10,   5.1396604E-10,   5.9637767E-10
     +,   6.9122386E-10,   8.0025159E-10,   9.2543279E-10
     +,   1.0689898E-09,   1.2334227E-09,   1.4215467E-09
     +,   1.6365179E-09,   1.8818733E-09,   2.1615760E-09
     +,   2.4800513E-09,   2.8422458E-09,   3.2536640E-09
     +,   3.7204479E-09,   4.2493933E-09,   4.8480699E-09
     +,   5.5248601E-09,   6.2890182E-09,   7.1508217E-09
     +,   8.1215594E-09,   9.2136769E-09,   1.0440933E-08
     +,   1.1818261E-08,   1.3362144E-08,   1.5090839E-08
     +,   1.7023879E-08,   1.9182902E-08,   2.1591379E-08
     +,   2.4274845E-08,   2.7261102E-08,   3.0580210E-08
     +,   3.4264758E-08,   3.8349981E-08,   4.2873950E-08
     +,   4.7877521E-08,   5.3404808E-08,   5.9503083E-08
     +,   6.6223002E-08,   7.3618786E-08,   8.1748311E-08
     +,   9.0673318E-08,   1.0045937E-07,   1.1117616E-07
     +,   1.2289763E-07,   1.3570182E-07,   1.4967129E-07
     +,   1.6489345E-07,   1.8145849E-07,   1.9946192E-07
     +,   2.1900641E-07,   2.4019428E-07,   2.6313549E-07
     +,   2.8794338E-07,   3.1473570E-07,   3.4363387E-07
     +,   3.7476377E-07,   4.0825432E-07,   4.4423822E-07
     +,   4.8285136E-07,   5.2423184E-07,   5.6852133E-07
     +,   6.1586223E-07,   6.6639927E-07,   7.2027854E-07
     +,   7.7764639E-07,   8.3864973E-07,   9.0343502E-07
     +,   9.7214797E-07,   1.0449329E-06,   1.1219330E-06
     +,   1.2032885E-06,   1.2891372E-06,   1.3796147E-06
     +,   1.4748528E-06,   1.5749799E-06,   1.6801217E-06
     +,   1.7904007E-06,   1.9059361E-06,   2.0268449E-06
     +,   2.1532430E-06,   2.2852455E-06,   2.4229689E-06
     +,   2.5665320E-06,   2.7160572E-06,   2.8716831E-06
     +,   3.0335300E-06,   3.2017799E-06,   3.3765859E-06
     +,   3.5581502E-06,   3.7466955E-06,   3.9424804E-06
     +,   4.1458043E-06,   4.3570149E-06,   4.5765173E-06
     +,   4.8047855E-06,   5.0423700E-06,   5.2899095E-06
     +,   5.5481473E-06,   5.8179394E-06,   6.1002743E-06
     +,   6.3962839E-06,   6.7072642E-06,   7.0346923E-06
     +,   7.3802385E-06,   7.7457926E-06,   8.1334783E-06
     +,   8.5456704E-06,   8.9850191E-06,   9.4544785E-06
     +,   9.9572444E-06,   1.0496893E-05,   1.1077287E-05
     +,   1.1702688E-05,   1.2377670E-05,   1.3107086E-05
     +,   1.3896217E-05,   1.4750673E-05,   1.5676393E-05
     +,   1.6679653E-05,   1.7767059E-05,   1.8945544E-05
     +,   2.0222356E-05,   2.1605072E-05,   2.3101578E-05
     +,   2.4720111E-05,   2.6469250E-05,   2.8357930E-05
     +,   3.0395517E-05,   3.2591808E-05,   3.4957160E-05
     +,   3.7502588E-05,   4.0239982E-05,   4.3182466E-05
     +,   4.6344929E-05,   4.9744831E-05,   5.3403452E-05
     +,   5.7347679E-05,   6.1612518E-05,   6.6244487E-05
     +,   7.1306044E-05,   7.6881312E-05,   8.3082741E-05
     +,   9.0059191E-05,   9.8004362E-05,   1.0716548E-04
     +,   1.1785105E-04,   1.3043602E-04,   1.4536316E-04
     +,   1.6313857E-04,   1.8431421E-04,   2.0947223E-04
     +,   2.3918039E-04,   2.7394926E-04,   3.1417378E-04
     +,   3.6006066E-04,   4.1157103E-04,   4.6835284E-04
     +,   5.2969641E-04,   5.9453171E-04,   6.6142710E-04
     +,   7.2869059E-04,   7.9448888E-04,   8.5703953E-04
     +,   9.1485260E-04,   9.6699002E-04,   1.0133621E-03
     +,   1.0549383E-03,   1.0939052E-03,   1.1336721E-03
     +,   1.1786994E-03,   1.2341667E-03,   1.3054863E-03
     +,   1.3977914E-03,   1.5155252E-03,   1.6621457E-03
     +,   1.8400809E-03,   2.0506838E-03,   2.2940447E-03
     +,   2.5684987E-03,   2.8697953E-03,   3.1901691E-03
     +,   3.5177546E-03,   3.8369477E-03,   4.1302834E-03
     +,   4.3818885E-03,   4.5817811E-03,   4.7292258E-03
     +,   4.8330766E-03,   4.9079955E-03,   4.9679135E-03
     +,   5.0201337E-03,   5.0639766E-03,   5.0951024E-03
     +,   5.1127481E-03,   5.1248902E-03,   5.1481109E-03
     +,   5.2033556E-03,   5.3113815E-03,   5.4901247E-03
     +,   5.7531903E-03,   6.1083972E-03,   6.5562734E-03
     +,   7.0873303E-03,   7.6753581E-03,   8.2697095E-03
     +,   8.7980144E-03,   9.1877738E-03,   9.3980674E-03
     +,   9.4421236E-03,   9.3891388E-03,   9.3456190E-03
     +,   9.4163381E-03,   9.6501596E-03,   9.9959653E-03
     +,   1.0307488E-02,   1.0411619E-02,   1.0205024E-02
     +,   9.7145243E-03,   9.0807639E-03,   8.4832842E-03
     +,   8.0620777E-03,   7.8771440E-03,   7.9095075E-03
     +,   8.0900127E-03,   8.3408924E-03,   8.6090909E-03
     +,   8.8665988E-03,   9.0751220E-03,   9.1509214E-03
     +,   8.9754770E-03,   8.4566334E-03,   7.5920462E-03
     +,   6.4815092E-03,   5.2798796E-03,   4.1305809E-03
     +,   3.1233348E-03,   2.2911783E-03,   1.6305067E-03
     +,   1.1224872E-03,   7.4489368E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wao_hz_107 = Yx
      RETURN
      END


      DOUBLE PRECISION FUNCTION A1955_hnn_wano_hz_107(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  8.3253786E-07,   8.6409636E-07
     +,   8.9663956E-07,   9.3019327E-07,   9.6478402E-07
     +,   1.0004399E-06,   1.0371892E-06,   1.0750623E-06
     +,   1.1140899E-06,   1.1543048E-06,   1.1957391E-06
     +,   1.2384286E-06,   1.2824102E-06,   1.3277211E-06
     +,   1.3744013E-06,   1.4224926E-06,   1.4720379E-06
     +,   1.5230825E-06,   1.5756741E-06,   1.6298624E-06
     +,   1.6856980E-06,   1.7432365E-06,   1.8025340E-06
     +,   1.8636511E-06,   1.9266477E-06,   1.9915892E-06
     +,   2.0585439E-06,   2.1275819E-06,   2.1987776E-06
     +,   2.2722079E-06,   2.3479531E-06,   2.4260967E-06
     +,   2.5067261E-06,   2.5899317E-06,   2.6758078E-06
     +,   2.7644523E-06,   2.8559659E-06,   2.9504540E-06
     +,   3.0480253E-06,   3.1487916E-06,   3.2528687E-06
     +,   3.3603785E-06,   3.4714365E-06,   3.5861779E-06
     +,   3.7047259E-06,   3.8272142E-06,   3.9537786E-06
     +,   4.0845571E-06,   4.2196903E-06,   4.3593209E-06
     +,   4.5035936E-06,   4.6526552E-06,   4.8066531E-06
     +,   4.9657365E-06,   5.1300594E-06,   5.2997621E-06
     +,   5.4749985E-06,   5.6559170E-06,   5.8426635E-06
     +,   6.0353850E-06,   6.2342215E-06,   6.4393134E-06
     +,   6.6507960E-06,   6.8687991E-06,   7.0934502E-06
     +,   7.3248657E-06,   7.5631606E-06,   7.8084367E-06
     +,   8.0607924E-06,   8.3203158E-06,   8.5870806E-06
     +,   8.8611541E-06,   9.1425900E-06,   9.4314291E-06
     +,   9.7277043E-06,   1.0031416E-05,   1.0342566E-05
     +,   1.0661136E-05,   1.0987084E-05,   1.1320366E-05
     +,   1.1660904E-05,   1.2008605E-05,   1.2363372E-05
     +,   1.2725037E-05,   1.3093450E-05,   1.3468480E-05
     +,   1.3849880E-05,   1.4237445E-05,   1.4630934E-05
     +,   1.5030081E-05,   1.5434602E-05,   1.5844184E-05
     +,   1.6258502E-05,   1.6677206E-05,   1.7099928E-05
     +,   1.7526287E-05,   1.7955879E-05,   1.8388297E-05
     +,   1.8823117E-05,   1.9259907E-05,   1.9698236E-05
     +,   2.0137670E-05,   2.0577792E-05,   2.1018181E-05
     +,   2.1458443E-05,   2.1898206E-05,   2.2337137E-05
     +,   2.2774964E-05,   2.3211411E-05,   2.3646304E-05
     +,   2.4079607E-05,   2.4511273E-05,   2.4941432E-05
     +,   2.5370320E-05,   2.5798343E-05,   2.6226073E-05
     +,   2.6654270E-05,   2.7083939E-05,   2.7516337E-05
     +,   2.7953007E-05,   2.8395845E-05,   2.8847115E-05
     +,   2.9309504E-05,   2.9786181E-05,   3.0280855E-05
     +,   3.0797823E-05,   3.1342082E-05,   3.1919375E-05
     +,   3.2536289E-05,   3.3200376E-05,   3.3920234E-05
     +,   3.4705663E-05,   3.5567777E-05,   3.6519126E-05
     +,   3.7573947E-05,   3.8748240E-05,   4.0060011E-05
     +,   4.1529431E-05,   4.3179036E-05,   4.5033954E-05
     +,   4.7122077E-05,   4.9474242E-05,   5.2124378E-05
     +,   5.5109638E-05,   5.8470498E-05,   6.2250889E-05
     +,   6.6497319E-05,   7.1260671E-05,   7.6593416E-05
     +,   8.2551160E-05,   8.9191504E-05,   9.6573378E-05
     +,   1.0475645E-04,   1.1380023E-04,   1.2376336E-04
     +,   1.3470228E-04,   1.4667062E-04,   1.5971795E-04
     +,   1.7388898E-04,   1.8922266E-04,   2.0575120E-04
     +,   2.2349971E-04,   2.4248550E-04,   2.6271769E-04
     +,   2.8419684E-04,   3.0691471E-04,   3.3085395E-04
     +,   3.5598790E-04,   3.8228036E-04,   4.0968697E-04
     +,   4.3814984E-04,   4.6760577E-04,   4.9798051E-04
     +,   5.2919739E-04,   5.6117354E-04,   5.9382373E-04
     +,   6.2707323E-04,   6.6085940E-04,   6.9514284E-04
     +,   7.2991621E-04,   7.6521654E-04,   8.0113177E-04
     +,   8.3781115E-04,   8.7546703E-04,   9.1437262E-04
     +,   9.5485221E-04,   9.9726336E-04,   1.0419694E-03
     +,   1.0893045E-03,   1.1395320E-03,   1.1928075E-03
     +,   1.2491376E-03,   1.3083594E-03,   1.3701387E-03
     +,   1.4339878E-03,   1.4993207E-03,   1.5655385E-03
     +,   1.6321257E-03,   1.6987730E-03,   1.7654765E-03
     +,   1.8326177E-03,   1.9009829E-03,   1.9717196E-03
     +,   2.0462112E-03,   2.1258986E-03,   2.2120369E-03
     +,   2.3054532E-03,   2.4063420E-03,   2.5141104E-03
     +,   2.6273446E-03,   2.7438551E-03,   2.8608646E-03
     +,   2.9751898E-03,   3.0835052E-03,   3.1825730E-03
     +,   3.2694163E-03,   3.3414820E-03,   3.3967420E-03
     +,   3.4337703E-03,   3.4518410E-03,   3.4509946E-03
     +,   3.4321260E-03,   3.3970210E-03,   3.3483224E-03
     +,   3.2894139E-03,   3.2242222E-03,   3.1568890E-03
     +,   3.0914580E-03,   3.0314964E-03,   2.9798078E-03
     +,   2.9382058E-03,   2.9074077E-03,   2.8870269E-03
     +,   2.8757111E-03,   2.8713208E-03,   2.8711834E-03
     +,   2.8723590E-03,   2.8719108E-03,   2.8671459E-03
     +,   2.8558213E-03,   2.8363257E-03,   2.8077902E-03
     +,   2.7701808E-03,   2.7243078E-03,   2.6717950E-03
     +,   2.6149808E-03,   2.5567526E-03,   2.5003359E-03
     +,   2.4490261E-03,   2.4059266E-03,   2.3736579E-03
     +,   2.3541495E-03,   2.3484507E-03,   2.3566585E-03
     +,   2.3779431E-03,   2.4106714E-03,   2.4526354E-03
     +,   2.5013743E-03,   2.5545389E-03,   2.6102602E-03
     +,   2.6674950E-03,   2.7262489E-03,   2.7876657E-03
     +,   2.8539004E-03,   2.9277762E-03,   3.0122499E-03
     +,   3.1097347E-03,   3.2214017E-03,   3.3466269E-03
     +,   3.4826943E-03,   3.6249056E-03,   3.7671160E-03
     +,   3.9026234E-03,   4.0253117E-03,   4.1307448E-03
     +,   4.2170612E-03,   4.2854147E-03,   4.3399055E-03
     +,   4.3869410E-03,   4.4342522E-03,   4.4895918E-03
     +,   4.5594214E-03,   4.6477038E-03,   4.7549312E-03
     +,   4.8775626E-03,   5.0079157E-03,   5.1346007E-03
     +,   5.2435314E-03,   5.3194216E-03,   5.3476701E-03
     +,   5.3162389E-03,   5.2173156E-03,   5.0483057E-03
     +,   4.8120958E-03,   4.5164623E-03,   4.1729230E-03
     +,   3.7951346E-03,   3.3974182E-03,   2.9934729E-03
     +,   2.5955236E-03,   2.2138376E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wano_hz_107 = Yx
      RETURN
      END


      DOUBLE PRECISION FUNCTION A1955_hnn_nwao_hz_107(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  2.1056781E-22,   3.1303503E-22
     +,   4.6442516E-22,   6.8763650E-22,   1.0160709E-21
     +,   1.4983312E-21,   2.2050246E-21,   3.2384668E-21
     +,   4.7466342E-21,   6.9431618E-21,   1.0135551E-20
     +,   1.4765773E-20,   2.1467770E-20,   3.1148682E-20
     +,   4.5103577E-20,   6.5178485E-20,   9.3997839E-20
     +,   1.3528563E-19,   1.9431627E-19,   2.7853795E-19
     +,   3.9845794E-19,   5.6885293E-19,   8.1047306E-19
     +,   1.1523959E-18,   1.6352407E-18,   2.3157074E-18
     +,   3.2726985E-18,   4.6158163E-18,   6.4970029E-18
     +,   9.1263482E-18,   1.2793901E-17,   1.7899017E-17
     +,   2.4990542E-17,   3.4821237E-17,   4.8420910E-17
     +,   6.7195898E-17,   9.3062127E-17,   1.2862465E-16
     +,   1.7741724E-16,   2.4422456E-16,   3.3550819E-16
     +,   4.5998082E-16,   6.2935040E-16,   8.5935399E-16
     +,   1.1710320E-15,   1.5925260E-15,   2.1613515E-15
     +,   2.9274223E-15,   3.9569966E-15,   5.3378585E-15
     +,   7.1860259E-15,   9.6545400E-15,   1.2944779E-14
     +,   1.7321270E-14,   2.3130633E-14,   3.0825779E-14
     +,   4.0997821E-14,   5.4416260E-14,   7.2080342E-14
     +,   9.5285528E-14,   1.2570638E-13,   1.6550384E-13
     +,   2.1746025E-13,   2.8514959E-13,   3.7315290E-13
     +,   4.8732779E-13,   6.3514932E-13,   8.2613766E-13
     +,   1.0723835E-12,   1.3892081E-12,   1.7959968E-12
     +,   2.3172078E-12,   2.9836340E-12,   3.8339492E-12
     +,   4.9166665E-12,   6.2923577E-12,   8.0366885E-12
     +,   1.0243803E-11,   1.3030610E-11,   1.6542084E-11
     +,   2.0957392E-11,   2.6497500E-11,   3.3434734E-11
     +,   4.2102457E-11,   5.2909430E-11,   6.6357281E-11
     +,   8.3053939E-11,   1.0374152E-10,   1.2932024E-10
     +,   1.6087948E-10,   1.9973564E-10,   2.4747510E-10
     +,   3.0600480E-10,   3.7761227E-10,   4.6503387E-10
     +,   5.7153637E-10,   7.0100936E-10,   8.5807422E-10
     +,   1.0482050E-09,   1.2778770E-09,   1.5547218E-09
     +,   1.8877173E-09,   2.2873994E-09,   2.7660989E-09
     +,   3.3382164E-09,   4.0205186E-09,   4.8324829E-09
     +,   5.7967284E-09,   6.9392576E-09,   8.2901179E-09
     +,   9.8840678E-09,   1.1760562E-08,   1.3965013E-08
     +,   1.6549139E-08,   1.9571790E-08,   2.3099691E-08
     +,   2.7208390E-08,   3.1983085E-08,   3.7519644E-08
     +,   4.3925606E-08,   5.1321308E-08,   5.9840971E-08
     +,   6.9633820E-08,   8.0865362E-08,   9.3718633E-08
     +,   1.0839521E-07,   1.2511664E-07,   1.4412552E-07
     +,   1.6568657E-07,   1.9008809E-07,   2.1764222E-07
     +,   2.4868646E-07,   2.8358409E-07,   3.2272501E-07
     +,   3.6652560E-07,   4.1542899E-07,   4.6990485E-07
     +,   5.3044937E-07,   5.9758395E-07,   6.7185346E-07
     +,   7.5382604E-07,   8.4408936E-07,   9.4324969E-07
     +,   1.0519273E-06,   1.1707538E-06,   1.3003735E-06
     +,   1.4414104E-06,   1.5945275E-06,   1.7603338E-06
     +,   1.9394517E-06,   2.1324743E-06,   2.3399655E-06
     +,   2.5624529E-06,   2.8004201E-06,   3.0542969E-06
     +,   3.3244530E-06,   3.6111876E-06,   3.9147199E-06
     +,   4.2351835E-06,   4.5726151E-06,   4.9269474E-06
     +,   5.2980040E-06,   5.6854856E-06,   6.0889724E-06
     +,   6.5079116E-06,   6.9416178E-06,   7.3892697E-06
     +,   7.8499043E-06,   8.3224222E-06,   8.8056140E-06
     +,   9.2980699E-06,   9.7983257E-06,   1.0304758E-05
     +,   1.0815710E-05,   1.1329405E-05,   1.1843965E-05
     +,   1.2357542E-05,   1.2868276E-05,   1.3374352E-05
     +,   1.3874043E-05,   1.4365783E-05,   1.4848210E-05
     +,   1.5320253E-05,   1.5781223E-05,   1.6230875E-05
     +,   1.6669546E-05,   1.7098217E-05,   1.7518651E-05
     +,   1.7933464E-05,   1.8346242E-05,   1.8761611E-05
     +,   1.9185287E-05,   1.9624124E-05,   2.0086101E-05
     +,   2.0580303E-05,   2.1116848E-05,   2.1706815E-05
     +,   2.2362150E-05,   2.3095634E-05,   2.3920897E-05
     +,   2.4852572E-05,   2.5906702E-05,   2.7101369E-05
     +,   2.8457733E-05,   3.0001469E-05,   3.1764695E-05
     +,   3.3788194E-05,   3.6124020E-05,   3.8838043E-05
     +,   4.2012380E-05,   4.5746161E-05,   5.0157203E-05
     +,   5.5379041E-05,   6.1557999E-05,   6.8847279E-05
     +,   7.7397439E-05,   8.7348264E-05,   9.8816556E-05
     +,   1.1188541E-04,   1.2659862E-04,   1.4294982E-04
     +,   1.6088899E-04,   1.8032664E-04,   2.0115008E-04
     +,   2.2324824E-04,   2.4653878E-04,   2.7101708E-04
     +,   2.9678864E-04,   3.2411728E-04,   3.5346314E-04
     +,   3.8550707E-04,   4.2117282E-04,   4.6162069E-04
     +,   5.0821784E-04,   5.6248426E-04,   6.2594860E-04
     +,   6.9996621E-04,   7.8540784E-04,   8.8227045E-04
     +,   9.8924874E-04,   1.1033722E-03,   1.2198485E-03
     +,   1.3322592E-03,   1.4331805E-03,   1.5151957E-03
     +,   1.5721287E-03,   1.6002258E-03,   1.5989916E-03
     +,   1.5714562E-03,   1.5237842E-03,   1.4643010E-03
     +,   1.4021257E-03,   1.3456816E-03,   1.3013456E-03
     +,   1.2724884E-03,   1.2590728E-03,   1.2579118E-03
     +,   1.2635592E-03,   1.2697080E-03,   1.2708389E-03
     +,   1.2637760E-03,   1.2487908E-03,   1.2299326E-03
     +,   1.2144264E-03,   1.2111865E-03,   1.2287468E-03
     +,   1.2730882E-03,   1.3458969E-03,   1.4437145E-03
     +,   1.5582057E-03,   1.6775075E-03,   1.7883707E-03
     +,   1.8785964E-03,   1.9392044E-03,   1.9658352E-03
     +,   1.9590717E-03,   1.9236972E-03,   1.8671614E-03
     +,   1.7977934E-03,   1.7232005E-03,   1.6492227E-03
     +,   1.5794320E-03,   1.5151239E-03,   1.4555607E-03
     +,   1.3983714E-03,   1.3400853E-03,   1.2768084E-03
     +,   1.2050093E-03,   1.1222803E-03,   1.0278996E-03
     +,   9.2306844E-04,   8.1072171E-04,   6.9501961E-04
     +,   5.8068021E-04,   4.7224248E-04,   3.7349437E-04
     +,   2.8706295E-04,   2.1429032E-04,   1.5530181E-04
     +,   1.0923530E-04,   7.4553209E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_nwao_hz_107 = Yx
      RETURN
      END



      DOUBLE PRECISION FUNCTION A1955_hnn_wao_fus_107(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  3.6712340E-16,   4.8281137E-16
     +,   6.3399013E-16,   8.3123827E-16,   1.0881966E-15
     +,   1.4224224E-15,   1.8564705E-15,   2.4192875E-15
     +,   3.1479306E-15,   4.0898190E-15,   5.3054222E-15
     +,   6.8718699E-15,   8.8872696E-15,   1.1476259E-14
     +,   1.4796952E-14,   1.9049436E-14,   2.4486762E-14
     +,   3.1428229E-14,   4.0276037E-14,   5.1536202E-14
     +,   6.5844174E-14,   8.3996497E-14,   1.0699021E-13
     +,   1.3607147E-13,   1.7279364E-13,   2.1909235E-13
     +,   2.7737380E-13,   3.5062475E-13,   4.4254598E-13
     +,   5.5771663E-13,   7.0179024E-13,   8.8173945E-13
     +,   1.1061451E-12,   1.3855497E-12,   1.7328923E-12
     +,   2.1640148E-12,   2.6982824E-12,   3.3593336E-12
     +,   4.1759768E-12,   5.1832462E-12,   6.4236910E-12
     +,   7.9489228E-12,   9.8212541E-12,   1.2116243E-11
     +,   1.4924709E-11,   1.8356209E-11,   2.2542334E-11
     +,   2.7641008E-11,   3.3841319E-11,   4.1369491E-11
     +,   5.0495347E-11,   6.1540613E-11,   7.4887770E-11
     +,   9.0991034E-11,   1.1038934E-10,   1.3371894E-10
     +,   1.6173256E-10,   1.9531732E-10,   2.3551738E-10
     +,   2.8355945E-10,   3.4088204E-10,   4.0916912E-10
     +,   4.9038862E-10,   5.8683602E-10,   7.0118433E-10
     +,   8.3653939E-10,   9.9650466E-10,   1.1852528E-09
     +,   1.4076077E-09,   1.6691342E-09,   1.9762385E-09
     +,   2.3362896E-09,   2.7577349E-09,   3.2502561E-09
     +,   3.8249222E-09,   4.4943311E-09,   5.2728599E-09
     +,   6.1768439E-09,   7.2247741E-09,   8.4376630E-09
     +,   9.8391810E-09,   1.1456039E-08,   1.3318395E-08
     +,   1.5459845E-08,   1.7918220E-08,   2.0736179E-08
     +,   2.3960666E-08,   2.7644468E-08,   3.1846106E-08
     +,   3.6630563E-08,   4.2069768E-08,   4.8243145E-08
     +,   5.5238299E-08,   6.3151617E-08,   7.2088831E-08
     +,   8.2165748E-08,   9.3508980E-08,   1.0625658E-07
     +,   1.2055854E-07,   1.3657791E-07,   1.5449100E-07
     +,   1.7448836E-07,   1.9677537E-07,   2.2157265E-07
     +,   2.4911691E-07,   2.7966126E-07,   3.1347594E-07
     +,   3.5084972E-07,   3.9208467E-07,   4.3750319E-07
     +,   4.8745227E-07,   5.4228474E-07,   6.0237954E-07
     +,   6.6813141E-07,   7.3995221E-07,   8.1827164E-07
     +,   9.0353450E-07,   9.9620286E-07,   1.0967527E-06
     +,   1.2056740E-06,   1.3234704E-06,   1.4506578E-06
     +,   1.5877621E-06,   1.7353193E-06,   1.8938747E-06
     +,   2.0639802E-06,   2.2461948E-06,   2.4410829E-06
     +,   2.6492144E-06,   2.8711620E-06,   3.1075049E-06
     +,   3.3588262E-06,   3.6257115E-06,   3.9087563E-06
     +,   4.2085599E-06,   4.5257343E-06,   4.8609013E-06
     +,   5.2146993E-06,   5.5877831E-06,   5.9808381E-06
     +,   6.3945718E-06,   6.8297340E-06,   7.2871139E-06
     +,   7.7675504E-06,   8.2719416E-06,   8.8012766E-06
     +,   9.3565295E-06,   9.9389217E-06,   1.0549606E-05
     +,   1.1189939E-05,   1.1861368E-05,   1.2565471E-05
     +,   1.3303954E-05,   1.4078681E-05,   1.4891662E-05
     +,   1.5745070E-05,   1.6641252E-05,   1.7582717E-05
     +,   1.8572169E-05,   1.9612464E-05,   2.0706653E-05
     +,   2.1857953E-05,   2.3069742E-05,   2.4345562E-05
     +,   2.5689094E-05,   2.7104157E-05,   2.8594668E-05
     +,   3.0164658E-05,   3.1818217E-05,   3.3559587E-05
     +,   3.5392823E-05,   3.7322225E-05,   3.9351980E-05
     +,   4.1486532E-05,   4.3730255E-05,   4.6087396E-05
     +,   4.8562586E-05,   5.1160649E-05,   5.3886677E-05
     +,   5.6746230E-05,   5.9745522E-05,   6.2891602E-05
     +,   6.6192588E-05,   6.9658025E-05,   7.3299183E-05
     +,   7.7129429E-05,   8.1164726E-05,   8.5424079E-05
     +,   8.9930174E-05,   9.4709896E-05,   9.9795056E-05
     +,   1.0522315E-04,   1.1103797E-04,   1.1729050E-04
     +,   1.2403967E-04,   1.3135295E-04,   1.3930730E-04
     +,   1.4798962E-04,   1.5749774E-04,   1.6794149E-04
     +,   1.7944406E-04,   1.9214486E-04,   2.0620275E-04
     +,   2.2180240E-04,   2.3916188E-04,   2.5854417E-04
     +,   2.8027175E-04,   3.0474420E-04,   3.3245896E-04
     +,   3.6403409E-04,   4.0022255E-04,   4.4194231E-04
     +,   4.9026875E-04,   5.4643507E-04,   6.1180623E-04
     +,   6.8782119E-04,   7.7593687E-04,   8.7753229E-04
     +,   9.9381397E-04,   1.1257620E-03,   1.2740381E-03
     +,   1.4390679E-03,   1.6211410E-03,   1.8206488E-03
     +,   2.0384074E-03,   2.2758755E-03,   2.5353231E-03
     +,   2.8194059E-03,   3.1303805E-03,   3.4689419E-03
     +,   3.8331193E-03,   4.2181835E-03,   4.6177222E-03
     +,   5.0258269E-03,   5.4389499E-03,   5.8552609E-03
     +,   6.2713744E-03,   6.6777072E-03,   7.0571522E-03
     +,   7.3903403E-03,   7.6664193E-03,   7.8927288E-03
     +,   8.0950214E-03,   8.3061429E-03,   8.5511887E-03
     +,   8.8415975E-03,   9.1818944E-03,   9.5769679E-03
     +,   1.0023164E-02,   1.0485137E-02,   1.0885583E-02
     +,   1.1135383E-02,   1.1195360E-02,   1.1120941E-02
     +,   1.1044567E-02,   1.1101224E-02,   1.1352281E-02
     +,   1.1763591E-02,   1.2246439E-02,   1.2719417E-02
     +,   1.3140062E-02,   1.3490744E-02,   1.3748657E-02
     +,   1.3882990E-02,   1.3889926E-02,   1.3831630E-02
     +,   1.3833967E-02,   1.4028184E-02,   1.4464501E-02
     +,   1.5054729E-02,   1.5597126E-02,   1.5884576E-02
     +,   1.5822781E-02,   1.5470596E-02,   1.4981008E-02
     +,   1.4495934E-02,   1.4066846E-02,   1.3651367E-02
     +,   1.3188330E-02,   1.2688423E-02,   1.2256297E-02
     +,   1.2024378E-02,   1.2059015E-02,   1.2306591E-02
     +,   1.2603177E-02,   1.2737472E-02,   1.2540742E-02
     +,   1.1960527E-02,   1.1071827E-02,   1.0017636E-02
     +,   8.9259231E-03,   7.8625670E-03,   6.8396674E-03
     +,   5.8511109E-03,   4.8991805E-03,   4.0004677E-03
     +,   3.1782337E-03,   2.4533835E-03,   1.8388293E-03
     +,   1.3377821E-03,   9.4466622E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wao_fus_107 = Yx
      RETURN
      END



      DOUBLE PRECISION FUNCTION A1955_hnn_wano_fus_107(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  4.0657360E-06,   4.2054226E-06
     +,   4.3513051E-06,   4.5036791E-06,   4.6628516E-06
     +,   4.8291399E-06,   5.0028721E-06,   5.1843881E-06
     +,   5.3740359E-06,   5.5721803E-06,   5.7791826E-06
     +,   5.9954282E-06,   6.2213076E-06,   6.4572191E-06
     +,   6.7035753E-06,   6.9607900E-06,   7.2292919E-06
     +,   7.5095131E-06,   7.8018957E-06,   8.1068865E-06
     +,   8.4249414E-06,   8.7565159E-06,   9.1020747E-06
     +,   9.4620900E-06,   9.8370174E-06,   1.0227332E-05
     +,   1.0633506E-05,   1.1056005E-05,   1.1495304E-05
     +,   1.1951858E-05,   1.2426132E-05,   1.2918582E-05
     +,   1.3429655E-05,   1.3959791E-05,   1.4509418E-05
     +,   1.5078956E-05,   1.5668813E-05,   1.6279382E-05
     +,   1.6911043E-05,   1.7564158E-05,   1.8239074E-05
     +,   1.8936131E-05,   1.9655596E-05,   2.0397814E-05
     +,   2.1163007E-05,   2.1951433E-05,   2.2763314E-05
     +,   2.3598843E-05,   2.4458195E-05,   2.5341515E-05
     +,   2.6248921E-05,   2.7180518E-05,   2.8136370E-05
     +,   2.9116522E-05,   3.0121008E-05,   3.1149793E-05
     +,   3.2202850E-05,   3.3280128E-05,   3.4381548E-05
     +,   3.5506997E-05,   3.6656362E-05,   3.7829486E-05
     +,   3.9026196E-05,   4.0246305E-05,   4.1489609E-05
     +,   4.2755877E-05,   4.4044857E-05,   4.5356308E-05
     +,   4.6689962E-05,   4.8045524E-05,   4.9422702E-05
     +,   5.0821192E-05,   5.2240703E-05,   5.3680888E-05
     +,   5.5141471E-05,   5.6622070E-05,   5.8122398E-05
     +,   5.9642145E-05,   6.1180937E-05,   6.2738574E-05
     +,   6.4314721E-05,   6.5909138E-05,   6.7521622E-05
     +,   6.9151887E-05,   7.0799761E-05,   7.2465358E-05
     +,   7.4148440E-05,   7.5849173E-05,   7.7567740E-05
     +,   7.9304431E-05,   8.1059741E-05,   8.2834376E-05
     +,   8.4629202E-05,   8.6445449E-05,   8.8284636E-05
     +,   9.0148693E-05,   9.2040027E-05,   9.3961586E-05
     +,   9.5916977E-05,   9.7910459E-05,   9.9947254E-05
     +,   1.0203353E-04,   1.0417651E-04,   1.0638475E-04
     +,   1.0866819E-04,   1.1103835E-04,   1.1350863E-04
     +,   1.1609437E-04,   1.1881287E-04,   1.2168386E-04
     +,   1.2473011E-04,   1.2797632E-04,   1.3145052E-04
     +,   1.3518374E-04,   1.3921008E-04,   1.4356671E-04
     +,   1.4829417E-04,   1.5343599E-04,   1.5903854E-04
     +,   1.6515111E-04,   1.7182510E-04,   1.7911405E-04
     +,   1.8707274E-04,   1.9575661E-04,   2.0522115E-04
     +,   2.1552066E-04,   2.2670803E-04,   2.3883321E-04
     +,   2.5194237E-04,   2.6607749E-04,   2.8127502E-04
     +,   2.9756560E-04,   3.1497361E-04,   3.3351695E-04
     +,   3.5320761E-04,   3.7405168E-04,   3.9605075E-04
     +,   4.1920345E-04,   4.4350699E-04,   4.6896015E-04
     +,   4.9556559E-04,   5.2333390E-04,   5.5228733E-04
     +,   5.8246352E-04,   6.1392097E-04,   6.4674410E-04
     +,   6.8104180E-04,   7.1696733E-04,   7.5470161E-04
     +,   7.9447258E-04,   8.3654921E-04,   8.8124274E-04
     +,   9.2890469E-04,   9.7992038E-04,   1.0347033E-03
     +,   1.0936806E-03,   1.1572799E-03,   1.2259113E-03
     +,   1.2999481E-03,   1.3797022E-03,   1.4654025E-03
     +,   1.5571716E-03,   1.6550004E-03,   1.7587250E-03
     +,   1.8680082E-03,   1.9823245E-03,   2.1009364E-03
     +,   2.2228933E-03,   2.3470235E-03,   2.4719592E-03
     +,   2.5961371E-03,   2.7178826E-03,   2.8354675E-03
     +,   2.9472525E-03,   3.0518007E-03,   3.1480514E-03
     +,   3.2355213E-03,   3.3144515E-03,   3.3859303E-03
     +,   3.4519744E-03,   3.5154771E-03,   3.5801032E-03
     +,   3.6500772E-03,   3.7298650E-03,   3.8238557E-03
     +,   3.9360002E-03,   4.0694820E-03,   4.2264434E-03
     +,   4.4077476E-03,   4.6128402E-03,   4.8395847E-03
     +,   5.0841868E-03,   5.3411406E-03,   5.6032282E-03
     +,   5.8617103E-03,   6.1067510E-03,   6.3281637E-03
     +,   6.5164450E-03,   6.6641346E-03,   6.7670676E-03
     +,   6.8255481E-03,   6.8448605E-03,   6.8351887E-03
     +,   6.8107052E-03,   6.7880289E-03,   6.7841816E-03
     +,   6.8145199E-03,   6.8908152E-03,   7.0197247E-03
     +,   7.2021782E-03,   7.4334107E-03,   7.7040214E-03
     +,   8.0013713E-03,   8.3113490E-03,   8.6199036E-03
     +,   8.9140125E-03,   9.1825146E-03,   9.4165774E-03
     +,   9.6103232E-03,   9.7616157E-03,   9.8723993E-03
     +,   9.9486066E-03,   9.9988673E-03,   1.0032327E-02
     +,   1.0056142E-02,   1.0073173E-02,   1.0080869E-02
     +,   1.0071510E-02,   1.0033722E-02,   9.9548856E-03
     +,   9.8237786E-03,   9.6328808E-03,   9.3801925E-03
     +,   9.0702111E-03,   8.7139439E-03,   8.3280373E-03
     +,   7.9327030E-03,   7.5489525E-03,   7.1955235E-03
     +,   6.8862336E-03,   6.6282796E-03,   6.4220838E-03
     +,   6.2623974E-03,   6.1404658E-03,   6.0464502E-03
     +,   5.9715724E-03,   5.9094722E-03,   5.8566518E-03
     +,   5.8121537E-03,   5.7766954E-03,   5.7516391E-03
     +,   5.7381494E-03,   5.7366178E-03,   5.7465504E-03
     +,   5.7666982E-03,   5.7954858E-03,   5.8313180E-03
     +,   5.8728969E-03,   5.9190853E-03,   5.9686895E-03
     +,   6.0199541E-03,   6.0701445E-03,   6.1153122E-03
     +,   6.1504696E-03,   6.1701788E-03,   6.1694607E-03
     +,   6.1448403E-03,   6.0951454E-03,   6.0219984E-03
     +,   5.9296093E-03,   5.8241263E-03,   5.7126028E-03
     +,   5.6018485E-03,   5.4974863E-03,   5.4033780E-03
     +,   5.3215246E-03,   5.2523231E-03,   5.1950896E-03
     +,   5.1486460E-03,   5.1116962E-03,   5.0830278E-03
     +,   5.0613838E-03,   5.0451742E-03,   5.0320569E-03
     +,   5.0186021E-03,   5.0001014E-03,   4.9706781E-03
     +,   4.9236496E-03,   4.8521585E-03,   4.7499426E-03
     +,   4.6121627E-03,   4.4360445E-03,   4.2213355E-03
     +,   3.9704950E-03,   3.6884630E-03,   3.3822872E-03
     +,   3.0603653E-03,   2.7317428E-03,   2.4053445E-03
     +,   2.0893058E-03,   1.7904870E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_wano_fus_107 = Yx
      RETURN
      END

      DOUBLE PRECISION FUNCTION A1955_hnn_nwao_fus_107(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 104.3/
      DATA y /  0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   2.5758556E-38,   5.9305709E-38
     +,   1.3591897E-37,   3.1006475E-37,   7.0409311E-37
     +,   1.5914993E-36,   3.5808393E-36,   8.0198317E-36
     +,   1.7879182E-35,   3.9676384E-35,   8.7642597E-35
     +,   1.9270829E-34,   4.2178165E-34,   9.1891810E-34
     +,   1.9928198E-33,   4.3018935E-33,   9.2438216E-33
     +,   1.9771843E-32,   4.2096063E-32,   8.9215331E-32
     +,   1.8821006E-31,   3.9521785E-31,   8.2612144E-31
     +,   1.7188910E-30,   3.5600115E-30,   7.3393602E-30
     +,   1.5061344E-29,   3.0766012E-29,   6.2557689E-29
     +,   1.2661707E-28,   2.5509628E-28,   5.1158727E-28
     +,   1.0212545E-27,   2.0293497E-27,   4.0139804E-27
     +,   7.9030042E-27,   1.5488628E-26,   3.0216023E-26
     +,   5.8675986E-26,   1.1341848E-25,   2.1822821E-25
     +,   4.1796355E-25,   7.9683402E-25,   1.5121599E-24
     +,   2.8564695E-24,   5.3710817E-24,   1.0053008E-23
     +,   1.8729833E-23,   3.4735259E-23,   6.4122319E-23
     +,   1.1782837E-22,   2.1552165E-22,   3.9240441E-22
     +,   7.1118438E-22,   1.2830078E-21,   2.3039607E-21
     +,   4.1183618E-21,   7.3277281E-21,   1.2978400E-20
     +,   2.2880913E-20,   4.0153880E-20,   7.0144250E-20
     +,   1.2196923E-19,   2.1110442E-19,   3.6371917E-19
     +,   6.2377504E-19,   1.0648541E-18,   1.8094789E-18
     +,   3.0606863E-18,   5.1532996E-18,   8.6368062E-18
     +,   1.4408639E-17,   2.3927265E-17,   3.9551704E-17
     +,   6.5078646E-17,   1.0658916E-16,   1.7377625E-16
     +,   2.8201181E-16,   4.5556068E-16,   7.3253289E-16
     +,   1.1724880E-15,   1.8680640E-15,   2.9626220E-15
     +,   4.6769415E-15,   7.3493618E-15,   1.1495761E-14
     +,   1.7899336E-14,   2.7741334E-14,   4.2796983E-14
     +,   6.5722526E-14,   1.0046408E-13,   1.5286486E-13
     +,   2.3152918E-13,   3.4906388E-13,   5.2385006E-13
     +,   7.8254520E-13,   1.1636252E-12,   1.7223394E-12
     +,   2.5376092E-12,   3.7216298E-12,   5.4330342E-12
     +,   7.8950353E-12,   1.1419999E-11,   1.6442948E-11
     +,   2.3566494E-11,   3.3621061E-11,   4.7745172E-11
     +,   6.7491443E-11,   9.4966229E-11,   1.3301225E-10
     +,   1.8544478E-10,   2.5735938E-10,   3.5552222E-10
     +,   4.8887150E-10,   6.6915096E-10,   9.1170688E-10
     +,   1.2364821E-09,   1.6692555E-09,   2.2431559E-09
     +,   3.0005265E-09,   3.9951980E-09,   5.2951878E-09
     +,   6.9859754E-09,   9.1743644E-09,   1.1993156E-08
     +,   1.5605780E-08,   2.0214005E-08,   2.6062759E-08
     +,   3.3449986E-08,   4.2734634E-08,   5.4346973E-08
     +,   6.8799231E-08,   8.6697774E-08,   1.0875570E-07
     +,   1.3580619E-07,   1.6881711E-07,   2.0890469E-07
     +,   2.5734889E-07,   3.1560779E-07,   3.8533153E-07
     +,   4.6837653E-07,   5.6681824E-07,   6.8296305E-07
     +,   8.1936048E-07,   9.7881173E-07,   1.1643837E-06
     +,   1.3794150E-06,   1.6275330E-06,   1.9126760E-06
     +,   2.2390668E-06,   2.6113055E-06,   3.0343404E-06
     +,   3.5135922E-06,   4.0549339E-06,   4.6647365E-06
     +,   5.3500848E-06,   6.1188043E-06,   6.9796247E-06
     +,   7.9423471E-06,   9.0180447E-06,   1.0219284E-05
     +,   1.1560374E-05,   1.3057647E-05,   1.4729746E-05
     +,   1.6597905E-05,   1.8686273E-05,   2.1022121E-05
     +,   2.3636101E-05,   2.6562382E-05,   2.9838635E-05
     +,   3.3506003E-05,   3.7608770E-05,   4.2193955E-05
     +,   4.7310601E-05,   5.3008964E-05,   5.9339396E-05
     +,   6.6351182E-05,   7.4091215E-05,   8.2602812E-05
     +,   9.1924529E-05,   1.0208939E-04,   1.1312462E-04
     +,   1.2505185E-04,   1.3788823E-04,   1.5164798E-04
     +,   1.6634507E-04,   1.8199590E-04,   1.9862257E-04
     +,   2.1625675E-04,   2.3493927E-04,   2.5473072E-04
     +,   2.7570792E-04,   2.9797276E-04,   3.2165932E-04
     +,   3.4693902E-04,   3.7403766E-04,   4.0324274E-04
     +,   4.3491434E-04,   4.6949976E-04,   5.0752453E-04
     +,   5.4960942E-04,   5.9646327E-04,   6.4887956E-04
     +,   7.0772233E-04,   7.7386491E-04,   8.4811641E-04
     +,   9.3101931E-04,   1.0226116E-03,   1.1221276E-03
     +,   1.2277049E-03,   1.3362593E-03,   1.4435463E-03
     +,   1.5445262E-03,   1.6340087E-03,   1.7073838E-03
     +,   1.7613856E-03,   1.7945758E-03,   1.8074977E-03
     +,   1.8024794E-03,   1.7831880E-03,   1.7540953E-03
     +,   1.7200025E-03,   1.6856998E-03,   1.6557227E-03
     +,   1.6341525E-03,   1.6243755E-03,   1.6288012E-03
     +,   1.6486261E-03,   1.6837489E-03,   1.7329274E-03
     +,   1.7941461E-03,   1.8650379E-03,   1.9431412E-03
     +,   2.0258063E-03,   2.1097672E-03,   2.1906146E-03
     +,   2.2626452E-03,   2.3195099E-03,   2.3558682E-03
     +,   2.3696937E-03,   2.3643668E-03,   2.3493932E-03
     +,   2.3388511E-03,   2.3475131E-03,   2.3857378E-03
     +,   2.4551428E-03,   2.5471984E-03,   2.6458891E-03
     +,   2.7337109E-03,   2.7985566E-03,   2.8382363E-03
     +,   2.8604234E-03,   2.8779386E-03,   2.9016265E-03
     +,   2.9342007E-03,   2.9678717E-03,   2.9866584E-03
     +,   2.9721174E-03,   2.9097991E-03,   2.7937524E-03
     +,   2.6275169E-03,   2.4219058E-03,   2.1911077E-03
     +,   1.9490134E-03,   1.7070160E-03,   1.4734584E-03
     +,   1.2541478E-03,   1.0531133E-03,   8.7308954E-04
     +,   7.1566866E-04,   5.8121065E-04,   4.6885951E-04
     +,   3.7675461E-04,   3.0234741E-04,   2.4282075E-04
     +,   1.9542167E-04,   1.5770958E-04,   1.2765784E-04
     +,   1.0365598E-04,   8.4449792E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1955_hnn_nwao_fus_107 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_nwao_fus_100(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  2.2672030E-08,   2.5554014E-08
     +,   2.8769371E-08,   3.2352105E-08,   3.6339308E-08
     +,   4.0771184E-08,   4.5691028E-08,   5.1145840E-08
     +,   5.7186355E-08,   6.3866814E-08,   7.1245900E-08
     +,   7.9386460E-08,   8.8355904E-08,   9.8225804E-08
     +,   1.0907308E-07,   1.2097961E-07,   1.3403168E-07
     +,   1.4832179E-07,   1.6394748E-07,   1.8101130E-07
     +,   1.9962188E-07,   2.1989403E-07,   2.4194671E-07
     +,   2.6590578E-07,   2.9190284E-07,   3.2007367E-07
     +,   3.5056075E-07,   3.8351237E-07,   4.1907941E-07
     +,   4.5741993E-07,   4.9869641E-07,   5.4307378E-07
     +,   5.9072164E-07,   6.4181455E-07,   6.9652589E-07
     +,   7.5503470E-07,   8.1752103E-07,   8.8416249E-07
     +,   9.5513997E-07,   1.0306322E-06,   1.1108179E-06
     +,   1.1958680E-06,   1.2859540E-06,   1.3812410E-06
     +,   1.4818891E-06,   1.5880472E-06,   1.6998611E-06
     +,   1.8174592E-06,   1.9409651E-06,   2.0704872E-06
     +,   2.2061242E-06,   2.3479479E-06,   2.4960248E-06
     +,   2.6504022E-06,   2.8110981E-06,   2.9781190E-06
     +,   3.1514510E-06,   3.3310448E-06,   3.5168387E-06
     +,   3.7087432E-06,   3.9066331E-06,   4.1103667E-06
     +,   4.3197738E-06,   4.5346428E-06,   4.7547478E-06
     +,   4.9798291E-06,   5.2095870E-06,   5.4437050E-06
     +,   5.6818358E-06,   5.9235904E-06,   6.1685632E-06
     +,   6.4163187E-06,   6.6663970E-06,   6.9182979E-06
     +,   7.1715167E-06,   7.4255026E-06,   7.6797151E-06
     +,   7.9335687E-06,   8.1864591E-06,   8.4377971E-06
     +,   8.6869532E-06,   8.9332880E-06,   9.1761849E-06
     +,   9.4149964E-06,   9.6490767E-06,   9.8778073E-06
     +,   1.0100546E-05,   1.0316691E-05,   1.0525635E-05
     +,   1.0726790E-05,   1.0919587E-05,   1.1103508E-05
     +,   1.1278034E-05,   1.1442685E-05,   1.1597038E-05
     +,   1.1740686E-05,   1.1873272E-05,   1.1994500E-05
     +,   1.2104105E-05,   1.2201890E-05,   1.2287706E-05
     +,   1.2361467E-05,   1.2423146E-05,   1.2472784E-05
     +,   1.2510483E-05,   1.2536419E-05,   1.2550833E-05
     +,   1.2554039E-05,   1.2546419E-05,   1.2528435E-05
     +,   1.2500615E-05,   1.2463561E-05,   1.2417949E-05
     +,   1.2364529E-05,   1.2304123E-05,   1.2237614E-05
     +,   1.2165964E-05,   1.2090193E-05,   1.2011391E-05
     +,   1.1930709E-05,   1.1849349E-05,   1.1768579E-05
     +,   1.1689704E-05,   1.1614087E-05,   1.1543128E-05
     +,   1.1478270E-05,   1.1420974E-05,   1.1372740E-05
     +,   1.1335083E-05,   1.1309527E-05,   1.1297609E-05
     +,   1.1300860E-05,   1.1320806E-05,   1.1358955E-05
     +,   1.1416794E-05,   1.1495777E-05,   1.1597322E-05
     +,   1.1722790E-05,   1.1873510E-05,   1.2050721E-05
     +,   1.2255634E-05,   1.2489356E-05,   1.2752921E-05
     +,   1.3047316E-05,   1.3373418E-05,   1.3732021E-05
     +,   1.4123882E-05,   1.4549652E-05,   1.5009913E-05
     +,   1.5505244E-05,   1.6036141E-05,   1.6603070E-05
     +,   1.7206563E-05,   1.7847111E-05,   1.8525277E-05
     +,   1.9241685E-05,   1.9997149E-05,   2.0792539E-05
     +,   2.1629023E-05,   2.2507926E-05,   2.3430877E-05
     +,   2.4399804E-05,   2.5417054E-05,   2.6485417E-05
     +,   2.7608037E-05,   2.8788596E-05,   3.0031280E-05
     +,   3.1340776E-05,   3.2722433E-05,   3.4182151E-05
     +,   3.5726291E-05,   3.7361777E-05,   3.9095947E-05
     +,   4.0936698E-05,   4.2892287E-05,   4.4971010E-05
     +,   4.7181344E-05,   4.9531674E-05,   5.2030013E-05
     +,   5.4684158E-05,   5.7500743E-05,   6.0485778E-05
     +,   6.3643616E-05,   6.6977060E-05,   7.0486924E-05
     +,   7.4171563E-05,   7.8027027E-05,   8.2046543E-05
     +,   8.6219909E-05,   9.0533875E-05,   9.4971758E-05
     +,   9.9513971E-05,   1.0413788E-04,   1.0881788E-04
     +,   1.1352630E-04,   1.1823403E-04,   1.2291119E-04
     +,   1.2752893E-04,   1.3206025E-04,   1.3648154E-04
     +,   1.4077500E-04,   1.4493056E-04,   1.4894825E-04
     +,   1.5284146E-04,   1.5663909E-04,   1.6038833E-04
     +,   1.6415758E-04,   1.6803875E-04,   1.7214965E-04
     +,   1.7663557E-04,   1.8167042E-04,   1.8745838E-04
     +,   1.9423525E-04,   2.0226992E-04,   2.1186755E-04
     +,   2.2336960E-04,   2.3715837E-04,   2.5365365E-04
     +,   2.7331017E-04,   2.9660645E-04,   3.2402552E-04
     +,   3.5602975E-04,   3.9302488E-04,   4.3531755E-04
     +,   4.8308590E-04,   5.3635630E-04,   5.9501966E-04
     +,   6.5885222E-04,   7.2759757E-04,   8.0101920E-04
     +,   8.7895547E-04,   9.6130080E-04,   1.0479246E-03
     +,   1.1385133E-03,   1.2324110E-03,   1.3285879E-03
     +,   1.4258040E-03,   1.5230232E-03,   1.6199920E-03
     +,   1.7176772E-03,   1.8182365E-03,   1.9242595E-03
     +,   2.0373147E-03,   2.1563512E-03,   2.2767759E-03
     +,   2.3910585E-03,   2.4910427E-03,   2.5712070E-03
     +,   2.6315288E-03,   2.6785464E-03,   2.7239469E-03
     +,   2.7812130E-03,   2.8614225E-03,   2.9695416E-03
     +,   3.1021663E-03,   3.2473898E-03,   3.3872479E-03
     +,   3.5024988E-03,   3.5784850E-03,   3.6097558E-03
     +,   3.6009930E-03,   3.5635123E-03,   3.5090044E-03
     +,   3.4439289E-03,   3.3674848E-03,   3.2739080E-03
     +,   3.1573686E-03,   3.0166009E-03,   2.8569791E-03
     +,   2.6893970E-03,   2.5267834E-03,   2.3800132E-03
     +,   2.2548954E-03,   2.1512059E-03,   2.0638674E-03
     +,   1.9854552E-03,   1.9088471E-03,   1.8290776E-03
     +,   1.7439659E-03,   1.6536809E-03,   1.5598135E-03
     +,   1.4643805E-03,   1.3691669E-03,   1.2753779E-03
     +,   1.1835918E-03,   1.0938426E-03,   1.0058581E-03
     +,   9.1925968E-04,   8.3379081E-04,   7.4949005E-04
     +,   6.6676282E-04,   5.8638526E-04,   5.0937349E-04
     +,   4.3683933E-04,   3.6980637E-04,   3.0906967E-04
     +,   2.5511321E-04,   2.0807001E-04,   1.6777625E-04
     +,   1.3381857E-04,   1.0561776E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_nwao_fus_100 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_nwao_fus_105(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  1.8264570E-33,   3.4726693E-33
     +,   6.5815774E-33,   1.2433526E-32,   2.3413419E-32
     +,   4.3948745E-32,   8.2230138E-32,   1.5336172E-31
     +,   2.8511331E-31,   5.2834531E-31,   9.7593989E-31
     +,   1.7969587E-30,   3.2980824E-30,   6.0337399E-30
     +,   1.1003188E-29,   2.0001485E-29,   3.6241376E-29
     +,   6.5457213E-29,   1.1784761E-28,   2.1148832E-28
     +,   3.7831851E-28,   6.7459471E-28,   1.1990323E-27
     +,   2.1243360E-27,   3.7517162E-27,   6.6044706E-27
     +,   1.1589217E-26,   2.0271383E-26,   3.5344022E-26
     +,   6.1426694E-26,   1.0641679E-25,   1.8376680E-25
     +,   3.1632573E-25,   5.4276613E-25,   9.2831485E-25
     +,   1.5826647E-24,   2.6896386E-24,   4.5562279E-24
     +,   7.6935521E-24,   1.2949620E-23,   2.1727138E-23
     +,   3.6337395E-23,   6.0578131E-23,   1.0066708E-22
     +,   1.6675429E-22,   2.7534144E-22,   4.5319107E-22
     +,   7.4353248E-22,   1.2159878E-21,   1.9823084E-21
     +,   3.2212998E-21,   5.2179434E-21,   8.4252182E-21
     +,   1.3560586E-20,   2.1756380E-20,   3.4794403E-20
     +,   5.5468994E-20,   8.8146104E-20,   1.3962712E-19
     +,   2.2047318E-19,   3.4702008E-19,   5.4446532E-19
     +,   8.5154056E-19,   1.3275588E-18,   2.0630991E-18
     +,   3.1960094E-18,   4.9352656E-18,   7.5968259E-18
     +,   1.1656704E-17,   1.7829345E-17,   2.7184181E-17
     +,   4.1315895E-17,   6.2595358E-17,   9.4533469E-17
     +,   1.4231662E-16,   2.1356959E-16,   3.1948701E-16
     +,   4.7642183E-16,   7.0818572E-16,   1.0493795E-15
     +,   1.5500476E-15,   2.2823129E-15,   3.3499520E-15
     +,   4.9014993E-15,   7.1489039E-15,   1.0394030E-14
     +,   1.5064384E-14,   2.1764759E-14,   3.1346233E-14
     +,   4.5003508E-14,   6.4406915E-14,   9.1887225E-14
     +,   1.3068045E-13,   1.8526406E-13,   2.6182528E-13
     +,   3.6886214E-13,   5.1801900E-13,   7.2521454E-13
     +,   1.0120860E-12,   1.4080217E-12,   1.9527062E-12
     +,   2.6996135E-12,   3.7204640E-12,   5.1113593E-12
     +,   7.0001583E-12,   9.5570375E-12,   1.3007000E-11
     +,   1.7647014E-11,   2.3867104E-11,   3.2179068E-11
     +,   4.3249720E-11,   5.7948091E-11,   7.7399129E-11
     +,   1.0305634E-10,   1.3678902E-10,   1.8099830E-10
     +,   2.3874586E-10,   3.1393890E-10,   4.1152645E-10
     +,   5.3776078E-10,   7.0053330E-10,   9.0972052E-10
     +,   1.1777023E-09,   1.5198720E-09,   1.9553421E-09
     +,   2.5077167E-09,   3.2061418E-09,   4.0863126E-09
     +,   5.1918301E-09,   6.5759331E-09,   8.3030649E-09
     +,   1.0451047E-08,   1.3113808E-08,   1.6403540E-08
     +,   2.0454728E-08,   2.5426868E-08,   3.1509028E-08
     +,   3.8923876E-08,   4.7933916E-08,   5.8844819E-08
     +,   7.2014210E-08,   8.7855533E-08,   1.0684576E-07
     +,   1.2953549E-07,   1.5655230E-07,   1.8861049E-07
     +,   2.2652368E-07,   2.7120575E-07,   3.2368163E-07
     +,   3.8510245E-07,   4.5674096E-07,   5.4000225E-07
     +,   6.3644057E-07,   7.4774420E-07,   8.7575063E-07
     +,   1.0224373E-06,   1.1899421E-06,   1.3805177E-06
     +,   1.5965752E-06,   1.8406209E-06,   2.1152703E-06
     +,   2.4232090E-06,   2.7671999E-06,   3.1500419E-06
     +,   3.5744956E-06,   4.0432915E-06,   4.5590700E-06
     +,   5.1243114E-06,   5.7413527E-06,   6.4122969E-06
     +,   7.1388995E-06,   7.9225883E-06,   8.7643411E-06
     +,   9.6647500E-06,   1.0623889E-05,   1.1641212E-05
     +,   1.2715621E-05,   1.3845407E-05,   1.5028190E-05
     +,   1.6261134E-05,   1.7540640E-05,   1.8862786E-05
     +,   2.0223082E-05,   2.1616775E-05,   2.3038960E-05
     +,   2.4484718E-05,   2.5949505E-05,   2.7429316E-05
     +,   2.8920880E-05,   3.0422136E-05,   3.1932512E-05
     +,   3.3453442E-05,   3.4988629E-05,   3.6544283E-05
     +,   3.8129579E-05,   3.9756902E-05,   4.1441923E-05
     +,   4.3203974E-05,   4.5065986E-05,   4.7054360E-05
     +,   4.9199374E-05,   5.1535331E-05,   5.4101154E-05
     +,   5.6941710E-05,   6.0109593E-05,   6.3667510E-05
     +,   6.7692497E-05,   7.2280403E-05,   7.7552293E-05
     +,   8.3660598E-05,   9.0794958E-05,   9.9188561E-05
     +,   1.0912201E-04,   1.2092438E-04,   1.3497425E-04
     +,   1.5169273E-04,   1.7154279E-04,   1.9501941E-04
     +,   2.2264724E-04,   2.5497543E-04,   2.9256905E-04
     +,   3.3599781E-04,   3.8580038E-04,   4.4241568E-04
     +,   5.0608732E-04,   5.7671743E-04,   6.5370998E-04
     +,   7.3578430E-04,   8.2087691E-04,   9.0609427E-04
     +,   9.8783476E-04,   1.0620556E-03,   1.1246947E-03
     +,   1.1721718E-03,   1.2019078E-03,   1.2127800E-03
     +,   1.2054240E-03,   1.1823485E-03,   1.1478500E-03
     +,   1.1077396E-03,   1.0689071E-03,   1.0387152E-03
     +,   1.0242749E-03,   1.0316279E-03,   1.0649451E-03
     +,   1.1258485E-03,   1.2130248E-03,   1.3222359E-03
     +,   1.4468784E-03,   1.5791679E-03,   1.7118448E-03
     +,   1.8402747E-03,   1.9642815E-03,   2.0890823E-03
     +,   2.2245331E-03,   2.3823895E-03,   2.5719970E-03
     +,   2.7954008E-03,   3.0433149E-03,   3.2936404E-03
     +,   3.5140866E-03,   3.6699998E-03,   3.7364685E-03
     +,   3.7103489E-03,   3.6152543E-03,   3.4938704E-03
     +,   3.3887152E-03,   3.3215471E-03,   3.2853712E-03
     +,   3.2564707E-03,   3.2195803E-03,   3.1879065E-03
     +,   3.2019352E-03,   3.3068084E-03,   3.5244813E-03
     +,   3.8391363E-03,   4.2020418E-03,   4.5478307E-03
     +,   4.8113721E-03,   4.9409196E-03,   4.9079047E-03
     +,   4.7124489E-03,   4.3811188E-03,   3.9564390E-03
     +,   3.4832570E-03,   2.9984547E-03,   2.5278605E-03
     +,   2.0881165E-03,   1.6903712E-03,   1.3426715E-03
     +,   1.0501493E-03,   8.1408967E-04,   6.3109398E-04
     +,   4.9369334E-04,   3.9210869E-04,   3.1647235E-04
     +,   2.5853777E-04,   2.1240277E-04,   1.7440628E-04
     +,   1.4250894E-04,   1.1562397E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_nwao_fus_105 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_nwao_fus_107(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  1.1724232E-19,   1.6372453E-19
     +,   2.2824307E-19,   3.1763508E-19,   4.4127537E-19
     +,   6.1198916E-19,   8.4727743E-19,   1.1709980E-18
     +,   1.6156274E-18,   2.2252176E-18,   3.0595314E-18
     +,   4.1994041E-18,   5.7540234E-18,   7.8705499E-18
     +,   1.0747000E-17,   1.4649479E-17,   1.9934560E-17
     +,   2.7079400E-17,   3.6721889E-17,   4.9711728E-17
     +,   6.7180354E-17,   9.0631526E-17,   1.2205693E-16
     +,   1.6409556E-16,   2.2023387E-16,   2.9506544E-16
     +,   3.9464168E-16,   5.2691479E-16,   7.0230350E-16
     +,   9.3445935E-16,   1.2412179E-15,   1.6458246E-15
     +,   2.1785550E-15,   2.8787713E-15,   3.7974638E-15
     +,   5.0006869E-15,   6.5738185E-15,   8.6268925E-15
     +,   1.1301640E-14,   1.4780120E-14,   1.9295966E-14
     +,   2.5148019E-14,   3.2718348E-14,   4.2494088E-14
     +,   5.5095793E-14,   7.1310945E-14,   9.2139702E-14
     +,   1.1884597E-13,   1.5302882E-13,   1.9670326E-13
     +,   2.5240728E-13,   3.2332559E-13,   4.1345613E-13
     +,   5.2780176E-13,   6.7260482E-13,   8.5565507E-13
     +,   1.0866537E-12,   1.3776234E-12,   1.7434949E-12
     +,   2.2027360E-12,   2.7781295E-12,   3.4977824E-12
     +,   4.3962785E-12,   5.5160251E-12,   6.9090250E-12
     +,   8.6389264E-12,   1.0783282E-11,   1.3436686E-11
     +,   1.6714206E-11,   2.0755214E-11,   2.5728768E-11
     +,   3.1839156E-11,   3.9332874E-11,   4.8506248E-11
     +,   5.9716190E-11,   7.3389281E-11,   9.0038303E-11
     +,   1.1027380E-10,   1.3482286E-10,   1.6455398E-10
     +,   2.0049502E-10,   2.4386274E-10,   2.9610175E-10
     +,   3.5891101E-10,   4.3428935E-10,   5.2459637E-10
     +,   6.3258365E-10,   7.6148954E-10,   9.1508251E-10
     +,   1.0977598E-09,   1.3146210E-09,   1.5716196E-09
     +,   1.8756174E-09,   2.2345401E-09,   2.6575759E-09
     +,   3.1552454E-09,   3.7396206E-09,   4.4246131E-09
     +,   5.2260130E-09,   6.1619545E-09,   7.2529813E-09
     +,   8.5224574E-09,   9.9967838E-09,   1.1706010E-08
     +,   1.3683747E-08,   1.5968130E-08,   1.8601714E-08
     +,   2.1632278E-08,   2.5113023E-08,   2.9103722E-08
     +,   3.3670187E-08,   3.8886185E-08,   4.4832738E-08
     +,   5.1599486E-08,   5.9284769E-08,   6.7997590E-08
     +,   7.7855930E-08,   8.8990269E-08,   1.0154138E-07
     +,   1.1566232E-07,   1.3152035E-07,   1.4929397E-07
     +,   1.6917788E-07,   1.9137941E-07,   2.1612090E-07
     +,   2.4363891E-07,   2.7418818E-07,   3.0803551E-07
     +,   3.4546264E-07,   3.8677064E-07,   4.3227112E-07
     +,   4.8228856E-07,   5.3716764E-07,   5.9725676E-07
     +,   6.6292489E-07,   7.3454373E-07,   8.1249607E-07
     +,   8.9716667E-07,   9.8895589E-07,   1.0882513E-06
     +,   1.1954555E-06,   1.3109549E-06,   1.4351278E-06
     +,   1.5683581E-06,   1.7110004E-06,   1.8633899E-06
     +,   2.0258583E-06,   2.1986934E-06,   2.3821515E-06
     +,   2.5764746E-06,   2.7818451E-06,   2.9984001E-06
     +,   3.2262542E-06,   3.4654449E-06,   3.7159621E-06
     +,   3.9777265E-06,   4.2506281E-06,   4.5344527E-06
     +,   4.8289617E-06,   5.1338211E-06,   5.4486459E-06
     +,   5.7729744E-06,   6.1063165E-06,   6.4481392E-06
     +,   6.7978426E-06,   7.1548211E-06,   7.5184639E-06
     +,   7.8881649E-06,   8.2633960E-06,   8.6437103E-06
     +,   9.0287595E-06,   9.4183888E-06,   9.8126520E-06
     +,   1.0211951E-05,   1.0617067E-05,   1.1029232E-05
     +,   1.1450280E-05,   1.1882747E-05,   1.2330001E-05
     +,   1.2796456E-05,   1.3287621E-05,   1.3810427E-05
     +,   1.4373293E-05,   1.4986426E-05,   1.5662003E-05
     +,   1.6414400E-05,   1.7260476E-05,   1.8219793E-05
     +,   1.9314723E-05,   2.0570777E-05,   2.2016678E-05
     +,   2.3684706E-05,   2.5610736E-05,   2.7834201E-05
     +,   3.0398342E-05,   3.3350178E-05,   3.6740359E-05
     +,   4.0623450E-05,   4.5057543E-05,   5.0103496E-05
     +,   5.5824770E-05,   6.2286352E-05,   6.9553149E-05
     +,   7.7689088E-05,   8.6754568E-05,   9.6803218E-05
     +,   1.0788046E-04,   1.2002035E-04,   1.3324567E-04
     +,   1.4756675E-04,   1.6298184E-04,   1.7948187E-04
     +,   1.9705524E-04,   2.1569361E-04,   2.3540203E-04
     +,   2.5620018E-04,   2.7813343E-04,   3.0126996E-04
     +,   3.2570484E-04,   3.5156059E-04,   3.7899005E-04
     +,   4.0818957E-04,   4.3941339E-04,   4.7299336E-04
     +,   5.0936057E-04,   5.4904760E-04,   5.9266819E-04
     +,   6.4083916E-04,   6.9407857E-04,   7.5264496E-04
     +,   8.1638526E-04,   8.8460505E-04,   9.5602887E-04
     +,   1.0288564E-03,   1.1009420E-03,   1.1700842E-03
     +,   1.2343527E-03,   1.2923798E-03,   1.3435539E-03
     +,   1.3880195E-03,   1.4264912E-03,   1.4599260E-03
     +,   1.4891688E-03,   1.5147710E-03,   1.5371457E-03
     +,   1.5571640E-03,   1.5770550E-03,   1.6012000E-03
     +,   1.6362697E-03,   1.6902317E-03,   1.7701689E-03
     +,   1.8796634E-03,   2.0169397E-03,   2.1751649E-03
     +,   2.3453336E-03,   2.5206676E-03,   2.7000278E-03
     +,   2.8875102E-03,   3.0872847E-03,   3.2962032E-03
     +,   3.4992921E-03,   3.6727649E-03,   3.7943276E-03
     +,   3.8548966E-03,   3.8640467E-03,   3.8454193E-03
     +,   3.8248145E-03,   3.8177790E-03,   3.8229234E-03
     +,   3.8238366E-03,   3.7987770E-03,   3.7342799E-03
     +,   3.6364489E-03,   3.5332618E-03,   3.4648015E-03
     +,   3.4649724E-03,   3.5438919E-03,   3.6806087E-03
     +,   3.8300555E-03,   3.9401650E-03,   3.9698356E-03
     +,   3.8994104E-03,   3.7307378E-03,   3.4801790E-03
     +,   3.1705154E-03,   2.8255803E-03,   2.4681271E-03
     +,   2.1184159E-03,   1.7924802E-03,   1.5003473E-03
     +,   1.2454636E-03,   1.0260839E-03,   8.3771738E-04
     +,   6.7565986E-04,   5.3639774E-04,   4.1783802E-04
     +,   3.1874701E-04,   2.3797526E-04,   1.7400709E-04
     +,   1.2480828E-04,   8.7995853E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_nwao_fus_107 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_nwao_fus_110(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  2.4234498E-17,   3.2866599E-17
     +,   4.4497188E-17,   6.0139961E-17,   8.1142309E-17
     +,   1.0929205E-16,   1.4695413E-16,   1.9725529E-16
     +,   2.6432198E-16,   3.5358186E-16,   4.7217386E-16
     +,   6.2945919E-16,   8.3770314E-16,   1.1129221E-15
     +,   1.4760254E-15,   1.9542488E-15,   2.5829615E-15
     +,   3.4080856E-15,   4.4890993E-15,   5.9028468E-15
     +,   7.7484821E-15,   1.0153824E-14,   1.3282951E-14
     +,   1.7346586E-14,   2.2614677E-14,   2.9431878E-14
     +,   3.8238503E-14,   4.9595321E-14,   6.4214300E-14
     +,   8.3000000E-14,   1.0709780E-13,   1.3795451E-13
     +,   1.7739674E-13,   2.2772547E-13,   2.9183031E-13
     +,   3.7333922E-13,   4.7679639E-13,   6.0787627E-13
     +,   7.7366314E-13,   9.8297455E-13,   1.2467794E-12
     +,   1.5786642E-12,   1.9954661E-12,   2.5179821E-12
     +,   3.1718885E-12,   3.9887425E-12,   5.0073765E-12
     +,   6.2753288E-12,   7.8508675E-12,   9.8051359E-12
     +,   1.2224915E-11,   1.5215631E-11,   1.8905539E-11
     +,   2.3450100E-11,   2.9037066E-11,   3.5893417E-11
     +,   4.4292923E-11,   5.4563902E-11,   6.7101373E-11
     +,   8.2378514E-11,   1.0095991E-10,   1.2352008E-10
     +,   1.5086317E-10,   1.8394250E-10,   2.2388995E-10
     +,   2.7204686E-10,   3.2999373E-10,   3.9959658E-10
     +,   4.8305254E-10,   5.8293409E-10,   7.0226314E-10
     +,   8.4456675E-10,   1.0139681E-09,   1.2152566E-09
     +,   1.4540099E-09,   1.7366746E-09,   2.0707469E-09
     +,   2.4648485E-09,   2.9289013E-09,   3.4743821E-09
     +,   4.1143791E-09,   4.8638849E-09,   5.7401044E-09
     +,   6.7625567E-09,   7.9534255E-09,   9.3380317E-09
     +,   1.0944810E-08,   1.2806163E-08,   1.4958394E-08
     +,   1.7442387E-08,   2.0303920E-08,   2.3594543E-08
     +,   2.7371499E-08,   3.1698544E-08,   3.6646984E-08
     +,   4.2295415E-08,   4.8730648E-08,   5.6049274E-08
     +,   6.4356549E-08,   7.3769144E-08,   8.4413990E-08
     +,   9.6430050E-08,   1.0996802E-07,   1.2519344E-07
     +,   1.4228354E-07,   1.6143217E-07,   1.8284652E-07
     +,   2.0674976E-07,   2.3338028E-07,   2.6299605E-07
     +,   2.9586761E-07,   3.3228741E-07,   3.7256157E-07
     +,   4.1701480E-07,   4.6598700E-07,   5.1984114E-07
     +,   5.7894948E-07,   6.4370869E-07,   7.1452536E-07
     +,   7.9181933E-07,   8.7603462E-07,   9.6761573E-07
     +,   1.0670325E-06,   1.1747554E-06,   1.2912682E-06
     +,   1.4170565E-06,   1.5526273E-06,   1.6984787E-06
     +,   1.8551094E-06,   2.0230377E-06,   2.2027625E-06
     +,   2.3947816E-06,   2.5996076E-06,   2.8177183E-06
     +,   3.0496169E-06,   3.2957728E-06,   3.5566520E-06
     +,   3.8326984E-06,   4.1243757E-06,   4.4320896E-06
     +,   4.7562735E-06,   5.0973126E-06,   5.4555676E-06
     +,   5.8314254E-06,   6.2252107E-06,   6.6372222E-06
     +,   7.0677825E-06,   7.5171479E-06,   7.9855363E-06
     +,   8.4731973E-06,   8.9802998E-06,   9.5069690E-06
     +,   1.0053363E-05,   1.0619543E-05,   1.1205556E-05
     +,   1.1811391E-05,   1.2437069E-05,   1.3082496E-05
     +,   1.3747653E-05,   1.4432435E-05,   1.5136774E-05
     +,   1.5860591E-05,   1.6603930E-05,   1.7366925E-05
     +,   1.8149791E-05,   1.8952967E-05,   1.9777157E-05
     +,   2.0623369E-05,   2.1493111E-05,   2.2388445E-05
     +,   2.3312006E-05,   2.4267270E-05,   2.5258578E-05
     +,   2.6291442E-05,   2.7372578E-05,   2.8510016E-05
     +,   2.9713301E-05,   3.0993633E-05,   3.2363885E-05
     +,   3.3838915E-05,   3.5435169E-05,   3.7171194E-05
     +,   3.9067098E-05,   4.1144674E-05,   4.3427139E-05
     +,   4.5938759E-05,   4.8704766E-05,   5.1750787E-05
     +,   5.5102086E-05,   5.8783284E-05,   6.2817475E-05
     +,   6.7225963E-05,   7.2027324E-05,   7.7236116E-05
     +,   8.2862702E-05,   8.8912187E-05,   9.5383366E-05
     +,   1.0226861E-04,   1.0955275E-04,   1.1721158E-04
     +,   1.2521210E-04,   1.3351160E-04,   1.4205705E-04
     +,   1.5078593E-04,   1.5962585E-04,   1.6849460E-04
     +,   1.7730288E-04,   1.8595594E-04,   1.9435854E-04
     +,   2.0241919E-04,   2.1005672E-04,   2.1720992E-04
     +,   2.2384746E-04,   2.2997965E-04,   2.3567153E-04
     +,   2.4105300E-04,   2.4632999E-04,   2.5178803E-04
     +,   2.5779204E-04,   2.6477652E-04,   2.7322641E-04
     +,   2.8364972E-04,   2.9654123E-04,   3.1234039E-04
     +,   3.3139187E-04,   3.5390802E-04,   3.7994774E-04
     +,   4.0939983E-04,   4.4199900E-04,   4.7734380E-04
     +,   5.1494461E-04,   5.5427605E-04,   5.9484883E-04
     +,   6.3627743E-04,   6.7835127E-04,   7.2111102E-04
     +,   7.6491322E-04,   8.1048027E-04,   8.5893122E-04
     +,   9.1175718E-04,   9.7072887E-04,   1.0377305E-03
     +,   1.1145029E-03,   1.2023565E-03,   1.3018729E-03
     +,   1.4127197E-03,   1.5336019E-03,   1.6622812E-03
     +,   1.7956599E-03,   1.9298157E-03,   2.0599640E-03
     +,   2.1805905E-03,   2.2858360E-03,   2.3703570E-03
     +,   2.4304444E-03,   2.4650260E-03,   2.4761017E-03
     +,   2.4683811E-03,   2.4483865E-03,   2.4235458E-03
     +,   2.4016998E-03,   2.3909148E-03,   2.3990648E-03
     +,   2.4326912E-03,   2.4953382E-03,   2.5862800E-03
     +,   2.7004834E-03,   2.8298011E-03,   2.9643807E-03
     +,   3.0934396E-03,   3.2055208E-03,   3.2892358E-03
     +,   3.3350850E-03,   3.3376219E-03,   3.2963867E-03
     +,   3.2148773E-03,   3.0983824E-03,   2.9523729E-03
     +,   2.7823667E-03,   2.5946328E-03,   2.3965114E-03
     +,   2.1955103E-03,   1.9978897E-03,   1.8076152E-03
     +,   1.6264126E-03,   1.4545978E-03,   1.2921724E-03
     +,   1.1393377E-03,   9.9654589E-04,   8.6424942E-04
     +,   7.4265356E-04,   6.3170318E-04,   5.3114974E-04
     +,   4.4072984E-04,   3.6023630E-04,   2.8952083E-04
     +,   2.2842502E-04,   1.7666580E-04,   1.3378912E-04
     +,   9.9121920E-05,   7.1799404E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_nwao_fus_110 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_nwao_fus_115(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  1.1744616E-20,   1.7115454E-20
     +,   2.4891729E-20,   3.6127003E-20,   5.2326408E-20
     +,   7.5635411E-20,   1.0910462E-19,   1.5706212E-19
     +,   2.2563988E-19,   3.2349731E-19,   4.6284793E-19
     +,   6.6087414E-19,   9.4170790E-19,   1.3391313E-18
     +,   1.9003910E-18,   2.6914091E-18,   3.8038806E-18
     +,   5.3651807E-18,   7.5519878E-18,   1.0608308E-17
     +,   1.4871152E-17,   2.0804592E-17,   2.9045858E-17
     +,   4.0468958E-17,   5.6269881E-17,   7.8079934E-17
     +,   1.0812264E-16,   1.4942011E-16,   2.0606901E-16
     +,   2.8361501E-16,   3.8954804E-16,   5.3395311E-16
     +,   7.3039704E-16,   9.9707838E-16,   1.3583498E-15
     +,   1.8467406E-15,   2.5056221E-15,   3.3926295E-15
     +,   4.5842774E-15,   6.1818353E-15,   8.3191714E-15
     +,   1.1172591E-14,   1.4974038E-14,   2.0028038E-14
     +,   2.6733393E-14,   3.5610600E-14,   4.7339072E-14
     +,   6.2801699E-14,   8.3144964E-14,   1.0985334E-13
     +,   1.4484582E-13,   1.9059424E-13,   2.5028018E-13
     +,   3.2798902E-13,   4.2894505E-13,   5.5983305E-13
     +,   7.2917182E-13,   9.4778872E-13,   1.2294388E-12
     +,   1.5915401E-12,   2.0560754E-12,   2.6507752E-12
     +,   3.4105381E-12,   4.3790887E-12,   5.6112151E-12
     +,   7.1754022E-12,   9.1568472E-12,   1.1661621E-11
     +,   1.4821314E-11,   1.8798614E-11,   2.3794560E-11
     +,   3.0056808E-11,   3.7889882E-11,   4.7666676E-11
     +,   5.9844053E-11,   7.4978482E-11,   9.3749480E-11
     +,   1.1698072E-10,   1.4566971E-10,   1.8102578E-10
     +,   2.2450480E-10,   2.7785588E-10,   3.4318670E-10
     +,   4.2301340E-10,   5.2034010E-10,   6.3875927E-10
     +,   7.8252194E-10,   9.5669261E-10,   1.1672437E-09
     +,   1.4212286E-09,   1.7269346E-09,   2.0941315E-09
     +,   2.5342255E-09,   3.0605292E-09,   3.6886172E-09
     +,   4.4365391E-09,   5.3251821E-09,   6.3788343E-09
     +,   7.6253155E-09,   9.0968451E-09,   1.0830199E-08
     +,   1.2867539E-08,   1.5256841E-08,   1.8053013E-08
     +,   2.1317939E-08,   2.5122153E-08,   2.9544809E-08
     +,   3.4675217E-08,   4.0613248E-08,   4.7471403E-08
     +,   5.5374173E-08,   6.4461226E-08,   7.4886479E-08
     +,   8.6820393E-08,   1.0045036E-07,   1.1598391E-07
     +,   1.3364591E-07,   1.5368464E-07,   1.7636806E-07
     +,   2.0198642E-07,   2.3085656E-07,   2.6331531E-07
     +,   2.9972890E-07,   3.4048537E-07,   3.8599916E-07
     +,   4.3670846E-07,   4.9308215E-07,   5.5560832E-07
     +,   6.2479785E-07,   7.0119353E-07,   7.8535123E-07
     +,   8.7784622E-07,   9.7928307E-07,   1.0902679E-06
     +,   1.2114377E-06,   1.3434301E-06,   1.4868951E-06
     +,   1.6424864E-06,   1.8108805E-06,   1.9927334E-06
     +,   2.1887329E-06,   2.3995469E-06,   2.6258440E-06
     +,   2.8683253E-06,   3.1276695E-06,   3.4045643E-06
     +,   3.6997451E-06,   4.0139362E-06,   4.3478899E-06
     +,   4.7024400E-06,   5.0784324E-06,   5.4767811E-06
     +,   5.8985279E-06,   6.3447724E-06,   6.8167492E-06
     +,   7.3158176E-06,   7.8435496E-06,   8.4016292E-06
     +,   8.9920195E-06,   9.6168451E-06,   1.0278477E-05
     +,   1.0979509E-05,   1.1722836E-05,   1.2511608E-05
     +,   1.3349152E-05,   1.4239045E-05,   1.5185057E-05
     +,   1.6191067E-05,   1.7261133E-05,   1.8399356E-05
     +,   1.9609703E-05,   2.0896052E-05,   2.2261987E-05
     +,   2.3710840E-05,   2.5245485E-05,   2.6868045E-05
     +,   2.8579982E-05,   3.0381840E-05,   3.2273074E-05
     +,   3.4252196E-05,   3.6316127E-05,   3.8460705E-05
     +,   4.0680057E-05,   4.2966811E-05,   4.5312019E-05
     +,   4.7705060E-05,   5.0133927E-05,   5.2585132E-05
     +,   5.5043674E-05,   5.7493457E-05,   5.9917365E-05
     +,   6.2297840E-05,   6.4617008E-05,   6.6856948E-05
     +,   6.9000467E-05,   7.1031456E-05,   7.2935531E-05
     +,   7.4700823E-05,   7.6318531E-05,   7.7783559E-05
     +,   7.9095516E-05,   8.0259531E-05,   8.1287188E-05
     +,   8.2197723E-05,   8.3019302E-05,   8.3790626E-05
     +,   8.4563108E-05,   8.5403452E-05,   8.6396984E-05
     +,   8.7651519E-05,   8.9301553E-05,   9.1512928E-05
     +,   9.4486801E-05,   9.8461926E-05,   1.0371534E-04
     +,   1.1055693E-04,   1.1932166E-04,   1.3035187E-04
     +,   1.4397537E-04,   1.6047660E-04,   1.8006359E-04
     +,   2.0283823E-04,   2.2876934E-04,   2.5767667E-04
     +,   2.8923794E-04,   3.2301460E-04,   3.5851012E-04
     +,   3.9523435E-04,   4.3280137E-04,   4.7100519E-04
     +,   5.0989079E-04,   5.4978312E-04,   5.9127971E-04
     +,   6.3519640E-04,   6.8248750E-04,   7.3417148E-04
     +,   7.9126231E-04,   8.5471605E-04,   9.2538889E-04
     +,   1.0039663E-03,   1.0908740E-03,   1.1861915E-03
     +,   1.2895808E-03,   1.4002596E-03,   1.5169160E-03
     +,   1.6375841E-03,   1.7594273E-03,   1.8784942E-03
     +,   1.9897788E-03,   2.0877705E-03,   2.1674961E-03
     +,   2.2258784E-03,   2.2628235E-03,   2.2817131E-03
     +,   2.2891208E-03,   2.2939167E-03,   2.3058150E-03
     +,   2.3333274E-03,   2.3811823E-03,   2.4479283E-03
     +,   2.5250257E-03,   2.5986542E-03,   2.6542125E-03
     +,   2.6817864E-03,   2.6800230E-03,   2.6565404E-03
     +,   2.6247825E-03,   2.5991043E-03,   2.5904288E-03
     +,   2.6040492E-03,   2.6396830E-03,   2.6927276E-03
     +,   2.7554792E-03,   2.8178403E-03,   2.8678346E-03
     +,   2.8926823E-03,   2.8808294E-03,   2.8245416E-03
     +,   2.7221441E-03,   2.5787975E-03,   2.4053138E-03
     +,   2.2151924E-03,   2.0211081E-03,   1.8320549E-03
     +,   1.6522628E-03,   1.4818645E-03,   1.3189090E-03
     +,   1.1614002E-03,   1.0087452E-03,   8.6217816E-04
     +,   7.2427117E-04,   5.9806055E-04,   4.8610248E-04
     +,   3.8991266E-04,   3.0974791E-04,   2.4474718E-04
     +,   1.9325838E-04,   1.5319891E-04,   1.2240811E-04
     +,   9.8865145E-05,   8.0828308E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_nwao_fus_115 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_nwao_fus_120(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  1.2750657E-27,   2.1299801E-27
     +,   3.5489666E-27,   5.8979136E-27,   9.7762353E-27
     +,   1.6163171E-26,   2.6653447E-26,   4.3838452E-26
     +,   7.1917651E-26,   1.1767681E-25,   1.9205312E-25
     +,   3.1262733E-25,   5.0759329E-25,   8.2200287E-25
     +,   1.3277280E-24,   2.1390620E-24,   3.4372630E-24
     +,   5.5090354E-24,   8.8068392E-24,   1.4042240E-23
     +,   2.2332010E-23,   3.5424272E-23,   5.6046157E-23
     +,   8.8443822E-23,   1.3920910E-22,   2.1854514E-22
     +,   3.4220640E-22,   5.3446606E-22,   8.3256971E-22
     +,   1.2935937E-21,   2.0047267E-21,   3.0987456E-21
     +,   4.7774204E-21,   7.3464810E-21,   1.1267790E-20
     +,   1.7237455E-20,   2.6301938E-20,   4.0029086E-20
     +,   6.0762937E-20,   9.1998052E-20,   1.3893027E-19
     +,   2.0926192E-19,   3.1438212E-19,   4.7108903E-19
     +,   7.0408750E-19,   1.0495977E-18,   1.5606300E-18
     +,   2.3144557E-18,   3.4235333E-18,   5.0509762E-18
     +,   7.4328779E-18,   1.0909640E-17,   1.5971314E-17
     +,   2.3321201E-17,   3.3965108E-17,   4.9339070E-17
     +,   7.1487318E-17,   1.0330956E-16,   1.4891140E-16
     +,   2.1408870E-16,   3.0699624E-16,   4.3908555E-16
     +,   6.2638828E-16,   8.9127443E-16,   1.2648997E-15
     +,   1.7905201E-15,   2.5279919E-15,   3.5599846E-15
     +,   5.0003527E-15,   7.0052839E-15,   9.7887405E-15
     +,   1.3642834E-14,   1.8965347E-14,   2.6296048E-14
     +,   3.6366319E-14,   5.0162504E-14,   6.9014435E-14
     +,   9.4705819E-14,   1.2962415E-13,   1.7695975E-13
     +,   2.4095759E-13,   3.2724851E-13,   4.4329788E-13
     +,   5.9894863E-13,   8.0715035E-13,   1.0849284E-12
     +,   1.4545191E-12,   1.9449921E-12,   2.5941356E-12
     +,   3.4509940E-12,   4.5789540E-12,   6.0599646E-12
     +,   7.9992523E-12,   1.0531759E-11,   1.3830329E-11
     +,   1.8115105E-11,   2.3665745E-11,   3.0837617E-11
     +,   4.0078628E-11,   5.1954802E-11,   6.7176056E-11
     +,   8.6632188E-11,   1.1143361E-10,   1.4296642E-10
     +,   1.8294614E-10,   2.3350327E-10,   2.9726147E-10
     +,   3.7745099E-10,   4.7802956E-10,   6.0384986E-10
     +,   7.6080864E-10,   9.5609687E-10,   1.1984082E-09
     +,   1.4982475E-09,   1.8682516E-09,   2.3236268E-09
     +,   2.8825049E-09,   3.5665948E-09,   4.4016293E-09
     +,   5.4180838E-09,   6.6520895E-09,   8.1459657E-09
     +,   9.9496313E-09,   1.2121248E-08,   1.4728686E-08
     +,   1.7850628E-08,   2.1578570E-08,   2.6017629E-08
     +,   3.1288579E-08,   3.7530420E-08,   4.4901089E-08
     +,   5.3580141E-08,   6.3771964E-08,   7.5705763E-08
     +,   8.9641105E-08,   1.0586724E-07,   1.2470736E-07
     +,   1.4651970E-07,   1.7170342E-07,   2.0069446E-07
     +,   2.3397554E-07,   2.7207085E-07,   3.1554907E-07
     +,   3.6503184E-07,   4.2118276E-07,   4.8471242E-07
     +,   5.5638634E-07,   6.3700799E-07,   7.2742318E-07
     +,   8.2852949E-07,   9.4124982E-07,   1.0665376E-06
     +,   1.2053849E-06,   1.3587879E-06,   1.5277566E-06
     +,   1.7132912E-06,   1.9164031E-06,   2.1380492E-06
     +,   2.3791806E-06,   2.6406742E-06,   2.9233452E-06
     +,   3.2279170E-06,   3.5550370E-06,   3.9052434E-06
     +,   4.2789175E-06,   4.6763107E-06,   5.0975186E-06
     +,   5.5424484E-06,   6.0108655E-06,   6.5023569E-06
     +,   7.0162905E-06,   7.5518669E-06,   8.1080952E-06
     +,   8.6838709E-06,   9.2779528E-06,   9.8889541E-06
     +,   1.0515436E-05,   1.1155946E-05,   1.1809030E-05
     +,   1.2473414E-05,   1.3147887E-05,   1.3831585E-05
     +,   1.4523892E-05,   1.5224630E-05,   1.5934123E-05
     +,   1.6653243E-05,   1.7383574E-05,   1.8127446E-05
     +,   1.8887911E-05,   1.9668902E-05,   2.0475209E-05
     +,   2.1312600E-05,   2.2187789E-05,   2.3108405E-05
     +,   2.4083114E-05,   2.5121630E-05,   2.6234758E-05
     +,   2.7434626E-05,   2.8734750E-05,   3.0150180E-05
     +,   3.1697859E-05,   3.3397009E-05,   3.5269473E-05
     +,   3.7340567E-05,   3.9639734E-05,   4.2201387E-05
     +,   4.5066470E-05,   4.8283924E-05,   5.1913274E-05
     +,   5.6027009E-05,   6.0713352E-05,   6.6080058E-05
     +,   7.2257586E-05,   7.9401405E-05,   8.7694498E-05
     +,   9.7344004E-05,   1.0857907E-04,   1.2163871E-04
     +,   1.3675817E-04,   1.5414780E-04,   1.7396633E-04
     +,   1.9629425E-04,   2.2110458E-04,   2.4823713E-04
     +,   2.7738986E-04,   3.0812382E-04,   3.3990131E-04
     +,   3.7214241E-04,   4.0433384E-04,   4.3614712E-04
     +,   4.6758421E-04,   4.9909955E-04,   5.3167186E-04
     +,   5.6677224E-04,   6.0619810E-04,   6.5177679E-04
     +,   7.0496800E-04,   7.6646381E-04,   8.3591795E-04
     +,   9.1189047E-04,   9.9203479E-04,   1.0734495E-03
     +,   1.1529730E-03,   1.2272983E-03,   1.2928743E-03
     +,   1.3459522E-03,   1.3831590E-03,   1.4028271E-03
     +,   1.4068065E-03,   1.4018423E-03,   1.3995165E-03
     +,   1.4143824E-03,   1.4609154E-03,   1.5504685E-03
     +,   1.6889010E-03,   1.8746170E-03,   2.0968749E-03
     +,   2.3357139E-03,   2.5660389E-03,   2.7663107E-03
     +,   2.9272526E-03,   3.0534966E-03,   3.1554697E-03
     +,   3.2373900E-03,   3.2914318E-03,   3.3027425E-03
     +,   3.2603634E-03,   3.1650951E-03,   3.0296284E-03
     +,   2.8731595E-03,   2.7151217E-03,   2.5707849E-03
     +,   2.4486568E-03,   2.3491189E-03,   2.2646126E-03
     +,   2.1819833E-03,   2.0867996E-03,   1.9683142E-03
     +,   1.8231670E-03,   1.6563635E-03,   1.4793477E-03
     +,   1.3059403E-03,   1.1480132E-03,   1.0123936E-03
     +,   9.0001093E-04,   8.0706197E-04,   7.2740793E-04
     +,   6.5491459E-04,   5.8508781E-04,   5.1570009E-04
     +,   4.4657561E-04,   3.7894471E-04,   3.1465094E-04
     +,   2.5552532E-04,   2.0296182E-04,   1.5773885E-04
     +,   1.2002110E-04,   8.9457455E-05,   6.5354783E-05
     +,   4.6823101E-05,   3.2910655E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_nwao_fus_120 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_nwao_fus_60(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  8.5908150E-06,   9.3389781E-06
     +,   1.0137650E-05,   1.0988785E-05,   1.1894331E-05
     +,   1.2856180E-05,   1.3876083E-05,   1.4955766E-05
     +,   1.6096841E-05,   1.7300739E-05,   1.8568813E-05
     +,   1.9902242E-05,   2.1302067E-05,   2.2769060E-05
     +,   2.4303867E-05,   2.5906937E-05,   2.7578382E-05
     +,   2.9318177E-05,   3.1126012E-05,   3.3001230E-05
     +,   3.4942987E-05,   3.6950139E-05,   3.9021113E-05
     +,   4.1154173E-05,   4.3347212E-05,   4.5597706E-05
     +,   4.7902930E-05,   5.0259794E-05,   5.2664760E-05
     +,   5.5114084E-05,   5.7603705E-05,   6.0129092E-05
     +,   6.2685533E-05,   6.5268039E-05,   6.7871151E-05
     +,   7.0489310E-05,   7.3116709E-05,   7.5747135E-05
     +,   7.8374353E-05,   8.0991886E-05,   8.3593142E-05
     +,   8.6171298E-05,   8.8719578E-05,   9.1231173E-05
     +,   9.3699229E-05,   9.6116899E-05,   9.8477562E-05
     +,   1.0077456E-04,   1.0300153E-04,   1.0515237E-04
     +,   1.0722125E-04,   1.0920259E-04,   1.1109129E-04
     +,   1.1288268E-04,   1.1457247E-04,   1.1615705E-04
     +,   1.1763329E-04,   1.1899869E-04,   1.2025135E-04
     +,   1.2139019E-04,   1.2241467E-04,   1.2332511E-04
     +,   1.2412251E-04,   1.2480860E-04,   1.2538598E-04
     +,   1.2585791E-04,   1.2622839E-04,   1.2650223E-04
     +,   1.2668486E-04,   1.2678240E-04,   1.2680155E-04
     +,   1.2674967E-04,   1.2663449E-04,   1.2646432E-04
     +,   1.2624776E-04,   1.2599368E-04,   1.2571123E-04
     +,   1.2540957E-04,   1.2509804E-04,   1.2478576E-04
     +,   1.2448175E-04,   1.2419479E-04,   1.2393323E-04
     +,   1.2370507E-04,   1.2351769E-04,   1.2337787E-04
     +,   1.2329174E-04,   1.2326463E-04,   1.2330101E-04
     +,   1.2340456E-04,   1.2357793E-04,   1.2382295E-04
     +,   1.2414035E-04,   1.2452998E-04,   1.2499069E-04
     +,   1.2552037E-04,   1.2611605E-04,   1.2677380E-04
     +,   1.2748888E-04,   1.2825587E-04,   1.2906859E-04
     +,   1.2992027E-04,   1.3080354E-04,   1.3171075E-04
     +,   1.3263381E-04,   1.3356446E-04,   1.3449424E-04
     +,   1.3541464E-04,   1.3631728E-04,   1.3719391E-04
     +,   1.3803648E-04,   1.3883738E-04,   1.3958925E-04
     +,   1.4028531E-04,   1.4091923E-04,   1.4148529E-04
     +,   1.4197844E-04,   1.4239416E-04,   1.4272869E-04
     +,   1.4297890E-04,   1.4314232E-04,   1.4321717E-04
     +,   1.4320233E-04,   1.4309720E-04,   1.4290195E-04
     +,   1.4261715E-04,   1.4224394E-04,   1.4178389E-04
     +,   1.4123911E-04,   1.4061193E-04,   1.3990505E-04
     +,   1.3912156E-04,   1.3826463E-04,   1.3733772E-04
     +,   1.3634434E-04,   1.3528822E-04,   1.3417308E-04
     +,   1.3300283E-04,   1.3178118E-04,   1.3051210E-04
     +,   1.2919932E-04,   1.2784677E-04,   1.2645822E-04
     +,   1.2503743E-04,   1.2358822E-04,   1.2211438E-04
     +,   1.2061952E-04,   1.1910748E-04,   1.1758208E-04
     +,   1.1604695E-04,   1.1450598E-04,   1.1296305E-04
     +,   1.1142195E-04,   1.0988666E-04,   1.0836124E-04
     +,   1.0684979E-04,   1.0535635E-04,   1.0388525E-04
     +,   1.0244059E-04,   1.0102680E-04,   9.9648234E-05
     +,   9.8309327E-05,   9.7014388E-05,   9.5767828E-05
     +,   9.4574032E-05,   9.3437346E-05,   9.2362010E-05
     +,   9.1352202E-05,   9.0411973E-05,   8.9545065E-05
     +,   8.8755303E-05,   8.8046145E-05,   8.7420834E-05
     +,   8.6882297E-05,   8.6433225E-05,   8.6075917E-05
     +,   8.5812411E-05,   8.5644271E-05,   8.5572690E-05
     +,   8.5598425E-05,   8.5721724E-05,   8.5942476E-05
     +,   8.6259970E-05,   8.6673041E-05,   8.7179986E-05
     +,   8.7778571E-05,   8.8466033E-05,   8.9239125E-05
     +,   9.0093985E-05,   9.1026239E-05,   9.2030976E-05
     +,   9.3102790E-05,   9.4235897E-05,   9.5423842E-05
     +,   9.6659795E-05,   9.7936550E-05,   9.9246412E-05
     +,   1.0058147E-04,   1.0193347E-04,   1.0329386E-04
     +,   1.0465385E-04,   1.0600450E-04,   1.0733680E-04
     +,   1.0864169E-04,   1.0991019E-04,   1.1113323E-04
     +,   1.1230198E-04,   1.1340775E-04,   1.1444221E-04
     +,   1.1539732E-04,   1.1626534E-04,   1.1703903E-04
     +,   1.1771162E-04,   1.1827690E-04,   1.1872929E-04
     +,   1.1906377E-04,   1.1927602E-04,   1.1936247E-04
     +,   1.1932020E-04,   1.1914707E-04,   1.1884167E-04
     +,   1.1840343E-04,   1.1783245E-04,   1.1712965E-04
     +,   1.1629665E-04,   1.1533586E-04,   1.1425024E-04
     +,   1.1304360E-04,   1.1172015E-04,   1.1028488E-04
     +,   1.0874320E-04,   1.0710108E-04,   1.0536485E-04
     +,   1.0354110E-04,   1.0163692E-04,   9.9659541E-05
     +,   9.7616488E-05,   9.5515359E-05,   9.3363735E-05
     +,   9.1169146E-05,   8.8939334E-05,   8.6681765E-05
     +,   8.4403880E-05,   8.2112652E-05,   7.9815080E-05
     +,   7.7517871E-05,   7.5227152E-05,   7.2948984E-05
     +,   7.0689035E-05,   6.8452326E-05,   6.6243811E-05
     +,   6.4067688E-05,   6.1927982E-05,   5.9828180E-05
     +,   5.7771391E-05,   5.5760313E-05,   5.3797121E-05
     +,   5.1883566E-05,   5.0021179E-05,   4.8211037E-05
     +,   4.6453872E-05,   4.4750144E-05,   4.3099884E-05
     +,   4.1502859E-05,   3.9958686E-05,   3.8466711E-05
     +,   3.7026111E-05,   3.5635796E-05,   3.4294513E-05
     +,   3.3000997E-05,   3.1753825E-05,   3.0551495E-05
     +,   2.9392486E-05,   2.8275146E-05,   2.7197810E-05
     +,   2.6158898E-05,   2.5156789E-05,   2.4189896E-05
     +,   2.3256696E-05,   2.2355611E-05,   2.1485257E-05
     +,   2.0644176E-05,   1.9831079E-05,   1.9044714E-05
     +,   1.8283967E-05,   1.7547613E-05,   1.6834691E-05
     +,   1.6144255E-05,   1.5475431E-05,   1.4827439E-05
     +,   1.4199501E-05,   1.3590993E-05,   1.3001267E-05
     +,   1.2429796E-05,   1.1876083E-05,   1.1339684E-05
     +,   1.0820232E-05,   1.0317276E-05,   9.8305245E-06
     +,   9.3596746E-06,   8.9044397E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_nwao_fus_60 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_nwao_fus_65(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  1.8320409E-06,   2.0337513E-06
     +,   2.2542822E-06,   2.4949784E-06,   2.7572505E-06
     +,   3.0425647E-06,   3.3524163E-06,   3.6883655E-06
     +,   4.0520158E-06,   4.4449862E-06,   4.8689490E-06
     +,   5.3255981E-06,   5.8166570E-06,   6.3438351E-06
     +,   6.9088787E-06,   7.5135345E-06,   8.1595035E-06
     +,   8.8485085E-06,   9.5822497E-06,   1.0362344E-05
     +,   1.1190410E-05,   1.2068010E-05,   1.2996589E-05
     +,   1.3977578E-05,   1.5012308E-05,   1.6101967E-05
     +,   1.7247683E-05,   1.8450477E-05,   1.9711171E-05
     +,   2.1030510E-05,   2.2409098E-05,   2.3847302E-05
     +,   2.5345385E-05,   2.6903446E-05,   2.8521301E-05
     +,   3.0198657E-05,   3.1935007E-05,   3.3729546E-05
     +,   3.5581328E-05,   3.7489150E-05,   3.9451610E-05
     +,   4.1466945E-05,   4.3533229E-05,   4.5648285E-05
     +,   4.7809681E-05,   5.0014605E-05,   5.2260126E-05
     +,   5.4542885E-05,   5.6859379E-05,   5.9205766E-05
     +,   6.1577986E-05,   6.3971580E-05,   6.6381923E-05
     +,   6.8804147E-05,   7.1233007E-05,   7.3663105E-05
     +,   7.6088858E-05,   7.8504265E-05,   8.0903330E-05
     +,   8.3279803E-05,   8.5627202E-05,   8.7939014E-05
     +,   9.0208654E-05,   9.2429291E-05,   9.4594259E-05
     +,   9.6696866E-05,   9.8730350E-05,   1.0068823E-04
     +,   1.0256411E-04,   1.0435175E-04,   1.0604526E-04
     +,   1.0763908E-04,   1.0912801E-04,   1.1050726E-04
     +,   1.1177263E-04,   1.1292035E-04,   1.1394750E-04
     +,   1.1485164E-04,   1.1563110E-04,   1.1628510E-04
     +,   1.1681357E-04,   1.1721731E-04,   1.1749809E-04
     +,   1.1765846E-04,   1.1770198E-04,   1.1763310E-04
     +,   1.1745718E-04,   1.1718047E-04,   1.1681006E-04
     +,   1.1635386E-04,   1.1582059E-04,   1.1521954E-04
     +,   1.1456072E-04,   1.1385467E-04,   1.1311224E-04
     +,   1.1234471E-04,   1.1156355E-04,   1.1078023E-04
     +,   1.1000627E-04,   1.0925296E-04,   1.0853133E-04
     +,   1.0785196E-04,   1.0722494E-04,   1.0665953E-04
     +,   1.0616436E-04,   1.0574707E-04,   1.0541441E-04
     +,   1.0517194E-04,   1.0502426E-04,   1.0497464E-04
     +,   1.0502522E-04,   1.0517691E-04,   1.0542940E-04
     +,   1.0578120E-04,   1.0622964E-04,   1.0677100E-04
     +,   1.0740055E-04,   1.0811263E-04,   1.0890080E-04
     +,   1.0975783E-04,   1.1067613E-04,   1.1164749E-04
     +,   1.1266363E-04,   1.1371596E-04,   1.1479607E-04
     +,   1.1589559E-04,   1.1700662E-04,   1.1812153E-04
     +,   1.1923329E-04,   1.2033570E-04,   1.2142307E-04
     +,   1.2249075E-04,   1.2353489E-04,   1.2455255E-04
     +,   1.2554179E-04,   1.2650169E-04,   1.2743210E-04
     +,   1.2833386E-04,   1.2920881E-04,   1.3005928E-04
     +,   1.3088858E-04,   1.3170052E-04,   1.3249938E-04
     +,   1.3328993E-04,   1.3407721E-04,   1.3486641E-04
     +,   1.3566283E-04,   1.3647170E-04,   1.3729806E-04
     +,   1.3814677E-04,   1.3902225E-04,   1.3992845E-04
     +,   1.4086887E-04,   1.4184639E-04,   1.4286319E-04
     +,   1.4392074E-04,   1.4501982E-04,   1.4616035E-04
     +,   1.4734165E-04,   1.4856209E-04,   1.4981927E-04
     +,   1.5111004E-04,   1.5243056E-04,   1.5377630E-04
     +,   1.5514198E-04,   1.5652174E-04,   1.5790913E-04
     +,   1.5929717E-04,   1.6067852E-04,   1.6204547E-04
     +,   1.6338998E-04,   1.6470379E-04,   1.6597839E-04
     +,   1.6720551E-04,   1.6837681E-04,   1.6948393E-04
     +,   1.7051892E-04,   1.7147414E-04,   1.7234226E-04
     +,   1.7311657E-04,   1.7379089E-04,   1.7435977E-04
     +,   1.7481841E-04,   1.7516293E-04,   1.7539028E-04
     +,   1.7549819E-04,   1.7548565E-04,   1.7535237E-04
     +,   1.7509912E-04,   1.7472771E-04,   1.7424094E-04
     +,   1.7364240E-04,   1.7293665E-04,   1.7212915E-04
     +,   1.7122598E-04,   1.7023407E-04,   1.6916075E-04
     +,   1.6801400E-04,   1.6680191E-04,   1.6553313E-04
     +,   1.6421630E-04,   1.6286004E-04,   1.6147312E-04
     +,   1.6006379E-04,   1.5864016E-04,   1.5720993E-04
     +,   1.5578035E-04,   1.5435815E-04,   1.5294924E-04
     +,   1.5155898E-04,   1.5019202E-04,   1.4885224E-04
     +,   1.4754273E-04,   1.4626588E-04,   1.4502315E-04
     +,   1.4381544E-04,   1.4264278E-04,   1.4150461E-04
     +,   1.4039967E-04,   1.3932616E-04,   1.3828167E-04
     +,   1.3726334E-04,   1.3626780E-04,   1.3529143E-04
     +,   1.3433020E-04,   1.3337996E-04,   1.3243615E-04
     +,   1.3149429E-04,   1.3054967E-04,   1.2959764E-04
     +,   1.2863352E-04,   1.2765272E-04,   1.2665076E-04
     +,   1.2562325E-04,   1.2456607E-04,   1.2347529E-04
     +,   1.2234725E-04,   1.2117861E-04,   1.1996633E-04
     +,   1.1870760E-04,   1.1740012E-04,   1.1604195E-04
     +,   1.1463155E-04,   1.1316773E-04,   1.1164980E-04
     +,   1.1007756E-04,   1.0845104E-04,   1.0677091E-04
     +,   1.0503830E-04,   1.0325453E-04,   1.0142166E-04
     +,   9.9541801E-05,   9.7617754E-05,   9.5652525E-05
     +,   9.3649520E-05,   9.1612470E-05,   8.9545247E-05
     +,   8.7451976E-05,   8.5337066E-05,   8.3205086E-05
     +,   8.1060651E-05,   7.8908604E-05,   7.6753546E-05
     +,   7.4600146E-05,   7.2453164E-05,   7.0317161E-05
     +,   6.8196670E-05,   6.6095898E-05,   6.4018794E-05
     +,   6.1969316E-05,   5.9951046E-05,   5.7967292E-05
     +,   5.6021145E-05,   5.4115226E-05,   5.2251849E-05
     +,   5.0433158E-05,   4.8660873E-05,   4.6936406E-05
     +,   4.5260902E-05,   4.3635013E-05,   4.2059328E-05
     +,   4.0533916E-05,   3.9058756E-05,   3.7633516E-05
     +,   3.6257734E-05,   3.4930428E-05,   3.3650736E-05
     +,   3.2417542E-05,   3.1229571E-05,   3.0085490E-05
     +,   2.8983724E-05,   2.7922806E-05,   2.6901042E-05
     +,   2.5916834E-05,   2.4968529E-05,   2.4054461E-05
     +,   2.3173076E-05,   2.2322618E-05,   2.1501597E-05
     +,   2.0708509E-05,   1.9941901E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_nwao_fus_65 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_nwao_fus_70(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  1.3791345E-06,   1.4682970E-06
     +,   1.5619752E-06,   1.6603046E-06,   1.7634228E-06
     +,   1.8714671E-06,   1.9845663E-06,   2.1028520E-06
     +,   2.2264549E-06,   2.3554942E-06,   2.4900944E-06
     +,   2.6303735E-06,   2.7764477E-06,   2.9284238E-06
     +,   3.0864103E-06,   3.2505145E-06,   3.4208292E-06
     +,   3.5974538E-06,   3.7804846E-06,   3.9700026E-06
     +,   4.1660987E-06,   4.3688578E-06,   4.5783559E-06
     +,   4.7946723E-06,   5.0178924E-06,   5.2480814E-06
     +,   5.4853199E-06,   5.7296897E-06,   5.9812573E-06
     +,   6.2401050E-06,   6.5063182E-06,   6.7799697E-06
     +,   7.0611482E-06,   7.3499486E-06,   7.6464530E-06
     +,   7.9507618E-06,   8.2629804E-06,   8.5832062E-06
     +,   8.9115483E-06,   9.2481214E-06,   9.5930491E-06
     +,   9.9464360E-06,   1.0308402E-05,   1.0679074E-05
     +,   1.1058572E-05,   1.1447000E-05,   1.1844479E-05
     +,   1.2251093E-05,   1.2666939E-05,   1.3092097E-05
     +,   1.3526630E-05,   1.3970558E-05,   1.4423902E-05
     +,   1.4886653E-05,   1.5358741E-05,   1.5840085E-05
     +,   1.6330558E-05,   1.6829961E-05,   1.7338067E-05
     +,   1.7854592E-05,   1.8379160E-05,   1.8911351E-05
     +,   1.9450683E-05,   1.9996562E-05,   2.0548341E-05
     +,   2.1105299E-05,   2.1666592E-05,   2.2231321E-05
     +,   2.2798495E-05,   2.3367013E-05,   2.3935716E-05
     +,   2.4503341E-05,   2.5068563E-05,   2.5629945E-05
     +,   2.6186033E-05,   2.6735241E-05,   2.7276035E-05
     +,   2.7806747E-05,   2.8325725E-05,   2.8831349E-05
     +,   2.9321982E-05,   2.9796012E-05,   3.0251984E-05
     +,   3.0688476E-05,   3.1104235E-05,   3.1498254E-05
     +,   3.1869695E-05,   3.2218111E-05,   3.2543372E-05
     +,   3.2845812E-05,   3.3126304E-05,   3.3386361E-05
     +,   3.3628199E-05,   3.3854882E-05,   3.4070446E-05
     +,   3.4280005E-05,   3.4489869E-05,   3.4707762E-05
     +,   3.4942848E-05,   3.5205991E-05,   3.5509791E-05
     +,   3.5868768E-05,   3.6299458E-05,   3.6820533E-05
     +,   3.7452784E-05,   3.8219321E-05,   3.9145350E-05
     +,   4.0258274E-05,   4.1587475E-05,   4.3164320E-05
     +,   4.5021563E-05,   4.7193575E-05,   4.9715309E-05
     +,   5.2622279E-05,   5.5949666E-05,   5.9732312E-05
     +,   6.4002998E-05,   6.8792921E-05,   7.4129712E-05
     +,   8.0037054E-05,   8.6534586E-05,   9.3635375E-05
     +,   1.0134713E-04,   1.0966953E-04,   1.1859462E-04
     +,   1.2810562E-04,   1.3817793E-04,   1.4877654E-04
     +,   1.5985695E-04,   1.7136669E-04,   1.8324290E-04
     +,   1.9541387E-04,   2.0780149E-04,   2.2031865E-04
     +,   2.3287408E-04,   2.4537047E-04,   2.5770758E-04
     +,   2.6978305E-04,   2.8149609E-04,   2.9274539E-04
     +,   3.0343555E-04,   3.1347465E-04,   3.2277819E-04
     +,   3.3127118E-04,   3.3888797E-04,   3.4557396E-04
     +,   3.5128818E-04,   3.5600163E-04,   3.5969945E-04
     +,   3.6238084E-04,   3.6405833E-04,   3.6475790E-04
     +,   3.6451803E-04,   3.6338856E-04,   3.6142947E-04
     +,   3.5870948E-04,   3.5530369E-04,   3.5129293E-04
     +,   3.4676053E-04,   3.4179122E-04,   3.3646938E-04
     +,   3.3087673E-04,   3.2509098E-04,   3.1918418E-04
     +,   3.1322244E-04,   3.0726430E-04,   3.0136021E-04
     +,   2.9555304E-04,   2.8987692E-04,   2.8435804E-04
     +,   2.7901609E-04,   2.7386413E-04,   2.6890970E-04
     +,   2.6415562E-04,   2.5960139E-04,   2.5524475E-04
     +,   2.5108180E-04,   2.4710878E-04,   2.4332243E-04
     +,   2.3972023E-04,   2.3630192E-04,   2.3306867E-04
     +,   2.3002377E-04,   2.2717212E-04,   2.2451981E-04
     +,   2.2207390E-04,   2.1984125E-04,   2.1782822E-04
     +,   2.1603984E-04,   2.1447899E-04,   2.1314557E-04
     +,   2.1203613E-04,   2.1114321E-04,   2.1045509E-04
     +,   2.0995575E-04,   2.0962484E-04,   2.0943790E-04
     +,   2.0936692E-04,   2.0938090E-04,   2.0944663E-04
     +,   2.0952990E-04,   2.0959601E-04,   2.0961133E-04
     +,   2.0954413E-04,   2.0936580E-04,   2.0905168E-04
     +,   2.0858223E-04,   2.0794380E-04,   2.0712875E-04
     +,   2.0613649E-04,   2.0497345E-04,   2.0365292E-04
     +,   2.0219522E-04,   2.0062694E-04,   1.9898025E-04
     +,   1.9729267E-04,   1.9560536E-04,   1.9396257E-04
     +,   1.9241040E-04,   1.9099546E-04,   1.8976367E-04
     +,   1.8875896E-04,   1.8802214E-04,   1.8759011E-04
     +,   1.8749425E-04,   1.8776018E-04,   1.8840651E-04
     +,   1.8944476E-04,   1.9087875E-04,   1.9270444E-04
     +,   1.9490982E-04,   1.9747527E-04,   2.0037391E-04
     +,   2.0357195E-04,   2.0702921E-04,   2.1070002E-04
     +,   2.1453395E-04,   2.1847663E-04,   2.2247116E-04
     +,   2.2645875E-04,   2.3037939E-04,   2.3417325E-04
     +,   2.3778163E-04,   2.4114799E-04,   2.4421833E-04
     +,   2.4694222E-04,   2.4927384E-04,   2.5117205E-04
     +,   2.5260111E-04,   2.5353112E-04,   2.5393834E-04
     +,   2.5380534E-04,   2.5312084E-04,   2.5188024E-04
     +,   2.5008491E-04,   2.4774249E-04,   2.4486613E-04
     +,   2.4147432E-04,   2.3759081E-04,   2.3324344E-04
     +,   2.2846420E-04,   2.2328846E-04,   2.1775402E-04
     +,   2.1190061E-04,   2.0577005E-04,   1.9940473E-04
     +,   1.9284771E-04,   1.8614123E-04,   1.7932666E-04
     +,   1.7244479E-04,   1.6553439E-04,   1.5863222E-04
     +,   1.5177279E-04,   1.4498757E-04,   1.3830514E-04
     +,   1.3175164E-04,   1.2534985E-04,   1.1911948E-04
     +,   1.1307732E-04,   1.0723651E-04,   1.0160818E-04
     +,   9.6199801E-05,   9.1016882E-05,   8.6062319E-05
     +,   8.1337188E-05,   7.6839489E-05,   7.2566567E-05
     +,   6.8513909E-05,   6.4675733E-05,   6.1045335E-05
     +,   5.7614707E-05,   5.4375756E-05,   5.1319457E-05
     +,   4.8436828E-05,   4.5718614E-05,   4.3155578E-05
     +,   4.0738738E-05,   3.8458780E-05,   3.6307243E-05
     +,   3.4275818E-05,   3.2356576E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_nwao_fus_70 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_nwao_fus_75(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  3.0534675E-06,   3.2631710E-06
     +,   3.4843822E-06,   3.7175034E-06,   3.9629554E-06
     +,   4.2211545E-06,   4.4925027E-06,   4.7774115E-06
     +,   5.0762887E-06,   5.3895183E-06,   5.7174921E-06
     +,   6.0605898E-06,   6.4191836E-06,   6.7936139E-06
     +,   7.1842246E-06,   7.5913467E-06,   8.0152668E-06
     +,   8.4562762E-06,   8.9146442E-06,   9.3905865E-06
     +,   9.8843193E-06,   1.0396034E-05,   1.0925858E-05
     +,   1.1473911E-05,   1.2040288E-05,   1.2625000E-05
     +,   1.3228057E-05,   1.3849428E-05,   1.4488997E-05
     +,   1.5146636E-05,   1.5822174E-05,   1.6515334E-05
     +,   1.7225841E-05,   1.7953347E-05,   1.8697416E-05
     +,   1.9457580E-05,   2.0233327E-05,   2.1024014E-05
     +,   2.1828990E-05,   2.2647515E-05,   2.3478799E-05
     +,   2.4321929E-05,   2.5175977E-05,   2.6039921E-05
     +,   2.6912685E-05,   2.7793069E-05,   2.8679871E-05
     +,   2.9571758E-05,   3.0467363E-05,   3.1365245E-05
     +,   3.2263917E-05,   3.3161770E-05,   3.4057182E-05
     +,   3.4948494E-05,   3.5833917E-05,   3.6711677E-05
     +,   3.7579975E-05,   3.8436876E-05,   3.9280509E-05
     +,   4.0108956E-05,   4.0920240E-05,   4.1712407E-05
     +,   4.2483513E-05,   4.3231576E-05,   4.3954667E-05
     +,   4.4650897E-05,   4.5318346E-05,   4.5955207E-05
     +,   4.6559726E-05,   4.7130183E-05,   4.7664984E-05
     +,   4.8162612E-05,   4.8621696E-05,   4.9040937E-05
     +,   4.9419243E-05,   4.9755632E-05,   5.0049359E-05
     +,   5.0299819E-05,   5.0506620E-05,   5.0669663E-05
     +,   5.0789040E-05,   5.0865125E-05,   5.0898583E-05
     +,   5.0890372E-05,   5.0841794E-05,   5.0754454E-05
     +,   5.0630333E-05,   5.0471754E-05,   5.0281440E-05
     +,   5.0062481E-05,   4.9818373E-05,   4.9552968E-05
     +,   4.9270540E-05,   4.8975755E-05,   4.8673599E-05
     +,   4.8369446E-05,   4.8069014E-05,   4.7778271E-05
     +,   4.7503490E-05,   4.7251138E-05,   4.7027857E-05
     +,   4.6840403E-05,   4.6695590E-05,   4.6600184E-05
     +,   4.6560879E-05,   4.6584220E-05,   4.6676494E-05
     +,   4.6843677E-05,   4.7091358E-05,   4.7424695E-05
     +,   4.7848313E-05,   4.8366328E-05,   4.8982212E-05
     +,   4.9698883E-05,   5.0518578E-05,   5.1443069E-05
     +,   5.2473442E-05,   5.3610460E-05,   5.4854383E-05
     +,   5.6205154E-05,   5.7662746E-05,   5.9226888E-05
     +,   6.0897724E-05,   6.2675521E-05,   6.4561136E-05
     +,   6.6556015E-05,   6.8662666E-05,   7.0884373E-05
     +,   7.3225492E-05,   7.5691874E-05,   7.8290315E-05
     +,   8.1028833E-05,   8.3916973E-05,   8.6964923E-05
     +,   9.0184178E-05,   9.3586641E-05,   9.7184697E-05
     +,   1.0099060E-04,   1.0501678E-04,   1.0927428E-04
     +,   1.1377360E-04,   1.1852309E-04,   1.2352898E-04
     +,   1.2879552E-04,   1.3432337E-04,   1.4010989E-04
     +,   1.4614941E-04,   1.5243185E-04,   1.5894306E-04
     +,   1.6566558E-04,   1.7257735E-04,   1.7965262E-04
     +,   1.8686305E-04,   1.9417664E-04,   2.0155929E-04
     +,   2.0897511E-04,   2.1638819E-04,   2.2376174E-04
     +,   2.3106109E-04,   2.3825282E-04,   2.4530690E-04
     +,   2.5219715E-04,   2.5890273E-04,   2.6540871E-04
     +,   2.7170582E-04,   2.7779193E-04,   2.8367198E-04
     +,   2.8935750E-04,   2.9486697E-04,   3.0022487E-04
     +,   3.0546033E-04,   3.1060626E-04,   3.1569810E-04
     +,   3.2077209E-04,   3.2586383E-04,   3.3100558E-04
     +,   3.3622523E-04,   3.4154445E-04,   3.4697703E-04
     +,   3.5252818E-04,   3.5819237E-04,   3.6395426E-04
     +,   3.6978719E-04,   3.7565385E-04,   3.8150695E-04
     +,   3.8728988E-04,   3.9293873E-04,   3.9838284E-04
     +,   4.0354699E-04,   4.0835323E-04,   4.1272261E-04
     +,   4.1657788E-04,   4.1984464E-04,   4.2245263E-04
     +,   4.2433804E-04,   4.2544477E-04,   4.2572513E-04
     +,   4.2514093E-04,   4.2366420E-04,   4.2127774E-04
     +,   4.1797484E-04,   4.1376034E-04,   4.0864991E-04
     +,   4.0266998E-04,   3.9585706E-04,   3.8825846E-04
     +,   3.7993083E-04,   3.7093990E-04,   3.6135895E-04
     +,   3.5126810E-04,   3.4075454E-04,   3.2990973E-04
     +,   3.1882868E-04,   3.0760877E-04,   2.9634664E-04
     +,   2.8513945E-04,   2.7407997E-04,   2.6325777E-04
     +,   2.5275623E-04,   2.4265137E-04,   2.3301096E-04
     +,   2.2389249E-04,   2.1534291E-04,   2.0739890E-04
     +,   2.0008539E-04,   1.9341604E-04,   1.8739288E-04
     +,   1.8200798E-04,   1.7724271E-04,   1.7307009E-04
     +,   1.6945503E-04,   1.6635589E-04,   1.6372545E-04
     +,   1.6151252E-04,   1.5966361E-04,   1.5812373E-04
     +,   1.5683778E-04,   1.5575193E-04,   1.5481428E-04
     +,   1.5397590E-04,   1.5319155E-04,   1.5242033E-04
     +,   1.5162569E-04,   1.5077605E-04,   1.4984469E-04
     +,   1.4880981E-04,   1.4765414E-04,   1.4636494E-04
     +,   1.4493366E-04,   1.4335531E-04,   1.4162839E-04
     +,   1.3975403E-04,   1.3773597E-04,   1.3557998E-04
     +,   1.3329330E-04,   1.3088463E-04,   1.2836329E-04
     +,   1.2573919E-04,   1.2302282E-04,   1.2022476E-04
     +,   1.1735546E-04,   1.1442538E-04,   1.1144453E-04
     +,   1.0842252E-04,   1.0536888E-04,   1.0229256E-04
     +,   9.9202305E-05,   9.6106131E-05,   9.3011695E-05
     +,   8.9926456E-05,   8.6857370E-05,   8.3811035E-05
     +,   8.0793732E-05,   7.7811186E-05,   7.4868665E-05
     +,   7.1971386E-05,   6.9123984E-05,   6.6330744E-05
     +,   6.3595638E-05,   6.0921931E-05,   5.8312853E-05
     +,   5.5770895E-05,   5.3298339E-05,   5.0897037E-05
     +,   4.8568570E-05,   4.6313598E-05,   4.4132961E-05
     +,   4.2026921E-05,   3.9995441E-05,   3.8038208E-05
     +,   3.6154404E-05,   3.4343251E-05,   3.2603442E-05
     +,   3.0933672E-05,   2.9332406E-05,   2.7797954E-05
     +,   2.6328618E-05,   2.4922283E-05,   2.3577100E-05
     +,   2.2291073E-05,   2.1062184E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_nwao_fus_75 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_nwao_fus_80(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  1.5412060E-06,   1.6216860E-06
     +,   1.7053726E-06,   1.7923289E-06,   1.8826178E-06
     +,   1.9763015E-06,   2.0734331E-06,   2.1740670E-06
     +,   2.2782556E-06,   2.3860398E-06,   2.4974636E-06
     +,   2.6125622E-06,   2.7313713E-06,   2.8539123E-06
     +,   2.9802084E-06,   3.1102770E-06,   3.2441237E-06
     +,   3.3817535E-06,   3.5231640E-06,   3.6683405E-06
     +,   3.8172675E-06,   3.9699216E-06,   4.1262647E-06
     +,   4.2862598E-06,   4.4498593E-06,   4.6170007E-06
     +,   4.7876215E-06,   4.9616497E-06,   5.1389948E-06
     +,   5.3195686E-06,   5.5032733E-06,   5.6899926E-06
     +,   5.8796090E-06,   6.0719967E-06,   6.2670129E-06
     +,   6.4645119E-06,   6.6643429E-06,   6.8663312E-06
     +,   7.0703095E-06,   7.2760909E-06,   7.4834929E-06
     +,   7.6923034E-06,   7.9023202E-06,   8.1133276E-06
     +,   8.3251061E-06,   8.5374159E-06,   8.7500284E-06
     +,   8.9626910E-06,   9.1751581E-06,   9.3871740E-06
     +,   9.5984806E-06,   9.8088040E-06,   1.0017879E-05
     +,   1.0225436E-05,   1.0431190E-05,   1.0634867E-05
     +,   1.0836188E-05,   1.1034866E-05,   1.1230618E-05
     +,   1.1423169E-05,   1.1612226E-05,   1.1797517E-05
     +,   1.1978764E-05,   1.2155682E-05,   1.2328008E-05
     +,   1.2495474E-05,   1.2657809E-05,   1.2814762E-05
     +,   1.2966083E-05,   1.3111521E-05,   1.3250844E-05
     +,   1.3383823E-05,   1.3510237E-05,   1.3629876E-05
     +,   1.3742543E-05,   1.3848039E-05,   1.3946196E-05
     +,   1.4036841E-05,   1.4119817E-05,   1.4194990E-05
     +,   1.4262227E-05,   1.4321408E-05,   1.4372440E-05
     +,   1.4415228E-05,   1.4449700E-05,   1.4475804E-05
     +,   1.4493492E-05,   1.4502742E-05,   1.4503539E-05
     +,   1.4495890E-05,   1.4479825E-05,   1.4455373E-05
     +,   1.4422603E-05,   1.4381591E-05,   1.4332434E-05
     +,   1.4275251E-05,   1.4210189E-05,   1.4137413E-05
     +,   1.4057119E-05,   1.3969529E-05,   1.3874904E-05
     +,   1.3773540E-05,   1.3665775E-05,   1.3551992E-05
     +,   1.3432637E-05,   1.3308209E-05,   1.3179287E-05
     +,   1.3046531E-05,   1.2910701E-05,   1.2772653E-05
     +,   1.2633392E-05,   1.2494036E-05,   1.2355892E-05
     +,   1.2220446E-05,   1.2089390E-05,   1.1964643E-05
     +,   1.1848401E-05,   1.1743135E-05,   1.1651641E-05
     +,   1.1577070E-05,   1.1522940E-05,   1.1493186E-05
     +,   1.1492177E-05,   1.1524741E-05,   1.1596194E-05
     +,   1.1712339E-05,   1.1879519E-05,   1.2104564E-05
     +,   1.2394819E-05,   1.2758164E-05,   1.3202914E-05
     +,   1.3737815E-05,   1.4372064E-05,   1.5115093E-05
     +,   1.5976693E-05,   1.6966722E-05,   1.8095121E-05
     +,   1.9371704E-05,   2.0806227E-05,   2.2407889E-05
     +,   2.4185621E-05,   2.6147505E-05,   2.8300743E-05
     +,   3.0651794E-05,   3.3205692E-05,   3.5966088E-05
     +,   3.8935472E-05,   4.2114352E-05,   4.5501460E-05
     +,   4.9094015E-05,   5.2886899E-05,   5.6872916E-05
     +,   6.1043298E-05,   6.5386703E-05,   6.9889946E-05
     +,   7.4537624E-05,   7.9312973E-05,   8.4196712E-05
     +,   8.9168665E-05,   9.4206574E-05,   9.9287099E-05
     +,   1.0438557E-04,   1.0947692E-04,   1.1453545E-04
     +,   1.1953466E-04,   1.2444828E-04,   1.2925017E-04
     +,   1.3391452E-04,   1.3841676E-04,   1.4273333E-04
     +,   1.4684175E-04,   1.5072148E-04,   1.5435385E-04
     +,   1.5772285E-04,   1.6081503E-04,   1.6361971E-04
     +,   1.6612947E-04,   1.6834037E-04,   1.7025208E-04
     +,   1.7186841E-04,   1.7319678E-04,   1.7424893E-04
     +,   1.7504055E-04,   1.7559147E-04,   1.7592529E-04
     +,   1.7606931E-04,   1.7605432E-04,   1.7591400E-04
     +,   1.7568462E-04,   1.7540446E-04,   1.7511346E-04
     +,   1.7485223E-04,   1.7466172E-04,   1.7458254E-04
     +,   1.7465425E-04,   1.7491491E-04,   1.7540033E-04
     +,   1.7614386E-04,   1.7717583E-04,   1.7852307E-04
     +,   1.8020906E-04,   1.8225322E-04,   1.8467118E-04
     +,   1.8747456E-04,   1.9067110E-04,   1.9426420E-04
     +,   1.9825305E-04,   2.0263265E-04,   2.0739391E-04
     +,   2.1252327E-04,   2.1800213E-04,   2.2380722E-04
     +,   2.2991007E-04,   2.3627657E-04,   2.4286771E-04
     +,   2.4963784E-04,   2.5653659E-04,   2.6350707E-04
     +,   2.7048765E-04,   2.7741180E-04,   2.8420889E-04
     +,   2.9080606E-04,   2.9712889E-04,   3.0310242E-04
     +,   3.0865375E-04,   3.1371336E-04,   3.1821788E-04
     +,   3.2211049E-04,   3.2534418E-04,   3.2788250E-04
     +,   3.2970076E-04,   3.3078762E-04,   3.3114516E-04
     +,   3.3078896E-04,   3.2974768E-04,   3.2806231E-04
     +,   3.2578452E-04,   3.2297522E-04,   3.1970211E-04
     +,   3.1603719E-04,   3.1205502E-04,   3.0782947E-04
     +,   3.0343179E-04,   2.9892748E-04,   2.9437550E-04
     +,   2.8982610E-04,   2.8531902E-04,   2.8088398E-04
     +,   2.7653977E-04,   2.7229398E-04,   2.6814459E-04
     +,   2.6408001E-04,   2.6008126E-04,   2.5612276E-04
     +,   2.5217453E-04,   2.4820364E-04,   2.4417590E-04
     +,   2.4005758E-04,   2.3581716E-04,   2.3142640E-04
     +,   2.2686130E-04,   2.2210342E-04,   2.1713952E-04
     +,   2.1196244E-04,   2.0657147E-04,   2.0097164E-04
     +,   1.9517365E-04,   1.8919275E-04,   1.8304866E-04
     +,   1.7676492E-04,   1.7036799E-04,   1.6388610E-04
     +,   1.5734915E-04,   1.5078705E-04,   1.4422946E-04
     +,   1.3770592E-04,   1.3124426E-04,   1.2487065E-04
     +,   1.1860939E-04,   1.1248157E-04,   1.0650681E-04
     +,   1.0070105E-04,   9.5078220E-05,   8.9649344E-05
     +,   8.4423278E-05,   7.9405108E-05,   7.4598946E-05
     +,   7.0006303E-05,   6.5626868E-05,   6.1458741E-05
     +,   5.7498142E-05,   5.3740729E-05,   5.0180559E-05
     +,   4.6811387E-05,   4.3626249E-05,   4.0617837E-05
     +,   3.7778806E-05,   3.5101111E-05,   3.2577416E-05
     +,   3.0200323E-05,   2.7962662E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_nwao_fus_80 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_nwao_fus_85(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  1.3823358E-06,   1.4558287E-06
     +,   1.5323105E-06,   1.6118405E-06,   1.6944807E-06
     +,   1.7802904E-06,   1.8693219E-06,   1.9616273E-06
     +,   2.0572581E-06,   2.1562544E-06,   2.2586587E-06
     +,   2.3645071E-06,   2.4738331E-06,   2.5866598E-06
     +,   2.7030108E-06,   2.8229051E-06,   2.9463467E-06
     +,   3.0733440E-06,   3.2038972E-06,   3.3379929E-06
     +,   3.4756183E-06,   3.6167546E-06,   3.7613675E-06
     +,   3.9094220E-06,   4.0608766E-06,   4.2156762E-06
     +,   4.3737618E-06,   4.5350694E-06,   4.6995169E-06
     +,   4.8670240E-06,   5.0375020E-06,   5.2108430E-06
     +,   5.3869439E-06,   5.5656910E-06,   5.7469510E-06
     +,   5.9305967E-06,   6.1164919E-06,   6.3044804E-06
     +,   6.4944115E-06,   6.6861226E-06,   6.8794493E-06
     +,   7.0742080E-06,   7.2702219E-06,   7.4673035E-06
     +,   7.6652632E-06,   7.8638986E-06,   8.0630143E-06
     +,   8.2624019E-06,   8.4618541E-06,   8.6611635E-06
     +,   8.8601237E-06,   9.0585154E-06,   9.2561295E-06
     +,   9.4527604E-06,   9.6481917E-06,   9.8422206E-06
     +,   1.0034649E-05,   1.0225270E-05,   1.0413894E-05
     +,   1.0600340E-05,   1.0784422E-05,   1.0965969E-05
     +,   1.1144825E-05,   1.1320833E-05,   1.1493856E-05
     +,   1.1663768E-05,   1.1830446E-05,   1.1993795E-05
     +,   1.2153730E-05,   1.2310177E-05,   1.2463081E-05
     +,   1.2612411E-05,   1.2758147E-05,   1.2900282E-05
     +,   1.3038844E-05,   1.3173862E-05,   1.3305405E-05
     +,   1.3433546E-05,   1.3558378E-05,   1.3680028E-05
     +,   1.3798635E-05,   1.3914353E-05,   1.4027369E-05
     +,   1.4137877E-05,   1.4246097E-05,   1.4352267E-05
     +,   1.4456637E-05,   1.4559488E-05,   1.4661104E-05
     +,   1.4761782E-05,   1.4861838E-05,   1.4961610E-05
     +,   1.5061431E-05,   1.5161645E-05,   1.5262618E-05
     +,   1.5364712E-05,   1.5468291E-05,   1.5573734E-05
     +,   1.5681409E-05,   1.5791698E-05,   1.5904970E-05
     +,   1.6021599E-05,   1.6141947E-05,   1.6266386E-05
     +,   1.6395263E-05,   1.6528944E-05,   1.6667762E-05
     +,   1.6812055E-05,   1.6962145E-05,   1.7118366E-05
     +,   1.7281014E-05,   1.7450413E-05,   1.7626853E-05
     +,   1.7810624E-05,   1.8002014E-05,   1.8201321E-05
     +,   1.8408815E-05,   1.8624798E-05,   1.8849549E-05
     +,   1.9083349E-05,   1.9326510E-05,   1.9579322E-05
     +,   1.9842104E-05,   2.0115182E-05,   2.0398871E-05
     +,   2.0693507E-05,   2.0999467E-05,   2.1317086E-05
     +,   2.1646731E-05,   2.1988786E-05,   2.2343622E-05
     +,   2.2711591E-05,   2.3093082E-05,   2.3488419E-05
     +,   2.3897959E-05,   2.4321995E-05,   2.4760786E-05
     +,   2.5214535E-05,   2.5683445E-05,   2.6167569E-05
     +,   2.6666976E-05,   2.7181573E-05,   2.7711187E-05
     +,   2.8255594E-05,   2.8814393E-05,   2.9387062E-05
     +,   2.9973033E-05,   3.0571540E-05,   3.1181695E-05
     +,   3.1802563E-05,   3.2433014E-05,   3.3071854E-05
     +,   3.3717854E-05,   3.4369677E-05,   3.5025969E-05
     +,   3.5685367E-05,   3.6346610E-05,   3.7008442E-05
     +,   3.7669834E-05,   3.8329872E-05,   3.8987921E-05
     +,   3.9643615E-05,   4.0297029E-05,   4.0948653E-05
     +,   4.1599447E-05,   4.2250966E-05,   4.2905409E-05
     +,   4.3565666E-05,   4.4235461E-05,   4.4919361E-05
     +,   4.5622786E-05,   4.6352168E-05,   4.7114943E-05
     +,   4.7919675E-05,   4.8776088E-05,   4.9695056E-05
     +,   5.0688675E-05,   5.1770348E-05,   5.2954707E-05
     +,   5.4257831E-05,   5.5696910E-05,   5.7290639E-05
     +,   5.9058737E-05,   6.1022118E-05,   6.3202686E-05
     +,   6.5623033E-05,   6.8306465E-05,   7.1276576E-05
     +,   7.4556527E-05,   7.8168967E-05,   8.2135113E-05
     +,   8.6474691E-05,   9.1204849E-05,   9.6339078E-05
     +,   1.0188683E-04,   1.0785255E-04,   1.1423462E-04
     +,   1.2102528E-04,   1.2820952E-04,   1.3576409E-04
     +,   1.4365769E-04,   1.5185107E-04,   1.6029642E-04
     +,   1.6893953E-04,   1.7771950E-04,   1.8656995E-04
     +,   1.9542144E-04,   2.0420311E-04,   2.1284599E-04
     +,   2.2128529E-04,   2.2946218E-04,   2.3732801E-04
     +,   2.4484645E-04,   2.5199572E-04,   2.5877144E-04
     +,   2.6518622E-04,   2.7127191E-04,   2.7707772E-04
     +,   2.8266927E-04,   2.8812629E-04,   2.9353853E-04
     +,   2.9900210E-04,   3.0461399E-04,   3.1046584E-04
     +,   3.1663867E-04,   3.2319679E-04,   3.3018348E-04
     +,   3.3761456E-04,   3.4547743E-04,   3.5372714E-04
     +,   3.6228693E-04,   3.7104942E-04,   3.7988080E-04
     +,   3.8862517E-04,   3.9711021E-04,   4.0515579E-04
     +,   4.1258274E-04,   4.1922071E-04,   4.2491878E-04
     +,   4.2955228E-04,   4.3303025E-04,   4.3530139E-04
     +,   4.3635824E-04,   4.3623857E-04,   4.3502444E-04
     +,   4.3284014E-04,   4.2984614E-04,   4.2623287E-04
     +,   4.2221122E-04,   4.1800246E-04,   4.1382873E-04
     +,   4.0990071E-04,   4.0640862E-04,   4.0351224E-04
     +,   4.0133361E-04,   3.9995089E-04,   3.9939498E-04
     +,   3.9964821E-04,   4.0064612E-04,   4.0227995E-04
     +,   4.0440282E-04,   4.0683668E-04,   4.0938091E-04
     +,   4.1182092E-04,   4.1393779E-04,   4.1551716E-04
     +,   4.1635736E-04,   4.1627712E-04,   4.1512129E-04
     +,   4.1276513E-04,   4.0911761E-04,   4.0412231E-04
     +,   3.9775815E-04,   3.9003696E-04,   3.8100148E-04
     +,   3.7072276E-04,   3.5929581E-04,   3.4683506E-04
     +,   3.3347096E-04,   3.1934323E-04,   3.0460034E-04
     +,   2.8939123E-04,   2.7386568E-04,   2.5816905E-04
     +,   2.4244071E-04,   2.2680784E-04,   2.1139024E-04
     +,   1.9629463E-04,   1.8161474E-04,   1.6743150E-04
     +,   1.5381072E-04,   1.4080704E-04,   1.2846033E-04
     +,   1.1680000E-04,   1.0584359E-04,   9.5598603E-05
     +,   8.6064210E-05,   7.7229532E-05,   6.9079215E-05
     +,   6.1591556E-05,   5.4740456E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_nwao_fus_85 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_nwao_fus_90(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  2.5846265E-07,   2.8391031E-07
     +,   3.1154721E-07,   3.4152691E-07,   3.7401341E-07
     +,   4.0917826E-07,   4.4719911E-07,   4.8826428E-07
     +,   5.3257054E-07,   5.8032009E-07,   6.3172649E-07
     +,   6.8701024E-07,   7.4640218E-07,   8.1013792E-07
     +,   8.7846411E-07,   9.5163659E-07,   1.0299145E-06
     +,   1.1135696E-06,   1.2028812E-06,   1.2981310E-06
     +,   1.3996132E-06,   1.5076296E-06,   1.6224823E-06
     +,   1.7444856E-06,   1.8739610E-06,   2.0112273E-06
     +,   2.1566163E-06,   2.3104653E-06,   2.4731078E-06
     +,   2.6448884E-06,   2.8261570E-06,   3.0172548E-06
     +,   3.2185367E-06,   3.4303594E-06,   3.6530669E-06
     +,   3.8870194E-06,   4.1325752E-06,   4.3900754E-06
     +,   4.6598766E-06,   4.9423265E-06,   5.2377754E-06
     +,   5.5465503E-06,   5.8689893E-06,   6.2054223E-06
     +,   6.5561721E-06,   6.9215348E-06,   7.3018246E-06
     +,   7.6973083E-06,   8.1082680E-06,   8.5349593E-06
     +,   8.9776267E-06,   9.4364741E-06,   9.9117033E-06
     +,   1.0403499E-05,   1.0911984E-05,   1.1437283E-05
     +,   1.1979496E-05,   1.2538645E-05,   1.3114754E-05
     +,   1.3707803E-05,   1.4317696E-05,   1.4944323E-05
     +,   1.5587522E-05,   1.6247042E-05,   1.6922613E-05
     +,   1.7613904E-05,   1.8320472E-05,   1.9041861E-05
     +,   1.9777532E-05,   2.0526837E-05,   2.1289094E-05
     +,   2.2063525E-05,   2.2849288E-05,   2.3645409E-05
     +,   2.4450896E-05,   2.5264588E-05,   2.6085349E-05
     +,   2.6911865E-05,   2.7742737E-05,   2.8576564E-05
     +,   2.9411784E-05,   3.0246743E-05,   3.1079810E-05
     +,   3.1909174E-05,   3.2732962E-05,   3.3549331E-05
     +,   3.4356268E-05,   3.5151792E-05,   3.5933830E-05
     +,   3.6700276E-05,   3.7448975E-05,   3.8177837E-05
     +,   3.8884682E-05,   3.9567331E-05,   4.0223698E-05
     +,   4.0851628E-05,   4.1449031E-05,   4.2013911E-05
     +,   4.2544252E-05,   4.3038188E-05,   4.3493877E-05
     +,   4.3909604E-05,   4.4283715E-05,   4.4614739E-05
     +,   4.4901295E-05,   4.5142166E-05,   4.5336248E-05
     +,   4.5482630E-05,   4.5580546E-05,   4.5629426E-05
     +,   4.5628884E-05,   4.5578705E-05,   4.5478882E-05
     +,   4.5329620E-05,   4.5131310E-05,   4.4884549E-05
     +,   4.4590175E-05,   4.4249187E-05,   4.3862845E-05
     +,   4.3432588E-05,   4.2960073E-05,   4.2447176E-05
     +,   4.1895921E-05,   4.1308591E-05,   4.0687650E-05
     +,   4.0035746E-05,   3.9355655E-05,   3.8650385E-05
     +,   3.7923110E-05,   3.7177080E-05,   3.6415760E-05
     +,   3.5642748E-05,   3.4861678E-05,   3.4076387E-05
     +,   3.3290700E-05,   3.2508611E-05,   3.1734133E-05
     +,   3.0971354E-05,   3.0224312E-05,   2.9497176E-05
     +,   2.8794011E-05,   2.8118966E-05,   2.7476139E-05
     +,   2.6869560E-05,   2.6303302E-05,   2.5781399E-05
     +,   2.5307811E-05,   2.4886549E-05,   2.4521634E-05
     +,   2.4217092E-05,   2.3977042E-05,   2.3805735E-05
     +,   2.3707578E-05,   2.3687226E-05,   2.3749630E-05
     +,   2.3900111E-05,   2.4144485E-05,   2.4489049E-05
     +,   2.4940782E-05,   2.5507297E-05,   2.6196958E-05
     +,   2.7018858E-05,   2.7982927E-05,   2.9099836E-05
     +,   3.0380852E-05,   3.1837772E-05,   3.3482738E-05
     +,   3.5327874E-05,   3.7385154E-05,   3.9665912E-05
     +,   4.2180149E-05,   4.4936212E-05,   4.7940022E-05
     +,   5.1194740E-05,   5.4699976E-05,   5.8450714E-05
     +,   6.2437182E-05,   6.6644090E-05,   7.1050061E-05
     +,   7.5627948E-05,   8.0343605E-05,   8.5157320E-05
     +,   9.0023030E-05,   9.4889620E-05,   9.9702003E-05
     +,   1.0440214E-04,   1.0893147E-04,   1.1323279E-04
     +,   1.1725230E-04,   1.2094330E-04,   1.2426914E-04
     +,   1.2720715E-04,   1.2975238E-04,   1.3192139E-04
     +,   1.3375687E-04,   1.3533173E-04,   1.3675303E-04
     +,   1.3816614E-04,   1.3975760E-04,   1.4175789E-04
     +,   1.4444295E-04,   1.4813458E-04,   1.5319834E-04
     +,   1.6004095E-04,   1.6910332E-04,   1.8085071E-04
     +,   1.9575995E-04,   2.1430085E-04,   2.3691675E-04
     +,   2.6399668E-04,   2.9584282E-04,   3.3263961E-04
     +,   3.7441801E-04,   4.2102116E-04,   4.7208345E-04
     +,   5.2699907E-04,   5.8493303E-04,   6.4481900E-04
     +,   7.0540037E-04,   7.6528377E-04,   8.2301034E-04
     +,   8.7715534E-04,   9.2642009E-04,   9.6972910E-04
     +,   1.0063233E-03,   1.0358202E-03,   1.0582526E-03
     +,   1.0740517E-03,   1.0840067E-03,   1.0891745E-03
     +,   1.0907649E-03,   1.0900059E-03,   1.0880076E-03
     +,   1.0856406E-03,   1.0834455E-03,   1.0815798E-03
     +,   1.0798177E-03,   1.0775920E-03,   1.0740828E-03
     +,   1.0683291E-03,   1.0593651E-03,   1.0463411E-03
     +,   1.0286381E-03,   1.0059391E-03,   9.7827113E-04
     +,   9.4600045E-04,   9.0978300E-04,   8.7050232E-04
     +,   8.2917104E-04,   7.8683236E-04,   7.4448285E-04
     +,   7.0298515E-04,   6.6303363E-04,   6.2512513E-04
     +,   5.8956072E-04,   5.5646995E-04,   5.2583910E-04
     +,   4.9755548E-04,   4.7144888E-04,   4.4732235E-04
     +,   4.2497914E-04,   4.0424100E-04,   3.8495311E-04
     +,   3.6698574E-04,   3.5023259E-04,   3.3460066E-04
     +,   3.2000450E-04,   3.0635830E-04,   2.9357307E-04
     +,   2.8155543E-04,   2.7020701E-04,   2.5942604E-04
     +,   2.4911159E-04,   2.3916591E-04,   2.2949858E-04
     +,   2.2003062E-04,   2.1069546E-04,   2.0144101E-04
     +,   1.9223054E-04,   1.8304121E-04,   1.7386572E-04
     +,   1.6470790E-04,   1.5558366E-04,   1.4651738E-04
     +,   1.3754073E-04,   1.2868791E-04,   1.1999773E-04
     +,   1.1150874E-04,   1.0325855E-04,   9.5282587E-05
     +,   8.7611821E-05,   8.0274011E-05,   7.3291005E-05
     +,   6.6680252E-05,   6.0453727E-05,   5.4618322E-05
     +,   4.9176535E-05,   4.4125140E-05,   3.9458293E-05
     +,   3.5166224E-05,   3.1236264E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_nwao_fus_90 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_nwao_fus_95(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  1.0250383E-11,   1.3197135E-11
     +,   1.6955491E-11,   2.1738498E-11,   2.7812466E-11
     +,   3.5509481E-11,   4.5241866E-11,   5.7521626E-11
     +,   7.2982599E-11,   9.2406506E-11,   1.1675741E-10
     +,   1.4721931E-10,   1.8524537E-10,   2.3261068E-10
     +,   2.9148392E-10,   3.6450640E-10,   4.5488172E-10
     +,   5.6649735E-10,   7.0405470E-10,   8.7321544E-10
     +,   1.0808013E-09,   1.3350037E-09,   1.6456178E-09
     +,   2.0243618E-09,   2.4852100E-09,   3.0447471E-09
     +,   3.7226757E-09,   4.5423194E-09,   5.5311569E-09
     +,   6.7216201E-09,   8.1517948E-09,   9.8662314E-09
     +,   1.1917130E-08,   1.4365336E-08,   1.7281517E-08
     +,   2.0747812E-08,   2.4859325E-08,   2.9725598E-08
     +,   3.5473047E-08,   4.2246782E-08,   5.0213234E-08
     +,   5.9562073E-08,   7.0509962E-08,   8.3303028E-08
     +,   9.8220660E-08,   1.1557764E-07,   1.3573056E-07
     +,   1.5907845E-07,   1.8607022E-07,   2.1720737E-07
     +,   2.5304982E-07,   2.9421770E-07,   3.4140078E-07
     +,   3.9536158E-07,   4.5693696E-07,   5.2704962E-07
     +,   6.0670993E-07,   6.9701616E-07,   7.9916765E-07
     +,   9.1446572E-07,   1.0443086E-06,   1.1902100E-06
     +,   1.3537928E-06,   1.5367825E-06,   1.7410266E-06
     +,   1.9684833E-06,   2.2212082E-06,   2.5013740E-06
     +,   2.8112577E-06,   3.1532106E-06,   3.5296894E-06
     +,   3.9432166E-06,   4.3963905E-06,   4.8918255E-06
     +,   5.4322099E-06,   6.0201837E-06,   6.6584616E-06
     +,   7.3496535E-06,   8.0963036E-06,   8.9009554E-06
     +,   9.7659504E-06,   1.0693469E-05,   1.1685623E-05
     +,   1.2744196E-05,   1.3870717E-05,   1.5066554E-05
     +,   1.6332573E-05,   1.7669478E-05,   1.9077432E-05
     +,   2.0556223E-05,   2.2105120E-05,   2.3723089E-05
     +,   2.5408412E-05,   2.7158832E-05,   2.8971745E-05
     +,   3.0843788E-05,   3.2771022E-05,   3.4749170E-05
     +,   3.6773083E-05,   3.8837377E-05,   4.0935902E-05
     +,   4.3062075E-05,   4.5208752E-05,   4.7368605E-05
     +,   4.9533588E-05,   5.1695650E-05,   5.3846194E-05
     +,   5.5976507E-05,   5.8077636E-05,   6.0140817E-05
     +,   6.2156934E-05,   6.4117310E-05,   6.6013155E-05
     +,   6.7836016E-05,   6.9577727E-05,   7.1230694E-05
     +,   7.2787538E-05,   7.4241696E-05,   7.5587079E-05
     +,   7.6818229E-05,   7.7930621E-05,   7.8920340E-05
     +,   7.9784426E-05,   8.0520680E-05,   8.1127859E-05
     +,   8.1605540E-05,   8.1954306E-05,   8.2175524E-05
     +,   8.2271479E-05,   8.2245322E-05,   8.2100996E-05
     +,   8.1843216E-05,   8.1477396E-05,   8.1009683E-05
     +,   8.0446735E-05,   7.9795820E-05,   7.9064659E-05
     +,   7.8261422E-05,   7.7394478E-05,   7.6472636E-05
     +,   7.5504715E-05,   7.4499840E-05,   7.3467156E-05
     +,   7.2415729E-05,   7.1354698E-05,   7.0293172E-05
     +,   6.9239977E-05,   6.8203946E-05,   6.7193738E-05
     +,   6.6217704E-05,   6.5284148E-05,   6.4401131E-05
     +,   6.3576415E-05,   6.2817693E-05,   6.2132356E-05
     +,   6.1527666E-05,   6.1010574E-05,   6.0587929E-05
     +,   6.0266269E-05,   6.0051963E-05,   5.9951060E-05
     +,   5.9969356E-05,   6.0112270E-05,   6.0384846E-05
     +,   6.0791703E-05,   6.1336876E-05,   6.2023850E-05
     +,   6.2855368E-05,   6.3833475E-05,   6.4959408E-05
     +,   6.6233391E-05,   6.7654750E-05,   6.9221729E-05
     +,   7.0931637E-05,   7.2780917E-05,   7.4764837E-05
     +,   7.6877994E-05,   7.9114347E-05,   8.1467377E-05
     +,   8.3930841E-05,   8.6498505E-05,   8.9165536E-05
     +,   9.1928392E-05,   9.4786134E-05,   9.7741169E-05
     +,   1.0080027E-04,   1.0397612E-04,   1.0728819E-04
     +,   1.1076387E-04,   1.1444007E-04,   1.1836398E-04
     +,   1.2259443E-04,   1.2720231E-04,   1.3227038E-04
     +,   1.3789350E-04,   1.4417795E-04,   1.5123961E-04
     +,   1.5920302E-04,   1.6819857E-04,   1.7835858E-04
     +,   1.8981431E-04,   2.0269130E-04,   2.1710340E-04
     +,   2.3314840E-04,   2.5090057E-04,   2.7040183E-04
     +,   2.9165600E-04,   3.1462085E-04,   3.3920427E-04
     +,   3.6526049E-04,   3.9258780E-04,   4.2093769E-04
     +,   4.5002811E-04,   4.7956489E-04,   5.0927966E-04
     +,   5.3896592E-04,   5.6854065E-04,   5.9809536E-04
     +,   6.2795554E-04,   6.5872277E-04,   6.9129310E-04
     +,   7.2683970E-04,   7.6674356E-04,   8.1246882E-04
     +,   8.6539926E-04,   9.2663552E-04,   9.9680689E-04
     +,   1.0758871E-03,   1.1631233E-03,   1.2570173E-03
     +,   1.3554471E-03,   1.4558707E-03,   1.5556125E-03
     +,   1.6521530E-03,   1.7433901E-03,   1.8278366E-03
     +,   1.9046934E-03,   1.9737778E-03,   2.0353338E-03
     +,   2.0897181E-03,   2.1370335E-03,   2.1767998E-03
     +,   2.2077211E-03,   2.2276624E-03,   2.2338454E-03
     +,   2.2233000E-03,   2.1934668E-03,   2.1428324E-03
     +,   2.0714530E-03,   1.9812032E-03,   1.8757314E-03
     +,   1.7600405E-03,   1.6398928E-03,   1.5210646E-03
     +,   1.4086870E-03,   1.3067510E-03,   1.2178347E-03
     +,   1.1430886E-03,   1.0823928E-03,   1.0346062E-03
     +,   9.9786359E-04,   9.6985023E-04,   9.4803318E-04
     +,   9.2985772E-04,   9.1290625E-04,   8.9503767E-04
     +,   8.7450421E-04,   8.5004233E-04,   8.2092284E-04
     +,   7.8695873E-04,   7.4845407E-04,   7.0611021E-04
     +,   6.6090660E-04,   6.1396201E-04,   5.6641037E-04
     +,   5.1930360E-04,   4.7353358E-04,   4.2979640E-04
     +,   3.8858459E-04,   3.5019484E-04,   3.1476715E-04
     +,   2.8230669E-04,   2.5272946E-04,   2.2588715E-04
     +,   2.0159710E-04,   1.7965389E-04,   1.5985564E-04
     +,   1.4200523E-04,   1.2591829E-04,   1.1142660E-04
     +,   9.8377182E-05,   8.6635540E-05,   7.6080796E-05
     +,   6.6606968E-05,   5.8119524E-05,   5.0533792E-05
     +,   4.3773660E-05,   3.7768041E-05,   3.2452648E-05
     +,   2.7766968E-05,   2.3654062E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_nwao_fus_95 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_nwao_hz_100(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  9.0295043E-07,   9.7330349E-07
     +,   1.0481522E-06,   1.1276938E-06,   1.2121318E-06
     +,   1.3016709E-06,   1.3965117E-06,   1.4968585E-06
     +,   1.6029160E-06,   1.7148800E-06,   1.8329499E-06
     +,   1.9573197E-06,   2.0881812E-06,   2.2257127E-06
     +,   2.3700932E-06,   2.5214943E-06,   2.6800701E-06
     +,   2.8459740E-06,   3.0193467E-06,   3.2003079E-06
     +,   3.3889737E-06,   3.5854443E-06,   3.7897955E-06
     +,   4.0020932E-06,   4.2223887E-06,   4.4506978E-06
     +,   4.6870318E-06,   4.9313780E-06,   5.1836873E-06
     +,   5.4439015E-06,   5.7119364E-06,   5.9876675E-06
     +,   6.2709596E-06,   6.5616496E-06,   6.8595309E-06
     +,   7.1643840E-06,   7.4759605E-06,   7.7939676E-06
     +,   8.1180970E-06,   8.4480089E-06,   8.7833369E-06
     +,   9.1236689E-06,   9.4685811E-06,   9.8176151E-06
     +,   1.0170294E-05,   1.0526091E-05,   1.0884480E-05
     +,   1.1244883E-05,   1.1606720E-05,   1.1969381E-05
     +,   1.2332242E-05,   1.2694637E-05,   1.3055905E-05
     +,   1.3415367E-05,   1.3772315E-05,   1.4126044E-05
     +,   1.4475843E-05,   1.4820973E-05,   1.5160709E-05
     +,   1.5494330E-05,   1.5821082E-05,   1.6140249E-05
     +,   1.6451117E-05,   1.6752951E-05,   1.7045060E-05
     +,   1.7326758E-05,   1.7597360E-05,   1.7856219E-05
     +,   1.8102706E-05,   1.8336206E-05,   1.8556138E-05
     +,   1.8761955E-05,   1.8953137E-05,   1.9129189E-05
     +,   1.9289671E-05,   1.9434154E-05,   1.9562278E-05
     +,   1.9673704E-05,   1.9768135E-05,   1.9845331E-05
     +,   1.9905086E-05,   1.9947243E-05,   1.9971689E-05
     +,   1.9978363E-05,   1.9967241E-05,   1.9938359E-05
     +,   1.9891791E-05,   1.9827658E-05,   1.9746130E-05
     +,   1.9647421E-05,   1.9531795E-05,   1.9399547E-05
     +,   1.9251023E-05,   1.9086614E-05,   1.8906734E-05
     +,   1.8711846E-05,   1.8502455E-05,   1.8279075E-05
     +,   1.8042281E-05,   1.7792645E-05,   1.7530791E-05
     +,   1.7257356E-05,   1.6973014E-05,   1.6678418E-05
     +,   1.6374284E-05,   1.6061300E-05,   1.5740197E-05
     +,   1.5411699E-05,   1.5076556E-05,   1.4735479E-05
     +,   1.4389228E-05,   1.4038518E-05,   1.3684093E-05
     +,   1.3326680E-05,   1.2967021E-05,   1.2605797E-05
     +,   1.2243740E-05,   1.1881521E-05,   1.1519833E-05
     +,   1.1159362E-05,   1.0800748E-05,   1.0444665E-05
     +,   1.0091736E-05,   9.7426100E-06,   9.3979224E-06
     +,   9.0583262E-06,   8.7244316E-06,   8.3969044E-06
     +,   8.0764239E-06,   7.7636587E-06,   7.4593445E-06
     +,   7.1642589E-06,   6.8791996E-06,   6.6050761E-06
     +,   6.3428320E-06,   6.0935404E-06,   5.8583760E-06
     +,   5.6386466E-06,   5.4357870E-06,   5.2514310E-06
     +,   5.0873705E-06,   4.9456280E-06,   4.8284523E-06
     +,   4.7383314E-06,   4.6780356E-06,   4.6506207E-06
     +,   4.6594423E-06,   4.7081789E-06,   4.8008301E-06
     +,   4.9417358E-06,   5.1355610E-06,   5.3872836E-06
     +,   5.7022239E-06,   6.0859588E-06,   6.5443305E-06
     +,   7.0833757E-06,   7.7093546E-06,   8.4285412E-06
     +,   9.2473438E-06,   1.0172029E-05,   1.1208751E-05
     +,   1.2363364E-05,   1.3641445E-05,   1.5048123E-05
     +,   1.6587821E-05,   1.8264293E-05,   2.0080459E-05
     +,   2.2038204E-05,   2.4138499E-05,   2.6381193E-05
     +,   2.8764713E-05,   3.1286287E-05,   3.3941717E-05
     +,   3.6725658E-05,   3.9631541E-05,   4.2651278E-05
     +,   4.5775803E-05,   4.8995058E-05,   5.2298034E-05
     +,   5.5673547E-05,   5.9109552E-05,   6.2594539E-05
     +,   6.6116823E-05,   6.9665497E-05,   7.3230643E-05
     +,   7.6803466E-05,   8.0377111E-05,   8.3946667E-05
     +,   8.7509186E-05,   9.1064234E-05,   9.4613875E-05
     +,   9.8163066E-05,   1.0171943E-04,   1.0529282E-04
     +,   1.0889550E-04,   1.1254178E-04,   1.1624753E-04
     +,   1.2003006E-04,   1.2390768E-04,   1.2789905E-04
     +,   1.3202359E-04,   1.3630172E-04,   1.4075545E-04
     +,   1.4541078E-04,   1.5029994E-04,   1.5546534E-04
     +,   1.6096611E-04,   1.6688587E-04,   1.7334466E-04
     +,   1.8051201E-04,   1.8862357E-04,   1.9800094E-04
     +,   2.0907164E-04,   2.2238748E-04,   2.3864103E-04
     +,   2.5866617E-04,   2.8343327E-04,   3.1401266E-04
     +,   3.5152098E-04,   3.9703483E-04,   4.5147483E-04
     +,   5.1547500E-04,   5.8923324E-04,   6.7236891E-04
     +,   7.6383387E-04,   8.6189184E-04,   9.6423354E-04
     +,   1.0681986E-03,   1.1712018E-03,   1.2711872E-03
     +,   1.3671186E-03,   1.4592725E-03,   1.5492493E-03
     +,   1.6396265E-03,   1.7333904E-03,   1.8334535E-03
     +,   1.9425566E-03,   2.0637440E-03,   2.2012561E-03
     +,   2.3611998E-03,   2.5512280E-03,   2.7788088E-03
     +,   3.0482458E-03,   3.3577499E-03,   3.6980351E-03
     +,   4.0538129E-03,   4.4078506E-03,   4.7455947E-03
     +,   5.0581144E-03,   5.3418498E-03,   5.5956487E-03
     +,   5.8173379E-03,   6.0015353E-03,   6.1403601E-03
     +,   6.2273522E-03,   6.2634544E-03,   6.2610572E-03
     +,   6.2407618E-03,   6.2193079E-03,   6.1949138E-03
     +,   6.1415238E-03,   6.0188822E-03,   5.7942672E-03
     +,   5.4623885E-03,   5.0514489E-03,   4.6129934E-03
     +,   4.2030350E-03,   3.8647084E-03,   3.6192404E-03
     +,   3.4658965E-03,   3.3875948E-03,   3.3581886E-03
     +,   3.3485782E-03,   3.3310472E-03,   3.2824560E-03
     +,   3.1870315E-03,   3.0384960E-03,   2.8406787E-03
     +,   2.6059006E-03,   2.3512945E-03,   2.0944355E-03
     +,   1.8495497E-03,   1.6256425E-03,   1.4264346E-03
     +,   1.2517022E-03,   1.0990126E-03,   9.6533581E-04
     +,   8.4791525E-04,   7.4461120E-04,   6.5383443E-04
     +,   5.7430548E-04,   5.0486502E-04,   4.4433371E-04
     +,   3.9151390E-04,   3.4522929E-04,   3.0440019E-04
     +,   2.6810766E-04,   2.3561383E-04,   2.0637862E-04
     +,   1.8002071E-04,   1.5627954E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_nwao_hz_100 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_nwao_hz_105(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  7.3910339E-10,   8.6476276E-10
     +,   1.0107617E-09,   1.1801966E-09,   1.3766107E-09
     +,   1.6040460E-09,   1.8670918E-09,   2.1709767E-09
     +,   2.5216420E-09,   2.9258034E-09,   3.3910805E-09
     +,   3.9260857E-09,   4.5405457E-09,   5.2453974E-09
     +,   6.0529772E-09,   6.9771549E-09,   8.0334486E-09
     +,   9.2392938E-09,   1.0614207E-08,   1.2179902E-08
     +,   1.3960681E-08,   1.5983614E-08,   1.8278683E-08
     +,   2.0879291E-08,   2.3822459E-08,   2.7148989E-08
     +,   3.0904125E-08,   3.5137798E-08,   3.9904695E-08
     +,   4.5265242E-08,   5.1285731E-08,   5.8038420E-08
     +,   6.5602755E-08,   7.4065433E-08,   8.3520476E-08
     +,   9.4070650E-08,   1.0582763E-07,   1.1891176E-07
     +,   1.3345394E-07,   1.4959528E-07,   1.6748825E-07
     +,   1.8729587E-07,   2.0919406E-07,   2.3337122E-07
     +,   2.6002917E-07,   2.8938194E-07,   3.2165937E-07
     +,   3.5710357E-07,   3.9597319E-07,   4.3854118E-07
     +,   4.8509685E-07,   5.3594169E-07,   5.9139586E-07
     +,   6.5179518E-07,   7.1748673E-07,   7.8883687E-07
     +,   8.6622651E-07,   9.5004629E-07,   1.0407048E-06
     +,   1.1386248E-06,   1.2442339E-06,   1.3579768E-06
     +,   1.4803087E-06,   1.6116845E-06,   1.7525739E-06
     +,   1.9034517E-06,   2.0647851E-06,   2.2370534E-06
     +,   2.4207325E-06,   2.6162843E-06,   2.8241736E-06
     +,   3.0448525E-06,   3.2787650E-06,   3.5263258E-06
     +,   3.7879461E-06,   4.0639939E-06,   4.3548430E-06
     +,   4.6608097E-06,   4.9821729E-06,   5.3192116E-06
     +,   5.6721283E-06,   6.0410757E-06,   6.4262063E-06
     +,   6.8275749E-06,   7.2451830E-06,   7.6790175E-06
     +,   8.1289445E-06,   8.5948295E-06,   9.0764261E-06
     +,   9.5734313E-06,   1.0085454E-05,   1.0612094E-05
     +,   1.1152816E-05,   1.1707011E-05,   1.2274065E-05
     +,   1.2853223E-05,   1.3443658E-05,   1.4044544E-05
     +,   1.4654897E-05,   1.5273759E-05,   1.5900039E-05
     +,   1.6532620E-05,   1.7170298E-05,   1.7811906E-05
     +,   1.8456125E-05,   1.9101715E-05,   1.9747335E-05
     +,   2.0391624E-05,   2.1033216E-05,   2.1670799E-05
     +,   2.2302977E-05,   2.2928454E-05,   2.3545901E-05
     +,   2.4154044E-05,   2.4751620E-05,   2.5337515E-05
     +,   2.5910560E-05,   2.6469774E-05,   2.7014168E-05
     +,   2.7542887E-05,   2.8055203E-05,   2.8550434E-05
     +,   2.9028099E-05,   2.9487779E-05,   2.9929206E-05
     +,   3.0352245E-05,   3.0756935E-05,   3.1143420E-05
     +,   3.1511994E-05,   3.1863143E-05,   3.2197440E-05
     +,   3.2515640E-05,   3.2818662E-05,   3.3107499E-05
     +,   3.3383356E-05,   3.3647520E-05,   3.3901419E-05
     +,   3.4146578E-05,   3.4384684E-05,   3.4617464E-05
     +,   3.4846791E-05,   3.5074620E-05,   3.5302965E-05
     +,   3.5533983E-05,   3.5769852E-05,   3.6012872E-05
     +,   3.6265454E-05,   3.6530048E-05,   3.6809262E-05
     +,   3.7105827E-05,   3.7422604E-05,   3.7762598E-05
     +,   3.8129088E-05,   3.8525501E-05,   3.8955564E-05
     +,   3.9423274E-05,   3.9933009E-05,   4.0489460E-05
     +,   4.1097788E-05,   4.1763553E-05,   4.2492804E-05
     +,   4.3292028E-05,   4.4168282E-05,   4.5129156E-05
     +,   4.6182628E-05,   4.7337162E-05,   4.8601651E-05
     +,   4.9985272E-05,   5.1497504E-05,   5.3148015E-05
     +,   5.4946348E-05,   5.6901965E-05,   5.9023863E-05
     +,   6.1320738E-05,   6.3800573E-05,   6.6470224E-05
     +,   6.9335547E-05,   7.2401053E-05,   7.5669603E-05
     +,   7.9142817E-05,   8.2820043E-05,   8.6699314E-05
     +,   9.0776521E-05,   9.5045929E-05,   9.9500270E-05
     +,   1.0413094E-04,   1.0892880E-04,   1.1388437E-04
     +,   1.1898814E-04,   1.2423171E-04,   1.2960829E-04
     +,   1.3511411E-04,   1.4074896E-04,   1.4651645E-04
     +,   1.5242567E-04,   1.5849138E-04,   1.6473472E-04
     +,   1.7118409E-04,   1.7787496E-04,   1.8484989E-04
     +,   1.9215910E-04,   1.9986057E-04,   2.0802005E-04
     +,   2.1671271E-04,   2.2602353E-04,   2.3604798E-04
     +,   2.4689481E-04,   2.5868698E-04,   2.7156473E-04
     +,   2.8568573E-04,   3.0122299E-04,   3.1836404E-04
     +,   3.3730420E-04,   3.5823704E-04,   3.8134461E-04
     +,   4.0677481E-04,   4.3463067E-04,   4.6494286E-04
     +,   4.9765594E-04,   5.3261087E-04,   5.6953408E-04
     +,   6.0804252E-04,   6.4764894E-04,   6.8777922E-04
     +,   7.2780903E-04,   7.6710060E-04,   8.0505514E-04
     +,   8.4115093E-04,   8.7499962E-04,   9.0637297E-04
     +,   9.3523681E-04,   9.6176012E-04,   9.8632008E-04
     +,   1.0094945E-03,   1.0320507E-03,   1.0549421E-03
     +,   1.0792953E-03,   1.1063907E-03,   1.1376154E-03
     +,   1.1743583E-03,   1.2178301E-03,   1.2688168E-03
     +,   1.3273744E-03,   1.3925690E-03,   1.4623163E-03
     +,   1.5334878E-03,   1.6023450E-03,   1.6652764E-03
     +,   1.7197767E-03,   1.7654486E-03,   1.8047433E-03
     +,   1.8432973E-03,   1.8896740E-03,   1.9545485E-03
     +,   2.0493416E-03,   2.1843135E-03,   2.3661347E-03
     +,   2.5951159E-03,   2.8626749E-03,   3.1502552E-03
     +,   3.4309211E-03,   3.6743819E-03,   3.8549656E-03
     +,   3.9603026E-03,   3.9978884E-03,   3.9967257E-03
     +,   4.0025371E-03,   4.0669162E-03,   4.2326865E-03
     +,   4.5193369E-03,   4.9134479E-03,   5.3683044E-03
     +,   5.8147651E-03,   6.1817495E-03,   6.4206091E-03
     +,   6.5242611E-03,   6.5312544E-03,   6.5090349E-03
     +,   6.5208040E-03,   6.5912888E-03,   6.6904817E-03
     +,   6.7456486E-03,   6.6752634E-03,   6.4256783E-03
     +,   5.9912414E-03,   5.4105050E-03,   4.7459789E-03
     +,   4.0605315E-03,   3.4018764E-03,   2.7982083E-03
     +,   2.2616850E-03,   1.7949324E-03,   1.3961075E-03
     +,   1.0618400E-03,   7.8798109E-04,   5.6951132E-04
     +,   4.0036568E-04,   2.7351649E-04,   1.8150212E-04
     +,   1.1696189E-04,   7.3183430E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_nwao_hz_105 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_nwao_hz_107(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  3.2050166E-24,   5.3924512E-24
     +,   9.0443423E-24,   1.5121659E-23,   2.5203061E-23
     +,   4.1874094E-23,   6.9353085E-23,   1.1450368E-22
     +,   1.8845651E-22,   3.0919531E-22,   5.0569402E-22
     +,   8.2446895E-22,   1.3399821E-21,   2.1709769E-21
     +,   3.5062377E-21,   5.6450226E-21,   9.0598289E-21
     +,   1.4494639E-20,   2.3117086E-20,   3.6752513E-20
     +,   5.8247080E-20,   9.2023307E-20,   1.4492829E-19
     +,   2.2753066E-19,   3.5609355E-19,   5.5554370E-19
     +,   8.6398364E-19,   1.3394616E-18,   2.0700654E-18
     +,   3.1891221E-18,   4.8977472E-18,   7.4980639E-18
     +,   1.1442939E-17,   1.7408514E-17,   2.6400728E-17
     +,   3.9911905E-17,   6.0148842E-17,   9.0361045E-17
     +,   1.3532202E-16,   2.0201790E-16,   3.0064021E-16
     +,   4.4600027E-16,   6.5956211E-16,   9.7232288E-16
     +,   1.4289005E-15,   2.0932624E-15,   3.0569057E-15
     +,   4.4501176E-15,   6.4579461E-15,   9.3422389E-15
     +,   1.3472359E-14,   1.9367232E-14,   2.7753929E-14
     +,   3.9647823E-14,   5.6460523E-14,   8.0150181E-14
     +,   1.1342313E-13,   1.6000387E-13,   2.2500552E-13
     +,   3.1542325E-13,   4.4078486E-13,   6.1403709E-13
     +,   8.5270826E-13,   1.1804274E-12,   1.6289771E-12
     +,   2.2409314E-12,   3.0730999E-12,   4.2010896E-12
     +,   5.7251612E-12,   7.7776535E-12,   1.0532918E-11
     +,   1.4219640E-11,   1.9136845E-11,   2.5673907E-11
     +,   3.4336582E-11,   4.5778395E-11,   6.0843351E-11
     +,   8.0614203E-11,   1.0647597E-10,   1.4019878E-10
     +,   1.8402976E-10,   2.4081204E-10,   3.1414257E-10
     +,   4.0853790E-10,   5.2965360E-10,   6.8456824E-10
     +,   8.8206709E-10,   1.1330743E-09,   1.4510622E-09
     +,   1.8526286E-09,   2.3581166E-09,   2.9924709E-09
     +,   3.7860155E-09,   4.7755613E-09,   6.0057839E-09
     +,   7.5304412E-09,   9.4140988E-09,   1.1734387E-08
     +,   1.4583595E-08,   1.8072054E-08,   2.2330280E-08
     +,   2.7512741E-08,   3.3801296E-08,   4.1410384E-08
     +,   5.0590298E-08,   6.1634680E-08,   7.4884554E-08
     +,   9.0736506E-08,   1.0964908E-07,   1.3215450E-07
     +,   1.5886272E-07,   1.9047883E-07,   2.2780807E-07
     +,   2.7177296E-07,   3.2342362E-07,   3.8396303E-07
     +,   4.5474789E-07,   5.3732771E-07,   6.3344646E-07
     +,   7.4507096E-07,   8.7443050E-07,   1.0240103E-06
     +,   1.1966209E-06,   1.3953879E-06,   1.6238067E-06
     +,   1.8857568E-06,   2.1855783E-06,   2.5280456E-06
     +,   2.9184200E-06,   3.3625424E-06,   3.8667672E-06
     +,   4.4380240E-06,   5.0839230E-06,   5.8126034E-06
     +,   6.6329485E-06,   7.5543867E-06,   8.5869979E-06
     +,   9.7414013E-06,   1.1028902E-05,   1.2461091E-05
     +,   1.4050172E-05,   1.5808475E-05,   1.7748453E-05
     +,   1.9882782E-05,   2.2223729E-05,   2.4783109E-05
     +,   2.7572414E-05,   3.0601921E-05,   3.3880679E-05
     +,   3.7416623E-05,   4.1215510E-05,   4.5280933E-05
     +,   4.9614486E-05,   5.4214590E-05,   5.9076741E-05
     +,   6.4192951E-05,   6.9552298E-05,   7.5139338E-05
     +,   8.0935701E-05,   8.6918517E-05,   9.3061288E-05
     +,   9.9333585E-05,   1.0570193E-04,   1.1212964E-04
     +,   1.1857673E-04,   1.2500110E-04,   1.3135874E-04
     +,   1.3760434E-04,   1.4369242E-04,   1.4957789E-04
     +,   1.5521611E-04,   1.6056460E-04,   1.6558325E-04
     +,   1.7023599E-04,   1.7449078E-04,   1.7832033E-04
     +,   1.8170319E-04,   1.8462409E-04,   1.8707461E-04
     +,   1.8905349E-04,   1.9056676E-04,   1.9162813E-04
     +,   1.9225874E-04,   1.9248706E-04,   1.9234870E-04
     +,   1.9188588E-04,   1.9114665E-04,   1.9018432E-04
     +,   1.8905645E-04,   1.8782375E-04,   1.8654909E-04
     +,   1.8529598E-04,   1.8412742E-04,   1.8310461E-04
     +,   1.8228569E-04,   1.8172414E-04,   1.8146813E-04
     +,   1.8155930E-04,   1.8203215E-04,   1.8291365E-04
     +,   1.8422308E-04,   1.8597247E-04,   1.8816686E-04
     +,   1.9080591E-04,   1.9388481E-04,   1.9739571E-04
     +,   2.0132963E-04,   2.0567789E-04,   2.1043410E-04
     +,   2.1559506E-04,   2.2116120E-04,   2.2713713E-04
     +,   2.3353120E-04,   2.4035394E-04,   2.4761789E-04
     +,   2.5533387E-04,   2.6351231E-04,   2.7216010E-04
     +,   2.8128349E-04,   2.9089057E-04,   3.0099729E-04
     +,   3.1163727E-04,   3.2287400E-04,   3.3481434E-04
     +,   3.4762642E-04,   3.6155563E-04,   3.7694111E-04
     +,   3.9422282E-04,   4.1395106E-04,   4.3677908E-04
     +,   4.6345202E-04,   4.9478147E-04,   5.3161057E-04
     +,   5.7476055E-04,   6.2495994E-04,   6.8276731E-04
     +,   7.4848329E-04,   8.2206744E-04,   9.0308982E-04
     +,   9.9071267E-04,   1.0837232E-03,   1.1806408E-03
     +,   1.2798450E-03,   1.3797232E-03,   1.4787430E-03
     +,   1.5754728E-03,   1.6685332E-03,   1.7564653E-03
     +,   1.8376675E-03,   1.9104634E-03,   1.9733408E-03
     +,   2.0254534E-03,   2.0672283E-03,   2.1009578E-03
     +,   2.1311152E-03,   2.1641310E-03,   2.2074706E-03
     +,   2.2680194E-03,   2.3500558E-03,   2.4533893E-03
     +,   2.5723693E-03,   2.6964273E-03,   2.8123958E-03
     +,   2.9081015E-03,   2.9761789E-03,   3.0166314E-03
     +,   3.0369963E-03,   3.0499527E-03,   3.0693228E-03
     +,   3.1062155E-03,   3.1669310E-03,   3.2531791E-03
     +,   3.3638808E-03,   3.4970646E-03,   3.6505195E-03
     +,   3.8209278E-03,   4.0023215E-03,   4.1849767E-03
     +,   4.3556243E-03,   4.4989986E-03,   4.6001123E-03
     +,   4.6466049E-03,   4.6303743E-03,   4.5482288E-03
     +,   4.4014715E-03,   4.1947155E-03,   3.9347350E-03
     +,   3.6296921E-03,   3.2891342E-03,   2.9244146E-03
     +,   2.5487840E-03,   2.1768326E-03,   1.8228481E-03
     +,   1.4989673E-03,   1.2134734E-03,   9.7007380E-04
     +,   7.6823623E-04,   6.0425472E-04,   4.7278029E-04
     +,   3.6804689E-04,   2.8476733E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_nwao_hz_107 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_nwao_hz_110(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  4.9129371E-11,   5.8912084E-11
     +,   7.0549892E-11,   8.4374695E-11,   1.0077549E-10
     +,   1.2020573E-10,   1.4319233E-10,   1.7034944E-10
     +,   2.0239047E-10,   2.4013957E-10,   2.8455313E-10
     +,   3.3673619E-10,   3.9796363E-10,   4.6970172E-10
     +,   5.5363925E-10,   6.5171774E-10,   7.6615558E-10
     +,   8.9949909E-10,   1.0546580E-09,   1.2349456E-09
     +,   1.4441434E-09,   1.6865546E-09,   1.9670490E-09
     +,   2.2911648E-09,   2.6651710E-09,   3.0961256E-09
     +,   3.5920176E-09,   4.1618451E-09,   4.8156870E-09
     +,   5.5648908E-09,   6.4221872E-09,   7.4017437E-09
     +,   8.5194394E-09,   9.7930029E-09,   1.1242054E-08
     +,   1.2888481E-08,   1.4756565E-08,   1.6873063E-08
     +,   1.9267651E-08,   2.1973019E-08,   2.5025233E-08
     +,   2.8463720E-08,   3.2331922E-08,   3.6677338E-08
     +,   4.1551914E-08,   4.7012126E-08,   5.3119685E-08
     +,   5.9941357E-08,   6.7549820E-08,   7.6023454E-08
     +,   8.5447340E-08,   9.5912419E-08,   1.0751698E-07
     +,   1.2036686E-07,   1.3457419E-07,   1.5025984E-07
     +,   1.6755270E-07,   1.8658868E-07,   2.0751300E-07
     +,   2.3047974E-07,   2.5564978E-07,   2.8319423E-07
     +,   3.1329299E-07,   3.4613251E-07,   3.8190944E-07
     +,   4.2082902E-07,   4.6310186E-07,   5.0894846E-07
     +,   5.5859641E-07,   6.1227746E-07,   6.7023143E-07
     +,   7.3270309E-07,   7.9994146E-07,   8.7219695E-07
     +,   9.4972523E-07,   1.0327778E-06,   1.1216151E-06
     +,   1.2164872E-06,   1.3176402E-06,   1.4253269E-06
     +,   1.5397812E-06,   1.6612285E-06,   1.7898989E-06
     +,   1.9259933E-06,   2.0697000E-06,   2.2212068E-06
     +,   2.3806592E-06,   2.5482072E-06,   2.7239589E-06
     +,   2.9080034E-06,   3.1003949E-06,   3.3011811E-06
     +,   3.5103562E-06,   3.7278805E-06,   3.9537031E-06
     +,   4.1877133E-06,   4.4297612E-06,   4.6796849E-06
     +,   4.9372456E-06,   5.2022015E-06,   5.4742400E-06
     +,   5.7530183E-06,   6.0381381E-06,   6.3291964E-06
     +,   6.6257035E-06,   6.9271778E-06,   7.2330640E-06
     +,   7.5427847E-06,   7.8557141E-06,   8.1712378E-06
     +,   8.4886606E-06,   8.8073166E-06,   9.1264801E-06
     +,   9.4454244E-06,   9.7634020E-06,   1.0079691E-05
     +,   1.0393525E-05,   1.0704191E-05,   1.1010951E-05
     +,   1.1313081E-05,   1.1609923E-05,   1.1900796E-05
     +,   1.2185107E-05,   1.2462266E-05,   1.2731747E-05
     +,   1.2993071E-05,   1.3245849E-05,   1.3489729E-05
     +,   1.3724437E-05,   1.3949803E-05,   1.4165715E-05
     +,   1.4372148E-05,   1.4569198E-05,   1.4757020E-05
     +,   1.4935900E-05,   1.5106207E-05,   1.5268410E-05
     +,   1.5423084E-05,   1.5570917E-05,   1.5712674E-05
     +,   1.5849246E-05,   1.5981597E-05,   1.6110786E-05
     +,   1.6237969E-05,   1.6364374E-05,   1.6491289E-05
     +,   1.6620093E-05,   1.6752194E-05,   1.6889051E-05
     +,   1.7032165E-05,   1.7183054E-05,   1.7343231E-05
     +,   1.7514223E-05,   1.7697526E-05,   1.7894603E-05
     +,   1.8106852E-05,   1.8335639E-05,   1.8582203E-05
     +,   1.8847722E-05,   1.9133240E-05,   1.9439663E-05
     +,   1.9767745E-05,   2.0118094E-05,   2.0491150E-05
     +,   2.0887128E-05,   2.1306056E-05,   2.1747741E-05
     +,   2.2211747E-05,   2.2697444E-05,   2.3203971E-05
     +,   2.3730179E-05,   2.4274719E-05,   2.4835974E-05
     +,   2.5412159E-05,   2.6001280E-05,   2.6601134E-05
     +,   2.7209369E-05,   2.7823542E-05,   2.8441103E-05
     +,   2.9059578E-05,   2.9676470E-05,   3.0289519E-05
     +,   3.0896645E-05,   3.1496129E-05,   3.2086755E-05
     +,   3.2667886E-05,   3.3239685E-05,   3.3803237E-05
     +,   3.4360659E-05,   3.4915331E-05,   3.5472014E-05
     +,   3.6037127E-05,   3.6618836E-05,   3.7227255E-05
     +,   3.7874703E-05,   3.8575985E-05,   3.9348728E-05
     +,   4.0213923E-05,   4.1196570E-05,   4.2326461E-05
     +,   4.3639433E-05,   4.5178906E-05,   4.6997648E-05
     +,   4.9160328E-05,   5.1746170E-05,   5.4851702E-05
     +,   5.8594251E-05,   6.3114698E-05,   6.8580630E-05
     +,   7.5187811E-05,   8.3159714E-05,   9.2745911E-05
     +,   1.0421679E-04,   1.1785411E-04,   1.3394009E-04
     +,   1.5273585E-04,   1.7446456E-04,   1.9928100E-04
     +,   2.2724640E-04,   2.5829984E-04,   2.9223156E-04
     +,   3.2866714E-04,   3.6705541E-04,   4.0666712E-04
     +,   4.4661789E-04,   4.8589872E-04,   5.2343390E-04
     +,   5.5813615E-04,   5.8899430E-04,   6.1514409E-04
     +,   6.3595414E-04,   6.5109221E-04,   6.6058099E-04
     +,   6.6482555E-04,   6.6461670E-04,   6.6110451E-04
     +,   6.5574027E-04,   6.5018929E-04,   6.4622011E-04
     +,   6.4557255E-04,   6.4981921E-04,   6.6022278E-04
     +,   6.7760819E-04,   7.0226390E-04,   7.3387672E-04
     +,   7.7153178E-04,   8.1378571E-04,   8.5881457E-04
     +,   9.0465957E-04,   9.4955025E-04,   9.9224714E-04
     +,   1.0323852E-03,   1.0706860E-03,   1.1090080E-03
     +,   1.1501472E-03,   1.1974050E-03,   1.2539704E-03
     +,   1.3222456E-03,   1.4032885E-03,   1.4965950E-03
     +,   1.6003309E-03,   1.7120134E-03,   1.8294379E-03
     +,   1.9514486E-03,   2.0782268E-03,   2.2110159E-03
     +,   2.3514251E-03,   2.5006193E-03,   2.6585348E-03
     +,   2.8230129E-03,   2.9887685E-03,   3.1463932E-03
     +,   3.2821028E-03,   3.3792045E-03,   3.4216070E-03
     +,   3.3987160E-03,   3.3098855E-03,   3.1661876E-03
     +,   2.9881613E-03,   2.7998821E-03,   2.6216977E-03
     +,   2.4644423E-03,   2.3276357E-03,   2.2019087E-03
     +,   2.0743161E-03,   1.9339217E-03,   1.7756221E-03
     +,   1.6010308E-03,   1.4169210E-03,   1.2323989E-03
     +,   1.0561049E-03,   8.9442724E-04,   7.5080286E-04
     +,   6.2606571E-04,   5.1922433E-04,   4.2834721E-04
     +,   3.5125946E-04,   2.8593358E-04,   2.3068982E-04
     +,   1.8417351E-04,   1.4528735E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_nwao_hz_110 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_nwao_hz_115(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  2.3858699E-34,   4.5155119E-34
     +,   8.5199775E-34,   1.6026477E-33,   3.0054459E-33
     +,   5.6189618E-33,   1.0472884E-32,   1.9460300E-32
     +,   3.6050449E-32,   6.6578877E-32,   1.2258396E-31
     +,   2.2500932E-31,   4.1176105E-31,   7.5119858E-31
     +,   1.3662669E-30,   2.4773897E-30,   4.4783303E-30
     +,   8.0706944E-30,   1.4500412E-29,   2.5972643E-29
     +,   4.6379369E-29,   8.2567337E-29,   1.4654006E-28
     +,   2.5928504E-28,   4.5737581E-28,   8.0433493E-28
     +,   1.4101662E-27,   2.4647807E-27,   4.2949293E-27
     +,   7.4611088E-27,   1.2921871E-26,   2.2310814E-26
     +,   3.8403733E-26,   6.5903646E-26,   1.1274876E-25
     +,   1.9230272E-25,   3.2699071E-25,   5.5430874E-25
     +,   9.3678021E-25,   1.5783198E-24,   2.6511154E-24
     +,   4.4394272E-24,   7.4113656E-24,   1.2335046E-23
     +,   2.0467103E-23,   3.3856468E-23,   5.5834357E-23
     +,   9.1796847E-23,   1.5046151E-22,   2.4586270E-22
     +,   4.0053104E-22,   6.5049814E-22,   1.0532398E-21
     +,   1.7001405E-21,   2.7359532E-21,   4.3893701E-21
     +,   7.0205646E-21,   1.1194633E-20,   1.7795796E-20
     +,   2.8203382E-20,   4.4560636E-20,   7.0189616E-20
     +,   1.1022175E-19,   1.7255657E-19,   2.6931794E-19
     +,   4.1905916E-19,   6.5005632E-19,   1.0053072E-18
     +,   1.5499597E-18,   2.3823743E-18,   3.6506632E-18
     +,   5.5770217E-18,   8.4939413E-18,   1.2896839E-17
     +,   1.9522386E-17,   2.9460805E-17,   4.4323610E-17
     +,   6.6480916E-17,   9.9408329E-17,   1.4819256E-16
     +,   2.2024265E-16,   3.2631682E-16,   4.8201119E-16
     +,   7.0981520E-16,   1.0420710E-15,   1.5252017E-15
     +,   2.2254709E-15,   3.2373868E-15,   4.6950138E-15
     +,   6.7881479E-15,   9.7843156E-15,   1.4060046E-14
     +,   2.0142506E-14,   2.8767797E-14,   4.0961439E-14
     +,   5.8145478E-14,   8.2285138E-14,   1.1609244E-13
     +,   1.6328715E-13,   2.2896840E-13,   3.2009001E-13
     +,   4.4610631E-13,   6.1982640E-13,   8.5857807E-13
     +,   1.1856412E-12,   1.6323152E-12,   2.2404023E-12
     +,   3.0656272E-12,   4.1819356E-12,   5.6873885E-12
     +,   7.7110505E-12,   1.0422958E-11,   1.4045555E-11
     +,   1.8869397E-11,   2.5272208E-11,   3.3744629E-11
     +,   4.4919200E-11,   5.9612218E-11,   7.8869564E-11
     +,   1.0402804E-10,   1.3679392E-10,   1.7932861E-10
     +,   2.3437310E-10,   3.0537803E-10,   3.9667811E-10
     +,   5.1369470E-10,   6.6320566E-10,   8.5361462E-10
     +,   1.0953229E-09,   1.4011946E-09,   1.7870028E-09
     +,   2.2720543E-09,   2.8799687E-09,   3.6393510E-09
     +,   4.5849515E-09,   5.7586003E-09,   7.2105761E-09
     +,   9.0009928E-09,   1.1201746E-08,   1.3897868E-08
     +,   1.7190381E-08,   2.1197943E-08,   2.6059720E-08
     +,   3.1938903E-08,   3.9024886E-08,   4.7536865E-08
     +,   5.7729022E-08,   6.9892231E-08,   8.4358959E-08
     +,   1.0150976E-07,   1.2177426E-07,   1.4563683E-07
     +,   1.7364454E-07,   2.0640586E-07,   2.4459848E-07
     +,   2.8897085E-07,   3.4035168E-07,   3.9964121E-07
     +,   4.6782853E-07,   5.4597672E-07,   6.3523260E-07
     +,   7.3681798E-07,   8.5203800E-07,   9.8227224E-07
     +,   1.1289541E-06,   1.2935780E-06,   1.4776825E-06
     +,   1.6828296E-06,   1.9106117E-06,   2.1626231E-06
     +,   2.4404183E-06,   2.7455155E-06,   3.0793542E-06
     +,   3.4433069E-06,   3.8386343E-06,   4.2664283E-06
     +,   4.7276285E-06,   5.2229921E-06,   5.7530515E-06
     +,   6.3181833E-06,   6.9184607E-06,   7.5538219E-06
     +,   8.2239303E-06,   8.9282767E-06,   9.6662043E-06
     +,   1.0436913E-05,   1.1239612E-05,   1.2073555E-05
     +,   1.2938029E-05,   1.3832584E-05,   1.4757031E-05
     +,   1.5711694E-05,   1.6697419E-05,   1.7715611E-05
     +,   1.8768400E-05,   1.9858675E-05,   2.0990015E-05
     +,   2.2166820E-05,   2.3394108E-05,   2.4677274E-05
     +,   2.6022028E-05,   2.7434073E-05,   2.8918763E-05
     +,   3.0480964E-05,   3.2124703E-05,   3.3852823E-05
     +,   3.5667188E-05,   3.7568774E-05,   3.9558461E-05
     +,   4.1637977E-05,   4.3811327E-05,   4.6087251E-05
     +,   4.8482052E-05,   5.1023013E-05,   5.3752890E-05
     +,   5.6733410E-05,   6.0050592E-05,   6.3817621E-05
     +,   6.8178379E-05,   7.3308845E-05,   7.9416845E-05
     +,   8.6740838E-05,   9.5545962E-05,   1.0611783E-04
     +,   1.1875625E-04,   1.3376545E-04,   1.5144517E-04
     +,   1.7207119E-04,   1.9588046E-04,   2.2303789E-04
     +,   2.5360342E-04,   2.8748586E-04,   3.2439872E-04
     +,   3.6381240E-04,   4.0491729E-04,   4.4661903E-04
     +,   4.8756361E-04,   5.2620517E-04,   5.6092470E-04
     +,   5.9017795E-04,   6.1266712E-04,   6.2752038E-04
     +,   6.3444331E-04,   6.3382735E-04,   6.2679517E-04
     +,   6.1517995E-04,   6.0143182E-04,   5.8847398E-04
     +,   5.7951390E-04,   5.7783513E-04,   5.8658066E-04
     +,   6.0851598E-04,   6.4574927E-04,   6.9938501E-04
     +,   7.6911930E-04,   8.5285440E-04,   9.4652415E-04
     +,   1.0443060E-03,   1.1393668E-03,   1.2250969E-03
     +,   1.2964589E-03,   1.3509716E-03,   1.3889006E-03
     +,   1.4125552E-03,   1.4250878E-03,   1.4294427E-03
     +,   1.4280037E-03,   1.4230333E-03,   1.4174234E-03
     +,   1.4150182E-03,   1.4199917E-03,   1.4353659E-03
     +,   1.4613771E-03,   1.4946157E-03,   1.5285412E-03
     +,   1.5553070E-03,   1.5681668E-03,   1.5634459E-03
     +,   1.5412923E-03,   1.5049920E-03,   1.4592909E-03
     +,   1.4084713E-03,   1.3549830E-03,   1.2989906E-03
     +,   1.2388411E-03,   1.1720489E-03,   1.0964196E-03
     +,   1.0108649E-03,   9.1581314E-04,   8.1320765E-04
     +,   7.0617697E-04,   5.9857650E-04,   4.9441133E-04
     +,   3.9735550E-04,   3.1032588E-04,   2.3522996E-04
     +,   1.7288575E-04,   1.2308205E-04,   8.4811662E-05
     +,   5.6523924E-05,   3.6412908E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_nwao_hz_115 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_nwao_hz_120(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   2.2311684E-38,   5.6000488E-38,   1.3977490E-37
     +,   3.4694269E-37,   8.5636878E-37,   2.1020442E-36
     +,   5.1311419E-36,   1.2455394E-35,   3.0066677E-35
     +,   7.2176863E-35,   1.7229992E-34,   4.0902832E-34
     +,   9.6562719E-34,   2.2669585E-33,   5.2923948E-33
     +,   1.2286986E-32,   2.8367850E-32,   6.5130134E-32
     +,   1.4870437E-31,   3.3762544E-31,   7.6232365E-31
     +,   1.7116889E-30,   3.8218902E-30,   8.4864501E-30
     +,   1.8739377E-29,   4.1148167E-29,   8.9854960E-29
     +,   1.9512506E-28,   4.2135885E-28,   9.0487228E-28
     +,   1.9323558E-27,   4.1037854E-27,   8.6668265E-27
     +,   1.8201904E-26,   3.8013965E-26,   7.8951849E-26
     +,   1.6306570E-25,   3.3491344E-25,   6.8406177E-25
     +,   1.3894332E-24,   2.8064113E-24,   5.6371034E-24
     +,   1.1259793E-23,   2.2366564E-23,   4.4182231E-23
     +,   8.6791190E-23,   1.6954106E-22,   3.2935579E-22
     +,   6.3624871E-22,   1.2223103E-21,   2.3351448E-21
     +,   4.4364007E-21,   8.3813817E-21,   1.5746835E-20
     +,   2.9419748E-20,   5.4661193E-20,   1.0099474E-19
     +,   1.8556652E-19,   3.3905629E-19,   6.1607719E-19
     +,   1.1131889E-18,   2.0002939E-18,   3.5743670E-18
     +,   6.3515154E-18,   1.1223935E-17,   1.9723506E-17
     +,   3.4467855E-17,   5.9899841E-17,   1.0351838E-16
     +,   1.7790185E-16,   3.0404279E-16,   5.1673668E-16
     +,   8.7332517E-16,   1.4678205E-15,   2.4533032E-15
     +,   4.0775632E-15,   6.7397001E-15,   1.1077774E-14
     +,   1.8107345E-14,   2.9433196E-14,   4.7577376E-14
     +,   7.6478130E-14,   1.2225391E-13,   1.9433989E-13
     +,   3.0721969E-13,   4.8296778E-13,   7.5502153E-13
     +,   1.1737891E-12,   1.8146883E-12,   2.7898888E-12
     +,   4.2654066E-12,   6.4850712E-12,   9.8049121E-12
     +,   1.4742109E-11,   2.2042312E-11,   3.2773961E-11
     +,   4.8460520E-11,   7.1257153E-11,   1.0419567E-10
     +,   1.5151144E-10,   2.1909329E-10,   3.1505534E-10
     +,   4.5053861E-10,   6.4070549E-10,   9.0607827E-10
     +,   1.2742303E-09,   1.7820152E-09,   2.4783429E-09
     +,   3.4276202E-09,   4.7141646E-09,   6.4475940E-09
     +,   8.7693284E-09,   1.1860863E-08,   1.5953376E-08
     +,   2.1338773E-08,   2.8383580E-08,   3.7544087E-08
     +,   4.9385179E-08,   6.4600790E-08,   8.4034916E-08
     +,   1.0870829E-07,   1.3984484E-07,   1.7889866E-07
     +,   2.2758992E-07,   2.8792255E-07,   3.6222917E-07
     +,   4.5318154E-07,   5.6382197E-07,   6.9757783E-07
     +,   8.5826389E-07,   1.0500985E-06,   1.2776850E-06
     +,   1.5459603E-06,   1.8601759E-06,   2.2258073E-06
     +,   2.6485141E-06,   3.1340132E-06,   3.6879107E-06
     +,   4.3155983E-06,   5.0220665E-06,   5.8116912E-06
     +,   6.6881148E-06,   7.6540018E-06,   8.7107301E-06
     +,   9.8582968E-06,   1.1095099E-05,   1.2417703E-05
     +,   1.3820872E-05,   1.5297412E-05,   1.6838016E-05
     +,   1.8431525E-05,   2.0065005E-05,   2.1724278E-05
     +,   2.3394352E-05,   2.5060110E-05,   2.6707643E-05
     +,   2.8325780E-05,   2.9908195E-05,   3.1456439E-05
     +,   3.2983098E-05,   3.4516674E-05,   3.6106419E-05
     +,   3.7828537E-05,   3.9792511E-05,   4.2147469E-05
     +,   4.5088203E-05,   4.8859314E-05,   5.3756477E-05
     +,   6.0124308E-05,   6.8347981E-05,   7.8839854E-05
     +,   9.2014205E-05,   1.0825903E-04,   1.2789290E-04
     +,   1.5112037E-04,   1.7798124E-04,   2.0830728E-04
     +,   2.4168557E-04,   2.7744079E-04,   3.1465327E-04
     +,   3.5220961E-04,   3.8889042E-04,   4.2349889E-04
     +,   4.5500221E-04,   4.8267469E-04,   5.0622609E-04
     +,   5.2587438E-04,   5.4235727E-04,   5.5685773E-04
     +,   5.7086127E-04,   5.8595586E-04,   6.0359878E-04
     +,   6.2490557E-04,   6.5049395E-04,   6.8040990E-04
     +,   7.1416434E-04,   7.5084012E-04,   7.8925904E-04
     +,   8.2815177E-04,   8.6630578E-04,   9.0269092E-04
     +,   9.3655911E-04,   9.6753461E-04,   9.9567953E-04
     +,   1.0214712E-03,   1.0456534E-03,   1.0689457E-03
     +,   1.0916854E-03,   1.1135550E-03,   1.1335626E-03
     +,   1.1503435E-03,   1.1627260E-03,   1.1703098E-03
     +,   1.1737879E-03,   1.1747921E-03,   1.1752539E-03
     +,   1.1764924E-03,   1.1783866E-03,   1.1789820E-03
     +,   1.1747266E-03,   1.1612922E-03,   1.1347174E-03
     +,   1.0925020E-03,   1.0342989E-03,   9.6203416E-04
     +,   8.7943248E-04,   7.9119374E-04,   7.0203986E-04
     +,   6.1594008E-04,   5.3562719E-04,   4.6254371E-04
     +,   3.9701734E-04,   3.3863584E-04,   2.8664607E-04
     +,   2.4026730E-04,   1.9889670E-04,   1.6215464E-04
     +,   1.2985693E-04,   1.0191572E-04,   7.8241712E-05
     +,   5.8670965E-05,   4.2923035E-05,   3.0612271E-05
     +,   2.1271158E-05,   1.4394989E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_nwao_hz_120 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_nwao_hz_60(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  2.2445756E-05,   2.3309905E-05
     +,   2.4231194E-05,   2.5213159E-05,   2.6259511E-05
     +,   2.7374143E-05,   2.8560993E-05,   2.9824238E-05
     +,   3.1168147E-05,   3.2597029E-05,   3.4115361E-05
     +,   3.5727662E-05,   3.7438542E-05,   3.9252525E-05
     +,   4.1174208E-05,   4.3208187E-05,   4.5358836E-05
     +,   4.7630536E-05,   5.0027535E-05,   5.2553729E-05
     +,   5.5212902E-05,   5.8008583E-05,   6.0943774E-05
     +,   6.4021253E-05,   6.7243389E-05,   7.0611888E-05
     +,   7.4128067E-05,   7.7792742E-05,   8.1605838E-05
     +,   8.5566891E-05,   8.9674708E-05,   9.3927149E-05
     +,   9.8321558E-05,   1.0285448E-04,   1.0752141E-04
     +,   1.1231731E-04,   1.1723631E-04,   1.2227141E-04
     +,   1.2741507E-04,   1.3265887E-04,   1.3799370E-04
     +,   1.4340930E-04,   1.4889501E-04,   1.5443937E-04
     +,   1.6003029E-04,   1.6565477E-04,   1.7129966E-04
     +,   1.7695085E-04,   1.8259406E-04,   1.8821459E-04
     +,   1.9379742E-04,   1.9932711E-04,   2.0478823E-04
     +,   2.1016548E-04,   2.1544305E-04,   2.2060580E-04
     +,   2.2563868E-04,   2.3052665E-04,   2.3525568E-04
     +,   2.3981195E-04,   2.4418233E-04,   2.4835460E-04
     +,   2.5231755E-04,   2.5606065E-04,   2.5957476E-04
     +,   2.6285212E-04,   2.6588593E-04,   2.6867114E-04
     +,   2.7120407E-04,   2.7348270E-04,   2.7550658E-04
     +,   2.7727702E-04,   2.7879700E-04,   2.8007125E-04
     +,   2.8110621E-04,   2.8190998E-04,   2.8249223E-04
     +,   2.8286432E-04,   2.8303888E-04,   2.8303018E-04
     +,   2.8285326E-04,   2.8252456E-04,   2.8206123E-04
     +,   2.8148101E-04,   2.8080234E-04,   2.8004375E-04
     +,   2.7922375E-04,   2.7836068E-04,   2.7747251E-04
     +,   2.7657647E-04,   2.7568900E-04,   2.7482514E-04
     +,   2.7399903E-04,   2.7322295E-04,   2.7250763E-04
     +,   2.7186202E-04,   2.7129316E-04,   2.7080587E-04
     +,   2.7040296E-04,   2.7008506E-04,   2.6985072E-04
     +,   2.6969626E-04,   2.6961585E-04,   2.6960176E-04
     +,   2.6964434E-04,   2.6973191E-04,   2.6985159E-04
     +,   2.6998867E-04,   2.7012746E-04,   2.7025107E-04
     +,   2.7034184E-04,   2.7038169E-04,   2.7035188E-04
     +,   2.7023407E-04,   2.7000965E-04,   2.6966073E-04
     +,   2.6916986E-04,   2.6852053E-04,   2.6769729E-04
     +,   2.6668611E-04,   2.6547411E-04,   2.6405029E-04
     +,   2.6240520E-04,   2.6053147E-04,   2.5842327E-04
     +,   2.5607736E-04,   2.5349198E-04,   2.5066762E-04
     +,   2.4760709E-04,   2.4431484E-04,   2.4079767E-04
     +,   2.3706422E-04,   2.3312467E-04,   2.2899157E-04
     +,   2.2467850E-04,   2.2020092E-04,   2.1557590E-04
     +,   2.1082154E-04,   2.0595685E-04,   2.0100243E-04
     +,   1.9597905E-04,   1.9090873E-04,   1.8581390E-04
     +,   1.8071708E-04,   1.7564144E-04,   1.7061016E-04
     +,   1.6564604E-04,   1.6077218E-04,   1.5601114E-04
     +,   1.5138471E-04,   1.4691455E-04,   1.4262165E-04
     +,   1.3852546E-04,   1.3464513E-04,   1.3099860E-04
     +,   1.2760263E-04,   1.2447234E-04,   1.2162206E-04
     +,   1.1906404E-04,   1.1680955E-04,   1.1486789E-04
     +,   1.1324690E-04,   1.1195247E-04,   1.1098883E-04
     +,   1.1035845E-04,   1.1006191E-04,   1.1009799E-04
     +,   1.1046359E-04,   1.1115373E-04,   1.1216176E-04
     +,   1.1347912E-04,   1.1509568E-04,   1.1699933E-04
     +,   1.1917671E-04,   1.2161285E-04,   1.2429120E-04
     +,   1.2719397E-04,   1.3030216E-04,   1.3359547E-04
     +,   1.3705305E-04,   1.4065267E-04,   1.4437197E-04
     +,   1.4818748E-04,   1.5207553E-04,   1.5601225E-04
     +,   1.5997322E-04,   1.6393469E-04,   1.6787281E-04
     +,   1.7176387E-04,   1.7558476E-04,   1.7931282E-04
     +,   1.8292647E-04,   1.8640488E-04,   1.8972818E-04
     +,   1.9287753E-04,   1.9583546E-04,   1.9858574E-04
     +,   2.0111371E-04,   2.0340638E-04,   2.0545204E-04
     +,   2.0724074E-04,   2.0876431E-04,   2.1001627E-04
     +,   2.1099202E-04,   2.1168873E-04,   2.1210535E-04
     +,   2.1224254E-04,   2.1210287E-04,   2.1169057E-04
     +,   2.1101149E-04,   2.1007321E-04,   2.0888477E-04
     +,   2.0745675E-04,   2.0580101E-04,   2.0393058E-04
     +,   2.0185993E-04,   1.9960412E-04,   1.9717937E-04
     +,   1.9460257E-04,   1.9189116E-04,   1.8906312E-04
     +,   1.8613657E-04,   1.8312973E-04,   1.8006093E-04
     +,   1.7694839E-04,   1.7381000E-04,   1.7066281E-04
     +,   1.6752393E-04,   1.6440911E-04,   1.6133365E-04
     +,   1.5831183E-04,   1.5535695E-04,   1.5248092E-04
     +,   1.4969455E-04,   1.4700752E-04,   1.4442811E-04
     +,   1.4196323E-04,   1.3961854E-04,   1.3739811E-04
     +,   1.3530470E-04,   1.3333987E-04,   1.3150385E-04
     +,   1.2979555E-04,   1.2821260E-04,   1.2675161E-04
     +,   1.2540820E-04,   1.2417685E-04,   1.2305123E-04
     +,   1.2202425E-04,   1.2108809E-04,   1.2023445E-04
     +,   1.1945442E-04,   1.1873880E-04,   1.1807815E-04
     +,   1.1746281E-04,   1.1688311E-04,   1.1632938E-04
     +,   1.1579211E-04,   1.1526191E-04,   1.1472988E-04
     +,   1.1418726E-04,   1.1362592E-04,   1.1303806E-04
     +,   1.1241651E-04,   1.1175461E-04,   1.1104636E-04
     +,   1.1028650E-04,   1.0947025E-04,   1.0859353E-04
     +,   1.0765303E-04,   1.0664608E-04,   1.0557065E-04
     +,   1.0442542E-04,   1.0320962E-04,   1.0192308E-04
     +,   1.0056629E-04,   9.9140234E-05,   9.7646436E-05
     +,   9.6086966E-05,   9.4464114E-05,   9.2780851E-05
     +,   9.1040209E-05,   8.9245739E-05,   8.7401255E-05
     +,   8.5510896E-05,   8.3578561E-05,   8.1608741E-05
     +,   7.9605925E-05,   7.7574630E-05,   7.5519543E-05
     +,   7.3445117E-05,   7.1356088E-05,   6.9256836E-05
     +,   6.7151908E-05,   6.5045693E-05,   6.2942418E-05
     +,   6.0846389E-05,   5.8761230E-05,   5.6690904E-05
     +,   5.4639026E-05,   5.2609030E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_nwao_hz_60 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_nwao_hz_65(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  4.4267922E-06,   4.7661865E-06
     +,   5.1257543E-06,   5.5061741E-06,   5.9081299E-06
     +,   6.3322891E-06,   6.7792712E-06,   7.2496923E-06
     +,   7.7441418E-06,   8.2631477E-06,   8.8072275E-06
     +,   9.3768476E-06,   9.9724475E-06,   1.0594381E-05
     +,   1.1242983E-05,   1.1918547E-05,   1.2621258E-05
     +,   1.3351288E-05,   1.4108753E-05,   1.4893650E-05
     +,   1.5705968E-05,   1.6545617E-05,   1.7412392E-05
     +,   1.8306077E-05,   1.9226369E-05,   2.0172847E-05
     +,   2.1145068E-05,   2.2142525E-05,   2.3164561E-05
     +,   2.4210509E-05,   2.5279636E-05,   2.6371070E-05
     +,   2.7483911E-05,   2.8617211E-05,   2.9769863E-05
     +,   3.0940759E-05,   3.2128726E-05,   3.3332431E-05
     +,   3.4550576E-05,   3.5781723E-05,   3.7024423E-05
     +,   3.8277070E-05,   3.9538088E-05,   4.0805782E-05
     +,   4.2078442E-05,   4.3354219E-05,   4.4631299E-05
     +,   4.5907724E-05,   4.7181558E-05,   4.8450805E-05
     +,   4.9713450E-05,   5.0967366E-05,   5.2210500E-05
     +,   5.3440766E-05,   5.4656019E-05,   5.5854180E-05
     +,   5.7033219E-05,   5.8191064E-05,   5.9325776E-05
     +,   6.0435483E-05,   6.1518353E-05,   6.2572741E-05
     +,   6.3597137E-05,   6.4590153E-05,   6.5550652E-05
     +,   6.6477704E-05,   6.7370580E-05,   6.8228874E-05
     +,   6.9052498E-05,   6.9841619E-05,   7.0596798E-05
     +,   7.1318995E-05,   7.2009512E-05,   7.2670082E-05
     +,   7.3302872E-05,   7.3910429E-05,   7.4495816E-05
     +,   7.5062460E-05,   7.5614247E-05,   7.6155535E-05
     +,   7.6691031E-05,   7.7225821E-05,   7.7765435E-05
     +,   7.8315665E-05,   7.8882636E-05,   7.9472738E-05
     +,   8.0092563E-05,   8.0748971E-05,   8.1448859E-05
     +,   8.2199280E-05,   8.3007311E-05,   8.3880113E-05
     +,   8.4824722E-05,   8.5848173E-05,   8.6957443E-05
     +,   8.8159286E-05,   8.9460344E-05,   9.0867208E-05
     +,   9.2386079E-05,   9.4023235E-05,   9.5784555E-05
     +,   9.7675787E-05,   9.9702433E-05,   1.0187003E-04
     +,   1.0418356E-04,   1.0664824E-04,   1.0926872E-04
     +,   1.1204958E-04,   1.1499504E-04,   1.1810933E-04
     +,   1.2139591E-04,   1.2485839E-04,   1.2849939E-04
     +,   1.3232121E-04,   1.3632524E-04,   1.4051249E-04
     +,   1.4488242E-04,   1.4943404E-04,   1.5416450E-04
     +,   1.5906953E-04,   1.6414376E-04,   1.6937919E-04
     +,   1.7476671E-04,   1.8029456E-04,   1.8594885E-04
     +,   1.9171322E-04,   1.9756953E-04,   2.0349676E-04
     +,   2.0947147E-04,   2.1546861E-04,   2.2146048E-04
     +,   2.2741753E-04,   2.3330924E-04,   2.3910288E-04
     +,   2.4476580E-04,   2.5026422E-04,   2.5556443E-04
     +,   2.6063318E-04,   2.6543866E-04,   2.6994976E-04
     +,   2.7413835E-04,   2.7797805E-04,   2.8144562E-04
     +,   2.8452155E-04,   2.8718985E-04,   2.8943858E-04
     +,   2.9126057E-04,   2.9265281E-04,   2.9361711E-04
     +,   2.9416001E-04,   2.9429287E-04,   2.9403143E-04
     +,   2.9339569E-04,   2.9241008E-04,   2.9110262E-04
     +,   2.8950488E-04,   2.8765120E-04,   2.8557869E-04
     +,   2.8332649E-04,   2.8093526E-04,   2.7844662E-04
     +,   2.7590271E-04,   2.7334530E-04,   2.7081533E-04
     +,   2.6835289E-04,   2.6599574E-04,   2.6377945E-04
     +,   2.6173645E-04,   2.5989569E-04,   2.5828200E-04
     +,   2.5691598E-04,   2.5581341E-04,   2.5498477E-04
     +,   2.5443541E-04,   2.5416506E-04,   2.5416774E-04
     +,   2.5443212E-04,   2.5494143E-04,   2.5567360E-04
     +,   2.5660187E-04,   2.5769489E-04,   2.5891772E-04
     +,   2.6023199E-04,   2.6159696E-04,   2.6296990E-04
     +,   2.6430728E-04,   2.6556570E-04,   2.6670229E-04
     +,   2.6767590E-04,   2.6844771E-04,   2.6898235E-04
     +,   2.6924841E-04,   2.6921905E-04,   2.6887257E-04
     +,   2.6819314E-04,   2.6717086E-04,   2.6580217E-04
     +,   2.6408996E-04,   2.6204321E-04,   2.5967765E-04
     +,   2.5701470E-04,   2.5408177E-04,   2.5091154E-04
     +,   2.4754109E-04,   2.4401146E-04,   2.4036744E-04
     +,   2.3665608E-04,   2.3292619E-04,   2.2922707E-04
     +,   2.2560779E-04,   2.2211685E-04,   2.1880033E-04
     +,   2.1570147E-04,   2.1285997E-04,   2.1031061E-04
     +,   2.0808337E-04,   2.0620190E-04,   2.0468395E-04
     +,   2.0354039E-04,   2.0277506E-04,   2.0238486E-04
     +,   2.0235947E-04,   2.0268190E-04,   2.0332850E-04
     +,   2.0426954E-04,   2.0546978E-04,   2.0688931E-04
     +,   2.0848386E-04,   2.1020634E-04,   2.1200710E-04
     +,   2.1383524E-04,   2.1563955E-04,   2.1736934E-04
     +,   2.1897549E-04,   2.2041114E-04,   2.2163254E-04
     +,   2.2259976E-04,   2.2327741E-04,   2.2363487E-04
     +,   2.2364692E-04,   2.2329365E-04,   2.2256098E-04
     +,   2.2144035E-04,   2.1992877E-04,   2.1802845E-04
     +,   2.1574684E-04,   2.1309557E-04,   2.1009088E-04
     +,   2.0675248E-04,   2.0310302E-04,   1.9916812E-04
     +,   1.9497485E-04,   1.9055211E-04,   1.8592957E-04
     +,   1.8113723E-04,   1.7620529E-04,   1.7116281E-04
     +,   1.6603815E-04,   1.6085860E-04,   1.5564983E-04
     +,   1.5043579E-04,   1.4523866E-04,   1.4007816E-04
     +,   1.3497203E-04,   1.2993607E-04,   1.2498400E-04
     +,   1.2012762E-04,   1.1537632E-04,   1.1073768E-04
     +,   1.0621796E-04,   1.0182156E-04,   9.7551514E-05
     +,   9.3409682E-05,   8.9396519E-05,   8.5511463E-05
     +,   8.1753467E-05,   7.8120676E-05,   7.4610638E-05
     +,   7.1220697E-05,   6.7947425E-05,   6.4787731E-05
     +,   6.1737934E-05,   5.8794685E-05,   5.5954530E-05
     +,   5.3214342E-05,   5.0570456E-05,   4.8020036E-05
     +,   4.5560184E-05,   4.3188240E-05,   4.0901807E-05
     +,   3.8698428E-05,   3.6576199E-05,   3.4533063E-05
     +,   3.2567361E-05,   3.0677529E-05,   2.8862101E-05
     +,   2.7119875E-05,   2.5449302E-05,   2.3849325E-05
     +,   2.2318774E-05,   2.0856492E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_nwao_hz_65 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_nwao_hz_70(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  1.6919650E-08,   1.9796740E-08
     +,   2.3124825E-08,   2.6967735E-08,   3.1397487E-08
     +,   3.6494939E-08,   4.2350361E-08,   4.9064916E-08
     +,   5.6751659E-08,   6.5535836E-08,   7.5557146E-08
     +,   8.6970296E-08,   9.9946710E-08,   1.1467497E-07
     +,   1.3136362E-07,   1.5024212E-07,   1.7156128E-07
     +,   1.9559685E-07,   2.2265039E-07,   2.5304934E-07
     +,   2.8715181E-07,   3.2534700E-07,   3.6805497E-07
     +,   4.1573233E-07,   4.6887240E-07,   5.2800402E-07
     +,   5.9369904E-07,   6.6657213E-07,   7.4727689E-07
     +,   8.3651736E-07,   9.3504485E-07,   1.0436535E-06
     +,   1.1631939E-06,   1.2945682E-06,   1.4387233E-06
     +,   1.5966690E-06,   1.7694689E-06,   1.9582319E-06
     +,   2.1641322E-06,   2.3883963E-06,   2.6323105E-06
     +,   2.8972017E-06,   3.1844625E-06,   3.4955349E-06
     +,   3.8319185E-06,   4.1951357E-06,   4.5867864E-06
     +,   5.0084795E-06,   5.4618822E-06,   5.9486897E-06
     +,   6.4706278E-06,   7.0294172E-06,   7.6268175E-06
     +,   8.2645956E-06,   8.9444775E-06,   9.6682079E-06
     +,   1.0437512E-05,   1.1254026E-05,   1.2119386E-05
     +,   1.3035164E-05,   1.4002794E-05,   1.5023668E-05
     +,   1.6099069E-05,   1.7230088E-05,   1.8417719E-05
     +,   1.9662803E-05,   2.0965901E-05,   2.2327456E-05
     +,   2.3747665E-05,   2.5226398E-05,   2.6763339E-05
     +,   2.8357834E-05,   3.0008965E-05,   3.1715375E-05
     +,   3.3475484E-05,   3.5287179E-05,   3.7148206E-05
     +,   3.9055696E-05,   4.1006369E-05,   4.2996766E-05
     +,   4.5022756E-05,   4.7079808E-05,   4.9163184E-05
     +,   5.1267507E-05,   5.3386968E-05,   5.5515626E-05
     +,   5.7646819E-05,   5.9773880E-05,   6.1889557E-05
     +,   6.3986379E-05,   6.6056535E-05,   6.8092253E-05
     +,   7.0085349E-05,   7.2027498E-05,   7.3910574E-05
     +,   7.5726202E-05,   7.7466088E-05,   7.9122256E-05
     +,   8.0686681E-05,   8.2151877E-05,   8.3510502E-05
     +,   8.4755738E-05,   8.5881249E-05,   8.6881402E-05
     +,   8.7751127E-05,   8.8486246E-05,   8.9083347E-05
     +,   8.9540023E-05,   8.9854861E-05,   9.0027592E-05
     +,   9.0059111E-05,   8.9951594E-05,   8.9708497E-05
     +,   8.9334731E-05,   8.8836561E-05,   8.8221743E-05
     +,   8.7499553E-05,   8.6680695E-05,   8.5777378E-05
     +,   8.4803345E-05,   8.3773579E-05,   8.2704544E-05
     +,   8.1613733E-05,   8.0519865E-05,   7.9442558E-05
     +,   7.8402169E-05,   7.7419434E-05,   7.6515513E-05
     +,   7.5711549E-05,   7.5028285E-05,   7.4485979E-05
     +,   7.4103977E-05,   7.3900315E-05,   7.3891591E-05
     +,   7.4092553E-05,   7.4515832E-05,   7.5171767E-05
     +,   7.6068136E-05,   7.7210228E-05,   7.8600497E-05
     +,   8.0238984E-05,   8.2123115E-05,   8.4247979E-05
     +,   8.6607077E-05,   8.9192225E-05,   9.1994269E-05
     +,   9.5004252E-05,   9.8213372E-05,   1.0161423E-04
     +,   1.0520208E-04,   1.0897489E-04,   1.1293474E-04
     +,   1.1708898E-04,   1.2145026E-04,   1.2603753E-04
     +,   1.3087623E-04,   1.3599923E-04,   1.4144534E-04
     +,   1.4726035E-04,   1.5349491E-04,   1.6020416E-04
     +,   1.6744548E-04,   1.7527746E-04,   1.8375710E-04
     +,   1.9293644E-04,   2.0286048E-04,   2.1356391E-04
     +,   2.2506756E-04,   2.3737669E-04,   2.5047737E-04
     +,   2.6433289E-04,   2.7888358E-04,   2.9404374E-04
     +,   3.0970367E-04,   3.2572815E-04,   3.4195677E-04
     +,   3.5820759E-04,   3.7428027E-04,   3.8995873E-04
     +,   4.0501921E-04,   4.1923119E-04,   4.3236808E-04
     +,   4.4420979E-04,   4.5455139E-04,   4.6320888E-04
     +,   4.7002436E-04,   4.7487259E-04,   4.7766400E-04
     +,   4.7834765E-04,   4.7691370E-04,   4.7339487E-04
     +,   4.6786387E-04,   4.6043226E-04,   4.5124770E-04
     +,   4.4048898E-04,   4.2836095E-04,   4.1508875E-04
     +,   4.0091033E-04,   3.8607066E-04,   3.7081627E-04
     +,   3.5538760E-04,   3.4001376E-04,   3.2490809E-04
     +,   3.1026232E-04,   2.9624446E-04,   2.8299753E-04
     +,   2.7063687E-04,   2.5925011E-04,   2.4889666E-04
     +,   2.3961000E-04,   2.3139987E-04,   2.2425345E-04
     +,   2.1813865E-04,   2.1300683E-04,   2.0879506E-04
     +,   2.0543073E-04,   2.0283271E-04,   2.0091524E-04
     +,   1.9958970E-04,   1.9876704E-04,   1.9835957E-04
     +,   1.9828246E-04,   1.9845500E-04,   1.9880172E-04
     +,   1.9925270E-04,   1.9974446E-04,   2.0021983E-04
     +,   2.0062820E-04,   2.0092539E-04,   2.0107349E-04
     +,   2.0104050E-04,   2.0080020E-04,   2.0033169E-04
     +,   1.9961885E-04,   1.9865045E-04,   1.9741929E-04
     +,   1.9592220E-04,   1.9415967E-04,   1.9213535E-04
     +,   1.8985593E-04,   1.8733094E-04,   1.8457237E-04
     +,   1.8159454E-04,   1.7841344E-04,   1.7504697E-04
     +,   1.7151462E-04,   1.6783649E-04,   1.6403392E-04
     +,   1.6012875E-04,   1.5614259E-04,   1.5209749E-04
     +,   1.4801441E-04,   1.4391408E-04,   1.3981597E-04
     +,   1.3573832E-04,   1.3169793E-04,   1.2770973E-04
     +,   1.2378661E-04,   1.1994001E-04,   1.1617912E-04
     +,   1.1251122E-04,   1.0894173E-04,   1.0547394E-04
     +,   1.0210944E-04,   9.8848461E-05,   9.5689742E-05
     +,   9.2630886E-05,   8.9668261E-05,   8.6797438E-05
     +,   8.4013627E-05,   8.1311548E-05,   7.8685691E-05
     +,   7.6130600E-05,   7.3640724E-05,   7.1210787E-05
     +,   6.8836023E-05,   6.6512010E-05,   6.4234759E-05
     +,   6.2000960E-05,   5.9807546E-05,   5.7652349E-05
     +,   5.5533408E-05,   5.3449490E-05,   5.1399784E-05
     +,   4.9384063E-05,   4.7401998E-05,   4.5454090E-05
     +,   4.3540964E-05,   4.1663458E-05,   3.9822688E-05
     +,   3.8019662E-05,   3.6255780E-05,   3.4532204E-05
     +,   3.2850297E-05,   3.1211344E-05,   2.9616576E-05
     +,   2.8067239E-05,   2.6564134E-05,   2.5108300E-05
     +,   2.3700530E-05,   2.2341454E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_nwao_hz_70 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_nwao_hz_75(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  4.3300411E-06,   4.4809453E-06
     +,   4.6344676E-06,   4.7905141E-06,   4.9489950E-06
     +,   5.1098100E-06,   5.2728465E-06,   5.4379911E-06
     +,   5.6051290E-06,   5.7741227E-06,   5.9448425E-06
     +,   6.1171481E-06,   6.2908966E-06,   6.4659307E-06
     +,   6.6420980E-06,   6.8192394E-06,   6.9971843E-06
     +,   7.1757686E-06,   7.3548231E-06,   7.5341677E-06
     +,   7.7136319E-06,   7.8930416E-06,   8.0722157E-06
     +,   8.2509814E-06,   8.4291696E-06,   8.6066029E-06
     +,   8.7831222E-06,   8.9585646E-06,   9.1327729E-06
     +,   9.3056060E-06,   9.4769248E-06,   9.6465992E-06
     +,   9.8145165E-06,   9.9805811E-06,   1.0144703E-05
     +,   1.0306816E-05,   1.0466875E-05,   1.0624847E-05
     +,   1.0780732E-05,   1.0934546E-05,   1.1086346E-05
     +,   1.1236199E-05,   1.1384220E-05,   1.1530548E-05
     +,   1.1675368E-05,   1.1818889E-05,   1.1961375E-05
     +,   1.2103120E-05,   1.2244474E-05,   1.2385828E-05
     +,   1.2527632E-05,   1.2670370E-05,   1.2814603E-05
     +,   1.2960933E-05,   1.3110025E-05,   1.3262604E-05
     +,   1.3419463E-05,   1.3581445E-05,   1.3749474E-05
     +,   1.3924539E-05,   1.4107676E-05,   1.4300019E-05
     +,   1.4502752E-05,   1.4717129E-05,   1.4944471E-05
     +,   1.5186177E-05,   1.5443693E-05,   1.5718539E-05
     +,   1.6012291E-05,   1.6326578E-05,   1.6663076E-05
     +,   1.7023516E-05,   1.7409669E-05,   1.7823306E-05
     +,   1.8266261E-05,   1.8740328E-05,   1.9247356E-05
     +,   1.9789137E-05,   2.0367423E-05,   2.0983987E-05
     +,   2.1640477E-05,   2.2338450E-05,   2.3079439E-05
     +,   2.3864784E-05,   2.4695668E-05,   2.5573205E-05
     +,   2.6498179E-05,   2.7471300E-05,   2.8492936E-05
     +,   2.9563214E-05,   3.0681942E-05,   3.1848718E-05
     +,   3.3062701E-05,   3.4322678E-05,   3.5627199E-05
     +,   3.6974299E-05,   3.8361573E-05,   3.9786417E-05
     +,   4.1245559E-05,   4.2735566E-05,   4.4252414E-05
     +,   4.5791774E-05,   4.7348876E-05,   4.8918813E-05
     +,   5.0496154E-05,   5.2075444E-05,   5.3650852E-05
     +,   5.5216511E-05,   5.6766406E-05,   5.8294750E-05
     +,   5.9795620E-05,   6.1263556E-05,   6.2693201E-05
     +,   6.4079701E-05,   6.5418637E-05,   6.6706423E-05
     +,   6.7939960E-05,   6.9117195E-05,   7.0236863E-05
     +,   7.1298717E-05,   7.2303752E-05,   7.3253927E-05
     +,   7.4152551E-05,   7.5004027E-05,   7.5813965E-05
     +,   7.6589167E-05,   7.7337638E-05,   7.8068297E-05
     +,   7.8791018E-05,   7.9516511E-05,   8.0256097E-05
     +,   8.1021542E-05,   8.1824925E-05,   8.2678380E-05
     +,   8.3593957E-05,   8.4583393E-05,   8.5657884E-05
     +,   8.6827989E-05,   8.8103647E-05,   8.9493733E-05
     +,   9.1006434E-05,   9.2648923E-05,   9.4427502E-05
     +,   9.6347954E-05,   9.8415381E-05,   1.0063447E-04
     +,   1.0301010E-04,   1.0554711E-04,   1.0825080E-04
     +,   1.1112755E-04,   1.1418447E-04,   1.1742996E-04
     +,   1.2087423E-04,   1.2452858E-04,   1.2840611E-04
     +,   1.3252116E-04,   1.3688994E-04,   1.4152906E-04
     +,   1.4645664E-04,   1.5169063E-04,   1.5724936E-04
     +,   1.6315060E-04,   1.6941203E-04,   1.7605061E-04
     +,   1.8308200E-04,   1.9052110E-04,   1.9838203E-04
     +,   2.0667800E-04,   2.1542222E-04,   2.2462779E-04
     +,   2.3430651E-04,   2.4447014E-04,   2.5512886E-04
     +,   2.6629170E-04,   2.7796451E-04,   2.9014741E-04
     +,   3.0283348E-04,   3.1600651E-04,   3.2963711E-04
     +,   3.4368239E-04,   3.5807985E-04,   3.7274935E-04
     +,   3.8758808E-04,   4.0247245E-04,   4.1725877E-04
     +,   4.3178417E-04,   4.4587336E-04,   4.5934209E-04
     +,   4.7200185E-04,   4.8367103E-04,   4.9418019E-04
     +,   5.0338311E-04,   5.1116326E-04,   5.1744014E-04
     +,   5.2217627E-04,   5.2538031E-04,   5.2710855E-04
     +,   5.2746327E-04,   5.2658864E-04,   5.2466511E-04
     +,   5.2189949E-04,   5.1851559E-04,   5.1474181E-04
     +,   5.1079970E-04,   5.0689158E-04,   5.0319091E-04
     +,   4.9983262E-04,   4.9690716E-04,   4.9445563E-04
     +,   4.9247034E-04,   4.9089669E-04,   4.8963760E-04
     +,   4.8856129E-04,   4.8751090E-04,   4.8631459E-04
     +,   4.8479741E-04,   4.8279131E-04,   4.8014618E-04
     +,   4.7673774E-04,   4.7247458E-04,   4.6730269E-04
     +,   4.6120639E-04,   4.5420844E-04,   4.4636775E-04
     +,   4.3777347E-04,   4.2854054E-04,   4.1879941E-04
     +,   4.0869167E-04,   3.9835941E-04,   3.8794044E-04
     +,   3.7755986E-04,   3.6732657E-04,   3.5732769E-04
     +,   3.4762750E-04,   3.3826713E-04,   3.2926424E-04
     +,   3.2061539E-04,   3.1229886E-04,   3.0427778E-04
     +,   2.9650485E-04,   2.8892644E-04,   2.8148678E-04
     +,   2.7413166E-04,   2.6681085E-04,   2.5948268E-04
     +,   2.5211481E-04,   2.4468507E-04,   2.3718318E-04
     +,   2.2961048E-04,   2.2197769E-04,   2.1430610E-04
     +,   2.0662350E-04,   1.9896466E-04,   1.9136790E-04
     +,   1.8387359E-04,   1.7652252E-04,   1.6935341E-04
     +,   1.6240176E-04,   1.5569932E-04,   1.4927237E-04
     +,   1.4314133E-04,   1.3732053E-04,   1.3181767E-04
     +,   1.2663436E-04,   1.2176699E-04,   1.1720673E-04
     +,   1.1294036E-04,   1.0895087E-04,   1.0521834E-04
     +,   1.0172127E-04,   9.8436649E-05,   9.5341093E-05
     +,   9.2411363E-05,   8.9624737E-05,   8.6959648E-05
     +,   8.4396263E-05,   8.1916442E-05,   7.9504032E-05
     +,   7.7144992E-05,   7.4827127E-05,   7.2540664E-05
     +,   7.0277492E-05,   6.8031557E-05,   6.5798500E-05
     +,   6.3575630E-05,   6.1361141E-05,   5.9154918E-05
     +,   5.6957710E-05,   5.4771110E-05,   5.2597454E-05
     +,   5.0439372E-05,   4.8300230E-05,   4.6183330E-05
     +,   4.4092401E-05,   4.2031152E-05,   4.0003299E-05
     +,   3.8012626E-05,   3.6062338E-05,   3.4155895E-05
     +,   3.2296430E-05,   3.0486797E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_nwao_hz_75 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_nwao_hz_80(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  6.9837007E-08,   7.8535216E-08
     +,   8.8216517E-08,   9.8978198E-08,   1.1092649E-07
     +,   1.2417598E-07,   1.3884980E-07,   1.5508118E-07
     +,   1.7301363E-07,   1.9280000E-07,   2.1460532E-07
     +,   2.3860576E-07,   2.6498984E-07,   2.9395710E-07
     +,   3.2572106E-07,   3.6050906E-07,   3.9855956E-07
     +,   4.4012691E-07,   4.8548009E-07,   5.3489913E-07
     +,   5.8868176E-07,   6.4713981E-07,   7.1059691E-07
     +,   7.7939342E-07,   8.5388518E-07,   9.3443674E-07
     +,   1.0214311E-06,   1.1152640E-06,   1.2163382E-06
     +,   1.3250730E-06,   1.4418990E-06,   1.5672493E-06
     +,   1.7015723E-06,   1.8453228E-06,   1.9989534E-06
     +,   2.1629282E-06,   2.3377133E-06,   2.5237648E-06
     +,   2.7215444E-06,   2.9315090E-06,   3.1541088E-06
     +,   3.3897722E-06,   3.6389279E-06,   3.9019824E-06
     +,   4.1793301E-06,   4.4713274E-06,   4.7783237E-06
     +,   5.1006195E-06,   5.4384982E-06,   5.7922016E-06
     +,   6.1619398E-06,   6.5478575E-06,   6.9500720E-06
     +,   7.3686529E-06,   7.8035910E-06,   8.2548468E-06
     +,   8.7223161E-06,   9.2058081E-06,   9.7050925E-06
     +,   1.0219868E-05,   1.0749735E-05,   1.1294252E-05
     +,   1.1852896E-05,   1.2425042E-05,   1.3010018E-05
     +,   1.3607073E-05,   1.4215344E-05,   1.4833926E-05
     +,   1.5461834E-05,   1.6097969E-05,   1.6741200E-05
     +,   1.7390308E-05,   1.8044015E-05,   1.8700939E-05
     +,   1.9359690E-05,   2.0018753E-05,   2.0676645E-05
     +,   2.1331767E-05,   2.1982471E-05,   2.2627148E-05
     +,   2.3264083E-05,   2.3891544E-05,   2.4507855E-05
     +,   2.5111256E-05,   2.5699990E-05,   2.6272381E-05
     +,   2.6826674E-05,   2.7361233E-05,   2.7874386E-05
     +,   2.8364540E-05,   2.8830118E-05,   2.9269675E-05
     +,   2.9681791E-05,   3.0065105E-05,   3.0418421E-05
     +,   3.0740597E-05,   3.1030606E-05,   3.1287582E-05
     +,   3.1510768E-05,   3.1699587E-05,   3.1853629E-05
     +,   3.1972657E-05,   3.2056658E-05,   3.2105872E-05
     +,   3.2120759E-05,   3.2102107E-05,   3.2050990E-05
     +,   3.1968859E-05,   3.1857580E-05,   3.1719432E-05
     +,   3.1557243E-05,   3.1374337E-05,   3.1174714E-05
     +,   3.0963027E-05,   3.0744715E-05,   3.0526011E-05
     +,   3.0314088E-05,   3.0117071E-05,   2.9944164E-05
     +,   2.9805686E-05,   2.9713125E-05,   2.9679235E-05
     +,   2.9718012E-05,   2.9844772E-05,   3.0076098E-05
     +,   3.0429823E-05,   3.0925028E-05,   3.1581862E-05
     +,   3.2421423E-05,   3.3465712E-05,   3.4737230E-05
     +,   3.6258763E-05,   3.8053306E-05,   4.0143259E-05
     +,   4.2550608E-05,   4.5295965E-05,   4.8398419E-05
     +,   5.1874878E-05,   5.5740118E-05,   6.0005412E-05
     +,   6.4679240E-05,   6.9765912E-05,   7.5265634E-05
     +,   8.1175072E-05,   8.7486063E-05,   9.4186216E-05
     +,   1.0126006E-04,   1.0868784E-04,   1.1644696E-04
     +,   1.2451346E-04,   1.3286136E-04,   1.4146416E-04
     +,   1.5029711E-04,   1.5933617E-04,   1.6856004E-04
     +,   1.7795051E-04,   1.8749408E-04,   1.9717970E-04
     +,   2.0700156E-04,   2.1695576E-04,   2.2704074E-04
     +,   2.3725517E-04,   2.4759723E-04,   2.5806183E-04
     +,   2.6863787E-04,   2.7930713E-04,   2.9004240E-04
     +,   3.0080529E-04,   3.1154737E-04,   3.2220886E-04
     +,   3.3271886E-04,   3.4299819E-04,   3.5296113E-04
     +,   3.6251976E-04,   3.7158630E-04,   3.8007624E-04
     +,   3.8791369E-04,   3.9503342E-04,   4.0138452E-04
     +,   4.0693308E-04,   4.1166239E-04,   4.1557621E-04
     +,   4.1869777E-04,   4.2107163E-04,   4.2276378E-04
     +,   4.2386190E-04,   4.2447759E-04,   4.2474587E-04
     +,   4.2482786E-04,   4.2490952E-04,   4.2520347E-04
     +,   4.2594620E-04,   4.2739505E-04,   4.2982280E-04
     +,   4.3350874E-04,   4.3872817E-04,   4.4573791E-04
     +,   4.5476184E-04,   4.6597308E-04,   4.7947577E-04
     +,   4.9528899E-04,   5.1333243E-04,   5.3341495E-04
     +,   5.5523100E-04,   5.7836098E-04,   6.0227601E-04
     +,   6.2635756E-04,   6.4991933E-04,   6.7224004E-04
     +,   6.9259823E-04,   7.1031065E-04,   7.2477490E-04
     +,   7.3550711E-04,   7.4217579E-04,   7.4462505E-04
     +,   7.4288936E-04,   7.3719345E-04,   7.2793808E-04
     +,   7.1567681E-04,   7.0107752E-04,   6.8487739E-04
     +,   6.6783145E-04,   6.5066374E-04,   6.3402276E-04
     +,   6.1843952E-04,   6.0430344E-04,   5.9184304E-04
     +,   5.8112817E-04,   5.7207776E-04,   5.6448230E-04
     +,   5.5803271E-04,   5.5235438E-04,   5.4704113E-04
     +,   5.4168986E-04,   5.3592998E-04,   5.2944530E-04
     +,   5.2199076E-04,   5.1340082E-04,   5.0359016E-04
     +,   4.9254991E-04,   4.8033911E-04,   4.6707262E-04
     +,   4.5290709E-04,   4.3802621E-04,   4.2262982E-04
     +,   4.0692111E-04,   3.9109564E-04,   3.7533636E-04
     +,   3.5980780E-04,   3.4464992E-04,   3.2998109E-04
     +,   3.1589359E-04,   3.0245760E-04,   2.8972080E-04
     +,   2.7771111E-04,   2.6643914E-04,   2.5589895E-04
     +,   2.4607181E-04,   2.3692851E-04,   2.2843039E-04
     +,   2.2053144E-04,   2.1318054E-04,   2.0632155E-04
     +,   1.9989602E-04,   1.9384459E-04,   1.8810750E-04
     +,   1.8262629E-04,   1.7734434E-04,   1.7220825E-04
     +,   1.6716930E-04,   1.6218351E-04,   1.5721269E-04
     +,   1.5222510E-04,   1.4719523E-04,   1.4210443E-04
     +,   1.3694118E-04,   1.3170045E-04,   1.2638343E-04
     +,   1.2099725E-04,   1.1555351E-04,   1.1006894E-04
     +,   1.0456295E-04,   9.9058248E-05,   9.3579016E-05
     +,   8.8150889E-05,   8.2798244E-05,   7.7546167E-05
     +,   7.2418065E-05,   6.7435547E-05,   6.2618172E-05
     +,   5.7982397E-05,   5.3542633E-05,   4.9309714E-05
     +,   4.5292101E-05,   4.1495245E-05,   3.7921898E-05
     +,   3.4572564E-05,   3.1444695E-05,   2.8534545E-05
     +,   2.5836373E-05,   2.3343002E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_nwao_hz_80 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_nwao_hz_85(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  2.7948354E-06,   2.9078769E-06
     +,   3.0239344E-06,   3.1430156E-06,   3.2651321E-06
     +,   3.3902945E-06,   3.5185030E-06,   3.6497663E-06
     +,   3.7840891E-06,   3.9214679E-06,   4.0619070E-06
     +,   4.2054071E-06,   4.3519694E-06,   4.5015900E-06
     +,   4.6542709E-06,   4.8100169E-06,   4.9688224E-06
     +,   5.1306934E-06,   5.2956375E-06,   5.4636571E-06
     +,   5.6347617E-06,   5.8089686E-06,   5.9862869E-06
     +,   6.1667388E-06,   6.3503526E-06,   6.5371496E-06
     +,   6.7271685E-06,   6.9204539E-06,   7.1170448E-06
     +,   7.3169990E-06,   7.5203830E-06,   7.7272580E-06
     +,   7.9377078E-06,   8.1518265E-06,   8.3697023E-06
     +,   8.5914498E-06,   8.8171946E-06,   9.0470621E-06
     +,   9.2811997E-06,   9.5197720E-06,   9.7629536E-06
     +,   1.0010927E-05,   1.0263903E-05,   1.0522106E-05
     +,   1.0785777E-05,   1.1055168E-05,   1.1330569E-05
     +,   1.1612268E-05,   1.1900594E-05,   1.2195890E-05
     +,   1.2498531E-05,   1.2808897E-05,   1.3127412E-05
     +,   1.3454528E-05,   1.3790705E-05,   1.4136447E-05
     +,   1.4492295E-05,   1.4858791E-05,   1.5236527E-05
     +,   1.5626134E-05,   1.6028243E-05,   1.6443533E-05
     +,   1.6872726E-05,   1.7316528E-05,   1.7775714E-05
     +,   1.8251074E-05,   1.8743389E-05,   1.9253497E-05
     +,   1.9782245E-05,   2.0330461E-05,   2.0899006E-05
     +,   2.1488742E-05,   2.2100527E-05,   2.2735176E-05
     +,   2.3393533E-05,   2.4076346E-05,   2.4784420E-05
     +,   2.5518433E-05,   2.6279005E-05,   2.7066764E-05
     +,   2.7882183E-05,   2.8725630E-05,   2.9597475E-05
     +,   3.0497858E-05,   3.1426793E-05,   3.2384254E-05
     +,   3.3369921E-05,   3.4383436E-05,   3.5424164E-05
     +,   3.6491307E-05,   3.7583795E-05,   3.8700520E-05
     +,   3.9839972E-05,   4.1000436E-05,   4.2180094E-05
     +,   4.3376727E-05,   4.4587901E-05,   4.5811055E-05
     +,   4.7043213E-05,   4.8281334E-05,   4.9522001E-05
     +,   5.0761642E-05,   5.1996416E-05,   5.3222422E-05
     +,   5.4435382E-05,   5.5631070E-05,   5.6804955E-05
     +,   5.7952453E-05,   5.9068858E-05,   6.0149516E-05
     +,   6.1189581E-05,   6.2184394E-05,   6.3129184E-05
     +,   6.4019325E-05,   6.4850261E-05,   6.5617685E-05
     +,   6.6317334E-05,   6.6945351E-05,   6.7497996E-05
     +,   6.7971872E-05,   6.8363988E-05,   6.8671659E-05
     +,   6.8892681E-05,   6.9025285E-05,   6.9068170E-05
     +,   6.9020622E-05,   6.8882451E-05,   6.8654073E-05
     +,   6.8336587E-05,   6.7931687E-05,   6.7441804E-05
     +,   6.6870161E-05,   6.6220637E-05,   6.5498083E-05
     +,   6.4708001E-05,   6.3856940E-05,   6.2952298E-05
     +,   6.2002517E-05,   6.1016861E-05,   6.0005874E-05
     +,   5.8980942E-05,   5.7954756E-05,   5.6941088E-05
     +,   5.5954817E-05,   5.5012115E-05,   5.4130309E-05
     +,   5.3327829E-05,   5.2624328E-05,   5.2040552E-05
     +,   5.1598145E-05,   5.1319723E-05,   5.1228570E-05
     +,   5.1348488E-05,   5.1703548E-05,   5.2317795E-05
     +,   5.3214899E-05,   5.4417880E-05,   5.5948491E-05
     +,   5.7827110E-05,   6.0071958E-05,   6.2698913E-05
     +,   6.5720851E-05,   6.9147703E-05,   7.2986091E-05
     +,   7.7238750E-05,   8.1904960E-05,   8.6980632E-05
     +,   9.2458438E-05,   9.8328986E-05,   1.0458132E-04
     +,   1.1120334E-04,   1.1818365E-04,   1.2551238E-04
     +,   1.3318351E-04,   1.4119546E-04,   1.4955194E-04
     +,   1.5826376E-04,   1.6734928E-04,   1.7683416E-04
     +,   1.8675262E-04,   1.9714386E-04,   2.0805359E-04
     +,   2.1952887E-04,   2.3161681E-04,   2.4436080E-04
     +,   2.5779608E-04,   2.7194736E-04,   2.8682410E-04
     +,   3.0241557E-04,   3.1868933E-04,   3.3558867E-04
     +,   3.5303237E-04,   3.7091496E-04,   3.8910648E-04
     +,   4.0745776E-04,   4.2580525E-04,   4.4397570E-04
     +,   4.6179650E-04,   4.7910240E-04,   4.9574277E-04
     +,   5.1159249E-04,   5.2655989E-04,   5.4059149E-04
     +,   5.5367971E-04,   5.6586310E-04,   5.7722389E-04
     +,   5.8788556E-04,   5.9800368E-04,   6.0775614E-04
     +,   6.1732839E-04,   6.2689889E-04,   6.3662475E-04
     +,   6.4662792E-04,   6.5698376E-04,   6.6771609E-04
     +,   6.7879230E-04,   6.9013151E-04,   7.0161070E-04
     +,   7.1307929E-04,   7.2437956E-04,   7.3536433E-04
     +,   7.4592046E-04,   7.5598480E-04,   7.6555676E-04
     +,   7.7470840E-04,   7.8358164E-04,   7.9238141E-04
     +,   8.0135331E-04,   8.1076147E-04,   8.2085439E-04
     +,   8.3182793E-04,   8.4379193E-04,   8.5673825E-04
     +,   8.7051839E-04,   8.8483025E-04,   8.9922175E-04
     +,   9.1311219E-04,   9.2582370E-04,   9.3662931E-04
     +,   9.4480987E-04,   9.4971037E-04,   9.5079967E-04
     +,   9.4771804E-04,   9.4030850E-04,   9.2863658E-04
     +,   9.1298443E-04,   8.9382811E-04,   8.7180140E-04
     +,   8.4764499E-04,   8.2214584E-04,   7.9608714E-04
     +,   7.7018875E-04,   7.4507121E-04,   7.2122266E-04
     +,   6.9898163E-04,   6.7853637E-04,   6.5993005E-04
     +,   6.4308080E-04,   6.2780676E-04,   6.1385118E-04
     +,   6.0091005E-04,   5.8865879E-04,   5.7677308E-04
     +,   5.6494819E-04,   5.5291317E-04,   5.4043927E-04
     +,   5.2734639E-04,   5.1350374E-04,   4.9882976E-04
     +,   4.8329117E-04,   4.6689666E-04,   4.4969216E-04
     +,   4.3175573E-04,   4.1318886E-04,   3.9411170E-04
     +,   3.7465838E-04,   3.5496950E-04,   3.3518756E-04
     +,   3.1545342E-04,   2.9589969E-04,   2.7665313E-04
     +,   2.5782653E-04,   2.3952223E-04,   2.2182841E-04
     +,   2.0482035E-04,   1.8855536E-04,   1.7308083E-04
     +,   1.5842960E-04,   1.4462190E-04,   1.3166701E-04
     +,   1.1956212E-04,   1.0829728E-04,   9.7852673E-05
     +,   8.8203109E-05,   7.9317637E-05,   7.1161165E-05
     +,   6.3696236E-05,   5.6881778E-05,   5.0677638E-05
     +,   4.5042951E-05,   3.9937473E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_nwao_hz_85 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_nwao_hz_90(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  1.9929975E-07,   2.1508831E-07
     +,   2.3195919E-07,   2.4997115E-07,   2.6918596E-07
     +,   2.8966735E-07,   3.1148016E-07,   3.3469198E-07
     +,   3.5937271E-07,   3.8559236E-07,   4.1342415E-07
     +,   4.4294291E-07,   4.7422469E-07,   5.0734627E-07
     +,   5.4238637E-07,   5.7942623E-07,   6.1854462E-07
     +,   6.5982408E-07,   7.0334829E-07,   7.4919740E-07
     +,   7.9745610E-07,   8.4820715E-07,   9.0153225E-07
     +,   9.5751420E-07,   1.0162347E-06,   1.0777729E-06
     +,   1.1422082E-06,   1.2096187E-06,   1.2800778E-06
     +,   1.3536594E-06,   1.4304350E-06,   1.5104695E-06
     +,   1.5938278E-06,   1.6805724E-06,   1.7707567E-06
     +,   1.8644336E-06,   1.9616539E-06,   2.0624550E-06
     +,   2.1668773E-06,   2.2749527E-06,   2.3867087E-06
     +,   2.5021625E-06,   2.6213302E-06,   2.7442190E-06
     +,   2.8708339E-06,   3.0011631E-06,   3.1352029E-06
     +,   3.2729274E-06,   3.4143156E-06,   3.5593375E-06
     +,   3.7079583E-06,   3.8601306E-06,   4.0158088E-06
     +,   4.1749440E-06,   4.3374721E-06,   4.5033385E-06
     +,   4.6724817E-06,   4.8448310E-06,   5.0203230E-06
     +,   5.1988977E-06,   5.3804820E-06,   5.5650203E-06
     +,   5.7524585E-06,   5.9427398E-06,   6.1358237E-06
     +,   6.3316825E-06,   6.5302866E-06,   6.7316305E-06
     +,   6.9357279E-06,   7.1425952E-06,   7.3522838E-06
     +,   7.5648604E-06,   7.7804279E-06,   7.9990978E-06
     +,   8.2210308E-06,   8.4464018E-06,   8.6754508E-06
     +,   8.9084269E-06,   9.1456268E-06,   9.3874096E-06
     +,   9.6341610E-06,   9.8863111E-06,   1.0144369E-05
     +,   1.0408875E-05,   1.0680415E-05,   1.0959673E-05
     +,   1.1247347E-05,   1.1544240E-05,   1.1851185E-05
     +,   1.2169095E-05,   1.2498940E-05,   1.2841789E-05
     +,   1.3198746E-05,   1.3570993E-05,   1.3959817E-05
     +,   1.4366547E-05,   1.4792575E-05,   1.5239430E-05
     +,   1.5708649E-05,   1.6201921E-05,   1.6720956E-05
     +,   1.7267583E-05,   1.7843682E-05,   1.8451288E-05
     +,   1.9092444E-05,   1.9769377E-05,   2.0484336E-05
     +,   2.1239688E-05,   2.2037879E-05,   2.2881542E-05
     +,   2.3773291E-05,   2.4715966E-05,   2.5712423E-05
     +,   2.6765658E-05,   2.7878701E-05,   2.9054836E-05
     +,   3.0297255E-05,   3.1609423E-05,   3.2994758E-05
     +,   3.4456734E-05,   3.5999055E-05,   3.7625272E-05
     +,   3.9339211E-05,   4.1144547E-05,   4.3045053E-05
     +,   4.5044409E-05,   4.7146572E-05,   4.9355222E-05
     +,   5.1674011E-05,   5.4106855E-05,   5.6657325E-05
     +,   5.9328948E-05,   6.2125495E-05,   6.5050248E-05
     +,   6.8106805E-05,   7.1298338E-05,   7.4627977E-05
     +,   7.8098456E-05,   8.1712751E-05,   8.5472922E-05
     +,   8.9381203E-05,   9.3438852E-05,   9.7646509E-05
     +,   1.0200445E-04,   1.0651153E-04,   1.1116539E-04
     +,   1.1596290E-04,   1.2089875E-04,   1.2596577E-04
     +,   1.3115531E-04,   1.3645588E-04,   1.4185341E-04
     +,   1.4733172E-04,   1.5287123E-04,   1.5844953E-04
     +,   1.6404087E-04,   1.6961737E-04,   1.7514720E-04
     +,   1.8059670E-04,   1.8592911E-04,   1.9110576E-04
     +,   1.9608616E-04,   2.0082912E-04,   2.0529283E-04
     +,   2.0943550E-04,   2.1321631E-04,   2.1659627E-04
     +,   2.1953882E-04,   2.2201095E-04,   2.2398378E-04
     +,   2.2543302E-04,   2.2634021E-04,   2.2669300E-04
     +,   2.2648582E-04,   2.2572001E-04,   2.2440442E-04
     +,   2.2255546E-04,   2.2019706E-04,   2.1736068E-04
     +,   2.1408481E-04,   2.1041519E-04,   2.0640343E-04
     +,   2.0210739E-04,   1.9758986E-04,   1.9291794E-04
     +,   1.8816230E-04,   1.8339574E-04,   1.7869245E-04
     +,   1.7412729E-04,   1.6977430E-04,   1.6570596E-04
     +,   1.6199151E-04,   1.5869668E-04,   1.5588287E-04
     +,   1.5360642E-04,   1.5191793E-04,   1.5086230E-04
     +,   1.5047847E-04,   1.5079991E-04,   1.5185487E-04
     +,   1.5366724E-04,   1.5625788E-04,   1.5964599E-04
     +,   1.6385225E-04,   1.6890187E-04,   1.7482888E-04
     +,   1.8168220E-04,   1.8953244E-04,   1.9848082E-04
     +,   2.0866723E-04,   2.2027781E-04,   2.3355221E-04
     +,   2.4878685E-04,   2.6633273E-04,   2.8659141E-04
     +,   3.0999508E-04,   3.3699209E-04,   3.6801310E-04
     +,   4.0344399E-04,   4.4359048E-04,   4.8864790E-04
     +,   5.3868123E-04,   5.9360889E-04,   6.5319618E-04
     +,   7.1707577E-04,   7.8476866E-04,   8.5573737E-04
     +,   9.2941331E-04,   1.0052737E-03,   1.0828652E-03
     +,   1.1618471E-03,   1.2419930E-03,   1.3231690E-03
     +,   1.4052627E-03,   1.4880704E-03,   1.5711774E-03
     +,   1.6538185E-03,   1.7347699E-03,   1.8123062E-03
     +,   1.8842358E-03,   1.9480271E-03,   2.0010541E-03
     +,   2.0408791E-03,   2.0655580E-03,   2.0738796E-03
     +,   2.0655163E-03,   2.0410267E-03,   2.0017342E-03
     +,   1.9495004E-03,   1.8864429E-03,   1.8147014E-03
     +,   1.7362351E-03,   1.6527656E-03,   1.5657775E-03
     +,   1.4766111E-03,   1.3865680E-03,   1.2969857E-03
     +,   1.2092745E-03,   1.1248932E-03,   1.0452458E-03
     +,   9.7156799E-04,   9.0481009E-04,   8.4553531E-04
     +,   7.9387770E-04,   7.4954756E-04,   7.1187178E-04
     +,   6.7988317E-04,   6.5242115E-04,   6.2824640E-04
     +,   6.0614879E-04,   5.8503216E-04,   5.6398357E-04
     +,   5.4231618E-04,   5.1958283E-04,   4.9557321E-04
     +,   4.7029016E-04,   4.4391016E-04,   4.1673917E-04
     +,   3.8916586E-04,   3.6161236E-04,   3.3450243E-04
     +,   3.0822141E-04,   2.8310120E-04,   2.5940189E-04
     +,   2.3730885E-04,   2.1692604E-04,   1.9829242E-04
     +,   1.8138360E-04,   1.6612498E-04,   1.5240442E-04
     +,   1.4008205E-04,   1.2900546E-04,   1.1901575E-04
     +,   1.0995915E-04,   1.0169184E-04,   9.4085088E-05
     +,   8.7028813E-05,   8.0430676E-05,   7.4219279E-05
     +,   6.8340785E-05,   6.2757470E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_nwao_hz_90 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_nwao_hz_95(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  6.8335018E-09,   7.6818125E-09
     +,   8.6273975E-09,   9.6803250E-09,   1.0851624E-08
     +,   1.2153333E-08,   1.3598473E-08,   1.5201261E-08
     +,   1.6977159E-08,   1.8942814E-08,   2.1116346E-08
     +,   2.3517334E-08,   2.6166949E-08,   2.9087882E-08
     +,   3.2304740E-08,   3.5843978E-08,   3.9733827E-08
     +,   4.4004757E-08,   4.8689454E-08,   5.3822568E-08
     +,   5.9441426E-08,   6.5585837E-08,   7.2297844E-08
     +,   7.9622538E-08,   8.7607830E-08,   9.6304078E-08
     +,   1.0576499E-07,   1.1604749E-07,   1.2721101E-07
     +,   1.3931883E-07,   1.5243748E-07,   1.6663617E-07
     +,   1.8198824E-07,   1.9857062E-07,   2.1646248E-07
     +,   2.3574785E-07,   2.5651411E-07,   2.7885079E-07
     +,   3.0285236E-07,   3.2861593E-07,   3.5624282E-07
     +,   3.8583610E-07,   4.1750309E-07,   4.5135417E-07
     +,   4.8750331E-07,   5.2606521E-07,   5.6715970E-07
     +,   6.1090634E-07,   6.5742961E-07,   7.0685502E-07
     +,   7.5931075E-07,   8.1492425E-07,   8.7382699E-07
     +,   9.3615193E-07,   1.0020302E-06,   1.0715962E-06
     +,   1.1449862E-06,   1.2223318E-06,   1.3037700E-06
     +,   1.3894379E-06,   1.4794673E-06,   1.5739960E-06
     +,   1.6731614E-06,   1.7770952E-06,   1.8859353E-06
     +,   1.9998206E-06,   2.1188830E-06,   2.2432628E-06
     +,   2.3731027E-06,   2.5085390E-06,   2.6497171E-06
     +,   2.7967842E-06,   2.9498963E-06,   3.1092034E-06
     +,   3.2748735E-06,   3.4470677E-06,   3.6259773E-06
     +,   3.8117846E-06,   4.0046825E-06,   4.2048978E-06
     +,   4.4126518E-06,   4.6281793E-06,   4.8517572E-06
     +,   5.0836602E-06,   5.3241820E-06,   5.5736650E-06
     +,   5.8324408E-06,   6.1009055E-06,   6.3794523E-06
     +,   6.6685134E-06,   6.9685389E-06,   7.2800453E-06
     +,   7.6035412E-06,   7.9395659E-06,   8.2887364E-06
     +,   8.6516438E-06,   9.0289241E-06,   9.4212728E-06
     +,   9.8293576E-06,   1.0253928E-05,   1.0695704E-05
     +,   1.1155444E-05,   1.1633894E-05,   1.2131866E-05
     +,   1.2650098E-05,   1.3189407E-05,   1.3750539E-05
     +,   1.4334241E-05,   1.4941227E-05,   1.5572239E-05
     +,   1.6227905E-05,   1.6908896E-05,   1.7615776E-05
     +,   1.8349067E-05,   1.9109219E-05,   1.9896694E-05
     +,   2.0711772E-05,   2.1554799E-05,   2.2425951E-05
     +,   2.3325327E-05,   2.4253070E-05,   2.5209123E-05
     +,   2.6193517E-05,   2.7206126E-05,   2.8246817E-05
     +,   2.9315413E-05,   3.0411848E-05,   3.1535939E-05
     +,   3.2687549E-05,   3.3866723E-05,   3.5073470E-05
     +,   3.6307905E-05,   3.7570411E-05,   3.8861388E-05
     +,   4.0181603E-05,   4.1531901E-05,   4.2913474E-05
     +,   4.4327706E-05,   4.5776454E-05,   4.7261699E-05
     +,   4.8785983E-05,   5.0351999E-05,   5.1962797E-05
     +,   5.3621949E-05,   5.5333137E-05,   5.7100347E-05
     +,   5.8928021E-05,   6.0820606E-05,   6.2782681E-05
     +,   6.4819142E-05,   6.6934677E-05,   6.9133886E-05
     +,   7.1421462E-05,   7.3801588E-05,   7.6278200E-05
     +,   7.8854631E-05,   8.1534003E-05,   8.4318395E-05
     +,   8.7209512E-05,   9.0207970E-05,   9.3313589E-05
     +,   9.6525087E-05,   9.9840436E-05,   1.0325661E-04
     +,   1.0676930E-04,   1.1037326E-04,   1.1406231E-04
     +,   1.1782916E-04,   1.2166596E-04,   1.2556421E-04
     +,   1.2951440E-04,   1.3350681E-04,   1.3753121E-04
     +,   1.4157761E-04,   1.4563611E-04,   1.4969677E-04
     +,   1.5375033E-04,   1.5778816E-04,   1.6180227E-04
     +,   1.6578600E-04,   1.6973319E-04,   1.7363908E-04
     +,   1.7749963E-04,   1.8131160E-04,   1.8507233E-04
     +,   1.8877941E-04,   1.9243069E-04,   1.9602366E-04
     +,   1.9955459E-04,   2.0301878E-04,   2.0640988E-04
     +,   2.0972025E-04,   2.1294066E-04,   2.1606052E-04
     +,   2.1906939E-04,   2.2195843E-04,   2.2472258E-04
     +,   2.2736452E-04,   2.2989855E-04,   2.3235592E-04
     +,   2.3479131E-04,   2.3728982E-04,   2.3997367E-04
     +,   2.4300886E-04,   2.4661067E-04,   2.5104563E-04
     +,   2.5663199E-04,   2.6373463E-04,   2.7275801E-04
     +,   2.8413409E-04,   2.9830646E-04,   3.1571713E-04
     +,   3.3679188E-04,   3.6192860E-04,   3.9149422E-04
     +,   4.2581116E-04,   4.6515930E-04,   5.0974922E-04
     +,   5.5969693E-04,   6.1497191E-04,   6.7533087E-04
     +,   7.4025983E-04,   8.0893270E-04,   8.8022900E-04
     +,   9.5286459E-04,   1.0256313E-03,   1.0977609E-03
     +,   1.1693084E-03,   1.2415187E-03,   1.3169424E-03
     +,   1.3992375E-03,   1.4925380E-03,   1.6004546E-03
     +,   1.7248784E-03,   1.8649063E-03,   2.0162631E-03
     +,   2.1714722E-03,   2.3208794E-03,   2.4544036E-03
     +,   2.5635511E-03,   2.6432290E-03,   2.6928326E-03
     +,   2.7162689E-03,   2.7209094E-03,   2.7157285E-03
     +,   2.7092400E-03,   2.7077736E-03,   2.7145944E-03
     +,   2.7300019E-03,   2.7522142E-03,   2.7785359E-03
     +,   2.8062672E-03,   2.8330078E-03,   2.8563291E-03
     +,   2.8731390E-03,   2.8792119E-03,   2.8692749E-03
     +,   2.8377478E-03,   2.7799562E-03,   2.6934259E-03
     +,   2.5788525E-03,   2.4404784E-03,   2.2857487E-03
     +,   2.1243591E-03,   1.9668946E-03,   1.8232596E-03
     +,   1.7012559E-03,   1.6055140E-03,   1.5370039E-03
     +,   1.4931696E-03,   1.4686186E-03,   1.4562397E-03
     +,   1.4484642E-03,   1.4384330E-03,   1.4208481E-03
     +,   1.3924110E-03,   1.3518308E-03,   1.2995114E-03
     +,   1.2370435E-03,   1.1666522E-03,   1.0907430E-03
     +,   1.0115546E-03,   9.3100261E-04,   8.5062132E-04
     +,   7.7160838E-04,   6.9487351E-04,   6.2114996E-04
     +,   5.5102719E-04,   4.8498911E-04,   4.2342622E-04
     +,   3.6662363E-04,   3.1477021E-04,   2.6793571E-04
     +,   2.2608694E-04,   1.8908837E-04,   1.5671970E-04
     +,   1.2869603E-04,   1.0467957E-04,   8.4311083E-05
     +,   6.7216948E-05,   5.3024229E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_nwao_hz_95 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_nwao_qq(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  1.3934449E-07,   1.5138474E-07
     +,   1.6433422E-07,   1.7824867E-07,   1.9318682E-07
     +,   2.0921023E-07,   2.2638149E-07,   2.4476674E-07
     +,   2.6443456E-07,   2.8545463E-07,   3.0790034E-07
     +,   3.3184648E-07,   3.5737102E-07,   3.8455235E-07
     +,   4.1347224E-07,   4.4421444E-07,   4.7686297E-07
     +,   5.1150533E-07,   5.4823022E-07,   5.8712595E-07
     +,   6.2828354E-07,   6.7179627E-07,   7.1775412E-07
     +,   7.6625122E-07,   8.1738187E-07,   8.7123681E-07
     +,   9.2791026E-07,   9.8749581E-07,   1.0500826E-06
     +,   1.1157618E-06,   1.1846240E-06,   1.2567532E-06
     +,   1.3322351E-06,   1.4111546E-06,   1.4935870E-06
     +,   1.5796102E-06,   1.6692987E-06,   1.7627167E-06
     +,   1.8599309E-06,   1.9609997E-06,   2.0659804E-06
     +,   2.1749167E-06,   2.2878542E-06,   2.4048297E-06
     +,   2.5258764E-06,   2.6510127E-06,   2.7802600E-06
     +,   2.9136240E-06,   3.0511085E-06,   3.1927077E-06
     +,   3.3384106E-06,   3.4881898E-06,   3.6420199E-06
     +,   3.7998636E-06,   3.9616702E-06,   4.1273884E-06
     +,   4.2969573E-06,   4.4703006E-06,   4.6473419E-06
     +,   4.8279990E-06,   5.0121689E-06,   5.1997531E-06
     +,   5.3906474E-06,   5.5847263E-06,   5.7818734E-06
     +,   5.9819608E-06,   6.1848491E-06,   6.3904013E-06
     +,   6.5984777E-06,   6.8089212E-06,   7.0215829E-06
     +,   7.2363091E-06,   7.4529485E-06,   7.6713313E-06
     +,   7.8913063E-06,   8.1127018E-06,   8.3353743E-06
     +,   8.5591591E-06,   8.7838898E-06,   9.0094300E-06
     +,   9.2356213E-06,   9.4623101E-06,   9.6893727E-06
     +,   9.9166664E-06,   1.0144056E-05,   1.0371436E-05
     +,   1.0598680E-05,   1.0825704E-05,   1.1052406E-05
     +,   1.1278705E-05,   1.1504523E-05,   1.1729821E-05
     +,   1.1954548E-05,   1.2178668E-05,   1.2402183E-05
     +,   1.2625087E-05,   1.2847394E-05,   1.3069156E-05
     +,   1.3290415E-05,   1.3511262E-05,   1.3731787E-05
     +,   1.3952106E-05,   1.4172352E-05,   1.4392703E-05
     +,   1.4613330E-05,   1.4834460E-05,   1.5056316E-05
     +,   1.5279164E-05,   1.5503276E-05,   1.5728983E-05
     +,   1.5956604E-05,   1.6186525E-05,   1.6419119E-05
     +,   1.6654807E-05,   1.6894011E-05,   1.7137219E-05
     +,   1.7384897E-05,   1.7637565E-05,   1.7895743E-05
     +,   1.8159959E-05,   1.8430786E-05,   1.8708773E-05
     +,   1.8994517E-05,   1.9288578E-05,   1.9591535E-05
     +,   1.9903944E-05,   2.0226393E-05,   2.0559406E-05
     +,   2.0903490E-05,   2.1259166E-05,   2.1626869E-05
     +,   2.2006996E-05,   2.2399938E-05,   2.2805962E-05
     +,   2.3225330E-05,   2.3658187E-05,   2.4104609E-05
     +,   2.4564562E-05,   2.5037978E-05,   2.5524587E-05
     +,   2.6024109E-05,   2.6536060E-05,   2.7059852E-05
     +,   2.7594815E-05,   2.8140090E-05,   2.8694672E-05
     +,   2.9257484E-05,   2.9827239E-05,   3.0402514E-05
     +,   3.0981813E-05,   3.1563417E-05,   3.2145515E-05
     +,   3.2726191E-05,   3.3303386E-05,   3.3874938E-05
     +,   3.4438566E-05,   3.4991990E-05,   3.5532776E-05
     +,   3.6058536E-05,   3.6566798E-05,   3.7055132E-05
     +,   3.7521113E-05,   3.7962429E-05,   3.8376882E-05
     +,   3.8762380E-05,   3.9117040E-05,   3.9439223E-05
     +,   3.9727591E-05,   3.9981165E-05,   4.0199404E-05
     +,   4.0382223E-05,   4.0530125E-05,   4.0644245E-05
     +,   4.0726456E-05,   4.0779436E-05,   4.0806724E-05
     +,   4.0812880E-05,   4.0803450E-05,   4.0785144E-05
     +,   4.0765815E-05,   4.0754549E-05,   4.0761668E-05
     +,   4.0798746E-05,   4.0878596E-05,   4.1015228E-05
     +,   4.1223750E-05,   4.1520365E-05,   4.1922245E-05
     +,   4.2447409E-05,   4.3114658E-05,   4.3943517E-05
     +,   4.4954340E-05,   4.6168359E-05,   4.7607828E-05
     +,   4.9296472E-05,   5.1259951E-05,   5.3526554E-05
     +,   5.6128225E-05,   5.9101545E-05,   6.2488682E-05
     +,   6.6338776E-05,   7.0709109E-05,   7.5665921E-05
     +,   8.1285594E-05,   8.7654735E-05,   9.4869334E-05
     +,   1.0303421E-04,   1.1226055E-04,   1.2266407E-04
     +,   1.3436048E-04,   1.4745949E-04,   1.6206029E-04
     +,   1.7824429E-04,   1.9606727E-04,   2.1555487E-04
     +,   2.3669019E-04,   2.5941330E-04,   2.8361045E-04
     +,   3.0911382E-04,   3.3569935E-04,   3.6308783E-04
     +,   3.9095362E-04,   4.1893061E-04,   4.4662345E-04
     +,   4.7362593E-04,   4.9953797E-04,   5.2398926E-04
     +,   5.4665317E-04,   5.6727260E-04,   5.8567052E-04
     +,   6.0176244E-04,   6.1555958E-04,   6.2716508E-04
     +,   6.3675927E-04,   6.4457703E-04,   6.5088115E-04
     +,   6.5592857E-04,   6.5994065E-04,   6.6307629E-04
     +,   6.6541758E-04,   6.6697039E-04,   6.6768331E-04
     +,   6.6748419E-04,   6.6633121E-04,   6.6427246E-04
     +,   6.6150114E-04,   6.5839896E-04,   6.5555208E-04
     +,   6.5373833E-04,   6.5387465E-04,   6.5693655E-04
     +,   6.6385430E-04,   6.7540316E-04,   6.9210411E-04
     +,   7.1415387E-04,   7.4139115E-04,   7.7331834E-04
     +,   8.0915593E-04,   8.4793544E-04,   8.8861299E-04
     +,   9.3017827E-04,   9.7174698E-04,   1.0126225E-03
     +,   1.0523087E-03,   1.0904762E-03,   1.1268996E-03
     +,   1.1613597E-03,   1.1935444E-03,   1.2229552E-03
     +,   1.2488445E-03,   1.2702093E-03,   1.2858296E-03
     +,   1.2943625E-03,   1.2944752E-03,   1.2849965E-03
     +,   1.2650640E-03,   1.2342456E-03,   1.1926123E-03
     +,   1.1407578E-03,   1.0797539E-03,   1.0110809E-03
     +,   9.3649601E-04,   8.5792434E-04,   7.7732239E-04
     +,   6.9657865E-04,   6.1739929E-04,   5.4128328E-04
     +,   4.6945555E-04,   4.0285371E-04,   3.4212784E-04
     +,   2.8764197E-04,   2.3951361E-04,   1.9762907E-04
     +,   1.6169665E-04,   1.3128298E-04,   1.0585961E-04
     +,   8.4847910E-05,   6.7651301E-05,   5.3696316E-05
     +,   4.2449217E-05,   3.3432672E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_nwao_qq = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_nwao_ww(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   1.2452619E-38
     +,   4.8888882E-38,   1.8963678E-37,   7.2676683E-37
     +,   2.7517473E-36,   1.0294467E-35,   3.8050873E-35
     +,   1.3895204E-34,   5.0136248E-34,   1.7873230E-33
     +,   6.2950426E-33,   2.1906921E-32,   7.5320112E-32
     +,   2.5587362E-31,   8.5883263E-31,   2.8481414E-30
     +,   9.3317076E-30,   3.0209957E-29,   9.6624646E-29
     +,   3.0536168E-28,   9.5348083E-28,   2.9414462E-27
     +,   8.9660467E-27,   2.7002860E-26,   8.0347197E-26
     +,   2.3622302E-25,   6.8619021E-25,   1.9693487E-24
     +,   5.5845554E-24,   1.5646859E-23,   4.3312872E-23
     +,   1.1846757E-22,   3.2014972E-22,   8.5482856E-22
     +,   2.2550606E-21,   5.8779584E-21,   1.5137362E-20
     +,   3.8517775E-20,   9.6837362E-20,   2.4054479E-19
     +,   5.9034304E-19,   1.4314725E-18,   3.4296308E-18
     +,   8.1186057E-18,   1.8988254E-17,   4.3879202E-17
     +,   1.0018164E-16,   2.2598847E-16,   5.0369598E-16
     +,   1.1092220E-15,   2.4134586E-15,   5.1881941E-15
     +,   1.1019533E-14,   2.3125622E-14,   4.7950637E-14
     +,   9.8235310E-14,   1.9884398E-13,   3.9766703E-13
     +,   7.8580317E-13,   1.5341710E-12,   2.9595371E-12
     +,   5.6409820E-12,   1.0623553E-11,   1.9768411E-11
     +,   3.6345760E-11,   6.6028343E-11,   1.1852683E-10
     +,   2.1023581E-10,   3.6847339E-10,   6.3813393E-10
     +,   1.0920471E-09,   1.8467570E-09,   3.0861438E-09
     +,   5.0964712E-09,   8.3172420E-09,   1.3413672E-08
     +,   2.1379329E-08,   3.3677331E-08,   5.2430273E-08
     +,   8.0675306E-08,   1.2269481E-07,   1.8443599E-07
     +,   2.7404425E-07,   4.0250521E-07,   5.8439429E-07
     +,   8.3876137E-07,   1.1900831E-06,   1.6693326E-06
     +,   2.3150155E-06,   3.1740760E-06,   4.3027394E-06
     +,   5.7669713E-06,   7.6424112E-06,   1.0014066E-05
     +,   1.2974342E-05,   1.6621434E-05,   2.1055144E-05
     +,   2.6372769E-05,   3.2663280E-05,   4.0000417E-05
     +,   4.8436090E-05,   5.7992329E-05,   6.8652866E-05
     +,   8.0357444E-05,   9.2995768E-05,   1.0640676E-04
     +,   1.2037495E-04,   1.3463844E-04,   1.4889269E-04
     +,   1.6280422E-04,   1.7602503E-04,   1.8821243E-04
     +,   1.9904836E-04,   2.0825956E-04,   2.1563900E-04
     +,   2.2106293E-04,   2.2450343E-04,   2.2603599E-04
     +,   2.2583880E-04,   2.2418573E-04,   2.2143178E-04
     +,   2.1799207E-04,   2.1431493E-04,   2.1085392E-04
     +,   2.0803737E-04,   2.0624005E-04,   2.0575942E-04
     +,   2.0679686E-04,   2.0944675E-04,   2.1369228E-04
     +,   2.1941062E-04,   2.2638298E-04,   2.3431210E-04
     +,   2.4284318E-04,   2.5158722E-04,   2.6014625E-04
     +,   2.6813554E-04,   2.7520425E-04,   2.8105357E-04
     +,   2.8544964E-04,   2.8823171E-04,   2.8931588E-04
     +,   2.8869283E-04,   2.8642156E-04,   2.8261918E-04
     +,   2.7744757E-04,   2.7109715E-04,   2.6377075E-04
     +,   2.5566912E-04,   2.4697633E-04,   2.3784961E-04
     +,   2.2841345E-04,   2.1875599E-04,   2.0893149E-04
     +,   1.9896684E-04,   1.8886816E-04,   1.7863064E-04
     +,   1.6824866E-04,   1.5772288E-04,   1.4706985E-04
     +,   1.3632303E-04,   1.2553718E-04,   1.1478545E-04
     +,   1.0415733E-04,   9.3749833E-05,   8.3666557E-05
     +,   7.4007767E-05,   6.4865329E-05,   5.6317953E-05
     +,   4.8426173E-05,   4.1232423E-05,   3.4757810E-05
     +,   2.9004814E-05,   2.3957857E-05,   1.9586196E-05
     +,   1.5847249E-05,   1.2688780E-05,   1.0053881E-05
     +,   7.8827379E-06,   6.1155174E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_nwao_ww = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_nwao_zz(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  6.4150306E-08,   7.2830709E-08
     +,   8.2721101E-08,   9.3966520E-08,   1.0672608E-07
     +,   1.2117319E-07,   1.3749552E-07,   1.5589681E-07
     +,   1.7659714E-07,   1.9983166E-07,   2.2585357E-07
     +,   2.5493276E-07,   2.8735653E-07,   3.2342737E-07
     +,   3.6346637E-07,   4.0781069E-07,   4.5681082E-07
     +,   5.1083430E-07,   5.7026256E-07,   6.3548543E-07
     +,   7.0690714E-07,   7.8494071E-07,   8.7000137E-07
     +,   9.6251267E-07,   1.0629005E-06,   1.1715842E-06
     +,   1.2889838E-06,   1.4155130E-06,   1.5515667E-06
     +,   1.6975329E-06,   1.8537826E-06,   2.0206553E-06
     +,   2.1984740E-06,   2.3875320E-06,   2.5880795E-06
     +,   2.8003415E-06,   3.0245017E-06,   3.2606881E-06
     +,   3.5089947E-06,   3.7694617E-06,   4.0420814E-06
     +,   4.3267764E-06,   4.6234304E-06,   4.9318592E-06
     +,   5.2518308E-06,   5.5830310E-06,   5.9251129E-06
     +,   6.2776417E-06,   6.6401426E-06,   7.0120782E-06
     +,   7.3928545E-06,   7.7818058E-06,   8.1782246E-06
     +,   8.5813608E-06,   8.9903824E-06,   9.4044362E-06
     +,   9.8226219E-06,   1.0243970E-05,   1.0667498E-05
     +,   1.1092180E-05,   1.1516932E-05,   1.1940668E-05
     +,   1.2362259E-05,   1.2780532E-05,   1.3194317E-05
     +,   1.3602415E-05,   1.4003587E-05,   1.4396605E-05
     +,   1.4780225E-05,   1.5153166E-05,   1.5514177E-05
     +,   1.5861993E-05,   1.6195352E-05,   1.6512988E-05
     +,   1.6813667E-05,   1.7096156E-05,   1.7359278E-05
     +,   1.7601849E-05,   1.7822742E-05,   1.8020883E-05
     +,   1.8195246E-05,   1.8344856E-05,   1.8468831E-05
     +,   1.8566350E-05,   1.8636689E-05,   1.8679219E-05
     +,   1.8693418E-05,   1.8678873E-05,   1.8635295E-05
     +,   1.8562518E-05,   1.8460518E-05,   1.8329394E-05
     +,   1.8169403E-05,   1.7980949E-05,   1.7764552E-05
     +,   1.7520913E-05,   1.7250877E-05,   1.6955395E-05
     +,   1.6635595E-05,   1.6292695E-05,   1.5928081E-05
     +,   1.5543217E-05,   1.5139711E-05,   1.4719199E-05
     +,   1.4283469E-05,   1.3834299E-05,   1.3373587E-05
     +,   1.2903226E-05,   1.2425172E-05,   1.1941313E-05
     +,   1.1453612E-05,   1.0963932E-05,   1.0474144E-05
     +,   9.9860599E-06,   9.5014357E-06,   9.0218973E-06
     +,   8.5490547E-06,   8.0843429E-06,   7.6291499E-06
     +,   7.1847471E-06,   6.7522315E-06,   6.3326479E-06
     +,   5.9268518E-06,   5.5356159E-06,   5.1595721E-06
     +,   4.7992439E-06,   4.4549856E-06,   4.1270814E-06
     +,   3.8156973E-06,   3.5208573E-06,   3.2425214E-06
     +,   2.9805547E-06,   2.7347069E-06,   2.5046895E-06
     +,   2.2901095E-06,   2.0905416E-06,   1.9054980E-06
     +,   1.7344553E-06,   1.5768361E-06,   1.4320609E-06
     +,   1.2995063E-06,   1.1785553E-06,   1.0685824E-06
     +,   9.6894973E-07,   8.7903925E-07,   7.9824110E-07
     +,   7.2595248E-07,   6.6159981E-07,   6.0463128E-07
     +,   5.5451454E-07,   5.1075369E-07,   4.7288350E-07
     +,   4.4046874E-07,   4.1311546E-07,   3.9046790E-07
     +,   3.7221361E-07,   3.5808426E-07,   3.4786532E-07
     +,   3.4139720E-07,   3.3858552E-07,   3.3940893E-07
     +,   3.4392980E-07,   3.5230917E-07,   3.6482317E-07
     +,   3.8188151E-07,   4.0405030E-07,   4.3207854E-07
     +,   4.6692463E-07,   5.0979179E-07,   5.6215987E-07
     +,   6.2581574E-07,   7.0289207E-07,   7.9589643E-07
     +,   9.0775126E-07,   1.0418195E-06,   1.2019123E-06
     +,   1.3923208E-06,   1.6178177E-06,   1.8836511E-06
     +,   2.1955816E-06,   2.5597963E-06,   2.9829932E-06
     +,   3.4722807E-06,   4.0352179E-06,   4.6798045E-06
     +,   5.4144639E-06,   6.2481399E-06,   7.1903009E-06
     +,   8.2508886E-06,   9.4404759E-06,   1.0770166E-05
     +,   1.2251799E-05,   1.3897770E-05,   1.5720760E-05
     +,   1.7733661E-05,   1.9949086E-05,   2.2378725E-05
     +,   2.5032823E-05,   2.7919092E-05,   3.1041272E-05
     +,   3.4398086E-05,   3.7981874E-05,   4.1776937E-05
     +,   4.5758898E-05,   4.9893428E-05,   5.4135631E-05
     +,   5.8430662E-05,   6.2714542E-05,   6.6916728E-05
     +,   7.0962342E-05,   7.4775940E-05,   7.8286052E-05
     +,   8.1429847E-05,   8.4157786E-05,   8.6438384E-05
     +,   8.8261244E-05,   8.9640504E-05,   9.0616166E-05
     +,   9.1255482E-05,   9.1652852E-05,   9.1929658E-05
     +,   9.2233313E-05,   9.2736213E-05,   9.3633214E-05
     +,   9.5137562E-05,   9.7473981E-05,   1.0086877E-04
     +,   1.0553472E-04,   1.1165474E-04,   1.1936210E-04
     +,   1.2872313E-04,   1.3972502E-04,   1.5227366E-04
     +,   1.6620189E-04,   1.8128919E-04,   1.9729348E-04
     +,   2.1398450E-04,   2.3117277E-04,   2.4872803E-04
     +,   2.6657386E-04,   2.8466128E-04,   3.0292606E-04
     +,   3.2123466E-04,   3.3934001E-04,   3.5684829E-04
     +,   3.7322528E-04,   3.8783450E-04,   3.9999982E-04
     +,   4.0909168E-04,   4.1460569E-04,   4.1622188E-04
     +,   4.1383025E-04,   4.0752499E-04,   3.9756380E-04
     +,   3.8431725E-04,   3.6821616E-04,   3.4971288E-04
     +,   3.2926822E-04,   3.0735615E-04,   2.8447973E-04
     +,   2.6118511E-04,   2.3806663E-04,   2.1574686E-04
     +,   1.9484115E-04,   1.7590969E-04,   1.5939916E-04
     +,   1.4559882E-04,   1.3460798E-04,   1.2633220E-04
     +,   1.2050017E-04,   1.1669957E-04,   1.1442647E-04
     +,   1.1314003E-04,   1.1231288E-04,   1.1147447E-04
     +,   1.1024116E-04,   1.0833328E-04,   1.0557981E-04
     +,   1.0191307E-04,   9.7354496E-05,   9.1997419E-05
     +,   8.5985484E-05,   7.9493642E-05,   7.2709016E-05
     +,   6.5815984E-05,   5.8982147E-05,   5.2353367E-05
     +,   4.6046844E-05,   4.0150258E-05,   3.4722609E-05
     +,   2.9796316E-05,   2.5382302E-05,   2.1472842E-05
     +,   1.8047127E-05,   1.5074612E-05,   1.2518724E-05
     +,   1.0339853E-05,   8.4969661E-06,   6.9502858E-06
     +,   5.6617087E-06,   4.5957454E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_nwao_zz = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wano_fus_100(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  2.5668140E-07,   2.7738133E-07
     +,   2.9954083E-07,   3.2324354E-07,   3.4857797E-07
     +,   3.7563603E-07,   4.0451184E-07,   4.3530426E-07
     +,   4.6811616E-07,   5.0305164E-07,   5.4022058E-07
     +,   5.7973568E-07,   6.2171370E-07,   6.6627234E-07
     +,   7.1353537E-07,   7.6363006E-07,   8.1668338E-07
     +,   8.7282905E-07,   9.3220353E-07,   9.9494275E-07
     +,   1.0611891E-06,   1.1310871E-06,   1.2047809E-06
     +,   1.2824199E-06,   1.3641562E-06,   1.4501392E-06
     +,   1.5405236E-06,   1.6354682E-06,   1.7351247E-06
     +,   1.8396537E-06,   1.9492154E-06,   2.0639652E-06
     +,   2.1840640E-06,   2.3096736E-06,   2.4409483E-06
     +,   2.5780498E-06,   2.7211374E-06,   2.8703632E-06
     +,   3.0258864E-06,   3.1878601E-06,   3.3564402E-06
     +,   3.5317703E-06,   3.7140039E-06,   3.9032866E-06
     +,   4.0997666E-06,   4.3035793E-06,   4.5148709E-06
     +,   4.7337708E-06,   4.9604205E-06,   5.1949514E-06
     +,   5.4374987E-06,   5.6881863E-06,   5.9471454E-06
     +,   6.2145095E-06,   6.4903979E-06,   6.7749424E-06
     +,   7.0682804E-06,   7.3705305E-06,   7.6818351E-06
     +,   8.0023410E-06,   8.3321775E-06,   8.6715045E-06
     +,   9.0204885E-06,   9.3792860E-06,   9.7480870E-06
     +,   1.0127094E-05,   1.0516505E-05,   1.0916558E-05
     +,   1.1327513E-05,   1.1749627E-05,   1.2183216E-05
     +,   1.2628610E-05,   1.3086187E-05,   1.3556336E-05
     +,   1.4039520E-05,   1.4536212E-05,   1.5046999E-05
     +,   1.5572468E-05,   1.6113278E-05,   1.6670219E-05
     +,   1.7244100E-05,   1.7835826E-05,   1.8446466E-05
     +,   1.9077139E-05,   1.9729086E-05,   2.0403770E-05
     +,   2.1102707E-05,   2.1827696E-05,   2.2580649E-05
     +,   2.3363722E-05,   2.4179279E-05,   2.5030042E-05
     +,   2.5918931E-05,   2.6849175E-05,   2.7824475E-05
     +,   2.8848775E-05,   2.9926448E-05,   3.1062424E-05
     +,   3.2261945E-05,   3.3530938E-05,   3.4875724E-05
     +,   3.6303267E-05,   3.7821042E-05,   3.9437367E-05
     +,   4.1160922E-05,   4.3001364E-05,   4.4968812E-05
     +,   4.7074122E-05,   4.9328755E-05,   5.1745137E-05
     +,   5.4335938E-05,   5.7114812E-05,   6.0095677E-05
     +,   6.3293024E-05,   6.6721514E-05,   7.0396520E-05
     +,   7.4332922E-05,   7.8546138E-05,   8.3050851E-05
     +,   8.7861255E-05,   9.2991402E-05,   9.8453675E-05
     +,   1.0426011E-04,   1.1042074E-04,   1.1694441E-04
     +,   1.2383788E-04,   1.3110727E-04,   1.3875624E-04
     +,   1.4678726E-04,   1.5520283E-04,   1.6400445E-04
     +,   1.7319438E-04,   1.8277821E-04,   1.9276382E-04
     +,   2.0316643E-04,   2.1400834E-04,   2.2532321E-04
     +,   2.3715808E-04,   2.4957897E-04,   2.6267028E-04
     +,   2.7654265E-04,   2.9133211E-04,   3.0720452E-04
     +,   3.2435876E-04,   3.4302502E-04,   3.6346627E-04
     +,   3.8597937E-04,   4.1088928E-04,   4.3854621E-04
     +,   4.6932622E-04,   5.0361728E-04,   5.4181553E-04
     +,   5.8431935E-04,   6.3150888E-04,   6.8373483E-04
     +,   7.4129261E-04,   8.0440729E-04,   8.7318377E-04
     +,   9.4758964E-04,   1.0273991E-03,   1.1121640E-03
     +,   1.2011790E-03,   1.2934715E-03,   1.3877952E-03
     +,   1.4826497E-03,   1.5763459E-03,   1.6670845E-03
     +,   1.7530652E-03,   1.8326209E-03,   1.9043430E-03
     +,   1.9671966E-03,   2.0206266E-03,   2.0646150E-03
     +,   2.0996914E-03,   2.1268923E-03,   2.1476678E-03
     +,   2.1637597E-03,   2.1770576E-03,   2.1894386E-03
     +,   2.2026282E-03,   2.2180902E-03,   2.2369523E-03
     +,   2.2599716E-03,   2.2875564E-03,   2.3198177E-03
     +,   2.3566487E-03,   2.3978341E-03,   2.4431467E-03
     +,   2.4924274E-03,   2.5456522E-03,   2.6029348E-03
     +,   2.6645097E-03,   2.7306515E-03,   2.8015585E-03
     +,   2.8772482E-03,   2.9574276E-03,   3.0414285E-03
     +,   3.1281929E-03,   3.2163006E-03,   3.3040934E-03
     +,   3.3898370E-03,   3.4719107E-03,   3.5489686E-03
     +,   3.6200879E-03,   3.6848420E-03,   3.7432665E-03
     +,   3.7958766E-03,   3.8436018E-03,   3.8878019E-03
     +,   3.9303112E-03,   3.9735567E-03,   4.0206336E-03
     +,   4.0752827E-03,   4.1415901E-03,   4.2233923E-03
     +,   4.3233451E-03,   4.4418923E-03,   4.5763138E-03
     +,   4.7203046E-03,   4.8643267E-03,   4.9968190E-03
     +,   5.1061520E-03,   5.1828818E-03,   5.2217874E-03
     +,   5.2230828E-03,   5.1924759E-03,   5.1399195E-03
     +,   5.0773779E-03,   5.0161821E-03,   4.9647219E-03
     +,   4.9270303E-03,   4.9027465E-03,   4.8882589E-03
     +,   4.8786248E-03,   4.8695710E-03,   4.8589227E-03
     +,   4.8471354E-03,   4.8369295E-03,   4.8323604E-03
     +,   4.8377737E-03,   4.8569031E-03,   4.8922473E-03
     +,   4.9446113E-03,   5.0126677E-03,   5.0924583E-03
     +,   5.1771454E-03,   5.2571786E-03,   5.3211586E-03
     +,   5.3574829E-03,   5.3563910E-03,   5.3119436E-03
     +,   5.2233678E-03,   5.0953524E-03,   4.9372469E-03
     +,   4.7613583E-03,   4.5807981E-03,   4.4073616E-03
     +,   4.2498815E-03,   4.1132686E-03,   3.9982833E-03
     +,   3.9019927E-03,   3.8186964E-03,   3.7411281E-03
     +,   3.6616887E-03,   3.5735578E-03,   3.4715089E-03
     +,   3.3523771E-03,   3.2151772E-03,   3.0608962E-03
     +,   2.8921089E-03,   2.7124239E-03,   2.5259575E-03
     +,   2.3368772E-03,   2.1490341E-03,   1.9657584E-03
     +,   1.7897664E-03,   1.6231247E-03,   1.4672874E-03
     +,   1.3231582E-03,   1.1911435E-03,   1.0712631E-03
     +,   9.6318591E-04,   8.6633727E-04,   7.7995606E-04
     +,   7.0317765E-04,   6.3507247E-04,   5.7473528E-04
     +,   5.2129757E-04,   4.7395690E-04,   4.3199045E-04
     +,   3.9474724E-04,   3.6165441E-04,   3.3219645E-04
     +,   3.0591496E-04,   2.8239700E-04,   2.6126963E-04
     +,   2.4219918E-04,   2.2488309E-04,   2.0905881E-04
     +,   1.9449725E-04,   1.8100334E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wano_fus_100 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wano_fus_105(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  1.4378655E-06,   1.4847623E-06
     +,   1.5331088E-06,   1.5829578E-06,   1.6343681E-06
     +,   1.6874014E-06,   1.7421187E-06,   1.7985882E-06
     +,   1.8568805E-06,   1.9170670E-06,   1.9792251E-06
     +,   2.0434343E-06,   2.1097815E-06,   2.1783501E-06
     +,   2.2492327E-06,   2.3225264E-06,   2.3983268E-06
     +,   2.4767389E-06,   2.5578699E-06,   2.6418281E-06
     +,   2.7287294E-06,   2.8186942E-06,   2.9118419E-06
     +,   3.0082995E-06,   3.1081991E-06,   3.2116702E-06
     +,   3.3188526E-06,   3.4298869E-06,   3.5449134E-06
     +,   3.6640804E-06,   3.7875388E-06,   3.9154347E-06
     +,   4.0479244E-06,   4.1851649E-06,   4.3273085E-06
     +,   4.4745125E-06,   4.6269392E-06,   4.7847411E-06
     +,   4.9480768E-06,   5.1171032E-06,   5.2919777E-06
     +,   5.4728453E-06,   5.6598597E-06,   5.8531664E-06
     +,   6.0529092E-06,   6.2592189E-06,   6.4722331E-06
     +,   6.6920661E-06,   6.9188391E-06,   7.1526601E-06
     +,   7.3936340E-06,   7.6418391E-06,   7.8973590E-06
     +,   8.1602639E-06,   8.4305975E-06,   8.7084054E-06
     +,   8.9937203E-06,   9.2865394E-06,   9.5868645E-06
     +,   9.8946812E-06,   1.0209935E-05,   1.0532578E-05
     +,   1.0862537E-05,   1.1199707E-05,   1.1543979E-05
     +,   1.1895229E-05,   1.2253286E-05,   1.2617987E-05
     +,   1.2989147E-05,   1.3366541E-05,   1.3749947E-05
     +,   1.4139119E-05,   1.4533807E-05,   1.4933718E-05
     +,   1.5338584E-05,   1.5748086E-05,   1.6161954E-05
     +,   1.6579874E-05,   1.7001526E-05,   1.7426653E-05
     +,   1.7854964E-05,   1.8286182E-05,   1.8720120E-05
     +,   1.9156569E-05,   1.9595378E-05,   2.0036510E-05
     +,   2.0479933E-05,   2.0925787E-05,   2.1374259E-05
     +,   2.1825708E-05,   2.2280621E-05,   2.2739743E-05
     +,   2.3203977E-05,   2.3674491E-05,   2.4152814E-05
     +,   2.4640762E-05,   2.5140556E-05,   2.5654950E-05
     +,   2.6187123E-05,   2.6740970E-05,   2.7320992E-05
     +,   2.7932489E-05,   2.8581608E-05,   2.9275563E-05
     +,   3.0022535E-05,   3.0832045E-05,   3.1714866E-05
     +,   3.2683249E-05,   3.3751014E-05,   3.4933841E-05
     +,   3.6249072E-05,   3.7716247E-05,   3.9356830E-05
     +,   4.1194515E-05,   4.3255161E-05,   4.5567180E-05
     +,   4.8160931E-05,   5.1069452E-05,   5.4327662E-05
     +,   5.7972487E-05,   6.2043189E-05,   6.6580025E-05
     +,   7.1625203E-05,   7.7221346E-05,   8.3411695E-05
     +,   9.0239068E-05,   9.7746437E-05,   1.0597461E-04
     +,   1.1496224E-04,   1.2474619E-04,   1.3535868E-04
     +,   1.4682741E-04,   1.5917636E-04,   1.7242144E-04
     +,   1.8657427E-04,   2.0163733E-04,   2.1760608E-04
     +,   2.3446685E-04,   2.5219942E-04,   2.7077223E-04
     +,   2.9014802E-04,   3.1027876E-04,   3.3110857E-04
     +,   3.5257655E-04,   3.7461284E-04,   3.9714243E-04
     +,   4.2008905E-04,   4.4337154E-04,   4.6690815E-04
     +,   4.9062184E-04,   5.1443704E-04,   5.3828495E-04
     +,   5.6210859E-04,   5.8586081E-04,   6.0951017E-04
     +,   6.3304295E-04,   6.5646716E-04,   6.7981123E-04
     +,   7.0313015E-04,   7.2650239E-04,   7.5003260E-04
     +,   7.7384972E-04,   7.9810788E-04,   8.2298188E-04
     +,   8.4866222E-04,   8.7535282E-04,   9.0326398E-04
     +,   9.3260698E-04,   9.6358859E-04,   9.9640549E-04
     +,   1.0312329E-03,   1.0682249E-03,   1.1075068E-03
     +,   1.1491776E-03,   1.1933033E-03,   1.2399169E-03
     +,   1.2890216E-03,   1.3405897E-03,   1.3945602E-03
     +,   1.4508460E-03,   1.5093097E-03,   1.5697775E-03
     +,   1.6320043E-03,   1.6956714E-03,   1.7603668E-03
     +,   1.8255727E-03,   1.8906641E-03,   1.9549241E-03
     +,   2.0175513E-03,   2.0777269E-03,   2.1346582E-03
     +,   2.1876753E-03,   2.2362960E-03,   2.2803028E-03
     +,   2.3197955E-03,   2.3552184E-03,   2.3873465E-03
     +,   2.4172426E-03,   2.4461732E-03,   2.4755052E-03
     +,   2.5066079E-03,   2.5407516E-03,   2.5790206E-03
     +,   2.6222714E-03,   2.6710816E-03,   2.7257181E-03
     +,   2.7861279E-03,   2.8518988E-03,   2.9222593E-03
     +,   2.9960459E-03,   3.0717200E-03,   3.1474377E-03
     +,   3.2211528E-03,   3.2907967E-03,   3.3544905E-03
     +,   3.4107729E-03,   3.4588114E-03,   3.4985279E-03
     +,   3.5306527E-03,   3.5566392E-03,   3.5784710E-03
     +,   3.5983976E-03,   3.6185919E-03,   3.6408275E-03
     +,   3.6662100E-03,   3.6949909E-03,   3.7265278E-03
     +,   3.7593483E-03,   3.7913686E-03,   3.8201620E-03
     +,   3.8433028E-03,   3.8586815E-03,   3.8647535E-03
     +,   3.8607079E-03,   3.8464880E-03,   3.8227353E-03
     +,   3.7906093E-03,   3.7515869E-03,   3.7072324E-03
     +,   3.6590099E-03,   3.6081409E-03,   3.5555493E-03
     +,   3.5018336E-03,   3.4473005E-03,   3.3920303E-03
     +,   3.3359625E-03,   3.2789581E-03,   3.2208860E-03
     +,   3.1616939E-03,   3.1014711E-03,   3.0405102E-03
     +,   2.9793219E-03,   2.9186739E-03,   2.8595573E-03
     +,   2.8031620E-03,   2.7508102E-03,   2.7039181E-03
     +,   2.6639556E-03,   2.6324475E-03,   2.6110136E-03
     +,   2.6014554E-03,   2.6058527E-03,   2.6266656E-03
     +,   2.6667807E-03,   2.7294750E-03,   2.8182524E-03
     +,   2.9365537E-03,   3.0873297E-03,   3.2725467E-03
     +,   3.4925940E-03,   3.7458232E-03,   4.0282006E-03
     +,   4.3332330E-03,   4.6522813E-03,   4.9752244E-03
     +,   5.2914023E-03,   5.5908188E-03,   5.8651972E-03
     +,   6.1086500E-03,   6.3178227E-03,   6.4912578E-03
     +,   6.6283792E-03,   6.7281690E-03,   6.7881513E-03
     +,   6.8040099E-03,   6.7699486E-03,   6.6798120E-03
     +,   6.5286104E-03,   6.3139708E-03,   6.0371910E-03
     +,   5.7035433E-03,   5.3219395E-03,   4.9038962E-03
     +,   4.4623897E-03,   4.0105311E-03,   3.5605330E-03
     +,   3.1230121E-03,   2.7064630E-03,   2.3173720E-03
     +,   1.9601737E-03,   1.6375221E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wano_fus_105 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wano_fus_107(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  4.6637056E-06,   4.7780131E-06
     +,   4.8935622E-06,   5.0103149E-06,   5.1282414E-06
     +,   5.2473097E-06,   5.3674848E-06,   5.4887378E-06
     +,   5.6110366E-06,   5.7343505E-06,   5.8586497E-06
     +,   5.9839103E-06,   6.1101082E-06,   6.2372173E-06
     +,   6.3652192E-06,   6.4941005E-06,   6.6238426E-06
     +,   6.7544415E-06,   6.8858926E-06,   7.0181941E-06
     +,   7.1513573E-06,   7.2853923E-06,   7.4203176E-06
     +,   7.5561634E-06,   7.6929655E-06,   7.8307667E-06
     +,   7.9696229E-06,   8.1096032E-06,   8.2507759E-06
     +,   8.3932355E-06,   8.5370857E-06,   8.6824375E-06
     +,   8.8294273E-06,   8.9782061E-06,   9.1289339E-06
     +,   9.2818009E-06,   9.4370143E-06,   9.5947980E-06
     +,   9.7554030E-06,   9.9191084E-06,   1.0086216E-05
     +,   1.0257053E-05,   1.0431981E-05,   1.0611387E-05
     +,   1.0795704E-05,   1.0985385E-05,   1.1180936E-05
     +,   1.1382883E-05,   1.1591813E-05,   1.1808346E-05
     +,   1.2033155E-05,   1.2266953E-05,   1.2510509E-05
     +,   1.2764648E-05,   1.3030238E-05,   1.3308219E-05
     +,   1.3599583E-05,   1.3905380E-05,   1.4226730E-05
     +,   1.4564826E-05,   1.4920899E-05,   1.5296271E-05
     +,   1.5692354E-05,   1.6110575E-05,   1.6552482E-05
     +,   1.7019682E-05,   1.7513839E-05,   1.8036706E-05
     +,   1.8590117E-05,   1.9175939E-05,   1.9796156E-05
     +,   2.0452799E-05,   2.1147986E-05,   2.1883863E-05
     +,   2.2662698E-05,   2.3486744E-05,   2.4358435E-05
     +,   2.5280169E-05,   2.6254398E-05,   2.7283746E-05
     +,   2.8370792E-05,   2.9518156E-05,   3.0728665E-05
     +,   3.2005060E-05,   3.3350163E-05,   3.4766988E-05
     +,   3.6258447E-05,   3.7827722E-05,   3.9477938E-05
     +,   4.1212337E-05,   4.3034226E-05,   4.4947225E-05
     +,   4.6954847E-05,   4.9060745E-05,   5.1268973E-05
     +,   5.3583473E-05,   5.6008357E-05,   5.8548194E-05
     +,   6.1207364E-05,   6.3990839E-05,   6.6903500E-05
     +,   6.9950511E-05,   7.3137169E-05,   7.6469303E-05
     +,   7.9952508E-05,   8.3593033E-05,   8.7397006E-05
     +,   9.1370799E-05,   9.5520845E-05,   9.9854187E-05
     +,   1.0437733E-04,   1.0909762E-04,   1.1402192E-04
     +,   1.1915740E-04,   1.2451100E-04,   1.3009027E-04
     +,   1.3590198E-04,   1.4195369E-04,   1.4825218E-04
     +,   1.5480419E-04,   1.6161695E-04,   1.6869657E-04
     +,   1.7604989E-04,   1.8368276E-04,   1.9160091E-04
     +,   1.9980939E-04,   2.0831371E-04,   2.1711795E-04
     +,   2.2622549E-04,   2.3564025E-04,   2.4536415E-04
     +,   2.5539851E-04,   2.6574489E-04,   2.7640251E-04
     +,   2.8737108E-04,   2.9864858E-04,   3.1023248E-04
     +,   3.2211901E-04,   3.3430554E-04,   3.4678675E-04
     +,   3.5955978E-04,   3.7261969E-04,   3.8596263E-04
     +,   3.9958721E-04,   4.1349145E-04,   4.2767549E-04
     +,   4.4214356E-04,   4.5690127E-04,   4.7195717E-04
     +,   4.8732638E-04,   5.0302694E-04,   5.1908160E-04
     +,   5.3552084E-04,   5.5237958E-04,   5.6969951E-04
     +,   5.8752799E-04,   6.0592208E-04,   6.2494219E-04
     +,   6.4465764E-04,   6.6514447E-04,   6.8648567E-04
     +,   7.0877164E-04,   7.3210342E-04,   7.5659074E-04
     +,   7.8235526E-04,   8.0953009E-04,   8.3826284E-04
     +,   8.6871523E-04,   9.0106693E-04,   9.3551324E-04
     +,   9.7226206E-04,   1.0115320E-03,   1.0535505E-03
     +,   1.0985514E-03,   1.1467680E-03,   1.1984255E-03
     +,   1.2537397E-03,   1.3129107E-03,   1.3761212E-03
     +,   1.4435422E-03,   1.5153174E-03,   1.5915867E-03
     +,   1.6724747E-03,   1.7581054E-03,   1.8486108E-03
     +,   1.9441344E-03,   2.0448430E-03,   2.1509200E-03
     +,   2.2625355E-03,   2.3798195E-03,   2.5028037E-03
     +,   2.6313371E-03,   2.7649996E-03,   2.9029951E-03
     +,   3.0440958E-03,   3.1866143E-03,   3.3284337E-03
     +,   3.4671803E-03,   3.6003883E-03,   3.7258002E-03
     +,   3.8416670E-03,   3.9470461E-03,   4.0420000E-03
     +,   4.1277003E-03,   4.2063724E-03,   4.2810477E-03
     +,   4.3551982E-03,   4.4322652E-03,   4.5151054E-03
     +,   4.6054926E-03,   4.7036861E-03,   4.8081786E-03
     +,   4.9156710E-03,   5.0213034E-03,   5.1191170E-03
     +,   5.2026967E-03,   5.2659605E-03,   5.3038681E-03
     +,   5.3130686E-03,   5.2922438E-03,   5.2421833E-03
     +,   5.1655909E-03,   5.0665820E-03,   4.9501103E-03
     +,   4.8213140E-03,   4.6849959E-03,   4.5452071E-03
     +,   4.4050938E-03,   4.2668576E-03,   4.1319239E-03
     +,   4.0011131E-03,   3.8748635E-03,   3.7533829E-03
     +,   3.6367613E-03,   3.5250392E-03,   3.4181769E-03
     +,   3.3160755E-03,   3.2185637E-03,   3.1254308E-03
     +,   3.0364811E-03,   2.9516050E-03,   2.8708396E-03
     +,   2.7944022E-03,   2.7226990E-03,   2.6562987E-03
     +,   2.5958782E-03,   2.5421197E-03,   2.4956539E-03
     +,   2.4569808E-03,   2.4264241E-03,   2.4041182E-03
     +,   2.3900219E-03,   2.3839429E-03,   2.3855942E-03
     +,   2.3946261E-03,   2.4106696E-03,   2.4333533E-03
     +,   2.4623114E-03,   2.4971620E-03,   2.5374938E-03
     +,   2.5828357E-03,   2.6326491E-03,   2.6863469E-03
     +,   2.7433217E-03,   2.8030453E-03,   2.8651878E-03
     +,   2.9297634E-03,   2.9973162E-03,   3.0690588E-03
     +,   3.1470004E-03,   3.2339895E-03,   3.3336829E-03
     +,   3.4503983E-03,   3.5888655E-03,   3.7538907E-03
     +,   3.9499025E-03,   4.1805161E-03,   4.4480357E-03
     +,   4.7530690E-03,   5.0942171E-03,   5.4678097E-03
     +,   5.8679674E-03,   6.2865578E-03,   6.7133736E-03
     +,   7.1362457E-03,   7.5413790E-03,   7.9133427E-03
     +,   8.2355458E-03,   8.4907608E-03,   8.6619528E-03
     +,   8.7335203E-03,   8.6926986E-03,   8.5311281E-03
     +,   8.2462318E-03,   7.8421822E-03,   7.3301867E-03
     +,   6.7280582E-03,   6.0587595E-03,   5.3488198E-03
     +,   4.6259277E-03,   3.9166505E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wano_fus_107 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wano_fus_110(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  1.7526033E-06,   1.8199930E-06
     +,   1.8895093E-06,   1.9611989E-06,   2.0351138E-06
     +,   2.1113053E-06,   2.1898227E-06,   2.2707204E-06
     +,   2.3540529E-06,   2.4398717E-06,   2.5282332E-06
     +,   2.6191944E-06,   2.7128144E-06,   2.8091483E-06
     +,   2.9082585E-06,   3.0102078E-06,   3.1150569E-06
     +,   3.2228716E-06,   3.3337228E-06,   3.4476750E-06
     +,   3.5648025E-06,   3.6851834E-06,   3.8088906E-06
     +,   3.9360098E-06,   4.0666287E-06,   4.2008337E-06
     +,   4.3387236E-06,   4.4804033E-06,   4.6259756E-06
     +,   4.7755607E-06,   4.9292858E-06,   5.0872800E-06
     +,   5.2496907E-06,   5.4166794E-06,   5.5884079E-06
     +,   5.7650664E-06,   5.9468593E-06,   6.1339988E-06
     +,   6.3267303E-06,   6.5253153E-06,   6.7300452E-06
     +,   6.9412272E-06,   7.1592085E-06,   7.3843667E-06
     +,   7.6171164E-06,   7.8579005E-06,   8.1072203E-06
     +,   8.3656041E-06,   8.6336404E-06,   8.9119694E-06
     +,   9.2012897E-06,   9.5023443E-06,   9.8159535E-06
     +,   1.0143009E-05,   1.0484450E-05,   1.0841315E-05
     +,   1.1214715E-05,   1.1605820E-05,   1.2015917E-05
     +,   1.2446362E-05,   1.2898595E-05,   1.3374156E-05
     +,   1.3874691E-05,   1.4401906E-05,   1.4957631E-05
     +,   1.5543792E-05,   1.6162376E-05,   1.6815489E-05
     +,   1.7505354E-05,   1.8234210E-05,   1.9004441E-05
     +,   1.9818497E-05,   2.0678915E-05,   2.1588270E-05
     +,   2.2549257E-05,   2.3564542E-05,   2.4636998E-05
     +,   2.5769430E-05,   2.6964675E-05,   2.8225761E-05
     +,   2.9555637E-05,   3.0957257E-05,   3.2433829E-05
     +,   3.3988395E-05,   3.5624096E-05,   3.7344296E-05
     +,   3.9152212E-05,   4.1051404E-05,   4.3045355E-05
     +,   4.5137785E-05,   4.7332462E-05,   4.9633694E-05
     +,   5.2045740E-05,   5.4573153E-05,   5.7221168E-05
     +,   5.9995076E-05,   6.2900661E-05,   6.5944543E-05
     +,   6.9133450E-05,   7.2475210E-05,   7.5977972E-05
     +,   7.9650716E-05,   8.3503022E-05,   8.7545704E-05
     +,   9.1789690E-05,   9.6247430E-05,   1.0093157E-04
     +,   1.0585556E-04,   1.1103346E-04,   1.1648023E-04
     +,   1.2221055E-04,   1.2824028E-04,   1.3458460E-04
     +,   1.4125886E-04,   1.4827779E-04,   1.5565660E-04
     +,   1.6340826E-04,   1.7154643E-04,   1.8008235E-04
     +,   1.8902612E-04,   1.9838715E-04,   2.0817202E-04
     +,   2.1838718E-04,   2.2903652E-04,   2.4012262E-04
     +,   2.5164659E-04,   2.6360992E-04,   2.7601246E-04
     +,   2.8885389E-04,   3.0213624E-04,   3.1586125E-04
     +,   3.3003301E-04,   3.4466019E-04,   3.5975259E-04
     +,   3.7532748E-04,   3.9140540E-04,   4.0801332E-04
     +,   4.2518371E-04,   4.4295771E-04,   4.6138006E-04
     +,   4.8050427E-04,   5.0038641E-04,   5.2108651E-04
     +,   5.4266886E-04,   5.6519551E-04,   5.8872520E-04
     +,   6.1331451E-04,   6.3900813E-04,   6.6583918E-04
     +,   6.9382857E-04,   7.2297553E-04,   7.5326097E-04
     +,   7.8464614E-04,   8.1706810E-04,   8.5044472E-04
     +,   8.8467711E-04,   9.1965770E-04,   9.5527217E-04
     +,   9.9141919E-04,   1.0280153E-03,   1.0650165E-03
     +,   1.1024317E-03,   1.1403479E-03,   1.1789449E-03
     +,   1.2185092E-03,   1.2594501E-03,   1.3023058E-03
     +,   1.3477379E-03,   1.3965216E-03,   1.4495177E-03
     +,   1.5076292E-03,   1.5717514E-03,   1.6427111E-03
     +,   1.7212030E-03,   1.8077287E-03,   1.9025359E-03
     +,   2.0056039E-03,   2.1166545E-03,   2.2351991E-03
     +,   2.3606669E-03,   2.4925172E-03,   2.6304608E-03
     +,   2.7745841E-03,   2.9254940E-03,   3.0843250E-03
     +,   3.2526162E-03,   3.4320583E-03,   3.6240700E-03
     +,   3.8293351E-03,   4.0473975E-03,   4.2763809E-03
     +,   4.5129852E-03,   4.7527244E-03,   4.9903649E-03
     +,   5.2205659E-03,   5.4384805E-03,   5.6402865E-03
     +,   5.8236415E-03,   5.9880237E-03,   6.1350046E-03
     +,   6.2685814E-03,   6.3952534E-03,   6.5236608E-03
     +,   6.6636303E-03,   6.8243360E-03,   7.0118369E-03
     +,   7.2265477E-03,   7.4614943E-03,   7.7022770E-03
     +,   7.9290848E-03,   8.1208311E-03,   8.2603274E-03
     +,   8.3392030E-03,   8.3609689E-03,   8.3410302E-03
     +,   8.3036069E-03,   8.2758535E-03,   8.2810419E-03
     +,   8.3326651E-03,   8.4311860E-03,   8.5646724E-03
     +,   8.7128198E-03,   8.8530406E-03,   8.9664720E-03
     +,   9.0419408E-03,   9.0767816E-03,   9.0748146E-03
     +,   9.0427659E-03,   8.9868577E-03,   8.9109149E-03
     +,   8.8164657E-03,   8.7041762E-03,   8.5756937E-03
     +,   8.4346533E-03,   8.2865786E-03,   8.1377542E-03
     +,   7.9939160E-03,   7.8594005E-03,   7.7368869E-03
     +,   7.6276166E-03,   7.5317523E-03,   7.4483366E-03
     +,   7.3752338E-03,   7.3090708E-03,   7.2455052E-03
     +,   7.1797818E-03,   7.1074506E-03,   7.0248093E-03
     +,   6.9289426E-03,   6.8175555E-03,   6.6886619E-03
     +,   6.5405443E-03,   6.3721519E-03,   6.1836676E-03
     +,   5.9771505E-03,   5.7568490E-03,   5.5290111E-03
     +,   5.3011742E-03,   5.0812624E-03,   4.8765573E-03
     +,   4.6929652E-03,   4.5346874E-03,   4.4041667E-03
     +,   4.3023680E-03,   4.2290748E-03,   4.1831634E-03
     +,   4.1627609E-03,   4.1653435E-03,   4.1878088E-03
     +,   4.2265914E-03,   4.2778645E-03,   4.3378342E-03
     +,   4.4030766E-03,   4.4708578E-03,   4.5393561E-03
     +,   4.6077170E-03,   4.6759383E-03,   4.7445525E-03
     +,   4.8141386E-03,   4.8847678E-03,   4.9554477E-03
     +,   5.0237039E-03,   5.0853761E-03,   5.1347399E-03
     +,   5.1649255E-03,   5.1686289E-03,   5.1389346E-03
     +,   5.0702151E-03,   4.9588582E-03,   4.8037465E-03
     +,   4.6064002E-03,   4.3708184E-03,   4.1029891E-03
     +,   3.8102972E-03,   3.5008178E-03,   3.1826566E-03
     +,   2.8634563E-03,   2.5499116E-03,   2.2477116E-03
     +,   1.9613507E-03,   1.6941829E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wano_fus_110 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wano_fus_115(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  3.4556979E-06,   3.5479948E-06
     +,   3.6428194E-06,   3.7402488E-06,   3.8403691E-06
     +,   3.9432689E-06,   4.0490359E-06,   4.1577664E-06
     +,   4.2695606E-06,   4.3845171E-06,   4.5027432E-06
     +,   4.6243508E-06,   4.7494577E-06,   4.8781794E-06
     +,   5.0106441E-06,   5.1469856E-06,   5.2873352E-06
     +,   5.4318375E-06,   5.5806454E-06,   5.7339093E-06
     +,   5.8917917E-06,   6.0544667E-06,   6.2221052E-06
     +,   6.3948937E-06,   6.5730296E-06,   6.7567057E-06
     +,   6.9461357E-06,   7.1415411E-06,   7.3431420E-06
     +,   7.5511794E-06,   7.7659024E-06,   7.9875617E-06
     +,   8.2164261E-06,   8.4527765E-06,   8.6968921E-06
     +,   8.9490713E-06,   9.2096298E-06,   9.4788738E-06
     +,   9.7571365E-06,   1.0044759E-05,   1.0342091E-05
     +,   1.0649480E-05,   1.0967302E-05,   1.1295932E-05
     +,   1.1635762E-05,   1.1987172E-05,   1.2350579E-05
     +,   1.2726372E-05,   1.3114973E-05,   1.3516804E-05
     +,   1.3932296E-05,   1.4361854E-05,   1.4805923E-05
     +,   1.5264939E-05,   1.5739315E-05,   1.6229491E-05
     +,   1.6735905E-05,   1.7258959E-05,   1.7799084E-05
     +,   1.8356712E-05,   1.8932220E-05,   1.9526024E-05
     +,   2.0138532E-05,   2.0770098E-05,   2.1421109E-05
     +,   2.2091945E-05,   2.2782928E-05,   2.3494418E-05
     +,   2.4226760E-05,   2.4980251E-05,   2.5755224E-05
     +,   2.6551983E-05,   2.7370863E-05,   2.8212118E-05
     +,   2.9076098E-05,   2.9963059E-05,   3.0873380E-05
     +,   3.1807365E-05,   3.2765325E-05,   3.3747699E-05
     +,   3.4754870E-05,   3.5787238E-05,   3.6845362E-05
     +,   3.7929763E-05,   3.9041017E-05,   4.0179890E-05
     +,   4.1347092E-05,   4.2543597E-05,   4.3770375E-05
     +,   4.5028537E-05,   4.6319372E-05,   4.7644418E-05
     +,   4.9005295E-05,   5.0403814E-05,   5.1842202E-05
     +,   5.3322787E-05,   5.4848158E-05,   5.6421446E-05
     +,   5.8045858E-05,   5.9725269E-05,   6.1463783E-05
     +,   6.3266009E-05,   6.5136999E-05,   6.7082583E-05
     +,   6.9108821E-05,   7.1222763E-05,   7.3431816E-05
     +,   7.5744218E-05,   7.8168792E-05,   8.0715385E-05
     +,   8.3394247E-05,   8.6216780E-05,   8.9194909E-05
     +,   9.2341295E-05,   9.5669355E-05,   9.9193458E-05
     +,   1.0292811E-04,   1.0688887E-04,   1.1109145E-04
     +,   1.1555156E-04,   1.2028583E-04,   1.2530989E-04
     +,   1.3064004E-04,   1.3629138E-04,   1.4227856E-04
     +,   1.4861484E-04,   1.5531298E-04,   1.6238324E-04
     +,   1.6983392E-04,   1.7767191E-04,   1.8590075E-04
     +,   1.9452094E-04,   2.0353102E-04,   2.1292492E-04
     +,   2.2269467E-04,   2.3282811E-04,   2.4330990E-04
     +,   2.5412190E-04,   2.6524457E-04,   2.7665502E-04
     +,   2.8833130E-04,   3.0025039E-04,   3.1239103E-04
     +,   3.2473638E-04,   3.3727335E-04,   3.4999594E-04
     +,   3.6290914E-04,   3.7602795E-04,   3.8938117E-04
     +,   4.0301605E-04,   4.1699572E-04,   4.3140352E-04
     +,   4.4634572E-04,   4.6194813E-04,   4.7835748E-04
     +,   4.9573975E-04,   5.1427889E-04,   5.3416943E-04
     +,   5.5561628E-04,   5.7882513E-04,   6.0399948E-04
     +,   6.3133345E-04,   6.6101045E-04,   6.9319952E-04
     +,   7.2805246E-04,   7.6571124E-04,   8.0631080E-04
     +,   8.4999012E-04,   8.9690706E-04,   9.4725046E-04
     +,   1.0012476E-03,   1.0591850E-03,   1.1214103E-03
     +,   1.1883456E-03,   1.2604845E-03,   1.3383776E-03
     +,   1.4226313E-03,   1.5138835E-03,   1.6127885E-03
     +,   1.7199924E-03,   1.8360985E-03,   1.9616720E-03
     +,   2.0972101E-03,   2.2431838E-03,   2.4000702E-03
     +,   2.5684380E-03,   2.7490596E-03,   2.9429828E-03
     +,   3.1515372E-03,   3.3762718E-03,   3.6186650E-03
     +,   3.8797094E-03,   4.1592713E-03,   4.4554076E-03
     +,   4.7638346E-03,   5.0776228E-03,   5.3873896E-03
     +,   5.6820940E-03,   5.9503070E-03,   6.1818827E-03
     +,   6.3698804E-03,   6.5121870E-03,   6.6126883E-03
     +,   6.6816020E-03,   6.7347791E-03,   6.7917844E-03
     +,   6.8729324E-03,   6.9954609E-03,   7.1696606E-03
     +,   7.3957690E-03,   7.6627806E-03,   7.9499474E-03
     +,   8.2311230E-03,   8.4809680E-03,   8.6817108E-03
     +,   8.8280393E-03,   8.9290757E-03,   9.0060132E-03
     +,   9.0864254E-03,   9.1960346E-03,   9.3505494E-03
     +,   9.5498180E-03,   9.7765392E-03,   1.0000470E-02
     +,   1.0187253E-02,   1.0309038E-02,   1.0353059E-02
     +,   1.0325136E-02,   1.0246676E-02,   1.0147111E-02
     +,   1.0054738E-02,   9.9896556E-03,   9.9605359E-03
     +,   9.9651841E-03,   9.9934069E-03,   1.0030692E-02
     +,   1.0061774E-02,   1.0073911E-02,   1.0059410E-02
     +,   1.0017023E-02,   9.9513456E-03,   9.8705897E-03
     +,   9.7833816E-03,   9.6961195E-03,   9.6118273E-03
     +,   9.5305173E-03,   9.4504338E-03,   9.3694702E-03
     +,   9.2859315E-03,   9.1986721E-03,   9.1066668E-03
     +,   9.0083359E-03,   8.9009218E-03,   8.7804506E-03
     +,   8.6423112E-03,   8.4826015E-03,   8.2994904E-03
     +,   8.0943704E-03,   7.8722630E-03,   7.6414612E-03
     +,   7.4126665E-03,   7.1979291E-03,   7.0092040E-03
     +,   6.8569970E-03,   6.7487815E-03,   6.6876672E-03
     +,   6.6714911E-03,   6.6928426E-03,   6.7400713E-03
     +,   6.7989761E-03,   6.8551842E-03,   6.8962513E-03
     +,   6.9133858E-03,   6.9022910E-03,   6.8630488E-03
     +,   6.7992155E-03,   6.7163780E-03,   6.6204919E-03
     +,   6.5164203E-03,   6.4069210E-03,   6.2923189E-03
     +,   6.1706910E-03,   6.0386313E-03,   5.8922167E-03
     +,   5.7278778E-03,   5.5430597E-03,   5.3365617E-03
     +,   5.1084687E-03,   4.8598950E-03,   4.5926939E-03
     +,   4.3091467E-03,   4.0119393E-03,   3.7040964E-03
     +,   3.3891166E-03,   3.0710187E-03,   2.7542682E-03
     +,   2.4436787E-03,   2.1440063E-03,   1.8597922E-03
     +,   1.5949119E-03,   1.3523512E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wano_fus_115 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wano_fus_120(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  1.6024069E-06,   1.6519642E-06
     +,   1.7029630E-06,   1.7554594E-06,   1.8095163E-06
     +,   1.8652011E-06,   1.9225831E-06,   1.9817403E-06
     +,   2.0427551E-06,   2.1057137E-06,   2.1707124E-06
     +,   2.2378529E-06,   2.3072453E-06,   2.3790058E-06
     +,   2.4532612E-06,   2.5301497E-06,   2.6098141E-06
     +,   2.6924131E-06,   2.7781177E-06,   2.8671045E-06
     +,   2.9595717E-06,   3.0557285E-06,   3.1557959E-06
     +,   3.2600153E-06,   3.3686467E-06,   3.4819620E-06
     +,   3.6002552E-06,   3.7238453E-06,   3.8530625E-06
     +,   3.9882671E-06,   4.1298422E-06,   4.2781899E-06
     +,   4.4337435E-06,   4.5969618E-06,   4.7683252E-06
     +,   4.9483497E-06,   5.1375805E-06,   5.3365829E-06
     +,   5.5459632E-06,   5.7663547E-06,   5.9984286E-06
     +,   6.2428721E-06,   6.5004206E-06,   6.7718338E-06
     +,   7.0579104E-06,   7.3594661E-06,   7.6773667E-06
     +,   8.0124855E-06,   8.3657405E-06,   8.7380758E-06
     +,   9.1304619E-06,   9.5438754E-06,   9.9793351E-06
     +,   1.0437875E-05,   1.0920525E-05,   1.1428347E-05
     +,   1.1962411E-05,   1.2523772E-05,   1.3113500E-05
     +,   1.3732667E-05,   1.4382300E-05,   1.5063441E-05
     +,   1.5777117E-05,   1.6524282E-05,   1.7305892E-05
     +,   1.8122879E-05,   1.8976058E-05,   1.9866251E-05
     +,   2.0794218E-05,   2.1760596E-05,   2.2765991E-05
     +,   2.3810922E-05,   2.4895840E-05,   2.6021020E-05
     +,   2.7186741E-05,   2.8393048E-05,   2.9640049E-05
     +,   3.0927586E-05,   3.2255379E-05,   3.3623186E-05
     +,   3.5030469E-05,   3.6476587E-05,   3.7960926E-05
     +,   3.9482562E-05,   4.1040505E-05,   4.2633757E-05
     +,   4.4261033E-05,   4.5921159E-05,   4.7612684E-05
     +,   4.9334132E-05,   5.1083931E-05,   5.2860581E-05
     +,   5.4662443E-05,   5.6487785E-05,   5.8335070E-05
     +,   6.0202641E-05,   6.2088839E-05,   6.3992287E-05
     +,   6.5911445E-05,   6.7845147E-05,   6.9792208E-05
     +,   7.1751645E-05,   7.3722666E-05,   7.5704855E-05
     +,   7.7697863E-05,   7.9701909E-05,   8.1717306E-05
     +,   8.3744817E-05,   8.5785512E-05,   8.7841152E-05
     +,   8.9913694E-05,   9.2005728E-05,   9.4120311E-05
     +,   9.6261007E-05,   9.8431985E-05,   1.0063819E-04
     +,   1.0288494E-04,   1.0517867E-04,   1.0752612E-04
     +,   1.0993490E-04,   1.1241381E-04,   1.1497198E-04
     +,   1.1762001E-04,   1.2036916E-04,   1.2323192E-04
     +,   1.2622178E-04,   1.2935376E-04,   1.3264392E-04
     +,   1.3610969E-04,   1.3977032E-04,   1.4364620E-04
     +,   1.4775941E-04,   1.5213402E-04,   1.5679523E-04
     +,   1.6177057E-04,   1.6708874E-04,   1.7278008E-04
     +,   1.7887626E-04,   1.8541100E-04,   1.9241772E-04
     +,   1.9993214E-04,   2.0798894E-04,   2.1662284E-04
     +,   2.2586860E-04,   2.3575872E-04,   2.4632315E-04
     +,   2.5759023E-04,   2.6958293E-04,   2.8231920E-04
     +,   2.9581273E-04,   3.1006869E-04,   3.2508452E-04
     +,   3.4085099E-04,   3.5734850E-04,   3.7454875E-04
     +,   3.9241469E-04,   4.1090260E-04,   4.2996029E-04
     +,   4.4953494E-04,   4.6957019E-04,   4.9001421E-04
     +,   5.1082356E-04,   5.3197041E-04,   5.5345061E-04
     +,   5.7528727E-04,   5.9754337E-04,   6.2032824E-04
     +,   6.4380479E-04,   6.6819723E-04,   6.9379422E-04
     +,   7.2094623E-04,   7.5006444E-04,   7.8160909E-04
     +,   8.1607833E-04,   8.5398566E-04,   8.9583325E-04
     +,   9.4208872E-04,   9.9316332E-04,   1.0493885E-03
     +,   1.1110246E-03,   1.1782516E-03,   1.2512201E-03
     +,   1.3300794E-03,   1.4150464E-03,   1.5064579E-03
     +,   1.6048118E-03,   1.7107758E-03,   1.8251425E-03
     +,   1.9487034E-03,   2.0821097E-03,   2.2256693E-03
     +,   2.3791871E-03,   2.5418394E-03,   2.7121475E-03
     +,   2.8881205E-03,   3.0675009E-03,   3.2480718E-03
     +,   3.4280496E-03,   3.6063252E-03,   3.7826004E-03
     +,   3.9573908E-03,   4.1318554E-03,   4.3075504E-03
     +,   4.4862190E-03,   4.6696775E-03,   4.8598489E-03
     +,   5.0590588E-03,   5.2703964E-03,   5.4981015E-03
     +,   5.7475008E-03,   6.0243732E-03,   6.3334042E-03
     +,   6.6758404E-03,   7.0467885E-03,   7.4332240E-03
     +,   7.8135077E-03,   8.1597455E-03,   8.4427800E-03
     +,   8.6394669E-03,   8.7399855E-03,   8.7529281E-03
     +,   8.7056989E-03,   8.6392891E-03,   8.5982177E-03
     +,   8.6186239E-03,   8.7185316E-03,   8.8939862E-03
     +,   9.1226352E-03,   9.3728788E-03,   9.6147535E-03
     +,   9.8275123E-03,   1.0001414E-02,   1.0134186E-02
     +,   1.0225296E-02,   1.0271975E-02,   1.0268841E-02
     +,   1.0210559E-02,   1.0095570E-02,   9.9287210E-03
     +,   9.7222999E-03,   9.4953626E-03,   9.2713404E-03
     +,   9.0739466E-03,   8.9217918E-03,   8.8232392E-03
     +,   8.7738503E-03,   8.7584276E-03,   8.7572234E-03
     +,   8.7539554E-03,   8.7420335E-03,   8.7261461E-03
     +,   8.7187691E-03,   8.7337233E-03,   8.7798797E-03
     +,   8.8577420E-03,   8.9595150E-03,   9.0719126E-03
     +,   9.1796648E-03,   9.2686424E-03,   9.3284165E-03
     +,   9.3545588E-03,   9.3510402E-03,   9.3317013E-03
     +,   9.3194153E-03,   9.3414318E-03,   9.4213476E-03
     +,   9.5698675E-03,   9.7779399E-03,   1.0015575E-02
     +,   1.0237282E-02,   1.0392951E-02,   1.0439916E-02
     +,   1.0352754E-02,   1.0127869E-02,   9.7822146E-03
     +,   9.3477843E-03,   8.8635134E-03,   8.3674127E-03
     +,   7.8902068E-03,   7.4517154E-03,   7.0601744E-03
     +,   6.7136800E-03,   6.4033982E-03,   6.1171404E-03
     +,   5.8425688E-03,   5.5695176E-03,   5.2912259E-03
     +,   5.0043571E-03,   4.7083553E-03,   4.4043977E-03
     +,   4.0944144E-03,   3.7804781E-03,   3.4645081E-03
     +,   3.1484547E-03,   2.8345447E-03,   2.5255368E-03
     +,   2.2248228E-03,   1.9361755E-03,   1.6635588E-03
     +,   1.4106061E-03,   1.1802478E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wano_fus_120 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wano_fus_60(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  2.7334804E-04,   2.8829579E-04
     +,   3.0417374E-04,   3.2107651E-04,   3.3910488E-04
     +,   3.5836222E-04,   3.7895172E-04,   4.0097421E-04
     +,   4.2452503E-04,   4.4968634E-04,   4.7652650E-04
     +,   5.0509296E-04,   5.3540868E-04,   5.6746538E-04
     +,   6.0122501E-04,   6.3661620E-04,   6.7353324E-04
     +,   7.1184669E-04,   7.5140764E-04,   7.9206284E-04
     +,   8.3367957E-04,   8.7616994E-04,   9.1952388E-04
     +,   9.6385268E-04,   1.0094289E-03,   1.0567217E-03
     +,   1.1064322E-03,   1.1595020E-03,   1.2170987E-03
     +,   1.2805742E-03,   1.3513750E-03,   1.4309132E-03
     +,   1.5204186E-03,   1.6207496E-03,   1.7322215E-03
     +,   1.8544500E-03,   1.9862647E-03,   2.1256628E-03
     +,   2.2699009E-03,   2.4156386E-03,   2.5591862E-03
     +,   2.6967807E-03,   2.8249167E-03,   2.9406042E-03
     +,   3.0416148E-03,   3.1265889E-03,   3.1951105E-03
     +,   3.2475870E-03,   3.2851426E-03,   3.3093730E-03
     +,   3.3221033E-03,   3.3251387E-03,   3.3200472E-03
     +,   3.3079896E-03,   3.2896302E-03,   3.2651217E-03
     +,   3.2341762E-03,   3.1962013E-03,   3.1504643E-03
     +,   3.0962958E-03,   3.0332687E-03,   2.9613308E-03
     +,   2.8808857E-03,   2.7928075E-03,   2.6983863E-03
     +,   2.5992144E-03,   2.4970605E-03,   2.3937025E-03
     +,   2.2907855E-03,   2.1897056E-03,   2.0915058E-03
     +,   1.9968362E-03,   1.9059422E-03,   1.8187095E-03
     +,   1.7347094E-03,   1.6533247E-03,   1.5738291E-03
     +,   1.4955363E-03,   1.4178874E-03,   1.3405357E-03
     +,   1.2634129E-03,   1.1867373E-03,   1.1109823E-03
     +,   1.0368397E-03,   9.6513290E-04,   8.9671690E-04
     +,   8.3241117E-04,   7.7289745E-04,   7.1868411E-04
     +,   6.7005935E-04,   6.2708987E-04,   5.8962480E-04
     +,   5.5733928E-04,   5.2976806E-04,   5.0635025E-04
     +,   4.8648202E-04,   4.6955288E-04,   4.5497756E-04
     +,   4.4222601E-04,   4.3083332E-04,   4.2041222E-04
     +,   4.1065205E-04,   4.0131542E-04,   3.9222991E-04
     +,   3.8328217E-04,   3.7440422E-04,   3.6556640E-04
     +,   3.5676738E-04,   3.4802579E-04,   3.3937284E-04
     +,   3.3084874E-04,   3.2249599E-04,   3.1435775E-04
     +,   3.0647501E-04,   2.9888516E-04,   2.9162018E-04
     +,   2.8470778E-04,   2.7816955E-04,   2.7202259E-04
     +,   2.6627904E-04,   2.6094605E-04,   2.5602698E-04
     +,   2.5152080E-04,   2.4742368E-04,   2.4372824E-04
     +,   2.4042453E-04,   2.3749952E-04,   2.3493826E-04
     +,   2.3272380E-04,   2.3083694E-04,   2.2925722E-04
     +,   2.2796281E-04,   2.2693044E-04,   2.2613638E-04
     +,   2.2555597E-04,   2.2516443E-04,   2.2493675E-04
     +,   2.2484805E-04,   2.2487390E-04,   2.2499045E-04
     +,   2.2517459E-04,   2.2540426E-04,   2.2565828E-04
     +,   2.2591707E-04,   2.2616201E-04,   2.2637601E-04
     +,   2.2654345E-04,   2.2665002E-04,   2.2668300E-04
     +,   2.2663106E-04,   2.2648413E-04,   2.2623361E-04
     +,   2.2587205E-04,   2.2539345E-04,   2.2479276E-04
     +,   2.2406617E-04,   2.2321065E-04,   2.2222445E-04
     +,   2.2110646E-04,   2.1985659E-04,   2.1847541E-04
     +,   2.1696427E-04,   2.1532511E-04,   2.1356065E-04
     +,   2.1167409E-04,   2.0966925E-04,   2.0755043E-04
     +,   2.0532256E-04,   2.0299079E-04,   2.0056072E-04
     +,   1.9803834E-04,   1.9543017E-04,   1.9274294E-04
     +,   1.8998356E-04,   1.8715898E-04,   1.8427672E-04
     +,   1.8134438E-04,   1.7836943E-04,   1.7535975E-04
     +,   1.7232270E-04,   1.6926626E-04,   1.6619770E-04
     +,   1.6312463E-04,   1.6005426E-04,   1.5699370E-04
     +,   1.5394994E-04,   1.5092938E-04,   1.4793813E-04
     +,   1.4498220E-04,   1.4206705E-04,   1.3919800E-04
     +,   1.3637947E-04,   1.3361571E-04,   1.3091054E-04
     +,   1.2826733E-04,   1.2568889E-04,   1.2317773E-04
     +,   1.2073558E-04,   1.1836389E-04,   1.1606374E-04
     +,   1.1383564E-04,   1.1167975E-04,   1.0959588E-04
     +,   1.0758329E-04,   1.0564087E-04,   1.0376736E-04
     +,   1.0196108E-04,   1.0022012E-04,   9.8542245E-05
     +,   9.6924909E-05,   9.5365584E-05,   9.3861432E-05
     +,   9.2409507E-05,   9.1006819E-05,   8.9650122E-05
     +,   8.8336295E-05,   8.7062021E-05,   8.5824096E-05
     +,   8.4619322E-05,   8.3444473E-05,   8.2296465E-05
     +,   8.1172206E-05,   8.0068712E-05,   7.8983154E-05
     +,   7.7912795E-05,   7.6855111E-05,   7.5807533E-05
     +,   7.4767893E-05,   7.3733929E-05,   7.2703740E-05
     +,   7.1675560E-05,   7.0647780E-05,   6.9618938E-05
     +,   6.8587724E-05,   6.7553105E-05,   6.6514171E-05
     +,   6.5470165E-05,   6.4420587E-05,   6.3364976E-05
     +,   6.2303028E-05,   6.1234707E-05,   6.0160048E-05
     +,   5.9079277E-05,   5.7992609E-05,   5.6900528E-05
     +,   5.5803608E-05,   5.4702417E-05,   5.3597698E-05
     +,   5.2490359E-05,   5.1381150E-05,   5.0271152E-05
     +,   4.9161252E-05,   4.8052545E-05,   4.6946134E-05
     +,   4.5843110E-05,   4.4744655E-05,   4.3651853E-05
     +,   4.2565804E-05,   4.1487678E-05,   4.0418581E-05
     +,   3.9359609E-05,   3.8311879E-05,   3.7276357E-05
     +,   3.6254009E-05,   3.5245823E-05,   3.4252680E-05
     +,   3.3275493E-05,   3.2314987E-05,   3.1371866E-05
     +,   3.0446834E-05,   2.9540512E-05,   2.8653425E-05
     +,   2.7786105E-05,   2.6938909E-05,   2.6112179E-05
     +,   2.5306224E-05,   2.4521265E-05,   2.3757471E-05
     +,   2.3014964E-05,   2.2293734E-05,   2.1593822E-05
     +,   2.0915104E-05,   2.0257497E-05,   1.9620833E-05
     +,   1.9004949E-05,   1.8409495E-05,   1.7834222E-05
     +,   1.7278811E-05,   1.6742895E-05,   1.6226108E-05
     +,   1.5727990E-05,   1.5248144E-05,   1.4786070E-05
     +,   1.4341313E-05,   1.3913380E-05,   1.3501772E-05
     +,   1.3106007E-05,   1.2725510E-05,   1.2359785E-05
     +,   1.2008318E-05,   1.1670586E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wano_fus_60 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wano_fus_65(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  5.5960110E-05,   6.0023616E-05
     +,   6.4357875E-05,   6.8973182E-05,   7.3878393E-05
     +,   7.9080462E-05,   8.4583851E-05,   9.0390866E-05
     +,   9.6501521E-05,   1.0291315E-04,   1.0962139E-04
     +,   1.1662068E-04,   1.2390496E-04,   1.3146890E-04
     +,   1.3930986E-04,   1.4743004E-04,   1.5583803E-04
     +,   1.6455278E-04,   1.7360599E-04,   1.8304493E-04
     +,   1.9293652E-04,   2.0337003E-04,   2.1445901E-04
     +,   2.2634423E-04,   2.3919401E-04,   2.5320263E-04
     +,   2.6859008E-04,   2.8559641E-04,   3.0447464E-04
     +,   3.2548400E-04,   3.4887847E-04,   3.7489238E-04
     +,   4.0373034E-04,   4.3555215E-04,   4.7045774E-04
     +,   5.0848088E-04,   5.4958148E-04,   5.9364061E-04
     +,   6.4047182E-04,   6.8982871E-04,   7.4142806E-04
     +,   7.9497200E-04,   8.5018674E-04,   9.0685277E-04
     +,   9.6484326E-04,   1.0241490E-03,   1.0849115E-03
     +,   1.1474191E-03,   1.2121145E-03,   1.2795681E-03
     +,   1.3504382E-03,   1.4254235E-03,   1.5052088E-03
     +,   1.5904021E-03,   1.6814786E-03,   1.7787465E-03
     +,   1.8823048E-03,   1.9920161E-03,   2.1074975E-03
     +,   2.2280891E-03,   2.3528191E-03,   2.4803812E-03
     +,   2.6090902E-03,   2.7368658E-03,   2.8612751E-03
     +,   2.9796043E-03,   3.0890196E-03,   3.1868145E-03
     +,   3.2706698E-03,   3.3389512E-03,   3.3909397E-03
     +,   3.4269521E-03,   3.4483380E-03,   3.4572843E-03
     +,   3.4564859E-03,   3.4487306E-03,   3.4364199E-03
     +,   3.4212123E-03,   3.4037528E-03,   3.3836190E-03
     +,   3.3594675E-03,   3.3293392E-03,   3.2910956E-03
     +,   3.2428748E-03,   3.1834990E-03,   3.1127220E-03
     +,   3.0313635E-03,   2.9411933E-03,   2.8447213E-03
     +,   2.7448377E-03,   2.6444448E-03,   2.5460836E-03
     +,   2.4516806E-03,   2.3623772E-03,   2.2784846E-03
     +,   2.1995835E-03,   2.1246874E-03,   2.0524603E-03
     +,   1.9814668E-03,   1.9103730E-03,   1.8381290E-03
     +,   1.7640628E-03,   1.6879194E-03,   1.6098284E-03
     +,   1.5302536E-03,   1.4498746E-03,   1.3695082E-03
     +,   1.2899986E-03,   1.2121502E-03,   1.1366656E-03
     +,   1.0641353E-03,   9.9501212E-04,   9.2963717E-04
     +,   8.6824235E-04,   8.1097690E-04,   7.5790961E-04
     +,   7.0906006E-04,   6.6438707E-04,   6.2380783E-04
     +,   5.8719300E-04,   5.5436546E-04,   5.2511331E-04
     +,   4.9918424E-04,   4.7630136E-04,   4.5616689E-04
     +,   4.3847520E-04,   4.2291876E-04,   4.0920341E-04
     +,   3.9705308E-04,   3.8621592E-04,   3.7647117E-04
     +,   3.6762975E-04,   3.5953402E-04,   3.5205862E-04
     +,   3.4510499E-04,   3.3860057E-04,   3.3249272E-04
     +,   3.2674591E-04,   3.2133560E-04,   3.1624714E-04
     +,   3.1146966E-04,   3.0699576E-04,   3.0281791E-04
     +,   2.9892681E-04,   2.9531101E-04,   2.9195653E-04
     +,   2.8884551E-04,   2.8595782E-04,   2.8327090E-04
     +,   2.8075991E-04,   2.7839953E-04,   2.7616404E-04
     +,   2.7402799E-04,   2.7196747E-04,   2.6996067E-04
     +,   2.6798816E-04,   2.6603349E-04,   2.6408394E-04
     +,   2.6212999E-04,   2.6016636E-04,   2.5819131E-04
     +,   2.5620684E-04,   2.5421844E-04,   2.5223466E-04
     +,   2.5026736E-04,   2.4833062E-04,   2.4644088E-04
     +,   2.4461627E-04,   2.4287609E-04,   2.4124030E-04
     +,   2.3972990E-04,   2.3836529E-04,   2.3716679E-04
     +,   2.3615385E-04,   2.3534473E-04,   2.3475625E-04
     +,   2.3440376E-04,   2.3430021E-04,   2.3445660E-04
     +,   2.3488136E-04,   2.3558029E-04,   2.3655650E-04
     +,   2.3781019E-04,   2.3933867E-04,   2.4113609E-04
     +,   2.4319346E-04,   2.4549913E-04,   2.4803830E-04
     +,   2.5079318E-04,   2.5374314E-04,   2.5686479E-04
     +,   2.6013245E-04,   2.6351833E-04,   2.6699202E-04
     +,   2.7052153E-04,   2.7407336E-04,   2.7761268E-04
     +,   2.8110374E-04,   2.8451043E-04,   2.8779640E-04
     +,   2.9092503E-04,   2.9386059E-04,   2.9656803E-04
     +,   2.9901383E-04,   3.0116588E-04,   3.0299398E-04
     +,   3.0447022E-04,   3.0556924E-04,   3.0626851E-04
     +,   3.0654858E-04,   3.0639319E-04,   3.0578952E-04
     +,   3.0472816E-04,   3.0320362E-04,   3.0121364E-04
     +,   2.9875984E-04,   2.9584733E-04,   2.9248476E-04
     +,   2.8868389E-04,   2.8446011E-04,   2.7983161E-04
     +,   2.7481897E-04,   2.6944547E-04,   2.6373670E-04
     +,   2.5771992E-04,   2.5142444E-04,   2.4488004E-04
     +,   2.3811810E-04,   2.3116992E-04,   2.2406761E-04
     +,   2.1684318E-04,   2.0952831E-04,   2.0215366E-04
     +,   1.9474891E-04,   1.8734328E-04,   1.7996421E-04
     +,   1.7263783E-04,   1.6538854E-04,   1.5823866E-04
     +,   1.5120844E-04,   1.4431676E-04,   1.3758014E-04
     +,   1.3101334E-04,   1.2462832E-04,   1.1843580E-04
     +,   1.1244448E-04,   1.0666055E-04,   1.0108906E-04
     +,   9.5733347E-05,   9.0594593E-05,   8.5673324E-05
     +,   8.0967955E-05,   7.6476274E-05,   7.2194860E-05
     +,   6.8119363E-05,   6.4244792E-05,   6.0565199E-05
     +,   5.7074114E-05,   5.3764947E-05,   5.0630679E-05
     +,   4.7664056E-05,   4.4857792E-05,   4.2204385E-05
     +,   3.9696377E-05,   3.7326627E-05,   3.5088004E-05
     +,   3.2973690E-05,   3.0976928E-05,   2.9091228E-05
     +,   2.7310545E-05,   2.5629040E-05,   2.4041185E-05
     +,   2.2541813E-05,   2.1125947E-05,   1.9788898E-05
     +,   1.8526394E-05,   1.7334385E-05,   1.6209066E-05
     +,   1.5146928E-05,   1.4144574E-05,   1.3198972E-05
     +,   1.2307153E-05,   1.1466429E-05,   1.0674238E-05
     +,   9.9282388E-06,   9.2260416E-06,   8.5655629E-06
     +,   7.9447718E-06,   7.3617362E-06,   6.8146360E-06
     +,   6.3016719E-06,   5.8212026E-06,   5.3715748E-06
     +,   4.9512614E-06,   4.5587703E-06,   4.1926646E-06
     +,   3.8515868E-06,   3.5341482E-06,   3.2390899E-06
     +,   2.9651696E-06,   2.7111910E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wano_fus_65 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wano_fus_70(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  2.0981957E-05,   2.2506369E-05
     +,   2.4146737E-05,   2.5912459E-05,   2.7813665E-05
     +,   2.9861087E-05,   3.2065927E-05,   3.4440036E-05
     +,   3.6995756E-05,   3.9745650E-05,   4.2702759E-05
     +,   4.5880246E-05,   4.9291422E-05,   5.2949290E-05
     +,   5.6866880E-05,   6.1056817E-05,   6.5530956E-05
     +,   7.0300703E-05,   7.5376702E-05,   8.0768266E-05
     +,   8.6484004E-05,   9.2531423E-05,   9.8916411E-05
     +,   1.0564412E-04,   1.1271847E-04,   1.2014202E-04
     +,   1.2791654E-04,   1.3604308E-04,   1.4452139E-04
     +,   1.5335117E-04,   1.6253159E-04,   1.7206121E-04
     +,   1.8193887E-04,   1.9216367E-04,   2.0273450E-04
     +,   2.1365173E-04,   2.2491660E-04,   2.3653200E-04
     +,   2.4850407E-04,   2.6084276E-04,   2.7356361E-04
     +,   2.8668871E-04,   3.0025048E-04,   3.1429256E-04
     +,   3.2887282E-04,   3.4406499E-04,   3.5996185E-04
     +,   3.7667440E-04,   3.9433400E-04,   4.1309040E-04
     +,   4.3310918E-04,   4.5456630E-04,   4.7764450E-04
     +,   5.0252449E-04,   5.2937341E-04,   5.5833900E-04
     +,   5.8953604E-04,   6.2303408E-04,   6.5885083E-04
     +,   6.9694081E-04,   7.3718705E-04,   7.7940046E-04
     +,   8.2332152E-04,   8.6862192E-04,   9.1492489E-04
     +,   9.6182799E-04,   1.0089310E-03,   1.0558835E-03
     +,   1.1024311E-03,   1.1484636E-03,   1.1940646E-03
     +,   1.2395487E-03,   1.2854703E-03,   1.3326107E-03
     +,   1.3819344E-03,   1.4344958E-03,   1.4913421E-03
     +,   1.5533704E-03,   1.6212128E-03,   1.6951495E-03
     +,   1.7750452E-03,   1.8603822E-03,   1.9503690E-03
     +,   2.0440938E-03,   2.1407420E-03,   2.2398545E-03
     +,   2.3414837E-03,   2.4463388E-03,   2.5557533E-03
     +,   2.6715125E-03,   2.7955214E-03,   2.9293632E-03
     +,   3.0737421E-03,   3.2280064E-03,   3.3898023E-03
     +,   3.5549290E-03,   3.7175568E-03,   3.8707671E-03
     +,   4.0072906E-03,   4.1204803E-03,   4.2051566E-03
     +,   4.2582680E-03,   4.2791790E-03,   4.2695431E-03
     +,   4.2327694E-03,   4.1733119E-03,   4.0958691E-03
     +,   4.0047807E-03,   3.9036630E-03,   3.7953507E-03
     +,   3.6821226E-03,   3.5659615E-03,   3.4488393E-03
     +,   3.3328191E-03,   3.2199423E-03,   3.1119830E-03
     +,   3.0101705E-03,   2.9148965E-03,   2.8256457E-03
     +,   2.7410691E-03,   2.6592340E-03,   2.5780238E-03
     +,   2.4954972E-03,   2.4102326E-03,   2.3215241E-03
     +,   2.2294261E-03,   2.1346747E-03,   2.0385263E-03
     +,   1.9425490E-03,   1.8483939E-03,   1.7576540E-03
     +,   1.6717387E-03,   1.5917871E-03,   1.5186748E-03
     +,   1.4529818E-03,   1.3950290E-03,   1.3448806E-03
     +,   1.3023628E-03,   1.2670762E-03,   1.2384255E-03
     +,   1.2156337E-03,   1.1977848E-03,   1.1838679E-03
     +,   1.1728189E-03,   1.1635812E-03,   1.1551527E-03
     +,   1.1466315E-03,   1.1372541E-03,   1.1264175E-03
     +,   1.1136917E-03,   1.0988201E-03,   1.0817087E-03
     +,   1.0624006E-03,   1.0410568E-03,   1.0179245E-03
     +,   9.9330838E-04,   9.6753926E-04,   9.4095711E-04
     +,   9.1388274E-04,   8.8661344E-04,   8.5940573E-04
     +,   8.3247625E-04,   8.0599700E-04,   7.8010088E-04
     +,   7.5488928E-04,   7.3043461E-04,   7.0678937E-04
     +,   6.8399246E-04,   6.6207256E-04,   6.4105418E-04
     +,   6.2096235E-04,   6.0182018E-04,   5.8365206E-04
     +,   5.6647899E-04,   5.5031909E-04,   5.3518638E-04
     +,   5.2108633E-04,   5.0801481E-04,   4.9595663E-04
     +,   4.8488268E-04,   4.7475277E-04,   4.6551257E-04
     +,   4.5709749E-04,   4.4943302E-04,   4.4243594E-04
     +,   4.3601883E-04,   4.3009009E-04,   4.2455821E-04
     +,   4.1933404E-04,   4.1433296E-04,   4.0947608E-04
     +,   4.0469298E-04,   3.9992185E-04,   3.9511174E-04
     +,   3.9022206E-04,   3.8522237E-04,   3.8009320E-04
     +,   3.7482448E-04,   3.6941498E-04,   3.6387198E-04
     +,   3.5820928E-04,   3.5244646E-04,   3.4660753E-04
     +,   3.4071915E-04,   3.3480962E-04,   3.2890850E-04
     +,   3.2304443E-04,   3.1724514E-04,   3.1153529E-04
     +,   3.0593693E-04,   3.0046902E-04,   2.9514619E-04
     +,   2.8997942E-04,   2.8497539E-04,   2.8013610E-04
     +,   2.7546048E-04,   2.7094269E-04,   2.6657409E-04
     +,   2.6234309E-04,   2.5823517E-04,   2.5423372E-04
     +,   2.5032047E-04,   2.4647589E-04,   2.4268014E-04
     +,   2.3891302E-04,   2.3515470E-04,   2.3138581E-04
     +,   2.2758861E-04,   2.2374588E-04,   2.1984290E-04
     +,   2.1586666E-04,   2.1180630E-04,   2.0765291E-04
     +,   2.0340001E-04,   1.9904364E-04,   1.9458207E-04
     +,   1.9001582E-04,   1.8534790E-04,   1.8058281E-04
     +,   1.7572708E-04,   1.7078937E-04,   1.6577958E-04
     +,   1.6070920E-04,   1.5559020E-04,   1.5043606E-04
     +,   1.4526093E-04,   1.4007869E-04,   1.3490410E-04
     +,   1.2975202E-04,   1.2463635E-04,   1.1957157E-04
     +,   1.1457077E-04,   1.0964696E-04,   1.0481221E-04
     +,   1.0007765E-04,   9.5453601E-05,   9.0948932E-05
     +,   8.6571468E-05,   8.2328253E-05,   7.8225006E-05
     +,   7.4266260E-05,   7.0455651E-05,   6.6795437E-05
     +,   6.3286774E-05,   5.9930197E-05,   5.6725195E-05
     +,   5.3670483E-05,   5.0763792E-05,   4.8002195E-05
     +,   4.5382389E-05,   4.2900425E-05,   4.0551906E-05
     +,   3.8332186E-05,   3.6236128E-05,   3.4258421E-05
     +,   3.2393749E-05,   3.0636646E-05,   2.8981593E-05
     +,   2.7423186E-05,   2.5955893E-05,   2.4574514E-05
     +,   2.3273782E-05,   2.2048769E-05,   2.0894659E-05
     +,   1.9806954E-05,   1.8781111E-05,   1.7813083E-05
     +,   1.6898968E-05,   1.6035105E-05,   1.5218105E-05
     +,   1.4444711E-05,   1.3712029E-05,   1.3017254E-05
     +,   1.2357898E-05,   1.1731623E-05,   1.1136295E-05
     +,   1.0570002E-05,   1.0030861E-05,   9.5172854E-06
     +,   9.0277772E-06,   8.5609727E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wano_fus_70 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wano_fus_75(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  1.6351050E-05,   1.6905795E-05
     +,   1.7516293E-05,   1.8189550E-05,   1.8933290E-05
     +,   1.9755977E-05,   2.0666781E-05,   2.1675716E-05
     +,   2.2793623E-05,   2.4032088E-05,   2.5403595E-05
     +,   2.6921434E-05,   2.8599712E-05,   3.0453202E-05
     +,   3.2497450E-05,   3.4748624E-05,   3.7223283E-05
     +,   3.9938481E-05,   4.2911488E-05,   4.6159461E-05
     +,   4.9699553E-05,   5.3548516E-05,   5.7722216E-05
     +,   6.2235791E-05,   6.7103138E-05,   7.2336275E-05
     +,   7.7945646E-05,   8.3939398E-05,   9.0322814E-05
     +,   9.7098571E-05,   1.0426623E-04,   1.1182130E-04
     +,   1.1975616E-04,   1.2805912E-04,   1.3671409E-04
     +,   1.4570124E-04,   1.5499667E-04,   1.6457197E-04
     +,   1.7439546E-04,   1.8443167E-04,   1.9464229E-04
     +,   2.0498586E-04,   2.1541951E-04,   2.2589878E-04
     +,   2.3637911E-04,   2.4681599E-04,   2.5716686E-04
     +,   2.6739106E-04,   2.7745226E-04,   2.8731843E-04
     +,   2.9696364E-04,   3.0636802E-04,   3.1552033E-04
     +,   3.2441769E-04,   3.3306552E-04,   3.4148002E-04
     +,   3.4968680E-04,   3.5772129E-04,   3.6562883E-04
     +,   3.7346437E-04,   3.8129077E-04,   3.8917971E-04
     +,   3.9720957E-04,   4.0546453E-04,   4.1403450E-04
     +,   4.2301283E-04,   4.3249648E-04,   4.4258448E-04
     +,   4.5337740E-04,   4.6497487E-04,   4.7747689E-04
     +,   4.9097918E-04,   5.0557387E-04,   5.2134326E-04
     +,   5.3836085E-04,   5.5668200E-04,   5.7634484E-04
     +,   5.9736049E-04,   6.1970984E-04,   6.4334285E-04
     +,   6.6816946E-04,   6.9406244E-04,   7.2086294E-04
     +,   7.4837852E-04,   7.7639916E-04,   8.0471445E-04
     +,   8.3312788E-04,   8.6149346E-04,   8.8973925E-04
     +,   9.1791054E-04,   9.4620680E-04,   9.7502570E-04
     +,   1.0049929E-03,   1.0369864E-03,   1.0721468E-03
     +,   1.1118492E-03,   1.1576472E-03,   1.2111887E-03
     +,   1.2740676E-03,   1.3476795E-03,   1.4330284E-03
     +,   1.5305743E-03,   1.6401049E-03,   1.7607179E-03
     +,   1.8908549E-03,   2.0285368E-03,   2.1716440E-03
     +,   2.3183585E-03,   2.4676207E-03,   2.6196109E-03
     +,   2.7760561E-03,   2.9404252E-03,   3.1177492E-03
     +,   3.3141377E-03,   3.5358483E-03,   3.7880994E-03
     +,   4.0735495E-03,   4.3910104E-03,   4.7344072E-03
     +,   5.0925026E-03,   5.4495460E-03,   5.7866503E-03
     +,   6.0840235E-03,   6.3232384E-03,   6.4894538E-03
     +,   6.5730656E-03,   6.5706451E-03,   6.4852028E-03
     +,   6.3259215E-03,   6.1073671E-03,   5.8483458E-03
     +,   5.5702352E-03,   5.2949307E-03,   5.0426293E-03
     +,   4.8294808E-03,   4.6658879E-03,   4.5553460E-03
     +,   4.4943993E-03,   4.4735619E-03,   4.4791242E-03
     +,   4.4954806E-03,   4.5075933E-03,   4.5031416E-03
     +,   4.4739349E-03,   4.4164574E-03,   4.3314844E-03
     +,   4.2230277E-03,   4.0969783E-03,   3.9598052E-03
     +,   3.8175411E-03,   3.6752634E-03,   3.5369075E-03
     +,   3.4053351E-03,   3.2825298E-03,   3.1697317E-03
     +,   3.0675244E-03,   2.9758210E-03,   2.8938972E-03
     +,   2.8203747E-03,   2.7533139E-03,   2.6903595E-03
     +,   2.6289548E-03,   2.5665979E-03,   2.5011145E-03
     +,   2.4309019E-03,   2.3551022E-03,   2.2736692E-03
     +,   2.1873526E-03,   2.0975592E-03,   2.0061564E-03
     +,   1.9152336E-03,   1.8268616E-03,   1.7428854E-03
     +,   1.6647681E-03,   1.5935164E-03,   1.5296678E-03
     +,   1.4733123E-03,   1.4241625E-03,   1.3816396E-03
     +,   1.3449512E-03,   1.3131847E-03,   1.2853654E-03
     +,   1.2605188E-03,   1.2377182E-03,   1.2161165E-03
     +,   1.1949814E-03,   1.1737082E-03,   1.1518409E-03
     +,   1.1290748E-03,   1.1052522E-03,   1.0803549E-03
     +,   1.0544803E-03,   1.0278192E-03,   1.0006299E-03
     +,   9.7320485E-04,   9.4584428E-04,   9.1883168E-04
     +,   8.9241116E-04,   8.6677592E-04,   8.4206229E-04
     +,   8.1834674E-04,   7.9564826E-04,   7.7393872E-04
     +,   7.5315009E-04,   7.3318655E-04,   7.1393908E-04
     +,   6.9529261E-04,   6.7713647E-04,   6.5936911E-04
     +,   6.4190471E-04,   6.2467606E-04,   6.0763472E-04
     +,   5.9074973E-04,   5.7400618E-04,   5.5740186E-04
     +,   5.4094649E-04,   5.2465429E-04,   5.0854665E-04
     +,   4.9264566E-04,   4.7697360E-04,   4.6155116E-04
     +,   4.4639560E-04,   4.3152031E-04,   4.1693606E-04
     +,   4.0264949E-04,   3.8866419E-04,   3.7497966E-04
     +,   3.6159443E-04,   3.4850399E-04,   3.3570363E-04
     +,   3.2318803E-04,   3.1095196E-04,   2.9899008E-04
     +,   2.8729704E-04,   2.7586982E-04,   2.6470568E-04
     +,   2.5380278E-04,   2.4316073E-04,   2.3277901E-04
     +,   2.2265788E-04,   2.1279883E-04,   2.0320326E-04
     +,   1.9387314E-04,   1.8480931E-04,   1.7601359E-04
     +,   1.6748742E-04,   1.5923103E-04,   1.5124514E-04
     +,   1.4352999E-04,   1.3608461E-04,   1.2890848E-04
     +,   1.2199968E-04,   1.1535658E-04,   1.0897682E-04
     +,   1.0285763E-04,   9.6996126E-05,   9.1388538E-05
     +,   8.6030755E-05,   8.0918791E-05,   7.6048127E-05
     +,   7.1413939E-05,   6.7011249E-05,   6.2834471E-05
     +,   5.8877769E-05,   5.5135384E-05,   5.1601135E-05
     +,   4.8268728E-05,   4.5131441E-05,   4.2182346E-05
     +,   3.9414623E-05,   3.6821155E-05,   3.4394765E-05
     +,   3.2128242E-05,   3.0014144E-05,   2.8045066E-05
     +,   2.6213758E-05,   2.4512934E-05,   2.2935395E-05
     +,   2.1474107E-05,   2.0122006E-05,   1.8872408E-05
     +,   1.7718625E-05,   1.6654329E-05,   1.5673366E-05
     +,   1.4769904E-05,   1.3938154E-05,   1.3172817E-05
     +,   1.2468797E-05,   1.1821273E-05,   1.1225729E-05
     +,   1.0677863E-05,   1.0173731E-05,   9.7095854E-06
     +,   9.2819964E-06,   8.8877669E-06,   8.5239471E-06
     +,   8.1878379E-06,   7.8768890E-06,   7.5888374E-06
     +,   7.3215833E-06,   7.0732153E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wano_fus_75 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wano_fus_80(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  2.0154701E-05,   2.0944415E-05
     +,   2.1753727E-05,   2.2582746E-05,   2.3431659E-05
     +,   2.4300667E-05,   2.5189964E-05,   2.6099829E-05
     +,   2.7030566E-05,   2.7982502E-05,   2.8956067E-05
     +,   2.9951745E-05,   3.0970114E-05,   3.2011783E-05
     +,   3.3077533E-05,   3.4168235E-05,   3.5284840E-05
     +,   3.6428490E-05,   3.7600461E-05,   3.8802158E-05
     +,   4.0035189E-05,   4.1301373E-05,   4.2602649E-05
     +,   4.3941232E-05,   4.5319608E-05,   4.6740344E-05
     +,   4.8206424E-05,   4.9721035E-05,   5.1287599E-05
     +,   5.2909880E-05,   5.4591976E-05,   5.6338195E-05
     +,   5.8153255E-05,   6.0042225E-05,   6.2010389E-05
     +,   6.4063577E-05,   6.6207867E-05,   6.8449692E-05
     +,   7.0795919E-05,   7.3253766E-05,   7.5830882E-05
     +,   7.8535144E-05,   8.1374899E-05,   8.4358777E-05
     +,   8.7495791E-05,   9.0794980E-05,   9.4265830E-05
     +,   9.7917735E-05,   1.0176022E-04,   1.0580273E-04
     +,   1.1005455E-04,   1.1452425E-04,   1.1922025E-04
     +,   1.2415007E-04,   1.2932002E-04,   1.3473543E-04
     +,   1.4040017E-04,   1.4631610E-04,   1.5248323E-04
     +,   1.5889942E-04,   1.6555958E-04,   1.7245632E-04
     +,   1.7957935E-04,   1.8691501E-04,   1.9444716E-04
     +,   2.0215676E-04,   2.1002167E-04,   2.1801807E-04
     +,   2.2612042E-04,   2.3430159E-04,   2.4253486E-04
     +,   2.5079399E-04,   2.5905517E-04,   2.6729703E-04
     +,   2.7550376E-04,   2.8366444E-04,   2.9177670E-04
     +,   2.9984553E-04,   3.0788529E-04,   3.1592158E-04
     +,   3.2398954E-04,   3.3213469E-04,   3.4041333E-04
     +,   3.4889014E-04,   3.5763759E-04,   3.6673600E-04
     +,   3.7626896E-04,   3.8632657E-04,   3.9700145E-04
     +,   4.0839097E-04,   4.2059933E-04,   4.3374137E-04
     +,   4.4794587E-04,   4.6336354E-04,   4.8017659E-04
     +,   4.9860287E-04,   5.1890616E-04,   5.4140441E-04
     +,   5.6646671E-04,   5.9451984E-04,   6.2603294E-04
     +,   6.6150835E-04,   7.0145703E-04,   7.4637926E-04
     +,   7.9672155E-04,   8.5285853E-04,   9.1505161E-04
     +,   9.8343613E-04,   1.0580103E-03,   1.1386577E-03
     +,   1.2251604E-03,   1.3172657E-03,   1.4147231E-03
     +,   1.5173417E-03,   1.6250086E-03,   1.7376820E-03
     +,   1.8552876E-03,   1.9776248E-03,   2.1041769E-03
     +,   2.2339786E-03,   2.3655603E-03,   2.4969876E-03
     +,   2.6261443E-03,   2.7511253E-03,   2.8707865E-03
     +,   2.9852402E-03,   3.0961584E-03,   3.2066563E-03
     +,   3.3207720E-03,   3.4425815E-03,   3.5751818E-03
     +,   3.7199978E-03,   3.8767844E-03,   4.0442836E-03
     +,   4.2216033E-03,   4.4094627E-03,   4.6108123E-03
     +,   4.8301802E-03,   5.0718440E-03,   5.3373720E-03
     +,   5.6238379E-03,   5.9235576E-03,   6.2260129E-03
     +,   6.5212557E-03,   6.8030846E-03,   7.0703924E-03
     +,   7.3253182E-03,   7.5687254E-03,   7.7953325E-03
     +,   7.9916306E-03,   8.1385626E-03,   8.2187206E-03
     +,   8.2244473E-03,   8.1622852E-03,   8.0507230E-03
     +,   7.9119848E-03,   7.7622770E-03,   7.6059746E-03
     +,   7.4367598E-03,   7.2446680E-03,   7.0245652E-03
     +,   6.7814458E-03,   6.5301214E-03,   6.2902072E-03
     +,   6.0794018E-03,   5.9081400E-03,   5.7773911E-03
     +,   5.6796558E-03,   5.6018373E-03,   5.5287392E-03
     +,   5.4460312E-03,   5.3423098E-03,   5.2103004E-03
     +,   5.0472729E-03,   4.8549627E-03,   4.6390011E-03
     +,   4.4078729E-03,   4.1715647E-03,   3.9399988E-03
     +,   3.7214963E-03,   3.5217372E-03,   3.3431475E-03
     +,   3.1851318E-03,   3.0448185E-03,   2.9182008E-03
     +,   2.8013294E-03,   2.6912400E-03,   2.5864798E-03
     +,   2.4871603E-03,   2.3946115E-03,   2.3108139E-03
     +,   2.2377693E-03,   2.1769721E-03,   2.1290611E-03
     +,   2.0936579E-03,   2.0694006E-03,   2.0541246E-03
     +,   2.0451166E-03,   2.0394004E-03,   2.0340155E-03
     +,   2.0262368E-03,   2.0137583E-03,   1.9947938E-03
     +,   1.9681288E-03,   1.9331235E-03,   1.8896670E-03
     +,   1.8381122E-03,   1.7791851E-03,   1.7138874E-03
     +,   1.6434016E-03,   1.5690126E-03,   1.4920182E-03
     +,   1.4136726E-03,   1.3351372E-03,   1.2574377E-03
     +,   1.1814629E-03,   1.1079311E-03,   1.0374130E-03
     +,   9.7032689E-04,   9.0695231E-04,   8.4744988E-04
     +,   7.9186814E-04,   7.4017001E-04,   6.9225160E-04
     +,   6.4795109E-04,   6.0707139E-04,   5.6938460E-04
     +,   5.3465553E-04,   5.0264085E-04,   4.7310611E-04
     +,   4.4582598E-04,   4.2059104E-04,   3.9720716E-04
     +,   3.7549820E-04,   3.5530771E-04,   3.3649473E-04
     +,   3.1893310E-04,   3.0251054E-04,   2.8712503E-04
     +,   2.7268394E-04,   2.5910462E-04,   2.4631104E-04
     +,   2.3423404E-04,   2.2280919E-04,   2.1197919E-04
     +,   2.0169202E-04,   1.9189971E-04,   1.8256060E-04
     +,   1.7363792E-04,   1.6509862E-04,   1.5691551E-04
     +,   1.4906420E-04,   1.4152502E-04,   1.3428144E-04
     +,   1.2731995E-04,   1.2062972E-04,   1.1420160E-04
     +,   1.0802820E-04,   1.0210391E-04,   9.6423835E-05
     +,   9.0983784E-05,   8.5780091E-05,   8.0808873E-05
     +,   7.6066222E-05,   7.1548420E-05,   6.7251240E-05
     +,   6.3170206E-05,   5.9300117E-05,   5.5635341E-05
     +,   5.2170060E-05,   4.8897939E-05,   4.5812212E-05
     +,   4.2905918E-05,   4.0171581E-05,   3.7601578E-05
     +,   3.5188317E-05,   3.2924087E-05,   3.0801144E-05
     +,   2.8811912E-05,   2.6948695E-05,   2.5204279E-05
     +,   2.3571387E-05,   2.2043221E-05,   2.0613181E-05
     +,   1.9275078E-05,   1.8022740E-05,   1.6850645E-05
     +,   1.5753485E-05,   1.4726303E-05,   1.3764485E-05
     +,   1.2863629E-05,   1.2019777E-05,   1.1229125E-05
     +,   1.0488231E-05,   9.7938873E-06,   9.1431039E-06
     +,   8.5331712E-06,   7.9614274E-06,   7.4255463E-06
     +,   6.9233192E-06,   6.4526894E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wano_fus_80 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wano_fus_85(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  7.4960240E-06,   7.8159610E-06
     +,   8.1526850E-06,   8.5071133E-06,   8.8802253E-06
     +,   9.2730370E-06,   9.6865797E-06,   1.0121937E-05
     +,   1.0580232E-05,   1.1062597E-05,   1.1570209E-05
     +,   1.2104269E-05,   1.2666009E-05,   1.3256646E-05
     +,   1.3877442E-05,   1.4529670E-05,   1.5214560E-05
     +,   1.5933385E-05,   1.6687396E-05,   1.7477792E-05
     +,   1.8305765E-05,   1.9172494E-05,   2.0079045E-05
     +,   2.1026483E-05,   2.2015805E-05,   2.3047867E-05
     +,   2.4123501E-05,   2.5243424E-05,   2.6408195E-05
     +,   2.7618300E-05,   2.8874101E-05,   3.0175745E-05
     +,   3.1523290E-05,   3.2916647E-05,   3.4355457E-05
     +,   3.5839301E-05,   3.7367543E-05,   3.8939310E-05
     +,   4.0553616E-05,   4.2209278E-05,   4.3904951E-05
     +,   4.5639055E-05,   4.7409911E-05,   4.9215691E-05
     +,   5.1054478E-05,   5.2924119E-05,   5.4822573E-05
     +,   5.6747573E-05,   5.8696947E-05,   6.0668561E-05
     +,   6.2660372E-05,   6.4670356E-05,   6.6696826E-05
     +,   6.8738344E-05,   7.0793700E-05,   7.2862174E-05
     +,   7.4943644E-05,   7.7038363E-05,   7.9147467E-05
     +,   8.1272854E-05,   8.3417253E-05,   8.5584536E-05
     +,   8.7779634E-05,   9.0008747E-05,   9.2279508E-05
     +,   9.4601019E-05,   9.6983880E-05,   9.9440556E-05
     +,   1.0198527E-04,   1.0463394E-04,   1.0740461E-04
     +,   1.1031718E-04,   1.1339359E-04,   1.1665748E-04
     +,   1.2013465E-04,   1.2385230E-04,   1.2783977E-04
     +,   1.3212749E-04,   1.3674700E-04,   1.4173143E-04
     +,   1.4711407E-04,   1.5292849E-04,   1.5920900E-04
     +,   1.6598882E-04,   1.7330024E-04,   1.8117536E-04
     +,   1.8964316E-04,   1.9873204E-04,   2.0846685E-04
     +,   2.1887005E-04,   2.2996042E-04,   2.4175497E-04
     +,   2.5426608E-04,   2.6750349E-04,   2.8147528E-04
     +,   2.9618701E-04,   3.1164309E-04,   3.2785092E-04
     +,   3.4481808E-04,   3.6255989E-04,   3.8109769E-04
     +,   4.0046390E-04,   4.2070358E-04,   4.4188040E-04
     +,   4.6407312E-04,   4.8738401E-04,   5.1193230E-04
     +,   5.3785642E-04,   5.6530925E-04,   5.9445505E-04
     +,   6.2545453E-04,   6.5846264E-04,   6.9360650E-04
     +,   7.3097413E-04,   7.7059615E-04,   8.1243407E-04
     +,   8.5635297E-04,   9.0212206E-04,   9.4939367E-04
     +,   9.9770492E-04,   1.0464903E-03,   1.0950790E-03
     +,   1.1427355E-03,   1.1886779E-03,   1.2321293E-03
     +,   1.2723581E-03,   1.3087445E-03,   1.3408222E-03
     +,   1.3683372E-03,   1.3913064E-03,   1.4100460E-03
     +,   1.4252161E-03,   1.4378414E-03,   1.4493190E-03
     +,   1.4614195E-03,   1.4762697E-03,   1.4963124E-03
     +,   1.5242433E-03,   1.5629217E-03,   1.6152322E-03
     +,   1.6839382E-03,   1.7714918E-03,   1.8798551E-03
     +,   2.0103806E-03,   2.1636924E-03,   2.3396695E-03
     +,   2.5374861E-03,   2.7555879E-03,   2.9916745E-03
     +,   3.2426494E-03,   3.5044805E-03,   3.7723267E-03
     +,   4.0410156E-03,   4.3058489E-03,   4.5638243E-03
     +,   4.8146909E-03,   5.0614239E-03,   5.3095557E-03
     +,   5.5656079E-03,   5.8350367E-03,   6.1206287E-03
     +,   6.4219688E-03,   6.7359614E-03,   7.0577255E-03
     +,   7.3811747E-03,   7.6994072E-03,   8.0053089E-03
     +,   8.2931137E-03,   8.5606547E-03,   8.8105686E-03
     +,   9.0490459E-03,   9.2819789E-03,   9.5109129E-03
     +,   9.7319745E-03,   9.9391267E-03,   1.0129675E-02
     +,   1.0307554E-02,   1.0481581E-02,   1.0659263E-02
     +,   1.0840630E-02,   1.1015657E-02,   1.1166381E-02
     +,   1.1271448E-02,   1.1310263E-02,   1.1265159E-02
     +,   1.1122662E-02,   1.0875502E-02,   1.0526294E-02
     +,   1.0091243E-02,   9.6000936E-03,   9.0903658E-03
     +,   8.5972603E-03,   8.1441449E-03,   7.7387127E-03
     +,   7.3757642E-03,   7.0444313E-03,   6.7352862E-03
     +,   6.4439201E-03,   6.1707888E-03,   5.9184036E-03
     +,   5.6881253E-03,   5.4782606E-03,   5.2840356E-03
     +,   5.0991252E-03,   4.9177944E-03,   4.7365660E-03
     +,   4.5547439E-03,   4.3738429E-03,   4.1962755E-03
     +,   4.0240278E-03,   3.8578289E-03,   3.6969369E-03
     +,   3.5396006E-03,   3.3837960E-03,   3.2279554E-03
     +,   3.0714879E-03,   2.9148555E-03,   2.7594154E-03
     +,   2.6069896E-03,   2.4594376E-03,   2.3182828E-03
     +,   2.1844928E-03,   2.0584140E-03,   1.9398589E-03
     +,   1.8282176E-03,   1.7226468E-03,   1.6222106E-03
     +,   1.5260425E-03,   1.4334056E-03,   1.3437689E-03
     +,   1.2568042E-03,   1.1723799E-03,   1.0905163E-03
     +,   1.0113483E-03,   9.3508977E-04,   8.6198089E-04
     +,   7.9226214E-04,   7.2615244E-04,   6.6382758E-04
     +,   6.0541852E-04,   5.5101264E-04,   5.0064595E-04
     +,   4.5430919E-04,   4.1194295E-04,   3.7345212E-04
     +,   3.3870290E-04,   3.0752382E-04,   2.7971875E-04
     +,   2.5506894E-04,   2.3333621E-04,   2.1427640E-04
     +,   1.9763874E-04,   1.8317752E-04,   1.7065354E-04
     +,   1.5983933E-04,   1.5052260E-04,   1.4250679E-04
     +,   1.3561320E-04,   1.2968182E-04,   1.2456955E-04
     +,   1.2015016E-04,   1.1631288E-04,   1.1296100E-04
     +,   1.1001066E-04,   1.0738971E-04,   1.0503614E-04
     +,   1.0289703E-04,   1.0092715E-04,   9.9088349E-05
     +,   9.7348617E-05,   9.5681215E-05,   9.4063907E-05
     +,   9.2478549E-05,   9.0910260E-05,   8.9347108E-05
     +,   8.7779743E-05,   8.6200947E-05,   8.4605243E-05
     +,   8.2988787E-05,   8.1348793E-05,   7.9683843E-05
     +,   7.7993143E-05,   7.6276890E-05,   7.4535768E-05
     +,   7.2771225E-05,   7.0984664E-05,   6.9178313E-05
     +,   6.7354529E-05,   6.5515946E-05,   6.3665429E-05
     +,   6.1805818E-05,   5.9940361E-05,   5.8072063E-05
     +,   5.6204237E-05,   5.4340144E-05,   5.2483007E-05
     +,   5.0636219E-05,   4.8802631E-05,   4.6985504E-05
     +,   4.5187830E-05,   4.3412507E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wano_fus_85 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wano_fus_90(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  3.5188721E-06,   3.6286631E-06
     +,   3.7410568E-06,   3.8560997E-06,   3.9738479E-06
     +,   4.0943623E-06,   4.2177039E-06,   4.3439409E-06
     +,   4.4731541E-06,   4.6054211E-06,   4.7408384E-06
     +,   4.8795068E-06,   5.0215399E-06,   5.1670618E-06
     +,   5.3162148E-06,   5.4691573E-06,   5.6260601E-06
     +,   5.7871212E-06,   5.9525619E-06,   6.1226192E-06
     +,   6.2975678E-06,   6.4777132E-06,   6.6633866E-06
     +,   6.8549643E-06,   7.0528645E-06,   7.2575413E-06
     +,   7.4695085E-06,   7.6893311E-06,   7.9176243E-06
     +,   8.1550752E-06,   8.4024441E-06,   8.6605451E-06
     +,   8.9302939E-06,   9.2126902E-06,   9.5088089E-06
     +,   9.8198443E-06,   1.0147105E-05,   1.0491988E-05
     +,   1.0856041E-05,   1.1240938E-05,   1.1648506E-05
     +,   1.2080713E-05,   1.2539695E-05,   1.3027783E-05
     +,   1.3547494E-05,   1.4101529E-05,   1.4692831E-05
     +,   1.5324549E-05,   1.6000105E-05,   1.6723166E-05
     +,   1.7497687E-05,   1.8327883E-05,   1.9218296E-05
     +,   2.0173802E-05,   2.1199539E-05,   2.2301054E-05
     +,   2.3484221E-05,   2.4755213E-05,   2.6120628E-05
     +,   2.7587406E-05,   2.9162742E-05,   3.0854277E-05
     +,   3.2669937E-05,   3.4617839E-05,   3.6706471E-05
     +,   3.8944527E-05,   4.1340747E-05,   4.3904096E-05
     +,   4.6643567E-05,   4.9568007E-05,   5.2686239E-05
     +,   5.6006829E-05,   5.9538117E-05,   6.3287771E-05
     +,   6.7263209E-05,   7.1470800E-05,   7.5916731E-05
     +,   8.0605743E-05,   8.5541615E-05,   9.0727481E-05
     +,   9.6164804E-05,   1.0185361E-04,   1.0779336E-04
     +,   1.1398127E-04,   1.2041323E-04,   1.2708438E-04
     +,   1.3398737E-04,   1.4111471E-04,   1.4845675E-04
     +,   1.5600299E-04,   1.6374169E-04,   1.7166126E-04
     +,   1.7974866E-04,   1.8799069E-04,   1.9637505E-04
     +,   2.0488905E-04,   2.1352060E-04,   2.2226002E-04
     +,   2.3109763E-04,   2.4002719E-04,   2.4904392E-04
     +,   2.5814600E-04,   2.6733446E-04,   2.7661465E-04
     +,   2.8599473E-04,   2.9548729E-04,   3.0510873E-04
     +,   3.1487888E-04,   3.2482171E-04,   3.3496568E-04
     +,   3.4534087E-04,   3.5598196E-04,   3.6692439E-04
     +,   3.7820567E-04,   3.8986382E-04,   4.0193796E-04
     +,   4.1446436E-04,   4.2747994E-04,   4.4101759E-04
     +,   4.5510742E-04,   4.6977837E-04,   4.8505378E-04
     +,   5.0095742E-04,   5.1751029E-04,   5.3473492E-04
     +,   5.5265636E-04,   5.7130877E-04,   5.9073442E-04
     +,   6.1099045E-04,   6.3215545E-04,   6.5432803E-04
     +,   6.7763281E-04,   7.0222380E-04,   7.2827714E-04
     +,   7.5599697E-04,   7.8559952E-04,   8.1731123E-04
     +,   8.5135212E-04,   8.8792975E-04,   9.2721579E-04
     +,   9.6934551E-04,   1.0143942E-03,   1.0623774E-03
     +,   1.1132531E-03,   1.1669103E-03,   1.2231799E-03
     +,   1.2818497E-03,   1.3426548E-03,   1.4052911E-03
     +,   1.4694299E-03,   1.5347028E-03,   1.6007172E-03
     +,   1.6670763E-03,   1.7333885E-03,   1.7993205E-03
     +,   1.8646581E-03,   1.9293962E-03,   1.9938175E-03
     +,   2.0586052E-03,   2.1248851E-03,   2.1942537E-03
     +,   2.2687227E-03,   2.3505937E-03,   2.4422552E-03
     +,   2.5459439E-03,   2.6635029E-03,   2.7962220E-03
     +,   2.9447512E-03,   3.1091734E-03,   3.2891559E-03
     +,   3.4840994E-03,   3.6932030E-03,   3.9152643E-03
     +,   4.1482765E-03,   4.3888814E-03,   4.6321177E-03
     +,   4.8719714E-03,   5.1029753E-03,   5.3226883E-03
     +,   5.5343416E-03,   5.7481495E-03,   5.9802970E-03
     +,   6.2490208E-03,   6.5688044E-03,   6.9447784E-03
     +,   7.3695742E-03,   7.8243725E-03,   8.2835099E-03
     +,   8.7210406E-03,   9.1172252E-03,   9.4638001E-03
     +,   9.7681871E-03,   1.0056121E-02,   1.0369979E-02
     +,   1.0760061E-02,   1.1267689E-02,   1.1905912E-02
     +,   1.2647835E-02,   1.3430637E-02,   1.4173588E-02
     +,   1.4800139E-02,   1.5254656E-02,   1.5512196E-02
     +,   1.5583154E-02,   1.5510617E-02,   1.5356494E-02
     +,   1.5178892E-02,   1.5012761E-02,   1.4867148E-02
     +,   1.4739397E-02,   1.4630363E-02,   1.4542977E-02
     +,   1.4463125E-02,   1.4343504E-02,   1.4111118E-02
     +,   1.3696820E-02,   1.3065814E-02,   1.2228758E-02
     +,   1.1231780E-02,   1.0138401E-02,   9.0151345E-03
     +,   7.9237502E-03,   6.9169053E-03,   6.0338774E-03
     +,   5.2963998E-03,   4.7070943E-03,   4.2514126E-03
     +,   3.9030930E-03,   3.6306840E-03,   3.4037998E-03
     +,   3.1974278E-03,   2.9941704E-03,   2.7845532E-03
     +,   2.5660251E-03,   2.3411785E-03,   2.1156413E-03
     +,   1.8961433E-03,   1.6889798E-03,   1.4990189E-03
     +,   1.3292864E-03,   1.1809879E-03,   1.0537863E-03
     +,   9.4623241E-04,   8.5618172E-04,   7.8118336E-04
     +,   7.1874098E-04,   6.6649122E-04,   6.2232529E-04
     +,   5.8443315E-04,   5.5131142E-04,   5.2176247E-04
     +,   4.9485633E-04,   4.6990355E-04,   4.4641187E-04
     +,   4.2404878E-04,   4.0260557E-04,   3.8196272E-04
     +,   3.6206498E-04,   3.4289985E-04,   3.2447913E-04
     +,   3.0682699E-04,   2.8997171E-04,   2.7393797E-04
     +,   2.5874487E-04,   2.4440495E-04,   2.3092193E-04
     +,   2.1829089E-04,   2.0649809E-04,   1.9552228E-04
     +,   1.8533652E-04,   1.7590777E-04,   1.6719833E-04
     +,   1.5916728E-04,   1.5177047E-04,   1.4496227E-04
     +,   1.3869704E-04,   1.3292905E-04,   1.2761341E-04
     +,   1.2270709E-04,   1.1816865E-04,   1.1395969E-04
     +,   1.1004413E-04,   1.0638915E-04,   1.0296482E-04
     +,   9.9744444E-05,   9.6703450E-05,   9.3820767E-05
     +,   9.1077658E-05,   8.8457724E-05,   8.5946813E-05
     +,   8.3532352E-05,   8.1203842E-05,   7.8951889E-05
     +,   7.6768607E-05,   7.4647185E-05,   7.2581621E-05
     +,   7.0566974E-05,   6.8598405E-05,   6.6672226E-05
     +,   6.4785003E-05,   6.2933788E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wano_fus_90 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wano_fus_95(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  2.9201415E-06,   3.0537826E-06
     +,   3.1925167E-06,   3.3364731E-06,   3.4857940E-06
     +,   3.6406195E-06,   3.8010821E-06,   3.9673255E-06
     +,   4.1394924E-06,   4.3177165E-06,   4.5021434E-06
     +,   4.6929135E-06,   4.8901729E-06,   5.0940580E-06
     +,   5.3047156E-06,   5.5222981E-06,   5.7469420E-06
     +,   5.9787999E-06,   6.2180293E-06,   6.4647747E-06
     +,   6.7191972E-06,   6.9814650E-06,   7.2517337E-06
     +,   7.5301823E-06,   7.8169951E-06,   8.1123453E-06
     +,   8.4164403E-06,   8.7294875E-06,   9.0516960E-06
     +,   9.3833041E-06,   9.7245638E-06,   1.0075725E-05
     +,   1.0437077E-05,   1.0808929E-05,   1.1191594E-05
     +,   1.1585426E-05,   1.1990813E-05,   1.2408142E-05
     +,   1.2837858E-05,   1.3280431E-05,   1.3736376E-05
     +,   1.4206218E-05,   1.4690548E-05,   1.5189987E-05
     +,   1.5705215E-05,   1.6236920E-05,   1.6785883E-05
     +,   1.7352882E-05,   1.7938779E-05,   1.8544468E-05
     +,   1.9170910E-05,   1.9819068E-05,   2.0489988E-05
     +,   2.1184769E-05,   2.1904492E-05,   2.2650340E-05
     +,   2.3423510E-05,   2.4225206E-05,   2.5056686E-05
     +,   2.5919240E-05,   2.6814121E-05,   2.7742639E-05
     +,   2.8706118E-05,   2.9705798E-05,   3.0742991E-05
     +,   3.1818978E-05,   3.2934939E-05,   3.4092107E-05
     +,   3.5291647E-05,   3.6534613E-05,   3.7822079E-05
     +,   3.9155024E-05,   4.0534374E-05,   4.1960913E-05
     +,   4.3435473E-05,   4.4958604E-05,   4.6531062E-05
     +,   4.8153317E-05,   4.9825758E-05,   5.1548905E-05
     +,   5.3323096E-05,   5.5148572E-05,   5.7025834E-05
     +,   5.8955193E-05,   6.0937007E-05,   6.2972002E-05
     +,   6.5060718E-05,   6.7204295E-05,   6.9403832E-05
     +,   7.1660950E-05,   7.3977586E-05,   7.6356497E-05
     +,   7.8800753E-05,   8.1314247E-05,   8.3901919E-05
     +,   8.6569424E-05,   8.9323454E-05,   9.2172202E-05
     +,   9.5124669E-05,   9.8191696E-05,   1.0138522E-04
     +,   1.0471878E-04,   1.0820733E-04,   1.1186766E-04
     +,   1.1571762E-04,   1.1977702E-04,   1.2406649E-04
     +,   1.2860794E-04,   1.3342410E-04,   1.3853879E-04
     +,   1.4397551E-04,   1.4975846E-04,   1.5591081E-04
     +,   1.6245498E-04,   1.6941178E-04,   1.7680103E-04
     +,   1.8463885E-04,   1.9293980E-04,   2.0171428E-04
     +,   2.1096891E-04,   2.2070741E-04,   2.3092808E-04
     +,   2.4162665E-04,   2.5279398E-04,   2.6441808E-04
     +,   2.7648406E-04,   2.8897723E-04,   3.0188164E-04
     +,   3.1518360E-04,   3.2887521E-04,   3.4295380E-04
     +,   3.5742644E-04,   3.7231395E-04,   3.8765054E-04
     +,   4.0348980E-04,   4.1990369E-04,   4.3698476E-04
     +,   4.5484531E-04,   4.7361886E-04,   4.9345114E-04
     +,   5.1450159E-04,   5.3693034E-04,   5.6089245E-04
     +,   5.8653031E-04,   6.1395846E-04,   6.4325484E-04
     +,   6.7445659E-04,   7.0754573E-04,   7.4244943E-04
     +,   7.7904575E-04,   8.1716146E-04,   8.5658784E-04
     +,   8.9710270E-04,   9.3848020E-04,   9.8052237E-04
     +,   1.0230782E-03,   1.0660755E-03,   1.1095258E-03
     +,   1.1535521E-03,   1.1983826E-03,   1.2443532E-03
     +,   1.2918946E-03,   1.3415099E-03,   1.3937507E-03
     +,   1.4491675E-03,   1.5082819E-03,   1.5715456E-03
     +,   1.6392996E-03,   1.7117613E-03,   1.7890112E-03
     +,   1.8709940E-03,   1.9575665E-03,   2.0485306E-03
     +,   2.1437078E-03,   2.2429884E-03,   2.3463559E-03
     +,   2.4539155E-03,   2.5658451E-03,   2.6823438E-03
     +,   2.8035378E-03,   2.9293504E-03,   3.0594512E-03
     +,   3.1931770E-03,   3.3295457E-03,   3.4673272E-03
     +,   3.6051278E-03,   3.7414602E-03,   3.8747760E-03
     +,   4.0033842E-03,   4.1253758E-03,   4.2386530E-03
     +,   4.3412051E-03,   4.4317287E-03,   4.5105936E-03
     +,   4.5808237E-03,   4.6486398E-03,   4.7230786E-03
     +,   4.8144124E-03,   4.9315565E-03,   5.0791912E-03
     +,   5.2556116E-03,   5.4522916E-03,   5.6556403E-03
     +,   5.8507854E-03,   6.0263360E-03,   6.1788643E-03
     +,   6.3158008E-03,   6.4558545E-03,   6.6267755E-03
     +,   6.8611694E-03,   7.1912911E-03,   7.6435893E-03
     +,   8.2323831E-03,   8.9520635E-03,   9.7691901E-03
     +,   1.0619569E-02,   1.1418729E-02,   1.2088935E-02
     +,   1.2595689E-02,   1.2973345E-02,   1.3317508E-02
     +,   1.3736024E-02,   1.4279495E-02,   1.4894523E-02
     +,   1.5437967E-02,   1.5750153E-02,   1.5738536E-02
     +,   1.5414353E-02,   1.4863993E-02,   1.4189228E-02
     +,   1.3464777E-02,   1.2731588E-02,   1.2009272E-02
     +,   1.1305531E-02,   1.0617436E-02,   9.9323690E-03
     +,   9.2342477E-03,   8.5125715E-03,   7.7686906E-03
     +,   7.0168287E-03,   6.2803929E-03,   5.5855014E-03
     +,   4.9545066E-03,   4.4011855E-03,   3.9291754E-03
     +,   3.5331568E-03,   3.2019797E-03,   2.9223540E-03
     +,   2.6816193E-03,   2.4693459E-03,   2.2779100E-03
     +,   2.1022179E-03,   1.9392552E-03,   1.7874826E-03
     +,   1.6463258E-03,   1.5157427E-03,   1.3958588E-03
     +,   1.2867328E-03,   1.1882145E-03,   1.0998758E-03
     +,   1.0210328E-03,   9.5081597E-04,   8.8824099E-04
     +,   8.3229615E-04,   7.8201195E-04,   7.3649740E-04
     +,   6.9497031E-04,   6.5676408E-04,   6.2132895E-04
     +,   5.8822759E-04,   5.5711716E-04,   5.2773632E-04
     +,   4.9989077E-04,   4.7343472E-04,   4.4826063E-04
     +,   4.2429002E-04,   4.0146030E-04,   3.7972056E-04
     +,   3.5902750E-04,   3.3933856E-04,   3.2061641E-04
     +,   3.0282210E-04,   2.8591990E-04,   2.6987409E-04
     +,   2.5465101E-04,   2.4021479E-04,   2.2653391E-04
     +,   2.1357679E-04,   2.0131245E-04,   1.8971138E-04
     +,   1.7874283E-04,   1.6837849E-04,   1.5858853E-04
     +,   1.4934478E-04,   1.4061887E-04,   1.3238273E-04
     +,   1.2460961E-04,   1.1727145E-04,   1.1034287E-04
     +,   1.0379883E-04,   9.7615390E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wano_fus_95 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wano_hz_100(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  1.7762563E-06,   1.8415517E-06
     +,   1.9085646E-06,   1.9773056E-06,   2.0477894E-06
     +,   2.1200278E-06,   2.1940282E-06,   2.2697991E-06
     +,   2.3473488E-06,   2.4266792E-06,   2.5077961E-06
     +,   2.5906988E-06,   2.6753896E-06,   2.7618632E-06
     +,   2.8501165E-06,   2.9401456E-06,   3.0319393E-06
     +,   3.1254885E-06,   3.2207845E-06,   3.3178087E-06
     +,   3.4165475E-06,   3.5169860E-06,   3.6190991E-06
     +,   3.7228688E-06,   3.8282728E-06,   3.9352813E-06
     +,   4.0438708E-06,   4.1540143E-06,   4.2656770E-06
     +,   4.3788309E-06,   4.4934454E-06,   4.6094797E-06
     +,   4.7269059E-06,   4.8456882E-06,   4.9657874E-06
     +,   5.0871690E-06,   5.2098007E-06,   5.3336430E-06
     +,   5.4586635E-06,   5.5848286E-06,   5.7121106E-06
     +,   5.8404739E-06,   5.9698964E-06,   6.1003548E-06
     +,   6.2318318E-06,   6.3643065E-06,   6.4977762E-06
     +,   6.6322295E-06,   6.7676756E-06,   6.9041234E-06
     +,   7.0415922E-06,   7.1801082E-06,   7.3197116E-06
     +,   7.4604518E-06,   7.6023889E-06,   7.7455998E-06
     +,   7.8901767E-06,   8.0362197E-06,   8.1838543E-06
     +,   8.3332216E-06,   8.4844760E-06,   8.6377995E-06
     +,   8.7933977E-06,   8.9514870E-06,   9.1123184E-06
     +,   9.2761702E-06,   9.4433308E-06,   9.6141339E-06
     +,   9.7889342E-06,   9.9681129E-06,   1.0152087E-05
     +,   1.0341299E-05,   1.0536237E-05,   1.0737398E-05
     +,   1.0945336E-05,   1.1160620E-05,   1.1383874E-05
     +,   1.1615745E-05,   1.1856901E-05,   1.2108086E-05
     +,   1.2370041E-05,   1.2643554E-05,   1.2929480E-05
     +,   1.3228677E-05,   1.3542049E-05,   1.3870569E-05
     +,   1.4215212E-05,   1.4577056E-05,   1.4957180E-05
     +,   1.5356731E-05,   1.5776905E-05,   1.6219010E-05
     +,   1.6684382E-05,   1.7174425E-05,   1.7690705E-05
     +,   1.8234836E-05,   1.8808541E-05,   1.9413748E-05
     +,   2.0052446E-05,   2.0726906E-05,   2.1439497E-05
     +,   2.2192873E-05,   2.2989876E-05,   2.3833740E-05
     +,   2.4727868E-05,   2.5676169E-05,   2.6682810E-05
     +,   2.7752425E-05,   2.8890048E-05,   3.0101344E-05
     +,   3.1392323E-05,   3.2769753E-05,   3.4240835E-05
     +,   3.5813449E-05,   3.7496051E-05,   3.9297938E-05
     +,   4.1228792E-05,   4.3299257E-05,   4.5520377E-05
     +,   4.7903788E-05,   5.0461975E-05,   5.3207539E-05
     +,   5.6153931E-05,   5.9314611E-05,   6.2703388E-05
     +,   6.6334018E-05,   7.0220653E-05,   7.4376803E-05
     +,   7.8815588E-05,   8.3550171E-05,   8.8592424E-05
     +,   9.3953327E-05,   9.9643505E-05,   1.0567155E-04
     +,   1.1204573E-04,   1.1877227E-04,   1.2585637E-04
     +,   1.3330166E-04,   1.4111139E-04,   1.4928673E-04
     +,   1.5782933E-04,   1.6673948E-04,   1.7601736E-04
     +,   1.8566461E-04,   1.9568273E-04,   2.0607426E-04
     +,   2.1684509E-04,   2.2800185E-04,   2.3955389E-04
     +,   2.5151449E-04,   2.6389869E-04,   2.7672431E-04
     +,   2.9001312E-04,   3.0378753E-04,   3.1807169E-04
     +,   3.3288958E-04,   3.4826572E-04,   3.6422035E-04
     +,   3.8077196E-04,   3.9793190E-04,   4.1570544E-04
     +,   4.3408861E-04,   4.5307077E-04,   4.7263189E-04
     +,   4.9274415E-04,   5.1337399E-04,   5.3448800E-04
     +,   5.5605493E-04,   5.7805702E-04,   6.0049602E-04
     +,   6.2339974E-04,   6.4683385E-04,   6.7090796E-04
     +,   6.9578353E-04,   7.2167307E-04,   7.4883719E-04
     +,   7.7757915E-04,   8.0823305E-04,   8.4114657E-04
     +,   8.7667257E-04,   9.1514469E-04,   9.5687888E-04
     +,   1.0021689E-03,   1.0513029E-03,   1.1045885E-03
     +,   1.1623900E-03,   1.2251759E-03,   1.2935493E-03
     +,   1.3682565E-03,   1.4501715E-03,   1.5402113E-03
     +,   1.6392154E-03,   1.7477570E-03,   1.8659112E-03
     +,   1.9930627E-03,   2.1277431E-03,   2.2675730E-03
     +,   2.4093636E-03,   2.5493521E-03,   2.6835685E-03
     +,   2.8083127E-03,   2.9206094E-03,   3.0185834E-03
     +,   3.1016816E-03,   3.1706661E-03,   3.2274208E-03
     +,   3.2745926E-03,   3.3151743E-03,   3.3520767E-03
     +,   3.3878090E-03,   3.4242736E-03,   3.4627228E-03
     +,   3.5038560E-03,   3.5480089E-03,   3.5954334E-03
     +,   3.6465956E-03,   3.7025085E-03,   3.7649511E-03
     +,   3.8365826E-03,   3.9208527E-03,   4.0216581E-03
     +,   4.1427035E-03,   4.2866524E-03,   4.4540376E-03
     +,   4.6421988E-03,   4.8443908E-03,   5.0494638E-03
     +,   5.2423044E-03,   5.4056137E-03,   5.5228025E-03
     +,   5.5818530E-03,   5.5792336E-03,   5.5226227E-03
     +,   5.4311971E-03,   5.3327135E-03,   5.2574999E-03
     +,   5.2309353E-03,   5.2668243E-03,   5.3642858E-03
     +,   5.5098291E-03,   5.6840358E-03,   5.8705099E-03
     +,   6.0629253E-03,   6.2669921E-03,   6.4958683E-03
     +,   6.7610564E-03,   7.0629604E-03,   7.3857564E-03
     +,   7.6997369E-03,   7.9703825E-03,   8.1702136E-03
     +,   8.2884319E-03,   8.3337985E-03,   8.3302949E-03
     +,   8.3075380E-03,   8.2900869E-03,   8.2895020E-03
     +,   8.3009265E-03,   8.3048586E-03,   8.2730567E-03
     +,   8.1768818E-03,   7.9959016E-03,   7.7239075E-03
     +,   7.3704855E-03,   6.9577540E-03,   6.5137497E-03
     +,   6.0654194E-03,   5.6336131E-03,   5.2313469E-03
     +,   4.8646647E-03,   4.5346403E-03,   4.2393482E-03
     +,   3.9751320E-03,   3.7372548E-03,   3.5204161E-03
     +,   3.3192849E-03,   3.1290427E-03,   2.9458501E-03
     +,   2.7670495E-03,   2.5910917E-03,   2.4173807E-03
     +,   2.2459873E-03,   2.0775211E-03,   1.9129678E-03
     +,   1.7536113E-03,   1.6008504E-03,   1.4561181E-03
     +,   1.3206553E-03,   1.1953622E-03,   1.0806998E-03
     +,   9.7663922E-04,   8.8273158E-04,   7.9817453E-04
     +,   7.2196580E-04,   6.5301865E-04,   5.9027917E-04
     +,   5.3281378E-04,   4.7983951E-04,   4.3076783E-04
     +,   3.8517764E-04,   3.4279449E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wano_hz_100 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wano_hz_105(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  1.1654733E-07,   1.2395024E-07
     +,   1.3176084E-07,   1.3999708E-07,   1.4867749E-07
     +,   1.5782146E-07,   1.6744804E-07,   1.7757756E-07
     +,   1.8823067E-07,   1.9942796E-07,   2.1119109E-07
     +,   2.2354196E-07,   2.3650304E-07,   2.5009672E-07
     +,   2.6434617E-07,   2.7927518E-07,   2.9490695E-07
     +,   3.1126598E-07,   3.2837690E-07,   3.4626359E-07
     +,   3.6495146E-07,   3.8446578E-07,   4.0483087E-07
     +,   4.2607252E-07,   4.4821618E-07,   4.7128668E-07
     +,   4.9530928E-07,   5.2031015E-07,   5.4631289E-07
     +,   5.7334319E-07,   6.0142560E-07,   6.3058388E-07
     +,   6.6084215E-07,   6.9222432E-07,   7.2475206E-07
     +,   7.5844861E-07,   7.9333591E-07,   8.2943370E-07
     +,   8.6676295E-07,   9.0534309E-07,   9.4519248E-07
     +,   9.8632790E-07,   1.0287660E-06,   1.0725219E-06
     +,   1.1176106E-06,   1.1640431E-06,   1.2118326E-06
     +,   1.2609872E-06,   1.3115166E-06,   1.3634279E-06
     +,   1.4167276E-06,   1.4714186E-06,   1.5275039E-06
     +,   1.5849862E-06,   1.6438634E-06,   1.7041340E-06
     +,   1.7657969E-06,   1.8288458E-06,   1.8932766E-06
     +,   1.9590841E-06,   2.0262596E-06,   2.0947971E-06
     +,   2.1646908E-06,   2.2359318E-06,   2.3085154E-06
     +,   2.3824396E-06,   2.4576984E-06,   2.5342961E-06
     +,   2.6122382E-06,   2.6915329E-06,   2.7721983E-06
     +,   2.8542593E-06,   2.9377529E-06,   3.0227213E-06
     +,   3.1092291E-06,   3.1973475E-06,   3.2871808E-06
     +,   3.3788449E-06,   3.4724817E-06,   3.5682770E-06
     +,   3.6664394E-06,   3.7672205E-06,   3.8709295E-06
     +,   3.9779202E-06,   4.0886048E-06,   4.2034817E-06
     +,   4.3231103E-06,   4.4481581E-06,   4.5793799E-06
     +,   4.7176522E-06,   4.8639681E-06,   5.0194844E-06
     +,   5.1854981E-06,   5.3634785E-06,   5.5551141E-06
     +,   5.7622797E-06,   5.9870886E-06,   6.2319314E-06
     +,   6.4994406E-06,   6.7925894E-06,   7.1146428E-06
     +,   7.4692225E-06,   7.8603007E-06,   8.2922879E-06
     +,   8.7699391E-06,   9.2985065E-06,   9.8836299E-06
     +,   1.0531420E-05,   1.1248418E-05,   1.2041708E-05
     +,   1.2918719E-05,   1.3887441E-05,   1.4956199E-05
     +,   1.6133736E-05,   1.7429091E-05,   1.8851770E-05
     +,   2.0411297E-05,   2.2117598E-05,   2.3980492E-05
     +,   2.6009760E-05,   2.8215292E-05,   3.0606388E-05
     +,   3.3192307E-05,   3.5981520E-05,   3.8981889E-05
     +,   4.2200300E-05,   4.5643010E-05,   4.9314749E-05
     +,   5.3218857E-05,   5.7357654E-05,   6.1731364E-05
     +,   6.6338442E-05,   7.1175913E-05,   7.6238175E-05
     +,   8.1518250E-05,   8.7006520E-05,   9.2691414E-05
     +,   9.8559045E-05,   1.0459416E-04,   1.1077862E-04
     +,   1.1709351E-04,   1.2351747E-04,   1.3002781E-04
     +,   1.3660140E-04,   1.4321356E-04,   1.4983902E-04
     +,   1.5645323E-04,   1.6303107E-04,   1.6954799E-04
     +,   1.7598139E-04,   1.8230923E-04,   1.8851145E-04
     +,   1.9457101E-04,   2.0047279E-04,   2.0620487E-04
     +,   2.1175847E-04,   2.1712898E-04,   2.2231475E-04
     +,   2.2731890E-04,   2.3214790E-04,   2.3681275E-04
     +,   2.4132803E-04,   2.4571302E-04,   2.4999099E-04
     +,   2.5418881E-04,   2.5833747E-04,   2.6247202E-04
     +,   2.6663096E-04,   2.7085774E-04,   2.7519985E-04
     +,   2.7970909E-04,   2.8444256E-04,   2.8946306E-04
     +,   2.9483941E-04,   3.0064795E-04,   3.0697201E-04
     +,   3.1390358E-04,   3.2154340E-04,   3.3000106E-04
     +,   3.3939700E-04,   3.4985880E-04,   3.6152438E-04
     +,   3.7453751E-04,   3.8904737E-04,   4.0520536E-04
     +,   4.2316117E-04,   4.4305986E-04,   4.6503561E-04
     +,   4.8920326E-04,   5.1565451E-04,   5.4444670E-04
     +,   5.7560031E-04,   6.0908752E-04,   6.4482458E-04
     +,   6.8266882E-04,   7.2241470E-04,   7.6379318E-04
     +,   8.0647721E-04,   8.5009029E-04,   8.9421199E-04
     +,   9.3839964E-04,   9.8220562E-04,   1.0251959E-03
     +,   1.0669800E-03,   1.1072243E-03,   1.1456661E-03
     +,   1.1821331E-03,   1.2165422E-03,   1.2489011E-03
     +,   1.2792994E-03,   1.3078834E-03,   1.3348442E-03
     +,   1.3603909E-03,   1.3847256E-03,   1.4080345E-03
     +,   1.4304657E-03,   1.4521339E-03,   1.4731220E-03
     +,   1.4934964E-03,   1.5133236E-03,   1.5326891E-03
     +,   1.5517137E-03,   1.5705638E-03,   1.5894457E-03
     +,   1.6085971E-03,   1.6282628E-03,   1.6486691E-03
     +,   1.6699956E-03,   1.6923500E-03,   1.7157567E-03
     +,   1.7401665E-03,   1.7654648E-03,   1.7915095E-03
     +,   1.8181652E-03,   1.8453330E-03,   1.8729835E-03
     +,   1.9011698E-03,   1.9300344E-03,   1.9598056E-03
     +,   1.9907989E-03,   2.0234105E-03,   2.0581207E-03
     +,   2.0954970E-03,   2.1361748E-03,   2.1808101E-03
     +,   2.2299939E-03,   2.2841459E-03,   2.3433666E-03
     +,   2.4073359E-03,   2.4752766E-03,   2.5459817E-03
     +,   2.6180167E-03,   2.6899553E-03,   2.7607419E-03
     +,   2.8300004E-03,   2.8983003E-03,   2.9672531E-03
     +,   3.0394411E-03,   3.1181369E-03,   3.2069620E-03
     +,   3.3096215E-03,   3.4299134E-03,   3.5721883E-03
     +,   3.7421193E-03,   3.9473586E-03,   4.1973940E-03
     +,   4.5018545E-03,   4.8672543E-03,   5.2928799E-03
     +,   5.7676919E-03,   6.2704049E-03,   6.7736036E-03
     +,   7.2508003E-03,   7.6838322E-03,   8.0672819E-03
     +,   8.4088435E-03,   8.7267570E-03,   9.0461206E-03
     +,   9.3947174E-03,   9.7970422E-03,   1.0264974E-02
     +,   1.0787847E-02,   1.1327320E-02,   1.1823232E-02
     +,   1.2209734E-02,   1.2433777E-02,   1.2465141E-02
     +,   1.2294239E-02,   1.1922415E-02,   1.1354948E-02
     +,   1.0602945E-02,   9.6917339E-03,   8.6666513E-03
     +,   7.5900299E-03,   6.5284879E-03,   5.5375481E-03
     +,   4.6508731E-03,   3.8781916E-03,   3.2116834E-03
     +,   2.6352664E-03,   2.1331322E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wano_hz_105 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wano_hz_107(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  1.2761217E-06,   1.3169184E-06
     +,   1.3585573E-06,   1.4010344E-06,   1.4443470E-06
     +,   1.4884926E-06,   1.5334643E-06,   1.5792567E-06
     +,   1.6258639E-06,   1.6732760E-06,   1.7214849E-06
     +,   1.7704801E-06,   1.8202524E-06,   1.8707871E-06
     +,   1.9220715E-06,   1.9740930E-06,   2.0268340E-06
     +,   2.0802788E-06,   2.1344115E-06,   2.1892110E-06
     +,   2.2446591E-06,   2.3007367E-06,   2.3574203E-06
     +,   2.4146882E-06,   2.4725189E-06,   2.5308857E-06
     +,   2.5897655E-06,   2.6491343E-06,   2.7089636E-06
     +,   2.7692283E-06,   2.8299023E-06,   2.8909565E-06
     +,   2.9523646E-06,   3.0141007E-06,   3.0761353E-06
     +,   3.1384429E-06,   3.2009978E-06,   3.2637715E-06
     +,   3.3267411E-06,   3.3898834E-06,   3.4531759E-06
     +,   3.5165965E-06,   3.5801284E-06,   3.6437550E-06
     +,   3.7074647E-06,   3.7712457E-06,   3.8350940E-06
     +,   3.8990042E-06,   3.9629817E-06,   4.0270352E-06
     +,   4.0911805E-06,   4.1554349E-06,   4.2198312E-06
     +,   4.2844081E-06,   4.3492091E-06,   4.4142948E-06
     +,   4.4797375E-06,   4.5456163E-06,   4.6120308E-06
     +,   4.6790960E-06,   4.7469407E-06,   4.8157167E-06
     +,   4.8855973E-06,   4.9567766E-06,   5.0294761E-06
     +,   5.1039483E-06,   5.1804695E-06,   5.2593555E-06
     +,   5.3409581E-06,   5.4256648E-06,   5.5139103E-06
     +,   5.6061745E-06,   5.7029902E-06,   5.8049372E-06
     +,   5.9126628E-06,   6.0268667E-06,   6.1483288E-06
     +,   6.2778895E-06,   6.4164624E-06,   6.5650529E-06
     +,   6.7247443E-06,   6.8966965E-06,   7.0821870E-06
     +,   7.2825687E-06,   7.4992913E-06,   7.7339291E-06
     +,   7.9881293E-06,   8.2636789E-06,   8.5624424E-06
     +,   8.8863999E-06,   9.2376222E-06,   9.6183194E-06
     +,   1.0030764E-05,   1.0477309E-05,   1.0960453E-05
     +,   1.1482707E-05,   1.2046653E-05,   1.2654988E-05
     +,   1.3310358E-05,   1.4015520E-05,   1.4773174E-05
     +,   1.5586018E-05,   1.6456679E-05,   1.7387822E-05
     +,   1.8381879E-05,   1.9441326E-05,   2.0568370E-05
     +,   2.1765089E-05,   2.3033293E-05,   2.4374724E-05
     +,   2.5790636E-05,   2.7282231E-05,   2.8850194E-05
     +,   3.0494939E-05,   3.2216427E-05,   3.4014432E-05
     +,   3.5888050E-05,   3.7836227E-05,   3.9857274E-05
     +,   4.1949053E-05,   4.4109249E-05,   4.6334786E-05
     +,   4.8622558E-05,   5.0968811E-05,   5.3369553E-05
     +,   5.5820368E-05,   5.8316953E-05,   6.0854491E-05
     +,   6.3428044E-05,   6.6032990E-05,   6.8664405E-05
     +,   7.1317540E-05,   7.3988187E-05,   7.6672070E-05
     +,   7.9365767E-05,   8.2066108E-05,   8.4770749E-05
     +,   8.7477943E-05,   9.0187197E-05,   9.2898568E-05
     +,   9.5613628E-05,   9.8334778E-05,   1.0106574E-04
     +,   1.0381176E-04,   1.0657924E-04,   1.0937583E-04
     +,   1.1221103E-04,   1.1509540E-04,   1.1804066E-04
     +,   1.2106048E-04,   1.2416925E-04,   1.2738253E-04
     +,   1.3071726E-04,   1.3419110E-04,   1.3782227E-04
     +,   1.4162979E-04,   1.4563344E-04,   1.4985265E-04
     +,   1.5430780E-04,   1.5901864E-04,   1.6400508E-04
     +,   1.6928645E-04,   1.7488241E-04,   1.8081215E-04
     +,   1.8709419E-04,   1.9374694E-04,   2.0078861E-04
     +,   2.0823732E-04,   2.1611176E-04,   2.2443126E-04
     +,   2.3321527E-04,   2.4248469E-04,   2.5226170E-04
     +,   2.6257124E-04,   2.7344038E-04,   2.8489847E-04
     +,   2.9697790E-04,   3.0971461E-04,   3.2314661E-04
     +,   3.3731683E-04,   3.5226837E-04,   3.6804797E-04
     +,   3.8470200E-04,   4.0227623E-04,   4.2081441E-04
     +,   4.4035603E-04,   4.6093605E-04,   4.8258292E-04
     +,   5.0531491E-04,   5.2914198E-04,   5.5406406E-04
     +,   5.8007444E-04,   6.0716108E-04,   6.3530658E-04
     +,   6.6449645E-04,   6.9472374E-04,   7.2599383E-04
     +,   7.5833435E-04,   7.9180114E-04,   8.2647864E-04
     +,   8.6248736E-04,   8.9998316E-04,   9.3915022E-04
     +,   9.8019815E-04,   1.0233425E-03,   1.0687825E-03
     +,   1.1166775E-03,   1.1671181E-03,   1.2200945E-03
     +,   1.2754651E-03,   1.3329218E-03,   1.3919737E-03
     +,   1.4519326E-03,   1.5119158E-03,   1.5708667E-03
     +,   1.6275779E-03,   1.6807553E-03,   1.7290672E-03
     +,   1.7712271E-03,   1.8060665E-03,   1.8326126E-03
     +,   1.8501540E-03,   1.8582880E-03,   1.8569524E-03
     +,   1.8464306E-03,   1.8273371E-03,   1.8005696E-03
     +,   1.7672625E-03,   1.7287041E-03,   1.6862778E-03
     +,   1.6413826E-03,   1.5953778E-03,   1.5495354E-03
     +,   1.5050145E-03,   1.4628589E-03,   1.4239991E-03
     +,   1.3892761E-03,   1.3594701E-03,   1.3353213E-03
     +,   1.3175578E-03,   1.3069003E-03,   1.3040500E-03
     +,   1.3096604E-03,   1.3242891E-03,   1.3483381E-03
     +,   1.3819821E-03,   1.4251169E-03,   1.4773051E-03
     +,   1.5377670E-03,   1.6054073E-03,   1.6788591E-03
     +,   1.7566028E-03,   1.8370502E-03,   1.9186956E-03
     +,   2.0002238E-03,   2.0806245E-03,   2.1592951E-03
     +,   2.2361067E-03,   2.3114621E-03,   2.3863064E-03
     +,   2.4620600E-03,   2.5404526E-03,   2.6232409E-03
     +,   2.7118442E-03,   2.8069834E-03,   2.9084671E-03
     +,   3.0152414E-03,   3.1257772E-03,   3.2387520E-03
     +,   3.3538879E-03,   3.4727673E-03,   3.5993499E-03
     +,   3.7399884E-03,   3.9028779E-03,   4.0970212E-03
     +,   4.3310612E-03,   4.6127914E-03,   4.9497397E-03
     +,   5.3507676E-03,   5.8277496E-03,   6.3954294E-03
     +,   7.0688562E-03,   7.8577939E-03,   8.7604858E-03
     +,   9.7586624E-03,   1.0816685E-02,   1.1884633E-02
     +,   1.2905910E-02,   1.3825198E-02,   1.4593178E-02
     +,   1.5166678E-02,   1.5504780E-02,   1.5565814E-02
     +,   1.5308277E-02,   1.4698147E-02,   1.3721407E-02
     +,   1.2398564E-02,   1.0794050E-02,   9.0154484E-03
     +,   7.1975030E-03,   5.4761777E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wano_hz_107 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wano_hz_110(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  4.9918381E-08,   5.4630270E-08
     +,   5.9746519E-08,   6.5297527E-08,   7.1315881E-08
     +,   7.7836162E-08,   8.4894715E-08,   9.2530385E-08
     +,   1.0078431E-07,   1.0969956E-07,   1.1932205E-07
     +,   1.2970000E-07,   1.4088455E-07,   1.5292872E-07
     +,   1.6588899E-07,   1.7982464E-07,   1.9479721E-07
     +,   2.1087163E-07,   2.2811622E-07,   2.4660125E-07
     +,   2.6640095E-07,   2.8759291E-07,   3.1025664E-07
     +,   3.3447594E-07,   3.6033799E-07,   3.8793152E-07
     +,   4.1735038E-07,   4.4869105E-07,   4.8205158E-07
     +,   5.1753511E-07,   5.5524777E-07,   5.9529663E-07
     +,   6.3779333E-07,   6.8285311E-07,   7.3059073E-07
     +,   7.8112646E-07,   8.3458298E-07,   8.9108198E-07
     +,   9.5075069E-07,   1.0137171E-06,   1.0801124E-06
     +,   1.1500647E-06,   1.2237085E-06,   1.3011773E-06
     +,   1.3826077E-06,   1.4681312E-06,   1.5578888E-06
     +,   1.6520117E-06,   1.7506386E-06,   1.8539060E-06
     +,   1.9619529E-06,   2.0749085E-06,   2.1929125E-06
     +,   2.3161012E-06,   2.4446033E-06,   2.5785546E-06
     +,   2.7180911E-06,   2.8633383E-06,   3.0144317E-06
     +,   3.1715056E-06,   3.3346851E-06,   3.5041057E-06
     +,   3.6799056E-06,   3.8622106E-06,   4.0511650E-06
     +,   4.2469114E-06,   4.4495873E-06,   4.6593518E-06
     +,   4.8763645E-06,   5.1007864E-06,   5.3327985E-06
     +,   5.5725918E-06,   5.8203777E-06,   6.0763700E-06
     +,   6.3408202E-06,   6.6139805E-06,   6.8961658E-06
     +,   7.1876884E-06,   7.4888940E-06,   7.8001985E-06
     +,   8.1220305E-06,   8.4548583E-06,   8.7992448E-06
     +,   9.1557686E-06,   9.5250734E-06,   9.9079043E-06
     +,   1.0305028E-05,   1.0717347E-05,   1.1145805E-05
     +,   1.1591444E-05,   1.2055392E-05,   1.2538923E-05
     +,   1.3043366E-05,   1.3570160E-05,   1.4120915E-05
     +,   1.4697309E-05,   1.5301126E-05,   1.5934365E-05
     +,   1.6599042E-05,   1.7297423E-05,   1.8031813E-05
     +,   1.8804709E-05,   1.9618679E-05,   2.0476564E-05
     +,   2.1381198E-05,   2.2335706E-05,   2.3343264E-05
     +,   2.4407214E-05,   2.5531052E-05,   2.6718541E-05
     +,   2.7973443E-05,   2.9299919E-05,   3.0702162E-05
     +,   3.2184646E-05,   3.3752000E-05,   3.5409306E-05
     +,   3.7161699E-05,   3.9014860E-05,   4.0974624E-05
     +,   4.3047210E-05,   4.5239485E-05,   4.7558420E-05
     +,   5.0011840E-05,   5.2607855E-05,   5.5355184E-05
     +,   5.8263024E-05,   6.1341554E-05,   6.4601139E-05
     +,   6.8052846E-05,   7.1708673E-05,   7.5580756E-05
     +,   7.9681689E-05,   8.4025058E-05,   8.8623929E-05
     +,   9.3492352E-05,   9.8643846E-05,   1.0409186E-04
     +,   1.0984926E-04,   1.1592890E-04,   1.2234176E-04
     +,   1.2909867E-04,   1.3620815E-04,   1.4367685E-04
     +,   1.5151016E-04,   1.5971019E-04,   1.6827631E-04
     +,   1.7720593E-04,   1.8649241E-04,   1.9612569E-04
     +,   2.0609352E-04,   2.1637924E-04,   2.2696285E-04
     +,   2.3782250E-04,   2.4893251E-04,   2.6026505E-04
     +,   2.7179022E-04,   2.8347821E-04,   2.9529713E-04
     +,   3.0721709E-04,   3.1920872E-04,   3.3124498E-04
     +,   3.4330273E-04,   3.5536388E-04,   3.6741665E-04
     +,   3.7945525E-04,   3.9148214E-04,   4.0350930E-04
     +,   4.1555750E-04,   4.2765899E-04,   4.3985643E-04
     +,   4.5220190E-04,   4.6475831E-04,   4.7759752E-04
     +,   4.9080106E-04,   5.0445821E-04,   5.1866431E-04
     +,   5.3351978E-04,   5.4913003E-04,   5.6560204E-04
     +,   5.8304647E-04,   6.0157193E-04,   6.2128750E-04
     +,   6.4229599E-04,   6.6469359E-04,   6.8856589E-04
     +,   7.1398017E-04,   7.4098387E-04,   7.6959759E-04
     +,   7.9980609E-04,   8.3155948E-04,   8.6476863E-04
     +,   8.9931424E-04,   9.3505468E-04,   9.7183755E-04
     +,   1.0095288E-03,   1.0480362E-03,   1.0873426E-03
     +,   1.1275384E-03,   1.1688470E-03,   1.2116373E-03
     +,   1.2564304E-03,   1.3038827E-03,   1.3547442E-03
     +,   1.4098093E-03,   1.4698326E-03,   1.5354401E-03
     +,   1.6070406E-03,   1.6847325E-03,   1.7682440E-03
     +,   1.8568771E-03,   1.9495037E-03,   2.0445818E-03
     +,   2.1402314E-03,   2.2343188E-03,   2.3245991E-03
     +,   2.4088267E-03,   2.4849239E-03,   2.5510897E-03
     +,   2.6059197E-03,   2.6484851E-03,   2.6783792E-03
     +,   2.6957253E-03,   2.7011409E-03,   2.6956836E-03
     +,   2.6807496E-03,   2.6579830E-03,   2.6291525E-03
     +,   2.5960531E-03,   2.5603953E-03,   2.5237594E-03
     +,   2.4875219E-03,   2.4528534E-03,   2.4207029E-03
     +,   2.3918154E-03,   2.3667496E-03,   2.3458737E-03
     +,   2.3293723E-03,   2.3172239E-03,   2.3091920E-03
     +,   2.3048178E-03,   2.3034210E-03,   2.3041563E-03
     +,   2.3060946E-03,   2.3083277E-03,   2.3101112E-03
     +,   2.3109943E-03,   2.3109333E-03,   2.3103538E-03
     +,   2.3101540E-03,   2.3116441E-03,   2.3164288E-03
     +,   2.3262410E-03,   2.3427601E-03,   2.3674318E-03
     +,   2.4012928E-03,   2.4448449E-03,   2.4979510E-03
     +,   2.5597876E-03,   2.6288193E-03,   2.7028532E-03
     +,   2.7791332E-03,   2.8545056E-03,   2.9256656E-03
     +,   2.9894589E-03,   3.0432274E-03,   3.0851967E-03
     +,   3.1148130E-03,   3.1329908E-03,   3.1422442E-03
     +,   3.1466007E-03,   3.1513385E-03,   3.1625340E-03
     +,   3.1864711E-03,   3.2290325E-03,   3.2951878E-03
     +,   3.3887126E-03,   3.5122721E-03,   3.6677872E-03
     +,   3.8569609E-03,   4.0817074E-03,   4.3439870E-03
     +,   4.6450859E-03,   4.9841325E-03,   5.3565707E-03
     +,   5.7530077E-03,   6.1592804E-03,   6.5574190E-03
     +,   6.9278488E-03,   7.2514741E-03,   7.5111608E-03
     +,   7.6921862E-03,   7.7817552E-03,   7.7684876E-03
     +,   7.6425350E-03,   7.3968442E-03,   7.0294067E-03
     +,   6.5457481E-03,   5.9603895E-03,   5.2971113E-03
     +,   4.5868987E-03,   3.8644611E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wano_hz_110 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wano_hz_115(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  1.4846167E-06,   1.5379645E-06
     +,   1.5925606E-06,   1.6484004E-06,   1.7054809E-06
     +,   1.7637977E-06,   1.8233407E-06,   1.8841014E-06
     +,   1.9460701E-06,   2.0092311E-06,   2.0735699E-06
     +,   2.1390697E-06,   2.2057125E-06,   2.2734744E-06
     +,   2.3423331E-06,   2.4122648E-06,   2.4832391E-06
     +,   2.5552276E-06,   2.6281991E-06,   2.7021181E-06
     +,   2.7769483E-06,   2.8526538E-06,   2.9291903E-06
     +,   3.0065175E-06,   3.0845915E-06,   3.1633629E-06
     +,   3.2427834E-06,   3.3228050E-06,   3.4033712E-06
     +,   3.4844288E-06,   3.5659223E-06,   3.6477907E-06
     +,   3.7299751E-06,   3.8124165E-06,   3.8950475E-06
     +,   3.9778060E-06,   4.0606278E-06,   4.1434414E-06
     +,   4.2261836E-06,   4.3087821E-06,   4.3911714E-06
     +,   4.4732778E-06,   4.5550341E-06,   4.6363684E-06
     +,   4.7172130E-06,   4.7974950E-06,   4.8771490E-06
     +,   4.9561040E-06,   5.0342946E-06,   5.1116572E-06
     +,   5.1881307E-06,   5.2636497E-06,   5.3381605E-06
     +,   5.4116099E-06,   5.4839452E-06,   5.5551232E-06
     +,   5.6251033E-06,   5.6938502E-06,   5.7613356E-06
     +,   5.8275409E-06,   5.8924506E-06,   5.9560625E-06
     +,   6.0183820E-06,   6.0794264E-06,   6.1392248E-06
     +,   6.1978226E-06,   6.2552726E-06,   6.3116513E-06
     +,   6.3670500E-06,   6.4215769E-06,   6.4753626E-06
     +,   6.5285626E-06,   6.5813560E-06,   6.6339453E-06
     +,   6.6865700E-06,   6.7394903E-06,   6.7930123E-06
     +,   6.8474737E-06,   6.9032462E-06,   6.9607572E-06
     +,   7.0204696E-06,   7.0829001E-06,   7.1486197E-06
     +,   7.2182552E-06,   7.2924868E-06,   7.3720789E-06
     +,   7.4578393E-06,   7.5506759E-06,   7.6515516E-06
     +,   7.7615268E-06,   7.8817338E-06,   8.0134159E-06
     +,   8.1578946E-06,   8.3165942E-06,   8.4910589E-06
     +,   8.6829214E-06,   8.8939287E-06,   9.1259681E-06
     +,   9.3810058E-06,   9.6611739E-06,   9.9686940E-06
     +,   1.0305927E-05,   1.0675340E-05,   1.1079569E-05
     +,   1.1521318E-05,   1.2003476E-05,   1.2528998E-05
     +,   1.3100969E-05,   1.3722553E-05,   1.4397094E-05
     +,   1.5127910E-05,   1.5918517E-05,   1.6772401E-05
     +,   1.7693139E-05,   1.8684279E-05,   1.9749519E-05
     +,   2.0892376E-05,   2.2116512E-05,   2.3425404E-05
     +,   2.4822441E-05,   2.6311067E-05,   2.7894368E-05
     +,   2.9575511E-05,   3.1357289E-05,   3.3242355E-05
     +,   3.5233017E-05,   3.7331571E-05,   3.9539784E-05
     +,   4.1859101E-05,   4.4290915E-05,   4.6836001E-05
     +,   4.9494782E-05,   5.2267638E-05,   5.5154145E-05
     +,   5.8154026E-05,   6.1266277E-05,   6.4489715E-05
     +,   6.7822701E-05,   7.1263741E-05,   7.4810538E-05
     +,   7.8461140E-05,   8.2213002E-05,   8.6063446E-05
     +,   9.0010108E-05,   9.4050163E-05,   9.8180710E-05
     +,   1.0239939E-04,   1.0670338E-04,   1.1109000E-04
     +,   1.1555717E-04,   1.2010246E-04,   1.2472359E-04
     +,   1.2941918E-04,   1.3418749E-04,   1.3902730E-04
     +,   1.4393765E-04,   1.4891860E-04,   1.5397013E-04
     +,   1.5909375E-04,   1.6429147E-04,   1.6956676E-04
     +,   1.7492461E-04,   1.8037265E-04,   1.8592118E-04
     +,   1.9158359E-04,   1.9737768E-04,   2.0332637E-04
     +,   2.0945846E-04,   2.1581016E-04,   2.2242572E-04
     +,   2.2935780E-04,   2.3666871E-04,   2.4443027E-04
     +,   2.5272492E-04,   2.6164443E-04,   2.7128842E-04
     +,   2.8176393E-04,   2.9318291E-04,   3.0566019E-04
     +,   3.1931270E-04,   3.3425417E-04,   3.5059865E-04
     +,   3.6845598E-04,   3.8793488E-04,   4.0914558E-04
     +,   4.3220154E-04,   4.5722802E-04,   4.8436390E-04
     +,   5.1376282E-04,   5.4559694E-04,   5.8005139E-04
     +,   6.1732053E-04,   6.5759377E-04,   7.0103700E-04
     +,   7.4777904E-04,   7.9789641E-04,   8.5140055E-04
     +,   9.0824213E-04,   9.6831535E-04,   1.0314687E-03
     +,   1.0975332E-03,   1.1663375E-03,   1.2377189E-03
     +,   1.3115249E-03,   1.3875843E-03,   1.4656520E-03
     +,   1.5453625E-03,   1.6261564E-03,   1.7072350E-03
     +,   1.7875301E-03,   1.8657041E-03,   1.9402285E-03
     +,   2.0094928E-03,   2.0719664E-03,   2.1264052E-03
     +,   2.1720389E-03,   2.2087761E-03,   2.2372997E-03
     +,   2.2590992E-03,   2.2763463E-03,   2.2916466E-03
     +,   2.3076588E-03,   2.3266557E-03,   2.3501029E-03
     +,   2.3783504E-03,   2.4105341E-03,   2.4447057E-03
     +,   2.4781981E-03,   2.5081546E-03,   2.5320819E-03
     +,   2.5483072E-03,   2.5562446E-03,   2.5563864E-03
     +,   2.5500678E-03,   2.5390729E-03,   2.5251976E-03
     +,   2.5099034E-03,   2.4941172E-03,   2.4782219E-03
     +,   2.4621775E-03,   2.4457346E-03,   2.4286148E-03
     +,   2.4106118E-03,   2.3916089E-03,   2.3715065E-03
     +,   2.3501380E-03,   2.3272238E-03,   2.3024140E-03
     +,   2.2754387E-03,   2.2463046E-03,   2.2155282E-03
     +,   2.1842739E-03,   2.1543994E-03,   2.1283198E-03
     +,   2.1087537E-03,   2.0983752E-03,   2.0994414E-03
     +,   2.1134992E-03,   2.1411907E-03,   2.1822038E-03
     +,   2.2353746E-03,   2.2988531E-03,   2.3703447E-03
     +,   2.4473104E-03,   2.5271215E-03,   2.6071677E-03
     +,   2.6849185E-03,   2.7580005E-03,   2.8242902E-03
     +,   2.8820559E-03,   2.9301348E-03,   2.9680640E-03
     +,   2.9961129E-03,   3.0151785E-03,   3.0264929E-03
     +,   3.0312331E-03,   3.0301288E-03,   3.0231480E-03
     +,   3.0094096E-03,   2.9873212E-03,   2.9549305E-03
     +,   2.9103751E-03,   2.8523235E-03,   2.7802556E-03
     +,   2.6945679E-03,   2.5964133E-03,   2.4874781E-03
     +,   2.3696376E-03,   2.2446909E-03,   2.1142010E-03
     +,   1.9794432E-03,   1.8415177E-03,   1.7014481E-03
     +,   1.5603557E-03,   1.4195296E-03,   1.2804499E-03
     +,   1.1447469E-03,   1.0140500E-03,   8.8992470E-04
     +,   7.7370921E-04,   6.6643354E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wano_hz_115 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wano_hz_120(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  5.4918721E-16,   7.4370133E-16
     +,   1.0051910E-15,   1.3560242E-15,   1.8258162E-15
     +,   2.4536927E-15,   3.2911908E-15,   4.4061244E-15
     +,   5.8875664E-15,   7.8520954E-15,   1.0452188E-14
     +,   1.3886823E-14,   1.8415123E-14,   2.4373493E-14
     +,   3.2198480E-14,   4.2455223E-14,   5.5872716E-14
     +,   7.3391244E-14,   9.6220680E-14,   1.2591172E-13
     +,   1.6445318E-13,   2.1438725E-13,   2.7895348E-13
     +,   3.6228033E-13,   4.6961220E-13,   6.0759340E-13
     +,   7.8463684E-13,   1.0113657E-12,   1.3011521E-12
     +,   1.6708299E-12,   2.1415259E-12,   2.7396653E-12
     +,   3.4983058E-12,   4.4586908E-12,   5.6720887E-12
     +,   7.2022366E-12,   9.1281557E-12,   1.1547513E-11
     +,   1.4580918E-11,   1.8376967E-11,   2.3118476E-11
     +,   2.9029336E-11,   3.6384007E-11,   4.5517728E-11
     +,   5.6839568E-11,   7.0846398E-11,   8.8142847E-11
     +,   1.0945996E-10,   1.3568319E-10,   1.6788054E-10
     +,   2.0733888E-10,   2.5560262E-10,   3.1452582E-10
     +,   3.8632880E-10,   4.7365778E-10,   5.7967275E-10
     +,   7.0813139E-10,   8.6348539E-10,   1.0510168E-09
     +,   1.2769690E-09,   1.5486910E-09,   1.8748447E-09
     +,   2.2656101E-09,   2.7328846E-09,   3.2906093E-09
     +,   3.9550647E-09,   4.7451456E-09,   5.6828622E-09
     +,   6.7937358E-09,   8.1072153E-09,   9.6573540E-09
     +,   1.1483356E-08,   1.3630310E-08,   1.6149771E-08
     +,   1.9100908E-08,   2.2550939E-08,   2.6576904E-08
     +,   3.1265859E-08,   3.6716422E-08,   4.3040732E-08
     +,   5.0364616E-08,   5.8829581E-08,   6.8595448E-08
     +,   7.9840135E-08,   9.2762185E-08,   1.0758450E-07
     +,   1.2455236E-07,   1.4394021E-07,   1.6604962E-07
     +,   1.9121362E-07,   2.1979730E-07,   2.5220427E-07
     +,   2.8887325E-07,   3.3028115E-07,   3.7695233E-07
     +,   4.2945030E-07,   4.8838342E-07,   5.5441518E-07
     +,   6.2824796E-07,   7.1064699E-07,   8.0241932E-07
     +,   9.0442956E-07,   1.0175899E-06,   1.1428801E-06
     +,   1.2813163E-06,   1.4339871E-06,   1.6020191E-06
     +,   1.7865964E-06,   1.9889465E-06,   2.2103684E-06
     +,   2.4521771E-06,   2.7157714E-06,   3.0025653E-06
     +,   3.3140263E-06,   3.6516492E-06,   4.0170135E-06
     +,   4.4116814E-06,   4.8373195E-06,   5.2955934E-06
     +,   5.7882098E-06,   6.3169859E-06,   6.8837221E-06
     +,   7.4903633E-06,   8.1388735E-06,   8.8313236E-06
     +,   9.5698624E-06,   1.0356845E-05,   1.1194676E-05
     +,   1.2085918E-05,   1.3033423E-05,   1.4040128E-05
     +,   1.5109204E-05,   1.6244179E-05,   1.7448687E-05
     +,   1.8726809E-05,   2.0082785E-05,   2.1521193E-05
     +,   2.3046832E-05,   2.4664963E-05,   2.6380842E-05
     +,   2.8200189E-05,   3.0128689E-05,   3.2172080E-05
     +,   3.4336335E-05,   3.6627087E-05,   3.9049708E-05
     +,   4.1609484E-05,   4.4310902E-05,   4.7157711E-05
     +,   5.0153165E-05,   5.3299122E-05,   5.6596193E-05
     +,   6.0044051E-05,   6.3640444E-05,   6.7381632E-05
     +,   7.1262133E-05,   7.5275282E-05,   7.9412348E-05
     +,   8.3664010E-05,   8.8019675E-05,   9.2468676E-05
     +,   9.7000826E-05,   1.0160786E-04,   1.0628458E-04
     +,   1.1102992E-04,   1.1584935E-04,   1.2075689E-04
     +,   1.2577712E-04,   1.3094814E-04,   1.3632375E-04
     +,   1.4197508E-04,   1.4799321E-04,   1.5449015E-04
     +,   1.6159998E-04,   1.6947833E-04,   1.7829977E-04
     +,   1.8825610E-04,   1.9955117E-04,   2.1239478E-04
     +,   2.2699704E-04,   2.4355648E-04,   2.6225494E-04
     +,   2.8324331E-04,   3.0663461E-04,   3.3249360E-04
     +,   3.6082836E-04,   3.9158677E-04,   4.2465123E-04
     +,   4.5983467E-04,   4.9688527E-04,   5.3548923E-04
     +,   5.7528249E-04,   6.1585836E-04,   6.5677805E-04
     +,   6.9758942E-04,   7.3784357E-04,   7.7710947E-04
     +,   8.1499823E-04,   8.5117517E-04,   8.8537001E-04
     +,   9.1739366E-04,   9.4714051E-04,   9.7458466E-04
     +,   9.9977688E-04,   1.0228250E-03,   1.0438726E-03
     +,   1.0630782E-03,   1.0805896E-03,   1.0965266E-03
     +,   1.1109672E-03,   1.1239449E-03,   1.1354596E-03
     +,   1.1454988E-03,   1.1540641E-03,   1.1612065E-03
     +,   1.1670524E-03,   1.1718302E-03,   1.1758815E-03
     +,   1.1796620E-03,   1.1837303E-03,   1.1887320E-03
     +,   1.1953777E-03,   1.2044210E-03,   1.2166379E-03
     +,   1.2328065E-03,   1.2536801E-03,   1.2799494E-03
     +,   1.3121861E-03,   1.3507773E-03,   1.3958303E-03
     +,   1.4471005E-03,   1.5039180E-03,   1.5651701E-03
     +,   1.6293146E-03,   1.6944578E-03,   1.7584850E-03
     +,   1.8192180E-03,   1.8745689E-03,   1.9226964E-03
     +,   1.9620871E-03,   1.9916068E-03,   2.0105040E-03
     +,   2.0183783E-03,   2.0151457E-03,   2.0010059E-03
     +,   1.9764453E-03,   1.9422501E-03,   1.8995540E-03
     +,   1.8498731E-03,   1.7951140E-03,   1.7375632E-03
     +,   1.6797889E-03,   1.6245213E-03,   1.5744627E-03
     +,   1.5320857E-03,   1.4994572E-03,   1.4780954E-03
     +,   1.4689285E-03,   1.4723346E-03,   1.4882609E-03
     +,   1.5163881E-03,   1.5562697E-03,   1.6074175E-03
     +,   1.6692572E-03,   1.7409741E-03,   1.8212810E-03
     +,   1.9081646E-03,   1.9987242E-03,   2.0891638E-03
     +,   2.1749877E-03,   2.2514430E-03,   2.3140933E-03
     +,   2.3594557E-03,   2.3855451E-03,   2.3922066E-03
     +,   2.3811301E-03,   2.3555614E-03,   2.3197057E-03
     +,   2.2779908E-03,   2.2343018E-03,   2.1913818E-03
     +,   2.1504606E-03,   2.1112228E-03,   2.0720402E-03
     +,   2.0304257E-03,   1.9835588E-03,   1.9288231E-03
     +,   1.8641998E-03,   1.7885235E-03,   1.7015713E-03
     +,   1.6040090E-03,   1.4972710E-03,   1.3833517E-03
     +,   1.2646285E-03,   1.1436540E-03,   1.0229871E-03
     +,   9.0504822E-04,   7.9196319E-04,   6.8552396E-04
     +,   5.8709242E-04,   4.9758627E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wano_hz_120 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wano_hz_60(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  1.4046709E-04,   1.4899240E-04
     +,   1.5826036E-04,   1.6842494E-04,   1.7966860E-04
     +,   1.9220059E-04,   2.0625418E-04,   2.2208481E-04
     +,   2.3996622E-04,   2.6018632E-04,   2.8304922E-04
     +,   3.0887642E-04,   3.3801465E-04,   3.7084511E-04
     +,   4.0780319E-04,   4.4939492E-04,   4.9621233E-04
     +,   5.4895284E-04,   6.0842343E-04,   6.7552901E-04
     +,   7.5125677E-04,   8.3662843E-04,   9.3262817E-04
     +,   1.0401213E-03,   1.1597350E-03,   1.2917173E-03
     +,   1.4358006E-03,   1.5910488E-03,   1.7557171E-03
     +,   1.9271893E-03,   2.1019722E-03,   2.2758185E-03
     +,   2.4440270E-03,   2.6018904E-03,   2.7452768E-03
     +,   2.8713099E-03,   2.9789710E-03,   3.0694925E-03
     +,   3.1464549E-03,   3.2154284E-03,   3.2832420E-03
     +,   3.3569369E-03,   3.4426257E-03,   3.5444489E-03
     +,   3.6638300E-03,   3.7991281E-03,   3.9457814E-03
     +,   4.0968535E-03,   4.2439452E-03,   4.3782550E-03
     +,   4.4917311E-03,   4.5779548E-03,   4.6328534E-03
     +,   4.6550087E-03,   4.6456796E-03,   4.6085957E-03
     +,   4.5495932E-03,   4.4760737E-03,   4.3961871E-03
     +,   4.3177926E-03,   4.2472286E-03,   4.1881232E-03
     +,   4.1406527E-03,   4.1014254E-03,   4.0642163E-03
     +,   4.0213228E-03,   3.9652348E-03,   3.8901921E-03
     +,   3.7931898E-03,   3.6743041E-03,   3.5363073E-03
     +,   3.3838139E-03,   3.2221992E-03,   3.0566049E-03
     +,   2.8911948E-03,   2.7287959E-03,   2.5708540E-03
     +,   2.4177216E-03,   2.2690331E-03,   2.1241365E-03
     +,   1.9824982E-03,   1.8439464E-03,   1.7087691E-03
     +,   1.5777379E-03,   1.4519687E-03,   1.3327355E-03
     +,   1.2213055E-03,   1.1187205E-03,   1.0256951E-03
     +,   9.4251893E-04,   8.6905161E-04,   8.0475578E-04
     +,   7.4879825E-04,   7.0014707E-04,   6.5768411E-04
     +,   6.2031479E-04,   5.8704411E-04,   5.5702525E-04
     +,   5.2959181E-04,   5.0424965E-04,   4.8066795E-04
     +,   4.5864441E-04,   4.3807467E-04,   4.1891541E-04
     +,   4.0116097E-04,   3.8481338E-04,   3.6987095E-04
     +,   3.5631511E-04,   3.4410643E-04,   3.3318251E-04
     +,   3.2346378E-04,   3.1485493E-04,   3.0725292E-04
     +,   3.0055092E-04,   2.9464418E-04,   2.8943343E-04
     +,   2.8482912E-04,   2.8075257E-04,   2.7713756E-04
     +,   2.7393043E-04,   2.7108897E-04,   2.6858188E-04
     +,   2.6638675E-04,   2.6448880E-04,   2.6287863E-04
     +,   2.6155083E-04,   2.6050184E-04,   2.5972901E-04
     +,   2.5922895E-04,   2.5899659E-04,   2.5902444E-04
     +,   2.5930197E-04,   2.5981493E-04,   2.6054570E-04
     +,   2.6147277E-04,   2.6257106E-04,   2.6381211E-04
     +,   2.6516421E-04,   2.6659330E-04,   2.6806296E-04
     +,   2.6953523E-04,   2.7097104E-04,   2.7233080E-04
     +,   2.7357522E-04,   2.7466545E-04,   2.7556400E-04
     +,   2.7623557E-04,   2.7664681E-04,   2.7676736E-04
     +,   2.7657027E-04,   2.7603222E-04,   2.7513385E-04
     +,   2.7386021E-04,   2.7220059E-04,   2.7014883E-04
     +,   2.6770384E-04,   2.6486849E-04,   2.6165054E-04
     +,   2.5806166E-04,   2.5411800E-04,   2.4983930E-04
     +,   2.4524884E-04,   2.4037252E-04,   2.3523881E-04
     +,   2.2987877E-04,   2.2432458E-04,   2.1860984E-04
     +,   2.1276892E-04,   2.0683567E-04,   2.0084383E-04
     +,   1.9482677E-04,   1.8881638E-04,   1.8284349E-04
     +,   1.7693629E-04,   1.7112117E-04,   1.6542251E-04
     +,   1.5986204E-04,   1.5445890E-04,   1.4922969E-04
     +,   1.4418790E-04,   1.3934505E-04,   1.3470939E-04
     +,   1.3028734E-04,   1.2608264E-04,   1.2209696E-04
     +,   1.1833012E-04,   1.1477980E-04,   1.1144212E-04
     +,   1.0831199E-04,   1.0538301E-04,   1.0264790E-04
     +,   1.0009815E-04,   9.7724762E-05,   9.5518408E-05
     +,   9.3469243E-05,   9.1567206E-05,   8.9802263E-05
     +,   8.8164161E-05,   8.6642809E-05,   8.5228370E-05
     +,   8.3911204E-05,   8.2681923E-05,   8.1531551E-05
     +,   8.0451289E-05,   7.9432801E-05,   7.8468125E-05
     +,   7.7549783E-05,   7.6670607E-05,   7.5823817E-05
     +,   7.5003009E-05,   7.4202238E-05,   7.3415933E-05
     +,   7.2638875E-05,   7.1866227E-05,   7.1093491E-05
     +,   7.0316572E-05,   6.9531648E-05,   6.8735302E-05
     +,   6.7924440E-05,   6.7096305E-05,   6.6248467E-05
     +,   6.5378801E-05,   6.4485444E-05,   6.3566935E-05
     +,   6.2622094E-05,   6.1650062E-05,   6.0650164E-05
     +,   5.9622158E-05,   5.8565944E-05,   5.7481775E-05
     +,   5.6370151E-05,   5.5231831E-05,   5.4067757E-05
     +,   5.2879084E-05,   5.1667219E-05,   5.0433788E-05
     +,   4.9180537E-05,   4.7909431E-05,   4.6622492E-05
     +,   4.5321864E-05,   4.4009881E-05,   4.2688924E-05
     +,   4.1361491E-05,   4.0029969E-05,   3.8696933E-05
     +,   3.7364978E-05,   3.6036516E-05,   3.4714118E-05
     +,   3.3400294E-05,   3.2097356E-05,   3.0807751E-05
     +,   2.9533623E-05,   2.8277202E-05,   2.7040536E-05
     +,   2.5825566E-05,   2.4634159E-05,   2.3467946E-05
     +,   2.2328431E-05,   2.1217058E-05,   2.0135083E-05
     +,   1.9083618E-05,   1.8063658E-05,   1.7075974E-05
     +,   1.6121188E-05,   1.5199859E-05,   1.4312363E-05
     +,   1.3458967E-05,   1.2639746E-05,   1.1854649E-05
     +,   1.1103565E-05,   1.0386240E-05,   9.7023167E-06
     +,   9.0513568E-06,   8.4327830E-06,   7.8459407E-06
     +,   7.2901476E-06,   6.7646288E-06,   6.2685522E-06
     +,   5.8010510E-06,   5.3611625E-06,   4.9479604E-06
     +,   4.5604224E-06,   4.1975550E-06,   3.8583325E-06
     +,   3.5417443E-06,   3.2467060E-06,   2.9722082E-06
     +,   2.7172257E-06,   2.4807443E-06,   2.2617751E-06
     +,   2.0593225E-06,   1.8724487E-06,   1.7002093E-06
     +,   1.5417122E-06,   1.3960864E-06,   1.2624938E-06
     +,   1.1401377E-06,   1.0282281E-06,   9.2603824E-07
     +,   8.3286710E-07,   7.4804797E-07
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wano_hz_60 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wano_hz_65(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  2.1899710E-05,   2.3308630E-05
     +,   2.4886314E-05,   2.6656540E-05,   2.8645802E-05
     +,   3.0883341E-05,   3.3400946E-05,   3.6233178E-05
     +,   3.9417151E-05,   4.2992102E-05,   4.6999565E-05
     +,   5.1482853E-05,   5.6487010E-05,   6.2058098E-05
     +,   6.8243840E-05,   7.5093136E-05,   8.2656035E-05
     +,   9.0984831E-05,   1.0013449E-04,   1.1016294E-04
     +,   1.2113352E-04,   1.3311580E-04,   1.4618663E-04
     +,   1.6043296E-04,   1.7595303E-04,   1.9285629E-04
     +,   2.1126634E-04,   2.3132026E-04,   2.5316668E-04
     +,   2.7696721E-04,   3.0289317E-04,   3.3112103E-04
     +,   3.6183099E-04,   3.9520231E-04,   4.3140358E-04
     +,   4.7059084E-04,   5.1289645E-04,   5.5841712E-04
     +,   6.0720847E-04,   6.5927044E-04,   7.1454607E-04
     +,   7.7291264E-04,   8.3420245E-04,   8.9822162E-04
     +,   9.6479972E-04,   1.0338495E-03,   1.1054666E-03
     +,   1.1800177E-03,   1.2582679E-03,   1.3414782E-03
     +,   1.4314913E-03,   1.5307714E-03,   1.6423847E-03
     +,   1.7698754E-03,   1.9170060E-03,   2.0873824E-03
     +,   2.2838977E-03,   2.5080491E-03,   2.7592655E-03
     +,   3.0343016E-03,   3.3269201E-03,   3.6281182E-03
     +,   3.9268914E-03,   4.2116018E-03,   4.4717952E-03
     +,   4.6999948E-03,   4.8930696E-03,   5.0527859E-03
     +,   5.1852129E-03,   5.2990876E-03,   5.4035615E-03
     +,   5.5058794E-03,   5.6096590E-03,   5.7142382E-03
     +,   5.8152415E-03,   5.9060222E-03,   5.9794979E-03
     +,   6.0297577E-03,   6.0529704E-03,   6.0475105E-03
     +,   6.0133631E-03,   5.9513012E-03,   5.8621727E-03
     +,   5.7465779E-03,   5.6050075E-03,   5.4382929E-03
     +,   5.2481596E-03,   5.0374987E-03,   4.8104753E-03
     +,   4.5721564E-03,   4.3279710E-03,   4.0830397E-03
     +,   3.8416814E-03,   3.6070640E-03,   3.3811252E-03
     +,   3.1648327E-03,   2.9585292E-03,   2.7623179E-03
     +,   2.5764960E-03,   2.4016758E-03,   2.2388736E-03
     +,   2.0893193E-03,   1.9542135E-03,   1.8343944E-03
     +,   1.7301359E-03,   1.6409664E-03,   1.5656848E-03
     +,   1.5024558E-03,   1.4490267E-03,   1.4029637E-03
     +,   1.3619148E-03,   1.3238022E-03,   1.2869694E-03
     +,   1.2502444E-03,   1.2129430E-03,   1.1748067E-03
     +,   1.1359309E-03,   1.0966478E-03,   1.0574379E-03
     +,   1.0188374E-03,   9.8136533E-04,   9.4548514E-04
     +,   9.1157068E-04,   8.7990338E-04,   8.5067214E-04
     +,   8.2398677E-04,   7.9988939E-04,   7.7837583E-04
     +,   7.5940543E-04,   7.4290886E-04,   7.2879961E-04
     +,   7.1697321E-04,   7.0730818E-04,   6.9966761E-04
     +,   6.9389387E-04,   6.8981102E-04,   6.8722287E-04
     +,   6.8591489E-04,   6.8565633E-04,   6.8620354E-04
     +,   6.8730646E-04,   6.8871345E-04,   6.9017662E-04
     +,   6.9145981E-04,   6.9234421E-04,   6.9263123E-04
     +,   6.9215056E-04,   6.9076166E-04,   6.8835710E-04
     +,   6.8486377E-04,   6.8024232E-04,   6.7448965E-04
     +,   6.6763163E-04,   6.5972633E-04,   6.5085723E-04
     +,   6.4112939E-04,   6.3066650E-04,   6.1960513E-04
     +,   6.0809002E-04,   5.9626985E-04,   5.8429257E-04
     +,   5.7230209E-04,   5.6043203E-04,   5.4880412E-04
     +,   5.3752813E-04,   5.2669615E-04,   5.1638327E-04
     +,   5.0664751E-04,   4.9752777E-04,   4.8904622E-04
     +,   4.8120931E-04,   4.7400862E-04,   4.6742239E-04
     +,   4.6141807E-04,   4.5595263E-04,   4.5097733E-04
     +,   4.4643728E-04,   4.4227458E-04,   4.3842904E-04
     +,   4.3484062E-04,   4.3144985E-04,   4.2819956E-04
     +,   4.2503531E-04,   4.2190673E-04,   4.1876681E-04
     +,   4.1557339E-04,   4.1228838E-04,   4.0887861E-04
     +,   4.0531525E-04,   4.0157436E-04,   3.9763591E-04
     +,   3.9348437E-04,   3.8910785E-04,   3.8449865E-04
     +,   3.7965269E-04,   3.7456909E-04,   3.6925069E-04
     +,   3.6370277E-04,   3.5793363E-04,   3.5195446E-04
     +,   3.4577868E-04,   3.3942191E-04,   3.3290172E-04
     +,   3.2623703E-04,   3.1944813E-04,   3.1255669E-04
     +,   3.0558498E-04,   2.9855597E-04,   2.9149215E-04
     +,   2.8441596E-04,   2.7734996E-04,   2.7031562E-04
     +,   2.6333352E-04,   2.5642326E-04,   2.4960248E-04
     +,   2.4288811E-04,   2.3629436E-04,   2.2983462E-04
     +,   2.2352005E-04,   2.1735996E-04,   2.1136198E-04
     +,   2.0553167E-04,   1.9987253E-04,   1.9438702E-04
     +,   1.8907568E-04,   1.8393769E-04,   1.7897057E-04
     +,   1.7417106E-04,   1.6953444E-04,   1.6505532E-04
     +,   1.6072759E-04,   1.5654473E-04,   1.5249928E-04
     +,   1.4858358E-04,   1.4479019E-04,   1.4111123E-04
     +,   1.3753910E-04,   1.3406636E-04,   1.3068564E-04
     +,   1.2738985E-04,   1.2417250E-04,   1.2102744E-04
     +,   1.1794915E-04,   1.1493218E-04,   1.1197200E-04
     +,   1.0906457E-04,   1.0620603E-04,   1.0339337E-04
     +,   1.0062413E-04,   9.7895856E-05,   9.5207157E-05
     +,   9.2556525E-05,   8.9943154E-05,   8.7366519E-05
     +,   8.4826373E-05,   8.2322847E-05,   7.9856138E-05
     +,   7.7426615E-05,   7.5035045E-05,   7.2682160E-05
     +,   7.0368893E-05,   6.8096189E-05,   6.5864973E-05
     +,   6.3676147E-05,   6.1530744E-05,   5.9429716E-05
     +,   5.7374025E-05,   5.5364402E-05,   5.3401516E-05
     +,   5.1486091E-05,   4.9618691E-05,   4.7799731E-05
     +,   4.6029632E-05,   4.4308523E-05,   4.2636468E-05
     +,   4.1013514E-05,   3.9439532E-05,   3.7914313E-05
     +,   3.6437577E-05,   3.5008787E-05,   3.3627530E-05
     +,   3.2293072E-05,   3.1004809E-05,   2.9761957E-05
     +,   2.8563785E-05,   2.7409222E-05,   2.6297419E-05
     +,   2.5227388E-05,   2.4198118E-05,   2.3208575E-05
     +,   2.2257607E-05,   2.1344193E-05,   2.0467134E-05
     +,   1.9625357E-05,   1.8817733E-05,   1.8043129E-05
     +,   1.7300483E-05,   1.6588570E-05,   1.5906349E-05
     +,   1.5252730E-05,   1.4626649E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wano_hz_65 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wano_hz_70(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  2.4015962E-05,   2.5418332E-05
     +,   2.6961619E-05,   2.8657892E-05,   3.0519979E-05
     +,   3.2561420E-05,   3.4796343E-05,   3.7239741E-05
     +,   3.9907372E-05,   4.2815591E-05,   4.5981709E-05
     +,   4.9423747E-05,   5.3160635E-05,   5.7211866E-05
     +,   6.1597966E-05,   6.6340239E-05,   7.1460498E-05
     +,   7.6981480E-05,   8.2926606E-05,   8.9319379E-05
     +,   9.6184085E-05,   1.0354506E-04,   1.1142624E-04
     +,   1.1985154E-04,   1.2884413E-04,   1.3842568E-04
     +,   1.4861680E-04,   1.5943620E-04,   1.7089972E-04
     +,   1.8302102E-04,   1.9581094E-04,   2.0927627E-04
     +,   2.2342148E-04,   2.3824775E-04,   2.5375281E-04
     +,   2.6993267E-04,   2.8678193E-04,   3.0429324E-04
     +,   3.2245993E-04,   3.4127594E-04,   3.6073657E-04
     +,   3.8083759E-04,   4.0157716E-04,   4.2295331E-04
     +,   4.4496340E-04,   4.6760050E-04,   4.9085333E-04
     +,   5.1469967E-04,   5.3910696E-04,   5.6402793E-04
     +,   5.8940030E-04,   6.1514531E-04,   6.4117659E-04
     +,   6.6740252E-04,   6.9374050E-04,   7.2013383E-04
     +,   7.4657268E-04,   7.7311881E-04,   7.9993688E-04
     +,   8.2732370E-04,   8.5573521E-04,   8.8581251E-04
     +,   9.1839384E-04,   9.5450849E-04,   9.9536218E-04
     +,   1.0422880E-03,   1.0966776E-03,   1.1598987E-03
     +,   1.2331902E-03,   1.3175601E-03,   1.4137019E-03
     +,   1.5219245E-03,   1.6421283E-03,   1.7738104E-03
     +,   1.9161130E-03,   2.0678765E-03,   2.2277460E-03
     +,   2.3942124E-03,   2.5657129E-03,   2.7407664E-03
     +,   2.9180769E-03,   3.0967474E-03,   3.2765470E-03
     +,   3.4580727E-03,   3.6428834E-03,   3.8333857E-03
     +,   4.0323315E-03,   4.2421008E-03,   4.4636447E-03
     +,   4.6955566E-03,   4.9335193E-03,   5.1705181E-03
     +,   5.3978902E-03,   5.6072581E-03,   5.7927240E-03
     +,   5.9526484E-03,   6.0903272E-03,   6.2131546E-03
     +,   6.3301730E-03,   6.4489576E-03,   6.5725828E-03
     +,   6.6978922E-03,   6.8157143E-03,   6.9129993E-03
     +,   6.9761807E-03,   6.9947643E-03,   6.9639278E-03
     +,   6.8855407E-03,   6.7673316E-03,   6.6207638E-03
     +,   6.4583668E-03,   6.2912372E-03,   6.1273375E-03
     +,   5.9706862E-03,   5.8213822E-03,   5.6762421E-03
     +,   5.5298740E-03,   5.3759976E-03,   5.2089789E-03
     +,   5.0252904E-03,   4.8246696E-03,   4.6107033E-03
     +,   4.3905084E-03,   4.1736346E-03,   3.9702957E-03
     +,   3.7894482E-03,   3.6371390E-03,   3.5156200E-03
     +,   3.4232608E-03,   3.3552723E-03,   3.3049693E-03
     +,   3.2651229E-03,   3.2291315E-03,   3.1917724E-03
     +,   3.1494708E-03,   3.1001745E-03,   3.0430034E-03
     +,   2.9778138E-03,   2.9048356E-03,   2.8244839E-03
     +,   2.7372495E-03,   2.6437610E-03,   2.5448517E-03
     +,   2.4416067E-03,   2.3353968E-03,   2.2278142E-03
     +,   2.1205670E-03,   2.0153588E-03,   1.9137247E-03
     +,   1.8169205E-03,   1.7258466E-03,   1.6410091E-03
     +,   1.5625202E-03,   1.4901744E-03,   1.4235158E-03
     +,   1.3619370E-03,   1.3047680E-03,   1.2513722E-03
     +,   1.2011968E-03,   1.1538245E-03,   1.1089878E-03
     +,   1.0665635E-03,   1.0265509E-03,   9.8904571E-04
     +,   9.5420668E-04,   9.2221389E-04,   8.9323876E-04
     +,   8.6742023E-04,   8.4484002E-04,   8.2551403E-04
     +,   8.0939039E-04,   7.9634524E-04,   7.8619074E-04
     +,   7.7868154E-04,   7.7352603E-04,   7.7039830E-04
     +,   7.6894643E-04,   7.6880475E-04,   7.6960382E-04
     +,   7.7097822E-04,   7.7257561E-04,   7.7406334E-04
     +,   7.7513390E-04,   7.7551126E-04,   7.7495369E-04
     +,   7.7325967E-04,   7.7026716E-04,   7.6585641E-04
     +,   7.5995037E-04,   7.5251400E-04,   7.4355211E-04
     +,   7.3310488E-04,   7.2124723E-04,   7.0808211E-04
     +,   6.9373584E-04,   6.7835429E-04,   6.6209555E-04
     +,   6.4512447E-04,   6.2760728E-04,   6.0970883E-04
     +,   5.9158658E-04,   5.7338708E-04,   5.5524416E-04
     +,   5.3727377E-04,   5.1957596E-04,   5.0223403E-04
     +,   4.8531278E-04,   4.6886099E-04,   4.5290997E-04
     +,   4.3747740E-04,   4.2256882E-04,   4.0817945E-04
     +,   3.9429509E-04,   3.8089609E-04,   3.6795659E-04
     +,   3.5544953E-04,   3.4334499E-04,   3.3161463E-04
     +,   3.2023079E-04,   3.0916763E-04,   2.9840288E-04
     +,   2.8791645E-04,   2.7769158E-04,   2.6771595E-04
     +,   2.5798008E-04,   2.4847794E-04,   2.3920527E-04
     +,   2.3016166E-04,   2.2134731E-04,   2.1276496E-04
     +,   2.0441822E-04,   1.9631184E-04,   1.8844988E-04
     +,   1.8083690E-04,   1.7347751E-04,   1.6637529E-04
     +,   1.5953333E-04,   1.5295383E-04,   1.4663750E-04
     +,   1.4058387E-04,   1.3479184E-04,   1.2925896E-04
     +,   1.2398178E-04,   1.1895522E-04,   1.1417380E-04
     +,   1.0963110E-04,   1.0531953E-04,   1.0123115E-04
     +,   9.7357617E-05,   9.3689574E-05,   9.0217938E-05
     +,   8.6932923E-05,   8.3824969E-05,   8.0884325E-05
     +,   7.8101373E-05,   7.5466698E-05,   7.2970863E-05
     +,   7.0604750E-05,   6.8359666E-05,   6.6227229E-05
     +,   6.4199419E-05,   6.2268671E-05,   6.0427690E-05
     +,   5.8669641E-05,   5.6988200E-05,   5.5377419E-05
     +,   5.3831871E-05,   5.2346360E-05,   5.0916111E-05
     +,   4.9536844E-05,   4.8204598E-05,   4.6915753E-05
     +,   4.5667064E-05,   4.4455504E-05,   4.3278338E-05
     +,   4.2133193E-05,   4.1017927E-05,   3.9930601E-05
     +,   3.8869555E-05,   3.7833190E-05,   3.6820275E-05
     +,   3.5829569E-05,   3.4860106E-05,   3.3911016E-05
     +,   3.2981639E-05,   3.2071177E-05,   3.1179185E-05
     +,   3.0305200E-05,   2.9448862E-05,   2.8609897E-05
     +,   2.7787979E-05,   2.6982982E-05,   2.6194683E-05
     +,   2.5422978E-05,   2.4667779E-05,   2.3929000E-05
     +,   2.3206634E-05,   2.2500515E-05,   2.1810651E-05
     +,   2.1136995E-05,   2.0479500E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wano_hz_70 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wano_hz_75(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  1.5727117E-05,   1.6334574E-05
     +,   1.6959053E-05,   1.7600745E-05,   1.8259880E-05
     +,   1.8936722E-05,   1.9631512E-05,   2.0344582E-05
     +,   2.1076281E-05,   2.1827003E-05,   2.2597216E-05
     +,   2.3387489E-05,   2.4198462E-05,   2.5030869E-05
     +,   2.5885618E-05,   2.6763775E-05,   2.7666552E-05
     +,   2.8595452E-05,   2.9552215E-05,   3.0538857E-05
     +,   3.1557815E-05,   3.2611963E-05,   3.3704575E-05
     +,   3.4839588E-05,   3.6021571E-05,   3.7255781E-05
     +,   3.8548373E-05,   3.9906434E-05,   4.1338088E-05
     +,   4.2852669E-05,   4.4460819E-05,   4.6174540E-05
     +,   4.8007460E-05,   4.9974915E-05,   5.2093899E-05
     +,   5.4383458E-05,   5.6864657E-05,   5.9560574E-05
     +,   6.2496547E-05,   6.5700224E-05,   6.9201618E-05
     +,   7.3032905E-05,   7.7228877E-05,   8.1826656E-05
     +,   8.6865883E-05,   9.2388451E-05,   9.8439021E-05
     +,   1.0506441E-04,   1.1231413E-04,   1.2024034E-04
     +,   1.2889790E-04,   1.3834375E-04,   1.4863809E-04
     +,   1.5984361E-04,   1.7202477E-04,   1.8524882E-04
     +,   1.9958449E-04,   2.1510053E-04,   2.3186623E-04
     +,   2.4994891E-04,   2.6941119E-04,   2.9031062E-04
     +,   3.1269618E-04,   3.3660335E-04,   3.6205395E-04
     +,   3.8905116E-04,   4.1757448E-04,   4.4757995E-04
     +,   4.7899652E-04,   5.1172177E-04,   5.4562656E-04
     +,   5.8055308E-04,   6.1632012E-04,   6.5272674E-04
     +,   6.8956451E-04,   7.2662561E-04,   7.6372409E-04
     +,   8.0070680E-04,   8.3747669E-04,   8.7402307E-04
     +,   9.1043074E-04,   9.4690965E-04,   9.8381029E-04
     +,   1.0216250E-03,   1.0609874E-03,   1.1026601E-03
     +,   1.1474943E-03,   1.1964015E-03,   1.2502924E-03
     +,   1.3100327E-03,   1.3764002E-03,   1.4500663E-03
     +,   1.5315722E-03,   1.6213463E-03,   1.7197325E-03
     +,   1.8269782E-03,   1.9432298E-03,   2.0684751E-03
     +,   2.2023949E-03,   2.3442174E-03,   2.4924893E-03
     +,   2.6449210E-03,   2.7983109E-03,   2.9486974E-03
     +,   3.0917537E-03,   3.2236017E-03,   3.3418899E-03
     +,   3.4471198E-03,   3.5438384E-03,   3.6413355E-03
     +,   3.7533254E-03,   3.8963694E-03,   4.0870355E-03
     +,   4.3383618E-03,   4.6563852E-03,   5.0379150E-03
     +,   5.4699397E-03,   5.9311977E-03,   6.3951542E-03
     +,   6.8342760E-03,   7.2249840E-03,   7.5526531E-03
     +,   7.8161173E-03,   8.0294115E-03,   8.2191927E-03
     +,   8.4168157E-03,   8.6471094E-03,   8.9182071E-03
     +,   9.2174569E-03,   9.5157111E-03,   9.7773867E-03
     +,   9.9711064E-03,   1.0075544E-02,   1.0079342E-02
     +,   9.9781184E-03,   9.7727161E-03,   9.4706565E-03
     +,   9.0890694E-03,   8.6556133E-03,   8.2053225E-03
     +,   7.7739526E-03,   7.3909136E-03,   7.0743952E-03
     +,   6.8297321E-03,   6.6505703E-03,   6.5213940E-03
     +,   6.4208019E-03,   6.3253990E-03,   6.2139453E-03
     +,   6.0711745E-03,   5.8903527E-03,   5.6737158E-03
     +,   5.4308190E-03,   5.1755840E-03,   4.9228328E-03
     +,   4.6854503E-03,   4.4724112E-03,   4.2881090E-03
     +,   4.1324217E-03,   4.0016132E-03,   3.8895693E-03
     +,   3.7892081E-03,   3.6937899E-03,   3.5979140E-03
     +,   3.4981135E-03,   3.3929173E-03,   3.2825472E-03
     +,   3.1683422E-03,   3.0521057E-03,   2.9355511E-03
     +,   2.8199540E-03,   2.7060113E-03,   2.5939173E-03
     +,   2.4835488E-03,   2.3747236E-03,   2.2674119E-03
     +,   2.1618607E-03,   2.0586441E-03,   1.9586212E-03
     +,   1.8628152E-03,   1.7723162E-03,   1.6881230E-03
     +,   1.6110576E-03,   1.5416794E-03,   1.4802449E-03
     +,   1.4267102E-03,   1.3807433E-03,   1.3417759E-03
     +,   1.3090593E-03,   1.2817251E-03,   1.2588414E-03
     +,   1.2394721E-03,   1.2227177E-03,   1.2077559E-03
     +,   1.1938580E-03,   1.1804037E-03,   1.1668862E-03
     +,   1.1529076E-03,   1.1381690E-03,   1.1224636E-03
     +,   1.1056620E-03,   1.0876996E-03,   1.0685617E-03
     +,   1.0482748E-03,   1.0268932E-03,   1.0044938E-03
     +,   9.8116382E-04,   9.5699873E-04,   9.3209511E-04
     +,   9.0654643E-04,   8.8044803E-04,   8.5388956E-04
     +,   8.2695775E-04,   7.9973909E-04,   7.7231525E-04
     +,   7.4477098E-04,   7.1718806E-04,   6.8965065E-04
     +,   6.6224358E-04,   6.3505047E-04,   6.0815457E-04
     +,   5.8163475E-04,   5.5556482E-04,   5.3001550E-04
     +,   5.0504948E-04,   4.8072124E-04,   4.5707452E-04
     +,   4.3414670E-04,   4.1196228E-04,   3.9053935E-04
     +,   3.6988710E-04,   3.5000831E-04,   3.3089751E-04
     +,   3.1254534E-04,   2.9493964E-04,   2.7806562E-04
     +,   2.6190700E-04,   2.4644742E-04,   2.3166978E-04
     +,   2.1755756E-04,   2.0409650E-04,   1.9127245E-04
     +,   1.7907306E-04,   1.6748506E-04,   1.5649729E-04
     +,   1.4609849E-04,   1.3627626E-04,   1.2701892E-04
     +,   1.1831405E-04,   1.1014717E-04,   1.0250421E-04
     +,   9.5368501E-05,   8.8723267E-05,   8.2550170E-05
     +,   7.6829776E-05,   7.1542010E-05,   6.6665540E-05
     +,   6.2178529E-05,   5.8059173E-05,   5.4285309E-05
     +,   5.0834820E-05,   4.7685935E-05,   4.4817072E-05
     +,   4.2207274E-05,   3.9836465E-05,   3.7685320E-05
     +,   3.5735469E-05,   3.3969354E-05,   3.2370452E-05
     +,   3.0923387E-05,   2.9613790E-05,   2.8428274E-05
     +,   2.7354512E-05,   2.6381071E-05,   2.5497429E-05
     +,   2.4694084E-05,   2.3962277E-05,   2.3294064E-05
     +,   2.2682258E-05,   2.2120275E-05,   2.1602258E-05
     +,   2.1122871E-05,   2.0677340E-05,   2.0261386E-05
     +,   1.9871219E-05,   1.9503339E-05,   1.9154733E-05
     +,   1.8822697E-05,   1.8504828E-05,   1.8199020E-05
     +,   1.7903385E-05,   1.7616310E-05,   1.7336342E-05
     +,   1.7062255E-05,   1.6792979E-05,   1.6527587E-05
     +,   1.6265321E-05,   1.6005475E-05,   1.5747522E-05
     +,   1.5491003E-05,   1.5235554E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wano_hz_75 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wano_hz_80(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  1.6321179E-05,   1.6727583E-05
     +,   1.7143409E-05,   1.7568998E-05,   1.8004721E-05
     +,   1.8450964E-05,   1.8908109E-05,   1.9376579E-05
     +,   1.9856801E-05,   2.0349200E-05,   2.0854250E-05
     +,   2.1372407E-05,   2.1904179E-05,   2.2450045E-05
     +,   2.3010531E-05,   2.3586172E-05,   2.4177503E-05
     +,   2.4785089E-05,   2.5409519E-05,   2.6051353E-05
     +,   2.6711214E-05,   2.7389726E-05,   2.8087499E-05
     +,   2.8805189E-05,   2.9543464E-05,   3.0302970E-05
     +,   3.1084415E-05,   3.1888510E-05,   3.2715954E-05
     +,   3.3567496E-05,   3.4443918E-05,   3.5345976E-05
     +,   3.6274505E-05,   3.7230377E-05,   3.8214450E-05
     +,   3.9227700E-05,   4.0271170E-05,   4.1345913E-05
     +,   4.2453164E-05,   4.3594224E-05,   4.4770619E-05
     +,   4.5983932E-05,   4.7236063E-05,   4.8529157E-05
     +,   4.9865677E-05,   5.1248382E-05,   5.2680574E-05
     +,   5.4165968E-05,   5.5708901E-05,   5.7314410E-05
     +,   5.8988324E-05,   6.0737235E-05,   6.2568812E-05
     +,   6.4491862E-05,   6.6516288E-05,   6.8653404E-05
     +,   7.0916038E-05,   7.3318392E-05,   7.5876553E-05
     +,   7.8608318E-05,   8.1533275E-05,   8.4673047E-05
     +,   8.8051369E-05,   9.1693793E-05,   9.5628209E-05
     +,   9.9884703E-05,   1.0449516E-04,   1.0949400E-04
     +,   1.1491788E-04,   1.2080513E-04,   1.2719668E-04
     +,   1.3413555E-04,   1.4166694E-04,   1.4983770E-04
     +,   1.5869724E-04,   1.6829619E-04,   1.7868802E-04
     +,   1.8992656E-04,   2.0206644E-04,   2.1516440E-04
     +,   2.2927547E-04,   2.4445297E-04,   2.6074986E-04
     +,   2.7821332E-04,   2.9688439E-04,   3.1679875E-04
     +,   3.3797874E-04,   3.6043738E-04,   3.8416978E-04
     +,   4.0915399E-04,   4.3534674E-04,   4.6268525E-04
     +,   4.9107935E-04,   5.2041438E-04,   5.5055367E-04
     +,   5.8133592E-04,   6.1258022E-04,   6.4409751E-04
     +,   6.7569053E-04,   7.0717547E-04,   7.3838927E-04
     +,   7.6921383E-04,   7.9959276E-04,   8.2956319E-04
     +,   8.5926894E-04,   8.8899536E-04,   9.1917772E-04
     +,   9.5041940E-04,   9.8349026E-04,   1.0193165E-03
     +,   1.0589473E-03,   1.1035133E-03,   1.1541629E-03
     +,   1.2119930E-03,   1.2779756E-03,   1.3529075E-03
     +,   1.4373494E-03,   1.5316504E-03,   1.6359586E-03
     +,   1.7503190E-03,   1.8748065E-03,   2.0096274E-03
     +,   2.1552630E-03,   2.3124665E-03,   2.4821875E-03
     +,   2.6653339E-03,   2.8624395E-03,   3.0732155E-03
     +,   3.2962689E-03,   3.5290502E-03,   3.7681391E-03
     +,   4.0100683E-03,   4.2526359E-03,   4.4964426E-03
     +,   4.7465754E-03,   5.0135395E-03,   5.3129103E-03
     +,   5.6629307E-03,   6.0801757E-03,   6.5742335E-03
     +,   7.1439459E-03,   7.7769579E-03,   8.4536020E-03
     +,   9.1532273E-03,   9.8590916E-03,   1.0559100E-02
     +,   1.1242145E-02,   1.1893031E-02,   1.2490714E-02
     +,   1.3011657E-02,   1.3435672E-02,   1.3750612E-02
     +,   1.3952572E-02,   1.4043247E-02,   1.4028276E-02
     +,   1.3918312E-02,   1.3731785E-02,   1.3494753E-02
     +,   1.3235963E-02,   1.2978361E-02,   1.2731668E-02
     +,   1.2490612E-02,   1.2239362E-02,   1.1959738E-02
     +,   1.1639057E-02,   1.1274618E-02,   1.0874581E-02
     +,   1.0456170E-02,   1.0041616E-02,   9.6522402E-03
     +,   9.3017705E-03,   8.9912331E-03,   8.7084705E-03
     +,   8.4330039E-03,   8.1439093E-03,   7.8270994E-03
     +,   7.4787945E-03,   7.1048979E-03,   6.7177867E-03
     +,   6.3326573E-03,   5.9648762E-03,   5.6279572E-03
     +,   5.3323237E-03,   5.0839442E-03,   4.8836651E-03
     +,   4.7273729E-03,   4.6072039E-03,   4.5134625E-03
     +,   4.4365106E-03,   4.3680733E-03,   4.3017827E-03
     +,   4.2330343E-03,   4.1585299E-03,   4.0758653E-03
     +,   3.9833467E-03,   3.8800279E-03,   3.7659109E-03
     +,   3.6420750E-03,   3.5106805E-03,   3.3748168E-03
     +,   3.2381145E-03,   3.1043196E-03,   2.9768515E-03
     +,   2.8584469E-03,   2.7509180E-03,   2.6550919E-03
     +,   2.5708408E-03,   2.4972323E-03,   2.4327403E-03
     +,   2.3754754E-03,   2.3233953E-03,   2.2744823E-03
     +,   2.2268794E-03,   2.1789742E-03,   2.1294577E-03
     +,   2.0773464E-03,   2.0219660E-03,   1.9629521E-03
     +,   1.9002093E-03,   1.8338835E-03,   1.7643172E-03
     +,   1.6919968E-03,   1.6175216E-03,   1.5415598E-03
     +,   1.4648046E-03,   1.3879434E-03,   1.3116250E-03
     +,   1.2364589E-03,   1.1629751E-03,   1.0916444E-03
     +,   1.0228609E-03,   9.5694658E-04,   8.9415058E-04
     +,   8.3465705E-04,   7.7859167E-04,   7.2602317E-04
     +,   6.7696581E-04,   6.3138938E-04,   5.8921718E-04
     +,   5.5033632E-04,   5.1460700E-04,   4.8186295E-04
     +,   4.5192189E-04,   4.2458752E-04,   3.9966163E-04
     +,   3.7694664E-04,   3.5624791E-04,   3.3738231E-04
     +,   3.2017796E-04,   3.0447487E-04,   2.9012901E-04
     +,   2.7700877E-04,   2.6499719E-04,   2.5398945E-04
     +,   2.4389183E-04,   2.3462063E-04,   2.2609976E-04
     +,   2.1826025E-04,   2.1103973E-04,   2.0438027E-04
     +,   1.9822814E-04,   1.9253339E-04,   1.8724891E-04
     +,   1.8233048E-04,   1.7773702E-04,   1.7343010E-04
     +,   1.6937412E-04,   1.6553582E-04,   1.6188466E-04
     +,   1.5839317E-04,   1.5503641E-04,   1.5179213E-04
     +,   1.4864061E-04,   1.4556458E-04,   1.4254899E-04
     +,   1.3958127E-04,   1.3665087E-04,   1.3374904E-04
     +,   1.3086892E-04,   1.2800492E-04,   1.2515324E-04
     +,   1.2231091E-04,   1.1947638E-04,   1.1664889E-04
     +,   1.1382877E-04,   1.1101626E-04,   1.0821290E-04
     +,   1.0542043E-04,   1.0264094E-04,   9.9876808E-05
     +,   9.7130418E-05,   9.4404561E-05,   9.1701731E-05
     +,   8.9024703E-05,   8.6376087E-05,   8.3758438E-05
     +,   8.1174396E-05,   7.8625810E-05,   7.6115044E-05
     +,   7.3643991E-05,   7.1214468E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wano_hz_80 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wano_hz_85(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  3.0823824E-06,   3.1532509E-06
     +,   3.2257894E-06,   3.3001975E-06,   3.3767087E-06
     +,   3.4555940E-06,   3.5371593E-06,   3.6217584E-06
     +,   3.7097941E-06,   3.8017199E-06,   3.8980511E-06
     +,   3.9993670E-06,   4.1063176E-06,   4.2196243E-06
     +,   4.3400955E-06,   4.4686317E-06,   4.6062150E-06
     +,   4.7539420E-06,   4.9130135E-06,   5.0847348E-06
     +,   5.2705404E-06,   5.4719899E-06,   5.6907611E-06
     +,   5.9286758E-06,   6.1876958E-06,   6.4699057E-06
     +,   6.7775468E-06,   7.1130039E-06,   7.4787818E-06
     +,   7.8775420E-06,   8.3120831E-06,   8.7853014E-06
     +,   9.3002400E-06,   9.8600549E-06,   1.0467964E-05
     +,   1.1127303E-05,   1.1841479E-05,   1.2613911E-05
     +,   1.3448078E-05,   1.4347474E-05,   1.5315596E-05
     +,   1.6355847E-05,   1.7471632E-05,   1.8666267E-05
     +,   1.9942994E-05,   2.1304859E-05,   2.2754883E-05
     +,   2.4295823E-05,   2.5930371E-05,   2.7661019E-05
     +,   2.9490153E-05,   3.1419873E-05,   3.3452285E-05
     +,   3.5589368E-05,   3.7832942E-05,   4.0184907E-05
     +,   4.2647240E-05,   4.5221921E-05,   4.7911260E-05
     +,   5.0717954E-05,   5.3645021E-05,   5.6696274E-05
     +,   5.9876314E-05,   6.3190673E-05,   6.6646193E-05
     +,   7.0251292E-05,   7.4015923E-05,   7.7952231E-05
     +,   8.2074796E-05,   8.6400563E-05,   9.0949710E-05
     +,   9.5745570E-05,   1.0081522E-04,   1.0618921E-04
     +,   1.1190255E-04,   1.1799389E-04,   1.2450694E-04
     +,   1.3148895E-04,   1.3899109E-04,   1.4706908E-04
     +,   1.5578108E-04,   1.6518756E-04,   1.7535182E-04
     +,   1.8633652E-04,   1.9820334E-04,   2.1101326E-04
     +,   2.2482128E-04,   2.3967847E-04,   2.5562677E-04
     +,   2.7269896E-04,   2.9091525E-04,   3.1028467E-04
     +,   3.3079888E-04,   3.5243316E-04,   3.7514794E-04
     +,   3.9888351E-04,   4.2356184E-04,   4.4909251E-04
     +,   4.7536427E-04,   5.0225883E-04,   5.2964292E-04
     +,   5.5737939E-04,   5.8532716E-04,   6.1335060E-04
     +,   6.4131693E-04,   6.6910929E-04,   6.9662364E-04
     +,   7.2377705E-04,   7.5050868E-04,   7.7678775E-04
     +,   8.0260559E-04,   8.2798506E-04,   8.5297262E-04
     +,   8.7764085E-04,   9.0208265E-04,   9.2641317E-04
     +,   9.5075881E-04,   9.7526243E-04,   1.0000742E-03
     +,   1.0253540E-03,   1.0512741E-03,   1.0780164E-03
     +,   1.1057830E-03,   1.1347986E-03,   1.1653182E-03
     +,   1.1976332E-03,   1.2320812E-03,   1.2690412E-03
     +,   1.3089291E-03,   1.3521885E-03,   1.3992591E-03
     +,   1.4505421E-03,   1.5063630E-03,   1.5669084E-03
     +,   1.6322000E-03,   1.7020463E-03,   1.7760680E-03
     +,   1.8537423E-03,   1.9345451E-03,   2.0181288E-03
     +,   2.1046114E-03,   2.1948526E-03,   2.2907346E-03
     +,   2.3953337E-03,   2.5128738E-03,   2.6484649E-03
     +,   2.8076051E-03,   2.9954989E-03,   3.2164499E-03
     +,   3.4734567E-03,   3.7680273E-03,   4.1003097E-03
     +,   4.4692955E-03,   4.8727426E-03,   5.3069168E-03
     +,   5.7661696E-03,   6.2428424E-03,   6.7274994E-03
     +,   7.2100637E-03,   7.6809176E-03,   8.1322584E-03
     +,   8.5591646E-03,   8.9609586E-03,   9.3424218E-03
     +,   9.7143669E-03,   1.0092593E-02,   1.0495206E-02
     +,   1.0939918E-02,   1.1443336E-02,   1.2022261E-02
     +,   1.2694044E-02,   1.3473168E-02,   1.4364740E-02
     +,   1.5360978E-02,   1.6442921E-02,   1.7576683E-02
     +,   1.8692337E-02,   1.9659262E-02,   2.0304602E-02
     +,   2.0504037E-02,   2.0293519E-02,   1.9895025E-02
     +,   1.9601712E-02,   1.9593460E-02,   1.9827221E-02
     +,   2.0089112E-02,   2.0162629E-02,   1.9974882E-02
     +,   1.9609086E-02,   1.9193547E-02,   1.8781906E-02
     +,   1.8327367E-02,   1.7746832E-02,   1.6994532E-02
     +,   1.6085550E-02,   1.5076840E-02,   1.4040533E-02
     +,   1.3046154E-02,   1.2148465E-02,   1.1377919E-02
     +,   1.0737796E-02,   1.0211072E-02,   9.7721796E-03
     +,   9.3961926E-03,   9.0626180E-03,   8.7553309E-03
     +,   8.4619392E-03,   8.1735197E-03,   7.8842267E-03
     +,   7.5901286E-03,   7.2877733E-03,   6.9733853E-03
     +,   6.6434704E-03,   6.2964205E-03,   5.9339423E-03
     +,   5.5616037E-03,   5.1879361E-03,   4.8227692E-03
     +,   4.4753705E-03,   4.1529653E-03,   3.8599698E-03
     +,   3.5978211E-03,   3.3653618E-03,   3.1595191E-03
     +,   2.9760487E-03,   2.8103150E-03,   2.6578824E-03
     +,   2.5149488E-03,   2.3785059E-03,   2.2464001E-03
     +,   2.1172045E-03,   1.9901097E-03,   1.8647697E-03
     +,   1.7412044E-03,   1.6197218E-03,   1.5008356E-03
     +,   1.3852065E-03,   1.2735825E-03,   1.1667197E-03
     +,   1.0653308E-03,   9.7003713E-04,   8.8130875E-04
     +,   7.9945382E-04,   7.2459085E-04,   6.5667828E-04
     +,   5.9552066E-04,   5.4079090E-04,   4.9207528E-04
     +,   4.4889568E-04,   4.1073500E-04,   3.7707278E-04
     +,   3.4739287E-04,   3.2120771E-04,   2.9806374E-04
     +,   2.7754833E-04,   2.5929307E-04,   2.4297286E-04
     +,   2.2830526E-04,   2.1504909E-04,   2.0299887E-04
     +,   1.9198131E-04,   1.8185221E-04,   1.7249078E-04
     +,   1.6379726E-04,   1.5568994E-04,   1.4810116E-04
     +,   1.4097535E-04,   1.3426605E-04,   1.2793459E-04
     +,   1.2194878E-04,   1.1628122E-04,   1.1090813E-04
     +,   1.0580897E-04,   1.0096503E-04,   9.6359538E-05
     +,   9.1977388E-05,   8.7804518E-05,   8.3827748E-05
     +,   8.0034974E-05,   7.6414377E-05,   7.2955423E-05
     +,   6.9647780E-05,   6.6482280E-05,   6.3450221E-05
     +,   6.0543967E-05,   5.7755828E-05,   5.5079545E-05
     +,   5.2509291E-05,   5.0039915E-05,   4.7666930E-05
     +,   4.5386147E-05,   4.3194199E-05,   4.1087878E-05
     +,   3.9064555E-05,   3.7121874E-05,   3.5257715E-05
     +,   3.3470293E-05,   3.1757576E-05,   3.0118041E-05
     +,   2.8550086E-05,   2.7052150E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wano_hz_85 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wano_hz_90(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  1.1021166E-05,   1.1372128E-05
     +,   1.1731509E-05,   1.2099316E-05,   1.2475554E-05
     +,   1.2860226E-05,   1.3253289E-05,   1.3654724E-05
     +,   1.4064493E-05,   1.4482524E-05,   1.4908754E-05
     +,   1.5343101E-05,   1.5785488E-05,   1.6235792E-05
     +,   1.6693904E-05,   1.7159713E-05,   1.7633069E-05
     +,   1.8113829E-05,   1.8601861E-05,   1.9096984E-05
     +,   1.9599040E-05,   2.0107869E-05,   2.0623283E-05
     +,   2.1145106E-05,   2.1673170E-05,   2.2207276E-05
     +,   2.2747248E-05,   2.3292912E-05,   2.3844088E-05
     +,   2.4400606E-05,   2.4962310E-05,   2.5529018E-05
     +,   2.6100603E-05,   2.6676935E-05,   2.7257864E-05
     +,   2.7843294E-05,   2.8433144E-05,   2.9027306E-05
     +,   2.9625737E-05,   3.0228406E-05,   3.0835297E-05
     +,   3.1446412E-05,   3.2061784E-05,   3.2681470E-05
     +,   3.3305587E-05,   3.3934230E-05,   3.4567569E-05
     +,   3.5205787E-05,   3.5849112E-05,   3.6497826E-05
     +,   3.7152258E-05,   3.7812733E-05,   3.8479706E-05
     +,   3.9153652E-05,   3.9835064E-05,   4.0524588E-05
     +,   4.1222916E-05,   4.1930780E-05,   4.2649073E-05
     +,   4.3378754E-05,   4.4120890E-05,   4.4876717E-05
     +,   4.5647608E-05,   4.6435052E-05,   4.7240763E-05
     +,   4.8066671E-05,   4.8914852E-05,   4.9787694E-05
     +,   5.0687857E-05,   5.1618226E-05,   5.2582061E-05
     +,   5.3582949E-05,   5.4624888E-05,   5.5712178E-05
     +,   5.6849654E-05,   5.8042493E-05,   5.9296453E-05
     +,   6.0617713E-05,   6.2012892E-05,   6.3489300E-05
     +,   6.5054592E-05,   6.6716959E-05,   6.8485249E-05
     +,   7.0368682E-05,   7.2376846E-05,   7.4520081E-05
     +,   7.6808778E-05,   7.9254060E-05,   8.1867060E-05
     +,   8.4659347E-05,   8.7642533E-05,   9.0828791E-05
     +,   9.4230090E-05,   9.7858523E-05,   1.0172668E-04
     +,   1.0584688E-04,   1.1023165E-04,   1.1489420E-04
     +,   1.1984745E-04,   1.2510565E-04,   1.3068320E-04
     +,   1.3659550E-04,   1.4285921E-04,   1.4949306E-04
     +,   1.5651670E-04,   1.6395304E-04,   1.7182663E-04
     +,   1.8016488E-04,   1.8899808E-04,   1.9836018E-04
     +,   2.0828715E-04,   2.1881911E-04,   2.2999791E-04
     +,   2.4186808E-04,   2.5447554E-04,   2.6786883E-04
     +,   2.8209557E-04,   2.9720532E-04,   3.1324607E-04
     +,   3.3026456E-04,   3.4830923E-04,   3.6742451E-04
     +,   3.8765813E-04,   4.0905568E-04,   4.3166569E-04
     +,   4.5553799E-04,   4.8073023E-04,   5.0730229E-04
     +,   5.3532043E-04,   5.6486082E-04,   5.9600268E-04
     +,   6.2882912E-04,   6.6342892E-04,   6.9988333E-04
     +,   7.3827320E-04,   7.7866262E-04,   8.2110293E-04
     +,   8.6562423E-04,   9.1224513E-04,   9.6096209E-04
     +,   1.0117724E-03,   1.0646780E-03,   1.1197035E-03
     +,   1.1769305E-03,   1.2365063E-03,   1.2986753E-03
     +,   1.3638063E-03,   1.4323931E-03,   1.5050629E-03
     +,   1.5825727E-03,   1.6657609E-03,   1.7554999E-03
     +,   1.8526327E-03,   1.9578517E-03,   2.0715869E-03
     +,   2.1938682E-03,   2.3242061E-03,   2.4614416E-03
     +,   2.6037178E-03,   2.7484428E-03,   2.8924451E-03
     +,   3.0322096E-03,   3.1643400E-03,   3.2861016E-03
     +,   3.3961046E-03,   3.4949922E-03,   3.5859640E-03
     +,   3.6749833E-03,   3.7704874E-03,   3.8824338E-03
     +,   4.0207189E-03,   4.1931830E-03,   4.4035488E-03
     +,   4.6500103E-03,   4.9250098E-03,   5.2166977E-03
     +,   5.5121477E-03,   5.8015711E-03,   6.0822079E-03
     +,   6.3602710E-03,   6.6496250E-03,   6.9677592E-03
     +,   7.3311925E-03,   7.7540358E-03,   8.2515469E-03
     +,   8.8461144E-03,   9.5685972E-03,   1.0448782E-02
     +,   1.1496526E-02,   1.2684828E-02,   1.3948833E-02
     +,   1.5207408E-02,   1.6399771E-02,   1.7516056E-02
     +,   1.8595384E-02,   1.9679027E-02,   2.0743882E-02
     +,   2.1675568E-02,   2.2324277E-02,   2.2621874E-02
     +,   2.2664031E-02,   2.2667827E-02,   2.2826623E-02
     +,   2.3203954E-02,   2.3761021E-02,   2.4428608E-02
     +,   2.5089975E-02,   2.5546391E-02,   2.5627265E-02
     +,   2.5359698E-02,   2.4948103E-02,   2.4568409E-02
     +,   2.4236519E-02,   2.3872927E-02,   2.3426864E-02
     +,   2.2918722E-02,   2.2394842E-02,   2.1852741E-02
     +,   2.1196224E-02,   2.0275211E-02,   1.9006496E-02
     +,   1.7472496E-02,   1.5891533E-02,   1.4478231E-02
     +,   1.3322383E-02,   1.2379962E-02,   1.1550133E-02
     +,   1.0753018E-02,   9.9560721E-03,   9.1585917E-03
     +,   8.3674230E-03,   7.5850445E-03,   6.8109576E-03
     +,   6.0480544E-03,   5.3066560E-03,   4.6035522E-03
     +,   3.9576646E-03,   3.3847285E-03,   2.8933343E-03
     +,   2.4837069E-03,   2.1489440E-03,   1.8777240E-03
     +,   1.6573598E-03,   1.4761349E-03,   1.3246569E-03
     +,   1.1961306E-03,   1.0859987E-03,   9.9133537E-04
     +,   9.1018958E-04,   8.4108341E-04,   7.8272767E-04
     +,   7.3384709E-04,   6.9316308E-04,   6.5940153E-04
     +,   6.3133665E-04,   6.0783443E-04,   5.8787875E-04
     +,   5.7058950E-04,   5.5522739E-04,   5.4118515E-04
     +,   5.2797823E-04,   5.1522919E-04,   5.0265138E-04
     +,   4.9003545E-04,   4.7723565E-04,   4.6415671E-04
     +,   4.5074362E-04,   4.3697251E-04,   4.2284408E-04
     +,   4.0837881E-04,   3.9361167E-04,   3.7858865E-04
     +,   3.6336438E-04,   3.4799869E-04,   3.3255509E-04
     +,   3.1710096E-04,   3.0170401E-04,   2.8643160E-04
     +,   2.7134997E-04,   2.5652105E-04,   2.4200544E-04
     +,   2.2785694E-04,   2.1412582E-04,   2.0085598E-04
     +,   1.8808623E-04,   1.7584575E-04,   1.6416024E-04
     +,   1.5304786E-04,   1.4252022E-04,   1.3258337E-04
     +,   1.2323620E-04,   1.1447395E-04,   1.0628565E-04
     +,   9.8656972E-05,   9.1569767E-05,   8.5002714E-05
     +,   7.8932469E-05,   7.3332463E-05,   6.8176167E-05
     +,   6.3435757E-05,   5.9083010E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wano_hz_90 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wano_hz_95(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  6.0366301E-07,   6.3483782E-07
     +,   6.6730360E-07,   7.0109814E-07,   7.3626308E-07
     +,   7.7284068E-07,   8.1087398E-07,   8.5041012E-07
     +,   8.9149819E-07,   9.3418822E-07,   9.7853649E-07
     +,   1.0246015E-06,   1.0724481E-06,   1.1221426E-06
     +,   1.1737611E-06,   1.2273855E-06,   1.2831033E-06
     +,   1.3410136E-06,   1.4012248E-06,   1.4638551E-06
     +,   1.5290360E-06,   1.5969155E-06,   1.6676524E-06
     +,   1.7414286E-06,   1.8184436E-06,   1.8989153E-06
     +,   1.9830886E-06,   2.0712382E-06,   2.1636574E-06
     +,   2.2606800E-06,   2.3626726E-06,   2.4700321E-06
     +,   2.5832014E-06,   2.7026679E-06,   2.8289548E-06
     +,   2.9626447E-06,   3.1043703E-06,   3.2548105E-06
     +,   3.4147117E-06,   3.5848773E-06,   3.7661782E-06
     +,   3.9595402E-06,   4.1659682E-06,   4.3865311E-06
     +,   4.6223768E-06,   4.8747088E-06,   5.1448237E-06
     +,   5.4340703E-06,   5.7438838E-06,   6.0757657E-06
     +,   6.4312917E-06,   6.8120853E-06,   7.2198477E-06
     +,   7.6563374E-06,   8.1233438E-06,   8.6227210E-06
     +,   9.1563652E-06,   9.7261645E-06,   1.0334058E-05
     +,   1.0981998E-05,   1.1671896E-05,   1.2405671E-05
     +,   1.3185237E-05,   1.4012398E-05,   1.4888966E-05
     +,   1.5816669E-05,   1.6797103E-05,   1.7831813E-05
     +,   1.8922226E-05,   2.0069589E-05,   2.1275055E-05
     +,   2.2539607E-05,   2.3864070E-05,   2.5249028E-05
     +,   2.6694970E-05,   2.8202059E-05,   2.9770428E-05
     +,   3.1399864E-05,   3.3089913E-05,   3.4840094E-05
     +,   3.6649577E-05,   3.8517257E-05,   4.0442090E-05
     +,   4.2422627E-05,   4.4457232E-05,   4.6544348E-05
     +,   4.8681981E-05,   5.0868312E-05,   5.3101205E-05
     +,   5.5378496E-05,   5.7697885E-05,   6.0057377E-05
     +,   6.2454594E-05,   6.4887266E-05,   6.7353380E-05
     +,   6.9850823E-05,   7.2377436E-05,   7.4931580E-05
     +,   7.7511351E-05,   8.0115366E-05,   8.2742168E-05
     +,   8.5390573E-05,   8.8059554E-05,   9.0748603E-05
     +,   9.3457013E-05,   9.6184798E-05,   9.8931880E-05
     +,   1.0169861E-04,   1.0448546E-04,   1.0729350E-04
     +,   1.1012368E-04,   1.1297768E-04,   1.1585710E-04
     +,   1.1876401E-04,   1.2170060E-04,   1.2466982E-04
     +,   1.2767447E-04,   1.3071814E-04,   1.3380453E-04
     +,   1.3693780E-04,   1.4012301E-04,   1.4336528E-04
     +,   1.4667107E-04,   1.5004720E-04,   1.5350168E-04
     +,   1.5704353E-04,   1.6068369E-04,   1.6443434E-04
     +,   1.6830956E-04,   1.7232622E-04,   1.7650348E-04
     +,   1.8086362E-04,   1.8543286E-04,   1.9024094E-04
     +,   1.9532286E-04,   2.0071818E-04,   2.0647241E-04
     +,   2.1263697E-04,   2.1927075E-04,   2.2643898E-04
     +,   2.3421536E-04,   2.4268079E-04,   2.5192418E-04
     +,   2.6204353E-04,   2.7314411E-04,   2.8533931E-04
     +,   2.9875248E-04,   3.1351493E-04,   3.2976802E-04
     +,   3.4766801E-04,   3.6738519E-04,   3.8911033E-04
     +,   4.1306281E-04,   4.3949316E-04,   4.6869207E-04
     +,   5.0099479E-04,   5.3679041E-04,   5.7651073E-04
     +,   6.2063988E-04,   6.6968944E-04,   7.2418922E-04
     +,   7.8466244E-04,   8.5160416E-04,   9.2545699E-04
     +,   1.0065762E-03,   1.0952225E-03,   1.1915504E-03
     +,   1.2956017E-03,   1.4073366E-03,   1.5266468E-03
     +,   1.6533810E-03,   1.7873937E-03,   1.9285518E-03
     +,   2.0767509E-03,   2.2318407E-03,   2.3934923E-03
     +,   2.5610360E-03,   2.7332536E-03,   2.9081965E-03
     +,   3.0831615E-03,   3.2547389E-03,   3.4192002E-03
     +,   3.5729487E-03,   3.7131361E-03,   3.8381838E-03
     +,   3.9481157E-03,   4.0445994E-03,   4.1306568E-03
     +,   4.2101350E-03,   4.2870762E-03,   4.3651205E-03
     +,   4.4470970E-03,   4.5348611E-03,   4.6295333E-03
     +,   4.7321366E-03,   4.8447042E-03,   4.9717911E-03
     +,   5.1221135E-03,   5.3097573E-03,   5.5540083E-03
     +,   5.8768396E-03,   6.2973197E-03,   6.8236040E-03
     +,   7.4451491E-03,   8.1289774E-03,   8.8237869E-03
     +,   9.4727688E-03,   1.0031606E-02,   1.0485190E-02
     +,   1.0856143E-02,   1.1200483E-02,   1.1590132E-02
     +,   1.2088426E-02,   1.2733322E-02,   1.3542157E-02
     +,   1.4530207E-02,   1.5712077E-02,   1.7062614E-02
     +,   1.8468847E-02,   1.9737672E-02,   2.0685513E-02
     +,   2.1252804E-02,   2.1549925E-02,   2.1794436E-02
     +,   2.2189535E-02,   2.2827789E-02,   2.3653807E-02
     +,   2.4473872E-02,   2.5025843E-02,   2.5118954E-02
     +,   2.4745245E-02,   2.4028171E-02,   2.3062725E-02
     +,   2.1849826E-02,   2.0380609E-02,   1.8720923E-02
     +,   1.6992263E-02,   1.5302255E-02,   1.3706780E-02
     +,   1.2216164E-02,   1.0821793E-02,   9.5221354E-03
     +,   8.3353538E-03,   7.2918218E-03,   6.4150840E-03
     +,   5.7064756E-03,   5.1440252E-03,   4.6933405E-03
     +,   4.3204185E-03,   3.9992821E-03,   3.7132073E-03
     +,   3.4519923E-03,   3.2090438E-03,   2.9796062E-03
     +,   2.7603284E-03,   2.5493994E-03,   2.3465627E-03
     +,   2.1528625E-03,   1.9701424E-03,   1.8004475E-03
     +,   1.6455280E-03,   1.5065328E-03,   1.3838371E-03
     +,   1.2770738E-03,   1.1852474E-03,   1.1068896E-03
     +,   1.0402515E-03,   9.8346709E-04,   9.3469850E-04
     +,   8.9224149E-04,   8.5458736E-04,   8.2045980E-04
     +,   7.8882813E-04,   7.5889524E-04,   7.3008158E-04
     +,   7.0200046E-04,   6.7442062E-04,   6.4723671E-04
     +,   6.2043522E-04,   5.9406320E-04,   5.6820788E-04
     +,   5.4296706E-04,   5.1844079E-04,   4.9471465E-04
     +,   4.7185537E-04,   4.4989955E-04,   4.2886534E-04
     +,   4.0874502E-04,   3.8951106E-04,   3.7112157E-04
     +,   3.5352050E-04,   3.3664881E-04,   3.2044164E-04
     +,   3.0483768E-04,   2.8977916E-04,   2.7521382E-04
     +,   2.6109873E-04,   2.4739563E-04,   2.3407824E-04
     +,   2.2112702E-04,   2.0853041E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wano_hz_95 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wano_qq(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   2.9441791E-38,   8.3105586E-38,   2.3293318E-37
     +,   6.4822807E-37,   1.7912494E-36,   4.9147280E-36
     +,   1.3388697E-35,   3.6216703E-35,   9.7269081E-35
     +,   2.5940352E-34,   6.8689255E-34,   1.8059968E-33
     +,   4.7146243E-33,   1.2220878E-32,   3.1453904E-32
     +,   8.0378899E-32,   2.0395906E-31,   5.1387502E-31
     +,   1.2854959E-30,   3.1931230E-30,   7.8751275E-30
     +,   1.9285447E-29,   4.6893969E-29,   1.1321862E-28
     +,   2.7140368E-28,   6.4601916E-28,   1.5267761E-27
     +,   3.5828926E-27,   8.3484811E-27,   1.9314333E-26
     +,   4.4369096E-26,   1.0120375E-25,   2.2919910E-25
     +,   5.1541578E-25,   1.1508429E-24,   2.5513874E-24
     +,   5.6164707E-24,   1.2276255E-23,   2.6642105E-23
     +,   5.7411612E-23,   1.2284179E-22,   2.6097831E-22
     +,   5.5050930E-22,   1.1530638E-21,   2.3979718E-21
     +,   4.9517826E-21,   1.0152921E-20,   2.0669846E-20
     +,   4.1781646E-20,   8.3858549E-20,   1.6712355E-19
     +,   3.3070433E-19,   6.4976645E-19,   1.2676223E-18
     +,   2.4554176E-18,   4.7225263E-18,   9.0188131E-18
     +,   1.7101646E-17,   3.2198952E-17,   6.0193549E-17
     +,   1.1173071E-16,   2.0592996E-16,   3.7686076E-16
     +,   6.8478882E-16,   1.2355090E-15,   2.2133013E-15
     +,   3.9369465E-15,   6.9531571E-15,   1.2193538E-14
     +,   2.1232046E-14,   3.6708643E-14,   6.3017096E-14
     +,   1.0741243E-13,   1.8178762E-13,   3.0549096E-13
     +,   5.0973673E-13,   8.4451624E-13,   1.3892390E-12
     +,   2.2691304E-12,   3.6801430E-12,   5.9263146E-12
     +,   9.4758697E-12,   1.5044159E-11,   2.3715002E-11
     +,   3.7118711E-11,   5.7687865E-11,   8.9020659E-11
     +,   1.3639899E-10,   2.0751348E-10,   3.1346453E-10
     +,   4.7015913E-10,   7.0020106E-10,   1.0354164E-09
     +,   1.5202736E-09,   2.2163393E-09,   3.2082297E-09
     +,   4.6112190E-09,   6.5808199E-09,   9.3252019E-09
     +,   1.3120528E-08,   1.8329590E-08,   2.5425786E-08
     +,   3.5019106E-08,   4.7891142E-08,   6.5030974E-08
     +,   8.7679723E-08,   1.1737960E-07,   1.5602552E-07
     +,   2.0592688E-07,   2.6986692E-07,   3.5115656E-07
     +,   4.5369703E-07,   5.8202477E-07,   7.4137108E-07
     +,   9.3764845E-07,   1.1775055E-06,   1.4682502E-06
     +,   1.8178232E-06,   2.2346726E-06,   2.7276642E-06
     +,   3.3058698E-06,   3.9782744E-06,   4.7535536E-06
     +,   5.6397053E-06,   6.6436464E-06,   7.7709046E-06
     +,   9.0251615E-06,   1.0407702E-05,   1.1917167E-05
     +,   1.3549089E-05,   1.5295926E-05,   1.7146536E-05
     +,   1.9086418E-05,   2.1098247E-05,   2.3162051E-05
     +,   2.5256411E-05,   2.7360267E-05,   2.9454395E-05
     +,   3.1524905E-05,   3.3566143E-05,   3.5585217E-05
     +,   3.7606645E-05,   3.9677230E-05,   4.1870782E-05
     +,   4.4291472E-05,   4.7074922E-05,   5.0386803E-05
     +,   5.4416851E-05,   5.9368456E-05,   6.5444023E-05
     +,   7.2826115E-05,   8.1655475E-05,   9.2010756E-05
     +,   1.0388945E-04,   1.1719747E-04,   1.3174501E-04
     +,   1.4725345E-04,   1.6337789E-04,   1.7974108E-04
     +,   1.9598115E-04,   2.1181443E-04,   2.2710601E-04
     +,   2.4194767E-04,   2.5674049E-04,   2.7226706E-04
     +,   2.8974249E-04,   3.1083115E-04,   3.3759879E-04
     +,   3.7240374E-04,   4.1769064E-04,   4.7571558E-04
     +,   5.4820039E-04,   6.3599768E-04,   7.3872739E-04
     +,   8.5455121E-04,   9.8005135E-04,   1.1102627E-03
     +,   1.2388993E-03,   1.3586847E-03,   1.4618996E-03
     +,   1.5409795E-03,   1.5892477E-03,   1.6016513E-03
     +,   1.5754482E-03,   1.5106986E-03,   1.4104932E-03
     +,   1.2807776E-03,   1.1297751E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wano_qq = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wano_ww(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  6.7656579E-06,   6.9959797E-06
     +,   7.2293774E-06,   7.4656414E-06,   7.7045606E-06
     +,   7.9459132E-06,   8.1894550E-06,   8.4349431E-06
     +,   8.6821246E-06,   8.9307223E-06,   9.1804677E-06
     +,   9.4310717E-06,   9.6822514E-06,   9.9336939E-06
     +,   1.0185098E-05,   1.0436157E-05,   1.0686545E-05
     +,   1.0935942E-05,   1.1184028E-05,   1.1430467E-05
     +,   1.1674931E-05,   1.1917097E-05,   1.2156624E-05
     +,   1.2393186E-05,   1.2626461E-05,   1.2856117E-05
     +,   1.3081838E-05,   1.3303312E-05,   1.3520224E-05
     +,   1.3732276E-05,   1.3939176E-05,   1.4140635E-05
     +,   1.4336382E-05,   1.4526159E-05,   1.4709705E-05
     +,   1.4886790E-05,   1.5057189E-05,   1.5220689E-05
     +,   1.5377100E-05,   1.5526244E-05,   1.5667962E-05
     +,   1.5802105E-05,   1.5928557E-05,   1.6047206E-05
     +,   1.6157974E-05,   1.6260785E-05,   1.6355601E-05
     +,   1.6442391E-05,   1.6521151E-05,   1.6591899E-05
     +,   1.6654672E-05,   1.6709530E-05,   1.6756545E-05
     +,   1.6795824E-05,   1.6827484E-05,   1.6851671E-05
     +,   1.6868538E-05,   1.6878275E-05,   1.6881077E-05
     +,   1.6877160E-05,   1.6866765E-05,   1.6850143E-05
     +,   1.6827562E-05,   1.6799311E-05,   1.6765687E-05
     +,   1.6727003E-05,   1.6683585E-05,   1.6635773E-05
     +,   1.6583912E-05,   1.6528353E-05,   1.6469467E-05
     +,   1.6407619E-05,   1.6343185E-05,   1.6276543E-05
     +,   1.6208071E-05,   1.6138152E-05,   1.6067163E-05
     +,   1.5995480E-05,   1.5923481E-05,   1.5851523E-05
     +,   1.5779973E-05,   1.5709184E-05,   1.5639489E-05
     +,   1.5571217E-05,   1.5504689E-05,   1.5440202E-05
     +,   1.5378038E-05,   1.5318468E-05,   1.5261739E-05
     +,   1.5208073E-05,   1.5157686E-05,   1.5110752E-05
     +,   1.5067440E-05,   1.5027884E-05,   1.4992197E-05
     +,   1.4960462E-05,   1.4932748E-05,   1.4909088E-05
     +,   1.4889491E-05,   1.4873946E-05,   1.4862411E-05
     +,   1.4854832E-05,   1.4851115E-05,   1.4851170E-05
     +,   1.4854871E-05,   1.4862095E-05,   1.4872697E-05
     +,   1.4886537E-05,   1.4903478E-05,   1.4923392E-05
     +,   1.4946178E-05,   1.4971768E-05,   1.5000132E-05
     +,   1.5031311E-05,   1.5065423E-05,   1.5102692E-05
     +,   1.5143468E-05,   1.5188256E-05,   1.5237751E-05
     +,   1.5292868E-05,   1.5354788E-05,   1.5424999E-05
     +,   1.5505346E-05,   1.5598082E-05,   1.5705920E-05
     +,   1.5832085E-05,   1.5980408E-05,   1.6155338E-05
     +,   1.6362026E-05,   1.6606406E-05,   1.6895194E-05
     +,   1.7235965E-05,   1.7637249E-05,   1.8108418E-05
     +,   1.8659870E-05,   1.9302877E-05,   2.0049662E-05
     +,   2.0913258E-05,   2.1907616E-05,   2.3047240E-05
     +,   2.4347381E-05,   2.5823589E-05,   2.7491644E-05
     +,   2.9367564E-05,   3.1466974E-05,   3.3805045E-05
     +,   3.6396501E-05,   3.9254814E-05,   4.2392119E-05
     +,   4.5819397E-05,   4.9545419E-05,   5.3576794E-05
     +,   5.7918372E-05,   6.2571977E-05,   6.7537010E-05
     +,   7.2809940E-05,   7.8385136E-05,   8.4253566E-05
     +,   9.0404545E-05,   9.6824442E-05,   1.0349814E-04
     +,   1.1040868E-04,   1.1753892E-04,   1.2487157E-04
     +,   1.3238945E-04,   1.4007723E-04,   1.4792210E-04
     +,   1.5591449E-04,   1.6405014E-04,   1.7233055E-04
     +,   1.8076316E-04,   1.8936305E-04,   1.9815309E-04
     +,   2.0716479E-04,   2.1643766E-04,   2.2601764E-04
     +,   2.3595664E-04,   2.4631046E-04,   2.5713528E-04
     +,   2.6848644E-04,   2.8041139E-04,   2.9294932E-04
     +,   3.0612355E-04,   3.1993914E-04,   3.3437874E-04
     +,   3.4939978E-04,   3.6493348E-04,   3.8088430E-04
     +,   3.9712904E-04,   4.1352244E-04,   4.2990019E-04
     +,   4.4608657E-04,   4.6190096E-04,   4.7716411E-04
     +,   4.9170782E-04,   5.0538190E-04,   5.1805982E-04
     +,   5.2964367E-04,   5.4006628E-04,   5.4928870E-04
     +,   5.5729889E-04,   5.6410563E-04,   5.6973076E-04
     +,   5.7420152E-04,   5.7754037E-04,   5.7975808E-04
     +,   5.8084604E-04,   5.8077474E-04,   5.7949184E-04
     +,   5.7692616E-04,   5.7299546E-04,   5.6761660E-04
     +,   5.6071969E-04,   5.5226288E-04,   5.4224755E-04
     +,   5.3073384E-04,   5.1785033E-04,   5.0380541E-04
     +,   4.8888742E-04,   4.7346434E-04,   4.5797482E-04
     +,   4.4291271E-04,   4.2880941E-04,   4.1621129E-04
     +,   4.0565178E-04,   3.9762515E-04,   3.9255907E-04
     +,   3.9079104E-04,   3.9254714E-04,   3.9792826E-04
     +,   4.0690225E-04,   4.1930153E-04,   4.3483308E-04
     +,   4.5309207E-04,   4.7358120E-04,   4.9573893E-04
     +,   5.1896757E-04,   5.4266385E-04,   5.6625070E-04
     +,   5.8920105E-04,   6.1105646E-04,   6.3144631E-04
     +,   6.5009005E-04,   6.6680351E-04,   6.8148761E-04
     +,   6.9411803E-04,   7.0473627E-04,   7.1342761E-04
     +,   7.2031212E-04,   7.2553253E-04,   7.2924513E-04
     +,   7.3161680E-04,   7.3282619E-04,   7.3306373E-04
     +,   7.3253765E-04,   7.3147425E-04,   7.3011895E-04
     +,   7.2873168E-04,   7.2757836E-04,   7.2691659E-04
     +,   7.2697987E-04,   7.2795642E-04,   7.2997046E-04
     +,   7.3306612E-04,   7.3719386E-04,   7.4220716E-04
     +,   7.4786268E-04,   7.5383147E-04,   7.5971661E-04
     +,   7.6507422E-04,   7.6943950E-04,   7.7235524E-04
     +,   7.7339314E-04,   7.7217806E-04,   7.6840050E-04
     +,   7.6182914E-04,   7.5231364E-04,   7.3978421E-04
     +,   7.2424702E-04,   7.0577598E-04,   6.8450684E-04
     +,   6.6062517E-04,   6.3436280E-04,   6.0598773E-04
     +,   5.7580194E-04,   5.4412516E-04,   5.1130477E-04
     +,   4.7769939E-04,   4.4367556E-04,   4.0960024E-04
     +,   3.7582905E-04,   3.4270549E-04,   3.1054282E-04
     +,   2.7962544E-04,   2.5019658E-04,   2.2245523E-04
     +,   1.9655502E-04,   1.7259490E-04,   1.5063299E-04
     +,   1.3068113E-04,   1.1271120E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wano_ww = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wano_zz(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  4.6965151E-06,   4.7715448E-06
     +,   4.8465458E-06,   4.9215437E-06,   4.9965752E-06
     +,   5.0716844E-06,   5.1469128E-06,   5.2223181E-06
     +,   5.2979585E-06,   5.3738941E-06,   5.4501929E-06
     +,   5.5269288E-06,   5.6041749E-06,   5.6820086E-06
     +,   5.7605112E-06,   5.8397636E-06,   5.9198460E-06
     +,   6.0008419E-06,   6.0828356E-06,   6.1659021E-06
     +,   6.2501222E-06,   6.3355719E-06,   6.4223200E-06
     +,   6.5104323E-06,   6.5999729E-06,   6.6909902E-06
     +,   6.7835404E-06,   6.8776603E-06,   6.9733715E-06
     +,   7.0707024E-06,   7.1696677E-06,   7.2702583E-06
     +,   7.3724682E-06,   7.4762770E-06,   7.5816415E-06
     +,   7.6885199E-06,   7.7968525E-06,   7.9065594E-06
     +,   8.0175560E-06,   8.1297339E-06,   8.2429915E-06
     +,   8.3571977E-06,   8.4722051E-06,   8.5878701E-06
     +,   8.7040307E-06,   8.8205088E-06,   8.9371224E-06
     +,   9.0536869E-06,   9.1699976E-06,   9.2858618E-06
     +,   9.4010666E-06,   9.5154128E-06,   9.6286931E-06
     +,   9.7407083E-06,   9.8512683E-06,   9.9601893E-06
     +,   1.0067305E-05,   1.0172464E-05,   1.0275538E-05
     +,   1.0376427E-05,   1.0475050E-05,   1.0571382E-05
     +,   1.0665420E-05,   1.0757225E-05,   1.0846893E-05
     +,   1.0934594E-05,   1.1020546E-05,   1.1105045E-05
     +,   1.1188476E-05,   1.1271287E-05,   1.1354027E-05
     +,   1.1437340E-05,   1.1521965E-05,   1.1608751E-05
     +,   1.1698664E-05,   1.1792775E-05,   1.1892281E-05
     +,   1.1998505E-05,   1.2112884E-05,   1.2236989E-05
     +,   1.2372509E-05,   1.2521252E-05,   1.2685151E-05
     +,   1.2866253E-05,   1.3066696E-05,   1.3288741E-05
     +,   1.3534718E-05,   1.3807023E-05,   1.4108150E-05
     +,   1.4440593E-05,   1.4806895E-05,   1.5209631E-05
     +,   1.5651327E-05,   1.6134480E-05,   1.6661606E-05
     +,   1.7235059E-05,   1.7857126E-05,   1.8530040E-05
     +,   1.9255811E-05,   2.0036412E-05,   2.0873553E-05
     +,   2.1768805E-05,   2.2723529E-05,   2.3738989E-05
     +,   2.4816098E-05,   2.5955738E-05,   2.7158485E-05
     +,   2.8424760E-05,   2.9754769E-05,   3.1148680E-05
     +,   3.2606338E-05,   3.4127690E-05,   3.5712397E-05
     +,   3.7360114E-05,   3.9070357E-05,   4.0842904E-05
     +,   4.2677217E-05,   4.4573186E-05,   4.6530582E-05
     +,   4.8549315E-05,   5.0629842E-05,   5.2772612E-05
     +,   5.4978835E-05,   5.7250134E-05,   5.9588725E-05
     +,   6.1997940E-05,   6.4482228E-05,   6.7047164E-05
     +,   6.9700160E-05,   7.2450726E-05,   7.5310396E-05
     +,   7.8293451E-05,   8.1417638E-05,   8.4703635E-05
     +,   8.8176494E-05,   9.1864880E-05,   9.5801901E-05
     +,   1.0002487E-04,   1.0457556E-04,   1.0949896E-04
     +,   1.1484387E-04,   1.2066057E-04,   1.2699996E-04
     +,   1.3391301E-04,   1.4144738E-04,   1.4964519E-04
     +,   1.5854285E-04,   1.6816576E-04,   1.7852668E-04
     +,   1.8962474E-04,   2.0144075E-04,   2.1393567E-04
     +,   2.2705097E-04,   2.4070368E-04,   2.5478724E-04
     +,   2.6917123E-04,   2.8370527E-04,   2.9821545E-04
     +,   3.1251763E-04,   3.2641989E-04,   3.3973754E-04
     +,   3.5230638E-04,   3.6400431E-04,   3.7476901E-04
     +,   3.8462112E-04,   3.9368102E-04,   4.0218324E-04
     +,   4.1047842E-04,   4.1902618E-04,   4.2837113E-04
     +,   4.3910817E-04,   4.5183665E-04,   4.6711115E-04
     +,   4.8539386E-04,   5.0701539E-04,   5.3214742E-04
     +,   5.6078902E-04,   5.9276161E-04,   6.2771590E-04
     +,   6.6513888E-04,   7.0438086E-04,   7.4471091E-04
     +,   7.8539975E-04,   8.2584319E-04,   8.6569902E-04
     +,   9.0496970E-04,   9.4400661E-04,   9.8337233E-04
     +,   1.0236601E-03,   1.0653316E-03,   1.1087605E-03
     +,   1.1545719E-03,   1.2042362E-03,   1.2606356E-03
     +,   1.3283408E-03,   1.4131111E-03,   1.5203839E-03
     +,   1.6529036E-03,   1.8080943E-03,   1.9763019E-03
     +,   2.1412477E-03,   2.2834204E-03,   2.3858349E-03
     +,   2.4401403E-03,   2.4503954E-03,   2.4325219E-03
     +,   2.4094575E-03,   2.4038784E-03,   2.4314011E-03
     +,   2.4965857E-03,   2.5927157E-03,   2.7048911E-03
     +,   2.8150799E-03,   2.9072806E-03,   2.9711230E-03
     +,   3.0026245E-03,   3.0024885E-03,   2.9733549E-03
     +,   2.9178699E-03,   2.8383357E-03,   2.7374199E-03
     +,   2.6186330E-03,   2.4860350E-03,   2.3436085E-03
     +,   2.1950137E-03,   2.0439457E-03,   1.8944251E-03
     +,   1.7505069E-03,   1.6153543E-03,   1.4904601E-03
     +,   1.3755840E-03,   1.2694563E-03,   1.1706997E-03
     +,   1.0784303E-03,   9.9229475E-04,   9.1215497E-04
     +,   8.3779113E-04,   7.6882832E-04,   7.0488814E-04
     +,   6.4579479E-04,   5.9169269E-04,   5.4296840E-04
     +,   5.0007930E-04,   4.6332041E-04,   4.3268883E-04
     +,   4.0781629E-04,   3.8801637E-04,   3.7240217E-04
     +,   3.6001482E-04,   3.4994361E-04,   3.4141185E-04
     +,   3.3381378E-04,   3.2672269E-04,   3.1986457E-04
     +,   3.1308489E-04,   3.0631054E-04,   2.9951418E-04
     +,   2.9269012E-04,   2.8583815E-04,   2.7895410E-04
     +,   2.7202853E-04,   2.6504713E-04,   2.5799344E-04
     +,   2.5085395E-04,   2.4361930E-04,   2.3628869E-04
     +,   2.2886992E-04,   2.2137807E-04,   2.1383773E-04
     +,   2.0627947E-04,   1.9873917E-04,   1.9125476E-04
     +,   1.8386560E-04,   1.7660848E-04,   1.6951766E-04
     +,   1.6262339E-04,   1.5595042E-04,   1.4951781E-04
     +,   1.4333917E-04,   1.3742106E-04,   1.3176598E-04
     +,   1.2637019E-04,   1.2122648E-04,   1.1632347E-04
     +,   1.1164712E-04,   1.0718018E-04,   1.0290452E-04
     +,   9.8800869E-05,   9.4849500E-05,   9.1031223E-05
     +,   8.7327040E-05,   8.3719999E-05,   8.0194070E-05
     +,   7.6735902E-05,   7.3334108E-05,   6.9979840E-05
     +,   6.6667148E-05,   6.3391606E-05,   6.0152121E-05
     +,   5.6949706E-05,   5.3787306E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wano_zz = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wao_fus_100(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  1.1472357E-10,   1.3432558E-10
     +,   1.5710912E-10,   1.8356011E-10,   2.1423571E-10
     +,   2.4977101E-10,   2.9088909E-10,   3.3841435E-10
     +,   3.9328549E-10,   4.5656517E-10,   5.2946092E-10
     +,   6.1334138E-10,   7.0975503E-10,   8.2044721E-10
     +,   9.4739272E-10,   1.0928187E-09,   1.2592224E-09
     +,   1.4494205E-09,   1.6665762E-09,   1.9142248E-09
     +,   2.1963371E-09,   2.5173532E-09,   2.8822182E-09
     +,   3.2964620E-09,   3.7662469E-09,   4.2984070E-09
     +,   4.9005511E-09,   5.5811413E-09,   6.3494969E-09
     +,   7.2159763E-09,   8.1920337E-09,   9.2902388E-09
     +,   1.0524518E-08,   1.1910188E-08,   1.3464012E-08
     +,   1.5204449E-08,   1.7151763E-08,   1.9327986E-08
     +,   2.1757337E-08,   2.4466164E-08,   2.7483267E-08
     +,   3.0839786E-08,   3.4569752E-08,   3.8709985E-08
     +,   4.3300521E-08,   4.8384297E-08,   5.4008133E-08
     +,   6.0222050E-08,   6.7080300E-08,   7.4641022E-08
     +,   8.2966793E-08,   9.2124132E-08,   1.0218482E-07
     +,   1.1322545E-07,   1.2532718E-07,   1.3857678E-07
     +,   1.5306686E-07,   1.6889454E-07,   1.8616379E-07
     +,   2.0498429E-07,   2.2547104E-07,   2.4774582E-07
     +,   2.7193732E-07,   2.9817866E-07,   3.2661094E-07
     +,   3.5738162E-07,   3.9064290E-07,   4.2655481E-07
     +,   4.6528376E-07,   5.0700004E-07,   5.5188184E-07
     +,   6.0011263E-07,   6.5188181E-07,   7.0738088E-07
     +,   7.6681050E-07,   8.3036946E-07,   8.9826892E-07
     +,   9.7071609E-07,   1.0479197E-06,   1.1301005E-06
     +,   1.2174703E-06,   1.3102425E-06,   1.4086398E-06
     +,   1.5128735E-06,   1.6231530E-06,   1.7396965E-06
     +,   1.8627028E-06,   1.9923827E-06,   2.1289293E-06
     +,   2.2725326E-06,   2.4233698E-06,   2.5816259E-06
     +,   2.7474634E-06,   2.9210289E-06,   3.1024817E-06
     +,   3.2919481E-06,   3.4895411E-06,   3.6953850E-06
     +,   3.9095594E-06,   4.1321628E-06,   4.3632554E-06
     +,   4.6028927E-06,   4.8511079E-06,   5.1079492E-06
     +,   5.3734138E-06,   5.6475287E-06,   5.9302793E-06
     +,   6.2216527E-06,   6.5216177E-06,   6.8301724E-06
     +,   7.1472627E-06,   7.4728850E-06,   7.8069988E-06
     +,   8.1495846E-06,   8.5006095E-06,   8.8601000E-06
     +,   9.2280397E-06,   9.6044851E-06,   9.9894814E-06
     +,   1.0383093E-05,   1.0785466E-05,   1.1196717E-05
     +,   1.1617075E-05,   1.2046763E-05,   1.2486074E-05
     +,   1.2935338E-05,   1.3395005E-05,   1.3865538E-05
     +,   1.4347474E-05,   1.4841485E-05,   1.5348269E-05
     +,   1.5868614E-05,   1.6403465E-05,   1.6953782E-05
     +,   1.7520715E-05,   1.8105466E-05,   1.8709363E-05
     +,   1.9333826E-05,   1.9980476E-05,   2.0650950E-05
     +,   2.1347110E-05,   2.2070864E-05,   2.2824242E-05
     +,   2.3609469E-05,   2.4428797E-05,   2.5284577E-05
     +,   2.6179356E-05,   2.7115659E-05,   2.8096068E-05
     +,   2.9123319E-05,   3.0200055E-05,   3.1328909E-05
     +,   3.2512591E-05,   3.3753615E-05,   3.5054414E-05
     +,   3.6417205E-05,   3.7844151E-05,   3.9336930E-05
     +,   4.0897172E-05,   4.2525913E-05,   4.4223863E-05
     +,   4.5991186E-05,   4.7827638E-05,   4.9732458E-05
     +,   5.1704112E-05,   5.3740550E-05,   5.5839071E-05
     +,   5.7996309E-05,   6.0208447E-05,   6.2471154E-05
     +,   6.4779495E-05,   6.7128283E-05,   6.9512032E-05
     +,   7.1925460E-05,   7.4363474E-05,   7.6821256E-05
     +,   7.9294827E-05,   8.1781298E-05,   8.4279018E-05
     +,   8.6788408E-05,   8.9311630E-05,   9.1853683E-05
     +,   9.4422103E-05,   9.7027594E-05,   9.9684279E-05
     +,   1.0240981E-04,   1.0522566E-04,   1.0815727E-04
     +,   1.1123373E-04,   1.1448804E-04,   1.1795697E-04
     +,   1.2168136E-04,   1.2570625E-04,   1.3008066E-04
     +,   1.3485862E-04,   1.4010016E-04,   1.4587240E-04
     +,   1.5225269E-04,   1.5933115E-04,   1.6721452E-04
     +,   1.7603241E-04,   1.8594402E-04,   1.9714684E-04
     +,   2.0988850E-04,   2.2447886E-04,   2.4130267E-04
     +,   2.6083595E-04,   2.8365848E-04,   3.1046680E-04
     +,   3.4207801E-04,   3.7942303E-04,   4.2353323E-04
     +,   4.7551168E-04,   5.3649273E-04,   6.0760812E-04
     +,   6.8993005E-04,   7.8446360E-04,   8.9211814E-04
     +,   1.0137446E-03,   1.1501875E-03,   1.3023687E-03
     +,   1.4714043E-03,   1.6586530E-03,   1.8656537E-03
     +,   2.0939365E-03,   2.3446528E-03,   2.6182078E-03
     +,   2.9138629E-03,   3.2297021E-03,   3.5627251E-03
     +,   3.9095692E-03,   4.2680623E-03,   4.6398817E-03
     +,   5.0332486E-03,   5.4633827E-03,   5.9485040E-03
     +,   6.5022204E-03,   7.1277833E-03,   7.8207962E-03
     +,   8.5810218E-03,   9.4263302E-03,   1.0396832E-02
     +,   1.1533288E-02,   1.2821905E-02,   1.4138377E-02
     +,   1.5271092E-02,   1.6038144E-02,   1.6385959E-02
     +,   1.6409723E-02,   1.6370360E-02,   1.6653381E-02
     +,   1.7496275E-02,   1.8663837E-02,   1.9561943E-02
     +,   1.9836186E-02,   1.9755593E-02,   1.9809745E-02
     +,   2.0067146E-02,   2.0275356E-02,   2.0471564E-02
     +,   2.0962719E-02,   2.1670422E-02,   2.1999920E-02
     +,   2.1471346E-02,   2.0161306E-02,   1.8484015E-02
     +,   1.6794570E-02,   1.5263290E-02,   1.3939532E-02
     +,   1.2812427E-02,   1.1844996E-02,   1.0991432E-02
     +,   1.0201697E-02,   9.4368756E-03,   8.6876936E-03
     +,   7.9710465E-03,   7.3119053E-03,   6.7306329E-03
     +,   6.2371963E-03,   5.8267135E-03,   5.4785553E-03
     +,   5.1624407E-03,   4.8490018E-03,   4.5179874E-03
     +,   4.1608280E-03,   3.7785352E-03,   3.3785177E-03
     +,   2.9717712E-03,   2.5710228E-03,   2.1890760E-03
     +,   1.8370402E-03,   1.5229495E-03,   1.2508847E-03
     +,   1.0211624E-03,   8.3109195E-04,   6.7610509E-04
     +,   5.5083929E-04,   4.4991961E-04,   3.6851873E-04
     +,   3.0255012E-04,   2.4872337E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wao_fus_100 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wao_fus_105(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  1.1675824E-10,   1.3559955E-10
     +,   1.5732576E-10,   1.8235156E-10,   2.1114915E-10
     +,   2.4425281E-10,   2.8226571E-10,   3.2587191E-10
     +,   3.7584361E-10,   4.3304813E-10,   4.9846566E-10
     +,   5.7319893E-10,   6.5848615E-10,   7.5571432E-10
     +,   8.6644136E-10,   9.9241360E-10,   1.1355773E-09
     +,   1.2981106E-09,   1.4824454E-09,   1.6912826E-09
     +,   1.9276403E-09,   2.1948674E-09,   2.4966700E-09
     +,   2.8371789E-09,   3.2209617E-09,   3.6530505E-09
     +,   4.1390273E-09,   4.6850586E-09,   5.2979026E-09
     +,   5.9850263E-09,   6.7546431E-09,   7.6157320E-09
     +,   8.5781720E-09,   9.6527888E-09,   1.0851358E-08
     +,   1.2186816E-08,   1.3673256E-08,   1.5325952E-08
     +,   1.7161625E-08,   1.9198401E-08,   2.1455964E-08
     +,   2.3955559E-08,   2.6720272E-08,   2.9775006E-08
     +,   3.3146730E-08,   3.6864254E-08,   4.0958959E-08
     +,   4.5464148E-08,   5.0415863E-08,   5.5852620E-08
     +,   6.1815825E-08,   6.8349244E-08,   7.5500061E-08
     +,   8.3318461E-08,   9.1857466E-08,   1.0117378E-07
     +,   1.1132769E-07,   1.2238232E-07,   1.3440510E-07
     +,   1.4746719E-07,   1.6164289E-07,   1.7701115E-07
     +,   1.9365493E-07,   2.1166026E-07,   2.3111818E-07
     +,   2.5212387E-07,   2.7477554E-07,   2.9917666E-07
     +,   3.2543471E-07,   3.5365983E-07,   3.8396746E-07
     +,   4.1647641E-07,   4.5131003E-07,   4.8859306E-07
     +,   5.2845644E-07,   5.7103045E-07,   6.1645403E-07
     +,   6.6486399E-07,   7.1639863E-07,   7.7120484E-07
     +,   8.2942495E-07,   8.9120198E-07,   9.5668747E-07
     +,   1.0260259E-06,   1.0993604E-06,   1.1768431E-06
     +,   1.2586127E-06,   1.3448181E-06,   1.4355977E-06
     +,   1.5310875E-06,   1.6314176E-06,   1.7367248E-06
     +,   1.8471291E-06,   1.9627437E-06,   2.0836890E-06
     +,   2.2100635E-06,   2.3419577E-06,   2.4794681E-06
     +,   2.6226603E-06,   2.7716114E-06,   2.9263704E-06
     +,   3.0869794E-06,   3.2534610E-06,   3.4258446E-06
     +,   3.6041167E-06,   3.7882792E-06,   3.9782958E-06
     +,   4.1741223E-06,   4.3756872E-06,   4.5829279E-06
     +,   4.7957342E-06,   5.0140056E-06,   5.2376045E-06
     +,   5.4663797E-06,   5.7001548E-06,   5.9387621E-06
     +,   6.1819787E-06,   6.4296014E-06,   6.6813841E-06
     +,   6.9370617E-06,   7.1963791E-06,   7.4590344E-06
     +,   7.7247460E-06,   7.9931897E-06,   8.2640408E-06
     +,   8.5369547E-06,   8.8116067E-06,   9.0876356E-06
     +,   9.3646750E-06,   9.6423873E-06,   9.9204026E-06
     +,   1.0198352E-05,   1.0475906E-05,   1.0752695E-05
     +,   1.1028406E-05,   1.1302710E-05,   1.1575298E-05
     +,   1.1845875E-05,   1.2114202E-05,   1.2380020E-05
     +,   1.2643149E-05,   1.2903406E-05,   1.3160647E-05
     +,   1.3414803E-05,   1.3665815E-05,   1.3913671E-05
     +,   1.4158444E-05,   1.4400226E-05,   1.4639168E-05
     +,   1.4875505E-05,   1.5109504E-05,   1.5341491E-05
     +,   1.5571883E-05,   1.5801126E-05,   1.6029742E-05
     +,   1.6258295E-05,   1.6487436E-05,   1.6717830E-05
     +,   1.6950225E-05,   1.7185388E-05,   1.7424129E-05
     +,   1.7667277E-05,   1.7915707E-05,   1.8170300E-05
     +,   1.8431923E-05,   1.8701441E-05,   1.8979701E-05
     +,   1.9267511E-05,   1.9565648E-05,   1.9874849E-05
     +,   2.0195745E-05,   2.0528920E-05,   2.0874848E-05
     +,   2.1233951E-05,   2.1606567E-05,   2.1992921E-05
     +,   2.2393191E-05,   2.2807524E-05,   2.3236042E-05
     +,   2.3678995E-05,   2.4136696E-05,   2.4609793E-05
     +,   2.5099274E-05,   2.5606729E-05,   2.6134549E-05
     +,   2.6686221E-05,   2.7266700E-05,   2.7882819E-05
     +,   2.8543720E-05,   2.9261477E-05,   3.0051726E-05
     +,   3.0934476E-05,   3.1934887E-05,   3.3084096E-05
     +,   3.4420271E-05,   3.5989644E-05,   3.7847491E-05
     +,   4.0059542E-05,   4.2702995E-05,   4.5867666E-05
     +,   4.9657490E-05,   5.4191885E-05,   5.9607151E-05
     +,   6.6058732E-05,   7.3722949E-05,   8.2798309E-05
     +,   9.3508403E-05,   1.0610286E-04,   1.2086045E-04
     +,   1.3808905E-04,   1.5812367E-04,   1.8132580E-04
     +,   2.0807954E-04,   2.3878399E-04,   2.7385194E-04
     +,   3.1369252E-04,   3.5871411E-04,   4.0930524E-04
     +,   4.6583207E-04,   5.2862428E-04,   5.9795874E-04
     +,   6.7404920E-04,   7.5702649E-04,   8.4693229E-04
     +,   9.4377011E-04,   1.0476175E-03,   1.1588752E-03
     +,   1.2785996E-03,   1.4089851E-03,   1.5537431E-03
     +,   1.7182700E-03,   1.9092181E-03,   2.1333066E-03
     +,   2.3952622E-03,   2.6952703E-03,   3.0268026E-03
     +,   3.3758536E-03,   3.7226568E-03,   4.0462888E-03
     +,   4.3312521E-03,   4.5740488E-03,   4.7867047E-03
     +,   4.9943747E-03,   5.2264379E-03,   5.5040414E-03
     +,   5.8311792E-03,   6.1967219E-03,   6.5883393E-03
     +,   7.0087141E-03,   7.4778865E-03,   8.0149490E-03
     +,   8.6132511E-03,   9.2325751E-03,   9.8162154E-03
     +,   1.0313923E-02,   1.0689683E-02,   1.0917232E-02
     +,   1.0982723E-02,   1.0902379E-02,   1.0743352E-02
     +,   1.0627457E-02,   1.0696949E-02,   1.1034373E-02
     +,   1.1580598E-02,   1.2149556E-02,   1.2584399E-02
     +,   1.2931064E-02,   1.3421511E-02,   1.4236726E-02
     +,   1.5298925E-02,   1.6368344E-02,   1.7377427E-02
     +,   1.8560907E-02,   2.0083189E-02,   2.1564886E-02
     +,   2.2252863E-02,   2.1808730E-02,   2.0768445E-02
     +,   2.0098861E-02,   2.0375723E-02,   2.1416755E-02
     +,   2.2583833E-02,   2.3289297E-02,   2.3241632E-02
     +,   2.2419319E-02,   2.0952323E-02,   1.9038389E-02
     +,   1.6912464E-02,   1.4790767E-02,   1.2799780E-02
     +,   1.0978386E-02,   9.3275141E-03,   7.8330711E-03
     +,   6.4748451E-03,   5.2437354E-03,   4.1496297E-03
     +,   3.2080223E-03,   2.4232403E-03,   1.7857200E-03
     +,   1.2786821E-03,   8.8487432E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wao_fus_105 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wao_fus_107(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  1.4554961E-10,   1.6701125E-10
     +,   1.9147170E-10,   2.1932281E-10,   2.5100663E-10
     +,   2.8701902E-10,   3.2791153E-10,   3.7430442E-10
     +,   4.2689063E-10,   4.8644055E-10,   5.5381566E-10
     +,   6.2997463E-10,   7.1598588E-10,   8.1303170E-10
     +,   9.2242902E-10,   1.0456401E-09,   1.1842758E-09
     +,   1.3401288E-09,   1.5151781E-09,   1.7116036E-09
     +,   1.9318132E-09,   2.1784674E-09,   2.4544786E-09
     +,   2.7630602E-09,   3.1077476E-09,   3.4923928E-09
     +,   3.9212456E-09,   4.3989528E-09,   4.9305733E-09
     +,   5.5216454E-09,   6.1782393E-09,   6.9069017E-09
     +,   7.7148199E-09,   8.6098071E-09,   9.6002841E-09
     +,   1.0695453E-08,   1.1905264E-08,   1.3240450E-08
     +,   1.4712647E-08,   1.6334427E-08,   1.8119335E-08
     +,   2.0081908E-08,   2.2237856E-08,   2.4604006E-08
     +,   2.7198523E-08,   3.0040642E-08,   3.3151249E-08
     +,   3.6552393E-08,   4.0267803E-08,   4.4322697E-08
     +,   4.8744077E-08,   5.3560349E-08,   5.8802026E-08
     +,   6.4501357E-08,   7.0692323E-08,   7.7411130E-08
     +,   8.4696026E-08,   9.2587086E-08,   1.0112679E-07
     +,   1.1035991E-07,   1.2033311E-07,   1.3109562E-07
     +,   1.4269934E-07,   1.5519753E-07,   1.6864688E-07
     +,   1.8310624E-07,   1.9863626E-07,   2.1530069E-07
     +,   2.3316578E-07,   2.5229929E-07,   2.7277230E-07
     +,   2.9465753E-07,   3.1803071E-07,   3.4296852E-07
     +,   3.6955146E-07,   3.9785917E-07,   4.2797734E-07
     +,   4.5999019E-07,   4.9398307E-07,   5.3004658E-07
     +,   5.6826923E-07,   6.0873987E-07,   6.5155342E-07
     +,   6.9680004E-07,   7.4457034E-07,   7.9496152E-07
     +,   8.4806157E-07,   9.0396753E-07,   9.6276881E-07
     +,   1.0245557E-06,   1.0894154E-06,   1.1574407E-06
     +,   1.2287150E-06,   1.3033184E-06,   1.3813382E-06
     +,   1.4628487E-06,   1.5479213E-06,   1.6366336E-06
     +,   1.7290445E-06,   1.8252236E-06,   1.9252248E-06
     +,   2.0290993E-06,   2.1368901E-06,   2.2486456E-06
     +,   2.3643915E-06,   2.4841650E-06,   2.6079822E-06
     +,   2.7358574E-06,   2.8677919E-06,   3.0037959E-06
     +,   3.1438492E-06,   3.2879475E-06,   3.4360612E-06
     +,   3.5881581E-06,   3.7441928E-06,   3.9041297E-06
     +,   4.0679015E-06,   4.2354577E-06,   4.4067228E-06
     +,   4.5816137E-06,   4.7600602E-06,   4.9419609E-06
     +,   5.1272341E-06,   5.3157764E-06,   5.5074847E-06
     +,   5.7022485E-06,   5.8999749E-06,   6.1005521E-06
     +,   6.3038669E-06,   6.5098334E-06,   6.7183469E-06
     +,   6.9293078E-06,   7.1426521E-06,   7.3582905E-06
     +,   7.5761845E-06,   7.7962850E-06,   8.0185710E-06
     +,   8.2430333E-06,   8.4697194E-06,   8.6986665E-06
     +,   8.9299847E-06,   9.1637921E-06,   9.4002498E-06
     +,   9.6395897E-06,   9.8820701E-06,   1.0127999E-05
     +,   1.0377778E-05,   1.0631839E-05,   1.0890684E-05
     +,   1.1154914E-05,   1.1425181E-05,   1.1702209E-05
     +,   1.1986839E-05,   1.2279967E-05,   1.2582585E-05
     +,   1.2895757E-05,   1.3220671E-05,   1.3558557E-05
     +,   1.3910776E-05,   1.4278729E-05,   1.4663911E-05
     +,   1.5067873E-05,   1.5492255E-05,   1.5938760E-05
     +,   1.6409102E-05,   1.6905053E-05,   1.7428412E-05
     +,   1.7980978E-05,   1.8564593E-05,   1.9181118E-05
     +,   1.9832352E-05,   2.0520114E-05,   2.1246187E-05
     +,   2.2012398E-05,   2.2820594E-05,   2.3672577E-05
     +,   2.4570214E-05,   2.5515457E-05,   2.6510312E-05
     +,   2.7557067E-05,   2.8658051E-05,   2.9816032E-05
     +,   3.1033982E-05,   3.2315333E-05,   3.3663993E-05
     +,   3.5084406E-05,   3.6581790E-05,   3.8162150E-05
     +,   3.9832245E-05,   4.1599942E-05,   4.3474178E-05
     +,   4.5465436E-05,   4.7585883E-05,   4.9849510E-05
     +,   5.2272811E-05,   5.4875338E-05,   5.7680292E-05
     +,   6.0715753E-05,   6.4015665E-05,   6.7620829E-05
     +,   7.1580827E-05,   7.5955701E-05,   8.0817626E-05
     +,   8.6253771E-05,   9.2368529E-05,   9.9285797E-05
     +,   1.0715319E-04,   1.1614551E-04,   1.2647084E-04
     +,   1.3837624E-04,   1.5215379E-04,   1.6814939E-04
     +,   1.8677003E-04,   2.0848938E-04,   2.3385428E-04
     +,   2.6347797E-04,   2.9804138E-04,   3.3827443E-04
     +,   3.8494394E-04,   4.3883812E-04,   5.0074933E-04
     +,   5.7148049E-04,   6.5185322E-04,   7.4273377E-04
     +,   8.4510015E-04,   9.6012239E-04,   1.0892964E-03
     +,   1.2345276E-03,   1.3982429E-03,   1.5832747E-03
     +,   1.7925495E-03,   2.0283591E-03,   2.2913185E-03
     +,   2.5791135E-03,   2.8854616E-03,   3.1999282E-03
     +,   3.5089923E-03,   3.7985542E-03,   4.0575950E-03
     +,   4.2819101E-03,   4.4765468E-03,   4.6555935E-03
     +,   4.8383544E-03,   5.0424817E-03,   5.2761901E-03
     +,   5.5329953E-03,   5.7922611E-03,   6.0263867E-03
     +,   6.2126033E-03,   6.3437717E-03,   6.4323745E-03
     +,   6.5049790E-03,   6.5898239E-03,   6.7052646E-03
     +,   6.8573607E-03,   7.0496439E-03,   7.2993403E-03
     +,   7.6468573E-03,   8.1447698E-03,   8.8229319E-03
     +,   9.6451091E-03,   1.0489115E-02,   1.1178355E-02
     +,   1.1559992E-02,   1.1587468E-02,   1.1353777E-02
     +,   1.1051401E-02,   1.0881606E-02,   1.0966741E-02
     +,   1.1316472E-02,   1.1862701E-02,   1.2529822E-02
     +,   1.3281579E-02,   1.4107672E-02,   1.4972203E-02
     +,   1.5791388E-02,   1.6474796E-02,   1.6970979E-02
     +,   1.7253062E-02,   1.7296543E-02,   1.7130671E-02
     +,   1.6907815E-02,   1.6872790E-02,   1.7238468E-02
     +,   1.8059516E-02,   1.9164139E-02,   2.0218482E-02
     +,   2.0968307E-02,   2.1446109E-02,   2.1838365E-02
     +,   2.2112617E-02,   2.1873791E-02,   2.0666691E-02
     +,   1.8386979E-02,   1.5360272E-02,   1.2086923E-02
     +,   8.9806188E-03,   6.2900567E-03,   4.1357046E-03
     +,   2.5435432E-03,   1.4620018E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wao_fus_107 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wao_fus_110(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  7.6865153E-11,   8.9430838E-11
     +,   1.0395303E-10,   1.2071923E-10,   1.4005776E-10
     +,   1.6234164E-10,   1.8799326E-10,   2.1749332E-10
     +,   2.5138644E-10,   2.9028702E-10,   3.3489189E-10
     +,   3.8598719E-10,   4.4446083E-10,   5.1130927E-10
     +,   5.8765948E-10,   6.7477623E-10,   7.7407675E-10
     +,   8.8715546E-10,   1.0158001E-09,   1.1620012E-09
     +,   1.3279953E-09,   1.5162787E-09,   1.7296258E-09
     +,   1.9711348E-09,   2.2442610E-09,   2.5528237E-09
     +,   2.9010823E-09,   3.2937575E-09,   3.7360603E-09
     +,   4.2337756E-09,   4.7933022E-09,   5.4216605E-09
     +,   6.1266254E-09,   6.9167698E-09,   7.8014688E-09
     +,   8.7910568E-09,   9.8968860E-09,   1.1131329E-08
     +,   1.2507987E-08,   1.4041702E-08,   1.5748711E-08
     +,   1.7646622E-08,   1.9754678E-08,   2.2093797E-08
     +,   2.4686749E-08,   2.7558062E-08,   3.0734522E-08
     +,   3.4244874E-08,   3.8120358E-08,   4.2394610E-08
     +,   4.7103942E-08,   5.2287238E-08,   5.7986419E-08
     +,   6.4246585E-08,   7.1115714E-08,   7.8645378E-08
     +,   8.6890978E-08,   9.5910806E-08,   1.0576771E-07
     +,   1.1652845E-07,   1.2826335E-07,   1.4104776E-07
     +,   1.5496128E-07,   1.7008747E-07,   1.8651515E-07
     +,   2.0433833E-07,   2.2365447E-07,   2.4456739E-07
     +,   2.6718575E-07,   2.9162209E-07,   3.1799541E-07
     +,   3.4642935E-07,   3.7705325E-07,   4.0999973E-07
     +,   4.4540886E-07,   4.8342213E-07,   5.2419114E-07
     +,   5.6786746E-07,   6.1460656E-07,   6.6457392E-07
     +,   7.1793346E-07,   7.7485197E-07,   8.3550680E-07
     +,   9.0007120E-07,   9.6872054E-07,   1.0416402E-06
     +,   1.1190066E-06,   1.2010087E-06,   1.2878270E-06
     +,   1.3796454E-06,   1.4766433E-06,   1.5790100E-06
     +,   1.6869228E-06,   1.8005550E-06,   1.9200907E-06
     +,   2.0456976E-06,   2.1775384E-06,   2.3157868E-06
     +,   2.4605906E-06,   2.6121133E-06,   2.7704978E-06
     +,   2.9358846E-06,   3.1084026E-06,   3.2881937E-06
     +,   3.4753677E-06,   3.6700562E-06,   3.8723633E-06
     +,   4.0823975E-06,   4.3002524E-06,   4.5260463E-06
     +,   4.7598587E-06,   5.0018089E-06,   5.2519867E-06
     +,   5.5104974E-06,   5.7774400E-06,   6.0529551E-06
     +,   6.3371517E-06,   6.6301968E-06,   6.9322414E-06
     +,   7.2434600E-06,   7.5640846E-06,   7.8943303E-06
     +,   8.2344959E-06,   8.5848742E-06,   8.9458181E-06
     +,   9.3177077E-06,   9.7010152E-06,   1.0096224E-05
     +,   1.0503871E-05,   1.0924598E-05,   1.1359057E-05
     +,   1.1807965E-05,   1.2272156E-05,   1.2752447E-05
     +,   1.3249797E-05,   1.3765167E-05,   1.4299590E-05
     +,   1.4854128E-05,   1.5429954E-05,   1.6028191E-05
     +,   1.6650079E-05,   1.7296807E-05,   1.7969571E-05
     +,   1.8669623E-05,   1.9398138E-05,   2.0156223E-05
     +,   2.0945039E-05,   2.1765578E-05,   2.2618735E-05
     +,   2.3505398E-05,   2.4426225E-05,   2.5381718E-05
     +,   2.6372338E-05,   2.7398239E-05,   2.8459412E-05
     +,   2.9555604E-05,   3.0686460E-05,   3.1851207E-05
     +,   3.3049037E-05,   3.4278735E-05,   3.5538891E-05
     +,   3.6827816E-05,   3.8143684E-05,   3.9484446E-05
     +,   4.0847746E-05,   4.2231106E-05,   4.3631873E-05
     +,   4.5047214E-05,   4.6474317E-05,   4.7910286E-05
     +,   4.9352097E-05,   5.0796803E-05,   5.2241438E-05
     +,   5.3683249E-05,   5.5119632E-05,   5.6548026E-05
     +,   5.7966157E-05,   5.9371960E-05,   6.0763614E-05
     +,   6.2139748E-05,   6.3499036E-05,   6.4840693E-05
     +,   6.6164044E-05,   6.7468740E-05,   6.8754678E-05
     +,   7.0021866E-05,   7.1270602E-05,   7.2501331E-05
     +,   7.3714466E-05,   7.4910662E-05,   7.6090742E-05
     +,   7.7256082E-05,   7.8408913E-05,   7.9552905E-05
     +,   8.0694212E-05,   8.1843107E-05,   8.3015984E-05
     +,   8.4238585E-05,   8.5550062E-05,   8.7008208E-05
     +,   8.8696441E-05,   9.0732210E-05,   9.3276649E-05
     +,   9.6546217E-05,   1.0082451E-04,   1.0647360E-04
     +,   1.1394501E-04,   1.2378575E-04,   1.3664125E-04
     +,   1.5324823E-04,   1.7441688E-04,   2.0100412E-04
     +,   2.3387434E-04,   2.7385130E-04,   3.2167707E-04
     +,   3.7796353E-04,   4.4319319E-04,   5.1772944E-04
     +,   6.0189725E-04,   6.9610437E-04,   8.0099289E-04
     +,   9.1760606E-04,   1.0474731E-03,   1.1925646E-03
     +,   1.3550823E-03,   1.5370331E-03,   1.7397213E-03
     +,   1.9632068E-03,   2.2061686E-03,   2.4661510E-03
     +,   2.7404435E-03,   3.0272319E-03,   3.3265147E-03
     +,   3.6400019E-03,   3.9695534E-03,   4.3145325E-03
     +,   4.6691312E-03,   5.0214906E-03,   5.3558182E-03
     +,   5.6571863E-03,   5.9171929E-03,   6.1385557E-03
     +,   6.3374550E-03,   6.5437625E-03,   6.7981896E-03
     +,   7.1444176E-03,   7.6152273E-03,   8.2165627E-03
     +,   8.9191319E-03,   9.6660350E-03,   1.0395206E-02
     +,   1.1064389E-02,   1.1661003E-02,   1.2194032E-02
     +,   1.2679499E-02,   1.3128318E-02,   1.3530634E-02
     +,   1.3838329E-02,   1.3973556E-02,   1.3878746E-02
     +,   1.3573542E-02,   1.3167188E-02,   1.2816478E-02
     +,   1.2659010E-02,   1.2753334E-02,   1.3050307E-02
     +,   1.3418336E-02,   1.3712056E-02,   1.3832275E-02
     +,   1.3743107E-02,   1.3476068E-02,   1.3149339E-02
     +,   1.2960121E-02,   1.3094706E-02,   1.3591928E-02
     +,   1.4279546E-02,   1.4858595E-02,   1.5076085E-02
     +,   1.4851094E-02,   1.4275067E-02,   1.3519305E-02
     +,   1.2740867E-02,   1.2051984E-02,   1.1536574E-02
     +,   1.1252788E-02,   1.1198914E-02,   1.1284571E-02
     +,   1.1352169E-02,   1.1243043E-02,   1.0865165E-02
     +,   1.0222385E-02,   9.3923369E-03,   8.4716482E-03
     +,   7.5270082E-03,   6.5802974E-03,   5.6282906E-03
     +,   4.6728677E-03,   3.7374720E-03,   2.8637070E-03
     +,   2.0949703E-03,   1.4611065E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wao_fus_110 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wao_fus_115(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  1.3485520E-10,   1.5590680E-10
     +,   1.8007248E-10,   2.0778465E-10,   2.3953209E-10
     +,   2.7586650E-10,   3.1740779E-10,   3.6485534E-10
     +,   4.1899545E-10,   4.8070831E-10,   5.5098243E-10
     +,   6.3092531E-10,   7.2177936E-10,   8.2492313E-10
     +,   9.4190500E-10,   1.0744496E-09,   1.2244707E-09
     +,   1.3941031E-09,   1.5857227E-09,   1.8019489E-09
     +,   2.0457018E-09,   2.3202114E-09,   2.6290312E-09
     +,   2.9761094E-09,   3.3657888E-09,   3.8028412E-09
     +,   4.2925410E-09,   4.8406679E-09,   5.4535585E-09
     +,   6.1381709E-09,   6.9021304E-09,   7.7537345E-09
     +,   8.7020755E-09,   9.7570920E-09,   1.0929520E-08
     +,   1.2231110E-08,   1.3674653E-08,   1.5273907E-08
     +,   1.7043874E-08,   1.9000746E-08,   2.1162082E-08
     +,   2.3546679E-08,   2.6174908E-08,   2.9068673E-08
     +,   3.2251510E-08,   3.5748581E-08,   3.9587000E-08
     +,   4.3795524E-08,   4.8405141E-08,   5.3448751E-08
     +,   5.8961543E-08,   6.4980568E-08,   7.1545557E-08
     +,   7.8698577E-08,   8.6483780E-08,   9.4948206E-08
     +,   1.0414156E-07,   1.1411559E-07,   1.2492525E-07
     +,   1.3662826E-07,   1.4928436E-07,   1.6295688E-07
     +,   1.7771177E-07,   1.9361676E-07,   2.1074358E-07
     +,   2.2916636E-07,   2.4896076E-07,   2.7020619E-07
     +,   2.9298457E-07,   3.1737872E-07,   3.4347522E-07
     +,   3.7136181E-07,   4.0112894E-07,   4.3286698E-07
     +,   4.6667017E-07,   5.0263026E-07,   5.4084501E-07
     +,   5.8140859E-07,   6.2441455E-07,   6.6996228E-07
     +,   7.1814469E-07,   7.6905377E-07,   8.2278632E-07
     +,   8.7943084E-07,   9.3907340E-07,   1.0018044E-06
     +,   1.0677007E-06,   1.1368458E-06,   1.2093109E-06
     +,   1.2851643E-06,   1.3644660E-06,   1.4472787E-06
     +,   1.5336490E-06,   1.6236148E-06,   1.7172183E-06
     +,   1.8144805E-06,   1.9154131E-06,   2.0200309E-06
     +,   2.1283201E-06,   2.2402739E-06,   2.3558612E-06
     +,   2.4750418E-06,   2.5977597E-06,   2.7239589E-06
     +,   2.8535512E-06,   2.9864550E-06,   3.1225588E-06
     +,   3.2617418E-06,   3.4038633E-06,   3.5487856E-06
     +,   3.6963331E-06,   3.8463377E-06,   3.9986016E-06
     +,   4.1529161E-06,   4.3090540E-06,   4.4667909E-06
     +,   4.6258669E-06,   4.7860312E-06,   4.9470050E-06
     +,   5.1084949E-06,   5.2702158E-06,   5.4318489E-06
     +,   5.5930900E-06,   5.7536090E-06,   5.9130721E-06
     +,   6.0711359E-06,   6.2274680E-06,   6.3817147E-06
     +,   6.5335203E-06,   6.6825442E-06,   6.8284285E-06
     +,   6.9708180E-06,   7.1093741E-06,   7.2437429E-06
     +,   7.3735973E-06,   7.4985987E-06,   7.6184260E-06
     +,   7.7327595E-06,   7.8413059E-06,   7.9437677E-06
     +,   8.0398768E-06,   8.1293665E-06,   8.2119896E-06
     +,   8.2875267E-06,   8.3557679E-06,   8.4165204E-06
     +,   8.4696203E-06,   8.5149277E-06,   8.5523152E-06
     +,   8.5816901E-06,   8.6029831E-06,   8.6161508E-06
     +,   8.6211803E-06,   8.6180880E-06,   8.6069231E-06
     +,   8.5877682E-06,   8.5607462E-06,   8.5260162E-06
     +,   8.4837766E-06,   8.4342846E-06,   8.3778395E-06
     +,   8.3148007E-06,   8.2455917E-06,   8.1706994E-06
     +,   8.0906993E-06,   8.0062482E-06,   7.9181045E-06
     +,   7.8271369E-06,   7.7343275E-06,   7.6407996E-06
     +,   7.5478333E-06,   7.4568761E-06,   7.3695646E-06
     +,   7.2877447E-06,   7.2134940E-06,   7.1491636E-06
     +,   7.0973974E-06,   7.0611800E-06,   7.0438782E-06
     +,   7.0493015E-06,   7.0817782E-06,   7.1462391E-06
     +,   7.2483290E-06,   7.3945403E-06,   7.5923836E-06
     +,   7.8505691E-06,   8.1792914E-06,   8.5905012E-06
     +,   9.0982039E-06,   9.7189013E-06,   1.0471984E-05
     +,   1.1380316E-05,   1.2470767E-05,   1.3774721E-05
     +,   1.5328871E-05,   1.7175927E-05,   1.9365403E-05
     +,   2.1954864E-05,   2.5011101E-05,   2.8611410E-05
     +,   3.2845950E-05,   3.7820275E-05,   4.3658489E-05
     +,   5.0508184E-05,   5.8545349E-05,   6.7979672E-05
     +,   7.9062054E-05,   9.2090726E-05,   1.0741941E-04
     +,   1.2546296E-04,   1.4670088E-04,   1.7168387E-04
     +,   2.0103807E-04,   2.3547045E-04,   2.7578525E-04
     +,   3.2289178E-04,   3.7784179E-04,   4.4185037E-04
     +,   5.1633723E-04,   6.0295325E-04,   7.0358545E-04
     +,   8.2033529E-04,   9.5542136E-04,   1.1109803E-03
     +,   1.2887713E-03,   1.4897096E-03,   1.7133112E-03
     +,   1.9570221E-03,   2.2158644E-03,   2.4825165E-03
     +,   2.7484305E-03,   3.0060024E-03,   3.2515421E-03
     +,   3.4879376E-03,   3.7256430E-03,   3.9809295E-03
     +,   4.2713471E-03,   4.6100891E-03,   5.0018691E-03
     +,   5.4424126E-03,   5.9219450E-03,   6.4308825E-03
     +,   6.9637801E-03,   7.5181853E-03,   8.0873398E-03
     +,   8.6506987E-03,   9.1686221E-03,   9.5855687E-03
     +,   9.8432563E-03,   9.9028219E-03,   9.7725149E-03
     +,   9.5286854E-03,   9.3103601E-03,   9.2798229E-03
     +,   9.5649781E-03,   1.0206222E-02,   1.1120049E-02
     +,   1.2093519E-02,   1.2839199E-02,   1.3120961E-02
     +,   1.2888397E-02,   1.2313568E-02,   1.1687480E-02
     +,   1.1257220E-02,   1.1125096E-02,   1.1252711E-02
     +,   1.1525293E-02,   1.1823399E-02,   1.2076802E-02
     +,   1.2283183E-02,   1.2485250E-02,   1.2730081E-02
     +,   1.3038514E-02,   1.3383565E-02,   1.3677969E-02
     +,   1.3799626E-02,   1.3660286E-02,   1.3261228E-02
     +,   1.2685722E-02,   1.2053734E-02,   1.1494388E-02
     +,   1.1140376E-02,   1.1103760E-02,   1.1414795E-02
     +,   1.1963480E-02,   1.2505588E-02,   1.2754537E-02
     +,   1.2509298E-02,   1.1730276E-02,   1.0521139E-02
     +,   9.0534482E-03,   7.5002979E-03,   6.0049691E-03
     +,   4.6717166E-03,   3.5601971E-03,   2.6846109E-03
     +,   2.0228061E-03,   1.5330252E-03,   1.1708387E-03
     +,   8.9900655E-04,   6.9054920E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wao_fus_115 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wao_fus_120(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  1.0897004E-08,   1.2221479E-08
     +,   1.3693433E-08,   1.5327482E-08,   1.7139561E-08
     +,   1.9146993E-08,   2.1368349E-08,   2.3823866E-08
     +,   2.6535350E-08,   2.9526211E-08,   3.2821688E-08
     +,   3.6448949E-08,   4.0437161E-08,   4.4817348E-08
     +,   4.9622926E-08,   5.4889608E-08,   6.0655161E-08
     +,   6.6960105E-08,   7.3847538E-08,   8.1362785E-08
     +,   8.9554298E-08,   9.8473279E-08,   1.0817336E-07
     +,   1.1871154E-07,   1.3014792E-07,   1.4254476E-07
     +,   1.5596817E-07,   1.7048743E-07,   1.8617381E-07
     +,   2.0310264E-07,   2.2135228E-07,   2.4100299E-07
     +,   2.6213903E-07,   2.8484718E-07,   3.0921638E-07
     +,   3.3533888E-07,   3.6330931E-07,   3.9322333E-07
     +,   4.2517991E-07,   4.5927928E-07,   4.9562414E-07
     +,   5.3431586E-07,   5.7545913E-07,   6.1915802E-07
     +,   6.6551814E-07,   7.1464194E-07,   7.6663434E-07
     +,   8.2159590E-07,   8.7962798E-07,   9.4082839E-07
     +,   1.0052943E-06,   1.0731150E-06,   1.1443790E-06
     +,   1.2191716E-06,   1.2975676E-06,   1.3796405E-06
     +,   1.4654574E-06,   1.5550725E-06,   1.6485376E-06
     +,   1.7458964E-06,   1.8471762E-06,   1.9524005E-06
     +,   2.0615830E-06,   2.1747185E-06,   2.2917973E-06
     +,   2.4127960E-06,   2.5376714E-06,   2.6663745E-06
     +,   2.7988408E-06,   2.9349840E-06,   3.0747105E-06
     +,   3.2179089E-06,   3.3644549E-06,   3.5141989E-06
     +,   3.6669869E-06,   3.8226358E-06,   3.9809652E-06
     +,   4.1417616E-06,   4.3047949E-06,   4.4698400E-06
     +,   4.6366340E-06,   4.8049046E-06,   4.9743803E-06
     +,   5.1447587E-06,   5.3157237E-06,   5.4869693E-06
     +,   5.6581484E-06,   5.8289338E-06,   5.9989684E-06
     +,   6.1678938E-06,   6.3353391E-06,   6.5009494E-06
     +,   6.6643438E-06,   6.8251434E-06,   6.9829825E-06
     +,   7.1374852E-06,   7.2882704E-06,   7.4349864E-06
     +,   7.5772591E-06,   7.7147461E-06,   7.8471003E-06
     +,   7.9739903E-06,   8.0950913E-06,   8.2101087E-06
     +,   8.3187469E-06,   8.4207441E-06,   8.5158445E-06
     +,   8.6038181E-06,   8.6844584E-06,   8.7575854E-06
     +,   8.8230363E-06,   8.8806846E-06,   8.9304222E-06
     +,   8.9721734E-06,   9.0058884E-06,   9.0315534E-06
     +,   9.0491785E-06,   9.0588092E-06,   9.0605172E-06
     +,   9.0544099E-06,   9.0406229E-06,   9.0193280E-06
     +,   8.9907198E-06,   8.9550294E-06,   8.9125124E-06
     +,   8.8634642E-06,   8.8081970E-06,   8.7470535E-06
     +,   8.6804066E-06,   8.6086484E-06,   8.5321972E-06
     +,   8.4514986E-06,   8.3670056E-06,   8.2792021E-06
     +,   8.1885801E-06,   8.0956534E-06,   8.0009422E-06
     +,   7.9049869E-06,   7.8083212E-06,   7.7115037E-06
     +,   7.6150773E-06,   7.5196021E-06,   7.4256395E-06
     +,   7.3337355E-06,   7.2444427E-06,   7.1583086E-06
     +,   7.0758647E-06,   6.9976436E-06,   6.9241669E-06
     +,   6.8559407E-06,   6.7934670E-06,   6.7372393E-06
     +,   6.6877351E-06,   6.6454331E-06,   6.6108055E-06
     +,   6.5843283E-06,   6.5664735E-06,   6.5577356E-06
     +,   6.5586214E-06,   6.5696668E-06,   6.5914537E-06
     +,   6.6246030E-06,   6.6698162E-06,   6.7278711E-06
     +,   6.7996502E-06,   6.8861596E-06,   6.9885482E-06
     +,   7.1081331E-06,   7.2464354E-06,   7.4052077E-06
     +,   7.5864382E-06,   7.7924096E-06,   8.0257005E-06
     +,   8.2892520E-06,   8.5863712E-06,   8.9207388E-06
     +,   9.2964592E-06,   9.7180628E-06,   1.0190505E-05
     +,   1.0719249E-05,   1.1310127E-05,   1.1969515E-05
     +,   1.2704157E-05,   1.3521256E-05,   1.4428446E-05
     +,   1.5433743E-05,   1.6545677E-05,   1.7773278E-05
     +,   1.9126004E-05,   2.0614005E-05,   2.2248167E-05
     +,   2.4040510E-05,   2.6004414E-05,   2.8154836E-05
     +,   3.0509007E-05,   3.3086966E-05,   3.5912137E-05
     +,   3.9012390E-05,   4.2420765E-05,   4.6176046E-05
     +,   5.0324088E-05,   5.4918637E-05,   6.0022267E-05
     +,   6.5708067E-05,   7.2060815E-05,   7.9178448E-05
     +,   8.7175220E-05,   9.6185082E-05,   1.0636794E-04
     +,   1.1791695E-04,   1.3106770E-04,   1.4611325E-04
     +,   1.6342130E-04,   1.8345429E-04,   2.0679645E-04
     +,   2.3417138E-04,   2.6646911E-04,   3.0474708E-04
     +,   3.5022345E-04,   4.0423768E-04,   4.6817481E-04
     +,   5.4336915E-04,   6.3098036E-04,   7.3188619E-04
     +,   8.4666192E-04,   9.7568677E-04,   1.1194585E-03
     +,   1.2790274E-03,   1.4565631E-03,   1.6556461E-03
     +,   1.8810991E-03,   2.1379506E-03,   2.4296083E-03
     +,   2.7555984E-03,   3.1099243E-03,   3.4813213E-03
     +,   3.8558980E-03,   4.2215083E-03,   4.5716325E-03
     +,   4.9061123E-03,   5.2279020E-03,   5.5379034E-03
     +,   5.8319285E-03,   6.1025918E-03,   6.3445363E-03
     +,   6.5580723E-03,   6.7473897E-03,   6.9156145E-03
     +,   7.0640771E-03,   7.2001149E-03,   7.3481700E-03
     +,   7.5519476E-03,   7.8595076E-03,   8.2963593E-03
     +,   8.8411951E-03,   9.4192466E-03,   9.9235848E-03
     +,   1.0262201E-02,   1.0406187E-02,   1.0399097E-02
     +,   1.0315156E-02,   1.0209369E-02,   1.0111037E-02
     +,   1.0049528E-02,   1.0054238E-02,   1.0117176E-02
     +,   1.0181963E-02,   1.0201256E-02,   1.0204543E-02
     +,   1.0287531E-02,   1.0525763E-02,   1.0904158E-02
     +,   1.1327622E-02,   1.1684505E-02,   1.1891244E-02
     +,   1.1892032E-02,   1.1653066E-02,   1.1189760E-02
     +,   1.0598410E-02,   1.0033317E-02,   9.6292775E-03
     +,   9.4345072E-03,   9.4034858E-03,   9.4357794E-03
     +,   9.4244741E-03,   9.2962710E-03,   9.0349559E-03
     +,   8.6761480E-03,   8.2718292E-03,   7.8484360E-03
     +,   7.3899101E-03,   6.8552927E-03,   6.2117754E-03
     +,   5.4582600E-03,   4.6277107E-03,   3.7740683E-03
     +,   2.9550979E-03,   2.2186618E-03,   1.5958627E-03
     +,   1.0991339E-03,   7.2474376E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wao_fus_120 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wao_fus_60(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  1.0437333E-05,   1.0956282E-05
     +,   1.1495503E-05,   1.2055809E-05,   1.2638109E-05
     +,   1.3243389E-05,   1.3872654E-05,   1.4527031E-05
     +,   1.5207714E-05,   1.5915937E-05,   1.6653048E-05
     +,   1.7420463E-05,   1.8219680E-05,   1.9052231E-05
     +,   1.9919760E-05,   2.0823985E-05,   2.1766631E-05
     +,   2.2749527E-05,   2.3774561E-05,   2.4843594E-05
     +,   2.5958574E-05,   2.7121481E-05,   2.8334234E-05
     +,   2.9598807E-05,   3.0917163E-05,   3.2291151E-05
     +,   3.3722656E-05,   3.5213481E-05,   3.6765283E-05
     +,   3.8379683E-05,   4.0058199E-05,   4.1802105E-05
     +,   4.3612617E-05,   4.5490768E-05,   4.7437312E-05
     +,   4.9452890E-05,   5.1537900E-05,   5.3692398E-05
     +,   5.5916276E-05,   5.8209120E-05,   6.0570277E-05
     +,   6.2998639E-05,   6.5492939E-05,   6.8051537E-05
     +,   7.0672519E-05,   7.3353505E-05,   7.6091921E-05
     +,   7.8884746E-05,   8.1728722E-05,   8.4620246E-05
     +,   8.7555432E-05,   9.0529938E-05,   9.3539289E-05
     +,   9.6578719E-05,   9.9643039E-05,   1.0272700E-04
     +,   1.0582512E-04,   1.0893155E-04,   1.1204046E-04
     +,   1.1514586E-04,   1.1824148E-04,   1.2132112E-04
     +,   1.2437857E-04,   1.2740737E-04,   1.3040133E-04
     +,   1.3335425E-04,   1.3625981E-04,   1.3911205E-04
     +,   1.4190513E-04,   1.4463313E-04,   1.4729064E-04
     +,   1.4987233E-04,   1.5237322E-04,   1.5478843E-04
     +,   1.5711361E-04,   1.5934442E-04,   1.6147728E-04
     +,   1.6350859E-04,   1.6543519E-04,   1.6725445E-04
     +,   1.6896383E-04,   1.7056122E-04,   1.7204513E-04
     +,   1.7341401E-04,   1.7466683E-04,   1.7580295E-04
     +,   1.7682184E-04,   1.7772341E-04,   1.7850778E-04
     +,   1.7917521E-04,   1.7972625E-04,   1.8016172E-04
     +,   1.8048247E-04,   1.8068960E-04,   1.8078428E-04
     +,   1.8076782E-04,   1.8064161E-04,   1.8040711E-04
     +,   1.8006585E-04,   1.7961953E-04,   1.7906970E-04
     +,   1.7841821E-04,   1.7766684E-04,   1.7681743E-04
     +,   1.7587203E-04,   1.7483268E-04,   1.7370156E-04
     +,   1.7248101E-04,   1.7117370E-04,   1.6978211E-04
     +,   1.6830934E-04,   1.6675839E-04,   1.6513276E-04
     +,   1.6343614E-04,   1.6167262E-04,   1.5984640E-04
     +,   1.5796225E-04,   1.5602514E-04,   1.5404043E-04
     +,   1.5201402E-04,   1.4995177E-04,   1.4786034E-04
     +,   1.4574629E-04,   1.4361677E-04,   1.4147910E-04
     +,   1.3934096E-04,   1.3721002E-04,   1.3509426E-04
     +,   1.3300187E-04,   1.3094080E-04,   1.2891933E-04
     +,   1.2694561E-04,   1.2502751E-04,   1.2317310E-04
     +,   1.2138986E-04,   1.1968524E-04,   1.1806635E-04
     +,   1.1653995E-04,   1.1511224E-04,   1.1378915E-04
     +,   1.1257597E-04,   1.1147753E-04,   1.1049815E-04
     +,   1.0964144E-04,   1.0891054E-04,   1.0830793E-04
     +,   1.0783545E-04,   1.0749436E-04,   1.0728522E-04
     +,   1.0720811E-04,   1.0726241E-04,   1.0744693E-04
     +,   1.0775992E-04,   1.0819908E-04,   1.0876155E-04
     +,   1.0944402E-04,   1.1024264E-04,   1.1115310E-04
     +,   1.1217073E-04,   1.1329038E-04,   1.1450652E-04
     +,   1.1581320E-04,   1.1720425E-04,   1.1867321E-04
     +,   1.2021316E-04,   1.2181703E-04,   1.2347742E-04
     +,   1.2518674E-04,   1.2693722E-04,   1.2872100E-04
     +,   1.3052989E-04,   1.3235565E-04,   1.3418992E-04
     +,   1.3602433E-04,   1.3785054E-04,   1.3966007E-04
     +,   1.4144459E-04,   1.4319579E-04,   1.4490563E-04
     +,   1.4656621E-04,   1.4816981E-04,   1.4970927E-04
     +,   1.5117765E-04,   1.5256835E-04,   1.5387555E-04
     +,   1.5509376E-04,   1.5621835E-04,   1.5724542E-04
     +,   1.5817177E-04,   1.5899506E-04,   1.5971388E-04
     +,   1.6032788E-04,   1.6083774E-04,   1.6124509E-04
     +,   1.6155280E-04,   1.6176475E-04,   1.6188600E-04
     +,   1.6192278E-04,   1.6188239E-04,   1.6177323E-04
     +,   1.6160472E-04,   1.6138726E-04,   1.6113215E-04
     +,   1.6085147E-04,   1.6055796E-04,   1.6026500E-04
     +,   1.5998627E-04,   1.5973582E-04,   1.5952773E-04
     +,   1.5937594E-04,   1.5929430E-04,   1.5929597E-04
     +,   1.5939363E-04,   1.5959902E-04,   1.5992296E-04
     +,   1.6037480E-04,   1.6096274E-04,   1.6169326E-04
     +,   1.6257114E-04,   1.6359934E-04,   1.6477873E-04
     +,   1.6610831E-04,   1.6758480E-04,   1.6920280E-04
     +,   1.7095471E-04,   1.7283071E-04,   1.7481901E-04
     +,   1.7690561E-04,   1.7907479E-04,   1.8130890E-04
     +,   1.8358862E-04,   1.8589316E-04,   1.8820073E-04
     +,   1.9048850E-04,   1.9273262E-04,   1.9490902E-04
     +,   1.9699329E-04,   1.9896106E-04,   2.0078842E-04
     +,   2.0245208E-04,   2.0392945E-04,   2.0519919E-04
     +,   2.0624128E-04,   2.0703740E-04,   2.0757092E-04
     +,   2.0782724E-04,   2.0779386E-04,   2.0746056E-04
     +,   2.0681947E-04,   2.0586504E-04,   2.0459433E-04
     +,   2.0300658E-04,   2.0110373E-04,   1.9888995E-04
     +,   1.9637165E-04,   1.9355759E-04,   1.9045841E-04
     +,   1.8708647E-04,   1.8345617E-04,   1.7958347E-04
     +,   1.7548550E-04,   1.7118083E-04,   1.6668859E-04
     +,   1.6202872E-04,   1.5722198E-04,   1.5228937E-04
     +,   1.4725221E-04,   1.4213135E-04,   1.3694752E-04
     +,   1.3172130E-04,   1.2647276E-04,   1.2122113E-04
     +,   1.1598510E-04,   1.1078212E-04,   1.0562853E-04
     +,   1.0054010E-04,   9.5531243E-05,   9.0615184E-05
     +,   8.5804160E-05,   8.1108592E-05,   7.6538447E-05
     +,   7.2101728E-05,   6.7805762E-05,   6.3656582E-05
     +,   5.9659331E-05,   5.5817152E-05,   5.2133084E-05
     +,   4.8608865E-05,   4.5245313E-05,   4.2042484E-05
     +,   3.8999282E-05,   3.6114361E-05,   3.3385240E-05
     +,   3.0809191E-05,   2.8382829E-05,   2.6102318E-05
     +,   2.3963559E-05,   2.1961630E-05,   2.0091831E-05
     +,   1.8349054E-05,   1.6728023E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wao_fus_60 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wao_fus_65(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  1.6729340E-06,   1.7889110E-06
     +,   1.9113563E-06,   2.0405112E-06,   2.1766280E-06
     +,   2.3199609E-06,   2.4707581E-06,   2.6292778E-06
     +,   2.7957828E-06,   2.9705213E-06,   3.1537593E-06
     +,   3.3457561E-06,   3.5467749E-06,   3.7570721E-06
     +,   3.9769106E-06,   4.2065576E-06,   4.4462668E-06
     +,   4.6963014E-06,   4.9569298E-06,   5.2284004E-06
     +,   5.5109817E-06,   5.8049400E-06,   6.1105243E-06
     +,   6.4280002E-06,   6.7576352E-06,   7.0996821E-06
     +,   7.4544082E-06,   7.8220883E-06,   8.2029756E-06
     +,   8.5973479E-06,   9.0054900E-06,   9.4276656E-06
     +,   9.8641694E-06,   1.0315302E-05,   1.0781353E-05
     +,   1.1262639E-05,   1.1759494E-05,   1.2272239E-05
     +,   1.2801237E-05,   1.3346858E-05,   1.3909503E-05
     +,   1.4489567E-05,   1.5087494E-05,   1.5703756E-05
     +,   1.6338856E-05,   1.6993303E-05,   1.7667680E-05
     +,   1.8362571E-05,   1.9078627E-05,   1.9816536E-05
     +,   2.0577045E-05,   2.1360904E-05,   2.2168957E-05
     +,   2.3002098E-05,   2.3861227E-05,   2.4747333E-05
     +,   2.5661469E-05,   2.6604679E-05,   2.7578095E-05
     +,   2.8582903E-05,   2.9620269E-05,   3.0691437E-05
     +,   3.1797681E-05,   3.2940228E-05,   3.4120370E-05
     +,   3.5339384E-05,   3.6598467E-05,   3.7898841E-05
     +,   3.9241666E-05,   4.0627980E-05,   4.2058768E-05
     +,   4.3534910E-05,   4.5057153E-05,   4.6626024E-05
     +,   4.8241964E-05,   4.9905055E-05,   5.1615392E-05
     +,   5.3372583E-05,   5.5175991E-05,   5.7024867E-05
     +,   5.8917944E-05,   6.0853570E-05,   6.2830026E-05
     +,   6.4844928E-05,   6.6895533E-05,   6.8978967E-05
     +,   7.1091599E-05,   7.3229778E-05,   7.5389151E-05
     +,   7.7565142E-05,   7.9752725E-05,   8.1946753E-05
     +,   8.4141560E-05,   8.6331194E-05,   8.8509754E-05
     +,   9.0670903E-05,   9.2808121E-05,   9.4915151E-05
     +,   9.6985372E-05,   9.9012541E-05,   1.0099031E-04
     +,   1.0291263E-04,   1.0477370E-04,   1.0656823E-04
     +,   1.0829112E-04,   1.0993809E-04,   1.1150517E-04
     +,   1.1298923E-04,   1.1438772E-04,   1.1569913E-04
     +,   1.1692249E-04,   1.1805799E-04,   1.1910655E-04
     +,   1.2007015E-04,   1.2095166E-04,   1.2175504E-04
     +,   1.2248506E-04,   1.2314761E-04,   1.2374937E-04
     +,   1.2429788E-04,   1.2480156E-04,   1.2526946E-04
     +,   1.2571141E-04,   1.2613765E-04,   1.2655891E-04
     +,   1.2698621E-04,   1.2743083E-04,   1.2790404E-04
     +,   1.2841704E-04,   1.2898081E-04,   1.2960591E-04
     +,   1.3030242E-04,   1.3107977E-04,   1.3194649E-04
     +,   1.3291031E-04,   1.3397771E-04,   1.3515413E-04
     +,   1.3644365E-04,   1.3784897E-04,   1.3937135E-04
     +,   1.4101063E-04,   1.4276501E-04,   1.4463102E-04
     +,   1.4660392E-04,   1.4867730E-04,   1.5084309E-04
     +,   1.5309219E-04,   1.5541386E-04,   1.5779620E-04
     +,   1.6022647E-04,   1.6269066E-04,   1.6517406E-04
     +,   1.6766155E-04,   1.7013733E-04,   1.7258537E-04
     +,   1.7498953E-04,   1.7733402E-04,   1.7960301E-04
     +,   1.8178148E-04,   1.8385476E-04,   1.8580910E-04
     +,   1.8763162E-04,   1.8931068E-04,   1.9083575E-04
     +,   1.9219756E-04,   1.9338822E-04,   1.9440129E-04
     +,   1.9523178E-04,   1.9587639E-04,   1.9633313E-04
     +,   1.9660180E-04,   1.9668356E-04,   1.9658115E-04
     +,   1.9629885E-04,   1.9584237E-04,   1.9521888E-04
     +,   1.9443690E-04,   1.9350639E-04,   1.9243857E-04
     +,   1.9124580E-04,   1.8994187E-04,   1.8854134E-04
     +,   1.8706021E-04,   1.8551522E-04,   1.8392426E-04
     +,   1.8230587E-04,   1.8067937E-04,   1.7906465E-04
     +,   1.7748220E-04,   1.7595298E-04,   1.7449797E-04
     +,   1.7313845E-04,   1.7189536E-04,   1.7078970E-04
     +,   1.6984183E-04,   1.6907163E-04,   1.6849813E-04
     +,   1.6813930E-04,   1.6801218E-04,   1.6813242E-04
     +,   1.6851412E-04,   1.6917018E-04,   1.7011153E-04
     +,   1.7134765E-04,   1.7288644E-04,   1.7473401E-04
     +,   1.7689502E-04,   1.7937258E-04,   1.8216879E-04
     +,   1.8528476E-04,   1.8872066E-04,   1.9247626E-04
     +,   1.9655118E-04,   2.0094497E-04,   2.0565838E-04
     +,   2.1069183E-04,   2.1604802E-04,   2.2173004E-04
     +,   2.2774248E-04,   2.3409174E-04,   2.4078510E-04
     +,   2.4783154E-04,   2.5524118E-04,   2.6302409E-04
     +,   2.7119051E-04,   2.7974957E-04,   2.8870971E-04
     +,   2.9807561E-04,   3.0784984E-04,   3.1802882E-04
     +,   3.2860387E-04,   3.3955867E-04,   3.5086990E-04
     +,   3.6250500E-04,   3.7442087E-04,   3.8656409E-04
     +,   3.9887027E-04,   4.1126361E-04,   4.2365806E-04
     +,   4.3595786E-04,   4.4805626E-04,   4.5983860E-04
     +,   4.7118354E-04,   4.8196645E-04,   4.9205846E-04
     +,   5.0133141E-04,   5.0966063E-04,   5.1692582E-04
     +,   5.2301545E-04,   5.2782928E-04,   5.3128012E-04
     +,   5.3329708E-04,   5.3382671E-04,   5.3283520E-04
     +,   5.3030899E-04,   5.2625558E-04,   5.2070332E-04
     +,   5.1370036E-04,   5.0531485E-04,   4.9563206E-04
     +,   4.8475288E-04,   4.7279178E-04,   4.5987251E-04
     +,   4.4612619E-04,   4.3168932E-04,   4.1669921E-04
     +,   4.0129264E-04,   3.8560055E-04,   3.6974790E-04
     +,   3.5385156E-04,   3.3801832E-04,   3.2234291E-04
     +,   3.0690871E-04,   2.9178505E-04,   2.7702891E-04
     +,   2.6268594E-04,   2.4878990E-04,   2.3536402E-04
     +,   2.2242244E-04,   2.0996989E-04,   1.9800621E-04
     +,   1.8652406E-04,   1.7551337E-04,   1.6496093E-04
     +,   1.5485255E-04,   1.4517095E-04,   1.3590131E-04
     +,   1.2702878E-04,   1.1853963E-04,   1.1042188E-04
     +,   1.0266416E-04,   9.5257972E-05,   8.8195076E-05
     +,   8.1469399E-05,   7.5075659E-05,   6.9009286E-05
     +,   6.3266583E-05,   5.7842692E-05,   5.2733954E-05
     +,   4.7935875E-05,   4.3443328E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wao_fus_65 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wao_fus_70(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  1.2512896E-09,   1.5160517E-09
     +,   1.8337118E-09,   2.2141495E-09,   2.6689781E-09
     +,   3.2118002E-09,   3.8584691E-09,   4.6275210E-09
     +,   5.5405316E-09,   6.6225105E-09,   7.9025071E-09
     +,   9.4141290E-09,   1.1196200E-08,   1.3293375E-08
     +,   1.5757138E-08,   1.8646592E-08,   2.2029269E-08
     +,   2.5982613E-08,   3.0594968E-08,   3.5966661E-08
     +,   4.2212072E-08,   4.9460912E-08,   5.7859523E-08
     +,   6.7573744E-08,   7.8790542E-08,   9.1719535E-08
     +,   1.0659667E-07,   1.2368646E-07,   1.4328353E-07
     +,   1.6571732E-07,   1.9135497E-07,   2.2060235E-07
     +,   2.5391100E-07,   2.9178022E-07,   3.3475874E-07
     +,   3.8345229E-07,   4.3852683E-07,   5.0070832E-07
     +,   5.7079365E-07,   6.4965013E-07,   7.3822298E-07
     +,   8.3753213E-07,   9.4868699E-07,   1.0728812E-06
     +,   1.2114050E-06,   1.3656320E-06,   1.5370464E-06
     +,   1.7272174E-06,   1.9378256E-06,   2.1706499E-06
     +,   2.4275769E-06,   2.7105784E-06,   3.0217404E-06
     +,   3.3632500E-06,   3.7373641E-06,   4.1464464E-06
     +,   4.5929487E-06,   5.0793601E-06,   5.6082681E-06
     +,   6.1823052E-06,   6.8041145E-06,   7.4763902E-06
     +,   8.2018396E-06,   8.9831119E-06,   9.8228684E-06
     +,   1.0723713E-05,   1.1688126E-05,   1.2718529E-05
     +,   1.3817214E-05,   1.4986257E-05,   1.6227605E-05
     +,   1.7542960E-05,   1.8933804E-05,   2.0401258E-05
     +,   2.1946238E-05,   2.3569171E-05,   2.5270328E-05
     +,   2.7049382E-05,   2.8905577E-05,   3.0837906E-05
     +,   3.2844688E-05,   3.4923702E-05,   3.7072481E-05
     +,   3.9287788E-05,   4.1565821E-05,   4.3902513E-05
     +,   4.6292902E-05,   4.8731854E-05,   5.1213425E-05
     +,   5.3731270E-05,   5.6278430E-05,   5.8847814E-05
     +,   6.1431594E-05,   6.4021551E-05,   6.6609427E-05
     +,   6.9186382E-05,   7.1743292E-05,   7.4271193E-05
     +,   7.6760611E-05,   7.9202371E-05,   8.1587023E-05
     +,   8.3905339E-05,   8.6148124E-05,   8.8306675E-05
     +,   9.0372268E-05,   9.2336864E-05,   9.4192626E-05
     +,   9.5932330E-05,   9.7549251E-05,   9.9037512E-05
     +,   1.0039171E-04,   1.0160739E-04,   1.0268079E-04
     +,   1.0360906E-04,   1.0439022E-04,   1.0502330E-04
     +,   1.0550828E-04,   1.0584613E-04,   1.0603885E-04
     +,   1.0608949E-04,   1.0600216E-04,   1.0578204E-04
     +,   1.0543531E-04,   1.0496924E-04,   1.0439217E-04
     +,   1.0371341E-04,   1.0294324E-04,   1.0209290E-04
     +,   1.0117460E-04,   1.0020129E-04,   9.9186771E-05
     +,   9.8145581E-05,   9.7092772E-05,   9.6044059E-05
     +,   9.5015421E-05,   9.4023279E-05,   9.3084098E-05
     +,   9.2214417E-05,   9.1430520E-05,   9.0748421E-05
     +,   9.0183566E-05,   8.9750705E-05,   8.9463661E-05
     +,   8.9335008E-05,   8.9376117E-05,   8.9596600E-05
     +,   9.0004462E-05,   9.0605659E-05,   9.1403890E-05
     +,   9.2400696E-05,   9.3595074E-05,   9.4983356E-05
     +,   9.6559423E-05,   9.8314369E-05,   1.0023662E-04
     +,   1.0231197E-04,   1.0452396E-04,   1.0685353E-04
     +,   1.0927985E-04,   1.1178006E-04,   1.1432994E-04
     +,   1.1690408E-04,   1.1947670E-04,   1.2202182E-04
     +,   1.2451361E-04,   1.2692729E-04,   1.2923942E-04
     +,   1.3142852E-04,   1.3347580E-04,   1.3536542E-04
     +,   1.3708491E-04,   1.3862576E-04,   1.3998369E-04
     +,   1.4115906E-04,   1.4215695E-04,   1.4298712E-04
     +,   1.4366421E-04,   1.4420747E-04,   1.4464067E-04
     +,   1.4499165E-04,   1.4529182E-04,   1.4557566E-04
     +,   1.4588011E-04,   1.4624368E-04,   1.4670590E-04
     +,   1.4730614E-04,   1.4808305E-04,   1.4907357E-04
     +,   1.5031194E-04,   1.5182902E-04,   1.5365136E-04
     +,   1.5580063E-04,   1.5829327E-04,   1.6113931E-04
     +,   1.6434258E-04,   1.6790038E-04,   1.7180320E-04
     +,   1.7603530E-04,   1.8057477E-04,   1.8539354E-04
     +,   1.9045852E-04,   1.9573211E-04,   2.0117294E-04
     +,   2.0673762E-04,   2.1238135E-04,   2.1805862E-04
     +,   2.2372528E-04,   2.2933936E-04,   2.3486289E-04
     +,   2.4026282E-04,   2.4551159E-04,   2.5058907E-04
     +,   2.5548250E-04,   2.6018781E-04,   2.6470984E-04
     +,   2.6906191E-04,   2.7326617E-04,   2.7735249E-04
     +,   2.8135814E-04,   2.8532612E-04,   2.8930395E-04
     +,   2.9334196E-04,   2.9749156E-04,   3.0180221E-04
     +,   3.0632041E-04,   3.1108654E-04,   3.1613398E-04
     +,   3.2148577E-04,   3.2715392E-04,   3.3313743E-04
     +,   3.3942156E-04,   3.4597673E-04,   3.5275926E-04
     +,   3.5971124E-04,   3.6676085E-04,   3.7382427E-04
     +,   3.8080709E-04,   3.8760630E-04,   3.9411368E-04
     +,   4.0021774E-04,   4.0580588E-04,   4.1076852E-04
     +,   4.1500121E-04,   4.1840825E-04,   4.2090396E-04
     +,   4.2241593E-04,   4.2288631E-04,   4.2227368E-04
     +,   4.2055344E-04,   4.1771861E-04,   4.1377981E-04
     +,   4.0876426E-04,   4.0271526E-04,   3.9569035E-04
     +,   3.8776020E-04,   3.7900583E-04,   3.6951649E-04
     +,   3.5938693E-04,   3.4871645E-04,   3.3760522E-04
     +,   3.2615251E-04,   3.1445504E-04,   3.0260393E-04
     +,   2.9068414E-04,   2.7877439E-04,   2.6694473E-04
     +,   2.5525707E-04,   2.4376372E-04,   2.3250838E-04
     +,   2.2152728E-04,   2.1084854E-04,   2.0049326E-04
     +,   1.9047668E-04,   1.8080794E-04,   1.7149177E-04
     +,   1.6252999E-04,   1.5392134E-04,   1.4566236E-04
     +,   1.3774843E-04,   1.3017307E-04,   1.2293039E-04
     +,   1.1601296E-04,   1.0941407E-04,   1.0312670E-04
     +,   9.7144235E-05,   9.1458554E-05,   8.6062850E-05
     +,   8.0949612E-05,   7.6110970E-05,   7.1538932E-05
     +,   6.7224391E-05,   6.3158543E-05,   5.9331363E-05
     +,   5.5732849E-05,   5.2352378E-05,   4.9178994E-05
     +,   4.6201683E-05,   4.3408578E-05,   4.0788491E-05
     +,   3.8330072E-05,   3.6022218E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wao_fus_70 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wao_fus_75(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  1.1411087E-06,   1.2065010E-06
     +,   1.2747943E-06,   1.3460570E-06,   1.4203584E-06
     +,   1.4977666E-06,   1.5783424E-06,   1.6621485E-06
     +,   1.7492424E-06,   1.8396752E-06,   1.9334975E-06
     +,   2.0307548E-06,   2.1314893E-06,   2.2357328E-06
     +,   2.3435166E-06,   2.4548681E-06,   2.5697998E-06
     +,   2.6883270E-06,   2.8104562E-06,   2.9361809E-06
     +,   3.0654944E-06,   3.1983823E-06,   3.3348147E-06
     +,   3.4747604E-06,   3.6181816E-06,   3.7650232E-06
     +,   3.9152278E-06,   4.0687314E-06,   4.2254524E-06
     +,   4.3853047E-06,   4.5481979E-06,   4.7140211E-06
     +,   4.8826619E-06,   5.0540007E-06,   5.2278983E-06
     +,   5.4042139E-06,   5.5828018E-06,   5.7634938E-06
     +,   5.9461249E-06,   6.1305154E-06,   6.3164862E-06
     +,   6.5038366E-06,   6.6923676E-06,   6.8818722E-06
     +,   7.0721403E-06,   7.2629446E-06,   7.4540676E-06
     +,   7.6452707E-06,   7.8363255E-06,   8.0269920E-06
     +,   8.2170363E-06,   8.4062112E-06,   8.5942738E-06
     +,   8.7809894E-06,   8.9661080E-06,   9.1493957E-06
     +,   9.3306180E-06,   9.5095365E-06,   9.6859267E-06
     +,   9.8595738E-06,   1.0030252E-05,   1.0197763E-05
     +,   1.0361912E-05,   1.0522508E-05,   1.0679378E-05
     +,   1.0832360E-05,   1.0981307E-05,   1.1126081E-05
     +,   1.1266568E-05,   1.1402662E-05,   1.1534278E-05
     +,   1.1661355E-05,   1.1783844E-05,   1.1901717E-05
     +,   1.2014964E-05,   1.2123601E-05,   1.2227666E-05
     +,   1.2327214E-05,   1.2422323E-05,   1.2513099E-05
     +,   1.2599665E-05,   1.2682161E-05,   1.2760768E-05
     +,   1.2835664E-05,   1.2907064E-05,   1.2975205E-05
     +,   1.3040331E-05,   1.3102720E-05,   1.3162658E-05
     +,   1.3220451E-05,   1.3276415E-05,   1.3330889E-05
     +,   1.3384224E-05,   1.3436765E-05,   1.3488884E-05
     +,   1.3540956E-05,   1.3593349E-05,   1.3646448E-05
     +,   1.3700625E-05,   1.3756260E-05,   1.3813721E-05
     +,   1.3873369E-05,   1.3935555E-05,   1.4000624E-05
     +,   1.4068897E-05,   1.4140684E-05,   1.4216273E-05
     +,   1.4295933E-05,   1.4379907E-05,   1.4468424E-05
     +,   1.4561673E-05,   1.4659833E-05,   1.4763048E-05
     +,   1.4871440E-05,   1.4985098E-05,   1.5104112E-05
     +,   1.5228526E-05,   1.5358390E-05,   1.5493728E-05
     +,   1.5634556E-05,   1.5780914E-05,   1.5932819E-05
     +,   1.6090338E-05,   1.6253542E-05,   1.6422553E-05
     +,   1.6597538E-05,   1.6778753E-05,   1.6966516E-05
     +,   1.7161254E-05,   1.7363527E-05,   1.7574015E-05
     +,   1.7793560E-05,   1.8023205E-05,   1.8264165E-05
     +,   1.8517909E-05,   1.8786117E-05,   1.9070747E-05
     +,   1.9374016E-05,   1.9698478E-05,   2.0046940E-05
     +,   2.0422578E-05,   2.0828853E-05,   2.1269547E-05
     +,   2.1748816E-05,   2.2271077E-05,   2.2841050E-05
     +,   2.3463803E-05,   2.4144612E-05,   2.4888959E-05
     +,   2.5702637E-05,   2.6591508E-05,   2.7561553E-05
     +,   2.8618944E-05,   2.9769784E-05,   3.1020198E-05
     +,   3.2376203E-05,   3.3843873E-05,   3.5428908E-05
     +,   3.7137077E-05,   3.8973725E-05,   4.0944014E-05
     +,   4.3052733E-05,   4.5304529E-05,   4.7703754E-05
     +,   5.0254257E-05,   5.2959636E-05,   5.5823184E-05
     +,   5.8847723E-05,   6.2036052E-05,   6.5390668E-05
     +,   6.8913578E-05,   7.2606628E-05,   7.6471333E-05
     +,   8.0509213E-05,   8.4721636E-05,   8.9109417E-05
     +,   9.3673269E-05,   9.8413533E-05,   1.0333007E-04
     +,   1.0842273E-04,   1.1368999E-04,   1.1913028E-04
     +,   1.2474037E-04,   1.3051591E-04,   1.3645089E-04
     +,   1.4253719E-04,   1.4876462E-04,   1.5512046E-04
     +,   1.6158835E-04,   1.6814868E-04,   1.7477792E-04
     +,   1.8144904E-04,   1.8813106E-04,   1.9478830E-04
     +,   2.0138174E-04,   2.0786870E-04,   2.1420368E-04
     +,   2.2033953E-04,   2.2622812E-04,   2.3182134E-04
     +,   2.3707295E-04,   2.4194026E-04,   2.4638543E-04
     +,   2.5037795E-04,   2.5389603E-04,   2.5692780E-04
     +,   2.5947340E-04,   2.6154597E-04,   2.6317287E-04
     +,   2.6439561E-04,   2.6527024E-04,   2.6586666E-04
     +,   2.6626774E-04,   2.6656783E-04,   2.6687043E-04
     +,   2.6728580E-04,   2.6792823E-04,   2.6891183E-04
     +,   2.7034752E-04,   2.7233860E-04,   2.7497666E-04
     +,   2.7833710E-04,   2.8247567E-04,   2.8742378E-04
     +,   2.9318617E-04,   2.9973889E-04,   3.0702964E-04
     +,   3.1497827E-04,   3.2348293E-04,   3.3242599E-04
     +,   3.4168464E-04,   3.5114391E-04,   3.6071311E-04
     +,   3.7034182E-04,   3.8003520E-04,   3.8987101E-04
     +,   4.0000948E-04,   4.1069926E-04,   4.2227696E-04
     +,   4.3515780E-04,   4.4981611E-04,   4.6676170E-04
     +,   4.8650691E-04,   5.0953281E-04,   5.3624756E-04
     +,   5.6695030E-04,   6.0180353E-04,   6.4079708E-04
     +,   6.8373221E-04,   7.3021557E-04,   7.7964383E-04
     +,   8.3122350E-04,   8.8397390E-04,   9.3675574E-04
     +,   9.8830089E-04,   1.0372516E-03,   1.0822138E-03
     +,   1.1218110E-03,   1.1547409E-03,   1.1798494E-03
     +,   1.1961932E-03,   1.2030987E-03,   1.2002132E-03
     +,   1.1875319E-03,   1.1654113E-03,   1.1345581E-03
     +,   1.0959909E-03,   1.0509797E-03,   1.0009730E-03
     +,   9.4751571E-04,   8.9215423E-04,   8.3635456E-04
     +,   7.8142947E-04,   7.2847470E-04,   6.7833718E-04
     +,   6.3160091E-04,   5.8858475E-04,   5.4936582E-04
     +,   5.1381491E-04,   4.8163513E-04,   4.5241936E-04
     +,   4.2568851E-04,   4.0094458E-04,   3.7770558E-04
     +,   3.5553798E-04,   3.3407391E-04,   3.1303393E-04
     +,   2.9222606E-04,   2.7154532E-04,   2.5096833E-04
     +,   2.3053726E-04,   2.1035185E-04,   1.9054717E-04
     +,   1.7128320E-04,   1.5272696E-04,   1.3504003E-04
     +,   1.1836905E-04,   1.0283227E-04,   8.8522036E-05
     +,   7.5496529E-05,   6.3780688E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wao_fus_75 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wao_fus_80(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  5.5570876E-35,   1.2890525E-34
     +,   2.9749299E-34,   6.8304914E-34,   1.5602829E-33
     +,   3.5459900E-33,   8.0175621E-33,   1.8035325E-32
     +,   4.0363399E-32,   8.9871433E-32,   1.9908262E-31
     +,   4.3875421E-31,   9.6203906E-31,   2.0986191E-30
     +,   4.5546389E-30,   9.8345845E-30,   2.1126534E-29
     +,   4.5152031E-29,   9.6009022E-29,   2.0310289E-28
     +,   4.2746131E-28,   8.9508095E-28,   1.8646599E-27
     +,   3.8646712E-27,   7.9691006E-27,   1.6348497E-26
     +,   3.3367608E-26,   6.7757106E-26,   1.3688488E-25
     +,   2.7512910E-25,   5.5017393E-25,   1.0945520E-24
     +,   2.1664570E-24,   4.2662588E-24,   8.3583118E-24
     +,   1.6291768E-23,   3.1593747E-23,   6.0955137E-23
     +,   1.1700281E-22,   2.2343971E-22,   4.2453238E-22
     +,   8.0247950E-22,   1.5091696E-21,   2.8237194E-21
     +,   5.2564400E-21,   9.7350377E-21,   1.7937710E-20
     +,   3.2883150E-20,   5.9973780E-20,   1.0882551E-19
     +,   1.9646555E-19,   3.5287321E-19,   6.3057178E-19
     +,   1.1210843E-18,   1.9829895E-18,   3.4896802E-18
     +,   6.1099849E-18,   1.0643233E-17,   1.8445585E-17
     +,   3.1805419E-17,   5.4562107E-17,   9.3125462E-17
     +,   1.5813809E-16,   2.6716989E-16,   4.4908257E-16
     +,   7.5103203E-16,   1.2496113E-15,   2.0686266E-15
     +,   3.4070875E-15,   5.5830500E-15,   9.1023135E-15
     +,   1.4764728E-14,   2.3828416E-14,   3.8260936E-14
     +,   6.1124384E-14,   9.7154245E-14,   1.5364278E-13
     +,   2.4174694E-13,   3.7844250E-13,   5.8944809E-13
     +,   9.1346364E-13,   1.4084154E-12,   2.1606219E-12
     +,   3.2978416E-12,   5.0081536E-12,   7.5672272E-12
     +,   1.1376139E-11,   1.7016369E-11,   2.5324824E-11
     +,   3.7500305E-11,   5.5249229E-11,   8.0990673E-11
     +,   1.1812888E-10,   1.7142855E-10,   2.4753177E-10
     +,   3.5562589E-10,   5.0835386E-10,   7.2303946E-10
     +,   1.0232233E-09,   1.4408001E-09,   2.0186333E-09
     +,   2.8140525E-09,   3.9032271E-09,   5.3869669E-09
     +,   7.3974777E-09,   1.0107740E-08,   1.3742014E-08
     +,   1.8589777E-08,   2.5021938E-08,   3.3512148E-08
     +,   4.4658961E-08,   5.9217651E-08,   7.8131450E-08
     +,   1.0257315E-07,   1.3398964E-07,   1.7416009E-07
     +,   2.2524658E-07,   2.8987435E-07,   3.7119347E-07
     +,   4.7296265E-07,   5.9965214E-07,   7.5650405E-07
     +,   9.4966902E-07,   1.1862610E-06,   1.4744751E-06
     +,   1.8236543E-06,   2.2444269E-06,   2.7486888E-06
     +,   3.3496756E-06,   4.0620721E-06,   4.9018586E-06
     +,   5.8863216E-06,   7.0341007E-06,   8.3647756E-06
     +,   9.8990522E-06,   1.1658180E-05,   1.3663876E-05
     +,   1.5937836E-05,   1.8501731E-05,   2.1376125E-05
     +,   2.4580813E-05,   2.8133585E-05,   3.2050000E-05
     +,   3.6343423E-05,   4.1023606E-05,   4.6096648E-05
     +,   5.1565279E-05,   5.7427307E-05,   6.3675951E-05
     +,   7.0300441E-05,   7.7284531E-05,   8.4607258E-05
     +,   9.2243987E-05,   1.0016493E-04,   1.0833680E-04
     +,   1.1672244E-04,   1.2528282E-04,   1.3397516E-04
     +,   1.4275628E-04,   1.5158069E-04,   1.6040253E-04
     +,   1.6917556E-04,   1.7785432E-04,   1.8639401E-04
     +,   1.9475012E-04,   2.0287966E-04,   2.1074089E-04
     +,   2.1829345E-04,   2.2549892E-04,   2.3232061E-04
     +,   2.3872311E-04,   2.4467314E-04,   2.5013933E-04
     +,   2.5509324E-04,   2.5950899E-04,   2.6336368E-04
     +,   2.6663824E-04,   2.6931768E-04,   2.7139200E-04
     +,   2.7285656E-04,   2.7371274E-04,   2.7396844E-04
     +,   2.7363843E-04,   2.7274532E-04,   2.7131935E-04
     +,   2.6939940E-04,   2.6703306E-04,   2.6427704E-04
     +,   2.6119841E-04,   2.5787490E-04,   2.5439606E-04
     +,   2.5086428E-04,   2.4739609E-04,   2.4412380E-04
     +,   2.4119637E-04,   2.3878005E-04,   2.3705880E-04
     +,   2.3623277E-04,   2.3651628E-04,   2.3813378E-04
     +,   2.4131320E-04,   2.4627804E-04,   2.5323627E-04
     +,   2.6236934E-04,   2.7381832E-04,   2.8766927E-04
     +,   3.0394128E-04,   3.2257463E-04,   3.4342494E-04
     +,   3.6626006E-04,   3.9076040E-04,   4.1653117E-04
     +,   4.4311810E-04,   4.7002846E-04,   4.9676310E-04
     +,   5.2283943E-04,   5.4783153E-04,   5.7139219E-04
     +,   5.9328193E-04,   6.1338407E-04,   6.3171366E-04
     +,   6.4841489E-04,   6.6374772E-04,   6.7806349E-04
     +,   6.9177744E-04,   7.0533244E-04,   7.1916467E-04
     +,   7.3366525E-04,   7.4915151E-04,   7.6583645E-04
     +,   7.8380870E-04,   8.0301659E-04,   8.2326221E-04
     +,   8.4419741E-04,   8.6533261E-04,   8.8605814E-04
     +,   9.0567541E-04,   9.2344079E-04,   9.3862647E-04
     +,   9.5058192E-04,   9.5879938E-04,   9.6297276E-04
     +,   9.6303935E-04,   9.5919275E-04,   9.5187023E-04
     +,   9.4170537E-04,   9.2945888E-04,   9.1593643E-04
     +,   9.0190436E-04,   8.8801834E-04,   8.7478157E-04
     +,   8.6252514E-04,   8.5142563E-04,   8.4153994E-04
     +,   8.3285035E-04,   8.2531001E-04,   8.1887277E-04
     +,   8.1350462E-04,   8.0917455E-04,   8.0582988E-04
     +,   8.0336386E-04,   8.0158713E-04,   8.0021092E-04
     +,   7.9884863E-04,   7.9703442E-04,   7.9425547E-04
     +,   7.8999595E-04,   7.8377640E-04,   7.7518949E-04
     +,   7.6392532E-04,   7.4978039E-04,   7.3265692E-04
     +,   7.1255560E-04,   6.8955898E-04,   6.6382019E-04
     +,   6.3555466E-04,   6.0503138E-04,   5.7256984E-04
     +,   5.3853996E-04,   5.0335348E-04,   4.6746634E-04
     +,   4.3135748E-04,   3.9552242E-04,   3.6044797E-04
     +,   3.2659489E-04,   2.9436516E-04,   2.6410032E-04
     +,   2.3605622E-04,   2.1039837E-04,   1.8720153E-04
     +,   1.6645162E-04,   1.4806242E-04,   1.3188373E-04
     +,   1.1772315E-04,   1.0536046E-04,   9.4564384E-05
     +,   8.5107386E-05,   7.6773831E-05,   6.9372443E-05
     +,   6.2737839E-05,   5.6733235E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wao_fus_80 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wao_fus_85(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  1.3979325E-06,   1.4728837E-06
     +,   1.5507944E-06,   1.6317083E-06,   1.7156701E-06
     +,   1.8027209E-06,   1.8928923E-06,   1.9862155E-06
     +,   2.0827167E-06,   2.1824123E-06,   2.2853171E-06
     +,   2.3914388E-06,   2.5007807E-06,   2.6133330E-06
     +,   2.7290844E-06,   2.8480194E-06,   2.9701046E-06
     +,   3.0953081E-06,   3.2235907E-06,   3.3548945E-06
     +,   3.4891652E-06,   3.6263359E-06,   3.7663267E-06
     +,   3.9090560E-06,   4.0544314E-06,   4.2023485E-06
     +,   4.3526966E-06,   4.5053607E-06,   4.6602072E-06
     +,   4.8171041E-06,   4.9759101E-06,   5.1364650E-06
     +,   5.2986156E-06,   5.4621942E-06,   5.6270260E-06
     +,   5.7929301E-06,   5.9597264E-06,   6.1272167E-06
     +,   6.2952086E-06,   6.4635042E-06,   6.6319039E-06
     +,   6.8001964E-06,   6.9681810E-06,   7.1356535E-06
     +,   7.3024112E-06,   7.4682471E-06,   7.6329688E-06
     +,   7.7963778E-06,   7.9582933E-06,   8.1185362E-06
     +,   8.2769411E-06,   8.4333469E-06,   8.5876145E-06
     +,   8.7396211E-06,   8.8892502E-06,   9.0364183E-06
     +,   9.1810625E-06,   9.3231356E-06,   9.4626248E-06
     +,   9.5995520E-06,   9.7339553E-06,   9.8659266E-06
     +,   9.9955851E-06,   1.0123091E-05,   1.0248649E-05
     +,   1.0372519E-05,   1.0494993E-05,   1.0616428E-05
     +,   1.0737235E-05,   1.0857874E-05,   1.0978873E-05
     +,   1.1100816E-05,   1.1224364E-05,   1.1350224E-05
     +,   1.1479191E-05,   1.1612109E-05,   1.1749915E-05
     +,   1.1893601E-05,   1.2044226E-05,   1.2202939E-05
     +,   1.2370941E-05,   1.2549499E-05,   1.2739963E-05
     +,   1.2943724E-05,   1.3162236E-05,   1.3397023E-05
     +,   1.3649627E-05,   1.3921665E-05,   1.4214754E-05
     +,   1.4530550E-05,   1.4870711E-05,   1.5236934E-05
     +,   1.5630871E-05,   1.6054146E-05,   1.6508404E-05
     +,   1.6995187E-05,   1.7515969E-05,   1.8072213E-05
     +,   1.8665185E-05,   1.9296143E-05,   1.9966132E-05
     +,   2.0676078E-05,   2.1426706E-05,   2.2218643E-05
     +,   2.3052198E-05,   2.3927587E-05,   2.4844690E-05
     +,   2.5803172E-05,   2.6802400E-05,   2.7841572E-05
     +,   2.8919452E-05,   3.0034678E-05,   3.1185449E-05
     +,   3.2369728E-05,   3.3585089E-05,   3.4828994E-05
     +,   3.6098383E-05,   3.7390120E-05,   3.8700648E-05
     +,   4.0026131E-05,   4.1362680E-05,   4.2705935E-05
     +,   4.4051583E-05,   4.5394983E-05,   4.6731388E-05
     +,   4.8055914E-05,   4.9363764E-05,   5.0649953E-05
     +,   5.1909497E-05,   5.3137614E-05,   5.4329477E-05
     +,   5.5480374E-05,   5.6585908E-05,   5.7641715E-05
     +,   5.8643862E-05,   5.9588558E-05,   6.0472383E-05
     +,   6.1292252E-05,   6.2045532E-05,   6.2729894E-05
     +,   6.3343527E-05,   6.3884996E-05,   6.4353306E-05
     +,   6.4747990E-05,   6.5068976E-05,   6.5316635E-05
     +,   6.5491840E-05,   6.5595821E-05,   6.5630236E-05
     +,   6.5597131E-05,   6.5498905E-05,   6.5338267E-05
     +,   6.5118184E-05,   6.4841937E-05,   6.4512969E-05
     +,   6.4134940E-05,   6.3711632E-05,   6.3246967E-05
     +,   6.2744948E-05,   6.2209678E-05,   6.1645325E-05
     +,   6.1056176E-05,   6.0446542E-05,   5.9820846E-05
     +,   5.9183709E-05,   5.8539910E-05,   5.7894489E-05
     +,   5.7252830E-05,   5.6620593E-05,   5.6003923E-05
     +,   5.5409488E-05,   5.4844524E-05,   5.4316810E-05
     +,   5.3834716E-05,   5.3407199E-05,   5.3043772E-05
     +,   5.2754429E-05,   5.2549542E-05,   5.2439824E-05
     +,   5.2436226E-05,   5.2549993E-05,   5.2792766E-05
     +,   5.3176798E-05,   5.3715474E-05,   5.4424068E-05
     +,   5.5320823E-05,   5.6428573E-05,   5.7776735E-05
     +,   5.9403701E-05,   6.1360035E-05,   6.3711857E-05
     +,   6.6545195E-05,   6.9970149E-05,   7.4125230E-05
     +,   7.9182129E-05,   8.5349777E-05,   9.2877235E-05
     +,   1.0205684E-04,   1.1322391E-04,   1.2675344E-04
     +,   1.4305560E-04,   1.6256560E-04,   1.8572828E-04
     +,   2.1298122E-04,   2.4472913E-04,   2.8131166E-04
     +,   3.2297379E-04,   3.6982982E-04,   4.2183677E-04
     +,   4.7876631E-04,   5.4018572E-04,   6.0546247E-04
     +,   6.7377888E-04,   7.4416224E-04,   8.1554468E-04
     +,   8.8679942E-04,   9.5681939E-04,   1.0245454E-03
     +,   1.0890061E-03,   1.1493262E-03,   1.2047162E-03
     +,   1.2544605E-03,   1.2979015E-03,   1.3344457E-03
     +,   1.3636141E-03,   1.3851157E-03,   1.3989563E-03
     +,   1.4055404E-03,   1.4057625E-03,   1.4010284E-03
     +,   1.3932050E-03,   1.3844820E-03,   1.3771566E-03
     +,   1.3733753E-03,   1.3748723E-03,   1.3827536E-03
     +,   1.3973487E-03,   1.4181727E-03,   1.4439780E-03
     +,   1.4728952E-03,   1.5026146E-03,   1.5306060E-03
     +,   1.5543175E-03,   1.5713668E-03,   1.5796863E-03
     +,   1.5776602E-03,   1.5642357E-03,   1.5390087E-03
     +,   1.5023081E-03,   1.4552143E-03,   1.3995686E-03
     +,   1.3378700E-03,   1.2731394E-03,   1.2086882E-03
     +,   1.1478454E-03,   1.0936696E-03,   1.0486626E-03
     +,   1.0145549E-03,   9.9216669E-04,   9.8135904E-04
     +,   9.8109466E-04,   9.8957983E-04,   1.0044756E-03
     +,   1.0231428E-03,   1.0428866E-03,   1.0611860E-03
     +,   1.0758726E-03,   1.0852568E-03,   1.0881862E-03
     +,   1.0840438E-03,   1.0727000E-03,   1.0544253E-03
     +,   1.0297809E-03,   9.9950761E-04,   9.6442323E-04
     +,   9.2534663E-04,   8.8303850E-04,   8.3817559E-04
     +,   7.9134852E-04,   7.4306870E-04,   6.9380348E-04
     +,   6.4398680E-04,   5.9405371E-04,   5.4444355E-04
     +,   4.9560866E-04,   4.4799157E-04,   4.0203371E-04
     +,   3.5814202E-04,   3.1667415E-04,   2.7792441E-04
     +,   2.4210667E-04,   2.0935920E-04,   1.7973378E-04
     +,   1.5321054E-04,   1.2970172E-04,   1.0906503E-04
     +,   9.1117719E-05,   7.5644144E-05,   6.2416206E-05
     +,   5.1197992E-05,   4.1756019E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wao_fus_85 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wao_fus_90(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  1.0382457E-25,   1.7433151E-25
     +,   2.9188901E-25,   4.8732361E-25,   8.1129266E-25
     +,   1.3467979E-24,   2.2293970E-24,   3.6798523E-24
     +,   6.0567573E-24,   9.9405088E-24,   1.6268093E-23
     +,   2.6547672E-23,   4.3199768E-23,   7.0096034E-23
     +,   1.1341410E-22,   1.8298139E-22,   2.9437616E-22
     +,   4.7223622E-22,   7.5540881E-22,   1.2049295E-21
     +,   1.9164733E-21,   3.0395370E-21,   4.8069594E-21
     +,   7.5804374E-21,   1.1920190E-20,   1.8690836E-20
     +,   2.9223803E-20,   4.5562556E-20,   7.0833195E-20
     +,   1.0980627E-19,   1.6973895E-19,   2.6163353E-19
     +,   4.0213024E-19,   6.1631687E-19,   9.4188699E-19
     +,   1.4353378E-18,   2.1810910E-18,   3.3048467E-18
     +,   4.9933192E-18,   7.5229455E-18,   1.1301886E-17
     +,   1.6930566E-17,   2.5290200E-17,   3.7669885E-17
     +,   5.5950014E-17,   8.2863579E-17,   1.2237452E-16
     +,   1.8020872E-16,   2.6461900E-16,   3.8745992E-16
     +,   5.6571303E-16,   8.2361439E-16,   1.1956710E-15
     +,   1.7308645E-15,   2.4984596E-15,   3.5961800E-15
     +,   5.1614804E-15,   7.3869455E-15,   1.0541835E-14
     +,   1.5001347E-14,   2.1286421E-14,   3.0118587E-14
     +,   4.2494267E-14,   5.9783829E-14,   8.3868269E-14
     +,   1.1732061E-13,   1.6364739E-13,   2.2761662E-13
     +,   3.1569081E-13,   4.3659415E-13,   6.0207926E-13
     +,   8.2792204E-13,   1.1352426E-12,   1.5521951E-12
     +,   2.1162412E-12,   2.8770012E-12,   3.9001428E-12
     +,   5.2720649E-12,   7.1061785E-12,   9.5511819E-12
     +,   1.2800823E-11,   1.7107002E-11,   2.2796875E-11
     +,   3.0292612E-11,   4.0137765E-11,   5.3031642E-11
     +,   6.9866953E-11,   9.1785406E-11,   1.2023635E-10
     +,   1.5705709E-10,   2.0456667E-10,   2.6569125E-10
     +,   3.4409567E-10,   4.4436171E-10,   5.7221455E-10
     +,   7.3475198E-10,   9.4075980E-10,   1.2011045E-09
     +,   1.5291103E-09,   1.9411583E-09,   2.4572149E-09
     +,   3.1015948E-09,   3.9037600E-09,   4.8994253E-09
     +,   6.1314576E-09,   7.6514910E-09,   9.5211217E-09
     +,   1.1813826E-08,   1.4616707E-08,   1.8033184E-08
     +,   2.2184629E-08,   2.7214197E-08,   3.3288924E-08
     +,   4.0603595E-08,   4.9384038E-08,   5.9892606E-08
     +,   7.2429849E-08,   8.7342748E-08,   1.0502623E-07
     +,   1.2592959E-07,   1.5056477E-07,   1.7950613E-07
     +,   2.1340348E-07,   2.5298121E-07,   2.9904714E-07
     +,   3.5249624E-07,   4.1432284E-07,   4.8561401E-07
     +,   5.6755806E-07,   6.6145896E-07,   7.6871970E-07
     +,   8.9085103E-07,   1.0294877E-06,   1.1863527E-06
     +,   1.3632975E-06,   1.5622556E-06,   1.7852602E-06
     +,   2.0344196E-06,   2.3119460E-06,   2.6200714E-06
     +,   2.9611203E-06,   3.3374124E-06,   3.7512707E-06
     +,   4.2050592E-06,   4.7010626E-06,   5.2415021E-06
     +,   5.8285837E-06,   6.4643446E-06,   7.1506829E-06
     +,   7.8894209E-06,   8.6821192E-06,   9.5301139E-06
     +,   1.0434616E-05,   1.1396470E-05,   1.2416273E-05
     +,   1.3494277E-05,   1.4630526E-05,   1.5824555E-05
     +,   1.7075710E-05,   1.8382822E-05,   1.9744373E-05
     +,   2.1158396E-05,   2.2622618E-05,   2.4134382E-05
     +,   2.5690542E-05,   2.7287640E-05,   2.8921939E-05
     +,   3.0589388E-05,   3.2285981E-05,   3.4007760E-05
     +,   3.5750876E-05,   3.7512109E-05,   3.9289098E-05
     +,   4.1081006E-05,   4.2889053E-05,   4.4717126E-05
     +,   4.6572968E-05,   4.8469323E-05,   5.0425278E-05
     +,   5.2468244E-05,   5.4635322E-05,   5.6976049E-05
     +,   5.9553924E-05,   6.2448824E-05,   6.5758664E-05
     +,   6.9600414E-05,   7.4110751E-05,   7.9444952E-05
     +,   8.5774045E-05,   9.3281356E-05,   1.0215651E-04
     +,   1.1258990E-04,   1.2476518E-04,   1.3885128E-04
     +,   1.5499878E-04,   1.7333707E-04,   1.9397579E-04
     +,   2.1701532E-04,   2.4256184E-04,   2.7074938E-04
     +,   3.0177741E-04,   3.3595227E-04,   3.7373209E-04
     +,   4.1577351E-04,   4.6295224E-04,   5.1634770E-04
     +,   5.7718268E-04,   6.4669293E-04,   7.2594930E-04
     +,   8.1562821E-04,   9.1578258E-04,   1.0256759E-03
     +,   1.1436981E-03,   1.2674107E-03,   1.3937582E-03
     +,   1.5193895E-03,   1.6412303E-03,   1.7571760E-03
     +,   1.8670172E-03,   1.9733559E-03,   2.0822280E-03
     +,   2.2029271E-03,   2.3465436E-03,   2.5230753E-03
     +,   2.7376716E-03,   2.9871303E-03,   3.2581466E-03
     +,   3.5282613E-03,   3.7698832E-03,   3.9563505E-03
     +,   4.0688403E-03,   4.1022277E-03,   4.0681837E-03
     +,   3.9939410E-03,   3.9159814E-03,   3.8693917E-03
     +,   3.8756868E-03,   3.9335797E-03,   4.0172995E-03
     +,   4.0845699E-03,   4.0921671E-03,   4.0125689E-03
     +,   3.8441196E-03,   3.6100033E-03,   3.3474816E-03
     +,   3.0933465E-03,   2.8727727E-03,   2.6956424E-03
     +,   2.5596551E-03,   2.4567212E-03,   2.3787897E-03
     +,   2.3207783E-03,   2.2806390E-03,   2.2576919E-03
     +,   2.2507946E-03,   2.2572540E-03,   2.2727663E-03
     +,   2.2920216E-03,   2.3095298E-03,   2.3203176E-03
     +,   2.3204223E-03,   2.3072613E-03,   2.2799200E-03
     +,   2.2393337E-03,   2.1882027E-03,   2.1305331E-03
     +,   2.0707871E-03,   2.0128442E-03,   1.9590859E-03
     +,   1.9098789E-03,   1.8636239E-03,   1.8173250E-03
     +,   1.7674753E-03,   1.7109439E-03,   1.6456340E-03
     +,   1.5707854E-03,   1.4869036E-03,   1.3954544E-03
     +,   1.2984585E-03,   1.1981090E-03,   1.0965208E-03
     +,   9.9555764E-04,   8.9680776E-04,   8.0157677E-04
     +,   7.1093248E-04,   6.2570290E-04,   5.4653763E-04
     +,   4.7388361E-04,   4.0799490E-04,   3.4893848E-04
     +,   2.9659795E-04,   2.5071015E-04,   2.1087856E-04
     +,   1.7662064E-04,   1.4739591E-04,   1.2264060E-04
     +,   1.0179728E-04,   8.4329891E-05,   6.9748399E-05
     +,   5.7610574E-05,   4.7527243E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wao_fus_90 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wao_fus_95(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  5.1960703E-18,   7.5487750E-18
     +,   1.0940629E-17,   1.5818590E-17,   2.2816795E-17
     +,   3.2832655E-17,   4.7132073E-17,   6.7497640E-17
     +,   9.6432855E-17,   1.3744227E-16,   1.9542396E-16
     +,   2.7720217E-16,   3.9226583E-16,   5.5376118E-16
     +,   7.7987795E-16,   1.0957085E-15,   1.5357595E-15
     +,   2.1473964E-15,   2.9954778E-15,   4.1684893E-15
     +,   5.7870066E-15,   8.0147994E-15,   1.1073659E-14
     +,   1.5263386E-14,   2.0988192E-14,   2.8791107E-14
     +,   3.9400710E-14,   5.3791481E-14,   7.3262529E-14
     +,   9.9543393E-14,   1.3492965E-13,   1.8245706E-13
     +,   2.4613710E-13,   3.3125081E-13,   4.4472984E-13
     +,   5.9565780E-13,   7.9590750E-13,   1.0609315E-12
     +,   1.4108260E-12,   1.8716391E-12,   2.4770479E-12
     +,   3.2704423E-12,   4.3076450E-12,   5.6602483E-12
     +,   7.4198477E-12,   9.7031784E-12,   1.2658935E-11
     +,   1.6475557E-11,   2.1391647E-11,   2.7708358E-11
     +,   3.5804797E-11,   4.6156377E-11,   5.9358574E-11
     +,   7.6155242E-11,   9.7470990E-11,   1.2445524E-10
     +,   1.5853119E-10,   2.0145412E-10,   2.5538754E-10
     +,   3.2298855E-10,   4.0750628E-10,   5.1291299E-10
     +,   6.4404609E-10,   8.0677087E-10,   1.0081972E-09
     +,   1.2569117E-09,   1.5632348E-09,   1.9395714E-09
     +,   2.4007742E-09,   2.9645395E-09,   3.6519510E-09
     +,   4.4880282E-09,   5.5023661E-09,   6.7298265E-09
     +,   8.2115044E-09,   9.9954072E-09,   1.2137912E-08
     +,   1.4704484E-08,   1.7771136E-08,   2.1426246E-08
     +,   2.5771493E-08,   3.0923804E-08,   3.7017898E-08
     +,   4.4207287E-08,   5.2666643E-08,   6.2595547E-08
     +,   7.4218377E-08,   8.7790120E-08,   1.0359609E-07
     +,   1.2195636E-07,   1.4322755E-07,   1.6780892E-07
     +,   1.9614062E-07,   2.2870809E-07,   2.6604962E-07
     +,   3.0875086E-07,   3.5745074E-07,   4.1284937E-07
     +,   4.7569674E-07,   5.4681004E-07,   6.2706005E-07
     +,   7.1737765E-07,   8.1874975E-07,   9.3223161E-07
     +,   1.0589168E-06,   1.1999698E-06,   1.3565865E-06
     +,   1.5300084E-06,   1.7215037E-06,   1.9323902E-06
     +,   2.1639696E-06,   2.4175847E-06,   2.6945440E-06
     +,   2.9961473E-06,   3.3236429E-06,   3.6782719E-06
     +,   4.0611526E-06,   4.4733779E-06,   4.9158953E-06
     +,   5.3895228E-06,   5.8949995E-06,   6.4328297E-06
     +,   7.0034180E-06,   7.6069173E-06,   8.2432916E-06
     +,   8.9122514E-06,   9.6133472E-06,   1.0345808E-05
     +,   1.1108590E-05,   1.1900491E-05,   1.2719943E-05
     +,   1.3565114E-05,   1.4434011E-05,   1.5324251E-05
     +,   1.6233353E-05,   1.7158511E-05,   1.8096734E-05
     +,   1.9044832E-05,   1.9999559E-05,   2.0957406E-05
     +,   2.1914913E-05,   2.2868466E-05,   2.3814438E-05
     +,   2.4749324E-05,   2.5669588E-05,   2.6571803E-05
     +,   2.7452787E-05,   2.8309471E-05,   2.9138995E-05
     +,   2.9938887E-05,   3.0706877E-05,   3.1441043E-05
     +,   3.2139927E-05,   3.2802389E-05,   3.3427732E-05
     +,   3.4015695E-05,   3.4566550E-05,   3.5080961E-05
     +,   3.5560166E-05,   3.6005855E-05,   3.6420246E-05
     +,   3.6806039E-05,   3.7166541E-05,   3.7505542E-05
     +,   3.7827380E-05,   3.8136946E-05,   3.8439710E-05
     +,   3.8741713E-05,   3.9049639E-05,   3.9370818E-05
     +,   3.9713232E-05,   4.0085630E-05,   4.0497522E-05
     +,   4.0959319E-05,   4.1482373E-05,   4.2079027E-05
     +,   4.2762778E-05,   4.3548342E-05,   4.4451706E-05
     +,   4.5490375E-05,   4.6683166E-05,   4.8050540E-05
     +,   4.9614213E-05,   5.1397255E-05,   5.3423737E-05
     +,   5.5718283E-05,   5.8305748E-05,   6.1210420E-05
     +,   6.4454929E-05,   6.8059555E-05,   7.2041104E-05
     +,   7.6412609E-05,   8.1182778E-05,   8.6355911E-05
     +,   9.1934045E-05,   9.7919801E-05,   1.0432112E-04
     +,   1.1115926E-04,   1.1847798E-04,   1.2635413E-04
     +,   1.3491092E-04,   1.4433010E-04,   1.5486179E-04
     +,   1.6683333E-04,   1.8065296E-04,   1.9681186E-04
     +,   2.1589416E-04,   2.3859982E-04,   2.6580447E-04
     +,   2.9866406E-04,   3.3877764E-04,   3.8840543E-04
     +,   4.5069042E-04,   5.2981667E-04,   6.3104520E-04
     +,   7.6054380E-04,   9.2516694E-04,   1.1322446E-03
     +,   1.3897468E-03,   1.7068475E-03,   2.0945340E-03
     +,   2.5651769E-03,   3.1292811E-03,   3.7885625E-03
     +,   4.5276969E-03,   5.3105736E-03,   6.0882149E-03
     +,   6.8178247E-03,   7.4817035E-03,   8.0887508E-03
     +,   8.6578354E-03,   9.2048729E-03,   9.7519848E-03
     +,   1.0334468E-02,   1.0959846E-02,   1.1536888E-02
     +,   1.1876079E-02,   1.1822397E-02,   1.1414809E-02
     +,   1.0889545E-02,   1.0496130E-02,   1.0311179E-02
     +,   1.0236825E-02,   1.0151567E-02,   1.0025066E-02
     +,   9.8923733E-03,   9.7625777E-03,   9.5838038E-03
     +,   9.2887981E-03,   8.8571357E-03,   8.3364807E-03
     +,   7.8149242E-03,   7.3707816E-03,   7.0354063E-03
     +,   6.7930627E-03,   6.6097016E-03,   6.4582177E-03
     +,   6.3198041E-03,   6.1714631E-03,   5.9819380E-03
     +,   5.7235737E-03,   5.3883940E-03,   4.9938154E-03
     +,   4.5746719E-03,   4.1687684E-03,   3.8050769E-03
     +,   3.4989293E-03,   3.2530220E-03,   3.0612415E-03
     +,   2.9126243E-03,   2.7944404E-03,   2.6943996E-03
     +,   2.6020901E-03,   2.5097828E-03,   2.4126554E-03
     +,   2.3085547E-03,   2.1974221E-03,   2.0806256E-03
     +,   1.9603129E-03,   1.8388713E-03,   1.7185773E-03
     +,   1.6013123E-03,   1.4884587E-03,   1.3808369E-03
     +,   1.2787520E-03,   1.1820514E-03,   1.0903120E-03
     +,   1.0029665E-03,   9.1946393E-04,   8.3939242E-04
     +,   7.6253328E-04,   6.8890094E-04,   6.1868236E-04
     +,   5.5219722E-04,   4.8980670E-04,   4.3184464E-04
     +,   3.7856612E-04,   3.3009597E-04,   2.8644208E-04
     +,   2.4748532E-04,   2.1300338E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wao_fus_95 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wao_hz_100(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  6.0711192E-10,   6.9744022E-10
     +,   8.0045370E-10,   9.1781249E-10,   1.0513834E-09
     +,   1.2032613E-09,   1.3757752E-09,   1.5715407E-09
     +,   1.7934725E-09,   2.0448139E-09,   2.3291813E-09
     +,   2.6505971E-09,   3.0135314E-09,   3.4229310E-09
     +,   3.8842920E-09,   4.4036992E-09,   4.9878541E-09
     +,   5.6441909E-09,   6.3809060E-09,   7.2069901E-09
     +,   8.1323748E-09,   9.1679899E-09,   1.0325771E-08
     +,   1.1618847E-08,   1.3061626E-08,   1.4669786E-08
     +,   1.6460492E-08,   1.8452539E-08,   2.0666251E-08
     +,   2.3123889E-08,   2.5849655E-08,   2.8869644E-08
     +,   3.2212334E-08,   3.5908567E-08,   3.9991487E-08
     +,   4.4497085E-08,   4.9464262E-08,   5.4934514E-08
     +,   6.0952885E-08,   6.7567647E-08,   7.4830695E-08
     +,   8.2797207E-08,   9.1526658E-08,   1.0108251E-07
     +,   1.1153251E-07,   1.2294846E-07,   1.3540746E-07
     +,   1.4899037E-07,   1.6378411E-07,   1.7987989E-07
     +,   1.9737521E-07,   2.1637143E-07,   2.3697692E-07
     +,   2.5930544E-07,   2.8347571E-07,   3.0961326E-07
     +,   3.3784983E-07,   3.6832165E-07,   4.0117277E-07
     +,   4.3655328E-07,   4.7461751E-07,   5.1552729E-07
     +,   5.5945156E-07,   6.0656191E-07,   6.5703830E-07
     +,   7.1106695E-07,   7.6883555E-07,   8.3054073E-07
     +,   8.9638382E-07,   9.6656697E-07,   1.0413006E-06
     +,   1.1207972E-06,   1.2052750E-06,   1.2949491E-06
     +,   1.3900446E-06,   1.4907797E-06,   1.5973854E-06
     +,   1.7100840E-06,   1.8290953E-06,   1.9546530E-06
     +,   2.0869761E-06,   2.2262782E-06,   2.3727894E-06
     +,   2.5267179E-06,   2.6882678E-06,   2.8576546E-06
     +,   3.0350654E-06,   3.2207049E-06,   3.4147508E-06
     +,   3.6173799E-06,   3.8287499E-06,   4.0490354E-06
     +,   4.2783754E-06,   4.5168986E-06,   4.7647482E-06
     +,   5.0220306E-06,   5.2888354E-06,   5.5652749E-06
     +,   5.8514042E-06,   6.1473111E-06,   6.4530363E-06
     +,   6.7686219E-06,   7.0940810E-06,   7.4294553E-06
     +,   7.7747254E-06,   8.1299104E-06,   8.4949797E-06
     +,   8.8699080E-06,   9.2546461E-06,   9.6491794E-06
     +,   1.0053429E-05,   1.0467374E-05,   1.0890933E-05
     +,   1.1324046E-05,   1.1766630E-05,   1.2218648E-05
     +,   1.2680006E-05,   1.3150667E-05,   1.3630556E-05
     +,   1.4119592E-05,   1.4617760E-05,   1.5124974E-05
     +,   1.5641242E-05,   1.6166503E-05,   1.6700733E-05
     +,   1.7243914E-05,   1.7796077E-05,   1.8357223E-05
     +,   1.8927347E-05,   1.9506544E-05,   2.0094849E-05
     +,   2.0692309E-05,   2.1299067E-05,   2.1915179E-05
     +,   2.2540833E-05,   2.3176164E-05,   2.3821347E-05
     +,   2.4476571E-05,   2.5142126E-05,   2.5818243E-05
     +,   2.6505282E-05,   2.7203578E-05,   2.7913509E-05
     +,   2.8635593E-05,   2.9370325E-05,   3.0118275E-05
     +,   3.0880168E-05,   3.1656709E-05,   3.2448723E-05
     +,   3.3257216E-05,   3.4083205E-05,   3.4927827E-05
     +,   3.5792447E-05,   3.6678455E-05,   3.7587411E-05
     +,   3.8520986E-05,   3.9481110E-05,   4.0469709E-05
     +,   4.1488980E-05,   4.2541204E-05,   4.3628785E-05
     +,   4.4754222E-05,   4.5920220E-05,   4.7129586E-05
     +,   4.8385125E-05,   4.9689726E-05,   5.1046372E-05
     +,   5.2457992E-05,   5.3927655E-05,   5.5458451E-05
     +,   5.7053374E-05,   5.8715519E-05,   6.0447921E-05
     +,   6.2253886E-05,   6.4136882E-05,   6.6100474E-05
     +,   6.8148642E-05,   7.0285882E-05,   7.2517236E-05
     +,   7.4848933E-05,   7.7287870E-05,   7.9842728E-05
     +,   8.2523540E-05,   8.5342414E-05,   8.8313755E-05
     +,   9.1454625E-05,   9.4785530E-05,   9.8330675E-05
     +,   1.0211841E-04,   1.0618228E-04,   1.1056182E-04
     +,   1.1530408E-04,   1.2046510E-04,   1.2611128E-04
     +,   1.3232252E-04,   1.3919515E-04,   1.4684554E-04
     +,   1.5541569E-04,   1.6507841E-04,   1.7604305E-04
     +,   1.8856360E-04,   2.0294558E-04,   2.1955144E-04
     +,   2.3880712E-04,   2.6120222E-04,   2.8728467E-04
     +,   3.1765405E-04,   3.5294707E-04,   3.9382806E-04
     +,   4.4097941E-04,   4.9510435E-04,   5.5696111E-04
     +,   6.2741770E-04,   7.0753100E-04,   7.9864374E-04
     +,   9.0242422E-04,   1.0208893E-03,   1.1562799E-03
     +,   1.3108744E-03,   1.4867182E-03,   1.6853510E-03
     +,   1.9076398E-03,   2.1537081E-03,   2.4229621E-03
     +,   2.7142416E-03,   3.0260263E-03,   3.3569194E-03
     +,   3.7064969E-03,   4.0769107E-03,   4.4745901E-03
     +,   4.9116462E-03,   5.4062707E-03,   5.9825950E-03
     +,   6.6701835E-03,   7.5005232E-03,   8.4948484E-03
     +,   9.6420404E-03,   1.0881750E-02,   1.2117923E-02
     +,   1.3264265E-02,   1.4284248E-02,   1.5195699E-02
     +,   1.6066199E-02,   1.7026765E-02,   1.8244069E-02
     +,   1.9791424E-02,   2.1513039E-02,   2.3087712E-02
     +,   2.4359025E-02,   2.5581980E-02,   2.7115295E-02
     +,   2.8963845E-02,   3.1070335E-02,   3.3617746E-02
     +,   3.6255572E-02,   3.7865512E-02,   3.7869412E-02
     +,   3.6978006E-02,   3.6315206E-02,   3.6226664E-02
     +,   3.6154803E-02,   3.5672322E-02,   3.4968153E-02
     +,   3.4028448E-02,   3.2503057E-02,   3.0513916E-02
     +,   2.8517283E-02,   2.6609223E-02,   2.4721177E-02
     +,   2.3074731E-02,   2.1923672E-02,   2.1125991E-02
     +,   2.0253187E-02,   1.9011969E-02,   1.7428976E-02
     +,   1.5732007E-02,   1.4191875E-02,   1.3015757E-02
     +,   1.2250438E-02,   1.1749957E-02,   1.1272462E-02
     +,   1.0633510E-02,   9.7892368E-03,   8.8098748E-03
     +,   7.8020012E-03,   6.8470398E-03,   5.9812255E-03
     +,   5.2041542E-03,   4.4986601E-03,   3.8483273E-03
     +,   3.2463612E-03,   2.6957623E-03,   2.2039795E-03
     +,   1.7773421E-03,   1.4176588E-03,   1.1217726E-03
     +,   8.8293210E-04,   6.9260033E-04,   5.4212904E-04
     +,   4.2364391E-04,   3.3048485E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wao_hz_100 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wao_hz_105(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  1.3447944E-11,   1.5766308E-11
     +,   1.8466711E-11,   2.1608867E-11,   2.5261447E-11
     +,   2.9503216E-11,   3.4424141E-11,   4.0127436E-11
     +,   4.6730918E-11,   5.4368843E-11,   6.3194554E-11
     +,   7.3382592E-11,   8.5131791E-11,   9.8667338E-11
     +,   1.1424543E-10,   1.3215670E-10,   1.5272922E-10
     +,   1.7633529E-10,   2.0339551E-10,   2.3438312E-10
     +,   2.6983307E-10,   3.1034830E-10,   3.5660389E-10
     +,   4.0936107E-10,   4.6947463E-10,   5.3789917E-10
     +,   6.1570549E-10,   7.0409412E-10,   8.0439772E-10
     +,   9.1811092E-10,   1.0468985E-09,   1.1926046E-09
     +,   1.3572911E-09,   1.5432410E-09,   1.7529851E-09
     +,   1.9893254E-09,   2.2553772E-09,   2.5545548E-09
     +,   2.8906482E-09,   3.2678293E-09,   3.6906949E-09
     +,   4.1642849E-09,   4.6941442E-09,   5.2863598E-09
     +,   5.9476042E-09,   6.6851435E-09,   7.5069657E-09
     +,   8.4217335E-09,   9.4389350E-09,   1.0568863E-08
     +,   1.1822774E-08,   1.3212768E-08,   1.4752063E-08
     +,   1.6454971E-08,   1.8336884E-08,   2.0414488E-08
     +,   2.2705837E-08,   2.5230193E-08,   2.8008444E-08
     +,   3.1062996E-08,   3.4417770E-08,   3.8098488E-08
     +,   4.2132740E-08,   4.6549733E-08,   5.1380844E-08
     +,   5.6659530E-08,   6.2421066E-08,   6.8703244E-08
     +,   7.5546154E-08,   8.2991825E-08,   9.1085155E-08
     +,   9.9873354E-08,   1.0940643E-07,   1.1973663E-07
     +,   1.3091937E-07,   1.4301197E-07,   1.5607618E-07
     +,   1.7017508E-07,   1.8537462E-07,   2.0174552E-07
     +,   2.1935965E-07,   2.3829182E-07,   2.5862192E-07
     +,   2.8043110E-07,   3.0380303E-07,   3.2882767E-07
     +,   3.5559398E-07,   3.8419844E-07,   4.1473774E-07
     +,   4.4731271E-07,   4.8202617E-07,   5.1898854E-07
     +,   5.5831003E-07,   6.0010359E-07,   6.4449119E-07
     +,   6.9159370E-07,   7.4153633E-07,   7.9445346E-07
     +,   8.5047651E-07,   9.0975072E-07,   9.7241912E-07
     +,   1.0386335E-06,   1.1085478E-06,   1.1823312E-06
     +,   1.2601492E-06,   1.3421856E-06,   1.4286239E-06
     +,   1.5196598E-06,   1.6154943E-06,   1.7163495E-06
     +,   1.8224448E-06,   1.9340264E-06,   2.0513414E-06
     +,   2.1746550E-06,   2.3042403E-06,   2.4404030E-06
     +,   2.5834424E-06,   2.7336973E-06,   2.8915063E-06
     +,   3.0572262E-06,   3.2312505E-06,   3.4139657E-06
     +,   3.6058029E-06,   3.8071937E-06,   4.0185901E-06
     +,   4.2404581E-06,   4.4733024E-06,   4.7176209E-06
     +,   4.9739178E-06,   5.2427436E-06,   5.5246305E-06
     +,   5.8201081E-06,   6.1297515E-06,   6.4540845E-06
     +,   6.7936789E-06,   7.1490572E-06,   7.5207472E-06
     +,   7.9092379E-06,   8.3150444E-06,   8.7385879E-06
     +,   9.1803277E-06,   9.6406266E-06,   1.0119805E-05
     +,   1.0618188E-05,   1.1135988E-05,   1.1673359E-05
     +,   1.2230459E-05,   1.2807308E-05,   1.3403870E-05
     +,   1.4020105E-05,   1.4655840E-05,   1.5310843E-05
     +,   1.5984904E-05,   1.6677697E-05,   1.7388869E-05
     +,   1.8118046E-05,   1.8864928E-05,   1.9629113E-05
     +,   2.0410385E-05,   2.1208498E-05,   2.2023360E-05
     +,   2.2854967E-05,   2.3703591E-05,   2.4569734E-05
     +,   2.5454096E-05,   2.6357740E-05,   2.7282098E-05
     +,   2.8228982E-05,   2.9200763E-05,   3.0200323E-05
     +,   3.1231040E-05,   3.2296924E-05,   3.3402583E-05
     +,   3.4553414E-05,   3.5755478E-05,   3.7015507E-05
     +,   3.8340997E-05,   3.9740175E-05,   4.1222011E-05
     +,   4.2796350E-05,   4.4473592E-05,   4.6265137E-05
     +,   4.8182985E-05,   5.0239956E-05,   5.2449715E-05
     +,   5.4826782E-05,   5.7386813E-05,   6.0146744E-05
     +,   6.3124702E-05,   6.6340850E-05,   6.9817484E-05
     +,   7.3580326E-05,   7.7659242E-05,   8.2089224E-05
     +,   8.6912434E-05,   9.2180293E-05,   9.7955541E-05
     +,   1.0431601E-04,   1.1135751E-04,   1.1919675E-04
     +,   1.2797557E-04,   1.3786381E-04,   1.4906138E-04
     +,   1.6180036E-04,   1.7634348E-04,   1.9297944E-04
     +,   2.1201713E-04,   2.3377335E-04,   2.5856108E-04
     +,   2.8666947E-04,   3.1834014E-04,   3.5374897E-04
     +,   3.9298361E-04,   4.3602733E-04,   4.8275923E-04
     +,   5.3294859E-04,   5.8629160E-04,   6.4244022E-04
     +,   7.0106576E-04,   7.6192990E-04,   8.2496047E-04
     +,   8.9033070E-04,   9.5851230E-04,   1.0302953E-03
     +,   1.1067829E-03,   1.1893369E-03,   1.2795132E-03
     +,   1.3789558E-03,   1.4893688E-03,   1.6124723E-03
     +,   1.7500550E-03,   1.9040125E-03,   2.0763602E-03
     +,   2.2690531E-03,   2.4835458E-03,   2.7200959E-03
     +,   2.9768529E-03,   3.2490517E-03,   3.5287626E-03
     +,   3.8055237E-03,   4.0680934E-03,   4.3070954E-03
     +,   4.5177164E-03,   4.7014793E-03,   4.8661507E-03
     +,   5.0238087E-03,   5.1877848E-03,   5.3699436E-03
     +,   5.5799093E-03,   5.8264076E-03,   6.1193518E-03
     +,   6.4701624E-03,   6.8879658E-03,   7.3729390E-03
     +,   7.9124719E-03,   8.4878597E-03,   9.0928208E-03
     +,   9.7497543E-03,   1.0500817E-02,   1.1369496E-02
     +,   1.2326504E-02,   1.3307713E-02,   1.4274008E-02
     +,   1.5231230E-02,   1.6170120E-02,   1.7037051E-02
     +,   1.7851362E-02,   1.8802764E-02,   2.0064188E-02
     +,   2.1562023E-02,   2.3186475E-02,   2.5073145E-02
     +,   2.7229765E-02,   2.9141413E-02,   3.0396808E-02
     +,   3.1445317E-02,   3.2966193E-02,   3.4680780E-02
     +,   3.5931766E-02,   3.7345316E-02,   4.0010642E-02
     +,   4.3034617E-02,   4.4340659E-02,   4.3632042E-02
     +,   4.2095616E-02,   4.0522698E-02,   3.9048385E-02
     +,   3.6965061E-02,   3.3461869E-02,   2.8980985E-02
     +,   2.4685442E-02,   2.1078546E-02,   1.7864387E-02
     +,   1.4697393E-02,   1.1563323E-02,   8.6483313E-03
     +,   6.1432295E-03,   4.1509303E-03,   2.6733014E-03
     +,   1.6419842E-03,   9.6148317E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wao_hz_105 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wao_hz_107(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  8.6185513E-13,   1.0303819E-12
     +,   1.2306396E-12,   1.4683500E-12,   1.7502321E-12
     +,   2.0841586E-12,   2.4793147E-12,   2.9464558E-12
     +,   3.4981378E-12,   4.1489724E-12,   4.9159882E-12
     +,   5.8190085E-12,   6.8810834E-12,   8.1288613E-12
     +,   9.5933660E-12,   1.1310484E-11,   1.3321642E-11
     +,   1.5674788E-11,   1.8425315E-11,   2.1636883E-11
     +,   2.5382963E-11,   2.9748086E-11,   3.4829115E-11
     +,   4.0737448E-11,   4.7600826E-11,   5.5565087E-11
     +,   6.4797417E-11,   7.5488928E-11,   8.7856736E-11
     +,   1.0214948E-10,   1.1864965E-10,   1.3767801E-10
     +,   1.5959926E-10,   1.8482778E-10,   2.1383149E-10
     +,   2.4714092E-10,   2.8535693E-10,   3.2915481E-10
     +,   3.7929834E-10,   4.3664869E-10,   5.0217308E-10
     +,   5.7695737E-10,   6.6222272E-10,   7.5933704E-10
     +,   8.6983498E-10,   9.9542397E-10,   1.1380262E-09
     +,   1.2997680E-09,   1.4830328E-09,   1.6904709E-09
     +,   1.9250272E-09,   2.1899660E-09,   2.4889188E-09
     +,   2.8259060E-09,   3.2053609E-09,   3.6321952E-09
     +,   4.1118473E-09,   4.6502602E-09,   5.2540301E-09
     +,   5.9303988E-09,   6.6872792E-09,   7.5333997E-09
     +,   8.4783274E-09,   9.5324699E-09,   1.0707251E-08
     +,   1.2015161E-08,   1.3469730E-08,   1.5085760E-08
     +,   1.6879373E-08,   1.8867961E-08,   2.1070516E-08
     +,   2.3507516E-08,   2.6201262E-08,   2.9175604E-08
     +,   3.2456587E-08,   3.6071867E-08,   4.0051834E-08
     +,   4.4428596E-08,   4.9236700E-08,   5.4513677E-08
     +,   6.0299215E-08,   6.6635636E-08,   7.3568984E-08
     +,   8.1147597E-08,   8.9422855E-08,   9.8450585E-08
     +,   1.0828848E-07,   1.1899949E-07,   1.3064916E-07
     +,   1.4330722E-07,   1.5704676E-07,   1.7194665E-07
     +,   1.8808868E-07,   2.0555841E-07,   2.2444829E-07
     +,   2.4485311E-07,   2.6687218E-07,   2.9061229E-07
     +,   3.1618137E-07,   3.4369640E-07,   3.7327607E-07
     +,   4.0504537E-07,   4.3913309E-07,   4.7567701E-07
     +,   5.1481476E-07,   5.5669511E-07,   6.0146749E-07
     +,   6.4928804E-07,   7.0031626E-07,   7.5472309E-07
     +,   8.1267615E-07,   8.7435717E-07,   9.3994691E-07
     +,   1.0096334E-06,   1.0836067E-06,   1.1620714E-06
     +,   1.2452253E-06,   1.3332851E-06,   1.4264626E-06
     +,   1.5249743E-06,   1.6290563E-06,   1.7389319E-06
     +,   1.8548516E-06,   1.9770564E-06,   2.1058006E-06
     +,   2.2413406E-06,   2.3839571E-06,   2.5339245E-06
     +,   2.6915254E-06,   2.8570719E-06,   3.0308697E-06
     +,   3.2132364E-06,   3.4045236E-06,   3.6050710E-06
     +,   3.8152652E-06,   4.0354876E-06,   4.2661468E-06
     +,   4.5076631E-06,   4.7605113E-06,   5.0251510E-06
     +,   5.3021095E-06,   5.5919149E-06,   5.8951250E-06
     +,   6.2123659E-06,   6.5442650E-06,   6.8914883E-06
     +,   7.2547809E-06,   7.6348915E-06,   8.0326145E-06
     +,   8.4488383E-06,   8.8844545E-06,   9.3404042E-06
     +,   9.8177461E-06,   1.0317537E-05,   1.0840917E-05
     +,   1.1389070E-05,   1.1963321E-05,   1.2564971E-05
     +,   1.3195501E-05,   1.3856413E-05,   1.4549312E-05
     +,   1.5275891E-05,   1.6037995E-05,   1.6837617E-05
     +,   1.7676808E-05,   1.8557810E-05,   1.9483026E-05
     +,   2.0455018E-05,   2.1476611E-05,   2.2550888E-05
     +,   2.3681099E-05,   2.4870800E-05,   2.6123815E-05
     +,   2.7444385E-05,   2.8837103E-05,   3.0306821E-05
     +,   3.1858825E-05,   3.3498771E-05,   3.5232606E-05
     +,   3.7066842E-05,   3.9007988E-05,   4.1063115E-05
     +,   4.3239241E-05,   4.5543526E-05,   4.7983089E-05
     +,   5.0564766E-05,   5.3295353E-05,   5.6181187E-05
     +,   5.9227903E-05,   6.2440646E-05,   6.5823966E-05
     +,   6.9382178E-05,   7.3119671E-05,   7.7040895E-05
     +,   8.1151738E-05,   8.5460430E-05,   8.9978843E-05
     +,   9.4724921E-05,   9.9724704E-05,   1.0501466E-04
     +,   1.1064539E-04,   1.1668505E-04,   1.2322261E-04
     +,   1.3037240E-04,   1.3827723E-04,   1.4711051E-04
     +,   1.5707940E-04,   1.6842409E-04,   1.8141815E-04
     +,   1.9636359E-04,   2.1358253E-04,   2.3340755E-04
     +,   2.5616592E-04,   2.8215858E-04,   3.1164062E-04
     +,   3.4478604E-04,   3.8166792E-04,   4.2221986E-04
     +,   4.6621662E-04,   5.1325443E-04,   5.6274346E-04
     +,   6.1392755E-04,   6.6591386E-04,   7.1773306E-04
     +,   7.6843717E-04,   8.1721792E-04,   8.6356781E-04
     +,   9.0742920E-04,   9.4938657E-04,   9.9080650E-04
     +,   1.0339576E-03,   1.0820494E-03,   1.1391783E-03
     +,   1.2101326E-03,   1.3000480E-03,   1.4139196E-03
     +,   1.5560058E-03,   1.7292253E-03,   1.9347315E-03
     +,   2.1717914E-03,   2.4380584E-03,   2.7302220E-03
     +,   3.0446404E-03,   3.3776520E-03,   3.7250312E-03
     +,   4.0808865E-03,   4.4364473E-03,   4.7795493E-03
     +,   5.0960947E-03,   5.3737056E-03,   5.6067761E-03
     +,   5.8011203E-03,   5.9749195E-03,   6.1540562E-03
     +,   6.3622487E-03,   6.6105323E-03,   6.8929065E-03
     +,   7.1919505E-03,   7.4907946E-03,   7.7813501E-03
     +,   8.0615152E-03,   8.3271908E-03,   8.5747149E-03
     +,   8.8208215E-03,   9.1244578E-03,   9.5818378E-03
     +,   1.0280551E-02,   1.1235839E-02,   1.2362470E-02
     +,   1.3520420E-02,   1.4594588E-02,   1.5513127E-02
     +,   1.6196989E-02,   1.6581669E-02,   1.6767994E-02
     +,   1.7083403E-02,   1.7853627E-02,   1.9102426E-02
     +,   2.0569602E-02,   2.2024129E-02,   2.3437854E-02
     +,   2.4862567E-02,   2.6268099E-02,   2.7517352E-02
     +,   2.8699070E-02,   3.0334894E-02,   3.2453880E-02
     +,   3.4072399E-02,   3.4557849E-02,   3.4389712E-02
     +,   3.4196373E-02,   3.3844352E-02,   3.2286968E-02
     +,   2.8569138E-02,   2.3122659E-02,   1.7360462E-02
     +,   1.2318757E-02,   8.2757194E-03,   5.1883413E-03
     +,   2.9806970E-03,   1.5475815E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wao_hz_107 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wao_hz_110(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  2.0643908E-15,   2.5954771E-15
     +,   3.2593597E-15,   4.0881999E-15,   5.1217592E-15
     +,   6.4090718E-15,   8.0104456E-15,   1.0000126E-14
     +,   1.2469310E-14,   1.5529765E-14,   1.9318553E-14
     +,   2.4003291E-14,   2.9789112E-14,   3.6925653E-14
     +,   4.5717885E-14,   5.6537132E-14,   6.9833875E-14
     +,   8.6156065E-14,   1.0616819E-13,   1.3067358E-13
     +,   1.6064572E-13,   1.9726022E-13,   2.4193272E-13
     +,   2.9637181E-13,   3.6263372E-13,   4.4318499E-13
     +,   5.4098880E-13,   6.5960101E-13,   8.0326539E-13
     +,   9.7706825E-13,   1.1870746E-12,   1.4405142E-12
     +,   1.7460003E-12,   2.1137790E-12,   2.5559975E-12
     +,   3.0870818E-12,   3.7241291E-12,   4.4873228E-12
     +,   5.4005298E-12,   6.4919190E-12,   7.7946720E-12
     +,   9.3477830E-12,   1.1197129E-11,   1.3396507E-11
     +,   1.6009026E-11,   1.9108399E-11,   2.2780966E-11
     +,   2.7127241E-11,   3.2264604E-11,   3.8329565E-11
     +,   4.5481036E-11,   5.3902938E-11,   6.3808958E-11
     +,   7.5446496E-11,   8.9100977E-11,   1.0510241E-10
     +,   1.2383171E-10,   1.4572583E-10,   1.7128879E-10
     +,   2.0109855E-10,   2.3581698E-10,   2.7620298E-10
     +,   3.2312472E-10,   3.7757011E-10,   4.4066875E-10
     +,   5.1370691E-10,   5.9814237E-10,   6.9563355E-10
     +,   8.0806190E-10,   9.3755137E-10,   1.0865067E-09
     +,   1.2576419E-09,   1.4540190E-09,   1.6790700E-09
     +,   1.9366715E-09,   2.2311453E-09,   2.5673734E-09
     +,   2.9507852E-09,   3.3874341E-09,   3.8841290E-09
     +,   4.4483963E-09,   5.0885975E-09,   5.8140963E-09
     +,   6.6351937E-09,   7.5632691E-09,   8.6110283E-09
     +,   9.7923163E-09,   1.1122567E-08,   1.2618624E-08
     +,   1.4298999E-08,   1.6183956E-08,   1.8295871E-08
     +,   2.0658939E-08,   2.3299608E-08,   2.6246893E-08
     +,   2.9532119E-08,   3.3189167E-08,   3.7255226E-08
     +,   4.1769876E-08,   4.6776588E-08,   5.2321564E-08
     +,   5.8454791E-08,   6.5229571E-08,   7.2703969E-08
     +,   8.0938896E-08,   9.0000540E-08,   9.9958562E-08
     +,   1.1088735E-07,   1.2286540E-07,   1.3597723E-07
     +,   1.5031013E-07,   1.6595830E-07,   1.8301931E-07
     +,   2.0159612E-07,   2.2179567E-07,   2.4373216E-07
     +,   2.6752141E-07,   2.9328717E-07,   3.2115517E-07
     +,   3.5125535E-07,   3.8372505E-07,   4.1870058E-07
     +,   4.5632734E-07,   4.9674946E-07,   5.4011554E-07
     +,   5.8657446E-07,   6.3628272E-07,   6.8939210E-07
     +,   7.4605526E-07,   8.0643173E-07,   8.7067343E-07
     +,   9.3893095E-07,   1.0113617E-06,   1.0881091E-06
     +,   1.1693257E-06,   1.2551510E-06,   1.3457244E-06
     +,   1.4411766E-06,   1.5416454E-06,   1.6472485E-06
     +,   1.7581152E-06,   1.8743597E-06,   1.9960905E-06
     +,   2.1234293E-06,   2.2564843E-06,   2.3953635E-06
     +,   2.5401971E-06,   2.6911068E-06,   2.8482252E-06
     +,   3.0117249E-06,   3.1817824E-06,   3.3586057E-06
     +,   3.5424664E-06,   3.7336670E-06,   3.9325791E-06
     +,   4.1396465E-06,   4.3554273E-06,   4.5805587E-06
     +,   4.8158395E-06,   5.0621938E-06,   5.3207241E-06
     +,   5.5927217E-06,   5.8797173E-06,   6.1834930E-06
     +,   6.5060822E-06,   6.8498362E-06,   7.2174303E-06
     +,   7.6118849E-06,   8.0366262E-06,   8.4954854E-06
     +,   8.9926807E-06,   9.5328696E-06,   1.0121119E-05
     +,   1.0762969E-05,   1.1464383E-05,   1.2231658E-05
     +,   1.3071471E-05,   1.3990795E-05,   1.4996794E-05
     +,   1.6096899E-05,   1.7298416E-05,   1.8608771E-05
     +,   2.0035024E-05,   2.1583930E-05,   2.3261709E-05
     +,   2.5073792E-05,   2.7024855E-05,   2.9118484E-05
     +,   3.1356834E-05,   3.3740656E-05,   3.6268921E-05
     +,   3.8939026E-05,   4.1746476E-05,   4.4684544E-05
     +,   4.7744659E-05,   5.0916296E-05,   5.4187061E-05
     +,   5.7543330E-05,   6.0970422E-05,   6.4452877E-05
     +,   6.7975714E-05,   7.1525246E-05,   7.5090327E-05
     +,   7.8664547E-05,   8.2248051E-05,   8.5850123E-05
     +,   8.9493100E-05,   9.3216462E-05,   9.7082746E-05
     +,   1.0118398E-04,   1.0564948E-04,   1.1065618E-04
     +,   1.1643978E-04,   1.2330765E-04,   1.3165390E-04
     +,   1.4197176E-04,   1.5486869E-04,   1.7107227E-04
     +,   1.9143159E-04,   2.1690414E-04,   2.4852238E-04
     +,   2.8734282E-04,   3.3436375E-04,   3.9041523E-04
     +,   4.5604206E-04,   5.3137692E-04,   6.1605085E-04
     +,   7.0911873E-04,   8.0910773E-04,   9.1410289E-04
     +,   1.0219701E-03,   1.1306313E-03,   1.2384134E-03
     +,   1.3443698E-03,   1.4485436E-03,   1.5521309E-03
     +,   1.6574404E-03,   1.7676407E-03,   1.8863274E-03
     +,   2.0169823E-03,   2.1624905E-03,   2.3249281E-03
     +,   2.5056067E-03,   2.7052492E-03,   2.9238970E-03
     +,   3.1604501E-03,   3.4120199E-03,   3.6735886E-03
     +,   3.9388486E-03,   4.2024590E-03,   4.4631679E-03
     +,   4.7270558E-03,   5.0087017E-03,   5.3281123E-03
     +,   5.7017901E-03,   6.1298227E-03,   6.5859002E-03
     +,   7.0186323E-03,   7.3672635E-03,   7.5853011E-03
     +,   7.6598497E-03,   7.6183281E-03,   7.5227222E-03
     +,   7.4532442E-03,   7.4814497E-03,   7.6380093E-03
     +,   7.8952890E-03,   8.1874598E-03,   8.4627923E-03
     +,   8.7260883E-03,   9.0294378E-03,   9.4150854E-03
     +,   9.8600350E-03,   1.0271904E-02,   1.0546385E-02
     +,   1.0651551E-02,   1.0676917E-02,   1.0801173E-02
     +,   1.1197534E-02,   1.1939345E-02,   1.2936523E-02
     +,   1.3915678E-02,   1.4504128E-02,   1.4447237E-02
     +,   1.3816604E-02,   1.3000985E-02,   1.2460710E-02
     +,   1.2445739E-02,   1.2884070E-02,   1.3469900E-02
     +,   1.3839772E-02,   1.3720999E-02,   1.3001233E-02
     +,   1.1721517E-02,   1.0030261E-02,   8.1312684E-03
     +,   6.2342798E-03,   4.5113009E-03,   3.0728206E-03
     +,   1.9640250E-03,   1.1751233E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wao_hz_110 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wao_hz_115(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  4.8288061E-28,   8.4116223E-28
     +,   1.4609854E-27,   2.5300601E-27,   4.3685615E-27
     +,   7.5209875E-27,   1.2910114E-26,   2.2095761E-26
     +,   3.7706386E-26,   6.4156338E-26,   1.0883943E-25
     +,   1.8410192E-25,   3.1049750E-25,   5.2212583E-25
     +,   8.7541867E-25,   1.4634779E-24,   2.4393492E-24
     +,   4.0540126E-24,   6.7177501E-24,   1.1098938E-23
     +,   1.8283600E-23,   3.0031067E-23,   4.9181151E-23
     +,   8.0306255E-23,   1.3074560E-22,   2.1223895E-22
     +,   3.4351530E-22,   5.5436399E-22,   8.9199181E-22
     +,   1.4310437E-21,   2.2891297E-21,   3.6509632E-21
     +,   5.8058810E-21,   9.2056623E-21,   1.4553354E-20
     +,   2.2939996E-20,   3.6053759E-20,   5.6497360E-20
     +,   8.8273161E-20,   1.3751557E-19,   2.1360092E-19
     +,   3.3080568E-19,   5.1081856E-19,   7.8647180E-19
     +,   1.2073331E-18,   1.8479517E-18,   2.8202055E-18
     +,   4.2913229E-18,   6.5106530E-18,   9.8487432E-18
     +,   1.4854734E-17,   2.2339182E-17,   3.3496100E-17
     +,   5.0078047E-17,   7.4648471E-17,   1.1094723E-16
     +,   1.6441427E-16,   2.4293074E-16,   3.5788966E-16
     +,   5.2570486E-16,   7.6993648E-16,   1.1243218E-15
     +,   1.6370178E-15,   2.3764928E-15,   3.4398709E-15
     +,   4.9644914E-15,   7.1437751E-15,   1.0249515E-14
     +,   1.4662411E-14,   2.0913572E-14,   2.9742234E-14
     +,   4.2173872E-14,   5.9626417E-14,   8.4053153E-14
     +,   1.1813970E-13,   1.6555988E-13,   2.3133614E-13
     +,   3.2229655E-13,   4.4769762E-13,   6.2007344E-13
     +,   8.5629675E-13,   1.1790283E-12,   1.6186462E-12
     +,   2.2156615E-12,   3.0239372E-12,   4.1150091E-12
     +,   5.5832452E-12,   7.5532029E-12,   1.0188231E-11
     +,   1.3702178E-11,   1.8373799E-11,   2.4566104E-11
     +,   3.2748936E-11,   4.3528792E-11,   5.7687750E-11
     +,   7.6227968E-11,   1.0043009E-10,   1.3192913E-10
     +,   1.7279708E-10,   2.2566299E-10,   2.9383740E-10
     +,   3.8148509E-10,   4.9381743E-10,   6.3735772E-10
     +,   8.2019830E-10,   1.0524042E-09,   1.3463838E-09
     +,   1.7174285E-09,   2.1842781E-09,   2.7699014E-09
     +,   3.5021934E-09,   4.4151238E-09,   5.5496958E-09
     +,   6.9553430E-09,   8.6913605E-09,   1.0828884E-08
     +,   1.3452388E-08,   1.6662566E-08,   2.0578224E-08
     +,   2.5339235E-08,   3.1110432E-08,   3.8083634E-08
     +,   4.6483358E-08,   5.6569181E-08,   6.8641306E-08
     +,   8.3044561E-08,   1.0017595E-07,   1.2048675E-07
     +,   1.4448912E-07,   1.7276570E-07,   2.0596973E-07
     +,   2.4483285E-07,   2.9017650E-07,   3.4290647E-07
     +,   4.0403151E-07,   4.7465562E-07,   5.5598804E-07
     +,   6.4934193E-07,   7.5614997E-07,   8.7793768E-07
     +,   1.0163565E-06,   1.1731474E-06,   1.3501472E-06
     +,   1.5493042E-06,   1.7726251E-06,   2.0221808E-06
     +,   2.3001212E-06,   2.6085982E-06,   2.9497664E-06
     +,   3.3258077E-06,   3.7388147E-06,   4.1907979E-06
     +,   4.6837131E-06,   5.2193182E-06,   5.7991992E-06
     +,   6.4246983E-06,   7.0969659E-06,   7.8167532E-06
     +,   8.5845768E-06,   9.4004963E-06,   1.0264190E-05
     +,   1.1174855E-05,   1.2131305E-05,   1.3131870E-05
     +,   1.4174315E-05,   1.5255943E-05,   1.6373564E-05
     +,   1.7523458E-05,   1.8701552E-05,   1.9903353E-05
     +,   2.1123898E-05,   2.2357957E-05,   2.3600003E-05
     +,   2.4844428E-05,   2.6085549E-05,   2.7317594E-05
     +,   2.8534960E-05,   2.9732277E-05,   3.0904470E-05
     +,   3.2047086E-05,   3.3156070E-05,   3.4228280E-05
     +,   3.5261284E-05,   3.6253667E-05,   3.7205114E-05
     +,   3.8116501E-05,   3.8990089E-05,   3.9829582E-05
     +,   4.0640185E-05,   4.1428761E-05,   4.2203927E-05
     +,   4.2976204E-05,   4.3758067E-05,   4.4563989E-05
     +,   4.5410638E-05,   4.6316949E-05,   4.7304227E-05
     +,   4.8396341E-05,   4.9619870E-05,   5.1004074E-05
     +,   5.2581308E-05,   5.4387066E-05,   5.6460220E-05
     +,   5.8843470E-05,   6.1583538E-05,   6.4731212E-05
     +,   6.8341928E-05,   7.2475777E-05,   7.7198078E-05
     +,   8.2579201E-05,   8.8693603E-05,   9.5619856E-05
     +,   1.0343909E-04,   1.1223306E-04,   1.2208335E-04
     +,   1.3306651E-04,   1.4525533E-04,   1.5871460E-04
     +,   1.7350439E-04,   1.8968405E-04,   2.0732057E-04
     +,   2.2650533E-04,   2.4737327E-04,   2.7012604E-04
     +,   2.9506008E-04,   3.2258994E-04,   3.5326890E-04
     +,   3.8778607E-04,   4.2696687E-04,   4.7174032E-04
     +,   5.2310998E-04,   5.8211142E-04,   6.4977905E-04
     +,   7.2710344E-04,   8.1497629E-04,   9.1412989E-04
     +,   1.0250183E-03,   1.1476312E-03,   1.2812461E-03
     +,   1.4240879E-03,   1.5729708E-03,   1.7230697E-03
     +,   1.8679225E-03,   1.9999025E-03,   2.1111905E-03
     +,   2.1953676E-03,   2.2493519E-03,   2.2752832E-03
     +,   2.2817610E-03,   2.2837005E-03,   2.3002708E-03
     +,   2.3508901E-03,   2.4500319E-03,   2.6024468E-03
     +,   2.8006204E-03,   3.0259537E-03,   3.2539554E-03
     +,   3.4622203E-03,   3.6389369E-03,   3.7888244E-03
     +,   3.9334334E-03,   4.1040028E-03,   4.3279384E-03
     +,   4.6140756E-03,   4.9444092E-03,   5.2777943E-03
     +,   5.5634254E-03,   5.7552024E-03,   5.8196308E-03
     +,   5.7399091E-03,   5.5243759E-03,   5.2179769E-03
     +,   4.9005430E-03,   4.6579158E-03,   4.5384639E-03
     +,   4.5302864E-03,   4.5827325E-03,   4.6557961E-03
     +,   4.7535873E-03,   4.9136179E-03,   5.1647965E-03
     +,   5.4924744E-03,   5.8366992E-03,   6.1193374E-03
     +,   6.2759030E-03,   6.2727216E-03,   6.1068400E-03
     +,   5.7978360E-03,   5.3793932E-03,   4.8924806E-03
     +,   4.3783560E-03,   3.8714830E-03,   3.3939739E-03
     +,   2.9542411E-03,   2.5498481E-03,   2.1734545E-03
     +,   1.8190612E-03,   1.4857778E-03,   1.1782718E-03
     +,   9.0406876E-04,   6.7002606E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wao_hz_115 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wao_hz_120(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   2.2794073E-38
     +,   5.0270428E-38,   1.1041057E-37,   2.4149395E-37
     +,   5.2602857E-37,   1.1410725E-36,   2.4650434E-36
     +,   5.3031839E-36,   1.1361951E-35,   2.4242089E-35
     +,   5.1510754E-35,   1.0900003E-34,   2.2969917E-34
     +,   4.8205109E-34,   1.0074670E-33,   2.0968760E-33
     +,   4.3463239E-33,   8.9715808E-33,   1.8442507E-32
     +,   3.7755633E-32,   7.6973457E-32,   1.5628036E-31
     +,   3.1599141E-31,   6.3627563E-31,   1.2759082E-30
     +,   2.5480194E-30,   5.0673997E-30,   1.0036179E-29
     +,   1.9795314E-29,   3.8882476E-29,   7.6058819E-29
     +,   1.4816853E-28,   2.8744731E-28,   5.5534941E-28
     +,   1.0685138E-27,   2.0473706E-27,   3.9067319E-27
     +,   7.4239484E-27,   1.4049644E-26,   2.6478489E-26
     +,   4.9697192E-26,   9.2888735E-26,   1.7290464E-25
     +,   3.2052069E-25,   5.9169523E-25,   1.0878126E-24
     +,   1.9916555E-24,   3.6313397E-24,   6.5937684E-24
     +,   1.1923523E-23,   2.1471781E-23,   3.8507519E-23
     +,   6.8773152E-23,   1.2232157E-22,   2.1666629E-22
     +,   3.8219389E-22,   6.7138298E-22,   1.1745486E-21
     +,   2.0463229E-21,   3.5503525E-21,   6.1345532E-21
     +,   1.0555938E-20,   1.8088598E-20,   3.0869204E-20
     +,   5.2461833E-20,   8.8791338E-20,   1.4965980E-19
     +,   2.5121209E-19,   4.1992349E-19,   6.9906026E-19
     +,   1.1589175E-18,   1.9133904E-18,   3.1459891E-18
     +,   5.1512871E-18,   8.3997916E-18,   1.3640631E-17
     +,   2.2059449E-17,   3.5527715E-17,   5.6982725E-17
     +,   9.1017151E-17,   1.4477658E-16,   2.2934314E-16
     +,   3.6180046E-16,   5.6841205E-16,   8.8932700E-16
     +,   1.3856538E-15,   2.1501089E-15,   3.3224766E-15
     +,   5.1129818E-15,   7.8359179E-15,   1.1959428E-14
     +,   1.8177193E-14,   2.7514015E-14,   4.1474738E-14
     +,   6.2260364E-14,   9.3078533E-14,   1.3857717E-13
     +,   2.0546107E-13,   3.0337449E-13,   4.4609195E-13
     +,   6.5325284E-13,   9.5266611E-13,   1.3835801E-12
     +,   2.0010805E-12,   2.8822791E-12,   4.1343235E-12
     +,   5.9058513E-12,   8.4016353E-12,   1.1902635E-11
     +,   1.6793171E-11,   2.3595284E-11,   3.3015292E-11
     +,   4.6006112E-11,   6.3843805E-11,   8.8230916E-11
     +,   1.2143153E-10,   1.6643546E-10,   2.2717379E-10
     +,   3.0880196E-10,   4.1802825E-10,   5.6355265E-10
     +,   7.5659262E-10,   1.0115758E-09,   1.3468943E-09
     +,   1.7859810E-09,   2.3584372E-09,   3.1015239E-09
     +,   4.0618615E-09,   5.2975953E-09,   6.8808217E-09
     +,   8.9003187E-09,   1.1465023E-08,   1.4707790E-08
     +,   1.8789686E-08,   2.3905361E-08,   3.0288582E-08
     +,   3.8217856E-08,   4.8023850E-08,   6.0096319E-08
     +,   7.4893151E-08,   9.2948831E-08,   1.1488134E-07
     +,   1.4140299E-07,   1.7332897E-07,   2.1158465E-07
     +,   2.5721968E-07,   3.1140434E-07,   3.7544964E-07
     +,   4.5079884E-07,   5.3903540E-07,   6.4188254E-07
     +,   7.6119227E-07,   8.9895286E-07,   1.0572704E-06
     +,   1.2383371E-06,   1.4444253E-06,   1.6778482E-06
     +,   1.9409476E-06,   2.2360484E-06,   2.5653824E-06
     +,   2.9310734E-06,   3.3350700E-06,   3.7790669E-06
     +,   4.2645001E-06,   4.7924468E-06,   5.3635226E-06
     +,   5.9778704E-06,   6.6350858E-06,   7.3341298E-06
     +,   8.0733598E-06,   8.8504521E-06,   9.6622989E-06
     +,   1.0505085E-05,   1.1374234E-05,   1.2264533E-05
     +,   1.3170143E-05,   1.4084630E-05,   1.5001297E-05
     +,   1.5913496E-05,   1.6815229E-05,   1.7702338E-05
     +,   1.8574034E-05,   1.9435964E-05,   2.0304389E-05
     +,   2.1212760E-05,   2.2220853E-05,   2.3426928E-05
     +,   2.4983292E-05,   2.7114595E-05,   3.0138104E-05
     +,   3.4485311E-05,   4.0722967E-05,   4.9574424E-05
     +,   6.1936196E-05,   7.8895784E-05,   1.0173456E-04
     +,   1.3191522E-04,   1.7102671E-04,   2.2067376E-04
     +,   2.8228425E-04,   3.5684611E-04,   4.4464762E-04
     +,   5.4511696E-04,   6.5690896E-04,   7.7836413E-04
     +,   9.0826437E-04,   1.0466292E-03,   1.1950791E-03
     +,   1.3561660E-03,   1.5314552E-03,   1.7186534E-03
     +,   1.9090481E-03,   2.0868031E-03,   2.2312289E-03
     +,   2.3221350E-03,   2.3465664E-03,   2.3043836E-03
     +,   2.2104317E-03,   2.0923081E-03,   1.9843073E-03
     +,   1.9191875E-03,   1.9197284E-03,   1.9922091E-03
     +,   2.1239961E-03,   2.2869017E-03,   2.4462244E-03
     +,   2.5724929E-03,   2.6507492E-03,   2.6829035E-03
     +,   2.6822835E-03,   2.6642110E-03,   2.6384848E-03
     +,   2.6077935E-03,   2.5717586E-03,   2.5327192E-03
     +,   2.4990097E-03,   2.4838347E-03,   2.5008230E-03
     +,   2.5587119E-03,   2.6571464E-03,   2.7846729E-03
     +,   2.9198451E-03,   3.0364254E-03,   3.1120472E-03
     +,   3.1370402E-03,   3.1187020E-03,   3.0781748E-03
     +,   3.0411577E-03,   3.0267574E-03,   3.0391393E-03
     +,   3.0651081E-03,   3.0786369E-03,   3.0508710E-03
     +,   2.9617322E-03,   2.8077210E-03,   2.6020578E-03
     +,   2.3674394E-03,   2.1260488E-03,   1.8921862E-03
     +,   1.6707312E-03,   1.4602467E-03,   1.2576749E-03
     +,   1.0617734E-03,   8.7418564E-04,   6.9885328E-04
     +,   5.4049329E-04,   4.0318153E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wao_hz_120 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wao_hz_60(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  1.2049565E-05,   1.2964714E-05
     +,   1.3929741E-05,   1.4945737E-05,   1.6013772E-05
     +,   1.7134831E-05,   1.8309764E-05,   1.9539391E-05
     +,   2.0824460E-05,   2.2165565E-05,   2.3563291E-05
     +,   2.5018109E-05,   2.6530483E-05,   2.8100694E-05
     +,   2.9729070E-05,   3.1415875E-05,   3.3161239E-05
     +,   3.4965371E-05,   3.6828445E-05,   3.8750513E-05
     +,   4.0731720E-05,   4.2772230E-05,   4.4872100E-05
     +,   4.7031506E-05,   4.9250673E-05,   5.1529700E-05
     +,   5.3868884E-05,   5.6268509E-05,   5.8728798E-05
     +,   6.1250088E-05,   6.3832806E-05,   6.6477158E-05
     +,   6.9183559E-05,   7.1952403E-05,   7.4783849E-05
     +,   7.7678211E-05,   8.0635662E-05,   8.3656130E-05
     +,   8.6739587E-05,   8.9885689E-05,   9.3094081E-05
     +,   9.6363816E-05,   9.9693949E-05,   1.0308312E-04
     +,   1.0652962E-04,   1.1003121E-04,   1.1358543E-04
     +,   1.1718903E-04,   1.2083853E-04,   1.2452972E-04
     +,   1.2825801E-04,   1.3201790E-04,   1.3580351E-04
     +,   1.3960830E-04,   1.4342493E-04,   1.4724561E-04
     +,   1.5106192E-04,   1.5486463E-04,   1.5864406E-04
     +,   1.6239013E-04,   1.6609189E-04,   1.6973822E-04
     +,   1.7331759E-04,   1.7681789E-04,   1.8022704E-04
     +,   1.8353274E-04,   1.8672236E-04,   1.8978355E-04
     +,   1.9270401E-04,   1.9547157E-04,   1.9807444E-04
     +,   2.0050125E-04,   2.0274121E-04,   2.0478398E-04
     +,   2.0662021E-04,   2.0824117E-04,   2.0963920E-04
     +,   2.1080760E-04,   2.1174070E-04,   2.1243411E-04
     +,   2.1288455E-04,   2.1309005E-04,   2.1304989E-04
     +,   2.1276476E-04,   2.1223660E-04,   2.1146862E-04
     +,   2.1046553E-04,   2.0923308E-04,   2.0777844E-04
     +,   2.0610981E-04,   2.0423674E-04,   2.0216944E-04
     +,   1.9991945E-04,   1.9749906E-04,   1.9492107E-04
     +,   1.9219927E-04,   1.8934799E-04,   1.8638164E-04
     +,   1.8331537E-04,   1.8016413E-04,   1.7694330E-04
     +,   1.7366804E-04,   1.7035364E-04,   1.6701470E-04
     +,   1.6366594E-04,   1.6032135E-04,   1.5699453E-04
     +,   1.5369865E-04,   1.5044613E-04,   1.4724846E-04
     +,   1.4411683E-04,   1.4106114E-04,   1.3809087E-04
     +,   1.3521443E-04,   1.3243961E-04,   1.2977292E-04
     +,   1.2722038E-04,   1.2478683E-04,   1.2247647E-04
     +,   1.2029262E-04,   1.1823762E-04,   1.1631326E-04
     +,   1.1452023E-04,   1.1285875E-04,   1.1132821E-04
     +,   1.0992740E-04,   1.0865426E-04,   1.0750638E-04
     +,   1.0648066E-04,   1.0557340E-04,   1.0478049E-04
     +,   1.0409747E-04,   1.0351923E-04,   1.0304049E-04
     +,   1.0265547E-04,   1.0235825E-04,   1.0214251E-04
     +,   1.0200189E-04,   1.0192958E-04,   1.0191890E-04
     +,   1.0196293E-04,   1.0205464E-04,   1.0218707E-04
     +,   1.0235326E-04,   1.0254623E-04,   1.0275914E-04
     +,   1.0298530E-04,   1.0321809E-04,   1.0345117E-04
     +,   1.0367841E-04,   1.0389395E-04,   1.0409219E-04
     +,   1.0426791E-04,   1.0441622E-04,   1.0453266E-04
     +,   1.0461312E-04,   1.0465398E-04,   1.0465205E-04
     +,   1.0460457E-04,   1.0450939E-04,   1.0436469E-04
     +,   1.0416930E-04,   1.0392249E-04,   1.0362396E-04
     +,   1.0327411E-04,   1.0287364E-04,   1.0242382E-04
     +,   1.0192645E-04,   1.0138367E-04,   1.0079811E-04
     +,   1.0017279E-04,   9.9511191E-05,   9.8817043E-05
     +,   9.8094461E-05,   9.7347802E-05,   9.6581731E-05
     +,   9.5801108E-05,   9.5010982E-05,   9.4216623E-05
     +,   9.3423201E-05,   9.2636197E-05,   9.1860929E-05
     +,   9.1102789E-05,   9.0367168E-05,   8.9659268E-05
     +,   8.8984285E-05,   8.8347173E-05,   8.7752713E-05
     +,   8.7205539E-05,   8.6709952E-05,   8.6270105E-05
     +,   8.5889747E-05,   8.5572348E-05,   8.5321044E-05
     +,   8.5138665E-05,   8.5027626E-05,   8.4990010E-05
     +,   8.5027481E-05,   8.5141313E-05,   8.5332395E-05
     +,   8.5601227E-05,   8.5947882E-05,   8.6372042E-05
     +,   8.6872969E-05,   8.7449640E-05,   8.8100467E-05
     +,   8.8823639E-05,   8.9616842E-05,   9.0477508E-05
     +,   9.1402690E-05,   9.2389077E-05,   9.3433082E-05
     +,   9.4530718E-05,   9.5677788E-05,   9.6869822E-05
     +,   9.8102035E-05,   9.9369507E-05,   1.0066699E-04
     +,   1.0198910E-04,   1.0333023E-04,   1.0468459E-04
     +,   1.0604640E-04,   1.0740968E-04,   1.0876836E-04
     +,   1.1011631E-04,   1.1144730E-04,   1.1275528E-04
     +,   1.1403400E-04,   1.1527741E-04,   1.1647946E-04
     +,   1.1763415E-04,   1.1873562E-04,   1.1977823E-04
     +,   1.2075650E-04,   1.2166506E-04,   1.2249879E-04
     +,   1.2325286E-04,   1.2392263E-04,   1.2450381E-04
     +,   1.2499247E-04,   1.2538485E-04,   1.2567764E-04
     +,   1.2586793E-04,   1.2595305E-04,   1.2593088E-04
     +,   1.2579956E-04,   1.2555772E-04,   1.2520437E-04
     +,   1.2473897E-04,   1.2416132E-04,   1.2347173E-04
     +,   1.2267084E-04,   1.2175977E-04,   1.2074000E-04
     +,   1.1961340E-04,   1.1838231E-04,   1.1704929E-04
     +,   1.1561727E-04,   1.1408962E-04,   1.1246998E-04
     +,   1.1076222E-04,   1.0897063E-04,   1.0709957E-04
     +,   1.0515363E-04,   1.0313775E-04,   1.0105690E-04
     +,   9.8916411E-05,   9.6721451E-05,   9.4477327E-05
     +,   9.2189577E-05,   8.9863686E-05,   8.7505163E-05
     +,   8.5119609E-05,   8.2712380E-05,   8.0288788E-05
     +,   7.7854238E-05,   7.5413947E-05,   7.2973031E-05
     +,   7.0536516E-05,   6.8109024E-05,   6.5695342E-05
     +,   6.3299725E-05,   6.0926504E-05,   5.8579688E-05
     +,   5.6263245E-05,   5.3980388E-05,   5.1734609E-05
     +,   4.9528997E-05,   4.7366397E-05,   4.5249479E-05
     +,   4.3180400E-05,   4.1161449E-05,   3.9194296E-05
     +,   3.7280632E-05,   3.5421821E-05,   3.3619010E-05
     +,   3.1873238E-05,   3.0184921E-05,   2.8554692E-05
     +,   2.6982822E-05,   2.5469395E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wao_hz_60 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wao_hz_65(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  7.6856833E-07,   8.6253732E-07
     +,   9.6671772E-07,   1.0820523E-06,   1.2095601E-06
     +,   1.3503324E-06,   1.5055269E-06,   1.6763870E-06
     +,   1.8642377E-06,   2.0704747E-06,   2.2965892E-06
     +,   2.5441561E-06,   2.8148411E-06,   3.1103830E-06
     +,   3.4326267E-06,   3.7835064E-06,   4.1650255E-06
     +,   4.5792940E-06,   5.0285084E-06,   5.5149253E-06
     +,   6.0409038E-06,   6.6088796E-06,   7.2213288E-06
     +,   7.8808216E-06,   8.5899874E-06,   9.3514700E-06
     +,   1.0167981E-05,   1.1042277E-05,   1.1977076E-05
     +,   1.2975155E-05,   1.4039283E-05,   1.5172149E-05
     +,   1.6376458E-05,   1.7654878E-05,   1.9009916E-05
     +,   2.0444071E-05,   2.1959731E-05,   2.3559067E-05
     +,   2.5244179E-05,   2.7016973E-05,   2.8879202E-05
     +,   3.0832263E-05,   3.2877451E-05,   3.5015742E-05
     +,   3.7247893E-05,   3.9574195E-05,   4.1994805E-05
     +,   4.4509332E-05,   4.7117159E-05,   4.9817252E-05
     +,   5.2608186E-05,   5.5487988E-05,   5.8454370E-05
     +,   6.1504637E-05,   6.4635431E-05,   6.7843095E-05
     +,   7.1123519E-05,   7.4471893E-05,   7.7883138E-05
     +,   8.1351704E-05,   8.4871339E-05,   8.8435554E-05
     +,   9.2037393E-05,   9.5669217E-05,   9.9323239E-05
     +,   1.0299124E-04,   1.0666440E-04,   1.1033380E-04
     +,   1.1399019E-04,   1.1762386E-04,   1.2122502E-04
     +,   1.2478368E-04,   1.2828974E-04,   1.3173283E-04
     +,   1.3510280E-04,   1.3838918E-04,   1.4158204E-04
     +,   1.4467117E-04,   1.4764667E-04,   1.5049908E-04
     +,   1.5321911E-04,   1.5579769E-04,   1.5822669E-04
     +,   1.6049806E-04,   1.6260441E-04,   1.6453923E-04
     +,   1.6629632E-04,   1.6787059E-04,   1.6925756E-04
     +,   1.7045360E-04,   1.7145590E-04,   1.7226278E-04
     +,   1.7287323E-04,   1.7328734E-04,   1.7350611E-04
     +,   1.7353160E-04,   1.7336664E-04,   1.7301521E-04
     +,   1.7248215E-04,   1.7177308E-04,   1.7089468E-04
     +,   1.6985425E-04,   1.6866012E-04,   1.6732098E-04
     +,   1.6584646E-04,   1.6424652E-04,   1.6253180E-04
     +,   1.6071330E-04,   1.5880242E-04,   1.5681055E-04
     +,   1.5474962E-04,   1.5263136E-04,   1.5046757E-04
     +,   1.4827009E-04,   1.4605060E-04,   1.4382023E-04
     +,   1.4159031E-04,   1.3937136E-04,   1.3717377E-04
     +,   1.3500746E-04,   1.3288159E-04,   1.3080516E-04
     +,   1.2878627E-04,   1.2683267E-04,   1.2495150E-04
     +,   1.2314926E-04,   1.2143186E-04,   1.1980470E-04
     +,   1.1827273E-04,   1.1684017E-04,   1.1551098E-04
     +,   1.1428862E-04,   1.1317604E-04,   1.1217604E-04
     +,   1.1129089E-04,   1.1052272E-04,   1.0987344E-04
     +,   1.0934471E-04,   1.0893810E-04,   1.0865503E-04
     +,   1.0849680E-04,   1.0846479E-04,   1.0856021E-04
     +,   1.0878433E-04,   1.0913840E-04,   1.0962373E-04
     +,   1.1024153E-04,   1.1099312E-04,   1.1187974E-04
     +,   1.1290270E-04,   1.1406322E-04,   1.1536237E-04
     +,   1.1680140E-04,   1.1838120E-04,   1.2010266E-04
     +,   1.2196633E-04,   1.2397286E-04,   1.2612229E-04
     +,   1.2841477E-04,   1.3084980E-04,   1.3342671E-04
     +,   1.3614423E-04,   1.3900090E-04,   1.4199485E-04
     +,   1.4512346E-04,   1.4838368E-04,   1.5177189E-04
     +,   1.5528378E-04,   1.5891463E-04,   1.6265910E-04
     +,   1.6651099E-04,   1.7046346E-04,   1.7450894E-04
     +,   1.7863943E-04,   1.8284627E-04,   1.8711982E-04
     +,   1.9144999E-04,   1.9582595E-04,   2.0023626E-04
     +,   2.0466925E-04,   2.0911229E-04,   2.1355283E-04
     +,   2.1797749E-04,   2.2237272E-04,   2.2672478E-04
     +,   2.3101973E-04,   2.3524382E-04,   2.3938346E-04
     +,   2.4342496E-04,   2.4735520E-04,   2.5116131E-04
     +,   2.5483154E-04,   2.5835482E-04,   2.6172076E-04
     +,   2.6492041E-04,   2.6794575E-04,   2.7079060E-04
     +,   2.7345019E-04,   2.7592166E-04,   2.7820378E-04
     +,   2.8029739E-04,   2.8220535E-04,   2.8393281E-04
     +,   2.8548689E-04,   2.8687727E-04,   2.8811567E-04
     +,   2.8921571E-04,   2.9019325E-04,   2.9106630E-04
     +,   2.9185452E-04,   2.9257947E-04,   2.9326358E-04
     +,   2.9393111E-04,   2.9460678E-04,   2.9531636E-04
     +,   2.9608549E-04,   2.9694004E-04,   2.9790544E-04
     +,   2.9900626E-04,   3.0026582E-04,   3.0170594E-04
     +,   3.0334617E-04,   3.0520384E-04,   3.0729311E-04
     +,   3.0962526E-04,   3.1220721E-04,   3.1504242E-04
     +,   3.1812955E-04,   3.2146269E-04,   3.2503120E-04
     +,   3.2881871E-04,   3.3280402E-04,   3.3696089E-04
     +,   3.4125769E-04,   3.4565758E-04,   3.5011960E-04
     +,   3.5459769E-04,   3.5904252E-04,   3.6340152E-04
     +,   3.6761965E-04,   3.7163988E-04,   3.7540434E-04
     +,   3.7885507E-04,   3.8193556E-04,   3.8459073E-04
     +,   3.8676840E-04,   3.8842033E-04,   3.8950273E-04
     +,   3.8997710E-04,   3.8981123E-04,   3.8897921E-04
     +,   3.8746221E-04,   3.8524871E-04,   3.8233461E-04
     +,   3.7872329E-04,   3.7442532E-04,   3.6945794E-04
     +,   3.6384488E-04,   3.5761640E-04,   3.5080753E-04
     +,   3.4345835E-04,   3.3561292E-04,   3.2731774E-04
     +,   3.1862181E-04,   3.0957590E-04,   3.0023171E-04
     +,   2.9064086E-04,   2.8085386E-04,   2.7091987E-04
     +,   2.6088706E-04,   2.5080089E-04,   2.4070448E-04
     +,   2.3063824E-04,   2.2063883E-04,   2.1073976E-04
     +,   2.0097200E-04,   1.9136304E-04,   1.8193698E-04
     +,   1.7271547E-04,   1.6371590E-04,   1.5495445E-04
     +,   1.4644333E-04,   1.3819335E-04,   1.3021285E-04
     +,   1.2250873E-04,   1.1508438E-04,   1.0794342E-04
     +,   1.0108732E-04,   9.4516421E-05,   8.8230139E-05
     +,   8.2226223E-05,   7.6502423E-05,   7.1054892E-05
     +,   6.5879736E-05,   6.0972241E-05,   5.6327139E-05
     +,   5.1939012E-05,   4.7800968E-05,   4.3906748E-05
     +,   4.0249422E-05,   3.6821657E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wao_hz_65 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wao_hz_70(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  1.0532930E-07,   1.2224582E-07
     +,   1.4165016E-07,   1.6386885E-07,   1.8926657E-07
     +,   2.1824864E-07,   2.5126212E-07,   2.8880345E-07
     +,   3.3142044E-07,   3.7971310E-07,   4.3434324E-07
     +,   4.9603477E-07,   5.6558008E-07,   6.4383903E-07
     +,   7.3175011E-07,   8.3033302E-07,   9.4068355E-07
     +,   1.0639909E-06,   1.2015357E-06,   1.3546829E-06
     +,   1.5249027E-06,   1.7137635E-06,   1.9229230E-06
     +,   2.1541518E-06,   2.4093210E-06,   2.6903881E-06
     +,   2.9994246E-06,   3.3385979E-06,   3.7101493E-06
     +,   4.1164249E-06,   4.5598549E-06,   5.0429139E-06
     +,   5.5681662E-06,   6.1382279E-06,   6.7557221E-06
     +,   7.4233262E-06,   8.1437302E-06,   8.9195673E-06
     +,   9.7534830E-06,   1.0648057E-05,   1.1605808E-05
     +,   1.2629096E-05,   1.3720211E-05,   1.4881261E-05
     +,   1.6114198E-05,   1.7420683E-05,   1.8802228E-05
     +,   2.0259959E-05,   2.1794769E-05,   2.3407194E-05
     +,   2.5097415E-05,   2.6865122E-05,   2.8709663E-05
     +,   3.0629944E-05,   3.2624281E-05,   3.4690576E-05
     +,   3.6826241E-05,   3.9028015E-05,   4.1292231E-05
     +,   4.3614673E-05,   4.5990451E-05,   4.8414258E-05
     +,   5.0880288E-05,   5.3382071E-05,   5.5912802E-05
     +,   5.8465263E-05,   6.1031635E-05,   6.3603962E-05
     +,   6.6173940E-05,   6.8732901E-05,   7.1272189E-05
     +,   7.3782969E-05,   7.6256489E-05,   7.8683945E-05
     +,   8.1056882E-05,   8.3366933E-05,   8.5606393E-05
     +,   8.7767810E-05,   8.9844296E-05,   9.1829970E-05
     +,   9.3719420E-05,   9.5508207E-05,   9.7193129E-05
     +,   9.8771736E-05,   1.0024283E-04,   1.0160665E-04
     +,   1.0286440E-04,   1.0401890E-04,   1.0507417E-04
     +,   1.0603560E-04,   1.0690992E-04,   1.0770536E-04
     +,   1.0843125E-04,   1.0909820E-04,   1.0971807E-04
     +,   1.1030357E-04,   1.1086839E-04,   1.1142700E-04
     +,   1.1199430E-04,   1.1258580E-04,   1.1321704E-04
     +,   1.1390354E-04,   1.1466067E-04,   1.1550337E-04
     +,   1.1644578E-04,   1.1750128E-04,   1.1868221E-04
     +,   1.1999954E-04,   1.2146292E-04,   1.2308058E-04
     +,   1.2485898E-04,   1.2680313E-04,   1.2891629E-04
     +,   1.3120013E-04,   1.3365471E-04,   1.3627912E-04
     +,   1.3907073E-04,   1.4202647E-04,   1.4514229E-04
     +,   1.4841366E-04,   1.5183636E-04,   1.5540584E-04
     +,   1.5911873E-04,   1.6297204E-04,   1.6696393E-04
     +,   1.7109381E-04,   1.7536302E-04,   1.7977394E-04
     +,   1.8433055E-04,   1.8903882E-04,   1.9390549E-04
     +,   1.9893845E-04,   2.0414683E-04,   2.0953915E-04
     +,   2.1512472E-04,   2.2091132E-04,   2.2690570E-04
     +,   2.3311231E-04,   2.3953369E-04,   2.4616858E-04
     +,   2.5301267E-04,   2.6005713E-04,   2.6728850E-04
     +,   2.7468978E-04,   2.8223812E-04,   2.8990605E-04
     +,   2.9766260E-04,   3.0547174E-04,   3.1329374E-04
     +,   3.2108658E-04,   3.2880486E-04,   3.3640169E-04
     +,   3.4382986E-04,   3.5104132E-04,   3.5798902E-04
     +,   3.6462728E-04,   3.7091330E-04,   3.7680610E-04
     +,   3.8226912E-04,   3.8726936E-04,   3.9177804E-04
     +,   3.9577085E-04,   3.9922859E-04,   4.0213644E-04
     +,   4.0448442E-04,   4.0626674E-04,   4.0748224E-04
     +,   4.0813390E-04,   4.0822825E-04,   4.0777554E-04
     +,   4.0678887E-04,   4.0528443E-04,   4.0328092E-04
     +,   4.0079904E-04,   3.9786144E-04,   3.9449215E-04
     +,   3.9071683E-04,   3.8656188E-04,   3.8205471E-04
     +,   3.7722234E-04,   3.7209329E-04,   3.6669473E-04
     +,   3.6105441E-04,   3.5519947E-04,   3.4915635E-04
     +,   3.4295116E-04,   3.3660873E-04,   3.3015318E-04
     +,   3.2360863E-04,   3.1699819E-04,   3.1034506E-04
     +,   3.0367187E-04,   2.9700180E-04,   2.9035882E-04
     +,   2.8376820E-04,   2.7725636E-04,   2.7085209E-04
     +,   2.6458609E-04,   2.5849143E-04,   2.5260507E-04
     +,   2.4696632E-04,   2.4161818E-04,   2.3660655E-04
     +,   2.3198026E-04,   2.2779052E-04,   2.2409113E-04
     +,   2.2093747E-04,   2.1838561E-04,   2.1649140E-04
     +,   2.1530993E-04,   2.1489439E-04,   2.1529470E-04
     +,   2.1655665E-04,   2.1872042E-04,   2.2182010E-04
     +,   2.2588162E-04,   2.3092306E-04,   2.3695218E-04
     +,   2.4396669E-04,   2.5195282E-04,   2.6088505E-04
     +,   2.7072619E-04,   2.8142662E-04,   2.9292348E-04
     +,   3.0514182E-04,   3.1799401E-04,   3.3138235E-04
     +,   3.4519591E-04,   3.5931615E-04,   3.7361390E-04
     +,   3.8795287E-04,   4.0219055E-04,   4.1618102E-04
     +,   4.2977644E-04,   4.4282753E-04,   4.5518792E-04
     +,   4.6671517E-04,   4.7727409E-04,   4.8673930E-04
     +,   4.9499678E-04,   5.0194596E-04,   5.0750218E-04
     +,   5.1159895E-04,   5.1418890E-04,   5.1524484E-04
     +,   5.1476061E-04,   5.1275146E-04,   5.0925388E-04
     +,   5.0432462E-04,   4.9803959E-04,   4.9049233E-04
     +,   4.8179150E-04,   4.7205968E-04,   4.6142901E-04
     +,   4.5003946E-04,   4.3803616E-04,   4.2556389E-04
     +,   4.1276621E-04,   3.9978290E-04,   3.8674584E-04
     +,   3.7377709E-04,   3.6098799E-04,   3.4847509E-04
     +,   3.3632078E-04,   3.2459293E-04,   3.1334363E-04
     +,   3.0260955E-04,   2.9241183E-04,   2.8275757E-04
     +,   2.7364164E-04,   2.6504707E-04,   2.5694675E-04
     +,   2.4930594E-04,   2.4208262E-04,   2.3523014E-04
     +,   2.2869973E-04,   2.2244069E-04,   2.1640302E-04
     +,   2.1053814E-04,   2.0479980E-04,   1.9914648E-04
     +,   1.9354036E-04,   1.8794932E-04,   1.8234670E-04
     +,   1.7671191E-04,   1.7102892E-04,   1.6528855E-04
     +,   1.5948666E-04,   1.5362399E-04,   1.4770612E-04
     +,   1.4174187E-04,   1.3574433E-04,   1.2972856E-04
     +,   1.2371241E-04,   1.1771506E-04,   1.1175669E-04
     +,   1.0585832E-04,   1.0003955E-04,   9.4320785E-05
     +,   8.8721099E-05,   8.3258266E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wao_hz_70 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wao_hz_75(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  1.5688610E-07,   1.7157460E-07
     +,   1.8746742E-07,   2.0464473E-07,   2.2319198E-07
     +,   2.4319817E-07,   2.6475516E-07,   2.8795967E-07
     +,   3.1291231E-07,   3.3971600E-07,   3.6847860E-07
     +,   3.9931155E-07,   4.3232984E-07,   4.6765007E-07
     +,   5.0539393E-07,   5.4568585E-07,   5.8865112E-07
     +,   6.3441922E-07,   6.8312278E-07,   7.3489247E-07
     +,   7.8986363E-07,   8.4817276E-07,   9.0995417E-07
     +,   9.7534473E-07,   1.0444821E-06,   1.1174988E-06
     +,   1.1945295E-06,   1.2757080E-06,   1.3611602E-06
     +,   1.4510138E-06,   1.5453933E-06,   1.6444128E-06
     +,   1.7481868E-06,   1.8568250E-06,   1.9704239E-06
     +,   2.0890786E-06,   2.2128791E-06,   2.3418963E-06
     +,   2.4762037E-06,   2.6158607E-06,   2.7609203E-06
     +,   2.9114171E-06,   3.0673846E-06,   3.2288415E-06
     +,   3.3958011E-06,   3.5682569E-06,   3.7462030E-06
     +,   3.9296137E-06,   4.1184639E-06,   4.3127170E-06
     +,   4.5123356E-06,   4.7172648E-06,   4.9274568E-06
     +,   5.1428678E-06,   5.3634408E-06,   5.5891369E-06
     +,   5.8199289E-06,   6.0557868E-06,   6.2967129E-06
     +,   6.5427334E-06,   6.7938890E-06,   7.0502701E-06
     +,   7.3120127E-06,   7.5792859E-06,   7.8523335E-06
     +,   8.1314702E-06,   8.4170715E-06,   8.7096241E-06
     +,   9.0097110E-06,   9.3180151E-06,   9.6353615E-06
     +,   9.9627105E-06,   1.0301183E-05,   1.0652053E-05
     +,   1.1016798E-05,   1.1397062E-05,   1.1794748E-05
     +,   1.2211953E-05,   1.2650999E-05,   1.3114517E-05
     +,   1.3605354E-05,   1.4126626E-05,   1.4681791E-05
     +,   1.5274536E-05,   1.5908836E-05,   1.6589027E-05
     +,   1.7319622E-05,   1.8105531E-05,   1.8951838E-05
     +,   1.9863897E-05,   2.0847228E-05,   2.1907681E-05
     +,   2.3051114E-05,   2.4283483E-05,   2.5610942E-05
     +,   2.7039485E-05,   2.8575027E-05,   3.0223493E-05
     +,   3.1990334E-05,   3.3880948E-05,   3.5900095E-05
     +,   3.8052094E-05,   4.0340561E-05,   4.2768635E-05
     +,   4.5338260E-05,   4.8050828E-05,   5.0906372E-05
     +,   5.3903903E-05,   5.7041019E-05,   6.0314374E-05
     +,   6.3718719E-05,   6.7247849E-05,   7.0893620E-05
     +,   7.4646472E-05,   7.8495112E-05,   8.2427163E-05
     +,   8.6428074E-05,   9.0482434E-05,   9.4572948E-05
     +,   9.8681034E-05,   1.0278738E-04,   1.0687101E-04
     +,   1.1091072E-04,   1.1488413E-04,   1.1876862E-04
     +,   1.2254117E-04,   1.2617922E-04,   1.2966002E-04
     +,   1.3296149E-04,   1.3606265E-04,   1.3894332E-04
     +,   1.4158468E-04,   1.4396991E-04,   1.4608368E-04
     +,   1.4791320E-04,   1.4944783E-04,   1.5067963E-04
     +,   1.5160344E-04,   1.5221715E-04,   1.5252174E-04
     +,   1.5252142E-04,   1.5222371E-04,   1.5163960E-04
     +,   1.5078332E-04,   1.4967262E-04,   1.4832850E-04
     +,   1.4677520E-04,   1.4504006E-04,   1.4315345E-04
     +,   1.4114825E-04,   1.3906002E-04,   1.3692651E-04
     +,   1.3478704E-04,   1.3268269E-04,   1.3065548E-04
     +,   1.2874808E-04,   1.2700299E-04,   1.2546264E-04
     +,   1.2416803E-04,   1.2315890E-04,   1.2247254E-04
     +,   1.2214351E-04,   1.2220285E-04,   1.2267762E-04
     +,   1.2359027E-04,   1.2495810E-04,   1.2679296E-04
     +,   1.2910058E-04,   1.3188097E-04,   1.3512779E-04
     +,   1.3882844E-04,   1.4296458E-04,   1.4751195E-04
     +,   1.5244180E-04,   1.5772124E-04,   1.6331370E-04
     +,   1.6918054E-04,   1.7528213E-04,   1.8157897E-04
     +,   1.8803401E-04,   1.9461210E-04,   2.0128349E-04
     +,   2.0802308E-04,   2.1481251E-04,   2.2164054E-04
     +,   2.2850325E-04,   2.3540488E-04,   2.4235698E-04
     +,   2.4937719E-04,   2.5648880E-04,   2.6371883E-04
     +,   2.7109715E-04,   2.7865364E-04,   2.8641583E-04
     +,   2.9440748E-04,   3.0264634E-04,   3.1114175E-04
     +,   3.1989501E-04,   3.2889729E-04,   3.3812880E-04
     +,   3.4756077E-04,   3.5715516E-04,   3.6686688E-04
     +,   3.7664655E-04,   3.8644247E-04,   3.9620200E-04
     +,   4.0587588E-04,   4.1541934E-04,   4.2479477E-04
     +,   4.3397272E-04,   4.4293096E-04,   4.5165577E-04
     +,   4.6014049E-04,   4.6838363E-04,   4.7638948E-04
     +,   4.8416335E-04,   4.9171346E-04,   4.9904885E-04
     +,   5.0618063E-04,   5.1312300E-04,   5.1989598E-04
     +,   5.2652875E-04,   5.3306337E-04,   5.3955824E-04
     +,   5.4609193E-04,   5.5276608E-04,   5.5970869E-04
     +,   5.6707143E-04,   5.7503051E-04,   5.8378099E-04
     +,   5.9353095E-04,   6.0449285E-04,   6.1687391E-04
     +,   6.3086336E-04,   6.4661645E-04,   6.6424318E-04
     +,   6.8379269E-04,   7.0523954E-04,   7.2847656E-04
     +,   7.5330469E-04,   7.7942852E-04,   8.0646010E-04
     +,   8.3392463E-04,   8.6127658E-04,   8.8791182E-04
     +,   9.1319199E-04,   9.3647244E-04,   9.5712376E-04
     +,   9.7456068E-04,   9.8826934E-04,   9.9782273E-04
     +,   1.0029036E-03,   1.0033109E-03,   9.9896768E-04
     +,   9.8991941E-04,   9.7632944E-04,   9.5846620E-04
     +,   9.3669037E-04,   9.1143942E-04,   8.8320806E-04
     +,   8.5253111E-04,   8.1996532E-04,   7.8606931E-04
     +,   7.5138890E-04,   7.1644667E-04,   6.8172434E-04
     +,   6.4765551E-04,   6.1461277E-04,   5.8290327E-04
     +,   5.5276789E-04,   5.2437495E-04,   4.9782149E-04
     +,   4.7313809E-04,   4.5028981E-04,   4.2918595E-04
     +,   4.0969113E-04,   3.9163104E-04,   3.7480623E-04
     +,   3.5900270E-04,   3.4400134E-04,   3.2959215E-04
     +,   3.1557924E-04,   3.0179176E-04,   2.8808808E-04
     +,   2.7436102E-04,   2.6053519E-04,   2.4657388E-04
     +,   2.3247238E-04,   2.1825652E-04,   2.0397808E-04
     +,   1.8970811E-04,   1.7553485E-04,   1.6155359E-04
     +,   1.4786527E-04,   1.3456900E-04,   1.2175833E-04
     +,   1.0951829E-04,   9.7919103E-05,   8.7019849E-05
     +,   7.6863536E-05,   6.7477711E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wao_hz_75 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wao_hz_80(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  8.8979135E-08,   9.6983563E-08
     +,   1.0562695E-07,   1.1495207E-07,   1.2500426E-07
     +,   1.3583134E-07,   1.4748255E-07,   1.6001007E-07
     +,   1.7346866E-07,   1.8791447E-07,   2.0340688E-07
     +,   2.2000751E-07,   2.3778048E-07,   2.5679157E-07
     +,   2.7710956E-07,   2.9880593E-07,   3.2195331E-07
     +,   3.4662762E-07,   3.7290727E-07,   4.0087070E-07
     +,   4.3060069E-07,   4.6218150E-07,   4.9569758E-07
     +,   5.3123648E-07,   5.6888848E-07,   6.0874152E-07
     +,   6.5088813E-07,   6.9542114E-07,   7.4243269E-07
     +,   7.9201641E-07,   8.4426813E-07,   8.9927966E-07
     +,   9.5714609E-07,   1.0179616E-06,   1.0818176E-06
     +,   1.1488062E-06,   1.2190197E-06,   1.2925442E-06
     +,   1.3694685E-06,   1.4498767E-06,   1.5338532E-06
     +,   1.6214741E-06,   1.7128178E-06,   1.8079575E-06
     +,   1.9069640E-06,   2.0099001E-06,   2.1168310E-06
     +,   2.2278098E-06,   2.3428925E-06,   2.4621277E-06
     +,   2.5855607E-06,   2.7132276E-06,   2.8451659E-06
     +,   2.9814080E-06,   3.1219765E-06,   3.2668952E-06
     +,   3.4161865E-06,   3.5698595E-06,   3.7279306E-06
     +,   3.8904127E-06,   4.0573086E-06,   4.2286292E-06
     +,   4.4043868E-06,   4.5845827E-06,   4.7692311E-06
     +,   4.9583509E-06,   5.1519537E-06,   5.3500667E-06
     +,   5.5527257E-06,   5.7599655E-06,   5.9718413E-06
     +,   6.1884157E-06,   6.4097712E-06,   6.6359944E-06
     +,   6.8672034E-06,   7.1035192E-06,   7.3451129E-06
     +,   7.5921512E-06,   7.8448265E-06,   8.1033913E-06
     +,   8.3680907E-06,   8.6392074E-06,   8.9170808E-06
     +,   9.2020573E-06,   9.4945117E-06,   9.7948914E-06
     +,   1.0103632E-05,   1.0421249E-05,   1.0748261E-05
     +,   1.1085224E-05,   1.1432722E-05,   1.1791399E-05
     +,   1.2161892E-05,   1.2544864E-05,   1.2941031E-05
     +,   1.3351088E-05,   1.3775733E-05,   1.4215716E-05
     +,   1.4671718E-05,   1.5144475E-05,   1.5634649E-05
     +,   1.6142891E-05,   1.6669788E-05,   1.7215938E-05
     +,   1.7781791E-05,   1.8367818E-05,   1.8974324E-05
     +,   1.9601552E-05,   2.0249598E-05,   2.0918511E-05
     +,   2.1608124E-05,   2.2318211E-05,   2.3048331E-05
     +,   2.3797907E-05,   2.4566167E-05,   2.5352283E-05
     +,   2.6155141E-05,   2.6973597E-05,   2.7806293E-05
     +,   2.8651730E-05,   2.9508461E-05,   3.0374826E-05
     +,   3.1249303E-05,   3.2130363E-05,   3.3016586E-05
     +,   3.3906788E-05,   3.4800159E-05,   3.5696245E-05
     +,   3.6595135E-05,   3.7497746E-05,   3.8405728E-05
     +,   3.9321763E-05,   4.0249848E-05,   4.1195228E-05
     +,   4.2164851E-05,   4.3167278E-05,   4.4213000E-05
     +,   4.5314475E-05,   4.6486402E-05,   4.7745452E-05
     +,   4.9110626E-05,   5.0602845E-05,   5.2244886E-05
     +,   5.4061402E-05,   5.6078166E-05,   5.8321770E-05
     +,   6.0819442E-05,   6.3597865E-05,   6.6682682E-05
     +,   7.0098176E-05,   7.3865747E-05,   7.8003388E-05
     +,   8.2525505E-05,   8.7441185E-05,   9.2754250E-05
     +,   9.8462508E-05,   1.0455829E-04,   1.1102690E-04
     +,   1.1784876E-04,   1.2499820E-04,   1.3244520E-04
     +,   1.4015596E-04,   1.4809506E-04,   1.5622657E-04
     +,   1.6451473E-04,   1.7292706E-04,   1.8143543E-04
     +,   1.9001756E-04,   1.9865939E-04,   2.0735586E-04
     +,   2.1611112E-04,   2.2494003E-04,   2.3386815E-04
     +,   2.4293245E-04,   2.5218047E-04,   2.6166919E-04
     +,   2.7146502E-04,   2.8164301E-04,   2.9228453E-04
     +,   3.0347801E-04,   3.1531384E-04,   3.2788530E-04
     +,   3.4128179E-04,   3.5558670E-04,   3.7087069E-04
     +,   3.8718389E-04,   4.0454970E-04,   4.2295409E-04
     +,   4.4233372E-04,   4.6256842E-04,   4.8347199E-04
     +,   5.0478877E-04,   5.2619074E-04,   5.4728019E-04
     +,   5.6760304E-04,   5.8666640E-04,   6.0396222E-04
     +,   6.1900244E-04,   6.3135207E-04,   6.4066745E-04
     +,   6.4673350E-04,   6.4949610E-04,   6.4908300E-04
     +,   6.4581580E-04,   6.4020313E-04,   6.3292182E-04
     +,   6.2478229E-04,   6.1668106E-04,   6.0954608E-04
     +,   6.0428225E-04,   6.0172094E-04,   6.0258148E-04
     +,   6.0744426E-04,   6.1674416E-04,   6.3077832E-04
     +,   6.4971868E-04,   6.7363656E-04,   7.0251152E-04
     +,   7.3623616E-04,   7.7460450E-04,   8.1728044E-04
     +,   8.6377183E-04,   9.1339293E-04,   9.6524262E-04
     +,   1.0182173E-03,   1.0710453E-03,   1.1223675E-03
     +,   1.1708167E-03,   1.2151393E-03,   1.2542799E-03
     +,   1.2874642E-03,   1.3142343E-03,   1.3344507E-03
     +,   1.3482502E-03,   1.3559841E-03,   1.3581517E-03
     +,   1.3553315E-03,   1.3481372E-03,   1.3371870E-03
     +,   1.3230973E-03,   1.3064834E-03,   1.2879588E-03
     +,   1.2681222E-03,   1.2475345E-03,   1.2266840E-03
     +,   1.2059413E-03,   1.1855226E-03,   1.1654742E-03
     +,   1.1456710E-03,   1.1258445E-03,   1.1056372E-03
     +,   1.0846637E-03,   1.0625829E-03,   1.0391604E-03
     +,   1.0143116E-03,   9.8812417E-04,   9.6085237E-04
     +,   9.3289046E-04,   9.0472837E-04,   8.7689055E-04
     +,   8.4987446E-04,   8.2409638E-04,   7.9984113E-04
     +,   7.7723589E-04,   7.5624307E-04,   7.3666486E-04
     +,   7.1817357E-04,   7.0034876E-04,   6.8272604E-04
     +,   6.6484715E-04,   6.4630259E-04,   6.2676740E-04
     +,   6.0602516E-04,   5.8397569E-04,   5.6063291E-04
     +,   5.3611322E-04,   5.1061175E-04,   4.8437747E-04
     +,   4.5768847E-04,   4.3082418E-04,   4.0405386E-04
     +,   3.7761385E-04,   3.5170719E-04,   3.2649652E-04
     +,   3.0210824E-04,   2.7862898E-04,   2.5612314E-04
     +,   2.3463106E-04,   2.1417756E-04,   1.9477739E-04
     +,   1.7643601E-04,   1.5915780E-04,   1.4294124E-04
     +,   1.2778437E-04,   1.1368165E-04,   1.0062393E-04
     +,   8.8598463E-05,   7.7584365E-05,   6.7557696E-05
     +,   5.8487178E-05,   5.0335213E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wao_hz_80 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wao_hz_85(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  8.3132244E-07,   8.8254041E-07
     +,   9.3632264E-07,   9.9275564E-07,   1.0519277E-06
     +,   1.1139286E-06,   1.1788441E-06,   1.2467635E-06
     +,   1.3177760E-06,   1.3919662E-06,   1.4694219E-06
     +,   1.5502283E-06,   1.6344716E-06,   1.7222312E-06
     +,   1.8135896E-06,   1.9086274E-06,   2.0074185E-06
     +,   2.1100388E-06,   2.2165614E-06,   2.3270513E-06
     +,   2.4415749E-06,   2.5601971E-06,   2.6829712E-06
     +,   2.8099523E-06,   2.9411929E-06,   3.0767330E-06
     +,   3.2166142E-06,   3.3608749E-06,   3.5095384E-06
     +,   3.6626316E-06,   3.8201752E-06,   3.9821762E-06
     +,   4.1486423E-06,   4.3195773E-06,   4.4949684E-06
     +,   4.6748041E-06,   4.8590691E-06,   5.0477297E-06
     +,   5.2407554E-06,   5.4381062E-06,   5.6397407E-06
     +,   5.8455967E-06,   6.0556176E-06,   6.2697400E-06
     +,   6.4878946E-06,   6.7099968E-06,   6.9359712E-06
     +,   7.1657219E-06,   7.3991623E-06,   7.6361948E-06
     +,   7.8767252E-06,   8.1206454E-06,   8.3678533E-06
     +,   8.6182536E-06,   8.8717297E-06,   9.1281854E-06
     +,   9.3875260E-06,   9.6496460E-06,   9.9144590E-06
     +,   1.0181885E-05,   1.0451838E-05,   1.0724260E-05
     +,   1.0999096E-05,   1.1276300E-05,   1.1555848E-05
     +,   1.1837740E-05,   1.2121976E-05,   1.2408596E-05
     +,   1.2697665E-05,   1.2989253E-05,   1.3283486E-05
     +,   1.3580504E-05,   1.3880493E-05,   1.4183658E-05
     +,   1.4490266E-05,   1.4800593E-05,   1.5114998E-05
     +,   1.5433858E-05,   1.5757583E-05,   1.6086684E-05
     +,   1.6421671E-05,   1.6763110E-05,   1.7111661E-05
     +,   1.7467990E-05,   1.7832823E-05,   1.8206965E-05
     +,   1.8591234E-05,   1.8986537E-05,   1.9393794E-05
     +,   1.9813975E-05,   2.0248079E-05,   2.0697189E-05
     +,   2.1162363E-05,   2.1644686E-05,   2.2145314E-05
     +,   2.2665354E-05,   2.3205912E-05,   2.3768142E-05
     +,   2.4353105E-05,   2.4961908E-05,   2.5595549E-05
     +,   2.6254998E-05,   2.6941127E-05,   2.7654798E-05
     +,   2.8396680E-05,   2.9167430E-05,   2.9967505E-05
     +,   3.0797240E-05,   3.1656797E-05,   3.2546239E-05
     +,   3.3465349E-05,   3.4413821E-05,   3.5391055E-05
     +,   3.6396275E-05,   3.7428410E-05,   3.8486323E-05
     +,   3.9568436E-05,   4.0673116E-05,   4.1798372E-05
     +,   4.2941956E-05,   4.4101540E-05,   4.5274395E-05
     +,   4.6457761E-05,   4.7648540E-05,   4.8843540E-05
     +,   5.0039325E-05,   5.1232539E-05,   5.2419553E-05
     +,   5.3596697E-05,   5.4760429E-05,   5.5907083E-05
     +,   5.7033078E-05,   5.8135069E-05,   5.9209728E-05
     +,   6.0254075E-05,   6.1265302E-05,   6.2240950E-05
     +,   6.3178893E-05,   6.4077554E-05,   6.4935659E-05
     +,   6.5752567E-05,   6.6528155E-05,   6.7262838E-05
     +,   6.7957757E-05,   6.8614623E-05,   6.9235808E-05
     +,   6.9824433E-05,   7.0384223E-05,   7.0919596E-05
     +,   7.1435657E-05,   7.1938121E-05,   7.2433264E-05
     +,   7.2928022E-05,   7.3429786E-05,   7.3946409E-05
     +,   7.4486139E-05,   7.5057636E-05,   7.5669741E-05
     +,   7.6331627E-05,   7.7052529E-05,   7.7841811E-05
     +,   7.8708865E-05,   7.9663172E-05,   8.0714206E-05
     +,   8.1871403E-05,   8.3144274E-05,   8.4542422E-05
     +,   8.6075568E-05,   8.7753862E-05,   8.9587942E-05
     +,   9.1588954E-05,   9.3768933E-05,   9.6140837E-05
     +,   9.8719138E-05,   1.0151981E-04,   1.0456046E-04
     +,   1.0786088E-04,   1.1144332E-04,   1.1533280E-04
     +,   1.1955872E-04,   1.2415466E-04,   1.2916149E-04
     +,   1.3462857E-04,   1.4061775E-04,   1.4720741E-04
     +,   1.5449767E-04,   1.6261802E-04,   1.7173395E-04
     +,   1.8205393E-04,   1.9383774E-04,   2.0740043E-04
     +,   2.2311583E-04,   2.4141232E-04,   2.6276015E-04
     +,   2.8765303E-04,   3.1657759E-04,   3.4997161E-04
     +,   3.8817941E-04,   4.3139677E-04,   4.7961526E-04
     +,   5.3258223E-04,   5.8977242E-04,   6.5038045E-04
     +,   7.1335502E-04,   7.7745429E-04,   8.4133557E-04
     +,   9.0368668E-04,   9.6336933E-04,   1.0195818E-03
     +,   1.0720049E-03,   1.1209203E-03,   1.1672927E-03
     +,   1.2127708E-03,   1.2595970E-03,   1.3104215E-03
     +,   1.3679937E-03,   1.4347973E-03,   1.5126136E-03
     +,   1.6021257E-03,   1.7026158E-03,   1.8118303E-03
     +,   1.9261062E-03,   2.0407133E-03,   2.1504145E-03
     +,   2.2501596E-03,   2.3357524E-03,   2.4043929E-03
     +,   2.4549537E-03,   2.4880492E-03,   2.5058282E-03
     +,   2.5116338E-03,   2.5095621E-03,   2.5039711E-03
     +,   2.4989555E-03,   2.4977652E-03,   2.5022281E-03
     +,   2.5122785E-03,   2.5257447E-03,   2.5386098E-03
     +,   2.5457877E-03,   2.5423719E-03,   2.5250488E-03
     +,   2.4933068E-03,   2.4500280E-03,   2.4012765E-03
     +,   2.3553025E-03,   2.3210009E-03,   2.3062539E-03
     +,   2.3164754E-03,   2.3536070E-03,   2.4156545E-03
     +,   2.4967554E-03,   2.5876963E-03,   2.6768958E-03
     +,   2.7517702E-03,   2.8003976E-03,   2.8132533E-03
     +,   2.7846871E-03,   2.7138095E-03,   2.6045353E-03
     +,   2.4647343E-03,   2.3047072E-03,   2.1353152E-03
     +,   1.9662920E-03,   1.8050516E-03,   1.6561394E-03
     +,   1.5213888E-03,   1.4005207E-03,   1.2919924E-03
     +,   1.1937991E-03,   1.1040611E-03,   1.0213578E-03
     +,   9.4480265E-04,   8.7394548E-04,   8.0860179E-04
     +,   7.4867840E-04,   6.9403427E-04,   6.4441498E-04
     +,   5.9944548E-04,   5.5865443E-04,   5.2153546E-04
     +,   4.8758322E-04,   4.5634125E-04,   4.2741877E-04
     +,   4.0049903E-04,   3.7532666E-04,   3.5170757E-04
     +,   3.2948723E-04,   3.0853972E-04,   2.8875895E-04
     +,   2.7004961E-04,   2.5232890E-04,   2.3552013E-04
     +,   2.1955703E-04,   2.0438194E-04,   1.8994634E-04
     +,   1.7621170E-04,   1.6314452E-04,   1.5072151E-04
     +,   1.3892383E-04,   1.2773693E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wao_hz_85 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wao_hz_90(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  2.7789383E-07,   3.0190606E-07
     +,   3.2767446E-07,   3.5529567E-07,   3.8486999E-07
     +,   4.1650102E-07,   4.5029253E-07,   4.8635161E-07
     +,   5.2478799E-07,   5.6570997E-07,   6.0922946E-07
     +,   6.5545856E-07,   7.0451040E-07,   7.5649496E-07
     +,   8.1152501E-07,   8.6971227E-07,   9.3116358E-07
     +,   9.9598662E-07,   1.0642876E-06,   1.1361643E-06
     +,   1.2117154E-06,   1.2910352E-06,   1.3742076E-06
     +,   1.4613157E-06,   1.5524362E-06,   1.6476329E-06
     +,   1.7469670E-06,   1.8504915E-06,   1.9582433E-06
     +,   2.0702555E-06,   2.1865510E-06,   2.3071339E-06
     +,   2.4320018E-06,   2.5611419E-06,   2.6945190E-06
     +,   2.8320908E-06,   2.9738028E-06,   3.1195743E-06
     +,   3.2693206E-06,   3.4229354E-06,   3.5803021E-06
     +,   3.7412767E-06,   3.9057090E-06,   4.0734280E-06
     +,   4.2442521E-06,   4.4179706E-06,   4.5943707E-06
     +,   4.7732124E-06,   4.9542487E-06,   5.1372135E-06
     +,   5.3218328E-06,   5.5078067E-06,   5.6948343E-06
     +,   5.8826022E-06,   6.0707780E-06,   6.2590270E-06
     +,   6.4470105E-06,   6.6343709E-06,   6.8207542E-06
     +,   7.0058095E-06,   7.1891645E-06,   7.3704650E-06
     +,   7.5493558E-06,   7.7254745E-06,   7.8984767E-06
     +,   8.0680265E-06,   8.2337838E-06,   8.3954374E-06
     +,   8.5526844E-06,   8.7052304E-06,   8.8528150E-06
     +,   8.9951873E-06,   9.1321308E-06,   9.2634400E-06
     +,   9.3889521E-06,   9.5085188E-06,   9.6220429E-06
     +,   9.7294478E-06,   9.8306928E-06,   9.9257877E-06
     +,   1.0014770E-05,   1.0097723E-05,   1.0174780E-05
     +,   1.0246112E-05,   1.0311936E-05,   1.0372528E-05
     +,   1.0428202E-05,   1.0479328E-05,   1.0526331E-05
     +,   1.0569684E-05,   1.0609912E-05,   1.0647604E-05
     +,   1.0683390E-05,   1.0717968E-05,   1.0752081E-05
     +,   1.0786533E-05,   1.0822176E-05,   1.0859922E-05
     +,   1.0900727E-05,   1.0945610E-05,   1.0995630E-05
     +,   1.1051893E-05,   1.1115549E-05,   1.1187799E-05
     +,   1.1269864E-05,   1.1363023E-05,   1.1468562E-05
     +,   1.1587798E-05,   1.1722064E-05,   1.1872718E-05
     +,   1.2041099E-05,   1.2228564E-05,   1.2436442E-05
     +,   1.2666044E-05,   1.2918640E-05,   1.3195483E-05
     +,   1.3497733E-05,   1.3826526E-05,   1.4182881E-05
     +,   1.4567730E-05,   1.4981932E-05,   1.5426172E-05
     +,   1.5901069E-05,   1.6407041E-05,   1.6944370E-05
     +,   1.7513139E-05,   1.8113318E-05,   1.8744624E-05
     +,   1.9406565E-05,   2.0098525E-05,   2.0819591E-05
     +,   2.1568645E-05,   2.2344439E-05,   2.3145392E-05
     +,   2.3969853E-05,   2.4815881E-05,   2.5681391E-05
     +,   2.6564101E-05,   2.7461690E-05,   2.8371587E-05
     +,   2.9291279E-05,   3.0218091E-05,   3.1149328E-05
     +,   3.2082437E-05,   3.3014796E-05,   3.3943921E-05
     +,   3.4867571E-05,   3.5783607E-05,   3.6690111E-05
     +,   3.7585607E-05,   3.8468817E-05,   3.9338898E-05
     +,   4.0195504E-05,   4.1038689E-05,   4.1869094E-05
     +,   4.2687883E-05,   4.3496966E-05,   4.4298813E-05
     +,   4.5096785E-05,   4.5894947E-05,   4.6698329E-05
     +,   4.7512924E-05,   4.8345872E-05,   4.9205570E-05
     +,   5.0101724E-05,   5.1045594E-05,   5.2050145E-05
     +,   5.3130203E-05,   5.4302731E-05,   5.5586948E-05
     +,   5.7004436E-05,   5.8579357E-05,   6.0338447E-05
     +,   6.2311192E-05,   6.4529740E-05,   6.7028377E-05
     +,   6.9843532E-05,   7.3013143E-05,   7.6575801E-05
     +,   8.0570506E-05,   8.5034568E-05,   9.0003763E-05
     +,   9.5509822E-05,   1.0158007E-04,   1.0823621E-04
     +,   1.1549339E-04,   1.2336095E-04,   1.3184268E-04
     +,   1.4093766E-04,   1.5064323E-04,   1.6095793E-04
     +,   1.7188613E-04,   1.8344125E-04,   1.9564900E-04
     +,   2.0855188E-04,   2.2221355E-04,   2.3672434E-04
     +,   2.5221528E-04,   2.6887908E-04,   2.8700687E-04
     +,   3.0704864E-04,   3.2969262E-04,   3.5596028E-04
     +,   3.8730455E-04,   4.2567382E-04,   4.7350916E-04
     +,   5.3364830E-04,   6.0910225E-04,   7.0273946E-04
     +,   8.1690814E-04,   9.5308764E-04,   1.1117080E-03
     +,   1.2922043E-03,   1.4933749E-03,   1.7140650E-03
     +,   1.9538931E-03,   2.2139209E-03,   2.4965724E-03
     +,   2.8046449E-03,   3.1392651E-03,   3.4974155E-03
     +,   3.8704034E-03,   4.2446135E-03,   4.6054665E-03
     +,   4.9435999E-03,   5.2598706E-03,   5.5650980E-03
     +,   5.8724792E-03,   6.1863996E-03,   6.4948476E-03
     +,   6.7721028E-03,   6.9912197E-03,   7.1384860E-03
     +,   7.2200168E-03,   7.2561223E-03,   7.2681773E-03
     +,   7.2686281E-03,   7.2617773E-03,   7.2512040E-03
     +,   7.2415462E-03,   7.2291251E-03,   7.1928045E-03
     +,   7.1016974E-03,   6.9400510E-03,   6.7279292E-03
     +,   6.5155881E-03,   6.3528265E-03,   6.2580267E-03
     +,   6.2107667E-03,   6.1700260E-03,   6.0992017E-03
     +,   5.9783291E-03,   5.8001261E-03,   5.5610519E-03
     +,   5.2594151E-03,   4.9014972E-03,   4.5073633E-03
     +,   4.1089836E-03,   3.7409230E-03,   3.4297816E-03
     +,   3.1884818E-03,   3.0166013E-03,   2.9042780E-03
     +,   2.8365911E-03,   2.7968250E-03,   2.7687133E-03
     +,   2.7382004E-03,   2.6948533E-03,   2.6326585E-03
     +,   2.5499687E-03,   2.4486149E-03,   2.3325803E-03
     +,   2.2066741E-03,   2.0755113E-03,   1.9429664E-03
     +,   1.8119861E-03,   1.6846030E-03,   1.5620627E-03
     +,   1.4449662E-03,   1.3333948E-03,   1.2270979E-03
     +,   1.1256272E-03,   1.0285313E-03,   9.3547837E-04
     +,   8.4635062E-04,   7.6123612E-04,   6.8043370E-04
     +,   6.0434599E-04,   5.3339638E-04,   4.6794827E-04
     +,   4.0823410E-04,   3.5434010E-04,   3.0618222E-04
     +,   2.6353827E-04,   2.2606921E-04,   1.9335831E-04
     +,   1.6495005E-04,   1.4037236E-04,   1.1917489E-04
     +,   1.0093557E-04,   8.5271829E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wao_hz_90 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wao_hz_95(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  3.1176301E-13,   3.8931513E-13
     +,   4.8548736E-13,   6.0457737E-13,   7.5184021E-13
     +,   9.3368325E-13,   1.1579015E-12,   1.4339775E-12
     +,   1.7734303E-12,   2.1901972E-12,   2.7011733E-12
     +,   3.3267492E-12,   4.0915635E-12,   5.0252263E-12
     +,   6.1634174E-12,   7.5489883E-12,   9.2332314E-12
     +,   1.1277650E-11,   1.3755742E-11,   1.6755130E-11
     +,   2.0380312E-11,   2.4755715E-11,   3.0028754E-11
     +,   3.6374716E-11,   4.4001042E-11,   5.3152659E-11
     +,   6.4118856E-11,   7.7241158E-11,   9.2920102E-11
     +,   1.1162735E-10,   1.3391611E-10,   1.6043297E-10
     +,   1.9193498E-10,   2.2930652E-10,   2.7357511E-10
     +,   3.2593975E-10,   3.8779260E-10,   4.6074491E-10
     +,   5.4666471E-10,   6.4771305E-10,   7.6638168E-10
     +,   9.0553809E-10,   1.0684847E-09,   1.2590129E-09
     +,   1.4814738E-09,   1.7408305E-09,   2.0427773E-09
     +,   2.3937823E-09,   2.8012253E-09,   3.2735008E-09
     +,   3.8201318E-09,   4.4518829E-09,   5.1809517E-09
     +,   6.0211174E-09,   6.9878578E-09,   8.0986311E-09
     +,   9.3730561E-09,   1.0833030E-08,   1.2503153E-08
     +,   1.4410892E-08,   1.6586775E-08,   1.9064869E-08
     +,   2.1883039E-08,   2.5083098E-08,   2.8711472E-08
     +,   3.2819504E-08,   3.7463483E-08,   4.2705636E-08
     +,   4.8614368E-08,   5.5264167E-08,   6.2736987E-08
     +,   7.1122166E-08,   8.0517154E-08,   9.1027310E-08
     +,   1.0276786E-07,   1.1586229E-07,   1.3044578E-07
     +,   1.4666254E-07,   1.6466744E-07,   1.8462882E-07
     +,   2.0672483E-07,   2.3114541E-07,   2.5809601E-07
     +,   2.8779198E-07,   3.2046145E-07,   3.5634966E-07
     +,   3.9570986E-07,   4.3881437E-07,   4.8594450E-07
     +,   5.3739603E-07,   5.9347519E-07,   6.5450740E-07
     +,   7.2082361E-07,   7.9276447E-07,   8.7069054E-07
     +,   9.5496273E-07,   1.0459494E-06,   1.1440371E-06
     +,   1.2496027E-06,   1.3630433E-06,   1.4847467E-06
     +,   1.6151037E-06,   1.7544997E-06,   1.9033321E-06
     +,   2.0619700E-06,   2.2307981E-06,   2.4101741E-06
     +,   2.6004470E-06,   2.8019442E-06,   3.0149988E-06
     +,   3.2398921E-06,   3.4769189E-06,   3.7263239E-06
     +,   3.9883371E-06,   4.2631495E-06,   4.5509587E-06
     +,   4.8518932E-06,   5.1660973E-06,   5.4936568E-06
     +,   5.8346304E-06,   6.1890946E-06,   6.5570516E-06
     +,   6.9385446E-06,   7.3335673E-06,   7.7421182E-06
     +,   8.1641847E-06,   8.5998117E-06,   9.0490157E-06
     +,   9.5118412E-06,   9.9884264E-06,   1.0478905E-05
     +,   1.0983476E-05,   1.1502477E-05,   1.2036250E-05
     +,   1.2585334E-05,   1.3150322E-05,   1.3731967E-05
     +,   1.4331143E-05,   1.4948967E-05,   1.5586635E-05
     +,   1.6245638E-05,   1.6927595E-05,   1.7634346E-05
     +,   1.8368044E-05,   1.9130999E-05,   1.9925776E-05
     +,   2.0755291E-05,   2.1622654E-05,   2.2531245E-05
     +,   2.3484869E-05,   2.4487519E-05,   2.5543541E-05
     +,   2.6657730E-05,   2.7835176E-05,   2.9081395E-05
     +,   3.0402296E-05,   3.1804437E-05,   3.3294691E-05
     +,   3.4880733E-05,   3.6570687E-05,   3.8373433E-05
     +,   4.0298473E-05,   4.2356241E-05,   4.4557990E-05
     +,   4.6915611E-05,   4.9441864E-05,   5.2150262E-05
     +,   5.5054872E-05,   5.8170506E-05,   6.1512357E-05
     +,   6.5095424E-05,   6.8934642E-05,   7.3044095E-05
     +,   7.7437122E-05,   8.2125473E-05,   8.7118300E-05
     +,   9.2422109E-05,   9.8039789E-05,   1.0396980E-04
     +,   1.1020646E-04,   1.1673753E-04,   1.2354589E-04
     +,   1.3060721E-04,   1.3789085E-04,   1.4535977E-04
     +,   1.5297050E-04,   1.6067486E-04,   1.6842061E-04
     +,   1.7615245E-04,   1.8381514E-04,   1.9135558E-04
     +,   1.9872708E-04,   2.0589209E-04,   2.1282615E-04
     +,   2.1952228E-04,   2.2599517E-04,   2.3228422E-04
     +,   2.3845721E-04,   2.4461219E-04,   2.5087892E-04
     +,   2.5742230E-04,   2.6444861E-04,   2.7221860E-04
     +,   2.8107665E-04,   2.9150004E-04,   3.0418212E-04
     +,   3.2015794E-04,   3.4097658E-04,   3.6891719E-04
     +,   4.0721631E-04,   4.6025022E-04,   5.3358625E-04
     +,   6.3377537E-04,   7.6778035E-04,   9.4205735E-04
     +,   1.1614015E-03,   1.4281967E-03,   1.7425952E-03
     +,   2.1043681E-03,   2.5160934E-03,   2.9862102E-03
     +,   3.5297605E-03,   4.1651605E-03,   4.9075442E-03
     +,   5.7605160E-03,   6.7070783E-03,   7.7016545E-03
     +,   8.6704995E-03,   9.5359096E-03,   1.0267008E-02
     +,   1.0929803E-02,   1.1689382E-02,   1.2749225E-02
     +,   1.4256055E-02,   1.6192684E-02,   1.8296214E-02
     +,   2.0139948E-02,   2.1440795E-02,   2.2286015E-02
     +,   2.2967087E-02,   2.3601947E-02,   2.3942281E-02
     +,   2.3598285E-02,   2.2470187E-02,   2.0831557E-02
     +,   1.9085515E-02,   1.7612653E-02,   1.6665494E-02
     +,   1.6247138E-02,   1.6184997E-02,   1.6297050E-02
     +,   1.6396837E-02,   1.6276320E-02,   1.5844123E-02
     +,   1.5213421E-02,   1.4576576E-02,   1.4052447E-02
     +,   1.3668933E-02,   1.3399273E-02,   1.3158427E-02
     +,   1.2800065E-02,   1.2180245E-02,   1.1266030E-02
     +,   1.0188142E-02,   9.1685103E-03,   8.3764484E-03
     +,   7.8370301E-03,   7.4517978E-03,   7.0889797E-03
     +,   6.6635469E-03,   6.1632842E-03,   5.6271353E-03
     +,   5.1065967E-03,   4.6370570E-03,   4.2291670E-03
     +,   3.8753951E-03,   3.5613917E-03,   3.2746252E-03
     +,   3.0076571E-03,   2.7573525E-03,   2.5226988E-03
     +,   2.3028629E-03,   2.0965065E-03,   1.9019020E-03
     +,   1.7175139E-03,   1.5424115E-03,   1.3765328E-03
     +,   1.2204876E-03,   1.0752500E-03,   9.4180228E-04
     +,   8.2083559E-04,   7.1263046E-04,   6.1699044E-04
     +,   5.3333282E-04,   4.6077685E-04,   3.9825935E-04
     +,   3.4463927E-04,   2.9875844E-04,   2.5952293E-04
     +,   2.2592196E-04,   1.9705440E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wao_hz_95 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wao_qq(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   1.3655875E-38
     +,   3.3651801E-38,   8.2490646E-38,   2.0114025E-37
     +,   4.8786693E-37,   1.1770431E-36,   2.8248930E-36
     +,   6.7440473E-36,   1.6014825E-35,   3.7830898E-35
     +,   8.8895102E-35,   2.0777641E-34,   4.8310182E-34
     +,   1.1173405E-33,   2.5705387E-33,   5.8828056E-33
     +,   1.3391747E-32,   3.0325826E-32,   6.8312132E-32
     +,   1.5306995E-31,   3.4117541E-31,   7.5646405E-31
     +,   1.6684325E-30,   3.6603796E-30,   7.9885746E-30
     +,   1.7342849E-29,   3.7451865E-29,   8.0454760E-29
     +,   1.7192068E-28,   3.6545250E-28,   7.7276495E-28
     +,   1.6254735E-27,   3.4010567E-27,   7.0790721E-27
     +,   1.4656823E-26,   3.0188021E-26,   6.1850701E-26
     +,   1.2605897E-25,   2.5556872E-25,   5.1543254E-25
     +,   1.0340587E-24,   2.0637152E-24,   4.0970651E-24
     +,   8.0913021E-24,   1.5895484E-23,   3.1064260E-23
     +,   6.0389391E-23,   1.1678713E-22,   2.2467407E-22
     +,   4.2995681E-22,   8.1852122E-22,   1.5500718E-21
     +,   2.9201792E-21,   5.4725781E-21,   1.0202409E-20
     +,   1.8920411E-20,   3.4905720E-20,   6.4060595E-20
     +,   1.1695100E-19,   2.1240098E-19,   3.8374147E-19
     +,   6.8967021E-19,   1.2330637E-18,   2.1930583E-18
     +,   3.8802269E-18,   6.8296155E-18,   1.1958243E-17
     +,   2.0828691E-17,   3.6091035E-17,   6.2210255E-17
     +,   1.0667650E-16,   1.8197378E-16,   3.0879849E-16
     +,   5.2129732E-16,   8.7545302E-16,   1.4625360E-15
     +,   2.4306690E-15,   4.0186741E-15,   6.6094764E-15
     +,   1.0814291E-14,   1.7602198E-14,   2.8501439E-14
     +,   4.5910656E-14,   7.3569650E-14,   1.1727984E-13
     +,   1.8598610E-13,   2.9341777E-13,   4.6049487E-13
     +,   7.1897328E-13,   1.1167134E-12,   1.7254952E-12
     +,   2.6522905E-12,   4.0557557E-12,   6.1698459E-12
     +,   9.3372914E-12,   1.4057659E-11,   2.1054792E-11
     +,   3.1371027E-11,   4.6500151E-11,   6.8570073E-11
     +,   1.0059208E-10,   1.4680565E-10,   2.1314077E-10
     +,   3.0785197E-10,   4.4236040E-10,   6.3235911E-10
     +,   8.9930413E-10,   1.2723445E-09,   1.7908285E-09
     +,   2.5076472E-09,   3.4932734E-09,   4.8413278E-09
     +,   6.6750960E-09,   9.1561496E-09,   1.2494858E-08
     +,   1.6963265E-08,   2.2911470E-08,   3.0787071E-08
     +,   4.1157712E-08,   5.4739747E-08,   7.2430097E-08
     +,   9.5346643E-08,   1.2487276E-07,   1.6270528E-07
     +,   2.1091505E-07,   2.7201085E-07,   3.4900634E-07
     +,   4.4550603E-07,   5.6578466E-07,   7.1486068E-07
     +,   8.9859572E-07,   1.1237743E-06,   1.3981747E-06
     +,   1.7306700E-06,   2.1312776E-06,   2.6111618E-06
     +,   3.1826851E-06,   3.8593562E-06,   4.6558489E-06
     +,   5.5878695E-06,   6.6719290E-06,   7.9252286E-06
     +,   9.3653580E-06,   1.1009898E-05,   1.2876293E-05
     +,   1.4980913E-05,   1.7339127E-05,   1.9964176E-05
     +,   2.2866894E-05,   2.6054982E-05,   2.9532275E-05
     +,   3.3298486E-05,   3.7348425E-05,   4.1671221E-05
     +,   4.6250272E-05,   5.1062769E-05,   5.6080284E-05
     +,   6.1267565E-05,   6.6584435E-05,   7.1984861E-05
     +,   7.7418590E-05,   8.2831692E-05,   8.8168446E-05
     +,   9.3372211E-05,   9.8386678E-05,   1.0315794E-04
     +,   1.0763604E-04,   1.1177632E-04,   1.1554138E-04
     +,   1.1890184E-04,   1.2183710E-04,   1.2433625E-04
     +,   1.2639808E-04,   1.2803117E-04,   1.2925267E-04
     +,   1.3008768E-04,   1.3056805E-04,   1.3073078E-04
     +,   1.3061680E-04,   1.3026965E-04,   1.2973457E-04
     +,   1.2905808E-04,   1.2828808E-04,   1.2747466E-04
     +,   1.2667156E-04,   1.2593837E-04,   1.2534317E-04
     +,   1.2496565E-04,   1.2490037E-04,   1.2525990E-04
     +,   1.2617739E-04,   1.2780828E-04,   1.3033114E-04
     +,   1.3394642E-04,   1.3887323E-04,   1.4534430E-04
     +,   1.5359794E-04,   1.6386926E-04,   1.7637831E-04
     +,   1.9131548E-04,   2.0882995E-04,   2.2901599E-04
     +,   2.5190084E-04,   2.7743939E-04,   3.0550777E-04
     +,   3.3590055E-04,   3.6833712E-04,   4.0246744E-04
     +,   4.3788014E-04,   4.7411773E-04,   5.1067612E-04
     +,   5.4702349E-04,   5.8259408E-04,   6.1679701E-04
     +,   6.4901198E-04,   6.7860144E-04,   7.0489792E-04
     +,   7.2722393E-04,   7.4490538E-04,   7.5729552E-04
     +,   7.6380849E-04,   7.6395448E-04,   7.5738167E-04
     +,   7.4391410E-04,   7.2358397E-04,   6.9665199E-04
     +,   6.6361506E-04,   6.2518549E-04,   5.8227743E-04
     +,   5.3595460E-04,   4.8737746E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wao_qq = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wao_ww(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  9.5579816E-32,   1.7221981E-31
     +,   3.0942058E-31,   5.5430812E-31,   9.9013826E-31
     +,   1.7635441E-30,   3.1319591E-30,   5.5460869E-30
     +,   9.7926797E-30,   1.7240797E-29,   3.0266043E-29
     +,   5.2977927E-29,   9.2465215E-29,   1.6091731E-28
     +,   2.7923488E-28,   4.8314870E-28,   8.3354912E-28
     +,   1.4339120E-27,   2.4595728E-27,   4.2066478E-27
     +,   7.1738972E-27,   1.2198880E-26,   2.0683505E-26
     +,   3.4967733E-26,   5.8946546E-26,   9.9080202E-26
     +,   1.6605729E-25,   2.7750761E-25,   4.6241404E-25
     +,   7.6829525E-25,   1.2728320E-24,   2.1025760E-24
     +,   3.4631909E-24,   5.6878374E-24,   9.3143757E-24
     +,   1.5209136E-23,   2.4762885E-23,   4.0200876E-23
     +,   6.5074733E-23,   1.0503405E-22,   1.6904230E-22
     +,   2.7126680E-22,   4.3405232E-22,   6.9251643E-22
     +,   1.1016973E-21,   1.7475669E-21,   2.7640834E-21
     +,   4.3591930E-21,   6.8549386E-21,   1.0748396E-20
     +,   1.6804654E-20,   2.6197096E-20,   4.0721077E-20
     +,   6.3114805E-20,   9.7539561E-20,   1.5030483E-19
     +,   2.3094671E-19,   3.5382478E-19,   5.4051435E-19
     +,   8.2332657E-19,   1.2504762E-18,   1.8937370E-18
     +,   2.8596399E-18,   4.3056695E-18,   6.4641551E-18
     +,   9.6767501E-18,   1.4443914E-17,   2.1497246E-17
     +,   3.1902579E-17,   4.7207171E-17,   6.9651738E-17
     +,   1.0247041E-16,   1.5031768E-16,   2.1986741E-16
     +,   3.2066886E-16,   4.6632483E-16,   6.7619000E-16
     +,   9.7766618E-16,   1.4094461E-15,   2.0260751E-15
     +,   2.9040510E-15,   4.1503827E-15,   5.9145427E-15
     +,   8.4042092E-15,   1.1907120E-14,   1.6821575E-14
     +,   2.3695227E-14,   3.3281605E-14,   4.6611105E-14
     +,   6.5090416E-14,   9.0631997E-14,   1.2583246E-13
     +,   1.7419931E-13,   2.4045672E-13,   3.3095892E-13
     +,   4.5420698E-13,   6.2154307E-13,   8.4807698E-13
     +,   1.1538147E-12,   1.5652541E-12,   2.1172638E-12
     +,   2.8556671E-12,   3.8404050E-12,   5.1498428E-12
     +,   6.8856999E-12,   9.1801237E-12,   1.2203711E-11
     +,   1.6176224E-11,   2.1379615E-11,   2.8175325E-11
     +,   3.7023339E-11,   4.8509790E-11,   6.3376082E-11
     +,   8.2558661E-11,   1.0723545E-10,   1.3888664E-10
     +,   1.7935793E-10,   2.3095462E-10,   2.9653457E-10
     +,   3.7963099E-10,   4.8461274E-10,   6.1683025E-10
     +,   7.8285795E-10,   9.9070097E-10,   1.2500980E-09
     +,   1.5728407E-09,   1.9732003E-09,   2.4683149E-09
     +,   3.0787071E-09,   3.8289754E-09,   4.7483164E-09
     +,   5.8713256E-09,   7.2390085E-09,   8.8994261E-09
     +,   1.0909170E-08,   1.3334148E-08,   1.6251096E-08
     +,   1.9748832E-08,   2.3930296E-08,   2.8913250E-08
     +,   3.4833324E-08,   4.1844615E-08,   5.0121965E-08
     +,   5.9864377E-08,   7.1294814E-08,   8.4663228E-08
     +,   1.0025047E-07,   1.1836727E-07,   1.3935711E-07
     +,   1.6360126E-07,   1.9151544E-07,   2.2355300E-07
     +,   2.6021075E-07,   3.0202190E-07,   3.4956165E-07
     +,   4.0344415E-07,   4.6433024E-07,   5.3291075E-07
     +,   6.0992579E-07,   6.9614282E-07,   7.9236605E-07
     +,   8.9942517E-07,   1.0181859E-06,   1.1495373E-06
     +,   1.2943789E-06,   1.4536274E-06,   1.6282083E-06
     +,   1.8190433E-06,   2.0270661E-06,   2.2532060E-06
     +,   2.4983635E-06,   2.7634276E-06,   3.0492527E-06
     +,   3.3566871E-06,   3.6865476E-06,   4.0395889E-06
     +,   4.4165313E-06,   4.8180441E-06,   5.2447231E-06
     +,   5.6971512E-06,   6.1757673E-06,   6.6810012E-06
     +,   7.2131306E-06,   7.7723471E-06,   8.3587183E-06
     +,   8.9721480E-06,   9.6124295E-06,   1.0279194E-05
     +,   1.0971820E-05,   1.1689518E-05,   1.2431237E-05
     +,   1.3195769E-05,   1.3981681E-05,   1.4787262E-05
     +,   1.5610640E-05,   1.6449794E-05,   1.7302573E-05
     +,   1.8166875E-05,   1.9040681E-05,   1.9922119E-05
     +,   2.0809712E-05,   2.1702517E-05,   2.2600305E-05
     +,   2.3503853E-05,   2.4415131E-05,   2.5337415E-05
     +,   2.6275637E-05,   2.7236465E-05,   2.8228538E-05
     +,   2.9262463E-05,   3.0350642E-05,   3.1507261E-05
     +,   3.2747877E-05,   3.4088884E-05,   3.5547073E-05
     +,   3.7138365E-05,   3.8877257E-05,   4.0775241E-05
     +,   4.2839794E-05,   4.5073066E-05,   4.7470618E-05
     +,   5.0020688E-05,   5.2703439E-05,   5.5490451E-05
     +,   5.8345406E-05,   6.1224848E-05,   6.4080217E-05
     +,   6.6859371E-05,   6.9510250E-05,   7.1982970E-05
     +,   7.4233525E-05,   7.6226170E-05,   7.7935751E-05
     +,   7.9348625E-05,   8.0462676E-05,   8.1286678E-05
     +,   8.1839171E-05,   8.2147773E-05,   8.2250714E-05
     +,   8.2201710E-05,   8.2080536E-05,   8.2010643E-05
     +,   8.2184371E-05,   8.2895203E-05,   8.4573207E-05
     +,   8.7817367E-05,   9.3415896E-05,   1.0234032E-04
     +,   1.1570218E-04,   1.3466435E-04,   1.6029434E-04
     +,   1.9338392E-04,   2.3423301E-04,   2.8245419E-04
     +,   3.3682687E-04,   3.9524763E-04,   4.5482159E-04
     +,   5.1208481E-04,   5.6335056E-04,   6.0514663E-04
     +,   6.3464808E-04,   6.5003976E-04,   6.5074058E-04
     +,   6.3743978E-04,   6.1195384E-04,   5.7693187E-04
     +,   5.3547294E-04,   4.9072510E-04,   4.4554588E-04
     +,   4.0226732E-04,   3.6256859E-04,   3.2746771E-04
     +,   2.9739650E-04,   2.7231660E-04,   2.5185829E-04
     +,   2.3544551E-04,   2.2239423E-04,   2.1198885E-04
     +,   2.0353455E-04,   1.9639099E-04,   1.8999740E-04
     +,   1.8388471E-04,   1.7768463E-04,   1.7112961E-04
     +,   1.6404917E-04,   1.5635802E-04,   1.4804614E-04
     +,   1.3916234E-04,   1.2979945E-04,   1.2008121E-04
     +,   1.1014852E-04,   1.0015191E-04,   9.0240115E-05
     +,   8.0555852E-05,   7.1228809E-05,   6.2371582E-05
     +,   5.4077213E-05,   4.6414552E-05,   3.9431525E-05
     +,   3.3152814E-05,   2.7582095E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wao_ww = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A1995_hnn_wao_zz(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 108.3/
      DATA y /  9.8205639E-09,   9.9019761E-09
     +,   9.9834860E-09,   1.0065078E-08,   1.0146747E-08
     +,   1.0228486E-08,   1.0310282E-08,   1.0392127E-08
     +,   1.0474016E-08,   1.0555934E-08,   1.0637873E-08
     +,   1.0719825E-08,   1.0801784E-08,   1.0883734E-08
     +,   1.0965667E-08,   1.1047578E-08,   1.1129451E-08
     +,   1.1211277E-08,   1.1293053E-08,   1.1374760E-08
     +,   1.1456392E-08,   1.1537941E-08,   1.1619393E-08
     +,   1.1700741E-08,   1.1781974E-08,   1.1863079E-08
     +,   1.1944050E-08,   1.2024873E-08,   1.2105540E-08
     +,   1.2186037E-08,   1.2266359E-08,   1.2346492E-08
     +,   1.2426424E-08,   1.2506148E-08,   1.2585653E-08
     +,   1.2664923E-08,   1.2743954E-08,   1.2822731E-08
     +,   1.2901245E-08,   1.2979484E-08,   1.3057442E-08
     +,   1.3135102E-08,   1.3212456E-08,   1.3289492E-08
     +,   1.3366201E-08,   1.3442571E-08,   1.3518591E-08
     +,   1.3594250E-08,   1.3669538E-08,   1.3744442E-08
     +,   1.3818957E-08,   1.3893064E-08,   1.3966758E-08
     +,   1.4040027E-08,   1.4112858E-08,   1.4185243E-08
     +,   1.4257171E-08,   1.4328629E-08,   1.4399610E-08
     +,   1.4470099E-08,   1.4540089E-08,   1.4609567E-08
     +,   1.4678524E-08,   1.4746949E-08,   1.4814830E-08
     +,   1.4882160E-08,   1.4948926E-08,   1.5015116E-08
     +,   1.5080728E-08,   1.5145744E-08,   1.5210155E-08
     +,   1.5273949E-08,   1.5337125E-08,   1.5399666E-08
     +,   1.5461563E-08,   1.5522806E-08,   1.5583394E-08
     +,   1.5643311E-08,   1.5702549E-08,   1.5761106E-08
     +,   1.5818976E-08,   1.5876152E-08,   1.5932640E-08
     +,   1.5988441E-08,   1.6043559E-08,   1.6098017E-08
     +,   1.6151837E-08,   1.6205066E-08,   1.6257763E-08
     +,   1.6310011E-08,   1.6361936E-08,   1.6413711E-08
     +,   1.6465579E-08,   1.6517864E-08,   1.6571020E-08
     +,   1.6625645E-08,   1.6682558E-08,   1.6742842E-08
     +,   1.6807945E-08,   1.6879778E-08,   1.6960849E-08
     +,   1.7054447E-08,   1.7164840E-08,   1.7297578E-08
     +,   1.7459785E-08,   1.7660614E-08,   1.7911727E-08
     +,   1.8227929E-08,   1.8627880E-08,   1.9135083E-08
     +,   1.9778815E-08,   2.0595571E-08,   2.1630397E-08
     +,   2.2938719E-08,   2.4588285E-08,   2.6661743E-08
     +,   2.9258819E-08,   3.2499926E-08,   3.6528942E-08
     +,   4.1516973E-08,   4.7667250E-08,   5.5217971E-08
     +,   6.4449075E-08,   7.5685215E-08,   8.9302155E-08
     +,   1.0573086E-07,   1.2546586E-07,   1.4906621E-07
     +,   1.7716168E-07,   2.1046121E-07,   2.4974989E-07
     +,   2.9589395E-07,   3.4984907E-07,   4.1264664E-07
     +,   4.8540994E-07,   5.6933368E-07,   6.6568833E-07
     +,   7.7580495E-07,   9.0108233E-07,   1.0429422E-06
     +,   1.2028528E-06,   1.3822714E-06,   1.5826386E-06
     +,   1.8053772E-06,   2.0518228E-06,   2.3232110E-06
     +,   2.6206860E-06,   2.9452051E-06,   3.2975313E-06
     +,   3.6782542E-06,   4.0876707E-06,   4.5257975E-06
     +,   4.9923965E-06,   5.4868565E-06,   6.0082325E-06
     +,   6.5552026E-06,   7.1261379E-06,   7.7189525E-06
     +,   8.3312852E-06,   8.9603463E-06,   9.6030271E-06
     +,   1.0255872E-05,   1.0915194E-05,   1.1577047E-05
     +,   1.2237224E-05,   1.2891382E-05,   1.3535064E-05
     +,   1.4163744E-05,   1.4772954E-05,   1.5358319E-05
     +,   1.5915575E-05,   1.6440741E-05,   1.6930164E-05
     +,   1.7380684E-05,   1.7789722E-05,   1.8155384E-05
     +,   1.8476667E-05,   1.8753615E-05,   1.8987515E-05
     +,   1.9181136E-05,   1.9338915E-05,   1.9467232E-05
     +,   1.9574623E-05,   1.9672001E-05,   1.9772837E-05
     +,   1.9893243E-05,   2.0052013E-05,   2.0270489E-05
     +,   2.0572283E-05,   2.0982856E-05,   2.1528889E-05
     +,   2.2237600E-05,   2.3135894E-05,   2.4249359E-05
     +,   2.5601470E-05,   2.7212673E-05,   2.9099469E-05
     +,   3.1273663E-05,   3.3741144E-05,   3.6500216E-05
     +,   3.9540013E-05,   4.2838823E-05,   4.6363592E-05
     +,   5.0073479E-05,   5.3930125E-05,   5.7919904E-05
     +,   6.2093837E-05,   6.6626562E-05,   7.1892442E-05
     +,   7.8544261E-05,   8.7570610E-05,   1.0029851E-04
     +,   1.1830396E-04,   1.4320636E-04,   1.7635961E-04
     +,   2.1847125E-04,   2.6927219E-04,   3.2731614E-04
     +,   3.9004468E-04,   4.5412811E-04,   5.1603367E-04
     +,   5.7271164E-04,   6.2220264E-04,   6.6397100E-04
     +,   6.9875323E-04,   7.2785083E-04,   7.5231784E-04
     +,   7.7289599E-04,   7.9128065E-04,   8.1187120E-04
     +,   8.4201468E-04,   8.8958838E-04,   9.5958379E-04
     +,   1.0525570E-03,   1.1648234E-03,   1.2867987E-03
     +,   1.3988628E-03,   1.4722993E-03,   1.4831421E-03
     +,   1.4327883E-03,   1.3557732E-03,   1.3016344E-03
     +,   1.3010806E-03,   1.3434285E-03,   1.3853799E-03
     +,   1.3856728E-03,   1.3370524E-03,   1.2687652E-03
     +,   1.2195213E-03,   1.2062644E-03,   1.2138557E-03
     +,   1.2097928E-03,   1.1690366E-03,   1.0901076E-03
     +,   9.9300616E-04,   9.0378767E-04,   8.3904096E-04
     +,   8.0059259E-04,   7.8065047E-04,   7.7032100E-04
     +,   7.6467358E-04,   7.6238526E-04,   7.6241366E-04
     +,   7.6142047E-04,   7.5402169E-04,   7.3530065E-04
     +,   7.0340885E-04,   6.6042697E-04,   6.1117497E-04
     +,   5.6098640E-04,   5.1381229E-04,   4.7147021E-04
     +,   4.3399987E-04,   4.0056222E-04,   3.7028900E-04
     +,   3.4274964E-04,   3.1802364E-04,   2.9655217E-04
     +,   2.7890957E-04,   2.6557891E-04,   2.5676665E-04
     +,   2.5226094E-04,   2.5136664E-04,   2.5292719E-04
     +,   2.5543963E-04,   2.5724739E-04,   2.5677020E-04
     +,   2.5272663E-04,   2.4430963E-04,   2.3128025E-04
     +,   2.1396864E-04,   1.9319038E-04,   1.7009067E-04
     +,   1.4596593E-04,   1.2208105E-04,   9.9522775E-05
     +,   7.9106991E-05,   6.1334424E-05,   4.6413705E-05
     +,   3.4303204E-05,   2.4780475E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A1995_hnn_wao_zz = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_nwao_fus_100(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  7.5019147E-14,   9.6802415E-14
     +,   1.2469831E-13,   1.6035816E-13,   2.0586392E-13
     +,   2.6383282E-13,   3.3754707E-13,   4.3111952E-13
     +,   5.4969440E-13,   6.9968261E-13,   8.8907554E-13
     +,   1.1278094E-12,   1.4282049E-12,   1.8055218E-12
     +,   2.2786373E-12,   2.8708060E-12,   3.6106871E-12
     +,   4.5335346E-12,   5.6825100E-12,   7.1105257E-12
     +,   8.8822092E-12,   1.1076438E-11,   1.3789109E-11
     +,   1.7136882E-11,   2.1261012E-11,   2.6332606E-11
     +,   3.2558380E-11,   4.0187523E-11,   4.9519448E-11
     +,   6.0914489E-11,   7.4803441E-11,   9.1702410E-11
     +,   1.1222732E-10,   1.3711199E-10,   1.6722827E-10
     +,   2.0361103E-10,   2.4748745E-10,   3.0030409E-10
     +,   3.6377121E-10,   4.3990045E-10,   5.3105209E-10
     +,   6.3999955E-10,   7.6997880E-10,   9.2477492E-10
     +,   1.1087959E-09,   1.3271714E-09,   1.5858368E-09
     +,   1.8916844E-09,   2.2526738E-09,   2.6779623E-09
     +,   3.1781093E-09,   3.7652437E-09,   4.4532178E-09
     +,   5.2579248E-09,   6.1974297E-09,   7.2923387E-09
     +,   8.5660465E-09,   1.0045046E-08,   1.1759348E-08
     +,   1.3742671E-08,   1.6033143E-08,   1.8673383E-08
     +,   2.1711282E-08,   2.5200400E-08,   2.9200235E-08
     +,   3.3777187E-08,   3.9004966E-08,   4.4964857E-08
     +,   5.1746934E-08,   5.9450375E-08,   6.8183979E-08
     +,   7.8067202E-08,   8.9230817E-08,   1.0181630E-07
     +,   1.1597861E-07,   1.3188534E-07,   1.4971788E-07
     +,   1.6967223E-07,   1.9195704E-07,   2.1679803E-07
     +,   2.4443591E-07,   2.7512667E-07,   3.0914376E-07
     +,   3.4677097E-07,   3.8831732E-07,   4.3409753E-07
     +,   4.8444650E-07,   5.3971252E-07,   6.0025747E-07
     +,   6.6645731E-07,   7.3869239E-07,   8.1735931E-07
     +,   9.0286045E-07,   9.9560373E-07,   1.0959997E-06
     +,   1.2044603E-06,   1.3214002E-06,   1.4472139E-06
     +,   1.5823020E-06,   1.7270472E-06,   1.8818162E-06
     +,   2.0469613E-06,   2.2227923E-06,   2.4096078E-06
     +,   2.6076659E-06,   2.8171876E-06,   3.0383585E-06
     +,   3.2712817E-06,   3.5160692E-06,   3.7727139E-06
     +,   4.0411837E-06,   4.3213695E-06,   4.6130949E-06
     +,   4.9161217E-06,   5.2300870E-06,   5.5546343E-06
     +,   5.8892388E-06,   6.2333438E-06,   6.5862951E-06
     +,   6.9473540E-06,   7.3157157E-06,   7.6904462E-06
     +,   8.0705749E-06,   8.4550411E-06,   8.8427087E-06
     +,   9.2323698E-06,   9.6227723E-06,   1.0012558E-05
     +,   1.0400363E-05,   1.0784763E-05,   1.1164305E-05
     +,   1.1537505E-05,   1.1902879E-05,   1.2258900E-05
     +,   1.2604082E-05,   1.2936947E-05,   1.3256051E-05
     +,   1.3559983E-05,   1.3847395E-05,   1.4117014E-05
     +,   1.4367618E-05,   1.4598114E-05,   1.4807501E-05
     +,   1.4994906E-05,   1.5159600E-05,   1.5300977E-05
     +,   1.5418625E-05,   1.5512294E-05,   1.5581929E-05
     +,   1.5627682E-05,   1.5649921E-05,   1.5649250E-05
     +,   1.5626516E-05,   1.5582822E-05,   1.5519552E-05
     +,   1.5438354E-05,   1.5341178E-05,   1.5230298E-05
     +,   1.5108250E-05,   1.4977937E-05,   1.4842573E-05
     +,   1.4705699E-05,   1.4571225E-05,   1.4443375E-05
     +,   1.4326771E-05,   1.4226384E-05,   1.4147585E-05
     +,   1.4096149E-05,   1.4078293E-05,   1.4100714E-05
     +,   1.4170631E-05,   1.4295835E-05,   1.4484785E-05
     +,   1.4746669E-05,   1.5091503E-05,   1.5530259E-05
     +,   1.6074879E-05,   1.6738490E-05,   1.7535418E-05
     +,   1.8481256E-05,   1.9592930E-05,   2.0888438E-05
     +,   2.2387225E-05,   2.4109338E-05,   2.6075671E-05
     +,   2.8307277E-05,   3.0824936E-05,   3.3648677E-05
     +,   3.6796511E-05,   4.0285042E-05,   4.4127122E-05
     +,   4.8332717E-05,   5.2908068E-05,   5.7854922E-05
     +,   6.3172840E-05,   6.8857102E-05,   7.4903022E-05
     +,   8.1304577E-05,   8.8057175E-05,   9.5161027E-05
     +,   1.0261882E-04,   1.1044081E-04,   1.1864034E-04
     +,   1.2723578E-04,   1.3624706E-04,   1.4569139E-04
     +,   1.5558382E-04,   1.6593032E-04,   1.7673188E-04
     +,   1.8798630E-04,   1.9969387E-04,   2.1187405E-04
     +,   2.2457475E-04,   2.3789563E-04,   2.5200524E-04
     +,   2.6716173E-04,   2.8373572E-04,   3.0223516E-04
     +,   3.2335144E-04,   3.4800282E-04,   3.7740817E-04
     +,   4.1314421E-04,   4.5717173E-04,   5.1177997E-04
     +,   5.7938020E-04,   6.6216692E-04,   7.6154055E-04
     +,   8.7748590E-04,   1.0079120E-03,   1.1481956E-03
     +,   1.2911068E-03,   1.4272662E-03,   1.5463271E-03
     +,   1.6386197E-03,   1.6972427E-03,   1.7199408E-03
     +,   1.7103179E-03,   1.6778348E-03,   1.6364177E-03
     +,   1.6018362E-03,   1.5885119E-03,   1.6065306E-03
     +,   1.6596428E-03,   1.7447039E-03,   1.8527902E-03
     +,   1.9716667E-03,   2.0891998E-03,   2.1966414E-03
     +,   2.2906933E-03,   2.3734716E-03,   2.4501053E-03
     +,   2.5251103E-03,   2.5990286E-03,   2.6671526E-03
     +,   2.7210258E-03,   2.7521693E-03,   2.7564568E-03
     +,   2.7369505E-03,   2.7037088E-03,   2.6704881E-03
     +,   2.6500432E-03,   2.6503957E-03,   2.6736546E-03
     +,   2.7169057E-03,   2.7734728E-03,   2.8333396E-03
     +,   2.8832091E-03,   2.9077022E-03,   2.8924847E-03
     +,   2.8281761E-03,   2.7129636E-03,   2.5524311E-03
     +,   2.3570543E-03,   2.1388985E-03,   1.9094578E-03
     +,   1.6787067E-03,   1.4553041E-03,   1.2465863E-03
     +,   1.0582822E-03,   8.9398224E-04,   7.5471675E-04
     +,   6.3920533E-04,   5.4445094E-04,   4.6665582E-04
     +,   4.0204963E-04,   3.4741021E-04,   3.0033602E-04
     +,   2.5919217E-04,   2.2297280E-04,   1.9107704E-04
     +,   1.6311527E-04,   1.3878470E-04,   1.1778515E-04
     +,   9.9794845E-05,   8.4467189E-05,   7.1451206E-05
     +,   6.0410246E-05,   5.1037441E-05,   4.3066280E-05
     +,   3.6271227E-05,   3.0467014E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_nwao_fus_100 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_nwao_fus_105(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  2.6370637E-20,   3.7882135E-20
     +,   5.4313765E-20,   7.7721089E-20,   1.1100083E-19
     +,   1.5822444E-19,   2.2510113E-19,   3.1962336E-19
     +,   4.5296043E-19,   6.4067274E-19,   9.0442274E-19
     +,   1.2742806E-18,   1.7919102E-18,   2.5149151E-18
     +,   3.5228332E-18,   4.9251103E-18,   6.8722128E-18
     +,   9.5705938E-18,   1.3302542E-17,   1.8453963E-17
     +,   2.5550711E-17,   3.5308204E-17,   4.8697119E-17
     +,   6.7033493E-17,   9.2095047E-17,   1.2628085E-16
     +,   1.7282155E-16,   2.3605736E-16,   3.2180460E-16
     +,   4.3785253E-16,   5.9459241E-16,   8.0587493E-16
     +,   1.0901200E-15,   1.4717736E-15,   1.9831832E-15
     +,   2.6671276E-15,   3.5800013E-15,   4.7959933E-15
     +,   6.4125722E-15,   8.5574832E-15,   1.1397638E-14
     +,   1.5151085E-14,   2.0101544E-14,   2.6617777E-14
     +,   3.5178047E-14,   4.6401556E-14,   6.1086952E-14
     +,   8.0264361E-14,   1.0525829E-13,   1.3776716E-13
     +,   1.7996727E-13,   2.3463921E-13,   3.0532583E-13
     +,   3.9653960E-13,   5.1400182E-13,   6.6496992E-13
     +,   8.5861027E-13,   1.1064926E-12,   1.4231813E-12
     +,   1.8269548E-12,   2.3407522E-12,   2.9932224E-12
     +,   3.8201473E-12,   4.8660988E-12,   6.1864051E-12
     +,   7.8496923E-12,   9.9409370E-12,   1.2564868E-11
     +,   1.5850614E-11,   1.9956864E-11,   2.5078153E-11
     +,   3.1452684E-11,   3.9371423E-11,   4.9187911E-11
     +,   6.1332855E-11,   7.6328381E-11,   9.4806309E-11
     +,   1.1753015E-10,   1.4541715E-10,   1.7957254E-10
     +,   2.2132081E-10,   2.7224611E-10,   3.3424372E-10
     +,   4.0955797E-10,   5.0087817E-10,   6.1136901E-10
     +,   7.4478751E-10,   9.0556435E-10,   1.0989154E-09
     +,   1.3309742E-09,   1.6089038E-09,   1.9411008E-09
     +,   2.3373519E-09,   2.8090408E-09,   3.3693801E-09
     +,   4.0336587E-09,   4.8195838E-09,   5.7474452E-09
     +,   6.8406516E-09,   8.1260279E-09,   9.6342339E-09
     +,   1.1400304E-08,   1.3463890E-08,   1.5870205E-08
     +,   1.8670358E-08,   2.1922007E-08,   2.5690269E-08
     +,   3.0047573E-08,   3.5076248E-08,   4.0866958E-08
     +,   4.7521389E-08,   5.5152331E-08,   6.3884599E-08
     +,   7.3856569E-08,   8.5218701E-08,   9.8139367E-08
     +,   1.1279943E-07,   1.2939833E-07,   1.4815218E-07
     +,   1.6929549E-07,   1.9308246E-07,   2.1978383E-07
     +,   2.4969302E-07,   2.8312306E-07,   3.2040671E-07
     +,   3.6189775E-07,   4.0797158E-07,   4.5901805E-07
     +,   5.1545112E-07,   5.7770103E-07,   6.4621406E-07
     +,   7.2145241E-07,   8.0389361E-07,   8.9401641E-07
     +,   9.9231613E-07,   1.0992910E-06,   1.2154386E-06
     +,   1.3412547E-06,   1.4772271E-06,   1.6238378E-06
     +,   1.7815348E-06,   1.9507606E-06,   2.1319227E-06
     +,   2.3253954E-06,   2.5315205E-06,   2.7505614E-06
     +,   2.9827850E-06,   3.2283413E-06,   3.4873462E-06
     +,   3.7598488E-06,   4.0457776E-06,   4.3450527E-06
     +,   4.6574314E-06,   4.9826217E-06,   5.3202311E-06
     +,   5.6697677E-06,   6.0306606E-06,   6.4021901E-06
     +,   6.7836436E-06,   7.1741269E-06,   7.5727326E-06
     +,   7.9784977E-06,   8.3903542E-06,   8.8073330E-06
     +,   9.2283690E-06,   9.6525137E-06,   1.0078904E-05
     +,   1.0506833E-05,   1.0935838E-05,   1.1365691E-05
     +,   1.1796674E-05,   1.2229449E-05,   1.2665365E-05
     +,   1.3106497E-05,   1.3555811E-05,   1.4017321E-05
     +,   1.4496176E-05,   1.4998920E-05,   1.5533566E-05
     +,   1.6109736E-05,   1.6738792E-05,   1.7433780E-05
     +,   1.8209721E-05,   1.9083194E-05,   2.0072526E-05
     +,   2.1197444E-05,   2.2478824E-05,   2.3938375E-05
     +,   2.5597907E-05,   2.7479453E-05,   2.9603860E-05
     +,   3.1990981E-05,   3.4658922E-05,   3.7623246E-05
     +,   4.0897961E-05,   4.4493921E-05,   4.8421203E-05
     +,   5.2688116E-05,   5.7303074E-05,   6.2277555E-05
     +,   6.7625442E-05,   7.3368530E-05,   7.9535661E-05
     +,   8.6167311E-05,   9.3316303E-05,   1.0104759E-04
     +,   1.0944070E-04,   1.1858387E-04,   1.2857351E-04
     +,   1.3950789E-04,   1.5147821E-04,   1.6456551E-04
     +,   1.7882617E-04,   1.9428912E-04,   2.1094750E-04
     +,   2.2875557E-04,   2.4762927E-04,   2.6744616E-04
     +,   2.8806092E-04,   3.0930445E-04,   3.3100424E-04
     +,   3.5299119E-04,   3.7510949E-04,   3.9722171E-04
     +,   4.1920360E-04,   4.4094652E-04,   4.6233539E-04
     +,   4.8324719E-04,   5.0354312E-04,   5.2308361E-04
     +,   5.4176943E-04,   5.5962091E-04,   5.7691341E-04
     +,   5.9434102E-04,   6.1321625E-04,   6.3563290E-04
     +,   6.6452578E-04,   7.0352812E-04,   7.5653620E-04
     +,   8.2697644E-04,   9.1683667E-04,   1.0257050E-03
     +,   1.1501648E-03,   1.2838728E-03,   1.4186942E-03
     +,   1.5467065E-03,   1.6630281E-03,   1.7686358E-03
     +,   1.8723555E-03,   1.9908990E-03,   2.1455577E-03
     +,   2.3550736E-03,   2.6253927E-03,   2.9405190E-03
     +,   3.2609077E-03,   3.5342304E-03,   3.7173338E-03
     +,   3.7978389E-03,   3.8019032E-03,   3.7813932E-03
     +,   3.7879050E-03,   3.8493238E-03,   3.9612865E-03
     +,   4.0955706E-03,   4.2179585E-03,   4.3044137E-03
     +,   4.3464638E-03,   4.3443842E-03,   4.2971782E-03
     +,   4.2017717E-03,   4.0638777E-03,   3.9080083E-03
     +,   3.7721670E-03,   3.6877689E-03,   3.6614572E-03
     +,   3.6731823E-03,   3.6896833E-03,   3.6803298E-03
     +,   3.6249096E-03,   3.5129364E-03,   3.3404075E-03
     +,   3.1089976E-03,   2.8276595E-03,   2.5137360E-03
     +,   2.1907890E-03,   1.8829082E-03,   1.6085409E-03
     +,   1.3762887E-03,   1.1849267E-03,   1.0264596E-03
     +,   8.9052401E-04,   7.6817913E-04,   6.5386883E-04
     +,   5.4567470E-04,   4.4434861E-04,   3.5196220E-04
     +,   2.7067144E-04,   2.0190702E-04,   1.4604907E-04
     +,   1.0245313E-04,   6.9724490E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_nwao_fus_105 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_nwao_fus_107(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  3.1062089E-28,   5.3806828E-28
     +,   9.2940150E-28,   1.6007269E-27,   2.7490778E-27
     +,   4.7077655E-27,   8.0388170E-27,   1.3687499E-26
     +,   2.3238747E-26,   3.9341516E-26,   6.6412129E-26
     +,   1.1178901E-25,   1.8763009E-25,   3.1402255E-25
     +,   5.2405613E-25,   8.7205773E-25,   1.4469930E-24
     +,   2.3941309E-24,   3.9498455E-24,   6.4978240E-24
     +,   1.0658838E-23,   1.7434621E-23,   2.8435842E-23
     +,   4.6246365E-23,   7.4996893E-23,   1.2127243E-22
     +,   1.9554064E-22,   3.1439326E-22,   5.0403532E-22
     +,   8.0576555E-22,   1.2844230E-21,   2.0415621E-21
     +,   3.2357652E-21,   5.1138587E-21,   8.0588661E-21
     +,   1.2663580E-20,   1.9842567E-20,   3.1002261E-20
     +,   4.8299890E-20,   7.5034303E-20,   1.1623216E-19
     +,   1.7953636E-19,   2.7652503E-19,   4.2469081E-19
     +,   6.5038213E-19,   9.9317539E-19,   1.5122975E-18
     +,   2.2961907E-18,   3.4764668E-18,   5.2483667E-18
     +,   7.9007354E-18,   1.1859683E-17,   1.7751465E-17
     +,   2.6494530E-17,   3.9430720E-17,   5.8515630E-17
     +,   8.6589842E-17,   1.2776805E-16,   1.8799186E-16
     +,   2.7581190E-16,   4.0350405E-16,   5.8862712E-16
     +,   8.5623300E-16,   1.2419591E-15,   1.7963000E-15
     +,   2.5906549E-15,   3.7256668E-15,   5.3426417E-15
     +,   7.6395570E-15,   1.0892843E-14,   1.5487293E-14
     +,   2.1956824E-14,   3.1040640E-14,   4.3756922E-14
     +,   6.1506898E-14,   8.6211142E-14,   1.2049339E-13
     +,   1.6793049E-13,   2.3337460E-13,   3.2339886E-13
     +,   4.4687396E-13,   6.1573657E-13,   8.4600117E-13
     +,   1.1590417E-12,   1.5834377E-12,   2.1570491E-12
     +,   2.9300919E-12,   3.9688604E-12,   5.3605956E-12
     +,   7.2198532E-12,   9.6962135E-12,   1.2984929E-11
     +,   1.7339644E-11,   2.3088973E-11,   3.0657206E-11
     +,   4.0590548E-11,   5.3590236E-11,   7.0551412E-11
     +,   9.2617046E-11,   1.2123824E-10,   1.5825365E-10
     +,   2.0598528E-10,   2.6734967E-10,   3.4600942E-10
     +,   4.4654103E-10,   5.7464561E-10,   7.3740858E-10
     +,   9.4356922E-10,   1.2039613E-09,   1.5318405E-09
     +,   1.9434825E-09,   2.4587430E-09,   3.1017908E-09
     +,   3.9019463E-09,   4.8945128E-09,   6.1222494E-09
     +,   7.6361761E-09,   9.4974606E-09,   1.1778929E-08
     +,   1.4567034E-08,   1.7964176E-08,   2.2090569E-08
     +,   2.7087809E-08,   3.3121388E-08,   4.0384116E-08
     +,   4.9099885E-08,   5.9527995E-08,   7.1965928E-08
     +,   8.6756195E-08,   1.0428987E-07,   1.2501214E-07
     +,   1.4942755E-07,   1.7810673E-07,   2.1168773E-07
     +,   2.5088804E-07,   2.9650582E-07,   3.4942607E-07
     +,   4.1062609E-07,   4.8117937E-07,   5.6226293E-07
     +,   6.5514718E-07,   7.6121626E-07,   8.8195662E-07
     +,   1.0189586E-06,   1.1739198E-06,   1.3486103E-06
     +,   1.5449343E-06,   1.7648284E-06,   2.0103273E-06
     +,   2.2835220E-06,   2.5864983E-06,   2.9214373E-06
     +,   3.2904316E-06,   3.6955917E-06,   4.1389553E-06
     +,   4.6224750E-06,   5.1479960E-06,   5.7171283E-06
     +,   6.3314396E-06,   6.9921157E-06,   7.7001714E-06
     +,   8.4563299E-06,   9.2608698E-06,   1.0113914E-05
     +,   1.1014989E-05,   1.1963329E-05,   1.2957717E-05
     +,   1.3996488E-05,   1.5077583E-05,   1.6198328E-05
     +,   1.7355915E-05,   1.8546823E-05,   1.9767320E-05
     +,   2.1013288E-05,   2.2280292E-05,   2.3563700E-05
     +,   2.4858540E-05,   2.6159856E-05,   2.7462591E-05
     +,   2.8761691E-05,   3.0052264E-05,   3.1329393E-05
     +,   3.2588767E-05,   3.3826087E-05,   3.5037701E-05
     +,   3.6220437E-05,   3.7371799E-05,   3.8490074E-05
     +,   3.9574326E-05,   4.0624964E-05,   4.1643405E-05
     +,   4.2632742E-05,   4.3597855E-05,   4.4545621E-05
     +,   4.5485718E-05,   4.6430519E-05,   4.7396148E-05
     +,   4.8402559E-05,   4.9474176E-05,   5.0640669E-05
     +,   5.1936731E-05,   5.3402975E-05,   5.5085144E-05
     +,   5.7034395E-05,   5.9306345E-05,   6.1959749E-05
     +,   6.5056192E-05,   6.8657449E-05,   7.2825482E-05
     +,   7.7621735E-05,   8.3106992E-05,   8.9346417E-05
     +,   9.6411626E-05,   1.0439143E-04,   1.1340219E-04
     +,   1.2360288E-04,   1.3521269E-04,   1.4852709E-04
     +,   1.6394060E-04,   1.8195275E-04,   2.0318035E-04
     +,   2.2834940E-04,   2.5827670E-04,   2.9383393E-04
     +,   3.3588390E-04,   3.8521978E-04,   4.4244478E-04
     +,   5.0787965E-04,   5.8143603E-04,   6.6251587E-04
     +,   7.4995286E-04,   8.4200612E-04,   9.3650853E-04
     +,   1.0310394E-03,   1.1232620E-03,   1.2112220E-03
     +,   1.2935853E-03,   1.3697094E-03,   1.4394952E-03
     +,   1.5031119E-03,   1.5606604E-03,   1.6119847E-03
     +,   1.6567267E-03,   1.6946172E-03,   1.7259147E-03
     +,   1.7517452E-03,   1.7742604E-03,   1.7965287E-03
     +,   1.8222461E-03,   1.8553559E-03,   1.8995383E-03
     +,   1.9575299E-03,   2.0301563E-03,   2.1153530E-03
     +,   2.2076583E-03,   2.2986219E-03,   2.3785441E-03
     +,   2.4390006E-03,   2.4756461E-03,   2.4904169E-03
     +,   2.4927706E-03,   2.4996665E-03,   2.5339781E-03
     +,   2.6209014E-03,   2.7821991E-03,   3.0289420E-03
     +,   3.3546055E-03,   3.7313378E-03,   4.1127387E-03
     +,   4.4445973E-03,   4.6820198E-03,   4.8069428E-03
     +,   4.8372215E-03,   4.8199277E-03,   4.8082233E-03
     +,   4.8324005E-03,   4.8834970E-03,   4.9231057E-03
     +,   4.9136705E-03,   4.8453771E-03,   4.7378149E-03
     +,   4.6169339E-03,   4.4886759E-03,   4.3308353E-03
     +,   4.1074529E-03,   3.7927476E-03,   3.3880384E-03
     +,   2.9222835E-03,   2.4395515E-03,   1.9821862E-03
     +,   1.5788852E-03,   1.2416346E-03,   9.6916582E-04
     +,   7.5311924E-04,   5.8315799E-04,   4.4987909E-04
     +,   3.4568793E-04,   2.6462588E-04,   2.0193620E-04
     +,   1.5369986E-04,   1.1667635E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_nwao_fus_107 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_nwao_fus_110(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  1.0085239E-18,   1.3991955E-18
     +,   1.9377686E-18,   2.6788556E-18,   3.6968100E-18
     +,   5.0925416E-18,   7.0027324E-18,   9.6123441E-18
     +,   1.3171086E-17,   1.8015210E-17,   2.4597160E-17
     +,   3.3524475E-17,   4.5610540E-17,   6.1943619E-17
     +,   8.3976276E-17,   1.1364353E-16,   1.5351821E-16
     +,   2.0701680E-16,   2.7866185E-16,   3.7443668E-16
     +,   5.0223426E-16,   6.7245734E-16,   8.9877353E-16
     +,   1.1991255E-15,   1.5970046E-15,   2.1231213E-15
     +,   2.8175598E-15,   3.7325108E-15,   4.9357741E-15
     +,   6.5153838E-15,   8.5851956E-15,   1.1292476E-14
     +,   1.4827100E-14,   1.9433618E-14,   2.5425913E-14
     +,   3.3206839E-14,   4.3292206E-14,   5.6340176E-14
     +,   7.3190362E-14,   9.4911939E-14,   1.2286079E-13
     +,   1.5875823E-13,   2.0477902E-13,   2.6367116E-13
     +,   3.3889712E-13,   4.3481402E-13,   5.5688500E-13
     +,   7.1195979E-13,   9.0860658E-13,   1.1575043E-12
     +,   1.4719673E-12,   1.8685420E-12,   2.3677375E-12
     +,   2.9949877E-12,   3.7816638E-12,   4.7664910E-12
     +,   5.9971182E-12,   7.5320843E-12,   9.4431624E-12
     +,   1.1818066E-11,   1.4764035E-11,   1.8411534E-11
     +,   2.2919406E-11,   2.8480470E-11,   3.5327821E-11
     +,   4.3743641E-11,   5.4068295E-11,   6.6710949E-11
     +,   8.2163776E-11,   1.0101615E-10,   1.2397383E-10
     +,   1.5187882E-10,   1.8573619E-10,   2.2673580E-10
     +,   2.7629435E-10,   3.3608752E-10,   4.0809481E-10
     +,   4.9465310E-10,   5.9850230E-10,   7.2286782E-10
     +,   8.7152524E-10,   1.0488886E-09,   1.2601149E-09
     +,   1.5111692E-09,   1.8090502E-09,   2.1617867E-09
     +,   2.5787150E-09,   3.0705940E-09,   3.6498025E-09
     +,   4.3305910E-09,   5.1292126E-09,   6.0643250E-09
     +,   7.1571913E-09,   8.4320027E-09,   9.9162412E-09
     +,   1.1641041E-08,   1.3641669E-08,   1.5957641E-08
     +,   1.8633648E-08,   2.1719792E-08,   2.5272128E-08
     +,   2.9353409E-08,   3.4033075E-08,   3.9388762E-08
     +,   4.5506301E-08,   5.2480690E-08,   6.0416923E-08
     +,   6.9429056E-08,   7.9644785E-08,   9.1201031E-08
     +,   1.0424884E-07,   1.1895200E-07,   1.3548824E-07
     +,   1.5405050E-07,   1.7484383E-07,   1.9809418E-07
     +,   2.2403795E-07,   2.5293124E-07,   2.8504596E-07
     +,   3.2067123E-07,   3.6011394E-07,   4.0369389E-07
     +,   4.5175184E-07,   5.0464297E-07,   5.6273888E-07
     +,   6.2642658E-07,   6.9610923E-07,   7.7219738E-07
     +,   8.5512073E-07,   9.4531896E-07,   1.0432428E-06
     +,   1.1493523E-06,   1.2641221E-06,   1.3880211E-06
     +,   1.5215401E-06,   1.6651724E-06,   1.8194211E-06
     +,   1.9847987E-06,   2.1618289E-06,   2.3510568E-06
     +,   2.5530239E-06,   2.7683168E-06,   2.9975442E-06
     +,   3.2413552E-06,   3.5004530E-06,   3.7755626E-06
     +,   4.0675550E-06,   4.3773175E-06,   4.7058875E-06
     +,   5.0544340E-06,   5.4242219E-06,   5.8167911E-06
     +,   6.2337826E-06,   6.6771204E-06,   7.1489726E-06
     +,   7.6517890E-06,   8.1883509E-06,   8.7616909E-06
     +,   9.3753488E-06,   1.0033080E-05,   1.0739121E-05
     +,   1.1498095E-05,   1.2314907E-05,   1.3195036E-05
     +,   1.4144085E-05,   1.5168099E-05,   1.6273336E-05
     +,   1.7466227E-05,   1.8753361E-05,   2.0141093E-05
     +,   2.1636020E-05,   2.3244080E-05,   2.4970988E-05
     +,   2.6821823E-05,   2.8800858E-05,   3.0911458E-05
     +,   3.3155589E-05,   3.5534056E-05,   3.8046015E-05
     +,   4.0688854E-05,   4.3458149E-05,   4.6346944E-05
     +,   4.9346887E-05,   5.2446583E-05,   5.5632812E-05
     +,   5.8890058E-05,   6.2200750E-05,   6.5545573E-05
     +,   6.8903311E-05,   7.2252631E-05,   7.5571072E-05
     +,   7.8837242E-05,   8.2031394E-05,   8.5136300E-05
     +,   8.8140019E-05,   9.1036069E-05,   9.3827082E-05
     +,   9.6525604E-05,   9.9156874E-05,   1.0176181E-04
     +,   1.0439759E-04,   1.0714098E-04,   1.1008809E-04
     +,   1.1335590E-04,   1.1708129E-04,   1.2141887E-04
     +,   1.2653967E-04,   1.3262477E-04,   1.3986173E-04
     +,   1.4843792E-04,   1.5853174E-04,   1.7030966E-04
     +,   1.8391370E-04,   1.9945945E-04,   2.1702836E-04
     +,   2.3666323E-04,   2.5836553E-04,   2.8208809E-04
     +,   3.0774417E-04,   3.3519833E-04,   3.6428674E-04
     +,   3.9483575E-04,   4.2670243E-04,   4.5983633E-04
     +,   4.9435458E-04,   5.3064531E-04,   5.6943164E-04
     +,   6.1182986E-04,   6.5931753E-04,   7.1361137E-04
     +,   7.7644532E-04,   8.4924483E-04,   9.3280937E-04
     +,   1.0269578E-03,   1.1303414E-03,   1.2403574E-03
     +,   1.3532295E-03,   1.4642342E-03,   1.5680211E-03
     +,   1.6590951E-03,   1.7324117E-03,   1.7841632E-03
     +,   1.8126994E-03,   1.8194094E-03,   1.8092849E-03
     +,   1.7907762E-03,   1.7747033E-03,   1.7722190E-03
     +,   1.7922171E-03,   1.8389269E-03,   1.9105218E-03
     +,   1.9994632E-03,   2.0945878E-03,   2.1844420E-03
     +,   2.2606656E-03,   2.3200656E-03,   2.3648688E-03
     +,   2.4012884E-03,   2.4377140E-03,   2.4835295E-03
     +,   2.5487468E-03,   2.6432858E-03,   2.7743408E-03
     +,   2.9420024E-03,   3.1355207E-03,   3.3342820E-03
     +,   3.5156000E-03,   3.6665343E-03,   3.7923590E-03
     +,   3.9140633E-03,   4.0540430E-03,   4.2179916E-03
     +,   4.3855067E-03,   4.5173313E-03,   4.5753326E-03
     +,   4.5423526E-03,   4.4289371E-03,   4.2640409E-03
     +,   4.0779919E-03,   3.8898545E-03,   3.7051784E-03
     +,   3.5218799E-03,   3.3368142E-03,   3.1486233E-03
     +,   2.9568125E-03,   2.7599542E-03,   2.5555945E-03
     +,   2.3415904E-03,   2.1180483E-03,   1.8881758E-03
     +,   1.6577952E-03,   1.4340115E-03,   1.2235185E-03
     +,   1.0313792E-03,   8.6041557E-04,   7.1135088E-04
     +,   5.8333261E-04,   4.7458915E-04,   3.8300455E-04
     +,   3.0645035E-04,   2.4296707E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_nwao_fus_110 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_nwao_fus_115(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  4.6203941E-19,   6.5405652E-19
     +,   9.2407738E-19,   1.3030314E-18,   1.8338187E-18
     +,   2.5758200E-18,   3.6109982E-18,   5.0523476E-18
     +,   7.0553345E-18,   9.8331749E-18,   1.3678076E-17
     +,   1.8989509E-17,   2.6312078E-17,   3.6387523E-17
     +,   5.0223445E-17,   6.9185062E-17,   9.5120298E-17
     +,   1.3052489E-16,   1.7875756E-16,   2.4433772E-16
     +,   3.3332795E-16,   4.5384809E-16,   6.1673972E-16
     +,   8.3647092E-16,   1.1322763E-15,   1.5297097E-15
     +,   2.0626231E-15,   2.7758066E-15,   3.7283019E-15
     +,   4.9979247E-15,   6.6868398E-15,   8.9290901E-15
     +,   1.1900044E-14,   1.5828781E-14,   2.1013532E-14
     +,   2.7842336E-14,   3.6818750E-14,   4.8594355E-14
     +,   6.4011330E-14,   8.4156078E-14,   1.1042503E-13
     +,   1.4461263E-13,   1.8901561E-13,   2.4657219E-13
     +,   3.2103001E-13,   4.1716118E-13,   5.4102279E-13
     +,   7.0029713E-13,   9.0470269E-13,   1.1664927E-12
     +,   1.5011151E-12,   1.9279793E-12,   2.4714039E-12
     +,   3.1618573E-12,   4.0373256E-12,   5.1451777E-12
     +,   6.5442760E-12,   8.3076532E-12,   1.0525722E-11
     +,   1.3310024E-11,   1.6798191E-11,   2.1159156E-11
     +,   2.6600546E-11,   3.3376364E-11,   4.1796563E-11
     +,   5.2239223E-11,   6.5164416E-11,   8.1129138E-11
     +,   1.0080887E-10,   1.2501876E-10,   1.5474151E-10
     +,   1.9115844E-10,   2.3568858E-10,   2.9002503E-10
     +,   3.5619435E-10,   4.3660991E-10,   5.3414029E-10
     +,   6.5219191E-10,   7.9478002E-10,   9.6665942E-10
     +,   1.1734256E-09,   1.4216490E-09,   1.7190444E-09
     +,   2.0745829E-09,   2.4988247E-09,   3.0039493E-09
     +,   3.6041645E-09,   4.3159027E-09,   5.1581495E-09
     +,   6.1528214E-09,   7.3249806E-09,   8.7034975E-09
     +,   1.0321345E-08,   1.2216150E-08,   1.4430699E-08
     +,   1.7013578E-08,   2.0019899E-08,   2.3511525E-08
     +,   2.7558475E-08,   3.2239271E-08,   3.7641804E-08
     +,   4.3864581E-08,   5.1016542E-08,   5.9219392E-08
     +,   6.8607697E-08,   7.9330121E-08,   9.1550817E-08
     +,   1.0544802E-07,   1.2122057E-07,   1.3908142E-07
     +,   1.5926487E-07,   1.8202414E-07,   2.0763304E-07
     +,   2.3638793E-07,   2.6860249E-07,   3.0462070E-07
     +,   3.4480092E-07,   3.8952896E-07,   4.3921253E-07
     +,   4.9428149E-07,   5.5519075E-07,   6.2240883E-07
     +,   6.9643244E-07,   7.7777463E-07,   8.6696679E-07
     +,   9.6455574E-07,   1.0711082E-06,   1.1871887E-06
     +,   1.3133855E-06,   1.4502890E-06,   1.5984953E-06
     +,   1.7586004E-06,   1.9312090E-06,   2.1169005E-06
     +,   2.3162693E-06,   2.5298939E-06,   2.7583437E-06
     +,   3.0021756E-06,   3.2619353E-06,   3.5381640E-06
     +,   3.8313606E-06,   4.1420421E-06,   4.4707072E-06
     +,   4.8178490E-06,   5.1839706E-06,   5.5695245E-06
     +,   5.9750737E-06,   6.4010956E-06,   6.8481554E-06
     +,   7.3168580E-06,   7.8077846E-06,   8.3217037E-06
     +,   8.8593260E-06,   9.4215220E-06,   1.0009238E-05
     +,   1.0623535E-05,   1.1265611E-05,   1.1936698E-05
     +,   1.2638340E-05,   1.3372040E-05,   1.4139550E-05
     +,   1.4942768E-05,   1.5783593E-05,   1.6664271E-05
     +,   1.7586928E-05,   1.8553885E-05,   1.9567487E-05
     +,   2.0630085E-05,   2.1744032E-05,   2.2911418E-05
     +,   2.4134484E-05,   2.5414949E-05,   2.6754409E-05
     +,   2.8154060E-05,   2.9614639E-05,   3.1136398E-05
     +,   3.2718817E-05,   3.4360826E-05,   3.6060530E-05
     +,   3.7815167E-05,   3.9621136E-05,   4.1473591E-05
     +,   4.3367156E-05,   4.5294935E-05,   4.7249319E-05
     +,   4.9221617E-05,   5.1202194E-05,   5.3180644E-05
     +,   5.5145552E-05,   5.7085421E-05,   5.8987862E-05
     +,   6.0840623E-05,   6.2631545E-05,   6.4348613E-05
     +,   6.5980967E-05,   6.7518347E-05,   6.8952402E-05
     +,   7.0276241E-05,   7.1485199E-05,   7.2577452E-05
     +,   7.3553761E-05,   7.4418509E-05,   7.5179487E-05
     +,   7.5848700E-05,   7.6442673E-05,   7.6982935E-05
     +,   7.7496996E-05,   7.8019002E-05,   7.8591169E-05
     +,   7.9265097E-05,   8.0103455E-05,   8.1182210E-05
     +,   8.2592000E-05,   8.4440442E-05,   8.6853397E-05
     +,   8.9975976E-05,   9.3973234E-05,   9.9029123E-05
     +,   1.0534780E-04,   1.1315027E-04,   1.2267557E-04
     +,   1.3417844E-04,   1.4792764E-04,   1.6420285E-04
     +,   1.8328404E-04,   2.0544644E-04,   2.3093187E-04
     +,   2.5993091E-04,   2.9254888E-04,   3.2877582E-04
     +,   3.6846395E-04,   4.1131073E-04,   4.5689059E-04
     +,   5.0467206E-04,   5.5410183E-04,   6.0467236E-04
     +,   6.5599597E-04,   7.0784945E-04,   7.6017075E-04
     +,   8.1303169E-04,   8.6657604E-04,   9.2098094E-04
     +,   9.7646838E-04,   1.0333465E-03,   1.0920877E-03
     +,   1.1532769E-03,   1.2174809E-03,   1.2849547E-03
     +,   1.3553241E-03,   1.4274543E-03,   1.4995402E-03
     +,   1.5696178E-03,   1.6362724E-03,   1.6995647E-03
     +,   1.7620289E-03,   1.8294768E-03,   1.9112205E-03
     +,   2.0186491E-03,   2.1615420E-03,   2.3424840E-03
     +,   2.5517247E-03,   2.7661999E-03,   2.9547450E-03
     +,   3.0885949E-03,   3.1519034E-03,   3.1470852E-03
     +,   3.0930692E-03,   3.0190933E-03,   2.9578609E-03
     +,   2.9395910E-03,   2.9858185E-03,   3.1023924E-03
     +,   3.2741921E-03,   3.4657686E-03,   3.6295759E-03
     +,   3.7195801E-03,   3.7043157E-03,   3.5744044E-03
     +,   3.3422017E-03,   3.0352944E-03,   2.6873169E-03
     +,   2.3302159E-03,   1.9892661E-03,   1.6813609E-03
     +,   1.4153949E-03,   1.1935928E-03,   1.0135396E-03
     +,   8.6992886E-04,   7.5624854E-04,   6.6584203E-04
     +,   5.9256121E-04,   5.3115020E-04,   4.7741388E-04
     +,   4.2832052E-04,   3.8198417E-04,   3.3754495E-04
     +,   2.9492931E-04,   2.5454717E-04,   2.1700043E-04
     +,   1.8283975E-04,   1.5242779E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_nwao_fus_115 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_nwao_fus_120(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  1.2069372E-18,   1.7137523E-18
     +,   2.4284453E-18,   3.4341414E-18,   4.8464173E-18
     +,   6.8255941E-18,   9.5933554E-18,   1.3455944E-17
     +,   1.8835291E-17,   2.6311361E-17,   3.6679677E-17
     +,   5.1029986E-17,   7.0849204E-17,   9.8165328E-17
     +,   1.3573624E-16,   1.8730368E-16,   2.5793413E-16
     +,   3.5447651E-16,   4.8615694E-16,   6.6539573E-16
     +,   9.0885682E-16,   1.2388740E-15,   1.6852719E-15
     +,   2.2878487E-15,   3.0995356E-15,   4.1906248E-15
     +,   5.6542452E-15,   7.6135252E-15,   1.0230765E-14
     +,   1.3719737E-14,   1.8360927E-14,   2.4522024E-14
     +,   3.2683732E-14,   4.3473349E-14,   5.7706525E-14
     +,   7.6443334E-14,   1.0105794E-13,   1.3332502E-13
     +,   1.7553642E-13,   2.3064149E-13,   3.0242632E-13
     +,   3.9574580E-13,   5.1680188E-13,   6.7351246E-13
     +,   8.7595133E-13,   1.1369213E-12,   1.4726220E-12
     +,   1.9035565E-12,   2.4555887E-12,   3.1612399E-12
     +,   4.0613628E-12,   5.2071594E-12,   6.6625806E-12
     +,   8.5074326E-12,   1.0840912E-11,   1.3786269E-11
     +,   1.7496069E-11,   2.2158886E-11,   2.8007261E-11
     +,   3.5326821E-11,   4.4468595E-11,   5.5861659E-11
     +,   7.0030544E-11,   8.7614596E-11,   1.0938975E-10
     +,   1.3629832E-10,   1.6948030E-10,   2.1030985E-10
     +,   2.6044306E-10,   3.2186906E-10,   3.9697143E-10
     +,   4.8859955E-10,   6.0015432E-10,   7.3566891E-10
     +,   8.9994395E-10,   1.0986572E-09,   1.3385106E-09
     +,   1.6274136E-09,   1.9746225E-09,   2.3910234E-09
     +,   2.8893281E-09,   3.4843575E-09,   4.1933883E-09
     +,   5.0363385E-09,   6.0364784E-09,   7.2204305E-09
     +,   8.6189740E-09,   1.0267415E-08,   1.2206203E-08
     +,   1.4481572E-08,   1.7145938E-08,   2.0259096E-08
     +,   2.3888687E-08,   2.8111090E-08,   3.3012363E-08
     +,   3.8689098E-08,   4.5249784E-08,   5.2814745E-08
     +,   6.1518691E-08,   7.1510904E-08,   8.2956561E-08
     +,   9.6038391E-08,   1.1095580E-07,   1.2792876E-07
     +,   1.4719730E-07,   1.6902256E-07,   1.9368908E-07
     +,   2.2150027E-07,   2.5279084E-07,   2.8791163E-07
     +,   3.2724316E-07,   3.7118900E-07,   4.2017757E-07
     +,   4.7466392E-07,   5.3511667E-07,   6.0204400E-07
     +,   6.7595698E-07,   7.5739683E-07,   8.4691749E-07
     +,   9.4508738E-07,   1.0524898E-06,   1.1697023E-06
     +,   1.2973169E-06,   1.4359198E-06,   1.5860887E-06
     +,   1.7483898E-06,   1.9233744E-06,   2.1115493E-06
     +,   2.3134071E-06,   2.5293916E-06,   2.7599019E-06
     +,   3.0052779E-06,   3.2658074E-06,   3.5416740E-06
     +,   3.8330122E-06,   4.1398589E-06,   4.4621561E-06
     +,   4.7997405E-06,   5.1523457E-06,   5.5196001E-06
     +,   5.9009726E-06,   6.2958497E-06,   6.7034798E-06
     +,   7.1229824E-06,   7.5533662E-06,   7.9934471E-06
     +,   8.4420344E-06,   8.8976976E-06,   9.3589670E-06
     +,   9.8242626E-06,   1.0291843E-05,   1.0760005E-05
     +,   1.1226855E-05,   1.1690515E-05,   1.2149052E-05
     +,   1.2600515E-05,   1.3042979E-05,   1.3474468E-05
     +,   1.3893176E-05,   1.4297261E-05,   1.4685037E-05
     +,   1.5054939E-05,   1.5405509E-05,   1.5735552E-05
     +,   1.6043985E-05,   1.6330008E-05,   1.6593063E-05
     +,   1.6832868E-05,   1.7049439E-05,   1.7243083E-05
     +,   1.7414484E-05,   1.7564631E-05,   1.7694880E-05
     +,   1.7806949E-05,   1.7902910E-05,   1.7985210E-05
     +,   1.8056635E-05,   1.8120323E-05,   1.8179766E-05
     +,   1.8238770E-05,   1.8301473E-05,   1.8372282E-05
     +,   1.8455936E-05,   1.8557430E-05,   1.8682043E-05
     +,   1.8835337E-05,   1.9023139E-05,   1.9251596E-05
     +,   1.9527115E-05,   1.9856516E-05,   2.0246915E-05
     +,   2.0705880E-05,   2.1241454E-05,   2.1862103E-05
     +,   2.2577015E-05,   2.3395782E-05,   2.4328892E-05
     +,   2.5387355E-05,   2.6582849E-05,   2.7928068E-05
     +,   2.9436063E-05,   3.1121024E-05,   3.2997435E-05
     +,   3.5080750E-05,   3.7387228E-05,   3.9933675E-05
     +,   4.2738728E-05,   4.5821987E-05,   4.9205762E-05
     +,   5.2915682E-05,   5.6981255E-05,   6.1438943E-05
     +,   6.6331631E-05,   7.1711707E-05,   7.7641387E-05
     +,   8.4193205E-05,   9.1449409E-05,   9.9498298E-05
     +,   1.0843375E-04,   1.1834619E-04,   1.2932137E-04
     +,   1.4143666E-04,   1.5476478E-04,   1.6938827E-04
     +,   1.8542644E-04,   2.0309220E-04,   2.2275742E-04
     +,   2.4505344E-04,   2.7096859E-04,   3.0193129E-04
     +,   3.3983504E-04,   3.8694742E-04,   4.4569094E-04
     +,   5.1820575E-04,   6.0581340E-04,   7.0840295E-04
     +,   8.2395924E-04,   9.4843161E-04,   1.0760984E-03
     +,   1.2005426E-03,   1.3159979E-03,   1.4187603E-03
     +,   1.5081633E-03,   1.5866548E-03,   1.6588632E-03
     +,   1.7296982E-03,   1.8021823E-03,   1.8756435E-03
     +,   1.9450744E-03,   2.0022150E-03,   2.0382728E-03
     +,   2.0477416E-03,   2.0317857E-03,   1.9995624E-03
     +,   1.9662899E-03,   1.9485614E-03,   1.9590049E-03
     +,   2.0031142E-03,   2.0796815E-03,   2.1839822E-03
     +,   2.3112632E-03,   2.4586103E-03,   2.6247003E-03
     +,   2.8084242E-03,   3.0066522E-03,   3.2113190E-03
     +,   3.4067167E-03,   3.5695131E-03,   3.6740843E-03
     +,   3.7021844E-03,   3.6518988E-03,   3.5397150E-03
     +,   3.3937288E-03,   3.2420480E-03,   3.1034159E-03
     +,   2.9839172E-03,   2.8794552E-03,   2.7803427E-03
     +,   2.6755445E-03,   2.5556507E-03,   2.4147476E-03
     +,   2.2514702E-03,   2.0689128E-03,   1.8736020E-03
     +,   1.6738769E-03,   1.4780506E-03,   1.2931022E-03
     +,   1.1236712E-03,   9.7189599E-04,   8.3768566E-04
     +,   7.1943784E-04,   6.1497081E-04,   5.2223692E-04
     +,   4.3976220E-04,   3.6669447E-04,   3.0263574E-04
     +,   2.4735834E-04,   2.0055915E-04,   1.6172859E-04
     +,   1.3011729E-04,   1.0480345E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_nwao_fus_120 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_nwao_fus_60(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  2.1775668E-05,   2.2390928E-05
     +,   2.3027880E-05,   2.3687999E-05,   2.4372921E-05
     +,   2.5084397E-05,   2.5824269E-05,   2.6594540E-05
     +,   2.7397335E-05,   2.8234854E-05,   2.9109471E-05
     +,   3.0023661E-05,   3.0979951E-05,   3.1981031E-05
     +,   3.3029661E-05,   3.4128596E-05,   3.5280740E-05
     +,   3.6489007E-05,   3.7756254E-05,   3.9085407E-05
     +,   4.0479332E-05,   4.1940868E-05,   4.3472675E-05
     +,   4.5077406E-05,   4.6757446E-05,   4.8515099E-05
     +,   5.0352421E-05,   5.2271265E-05,   5.4273096E-05
     +,   5.6359229E-05,   5.8530502E-05,   6.0787501E-05
     +,   6.3130385E-05,   6.5558976E-05,   6.8072506E-05
     +,   7.0669972E-05,   7.3349860E-05,   7.6110133E-05
     +,   7.8948389E-05,   8.1861821E-05,   8.4847015E-05
     +,   8.7900407E-05,   9.1017733E-05,   9.4194547E-05
     +,   9.7426040E-05,   1.0070710E-04,   1.0403219E-04
     +,   1.0739569E-04,   1.1079176E-04,   1.1421424E-04
     +,   1.1765705E-04,   1.2111399E-04,   1.2457868E-04
     +,   1.2804499E-04,   1.3150653E-04,   1.3495728E-04
     +,   1.3839122E-04,   1.4180248E-04,   1.4518549E-04
     +,   1.4853467E-04,   1.5184493E-04,   1.5511124E-04
     +,   1.5832904E-04,   1.6149410E-04,   1.6460233E-04
     +,   1.6765026E-04,   1.7063464E-04,   1.7355273E-04
     +,   1.7640220E-04,   1.7918118E-04,   1.8188833E-04
     +,   1.8452281E-04,   1.8708440E-04,   1.8957326E-04
     +,   1.9199018E-04,   1.9433667E-04,   1.9661478E-04
     +,   1.9882718E-04,   2.0097694E-04,   2.0306786E-04
     +,   2.0510411E-04,   2.0709052E-04,   2.0903211E-04
     +,   2.1093394E-04,   2.1280188E-04,   2.1464114E-04
     +,   2.1645716E-04,   2.1825513E-04,   2.2003952E-04
     +,   2.2181455E-04,   2.2358318E-04,   2.2534771E-04
     +,   2.2710914E-04,   2.2886708E-04,   2.3061980E-04
     +,   2.3236396E-04,   2.3409449E-04,   2.3580463E-04
     +,   2.3748596E-04,   2.3912839E-04,   2.4072033E-04
     +,   2.4224882E-04,   2.4369950E-04,   2.4505742E-04
     +,   2.4630674E-04,   2.4743148E-04,   2.4841592E-04
     +,   2.4924439E-04,   2.4990275E-04,   2.5037781E-04
     +,   2.5065837E-04,   2.5073547E-04,   2.5060269E-04
     +,   2.5025650E-04,   2.4969666E-04,   2.4892637E-04
     +,   2.4795230E-04,   2.4678491E-04,   2.4543804E-04
     +,   2.4392927E-04,   2.4227935E-04,   2.4051224E-04
     +,   2.3865431E-04,   2.3673431E-04,   2.3478274E-04
     +,   2.3283134E-04,   2.3091231E-04,   2.2905805E-04
     +,   2.2730028E-04,   2.2566952E-04,   2.2419452E-04
     +,   2.2290170E-04,   2.2181468E-04,   2.2095401E-04
     +,   2.2033638E-04,   2.1997480E-04,   2.1987816E-04
     +,   2.2005117E-04,   2.2049450E-04,   2.2120467E-04
     +,   2.2217425E-04,   2.2339216E-04,   2.2484384E-04
     +,   2.2651185E-04,   2.2837607E-04,   2.3041409E-04
     +,   2.3260209E-04,   2.3491474E-04,   2.3732599E-04
     +,   2.3980992E-04,   2.4234033E-04,   2.4489223E-04
     +,   2.4744112E-04,   2.4996436E-04,   2.5244098E-04
     +,   2.5485194E-04,   2.5718054E-04,   2.5941251E-04
     +,   2.6153604E-04,   2.6354191E-04,   2.6542373E-04
     +,   2.6717750E-04,   2.6880155E-04,   2.7029685E-04
     +,   2.7166633E-04,   2.7291506E-04,   2.7404941E-04
     +,   2.7507753E-04,   2.7600833E-04,   2.7685158E-04
     +,   2.7761766E-04,   2.7831670E-04,   2.7895853E-04
     +,   2.7955265E-04,   2.8010726E-04,   2.8062958E-04
     +,   2.8112513E-04,   2.8159792E-04,   2.8204979E-04
     +,   2.8248093E-04,   2.8288920E-04,   2.8327064E-04
     +,   2.8361916E-04,   2.8392713E-04,   2.8418491E-04
     +,   2.8438188E-04,   2.8450595E-04,   2.8454463E-04
     +,   2.8448505E-04,   2.8431421E-04,   2.8401965E-04
     +,   2.8358985E-04,   2.8301441E-04,   2.8228475E-04
     +,   2.8139388E-04,   2.8033741E-04,   2.7911289E-04
     +,   2.7772106E-04,   2.7616479E-04,   2.7444991E-04
     +,   2.7258502E-04,   2.7058067E-04,   2.6845024E-04
     +,   2.6620910E-04,   2.6387407E-04,   2.6146381E-04
     +,   2.5899752E-04,   2.5649558E-04,   2.5397810E-04
     +,   2.5146516E-04,   2.4897646E-04,   2.4653008E-04
     +,   2.4414345E-04,   2.4183177E-04,   2.3960849E-04
     +,   2.3748487E-04,   2.3546942E-04,   2.3356878E-04
     +,   2.3178621E-04,   2.3012297E-04,   2.2857722E-04
     +,   2.2714483E-04,   2.2581918E-04,   2.2459133E-04
     +,   2.2345048E-04,   2.2238366E-04,   2.2137667E-04
     +,   2.2041368E-04,   2.1947810E-04,   2.1855233E-04
     +,   2.1761862E-04,   2.1665881E-04,   2.1565508E-04
     +,   2.1458986E-04,   2.1344639E-04,   2.1220872E-04
     +,   2.1086205E-04,   2.0939288E-04,   2.0778926E-04
     +,   2.0604087E-04,   2.0413901E-04,   2.0207686E-04
     +,   1.9984937E-04,   1.9745372E-04,   1.9488834E-04
     +,   1.9215420E-04,   1.8925354E-04,   1.8619045E-04
     +,   1.8297105E-04,   1.7960199E-04,   1.7609246E-04
     +,   1.7245160E-04,   1.6869057E-04,   1.6482126E-04
     +,   1.6085558E-04,   1.5680696E-04,   1.5268814E-04
     +,   1.4851306E-04,   1.4429507E-04,   1.4004744E-04
     +,   1.3578388E-04,   1.3151647E-04,   1.2725801E-04
     +,   1.2302007E-04,   1.1881367E-04,   1.1464909E-04
     +,   1.1053566E-04,   1.0648234E-04,   1.0249671E-04
     +,   9.8585653E-05,   9.4755218E-05,   9.1010355E-05
     +,   8.7355766E-05,   8.3794395E-05,   8.0329468E-05
     +,   7.6962417E-05,   7.3694930E-05,   7.0527552E-05
     +,   6.7460292E-05,   6.4493091E-05,   6.1624683E-05
     +,   5.8854170E-05,   5.6179928E-05,   5.3600055E-05
     +,   5.1112798E-05,   4.8715603E-05,   4.6406549E-05
     +,   4.4182860E-05,   4.2042302E-05,   3.9982551E-05
     +,   3.8000930E-05,   3.6095131E-05,   3.4262710E-05
     +,   3.2501517E-05,   3.0809275E-05,   2.9183839E-05
     +,   2.7623179E-05,   2.6125277E-05,   2.4688376E-05
     +,   2.3310640E-05,   2.1990361E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_nwao_fus_60 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_nwao_fus_65(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  1.7661523E-05,   1.8241823E-05
     +,   1.8846191E-05,   1.9475585E-05,   2.0130979E-05
     +,   2.0813335E-05,   2.1523527E-05,   2.2262459E-05
     +,   2.3030974E-05,   2.3829847E-05,   2.4659810E-05
     +,   2.5521558E-05,   2.6415652E-05,   2.7342630E-05
     +,   2.8302964E-05,   2.9296960E-05,   3.0324894E-05
     +,   3.1386946E-05,   3.2483127E-05,   3.3613425E-05
     +,   3.4777669E-05,   3.5975627E-05,   3.7206883E-05
     +,   3.8471007E-05,   3.9767383E-05,   4.1095347E-05
     +,   4.2454154E-05,   4.3842971E-05,   4.5260811E-05
     +,   4.6706773E-05,   4.8179736E-05,   4.9678678E-05
     +,   5.1202478E-05,   5.2750074E-05,   5.4320331E-05
     +,   5.5912191E-05,   5.7524681E-05,   5.9156802E-05
     +,   6.0807717E-05,   6.2476720E-05,   6.4163141E-05
     +,   6.5866530E-05,   6.7586545E-05,   6.9323083E-05
     +,   7.1076218E-05,   7.2846262E-05,   7.4633652E-05
     +,   7.6439144E-05,   7.8263743E-05,   8.0108592E-05
     +,   8.1975151E-05,   8.3865125E-05,   8.5780317E-05
     +,   8.7722918E-05,   8.9695131E-05,   9.1699410E-05
     +,   9.3738381E-05,   9.5814743E-05,   9.7931290E-05
     +,   1.0009078E-04,   1.0229612E-04,   1.0455000E-04
     +,   1.0685511E-04,   1.0921411E-04,   1.1162923E-04
     +,   1.1410266E-04,   1.1663632E-04,   1.1923161E-04
     +,   1.2188974E-04,   1.2461144E-04,   1.2739701E-04
     +,   1.3024620E-04,   1.3315839E-04,   1.3613208E-04
     +,   1.3916548E-04,   1.4225616E-04,   1.4540106E-04
     +,   1.4859665E-04,   1.5183842E-04,   1.5512166E-04
     +,   1.5844099E-04,   1.6179046E-04,   1.6516366E-04
     +,   1.6855332E-04,   1.7195249E-04,   1.7535302E-04
     +,   1.7874681E-04,   1.8212537E-04,   1.8547995E-04
     +,   1.8880170E-04,   1.9208115E-04,   1.9530924E-04
     +,   1.9847660E-04,   2.0157383E-04,   2.0459159E-04
     +,   2.0752063E-04,   2.1035189E-04,   2.1307605E-04
     +,   2.1568459E-04,   2.1816869E-04,   2.2052010E-04
     +,   2.2273083E-04,   2.2479294E-04,   2.2669927E-04
     +,   2.2844276E-04,   2.3001705E-04,   2.3141595E-04
     +,   2.3263399E-04,   2.3366626E-04,   2.3450844E-04
     +,   2.3515681E-04,   2.3560853E-04,   2.3586131E-04
     +,   2.3591390E-04,   2.3576568E-04,   2.3541730E-04
     +,   2.3487009E-04,   2.3412645E-04,   2.3319003E-04
     +,   2.3206547E-04,   2.3075847E-04,   2.2927603E-04
     +,   2.2762625E-04,   2.2581842E-04,   2.2386288E-04
     +,   2.2177116E-04,   2.1955564E-04,   2.1723018E-04
     +,   2.1480913E-04,   2.1230770E-04,   2.0974201E-04
     +,   2.0712859E-04,   2.0448449E-04,   2.0182734E-04
     +,   1.9917448E-04,   1.9654359E-04,   1.9395204E-04
     +,   1.9141691E-04,   1.8895497E-04,   1.8658191E-04
     +,   1.8431306E-04,   1.8216255E-04,   1.8014335E-04
     +,   1.7826734E-04,   1.7654478E-04,   1.7498482E-04
     +,   1.7359453E-04,   1.7237983E-04,   1.7134461E-04
     +,   1.7049114E-04,   1.6981996E-04,   1.6932981E-04
     +,   1.6901772E-04,   1.6887899E-04,   1.6890737E-04
     +,   1.6909507E-04,   1.6943278E-04,   1.6991005E-04
     +,   1.7051499E-04,   1.7123489E-04,   1.7205616E-04
     +,   1.7296454E-04,   1.7394502E-04,   1.7498262E-04
     +,   1.7606204E-04,   1.7716813E-04,   1.7828605E-04
     +,   1.7940132E-04,   1.8050052E-04,   1.8157040E-04
     +,   1.8259956E-04,   1.8357724E-04,   1.8449417E-04
     +,   1.8534267E-04,   1.8611639E-04,   1.8681104E-04
     +,   1.8742355E-04,   1.8795280E-04,   1.8839950E-04
     +,   1.8876602E-04,   1.8905627E-04,   1.8927589E-04
     +,   1.8943204E-04,   1.8953331E-04,   1.8958931E-04
     +,   1.8961103E-04,   1.8961055E-04,   1.8960029E-04
     +,   1.8959395E-04,   1.8960539E-04,   1.8964894E-04
     +,   1.8973919E-04,   1.8989103E-04,   1.9011914E-04
     +,   1.9043847E-04,   1.9086355E-04,   1.9140901E-04
     +,   1.9208924E-04,   1.9291829E-04,   1.9391028E-04
     +,   1.9507894E-04,   1.9643789E-04,   1.9800031E-04
     +,   1.9977934E-04,   2.0178803E-04,   2.0403834E-04
     +,   2.0654286E-04,   2.0931274E-04,   2.1235891E-04
     +,   2.1569130E-04,   2.1931827E-04,   2.2324786E-04
     +,   2.2748522E-04,   2.3203414E-04,   2.3689597E-04
     +,   2.4206922E-04,   2.4754956E-04,   2.5332838E-04
     +,   2.5939473E-04,   2.6573215E-04,   2.7232047E-04
     +,   2.7913504E-04,   2.8614624E-04,   2.9332013E-04
     +,   3.0061684E-04,   3.0799393E-04,   3.1540249E-04
     +,   3.2279082E-04,   3.3010336E-04,   3.3728135E-04
     +,   3.4426386E-04,   3.5098716E-04,   3.5738852E-04
     +,   3.6340315E-04,   3.6896806E-04,   3.7402174E-04
     +,   3.7850524E-04,   3.8236330E-04,   3.8554447E-04
     +,   3.8800316E-04,   3.8969947E-04,   3.9059998E-04
     +,   3.9067859E-04,   3.8991700E-04,   3.8830450E-04
     +,   3.8583876E-04,   3.8252561E-04,   3.7837907E-04
     +,   3.7342132E-04,   3.6768120E-04,   3.6119617E-04
     +,   3.5400846E-04,   3.4616745E-04,   3.3772824E-04
     +,   3.2874793E-04,   3.1928986E-04,   3.0941720E-04
     +,   2.9919727E-04,   2.8869652E-04,   2.7798163E-04
     +,   2.6711970E-04,   2.5617325E-04,   2.4520530E-04
     +,   2.3427411E-04,   2.2343473E-04,   2.1273794E-04
     +,   2.0222990E-04,   1.9195289E-04,   1.8194319E-04
     +,   1.7223244E-04,   1.6284703E-04,   1.5380819E-04
     +,   1.4513347E-04,   1.3683358E-04,   1.2891727E-04
     +,   1.2138684E-04,   1.1424287E-04,   1.0748141E-04
     +,   1.0109560E-04,   9.5076910E-05,   8.9413035E-05
     +,   8.4091422E-05,   7.9097226E-05,   7.4414573E-05
     +,   7.0027578E-05,   6.5918728E-05,   6.2071638E-05
     +,   5.8468868E-05,   5.5094097E-05,   5.1931460E-05
     +,   4.8965103E-05,   4.6180437E-05,   4.3563461E-05
     +,   4.1101386E-05,   3.8782004E-05,   3.6594218E-05
     +,   3.4527817E-05,   3.2573480E-05,   3.0722957E-05
     +,   2.8968630E-05,   2.7303757E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_nwao_fus_65 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_nwao_fus_70(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  3.0370410E-07,   3.4989668E-07
     +,   4.0241105E-07,   4.6199725E-07,   5.2948167E-07
     +,   6.0576775E-07,   6.9183761E-07,   7.8876366E-07
     +,   8.9771061E-07,   1.0199321E-06,   1.1567881E-06
     +,   1.3097416E-06,   1.4803537E-06,   1.6703017E-06
     +,   1.8813772E-06,   2.1154694E-06,   2.3745931E-06
     +,   2.6608755E-06,   2.9765376E-06,   3.3239226E-06
     +,   3.7054697E-06,   4.1237245E-06,   4.5812944E-06
     +,   5.0809031E-06,   5.6253016E-06,   6.2173262E-06
     +,   6.8598406E-06,   7.5557496E-06,   8.3079212E-06
     +,   9.1192514E-06,   9.9925446E-06,   1.0930578E-05
     +,   1.1936027E-05,   1.3011449E-05,   1.4159198E-05
     +,   1.5381498E-05,   1.6680347E-05,   1.8057432E-05
     +,   1.9514200E-05,   2.1051799E-05,   2.2670907E-05
     +,   2.4371942E-05,   2.6154758E-05,   2.8018858E-05
     +,   2.9963208E-05,   3.1986321E-05,   3.4086039E-05
     +,   3.6259793E-05,   3.8504430E-05,   4.0816107E-05
     +,   4.3190568E-05,   4.5622943E-05,   4.8107733E-05
     +,   5.0639064E-05,   5.3210377E-05,   5.5814809E-05
     +,   5.8445057E-05,   6.1093422E-05,   6.3751962E-05
     +,   6.6412416E-05,   6.9066518E-05,   7.1705741E-05
     +,   7.4321768E-05,   7.6906355E-05,   7.9451376E-05
     +,   8.1949111E-05,   8.4392268E-05,   8.6773907E-05
     +,   8.9087865E-05,   9.1328548E-05,   9.3491159E-05
     +,   9.5571755E-05,   9.7567303E-05,   9.9475532E-05
     +,   1.0129536E-04,   1.0302661E-04,   1.0467014E-04
     +,   1.0622780E-04,   1.0770225E-04,   1.0909727E-04
     +,   1.1041737E-04,   1.1166792E-04,   1.1285495E-04
     +,   1.1398495E-04,   1.1506516E-04,   1.1610288E-04
     +,   1.1710593E-04,   1.1808205E-04,   1.1903911E-04
     +,   1.1998485E-04,   1.2092671E-04,   1.2187196E-04
     +,   1.2282740E-04,   1.2379949E-04,   1.2479410E-04
     +,   1.2581664E-04,   1.2687212E-04,   1.2796484E-04
     +,   1.2909887E-04,   1.3027777E-04,   1.3150487E-04
     +,   1.3278319E-04,   1.3411563E-04,   1.3550496E-04
     +,   1.3695407E-04,   1.3846593E-04,   1.4004373E-04
     +,   1.4169066E-04,   1.4341061E-04,   1.4520728E-04
     +,   1.4708485E-04,   1.4904764E-04,   1.5110006E-04
     +,   1.5324661E-04,   1.5549123E-04,   1.5783808E-04
     +,   1.6029026E-04,   1.6285038E-04,   1.6551994E-04
     +,   1.6829936E-04,   1.7118748E-04,   1.7418126E-04
     +,   1.7727618E-04,   1.8046545E-04,   1.8374015E-04
     +,   1.8708920E-04,   1.9049925E-04,   1.9395443E-04
     +,   1.9743697E-04,   2.0092701E-04,   2.0440282E-04
     +,   2.0784115E-04,   2.1121757E-04,   2.1450636E-04
     +,   2.1768165E-04,   2.2071744E-04,   2.2358801E-04
     +,   2.2626860E-04,   2.2873563E-04,   2.3096743E-04
     +,   2.3294435E-04,   2.3464946E-04,   2.3606894E-04
     +,   2.3719216E-04,   2.3801216E-04,   2.3852570E-04
     +,   2.3873369E-04,   2.3864095E-04,   2.3825633E-04
     +,   2.3759267E-04,   2.3666686E-04,   2.3549912E-04
     +,   2.3411331E-04,   2.3253605E-04,   2.3079690E-04
     +,   2.2892735E-04,   2.2696058E-04,   2.2493117E-04
     +,   2.2287389E-04,   2.2082395E-04,   2.1881574E-04
     +,   2.1688244E-04,   2.1505577E-04,   2.1336463E-04
     +,   2.1183566E-04,   2.1049188E-04,   2.0935254E-04
     +,   2.0843287E-04,   2.0774365E-04,   2.0729113E-04
     +,   2.0707656E-04,   2.0709645E-04,   2.0734253E-04
     +,   2.0780173E-04,   2.0845659E-04,   2.0928548E-04
     +,   2.1026288E-04,   2.1135989E-04,   2.1254484E-04
     +,   2.1378374E-04,   2.1504107E-04,   2.1627998E-04
     +,   2.1746376E-04,   2.1855559E-04,   2.1951992E-04
     +,   2.2032269E-04,   2.2093214E-04,   2.2131937E-04
     +,   2.2145855E-04,   2.2132779E-04,   2.2090909E-04
     +,   2.2018880E-04,   2.1915778E-04,   2.1781157E-04
     +,   2.1614991E-04,   2.1417763E-04,   2.1190308E-04
     +,   2.0933936E-04,   2.0650313E-04,   2.0341402E-04
     +,   2.0009535E-04,   1.9657212E-04,   1.9287199E-04
     +,   1.8902375E-04,   1.8505720E-04,   1.8100320E-04
     +,   1.7689150E-04,   1.7275255E-04,   1.6861528E-04
     +,   1.6450744E-04,   1.6045567E-04,   1.5648380E-04
     +,   1.5261445E-04,   1.4886746E-04,   1.4526026E-04
     +,   1.4180774E-04,   1.3852220E-04,   1.3541373E-04
     +,   1.3248915E-04,   1.2975358E-04,   1.2720938E-04
     +,   1.2485683E-04,   1.2269421E-04,   1.2071784E-04
     +,   1.1892276E-04,   1.1730190E-04,   1.1584756E-04
     +,   1.1455057E-04,   1.1340106E-04,   1.1238840E-04
     +,   1.1150147E-04,   1.1072886E-04,   1.1005873E-04
     +,   1.0947949E-04,   1.0897941E-04,   1.0854691E-04
     +,   1.0817075E-04,   1.0784001E-04,   1.0754418E-04
     +,   1.0727313E-04,   1.0701739E-04,   1.0676793E-04
     +,   1.0651627E-04,   1.0625464E-04,   1.0597573E-04
     +,   1.0567295E-04,   1.0534024E-04,   1.0497215E-04
     +,   1.0456389E-04,   1.0411113E-04,   1.0361025E-04
     +,   1.0305802E-04,   1.0245188E-04,   1.0178976E-04
     +,   1.0106999E-04,   1.0029149E-04,   9.9453508E-05
     +,   9.8555865E-05,   9.7598670E-05,   9.6582451E-05
     +,   9.5508192E-05,   9.4376926E-05,   9.3190341E-05
     +,   9.1950220E-05,   9.0658614E-05,   8.9317844E-05
     +,   8.7930406E-05,   8.6499123E-05,   8.5026790E-05
     +,   8.3516454E-05,   8.1971259E-05,   8.0394348E-05
     +,   7.8789235E-05,   7.7159013E-05,   7.5507334E-05
     +,   7.3837327E-05,   7.2152550E-05,   7.0456321E-05
     +,   6.8751862E-05,   6.7042631E-05,   6.5331515E-05
     +,   6.3621810E-05,   6.1916398E-05,   6.0218084E-05
     +,   5.8529786E-05,   5.6853856E-05,   5.5192988E-05
     +,   5.3549222E-05,   5.1924842E-05,   5.0321967E-05
     +,   4.8742244E-05,   4.7187386E-05,   4.5658860E-05
     +,   4.4158118E-05,   4.2686283E-05,   4.1244399E-05
     +,   3.9833325E-05,   3.8453745E-05,   3.7106354E-05
     +,   3.5791545E-05,   3.4509645E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_nwao_fus_70 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_nwao_fus_75(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  1.7649143E-08,   2.0211829E-08
     +,   2.3116087E-08,   2.6402683E-08,   3.0116777E-08
     +,   3.4308123E-08,   3.9031153E-08,   4.4345924E-08
     +,   5.0318217E-08,   5.7019630E-08,   6.4528741E-08
     +,   7.2931080E-08,   8.2319289E-08,   9.2794423E-08
     +,   1.0446608E-07,   1.1745195E-07,   1.3188004E-07
     +,   1.4788812E-07,   1.6562355E-07,   1.8524533E-07
     +,   2.0692374E-07,   2.3084097E-07,   2.5719032E-07
     +,   2.8617978E-07,   3.1802767E-07,   3.5296793E-07
     +,   3.9124745E-07,   4.3312770E-07,   4.7888244E-07
     +,   5.2880279E-07,   5.8319119E-07,   6.4236673E-07
     +,   7.0666329E-07,   7.7642983E-07,   8.5202606E-07
     +,   9.3383022E-07,   1.0222345E-06,   1.1176397E-06
     +,   1.2204656E-06,   1.3311436E-06,   1.4501129E-06
     +,   1.5778313E-06,   1.7147585E-06,   1.8613716E-06
     +,   2.0181526E-06,   2.1855974E-06,   2.3641969E-06
     +,   2.5544562E-06,   2.7568892E-06,   2.9719977E-06
     +,   3.2002963E-06,   3.4423024E-06,   3.6985168E-06
     +,   3.9694555E-06,   4.2556094E-06,   4.5574780E-06
     +,   4.8755442E-06,   5.2102814E-06,   5.5621572E-06
     +,   5.9315994E-06,   6.3190482E-06,   6.7248930E-06
     +,   7.1495206E-06,   7.5932958E-06,   8.0565233E-06
     +,   8.5395077E-06,   9.0425174E-06,   9.5657542E-06
     +,   1.0109407E-05,   1.0673614E-05,   1.1258467E-05
     +,   1.1864007E-05,   1.2490251E-05,   1.3137085E-05
     +,   1.3804418E-05,   1.4492071E-05,   1.5199809E-05
     +,   1.5927362E-05,   1.6674321E-05,   1.7440289E-05
     +,   1.8224793E-05,   1.9027289E-05,   1.9847212E-05
     +,   2.0683818E-05,   2.1536523E-05,   2.2404482E-05
     +,   2.3286919E-05,   2.4182998E-05,   2.5091844E-05
     +,   2.6012585E-05,   2.6944226E-05,   2.7885855E-05
     +,   2.8836519E-05,   2.9795265E-05,   3.0761137E-05
     +,   3.1733201E-05,   3.2710563E-05,   3.3692268E-05
     +,   3.4677472E-05,   3.5665373E-05,   3.6655172E-05
     +,   3.7646205E-05,   3.8637721E-05,   3.9629187E-05
     +,   4.0620092E-05,   4.1610034E-05,   4.2598760E-05
     +,   4.3585977E-05,   4.4571851E-05,   4.5556415E-05
     +,   4.6540081E-05,   4.7523481E-05,   4.8507503E-05
     +,   4.9493421E-05,   5.0482729E-05,   5.1477618E-05
     +,   5.2480507E-05,   5.3494510E-05,   5.4523338E-05
     +,   5.5571352E-05,   5.6643679E-05,   5.7746129E-05
     +,   5.8885398E-05,   6.0069051E-05,   6.1305436E-05
     +,   6.2603773E-05,   6.3974134E-05,   6.5427164E-05
     +,   6.6974280E-05,   6.8627378E-05,   7.0398652E-05
     +,   7.2300449E-05,   7.4345051E-05,   7.6544122E-05
     +,   7.8908801E-05,   8.1449107E-05,   8.4173640E-05
     +,   8.7089189E-05,   9.0200352E-05,   9.3509341E-05
     +,   9.7015101E-05,   1.0071375E-04,   1.0459792E-04
     +,   1.0865672E-04,   1.1287576E-04,   1.1723652E-04
     +,   1.2171826E-04,   1.2629604E-04,   1.3094311E-04
     +,   1.3563072E-04,   1.4032835E-04,   1.4500636E-04
     +,   1.4963471E-04,   1.5418585E-04,   1.5863495E-04
     +,   1.6296131E-04,   1.6714953E-04,   1.7118968E-04
     +,   1.7507972E-04,   1.7882403E-04,   1.8243531E-04
     +,   1.8593384E-04,   1.8934673E-04,   1.9270818E-04
     +,   1.9605698E-04,   1.9943593E-04,   2.0288963E-04
     +,   2.0646219E-04,   2.1019536E-04,   2.1412541E-04
     +,   2.1828225E-04,   2.2268551E-04,   2.2734434E-04
     +,   2.3225562E-04,   2.3740306E-04,   2.4275783E-04
     +,   2.4827855E-04,   2.5391381E-04,   2.5960407E-04
     +,   2.6528491E-04,   2.7089089E-04,   2.7635950E-04
     +,   2.8163672E-04,   2.8668024E-04,   2.9146537E-04
     +,   2.9598817E-04,   3.0026902E-04,   3.0435479E-04
     +,   3.0831929E-04,   3.1226367E-04,   3.1631297E-04
     +,   3.2061266E-04,   3.2532305E-04,   3.3061090E-04
     +,   3.3664334E-04,   3.4357517E-04,   3.5154278E-04
     +,   3.6065097E-04,   3.7096580E-04,   3.8250917E-04
     +,   3.9524792E-04,   4.0909735E-04,   4.2391391E-04
     +,   4.3950244E-04,   4.5561980E-04,   4.7197929E-04
     +,   4.8826815E-04,   5.0414959E-04,   5.1928282E-04
     +,   5.3333270E-04,   5.4598163E-04,   5.5694423E-04
     +,   5.6597288E-04,   5.7286932E-04,   5.7748798E-04
     +,   5.7973998E-04,   5.7959300E-04,   5.7707046E-04
     +,   5.7224621E-04,   5.6524150E-04,   5.5621617E-04
     +,   5.4536224E-04,   5.3289614E-04,   5.1904970E-04
     +,   5.0406618E-04,   4.8818626E-04,   4.7165027E-04
     +,   4.5468647E-04,   4.3750959E-04,   4.2031647E-04
     +,   4.0328372E-04,   3.8656860E-04,   3.7030186E-04
     +,   3.5459589E-04,   3.3953902E-04,   3.2519901E-04
     +,   3.1162400E-04,   2.9884331E-04,   2.8687107E-04
     +,   2.7570501E-04,   2.6532990E-04,   2.5571886E-04
     +,   2.4683459E-04,   2.3863233E-04,   2.3105816E-04
     +,   2.2405441E-04,   2.1755802E-04,   2.1150320E-04
     +,   2.0582382E-04,   2.0045211E-04,   1.9532372E-04
     +,   1.9037556E-04,   1.8554997E-04,   1.8079486E-04
     +,   1.7606349E-04,   1.7131797E-04,   1.6652701E-04
     +,   1.6166884E-04,   1.5672938E-04,   1.5170260E-04
     +,   1.4659094E-04,   1.4140240E-04,   1.3615232E-04
     +,   1.3086019E-04,   1.2554944E-04,   1.2024606E-04
     +,   1.1497719E-04,   1.0977084E-04,   1.0465363E-04
     +,   9.9650701E-05,   9.4784846E-05,   9.0075751E-05
     +,   8.5540538E-05,   8.1191567E-05,   7.7039062E-05
     +,   7.3088449E-05,   6.9343005E-05,   6.5802451E-05
     +,   6.2463878E-05,   5.9322683E-05,   5.6371562E-05
     +,   5.3602631E-05,   5.1006504E-05,   4.8573140E-05
     +,   4.6292465E-05,   4.4153716E-05,   4.2146883E-05
     +,   4.0261639E-05,   3.8488542E-05,   3.6818627E-05
     +,   3.5243185E-05,   3.3754379E-05,   3.2344862E-05
     +,   3.1008040E-05,   2.9737741E-05,   2.8528380E-05
     +,   2.7374886E-05,   2.6272606E-05,   2.5217447E-05
     +,   2.4205565E-05,   2.3233531E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_nwao_fus_75 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_nwao_fus_80(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  1.3284147E-11,   1.6665598E-11
     +,   2.0869959E-11,   2.6087453E-11,   3.2550098E-11
     +,   4.0540214E-11,   5.0399830E-11,   6.2543692E-11
     +,   7.7473056E-11,   9.5791541E-11,   1.1822655E-10
     +,   1.4565171E-10,   1.7911256E-10,   2.1986035E-10
     +,   2.6938995E-10,   3.2947681E-10,   4.0223486E-10
     +,   4.9017057E-10,   5.9624489E-10,   7.2395756E-10
     +,   8.7742941E-10,   1.0615120E-09,   1.2818789E-09
     +,   1.5451903E-09,   1.8592012E-09,   2.2329676E-09
     +,   2.6770104E-09,   3.2035403E-09,   3.8266643E-09
     +,   4.5627182E-09,   5.4304636E-09,   6.4515153E-09
     +,   7.6506499E-09,   9.0562402E-09,   1.0700598E-08
     +,   1.2620613E-08,   1.4858194E-08,   1.7460733E-08
     +,   2.0481968E-08,   2.3982498E-08,   2.8030389E-08
     +,   3.2702271E-08,   3.8083691E-08,   4.4270426E-08
     +,   5.1369202E-08,   5.9498667E-08,   6.8790108E-08
     +,   7.9388926E-08,   9.1455796E-08,   1.0516668E-07
     +,   1.2071534E-07,   1.3831411E-07,   1.5819349E-07
     +,   1.8060601E-07,   2.0582401E-07,   2.3414397E-07
     +,   2.6588503E-07,   3.0139117E-07,   3.4103235E-07
     +,   3.8520261E-07,   4.3432524E-07,   4.8884795E-07
     +,   5.4924823E-07,   6.1603231E-07,   6.8973037E-07
     +,   7.7090442E-07,   8.6014387E-07,   9.5806172E-07
     +,   1.0653006E-06,   1.1825297E-06,   1.3104418E-06
     +,   1.4497537E-06,   1.6012112E-06,   1.7655636E-06
     +,   1.9435981E-06,   2.1361129E-06,   2.3439241E-06
     +,   2.5678703E-06,   2.8087788E-06,   3.0675114E-06
     +,   3.3449326E-06,   3.6419124E-06,   3.9593401E-06
     +,   4.2980564E-06,   4.6589930E-06,   5.0429894E-06
     +,   5.4509337E-06,   5.8836931E-06,   6.3421280E-06
     +,   6.8271038E-06,   7.3394149E-06,   7.8798912E-06
     +,   8.4493195E-06,   9.0484555E-06,   9.6780286E-06
     +,   1.0338723E-05,   1.1031202E-05,   1.1756007E-05
     +,   1.2513694E-05,   1.3304732E-05,   1.4129524E-05
     +,   1.4988439E-05,   1.5881669E-05,   1.6809448E-05
     +,   1.7771894E-05,   1.8769084E-05,   1.9801086E-05
     +,   2.0867792E-05,   2.1969385E-05,   2.3105797E-05
     +,   2.4277228E-05,   2.5483971E-05,   2.6726537E-05
     +,   2.8005765E-05,   2.9322677E-05,   3.0679097E-05
     +,   3.2077071E-05,   3.3519511E-05,   3.5010071E-05
     +,   3.6553269E-05,   3.8154671E-05,   3.9820727E-05
     +,   4.1559178E-05,   4.3378892E-05,   4.5289882E-05
     +,   4.7303281E-05,   4.9431375E-05,   5.1687079E-05
     +,   5.4084241E-05,   5.6637069E-05,   5.9359863E-05
     +,   6.2266634E-05,   6.5370725E-05,   6.8683912E-05
     +,   7.2216462E-05,   7.5976197E-05,   7.9967991E-05
     +,   8.4193249E-05,   8.8649351E-05,   9.3329523E-05
     +,   9.8221775E-05,   1.0330982E-04,   1.0857233E-04
     +,   1.1398355E-04,   1.1951369E-04,   1.2512883E-04
     +,   1.3079404E-04,   1.3647157E-04,   1.4212477E-04
     +,   1.4771856E-04,   1.5322055E-04,   1.5860480E-04
     +,   1.6385104E-04,   1.6894820E-04,   1.7389502E-04
     +,   1.7870136E-04,   1.8338909E-04,   1.8799119E-04
     +,   1.9255385E-04,   1.9713255E-04,   2.0179260E-04
     +,   2.0660633E-04,   2.1164927E-04,   2.1699929E-04
     +,   2.2272984E-04,   2.2890871E-04,   2.3559283E-04
     +,   2.4282496E-04,   2.5063087E-04,   2.5901481E-04
     +,   2.6796144E-04,   2.7743052E-04,   2.8736013E-04
     +,   2.9766708E-04,   3.0824897E-04,   3.1898831E-04
     +,   3.2975516E-04,   3.4041426E-04,   3.5082910E-04
     +,   3.6086756E-04,   3.7040765E-04,   3.7934084E-04
     +,   3.8757967E-04,   3.9505618E-04,   4.0172823E-04
     +,   4.0757778E-04,   4.1261085E-04,   4.1685608E-04
     +,   4.2036097E-04,   4.2318905E-04,   4.2541366E-04
     +,   4.2711367E-04,   4.2836845E-04,   4.2925173E-04
     +,   4.2982769E-04,   4.3014716E-04,   4.3024475E-04
     +,   4.3013706E-04,   4.2982347E-04,   4.2928572E-04
     +,   4.2849215E-04,   4.2739976E-04,   4.2595956E-04
     +,   4.2412087E-04,   4.2183700E-04,   4.1907010E-04
     +,   4.1579510E-04,   4.1200439E-04,   4.0770959E-04
     +,   4.0294303E-04,   3.9775853E-04,   3.9222813E-04
     +,   3.8644203E-04,   3.8050290E-04,   3.7452267E-04
     +,   3.6861707E-04,   3.6290140E-04,   3.5748593E-04
     +,   3.5247012E-04,   3.4794194E-04,   3.4397258E-04
     +,   3.4061636E-04,   3.3790933E-04,   3.3586929E-04
     +,   3.3449693E-04,   3.3377635E-04,   3.3367731E-04
     +,   3.3415644E-04,   3.3515965E-04,   3.3662355E-04
     +,   3.3847778E-04,   3.4064593E-04,   3.4304862E-04
     +,   3.4560400E-04,   3.4823059E-04,   3.5084903E-04
     +,   3.5338421E-04,   3.5576767E-04,   3.5793916E-04
     +,   3.5984995E-04,   3.6146326E-04,   3.6275692E-04
     +,   3.6372276E-04,   3.6436756E-04,   3.6471186E-04
     +,   3.6478802E-04,   3.6463825E-04,   3.6431104E-04
     +,   3.6385746E-04,   3.6332727E-04,   3.6276496E-04
     +,   3.6220602E-04,   3.6167345E-04,   3.6117539E-04
     +,   3.6070385E-04,   3.6023359E-04,   3.5972294E-04
     +,   3.5911537E-04,   3.5834170E-04,   3.5732388E-04
     +,   3.5597797E-04,   3.5421853E-04,   3.5196322E-04
     +,   3.4913555E-04,   3.4566969E-04,   3.4151209E-04
     +,   3.3662442E-04,   3.3098532E-04,   3.2458981E-04
     +,   3.1745018E-04,   3.0959441E-04,   3.0106472E-04
     +,   2.9191715E-04,   2.8221557E-04,   2.7203455E-04
     +,   2.6145080E-04,   2.5054664E-04,   2.3940369E-04
     +,   2.2810175E-04,   2.1671988E-04,   2.0532950E-04
     +,   1.9399986E-04,   1.8279263E-04,   1.7176304E-04
     +,   1.6096163E-04,   1.5042964E-04,   1.4020548E-04
     +,   1.3031853E-04,   1.2079516E-04,   1.1165661E-04
     +,   1.0291786E-04,   9.4591152E-05,   8.6684369E-05
     +,   7.9202830E-05,   7.2147886E-05,   6.5518376E-05
     +,   5.9310554E-05,   5.3518106E-05,   4.8133221E-05
     +,   4.3145461E-05,   3.8542865E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_nwao_fus_80 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_nwao_fus_85(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  2.7229538E-11,   3.3321911E-11
     +,   4.0716045E-11,   4.9675646E-11,   6.0515447E-11
     +,   7.3609625E-11,   8.9401583E-11,   1.0841782E-10
     +,   1.3128081E-10,   1.5872484E-10,   1.9161636E-10
     +,   2.3097589E-10,   2.7799887E-10,   3.3409020E-10
     +,   4.0089410E-10,   4.8032933E-10,   5.7463562E-10
     +,   6.8642242E-10,   8.1871593E-10,   9.7503383E-10
     +,   1.1594438E-09,   1.3766581E-09,   1.6320928E-09
     +,   1.9320092E-09,   2.2835822E-09,   2.6950573E-09
     +,   3.1758809E-09,   3.7368491E-09,   4.3902579E-09
     +,   5.1501474E-09,   6.0324328E-09,   7.0552115E-09
     +,   8.2389402E-09,   9.6067883E-09,   1.1184796E-08
     +,   1.3002360E-08,   1.5092519E-08,   1.7492200E-08
     +,   2.0242842E-08,   2.3390728E-08,   2.6987289E-08
     +,   3.1089936E-08,   3.5762170E-08,   4.1074486E-08
     +,   4.7104702E-08,   5.3938923E-08,   6.1671280E-08
     +,   7.0405761E-08,   8.0256200E-08,   9.1346607E-08
     +,   1.0381261E-07,   1.1780221E-07,   1.3347497E-07
     +,   1.5100504E-07,   1.7057933E-07,   1.9240018E-07
     +,   2.1668504E-07,   2.4366690E-07,   2.7359573E-07
     +,   3.0673664E-07,   3.4337364E-07,   3.8380588E-07
     +,   4.2835165E-07,   4.7734744E-07,   5.3114366E-07
     +,   5.9011086E-07,   6.5463672E-07,   7.2512120E-07
     +,   8.0198282E-07,   8.8565332E-07,   9.7657755E-07
     +,   1.0752117E-06,   1.1820260E-06,   1.2974863E-06
     +,   1.4220759E-06,   1.5562782E-06,   1.7005754E-06
     +,   1.8554545E-06,   2.0213784E-06,   2.1988185E-06
     +,   2.3882269E-06,   2.5900381E-06,   2.8046748E-06
     +,   3.0325016E-06,   3.2739101E-06,   3.5291976E-06
     +,   3.7986576E-06,   4.0825321E-06,   4.3810114E-06
     +,   4.6942478E-06,   5.0222989E-06,   5.3651956E-06
     +,   5.7228935E-06,   6.0952793E-06,   6.4821634E-06
     +,   6.8832906E-06,   7.2983412E-06,   7.7268705E-06
     +,   8.1684066E-06,   8.6223899E-06,   9.0881877E-06
     +,   9.5651130E-06,   1.0052374E-05,   1.0549167E-05
     +,   1.1054633E-05,   1.1567877E-05,   1.2088007E-05
     +,   1.2614045E-05,   1.3145173E-05,   1.3680469E-05
     +,   1.4219150E-05,   1.4760510E-05,   1.5303949E-05
     +,   1.5849057E-05,   1.6395514E-05,   1.6943373E-05
     +,   1.7492806E-05,   1.8044375E-05,   1.8598961E-05
     +,   1.9157842E-05,   1.9722725E-05,   2.0295742E-05
     +,   2.0879579E-05,   2.1477428E-05,   2.2093049E-05
     +,   2.2730781E-05,   2.3395558E-05,   2.4092835E-05
     +,   2.4828720E-05,   2.5609828E-05,   2.6443291E-05
     +,   2.7336682E-05,   2.8298005E-05,   2.9335439E-05
     +,   3.0457441E-05,   3.1672516E-05,   3.2989090E-05
     +,   3.4415360E-05,   3.5959129E-05,   3.7627706E-05
     +,   3.9427454E-05,   4.1363997E-05,   4.3441749E-05
     +,   4.5663823E-05,   4.8031918E-05,   5.0545714E-05
     +,   5.3203708E-05,   5.6001798E-05,   5.8934183E-05
     +,   6.1992971E-05,   6.5167646E-05,   6.8446352E-05
     +,   7.1814284E-05,   7.5255171E-05,   7.8750811E-05
     +,   8.2281440E-05,   8.5826228E-05,   8.9362969E-05
     +,   9.2870010E-05,   9.6325079E-05,   9.9707227E-05
     +,   1.0299717E-04,   1.0617750E-04,   1.0923497E-04
     +,   1.1215964E-04,   1.1494716E-04,   1.1759915E-04
     +,   1.2012410E-04,   1.2253833E-04,   1.2486619E-04
     +,   1.2714149E-04,   1.2940666E-04,   1.3171346E-04
     +,   1.3412225E-04,   1.3670133E-04,   1.3952560E-04
     +,   1.4267457E-04,   1.4623071E-04,   1.5027610E-04
     +,   1.5488970E-04,   1.6014371E-04,   1.6609889E-04
     +,   1.7280308E-04,   1.8028391E-04,   1.8854822E-04
     +,   1.9757768E-04,   2.0732667E-04,   2.1772159E-04
     +,   2.2865884E-04,   2.4001065E-04,   2.5162217E-04
     +,   2.6332060E-04,   2.7491935E-04,   2.8622357E-04
     +,   2.9704327E-04,   3.0719565E-04,   3.1652066E-04
     +,   3.2488458E-04,   3.3219034E-04,   3.3838535E-04
     +,   3.4346216E-04,   3.4746464E-04,   3.5048439E-04
     +,   3.5265958E-04,   3.5416780E-04,   3.5521819E-04
     +,   3.5604046E-04,   3.5687315E-04,   3.5794979E-04
     +,   3.5948653E-04,   3.6166911E-04,   3.6464180E-04
     +,   3.6849780E-04,   3.7327348E-04,   3.7894413E-04
     +,   3.8542412E-04,   3.9256978E-04,   4.0018393E-04
     +,   4.0802787E-04,   4.1582834E-04,   4.2329283E-04
     +,   4.3012245E-04,   4.3602515E-04,   4.4073025E-04
     +,   4.4399968E-04,   4.4564050E-04,   4.4551230E-04
     +,   4.4353443E-04,   4.3968993E-04,   4.3402635E-04
     +,   4.2665403E-04,   4.1774314E-04,   4.0751390E-04
     +,   3.9623264E-04,   3.8419725E-04,   3.7172803E-04
     +,   3.5915498E-04,   3.4680500E-04,   3.3499231E-04
     +,   3.2400424E-04,   3.1409363E-04,   3.0546999E-04
     +,   2.9829310E-04,   2.9267013E-04,   2.8865054E-04
     +,   2.8622907E-04,   2.8534574E-04,   2.8588975E-04
     +,   2.8770478E-04,   2.9059575E-04,   2.9433516E-04
     +,   2.9867305E-04,   3.0334381E-04,   3.0807510E-04
     +,   3.1259845E-04,   3.1665430E-04,   3.2000264E-04
     +,   3.2242690E-04,   3.2374155E-04,   3.2379583E-04
     +,   3.2247687E-04,   3.1971143E-04,   3.1546698E-04
     +,   3.0974991E-04,   3.0260443E-04,   2.9410832E-04
     +,   2.8436905E-04,   2.7352027E-04,   2.6171439E-04
     +,   2.4911796E-04,   2.3590586E-04,   2.2225529E-04
     +,   2.0834319E-04,   1.9433584E-04,   1.8039299E-04
     +,   1.6665607E-04,   1.5325395E-04,   1.4029523E-04
     +,   1.2787024E-04,   1.1605211E-04,   1.0489258E-04
     +,   9.4429342E-05,   8.4682601E-05,   7.5658543E-05
     +,   6.7352645E-05,   5.9747872E-05,   5.2821397E-05
     +,   4.6541845E-05,   4.0874773E-05,   3.5782447E-05
     +,   3.1224376E-05,   2.7160228E-05,   2.3549585E-05
     +,   2.0353393E-05,   1.7533690E-05,   1.5054538E-05
     +,   1.2882131E-05,   1.0984864E-05,   9.3336648E-06
     +,   7.9015626E-06,   6.6639136E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_nwao_fus_85 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_nwao_fus_90(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  3.4978229E-11,   4.3397858E-11
     +,   5.3753401E-11,   6.6467096E-11,   8.2049027E-11
     +,   1.0111297E-10,   1.2439540E-10,   1.5278018E-10
     +,   1.8732564E-10,   2.2929296E-10,   2.8018821E-10
     +,   3.4180356E-10,   4.1626200E-10,   5.0608440E-10
     +,   6.1425115E-10,   7.4427436E-10,   9.0029773E-10
     +,   1.0871920E-09,   1.3106610E-09,   1.5773959E-09
     +,   1.8952053E-09,   2.2732094E-09,   2.7219931E-09
     +,   3.2538805E-09,   3.8831214E-09,   4.6262132E-09
     +,   5.5022045E-09,   6.5330306E-09,   7.7438651E-09
     +,   9.1636316E-09,   1.0825363E-08,   1.2766832E-08
     +,   1.5031080E-08,   1.7667055E-08,   2.0730173E-08
     +,   2.4283317E-08,   2.8397528E-08,   3.3152613E-08
     +,   3.8638582E-08,   4.4956440E-08,   5.2218926E-08
     +,   6.0552388E-08,   7.0097002E-08,   8.1009148E-08
     +,   9.3461978E-08,   1.0764731E-07,   1.2377606E-07
     +,   1.4208119E-07,   1.6281852E-07,   1.8626717E-07
     +,   2.1273317E-07,   2.4255024E-07,   2.7607913E-07
     +,   3.1371323E-07,   3.5587499E-07,   4.0302194E-07
     +,   4.5564479E-07,   5.1426935E-07,   5.7945851E-07
     +,   6.5180785E-07,   7.3195514E-07,   8.2056863E-07
     +,   9.1835784E-07,   1.0260686E-06,   1.1444761E-06
     +,   1.2743936E-06,   1.4166677E-06,   1.5721653E-06
     +,   1.7417874E-06,   1.9264548E-06,   2.1271057E-06
     +,   2.3446937E-06,   2.5801887E-06,   2.8345360E-06
     +,   3.1087031E-06,   3.4036379E-06,   3.7202678E-06
     +,   4.0595060E-06,   4.4221929E-06,   4.8091565E-06
     +,   5.2211599E-06,   5.6588983E-06,   6.1230094E-06
     +,   6.6139710E-06,   7.1322902E-06,   7.6782335E-06
     +,   8.2520246E-06,   8.8537372E-06,   9.4833031E-06
     +,   1.0140532E-05,   1.0824991E-05,   1.1536160E-05
     +,   1.2273318E-05,   1.3035559E-05,   1.3821786E-05
     +,   1.4630720E-05,   1.5460910E-05,   1.6310622E-05
     +,   1.7178012E-05,   1.8061019E-05,   1.8957393E-05
     +,   1.9864730E-05,   2.0780355E-05,   2.1701526E-05
     +,   2.2625311E-05,   2.3548640E-05,   2.4468356E-05
     +,   2.5381047E-05,   2.6283462E-05,   2.7172027E-05
     +,   2.8043265E-05,   2.8893643E-05,   2.9719617E-05
     +,   3.0517698E-05,   3.1284326E-05,   3.2016225E-05
     +,   3.2710006E-05,   3.3362528E-05,   3.3970759E-05
     +,   3.4531859E-05,   3.5043195E-05,   3.5502308E-05
     +,   3.5907025E-05,   3.6255453E-05,   3.6545964E-05
     +,   3.6777241E-05,   3.6948310E-05,   3.7058511E-05
     +,   3.7107562E-05,   3.7095553E-05,   3.7022961E-05
     +,   3.6890637E-05,   3.6699861E-05,   3.6452326E-05
     +,   3.6150144E-05,   3.5795860E-05,   3.5392441E-05
     +,   3.4943307E-05,   3.4452307E-05,   3.3923716E-05
     +,   3.3362307E-05,   3.2773205E-05,   3.2162010E-05
     +,   3.1534706E-05,   3.0897656E-05,   3.0257701E-05
     +,   2.9621848E-05,   2.8997612E-05,   2.8392711E-05
     +,   2.7815116E-05,   2.7273143E-05,   2.6775178E-05
     +,   2.6329964E-05,   2.5946363E-05,   2.5633508E-05
     +,   2.5400799E-05,   2.5258014E-05,   2.5215450E-05
     +,   2.5284029E-05,   2.5475614E-05,   2.5803229E-05
     +,   2.6281461E-05,   2.6926755E-05,   2.7758102E-05
     +,   2.8797185E-05,   3.0069174E-05,   3.1603064E-05
     +,   3.3432141E-05,   3.5594410E-05,   3.8132304E-05
     +,   4.1093746E-05,   4.4530501E-05,   4.8498692E-05
     +,   5.3057418E-05,   5.8267495E-05,   6.4189968E-05
     +,   7.0883056E-05,   7.8400917E-05,   8.6790016E-05
     +,   9.6086078E-05,   1.0631131E-04,   1.1746910E-04
     +,   1.2954543E-04,   1.4250026E-04,   1.5627003E-04
     +,   1.7076406E-04,   1.8586454E-04,   2.0142749E-04
     +,   2.1728176E-04,   2.3323855E-04,   2.4908717E-04
     +,   2.6460763E-04,   2.7957457E-04,   2.9376295E-04
     +,   3.0696267E-04,   3.1897935E-04,   3.2965120E-04
     +,   3.3885136E-04,   3.4649903E-04,   3.5256732E-04
     +,   3.5708499E-04,   3.6014253E-04,   3.6189047E-04
     +,   3.6253862E-04,   3.6234973E-04,   3.6163151E-04
     +,   3.6072545E-04,   3.5999430E-04,   3.5980740E-04
     +,   3.6052705E-04,   3.6249508E-04,   3.6602450E-04
     +,   3.7139177E-04,   3.7883778E-04,   3.8857182E-04
     +,   4.0078137E-04,   4.1564630E-04,   4.3335048E-04
     +,   4.5410328E-04,   4.7813778E-04,   5.0571939E-04
     +,   5.3712941E-04,   5.7263847E-04,   6.1246497E-04
     +,   6.5670966E-04,   7.0530677E-04,   7.5792870E-04
     +,   8.1394264E-04,   8.7235461E-04,   9.3179615E-04
     +,   9.9054654E-04,   1.0465909E-03,   1.0977526E-03
     +,   1.1418159E-03,   1.1767242E-03,   1.2007554E-03
     +,   1.2126943E-03,   1.2119724E-03,   1.1987514E-03
     +,   1.1739403E-03,   1.1391427E-03,   1.0965356E-03
     +,   1.0486908E-03,   9.9837093E-04,   9.4828609E-04
     +,   9.0090488E-04,   8.5825636E-04,   8.2180847E-04
     +,   7.9240056E-04,   7.7022449E-04,   7.5488607E-04
     +,   7.4548763E-04,   7.4076233E-04,   7.3921407E-04
     +,   7.3926541E-04,   7.3939440E-04,   7.3824968E-04
     +,   7.3473854E-04,   7.2808116E-04,   7.1783160E-04
     +,   7.0387049E-04,   6.8636076E-04,   6.6569907E-04
     +,   6.4243784E-04,   6.1721692E-04,   5.9069251E-04
     +,   5.6347973E-04,   5.3611345E-04,   5.0901808E-04
     +,   4.8250347E-04,   4.5677013E-04,   4.3192611E-04
     +,   4.0801338E-04,   3.8502316E-04,   3.6293178E-04
     +,   3.4170449E-04,   3.2132043E-04,   3.0176912E-04
     +,   2.8305469E-04,   2.6519495E-04,   2.4820765E-04
     +,   2.3211355E-04,   2.1692284E-04,   2.0263289E-04
     +,   1.8922778E-04,   1.7667226E-04,   1.6492041E-04
     +,   1.5391129E-04,   1.4357935E-04,   1.3385591E-04
     +,   1.2467185E-04,   1.1596468E-04,   1.0767939E-04
     +,   9.9771714E-05,   9.2207316E-05,   8.4962929E-05
     +,   7.8025107E-05,   7.1388597E-05,   6.5055414E-05
     +,   5.9031423E-05,   5.3325282E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_nwao_fus_90 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_nwao_fus_95(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  1.7505382E-12,   2.2868309E-12
     +,   2.9812060E-12,   3.8782944E-12,   5.0348176E-12
     +,   6.5226210E-12,   8.4324344E-12,   1.0878721E-11
     +,   1.4005545E-11,   1.7993478E-11,   2.3068842E-11
     +,   2.9514412E-11,   3.7682212E-11,   4.8010332E-11
     +,   6.1042373E-11,   7.7450331E-11,   9.8064494E-11
     +,   1.2390805E-10,   1.5623659E-10,   1.9659085E-10
     +,   2.4685498E-10,   3.0932887E-10,   3.8680778E-10
     +,   4.8269183E-10,   6.0109295E-10,   7.4698547E-10
     +,   9.2636332E-10,   1.1464393E-09,   1.4158534E-09
     +,   1.7449637E-09,   2.1461115E-09,   2.6340081E-09
     +,   3.2261267E-09,   3.9431809E-09,   4.8096096E-09
     +,   5.8542700E-09,   7.1110957E-09,   8.6198249E-09
     +,   1.0427007E-08,   1.2586990E-08,   1.5162895E-08
     +,   1.8228173E-08,   2.1867631E-08,   2.6179400E-08
     +,   3.1276400E-08,   3.7288434E-08,   4.4363830E-08
     +,   5.2672345E-08,   6.2407423E-08,   7.3788158E-08
     +,   8.7063405E-08,   1.0251416E-07,   1.2045605E-07
     +,   1.4124480E-07,   1.6527703E-07,   1.9299669E-07
     +,   2.2489728E-07,   2.6152640E-07,   3.0349017E-07
     +,   3.5145439E-07,   4.0615376E-07,   4.6838929E-07
     +,   5.3903756E-07,   6.1905291E-07,   7.0946442E-07
     +,   8.1138757E-07,   9.2602363E-07,   1.0546518E-06
     +,   1.1986448E-06,   1.3594588E-06,   1.5386350E-06
     +,   1.7377960E-06,   1.9586537E-06,   2.2029660E-06
     +,   2.4725846E-06,   2.7694132E-06,   3.0954043E-06
     +,   3.4525633E-06,   3.8428816E-06,   4.2684014E-06
     +,   4.7311455E-06,   5.2331134E-06,   5.7762850E-06
     +,   6.3624843E-06,   6.9936082E-06,   7.6712740E-06
     +,   8.3970590E-06,   9.1723523E-06,   9.9983499E-06
     +,   1.0876065E-05,   1.1806163E-05,   1.2789134E-05
     +,   1.3825140E-05,   1.4914012E-05,   1.6055239E-05
     +,   1.7247938E-05,   1.8490889E-05,   1.9782316E-05
     +,   2.1120175E-05,   2.2501950E-05,   2.3924693E-05
     +,   2.5385079E-05,   2.6879194E-05,   2.8402868E-05
     +,   2.9951476E-05,   3.1520009E-05,   3.3103170E-05
     +,   3.4695080E-05,   3.6289999E-05,   3.7881517E-05
     +,   3.9463248E-05,   4.1028587E-05,   4.2570842E-05
     +,   4.4083306E-05,   4.5559067E-05,   4.6991667E-05
     +,   4.8374386E-05,   4.9700920E-05,   5.0965162E-05
     +,   5.2161311E-05,   5.3283988E-05,   5.4328066E-05
     +,   5.5289089E-05,   5.6163015E-05,   5.6946414E-05
     +,   5.7636429E-05,   5.8230864E-05,   5.8728114E-05
     +,   5.9127320E-05,   5.9428286E-05,   5.9631526E-05
     +,   5.9738235E-05,   5.9750280E-05,   5.9670252E-05
     +,   5.9501363E-05,   5.9247483E-05,   5.8913065E-05
     +,   5.8503156E-05,   5.8023343E-05,   5.7479694E-05
     +,   5.6878802E-05,   5.6227607E-05,   5.5533488E-05
     +,   5.4804121E-05,   5.4047432E-05,   5.3271768E-05
     +,   5.2485419E-05,   5.1697061E-05,   5.0915358E-05
     +,   5.0149054E-05,   4.9406997E-05,   4.8697850E-05
     +,   4.8030346E-05,   4.7412999E-05,   4.6854155E-05
     +,   4.6361907E-05,   4.5943991E-05,   4.5607816E-05
     +,   4.5360233E-05,   4.5207602E-05,   4.5155586E-05
     +,   4.5209134E-05,   4.5372311E-05,   4.5648285E-05
     +,   4.6039127E-05,   4.6545767E-05,   4.7167890E-05
     +,   4.7903850E-05,   4.8750604E-05,   4.9703507E-05
     +,   5.0756593E-05,   5.1902149E-05,   5.3131065E-05
     +,   5.4432719E-05,   5.5795106E-05,   5.7205096E-05
     +,   5.8648384E-05,   6.0110153E-05,   6.1575287E-05
     +,   6.3028951E-05,   6.4457257E-05,   6.5847918E-05
     +,   6.7191781E-05,   6.8483329E-05,   6.9722635E-05
     +,   7.0916780E-05,   7.2081595E-05,   7.3243682E-05
     +,   7.4442032E-05,   7.5730451E-05,   7.7178418E-05
     +,   7.8872785E-05,   8.0918173E-05,   8.3436309E-05
     +,   8.6565859E-05,   9.0458670E-05,   9.5278563E-05
     +,   1.0119533E-04,   1.0838066E-04,   1.1700509E-04
     +,   1.2722917E-04,   1.3920429E-04,   1.5306301E-04
     +,   1.6892036E-04,   1.8686948E-04,   2.0697567E-04
     +,   2.2928035E-04,   2.5378619E-04,   2.8045915E-04
     +,   3.0921813E-04,   3.3992293E-04,   3.7238051E-04
     +,   4.0632635E-04,   4.4144216E-04,   4.7736333E-04
     +,   5.1370292E-04,   5.5008737E-04,   5.8618898E-04
     +,   6.2178384E-04,   6.5676781E-04,   6.9119292E-04
     +,   7.2526286E-04,   7.5930456E-04,   7.9372025E-04
     +,   8.2890916E-04,   8.6520746E-04,   9.0280653E-04
     +,   9.4173115E-04,   9.8184205E-04,   1.0228854E-03
     +,   1.0645739E-03,   1.1066656E-03,   1.1490444E-03
     +,   1.1917087E-03,   1.2347342E-03,   1.2781464E-03
     +,   1.3217776E-03,   1.3651296E-03,   1.4073090E-03
     +,   1.4470736E-03,   1.4829818E-03,   1.5136462E-03
     +,   1.5380218E-03,   1.5556499E-03,   1.5668118E-03
     +,   1.5725059E-03,   1.5742753E-03,   1.5738878E-03
     +,   1.5729478E-03,   1.5725149E-03,   1.5728162E-03
     +,   1.5731172E-03,   1.5717791E-03,   1.5664966E-03
     +,   1.5546732E-03,   1.5338663E-03,   1.5022021E-03
     +,   1.4587165E-03,   1.4035234E-03,   1.3378231E-03
     +,   1.2637537E-03,   1.1840725E-03,   1.1018342E-03
     +,   1.0199957E-03,   9.4111043E-04,   8.6710922E-04
     +,   7.9918181E-04,   7.3779380E-04,   6.8276684E-04
     +,   6.3344842E-04,   5.8889820E-04,   5.4807100E-04
     +,   5.0998025E-04,   4.7379342E-04,   4.3891781E-04
     +,   4.0499555E-04,   3.7190400E-04,   3.3969874E-04
     +,   3.0856230E-04,   2.7874982E-04,   2.5052487E-04
     +,   2.2413346E-04,   1.9976309E-04,   1.7753131E-04
     +,   1.5748359E-04,   1.3958845E-04,   1.2375851E-04
     +,   1.0985300E-04,   9.7701624E-05,   8.7114830E-05
     +,   7.7895565E-05,   6.9853624E-05,   6.2811450E-05
     +,   5.6610766E-05,   5.1113817E-05,   4.6205074E-05
     +,   4.1790026E-05,   3.7792946E-05,   3.4154775E-05
     +,   3.0829353E-05,   2.7781191E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_nwao_fus_95 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_nwao_hz_100(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  9.8775081E-07,   1.0528910E-06
     +,   1.1214482E-06,   1.1935341E-06,   1.2692617E-06
     +,   1.3487436E-06,   1.4320863E-06,   1.5193980E-06
     +,   1.6107854E-06,   1.7063476E-06,   1.8061838E-06
     +,   1.9103909E-06,   2.0190550E-06,   2.1322642E-06
     +,   2.2501004E-06,   2.3726341E-06,   2.4999354E-06
     +,   2.6320690E-06,   2.7690837E-06,   2.9110299E-06
     +,   3.0579454E-06,   3.2098631E-06,   3.3667993E-06
     +,   3.5287705E-06,   3.6957736E-06,   3.8678040E-06
     +,   4.0448408E-06,   4.2268589E-06,   4.4138110E-06
     +,   4.6056498E-06,   4.8023053E-06,   5.0037047E-06
     +,   5.2097585E-06,   5.4203715E-06,   5.6354206E-06
     +,   5.8547848E-06,   6.0783304E-06,   6.3058960E-06
     +,   6.5373251E-06,   6.7724445E-06,   7.0110573E-06
     +,   7.2529720E-06,   7.4979671E-06,   7.7458244E-06
     +,   7.9963065E-06,   8.2491742E-06,   8.5041593E-06
     +,   8.7610006E-06,   9.0194253E-06,   9.2791397E-06
     +,   9.5398500E-06,   9.8012615E-06,   1.0063054E-05
     +,   1.0324918E-05,   1.0586522E-05,   1.0847540E-05
     +,   1.1107640E-05,   1.1366483E-05,   1.1623732E-05
     +,   1.1879035E-05,   1.2132054E-05,   1.2382431E-05
     +,   1.2629827E-05,   1.2873898E-05,   1.3114287E-05
     +,   1.3350658E-05,   1.3582674E-05,   1.3809989E-05
     +,   1.4032275E-05,   1.4249202E-05,   1.4460451E-05
     +,   1.4665706E-05,   1.4864667E-05,   1.5057018E-05
     +,   1.5242476E-05,   1.5420763E-05,   1.5591608E-05
     +,   1.5754749E-05,   1.5909935E-05,   1.6056931E-05
     +,   1.6195514E-05,   1.6325474E-05,   1.6446620E-05
     +,   1.6558757E-05,   1.6661732E-05,   1.6755392E-05
     +,   1.6839600E-05,   1.6914242E-05,   1.6979220E-05
     +,   1.7034459E-05,   1.7079896E-05,   1.7115488E-05
     +,   1.7141223E-05,   1.7157101E-05,   1.7163151E-05
     +,   1.7159426E-05,   1.7146001E-05,   1.7122984E-05
     +,   1.7090502E-05,   1.7048718E-05,   1.6997827E-05
     +,   1.6938047E-05,   1.6869644E-05,   1.6792917E-05
     +,   1.6708200E-05,   1.6615870E-05,   1.6516346E-05
     +,   1.6410109E-05,   1.6297663E-05,   1.6179591E-05
     +,   1.6056529E-05,   1.5929159E-05,   1.5798250E-05
     +,   1.5664627E-05,   1.5529215E-05,   1.5392983E-05
     +,   1.5257036E-05,   1.5122546E-05,   1.4990812E-05
     +,   1.4863233E-05,   1.4741342E-05,   1.4626825E-05
     +,   1.4521500E-05,   1.4427366E-05,   1.4346591E-05
     +,   1.4281556E-05,   1.4234846E-05,   1.4209292E-05
     +,   1.4207973E-05,   1.4234241E-05,   1.4291745E-05
     +,   1.4384447E-05,   1.4516651E-05,   1.4692984E-05
     +,   1.4918461E-05,   1.5198449E-05,   1.5538704E-05
     +,   1.5945348E-05,   1.6424872E-05,   1.6984128E-05
     +,   1.7630226E-05,   1.8370603E-05,   1.9212901E-05
     +,   2.0164911E-05,   2.1234531E-05,   2.2429442E-05
     +,   2.3757495E-05,   2.5225901E-05,   2.6841648E-05
     +,   2.8611114E-05,   3.0539639E-05,   3.2632062E-05
     +,   3.4891556E-05,   3.7320246E-05,   3.9918592E-05
     +,   4.2685329E-05,   4.5617395E-05,   4.8709200E-05
     +,   5.1953772E-05,   5.5341057E-05,   5.8859168E-05
     +,   6.2493913E-05,   6.6228356E-05,   7.0044443E-05
     +,   7.3921241E-05,   7.7836819E-05,   8.1767888E-05
     +,   8.5690401E-05,   8.9580222E-05,   9.3413037E-05
     +,   9.7166558E-05,   1.0081936E-04,   1.0435314E-04
     +,   1.0775279E-04,   1.1100752E-04,   1.1411152E-04
     +,   1.1706442E-04,   1.1987254E-04,   1.2254906E-04
     +,   1.2511440E-04,   1.2759668E-04,   1.3003126E-04
     +,   1.3246154E-04,   1.3493735E-04,   1.3751540E-04
     +,   1.4025791E-04,   1.4323174E-04,   1.4650742E-04
     +,   1.5015696E-04,   1.5425413E-04,   1.5887069E-04
     +,   1.6407664E-04,   1.6993808E-04,   1.7651457E-04
     +,   1.8386090E-04,   1.9202210E-04,   2.0103785E-04
     +,   2.1093892E-04,   2.2175031E-04,   2.3349718E-04
     +,   2.4620321E-04,   2.5990378E-04,   2.7464566E-04
     +,   2.9049974E-04,   3.0756608E-04,   3.2597469E-04
     +,   3.4589440E-04,   3.6751758E-04,   3.9105589E-04
     +,   4.1671906E-04,   4.4468397E-04,   4.7507652E-04
     +,   5.0792511E-04,   5.4314599E-04,   5.8052159E-04
     +,   6.1970088E-04,   6.6022039E-04,   7.0153968E-04
     +,   7.4312295E-04,   7.8449911E-04,   8.2537252E-04
     +,   8.6570479E-04,   9.0579467E-04,   9.4632758E-04
     +,   9.8838226E-04,   1.0334157E-03,   1.0831705E-03
     +,   1.1395767E-03,   1.2045943E-03,   1.2800249E-03
     +,   1.3672827E-03,   1.4671009E-03,   1.5792791E-03
     +,   1.7023698E-03,   1.8336303E-03,   1.9692031E-03
     +,   2.1047483E-03,   2.2364776E-03,   2.3623598E-03
     +,   2.4831279E-03,   2.6024815E-03,   2.7262671E-03
     +,   2.8607906E-03,   3.0109654E-03,   3.1793804E-03
     +,   3.3666664E-03,   3.5730789E-03,   3.7996597E-03
     +,   4.0473132E-03,   4.3131132E-03,   4.5847041E-03
     +,   4.8366394E-03,   5.0318474E-03,   5.1305140E-03
     +,   5.1039406E-03,   4.9476316E-03,   4.6871011E-03
     +,   4.3728193E-03,   4.0657897E-03,   3.8199711E-03
     +,   3.6685825E-03,   3.6186236E-03,   3.6540248E-03
     +,   3.7439885E-03,   3.8525253E-03,   3.9462657E-03
     +,   3.9995415E-03,   3.9970116E-03,   3.9343992E-03
     +,   3.8174016E-03,   3.6588784E-03,   3.4746334E-03
     +,   3.2789127E-03,   3.0808276E-03,   2.8831381E-03
     +,   2.6832554E-03,   2.4762191E-03,   2.2579553E-03
     +,   2.0278140E-03,   1.7895163E-03,   1.5503059E-03
     +,   1.3192212E-03,   1.1048566E-03,   9.1370119E-04
     +,   7.4929191E-04,   6.1214261E-04,   5.0045463E-04
     +,   4.1094128E-04,   3.3977127E-04,   2.8320478E-04
     +,   2.3797972E-04,   2.0147838E-04,   1.7169530E-04
     +,   1.4714016E-04,   1.2670601E-04,   1.0956242E-04
     +,   9.5070980E-05,   8.2728613E-05,   7.2134491E-05
     +,   6.2965621E-05,   5.4964610E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_nwao_hz_100 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_nwao_hz_105(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  6.0945421E-10,   7.0873984E-10
     +,   8.2324159E-10,   9.5512454E-10,   1.1068423E-09
     +,   1.2811682E-09,   1.4812148E-09,   1.7105026E-09
     +,   1.9729844E-09,   2.2730839E-09,   2.6157774E-09
     +,   3.0066325E-09,   3.4518515E-09,   3.9583750E-09
     +,   4.5339434E-09,   5.1871361E-09,   5.9275092E-09
     +,   6.7656720E-09,   7.7133322E-09,   8.7834753E-09
     +,   9.9904263E-09,   1.1349996E-08,   1.2879520E-08
     +,   1.4598153E-08,   1.6526783E-08,   1.8688405E-08
     +,   2.1108104E-08,   2.3813335E-08,   2.6833895E-08
     +,   3.0202386E-08,   3.3954027E-08,   3.8127126E-08
     +,   4.2763237E-08,   4.7907239E-08,   5.3607273E-08
     +,   5.9915621E-08,   6.6888298E-08,   7.4585174E-08
     +,   8.3070752E-08,   9.2414055E-08,   1.0268817E-07
     +,   1.1397158E-07,   1.2634708E-07,   1.3990304E-07
     +,   1.5473276E-07,   1.7093512E-07,   1.8861360E-07
     +,   2.0787760E-07,   2.2884252E-07,   2.5162740E-07
     +,   2.7635832E-07,   3.0316636E-07,   3.3218652E-07
     +,   3.6356079E-07,   3.9743347E-07,   4.3395556E-07
     +,   4.7328095E-07,   5.1556822E-07,   5.6097997E-07
     +,   6.0967875E-07,   6.6183321E-07,   7.1761025E-07
     +,   7.7718073E-07,   8.4071581E-07,   9.0838319E-07
     +,   9.8035230E-07,   1.0567908E-06,   1.1378594E-06
     +,   1.2237181E-06,   1.3145208E-06,   1.4104144E-06
     +,   1.5115390E-06,   1.6180294E-06,   1.7299974E-06
     +,   1.8475573E-06,   1.9708050E-06,   2.0998227E-06
     +,   2.2346837E-06,   2.3754271E-06,   2.5220916E-06
     +,   2.6746891E-06,   2.8332131E-06,   2.9976411E-06
     +,   3.1679015E-06,   3.3439453E-06,   3.5256505E-06
     +,   3.7129007E-06,   3.9055417E-06,   4.1033927E-06
     +,   4.3062573E-06,   4.5138827E-06,   4.7260155E-06
     +,   4.9423647E-06,   5.1626121E-06,   5.3864123E-06
     +,   5.6133949E-06,   5.8431692E-06,   6.0752968E-06
     +,   6.3093421E-06,   6.5448380E-06,   6.7812994E-06
     +,   7.0182309E-06,   7.2550984E-06,   7.4913769E-06
     +,   7.7265304E-06,   7.9600104E-06,   8.1912822E-06
     +,   8.4197682E-06,   8.6449663E-06,   8.8663201E-06
     +,   9.0833200E-06,   9.2954715E-06,   9.5023051E-06
     +,   9.7033844E-06,   9.8982837E-06,   1.0086669E-05
     +,   1.0268202E-05,   1.0442628E-05,   1.0609745E-05
     +,   1.0769416E-05,   1.0921578E-05,   1.1066236E-05
     +,   1.1203490E-05,   1.1333526E-05,   1.1456626E-05
     +,   1.1573167E-05,   1.1683639E-05,   1.1788624E-05
     +,   1.1888831E-05,   1.1985075E-05,   1.2078288E-05
     +,   1.2169515E-05,   1.2259923E-05,   1.2350777E-05
     +,   1.2443465E-05,   1.2539474E-05,   1.2640387E-05
     +,   1.2747882E-05,   1.2863709E-05,   1.2989697E-05
     +,   1.3127717E-05,   1.3279687E-05,   1.3447549E-05
     +,   1.3633253E-05,   1.3838738E-05,   1.4065876E-05
     +,   1.4316547E-05,   1.4592495E-05,   1.4895406E-05
     +,   1.5226850E-05,   1.5588214E-05,   1.5980835E-05
     +,   1.6405796E-05,   1.6864073E-05,   1.7356459E-05
     +,   1.7883600E-05,   1.8446022E-05,   1.9044046E-05
     +,   1.9678089E-05,   2.0348378E-05,   2.1055273E-05
     +,   2.1799278E-05,   2.2581007E-05,   2.3401626E-05
     +,   2.4262568E-05,   2.5166026E-05,   2.6114974E-05
     +,   2.7113378E-05,   2.8166432E-05,   2.9280565E-05
     +,   3.0464153E-05,   3.1727064E-05,   3.3081411E-05
     +,   3.4541503E-05,   3.6124071E-05,   3.7848451E-05
     +,   3.9736406E-05,   4.1812575E-05,   4.4104134E-05
     +,   4.6640747E-05,   4.9454378E-05,   5.2578467E-05
     +,   5.6048553E-05,   5.9900089E-05,   6.4168984E-05
     +,   6.8889967E-05,   7.4095718E-05,   7.9815807E-05
     +,   8.6074280E-05,   9.2890761E-05,   1.0027574E-04
     +,   1.0823168E-04,   1.1675094E-04,   1.2581301E-04
     +,   1.3538725E-04,   1.4542702E-04,   1.5587524E-04
     +,   1.6665951E-04,   1.7769479E-04,   1.8888789E-04
     +,   2.0013402E-04,   2.1132646E-04,   2.2235462E-04
     +,   2.3311387E-04,   2.4350942E-04,   2.5346217E-04
     +,   2.6291952E-04,   2.7185827E-04,   2.8029585E-04
     +,   2.8829582E-04,   2.9597280E-04,   3.0350045E-04
     +,   3.1111081E-04,   3.1909908E-04,   3.2782316E-04
     +,   3.3770397E-04,   3.4922559E-04,   3.6293344E-04
     +,   3.7943866E-04,   3.9940863E-04,   4.2356551E-04
     +,   4.5266683E-04,   4.8747705E-04,   5.2872172E-04
     +,   5.7701638E-04,   6.3280849E-04,   6.9627375E-04
     +,   7.6727121E-04,   8.4529759E-04,   9.2949893E-04
     +,   1.0187326E-03,   1.1116479E-03,   1.2068385E-03
     +,   1.3028840E-03,   1.3984288E-03,   1.4921343E-03
     +,   1.5826094E-03,   1.6683290E-03,   1.7476112E-03
     +,   1.8187335E-03,   1.8801328E-03,   1.9307028E-03
     +,   1.9700590E-03,   1.9987063E-03,   2.0181206E-03
     +,   2.0307640E-03,   2.0401732E-03,   2.0510876E-03
     +,   2.0694803E-03,   2.1021853E-03,   2.1558292E-03
     +,   2.2351532E-03,   2.3411869E-03,   2.4703685E-03
     +,   2.6156877E-03,   2.7702467E-03,   2.9327029E-03
     +,   3.1117906E-03,   3.3268493E-03,   3.6016295E-03
     +,   3.9522480E-03,   4.3745046E-03,   4.8377882E-03
     +,   5.2926890E-03,   5.6914454E-03,   6.0108332E-03
     +,   6.2603941E-03,   6.4670411E-03,   6.6487473E-03
     +,   6.8029920E-03,   6.9210120E-03,   7.0083626E-03
     +,   7.0839715E-03,   7.1572410E-03,   7.2104875E-03
     +,   7.2082165E-03,   7.1233311E-03,   6.9535198E-03
     +,   6.7143859E-03,   6.4198636E-03,   6.0690688E-03
     +,   5.6494279E-03,   5.1499861E-03,   4.5741145E-03
     +,   3.9440617E-03,   3.2964363E-03,   2.6732322E-03
     +,   2.1113458E-03,   1.6354136E-03,   1.2545731E-03
     +,   9.6390827E-04,   7.4923190E-04,   5.9260137E-04
     +,   4.7697805E-04,   3.8882651E-04,   3.1882332E-04
     +,   2.6125077E-04,   2.1289512E-04,   1.7200963E-04
     +,   1.3755893E-04,   1.0879867E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_nwao_hz_105 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_nwao_hz_107(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  6.6919208E-16,   8.7432213E-16
     +,   1.1406074E-15,   1.4857325E-15,   1.9323424E-15
     +,   2.5094092E-15,   3.2538586E-15,   4.2127582E-15
     +,   5.4459877E-15,   7.0295074E-15,   9.0597357E-15
     +,   1.1658673E-14,   1.4980316E-14,   1.9219120E-14
     +,   2.4620149E-14,   3.1490913E-14,   4.0217995E-14
     +,   5.1286087E-14,   6.5300677E-14,   8.3018790E-14
     +,   1.0538427E-13,   1.3357287E-13,   1.6904401E-13
     +,   2.1361136E-13,   2.6951808E-13,   3.3954090E-13
     +,   4.2710719E-13,   5.3644551E-13,   6.7274826E-13
     +,   8.4240823E-13,   1.0532505E-12,   1.3148678E-12
     +,   1.6389784E-12,   2.0398893E-12,   2.5350082E-12
     +,   3.1455257E-12,   3.8971738E-12,   4.8210906E-12
     +,   5.9550065E-12,   7.3444879E-12,   9.0444006E-12
     +,   1.1120931E-11,   1.3653434E-11,   1.6737218E-11
     +,   2.0486403E-11,   2.5037469E-11,   3.0553046E-11
     +,   3.7227142E-11,   4.5290598E-11,   5.5016686E-11
     +,   6.6730260E-11,   8.0815264E-11,   9.7724495E-11
     +,   1.1799287E-10,   1.4224842E-10,   1.7123017E-10
     +,   2.0580414E-10,   2.4698410E-10,   2.9595543E-10
     +,   3.5409756E-10,   4.2302140E-10,   5.0459203E-10
     +,   6.0098099E-10,   7.1469808E-10,   8.4864177E-10
     +,   1.0061596E-09,   1.1911110E-09,   1.4079184E-09
     +,   1.6616654E-09,   1.9581701E-09,   2.3040851E-09
     +,   2.7070008E-09,   3.1755700E-09,   3.7195802E-09
     +,   4.3501798E-09,   5.0799795E-09,   5.9232272E-09
     +,   6.8960286E-09,   8.0163893E-09,   9.3046610E-09
     +,   1.0783611E-08,   1.2478712E-08,   1.4418513E-08
     +,   1.6634468E-08,   1.9162190E-08,   2.2040524E-08
     +,   2.5312927E-08,   2.9027310E-08,   3.3236521E-08
     +,   3.7998920E-08,   4.3378069E-08,   4.9444182E-08
     +,   5.6273940E-08,   6.3950921E-08,   7.2566294E-08
     +,   8.2219131E-08,   9.3017327E-08,   1.0507620E-07
     +,   1.1852206E-07,   1.3349006E-07,   1.5012611E-07
     +,   1.6858721E-07,   1.8903954E-07,   2.1166302E-07
     +,   2.3664876E-07,   2.6420054E-07,   2.9453611E-07
     +,   3.2788185E-07,   3.6448648E-07,   4.0460392E-07
     +,   4.4850788E-07,   4.9648588E-07,   5.4884123E-07
     +,   6.0589514E-07,   6.6797713E-07,   7.3544970E-07
     +,   8.0867727E-07,   8.8805285E-07,   9.7398674E-07
     +,   1.0669114E-06,   1.1672851E-06,   1.2755786E-06
     +,   1.3923000E-06,   1.5179818E-06,   1.6531872E-06
     +,   1.7985108E-06,   1.9545887E-06,   2.1220792E-06
     +,   2.3016980E-06,   2.4942017E-06,   2.7003948E-06
     +,   2.9211346E-06,   3.1573450E-06,   3.4099821E-06
     +,   3.6800941E-06,   3.9687875E-06,   4.2772408E-06
     +,   4.6067053E-06,   4.9585083E-06,   5.3340696E-06
     +,   5.7348425E-06,   6.1623987E-06,   6.6183702E-06
     +,   7.1044574E-06,   7.6224455E-06,   8.1740945E-06
     +,   8.7613507E-06,   9.3860444E-06,   1.0050111E-05
     +,   1.0755486E-05,   1.1503979E-05,   1.2297548E-05
     +,   1.3137880E-05,   1.4026681E-05,   1.4965498E-05
     +,   1.5955735E-05,   1.6998636E-05,   1.8095070E-05
     +,   1.9245956E-05,   2.0451631E-05,   2.1712314E-05
     +,   2.3027917E-05,   2.4397821E-05,   2.5821424E-05
     +,   2.7297439E-05,   2.8824470E-05,   3.0400783E-05
     +,   3.2024400E-05,   3.3693221E-05,   3.5404799E-05
     +,   3.7157093E-05,   3.8947735E-05,   4.0774841E-05
     +,   4.2636872E-05,   4.4532815E-05,   4.6462534E-05
     +,   4.8426606E-05,   5.0427006E-05,   5.2467043E-05
     +,   5.4551656E-05,   5.6687688E-05,   5.8883732E-05
     +,   6.1151142E-05,   6.3503052E-05,   6.5955341E-05
     +,   6.8526344E-05,   7.1236704E-05,   7.4109543E-05
     +,   7.7169505E-05,   8.0443759E-05,   8.3959872E-05
     +,   8.7746550E-05,   9.1832517E-05,   9.6245130E-05
     +,   1.0101130E-04,   1.0615406E-04,   1.1169488E-04
     +,   1.1765018E-04,   1.2403194E-04,   1.3084934E-04
     +,   1.3810549E-04,   1.4580286E-04,   1.5394053E-04
     +,   1.6252020E-04,   1.7154797E-04,   1.8103742E-04
     +,   1.9101765E-04,   2.0153336E-04,   2.1265313E-04
     +,   2.2447150E-04,   2.3710907E-04,   2.5071666E-04
     +,   2.6546506E-04,   2.8154245E-04,   2.9914099E-04
     +,   3.1844177E-04,   3.3959848E-04,   3.6271545E-04
     +,   3.8784093E-04,   4.1494454E-04,   4.4392631E-04
     +,   4.7462498E-04,   5.0684833E-04,   5.4042198E-04
     +,   5.7524885E-04,   6.1140029E-04,   6.4917974E-04
     +,   6.8920193E-04,   7.3242327E-04,   7.8011770E-04
     +,   8.3378068E-04,   8.9493342E-04,   9.6487935E-04
     +,   1.0443602E-03,   1.1332718E-03,   1.2304251E-03
     +,   1.3334561E-03,   1.4389524E-03,   1.5427484E-03
     +,   1.6404481E-03,   1.7279857E-03,   1.8021897E-03
     +,   1.8612070E-03,   1.9046975E-03,   1.9338063E-03
     +,   1.9508678E-03,   1.9590028E-03,   1.9616685E-03
     +,   1.9622745E-03,   1.9639591E-03,   1.9695854E-03
     +,   1.9821466E-03,   2.0057969E-03,   2.0475863E-03
     +,   2.1194711E-03,   2.2391267E-03,   2.4277056E-03
     +,   2.7030318E-03,   3.0698313E-03,   3.5114498E-03
     +,   3.9889514E-03,   4.4506397E-03,   4.8473910E-03
     +,   5.1459959E-03,   5.3330674E-03,   5.4116850E-03
     +,   5.3990609E-03,   5.3304811E-03,   5.2635875E-03
     +,   5.2694939E-03,   5.4045347E-03,   5.6758178E-03
     +,   6.0274107E-03,   6.3657505E-03,   6.6129300E-03
     +,   6.7505785E-03,   6.8183006E-03,   6.8676774E-03
     +,   6.9108573E-03,   6.9079441E-03,   6.8007843E-03
     +,   6.5598385E-03,   6.2044943E-03,   5.7866219E-03
     +,   5.3584422E-03,   4.9500880E-03,   4.5664920E-03
     +,   4.1958881E-03,   3.8212924E-03,   3.4296389E-03
     +,   3.0176528E-03,   2.5937974E-03,   2.1752575E-03
     +,   1.7818027E-03,   1.4293792E-03,   1.1266466E-03
     +,   8.7494677E-04,   6.7055272E-04,   5.0740270E-04
     +,   3.7898964E-04,   2.7930731E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_nwao_hz_107 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_nwao_hz_110(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  1.7195403E-15,   2.2309662E-15
     +,   2.8901922E-15,   3.7386035E-15,   4.8288472E-15
     +,   6.2277530E-15,   8.0199019E-15,   1.0312323E-14
     +,   1.3240351E-14,   1.6974247E-14,   2.1728662E-14
     +,   2.7773365E-14,   3.5446465E-14,   4.5172033E-14
     +,   5.7480442E-14,   7.3033085E-14,   9.2655348E-14
     +,   1.1737445E-13,   1.4846608E-13,   1.8751342E-13
     +,   2.3647650E-13,   2.9778139E-13,   3.7441803E-13
     +,   4.7007623E-13,   5.8929174E-13,   7.3763754E-13
     +,   9.2195110E-13,   1.1506016E-12,   1.4338108E-12
     +,   1.7840713E-12,   2.2165720E-12,   2.7498140E-12
     +,   3.4062410E-12,   4.2130908E-12,   5.2032671E-12
     +,   6.4165678E-12,   7.9010158E-12,   9.7143101E-12
     +,   1.1925935E-11,   1.4619278E-11,   1.7894089E-11
     +,   2.1869876E-11,   2.6689003E-11,   3.2521444E-11
     +,   3.9569330E-11,   4.8072889E-11,   5.8316553E-11
     +,   7.0637364E-11,   8.5433986E-11,   1.0317548E-10
     +,   1.2441517E-10,   1.4980395E-10,   1.8010399E-10
     +,   2.1620991E-10,   2.5916602E-10,   3.1019295E-10
     +,   3.7071246E-10,   4.4237877E-10,   5.2711280E-10
     +,   6.2713729E-10,   7.4503159E-10,   8.8376545E-10
     +,   1.0467675E-09,   1.2379883E-09,   1.4619502E-09
     +,   1.7238523E-09,   2.0296453E-09,   2.3861095E-09
     +,   2.8009934E-09,   3.2831078E-09,   3.8424588E-09
     +,   4.4904005E-09,   5.2397957E-09,   6.1051018E-09
     +,   7.1026887E-09,   8.2509475E-09,   9.5705417E-09
     +,   1.1084673E-08,   1.2819113E-08,   1.4802819E-08
     +,   1.7067997E-08,   1.9650432E-08,   2.2589944E-08
     +,   2.5930150E-08,   2.9720141E-08,   3.4013063E-08
     +,   3.8867999E-08,   4.4349612E-08,   5.0528786E-08
     +,   5.7483309E-08,   6.5297087E-08,   7.4062307E-08
     +,   8.3878824E-08,   9.4854641E-08,   1.0710674E-07
     +,   1.2076086E-07,   1.3595320E-07,   1.5282778E-07
     +,   1.7154053E-07,   1.9225740E-07,   2.1515490E-07
     +,   2.4042131E-07,   2.6825327E-07,   2.9886107E-07
     +,   3.3246488E-07,   3.6929615E-07,   4.0959821E-07
     +,   4.5361858E-07,   5.0162606E-07,   5.5388699E-07
     +,   6.1068283E-07,   6.7230246E-07,   7.3904050E-07
     +,   8.1120061E-07,   8.8908041E-07,   9.7300097E-07
     +,   1.0632641E-06,   1.1601845E-06,   1.2640722E-06
     +,   1.3752360E-06,   1.4939814E-06,   1.6205963E-06
     +,   1.7553712E-06,   1.8985834E-06,   2.0504956E-06
     +,   2.2113570E-06,   2.3814071E-06,   2.5608465E-06
     +,   2.7498761E-06,   2.9486685E-06,   3.1573736E-06
     +,   3.3761185E-06,   3.6050139E-06,   3.8441203E-06
     +,   4.0934992E-06,   4.3531809E-06,   4.6231685E-06
     +,   4.9034470E-06,   5.1939805E-06,   5.4947259E-06
     +,   5.8055898E-06,   6.1265023E-06,   6.4573719E-06
     +,   6.7981041E-06,   7.1486147E-06,   7.5087746E-06
     +,   7.8785533E-06,   8.2578417E-06,   8.6466061E-06
     +,   9.0448357E-06,   9.4524921E-06,   9.8696746E-06
     +,   1.0296427E-05,   1.0732892E-05,   1.1179257E-05
     +,   1.1635773E-05,   1.2102774E-05,   1.2580605E-05
     +,   1.3069832E-05,   1.3570992E-05,   1.4084830E-05
     +,   1.4612229E-05,   1.5154164E-05,   1.5711958E-05
     +,   1.6287033E-05,   1.6881171E-05,   1.7496497E-05
     +,   1.8135523E-05,   1.8801276E-05,   1.9497236E-05
     +,   2.0227715E-05,   2.0997597E-05,   2.1812719E-05
     +,   2.2679851E-05,   2.3606834E-05,   2.4602699E-05
     +,   2.5677633E-05,   2.6843247E-05,   2.8112489E-05
     +,   2.9499693E-05,   3.1020609E-05,   3.2692005E-05
     +,   3.4532208E-05,   3.6560021E-05,   3.8795144E-05
     +,   4.1257488E-05,   4.3966764E-05,   4.6942165E-05
     +,   5.0201132E-05,   5.3760079E-05,   5.7631991E-05
     +,   6.1827166E-05,   6.6352106E-05,   7.1208211E-05
     +,   7.6393291E-05,   8.1898470E-05,   8.7711283E-05
     +,   9.3812901E-05,   1.0017980E-04,   1.0678602E-04
     +,   1.1360086E-04,   1.2059416E-04,   1.2773431E-04
     +,   1.3499284E-04,   1.4234547E-04,   1.4977291E-04
     +,   1.5726600E-04,   1.6482308E-04,   1.7245433E-04
     +,   1.8018091E-04,   1.8803353E-04,   1.9605416E-04
     +,   2.0428940E-04,   2.1279078E-04,   2.2160857E-04
     +,   2.3078726E-04,   2.4036075E-04,   2.5034492E-04
     +,   2.6073746E-04,   2.7150975E-04,   2.8261103E-04
     +,   2.9397084E-04,   3.0550943E-04,   3.1715652E-04
     +,   3.2887611E-04,   3.4070856E-04,   3.5281101E-04
     +,   3.6551512E-04,   3.7937888E-04,   3.9523200E-04
     +,   4.1420248E-04,   4.3770351E-04,   4.6738653E-04
     +,   5.0501461E-04,   5.5229675E-04,   6.1064993E-04
     +,   6.8092602E-04,   7.6313090E-04,   8.5615914E-04
     +,   9.5764373E-04,   1.0639265E-03,   1.1702423E-03
     +,   1.2711489E-03,   1.3611737E-03,   1.4356854E-03
     +,   1.4917161E-03,   1.5286860E-03,   1.5486875E-03
     +,   1.5562243E-03,   1.5573653E-03,   1.5584830E-03
     +,   1.5649516E-03,   1.5802562E-03,   1.6058853E-03
     +,   1.6420885E-03,   1.6891009E-03,   1.7481735E-03
     +,   1.8216172E-03,   1.9116979E-03,   2.0188857E-03
     +,   2.1406547E-03,   2.2720576E-03,   2.4080130E-03
     +,   2.5462834E-03,   2.6888796E-03,   2.8404843E-03
     +,   3.0042261E-03,   3.1774468E-03,   3.3510132E-03
     +,   3.5140105E-03,   3.6622582E-03,   3.8051240E-03
     +,   3.9645266E-03,   4.1639693E-03,   4.4121002E-03
     +,   4.6909987E-03,   4.9571716E-03,   5.1564374E-03
     +,   5.2444716E-03,   5.2024242E-03,   5.0405846E-03
     +,   4.7902223E-03,   4.4891257E-03,   4.1682282E-03
     +,   3.8448696E-03,   3.5237523E-03,   3.2030817E-03
     +,   2.8804697E-03,   2.5562111E-03,   2.2333842E-03
     +,   1.9168745E-03,   1.6128020E-03,   1.3279864E-03
     +,   1.0692009E-03,   8.4187498E-04,   6.4901792E-04
     +,   4.9075700E-04,   3.6469835E-04,   2.6682613E-04
     +,   1.9243572E-04,   1.3689618E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_nwao_hz_110 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_nwao_hz_115(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  2.9603555E-06,   3.0958306E-06
     +,   3.2351720E-06,   3.3783419E-06,   3.5253004E-06
     +,   3.6759984E-06,   3.8303688E-06,   3.9883407E-06
     +,   4.1498324E-06,   4.3147425E-06,   4.4829676E-06
     +,   4.6543923E-06,   4.8288803E-06,   5.0062927E-06
     +,   5.1864799E-06,   5.3692697E-06,   5.5544892E-06
     +,   5.7419529E-06,   5.9314552E-06,   6.1227875E-06
     +,   6.3157318E-06,   6.5100535E-06,   6.7055071E-06
     +,   6.9018470E-06,   7.0988026E-06,   7.2961084E-06
     +,   7.4934842E-06,   7.6906490E-06,   7.8872981E-06
     +,   8.0831387E-06,   8.2778588E-06,   8.4711501E-06
     +,   8.6626960E-06,   8.8521829E-06,   9.0392805E-06
     +,   9.2236678E-06,   9.4050247E-06,   9.5830219E-06
     +,   9.7573393E-06,   9.9276576E-06,   1.0093654E-05
     +,   1.0255020E-05,   1.0411444E-05,   1.0562621E-05
     +,   1.0708257E-05,   1.0848066E-05,   1.0981766E-05
     +,   1.1109086E-05,   1.1229773E-05,   1.1343574E-05
     +,   1.1450256E-05,   1.1549599E-05,   1.1641394E-05
     +,   1.1725448E-05,   1.1801582E-05,   1.1869636E-05
     +,   1.1929464E-05,   1.1980938E-05,   1.2023950E-05
     +,   1.2058407E-05,   1.2084232E-05,   1.2101370E-05
     +,   1.2109787E-05,   1.2109464E-05,   1.2100400E-05
     +,   1.2082620E-05,   1.2056157E-05,   1.2021073E-05
     +,   1.1977444E-05,   1.1925365E-05,   1.1864948E-05
     +,   1.1796327E-05,   1.1719644E-05,   1.1635069E-05
     +,   1.1542783E-05,   1.1442985E-05,   1.1335883E-05
     +,   1.1221702E-05,   1.1100691E-05,   1.0973100E-05
     +,   1.0839192E-05,   1.0699248E-05,   1.0553553E-05
     +,   1.0402417E-05,   1.0246129E-05,   1.0085024E-05
     +,   9.9194194E-06,   9.7496477E-06,   9.5760497E-06
     +,   9.3989611E-06,   9.2187456E-06,   9.0357516E-06
     +,   8.8503393E-06,   8.6628688E-06,   8.4737094E-06
     +,   8.2832294E-06,   8.0917953E-06,   7.8997955E-06
     +,   7.7076011E-06,   7.5155954E-06,   7.3241608E-06
     +,   7.1336772E-06,   6.9445518E-06,   6.7571723E-06
     +,   6.5719387E-06,   6.3892562E-06,   6.2095291E-06
     +,   6.0331981E-06,   5.8606624E-06,   5.6923764E-06
     +,   5.5287815E-06,   5.3703334E-06,   5.2175046E-06
     +,   5.0707736E-06,   4.9306577E-06,   4.7976528E-06
     +,   4.6723117E-06,   4.5551865E-06,   4.4468566E-06
     +,   4.3479240E-06,   4.2590141E-06,   4.1807871E-06
     +,   4.1139224E-06,   4.0591322E-06,   4.0171576E-06
     +,   3.9887732E-06,   3.9747865E-06,   3.9760366E-06
     +,   3.9933998E-06,   4.0277823E-06,   4.0801278E-06
     +,   4.1514145E-06,   4.2426568E-06,   4.3548921E-06
     +,   4.4891990E-06,   4.6466857E-06,   4.8284865E-06
     +,   5.0357608E-06,   5.2696932E-06,   5.5314977E-06
     +,   5.8223754E-06,   6.1435644E-06,   6.4963010E-06
     +,   6.8818263E-06,   7.3013857E-06,   7.7561499E-06
     +,   8.2473889E-06,   8.7762155E-06,   9.3437839E-06
     +,   9.9511972E-06,   1.0599412E-05,   1.1289481E-05
     +,   1.2022199E-05,   1.2798369E-05,   1.3618654E-05
     +,   1.4483590E-05,   1.5393614E-05,   1.6348857E-05
     +,   1.7349532E-05,   1.8395394E-05,   1.9486155E-05
     +,   2.0621283E-05,   2.1799840E-05,   2.3020932E-05
     +,   2.4283067E-05,   2.5584644E-05,   2.6923717E-05
     +,   2.8298005E-05,   2.9704959E-05,   3.1141499E-05
     +,   3.2604570E-05,   3.4090430E-05,   3.5595229E-05
     +,   3.7114780E-05,   3.8644623E-05,   4.0180130E-05
     +,   4.1716332E-05,   4.3248285E-05,   4.4770961E-05
     +,   4.6279361E-05,   4.7768666E-05,   4.9234102E-05
     +,   5.0671624E-05,   5.2077332E-05,   5.3448195E-05
     +,   5.4781947E-05,   5.6077322E-05,   5.7334244E-05
     +,   5.8553789E-05,   5.9738893E-05,   6.0893806E-05
     +,   6.2024832E-05,   6.3140207E-05,   6.4250038E-05
     +,   6.5366898E-05,   6.6505156E-05,   6.7681685E-05
     +,   6.8915215E-05,   7.0226393E-05,   7.1638009E-05
     +,   7.3173986E-05,   7.4860065E-05,   7.6722543E-05
     +,   7.8788667E-05,   8.1086087E-05,   8.3642110E-05
     +,   8.6484448E-05,   8.9639710E-05,   9.3134309E-05
     +,   9.6994154E-05,   1.0124417E-04,   1.0591032E-04
     +,   1.1101798E-04,   1.1659432E-04,   1.2266854E-04
     +,   1.2927306E-04,   1.3644478E-04,   1.4422472E-04
     +,   1.5266219E-04,   1.6181084E-04,   1.7173185E-04
     +,   1.8249158E-04,   1.9415963E-04,   2.0680630E-04
     +,   2.2049587E-04,   2.3528666E-04,   2.5121804E-04
     +,   2.6830999E-04,   2.8655425E-04,   3.0591057E-04
     +,   3.2630443E-04,   3.4762206E-04,   3.6972095E-04
     +,   3.9242348E-04,   4.1553125E-04,   4.3882881E-04
     +,   4.6209214E-04,   4.8509636E-04,   5.0761981E-04
     +,   5.2945362E-04,   5.5040541E-04,   5.7030696E-04
     +,   5.8902759E-04,   6.0648588E-04,   6.2268187E-04
     +,   6.3771580E-04,   6.5182894E-04,   6.6543132E-04
     +,   6.7912461E-04,   6.9371489E-04,   7.1018754E-04
     +,   7.2966708E-04,   7.5332361E-04,   7.8225596E-04
     +,   8.1735465E-04,   8.5912680E-04,   9.0757414E-04
     +,   9.6205587E-04,   1.0212585E-03,   1.0832163E-03
     +,   1.1454164E-03,   1.2050258E-03,   1.2591236E-03
     +,   1.3050210E-03,   1.3405439E-03,   1.3642702E-03
     +,   1.3756896E-03,   1.3752469E-03,   1.3642777E-03
     +,   1.3448352E-03,   1.3194425E-03,   1.2907999E-03
     +,   1.2614984E-03,   1.2337476E-03,   1.2091935E-03
     +,   1.1887806E-03,   1.1727337E-03,   1.1605916E-03
     +,   1.1513218E-03,   1.1434783E-03,   1.1353828E-03
     +,   1.1253136E-03,   1.1116739E-03,   1.0931323E-03
     +,   1.0687265E-03,   1.0379041E-03,   1.0005491E-03
     +,   9.5693168E-04,   9.0766989E-04,   8.5364497E-04
     +,   7.9590536E-04,   7.3560228E-04,   6.7390263E-04
     +,   6.1194057E-04,   5.5075734E-04,   4.9127778E-04
     +,   4.3429001E-04,   3.8043276E-04,   3.3020289E-04
     +,   2.8394637E-04,   2.4187523E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_nwao_hz_115 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_nwao_hz_120(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   1.7439777E-38,   5.9647637E-38,   2.0202193E-37
     +,   6.7757938E-37,   2.2504823E-36,   7.4024403E-36
     +,   2.4109527E-35,   7.7768037E-35,   2.4840227E-34
     +,   7.8572191E-34,   2.4611740E-33,   7.6344163E-33
     +,   2.3452596E-32,   7.1339077E-32,   2.1491415E-31
     +,   6.4112482E-31,   1.8940285E-30,   5.5410186E-30
     +,   1.6053068E-29,   4.6058064E-29,   1.3085768E-28
     +,   3.6817615E-28,   1.0258330E-27,   2.8304851E-27
     +,   7.7340724E-27,   2.0928366E-26,   5.6080146E-26
     +,   1.4881523E-25,   3.9106485E-25,   1.0176881E-24
     +,   2.6226693E-24,   6.6934501E-24,   1.6916231E-23
     +,   4.2337101E-23,   1.0493050E-22,   2.5753880E-22
     +,   6.2595696E-22,   1.5066380E-21,   3.5912725E-21
     +,   8.4768177E-21,   1.9814305E-20,   4.5865165E-20
     +,   1.0513444E-19,   2.3865962E-19,   5.3646737E-19
     +,   1.1942368E-18,   2.6325714E-18,   5.7467902E-18
     +,   1.2423292E-17,   2.6593577E-17,   5.6375939E-17
     +,   1.1834498E-16,   2.4601238E-16,   5.0642295E-16
     +,   1.0323299E-15,   2.0839234E-15,   4.1655247E-15
     +,   8.2456591E-15,   1.6162710E-14,   3.1372284E-14
     +,   6.0301854E-14,   1.1477172E-13,   2.1632137E-13
     +,   4.0373193E-13,   7.4614539E-13,   1.3654931E-12
     +,   2.4745223E-12,   4.4405508E-12,   7.8903507E-12
     +,   1.3883708E-11,   2.4190016E-11,   4.1734619E-11
     +,   7.1299355E-11,   1.2061542E-10,   2.0204835E-10
     +,   3.3513933E-10,   5.5045529E-10,   8.9524915E-10
     +,   1.4417552E-09,   2.2991764E-09,   3.6304759E-09
     +,   5.6767093E-09,   8.7892102E-09,   1.3475117E-08
     +,   2.0457188E-08,   3.0753402E-08,   4.5780808E-08
     +,   6.7484066E-08,   9.8509190E-08,   1.4239555E-07
     +,   2.0383229E-07,   2.8894794E-07,   4.0562787E-07
     +,   5.6393623E-07,   7.7645478E-07,   1.0588147E-06
     +,   1.4300310E-06,   1.9129338E-06,   2.5346685E-06
     +,   3.3266811E-06,   4.3252471E-06,   5.5709947E-06
     +,   7.1090130E-06,   8.9882551E-06,   1.1260394E-05
     +,   1.3979638E-05,   1.7200149E-05,   2.0975409E-05
     +,   2.5356052E-05,   3.0387064E-05,   3.6107740E-05
     +,   4.2546963E-05,   4.9723607E-05,   5.7643949E-05
     +,   6.6300825E-05,   7.5673364E-05,   8.5725289E-05
     +,   9.6409560E-05,   1.0766438E-04,   1.1941927E-04
     +,   1.3159509E-04,   1.4410655E-04,   1.5686483E-04
     +,   1.6977634E-04,   1.8274871E-04,   1.9568333E-04
     +,   2.0847910E-04,   2.2102718E-04,   2.3320824E-04
     +,   2.4488990E-04,   2.5592305E-04,   2.6614757E-04
     +,   2.7539232E-04,   2.8349058E-04,   2.9029552E-04
     +,   2.9570493E-04,   2.9969003E-04,   3.0232617E-04
     +,   3.0382385E-04,   3.0455034E-04,   3.0503975E-04
     +,   3.0598539E-04,   3.0820945E-04,   3.1261117E-04
     +,   3.2009234E-04,   3.3146972E-04,   3.4738029E-04
     +,   3.6818656E-04,   3.9390885E-04,   4.2416246E-04
     +,   4.5815588E-04,   4.9469760E-04,   5.3226692E-04
     +,   5.6913082E-04,   6.0347124E-04,   6.3358591E-04
     +,   6.5806758E-04,   6.7601143E-04,   6.8717304E-04
     +,   6.9207093E-04,   6.9200055E-04,   6.8894069E-04
     +,   6.8535848E-04,   6.8393268E-04,   6.8723148E-04
     +,   6.9739966E-04,   7.1588554E-04,   7.4325607E-04
     +,   7.7909982E-04,   8.2202675E-04,   8.6975138E-04
     +,   9.1924332E-04,   9.6696900E-04,   1.0091481E-03
     +,   1.0421104E-03,   1.0626193E-03,   1.0682197E-03
     +,   1.0574886E-03,   1.0301879E-03,   9.8725408E-04
     +,   9.3066698E-04,   8.6316973E-04,   7.8793790E-04
     +,   7.0825190E-04,   6.2716933E-04,   5.4736092E-04
     +,   4.7094835E-04,   3.9952004E-04,   3.3414806E-04
     +,   2.7544907E-04,   2.2368952E-04,   1.7884822E-04
     +,   1.4068966E-04,   1.0880607E-04,   8.2667837E-05
     +,   6.1660583E-05,   4.5121378E-05,   3.2376069E-05
     +,   2.2767499E-05,   1.5684724E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_nwao_hz_120 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_nwao_hz_60(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  4.3137832E-05,   4.5892204E-05
     +,   4.8769583E-05,   5.1772669E-05,   5.4904434E-05
     +,   5.8167963E-05,   6.1566279E-05,   6.5102759E-05
     +,   6.8780857E-05,   7.2603980E-05,   7.6575823E-05
     +,   8.0700120E-05,   8.4980406E-05,   8.9420384E-05
     +,   9.4023613E-05,   9.8793120E-05,   1.0373183E-04
     +,   1.0884216E-04,   1.1412557E-04,   1.1958301E-04
     +,   1.2521425E-04,   1.3101808E-04,   1.3699148E-04
     +,   1.4313040E-04,   1.4942852E-04,   1.5587805E-04
     +,   1.6246898E-04,   1.6918933E-04,   1.7602452E-04
     +,   1.8295829E-04,   1.8997147E-04,   1.9704338E-04
     +,   2.0415087E-04,   2.1126926E-04,   2.1837185E-04
     +,   2.2543091E-04,   2.3241779E-04,   2.3930280E-04
     +,   2.4605653E-04,   2.5264983E-04,   2.5905384E-04
     +,   2.6524157E-04,   2.7118719E-04,   2.7686730E-04
     +,   2.8226091E-04,   2.8735012E-04,   2.9211963E-04
     +,   2.9655808E-04,   3.0065700E-04,   3.0441163E-04
     +,   3.0782062E-04,   3.1088557E-04,   3.1361089E-04
     +,   3.1600372E-04,   3.1807306E-04,   3.1982968E-04
     +,   3.2128525E-04,   3.2245214E-04,   3.2334260E-04
     +,   3.2396856E-04,   3.2434092E-04,   3.2446935E-04
     +,   3.2436213E-04,   3.2402563E-04,   3.2346463E-04
     +,   3.2268232E-04,   3.2168019E-04,   3.2045890E-04
     +,   3.1901812E-04,   3.1735757E-04,   3.1547702E-04
     +,   3.1337759E-04,   3.1106151E-04,   3.0853369E-04
     +,   3.0580157E-04,   3.0287573E-04,   2.9977071E-04
     +,   2.9650456E-04,   2.9310002E-04,   2.8958352E-04
     +,   2.8598536E-04,   2.8233981E-04,   2.7868379E-04
     +,   2.7505748E-04,   2.7150215E-04,   2.6806086E-04
     +,   2.6477635E-04,   2.6169108E-04,   2.5884548E-04
     +,   2.5627785E-04,   2.5402309E-04,   2.5211199E-04
     +,   2.5057065E-04,   2.4942000E-04,   2.4867515E-04
     +,   2.4834563E-04,   2.4843501E-04,   2.4894081E-04
     +,   2.4985496E-04,   2.5116393E-04,   2.5284942E-04
     +,   2.5488870E-04,   2.5725484E-04,   2.5991825E-04
     +,   2.6284621E-04,   2.6600464E-04,   2.6935805E-04
     +,   2.7286960E-04,   2.7650347E-04,   2.8022315E-04
     +,   2.8399346E-04,   2.8778004E-04,   2.9154983E-04
     +,   2.9527143E-04,   2.9891450E-04,   3.0245126E-04
     +,   3.0585451E-04,   3.0909939E-04,   3.1216230E-04
     +,   3.1502114E-04,   3.1765524E-04,   3.2004510E-04
     +,   3.2217274E-04,   3.2402124E-04,   3.2557501E-04
     +,   3.2681981E-04,   3.2774251E-04,   3.2833169E-04
     +,   3.2857753E-04,   3.2847165E-04,   3.2800788E-04
     +,   3.2718183E-04,   3.2599148E-04,   3.2443734E-04
     +,   3.2252239E-04,   3.2025232E-04,   3.1763583E-04
     +,   3.1468429E-04,   3.1141244E-04,   3.0783773E-04
     +,   3.0398110E-04,   2.9986599E-04,   2.9551881E-04
     +,   2.9096883E-04,   2.8624741E-04,   2.8138881E-04
     +,   2.7642789E-04,   2.7140256E-04,   2.6635072E-04
     +,   2.6131130E-04,   2.5632390E-04,   2.5142677E-04
     +,   2.4665840E-04,   2.4205538E-04,   2.3765264E-04
     +,   2.3348277E-04,   2.2957518E-04,   2.2595678E-04
     +,   2.2264969E-04,   2.1967270E-04,   2.1703998E-04
     +,   2.1476080E-04,   2.1284005E-04,   2.1127713E-04
     +,   2.1006698E-04,   2.0919938E-04,   2.0865943E-04
     +,   2.0842777E-04,   2.0848103E-04,   2.0879159E-04
     +,   2.0932907E-04,   2.1005966E-04,   2.1094763E-04
     +,   2.1195534E-04,   2.1304416E-04,   2.1417464E-04
     +,   2.1530766E-04,   2.1640457E-04,   2.1742804E-04
     +,   2.1834228E-04,   2.1911383E-04,   2.1971171E-04
     +,   2.2010788E-04,   2.2027759E-04,   2.2019958E-04
     +,   2.1985600E-04,   2.1923288E-04,   2.1831991E-04
     +,   2.1711052E-04,   2.1560154E-04,   2.1379344E-04
     +,   2.1168990E-04,   2.0929740E-04,   2.0662583E-04
     +,   2.0368659E-04,   2.0049429E-04,   1.9706455E-04
     +,   1.9341520E-04,   1.8956543E-04,   1.8553455E-04
     +,   1.8134377E-04,   1.7701357E-04,   1.7256560E-04
     +,   1.6802095E-04,   1.6340037E-04,   1.5872486E-04
     +,   1.5401375E-04,   1.4928666E-04,   1.4456183E-04
     +,   1.3985636E-04,   1.3518726E-04,   1.3056902E-04
     +,   1.2601628E-04,   1.2154184E-04,   1.1715743E-04
     +,   1.1287368E-04,   1.0869969E-04,   1.0464423E-04
     +,   1.0071365E-04,   9.6914264E-05,   9.3250761E-05
     +,   8.9726847E-05,   8.6345222E-05,   8.3107516E-05
     +,   8.0014885E-05,   7.7066812E-05,   7.4262789E-05
     +,   7.1601105E-05,   6.9079433E-05,   6.6694862E-05
     +,   6.4443848E-05,   6.2322630E-05,   6.0326489E-05
     +,   5.8450863E-05,   5.6690584E-05,   5.5040320E-05
     +,   5.3494550E-05,   5.2047555E-05,   5.0693689E-05
     +,   4.9427148E-05,   4.8242189E-05,   4.7133119E-05
     +,   4.6094319E-05,   4.5120447E-05,   4.4206077E-05
     +,   4.3346230E-05,   4.2535998E-05,   4.1770698E-05
     +,   4.1046023E-05,   4.0357718E-05,   3.9702005E-05
     +,   3.9075174E-05,   3.8473911E-05,   3.7895192E-05
     +,   3.7336071E-05,   3.6794056E-05,   3.6266727E-05
     +,   3.5752029E-05,   3.5248042E-05,   3.4753051E-05
     +,   3.4265613E-05,   3.3784334E-05,   3.3308112E-05
     +,   3.2835927E-05,   3.2366905E-05,   3.1900301E-05
     +,   3.1435466E-05,   3.0971922E-05,   3.0509200E-05
     +,   3.0046956E-05,   2.9584895E-05,   2.9122777E-05
     +,   2.8660494E-05,   2.8197855E-05,   2.7734848E-05
     +,   2.7271373E-05,   2.6807471E-05,   2.6343141E-05
     +,   2.5878415E-05,   2.5413412E-05,   2.4948151E-05
     +,   2.4482781E-05,   2.4017410E-05,   2.3552142E-05
     +,   2.3087183E-05,   2.2622613E-05,   2.2158672E-05
     +,   2.1695460E-05,   2.1233203E-05,   2.0772130E-05
     +,   2.0312380E-05,   1.9854186E-05,   1.9397741E-05
     +,   1.8943301E-05,   1.8491077E-05,   1.8041297E-05
     +,   1.7594195E-05,   1.7149992E-05,   1.6708960E-05
     +,   1.6271322E-05,   1.5837319E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_nwao_hz_60 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_nwao_hz_65(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  6.5353952E-06,   7.0545630E-06
     +,   7.6045062E-06,   8.1860699E-06,   8.8000870E-06
     +,   9.4473326E-06,   1.0128487E-05,   1.0844207E-05
     +,   1.1595092E-05,   1.2381646E-05,   1.3204350E-05
     +,   1.4063644E-05,   1.4959886E-05,   1.5893440E-05
     +,   1.6864671E-05,   1.7873888E-05,   1.8921475E-05
     +,   2.0007867E-05,   2.1133523E-05,   2.2299058E-05
     +,   2.3505210E-05,   2.4752919E-05,   2.6043263E-05
     +,   2.7377675E-05,   2.8757790E-05,   3.0185651E-05
     +,   3.1663643E-05,   3.3194618E-05,   3.4781802E-05
     +,   3.6429014E-05,   3.8140453E-05,   3.9920989E-05
     +,   4.1776002E-05,   4.3711461E-05,   4.5733796E-05
     +,   4.7850070E-05,   5.0067913E-05,   5.2395266E-05
     +,   5.4840635E-05,   5.7412890E-05,   6.0121045E-05
     +,   6.2974497E-05,   6.5982509E-05,   6.9154470E-05
     +,   7.2499541E-05,   7.6026656E-05,   7.9744088E-05
     +,   8.3659703E-05,   8.7780616E-05,   9.2112772E-05
     +,   9.6661257E-05,   1.0142999E-04,   1.0642115E-04
     +,   1.1163583E-04,   1.1707304E-04,   1.2273039E-04
     +,   1.2860342E-04,   1.3468582E-04,   1.4096944E-04
     +,   1.4744366E-04,   1.5409640E-04,   1.6091300E-04
     +,   1.6787725E-04,   1.7497115E-04,   1.8217442E-04
     +,   1.8946562E-04,   1.9682167E-04,   2.0421797E-04
     +,   2.1162920E-04,   2.1902887E-04,   2.2639014E-04
     +,   2.3368560E-04,   2.4088805E-04,   2.4796996E-04
     +,   2.5490459E-04,   2.6166620E-04,   2.6822966E-04
     +,   2.7457156E-04,   2.8066931E-04,   2.8650241E-04
     +,   2.9205231E-04,   2.9730235E-04,   3.0223804E-04
     +,   3.0684652E-04,   3.1111791E-04,   3.1504349E-04
     +,   3.1861724E-04,   3.2183476E-04,   3.2469339E-04
     +,   3.2719236E-04,   3.2933182E-04,   3.3111341E-04
     +,   3.3253984E-04,   3.3361447E-04,   3.3434143E-04
     +,   3.3472525E-04,   3.3477088E-04,   3.3448360E-04
     +,   3.3386901E-04,   3.3293304E-04,   3.3168183E-04
     +,   3.3012219E-04,   3.2826143E-04,   3.2610790E-04
     +,   3.2367077E-04,   3.2096080E-04,   3.1798976E-04
     +,   3.1477225E-04,   3.1132344E-04,   3.0766218E-04
     +,   3.0380877E-04,   2.9978633E-04,   2.9562053E-04
     +,   2.9133935E-04,   2.8697401E-04,   2.8255658E-04
     +,   2.7812261E-04,   2.7370840E-04,   2.6935193E-04
     +,   2.6509189E-04,   2.6096709E-04,   2.5701677E-04
     +,   2.5327847E-04,   2.4978857E-04,   2.4658145E-04
     +,   2.4368848E-04,   2.4113792E-04,   2.3895406E-04
     +,   2.3715691E-04,   2.3576138E-04,   2.3477772E-04
     +,   2.3421046E-04,   2.3405865E-04,   2.3431586E-04
     +,   2.3497010E-04,   2.3600404E-04,   2.3739532E-04
     +,   2.3911679E-04,   2.4113730E-04,   2.4342176E-04
     +,   2.4593185E-04,   2.4862710E-04,   2.5146501E-04
     +,   2.5440211E-04,   2.5739442E-04,   2.6039811E-04
     +,   2.6337057E-04,   2.6627036E-04,   2.6905822E-04
     +,   2.7169735E-04,   2.7415369E-04,   2.7639695E-04
     +,   2.7839950E-04,   2.8013776E-04,   2.8159178E-04
     +,   2.8274528E-04,   2.8358560E-04,   2.8410327E-04
     +,   2.8429262E-04,   2.8415097E-04,   2.8367835E-04
     +,   2.8287777E-04,   2.8175450E-04,   2.8031608E-04
     +,   2.7857203E-04,   2.7653377E-04,   2.7421405E-04
     +,   2.7162730E-04,   2.6878904E-04,   2.6571637E-04
     +,   2.6242656E-04,   2.5893890E-04,   2.5527284E-04
     +,   2.5144892E-04,   2.4748821E-04,   2.4341236E-04
     +,   2.3924411E-04,   2.3500601E-04,   2.3072115E-04
     +,   2.2641275E-04,   2.2210395E-04,   2.1781815E-04
     +,   2.1357751E-04,   2.0940458E-04,   2.0532045E-04
     +,   2.0134552E-04,   1.9749886E-04,   1.9379801E-04
     +,   1.9025944E-04,   1.8689685E-04,   1.8372292E-04
     +,   1.8074774E-04,   1.7797934E-04,   1.7542379E-04
     +,   1.7308431E-04,   1.7096261E-04,   1.6905753E-04
     +,   1.6736635E-04,   1.6588422E-04,   1.6460424E-04
     +,   1.6351824E-04,   1.6261626E-04,   1.6188744E-04
     +,   1.6131964E-04,   1.6090015E-04,   1.6061564E-04
     +,   1.6045246E-04,   1.6039704E-04,   1.6043569E-04
     +,   1.6055521E-04,   1.6074280E-04,   1.6098635E-04
     +,   1.6127428E-04,   1.6159611E-04,   1.6194195E-04
     +,   1.6230298E-04,   1.6267123E-04,   1.6303953E-04
     +,   1.6340171E-04,   1.6375225E-04,   1.6408633E-04
     +,   1.6439983E-04,   1.6468899E-04,   1.6495059E-04
     +,   1.6518164E-04,   1.6537940E-04,   1.6554112E-04
     +,   1.6566413E-04,   1.6574566E-04,   1.6578278E-04
     +,   1.6577239E-04,   1.6571111E-04,   1.6559527E-04
     +,   1.6542089E-04,   1.6518388E-04,   1.6487962E-04
     +,   1.6450351E-04,   1.6405068E-04,   1.6351618E-04
     +,   1.6289491E-04,   1.6218197E-04,   1.6137239E-04
     +,   1.6046151E-04,   1.5944500E-04,   1.5831865E-04
     +,   1.5707899E-04,   1.5572287E-04,   1.5424773E-04
     +,   1.5265186E-04,   1.5093395E-04,   1.4909377E-04
     +,   1.4713137E-04,   1.4504811E-04,   1.4284602E-04
     +,   1.4052757E-04,   1.3809658E-04,   1.3555703E-04
     +,   1.3291412E-04,   1.3017350E-04,   1.2734132E-04
     +,   1.2442480E-04,   1.2143090E-04,   1.1836771E-04
     +,   1.1524334E-04,   1.1206620E-04,   1.0884494E-04
     +,   1.0558827E-04,   1.0230523E-04,   9.9004545E-05
     +,   9.5694937E-05,   9.2384980E-05,   8.9082918E-05
     +,   8.5797212E-05,   8.2535131E-05,   7.9304526E-05
     +,   7.6111886E-05,   7.2964154E-05,   6.9867237E-05
     +,   6.6826600E-05,   6.3847678E-05,   6.0934541E-05
     +,   5.8091606E-05,   5.5322271E-05,   5.2629464E-05
     +,   5.0016013E-05,   4.7483583E-05,   4.5034136E-05
     +,   4.2668464E-05,   4.0387473E-05,   3.8191673E-05
     +,   3.6080790E-05,   3.4054545E-05,   3.2112195E-05
     +,   3.0252948E-05,   2.8475521E-05,   2.6778485E-05
     +,   2.5160229E-05,   2.3618903E-05,   2.2152675E-05
     +,   2.0759437E-05,   1.9437030E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_nwao_hz_65 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_nwao_hz_70(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  8.8575080E-06,   9.0010899E-06
     +,   9.1424181E-06,   9.2813607E-06,   9.4178104E-06
     +,   9.5516771E-06,   9.6828799E-06,   9.8113660E-06
     +,   9.9371100E-06,   1.0060109E-05,   1.0180398E-05
     +,   1.0298049E-05,   1.0413173E-05,   1.0525931E-05
     +,   1.0636541E-05,   1.0745271E-05,   1.0852467E-05
     +,   1.0958550E-05,   1.1064011E-05,   1.1169441E-05
     +,   1.1275532E-05,   1.1383087E-05,   1.1493017E-05
     +,   1.1606380E-05,   1.1724364E-05,   1.1848306E-05
     +,   1.1979712E-05,   1.2120272E-05,   1.2271832E-05
     +,   1.2436463E-05,   1.2616417E-05,   1.2814176E-05
     +,   1.3032440E-05,   1.3274137E-05,   1.3542420E-05
     +,   1.3840687E-05,   1.4172575E-05,   1.4541944E-05
     +,   1.4952888E-05,   1.5409738E-05,   1.5916999E-05
     +,   1.6479402E-05,   1.7101811E-05,   1.7789269E-05
     +,   1.8546913E-05,   1.9379984E-05,   2.0293704E-05
     +,   2.1293336E-05,   2.2384089E-05,   2.3570979E-05
     +,   2.4858928E-05,   2.6252588E-05,   2.7756245E-05
     +,   2.9373905E-05,   3.1108983E-05,   3.2964464E-05
     +,   3.4942685E-05,   3.7045305E-05,   3.9273273E-05
     +,   4.1626590E-05,   4.4104545E-05,   4.6705318E-05
     +,   4.9426239E-05,   5.2263658E-05,   5.5212706E-05
     +,   5.8267658E-05,   6.1421757E-05,   6.4667045E-05
     +,   6.7994821E-05,   7.1395392E-05,   7.4858253E-05
     +,   7.8372184E-05,   8.1925507E-05,   8.5505635E-05
     +,   8.9100118E-05,   9.2696209E-05,   9.6281183E-05
     +,   9.9842713E-05,   1.0336845E-04,   1.0684714E-04
     +,   1.1026820E-04,   1.1362212E-04,   1.1690072E-04
     +,   1.2009680E-04,   1.2320557E-04,   1.2622318E-04
     +,   1.2914807E-04,   1.3198057E-04,   1.3472307E-04
     +,   1.3738005E-04,   1.3995777E-04,   1.4246484E-04
     +,   1.4491173E-04,   1.4731071E-04,   1.4967575E-04
     +,   1.5202237E-04,   1.5436762E-04,   1.5672912E-04
     +,   1.5912591E-04,   1.6157741E-04,   1.6410345E-04
     +,   1.6672410E-04,   1.6945886E-04,   1.7232724E-04
     +,   1.7534784E-04,   1.7853844E-04,   1.8191570E-04
     +,   1.8549433E-04,   1.8928833E-04,   1.9330884E-04
     +,   1.9756547E-04,   2.0206528E-04,   2.0681285E-04
     +,   2.1181005E-04,   2.1705496E-04,   2.2254397E-04
     +,   2.2826856E-04,   2.3421754E-04,   2.4037599E-04
     +,   2.4672531E-04,   2.5324372E-04,   2.5990518E-04
     +,   2.6668143E-04,   2.7354129E-04,   2.8045118E-04
     +,   2.8737597E-04,   2.9428027E-04,   3.0112770E-04
     +,   3.0788357E-04,   3.1451500E-04,   3.2099185E-04
     +,   3.2728762E-04,   3.3338086E-04,   3.3925410E-04
     +,   3.4489637E-04,   3.5030206E-04,   3.5547116E-04
     +,   3.6040848E-04,   3.6512301E-04,   3.6962755E-04
     +,   3.7393547E-04,   3.7806097E-04,   3.8201665E-04
     +,   3.8581120E-04,   3.8944854E-04,   3.9292476E-04
     +,   3.9622851E-04,   3.9933843E-04,   4.0222390E-04
     +,   4.0484403E-04,   4.0714850E-04,   4.0907942E-04
     +,   4.1057222E-04,   4.1155881E-04,   4.1196976E-04
     +,   4.1173768E-04,   4.1080080E-04,   4.0910658E-04
     +,   4.0661375E-04,   4.0329693E-04,   3.9914803E-04
     +,   3.9417832E-04,   3.8842051E-04,   3.8192657E-04
     +,   3.7477075E-04,   3.6704497E-04,   3.5885861E-04
     +,   3.5033468E-04,   3.4160601E-04,   3.3281342E-04
     +,   3.2409714E-04,   3.1559780E-04,   3.0744780E-04
     +,   2.9976957E-04,   2.9267147E-04,   2.8624461E-04
     +,   2.8056159E-04,   2.7567323E-04,   2.7160911E-04
     +,   2.6837719E-04,   2.6596454E-04,   2.6433868E-04
     +,   2.6344936E-04,   2.6323146E-04,   2.6360704E-04
     +,   2.6448877E-04,   2.6578264E-04,   2.6739109E-04
     +,   2.6921538E-04,   2.7115902E-04,   2.7312888E-04
     +,   2.7503827E-04,   2.7680752E-04,   2.7836583E-04
     +,   2.7965201E-04,   2.8061442E-04,   2.8121180E-04
     +,   2.8141291E-04,   2.8119620E-04,   2.8054931E-04
     +,   2.7946854E-04,   2.7795826E-04,   2.7603001E-04
     +,   2.7370162E-04,   2.7099680E-04,   2.6794442E-04
     +,   2.6457693E-04,   2.6093097E-04,   2.5704570E-04
     +,   2.5296223E-04,   2.4872407E-04,   2.4437430E-04
     +,   2.3995763E-04,   2.3551760E-04,   2.3109713E-04
     +,   2.2673745E-04,   2.2247763E-04,   2.1835446E-04
     +,   2.1440058E-04,   2.1064581E-04,   2.0711507E-04
     +,   2.0382876E-04,   2.0080258E-04,   1.9804650E-04
     +,   1.9556590E-04,   1.9335975E-04,   1.9142250E-04
     +,   1.8974280E-04,   1.8830464E-04,   1.8708705E-04
     +,   1.8606510E-04,   1.8521007E-04,   1.8449008E-04
     +,   1.8387075E-04,   1.8331599E-04,   1.8278847E-04
     +,   1.8225046E-04,   1.8166455E-04,   1.8099442E-04
     +,   1.8020523E-04,   1.7926427E-04,   1.7814190E-04
     +,   1.7681140E-04,   1.7525000E-04,   1.7343841E-04
     +,   1.7136201E-04,   1.6901015E-04,   1.6637653E-04
     +,   1.6345960E-04,   1.6026130E-04,   1.5678852E-04
     +,   1.5305095E-04,   1.4906256E-04,   1.4484055E-04
     +,   1.4040396E-04,   1.3577547E-04,   1.3097834E-04
     +,   1.2603855E-04,   1.2098245E-04,   1.1583700E-04
     +,   1.1063009E-04,   1.0538817E-04,   1.0013850E-04
     +,   9.4906623E-05,   8.9717221E-05,   8.4593521E-05
     +,   7.9556929E-05,   7.4627707E-05,   6.9823545E-05
     +,   6.5160370E-05,   6.0652026E-05,   5.6310124E-05
     +,   5.2144849E-05,   4.8163241E-05,   4.4371624E-05
     +,   4.0773280E-05,   3.7370733E-05,   3.4164288E-05
     +,   3.1152791E-05,   2.8334172E-05,   2.5704392E-05
     +,   2.3259061E-05,   2.0992478E-05,   1.8898189E-05
     +,   1.6969407E-05,   1.5198326E-05,   1.3577333E-05
     +,   1.2098028E-05,   1.0752248E-05,   9.5317273E-06
     +,   8.4280091E-06,   7.4329328E-06,   6.5384379E-06
     +,   5.7367956E-06,   5.0204535E-06,   4.3822120E-06
     +,   3.8152180E-06,   3.3129641E-06,   2.8693853E-06
     +,   2.4787446E-06,   2.1357187E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_nwao_hz_70 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_nwao_hz_75(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  8.1855305E-06,   8.3285713E-06
     +,   8.4698122E-06,   8.6090749E-06,   8.7461895E-06
     +,   8.8809893E-06,   9.0133008E-06,   9.1429602E-06
     +,   9.2698074E-06,   9.3936760E-06,   9.5144169E-06
     +,   9.6318772E-06,   9.7459115E-06,   9.8563805E-06
     +,   9.9631588E-06,   1.0066117E-05,   1.0165145E-05
     +,   1.0260138E-05,   1.0351001E-05,   1.0437656E-05
     +,   1.0520033E-05,   1.0598084E-05,   1.0671769E-05
     +,   1.0741070E-05,   1.0805986E-05,   1.0866539E-05
     +,   1.0922769E-05,   1.0974746E-05,   1.1022560E-05
     +,   1.1066333E-05,   1.1106215E-05,   1.1142383E-05
     +,   1.1175058E-05,   1.1204487E-05,   1.1230960E-05
     +,   1.1254802E-05,   1.1276385E-05,   1.1296114E-05
     +,   1.1314451E-05,   1.1331897E-05,   1.1348996E-05
     +,   1.1366351E-05,   1.1384601E-05,   1.1404436E-05
     +,   1.1426602E-05,   1.1451881E-05,   1.1481106E-05
     +,   1.1515149E-05,   1.1554925E-05,   1.1601384E-05
     +,   1.1655507E-05,   1.1718307E-05,   1.1790808E-05
     +,   1.1874063E-05,   1.1969113E-05,   1.2077014E-05
     +,   1.2198806E-05,   1.2335510E-05,   1.2488124E-05
     +,   1.2657596E-05,   1.2844843E-05,   1.3050707E-05
     +,   1.3275977E-05,   1.3521373E-05,   1.3787522E-05
     +,   1.4074978E-05,   1.4384217E-05,   1.4715612E-05
     +,   1.5069476E-05,   1.5446047E-05,   1.5845506E-05
     +,   1.6268006E-05,   1.6713702E-05,   1.7182725E-05
     +,   1.7675315E-05,   1.8191806E-05,   1.8732708E-05
     +,   1.9298761E-05,   1.9890949E-05,   2.0510701E-05
     +,   2.1159871E-05,   2.1840862E-05,   2.2556760E-05
     +,   2.3311246E-05,   2.4109053E-05,   2.4955591E-05
     +,   2.5857416E-05,   2.6822114E-05,   2.7858392E-05
     +,   2.8976167E-05,   3.0186431E-05,   3.1501477E-05
     +,   3.2934702E-05,   3.4500608E-05,   3.6214675E-05
     +,   3.8093218E-05,   4.0153402E-05,   4.2412546E-05
     +,   4.4888537E-05,   4.7599144E-05,   5.0561837E-05
     +,   5.3793668E-05,   5.7310324E-05,   6.1126637E-05
     +,   6.5255728E-05,   6.9708818E-05,   7.4495088E-05
     +,   7.9620535E-05,   8.5089734E-05,   9.0902926E-05
     +,   9.7058095E-05,   1.0354981E-04,   1.1036947E-04
     +,   1.1750545E-04,   1.2494186E-04,   1.3266188E-04
     +,   1.4064378E-04,   1.4886458E-04,   1.5729881E-04
     +,   1.6591931E-04,   1.7469788E-04,   1.8360473E-04
     +,   1.9261081E-04,   2.0168720E-04,   2.1080623E-04
     +,   2.1994193E-04,   2.2907120E-04,   2.3817310E-04
     +,   2.4723139E-04,   2.5623385E-04,   2.6517277E-04
     +,   2.7404574E-04,   2.8285562E-04,   2.9160915E-04
     +,   3.0031899E-04,   3.0900128E-04,   3.1767561E-04
     +,   3.2636343E-04,   3.3508684E-04,   3.4386752E-04
     +,   3.5272341E-04,   3.6166841E-04,   3.7070978E-04
     +,   3.7984646E-04,   3.8906725E-04,   3.9834861E-04
     +,   4.0765648E-04,   4.1694159E-04,   4.2614370E-04
     +,   4.3519036E-04,   4.4399730E-04,   4.5247446E-04
     +,   4.6052402E-04,   4.6804763E-04,   4.7494803E-04
     +,   4.8113335E-04,   4.8652259E-04,   4.9104640E-04
     +,   4.9465417E-04,   4.9731421E-04,   4.9901701E-04
     +,   4.9977569E-04,   4.9962680E-04,   4.9862848E-04
     +,   4.9685914E-04,   4.9441354E-04,   4.9139961E-04
     +,   4.8793413E-04,   4.8413675E-04,   4.8012708E-04
     +,   4.7601765E-04,   4.7191218E-04,   4.6790022E-04
     +,   4.6405519E-04,   4.6043194E-04,   4.5706760E-04
     +,   4.5397994E-04,   4.5116924E-04,   4.4861963E-04
     +,   4.4630110E-04,   4.4417247E-04,   4.4218355E-04
     +,   4.4027675E-04,   4.3839097E-04,   4.3646226E-04
     +,   4.3442586E-04,   4.3221773E-04,   4.2977504E-04
     +,   4.2703818E-04,   4.2394994E-04,   4.2045832E-04
     +,   4.1651580E-04,   4.1208082E-04,   4.0711946E-04
     +,   4.0160530E-04,   3.9552271E-04,   3.8886489E-04
     +,   3.8163812E-04,   3.7386094E-04,   3.6556300E-04
     +,   3.5678860E-04,   3.4759153E-04,   3.3803887E-04
     +,   3.2820570E-04,   3.1817466E-04,   3.0803532E-04
     +,   2.9787753E-04,   2.8779425E-04,   2.7787508E-04
     +,   2.6820533E-04,   2.5886536E-04,   2.4992492E-04
     +,   2.4144672E-04,   2.3348129E-04,   2.2606841E-04
     +,   2.1923622E-04,   2.1300119E-04,   2.0736945E-04
     +,   2.0233518E-04,   1.9788428E-04,   1.9399311E-04
     +,   1.9063060E-04,   1.8775903E-04,   1.8533545E-04
     +,   1.8331291E-04,   1.8164075E-04,   1.8026706E-04
     +,   1.7913847E-04,   1.7820172E-04,   1.7740451E-04
     +,   1.7669615E-04,   1.7602835E-04,   1.7535572E-04
     +,   1.7463663E-04,   1.7383321E-04,   1.7291204E-04
     +,   1.7184425E-04,   1.7060565E-04,   1.6917703E-04
     +,   1.6754378E-04,   1.6569598E-04,   1.6362827E-04
     +,   1.6133944E-04,   1.5883257E-04,   1.5611366E-04
     +,   1.5319267E-04,   1.5008188E-04,   1.4679579E-04
     +,   1.4335150E-04,   1.3976646E-04,   1.3606031E-04
     +,   1.3225219E-04,   1.2836226E-04,   1.2441058E-04
     +,   1.2041597E-04,   1.1639764E-04,   1.1237268E-04
     +,   1.0835824E-04,   1.0436946E-04,   1.0042021E-04
     +,   9.6523589E-05,   9.2690156E-05,   8.8930057E-05
     +,   8.5251573E-05,   8.1661652E-05,   7.8166071E-05
     +,   7.4769261E-05,   7.1474962E-05,   6.8285517E-05
     +,   6.5202541E-05,   6.2226849E-05,   5.9358445E-05
     +,   5.6597197E-05,   5.3941687E-05,   5.1390904E-05
     +,   4.8942664E-05,   4.6595171E-05,   4.4346001E-05
     +,   4.2192503E-05,   4.0132240E-05,   3.8162070E-05
     +,   3.6279296E-05,   3.4480858E-05,   3.2763652E-05
     +,   3.1124808E-05,   2.9561017E-05,   2.8069451E-05
     +,   2.6646854E-05,   2.5290339E-05,   2.3997058E-05
     +,   2.2763981E-05,   2.1588332E-05,   2.0467356E-05
     +,   1.9398494E-05,   1.8379167E-05,   1.7406945E-05
     +,   1.6479511E-05,   1.5594625E-05,   1.4750277E-05
     +,   1.3944465E-05,   1.3175345E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_nwao_hz_75 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_nwao_hz_80(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  1.0235668E-06,   1.1049456E-06
     +,   1.1917922E-06,   1.2843865E-06,   1.3830198E-06
     +,   1.4879920E-06,   1.5996045E-06,   1.7181712E-06
     +,   1.8440134E-06,   1.9774511E-06,   2.1188155E-06
     +,   2.2684453E-06,   2.4266722E-06,   2.5938405E-06
     +,   2.7702979E-06,   2.9563828E-06,   3.1524442E-06
     +,   3.3588306E-06,   3.5758762E-06,   3.8039266E-06
     +,   4.0433160E-06,   4.2943784E-06,   4.5574275E-06
     +,   4.8327875E-06,   5.1207517E-06,   5.4216193E-06
     +,   5.7356692E-06,   6.0631733E-06,   6.4043702E-06
     +,   6.7595047E-06,   7.1287791E-06,   7.5123939E-06
     +,   7.9105221E-06,   8.3233253E-06,   8.7509161E-06
     +,   9.1934116E-06,   9.6509002E-06,   1.0123427E-05
     +,   1.0611034E-05,   1.1113741E-05,   1.1631524E-05
     +,   1.2164365E-05,   1.2712196E-05,   1.3274957E-05
     +,   1.3852560E-05,   1.4444920E-05,   1.5051904E-05
     +,   1.5673408E-05,   1.6309326E-05,   1.6959517E-05
     +,   1.7623879E-05,   1.8302331E-05,   1.8994762E-05
     +,   1.9701136E-05,   2.0421390E-05,   2.1155538E-05
     +,   2.1903619E-05,   2.2665714E-05,   2.3441979E-05
     +,   2.4232566E-05,   2.5037758E-05,   2.5857849E-05
     +,   2.6693231E-05,   2.7544394E-05,   2.8411847E-05
     +,   2.9296223E-05,   3.0198242E-05,   3.1118656E-05
     +,   3.2058368E-05,   3.3018321E-05,   3.3999553E-05
     +,   3.5003184E-05,   3.6030444E-05,   3.7082529E-05
     +,   3.8160793E-05,   3.9266648E-05,   4.0401534E-05
     +,   4.1567000E-05,   4.2764495E-05,   4.3995627E-05
     +,   4.5262001E-05,   4.6565201E-05,   4.7906909E-05
     +,   4.9288570E-05,   5.0711951E-05,   5.2178453E-05
     +,   5.3689622E-05,   5.5246885E-05,   5.6851608E-05
     +,   5.8505102E-05,   6.0208393E-05,   6.1962543E-05
     +,   6.3768428E-05,   6.5626678E-05,   6.7537796E-05
     +,   6.9501999E-05,   7.1519360E-05,   7.3589421E-05
     +,   7.5711650E-05,   7.7885103E-05,   8.0108475E-05
     +,   8.2380167E-05,   8.4697960E-05,   8.7059423E-05
     +,   8.9461690E-05,   9.1901420E-05,   9.4375042E-05
     +,   9.6878161E-05,   9.9406709E-05,   1.0195567E-04
     +,   1.0452013E-04,   1.0709492E-04,   1.0967477E-04
     +,   1.1225444E-04,   1.1482847E-04,   1.1739229E-04
     +,   1.1994092E-04,   1.2247027E-04,   1.2497678E-04
     +,   1.2745764E-04,   1.2991094E-04,   1.3233561E-04
     +,   1.3473199E-04,   1.3710154E-04,   1.3944725E-04
     +,   1.4177345E-04,   1.4408617E-04,   1.4639289E-04
     +,   1.4870294E-04,   1.5102721E-04,   1.5337829E-04
     +,   1.5577035E-04,   1.5821910E-04,   1.6074137E-04
     +,   1.6335541E-04,   1.6608031E-04,   1.6893588E-04
     +,   1.7194219E-04,   1.7511935E-04,   1.7848703E-04
     +,   1.8206377E-04,   1.8586706E-04,   1.8991216E-04
     +,   1.9421226E-04,   1.9877766E-04,   2.0361476E-04
     +,   2.0872749E-04,   2.1411454E-04,   2.1977141E-04
     +,   2.2568935E-04,   2.3185495E-04,   2.3825285E-04
     +,   2.4486278E-04,   2.5166312E-04,   2.5863055E-04
     +,   2.6574099E-04,   2.7297132E-04,   2.8029864E-04
     +,   2.8770461E-04,   2.9517250E-04,   3.0269084E-04
     +,   3.1025321E-04,   3.1785658E-04,   3.2550504E-04
     +,   3.3320466E-04,   3.4096622E-04,   3.4880204E-04
     +,   3.5672469E-04,   3.6474556E-04,   3.7287106E-04
     +,   3.8110389E-04,   3.8943678E-04,   3.9785396E-04
     +,   4.0632844E-04,   4.1482074E-04,   4.2327947E-04
     +,   4.3164013E-04,   4.3982788E-04,   4.4775818E-04
     +,   4.5533926E-04,   4.6247558E-04,   4.6906952E-04
     +,   4.7502815E-04,   4.8026314E-04,   4.8469723E-04
     +,   4.8826585E-04,   4.9092079E-04,   4.9263192E-04
     +,   4.9338810E-04,   4.9319823E-04,   4.9209106E-04
     +,   4.9011328E-04,   4.8732769E-04,   4.8381154E-04
     +,   4.7965220E-04,   4.7494532E-04,   4.6978981E-04
     +,   4.6428648E-04,   4.5853484E-04,   4.5262903E-04
     +,   4.4665867E-04,   4.4070478E-04,   4.3484184E-04
     +,   4.2913604E-04,   4.2364516E-04,   4.1842170E-04
     +,   4.1351028E-04,   4.0895163E-04,   4.0478143E-04
     +,   4.0103131E-04,   3.9772989E-04,   3.9490103E-04
     +,   3.9256547E-04,   3.9073845E-04,   3.8942971E-04
     +,   3.8864202E-04,   3.8837109E-04,   3.8860389E-04
     +,   3.8931906E-04,   3.9048656E-04,   3.9206870E-04
     +,   3.9402058E-04,   3.9629213E-04,   3.9883016E-04
     +,   4.0157966E-04,   4.0448780E-04,   4.0750415E-04
     +,   4.1058465E-04,   4.1369183E-04,   4.1679639E-04
     +,   4.1987788E-04,   4.2292345E-04,   4.2592795E-04
     +,   4.2889098E-04,   4.3181569E-04,   4.3470514E-04
     +,   4.3755994E-04,   4.4037538E-04,   4.4313812E-04
     +,   4.4582505E-04,   4.4840094E-04,   4.5081775E-04
     +,   4.5301445E-04,   4.5491836E-04,   4.5644699E-04
     +,   4.5750965E-04,   4.5801187E-04,   4.5785774E-04
     +,   4.5695514E-04,   4.5521819E-04,   4.5257236E-04
     +,   4.4895610E-04,   4.4432556E-04,   4.3865546E-04
     +,   4.3193993E-04,   4.2419482E-04,   4.1545386E-04
     +,   4.0577198E-04,   3.9521939E-04,   3.8388112E-04
     +,   3.7185501E-04,   3.5924435E-04,   3.4616102E-04
     +,   3.3271665E-04,   3.1902225E-04,   3.0518536E-04
     +,   2.9130653E-04,   2.7748017E-04,   2.6378973E-04
     +,   2.5030901E-04,   2.3710121E-04,   2.2421831E-04
     +,   2.1170414E-04,   1.9958951E-04,   1.8790031E-04
     +,   1.7665111E-04,   1.6585289E-04,   1.5550955E-04
     +,   1.4562040E-04,   1.3618283E-04,   1.2718912E-04
     +,   1.1863206E-04,   1.1050173E-04,   1.0278741E-04
     +,   9.5479067E-05,   8.8564295E-05,   8.2032770E-05
     +,   7.5872013E-05,   7.0070870E-05,   6.4618107E-05
     +,   5.9501221E-05,   5.4708376E-05,   5.0227194E-05
     +,   4.6045570E-05,   4.2150645E-05,   3.8529557E-05
     +,   3.5169280E-05,   3.2056570E-05,   2.9178518E-05
     +,   2.6521902E-05,   2.4073746E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_nwao_hz_80 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_nwao_hz_85(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  1.1381522E-06,   1.2078923E-06
     +,   1.2809853E-06,   1.3575263E-06,   1.4376132E-06
     +,   1.5213429E-06,   1.6088061E-06,   1.7000973E-06
     +,   1.7953080E-06,   1.8945234E-06,   1.9978320E-06
     +,   2.1053183E-06,   2.2170616E-06,   2.3331413E-06
     +,   2.4536366E-06,   2.5786160E-06,   2.7081533E-06
     +,   2.8423187E-06,   2.9811731E-06,   3.1247812E-06
     +,   3.2732034E-06,   3.4265033E-06,   3.5847297E-06
     +,   3.7479447E-06,   3.9161955E-06,   4.0895379E-06
     +,   4.2680258E-06,   4.4517146E-06,   4.6406526E-06
     +,   4.8348993E-06,   5.0345070E-06,   5.2395394E-06
     +,   5.4500597E-06,   5.6661420E-06,   5.8878522E-06
     +,   6.1152746E-06,   6.3485031E-06,   6.5876256E-06
     +,   6.8327554E-06,   7.0840119E-06,   7.3415194E-06
     +,   7.6054325E-06,   7.8758976E-06,   8.1530970E-06
     +,   8.4372186E-06,   8.7284834E-06,   9.0271069E-06
     +,   9.3333483E-06,   9.6474878E-06,   9.9698082E-06
     +,   1.0300640E-05,   1.0640335E-05,   1.0989255E-05
     +,   1.1347814E-05,   1.1716428E-05,   1.2095563E-05
     +,   1.2485703E-05,   1.2887369E-05,   1.3301114E-05
     +,   1.3727497E-05,   1.4167141E-05,   1.4620661E-05
     +,   1.5088726E-05,   1.5572035E-05,   1.6071283E-05
     +,   1.6587212E-05,   1.7120585E-05,   1.7672161E-05
     +,   1.8242736E-05,   1.8833103E-05,   1.9444076E-05
     +,   2.0076457E-05,   2.0731077E-05,   2.1408678E-05
     +,   2.2110069E-05,   2.2836006E-05,   2.3587214E-05
     +,   2.4364428E-05,   2.5168221E-05,   2.5999225E-05
     +,   2.6857970E-05,   2.7744913E-05,   2.8660472E-05
     +,   2.9604824E-05,   3.0578303E-05,   3.1580876E-05
     +,   3.2612541E-05,   3.3673132E-05,   3.4762339E-05
     +,   3.5879762E-05,   3.7024711E-05,   3.8196467E-05
     +,   3.9394115E-05,   4.0616567E-05,   4.1862568E-05
     +,   4.3130698E-05,   4.4419405E-05,   4.5726836E-05
     +,   4.7051133E-05,   4.8390204E-05,   4.9741844E-05
     +,   5.1103743E-05,   5.2473326E-05,   5.3848064E-05
     +,   5.5225286E-05,   5.6602243E-05,   5.7976205E-05
     +,   5.9344202E-05,   6.0703602E-05,   6.2051455E-05
     +,   6.3385050E-05,   6.4701715E-05,   6.5998829E-05
     +,   6.7273984E-05,   6.8524692E-05,   6.9748996E-05
     +,   7.0944763E-05,   7.2110262E-05,   7.3243966E-05
     +,   7.4344520E-05,   7.5410906E-05,   7.6442215E-05
     +,   7.7437900E-05,   7.8397665E-05,   7.9321399E-05
     +,   8.0209276E-05,   8.1061720E-05,   8.1879269E-05
     +,   8.2662751E-05,   8.3413142E-05,   8.4131563E-05
     +,   8.4819279E-05,   8.5477666E-05,   8.6108157E-05
     +,   8.6712258E-05,   8.7291526E-05,   8.7847511E-05
     +,   8.8381763E-05,   8.8895787E-05,   8.9391047E-05
     +,   8.9868889E-05,   9.0330606E-05,   9.0777336E-05
     +,   9.1210110E-05,   9.1629823E-05,   9.2037095E-05
     +,   9.2432507E-05,   9.2816299E-05,   9.3188610E-05
     +,   9.3549330E-05,   9.3898190E-05,   9.4234842E-05
     +,   9.4558753E-05,   9.4869582E-05,   9.5167066E-05
     +,   9.5451389E-05,   9.5723357E-05,   9.5984746E-05
     +,   9.6238691E-05,   9.6490221E-05,   9.6746706E-05
     +,   9.7018499E-05,   9.7319651E-05,   9.7668584E-05
     +,   9.8088727E-05,   9.8609264E-05,   9.9265599E-05
     +,   1.0009984E-04,   1.0116118E-04,   1.0250556E-04
     +,   1.0419599E-04,   1.0630119E-04,   1.0889536E-04
     +,   1.1205659E-04,   1.1586537E-04,   1.2040295E-04
     +,   1.2574872E-04,   1.3197913E-04,   1.3916545E-04
     +,   1.4737149E-04,   1.5665332E-04,   1.6705586E-04
     +,   1.7861673E-04,   1.9136080E-04,   2.0530484E-04
     +,   2.2045609E-04,   2.3681359E-04,   2.5436937E-04
     +,   2.7310537E-04,   2.9300066E-04,   3.1402032E-04
     +,   3.3612177E-04,   3.5924904E-04,   3.8332571E-04
     +,   4.0826175E-04,   4.3393593E-04,   4.6020935E-04
     +,   4.8691031E-04,   5.1384192E-04,   5.4079061E-04
     +,   5.6751817E-04,   5.9378473E-04,   6.1934342E-04
     +,   6.4396078E-04,   6.6742132E-04,   6.8953232E-04
     +,   7.1013888E-04,   7.2911405E-04,   7.4636767E-04
     +,   7.6183648E-04,   7.7547843E-04,   7.8726752E-04
     +,   7.9718069E-04,   8.0519536E-04,   8.1128487E-04
     +,   8.1541715E-04,   8.1756251E-04,   8.1770105E-04
     +,   8.1583549E-04,   8.1200688E-04,   8.0630690E-04
     +,   7.9888973E-04,   7.8998011E-04,   7.7987084E-04
     +,   7.6891866E-04,   7.5752445E-04,   7.4611715E-04
     +,   7.3512219E-04,   7.2493480E-04,   7.1589177E-04
     +,   7.0824981E-04,   7.0216868E-04,   6.9770403E-04
     +,   6.9481554E-04,   6.9337804E-04,   6.9320714E-04
     +,   6.9408707E-04,   6.9580146E-04,   6.9816114E-04
     +,   7.0102658E-04,   7.0432079E-04,   7.0803007E-04
     +,   7.1219524E-04,   7.1689056E-04,   7.2219910E-04
     +,   7.2818034E-04,   7.3484000E-04,   7.4210664E-04
     +,   7.4981170E-04,   7.5768586E-04,   7.6536066E-04
     +,   7.7238661E-04,   7.7825534E-04,   7.8243134E-04
     +,   7.8438659E-04,   7.8363396E-04,   7.7975699E-04
     +,   7.7243522E-04,   7.6146203E-04,   7.4675173E-04
     +,   7.2834553E-04,   7.0639706E-04,   6.8117067E-04
     +,   6.5301632E-04,   6.2235462E-04,   5.8965420E-04
     +,   5.5541086E-04,   5.2013149E-04,   4.8431085E-04
     +,   4.4841910E-04,   4.1289002E-04,   3.7810975E-04
     +,   3.4441677E-04,   3.1208512E-04,   2.8134184E-04
     +,   2.5234898E-04,   2.2522455E-04,   2.0003437E-04
     +,   1.7680234E-04,   1.5551969E-04,   1.3614203E-04
     +,   1.1860638E-04,   1.0282861E-04,   8.8711546E-05
     +,   7.6151184E-05,   6.5034990E-05,   5.5251912E-05
     +,   4.6688012E-05,   3.9233742E-05,   3.2782780E-05
     +,   2.7232105E-05,   2.2485096E-05,   1.8450504E-05
     +,   1.5043707E-05,   1.2185970E-05,   9.8051660E-06
     +,   7.8356343E-06,   6.2180188E-06,   4.8993475E-06
     +,   3.8324388E-06,   2.9758655E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_nwao_hz_85 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_nwao_hz_90(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  6.3995429E-07,   6.8438976E-07
     +,   7.3139722E-07,   7.8108440E-07,   8.3356355E-07
     +,   8.8894848E-07,   9.4735191E-07,   1.0088902E-06
     +,   1.0736827E-06,   1.1418439E-06,   1.2134939E-06
     +,   1.2887531E-06,   1.3677379E-06,   1.4505692E-06
     +,   1.5373660E-06,   1.6282443E-06,   1.7233220E-06
     +,   1.8227161E-06,   1.9265372E-06,   2.0348982E-06
     +,   2.1479084E-06,   2.2656761E-06,   2.3883006E-06
     +,   2.5158852E-06,   2.6485209E-06,   2.7863009E-06
     +,   2.9293114E-06,   3.0776359E-06,   3.2313435E-06
     +,   3.3905110E-06,   3.5551927E-06,   3.7254495E-06
     +,   3.9013275E-06,   4.0828727E-06,   4.2701104E-06
     +,   4.4630674E-06,   4.6617643E-06,   4.8661996E-06
     +,   5.0763720E-06,   5.2922746E-06,   5.5138762E-06
     +,   5.7411503E-06,   5.9740446E-06,   6.2125087E-06
     +,   6.4564779E-06,   6.7058795E-06,   6.9606162E-06
     +,   7.2205917E-06,   7.4857030E-06,   7.7558179E-06
     +,   8.0308073E-06,   8.3105333E-06,   8.5948323E-06
     +,   8.8835477E-06,   9.1764950E-06,   9.4734933E-06
     +,   9.7743477E-06,   1.0078857E-05,   1.0386814E-05
     +,   1.0697989E-05,   1.1012169E-05,   1.1329110E-05
     +,   1.1648583E-05,   1.1970353E-05,   1.2294163E-05
     +,   1.2619781E-05,   1.2946965E-05,   1.3275465E-05
     +,   1.3605044E-05,   1.3935472E-05,   1.4266519E-05
     +,   1.4597962E-05,   1.4929608E-05,   1.5261236E-05
     +,   1.5592677E-05,   1.5923761E-05,   1.6254346E-05
     +,   1.6584314E-05,   1.6913538E-05,   1.7241959E-05
     +,   1.7569517E-05,   1.7896207E-05,   1.8222043E-05
     +,   1.8547047E-05,   1.8871346E-05,   1.9195028E-05
     +,   1.9518273E-05,   1.9841282E-05,   2.0164314E-05
     +,   2.0487667E-05,   2.0811663E-05,   2.1136697E-05
     +,   2.1463200E-05,   2.1791659E-05,   2.2122586E-05
     +,   2.2456557E-05,   2.2794196E-05,   2.3136134E-05
     +,   2.3483062E-05,   2.3835717E-05,   2.4194856E-05
     +,   2.4561283E-05,   2.4935774E-05,   2.5319181E-05
     +,   2.5712345E-05,   2.6116119E-05,   2.6531381E-05
     +,   2.6958931E-05,   2.7399690E-05,   2.7854439E-05
     +,   2.8324008E-05,   2.8809201E-05,   2.9310777E-05
     +,   2.9829491E-05,   3.0365998E-05,   3.0921045E-05
     +,   3.1495209E-05,   3.2089112E-05,   3.2703349E-05
     +,   3.3338467E-05,   3.3995035E-05,   3.4673547E-05
     +,   3.5374560E-05,   3.6098641E-05,   3.6846377E-05
     +,   3.7618414E-05,   3.8415492E-05,   3.9238344E-05
     +,   4.0087914E-05,   4.0965224E-05,   4.1871466E-05
     +,   4.2807984E-05,   4.3776352E-05,   4.4778251E-05
     +,   4.5815650E-05,   4.6890749E-05,   4.8005961E-05
     +,   4.9163922E-05,   5.0367522E-05,   5.1619882E-05
     +,   5.2924199E-05,   5.4283966E-05,   5.5702767E-05
     +,   5.7184265E-05,   5.8732236E-05,   6.0350194E-05
     +,   6.2041967E-05,   6.3810803E-05,   6.5659959E-05
     +,   6.7592344E-05,   6.9610163E-05,   7.1715614E-05
     +,   7.3909738E-05,   7.6193166E-05,   7.8565652E-05
     +,   8.1026003E-05,   8.3572151E-05,   8.6200555E-05
     +,   8.8907203E-05,   9.1686190E-05,   9.4530762E-05
     +,   9.7432938E-05,   1.0038298E-04,   1.0337074E-04
     +,   1.0638409E-04,   1.0941029E-04,   1.1243553E-04
     +,   1.1544525E-04,   1.1842448E-04,   1.2135749E-04
     +,   1.2422939E-04,   1.2702498E-04,   1.2973032E-04
     +,   1.3233272E-04,   1.3482130E-04,   1.3718772E-04
     +,   1.3942631E-04,   1.4153530E-04,   1.4351704E-04
     +,   1.4537845E-04,   1.4713200E-04,   1.4879524E-04
     +,   1.5039228E-04,   1.5195270E-04,   1.5351224E-04
     +,   1.5511211E-04,   1.5679827E-04,   1.5862081E-04
     +,   1.6063220E-04,   1.6288678E-04,   1.6543803E-04
     +,   1.6833826E-04,   1.7163705E-04,   1.7538040E-04
     +,   1.7961260E-04,   1.8437621E-04,   1.8971795E-04
     +,   1.9569219E-04,   2.0236880E-04,   2.0984390E-04
     +,   2.1824625E-04,   2.2775117E-04,   2.3858450E-04
     +,   2.5103122E-04,   2.6543482E-04,   2.8219007E-04
     +,   3.0173705E-04,   3.2453393E-04,   3.5103981E-04
     +,   3.8168358E-04,   4.1682716E-04,   4.5674917E-04
     +,   5.0159625E-04,   5.5137463E-04,   6.0592016E-04
     +,   6.6488364E-04,   7.2772050E-04,   7.9367124E-04
     +,   8.6178549E-04,   9.3089580E-04,   9.9966524E-04
     +,   1.0666094E-03,   1.1301544E-03,   1.1887115E-03
     +,   1.2407596E-03,   1.2849700E-03,   1.3202906E-03
     +,   1.3460756E-03,   1.3621692E-03,   1.3689828E-03
     +,   1.3675319E-03,   1.3594272E-03,   1.3468072E-03
     +,   1.3322079E-03,   1.3183570E-03,   1.3079206E-03
     +,   1.3032093E-03,   1.3058865E-03,   1.3167269E-03
     +,   1.3354626E-03,   1.3607586E-03,   1.3903338E-03
     +,   1.4212198E-03,   1.4501205E-03,   1.4738423E-03
     +,   1.4896843E-03,   1.4957838E-03,   1.4913169E-03
     +,   1.4765548E-03,   1.4527531E-03,   1.4219235E-03
     +,   1.3864861E-03,   1.3489194E-03,   1.3114096E-03
     +,   1.2755718E-03,   1.2423092E-03,   1.2117579E-03
     +,   1.1833891E-03,   1.1561724E-03,   1.1288129E-03
     +,   1.0999998E-03,   1.0686086E-03,   1.0338745E-03
     +,   9.9546253E-04,   9.5348078E-04,   9.0842182E-04
     +,   8.6105836E-04,   8.1232766E-04,   7.6319737E-04
     +,   7.1456982E-04,   6.6720514E-04,   6.2167889E-04
     +,   5.7838048E-04,   5.3750916E-04,   4.9912982E-04
     +,   4.6318630E-04,   4.2956253E-04,   3.9810044E-04
     +,   3.6863144E-04,   3.4099704E-04,   3.1504643E-04
     +,   2.9065425E-04,   2.6770774E-04,   2.4610906E-04
     +,   2.2577445E-04,   2.0662362E-04,   1.8858988E-04
     +,   1.7160854E-04,   1.5562675E-04,   1.4060001E-04
     +,   1.2648996E-04,   1.1326934E-04,   1.0091757E-04
     +,   8.9421665E-05,   7.8771140E-05,   6.8957299E-05
     +,   5.9970367E-05,   5.1796960E-05,   4.4419518E-05
     +,   3.7813297E-05,   3.1947191E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_nwao_hz_90 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_nwao_hz_95(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  1.8634901E-21,   2.8497002E-21
     +,   4.3471475E-21,   6.6151193E-21,   1.0041551E-20
     +,   1.5205425E-20,   2.2967980E-20,   3.4607896E-20
     +,   5.2019444E-20,   7.7997542E-20,   1.1666107E-19
     +,   1.7406337E-19,   2.5906837E-19,   3.8463785E-19
     +,   5.6966812E-19,   8.4162908E-19,   1.2403669E-18
     +,   1.8235290E-18,   2.6742582E-18,   3.9122243E-18
     +,   5.7091931E-18,   8.3111220E-18,   1.2068994E-17
     +,   1.7483013E-17,   2.5263279E-17,   3.6416054E-17
     +,   5.2363256E-17,   7.5109409E-17,   1.0747051E-16
     +,   1.5339745E-16,   2.1841048E-16,   3.1021319E-16
     +,   4.3951809E-16,   6.2119279E-16,   8.7580004E-16
     +,   1.2317213E-15,   1.7280436E-15,   2.4183784E-15
     +,   3.3761704E-15,   4.7017198E-15,   6.5315769E-15
     +,   9.0513128E-15,   1.2512189E-14,   1.7253834E-14
     +,   2.3733868E-14,   3.2567441E-14,   4.4578734E-14
     +,   6.0869759E-14,   8.2910465E-14,   1.1265342E-13
     +,   1.5268979E-13,   2.0644711E-13,   2.7844206E-13
     +,   3.7462329E-13,   5.0278558E-13,   6.7313136E-13
     +,   8.9897799E-13,   1.1976450E-12,   1.5916229E-12
     +,   2.1099901E-12,   2.7903129E-12,   3.6809024E-12
     +,   4.8437920E-12,   6.3584277E-12,   8.3261098E-12
     +,   1.0875897E-11,   1.4171660E-11,   1.8420631E-11
     +,   2.3884670E-11,   3.0893295E-11,   3.9860192E-11
     +,   5.1303333E-11,   6.5869699E-11,   8.4363107E-11
     +,   1.0778296E-10,   1.3736555E-10,   1.7463712E-10
     +,   2.2147729E-10,   2.8018721E-10,   3.5358844E-10
     +,   4.4512127E-10,   5.5897098E-10,   7.0021933E-10
     +,   8.7498869E-10,   1.0907079E-09,   1.3562536E-09
     +,   1.6823021E-09,   2.0816038E-09,   2.5693421E-09
     +,   3.1635898E-09,   3.8856638E-09,   4.7608100E-09
     +,   5.8187148E-09,   7.0942048E-09,   8.6280130E-09
     +,   1.0467631E-08,   1.2668341E-08,   1.5293896E-08
     +,   1.8418209E-08,   2.2126196E-08,   2.6515316E-08
     +,   3.1697162E-08,   3.7798237E-08,   4.4962761E-08
     +,   5.3353748E-08,   6.3154943E-08,   7.4573286E-08
     +,   8.7838323E-08,   1.0320976E-07,   1.2097206E-07
     +,   1.4144265E-07,   1.6497039E-07,   1.9193861E-07
     +,   2.2276730E-07,   2.5790905E-07,   2.9786366E-07
     +,   3.4316002E-07,   3.9437256E-07,   4.5211411E-07
     +,   5.1703580E-07,   5.8983039E-07,   6.7121766E-07
     +,   7.6196011E-07,   8.6284814E-07,   9.7469876E-07
     +,   1.0983528E-06,   1.2346726E-06,   1.3845174E-06
     +,   1.5487660E-06,   1.7282920E-06,   1.9239612E-06
     +,   2.1366234E-06,   2.3671178E-06,   2.6162327E-06
     +,   2.8847519E-06,   3.1734226E-06,   3.4829632E-06
     +,   3.8140734E-06,   4.1674448E-06,   4.5437951E-06
     +,   4.9438354E-06,   5.3683943E-06,   5.8184137E-06
     +,   6.2950135E-06,   6.7996007E-06,   7.3338515E-06
     +,   7.9000401E-06,   8.5008878E-06,   9.1399143E-06
     +,   9.8215323E-06,   1.0551096E-05,   1.1335384E-05
     +,   1.2182374E-05,   1.3101760E-05,   1.4104945E-05
     +,   1.5205231E-05,   1.6417962E-05,   1.7760334E-05
     +,   1.9251949E-05,   2.0913956E-05,   2.2769511E-05
     +,   2.4843228E-05,   2.7160433E-05,   2.9747529E-05
     +,   3.2630072E-05,   3.5832982E-05,   3.9379094E-05
     +,   4.3288230E-05,   4.7576250E-05,   5.2253050E-05
     +,   5.7323250E-05,   6.2782623E-05,   6.8619120E-05
     +,   7.4811018E-05,   8.1326507E-05,   8.8123663E-05
     +,   9.5149255E-05,   1.0234068E-04,   1.0962566E-04
     +,   1.1692353E-04,   1.2414709E-04,   1.3120304E-04
     +,   1.3799699E-04,   1.4443239E-04,   1.5041577E-04
     +,   1.5585827E-04,   1.6067852E-04,   1.6480534E-04
     +,   1.6817954E-04,   1.7075750E-04,   1.7251115E-04
     +,   1.7343080E-04,   1.7352530E-04,   1.7282268E-04
     +,   1.7136961E-04,   1.6923109E-04,   1.6648781E-04
     +,   1.6323490E-04,   1.5957854E-04,   1.5563125E-04
     +,   1.5150987E-04,   1.4732927E-04,   1.4320170E-04
     +,   1.3923441E-04,   1.3553386E-04,   1.3221694E-04
     +,   1.2943037E-04,   1.2738731E-04,   1.2641662E-04
     +,   1.2702994E-04,   1.2999671E-04,   1.3641725E-04
     +,   1.4776835E-04,   1.6590208E-04,   1.9297002E-04
     +,   2.3126644E-04,   2.8300640E-04,   3.5005904E-04
     +,   4.3373505E-04,   5.3456338E-04,   6.5217877E-04
     +,   7.8516407E-04,   9.3085703E-04,   1.0851207E-03
     +,   1.2421827E-03,   1.3949646E-03,   1.5359855E-03
     +,   1.6592852E-03,   1.7628581E-03,   1.8508941E-03
     +,   1.9345115E-03,   2.0297598E-03,   2.1525996E-03
     +,   2.3118923E-03,   2.5034000E-03,   2.7079941E-03
     +,   2.8962330E-03,   3.0382369E-03,   3.1146260E-03
     +,   3.1232443E-03,   3.0782484E-03,   3.0025844E-03
     +,   2.9183580E-03,   2.8403210E-03,   2.7749541E-03
     +,   2.7239011E-03,   2.6878044E-03,   2.6673418E-03
     +,   2.6608752E-03,   2.6611404E-03,   2.6544249E-03
     +,   2.6240796E-03,   2.5572316E-03,   2.4511672E-03
     +,   2.3157003E-03,   2.1702077E-03,   2.0366171E-03
     +,   1.9319742E-03,   1.8635085E-03,   1.8278826E-03
     +,   1.8139649E-03,   1.8073741E-03,   1.7948410E-03
     +,   1.7670901E-03,   1.7198225E-03,   1.6531725E-03
     +,   1.5703203E-03,   1.4759873E-03,   1.3752335E-03
     +,   1.2727507E-03,   1.1725179E-03,   1.0776506E-03
     +,   9.9032791E-04,   9.1168890E-04,   8.4186840E-04
     +,   7.8005326E-04,   7.2475633E-04,   6.7412516E-04
     +,   6.2631274E-04,   5.7979464E-04,   5.3354632E-04
     +,   4.8713532E-04,   4.4065027E-04,   3.9457466E-04
     +,   3.4962696E-04,   3.0657803E-04,   2.6614525E-04
     +,   2.2887987E-04,   1.9514744E-04,   1.6511328E-04
     +,   1.3875964E-04,   1.1593316E-04,   9.6379408E-05
     +,   7.9786405E-05,   6.5813510E-05,   5.4119970E-05
     +,   4.4381773E-05,   3.6302223E-05,   2.9618492E-05
     +,   2.4101271E-05,   1.9554904E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_nwao_hz_95 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_nwao_qq(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  1.9394263E-07,   2.1195558E-07
     +,   2.3145292E-07,   2.5253718E-07,   2.7531757E-07
     +,   2.9990863E-07,   3.2642927E-07,   3.5500554E-07
     +,   3.8576891E-07,   4.1885576E-07,   4.5440987E-07
     +,   4.9258045E-07,   5.3352119E-07,   5.7739362E-07
     +,   6.2436510E-07,   6.7460633E-07,   7.2829630E-07
     +,   7.8561879E-07,   8.4676128E-07,   9.1191805E-07
     +,   9.8128760E-07,   1.0550746E-06,   1.1334832E-06
     +,   1.2167279E-06,   1.3050196E-06,   1.3985767E-06
     +,   1.4976190E-06,   1.6023697E-06,   1.7130473E-06
     +,   1.8298774E-06,   1.9530803E-06,   2.0828784E-06
     +,   2.2194913E-06,   2.3631385E-06,   2.5140291E-06
     +,   2.6723728E-06,   2.8383779E-06,   3.0122326E-06
     +,   3.1941313E-06,   3.3842548E-06,   3.5827682E-06
     +,   3.7898385E-06,   4.0056038E-06,   4.2302013E-06
     +,   4.4637495E-06,   4.7063577E-06,   4.9581017E-06
     +,   5.2190526E-06,   5.4892662E-06,   5.7687571E-06
     +,   6.0575380E-06,   6.3555963E-06,   6.6628800E-06
     +,   6.9793341E-06,   7.3048536E-06,   7.6393253E-06
     +,   7.9826032E-06,   8.3345112E-06,   8.6948521E-06
     +,   9.0633748E-06,   9.4398338E-06,   9.8239134E-06
     +,   1.0215298E-05,   1.0613639E-05,   1.1018530E-05
     +,   1.1429563E-05,   1.1846294E-05,   1.2268230E-05
     +,   1.2694867E-05,   1.3125673E-05,   1.3560074E-05
     +,   1.3997484E-05,   1.4437303E-05,   1.4878852E-05
     +,   1.5321484E-05,   1.5764517E-05,   1.6207245E-05
     +,   1.6648963E-05,   1.7088903E-05,   1.7526332E-05
     +,   1.7960494E-05,   1.8390621E-05,   1.8815961E-05
     +,   1.9235697E-05,   1.9649116E-05,   2.0055410E-05
     +,   2.0453832E-05,   2.0843640E-05,   2.1224094E-05
     +,   2.1594498E-05,   2.1954127E-05,   2.2302323E-05
     +,   2.2638447E-05,   2.2961887E-05,   2.3272061E-05
     +,   2.3568442E-05,   2.3850533E-05,   2.4117866E-05
     +,   2.4370045E-05,   2.4606717E-05,   2.4827586E-05
     +,   2.5032417E-05,   2.5221003E-05,   2.5393238E-05
     +,   2.5549065E-05,   2.5688483E-05,   2.5811576E-05
     +,   2.5918474E-05,   2.6009413E-05,   2.6084654E-05
     +,   2.6144566E-05,   2.6189575E-05,   2.6220177E-05
     +,   2.6236938E-05,   2.6240505E-05,   2.6231584E-05
     +,   2.6210941E-05,   2.6179421E-05,   2.6137925E-05
     +,   2.6087408E-05,   2.6028885E-05,   2.5963427E-05
     +,   2.5892143E-05,   2.5816191E-05,   2.5736756E-05
     +,   2.5655068E-05,   2.5572373E-05,   2.5489944E-05
     +,   2.5409061E-05,   2.5331006E-05,   2.5257074E-05
     +,   2.5188530E-05,   2.5126632E-05,   2.5072623E-05
     +,   2.5027697E-05,   2.4993014E-05,   2.4969684E-05
     +,   2.4958754E-05,   2.4961213E-05,   2.4977977E-05
     +,   2.5009867E-05,   2.5057638E-05,   2.5121926E-05
     +,   2.5203284E-05,   2.5302154E-05,   2.5418842E-05
     +,   2.5553585E-05,   2.5706449E-05,   2.5877414E-05
     +,   2.6066326E-05,   2.6272884E-05,   2.6496717E-05
     +,   2.6737285E-05,   2.6993965E-05,   2.7266009E-05
     +,   2.7552594E-05,   2.7852810E-05,   2.8165623E-05
     +,   2.8490043E-05,   2.8824943E-05,   2.9169247E-05
     +,   2.9521880E-05,   2.9881765E-05,   3.0247984E-05
     +,   3.0619623E-05,   3.0995983E-05,   3.1376534E-05
     +,   3.1760959E-05,   3.2149244E-05,   3.2541637E-05
     +,   3.2938846E-05,   3.3341919E-05,   3.3752403E-05
     +,   3.4172393E-05,   3.4604527E-05,   3.5052086E-05
     +,   3.5519002E-05,   3.6009944E-05,   3.6530368E-05
     +,   3.7086520E-05,   3.7685590E-05,   3.8335562E-05
     +,   3.9045612E-05,   3.9825798E-05,   4.0687413E-05
     +,   4.1642958E-05,   4.2706277E-05,   4.3892716E-05
     +,   4.5219007E-05,   4.6703975E-05,   4.8367940E-05
     +,   5.0233499E-05,   5.2325420E-05,   5.4670458E-05
     +,   5.7298308E-05,   6.0240349E-05,   6.3531050E-05
     +,   6.7206412E-05,   7.1304043E-05,   7.5863885E-05
     +,   8.0925085E-05,   8.6528002E-05,   9.2710157E-05
     +,   9.9507066E-05,   1.0694986E-04,   1.1506230E-04
     +,   1.2386194E-04,   1.3335391E-04,   1.4353200E-04
     +,   1.5437575E-04,   1.6584650E-04,   1.7789062E-04
     +,   1.9043220E-04,   2.0337764E-04,   2.1661309E-04
     +,   2.3000639E-04,   2.4340936E-04,   2.5665824E-04
     +,   2.6958331E-04,   2.8200730E-04,   2.9375669E-04
     +,   3.0466658E-04,   3.1458863E-04,   3.2339955E-04
     +,   3.3100761E-04,   3.3736369E-04,   3.4246393E-04
     +,   3.4635814E-04,   3.4915179E-04,   3.5100718E-04
     +,   3.5214183E-04,   3.5282265E-04,   3.5335851E-04
     +,   3.5408780E-04,   3.5536490E-04,   3.5754300E-04
     +,   3.6095717E-04,   3.6590628E-04,   3.7263602E-04
     +,   3.8132622E-04,   3.9207996E-04,   4.0491921E-04
     +,   4.1978667E-04,   4.3655053E-04,   4.5502529E-04
     +,   4.7498295E-04,   4.9618538E-04,   5.1840988E-04
     +,   5.4147403E-04,   5.6527456E-04,   5.8979733E-04
     +,   6.1515177E-04,   6.4156740E-04,   6.6940096E-04
     +,   6.9913251E-04,   7.3132874E-04,   7.6662784E-04
     +,   8.0567703E-04,   8.4909273E-04,   8.9739502E-04
     +,   9.5093506E-04,   1.0098508E-03,   1.0739800E-03
     +,   1.1428309E-03,   1.2155378E-03,   1.2908492E-03
     +,   1.3671414E-03,   1.4424449E-03,   1.5145318E-03
     +,   1.5810000E-03,   1.6393908E-03,   1.6873284E-03
     +,   1.7226476E-03,   1.7435466E-03,   1.7486841E-03
     +,   1.7372828E-03,   1.7091793E-03,   1.6648392E-03
     +,   1.6053300E-03,   1.5322660E-03,   1.4476830E-03
     +,   1.3539544E-03,   1.2536250E-03,   1.1492829E-03
     +,   1.0434514E-03,   9.3843031E-04,   8.3627173E-04
     +,   7.3865469E-04,   6.4690958E-04,   5.6198728E-04
     +,   4.8446225E-04,   4.1459795E-04,   3.5237524E-04
     +,   2.9755876E-04,   2.4973892E-04,   2.0839389E-04
     +,   1.7293449E-04,   1.4274246E-04,   1.1720600E-04
     +,   9.5735493E-05,   7.7783538E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_nwao_qq = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_nwao_ww(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   2.5083332E-38,   5.5652770E-38
     +,   1.2295780E-37,   2.7052228E-37,   5.9266732E-37
     +,   1.2929746E-36,   2.8088597E-36,   6.0763265E-36
     +,   1.3089303E-35,   2.8078221E-35,   5.9976856E-35
     +,   1.2757497E-34,   2.7022051E-34,   5.6995267E-34
     +,   1.1970720E-33,   2.5036839E-33,   5.2143445E-33
     +,   1.0814197E-32,   2.2333230E-32,   4.5927546E-32
     +,   9.4051520E-32,   1.9178938E-31,   3.8945520E-31
     +,   7.8750476E-31,   1.5857020E-30,   3.1794546E-30
     +,   6.3482360E-30,   1.2621941E-29,   2.4989564E-29
     +,   4.9267494E-29,   9.6724896E-29,   1.8909230E-28
     +,   3.6811236E-28,   7.1359966E-28,   1.3775104E-27
     +,   2.6479177E-27,   5.0686628E-27,   9.6613629E-27
     +,   1.8337962E-26,   3.4660231E-26,   6.5234822E-26
     +,   1.2226632E-25,   2.2818665E-25,   4.2407535E-25
     +,   7.8480512E-25,   1.4462720E-24,   2.6540906E-24
     +,   4.8498620E-24,   8.8253214E-24,   1.5991567E-23
     +,   2.8854664E-23,   5.1845598E-23,   9.2762804E-23
     +,   1.6527802E-22,   2.9323273E-22,   5.1805892E-22
     +,   9.1140945E-22,   1.5966654E-21,   2.7853750E-21
     +,   4.8386156E-21,   8.3702059E-21,   1.4418185E-20
     +,   2.4731535E-20,   4.2243439E-20,   7.1851383E-20
     +,   1.2169946E-19,   2.0525869E-19,   3.4473176E-19
     +,   5.7654023E-19,   9.6016437E-19,   1.5923491E-18
     +,   2.6295497E-18,   4.3242293E-18,   7.0810267E-18
     +,   1.1546507E-17,   1.8748874E-17,   3.0315574E-17
     +,   4.8812557E-17,   7.8261993E-17,   1.2495453E-16
     +,   1.9866210E-16,   3.1451757E-16,   4.9584102E-16
     +,   7.7841026E-16,   1.2168856E-15,   1.8943106E-15
     +,   2.9364347E-15,   4.5327024E-15,   6.9672682E-15
     +,   1.0664359E-14,   1.6254816E-14,   2.4671259E-14
     +,   3.7287857E-14,   5.6119158E-14,   8.4105323E-14
     +,   1.2551726E-13,   1.8653389E-13,   2.7604069E-13
     +,   4.0677677E-13,   5.9690848E-13,   8.7222184E-13
     +,   1.2691530E-12,   1.8389405E-12,   2.6533656E-12
     +,   3.8122999E-12,   5.4543822E-12,   7.7709011E-12
     +,   1.1024661E-11,   1.5575178E-11,   2.1910758E-11
     +,   3.0694437E-11,   4.2817878E-11,   5.9478270E-11
     +,   8.2274368E-11,   1.1332572E-10,   1.5544262E-10
     +,   2.1231215E-10,   2.8876682E-10,   3.9109965E-10
     +,   5.2746740E-10,   7.0839601E-10,   9.4736008E-10
     +,   1.2616269E-09,   1.6730555E-09,   2.2093158E-09
     +,   2.9052103E-09,   3.8041379E-09,   4.9603348E-09
     +,   6.4406485E-09,   8.3275244E-09,   1.0721871E-08
     +,   1.3746521E-08,   1.7550379E-08,   2.2312106E-08
     +,   2.8246861E-08,   3.5609350E-08,   4.4701832E-08
     +,   5.5879795E-08,   6.9558787E-08,   8.6222578E-08
     +,   1.0642754E-07,   1.3081434E-07,   1.6011225E-07
     +,   1.9514705E-07,   2.3684856E-07,   2.8624740E-07
     +,   3.4449843E-07,   4.1285597E-07,   4.9269551E-07
     +,   5.8550171E-07,   6.9286318E-07,   8.1646914E-07
     +,   9.5807104E-07,   1.1195223E-06,   1.3026814E-06
     +,   1.5094467E-06,   1.7417103E-06,   2.0012785E-06
     +,   2.2899417E-06,   2.6092819E-06,   2.9608057E-06
     +,   3.3457341E-06,   3.7650245E-06,   4.2194324E-06
     +,   4.7092449E-06,   5.2345240E-06,   5.7948100E-06
     +,   6.3893090E-06,   7.0168262E-06,   7.6756714E-06
     +,   8.3639561E-06,   9.0792864E-06,   9.8191113E-06
     +,   1.0580691E-05,   1.1361088E-05,   1.2157590E-05
     +,   1.2967434E-05,   1.3788264E-05,   1.4618136E-05
     +,   1.5455684E-05,   1.6300301E-05,   1.7152130E-05
     +,   1.8012521E-05,   1.8883682E-05,   1.9769137E-05
     +,   2.0673586E-05,   2.1602978E-05,   2.2564516E-05
     +,   2.3566436E-05,   2.4618332E-05,   2.5730527E-05
     +,   2.6914373E-05,   2.8181916E-05,   2.9545785E-05
     +,   3.1019121E-05,   3.2615171E-05,   3.4347795E-05
     +,   3.6230547E-05,   3.8277289E-05,   4.0501789E-05
     +,   4.2917789E-05,   4.5538982E-05,   4.8378562E-05
     +,   5.1449722E-05,   5.4765027E-05,   5.8336242E-05
     +,   6.2174186E-05,   6.6287430E-05,   7.0683542E-05
     +,   7.5366101E-05,   8.0335849E-05,   8.5589287E-05
     +,   9.1117174E-05,   9.6906064E-05,   1.0293463E-04
     +,   1.0917686E-04,   1.1559873E-04,   1.2215972E-04
     +,   1.2881475E-04,   1.3551135E-04,   1.4219490E-04
     +,   1.4880564E-04,   1.5528318E-04,   1.6156674E-04
     +,   1.6759570E-04,   1.7331359E-04,   1.7866597E-04
     +,   1.8360399E-04,   1.8808391E-04,   1.9206782E-04
     +,   1.9552369E-04,   1.9842494E-04,   2.0075071E-04
     +,   2.0248491E-04,   2.0361568E-04,   2.0413507E-04
     +,   2.0403831E-04,   2.0332365E-04,   2.0199236E-04
     +,   2.0004838E-04,   1.9749906E-04,   1.9435528E-04
     +,   1.9063175E-04,   1.8634835E-04,   1.8152899E-04
     +,   1.7620412E-04,   1.7040911E-04,   1.6418484E-04
     +,   1.5757841E-04,   1.5064010E-04,   1.4342625E-04
     +,   1.3599420E-04,   1.2840507E-04,   1.2072080E-04
     +,   1.1300167E-04,   1.0530766E-04,   9.7695549E-05
     +,   9.0219553E-05,   8.2928600E-05,   7.5866978E-05
     +,   6.9073467E-05,   6.2580868E-05,   5.6416753E-05
     +,   5.0602070E-05,   4.5152156E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_nwao_ww = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_nwao_zz(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  9.7899671E-09,   1.0247188E-08
     +,   1.0720666E-08,   1.1210687E-08,   1.1717550E-08
     +,   1.2241559E-08,   1.2782969E-08,   1.3342076E-08
     +,   1.3919164E-08,   1.4514479E-08,   1.5128302E-08
     +,   1.5760925E-08,   1.6412605E-08,   1.7083654E-08
     +,   1.7774399E-08,   1.8485169E-08,   1.9216365E-08
     +,   1.9968448E-08,   2.0741926E-08,   2.1537426E-08
     +,   2.2355700E-08,   2.3197670E-08,   2.4064413E-08
     +,   2.4957318E-08,   2.5878016E-08,   2.6828561E-08
     +,   2.7811470E-08,   2.8829803E-08,   2.9887278E-08
     +,   3.0988499E-08,   3.2138949E-08,   3.3345344E-08
     +,   3.4615763E-08,   3.5959957E-08,   3.7389515E-08
     +,   3.8918337E-08,   4.0562991E-08,   4.2342990E-08
     +,   4.4281492E-08,   4.6405752E-08,   4.8747577E-08
     +,   5.1344333E-08,   5.4239283E-08,   5.7482762E-08
     +,   6.1132859E-08,   6.5256536E-08,   6.9930323E-08
     +,   7.5241914E-08,   8.1291120E-08,   8.8190738E-08
     +,   9.6068590E-08,   1.0506839E-07,   1.1535073E-07
     +,   1.2709546E-07,   1.4050167E-07,   1.5579023E-07
     +,   1.7320431E-07,   1.9301054E-07,   2.1550062E-07
     +,   2.4099023E-07,   2.6982232E-07,   3.0236419E-07
     +,   3.3901051E-07,   3.8018177E-07,   4.2632084E-07
     +,   4.7789598E-07,   5.3539708E-07,   5.9933035E-07
     +,   6.7022012E-07,   7.4860247E-07,   8.3502084E-07
     +,   9.3002200E-07,   1.0341536E-06,   1.1479415E-06
     +,   1.2719072E-06,   1.4065440E-06,   1.5523135E-06
     +,   1.7096404E-06,   1.8788835E-06,   2.0603584E-06
     +,   2.2543056E-06,   2.4608864E-06,   2.6801833E-06
     +,   2.9121454E-06,   3.1566781E-06,   3.4135087E-06
     +,   3.6822796E-06,   3.9624983E-06,   4.2535357E-06
     +,   4.5546412E-06,   4.8648917E-06,   5.1832581E-06
     +,   5.5085652E-06,   5.8395049E-06,   6.1746414E-06
     +,   6.5124182E-06,   6.8511827E-06,   7.1891486E-06
     +,   7.5244816E-06,   7.8552648E-06,   8.1795324E-06
     +,   8.4953008E-06,   8.8005299E-06,   9.0932335E-06
     +,   9.3714389E-06,   9.6332269E-06,   9.8767659E-06
     +,   1.0100277E-05,   1.0302165E-05,   1.0480913E-05
     +,   1.0635191E-05,   1.0763838E-05,   1.0865873E-05
     +,   1.0940530E-05,   1.0987235E-05,   1.1005650E-05
     +,   1.0995653E-05,   1.0957347E-05,   1.0891065E-05
     +,   1.0797356E-05,   1.0676982E-05,   1.0530927E-05
     +,   1.0360356E-05,   1.0166619E-05,   9.9512345E-06
     +,   9.7158709E-06,   9.4623156E-06,   9.1925040E-06
     +,   8.9084333E-06,   8.6121881E-06,   8.3059085E-06
     +,   7.9917727E-06,   7.6719662E-06,   7.3487149E-06
     +,   7.0242036E-06,   6.7006004E-06,   6.3800412E-06
     +,   6.0646234E-06,   5.7563893E-06,   5.4573138E-06
     +,   5.1693505E-06,   4.8943539E-06,   4.6341302E-06
     +,   4.3904233E-06,   4.1649073E-06,   3.9592305E-06
     +,   3.7749246E-06,   3.6135189E-06,   3.4764500E-06
     +,   3.3650997E-06,   3.2807964E-06,   3.2247733E-06
     +,   3.1982022E-06,   3.2021499E-06,   3.2375790E-06
     +,   3.3053243E-06,   3.4060797E-06,   3.5403532E-06
     +,   3.7084912E-06,   3.9105857E-06,   4.1465046E-06
     +,   4.4158455E-06,   4.7178678E-06,   5.0515841E-06
     +,   5.4155862E-06,   5.8081487E-06,   6.2271670E-06
     +,   6.6701600E-06,   7.1342820E-06,   7.6162519E-06
     +,   8.1125563E-06,   8.6192313E-06,   9.1320753E-06
     +,   9.6466219E-06,   1.0158185E-05,   1.0661937E-05
     +,   1.1152896E-05,   1.1626107E-05,   1.2076624E-05
     +,   1.2499613E-05,   1.2890441E-05,   1.3244667E-05
     +,   1.3558306E-05,   1.3827699E-05,   1.4049758E-05
     +,   1.4222011E-05,   1.4342762E-05,   1.4411274E-05
     +,   1.4428049E-05,   1.4395281E-05,   1.4317485E-05
     +,   1.4202462E-05,   1.4062727E-05,   1.3917502E-05
     +,   1.3795273E-05,   1.3737327E-05,   1.3801739E-05
     +,   1.4068083E-05,   1.4642114E-05,   1.5660240E-05
     +,   1.7292043E-05,   1.9741441E-05,   2.3242665E-05
     +,   2.8053386E-05,   3.4441524E-05,   4.2665357E-05
     +,   5.2952972E-05,   6.5470151E-05,   8.0294842E-05
     +,   9.7387383E-05,   1.1656306E-04,   1.3748305E-04
     +,   1.5963841E-04,   1.8236694E-04,   2.0487419E-04
     +,   2.2627518E-04,   2.4565350E-04,   2.6212505E-04
     +,   2.7492139E-04,   2.8345088E-04,   2.8736345E-04
     +,   2.8658452E-04,   2.8132251E-04,   2.7204558E-04
     +,   2.5943088E-04,   2.4428559E-04,   2.2746992E-04
     +,   2.0980957E-04,   1.9203023E-04,   1.7471309E-04
     +,   1.5827769E-04,   1.4299423E-04,   1.2900982E-04
     +,   1.1640156E-04,   1.0522130E-04,   9.5543546E-05
     +,   8.7500441E-05,   8.1298742E-05,   7.7220167E-05
     +,   7.5600146E-05,   7.6791730E-05,   8.1114995E-05
     +,   8.8798755E-05,   9.9918987E-05,   1.1434962E-04
     +,   1.3171903E-04,   1.5140117E-04,   1.7252940E-04
     +,   1.9404222E-04,   2.1477239E-04,   2.3353720E-04
     +,   2.4926628E-04,   2.6109899E-04,   2.6847710E-04
     +,   2.7119793E-04,   2.6941794E-04,   2.6361769E-04
     +,   2.5452874E-04,   2.4303254E-04,   2.3005395E-04
     +,   2.1646637E-04,   2.0300994E-04,   1.9025254E-04
     +,   1.7856913E-04,   1.6815588E-04,   1.5906019E-04
     +,   1.5121880E-04,   1.4449914E-04,   1.3873042E-04
     +,   1.3373057E-04,   1.2932149E-04,   1.2533891E-04
     +,   1.2163779E-04,   1.1809349E-04,   1.1460679E-04
     +,   1.1110386E-04,   1.0753987E-04,   1.0389782E-04
     +,   1.0018695E-04,   9.6439573E-05,   9.2702758E-05
     +,   8.9032801E-05,   8.5485975E-05,   8.2111888E-05
     +,   7.8948564E-05,   7.6017532E-05,   7.3324481E-05
     +,   7.0857721E-05,   6.8591959E-05,   6.6490415E-05
     +,   6.4508196E-05,   6.2596511E-05,   6.0705894E-05
     +,   5.8789556E-05,   5.6805929E-05,   5.4720927E-05
     +,   5.2509782E-05,   5.0157643E-05,   4.7660582E-05
     +,   4.5024677E-05,   4.2265616E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_nwao_zz = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wano_fus_100(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  2.6075511E-06,   2.6671528E-06
     +,   2.7272349E-06,   2.7877727E-06,   2.8487473E-06
     +,   2.9101388E-06,   2.9719258E-06,   3.0340912E-06
     +,   3.0966178E-06,   3.1594882E-06,   3.2226894E-06
     +,   3.2862099E-06,   3.3500387E-06,   3.4141694E-06
     +,   3.4786003E-06,   3.5433284E-06,   3.6083591E-06
     +,   3.6737028E-06,   3.7393709E-06,   3.8053840E-06
     +,   3.8717676E-06,   3.9385559E-06,   4.0057862E-06
     +,   4.0735104E-06,   4.1417838E-06,   4.2106758E-06
     +,   4.2802640E-06,   4.3506416E-06,   4.4219087E-06
     +,   4.4941862E-06,   4.5676034E-06,   4.6423106E-06
     +,   4.7184762E-06,   4.7962858E-06,   4.8759453E-06
     +,   4.9576847E-06,   5.0417602E-06,   5.1284478E-06
     +,   5.2180585E-06,   5.3109325E-06,   5.4074394E-06
     +,   5.5079918E-06,   5.6130316E-06,   5.7230509E-06
     +,   5.8385845E-06,   5.9602175E-06,   6.0885832E-06
     +,   6.2243780E-06,   6.3683615E-06,   6.5213512E-06
     +,   6.6842472E-06,   6.8580271E-06,   7.0437450E-06
     +,   7.2425555E-06,   7.4557038E-06,   7.6845427E-06
     +,   7.9305410E-06,   8.1952830E-06,   8.4804897E-06
     +,   8.7879998E-06,   9.1198217E-06,   9.4780880E-06
     +,   9.8651144E-06,   1.0283382E-05,   1.0735526E-05
     +,   1.1224383E-05,   1.1752985E-05,   1.2324516E-05
     +,   1.2942395E-05,   1.3610216E-05,   1.4331781E-05
     +,   1.5111080E-05,   1.5952328E-05,   1.6859833E-05
     +,   1.7838165E-05,   1.8892038E-05,   2.0026315E-05
     +,   2.1246027E-05,   2.2556196E-05,   2.3962046E-05
     +,   2.5468838E-05,   2.7081849E-05,   2.8806413E-05
     +,   3.0647549E-05,   3.2610697E-05,   3.4700635E-05
     +,   3.6922254E-05,   3.9280170E-05,   4.1778698E-05
     +,   4.4421911E-05,   4.7213176E-05,   5.0155759E-05
     +,   5.3252246E-05,   5.6504679E-05,   5.9914484E-05
     +,   6.3482388E-05,   6.7208508E-05,   7.1091752E-05
     +,   7.5130607E-05,   7.9322497E-05,   8.3663981E-05
     +,   8.8150802E-05,   9.2777213E-05,   9.7537035E-05
     +,   1.0242293E-04,   1.0742668E-04,   1.1253941E-04
     +,   1.1775058E-04,   1.2305047E-04,   1.2842743E-04
     +,   1.3387030E-04,   1.3936761E-04,   1.4490822E-04
     +,   1.5048165E-04,   1.5607776E-04,   1.6168909E-04
     +,   1.6730900E-04,   1.7293394E-04,   1.7856355E-04
     +,   1.8420139E-04,   1.8985567E-04,   1.9553929E-04
     +,   2.0127196E-04,   2.0707968E-04,   2.1299590E-04
     +,   2.1906199E-04,   2.2532781E-04,   2.3185134E-04
     +,   2.3870012E-04,   2.4595027E-04,   2.5368677E-04
     +,   2.6200304E-04,   2.7100090E-04,   2.8078782E-04
     +,   2.9147899E-04,   3.0319404E-04,   3.1605689E-04
     +,   3.3019338E-04,   3.4573089E-04,   3.6279648E-04
     +,   3.8151277E-04,   4.0200076E-04,   4.2437491E-04
     +,   4.4874186E-04,   4.7520109E-04,   5.0383626E-04
     +,   5.3472572E-04,   5.6792650E-04,   6.0348277E-04
     +,   6.4142147E-04,   6.8174227E-04,   7.2443410E-04
     +,   7.6944975E-04,   8.1672327E-04,   8.6616020E-04
     +,   9.1764063E-04,   9.7102008E-04,   1.0261214E-03
     +,   1.0827603E-03,   1.1407165E-03,   1.1997622E-03
     +,   1.2596514E-03,   1.3201147E-03,   1.3808798E-03
     +,   1.4416417E-03,   1.5020811E-03,   1.5618599E-03
     +,   1.6206139E-03,   1.6779690E-03,   1.7335388E-03
     +,   1.7869615E-03,   1.8379003E-03,   1.8860938E-03
     +,   1.9313893E-03,   1.9737843E-03,   2.0134768E-03
     +,   2.0509064E-03,   2.0867942E-03,   2.1221680E-03
     +,   2.1583536E-03,   2.1969466E-03,   2.2397116E-03
     +,   2.2884647E-03,   2.3448523E-03,   2.4101296E-03
     +,   2.4848990E-03,   2.5688796E-03,   2.6607504E-03
     +,   2.7581223E-03,   2.8577375E-03,   2.9557773E-03
     +,   3.0484369E-03,   3.1325442E-03,   3.2061962E-03
     +,   3.2693057E-03,   3.3238186E-03,   3.3736792E-03
     +,   3.4243173E-03,   3.4818649E-03,   3.5521968E-03
     +,   3.6399639E-03,   3.7480060E-03,   3.8771702E-03
     +,   4.0267301E-03,   4.1952059E-03,   4.3812217E-03
     +,   4.5842496E-03,   4.8046019E-03,   5.0430214E-03
     +,   5.2996879E-03,   5.5730683E-03,   5.8591501E-03
     +,   6.1509460E-03,   6.4389110E-03,   6.7119091E-03
     +,   6.9590048E-03,   7.1716770E-03,   7.3461370E-03
     +,   7.4848840E-03,   7.5965542E-03,   7.6938416E-03
     +,   7.7897827E-03,   7.8937300E-03,   8.0085006E-03
     +,   8.1297532E-03,   8.2476968E-03,   8.3502987E-03
     +,   8.4269606E-03,   8.4711565E-03,   8.4812464E-03
     +,   8.4591340E-03,   8.4074503E-03,   8.3269384E-03
     +,   8.2155326E-03,   8.0699529E-03,   7.8890165E-03
     +,   7.6767164E-03,   7.4434723E-03,   7.2046807E-03
     +,   6.9772187E-03,   6.7755054E-03,   6.6084089E-03
     +,   6.4777485E-03,   6.3782465E-03,   6.2985038E-03
     +,   6.2228474E-03,   6.1337468E-03,   6.0148602E-03
     +,   5.8540734E-03,   5.6457417E-03,   5.3915768E-03
     +,   5.0995271E-03,   4.7815200E-03,   4.4505727E-03
     +,   4.1182847E-03,   3.7936708E-03,   3.4827788E-03
     +,   3.1894483E-03,   2.9160448E-03,   2.6641884E-03
     +,   2.4351059E-03,   2.2295085E-03,   2.0475292E-03
     +,   1.8884653E-03,   1.7508038E-03,   1.6323412E-03
     +,   1.5304307E-03,   1.4422828E-03,   1.3651786E-03
     +,   1.2966662E-03,   1.2346446E-03,   1.1773860E-03
     +,   1.1235271E-03,   1.0720015E-03,   1.0220282E-03
     +,   9.7303127E-04,   9.2463684E-04,   8.7662466E-04
     +,   8.2890643E-04,   7.8151620E-04,   7.3456310E-04
     +,   6.8823888E-04,   6.4277096E-04,   5.9841026E-04
     +,   5.5541779E-04,   5.1402749E-04,   4.7445783E-04
     +,   4.3687591E-04,   4.0141423E-04,   3.6815781E-04
     +,   3.3714072E-04,   3.0836082E-04,   2.8177796E-04
     +,   2.5732568E-04,   2.3491171E-04,   2.1442852E-04
     +,   1.9575786E-04,   1.7877556E-04,   1.6335763E-04
     +,   1.4937978E-04,   1.3672191E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wano_fus_100 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wano_fus_105(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  1.0522033E-06,   1.1181868E-06
     +,   1.1877634E-06,   1.2610933E-06,   1.3383444E-06
     +,   1.4196913E-06,   1.5053103E-06,   1.5953868E-06
     +,   1.6901130E-06,   1.7896824E-06,   1.8942989E-06
     +,   2.0041739E-06,   2.1195176E-06,   2.2405538E-06
     +,   2.3675125E-06,   2.5006229E-06,   2.6401278E-06
     +,   2.7862773E-06,   2.9393188E-06,   3.0995145E-06
     +,   3.2671312E-06,   3.4424443E-06,   3.6257247E-06
     +,   3.8172648E-06,   4.0173472E-06,   4.2262718E-06
     +,   4.4443386E-06,   4.6718610E-06,   4.9091391E-06
     +,   5.1564989E-06,   5.4142520E-06,   5.6827243E-06
     +,   5.9622448E-06,   6.2531462E-06,   6.5557497E-06
     +,   6.8703939E-06,   7.1974173E-06,   7.5371408E-06
     +,   7.8899029E-06,   8.2560400E-06,   8.6358668E-06
     +,   9.0297181E-06,   9.4379020E-06,   9.8607361E-06
     +,   1.0298524E-05,   1.0751574E-05,   1.1220157E-05
     +,   1.1704553E-05,   1.2205040E-05,   1.2721848E-05
     +,   1.3255221E-05,   1.3805391E-05,   1.4372533E-05
     +,   1.4956852E-05,   1.5558488E-05,   1.6177588E-05
     +,   1.6814265E-05,   1.7468612E-05,   1.8140703E-05
     +,   1.8830542E-05,   1.9538173E-05,   2.0263529E-05
     +,   2.1006586E-05,   2.1767260E-05,   2.2545406E-05
     +,   2.3340883E-05,   2.4153522E-05,   2.4983066E-05
     +,   2.5829278E-05,   2.6691871E-05,   2.7570519E-05
     +,   2.8464870E-05,   2.9374572E-05,   3.0299138E-05
     +,   3.1238164E-05,   3.2191176E-05,   3.3157699E-05
     +,   3.4137251E-05,   3.5129240E-05,   3.6133180E-05
     +,   3.7148537E-05,   3.8174778E-05,   3.9211442E-05
     +,   4.0257924E-05,   4.1313913E-05,   4.2378877E-05
     +,   4.3452506E-05,   4.4534510E-05,   4.5624678E-05
     +,   4.6722969E-05,   4.7829308E-05,   4.8943919E-05
     +,   5.0067141E-05,   5.1199484E-05,   5.2341704E-05
     +,   5.3494776E-05,   5.4660035E-05,   5.5838962E-05
     +,   5.7033507E-05,   5.8245976E-05,   5.9479087E-05
     +,   6.0736042E-05,   6.2020415E-05,   6.3336433E-05
     +,   6.4688851E-05,   6.6083034E-05,   6.7525027E-05
     +,   6.9021313E-05,   7.0579525E-05,   7.2207498E-05
     +,   7.3914125E-05,   7.5708907E-05,   7.7602068E-05
     +,   7.9604659E-05,   8.1727972E-05,   8.3984552E-05
     +,   8.6386921E-05,   8.8948298E-05,   9.1682268E-05
     +,   9.4602605E-05,   9.7723227E-05,   1.0105771E-04
     +,   1.0461974E-04,   1.0842248E-04,   1.1247848E-04
     +,   1.1679961E-04,   1.2139705E-04,   1.2628039E-04
     +,   1.3145871E-04,   1.3693993E-04,   1.4273070E-04
     +,   1.4883699E-04,   1.5526426E-04,   1.6201680E-04
     +,   1.6909982E-04,   1.7651884E-04,   1.8428078E-04
     +,   1.9239474E-04,   2.0087266E-04,   2.0973082E-04
     +,   2.1898939E-04,   2.2867548E-04,   2.3882266E-04
     +,   2.4947221E-04,   2.6067442E-04,   2.7248668E-04
     +,   2.8497929E-04,   2.9822919E-04,   3.1232496E-04
     +,   3.2736553E-04,   3.4345812E-04,   3.6072356E-04
     +,   3.7928933E-04,   3.9929606E-04,   4.2089453E-04
     +,   4.4424721E-04,   4.6952916E-04,   4.9692293E-04
     +,   5.2663003E-04,   5.5885344E-04,   5.9380685E-04
     +,   6.3170603E-04,   6.7275570E-04,   7.1715680E-04
     +,   7.6507340E-04,   8.1663602E-04,   8.7191933E-04
     +,   9.3092746E-04,   9.9358254E-04,   1.0596950E-03
     +,   1.1289837E-03,   1.2010328E-03,   1.2753198E-03
     +,   1.3512108E-03,   1.4279741E-03,   1.5048108E-03
     +,   1.5808691E-03,   1.6552949E-03,   1.7272605E-03
     +,   1.7960041E-03,   1.8608704E-03,   1.9213263E-03
     +,   1.9770213E-03,   2.0277738E-03,   2.0736239E-03
     +,   2.1148389E-03,   2.1519407E-03,   2.1857293E-03
     +,   2.2172951E-03,   2.2480430E-03,   2.2796590E-03
     +,   2.3140830E-03,   2.3534182E-03,   2.3997901E-03
     +,   2.4552001E-03,   2.5212851E-03,   2.5991409E-03
     +,   2.6890929E-03,   2.7905472E-03,   2.9019525E-03
     +,   3.0207508E-03,   3.1435713E-03,   3.2664118E-03
     +,   3.3849953E-03,   3.4951495E-03,   3.5932199E-03
     +,   3.6764964E-03,   3.7434578E-03,   3.7940149E-03
     +,   3.8294834E-03,   3.8524051E-03,   3.8662422E-03
     +,   3.8749087E-03,   3.8823278E-03,   3.8920462E-03
     +,   3.9069289E-03,   3.9290753E-03,   3.9597903E-03
     +,   3.9996980E-03,   4.0488034E-03,   4.1065286E-03
     +,   4.1716276E-03,   4.2420165E-03,   4.3145963E-03
     +,   4.3851151E-03,   4.4482551E-03,   4.4979006E-03
     +,   4.5277188E-03,   4.5319311E-03,   4.5061531E-03
     +,   4.4481596E-03,   4.3583848E-03,   4.2399750E-03
     +,   4.0985248E-03,   3.9413329E-03,   3.7765251E-03
     +,   3.6121523E-03,   3.4553781E-03,   3.3120157E-03
     +,   3.1862536E-03,   3.0807189E-03,   2.9966794E-03
     +,   2.9343241E-03,   2.8930539E-03,   2.8717001E-03
     +,   2.8687012E-03,   2.8822247E-03,   2.9102569E-03
     +,   2.9506909E-03,   3.0014776E-03,   3.0607039E-03
     +,   3.1267793E-03,   3.1985040E-03,   3.2751495E-03
     +,   3.3564863E-03,   3.4427138E-03,   3.5344246E-03
     +,   3.6324949E-03,   3.7380746E-03,   3.8524852E-03
     +,   3.9770980E-03,   4.1131927E-03,   4.2615444E-03
     +,   4.4220123E-03,   4.5930054E-03,   4.7710203E-03
     +,   4.9504186E-03,   5.1235529E-03,   5.2813245E-03
     +,   5.4140999E-03,   5.5128257E-03,   5.5701812E-03
     +,   5.5814083E-03,   5.5447812E-03,   5.4615838E-03
     +,   5.3356532E-03,   5.1726932E-03,   4.9794479E-03
     +,   4.7629708E-03,   4.5300866E-03,   4.2869207E-03
     +,   4.0387968E-03,   3.7900533E-03,   3.5440561E-03
     +,   3.3032708E-03,   3.0692448E-03,   2.8428535E-03
     +,   2.6243359E-03,   2.4136046E-03,   2.2104152E-03
     +,   2.0145120E-03,   1.8258604E-03,   1.6446699E-03
     +,   1.4714409E-03,   1.3068684E-03,   1.1517693E-03
     +,   1.0069651E-03,   8.7316346E-04,   7.5089507E-04
     +,   6.4042961E-04,   5.4177310E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wano_fus_105 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wano_fus_107(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  4.4231524E-06,   4.5330085E-06
     +,   4.6455648E-06,   4.7608796E-06,   4.8790193E-06
     +,   5.0000499E-06,   5.1240308E-06,   5.2510295E-06
     +,   5.3811114E-06,   5.5143387E-06,   5.6507783E-06
     +,   5.7904972E-06,   5.9335553E-06,   6.0800203E-06
     +,   6.2299573E-06,   6.3834259E-06,   6.5404920E-06
     +,   6.7012215E-06,   6.8656677E-06,   7.0338974E-06
     +,   7.2059684E-06,   7.3819429E-06,   7.5618723E-06
     +,   7.7458180E-06,   7.9338279E-06,   8.1259586E-06
     +,   8.3222612E-06,   8.5227866E-06,   8.7275766E-06
     +,   8.9366822E-06,   9.1501379E-06,   9.3679901E-06
     +,   9.5902724E-06,   9.8170303E-06,   1.0048283E-05
     +,   1.0284064E-05,   1.0524408E-05,   1.0769329E-05
     +,   1.1018852E-05,   1.1273001E-05,   1.1531782E-05
     +,   1.1795210E-05,   1.2063296E-05,   1.2336041E-05
     +,   1.2613450E-05,   1.2895529E-05,   1.3182267E-05
     +,   1.3473658E-05,   1.3769700E-05,   1.4070371E-05
     +,   1.4375661E-05,   1.4685560E-05,   1.5000036E-05
     +,   1.5319083E-05,   1.5642663E-05,   1.5970763E-05
     +,   1.6303353E-05,   1.6640406E-05,   1.6981909E-05
     +,   1.7327822E-05,   1.7678132E-05,   1.8032806E-05
     +,   1.8391836E-05,   1.8755209E-05,   1.9122906E-05
     +,   1.9494926E-05,   1.9871291E-05,   2.0251991E-05
     +,   2.0637075E-05,   2.1026573E-05,   2.1420550E-05
     +,   2.1819089E-05,   2.2222308E-05,   2.2630307E-05
     +,   2.3043267E-05,   2.3461384E-05,   2.3884902E-05
     +,   2.4314135E-05,   2.4749383E-05,   2.5191075E-05
     +,   2.5639678E-05,   2.6095746E-05,   2.6559926E-05
     +,   2.7032893E-05,   2.7515545E-05,   2.8008775E-05
     +,   2.8513652E-05,   2.9031367E-05,   2.9563258E-05
     +,   3.0110825E-05,   3.0675656E-05,   3.1259573E-05
     +,   3.1864551E-05,   3.2492746E-05,   3.3146491E-05
     +,   3.3828303E-05,   3.4540910E-05,   3.5287161E-05
     +,   3.6070142E-05,   3.6893107E-05,   3.7759466E-05
     +,   3.8672842E-05,   3.9636881E-05,   4.0655483E-05
     +,   4.1732630E-05,   4.2872427E-05,   4.4079108E-05
     +,   4.5356825E-05,   4.6710124E-05,   4.8143316E-05
     +,   4.9661016E-05,   5.1267853E-05,   5.2968651E-05
     +,   5.4768461E-05,   5.6672325E-05,   5.8686117E-05
     +,   6.0815582E-05,   6.3067491E-05,   6.5449116E-05
     +,   6.7968766E-05,   7.0635950E-05,   7.3461269E-05
     +,   7.6457320E-05,   7.9638579E-05,   8.3021805E-05
     +,   8.6626380E-05,   9.0474852E-05,   9.4592673E-05
     +,   9.9009289E-05,   1.0375802E-04,   1.0887632E-04
     +,   1.1440602E-04,   1.2039360E-04,   1.2688925E-04
     +,   1.3394824E-04,   1.4162929E-04,   1.4999500E-04
     +,   1.5911061E-04,   1.6904356E-04,   1.7986305E-04
     +,   1.9163721E-04,   2.0443431E-04,   2.1832059E-04
     +,   2.3335879E-04,   2.4960833E-04,   2.6712148E-04
     +,   2.8594930E-04,   3.0613301E-04,   3.2771111E-04
     +,   3.5071766E-04,   3.7518010E-04,   4.0112986E-04
     +,   4.2859258E-04,   4.5759950E-04,   4.8818585E-04
     +,   5.2039413E-04,   5.5427675E-04,   5.8989349E-04
     +,   6.2732404E-04,   6.6665182E-04,   7.0797693E-04
     +,   7.5140933E-04,   7.9705566E-04,   8.4503205E-04
     +,   8.9543290E-04,   9.4833435E-04,   1.0037733E-03
     +,   1.0617329E-03,   1.1221262E-03,   1.1847678E-03
     +,   1.2493798E-03,   1.3155558E-03,   1.3827742E-03
     +,   1.4504020E-03,   1.5177112E-03,   1.5839173E-03
     +,   1.6482190E-03,   1.7098727E-03,   1.7682526E-03
     +,   1.8229198E-03,   1.8736942E-03,   1.9206823E-03
     +,   1.9643262E-03,   2.0053729E-03,   2.0448428E-03
     +,   2.0839570E-03,   2.1240239E-03,   2.1663378E-03
     +,   2.2120404E-03,   2.2620407E-03,   2.3169047E-03
     +,   2.3768349E-03,   2.4416519E-03,   2.5108152E-03
     +,   2.5835144E-03,   2.6586875E-03,   2.7351566E-03
     +,   2.8116475E-03,   2.8868569E-03,   2.9595210E-03
     +,   3.0283919E-03,   3.0923162E-03,   3.1501995E-03
     +,   3.2010726E-03,   3.2441025E-03,   3.2786273E-03
     +,   3.3042079E-03,   3.3206705E-03,   3.3281615E-03
     +,   3.3272284E-03,   3.3188763E-03,   3.3046266E-03
     +,   3.2865463E-03,   3.2672286E-03,   3.2496897E-03
     +,   3.2371820E-03,   3.2329415E-03,   3.2398533E-03
     +,   3.2601287E-03,   3.2949969E-03,   3.3445067E-03
     +,   3.4074527E-03,   3.4814465E-03,   3.5631533E-03
     +,   3.6486075E-03,   3.7336424E-03,   3.8142444E-03
     +,   3.8869129E-03,   3.9488999E-03,   3.9983103E-03
     +,   4.0341220E-03,   4.0560458E-03,   4.0643630E-03
     +,   4.0597110E-03,   4.0428387E-03,   4.0144273E-03
     +,   3.9749742E-03,   3.9247442E-03,   3.8638299E-03
     +,   3.7922587E-03,   3.7102117E-03,   3.6182199E-03
     +,   3.5173686E-03,   3.4094343E-03,   3.2968863E-03
     +,   3.1828771E-03,   3.0710206E-03,   2.9651632E-03
     +,   2.8691285E-03,   2.7863965E-03,   2.7199388E-03
     +,   2.6720248E-03,   2.6441948E-03,   2.6372513E-03
     +,   2.6513350E-03,   2.6860242E-03,   2.7404544E-03
     +,   2.8133972E-03,   2.9033734E-03,   3.0087058E-03
     +,   3.1275623E-03,   3.2580192E-03,   3.3980329E-03
     +,   3.5454468E-03,   3.6979185E-03,   3.8528766E-03
     +,   4.0074727E-03,   4.1586123E-03,   4.3031205E-03
     +,   4.4380212E-03,   4.5609409E-03,   4.6705799E-03
     +,   4.7671259E-03,   4.8525110E-03,   4.9302899E-03
     +,   5.0052232E-03,   5.0823712E-03,   5.1659443E-03
     +,   5.2580521E-03,   5.3575933E-03,   5.4596965E-03
     +,   5.5557117E-03,   5.6340839E-03,   5.6817704E-03
     +,   5.6861197E-03,   5.6367172E-03,   5.5268831E-03
     +,   5.3545344E-03,   5.1223105E-03,   4.8370161E-03
     +,   4.5084632E-03,   4.1482975E-03,   3.7686592E-03
     +,   3.3812504E-03,   2.9965129E-03,   2.6233040E-03
     +,   2.2687300E-03,   1.9381630E-03,   1.6353942E-03
     +,   1.3627283E-03,   1.1211905E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wano_fus_107 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wano_fus_110(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  2.8678423E-06,   2.9145460E-06
     +,   2.9620521E-06,   3.0103952E-06,   3.0596148E-06
     +,   3.1097518E-06,   3.1608467E-06,   3.2129440E-06
     +,   3.2660914E-06,   3.3203351E-06,   3.3757256E-06
     +,   3.4323168E-06,   3.4901607E-06,   3.5493144E-06
     +,   3.6098384E-06,   3.6717893E-06,   3.7352322E-06
     +,   3.8002318E-06,   3.8668513E-06,   3.9351621E-06
     +,   4.0052319E-06,   4.0771370E-06,   4.1509456E-06
     +,   4.2267384E-06,   4.3045889E-06,   4.3845757E-06
     +,   4.4667827E-06,   4.5512911E-06,   4.6381833E-06
     +,   4.7275475E-06,   4.8194674E-06,   4.9140335E-06
     +,   5.0113367E-06,   5.1114712E-06,   5.2145283E-06
     +,   5.3206049E-06,   5.4298039E-06,   5.5422202E-06
     +,   5.6579638E-06,   5.7771431E-06,   5.8998662E-06
     +,   6.0262541E-06,   6.1564233E-06,   6.2905051E-06
     +,   6.4286328E-06,   6.5709546E-06,   6.7176143E-06
     +,   6.8687800E-06,   7.0246269E-06,   7.1853410E-06
     +,   7.3511255E-06,   7.5222119E-06,   7.6988308E-06
     +,   7.8812582E-06,   8.0697764E-06,   8.2647093E-06
     +,   8.4664052E-06,   8.6752516E-06,   8.8916822E-06
     +,   9.1161501E-06,   9.3491853E-06,   9.5913392E-06
     +,   9.8432465E-06,   1.0105590E-05,   1.0379113E-05
     +,   1.0664640E-05,   1.0963077E-05,   1.1275396E-05
     +,   1.1602669E-05,   1.1946064E-05,   1.2306840E-05
     +,   1.2686373E-05,   1.3086160E-05,   1.3507769E-05
     +,   1.3952940E-05,   1.4423527E-05,   1.4921525E-05
     +,   1.5449079E-05,   1.6008426E-05,   1.6602011E-05
     +,   1.7232414E-05,   1.7902359E-05,   1.8614786E-05
     +,   1.9372663E-05,   2.0179332E-05,   2.1038075E-05
     +,   2.1952474E-05,   2.2926228E-05,   2.3963201E-05
     +,   2.5067444E-05,   2.6243024E-05,   2.7494272E-05
     +,   2.8825585E-05,   3.0241488E-05,   3.1746615E-05
     +,   3.3345641E-05,   3.5043402E-05,   3.6844598E-05
     +,   3.8754108E-05,   4.0776809E-05,   4.2917538E-05
     +,   4.5181238E-05,   4.7572539E-05,   5.0096358E-05
     +,   5.2757474E-05,   5.5560642E-05,   5.8510883E-05
     +,   6.1612758E-05,   6.4871849E-05,   6.8293200E-05
     +,   7.1882714E-05,   7.5646720E-05,   7.9592362E-05
     +,   8.3727893E-05,   8.8062232E-05,   9.2606926E-05
     +,   9.7374425E-05,   1.0238009E-04,   1.0764175E-04
     +,   1.1318058E-04,   1.1902141E-04,   1.2519235E-04
     +,   1.3172670E-04,   1.3866200E-04,   1.4604079E-04
     +,   1.5391073E-04,   1.6232450E-04,   1.7133875E-04
     +,   1.8101529E-04,   1.9141923E-04,   2.0261835E-04
     +,   2.1468161E-04,   2.2767871E-04,   2.4167571E-04
     +,   2.5673624E-04,   2.7291712E-04,   2.9026685E-04
     +,   3.0882240E-04,   3.2860739E-04,   3.4963005E-04
     +,   3.7187833E-04,   3.9532213E-04,   4.1990966E-04
     +,   4.4556646E-04,   4.7219754E-04,   4.9968209E-04
     +,   5.2788632E-04,   5.5665208E-04,   5.8581261E-04
     +,   6.1519019E-04,   6.4460101E-04,   6.7387032E-04
     +,   7.0282689E-04,   7.3132187E-04,   7.5923215E-04
     +,   7.8646978E-04,   8.1299141E-04,   8.3880278E-04
     +,   8.6397480E-04,   8.8863674E-04,   9.1298955E-04
     +,   9.3730475E-04,   9.6191803E-04,   9.8723534E-04
     +,   1.0137117E-03,   1.0418504E-03,   1.0721846E-03
     +,   1.1052598E-03,   1.1416180E-03,   1.1817692E-03
     +,   1.2261858E-03,   1.2752602E-03,   1.3293020E-03
     +,   1.3885114E-03,   1.4529644E-03,   1.5226054E-03
     +,   1.5972290E-03,   1.6764996E-03,   1.7599500E-03
     +,   1.8469981E-03,   1.9369817E-03,   2.0291768E-03
     +,   2.1228734E-03,   2.2173778E-03,   2.3120916E-03
     +,   2.4065394E-03,   2.5004053E-03,   2.5935464E-03
     +,   2.6859888E-03,   2.7779394E-03,   2.8696901E-03
     +,   2.9615918E-03,   3.0539478E-03,   3.1469057E-03
     +,   3.2404114E-03,   3.3340927E-03,   3.4273367E-03
     +,   3.5193090E-03,   3.6091711E-03,   3.6963455E-03
     +,   3.7807692E-03,   3.8632283E-03,   3.9454848E-03
     +,   4.0303282E-03,   4.1213497E-03,   4.2224964E-03
     +,   4.3374831E-03,   4.4690189E-03,   4.6181520E-03
     +,   4.7837710E-03,   4.9623740E-03,   5.1483419E-03
     +,   5.3344830E-03,   5.5130664E-03,   5.6769368E-03
     +,   5.8205915E-03,   5.9410408E-03,   6.0380679E-03
     +,   6.1140503E-03,   6.1730631E-03,   6.2196944E-03
     +,   6.2577263E-03,   6.2889764E-03,   6.3126679E-03
     +,   6.3254386E-03,   6.3220193E-03,   6.2964573E-03
     +,   6.2435870E-03,   6.1604381E-03,   6.0472642E-03
     +,   5.9079397E-03,   5.7497560E-03,   5.5823661E-03
     +,   5.4165302E-03,   5.2623977E-03,   5.1280675E-03
     +,   5.0184955E-03,   4.9350159E-03,   4.8754998E-03
     +,   4.8351130E-03,   4.8074285E-03,   4.7856104E-03
     +,   4.7634440E-03,   4.7359895E-03,   4.6998211E-03
     +,   4.6529486E-03,   4.5944811E-03,   4.5242733E-03
     +,   4.4426546E-03,   4.3502143E-03,   4.2478475E-03
     +,   4.1367346E-03,   4.0184897E-03,   3.8951857E-03
     +,   3.7692897E-03,   3.6436755E-03,   3.5213670E-03
     +,   3.4054751E-03,   3.2989432E-03,   3.2044067E-03
     +,   3.1240827E-03,   3.0596172E-03,   3.0121030E-03
     +,   2.9820288E-03,   2.9693795E-03,   2.9737498E-03
     +,   2.9945055E-03,   3.0309795E-03,   3.0826924E-03
     +,   3.1494831E-03,   3.2316237E-03,   3.3297865E-03
     +,   3.4449289E-03,   3.5781015E-03,   3.7301506E-03
     +,   3.9016055E-03,   4.0924810E-03,   4.3024295E-03
     +,   4.5309253E-03,   4.7774916E-03,   5.0420179E-03
     +,   5.3246059E-03,   5.6252601E-03,   5.9430394E-03
     +,   6.2748832E-03,   6.6144480E-03,   6.9509600E-03
     +,   7.2688730E-03,   7.5482321E-03,   7.7661378E-03
     +,   7.8991577E-03,   7.9262108E-03,   7.8316070E-03
     +,   7.6075923E-03,   7.2558443E-03,   6.7877281E-03
     +,   6.2231850E-03,   5.5884868E-03,   4.9134362E-03
     +,   4.2281314E-03,   3.5602525E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wano_fus_110 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wano_fus_115(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  1.0279176E-06,   1.0642779E-06
     +,   1.1017213E-06,   1.1402716E-06,   1.1799548E-06
     +,   1.2207984E-06,   1.2628269E-06,   1.3060679E-06
     +,   1.3505493E-06,   1.3962964E-06,   1.4433379E-06
     +,   1.4917022E-06,   1.5414153E-06,   1.5925067E-06
     +,   1.6450056E-06,   1.6989385E-06,   1.7543348E-06
     +,   1.8112248E-06,   1.8696356E-06,   1.9295969E-06
     +,   1.9911386E-06,   2.0542909E-06,   2.1190817E-06
     +,   2.1855433E-06,   2.2537035E-06,   2.3235941E-06
     +,   2.3952471E-06,   2.4686947E-06,   2.5439670E-06
     +,   2.6210998E-06,   2.7001256E-06,   2.7810802E-06
     +,   2.8640018E-06,   2.9489306E-06,   3.0359042E-06
     +,   3.1249692E-06,   3.2161736E-06,   3.3095646E-06
     +,   3.4051993E-06,   3.5031408E-06,   3.6034485E-06
     +,   3.7062011E-06,   3.8114754E-06,   3.9193615E-06
     +,   4.0299601E-06,   4.1433832E-06,   4.2597530E-06
     +,   4.3792093E-06,   4.5019110E-06,   4.6280288E-06
     +,   4.7577601E-06,   4.8913289E-06,   5.0289750E-06
     +,   5.1709776E-06,   5.3176386E-06,   5.4693037E-06
     +,   5.6263539E-06,   5.7892094E-06,   5.9583449E-06
     +,   6.1342735E-06,   6.3175771E-06,   6.5088816E-06
     +,   6.7088822E-06,   6.9183511E-06,   7.1381160E-06
     +,   7.3690962E-06,   7.6122897E-06,   7.8687726E-06
     +,   8.1397238E-06,   8.4264166E-06,   8.7302224E-06
     +,   9.0526210E-06,   9.3952140E-06,   9.7596776E-06
     +,   1.0147845E-05,   1.0561663E-05,   1.1003192E-05
     +,   1.1474654E-05,   1.1978335E-05,   1.2516727E-05
     +,   1.3092416E-05,   1.3708155E-05,   1.4366847E-05
     +,   1.5071447E-05,   1.5825242E-05,   1.6631488E-05
     +,   1.7493698E-05,   1.8415536E-05,   1.9400823E-05
     +,   2.0453606E-05,   2.1577993E-05,   2.2778415E-05
     +,   2.4059460E-05,   2.5425952E-05,   2.6882924E-05
     +,   2.8435690E-05,   3.0089901E-05,   3.1851272E-05
     +,   3.3726072E-05,   3.5720790E-05,   3.7842288E-05
     +,   4.0097872E-05,   4.2495027E-05,   4.5041845E-05
     +,   4.7746769E-05,   5.0618688E-05,   5.3666990E-05
     +,   5.6901077E-05,   6.0331560E-05,   6.3968560E-05
     +,   6.7823028E-05,   7.1906172E-05,   7.6229342E-05
     +,   8.0804268E-05,   8.5642030E-05,   9.0754947E-05
     +,   9.6153919E-05,   1.0185027E-04,   1.0785484E-04
     +,   1.1417780E-04,   1.2082901E-04,   1.2781667E-04
     +,   1.3514880E-04,   1.4283218E-04,   1.5087232E-04
     +,   1.5927349E-04,   1.6803904E-04,   1.7717003E-04
     +,   1.8666738E-04,   1.9653043E-04,   2.0675770E-04
     +,   2.1734695E-04,   2.2829638E-04,   2.3960265E-04
     +,   2.5126472E-04,   2.6328251E-04,   2.7565815E-04
     +,   2.8839678E-04,   3.0150788E-04,   3.1500656E-04
     +,   3.2891327E-04,   3.4325747E-04,   3.5807752E-04
     +,   3.7342170E-04,   3.8935096E-04,   4.0593575E-04
     +,   4.2326417E-04,   4.4143258E-04,   4.6055330E-04
     +,   4.8075084E-04,   5.0215703E-04,   5.2491855E-04
     +,   5.4918265E-04,   5.7510420E-04,   6.0283864E-04
     +,   6.3254195E-04,   6.6436839E-04,   6.9846644E-04
     +,   7.3499262E-04,   7.7409629E-04,   8.1593829E-04
     +,   8.6069119E-04,   9.0853753E-04,   9.5969497E-04
     +,   1.0143941E-03,   1.0728969E-03,   1.1354879E-03
     +,   1.2024646E-03,   1.2741234E-03,   1.3507304E-03
     +,   1.4325214E-03,   1.5196389E-03,   1.6121335E-03
     +,   1.7099293E-03,   1.8128095E-03,   1.9204146E-03
     +,   2.0322362E-03,   2.1476615E-03,   2.2659968E-03
     +,   2.3865087E-03,   2.5084959E-03,   2.6313027E-03
     +,   2.7544415E-03,   2.8775646E-03,   3.0005779E-03
     +,   3.1236529E-03,   3.2472832E-03,   3.3723386E-03
     +,   3.5000998E-03,   3.6323231E-03,   3.7711912E-03
     +,   3.9192806E-03,   4.0793852E-03,   4.2542242E-03
     +,   4.4461028E-03,   4.6563498E-03,   4.8849080E-03
     +,   5.1298435E-03,   5.3872354E-03,   5.6515462E-03
     +,   5.9162844E-03,   6.1754929E-03,   6.4251223E-03
     +,   6.6644480E-03,   6.8965624E-03,   7.1275756E-03
     +,   7.3647774E-03,   7.6137655E-03,   7.8759799E-03
     +,   8.1473496E-03,   8.4186345E-03,   8.6778328E-03
     +,   8.9130485E-03,   9.1155199E-03,   9.2811482E-03
     +,   9.4106523E-03,   9.5084384E-03,   9.5810117E-03
     +,   9.6353320E-03,   9.6775200E-03,   9.7117312E-03
     +,   9.7394763E-03,   9.7594857E-03,   9.7687626E-03
     +,   9.7648781E-03,   9.7488333E-03,   9.7272024E-03
     +,   9.7120022E-03,   9.7177159E-03,   9.7561479E-03
     +,   9.8309861E-03,   9.9342680E-03,   1.0046287E-02
     +,   1.0139162E-02,   1.0182852E-02,   1.0152301E-02
     +,   1.0033466E-02,   9.8268529E-03,   9.5475595E-03
     +,   9.2217317E-03,   8.8806851E-03,   8.5544307E-03
     +,   8.2665924E-03,   8.0320127E-03,   7.8569762E-03
     +,   7.7410899E-03,   7.6791486E-03,   7.6620299E-03
     +,   7.6765702E-03,   7.7054175E-03,   7.7279401E-03
     +,   7.7230213E-03,   7.6731187E-03,   7.5685424E-03
     +,   7.4100159E-03,   7.2086388E-03,   6.9827996E-03
     +,   6.7534680E-03,   6.5390030E-03,   6.3514179E-03
     +,   6.1948639E-03,   6.0663130E-03,   5.9580132E-03
     +,   5.8604260E-03,   5.7650497E-03,   5.6663598E-03
     +,   5.5627413E-03,   5.4564872E-03,   5.3530354E-03
     +,   5.2598151E-03,   5.1848083E-03,   5.1351511E-03
     +,   5.1158741E-03,   5.1290253E-03,   5.1732189E-03
     +,   5.2437359E-03,   5.3329947E-03,   5.4314267E-03
     +,   5.5284631E-03,   5.6135403E-03,   5.6770165E-03
     +,   5.7108281E-03,   5.7089436E-03,   5.6675277E-03
     +,   5.5849385E-03,   5.4614479E-03,   5.2989596E-03
     +,   5.1005580E-03,   4.8702299E-03,   4.6125464E-03
     +,   4.3324172E-03,   4.0350365E-03,   3.7257320E-03
     +,   3.4099349E-03,   3.0929714E-03,   2.7799599E-03
     +,   2.4756128E-03,   2.1840667E-03,   1.9087810E-03
     +,   1.6523980E-03,   1.4167652E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wano_fus_115 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wano_fus_120(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  2.6272660E-06,   2.6983876E-06
     +,   2.7708079E-06,   2.8445324E-06,   2.9195689E-06
     +,   2.9959267E-06,   3.0736103E-06,   3.1526295E-06
     +,   3.2329926E-06,   3.3147057E-06,   3.3977797E-06
     +,   3.4822244E-06,   3.5680466E-06,   3.6552590E-06
     +,   3.7438749E-06,   3.8339026E-06,   3.9253582E-06
     +,   4.0182576E-06,   4.1126141E-06,   4.2084471E-06
     +,   4.3057762E-06,   4.4046246E-06,   4.5050115E-06
     +,   4.6069681E-06,   4.7105182E-06,   4.8156958E-06
     +,   4.9225346E-06,   5.0310759E-06,   5.1413567E-06
     +,   5.2534278E-06,   5.3673348E-06,   5.4831339E-06
     +,   5.6008867E-06,   5.7206612E-06,   5.8425217E-06
     +,   5.9665513E-06,   6.0928364E-06,   6.2214640E-06
     +,   6.3525358E-06,   6.4861624E-06,   6.6224579E-06
     +,   6.7615510E-06,   6.9035732E-06,   7.0486731E-06
     +,   7.1970089E-06,   7.3487536E-06,   7.5040793E-06
     +,   7.6631859E-06,   7.8262801E-06,   7.9935817E-06
     +,   8.1653234E-06,   8.3417617E-06,   8.5231559E-06
     +,   8.7097924E-06,   8.9019650E-06,   9.0999920E-06
     +,   9.3042072E-06,   9.5149608E-06,   9.7326292E-06
     +,   9.9575946E-06,   1.0190271E-05,   1.0431086E-05
     +,   1.0680491E-05,   1.0938964E-05,   1.1206997E-05
     +,   1.1485105E-05,   1.1773846E-05,   1.2073770E-05
     +,   1.2385487E-05,   1.2709613E-05,   1.3046804E-05
     +,   1.3397746E-05,   1.3763161E-05,   1.4143783E-05
     +,   1.4540413E-05,   1.4953876E-05,   1.5385051E-05
     +,   1.5834872E-05,   1.6304281E-05,   1.6794316E-05
     +,   1.7306067E-05,   1.7840686E-05,   1.8399409E-05
     +,   1.8983468E-05,   1.9594325E-05,   2.0233367E-05
     +,   2.0902176E-05,   2.1602393E-05,   2.2335775E-05
     +,   2.3104210E-05,   2.3909606E-05,   2.4754088E-05
     +,   2.5639862E-05,   2.6569254E-05,   2.7544722E-05
     +,   2.8568847E-05,   2.9644358E-05,   3.0774001E-05
     +,   3.1960746E-05,   3.3207616E-05,   3.4517740E-05
     +,   3.5894387E-05,   3.7340698E-05,   3.8860057E-05
     +,   4.0455805E-05,   4.2131283E-05,   4.3889875E-05
     +,   4.5734643E-05,   4.7669040E-05,   4.9695900E-05
     +,   5.1818224E-05,   5.4038726E-05,   5.6359906E-05
     +,   5.8784102E-05,   6.1312960E-05,   6.3948559E-05
     +,   6.6691820E-05,   6.9543785E-05,   7.2504983E-05
     +,   7.5575539E-05,   7.8755278E-05,   8.2043312E-05
     +,   8.5438696E-05,   8.8940011E-05,   9.2545546E-05
     +,   9.6253309E-05,   1.0006133E-04,   1.0396702E-04
     +,   1.0796831E-04,   1.1206303E-04,   1.1624936E-04
     +,   1.2052581E-04,   1.2489174E-04,   1.2934675E-04
     +,   1.3389191E-04,   1.3852934E-04,   1.4326262E-04
     +,   1.4809704E-04,   1.5303979E-04,   1.5810046E-04
     +,   1.6329072E-04,   1.6862551E-04,   1.7412264E-04
     +,   1.7980342E-04,   1.8569326E-04,   1.9182073E-04
     +,   1.9822064E-04,   2.0493136E-04,   2.1199739E-04
     +,   2.1946985E-04,   2.2740498E-04,   2.3586887E-04
     +,   2.4493336E-04,   2.5468011E-04,   2.6520016E-04
     +,   2.7659422E-04,   2.8897406E-04,   3.0245952E-04
     +,   3.1718452E-04,   3.3328848E-04,   3.5092156E-04
     +,   3.7024019E-04,   3.9140283E-04,   4.1457458E-04
     +,   4.3991464E-04,   4.6758252E-04,   4.9773220E-04
     +,   5.3051440E-04,   5.6607713E-04,   6.0456526E-04
     +,   6.4614147E-04,   6.9097377E-04,   7.3926349E-04
     +,   7.9124665E-04,   8.4720494E-04,   9.0747734E-04
     +,   9.7245158E-04,   1.0425794E-03,   1.1183617E-03
     +,   1.2003419E-03,   1.2891003E-03,   1.3852236E-03
     +,   1.4893336E-03,   1.6020230E-03,   1.7238817E-03
     +,   1.8554522E-03,   1.9972024E-03,   2.1494753E-03
     +,   2.3123960E-03,   2.4858625E-03,   2.6693770E-03
     +,   2.8620719E-03,   3.0626652E-03,   3.2694608E-03
     +,   3.4805434E-03,   3.6938402E-03,   3.9074430E-03
     +,   4.1197701E-03,   4.3298150E-03,   4.5373403E-03
     +,   4.7428240E-03,   4.9474351E-03,   5.1526199E-03
     +,   5.3597256E-03,   5.5693816E-03,   5.7809488E-03
     +,   5.9922473E-03,   6.1994982E-03,   6.3980371E-03
     +,   6.5834969E-03,   6.7533795E-03,   6.9086561E-03
     +,   7.0544370E-03,   7.1993698E-03,   7.3534152E-03
     +,   7.5245546E-03,   7.7156886E-03,   7.9230415E-03
     +,   8.1373341E-03,   8.3470913E-03,   8.5431859E-03
     +,   8.7220157E-03,   8.8858940E-03,   9.0401405E-03
     +,   9.1883726E-03,   9.3285469E-03,   9.4517600E-03
     +,   9.5447088E-03,   9.5941322E-03,   9.5914034E-03
     +,   9.5350938E-03,   9.4310977E-03,   9.2911981E-03
     +,   9.1312164E-03,   8.9694392E-03,   8.8253766E-03
     +,   8.7181376E-03,   8.6641302E-03,   8.6742342E-03
     +,   8.7514427E-03,   8.8896547E-03,   9.0744430E-03
     +,   9.2853261E-03,   9.4986940E-03,   9.6906321E-03
     +,   9.8390775E-03,   9.9258963E-03,   9.9391853E-03
     +,   9.8756943E-03,   9.7425757E-03,   9.5573887E-03
     +,   9.3453843E-03,   9.1347033E-03,   8.9501096E-03
     +,   8.8072503E-03,   8.7091336E-03,   8.6458474E-03
     +,   8.5980976E-03,   8.5435063E-03,   8.4639406E-03
     +,   8.3513949E-03,   8.2104122E-03,   8.0562998E-03
     +,   7.9096574E-03,   7.7895885E-03,   7.7078827E-03
     +,   7.6661673E-03,   7.6565496E-03,   7.6648700E-03
     +,   7.6751146E-03,   7.6731583E-03,   7.6491111E-03
     +,   7.5977668E-03,   7.5177522E-03,   7.4100695E-03
     +,   7.2765062E-03,   7.1186451E-03,   6.9373660E-03
     +,   6.7330119E-03,   6.5059583E-03,   6.2570805E-03
     +,   5.9883399E-03,   5.7029100E-03,   5.4051322E-03
     +,   5.1002284E-03,   4.7936752E-03,   4.4907322E-03
     +,   4.1956562E-03,   3.9113401E-03,   3.6390063E-03
     +,   3.3782576E-03,   3.1275449E-03,   2.8847279E-03
     +,   2.6477771E-03,   2.4152738E-03,   2.1867910E-03
     +,   1.9629672E-03,   1.7453522E-03,   1.5361308E-03
     +,   1.3377008E-03,   1.1523444E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wano_fus_120 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wano_fus_60(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  1.3808237E-04,   1.4727926E-04
     +,   1.5746521E-04,   1.6879194E-04,   1.8142541E-04
     +,   1.9554126E-04,   2.1131834E-04,   2.2893297E-04
     +,   2.4854988E-04,   2.7031181E-04,   2.9433277E-04
     +,   3.2068935E-04,   3.4941392E-04,   3.8049652E-04
     +,   4.1388645E-04,   4.4950037E-04,   4.8724003E-04
     +,   5.2701071E-04,   5.6874135E-04,   6.1240891E-04
     +,   6.5805425E-04,   7.0579018E-04,   7.5579662E-04
     +,   8.0831326E-04,   8.6361216E-04,   9.2198909E-04
     +,   9.8375126E-04,   1.0492422E-03,   1.1188806E-03
     +,   1.1932339E-03,   1.2730748E-03,   1.3594211E-03
     +,   1.4534950E-03,   1.5565977E-03,   1.6698774E-03
     +,   1.7940520E-03,   1.9291217E-03,   2.0741413E-03
     +,   2.2271606E-03,   2.3853038E-03,   2.5449868E-03
     +,   2.7022413E-03,   2.8529866E-03,   2.9932943E-03
     +,   3.1195276E-03,   3.2284653E-03,   3.3174148E-03
     +,   3.3843992E-03,   3.4283348E-03,   3.4492034E-03
     +,   3.4480719E-03,   3.4269267E-03,   3.3883322E-03
     +,   3.3349553E-03,   3.2691602E-03,   3.1927398E-03
     +,   3.1069191E-03,   3.0125838E-03,   2.9106275E-03
     +,   2.8023168E-03,   2.6894757E-03,   2.5744785E-03
     +,   2.4600115E-03,   2.3486889E-03,   2.2426425E-03
     +,   2.1431604E-03,   2.0504955E-03,   1.9638706E-03
     +,   1.8816526E-03,   1.8016748E-03,   1.7216337E-03
     +,   1.6394758E-03,   1.5537189E-03,   1.4636790E-03
     +,   1.3695281E-03,   1.2722589E-03,   1.1735178E-03
     +,   1.0753665E-03,   9.8002935E-04,   8.8961155E-04
     +,   8.0589770E-04,   7.3019735E-04,   6.6326995E-04
     +,   6.0533482E-04,   5.5610604E-04,   5.1492645E-04
     +,   4.8086664E-04,   4.5285671E-04,   4.2979387E-04
     +,   4.1062632E-04,   3.9441296E-04,   3.8035089E-04
     +,   3.6778787E-04,   3.5621566E-04,   3.4525513E-04
     +,   3.3463453E-04,   3.2416970E-04,   3.1374511E-04
     +,   3.0329562E-04,   2.9279487E-04,   2.8224426E-04
     +,   2.7166522E-04,   2.6109474E-04,   2.5057857E-04
     +,   2.4016896E-04,   2.2992166E-04,   2.1989302E-04
     +,   2.1013945E-04,   2.0071174E-04,   1.9165862E-04
     +,   1.8302165E-04,   1.7483595E-04,   1.6712952E-04
     +,   1.5992245E-04,   1.5322850E-04,   1.4705233E-04
     +,   1.4139348E-04,   1.3624461E-04,   1.3159294E-04
     +,   1.2742131E-04,   1.2370849E-04,   1.2043082E-04
     +,   1.1756203E-04,   1.1507444E-04,   1.1293974E-04
     +,   1.1112922E-04,   1.0961438E-04,   1.0836747E-04
     +,   1.0736148E-04,   1.0657052E-04,   1.0596999E-04
     +,   1.0553666E-04,   1.0524868E-04,   1.0508564E-04
     +,   1.0502859E-04,   1.0505987E-04,   1.0516323E-04
     +,   1.0532359E-04,   1.0552717E-04,   1.0576128E-04
     +,   1.0601426E-04,   1.0627544E-04,   1.0653512E-04
     +,   1.0678435E-04,   1.0701505E-04,   1.0721978E-04
     +,   1.0739190E-04,   1.0752519E-04,   1.0761417E-04
     +,   1.0765386E-04,   1.0763972E-04,   1.0756771E-04
     +,   1.0743426E-04,   1.0723624E-04,   1.0697086E-04
     +,   1.0663579E-04,   1.0622909E-04,   1.0574924E-04
     +,   1.0519502E-04,   1.0456566E-04,   1.0386082E-04
     +,   1.0308044E-04,   1.0222501E-04,   1.0129518E-04
     +,   1.0029224E-04,   9.9217672E-05,   9.8073440E-05
     +,   9.6861797E-05,   9.5585383E-05,   9.4247276E-05
     +,   9.2850605E-05,   9.1399081E-05,   8.9896581E-05
     +,   8.8347122E-05,   8.6755121E-05,   8.5124957E-05
     +,   8.3461462E-05,   8.1769351E-05,   8.0053469E-05
     +,   7.8318757E-05,   7.6570046E-05,   7.4812451E-05
     +,   7.3050556E-05,   7.1289323E-05,   6.9533337E-05
     +,   6.7787070E-05,   6.6054869E-05,   6.4340769E-05
     +,   6.2648855E-05,   6.0982544E-05,   5.9345406E-05
     +,   5.7740526E-05,   5.6170677E-05,   5.4638585E-05
     +,   5.3146283E-05,   5.1695974E-05,   5.0289091E-05
     +,   4.8927119E-05,   4.7611258E-05,   4.6342106E-05
     +,   4.5120389E-05,   4.3946206E-05,   4.2819716E-05
     +,   4.1740674E-05,   4.0708630E-05,   3.9723069E-05
     +,   3.8783019E-05,   3.7887628E-05,   3.7035734E-05
     +,   3.6226029E-05,   3.5457222E-05,   3.4727724E-05
     +,   3.4036046E-05,   3.3380518E-05,   3.2759450E-05
     +,   3.2171116E-05,   3.1613727E-05,   3.1085583E-05
     +,   3.0584833E-05,   3.0109759E-05,   2.9658606E-05
     +,   2.9229659E-05,   2.8821234E-05,   2.8431681E-05
     +,   2.8059454E-05,   2.7702963E-05,   2.7360786E-05
     +,   2.7031483E-05,   2.6713722E-05,   2.6406224E-05
     +,   2.6107768E-05,   2.5817259E-05,   2.5533589E-05
     +,   2.5255800E-05,   2.4982959E-05,   2.4714222E-05
     +,   2.4448802E-05,   2.4185982E-05,   2.3925126E-05
     +,   2.3665643E-05,   2.3407018E-05,   2.3148776E-05
     +,   2.2890508E-05,   2.2631884E-05,   2.2372566E-05
     +,   2.2112319E-05,   2.1850934E-05,   2.1588225E-05
     +,   2.1324098E-05,   2.1058420E-05,   2.0791171E-05
     +,   2.0522291E-05,   2.0251795E-05,   1.9979738E-05
     +,   1.9706124E-05,   1.9431072E-05,   1.9154631E-05
     +,   1.8876945E-05,   1.8598119E-05,   1.8318284E-05
     +,   1.8037616E-05,   1.7756227E-05,   1.7474316E-05
     +,   1.7192033E-05,   1.6909560E-05,   1.6627062E-05
     +,   1.6344717E-05,   1.6062713E-05,   1.5781223E-05
     +,   1.5500420E-05,   1.5220476E-05,   1.4941552E-05
     +,   1.4663844E-05,   1.4387474E-05,   1.4112637E-05
     +,   1.3839443E-05,   1.3568068E-05,   1.3298643E-05
     +,   1.3031286E-05,   1.2766155E-05,   1.2503328E-05
     +,   1.2242947E-05,   1.1985107E-05,   1.1729896E-05
     +,   1.1477434E-05,   1.1227766E-05,   1.0981007E-05
     +,   1.0737193E-05,   1.0496402E-05,   1.0258714E-05
     +,   1.0024150E-05,   9.7927659E-06,   9.5645937E-06
     +,   9.3396839E-06,   9.1180573E-06,   8.8997385E-06
     +,   8.6847467E-06,   8.4730891E-06,   8.2647921E-06
     +,   8.0598529E-06,   7.8582761E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wano_fus_60 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wano_fus_65(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  4.9539009E-05,   5.2733893E-05
     +,   5.6176181E-05,   5.9877446E-05,   6.3848252E-05
     +,   6.8097790E-05,   7.2633316E-05,   7.7460594E-05
     +,   8.2583509E-05,   8.8003762E-05,   9.3721566E-05
     +,   9.9735422E-05,   1.0604213E-04,   1.1263765E-04
     +,   1.1951735E-04,   1.2667586E-04,   1.3410837E-04
     +,   1.4181068E-04,   1.4977902E-04,   1.5801123E-04
     +,   1.6650630E-04,   1.7526404E-04,   1.8428503E-04
     +,   1.9357023E-04,   2.0311974E-04,   2.1293275E-04
     +,   2.2300651E-04,   2.3333621E-04,   2.4391468E-04
     +,   2.5473419E-04,   2.6578773E-04,   2.7707370E-04
     +,   2.8860089E-04,   3.0039632E-04,   3.1251405E-04
     +,   3.2504948E-04,   3.3815127E-04,   3.5203702E-04
     +,   3.6700969E-04,   3.8347082E-04,   4.0193068E-04
     +,   4.2301440E-04,   4.4745568E-04,   4.7608424E-04
     +,   5.0979364E-04,   5.4949964E-04,   5.9607776E-04
     +,   6.5029669E-04,   7.1274163E-04,   7.8373437E-04
     +,   8.6327997E-04,   9.5102470E-04,   1.0462484E-03
     +,   1.1479162E-03,   1.2547490E-03,   1.3653616E-03
     +,   1.4784049E-03,   1.5927191E-03,   1.7074664E-03
     +,   1.8221975E-03,   1.9368640E-03,   2.0517125E-03
     +,   2.1671304E-03,   2.2834099E-03,   2.4004909E-03
     +,   2.5177738E-03,   2.6339723E-03,   2.7471010E-03
     +,   2.8546026E-03,   2.9535710E-03,   3.0410648E-03
     +,   3.1144344E-03,   3.1716202E-03,   3.2113427E-03
     +,   3.2332006E-03,   3.2376344E-03,   3.2257766E-03
     +,   3.1992402E-03,   3.1598955E-03,   3.1096314E-03
     +,   3.0502020E-03,   2.9831117E-03,   2.9095709E-03
     +,   2.8305342E-03,   2.7467215E-03,   2.6587234E-03
     +,   2.5670361E-03,   2.4721241E-03,   2.3744470E-03
     +,   2.2744669E-03,   2.1726782E-03,   2.0695832E-03
     +,   1.9657323E-03,   1.8617372E-03,   1.7582882E-03
     +,   1.6561694E-03,   1.5562432E-03,   1.4594337E-03
     +,   1.3666532E-03,   1.2787452E-03,   1.1964068E-03
     +,   1.1201237E-03,   1.0501345E-03,   9.8640251E-04
     +,   9.2863792E-04,   8.7634026E-04,   8.2885905E-04
     +,   7.8547234E-04,   7.4544159E-04,   7.0809625E-04
     +,   6.7286409E-04,   6.3930720E-04,   6.0713198E-04
     +,   5.7618140E-04,   5.4642354E-04,   5.1791116E-04
     +,   4.9076817E-04,   4.6514734E-04,   4.4120883E-04
     +,   4.1909542E-04,   3.9891718E-04,   3.8074396E-04
     +,   3.6459617E-04,   3.5044877E-04,   3.3823479E-04
     +,   3.2785174E-04,   3.1917018E-04,   3.1204376E-04
     +,   3.0631496E-04,   3.0182488E-04,   2.9841810E-04
     +,   2.9594824E-04,   2.9428050E-04,   2.9329420E-04
     +,   2.9288293E-04,   2.9295479E-04,   2.9343099E-04
     +,   2.9424470E-04,   2.9533939E-04,   2.9666664E-04
     +,   2.9818490E-04,   2.9985738E-04,   3.0165134E-04
     +,   3.0353628E-04,   3.0548338E-04,   3.0746439E-04
     +,   3.0945233E-04,   3.1141966E-04,   3.1333970E-04
     +,   3.1518575E-04,   3.1693146E-04,   3.1855123E-04
     +,   3.2002007E-04,   3.2131415E-04,   3.2241087E-04
     +,   3.2328951E-04,   3.2393084E-04,   3.2431740E-04
     +,   3.2443428E-04,   3.2426851E-04,   3.2380968E-04
     +,   3.2304961E-04,   3.2198295E-04,   3.2060628E-04
     +,   3.1891916E-04,   3.1692348E-04,   3.1462344E-04
     +,   3.1202575E-04,   3.0913897E-04,   3.0597454E-04
     +,   3.0254500E-04,   2.9886546E-04,   2.9495239E-04
     +,   2.9082369E-04,   2.8649883E-04,   2.8199804E-04
     +,   2.7734312E-04,   2.7255589E-04,   2.6765891E-04
     +,   2.6267508E-04,   2.5762702E-04,   2.5253801E-04
     +,   2.4742971E-04,   2.4232430E-04,   2.3724284E-04
     +,   2.3220526E-04,   2.2723056E-04,   2.2233647E-04
     +,   2.1753999E-04,   2.1285533E-04,   2.0829659E-04
     +,   2.0387545E-04,   1.9960194E-04,   1.9548522E-04
     +,   1.9153133E-04,   1.8774634E-04,   1.8413302E-04
     +,   1.8069382E-04,   1.7742923E-04,   1.7433781E-04
     +,   1.7141753E-04,   1.6866413E-04,   1.6607300E-04
     +,   1.6363799E-04,   1.6135184E-04,   1.5920689E-04
     +,   1.5719410E-04,   1.5530435E-04,   1.5352762E-04
     +,   1.5185359E-04,   1.5027171E-04,   1.4877104E-04
     +,   1.4734075E-04,   1.4596988E-04,   1.4464765E-04
     +,   1.4336346E-04,   1.4210677E-04,   1.4086784E-04
     +,   1.3963674E-04,   1.3840447E-04,   1.3716237E-04
     +,   1.3590221E-04,   1.3461664E-04,   1.3329861E-04
     +,   1.3194207E-04,   1.3054122E-04,   1.2909129E-04
     +,   1.2758803E-04,   1.2602787E-04,   1.2440795E-04
     +,   1.2272601E-04,   1.2098064E-04,   1.1917069E-04
     +,   1.1729604E-04,   1.1535689E-04,   1.1335414E-04
     +,   1.1128910E-04,   1.0916359E-04,   1.0698013E-04
     +,   1.0474140E-04,   1.0245055E-04,   1.0011120E-04
     +,   9.7727039E-05,   9.5302516E-05,   9.2841670E-05
     +,   9.0349378E-05,   8.7830354E-05,   8.5289335E-05
     +,   8.2731669E-05,   8.0162041E-05,   7.7585937E-05
     +,   7.5008065E-05,   7.2433693E-05,   6.9867951E-05
     +,   6.7315399E-05,   6.4781168E-05,   6.2269501E-05
     +,   5.9785150E-05,   5.7332269E-05,   5.4914817E-05
     +,   5.2536885E-05,   5.0201681E-05,   4.7912828E-05
     +,   4.5673281E-05,   4.3485830E-05,   4.1353007E-05
     +,   3.9276943E-05,   3.7259764E-05,   3.5303085E-05
     +,   3.3408276E-05,   3.1576463E-05,   2.9808451E-05
     +,   2.8105031E-05,   2.6466278E-05,   2.4892570E-05
     +,   2.3383536E-05,   2.1939015E-05,   2.0558409E-05
     +,   1.9240930E-05,   1.7985829E-05,   1.6791837E-05
     +,   1.5657883E-05,   1.4582570E-05,   1.3564401E-05
     +,   1.2601918E-05,   1.1693319E-05,   1.0837013E-05
     +,   1.0031079E-05,   9.2737446E-06,   8.5631846E-06
     +,   7.8974153E-06,   7.2745506E-06,   6.6926541E-06
     +,   6.1498572E-06,   5.6442418E-06,   5.1739344E-06
     +,   4.7370913E-06,   4.3318901E-06,   3.9565962E-06
     +,   3.6094752E-06,   3.2888584E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wano_fus_65 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wano_fus_70(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  6.8166701E-05,   7.2206334E-05
     +,   7.6394208E-05,   8.0728329E-05,   8.5206586E-05
     +,   8.9826404E-05,   9.4584495E-05,   9.9477475E-05
     +,   1.0450168E-04,   1.0965293E-04,   1.1492720E-04
     +,   1.2032050E-04,   1.2582877E-04,   1.3144872E-04
     +,   1.3717782E-04,   1.4301430E-04,   1.4895828E-04
     +,   1.5501174E-04,   1.6117898E-04,   1.6746772E-04
     +,   1.7388922E-04,   1.8045923E-04,   1.8719805E-04
     +,   1.9413199E-04,   2.0129274E-04,   2.0871848E-04
     +,   2.1645364E-04,   2.2454867E-04,   2.3305921E-04
     +,   2.4204585E-04,   2.5157188E-04,   2.6170249E-04
     +,   2.7250187E-04,   2.8403121E-04,   2.9634481E-04
     +,   3.0948810E-04,   3.2349493E-04,   3.3838299E-04
     +,   3.5415345E-04,   3.7078877E-04,   3.8825095E-04
     +,   4.0648467E-04,   4.2541680E-04,   4.4496229E-04
     +,   4.6502904E-04,   4.8552500E-04,   5.0636509E-04
     +,   5.2748248E-04,   5.4883672E-04,   5.7042117E-04
     +,   5.9227232E-04,   6.1447395E-04,   6.3715631E-04
     +,   6.6049752E-04,   6.8471296E-04,   7.1004726E-04
     +,   7.3675724E-04,   7.6509552E-04,   7.9529034E-04
     +,   8.2752522E-04,   8.6192723E-04,   8.9854928E-04
     +,   9.3736843E-04,   9.7828673E-04,   1.0211356E-03
     +,   1.0656954E-03,   1.1117089E-03,   1.1589011E-03
     +,   1.2069978E-03,   1.2557380E-03,   1.3048811E-03
     +,   1.3542111E-03,   1.4035344E-03,   1.4526733E-03
     +,   1.5014816E-03,   1.5498481E-03,   1.5977265E-03
     +,   1.6451715E-03,   1.6923801E-03,   1.7397555E-03
     +,   1.7879393E-03,   1.8378341E-03,   1.8906064E-03
     +,   1.9476225E-03,   2.0103974E-03,   2.0804286E-03
     +,   2.1590809E-03,   2.2474038E-03,   2.3459741E-03
     +,   2.4547640E-03,   2.5730259E-03,   2.6992657E-03
     +,   2.8312397E-03,   2.9660403E-03,   3.1002127E-03
     +,   3.2299459E-03,   3.3512767E-03,   3.4602964E-03
     +,   3.5533838E-03,   3.6273692E-03,   3.6796695E-03
     +,   3.7084001E-03,   3.7123910E-03,   3.6912379E-03
     +,   3.6452827E-03,   3.5756147E-03,   3.4840554E-03
     +,   3.3731549E-03,   3.2461223E-03,   3.1067850E-03
     +,   2.9594246E-03,   2.8086009E-03,   2.6589159E-03
     +,   2.5147367E-03,   2.3799667E-03,   2.2577620E-03
     +,   2.1504269E-03,   2.0592895E-03,   1.9847103E-03
     +,   1.9261605E-03,   1.8823541E-03,   1.8514091E-03
     +,   1.8310265E-03,   1.8186716E-03,   1.8117287E-03
     +,   1.8076394E-03,   1.8040111E-03,   1.7987061E-03
     +,   1.7899123E-03,   1.7761955E-03,   1.7565329E-03
     +,   1.7303404E-03,   1.6974671E-03,   1.6581868E-03
     +,   1.6131562E-03,   1.5633546E-03,   1.5100108E-03
     +,   1.4545075E-03,   1.3982832E-03,   1.3427322E-03
     +,   1.2891199E-03,   1.2384915E-03,   1.1916319E-03
     +,   1.1490291E-03,   1.1108690E-03,   1.0770615E-03
     +,   1.0472647E-03,   1.0209546E-03,   9.9747139E-04
     +,   9.7609067E-04,   9.5608208E-04,   9.3675533E-04
     +,   9.1751019E-04,   8.9785852E-04,   8.7744411E-04
     +,   8.5604709E-04,   8.3357823E-04,   8.1006985E-04
     +,   7.8564684E-04,   7.6051755E-04,   7.3494070E-04
     +,   7.0920563E-04,   6.8361493E-04,   6.5845740E-04
     +,   6.3400628E-04,   6.1049778E-04,   5.8813038E-04
     +,   5.6705967E-04,   5.4739695E-04,   5.2921550E-04
     +,   5.1254453E-04,   4.9738545E-04,   4.8370793E-04
     +,   4.7145982E-04,   4.6057030E-04,   4.5095562E-04
     +,   4.4252351E-04,   4.3517485E-04,   4.2880865E-04
     +,   4.2332252E-04,   4.1861529E-04,   4.1458872E-04
     +,   4.1114647E-04,   4.0819676E-04,   4.0565166E-04
     +,   4.0342697E-04,   4.0144401E-04,   3.9962804E-04
     +,   3.9791013E-04,   3.9622595E-04,   3.9451671E-04
     +,   3.9272968E-04,   3.9081776E-04,   3.8874030E-04
     +,   3.8646226E-04,   3.8395583E-04,   3.8119865E-04
     +,   3.7817497E-04,   3.7487564E-04,   3.7129584E-04
     +,   3.6743775E-04,   3.6330675E-04,   3.5891420E-04
     +,   3.5427418E-04,   3.4940397E-04,   3.4432422E-04
     +,   3.3905584E-04,   3.3362242E-04,   3.2804726E-04
     +,   3.2235359E-04,   3.1656522E-04,   3.1070301E-04
     +,   3.0478821E-04,   2.9883964E-04,   2.9287409E-04
     +,   2.8690649E-04,   2.8094958E-04,   2.7501449E-04
     +,   2.6910898E-04,   2.6324028E-04,   2.5741305E-04
     +,   2.5163041E-04,   2.4589422E-04,   2.4020496E-04
     +,   2.3456295E-04,   2.2896660E-04,   2.2341523E-04
     +,   2.1790729E-04,   2.1244133E-04,   2.0701620E-04
     +,   2.0163097E-04,   1.9628582E-04,   1.9098040E-04
     +,   1.8571616E-04,   1.8049458E-04,   1.7531800E-04
     +,   1.7018941E-04,   1.6511232E-04,   1.6009129E-04
     +,   1.5513079E-04,   1.5023594E-04,   1.4541212E-04
     +,   1.4066479E-04,   1.3600009E-04,   1.3142302E-04
     +,   1.2693953E-04,   1.2255480E-04,   1.1827371E-04
     +,   1.1410127E-04,   1.1004097E-04,   1.0609710E-04
     +,   1.0227211E-04,   9.8568766E-05,   9.4989162E-05
     +,   9.1534013E-05,   8.8204441E-05,   8.4999905E-05
     +,   8.1920167E-05,   7.8963938E-05,   7.6129414E-05
     +,   7.3414689E-05,   7.0816706E-05,   6.8332716E-05
     +,   6.5959204E-05,   6.3692460E-05,   6.1528524E-05
     +,   5.9463189E-05,   5.7492241E-05,   5.5611232E-05
     +,   5.3815638E-05,   5.2100975E-05,   5.0462681E-05
     +,   4.8896512E-05,   4.7397883E-05,   4.5962748E-05
     +,   4.4586799E-05,   4.3266209E-05,   4.1997140E-05
     +,   4.0775933E-05,   3.9599301E-05,   3.8463833E-05
     +,   3.7366648E-05,   3.6304860E-05,   3.5275843E-05
     +,   3.4277269E-05,   3.3306784E-05,   3.2362510E-05
     +,   3.1442458E-05,   3.0545030E-05,   2.9668818E-05
     +,   2.8812365E-05,   2.7974547E-05,   2.7154283E-05
     +,   2.6350728E-05,   2.5563062E-05,   2.4790632E-05
     +,   2.4032843E-05,   2.3289207E-05,   2.2559381E-05
     +,   2.1843021E-05,   2.1139884E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wano_fus_70 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wano_fus_75(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  3.3509412E-05,   3.4701945E-05
     +,   3.5916582E-05,   3.7152644E-05,   3.8409598E-05
     +,   3.9687035E-05,   4.0984618E-05,   4.2302276E-05
     +,   4.3640171E-05,   4.4998636E-05,   4.6378424E-05
     +,   4.7780621E-05,   4.9206665E-05,   5.0658531E-05
     +,   5.2138665E-05,   5.3650034E-05,   5.5196248E-05
     +,   5.6781599E-05,   5.8410955E-05,   6.0089991E-05
     +,   6.1825114E-05,   6.3623549E-05,   6.5493201E-05
     +,   6.7442954E-05,   6.9482259E-05,   7.1621507E-05
     +,   7.3871881E-05,   7.6245204E-05,   7.8753968E-05
     +,   8.1411439E-05,   8.4231244E-05,   8.7227701E-05
     +,   9.0415488E-05,   9.3809773E-05,   9.7425778E-05
     +,   1.0127918E-04,   1.0538596E-04,   1.0976189E-04
     +,   1.1442322E-04,   1.1938633E-04,   1.2466744E-04
     +,   1.3028337E-04,   1.3625083E-04,   1.4258703E-04
     +,   1.4930959E-04,   1.5643658E-04,   1.6398622E-04
     +,   1.7197766E-04,   1.8043068E-04,   1.8936503E-04
     +,   1.9880131E-04,   2.0876061E-04,   2.1926328E-04
     +,   2.3033048E-04,   2.4198183E-04,   2.5423692E-04
     +,   2.6711385E-04,   2.8062952E-04,   2.9479907E-04
     +,   3.0963594E-04,   3.2515250E-04,   3.4135950E-04
     +,   3.5826815E-04,   3.7589061E-04,   3.9423944E-04
     +,   4.1333193E-04,   4.3318962E-04,   4.5383902E-04
     +,   4.7531372E-04,   4.9765408E-04,   5.2090705E-04
     +,   5.4512464E-04,   5.7036290E-04,   5.9667579E-04
     +,   6.2411808E-04,   6.5273832E-04,   6.8257749E-04
     +,   7.1366981E-04,   7.4603898E-04,   7.7970698E-04
     +,   8.1469613E-04,   8.5103611E-04,   8.8877289E-04
     +,   9.2797203E-04,   9.6874061E-04,   1.0112161E-03
     +,   1.0555896E-03,   1.1021059E-03,   1.1510756E-03
     +,   1.2028923E-03,   1.2580354E-03,   1.3171053E-03
     +,   1.3808161E-03,   1.4499993E-03,   1.5255621E-03
     +,   1.6084218E-03,   1.6993883E-03,   1.7990019E-03
     +,   1.9073803E-03,   2.0240496E-03,   2.1478364E-03
     +,   2.2768611E-03,   2.4086174E-03,   2.5402182E-03
     +,   2.6686972E-03,   2.7913721E-03,   2.9062219E-03
     +,   3.0121589E-03,   3.1093182E-03,   3.1991126E-03
     +,   3.2843305E-03,   3.3690566E-03,   3.4585032E-03
     +,   3.5586273E-03,   3.6755013E-03,   3.8144558E-03
     +,   3.9789197E-03,   4.1693910E-03,   4.3826164E-03
     +,   4.6114209E-03,   4.8453612E-03,   5.0720656E-03
     +,   5.2791853E-03,   5.4561966E-03,   5.5957264E-03
     +,   5.6939577E-03,   5.7501630E-03,   5.7655745E-03
     +,   5.7421583E-03,   5.6818039E-03,   5.5861343E-03
     +,   5.4570031E-03,   5.2972543E-03,   5.1114229E-03
     +,   4.9058171E-03,   4.6880692E-03,   4.4660810E-03
     +,   4.2468477E-03,   4.0354985E-03,   3.8348250E-03
     +,   3.6454769E-03,   3.4665745E-03,   3.2965883E-03
     +,   3.1341296E-03,   2.9784578E-03,   2.8296278E-03
     +,   2.6882617E-03,   2.5552639E-03,   2.4313934E-03
     +,   2.3170237E-03,   2.2120348E-03,   2.1158166E-03
     +,   2.0274441E-03,   1.9458084E-03,   1.8697788E-03
     +,   1.7983096E-03,   1.7305058E-03,   1.6656660E-03
     +,   1.6032597E-03,   1.5429580E-03,   1.4846007E-03
     +,   1.4281839E-03,   1.3738479E-03,   1.3218190E-03
     +,   1.2724072E-03,   1.2259397E-03,   1.1827351E-03
     +,   1.1430681E-03,   1.1071404E-03,   1.0750727E-03
     +,   1.0468812E-03,   1.0224965E-03,   1.0017552E-03
     +,   9.8442030E-04,   9.7019441E-04,   9.5873600E-04
     +,   9.4968104E-04,   9.4265473E-04,   9.3728857E-04
     +,   9.3323342E-04,   9.3016541E-04,   9.2779240E-04
     +,   9.2585461E-04,   9.2412444E-04,   9.2240085E-04
     +,   9.2050567E-04,   9.1828004E-04,   9.1557723E-04
     +,   9.1226073E-04,   9.0820109E-04,   9.0327830E-04
     +,   8.9737977E-04,   8.9040562E-04,   8.8227203E-04
     +,   8.7291276E-04,   8.6228806E-04,   8.5038046E-04
     +,   8.3720410E-04,   8.2280237E-04,   8.0724317E-04
     +,   7.9062482E-04,   7.7306305E-04,   7.5469504E-04
     +,   7.3566847E-04,   7.1613607E-04,   6.9625565E-04
     +,   6.7617471E-04,   6.5603806E-04,   6.3597376E-04
     +,   6.1609491E-04,   5.9650186E-04,   5.7727058E-04
     +,   5.5846560E-04,   5.4013182E-04,   5.2229967E-04
     +,   5.0498615E-04,   4.8819688E-04,   4.7193051E-04
     +,   4.5617408E-04,   4.4091459E-04,   4.2613246E-04
     +,   4.1180689E-04,   3.9791616E-04,   3.8443829E-04
     +,   3.7135350E-04,   3.5863963E-04,   3.4627941E-04
     +,   3.3425493E-04,   3.2255013E-04,   3.1115039E-04
     +,   3.0004219E-04,   2.8921457E-04,   2.7865526E-04
     +,   2.6835600E-04,   2.5830776E-04,   2.4850303E-04
     +,   2.3893565E-04,   2.2959997E-04,   2.2049231E-04
     +,   2.1160903E-04,   2.0294763E-04,   1.9450657E-04
     +,   1.8628483E-04,   1.7828315E-04,   1.7050089E-04
     +,   1.6293988E-04,   1.5560113E-04,   1.4848592E-04
     +,   1.4159664E-04,   1.3493365E-04,   1.2849942E-04
     +,   1.2229399E-04,   1.1631846E-04,   1.1057346E-04
     +,   1.0505769E-04,   9.9770950E-05,   9.4710849E-05
     +,   8.9875641E-05,   8.5262109E-05,   8.0866521E-05
     +,   7.6685086E-05,   7.2712370E-05,   6.8943460E-05
     +,   6.5372369E-05,   6.1992832E-05,   5.8798250E-05
     +,   5.5781635E-05,   5.2936073E-05,   5.0254217E-05
     +,   4.7728685E-05,   4.5352088E-05,   4.3116972E-05
     +,   4.1016290E-05,   3.9042508E-05,   3.7188893E-05
     +,   3.5448295E-05,   3.3814267E-05,   3.2280317E-05
     +,   3.0840205E-05,   2.9488170E-05,   2.8218356E-05
     +,   2.7025519E-05,   2.5904497E-05,   2.4850411E-05
     +,   2.3858804E-05,   2.2925202E-05,   2.2045691E-05
     +,   2.1216329E-05,   2.0433607E-05,   1.9694213E-05
     +,   1.8994944E-05,   1.8332896E-05,   1.7705321E-05
     +,   1.7109722E-05,   1.6543707E-05,   1.6005084E-05
     +,   1.5491805E-05,   1.5001968E-05,   1.4533849E-05
     +,   1.4085816E-05,   1.3656369E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wano_fus_75 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wano_fus_80(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  3.0332340E-06,   3.1412133E-06
     +,   3.2519852E-06,   3.3657104E-06,   3.4825928E-06
     +,   3.6028750E-06,   3.7268410E-06,   3.8548351E-06
     +,   3.9872607E-06,   4.1245880E-06,   4.2673710E-06
     +,   4.4162521E-06,   4.5719680E-06,   4.7353747E-06
     +,   4.9074538E-06,   5.0893159E-06,   5.2822370E-06
     +,   5.4876623E-06,   5.7072116E-06,   5.9427248E-06
     +,   6.1962605E-06,   6.4701262E-06,   6.7668811E-06
     +,   7.0893971E-06,   7.4408276E-06,   7.8246840E-06
     +,   8.2448287E-06,   8.7055187E-06,   9.2113960E-06
     +,   9.7675756E-06,   1.0379591E-05,   1.1053500E-05
     +,   1.1795866E-05,   1.2613807E-05,   1.3514958E-05
     +,   1.4507598E-05,   1.5600634E-05,   1.6803542E-05
     +,   1.8126539E-05,   1.9580528E-05,   2.1177066E-05
     +,   2.2928547E-05,   2.4848023E-05,   2.6949419E-05
     +,   2.9247461E-05,   3.1757769E-05,   3.4496679E-05
     +,   3.7481575E-05,   4.0730774E-05,   4.4263354E-05
     +,   4.8099490E-05,   5.2260344E-05,   5.6767789E-05
     +,   6.1644867E-05,   6.6915105E-05,   7.2603048E-05
     +,   7.8733705E-05,   8.5332562E-05,   9.2425376E-05
     +,   1.0003743E-04,   1.0819417E-04,   1.1691968E-04
     +,   1.2623731E-04,   1.3616894E-04,   1.4673370E-04
     +,   1.5794889E-04,   1.6982893E-04,   1.8238420E-04
     +,   1.9562224E-04,   2.0954640E-04,   2.2415596E-04
     +,   2.3944626E-04,   2.5540942E-04,   2.7203208E-04
     +,   2.8929970E-04,   3.0719521E-04,   3.2570091E-04
     +,   3.4480056E-04,   3.6447961E-04,   3.8473209E-04
     +,   4.0556118E-04,   4.2698608E-04,   4.4904603E-04
     +,   4.7180368E-04,   4.9535936E-04,   5.1984511E-04
     +,   5.4543803E-04,   5.7235954E-04,   6.0087384E-04
     +,   6.3128705E-04,   6.6393096E-04,   6.9915585E-04
     +,   7.3730678E-04,   7.7869836E-04,   8.2358532E-04
     +,   8.7213423E-04,   9.2439365E-04,   9.8026195E-04
     +,   1.0394790E-03,   1.1016075E-03,   1.1660402E-03
     +,   1.2320117E-03,   1.2986158E-03,   1.3648536E-03
     +,   1.4296676E-03,   1.4919937E-03,   1.5508115E-03
     +,   1.6051880E-03,   1.6543540E-03,   1.6977248E-03
     +,   1.7349733E-03,   1.7660663E-03,   1.7913134E-03
     +,   1.8113996E-03,   1.8274204E-03,   1.8408955E-03
     +,   1.8537663E-03,   1.8683813E-03,   1.8874373E-03
     +,   1.9139005E-03,   1.9508819E-03,   2.0014585E-03
     +,   2.0684616E-03,   2.1542280E-03,   2.2603220E-03
     +,   2.3873071E-03,   2.5345678E-03,   2.7002487E-03
     +,   2.8814352E-03,   3.0744688E-03,   3.2755660E-03
     +,   3.4815648E-03,   3.6907976E-03,   3.9038137E-03
     +,   4.1238712E-03,   4.3567899E-03,   4.6100682E-03
     +,   4.8912554E-03,   5.2057104E-03,   5.5543068E-03
     +,   5.9316372E-03,   6.3255779E-03,   6.7184079E-03
     +,   7.0894826E-03,   7.4187717E-03,   7.6900348E-03
     +,   7.8927390E-03,   8.0218194E-03,   8.0760177E-03
     +,   8.0555938E-03,   7.9609463E-03,   7.7931569E-03
     +,   7.5562941E-03,   7.2604218E-03,   6.9235298E-03
     +,   6.5708254E-03,   6.2310360E-03,   5.9308903E-03
     +,   5.6893337E-03,   5.5141174E-03,   5.4011196E-03
     +,   5.3367419E-03,   5.3020860E-03,   5.2773766E-03
     +,   5.2456609E-03,   5.1949886E-03,   5.1191696E-03
     +,   5.0173006E-03,   4.8924848E-03,   4.7501661E-03
     +,   4.5963894E-03,   4.4364827E-03,   4.2741816E-03
     +,   4.1115200E-03,   3.9492366E-03,   3.7875413E-03
     +,   3.6269007E-03,   3.4684967E-03,   3.3143738E-03
     +,   3.1671459E-03,   3.0294626E-03,   2.9034610E-03
     +,   2.7902864E-03,   2.6899667E-03,   2.6014321E-03
     +,   2.5228255E-03,   2.4518433E-03,   2.3861057E-03
     +,   2.3234384E-03,   2.2620144E-03,   2.2004405E-03
     +,   2.1377213E-03,   2.0732193E-03,   2.0065980E-03
     +,   1.9377589E-03,   1.8668383E-03,   1.7941485E-03
     +,   1.7201962E-03,   1.6456424E-03,   1.5712529E-03
     +,   1.4978895E-03,   1.4264173E-03,   1.3576903E-03
     +,   1.2924677E-03,   1.2313760E-03,   1.1748837E-03
     +,   1.1232517E-03,   1.0765560E-03,   1.0346648E-03
     +,   9.9727255E-04,   9.6392940E-04,   9.3406456E-04
     +,   9.0704695E-04,   8.8221277E-04,   8.5891178E-04
     +,   8.3654159E-04,   8.1457332E-04,   7.9257472E-04
     +,   7.7021122E-04,   7.4726105E-04,   7.2359864E-04
     +,   6.9919106E-04,   6.7408226E-04,   6.4837484E-04
     +,   6.2221958E-04,   5.9578678E-04,   5.6926772E-04
     +,   5.4284831E-04,   5.1670749E-04,   4.9100711E-04
     +,   4.6588684E-04,   4.4146681E-04,   4.1783645E-04
     +,   3.9506861E-04,   3.7321154E-04,   3.5229558E-04
     +,   3.3233530E-04,   3.1333187E-04,   2.9527856E-04
     +,   2.7815855E-04,   2.6195051E-04,   2.4662909E-04
     +,   2.3216601E-04,   2.1853349E-04,   2.0569938E-04
     +,   1.9363473E-04,   1.8230863E-04,   1.7169044E-04
     +,   1.6175106E-04,   1.5245928E-04,   1.4378702E-04
     +,   1.3570354E-04,   1.2818055E-04,   1.2118978E-04
     +,   1.1470189E-04,   1.0868982E-04,   1.0312524E-04
     +,   9.7981851E-05,   9.3233168E-05,   8.8853420E-05
     +,   8.4818363E-05,   8.1103492E-05,   7.7686258E-05
     +,   7.4544507E-05,   7.1657269E-05,   6.9004614E-05
     +,   6.6567532E-05,   6.4328364E-05,   6.2270192E-05
     +,   6.0377162E-05,   5.8634541E-05,   5.7028366E-05
     +,   5.5545883E-05,   5.4174841E-05,   5.2904230E-05
     +,   5.1723455E-05,   5.0623024E-05,   4.9593968E-05
     +,   4.8628015E-05,   4.7717658E-05,   4.6855770E-05
     +,   4.6036006E-05,   4.5252433E-05,   4.4499637E-05
     +,   4.3772776E-05,   4.3067259E-05,   4.2379139E-05
     +,   4.1704669E-05,   4.1040603E-05,   4.0384053E-05
     +,   3.9732371E-05,   3.9083283E-05,   3.8434802E-05
     +,   3.7785245E-05,   3.7133177E-05,   3.6477391E-05
     +,   3.5816920E-05,   3.5151013E-05,   3.4479173E-05
     +,   3.3801018E-05,   3.3116368E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wano_fus_80 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wano_fus_85(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  3.6492279E-06,   3.7206614E-06
     +,   3.7920292E-06,   3.8632925E-06,   3.9344163E-06
     +,   4.0053742E-06,   4.0761406E-06,   4.1467006E-06
     +,   4.2170482E-06,   4.2871852E-06,   4.3571290E-06
     +,   4.4269118E-06,   4.4965795E-06,   4.5662009E-06
     +,   4.6358691E-06,   4.7057006E-06,   4.7758449E-06
     +,   4.8464890E-06,   4.9178543E-06,   4.9902151E-06
     +,   5.0638928E-06,   5.1392717E-06,   5.2167957E-06
     +,   5.2969890E-06,   5.3804529E-06,   5.4678821E-06
     +,   5.5600722E-06,   5.6579293E-06,   5.7624784E-06
     +,   5.8748815E-06,   5.9964373E-06,   6.1286014E-06
     +,   6.2730005E-06,   6.4314354E-06,   6.6058865E-06
     +,   6.7985457E-06,   7.0118099E-06,   7.2482835E-06
     +,   7.5108087E-06,   7.8024577E-06,   8.1265243E-06
     +,   8.4865678E-06,   8.8863562E-06,   9.3299277E-06
     +,   9.8215432E-06,   1.0365716E-05,   1.0967151E-05
     +,   1.1630811E-05,   1.2361867E-05,   1.3165658E-05
     +,   1.4047751E-05,   1.5013910E-05,   1.6070000E-05
     +,   1.7222153E-05,   1.8476550E-05,   1.9839625E-05
     +,   2.1317921E-05,   2.2918184E-05,   2.4647337E-05
     +,   2.6512427E-05,   2.8520864E-05,   3.0680141E-05
     +,   3.2998199E-05,   3.5483303E-05,   3.8143993E-05
     +,   4.0989424E-05,   4.4029282E-05,   4.7273752E-05
     +,   5.0733841E-05,   5.4421376E-05,   5.8349080E-05
     +,   6.2530737E-05,   6.6981476E-05,   7.1717266E-05
     +,   7.6755976E-05,   8.2117011E-05,   8.7821543E-05
     +,   9.3892915E-05,   1.0035586E-04,   1.0723808E-04
     +,   1.1456934E-04,   1.2238178E-04,   1.3071026E-04
     +,   1.3959048E-04,   1.4906259E-04,   1.5916575E-04
     +,   1.6994157E-04,   1.8143131E-04,   1.9367549E-04
     +,   2.0671269E-04,   2.2057633E-04,   2.3529572E-04
     +,   2.5089222E-04,   2.6737800E-04,   2.8475342E-04
     +,   3.0300629E-04,   3.2211046E-04,   3.4202248E-04
     +,   3.6268544E-04,   3.8402737E-04,   4.0596342E-04
     +,   4.2840003E-04,   4.5123475E-04,   4.7436749E-04
     +,   4.9770228E-04,   5.2115403E-04,   5.4465659E-04
     +,   5.6816329E-04,   5.9166166E-04,   6.1516400E-04
     +,   6.3871784E-04,   6.6240050E-04,   6.8631582E-04
     +,   7.1059022E-04,   7.3535991E-04,   7.6077442E-04
     +,   7.8697683E-04,   8.1410888E-04,   8.4230618E-04
     +,   8.7170082E-04,   9.0243161E-04,   9.3465002E-04
     +,   9.6854282E-04,   1.0043425E-03,   1.0423424E-03
     +,   1.0829060E-03,   1.1264671E-03,   1.1735152E-03
     +,   1.2245839E-03,   1.2802100E-03,   1.3408925E-03
     +,   1.4070488E-03,   1.4789655E-03,   1.5567469E-03
     +,   1.6403064E-03,   1.7293498E-03,   1.8234146E-03
     +,   1.9219454E-03,   2.0244289E-03,   2.1305773E-03
     +,   2.2405349E-03,   2.3551232E-03,   2.4759809E-03
     +,   2.6056177E-03,   2.7472808E-03,   2.9045551E-03
     +,   3.0808742E-03,   3.2787963E-03,   3.4994679E-03
     +,   3.7422886E-03,   4.0049218E-03,   4.2838496E-03
     +,   4.5749531E-03,   4.8742867E-03,   5.1783966E-03
     +,   5.4841819E-03,   5.7883603E-03,   6.0867630E-03
     +,   6.3741235E-03,   6.6444706E-03,   6.8928422E-03
     +,   7.1176221E-03,   7.3224548E-03,   7.5163278E-03
     +,   7.7101653E-03,   7.9108244E-03,   8.1151212E-03
     +,   8.3082188E-03,   8.4693562E-03,   8.5834693E-03
     +,   8.6524487E-03,   8.6985594E-03,   8.7568089E-03
     +,   8.8598356E-03,   9.0236329E-03,   9.2410864E-03
     +,   9.4842846E-03,   9.7120386E-03,   9.8787341E-03
     +,   9.9436576E-03,   9.8812850E-03,   9.6908761E-03
     +,   9.3998788E-03,   9.0568317E-03,   8.7141665E-03
     +,   8.4089870E-03,   8.1515815E-03,   7.9271533E-03
     +,   7.7084098E-03,   7.4708923E-03,   7.2035315E-03
     +,   6.9104806E-03,   6.6061369E-03,   6.3074776E-03
     +,   6.0275411E-03,   5.7727243E-03,   5.5430448E-03
     +,   5.3346558E-03,   5.1424266E-03,   4.9617831E-03
     +,   4.7894767E-03,   4.6232725E-03,   4.4614621E-03
     +,   4.3023326E-03,   4.1441433E-03,   3.9854692E-03
     +,   3.8256065E-03,   3.6649951E-03,   3.5051815E-03
     +,   3.3485263E-03,   3.1976700E-03,   3.0549027E-03
     +,   2.9217973E-03,   2.7989461E-03,   2.6860368E-03
     +,   2.5820800E-03,   2.4857188E-03,   2.3955619E-03
     +,   2.3103864E-03,   2.2293285E-03,   2.1518865E-03
     +,   2.0778815E-03,   2.0073499E-03,   1.9404087E-03
     +,   1.8771327E-03,   1.8174268E-03,   1.7609869E-03
     +,   1.7072635E-03,   1.6554893E-03,   1.6047393E-03
     +,   1.5540052E-03,   1.5023013E-03,   1.4487226E-03
     +,   1.3925496E-03,   1.3332785E-03,   1.2706617E-03
     +,   1.2047164E-03,   1.1357069E-03,   1.0641265E-03
     +,   9.9064235E-04,   9.1605732E-04,   8.4125315E-04
     +,   7.6713995E-04,   6.9461891E-04,   6.2451413E-04
     +,   5.5757479E-04,   4.9442134E-04,   4.3554039E-04
     +,   3.8128515E-04,   3.3185320E-04,   2.8732355E-04
     +,   2.4764016E-04,   2.1265297E-04,   1.8212527E-04
     +,   1.5574878E-04,   1.3317898E-04,   1.1403746E-04
     +,   9.7941760E-05,   8.4510444E-05,   7.3377683E-05
     +,   6.4202774E-05,   5.6671710E-05,   5.0505478E-05
     +,   4.5457626E-05,   4.1315619E-05,   3.7898961E-05
     +,   3.5056724E-05,   3.2665044E-05,   3.0623323E-05
     +,   2.8851400E-05,   2.7286344E-05,   2.5879526E-05
     +,   2.4594179E-05,   2.3402634E-05,   2.2284972E-05
     +,   2.1226726E-05,   2.0218060E-05,   1.9252260E-05
     +,   1.8324989E-05,   1.7433733E-05,   1.6576865E-05
     +,   1.5753758E-05,   1.4964064E-05,   1.4207669E-05
     +,   1.3484647E-05,   1.2794832E-05,   1.2138174E-05
     +,   1.1514284E-05,   1.0922757E-05,   1.0363023E-05
     +,   9.8342480E-06,   9.3355447E-06,   8.8658608E-06
     +,   8.4240910E-06,   8.0089931E-06,   7.6192773E-06
     +,   7.2536072E-06,   6.9106136E-06,   6.5889535E-06
     +,   6.2872546E-06,   6.0041743E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wano_fus_85 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wano_fus_90(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  2.4883839E-06,   2.5725344E-06
     +,   2.6593052E-06,   2.7488272E-06,   2.8412464E-06
     +,   2.9367225E-06,   3.0354213E-06,   3.1375300E-06
     +,   3.2432495E-06,   3.3527904E-06,   3.4663872E-06
     +,   3.5842897E-06,   3.7067641E-06,   3.8340995E-06
     +,   3.9666070E-06,   4.1046142E-06,   4.2484776E-06
     +,   4.3985838E-06,   4.5553329E-06,   4.7191652E-06
     +,   4.8905513E-06,   5.0699950E-06,   5.2580290E-06
     +,   5.4552393E-06,   5.6622393E-06,   5.8797004E-06
     +,   6.1083401E-06,   6.3489397E-06,   6.6023244E-06
     +,   6.8694053E-06,   7.1511481E-06,   7.4486093E-06
     +,   7.7629320E-06,   8.0953587E-06,   8.4472167E-06
     +,   8.8199622E-06,   9.2151777E-06,   9.6345484E-06
     +,   1.0079927E-05,   1.0553314E-05,   1.1056845E-05
     +,   1.1592858E-05,   1.2163826E-05,   1.2772437E-05
     +,   1.3421561E-05,   1.4114268E-05,   1.4853797E-05
     +,   1.5643609E-05,   1.6487380E-05,   1.7388915E-05
     +,   1.8352261E-05,   1.9381641E-05,   2.0481377E-05
     +,   2.1656011E-05,   2.2910133E-05,   2.4248484E-05
     +,   2.5675852E-05,   2.7197069E-05,   2.8816998E-05
     +,   3.0540366E-05,   3.2371954E-05,   3.4316308E-05
     +,   3.6377900E-05,   3.8560989E-05,   4.0869516E-05
     +,   4.3307213E-05,   4.5877528E-05,   4.8583406E-05
     +,   5.1427538E-05,   5.4412169E-05,   5.7539139E-05
     +,   6.0809874E-05,   6.4225482E-05,   6.7786263E-05
     +,   7.1492606E-05,   7.5344324E-05,   7.9341058E-05
     +,   8.3482279E-05,   8.7766879E-05,   9.2194226E-05
     +,   9.6763499E-05,   1.0147413E-04,   1.0632597E-04
     +,   1.1131870E-04,   1.1645383E-04,   1.2173239E-04
     +,   1.2715709E-04,   1.3273174E-04,   1.3846144E-04
     +,   1.4435308E-04,   1.5041461E-04,   1.5665681E-04
     +,   1.6309223E-04,   1.6973610E-04,   1.7660612E-04
     +,   1.8372295E-04,   1.9111054E-04,   1.9879546E-04
     +,   2.0680847E-04,   2.1518368E-04,   2.2395929E-04
     +,   2.3317760E-04,   2.4288414E-04,   2.5312920E-04
     +,   2.6396720E-04,   2.7545608E-04,   2.8765731E-04
     +,   3.0063392E-04,   3.1445414E-04,   3.2918336E-04
     +,   3.4488877E-04,   3.6163474E-04,   3.7948144E-04
     +,   3.9848304E-04,   4.1868124E-04,   4.4011054E-04
     +,   4.6278519E-04,   4.8670333E-04,   5.1184226E-04
     +,   5.3815520E-04,   5.6557258E-04,   5.9399678E-04
     +,   6.2330940E-04,   6.5337174E-04,   6.8402983E-04
     +,   7.1512250E-04,   7.4649346E-04,   7.7799719E-04
     +,   8.0952293E-04,   8.4100227E-04,   8.7242614E-04
     +,   9.0385968E-04,   9.3545136E-04,   9.6743472E-04
     +,   1.0001344E-03,   1.0339521E-03,   1.0693511E-03
     +,   1.1068316E-03,   1.1469013E-03,   1.1900392E-03
     +,   1.2366556E-03,   1.2870658E-03,   1.3414525E-03
     +,   1.3998484E-03,   1.4621165E-03,   1.5279361E-03
     +,   1.5968329E-03,   1.6681544E-03,   1.7411251E-03
     +,   1.8148771E-03,   1.8884937E-03,   1.9611276E-03
     +,   2.0320506E-03,   2.1008099E-03,   2.1673285E-03
     +,   2.2320163E-03,   2.2958498E-03,   2.3603863E-03
     +,   2.4277412E-03,   2.5004288E-03,   2.5811689E-03
     +,   2.6725980E-03,   2.7769096E-03,   2.8955424E-03
     +,   3.0288750E-03,   3.1761371E-03,   3.3354943E-03
     +,   3.5043948E-03,   3.6801070E-03,   3.8602233E-03
     +,   4.0432010E-03,   4.2283842E-03,   4.4160746E-03
     +,   4.6074148E-03,   4.8047430E-03,   5.0124885E-03
     +,   5.2384329E-03,   5.4946314E-03,   5.7966164E-03
     +,   6.1603049E-03,   6.5965331E-03,   7.1052704E-03
     +,   7.6724049E-03,   8.2709547E-03,   8.8675991E-03
     +,   9.4310809E-03,   9.9387718E-03,   1.0378624E-02
     +,   1.0747523E-02,   1.1050051E-02,   1.1299644E-02
     +,   1.1520785E-02,   1.1747535E-02,   1.2015265E-02
     +,   1.2347775E-02,   1.2743665E-02,   1.3168648E-02
     +,   1.3558554E-02,   1.3836971E-02,   1.3942795E-02
     +,   1.3853895E-02,   1.3592858E-02,   1.3212145E-02
     +,   1.2769940E-02,   1.2311733E-02,   1.1863540E-02
     +,   1.1434458E-02,   1.1022956E-02,   1.0622108E-02
     +,   1.0221314E-02,   9.8057231E-03,   9.3581062E-03
     +,   8.8671194E-03,   8.3373198E-03,   7.7932249E-03
     +,   7.2717094E-03,   6.8064486E-03,   6.4136437E-03
     +,   6.0865241E-03,   5.8007799E-03,   5.5257520E-03
     +,   5.2356515E-03,   4.9162237E-03,   4.5658168E-03
     +,   4.1925265E-03,   3.8095040E-03,   3.4309700E-03
     +,   3.0692306E-03,   2.7333691E-03,   2.4289531E-03
     +,   2.1583643E-03,   1.9214723E-03,   1.7162417E-03
     +,   1.5395201E-03,   1.3875429E-03,   1.2564490E-03
     +,   1.1426257E-03,   1.0429190E-03,   9.5474685E-04
     +,   8.7608217E-04,   8.0540980E-04,   7.4163039E-04
     +,   6.8395416E-04,   6.3181139E-04,   5.8474514E-04
     +,   5.4237229E-04,   5.0432043E-04,   4.7020879E-04
     +,   4.3964756E-04,   4.1222663E-04,   3.8754480E-04
     +,   3.6520738E-04,   3.4485193E-04,   3.2615333E-04
     +,   3.0882607E-04,   2.9263643E-04,   2.7739131E-04
     +,   2.6294272E-04,   2.4917678E-04,   2.3600960E-04
     +,   2.2338328E-04,   2.1125530E-04,   1.9959977E-04
     +,   1.8839898E-04,   1.7764232E-04,   1.6732355E-04
     +,   1.5743912E-04,   1.4798780E-04,   1.3896804E-04
     +,   1.3037857E-04,   1.2221771E-04,   1.1448262E-04
     +,   1.0717040E-04,   1.0027490E-04,   9.3790564E-05
     +,   8.7708206E-05,   8.2018640E-05,   7.6710174E-05
     +,   7.1769580E-05,   6.7182926E-05,   6.2933788E-05
     +,   5.9005921E-05,   5.5381577E-05,   5.2042469E-05
     +,   4.8970494E-05,   4.6146575E-05,   4.3552722E-05
     +,   4.1170399E-05,   3.8982220E-05,   3.6971411E-05
     +,   3.5121589E-05,   3.3417600E-05,   3.1845102E-05
     +,   3.0390936E-05,   2.9042798E-05,   2.7789471E-05
     +,   2.6620750E-05,   2.5527361E-05,   2.4501098E-05
     +,   2.3534520E-05,   2.2621052E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wano_fus_90 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wano_fus_95(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  9.5962002E-07,   1.0145689E-06
     +,   1.0723963E-06,   1.1332598E-06,   1.1973319E-06
     +,   1.2647974E-06,   1.3358524E-06,   1.4107103E-06
     +,   1.4896007E-06,   1.5727676E-06,   1.6604757E-06
     +,   1.7530115E-06,   1.8506769E-06,   1.9538015E-06
     +,   2.0627401E-06,   2.1778658E-06,   2.2995846E-06
     +,   2.4283338E-06,   2.5645704E-06,   2.7087922E-06
     +,   2.8615252E-06,   3.0233366E-06,   3.1948168E-06
     +,   3.3766066E-06,   3.5693727E-06,   3.7738316E-06
     +,   3.9907363E-06,   4.2208853E-06,   4.4651092E-06
     +,   4.7242984E-06,   4.9993664E-06,   5.2912892E-06
     +,   5.6010813E-06,   5.9298127E-06,   6.2785743E-06
     +,   6.6485295E-06,   7.0408823E-06,   7.4568661E-06
     +,   7.8977810E-06,   8.3649711E-06,   8.8598063E-06
     +,   9.3837334E-06,   9.9382105E-06,   1.0524767E-05
     +,   1.1144967E-05,   1.1800434E-05,   1.2492799E-05
     +,   1.3223766E-05,   1.3995093E-05,   1.4808529E-05
     +,   1.5665906E-05,   1.6569104E-05,   1.7519986E-05
     +,   1.8520512E-05,   1.9572610E-05,   2.0678286E-05
     +,   2.1839560E-05,   2.3058461E-05,   2.4337070E-05
     +,   2.5677393E-05,   2.7081524E-05,   2.8551476E-05
     +,   3.0089290E-05,   3.1696989E-05,   3.3376484E-05
     +,   3.5129699E-05,   3.6958514E-05,   3.8864608E-05
     +,   4.0849682E-05,   4.2915311E-05,   4.5062912E-05
     +,   4.7293819E-05,   4.9609302E-05,   5.2010240E-05
     +,   5.4497654E-05,   5.7072317E-05,   5.9734954E-05
     +,   6.2486259E-05,   6.5326596E-05,   6.8256653E-05
     +,   7.1277071E-05,   7.4388634E-05,   7.7592485E-05
     +,   8.0889615E-05,   8.4282401E-05,   8.7772896E-05
     +,   9.1364527E-05,   9.5061536E-05,   9.8869314E-05
     +,   1.0279483E-04,   1.0684621E-04,   1.1103383E-04
     +,   1.1537004E-04,   1.1986943E-04,   1.2454913E-04
     +,   1.2942898E-04,   1.3453186E-04,   1.3988304E-04
     +,   1.4551147E-04,   1.5144900E-04,   1.5773051E-04
     +,   1.6439421E-04,   1.7148028E-04,   1.7903227E-04
     +,   1.8709576E-04,   1.9571817E-04,   2.0494874E-04
     +,   2.1483621E-04,   2.2543223E-04,   2.3678571E-04
     +,   2.4894628E-04,   2.6196192E-04,   2.7587867E-04
     +,   2.9074095E-04,   3.0658831E-04,   3.2346181E-04
     +,   3.4139515E-04,   3.6042192E-04,   3.8057342E-04
     +,   4.0187835E-04,   4.2436528E-04,   4.4805999E-04
     +,   4.7299004E-04,   4.9918232E-04,   5.2666385E-04
     +,   5.5546046E-04,   5.8559608E-04,   6.1708625E-04
     +,   6.4994156E-04,   6.8415719E-04,   7.1971072E-04
     +,   7.5655413E-04,   7.9461088E-04,   8.3376223E-04
     +,   8.7385293E-04,   9.1467937E-04,   9.5599226E-04
     +,   9.9749665E-04,   1.0388568E-03,   1.0797072E-03
     +,   1.1196561E-03,   1.1583131E-03,   1.1953000E-03
     +,   1.2302721E-03,   1.2629412E-03,   1.2930884E-03
     +,   1.3205975E-03,   1.3454471E-03,   1.3677366E-03
     +,   1.3876808E-03,   1.4056010E-03,   1.4219242E-03
     +,   1.4371581E-03,   1.4518823E-03,   1.4667264E-03
     +,   1.4823586E-03,   1.4994768E-03,   1.5188010E-03
     +,   1.5410788E-03,   1.5670791E-03,   1.5975927E-03
     +,   1.6334180E-03,   1.6753322E-03,   1.7240595E-03
     +,   1.7801884E-03,   1.8441209E-03,   1.9159784E-03
     +,   1.9955209E-03,   2.0820941E-03,   2.1745653E-03
     +,   2.2713710E-03,   2.3705156E-03,   2.4697292E-03
     +,   2.5666242E-03,   2.6589339E-03,   2.7448016E-03
     +,   2.8230825E-03,   2.8936686E-03,   2.9577247E-03
     +,   3.0178458E-03,   3.0780621E-03,   3.1436351E-03
     +,   3.2206771E-03,   3.3154723E-03,   3.4336769E-03
     +,   3.5793071E-03,   3.7537694E-03,   3.9550965E-03
     +,   4.1776425E-03,   4.4126259E-03,   4.6493816E-03
     +,   4.8774816E-03,   5.0889929E-03,   5.2803173E-03
     +,   5.4531624E-03,   5.6139622E-03,   5.7722703E-03
     +,   5.9382189E-03,   6.1201155E-03,   6.3228747E-03
     +,   6.5479665E-03,   6.7953249E-03,   7.0661744E-03
     +,   7.3659853E-03,   7.7060326E-03,   8.1033157E-03
     +,   8.5791377E-03,   9.1554178E-03,   9.8483041E-03
     +,   1.0658427E-02,   1.1560800E-02,   1.2501326E-02
     +,   1.3406700E-02,   1.4211426E-02,   1.4889985E-02
     +,   1.5471654E-02,   1.6018910E-02,   1.6575912E-02
     +,   1.7122326E-02,   1.7570959E-02,   1.7820176E-02
     +,   1.7825466E-02,   1.7634101E-02,   1.7351553E-02
     +,   1.7065749E-02,   1.6789470E-02,   1.6459711E-02
     +,   1.5983386E-02,   1.5289782E-02,   1.4360740E-02
     +,   1.3232769E-02,   1.1981108E-02,   1.0695742E-02
     +,   9.4604017E-03,   8.3372835E-03,   7.3606796E-03
     +,   6.5370873E-03,   5.8504627E-03,   5.2712937E-03
     +,   4.7668861E-03,   4.3101627E-03,   3.8842089E-03
     +,   3.4821609E-03,   3.1041426E-03,   2.7531364E-03
     +,   2.4321447E-03,   2.1425176E-03,   1.8837946E-03
     +,   1.6542209E-03,   1.4513053E-03,   1.2724671E-03
     +,   1.1152201E-03,   9.7738346E-04,   8.5703173E-04
     +,   7.5242168E-04,   6.6199357E-04,   5.8426009E-04
     +,   5.1783503E-04,   4.6139033E-04,   4.1367498E-04
     +,   3.7353035E-04,   3.3988419E-04,   3.1177682E-04
     +,   2.8834751E-04,   2.6883904E-04,   2.5258985E-04
     +,   2.3902606E-04,   2.2765560E-04,   2.1805626E-04
     +,   2.0987043E-04,   2.0279767E-04,   1.9658761E-04
     +,   1.9103514E-04,   1.8597246E-04,   1.8126651E-04
     +,   1.7681131E-04,   1.7252604E-04,   1.6834885E-04
     +,   1.6423408E-04,   1.6014963E-04,   1.5607267E-04
     +,   1.5198936E-04,   1.4789154E-04,   1.4377573E-04
     +,   1.3964275E-04,   1.3549482E-04,   1.3133742E-04
     +,   1.2717613E-04,   1.2301841E-04,   1.1887239E-04
     +,   1.1474568E-04,   1.1064676E-04,   1.0658370E-04
     +,   1.0256485E-04,   9.8597833E-05,   9.4690062E-05
     +,   9.0848414E-05,   8.7079185E-05,   8.3388441E-05
     +,   7.9781319E-05,   7.6262331E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wano_fus_95 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wano_hz_100(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  8.3713729E-09,   9.4778043E-09
     +,   1.0719817E-08,   1.2112501E-08,   1.3672500E-08
     +,   1.5418077E-08,   1.7369135E-08,   1.9547608E-08
     +,   2.1977392E-08,   2.4684509E-08,   2.7697386E-08
     +,   3.1047040E-08,   3.4766938E-08,   3.8893614E-08
     +,   4.3466663E-08,   4.8528701E-08,   5.4125980E-08
     +,   6.0308516E-08,   6.7129761E-08,   7.4647645E-08
     +,   8.2924153E-08,   9.2026056E-08,   1.0202424E-07
     +,   1.1299530E-07,   1.2502008E-07,   1.3818546E-07
     +,   1.5258367E-07,   1.6831277E-07,   1.8547604E-07
     +,   2.0418410E-07,   2.2455229E-07,   2.4670339E-07
     +,   2.7076632E-07,   2.9687712E-07,   3.2517696E-07
     +,   3.5581513E-07,   3.8894774E-07,   4.2473570E-07
     +,   4.6334836E-07,   5.0496203E-07,   5.4975652E-07
     +,   5.9792160E-07,   6.4964917E-07,   7.0513983E-07
     +,   7.6459878E-07,   8.2823743E-07,   8.9626803E-07
     +,   9.6891108E-07,   1.0463912E-06,   1.1289322E-06
     +,   1.2167643E-06,   1.3101213E-06,   1.4092332E-06
     +,   1.5143385E-06,   1.6256685E-06,   1.7434606E-06
     +,   1.8679507E-06,   1.9993736E-06,   2.1379656E-06
     +,   2.2839538E-06,   2.4375763E-06,   2.5990566E-06
     +,   2.7686256E-06,   2.9465166E-06,   3.1329498E-06
     +,   3.3281585E-06,   3.5323765E-06,   3.7458315E-06
     +,   3.9687679E-06,   4.2014308E-06,   4.4440790E-06
     +,   4.6969840E-06,   4.9604441E-06,   5.2347482E-06
     +,   5.5202413E-06,   5.8172900E-06,   6.1262995E-06
     +,   6.4477299E-06,   6.7820565E-06,   7.1298532E-06
     +,   7.4917511E-06,   7.8684607E-06,   8.2608049E-06
     +,   8.6696446E-06,   9.0960730E-06,   9.5412179E-06
     +,   1.0006420E-05,   1.0493182E-05,   1.1003220E-05
     +,   1.1538489E-05,   1.2101153E-05,   1.2693728E-05
     +,   1.3319048E-05,   1.3980321E-05,   1.4681184E-05
     +,   1.5425756E-05,   1.6218715E-05,   1.7065258E-05
     +,   1.7971326E-05,   1.8943585E-05,   1.9989493E-05
     +,   2.1117456E-05,   2.2336711E-05,   2.3657671E-05
     +,   2.5091824E-05,   2.6651867E-05,   2.8351817E-05
     +,   3.0206755E-05,   3.2233624E-05,   3.4450302E-05
     +,   3.6876398E-05,   3.9532952E-05,   4.2442462E-05
     +,   4.5629065E-05,   4.9117840E-05,   5.2936222E-05
     +,   5.7112105E-05,   6.1675251E-05,   6.6656568E-05
     +,   7.2088187E-05,   7.8003519E-05,   8.4436331E-05
     +,   9.1421818E-05,   9.8995682E-05,   1.0719401E-04
     +,   1.1605307E-04,   1.2560924E-04,   1.3589724E-04
     +,   1.4695167E-04,   1.5880486E-04,   1.7148670E-04
     +,   1.8502367E-04,   1.9943828E-04,   2.1474581E-04
     +,   2.3095688E-04,   2.4807325E-04,   2.6608820E-04
     +,   2.8498436E-04,   3.0473369E-04,   3.2529639E-04
     +,   3.4661850E-04,   3.6863488E-04,   3.9126744E-04
     +,   4.1442594E-04,   4.3801017E-04,   4.6190733E-04
     +,   4.8600338E-04,   5.1017426E-04,   5.3429877E-04
     +,   5.5825908E-04,   5.8194116E-04,   6.0525059E-04
     +,   6.2810449E-04,   6.5044616E-04,   6.7224674E-04
     +,   6.9351058E-04,   7.1427826E-04,   7.3462696E-04
     +,   7.5467792E-04,   7.7458483E-04,   7.9453754E-04
     +,   8.1475155E-04,   8.3545496E-04,   8.5688423E-04
     +,   8.7925646E-04,   9.0276438E-04,   9.2755217E-04
     +,   9.5370197E-04,   9.8122167E-04,   1.0100298E-03
     +,   1.0399616E-03,   1.0707573E-03,   1.1020814E-03
     +,   1.1335314E-03,   1.1646569E-03,   1.1949892E-03
     +,   1.2240594E-03,   1.2514401E-03,   1.2767707E-03
     +,   1.2997957E-03,   1.3204018E-03,   1.3386548E-03
     +,   1.3548575E-03,   1.3695864E-03,   1.3837544E-03
     +,   1.3986609E-03,   1.4160404E-03,   1.4380894E-03
     +,   1.4674696E-03,   1.5072669E-03,   1.5608736E-03
     +,   1.6318090E-03,   1.7234436E-03,   1.8386212E-03
     +,   1.9792919E-03,   2.1460468E-03,   2.3379009E-03
     +,   2.5521026E-03,   2.7843586E-03,   3.0293746E-03
     +,   3.2814578E-03,   3.5354209E-03,   3.7870009E-03
     +,   4.0330929E-03,   4.2713745E-03,   4.4996627E-03
     +,   4.7155907E-03,   4.9167345E-03,   5.1019224E-03
     +,   5.2731647E-03,   5.4376423E-03,   5.6088339E-03
     +,   5.8052638E-03,   6.0466705E-03,   6.3475217E-03
     +,   6.7098336E-03,   7.1183462E-03,   7.5412910E-03
     +,   7.9387370E-03,   8.2757054E-03,   8.5349539E-03
     +,   8.7218788E-03,   8.8586817E-03,   8.9711100E-03
     +,   9.0762954E-03,   9.1795167E-03,   9.2806155E-03
     +,   9.3834959E-03,   9.5000286E-03,   9.6448446E-03
     +,   9.8257298E-03,   1.0038158E-02,   1.0269532E-02
     +,   1.0510352E-02,   1.0763355E-02,   1.1040818E-02
     +,   1.1349457E-02,   1.1673309E-02,   1.1969293E-02
     +,   1.2182821E-02,   1.2273879E-02,   1.2234419E-02
     +,   1.2082879E-02,   1.1840898E-02,   1.1511817E-02
     +,   1.1079931E-02,   1.0530179E-02,   9.8717650E-03
     +,   9.1461008E-03,   8.4136771E-03,   7.7315085E-03
     +,   7.1351449E-03,   6.6346810E-03,   6.2207137E-03
     +,   5.8734943E-03,   5.5702315E-03,   5.2889003E-03
     +,   5.0110049E-03,   4.7236201E-03,   4.4211694E-03
     +,   4.1056867E-03,   3.7850931E-03,   3.4704206E-03
     +,   3.1724239E-03,   2.8991622E-03,   2.6548256E-03
     +,   2.4398752E-03,   2.2520586E-03,   2.0876445E-03
     +,   1.9425830E-03,   1.8132448E-03,   1.6967416E-03
     +,   1.5909664E-03,   1.4943846E-03,   1.4058761E-03
     +,   1.3244873E-03,   1.2493560E-03,   1.1796196E-03
     +,   1.1144228E-03,   1.0529537E-03,   9.9445530E-04
     +,   9.3830185E-04,   8.8399526E-04,   8.3119125E-04
     +,   7.7970320E-04,   7.2946557E-04,   6.8053877E-04
     +,   6.3304952E-04,   5.8718381E-04,   5.4314686E-04
     +,   5.0113001E-04,   4.6130398E-04,   4.2379665E-04
     +,   3.8869272E-04,   3.5602172E-04,   3.2576686E-04
     +,   2.9786880E-04,   2.7223176E-04,   2.4873563E-04
     +,   2.2723919E-04,   2.0759164E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wano_hz_100 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wano_hz_105(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  8.6883119E-07,   9.0695170E-07
     +,   9.4645338E-07,   9.8737939E-07,   1.0297774E-06
     +,   1.0736981E-06,   1.1191927E-06,   1.1663171E-06
     +,   1.2151326E-06,   1.2656999E-06,   1.3180874E-06
     +,   1.3723686E-06,   1.4286186E-06,   1.4869199E-06
     +,   1.5473641E-06,   1.6100433E-06,   1.6750600E-06
     +,   1.7425259E-06,   1.8125564E-06,   1.8852788E-06
     +,   1.9608287E-06,   2.0393545E-06,   2.1210085E-06
     +,   2.2059630E-06,   2.2943932E-06,   2.3864939E-06
     +,   2.4824706E-06,   2.5825459E-06,   2.6869491E-06
     +,   2.7959350E-06,   2.9097657E-06,   3.0287258E-06
     +,   3.1531140E-06,   3.2832511E-06,   3.4194682E-06
     +,   3.5621215E-06,   3.7115872E-06,   3.8682510E-06
     +,   4.0325299E-06,   4.2048555E-06,   4.3856735E-06
     +,   4.5754596E-06,   4.7746958E-06,   4.9838918E-06
     +,   5.2035725E-06,   5.4342836E-06,   5.6765743E-06
     +,   5.9310214E-06,   6.1982169E-06,   6.4787459E-06
     +,   6.7732249E-06,   7.0822734E-06,   7.4065028E-06
     +,   7.7465529E-06,   8.1030375E-06,   8.4765870E-06
     +,   8.8678225E-06,   9.2773580E-06,   9.7058009E-06
     +,   1.0153720E-05,   1.0621698E-05,   1.1110265E-05
     +,   1.1619942E-05,   1.2151225E-05,   1.2704540E-05
     +,   1.3280313E-05,   1.3878911E-05,   1.4500630E-05
     +,   1.5145737E-05,   1.5814439E-05,   1.6506872E-05
     +,   1.7223105E-05,   1.7963175E-05,   1.8726945E-05
     +,   1.9514291E-05,   2.0324978E-05,   2.1158687E-05
     +,   2.2015038E-05,   2.2893475E-05,   2.3793435E-05
     +,   2.4714236E-05,   2.5655107E-05,   2.6615215E-05
     +,   2.7593493E-05,   2.8589035E-05,   2.9600596E-05
     +,   3.0626994E-05,   3.1666925E-05,   3.2719014E-05
     +,   3.3781856E-05,   3.4853878E-05,   3.5933557E-05
     +,   3.7019287E-05,   3.8109451E-05,   3.9202401E-05
     +,   4.0296465E-05,   4.1390056E-05,   4.2481450E-05
     +,   4.3569118E-05,   4.4651522E-05,   4.5727222E-05
     +,   4.6794896E-05,   4.7853235E-05,   4.8901202E-05
     +,   4.9937840E-05,   5.0962441E-05,   5.1974508E-05
     +,   5.2973613E-05,   5.3959939E-05,   5.4933600E-05
     +,   5.5895252E-05,   5.6845820E-05,   5.7786630E-05
     +,   5.8719441E-05,   5.9646278E-05,   6.0569932E-05
     +,   6.1493389E-05,   6.2420317E-05,   6.3354899E-05
     +,   6.4301930E-05,   6.5266817E-05,   6.6255561E-05
     +,   6.7274945E-05,   6.8332440E-05,   6.9436319E-05
     +,   7.0595685E-05,   7.1820548E-05,   7.3121737E-05
     +,   7.4511205E-05,   7.6001954E-05,   7.7608078E-05
     +,   7.9344922E-05,   8.1229169E-05,   8.3278646E-05
     +,   8.5512816E-05,   8.7952554E-05,   9.0620240E-05
     +,   9.3539820E-05,   9.6736774E-05,   1.0023817E-04
     +,   1.0407205E-04,   1.0826808E-04,   1.1285673E-04
     +,   1.1786915E-04,   1.2333690E-04,   1.2929033E-04
     +,   1.3576048E-04,   1.4277500E-04,   1.5035999E-04
     +,   1.5853810E-04,   1.6732611E-04,   1.7673739E-04
     +,   1.8677623E-04,   1.9744023E-04,   2.0871754E-04
     +,   2.2058655E-04,   2.3301509E-04,   2.4595801E-04
     +,   2.5936161E-04,   2.7315787E-04,   2.8726956E-04
     +,   3.0160989E-04,   3.1608218E-04,   3.3058733E-04
     +,   3.4501954E-04,   3.5927555E-04,   3.7325526E-04
     +,   3.8686671E-04,   4.0003151E-04,   4.1268571E-04
     +,   4.2479087E-04,   4.3633135E-04,   4.4732308E-04
     +,   4.5781446E-04,   4.6789073E-04,   4.7767389E-04
     +,   4.8732312E-04,   4.9703557E-04,   5.0704298E-04
     +,   5.1760697E-04,   5.2901590E-04,   5.4157374E-04
     +,   5.5559742E-04,   5.7139911E-04,   5.8928051E-04
     +,   6.0951611E-04,   6.3234143E-04,   6.5793999E-04
     +,   6.8642473E-04,   7.1784004E-04,   7.5213891E-04
     +,   7.8919280E-04,   8.2879281E-04,   8.7065285E-04
     +,   9.1444794E-04,   9.5981744E-04,   1.0064252E-03
     +,   1.0539745E-03,   1.1022547E-03,   1.1511868E-03
     +,   1.2008210E-03,   1.2513748E-03,   1.3031957E-03
     +,   1.3567447E-03,   1.4125387E-03,   1.4710708E-03
     +,   1.5327532E-03,   1.5978093E-03,   1.6662303E-03
     +,   1.7377302E-03,   1.8117387E-03,   1.8874736E-03
     +,   1.9640017E-03,   2.0404009E-03,   2.1159034E-03
     +,   2.1900630E-03,   2.2628871E-03,   2.3348930E-03
     +,   2.4071336E-03,   2.4810447E-03,   2.5582551E-03
     +,   2.6402713E-03,   2.7281151E-03,   2.8219668E-03
     +,   2.9208532E-03,   3.0225168E-03,   3.1233681E-03
     +,   3.2187589E-03,   3.3033830E-03,   3.3718674E-03
     +,   3.4194004E-03,   3.4423594E-03,   3.4387931E-03
     +,   3.4086590E-03,   3.3538542E-03,   3.2779928E-03
     +,   3.1860436E-03,   3.0838693E-03,   2.9778134E-03
     +,   2.8742978E-03,   2.7795418E-03,   2.6992804E-03
     +,   2.6384974E-03,   2.6010992E-03,   2.5895499E-03
     +,   2.6045602E-03,   2.6449363E-03,   2.7077501E-03
     +,   2.7889183E-03,   2.8842157E-03,   2.9904768E-03
     +,   3.1067706E-03,   3.2349925E-03,   3.3796518E-03
     +,   3.5467665E-03,   3.7418120E-03,   3.9676898E-03
     +,   4.2229546E-03,   4.5013488E-03,   4.7926945E-03
     +,   5.0850715E-03,   5.3678518E-03,   5.6342706E-03
     +,   5.8832220E-03,   6.1192750E-03,   6.3510924E-03
     +,   6.5885126E-03,   6.8390826E-03,   7.1049496E-03
     +,   7.3806820E-03,   7.6527237E-03,   7.9007288E-03
     +,   8.1006438E-03,   8.2291141E-03,   8.2680872E-03
     +,   8.2087154E-03,   8.0533624E-03,   7.8152884E-03
     +,   7.5162323E-03,   7.1824966E-03,   6.8402449E-03
     +,   6.5113176E-03,   6.2098210E-03,   5.9405034E-03
     +,   5.6991065E-03,   5.4743853E-03,   5.2515827E-03
     +,   5.0160061E-03,   4.7562672E-03,   4.4662273E-03
     +,   4.1455226E-03,   3.7990008E-03,   3.4352136E-03
     +,   3.0646797E-03,   2.6980948E-03,   2.3450453E-03
     +,   2.0131769E-03,   1.7078487E-03,   1.4322498E-03
     +,   1.1876459E-03,   9.7384263E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wano_hz_105 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wano_hz_107(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  4.5961165E-06,   4.6732121E-06
     +,   4.7502826E-06,   4.8272882E-06,   4.9041951E-06
     +,   4.9809687E-06,   5.0575704E-06,   5.1339644E-06
     +,   5.2101173E-06,   5.2859909E-06,   5.3615513E-06
     +,   5.4367647E-06,   5.5115938E-06,   5.5860050E-06
     +,   5.6599665E-06,   5.7334414E-06,   5.8063983E-06
     +,   5.8788064E-06,   5.9506315E-06,   6.0218426E-06
     +,   6.0924090E-06,   6.1623027E-06,   6.2314903E-06
     +,   6.2999475E-06,   6.3676434E-06,   6.4345509E-06
     +,   6.5006452E-06,   6.5659019E-06,   6.6302932E-06
     +,   6.6937969E-06,   6.7563892E-06,   6.8180498E-06
     +,   6.8787563E-06,   6.9384901E-06,   6.9972307E-06
     +,   7.0549590E-06,   7.1116610E-06,   7.1673167E-06
     +,   7.2219141E-06,   7.2754392E-06,   7.3278770E-06
     +,   7.3792189E-06,   7.4294503E-06,   7.4785657E-06
     +,   7.5265552E-06,   7.5734124E-06,   7.6191332E-06
     +,   7.6637116E-06,   7.7071491E-06,   7.7494406E-06
     +,   7.7905906E-06,   7.8306039E-06,   7.8694811E-06
     +,   7.9072333E-06,   7.9438678E-06,   7.9793990E-06
     +,   8.0138425E-06,   8.0472155E-06,   8.0795398E-06
     +,   8.1108428E-06,   8.1411508E-06,   8.1705002E-06
     +,   8.1989283E-06,   8.2264769E-06,   8.2531997E-06
     +,   8.2791476E-06,   8.3043842E-06,   8.3289797E-06
     +,   8.3530076E-06,   8.3765553E-06,   8.3997120E-06
     +,   8.4225876E-06,   8.4452940E-06,   8.4679541E-06
     +,   8.4907051E-06,   8.5136990E-06,   8.5370966E-06
     +,   8.5610754E-06,   8.5858319E-06,   8.6115742E-06
     +,   8.6385317E-06,   8.6669543E-06,   8.6971104E-06
     +,   8.7292938E-06,   8.7638227E-06,   8.8010411E-06
     +,   8.8413281E-06,   8.8850911E-06,   8.9327805E-06
     +,   8.9848882E-06,   9.0419480E-06,   9.1045567E-06
     +,   9.1733709E-06,   9.2491118E-06,   9.3325880E-06
     +,   9.4247025E-06,   9.5264622E-06,   9.6389940E-06
     +,   9.7635675E-06,   9.9016233E-06,   1.0054777E-05
     +,   1.0224868E-05,   1.0413954E-05,   1.0624392E-05
     +,   1.0858838E-05,   1.1120297E-05,   1.1412179E-05
     +,   1.1738279E-05,   1.2102967E-05,   1.2511042E-05
     +,   1.2967941E-05,   1.3479726E-05,   1.4053140E-05
     +,   1.4695675E-05,   1.5415499E-05,   1.6221771E-05
     +,   1.7124319E-05,   1.8133942E-05,   1.9262296E-05
     +,   2.0521917E-05,   2.1926280E-05,   2.3489500E-05
     +,   2.5226656E-05,   2.7153452E-05,   2.9286202E-05
     +,   3.1641688E-05,   3.4237106E-05,   3.7089463E-05
     +,   4.0215993E-05,   4.3633518E-05,   4.7358233E-05
     +,   5.1405488E-05,   5.5789635E-05,   6.0522987E-05
     +,   6.5616550E-05,   7.1079005E-05,   7.6916542E-05
     +,   8.3132567E-05,   8.9727451E-05,   9.6698452E-05
     +,   1.0403861E-04,   1.1173800E-04,   1.1978277E-04
     +,   1.2815515E-04,   1.3683418E-04,   1.4579372E-04
     +,   1.5500688E-04,   1.6444109E-04,   1.7406263E-04
     +,   1.8383539E-04,   1.9372004E-04,   2.0367881E-04
     +,   2.1367060E-04,   2.2365575E-04,   2.3359501E-04
     +,   2.4345030E-04,   2.5318578E-04,   2.6276641E-04
     +,   2.7216275E-04,   2.8134597E-04,   2.9029237E-04
     +,   2.9898193E-04,   3.0739748E-04,   3.1552851E-04
     +,   3.2336626E-04,   3.3090787E-04,   3.3815458E-04
     +,   3.4511212E-04,   3.5179150E-04,   3.5820776E-04
     +,   3.6438348E-04,   3.7034560E-04,   3.7612932E-04
     +,   3.8177767E-04,   3.8734343E-04,   3.9288949E-04
     +,   3.9849101E-04,   4.0423646E-04,   4.1022882E-04
     +,   4.1658623E-04,   4.2344246E-04,   4.3094496E-04
     +,   4.3925652E-04,   4.4854818E-04,   4.5899957E-04
     +,   4.7079066E-04,   4.8409740E-04,   4.9908285E-04
     +,   5.1588769E-04,   5.3462695E-04,   5.5537320E-04
     +,   5.7815650E-04,   6.0295605E-04,   6.2969321E-04
     +,   6.5824296E-04,   6.8842177E-04,   7.2001375E-04
     +,   7.5276627E-04,   7.8641466E-04,   8.2070602E-04
     +,   8.5540401E-04,   8.9032814E-04,   9.2535117E-04
     +,   9.6042821E-04,   9.9559675E-04,   1.0309707E-03
     +,   1.0667447E-03,   1.1031542E-03,   1.1404640E-03
     +,   1.1789292E-03,   1.2187541E-03,   1.2600694E-03
     +,   1.3028842E-03,   1.3470807E-03,   1.3923990E-03
     +,   1.4384452E-03,   1.4847122E-03,   1.5306104E-03
     +,   1.5755248E-03,   1.6188446E-03,   1.6600317E-03
     +,   1.6986540E-03,   1.7344228E-03,   1.7672129E-03
     +,   1.7970661E-03,   1.8241968E-03,   1.8489549E-03
     +,   1.8718161E-03,   1.8933382E-03,   1.9141239E-03
     +,   1.9347862E-03,   1.9558959E-03,   1.9779552E-03
     +,   2.0013363E-03,   2.0262543E-03,   2.0527288E-03
     +,   2.0805560E-03,   2.1093045E-03,   2.1383166E-03
     +,   2.1667464E-03,   2.1936162E-03,   2.2178940E-03
     +,   2.2385798E-03,   2.2548132E-03,   2.2659709E-03
     +,   2.2717470E-03,   2.2722217E-03,   2.2678995E-03
     +,   2.2597164E-03,   2.2490311E-03,   2.2375949E-03
     +,   2.2275287E-03,   2.2213138E-03,   2.2218467E-03
     +,   2.2325453E-03,   2.2575126E-03,   2.3016997E-03
     +,   2.3709235E-03,   2.4715823E-03,   2.6098890E-03
     +,   2.7905067E-03,   3.0149433E-03,   3.2799123E-03
     +,   3.5768203E-03,   3.8928473E-03,   4.2141164E-03
     +,   4.5304331E-03,   4.8399037E-03,   5.1515787E-03
     +,   5.4841964E-03,   5.8611557E-03,   6.3036340E-03
     +,   6.8247924E-03,   7.4276780E-03,   8.1055649E-03
     +,   8.8437796E-03,   9.6193347E-03,   1.0400862E-02
     +,   1.1150201E-02,   1.1827545E-02,   1.2397422E-02
     +,   1.2830032E-02,   1.3098135E-02,   1.3174094E-02
     +,   1.3034608E-02,   1.2673859E-02,   1.2116527E-02
     +,   1.1418954E-02,   1.0654330E-02,   9.8881833E-03
     +,   9.1578849E-03,   8.4668882E-03,   7.7935294E-03
     +,   7.1081193E-03,   6.3887886E-03,   5.6307227E-03
     +,   4.8471913E-03,   4.0645069E-03,   3.3143105E-03
     +,   2.6258091E-03,   2.0205465E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wano_hz_107 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wano_hz_110(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  2.6032257E-08,   2.8573155E-08
     +,   3.1340793E-08,   3.4353114E-08,   3.7629377E-08
     +,   4.1190173E-08,   4.5057210E-08,   4.9253803E-08
     +,   5.3804769E-08,   5.8736191E-08,   6.4076076E-08
     +,   6.9854025E-08,   7.6101138E-08,   8.2850576E-08
     +,   9.0137483E-08,   9.7998559E-08,   1.0647278E-07
     +,   1.1560134E-07,   1.2542709E-07,   1.3599549E-07
     +,   1.4735424E-07,   1.5955345E-07,   1.7264493E-07
     +,   1.8668392E-07,   2.0172699E-07,   2.1783416E-07
     +,   2.3506756E-07,   2.5349226E-07,   2.7317498E-07
     +,   2.9418635E-07,   3.1659809E-07,   3.4048554E-07
     +,   3.6592652E-07,   3.9300170E-07,   4.2179275E-07
     +,   4.5238548E-07,   4.8486783E-07,   5.1932875E-07
     +,   5.5586077E-07,   5.9455920E-07,   6.3551863E-07
     +,   6.7883900E-07,   7.2461870E-07,   7.7296033E-07
     +,   8.2396662E-07,   8.7774299E-07,   9.3439263E-07
     +,   9.9402291E-07,   1.0567416E-06,   1.1226534E-06
     +,   1.1918663E-06,   1.2644884E-06,   1.3406234E-06
     +,   1.4203797E-06,   1.5038580E-06,   1.5911629E-06
     +,   1.6823947E-06,   1.7776512E-06,   1.8770312E-06
     +,   1.9806230E-06,   2.0885195E-06,   2.2008023E-06
     +,   2.3175548E-06,   2.4388555E-06,   2.5647719E-06
     +,   2.6953712E-06,   2.8307172E-06,   2.9708592E-06
     +,   3.1158470E-06,   3.2657215E-06,   3.4205164E-06
     +,   3.5802586E-06,   3.7449731E-06,   3.9146585E-06
     +,   4.0893242E-06,   4.2689649E-06,   4.4535682E-06
     +,   4.6431196E-06,   4.8375764E-06,   5.0369085E-06
     +,   5.2410710E-06,   5.4500133E-06,   5.6636850E-06
     +,   5.8819946E-06,   6.1049059E-06,   6.3323178E-06
     +,   6.5641602E-06,   6.8003474E-06,   7.0407968E-06
     +,   7.2854291E-06,   7.5341404E-06,   7.7868581E-06
     +,   8.0435002E-06,   8.3039959E-06,   8.5682750E-06
     +,   8.8362840E-06,   9.1079892E-06,   9.3833441E-06
     +,   9.6623498E-06,   9.9450208E-06,   1.0231397E-05
     +,   1.0521562E-05,   1.0815599E-05,   1.1113666E-05
     +,   1.1415957E-05,   1.1722719E-05,   1.2034266E-05
     +,   1.2350934E-05,   1.2673222E-05,   1.3001623E-05
     +,   1.3336778E-05,   1.3679416E-05,   1.4030386E-05
     +,   1.4390681E-05,   1.4761379E-05,   1.5143812E-05
     +,   1.5539388E-05,   1.5949754E-05,   1.6376749E-05
     +,   1.6822436E-05,   1.7289118E-05,   1.7779310E-05
     +,   1.8295832E-05,   1.8841780E-05,   1.9420535E-05
     +,   2.0035779E-05,   2.0691539E-05,   2.1392081E-05
     +,   2.2142058E-05,   2.2946429E-05,   2.3810433E-05
     +,   2.4739655E-05,   2.5739968E-05,   2.6817403E-05
     +,   2.7978365E-05,   2.9229426E-05,   3.0577376E-05
     +,   3.2029173E-05,   3.3591936E-05,   3.5272999E-05
     +,   3.7079652E-05,   3.9019596E-05,   4.1100644E-05
     +,   4.3330954E-05,   4.5719171E-05,   4.8274189E-05
     +,   5.1006271E-05,   5.3926138E-05,   5.7046240E-05
     +,   6.0380833E-05,   6.3945874E-05,   6.7761051E-05
     +,   7.1848321E-05,   7.6234144E-05,   8.0949387E-05
     +,   8.6030137E-05,   9.1518334E-05,   9.7461430E-05
     +,   1.0391494E-04,   1.1093965E-04,   1.1860401E-04
     +,   1.2698332E-04,   1.3615705E-04,   1.4621213E-04
     +,   1.5723630E-04,   1.6932032E-04,   1.8255372E-04
     +,   1.9702266E-04,   2.1280738E-04,   2.2997592E-04
     +,   2.4858731E-04,   2.6867958E-04,   2.9027340E-04
     +,   3.1336577E-04,   3.3792894E-04,   3.6390856E-04
     +,   3.9122044E-04,   4.1975550E-04,   4.4937828E-04
     +,   4.7992944E-04,   5.1123230E-04,   5.4309034E-04
     +,   5.7530717E-04,   6.0767593E-04,   6.4000051E-04
     +,   6.7209604E-04,   7.0379913E-04,   7.3497329E-04
     +,   7.6551148E-04,   7.9535332E-04,   8.2447141E-04
     +,   8.5288583E-04,   8.8065822E-04,   9.0788450E-04
     +,   9.3470007E-04,   9.6125586E-04,   9.8772417E-04
     +,   1.0142698E-03,   1.0410445E-03,   1.0681739E-03
     +,   1.0957334E-03,   1.1237477E-03,   1.1521670E-03
     +,   1.1808724E-03,   1.2096728E-03,   1.2383007E-03
     +,   1.2664428E-03,   1.2937372E-03,   1.3198112E-03
     +,   1.3443041E-03,   1.3668932E-03,   1.3873343E-03
     +,   1.4054778E-03,   1.4213035E-03,   1.4349306E-03
     +,   1.4466270E-03,   1.4568046E-03,   1.4660035E-03
     +,   1.4748641E-03,   1.4840852E-03,   1.4943762E-03
     +,   1.5064067E-03,   1.5207528E-03,   1.5378506E-03
     +,   1.5579652E-03,   1.5811741E-03,   1.6073629E-03
     +,   1.6362453E-03,   1.6674087E-03,   1.7003426E-03
     +,   1.7345084E-03,   1.7693674E-03,   1.8044446E-03
     +,   1.8393317E-03,   1.8737164E-03,   1.9073715E-03
     +,   1.9401389E-03,   1.9719028E-03,   2.0025477E-03
     +,   2.0319258E-03,   2.0598208E-03,   2.0859074E-03
     +,   2.1097250E-03,   2.1306656E-03,   2.1479866E-03
     +,   2.1608262E-03,   2.1682705E-03,   2.1694317E-03
     +,   2.1635636E-03,   2.1501775E-03,   2.1291804E-03
     +,   2.1009711E-03,   2.0665254E-03,   2.0274085E-03
     +,   1.9857124E-03,   1.9439405E-03,   1.9047871E-03
     +,   1.8709054E-03,   1.8446286E-03,   1.8277419E-03
     +,   1.8213219E-03,   1.8257084E-03,   1.8406182E-03
     +,   1.8654221E-03,   1.8995214E-03,   1.9427747E-03
     +,   1.9958552E-03,   2.0604092E-03,   2.1389425E-03
     +,   2.2343472E-03,   2.3491308E-03,   2.4845728E-03
     +,   2.6400718E-03,   2.8133106E-03,   3.0013006E-03
     +,   3.2027541E-03,   3.4208631E-03,   3.6656735E-03
     +,   3.9544269E-03,   4.3087383E-03,   4.7490047E-03
     +,   5.2872053E-03,   5.9215669E-03,   6.6351756E-03
     +,   7.3996568E-03,   8.1829084E-03,   8.9565786E-03
     +,   9.7014336E-03,   1.0406980E-02,   1.1066653E-02
     +,   1.1669994E-02,   1.2194269E-02,   1.2599207E-02
     +,   1.2827147E-02,   1.2810695E-02,   1.2487214E-02
     +,   1.1817653E-02,   1.0803771E-02,   9.4973333E-03
     +,   7.9958327E-03,   6.4252634E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wano_hz_110 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wano_hz_115(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  3.4939024E-08,   3.8256850E-08
     +,   4.1861668E-08,   4.5775419E-08,   5.0021701E-08
     +,   5.4625659E-08,   5.9613789E-08,   6.5014483E-08
     +,   7.0857986E-08,   7.7176139E-08,   8.4002899E-08
     +,   9.1374446E-08,   9.9328545E-08,   1.0790576E-07
     +,   1.1714898E-07,   1.2710278E-07,   1.3781515E-07
     +,   1.4933657E-07,   1.6171967E-07,   1.7502057E-07
     +,   1.8929815E-07,   2.0461476E-07,   2.2103504E-07
     +,   2.3862822E-07,   2.5746547E-07,   2.7762295E-07
     +,   2.9917982E-07,   3.2221962E-07,   3.4682884E-07
     +,   3.7309940E-07,   4.0112570E-07,   4.3100812E-07
     +,   4.6285083E-07,   4.9676322E-07,   5.3285783E-07
     +,   5.7125328E-07,   6.1207413E-07,   6.5544725E-07
     +,   7.0150679E-07,   7.5039299E-07,   8.0224805E-07
     +,   8.5722417E-07,   9.1547480E-07,   9.7716190E-07
     +,   1.0424520E-06,   1.1115200E-06,   1.1845407E-06
     +,   1.2617008E-06,   1.3431913E-06,   1.4292056E-06
     +,   1.5199471E-06,   1.6156253E-06,   1.7164491E-06
     +,   1.8226419E-06,   1.9344243E-06,   2.0520270E-06
     +,   2.1756848E-06,   2.3056373E-06,   2.4421308E-06
     +,   2.5854085E-06,   2.7357282E-06,   2.8933391E-06
     +,   3.0585036E-06,   3.2314854E-06,   3.4125417E-06
     +,   3.6019403E-06,   3.7999532E-06,   4.0068376E-06
     +,   4.2228644E-06,   4.4482981E-06,   4.6834052E-06
     +,   4.9284481E-06,   5.1836955E-06,   5.4493853E-06
     +,   5.7257807E-06,   6.0131310E-06,   6.3116822E-06
     +,   6.6216849E-06,   6.9433522E-06,   7.2769299E-06
     +,   7.6226402E-06,   7.9807087E-06,   8.3513705E-06
     +,   8.7348026E-06,   9.1312786E-06,   9.5409741E-06
     +,   9.9641284E-06,   1.0400972E-05,   1.0851742E-05
     +,   1.1316715E-05,   1.1796125E-05,   1.2290286E-05
     +,   1.2799526E-05,   1.3324202E-05,   1.3864726E-05
     +,   1.4421549E-05,   1.4995217E-05,   1.5586274E-05
     +,   1.6195407E-05,   1.6823386E-05,   1.7471068E-05
     +,   1.8139457E-05,   1.8829625E-05,   1.9542827E-05
     +,   2.0280475E-05,   2.1044132E-05,   2.1835574E-05
     +,   2.2656639E-05,   2.3509570E-05,   2.4396606E-05
     +,   2.5320327E-05,   2.6283480E-05,   2.7289041E-05
     +,   2.8340233E-05,   2.9440311E-05,   3.0593055E-05
     +,   3.1802065E-05,   3.3071326E-05,   3.4404908E-05
     +,   3.5806970E-05,   3.7281807E-05,   3.8833572E-05
     +,   4.0466570E-05,   4.2184965E-05,   4.3992844E-05
     +,   4.5894049E-05,   4.7892274E-05,   4.9990711E-05
     +,   5.2192328E-05,   5.4499647E-05,   5.6914650E-05
     +,   5.9438775E-05,   6.2072955E-05,   6.4817177E-05
     +,   6.7671011E-05,   7.0633345E-05,   7.3702271E-05
     +,   7.6875287E-05,   8.0149199E-05,   8.3520492E-05
     +,   8.6984721E-05,   9.0537578E-05,   9.4174378E-05
     +,   9.7890494E-05,   1.0168167E-04,   1.0554357E-04
     +,   1.0947368E-04,   1.1346956E-04,   1.1753084E-04
     +,   1.2165894E-04,   1.2585703E-04,   1.3013197E-04
     +,   1.3449279E-04,   1.3895260E-04,   1.4352845E-04
     +,   1.4824184E-04,   1.5311925E-04,   1.5819159E-04
     +,   1.6349637E-04,   1.6907530E-04,   1.7497619E-04
     +,   1.8125205E-04,   1.8795971E-04,   1.9516161E-04
     +,   2.0292151E-04,   2.1130567E-04,   2.2038032E-04
     +,   2.3020942E-04,   2.4085336E-04,   2.5236400E-04
     +,   2.6478691E-04,   2.7815215E-04,   2.9247682E-04
     +,   3.0776049E-04,   3.2398314E-04,   3.4110475E-04
     +,   3.5906158E-04,   3.7777046E-04,   3.9712767E-04
     +,   4.1701118E-04,   4.3728549E-04,   4.5780183E-04
     +,   4.7841214E-04,   4.9896329E-04,   5.1931321E-04
     +,   5.3933082E-04,   5.5890472E-04,   5.7794602E-04
     +,   5.9638941E-04,   6.1420241E-04,   6.3137535E-04
     +,   6.4792793E-04,   6.6390290E-04,   6.7936198E-04
     +,   6.9438736E-04,   7.0907176E-04,   7.2352489E-04
     +,   7.3786802E-04,   7.5223966E-04,   7.6680724E-04
     +,   7.8176556E-04,   7.9735846E-04,   8.1387995E-04
     +,   8.3168811E-04,   8.5121091E-04,   8.7293988E-04
     +,   8.9743198E-04,   9.2528184E-04,   9.5710380E-04
     +,   9.9349394E-04,   1.0349827E-03,   1.0820020E-03
     +,   1.1348149E-03,   1.1934832E-03,   1.2578178E-03
     +,   1.3273468E-03,   1.4012964E-03,   1.4785746E-03
     +,   1.5578166E-03,   1.6373837E-03,   1.7154590E-03
     +,   1.7901160E-03,   1.8594301E-03,   1.9216056E-03
     +,   1.9751021E-03,   2.0187856E-03,   2.0520159E-03
     +,   2.0747536E-03,   2.0875884E-03,   2.0917132E-03
     +,   2.0888497E-03,   2.0811080E-03,   2.0707988E-03
     +,   2.0602331E-03,   2.0515183E-03,   2.0463821E-03
     +,   2.0460556E-03,   2.0512072E-03,   2.0619580E-03
     +,   2.0779490E-03,   2.0984702E-03,   2.1226131E-03
     +,   2.1494308E-03,   2.1780848E-03,   2.2079733E-03
     +,   2.2387651E-03,   2.2704136E-03,   2.3030764E-03
     +,   2.3369906E-03,   2.3723145E-03,   2.4089564E-03
     +,   2.4464633E-03,   2.4839540E-03,   2.5201729E-03
     +,   2.5536458E-03,   2.5829033E-03,   2.6067980E-03
     +,   2.6247681E-03,   2.6370576E-03,   2.6447754E-03
     +,   2.6497778E-03,   2.6543669E-03,   2.6608899E-03
     +,   2.6713037E-03,   2.6869199E-03,   2.7083559E-03
     +,   2.7358113E-03,   2.7695566E-03,   2.8104719E-03
     +,   2.8603789E-03,   2.9219605E-03,   2.9981609E-03
     +,   3.0911523E-03,   3.2012225E-03,   3.3258670E-03
     +,   3.4596608E-03,   3.5948618E-03,   3.7228896E-03
     +,   3.8361177E-03,   3.9294856E-03,   4.0014740E-03
     +,   4.0539172E-03,   4.0909699E-03,   4.1173156E-03
     +,   4.1363710E-03,   4.1489131E-03,   4.1525722E-03
     +,   4.1422094E-03,   4.1110152E-03,   4.0519685E-03
     +,   3.9591934E-03,   3.8290289E-03,   3.6605415E-03
     +,   3.4556238E-03,   3.2186273E-03,   2.9558416E-03
     +,   2.6748450E-03,   2.3838463E-03,   2.0911405E-03
     +,   1.8045348E-03,   1.5309777E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wano_hz_115 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wano_hz_120(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  1.8617798E-11,   2.2291056E-11
     +,   2.6656509E-11,   3.1837848E-11,   3.7979831E-11
     +,   4.5251584E-11,   5.3849591E-11,   6.4003018E-11
     +,   7.5978182E-11,   9.0083600E-11,   1.0667744E-10
     +,   1.2617404E-10,   1.4905141E-10,   1.7586201E-10
     +,   2.0724270E-10,   2.4392441E-10,   2.8674849E-10
     +,   3.3668096E-10,   3.9482595E-10,   4.6244819E-10
     +,   5.4099253E-10,   6.3210853E-10,   7.3766915E-10
     +,   8.5981516E-10,   1.0009625E-09,   1.1638669E-09
     +,   1.3516388E-09,   1.5678037E-09,   1.8163286E-09
     +,   2.1017070E-09,   2.4289664E-09,   2.8037899E-09
     +,   3.2325371E-09,   3.7223575E-09,   4.2812154E-09
     +,   4.9180495E-09,   5.6428195E-09,   6.4666068E-09
     +,   7.4017592E-09,   8.4620213E-09,   9.6625623E-09
     +,   1.1020279E-08,   1.2553777E-08,   1.4283658E-08
     +,   1.6232649E-08,   1.8425785E-08,   2.0890520E-08
     +,   2.3657080E-08,   2.6758672E-08,   3.0231465E-08
     +,   3.4115182E-08,   3.8453265E-08,   4.3292818E-08
     +,   4.8685507E-08,   5.4687106E-08,   6.1358605E-08
     +,   6.8765935E-08,   7.6980683E-08,   8.6080433E-08
     +,   9.6148504E-08,   1.0727571E-07,   1.1955898E-07
     +,   1.3310347E-07,   1.4802249E-07,   1.6443693E-07
     +,   1.8247755E-07,   2.0228438E-07,   2.2400678E-07
     +,   2.4780564E-07,   2.7385266E-07,   3.0233159E-07
     +,   3.3343821E-07,   3.6738334E-07,   4.0438738E-07
     +,   4.4468928E-07,   4.8854184E-07,   5.3621443E-07
     +,   5.8799492E-07,   6.4418339E-07,   7.0510384E-07
     +,   7.7109837E-07,   8.4252923E-07,   9.1978296E-07
     +,   1.0032552E-06,   1.0933875E-06,   1.1906221E-06
     +,   1.2954383E-06,   1.4083387E-06,   1.5298501E-06
     +,   1.6605326E-06,   1.8009571E-06,   1.9517361E-06
     +,   2.1135056E-06,   2.2869281E-06,   2.4726951E-06
     +,   2.6715225E-06,   2.8841607E-06,   3.1113634E-06
     +,   3.3539288E-06,   3.6126710E-06,   3.8884255E-06
     +,   4.1820545E-06,   4.4944063E-06,   4.8263714E-06
     +,   5.1788411E-06,   5.5527121E-06,   5.9489003E-06
     +,   6.3682596E-06,   6.8117447E-06,   7.2801963E-06
     +,   7.7745044E-06,   8.2955266E-06,   8.8441038E-06
     +,   9.4210800E-06,   1.0027184E-05,   1.0663283E-05
     +,   1.1330067E-05,   1.2028286E-05,   1.2758663E-05
     +,   1.3521906E-05,   1.4318751E-05,   1.5149851E-05
     +,   1.6015971E-05,   1.6917878E-05,   1.7856397E-05
     +,   1.8832421E-05,   1.9846984E-05,   2.0901134E-05
     +,   2.1996177E-05,   2.3133578E-05,   2.4315013E-05
     +,   2.5542433E-05,   2.6818119E-05,   2.8144566E-05
     +,   2.9524774E-05,   3.0962143E-05,   3.2460532E-05
     +,   3.4024317E-05,   3.5658439E-05,   3.7368507E-05
     +,   3.9160594E-05,   4.1041625E-05,   4.3019223E-05
     +,   4.5101748E-05,   4.7298443E-05,   4.9619037E-05
     +,   5.2074662E-05,   5.4676701E-05,   5.7437697E-05
     +,   6.0371003E-05,   6.3490254E-05,   6.6810564E-05
     +,   7.0346723E-05,   7.4114410E-05,   7.8129298E-05
     +,   8.2407016E-05,   8.6962922E-05,   9.1810820E-05
     +,   9.6964577E-05,   1.0243498E-04,   1.0823121E-04
     +,   1.1435970E-04,   1.2082227E-04,   1.2761849E-04
     +,   1.3474154E-04,   1.4218058E-04,   1.4991927E-04
     +,   1.5793589E-04,   1.6620388E-04,   1.7469084E-04
     +,   1.8336262E-04,   1.9218023E-04,   2.0110492E-04
     +,   2.1009844E-04,   2.1912546E-04,   2.2815635E-04
     +,   2.3716861E-04,   2.4615118E-04,   2.5510593E-04
     +,   2.6405038E-04,   2.7301966E-04,   2.8206722E-04
     +,   2.9126919E-04,   3.0072057E-04,   3.1053930E-04
     +,   3.2086298E-04,   3.3184886E-04,   3.4367142E-04
     +,   3.5651732E-04,   3.7058664E-04,   3.8608193E-04
     +,   4.0320895E-04,   4.2217050E-04,   4.4315844E-04
     +,   4.6635905E-04,   4.9193733E-04,   5.2004954E-04
     +,   5.5082765E-04,   5.8438076E-04,   6.2080158E-04
     +,   6.6014053E-04,   7.0242200E-04,   7.4761355E-04
     +,   7.9563685E-04,   8.4636023E-04,   8.9959445E-04
     +,   9.5512858E-04,   1.0127261E-03,   1.0721736E-03
     +,   1.1333042E-03,   1.1960124E-03,   1.2602868E-03
     +,   1.3261661E-03,   1.3937288E-03,   1.4630249E-03
     +,   1.5340195E-03,   1.6065378E-03,   1.6802261E-03
     +,   1.7546003E-03,   1.8290749E-03,   1.9030991E-03
     +,   1.9762579E-03,   2.0483518E-03,   2.1194036E-03
     +,   2.1895333E-03,   2.2587699E-03,   2.3267332E-03
     +,   2.3923835E-03,   2.4538541E-03,   2.5084703E-03
     +,   2.5530120E-03,   2.5841638E-03,   2.5991278E-03
     +,   2.5962018E-03,   2.5752622E-03,   2.5379949E-03
     +,   2.4878359E-03,   2.4296287E-03,   2.3690499E-03
     +,   2.3118898E-03,   2.2633369E-03,   2.2273774E-03
     +,   2.2063856E-03,   2.2010086E-03,   2.2103100E-03
     +,   2.2321525E-03,   2.2637048E-03,   2.3019707E-03
     +,   2.3441939E-03,   2.3881358E-03,   2.4321117E-03
     +,   2.4749183E-03,   2.5156250E-03,   2.5533731E-03
     +,   2.5871962E-03,   2.6158779E-03,   2.6378934E-03
     +,   2.6514141E-03,   2.6543941E-03,   2.6447577E-03
     +,   2.6206796E-03,   2.5809389E-03,   2.5253287E-03
     +,   2.4549924E-03,   2.3726393E-03,   2.2825354E-03
     +,   2.1902446E-03,   2.1021231E-03,   2.0245926E-03
     +,   1.9633523E-03,   1.9226118E-03,   1.9045091E-03
     +,   1.9088056E-03,   1.9329517E-03,   1.9724919E-03
     +,   2.0217965E-03,   2.0749231E-03,   2.1265105E-03
     +,   2.1724827E-03,   2.2104383E-03,   2.2396939E-03
     +,   2.2609325E-03,   2.2756222E-03,   2.2853145E-03
     +,   2.2909930E-03,   2.2926172E-03,   2.2889473E-03
     +,   2.2776534E-03,   2.2556747E-03,   2.2197408E-03
     +,   2.1669283E-03,   2.0951773E-03,   2.0036486E-03
     +,   1.8929318E-03,   1.7650017E-03,   1.6230491E-03
     +,   1.4711511E-03,   1.3138739E-03,   1.1558862E-03
     +,   1.0015543E-03,   8.5466926E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wano_hz_120 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wano_hz_60(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  2.0967262E-04,   2.2084730E-04
     +,   2.3335686E-04,   2.4751227E-04,   2.6366854E-04
     +,   2.8221816E-04,   3.0357856E-04,   3.2817840E-04
     +,   3.5643493E-04,   3.8872517E-04,   4.2535824E-04
     +,   4.6654153E-04,   5.1234587E-04,   5.6268432E-04
     +,   6.1729416E-04,   6.7573093E-04,   7.3739339E-04
     +,   8.0156024E-04,   8.6745172E-04,   9.3432015E-04
     +,   1.0015467E-03,   1.0687476E-03,   1.1358649E-03
     +,   1.2032450E-03,   1.2716551E-03,   1.3422775E-03
     +,   1.4166322E-03,   1.4964854E-03,   1.5837364E-03
     +,   1.6803653E-03,   1.7884024E-03,   1.9100015E-03
     +,   2.0475187E-03,   2.2035758E-03,   2.3809425E-03
     +,   2.5822218E-03,   2.8092184E-03,   3.0620745E-03
     +,   3.3383779E-03,   3.6324731E-03,   3.9353110E-03
     +,   4.2351028E-03,   4.5187008E-03,   4.7736163E-03
     +,   4.9900254E-03,   5.1622414E-03,   5.2891253E-03
     +,   5.3733196E-03,   5.4194899E-03,   5.4323436E-03
     +,   5.4150973E-03,   5.3690481E-03,   5.2942312E-03
     +,   5.1908526E-03,   5.0606946E-03,   4.9077878E-03
     +,   4.7380989E-03,   4.5582750E-03,   4.3740734E-03
     +,   4.1890983E-03,   4.0043229E-03,   3.8186170E-03
     +,   3.6299075E-03,   3.4366010E-03,   3.2387017E-03
     +,   3.0382907E-03,   2.8393052E-03,   2.6467638E-03
     +,   2.4656928E-03,   2.3001530E-03,   2.1525461E-03
     +,   2.0233709E-03,   1.9113567E-03,   1.8139395E-03
     +,   1.7278317E-03,   1.6496205E-03,   1.5762552E-03
     +,   1.5053455E-03,   1.4353131E-03,   1.3653586E-03
     +,   1.2953477E-03,   1.2256220E-03,   1.1567994E-03
     +,   1.0896028E-03,   1.0246879E-03,   9.6258451E-04
     +,   9.0362434E-04,   8.4795058E-04,   7.9554459E-04
     +,   7.4626913E-04,   6.9992425E-04,   6.5628596E-04
     +,   6.1514357E-04,   5.7632406E-04,   5.3969910E-04
     +,   5.0518586E-04,   4.7273858E-04,   4.4234202E-04
     +,   4.1399393E-04,   3.8769859E-04,   3.6345739E-04
     +,   3.4126188E-04,   3.2109235E-04,   3.0291095E-04
     +,   2.8666385E-04,   2.7228080E-04,   2.5967535E-04
     +,   2.4874878E-04,   2.3938723E-04,   2.3146965E-04
     +,   2.2486619E-04,   2.1944261E-04,   2.1506258E-04
     +,   2.1159030E-04,   2.0889334E-04,   2.0684366E-04
     +,   2.0532092E-04,   2.0421269E-04,   2.0341629E-04
     +,   2.0283894E-04,   2.0239833E-04,   2.0202261E-04
     +,   2.0165001E-04,   2.0122841E-04,   2.0071493E-04
     +,   2.0007482E-04,   1.9928110E-04,   1.9831366E-04
     +,   1.9715849E-04,   1.9580677E-04,   1.9425461E-04
     +,   1.9250199E-04,   1.9055224E-04,   1.8841217E-04
     +,   1.8609047E-04,   1.8359817E-04,   1.8094787E-04
     +,   1.7815357E-04,   1.7523022E-04,   1.7219341E-04
     +,   1.6905958E-04,   1.6584512E-04,   1.6256652E-04
     +,   1.5924023E-04,   1.5588228E-04,   1.5250879E-04
     +,   1.4913446E-04,   1.4577423E-04,   1.4244170E-04
     +,   1.3914981E-04,   1.3591099E-04,   1.3273586E-04
     +,   1.2963497E-04,   1.2661733E-04,   1.2369105E-04
     +,   1.2086318E-04,   1.1813972E-04,   1.1552596E-04
     +,   1.1302550E-04,   1.1064172E-04,   1.0837664E-04
     +,   1.0623140E-04,   1.0420658E-04,   1.0230146E-04
     +,   1.0051506E-04,   9.8845536E-05,   9.7290300E-05
     +,   9.5846342E-05,   9.4510076E-05,   9.3277617E-05
     +,   9.2144444E-05,   9.1105969E-05,   9.0157206E-05
     +,   8.9292997E-05,   8.8508052E-05,   8.7796921E-05
     +,   8.7154243E-05,   8.6574531E-05,   8.6052358E-05
     +,   8.5582447E-05,   8.5159525E-05,   8.4778585E-05
     +,   8.4434680E-05,   8.4123094E-05,   8.3839368E-05
     +,   8.3579202E-05,   8.3338564E-05,   8.3113671E-05
     +,   8.2901002E-05,   8.2697254E-05,   8.2499435E-05
     +,   8.2304767E-05,   8.2110731E-05,   8.1915096E-05
     +,   8.1715792E-05,   8.1511025E-05,   8.1299258E-05
     +,   8.1079081E-05,   8.0849342E-05,   8.0609061E-05
     +,   8.0357422E-05,   8.0093734E-05,   7.9817546E-05
     +,   7.9528443E-05,   7.9226171E-05,   7.8910634E-05
     +,   7.8581696E-05,   7.8239435E-05,   7.7883968E-05
     +,   7.7515375E-05,   7.7133955E-05,   7.6739860E-05
     +,   7.6333403E-05,   7.5914875E-05,   7.5484539E-05
     +,   7.5042750E-05,   7.4589741E-05,   7.4125870E-05
     +,   7.3651303E-05,   7.3166404E-05,   7.2671341E-05
     +,   7.2166316E-05,   7.1651513E-05,   7.1127048E-05
     +,   7.0593109E-05,   7.0049653E-05,   6.9496818E-05
     +,   6.8934583E-05,   6.8362948E-05,   6.7781832E-05
     +,   6.7191198E-05,   6.6590976E-05,   6.5980981E-05
     +,   6.5361135E-05,   6.4731306E-05,   6.4091291E-05
     +,   6.3440995E-05,   6.2780164E-05,   6.2108753E-05
     +,   6.1426537E-05,   6.0733408E-05,   6.0029230E-05
     +,   5.9313876E-05,   5.8587346E-05,   5.7849473E-05
     +,   5.7100286E-05,   5.6339813E-05,   5.5568038E-05
     +,   5.4785130E-05,   5.3991091E-05,   5.3186213E-05
     +,   5.2370571E-05,   5.1544481E-05,   5.0708302E-05
     +,   4.9862247E-05,   4.9006845E-05,   4.8142392E-05
     +,   4.7269463E-05,   4.6388552E-05,   4.5500194E-05
     +,   4.4605091E-05,   4.3703756E-05,   4.2796972E-05
     +,   4.1885418E-05,   4.0969851E-05,   4.0051036E-05
     +,   3.9129740E-05,   3.8206865E-05,   3.7283200E-05
     +,   3.6359612E-05,   3.5436955E-05,   3.4516081E-05
     +,   3.3597957E-05,   3.2683332E-05,   3.1773216E-05
     +,   3.0868334E-05,   2.9969649E-05,   2.9077959E-05
     +,   2.8194070E-05,   2.7318874E-05,   2.6453024E-05
     +,   2.5597377E-05,   2.4752626E-05,   2.3919434E-05
     +,   2.3098562E-05,   2.2290507E-05,   2.1495987E-05
     +,   2.0715441E-05,   1.9949437E-05,   1.9198511E-05
     +,   1.8463008E-05,   1.7743350E-05,   1.7039860E-05
     +,   1.6352900E-05,   1.5682710E-05,   1.5029515E-05
     +,   1.4393499E-05,   1.3774779E-05,   1.3173511E-05
     +,   1.2589730E-05,   1.2023465E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wano_hz_60 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wano_hz_65(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  4.6523459E-05,   4.8784099E-05
     +,   5.1168408E-05,   5.3686905E-05,   5.6351430E-05
     +,   5.9175021E-05,   6.2171770E-05,   6.5357177E-05
     +,   6.8748028E-05,   7.2362054E-05,   7.6218603E-05
     +,   8.0338294E-05,   8.4743195E-05,   8.9457397E-05
     +,   9.4507523E-05,   9.9923353E-05,   1.0573950E-04
     +,   1.1199705E-04,   1.1874547E-04,   1.2604624E-04
     +,   1.3397609E-04,   1.4263111E-04,   1.5213092E-04
     +,   1.6262381E-04,   1.7428929E-04,   1.8734214E-04
     +,   2.0203226E-04,   2.1864277E-04,   2.3748339E-04
     +,   2.5888236E-04,   2.8316921E-04,   3.1065987E-04
     +,   3.4163351E-04,   3.7631247E-04,   4.1484070E-04
     +,   4.5727470E-04,   5.0357758E-04,   5.5362802E-04
     +,   6.0725084E-04,   6.6425890E-04,   7.2450831E-04
     +,   7.8797742E-04,   8.5483160E-04,   9.2549826E-04
     +,   1.0007094E-03,   1.0815182E-03,   1.1692586E-03
     +,   1.2654681E-03,   1.3717364E-03,   1.4895094E-03
     +,   1.6198788E-03,   1.7633714E-03,   1.9197699E-03
     +,   2.0880701E-03,   2.2665199E-03,   2.4528359E-03
     +,   2.6445421E-03,   2.8393934E-03,   3.0358131E-03
     +,   3.2332304E-03,   3.4322713E-03,   3.6346314E-03
     +,   3.8426958E-03,   4.0588290E-03,   4.2844489E-03
     +,   4.5191203E-03,   4.7597522E-03,   5.0002020E-03
     +,   5.2314801E-03,   5.4425299E-03,   5.6216470E-03
     +,   5.7581901E-03,   5.8443788E-03,   5.8767255E-03
     +,   5.8568907E-03,   5.7916795E-03,   5.6922040E-03
     +,   5.5722822E-03,   5.4463469E-03,   5.3271055E-03
     +,   5.2235690E-03,   5.1396214E-03,   5.0736610E-03
     +,   5.0192517E-03,   4.9667777E-03,   4.9056257E-03
     +,   4.8264395E-03,   4.7228518E-03,   4.5924028E-03
     +,   4.4365074E-03,   4.2596241E-03,   4.0679500E-03
     +,   3.8681177E-03,   3.6660973E-03,   3.4666078E-03
     +,   3.2729690E-03,   3.0872850E-03,   2.9108506E-03
     +,   2.7444691E-03,   2.5887268E-03,   2.4440954E-03
     +,   2.3108763E-03,   2.1891503E-03,   2.0786480E-03
     +,   1.9787117E-03,   1.8883322E-03,   1.8062143E-03
     +,   1.7309162E-03,   1.6609513E-03,   1.5949522E-03
     +,   1.5317351E-03,   1.4703765E-03,   1.4102368E-03
     +,   1.3509541E-03,   1.2924261E-03,   1.2347404E-03
     +,   1.1781502E-03,   1.1229825E-03,   1.0696060E-03
     +,   1.0183677E-03,   9.6956117E-04,   9.2340331E-04
     +,   8.8001654E-04,   8.3943020E-04,   8.0159149E-04
     +,   7.6637865E-04,   7.3362171E-04,   7.0312608E-04
     +,   6.7468523E-04,   6.4810272E-04,   6.2320312E-04
     +,   5.9983938E-04,   5.7789707E-04,   5.5729726E-04
     +,   5.3798658E-04,   5.1993725E-04,   5.0313794E-04
     +,   4.8758622E-04,   4.7328207E-04,   4.6022111E-04
     +,   4.4839055E-04,   4.3776349E-04,   4.2829890E-04
     +,   4.1993978E-04,   4.1261417E-04,   4.0623851E-04
     +,   4.0071667E-04,   3.9594743E-04,   3.9182478E-04
     +,   3.8824236E-04,   3.8509740E-04,   3.8229208E-04
     +,   3.7973726E-04,   3.7735372E-04,   3.7507367E-04
     +,   3.7284105E-04,   3.7061272E-04,   3.6835761E-04
     +,   3.6605570E-04,   3.6369849E-04,   3.6128674E-04
     +,   3.5882916E-04,   3.5634221E-04,   3.5384679E-04
     +,   3.5136848E-04,   3.4893531E-04,   3.4657615E-04
     +,   3.4432040E-04,   3.4219594E-04,   3.4022884E-04
     +,   3.3844146E-04,   3.3685350E-04,   3.3547930E-04
     +,   3.3432909E-04,   3.3340781E-04,   3.3271543E-04
     +,   3.3224642E-04,   3.3199077E-04,   3.3193282E-04
     +,   3.3205299E-04,   3.3232724E-04,   3.3272797E-04
     +,   3.3322471E-04,   3.3378418E-04,   3.3437141E-04
     +,   3.3495019E-04,   3.3548381E-04,   3.3593571E-04
     +,   3.3626996E-04,   3.3645207E-04,   3.3644919E-04
     +,   3.3623094E-04,   3.3576973E-04,   3.3504108E-04
     +,   3.3402370E-04,   3.3270026E-04,   3.3105657E-04
     +,   3.2908274E-04,   3.2677251E-04,   3.2412299E-04
     +,   3.2113536E-04,   3.1781345E-04,   3.1416496E-04
     +,   3.1019992E-04,   3.0593108E-04,   3.0137363E-04
     +,   2.9654405E-04,   2.9146115E-04,   2.8614452E-04
     +,   2.8061459E-04,   2.7489330E-04,   2.6900138E-04
     +,   2.6296123E-04,   2.5679410E-04,   2.5052123E-04
     +,   2.4416338E-04,   2.3774029E-04,   2.3127178E-04
     +,   2.2477531E-04,   2.1826888E-04,   2.1176864E-04
     +,   2.0528994E-04,   1.9884693E-04,   1.9245269E-04
     +,   1.8612012E-04,   1.7985947E-04,   1.7368176E-04
     +,   1.6759604E-04,   1.6161078E-04,   1.5573364E-04
     +,   1.4997114E-04,   1.4433013E-04,   1.3881504E-04
     +,   1.3343134E-04,   1.2818273E-04,   1.2307279E-04
     +,   1.1810441E-04,   1.1327968E-04,   1.0860086E-04
     +,   1.0406907E-04,   9.9685167E-05,   9.5449490E-05
     +,   9.1361842E-05,   8.7422224E-05,   8.3629136E-05
     +,   7.9981772E-05,   7.6478325E-05,   7.3116702E-05
     +,   6.9894973E-05,   6.6810077E-05,   6.3859581E-05
     +,   6.1039915E-05,   5.8347960E-05,   5.5780351E-05
     +,   5.3332973E-05,   5.1002302E-05,   4.8784004E-05
     +,   4.6674228E-05,   4.4668737E-05,   4.2763211E-05
     +,   4.0953670E-05,   3.9235591E-05,   3.7604965E-05
     +,   3.6057561E-05,   3.4589288E-05,   3.3196113E-05
     +,   3.1874079E-05,   3.0619449E-05,   2.9428500E-05
     +,   2.8297653E-05,   2.7223492E-05,   2.6202704E-05
     +,   2.5232264E-05,   2.4309058E-05,   2.3430401E-05
     +,   2.2593495E-05,   2.1795933E-05,   2.1035317E-05
     +,   2.0309408E-05,   1.9616222E-05,   1.8953720E-05
     +,   1.8320196E-05,   1.7713941E-05,   1.7133405E-05
     +,   1.6577205E-05,   1.6043943E-05,   1.5532463E-05
     +,   1.5041566E-05,   1.4570240E-05,   1.4117554E-05
     +,   1.3682562E-05,   1.3264454E-05,   1.2862452E-05
     +,   1.2475872E-05,   1.2104038E-05,   1.1746332E-05
     +,   1.1402177E-05,   1.1071022E-05,   1.0752379E-05
     +,   1.0445756E-05,   1.0150697E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wano_hz_65 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wano_hz_70(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  3.8502250E-05,   3.9952833E-05
     +,   4.1475658E-05,   4.3076165E-05,   4.4760473E-05
     +,   4.6535330E-05,   4.8408132E-05,   5.0387043E-05
     +,   5.2481075E-05,   5.4699900E-05,   5.7054243E-05
     +,   5.9555721E-05,   6.2216815E-05,   6.5051128E-05
     +,   6.8073350E-05,   7.1299102E-05,   7.4745352E-05
     +,   7.8430290E-05,   8.2373153E-05,   8.6594708E-05
     +,   9.1117028E-05,   9.5963653E-05,   1.0115933E-04
     +,   1.0673053E-04,   1.1270477E-04,   1.1911120E-04
     +,   1.2598005E-04,   1.3334262E-04,   1.4123059E-04
     +,   1.4967655E-04,   1.5871236E-04,   1.6836965E-04
     +,   1.7867860E-04,   1.8966752E-04,   2.0136124E-04
     +,   2.1378144E-04,   2.2694514E-04,   2.4086356E-04
     +,   2.5554257E-04,   2.7098224E-04,   2.8717559E-04
     +,   3.0411209E-04,   3.2177658E-04,   3.4015457E-04
     +,   3.5923501E-04,   3.7901683E-04,   3.9951515E-04
     +,   4.2077259E-04,   4.4286970E-04,   4.6593542E-04
     +,   4.9016293E-04,   5.1582133E-04,   5.4326444E-04
     +,   5.7294074E-04,   6.0539017E-04,   6.4123824E-04
     +,   6.8117533E-04,   7.2592183E-04,   7.7618298E-04
     +,   8.3258236E-04,   8.9559710E-04,   9.6547342E-04
     +,   1.0421607E-03,   1.1252547E-03,   1.2139612E-03
     +,   1.3071195E-03,   1.4032617E-03,   1.5007246E-03
     +,   1.5978387E-03,   1.6931357E-03,   1.7855973E-03
     +,   1.8748865E-03,   1.9615551E-03,   2.0471329E-03
     +,   2.1341438E-03,   2.2259192E-03,   2.3262620E-03
     +,   2.4389485E-03,   2.5671071E-03,   2.7126046E-03
     +,   2.8755188E-03,   3.0538717E-03,   3.2437181E-03
     +,   3.4396218E-03,   3.6355781E-03,   3.8259712E-03
     +,   4.0066377E-03,   4.1755079E-03,   4.3327915E-03
     +,   4.4806376E-03,   4.6223281E-03,   4.7614118E-03
     +,   4.9008541E-03,   5.0425790E-03,   5.1872991E-03
     +,   5.3346325E-03,   5.4832702E-03,   5.6310026E-03
     +,   5.7747262E-03,   5.9103281E-03,   6.0327309E-03
     +,   6.1361315E-03,   6.2144161E-03,   6.2616640E-03
     +,   6.2726270E-03,   6.2430482E-03,   6.1699720E-03
     +,   6.0520698E-03,   5.8900304E-03,   5.6871306E-03
     +,   5.4495246E-03,   5.1863473E-03,   4.9092099E-03
     +,   4.6312134E-03,   4.3655997E-03,   4.1241175E-03
     +,   3.9158659E-03,   3.7462118E-03,   3.6164501E-03
     +,   3.5238944E-03,   3.4624431E-03,   3.4235138E-03
     +,   3.3971341E-03,   3.3731777E-03,   3.3425048E-03
     +,   3.2979331E-03,   3.2348875E-03,   3.1516901E-03
     +,   3.0494360E-03,   2.9315115E-03,   2.8028963E-03
     +,   2.6693072E-03,   2.5364102E-03,   2.4091525E-03
     +,   2.2912943E-03,   2.1851989E-03,   2.0918262E-03
     +,   2.0108917E-03,   1.9411277E-03,   1.8806111E-03
     +,   1.8270809E-03,   1.7782127E-03,   1.7318580E-03
     +,   1.6862095E-03,   1.6398929E-03,   1.5920182E-03
     +,   1.5421414E-03,   1.4902418E-03,   1.4366155E-03
     +,   1.3817907E-03,   1.3264437E-03,   1.2712835E-03
     +,   1.2170143E-03,   1.1642588E-03,   1.1135376E-03
     +,   1.0652549E-03,   1.0197011E-03,   9.7707147E-04
     +,   9.3747035E-04,   9.0095360E-04,   8.6752966E-04
     +,   8.3718169E-04,   8.0988038E-04,   7.8557635E-04
     +,   7.6421595E-04,   7.4572704E-04,   7.3001848E-04
     +,   7.1697612E-04,   7.0645794E-04,   6.9829583E-04
     +,   6.9228967E-04,   6.8821601E-04,   6.8582827E-04
     +,   6.8486400E-04,   6.8505103E-04,   6.8611361E-04
     +,   6.8777910E-04,   6.8978476E-04,   6.9188169E-04
     +,   6.9383951E-04,   6.9544947E-04,   6.9652608E-04
     +,   6.9690892E-04,   6.9646270E-04,   6.9507683E-04
     +,   6.9266587E-04,   6.8916695E-04,   6.8453938E-04
     +,   6.7876413E-04,   6.7183870E-04,   6.6378049E-04
     +,   6.5462221E-04,   6.4441015E-04,   6.3320395E-04
     +,   6.2107248E-04,   6.0809671E-04,   5.9436134E-04
     +,   5.7995931E-04,   5.6498853E-04,   5.4954499E-04
     +,   5.3373037E-04,   5.1764055E-04,   5.0137355E-04
     +,   4.8502078E-04,   4.6866902E-04,   4.5240164E-04
     +,   4.3629139E-04,   4.2040765E-04,   4.0481001E-04
     +,   3.8955038E-04,   3.7467506E-04,   3.6021895E-04
     +,   3.4621352E-04,   3.3268152E-04,   3.1963974E-04
     +,   3.0709917E-04,   2.9506584E-04,   2.8354279E-04
     +,   2.7252643E-04,   2.6201317E-04,   2.5199499E-04
     +,   2.4246243E-04,   2.3340428E-04,   2.2480781E-04
     +,   2.1666058E-04,   2.0894737E-04,   2.0165445E-04
     +,   1.9476646E-04,   1.8826814E-04,   1.8214392E-04
     +,   1.7637773E-04,   1.7095428E-04,   1.6585650E-04
     +,   1.6106863E-04,   1.5657398E-04,   1.5235592E-04
     +,   1.4839764E-04,   1.4468229E-04,   1.4119335E-04
     +,   1.3791402E-04,   1.3482774E-04,   1.3191826E-04
     +,   1.2916948E-04,   1.2656610E-04,   1.2409274E-04
     +,   1.2173514E-04,   1.1947935E-04,   1.1731216E-04
     +,   1.1522141E-04,   1.1319522E-04,   1.1122323E-04
     +,   1.0929524E-04,   1.0740248E-04,   1.0553707E-04
     +,   1.0369151E-04,   1.0185985E-04,   1.0003636E-04
     +,   9.8216638E-05,   9.6396834E-05,   9.4573814E-05
     +,   9.2745417E-05,   9.0909700E-05,   8.9065739E-05
     +,   8.7212989E-05,   8.5351385E-05,   8.3481362E-05
     +,   8.1603706E-05,   7.9719692E-05,   7.7830751E-05
     +,   7.5938609E-05,   7.4045201E-05,   7.2152558E-05
     +,   7.0263108E-05,   6.8378919E-05,   6.6502624E-05
     +,   6.4636348E-05,   6.2782681E-05,   6.0943927E-05
     +,   5.9122322E-05,   5.7320311E-05,   5.5539771E-05
     +,   5.3782951E-05,   5.2051710E-05,   5.0347793E-05
     +,   4.8673068E-05,   4.7028789E-05,   4.5416611E-05
     +,   4.3837543E-05,   4.2292799E-05,   4.0783438E-05
     +,   3.9310111E-05,   3.7873546E-05,   3.6474219E-05
     +,   3.5112658E-05,   3.3789089E-05,   3.2503667E-05
     +,   3.1256441E-05,   3.0047308E-05,   2.8876218E-05
     +,   2.7742857E-05,   2.6646903E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wano_hz_70 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wano_hz_75(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  1.7799426E-05,   1.8853376E-05
     +,   1.9964782E-05,   2.1136431E-05,   2.2371214E-05
     +,   2.3672083E-05,   2.5041934E-05,   2.6483762E-05
     +,   2.8000535E-05,   2.9595107E-05,   3.1270349E-05
     +,   3.3029039E-05,   3.4873723E-05,   3.6806894E-05
     +,   3.8830847E-05,   4.0947514E-05,   4.3158700E-05
     +,   4.5465869E-05,   4.7870028E-05,   5.0371942E-05
     +,   5.2971900E-05,   5.5669803E-05,   5.8464924E-05
     +,   6.1356281E-05,   6.4342144E-05,   6.7420420E-05
     +,   7.0588510E-05,   7.3843330E-05,   7.7181103E-05
     +,   8.0597900E-05,   8.4089093E-05,   8.7649845E-05
     +,   9.1274953E-05,   9.4959090E-05,   9.8696401E-05
     +,   1.0248124E-04,   1.0630795E-04,   1.1017067E-04
     +,   1.1406394E-04,   1.1798251E-04,   1.2192142E-04
     +,   1.2587631E-04,   1.2984317E-04,   1.3381879E-04
     +,   1.3780090E-04,   1.4178816E-04,   1.4578002E-04
     +,   1.4977792E-04,   1.5378465E-04,   1.5780513E-04
     +,   1.6184693E-04,   1.6592088E-04,   1.7004153E-04
     +,   1.7422863E-04,   1.7850759E-04,   1.8291124E-04
     +,   1.8748094E-04,   1.9226818E-04,   1.9733609E-04
     +,   2.0276042E-04,   2.0863162E-04,   2.1505475E-04
     +,   2.2215018E-04,   2.3005359E-04,   2.3891324E-04
     +,   2.4888877E-04,   2.6014698E-04,   2.7285624E-04
     +,   2.8718158E-04,   3.0327716E-04,   3.2127905E-04
     +,   3.4129896E-04,   3.6341941E-04,   3.8768788E-04
     +,   4.1412353E-04,   4.4272203E-04,   4.7347095E-04
     +,   5.0637714E-04,   5.4149405E-04,   5.7897618E-04
     +,   6.1912398E-04,   6.6244230E-04,   7.0969446E-04
     +,   7.6193496E-04,   8.2054752E-04,   8.8720099E-04
     +,   9.6381298E-04,   1.0524254E-03,   1.1550452E-03
     +,   1.2734465E-03,   1.4089309E-03,   1.5621437E-03
     +,   1.7328948E-03,   1.9200863E-03,   2.1217396E-03
     +,   2.3351430E-03,   2.5571052E-03,   2.7842291E-03
     +,   3.0132886E-03,   3.2414508E-03,   3.4664634E-03
     +,   3.6867140E-03,   3.9011186E-03,   4.1090283E-03
     +,   4.3100822E-03,   4.5041908E-03,   4.6917656E-03
     +,   4.8740706E-03,   5.0537917E-03,   5.2351607E-03
     +,   5.4238103E-03,   5.6257634E-03,   5.8460175E-03
     +,   6.0870373E-03,   6.3478090E-03,   6.6239322E-03
     +,   6.9083432E-03,   7.1924962E-03,   7.4668834E-03
     +,   7.7209268E-03,   7.9423338E-03,   8.1169680E-03
     +,   8.2303239E-03,   8.2704825E-03,   8.2322638E-03
     +,   8.1207622E-03,   7.9525132E-03,   7.7534625E-03
     +,   7.5535304E-03,   7.3796213E-03,   7.2491756E-03
     +,   7.1663894E-03,   7.1221553E-03,   7.0975190E-03
     +,   7.0692901E-03,   7.0161661E-03,   6.9237961E-03
     +,   6.7875097E-03,   6.6123535E-03,   6.4104423E-03
     +,   6.1966279E-03,   5.9837303E-03,   5.7790573E-03
     +,   5.5832518E-03,   5.3916615E-03,   5.1975446E-03
     +,   4.9955165E-03,   4.7841868E-03,   4.5667551E-03
     +,   4.3499288E-03,   4.1416986E-03,   3.9488678E-03
     +,   3.7755114E-03,   3.6223864E-03,   3.4875018E-03
     +,   3.3673148E-03,   3.2580092E-03,   3.1565065E-03
     +,   3.0608790E-03,   2.9703320E-03,   2.8847731E-03
     +,   2.8043073E-03,   2.7288445E-03,   2.6578316E-03
     +,   2.5902896E-03,   2.5249373E-03,   2.4604497E-03
     +,   2.3956648E-03,   2.3297607E-03,   2.2623430E-03
     +,   2.1934060E-03,   2.1233088E-03,   2.0526431E-03
     +,   1.9821350E-03,   1.9125516E-03,   1.8446198E-03
     +,   1.7789889E-03,   1.7161862E-03,   1.6566170E-03
     +,   1.6005597E-03,   1.5481717E-03,   1.4995033E-03
     +,   1.4544796E-03,   1.4129397E-03,   1.3746170E-03
     +,   1.3391589E-03,   1.3061386E-03,   1.2750664E-03
     +,   1.2454193E-03,   1.2166520E-03,   1.1882375E-03
     +,   1.1596855E-03,   1.1305684E-03,   1.1005504E-03
     +,   1.0693880E-03,   1.0369587E-03,   1.0032419E-03
     +,   9.6833182E-04,   9.3241822E-04,   8.9576084E-04
     +,   8.5869193E-04,   8.2156819E-04,   7.8477396E-04
     +,   7.4868381E-04,   7.1365107E-04,   6.7999860E-04
     +,   6.4799405E-04,   6.1785942E-04,   5.8975397E-04
     +,   5.6378049E-04,   5.3998927E-04,   5.1837298E-04
     +,   4.9888558E-04,   4.8143879E-04,   4.6591370E-04
     +,   4.5216767E-04,   4.4004011E-04,   4.2936165E-04
     +,   4.1995390E-04,   4.1164132E-04,   4.0424979E-04
     +,   3.9761205E-04,   3.9156975E-04,   3.8597547E-04
     +,   3.8069417E-04,   3.7560254E-04,   3.7059185E-04
     +,   3.6556594E-04,   3.6044241E-04,   3.5515189E-04
     +,   3.4963753E-04,   3.4385579E-04,   3.3777277E-04
     +,   3.3136728E-04,   3.2462744E-04,   3.1755085E-04
     +,   3.1014357E-04,   3.0241904E-04,   2.9439791E-04
     +,   2.8610585E-04,   2.7757353E-04,   2.6883508E-04
     +,   2.5992744E-04,   2.5089056E-04,   2.4176309E-04
     +,   2.3258646E-04,   2.2340003E-04,   2.1424225E-04
     +,   2.0515123E-04,   1.9616044E-04,   1.8730365E-04
     +,   1.7860904E-04,   1.7010374E-04,   1.6181149E-04
     +,   1.5375113E-04,   1.4594037E-04,   1.3839158E-04
     +,   1.3111591E-04,   1.2412036E-04,   1.1740925E-04
     +,   1.1098532E-04,   1.0484719E-04,   9.8993165E-05
     +,   9.3418726E-05,   8.8117995E-05,   8.3083818E-05
     +,   7.8307799E-05,   7.3781186E-05,   6.9494025E-05
     +,   6.5436201E-05,   6.1597275E-05,   5.7966594E-05
     +,   5.4534095E-05,   5.1288906E-05,   4.8221482E-05
     +,   4.5321605E-05,   4.2580283E-05,   3.9988503E-05
     +,   3.7537728E-05,   3.5220302E-05,   3.3028402E-05
     +,   3.0955314E-05,   2.8994458E-05,   2.7139713E-05
     +,   2.5385683E-05,   2.3726883E-05,   2.2158734E-05
     +,   2.0676503E-05,   1.9276136E-05,   1.7953831E-05
     +,   1.6705788E-05,   1.5528640E-05,   1.4419119E-05
     +,   1.3374257E-05,   1.2391120E-05,   1.1466935E-05
     +,   1.0599060E-05,   9.7849197E-06,   9.0221165E-06
     +,   8.3082450E-06,   7.6410061E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wano_hz_75 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wano_hz_80(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  9.0935491E-06,   9.6804515E-06
     +,   1.0295809E-05,   1.0940224E-05,   1.1614290E-05
     +,   1.2318559E-05,   1.3053489E-05,   1.3819516E-05
     +,   1.4617029E-05,   1.5446303E-05,   1.6307595E-05
     +,   1.7201095E-05,   1.8126873E-05,   1.9084988E-05
     +,   2.0075413E-05,   2.1098012E-05,   2.2152630E-05
     +,   2.3239050E-05,   2.4356923E-05,   2.5505922E-05
     +,   2.6685637E-05,   2.7895636E-05,   2.9135399E-05
     +,   3.0404464E-05,   3.1702257E-05,   3.3028304E-05
     +,   3.4382090E-05,   3.5763183E-05,   3.7171125E-05
     +,   3.8605613E-05,   4.0066348E-05,   4.1553245E-05
     +,   4.3066259E-05,   4.4605615E-05,   4.6171601E-05
     +,   4.7764792E-05,   4.9386043E-05,   5.1036357E-05
     +,   5.2717205E-05,   5.4430315E-05,   5.6177760E-05
     +,   5.7962174E-05,   5.9786536E-05,   6.1654478E-05
     +,   6.3570224E-05,   6.5538748E-05,   6.7565707E-05
     +,   6.9657821E-05,   7.1822920E-05,   7.4069947E-05
     +,   7.6409422E-05,   7.8853634E-05,   8.1416663E-05
     +,   8.4115120E-05,   8.6968132E-05,   8.9998088E-05
     +,   9.3230738E-05,   9.6695992E-05,   1.0042827E-04
     +,   1.0446687E-04,   1.0885679E-04,   1.1364883E-04
     +,   1.1890024E-04,   1.2467499E-04,   1.3104330E-04
     +,   1.3808238E-04,   1.4587557E-04,   1.5451133E-04
     +,   1.6408316E-04,   1.7468723E-04,   1.8642124E-04
     +,   1.9938195E-04,   2.1366343E-04,   2.2935212E-04
     +,   2.4652694E-04,   2.6525461E-04,   2.8558704E-04
     +,   3.0755991E-04,   3.3118654E-04,   3.5646243E-04
     +,   3.8335985E-04,   4.1182936E-04,   4.4180136E-04
     +,   4.7318169E-04,   5.0586706E-04,   5.3973007E-04
     +,   5.7463621E-04,   6.1043998E-04,   6.4698985E-04
     +,   6.8413129E-04,   7.2170427E-04,   7.5955258E-04
     +,   7.9752144E-04,   8.3545945E-04,   8.7322237E-04
     +,   9.1067725E-04,   9.4770908E-04,   9.8422496E-04
     +,   1.0201726E-03,   1.0555489E-03,   1.0904216E-03
     +,   1.1249493E-03,   1.1593964E-03,   1.1941665E-03
     +,   1.2298131E-03,   1.2670489E-03,   1.3067515E-03
     +,   1.3499330E-03,   1.3977227E-03,   1.4512832E-03
     +,   1.5117503E-03,   1.5801422E-03,   1.6572759E-03
     +,   1.7437172E-03,   1.8397479E-03,   1.9454367E-03
     +,   2.0606788E-03,   2.1853619E-03,   2.3194815E-03
     +,   2.4632514E-03,   2.6171636E-03,   2.7819697E-03
     +,   2.9586696E-03,   3.1484216E-03,   3.3525389E-03
     +,   3.5725220E-03,   3.8101692E-03,   4.0676463E-03
     +,   4.3474920E-03,   4.6522981E-03,   4.9841143E-03
     +,   5.3436211E-03,   5.7294890E-03,   6.1384039E-03
     +,   6.5663457E-03,   7.0106410E-03,   7.4719572E-03
     +,   7.9545816E-03,   8.4638027E-03,   9.0009579E-03
     +,   9.5587894E-03,   1.0121061E-02,   1.0667644E-02
     +,   1.1182852E-02,   1.1660423E-02,   1.2099878E-02
     +,   1.2495769E-02,   1.2827821E-02,   1.3062716E-02
     +,   1.3168647E-02,   1.3133526E-02,   1.2973641E-02
     +,   1.2725390E-02,   1.2425691E-02,   1.2094403E-02
     +,   1.1729588E-02,   1.1318111E-02,   1.0853924E-02
     +,   1.0352366E-02,   9.8517872E-03,   9.3998769E-03
     +,   9.0324981E-03,   8.7565780E-03,   8.5467855E-03
     +,   8.3579039E-03,   8.1452271E-03,   7.8824656E-03
     +,   7.5689266E-03,   7.2246990E-03,   6.8787262E-03
     +,   6.5562949E-03,   6.2716217E-03,   6.0263858E-03
     +,   5.8131944E-03,   5.6207869E-03,   5.4385485E-03
     +,   5.2589881E-03,   5.0781597E-03,   4.8947819E-03
     +,   4.7090156E-03,   4.5216060E-03,   4.3336134E-03
     +,   4.1465377E-03,   3.9627221E-03,   3.7854123E-03
     +,   3.6185838E-03,   3.4663822E-03,   3.3323800E-03
     +,   3.2189046E-03,   3.1265081E-03,   3.0538850E-03
     +,   2.9979853E-03,   2.9544660E-03,   2.9182704E-03
     +,   2.8842019E-03,   2.8474962E-03,   2.8042148E-03
     +,   2.7515374E-03,   2.6878701E-03,   2.6128143E-03
     +,   2.5270639E-03,   2.4321410E-03,   2.3301921E-03
     +,   2.2236798E-03,   2.1151544E-03,   2.0070712E-03
     +,   1.9015912E-03,   1.8005434E-03,   1.7053350E-03
     +,   1.6169533E-03,   1.5359985E-03,   1.4626837E-03
     +,   1.3969243E-03,   1.3383572E-03,   1.2864093E-03
     +,   1.2403436E-03,   1.1993105E-03,   1.1624027E-03
     +,   1.1286837E-03,   1.0972499E-03,   1.0672491E-03
     +,   1.0379227E-03,   1.0086222E-03,   9.7882829E-04
     +,   9.4816228E-04,   9.1637502E-04,   8.8335638E-04
     +,   8.4910879E-04,   8.1373763E-04,   7.7742949E-04
     +,   7.4042892E-04,   7.0302596E-04,   6.6551921E-04
     +,   6.2821968E-04,   5.9141894E-04,   5.5538671E-04
     +,   5.2035932E-04,   4.8653511E-04,   4.5407529E-04
     +,   4.2309801E-04,   3.9368423E-04,   3.6587971E-04
     +,   3.3969866E-04,   3.1513267E-04,   2.9214512E-04
     +,   2.7068917E-04,   2.5070139E-04,   2.3211056E-04
     +,   2.1484263E-04,   1.9881663E-04,   1.8395633E-04
     +,   1.7018247E-04,   1.5742208E-04,   1.4560566E-04
     +,   1.3466489E-04,   1.2453964E-04,   1.1517073E-04
     +,   1.0650607E-04,   9.8495919E-05,   9.1094415E-05
     +,   8.4260115E-05,   7.7952827E-05,   7.2136761E-05
     +,   6.6777626E-05,   6.1843530E-05,   5.7304529E-05
     +,   5.3132346E-05,   4.9300768E-05,   4.5784647E-05
     +,   4.2560438E-05,   3.9605929E-05,   3.6900150E-05
     +,   3.4423705E-05,   3.2157812E-05,   3.0085546E-05
     +,   2.8190450E-05,   2.6457710E-05,   2.4873265E-05
     +,   2.3424083E-05,   2.2098324E-05,   2.0884685E-05
     +,   1.9773115E-05,   1.8754170E-05,   1.7819217E-05
     +,   1.6960466E-05,   1.6170590E-05,   1.5443135E-05
     +,   1.4772003E-05,   1.4151808E-05,   1.3577637E-05
     +,   1.3044938E-05,   1.2549663E-05,   1.2088107E-05
     +,   1.1656977E-05,   1.1253242E-05,   1.0874188E-05
     +,   1.0517366E-05,   1.0180563E-05,   9.8618202E-06
     +,   9.5593514E-06,   9.2715600E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wano_hz_80 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wano_hz_85(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  3.7065311E-06,   3.8969524E-06
     +,   4.1008302E-06,   4.3193613E-06,   4.5538518E-06
     +,   4.8057032E-06,   5.0764056E-06,   5.3675667E-06
     +,   5.6809013E-06,   6.0182124E-06,   6.3814327E-06
     +,   6.7725982E-06,   7.1938389E-06,   7.6474034E-06
     +,   8.1356502E-06,   8.6610062E-06,   9.2260188E-06
     +,   9.8333276E-06,   1.0485611E-05,   1.1185656E-05
     +,   1.1936290E-05,   1.2740414E-05,   1.3600908E-05
     +,   1.4520738E-05,   1.5502803E-05,   1.6550048E-05
     +,   1.7665365E-05,   1.8851622E-05,   2.0111558E-05
     +,   2.1447910E-05,   2.2863213E-05,   2.4359952E-05
     +,   2.5940451E-05,   2.7606915E-05,   2.9361243E-05
     +,   3.1205262E-05,   3.3140605E-05,   3.5168556E-05
     +,   3.7290290E-05,   3.9506780E-05,   4.1818595E-05
     +,   4.4226275E-05,   4.6729929E-05,   4.9329585E-05
     +,   5.2025003E-05,   5.4815802E-05,   5.7701254E-05
     +,   6.0680595E-05,   6.3752974E-05,   6.6917222E-05
     +,   7.0172253E-05,   7.3516923E-05,   7.6949909E-05
     +,   8.0470127E-05,   8.4076288E-05,   8.7767432E-05
     +,   9.1542606E-05,   9.5401061E-05,   9.9342353E-05
     +,   1.0336605E-04,   1.0747240E-04,   1.1166171E-04
     +,   1.1593478E-04,   1.2029315E-04,   1.2473851E-04
     +,   1.2927339E-04,   1.3390112E-04,   1.3862539E-04
     +,   1.4345109E-04,   1.4838396E-04,   1.5343071E-04
     +,   1.5859911E-04,   1.6389831E-04,   1.6933819E-04
     +,   1.7493042E-04,   1.8068793E-04,   1.8662485E-04
     +,   1.9275711E-04,   1.9910112E-04,   2.0567526E-04
     +,   2.1249884E-04,   2.1959197E-04,   2.2697581E-04
     +,   2.3467062E-04,   2.4269884E-04,   2.5108006E-04
     +,   2.5983457E-04,   2.6898051E-04,   2.7853408E-04
     +,   2.8850915E-04,   2.9891526E-04,   3.0975899E-04
     +,   3.2104226E-04,   3.3276176E-04,   3.4490926E-04
     +,   3.5747042E-04,   3.7042607E-04,   3.8374940E-04
     +,   3.9741016E-04,   4.1137217E-04,   4.2559547E-04
     +,   4.4003740E-04,   4.5465273E-04,   4.6939749E-04
     +,   4.8422994E-04,   4.9911434E-04,   5.1402388E-04
     +,   5.2894372E-04,   5.4388057E-04,   5.5886299E-04
     +,   5.7395350E-04,   5.8925652E-04,   6.0492725E-04
     +,   6.2118482E-04,   6.3832157E-04,   6.5672130E-04
     +,   6.7686272E-04,   6.9933519E-04,   7.2484091E-04
     +,   7.5419468E-04,   7.8832038E-04,   8.2822487E-04
     +,   8.7498268E-04,   9.2969299E-04,   9.9343131E-04
     +,   1.0671894E-03,   1.1518090E-03,   1.2478896E-03
     +,   1.3557151E-03,   1.4751608E-03,   1.6056080E-03
     +,   1.7458773E-03,   1.8942100E-03,   2.0482501E-03
     +,   2.2051712E-03,   2.3618080E-03,   2.5149006E-03
     +,   2.6613935E-03,   2.7987822E-03,   2.9254586E-03
     +,   3.0409929E-03,   3.1463676E-03,   3.2440412E-03
     +,   3.3379060E-03,   3.4331004E-03,   3.5357799E-03
     +,   3.6529498E-03,   3.7923066E-03,   3.9622467E-03
     +,   4.1717528E-03,   4.4298596E-03,   4.7445698E-03
     +,   5.1206518E-03,   5.5573368E-03,   6.0466100E-03
     +,   6.5738657E-03,   7.1218270E-03,   7.6766992E-03
     +,   8.2340650E-03,   8.7996870E-03,   9.3846321E-03
     +,   9.9958535E-03,   1.0628061E-02,   1.1262487E-02
     +,   1.1873285E-02,   1.2439812E-02,   1.2957093E-02
     +,   1.3438513E-02,   1.3907362E-02,   1.4381499E-02
     +,   1.4861660E-02,   1.5332450E-02,   1.5775753E-02
     +,   1.6182894E-02,   1.6554751E-02,   1.6891310E-02
     +,   1.7184786E-02,   1.7421296E-02,   1.7581850E-02
     +,   1.7634921E-02,   1.7532405E-02,   1.7226852E-02
     +,   1.6704543E-02,   1.6006663E-02,   1.5216953E-02
     +,   1.4424628E-02,   1.3687616E-02,   1.3017857E-02
     +,   1.2393750E-02,   1.1789242E-02,   1.1201045E-02
     +,   1.0654503E-02,   1.0185949E-02,   9.8156864E-03
     +,   9.5319767E-03,   9.2964610E-03,   9.0639153E-03
     +,   8.8023469E-03,   8.5021919E-03,   8.1728911E-03
     +,   7.8325905E-03,   7.4973661E-03,   7.1752840E-03
     +,   6.8656956E-03,   6.5627545E-03,   6.2602484E-03
     +,   5.9552640E-03,   5.6498917E-03,   5.3503998E-03
     +,   5.0651166E-03,   4.8019835E-03,   4.5664865E-03
     +,   4.3608467E-03,   4.1839308E-03,   4.0320349E-03
     +,   3.8998798E-03,   3.7815778E-03,   3.6714319E-03
     +,   3.5643426E-03,   3.4561260E-03,   3.3435805E-03
     +,   3.2245086E-03,   3.0976881E-03,   2.9628072E-03
     +,   2.8203989E-03,   2.6716313E-03,   2.5182040E-03
     +,   2.3620932E-03,   2.2053877E-03,   2.0501274E-03
     +,   1.8981789E-03,   1.7511904E-03,   1.6105025E-03
     +,   1.4772157E-03,   1.3521386E-03,   1.2358271E-03
     +,   1.1285908E-03,   1.0305089E-03,   9.4145647E-04
     +,   8.6111040E-04,   7.8899198E-04,   7.2450167E-04
     +,   6.6695560E-04,   6.1563548E-04,   5.6980550E-04
     +,   5.2876968E-04,   4.9187627E-04,   4.5854112E-04
     +,   4.2825972E-04,   4.0059554E-04,   3.7519261E-04
     +,   3.5175300E-04,   3.3003982E-04,   3.0986257E-04
     +,   2.9106328E-04,   2.7351917E-04,   2.5712411E-04
     +,   2.4179294E-04,   2.2745074E-04,   2.1403161E-04
     +,   2.0147883E-04,   1.8973764E-04,   1.7876079E-04
     +,   1.6850258E-04,   1.5892087E-04,   1.4997603E-04
     +,   1.4163031E-04,   1.3384879E-04,   1.2659741E-04
     +,   1.1984379E-04,   1.1355711E-04,   1.0770745E-04
     +,   1.0226694E-04,   9.7207310E-05,   9.2503004E-05
     +,   8.8127992E-05,   8.4058549E-05,   8.0271326E-05
     +,   7.6744138E-05,   7.3456431E-05,   7.0387927E-05
     +,   6.7520370E-05,   6.4836189E-05,   6.2319028E-05
     +,   5.9954084E-05,   5.7727080E-05,   5.5625518E-05
     +,   5.3637392E-05,   5.1752224E-05,   4.9960468E-05
     +,   4.8253278E-05,   4.6622928E-05,   4.5062425E-05
     +,   4.3565753E-05,   4.2127431E-05,   4.0742700E-05
     +,   3.9407398E-05,   3.8117876E-05,   3.6871123E-05
     +,   3.5664380E-05,   3.4495355E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wano_hz_85 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wano_hz_90(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  3.2354679E-09,   3.8986609E-09
     +,   4.6895563E-09,   5.6309584E-09,   6.7494605E-09
     +,   8.0759559E-09,   9.6461372E-09,   1.1501372E-08
     +,   1.3689384E-08,   1.6264977E-08,   1.9291230E-08
     +,   2.2840457E-08,   2.6995126E-08,   3.1849545E-08
     +,   3.7511100E-08,   4.4101423E-08,   5.1758668E-08
     +,   6.0639088E-08,   7.0918425E-08,   8.2794905E-08
     +,   9.6490901E-08,   1.1225585E-07,   1.3036735E-07
     +,   1.5113629E-07,   1.7490669E-07,   2.0206133E-07
     +,   2.3302329E-07,   2.6826010E-07,   3.0828420E-07
     +,   3.5366122E-07,   4.0500726E-07,   4.6299715E-07
     +,   5.2836521E-07,   6.0191064E-07,   6.8449395E-07
     +,   7.7704931E-07,   8.8058221E-07,   9.9616682E-07
     +,   1.1249581E-06,   1.2681893E-06,   1.4271637E-06
     +,   1.6032740E-06,   1.7979792E-06,   2.0128248E-06
     +,   2.2494289E-06,   2.5094882E-06,   2.7947551E-06
     +,   3.1070624E-06,   3.4483032E-06,   3.8204093E-06
     +,   4.2253755E-06,   4.6652426E-06,   5.1420552E-06
     +,   5.6579133E-06,   6.2148933E-06,   6.8151007E-06
     +,   7.4606196E-06,   8.1535136E-06,   8.8958286E-06
     +,   9.6895274E-06,   1.0536567E-05,   1.1438794E-05
     +,   1.2398019E-05,   1.3415989E-05,   1.4494316E-05
     +,   1.5634576E-05,   1.6838290E-05,   1.8106821E-05
     +,   1.9441566E-05,   2.0843854E-05,   2.2314978E-05
     +,   2.3856272E-05,   2.5469184E-05,   2.7155062E-05
     +,   2.8915621E-05,   3.0752715E-05,   3.2668537E-05
     +,   3.4665693E-05,   3.6747115E-05,   3.8916533E-05
     +,   4.1178366E-05,   4.3537853E-05,   4.6001434E-05
     +,   4.8576308E-05,   5.1271734E-05,   5.4097887E-05
     +,   5.7067027E-05,   6.0193343E-05,   6.3493164E-05
     +,   6.6985340E-05,   7.0690861E-05,   7.4633914E-05
     +,   7.8841367E-05,   8.3343250E-05,   8.8172492E-05
     +,   9.3365212E-05,   9.8960780E-05,   1.0500076E-04
     +,   1.1152980E-04,   1.1859465E-04,   1.2624351E-04
     +,   1.3452591E-04,   1.4349024E-04,   1.5318471E-04
     +,   1.6365502E-04,   1.7494269E-04,   1.8708459E-04
     +,   2.0010849E-04,   2.1403669E-04,   2.2887728E-04
     +,   2.4462841E-04,   2.6127390E-04,   2.7878321E-04
     +,   2.9711137E-04,   3.1619595E-04,   3.3596586E-04
     +,   3.5633380E-04,   3.7720817E-04,   3.9849422E-04
     +,   4.2010163E-04,   4.4195450E-04,   4.6399841E-04
     +,   4.8621700E-04,   5.0864328E-04,   5.3137413E-04
     +,   5.5458501E-04,   5.7854515E-04,   6.0362415E-04
     +,   6.3030428E-04,   6.5917667E-04,   6.9093285E-04
     +,   7.2634500E-04,   7.6623267E-04,   8.1140827E-04
     +,   8.6262549E-04,   9.2049938E-04,   9.8542648E-04
     +,   1.0575069E-03,   1.1364685E-03,   1.2216166E-03
     +,   1.3117988E-03,   1.4054332E-03,   1.5005553E-03
     +,   1.5949247E-03,   1.6861744E-03,   1.7719764E-03
     +,   1.8502793E-03,   1.9194578E-03,   1.9785305E-03
     +,   2.0272720E-03,   2.0662763E-03,   2.0969615E-03
     +,   2.1214695E-03,   2.1425080E-03,   2.1631508E-03
     +,   2.1866048E-03,   2.2160052E-03,   2.2542553E-03
     +,   2.3039826E-03,   2.3675526E-03,   2.4472356E-03
     +,   2.5454047E-03,   2.6647623E-03,   2.8085045E-03
     +,   2.9801889E-03,   3.1833618E-03,   3.4207152E-03
     +,   3.6929885E-03,   3.9979024E-03,   4.3295813E-03
     +,   4.6793325E-03,   5.0375895E-03,   5.3974679E-03
     +,   5.7582818E-03,   6.1276383E-03,   6.5201856E-03
     +,   6.9522141E-03,   7.4338843E-03,   7.9629105E-03
     +,   8.5249506E-03,   9.1029257E-03,   9.6917255E-03
     +,   1.0309822E-02,   1.0997979E-02,   1.1803743E-02
     +,   1.2757350E-02,   1.3852373E-02,   1.5043658E-02
     +,   1.6266843E-02,   1.7467530E-02,   1.8611213E-02
     +,   1.9664668E-02,   2.0575669E-02,   2.1288715E-02
     +,   2.1782231E-02,   2.2079049E-02,   2.2229305E-02
     +,   2.2304146E-02,   2.2396417E-02,   2.2583390E-02
     +,   2.2862155E-02,   2.3124881E-02,   2.3207080E-02
     +,   2.2971217E-02,   2.2375735E-02,   2.1510862E-02
     +,   2.0585211E-02,   1.9844342E-02,   1.9441392E-02
     +,   1.9348327E-02,   1.9386631E-02,   1.9352630E-02
     +,   1.9126857E-02,   1.8686501E-02,   1.8043391E-02
     +,   1.7195230E-02,   1.6141068E-02,   1.4930822E-02
     +,   1.3679699E-02,   1.2523312E-02,   1.1548246E-02
     +,   1.0756789E-02,   1.0085500E-02,   9.4543910E-03
     +,   8.8087842E-03,   8.1334207E-03,   7.4437181E-03
     +,   6.7674206E-03,   6.1297310E-03,   5.5460921E-03
     +,   5.0217430E-03,   4.5549218E-03,   4.1402625E-03
     +,   3.7715780E-03,   3.4429056E-03,   3.1489443E-03
     +,   2.8850490E-03,   2.6471235E-03,   2.4316371E-03
     +,   2.2355427E-03,   2.0563363E-03,   1.8920149E-03
     +,   1.7410268E-03,   1.6022121E-03,   1.4746294E-03
     +,   1.3575352E-03,   1.2502390E-03,   1.1520808E-03
     +,   1.0624194E-03,   9.8059722E-04,   9.0599887E-04
     +,   8.3801831E-04,   7.7610387E-04,   7.1974698E-04
     +,   6.6847040E-04,   6.2185345E-04,   5.7949673E-04
     +,   5.4104516E-04,   5.0616387E-04,   4.7454238E-04
     +,   4.4589586E-04,   4.1994968E-04,   3.9645442E-04
     +,   3.7517076E-04,   3.5587503E-04,   3.3835720E-04
     +,   3.2242047E-04,   3.0788305E-04,   2.9457558E-04
     +,   2.8234365E-04,   2.7104691E-04,   2.6055958E-04
     +,   2.5077153E-04,   2.4158388E-04,   2.3291385E-04
     +,   2.2468796E-04,   2.1684625E-04,   2.0933748E-04
     +,   2.0211915E-04,   1.9515742E-04,   1.8842300E-04
     +,   1.8189401E-04,   1.7555192E-04,   1.6938214E-04
     +,   1.6337387E-04,   1.5751724E-04,   1.5180623E-04
     +,   1.4623458E-04,   1.4079857E-04,   1.3549534E-04
     +,   1.3032179E-04,   1.2527610E-04,   1.2035647E-04
     +,   1.1556190E-04,   1.1089089E-04,   1.0634232E-04
     +,   1.0191492E-04,   9.7607335E-05,   9.3418581E-05
     +,   8.9347122E-05,   8.5391526E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wano_hz_90 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wano_hz_95(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  7.2075345E-08,   7.9941792E-08
     +,   8.8591321E-08,   9.8092777E-08,   1.0852059E-07
     +,   1.1995465E-07,   1.3247990E-07,   1.4618794E-07
     +,   1.6117667E-07,   1.7754984E-07,   1.9541866E-07
     +,   2.1490193E-07,   2.3612451E-07,   2.5922026E-07
     +,   2.8433098E-07,   3.1160539E-07,   3.4120225E-07
     +,   3.7328905E-07,   4.0804053E-07,   4.4564251E-07
     +,   4.8628903E-07,   5.3018539E-07,   5.7754335E-07
     +,   6.2858800E-07,   6.8355064E-07,   7.4267530E-07
     +,   8.0621470E-07,   8.7443283E-07,   9.4759957E-07
     +,   1.0260001E-06,   1.1099221E-06,   1.1996685E-06
     +,   1.2955491E-06,   1.3978840E-06,   1.5069971E-06
     +,   1.6232249E-06,   1.7469139E-06,   1.8784084E-06
     +,   2.0180692E-06,   2.1662624E-06,   2.3233542E-06
     +,   2.4897258E-06,   2.6657524E-06,   2.8518241E-06
     +,   3.0483329E-06,   3.2556795E-06,   3.4742561E-06
     +,   3.7044731E-06,   3.9467450E-06,   4.2014776E-06
     +,   4.4690951E-06,   4.7500280E-06,   5.0447002E-06
     +,   5.3535609E-06,   5.6770482E-06,   6.0156249E-06
     +,   6.3697621E-06,   6.7399451E-06,   7.1266768E-06
     +,   7.5304629E-06,   7.9518559E-06,   8.3914038E-06
     +,   8.8497000E-06,   9.3273766E-06,   9.8250657E-06
     +,   1.0343468E-05,   1.0883324E-05,   1.1445390E-05
     +,   1.2030498E-05,   1.2639523E-05,   1.3273399E-05
     +,   1.3933109E-05,   1.4619727E-05,   1.5334312E-05
     +,   1.6078055E-05,   1.6852191E-05,   1.7658011E-05
     +,   1.8496901E-05,   1.9370205E-05,   2.0279413E-05
     +,   2.1226026E-05,   2.2211581E-05,   2.3237693E-05
     +,   2.4305822E-05,   2.5417723E-05,   2.6574839E-05
     +,   2.7778784E-05,   2.9031064E-05,   3.0333129E-05
     +,   3.1686424E-05,   3.3092136E-05,   3.4551496E-05
     +,   3.6065576E-05,   3.7635284E-05,   3.9261417E-05
     +,   4.0944586E-05,   4.2685373E-05,   4.4483982E-05
     +,   4.6340712E-05,   4.8255708E-05,   5.0229053E-05
     +,   5.2260933E-05,   5.4351389E-05,   5.6500863E-05
     +,   5.8710022E-05,   6.0979994E-05,   6.3312604E-05
     +,   6.5710097E-05,   6.8176501E-05,   7.0716429E-05
     +,   7.3336530E-05,   7.6045333E-05,   7.8853700E-05
     +,   8.1775368E-05,   8.4826868E-05,   8.8029148E-05
     +,   9.1406589E-05,   9.4988740E-05,   9.8810313E-05
     +,   1.0291186E-04,   1.0734046E-04,   1.1214974E-04
     +,   1.1740135E-04,   1.2316504E-04,   1.2951931E-04
     +,   1.3655222E-04,   1.4436229E-04,   1.5305818E-04
     +,   1.6276106E-04,   1.7360419E-04,   1.8573404E-04
     +,   1.9931019E-04,   2.1450604E-04,   2.3150531E-04
     +,   2.5050330E-04,   2.7170056E-04,   2.9529814E-04
     +,   3.2148839E-04,   3.5044458E-04,   3.8230763E-04
     +,   4.1716496E-04,   4.5503941E-04,   4.9586553E-04
     +,   5.3947273E-04,   5.8557099E-04,   6.3373352E-04
     +,   6.8341335E-04,   7.3392689E-04,   7.8449253E-04
     +,   8.3425513E-04,   8.8232267E-04,   9.2783821E-04
     +,   9.7001664E-04,   1.0082230E-03,   1.0420223E-03
     +,   1.0712305E-03,   1.0959469E-03,   1.1165646E-03
     +,   1.1337702E-03,   1.1485044E-03,   1.1619183E-03
     +,   1.1753084E-03,   1.1900458E-03,   1.2075112E-03
     +,   1.2290295E-03,   1.2558367E-03,   1.2890530E-03
     +,   1.3296867E-03,   1.3786496E-03,   1.4367676E-03
     +,   1.5048228E-03,   1.5835145E-03,   1.6734570E-03
     +,   1.7750828E-03,   1.8885444E-03,   2.0135634E-03
     +,   2.1492592E-03,   2.2940438E-03,   2.4455346E-03
     +,   2.6006056E-03,   2.7556031E-03,   2.9067206E-03
     +,   3.0506572E-03,   3.1852806E-03,   3.3104930E-03
     +,   3.4289374E-03,   3.5465651E-03,   3.6728331E-03
     +,   3.8203765E-03,   4.0040226E-03,   4.2387475E-03
     +,   4.5369170E-03,   4.9049803E-03,   5.3406800E-03
     +,   5.8323485E-03,   6.3604084E-03,   6.9018179E-03
     +,   7.4348808E-03,   7.9440875E-03,   8.4244674E-03
     +,   8.8865235E-03,   9.3624247E-03,   9.9061709E-03
     +,   1.0578983E-02,   1.1416320E-02,   1.2395069E-02
     +,   1.3435006E-02,   1.4447226E-02,   1.5394718E-02
     +,   1.6300870E-02,   1.7189810E-02,   1.8024314E-02
     +,   1.8734766E-02,   1.9352805E-02,   2.0104466E-02
     +,   2.1271676E-02,   2.2885622E-02,   2.4630420E-02
     +,   2.6152251E-02,   2.7398396E-02,   2.8522421E-02
     +,   2.9488297E-02,   2.9962175E-02,   2.9676350E-02
     +,   2.8740434E-02,   2.7485762E-02,   2.6166197E-02
     +,   2.4924358E-02,   2.3885805E-02,   2.3099339E-02
     +,   2.2407081E-02,   2.1495903E-02,   2.0133268E-02
     +,   1.8343341E-02,   1.6357008E-02,   1.4429392E-02
     +,   1.2709431E-02,   1.1228754E-02,   9.9534635E-03
     +,   8.8324957E-03,   7.8225303E-03,   6.8949298E-03
     +,   6.0349884E-03,   5.2394876E-03,   4.5128441E-03
     +,   3.8628234E-03,   3.2949881E-03,   2.8092852E-03
     +,   2.3996527E-03,   2.0560410E-03,   1.7676854E-03
     +,   1.5251279E-03,   1.3212053E-03,   1.1506785E-03
     +,   1.0094545E-03,   8.9399522E-04,   8.0085616E-04
     +,   7.2666240E-04,   6.6813652E-04,   6.2223856E-04
     +,   5.8626925E-04,   5.5790291E-04,   5.3521560E-04
     +,   5.1664718E-04,   5.0096790E-04,   4.8723182E-04
     +,   4.7472789E-04,   4.6293790E-04,   4.5149372E-04
     +,   4.4014386E-04,   4.2872451E-04,   4.1713621E-04
     +,   4.0532689E-04,   3.9327538E-04,   3.8098748E-04
     +,   3.6848258E-04,   3.5579570E-04,   3.4296923E-04
     +,   3.3005176E-04,   3.1709860E-04,   3.0416381E-04
     +,   2.9130571E-04,   2.7857942E-04,   2.6603776E-04
     +,   2.5373121E-04,   2.4170213E-04,   2.2999040E-04
     +,   2.1862604E-04,   2.0763479E-04,   1.9703573E-04
     +,   1.8683926E-04,   1.7705160E-04,   1.6767283E-04
     +,   1.5869951E-04,   1.5012326E-04,   1.4193325E-04
     +,   1.3411634E-04,   1.2665770E-04,   1.1954275E-04
     +,   1.1275568E-04,   1.0628135E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wano_hz_95 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wano_qq(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  7.0574896E-21,   1.0160539E-20
     +,   1.4601127E-20,   2.0943814E-20,   2.9986677E-20
     +,   4.2855410E-20,   6.1134005E-20,   8.7048533E-20
     +,   1.2372143E-19,   1.7552066E-19,   2.4855144E-19
     +,   3.5132372E-19,   4.9567676E-19,   6.9805731E-19
     +,   9.8127164E-19,   1.3768520E-18,   1.9283615E-18
     +,   2.6958420E-18,   3.7618396E-18,   5.2397036E-18
     +,   7.2847795E-18,   1.0109567E-17,   1.4003858E-17
     +,   1.9362745E-17,   2.6723097E-17,   3.6813597E-17
     +,   5.0621339E-17,   6.9480399E-17,   9.5190257E-17
     +,   1.3017449E-16,   1.7768877E-16,   2.4210145E-16
     +,   3.2925799E-16,   4.4697097E-16,   6.0565317E-16
     +,   8.1916270E-16,   1.1059182E-15,   1.4903017E-15
     +,   2.0046007E-15,   2.6914559E-15,   3.6070047E-15
     +,   4.8251549E-15,   6.4428053E-15,   8.5870142E-15
     +,   1.1423857E-14,   1.5170040E-14,   2.0107673E-14
     +,   2.6603592E-14,   3.5133578E-14,   4.6313366E-14
     +,   6.0938579E-14,   8.0035669E-14,   1.0492428E-13
     +,   1.3730077E-13,   1.7933722E-13,   2.3381465E-13
     +,   3.0428185E-13,   3.9526062E-13,   5.1250237E-13
     +,   6.6329971E-13,   8.5689859E-13,   1.1049689E-12
     +,   1.4222442E-12,   1.8272766E-12,   2.3433412E-12
     +,   2.9996559E-12,   3.8327640E-12,   4.8882768E-12
     +,   6.2230477E-12,   7.9077847E-12,   1.0030228E-11
     +,   1.2699054E-11,   1.6048761E-11,   2.0244709E-11
     +,   2.5490983E-11,   3.2038133E-11,   4.0193293E-11
     +,   5.0332547E-11,   6.2913862E-11,   7.8496487E-11
     +,   9.7759828E-11,   1.2152812E-10,   1.5080109E-10
     +,   1.8678048E-10,   2.3092608E-10,   2.8498329E-10
     +,   3.5105363E-10,   4.3165418E-10,   5.2979487E-10
     +,   6.4907102E-10,   7.9374868E-10,   9.6891128E-10
     +,   1.1805803E-09,   1.4358802E-09,   1.7432229E-09
     +,   2.1125131E-09,   2.5554205E-09,   3.0855669E-09
     +,   3.7189671E-09,   4.4742889E-09,   5.3732978E-09
     +,   6.4413541E-09,   7.7077384E-09,   9.2065031E-09
     +,   1.0976929E-08,   1.3064303E-08,   1.5520811E-08
     +,   1.8405952E-08,   2.1788621E-08,   2.5746681E-08
     +,   3.0369470E-08,   3.5758404E-08,   4.2028642E-08
     +,   4.9310856E-08,   5.7751496E-08,   6.7517895E-08
     +,   7.8795736E-08,   9.1795080E-08,   1.0675047E-07
     +,   1.2392390E-07,   1.4360820E-07,   1.6612660E-07
     +,   1.9183969E-07,   2.2114581E-07,   2.5448469E-07
     +,   2.9234053E-07,   3.3524628E-07,   3.8378190E-07
     +,   4.3858526E-07,   5.0035032E-07,   5.6983265E-07
     +,   6.4785047E-07,   7.3529264E-07,   8.3310880E-07
     +,   9.4232973E-07,   1.0640591E-06,   1.1994766E-06
     +,   1.3498430E-06,   1.5164975E-06,   1.7008688E-06
     +,   1.9044462E-06,   2.1288206E-06,   2.3756565E-06
     +,   2.6466962E-06,   2.9437711E-06,   3.2687358E-06
     +,   3.6235981E-06,   4.0103382E-06,   4.4310445E-06
     +,   4.8878551E-06,   5.3828762E-06,   5.9183667E-06
     +,   6.4964688E-06,   7.1194013E-06,   7.7893555E-06
     +,   8.5084866E-06,   9.2789378E-06,   1.0102666E-05
     +,   1.0981755E-05,   1.1917960E-05,   1.2913038E-05
     +,   1.3968602E-05,   1.5085918E-05,   1.6266353E-05
     +,   1.7510738E-05,   1.8819828E-05,   2.0194064E-05
     +,   2.1633570E-05,   2.3138213E-05,   2.4707264E-05
     +,   2.6340049E-05,   2.8035065E-05,   2.9790646E-05
     +,   3.1604643E-05,   3.3474451E-05,   3.5397101E-05
     +,   3.7368958E-05,   3.9386123E-05,   4.1444189E-05
     +,   4.3538312E-05,   4.5663292E-05,   4.7813202E-05
     +,   4.9982300E-05,   5.2163941E-05,   5.4351476E-05
     +,   5.6537952E-05,   5.8716185E-05,   6.0878945E-05
     +,   6.3018604E-05,   6.5128086E-05,   6.7199842E-05
     +,   6.9226793E-05,   7.1202106E-05,   7.3118972E-05
     +,   7.4971555E-05,   7.6753910E-05,   7.8461242E-05
     +,   8.0089063E-05,   8.1633632E-05,   8.3092382E-05
     +,   8.4463150E-05,   8.5745145E-05,   8.6938133E-05
     +,   8.8043067E-05,   8.9061796E-05,   8.9996989E-05
     +,   9.0852373E-05,   9.1632326E-05,   9.2342016E-05
     +,   9.2987211E-05,   9.3574025E-05,   9.4109098E-05
     +,   9.4599054E-05,   9.5050615E-05,   9.5470197E-05
     +,   9.5863907E-05,   9.6237301E-05,   9.6595119E-05
     +,   9.6941345E-05,   9.7278913E-05,   9.7609722E-05
     +,   9.7934528E-05,   9.8253069E-05,   9.8564036E-05
     +,   9.8865261E-05,   9.9154015E-05,   9.9427154E-05
     +,   9.9681631E-05,   9.9914898E-05,   1.0012549E-04
     +,   1.0031352E-04,   1.0048144E-04,   1.0063472E-04
     +,   1.0078248E-04,   1.0093829E-04,   1.0112079E-04
     +,   1.0135429E-04,   1.0166926E-04,   1.0210278E-04
     +,   1.0269862E-04,   1.0350737E-04,   1.0458613E-04
     +,   1.0599823E-04,   1.0781216E-04,   1.1010133E-04
     +,   1.1294208E-04,   1.1641285E-04,   1.2059272E-04
     +,   1.2555876E-04,   1.3138630E-04,   1.3814440E-04
     +,   1.4589755E-04,   1.5470090E-04,   1.6460015E-04
     +,   1.7563300E-04,   1.8782311E-04,   2.0118644E-04
     +,   2.1572408E-04,   2.3142832E-04,   2.4828097E-04
     +,   2.6625142E-04,   2.8530546E-04,   3.0539633E-04
     +,   3.2647437E-04,   3.4848531E-04,   3.7137259E-04
     +,   3.9508208E-04,   4.1956094E-04,   4.4476759E-04
     +,   4.7067352E-04,   4.9726904E-04,   5.2457093E-04
     +,   5.5262161E-04,   5.8150542E-04,   6.1133405E-04
     +,   6.4226217E-04,   6.7446311E-04,   7.0812984E-04
     +,   7.4345141E-04,   7.8058185E-04,   8.1962638E-04
     +,   8.6058694E-04,   9.0334367E-04,   9.4761734E-04
     +,   9.9293597E-04,   1.0386376E-03,   1.0838403E-03
     +,   1.1274839E-03,   1.1683346E-03,   1.2050434E-03
     +,   1.2362136E-03,   1.2604615E-03,   1.2765019E-03
     +,   1.2832269E-03,   1.2797812E-03,   1.2656215E-03
     +,   1.2405619E-03,   1.2047949E-03,   1.1588967E-03
     +,   1.1037946E-03,   1.0407264E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wano_qq = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wano_ww(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  9.8688145E-07,   1.0376210E-06
     +,   1.0903185E-06,   1.1450062E-06,   1.2017179E-06
     +,   1.2604847E-06,   1.3213328E-06,   1.3842885E-06
     +,   1.4493763E-06,   1.5166133E-06,   1.5860179E-06
     +,   1.6576053E-06,   1.7313826E-06,   1.8073578E-06
     +,   1.8855357E-06,   1.9659121E-06,   2.0484838E-06
     +,   2.1332428E-06,   2.2201725E-06,   2.3092564E-06
     +,   2.4004723E-06,   2.4937945E-06,   2.5891882E-06
     +,   2.6866198E-06,   2.7860451E-06,   2.8874197E-06
     +,   2.9906930E-06,   3.0958111E-06,   3.2027117E-06
     +,   3.3113331E-06,   3.4216039E-06,   3.5334524E-06
     +,   3.6468032E-06,   3.7615780E-06,   3.8776898E-06
     +,   3.9950542E-06,   4.1135850E-06,   4.2331881E-06
     +,   4.3537730E-06,   4.4752487E-06,   4.5975185E-06
     +,   4.7204944E-06,   4.8440793E-06,   4.9681857E-06
     +,   5.0927288E-06,   5.2176238E-06,   5.3427902E-06
     +,   5.4681564E-06,   5.5936571E-06,   5.7192278E-06
     +,   5.8448231E-06,   5.9704021E-06,   6.0959319E-06
     +,   6.2213990E-06,   6.3467946E-06,   6.4721316E-06
     +,   6.5974359E-06,   6.7227516E-06,   6.8481395E-06
     +,   6.9736780E-06,   7.0994706E-06,   7.2256298E-06
     +,   7.3523051E-06,   7.4796631E-06,   7.6078854E-06
     +,   7.7371860E-06,   7.8678022E-06,   7.9999900E-06
     +,   8.1340331E-06,   8.2702372E-06,   8.4089315E-06
     +,   8.5504671E-06,   8.6952195E-06,   8.8435736E-06
     +,   8.9959422E-06,   9.1527527E-06,   9.3144445E-06
     +,   9.4814850E-06,   9.6543172E-06,   9.8334249E-06
     +,   1.0019280E-05,   1.0212363E-05,   1.0413160E-05
     +,   1.0622117E-05,   1.0839733E-05,   1.1066438E-05
     +,   1.1302685E-05,   1.1548899E-05,   1.1805491E-05
     +,   1.2072862E-05,   1.2351359E-05,   1.2641342E-05
     +,   1.2943132E-05,   1.3257035E-05,   1.3583335E-05
     +,   1.3922297E-05,   1.4274178E-05,   1.4639193E-05
     +,   1.5017589E-05,   1.5409587E-05,   1.5815431E-05
     +,   1.6235383E-05,   1.6669685E-05,   1.7118657E-05
     +,   1.7582648E-05,   1.8062059E-05,   1.8557375E-05
     +,   1.9069088E-05,   1.9597901E-05,   2.0144489E-05
     +,   2.0709716E-05,   2.1294543E-05,   2.1900061E-05
     +,   2.2527522E-05,   2.3178214E-05,   2.3853756E-05
     +,   2.4555715E-05,   2.5285912E-05,   2.6046264E-05
     +,   2.6838816E-05,   2.7665739E-05,   2.8529221E-05
     +,   2.9431572E-05,   3.0375129E-05,   3.1362222E-05
     +,   3.2395135E-05,   3.3476128E-05,   3.4607205E-05
     +,   3.5790308E-05,   3.7027145E-05,   3.8319085E-05
     +,   3.9667226E-05,   4.1072271E-05,   4.2534324E-05
     +,   4.4053166E-05,   4.5627916E-05,   4.7257119E-05
     +,   4.8938637E-05,   5.0669652E-05,   5.2446696E-05
     +,   5.4265311E-05,   5.6120505E-05,   5.8006433E-05
     +,   5.9916492E-05,   6.1843413E-05,   6.3778913E-05
     +,   6.5714543E-05,   6.7640765E-05,   6.9547757E-05
     +,   7.1425238E-05,   7.3262308E-05,   7.5048236E-05
     +,   7.6771692E-05,   7.8421588E-05,   7.9986858E-05
     +,   8.1456623E-05,   8.2820465E-05,   8.4068226E-05
     +,   8.5190710E-05,   8.6179134E-05,   8.7025779E-05
     +,   8.7723805E-05,   8.8267421E-05,   8.8652137E-05
     +,   8.8874454E-05,   8.8932291E-05,   8.8824840E-05
     +,   8.8552544E-05,   8.8117245E-05,   8.7522072E-05
     +,   8.6771230E-05,   8.5870357E-05,   8.4826039E-05
     +,   8.3645922E-05,   8.2338571E-05,   8.0913320E-05
     +,   7.9380407E-05,   7.7750447E-05,   7.6034630E-05
     +,   7.4244475E-05,   7.2391791E-05,   7.0488823E-05
     +,   6.8547561E-05,   6.6580513E-05,   6.4600084E-05
     +,   6.2618943E-05,   6.0649887E-05,   5.8706017E-05
     +,   5.6801196E-05,   5.4949367E-05,   5.3165855E-05
     +,   5.1466817E-05,   4.9869835E-05,   4.8394406E-05
     +,   4.7061712E-05,   4.5895751E-05,   4.4922916E-05
     +,   4.4172906E-05,   4.3678694E-05,   4.3476757E-05
     +,   4.3607259E-05,   4.4114116E-05,   4.5044646E-05
     +,   4.6449342E-05,   4.8381393E-05,   5.0895342E-05
     +,   5.4046992E-05,   5.7890629E-05,   6.2478430E-05
     +,   6.7858142E-05,   7.4069721E-05,   8.1145430E-05
     +,   8.9103822E-05,   9.7949807E-05,   1.0767089E-04
     +,   1.1823513E-04,   1.2958984E-04,   1.4165811E-04
     +,   1.5434364E-04,   1.6752466E-04,   1.8106113E-04
     +,   1.9479505E-04,   2.0855507E-04,   2.2216211E-04
     +,   2.3543272E-04,   2.4819086E-04,   2.6026834E-04
     +,   2.7151604E-04,   2.8180829E-04,   2.9104744E-04
     +,   2.9916904E-04,   3.0614185E-04,   3.1197153E-04
     +,   3.1669569E-04,   3.2038405E-04,   3.2313238E-04
     +,   3.2505789E-04,   3.2629297E-04,   3.2697860E-04
     +,   3.2725863E-04,   3.2727388E-04,   3.2715744E-04
     +,   3.2703052E-04,   3.2699967E-04,   3.2715502E-04
     +,   3.2756964E-04,   3.2829907E-04,   3.2938304E-04
     +,   3.3084562E-04,   3.3269802E-04,   3.3493905E-04
     +,   3.3755874E-04,   3.4053862E-04,   3.4385422E-04
     +,   3.4747703E-04,   3.5137369E-04,   3.5550911E-04
     +,   3.5984401E-04,   3.6433671E-04,   3.6894178E-04
     +,   3.7360901E-04,   3.7828356E-04,   3.8290504E-04
     +,   3.8740807E-04,   3.9172330E-04,   3.9577860E-04
     +,   3.9950214E-04,   4.0282469E-04,   4.0568342E-04
     +,   4.0802386E-04,   4.0980327E-04,   4.1099032E-04
     +,   4.1156498E-04,   4.1151734E-04,   4.1084230E-04
     +,   4.0953659E-04,   4.0759248E-04,   4.0499345E-04
     +,   4.0170932E-04,   3.9769523E-04,   3.9288943E-04
     +,   3.8721779E-04,   3.8059693E-04,   3.7294094E-04
     +,   3.6417201E-04,   3.5422502E-04,   3.4306134E-04
     +,   3.3067100E-04,   3.1708341E-04,   3.0236843E-04
     +,   2.8663370E-04,   2.7002697E-04,   2.5272759E-04
     +,   2.3494246E-04,   2.1689327E-04,   1.9880969E-04
     +,   1.8091900E-04,   1.6343642E-04,   1.4655986E-04
     +,   1.3045954E-04,   1.1527636E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wano_ww = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wano_zz(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  2.5855422E-06,   2.7206443E-06
     +,   2.8599595E-06,   3.0034150E-06,   3.1509280E-06
     +,   3.3024014E-06,   3.4577124E-06,   3.6167298E-06
     +,   3.7793059E-06,   3.9452657E-06,   4.1144244E-06
     +,   4.2865859E-06,   4.4615213E-06,   4.6389964E-06
     +,   4.8187603E-06,   5.0005383E-06,   5.1840452E-06
     +,   5.3689841E-06,   5.5550304E-06,   5.7418588E-06
     +,   5.9291278E-06,   6.1164842E-06,   6.3035554E-06
     +,   6.4899732E-06,   6.6753482E-06,   6.8592904E-06
     +,   7.0414062E-06,   7.2212970E-06,   7.3985484E-06
     +,   7.5727717E-06,   7.7435488E-06,   7.9104848E-06
     +,   8.0731825E-06,   8.2312581E-06,   8.3843206E-06
     +,   8.5320016E-06,   8.6739437E-06,   8.8097968E-06
     +,   8.9392352E-06,   9.0619487E-06,   9.1776456E-06
     +,   9.2860610E-06,   9.3869467E-06,   9.4800835E-06
     +,   9.5652922E-06,   9.6424083E-06,   9.7113079E-06
     +,   9.7718976E-06,   9.8241262E-06,   9.8679693E-06
     +,   9.9034551E-06,   9.9306380E-06,   9.9496283E-06
     +,   9.9605786E-06,   9.9636745E-06,   9.9591653E-06
     +,   9.9473355E-06,   9.9285244E-06,   9.9031213E-06
     +,   9.8715682E-06,   9.8343507E-06,   9.7920183E-06
     +,   9.7451739E-06,   9.6944686E-06,   9.6406202E-06
     +,   9.5843970E-06,   9.5266259E-06,   9.4682036E-06
     +,   9.4100869E-06,   9.3532899E-06,   9.2989012E-06
     +,   9.2480868E-06,   9.2020628E-06,   9.1621514E-06
     +,   9.1297306E-06,   9.1062730E-06,   9.0933263E-06
     +,   9.0925414E-06,   9.1056436E-06,   9.1344664E-06
     +,   9.1809316E-06,   9.2470527E-06,   9.3349508E-06
     +,   9.4468187E-06,   9.5849618E-06,   9.7517441E-06
     +,   9.9496065E-06,   1.0181068E-05,   1.0448678E-05
     +,   1.0755030E-05,   1.1102708E-05,   1.1494307E-05
     +,   1.1932376E-05,   1.2419429E-05,   1.2957888E-05
     +,   1.3550069E-05,   1.4198197E-05,   1.4904308E-05
     +,   1.5670339E-05,   1.6498127E-05,   1.7389319E-05
     +,   1.8345609E-05,   1.9368517E-05,   2.0459742E-05
     +,   2.1621132E-05,   2.2854838E-05,   2.4163510E-05
     +,   2.5550245E-05,   2.7019358E-05,   2.8575838E-05
     +,   3.0226147E-05,   3.1978154E-05,   3.3841392E-05
     +,   3.5827226E-05,   3.7948645E-05,   4.0221028E-05
     +,   4.2661224E-05,   4.5288307E-05,   4.8123107E-05
     +,   5.1188475E-05,   5.4509270E-05,   5.8112331E-05
     +,   6.2027488E-05,   6.6287736E-05,   7.0930044E-05
     +,   7.5996257E-05,   8.1534374E-05,   8.7598208E-05
     +,   9.4248629E-05,   1.0155259E-04,   1.0958115E-04
     +,   1.1840665E-04,   1.2809863E-04,   1.3871632E-04
     +,   1.5030362E-04,   1.6288026E-04,   1.7643445E-04
     +,   1.9091730E-04,   2.0623844E-04,   2.2226661E-04
     +,   2.3883089E-04,   2.5573128E-04,   2.7274905E-04
     +,   2.8966059E-04,   3.0625521E-04,   3.2234483E-04
     +,   3.3778566E-04,   3.5247664E-04,   3.6636853E-04
     +,   3.7946025E-04,   3.9178913E-04,   4.0342435E-04
     +,   4.1445208E-04,   4.2496569E-04,   4.3505797E-04
     +,   4.4481561E-04,   4.5431656E-04,   4.6363016E-04
     +,   4.7282196E-04,   4.8195012E-04,   4.9106829E-04
     +,   5.0022686E-04,   5.0947000E-04,   5.1885017E-04
     +,   5.2843516E-04,   5.3834927E-04,   5.4881145E-04
     +,   5.6020054E-04,   5.7312369E-04,   5.8847881E-04
     +,   6.0749915E-04,   6.3174323E-04,   6.6300906E-04
     +,   7.0314365E-04,   7.5373036E-04,   8.1567932E-04
     +,   8.8875898E-04,   9.7121450E-04,   1.0595627E-03
     +,   1.1486940E-03,   1.2323249E-03,   1.3037424E-03
     +,   1.3568656E-03,   1.3874008E-03,   1.3940999E-03
     +,   1.3798194E-03,   1.3520246E-03,   1.3222266E-03
     +,   1.3040386E-03,   1.3100647E-03,   1.3484928E-03
     +,   1.4208038E-03,   1.5215626E-03,   1.6404304E-03
     +,   1.7654046E-03,   1.8856719E-03,   1.9933018E-03
     +,   2.0836093E-03,   2.1552059E-03,   2.2102681E-03
     +,   2.2546006E-03,   2.2965691E-03,   2.3440658E-03
     +,   2.4007277E-03,   2.4639440E-03,   2.5265708E-03
     +,   2.5813042E-03,   2.6240570E-03,   2.6534144E-03
     +,   2.6672562E-03,   2.6606170E-03,   2.6280198E-03
     +,   2.5687267E-03,   2.4903510E-03,   2.4075292E-03
     +,   2.3365626E-03,   2.2892987E-03,   2.2690902E-03
     +,   2.2692189E-03,   2.2742816E-03,   2.2642359E-03
     +,   2.2206013E-03,   2.1325320E-03,   2.0002006E-03
     +,   1.8340497E-03,   1.6505062E-03,   1.4666598E-03
     +,   1.2958347E-03,   1.1456265E-03,   1.0181838E-03
     +,   9.1186911E-04,   8.2323520E-04,   7.4852601E-04
     +,   6.8458478E-04,   6.2907534E-04,   5.8038725E-04
     +,   5.3737755E-04,   4.9914280E-04,   4.6488276E-04
     +,   4.3385927E-04,   4.0542753E-04,   3.7908132E-04
     +,   3.5447534E-04,   3.3142467E-04,   3.0986196E-04
     +,   2.8980424E-04,   2.7130023E-04,   2.5439449E-04
     +,   2.3910715E-04,   2.2541301E-04,   2.1324673E-04
     +,   2.0249934E-04,   1.9303402E-04,   1.8469532E-04
     +,   1.7731929E-04,   1.7074807E-04,   1.6483336E-04
     +,   1.5944488E-04,   1.5446944E-04,   1.4981210E-04
     +,   1.4539459E-04,   1.4115142E-04,   1.3702961E-04
     +,   1.3298490E-04,   1.2898097E-04,   1.2498861E-04
     +,   1.2098460E-04,   1.1695243E-04,   1.1288125E-04
     +,   1.0876612E-04,   1.0460807E-04,   1.0041321E-04
     +,   9.6192998E-05,   9.1961869E-05,   8.7738612E-05
     +,   8.3542611E-05,   7.9395635E-05,   7.5318771E-05
     +,   7.1332193E-05,   6.7455061E-05,   6.3703192E-05
     +,   6.0090653E-05,   5.6627869E-05,   5.3322277E-05
     +,   5.0178547E-05,   4.7197740E-05,   4.4379140E-05
     +,   4.1718933E-05,   3.9212100E-05,   3.6852085E-05
     +,   3.4630899E-05,   3.2540374E-05,   3.0571777E-05
     +,   2.8716717E-05,   2.6966825E-05,   2.5314264E-05
     +,   2.3751785E-05,   2.2272756E-05,   2.0871434E-05
     +,   1.9542609E-05,   1.8281786E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wano_zz = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wao_fus_100(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  5.7605201E-09,   6.6272263E-09
     +,   7.6149700E-09,   8.7391285E-09,   1.0016899E-08
     +,   1.1467399E-08,   1.3111750E-08,   1.4973446E-08
     +,   1.7078500E-08,   1.9455506E-08,   2.2136094E-08
     +,   2.5155144E-08,   2.8550755E-08,   3.2364941E-08
     +,   3.6643723E-08,   4.1437158E-08,   4.6800139E-08
     +,   5.2792483E-08,   5.9478950E-08,   6.6930092E-08
     +,   7.5222374E-08,   8.4438653E-08,   9.4667755E-08
     +,   1.0600628E-07,   1.1855725E-07,   1.3243196E-07
     +,   1.4774936E-07,   1.6463706E-07,   1.8323034E-07
     +,   2.0367455E-07,   2.2612251E-07,   2.5073791E-07
     +,   2.7769320E-07,   3.0717126E-07,   3.3936291E-07
     +,   3.7447063E-07,   4.1270687E-07,   4.5429155E-07
     +,   4.9945641E-07,   5.4844287E-07,   6.0149881E-07
     +,   6.5888435E-07,   7.2086408E-07,   7.8771370E-07
     +,   8.5971442E-07,   9.3715568E-07,   1.0203277E-06
     +,   1.1095294E-06,   1.2050640E-06,   1.3072309E-06
     +,   1.4163354E-06,   1.5326832E-06,   1.6565706E-06
     +,   1.7882999E-06,   1.9281565E-06,   2.0764267E-06
     +,   2.2333845E-06,   2.3992909E-06,   2.5743986E-06
     +,   2.7589313E-06,   2.9531097E-06,   3.1571192E-06
     +,   3.3711306E-06,   3.5952917E-06,   3.8297080E-06
     +,   4.0744681E-06,   4.3296263E-06,   4.5951883E-06
     +,   4.8711354E-06,   5.1574057E-06,   5.4538937E-06
     +,   5.7604493E-06,   6.0768907E-06,   6.4029505E-06
     +,   6.7383507E-06,   7.0827487E-06,   7.4357536E-06
     +,   7.7969362E-06,   8.1657727E-06,   8.5417305E-06
     +,   8.9242076E-06,   9.3125573E-06,   9.7060911E-06
     +,   1.0104018E-05,   1.0505599E-05,   1.0909947E-05
     +,   1.1316194E-05,   1.1723412E-05,   1.2130642E-05
     +,   1.2536901E-05,   1.2941133E-05,   1.3342298E-05
     +,   1.3739325E-05,   1.4131122E-05,   1.4516584E-05
     +,   1.4894601E-05,   1.5264073E-05,   1.5623864E-05
     +,   1.5972884E-05,   1.6310052E-05,   1.6634294E-05
     +,   1.6944588E-05,   1.7239900E-05,   1.7519267E-05
     +,   1.7781764E-05,   1.8026509E-05,   1.8252680E-05
     +,   1.8459485E-05,   1.8646244E-05,   1.8812299E-05
     +,   1.8957086E-05,   1.9080106E-05,   1.9180950E-05
     +,   1.9259282E-05,   1.9314841E-05,   1.9347473E-05
     +,   1.9357089E-05,   1.9343710E-05,   1.9307423E-05
     +,   1.9248426E-05,   1.9166988E-05,   1.9063486E-05
     +,   1.8938366E-05,   1.8792172E-05,   1.8625529E-05
     +,   1.8439147E-05,   1.8233795E-05,   1.8010358E-05
     +,   1.7769760E-05,   1.7513010E-05,   1.7241178E-05
     +,   1.6955393E-05,   1.6656839E-05,   1.6346779E-05
     +,   1.6026495E-05,   1.5697329E-05,   1.5360652E-05
     +,   1.5017881E-05,   1.4670466E-05,   1.4319860E-05
     +,   1.3967597E-05,   1.3615178E-05,   1.3264148E-05
     +,   1.2916058E-05,   1.2572472E-05,   1.2235015E-05
     +,   1.1905239E-05,   1.1584808E-05,   1.1275349E-05
     +,   1.0978526E-05,   1.0696074E-05,   1.0429701E-05
     +,   1.0181237E-05,   9.9525460E-06,   9.7455732E-06
     +,   9.5623791E-06,   9.4051375E-06,   9.2761929E-06
     +,   9.1780303E-06,   9.1133716E-06,   9.0851590E-06
     +,   9.0966059E-06,   9.1512265E-06,   9.2528853E-06
     +,   9.4057941E-06,   9.6145804E-06,   9.8842902E-06
     +,   1.0220420E-05,   1.0628941E-05,   1.1116218E-05
     +,   1.1689205E-05,   1.2355150E-05,   1.3121787E-05
     +,   1.3997175E-05,   1.4989651E-05,   1.6107777E-05
     +,   1.7360057E-05,   1.8755054E-05,   2.0301082E-05
     +,   2.2006052E-05,   2.3877385E-05,   2.5921428E-05
     +,   2.8144097E-05,   3.0549592E-05,   3.3141125E-05
     +,   3.5920366E-05,   3.8887472E-05,   4.2041280E-05
     +,   4.5378776E-05,   4.8896862E-05,   5.2591084E-05
     +,   5.6457899E-05,   6.0495291E-05,   6.4703687E-05
     +,   6.9089583E-05,   7.3665593E-05,   7.8455945E-05
     +,   8.3497405E-05,   8.8843837E-05,   9.4571384E-05
     +,   1.0077916E-04,   1.0759627E-04,   1.1518098E-04
     +,   1.2372484E-04,   1.3345214E-04,   1.4461686E-04
     +,   1.5750497E-04,   1.7242624E-04,   1.8971830E-04
     +,   2.0975003E-04,   2.3293060E-04,   2.5974418E-04
     +,   2.9077835E-04,   3.2678855E-04,   3.6875682E-04
     +,   4.1794879E-04,   4.7594457E-04,   5.4460356E-04
     +,   6.2600174E-04,   7.2225143E-04,   8.3538058E-04
     +,   9.6726528E-04,   1.1197943E-03,   1.2953405E-03
     +,   1.4974336E-03,   1.7315162E-03,   2.0050579E-03
     +,   2.3272866E-03,   2.7088423E-03,   3.1626525E-03
     +,   3.7057493E-03,   4.3581575E-03,   5.1341695E-03
     +,   6.0266247E-03,   7.0011285E-03,   8.0175120E-03
     +,   9.0678483E-03,   1.0175235E-02,   1.1311713E-02
     +,   1.2309132E-02,   1.2933748E-02,   1.3167741E-02
     +,   1.3420172E-02,   1.4296128E-02,   1.5995611E-02
     +,   1.7983587E-02,   1.9422632E-02,   1.9920569E-02
     +,   1.9733949E-02,   1.9355947E-02,   1.9099206E-02
     +,   1.8968735E-02,   1.8711343E-02,   1.8021218E-02
     +,   1.6882749E-02,   1.5666142E-02,   1.4733218E-02
     +,   1.4067727E-02,   1.3431446E-02,   1.2723576E-02
     +,   1.2029080E-02,   1.1434231E-02,   1.0939424E-02
     +,   1.0502934E-02,   1.0077155E-02,   9.6066371E-03
     +,   9.0409229E-03,   8.3695846E-03,   7.6379366E-03
     +,   6.9236727E-03,   6.2975059E-03,   5.7977806E-03
     +,   5.4266462E-03,   5.1581045E-03,   4.9499255E-03
     +,   4.7559892E-03,   4.5384970E-03,   4.2766896E-03
     +,   3.9694938E-03,   3.6316102E-03,   3.2852557E-03
     +,   2.9517987E-03,   2.6457512E-03,   2.3729608E-03
     +,   2.1322004E-03,   1.9183554E-03,   1.7257392E-03
     +,   1.5499180E-03,   1.3883531E-03,   1.2399091E-03
     +,   1.1040686E-03,   9.8035031E-04,   8.6799683E-04
     +,   7.6600059E-04,   6.7324628E-04,   5.8871618E-04
     +,   5.1160523E-04,   4.4135502E-04,   3.7762497E-04
     +,   3.2020384E-04,   2.6893921E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wao_fus_100 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wao_fus_105(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  1.7526349E-32,   3.3893937E-32
     +,   6.5317978E-32,   1.2543358E-31,   2.4003084E-31
     +,   4.5772114E-31,   8.6977244E-31,   1.6469537E-30
     +,   3.1077172E-30,   5.8434332E-30,   1.0948877E-29
     +,   2.0443381E-29,   3.8037008E-29,   7.0523757E-29
     +,   1.3030025E-28,   2.3989959E-28,   4.4013585E-28
     +,   8.0468738E-28,   1.4660190E-27,   2.6615162E-27
     +,   4.8150163E-27,   8.6805877E-27,   1.5594527E-26
     +,   2.7917741E-26,   4.9803778E-26,   8.8537415E-26
     +,   1.5684400E-25,   2.7688251E-25,   4.8707640E-25
     +,   8.5385910E-25,   1.4915982E-24,   2.5965763E-24
     +,   4.5043559E-24,   7.7866488E-24,   1.3413753E-23
     +,   2.3026739E-23,   3.9391656E-23,   6.7151829E-23
     +,   1.1407681E-22,   1.9311978E-22,   3.2579284E-22
     +,   5.4770403E-22,   9.1756898E-22,   1.5318547E-21
     +,   2.5485202E-21,   4.2252527E-21,   6.9808308E-21
     +,   1.1493540E-20,   1.8858067E-20,   3.0833978E-20
     +,   5.0241212E-20,   8.1580849E-20,   1.3201133E-19
     +,   2.1288018E-19,   3.4210042E-19,   5.4786467E-19
     +,   8.7436455E-19,   1.3906357E-18,   2.2041572E-18
     +,   3.4815312E-18,   5.4803325E-18,   8.5969791E-18
     +,   1.3439812E-17,   2.0938762E-17,   3.2509809E-17
     +,   5.0302325E-17,   7.7567294E-17,   1.1920017E-16
     +,   1.8255312E-16,   2.7862275E-16,   4.2379893E-16
     +,   6.4242425E-16,   9.7052823E-16,   1.4611947E-15
     +,   2.1924457E-15,   3.2784734E-15,   4.8858322E-15
     +,   7.2566685E-15,   1.0741242E-14,   1.5845237E-14
     +,   2.3295544E-14,   3.4133165E-14,   4.9844491E-14
     +,   7.2540091E-14,   1.0521701E-13,   1.5209751E-13
     +,   2.1912662E-13,   3.1463357E-13,   4.5025187E-13
     +,   6.4217219E-13,   9.1281789E-13,   1.2931859E-12
     +,   1.8259224E-12,   2.5695073E-12,   3.6038440E-12
     +,   5.0376942E-12,   7.0186712E-12,   9.7459627E-12
     +,   1.3488074E-11,   1.8605064E-11,   2.5578263E-11
     +,   3.5049033E-11,   4.7867217E-11,   6.5157497E-11
     +,   8.8400877E-11,   1.1954120E-10,   1.6112160E-10
     +,   2.1644748E-10,   2.8982508E-10,   3.8680528E-10
     +,   5.1455079E-10,   6.8225470E-10,   9.0167335E-10
     +,   1.1878017E-09,   1.5596235E-09,   2.0412516E-09
     +,   2.6629596E-09,   3.4628236E-09,   4.4884536E-09
     +,   5.7991723E-09,   7.4687154E-09,   9.5880361E-09
     +,   1.2269433E-08,   1.5650672E-08,   1.9900186E-08
     +,   2.5223153E-08,   3.1868808E-08,   4.0137508E-08
     +,   5.0391698E-08,   6.3065670E-08,   7.8678163E-08
     +,   9.7846019E-08,   1.2130106E-07,   1.4990353E-07
     +,   1.8466677E-07,   2.2677513E-07,   2.7760757E-07
     +,   3.3876285E-07,   4.1208577E-07,   4.9969896E-07
     +,   6.0401851E-07,   7.2780307E-07,   8.7417169E-07
     +,   1.0466364E-06,   1.2491386E-06,   1.4860351E-06
     +,   1.7622126E-06,   2.0829816E-06,   2.4541939E-06
     +,   2.8822142E-06,   3.3738411E-06,   3.9364895E-06
     +,   4.5779025E-06,   5.3063272E-06,   6.1303622E-06
     +,   7.0589031E-06,   8.1011067E-06,   9.2660684E-06
     +,   1.0563179E-05,   1.2001361E-05,   1.3589430E-05
     +,   1.5335758E-05,   1.7247796E-05,   1.9332672E-05
     +,   2.1595992E-05,   2.4042462E-05,   2.6675352E-05
     +,   2.9496410E-05,   3.2505821E-05,   3.5701538E-05
     +,   3.9080500E-05,   4.2636890E-05,   4.6363530E-05
     +,   5.0251343E-05,   5.4289554E-05,   5.8466070E-05
     +,   6.2767140E-05,   6.7178546E-05,   7.1685405E-05
     +,   7.6272758E-05,   8.0926176E-05,   8.5631502E-05
     +,   9.0377267E-05,   9.5152827E-05,   9.9950856E-05
     +,   1.0476715E-04,   1.0960118E-04,   1.1445695E-04
     +,   1.1934240E-04,   1.2427194E-04,   1.2926423E-04
     +,   1.3434427E-04,   1.3954313E-04,   1.4489710E-04
     +,   1.5044997E-04,   1.5624989E-04,   1.6235291E-04
     +,   1.6881964E-04,   1.7571630E-04,   1.8311637E-04
     +,   1.9109645E-04,   1.9974042E-04,   2.0913448E-04
     +,   2.1937009E-04,   2.3054180E-04,   2.4274463E-04
     +,   2.5607794E-04,   2.7063844E-04,   2.8652418E-04
     +,   3.0383404E-04,   3.2266561E-04,   3.4312694E-04
     +,   3.6533270E-04,   3.8942150E-04,   4.1556606E-04
     +,   4.4398944E-04,   4.7498592E-04,   5.0893350E-04
     +,   5.4632430E-04,   5.8775919E-04,   6.3396728E-04
     +,   6.8580220E-04,   7.4424664E-04,   8.1043463E-04
     +,   8.8568503E-04,   9.7162259E-04,   1.0702620E-03
     +,   1.1841744E-03,   1.3165385E-03,   1.4710556E-03
     +,   1.6516041E-03,   1.8615645E-03,   2.1030561E-03
     +,   2.3759692E-03,   2.6774872E-03,   3.0019758E-03
     +,   3.3415267E-03,   3.6870022E-03,   4.0294495E-03
     +,   4.3620975E-03,   4.6828720E-03,   4.9973857E-03
     +,   5.3211707E-03,   5.6789718E-03,   6.0998751E-03
     +,   6.6081798E-03,   7.2129411E-03,   7.8985421E-03
     +,   8.6207567E-03,   9.3145706E-03,   9.9143675E-03
     +,   1.0378368E-02,   1.0700188E-02,   1.0904825E-02
     +,   1.1043509E-02,   1.1201688E-02,   1.1503437E-02
     +,   1.2070709E-02,   1.2934036E-02,   1.3973190E-02
     +,   1.4978535E-02,   1.5812514E-02,   1.6541431E-02
     +,   1.7410962E-02,   1.8637141E-02,   2.0201528E-02
     +,   2.1875471E-02,   2.3341661E-02,   2.4312034E-02
     +,   2.4826556E-02,   2.5342984E-02,   2.6141617E-02
     +,   2.6847934E-02,   2.6925551E-02,   2.6326362E-02
     +,   2.5378926E-02,   2.4360767E-02,   2.3231773E-02
     +,   2.1732610E-02,   1.9806251E-02,   1.7725838E-02
     +,   1.5840467E-02,   1.4361169E-02,   1.3280796E-02
     +,   1.2398590E-02,   1.1468916E-02,   1.0359503E-02
     +,   9.0873158E-03,   7.7535831E-03,   6.4671729E-03
     +,   5.3036660E-03,   4.2978362E-03,   3.4522442E-03
     +,   2.7518189E-03,   2.1761917E-03,   1.7067703E-03
     +,   1.3281190E-03,   1.0267096E-03,   7.8974396E-04
     +,   6.0498249E-04,   4.6142979E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wao_fus_105 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wao_fus_107(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  1.4445696E-20,   2.0370067E-20
     +,   2.8674723E-20,   4.0294785E-20,   5.6526188E-20
     +,   7.9158949E-20,   1.1066150E-19,   1.5443329E-19
     +,   2.1514761E-19,   2.9921149E-19,   4.1540214E-19
     +,   5.7571755E-19,   7.9652116E-19,   1.1000980E-18
     +,   1.5167646E-18,   2.0876151E-18,   2.8683391E-18
     +,   3.9342484E-18,   5.3869046E-18,   7.3631507E-18
     +,   1.0047049E-17,   1.3685544E-17,   1.8609445E-17
     +,   2.5261265E-17,   3.4231205E-17,   4.6306166E-17
     +,   6.2532128E-17,   8.4298148E-17,   1.1344333E-16
     +,   1.5240218E-16,   2.0438485E-16,   2.7362449E-16
     +,   3.6568657E-16,   4.8788145E-16,   6.4977914E-16
     +,   8.6390648E-16,   1.1466119E-15,   1.5191935E-15
     +,   2.0093633E-15,   2.6530984E-15,   3.4969971E-15
     +,   4.6013828E-15,   6.0440341E-15,   7.9252689E-15
     +,   1.0374066E-14,   1.3556114E-14,   1.7683441E-14
     +,   2.3027556E-14,   2.9935005E-14,   3.8846883E-14
     +,   5.0324755E-14,   6.5081621E-14,   8.4019732E-14
     +,   1.0828138E-13,   1.3930712E-13,   1.7891249E-13
     +,   2.2938110E-13,   2.9357728E-13,   3.7509183E-13
     +,   4.7840876E-13,   6.0913140E-13,   7.7422834E-13
     +,   9.8237390E-13,   1.2443259E-12,   1.5733951E-12
     +,   1.9860500E-12,   2.5026094E-12,   3.1480550E-12
     +,   3.9531204E-12,   4.9554948E-12,   6.2012917E-12
     +,   7.7468761E-12,   9.6610107E-12,   1.2027183E-11
     +,   1.4947009E-11,   1.8543594E-11,   2.2965813E-11
     +,   2.8393706E-11,   3.5043576E-11,   4.3176136E-11
     +,   5.3104184E-11,   6.5202330E-11,   7.9918974E-11
     +,   9.7786862E-11,   1.1944480E-10,   1.4564684E-10
     +,   1.7729039E-10,   2.1543704E-10,   2.6134025E-10
     +,   3.1648009E-10,   3.8259143E-10,   4.6171761E-10
     +,   5.5625005E-10,   6.6898559E-10,   8.0318835E-10
     +,   9.6265784E-10,   1.1518213E-09,   1.3757856E-09
     +,   1.6404894E-09,   1.9527822E-09,   2.3205604E-09
     +,   2.7529272E-09,   3.2602838E-09,   3.8545975E-09
     +,   4.5495350E-09,   5.3606946E-09,   6.3058847E-09
     +,   7.4051876E-09,   8.6816829E-09,   1.0161180E-08
     +,   1.1873058E-08,   1.3850377E-08,   1.6130402E-08
     +,   1.8755079E-08,   2.1771047E-08,   2.5231349E-08
     +,   2.9194410E-08,   3.3725918E-08,   3.8898989E-08
     +,   4.4794906E-08,   5.1504323E-08,   5.9126823E-08
     +,   6.7773591E-08,   7.7567357E-08,   8.8643667E-08
     +,   1.0115202E-07,   1.1525784E-07,   1.3114149E-07
     +,   1.4900303E-07,   1.6906171E-07,   1.9155819E-07
     +,   2.1675665E-07,   2.4494756E-07,   2.7644589E-07
     +,   3.1159971E-07,   3.5078855E-07,   3.9442745E-07
     +,   4.4297008E-07,   4.9691141E-07,   5.5679391E-07
     +,   6.2320225E-07,   6.9677975E-07,   7.7822529E-07
     +,   8.6829789E-07,   9.6782628E-07,   1.0776942E-06
     +,   1.1988870E-06,   1.3324417E-06,   1.4794953E-06
     +,   1.6412756E-06,   1.8190792E-06,   2.0143443E-06
     +,   2.2285637E-06,   2.4633628E-06,   2.7204640E-06
     +,   3.0017034E-06,   3.3090384E-06,   3.6444901E-06
     +,   4.0102786E-06,   4.4086441E-06,   4.8419947E-06
     +,   5.3128456E-06,   5.8237483E-06,   6.3774896E-06
     +,   6.9768175E-06,   7.6246611E-06,   8.3240220E-06
     +,   9.0779986E-06,   9.8898163E-06,   1.0762664E-05
     +,   1.1700058E-05,   1.2705384E-05,   1.3782267E-05
     +,   1.4934419E-05,   1.6165670E-05,   1.7480035E-05
     +,   1.8881516E-05,   2.0374408E-05,   2.1963100E-05
     +,   2.3652130E-05,   2.5446225E-05,   2.7349941E-05
     +,   2.9368412E-05,   3.1506264E-05,   3.3768385E-05
     +,   3.6159447E-05,   3.8683898E-05,   4.1345960E-05
     +,   4.4148954E-05,   4.7096397E-05,   5.0190374E-05
     +,   5.3432686E-05,   5.6824400E-05,   6.0365488E-05
     +,   6.4056359E-05,   6.7896406E-05,   7.1886730E-05
     +,   7.6029151E-05,   8.0328202E-05,   8.4793915E-05
     +,   8.9441623E-05,   9.4297218E-05,   9.9397716E-05
     +,   1.0479677E-04,   1.1056785E-04,   1.1680765E-04
     +,   1.2364262E-04,   1.3122959E-04,   1.3976199E-04
     +,   1.4947134E-04,   1.6062733E-04,   1.7354259E-04
     +,   1.8856616E-04,   2.0608702E-04,   2.2652924E-04
     +,   2.5034978E-04,   2.7803512E-04,   3.1008976E-04
     +,   3.4703911E-04,   3.8939767E-04,   4.3766227E-04
     +,   4.9228169E-04,   5.5363303E-04,   6.2202022E-04
     +,   6.9769460E-04,   7.8099465E-04,   8.7252492E-04
     +,   9.7352092E-04,   1.0862642E-03,   1.2144771E-03
     +,   1.3635271E-03,   1.5401965E-03,   1.7520523E-03
     +,   2.0062593E-03,   2.3084707E-03,   2.6618119E-03
     +,   3.0661542E-03,   3.5172191E-03,   4.0048673E-03
     +,   4.5110746E-03,   5.0087781E-03,   5.4643992E-03
     +,   5.8455896E-03,   6.1326870E-03,   6.3295364E-03
     +,   6.4672786E-03,   6.5976628E-03,   6.7754285E-03
     +,   7.0350803E-03,   7.3722028E-03,   7.7409316E-03
     +,   8.0737378E-03,   8.3153425E-03,   8.4523745E-03
     +,   8.5215317E-03,   8.5931914E-03,   8.7413434E-03
     +,   9.0154195E-03,   9.4280737E-03,   9.9659087E-03
     +,   1.0613691E-02,   1.1362721E-02,   1.2178464E-02
     +,   1.2956988E-02,   1.3539479E-02,   1.3804465E-02
     +,   1.3752568E-02,   1.3496596E-02,   1.3200197E-02
     +,   1.3078765E-02,   1.3442914E-02,   1.4601887E-02
     +,   1.6586108E-02,   1.9004600E-02,   2.1298455E-02
     +,   2.3109417E-02,   2.4342094E-02,   2.5024185E-02
     +,   2.5223175E-02,   2.5060007E-02,   2.4798324E-02
     +,   2.4770191E-02,   2.4980925E-02,   2.4902463E-02
     +,   2.3923941E-02,   2.1988209E-02,   1.9608859E-02
     +,   1.7313441E-02,   1.5264367E-02,   1.3368185E-02
     +,   1.1534875E-02,   9.7710872E-03,   8.1263250E-03
     +,   6.6337241E-03,   5.3029740E-03,   4.1391118E-03
     +,   3.1494943E-03,   2.3367316E-03,   1.6922902E-03
     +,   1.1973508E-03,   8.2820817E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wao_fus_107 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wao_fus_110(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  5.0855056E-13,   6.0622926E-13
     +,   7.2199836E-13,   8.5906889E-13,   1.0212081E-12
     +,   1.2128199E-12,   1.4390345E-12,   1.7058477E-12
     +,   2.0202499E-12,   2.3903568E-12,   2.8256273E-12
     +,   3.3370479E-12,   3.9373426E-12,   4.6412795E-12
     +,   5.4659849E-12,   6.4311993E-12,   7.5597957E-12
     +,   8.8781699E-12,   1.0416690E-11,   1.2210419E-11
     +,   1.4299665E-11,   1.6730796E-11,   1.9556905E-11
     +,   2.2839125E-11,   2.6647204E-11,   3.1061209E-11
     +,   3.6172551E-11,   4.2085817E-11,   4.8919906E-11
     +,   5.6810789E-11,   6.5912609E-11,   7.6401364E-11
     +,   8.8476483E-11,   1.0236473E-10,   1.1832205E-10
     +,   1.3663916E-10,   1.5764523E-10,   1.8171005E-10
     +,   2.0925296E-10,   2.4074653E-10,   2.7672054E-10
     +,   3.1777378E-10,   3.6457601E-10,   4.1788056E-10
     +,   4.7853183E-10,   5.4747634E-10,   6.2576649E-10
     +,   7.1458550E-10,   8.1525064E-10,   9.2922603E-10
     +,   1.0581485E-09,   1.2038335E-09,   1.3682963E-09
     +,   1.5537790E-09,   1.7627539E-09,   1.9979676E-09
     +,   2.2624524E-09,   2.5595615E-09,   2.8929878E-09
     +,   3.2667915E-09,   3.6854610E-09,   4.1538999E-09
     +,   4.6775104E-09,   5.2622213E-09,   5.9144907E-09
     +,   6.6414083E-09,   7.4507387E-09,   8.3508818E-09
     +,   9.3510497E-09,   1.0461248E-08,   1.1692358E-08
     +,   1.3056179E-08,   1.4565576E-08,   1.6234285E-08
     +,   1.8077333E-08,   2.0110923E-08,   2.2352499E-08
     +,   2.4820952E-08,   2.7536331E-08,   3.0520461E-08
     +,   3.3796656E-08,   3.7389906E-08,   4.1327155E-08
     +,   4.5636487E-08,   5.0349112E-08,   5.5497097E-08
     +,   6.1115223E-08,   6.7240400E-08,   7.3911821E-08
     +,   8.1171251E-08,   8.9062247E-08,   9.7631634E-08
     +,   1.0692871E-07,   1.1700548E-07,   1.2791685E-07
     +,   1.3972063E-07,   1.5247814E-07,   1.6625245E-07
     +,   1.8111128E-07,   1.9712517E-07,   2.1436817E-07
     +,   2.3291855E-07,   2.5285624E-07,   2.7426682E-07
     +,   2.9723958E-07,   3.2186719E-07,   3.4824851E-07
     +,   3.7648201E-07,   4.0667848E-07,   4.3894599E-07
     +,   4.7340188E-07,   5.1016804E-07,   5.4937232E-07
     +,   5.9114996E-07,   6.3563624E-07,   6.8298482E-07
     +,   7.3334485E-07,   7.8688072E-07,   8.4376353E-07
     +,   9.0417313E-07,   9.6830240E-07,   1.0363469E-06
     +,   1.1085215E-06,   1.1850508E-06,   1.2661732E-06
     +,   1.3521401E-06,   1.4432231E-06,   1.5397005E-06
     +,   1.6418766E-06,   1.7500723E-06,   1.8646283E-06
     +,   1.9859065E-06,   2.1142955E-06,   2.2501938E-06
     +,   2.3940365E-06,   2.5462823E-06,   2.7074127E-06
     +,   2.8779396E-06,   3.0583988E-06,   3.2493635E-06
     +,   3.4514121E-06,   3.6651713E-06,   3.8912895E-06
     +,   4.1304370E-06,   4.3833238E-06,   4.6506402E-06
     +,   4.9331688E-06,   5.2316377E-06,   5.5468349E-06
     +,   5.8795576E-06,   6.2305653E-06,   6.6007083E-06
     +,   6.9907437E-06,   7.4014742E-06,   7.8336807E-06
     +,   8.2881197E-06,   8.7655490E-06,   9.2666151E-06
     +,   9.7920656E-06,   1.0342463E-05,   1.0918407E-05
     +,   1.1520442E-05,   1.2148962E-05,   1.2804463E-05
     +,   1.3487209E-05,   1.4197489E-05,   1.4935505E-05
     +,   1.5701386E-05,   1.6495236E-05,   1.7316976E-05
     +,   1.8166676E-05,   1.9044168E-05,   1.9949353E-05
     +,   2.0882098E-05,   2.1842256E-05,   2.2829734E-05
     +,   2.3844344E-05,   2.4886069E-05,   2.5954927E-05
     +,   2.7051019E-05,   2.8174605E-05,   2.9325902E-05
     +,   3.0505613E-05,   3.1714291E-05,   3.2952925E-05
     +,   3.4222663E-05,   3.5524994E-05,   3.6861773E-05
     +,   3.8235085E-05,   3.9647875E-05,   4.1103343E-05
     +,   4.2605701E-05,   4.4160097E-05,   4.5772733E-05
     +,   4.7451758E-05,   4.9206832E-05,   5.1050629E-05
     +,   5.2998636E-05,   5.5070304E-05,   5.7290621E-05
     +,   5.9690359E-05,   6.2308944E-05,   6.5195272E-05
     +,   6.8411216E-05,   7.2034389E-05,   7.6161210E-05
     +,   8.0912825E-05,   8.6437765E-05,   9.2918781E-05
     +,   1.0057745E-04,   1.0967712E-04,   1.2052950E-04
     +,   1.3349055E-04,   1.4896212E-04,   1.6738370E-04
     +,   1.8922247E-04,   2.1496133E-04,   2.4507931E-04
     +,   2.8005365E-04,   3.2034391E-04,   3.6642441E-04
     +,   4.1882604E-04,   4.7821988E-04,   5.4553989E-04
     +,   6.2211050E-04,   7.0981262E-04,   8.1112364E-04
     +,   9.2911109E-04,   1.0672116E-03,   1.2288312E-03
     +,   1.4168096E-03,   1.6328058E-03,   1.8769527E-03
     +,   2.1475879E-03,   2.4415047E-03,   2.7542142E-03
     +,   3.0801159E-03,   3.4123126E-03,   3.7420571E-03
     +,   4.0585948E-03,   4.3499349E-03,   4.6052900E-03
     +,   4.8189759E-03,   4.9944925E-03,   5.1472513E-03
     +,   5.3039789E-03,   5.4983236E-03,   5.7623563E-03
     +,   6.1149937E-03,   6.5504215E-03,   7.0309546E-03
     +,   7.4914000E-03,   7.8575201E-03,   8.0755558E-03
     +,   8.1396429E-03,   8.1010908E-03,   8.0501670E-03
     +,   8.0760773E-03,   8.2260612E-03,   8.4872898E-03
     +,   8.8012349E-03,   9.0999808E-03,   9.3415771E-03
     +,   9.5276553E-03,   9.6986378E-03,   9.9119414E-03
     +,   1.0212747E-02,   1.0610167E-02,   1.1071913E-02
     +,   1.1540599E-02,   1.1960291E-02,   1.2295727E-02
     +,   1.2538236E-02,   1.2712331E-02,   1.2893077E-02
     +,   1.3207691E-02,   1.3779961E-02,   1.4642569E-02
     +,   1.5710194E-02,   1.6844532E-02,   1.7915322E-02
     +,   1.8784629E-02,   1.9317156E-02,   1.9511044E-02
     +,   1.9579567E-02,   1.9752128E-02,   1.9992737E-02
     +,   2.0095520E-02,   2.0061146E-02,   2.0118184E-02
     +,   2.0307466E-02,   2.0288602E-02,   1.9626314E-02
     +,   1.8110797E-02,   1.5812883E-02,   1.3000719E-02
     +,   1.0041422E-02,   7.2894162E-03,   4.9874336E-03
     +,   3.2281168E-03,   1.9820896E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wao_fus_110 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wao_fus_115(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  3.2328356E-07,   3.4841500E-07
     +,   3.7517208E-07,   4.0363005E-07,   4.3386669E-07
     +,   4.6596102E-07,   4.9999073E-07,   5.3603662E-07
     +,   5.7417884E-07,   6.1449629E-07,   6.5706934E-07
     +,   7.0197814E-07,   7.4929926E-07,   7.9911058E-07
     +,   8.5148895E-07,   9.0650559E-07,   9.6423275E-07
     +,   1.0247401E-06,   1.0880902E-06,   1.1543469E-06
     +,   1.2235663E-06,   1.2958037E-06,   1.3711043E-06
     +,   1.4495135E-06,   1.5310650E-06,   1.6157907E-06
     +,   1.7037142E-06,   1.7948532E-06,   1.8892127E-06
     +,   1.9867971E-06,   2.0875934E-06,   2.1915866E-06
     +,   2.2987501E-06,   2.4090489E-06,   2.5224331E-06
     +,   2.6388475E-06,   2.7582250E-06,   2.8804850E-06
     +,   3.0055376E-06,   3.1332861E-06,   3.2636117E-06
     +,   3.3963961E-06,   3.5314993E-06,   3.6687763E-06
     +,   3.8080686E-06,   3.9492111E-06,   4.0920168E-06
     +,   4.2362976E-06,   4.3818563E-06,   4.5284746E-06
     +,   4.6759351E-06,   4.8240108E-06,   4.9724576E-06
     +,   5.1210354E-06,   5.2694863E-06,   5.4175530E-06
     +,   5.5649712E-06,   5.7114694E-06,   5.8567794E-06
     +,   6.0006187E-06,   6.1427163E-06,   6.2827867E-06
     +,   6.4205547E-06,   6.5557460E-06,   6.6880825E-06
     +,   6.8172958E-06,   6.9431226E-06,   7.0653005E-06
     +,   7.1835761E-06,   7.2977118E-06,   7.4074678E-06
     +,   7.5126250E-06,   7.6129745E-06,   7.7083114E-06
     +,   7.7984560E-06,   7.8832390E-06,   7.9625079E-06
     +,   8.0361297E-06,   8.1039852E-06,   8.1659755E-06
     +,   8.2220231E-06,   8.2720699E-06,   8.3160821E-06
     +,   8.3540372E-06,   8.3859495E-06,   8.4118446E-06
     +,   8.4317735E-06,   8.4458152E-06,   8.4540670E-06
     +,   8.4566518E-06,   8.4537141E-06,   8.4454259E-06
     +,   8.4319809E-06,   8.4135945E-06,   8.3905088E-06
     +,   8.3629875E-06,   8.3313162E-06,   8.2958068E-06
     +,   8.2567913E-06,   8.2146244E-06,   8.1696835E-06
     +,   8.1223707E-06,   8.0731088E-06,   8.0223435E-06
     +,   7.9705405E-06,   7.9181928E-06,   7.8658122E-06
     +,   7.8139410E-06,   7.7631357E-06,   7.7139903E-06
     +,   7.6671149E-06,   7.6231540E-06,   7.5827766E-06
     +,   7.5466814E-06,   7.5156063E-06,   7.4903137E-06
     +,   7.4716072E-06,   7.4603258E-06,   7.4573500E-06
     +,   7.4635986E-06,   7.4800387E-06,   7.5076769E-06
     +,   7.5475723E-06,   7.6008291E-06,   7.6686047E-06
     +,   7.7521026E-06,   7.8525882E-06,   7.9713564E-06
     +,   8.1097687E-06,   8.2692286E-06,   8.4511821E-06
     +,   8.6571172E-06,   8.8885654E-06,   9.1470602E-06
     +,   9.4341804E-06,   9.7515085E-06,   1.0100628E-05
     +,   1.0483111E-05,   1.0900500E-05,   1.1354319E-05
     +,   1.1845987E-05,   1.2376884E-05,   1.2948291E-05
     +,   1.3561365E-05,   1.4217158E-05,   1.4916449E-05
     +,   1.5660024E-05,   1.6448266E-05,   1.7281449E-05
     +,   1.8159590E-05,   1.9082296E-05,   2.0049119E-05
     +,   2.1059052E-05,   2.2110891E-05,   2.3203056E-05
     +,   2.4333600E-05,   2.5500260E-05,   2.6700211E-05
     +,   2.7930575E-05,   2.9187793E-05,   3.0468122E-05
     +,   3.1767479E-05,   3.3081258E-05,   3.4404911E-05
     +,   3.5733246E-05,   3.7061101E-05,   3.8383023E-05
     +,   3.9693452E-05,   4.0986804E-05,   4.2257292E-05
     +,   4.3499520E-05,   4.4707882E-05,   4.5877216E-05
     +,   4.7002584E-05,   4.8079473E-05,   4.9103874E-05
     +,   5.0072300E-05,   5.0982067E-05,   5.1831295E-05
     +,   5.2619023E-05,   5.3345375E-05,   5.4011551E-05
     +,   5.4620214E-05,   5.5175242E-05,   5.5682158E-05
     +,   5.6148045E-05,   5.6581681E-05,   5.6993638E-05
     +,   5.7396232E-05,   5.7803682E-05,   5.8231923E-05
     +,   5.8698635E-05,   5.9223104E-05,   5.9825958E-05
     +,   6.0529092E-05,   6.1355189E-05,   6.2327643E-05
     +,   6.3470041E-05,   6.4805899E-05,   6.6359135E-05
     +,   6.8153422E-05,   7.0213944E-05,   7.2567709E-05
     +,   7.5246673E-05,   7.8291079E-05,   8.1753758E-05
     +,   8.5708481E-05,   9.0256326E-05,   9.5537653E-05
     +,   1.0174363E-04,   1.0912812E-04,   1.1802473E-04
     +,   1.2885770E-04,   1.4216086E-04,   1.5859405E-04
     +,   1.7896506E-04,   2.0425839E-04,   2.3566591E-04
     +,   2.7464109E-04,   3.2292568E-04,   3.8259517E-04
     +,   4.5605257E-04,   5.4597639E-04,   6.5520033E-04
     +,   7.8649592E-04,   9.4238308E-04,   1.1248278E-03
     +,   1.3351470E-03,   1.5739586E-03,   1.8412820E-03
     +,   2.1366680E-03,   2.4590828E-03,   2.8066409E-03
     +,   3.1756626E-03,   3.5599354E-03,   3.9502555E-03
     +,   4.3350863E-03,   4.7023883E-03,   5.0419457E-03
     +,   5.3471932E-03,   5.6155054E-03,   5.8475384E-03
     +,   6.0470281E-03,   6.2222411E-03,   6.3885506E-03
     +,   6.5693357E-03,   6.7927232E-03,   7.0840335E-03
     +,   7.4574966E-03,   7.9116076E-03,   8.4275622E-03
     +,   8.9686103E-03,   9.4807791E-03,   9.9058719E-03
     +,   1.0211986E-02,   1.0425332E-02,   1.0632751E-02
     +,   1.0939008E-02,   1.1402882E-02,   1.1999410E-02
     +,   1.2640521E-02,   1.3238247E-02,   1.3748546E-02
     +,   1.4152582E-02,   1.4413824E-02,   1.4496807E-02
     +,   1.4438411E-02,   1.4345459E-02,   1.4280790E-02
     +,   1.4199653E-02,   1.4058360E-02,   1.3945692E-02
     +,   1.4023268E-02,   1.4334356E-02,   1.4732464E-02
     +,   1.5016934E-02,   1.5111834E-02,   1.5110507E-02
     +,   1.5169309E-02,   1.5357490E-02,   1.5585727E-02
     +,   1.5662333E-02,   1.5420690E-02,   1.4822572E-02
     +,   1.3988686E-02,   1.3138806E-02,   1.2451061E-02
     +,   1.1929926E-02,   1.1414352E-02,   1.0726208E-02
     +,   9.8083206E-03,   8.7312348E-03,   7.6032393E-03
     +,   6.4955838E-03,   5.4342966E-03,   4.4306279E-03
     +,   3.5038446E-03,   2.6812642E-03,   1.9862510E-03
     +,   1.4280874E-03,   1.0002343E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wao_fus_115 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wao_fus_120(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  1.0231027E-15,   1.2827299E-15
     +,   1.6064443E-15,   2.0095977E-15,   2.5111135E-15
     +,   3.1342881E-15,   3.9077145E-15,   4.8665511E-15
     +,   6.0539105E-15,   7.5224962E-15,   9.3368789E-15
     +,   1.1575955E-14,   1.4335900E-14,   1.7733970E-14
     +,   2.1913069E-14,   2.7046594E-14,   3.3345380E-14
     +,   4.1065153E-14,   5.0515425E-14,   6.2070954E-14
     +,   7.6184495E-14,   9.3402852E-14,   1.1438436E-13
     +,   1.3992255E-13,   1.7097040E-13,   2.0867417E-13
     +,   2.5440766E-13,   3.0981776E-13,   3.7687328E-13
     +,   4.5793079E-13,   5.5579619E-13,   6.7382309E-13
     +,   8.1599956E-13,   9.8707327E-13,   1.1926743E-12
     +,   1.4394836E-12,   1.7354350E-12,   2.0898793E-12
     +,   2.5139040E-12,   3.0205853E-12,   3.6253147E-12
     +,   4.3462634E-12,   5.2047338E-12,   6.2257881E-12
     +,   7.4388317E-12,   8.8782991E-12,   1.0584435E-11
     +,   1.2604306E-11,   1.4992915E-11,   1.7814156E-11
     +,   2.1142612E-11,   2.5064936E-11,   2.9681611E-11
     +,   3.5109363E-11,   4.1483119E-11,   4.8959111E-11
     +,   5.7717765E-11,   6.7967222E-11,   7.9947375E-11
     +,   9.3933882E-11,   1.1024397E-10,   1.2924078E-10
     +,   1.5134179E-10,   1.7702424E-10,   2.0683287E-10
     +,   2.4139046E-10,   2.8140751E-10,   3.2769015E-10
     +,   3.8115855E-10,   4.4285467E-10,   5.1396204E-10
     +,   5.9581867E-10,   6.8994416E-10,   7.9804063E-10
     +,   9.2204094E-10,   1.0641155E-09,   1.2267077E-09
     +,   1.4125702E-09,   1.6247641E-09,   1.8667423E-09
     +,   2.1423605E-09,   2.4559192E-09,   2.8122362E-09
     +,   3.2166143E-09,   3.6750587E-09,   4.1941242E-09
     +,   4.7811479E-09,   5.4442326E-09,   6.1923506E-09
     +,   7.0354171E-09,   7.9842843E-09,   9.0509875E-09
     +,   1.0248725E-08,   1.1591976E-08,   1.3096611E-08
     +,   1.4779995E-08,   1.6661163E-08,   1.8760673E-08
     +,   2.1101108E-08,   2.3706962E-08,   2.6604804E-08
     +,   2.9823614E-08,   3.3394304E-08,   3.7350670E-08
     +,   4.1729010E-08,   4.6568434E-08,   5.1911172E-08
     +,   5.7801653E-08,   6.4289083E-08,   7.1424310E-08
     +,   7.9262691E-08,   8.7862873E-08,   9.7287241E-08
     +,   1.0760231E-07,   1.1887703E-07,   1.3118718E-07
     +,   1.4460961E-07,   1.5922697E-07,   1.7512579E-07
     +,   1.9239654E-07,   2.1113480E-07,   2.3143799E-07
     +,   2.5340978E-07,   2.7715697E-07,   3.0279034E-07
     +,   3.3042451E-07,   3.6017838E-07,   3.9217096E-07
     +,   4.2652746E-07,   4.6337493E-07,   5.0284234E-07
     +,   5.4506091E-07,   5.9016469E-07,   6.3828401E-07
     +,   6.8955455E-07,   7.4410968E-07,   8.0208304E-07
     +,   8.6360529E-07,   9.2880663E-07,   9.9781528E-07
     +,   1.0707492E-06,   1.1477288E-06,   1.2288654E-06
     +,   1.3142666E-06,   1.4040334E-06,   1.4982461E-06
     +,   1.5969994E-06,   1.7003526E-06,   1.8083697E-06
     +,   1.9211011E-06,   2.0385678E-06,   2.1608057E-06
     +,   2.2878062E-06,   2.4195610E-06,   2.5560407E-06
     +,   2.6971970E-06,   2.8429706E-06,   2.9932585E-06
     +,   3.1479767E-06,   3.3069823E-06,   3.4701320E-06
     +,   3.6372630E-06,   3.8081648E-06,   3.9826491E-06
     +,   4.1604621E-06,   4.3413502E-06,   4.5250345E-06
     +,   4.7112139E-06,   4.8995730E-06,   5.0897474E-06
     +,   5.2814025E-06,   5.4741349E-06,   5.6675517E-06
     +,   5.8612391E-06,   6.0547641E-06,   6.2476875E-06
     +,   6.4395390E-06,   6.6298567E-06,   6.8181653E-06
     +,   7.0039823E-06,   7.1868299E-06,   7.3662045E-06
     +,   7.5416538E-06,   7.7126988E-06,   7.8789071E-06
     +,   8.0398868E-06,   8.1953140E-06,   8.3449877E-06
     +,   8.4888707E-06,   8.6272403E-06,   8.7607823E-06
     +,   8.8908719E-06,   9.0198882E-06,   9.1516777E-06
     +,   9.2922801E-06,   9.4507841E-06,   9.6406548E-06
     +,   9.8812970E-06,   1.0200156E-05,   1.0635430E-05
     +,   1.1239050E-05,   1.2080659E-05,   1.3251488E-05
     +,   1.4869181E-05,   1.7082415E-05,   2.0074873E-05
     +,   2.4070132E-05,   2.9332550E-05,   3.6169262E-05
     +,   4.4927878E-05,   5.5989560E-05,   6.9764217E-05
     +,   8.6671600E-05,   1.0712980E-04,   1.3153440E-04
     +,   1.6024189E-04,   1.9356048E-04,   2.3174727E-04
     +,   2.7505204E-04,   3.2375872E-04,   3.7830658E-04
     +,   4.3942680E-04,   5.0831673E-04,   5.8681186E-04
     +,   6.7748490E-04,   7.8368990E-04,   9.0936624E-04
     +,   1.0587783E-03,   1.2360977E-03,   1.4450098E-03
     +,   1.6884257E-03,   1.9682427E-03,   2.2852765E-03
     +,   2.6388161E-03,   3.0262643E-03,   3.4424942E-03
     +,   3.8792989E-03,   4.3248883E-03,   4.7636749E-03
     +,   5.1773284E-03,   5.5480008E-03,   5.8644502E-03
     +,   6.1288639E-03,   6.3595567E-03,   6.5849582E-03
     +,   6.8293344E-03,   7.0993709E-03,   7.3834499E-03
     +,   7.6680016E-03,   7.9595335E-03,   8.2896538E-03
     +,   8.6903227E-03,   9.1534397E-03,   9.6145626E-03
     +,   9.9887103E-03,   1.0238060E-02,   1.0411683E-02
     +,   1.0613296E-02,   1.0917707E-02,   1.1303679E-02
     +,   1.1659183E-02,   1.1855770E-02,   1.1834357E-02
     +,   1.1644259E-02,   1.1416813E-02,   1.1292529E-02
     +,   1.1344379E-02,   1.1553580E-02,   1.1851951E-02
     +,   1.2168539E-02,   1.2431018E-02,   1.2565931E-02
     +,   1.2542657E-02,   1.2409056E-02,   1.2256414E-02
     +,   1.2148832E-02,   1.2097541E-02,   1.2102292E-02
     +,   1.2195567E-02,   1.2417444E-02,   1.2744729E-02
     +,   1.3069662E-02,   1.3258431E-02,   1.3216499E-02
     +,   1.2898750E-02,   1.2292511E-02,   1.1430274E-02
     +,   1.0414463E-02,   9.3908217E-03,   8.4686121E-03
     +,   7.6639582E-03,   6.9168760E-03,   6.1539803E-03
     +,   5.3406875E-03,   4.4929334E-03,   3.6572865E-03
     +,   2.8830476E-03,   2.2043004E-03,   1.6359475E-03
     +,   1.1779773E-03,   8.2173775E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wao_fus_120 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wao_fus_60(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  2.4447692E-05,   2.5874273E-05
     +,   2.7355592E-05,   2.8891653E-05,   3.0482404E-05
     +,   3.2127627E-05,   3.3826866E-05,   3.5579549E-05
     +,   3.7384969E-05,   3.9242113E-05,   4.1149895E-05
     +,   4.3107040E-05,   4.5111974E-05,   4.7163037E-05
     +,   4.9258386E-05,   5.1395851E-05,   5.3573203E-05
     +,   5.5788027E-05,   5.8037571E-05,   6.0319049E-05
     +,   6.2629428E-05,   6.4965578E-05,   6.7324028E-05
     +,   6.9701346E-05,   7.2093768E-05,   7.4497497E-05
     +,   7.6908589E-05,   7.9322992E-05,   8.1736405E-05
     +,   8.4144645E-05,   8.6543194E-05,   8.8927663E-05
     +,   9.1293507E-05,   9.3636198E-05,   9.5951043E-05
     +,   9.8233446E-05,   1.0047885E-04,   1.0268256E-04
     +,   1.0484004E-04,   1.0694681E-04,   1.0899832E-04
     +,   1.1099032E-04,   1.1291839E-04,   1.1477845E-04
     +,   1.1656652E-04,   1.1827870E-04,   1.1991123E-04
     +,   1.2146062E-04,   1.2292356E-04,   1.2429690E-04
     +,   1.2557776E-04,   1.2676348E-04,   1.2785161E-04
     +,   1.2884005E-04,   1.2972688E-04,   1.3051048E-04
     +,   1.3118955E-04,   1.3176304E-04,   1.3223027E-04
     +,   1.3259072E-04,   1.3284432E-04,   1.3299120E-04
     +,   1.3303189E-04,   1.3296716E-04,   1.3279809E-04
     +,   1.3252601E-04,   1.3215268E-04,   1.3168002E-04
     +,   1.3111025E-04,   1.3044590E-04,   1.2968972E-04
     +,   1.2884474E-04,   1.2791410E-04,   1.2690137E-04
     +,   1.2581021E-04,   1.2464442E-04,   1.2340803E-04
     +,   1.2210516E-04,   1.2074023E-04,   1.1931761E-04
     +,   1.1784188E-04,   1.1631761E-04,   1.1474943E-04
     +,   1.1314226E-04,   1.1150059E-04,   1.0982936E-04
     +,   1.0813327E-04,   1.0641702E-04,   1.0468529E-04
     +,   1.0294263E-04,   1.0119370E-04,   9.9442870E-05
     +,   9.7694443E-05,   9.5952666E-05,   9.4221577E-05
     +,   9.2505114E-05,   9.0807000E-05,   8.9130910E-05
     +,   8.7480279E-05,   8.5858264E-05,   8.4267980E-05
     +,   8.2712191E-05,   8.1193692E-05,   7.9714846E-05
     +,   7.8277924E-05,   7.6884942E-05,   7.5537719E-05
     +,   7.4238000E-05,   7.2987001E-05,   7.1786097E-05
     +,   7.0636241E-05,   6.9538248E-05,   6.8492751E-05
     +,   6.7500136E-05,   6.6560729E-05,   6.5674503E-05
     +,   6.4841413E-05,   6.4061169E-05,   6.3333333E-05
     +,   6.2657331E-05,   6.2032384E-05,   6.1457671E-05
     +,   6.0932187E-05,   6.0454789E-05,   6.0024246E-05
     +,   5.9639187E-05,   5.9298178E-05,   5.8999693E-05
     +,   5.8742095E-05,   5.8523688E-05,   5.8342699E-05
     +,   5.8197318E-05,   5.8085661E-05,   5.8005804E-05
     +,   5.7955800E-05,   5.7933659E-05,   5.7937392E-05
     +,   5.7965004E-05,   5.8014451E-05,   5.8083748E-05
     +,   5.8170903E-05,   5.8273952E-05,   5.8390935E-05
     +,   5.8519978E-05,   5.8659218E-05,   5.8806854E-05
     +,   5.8961166E-05,   5.9120473E-05,   5.9283186E-05
     +,   5.9447833E-05,   5.9612958E-05,   5.9777289E-05
     +,   5.9939623E-05,   6.0098839E-05,   6.0254009E-05
     +,   6.0404269E-05,   6.0548926E-05,   6.0687395E-05
     +,   6.0819246E-05,   6.0944196E-05,   6.1062099E-05
     +,   6.1172992E-05,   6.1277031E-05,   6.1374558E-05
     +,   6.1466046E-05,   6.1552164E-05,   6.1633691E-05
     +,   6.1711638E-05,   6.1787076E-05,   6.1861312E-05
     +,   6.1935789E-05,   6.2012048E-05,   6.2091829E-05
     +,   6.2177001E-05,   6.2269515E-05,   6.2371531E-05
     +,   6.2485240E-05,   6.2612969E-05,   6.2757194E-05
     +,   6.2920408E-05,   6.3105195E-05,   6.3314241E-05
     +,   6.3550244E-05,   6.3815969E-05,   6.4114160E-05
     +,   6.4447617E-05,   6.4819142E-05,   6.5231492E-05
     +,   6.5687338E-05,   6.6189423E-05,   6.6740278E-05
     +,   6.7342487E-05,   6.7998415E-05,   6.8710309E-05
     +,   6.9480411E-05,   7.0310583E-05,   7.1202783E-05
     +,   7.2158546E-05,   7.3179210E-05,   7.4266092E-05
     +,   7.5419986E-05,   7.6641751E-05,   7.7931618E-05
     +,   7.9289770E-05,   8.0716069E-05,   8.2209852E-05
     +,   8.3770530E-05,   8.5396765E-05,   8.7087115E-05
     +,   8.8839835E-05,   9.0652502E-05,   9.2522867E-05
     +,   9.4447816E-05,   9.6424148E-05,   9.8448305E-05
     +,   1.0051634E-04,   1.0262405E-04,   1.0476659E-04
     +,   1.0693938E-04,   1.0913700E-04,   1.1135402E-04
     +,   1.1358471E-04,   1.1582307E-04,   1.1806300E-04
     +,   1.2029782E-04,   1.2252133E-04,   1.2472658E-04
     +,   1.2690683E-04,   1.2905523E-04,   1.3116479E-04
     +,   1.3322868E-04,   1.3523975E-04,   1.3719138E-04
     +,   1.3907661E-04,   1.4088879E-04,   1.4262146E-04
     +,   1.4426823E-04,   1.4582305E-04,   1.4727995E-04
     +,   1.4863338E-04,   1.4987805E-04,   1.5100898E-04
     +,   1.5202160E-04,   1.5291160E-04,   1.5367522E-04
     +,   1.5430895E-04,   1.5480985E-04,   1.5517535E-04
     +,   1.5540335E-04,   1.5549219E-04,   1.5544072E-04
     +,   1.5524817E-04,   1.5491435E-04,   1.5443949E-04
     +,   1.5382421E-04,   1.5306975E-04,   1.5217757E-04
     +,   1.5114977E-04,   1.4998876E-04,   1.4869729E-04
     +,   1.4727880E-04,   1.4573659E-04,   1.4407479E-04
     +,   1.4229759E-04,   1.4040955E-04,   1.3841550E-04
     +,   1.3632046E-04,   1.3412989E-04,   1.3184920E-04
     +,   1.2948411E-04,   1.2704046E-04,   1.2452410E-04
     +,   1.2194139E-04,   1.1929807E-04,   1.1660069E-04
     +,   1.1385507E-04,   1.1106769E-04,   1.0824464E-04
     +,   1.0539192E-04,   1.0251590E-04,   9.9622113E-05
     +,   9.6716729E-05,   9.3805385E-05,   9.0893504E-05
     +,   8.7986846E-05,   8.5090229E-05,   8.2209102E-05
     +,   7.9347890E-05,   7.6511431E-05,   7.3704337E-05
     +,   7.0930488E-05,   6.8193905E-05,   6.5498185E-05
     +,   6.2846979E-05,   6.0243361E-05,   5.7690282E-05
     +,   5.5190434E-05,   5.2746127E-05,   5.0359729E-05
     +,   4.8033093E-05,   4.5767883E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wao_fus_60 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wao_fus_65(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  5.6283955E-07,   6.3317378E-07
     +,   7.1129148E-07,   7.9791317E-07,   8.9381513E-07
     +,   9.9982435E-07,   1.1168152E-06,   1.2457206E-06
     +,   1.3875281E-06,   1.5432717E-06,   1.7140467E-06
     +,   1.9010027E-06,   2.1053304E-06,   2.3282817E-06
     +,   2.5711570E-06,   2.8352893E-06,   3.1220654E-06
     +,   3.4329134E-06,   3.7692737E-06,   4.1326343E-06
     +,   4.5244965E-06,   4.9463829E-06,   5.3998019E-06
     +,   5.8862888E-06,   6.4073338E-06,   6.9644329E-06
     +,   7.5590383E-06,   8.1925782E-06,   8.8663828E-06
     +,   9.5817668E-06,   1.0339917E-05,   1.1141965E-05
     +,   1.1988923E-05,   1.2881711E-05,   1.3821055E-05
     +,   1.4807602E-05,   1.5841835E-05,   1.6924021E-05
     +,   1.8054301E-05,   1.9232641E-05,   2.0458734E-05
     +,   2.1732165E-05,   2.3052213E-05,   2.4418021E-05
     +,   2.5828478E-05,   2.7282289E-05,   2.8777851E-05
     +,   3.0313446E-05,   3.1887110E-05,   3.3496617E-05
     +,   3.5139608E-05,   3.6813562E-05,   3.8515667E-05
     +,   4.0243078E-05,   4.1992695E-05,   4.3761367E-05
     +,   4.5545807E-05,   4.7342652E-05,   4.9148486E-05
     +,   5.0959738E-05,   5.2772972E-05,   5.4584598E-05
     +,   5.6391156E-05,   5.8189205E-05,   5.9975286E-05
     +,   6.1746090E-05,   6.3498461E-05,   6.5229171E-05
     +,   6.6935288E-05,   6.8613946E-05,   7.0262446E-05
     +,   7.1878232E-05,   7.3458963E-05,   7.5002281E-05
     +,   7.6506141E-05,   7.7968631E-05,   7.9388003E-05
     +,   8.0762642E-05,   8.2090955E-05,   8.3371640E-05
     +,   8.4603438E-05,   8.5785250E-05,   8.6916079E-05
     +,   8.7994915E-05,   8.9021079E-05,   8.9993751E-05
     +,   9.0912414E-05,   9.1776557E-05,   9.2585877E-05
     +,   9.3340248E-05,   9.4039598E-05,   9.4684256E-05
     +,   9.5274692E-05,   9.5811731E-05,   9.6296608E-05
     +,   9.6730924E-05,   9.7116827E-05,   9.7457021E-05
     +,   9.7754804E-05,   9.8014301E-05,   9.8240329E-05
     +,   9.8438664E-05,   9.8615958E-05,   9.8779936E-05
     +,   9.8939367E-05,   9.9104160E-05,   9.9285418E-05
     +,   9.9495359E-05,   9.9747507E-05,   1.0005646E-04
     +,   1.0043801E-04,   1.0090907E-04,   1.0148749E-04
     +,   1.0219209E-04,   1.0304231E-04,   1.0405840E-04
     +,   1.0526070E-04,   1.0666995E-04,   1.0830667E-04
     +,   1.1019107E-04,   1.1234272E-04,   1.1477999E-04
     +,   1.1752016E-04,   1.2057871E-04,   1.2396918E-04
     +,   1.2770257E-04,   1.3178751E-04,   1.3622893E-04
     +,   1.4102893E-04,   1.4618576E-04,   1.5169373E-04
     +,   1.5754304E-04,   1.6371990E-04,   1.7020528E-04
     +,   1.7697648E-04,   1.8400616E-04,   1.9126262E-04
     +,   1.9870995E-04,   2.0630837E-04,   2.1401473E-04
     +,   2.2178178E-04,   2.2956033E-04,   2.3729863E-04
     +,   2.4494331E-04,   2.5244005E-04,   2.5973318E-04
     +,   2.6676906E-04,   2.7349323E-04,   2.7985408E-04
     +,   2.8580209E-04,   2.9129011E-04,   2.9627615E-04
     +,   3.0072109E-04,   3.0459114E-04,   3.0785808E-04
     +,   3.1049890E-04,   3.1249662E-04,   3.1384017E-04
     +,   3.1452512E-04,   3.1455269E-04,   3.1393036E-04
     +,   3.1267141E-04,   3.1079489E-04,   3.0832444E-04
     +,   3.0528911E-04,   3.0172153E-04,   2.9765838E-04
     +,   2.9313911E-04,   2.8820551E-04,   2.8290186E-04
     +,   2.7727216E-04,   2.7136231E-04,   2.6521744E-04
     +,   2.5888201E-04,   2.5239945E-04,   2.4581127E-04
     +,   2.3915761E-04,   2.3247556E-04,   2.2579973E-04
     +,   2.1916181E-04,   2.1259024E-04,   2.0611133E-04
     +,   1.9974649E-04,   1.9351557E-04,   1.8743468E-04
     +,   1.8151707E-04,   1.7577309E-04,   1.7021075E-04
     +,   1.6483602E-04,   1.5965170E-04,   1.5466001E-04
     +,   1.4986082E-04,   1.4525274E-04,   1.4083399E-04
     +,   1.3660075E-04,   1.3255001E-04,   1.2867711E-04
     +,   1.2497822E-04,   1.2144944E-04,   1.1808635E-04
     +,   1.1488587E-04,   1.1184439E-04,   1.0895961E-04
     +,   1.0622950E-04,   1.0365251E-04,   1.0122824E-04
     +,   9.8956240E-05,   9.6837321E-05,   9.4872521E-05
     +,   9.3063405E-05,   9.1412287E-05,   8.9921312E-05
     +,   8.8593428E-05,   8.7431428E-05,   8.6438275E-05
     +,   8.5616906E-05,   8.4970030E-05,   8.4500258E-05
     +,   8.4209722E-05,   8.4100167E-05,   8.4172789E-05
     +,   8.4428189E-05,   8.4866268E-05,   8.5486259E-05
     +,   8.6286454E-05,   8.7264540E-05,   8.8417088E-05
     +,   8.9739988E-05,   9.1228219E-05,   9.2875824E-05
     +,   9.4676114E-05,   9.6621261E-05,   9.8703167E-05
     +,   1.0091245E-04,   1.0323928E-04,   1.0567316E-04
     +,   1.0820298E-04,   1.1081716E-04,   1.1350337E-04
     +,   1.1624922E-04,   1.1904183E-04,   1.2186813E-04
     +,   1.2471490E-04,   1.2756842E-04,   1.3041562E-04
     +,   1.3324275E-04,   1.3603653E-04,   1.3878380E-04
     +,   1.4147128E-04,   1.4408653E-04,   1.4661670E-04
     +,   1.4905007E-04,   1.5137470E-04,   1.5357923E-04
     +,   1.5565318E-04,   1.5758601E-04,   1.5936838E-04
     +,   1.6099104E-04,   1.6244562E-04,   1.6372449E-04
     +,   1.6482042E-04,   1.6572731E-04,   1.6643947E-04
     +,   1.6695219E-04,   1.6726147E-04,   1.6736415E-04
     +,   1.6725789E-04,   1.6694119E-04,   1.6641340E-04
     +,   1.6567470E-04,   1.6472618E-04,   1.6356967E-04
     +,   1.6220805E-04,   1.6064469E-04,   1.5888427E-04
     +,   1.5693171E-04,   1.5479319E-04,   1.5247533E-04
     +,   1.4998550E-04,   1.4733202E-04,   1.4452326E-04
     +,   1.4156882E-04,   1.3847837E-04,   1.3526210E-04
     +,   1.3193105E-04,   1.2849577E-04,   1.2496808E-04
     +,   1.2135896E-04,   1.1768036E-04,   1.1394432E-04
     +,   1.1016216E-04,   1.0634572E-04,   1.0250639E-04
     +,   9.8655873E-05,   9.4805102E-05,   9.0964910E-05
     +,   8.7145723E-05,   8.3357401E-05,   7.9609803E-05
     +,   7.5911805E-05,   7.2271891E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wao_fus_65 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wao_fus_70(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  9.5027900E-07,   1.0145036E-06
     +,   1.0821974E-06,   1.1534767E-06,   1.2284596E-06
     +,   1.3072645E-06,   1.3900019E-06,   1.4767855E-06
     +,   1.5677247E-06,   1.6629215E-06,   1.7624778E-06
     +,   1.8664931E-06,   1.9750526E-06,   2.0882446E-06
     +,   2.2061490E-06,   2.3288328E-06,   2.4563622E-06
     +,   2.5887953E-06,   2.7261742E-06,   2.8685374E-06
     +,   3.0159138E-06,   3.1683217E-06,   3.3257636E-06
     +,   3.4882387E-06,   3.6557249E-06,   3.8281960E-06
     +,   4.0056107E-06,   4.1879198E-06,   4.3750501E-06
     +,   4.5669299E-06,   4.7634635E-06,   4.9645496E-06
     +,   5.1700754E-06,   5.3799195E-06,   5.5939386E-06
     +,   5.8119931E-06,   6.0339326E-06,   6.2595900E-06
     +,   6.4888045E-06,   6.7214119E-06,   6.9572338E-06
     +,   7.1961108E-06,   7.4378681E-06,   7.6823526E-06
     +,   7.9294159E-06,   8.1789285E-06,   8.4307621E-06
     +,   8.6848313E-06,   8.9410705E-06,   9.1994343E-06
     +,   9.4599318E-06,   9.7226139E-06,   9.9875642E-06
     +,   1.0254952E-05,   1.0524976E-05,   1.0797935E-05
     +,   1.1074193E-05,   1.1354201E-05,   1.1638514E-05
     +,   1.1927776E-05,   1.2222755E-05,   1.2524323E-05
     +,   1.2833497E-05,   1.3151430E-05,   1.3479398E-05
     +,   1.3818851E-05,   1.4171394E-05,   1.4538779E-05
     +,   1.4922951E-05,   1.5326019E-05,   1.5750275E-05
     +,   1.6198182E-05,   1.6672426E-05,   1.7175798E-05
     +,   1.7711332E-05,   1.8282224E-05,   1.8891838E-05
     +,   1.9543733E-05,   2.0241538E-05,   2.0989115E-05
     +,   2.1790420E-05,   2.2649530E-05,   2.3570667E-05
     +,   2.4557978E-05,   2.5615926E-05,   2.6748761E-05
     +,   2.7960899E-05,   2.9256693E-05,   3.0640484E-05
     +,   3.2116586E-05,   3.3689070E-05,   3.5362049E-05
     +,   3.7139431E-05,   3.9024948E-05,   4.1022122E-05
     +,   4.3134241E-05,   4.5364421E-05,   4.7715199E-05
     +,   5.0189057E-05,   5.2788004E-05,   5.5513683E-05
     +,   5.8367379E-05,   6.1349623E-05,   6.4460706E-05
     +,   6.7700348E-05,   7.1067596E-05,   7.4561081E-05
     +,   7.8178149E-05,   8.1916471E-05,   8.5771935E-05
     +,   8.9740177E-05,   9.3815892E-05,   9.7992874E-05
     +,   1.0226416E-04,   1.0662119E-04,   1.1105558E-04
     +,   1.1555682E-04,   1.2011410E-04,   1.2471544E-04
     +,   1.2934791E-04,   1.3399795E-04,   1.3865052E-04
     +,   1.4329042E-04,   1.4790165E-04,   1.5246758E-04
     +,   1.5697131E-04,   1.6139579E-04,   1.6572340E-04
     +,   1.6993721E-04,   1.7402043E-04,   1.7795680E-04
     +,   1.8173079E-04,   1.8532797E-04,   1.8873469E-04
     +,   1.9193906E-04,   1.9493060E-04,   1.9770049E-04
     +,   2.0024183E-04,   2.0254964E-04,   2.0462101E-04
     +,   2.0645493E-04,   2.0805272E-04,   2.0941763E-04
     +,   2.1055498E-04,   2.1147204E-04,   2.1217756E-04
     +,   2.1268232E-04,   2.1299817E-04,   2.1313835E-04
     +,   2.1311695E-04,   2.1294881E-04,   2.1264907E-04
     +,   2.1223321E-04,   2.1171634E-04,   2.1111339E-04
     +,   2.1043859E-04,   2.0970510E-04,   2.0892527E-04
     +,   2.0810965E-04,   2.0726775E-04,   2.0640710E-04
     +,   2.0553361E-04,   2.0465143E-04,   2.0376257E-04
     +,   2.0286741E-04,   2.0196439E-04,   2.0105015E-04
     +,   2.0011979E-04,   1.9916693E-04,   1.9818386E-04
     +,   1.9716169E-04,   1.9609106E-04,   1.9496180E-04
     +,   1.9376374E-04,   1.9248672E-04,   1.9112111E-04
     +,   1.8965814E-04,   1.8809014E-04,   1.8641097E-04
     +,   1.8461634E-04,   1.8270401E-04,   1.8067459E-04
     +,   1.7853058E-04,   1.7627818E-04,   1.7392625E-04
     +,   1.7148686E-04,   1.6897538E-04,   1.6641036E-04
     +,   1.6381404E-04,   1.6121101E-04,   1.5862954E-04
     +,   1.5610029E-04,   1.5365645E-04,   1.5133373E-04
     +,   1.4916895E-04,   1.4720090E-04,   1.4546886E-04
     +,   1.4401277E-04,   1.4287242E-04,   1.4208672E-04
     +,   1.4169372E-04,   1.4172963E-04,   1.4222851E-04
     +,   1.4322205E-04,   1.4473901E-04,   1.4680473E-04
     +,   1.4944188E-04,   1.5266925E-04,   1.5650287E-04
     +,   1.6095571E-04,   1.6603772E-04,   1.7175806E-04
     +,   1.7812304E-04,   1.8513913E-04,   1.9281267E-04
     +,   2.0115076E-04,   2.1016247E-04,   2.1985744E-04
     +,   2.3025020E-04,   2.4135543E-04,   2.5319151E-04
     +,   2.6577798E-04,   2.7913519E-04,   2.9328268E-04
     +,   3.0823491E-04,   3.2400450E-04,   3.4059145E-04
     +,   3.5798611E-04,   3.7616357E-04,   3.9507990E-04
     +,   4.1467062E-04,   4.3484429E-04,   4.5548804E-04
     +,   4.7645695E-04,   4.9758190E-04,   5.1866687E-04
     +,   5.3949223E-04,   5.5982010E-04,   5.7939469E-04
     +,   5.9795508E-04,   6.1523740E-04,   6.3098432E-04
     +,   6.4495322E-04,   6.5692107E-04,   6.6669757E-04
     +,   6.7412492E-04,   6.7908800E-04,   6.8151613E-04
     +,   6.8138499E-04,   6.7871832E-04,   6.7358592E-04
     +,   6.6609943E-04,   6.5641035E-04,   6.4470345E-04
     +,   6.3118601E-04,   6.1608880E-04,   5.9964799E-04
     +,   5.8210769E-04,   5.6370557E-04,   5.4466899E-04
     +,   5.2521273E-04,   5.0552591E-04,   4.8578010E-04
     +,   4.6611874E-04,   4.4666033E-04,   4.2749810E-04
     +,   4.0870105E-04,   3.9031854E-04,   3.7237871E-04
     +,   3.5489534E-04,   3.3786954E-04,   3.2129296E-04
     +,   3.0515387E-04,   2.8943340E-04,   2.7411702E-04
     +,   2.5918707E-04,   2.4463283E-04,   2.3044563E-04
     +,   2.1662127E-04,   2.0316252E-04,   1.9007329E-04
     +,   1.7736488E-04,   1.6505012E-04,   1.5314444E-04
     +,   1.4166647E-04,   1.3063262E-04,   1.2006221E-04
     +,   1.0997021E-04,   1.0037208E-04,   9.1280541E-05
     +,   8.2703511E-05,   7.4646858E-05,   6.7112189E-05
     +,   6.0098126E-05,   5.3598673E-05,   4.7604539E-05
     +,   4.2102958E-05,   3.7077894E-05,   3.2511089E-05
     +,   2.8381321E-05,   2.4665658E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wao_fus_70 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wao_fus_75(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  4.2598325E-09,   4.9368478E-09
     +,   5.7139462E-09,   6.6046506E-09,   7.6241564E-09
     +,   8.7894758E-09,   1.0119553E-08,   1.1635583E-08
     +,   1.3361156E-08,   1.5322412E-08,   1.7548436E-08
     +,   2.0071459E-08,   2.2926976E-08,   2.6154279E-08
     +,   2.9796706E-08,   3.3901646E-08,   3.8521350E-08
     +,   4.3713090E-08,   4.9539171E-08,   5.6067893E-08
     +,   6.3373541E-08,   7.1537052E-08,   8.0645762E-08
     +,   9.0794799E-08,   1.0208639E-07,   1.1463126E-07
     +,   1.2854842E-07,   1.4396585E-07,   1.6101994E-07
     +,   1.7985784E-07,   2.0063486E-07,   2.2351773E-07
     +,   2.4868299E-07,   2.7631836E-07,   3.0662039E-07
     +,   3.3979816E-07,   3.7607185E-07,   4.1566997E-07
     +,   4.5883411E-07,   5.0581627E-07,   5.5687565E-07
     +,   6.1228610E-07,   6.7232548E-07,   7.3728427E-07
     +,   8.0745968E-07,   8.8315824E-07,   9.6468796E-07
     +,   1.0523665E-06,   1.1465174E-06,   1.2474604E-06
     +,   1.3555239E-06,   1.4710358E-06,   1.5943180E-06
     +,   1.7256976E-06,   1.8654896E-06,   2.0140101E-06
     +,   2.1715657E-06,   2.3384541E-06,   2.5149686E-06
     +,   2.7013791E-06,   2.8979589E-06,   3.1049512E-06
     +,   3.3226002E-06,   3.5511332E-06,   3.7907530E-06
     +,   4.0416585E-06,   4.3040409E-06,   4.5780616E-06
     +,   4.8638899E-06,   5.1616821E-06,   5.4715897E-06
     +,   5.7937691E-06,   6.1283918E-06,   6.4756027E-06
     +,   6.8356017E-06,   7.2086023E-06,   7.5948487E-06
     +,   7.9946403E-06,   8.4082822E-06,   8.8361867E-06
     +,   9.2788159E-06,   9.7367138E-06,   1.0210531E-05
     +,   1.0700947E-05,   1.1208878E-05,   1.1735229E-05
     +,   1.2281103E-05,   1.2847722E-05,   1.3436440E-05
     +,   1.4048777E-05,   1.4686328E-05,   1.5350895E-05
     +,   1.6044376E-05,   1.6768823E-05,   1.7526390E-05
     +,   1.8319337E-05,   1.9150035E-05,   2.0020834E-05
     +,   2.0934229E-05,   2.1892694E-05,   2.2898706E-05
     +,   2.3954748E-05,   2.5063133E-05,   2.6226206E-05
     +,   2.7446167E-05,   2.8725110E-05,   3.0065039E-05
     +,   3.1467618E-05,   3.2934731E-05,   3.4467783E-05
     +,   3.6068272E-05,   3.7737580E-05,   3.9477065E-05
     +,   4.1288185E-05,   4.3172222E-05,   4.5131110E-05
     +,   4.7166552E-05,   4.9280905E-05,   5.1476862E-05
     +,   5.3757700E-05,   5.6127370E-05,   5.8590271E-05
     +,   6.1151834E-05,   6.3818137E-05,   6.6596142E-05
     +,   6.9493479E-05,   7.2518662E-05,   7.5680400E-05
     +,   7.8988138E-05,   8.2451450E-05,   8.6079788E-05
     +,   8.9882225E-05,   9.3867253E-05,   9.8041688E-05
     +,   1.0241129E-04,   1.0697953E-04,   1.1174745E-04
     +,   1.1671319E-04,   1.2187145E-04,   1.2721347E-04
     +,   1.3272588E-04,   1.3839173E-04,   1.4418953E-04
     +,   1.5009352E-04,   1.5607401E-04,   1.6209656E-04
     +,   1.6812491E-04,   1.7411832E-04,   1.8003480E-04
     +,   1.8583109E-04,   1.9146258E-04,   1.9688674E-04
     +,   2.0206130E-04,   2.0694744E-04,   2.1150980E-04
     +,   2.1571787E-04,   2.1954667E-04,   2.2297716E-04
     +,   2.2599818E-04,   2.2860499E-04,   2.3080099E-04
     +,   2.3259694E-04,   2.3401096E-04,   2.3506848E-04
     +,   2.3580081E-04,   2.3624518E-04,   2.3644335E-04
     +,   2.3644067E-04,   2.3628520E-04,   2.3602620E-04
     +,   2.3571326E-04,   2.3539535E-04,   2.3511956E-04
     +,   2.3493047E-04,   2.3486927E-04,   2.3497341E-04
     +,   2.3527605E-04,   2.3580574E-04,   2.3658639E-04
     +,   2.3763730E-04,   2.3897305E-04,   2.4060364E-04
     +,   2.4253494E-04,   2.4476805E-04,   2.4730031E-04
     +,   2.5012449E-04,   2.5322937E-04,   2.5659939E-04
     +,   2.6021391E-04,   2.6404866E-04,   2.6807329E-04
     +,   2.7225300E-04,   2.7654815E-04,   2.8091326E-04
     +,   2.8529903E-04,   2.8965090E-04,   2.9391158E-04
     +,   2.9802055E-04,   3.0191531E-04,   3.0553466E-04
     +,   3.0881766E-04,   3.1170779E-04,   3.1415309E-04
     +,   3.1610910E-04,   3.1754028E-04,   3.1842178E-04
     +,   3.1874084E-04,   3.1849771E-04,   3.1770614E-04
     +,   3.1639356E-04,   3.1460114E-04,   3.1238113E-04
     +,   3.0979744E-04,   3.0692149E-04,   3.0383127E-04
     +,   3.0060756E-04,   2.9733169E-04,   2.9408300E-04
     +,   2.9093557E-04,   2.8795784E-04,   2.8521041E-04
     +,   2.8274694E-04,   2.8061483E-04,   2.7885771E-04
     +,   2.7751966E-04,   2.7664844E-04,   2.7630245E-04
     +,   2.7655589E-04,   2.7750488E-04,   2.7927273E-04
     +,   2.8201446E-04,   2.8591882E-04,   2.9120879E-04
     +,   2.9813699E-04,   3.0698054E-04,   3.1802955E-04
     +,   3.3157377E-04,   3.4788533E-04,   3.6719639E-04
     +,   3.8968085E-04,   4.1543017E-04,   4.4443313E-04
     +,   4.7655823E-04,   5.1153469E-04,   5.4895831E-04
     +,   5.8827270E-04,   6.2879210E-04,   6.6971220E-04
     +,   7.1012718E-04,   7.4907934E-04,   7.8557176E-04
     +,   8.1863336E-04,   8.4734068E-04,   8.7086728E-04
     +,   8.8852533E-04,   8.9978275E-04,   9.0429699E-04
     +,   9.0192049E-04,   8.9270639E-04,   8.7689934E-04
     +,   8.5492246E-04,   8.2734448E-04,   7.9486158E-04
     +,   7.5825251E-04,   7.1834895E-04,   6.7599933E-04
     +,   6.3203415E-04,   5.8724737E-04,   5.4236106E-04
     +,   4.9801741E-04,   4.5476609E-04,   4.1305803E-04
     +,   3.7325340E-04,   3.3560954E-04,   3.0031140E-04
     +,   2.6745835E-04,   2.3709575E-04,   2.0921182E-04
     +,   1.8375409E-04,   1.6064281E-04,   1.3976937E-04
     +,   1.2101601E-04,   1.0425215E-04,   8.9342619E-05
     +,   7.6152712E-05,   6.4544940E-05,   5.4388089E-05
     +,   4.5551267E-05,   3.7910504E-05,   3.1346641E-05
     +,   2.5744950E-05,   2.0997917E-05,   1.7004175E-05
     +,   1.3669654E-05,   1.0906990E-05,   8.6363425E-06
     +,   6.7853139E-06,   5.2888859E-06,   4.0894929E-06
     +,   3.1364266E-06,   2.3857190E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wao_fus_75 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wao_fus_80(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  2.5506238E-18,   3.8159260E-18
     +,   5.6933530E-18,   8.4712212E-18,   1.2569973E-17
     +,   1.8601080E-17,   2.7450480E-17,   4.0399306E-17
     +,   5.9294245E-17,   8.6787896E-17,   1.2668263E-16
     +,   1.8441257E-16,   2.6771450E-16,   3.8758298E-16
     +,   5.5959396E-16,   8.0572956E-16,   1.1569586E-15
     +,   1.6567652E-15,   2.3659858E-15,   3.3695784E-15
     +,   4.7857539E-15,   6.7786111E-15,   9.5750070E-15
     +,   1.3488093E-14,   1.8948403E-14,   2.6546431E-14
     +,   3.7089587E-14,   5.1678727E-14,   7.1809163E-14
     +,   9.9509268E-14,   1.3751672E-13,   1.8952251E-13
     +,   2.6048204E-13,   3.5703341E-13,   4.8803317E-13
     +,   6.6527561E-13,   9.0441798E-13,   1.2261574E-12
     +,   1.6578153E-12,   2.2353256E-12,   3.0057699E-12
     +,   4.0307475E-12,   5.3904619E-12,   7.1891911E-12
     +,   9.5619537E-12,   1.2683203E-11,   1.6777335E-11
     +,   2.2132560E-11,   2.9117622E-11,   3.8202639E-11
     +,   4.9985672E-11,   6.5225138E-11,   8.4878715E-11
     +,   1.1015426E-10,   1.4256668E-10,   1.8401489E-10
     +,   2.3686775E-10,   3.0407335E-10,   3.8928974E-10
     +,   4.9703414E-10,   6.3288347E-10,   8.0367879E-10
     +,   1.0178073E-09,   1.2855138E-09,   1.6192482E-09
     +,   2.0341331E-09,   2.5484617E-09,   3.1842551E-09
     +,   3.9680126E-09,   4.9314637E-09,   6.1124963E-09
     +,   7.5562179E-09,   9.3162278E-09,   1.1455693E-08
     +,   1.4049329E-08,   1.7184895E-08,   2.0965176E-08
     +,   2.5510509E-08,   3.0960383E-08,   3.7477324E-08
     +,   4.5249287E-08,   5.4493050E-08,   6.5458465E-08
     +,   7.8430205E-08,   9.3737349E-08,   1.1175112E-07
     +,   1.3289593E-07,   1.5765215E-07,   1.8656273E-07
     +,   2.2024088E-07,   2.5937155E-07,   3.0472660E-07
     +,   3.5716675E-07,   4.1765182E-07,   4.8724792E-07
     +,   5.6713725E-07,   6.5862969E-07,   7.6315797E-07
     +,   8.8230769E-07,   1.0178137E-06,   1.1715708E-06
     +,   1.3456518E-06,   1.5422869E-06,   1.7639113E-06
     +,   2.0131479E-06,   2.2928159E-06,   2.6059504E-06
     +,   2.9557389E-06,   3.3456652E-06,   3.7793145E-06
     +,   4.2605243E-06,   4.7932995E-06,   5.3818094E-06
     +,   6.0304014E-06,   6.7434371E-06,   7.5255575E-06
     +,   8.3812638E-06,   9.3151793E-06,   1.0331859E-05
     +,   1.1435762E-05,   1.2631239E-05,   1.3922279E-05
     +,   1.5312715E-05,   1.6805963E-05,   1.8405006E-05
     +,   2.0112320E-05,   2.1929867E-05,   2.3858769E-05
     +,   2.5899670E-05,   2.8052415E-05,   3.0316132E-05
     +,   3.2689208E-05,   3.5169414E-05,   3.7753627E-05
     +,   4.0438452E-05,   4.3219952E-05,   4.6093995E-05
     +,   4.9056373E-05,   5.2103082E-05,   5.5230710E-05
     +,   5.8436268E-05,   6.1718194E-05,   6.5076267E-05
     +,   6.8512018E-05,   7.2029230E-05,   7.5633514E-05
     +,   7.9334008E-05,   8.3141713E-05,   8.7070999E-05
     +,   9.1139045E-05,   9.5365001E-05,   9.9771372E-05
     +,   1.0438128E-04,   1.0921952E-04,   1.1431096E-04
     +,   1.1967958E-04,   1.2534768E-04,   1.3133329E-04
     +,   1.3765154E-04,   1.4431008E-04,   1.5131025E-04
     +,   1.5864529E-04,   1.6629806E-04,   1.7424385E-04
     +,   1.8244580E-04,   1.9085858E-04,   1.9942732E-04
     +,   2.0808936E-04,   2.1677576E-04,   2.2541218E-04
     +,   2.3392437E-04,   2.4223659E-04,   2.5027792E-04
     +,   2.5798319E-04,   2.6529605E-04,   2.7217160E-04
     +,   2.7857677E-04,   2.8449332E-04,   2.8991723E-04
     +,   2.9485862E-04,   2.9934110E-04,   3.0339879E-04
     +,   3.0707655E-04,   3.1042457E-04,   3.1349770E-04
     +,   3.1635142E-04,   3.1903986E-04,   3.2161389E-04
     +,   3.2411903E-04,   3.2659608E-04,   3.2907986E-04
     +,   3.3160133E-04,   3.3418872E-04,   3.3686886E-04
     +,   3.3967066E-04,   3.4262479E-04,   3.4576681E-04
     +,   3.4913560E-04,   3.5277329E-04,   3.5672396E-04
     +,   3.6102865E-04,   3.6572374E-04,   3.7083434E-04
     +,   3.7637158E-04,   3.8232945E-04,   3.8868061E-04
     +,   3.9537982E-04,   4.0236139E-04,   4.0954663E-04
     +,   4.1684904E-04,   4.2418067E-04,   4.3146373E-04
     +,   4.3863512E-04,   4.4565715E-04,   4.5252149E-04
     +,   4.5925324E-04,   4.6591056E-04,   4.7258197E-04
     +,   4.7938377E-04,   4.8645146E-04,   4.9393415E-04
     +,   5.0198793E-04,   5.1077077E-04,   5.2043819E-04
     +,   5.3113961E-04,   5.4301909E-04,   5.5620982E-04
     +,   5.7083194E-04,   5.8698579E-04,   6.0473982E-04
     +,   6.2411843E-04,   6.4507866E-04,   6.6749920E-04
     +,   6.9115119E-04,   7.1568991E-04,   7.4064388E-04
     +,   7.6541718E-04,   7.8930572E-04,   8.1152056E-04
     +,   8.3123398E-04,   8.4762776E-04,   8.5995026E-04
     +,   8.6757465E-04,   8.7005040E-04,   8.6714869E-04
     +,   8.5888640E-04,   8.4553566E-04,   8.2761265E-04
     +,   8.0585032E-04,   7.8114460E-04,   7.5450935E-04
     +,   7.2699925E-04,   6.9965998E-04,   6.7346310E-04
     +,   6.4925291E-04,   6.2772189E-04,   6.0937268E-04
     +,   5.9451966E-04,   5.8328337E-04,   5.7560229E-04
     +,   5.7125307E-04,   5.6987157E-04,   5.7097932E-04
     +,   5.7401072E-04,   5.7834067E-04,   5.8331084E-04
     +,   5.8825698E-04,   5.9253298E-04,   5.9553597E-04
     +,   5.9672818E-04,   5.9565570E-04,   5.9196533E-04
     +,   5.8541651E-04,   5.7588593E-04,   5.6337309E-04
     +,   5.4798945E-04,   5.2995479E-04,   5.0957687E-04
     +,   4.8723342E-04,   4.6335420E-04,   4.3838835E-04
     +,   4.1279432E-04,   3.8700871E-04,   3.6143223E-04
     +,   3.3641915E-04,   3.1225770E-04,   2.8917889E-04
     +,   2.6734074E-04,   2.4684443E-04,   2.2773420E-04
     +,   2.1000236E-04,   1.9360583E-04,   1.7847151E-04
     +,   1.6450924E-04,   1.5161700E-04,   1.3969082E-04
     +,   1.2863029E-04,   1.1834242E-04,   1.0874600E-04
     +,   9.9770681E-05,   9.1358823E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wao_fus_80 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wao_fus_85(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  7.3524499E-11,   9.0789674E-11
     +,   1.1191899E-10,   1.3773066E-10,   1.6920712E-10
     +,   2.0752482E-10,   2.5408653E-10,   3.1056641E-10
     +,   3.7895762E-10,   4.6162241E-10,   5.6136484E-10
     +,   6.8150158E-10,   8.2594187E-10,   9.9929531E-10
     +,   1.2069866E-09,   1.4553641E-09,   1.7518762E-09
     +,   2.1052289E-09,   2.5255527E-09,   3.0246616E-09
     +,   3.6162617E-09,   4.3162571E-09,   5.1430016E-09
     +,   6.1177401E-09,   7.2648629E-09,   8.6124690E-09
     +,   1.0192748E-08,   1.2042608E-08,   1.4204067E-08
     +,   1.6725171E-08,   1.9660344E-08,   2.3071545E-08
     +,   2.7028809E-08,   3.1611378E-08,   3.6908297E-08
     +,   4.3019945E-08,   5.0059043E-08,   5.8151326E-08
     +,   6.7437725E-08,   7.8075260E-08,   9.0237968E-08
     +,   1.0411971E-07,   1.1993401E-07,   1.3791734E-07
     +,   1.5832981E-07,   1.8145766E-07,   2.0761308E-07
     +,   2.3713871E-07,   2.7040792E-07,   3.0782527E-07
     +,   3.4983077E-07,   3.9690096E-07,   4.4954680E-07
     +,   5.0832176E-07,   5.7381470E-07,   6.4665909E-07
     +,   7.2752846E-07,   8.1713910E-07,   9.1625128E-07
     +,   1.0256622E-06,   1.1462187E-06,   1.2788001E-06
     +,   1.4243312E-06,   1.5837769E-06,   1.7581274E-06
     +,   1.9484135E-06,   2.1556980E-06,   2.3810546E-06
     +,   2.6255900E-06,   2.8904199E-06,   3.1766692E-06
     +,   3.4854656E-06,   3.8179405E-06,   4.1751750E-06
     +,   4.5582651E-06,   4.9682608E-06,   5.4061707E-06
     +,   5.8729679E-06,   6.3695102E-06,   6.8966297E-06
     +,   7.4550594E-06,   8.0454329E-06,   8.6682940E-06
     +,   9.3239751E-06,   1.0012843E-05,   1.0734944E-05
     +,   1.1490278E-05,   1.2278647E-05,   1.3099683E-05
     +,   1.3952870E-05,   1.4837397E-05,   1.5752363E-05
     +,   1.6696627E-05,   1.7668857E-05,   1.8667499E-05
     +,   1.9690809E-05,   2.0736881E-05,   2.1803480E-05
     +,   2.2888318E-05,   2.3988874E-05,   2.5102474E-05
     +,   2.6226315E-05,   2.7357341E-05,   2.8492503E-05
     +,   2.9628611E-05,   3.0762410E-05,   3.1890642E-05
     +,   3.3009852E-05,   3.4116907E-05,   3.5208435E-05
     +,   3.6281286E-05,   3.7332418E-05,   3.8358929E-05
     +,   3.9358147E-05,   4.0327486E-05,   4.1264913E-05
     +,   4.2168420E-05,   4.3036503E-05,   4.3868004E-05
     +,   4.4662214E-05,   4.5418863E-05,   4.6138102E-05
     +,   4.6820696E-05,   4.7467896E-05,   4.8081518E-05
     +,   4.8663929E-05,   4.9218135E-05,   4.9747636E-05
     +,   5.0256571E-05,   5.0749677E-05,   5.1232208E-05
     +,   5.1709998E-05,   5.2189389E-05,   5.2677147E-05
     +,   5.3180556E-05,   5.3707281E-05,   5.4265300E-05
     +,   5.4862907E-05,   5.5508604E-05,   5.6211065E-05
     +,   5.6978988E-05,   5.7821144E-05,   5.8746191E-05
     +,   5.9762675E-05,   6.0878945E-05,   6.2102838E-05
     +,   6.3442203E-05,   6.4904045E-05,   6.6495093E-05
     +,   6.8221489E-05,   7.0088492E-05,   7.2101167E-05
     +,   7.4263327E-05,   7.6578312E-05,   7.9048586E-05
     +,   8.1675717E-05,   8.4460509E-05,   8.7402354E-05
     +,   9.0500413E-05,   9.3751973E-05,   9.7153614E-05
     +,   1.0070069E-04,   1.0438661E-04,   1.0820437E-04
     +,   1.1214439E-04,   1.1619600E-04,   1.2034673E-04
     +,   1.2458238E-04,   1.2888724E-04,   1.3324342E-04
     +,   1.3763293E-04,   1.4203567E-04,   1.4643185E-04
     +,   1.5080189E-04,   1.5512723E-04,   1.5939168E-04
     +,   1.6358191E-04,   1.6768945E-04,   1.7171144E-04
     +,   1.7565192E-04,   1.7952318E-04,   1.8334565E-04
     +,   1.8715041E-04,   1.9097695E-04,   1.9487468E-04
     +,   1.9890165E-04,   2.0312308E-04,   2.0761046E-04
     +,   2.1243827E-04,   2.1768485E-04,   2.2342723E-04
     +,   2.2974223E-04,   2.3670503E-04,   2.4438745E-04
     +,   2.5286170E-04,   2.6219693E-04,   2.7246561E-04
     +,   2.8374005E-04,   2.9609428E-04,   3.0960573E-04
     +,   3.2434551E-04,   3.4038073E-04,   3.5775793E-04
     +,   3.7649929E-04,   3.9658946E-04,   4.1796215E-04
     +,   4.4050079E-04,   4.6402586E-04,   4.8830779E-04
     +,   5.1307841E-04,   5.3804886E-04,   5.6295120E-04
     +,   5.8756291E-04,   6.1175466E-04,   6.3552265E-04
     +,   6.5901486E-04,   6.8254536E-04,   7.0658082E-04
     +,   7.3172041E-04,   7.5863110E-04,   7.8798563E-04
     +,   8.2037400E-04,   8.5621962E-04,   8.9570833E-04
     +,   9.3873061E-04,   9.8488864E-04,   1.0334996E-03
     +,   1.0836830E-03,   1.1344487E-03,   1.1848051E-03
     +,   1.2338574E-03,   1.2808573E-03,   1.3252342E-03
     +,   1.3665283E-03,   1.4043220E-03,   1.4381285E-03
     +,   1.4673081E-03,   1.4910293E-03,   1.5083010E-03
     +,   1.5180948E-03,   1.5195202E-03,   1.5120393E-03
     +,   1.4956587E-03,   1.4710603E-03,   1.4396241E-03
     +,   1.4033439E-03,   1.3646130E-03,   1.3259426E-03
     +,   1.2896504E-03,   1.2575495E-03,   1.2307464E-03
     +,   1.2095090E-03,   1.1932952E-03,   1.1808744E-03
     +,   1.1705545E-03,   1.1604581E-03,   1.1488006E-03
     +,   1.1341359E-03,   1.1155177E-03,   1.0925800E-03
     +,   1.0655177E-03,   1.0349785E-03,   1.0019275E-03
     +,   9.6745626E-04,   9.3262439E-04,   8.9832477E-04
     +,   8.6519512E-04,   8.3359092E-04,   8.0358738E-04
     +,   7.7503471E-04,   7.4762449E-04,   7.2096242E-04
     +,   6.9464167E-04,   6.6828786E-04,   6.4161263E-04
     +,   6.1441644E-04,   5.8661122E-04,   5.5820198E-04
     +,   5.2927801E-04,   4.9999892E-04,   4.7056345E-04
     +,   4.4120540E-04,   4.1216469E-04,   3.8367644E-04
     +,   3.5596325E-04,   3.2921441E-04,   3.0359504E-04
     +,   2.7922657E-04,   2.5619986E-04,   2.3456967E-04
     +,   2.1435447E-04,   1.9554797E-04,   1.7811904E-04
     +,   1.6202088E-04,   1.4719149E-04,   1.3356142E-04
     +,   1.2105686E-04,   1.0960226E-04,   9.9124438E-05
     +,   8.9551635E-05,   8.0816113E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wao_fus_85 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wao_fus_90(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  4.1274051E-10,   4.8117299E-10
     +,   5.6032118E-10,   6.5175160E-10,   7.5724826E-10
     +,   8.7883351E-10,   1.0187915E-09,   1.1797110E-09
     +,   1.3645152E-09,   1.5764940E-09,   1.8193603E-09
     +,   2.0972881E-09,   2.4149553E-09,   2.7776219E-09
     +,   3.1911831E-09,   3.6621977E-09,   4.1980353E-09
     +,   4.8068998E-09,   5.4979075E-09,   6.2812187E-09
     +,   7.1681190E-09,   8.1711402E-09,   9.3041042E-09
     +,   1.0582366E-08,   1.2022812E-08,   1.3644121E-08
     +,   1.5466844E-08,   1.7513614E-08,   1.9809161E-08
     +,   2.2380780E-08,   2.5258128E-08,   2.8473812E-08
     +,   3.2063330E-08,   3.6065508E-08,   4.0522266E-08
     +,   4.5479489E-08,   5.0986923E-08,   5.7098120E-08
     +,   6.3871369E-08,   7.1369548E-08,   7.9660161E-08
     +,   8.8816307E-08,   9.8916054E-08,   1.1004346E-07
     +,   1.2228848E-07,   1.3574775E-07,   1.5052332E-07
     +,   1.6672492E-07,   1.8446936E-07,   2.0387968E-07
     +,   2.2508716E-07,   2.4823109E-07,   2.7345726E-07
     +,   3.0092087E-07,   3.3078348E-07,   3.6321649E-07
     +,   3.9839892E-07,   4.3651809E-07,   4.7777013E-07
     +,   5.2235731E-07,   5.7049306E-07,   6.2239553E-07
     +,   6.7829262E-07,   7.3842068E-07,   8.0301925E-07
     +,   8.7233786E-07,   9.4663307E-07,   1.0261623E-06
     +,   1.1111924E-06,   1.2019934E-06,   1.2988389E-06
     +,   1.4020051E-06,   1.5117739E-06,   1.6284163E-06
     +,   1.7522150E-06,   1.8834473E-06,   2.0223874E-06
     +,   2.1693122E-06,   2.3244754E-06,   2.4881422E-06
     +,   2.6605621E-06,   2.8419761E-06,   3.0326203E-06
     +,   3.2326891E-06,   3.4424152E-06,   3.6619585E-06
     +,   3.8914955E-06,   4.1311714E-06,   4.3811133E-06
     +,   4.6414325E-06,   4.9121854E-06,   5.1934330E-06
     +,   5.4851971E-06,   5.7874704E-06,   6.1002138E-06
     +,   6.4233550E-06,   6.7568044E-06,   7.1003947E-06
     +,   7.4539657E-06,   7.8173043E-06,   8.1901653E-06
     +,   8.5722777E-06,   8.9632922E-06,   9.3628678E-06
     +,   9.7706115E-06,   1.0186100E-05,   1.0608888E-05
     +,   1.1038443E-05,   1.1474312E-05,   1.1915904E-05
     +,   1.2362674E-05,   1.2814045E-05,   1.3269428E-05
     +,   1.3728242E-05,   1.4189839E-05,   1.4653700E-05
     +,   1.5119202E-05,   1.5585809E-05,   1.6053007E-05
     +,   1.6520324E-05,   1.6987358E-05,   1.7453724E-05
     +,   1.7919167E-05,   1.8383507E-05,   1.8846675E-05
     +,   1.9308709E-05,   1.9769814E-05,   2.0230282E-05
     +,   2.0690621E-05,   2.1151503E-05,   2.1613781E-05
     +,   2.2078517E-05,   2.2546999E-05,   2.3020681E-05
     +,   2.3501292E-05,   2.3990784E-05,   2.4491328E-05
     +,   2.5005325E-05,   2.5535401E-05,   2.6084392E-05
     +,   2.6655280E-05,   2.7251259E-05,   2.7875649E-05
     +,   2.8531869E-05,   2.9223429E-05,   2.9953748E-05
     +,   3.0726391E-05,   3.1544641E-05,   3.2411739E-05
     +,   3.3330682E-05,   3.4304045E-05,   3.5334280E-05
     +,   3.6423105E-05,   3.7571877E-05,   3.8781291E-05
     +,   4.0051360E-05,   4.1381405E-05,   4.2769687E-05
     +,   4.4213979E-05,   4.5710738E-05,   4.7255671E-05
     +,   4.8843496E-05,   5.0467697E-05,   5.2121170E-05
     +,   5.3795426E-05,   5.5481269E-05,   5.7168585E-05
     +,   5.8846439E-05,   6.0503309E-05,   6.2126783E-05
     +,   6.3704530E-05,   6.5223445E-05,   6.6670611E-05
     +,   6.8033223E-05,   6.9298789E-05,   7.0455593E-05
     +,   7.1492730E-05,   7.2400828E-05,   7.3172327E-05
     +,   7.3801981E-05,   7.4287629E-05,   7.4630778E-05
     +,   7.4837684E-05,   7.4920186E-05,   7.4896998E-05
     +,   7.4794822E-05,   7.4649761E-05,   7.4508469E-05
     +,   7.4429336E-05,   7.4483265E-05,   7.4753938E-05
     +,   7.5337382E-05,   7.6340715E-05,   7.7879275E-05
     +,   8.0073449E-05,   8.3042847E-05,   8.6901469E-05
     +,   9.1749956E-05,   9.7669705E-05,   1.0471982E-04
     +,   1.1293197E-04,   1.2231694E-04,   1.3286785E-04
     +,   1.4457759E-04,   1.5745657E-04,   1.7155369E-04
     +,   1.8698550E-04,   2.0394906E-04,   2.2274182E-04
     +,   2.4376468E-04,   2.6751732E-04,   2.9460591E-04
     +,   3.2573851E-04,   3.6176521E-04,   4.0373145E-04
     +,   4.5296043E-04,   5.1113777E-04,   5.8033317E-04
     +,   6.6295586E-04,   7.6147885E-04,   8.7804388E-04
     +,   1.0138850E-03,   1.1687567E-03,   1.3405600E-03
     +,   1.5252959E-03,   1.7175901E-03,   1.9114027E-03
     +,   2.1009766E-03,   2.2813608E-03,   2.4484275E-03
     +,   2.5984191E-03,   2.7274140E-03,   2.8314383E-03
     +,   2.9073688E-03,   2.9546279E-03,   2.9766550E-03
     +,   2.9811487E-03,   2.9783971E-03,   2.9780322E-03
     +,   2.9854260E-03,   2.9993497E-03,   3.0119841E-03
     +,   3.0112877E-03,   2.9847824E-03,   2.9232516E-03
     +,   2.8233021E-03,   2.6881406E-03,   2.5267662E-03
     +,   2.3520417E-03,   2.1780722E-03,   2.0177136E-03
     +,   1.8803518E-03,   1.7707427E-03,   1.6888018E-03
     +,   1.6304473E-03,   1.5891570E-03,   1.5576532E-03
     +,   1.5294044E-03,   1.4995895E-03,   1.4655197E-03
     +,   1.4265946E-03,   1.3839111E-03,   1.3397196E-03
     +,   1.2967738E-03,   1.2577216E-03,   1.2245756E-03
     +,   1.1983395E-03,   1.1788536E-03,   1.1648431E-03
     +,   1.1541826E-03,   1.1442846E-03,   1.1325498E-03
     +,   1.1167892E-03,   1.0955306E-03,   1.0681954E-03
     +,   1.0350813E-03,   9.9723006E-04,   9.5615914E-04
     +,   9.1356650E-04,   8.7104458E-04,   8.2983408E-04
     +,   7.9070905E-04,   7.5392501E-04,   7.1928184E-04
     +,   6.8625133E-04,   6.5411872E-04,   6.2215707E-04
     +,   5.8973726E-04,   5.5643386E-04,   5.2205927E-04
     +,   4.8665531E-04,   4.5047162E-04,   4.1390274E-04
     +,   3.7743401E-04,   3.4157324E-04,   3.0680766E-04
     +,   2.7356533E-04,   2.4219218E-04,   2.1294644E-04
     +,   1.8599162E-04,   1.6140848E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wao_fus_90 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wao_fus_95(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   1.8383026E-38,   4.5105797E-38,   1.1008672E-37
     +,   2.6725641E-37,   6.4538435E-37,   1.5502178E-36
     +,   3.7039139E-36,   8.8041305E-36,   2.0813346E-35
     +,   4.8943900E-35,   1.1448268E-34,   2.6636410E-34
     +,   6.1645256E-34,   1.4191503E-33,   3.2496663E-33
     +,   7.4019138E-33,   1.6770628E-32,   3.7795482E-32
     +,   8.4727429E-32,   1.8893337E-31,   4.1906247E-31
     +,   9.2459091E-31,   2.0291137E-30,   4.4295452E-30
     +,   9.6184425E-30,   2.0775197E-29,   4.4636020E-29
     +,   9.5392520E-29,   2.0278935E-28,   4.2880854E-28
     +,   9.0193996E-28,   1.8870992E-27,   3.9273540E-27
     +,   8.1302509E-27,   1.6742041E-26,   3.4293004E-26
     +,   6.9871333E-26,   1.4160905E-25,   2.8548410E-25
     +,   5.7249357E-25,   1.1420166E-24,   2.2660000E-24
     +,   4.4724974E-24,   8.7809259E-24,   1.7148763E-23
     +,   3.3314880E-23,   6.4378011E-23,   1.2374795E-22
     +,   2.3661758E-22,   4.5004815E-22,   8.5150297E-22
     +,   1.6025185E-21,   3.0001899E-21,   5.5871818E-21
     +,   1.0350178E-20,   1.9072748E-20,   3.4961784E-20
     +,   6.3752180E-20,   1.1563887E-19,   2.0865462E-19
     +,   3.7451608E-19,   6.6870077E-19,   1.1877207E-18
     +,   2.0985465E-18,   3.6885539E-18,   6.4492414E-18
     +,   1.1217303E-17,   1.9408736E-17,   3.3406880E-17
     +,   5.7202537E-17,   9.7435854E-17,   1.6510458E-16
     +,   2.7831435E-16,   4.6671404E-16,   7.7860396E-16
     +,   1.2921339E-15,   2.1333448E-15,   3.5039015E-15
     +,   5.7252126E-15,   9.3063942E-15,   1.5049566E-14
     +,   2.4211852E-14,   3.8750070E-14,   6.1700753E-14
     +,   9.7737228E-14,   1.5402474E-13,   2.4148183E-13
     +,   3.7665398E-13,   5.8448591E-13,   9.0233138E-13
     +,   1.3858836E-12,   2.1176695E-12,   3.2192955E-12
     +,   4.8689607E-12,   7.3264268E-12,   1.0967715E-11
     +,   1.6334852E-11,   2.4204179E-11,   3.5681458E-11
     +,   5.2332614E-11,   7.6363547E-11,   1.1085916E-10
     +,   1.6011628E-10,   2.3007936E-10,   3.2892650E-10
     +,   4.6784110E-10,   6.6202815E-10,   9.3204888E-10
     +,   1.3054908E-09,   1.8192270E-09,   2.5221931E-09
     +,   3.4789465E-09,   4.7742033E-09,   6.5181136E-09
     +,   8.8538465E-09,   1.1965096E-08,   1.6087181E-08
     +,   2.1519346E-08,   2.8638533E-08,   3.7919694E-08
     +,   4.9952771E-08,   6.5469891E-08,   8.5371610E-08
     +,   1.1075890E-07,   1.4296988E-07,   1.8361311E-07
     +,   2.3462647E-07,   2.9830326E-07,   3.7736160E-07
     +,   4.7499256E-07,   5.9489776E-07,   7.4139331E-07
     +,   9.1940126E-07,   1.1345585E-06,   1.3932435E-06
     +,   1.7026280E-06,   2.0707316E-06,   2.5063810E-06
     +,   3.0194014E-06,   3.6203960E-06,   4.3209375E-06
     +,   5.1334600E-06,   6.0712441E-06,   7.1484137E-06
     +,   8.3796913E-06,   9.7805687E-06,   1.1367024E-05
     +,   1.3155426E-05,   1.5162444E-05,   1.7404451E-05
     +,   1.9898171E-05,   2.2659213E-05,   2.5702715E-05
     +,   2.9042547E-05,   3.2690987E-05,   3.6658523E-05
     +,   4.0952709E-05,   4.5579687E-05,   5.0541796E-05
     +,   5.5839537E-05,   6.1471372E-05,   6.7433677E-05
     +,   7.3724332E-05,   8.0340891E-05,   8.7286280E-05
     +,   9.4567149E-05,   1.0219705E-04,   1.1019901E-04
     +,   1.1860135E-04,   1.2744097E-04,   1.3675565E-04
     +,   1.4658441E-04,   1.5696438E-04,   1.6793216E-04
     +,   1.7954069E-04,   1.9187966E-04,   2.0512416E-04
     +,   2.1959371E-04,   2.3582166E-04,   2.5463439E-04
     +,   2.7720910E-04,   3.0514909E-04,   3.4058580E-04
     +,   3.8638513E-04,   4.4651222E-04,   5.2650931E-04
     +,   6.3394220E-04,   7.7827671E-04,   9.6982840E-04
     +,   1.2173721E-03,   1.5248773E-03,   1.8885765E-03
     +,   2.2959639E-03,   2.7282524E-03,   3.1653726E-03
     +,   3.5922925E-03,   4.0033739E-03,   4.4037746E-03
     +,   4.8079849E-03,   5.2344860E-03,   5.6934184E-03
     +,   6.1670765E-03,   6.5981392E-03,   6.9067138E-03
     +,   7.0394864E-03,   7.0179896E-03,   6.9397716E-03
     +,   6.9190175E-03,   7.0059360E-03,   7.1480884E-03
     +,   7.2262362E-03,   7.1376460E-03,   6.8630897E-03
     +,   6.4725480E-03,   6.0752938E-03,   5.7565044E-03
     +,   5.5411346E-03,   5.3998865E-03,   5.2837129E-03
     +,   5.1565892E-03,   5.0059333E-03,   4.8335283E-03
     +,   4.6450039E-03,   4.4478485E-03,   4.2527239E-03
     +,   4.0715830E-03,   3.9134473E-03,   3.7828570E-03
     +,   3.6811854E-03,   3.6072175E-03,   3.5553207E-03
     +,   3.5130649E-03,   3.4617255E-03,   3.3809186E-03
     +,   3.2557421E-03,   3.0828272E-03,   2.8718095E-03
     +,   2.6414052E-03,   2.4122528E-03,   2.2003264E-03
     +,   2.0138470E-03,   1.8539045E-03,   1.7174268E-03
     +,   1.5999711E-03,   1.4974338E-03,   1.4063257E-03
     +,   1.3234840E-03,   1.2458058E-03,   1.1702967E-03
     +,   1.0944750E-03,   1.0167365E-03,   9.3656901E-04
     +,   8.5450074E-04,   7.7177223E-04,   6.8999623E-04
     +,   6.1075005E-04,   5.3537445E-04,   4.6484353E-04
     +,   3.9975386E-04,   3.4041470E-04,   2.8691566E-04
     +,   2.3921058E-04,   1.9715189E-04,   1.6052298E-04
     +,   1.2904356E-04,   1.0237209E-04,   8.0114733E-05
     +,   6.1829989E-05,   4.7049187E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wao_fus_95 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wao_hz_100(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  1.0735009E-13,   1.3178724E-13
     +,   1.6160035E-13,   1.9792703E-13,   2.4213872E-13
     +,   2.9588343E-13,   3.6113679E-13,   4.4027087E-13
     +,   5.3612323E-13,   6.5208592E-13,   7.9221037E-13
     +,   9.6133388E-13,   1.1652048E-12,   1.4106726E-12
     +,   1.7058789E-12,   2.0604614E-12,   2.4858648E-12
     +,   2.9956215E-12,   3.6057225E-12,   4.3350367E-12
     +,   5.2058258E-12,   6.2443050E-12,   7.4812344E-12
     +,   8.9528315E-12,   1.0701421E-11,   1.2776705E-11
     +,   1.5236746E-11,   1.8149456E-11,   2.1593812E-11
     +,   2.5662122E-11,   3.0461481E-11,   3.6116436E-11
     +,   4.2771568E-11,   5.0594480E-11,   5.9778543E-11
     +,   7.0547859E-11,   8.3161054E-11,   9.7915280E-11
     +,   1.1515364E-10,   1.3527006E-10,   1.5871621E-10
     +,   1.8601054E-10,   2.1774541E-10,   2.5459881E-10
     +,   2.9734440E-10,   3.4686515E-10,   4.0416318E-10
     +,   4.7037990E-10,   5.4681187E-10,   6.3492417E-10
     +,   7.3638035E-10,   8.5306007E-10,   9.8707975E-10
     +,   1.1408318E-09,   1.3170023E-09,   1.5186125E-09
     +,   1.7490579E-09,   2.0121345E-09,   2.3121063E-09
     +,   2.6537041E-09,   3.0422524E-09,   3.4836352E-09
     +,   3.9844350E-09,   4.5519468E-09,   5.1942539E-09
     +,   5.9203220E-09,   6.7400707E-09,   7.6644158E-09
     +,   8.7054133E-09,   9.8763442E-09,   1.1191776E-08
     +,   1.2667707E-08,   1.4321719E-08,   1.6172855E-08
     +,   1.8242075E-08,   2.0552195E-08,   2.3128027E-08
     +,   2.5996631E-08,   2.9187024E-08,   3.2730981E-08
     +,   3.6662733E-08,   4.1019181E-08,   4.5840299E-08
     +,   5.1168293E-08,   5.7049860E-08,   6.3533534E-08
     +,   7.0672186E-08,   7.8521907E-08,   8.7142595E-08
     +,   9.6598150E-08,   1.0695544E-07,   1.1828627E-07
     +,   1.3066635E-07,   1.4417536E-07,   1.5889731E-07
     +,   1.7492046E-07,   1.9233804E-07,   2.1124542E-07
     +,   2.3174444E-07,   2.5394010E-07,   2.7794184E-07
     +,   3.0386408E-07,   3.3182212E-07,   3.6193777E-07
     +,   3.9433570E-07,   4.2914365E-07,   4.6649436E-07
     +,   5.0651698E-07,   5.4935396E-07,   5.9513945E-07
     +,   6.4401547E-07,   6.9612452E-07,   7.5160960E-07
     +,   8.1061802E-07,   8.7328732E-07,   9.3977292E-07
     +,   1.0102126E-06,   1.0847536E-06,   1.1635416E-06
     +,   1.2467200E-06,   1.3344359E-06,   1.4268256E-06
     +,   1.5240354E-06,   1.6262070E-06,   1.7334835E-06
     +,   1.8460079E-06,   1.9639299E-06,   2.0873879E-06
     +,   2.2165384E-06,   2.3515368E-06,   2.4925473E-06
     +,   2.6397415E-06,   2.7933088E-06,   2.9534351E-06
     +,   3.1203404E-06,   3.2942571E-06,   3.4754437E-06
     +,   3.6641857E-06,   3.8607991E-06,   4.0656450E-06
     +,   4.2791044E-06,   4.5016250E-06,   4.7337026E-06
     +,   4.9758878E-06,   5.2288092E-06,   5.4931206E-06
     +,   5.7696275E-06,   6.0591424E-06,   6.3626085E-06
     +,   6.6810667E-06,   7.0156025E-06,   7.3674987E-06
     +,   7.7380555E-06,   8.1287317E-06,   8.5410957E-06
     +,   8.9768273E-06,   9.4377410E-06,   9.9257013E-06
     +,   1.0442812E-05,   1.0991159E-05,   1.1573019E-05
     +,   1.2190779E-05,   1.2846831E-05,   1.3543839E-05
     +,   1.4284386E-05,   1.5071258E-05,   1.5907297E-05
     +,   1.6795457E-05,   1.7738828E-05,   1.8740471E-05
     +,   1.9803840E-05,   2.0932292E-05,   2.2129527E-05
     +,   2.3399431E-05,   2.4746167E-05,   2.6174279E-05
     +,   2.7688526E-05,   2.9294255E-05,   3.0997249E-05
     +,   3.2803811E-05,   3.4720910E-05,   3.6755806E-05
     +,   3.8916933E-05,   4.1212861E-05,   4.3653174E-05
     +,   4.6248169E-05,   4.9009112E-05,   5.1948584E-05
     +,   5.5080363E-05,   5.8421414E-05,   6.1991239E-05
     +,   6.5814784E-05,   6.9923924E-05,   7.4359741E-05
     +,   7.9177793E-05,   8.4450221E-05,   9.0274261E-05
     +,   9.6776232E-05,   1.0412026E-04,   1.1251902E-04
     +,   1.2223884E-04,   1.3361483E-04,   1.4705391E-04
     +,   1.6304728E-04,   1.8217426E-04,   2.0510081E-04
     +,   2.3258686E-04,   2.6546832E-04,   3.0465730E-04
     +,   3.5112503E-04,   4.0587221E-04,   4.6992031E-04
     +,   5.4423790E-04,   6.2970264E-04,   7.2702114E-04
     +,   8.3667907E-04,   9.5895428E-04,   1.0940250E-03
     +,   1.2423187E-03,   1.4048900E-03,   1.5839562E-03
     +,   1.7831903E-03,   2.0077284E-03,   2.2640524E-03
     +,   2.5604321E-03,   2.9091246E-03,   3.3297290E-03
     +,   3.8512200E-03,   4.5070155E-03,   5.3217737E-03
     +,   6.2980298E-03,   7.4165035E-03,   8.6534293E-03
     +,   9.9943513E-03,   1.1424880E-02,   1.2908990E-02
     +,   1.4401926E-02,   1.5905870E-02,   1.7474061E-02
     +,   1.9084556E-02,   2.0555923E-02,   2.1792719E-02
     +,   2.3129003E-02,   2.5072426E-02,   2.7553765E-02
     +,   2.9731954E-02,   3.0740082E-02,   3.0686324E-02
     +,   3.0748179E-02,   3.1935979E-02,   3.3895481E-02
     +,   3.5169665E-02,   3.4863263E-02,   3.3739042E-02
     +,   3.2803994E-02,   3.2021750E-02,   3.1333558E-02
     +,   3.0897820E-02,   3.0104529E-02,   2.8069399E-02
     +,   2.4917705E-02,   2.1720365E-02,   1.9426551E-02
     +,   1.8196097E-02,   1.7554430E-02,   1.6929833E-02
     +,   1.6056828E-02,   1.5012893E-02,   1.3994168E-02
     +,   1.3110001E-02,   1.2352195E-02,   1.1678718E-02
     +,   1.1077545E-02,   1.0554945E-02,   1.0095339E-02
     +,   9.6531324E-03,   9.1808122E-03,   8.6545479E-03
     +,   8.0753053E-03,   7.4549713E-03,   6.8057431E-03
     +,   6.1399620E-03,   5.4734764E-03,   4.8266188E-03
     +,   4.2208461E-03,   3.6731951E-03,   3.1926709E-03
     +,   2.7789460E-03,   2.4245481E-03,   2.1181752E-03
     +,   1.8481946E-03,   1.6053081E-03,   1.3836311E-03
     +,   1.1806096E-03,   9.9602854E-04,   8.3082251E-04
     +,   6.8597065E-04,   5.6178076E-04,   4.5760593E-04
     +,   3.7187251E-04,   3.0235859E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wao_hz_100 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wao_hz_105(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  2.6694269E-15,   3.3862607E-15
     +,   4.2902087E-15,   5.4286130E-15,   6.8604612E-15
     +,   8.6591136E-15,   1.0915525E-14,   1.3742667E-14
     +,   1.7280355E-14,   2.1701377E-14,   2.7219155E-14
     +,   3.4097176E-14,   4.2659391E-14,   5.3304658E-14
     +,   6.6522830E-14,   8.2914320E-14,   1.0321476E-13
     +,   1.2832461E-13,   1.5934216E-13,   1.9760846E-13
     +,   2.4475682E-13,   3.0277495E-13,   3.7407355E-13
     +,   4.6158400E-13,   5.6884825E-13,   7.0015982E-13
     +,   8.6069953E-13,   1.0567249E-12,   1.2957622E-12
     +,   1.5868797E-12,   1.9409550E-12,   2.3710558E-12
     +,   2.8928231E-12,   3.5249943E-12,   4.2899035E-12
     +,   5.2142383E-12,   6.3298104E-12,   7.6743733E-12
     +,   9.2928590E-12,   1.1238602E-11,   1.3574622E-11
     +,   1.6375684E-11,   1.9729844E-11,   2.3741205E-11
     +,   2.8532244E-11,   3.4247265E-11,   4.1055180E-11
     +,   4.9154698E-11,   5.8778475E-11,   7.0197868E-11
     +,   8.3730696E-11,   9.9747301E-11,   1.1867821E-10
     +,   1.4102508E-10,   1.6736915E-10,   1.9838498E-10
     +,   2.3485341E-10,   2.7767663E-10,   3.2789735E-10
     +,   3.8671391E-10,   4.5550949E-10,   5.3586885E-10
     +,   6.2961392E-10,   7.3883227E-10,   8.6590607E-10
     +,   1.0135622E-09,   1.1849109E-09,   1.3834862E-09
     +,   1.6133118E-09,   1.8789559E-09,   2.1855922E-09
     +,   2.5390843E-09,   2.9460614E-09,   3.4139600E-09
     +,   3.9512114E-09,   4.5672657E-09,   5.2727502E-09
     +,   6.0796030E-09,   7.0010868E-09,   8.0521234E-09
     +,   9.2493257E-09,   1.0611200E-08,   1.2158378E-08
     +,   1.3913526E-08,   1.5902225E-08,   1.8152265E-08
     +,   2.0694689E-08,   2.3563576E-08,   2.6796519E-08
     +,   3.0434926E-08,   3.4523822E-08,   3.9112894E-08
     +,   4.4256378E-08,   5.0013387E-08,   5.6448382E-08
     +,   6.3631397E-08,   7.1638731E-08,   8.0552134E-08
     +,   9.0460880E-08,   1.0146105E-07,   1.1365606E-07
     +,   1.2715751E-07,   1.4208376E-07,   1.5856287E-07
     +,   1.7673111E-07,   1.9673389E-07,   2.1872671E-07
     +,   2.4287095E-07,   2.6934401E-07,   2.9832654E-07
     +,   3.3001308E-07,   3.6460690E-07,   4.0232158E-07
     +,   4.4338168E-07,   4.8801564E-07,   5.3647233E-07
     +,   5.8899820E-07,   6.4585510E-07,   7.0731176E-07
     +,   7.7364405E-07,   8.4513795E-07,   9.2207682E-07
     +,   1.0047576E-06,   1.0934784E-06,   1.1885401E-06
     +,   1.2902451E-06,   1.3989011E-06,   1.5148007E-06
     +,   1.6382464E-06,   1.7695317E-06,   1.9089443E-06
     +,   2.0567625E-06,   2.2132622E-06,   2.3786872E-06
     +,   2.5532875E-06,   2.7372892E-06,   2.9309031E-06
     +,   3.1343202E-06,   3.3477120E-06,   3.5712392E-06
     +,   3.8050136E-06,   4.0491545E-06,   4.3037512E-06
     +,   4.5688776E-06,   4.8446063E-06,   5.1309553E-06
     +,   5.4280167E-06,   5.7358152E-06,   6.0544380E-06
     +,   6.3840084E-06,   6.7246465E-06,   7.0766441E-06
     +,   7.4402951E-06,   7.8160865E-06,   8.2046636E-06
     +,   8.6068912E-06,   9.0239191E-06,   9.4571724E-06
     +,   9.9085883E-06,   1.0380472E-05,   1.0875763E-05
     +,   1.1398079E-05,   1.1951714E-05,   1.2541994E-05
     +,   1.3175091E-05,   1.3858387E-05,   1.4600461E-05
     +,   1.5411248E-05,   1.6302154E-05,   1.7285984E-05
     +,   1.8377388E-05,   1.9592377E-05,   2.0948732E-05
     +,   2.2465771E-05,   2.4164261E-05,   2.6066326E-05
     +,   2.8194925E-05,   3.0573949E-05,   3.3227570E-05
     +,   3.6179845E-05,   3.9454291E-05,   4.3072676E-05
     +,   4.7055808E-05,   5.1420942E-05,   5.6182693E-05
     +,   6.1351617E-05,   6.6933746E-05,   7.2930365E-05
     +,   7.9336300E-05,   8.6142492E-05,   9.3332332E-05
     +,   1.0088475E-04,   1.0877357E-04,   1.1696718E-04
     +,   1.2543278E-04,   1.3413328E-04,   1.4303412E-04
     +,   1.5210106E-04,   1.6130459E-04,   1.7062525E-04
     +,   1.8005235E-04,   1.8959402E-04,   1.9927672E-04
     +,   2.0915545E-04,   2.1931948E-04,   2.2989964E-04
     +,   2.4108353E-04,   2.5312253E-04,   2.6635156E-04
     +,   2.8120429E-04,   2.9822864E-04,   3.1811124E-04
     +,   3.4168275E-04,   3.6993399E-04,   4.0400971E-04
     +,   4.4519332E-04,   4.9487164E-04,   5.5446284E-04
     +,   6.2535354E-04,   7.0875545E-04,   8.0559595E-04
     +,   9.1636454E-04,   1.0409725E-03,   1.1786362E-03
     +,   1.3277712E-03,   1.4860356E-03,   1.6503162E-03
     +,   1.8169702E-03,   1.9821092E-03,   2.1420813E-03
     +,   2.2941225E-03,   2.4371515E-03,   2.5727644E-03
     +,   2.7060900E-03,   2.8464985E-03,   3.0076194E-03
     +,   3.2062146E-03,   3.4595430E-03,   3.7811948E-03
     +,   4.1765645E-03,   4.6400474E-03,   5.1566786E-03
     +,   5.7092952E-03,   6.2877624E-03,   6.8930555E-03
     +,   7.5276503E-03,   8.1753461E-03,   8.7853977E-03
     +,   9.2823105E-03,   9.6066818E-03,   9.7647691E-03
     +,   9.8517062E-03,   1.0027648E-02,   1.0459219E-02
     +,   1.1262481E-02,   1.2481213E-02,   1.4107157E-02
     +,   1.6102489E-02,   1.8365871E-02,   2.0670336E-02
     +,   2.2764042E-02,   2.4640134E-02,   2.6528908E-02
     +,   2.8498894E-02,   3.0303825E-02,   3.1782519E-02
     +,   3.3178259E-02,   3.4974083E-02,   3.7515406E-02
     +,   4.0126149E-02,   4.1103367E-02,   4.0282324E-02
     +,   3.9999865E-02,   4.1709963E-02,   4.3798968E-02
     +,   4.4079769E-02,   4.2039182E-02,   3.8480669E-02
     +,   3.4936029E-02,   3.2489136E-02,   3.0906092E-02
     +,   2.9431790E-02,   2.7645884E-02,   2.5341535E-02
     +,   2.2452468E-02,   1.9424612E-02,   1.7021041E-02
     +,   1.5544652E-02,   1.4582943E-02,   1.3509036E-02
     +,   1.2013331E-02,   1.0185264E-02,   8.2889935E-03
     +,   6.5479456E-03,   5.0680134E-03,   3.8619780E-03
     +,   2.8987480E-03,   2.1378321E-03,   1.5439126E-03
     +,   1.0888207E-03,   7.4913114E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wao_hz_105 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wao_hz_107(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  6.1949224E-11,   7.2457713E-11
     +,   8.4660549E-11,   9.8814831E-11,   1.1521518E-10
     +,   1.3419738E-10,   1.5614343E-10,   1.8148864E-10
     +,   2.1072838E-10,   2.4442268E-10,   2.8320873E-10
     +,   3.2780750E-10,   3.7903267E-10,   4.3780540E-10
     +,   5.0516452E-10,   5.8227828E-10,   6.7046246E-10
     +,   7.7119916E-10,   8.8614327E-10,   1.0171582E-09
     +,   1.1663256E-09,   1.3359774E-09,   1.5287063E-09
     +,   1.7474194E-09,   1.9953399E-09,   2.2760580E-09
     +,   2.5935685E-09,   2.9522964E-09,   3.3571359E-09
     +,   3.8135206E-09,   4.3274340E-09,   4.9054880E-09
     +,   5.5549694E-09,   6.2839156E-09,   7.1011064E-09
     +,   8.0162250E-09,   9.0398897E-09,   1.0183661E-08
     +,   1.1460225E-08,   1.2883446E-08,   1.4468343E-08
     +,   1.6231384E-08,   1.8190327E-08,   2.0364553E-08
     +,   2.2775010E-08,   2.5444436E-08,   2.8397245E-08
     +,   3.1659905E-08,   3.5260957E-08,   3.9230891E-08
     +,   4.3602668E-08,   4.8411618E-08,   5.3695324E-08
     +,   5.9494315E-08,   6.5851488E-08,   7.2812760E-08
     +,   8.0426936E-08,   8.8745914E-08,   9.7824717E-08
     +,   1.0772126E-07,   1.1849730E-07,   1.3021730E-07
     +,   1.4294967E-07,   1.5676648E-07,   1.7174241E-07
     +,   1.8795645E-07,   2.0549140E-07,   2.2443260E-07
     +,   2.4486960E-07,   2.6689568E-07,   2.9060701E-07
     +,   3.1610341E-07,   3.4348906E-07,   3.7286785E-07
     +,   4.0434989E-07,   4.3804724E-07,   4.7407406E-07
     +,   5.1254904E-07,   5.5358805E-07,   5.9731298E-07
     +,   6.4384659E-07,   6.9331185E-07,   7.4583505E-07
     +,   8.0153501E-07,   8.6054422E-07,   9.2298086E-07
     +,   9.8897033E-07,   1.0586341E-06,   1.1320925E-06
     +,   1.2094664E-06,   1.2908639E-06,   1.3763997E-06
     +,   1.4661812E-06,   1.5603105E-06,   1.6588856E-06
     +,   1.7619982E-06,   1.8697382E-06,   1.9821775E-06
     +,   2.0993909E-06,   2.2214435E-06,   2.3483910E-06
     +,   2.4802866E-06,   2.6171581E-06,   2.7590411E-06
     +,   2.9059538E-06,   3.0579076E-06,   3.2149076E-06
     +,   3.3769252E-06,   3.5439648E-06,   3.7159762E-06
     +,   3.8929252E-06,   4.0747595E-06,   4.2614183E-06
     +,   4.4528369E-06,   4.6489140E-06,   4.8495881E-06
     +,   5.0547401E-06,   5.2642704E-06,   5.4780667E-06
     +,   5.6960080E-06,   5.9179765E-06,   6.1438272E-06
     +,   6.3734328E-06,   6.6066559E-06,   6.8433578E-06
     +,   7.0833999E-06,   7.3266538E-06,   7.5729636E-06
     +,   7.8222101E-06,   8.0742639E-06,   8.3290088E-06
     +,   8.5863358E-06,   8.8461557E-06,   9.1083675E-06
     +,   9.3729141E-06,   9.6397434E-06,   9.9088329E-06
     +,   1.0180177E-05,   1.0453805E-05,   1.0729783E-05
     +,   1.1008184E-05,   1.1289150E-05,   1.1572859E-05
     +,   1.1859537E-05,   1.2149476E-05,   1.2442982E-05
     +,   1.2740506E-05,   1.3042491E-05,   1.3349503E-05
     +,   1.3662197E-05,   1.3981268E-05,   1.4307603E-05
     +,   1.4642098E-05,   1.4985817E-05,   1.5339936E-05
     +,   1.5705757E-05,   1.6084725E-05,   1.6478372E-05
     +,   1.6888469E-05,   1.7316839E-05,   1.7765513E-05
     +,   1.8236671E-05,   1.8732573E-05,   1.9255762E-05
     +,   1.9808780E-05,   2.0394402E-05,   2.1015496E-05
     +,   2.1675056E-05,   2.2376211E-05,   2.3122062E-05
     +,   2.3915998E-05,   2.4761250E-05,   2.5661213E-05
     +,   2.6619276E-05,   2.7638831E-05,   2.8723302E-05
     +,   2.9875971E-05,   3.1100204E-05,   3.2399297E-05
     +,   3.3776530E-05,   3.5235200E-05,   3.6778441E-05
     +,   3.8409780E-05,   4.0132501E-05,   4.1950243E-05
     +,   4.3866905E-05,   4.5886754E-05,   4.8014637E-05
     +,   5.0255763E-05,   5.2616779E-05,   5.5104796E-05
     +,   5.7728594E-05,   6.0498543E-05,   6.3426480E-05
     +,   6.6527231E-05,   6.9817368E-05,   7.3317475E-05
     +,   7.7051045E-05,   8.1045706E-05,   8.5334927E-05
     +,   8.9956840E-05,   9.4957752E-05,   1.0039101E-04
     +,   1.0632056E-04,   1.1282234E-04,   1.1998565E-04
     +,   1.2791919E-04,   1.3675079E-04,   1.4663476E-04
     +,   1.5775570E-04,   1.7033132E-04,   1.8462210E-04
     +,   2.0092796E-04,   2.1959483E-04,   2.4100966E-04
     +,   2.6559384E-04,   2.9379086E-04,   3.2604011E-04
     +,   3.6276475E-04,   4.0432313E-04,   4.5099348E-04
     +,   5.0294201E-04,   5.6021358E-04,   6.2274380E-04
     +,   6.9039216E-04,   7.6305220E-04,   8.4074977E-04
     +,   9.2385191E-04,   1.0132666E-03,   1.1106599E-03
     +,   1.2186292E-03,   1.3407315E-03,   1.4814206E-03
     +,   1.6456813E-03,   1.8386407E-03,   2.0650299E-03
     +,   2.3286745E-03,   2.6319544E-03,   2.9750287E-03
     +,   3.3549173E-03,   3.7644112E-03,   4.1917292E-03
     +,   4.6219556E-03,   5.0407802E-03,   5.4399814E-03
     +,   5.8211568E-03,   6.1949687E-03,   6.5735560E-03
     +,   6.9590341E-03,   7.3351832E-03,   7.6696109E-03
     +,   7.9296939E-03,   8.1049763E-03,   8.2227159E-03
     +,   8.3438810E-03,   8.5395472E-03,   8.8635376E-03
     +,   9.3413135E-03,   9.9840183E-03,   1.0808240E-02
     +,   1.1825226E-02,   1.2988254E-02,   1.4153652E-02
     +,   1.5143949E-02,   1.5888965E-02,   1.6473167E-02
     +,   1.6998006E-02,   1.7458156E-02,   1.7853135E-02
     +,   1.8380785E-02,   1.9409193E-02,   2.1204129E-02
     +,   2.3622429E-02,   2.6118752E-02,   2.8228031E-02
     +,   3.0064764E-02,   3.2287434E-02,   3.5333235E-02
     +,   3.8727283E-02,   4.1784197E-02,   4.4316493E-02
     +,   4.5866426E-02,   4.5362581E-02,   4.2639960E-02
     +,   3.9659448E-02,   3.8026486E-02,   3.7143972E-02
     +,   3.6061164E-02,   3.4118865E-02,   3.0666232E-02
     +,   2.5995458E-02,   2.1329856E-02,   1.7458862E-02
     +,   1.4212668E-02,   1.1157658E-02,   8.2207071E-03
     +,   5.6324787E-03,   3.6045650E-03,   2.1785169E-03
     +,   1.2628098E-03,   7.1676285E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wao_hz_107 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wao_hz_110(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  3.4253485E-15,   4.5288243E-15
     +,   5.9775822E-15,   7.8763383E-15,   1.0360613E-14
     +,   1.3605441E-14,   1.7836225E-14,   2.3343330E-14
     +,   3.0499681E-14,   3.9783108E-14,   5.1805653E-14
     +,   6.7349955E-14,   8.7412845E-14,   1.1326513E-13
     +,   1.4652319E-13,   1.8923589E-13,   2.4400195E-13
     +,   3.1410904E-13,   4.0370471E-13,   5.1802318E-13
     +,   6.6365105E-13,   8.4886872E-13,   1.0840535E-12
     +,   1.3822213E-12,   1.7596301E-12,   2.2365948E-12
     +,   2.8384283E-12,   3.5966594E-12,   4.5504182E-12
     +,   5.7483133E-12,   7.2504737E-12,   9.1313380E-12
     +,   1.1482800E-11,   1.4418215E-11,   1.8076929E-11
     +,   2.2630373E-11,   2.8288974E-11,   3.5310199E-11
     +,   4.4009432E-11,   5.4771677E-11,   6.8066074E-11
     +,   8.4464540E-11,   1.0466110E-10,   1.2949923E-10
     +,   1.5999969E-10,   1.9739925E-10,   2.4318778E-10
     +,   2.9916458E-10,   3.6749614E-10,   4.5077977E-10
     +,   5.5213700E-10,   6.7530470E-10,   8.2474366E-10
     +,   1.0057859E-09,   1.2247674E-09,   1.4892332E-09
     +,   1.8081296E-09,   2.1920543E-09,   2.6535383E-09
     +,   3.2073428E-09,   3.8708778E-09,   4.6645647E-09
     +,   5.6123732E-09,   6.7423587E-09,   8.0872260E-09
     +,   9.6851327E-09,   1.1580449E-08,   1.3824539E-08
     +,   1.6476925E-08,   1.9606331E-08,   2.3291889E-08
     +,   2.7624512E-08,   3.2708648E-08,   3.8663064E-08
     +,   4.5623835E-08,   5.3745513E-08,   6.3203522E-08
     +,   7.4196699E-08,   8.6948070E-08,   1.0170995E-07
     +,   1.1876493E-07,   1.3842916E-07,   1.6105619E-07
     +,   1.8703543E-07,   2.1680539E-07,   2.5084324E-07
     +,   2.8967898E-07,   3.3389330E-07,   3.8412125E-07
     +,   4.4105758E-07,   5.0544980E-07,   5.7811377E-07
     +,   6.5992629E-07,   7.5182891E-07,   8.5482793E-07
     +,   9.6999486E-07,   1.0984694E-06,   1.2414396E-06
     +,   1.4001664E-06,   1.5759609E-06,   1.7701848E-06
     +,   1.9842512E-06,   2.2195850E-06,   2.4776614E-06
     +,   2.7599615E-06,   3.0679737E-06,   3.4031875E-06
     +,   3.7670131E-06,   4.1609151E-06,   4.5862002E-06
     +,   5.0441536E-06,   5.5359437E-06,   6.0626239E-06
     +,   6.6251218E-06,   7.2241146E-06,   7.8602488E-06
     +,   8.5337997E-06,   9.2449054E-06,   9.9934232E-06
     +,   1.0778942E-05,   1.1600788E-05,   1.2457886E-05
     +,   1.3348931E-05,   1.4272252E-05,   1.5225841E-05
     +,   1.6207337E-05,   1.7214077E-05,   1.8242932E-05
     +,   1.9290552E-05,   2.0353229E-05,   2.1426935E-05
     +,   2.2507371E-05,   2.3590006E-05,   2.4669955E-05
     +,   2.5742262E-05,   2.6801779E-05,   2.7843227E-05
     +,   2.8861275E-05,   2.9850560E-05,   3.0805793E-05
     +,   3.1721658E-05,   3.2593078E-05,   3.3415145E-05
     +,   3.4183184E-05,   3.4892852E-05,   3.5540063E-05
     +,   3.6121281E-05,   3.6633268E-05,   3.7073372E-05
     +,   3.7439437E-05,   3.7729838E-05,   3.7943599E-05
     +,   3.8080303E-05,   3.8140184E-05,   3.8124104E-05
     +,   3.8033591E-05,   3.7870777E-05,   3.7638474E-05
     +,   3.7340040E-05,   3.6979516E-05,   3.6561465E-05
     +,   3.6090987E-05,   3.5573754E-05,   3.5015779E-05
     +,   3.4423636E-05,   3.3804190E-05,   3.3164662E-05
     +,   3.2512537E-05,   3.1855514E-05,   3.1201536E-05
     +,   3.0558524E-05,   2.9934617E-05,   2.9337893E-05
     +,   2.8776398E-05,   2.8258140E-05,   2.7790988E-05
     +,   2.7382719E-05,   2.7040896E-05,   2.6772910E-05
     +,   2.6585963E-05,   2.6487058E-05,   2.6483025E-05
     +,   2.6580521E-05,   2.6786078E-05,   2.7106164E-05
     +,   2.7547232E-05,   2.8115834E-05,   2.8818711E-05
     +,   2.9662786E-05,   3.0655643E-05,   3.1805201E-05
     +,   3.3120265E-05,   3.4610570E-05,   3.6286714E-05
     +,   3.8160957E-05,   4.0246439E-05,   4.2558397E-05
     +,   4.5113251E-05,   4.7928992E-05,   5.1025898E-05
     +,   5.4424865E-05,   5.8149162E-05,   6.2222214E-05
     +,   6.6668756E-05,   7.1513954E-05,   7.6782089E-05
     +,   8.2498314E-05,   8.8685367E-05,   9.5365649E-05
     +,   1.0256027E-04,   1.1028817E-04,   1.1857007E-04
     +,   1.2742553E-04,   1.3687885E-04,   1.4696078E-04
     +,   1.5771406E-04,   1.6920084E-04,   1.8151005E-04
     +,   1.9477535E-04,   2.0918559E-04,   2.2501174E-04
     +,   2.4263287E-04,   2.6257004E-04,   2.8552732E-04
     +,   3.1243084E-04,   3.4448100E-04,   3.8317038E-04
     +,   4.3030435E-04,   4.8796204E-04,   5.5840350E-04
     +,   6.4389670E-04,   7.4643287E-04,   8.6741580E-04
     +,   1.0072152E-03,   1.1648511E-03,   1.3377616E-03
     +,   1.5218768E-03,   1.7120669E-03,   1.9029571E-03
     +,   2.0900934E-03,   2.2710601E-03,   2.4462864E-03
     +,   2.6191450E-03,   2.7950844E-03,   2.9799938E-03
     +,   3.1778589E-03,   3.3886903E-03,   3.6071495E-03
     +,   3.8226428E-03,   4.0213172E-03,   4.1895928E-03
     +,   4.3191281E-03,   4.4118157E-03,   4.4837072E-03
     +,   4.5657819E-03,   4.6993350E-03,   4.9251616E-03
     +,   5.2681677E-03,   5.7239062E-03,   6.2552206E-03
     +,   6.8045296E-03,   7.3190001E-03,   7.7763312E-03
     +,   8.1984969E-03,   8.6450595E-03,   9.1854408E-03
     +,   9.8555442E-03,   1.0616827E-02,   1.1352289E-02
     +,   1.1922816E-02,   1.2256213E-02,   1.2392990E-02
     +,   1.2436322E-02,   1.2450639E-02,   1.2431563E-02
     +,   1.2409453E-02,   1.2557852E-02,   1.3109169E-02
     +,   1.4124529E-02,   1.5436842E-02,   1.6908454E-02
     +,   1.8647639E-02,   2.0747878E-02,   2.2782193E-02
     +,   2.3939397E-02,   2.3973402E-02,   2.3651717E-02
     +,   2.3917938E-02,   2.4967421E-02,   2.6281266E-02
     +,   2.7202317E-02,   2.7434127E-02,   2.6992504E-02
     +,   2.5728326E-02,   2.3338879E-02,   1.9833738E-02
     +,   1.5637146E-02,   1.1339906E-02,   7.4961432E-03
     +,   4.4874288E-03,   2.4296406E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wao_hz_110 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wao_hz_115(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  3.7475218E-12,   4.5465793E-12
     +,   5.5091348E-12,   6.6670905E-12,   8.0583387E-12
     +,   9.7277525E-12,   1.1728298E-11,   1.4122576E-11
     +,   1.6984416E-11,   2.0400591E-11,   2.4473272E-11
     +,   2.9322426E-11,   3.5088397E-11,   4.1935691E-11
     +,   5.0056900E-11,   5.9675952E-11,   7.1054683E-11
     +,   8.4497805E-11,   1.0035864E-10,   1.1904798E-10
     +,   1.4104180E-10,   1.6689095E-10,   1.9723129E-10
     +,   2.3279792E-10,   2.7443472E-10,   3.2311634E-10
     +,   3.7996004E-10,   4.4624932E-10,   5.2345095E-10
     +,   6.1324684E-10,   7.1755274E-10,   8.3855695E-10
     +,   9.7874997E-10,   1.1409673E-09,   1.3284167E-09
     +,   1.5447441E-09,   1.7940804E-09,   2.0810744E-09
     +,   2.4109914E-09,   2.7897622E-09,   3.2240361E-09
     +,   3.7213168E-09,   4.2899861E-09,   4.9394515E-09
     +,   5.6802185E-09,   6.5240435E-09,   7.4839708E-09
     +,   8.5745668E-09,   9.8120294E-09,   1.1214238E-08
     +,   1.2801089E-08,   1.4594574E-08,   1.6618880E-08
     +,   1.8900812E-08,   2.1469679E-08,   2.4357858E-08
     +,   2.7600764E-08,   3.1237207E-08,   3.5309679E-08
     +,   3.9864322E-08,   4.4951754E-08,   5.0626628E-08
     +,   5.6948618E-08,   6.3982355E-08,   7.1797530E-08
     +,   8.0469640E-08,   9.0080235E-08,   1.0071651E-07
     +,   1.1247278E-07,   1.2544983E-07,   1.3975567E-07
     +,   1.5550569E-07,   1.7282362E-07,   1.9183891E-07
     +,   2.1269157E-07,   2.3552900E-07,   2.6050728E-07
     +,   2.8779226E-07,   3.1755562E-07,   3.4998101E-07
     +,   3.8526011E-07,   4.2359366E-07,   4.6519295E-07
     +,   5.1027183E-07,   5.5906452E-07,   6.1180185E-07
     +,   6.6872963E-07,   7.3010034E-07,   7.9617371E-07
     +,   8.6721911E-07,   9.4350497E-07,   1.0253129E-06
     +,   1.1129277E-06,   1.2066378E-06,   1.3067361E-06
     +,   1.4135164E-06,   1.5272802E-06,   1.6483164E-06
     +,   1.7769239E-06,   1.9133972E-06,   2.0580276E-06
     +,   2.2111064E-06,   2.3729012E-06,   2.5436905E-06
     +,   2.7237361E-06,   2.9132905E-06,   3.1125999E-06
     +,   3.3218669E-06,   3.5413311E-06,   3.7711620E-06
     +,   4.0115387E-06,   4.2626134E-06,   4.5245147E-06
     +,   4.7973604E-06,   5.0811955E-06,   5.3761187E-06
     +,   5.6821186E-06,   5.9992035E-06,   6.3273337E-06
     +,   6.6664415E-06,   7.0164401E-06,   7.3771648E-06
     +,   7.7484592E-06,   8.1301187E-06,   8.5219008E-06
     +,   8.9235245E-06,   9.3346980E-06,   9.7550364E-06
     +,   1.0184171E-05,   1.0621681E-05,   1.1067113E-05
     +,   1.1519976E-05,   1.1979766E-05,   1.2445897E-05
     +,   1.2917803E-05,   1.3394872E-05,   1.3876467E-05
     +,   1.4361929E-05,   1.4850573E-05,   1.5341717E-05
     +,   1.5834605E-05,   1.6328520E-05,   1.6822727E-05
     +,   1.7316472E-05,   1.7809023E-05,   1.8299575E-05
     +,   1.8787450E-05,   1.9271856E-05,   1.9752086E-05
     +,   2.0227442E-05,   2.0697196E-05,   2.1160744E-05
     +,   2.1617407E-05,   2.2066608E-05,   2.2507784E-05
     +,   2.2940420E-05,   2.3364069E-05,   2.3778270E-05
     +,   2.4182720E-05,   2.4577084E-05,   2.4961133E-05
     +,   2.5334710E-05,   2.5697678E-05,   2.6050049E-05
     +,   2.6391830E-05,   2.6723153E-05,   2.7044194E-05
     +,   2.7355230E-05,   2.7656615E-05,   2.7948732E-05
     +,   2.8232140E-05,   2.8507384E-05,   2.8775154E-05
     +,   2.9036217E-05,   2.9291443E-05,   2.9541819E-05
     +,   2.9788422E-05,   3.0032521E-05,   3.0275532E-05
     +,   3.0519055E-05,   3.0764972E-05,   3.1015385E-05
     +,   3.1272823E-05,   3.1540152E-05,   3.1820793E-05
     +,   3.2118736E-05,   3.2438686E-05,   3.2786204E-05
     +,   3.3167773E-05,   3.3591132E-05,   3.4065226E-05
     +,   3.4600584E-05,   3.5209479E-05,   3.5906007E-05
     +,   3.6706628E-05,   3.7629972E-05,   3.8697577E-05
     +,   3.9933620E-05,   4.1365332E-05,   4.3023549E-05
     +,   4.4942080E-05,   4.7158832E-05,   4.9714836E-05
     +,   5.2655003E-05,   5.6027751E-05,   5.9884118E-05
     +,   6.4278865E-05,   6.9267851E-05,   7.4908909E-05
     +,   8.1260572E-05,   8.8380104E-05,   9.6325857E-05
     +,   1.0515349E-04,   1.1491997E-04,   1.2568475E-04
     +,   1.3751435E-04,   1.5049010E-04,   1.6471549E-04
     +,   1.8033490E-04,   1.9754141E-04,   2.1659925E-04
     +,   2.3785656E-04,   2.6175770E-04,   2.8884920E-04
     +,   3.1976923E-04,   3.5524394E-04,   3.9604379E-04
     +,   4.4296426E-04,   4.9678230E-04,   5.5822934E-04
     +,   6.2797021E-04,   7.0657424E-04,   7.9452287E-04
     +,   8.9212658E-04,   9.9948200E-04,   1.1163562E-03
     +,   1.2421159E-03,   1.3757595E-03,   1.5161178E-03
     +,   1.6623182E-03,   1.8143033E-03,   1.9731901E-03
     +,   2.1410810E-03,   2.3200668E-03,   2.5107516E-03
     +,   2.7107182E-03,   2.9142005E-03,   3.1132184E-03
     +,   3.2999411E-03,   3.4691161E-03,   3.6188515E-03
     +,   3.7495727E-03,   3.8618178E-03,   3.9552357E-03
     +,   4.0304917E-03,   4.0936582E-03,   4.1602179E-03
     +,   4.2540384E-03,   4.3994123E-03,   4.6086381E-03
     +,   4.8717787E-03,   5.1551792E-03,   5.4107718E-03
     +,   5.5947099E-03,   5.6893625E-03,   5.7194396E-03
     +,   5.7503763E-03,   5.8624661E-03,   6.1096894E-03
     +,   6.4884615E-03,   6.9413399E-03,   7.3968042E-03
     +,   7.8131054E-03,   8.1860889E-03,   8.5146166E-03
     +,   8.7674912E-03,   8.8995192E-03,   8.9086480E-03
     +,   8.8635106E-03,   8.8513587E-03,   8.8901864E-03
     +,   8.9037027E-03,   8.7900190E-03,   8.5105700E-03
     +,   8.1146387E-03,   7.6934150E-03,   7.3178383E-03
     +,   7.0041069E-03,   6.7169010E-03,   6.3981195E-03
     +,   6.0026874E-03,   5.5204025E-03,   4.9717459E-03
     +,   4.3866145E-03,   3.7865185E-03,   3.1834680E-03
     +,   2.5899634E-03,   2.0264555E-03,   1.5189978E-03
     +,   1.0900709E-03,   7.5080351E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wao_hz_115 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wao_hz_120(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  1.5836545E-16,   2.1063130E-16
     +,   2.7969391E-16,   3.7079722E-16,   4.9077888E-16
     +,   6.4853528E-16,   8.5560624E-16,   1.1269685E-15
     +,   1.4819913E-15,   1.9456902E-15,   2.5503374E-15
     +,   3.3374775E-15,   4.3604778E-15,   5.6878085E-15
     +,   7.4072015E-15,   9.6306765E-15,   1.2501280E-14
     +,   1.6201326E-14,   2.0962354E-14,   2.7078559E-14
     +,   3.4922552E-14,   4.4966059E-14,   5.7804002E-14
     +,   7.4187001E-14,   9.5058706E-14,   1.2160490E-13
     +,   1.5531269E-13,   1.9804304E-13,   2.5211999E-13
     +,   3.2044305E-13,   4.0662078E-13,   5.1513866E-13
     +,   6.5155905E-13,   8.2277485E-13,   1.0372955E-12
     +,   1.3056264E-12,   1.6407161E-12,   2.0584569E-12
     +,   2.5783746E-12,   3.2243917E-12,   4.0257147E-12
     +,   5.0180684E-12,   6.2448731E-12,   7.7590061E-12
     +,   9.6246396E-12,   1.1919577E-11,   1.4737732E-11
     +,   1.8192647E-11,   2.2421238E-11,   2.7587772E-11
     +,   3.3889783E-11,   4.1564190E-11,   5.0893716E-11
     +,   6.2216510E-11,   7.5934821E-11,   9.2527888E-11
     +,   1.1256397E-10,   1.3671697E-10,   1.6578401E-10
     +,   2.0070466E-10,   2.4258784E-10,   2.9273486E-10
     +,   3.5267622E-10,   4.2420467E-10,   5.0941079E-10
     +,   6.1074057E-10,   7.3104234E-10,   8.7362079E-10
     +,   1.0423146E-09,   1.2415672E-09,   1.4765151E-09
     +,   1.7530775E-09,   2.0780822E-09,   2.4593323E-09
     +,   2.9058105E-09,   3.4277827E-09,   4.0369663E-09
     +,   4.7467390E-09,   5.5722222E-09,   6.5306613E-09
     +,   7.6415558E-09,   8.9269356E-09,   1.0411682E-08
     +,   1.2123564E-08,   1.4094193E-08,   1.6358495E-08
     +,   1.8955818E-08,   2.1929932E-08,   2.5329575E-08
     +,   2.9208971E-08,   3.3627789E-08,   3.8652342E-08
     +,   4.4355669E-08,   5.0818059E-08,   5.8127686E-08
     +,   6.6380991E-08,   7.5683637E-08,   8.6149754E-08
     +,   9.7904262E-08,   1.1108235E-07,   1.2583000E-07
     +,   1.4230540E-07,   1.6067625E-07,   1.8112490E-07
     +,   2.0384509E-07,   2.2904359E-07,   2.5694106E-07
     +,   2.8776697E-07,   3.2177155E-07,   3.5920996E-07
     +,   4.0035468E-07,   4.4548915E-07,   4.9490848E-07
     +,   5.4892155E-07,   6.0783810E-07,   6.7199278E-07
     +,   7.4171220E-07,   8.1733845E-07,   8.9921616E-07
     +,   9.8769351E-07,   1.0831221E-06,   1.1858421E-06
     +,   1.2961997E-06,   1.4145322E-06,   1.5411664E-06
     +,   1.6764159E-06,   1.8205864E-06,   1.9739450E-06
     +,   2.1367546E-06,   2.3092437E-06,   2.4916139E-06
     +,   2.6840305E-06,   2.8866302E-06,   3.0994827E-06
     +,   3.3226383E-06,   3.5560900E-06,   3.7997770E-06
     +,   4.0535833E-06,   4.3173372E-06,   4.5908114E-06
     +,   4.8736879E-06,   5.1656111E-06,   5.4661482E-06
     +,   5.7747989E-06,   6.0910043E-06,   6.4140886E-06
     +,   6.7433916E-06,   7.0781007E-06,   7.4173854E-06
     +,   7.7603527E-06,   8.1059970E-06,   8.4533449E-06
     +,   8.8012794E-06,   9.1486927E-06,   9.4944135E-06
     +,   9.8372402E-06,   1.0175956E-05,   1.0509268E-05
     +,   1.0835961E-05,   1.1154727E-05,   1.1464319E-05
     +,   1.1763495E-05,   1.2051002E-05,   1.2325706E-05
     +,   1.2586445E-05,   1.2832176E-05,   1.3061920E-05
     +,   1.3274807E-05,   1.3470102E-05,   1.3647183E-05
     +,   1.3805652E-05,   1.3945281E-05,   1.4066100E-05
     +,   1.4168424E-05,   1.4252892E-05,   1.4320533E-05
     +,   1.4372812E-05,   1.4411700E-05,   1.4439749E-05
     +,   1.4460155E-05,   1.4476844E-05,   1.4494538E-05
     +,   1.4518842E-05,   1.4556299E-05,   1.4614449E-05
     +,   1.4701878E-05,   1.4828222E-05,   1.5004195E-05
     +,   1.5241494E-05,   1.5552852E-05,   1.5951815E-05
     +,   1.6452754E-05,   1.7070717E-05,   1.7821219E-05
     +,   1.8720453E-05,   1.9784859E-05,   2.1031765E-05
     +,   2.2479111E-05,   2.4146078E-05,   2.6054204E-05
     +,   2.8227409E-05,   3.0694420E-05,   3.3489021E-05
     +,   3.6652727E-05,   4.0236275E-05,   4.4300697E-05
     +,   4.8920443E-05,   5.4181994E-05,   6.0185663E-05
     +,   6.7043795E-05,   7.4876858E-05,   8.3812163E-05
     +,   9.3973489E-05,   1.0547669E-04,   1.1841877E-04
     +,   1.3286814E-04,   1.4885493E-04,   1.6635821E-04
     +,   1.8530541E-04,   2.0555801E-04,   2.2691779E-04
     +,   2.4912681E-04,   2.7187646E-04,   2.9482340E-04
     +,   3.1760632E-04,   3.3988321E-04,   3.6135805E-04
     +,   3.8183911E-04,   4.0130029E-04,   4.1996557E-04
     +,   4.3841402E-04,   4.5769394E-04,   4.7944259E-04
     +,   5.0594617E-04,   5.4012489E-04,   5.8534811E-04
     +,   6.4505119E-04,   7.2214170E-04,   8.1824500E-04
     +,   9.3298388E-04,   1.0634651E-03,   1.2042500E-03
     +,   1.3479654E-03,   1.4865120E-03,   1.6127463E-03
     +,   1.7219826E-03,   1.8130458E-03,   1.8882825E-03
     +,   1.9525427E-03,   2.0114847E-03,   2.0697566E-03
     +,   2.1298833E-03,   2.1922020E-03,   2.2559303E-03
     +,   2.3208449E-03,   2.3887514E-03,   2.4640870E-03
     +,   2.5529910E-03,   2.6608761E-03,   2.7888895E-03
     +,   2.9304067E-03,   3.0694099E-03,   3.1823555E-03
     +,   3.2446948E-03,   3.2405842E-03,   3.1722218E-03
     +,   3.0637151E-03,   2.9558756E-03,   2.8923042E-03
     +,   2.9022796E-03,   2.9885068E-03,   3.1261821E-03
     +,   3.2744154E-03,   3.3950110E-03,   3.4699554E-03
     +,   3.5099818E-03,   3.5502198E-03,   3.6348256E-03
     +,   3.7966189E-03,   4.0397760E-03,   4.3325094E-03
     +,   4.6130307E-03,   4.8085777E-03,   4.8610615E-03
     +,   4.7486508E-03,   4.4919723E-03,   4.1414397E-03
     +,   3.7531960E-03,   3.3686229E-03,   3.0071051E-03
     +,   2.6717768E-03,   2.3600047E-03,   2.0701268E-03
     +,   1.8025716E-03,   1.5578334E-03,   1.3349948E-03
     +,   1.1319327E-03,   9.4652153E-04,   7.7766198E-04
     +,   6.2545057E-04,   4.9077376E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wao_hz_120 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wao_hz_60(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  1.7743188E-05,   1.8276542E-05
     +,   1.8826278E-05,   1.9395104E-05,   1.9986088E-05
     +,   2.0602667E-05,   2.1248637E-05,   2.1928183E-05
     +,   2.2645894E-05,   2.3406725E-05,   2.4216017E-05
     +,   2.5079535E-05,   2.6003338E-05,   2.6993919E-05
     +,   2.8058115E-05,   2.9203027E-05,   3.0436111E-05
     +,   3.1765139E-05,   3.3198019E-05,   3.4743007E-05
     +,   3.6408477E-05,   3.8202998E-05,   4.0135183E-05
     +,   4.2213796E-05,   4.4447548E-05,   4.6845187E-05
     +,   4.9415383E-05,   5.2166706E-05,   5.5107430E-05
     +,   5.8245729E-05,   6.1589300E-05,   6.5145556E-05
     +,   6.8921458E-05,   7.2923387E-05,   7.7156968E-05
     +,   8.1627208E-05,   8.6338296E-05,   9.1293179E-05
     +,   9.6494063E-05,   1.0194188E-04,   1.0763601E-04
     +,   1.1357473E-04,   1.1975443E-04,   1.2617013E-04
     +,   1.3281501E-04,   1.3968057E-04,   1.4675601E-04
     +,   1.5402892E-04,   1.6148505E-04,   1.6910776E-04
     +,   1.7687889E-04,   1.8477847E-04,   1.9278438E-04
     +,   2.0087344E-04,   2.0902058E-04,   2.1719988E-04
     +,   2.2538427E-04,   2.3354602E-04,   2.4165698E-04
     +,   2.4968854E-04,   2.5761270E-04,   2.6540124E-04
     +,   2.7302720E-04,   2.8046445E-04,   2.8768770E-04
     +,   2.9467352E-04,   3.0140002E-04,   3.0784670E-04
     +,   3.1399514E-04,   3.1982880E-04,   3.2533289E-04
     +,   3.3049469E-04,   3.3530308E-04,   3.3974831E-04
     +,   3.4382255E-04,   3.4751889E-04,   3.5083215E-04
     +,   3.5375752E-04,   3.5629098E-04,   3.5842936E-04
     +,   3.6016968E-04,   3.6150939E-04,   3.6244604E-04
     +,   3.6297727E-04,   3.6310099E-04,   3.6281513E-04
     +,   3.6211801E-04,   3.6100793E-04,   3.5948411E-04
     +,   3.5754623E-04,   3.5519511E-04,   3.5243251E-04
     +,   3.4926183E-04,   3.4568788E-04,   3.4171759E-04
     +,   3.3736016E-04,   3.3262686E-04,   3.2753186E-04
     +,   3.2209189E-04,   3.1632619E-04,   3.1025705E-04
     +,   3.0390915E-04,   2.9731065E-04,   2.9049144E-04
     +,   2.8348394E-04,   2.7632268E-04,   2.6904372E-04
     +,   2.6168546E-04,   2.5428561E-04,   2.4688439E-04
     +,   2.3952100E-04,   2.3223503E-04,   2.2506501E-04
     +,   2.1804847E-04,   2.1122232E-04,   2.0461997E-04
     +,   1.9827424E-04,   1.9221455E-04,   1.8646782E-04
     +,   1.8105777E-04,   1.7600488E-04,   1.7132671E-04
     +,   1.6703685E-04,   1.6314551E-04,   1.5965939E-04
     +,   1.5658156E-04,   1.5391168E-04,   1.5164621E-04
     +,   1.4977800E-04,   1.4829708E-04,   1.4719028E-04
     +,   1.4644185E-04,   1.4603332E-04,   1.4594408E-04
     +,   1.4615120E-04,   1.4663003E-04,   1.4735418E-04
     +,   1.4829591E-04,   1.4942640E-04,   1.5071606E-04
     +,   1.5213442E-04,   1.5365100E-04,   1.5523504E-04
     +,   1.5685614E-04,   1.5848427E-04,   1.6008990E-04
     +,   1.6164497E-04,   1.6312205E-04,   1.6449548E-04
     +,   1.6574108E-04,   1.6683644E-04,   1.6776129E-04
     +,   1.6849734E-04,   1.6902867E-04,   1.6934174E-04
     +,   1.6942548E-04,   1.6927133E-04,   1.6887340E-04
     +,   1.6822810E-04,   1.6733477E-04,   1.6619496E-04
     +,   1.6481262E-04,   1.6319436E-04,   1.6134845E-04
     +,   1.5928569E-04,   1.5701854E-04,   1.5456116E-04
     +,   1.5192930E-04,   1.4913976E-04,   1.4621092E-04
     +,   1.4316135E-04,   1.4001090E-04,   1.3677956E-04
     +,   1.3348745E-04,   1.3015485E-04,   1.2680163E-04
     +,   1.2344769E-04,   1.2011197E-04,   1.1681288E-04
     +,   1.1356785E-04,   1.1039332E-04,   1.0730502E-04
     +,   1.0431669E-04,   1.0144171E-04,   9.8691533E-05
     +,   9.6076466E-05,   9.3605406E-05,   9.1285758E-05
     +,   8.9123962E-05,   8.7124441E-05,   8.5290929E-05
     +,   8.3625491E-05,   8.2129060E-05,   8.0801590E-05
     +,   7.9641577E-05,   7.8646874E-05,   7.7814053E-05
     +,   7.7139033E-05,   7.6616911E-05,   7.6241959E-05
     +,   7.6007898E-05,   7.5907854E-05,   7.5934469E-05
     +,   7.6079981E-05,   7.6336233E-05,   7.6694778E-05
     +,   7.7147022E-05,   7.7684068E-05,   7.8296980E-05
     +,   7.8976773E-05,   7.9714286E-05,   8.0500584E-05
     +,   8.1326580E-05,   8.2183396E-05,   8.3062223E-05
     +,   8.3954415E-05,   8.4851541E-05,   8.5745225E-05
     +,   8.6627573E-05,   8.7490691E-05,   8.8327128E-05
     +,   8.9129680E-05,   8.9891451E-05,   9.0605929E-05
     +,   9.1266906E-05,   9.1868627E-05,   9.2405651E-05
     +,   9.2873022E-05,   9.3266193E-05,   9.3581046E-05
     +,   9.3813942E-05,   9.3961695E-05,   9.4021634E-05
     +,   9.3991512E-05,   9.3869603E-05,   9.3654693E-05
     +,   9.3346032E-05,   9.2943344E-05,   9.2446891E-05
     +,   9.1857371E-05,   9.1175956E-05,   9.0404239E-05
     +,   8.9544264E-05,   8.8598608E-05,   8.7569970E-05
     +,   8.6461696E-05,   8.5277330E-05,   8.4020699E-05
     +,   8.2696126E-05,   8.1307815E-05,   7.9860649E-05
     +,   7.8359211E-05,   7.6808610E-05,   7.5214040E-05
     +,   7.3580457E-05,   7.1913339E-05,   7.0217655E-05
     +,   6.8498841E-05,   6.6761997E-05,   6.5012151E-05
     +,   6.3254469E-05,   6.1493542E-05,   5.9734255E-05
     +,   5.7981026E-05,   5.6238146E-05,   5.4509699E-05
     +,   5.2799434E-05,   5.1111059E-05,   4.9447826E-05
     +,   4.7812766E-05,   4.6208639E-05,   4.4637869E-05
     +,   4.3102835E-05,   4.1605217E-05,   4.0146879E-05
     +,   3.8728966E-05,   3.7352740E-05,   3.6018995E-05
     +,   3.4728273E-05,   3.3481090E-05,   3.2277378E-05
     +,   3.1117215E-05,   3.0000281E-05,   2.8926097E-05
     +,   2.7894162E-05,   2.6903563E-05,   2.5953548E-05
     +,   2.5042964E-05,   2.4170766E-05,   2.3335801E-05
     +,   2.2536708E-05,   2.1772172E-05,   2.1040778E-05
     +,   2.0341184E-05,   1.9671908E-05,   1.9031511E-05
     +,   1.8418554E-05,   1.7831568E-05,   1.7269198E-05
     +,   1.6730026E-05,   1.6212703E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wao_hz_60 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wao_hz_65(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  2.1952887E-06,   2.4047019E-06
     +,   2.6311077E-06,   2.8755903E-06,   3.1392913E-06
     +,   3.4234029E-06,   3.7291445E-06,   4.0577993E-06
     +,   4.4106973E-06,   4.7891922E-06,   5.1947018E-06
     +,   5.6286890E-06,   6.0926304E-06,   6.5880677E-06
     +,   7.1165764E-06,   7.6797442E-06,   8.2792094E-06
     +,   8.9166433E-06,   9.5937012E-06,   1.0312091E-05
     +,   1.1073524E-05,   1.1879725E-05,   1.2732377E-05
     +,   1.3633219E-05,   1.4583899E-05,   1.5586094E-05
     +,   1.6641436E-05,   1.7751521E-05,   1.8917839E-05
     +,   2.0141893E-05,   2.1425019E-05,   2.2768534E-05
     +,   2.4173622E-05,   2.5641390E-05,   2.7172726E-05
     +,   2.8768462E-05,   3.0429277E-05,   3.2155585E-05
     +,   3.3947719E-05,   3.5805824E-05,   3.7729715E-05
     +,   3.9719158E-05,   4.1773532E-05,   4.3892083E-05
     +,   4.6073787E-05,   4.8317419E-05,   5.0621358E-05
     +,   5.2983836E-05,   5.5402863E-05,   5.7876045E-05
     +,   6.0400824E-05,   6.2974446E-05,   6.5593747E-05
     +,   6.8255533E-05,   7.0956135E-05,   7.3691910E-05
     +,   7.6458920E-05,   7.9253041E-05,   8.2070095E-05
     +,   8.4905565E-05,   8.7755077E-05,   9.0613932E-05
     +,   9.3477582E-05,   9.6341399E-05,   9.9200624E-05
     +,   1.0205071E-04,   1.0488712E-04,   1.0770530E-04
     +,   1.1050094E-04,   1.1326979E-04,   1.1600787E-04
     +,   1.1871129E-04,   1.2137649E-04,   1.2399990E-04
     +,   1.2657841E-04,   1.2910915E-04,   1.3158943E-04
     +,   1.3401700E-04,   1.3638954E-04,   1.3870535E-04
     +,   1.4096280E-04,   1.4316061E-04,   1.4529774E-04
     +,   1.4737302E-04,   1.4938613E-04,   1.5133628E-04
     +,   1.5322314E-04,   1.5504645E-04,   1.5680594E-04
     +,   1.5850154E-04,   1.6013288E-04,   1.6169973E-04
     +,   1.6320184E-04,   1.6463874E-04,   1.6600982E-04
     +,   1.6731430E-04,   1.6855121E-04,   1.6971921E-04
     +,   1.7081683E-04,   1.7184221E-04,   1.7279331E-04
     +,   1.7366765E-04,   1.7446250E-04,   1.7517478E-04
     +,   1.7580119E-04,   1.7633803E-04,   1.7678151E-04
     +,   1.7712745E-04,   1.7737161E-04,   1.7750947E-04
     +,   1.7753660E-04,   1.7744835E-04,   1.7724022E-04
     +,   1.7690771E-04,   1.7644657E-04,   1.7585261E-04
     +,   1.7512213E-04,   1.7425172E-04,   1.7323828E-04
     +,   1.7207935E-04,   1.7077291E-04,   1.6931785E-04
     +,   1.6771341E-04,   1.6595970E-04,   1.6405761E-04
     +,   1.6200889E-04,   1.5981597E-04,   1.5748243E-04
     +,   1.5501243E-04,   1.5241122E-04,   1.4968473E-04
     +,   1.4683991E-04,   1.4388438E-04,   1.4082679E-04
     +,   1.3767630E-04,   1.3444285E-04,   1.3113697E-04
     +,   1.2776979E-04,   1.2435290E-04,   1.2089818E-04
     +,   1.1741823E-04,   1.1392545E-04,   1.1043258E-04
     +,   1.0695234E-04,   1.0349738E-04,   1.0008061E-04
     +,   9.6713957E-05,   9.3409850E-05,   9.0179899E-05
     +,   8.7035231E-05,   8.3986910E-05,   8.1044658E-05
     +,   7.8218298E-05,   7.5516531E-05,   7.2947420E-05
     +,   7.0518283E-05,   6.8235524E-05,   6.6105102E-05
     +,   6.4131549E-05,   6.2319152E-05,   6.0671042E-05
     +,   5.9189562E-05,   5.7876456E-05,   5.6732391E-05
     +,   5.5757559E-05,   5.4951317E-05,   5.4312368E-05
     +,   5.3838798E-05,   5.3528092E-05,   5.3377265E-05
     +,   5.3382770E-05,   5.3540683E-05,   5.3846714E-05
     +,   5.4296190E-05,   5.4884240E-05,   5.5605768E-05
     +,   5.6455443E-05,   5.7427886E-05,   5.8517631E-05
     +,   5.9719201E-05,   6.1027167E-05,   6.2435975E-05
     +,   6.3940512E-05,   6.5535409E-05,   6.7215697E-05
     +,   6.8976493E-05,   7.0813127E-05,   7.2721195E-05
     +,   7.4696225E-05,   7.6734490E-05,   7.8831952E-05
     +,   8.0985090E-05,   8.3190607E-05,   8.5445077E-05
     +,   8.7745844E-05,   9.0089714E-05,   9.2474351E-05
     +,   9.4896990E-05,   9.7354939E-05,   9.9846155E-05
     +,   1.0236782E-04,   1.0491791E-04,   1.0749367E-04
     +,   1.1009270E-04,   1.1271247E-04,   1.1534995E-04
     +,   1.1800267E-04,   1.2066727E-04,   1.2334064E-04
     +,   1.2601947E-04,   1.2869979E-04,   1.3137821E-04
     +,   1.3405045E-04,   1.3671230E-04,   1.3935944E-04
     +,   1.4198726E-04,   1.4459115E-04,   1.4716602E-04
     +,   1.4970734E-04,   1.5220985E-04,   1.5466864E-04
     +,   1.5707876E-04,   1.5943531E-04,   1.6173349E-04
     +,   1.6396835E-04,   1.6613568E-04,   1.6823084E-04
     +,   1.7024974E-04,   1.7218839E-04,   1.7404307E-04
     +,   1.7581043E-04,   1.7748699E-04,   1.7907008E-04
     +,   1.8055673E-04,   1.8194449E-04,   1.8323110E-04
     +,   1.8441440E-04,   1.8549243E-04,   1.8646325E-04
     +,   1.8732517E-04,   1.8807645E-04,   1.8871538E-04
     +,   1.8924024E-04,   1.8964929E-04,   1.8994071E-04
     +,   1.9011257E-04,   1.9016283E-04,   1.9008938E-04
     +,   1.8989002E-04,   1.8956228E-04,   1.8910381E-04
     +,   1.8851197E-04,   1.8778429E-04,   1.8691819E-04
     +,   1.8591103E-04,   1.8476056E-04,   1.8346426E-04
     +,   1.8202025E-04,   1.8042665E-04,   1.7868198E-04
     +,   1.7678538E-04,   1.7473596E-04,   1.7253400E-04
     +,   1.7017998E-04,   1.6767508E-04,   1.6502135E-04
     +,   1.6222120E-04,   1.5927842E-04,   1.5619709E-04
     +,   1.5298222E-04,   1.4963967E-04,   1.4617595E-04
     +,   1.4259880E-04,   1.3891584E-04,   1.3513638E-04
     +,   1.3126931E-04,   1.2732504E-04,   1.2331395E-04
     +,   1.1924680E-04,   1.1513526E-04,   1.1099024E-04
     +,   1.0682384E-04,   1.0264761E-04,   9.8473058E-05
     +,   9.4312250E-05,   9.0175810E-05,   8.6075437E-05
     +,   8.2021157E-05,   7.8023455E-05,   7.4092299E-05
     +,   7.0236281E-05,   6.6463988E-05,   6.2782994E-05
     +,   5.9200611E-05,   5.5722932E-05,   5.2355434E-05
     +,   4.9102822E-05,   4.5968882E-05,   4.2956992E-05
     +,   4.0069379E-05,   3.7307687E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wao_hz_65 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wao_hz_70(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  2.6409978E-08,   2.9859844E-08
     +,   3.3721584E-08,   3.8038838E-08,   4.2859458E-08
     +,   4.8235556E-08,   5.4223442E-08,   6.0884581E-08
     +,   6.8285658E-08,   7.6498189E-08,   8.5600085E-08
     +,   9.5675155E-08,   1.0681318E-07,   1.1911110E-07
     +,   1.3267301E-07,   1.4760948E-07,   1.6403959E-07
     +,   1.8209046E-07,   2.0189619E-07,   2.2360061E-07
     +,   2.4735587E-07,   2.7332362E-07,   3.0167308E-07
     +,   3.3258516E-07,   3.6624786E-07,   4.0286054E-07
     +,   4.4263169E-07,   4.8578016E-07,   5.3253285E-07
     +,   5.8312861E-07,   6.3781300E-07,   6.9684370E-07
     +,   7.6048633E-07,   8.2901749E-07,   9.0271755E-07
     +,   9.8187991E-07,   1.0668056E-06,   1.1577987E-06
     +,   1.2551742E-06,   1.3592553E-06,   1.4703621E-06
     +,   1.5888321E-06,   1.7149954E-06,   1.8491925E-06
     +,   1.9917652E-06,   2.1430617E-06,   2.3034218E-06
     +,   2.4731942E-06,   2.6527282E-06,   2.8423628E-06
     +,   3.0424474E-06,   3.2533267E-06,   3.4753332E-06
     +,   3.7088132E-06,   3.9540901E-06,   4.2114993E-06
     +,   4.4813678E-06,   4.7640160E-06,   5.0597687E-06
     +,   5.3689305E-06,   5.6918234E-06,   6.0287439E-06
     +,   6.3800012E-06,   6.7459082E-06,   7.1267505E-06
     +,   7.5228386E-06,   7.9344791E-06,   8.3619598E-06
     +,   8.8055940E-06,   9.2656865E-06,   9.7425518E-06
     +,   1.0236506E-05,   1.0747887E-05,   1.1276988E-05
     +,   1.1824160E-05,   1.2389746E-05,   1.2974095E-05
     +,   1.3577583E-05,   1.4200526E-05,   1.4843315E-05
     +,   1.5506319E-05,   1.6189910E-05,   1.6894486E-05
     +,   1.7620339E-05,   1.8367937E-05,   1.9137547E-05
     +,   1.9929541E-05,   2.0744226E-05,   2.1581905E-05
     +,   2.2442871E-05,   2.3327277E-05,   2.4235342E-05
     +,   2.5167192E-05,   2.6122909E-05,   2.7102482E-05
     +,   2.8105855E-05,   2.9132905E-05,   3.0183324E-05
     +,   3.1256812E-05,   3.2352928E-05,   3.3471122E-05
     +,   3.4610763E-05,   3.5770983E-05,   3.6950903E-05
     +,   3.8149479E-05,   3.9365532E-05,   4.0597788E-05
     +,   4.1844654E-05,   4.3104741E-05,   4.4376196E-05
     +,   4.5657220E-05,   4.6945843E-05,   4.8240003E-05
     +,   4.9537550E-05,   5.0836054E-05,   5.2133350E-05
     +,   5.3426840E-05,   5.4714081E-05,   5.5992517E-05
     +,   5.7259571E-05,   5.8512702E-05,   5.9749214E-05
     +,   6.0966562E-05,   6.2162231E-05,   6.3333719E-05
     +,   6.4478583E-05,   6.5594526E-05,   6.6679211E-05
     +,   6.7730522E-05,   6.8746442E-05,   6.9725065E-05
     +,   7.0664639E-05,   7.1563562E-05,   7.2420298E-05
     +,   7.3233568E-05,   7.4002208E-05,   7.4725212E-05
     +,   7.5401702E-05,   7.6030985E-05,   7.6612501E-05
     +,   7.7145771E-05,   7.7630517E-05,   7.8066558E-05
     +,   7.8453835E-05,   7.8792393E-05,   7.9082332E-05
     +,   7.9323938E-05,   7.9517507E-05,   7.9663478E-05
     +,   7.9762322E-05,   7.9814636E-05,   7.9821089E-05
     +,   7.9782454E-05,   7.9699566E-05,   7.9573445E-05
     +,   7.9405145E-05,   7.9195903E-05,   7.8947131E-05
     +,   7.8660312E-05,   7.8337209E-05,   7.7979748E-05
     +,   7.7590012E-05,   7.7170371E-05,   7.6723358E-05
     +,   7.6251796E-05,   7.5758689E-05,   7.5247241E-05
     +,   7.4720927E-05,   7.4183299E-05,   7.3638214E-05
     +,   7.3089424E-05,   7.2540985E-05,   7.1996816E-05
     +,   7.1460890E-05,   7.0937058E-05,   7.0429043E-05
     +,   6.9940419E-05,   6.9474503E-05,   6.9034337E-05
     +,   6.8622721E-05,   6.8242152E-05,   6.7894907E-05
     +,   6.7583016E-05,   6.7308465E-05,   6.7073219E-05
     +,   6.6879424E-05,   6.6729583E-05,   6.6626839E-05
     +,   6.6575216E-05,   6.6579953E-05,   6.6647779E-05
     +,   6.6787376E-05,   6.7009605E-05,   6.7327979E-05
     +,   6.7758971E-05,   6.8322188E-05,   6.9040761E-05
     +,   6.9941343E-05,   7.1054092E-05,   7.2413000E-05
     +,   7.4054922E-05,   7.6020035E-05,   7.8350444E-05
     +,   8.1090104E-05,   8.4283754E-05,   8.7975255E-05
     +,   9.2207934E-05,   9.7021359E-05,   1.0245158E-04
     +,   1.0852944E-04,   1.1527808E-04,   1.2271485E-04
     +,   1.3084653E-04,   1.3967192E-04,   1.4918011E-04
     +,   1.5935085E-04,   1.7015579E-04,   1.8155713E-04
     +,   1.9351393E-04,   2.0597808E-04,   2.1890082E-04
     +,   2.3223353E-04,   2.4592984E-04,   2.5994913E-04
     +,   2.7425503E-04,   2.8882327E-04,   3.0363450E-04
     +,   3.1868002E-04,   3.3395793E-04,   3.4947126E-04
     +,   3.6522545E-04,   3.8122080E-04,   3.9745460E-04
     +,   4.1390661E-04,   4.3054088E-04,   4.4729677E-04
     +,   4.6408578E-04,   4.8078835E-04,   4.9724994E-04
     +,   5.1328493E-04,   5.2867649E-04,   5.4318225E-04
     +,   5.5654097E-04,   5.6848011E-04,   5.7873048E-04
     +,   5.8703241E-04,   5.9315225E-04,   5.9689215E-04
     +,   5.9810135E-04,   5.9668539E-04,   5.9261371E-04
     +,   5.8592152E-04,   5.7671289E-04,   5.6515832E-04
     +,   5.5148534E-04,   5.3597585E-04,   5.1894778E-04
     +,   5.0075044E-04,   4.8174334E-04,   4.6228492E-04
     +,   4.4272179E-04,   4.2336789E-04,   4.0450445E-04
     +,   3.8636356E-04,   3.6912630E-04,   3.5291933E-04
     +,   3.3781433E-04,   3.2383265E-04,   3.1094672E-04
     +,   2.9908898E-04,   2.8815912E-04,   2.7803201E-04
     +,   2.6856843E-04,   2.5961967E-04,   2.5104053E-04
     +,   2.4269080E-04,   2.3444602E-04,   2.2619801E-04
     +,   2.1785958E-04,   2.0936698E-04,   2.0067727E-04
     +,   1.9177183E-04,   1.8265154E-04,   1.7333547E-04
     +,   1.6385995E-04,   1.5427118E-04,   1.4462767E-04
     +,   1.3499113E-04,   1.2542871E-04,   1.1600780E-04
     +,   1.0679198E-04,   9.7842123E-05,   8.9212670E-05
     +,   8.0952035E-05,   7.3099793E-05,   6.5687549E-05
     +,   5.8738475E-05,   5.2267165E-05,   4.6281148E-05
     +,   4.0779840E-05,   3.5756406E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wao_hz_70 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wao_hz_75(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  8.8501421E-11,   1.0952621E-10
     +,   1.3529394E-10,   1.6681229E-10,   2.0529051E-10
     +,   2.5217506E-10,   3.0918923E-10,   3.7838840E-10
     +,   4.6221510E-10,   5.6355964E-10,   6.8584494E-10
     +,   8.3311558E-10,   1.0101219E-09,   1.2224554E-09
     +,   1.4766771E-09,   1.7804399E-09,   2.1426927E-09
     +,   2.5738631E-09,   3.0860334E-09,   3.6932344E-09
     +,   4.4116839E-09,   5.2601088E-09,   6.2600081E-09
     +,   7.4361486E-09,   8.8168068E-09,   1.0434368E-08
     +,   1.2325735E-08,   1.4532909E-08,   1.7103412E-08
     +,   2.0091234E-08,   2.3557078E-08,   2.7569495E-08
     +,   3.2205424E-08,   3.7551196E-08,   4.3702940E-08
     +,   5.0768143E-08,   5.8866391E-08,   6.8129815E-08
     +,   7.8704943E-08,   9.0753666E-08,   1.0445319E-07
     +,   1.1999897E-07,   1.3760393E-07,   1.5750106E-07
     +,   1.7994354E-07,   2.0520704E-07,   2.3358780E-07
     +,   2.6540712E-07,   3.0101145E-07,   3.4076925E-07
     +,   3.8507795E-07,   4.3436114E-07,   4.8906685E-07
     +,   5.4967370E-07,   6.1668436E-07,   6.9063185E-07
     +,   7.7207574E-07,   8.6160298E-07,   9.5983012E-07
     +,   1.0673938E-06,   1.1849652E-06,   1.3132330E-06
     +,   1.4529171E-06,   1.6047633E-06,   1.7695326E-06
     +,   1.9480181E-06,   2.1410387E-06,   2.3494240E-06
     +,   2.5740399E-06,   2.8157747E-06,   3.0755386E-06
     +,   3.3542742E-06,   3.6529630E-06,   3.9725865E-06
     +,   4.3141954E-06,   4.6788700E-06,   5.0677404E-06
     +,   5.4820011E-06,   5.9228601E-06,   6.3916418E-06
     +,   6.8897293E-06,   7.4185918E-06,   7.9798156E-06
     +,   8.5750107E-06,   9.2060609E-06,   9.8748169E-06
     +,   1.0583370E-05,   1.1333946E-05,   1.2128938E-05
     +,   1.2970953E-05,   1.3862697E-05,   1.4807173E-05
     +,   1.5807569E-05,   1.6867300E-05,   1.7990002E-05
     +,   1.9179559E-05,   2.0440142E-05,   2.1776004E-05
     +,   2.3191787E-05,   2.4692317E-05,   2.6282631E-05
     +,   2.7968041E-05,   2.9753846E-05,   3.1645704E-05
     +,   3.3649325E-05,   3.5770521E-05,   3.8015234E-05
     +,   4.0389059E-05,   4.2898151E-05,   4.5547895E-05
     +,   4.8343860E-05,   5.1291245E-05,   5.4394859E-05
     +,   5.7659210E-05,   6.1087703E-05,   6.4683947E-05
     +,   6.8449830E-05,   7.2386858E-05,   7.6495293E-05
     +,   8.0774196E-05,   8.5221465E-05,   8.9832894E-05
     +,   9.4603216E-05,   9.9525147E-05,   1.0458948E-04
     +,   1.0978497E-04,   1.1509850E-04,   1.2051408E-04
     +,   1.2601430E-04,   1.3157932E-04,   1.3718747E-04
     +,   1.4281526E-04,   1.4843818E-04,   1.5403007E-04
     +,   1.5956532E-04,   1.6501835E-04,   1.7036531E-04
     +,   1.7558446E-04,   1.8065808E-04,   1.8557333E-04
     +,   1.9032331E-04,   1.9490947E-04,   1.9934215E-04
     +,   2.0364214E-04,   2.0784177E-04,   2.1198516E-04
     +,   2.1612998E-04,   2.2034552E-04,   2.2471344E-04
     +,   2.2932593E-04,   2.3428301E-04,   2.3969181E-04
     +,   2.4566022E-04,   2.5229523E-04,   2.5969735E-04
     +,   2.6795545E-04,   2.7714219E-04,   2.8730702E-04
     +,   2.9847526E-04,   3.1063866E-04,   3.2375634E-04
     +,   3.3775083E-04,   3.5250490E-04,   3.6786855E-04
     +,   3.8365286E-04,   3.9964056E-04,   4.1558832E-04
     +,   4.3123457E-04,   4.4630756E-04,   4.6053197E-04
     +,   4.7364424E-04,   4.8539395E-04,   4.9555890E-04
     +,   5.0395029E-04,   5.1041972E-04,   5.1486533E-04
     +,   5.1723281E-04,   5.1751867E-04,   5.1576871E-04
     +,   5.1207404E-04,   5.0656853E-04,   4.9942260E-04
     +,   4.9083424E-04,   4.8102543E-04,   4.7023219E-04
     +,   4.5869843E-04,   4.4666935E-04,   4.3438657E-04
     +,   4.2208526E-04,   4.0998711E-04,   3.9830455E-04
     +,   3.8723490E-04,   3.7696285E-04,   3.6766171E-04
     +,   3.5948996E-04,   3.5259785E-04,   3.4712075E-04
     +,   3.4318387E-04,   3.4089782E-04,   3.4035664E-04
     +,   3.4163566E-04,   3.4478767E-04,   3.4983890E-04
     +,   3.5678610E-04,   3.6559318E-04,   3.7618738E-04
     +,   3.8846157E-04,   4.0226951E-04,   4.1743126E-04
     +,   4.3373564E-04,   4.5094179E-04,   4.6879295E-04
     +,   4.8701462E-04,   5.0533027E-04,   5.2346761E-04
     +,   5.4116757E-04,   5.5819331E-04,   5.7433546E-04
     +,   5.8942440E-04,   6.0332497E-04,   6.1594765E-04
     +,   6.2724244E-04,   6.3719944E-04,   6.4584345E-04
     +,   6.5322756E-04,   6.5942784E-04,   6.6453242E-04
     +,   6.6863629E-04,   6.7183230E-04,   6.7420444E-04
     +,   6.7582406E-04,   6.7674631E-04,   6.7700929E-04
     +,   6.7663478E-04,   6.7563204E-04,   6.7400135E-04
     +,   6.7174109E-04,   6.6885323E-04,   6.6534977E-04
     +,   6.6125719E-04,   6.5662077E-04,   6.5150642E-04
     +,   6.4599985E-04,   6.4020383E-04,   6.3423102E-04
     +,   6.2819995E-04,   6.2222342E-04,   6.1640004E-04
     +,   6.1080640E-04,   6.0548610E-04,   6.0044782E-04
     +,   5.9565780E-04,   5.9104164E-04,   5.8648590E-04
     +,   5.8184069E-04,   5.7693111E-04,   5.7156151E-04
     +,   5.6553009E-04,   5.5863586E-04,   5.5069086E-04
     +,   5.4152985E-04,   5.3101493E-04,   5.1904650E-04
     +,   5.0556374E-04,   4.9054791E-04,   4.7402430E-04
     +,   4.5605793E-04,   4.3675525E-04,   4.1625570E-04
     +,   3.9472940E-04,   3.7237082E-04,   3.4939189E-04
     +,   3.2602012E-04,   3.0248245E-04,   2.7901217E-04
     +,   2.5582869E-04,   2.3314553E-04,   2.1115570E-04
     +,   1.9003118E-04,   1.6992283E-04,   1.5094956E-04
     +,   1.3320772E-04,   1.1676258E-04,   1.0165207E-04
     +,   8.7890214E-05,   7.5463271E-05,   6.4340296E-05
     +,   5.4468557E-05,   4.5783076E-05,   3.8207116E-05
     +,   3.1654447E-05,   2.6035208E-05,   2.1257052E-05
     +,   1.7228689E-05,   1.3860905E-05,   1.1069011E-05
     +,   8.7739008E-06,   6.9028624E-06,   5.3903536E-06
     +,   4.1777726E-06,   3.2136952E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wao_hz_75 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wao_hz_80(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  2.6935740E-07,   2.9908651E-07
     +,   3.3170943E-07,   3.6746061E-07,   4.0659026E-07
     +,   4.4936343E-07,   4.9605751E-07,   5.4696699E-07
     +,   6.0240194E-07,   6.6268467E-07,   7.2815521E-07
     +,   7.9917038E-07,   8.7609692E-07,   9.5932080E-07
     +,   1.0492430E-06,   1.1462736E-06,   1.2508408E-06
     +,   1.3633871E-06,   1.4843603E-06,   1.6142259E-06
     +,   1.7534574E-06,   1.9025410E-06,   2.0619623E-06
     +,   2.2322251E-06,   2.4138267E-06,   2.6072769E-06
     +,   2.8130855E-06,   3.0317649E-06,   3.2638159E-06
     +,   3.5097514E-06,   3.7700620E-06,   4.0452446E-06
     +,   4.3357809E-06,   4.6421478E-06,   4.9647924E-06
     +,   5.3041613E-06,   5.6606855E-06,   6.0347543E-06
     +,   6.4267579E-06,   6.8370623E-06,   7.2659841E-06
     +,   7.7138438E-06,   8.1809012E-06,   8.6674108E-06
     +,   9.1735865E-06,   9.6996173E-06,   1.0245633E-05
     +,   1.0811754E-05,   1.1398068E-05,   1.2004592E-05
     +,   1.2631343E-05,   1.3278303E-05,   1.3945378E-05
     +,   1.4632489E-05,   1.5339478E-05,   1.6066178E-05
     +,   1.6812386E-05,   1.7577864E-05,   1.8362354E-05
     +,   1.9165531E-05,   1.9987090E-05,   2.0826648E-05
     +,   2.1683829E-05,   2.2558250E-05,   2.3449436E-05
     +,   2.4356952E-05,   2.5280337E-05,   2.6219055E-05
     +,   2.7172604E-05,   2.8140452E-05,   2.9122026E-05
     +,   3.0116764E-05,   3.1124091E-05,   3.2143325E-05
     +,   3.3173863E-05,   3.4215038E-05,   3.5266177E-05
     +,   3.6326597E-05,   3.7395497E-05,   3.8472153E-05
     +,   3.9555765E-05,   4.0645507E-05,   4.1740557E-05
     +,   4.2839893E-05,   4.3942731E-05,   4.5047957E-05
     +,   4.6154579E-05,   4.7261517E-05,   4.8367630E-05
     +,   4.9471757E-05,   5.0572573E-05,   5.1668801E-05
     +,   5.2759089E-05,   5.3841988E-05,   5.4916029E-05
     +,   5.5979628E-05,   5.7031248E-05,   5.8069123E-05
     +,   5.9091577E-05,   6.0096841E-05,   6.1083105E-05
     +,   6.2048544E-05,   6.2991181E-05,   6.3909167E-05
     +,   6.4800566E-05,   6.5663451E-05,   6.6495937E-05
     +,   6.7296023E-05,   6.8061949E-05,   6.8791844E-05
     +,   6.9483940E-05,   7.0136593E-05,   7.0748210E-05
     +,   7.1317358E-05,   7.1842631E-05,   7.2322931E-05
     +,   7.2757190E-05,   7.3144583E-05,   7.3484473E-05
     +,   7.3776442E-05,   7.4020318E-05,   7.4216106E-05
     +,   7.4364099E-05,   7.4464886E-05,   7.4519230E-05
     +,   7.4528238E-05,   7.4493248E-05,   7.4415868E-05
     +,   7.4297968E-05,   7.4141659E-05,   7.3949355E-05
     +,   7.3723670E-05,   7.3467440E-05,   7.3183808E-05
     +,   7.2876086E-05,   7.2547838E-05,   7.2202856E-05
     +,   7.1845221E-05,   7.1479240E-05,   7.1109542E-05
     +,   7.0741145E-05,   7.0379421E-05,   7.0030255E-05
     +,   6.9700101E-05,   6.9396090E-05,   6.9126210E-05
     +,   6.8899382E-05,   6.8725734E-05,   6.8616748E-05
     +,   6.8585519E-05,   6.8647016E-05,   6.8818365E-05
     +,   6.9119145E-05,   6.9571812E-05,   7.0201910E-05
     +,   7.1038558E-05,   7.2114752E-05,   7.3467578E-05
     +,   7.5138953E-05,   7.7175217E-05,   7.9627876E-05
     +,   8.2553473E-05,   8.6012878E-05,   9.0072470E-05
     +,   9.4801559E-05,   1.0027311E-04,   1.0656179E-04
     +,   1.1374246E-04,   1.2188854E-04,   1.3106789E-04
     +,   1.4134368E-04,   1.5276630E-04,   1.6537397E-04
     +,   1.7918715E-04,   1.9420558E-04,   2.1040547E-04
     +,   2.2773423E-04,   2.4611218E-04,   2.6542920E-04
     +,   2.8554510E-04,   3.0629287E-04,   3.2747749E-04
     +,   3.4888973E-04,   3.7030148E-04,   3.9148270E-04
     +,   4.1220538E-04,   4.3225431E-04,   4.5143632E-04
     +,   4.6958547E-04,   4.8657652E-04,   5.0232100E-04
     +,   5.1677588E-04,   5.2994071E-04,   5.4185069E-04
     +,   5.5257702E-04,   5.6221039E-04,   5.7085778E-04
     +,   5.7862682E-04,   5.8561872E-04,   5.9192086E-04
     +,   5.9759844E-04,   6.0269609E-04,   6.0723571E-04
     +,   6.1122497E-04,   6.1466353E-04,   6.1755365E-04
     +,   6.1991345E-04,   6.2178448E-04,   6.2324316E-04
     +,   6.2440615E-04,   6.2543125E-04,   6.2651723E-04
     +,   6.2789582E-04,   6.2982232E-04,   6.3256442E-04
     +,   6.3638744E-04,   6.4154348E-04,   6.4825779E-04
     +,   6.5672240E-04,   6.6708593E-04,   6.7945273E-04
     +,   6.9387740E-04,   7.1036292E-04,   7.2885974E-04
     +,   7.4925605E-04,   7.7138352E-04,   7.9500157E-04
     +,   8.1980409E-04,   8.4541773E-04,   8.7140838E-04
     +,   8.9730020E-04,   9.2259119E-04,   9.4679475E-04
     +,   9.6945884E-04,   9.9020847E-04,   1.0087691E-03
     +,   1.0249841E-03,   1.0388182E-03,   1.0503448E-03
     +,   1.0597233E-03,   1.0671575E-03,   1.0728578E-03
     +,   1.0769999E-03,   1.0796920E-03,   1.0809572E-03
     +,   1.0807334E-03,   1.0788864E-03,   1.0752386E-03
     +,   1.0696080E-03,   1.0618416E-03,   1.0518560E-03
     +,   1.0396503E-03,   1.0253229E-03,   1.0090603E-03
     +,   9.9111372E-04,   9.7177515E-04,   9.5133507E-04
     +,   9.3005755E-04,   9.0814562E-04,   8.8572560E-04
     +,   8.6284563E-04,   8.3947199E-04,   8.1551587E-04
     +,   7.9084752E-04,   7.6532678E-04,   7.3882908E-04
     +,   7.1126712E-04,   6.8261375E-04,   6.5290619E-04
     +,   6.2225299E-04,   5.9082947E-04,   5.5886683E-04
     +,   5.2664359E-04,   4.9445505E-04,   4.6261415E-04
     +,   4.3141455E-04,   4.0113437E-04,   3.7201057E-04
     +,   3.4423568E-04,   3.1795725E-04,   2.9326545E-04
     +,   2.7020928E-04,   2.4878996E-04,   2.2897187E-04
     +,   2.1069215E-04,   1.9386128E-04,   1.7838045E-04
     +,   1.6413869E-04,   1.5102724E-04,   1.3894042E-04
     +,   1.2777738E-04,   1.1744850E-04,   1.0787400E-04
     +,   9.8985940E-05,   9.0725800E-05,   8.3044804E-05
     +,   7.5902215E-05,   6.9263660E-05,   6.3100604E-05
     +,   5.7387402E-05,   5.2101172E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wao_hz_80 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wao_hz_85(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  4.7098516E-11,   5.6448141E-11
     +,   6.7565460E-11,   8.0766185E-11,   9.6419699E-11
     +,   1.1495683E-10,   1.3687781E-10,   1.6276583E-10
     +,   1.9329746E-10,   2.2925502E-10,   2.7154579E-10
     +,   3.2121783E-10,   3.7947798E-10,   4.4771858E-10
     +,   5.2754079E-10,   6.2078026E-10,   7.2954304E-10
     +,   8.5624124E-10,   1.0036280E-09,   1.1748443E-09
     +,   1.3734722E-09,   1.6035887E-09,   1.8698043E-09
     +,   2.1773721E-09,   2.5322120E-09,   2.9410301E-09
     +,   3.4113923E-09,   3.9518215E-09,   4.5718704E-09
     +,   5.2823195E-09,   6.0951879E-09,   7.0239654E-09
     +,   8.0837168E-09,   9.2912584E-09,   1.0665230E-08
     +,   1.2226447E-08,   1.3997975E-08,   1.6005313E-08
     +,   1.8276696E-08,   2.0843348E-08,   2.3739531E-08
     +,   2.7003116E-08,   3.0675462E-08,   3.4802117E-08
     +,   3.9432823E-08,   4.4622041E-08,   5.0428824E-08
     +,   5.6917813E-08,   6.4159245E-08,   7.2228787E-08
     +,   8.1208945E-08,   9.1188831E-08,   1.0226398E-07
     +,   1.1453815E-07,   1.2812191E-07,   1.4313471E-07
     +,   1.5970392E-07,   1.7796620E-07,   1.9806721E-07
     +,   2.2016141E-07,   2.4441431E-07,   2.7100023E-07
     +,   3.0010469E-07,   3.3192438E-07,   3.6666501E-07
     +,   4.0454529E-07,   4.4579559E-07,   4.9065494E-07
     +,   5.3937720E-07,   5.9222668E-07,   6.4947949E-07
     +,   7.1142466E-07,   7.7836495E-07,   8.5060839E-07
     +,   9.2848194E-07,   1.0123223E-06,   1.1024794E-06
     +,   1.1993181E-06,   1.3032045E-06,   1.4145279E-06
     +,   1.5336858E-06,   1.6610893E-06,   1.7971643E-06
     +,   1.9423298E-06,   2.0970549E-06,   2.2617808E-06
     +,   2.4369845E-06,   2.6231503E-06,   2.8207746E-06
     +,   3.0303745E-06,   3.2524563E-06,   3.4875632E-06
     +,   3.7362436E-06,   3.9990596E-06,   4.2765864E-06
     +,   4.5694137E-06,   4.8781544E-06,   5.2034011E-06
     +,   5.5457917E-06,   5.9059666E-06,   6.2845770E-06
     +,   6.6822981E-06,   7.0997717E-06,   7.5376847E-06
     +,   7.9967167E-06,   8.4775493E-06,   8.9808809E-06
     +,   9.5073210E-06,   1.0057611E-05,   1.0632330E-05
     +,   1.1232116E-05,   1.1857559E-05,   1.2509199E-05
     +,   1.3187568E-05,   1.3893026E-05,   1.4626056E-05
     +,   1.5386868E-05,   1.6175696E-05,   1.6992642E-05
     +,   1.7837701E-05,   1.8710774E-05,   1.9611529E-05
     +,   2.0539597E-05,   2.1494432E-05,   2.2475326E-05
     +,   2.3481427E-05,   2.4511783E-05,   2.5565185E-05
     +,   2.6640413E-05,   2.7736127E-05,   2.8850904E-05
     +,   2.9983330E-05,   3.1132029E-05,   3.2295615E-05
     +,   3.3473003E-05,   3.4663310E-05,   3.5866040E-05
     +,   3.7081165E-05,   3.8309303E-05,   3.9551840E-05
     +,   4.0810974E-05,   4.2090105E-05,   4.3393877E-05
     +,   4.4728331E-05,   4.6101221E-05,   4.7521859E-05
     +,   4.9001901E-05,   5.0554714E-05,   5.2196163E-05
     +,   5.3944397E-05,   5.5819695E-05,   5.7845202E-05
     +,   6.0045910E-05,   6.2449275E-05,   6.5084634E-05
     +,   6.7983106E-05,   7.1177150E-05,   7.4699608E-05
     +,   7.8584417E-05,   8.2864099E-05,   8.7570537E-05
     +,   9.2733564E-05,   9.8379242E-05,   1.0453114E-04
     +,   1.1120643E-04,   1.1841751E-04,   1.2616998E-04
     +,   1.3446224E-04,   1.4328532E-04,   1.5262085E-04
     +,   1.6244485E-04,   1.7272294E-04,   1.8341471E-04
     +,   1.9447254E-04,   2.0584279E-04,   2.1746724E-04
     +,   2.2928239E-04,   2.4122301E-04,   2.5322140E-04
     +,   2.6520895E-04,   2.7711707E-04,   2.8887604E-04
     +,   3.0042039E-04,   3.1168366E-04,   3.2260444E-04
     +,   3.3312567E-04,   3.4319746E-04,   3.5278028E-04
     +,   3.6184752E-04,   3.7039389E-04,   3.7843658E-04
     +,   3.8602515E-04,   3.9324630E-04,   4.0022892E-04
     +,   4.0715063E-04,   4.1423584E-04,   4.2175906E-04
     +,   4.3003395E-04,   4.3940445E-04,   4.5023058E-04
     +,   4.6286301E-04,   4.7762331E-04,   4.9477181E-04
     +,   5.1448541E-04,   5.3683465E-04,   5.6176278E-04
     +,   5.8908871E-04,   6.1849679E-04,   6.4955972E-04
     +,   6.8175723E-04,   7.1449758E-04,   7.4716186E-04
     +,   7.7911955E-04,   8.0977235E-04,   8.3858543E-04
     +,   8.6512999E-04,   8.8913715E-04,   9.1056107E-04
     +,   9.2966430E-04,   9.4708515E-04,   9.6390286E-04
     +,   9.8165206E-04,   1.0022694E-03,   1.0279545E-03
     +,   1.0609317E-03,   1.1031567E-03,   1.1559614E-03
     +,   1.2197596E-03,   1.2938270E-03,   1.3762454E-03
     +,   1.4640267E-03,   1.5533931E-03,   1.6402332E-03
     +,   1.7205382E-03,   1.7909001E-03,   1.8488753E-03
     +,   1.8932357E-03,   1.9240889E-03,   1.9428002E-03
     +,   1.9517774E-03,   1.9540596E-03,   1.9527872E-03
     +,   1.9506047E-03,   1.9491373E-03,   1.9486789E-03
     +,   1.9481906E-03,   1.9456662E-03,   1.9387584E-03
     +,   1.9255083E-03,   1.9049438E-03,   1.8773685E-03
     +,   1.8442442E-03,   1.8077340E-03,   1.7700428E-03
     +,   1.7327724E-03,   1.6965220E-03,   1.6607863E-03
     +,   1.6242171E-03,   1.5850929E-03,   1.5418702E-03
     +,   1.4936605E-03,   1.4404681E-03,   1.3832280E-03
     +,   1.3235740E-03,   1.2634994E-03,   1.2049723E-03
     +,   1.1496004E-03,   1.0984312E-03,   1.0518634E-03
     +,   1.0097021E-03,   9.7129104E-04,   9.3567919E-04
     +,   9.0180273E-04,   8.6860865E-04,   8.3518209E-04
     +,   8.0078398E-04,   7.6489989E-04,   7.2722940E-04
     +,   6.8767736E-04,   6.4634113E-04,   6.0346699E-04
     +,   5.5944442E-04,   5.1475654E-04,   4.6995509E-04
     +,   4.2563200E-04,   3.8236624E-04,   3.4071621E-04
     +,   3.0116452E-04,   2.6411671E-04,   2.2987617E-04
     +,   1.9863079E-04,   1.7046684E-04,   1.4536970E-04
     +,   1.2324360E-04,   1.0392364E-04,   8.7198881E-05
     +,   7.2830073E-05,   6.0565580E-05,   5.0156614E-05
     +,   4.1364503E-05,   3.3969176E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wao_hz_85 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wao_hz_90(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  6.1670176E-11,   7.2922092E-11
     +,   8.6127785E-11,   1.0160736E-10,   1.1973075E-10
     +,   1.4092462E-10,   1.6567840E-10,   1.9455607E-10
     +,   2.2820493E-10,   2.6736488E-10,   3.1288411E-10
     +,   3.6573394E-10,   4.2701848E-10,   4.9800081E-10
     +,   5.8011723E-10,   6.7499806E-10,   7.8449897E-10
     +,   9.1072172E-10,   1.0560430E-09,   1.2231537E-09
     +,   1.4150909E-09,   1.6352858E-09,   1.8875881E-09
     +,   2.1763418E-09,   2.5064109E-09,   2.8832572E-09
     +,   3.3130068E-09,   3.8025094E-09,   4.3593795E-09
     +,   4.9921725E-09,   5.7103504E-09,   6.5244867E-09
     +,   7.4463076E-09,   8.4888372E-09,   9.6664472E-09
     +,   1.0995080E-08,   1.2492370E-08,   1.4177675E-08
     +,   1.6072406E-08,   1.8200117E-08,   2.0586539E-08
     +,   2.3260130E-08,   2.6251781E-08,   2.9595514E-08
     +,   3.3328345E-08,   3.7490828E-08,   4.2126768E-08
     +,   4.7284175E-08,   5.3015121E-08,   5.9375800E-08
     +,   6.6427262E-08,   7.4235828E-08,   8.2872376E-08
     +,   9.2414083E-08,   1.0294338E-07,   1.1454939E-07
     +,   1.2732755E-07,   1.4138021E-07,   1.5681722E-07
     +,   1.7375505E-07,   1.9231936E-07,   2.1264246E-07
     +,   2.3486648E-07,   2.5914213E-07,   2.8562820E-07
     +,   3.1449423E-07,   3.4591949E-07,   3.8009145E-07
     +,   4.1720972E-07,   4.5748348E-07,   5.0113277E-07
     +,   5.4838819E-07,   5.9949360E-07,   6.5469732E-07
     +,   7.1426524E-07,   7.7847187E-07,   8.4760256E-07
     +,   9.2195711E-07,   1.0018369E-06,   1.0875627E-06
     +,   1.1794618E-06,   1.2778722E-06,   1.3831452E-06
     +,   1.4956247E-06,   1.6156912E-06,   1.7437037E-06
     +,   1.8800450E-06,   2.0251000E-06,   2.1792578E-06
     +,   2.3429186E-06,   2.5164652E-06,   2.7003009E-06
     +,   2.8948241E-06,   3.1004295E-06,   3.3175095E-06
     +,   3.5464514E-06,   3.7876459E-06,   4.0414457E-06
     +,   4.3082214E-06,   4.5883203E-06,   4.8820748E-06
     +,   5.1898096E-06,   5.5117976E-06,   5.8483183E-06
     +,   6.1996193E-06,   6.5659133E-06,   6.9474022E-06
     +,   7.3441925E-06,   7.7564564E-06,   8.1842200E-06
     +,   8.6275286E-06,   9.0863659E-06,   9.5606647E-06
     +,   1.0050325E-05,   1.0555117E-05,   1.1074888E-05
     +,   1.1609286E-05,   1.2157977E-05,   1.2720538E-05
     +,   1.3296486E-05,   1.3885285E-05,   1.4486267E-05
     +,   1.5098752E-05,   1.5721967E-05,   1.6355070E-05
     +,   1.6997141E-05,   1.7647211E-05,   1.8304168E-05
     +,   1.8966903E-05,   1.9634208E-05,   2.0304817E-05
     +,   2.0977393E-05,   2.1650580E-05,   2.2322878E-05
     +,   2.2992830E-05,   2.3658922E-05,   2.4319615E-05
     +,   2.4973344E-05,   2.5618578E-05,   2.6253816E-05
     +,   2.6877544E-05,   2.7488402E-05,   2.8085129E-05
     +,   2.8666624E-05,   2.9232018E-05,   2.9780660E-05
     +,   3.0312387E-05,   3.0827363E-05,   3.1326395E-05
     +,   3.1810989E-05,   3.2283435E-05,   3.2747183E-05
     +,   3.3206794E-05,   3.3668377E-05,   3.4139750E-05
     +,   3.4630742E-05,   3.5153527E-05,   3.5722831E-05
     +,   3.6356520E-05,   3.7075577E-05,   3.7904701E-05
     +,   3.8872480E-05,   4.0011397E-05,   4.1358428E-05
     +,   4.2954416E-05,   4.4844390E-05,   4.7077006E-05
     +,   4.9703984E-05,   5.2779400E-05,   5.6357985E-05
     +,   6.0495080E-05,   6.5243083E-05,   7.0651033E-05
     +,   7.6761673E-05,   8.3609237E-05,   9.1217393E-05
     +,   9.9595658E-05,   1.0873907E-04,   1.1862529E-04
     +,   1.2921398E-04,   1.4044678E-04,   1.5224611E-04
     +,   1.6452187E-04,   1.7716856E-04,   1.9007482E-04
     +,   2.0312717E-04,   2.1621733E-04,   2.2925049E-04
     +,   2.4215072E-04,   2.5487388E-04,   2.6740690E-04
     +,   2.7977789E-04,   2.9205601E-04,   3.0434836E-04
     +,   3.1680218E-04,   3.2959154E-04,   3.4291946E-04
     +,   3.5700679E-04,   3.7209431E-04,   3.8845476E-04
     +,   4.0640222E-04,   4.2633142E-04,   4.4875088E-04
     +,   4.7434485E-04,   5.0403102E-04,   5.3901173E-04
     +,   5.8082485E-04,   6.3131476E-04,   6.9256237E-04
     +,   7.6668826E-04,   8.5552048E-04,   9.6020440E-04
     +,   1.0806802E-03,   1.2153240E-03,   1.3607645E-03
     +,   1.5121229E-03,   1.6637668E-03,   1.8105102E-03
     +,   1.9491661E-03,   2.0797881E-03,   2.2063036E-03
     +,   2.3358190E-03,   2.4765786E-03,   2.6350575E-03
     +,   2.8132626E-03,   3.0077400E-03,   3.2108407E-03
     +,   3.4142053E-03,   3.6127188E-03,   3.8070627E-03
     +,   4.0033027E-03,   4.2092097E-03,   4.4287373E-03
     +,   4.6570096E-03,   4.8790518E-03,   5.0732964E-03
     +,   5.2182851E-03,   5.2991263E-03,   5.3108577E-03
     +,   5.2589774E-03,   5.1585212E-03,   5.0318940E-03
     +,   4.9039545E-03,   4.7944780E-03,   4.7113430E-03
     +,   4.6491101E-03,   4.5940368E-03,   4.5321723E-03
     +,   4.4553764E-03,   4.3625091E-03,   4.2568455E-03
     +,   4.1421535E-03,   4.0200641E-03,   3.8892953E-03
     +,   3.7466518E-03,   3.5891836E-03,   3.4162672E-03
     +,   3.2310176E-03,   3.0400688E-03,   2.8520089E-03
     +,   2.6751668E-03,   2.5156536E-03,   2.3765815E-03
     +,   2.2581366E-03,   2.1583664E-03,   2.0740160E-03
     +,   2.0012248E-03,   1.9360653E-03,   1.8749338E-03
     +,   1.8148734E-03,   1.7537415E-03,   1.6901882E-03
     +,   1.6234994E-03,   1.5533422E-03,   1.4796149E-03
     +,   1.4023312E-03,   1.3216902E-03,   1.2381318E-03
     +,   1.1524219E-03,   1.0656666E-03,   9.7919803E-04
     +,   8.9447584E-04,   8.1288075E-04,   7.3558069E-04
     +,   6.6343800E-04,   5.9693720E-04,   5.3623953E-04
     +,   4.8119758E-04,   4.3146531E-04,   3.8656505E-04
     +,   3.4595520E-04,   3.0910704E-04,   2.7553691E-04
     +,   2.4483944E-04,   2.1669002E-04,   1.9084770E-04
     +,   1.6714309E-04,   1.4546140E-04,   1.2572677E-04
     +,   1.0788012E-04,   9.1866787E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wao_hz_90 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wao_hz_95(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  4.2508120E-08,   4.7131600E-08
     +,   5.2210883E-08,   5.7785321E-08,   6.3897353E-08
     +,   7.0592520E-08,   7.7919047E-08,   8.5928761E-08
     +,   9.4677233E-08,   1.0422279E-07,   1.1462832E-07
     +,   1.2596051E-07,   1.3828939E-07,   1.5169007E-07
     +,   1.6624183E-07,   1.8202753E-07,   1.9913573E-07
     +,   2.1765973E-07,   2.3769640E-07,   2.5934875E-07
     +,   2.8272453E-07,   3.0793700E-07,   3.3510327E-07
     +,   3.6434761E-07,   3.9579729E-07,   4.2958686E-07
     +,   4.6585512E-07,   5.0474745E-07,   5.4641197E-07
     +,   5.9100472E-07,   6.3868407E-07,   6.8961555E-07
     +,   7.4396837E-07,   8.0191825E-07,   8.6364122E-07
     +,   9.2932152E-07,   9.9914678E-07,   1.0733047E-06
     +,   1.1519905E-06,   1.2354024E-06,   1.3237360E-06
     +,   1.4171964E-06,   1.5159829E-06,   1.6203018E-06
     +,   1.7303578E-06,   1.8463587E-06,   1.9685049E-06
     +,   2.0970031E-06,   2.2320576E-06,   2.3738644E-06
     +,   2.5226236E-06,   2.6785326E-06,   2.8417755E-06
     +,   3.0125445E-06,   3.1910135E-06,   3.3773604E-06
     +,   3.5717530E-06,   3.7743516E-06,   3.9853135E-06
     +,   4.2047755E-06,   4.4328799E-06,   4.6697464E-06
     +,   4.9154946E-06,   5.1702336E-06,   5.4340508E-06
     +,   5.7070333E-06,   5.9892600E-06,   6.2807808E-06
     +,   6.5816512E-06,   6.8919062E-06,   7.2115722E-06
     +,   7.5406656E-06,   7.8792000E-06,   8.2271390E-06
     +,   8.5844786E-06,   8.9511859E-06,   9.3272220E-06
     +,   9.7125503E-06,   1.0107085E-05,   1.0510773E-05
     +,   1.0923538E-05,   1.1345305E-05,   1.1776001E-05
     +,   1.2215489E-05,   1.2663743E-05,   1.3120621E-05
     +,   1.3586041E-05,   1.4059910E-05,   1.4542135E-05
     +,   1.5032649E-05,   1.5531325E-05,   1.6038101E-05
     +,   1.6552911E-05,   1.7075685E-05,   1.7606375E-05
     +,   1.8144930E-05,   1.8691340E-05,   1.9245543E-05
     +,   1.9807558E-05,   2.0377380E-05,   2.0955040E-05
     +,   2.1540593E-05,   2.2134043E-05,   2.2735485E-05
     +,   2.3344995E-05,   2.3962675E-05,   2.4588653E-05
     +,   2.5222987E-05,   2.5865906E-05,   2.6517493E-05
     +,   2.7177924E-05,   2.7847362E-05,   2.8525990E-05
     +,   2.9214005E-05,   2.9911502E-05,   3.0618769E-05
     +,   3.1335901E-05,   3.2063079E-05,   3.2800472E-05
     +,   3.3548200E-05,   3.4306424E-05,   3.5075183E-05
     +,   3.5854569E-05,   3.6644629E-05,   3.7445370E-05
     +,   3.8256752E-05,   3.9078725E-05,   3.9911112E-05
     +,   4.0753752E-05,   4.1606425E-05,   4.2468833E-05
     +,   4.3340624E-05,   4.4221411E-05,   4.5110650E-05
     +,   4.6007830E-05,   4.6912333E-05,   4.7823465E-05
     +,   4.8740490E-05,   4.9662591E-05,   5.0588926E-05
     +,   5.1518506E-05,   5.2450403E-05,   5.3383577E-05
     +,   5.4316984E-05,   5.5249584E-05,   5.6180186E-05
     +,   5.7107842E-05,   5.8031364E-05,   5.8949754E-05
     +,   5.9862035E-05,   6.0767157E-05,   6.1664403E-05
     +,   6.2552906E-05,   6.3432031E-05,   6.4301275E-05
     +,   6.5160304E-05,   6.6008957E-05,   6.6847140E-05
     +,   6.7675232E-05,   6.8493609E-05,   6.9303038E-05
     +,   7.0104543E-05,   7.0899332E-05,   7.1689152E-05
     +,   7.2475821E-05,   7.3261675E-05,   7.4049349E-05
     +,   7.4841846E-05,   7.5642587E-05,   7.6455239E-05
     +,   7.7284116E-05,   7.8133635E-05,   7.9008780E-05
     +,   7.9914811E-05,   8.0857368E-05,   8.1842416E-05
     +,   8.2876046E-05,   8.3964733E-05,   8.5115040E-05
     +,   8.6333683E-05,   8.7627493E-05,   8.9003224E-05
     +,   9.0468064E-05,   9.2029150E-05,   9.3694252E-05
     +,   9.5472002E-05,   9.7372504E-05,   9.9408338E-05
     +,   1.0159545E-04,   1.0395575E-04,   1.0651804E-04
     +,   1.0932203E-04,   1.1242086E-04,   1.1588472E-04
     +,   1.1980578E-04,   1.2430022E-04,   1.2951369E-04
     +,   1.3562088E-04,   1.4282633E-04,   1.5136355E-04
     +,   1.6148514E-04,   1.7345865E-04,   1.8754949E-04
     +,   2.0401143E-04,   2.2307372E-04,   2.4493141E-04
     +,   2.6975898E-04,   2.9772392E-04,   3.2904855E-04
     +,   3.6409567E-04,   4.0348980E-04,   4.4829230E-04
     +,   5.0015235E-04,   5.6147028E-04,   6.3547224E-04
     +,   7.2620378E-04,   8.3845702E-04,   9.7768556E-04
     +,   1.1501302E-03,   1.3630011E-03,   1.6248570E-03
     +,   1.9456295E-03,   2.3360702E-03,   2.8064908E-03
     +,   3.3647667E-03,   4.0140054E-03,   4.7486476E-03
     +,   5.5501699E-03,   6.3838889E-03,   7.2024190E-03
     +,   7.9599768E-03,   8.6342730E-03,   9.2413835E-03
     +,   9.8249204E-03,   1.0423088E-02,   1.1041622E-02
     +,   1.1660420E-02,   1.2266484E-02,   1.2876526E-02
     +,   1.3517146E-02,   1.4167765E-02,   1.4721089E-02
     +,   1.5015278E-02,   1.4923869E-02,   1.4438368E-02
     +,   1.3691693E-02,   1.2899335E-02,   1.2233672E-02
     +,   1.1726506E-02,   1.1304767E-02,   1.0917821E-02
     +,   1.0590897E-02,   1.0347919E-02,   1.0128083E-02
     +,   9.8133683E-03,   9.3251672E-03,   8.6783562E-03
     +,   7.9573132E-03,   7.2587254E-03,   6.6506029E-03
     +,   6.1604939E-03,   5.7846671E-03,   5.5063707E-03
     +,   5.3099953E-03,   5.1842476E-03,   5.1155477E-03
     +,   5.0809444E-03,   5.0486564E-03,   4.9868175E-03
     +,   4.8745456E-03,   4.7081476E-03,   4.4994568E-03
     +,   4.2681843E-03,   4.0327958E-03,   3.8044727E-03
     +,   3.5854187E-03,   3.3713391E-03,   3.1554771E-03
     +,   2.9324405E-03,   2.7004317E-03,   2.4615352E-03
     +,   2.2208495E-03,   1.9847732E-03,   1.7594679E-03
     +,   1.5497808E-03,   1.3586634E-03,   1.1873340E-03
     +,   1.0355541E-03,   9.0223365E-04,   7.8583532E-04
     +,   6.8467250E-04,   5.9710629E-04,   5.2157335E-04
     +,   4.5659905E-04,   4.0077284E-04,   3.5276331E-04
     +,   3.1133663E-04,   2.7538161E-04,   2.4393812E-04
     +,   2.1620138E-04,   1.9152540E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wao_hz_95 = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wao_qq(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   2.1944823E-38,   5.5863907E-38,   1.4140302E-37
     +,   3.5589421E-37,   8.9067912E-37,   2.2164427E-36
     +,   5.4846608E-36,   1.3494741E-35,   3.3015667E-35
     +,   8.0317741E-35,   1.9428442E-34,   4.6732503E-34
     +,   1.1176652E-33,   2.6580660E-33,   6.2856188E-33
     +,   1.4779802E-32,   3.4556178E-32,   8.0337686E-32
     +,   1.8572317E-31,   4.2689841E-31,   9.7577062E-31
     +,   2.2176568E-30,   5.0116500E-30,   1.1261697E-29
     +,   2.5163254E-29,   5.5908759E-29,   1.2351444E-28
     +,   2.7132761E-28,   5.9266637E-28,   1.2872461E-27
     +,   2.7800523E-27,   5.9702981E-27,   1.2748649E-26
     +,   2.7068810E-26,   5.7149749E-26,   1.1997699E-25
     +,   2.5044857E-25,   5.1986560E-25,   1.0729731E-24
     +,   2.2020492E-24,   4.4936641E-24,   9.1183525E-24
     +,   1.8397871E-23,   3.6911303E-23,   7.3637969E-23
     +,   1.4607360E-22,   2.8812381E-22,   5.6510284E-22
     +,   1.1020851E-21,   2.1372265E-21,   4.1210445E-21
     +,   7.9017268E-21,   1.5064912E-20,   2.8559538E-20
     +,   5.3837819E-20,   1.0091156E-19,   1.8808673E-19
     +,   3.4858029E-19,   6.4237719E-19,   1.1771142E-18
     +,   2.1448038E-18,   3.8860424E-18,   7.0008448E-18
     +,   1.2541677E-17,   2.2340491E-17,   3.9570623E-17
     +,   6.9695790E-17,   1.2205767E-16,   2.1256235E-16
     +,   3.6808023E-16,   6.3378960E-16,   1.0851602E-15
     +,   1.8475167E-15,   3.1278038E-15,   5.2652703E-15
     +,   8.8139004E-15,   1.4670916E-14,   2.4282663E-14
     +,   3.9965664E-14,   6.5408101E-14,   1.0644799E-13
     +,   1.7226200E-13,   2.7720366E-13,   4.4357421E-13
     +,   7.0581589E-13,   1.1168315E-12,   1.7572368E-12
     +,   2.7494858E-12,   4.2779222E-12,   6.6188461E-12
     +,   1.0183655E-11,   1.5581090E-11,   2.3706946E-11
     +,   3.5868881E-11,   5.3970415E-11,   8.0755513E-11
     +,   1.2016454E-10,   1.7781950E-10,   2.6167699E-10
     +,   3.8296996E-10,   5.5738542E-10,   8.0680357E-10
     +,   1.1614331E-09,   1.6627524E-09,   2.3675424E-09
     +,   3.3526464E-09,   4.7220046E-09,   6.6145938E-09
     +,   9.2157659E-09,   1.2770950E-08,   1.7602394E-08
     +,   2.4132669E-08,   3.2909259E-08,   4.4640036E-08
     +,   6.0233667E-08,   8.0845943E-08,   1.0794732E-07
     +,   1.4338288E-07,   1.8946609E-07,   2.4907337E-07
     +,   3.2575994E-07,   4.2389806E-07,   5.4880724E-07
     +,   7.0697655E-07,   9.0619153E-07,   1.1558070E-06
     +,   1.4669586E-06,   1.8528253E-06,   2.3289349E-06
     +,   2.9133521E-06,   3.6272293E-06,   4.4948088E-06
     +,   5.5440210E-06,   6.8066765E-06,   8.3188124E-06
     +,   1.0121076E-05,   1.2258598E-05,   1.4782083E-05
     +,   1.7746836E-05,   2.1213791E-05,   2.5249086E-05
     +,   2.9924066E-05,   3.5315250E-05,   4.1503139E-05
     +,   4.8572896E-05,   5.6612815E-05,   6.5713670E-05
     +,   7.5967844E-05,   8.7466069E-05,   1.0030027E-04
     +,   1.1455575E-04,   1.3031399E-04,   1.4764871E-04
     +,   1.6662038E-04,   1.8728124E-04,   2.0966158E-04
     +,   2.3377937E-04,   2.5962581E-04,   2.8716723E-04
     +,   3.1634924E-04,   3.4707962E-04,   3.7924407E-04
     +,   4.1268783E-04,   4.4722765E-04,   4.8264742E-04
     +,   5.1869365E-04,   5.5509183E-04,   5.9153012E-04
     +,   6.2767818E-04,   6.6318497E-04,   6.9768535E-04
     +,   7.3080743E-04,   7.6217484E-04,   7.9142099E-04
     +,   8.1819255E-04,   8.4215682E-04,   8.6301123E-04
     +,   8.8048616E-04,   8.9435879E-04,   9.0444920E-04
     +,   9.1063266E-04,   9.1283681E-04,   9.1104716E-04
     +,   9.0530497E-04,   8.9570845E-04,   8.8240579E-04
     +,   8.6559681E-04,   8.4552343E-04,   8.2246470E-04
     +,   7.9673395E-04,   7.6866150E-04,   7.3860172E-04
     +,   7.0690858E-04,   6.7394355E-04,   6.4006296E-04
     +,   6.0560467E-04,   5.7089364E-04,   5.3623051E-04
     +,   5.0189416E-04,   4.6813095E-04,   4.3515873E-04
     +,   4.0316459E-04,   3.7230385E-04,   3.4270532E-04
     +,   3.1446590E-04,   2.8765711E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wao_qq = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wao_ww(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   1.5364098E-38,   3.1977589E-38,   6.6320357E-38
     +,   1.3705893E-37,   2.8225411E-37,   5.7919638E-37
     +,   1.1843517E-36,   2.4131714E-36,   4.8996099E-36
     +,   9.9127486E-36,   1.9984472E-35,   4.0146745E-35
     +,   8.0365088E-35,   1.6030745E-34,   3.1863678E-34
     +,   6.3110368E-34,   1.2455793E-33,   2.4496156E-33
     +,   4.8005815E-33,   9.3744110E-33,   1.8241339E-32
     +,   3.5369617E-32,   6.8339715E-32,   1.3157458E-31
     +,   2.5242462E-31,   4.8256672E-31,   9.1926818E-31
     +,   1.7449702E-30,   3.3006520E-30,   6.2211265E-30
     +,   1.1684388E-29,   2.1867398E-29,   4.0780339E-29
     +,   7.5782184E-29,   1.4032856E-28,   2.5893408E-28
     +,   4.7609282E-28,   8.7228815E-28,   1.5925174E-27
     +,   2.8971504E-27,   5.2519878E-27,   9.4871132E-27
     +,   1.7076820E-26,   3.0629916E-26,   5.4744519E-26
     +,   9.7498881E-26,   1.7302860E-25,   3.0598406E-25
     +,   5.3918845E-25,   9.4679618E-25,   1.6566156E-24
     +,   2.8883600E-24,   5.0181091E-24,   8.6874325E-24
     +,   1.4986964E-23,   2.5762632E-23,   4.4129365E-23
     +,   7.5322730E-23,   1.2811119E-22,   2.1712951E-22
     +,   3.6668519E-22,   6.1709027E-22,   1.0348005E-21
     +,   1.7291217E-21,   2.8791019E-21,   4.7769543E-21
     +,   7.8979488E-21,   1.3011587E-20,   2.1360448E-20
     +,   3.4942161E-20,   5.6957608E-20,   9.2515893E-20
     +,   1.4974137E-19,   2.4151172E-19,   3.8813889E-19
     +,   6.2158125E-19,   9.9190577E-19,   1.5772680E-18
     +,   2.4992507E-18,   3.9460953E-18,   6.2085050E-18
     +,   9.7335021E-18,   1.5205929E-17,   2.3671514E-17
     +,   3.6718580E-17,   5.6757395E-17,   8.7420510E-17
     +,   1.3417323E-16,   2.0520137E-16,   3.1272051E-16
     +,   4.7489945E-16,   7.1861095E-16,   1.0835843E-15
     +,   1.6281206E-15,   2.4376460E-15,   3.6367889E-15
     +,   5.4066278E-15,   8.0094588E-15,   1.1823224E-14
     +,   1.7391233E-14,   2.5490931E-14,   3.7230913E-14
     +,   5.4185541E-14,   7.8583224E-14,   1.1356201E-13
     +,   1.6353024E-13,   2.3465225E-13,   3.3551601E-13
     +,   4.7803921E-13,   6.7870541E-13,   9.6018516E-13
     +,   1.3536006E-12,   1.9014625E-12,   2.6616242E-12
     +,   3.7125086E-12,   5.1600135E-12,   7.1466162E-12
     +,   9.8629525E-12,   1.3563605E-11,   1.8586804E-11
     +,   2.5380279E-11,   3.4534636E-11,   4.6823639E-11
     +,   6.3262624E-11,   8.5169954E-11,   1.1425810E-10
     +,   1.5274040E-10,   2.0345782E-10,   2.7006289E-10
     +,   3.5720138E-10,   4.7078552E-10,   6.1829392E-10
     +,   8.0914947E-10,   1.0551858E-09,   1.3711403E-09
     +,   1.7754379E-09,   2.2908009E-09,   2.9453087E-09
     +,   3.7734704E-09,   4.8173128E-09,   6.1282850E-09
     +,   7.7683922E-09,   9.8126458E-09,   1.2351044E-08
     +,   1.5491164E-08,   1.9361126E-08,   2.4112008E-08
     +,   2.9923079E-08,   3.7003211E-08,   4.5597016E-08
     +,   5.5988341E-08,   6.8505273E-08,   8.3525343E-08
     +,   1.0147883E-07,   1.2285672E-07,   1.4821431E-07
     +,   1.7817612E-07,   2.1344270E-07,   2.5478732E-07
     +,   3.0307660E-07,   3.5925095E-07,   4.2434525E-07
     +,   4.9948085E-07,   5.8586716E-07,   6.8480307E-07
     +,   7.9765391E-07,   9.2588982E-07,   1.0710196E-06
     +,   1.2346287E-06,   1.4183527E-06,   1.6238320E-06
     +,   1.8527790E-06,   2.1068404E-06,   2.3877201E-06
     +,   2.6970315E-06,   3.0363226E-06,   3.4071511E-06
     +,   3.8108719E-06,   4.2488582E-06,   4.7222579E-06
     +,   5.2321561E-06,   5.7795164E-06,   6.3650946E-06
     +,   6.9896828E-06,   7.6538172E-06,   8.3580471E-06
     +,   9.1028833E-06,   9.8887176E-06,   1.0716180E-05
     +,   1.1585787E-05,   1.2498316E-05,   1.3454731E-05
     +,   1.4456257E-05,   1.5504493E-05,   1.6601258E-05
     +,   1.7749098E-05,   1.8950746E-05,   2.0209616E-05
     +,   2.1529599E-05,   2.2915105E-05,   2.4371097E-05
     +,   2.5902758E-05,   2.7516071E-05,   2.9216870E-05
     +,   3.1011416E-05,   3.2905959E-05,   3.4906603E-05
     +,   3.7019257E-05,   3.9249026E-05,   4.1600932E-05
     +,   4.4078533E-05,   4.6684694E-05,   4.9420967E-05
     +,   5.2287542E-05,   5.5283166E-05,   5.8404647E-05
     +,   6.1647406E-05,   6.5005021E-05,   6.8469286E-05
     +,   7.2030438E-05,   7.5676493E-05,   7.9394886E-05
     +,   8.3170657E-05,   8.6988133E-05,   9.0830566E-05
     +,   9.4679730E-05,   9.8517732E-05,   1.0232499E-04
     +,   1.0608280E-04,   1.0977145E-04,   1.1337131E-04
     +,   1.1686371E-04,   1.2022926E-04,   1.2345002E-04
     +,   1.2650769E-04,   1.2938502E-04,   1.3206547E-04
     +,   1.3453269E-04,   1.3677182E-04,   1.3876821E-04
     +,   1.4050835E-04,   1.4197969E-04,   1.4317063E-04
     +,   1.4407080E-04,   1.4467102E-04,   1.4496357E-04
     +,   1.4494227E-04,   1.4460267E-04,   1.4394216E-04
     +,   1.4296021E-04,   1.4165834E-04,   1.4004060E-04
     +,   1.3811296E-04,   1.3588427E-04,   1.3336560E-04
     +,   1.3057030E-04,   1.2751448E-04,   1.2421564E-04
     +,   1.2069417E-04,   1.1697166E-04,   1.1307120E-04
     +,   1.0901774E-04,   1.0483599E-04,   1.0055247E-04
     +,   9.6192598E-05,   9.1782611E-05,   8.7348286E-05
     +,   8.2913670E-05,   7.8502468E-05,   7.4136580E-05
     +,   6.9836897E-05,   6.5621985E-05,   6.1508668E-05
     +,   5.7511814E-05,   5.3644053E-05,   4.9916434E-05
     +,   4.6337529E-05,   4.2914089E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wao_ww = Yx
      RETURN
      END
      DOUBLE PRECISION FUNCTION A2016_hnn_wao_zz(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 110.4/
      DATA y /  8.1390408E-06,   8.1560420E-06
     +,   8.1542348E-06,   8.1336339E-06,   8.0943810E-06
     +,   8.0367445E-06,   7.9611236E-06,   7.8680341E-06
     +,   7.7581026E-06,   7.6320730E-06,   7.4907825E-06
     +,   7.3351539E-06,   7.1662030E-06,   6.9850030E-06
     +,   6.7926844E-06,   6.5904364E-06,   6.3794687E-06
     +,   6.1610149E-06,   5.9363269E-06,   5.7066486E-06
     +,   5.4732091E-06,   5.2372134E-06,   4.9998453E-06
     +,   4.7622270E-06,   4.5254496E-06,   4.2905317E-06
     +,   4.0584314E-06,   3.8300336E-06,   3.6061617E-06
     +,   3.3875463E-06,   3.1748525E-06,   2.9686564E-06
     +,   2.7694541E-06,   2.5776621E-06,   2.3936270E-06
     +,   2.2176107E-06,   2.0498019E-06,   1.8903302E-06
     +,   1.7392507E-06,   1.5965593E-06,   1.4622038E-06
     +,   1.3360713E-06,   1.2180138E-06,   1.1078358E-06
     +,   1.0053095E-06,   9.1017597E-07,   8.2215723E-07
     +,   7.4094953E-07,   6.6623437E-07,   5.9768706E-07
     +,   5.3497121E-07,   4.7774756E-07,   4.2568001E-07
     +,   3.7843145E-07,   3.3567392E-07,   2.9708440E-07
     +,   2.6235074E-07,   2.3117181E-07,   2.0325885E-07
     +,   1.7833796E-07,   1.5614779E-07,   1.3644340E-07
     +,   1.1899366E-07,   1.0358276E-07,   9.0010957E-08
     +,   7.8092079E-08,   6.7654724E-08,   5.8541922E-08
     +,   5.0609493E-08,   4.3726224E-08,   3.7772953E-08
     +,   3.2641879E-08,   2.8235682E-08,   2.4467452E-08
     +,   2.1258908E-08,   1.8540430E-08,   1.6250135E-08
     +,   1.4333160E-08,   1.2741305E-08,   1.1431958E-08
     +,   1.0367860E-08,   9.5164667E-09,   8.8494376E-09
     +,   8.3422957E-09,   7.9737390E-09,   7.7255713E-09
     +,   7.5821260E-09,   7.5300450E-09,   7.5579747E-09
     +,   7.6563129E-09,   7.8169657E-09,   8.0331670E-09
     +,   8.2992830E-09,   8.6106642E-09,   8.9634966E-09
     +,   9.3546895E-09,   9.7817834E-09,   1.0242789E-08
     +,   1.0736208E-08,   1.1260906E-08,   1.1816057E-08
     +,   1.2401132E-08,   1.3015755E-08,   1.3659804E-08
     +,   1.4333292E-08,   1.5036374E-08,   1.5769331E-08
     +,   1.6532431E-08,   1.7326226E-08,   1.8151130E-08
     +,   1.9007741E-08,   1.9896669E-08,   2.0818588E-08
     +,   2.1774243E-08,   2.2764274E-08,   2.3789637E-08
     +,   2.4851060E-08,   2.5949467E-08,   2.7085797E-08
     +,   2.8261042E-08,   2.9476292E-08,   3.0732561E-08
     +,   3.2031075E-08,   3.3373087E-08,   3.4759925E-08
     +,   3.6193018E-08,   3.7673942E-08,   3.9204227E-08
     +,   4.0785689E-08,   4.2420218E-08,   4.4109846E-08
     +,   4.5856762E-08,   4.7663423E-08,   4.9532247E-08
     +,   5.1466053E-08,   5.3467840E-08,   5.5540834E-08
     +,   5.7688524E-08,   5.9914690E-08,   6.2223506E-08
     +,   6.4619194E-08,   6.7106633E-08,   6.9690962E-08
     +,   7.2377802E-08,   7.5173297E-08,   7.8083680E-08
     +,   8.1116468E-08,   8.4279058E-08,   8.7579934E-08
     +,   9.1028326E-08,   9.4633791E-08,   9.8407703E-08
     +,   1.0236158E-07,   1.0650858E-07,   1.1086316E-07
     +,   1.1544123E-07,   1.2026074E-07,   1.2534097E-07
     +,   1.3070502E-07,   1.3637771E-07,   1.4238827E-07
     +,   1.4877064E-07,   1.5556361E-07,   1.6281518E-07
     +,   1.7058161E-07,   1.7893315E-07,   1.8795750E-07
     +,   1.9776590E-07,   2.0850212E-07,   2.2035154E-07
     +,   2.3356081E-07,   2.4845130E-07,   2.6544981E-07
     +,   2.8511826E-07,   3.0819467E-07,   3.3564331E-07
     +,   3.6870856E-07,   4.0898877E-07,   4.5850769E-07
     +,   5.1979663E-07,   5.9598131E-07,   6.9084621E-07
     +,   8.0894210E-07,   9.5558687E-07,   1.1369343E-06
     +,   1.3599418E-06,   1.6323231E-06,   1.9624613E-06
     +,   2.3592006E-06,   2.8318298E-06,   3.3896888E-06
     +,   4.0421933E-06,   4.7986932E-06,   5.6683721E-06
     +,   6.6608040E-06,   7.7858685E-06,   9.0550238E-06
     +,   1.0481625E-05,   1.2082162E-05,   1.3877728E-05
     +,   1.5893933E-05,   1.8162345E-05,   2.0718719E-05
     +,   2.3602046E-05,   2.6850927E-05,   3.0498177E-05
     +,   3.4566598E-05,   3.9061568E-05,   4.3969630E-05
     +,   4.9260121E-05,   5.4894976E-05,   6.0852963E-05
     +,   6.7161498E-05,   7.3945797E-05,   8.1483595E-05
     +,   9.0263238E-05,   1.0103726E-04,   1.1485753E-04
     +,   1.3309013E-04,   1.5736811E-04,   1.8947262E-04
     +,   2.3107752E-04,   2.8332500E-04,   3.4623992E-04
     +,   4.1807201E-04,   4.9486902E-04,   5.7050504E-04
     +,   6.3759089E-04,   6.8915234E-04,   7.2074542E-04
     +,   7.3217251E-04,   7.2795630E-04,   7.1609579E-04
     +,   7.0537906E-04,   7.0227339E-04,   7.0873916E-04
     +,   7.2197907E-04,   7.3625712E-04,   7.4593956E-04
     +,   7.4832473E-04,   7.4502273E-04,   7.4146292E-04
     +,   7.4504147E-04,   7.6284155E-04,   7.9957931E-04
     +,   8.5591909E-04,   9.2721923E-04,   1.0031629E-03
     +,   1.0690378E-03,   1.1091130E-03,   1.1111769E-03
     +,   1.0704936E-03,   9.9122385E-04,   8.8474917E-04
     +,   7.6578965E-04,   6.4834068E-04,   5.4281729E-04
     +,   4.5521552E-04,   3.8763758E-04,   3.3950072E-04
     +,   3.0865765E-04,   2.9211631E-04,   2.8647110E-04
     +,   2.8813892E-04,   2.9361714E-04,   2.9978671E-04
     +,   3.0424193E-04,   3.0554179E-04,   3.0330080E-04
     +,   2.9807584E-04,   2.9108327E-04,   2.8382431E-04
     +,   2.7770942E-04,   2.7376352E-04,   2.7245950E-04
     +,   2.7367202E-04,   2.7675036E-04,   2.8066558E-04
     +,   2.8420228E-04,   2.8615686E-04,   2.8551498E-04
     +,   2.8158404E-04,   2.7406405E-04,   2.6305360E-04
     +,   2.4899881E-04,   2.3259057E-04,   2.1465379E-04
     +,   1.9601715E-04,   1.7742495E-04,   1.5946616E-04
     +,   1.4254134E-04,   1.2687423E-04,   1.1253633E-04
     +,   9.9492565E-05,   8.7643770E-05,   7.6867764E-05
     +,   6.7048102E-05,   5.8089900E-05,   4.9927225E-05
     +,   4.2518048E-05,   3.5838471E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A2016_hnn_wao_zz = Yx
      RETURN
      END
