c 4jets flavour independent 189 GeV
c----------------------------------
c Author:- Jean-Michel Pascolo
c Efficiencies at 189,192,200,202GeV start at 40GeV/c2
      Real FUNCTION A189_HGG_EFF(amass,err)
      implicit none
      integer i,nmas
      parameter (nmas=19)
      real hmass(nmas),effi(nmas),geni(nmas)
      real eff,eff1,eff2,del1,del2,amass
c
      data hmass /40.,45.,50.,55.,60.,65.,70.,72.,73.,75.,80.,85.,90.,95
     &     .,96.,97.,98.,99.,100./
      data effi  /20.12,21.07,22.01,22.15,21.42,21.46,22.17,17.02,17.05
     &     ,17.13,30.68,26.16,30.82,29.34,32.40,33.22,32.86,28.28,27.05/
      Logical err
      data geni /9999.,9999.,9999.,9999.,9999.,9999.,9999.,5000.,4000.
     &     ,9999.,9999.,9999.,9999.,9999.,5000.,5000.,5000.,5000.,9999./
      A189_HGG_EFF = 0.
      If (amass.lt.hmass(1))    return
      If (amass.gt.hmass(nmas)) return
      Do i=2,nmas
        If (amass.le.hmass(i)) then
            eff1 = effi(i-1)
            eff2 = effi(i)
            If (err) then       ! Si c''est l'erreur stat alors sigma=sqrt( (100-effi) / (effi*geni) )
              eff1 = sqrt( (100.-eff1) / (eff1*geni(i-1)) ) *100.
              eff2 = sqrt( (100.-eff2) / (eff2*geni(i)) )   *100.
            Endif
            del1 = amass - hmass(i-1)
            del2 = hmass(i) - amass
            goto 1000
         endif
      Enddo
 1000 continue
      eff = (eff1*del2 + eff2*del1) / (del1 + del2)
      A189_HGG_EFF = max(eff,0.) / 100.
      RETURN 
      END
      Real FUNCTION A192_HGG_EFF(amass,err)
      implicit none
      integer i,nmas
      parameter (nmas=17)
      real hmass(nmas),effi(nmas),geni(nmas)
      real eff,eff1,eff2,del1,del2,amass
c
      data hmass /40.,45.,50.,55.,60.,65.,70.,75.,80.,85.,90.,95.,98.,99
     &     .,100.,101.,102./
      data effi  /22.54,17.60,21.03,20.06,19.36,17.41,17.42,18.00,26.85
     &     ,30.44,28.40,26.16,23.92,21.90,18.02,8.68,3.18/
      Logical err
      data geni /9999.,5000.,9999.,9999.,2000.,9748.,9999.,9999.,9999.
     &     ,9999.,9999.,9794.,5000.,5000.,8973.,5000.,5000./
      A192_HGG_EFF = 0.
      If (amass.lt.hmass(1))    return
      If (amass.gt.hmass(nmas)) return
      Do i=2,nmas
        If (amass.le.hmass(i)) then
            eff1 = effi(i-1)
            eff2 = effi(i)
            If (err) then       ! Si c''est l'erreur stat alors sigma=sqrt( (100-effi) / (effi*geni) )
              eff1 = sqrt( (100.-eff1) / (eff1*geni(i-1)) )*100.
              eff2 = sqrt( (100.-eff2) / (eff2*geni(i)) )*100.
            Endif
            del1 = amass - hmass(i-1)
            del2 = hmass(i) - amass
            goto 1000
         endif
      Enddo
 1000 continue
      eff = (eff1*del2 + eff2*del1) / (del1 + del2)
      A192_HGG_EFF = max(eff,0.) / 100.
      RETURN 
      END
      Real FUNCTION A196_HGG_EFF(amass,err)
      implicit none
      integer i,nmas
      parameter (nmas=16)
      real hmass(nmas),effi(nmas),geni(nmas)
      real eff,eff1,eff2,del1,del2,amass
c
      data hmass /40.,45.,50.,55.,60.,65.,70.,75.,80.,85.,90.,95.,100.
     &     ,103.,104.,105./
      data effi  /22.10,19.55,20.50,20.55,21.87,16.60,17.65,18.06,26.06
     &     ,29.02,29.94,28.17,30.14,22.65,18.96,10.81/
      Logical err
      data geni /5000.,4000.,4000.,4000.,1999.,1999.,1999.,1999.,1999.
     &     ,1999.,1999.,1999.,1999.,4000.,5000.,1999./
      A196_HGG_EFF = 0.
      If (amass.lt.hmass(1))    return
      If (amass.gt.hmass(nmas)) return
      Do i=2,nmas
        If (amass.le.hmass(i)) then
            eff1 = effi(i-1)
            eff2 = effi(i)
            If (err) then       ! Si c''est l'erreur stat alors sigma=sqrt( (100-effi) / (effi*geni) )
              eff1 = sqrt( (100.-eff1) / (eff1*geni(i-1)) )*100.
              eff2 = sqrt( (100.-eff2) / (eff2*geni(i)) )*100.
            Endif
            del1 = amass - hmass(i-1)
            del2 = hmass(i) - amass
            goto 1000
         endif
      Enddo
 1000 continue
      eff = (eff1*del2 + eff2*del1) / (del1 + del2)
      A196_HGG_EFF = max(eff,0.) / 100.
      RETURN 
      END
      Real FUNCTION A200_HGG_EFF(amass,err)
      implicit none
      integer i,nmas
      parameter (nmas=19)
      real hmass(nmas),effi(nmas),geni(nmas)
      real eff,eff1,eff2,del1,del2,amass
c
      data hmass /40.,45.,50.,55.,60.,65.,70.,75.,80.,85.,90.,95.,100.
     &     ,105.,106.,107.,108.,109.,110./
      data effi  /21.14,19.13,21.19,22.44,21.65,17.90,18.56,16.81,25.49
     &     ,26.38,30.81,30.57,31.52,33.57,32.86,33.3,32.83,26.44,30.01/
      Logical err
      data geni /9999.,9999.,9999.,8999.,9999.,9999.,9999.,9999.,9999.
     &     ,9999.,9999.,9150.,9999.,8999.,5000.,5000.,3000.,5000.,9999./
      A200_HGG_EFF = 0.
      If (amass.lt.hmass(1))    return
      If (amass.gt.hmass(nmas)) return
      Do i=2,nmas
        If (amass.le.hmass(i)) then
            eff1 = effi(i-1)
            eff2 = effi(i)
            If (err) then       ! Si c''est l'erreur stat alors sigma=sqrt( (100-effi) / (effi*geni) )
              eff1 = sqrt( (100.-eff1) / (eff1*geni(i-1)) )*100.
              eff2 = sqrt( (100.-eff2) / (eff2*geni(i)) )*100.
            Endif
            del1 = amass - hmass(i-1)
            del2 = hmass(i) - amass
            goto 1000
         endif
      Enddo
 1000 continue
      eff = (eff1*del2 + eff2*del1) / (del1 + del2)
      A200_HGG_EFF = max(eff,0.) / 100.
      RETURN 
      END
      Real FUNCTION A202_HGG_EFF(amass,err)
      implicit none
      integer i,nmas
      parameter (nmas=19)
      real hmass(nmas),effi(nmas),geni(nmas)
      real eff,eff1,eff2,del1,del2,amass
c
      data hmass /40.,45.,50.,55.,60.,65.,70.,75.,80.,85.,90.,95.,100.
     &     ,105.,106.,107.,108.,109.,110./
      data effi  /20.37,19.44,20.04,22.9,21.22,19.01,18.76,16.88,25.12
     &     ,26.11,30.26,31.11,31.33,29.74,35.00,38.50,42.95,47.40,41.09/
      Logical err
      data geni /9999.,8999.,9999.,8999.,4999.,4999.,4999.,4999.,4999.
     &     ,4999.,4999.,4999.,4999.,2000.,3000.,2000.,2000.,2000.,9999./
      A202_HGG_EFF = 0.
      If (amass.lt.hmass(1))    return
      If (amass.gt.hmass(nmas)) return
      Do i=2,nmas
        If (amass.le.hmass(i)) then
            eff1 = effi(i-1)
            eff2 = effi(i)
            If (err) then       ! Si c''est l'erreur stat alors sigma=sqrt( (100-effi) / (effi*geni) )
              eff1 = sqrt( (100.-eff1) / (eff1*geni(i-1)) )*100.
              eff2 = sqrt( (100.-eff2) / (eff2*geni(i)) )*100.
            Endif
            del1 = amass - hmass(i-1)
            del2 = hmass(i) - amass
            goto 1000
         endif
      Enddo
 1000 continue
      eff = (eff1*del2 + eff2*del1) / (del1 + del2)
      A202_HGG_EFF = max(eff,0.) / 100.
      RETURN 
      END
      Real FUNCTION A2000_HGG_EFF(mhiggs,sqrts,iana,err)
      Implicit none
      Real mhiggs
      Integer iana
      Real sqrts
      include 'a_2000_vars.inc'
c300 (iana=1) analyse flavor independante en totalite, efficacites sur ggluons
c301 (iana=2) analyse flavor independante et .not. bbbar, efficacites
C sur ggluons. Not used
c
      Logical first,err
      Data first /.TRUE./
c
      Integer necms
      Parameter (necms = 4)
      Integer nmhmax,niana
      Parameter (nmhmax = 1000 , niana = 2)
c
      Integer i,ii,j,n1,n2,igen
      Character*50 file,file1
c
      Real ecms(necms),mh,mh1,mh2
      Character*5 nameecms(necms)
      Data ecms     /201.3,205.2,206.7,208.2/
      Data nameecms /'201.6','205.2','206.7','208.1'/
c
      Integer j1,j2,imax
      Integer im1,im2,im3,im4
      Real m1,m2,eff1,eff2,eff3,eff4
      Real int,int1,int2
      Real tmp1,tmp2,err1,err2,err3,err4,errint1,errint2,errsig
      Parameter (imax=1000000)
c
      Real ecml,ecmh
c
      Integer nmhmc(necms),genmc(nmhmax,necms)
      Real tablemh(nmhmax,necms),tablesig(nmhmax,necms)
      Data nmhmc/24,20,20,20/
      Integer itemp1(96),itemp2(96),itemp3(96)
      Data (itemp1(i),i=       1,      96)/
     &   9999,  8999,  9999,  8999,  4999,  4996,  4996,  4994,
     &   4996,  4985,  4989,  4984,  4978,  1990,  2987,  1993,
     &   1990,  1987,  9953,  1985,  1990,  1990,  1990,  1987,
     &   4999,  4999,  4999,  4999,  9996,  9994,  9992,  9802,
     &   9984,  9017,  9973,  8984,  9962,  7969,  7959,  1992,
     &   1989,  1988,  1990,  1991,     0,     0,     0,     0,
     &   9999,  9999,  9999,  9999,  9992,  9996,  9989,  9982,
     &   9984,  9983,  9977,  8973,  9973,  9959,  9957,  1994,
     &   1994,  1990,  1988,  9950,     0,     0,     0,     0,
     &   4999,  4999,  4999,  4999,  9990,  9995,  9984,  9985,
     &   9989,  9982,  9985,  9978,  9413,  9969,  9966,   996,
     &   1993,
     &   1995,
     &   2183,
     &   9961,
     &      0,
     &      0,
     &      0,
     &      0/
      Data (itemp2(i),i=       1,      96)/
     &     40,    45,    50,    55,    60,    65,    70,    75,
     &     80,    85,    90,    95,   100,   105,   106,   107,
     &    108,   109,   110,   111,   112,   113,   114,   115,
     &     40,    45,    50,    55,    60,    65,    70,    75,
     &     80,    85,    90,    95,   100,   105,   110,   111,
     &    112,   113,   114,   115,     0,     0,     0,     0,
     &     40,    45,    50,    55,    60,    65,    70,    75,
     &     80,    85,    90,    95,   100,   105,   110,   111,
     &    112,   113,   114,   115,     0,     0,     0,     0,
     &     40,    45,    50,    55,    60,    65,    70,    75,
     &     80,    85,    90,    95,   100,   105,   110,   111,
     &    112,
     &    113,
     &    114,
     &    115,
     &      0,
     &      0,
     &      0,
     &      0/
      Data (itemp3(i),i=       1,      96)/
     &   2037,  1750,  2004,  2061,   987,  1084,   903,   975,
     &   1267,  1324,  1353,  1323,  1473,   436,   764,   465,
     &    460,   438,  1505,   164,    58,    32,    10,     5,
     &    972,   950,  1108,  1084,  1972,  2212,  1709,  1741,
     &   2320,  2240,  2704,  2360,  2863,  1988,  2241,   556,
     &    513,   455,   394,   261,     0,     0,     0,     0,
     &   1968,  2010,  2258,  2180,  2049,  2187,  1773,  1840,
     &   2256,  2476,  2711,  2471,  2914,  2486,  3183,   593,
     &    615,   613,   595,  3069,     0,     0,     0,     0,
     &    988,   987,  1188,  1082,  2065,  2173,  1847,  1662,
     &   2147,  2391,  2628,  2683,  2683,  2516,  3291,   352,
     &    704,
     &    676,
     &    809,
     &   3851,
     &      0,
     &      0,
     &      0,
     &      0/
      Save tablemh,tablesig,genmc
      Integer ind,k
c
      If (first) then           ! Lecture des bruits de fond
        first = .FALSE.
c
        ind = 0
        Do j=1,4
          Do k=1,24
            ind = ind + 1
            genmc(k,j) = itemp1(ind)
            tablemh(k,j) = itemp2(ind)
            tablesig(k,j) = itemp3(ind)
          Enddo
        Enddo
c
      Endif
c
      j1 = 0
      j2 = 0
      Do i=1,necms-1
        If (sqrts.ge.ecms(i) .and. sqrts.le.ecms(i+1))
     &       then
          j1 = i
          j2 = i + 1
        Endif
      Enddo
      If (j1.eq.0) stop 41
      If (mhiggs.lt.tablemh(1,j1) .or. mhiggs.lt.tablemh(1
     &     ,j2) .or. mhiggs.gt.tablemh(nmhmc(j1),j1) .or.
     &     mhiggs.gt.tablemh(nmhmc(j2),j2)) then
        A2000_HGG_EFF = 0E0
        Return
      Endif
c
      ecml = ecms(j1)
      ecmh = ecms(j2)
c
      m1 = mhiggs+ecml-sqrts
      m2 = mhiggs+ecmh-sqrts
      m1 = Max(m1,tablemh(1,j1))
      m2 = Min(m2,tablemh(nmhmc(j2),j2))
c
      im1 = 0
      im2 = 0
      Do i=1,nmhmc(j1)-1          ! On parcourt toutes les masses du ecm1
        If (m1.ge.tablemh(i,j1) .and. m1.le.tablemh(i+1,j1))then
          im1 = i
          im2 = i + 1
          goto 30
        Endif
      Enddo
 30   CONTINUE
      If (im1.eq.0) then
        Print*,'im1=0 dans Aeffgg_2000'
        stop
      Endif
      im3 = 0
      im4 = 0
      Do i=1,nmhmc(j2)-1          ! On parcourt toutes les masses du ecm2
        If (m2.ge.tablemh(i,j2) .and. m2.le.tablemh(i+1,j2))then
          im3 = i
          im4 = i + 1
          goto 40
        Endif
      Enddo
 40   CONTINUE
      If (im3.eq.0) then
        Print*,'im3=0 dans Aeffgg_2000'
        stop
      Endif
c
      If (im1.ne.0) then
        tmp1 = tablesig(im1,j1)
        tmp2 = genmc(im1,j1)
        eff1 = tmp1/tmp2
        err1 = 0.
        If (tmp1.ne.0.) err1 = sqrt( (tmp2-tmp1)/(tmp2*tmp1) )
        tmp1 = tablesig(im2,j1)
        tmp2 = genmc(im2,j1)
        eff2 = tmp1/tmp2
        err2 = 0.
        If (tmp1.ne.0.) err2 = sqrt( (tmp2-tmp1)/(tmp2*tmp1) )
        int1=eff1*(tablemh(im2,j1)-m1)+eff2*(m1-tablemh(im1,j1))
        int1 = int1/(tablemh(im2,j1)-tablemh(im1,j1))
        errint1=err1*(tablemh(im2,j1)-m1)+err2*(m1-tablemh(im1,j1))
        errint1 = errint1/(tablemh(im2,j1)-tablemh(im1,j1))
      Endif
c
      If (im3.ne.0) then
        tmp1 = tablesig(im3,j2)
        tmp2 = genmc(im3,j2)
        eff3 = tmp1/tmp2
        err3 = 0.
        If (tmp1.ne.0.) err3 = sqrt( (tmp2-tmp1)/(tmp2*tmp1) )
        tmp1 = tablesig(im4,j2)
        tmp2 = genmc(im4,j2)
        eff4 = tmp1/tmp2
        err4 = 0.
        If (tmp1.ne.0.) err4 = sqrt( (tmp2-tmp1)/(tmp2*tmp1) )
        int2=eff3*(tablemh(im4,j2)-m2)+eff4*(m2-tablemh(im3,j2))
        int2 = int2/(tablemh(im4,j2)-tablemh(im3,j2))
        errint2=err3*(tablemh(im4,j2)-m2)+err4*(m2-tablemh(im3,j2))
        errint2 = errint2/(tablemh(im4,j2)-tablemh(im3,j2))
      Endif
c
      int = int1*(ecmh-sqrts)+int2*(sqrts-ecml)
      int = int / (ecmh-ecml)
      errsig = errint1*(ecmh-sqrts)+errint2*(sqrts-ecml)
      errsig = errsig / (ecmh-ecml)
c
      If (.not.err) A2000_HGG_EFF = int
      If (err) A2000_HGG_EFF = errsig
c
      goto 999
 998  Print*,'Probleme avec le fichier ',file
      STOP
 999  RETURN
      END
      REAL FUNCTION A189_HGG_BACKG(mh,myich,err)
      Implicit none
      Real mh
      Integer myich
c
      Logical first,err
      Data first/.TRUE./
      Integer npoint
      Parameter (npoint=601)
      Real sigma(npoint),bdf(npoint),hmass(npoint)
      Real massi,massx,dmass,rmass
      Integer i,imass,jmass
      Data (hmass(i),i=       1,     601)/
     &  0.40000E+02, 0.40100E+02, 0.40200E+02, 0.40300E+02, 0.40400E+02,
     &  0.40500E+02, 0.40600E+02, 0.40700E+02, 0.40800E+02, 0.40900E+02,
     &  0.41000E+02, 0.41100E+02, 0.41200E+02, 0.41300E+02, 0.41400E+02,
     &  0.41500E+02, 0.41600E+02, 0.41700E+02, 0.41800E+02, 0.41900E+02,
     &  0.42000E+02, 0.42100E+02, 0.42200E+02, 0.42300E+02, 0.42400E+02,
     &  0.42500E+02, 0.42600E+02, 0.42700E+02, 0.42800E+02, 0.42900E+02,
     &  0.43000E+02, 0.43100E+02, 0.43200E+02, 0.43300E+02, 0.43400E+02,
     &  0.43500E+02, 0.43600E+02, 0.43700E+02, 0.43800E+02, 0.43900E+02,
     &  0.44000E+02, 0.44100E+02, 0.44200E+02, 0.44300E+02, 0.44400E+02,
     &  0.44500E+02, 0.44600E+02, 0.44700E+02, 0.44800E+02, 0.44900E+02,
     &  0.45000E+02, 0.45100E+02, 0.45200E+02, 0.45300E+02, 0.45400E+02,
     &  0.45500E+02, 0.45600E+02, 0.45700E+02, 0.45800E+02, 0.45900E+02,
     &  0.46000E+02, 0.46100E+02, 0.46200E+02, 0.46300E+02, 0.46400E+02,
     &  0.46500E+02, 0.46600E+02, 0.46700E+02, 0.46800E+02, 0.46900E+02,
     &  0.47000E+02, 0.47100E+02, 0.47200E+02, 0.47300E+02, 0.47400E+02,
     &  0.47500E+02, 0.47600E+02, 0.47700E+02, 0.47800E+02, 0.47900E+02,
     &  0.48000E+02, 0.48100E+02, 0.48200E+02, 0.48300E+02, 0.48400E+02,
     &  0.48500E+02, 0.48600E+02, 0.48700E+02, 0.48800E+02, 0.48900E+02,
     &  0.49000E+02, 0.49100E+02, 0.49200E+02, 0.49300E+02, 0.49400E+02,
     &  0.49500E+02, 0.49600E+02, 0.49700E+02, 0.49800E+02, 0.49900E+02,
     &  0.50000E+02, 0.50100E+02, 0.50200E+02, 0.50300E+02, 0.50400E+02,
     &  0.50500E+02, 0.50600E+02, 0.50700E+02, 0.50800E+02, 0.50900E+02,
     &  0.51000E+02, 0.51100E+02, 0.51200E+02, 0.51300E+02, 0.51400E+02,
     &  0.51500E+02, 0.51600E+02, 0.51700E+02, 0.51800E+02, 0.51900E+02,
     &  0.52000E+02, 0.52100E+02, 0.52200E+02, 0.52300E+02, 0.52400E+02,
     &  0.52500E+02, 0.52600E+02, 0.52700E+02, 0.52800E+02, 0.52900E+02,
     &  0.53000E+02, 0.53100E+02, 0.53200E+02, 0.53300E+02, 0.53400E+02,
     &  0.53500E+02, 0.53600E+02, 0.53700E+02, 0.53800E+02, 0.53900E+02,
     &  0.54000E+02, 0.54100E+02, 0.54200E+02, 0.54300E+02, 0.54400E+02,
     &  0.54500E+02, 0.54600E+02, 0.54700E+02, 0.54800E+02, 0.54900E+02,
     &  0.55000E+02, 0.55100E+02, 0.55200E+02, 0.55300E+02, 0.55400E+02,
     &  0.55500E+02, 0.55600E+02, 0.55700E+02, 0.55800E+02, 0.55900E+02,
     &  0.56000E+02, 0.56100E+02, 0.56200E+02, 0.56300E+02, 0.56400E+02,
     &  0.56500E+02, 0.56600E+02, 0.56700E+02, 0.56800E+02, 0.56900E+02,
     &  0.57000E+02, 0.57100E+02, 0.57200E+02, 0.57300E+02, 0.57400E+02,
     &  0.57500E+02, 0.57600E+02, 0.57700E+02, 0.57800E+02, 0.57900E+02,
     &  0.58000E+02, 0.58100E+02, 0.58200E+02, 0.58300E+02, 0.58400E+02,
     &  0.58500E+02, 0.58600E+02, 0.58700E+02, 0.58800E+02, 0.58900E+02,
     &  0.59000E+02, 0.59100E+02, 0.59200E+02, 0.59300E+02, 0.59400E+02,
     &  0.59500E+02, 0.59600E+02, 0.59700E+02, 0.59800E+02, 0.59900E+02,
     &  0.60000E+02, 0.60100E+02, 0.60200E+02, 0.60300E+02, 0.60400E+02,
     &  0.60500E+02, 0.60600E+02, 0.60700E+02, 0.60800E+02, 0.60900E+02,
     &  0.61000E+02, 0.61100E+02, 0.61200E+02, 0.61300E+02, 0.61400E+02,
     &  0.61500E+02, 0.61600E+02, 0.61700E+02, 0.61800E+02, 0.61900E+02,
     &  0.62000E+02, 0.62100E+02, 0.62200E+02, 0.62300E+02, 0.62400E+02,
     &  0.62500E+02, 0.62600E+02, 0.62700E+02, 0.62800E+02, 0.62900E+02,
     &  0.63000E+02, 0.63100E+02, 0.63200E+02, 0.63300E+02, 0.63400E+02,
     &  0.63500E+02, 0.63600E+02, 0.63700E+02, 0.63800E+02, 0.63900E+02,
     &  0.64000E+02, 0.64100E+02, 0.64200E+02, 0.64300E+02, 0.64400E+02,
     &  0.64500E+02, 0.64600E+02, 0.64700E+02, 0.64800E+02, 0.64900E+02,
     &  0.65000E+02, 0.65100E+02, 0.65200E+02, 0.65300E+02, 0.65400E+02,
     &  0.65500E+02, 0.65600E+02, 0.65700E+02, 0.65800E+02, 0.65900E+02,
     &  0.66000E+02, 0.66100E+02, 0.66200E+02, 0.66300E+02, 0.66400E+02,
     &  0.66500E+02, 0.66600E+02, 0.66700E+02, 0.66800E+02, 0.66900E+02,
     &  0.67000E+02, 0.67100E+02, 0.67200E+02, 0.67300E+02, 0.67400E+02,
     &  0.67500E+02, 0.67600E+02, 0.67700E+02, 0.67800E+02, 0.67900E+02,
     &  0.68000E+02, 0.68100E+02, 0.68200E+02, 0.68300E+02, 0.68400E+02,
     &  0.68500E+02, 0.68600E+02, 0.68700E+02, 0.68800E+02, 0.68900E+02,
     &  0.69000E+02, 0.69100E+02, 0.69200E+02, 0.69300E+02, 0.69400E+02,
     &  0.69500E+02, 0.69600E+02, 0.69700E+02, 0.69800E+02, 0.69900E+02,
     &  0.70000E+02, 0.70100E+02, 0.70200E+02, 0.70300E+02, 0.70400E+02,
     &  0.70500E+02, 0.70600E+02, 0.70700E+02, 0.70800E+02, 0.70900E+02,
     &  0.71000E+02, 0.71100E+02, 0.71200E+02, 0.71300E+02, 0.71400E+02,
     &  0.71500E+02, 0.71600E+02, 0.71700E+02, 0.71800E+02, 0.71900E+02,
     &  0.72000E+02, 0.72100E+02, 0.72200E+02, 0.72300E+02, 0.72400E+02,
     &  0.72500E+02, 0.72600E+02, 0.72700E+02, 0.72800E+02, 0.72900E+02,
     &  0.73000E+02, 0.73100E+02, 0.73200E+02, 0.73300E+02, 0.73400E+02,
     &  0.73500E+02, 0.73600E+02, 0.73700E+02, 0.73800E+02, 0.73900E+02,
     &  0.74000E+02, 0.74100E+02, 0.74200E+02, 0.74300E+02, 0.74400E+02,
     &  0.74500E+02, 0.74600E+02, 0.74700E+02, 0.74800E+02, 0.74900E+02,
     &  0.75000E+02, 0.75100E+02, 0.75200E+02, 0.75300E+02, 0.75400E+02,
     &  0.75500E+02, 0.75600E+02, 0.75700E+02, 0.75800E+02, 0.75900E+02,
     &  0.76000E+02, 0.76100E+02, 0.76200E+02, 0.76300E+02, 0.76400E+02,
     &  0.76500E+02, 0.76600E+02, 0.76700E+02, 0.76800E+02, 0.76900E+02,
     &  0.77000E+02, 0.77100E+02, 0.77200E+02, 0.77300E+02, 0.77400E+02,
     &  0.77500E+02, 0.77600E+02, 0.77700E+02, 0.77800E+02, 0.77900E+02,
     &  0.78000E+02, 0.78100E+02, 0.78200E+02, 0.78300E+02, 0.78400E+02,
     &  0.78500E+02, 0.78600E+02, 0.78700E+02, 0.78800E+02, 0.78900E+02,
     &  0.79000E+02, 0.79100E+02, 0.79200E+02, 0.79300E+02, 0.79400E+02,
     &  0.79500E+02, 0.79600E+02, 0.79700E+02, 0.79800E+02, 0.79900E+02,
     &  0.80000E+02, 0.80100E+02, 0.80200E+02, 0.80300E+02, 0.80400E+02,
     &  0.80500E+02, 0.80600E+02, 0.80700E+02, 0.80800E+02, 0.80900E+02,
     &  0.81000E+02, 0.81100E+02, 0.81200E+02, 0.81300E+02, 0.81400E+02,
     &  0.81500E+02, 0.81600E+02, 0.81700E+02, 0.81800E+02, 0.81900E+02,
     &  0.82000E+02, 0.82100E+02, 0.82200E+02, 0.82300E+02, 0.82400E+02,
     &  0.82500E+02, 0.82600E+02, 0.82700E+02, 0.82800E+02, 0.82900E+02,
     &  0.83000E+02, 0.83100E+02, 0.83200E+02, 0.83300E+02, 0.83400E+02,
     &  0.83500E+02, 0.83600E+02, 0.83700E+02, 0.83800E+02, 0.83900E+02,
     &  0.84000E+02, 0.84100E+02, 0.84200E+02, 0.84300E+02, 0.84400E+02,
     &  0.84500E+02, 0.84600E+02, 0.84700E+02, 0.84800E+02, 0.84900E+02,
     &  0.85000E+02, 0.85100E+02, 0.85200E+02, 0.85300E+02, 0.85400E+02,
     &  0.85500E+02, 0.85600E+02, 0.85700E+02, 0.85800E+02, 0.85900E+02,
     &  0.86000E+02, 0.86100E+02, 0.86200E+02, 0.86300E+02, 0.86400E+02,
     &  0.86500E+02, 0.86600E+02, 0.86700E+02, 0.86800E+02, 0.86900E+02,
     &  0.87000E+02, 0.87100E+02, 0.87200E+02, 0.87300E+02, 0.87400E+02,
     &  0.87500E+02, 0.87600E+02, 0.87700E+02, 0.87800E+02, 0.87900E+02,
     &  0.88000E+02, 0.88100E+02, 0.88200E+02, 0.88300E+02, 0.88400E+02,
     &  0.88500E+02, 0.88600E+02, 0.88700E+02, 0.88800E+02, 0.88900E+02,
     &  0.89000E+02, 0.89100E+02, 0.89200E+02, 0.89300E+02, 0.89400E+02,
     &  0.89500E+02, 0.89600E+02, 0.89700E+02, 0.89800E+02, 0.89900E+02,
     &  0.90000E+02, 0.90100E+02, 0.90200E+02, 0.90300E+02, 0.90400E+02,
     &  0.90500E+02, 0.90600E+02, 0.90700E+02, 0.90800E+02, 0.90900E+02,
     &  0.91000E+02, 0.91100E+02, 0.91200E+02, 0.91300E+02, 0.91400E+02,
     &  0.91500E+02, 0.91600E+02, 0.91700E+02, 0.91800E+02, 0.91900E+02,
     &  0.92000E+02, 0.92100E+02, 0.92200E+02, 0.92300E+02, 0.92400E+02,
     &  0.92500E+02, 0.92600E+02, 0.92700E+02, 0.92800E+02, 0.92900E+02,
     &  0.93000E+02, 0.93100E+02, 0.93200E+02, 0.93300E+02, 0.93400E+02,
     &  0.93500E+02, 0.93600E+02, 0.93700E+02, 0.93800E+02, 0.93900E+02,
     &  0.94000E+02, 0.94100E+02, 0.94200E+02, 0.94300E+02, 0.94400E+02,
     &  0.94500E+02, 0.94600E+02, 0.94700E+02, 0.94800E+02, 0.94900E+02,
     &  0.95000E+02, 0.95100E+02, 0.95200E+02, 0.95300E+02, 0.95400E+02,
     &  0.95500E+02, 0.95600E+02, 0.95700E+02, 0.95800E+02, 0.95900E+02,
     &  0.96000E+02, 0.96100E+02, 0.96200E+02, 0.96300E+02, 0.96400E+02,
     &  0.96500E+02, 0.96600E+02, 0.96700E+02, 0.96800E+02, 0.96900E+02,
     &  0.97000E+02, 0.97100E+02, 0.97200E+02, 0.97300E+02, 0.97400E+02,
     &  0.97500E+02, 0.97600E+02, 0.97700E+02, 0.97800E+02, 0.97900E+02,
     &  0.98000E+02, 0.98100E+02, 0.98200E+02, 0.98300E+02, 0.98400E+02,
     &  0.98500E+02, 0.98600E+02, 0.98700E+02, 0.98800E+02, 0.98900E+02,
     &  0.99000E+02, 0.99100E+02, 0.99200E+02, 0.99300E+02, 0.99400E+02,
     &  0.99500E+02,
     &  0.99600E+02,
     &  0.99700E+02,
     &  0.99800E+02,
     &  0.99900E+02,
     &  0.10000E+03/
      Data (bdf(i),i=       1,     601)/
     &  0.28268E+02, 0.28270E+02, 0.28319E+02, 0.28192E+02, 0.27897E+02,
     &  0.28195E+02, 0.28299E+02, 0.28455E+02, 0.28491E+02, 0.28536E+02,
     &  0.28600E+02, 0.28678E+02, 0.28953E+02, 0.29064E+02, 0.29354E+02,
     &  0.29564E+02, 0.29989E+02, 0.30036E+02, 0.30044E+02, 0.30039E+02,
     &  0.29948E+02, 0.29816E+02, 0.30040E+02, 0.30451E+02, 0.30421E+02,
     &  0.30233E+02, 0.30368E+02, 0.30634E+02, 0.30711E+02, 0.30651E+02,
     &  0.30483E+02, 0.30565E+02, 0.30427E+02, 0.30854E+02, 0.30897E+02,
     &  0.31227E+02, 0.31441E+02, 0.31419E+02, 0.31441E+02, 0.31670E+02,
     &  0.31342E+02, 0.31292E+02, 0.31747E+02, 0.31921E+02, 0.31876E+02,
     &  0.31994E+02, 0.31908E+02, 0.32121E+02, 0.32179E+02, 0.32284E+02,
     &  0.32837E+02, 0.32444E+02, 0.32305E+02, 0.32586E+02, 0.32840E+02,
     &  0.32848E+02, 0.32503E+02, 0.32341E+02, 0.32135E+02, 0.32318E+02,
     &  0.32534E+02, 0.32752E+02, 0.32934E+02, 0.32806E+02, 0.33136E+02,
     &  0.33082E+02, 0.33162E+02, 0.33256E+02, 0.33185E+02, 0.33185E+02,
     &  0.33450E+02, 0.33910E+02, 0.34388E+02, 0.34430E+02, 0.34682E+02,
     &  0.35052E+02, 0.35485E+02, 0.35552E+02, 0.35732E+02, 0.35539E+02,
     &  0.36014E+02, 0.36499E+02, 0.36697E+02, 0.36675E+02, 0.37144E+02,
     &  0.37371E+02, 0.37722E+02, 0.38334E+02, 0.38574E+02, 0.38698E+02,
     &  0.39029E+02, 0.39107E+02, 0.39868E+02, 0.40125E+02, 0.40503E+02,
     &  0.41089E+02, 0.41514E+02, 0.42146E+02, 0.42799E+02, 0.42828E+02,
     &  0.42904E+02, 0.43055E+02, 0.43087E+02, 0.43089E+02, 0.43082E+02,
     &  0.43090E+02, 0.42950E+02, 0.43178E+02, 0.43096E+02, 0.43104E+02,
     &  0.42712E+02, 0.42687E+02, 0.42536E+02, 0.42834E+02, 0.42921E+02,
     &  0.43157E+02, 0.43546E+02, 0.43594E+02, 0.44122E+02, 0.44437E+02,
     &  0.44418E+02, 0.44261E+02, 0.44365E+02, 0.44603E+02, 0.44548E+02,
     &  0.44735E+02, 0.45010E+02, 0.45182E+02, 0.45317E+02, 0.45492E+02,
     &  0.45541E+02, 0.45525E+02, 0.45973E+02, 0.46396E+02, 0.46417E+02,
     &  0.46691E+02, 0.46984E+02, 0.47513E+02, 0.47805E+02, 0.48446E+02,
     &  0.48383E+02, 0.48291E+02, 0.48442E+02, 0.48239E+02, 0.47986E+02,
     &  0.48004E+02, 0.48212E+02, 0.48291E+02, 0.48764E+02, 0.48718E+02,
     &  0.48941E+02, 0.48640E+02, 0.49183E+02, 0.49202E+02, 0.49266E+02,
     &  0.49364E+02, 0.49877E+02, 0.49795E+02, 0.49689E+02, 0.50113E+02,
     &  0.49997E+02, 0.50306E+02, 0.50488E+02, 0.50724E+02, 0.51056E+02,
     &  0.51038E+02, 0.51075E+02, 0.51455E+02, 0.51553E+02, 0.51772E+02,
     &  0.52028E+02, 0.52290E+02, 0.52364E+02, 0.52253E+02, 0.52170E+02,
     &  0.52140E+02, 0.51919E+02, 0.51947E+02, 0.51775E+02, 0.52245E+02,
     &  0.52610E+02, 0.52622E+02, 0.52480E+02, 0.53022E+02, 0.53212E+02,
     &  0.53403E+02, 0.53193E+02, 0.53348E+02, 0.53790E+02, 0.53867E+02,
     &  0.54045E+02, 0.54059E+02, 0.54266E+02, 0.53989E+02, 0.54160E+02,
     &  0.54251E+02, 0.54283E+02, 0.54807E+02, 0.54695E+02, 0.54791E+02,
     &  0.54804E+02, 0.55313E+02, 0.55638E+02, 0.55797E+02, 0.56258E+02,
     &  0.56630E+02, 0.56803E+02, 0.57009E+02, 0.57782E+02, 0.58011E+02,
     &  0.58507E+02, 0.58860E+02, 0.59697E+02, 0.59656E+02, 0.59784E+02,
     &  0.60017E+02, 0.60263E+02, 0.60228E+02, 0.60519E+02, 0.60703E+02,
     &  0.61428E+02, 0.62002E+02, 0.62575E+02, 0.63125E+02, 0.63482E+02,
     &  0.64258E+02, 0.64825E+02, 0.65157E+02, 0.65608E+02, 0.65882E+02,
     &  0.66177E+02, 0.66287E+02, 0.66757E+02, 0.66795E+02, 0.67295E+02,
     &  0.67838E+02, 0.68264E+02, 0.68086E+02, 0.68391E+02, 0.69001E+02,
     &  0.69429E+02, 0.69741E+02, 0.70051E+02, 0.70158E+02, 0.70668E+02,
     &  0.70524E+02, 0.70683E+02, 0.70887E+02, 0.71387E+02, 0.71448E+02,
     &  0.71550E+02, 0.72285E+02, 0.72454E+02, 0.72873E+02, 0.73364E+02,
     &  0.73742E+02, 0.74064E+02, 0.74280E+02, 0.74895E+02, 0.74802E+02,
     &  0.75094E+02, 0.75756E+02, 0.75976E+02, 0.76392E+02, 0.76794E+02,
     &  0.77508E+02, 0.77926E+02, 0.78376E+02, 0.78929E+02, 0.78965E+02,
     &  0.79160E+02, 0.79761E+02, 0.80206E+02, 0.80192E+02, 0.80805E+02,
     &  0.81287E+02, 0.81268E+02, 0.81625E+02, 0.82307E+02, 0.82710E+02,
     &  0.82990E+02, 0.82793E+02, 0.83524E+02, 0.83832E+02, 0.83902E+02,
     &  0.84360E+02, 0.84827E+02, 0.84916E+02, 0.85312E+02, 0.85954E+02,
     &  0.86265E+02, 0.86714E+02, 0.86992E+02, 0.87470E+02, 0.87659E+02,
     &  0.88263E+02, 0.88974E+02, 0.89206E+02, 0.90001E+02, 0.90315E+02,
     &  0.91140E+02, 0.89399E+02, 0.88293E+02, 0.87309E+02, 0.85619E+02,
     &  0.84489E+02, 0.83405E+02, 0.82314E+02, 0.81680E+02, 0.80308E+02,
     &  0.79429E+02, 0.78266E+02, 0.77001E+02, 0.75942E+02, 0.75015E+02,
     &  0.74378E+02, 0.74085E+02, 0.73414E+02, 0.72795E+02, 0.72170E+02,
     &  0.71733E+02, 0.70869E+02, 0.70797E+02, 0.69958E+02, 0.69572E+02,
     &  0.68991E+02, 0.67908E+02, 0.67614E+02, 0.67092E+02, 0.66355E+02,
     &  0.66052E+02, 0.66194E+02, 0.66060E+02, 0.66100E+02, 0.65941E+02,
     &  0.66135E+02, 0.65798E+02, 0.65230E+02, 0.65719E+02, 0.65799E+02,
     &  0.66199E+02, 0.66974E+02, 0.67139E+02, 0.68305E+02, 0.68556E+02,
     &  0.68776E+02, 0.69733E+02, 0.70505E+02, 0.71628E+02, 0.71853E+02,
     &  0.72583E+02, 0.73615E+02, 0.75255E+02, 0.76516E+02, 0.77667E+02,
     &  0.79808E+02, 0.82029E+02, 0.83403E+02, 0.85502E+02, 0.87198E+02,
     &  0.88943E+02, 0.90890E+02, 0.93540E+02, 0.95531E+02, 0.97914E+02,
     &  0.10025E+03, 0.10239E+03, 0.10541E+03, 0.10800E+03, 0.10999E+03,
     &  0.11267E+03, 0.11548E+03, 0.11765E+03, 0.11980E+03, 0.12210E+03,
     &  0.12447E+03, 0.12684E+03, 0.12905E+03, 0.13092E+03, 0.13285E+03,
     &  0.13396E+03, 0.13577E+03, 0.13732E+03, 0.13871E+03, 0.14019E+03,
     &  0.14164E+03, 0.14311E+03, 0.14447E+03, 0.14562E+03, 0.14662E+03,
     &  0.14759E+03, 0.14877E+03, 0.14939E+03, 0.14991E+03, 0.15041E+03,
     &  0.15060E+03, 0.15093E+03, 0.15145E+03, 0.15164E+03, 0.15215E+03,
     &  0.15272E+03, 0.15185E+03, 0.15026E+03, 0.14928E+03, 0.14769E+03,
     &  0.14671E+03, 0.14510E+03, 0.14391E+03, 0.14238E+03, 0.14091E+03,
     &  0.13982E+03, 0.13830E+03, 0.13622E+03, 0.13454E+03, 0.13300E+03,
     &  0.13107E+03, 0.12939E+03, 0.12720E+03, 0.12553E+03, 0.12360E+03,
     &  0.12203E+03, 0.12045E+03, 0.11891E+03, 0.11714E+03, 0.11536E+03,
     &  0.11394E+03, 0.11189E+03, 0.11050E+03, 0.10915E+03, 0.10759E+03,
     &  0.10589E+03, 0.10421E+03, 0.10217E+03, 0.10097E+03, 0.99142E+02,
     &  0.97678E+02, 0.95173E+02, 0.93888E+02, 0.92588E+02, 0.90957E+02,
     &  0.89474E+02, 0.87731E+02, 0.86944E+02, 0.85563E+02, 0.84238E+02,
     &  0.82595E+02, 0.81325E+02, 0.80668E+02, 0.80098E+02, 0.79050E+02,
     &  0.77434E+02, 0.77099E+02, 0.76368E+02, 0.75999E+02, 0.75642E+02,
     &  0.75118E+02, 0.74329E+02, 0.73767E+02, 0.72948E+02, 0.72621E+02,
     &  0.71946E+02, 0.71775E+02, 0.70854E+02, 0.70235E+02, 0.70325E+02,
     &  0.70345E+02, 0.70122E+02, 0.69783E+02, 0.69219E+02, 0.69591E+02,
     &  0.69384E+02, 0.69299E+02, 0.69258E+02, 0.68977E+02, 0.68746E+02,
     &  0.68589E+02, 0.68404E+02, 0.68820E+02, 0.68714E+02, 0.68528E+02,
     &  0.68559E+02, 0.68475E+02, 0.68315E+02, 0.68100E+02, 0.68399E+02,
     &  0.68844E+02, 0.69077E+02, 0.69347E+02, 0.69326E+02, 0.69731E+02,
     &  0.70154E+02, 0.70638E+02, 0.71336E+02, 0.71493E+02, 0.71964E+02,
     &  0.72255E+02, 0.73315E+02, 0.74418E+02, 0.75568E+02, 0.76182E+02,
     &  0.77135E+02, 0.76047E+02, 0.75166E+02, 0.74445E+02, 0.73932E+02,
     &  0.72949E+02, 0.72461E+02, 0.72022E+02, 0.71676E+02, 0.71040E+02,
     &  0.70690E+02, 0.70104E+02, 0.69366E+02, 0.68584E+02, 0.68086E+02,
     &  0.67846E+02, 0.67650E+02, 0.66904E+02, 0.66313E+02, 0.66104E+02,
     &  0.65505E+02, 0.64863E+02, 0.64209E+02, 0.63208E+02, 0.62630E+02,
     &  0.61926E+02, 0.60978E+02, 0.60271E+02, 0.59829E+02, 0.58945E+02,
     &  0.58296E+02, 0.57454E+02, 0.56786E+02, 0.56285E+02, 0.55890E+02,
     &  0.55237E+02, 0.54176E+02, 0.53144E+02, 0.52432E+02, 0.51139E+02,
     &  0.50039E+02, 0.49376E+02, 0.48513E+02, 0.47477E+02, 0.46255E+02,
     &  0.45594E+02, 0.44090E+02, 0.43342E+02, 0.42395E+02, 0.41347E+02,
     &  0.40826E+02, 0.41299E+02, 0.41633E+02, 0.41923E+02, 0.42059E+02,
     &  0.42340E+02, 0.42937E+02, 0.43070E+02, 0.43549E+02, 0.43981E+02,
     &  0.44446E+02, 0.44607E+02, 0.44783E+02, 0.45116E+02, 0.45766E+02,
     &  0.45880E+02, 0.46607E+02, 0.47042E+02, 0.47249E+02, 0.47703E+02,
     &  0.48161E+02, 0.48810E+02, 0.49187E+02, 0.49808E+02, 0.50657E+02,
     &  0.51681E+02, 0.52934E+02, 0.54939E+02, 0.56406E+02, 0.57274E+02,
     &  0.57974E+02, 0.58299E+02, 0.58879E+02, 0.59539E+02, 0.59969E+02,
     &  0.60573E+02, 0.61093E+02, 0.61729E+02, 0.62369E+02, 0.62792E+02,
     &  0.63267E+02, 0.63799E+02, 0.64362E+02, 0.64880E+02, 0.65140E+02,
     &  0.66383E+02,
     &  0.66967E+02,
     &  0.68416E+02,
     &  0.69348E+02,
     &  0.70519E+02,
     &  0.72397E+02/
      Data (sigma(i),i=       1,     601)/
     &  0.31778E-01, 0.31746E-01, 0.31706E-01, 0.31787E-01, 0.31940E-01,
     &  0.31761E-01, 0.31675E-01, 0.31561E-01, 0.31567E-01, 0.31559E-01,
     &  0.31534E-01, 0.31474E-01, 0.31344E-01, 0.31282E-01, 0.31099E-01,
     &  0.30972E-01, 0.30768E-01, 0.30751E-01, 0.30743E-01, 0.30751E-01,
     &  0.30796E-01, 0.30863E-01, 0.30736E-01, 0.30553E-01, 0.30571E-01,
     &  0.30645E-01, 0.30575E-01, 0.30426E-01, 0.30382E-01, 0.30405E-01,
     &  0.30462E-01, 0.30398E-01, 0.30442E-01, 0.30236E-01, 0.30223E-01,
     &  0.30050E-01, 0.29974E-01, 0.29983E-01, 0.29943E-01, 0.29858E-01,
     &  0.30002E-01, 0.30030E-01, 0.29800E-01, 0.29721E-01, 0.29727E-01,
     &  0.29652E-01, 0.29690E-01, 0.29556E-01, 0.29503E-01, 0.29445E-01,
     &  0.29209E-01, 0.29395E-01, 0.29477E-01, 0.29360E-01, 0.29268E-01,
     &  0.29260E-01, 0.29432E-01, 0.29504E-01, 0.29624E-01, 0.29528E-01,
     &  0.29430E-01, 0.29311E-01, 0.29219E-01, 0.29268E-01, 0.29131E-01,
     &  0.29150E-01, 0.29119E-01, 0.29087E-01, 0.29110E-01, 0.29109E-01,
     &  0.28989E-01, 0.28796E-01, 0.28587E-01, 0.28548E-01, 0.28440E-01,
     &  0.28306E-01, 0.28140E-01, 0.28104E-01, 0.28026E-01, 0.28086E-01,
     &  0.27891E-01, 0.27713E-01, 0.27648E-01, 0.27625E-01, 0.27438E-01,
     &  0.27352E-01, 0.27224E-01, 0.27033E-01, 0.26954E-01, 0.26912E-01,
     &  0.26793E-01, 0.26765E-01, 0.26512E-01, 0.26414E-01, 0.26310E-01,
     &  0.26115E-01, 0.25971E-01, 0.25766E-01, 0.25572E-01, 0.25566E-01,
     &  0.25538E-01, 0.25486E-01, 0.25475E-01, 0.25488E-01, 0.25489E-01,
     &  0.25478E-01, 0.25499E-01, 0.25432E-01, 0.25438E-01, 0.25462E-01,
     &  0.25554E-01, 0.25564E-01, 0.25614E-01, 0.25523E-01, 0.25491E-01,
     &  0.25428E-01, 0.25331E-01, 0.25310E-01, 0.25161E-01, 0.25070E-01,
     &  0.25071E-01, 0.25117E-01, 0.25091E-01, 0.25024E-01, 0.25034E-01,
     &  0.24982E-01, 0.24910E-01, 0.24868E-01, 0.24832E-01, 0.24776E-01,
     &  0.24759E-01, 0.24763E-01, 0.24645E-01, 0.24521E-01, 0.24521E-01,
     &  0.24452E-01, 0.24371E-01, 0.24252E-01, 0.24183E-01, 0.24024E-01,
     &  0.24037E-01, 0.24057E-01, 0.24006E-01, 0.24063E-01, 0.24113E-01,
     &  0.24101E-01, 0.24049E-01, 0.24029E-01, 0.23921E-01, 0.23919E-01,
     &  0.23878E-01, 0.23937E-01, 0.23809E-01, 0.23801E-01, 0.23791E-01,
     &  0.23769E-01, 0.23650E-01, 0.23665E-01, 0.23693E-01, 0.23586E-01,
     &  0.23598E-01, 0.23512E-01, 0.23472E-01, 0.23416E-01, 0.23348E-01,
     &  0.23343E-01, 0.23330E-01, 0.23239E-01, 0.23210E-01, 0.23152E-01,
     &  0.23099E-01, 0.23043E-01, 0.23013E-01, 0.23033E-01, 0.23038E-01,
     &  0.23038E-01, 0.23081E-01, 0.23058E-01, 0.23088E-01, 0.22998E-01,
     &  0.22922E-01, 0.22924E-01, 0.22946E-01, 0.22840E-01, 0.22798E-01,
     &  0.22747E-01, 0.22777E-01, 0.22746E-01, 0.22652E-01, 0.22636E-01,
     &  0.22593E-01, 0.22578E-01, 0.22526E-01, 0.22577E-01, 0.22530E-01,
     &  0.22510E-01, 0.22503E-01, 0.22399E-01, 0.22415E-01, 0.22395E-01,
     &  0.22408E-01, 0.22318E-01, 0.22256E-01, 0.22235E-01, 0.22156E-01,
     &  0.22091E-01, 0.22054E-01, 0.22018E-01, 0.21886E-01, 0.21859E-01,
     &  0.21788E-01, 0.21733E-01, 0.21586E-01, 0.21596E-01, 0.21576E-01,
     &  0.21542E-01, 0.21500E-01, 0.21506E-01, 0.21461E-01, 0.21433E-01,
     &  0.21304E-01, 0.21201E-01, 0.21115E-01, 0.21023E-01, 0.20962E-01,
     &  0.20848E-01, 0.20765E-01, 0.20709E-01, 0.20647E-01, 0.20599E-01,
     &  0.20564E-01, 0.20545E-01, 0.20472E-01, 0.20466E-01, 0.20390E-01,
     &  0.20307E-01, 0.20243E-01, 0.20281E-01, 0.20239E-01, 0.20156E-01,
     &  0.20088E-01, 0.20051E-01, 0.20011E-01, 0.19996E-01, 0.19924E-01,
     &  0.19939E-01, 0.19908E-01, 0.19887E-01, 0.19812E-01, 0.19805E-01,
     &  0.19777E-01, 0.19670E-01, 0.19637E-01, 0.19571E-01, 0.19497E-01,
     &  0.19448E-01, 0.19400E-01, 0.19364E-01, 0.19279E-01, 0.19285E-01,
     &  0.19246E-01, 0.19155E-01, 0.19115E-01, 0.19054E-01, 0.18989E-01,
     &  0.18901E-01, 0.18850E-01, 0.18794E-01, 0.18720E-01, 0.18722E-01,
     &  0.18696E-01, 0.18626E-01, 0.18567E-01, 0.18551E-01, 0.18475E-01,
     &  0.18420E-01, 0.18416E-01, 0.18371E-01, 0.18291E-01, 0.18246E-01,
     &  0.18213E-01, 0.18226E-01, 0.18152E-01, 0.18118E-01, 0.18102E-01,
     &  0.18046E-01, 0.18006E-01, 0.17990E-01, 0.17946E-01, 0.17877E-01,
     &  0.17844E-01, 0.17793E-01, 0.17754E-01, 0.17706E-01, 0.17680E-01,
     &  0.17618E-01, 0.17548E-01, 0.17529E-01, 0.17455E-01, 0.17420E-01,
     &  0.17346E-01, 0.17517E-01, 0.17637E-01, 0.17735E-01, 0.17915E-01,
     &  0.18029E-01, 0.18142E-01, 0.18264E-01, 0.18333E-01, 0.18490E-01,
     &  0.18593E-01, 0.18724E-01, 0.18880E-01, 0.19011E-01, 0.19134E-01,
     &  0.19214E-01, 0.19254E-01, 0.19348E-01, 0.19437E-01, 0.19523E-01,
     &  0.19582E-01, 0.19689E-01, 0.19701E-01, 0.19821E-01, 0.19879E-01,
     &  0.19957E-01, 0.20111E-01, 0.20154E-01, 0.20245E-01, 0.20350E-01,
     &  0.20395E-01, 0.20378E-01, 0.20406E-01, 0.20403E-01, 0.20433E-01,
     &  0.20411E-01, 0.20465E-01, 0.20553E-01, 0.20473E-01, 0.20455E-01,
     &  0.20393E-01, 0.20284E-01, 0.20266E-01, 0.20095E-01, 0.20049E-01,
     &  0.20015E-01, 0.19890E-01, 0.19790E-01, 0.19634E-01, 0.19599E-01,
     &  0.19497E-01, 0.19352E-01, 0.19141E-01, 0.18974E-01, 0.18828E-01,
     &  0.18569E-01, 0.18316E-01, 0.18154E-01, 0.17929E-01, 0.17745E-01,
     &  0.17563E-01, 0.17362E-01, 0.17112E-01, 0.16935E-01, 0.16735E-01,
     &  0.16537E-01, 0.16354E-01, 0.16112E-01, 0.15916E-01, 0.15772E-01,
     &  0.15584E-01, 0.15390E-01, 0.15241E-01, 0.15109E-01, 0.14962E-01,
     &  0.14815E-01, 0.14680E-01, 0.14546E-01, 0.14439E-01, 0.14328E-01,
     &  0.14264E-01, 0.14165E-01, 0.14084E-01, 0.14015E-01, 0.13941E-01,
     &  0.13865E-01, 0.13793E-01, 0.13732E-01, 0.13677E-01, 0.13628E-01,
     &  0.13578E-01, 0.13522E-01, 0.13493E-01, 0.13468E-01, 0.13443E-01,
     &  0.13428E-01, 0.13408E-01, 0.13386E-01, 0.13371E-01, 0.13348E-01,
     &  0.13319E-01, 0.13356E-01, 0.13428E-01, 0.13473E-01, 0.13546E-01,
     &  0.13598E-01, 0.13675E-01, 0.13734E-01, 0.13811E-01, 0.13884E-01,
     &  0.13938E-01, 0.14014E-01, 0.14118E-01, 0.14206E-01, 0.14287E-01,
     &  0.14393E-01, 0.14484E-01, 0.14605E-01, 0.14702E-01, 0.14810E-01,
     &  0.14904E-01, 0.15005E-01, 0.15100E-01, 0.15210E-01, 0.15322E-01,
     &  0.15419E-01, 0.15556E-01, 0.15650E-01, 0.15744E-01, 0.15861E-01,
     &  0.15980E-01, 0.16100E-01, 0.16248E-01, 0.16339E-01, 0.16483E-01,
     &  0.16600E-01, 0.16801E-01, 0.16905E-01, 0.17014E-01, 0.17150E-01,
     &  0.17285E-01, 0.17440E-01, 0.17505E-01, 0.17635E-01, 0.17763E-01,
     &  0.17920E-01, 0.18051E-01, 0.18110E-01, 0.18166E-01, 0.18269E-01,
     &  0.18432E-01, 0.18459E-01, 0.18520E-01, 0.18544E-01, 0.18567E-01,
     &  0.18609E-01, 0.18682E-01, 0.18730E-01, 0.18819E-01, 0.18827E-01,
     &  0.18885E-01, 0.18878E-01, 0.18964E-01, 0.19020E-01, 0.18998E-01,
     &  0.18982E-01, 0.18991E-01, 0.19023E-01, 0.19058E-01, 0.18984E-01,
     &  0.18982E-01, 0.18949E-01, 0.18930E-01, 0.18919E-01, 0.18932E-01,
     &  0.18931E-01, 0.18920E-01, 0.18846E-01, 0.18840E-01, 0.18832E-01,
     &  0.18799E-01, 0.18778E-01, 0.18758E-01, 0.18752E-01, 0.18700E-01,
     &  0.18621E-01, 0.18577E-01, 0.18512E-01, 0.18495E-01, 0.18426E-01,
     &  0.18349E-01, 0.18272E-01, 0.18172E-01, 0.18131E-01, 0.18074E-01,
     &  0.18027E-01, 0.17909E-01, 0.17772E-01, 0.17650E-01, 0.17580E-01,
     &  0.17489E-01, 0.17571E-01, 0.17657E-01, 0.17723E-01, 0.17761E-01,
     &  0.17851E-01, 0.17914E-01, 0.17962E-01, 0.18009E-01, 0.18078E-01,
     &  0.18118E-01, 0.18198E-01, 0.18286E-01, 0.18372E-01, 0.18439E-01,
     &  0.18483E-01, 0.18510E-01, 0.18617E-01, 0.18685E-01, 0.18718E-01,
     &  0.18807E-01, 0.18896E-01, 0.18995E-01, 0.19141E-01, 0.19254E-01,
     &  0.19360E-01, 0.19496E-01, 0.19605E-01, 0.19707E-01, 0.19878E-01,
     &  0.20006E-01, 0.20159E-01, 0.20295E-01, 0.20428E-01, 0.20538E-01,
     &  0.20668E-01, 0.20887E-01, 0.21108E-01, 0.21270E-01, 0.21570E-01,
     &  0.21842E-01, 0.22054E-01, 0.22281E-01, 0.22536E-01, 0.22849E-01,
     &  0.23063E-01, 0.23482E-01, 0.23734E-01, 0.24055E-01, 0.24398E-01,
     &  0.24609E-01, 0.24512E-01, 0.24463E-01, 0.24410E-01, 0.24394E-01,
     &  0.24328E-01, 0.24211E-01, 0.24192E-01, 0.24079E-01, 0.23996E-01,
     &  0.23904E-01, 0.23878E-01, 0.23838E-01, 0.23766E-01, 0.23633E-01,
     &  0.23604E-01, 0.23440E-01, 0.23324E-01, 0.23265E-01, 0.23154E-01,
     &  0.23048E-01, 0.22893E-01, 0.22792E-01, 0.22656E-01, 0.22449E-01,
     &  0.22194E-01, 0.21891E-01, 0.21445E-01, 0.21130E-01, 0.20940E-01,
     &  0.20819E-01, 0.20756E-01, 0.20654E-01, 0.20562E-01, 0.20488E-01,
     &  0.20394E-01, 0.20321E-01, 0.20240E-01, 0.20141E-01, 0.20079E-01,
     &  0.20016E-01, 0.19942E-01, 0.19864E-01, 0.19802E-01, 0.19776E-01,
     &  0.19610E-01,
     &  0.19533E-01,
     &  0.19344E-01,
     &  0.19226E-01,
     &  0.19081E-01,
     &  0.18859E-01/
c
      massi = hmass(1)
      massx = hmass(npoint)
      dmass = (massx-massi)/Real(npoint-1)
c      
      imass = int( (mh-massi)/dmass ) + 1
c
      if (imass.eq.npoint) then
        imass = npoint
        jmass = npoint
        rmass = 0.0
      Endif
cjm Modifie le 24Fevrier
      If (imass.le.0 .or. imass.gt.npoint) then
        A189_HGG_BACKG = 0.
        RETURN
      Endif
      If (imass.ge.1..and.imass.lt.npoint) then
        jmass = imass + 1
        rmass = mh - hmass(imass)
      endif
c
      If (.not.err) A189_HGG_BACKG = bdf(imass)+(bdf(jmass)
     &     -bdf(imass))*rmass/dmass
      If (err) A189_HGG_BACKG = sigma(imass)+(sigma(jmass)
     &     -sigma(imass))*rmass/dmass
c
      RETURN
      END
      REAL FUNCTION A192_HGG_BACKG(mh,myich,err)
      Implicit none
      Real mh
      Integer myich
c
      Logical first,err
      Data first/.TRUE./
      Integer npoint
      Parameter (npoint=701)
      Real sigma(npoint),bdf(npoint),hmass(npoint)
      Real massi,massx,dmass,rmass
      Integer i,imass,jmass
      Data (hmass(i),i=       1,     701)/
     &  0.40000E+02, 0.40100E+02, 0.40200E+02, 0.40300E+02, 0.40400E+02,
     &  0.40500E+02, 0.40600E+02, 0.40700E+02, 0.40800E+02, 0.40900E+02,
     &  0.41000E+02, 0.41100E+02, 0.41200E+02, 0.41300E+02, 0.41400E+02,
     &  0.41500E+02, 0.41600E+02, 0.41700E+02, 0.41800E+02, 0.41900E+02,
     &  0.42000E+02, 0.42100E+02, 0.42200E+02, 0.42300E+02, 0.42400E+02,
     &  0.42500E+02, 0.42600E+02, 0.42700E+02, 0.42800E+02, 0.42900E+02,
     &  0.43000E+02, 0.43100E+02, 0.43200E+02, 0.43300E+02, 0.43400E+02,
     &  0.43500E+02, 0.43600E+02, 0.43700E+02, 0.43800E+02, 0.43900E+02,
     &  0.44000E+02, 0.44100E+02, 0.44200E+02, 0.44300E+02, 0.44400E+02,
     &  0.44500E+02, 0.44600E+02, 0.44700E+02, 0.44800E+02, 0.44900E+02,
     &  0.45000E+02, 0.45100E+02, 0.45200E+02, 0.45300E+02, 0.45400E+02,
     &  0.45500E+02, 0.45600E+02, 0.45700E+02, 0.45800E+02, 0.45900E+02,
     &  0.46000E+02, 0.46100E+02, 0.46200E+02, 0.46300E+02, 0.46400E+02,
     &  0.46500E+02, 0.46600E+02, 0.46700E+02, 0.46800E+02, 0.46900E+02,
     &  0.47000E+02, 0.47100E+02, 0.47200E+02, 0.47300E+02, 0.47400E+02,
     &  0.47500E+02, 0.47600E+02, 0.47700E+02, 0.47800E+02, 0.47900E+02,
     &  0.48000E+02, 0.48100E+02, 0.48200E+02, 0.48300E+02, 0.48400E+02,
     &  0.48500E+02, 0.48600E+02, 0.48700E+02, 0.48800E+02, 0.48900E+02,
     &  0.49000E+02, 0.49100E+02, 0.49200E+02, 0.49300E+02, 0.49400E+02,
     &  0.49500E+02, 0.49600E+02, 0.49700E+02, 0.49800E+02, 0.49900E+02,
     &  0.50000E+02, 0.50100E+02, 0.50200E+02, 0.50300E+02, 0.50400E+02,
     &  0.50500E+02, 0.50600E+02, 0.50700E+02, 0.50800E+02, 0.50900E+02,
     &  0.51000E+02, 0.51100E+02, 0.51200E+02, 0.51300E+02, 0.51400E+02,
     &  0.51500E+02, 0.51600E+02, 0.51700E+02, 0.51800E+02, 0.51900E+02,
     &  0.52000E+02, 0.52100E+02, 0.52200E+02, 0.52300E+02, 0.52400E+02,
     &  0.52500E+02, 0.52600E+02, 0.52700E+02, 0.52800E+02, 0.52900E+02,
     &  0.53000E+02, 0.53100E+02, 0.53200E+02, 0.53300E+02, 0.53400E+02,
     &  0.53500E+02, 0.53600E+02, 0.53700E+02, 0.53800E+02, 0.53900E+02,
     &  0.54000E+02, 0.54100E+02, 0.54200E+02, 0.54300E+02, 0.54400E+02,
     &  0.54500E+02, 0.54600E+02, 0.54700E+02, 0.54800E+02, 0.54900E+02,
     &  0.55000E+02, 0.55100E+02, 0.55200E+02, 0.55300E+02, 0.55400E+02,
     &  0.55500E+02, 0.55600E+02, 0.55700E+02, 0.55800E+02, 0.55900E+02,
     &  0.56000E+02, 0.56100E+02, 0.56200E+02, 0.56300E+02, 0.56400E+02,
     &  0.56500E+02, 0.56600E+02, 0.56700E+02, 0.56800E+02, 0.56900E+02,
     &  0.57000E+02, 0.57100E+02, 0.57200E+02, 0.57300E+02, 0.57400E+02,
     &  0.57500E+02, 0.57600E+02, 0.57700E+02, 0.57800E+02, 0.57900E+02,
     &  0.58000E+02, 0.58100E+02, 0.58200E+02, 0.58300E+02, 0.58400E+02,
     &  0.58500E+02, 0.58600E+02, 0.58700E+02, 0.58800E+02, 0.58900E+02,
     &  0.59000E+02, 0.59100E+02, 0.59200E+02, 0.59300E+02, 0.59400E+02,
     &  0.59500E+02, 0.59600E+02, 0.59700E+02, 0.59800E+02, 0.59900E+02,
     &  0.60000E+02, 0.60100E+02, 0.60200E+02, 0.60300E+02, 0.60400E+02,
     &  0.60500E+02, 0.60600E+02, 0.60700E+02, 0.60800E+02, 0.60900E+02,
     &  0.61000E+02, 0.61100E+02, 0.61200E+02, 0.61300E+02, 0.61400E+02,
     &  0.61500E+02, 0.61600E+02, 0.61700E+02, 0.61800E+02, 0.61900E+02,
     &  0.62000E+02, 0.62100E+02, 0.62200E+02, 0.62300E+02, 0.62400E+02,
     &  0.62500E+02, 0.62600E+02, 0.62700E+02, 0.62800E+02, 0.62900E+02,
     &  0.63000E+02, 0.63100E+02, 0.63200E+02, 0.63300E+02, 0.63400E+02,
     &  0.63500E+02, 0.63600E+02, 0.63700E+02, 0.63800E+02, 0.63900E+02,
     &  0.64000E+02, 0.64100E+02, 0.64200E+02, 0.64300E+02, 0.64400E+02,
     &  0.64500E+02, 0.64600E+02, 0.64700E+02, 0.64800E+02, 0.64900E+02,
     &  0.65000E+02, 0.65100E+02, 0.65200E+02, 0.65300E+02, 0.65400E+02,
     &  0.65500E+02, 0.65600E+02, 0.65700E+02, 0.65800E+02, 0.65900E+02,
     &  0.66000E+02, 0.66100E+02, 0.66200E+02, 0.66300E+02, 0.66400E+02,
     &  0.66500E+02, 0.66600E+02, 0.66700E+02, 0.66800E+02, 0.66900E+02,
     &  0.67000E+02, 0.67100E+02, 0.67200E+02, 0.67300E+02, 0.67400E+02,
     &  0.67500E+02, 0.67600E+02, 0.67700E+02, 0.67800E+02, 0.67900E+02,
     &  0.68000E+02, 0.68100E+02, 0.68200E+02, 0.68300E+02, 0.68400E+02,
     &  0.68500E+02, 0.68600E+02, 0.68700E+02, 0.68800E+02, 0.68900E+02,
     &  0.69000E+02, 0.69100E+02, 0.69200E+02, 0.69300E+02, 0.69400E+02,
     &  0.69500E+02, 0.69600E+02, 0.69700E+02, 0.69800E+02, 0.69900E+02,
     &  0.70000E+02, 0.70100E+02, 0.70200E+02, 0.70300E+02, 0.70400E+02,
     &  0.70500E+02, 0.70600E+02, 0.70700E+02, 0.70800E+02, 0.70900E+02,
     &  0.71000E+02, 0.71100E+02, 0.71200E+02, 0.71300E+02, 0.71400E+02,
     &  0.71500E+02, 0.71600E+02, 0.71700E+02, 0.71800E+02, 0.71900E+02,
     &  0.72000E+02, 0.72100E+02, 0.72200E+02, 0.72300E+02, 0.72400E+02,
     &  0.72500E+02, 0.72600E+02, 0.72700E+02, 0.72800E+02, 0.72900E+02,
     &  0.73000E+02, 0.73100E+02, 0.73200E+02, 0.73300E+02, 0.73400E+02,
     &  0.73500E+02, 0.73600E+02, 0.73700E+02, 0.73800E+02, 0.73900E+02,
     &  0.74000E+02, 0.74100E+02, 0.74200E+02, 0.74300E+02, 0.74400E+02,
     &  0.74500E+02, 0.74600E+02, 0.74700E+02, 0.74800E+02, 0.74900E+02,
     &  0.75000E+02, 0.75100E+02, 0.75200E+02, 0.75300E+02, 0.75400E+02,
     &  0.75500E+02, 0.75600E+02, 0.75700E+02, 0.75800E+02, 0.75900E+02,
     &  0.76000E+02, 0.76100E+02, 0.76200E+02, 0.76300E+02, 0.76400E+02,
     &  0.76500E+02, 0.76600E+02, 0.76700E+02, 0.76800E+02, 0.76900E+02,
     &  0.77000E+02, 0.77100E+02, 0.77200E+02, 0.77300E+02, 0.77400E+02,
     &  0.77500E+02, 0.77600E+02, 0.77700E+02, 0.77800E+02, 0.77900E+02,
     &  0.78000E+02, 0.78100E+02, 0.78200E+02, 0.78300E+02, 0.78400E+02,
     &  0.78500E+02, 0.78600E+02, 0.78700E+02, 0.78800E+02, 0.78900E+02,
     &  0.79000E+02, 0.79100E+02, 0.79200E+02, 0.79300E+02, 0.79400E+02,
     &  0.79500E+02, 0.79600E+02, 0.79700E+02, 0.79800E+02, 0.79900E+02,
     &  0.80000E+02, 0.80100E+02, 0.80200E+02, 0.80300E+02, 0.80400E+02,
     &  0.80500E+02, 0.80600E+02, 0.80700E+02, 0.80800E+02, 0.80900E+02,
     &  0.81000E+02, 0.81100E+02, 0.81200E+02, 0.81300E+02, 0.81400E+02,
     &  0.81500E+02, 0.81600E+02, 0.81700E+02, 0.81800E+02, 0.81900E+02,
     &  0.82000E+02, 0.82100E+02, 0.82200E+02, 0.82300E+02, 0.82400E+02,
     &  0.82500E+02, 0.82600E+02, 0.82700E+02, 0.82800E+02, 0.82900E+02,
     &  0.83000E+02, 0.83100E+02, 0.83200E+02, 0.83300E+02, 0.83400E+02,
     &  0.83500E+02, 0.83600E+02, 0.83700E+02, 0.83800E+02, 0.83900E+02,
     &  0.84000E+02, 0.84100E+02, 0.84200E+02, 0.84300E+02, 0.84400E+02,
     &  0.84500E+02, 0.84600E+02, 0.84700E+02, 0.84800E+02, 0.84900E+02,
     &  0.85000E+02, 0.85100E+02, 0.85200E+02, 0.85300E+02, 0.85400E+02,
     &  0.85500E+02, 0.85600E+02, 0.85700E+02, 0.85800E+02, 0.85900E+02,
     &  0.86000E+02, 0.86100E+02, 0.86200E+02, 0.86300E+02, 0.86400E+02,
     &  0.86500E+02, 0.86600E+02, 0.86700E+02, 0.86800E+02, 0.86900E+02,
     &  0.87000E+02, 0.87100E+02, 0.87200E+02, 0.87300E+02, 0.87400E+02,
     &  0.87500E+02, 0.87600E+02, 0.87700E+02, 0.87800E+02, 0.87900E+02,
     &  0.88000E+02, 0.88100E+02, 0.88200E+02, 0.88300E+02, 0.88400E+02,
     &  0.88500E+02, 0.88600E+02, 0.88700E+02, 0.88800E+02, 0.88900E+02,
     &  0.89000E+02, 0.89100E+02, 0.89200E+02, 0.89300E+02, 0.89400E+02,
     &  0.89500E+02, 0.89600E+02, 0.89700E+02, 0.89800E+02, 0.89900E+02,
     &  0.90000E+02, 0.90100E+02, 0.90200E+02, 0.90300E+02, 0.90400E+02,
     &  0.90500E+02, 0.90600E+02, 0.90700E+02, 0.90800E+02, 0.90900E+02,
     &  0.91000E+02, 0.91100E+02, 0.91200E+02, 0.91300E+02, 0.91400E+02,
     &  0.91500E+02, 0.91600E+02, 0.91700E+02, 0.91800E+02, 0.91900E+02,
     &  0.92000E+02, 0.92100E+02, 0.92200E+02, 0.92300E+02, 0.92400E+02,
     &  0.92500E+02, 0.92600E+02, 0.92700E+02, 0.92800E+02, 0.92900E+02,
     &  0.93000E+02, 0.93100E+02, 0.93200E+02, 0.93300E+02, 0.93400E+02,
     &  0.93500E+02, 0.93600E+02, 0.93700E+02, 0.93800E+02, 0.93900E+02,
     &  0.94000E+02, 0.94100E+02, 0.94200E+02, 0.94300E+02, 0.94400E+02,
     &  0.94500E+02, 0.94600E+02, 0.94700E+02, 0.94800E+02, 0.94900E+02,
     &  0.95000E+02, 0.95100E+02, 0.95200E+02, 0.95300E+02, 0.95400E+02,
     &  0.95500E+02, 0.95600E+02, 0.95700E+02, 0.95800E+02, 0.95900E+02,
     &  0.96000E+02, 0.96100E+02, 0.96200E+02, 0.96300E+02, 0.96400E+02,
     &  0.96500E+02, 0.96600E+02, 0.96700E+02, 0.96800E+02, 0.96900E+02,
     &  0.97000E+02, 0.97100E+02, 0.97200E+02, 0.97300E+02, 0.97400E+02,
     &  0.97500E+02, 0.97600E+02, 0.97700E+02, 0.97800E+02, 0.97900E+02,
     &  0.98000E+02, 0.98100E+02, 0.98200E+02, 0.98300E+02, 0.98400E+02,
     &  0.98500E+02, 0.98600E+02, 0.98700E+02, 0.98800E+02, 0.98900E+02,
     &  0.99000E+02, 0.99100E+02, 0.99200E+02, 0.99300E+02, 0.99400E+02,
     &  0.99500E+02, 0.99600E+02, 0.99700E+02, 0.99800E+02, 0.99900E+02,
     &  0.10000E+03, 0.10010E+03, 0.10020E+03, 0.10030E+03, 0.10040E+03,
     &  0.10050E+03, 0.10060E+03, 0.10070E+03, 0.10080E+03, 0.10090E+03,
     &  0.10100E+03, 0.10110E+03, 0.10120E+03, 0.10130E+03, 0.10140E+03,
     &  0.10150E+03, 0.10160E+03, 0.10170E+03, 0.10180E+03, 0.10190E+03,
     &  0.10200E+03, 0.10210E+03, 0.10220E+03, 0.10230E+03, 0.10240E+03,
     &  0.10250E+03, 0.10260E+03, 0.10270E+03, 0.10280E+03, 0.10290E+03,
     &  0.10300E+03, 0.10310E+03, 0.10320E+03, 0.10330E+03, 0.10340E+03,
     &  0.10350E+03, 0.10360E+03, 0.10370E+03, 0.10380E+03, 0.10390E+03,
     &  0.10400E+03, 0.10410E+03, 0.10420E+03, 0.10430E+03, 0.10440E+03,
     &  0.10450E+03, 0.10460E+03, 0.10470E+03, 0.10480E+03, 0.10490E+03,
     &  0.10500E+03, 0.10510E+03, 0.10520E+03, 0.10530E+03, 0.10540E+03,
     &  0.10550E+03, 0.10560E+03, 0.10570E+03, 0.10580E+03, 0.10590E+03,
     &  0.10600E+03, 0.10610E+03, 0.10620E+03, 0.10630E+03, 0.10640E+03,
     &  0.10650E+03, 0.10660E+03, 0.10670E+03, 0.10680E+03, 0.10690E+03,
     &  0.10700E+03, 0.10710E+03, 0.10720E+03, 0.10730E+03, 0.10740E+03,
     &  0.10750E+03, 0.10760E+03, 0.10770E+03, 0.10780E+03, 0.10790E+03,
     &  0.10800E+03, 0.10810E+03, 0.10820E+03, 0.10830E+03, 0.10840E+03,
     &  0.10850E+03, 0.10860E+03, 0.10870E+03, 0.10880E+03, 0.10890E+03,
     &  0.10900E+03, 0.10910E+03, 0.10920E+03, 0.10930E+03, 0.10940E+03,
     &  0.10950E+03,
     &  0.10960E+03,
     &  0.10970E+03,
     &  0.10980E+03,
     &  0.10990E+03,
     &  0.11000E+03/
      Data (bdf(i),i=       1,     701)/
     &  0.61914E+01, 0.61391E+01, 0.60513E+01, 0.60355E+01, 0.60065E+01,
     &  0.59806E+01, 0.59340E+01, 0.58814E+01, 0.58151E+01, 0.57820E+01,
     &  0.57348E+01, 0.56389E+01, 0.56473E+01, 0.55827E+01, 0.55399E+01,
     &  0.54960E+01, 0.54345E+01, 0.53856E+01, 0.53846E+01, 0.53615E+01,
     &  0.53468E+01, 0.53777E+01, 0.53366E+01, 0.53532E+01, 0.52909E+01,
     &  0.53416E+01, 0.52903E+01, 0.52970E+01, 0.52226E+01, 0.51241E+01,
     &  0.51496E+01, 0.51879E+01, 0.51819E+01, 0.51613E+01, 0.52055E+01,
     &  0.52325E+01, 0.51851E+01, 0.52013E+01, 0.51706E+01, 0.52054E+01,
     &  0.52169E+01, 0.51936E+01, 0.51925E+01, 0.51120E+01, 0.50483E+01,
     &  0.50436E+01, 0.50393E+01, 0.50340E+01, 0.50451E+01, 0.50492E+01,
     &  0.50348E+01, 0.50137E+01, 0.50222E+01, 0.50618E+01, 0.50523E+01,
     &  0.51107E+01, 0.51407E+01, 0.51738E+01, 0.51913E+01, 0.52282E+01,
     &  0.52313E+01, 0.52744E+01, 0.52833E+01, 0.53047E+01, 0.53106E+01,
     &  0.53033E+01, 0.52878E+01, 0.52894E+01, 0.53565E+01, 0.53838E+01,
     &  0.53613E+01, 0.53986E+01, 0.54863E+01, 0.55008E+01, 0.55358E+01,
     &  0.55466E+01, 0.55541E+01, 0.55007E+01, 0.55288E+01, 0.55430E+01,
     &  0.55472E+01, 0.56092E+01, 0.56427E+01, 0.56483E+01, 0.56747E+01,
     &  0.57155E+01, 0.57586E+01, 0.57913E+01, 0.57874E+01, 0.58516E+01,
     &  0.59014E+01, 0.58976E+01, 0.59446E+01, 0.59567E+01, 0.60123E+01,
     &  0.60641E+01, 0.61365E+01, 0.61999E+01, 0.62193E+01, 0.62920E+01,
     &  0.63248E+01, 0.62878E+01, 0.62902E+01, 0.62029E+01, 0.62151E+01,
     &  0.62337E+01, 0.62319E+01, 0.62318E+01, 0.63239E+01, 0.63144E+01,
     &  0.63073E+01, 0.63091E+01, 0.63128E+01, 0.63292E+01, 0.63519E+01,
     &  0.63311E+01, 0.63979E+01, 0.63702E+01, 0.63757E+01, 0.63740E+01,
     &  0.64225E+01, 0.64339E+01, 0.64706E+01, 0.65278E+01, 0.65474E+01,
     &  0.65624E+01, 0.65572E+01, 0.65528E+01, 0.65433E+01, 0.65387E+01,
     &  0.64953E+01, 0.65183E+01, 0.65374E+01, 0.65467E+01, 0.65393E+01,
     &  0.64603E+01, 0.65200E+01, 0.64147E+01, 0.64327E+01, 0.64852E+01,
     &  0.65027E+01, 0.64817E+01, 0.65332E+01, 0.64937E+01, 0.65252E+01,
     &  0.64968E+01, 0.65261E+01, 0.66030E+01, 0.65964E+01, 0.65989E+01,
     &  0.66363E+01, 0.66108E+01, 0.66244E+01, 0.66693E+01, 0.66389E+01,
     &  0.66574E+01, 0.66559E+01, 0.66765E+01, 0.66920E+01, 0.66847E+01,
     &  0.66849E+01, 0.67033E+01, 0.67195E+01, 0.67961E+01, 0.67546E+01,
     &  0.67608E+01, 0.68339E+01, 0.68717E+01, 0.68900E+01, 0.69042E+01,
     &  0.68944E+01, 0.68707E+01, 0.68848E+01, 0.68879E+01, 0.69733E+01,
     &  0.69680E+01, 0.69926E+01, 0.70092E+01, 0.70881E+01, 0.71098E+01,
     &  0.71113E+01, 0.71604E+01, 0.71905E+01, 0.71981E+01, 0.72797E+01,
     &  0.73413E+01, 0.73846E+01, 0.74689E+01, 0.74987E+01, 0.75738E+01,
     &  0.76302E+01, 0.76404E+01, 0.76383E+01, 0.77621E+01, 0.78271E+01,
     &  0.79151E+01, 0.80013E+01, 0.80556E+01, 0.81581E+01, 0.82021E+01,
     &  0.83190E+01, 0.83319E+01, 0.84145E+01, 0.84427E+01, 0.84142E+01,
     &  0.83895E+01, 0.84215E+01, 0.84996E+01, 0.85075E+01, 0.84867E+01,
     &  0.84573E+01, 0.84856E+01, 0.84734E+01, 0.84274E+01, 0.84214E+01,
     &  0.83428E+01, 0.83117E+01, 0.83099E+01, 0.82755E+01, 0.82710E+01,
     &  0.82028E+01, 0.82175E+01, 0.81802E+01, 0.81434E+01, 0.81706E+01,
     &  0.82418E+01, 0.81955E+01, 0.81963E+01, 0.81586E+01, 0.81640E+01,
     &  0.81341E+01, 0.80995E+01, 0.81020E+01, 0.80952E+01, 0.80814E+01,
     &  0.80205E+01, 0.80188E+01, 0.79833E+01, 0.80443E+01, 0.80114E+01,
     &  0.80316E+01, 0.80171E+01, 0.79822E+01, 0.79384E+01, 0.79151E+01,
     &  0.79005E+01, 0.78776E+01, 0.79231E+01, 0.79261E+01, 0.78914E+01,
     &  0.79216E+01, 0.80188E+01, 0.80214E+01, 0.81310E+01, 0.82348E+01,
     &  0.83192E+01, 0.83817E+01, 0.83522E+01, 0.84070E+01, 0.84909E+01,
     &  0.84590E+01, 0.85379E+01, 0.86228E+01, 0.86745E+01, 0.87128E+01,
     &  0.87557E+01, 0.88191E+01, 0.88694E+01, 0.88803E+01, 0.89461E+01,
     &  0.90302E+01, 0.91221E+01, 0.92067E+01, 0.93355E+01, 0.94518E+01,
     &  0.93537E+01, 0.93905E+01, 0.94816E+01, 0.95034E+01, 0.95438E+01,
     &  0.94989E+01, 0.94929E+01, 0.95438E+01, 0.95957E+01, 0.96626E+01,
     &  0.97183E+01, 0.97837E+01, 0.98097E+01, 0.99115E+01, 0.10014E+02,
     &  0.10096E+02, 0.10175E+02, 0.10272E+02, 0.10214E+02, 0.10265E+02,
     &  0.10346E+02, 0.10360E+02, 0.10421E+02, 0.10451E+02, 0.10522E+02,
     &  0.10625E+02, 0.10669E+02, 0.10615E+02, 0.10579E+02, 0.10717E+02,
     &  0.10713E+02, 0.10696E+02, 0.10713E+02, 0.10712E+02, 0.10755E+02,
     &  0.10775E+02, 0.10786E+02, 0.10846E+02, 0.10924E+02, 0.11031E+02,
     &  0.11054E+02, 0.11085E+02, 0.11149E+02, 0.11026E+02, 0.11146E+02,
     &  0.11132E+02, 0.11187E+02, 0.11195E+02, 0.11241E+02, 0.11274E+02,
     &  0.11399E+02, 0.11416E+02, 0.11489E+02, 0.11527E+02, 0.11576E+02,
     &  0.11636E+02, 0.11748E+02, 0.11744E+02, 0.11810E+02, 0.11882E+02,
     &  0.12000E+02, 0.12113E+02, 0.12216E+02, 0.12317E+02, 0.12420E+02,
     &  0.12581E+02, 0.12664E+02, 0.12653E+02, 0.12757E+02, 0.12901E+02,
     &  0.12958E+02, 0.13150E+02, 0.13294E+02, 0.13392E+02, 0.13502E+02,
     &  0.13695E+02, 0.13862E+02, 0.14002E+02, 0.14211E+02, 0.14433E+02,
     &  0.14657E+02, 0.14900E+02, 0.15098E+02, 0.15360E+02, 0.15581E+02,
     &  0.15793E+02, 0.16014E+02, 0.16176E+02, 0.16390E+02, 0.16626E+02,
     &  0.16925E+02, 0.17077E+02, 0.17396E+02, 0.17665E+02, 0.17950E+02,
     &  0.18193E+02, 0.18465E+02, 0.18823E+02, 0.19047E+02, 0.19216E+02,
     &  0.19513E+02, 0.19753E+02, 0.19978E+02, 0.20280E+02, 0.20461E+02,
     &  0.20702E+02, 0.21008E+02, 0.21209E+02, 0.21274E+02, 0.21481E+02,
     &  0.21599E+02, 0.21687E+02, 0.21797E+02, 0.21818E+02, 0.21878E+02,
     &  0.21911E+02, 0.21899E+02, 0.21879E+02, 0.21811E+02, 0.21756E+02,
     &  0.21767E+02, 0.21636E+02, 0.21539E+02, 0.21554E+02, 0.21436E+02,
     &  0.21299E+02, 0.21389E+02, 0.21353E+02, 0.21311E+02, 0.21216E+02,
     &  0.21140E+02, 0.21088E+02, 0.21120E+02, 0.21020E+02, 0.20896E+02,
     &  0.20880E+02, 0.20809E+02, 0.20684E+02, 0.20553E+02, 0.20470E+02,
     &  0.20378E+02, 0.20337E+02, 0.20287E+02, 0.20148E+02, 0.20143E+02,
     &  0.20156E+02, 0.20085E+02, 0.20070E+02, 0.20111E+02, 0.20067E+02,
     &  0.19971E+02, 0.19956E+02, 0.19989E+02, 0.19991E+02, 0.20010E+02,
     &  0.20017E+02, 0.20090E+02, 0.20039E+02, 0.20176E+02, 0.20228E+02,
     &  0.20339E+02, 0.20394E+02, 0.20532E+02, 0.20579E+02, 0.20741E+02,
     &  0.20865E+02, 0.20996E+02, 0.21120E+02, 0.21240E+02, 0.21278E+02,
     &  0.21434E+02, 0.21575E+02, 0.21654E+02, 0.21790E+02, 0.21898E+02,
     &  0.21991E+02, 0.21742E+02, 0.21477E+02, 0.21226E+02, 0.20947E+02,
     &  0.20742E+02, 0.20519E+02, 0.20206E+02, 0.19922E+02, 0.19713E+02,
     &  0.19465E+02, 0.19252E+02, 0.18976E+02, 0.18778E+02, 0.18515E+02,
     &  0.18254E+02, 0.18077E+02, 0.17796E+02, 0.17500E+02, 0.17432E+02,
     &  0.17237E+02, 0.17088E+02, 0.16897E+02, 0.16788E+02, 0.16615E+02,
     &  0.16463E+02, 0.16316E+02, 0.16217E+02, 0.16066E+02, 0.15913E+02,
     &  0.15827E+02, 0.15748E+02, 0.15531E+02, 0.15411E+02, 0.15281E+02,
     &  0.15102E+02, 0.14997E+02, 0.14894E+02, 0.14744E+02, 0.14669E+02,
     &  0.14572E+02, 0.14449E+02, 0.14350E+02, 0.14233E+02, 0.14144E+02,
     &  0.14054E+02, 0.14000E+02, 0.13918E+02, 0.13828E+02, 0.13702E+02,
     &  0.13660E+02, 0.13477E+02, 0.13325E+02, 0.13184E+02, 0.13027E+02,
     &  0.12853E+02, 0.12736E+02, 0.12608E+02, 0.12465E+02, 0.12298E+02,
     &  0.12118E+02, 0.11991E+02, 0.11931E+02, 0.11832E+02, 0.11682E+02,
     &  0.11605E+02, 0.11468E+02, 0.11360E+02, 0.11207E+02, 0.11019E+02,
     &  0.10924E+02, 0.10894E+02, 0.10769E+02, 0.10700E+02, 0.10571E+02,
     &  0.10494E+02, 0.10404E+02, 0.10310E+02, 0.10233E+02, 0.10198E+02,
     &  0.10085E+02, 0.10015E+02, 0.98931E+01, 0.97433E+01, 0.96375E+01,
     &  0.95408E+01, 0.93752E+01, 0.92018E+01, 0.90387E+01, 0.89286E+01,
     &  0.87603E+01, 0.86533E+01, 0.84874E+01, 0.83450E+01, 0.82172E+01,
     &  0.80518E+01, 0.79717E+01, 0.78621E+01, 0.77680E+01, 0.76799E+01,
     &  0.75891E+01, 0.74405E+01, 0.72357E+01, 0.71376E+01, 0.70055E+01,
     &  0.68475E+01, 0.67052E+01, 0.65615E+01, 0.64191E+01, 0.62577E+01,
     &  0.61342E+01, 0.60572E+01, 0.59313E+01, 0.58442E+01, 0.57734E+01,
     &  0.56539E+01, 0.55022E+01, 0.53634E+01, 0.52740E+01, 0.51623E+01,
     &  0.50906E+01, 0.49580E+01, 0.48702E+01, 0.47759E+01, 0.46665E+01,
     &  0.45449E+01, 0.44367E+01, 0.43217E+01, 0.41904E+01, 0.40562E+01,
     &  0.38929E+01, 0.37882E+01, 0.37146E+01, 0.36329E+01, 0.35157E+01,
     &  0.33915E+01, 0.32983E+01, 0.31962E+01, 0.30861E+01, 0.30009E+01,
     &  0.28996E+01, 0.27721E+01, 0.26775E+01, 0.26022E+01, 0.25558E+01,
     &  0.24562E+01, 0.23535E+01, 0.22700E+01, 0.22117E+01, 0.21454E+01,
     &  0.20611E+01, 0.19633E+01, 0.18288E+01, 0.17279E+01, 0.15907E+01,
     &  0.14984E+01, 0.14170E+01, 0.13119E+01, 0.11988E+01, 0.10849E+01,
     &  0.10004E+01, 0.91368E+00, 0.81122E+00, 0.72984E+00, 0.65493E+00,
     &  0.57621E+00, 0.53559E+00, 0.48048E+00, 0.41128E+00, 0.34454E+00,
     &  0.29657E+00, 0.25131E+00, 0.20850E+00, 0.18049E+00, 0.14847E+00,
     &  0.13263E+00, 0.11990E+00, 0.10717E+00, 0.10243E+00, 0.83493E-01,
     &  0.74583E-01, 0.74583E-01, 0.68217E-01, 0.60221E-01, 0.55486E-01,
     &  0.41281E-01, 0.38020E-01, 0.27854E-01, 0.20672E-01, 0.20672E-01,
     &  0.20672E-01, 0.10287E-01, 0.10287E-01, 0.10287E-01, 0.10287E-01,
     &  0.10287E-01, 0.10287E-01, 0.10287E-01, 0.55517E-02, 0.55517E-02,
     &  0.55517E-02, 0.55517E-02, 0.55517E-02, 0.55517E-02, 0.55517E-02,
     &  0.55517E-02, 0.55517E-02, 0.55517E-02, 0.55517E-02, 0.55517E-02,
     &  0.55517E-02, 0.55517E-02, 0.55517E-02, 0.55517E-02, 0.55517E-02,
     &  0.55517E-02, 0.55517E-02, 0.55517E-02, 0.55517E-02, 0.55517E-02,
     &  0.55517E-02, 0.55517E-02, 0.55517E-02, 0.55517E-02, 0.55517E-02,
     &  0.55517E-02, 0.55517E-02, 0.10287E-01, 0.10287E-01, 0.10287E-01,
     &  0.10287E-01, 0.10287E-01, 0.15022E-01, 0.15022E-01, 0.15022E-01,
     &  0.15022E-01, 0.15022E-01, 0.15022E-01, 0.15022E-01, 0.19757E-01,
     &  0.19757E-01, 0.24492E-01, 0.38697E-01, 0.38697E-01, 0.49777E-01,
     &  0.51408E-01,
     &  0.65613E-01,
     &  0.68874E-01,
     &  0.70504E-01,
     &  0.70504E-01,
     &  0.76870E-01/
      Data (sigma(i),i=       1,     701)/
     &  0.27403E-01, 0.27519E-01, 0.27696E-01, 0.27735E-01, 0.27808E-01,
     &  0.27883E-01, 0.27987E-01, 0.28103E-01, 0.28273E-01, 0.28346E-01,
     &  0.28464E-01, 0.28702E-01, 0.28677E-01, 0.28831E-01, 0.28950E-01,
     &  0.29078E-01, 0.29226E-01, 0.29352E-01, 0.29368E-01, 0.29424E-01,
     &  0.29462E-01, 0.29360E-01, 0.29478E-01, 0.29423E-01, 0.29566E-01,
     &  0.29439E-01, 0.29575E-01, 0.29545E-01, 0.29769E-01, 0.30066E-01,
     &  0.30009E-01, 0.29910E-01, 0.29932E-01, 0.30004E-01, 0.29892E-01,
     &  0.29819E-01, 0.29955E-01, 0.29916E-01, 0.30015E-01, 0.29921E-01,
     &  0.29895E-01, 0.29946E-01, 0.29935E-01, 0.30160E-01, 0.30331E-01,
     &  0.30335E-01, 0.30350E-01, 0.30355E-01, 0.30339E-01, 0.30353E-01,
     &  0.30376E-01, 0.30441E-01, 0.30422E-01, 0.30299E-01, 0.30308E-01,
     &  0.30132E-01, 0.30041E-01, 0.29945E-01, 0.29870E-01, 0.29760E-01,
     &  0.29746E-01, 0.29635E-01, 0.29599E-01, 0.29548E-01, 0.29536E-01,
     &  0.29556E-01, 0.29603E-01, 0.29605E-01, 0.29432E-01, 0.29362E-01,
     &  0.29401E-01, 0.29297E-01, 0.29054E-01, 0.29008E-01, 0.28906E-01,
     &  0.28883E-01, 0.28847E-01, 0.28955E-01, 0.28881E-01, 0.28835E-01,
     &  0.28830E-01, 0.28664E-01, 0.28580E-01, 0.28561E-01, 0.28487E-01,
     &  0.28381E-01, 0.28285E-01, 0.28196E-01, 0.28184E-01, 0.28023E-01,
     &  0.27890E-01, 0.27870E-01, 0.27760E-01, 0.27717E-01, 0.27578E-01,
     &  0.27452E-01, 0.27281E-01, 0.27134E-01, 0.27072E-01, 0.26915E-01,
     &  0.26838E-01, 0.26896E-01, 0.26884E-01, 0.27055E-01, 0.27023E-01,
     &  0.26975E-01, 0.26966E-01, 0.26966E-01, 0.26780E-01, 0.26799E-01,
     &  0.26792E-01, 0.26787E-01, 0.26783E-01, 0.26748E-01, 0.26699E-01,
     &  0.26736E-01, 0.26609E-01, 0.26668E-01, 0.26659E-01, 0.26657E-01,
     &  0.26547E-01, 0.26516E-01, 0.26431E-01, 0.26299E-01, 0.26249E-01,
     &  0.26222E-01, 0.26217E-01, 0.26233E-01, 0.26245E-01, 0.26261E-01,
     &  0.26337E-01, 0.26296E-01, 0.26266E-01, 0.26255E-01, 0.26275E-01,
     &  0.26422E-01, 0.26292E-01, 0.26490E-01, 0.26445E-01, 0.26342E-01,
     &  0.26310E-01, 0.26345E-01, 0.26242E-01, 0.26315E-01, 0.26249E-01,
     &  0.26298E-01, 0.26243E-01, 0.26084E-01, 0.26097E-01, 0.26099E-01,
     &  0.26026E-01, 0.26076E-01, 0.26062E-01, 0.25977E-01, 0.26029E-01,
     &  0.26012E-01, 0.26024E-01, 0.25983E-01, 0.25971E-01, 0.25991E-01,
     &  0.26004E-01, 0.25975E-01, 0.25943E-01, 0.25809E-01, 0.25883E-01,
     &  0.25869E-01, 0.25739E-01, 0.25670E-01, 0.25621E-01, 0.25608E-01,
     &  0.25613E-01, 0.25656E-01, 0.25636E-01, 0.25632E-01, 0.25491E-01,
     &  0.25518E-01, 0.25464E-01, 0.25428E-01, 0.25267E-01, 0.25230E-01,
     &  0.25243E-01, 0.25168E-01, 0.25115E-01, 0.25097E-01, 0.24949E-01,
     &  0.24835E-01, 0.24765E-01, 0.24615E-01, 0.24570E-01, 0.24443E-01,
     &  0.24353E-01, 0.24349E-01, 0.24348E-01, 0.24163E-01, 0.24051E-01,
     &  0.23920E-01, 0.23800E-01, 0.23716E-01, 0.23575E-01, 0.23525E-01,
     &  0.23359E-01, 0.23353E-01, 0.23238E-01, 0.23204E-01, 0.23243E-01,
     &  0.23280E-01, 0.23248E-01, 0.23142E-01, 0.23133E-01, 0.23162E-01,
     &  0.23205E-01, 0.23166E-01, 0.23173E-01, 0.23233E-01, 0.23248E-01,
     &  0.23356E-01, 0.23393E-01, 0.23392E-01, 0.23438E-01, 0.23445E-01,
     &  0.23547E-01, 0.23527E-01, 0.23586E-01, 0.23631E-01, 0.23575E-01,
     &  0.23479E-01, 0.23552E-01, 0.23553E-01, 0.23592E-01, 0.23586E-01,
     &  0.23616E-01, 0.23672E-01, 0.23679E-01, 0.23690E-01, 0.23716E-01,
     &  0.23816E-01, 0.23815E-01, 0.23878E-01, 0.23792E-01, 0.23840E-01,
     &  0.23818E-01, 0.23844E-01, 0.23902E-01, 0.23975E-01, 0.24006E-01,
     &  0.24017E-01, 0.24064E-01, 0.24007E-01, 0.24014E-01, 0.24068E-01,
     &  0.24021E-01, 0.23881E-01, 0.23868E-01, 0.23699E-01, 0.23549E-01,
     &  0.23429E-01, 0.23358E-01, 0.23382E-01, 0.23307E-01, 0.23194E-01,
     &  0.23240E-01, 0.23121E-01, 0.23011E-01, 0.22942E-01, 0.22893E-01,
     &  0.22833E-01, 0.22746E-01, 0.22678E-01, 0.22667E-01, 0.22574E-01,
     &  0.22472E-01, 0.22358E-01, 0.22267E-01, 0.22115E-01, 0.21987E-01,
     &  0.22096E-01, 0.22063E-01, 0.21947E-01, 0.21915E-01, 0.21864E-01,
     &  0.21904E-01, 0.21909E-01, 0.21841E-01, 0.21782E-01, 0.21712E-01,
     &  0.21648E-01, 0.21566E-01, 0.21538E-01, 0.21431E-01, 0.21333E-01,
     &  0.21238E-01, 0.21153E-01, 0.21053E-01, 0.21115E-01, 0.21064E-01,
     &  0.20983E-01, 0.20975E-01, 0.20916E-01, 0.20895E-01, 0.20821E-01,
     &  0.20715E-01, 0.20677E-01, 0.20730E-01, 0.20775E-01, 0.20635E-01,
     &  0.20637E-01, 0.20653E-01, 0.20640E-01, 0.20643E-01, 0.20599E-01,
     &  0.20581E-01, 0.20566E-01, 0.20507E-01, 0.20436E-01, 0.20334E-01,
     &  0.20312E-01, 0.20284E-01, 0.20222E-01, 0.20335E-01, 0.20227E-01,
     &  0.20247E-01, 0.20204E-01, 0.20191E-01, 0.20148E-01, 0.20118E-01,
     &  0.20013E-01, 0.19995E-01, 0.19928E-01, 0.19892E-01, 0.19846E-01,
     &  0.19792E-01, 0.19699E-01, 0.19697E-01, 0.19650E-01, 0.19591E-01,
     &  0.19496E-01, 0.19407E-01, 0.19317E-01, 0.19237E-01, 0.19158E-01,
     &  0.19031E-01, 0.18969E-01, 0.18978E-01, 0.18908E-01, 0.18795E-01,
     &  0.18751E-01, 0.18613E-01, 0.18511E-01, 0.18441E-01, 0.18366E-01,
     &  0.18239E-01, 0.18136E-01, 0.18044E-01, 0.17908E-01, 0.17762E-01,
     &  0.17623E-01, 0.17479E-01, 0.17362E-01, 0.17217E-01, 0.17087E-01,
     &  0.16970E-01, 0.16850E-01, 0.16765E-01, 0.16654E-01, 0.16535E-01,
     &  0.16388E-01, 0.16314E-01, 0.16163E-01, 0.16035E-01, 0.15906E-01,
     &  0.15800E-01, 0.15682E-01, 0.15527E-01, 0.15434E-01, 0.15361E-01,
     &  0.15239E-01, 0.15141E-01, 0.15051E-01, 0.14939E-01, 0.14870E-01,
     &  0.14783E-01, 0.14670E-01, 0.14595E-01, 0.14571E-01, 0.14494E-01,
     &  0.14449E-01, 0.14416E-01, 0.14375E-01, 0.14368E-01, 0.14345E-01,
     &  0.14333E-01, 0.14336E-01, 0.14339E-01, 0.14361E-01, 0.14375E-01,
     &  0.14368E-01, 0.14408E-01, 0.14437E-01, 0.14433E-01, 0.14468E-01,
     &  0.14511E-01, 0.14483E-01, 0.14495E-01, 0.14500E-01, 0.14527E-01,
     &  0.14545E-01, 0.14559E-01, 0.14546E-01, 0.14578E-01, 0.14616E-01,
     &  0.14625E-01, 0.14647E-01, 0.14689E-01, 0.14732E-01, 0.14757E-01,
     &  0.14790E-01, 0.14801E-01, 0.14819E-01, 0.14871E-01, 0.14866E-01,
     &  0.14857E-01, 0.14882E-01, 0.14884E-01, 0.14872E-01, 0.14886E-01,
     &  0.14919E-01, 0.14922E-01, 0.14913E-01, 0.14910E-01, 0.14893E-01,
     &  0.14890E-01, 0.14859E-01, 0.14874E-01, 0.14818E-01, 0.14796E-01,
     &  0.14754E-01, 0.14724E-01, 0.14671E-01, 0.14647E-01, 0.14584E-01,
     &  0.14529E-01, 0.14472E-01, 0.14418E-01, 0.14377E-01, 0.14358E-01,
     &  0.14296E-01, 0.14243E-01, 0.14213E-01, 0.14159E-01, 0.14115E-01,
     &  0.14079E-01, 0.14149E-01, 0.14229E-01, 0.14306E-01, 0.14396E-01,
     &  0.14459E-01, 0.14533E-01, 0.14627E-01, 0.14715E-01, 0.14783E-01,
     &  0.14870E-01, 0.14936E-01, 0.15027E-01, 0.15091E-01, 0.15182E-01,
     &  0.15269E-01, 0.15324E-01, 0.15420E-01, 0.15531E-01, 0.15546E-01,
     &  0.15618E-01, 0.15674E-01, 0.15744E-01, 0.15785E-01, 0.15847E-01,
     &  0.15910E-01, 0.15964E-01, 0.16001E-01, 0.16058E-01, 0.16122E-01,
     &  0.16161E-01, 0.16191E-01, 0.16280E-01, 0.16327E-01, 0.16381E-01,
     &  0.16457E-01, 0.16499E-01, 0.16541E-01, 0.16610E-01, 0.16639E-01,
     &  0.16690E-01, 0.16747E-01, 0.16802E-01, 0.16859E-01, 0.16904E-01,
     &  0.16946E-01, 0.16967E-01, 0.16999E-01, 0.17041E-01, 0.17108E-01,
     &  0.17136E-01, 0.17227E-01, 0.17305E-01, 0.17390E-01, 0.17481E-01,
     &  0.17584E-01, 0.17657E-01, 0.17735E-01, 0.17826E-01, 0.17928E-01,
     &  0.18045E-01, 0.18138E-01, 0.18188E-01, 0.18261E-01, 0.18361E-01,
     &  0.18430E-01, 0.18538E-01, 0.18623E-01, 0.18744E-01, 0.18888E-01,
     &  0.18963E-01, 0.19008E-01, 0.19122E-01, 0.19186E-01, 0.19289E-01,
     &  0.19367E-01, 0.19452E-01, 0.19565E-01, 0.19663E-01, 0.19719E-01,
     &  0.19848E-01, 0.19944E-01, 0.20070E-01, 0.20224E-01, 0.20349E-01,
     &  0.20470E-01, 0.20671E-01, 0.20866E-01, 0.21073E-01, 0.21223E-01,
     &  0.21455E-01, 0.21601E-01, 0.21821E-01, 0.22021E-01, 0.22189E-01,
     &  0.22434E-01, 0.22581E-01, 0.22754E-01, 0.22916E-01, 0.23070E-01,
     &  0.23248E-01, 0.23499E-01, 0.23822E-01, 0.23987E-01, 0.24231E-01,
     &  0.24516E-01, 0.24777E-01, 0.25074E-01, 0.25345E-01, 0.25682E-01,
     &  0.25946E-01, 0.26161E-01, 0.26461E-01, 0.26715E-01, 0.26931E-01,
     &  0.27252E-01, 0.27615E-01, 0.27985E-01, 0.28240E-01, 0.28572E-01,
     &  0.28845E-01, 0.29212E-01, 0.29515E-01, 0.29849E-01, 0.30234E-01,
     &  0.30683E-01, 0.31079E-01, 0.31515E-01, 0.32071E-01, 0.32606E-01,
     &  0.33276E-01, 0.33775E-01, 0.34133E-01, 0.34599E-01, 0.35177E-01,
     &  0.35820E-01, 0.36339E-01, 0.36956E-01, 0.37621E-01, 0.38117E-01,
     &  0.38789E-01, 0.39642E-01, 0.40346E-01, 0.40979E-01, 0.41395E-01,
     &  0.42321E-01, 0.43233E-01, 0.44067E-01, 0.44666E-01, 0.45388E-01,
     &  0.46316E-01, 0.47421E-01, 0.49140E-01, 0.50598E-01, 0.52613E-01,
     &  0.54108E-01, 0.55655E-01, 0.57900E-01, 0.60510E-01, 0.63484E-01,
     &  0.66201E-01, 0.69376E-01, 0.73601E-01, 0.78006E-01, 0.82186E-01,
     &  0.87472E-01, 0.90801E-01, 0.96180E-01, 0.10298E+00, 0.11276E+00,
     &  0.12076E+00, 0.13197E+00, 0.14503E+00, 0.15690E+00, 0.17307E+00,
     &  0.18320E+00, 0.19385E+00, 0.20657E+00, 0.21112E+00, 0.23286E+00,
     &  0.24751E+00, 0.24751E+00, 0.26046E+00, 0.28179E+00, 0.29369E+00,
     &  0.34112E+00, 0.36538E+00, 0.42640E+00, 0.50176E+00, 0.50176E+00,
     &  0.50176E+00, 0.70933E+00, 0.70933E+00, 0.70933E+00, 0.70933E+00,
     &  0.70933E+00, 0.70933E+00, 0.70933E+00, 0.99999E+00, 0.99999E+00,
     &  0.99999E+00, 0.99999E+00, 0.99999E+00, 0.99999E+00, 0.99999E+00,
     &  0.99999E+00, 0.99999E+00, 0.99999E+00, 0.99999E+00, 0.99999E+00,
     &  0.99999E+00, 0.99999E+00, 0.99999E+00, 0.99999E+00, 0.99999E+00,
     &  0.99999E+00, 0.99999E+00, 0.99999E+00, 0.99999E+00, 0.99999E+00,
     &  0.99999E+00, 0.99999E+00, 0.99999E+00, 0.99999E+00, 0.99999E+00,
     &  0.99999E+00, 0.99999E+00, 0.70933E+00, 0.70933E+00, 0.70933E+00,
     &  0.70933E+00, 0.70933E+00, 0.57905E+00, 0.57905E+00, 0.57905E+00,
     &  0.57905E+00, 0.57905E+00, 0.57905E+00, 0.57905E+00, 0.50127E+00,
     &  0.50127E+00, 0.44820E+00, 0.35409E+00, 0.35409E+00, 0.31711E+00,
     &  0.30869E+00,
     &  0.27224E+00,
     &  0.26150E+00,
     &  0.25650E+00,
     &  0.25650E+00,
     &  0.24411E+00/
c
      massi = hmass(1)
      massx = hmass(npoint)
      dmass = (massx-massi)/Real(npoint-1)
c      
      imass = int( (mh-massi)/dmass ) + 1
c
      if (imass.eq.npoint) then
        imass = npoint
        jmass = npoint
        rmass = 0.0
      Endif
cjm Modifie le 24Fevrier
      If (imass.le.0 .or. imass.gt.npoint) then
        A192_HGG_BACKG = 0.
        RETURN
      Endif
      If (imass.ge.1..and.imass.lt.npoint) then
        jmass = imass + 1
        rmass = mh - hmass(imass)
      endif
c
      If (.not.err) A192_HGG_BACKG = bdf(imass)+(bdf(jmass)
     &     -bdf(imass))*rmass/dmass
      If (err) A192_HGG_BACKG = sigma(imass)+(sigma(jmass)
     &     -sigma(imass))*rmass/dmass
c
      RETURN
      END
      REAL FUNCTION A196_HGG_BACKG(mh,myich,err)
      Implicit none
      Real mh
      Integer myich
c
      Logical first,err
      Data first/.TRUE./
      Integer npoint
      Parameter (npoint=701)
      Real sigma(npoint),bdf(npoint),hmass(npoint)
      Real massi,massx,dmass,rmass
      Integer i,imass,jmass
      Data (hmass(i),i=       1,     701)/
     &  0.40000E+02, 0.40100E+02, 0.40200E+02, 0.40300E+02, 0.40400E+02,
     &  0.40500E+02, 0.40600E+02, 0.40700E+02, 0.40800E+02, 0.40900E+02,
     &  0.41000E+02, 0.41100E+02, 0.41200E+02, 0.41300E+02, 0.41400E+02,
     &  0.41500E+02, 0.41600E+02, 0.41700E+02, 0.41800E+02, 0.41900E+02,
     &  0.42000E+02, 0.42100E+02, 0.42200E+02, 0.42300E+02, 0.42400E+02,
     &  0.42500E+02, 0.42600E+02, 0.42700E+02, 0.42800E+02, 0.42900E+02,
     &  0.43000E+02, 0.43100E+02, 0.43200E+02, 0.43300E+02, 0.43400E+02,
     &  0.43500E+02, 0.43600E+02, 0.43700E+02, 0.43800E+02, 0.43900E+02,
     &  0.44000E+02, 0.44100E+02, 0.44200E+02, 0.44300E+02, 0.44400E+02,
     &  0.44500E+02, 0.44600E+02, 0.44700E+02, 0.44800E+02, 0.44900E+02,
     &  0.45000E+02, 0.45100E+02, 0.45200E+02, 0.45300E+02, 0.45400E+02,
     &  0.45500E+02, 0.45600E+02, 0.45700E+02, 0.45800E+02, 0.45900E+02,
     &  0.46000E+02, 0.46100E+02, 0.46200E+02, 0.46300E+02, 0.46400E+02,
     &  0.46500E+02, 0.46600E+02, 0.46700E+02, 0.46800E+02, 0.46900E+02,
     &  0.47000E+02, 0.47100E+02, 0.47200E+02, 0.47300E+02, 0.47400E+02,
     &  0.47500E+02, 0.47600E+02, 0.47700E+02, 0.47800E+02, 0.47900E+02,
     &  0.48000E+02, 0.48100E+02, 0.48200E+02, 0.48300E+02, 0.48400E+02,
     &  0.48500E+02, 0.48600E+02, 0.48700E+02, 0.48800E+02, 0.48900E+02,
     &  0.49000E+02, 0.49100E+02, 0.49200E+02, 0.49300E+02, 0.49400E+02,
     &  0.49500E+02, 0.49600E+02, 0.49700E+02, 0.49800E+02, 0.49900E+02,
     &  0.50000E+02, 0.50100E+02, 0.50200E+02, 0.50300E+02, 0.50400E+02,
     &  0.50500E+02, 0.50600E+02, 0.50700E+02, 0.50800E+02, 0.50900E+02,
     &  0.51000E+02, 0.51100E+02, 0.51200E+02, 0.51300E+02, 0.51400E+02,
     &  0.51500E+02, 0.51600E+02, 0.51700E+02, 0.51800E+02, 0.51900E+02,
     &  0.52000E+02, 0.52100E+02, 0.52200E+02, 0.52300E+02, 0.52400E+02,
     &  0.52500E+02, 0.52600E+02, 0.52700E+02, 0.52800E+02, 0.52900E+02,
     &  0.53000E+02, 0.53100E+02, 0.53200E+02, 0.53300E+02, 0.53400E+02,
     &  0.53500E+02, 0.53600E+02, 0.53700E+02, 0.53800E+02, 0.53900E+02,
     &  0.54000E+02, 0.54100E+02, 0.54200E+02, 0.54300E+02, 0.54400E+02,
     &  0.54500E+02, 0.54600E+02, 0.54700E+02, 0.54800E+02, 0.54900E+02,
     &  0.55000E+02, 0.55100E+02, 0.55200E+02, 0.55300E+02, 0.55400E+02,
     &  0.55500E+02, 0.55600E+02, 0.55700E+02, 0.55800E+02, 0.55900E+02,
     &  0.56000E+02, 0.56100E+02, 0.56200E+02, 0.56300E+02, 0.56400E+02,
     &  0.56500E+02, 0.56600E+02, 0.56700E+02, 0.56800E+02, 0.56900E+02,
     &  0.57000E+02, 0.57100E+02, 0.57200E+02, 0.57300E+02, 0.57400E+02,
     &  0.57500E+02, 0.57600E+02, 0.57700E+02, 0.57800E+02, 0.57900E+02,
     &  0.58000E+02, 0.58100E+02, 0.58200E+02, 0.58300E+02, 0.58400E+02,
     &  0.58500E+02, 0.58600E+02, 0.58700E+02, 0.58800E+02, 0.58900E+02,
     &  0.59000E+02, 0.59100E+02, 0.59200E+02, 0.59300E+02, 0.59400E+02,
     &  0.59500E+02, 0.59600E+02, 0.59700E+02, 0.59800E+02, 0.59900E+02,
     &  0.60000E+02, 0.60100E+02, 0.60200E+02, 0.60300E+02, 0.60400E+02,
     &  0.60500E+02, 0.60600E+02, 0.60700E+02, 0.60800E+02, 0.60900E+02,
     &  0.61000E+02, 0.61100E+02, 0.61200E+02, 0.61300E+02, 0.61400E+02,
     &  0.61500E+02, 0.61600E+02, 0.61700E+02, 0.61800E+02, 0.61900E+02,
     &  0.62000E+02, 0.62100E+02, 0.62200E+02, 0.62300E+02, 0.62400E+02,
     &  0.62500E+02, 0.62600E+02, 0.62700E+02, 0.62800E+02, 0.62900E+02,
     &  0.63000E+02, 0.63100E+02, 0.63200E+02, 0.63300E+02, 0.63400E+02,
     &  0.63500E+02, 0.63600E+02, 0.63700E+02, 0.63800E+02, 0.63900E+02,
     &  0.64000E+02, 0.64100E+02, 0.64200E+02, 0.64300E+02, 0.64400E+02,
     &  0.64500E+02, 0.64600E+02, 0.64700E+02, 0.64800E+02, 0.64900E+02,
     &  0.65000E+02, 0.65100E+02, 0.65200E+02, 0.65300E+02, 0.65400E+02,
     &  0.65500E+02, 0.65600E+02, 0.65700E+02, 0.65800E+02, 0.65900E+02,
     &  0.66000E+02, 0.66100E+02, 0.66200E+02, 0.66300E+02, 0.66400E+02,
     &  0.66500E+02, 0.66600E+02, 0.66700E+02, 0.66800E+02, 0.66900E+02,
     &  0.67000E+02, 0.67100E+02, 0.67200E+02, 0.67300E+02, 0.67400E+02,
     &  0.67500E+02, 0.67600E+02, 0.67700E+02, 0.67800E+02, 0.67900E+02,
     &  0.68000E+02, 0.68100E+02, 0.68200E+02, 0.68300E+02, 0.68400E+02,
     &  0.68500E+02, 0.68600E+02, 0.68700E+02, 0.68800E+02, 0.68900E+02,
     &  0.69000E+02, 0.69100E+02, 0.69200E+02, 0.69300E+02, 0.69400E+02,
     &  0.69500E+02, 0.69600E+02, 0.69700E+02, 0.69800E+02, 0.69900E+02,
     &  0.70000E+02, 0.70100E+02, 0.70200E+02, 0.70300E+02, 0.70400E+02,
     &  0.70500E+02, 0.70600E+02, 0.70700E+02, 0.70800E+02, 0.70900E+02,
     &  0.71000E+02, 0.71100E+02, 0.71200E+02, 0.71300E+02, 0.71400E+02,
     &  0.71500E+02, 0.71600E+02, 0.71700E+02, 0.71800E+02, 0.71900E+02,
     &  0.72000E+02, 0.72100E+02, 0.72200E+02, 0.72300E+02, 0.72400E+02,
     &  0.72500E+02, 0.72600E+02, 0.72700E+02, 0.72800E+02, 0.72900E+02,
     &  0.73000E+02, 0.73100E+02, 0.73200E+02, 0.73300E+02, 0.73400E+02,
     &  0.73500E+02, 0.73600E+02, 0.73700E+02, 0.73800E+02, 0.73900E+02,
     &  0.74000E+02, 0.74100E+02, 0.74200E+02, 0.74300E+02, 0.74400E+02,
     &  0.74500E+02, 0.74600E+02, 0.74700E+02, 0.74800E+02, 0.74900E+02,
     &  0.75000E+02, 0.75100E+02, 0.75200E+02, 0.75300E+02, 0.75400E+02,
     &  0.75500E+02, 0.75600E+02, 0.75700E+02, 0.75800E+02, 0.75900E+02,
     &  0.76000E+02, 0.76100E+02, 0.76200E+02, 0.76300E+02, 0.76400E+02,
     &  0.76500E+02, 0.76600E+02, 0.76700E+02, 0.76800E+02, 0.76900E+02,
     &  0.77000E+02, 0.77100E+02, 0.77200E+02, 0.77300E+02, 0.77400E+02,
     &  0.77500E+02, 0.77600E+02, 0.77700E+02, 0.77800E+02, 0.77900E+02,
     &  0.78000E+02, 0.78100E+02, 0.78200E+02, 0.78300E+02, 0.78400E+02,
     &  0.78500E+02, 0.78600E+02, 0.78700E+02, 0.78800E+02, 0.78900E+02,
     &  0.79000E+02, 0.79100E+02, 0.79200E+02, 0.79300E+02, 0.79400E+02,
     &  0.79500E+02, 0.79600E+02, 0.79700E+02, 0.79800E+02, 0.79900E+02,
     &  0.80000E+02, 0.80100E+02, 0.80200E+02, 0.80300E+02, 0.80400E+02,
     &  0.80500E+02, 0.80600E+02, 0.80700E+02, 0.80800E+02, 0.80900E+02,
     &  0.81000E+02, 0.81100E+02, 0.81200E+02, 0.81300E+02, 0.81400E+02,
     &  0.81500E+02, 0.81600E+02, 0.81700E+02, 0.81800E+02, 0.81900E+02,
     &  0.82000E+02, 0.82100E+02, 0.82200E+02, 0.82300E+02, 0.82400E+02,
     &  0.82500E+02, 0.82600E+02, 0.82700E+02, 0.82800E+02, 0.82900E+02,
     &  0.83000E+02, 0.83100E+02, 0.83200E+02, 0.83300E+02, 0.83400E+02,
     &  0.83500E+02, 0.83600E+02, 0.83700E+02, 0.83800E+02, 0.83900E+02,
     &  0.84000E+02, 0.84100E+02, 0.84200E+02, 0.84300E+02, 0.84400E+02,
     &  0.84500E+02, 0.84600E+02, 0.84700E+02, 0.84800E+02, 0.84900E+02,
     &  0.85000E+02, 0.85100E+02, 0.85200E+02, 0.85300E+02, 0.85400E+02,
     &  0.85500E+02, 0.85600E+02, 0.85700E+02, 0.85800E+02, 0.85900E+02,
     &  0.86000E+02, 0.86100E+02, 0.86200E+02, 0.86300E+02, 0.86400E+02,
     &  0.86500E+02, 0.86600E+02, 0.86700E+02, 0.86800E+02, 0.86900E+02,
     &  0.87000E+02, 0.87100E+02, 0.87200E+02, 0.87300E+02, 0.87400E+02,
     &  0.87500E+02, 0.87600E+02, 0.87700E+02, 0.87800E+02, 0.87900E+02,
     &  0.88000E+02, 0.88100E+02, 0.88200E+02, 0.88300E+02, 0.88400E+02,
     &  0.88500E+02, 0.88600E+02, 0.88700E+02, 0.88800E+02, 0.88900E+02,
     &  0.89000E+02, 0.89100E+02, 0.89200E+02, 0.89300E+02, 0.89400E+02,
     &  0.89500E+02, 0.89600E+02, 0.89700E+02, 0.89800E+02, 0.89900E+02,
     &  0.90000E+02, 0.90100E+02, 0.90200E+02, 0.90300E+02, 0.90400E+02,
     &  0.90500E+02, 0.90600E+02, 0.90700E+02, 0.90800E+02, 0.90900E+02,
     &  0.91000E+02, 0.91100E+02, 0.91200E+02, 0.91300E+02, 0.91400E+02,
     &  0.91500E+02, 0.91600E+02, 0.91700E+02, 0.91800E+02, 0.91900E+02,
     &  0.92000E+02, 0.92100E+02, 0.92200E+02, 0.92300E+02, 0.92400E+02,
     &  0.92500E+02, 0.92600E+02, 0.92700E+02, 0.92800E+02, 0.92900E+02,
     &  0.93000E+02, 0.93100E+02, 0.93200E+02, 0.93300E+02, 0.93400E+02,
     &  0.93500E+02, 0.93600E+02, 0.93700E+02, 0.93800E+02, 0.93900E+02,
     &  0.94000E+02, 0.94100E+02, 0.94200E+02, 0.94300E+02, 0.94400E+02,
     &  0.94500E+02, 0.94600E+02, 0.94700E+02, 0.94800E+02, 0.94900E+02,
     &  0.95000E+02, 0.95100E+02, 0.95200E+02, 0.95300E+02, 0.95400E+02,
     &  0.95500E+02, 0.95600E+02, 0.95700E+02, 0.95800E+02, 0.95900E+02,
     &  0.96000E+02, 0.96100E+02, 0.96200E+02, 0.96300E+02, 0.96400E+02,
     &  0.96500E+02, 0.96600E+02, 0.96700E+02, 0.96800E+02, 0.96900E+02,
     &  0.97000E+02, 0.97100E+02, 0.97200E+02, 0.97300E+02, 0.97400E+02,
     &  0.97500E+02, 0.97600E+02, 0.97700E+02, 0.97800E+02, 0.97900E+02,
     &  0.98000E+02, 0.98100E+02, 0.98200E+02, 0.98300E+02, 0.98400E+02,
     &  0.98500E+02, 0.98600E+02, 0.98700E+02, 0.98800E+02, 0.98900E+02,
     &  0.99000E+02, 0.99100E+02, 0.99200E+02, 0.99300E+02, 0.99400E+02,
     &  0.99500E+02, 0.99600E+02, 0.99700E+02, 0.99800E+02, 0.99900E+02,
     &  0.10000E+03, 0.10010E+03, 0.10020E+03, 0.10030E+03, 0.10040E+03,
     &  0.10050E+03, 0.10060E+03, 0.10070E+03, 0.10080E+03, 0.10090E+03,
     &  0.10100E+03, 0.10110E+03, 0.10120E+03, 0.10130E+03, 0.10140E+03,
     &  0.10150E+03, 0.10160E+03, 0.10170E+03, 0.10180E+03, 0.10190E+03,
     &  0.10200E+03, 0.10210E+03, 0.10220E+03, 0.10230E+03, 0.10240E+03,
     &  0.10250E+03, 0.10260E+03, 0.10270E+03, 0.10280E+03, 0.10290E+03,
     &  0.10300E+03, 0.10310E+03, 0.10320E+03, 0.10330E+03, 0.10340E+03,
     &  0.10350E+03, 0.10360E+03, 0.10370E+03, 0.10380E+03, 0.10390E+03,
     &  0.10400E+03, 0.10410E+03, 0.10420E+03, 0.10430E+03, 0.10440E+03,
     &  0.10450E+03, 0.10460E+03, 0.10470E+03, 0.10480E+03, 0.10490E+03,
     &  0.10500E+03, 0.10510E+03, 0.10520E+03, 0.10530E+03, 0.10540E+03,
     &  0.10550E+03, 0.10560E+03, 0.10570E+03, 0.10580E+03, 0.10590E+03,
     &  0.10600E+03, 0.10610E+03, 0.10620E+03, 0.10630E+03, 0.10640E+03,
     &  0.10650E+03, 0.10660E+03, 0.10670E+03, 0.10680E+03, 0.10690E+03,
     &  0.10700E+03, 0.10710E+03, 0.10720E+03, 0.10730E+03, 0.10740E+03,
     &  0.10750E+03, 0.10760E+03, 0.10770E+03, 0.10780E+03, 0.10790E+03,
     &  0.10800E+03, 0.10810E+03, 0.10820E+03, 0.10830E+03, 0.10840E+03,
     &  0.10850E+03, 0.10860E+03, 0.10870E+03, 0.10880E+03, 0.10890E+03,
     &  0.10900E+03, 0.10910E+03, 0.10920E+03, 0.10930E+03, 0.10940E+03,
     &  0.10950E+03,
     &  0.10960E+03,
     &  0.10970E+03,
     &  0.10980E+03,
     &  0.10990E+03,
     &  0.11000E+03/
      Data (bdf(i),i=       1,     701)/
     &  0.16003E+02, 0.15654E+02, 0.15659E+02, 0.15708E+02, 0.15419E+02,
     &  0.15348E+02, 0.15262E+02, 0.15075E+02, 0.14996E+02, 0.14768E+02,
     &  0.14669E+02, 0.14676E+02, 0.14669E+02, 0.14513E+02, 0.14410E+02,
     &  0.14135E+02, 0.14057E+02, 0.13952E+02, 0.13883E+02, 0.13869E+02,
     &  0.13937E+02, 0.13853E+02, 0.13899E+02, 0.13942E+02, 0.13803E+02,
     &  0.13736E+02, 0.13683E+02, 0.13620E+02, 0.13650E+02, 0.13718E+02,
     &  0.13667E+02, 0.13601E+02, 0.13630E+02, 0.13502E+02, 0.13514E+02,
     &  0.13399E+02, 0.13410E+02, 0.13375E+02, 0.13279E+02, 0.13335E+02,
     &  0.13293E+02, 0.13158E+02, 0.13121E+02, 0.13178E+02, 0.13030E+02,
     &  0.12959E+02, 0.13084E+02, 0.12908E+02, 0.12882E+02, 0.12922E+02,
     &  0.12972E+02, 0.13041E+02, 0.13195E+02, 0.13091E+02, 0.13085E+02,
     &  0.13081E+02, 0.13203E+02, 0.13338E+02, 0.13387E+02, 0.13520E+02,
     &  0.13516E+02, 0.13576E+02, 0.13624E+02, 0.13618E+02, 0.13476E+02,
     &  0.13475E+02, 0.13425E+02, 0.13493E+02, 0.13691E+02, 0.13797E+02,
     &  0.13907E+02, 0.13945E+02, 0.13912E+02, 0.13955E+02, 0.13971E+02,
     &  0.14018E+02, 0.14081E+02, 0.14171E+02, 0.14126E+02, 0.14139E+02,
     &  0.14231E+02, 0.14379E+02, 0.14562E+02, 0.14586E+02, 0.14747E+02,
     &  0.14915E+02, 0.14973E+02, 0.15142E+02, 0.15124E+02, 0.15353E+02,
     &  0.15436E+02, 0.15417E+02, 0.15548E+02, 0.15599E+02, 0.15680E+02,
     &  0.15837E+02, 0.15928E+02, 0.16004E+02, 0.16144E+02, 0.16252E+02,
     &  0.16209E+02, 0.16351E+02, 0.16424E+02, 0.16256E+02, 0.16371E+02,
     &  0.16510E+02, 0.16541E+02, 0.16533E+02, 0.16603E+02, 0.16605E+02,
     &  0.16531E+02, 0.16576E+02, 0.16678E+02, 0.16703E+02, 0.16788E+02,
     &  0.16661E+02, 0.16679E+02, 0.16688E+02, 0.16668E+02, 0.16794E+02,
     &  0.16851E+02, 0.16782E+02, 0.16949E+02, 0.16849E+02, 0.16790E+02,
     &  0.16713E+02, 0.16702E+02, 0.16621E+02, 0.16800E+02, 0.16891E+02,
     &  0.16885E+02, 0.16913E+02, 0.16978E+02, 0.16943E+02, 0.17114E+02,
     &  0.17207E+02, 0.17411E+02, 0.17628E+02, 0.17747E+02, 0.17860E+02,
     &  0.17920E+02, 0.17965E+02, 0.18075E+02, 0.18068E+02, 0.18172E+02,
     &  0.18410E+02, 0.18459E+02, 0.18512E+02, 0.18443E+02, 0.18652E+02,
     &  0.18811E+02, 0.18652E+02, 0.18666E+02, 0.18718E+02, 0.18735E+02,
     &  0.18839E+02, 0.18752E+02, 0.18874E+02, 0.18835E+02, 0.18823E+02,
     &  0.18807E+02, 0.18782E+02, 0.18732E+02, 0.18865E+02, 0.18875E+02,
     &  0.18888E+02, 0.18916E+02, 0.18965E+02, 0.19010E+02, 0.19104E+02,
     &  0.19137E+02, 0.19127E+02, 0.19245E+02, 0.19128E+02, 0.19312E+02,
     &  0.19343E+02, 0.19374E+02, 0.19561E+02, 0.19629E+02, 0.19591E+02,
     &  0.19555E+02, 0.19581E+02, 0.19689E+02, 0.19703E+02, 0.19870E+02,
     &  0.19837E+02, 0.19895E+02, 0.19903E+02, 0.19882E+02, 0.20089E+02,
     &  0.20182E+02, 0.20258E+02, 0.20423E+02, 0.20396E+02, 0.20387E+02,
     &  0.20525E+02, 0.20766E+02, 0.20919E+02, 0.21106E+02, 0.21252E+02,
     &  0.21271E+02, 0.21320E+02, 0.21370E+02, 0.21418E+02, 0.21482E+02,
     &  0.21572E+02, 0.21552E+02, 0.21452E+02, 0.21457E+02, 0.21458E+02,
     &  0.21575E+02, 0.21669E+02, 0.21474E+02, 0.21435E+02, 0.21285E+02,
     &  0.21279E+02, 0.21333E+02, 0.21119E+02, 0.21127E+02, 0.21048E+02,
     &  0.21027E+02, 0.20930E+02, 0.20718E+02, 0.20546E+02, 0.20490E+02,
     &  0.20456E+02, 0.20328E+02, 0.20056E+02, 0.20037E+02, 0.19976E+02,
     &  0.19925E+02, 0.19995E+02, 0.19914E+02, 0.19844E+02, 0.19918E+02,
     &  0.19895E+02, 0.19901E+02, 0.19797E+02, 0.19674E+02, 0.19586E+02,
     &  0.19601E+02, 0.19598E+02, 0.19533E+02, 0.19342E+02, 0.19172E+02,
     &  0.18958E+02, 0.18790E+02, 0.18751E+02, 0.18699E+02, 0.18755E+02,
     &  0.18749E+02, 0.18917E+02, 0.19017E+02, 0.19333E+02, 0.19351E+02,
     &  0.19633E+02, 0.19832E+02, 0.19913E+02, 0.20084E+02, 0.20171E+02,
     &  0.20342E+02, 0.20437E+02, 0.20743E+02, 0.20806E+02, 0.20684E+02,
     &  0.20797E+02, 0.20914E+02, 0.21052E+02, 0.21237E+02, 0.21443E+02,
     &  0.21491E+02, 0.21541E+02, 0.21686E+02, 0.21823E+02, 0.21935E+02,
     &  0.22080E+02, 0.22246E+02, 0.22417E+02, 0.22425E+02, 0.22649E+02,
     &  0.22867E+02, 0.23150E+02, 0.23102E+02, 0.23279E+02, 0.23412E+02,
     &  0.23586E+02, 0.23630E+02, 0.23639E+02, 0.23744E+02, 0.23776E+02,
     &  0.23899E+02, 0.23998E+02, 0.24083E+02, 0.23931E+02, 0.24009E+02,
     &  0.24040E+02, 0.23999E+02, 0.24185E+02, 0.24206E+02, 0.24487E+02,
     &  0.24708E+02, 0.24741E+02, 0.24554E+02, 0.24553E+02, 0.24576E+02,
     &  0.24562E+02, 0.24523E+02, 0.24654E+02, 0.24751E+02, 0.24709E+02,
     &  0.24688E+02, 0.24720E+02, 0.24652E+02, 0.24978E+02, 0.25008E+02,
     &  0.25269E+02, 0.25308E+02, 0.25306E+02, 0.25354E+02, 0.25335E+02,
     &  0.25256E+02, 0.25420E+02, 0.25357E+02, 0.25395E+02, 0.25369E+02,
     &  0.25432E+02, 0.25608E+02, 0.25903E+02, 0.26007E+02, 0.26114E+02,
     &  0.26371E+02, 0.26699E+02, 0.26819E+02, 0.27076E+02, 0.27351E+02,
     &  0.27402E+02, 0.27694E+02, 0.27909E+02, 0.28159E+02, 0.28301E+02,
     &  0.28623E+02, 0.28986E+02, 0.29272E+02, 0.29482E+02, 0.29751E+02,
     &  0.30286E+02, 0.30851E+02, 0.30948E+02, 0.31215E+02, 0.31611E+02,
     &  0.31920E+02, 0.32494E+02, 0.32965E+02, 0.33521E+02, 0.33793E+02,
     &  0.34182E+02, 0.34749E+02, 0.35300E+02, 0.35837E+02, 0.36451E+02,
     &  0.37055E+02, 0.38084E+02, 0.38561E+02, 0.39563E+02, 0.40266E+02,
     &  0.41032E+02, 0.41935E+02, 0.42616E+02, 0.43511E+02, 0.44171E+02,
     &  0.45031E+02, 0.45720E+02, 0.46565E+02, 0.47477E+02, 0.48202E+02,
     &  0.49067E+02, 0.49825E+02, 0.50513E+02, 0.51055E+02, 0.51536E+02,
     &  0.52134E+02, 0.52778E+02, 0.53443E+02, 0.53889E+02, 0.54431E+02,
     &  0.54643E+02, 0.54926E+02, 0.55217E+02, 0.55349E+02, 0.55485E+02,
     &  0.55754E+02, 0.55779E+02, 0.55776E+02, 0.55663E+02, 0.55581E+02,
     &  0.55465E+02, 0.55244E+02, 0.54924E+02, 0.54670E+02, 0.54391E+02,
     &  0.54294E+02, 0.54142E+02, 0.53945E+02, 0.53550E+02, 0.53305E+02,
     &  0.53014E+02, 0.52668E+02, 0.52368E+02, 0.52053E+02, 0.51711E+02,
     &  0.51530E+02, 0.51319E+02, 0.50955E+02, 0.50847E+02, 0.50413E+02,
     &  0.50039E+02, 0.49892E+02, 0.49916E+02, 0.49590E+02, 0.49312E+02,
     &  0.49120E+02, 0.48735E+02, 0.48547E+02, 0.48034E+02, 0.47773E+02,
     &  0.47501E+02, 0.47400E+02, 0.47099E+02, 0.46997E+02, 0.47272E+02,
     &  0.47087E+02, 0.47163E+02, 0.47109E+02, 0.47072E+02, 0.47009E+02,
     &  0.47020E+02, 0.47117E+02, 0.47213E+02, 0.47278E+02, 0.47306E+02,
     &  0.47369E+02, 0.47281E+02, 0.47100E+02, 0.47068E+02, 0.46873E+02,
     &  0.46974E+02, 0.47070E+02, 0.47288E+02, 0.47471E+02, 0.47587E+02,
     &  0.47917E+02, 0.47311E+02, 0.46766E+02, 0.46342E+02, 0.45940E+02,
     &  0.45486E+02, 0.45092E+02, 0.44847E+02, 0.44545E+02, 0.44381E+02,
     &  0.44111E+02, 0.43905E+02, 0.43400E+02, 0.43096E+02, 0.42828E+02,
     &  0.42506E+02, 0.42225E+02, 0.42006E+02, 0.41902E+02, 0.41589E+02,
     &  0.41416E+02, 0.41317E+02, 0.41216E+02, 0.41022E+02, 0.40738E+02,
     &  0.40503E+02, 0.40336E+02, 0.40278E+02, 0.40181E+02, 0.39945E+02,
     &  0.39857E+02, 0.39536E+02, 0.39421E+02, 0.39387E+02, 0.39383E+02,
     &  0.39311E+02, 0.39263E+02, 0.39112E+02, 0.39033E+02, 0.39040E+02,
     &  0.38857E+02, 0.38891E+02, 0.38831E+02, 0.38736E+02, 0.38835E+02,
     &  0.38832E+02, 0.38838E+02, 0.39017E+02, 0.39066E+02, 0.39041E+02,
     &  0.39227E+02, 0.38738E+02, 0.38403E+02, 0.37941E+02, 0.37603E+02,
     &  0.37369E+02, 0.37163E+02, 0.36825E+02, 0.36587E+02, 0.36304E+02,
     &  0.36241E+02, 0.35968E+02, 0.35901E+02, 0.35573E+02, 0.35312E+02,
     &  0.35052E+02, 0.34780E+02, 0.34693E+02, 0.34454E+02, 0.34232E+02,
     &  0.34063E+02, 0.33972E+02, 0.33766E+02, 0.33554E+02, 0.33457E+02,
     &  0.33360E+02, 0.33188E+02, 0.33014E+02, 0.32756E+02, 0.32437E+02,
     &  0.32245E+02, 0.32192E+02, 0.32210E+02, 0.32031E+02, 0.31709E+02,
     &  0.31718E+02, 0.31585E+02, 0.31391E+02, 0.31146E+02, 0.30910E+02,
     &  0.30712E+02, 0.30502E+02, 0.30175E+02, 0.30000E+02, 0.29631E+02,
     &  0.29283E+02, 0.29330E+02, 0.29232E+02, 0.28982E+02, 0.28772E+02,
     &  0.28574E+02, 0.28249E+02, 0.27740E+02, 0.27278E+02, 0.26912E+02,
     &  0.26647E+02, 0.26357E+02, 0.26133E+02, 0.25899E+02, 0.25627E+02,
     &  0.25263E+02, 0.25034E+02, 0.24845E+02, 0.24538E+02, 0.24411E+02,
     &  0.24277E+02, 0.24128E+02, 0.23974E+02, 0.23672E+02, 0.23440E+02,
     &  0.23369E+02, 0.23178E+02, 0.23060E+02, 0.22751E+02, 0.22528E+02,
     &  0.22226E+02, 0.22077E+02, 0.21857E+02, 0.21571E+02, 0.21439E+02,
     &  0.21220E+02, 0.21129E+02, 0.20975E+02, 0.20772E+02, 0.20518E+02,
     &  0.20180E+02, 0.19962E+02, 0.19731E+02, 0.19429E+02, 0.19153E+02,
     &  0.18998E+02, 0.18782E+02, 0.18608E+02, 0.18330E+02, 0.18076E+02,
     &  0.17686E+02, 0.17498E+02, 0.17222E+02, 0.17060E+02, 0.16734E+02,
     &  0.16471E+02, 0.16124E+02, 0.15737E+02, 0.15389E+02, 0.15022E+02,
     &  0.14810E+02, 0.14556E+02, 0.14164E+02, 0.14002E+02, 0.13595E+02,
     &  0.13222E+02, 0.12857E+02, 0.12530E+02, 0.12245E+02, 0.11866E+02,
     &  0.11618E+02, 0.11381E+02, 0.11150E+02, 0.10818E+02, 0.10511E+02,
     &  0.10310E+02, 0.99960E+01, 0.98457E+01, 0.95927E+01, 0.93150E+01,
     &  0.90964E+01, 0.89113E+01, 0.86012E+01, 0.83262E+01, 0.80768E+01,
     &  0.78892E+01, 0.76956E+01, 0.73982E+01, 0.70601E+01, 0.68775E+01,
     &  0.66306E+01, 0.62796E+01, 0.61200E+01, 0.59528E+01, 0.57584E+01,
     &  0.55823E+01, 0.53927E+01, 0.51642E+01, 0.49735E+01, 0.48226E+01,
     &  0.46440E+01, 0.44203E+01, 0.42333E+01, 0.40181E+01, 0.37521E+01,
     &  0.34813E+01, 0.33702E+01, 0.31850E+01, 0.30873E+01, 0.28731E+01,
     &  0.27319E+01, 0.26835E+01, 0.26157E+01, 0.25393E+01, 0.24641E+01,
     &  0.23444E+01, 0.22365E+01, 0.21944E+01, 0.21888E+01, 0.21135E+01,
     &  0.20489E+01, 0.20131E+01, 0.20068E+01, 0.19801E+01, 0.19889E+01,
     &  0.20041E+01, 0.20279E+01, 0.20523E+01, 0.20789E+01, 0.20738E+01,
     &  0.21146E+01, 0.21734E+01, 0.22335E+01, 0.22248E+01, 0.22625E+01,
     &  0.23341E+01, 0.23769E+01, 0.24416E+01, 0.25284E+01, 0.25931E+01,
     &  0.26740E+01, 0.27282E+01, 0.28637E+01, 0.29471E+01, 0.30247E+01,
     &  0.31055E+01, 0.31669E+01, 0.33331E+01, 0.34824E+01, 0.35973E+01,
     &  0.37606E+01,
     &  0.38500E+01,
     &  0.39368E+01,
     &  0.40674E+01,
     &  0.42506E+01,
     &  0.43448E+01/
      Data (sigma(i),i=       1,     701)/
     &  0.27178E-01, 0.27488E-01, 0.27477E-01, 0.27429E-01, 0.27689E-01,
     &  0.27742E-01, 0.27834E-01, 0.27999E-01, 0.28092E-01, 0.28310E-01,
     &  0.28418E-01, 0.28395E-01, 0.28396E-01, 0.28550E-01, 0.28667E-01,
     &  0.28954E-01, 0.29046E-01, 0.29152E-01, 0.29210E-01, 0.29208E-01,
     &  0.29149E-01, 0.29232E-01, 0.29178E-01, 0.29155E-01, 0.29292E-01,
     &  0.29373E-01, 0.29449E-01, 0.29506E-01, 0.29494E-01, 0.29443E-01,
     &  0.29523E-01, 0.29600E-01, 0.29582E-01, 0.29716E-01, 0.29709E-01,
     &  0.29829E-01, 0.29819E-01, 0.29852E-01, 0.29959E-01, 0.29912E-01,
     &  0.29957E-01, 0.30097E-01, 0.30142E-01, 0.30054E-01, 0.30207E-01,
     &  0.30299E-01, 0.30158E-01, 0.30357E-01, 0.30396E-01, 0.30346E-01,
     &  0.30294E-01, 0.30202E-01, 0.30014E-01, 0.30118E-01, 0.30133E-01,
     &  0.30129E-01, 0.30006E-01, 0.29863E-01, 0.29790E-01, 0.29622E-01,
     &  0.29610E-01, 0.29539E-01, 0.29459E-01, 0.29446E-01, 0.29596E-01,
     &  0.29583E-01, 0.29646E-01, 0.29584E-01, 0.29383E-01, 0.29252E-01,
     &  0.29145E-01, 0.29100E-01, 0.29131E-01, 0.29069E-01, 0.29059E-01,
     &  0.28979E-01, 0.28901E-01, 0.28797E-01, 0.28846E-01, 0.28818E-01,
     &  0.28706E-01, 0.28544E-01, 0.28356E-01, 0.28342E-01, 0.28208E-01,
     &  0.28063E-01, 0.28000E-01, 0.27854E-01, 0.27856E-01, 0.27661E-01,
     &  0.27567E-01, 0.27586E-01, 0.27480E-01, 0.27425E-01, 0.27366E-01,
     &  0.27248E-01, 0.27160E-01, 0.27092E-01, 0.26971E-01, 0.26885E-01,
     &  0.26908E-01, 0.26806E-01, 0.26763E-01, 0.26878E-01, 0.26808E-01,
     &  0.26693E-01, 0.26696E-01, 0.26699E-01, 0.26638E-01, 0.26643E-01,
     &  0.26692E-01, 0.26651E-01, 0.26570E-01, 0.26549E-01, 0.26483E-01,
     &  0.26588E-01, 0.26573E-01, 0.26574E-01, 0.26586E-01, 0.26488E-01,
     &  0.26430E-01, 0.26488E-01, 0.26373E-01, 0.26445E-01, 0.26492E-01,
     &  0.26543E-01, 0.26562E-01, 0.26606E-01, 0.26458E-01, 0.26390E-01,
     &  0.26388E-01, 0.26368E-01, 0.26317E-01, 0.26340E-01, 0.26223E-01,
     &  0.26151E-01, 0.25999E-01, 0.25867E-01, 0.25793E-01, 0.25722E-01,
     &  0.25674E-01, 0.25658E-01, 0.25575E-01, 0.25579E-01, 0.25504E-01,
     &  0.25357E-01, 0.25339E-01, 0.25304E-01, 0.25356E-01, 0.25210E-01,
     &  0.25103E-01, 0.25209E-01, 0.25199E-01, 0.25155E-01, 0.25150E-01,
     &  0.25089E-01, 0.25158E-01, 0.25075E-01, 0.25107E-01, 0.25101E-01,
     &  0.25112E-01, 0.25115E-01, 0.25147E-01, 0.25056E-01, 0.25055E-01,
     &  0.25037E-01, 0.25022E-01, 0.24995E-01, 0.24970E-01, 0.24909E-01,
     &  0.24884E-01, 0.24883E-01, 0.24813E-01, 0.24879E-01, 0.24765E-01,
     &  0.24757E-01, 0.24748E-01, 0.24635E-01, 0.24593E-01, 0.24608E-01,
     &  0.24630E-01, 0.24613E-01, 0.24548E-01, 0.24532E-01, 0.24433E-01,
     &  0.24448E-01, 0.24404E-01, 0.24392E-01, 0.24405E-01, 0.24288E-01,
     &  0.24231E-01, 0.24182E-01, 0.24093E-01, 0.24114E-01, 0.24120E-01,
     &  0.24040E-01, 0.23907E-01, 0.23814E-01, 0.23722E-01, 0.23649E-01,
     &  0.23624E-01, 0.23600E-01, 0.23577E-01, 0.23549E-01, 0.23522E-01,
     &  0.23483E-01, 0.23502E-01, 0.23564E-01, 0.23548E-01, 0.23547E-01,
     &  0.23496E-01, 0.23457E-01, 0.23547E-01, 0.23569E-01, 0.23667E-01,
     &  0.23670E-01, 0.23648E-01, 0.23774E-01, 0.23790E-01, 0.23835E-01,
     &  0.23844E-01, 0.23892E-01, 0.24021E-01, 0.24129E-01, 0.24174E-01,
     &  0.24201E-01, 0.24286E-01, 0.24447E-01, 0.24464E-01, 0.24507E-01,
     &  0.24534E-01, 0.24504E-01, 0.24573E-01, 0.24622E-01, 0.24587E-01,
     &  0.24601E-01, 0.24602E-01, 0.24667E-01, 0.24735E-01, 0.24790E-01,
     &  0.24791E-01, 0.24802E-01, 0.24838E-01, 0.24938E-01, 0.25042E-01,
     &  0.25194E-01, 0.25299E-01, 0.25343E-01, 0.25386E-01, 0.25363E-01,
     &  0.25376E-01, 0.25275E-01, 0.25205E-01, 0.25013E-01, 0.24995E-01,
     &  0.24823E-01, 0.24692E-01, 0.24642E-01, 0.24541E-01, 0.24489E-01,
     &  0.24392E-01, 0.24334E-01, 0.24173E-01, 0.24134E-01, 0.24202E-01,
     &  0.24127E-01, 0.24070E-01, 0.23988E-01, 0.23890E-01, 0.23765E-01,
     &  0.23730E-01, 0.23701E-01, 0.23620E-01, 0.23548E-01, 0.23497E-01,
     &  0.23424E-01, 0.23334E-01, 0.23252E-01, 0.23246E-01, 0.23135E-01,
     &  0.23015E-01, 0.22877E-01, 0.22906E-01, 0.22814E-01, 0.22756E-01,
     &  0.22672E-01, 0.22655E-01, 0.22661E-01, 0.22604E-01, 0.22583E-01,
     &  0.22526E-01, 0.22476E-01, 0.22437E-01, 0.22508E-01, 0.22477E-01,
     &  0.22469E-01, 0.22493E-01, 0.22413E-01, 0.22411E-01, 0.22280E-01,
     &  0.22193E-01, 0.22177E-01, 0.22261E-01, 0.22266E-01, 0.22258E-01,
     &  0.22256E-01, 0.22269E-01, 0.22218E-01, 0.22181E-01, 0.22194E-01,
     &  0.22202E-01, 0.22183E-01, 0.22211E-01, 0.22062E-01, 0.22052E-01,
     &  0.21936E-01, 0.21919E-01, 0.21922E-01, 0.21895E-01, 0.21905E-01,
     &  0.21934E-01, 0.21866E-01, 0.21889E-01, 0.21862E-01, 0.21873E-01,
     &  0.21847E-01, 0.21774E-01, 0.21649E-01, 0.21605E-01, 0.21556E-01,
     &  0.21449E-01, 0.21313E-01, 0.21269E-01, 0.21160E-01, 0.21051E-01,
     &  0.21033E-01, 0.20927E-01, 0.20852E-01, 0.20760E-01, 0.20703E-01,
     &  0.20590E-01, 0.20465E-01, 0.20355E-01, 0.20278E-01, 0.20184E-01,
     &  0.20008E-01, 0.19828E-01, 0.19799E-01, 0.19713E-01, 0.19591E-01,
     &  0.19496E-01, 0.19324E-01, 0.19182E-01, 0.19017E-01, 0.18938E-01,
     &  0.18826E-01, 0.18669E-01, 0.18519E-01, 0.18373E-01, 0.18209E-01,
     &  0.18061E-01, 0.17810E-01, 0.17698E-01, 0.17474E-01, 0.17312E-01,
     &  0.17144E-01, 0.16958E-01, 0.16819E-01, 0.16639E-01, 0.16511E-01,
     &  0.16345E-01, 0.16220E-01, 0.16064E-01, 0.15906E-01, 0.15779E-01,
     &  0.15635E-01, 0.15512E-01, 0.15396E-01, 0.15308E-01, 0.15230E-01,
     &  0.15133E-01, 0.15037E-01, 0.14938E-01, 0.14867E-01, 0.14785E-01,
     &  0.14750E-01, 0.14708E-01, 0.14666E-01, 0.14643E-01, 0.14623E-01,
     &  0.14584E-01, 0.14576E-01, 0.14571E-01, 0.14584E-01, 0.14593E-01,
     &  0.14606E-01, 0.14630E-01, 0.14670E-01, 0.14702E-01, 0.14738E-01,
     &  0.14752E-01, 0.14778E-01, 0.14803E-01, 0.14855E-01, 0.14888E-01,
     &  0.14926E-01, 0.14974E-01, 0.15015E-01, 0.15059E-01, 0.15105E-01,
     &  0.15129E-01, 0.15158E-01, 0.15211E-01, 0.15227E-01, 0.15288E-01,
     &  0.15343E-01, 0.15361E-01, 0.15356E-01, 0.15401E-01, 0.15441E-01,
     &  0.15467E-01, 0.15518E-01, 0.15541E-01, 0.15611E-01, 0.15647E-01,
     &  0.15678E-01, 0.15688E-01, 0.15726E-01, 0.15731E-01, 0.15674E-01,
     &  0.15691E-01, 0.15673E-01, 0.15672E-01, 0.15659E-01, 0.15655E-01,
     &  0.15639E-01, 0.15608E-01, 0.15576E-01, 0.15546E-01, 0.15528E-01,
     &  0.15505E-01, 0.15502E-01, 0.15507E-01, 0.15499E-01, 0.15504E-01,
     &  0.15461E-01, 0.15426E-01, 0.15374E-01, 0.15322E-01, 0.15283E-01,
     &  0.15208E-01, 0.15277E-01, 0.15340E-01, 0.15387E-01, 0.15429E-01,
     &  0.15480E-01, 0.15520E-01, 0.15535E-01, 0.15554E-01, 0.15555E-01,
     &  0.15572E-01, 0.15577E-01, 0.15633E-01, 0.15653E-01, 0.15672E-01,
     &  0.15696E-01, 0.15720E-01, 0.15730E-01, 0.15730E-01, 0.15762E-01,
     &  0.15769E-01, 0.15751E-01, 0.15741E-01, 0.15746E-01, 0.15766E-01,
     &  0.15783E-01, 0.15783E-01, 0.15772E-01, 0.15776E-01, 0.15790E-01,
     &  0.15790E-01, 0.15827E-01, 0.15828E-01, 0.15805E-01, 0.15783E-01,
     &  0.15773E-01, 0.15760E-01, 0.15774E-01, 0.15757E-01, 0.15731E-01,
     &  0.15741E-01, 0.15716E-01, 0.15711E-01, 0.15703E-01, 0.15680E-01,
     &  0.15659E-01, 0.15656E-01, 0.15612E-01, 0.15591E-01, 0.15587E-01,
     &  0.15552E-01, 0.15634E-01, 0.15686E-01, 0.15753E-01, 0.15801E-01,
     &  0.15835E-01, 0.15866E-01, 0.15920E-01, 0.15958E-01, 0.15998E-01,
     &  0.16015E-01, 0.16069E-01, 0.16088E-01, 0.16136E-01, 0.16183E-01,
     &  0.16237E-01, 0.16302E-01, 0.16320E-01, 0.16362E-01, 0.16406E-01,
     &  0.16450E-01, 0.16479E-01, 0.16532E-01, 0.16581E-01, 0.16616E-01,
     &  0.16658E-01, 0.16706E-01, 0.16763E-01, 0.16830E-01, 0.16898E-01,
     &  0.16947E-01, 0.16981E-01, 0.16990E-01, 0.17045E-01, 0.17139E-01,
     &  0.17165E-01, 0.17216E-01, 0.17298E-01, 0.17392E-01, 0.17472E-01,
     &  0.17563E-01, 0.17653E-01, 0.17775E-01, 0.17861E-01, 0.17978E-01,
     &  0.18113E-01, 0.18146E-01, 0.18208E-01, 0.18307E-01, 0.18410E-01,
     &  0.18486E-01, 0.18605E-01, 0.18784E-01, 0.18961E-01, 0.19118E-01,
     &  0.19235E-01, 0.19360E-01, 0.19459E-01, 0.19572E-01, 0.19678E-01,
     &  0.19826E-01, 0.19944E-01, 0.20034E-01, 0.20185E-01, 0.20265E-01,
     &  0.20345E-01, 0.20431E-01, 0.20532E-01, 0.20665E-01, 0.20776E-01,
     &  0.20848E-01, 0.20940E-01, 0.21020E-01, 0.21174E-01, 0.21279E-01,
     &  0.21425E-01, 0.21509E-01, 0.21654E-01, 0.21813E-01, 0.21901E-01,
     &  0.22035E-01, 0.22114E-01, 0.22218E-01, 0.22336E-01, 0.22482E-01,
     &  0.22692E-01, 0.22834E-01, 0.22963E-01, 0.23157E-01, 0.23340E-01,
     &  0.23464E-01, 0.23624E-01, 0.23760E-01, 0.23959E-01, 0.24154E-01,
     &  0.24409E-01, 0.24575E-01, 0.24809E-01, 0.24955E-01, 0.25206E-01,
     &  0.25431E-01, 0.25702E-01, 0.26038E-01, 0.26342E-01, 0.26687E-01,
     &  0.26913E-01, 0.27169E-01, 0.27522E-01, 0.27731E-01, 0.28150E-01,
     &  0.28531E-01, 0.28942E-01, 0.29338E-01, 0.29700E-01, 0.30146E-01,
     &  0.30474E-01, 0.30808E-01, 0.31140E-01, 0.31671E-01, 0.32148E-01,
     &  0.32477E-01, 0.33015E-01, 0.33281E-01, 0.33747E-01, 0.34257E-01,
     &  0.34676E-01, 0.35044E-01, 0.35721E-01, 0.36342E-01, 0.36923E-01,
     &  0.37411E-01, 0.37929E-01, 0.38696E-01, 0.39659E-01, 0.40219E-01,
     &  0.40941E-01, 0.42014E-01, 0.42667E-01, 0.43292E-01, 0.44002E-01,
     &  0.44721E-01, 0.45572E-01, 0.46603E-01, 0.47564E-01, 0.48366E-01,
     &  0.49355E-01, 0.50650E-01, 0.51795E-01, 0.53218E-01, 0.54972E-01,
     &  0.57000E-01, 0.57950E-01, 0.59478E-01, 0.60462E-01, 0.62805E-01,
     &  0.64528E-01, 0.65327E-01, 0.66279E-01, 0.67385E-01, 0.68446E-01,
     &  0.70168E-01, 0.71961E-01, 0.72874E-01, 0.73146E-01, 0.74628E-01,
     &  0.76046E-01, 0.76797E-01, 0.77013E-01, 0.77469E-01, 0.77400E-01,
     &  0.77260E-01, 0.76808E-01, 0.76440E-01, 0.76001E-01, 0.76062E-01,
     &  0.75259E-01, 0.74151E-01, 0.73153E-01, 0.73212E-01, 0.72702E-01,
     &  0.71639E-01, 0.71111E-01, 0.70110E-01, 0.68846E-01, 0.67937E-01,
     &  0.66923E-01, 0.66240E-01, 0.64797E-01, 0.63870E-01, 0.62975E-01,
     &  0.62165E-01, 0.61536E-01, 0.60045E-01, 0.58703E-01, 0.57785E-01,
     &  0.56576E-01,
     &  0.55929E-01,
     &  0.55327E-01,
     &  0.54374E-01,
     &  0.53143E-01,
     &  0.52580E-01/
c
      massi = hmass(1)
      massx = hmass(npoint)
      dmass = (massx-massi)/Real(npoint-1)
c      
      imass = int( (mh-massi)/dmass ) + 1
c
      if (imass.eq.npoint) then
        imass = npoint
        jmass = npoint
        rmass = 0.0
      Endif
cjm Modifie le 24Fevrier
      If (imass.le.0 .or. imass.gt.npoint) then
        A196_HGG_BACKG = 0.
        RETURN
      Endif
      If (imass.ge.1..and.imass.lt.npoint) then
        jmass = imass + 1
        rmass = mh - hmass(imass)
      endif
c
      If (.not.err) A196_HGG_BACKG = bdf(imass)+(bdf(jmass)
     &     -bdf(imass))*rmass/dmass
      If (err) A196_HGG_BACKG = sigma(imass)+(sigma(jmass)
     &     -sigma(imass))*rmass/dmass
c
      RETURN
      END
      REAL FUNCTION A200_HGG_BACKG(mh,myich,err)
      Implicit none
      Real mh
      Integer myich
c
      Logical first,err
      Data first/.TRUE./
      Integer npoint
      Parameter (npoint=701)
      Real sigma(npoint),bdf(npoint),hmass(npoint)
      Real massi,massx,dmass,rmass
      Integer i,imass,jmass
      Data (hmass(i),i=       1,     701)/
     &  0.40000E+02, 0.40100E+02, 0.40200E+02, 0.40300E+02, 0.40400E+02,
     &  0.40500E+02, 0.40600E+02, 0.40700E+02, 0.40800E+02, 0.40900E+02,
     &  0.41000E+02, 0.41100E+02, 0.41200E+02, 0.41300E+02, 0.41400E+02,
     &  0.41500E+02, 0.41600E+02, 0.41700E+02, 0.41800E+02, 0.41900E+02,
     &  0.42000E+02, 0.42100E+02, 0.42200E+02, 0.42300E+02, 0.42400E+02,
     &  0.42500E+02, 0.42600E+02, 0.42700E+02, 0.42800E+02, 0.42900E+02,
     &  0.43000E+02, 0.43100E+02, 0.43200E+02, 0.43300E+02, 0.43400E+02,
     &  0.43500E+02, 0.43600E+02, 0.43700E+02, 0.43800E+02, 0.43900E+02,
     &  0.44000E+02, 0.44100E+02, 0.44200E+02, 0.44300E+02, 0.44400E+02,
     &  0.44500E+02, 0.44600E+02, 0.44700E+02, 0.44800E+02, 0.44900E+02,
     &  0.45000E+02, 0.45100E+02, 0.45200E+02, 0.45300E+02, 0.45400E+02,
     &  0.45500E+02, 0.45600E+02, 0.45700E+02, 0.45800E+02, 0.45900E+02,
     &  0.46000E+02, 0.46100E+02, 0.46200E+02, 0.46300E+02, 0.46400E+02,
     &  0.46500E+02, 0.46600E+02, 0.46700E+02, 0.46800E+02, 0.46900E+02,
     &  0.47000E+02, 0.47100E+02, 0.47200E+02, 0.47300E+02, 0.47400E+02,
     &  0.47500E+02, 0.47600E+02, 0.47700E+02, 0.47800E+02, 0.47900E+02,
     &  0.48000E+02, 0.48100E+02, 0.48200E+02, 0.48300E+02, 0.48400E+02,
     &  0.48500E+02, 0.48600E+02, 0.48700E+02, 0.48800E+02, 0.48900E+02,
     &  0.49000E+02, 0.49100E+02, 0.49200E+02, 0.49300E+02, 0.49400E+02,
     &  0.49500E+02, 0.49600E+02, 0.49700E+02, 0.49800E+02, 0.49900E+02,
     &  0.50000E+02, 0.50100E+02, 0.50200E+02, 0.50300E+02, 0.50400E+02,
     &  0.50500E+02, 0.50600E+02, 0.50700E+02, 0.50800E+02, 0.50900E+02,
     &  0.51000E+02, 0.51100E+02, 0.51200E+02, 0.51300E+02, 0.51400E+02,
     &  0.51500E+02, 0.51600E+02, 0.51700E+02, 0.51800E+02, 0.51900E+02,
     &  0.52000E+02, 0.52100E+02, 0.52200E+02, 0.52300E+02, 0.52400E+02,
     &  0.52500E+02, 0.52600E+02, 0.52700E+02, 0.52800E+02, 0.52900E+02,
     &  0.53000E+02, 0.53100E+02, 0.53200E+02, 0.53300E+02, 0.53400E+02,
     &  0.53500E+02, 0.53600E+02, 0.53700E+02, 0.53800E+02, 0.53900E+02,
     &  0.54000E+02, 0.54100E+02, 0.54200E+02, 0.54300E+02, 0.54400E+02,
     &  0.54500E+02, 0.54600E+02, 0.54700E+02, 0.54800E+02, 0.54900E+02,
     &  0.55000E+02, 0.55100E+02, 0.55200E+02, 0.55300E+02, 0.55400E+02,
     &  0.55500E+02, 0.55600E+02, 0.55700E+02, 0.55800E+02, 0.55900E+02,
     &  0.56000E+02, 0.56100E+02, 0.56200E+02, 0.56300E+02, 0.56400E+02,
     &  0.56500E+02, 0.56600E+02, 0.56700E+02, 0.56800E+02, 0.56900E+02,
     &  0.57000E+02, 0.57100E+02, 0.57200E+02, 0.57300E+02, 0.57400E+02,
     &  0.57500E+02, 0.57600E+02, 0.57700E+02, 0.57800E+02, 0.57900E+02,
     &  0.58000E+02, 0.58100E+02, 0.58200E+02, 0.58300E+02, 0.58400E+02,
     &  0.58500E+02, 0.58600E+02, 0.58700E+02, 0.58800E+02, 0.58900E+02,
     &  0.59000E+02, 0.59100E+02, 0.59200E+02, 0.59300E+02, 0.59400E+02,
     &  0.59500E+02, 0.59600E+02, 0.59700E+02, 0.59800E+02, 0.59900E+02,
     &  0.60000E+02, 0.60100E+02, 0.60200E+02, 0.60300E+02, 0.60400E+02,
     &  0.60500E+02, 0.60600E+02, 0.60700E+02, 0.60800E+02, 0.60900E+02,
     &  0.61000E+02, 0.61100E+02, 0.61200E+02, 0.61300E+02, 0.61400E+02,
     &  0.61500E+02, 0.61600E+02, 0.61700E+02, 0.61800E+02, 0.61900E+02,
     &  0.62000E+02, 0.62100E+02, 0.62200E+02, 0.62300E+02, 0.62400E+02,
     &  0.62500E+02, 0.62600E+02, 0.62700E+02, 0.62800E+02, 0.62900E+02,
     &  0.63000E+02, 0.63100E+02, 0.63200E+02, 0.63300E+02, 0.63400E+02,
     &  0.63500E+02, 0.63600E+02, 0.63700E+02, 0.63800E+02, 0.63900E+02,
     &  0.64000E+02, 0.64100E+02, 0.64200E+02, 0.64300E+02, 0.64400E+02,
     &  0.64500E+02, 0.64600E+02, 0.64700E+02, 0.64800E+02, 0.64900E+02,
     &  0.65000E+02, 0.65100E+02, 0.65200E+02, 0.65300E+02, 0.65400E+02,
     &  0.65500E+02, 0.65600E+02, 0.65700E+02, 0.65800E+02, 0.65900E+02,
     &  0.66000E+02, 0.66100E+02, 0.66200E+02, 0.66300E+02, 0.66400E+02,
     &  0.66500E+02, 0.66600E+02, 0.66700E+02, 0.66800E+02, 0.66900E+02,
     &  0.67000E+02, 0.67100E+02, 0.67200E+02, 0.67300E+02, 0.67400E+02,
     &  0.67500E+02, 0.67600E+02, 0.67700E+02, 0.67800E+02, 0.67900E+02,
     &  0.68000E+02, 0.68100E+02, 0.68200E+02, 0.68300E+02, 0.68400E+02,
     &  0.68500E+02, 0.68600E+02, 0.68700E+02, 0.68800E+02, 0.68900E+02,
     &  0.69000E+02, 0.69100E+02, 0.69200E+02, 0.69300E+02, 0.69400E+02,
     &  0.69500E+02, 0.69600E+02, 0.69700E+02, 0.69800E+02, 0.69900E+02,
     &  0.70000E+02, 0.70100E+02, 0.70200E+02, 0.70300E+02, 0.70400E+02,
     &  0.70500E+02, 0.70600E+02, 0.70700E+02, 0.70800E+02, 0.70900E+02,
     &  0.71000E+02, 0.71100E+02, 0.71200E+02, 0.71300E+02, 0.71400E+02,
     &  0.71500E+02, 0.71600E+02, 0.71700E+02, 0.71800E+02, 0.71900E+02,
     &  0.72000E+02, 0.72100E+02, 0.72200E+02, 0.72300E+02, 0.72400E+02,
     &  0.72500E+02, 0.72600E+02, 0.72700E+02, 0.72800E+02, 0.72900E+02,
     &  0.73000E+02, 0.73100E+02, 0.73200E+02, 0.73300E+02, 0.73400E+02,
     &  0.73500E+02, 0.73600E+02, 0.73700E+02, 0.73800E+02, 0.73900E+02,
     &  0.74000E+02, 0.74100E+02, 0.74200E+02, 0.74300E+02, 0.74400E+02,
     &  0.74500E+02, 0.74600E+02, 0.74700E+02, 0.74800E+02, 0.74900E+02,
     &  0.75000E+02, 0.75100E+02, 0.75200E+02, 0.75300E+02, 0.75400E+02,
     &  0.75500E+02, 0.75600E+02, 0.75700E+02, 0.75800E+02, 0.75900E+02,
     &  0.76000E+02, 0.76100E+02, 0.76200E+02, 0.76300E+02, 0.76400E+02,
     &  0.76500E+02, 0.76600E+02, 0.76700E+02, 0.76800E+02, 0.76900E+02,
     &  0.77000E+02, 0.77100E+02, 0.77200E+02, 0.77300E+02, 0.77400E+02,
     &  0.77500E+02, 0.77600E+02, 0.77700E+02, 0.77800E+02, 0.77900E+02,
     &  0.78000E+02, 0.78100E+02, 0.78200E+02, 0.78300E+02, 0.78400E+02,
     &  0.78500E+02, 0.78600E+02, 0.78700E+02, 0.78800E+02, 0.78900E+02,
     &  0.79000E+02, 0.79100E+02, 0.79200E+02, 0.79300E+02, 0.79400E+02,
     &  0.79500E+02, 0.79600E+02, 0.79700E+02, 0.79800E+02, 0.79900E+02,
     &  0.80000E+02, 0.80100E+02, 0.80200E+02, 0.80300E+02, 0.80400E+02,
     &  0.80500E+02, 0.80600E+02, 0.80700E+02, 0.80800E+02, 0.80900E+02,
     &  0.81000E+02, 0.81100E+02, 0.81200E+02, 0.81300E+02, 0.81400E+02,
     &  0.81500E+02, 0.81600E+02, 0.81700E+02, 0.81800E+02, 0.81900E+02,
     &  0.82000E+02, 0.82100E+02, 0.82200E+02, 0.82300E+02, 0.82400E+02,
     &  0.82500E+02, 0.82600E+02, 0.82700E+02, 0.82800E+02, 0.82900E+02,
     &  0.83000E+02, 0.83100E+02, 0.83200E+02, 0.83300E+02, 0.83400E+02,
     &  0.83500E+02, 0.83600E+02, 0.83700E+02, 0.83800E+02, 0.83900E+02,
     &  0.84000E+02, 0.84100E+02, 0.84200E+02, 0.84300E+02, 0.84400E+02,
     &  0.84500E+02, 0.84600E+02, 0.84700E+02, 0.84800E+02, 0.84900E+02,
     &  0.85000E+02, 0.85100E+02, 0.85200E+02, 0.85300E+02, 0.85400E+02,
     &  0.85500E+02, 0.85600E+02, 0.85700E+02, 0.85800E+02, 0.85900E+02,
     &  0.86000E+02, 0.86100E+02, 0.86200E+02, 0.86300E+02, 0.86400E+02,
     &  0.86500E+02, 0.86600E+02, 0.86700E+02, 0.86800E+02, 0.86900E+02,
     &  0.87000E+02, 0.87100E+02, 0.87200E+02, 0.87300E+02, 0.87400E+02,
     &  0.87500E+02, 0.87600E+02, 0.87700E+02, 0.87800E+02, 0.87900E+02,
     &  0.88000E+02, 0.88100E+02, 0.88200E+02, 0.88300E+02, 0.88400E+02,
     &  0.88500E+02, 0.88600E+02, 0.88700E+02, 0.88800E+02, 0.88900E+02,
     &  0.89000E+02, 0.89100E+02, 0.89200E+02, 0.89300E+02, 0.89400E+02,
     &  0.89500E+02, 0.89600E+02, 0.89700E+02, 0.89800E+02, 0.89900E+02,
     &  0.90000E+02, 0.90100E+02, 0.90200E+02, 0.90300E+02, 0.90400E+02,
     &  0.90500E+02, 0.90600E+02, 0.90700E+02, 0.90800E+02, 0.90900E+02,
     &  0.91000E+02, 0.91100E+02, 0.91200E+02, 0.91300E+02, 0.91400E+02,
     &  0.91500E+02, 0.91600E+02, 0.91700E+02, 0.91800E+02, 0.91900E+02,
     &  0.92000E+02, 0.92100E+02, 0.92200E+02, 0.92300E+02, 0.92400E+02,
     &  0.92500E+02, 0.92600E+02, 0.92700E+02, 0.92800E+02, 0.92900E+02,
     &  0.93000E+02, 0.93100E+02, 0.93200E+02, 0.93300E+02, 0.93400E+02,
     &  0.93500E+02, 0.93600E+02, 0.93700E+02, 0.93800E+02, 0.93900E+02,
     &  0.94000E+02, 0.94100E+02, 0.94200E+02, 0.94300E+02, 0.94400E+02,
     &  0.94500E+02, 0.94600E+02, 0.94700E+02, 0.94800E+02, 0.94900E+02,
     &  0.95000E+02, 0.95100E+02, 0.95200E+02, 0.95300E+02, 0.95400E+02,
     &  0.95500E+02, 0.95600E+02, 0.95700E+02, 0.95800E+02, 0.95900E+02,
     &  0.96000E+02, 0.96100E+02, 0.96200E+02, 0.96300E+02, 0.96400E+02,
     &  0.96500E+02, 0.96600E+02, 0.96700E+02, 0.96800E+02, 0.96900E+02,
     &  0.97000E+02, 0.97100E+02, 0.97200E+02, 0.97300E+02, 0.97400E+02,
     &  0.97500E+02, 0.97600E+02, 0.97700E+02, 0.97800E+02, 0.97900E+02,
     &  0.98000E+02, 0.98100E+02, 0.98200E+02, 0.98300E+02, 0.98400E+02,
     &  0.98500E+02, 0.98600E+02, 0.98700E+02, 0.98800E+02, 0.98900E+02,
     &  0.99000E+02, 0.99100E+02, 0.99200E+02, 0.99300E+02, 0.99400E+02,
     &  0.99500E+02, 0.99600E+02, 0.99700E+02, 0.99800E+02, 0.99900E+02,
     &  0.10000E+03, 0.10010E+03, 0.10020E+03, 0.10030E+03, 0.10040E+03,
     &  0.10050E+03, 0.10060E+03, 0.10070E+03, 0.10080E+03, 0.10090E+03,
     &  0.10100E+03, 0.10110E+03, 0.10120E+03, 0.10130E+03, 0.10140E+03,
     &  0.10150E+03, 0.10160E+03, 0.10170E+03, 0.10180E+03, 0.10190E+03,
     &  0.10200E+03, 0.10210E+03, 0.10220E+03, 0.10230E+03, 0.10240E+03,
     &  0.10250E+03, 0.10260E+03, 0.10270E+03, 0.10280E+03, 0.10290E+03,
     &  0.10300E+03, 0.10310E+03, 0.10320E+03, 0.10330E+03, 0.10340E+03,
     &  0.10350E+03, 0.10360E+03, 0.10370E+03, 0.10380E+03, 0.10390E+03,
     &  0.10400E+03, 0.10410E+03, 0.10420E+03, 0.10430E+03, 0.10440E+03,
     &  0.10450E+03, 0.10460E+03, 0.10470E+03, 0.10480E+03, 0.10490E+03,
     &  0.10500E+03, 0.10510E+03, 0.10520E+03, 0.10530E+03, 0.10540E+03,
     &  0.10550E+03, 0.10560E+03, 0.10570E+03, 0.10580E+03, 0.10590E+03,
     &  0.10600E+03, 0.10610E+03, 0.10620E+03, 0.10630E+03, 0.10640E+03,
     &  0.10650E+03, 0.10660E+03, 0.10670E+03, 0.10680E+03, 0.10690E+03,
     &  0.10700E+03, 0.10710E+03, 0.10720E+03, 0.10730E+03, 0.10740E+03,
     &  0.10750E+03, 0.10760E+03, 0.10770E+03, 0.10780E+03, 0.10790E+03,
     &  0.10800E+03, 0.10810E+03, 0.10820E+03, 0.10830E+03, 0.10840E+03,
     &  0.10850E+03, 0.10860E+03, 0.10870E+03, 0.10880E+03, 0.10890E+03,
     &  0.10900E+03, 0.10910E+03, 0.10920E+03, 0.10930E+03, 0.10940E+03,
     &  0.10950E+03,
     &  0.10960E+03,
     &  0.10970E+03,
     &  0.10980E+03,
     &  0.10990E+03,
     &  0.11000E+03/
      Data (bdf(i),i=       1,     701)/
     &  0.14655E+02, 0.14362E+02, 0.14438E+02, 0.14371E+02, 0.14300E+02,
     &  0.14240E+02, 0.14214E+02, 0.14090E+02, 0.13902E+02, 0.13670E+02,
     &  0.13673E+02, 0.13577E+02, 0.13528E+02, 0.13493E+02, 0.13340E+02,
     &  0.13301E+02, 0.13183E+02, 0.13141E+02, 0.13020E+02, 0.13036E+02,
     &  0.13002E+02, 0.12996E+02, 0.13039E+02, 0.13041E+02, 0.13006E+02,
     &  0.12875E+02, 0.12709E+02, 0.12531E+02, 0.12488E+02, 0.12488E+02,
     &  0.12357E+02, 0.12445E+02, 0.12381E+02, 0.12302E+02, 0.12307E+02,
     &  0.12248E+02, 0.12292E+02, 0.12315E+02, 0.12247E+02, 0.12227E+02,
     &  0.12188E+02, 0.12339E+02, 0.12231E+02, 0.12197E+02, 0.12106E+02,
     &  0.12029E+02, 0.12012E+02, 0.12041E+02, 0.12030E+02, 0.12104E+02,
     &  0.12128E+02, 0.12260E+02, 0.12342E+02, 0.12414E+02, 0.12603E+02,
     &  0.12823E+02, 0.12873E+02, 0.13044E+02, 0.13012E+02, 0.13203E+02,
     &  0.13443E+02, 0.13423E+02, 0.13480E+02, 0.13549E+02, 0.13612E+02,
     &  0.13757E+02, 0.13762E+02, 0.13928E+02, 0.13821E+02, 0.13846E+02,
     &  0.13954E+02, 0.13886E+02, 0.14004E+02, 0.14048E+02, 0.14166E+02,
     &  0.14087E+02, 0.14019E+02, 0.14058E+02, 0.14086E+02, 0.14154E+02,
     &  0.14316E+02, 0.14475E+02, 0.14359E+02, 0.14510E+02, 0.14575E+02,
     &  0.14687E+02, 0.14862E+02, 0.14910E+02, 0.14973E+02, 0.15096E+02,
     &  0.15090E+02, 0.15274E+02, 0.15284E+02, 0.15470E+02, 0.15576E+02,
     &  0.15767E+02, 0.15918E+02, 0.15996E+02, 0.16077E+02, 0.16106E+02,
     &  0.16427E+02, 0.16671E+02, 0.16670E+02, 0.16654E+02, 0.16644E+02,
     &  0.16784E+02, 0.16832E+02, 0.16895E+02, 0.16861E+02, 0.17001E+02,
     &  0.17040E+02, 0.16932E+02, 0.17024E+02, 0.17181E+02, 0.17218E+02,
     &  0.17554E+02, 0.17735E+02, 0.17777E+02, 0.17723E+02, 0.17806E+02,
     &  0.17863E+02, 0.17862E+02, 0.18008E+02, 0.18071E+02, 0.18182E+02,
     &  0.18412E+02, 0.18594E+02, 0.18586E+02, 0.18528E+02, 0.18610E+02,
     &  0.18585E+02, 0.18615E+02, 0.18688E+02, 0.18595E+02, 0.18585E+02,
     &  0.18527E+02, 0.18657E+02, 0.18594E+02, 0.18550E+02, 0.18676E+02,
     &  0.18792E+02, 0.18748E+02, 0.18787E+02, 0.18865E+02, 0.19069E+02,
     &  0.19093E+02, 0.19157E+02, 0.19132E+02, 0.19191E+02, 0.19153E+02,
     &  0.19076E+02, 0.19135E+02, 0.19198E+02, 0.19218E+02, 0.19110E+02,
     &  0.19022E+02, 0.18922E+02, 0.18877E+02, 0.18912E+02, 0.18771E+02,
     &  0.18648E+02, 0.18714E+02, 0.18686E+02, 0.18698E+02, 0.18820E+02,
     &  0.19011E+02, 0.19049E+02, 0.19067E+02, 0.19047E+02, 0.18901E+02,
     &  0.18941E+02, 0.18852E+02, 0.18851E+02, 0.18851E+02, 0.19003E+02,
     &  0.19066E+02, 0.19141E+02, 0.19194E+02, 0.19298E+02, 0.19371E+02,
     &  0.19348E+02, 0.19402E+02, 0.19544E+02, 0.19541E+02, 0.19621E+02,
     &  0.19659E+02, 0.20040E+02, 0.20269E+02, 0.20414E+02, 0.20525E+02,
     &  0.20670E+02, 0.20792E+02, 0.20750E+02, 0.20818E+02, 0.20774E+02,
     &  0.20836E+02, 0.20944E+02, 0.21135E+02, 0.21335E+02, 0.21561E+02,
     &  0.21712E+02, 0.21864E+02, 0.21888E+02, 0.21967E+02, 0.22156E+02,
     &  0.22166E+02, 0.22291E+02, 0.22398E+02, 0.22267E+02, 0.22175E+02,
     &  0.22095E+02, 0.22106E+02, 0.21957E+02, 0.21835E+02, 0.21997E+02,
     &  0.21936E+02, 0.21825E+02, 0.21814E+02, 0.21844E+02, 0.21742E+02,
     &  0.21469E+02, 0.21615E+02, 0.21513E+02, 0.21385E+02, 0.21457E+02,
     &  0.21475E+02, 0.21464E+02, 0.21277E+02, 0.21294E+02, 0.21294E+02,
     &  0.21295E+02, 0.21079E+02, 0.20941E+02, 0.20827E+02, 0.20701E+02,
     &  0.20559E+02, 0.20498E+02, 0.20554E+02, 0.20418E+02, 0.20447E+02,
     &  0.20373E+02, 0.20396E+02, 0.20364E+02, 0.20048E+02, 0.20048E+02,
     &  0.19970E+02, 0.19824E+02, 0.19694E+02, 0.19577E+02, 0.19579E+02,
     &  0.19429E+02, 0.19590E+02, 0.19839E+02, 0.19859E+02, 0.20155E+02,
     &  0.20230E+02, 0.20337E+02, 0.20332E+02, 0.20515E+02, 0.20666E+02,
     &  0.20841E+02, 0.21023E+02, 0.21285E+02, 0.21420E+02, 0.21727E+02,
     &  0.21744E+02, 0.21784E+02, 0.22118E+02, 0.21976E+02, 0.22175E+02,
     &  0.22218E+02, 0.22354E+02, 0.22394E+02, 0.22564E+02, 0.22759E+02,
     &  0.22771E+02, 0.22955E+02, 0.23172E+02, 0.23217E+02, 0.23269E+02,
     &  0.23254E+02, 0.23166E+02, 0.23283E+02, 0.23395E+02, 0.23769E+02,
     &  0.23716E+02, 0.23764E+02, 0.23748E+02, 0.23782E+02, 0.23777E+02,
     &  0.23967E+02, 0.24017E+02, 0.24225E+02, 0.24346E+02, 0.24423E+02,
     &  0.24486E+02, 0.24554E+02, 0.24568E+02, 0.24779E+02, 0.24956E+02,
     &  0.24836E+02, 0.24947E+02, 0.25134E+02, 0.25166E+02, 0.25243E+02,
     &  0.25185E+02, 0.25165E+02, 0.25100E+02, 0.25026E+02, 0.25040E+02,
     &  0.25157E+02, 0.25260E+02, 0.25314E+02, 0.25247E+02, 0.25262E+02,
     &  0.25276E+02, 0.25330E+02, 0.25213E+02, 0.25166E+02, 0.25205E+02,
     &  0.25246E+02, 0.25262E+02, 0.25418E+02, 0.25538E+02, 0.25632E+02,
     &  0.25675E+02, 0.25822E+02, 0.25880E+02, 0.25975E+02, 0.26137E+02,
     &  0.26244E+02, 0.26267E+02, 0.26413E+02, 0.26237E+02, 0.26257E+02,
     &  0.26395E+02, 0.26571E+02, 0.26782E+02, 0.26914E+02, 0.27225E+02,
     &  0.27455E+02, 0.27522E+02, 0.27906E+02, 0.28217E+02, 0.28577E+02,
     &  0.28980E+02, 0.29441E+02, 0.29602E+02, 0.30098E+02, 0.30226E+02,
     &  0.30723E+02, 0.31114E+02, 0.31707E+02, 0.32101E+02, 0.32925E+02,
     &  0.33655E+02, 0.34470E+02, 0.35282E+02, 0.35858E+02, 0.36646E+02,
     &  0.37464E+02, 0.38262E+02, 0.38718E+02, 0.39341E+02, 0.39840E+02,
     &  0.40598E+02, 0.41568E+02, 0.42281E+02, 0.43128E+02, 0.43837E+02,
     &  0.44635E+02, 0.45644E+02, 0.46274E+02, 0.47072E+02, 0.47946E+02,
     &  0.48947E+02, 0.49756E+02, 0.50667E+02, 0.51453E+02, 0.52237E+02,
     &  0.52873E+02, 0.53725E+02, 0.54293E+02, 0.54865E+02, 0.55451E+02,
     &  0.55889E+02, 0.56240E+02, 0.56724E+02, 0.56867E+02, 0.57006E+02,
     &  0.57253E+02, 0.57442E+02, 0.57507E+02, 0.57582E+02, 0.57561E+02,
     &  0.57560E+02, 0.57573E+02, 0.57676E+02, 0.57600E+02, 0.57322E+02,
     &  0.57249E+02, 0.56722E+02, 0.56648E+02, 0.56521E+02, 0.56241E+02,
     &  0.56022E+02, 0.55689E+02, 0.55389E+02, 0.55054E+02, 0.54845E+02,
     &  0.54529E+02, 0.54250E+02, 0.53992E+02, 0.53804E+02, 0.53375E+02,
     &  0.52749E+02, 0.52354E+02, 0.52140E+02, 0.51659E+02, 0.51580E+02,
     &  0.51280E+02, 0.51049E+02, 0.50792E+02, 0.50259E+02, 0.50024E+02,
     &  0.49919E+02, 0.49615E+02, 0.49065E+02, 0.48747E+02, 0.48672E+02,
     &  0.48519E+02, 0.48505E+02, 0.48347E+02, 0.48266E+02, 0.48005E+02,
     &  0.47903E+02, 0.47741E+02, 0.47637E+02, 0.47538E+02, 0.47258E+02,
     &  0.47093E+02, 0.46872E+02, 0.46507E+02, 0.46321E+02, 0.46136E+02,
     &  0.45902E+02, 0.45503E+02, 0.45380E+02, 0.45266E+02, 0.45252E+02,
     &  0.45246E+02, 0.45285E+02, 0.45118E+02, 0.44989E+02, 0.44957E+02,
     &  0.44769E+02, 0.44573E+02, 0.44323E+02, 0.44239E+02, 0.44095E+02,
     &  0.43846E+02, 0.43709E+02, 0.43585E+02, 0.43612E+02, 0.43361E+02,
     &  0.43218E+02, 0.43088E+02, 0.43212E+02, 0.43177E+02, 0.43150E+02,
     &  0.43131E+02, 0.43101E+02, 0.43078E+02, 0.42821E+02, 0.42859E+02,
     &  0.42981E+02, 0.42954E+02, 0.42958E+02, 0.42913E+02, 0.42887E+02,
     &  0.42834E+02, 0.42873E+02, 0.42687E+02, 0.42684E+02, 0.42658E+02,
     &  0.42523E+02, 0.42716E+02, 0.42731E+02, 0.42977E+02, 0.42977E+02,
     &  0.42955E+02, 0.43058E+02, 0.43066E+02, 0.43099E+02, 0.43244E+02,
     &  0.43300E+02, 0.43565E+02, 0.43739E+02, 0.44025E+02, 0.43921E+02,
     &  0.44285E+02, 0.43929E+02, 0.43806E+02, 0.43323E+02, 0.43100E+02,
     &  0.42709E+02, 0.42225E+02, 0.42011E+02, 0.41685E+02, 0.41416E+02,
     &  0.41025E+02, 0.40824E+02, 0.40815E+02, 0.40492E+02, 0.40236E+02,
     &  0.39935E+02, 0.39660E+02, 0.39541E+02, 0.39182E+02, 0.38918E+02,
     &  0.38573E+02, 0.38378E+02, 0.38045E+02, 0.37839E+02, 0.37745E+02,
     &  0.37696E+02, 0.37420E+02, 0.37358E+02, 0.37093E+02, 0.36849E+02,
     &  0.36798E+02, 0.36815E+02, 0.36790E+02, 0.36787E+02, 0.36813E+02,
     &  0.36410E+02, 0.36433E+02, 0.36385E+02, 0.36411E+02, 0.36463E+02,
     &  0.36442E+02, 0.36300E+02, 0.36413E+02, 0.36264E+02, 0.36088E+02,
     &  0.36076E+02, 0.35898E+02, 0.35818E+02, 0.35612E+02, 0.35598E+02,
     &  0.35457E+02, 0.35181E+02, 0.34844E+02, 0.34564E+02, 0.34267E+02,
     &  0.33856E+02, 0.33578E+02, 0.33350E+02, 0.33217E+02, 0.32908E+02,
     &  0.32728E+02, 0.32518E+02, 0.32265E+02, 0.32001E+02, 0.31793E+02,
     &  0.31717E+02, 0.31566E+02, 0.31352E+02, 0.31208E+02, 0.31031E+02,
     &  0.30788E+02, 0.30768E+02, 0.30526E+02, 0.30349E+02, 0.30236E+02,
     &  0.30119E+02, 0.29849E+02, 0.29804E+02, 0.29541E+02, 0.29484E+02,
     &  0.29286E+02, 0.29044E+02, 0.28987E+02, 0.28957E+02, 0.28748E+02,
     &  0.28473E+02, 0.28363E+02, 0.28351E+02, 0.28293E+02, 0.28201E+02,
     &  0.28063E+02, 0.27984E+02, 0.27961E+02, 0.28023E+02, 0.27794E+02,
     &  0.27625E+02, 0.27544E+02, 0.27458E+02, 0.27273E+02, 0.27188E+02,
     &  0.26902E+02, 0.26604E+02, 0.26422E+02, 0.26302E+02, 0.26115E+02,
     &  0.25808E+02, 0.25716E+02, 0.25358E+02, 0.25105E+02, 0.24849E+02,
     &  0.24727E+02, 0.24462E+02, 0.24236E+02, 0.24076E+02, 0.23785E+02,
     &  0.23788E+02, 0.23586E+02, 0.23452E+02, 0.23322E+02, 0.23146E+02,
     &  0.22787E+02, 0.22470E+02, 0.22313E+02, 0.22278E+02, 0.22258E+02,
     &  0.22153E+02, 0.22073E+02, 0.21994E+02, 0.21870E+02, 0.21564E+02,
     &  0.21312E+02, 0.20998E+02, 0.20814E+02, 0.20645E+02, 0.20433E+02,
     &  0.20364E+02, 0.20332E+02, 0.20363E+02, 0.20196E+02, 0.20185E+02,
     &  0.20072E+02, 0.19953E+02, 0.19867E+02, 0.19758E+02, 0.19646E+02,
     &  0.19512E+02, 0.19311E+02, 0.19020E+02, 0.19024E+02, 0.18960E+02,
     &  0.18838E+02, 0.18783E+02, 0.18722E+02, 0.18632E+02, 0.18560E+02,
     &  0.18461E+02, 0.18517E+02, 0.18595E+02, 0.18582E+02, 0.18466E+02,
     &  0.18474E+02, 0.18494E+02, 0.18477E+02, 0.18427E+02, 0.18412E+02,
     &  0.18460E+02, 0.18530E+02, 0.18535E+02, 0.18508E+02, 0.18560E+02,
     &  0.18745E+02, 0.18864E+02, 0.18861E+02, 0.18984E+02, 0.19112E+02,
     &  0.19229E+02, 0.19252E+02, 0.19308E+02, 0.19561E+02, 0.19870E+02,
     &  0.20113E+02, 0.20197E+02, 0.20347E+02, 0.20528E+02, 0.20850E+02,
     &  0.21159E+02, 0.21478E+02, 0.21888E+02, 0.22249E+02, 0.22581E+02,
     &  0.23062E+02, 0.23538E+02, 0.24210E+02, 0.24899E+02, 0.25347E+02,
     &  0.25973E+02,
     &  0.26593E+02,
     &  0.27258E+02,
     &  0.27894E+02,
     &  0.28409E+02,
     &  0.29102E+02/
      Data (sigma(i),i=       1,     701)/
     &  0.29472E-01, 0.29755E-01, 0.29696E-01, 0.29799E-01, 0.29858E-01,
     &  0.29935E-01, 0.29996E-01, 0.30134E-01, 0.30341E-01, 0.30595E-01,
     &  0.30612E-01, 0.30699E-01, 0.30756E-01, 0.30807E-01, 0.30998E-01,
     &  0.31051E-01, 0.31205E-01, 0.31286E-01, 0.31405E-01, 0.31367E-01,
     &  0.31425E-01, 0.31448E-01, 0.31415E-01, 0.31463E-01, 0.31513E-01,
     &  0.31686E-01, 0.31882E-01, 0.32060E-01, 0.32104E-01, 0.32124E-01,
     &  0.32283E-01, 0.32173E-01, 0.32256E-01, 0.32351E-01, 0.32369E-01,
     &  0.32442E-01, 0.32381E-01, 0.32353E-01, 0.32457E-01, 0.32485E-01,
     &  0.32560E-01, 0.32364E-01, 0.32528E-01, 0.32612E-01, 0.32742E-01,
     &  0.32846E-01, 0.32859E-01, 0.32823E-01, 0.32870E-01, 0.32766E-01,
     &  0.32746E-01, 0.32580E-01, 0.32468E-01, 0.32378E-01, 0.32173E-01,
     &  0.31889E-01, 0.31817E-01, 0.31608E-01, 0.31667E-01, 0.31444E-01,
     &  0.31159E-01, 0.31192E-01, 0.31144E-01, 0.31048E-01, 0.30996E-01,
     &  0.30839E-01, 0.30827E-01, 0.30653E-01, 0.30755E-01, 0.30730E-01,
     &  0.30608E-01, 0.30680E-01, 0.30544E-01, 0.30482E-01, 0.30338E-01,
     &  0.30425E-01, 0.30494E-01, 0.30460E-01, 0.30424E-01, 0.30343E-01,
     &  0.30178E-01, 0.30020E-01, 0.30125E-01, 0.29980E-01, 0.29903E-01,
     &  0.29789E-01, 0.29613E-01, 0.29565E-01, 0.29509E-01, 0.29360E-01,
     &  0.29389E-01, 0.29208E-01, 0.29172E-01, 0.29008E-01, 0.28928E-01,
     &  0.28764E-01, 0.28618E-01, 0.28543E-01, 0.28451E-01, 0.28415E-01,
     &  0.28158E-01, 0.27957E-01, 0.27972E-01, 0.27983E-01, 0.27993E-01,
     &  0.27875E-01, 0.27836E-01, 0.27780E-01, 0.27814E-01, 0.27712E-01,
     &  0.27687E-01, 0.27778E-01, 0.27718E-01, 0.27598E-01, 0.27581E-01,
     &  0.27321E-01, 0.27186E-01, 0.27161E-01, 0.27207E-01, 0.27154E-01,
     &  0.27125E-01, 0.27130E-01, 0.27030E-01, 0.26986E-01, 0.26921E-01,
     &  0.26749E-01, 0.26651E-01, 0.26647E-01, 0.26698E-01, 0.26638E-01,
     &  0.26656E-01, 0.26635E-01, 0.26576E-01, 0.26637E-01, 0.26648E-01,
     &  0.26700E-01, 0.26608E-01, 0.26635E-01, 0.26661E-01, 0.26568E-01,
     &  0.26492E-01, 0.26528E-01, 0.26502E-01, 0.26457E-01, 0.26336E-01,
     &  0.26320E-01, 0.26268E-01, 0.26276E-01, 0.26232E-01, 0.26245E-01,
     &  0.26294E-01, 0.26255E-01, 0.26215E-01, 0.26197E-01, 0.26270E-01,
     &  0.26327E-01, 0.26390E-01, 0.26433E-01, 0.26406E-01, 0.26499E-01,
     &  0.26596E-01, 0.26534E-01, 0.26543E-01, 0.26517E-01, 0.26441E-01,
     &  0.26295E-01, 0.26273E-01, 0.26268E-01, 0.26275E-01, 0.26366E-01,
     &  0.26321E-01, 0.26377E-01, 0.26375E-01, 0.26374E-01, 0.26264E-01,
     &  0.26232E-01, 0.26171E-01, 0.26131E-01, 0.26060E-01, 0.26004E-01,
     &  0.26006E-01, 0.25971E-01, 0.25869E-01, 0.25858E-01, 0.25800E-01,
     &  0.25781E-01, 0.25549E-01, 0.25402E-01, 0.25308E-01, 0.25236E-01,
     &  0.25150E-01, 0.25077E-01, 0.25099E-01, 0.25061E-01, 0.25085E-01,
     &  0.25025E-01, 0.24960E-01, 0.24837E-01, 0.24721E-01, 0.24586E-01,
     &  0.24495E-01, 0.24416E-01, 0.24396E-01, 0.24360E-01, 0.24266E-01,
     &  0.24265E-01, 0.24216E-01, 0.24163E-01, 0.24220E-01, 0.24276E-01,
     &  0.24328E-01, 0.24318E-01, 0.24397E-01, 0.24467E-01, 0.24405E-01,
     &  0.24458E-01, 0.24521E-01, 0.24532E-01, 0.24517E-01, 0.24580E-01,
     &  0.24733E-01, 0.24656E-01, 0.24722E-01, 0.24809E-01, 0.24777E-01,
     &  0.24760E-01, 0.24772E-01, 0.24883E-01, 0.24889E-01, 0.24903E-01,
     &  0.24891E-01, 0.25032E-01, 0.25121E-01, 0.25202E-01, 0.25278E-01,
     &  0.25375E-01, 0.25430E-01, 0.25401E-01, 0.25482E-01, 0.25476E-01,
     &  0.25533E-01, 0.25528E-01, 0.25569E-01, 0.25755E-01, 0.25766E-01,
     &  0.25815E-01, 0.25915E-01, 0.25990E-01, 0.26062E-01, 0.26048E-01,
     &  0.26132E-01, 0.26026E-01, 0.25865E-01, 0.25844E-01, 0.25671E-01,
     &  0.25648E-01, 0.25596E-01, 0.25592E-01, 0.25476E-01, 0.25394E-01,
     &  0.25281E-01, 0.25165E-01, 0.25016E-01, 0.24946E-01, 0.24764E-01,
     &  0.24758E-01, 0.24735E-01, 0.24563E-01, 0.24644E-01, 0.24538E-01,
     &  0.24504E-01, 0.24440E-01, 0.24419E-01, 0.24325E-01, 0.24231E-01,
     &  0.24233E-01, 0.24129E-01, 0.24025E-01, 0.24006E-01, 0.23989E-01,
     &  0.23999E-01, 0.24049E-01, 0.23976E-01, 0.23903E-01, 0.23710E-01,
     &  0.23724E-01, 0.23715E-01, 0.23719E-01, 0.23705E-01, 0.23705E-01,
     &  0.23618E-01, 0.23587E-01, 0.23488E-01, 0.23426E-01, 0.23394E-01,
     &  0.23363E-01, 0.23334E-01, 0.23324E-01, 0.23221E-01, 0.23152E-01,
     &  0.23202E-01, 0.23151E-01, 0.23057E-01, 0.23048E-01, 0.23012E-01,
     &  0.23042E-01, 0.23050E-01, 0.23087E-01, 0.23131E-01, 0.23131E-01,
     &  0.23084E-01, 0.23032E-01, 0.23006E-01, 0.23035E-01, 0.23021E-01,
     &  0.23010E-01, 0.22983E-01, 0.23032E-01, 0.23058E-01, 0.23039E-01,
     &  0.23016E-01, 0.22993E-01, 0.22923E-01, 0.22866E-01, 0.22826E-01,
     &  0.22803E-01, 0.22735E-01, 0.22714E-01, 0.22674E-01, 0.22601E-01,
     &  0.22559E-01, 0.22546E-01, 0.22488E-01, 0.22562E-01, 0.22553E-01,
     &  0.22488E-01, 0.22405E-01, 0.22308E-01, 0.22253E-01, 0.22126E-01,
     &  0.22035E-01, 0.22008E-01, 0.21853E-01, 0.21737E-01, 0.21603E-01,
     &  0.21455E-01, 0.21298E-01, 0.21240E-01, 0.21067E-01, 0.21016E-01,
     &  0.20841E-01, 0.20707E-01, 0.20508E-01, 0.20380E-01, 0.20115E-01,
     &  0.19899E-01, 0.19654E-01, 0.19428E-01, 0.19265E-01, 0.19057E-01,
     &  0.18845E-01, 0.18646E-01, 0.18530E-01, 0.18382E-01, 0.18255E-01,
     &  0.18085E-01, 0.17868E-01, 0.17714E-01, 0.17534E-01, 0.17386E-01,
     &  0.17229E-01, 0.17034E-01, 0.16907E-01, 0.16756E-01, 0.16597E-01,
     &  0.16420E-01, 0.16281E-01, 0.16128E-01, 0.16002E-01, 0.15878E-01,
     &  0.15780E-01, 0.15652E-01, 0.15569E-01, 0.15479E-01, 0.15388E-01,
     &  0.15326E-01, 0.15275E-01, 0.15205E-01, 0.15183E-01, 0.15163E-01,
     &  0.15130E-01, 0.15106E-01, 0.15091E-01, 0.15077E-01, 0.15077E-01,
     &  0.15077E-01, 0.15072E-01, 0.15057E-01, 0.15065E-01, 0.15101E-01,
     &  0.15107E-01, 0.15178E-01, 0.15186E-01, 0.15200E-01, 0.15237E-01,
     &  0.15267E-01, 0.15310E-01, 0.15349E-01, 0.15391E-01, 0.15418E-01,
     &  0.15463E-01, 0.15505E-01, 0.15543E-01, 0.15570E-01, 0.15632E-01,
     &  0.15720E-01, 0.15777E-01, 0.15803E-01, 0.15872E-01, 0.15881E-01,
     &  0.15922E-01, 0.15956E-01, 0.15994E-01, 0.16080E-01, 0.16112E-01,
     &  0.16121E-01, 0.16157E-01, 0.16246E-01, 0.16290E-01, 0.16298E-01,
     &  0.16310E-01, 0.16305E-01, 0.16325E-01, 0.16328E-01, 0.16361E-01,
     &  0.16358E-01, 0.16366E-01, 0.16375E-01, 0.16376E-01, 0.16412E-01,
     &  0.16416E-01, 0.16445E-01, 0.16484E-01, 0.16497E-01, 0.16505E-01,
     &  0.16520E-01, 0.16562E-01, 0.16559E-01, 0.16557E-01, 0.16543E-01,
     &  0.16519E-01, 0.16492E-01, 0.16500E-01, 0.16504E-01, 0.16489E-01,
     &  0.16492E-01, 0.16499E-01, 0.16522E-01, 0.16514E-01, 0.16514E-01,
     &  0.16534E-01, 0.16534E-01, 0.16544E-01, 0.16512E-01, 0.16537E-01,
     &  0.16533E-01, 0.16533E-01, 0.16496E-01, 0.16469E-01, 0.16453E-01,
     &  0.16430E-01, 0.16414E-01, 0.16397E-01, 0.16418E-01, 0.16387E-01,
     &  0.16344E-01, 0.16325E-01, 0.16295E-01, 0.16275E-01, 0.16257E-01,
     &  0.16250E-01, 0.16229E-01, 0.16248E-01, 0.16222E-01, 0.16205E-01,
     &  0.16207E-01, 0.16161E-01, 0.16142E-01, 0.16086E-01, 0.16073E-01,
     &  0.16057E-01, 0.16026E-01, 0.16002E-01, 0.15973E-01, 0.15947E-01,
     &  0.15926E-01, 0.15872E-01, 0.15834E-01, 0.15788E-01, 0.15785E-01,
     &  0.15713E-01, 0.15764E-01, 0.15778E-01, 0.15843E-01, 0.15868E-01,
     &  0.15936E-01, 0.16013E-01, 0.16050E-01, 0.16091E-01, 0.16127E-01,
     &  0.16196E-01, 0.16230E-01, 0.16255E-01, 0.16309E-01, 0.16343E-01,
     &  0.16396E-01, 0.16446E-01, 0.16463E-01, 0.16519E-01, 0.16584E-01,
     &  0.16655E-01, 0.16688E-01, 0.16762E-01, 0.16805E-01, 0.16841E-01,
     &  0.16856E-01, 0.16923E-01, 0.16935E-01, 0.17002E-01, 0.17059E-01,
     &  0.17098E-01, 0.17104E-01, 0.17129E-01, 0.17140E-01, 0.17152E-01,
     &  0.17234E-01, 0.17261E-01, 0.17293E-01, 0.17301E-01, 0.17309E-01,
     &  0.17336E-01, 0.17386E-01, 0.17373E-01, 0.17437E-01, 0.17501E-01,
     &  0.17526E-01, 0.17597E-01, 0.17628E-01, 0.17693E-01, 0.17735E-01,
     &  0.17798E-01, 0.17871E-01, 0.17967E-01, 0.18050E-01, 0.18131E-01,
     &  0.18236E-01, 0.18313E-01, 0.18384E-01, 0.18445E-01, 0.18524E-01,
     &  0.18574E-01, 0.18643E-01, 0.18724E-01, 0.18816E-01, 0.18883E-01,
     &  0.18922E-01, 0.18977E-01, 0.19052E-01, 0.19115E-01, 0.19179E-01,
     &  0.19254E-01, 0.19276E-01, 0.19351E-01, 0.19423E-01, 0.19473E-01,
     &  0.19524E-01, 0.19621E-01, 0.19642E-01, 0.19723E-01, 0.19747E-01,
     &  0.19814E-01, 0.19888E-01, 0.19924E-01, 0.19958E-01, 0.20034E-01,
     &  0.20142E-01, 0.20198E-01, 0.20235E-01, 0.20270E-01, 0.20311E-01,
     &  0.20382E-01, 0.20438E-01, 0.20460E-01, 0.20453E-01, 0.20550E-01,
     &  0.20616E-01, 0.20662E-01, 0.20701E-01, 0.20767E-01, 0.20829E-01,
     &  0.20960E-01, 0.21087E-01, 0.21169E-01, 0.21242E-01, 0.21324E-01,
     &  0.21457E-01, 0.21516E-01, 0.21671E-01, 0.21776E-01, 0.21894E-01,
     &  0.21944E-01, 0.22065E-01, 0.22164E-01, 0.22243E-01, 0.22391E-01,
     &  0.22423E-01, 0.22536E-01, 0.22619E-01, 0.22693E-01, 0.22783E-01,
     &  0.22963E-01, 0.23123E-01, 0.23204E-01, 0.23233E-01, 0.23276E-01,
     &  0.23351E-01, 0.23409E-01, 0.23463E-01, 0.23539E-01, 0.23707E-01,
     &  0.23870E-01, 0.24051E-01, 0.24186E-01, 0.24304E-01, 0.24441E-01,
     &  0.24502E-01, 0.24528E-01, 0.24532E-01, 0.24634E-01, 0.24666E-01,
     &  0.24735E-01, 0.24809E-01, 0.24884E-01, 0.24980E-01, 0.25052E-01,
     &  0.25167E-01, 0.25315E-01, 0.25523E-01, 0.25546E-01, 0.25602E-01,
     &  0.25713E-01, 0.25724E-01, 0.25752E-01, 0.25809E-01, 0.25855E-01,
     &  0.25939E-01, 0.25892E-01, 0.25854E-01, 0.25849E-01, 0.25929E-01,
     &  0.25937E-01, 0.25928E-01, 0.25956E-01, 0.26001E-01, 0.26020E-01,
     &  0.26006E-01, 0.25981E-01, 0.25981E-01, 0.26015E-01, 0.25990E-01,
     &  0.25872E-01, 0.25800E-01, 0.25826E-01, 0.25790E-01, 0.25723E-01,
     &  0.25655E-01, 0.25641E-01, 0.25634E-01, 0.25467E-01, 0.25262E-01,
     &  0.25125E-01, 0.25060E-01, 0.24978E-01, 0.24855E-01, 0.24657E-01,
     &  0.24472E-01, 0.24278E-01, 0.24057E-01, 0.23864E-01, 0.23678E-01,
     &  0.23436E-01, 0.23190E-01, 0.22875E-01, 0.22567E-01, 0.22354E-01,
     &  0.22089E-01,
     &  0.21812E-01,
     &  0.21537E-01,
     &  0.21293E-01,
     &  0.21103E-01,
     &  0.20860E-01/
c
      massi = hmass(1)
      massx = hmass(npoint)
      dmass = (massx-massi)/Real(npoint-1)
c      
      imass = int( (mh-massi)/dmass ) + 1
c
      if (imass.eq.npoint) then
        imass = npoint
        jmass = npoint
        rmass = 0.0
      Endif
cjm Modifie le 24Fevrier
      If (imass.le.0 .or. imass.gt.npoint) then
        A200_HGG_BACKG = 0.
        RETURN
      Endif
      If (imass.ge.1..and.imass.lt.npoint) then
        jmass = imass + 1
        rmass = mh - hmass(imass)
      endif
c
      If (.not.err) A200_HGG_BACKG = bdf(imass)+(bdf(jmass)
     &     -bdf(imass))*rmass/dmass
      If (err) A200_HGG_BACKG = sigma(imass)+(sigma(jmass)
     &     -sigma(imass))*rmass/dmass
c
      RETURN
      END
      REAL FUNCTION A202_HGG_BACKG(mh,myich,err)
      Implicit none
      Real mh
      Integer myich
c
      Logical first,err
      Data first/.TRUE./
      Integer npoint
      Parameter (npoint=701)
      Real sigma(npoint),bdf(npoint),hmass(npoint)
      Real massi,massx,dmass,rmass
      Integer i,imass,jmass
      Data (hmass(i),i=       1,     701)/
     &  0.40000E+02, 0.40100E+02, 0.40200E+02, 0.40300E+02, 0.40400E+02,
     &  0.40500E+02, 0.40600E+02, 0.40700E+02, 0.40800E+02, 0.40900E+02,
     &  0.41000E+02, 0.41100E+02, 0.41200E+02, 0.41300E+02, 0.41400E+02,
     &  0.41500E+02, 0.41600E+02, 0.41700E+02, 0.41800E+02, 0.41900E+02,
     &  0.42000E+02, 0.42100E+02, 0.42200E+02, 0.42300E+02, 0.42400E+02,
     &  0.42500E+02, 0.42600E+02, 0.42700E+02, 0.42800E+02, 0.42900E+02,
     &  0.43000E+02, 0.43100E+02, 0.43200E+02, 0.43300E+02, 0.43400E+02,
     &  0.43500E+02, 0.43600E+02, 0.43700E+02, 0.43800E+02, 0.43900E+02,
     &  0.44000E+02, 0.44100E+02, 0.44200E+02, 0.44300E+02, 0.44400E+02,
     &  0.44500E+02, 0.44600E+02, 0.44700E+02, 0.44800E+02, 0.44900E+02,
     &  0.45000E+02, 0.45100E+02, 0.45200E+02, 0.45300E+02, 0.45400E+02,
     &  0.45500E+02, 0.45600E+02, 0.45700E+02, 0.45800E+02, 0.45900E+02,
     &  0.46000E+02, 0.46100E+02, 0.46200E+02, 0.46300E+02, 0.46400E+02,
     &  0.46500E+02, 0.46600E+02, 0.46700E+02, 0.46800E+02, 0.46900E+02,
     &  0.47000E+02, 0.47100E+02, 0.47200E+02, 0.47300E+02, 0.47400E+02,
     &  0.47500E+02, 0.47600E+02, 0.47700E+02, 0.47800E+02, 0.47900E+02,
     &  0.48000E+02, 0.48100E+02, 0.48200E+02, 0.48300E+02, 0.48400E+02,
     &  0.48500E+02, 0.48600E+02, 0.48700E+02, 0.48800E+02, 0.48900E+02,
     &  0.49000E+02, 0.49100E+02, 0.49200E+02, 0.49300E+02, 0.49400E+02,
     &  0.49500E+02, 0.49600E+02, 0.49700E+02, 0.49800E+02, 0.49900E+02,
     &  0.50000E+02, 0.50100E+02, 0.50200E+02, 0.50300E+02, 0.50400E+02,
     &  0.50500E+02, 0.50600E+02, 0.50700E+02, 0.50800E+02, 0.50900E+02,
     &  0.51000E+02, 0.51100E+02, 0.51200E+02, 0.51300E+02, 0.51400E+02,
     &  0.51500E+02, 0.51600E+02, 0.51700E+02, 0.51800E+02, 0.51900E+02,
     &  0.52000E+02, 0.52100E+02, 0.52200E+02, 0.52300E+02, 0.52400E+02,
     &  0.52500E+02, 0.52600E+02, 0.52700E+02, 0.52800E+02, 0.52900E+02,
     &  0.53000E+02, 0.53100E+02, 0.53200E+02, 0.53300E+02, 0.53400E+02,
     &  0.53500E+02, 0.53600E+02, 0.53700E+02, 0.53800E+02, 0.53900E+02,
     &  0.54000E+02, 0.54100E+02, 0.54200E+02, 0.54300E+02, 0.54400E+02,
     &  0.54500E+02, 0.54600E+02, 0.54700E+02, 0.54800E+02, 0.54900E+02,
     &  0.55000E+02, 0.55100E+02, 0.55200E+02, 0.55300E+02, 0.55400E+02,
     &  0.55500E+02, 0.55600E+02, 0.55700E+02, 0.55800E+02, 0.55900E+02,
     &  0.56000E+02, 0.56100E+02, 0.56200E+02, 0.56300E+02, 0.56400E+02,
     &  0.56500E+02, 0.56600E+02, 0.56700E+02, 0.56800E+02, 0.56900E+02,
     &  0.57000E+02, 0.57100E+02, 0.57200E+02, 0.57300E+02, 0.57400E+02,
     &  0.57500E+02, 0.57600E+02, 0.57700E+02, 0.57800E+02, 0.57900E+02,
     &  0.58000E+02, 0.58100E+02, 0.58200E+02, 0.58300E+02, 0.58400E+02,
     &  0.58500E+02, 0.58600E+02, 0.58700E+02, 0.58800E+02, 0.58900E+02,
     &  0.59000E+02, 0.59100E+02, 0.59200E+02, 0.59300E+02, 0.59400E+02,
     &  0.59500E+02, 0.59600E+02, 0.59700E+02, 0.59800E+02, 0.59900E+02,
     &  0.60000E+02, 0.60100E+02, 0.60200E+02, 0.60300E+02, 0.60400E+02,
     &  0.60500E+02, 0.60600E+02, 0.60700E+02, 0.60800E+02, 0.60900E+02,
     &  0.61000E+02, 0.61100E+02, 0.61200E+02, 0.61300E+02, 0.61400E+02,
     &  0.61500E+02, 0.61600E+02, 0.61700E+02, 0.61800E+02, 0.61900E+02,
     &  0.62000E+02, 0.62100E+02, 0.62200E+02, 0.62300E+02, 0.62400E+02,
     &  0.62500E+02, 0.62600E+02, 0.62700E+02, 0.62800E+02, 0.62900E+02,
     &  0.63000E+02, 0.63100E+02, 0.63200E+02, 0.63300E+02, 0.63400E+02,
     &  0.63500E+02, 0.63600E+02, 0.63700E+02, 0.63800E+02, 0.63900E+02,
     &  0.64000E+02, 0.64100E+02, 0.64200E+02, 0.64300E+02, 0.64400E+02,
     &  0.64500E+02, 0.64600E+02, 0.64700E+02, 0.64800E+02, 0.64900E+02,
     &  0.65000E+02, 0.65100E+02, 0.65200E+02, 0.65300E+02, 0.65400E+02,
     &  0.65500E+02, 0.65600E+02, 0.65700E+02, 0.65800E+02, 0.65900E+02,
     &  0.66000E+02, 0.66100E+02, 0.66200E+02, 0.66300E+02, 0.66400E+02,
     &  0.66500E+02, 0.66600E+02, 0.66700E+02, 0.66800E+02, 0.66900E+02,
     &  0.67000E+02, 0.67100E+02, 0.67200E+02, 0.67300E+02, 0.67400E+02,
     &  0.67500E+02, 0.67600E+02, 0.67700E+02, 0.67800E+02, 0.67900E+02,
     &  0.68000E+02, 0.68100E+02, 0.68200E+02, 0.68300E+02, 0.68400E+02,
     &  0.68500E+02, 0.68600E+02, 0.68700E+02, 0.68800E+02, 0.68900E+02,
     &  0.69000E+02, 0.69100E+02, 0.69200E+02, 0.69300E+02, 0.69400E+02,
     &  0.69500E+02, 0.69600E+02, 0.69700E+02, 0.69800E+02, 0.69900E+02,
     &  0.70000E+02, 0.70100E+02, 0.70200E+02, 0.70300E+02, 0.70400E+02,
     &  0.70500E+02, 0.70600E+02, 0.70700E+02, 0.70800E+02, 0.70900E+02,
     &  0.71000E+02, 0.71100E+02, 0.71200E+02, 0.71300E+02, 0.71400E+02,
     &  0.71500E+02, 0.71600E+02, 0.71700E+02, 0.71800E+02, 0.71900E+02,
     &  0.72000E+02, 0.72100E+02, 0.72200E+02, 0.72300E+02, 0.72400E+02,
     &  0.72500E+02, 0.72600E+02, 0.72700E+02, 0.72800E+02, 0.72900E+02,
     &  0.73000E+02, 0.73100E+02, 0.73200E+02, 0.73300E+02, 0.73400E+02,
     &  0.73500E+02, 0.73600E+02, 0.73700E+02, 0.73800E+02, 0.73900E+02,
     &  0.74000E+02, 0.74100E+02, 0.74200E+02, 0.74300E+02, 0.74400E+02,
     &  0.74500E+02, 0.74600E+02, 0.74700E+02, 0.74800E+02, 0.74900E+02,
     &  0.75000E+02, 0.75100E+02, 0.75200E+02, 0.75300E+02, 0.75400E+02,
     &  0.75500E+02, 0.75600E+02, 0.75700E+02, 0.75800E+02, 0.75900E+02,
     &  0.76000E+02, 0.76100E+02, 0.76200E+02, 0.76300E+02, 0.76400E+02,
     &  0.76500E+02, 0.76600E+02, 0.76700E+02, 0.76800E+02, 0.76900E+02,
     &  0.77000E+02, 0.77100E+02, 0.77200E+02, 0.77300E+02, 0.77400E+02,
     &  0.77500E+02, 0.77600E+02, 0.77700E+02, 0.77800E+02, 0.77900E+02,
     &  0.78000E+02, 0.78100E+02, 0.78200E+02, 0.78300E+02, 0.78400E+02,
     &  0.78500E+02, 0.78600E+02, 0.78700E+02, 0.78800E+02, 0.78900E+02,
     &  0.79000E+02, 0.79100E+02, 0.79200E+02, 0.79300E+02, 0.79400E+02,
     &  0.79500E+02, 0.79600E+02, 0.79700E+02, 0.79800E+02, 0.79900E+02,
     &  0.80000E+02, 0.80100E+02, 0.80200E+02, 0.80300E+02, 0.80400E+02,
     &  0.80500E+02, 0.80600E+02, 0.80700E+02, 0.80800E+02, 0.80900E+02,
     &  0.81000E+02, 0.81100E+02, 0.81200E+02, 0.81300E+02, 0.81400E+02,
     &  0.81500E+02, 0.81600E+02, 0.81700E+02, 0.81800E+02, 0.81900E+02,
     &  0.82000E+02, 0.82100E+02, 0.82200E+02, 0.82300E+02, 0.82400E+02,
     &  0.82500E+02, 0.82600E+02, 0.82700E+02, 0.82800E+02, 0.82900E+02,
     &  0.83000E+02, 0.83100E+02, 0.83200E+02, 0.83300E+02, 0.83400E+02,
     &  0.83500E+02, 0.83600E+02, 0.83700E+02, 0.83800E+02, 0.83900E+02,
     &  0.84000E+02, 0.84100E+02, 0.84200E+02, 0.84300E+02, 0.84400E+02,
     &  0.84500E+02, 0.84600E+02, 0.84700E+02, 0.84800E+02, 0.84900E+02,
     &  0.85000E+02, 0.85100E+02, 0.85200E+02, 0.85300E+02, 0.85400E+02,
     &  0.85500E+02, 0.85600E+02, 0.85700E+02, 0.85800E+02, 0.85900E+02,
     &  0.86000E+02, 0.86100E+02, 0.86200E+02, 0.86300E+02, 0.86400E+02,
     &  0.86500E+02, 0.86600E+02, 0.86700E+02, 0.86800E+02, 0.86900E+02,
     &  0.87000E+02, 0.87100E+02, 0.87200E+02, 0.87300E+02, 0.87400E+02,
     &  0.87500E+02, 0.87600E+02, 0.87700E+02, 0.87800E+02, 0.87900E+02,
     &  0.88000E+02, 0.88100E+02, 0.88200E+02, 0.88300E+02, 0.88400E+02,
     &  0.88500E+02, 0.88600E+02, 0.88700E+02, 0.88800E+02, 0.88900E+02,
     &  0.89000E+02, 0.89100E+02, 0.89200E+02, 0.89300E+02, 0.89400E+02,
     &  0.89500E+02, 0.89600E+02, 0.89700E+02, 0.89800E+02, 0.89900E+02,
     &  0.90000E+02, 0.90100E+02, 0.90200E+02, 0.90300E+02, 0.90400E+02,
     &  0.90500E+02, 0.90600E+02, 0.90700E+02, 0.90800E+02, 0.90900E+02,
     &  0.91000E+02, 0.91100E+02, 0.91200E+02, 0.91300E+02, 0.91400E+02,
     &  0.91500E+02, 0.91600E+02, 0.91700E+02, 0.91800E+02, 0.91900E+02,
     &  0.92000E+02, 0.92100E+02, 0.92200E+02, 0.92300E+02, 0.92400E+02,
     &  0.92500E+02, 0.92600E+02, 0.92700E+02, 0.92800E+02, 0.92900E+02,
     &  0.93000E+02, 0.93100E+02, 0.93200E+02, 0.93300E+02, 0.93400E+02,
     &  0.93500E+02, 0.93600E+02, 0.93700E+02, 0.93800E+02, 0.93900E+02,
     &  0.94000E+02, 0.94100E+02, 0.94200E+02, 0.94300E+02, 0.94400E+02,
     &  0.94500E+02, 0.94600E+02, 0.94700E+02, 0.94800E+02, 0.94900E+02,
     &  0.95000E+02, 0.95100E+02, 0.95200E+02, 0.95300E+02, 0.95400E+02,
     &  0.95500E+02, 0.95600E+02, 0.95700E+02, 0.95800E+02, 0.95900E+02,
     &  0.96000E+02, 0.96100E+02, 0.96200E+02, 0.96300E+02, 0.96400E+02,
     &  0.96500E+02, 0.96600E+02, 0.96700E+02, 0.96800E+02, 0.96900E+02,
     &  0.97000E+02, 0.97100E+02, 0.97200E+02, 0.97300E+02, 0.97400E+02,
     &  0.97500E+02, 0.97600E+02, 0.97700E+02, 0.97800E+02, 0.97900E+02,
     &  0.98000E+02, 0.98100E+02, 0.98200E+02, 0.98300E+02, 0.98400E+02,
     &  0.98500E+02, 0.98600E+02, 0.98700E+02, 0.98800E+02, 0.98900E+02,
     &  0.99000E+02, 0.99100E+02, 0.99200E+02, 0.99300E+02, 0.99400E+02,
     &  0.99500E+02, 0.99600E+02, 0.99700E+02, 0.99800E+02, 0.99900E+02,
     &  0.10000E+03, 0.10010E+03, 0.10020E+03, 0.10030E+03, 0.10040E+03,
     &  0.10050E+03, 0.10060E+03, 0.10070E+03, 0.10080E+03, 0.10090E+03,
     &  0.10100E+03, 0.10110E+03, 0.10120E+03, 0.10130E+03, 0.10140E+03,
     &  0.10150E+03, 0.10160E+03, 0.10170E+03, 0.10180E+03, 0.10190E+03,
     &  0.10200E+03, 0.10210E+03, 0.10220E+03, 0.10230E+03, 0.10240E+03,
     &  0.10250E+03, 0.10260E+03, 0.10270E+03, 0.10280E+03, 0.10290E+03,
     &  0.10300E+03, 0.10310E+03, 0.10320E+03, 0.10330E+03, 0.10340E+03,
     &  0.10350E+03, 0.10360E+03, 0.10370E+03, 0.10380E+03, 0.10390E+03,
     &  0.10400E+03, 0.10410E+03, 0.10420E+03, 0.10430E+03, 0.10440E+03,
     &  0.10450E+03, 0.10460E+03, 0.10470E+03, 0.10480E+03, 0.10490E+03,
     &  0.10500E+03, 0.10510E+03, 0.10520E+03, 0.10530E+03, 0.10540E+03,
     &  0.10550E+03, 0.10560E+03, 0.10570E+03, 0.10580E+03, 0.10590E+03,
     &  0.10600E+03, 0.10610E+03, 0.10620E+03, 0.10630E+03, 0.10640E+03,
     &  0.10650E+03, 0.10660E+03, 0.10670E+03, 0.10680E+03, 0.10690E+03,
     &  0.10700E+03, 0.10710E+03, 0.10720E+03, 0.10730E+03, 0.10740E+03,
     &  0.10750E+03, 0.10760E+03, 0.10770E+03, 0.10780E+03, 0.10790E+03,
     &  0.10800E+03, 0.10810E+03, 0.10820E+03, 0.10830E+03, 0.10840E+03,
     &  0.10850E+03, 0.10860E+03, 0.10870E+03, 0.10880E+03, 0.10890E+03,
     &  0.10900E+03, 0.10910E+03, 0.10920E+03, 0.10930E+03, 0.10940E+03,
     &  0.10950E+03,
     &  0.10960E+03,
     &  0.10970E+03,
     &  0.10980E+03,
     &  0.10990E+03,
     &  0.11000E+03/
      Data (bdf(i),i=       1,     701)/
     &  0.67609E+01, 0.66895E+01, 0.65564E+01, 0.64732E+01, 0.64548E+01,
     &  0.63741E+01, 0.62933E+01, 0.63473E+01, 0.63214E+01, 0.63073E+01,
     &  0.63042E+01, 0.62169E+01, 0.62187E+01, 0.61851E+01, 0.61118E+01,
     &  0.60023E+01, 0.60546E+01, 0.61140E+01, 0.60924E+01, 0.60378E+01,
     &  0.60570E+01, 0.59971E+01, 0.59496E+01, 0.60032E+01, 0.59607E+01,
     &  0.60147E+01, 0.60003E+01, 0.59833E+01, 0.59780E+01, 0.59186E+01,
     &  0.59233E+01, 0.59326E+01, 0.58995E+01, 0.58692E+01, 0.58286E+01,
     &  0.58046E+01, 0.58566E+01, 0.59034E+01, 0.58657E+01, 0.58860E+01,
     &  0.58504E+01, 0.58462E+01, 0.58600E+01, 0.58360E+01, 0.58092E+01,
     &  0.58383E+01, 0.58694E+01, 0.58693E+01, 0.57981E+01, 0.58080E+01,
     &  0.58266E+01, 0.58862E+01, 0.58080E+01, 0.58864E+01, 0.59220E+01,
     &  0.59341E+01, 0.59911E+01, 0.60407E+01, 0.60338E+01, 0.61377E+01,
     &  0.61713E+01, 0.61616E+01, 0.62728E+01, 0.62582E+01, 0.62391E+01,
     &  0.63342E+01, 0.63720E+01, 0.64024E+01, 0.63529E+01, 0.64003E+01,
     &  0.63956E+01, 0.64265E+01, 0.64626E+01, 0.64605E+01, 0.65083E+01,
     &  0.65747E+01, 0.65467E+01, 0.66198E+01, 0.66298E+01, 0.65925E+01,
     &  0.66516E+01, 0.66136E+01, 0.67204E+01, 0.67348E+01, 0.67872E+01,
     &  0.68298E+01, 0.68177E+01, 0.68363E+01, 0.68632E+01, 0.68931E+01,
     &  0.69258E+01, 0.70106E+01, 0.70410E+01, 0.71283E+01, 0.72443E+01,
     &  0.72299E+01, 0.73342E+01, 0.74046E+01, 0.73842E+01, 0.73987E+01,
     &  0.74417E+01, 0.74415E+01, 0.74988E+01, 0.75171E+01, 0.75644E+01,
     &  0.75927E+01, 0.75972E+01, 0.76238E+01, 0.77184E+01, 0.78095E+01,
     &  0.77154E+01, 0.77819E+01, 0.78542E+01, 0.78055E+01, 0.78796E+01,
     &  0.79111E+01, 0.79592E+01, 0.80109E+01, 0.80226E+01, 0.80221E+01,
     &  0.80392E+01, 0.80620E+01, 0.80859E+01, 0.81475E+01, 0.82016E+01,
     &  0.82230E+01, 0.82943E+01, 0.83577E+01, 0.84233E+01, 0.84495E+01,
     &  0.84586E+01, 0.84627E+01, 0.85285E+01, 0.85971E+01, 0.87513E+01,
     &  0.88484E+01, 0.89340E+01, 0.89611E+01, 0.89469E+01, 0.90668E+01,
     &  0.91355E+01, 0.92571E+01, 0.92880E+01, 0.93141E+01, 0.93187E+01,
     &  0.93543E+01, 0.94610E+01, 0.95013E+01, 0.95038E+01, 0.96175E+01,
     &  0.97283E+01, 0.97783E+01, 0.97306E+01, 0.97925E+01, 0.97526E+01,
     &  0.96461E+01, 0.96763E+01, 0.97217E+01, 0.97672E+01, 0.98109E+01,
     &  0.97393E+01, 0.97179E+01, 0.97723E+01, 0.97061E+01, 0.96535E+01,
     &  0.96770E+01, 0.97052E+01, 0.97876E+01, 0.98165E+01, 0.97918E+01,
     &  0.97919E+01, 0.98586E+01, 0.98706E+01, 0.98847E+01, 0.98774E+01,
     &  0.98700E+01, 0.98040E+01, 0.98062E+01, 0.98256E+01, 0.97702E+01,
     &  0.97910E+01, 0.98286E+01, 0.98619E+01, 0.99112E+01, 0.99124E+01,
     &  0.99650E+01, 0.99914E+01, 0.10031E+02, 0.10117E+02, 0.10084E+02,
     &  0.10057E+02, 0.10145E+02, 0.10273E+02, 0.10366E+02, 0.10405E+02,
     &  0.10456E+02, 0.10506E+02, 0.10508E+02, 0.10638E+02, 0.10735E+02,
     &  0.10775E+02, 0.10811E+02, 0.10751E+02, 0.10777E+02, 0.10804E+02,
     &  0.10794E+02, 0.10716E+02, 0.10694E+02, 0.10782E+02, 0.10811E+02,
     &  0.10772E+02, 0.10745E+02, 0.10707E+02, 0.10658E+02, 0.10627E+02,
     &  0.10563E+02, 0.10574E+02, 0.10528E+02, 0.10445E+02, 0.10467E+02,
     &  0.10443E+02, 0.10422E+02, 0.10446E+02, 0.10410E+02, 0.10405E+02,
     &  0.10419E+02, 0.10438E+02, 0.10388E+02, 0.10333E+02, 0.10371E+02,
     &  0.10315E+02, 0.10220E+02, 0.10156E+02, 0.10177E+02, 0.10113E+02,
     &  0.10179E+02, 0.10207E+02, 0.10238E+02, 0.10129E+02, 0.10065E+02,
     &  0.10013E+02, 0.10029E+02, 0.99605E+01, 0.99253E+01, 0.99510E+01,
     &  0.99069E+01, 0.98004E+01, 0.97554E+01, 0.97176E+01, 0.96896E+01,
     &  0.96352E+01, 0.95995E+01, 0.96401E+01, 0.97206E+01, 0.98131E+01,
     &  0.98708E+01, 0.99777E+01, 0.10117E+02, 0.10188E+02, 0.10226E+02,
     &  0.10264E+02, 0.10276E+02, 0.10378E+02, 0.10449E+02, 0.10560E+02,
     &  0.10558E+02, 0.10748E+02, 0.10860E+02, 0.11003E+02, 0.11105E+02,
     &  0.11171E+02, 0.11233E+02, 0.11216E+02, 0.11269E+02, 0.11295E+02,
     &  0.11391E+02, 0.11530E+02, 0.11603E+02, 0.11638E+02, 0.11630E+02,
     &  0.11699E+02, 0.11658E+02, 0.11687E+02, 0.11705E+02, 0.11751E+02,
     &  0.11813E+02, 0.11838E+02, 0.11874E+02, 0.11948E+02, 0.11955E+02,
     &  0.11921E+02, 0.11914E+02, 0.11964E+02, 0.12068E+02, 0.12043E+02,
     &  0.12100E+02, 0.12065E+02, 0.12184E+02, 0.12219E+02, 0.12280E+02,
     &  0.12306E+02, 0.12237E+02, 0.12166E+02, 0.12114E+02, 0.12021E+02,
     &  0.11990E+02, 0.12038E+02, 0.12022E+02, 0.11986E+02, 0.11935E+02,
     &  0.11951E+02, 0.11888E+02, 0.11975E+02, 0.11965E+02, 0.11912E+02,
     &  0.11811E+02, 0.11758E+02, 0.11831E+02, 0.11715E+02, 0.11679E+02,
     &  0.11674E+02, 0.11663E+02, 0.11634E+02, 0.11570E+02, 0.11554E+02,
     &  0.11599E+02, 0.11664E+02, 0.11619E+02, 0.11589E+02, 0.11619E+02,
     &  0.11579E+02, 0.11529E+02, 0.11641E+02, 0.11627E+02, 0.11632E+02,
     &  0.11660E+02, 0.11772E+02, 0.11793E+02, 0.11935E+02, 0.12132E+02,
     &  0.12220E+02, 0.12269E+02, 0.12329E+02, 0.12459E+02, 0.12547E+02,
     &  0.12625E+02, 0.12777E+02, 0.12887E+02, 0.13034E+02, 0.13152E+02,
     &  0.13221E+02, 0.13503E+02, 0.13704E+02, 0.13976E+02, 0.14279E+02,
     &  0.14536E+02, 0.14868E+02, 0.15249E+02, 0.15578E+02, 0.15909E+02,
     &  0.16296E+02, 0.16530E+02, 0.16895E+02, 0.17161E+02, 0.17495E+02,
     &  0.17694E+02, 0.18048E+02, 0.18472E+02, 0.18797E+02, 0.19336E+02,
     &  0.19655E+02, 0.20147E+02, 0.20720E+02, 0.21174E+02, 0.21766E+02,
     &  0.22185E+02, 0.22717E+02, 0.23012E+02, 0.23373E+02, 0.23688E+02,
     &  0.24056E+02, 0.24352E+02, 0.24724E+02, 0.24989E+02, 0.25210E+02,
     &  0.25290E+02, 0.25409E+02, 0.25602E+02, 0.25721E+02, 0.25863E+02,
     &  0.25972E+02, 0.26034E+02, 0.26101E+02, 0.26075E+02, 0.26111E+02,
     &  0.26103E+02, 0.26092E+02, 0.26203E+02, 0.26210E+02, 0.26217E+02,
     &  0.26106E+02, 0.25982E+02, 0.25877E+02, 0.25743E+02, 0.25625E+02,
     &  0.25480E+02, 0.25374E+02, 0.25196E+02, 0.25065E+02, 0.24845E+02,
     &  0.24672E+02, 0.24547E+02, 0.24429E+02, 0.24277E+02, 0.24090E+02,
     &  0.24017E+02, 0.23926E+02, 0.23795E+02, 0.23650E+02, 0.23389E+02,
     &  0.23274E+02, 0.23114E+02, 0.22915E+02, 0.22730E+02, 0.22722E+02,
     &  0.22623E+02, 0.22627E+02, 0.22551E+02, 0.22514E+02, 0.22452E+02,
     &  0.22345E+02, 0.22116E+02, 0.22053E+02, 0.22118E+02, 0.22074E+02,
     &  0.21835E+02, 0.21737E+02, 0.21743E+02, 0.21747E+02, 0.21559E+02,
     &  0.21542E+02, 0.21583E+02, 0.21543E+02, 0.21288E+02, 0.21247E+02,
     &  0.21110E+02, 0.21151E+02, 0.21029E+02, 0.20995E+02, 0.21032E+02,
     &  0.21222E+02, 0.21265E+02, 0.21173E+02, 0.21141E+02, 0.21097E+02,
     &  0.21153E+02, 0.21163E+02, 0.21079E+02, 0.21124E+02, 0.21149E+02,
     &  0.21147E+02, 0.21142E+02, 0.21053E+02, 0.21007E+02, 0.20979E+02,
     &  0.20880E+02, 0.20955E+02, 0.20913E+02, 0.20835E+02, 0.20796E+02,
     &  0.20829E+02, 0.20931E+02, 0.20968E+02, 0.20991E+02, 0.21058E+02,
     &  0.21141E+02, 0.21189E+02, 0.21258E+02, 0.21235E+02, 0.21231E+02,
     &  0.21338E+02, 0.21425E+02, 0.21491E+02, 0.21569E+02, 0.21579E+02,
     &  0.21611E+02, 0.21565E+02, 0.21468E+02, 0.21421E+02, 0.21547E+02,
     &  0.21531E+02, 0.21539E+02, 0.21597E+02, 0.21669E+02, 0.21752E+02,
     &  0.21905E+02, 0.22026E+02, 0.22200E+02, 0.22301E+02, 0.22438E+02,
     &  0.22556E+02, 0.22448E+02, 0.22248E+02, 0.22125E+02, 0.22020E+02,
     &  0.21859E+02, 0.21740E+02, 0.21600E+02, 0.21460E+02, 0.21367E+02,
     &  0.21182E+02, 0.21137E+02, 0.20984E+02, 0.20843E+02, 0.20745E+02,
     &  0.20596E+02, 0.20464E+02, 0.20284E+02, 0.20296E+02, 0.20227E+02,
     &  0.20052E+02, 0.20028E+02, 0.19926E+02, 0.19931E+02, 0.19874E+02,
     &  0.19690E+02, 0.19707E+02, 0.19649E+02, 0.19550E+02, 0.19433E+02,
     &  0.19427E+02, 0.19421E+02, 0.19416E+02, 0.19403E+02, 0.19351E+02,
     &  0.19404E+02, 0.19339E+02, 0.19240E+02, 0.19266E+02, 0.19267E+02,
     &  0.19283E+02, 0.19308E+02, 0.19277E+02, 0.19247E+02, 0.19099E+02,
     &  0.19146E+02, 0.19144E+02, 0.19172E+02, 0.19174E+02, 0.19251E+02,
     &  0.19302E+02, 0.19061E+02, 0.18860E+02, 0.18676E+02, 0.18551E+02,
     &  0.18418E+02, 0.18319E+02, 0.18212E+02, 0.18070E+02, 0.18032E+02,
     &  0.17975E+02, 0.17831E+02, 0.17673E+02, 0.17553E+02, 0.17481E+02,
     &  0.17405E+02, 0.17294E+02, 0.17161E+02, 0.17043E+02, 0.16913E+02,
     &  0.16877E+02, 0.16822E+02, 0.16736E+02, 0.16632E+02, 0.16582E+02,
     &  0.16439E+02, 0.16360E+02, 0.16357E+02, 0.16352E+02, 0.16302E+02,
     &  0.16190E+02, 0.16184E+02, 0.16120E+02, 0.16092E+02, 0.16021E+02,
     &  0.16048E+02, 0.15965E+02, 0.15867E+02, 0.15808E+02, 0.15722E+02,
     &  0.15660E+02, 0.15674E+02, 0.15550E+02, 0.15431E+02, 0.15357E+02,
     &  0.15340E+02, 0.15325E+02, 0.15223E+02, 0.15086E+02, 0.15003E+02,
     &  0.14982E+02, 0.14858E+02, 0.14829E+02, 0.14755E+02, 0.14648E+02,
     &  0.14581E+02, 0.14418E+02, 0.14377E+02, 0.14154E+02, 0.14071E+02,
     &  0.13957E+02, 0.13919E+02, 0.13904E+02, 0.13782E+02, 0.13779E+02,
     &  0.13734E+02, 0.13609E+02, 0.13588E+02, 0.13594E+02, 0.13552E+02,
     &  0.13382E+02, 0.13233E+02, 0.13152E+02, 0.12998E+02, 0.12886E+02,
     &  0.12702E+02, 0.12580E+02, 0.12595E+02, 0.12477E+02, 0.12373E+02,
     &  0.12290E+02, 0.12147E+02, 0.12019E+02, 0.11952E+02, 0.11972E+02,
     &  0.11884E+02, 0.11880E+02, 0.11735E+02, 0.11733E+02, 0.11671E+02,
     &  0.11566E+02, 0.11600E+02, 0.11447E+02, 0.11423E+02, 0.11332E+02,
     &  0.11289E+02, 0.11196E+02, 0.11193E+02, 0.11243E+02, 0.11188E+02,
     &  0.11323E+02, 0.11263E+02, 0.11311E+02, 0.11344E+02, 0.11341E+02,
     &  0.11488E+02, 0.11626E+02, 0.11676E+02, 0.11692E+02, 0.11735E+02,
     &  0.11878E+02, 0.11974E+02, 0.12118E+02, 0.12260E+02, 0.12462E+02,
     &  0.12700E+02, 0.12842E+02, 0.12977E+02, 0.13150E+02, 0.13428E+02,
     &  0.13683E+02, 0.13901E+02, 0.14142E+02, 0.14320E+02, 0.14490E+02,
     &  0.14777E+02, 0.14903E+02, 0.15095E+02, 0.15300E+02, 0.15552E+02,
     &  0.15754E+02, 0.16009E+02, 0.16336E+02, 0.16583E+02, 0.16785E+02,
     &  0.16907E+02, 0.17092E+02, 0.17392E+02, 0.17670E+02, 0.17896E+02,
     &  0.18093E+02, 0.18408E+02, 0.18769E+02, 0.18983E+02, 0.19296E+02,
     &  0.19665E+02,
     &  0.19908E+02,
     &  0.20314E+02,
     &  0.20491E+02,
     &  0.20804E+02,
     &  0.21062E+02/
      Data (sigma(i),i=       1,     701)/
     &  0.31339E-01, 0.31519E-01, 0.31825E-01, 0.32011E-01, 0.32065E-01,
     &  0.32272E-01, 0.32469E-01, 0.32315E-01, 0.32387E-01, 0.32434E-01,
     &  0.32443E-01, 0.32663E-01, 0.32692E-01, 0.32783E-01, 0.32972E-01,
     &  0.33271E-01, 0.33118E-01, 0.32976E-01, 0.33016E-01, 0.33165E-01,
     &  0.33108E-01, 0.33294E-01, 0.33428E-01, 0.33260E-01, 0.33372E-01,
     &  0.33262E-01, 0.33299E-01, 0.33346E-01, 0.33367E-01, 0.33544E-01,
     &  0.33536E-01, 0.33506E-01, 0.33590E-01, 0.33693E-01, 0.33812E-01,
     &  0.33882E-01, 0.33733E-01, 0.33595E-01, 0.33703E-01, 0.33630E-01,
     &  0.33740E-01, 0.33748E-01, 0.33723E-01, 0.33778E-01, 0.33843E-01,
     &  0.33752E-01, 0.33662E-01, 0.33676E-01, 0.33869E-01, 0.33824E-01,
     &  0.33762E-01, 0.33598E-01, 0.33810E-01, 0.33598E-01, 0.33503E-01,
     &  0.33476E-01, 0.33283E-01, 0.33167E-01, 0.33214E-01, 0.32951E-01,
     &  0.32884E-01, 0.32913E-01, 0.32625E-01, 0.32673E-01, 0.32728E-01,
     &  0.32478E-01, 0.32395E-01, 0.32329E-01, 0.32461E-01, 0.32338E-01,
     &  0.32357E-01, 0.32266E-01, 0.32182E-01, 0.32167E-01, 0.32048E-01,
     &  0.31888E-01, 0.31942E-01, 0.31782E-01, 0.31756E-01, 0.31848E-01,
     &  0.31708E-01, 0.31799E-01, 0.31547E-01, 0.31504E-01, 0.31384E-01,
     &  0.31279E-01, 0.31301E-01, 0.31252E-01, 0.31201E-01, 0.31117E-01,
     &  0.31003E-01, 0.30823E-01, 0.30767E-01, 0.30571E-01, 0.30334E-01,
     &  0.30372E-01, 0.30139E-01, 0.29971E-01, 0.30022E-01, 0.29974E-01,
     &  0.29882E-01, 0.29882E-01, 0.29765E-01, 0.29722E-01, 0.29628E-01,
     &  0.29566E-01, 0.29540E-01, 0.29496E-01, 0.29312E-01, 0.29146E-01,
     &  0.29328E-01, 0.29217E-01, 0.29092E-01, 0.29180E-01, 0.29031E-01,
     &  0.28966E-01, 0.28878E-01, 0.28786E-01, 0.28776E-01, 0.28776E-01,
     &  0.28764E-01, 0.28720E-01, 0.28668E-01, 0.28569E-01, 0.28473E-01,
     &  0.28421E-01, 0.28297E-01, 0.28185E-01, 0.28067E-01, 0.28038E-01,
     &  0.28020E-01, 0.28007E-01, 0.27901E-01, 0.27789E-01, 0.27551E-01,
     &  0.27409E-01, 0.27300E-01, 0.27258E-01, 0.27286E-01, 0.27111E-01,
     &  0.27016E-01, 0.26848E-01, 0.26803E-01, 0.26755E-01, 0.26744E-01,
     &  0.26696E-01, 0.26560E-01, 0.26508E-01, 0.26489E-01, 0.26332E-01,
     &  0.26189E-01, 0.26120E-01, 0.26185E-01, 0.26101E-01, 0.26151E-01,
     &  0.26290E-01, 0.26246E-01, 0.26193E-01, 0.26126E-01, 0.26073E-01,
     &  0.26163E-01, 0.26197E-01, 0.26130E-01, 0.26224E-01, 0.26300E-01,
     &  0.26267E-01, 0.26224E-01, 0.26120E-01, 0.26077E-01, 0.26109E-01,
     &  0.26109E-01, 0.26024E-01, 0.26004E-01, 0.25993E-01, 0.26009E-01,
     &  0.26011E-01, 0.26097E-01, 0.26098E-01, 0.26077E-01, 0.26124E-01,
     &  0.26096E-01, 0.26046E-01, 0.26019E-01, 0.25951E-01, 0.25945E-01,
     &  0.25873E-01, 0.25837E-01, 0.25787E-01, 0.25684E-01, 0.25730E-01,
     &  0.25753E-01, 0.25644E-01, 0.25490E-01, 0.25381E-01, 0.25341E-01,
     &  0.25278E-01, 0.25221E-01, 0.25211E-01, 0.25066E-01, 0.24947E-01,
     &  0.24899E-01, 0.24853E-01, 0.24926E-01, 0.24899E-01, 0.24866E-01,
     &  0.24879E-01, 0.24971E-01, 0.24995E-01, 0.24906E-01, 0.24875E-01,
     &  0.24923E-01, 0.24956E-01, 0.24988E-01, 0.25032E-01, 0.25075E-01,
     &  0.25165E-01, 0.25152E-01, 0.25205E-01, 0.25311E-01, 0.25292E-01,
     &  0.25327E-01, 0.25352E-01, 0.25323E-01, 0.25357E-01, 0.25361E-01,
     &  0.25356E-01, 0.25330E-01, 0.25392E-01, 0.25460E-01, 0.25413E-01,
     &  0.25486E-01, 0.25608E-01, 0.25686E-01, 0.25666E-01, 0.25743E-01,
     &  0.25666E-01, 0.25632E-01, 0.25598E-01, 0.25731E-01, 0.25816E-01,
     &  0.25877E-01, 0.25861E-01, 0.25944E-01, 0.25988E-01, 0.25950E-01,
     &  0.26010E-01, 0.26153E-01, 0.26220E-01, 0.26264E-01, 0.26300E-01,
     &  0.26376E-01, 0.26409E-01, 0.26345E-01, 0.26245E-01, 0.26112E-01,
     &  0.26027E-01, 0.25894E-01, 0.25717E-01, 0.25631E-01, 0.25590E-01,
     &  0.25549E-01, 0.25525E-01, 0.25409E-01, 0.25319E-01, 0.25180E-01,
     &  0.25185E-01, 0.24961E-01, 0.24834E-01, 0.24679E-01, 0.24574E-01,
     &  0.24496E-01, 0.24439E-01, 0.24452E-01, 0.24401E-01, 0.24371E-01,
     &  0.24272E-01, 0.24120E-01, 0.24044E-01, 0.24013E-01, 0.24024E-01,
     &  0.23953E-01, 0.23990E-01, 0.23952E-01, 0.23940E-01, 0.23890E-01,
     &  0.23835E-01, 0.23811E-01, 0.23761E-01, 0.23685E-01, 0.23677E-01,
     &  0.23712E-01, 0.23713E-01, 0.23661E-01, 0.23557E-01, 0.23586E-01,
     &  0.23523E-01, 0.23547E-01, 0.23438E-01, 0.23404E-01, 0.23343E-01,
     &  0.23321E-01, 0.23381E-01, 0.23442E-01, 0.23492E-01, 0.23584E-01,
     &  0.23610E-01, 0.23567E-01, 0.23580E-01, 0.23618E-01, 0.23675E-01,
     &  0.23662E-01, 0.23719E-01, 0.23633E-01, 0.23648E-01, 0.23694E-01,
     &  0.23804E-01, 0.23851E-01, 0.23783E-01, 0.23898E-01, 0.23933E-01,
     &  0.23941E-01, 0.23947E-01, 0.23965E-01, 0.24034E-01, 0.24048E-01,
     &  0.23996E-01, 0.23938E-01, 0.23990E-01, 0.24022E-01, 0.23989E-01,
     &  0.24027E-01, 0.24082E-01, 0.23967E-01, 0.23993E-01, 0.23985E-01,
     &  0.23957E-01, 0.23838E-01, 0.23822E-01, 0.23680E-01, 0.23485E-01,
     &  0.23408E-01, 0.23362E-01, 0.23311E-01, 0.23181E-01, 0.23097E-01,
     &  0.23028E-01, 0.22890E-01, 0.22794E-01, 0.22663E-01, 0.22552E-01,
     &  0.22497E-01, 0.22257E-01, 0.22088E-01, 0.21873E-01, 0.21644E-01,
     &  0.21449E-01, 0.21209E-01, 0.20940E-01, 0.20715E-01, 0.20489E-01,
     &  0.20244E-01, 0.20094E-01, 0.19867E-01, 0.19714E-01, 0.19521E-01,
     &  0.19404E-01, 0.19206E-01, 0.18980E-01, 0.18818E-01, 0.18549E-01,
     &  0.18393E-01, 0.18165E-01, 0.17901E-01, 0.17705E-01, 0.17460E-01,
     &  0.17286E-01, 0.17077E-01, 0.16966E-01, 0.16828E-01, 0.16707E-01,
     &  0.16572E-01, 0.16467E-01, 0.16336E-01, 0.16243E-01, 0.16170E-01,
     &  0.16139E-01, 0.16098E-01, 0.16034E-01, 0.15994E-01, 0.15949E-01,
     &  0.15914E-01, 0.15894E-01, 0.15875E-01, 0.15879E-01, 0.15864E-01,
     &  0.15864E-01, 0.15868E-01, 0.15832E-01, 0.15830E-01, 0.15825E-01,
     &  0.15850E-01, 0.15885E-01, 0.15914E-01, 0.15953E-01, 0.15988E-01,
     &  0.16036E-01, 0.16067E-01, 0.16123E-01, 0.16163E-01, 0.16230E-01,
     &  0.16286E-01, 0.16325E-01, 0.16363E-01, 0.16413E-01, 0.16471E-01,
     &  0.16499E-01, 0.16529E-01, 0.16576E-01, 0.16624E-01, 0.16712E-01,
     &  0.16748E-01, 0.16802E-01, 0.16875E-01, 0.16933E-01, 0.16930E-01,
     &  0.16964E-01, 0.16954E-01, 0.16977E-01, 0.16983E-01, 0.17002E-01,
     &  0.17035E-01, 0.17119E-01, 0.17135E-01, 0.17103E-01, 0.17111E-01,
     &  0.17198E-01, 0.17226E-01, 0.17214E-01, 0.17205E-01, 0.17268E-01,
     &  0.17259E-01, 0.17227E-01, 0.17223E-01, 0.17303E-01, 0.17306E-01,
     &  0.17343E-01, 0.17298E-01, 0.17318E-01, 0.17308E-01, 0.17269E-01,
     &  0.17163E-01, 0.17131E-01, 0.17143E-01, 0.17140E-01, 0.17141E-01,
     &  0.17085E-01, 0.17054E-01, 0.17063E-01, 0.17017E-01, 0.16989E-01,
     &  0.16962E-01, 0.16934E-01, 0.16936E-01, 0.16939E-01, 0.16927E-01,
     &  0.16941E-01, 0.16900E-01, 0.16896E-01, 0.16901E-01, 0.16894E-01,
     &  0.16857E-01, 0.16801E-01, 0.16765E-01, 0.16740E-01, 0.16694E-01,
     &  0.16648E-01, 0.16615E-01, 0.16578E-01, 0.16557E-01, 0.16537E-01,
     &  0.16488E-01, 0.16446E-01, 0.16410E-01, 0.16354E-01, 0.16333E-01,
     &  0.16305E-01, 0.16308E-01, 0.16315E-01, 0.16315E-01, 0.16255E-01,
     &  0.16247E-01, 0.16225E-01, 0.16191E-01, 0.16159E-01, 0.16123E-01,
     &  0.16064E-01, 0.16009E-01, 0.15943E-01, 0.15903E-01, 0.15846E-01,
     &  0.15811E-01, 0.15835E-01, 0.15889E-01, 0.15920E-01, 0.15953E-01,
     &  0.16006E-01, 0.16045E-01, 0.16089E-01, 0.16135E-01, 0.16160E-01,
     &  0.16211E-01, 0.16230E-01, 0.16273E-01, 0.16333E-01, 0.16359E-01,
     &  0.16411E-01, 0.16451E-01, 0.16519E-01, 0.16515E-01, 0.16540E-01,
     &  0.16601E-01, 0.16602E-01, 0.16639E-01, 0.16655E-01, 0.16684E-01,
     &  0.16759E-01, 0.16761E-01, 0.16795E-01, 0.16843E-01, 0.16895E-01,
     &  0.16928E-01, 0.16944E-01, 0.16975E-01, 0.16988E-01, 0.17009E-01,
     &  0.17008E-01, 0.17049E-01, 0.17113E-01, 0.17124E-01, 0.17142E-01,
     &  0.17165E-01, 0.17187E-01, 0.17232E-01, 0.17269E-01, 0.17361E-01,
     &  0.17377E-01, 0.17403E-01, 0.17398E-01, 0.17420E-01, 0.17420E-01,
     &  0.17432E-01, 0.17558E-01, 0.17655E-01, 0.17744E-01, 0.17818E-01,
     &  0.17901E-01, 0.17964E-01, 0.18031E-01, 0.18116E-01, 0.18151E-01,
     &  0.18196E-01, 0.18273E-01, 0.18363E-01, 0.18444E-01, 0.18502E-01,
     &  0.18556E-01, 0.18636E-01, 0.18724E-01, 0.18803E-01, 0.18882E-01,
     &  0.18920E-01, 0.18968E-01, 0.19038E-01, 0.19107E-01, 0.19149E-01,
     &  0.19239E-01, 0.19288E-01, 0.19303E-01, 0.19325E-01, 0.19370E-01,
     &  0.19447E-01, 0.19461E-01, 0.19526E-01, 0.19558E-01, 0.19609E-01,
     &  0.19603E-01, 0.19660E-01, 0.19728E-01, 0.19785E-01, 0.19856E-01,
     &  0.19917E-01, 0.19913E-01, 0.19993E-01, 0.20074E-01, 0.20135E-01,
     &  0.20160E-01, 0.20183E-01, 0.20258E-01, 0.20363E-01, 0.20434E-01,
     &  0.20469E-01, 0.20567E-01, 0.20600E-01, 0.20654E-01, 0.20748E-01,
     &  0.20810E-01, 0.20939E-01, 0.20988E-01, 0.21152E-01, 0.21233E-01,
     &  0.21324E-01, 0.21359E-01, 0.21381E-01, 0.21486E-01, 0.21489E-01,
     &  0.21538E-01, 0.21661E-01, 0.21693E-01, 0.21691E-01, 0.21731E-01,
     &  0.21868E-01, 0.21998E-01, 0.22064E-01, 0.22189E-01, 0.22284E-01,
     &  0.22441E-01, 0.22557E-01, 0.22546E-01, 0.22650E-01, 0.22749E-01,
     &  0.22831E-01, 0.22977E-01, 0.23103E-01, 0.23173E-01, 0.23168E-01,
     &  0.23236E-01, 0.23259E-01, 0.23412E-01, 0.23426E-01, 0.23501E-01,
     &  0.23612E-01, 0.23604E-01, 0.23752E-01, 0.23787E-01, 0.23882E-01,
     &  0.23940E-01, 0.24041E-01, 0.24034E-01, 0.23985E-01, 0.24048E-01,
     &  0.23915E-01, 0.23969E-01, 0.23924E-01, 0.23888E-01, 0.23899E-01,
     &  0.23749E-01, 0.23633E-01, 0.23586E-01, 0.23564E-01, 0.23520E-01,
     &  0.23395E-01, 0.23292E-01, 0.23156E-01, 0.23021E-01, 0.22827E-01,
     &  0.22604E-01, 0.22483E-01, 0.22365E-01, 0.22214E-01, 0.21979E-01,
     &  0.21778E-01, 0.21603E-01, 0.21419E-01, 0.21287E-01, 0.21162E-01,
     &  0.20962E-01, 0.20869E-01, 0.20734E-01, 0.20599E-01, 0.20432E-01,
     &  0.20306E-01, 0.20143E-01, 0.19944E-01, 0.19797E-01, 0.19678E-01,
     &  0.19613E-01, 0.19508E-01, 0.19344E-01, 0.19193E-01, 0.19069E-01,
     &  0.18962E-01, 0.18805E-01, 0.18626E-01, 0.18520E-01, 0.18373E-01,
     &  0.18205E-01,
     &  0.18092E-01,
     &  0.17911E-01,
     &  0.17828E-01,
     &  0.17701E-01,
     &  0.17602E-01/
c
      massi = hmass(1)
      massx = hmass(npoint)
      dmass = (massx-massi)/Real(npoint-1)
c      
      imass = int( (mh-massi)/dmass ) + 1
c
      if (imass.eq.npoint) then
        imass = npoint
        jmass = npoint
        rmass = 0.0
      Endif
cjm Modifie le 24Fevrier
      If (imass.le.0 .or. imass.gt.npoint) then
        A202_HGG_BACKG = 0.
        RETURN
      Endif
      If (imass.ge.1..and.imass.lt.npoint) then
        jmass = imass + 1
        rmass = mh - hmass(imass)
      endif
c
      If (.not.err) A202_HGG_BACKG = bdf(imass)+(bdf(jmass)
     &     -bdf(imass))*rmass/dmass
      If (err) A202_HGG_BACKG = sigma(imass)+(sigma(jmass)
     &     -sigma(imass))*rmass/dmass
c
      RETURN
      END
      Integer FUNCTION A189_HGG_CAND(mh,myich,debug)
      Implicit none
      Real mh
      Integer myich
      Logical debug
c
      Integer npoint
      Parameter (npoint=601)
      Real hmass(npoint),err
      Real massi,massx,dmass,rmass
      Integer i,imass,jmass,idata(npoint)
      Data (hmass(i),i=       1,     601)/
     &  0.40000E+02, 0.40100E+02, 0.40200E+02, 0.40300E+02, 0.40400E+02,
     &  0.40500E+02, 0.40600E+02, 0.40700E+02, 0.40800E+02, 0.40900E+02,
     &  0.41000E+02, 0.41100E+02, 0.41200E+02, 0.41300E+02, 0.41400E+02,
     &  0.41500E+02, 0.41600E+02, 0.41700E+02, 0.41800E+02, 0.41900E+02,
     &  0.42000E+02, 0.42100E+02, 0.42200E+02, 0.42300E+02, 0.42400E+02,
     &  0.42500E+02, 0.42600E+02, 0.42700E+02, 0.42800E+02, 0.42900E+02,
     &  0.43000E+02, 0.43100E+02, 0.43200E+02, 0.43300E+02, 0.43400E+02,
     &  0.43500E+02, 0.43600E+02, 0.43700E+02, 0.43800E+02, 0.43900E+02,
     &  0.44000E+02, 0.44100E+02, 0.44200E+02, 0.44300E+02, 0.44400E+02,
     &  0.44500E+02, 0.44600E+02, 0.44700E+02, 0.44800E+02, 0.44900E+02,
     &  0.45000E+02, 0.45100E+02, 0.45200E+02, 0.45300E+02, 0.45400E+02,
     &  0.45500E+02, 0.45600E+02, 0.45700E+02, 0.45800E+02, 0.45900E+02,
     &  0.46000E+02, 0.46100E+02, 0.46200E+02, 0.46300E+02, 0.46400E+02,
     &  0.46500E+02, 0.46600E+02, 0.46700E+02, 0.46800E+02, 0.46900E+02,
     &  0.47000E+02, 0.47100E+02, 0.47200E+02, 0.47300E+02, 0.47400E+02,
     &  0.47500E+02, 0.47600E+02, 0.47700E+02, 0.47800E+02, 0.47900E+02,
     &  0.48000E+02, 0.48100E+02, 0.48200E+02, 0.48300E+02, 0.48400E+02,
     &  0.48500E+02, 0.48600E+02, 0.48700E+02, 0.48800E+02, 0.48900E+02,
     &  0.49000E+02, 0.49100E+02, 0.49200E+02, 0.49300E+02, 0.49400E+02,
     &  0.49500E+02, 0.49600E+02, 0.49700E+02, 0.49800E+02, 0.49900E+02,
     &  0.50000E+02, 0.50100E+02, 0.50200E+02, 0.50300E+02, 0.50400E+02,
     &  0.50500E+02, 0.50600E+02, 0.50700E+02, 0.50800E+02, 0.50900E+02,
     &  0.51000E+02, 0.51100E+02, 0.51200E+02, 0.51300E+02, 0.51400E+02,
     &  0.51500E+02, 0.51600E+02, 0.51700E+02, 0.51800E+02, 0.51900E+02,
     &  0.52000E+02, 0.52100E+02, 0.52200E+02, 0.52300E+02, 0.52400E+02,
     &  0.52500E+02, 0.52600E+02, 0.52700E+02, 0.52800E+02, 0.52900E+02,
     &  0.53000E+02, 0.53100E+02, 0.53200E+02, 0.53300E+02, 0.53400E+02,
     &  0.53500E+02, 0.53600E+02, 0.53700E+02, 0.53800E+02, 0.53900E+02,
     &  0.54000E+02, 0.54100E+02, 0.54200E+02, 0.54300E+02, 0.54400E+02,
     &  0.54500E+02, 0.54600E+02, 0.54700E+02, 0.54800E+02, 0.54900E+02,
     &  0.55000E+02, 0.55100E+02, 0.55200E+02, 0.55300E+02, 0.55400E+02,
     &  0.55500E+02, 0.55600E+02, 0.55700E+02, 0.55800E+02, 0.55900E+02,
     &  0.56000E+02, 0.56100E+02, 0.56200E+02, 0.56300E+02, 0.56400E+02,
     &  0.56500E+02, 0.56600E+02, 0.56700E+02, 0.56800E+02, 0.56900E+02,
     &  0.57000E+02, 0.57100E+02, 0.57200E+02, 0.57300E+02, 0.57400E+02,
     &  0.57500E+02, 0.57600E+02, 0.57700E+02, 0.57800E+02, 0.57900E+02,
     &  0.58000E+02, 0.58100E+02, 0.58200E+02, 0.58300E+02, 0.58400E+02,
     &  0.58500E+02, 0.58600E+02, 0.58700E+02, 0.58800E+02, 0.58900E+02,
     &  0.59000E+02, 0.59100E+02, 0.59200E+02, 0.59300E+02, 0.59400E+02,
     &  0.59500E+02, 0.59600E+02, 0.59700E+02, 0.59800E+02, 0.59900E+02,
     &  0.60000E+02, 0.60100E+02, 0.60200E+02, 0.60300E+02, 0.60400E+02,
     &  0.60500E+02, 0.60600E+02, 0.60700E+02, 0.60800E+02, 0.60900E+02,
     &  0.61000E+02, 0.61100E+02, 0.61200E+02, 0.61300E+02, 0.61400E+02,
     &  0.61500E+02, 0.61600E+02, 0.61700E+02, 0.61800E+02, 0.61900E+02,
     &  0.62000E+02, 0.62100E+02, 0.62200E+02, 0.62300E+02, 0.62400E+02,
     &  0.62500E+02, 0.62600E+02, 0.62700E+02, 0.62800E+02, 0.62900E+02,
     &  0.63000E+02, 0.63100E+02, 0.63200E+02, 0.63300E+02, 0.63400E+02,
     &  0.63500E+02, 0.63600E+02, 0.63700E+02, 0.63800E+02, 0.63900E+02,
     &  0.64000E+02, 0.64100E+02, 0.64200E+02, 0.64300E+02, 0.64400E+02,
     &  0.64500E+02, 0.64600E+02, 0.64700E+02, 0.64800E+02, 0.64900E+02,
     &  0.65000E+02, 0.65100E+02, 0.65200E+02, 0.65300E+02, 0.65400E+02,
     &  0.65500E+02, 0.65600E+02, 0.65700E+02, 0.65800E+02, 0.65900E+02,
     &  0.66000E+02, 0.66100E+02, 0.66200E+02, 0.66300E+02, 0.66400E+02,
     &  0.66500E+02, 0.66600E+02, 0.66700E+02, 0.66800E+02, 0.66900E+02,
     &  0.67000E+02, 0.67100E+02, 0.67200E+02, 0.67300E+02, 0.67400E+02,
     &  0.67500E+02, 0.67600E+02, 0.67700E+02, 0.67800E+02, 0.67900E+02,
     &  0.68000E+02, 0.68100E+02, 0.68200E+02, 0.68300E+02, 0.68400E+02,
     &  0.68500E+02, 0.68600E+02, 0.68700E+02, 0.68800E+02, 0.68900E+02,
     &  0.69000E+02, 0.69100E+02, 0.69200E+02, 0.69300E+02, 0.69400E+02,
     &  0.69500E+02, 0.69600E+02, 0.69700E+02, 0.69800E+02, 0.69900E+02,
     &  0.70000E+02, 0.70100E+02, 0.70200E+02, 0.70300E+02, 0.70400E+02,
     &  0.70500E+02, 0.70600E+02, 0.70700E+02, 0.70800E+02, 0.70900E+02,
     &  0.71000E+02, 0.71100E+02, 0.71200E+02, 0.71300E+02, 0.71400E+02,
     &  0.71500E+02, 0.71600E+02, 0.71700E+02, 0.71800E+02, 0.71900E+02,
     &  0.72000E+02, 0.72100E+02, 0.72200E+02, 0.72300E+02, 0.72400E+02,
     &  0.72500E+02, 0.72600E+02, 0.72700E+02, 0.72800E+02, 0.72900E+02,
     &  0.73000E+02, 0.73100E+02, 0.73200E+02, 0.73300E+02, 0.73400E+02,
     &  0.73500E+02, 0.73600E+02, 0.73700E+02, 0.73800E+02, 0.73900E+02,
     &  0.74000E+02, 0.74100E+02, 0.74200E+02, 0.74300E+02, 0.74400E+02,
     &  0.74500E+02, 0.74600E+02, 0.74700E+02, 0.74800E+02, 0.74900E+02,
     &  0.75000E+02, 0.75100E+02, 0.75200E+02, 0.75300E+02, 0.75400E+02,
     &  0.75500E+02, 0.75600E+02, 0.75700E+02, 0.75800E+02, 0.75900E+02,
     &  0.76000E+02, 0.76100E+02, 0.76200E+02, 0.76300E+02, 0.76400E+02,
     &  0.76500E+02, 0.76600E+02, 0.76700E+02, 0.76800E+02, 0.76900E+02,
     &  0.77000E+02, 0.77100E+02, 0.77200E+02, 0.77300E+02, 0.77400E+02,
     &  0.77500E+02, 0.77600E+02, 0.77700E+02, 0.77800E+02, 0.77900E+02,
     &  0.78000E+02, 0.78100E+02, 0.78200E+02, 0.78300E+02, 0.78400E+02,
     &  0.78500E+02, 0.78600E+02, 0.78700E+02, 0.78800E+02, 0.78900E+02,
     &  0.79000E+02, 0.79100E+02, 0.79200E+02, 0.79300E+02, 0.79400E+02,
     &  0.79500E+02, 0.79600E+02, 0.79700E+02, 0.79800E+02, 0.79900E+02,
     &  0.80000E+02, 0.80100E+02, 0.80200E+02, 0.80300E+02, 0.80400E+02,
     &  0.80500E+02, 0.80600E+02, 0.80700E+02, 0.80800E+02, 0.80900E+02,
     &  0.81000E+02, 0.81100E+02, 0.81200E+02, 0.81300E+02, 0.81400E+02,
     &  0.81500E+02, 0.81600E+02, 0.81700E+02, 0.81800E+02, 0.81900E+02,
     &  0.82000E+02, 0.82100E+02, 0.82200E+02, 0.82300E+02, 0.82400E+02,
     &  0.82500E+02, 0.82600E+02, 0.82700E+02, 0.82800E+02, 0.82900E+02,
     &  0.83000E+02, 0.83100E+02, 0.83200E+02, 0.83300E+02, 0.83400E+02,
     &  0.83500E+02, 0.83600E+02, 0.83700E+02, 0.83800E+02, 0.83900E+02,
     &  0.84000E+02, 0.84100E+02, 0.84200E+02, 0.84300E+02, 0.84400E+02,
     &  0.84500E+02, 0.84600E+02, 0.84700E+02, 0.84800E+02, 0.84900E+02,
     &  0.85000E+02, 0.85100E+02, 0.85200E+02, 0.85300E+02, 0.85400E+02,
     &  0.85500E+02, 0.85600E+02, 0.85700E+02, 0.85800E+02, 0.85900E+02,
     &  0.86000E+02, 0.86100E+02, 0.86200E+02, 0.86300E+02, 0.86400E+02,
     &  0.86500E+02, 0.86600E+02, 0.86700E+02, 0.86800E+02, 0.86900E+02,
     &  0.87000E+02, 0.87100E+02, 0.87200E+02, 0.87300E+02, 0.87400E+02,
     &  0.87500E+02, 0.87600E+02, 0.87700E+02, 0.87800E+02, 0.87900E+02,
     &  0.88000E+02, 0.88100E+02, 0.88200E+02, 0.88300E+02, 0.88400E+02,
     &  0.88500E+02, 0.88600E+02, 0.88700E+02, 0.88800E+02, 0.88900E+02,
     &  0.89000E+02, 0.89100E+02, 0.89200E+02, 0.89300E+02, 0.89400E+02,
     &  0.89500E+02, 0.89600E+02, 0.89700E+02, 0.89800E+02, 0.89900E+02,
     &  0.90000E+02, 0.90100E+02, 0.90200E+02, 0.90300E+02, 0.90400E+02,
     &  0.90500E+02, 0.90600E+02, 0.90700E+02, 0.90800E+02, 0.90900E+02,
     &  0.91000E+02, 0.91100E+02, 0.91200E+02, 0.91300E+02, 0.91400E+02,
     &  0.91500E+02, 0.91600E+02, 0.91700E+02, 0.91800E+02, 0.91900E+02,
     &  0.92000E+02, 0.92100E+02, 0.92200E+02, 0.92300E+02, 0.92400E+02,
     &  0.92500E+02, 0.92600E+02, 0.92700E+02, 0.92800E+02, 0.92900E+02,
     &  0.93000E+02, 0.93100E+02, 0.93200E+02, 0.93300E+02, 0.93400E+02,
     &  0.93500E+02, 0.93600E+02, 0.93700E+02, 0.93800E+02, 0.93900E+02,
     &  0.94000E+02, 0.94100E+02, 0.94200E+02, 0.94300E+02, 0.94400E+02,
     &  0.94500E+02, 0.94600E+02, 0.94700E+02, 0.94800E+02, 0.94900E+02,
     &  0.95000E+02, 0.95100E+02, 0.95200E+02, 0.95300E+02, 0.95400E+02,
     &  0.95500E+02, 0.95600E+02, 0.95700E+02, 0.95800E+02, 0.95900E+02,
     &  0.96000E+02, 0.96100E+02, 0.96200E+02, 0.96300E+02, 0.96400E+02,
     &  0.96500E+02, 0.96600E+02, 0.96700E+02, 0.96800E+02, 0.96900E+02,
     &  0.97000E+02, 0.97100E+02, 0.97200E+02, 0.97300E+02, 0.97400E+02,
     &  0.97500E+02, 0.97600E+02, 0.97700E+02, 0.97800E+02, 0.97900E+02,
     &  0.98000E+02, 0.98100E+02, 0.98200E+02, 0.98300E+02, 0.98400E+02,
     &  0.98500E+02, 0.98600E+02, 0.98700E+02, 0.98800E+02, 0.98900E+02,
     &  0.99000E+02, 0.99100E+02, 0.99200E+02, 0.99300E+02, 0.99400E+02,
     &  0.99500E+02,
     &  0.99600E+02,
     &  0.99700E+02,
     &  0.99800E+02,
     &  0.99900E+02,
     &  0.10000E+03/
      Data (idata(i),i=       1,     601)/
     &     31,    31,    33,    31,    31,    31,    31,    31,
     &     30,    30,    30,    30,    31,    30,    28,    28,
     &     29,    30,    28,    28,    29,    29,    29,    29,
     &     28,    29,    29,    30,    29,    29,    30,    31,
     &     31,    31,    31,    32,    32,    33,    33,    34,
     &     33,    33,    34,    33,    34,    34,    34,    32,
     &     32,    32,    32,    32,    32,    29,    28,    28,
     &     27,    27,    28,    29,    27,    25,    27,    25,
     &     26,    25,    26,    27,    28,    27,    28,    27,
     &     27,    27,    27,    27,    25,    28,    28,    29,
     &     28,    28,    27,    26,    25,    27,    26,    26,
     &     27,    26,    29,    30,    31,    31,    33,    33,
     &     33,    33,    31,    33,    33,    31,    34,    34,
     &     33,    33,    34,    33,    33,    32,    31,    31,
     &     33,    36,    35,    35,    36,    38,    37,    36,
     &     37,    36,    36,    37,    38,    37,    37,    36,
     &     37,    38,    37,    35,    35,    36,    36,    37,
     &     38,    40,    41,    41,    41,    40,    39,    38,
     &     37,    38,    39,    38,    38,    38,    38,    39,
     &     39,    41,    43,    42,    43,    44,    44,    45,
     &     43,    42,    43,    44,    45,    46,    46,    45,
     &     44,    46,    45,    44,    42,    41,    43,    42,
     &     44,    45,    45,    45,    45,    44,    45,    44,
     &     43,    44,    44,    44,    44,    45,    46,    48,
     &     48,    49,    48,    49,    48,    49,    48,    51,
     &     53,    54,    52,    53,    53,    55,    53,    53,
     &     54,    55,    54,    54,    55,    55,    55,    56,
     &     58,    60,    60,    60,    60,    59,    58,    60,
     &     61,    63,    62,    62,    60,    60,    60,    60,
     &     57,    57,    55,    56,    56,    56,    57,    59,
     &     59,    60,    61,    63,    63,    64,    62,    63,
     &     63,    61,    61,    62,    63,    63,    63,    61,
     &     59,    58,    57,    57,    58,    59,    58,    62,
     &     63,    64,    66,    67,    70,    72,    71,    72,
     &     73,    74,    73,    77,    78,    76,    75,    72,
     &     71,    69,    68,    69,    70,    71,    70,    71,
     &     69,    70,    72,    70,    69,    67,    71,    68,
     &     70,    70,    69,    71,    71,    69,    72,    70,
     &     68,    66,    66,    65,    60,    56,    53,    53,
     &     52,    51,    53,    51,    53,    53,    53,    54,
     &     53,    54,    55,    53,    50,    50,    53,    55,
     &     56,    54,    53,    53,    52,    53,    55,    57,
     &     57,    55,    54,    55,    58,    60,    59,    61,
     &     63,    64,    65,    65,    68,    68,    71,    74,
     &     76,    76,    77,    79,    81,    83,    87,    91,
     &     92,    91,    92,    95,    95,    98,    99,   102,
     &    106,   108,   106,   107,   109,   111,   114,   115,
     &    117,   119,   123,   124,   126,   127,   129,   131,
     &    132,   134,   136,   138,   140,   142,   142,   143,
     &    143,   144,   147,   147,   148,   147,   145,   142,
     &    142,   143,   144,   142,   141,   140,   141,   139,
     &    137,   135,   131,   130,   130,   127,   126,   123,
     &    123,   123,   124,   124,   121,   118,   117,   113,
     &    112,   107,   109,   109,   108,   106,   103,   103,
     &    103,   101,    98,    95,    92,    91,    92,    90,
     &     89,    86,    84,    81,    79,    75,    73,    72,
     &     72,    71,    70,    70,    70,    69,    68,    67,
     &     64,    63,    63,    62,    61,    61,    61,    60,
     &     62,    60,    57,    57,    57,    56,    57,    57,
     &     57,    57,    55,    54,    54,    53,    50,    48,
     &     49,    51,    52,    52,    51,    53,    52,    53,
     &     53,    54,    53,    51,    50,    52,    53,    53,
     &     54,    55,    59,    57,    60,    61,    59,    59,
     &     58,    58,    58,    59,    59,    55,    55,    54,
     &     53,    53,    53,    53,    51,    51,    50,    51,
     &     51,    51,    51,    53,    53,    52,    49,    51,
     &     50,    50,    49,    49,    48,    48,    47,    48,
     &     49,    49,    50,    51,    50,    49,    50,    50,
     &     48,    46,    46,    44,    45,    45,    44,    43,
     &     42,    42,    41,    44,    45,    44,    44,    43,
     &     42,    44,    44,    44,    44,    44,    45,    45,
     &     46,    47,    48,    49,    49,    50,    51,    51,
     &     52,    52,    54,    56,    59,    59,    61,    61,
     &     63,    63,    62,    64,    63,    63,    64,    64,
     &     63,
     &     64,
     &     64,
     &     65,
     &     65,
     &     63,
     &     67,
     &     65,
     &     67/
c
      massi = hmass(1)
      massx = hmass(npoint)
      dmass = (massx-massi)/Real(npoint-1)
c      
      imass = int( (mh-massi)/dmass ) + 1
c
      if (imass.eq.npoint) then
        imass = npoint
        jmass = npoint
        rmass = 0.0
      Endif
cjm Modifie le 24Fevrier
      If (imass.le.0 .or. imass.gt.npoint) then
        A189_HGG_CAND = 0
        RETURN
      Endif
      If (imass.ge.1..and.imass.lt.npoint) then
        jmass = imass + 1
        rmass = mh - hmass(imass)
      endif
      If ( mh*10. - Real(INT(mh*10.)) .ne.0. .and.debug) then
        Print*,
     &'Warning : Number of data is interpolated !!! (A189_HGG_CAND)'
      Endif
c
      A189_HGG_CAND = INT( Real(idata(imass))+Real(idata(jmass)
     &     -idata(imass))*rmass/dmass + 0.5)
c
      RETURN
      END
      Integer FUNCTION A192_HGG_CAND(mh,myich,debug)
      Implicit none
      Real mh
      Integer myich
      Logical debug
c
      Integer npoint
      Parameter (npoint=701)
      Real hmass(npoint),err
      Real massi,massx,dmass,rmass
      Integer i,imass,jmass,idata(npoint)
      Data (hmass(i),i=       1,     701)/
     &  0.40000E+02, 0.40100E+02, 0.40200E+02, 0.40300E+02, 0.40400E+02,
     &  0.40500E+02, 0.40600E+02, 0.40700E+02, 0.40800E+02, 0.40900E+02,
     &  0.41000E+02, 0.41100E+02, 0.41200E+02, 0.41300E+02, 0.41400E+02,
     &  0.41500E+02, 0.41600E+02, 0.41700E+02, 0.41800E+02, 0.41900E+02,
     &  0.42000E+02, 0.42100E+02, 0.42200E+02, 0.42300E+02, 0.42400E+02,
     &  0.42500E+02, 0.42600E+02, 0.42700E+02, 0.42800E+02, 0.42900E+02,
     &  0.43000E+02, 0.43100E+02, 0.43200E+02, 0.43300E+02, 0.43400E+02,
     &  0.43500E+02, 0.43600E+02, 0.43700E+02, 0.43800E+02, 0.43900E+02,
     &  0.44000E+02, 0.44100E+02, 0.44200E+02, 0.44300E+02, 0.44400E+02,
     &  0.44500E+02, 0.44600E+02, 0.44700E+02, 0.44800E+02, 0.44900E+02,
     &  0.45000E+02, 0.45100E+02, 0.45200E+02, 0.45300E+02, 0.45400E+02,
     &  0.45500E+02, 0.45600E+02, 0.45700E+02, 0.45800E+02, 0.45900E+02,
     &  0.46000E+02, 0.46100E+02, 0.46200E+02, 0.46300E+02, 0.46400E+02,
     &  0.46500E+02, 0.46600E+02, 0.46700E+02, 0.46800E+02, 0.46900E+02,
     &  0.47000E+02, 0.47100E+02, 0.47200E+02, 0.47300E+02, 0.47400E+02,
     &  0.47500E+02, 0.47600E+02, 0.47700E+02, 0.47800E+02, 0.47900E+02,
     &  0.48000E+02, 0.48100E+02, 0.48200E+02, 0.48300E+02, 0.48400E+02,
     &  0.48500E+02, 0.48600E+02, 0.48700E+02, 0.48800E+02, 0.48900E+02,
     &  0.49000E+02, 0.49100E+02, 0.49200E+02, 0.49300E+02, 0.49400E+02,
     &  0.49500E+02, 0.49600E+02, 0.49700E+02, 0.49800E+02, 0.49900E+02,
     &  0.50000E+02, 0.50100E+02, 0.50200E+02, 0.50300E+02, 0.50400E+02,
     &  0.50500E+02, 0.50600E+02, 0.50700E+02, 0.50800E+02, 0.50900E+02,
     &  0.51000E+02, 0.51100E+02, 0.51200E+02, 0.51300E+02, 0.51400E+02,
     &  0.51500E+02, 0.51600E+02, 0.51700E+02, 0.51800E+02, 0.51900E+02,
     &  0.52000E+02, 0.52100E+02, 0.52200E+02, 0.52300E+02, 0.52400E+02,
     &  0.52500E+02, 0.52600E+02, 0.52700E+02, 0.52800E+02, 0.52900E+02,
     &  0.53000E+02, 0.53100E+02, 0.53200E+02, 0.53300E+02, 0.53400E+02,
     &  0.53500E+02, 0.53600E+02, 0.53700E+02, 0.53800E+02, 0.53900E+02,
     &  0.54000E+02, 0.54100E+02, 0.54200E+02, 0.54300E+02, 0.54400E+02,
     &  0.54500E+02, 0.54600E+02, 0.54700E+02, 0.54800E+02, 0.54900E+02,
     &  0.55000E+02, 0.55100E+02, 0.55200E+02, 0.55300E+02, 0.55400E+02,
     &  0.55500E+02, 0.55600E+02, 0.55700E+02, 0.55800E+02, 0.55900E+02,
     &  0.56000E+02, 0.56100E+02, 0.56200E+02, 0.56300E+02, 0.56400E+02,
     &  0.56500E+02, 0.56600E+02, 0.56700E+02, 0.56800E+02, 0.56900E+02,
     &  0.57000E+02, 0.57100E+02, 0.57200E+02, 0.57300E+02, 0.57400E+02,
     &  0.57500E+02, 0.57600E+02, 0.57700E+02, 0.57800E+02, 0.57900E+02,
     &  0.58000E+02, 0.58100E+02, 0.58200E+02, 0.58300E+02, 0.58400E+02,
     &  0.58500E+02, 0.58600E+02, 0.58700E+02, 0.58800E+02, 0.58900E+02,
     &  0.59000E+02, 0.59100E+02, 0.59200E+02, 0.59300E+02, 0.59400E+02,
     &  0.59500E+02, 0.59600E+02, 0.59700E+02, 0.59800E+02, 0.59900E+02,
     &  0.60000E+02, 0.60100E+02, 0.60200E+02, 0.60300E+02, 0.60400E+02,
     &  0.60500E+02, 0.60600E+02, 0.60700E+02, 0.60800E+02, 0.60900E+02,
     &  0.61000E+02, 0.61100E+02, 0.61200E+02, 0.61300E+02, 0.61400E+02,
     &  0.61500E+02, 0.61600E+02, 0.61700E+02, 0.61800E+02, 0.61900E+02,
     &  0.62000E+02, 0.62100E+02, 0.62200E+02, 0.62300E+02, 0.62400E+02,
     &  0.62500E+02, 0.62600E+02, 0.62700E+02, 0.62800E+02, 0.62900E+02,
     &  0.63000E+02, 0.63100E+02, 0.63200E+02, 0.63300E+02, 0.63400E+02,
     &  0.63500E+02, 0.63600E+02, 0.63700E+02, 0.63800E+02, 0.63900E+02,
     &  0.64000E+02, 0.64100E+02, 0.64200E+02, 0.64300E+02, 0.64400E+02,
     &  0.64500E+02, 0.64600E+02, 0.64700E+02, 0.64800E+02, 0.64900E+02,
     &  0.65000E+02, 0.65100E+02, 0.65200E+02, 0.65300E+02, 0.65400E+02,
     &  0.65500E+02, 0.65600E+02, 0.65700E+02, 0.65800E+02, 0.65900E+02,
     &  0.66000E+02, 0.66100E+02, 0.66200E+02, 0.66300E+02, 0.66400E+02,
     &  0.66500E+02, 0.66600E+02, 0.66700E+02, 0.66800E+02, 0.66900E+02,
     &  0.67000E+02, 0.67100E+02, 0.67200E+02, 0.67300E+02, 0.67400E+02,
     &  0.67500E+02, 0.67600E+02, 0.67700E+02, 0.67800E+02, 0.67900E+02,
     &  0.68000E+02, 0.68100E+02, 0.68200E+02, 0.68300E+02, 0.68400E+02,
     &  0.68500E+02, 0.68600E+02, 0.68700E+02, 0.68800E+02, 0.68900E+02,
     &  0.69000E+02, 0.69100E+02, 0.69200E+02, 0.69300E+02, 0.69400E+02,
     &  0.69500E+02, 0.69600E+02, 0.69700E+02, 0.69800E+02, 0.69900E+02,
     &  0.70000E+02, 0.70100E+02, 0.70200E+02, 0.70300E+02, 0.70400E+02,
     &  0.70500E+02, 0.70600E+02, 0.70700E+02, 0.70800E+02, 0.70900E+02,
     &  0.71000E+02, 0.71100E+02, 0.71200E+02, 0.71300E+02, 0.71400E+02,
     &  0.71500E+02, 0.71600E+02, 0.71700E+02, 0.71800E+02, 0.71900E+02,
     &  0.72000E+02, 0.72100E+02, 0.72200E+02, 0.72300E+02, 0.72400E+02,
     &  0.72500E+02, 0.72600E+02, 0.72700E+02, 0.72800E+02, 0.72900E+02,
     &  0.73000E+02, 0.73100E+02, 0.73200E+02, 0.73300E+02, 0.73400E+02,
     &  0.73500E+02, 0.73600E+02, 0.73700E+02, 0.73800E+02, 0.73900E+02,
     &  0.74000E+02, 0.74100E+02, 0.74200E+02, 0.74300E+02, 0.74400E+02,
     &  0.74500E+02, 0.74600E+02, 0.74700E+02, 0.74800E+02, 0.74900E+02,
     &  0.75000E+02, 0.75100E+02, 0.75200E+02, 0.75300E+02, 0.75400E+02,
     &  0.75500E+02, 0.75600E+02, 0.75700E+02, 0.75800E+02, 0.75900E+02,
     &  0.76000E+02, 0.76100E+02, 0.76200E+02, 0.76300E+02, 0.76400E+02,
     &  0.76500E+02, 0.76600E+02, 0.76700E+02, 0.76800E+02, 0.76900E+02,
     &  0.77000E+02, 0.77100E+02, 0.77200E+02, 0.77300E+02, 0.77400E+02,
     &  0.77500E+02, 0.77600E+02, 0.77700E+02, 0.77800E+02, 0.77900E+02,
     &  0.78000E+02, 0.78100E+02, 0.78200E+02, 0.78300E+02, 0.78400E+02,
     &  0.78500E+02, 0.78600E+02, 0.78700E+02, 0.78800E+02, 0.78900E+02,
     &  0.79000E+02, 0.79100E+02, 0.79200E+02, 0.79300E+02, 0.79400E+02,
     &  0.79500E+02, 0.79600E+02, 0.79700E+02, 0.79800E+02, 0.79900E+02,
     &  0.80000E+02, 0.80100E+02, 0.80200E+02, 0.80300E+02, 0.80400E+02,
     &  0.80500E+02, 0.80600E+02, 0.80700E+02, 0.80800E+02, 0.80900E+02,
     &  0.81000E+02, 0.81100E+02, 0.81200E+02, 0.81300E+02, 0.81400E+02,
     &  0.81500E+02, 0.81600E+02, 0.81700E+02, 0.81800E+02, 0.81900E+02,
     &  0.82000E+02, 0.82100E+02, 0.82200E+02, 0.82300E+02, 0.82400E+02,
     &  0.82500E+02, 0.82600E+02, 0.82700E+02, 0.82800E+02, 0.82900E+02,
     &  0.83000E+02, 0.83100E+02, 0.83200E+02, 0.83300E+02, 0.83400E+02,
     &  0.83500E+02, 0.83600E+02, 0.83700E+02, 0.83800E+02, 0.83900E+02,
     &  0.84000E+02, 0.84100E+02, 0.84200E+02, 0.84300E+02, 0.84400E+02,
     &  0.84500E+02, 0.84600E+02, 0.84700E+02, 0.84800E+02, 0.84900E+02,
     &  0.85000E+02, 0.85100E+02, 0.85200E+02, 0.85300E+02, 0.85400E+02,
     &  0.85500E+02, 0.85600E+02, 0.85700E+02, 0.85800E+02, 0.85900E+02,
     &  0.86000E+02, 0.86100E+02, 0.86200E+02, 0.86300E+02, 0.86400E+02,
     &  0.86500E+02, 0.86600E+02, 0.86700E+02, 0.86800E+02, 0.86900E+02,
     &  0.87000E+02, 0.87100E+02, 0.87200E+02, 0.87300E+02, 0.87400E+02,
     &  0.87500E+02, 0.87600E+02, 0.87700E+02, 0.87800E+02, 0.87900E+02,
     &  0.88000E+02, 0.88100E+02, 0.88200E+02, 0.88300E+02, 0.88400E+02,
     &  0.88500E+02, 0.88600E+02, 0.88700E+02, 0.88800E+02, 0.88900E+02,
     &  0.89000E+02, 0.89100E+02, 0.89200E+02, 0.89300E+02, 0.89400E+02,
     &  0.89500E+02, 0.89600E+02, 0.89700E+02, 0.89800E+02, 0.89900E+02,
     &  0.90000E+02, 0.90100E+02, 0.90200E+02, 0.90300E+02, 0.90400E+02,
     &  0.90500E+02, 0.90600E+02, 0.90700E+02, 0.90800E+02, 0.90900E+02,
     &  0.91000E+02, 0.91100E+02, 0.91200E+02, 0.91300E+02, 0.91400E+02,
     &  0.91500E+02, 0.91600E+02, 0.91700E+02, 0.91800E+02, 0.91900E+02,
     &  0.92000E+02, 0.92100E+02, 0.92200E+02, 0.92300E+02, 0.92400E+02,
     &  0.92500E+02, 0.92600E+02, 0.92700E+02, 0.92800E+02, 0.92900E+02,
     &  0.93000E+02, 0.93100E+02, 0.93200E+02, 0.93300E+02, 0.93400E+02,
     &  0.93500E+02, 0.93600E+02, 0.93700E+02, 0.93800E+02, 0.93900E+02,
     &  0.94000E+02, 0.94100E+02, 0.94200E+02, 0.94300E+02, 0.94400E+02,
     &  0.94500E+02, 0.94600E+02, 0.94700E+02, 0.94800E+02, 0.94900E+02,
     &  0.95000E+02, 0.95100E+02, 0.95200E+02, 0.95300E+02, 0.95400E+02,
     &  0.95500E+02, 0.95600E+02, 0.95700E+02, 0.95800E+02, 0.95900E+02,
     &  0.96000E+02, 0.96100E+02, 0.96200E+02, 0.96300E+02, 0.96400E+02,
     &  0.96500E+02, 0.96600E+02, 0.96700E+02, 0.96800E+02, 0.96900E+02,
     &  0.97000E+02, 0.97100E+02, 0.97200E+02, 0.97300E+02, 0.97400E+02,
     &  0.97500E+02, 0.97600E+02, 0.97700E+02, 0.97800E+02, 0.97900E+02,
     &  0.98000E+02, 0.98100E+02, 0.98200E+02, 0.98300E+02, 0.98400E+02,
     &  0.98500E+02, 0.98600E+02, 0.98700E+02, 0.98800E+02, 0.98900E+02,
     &  0.99000E+02, 0.99100E+02, 0.99200E+02, 0.99300E+02, 0.99400E+02,
     &  0.99500E+02, 0.99600E+02, 0.99700E+02, 0.99800E+02, 0.99900E+02,
     &  0.10000E+03, 0.10010E+03, 0.10020E+03, 0.10030E+03, 0.10040E+03,
     &  0.10050E+03, 0.10060E+03, 0.10070E+03, 0.10080E+03, 0.10090E+03,
     &  0.10100E+03, 0.10110E+03, 0.10120E+03, 0.10130E+03, 0.10140E+03,
     &  0.10150E+03, 0.10160E+03, 0.10170E+03, 0.10180E+03, 0.10190E+03,
     &  0.10200E+03, 0.10210E+03, 0.10220E+03, 0.10230E+03, 0.10240E+03,
     &  0.10250E+03, 0.10260E+03, 0.10270E+03, 0.10280E+03, 0.10290E+03,
     &  0.10300E+03, 0.10310E+03, 0.10320E+03, 0.10330E+03, 0.10340E+03,
     &  0.10350E+03, 0.10360E+03, 0.10370E+03, 0.10380E+03, 0.10390E+03,
     &  0.10400E+03, 0.10410E+03, 0.10420E+03, 0.10430E+03, 0.10440E+03,
     &  0.10450E+03, 0.10460E+03, 0.10470E+03, 0.10480E+03, 0.10490E+03,
     &  0.10500E+03, 0.10510E+03, 0.10520E+03, 0.10530E+03, 0.10540E+03,
     &  0.10550E+03, 0.10560E+03, 0.10570E+03, 0.10580E+03, 0.10590E+03,
     &  0.10600E+03, 0.10610E+03, 0.10620E+03, 0.10630E+03, 0.10640E+03,
     &  0.10650E+03, 0.10660E+03, 0.10670E+03, 0.10680E+03, 0.10690E+03,
     &  0.10700E+03, 0.10710E+03, 0.10720E+03, 0.10730E+03, 0.10740E+03,
     &  0.10750E+03, 0.10760E+03, 0.10770E+03, 0.10780E+03, 0.10790E+03,
     &  0.10800E+03, 0.10810E+03, 0.10820E+03, 0.10830E+03, 0.10840E+03,
     &  0.10850E+03, 0.10860E+03, 0.10870E+03, 0.10880E+03, 0.10890E+03,
     &  0.10900E+03, 0.10910E+03, 0.10920E+03, 0.10930E+03, 0.10940E+03,
     &  0.10950E+03,
     &  0.10960E+03,
     &  0.10970E+03,
     &  0.10980E+03,
     &  0.10990E+03,
     &  0.11000E+03/
      Data (idata(i),i=       1,     701)/
     &      6,     6,     5,     5,     5,     5,     5,     5,
     &      6,     7,     7,     8,     8,     8,     8,     8,
     &      8,     8,     8,     8,     8,     8,     8,     8,
     &      8,     8,     8,     8,     8,     7,     7,     7,
     &      7,     7,     7,     7,     7,     7,     7,     7,
     &      7,     7,     7,     7,     7,     7,     7,     6,
     &      6,     6,     6,     6,     6,     6,     5,     5,
     &      5,     5,     5,     4,     4,     4,     3,     3,
     &      2,     3,     4,     4,     4,     4,     4,     4,
     &      4,     4,     5,     5,     5,     5,     5,     6,
     &      6,     6,     6,     6,     6,     6,     5,     5,
     &      5,     5,     5,     5,     4,     4,     5,     5,
     &      5,     5,     4,     4,     3,     3,     3,     3,
     &      3,     3,     4,     4,     4,     5,     5,     5,
     &      5,     5,     6,     6,     6,     6,     6,     6,
     &      6,     6,     6,     6,     6,     6,     7,     7,
     &      6,     6,     6,     6,     6,     6,     6,     6,
     &      6,     5,     5,     5,     5,     6,     6,     6,
     &      7,     7,     7,     8,     8,     8,     8,     8,
     &      8,     8,     8,     8,     7,     7,     7,     8,
     &      7,     7,     7,     7,     7,     7,     7,     5,
     &      5,     5,     5,     5,     6,     6,     6,     6,
     &      6,     6,     7,     7,     7,     7,     7,     6,
     &      6,     6,     6,     6,     6,     6,     6,     6,
     &      6,     6,     6,     6,     7,     7,     7,     7,
     &      7,     7,     7,     7,     7,     7,     7,     6,
     &      6,     6,     5,     6,     6,     6,     6,     6,
     &      6,     6,     6,     6,     6,     6,     6,     6,
     &      6,     6,     6,     7,     7,     7,     5,     5,
     &      5,     5,     5,     5,     5,     5,     5,     5,
     &      5,     5,     5,     6,     6,     6,     6,     6,
     &      7,     8,     8,     9,     9,     9,     9,     8,
     &      9,     9,     9,     9,     9,     9,     9,     8,
     &      8,     9,     9,    10,    11,    10,    11,    12,
     &     12,    12,    12,    12,    12,    12,    12,    12,
     &     12,    12,    12,    11,    11,    12,    12,    13,
     &     14,    14,    14,    14,    15,    15,    16,    18,
     &     18,    18,    18,    18,    19,    21,    22,    22,
     &     21,    20,    20,    20,    20,    20,    20,    20,
     &     20,    17,    17,    16,    16,    16,    16,    15,
     &     13,    13,    12,    12,    12,    12,    13,    14,
     &     14,    15,    15,    14,    16,    16,    16,    17,
     &     16,    16,    16,    16,    18,    18,    16,    16,
     &     16,    16,    17,    17,    17,    18,    18,    17,
     &     17,    18,    19,    18,    18,    18,    19,    19,
     &     18,    19,    19,    19,    19,    19,    19,    20,
     &     20,    22,    22,    22,    21,    21,    20,    20,
     &     20,    20,    20,    19,    20,    21,    21,    21,
     &     21,    22,    22,    23,    23,    22,    22,    22,
     &     22,    23,    23,    22,    22,    22,    22,    23,
     &     21,    20,    20,    21,    20,    20,    20,    19,
     &     19,    19,    19,    18,    18,    18,    16,    15,
     &     15,    15,    15,    14,    14,    14,    14,    15,
     &     16,    16,    17,    17,    17,    17,    18,    19,
     &     19,    19,    19,    18,    17,    17,    17,    17,
     &     17,    18,    18,    19,    19,    20,    21,    19,
     &     20,    20,    20,    20,    20,    20,    20,    20,
     &     20,    20,    19,    19,    18,    18,    18,    19,
     &     19,    19,    18,    18,    18,    18,    16,    15,
     &     13,    12,    11,    11,    11,    11,    11,    11,
     &     11,    11,    12,    12,    12,    12,    12,    12,
     &     11,    10,    10,    10,    10,    10,    10,    10,
     &     10,    10,    10,    10,    10,    11,    11,    11,
     &     11,    11,    11,    11,    11,    11,    12,    12,
     &     12,    11,    11,    10,    10,    10,    11,    11,
     &     11,    11,    11,    12,    11,    10,     9,     9,
     &      9,    10,    10,    10,    10,    10,    10,    10,
     &     10,    10,    10,     9,     9,     9,     9,     9,
     &      9,     9,     8,     8,     8,     8,     7,     7,
     &      7,     6,     5,     6,     6,     6,     6,     6,
     &      6,     6,     5,     5,     5,     5,     5,     6,
     &      6,     6,     6,     6,     6,     6,     6,     6,
     &      6,     6,     6,     6,     6,     5,     5,     5,
     &      5,     5,     5,     5,     5,     5,     5,     5,
     &      5,     5,     4,     4,     4,     4,     3,     3,
     &      2,     2,     2,     2,     2,     1,     1,     1,
     &      1,     1,     1,     1,     1,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,
     &      0,
     &      0,
     &      0,
     &      0/
c
      massi = hmass(1)
      massx = hmass(npoint)
      dmass = (massx-massi)/Real(npoint-1)
c      
      imass = int( (mh-massi)/dmass ) + 1
c
      if (imass.eq.npoint) then
        imass = npoint
        jmass = npoint
        rmass = 0.0
      Endif
cjm Modifie le 24Fevrier
      If (imass.le.0 .or. imass.gt.npoint) then
        A192_HGG_CAND = 0
        RETURN
      Endif
      If (imass.ge.1..and.imass.lt.npoint) then
        jmass = imass + 1
        rmass = mh - hmass(imass)
      endif
      If ( mh*10. - Real(INT(mh*10.)) .ne.0. .and.debug) then
        Print*,
     &'Warning : Number of data is interpolated !!! (A192_HGG_CAND)'
      Endif
c
      A192_HGG_CAND = INT( Real(idata(imass))+Real(idata(jmass)
     &     -idata(imass))*rmass/dmass + 0.5)
c
      RETURN
      END
      Integer FUNCTION A196_HGG_CAND(mh,myich,debug)
      Implicit none
      Real mh
      Integer myich
      Logical debug
c
      Integer npoint
      Parameter (npoint=701)
      Real hmass(npoint),err
      Real massi,massx,dmass,rmass
      Integer i,imass,jmass,idata(npoint)
      Data (hmass(i),i=       1,     701)/
     &  0.40000E+02, 0.40100E+02, 0.40200E+02, 0.40300E+02, 0.40400E+02,
     &  0.40500E+02, 0.40600E+02, 0.40700E+02, 0.40800E+02, 0.40900E+02,
     &  0.41000E+02, 0.41100E+02, 0.41200E+02, 0.41300E+02, 0.41400E+02,
     &  0.41500E+02, 0.41600E+02, 0.41700E+02, 0.41800E+02, 0.41900E+02,
     &  0.42000E+02, 0.42100E+02, 0.42200E+02, 0.42300E+02, 0.42400E+02,
     &  0.42500E+02, 0.42600E+02, 0.42700E+02, 0.42800E+02, 0.42900E+02,
     &  0.43000E+02, 0.43100E+02, 0.43200E+02, 0.43300E+02, 0.43400E+02,
     &  0.43500E+02, 0.43600E+02, 0.43700E+02, 0.43800E+02, 0.43900E+02,
     &  0.44000E+02, 0.44100E+02, 0.44200E+02, 0.44300E+02, 0.44400E+02,
     &  0.44500E+02, 0.44600E+02, 0.44700E+02, 0.44800E+02, 0.44900E+02,
     &  0.45000E+02, 0.45100E+02, 0.45200E+02, 0.45300E+02, 0.45400E+02,
     &  0.45500E+02, 0.45600E+02, 0.45700E+02, 0.45800E+02, 0.45900E+02,
     &  0.46000E+02, 0.46100E+02, 0.46200E+02, 0.46300E+02, 0.46400E+02,
     &  0.46500E+02, 0.46600E+02, 0.46700E+02, 0.46800E+02, 0.46900E+02,
     &  0.47000E+02, 0.47100E+02, 0.47200E+02, 0.47300E+02, 0.47400E+02,
     &  0.47500E+02, 0.47600E+02, 0.47700E+02, 0.47800E+02, 0.47900E+02,
     &  0.48000E+02, 0.48100E+02, 0.48200E+02, 0.48300E+02, 0.48400E+02,
     &  0.48500E+02, 0.48600E+02, 0.48700E+02, 0.48800E+02, 0.48900E+02,
     &  0.49000E+02, 0.49100E+02, 0.49200E+02, 0.49300E+02, 0.49400E+02,
     &  0.49500E+02, 0.49600E+02, 0.49700E+02, 0.49800E+02, 0.49900E+02,
     &  0.50000E+02, 0.50100E+02, 0.50200E+02, 0.50300E+02, 0.50400E+02,
     &  0.50500E+02, 0.50600E+02, 0.50700E+02, 0.50800E+02, 0.50900E+02,
     &  0.51000E+02, 0.51100E+02, 0.51200E+02, 0.51300E+02, 0.51400E+02,
     &  0.51500E+02, 0.51600E+02, 0.51700E+02, 0.51800E+02, 0.51900E+02,
     &  0.52000E+02, 0.52100E+02, 0.52200E+02, 0.52300E+02, 0.52400E+02,
     &  0.52500E+02, 0.52600E+02, 0.52700E+02, 0.52800E+02, 0.52900E+02,
     &  0.53000E+02, 0.53100E+02, 0.53200E+02, 0.53300E+02, 0.53400E+02,
     &  0.53500E+02, 0.53600E+02, 0.53700E+02, 0.53800E+02, 0.53900E+02,
     &  0.54000E+02, 0.54100E+02, 0.54200E+02, 0.54300E+02, 0.54400E+02,
     &  0.54500E+02, 0.54600E+02, 0.54700E+02, 0.54800E+02, 0.54900E+02,
     &  0.55000E+02, 0.55100E+02, 0.55200E+02, 0.55300E+02, 0.55400E+02,
     &  0.55500E+02, 0.55600E+02, 0.55700E+02, 0.55800E+02, 0.55900E+02,
     &  0.56000E+02, 0.56100E+02, 0.56200E+02, 0.56300E+02, 0.56400E+02,
     &  0.56500E+02, 0.56600E+02, 0.56700E+02, 0.56800E+02, 0.56900E+02,
     &  0.57000E+02, 0.57100E+02, 0.57200E+02, 0.57300E+02, 0.57400E+02,
     &  0.57500E+02, 0.57600E+02, 0.57700E+02, 0.57800E+02, 0.57900E+02,
     &  0.58000E+02, 0.58100E+02, 0.58200E+02, 0.58300E+02, 0.58400E+02,
     &  0.58500E+02, 0.58600E+02, 0.58700E+02, 0.58800E+02, 0.58900E+02,
     &  0.59000E+02, 0.59100E+02, 0.59200E+02, 0.59300E+02, 0.59400E+02,
     &  0.59500E+02, 0.59600E+02, 0.59700E+02, 0.59800E+02, 0.59900E+02,
     &  0.60000E+02, 0.60100E+02, 0.60200E+02, 0.60300E+02, 0.60400E+02,
     &  0.60500E+02, 0.60600E+02, 0.60700E+02, 0.60800E+02, 0.60900E+02,
     &  0.61000E+02, 0.61100E+02, 0.61200E+02, 0.61300E+02, 0.61400E+02,
     &  0.61500E+02, 0.61600E+02, 0.61700E+02, 0.61800E+02, 0.61900E+02,
     &  0.62000E+02, 0.62100E+02, 0.62200E+02, 0.62300E+02, 0.62400E+02,
     &  0.62500E+02, 0.62600E+02, 0.62700E+02, 0.62800E+02, 0.62900E+02,
     &  0.63000E+02, 0.63100E+02, 0.63200E+02, 0.63300E+02, 0.63400E+02,
     &  0.63500E+02, 0.63600E+02, 0.63700E+02, 0.63800E+02, 0.63900E+02,
     &  0.64000E+02, 0.64100E+02, 0.64200E+02, 0.64300E+02, 0.64400E+02,
     &  0.64500E+02, 0.64600E+02, 0.64700E+02, 0.64800E+02, 0.64900E+02,
     &  0.65000E+02, 0.65100E+02, 0.65200E+02, 0.65300E+02, 0.65400E+02,
     &  0.65500E+02, 0.65600E+02, 0.65700E+02, 0.65800E+02, 0.65900E+02,
     &  0.66000E+02, 0.66100E+02, 0.66200E+02, 0.66300E+02, 0.66400E+02,
     &  0.66500E+02, 0.66600E+02, 0.66700E+02, 0.66800E+02, 0.66900E+02,
     &  0.67000E+02, 0.67100E+02, 0.67200E+02, 0.67300E+02, 0.67400E+02,
     &  0.67500E+02, 0.67600E+02, 0.67700E+02, 0.67800E+02, 0.67900E+02,
     &  0.68000E+02, 0.68100E+02, 0.68200E+02, 0.68300E+02, 0.68400E+02,
     &  0.68500E+02, 0.68600E+02, 0.68700E+02, 0.68800E+02, 0.68900E+02,
     &  0.69000E+02, 0.69100E+02, 0.69200E+02, 0.69300E+02, 0.69400E+02,
     &  0.69500E+02, 0.69600E+02, 0.69700E+02, 0.69800E+02, 0.69900E+02,
     &  0.70000E+02, 0.70100E+02, 0.70200E+02, 0.70300E+02, 0.70400E+02,
     &  0.70500E+02, 0.70600E+02, 0.70700E+02, 0.70800E+02, 0.70900E+02,
     &  0.71000E+02, 0.71100E+02, 0.71200E+02, 0.71300E+02, 0.71400E+02,
     &  0.71500E+02, 0.71600E+02, 0.71700E+02, 0.71800E+02, 0.71900E+02,
     &  0.72000E+02, 0.72100E+02, 0.72200E+02, 0.72300E+02, 0.72400E+02,
     &  0.72500E+02, 0.72600E+02, 0.72700E+02, 0.72800E+02, 0.72900E+02,
     &  0.73000E+02, 0.73100E+02, 0.73200E+02, 0.73300E+02, 0.73400E+02,
     &  0.73500E+02, 0.73600E+02, 0.73700E+02, 0.73800E+02, 0.73900E+02,
     &  0.74000E+02, 0.74100E+02, 0.74200E+02, 0.74300E+02, 0.74400E+02,
     &  0.74500E+02, 0.74600E+02, 0.74700E+02, 0.74800E+02, 0.74900E+02,
     &  0.75000E+02, 0.75100E+02, 0.75200E+02, 0.75300E+02, 0.75400E+02,
     &  0.75500E+02, 0.75600E+02, 0.75700E+02, 0.75800E+02, 0.75900E+02,
     &  0.76000E+02, 0.76100E+02, 0.76200E+02, 0.76300E+02, 0.76400E+02,
     &  0.76500E+02, 0.76600E+02, 0.76700E+02, 0.76800E+02, 0.76900E+02,
     &  0.77000E+02, 0.77100E+02, 0.77200E+02, 0.77300E+02, 0.77400E+02,
     &  0.77500E+02, 0.77600E+02, 0.77700E+02, 0.77800E+02, 0.77900E+02,
     &  0.78000E+02, 0.78100E+02, 0.78200E+02, 0.78300E+02, 0.78400E+02,
     &  0.78500E+02, 0.78600E+02, 0.78700E+02, 0.78800E+02, 0.78900E+02,
     &  0.79000E+02, 0.79100E+02, 0.79200E+02, 0.79300E+02, 0.79400E+02,
     &  0.79500E+02, 0.79600E+02, 0.79700E+02, 0.79800E+02, 0.79900E+02,
     &  0.80000E+02, 0.80100E+02, 0.80200E+02, 0.80300E+02, 0.80400E+02,
     &  0.80500E+02, 0.80600E+02, 0.80700E+02, 0.80800E+02, 0.80900E+02,
     &  0.81000E+02, 0.81100E+02, 0.81200E+02, 0.81300E+02, 0.81400E+02,
     &  0.81500E+02, 0.81600E+02, 0.81700E+02, 0.81800E+02, 0.81900E+02,
     &  0.82000E+02, 0.82100E+02, 0.82200E+02, 0.82300E+02, 0.82400E+02,
     &  0.82500E+02, 0.82600E+02, 0.82700E+02, 0.82800E+02, 0.82900E+02,
     &  0.83000E+02, 0.83100E+02, 0.83200E+02, 0.83300E+02, 0.83400E+02,
     &  0.83500E+02, 0.83600E+02, 0.83700E+02, 0.83800E+02, 0.83900E+02,
     &  0.84000E+02, 0.84100E+02, 0.84200E+02, 0.84300E+02, 0.84400E+02,
     &  0.84500E+02, 0.84600E+02, 0.84700E+02, 0.84800E+02, 0.84900E+02,
     &  0.85000E+02, 0.85100E+02, 0.85200E+02, 0.85300E+02, 0.85400E+02,
     &  0.85500E+02, 0.85600E+02, 0.85700E+02, 0.85800E+02, 0.85900E+02,
     &  0.86000E+02, 0.86100E+02, 0.86200E+02, 0.86300E+02, 0.86400E+02,
     &  0.86500E+02, 0.86600E+02, 0.86700E+02, 0.86800E+02, 0.86900E+02,
     &  0.87000E+02, 0.87100E+02, 0.87200E+02, 0.87300E+02, 0.87400E+02,
     &  0.87500E+02, 0.87600E+02, 0.87700E+02, 0.87800E+02, 0.87900E+02,
     &  0.88000E+02, 0.88100E+02, 0.88200E+02, 0.88300E+02, 0.88400E+02,
     &  0.88500E+02, 0.88600E+02, 0.88700E+02, 0.88800E+02, 0.88900E+02,
     &  0.89000E+02, 0.89100E+02, 0.89200E+02, 0.89300E+02, 0.89400E+02,
     &  0.89500E+02, 0.89600E+02, 0.89700E+02, 0.89800E+02, 0.89900E+02,
     &  0.90000E+02, 0.90100E+02, 0.90200E+02, 0.90300E+02, 0.90400E+02,
     &  0.90500E+02, 0.90600E+02, 0.90700E+02, 0.90800E+02, 0.90900E+02,
     &  0.91000E+02, 0.91100E+02, 0.91200E+02, 0.91300E+02, 0.91400E+02,
     &  0.91500E+02, 0.91600E+02, 0.91700E+02, 0.91800E+02, 0.91900E+02,
     &  0.92000E+02, 0.92100E+02, 0.92200E+02, 0.92300E+02, 0.92400E+02,
     &  0.92500E+02, 0.92600E+02, 0.92700E+02, 0.92800E+02, 0.92900E+02,
     &  0.93000E+02, 0.93100E+02, 0.93200E+02, 0.93300E+02, 0.93400E+02,
     &  0.93500E+02, 0.93600E+02, 0.93700E+02, 0.93800E+02, 0.93900E+02,
     &  0.94000E+02, 0.94100E+02, 0.94200E+02, 0.94300E+02, 0.94400E+02,
     &  0.94500E+02, 0.94600E+02, 0.94700E+02, 0.94800E+02, 0.94900E+02,
     &  0.95000E+02, 0.95100E+02, 0.95200E+02, 0.95300E+02, 0.95400E+02,
     &  0.95500E+02, 0.95600E+02, 0.95700E+02, 0.95800E+02, 0.95900E+02,
     &  0.96000E+02, 0.96100E+02, 0.96200E+02, 0.96300E+02, 0.96400E+02,
     &  0.96500E+02, 0.96600E+02, 0.96700E+02, 0.96800E+02, 0.96900E+02,
     &  0.97000E+02, 0.97100E+02, 0.97200E+02, 0.97300E+02, 0.97400E+02,
     &  0.97500E+02, 0.97600E+02, 0.97700E+02, 0.97800E+02, 0.97900E+02,
     &  0.98000E+02, 0.98100E+02, 0.98200E+02, 0.98300E+02, 0.98400E+02,
     &  0.98500E+02, 0.98600E+02, 0.98700E+02, 0.98800E+02, 0.98900E+02,
     &  0.99000E+02, 0.99100E+02, 0.99200E+02, 0.99300E+02, 0.99400E+02,
     &  0.99500E+02, 0.99600E+02, 0.99700E+02, 0.99800E+02, 0.99900E+02,
     &  0.10000E+03, 0.10010E+03, 0.10020E+03, 0.10030E+03, 0.10040E+03,
     &  0.10050E+03, 0.10060E+03, 0.10070E+03, 0.10080E+03, 0.10090E+03,
     &  0.10100E+03, 0.10110E+03, 0.10120E+03, 0.10130E+03, 0.10140E+03,
     &  0.10150E+03, 0.10160E+03, 0.10170E+03, 0.10180E+03, 0.10190E+03,
     &  0.10200E+03, 0.10210E+03, 0.10220E+03, 0.10230E+03, 0.10240E+03,
     &  0.10250E+03, 0.10260E+03, 0.10270E+03, 0.10280E+03, 0.10290E+03,
     &  0.10300E+03, 0.10310E+03, 0.10320E+03, 0.10330E+03, 0.10340E+03,
     &  0.10350E+03, 0.10360E+03, 0.10370E+03, 0.10380E+03, 0.10390E+03,
     &  0.10400E+03, 0.10410E+03, 0.10420E+03, 0.10430E+03, 0.10440E+03,
     &  0.10450E+03, 0.10460E+03, 0.10470E+03, 0.10480E+03, 0.10490E+03,
     &  0.10500E+03, 0.10510E+03, 0.10520E+03, 0.10530E+03, 0.10540E+03,
     &  0.10550E+03, 0.10560E+03, 0.10570E+03, 0.10580E+03, 0.10590E+03,
     &  0.10600E+03, 0.10610E+03, 0.10620E+03, 0.10630E+03, 0.10640E+03,
     &  0.10650E+03, 0.10660E+03, 0.10670E+03, 0.10680E+03, 0.10690E+03,
     &  0.10700E+03, 0.10710E+03, 0.10720E+03, 0.10730E+03, 0.10740E+03,
     &  0.10750E+03, 0.10760E+03, 0.10770E+03, 0.10780E+03, 0.10790E+03,
     &  0.10800E+03, 0.10810E+03, 0.10820E+03, 0.10830E+03, 0.10840E+03,
     &  0.10850E+03, 0.10860E+03, 0.10870E+03, 0.10880E+03, 0.10890E+03,
     &  0.10900E+03, 0.10910E+03, 0.10920E+03, 0.10930E+03, 0.10940E+03,
     &  0.10950E+03,
     &  0.10960E+03,
     &  0.10970E+03,
     &  0.10980E+03,
     &  0.10990E+03,
     &  0.11000E+03/
      Data (idata(i),i=       1,     701)/
     &     22,    22,    22,    22,    22,    22,    22,    22,
     &     19,    18,    18,    18,    18,    18,    17,    19,
     &     19,    20,    19,    20,    20,    19,    20,    21,
     &     21,    20,    19,    19,    18,    18,    18,    19,
     &     17,    16,    17,    15,    16,    16,    16,    16,
     &     16,    16,    16,    16,    14,    14,    13,    13,
     &     13,    13,    12,    12,    12,    12,    12,    12,
     &     11,    11,    12,    13,    14,    14,    15,    15,
     &     15,    16,    16,    16,    17,    17,    17,    16,
     &     15,    15,    15,    15,    15,    15,    15,    15,
     &     15,    14,    14,    14,    15,    15,    14,    11,
     &     11,    12,    12,    12,    12,    13,    11,    12,
     &     12,    11,    11,    11,    11,    13,    13,    12,
     &     12,    13,    13,    13,    14,    14,    14,    14,
     &     15,    14,    14,    14,    15,    15,    16,    16,
     &     15,    15,    15,    15,    15,    15,    14,    14,
     &     13,    13,    14,    13,    13,    13,    13,    12,
     &     12,    12,    12,    11,    12,    11,    14,    15,
     &     14,    15,    16,    17,    17,    17,    17,    17,
     &     17,    16,    16,    16,    16,    14,    14,    13,
     &     13,    13,    13,    14,    14,    14,    14,    14,
     &     13,    12,    12,    12,    13,    12,    12,    12,
     &     11,    12,    14,    14,    14,    14,    14,    15,
     &     15,    15,    15,    15,    16,    16,    17,    17,
     &     17,    17,    17,    18,    18,    19,    20,    20,
     &     20,    20,    20,    19,    19,    19,    19,    19,
     &     18,    16,    17,    17,    15,    15,    15,    15,
     &     16,    17,    17,    17,    17,    16,    16,    16,
     &     14,    14,    13,    13,    12,    11,    10,    10,
     &     10,    11,    11,    11,    11,    13,    13,    14,
     &     14,    15,    13,    13,    12,    13,    13,    13,
     &     14,    14,    14,    15,    16,    15,    15,    15,
     &     15,    15,    15,    15,    16,    16,    16,    16,
     &     17,    17,    18,    19,    21,    21,    21,    21,
     &     21,    22,    22,    22,    23,    25,    25,    25,
     &     26,    26,    26,    26,    26,    28,    27,    27,
     &     27,    27,    28,    30,    30,    31,    29,    28,
     &     29,    28,    27,    31,    32,    31,    30,    29,
     &     29,    29,    28,    28,    29,    28,    29,    29,
     &     30,    31,    31,    31,    33,    33,    33,    33,
     &     33,    33,    31,    31,    31,    30,    28,    29,
     &     28,    29,    30,    30,    31,    31,    31,    31,
     &     32,    32,    31,    31,    31,    30,    31,    33,
     &     32,    31,    31,    32,    32,    33,    33,    33,
     &     32,    32,    33,    35,    36,    36,    36,    35,
     &     37,    37,    39,    39,    39,    41,    42,    41,
     &     42,    40,    40,    40,    40,    41,    41,    44,
     &     44,    47,    46,    45,    49,    50,    49,    48,
     &     51,    52,    50,    51,    51,    52,    53,    53,
     &     54,    53,    52,    53,    53,    56,    57,    55,
     &     55,    54,    54,    54,    53,    53,    51,    49,
     &     49,    50,    47,    46,    46,    47,    46,    48,
     &     48,    49,    49,    51,    50,    52,    53,    51,
     &     51,    52,    52,    53,    54,    54,    56,    55,
     &     55,    55,    53,    53,    53,    53,    54,    54,
     &     54,    50,    49,    50,    47,    47,    49,    50,
     &     47,    47,    45,    45,    46,    47,    46,    45,
     &     42,    41,    39,    40,    41,    42,    42,    41,
     &     41,    40,    40,    41,    40,    40,    40,    41,
     &     38,    38,    38,    37,    38,    37,    37,    36,
     &     36,    36,    38,    38,    38,    38,    36,    37,
     &     40,    43,    45,    43,    42,    43,    43,    44,
     &     44,    43,    43,    43,    43,    43,    42,    41,
     &     41,    40,    39,    40,    40,    40,    39,    36,
     &     37,    39,    40,    39,    38,    38,    37,    38,
     &     37,    35,    35,    35,    34,    34,    32,    32,
     &     31,    32,    32,    30,    32,    32,    29,    29,
     &     28,    27,    28,    28,    28,    29,    29,    29,
     &     29,    30,    30,    30,    29,    29,    29,    27,
     &     27,    28,    28,    27,    26,    27,    27,    26,
     &     26,    26,    25,    23,    25,    25,    25,    26,
     &     26,    25,    25,    25,    25,    25,    24,    24,
     &     24,    22,    22,    22,    21,    20,    19,    19,
     &     19,    18,    18,    18,    18,    18,    18,    17,
     &     17,    16,    16,    16,    16,    16,    16,    16,
     &     16,    15,    15,    15,    15,    14,    14,    14,
     &     14,    14,    14,    13,    12,    12,    12,    12,
     &     12,    12,    12,    11,    11,    11,    11,    10,
     &     10,     9,     8,     8,     8,     8,     7,     7,
     &      7,     7,     7,     7,     6,     6,     6,     6,
     &      6,     5,     5,     5,     5,     5,     4,     4,
     &      4,     4,     4,     4,     4,     4,     4,     4,
     &      4,     4,     4,     4,     4,     4,     4,     4,
     &      4,     4,     4,     4,     4,     4,     4,     4,
     &      4,     4,     4,     4,     4,     4,     4,     4,
     &      4,     4,     4,     4,     4,     4,     4,     4,
     &      4,     4,     3,     3,     3,     3,     3,     3,
     &      3,
     &      3,
     &      3,
     &      3,
     &      3/
c
      massi = hmass(1)
      massx = hmass(npoint)
      dmass = (massx-massi)/Real(npoint-1)
c      
      imass = int( (mh-massi)/dmass ) + 1
c
      if (imass.eq.npoint) then
        imass = npoint
        jmass = npoint
        rmass = 0.0
      Endif
cjm Modifie le 24Fevrier
      If (imass.le.0 .or. imass.gt.npoint) then
        A196_HGG_CAND = 0
        RETURN
      Endif
      If (imass.ge.1..and.imass.lt.npoint) then
        jmass = imass + 1
        rmass = mh - hmass(imass)
      endif
      If ( mh*10. - Real(INT(mh*10.)) .ne.0. .and.debug) then
        Print*,
     &'Warning : Number of data is interpolated !!! (A196_HGG_CAND)'
      Endif
c
      A196_HGG_CAND = INT( Real(idata(imass))+Real(idata(jmass)
     &     -idata(imass))*rmass/dmass + 0.5)
c
      RETURN
      END
      Integer FUNCTION A200_HGG_CAND(mh,myich,debug)
      Implicit none
      Real mh
      Integer myich
      Logical debug
c
      Integer npoint
      Parameter (npoint=701)
      Real hmass(npoint),err
      Real massi,massx,dmass,rmass
      Integer i,imass,jmass,idata(npoint)
      Data (hmass(i),i=       1,     701)/
     &  0.40000E+02, 0.40100E+02, 0.40200E+02, 0.40300E+02, 0.40400E+02,
     &  0.40500E+02, 0.40600E+02, 0.40700E+02, 0.40800E+02, 0.40900E+02,
     &  0.41000E+02, 0.41100E+02, 0.41200E+02, 0.41300E+02, 0.41400E+02,
     &  0.41500E+02, 0.41600E+02, 0.41700E+02, 0.41800E+02, 0.41900E+02,
     &  0.42000E+02, 0.42100E+02, 0.42200E+02, 0.42300E+02, 0.42400E+02,
     &  0.42500E+02, 0.42600E+02, 0.42700E+02, 0.42800E+02, 0.42900E+02,
     &  0.43000E+02, 0.43100E+02, 0.43200E+02, 0.43300E+02, 0.43400E+02,
     &  0.43500E+02, 0.43600E+02, 0.43700E+02, 0.43800E+02, 0.43900E+02,
     &  0.44000E+02, 0.44100E+02, 0.44200E+02, 0.44300E+02, 0.44400E+02,
     &  0.44500E+02, 0.44600E+02, 0.44700E+02, 0.44800E+02, 0.44900E+02,
     &  0.45000E+02, 0.45100E+02, 0.45200E+02, 0.45300E+02, 0.45400E+02,
     &  0.45500E+02, 0.45600E+02, 0.45700E+02, 0.45800E+02, 0.45900E+02,
     &  0.46000E+02, 0.46100E+02, 0.46200E+02, 0.46300E+02, 0.46400E+02,
     &  0.46500E+02, 0.46600E+02, 0.46700E+02, 0.46800E+02, 0.46900E+02,
     &  0.47000E+02, 0.47100E+02, 0.47200E+02, 0.47300E+02, 0.47400E+02,
     &  0.47500E+02, 0.47600E+02, 0.47700E+02, 0.47800E+02, 0.47900E+02,
     &  0.48000E+02, 0.48100E+02, 0.48200E+02, 0.48300E+02, 0.48400E+02,
     &  0.48500E+02, 0.48600E+02, 0.48700E+02, 0.48800E+02, 0.48900E+02,
     &  0.49000E+02, 0.49100E+02, 0.49200E+02, 0.49300E+02, 0.49400E+02,
     &  0.49500E+02, 0.49600E+02, 0.49700E+02, 0.49800E+02, 0.49900E+02,
     &  0.50000E+02, 0.50100E+02, 0.50200E+02, 0.50300E+02, 0.50400E+02,
     &  0.50500E+02, 0.50600E+02, 0.50700E+02, 0.50800E+02, 0.50900E+02,
     &  0.51000E+02, 0.51100E+02, 0.51200E+02, 0.51300E+02, 0.51400E+02,
     &  0.51500E+02, 0.51600E+02, 0.51700E+02, 0.51800E+02, 0.51900E+02,
     &  0.52000E+02, 0.52100E+02, 0.52200E+02, 0.52300E+02, 0.52400E+02,
     &  0.52500E+02, 0.52600E+02, 0.52700E+02, 0.52800E+02, 0.52900E+02,
     &  0.53000E+02, 0.53100E+02, 0.53200E+02, 0.53300E+02, 0.53400E+02,
     &  0.53500E+02, 0.53600E+02, 0.53700E+02, 0.53800E+02, 0.53900E+02,
     &  0.54000E+02, 0.54100E+02, 0.54200E+02, 0.54300E+02, 0.54400E+02,
     &  0.54500E+02, 0.54600E+02, 0.54700E+02, 0.54800E+02, 0.54900E+02,
     &  0.55000E+02, 0.55100E+02, 0.55200E+02, 0.55300E+02, 0.55400E+02,
     &  0.55500E+02, 0.55600E+02, 0.55700E+02, 0.55800E+02, 0.55900E+02,
     &  0.56000E+02, 0.56100E+02, 0.56200E+02, 0.56300E+02, 0.56400E+02,
     &  0.56500E+02, 0.56600E+02, 0.56700E+02, 0.56800E+02, 0.56900E+02,
     &  0.57000E+02, 0.57100E+02, 0.57200E+02, 0.57300E+02, 0.57400E+02,
     &  0.57500E+02, 0.57600E+02, 0.57700E+02, 0.57800E+02, 0.57900E+02,
     &  0.58000E+02, 0.58100E+02, 0.58200E+02, 0.58300E+02, 0.58400E+02,
     &  0.58500E+02, 0.58600E+02, 0.58700E+02, 0.58800E+02, 0.58900E+02,
     &  0.59000E+02, 0.59100E+02, 0.59200E+02, 0.59300E+02, 0.59400E+02,
     &  0.59500E+02, 0.59600E+02, 0.59700E+02, 0.59800E+02, 0.59900E+02,
     &  0.60000E+02, 0.60100E+02, 0.60200E+02, 0.60300E+02, 0.60400E+02,
     &  0.60500E+02, 0.60600E+02, 0.60700E+02, 0.60800E+02, 0.60900E+02,
     &  0.61000E+02, 0.61100E+02, 0.61200E+02, 0.61300E+02, 0.61400E+02,
     &  0.61500E+02, 0.61600E+02, 0.61700E+02, 0.61800E+02, 0.61900E+02,
     &  0.62000E+02, 0.62100E+02, 0.62200E+02, 0.62300E+02, 0.62400E+02,
     &  0.62500E+02, 0.62600E+02, 0.62700E+02, 0.62800E+02, 0.62900E+02,
     &  0.63000E+02, 0.63100E+02, 0.63200E+02, 0.63300E+02, 0.63400E+02,
     &  0.63500E+02, 0.63600E+02, 0.63700E+02, 0.63800E+02, 0.63900E+02,
     &  0.64000E+02, 0.64100E+02, 0.64200E+02, 0.64300E+02, 0.64400E+02,
     &  0.64500E+02, 0.64600E+02, 0.64700E+02, 0.64800E+02, 0.64900E+02,
     &  0.65000E+02, 0.65100E+02, 0.65200E+02, 0.65300E+02, 0.65400E+02,
     &  0.65500E+02, 0.65600E+02, 0.65700E+02, 0.65800E+02, 0.65900E+02,
     &  0.66000E+02, 0.66100E+02, 0.66200E+02, 0.66300E+02, 0.66400E+02,
     &  0.66500E+02, 0.66600E+02, 0.66700E+02, 0.66800E+02, 0.66900E+02,
     &  0.67000E+02, 0.67100E+02, 0.67200E+02, 0.67300E+02, 0.67400E+02,
     &  0.67500E+02, 0.67600E+02, 0.67700E+02, 0.67800E+02, 0.67900E+02,
     &  0.68000E+02, 0.68100E+02, 0.68200E+02, 0.68300E+02, 0.68400E+02,
     &  0.68500E+02, 0.68600E+02, 0.68700E+02, 0.68800E+02, 0.68900E+02,
     &  0.69000E+02, 0.69100E+02, 0.69200E+02, 0.69300E+02, 0.69400E+02,
     &  0.69500E+02, 0.69600E+02, 0.69700E+02, 0.69800E+02, 0.69900E+02,
     &  0.70000E+02, 0.70100E+02, 0.70200E+02, 0.70300E+02, 0.70400E+02,
     &  0.70500E+02, 0.70600E+02, 0.70700E+02, 0.70800E+02, 0.70900E+02,
     &  0.71000E+02, 0.71100E+02, 0.71200E+02, 0.71300E+02, 0.71400E+02,
     &  0.71500E+02, 0.71600E+02, 0.71700E+02, 0.71800E+02, 0.71900E+02,
     &  0.72000E+02, 0.72100E+02, 0.72200E+02, 0.72300E+02, 0.72400E+02,
     &  0.72500E+02, 0.72600E+02, 0.72700E+02, 0.72800E+02, 0.72900E+02,
     &  0.73000E+02, 0.73100E+02, 0.73200E+02, 0.73300E+02, 0.73400E+02,
     &  0.73500E+02, 0.73600E+02, 0.73700E+02, 0.73800E+02, 0.73900E+02,
     &  0.74000E+02, 0.74100E+02, 0.74200E+02, 0.74300E+02, 0.74400E+02,
     &  0.74500E+02, 0.74600E+02, 0.74700E+02, 0.74800E+02, 0.74900E+02,
     &  0.75000E+02, 0.75100E+02, 0.75200E+02, 0.75300E+02, 0.75400E+02,
     &  0.75500E+02, 0.75600E+02, 0.75700E+02, 0.75800E+02, 0.75900E+02,
     &  0.76000E+02, 0.76100E+02, 0.76200E+02, 0.76300E+02, 0.76400E+02,
     &  0.76500E+02, 0.76600E+02, 0.76700E+02, 0.76800E+02, 0.76900E+02,
     &  0.77000E+02, 0.77100E+02, 0.77200E+02, 0.77300E+02, 0.77400E+02,
     &  0.77500E+02, 0.77600E+02, 0.77700E+02, 0.77800E+02, 0.77900E+02,
     &  0.78000E+02, 0.78100E+02, 0.78200E+02, 0.78300E+02, 0.78400E+02,
     &  0.78500E+02, 0.78600E+02, 0.78700E+02, 0.78800E+02, 0.78900E+02,
     &  0.79000E+02, 0.79100E+02, 0.79200E+02, 0.79300E+02, 0.79400E+02,
     &  0.79500E+02, 0.79600E+02, 0.79700E+02, 0.79800E+02, 0.79900E+02,
     &  0.80000E+02, 0.80100E+02, 0.80200E+02, 0.80300E+02, 0.80400E+02,
     &  0.80500E+02, 0.80600E+02, 0.80700E+02, 0.80800E+02, 0.80900E+02,
     &  0.81000E+02, 0.81100E+02, 0.81200E+02, 0.81300E+02, 0.81400E+02,
     &  0.81500E+02, 0.81600E+02, 0.81700E+02, 0.81800E+02, 0.81900E+02,
     &  0.82000E+02, 0.82100E+02, 0.82200E+02, 0.82300E+02, 0.82400E+02,
     &  0.82500E+02, 0.82600E+02, 0.82700E+02, 0.82800E+02, 0.82900E+02,
     &  0.83000E+02, 0.83100E+02, 0.83200E+02, 0.83300E+02, 0.83400E+02,
     &  0.83500E+02, 0.83600E+02, 0.83700E+02, 0.83800E+02, 0.83900E+02,
     &  0.84000E+02, 0.84100E+02, 0.84200E+02, 0.84300E+02, 0.84400E+02,
     &  0.84500E+02, 0.84600E+02, 0.84700E+02, 0.84800E+02, 0.84900E+02,
     &  0.85000E+02, 0.85100E+02, 0.85200E+02, 0.85300E+02, 0.85400E+02,
     &  0.85500E+02, 0.85600E+02, 0.85700E+02, 0.85800E+02, 0.85900E+02,
     &  0.86000E+02, 0.86100E+02, 0.86200E+02, 0.86300E+02, 0.86400E+02,
     &  0.86500E+02, 0.86600E+02, 0.86700E+02, 0.86800E+02, 0.86900E+02,
     &  0.87000E+02, 0.87100E+02, 0.87200E+02, 0.87300E+02, 0.87400E+02,
     &  0.87500E+02, 0.87600E+02, 0.87700E+02, 0.87800E+02, 0.87900E+02,
     &  0.88000E+02, 0.88100E+02, 0.88200E+02, 0.88300E+02, 0.88400E+02,
     &  0.88500E+02, 0.88600E+02, 0.88700E+02, 0.88800E+02, 0.88900E+02,
     &  0.89000E+02, 0.89100E+02, 0.89200E+02, 0.89300E+02, 0.89400E+02,
     &  0.89500E+02, 0.89600E+02, 0.89700E+02, 0.89800E+02, 0.89900E+02,
     &  0.90000E+02, 0.90100E+02, 0.90200E+02, 0.90300E+02, 0.90400E+02,
     &  0.90500E+02, 0.90600E+02, 0.90700E+02, 0.90800E+02, 0.90900E+02,
     &  0.91000E+02, 0.91100E+02, 0.91200E+02, 0.91300E+02, 0.91400E+02,
     &  0.91500E+02, 0.91600E+02, 0.91700E+02, 0.91800E+02, 0.91900E+02,
     &  0.92000E+02, 0.92100E+02, 0.92200E+02, 0.92300E+02, 0.92400E+02,
     &  0.92500E+02, 0.92600E+02, 0.92700E+02, 0.92800E+02, 0.92900E+02,
     &  0.93000E+02, 0.93100E+02, 0.93200E+02, 0.93300E+02, 0.93400E+02,
     &  0.93500E+02, 0.93600E+02, 0.93700E+02, 0.93800E+02, 0.93900E+02,
     &  0.94000E+02, 0.94100E+02, 0.94200E+02, 0.94300E+02, 0.94400E+02,
     &  0.94500E+02, 0.94600E+02, 0.94700E+02, 0.94800E+02, 0.94900E+02,
     &  0.95000E+02, 0.95100E+02, 0.95200E+02, 0.95300E+02, 0.95400E+02,
     &  0.95500E+02, 0.95600E+02, 0.95700E+02, 0.95800E+02, 0.95900E+02,
     &  0.96000E+02, 0.96100E+02, 0.96200E+02, 0.96300E+02, 0.96400E+02,
     &  0.96500E+02, 0.96600E+02, 0.96700E+02, 0.96800E+02, 0.96900E+02,
     &  0.97000E+02, 0.97100E+02, 0.97200E+02, 0.97300E+02, 0.97400E+02,
     &  0.97500E+02, 0.97600E+02, 0.97700E+02, 0.97800E+02, 0.97900E+02,
     &  0.98000E+02, 0.98100E+02, 0.98200E+02, 0.98300E+02, 0.98400E+02,
     &  0.98500E+02, 0.98600E+02, 0.98700E+02, 0.98800E+02, 0.98900E+02,
     &  0.99000E+02, 0.99100E+02, 0.99200E+02, 0.99300E+02, 0.99400E+02,
     &  0.99500E+02, 0.99600E+02, 0.99700E+02, 0.99800E+02, 0.99900E+02,
     &  0.10000E+03, 0.10010E+03, 0.10020E+03, 0.10030E+03, 0.10040E+03,
     &  0.10050E+03, 0.10060E+03, 0.10070E+03, 0.10080E+03, 0.10090E+03,
     &  0.10100E+03, 0.10110E+03, 0.10120E+03, 0.10130E+03, 0.10140E+03,
     &  0.10150E+03, 0.10160E+03, 0.10170E+03, 0.10180E+03, 0.10190E+03,
     &  0.10200E+03, 0.10210E+03, 0.10220E+03, 0.10230E+03, 0.10240E+03,
     &  0.10250E+03, 0.10260E+03, 0.10270E+03, 0.10280E+03, 0.10290E+03,
     &  0.10300E+03, 0.10310E+03, 0.10320E+03, 0.10330E+03, 0.10340E+03,
     &  0.10350E+03, 0.10360E+03, 0.10370E+03, 0.10380E+03, 0.10390E+03,
     &  0.10400E+03, 0.10410E+03, 0.10420E+03, 0.10430E+03, 0.10440E+03,
     &  0.10450E+03, 0.10460E+03, 0.10470E+03, 0.10480E+03, 0.10490E+03,
     &  0.10500E+03, 0.10510E+03, 0.10520E+03, 0.10530E+03, 0.10540E+03,
     &  0.10550E+03, 0.10560E+03, 0.10570E+03, 0.10580E+03, 0.10590E+03,
     &  0.10600E+03, 0.10610E+03, 0.10620E+03, 0.10630E+03, 0.10640E+03,
     &  0.10650E+03, 0.10660E+03, 0.10670E+03, 0.10680E+03, 0.10690E+03,
     &  0.10700E+03, 0.10710E+03, 0.10720E+03, 0.10730E+03, 0.10740E+03,
     &  0.10750E+03, 0.10760E+03, 0.10770E+03, 0.10780E+03, 0.10790E+03,
     &  0.10800E+03, 0.10810E+03, 0.10820E+03, 0.10830E+03, 0.10840E+03,
     &  0.10850E+03, 0.10860E+03, 0.10870E+03, 0.10880E+03, 0.10890E+03,
     &  0.10900E+03, 0.10910E+03, 0.10920E+03, 0.10930E+03, 0.10940E+03,
     &  0.10950E+03,
     &  0.10960E+03,
     &  0.10970E+03,
     &  0.10980E+03,
     &  0.10990E+03,
     &  0.11000E+03/
      Data (idata(i),i=       1,     701)/
     &     22,    22,    19,    18,    18,    19,    18,    17,
     &     17,    17,    17,    16,    16,    16,    16,    17,
     &     18,    17,    18,    16,    17,    16,    16,    16,
     &     16,    16,    16,    18,    17,    17,    17,    16,
     &     17,    16,    16,    17,    17,    17,    17,    18,
     &     17,    17,    17,    16,    16,    16,    16,    15,
     &     15,    14,    12,    13,    12,    11,    10,     9,
     &      9,     9,     9,     9,    10,    11,    11,    11,
     &     11,    11,    11,    11,    11,    11,    11,    11,
     &     11,    10,    11,    12,    12,    12,    12,    13,
     &     13,    13,    13,    13,    13,    13,    13,    13,
     &     13,    13,    14,    14,    15,    16,    17,    16,
     &     15,    15,    16,    16,    17,    18,    18,    18,
     &     18,    18,    19,    19,    19,    19,    19,    19,
     &     19,    20,    19,    19,    18,    18,    19,    20,
     &     20,    21,    21,    20,    22,    22,    22,    23,
     &     22,    22,    22,    22,    22,    22,    22,    22,
     &     21,    21,    21,    21,    21,    21,    21,    21,
     &     21,    22,    21,    21,    21,    19,    19,    20,
     &     20,    20,    19,    19,    18,    19,    19,    19,
     &     19,    19,    18,    18,    18,    18,    19,    19,
     &     20,    21,    22,    22,    22,    21,    21,    22,
     &     22,    22,    22,    21,    21,    20,    21,    20,
     &     20,    20,    20,    21,    20,    20,    20,    19,
     &     18,    19,    19,    18,    17,    15,    16,    16,
     &     16,    17,    18,    19,    19,    20,    19,    19,
     &     19,    20,    19,    20,    21,    22,    22,    22,
     &     22,    20,    19,    19,    18,    18,    18,    18,
     &     19,    19,    18,    19,    18,    17,    18,    19,
     &     18,    18,    18,    19,    19,    19,    19,    18,
     &     17,    17,    18,    18,    18,    19,    20,    20,
     &     20,    20,    20,    20,    19,    19,    18,    18,
     &     19,    18,    19,    19,    18,    19,    19,    20,
     &     20,    19,    19,    19,    20,    21,    21,    22,
     &     22,    23,    23,    23,    22,    23,    23,    23,
     &     23,    23,    23,    24,    26,    25,    25,    25,
     &     25,    25,    26,    26,    26,    26,    31,    30,
     &     30,    30,    29,    28,    28,    27,    27,    26,
     &     26,    25,    25,    25,    23,    22,    23,    23,
     &     24,    24,    25,    24,    24,    24,    25,    25,
     &     27,    29,    29,    27,    24,    23,    23,    22,
     &     22,    22,    19,    19,    18,    19,    19,    19,
     &     19,    19,    19,    18,    19,    19,    19,    18,
     &     19,    19,    20,    19,    17,    18,    19,    19,
     &     19,    19,    21,    22,    21,    22,    23,    26,
     &     27,    28,    32,    32,    32,    30,    30,    32,
     &     34,    33,    34,    35,    36,    36,    36,    37,
     &     36,    37,    36,    37,    36,    38,    38,    37,
     &     36,    34,    36,    40,    41,    41,    40,    41,
     &     42,    42,    40,    41,    41,    41,    42,    41,
     &     41,    42,    41,    43,    44,    44,    45,    46,
     &     45,    45,    45,    45,    46,    46,    47,    49,
     &     49,    51,    51,    50,    50,    49,    49,    46,
     &     44,    45,    42,    41,    40,    42,    43,    41,
     &     41,    41,    41,    44,    44,    43,    43,    43,
     &     45,    46,    46,    47,    48,    47,    48,    49,
     &     53,    49,    48,    49,    48,    48,    48,    50,
     &     50,    49,    50,    50,    49,    49,    49,    48,
     &     48,    49,    49,    47,    46,    46,    45,    44,
     &     43,    45,    45,    46,    44,    46,    48,    48,
     &     51,    50,    51,    50,    50,    50,    50,    51,
     &     50,    49,    48,    47,    47,    47,    46,    48,
     &     47,    47,    47,    45,    43,    43,    43,    42,
     &     41,    41,    42,    39,    39,    40,    40,    39,
     &     36,    37,    37,    35,    35,    34,    35,    33,
     &     31,    32,    33,    32,    30,    30,    31,    31,
     &     30,    29,    30,    30,    30,    30,    29,    29,
     &     30,    31,    30,    30,    30,    30,    31,    31,
     &     31,    32,    31,    32,    32,    31,    32,    32,
     &     29,    28,    29,    29,    27,    26,    26,    26,
     &     24,    24,    24,    24,    23,    21,    21,    20,
     &     18,    18,    18,    18,    19,    18,    18,    17,
     &     18,    18,    20,    20,    20,    22,    23,    22,
     &     21,    21,    21,    21,    21,    21,    21,    21,
     &     21,    23,    23,    23,    24,    22,    21,    21,
     &     21,    21,    21,    20,    19,    19,    19,    19,
     &     20,    20,    21,    21,    22,    22,    21,    21,
     &     22,    21,    21,    22,    23,    22,    22,    23,
     &     25,    25,    24,    24,    24,    24,    24,    25,
     &     25,    25,    26,    24,    24,    24,    24,    25,
     &     24,    25,    25,    24,    24,    25,    23,    22,
     &     22,    22,    22,    22,    21,    20,    21,    20,
     &     19,    20,    20,    20,    20,    19,    19,    19,
     &     19,    21,    20,    20,    20,    20,    19,    19,
     &     20,    20,    21,    22,    22,    22,    23,    23,
     &     23,    23,    24,    25,    26,    26,    26,    26,
     &     26,    26,    27,    28,    28,    29,    29,    30,
     &     30,
     &     30,
     &     30,
     &     29,
     &     30/
c
      massi = hmass(1)
      massx = hmass(npoint)
      dmass = (massx-massi)/Real(npoint-1)
c      
      imass = int( (mh-massi)/dmass ) + 1
c
      if (imass.eq.npoint) then
        imass = npoint
        jmass = npoint
        rmass = 0.0
      Endif
cjm Modifie le 24Fevrier
      If (imass.le.0 .or. imass.gt.npoint) then
        A200_HGG_CAND = 0
        RETURN
      Endif
      If (imass.ge.1..and.imass.lt.npoint) then
        jmass = imass + 1
        rmass = mh - hmass(imass)
      endif
      If ( mh*10. - Real(INT(mh*10.)) .ne.0. .and.debug) then
        Print*,
     &'Warning : Number of data is interpolated !!! (A200_HGG_CAND)'
      Endif
c
      A200_HGG_CAND = INT( Real(idata(imass))+Real(idata(jmass)
     &     -idata(imass))*rmass/dmass + 0.5)
c
      RETURN
      END
      Integer FUNCTION A202_HGG_CAND(mh,myich,debug)
      Implicit none
      Real mh
      Integer myich
      Logical debug
c
      Integer npoint
      Parameter (npoint=701)
      Real hmass(npoint),err
      Real massi,massx,dmass,rmass
      Integer i,imass,jmass,idata(npoint)
      Data (hmass(i),i=       1,     701)/
     &  0.40000E+02, 0.40100E+02, 0.40200E+02, 0.40300E+02, 0.40400E+02,
     &  0.40500E+02, 0.40600E+02, 0.40700E+02, 0.40800E+02, 0.40900E+02,
     &  0.41000E+02, 0.41100E+02, 0.41200E+02, 0.41300E+02, 0.41400E+02,
     &  0.41500E+02, 0.41600E+02, 0.41700E+02, 0.41800E+02, 0.41900E+02,
     &  0.42000E+02, 0.42100E+02, 0.42200E+02, 0.42300E+02, 0.42400E+02,
     &  0.42500E+02, 0.42600E+02, 0.42700E+02, 0.42800E+02, 0.42900E+02,
     &  0.43000E+02, 0.43100E+02, 0.43200E+02, 0.43300E+02, 0.43400E+02,
     &  0.43500E+02, 0.43600E+02, 0.43700E+02, 0.43800E+02, 0.43900E+02,
     &  0.44000E+02, 0.44100E+02, 0.44200E+02, 0.44300E+02, 0.44400E+02,
     &  0.44500E+02, 0.44600E+02, 0.44700E+02, 0.44800E+02, 0.44900E+02,
     &  0.45000E+02, 0.45100E+02, 0.45200E+02, 0.45300E+02, 0.45400E+02,
     &  0.45500E+02, 0.45600E+02, 0.45700E+02, 0.45800E+02, 0.45900E+02,
     &  0.46000E+02, 0.46100E+02, 0.46200E+02, 0.46300E+02, 0.46400E+02,
     &  0.46500E+02, 0.46600E+02, 0.46700E+02, 0.46800E+02, 0.46900E+02,
     &  0.47000E+02, 0.47100E+02, 0.47200E+02, 0.47300E+02, 0.47400E+02,
     &  0.47500E+02, 0.47600E+02, 0.47700E+02, 0.47800E+02, 0.47900E+02,
     &  0.48000E+02, 0.48100E+02, 0.48200E+02, 0.48300E+02, 0.48400E+02,
     &  0.48500E+02, 0.48600E+02, 0.48700E+02, 0.48800E+02, 0.48900E+02,
     &  0.49000E+02, 0.49100E+02, 0.49200E+02, 0.49300E+02, 0.49400E+02,
     &  0.49500E+02, 0.49600E+02, 0.49700E+02, 0.49800E+02, 0.49900E+02,
     &  0.50000E+02, 0.50100E+02, 0.50200E+02, 0.50300E+02, 0.50400E+02,
     &  0.50500E+02, 0.50600E+02, 0.50700E+02, 0.50800E+02, 0.50900E+02,
     &  0.51000E+02, 0.51100E+02, 0.51200E+02, 0.51300E+02, 0.51400E+02,
     &  0.51500E+02, 0.51600E+02, 0.51700E+02, 0.51800E+02, 0.51900E+02,
     &  0.52000E+02, 0.52100E+02, 0.52200E+02, 0.52300E+02, 0.52400E+02,
     &  0.52500E+02, 0.52600E+02, 0.52700E+02, 0.52800E+02, 0.52900E+02,
     &  0.53000E+02, 0.53100E+02, 0.53200E+02, 0.53300E+02, 0.53400E+02,
     &  0.53500E+02, 0.53600E+02, 0.53700E+02, 0.53800E+02, 0.53900E+02,
     &  0.54000E+02, 0.54100E+02, 0.54200E+02, 0.54300E+02, 0.54400E+02,
     &  0.54500E+02, 0.54600E+02, 0.54700E+02, 0.54800E+02, 0.54900E+02,
     &  0.55000E+02, 0.55100E+02, 0.55200E+02, 0.55300E+02, 0.55400E+02,
     &  0.55500E+02, 0.55600E+02, 0.55700E+02, 0.55800E+02, 0.55900E+02,
     &  0.56000E+02, 0.56100E+02, 0.56200E+02, 0.56300E+02, 0.56400E+02,
     &  0.56500E+02, 0.56600E+02, 0.56700E+02, 0.56800E+02, 0.56900E+02,
     &  0.57000E+02, 0.57100E+02, 0.57200E+02, 0.57300E+02, 0.57400E+02,
     &  0.57500E+02, 0.57600E+02, 0.57700E+02, 0.57800E+02, 0.57900E+02,
     &  0.58000E+02, 0.58100E+02, 0.58200E+02, 0.58300E+02, 0.58400E+02,
     &  0.58500E+02, 0.58600E+02, 0.58700E+02, 0.58800E+02, 0.58900E+02,
     &  0.59000E+02, 0.59100E+02, 0.59200E+02, 0.59300E+02, 0.59400E+02,
     &  0.59500E+02, 0.59600E+02, 0.59700E+02, 0.59800E+02, 0.59900E+02,
     &  0.60000E+02, 0.60100E+02, 0.60200E+02, 0.60300E+02, 0.60400E+02,
     &  0.60500E+02, 0.60600E+02, 0.60700E+02, 0.60800E+02, 0.60900E+02,
     &  0.61000E+02, 0.61100E+02, 0.61200E+02, 0.61300E+02, 0.61400E+02,
     &  0.61500E+02, 0.61600E+02, 0.61700E+02, 0.61800E+02, 0.61900E+02,
     &  0.62000E+02, 0.62100E+02, 0.62200E+02, 0.62300E+02, 0.62400E+02,
     &  0.62500E+02, 0.62600E+02, 0.62700E+02, 0.62800E+02, 0.62900E+02,
     &  0.63000E+02, 0.63100E+02, 0.63200E+02, 0.63300E+02, 0.63400E+02,
     &  0.63500E+02, 0.63600E+02, 0.63700E+02, 0.63800E+02, 0.63900E+02,
     &  0.64000E+02, 0.64100E+02, 0.64200E+02, 0.64300E+02, 0.64400E+02,
     &  0.64500E+02, 0.64600E+02, 0.64700E+02, 0.64800E+02, 0.64900E+02,
     &  0.65000E+02, 0.65100E+02, 0.65200E+02, 0.65300E+02, 0.65400E+02,
     &  0.65500E+02, 0.65600E+02, 0.65700E+02, 0.65800E+02, 0.65900E+02,
     &  0.66000E+02, 0.66100E+02, 0.66200E+02, 0.66300E+02, 0.66400E+02,
     &  0.66500E+02, 0.66600E+02, 0.66700E+02, 0.66800E+02, 0.66900E+02,
     &  0.67000E+02, 0.67100E+02, 0.67200E+02, 0.67300E+02, 0.67400E+02,
     &  0.67500E+02, 0.67600E+02, 0.67700E+02, 0.67800E+02, 0.67900E+02,
     &  0.68000E+02, 0.68100E+02, 0.68200E+02, 0.68300E+02, 0.68400E+02,
     &  0.68500E+02, 0.68600E+02, 0.68700E+02, 0.68800E+02, 0.68900E+02,
     &  0.69000E+02, 0.69100E+02, 0.69200E+02, 0.69300E+02, 0.69400E+02,
     &  0.69500E+02, 0.69600E+02, 0.69700E+02, 0.69800E+02, 0.69900E+02,
     &  0.70000E+02, 0.70100E+02, 0.70200E+02, 0.70300E+02, 0.70400E+02,
     &  0.70500E+02, 0.70600E+02, 0.70700E+02, 0.70800E+02, 0.70900E+02,
     &  0.71000E+02, 0.71100E+02, 0.71200E+02, 0.71300E+02, 0.71400E+02,
     &  0.71500E+02, 0.71600E+02, 0.71700E+02, 0.71800E+02, 0.71900E+02,
     &  0.72000E+02, 0.72100E+02, 0.72200E+02, 0.72300E+02, 0.72400E+02,
     &  0.72500E+02, 0.72600E+02, 0.72700E+02, 0.72800E+02, 0.72900E+02,
     &  0.73000E+02, 0.73100E+02, 0.73200E+02, 0.73300E+02, 0.73400E+02,
     &  0.73500E+02, 0.73600E+02, 0.73700E+02, 0.73800E+02, 0.73900E+02,
     &  0.74000E+02, 0.74100E+02, 0.74200E+02, 0.74300E+02, 0.74400E+02,
     &  0.74500E+02, 0.74600E+02, 0.74700E+02, 0.74800E+02, 0.74900E+02,
     &  0.75000E+02, 0.75100E+02, 0.75200E+02, 0.75300E+02, 0.75400E+02,
     &  0.75500E+02, 0.75600E+02, 0.75700E+02, 0.75800E+02, 0.75900E+02,
     &  0.76000E+02, 0.76100E+02, 0.76200E+02, 0.76300E+02, 0.76400E+02,
     &  0.76500E+02, 0.76600E+02, 0.76700E+02, 0.76800E+02, 0.76900E+02,
     &  0.77000E+02, 0.77100E+02, 0.77200E+02, 0.77300E+02, 0.77400E+02,
     &  0.77500E+02, 0.77600E+02, 0.77700E+02, 0.77800E+02, 0.77900E+02,
     &  0.78000E+02, 0.78100E+02, 0.78200E+02, 0.78300E+02, 0.78400E+02,
     &  0.78500E+02, 0.78600E+02, 0.78700E+02, 0.78800E+02, 0.78900E+02,
     &  0.79000E+02, 0.79100E+02, 0.79200E+02, 0.79300E+02, 0.79400E+02,
     &  0.79500E+02, 0.79600E+02, 0.79700E+02, 0.79800E+02, 0.79900E+02,
     &  0.80000E+02, 0.80100E+02, 0.80200E+02, 0.80300E+02, 0.80400E+02,
     &  0.80500E+02, 0.80600E+02, 0.80700E+02, 0.80800E+02, 0.80900E+02,
     &  0.81000E+02, 0.81100E+02, 0.81200E+02, 0.81300E+02, 0.81400E+02,
     &  0.81500E+02, 0.81600E+02, 0.81700E+02, 0.81800E+02, 0.81900E+02,
     &  0.82000E+02, 0.82100E+02, 0.82200E+02, 0.82300E+02, 0.82400E+02,
     &  0.82500E+02, 0.82600E+02, 0.82700E+02, 0.82800E+02, 0.82900E+02,
     &  0.83000E+02, 0.83100E+02, 0.83200E+02, 0.83300E+02, 0.83400E+02,
     &  0.83500E+02, 0.83600E+02, 0.83700E+02, 0.83800E+02, 0.83900E+02,
     &  0.84000E+02, 0.84100E+02, 0.84200E+02, 0.84300E+02, 0.84400E+02,
     &  0.84500E+02, 0.84600E+02, 0.84700E+02, 0.84800E+02, 0.84900E+02,
     &  0.85000E+02, 0.85100E+02, 0.85200E+02, 0.85300E+02, 0.85400E+02,
     &  0.85500E+02, 0.85600E+02, 0.85700E+02, 0.85800E+02, 0.85900E+02,
     &  0.86000E+02, 0.86100E+02, 0.86200E+02, 0.86300E+02, 0.86400E+02,
     &  0.86500E+02, 0.86600E+02, 0.86700E+02, 0.86800E+02, 0.86900E+02,
     &  0.87000E+02, 0.87100E+02, 0.87200E+02, 0.87300E+02, 0.87400E+02,
     &  0.87500E+02, 0.87600E+02, 0.87700E+02, 0.87800E+02, 0.87900E+02,
     &  0.88000E+02, 0.88100E+02, 0.88200E+02, 0.88300E+02, 0.88400E+02,
     &  0.88500E+02, 0.88600E+02, 0.88700E+02, 0.88800E+02, 0.88900E+02,
     &  0.89000E+02, 0.89100E+02, 0.89200E+02, 0.89300E+02, 0.89400E+02,
     &  0.89500E+02, 0.89600E+02, 0.89700E+02, 0.89800E+02, 0.89900E+02,
     &  0.90000E+02, 0.90100E+02, 0.90200E+02, 0.90300E+02, 0.90400E+02,
     &  0.90500E+02, 0.90600E+02, 0.90700E+02, 0.90800E+02, 0.90900E+02,
     &  0.91000E+02, 0.91100E+02, 0.91200E+02, 0.91300E+02, 0.91400E+02,
     &  0.91500E+02, 0.91600E+02, 0.91700E+02, 0.91800E+02, 0.91900E+02,
     &  0.92000E+02, 0.92100E+02, 0.92200E+02, 0.92300E+02, 0.92400E+02,
     &  0.92500E+02, 0.92600E+02, 0.92700E+02, 0.92800E+02, 0.92900E+02,
     &  0.93000E+02, 0.93100E+02, 0.93200E+02, 0.93300E+02, 0.93400E+02,
     &  0.93500E+02, 0.93600E+02, 0.93700E+02, 0.93800E+02, 0.93900E+02,
     &  0.94000E+02, 0.94100E+02, 0.94200E+02, 0.94300E+02, 0.94400E+02,
     &  0.94500E+02, 0.94600E+02, 0.94700E+02, 0.94800E+02, 0.94900E+02,
     &  0.95000E+02, 0.95100E+02, 0.95200E+02, 0.95300E+02, 0.95400E+02,
     &  0.95500E+02, 0.95600E+02, 0.95700E+02, 0.95800E+02, 0.95900E+02,
     &  0.96000E+02, 0.96100E+02, 0.96200E+02, 0.96300E+02, 0.96400E+02,
     &  0.96500E+02, 0.96600E+02, 0.96700E+02, 0.96800E+02, 0.96900E+02,
     &  0.97000E+02, 0.97100E+02, 0.97200E+02, 0.97300E+02, 0.97400E+02,
     &  0.97500E+02, 0.97600E+02, 0.97700E+02, 0.97800E+02, 0.97900E+02,
     &  0.98000E+02, 0.98100E+02, 0.98200E+02, 0.98300E+02, 0.98400E+02,
     &  0.98500E+02, 0.98600E+02, 0.98700E+02, 0.98800E+02, 0.98900E+02,
     &  0.99000E+02, 0.99100E+02, 0.99200E+02, 0.99300E+02, 0.99400E+02,
     &  0.99500E+02, 0.99600E+02, 0.99700E+02, 0.99800E+02, 0.99900E+02,
     &  0.10000E+03, 0.10010E+03, 0.10020E+03, 0.10030E+03, 0.10040E+03,
     &  0.10050E+03, 0.10060E+03, 0.10070E+03, 0.10080E+03, 0.10090E+03,
     &  0.10100E+03, 0.10110E+03, 0.10120E+03, 0.10130E+03, 0.10140E+03,
     &  0.10150E+03, 0.10160E+03, 0.10170E+03, 0.10180E+03, 0.10190E+03,
     &  0.10200E+03, 0.10210E+03, 0.10220E+03, 0.10230E+03, 0.10240E+03,
     &  0.10250E+03, 0.10260E+03, 0.10270E+03, 0.10280E+03, 0.10290E+03,
     &  0.10300E+03, 0.10310E+03, 0.10320E+03, 0.10330E+03, 0.10340E+03,
     &  0.10350E+03, 0.10360E+03, 0.10370E+03, 0.10380E+03, 0.10390E+03,
     &  0.10400E+03, 0.10410E+03, 0.10420E+03, 0.10430E+03, 0.10440E+03,
     &  0.10450E+03, 0.10460E+03, 0.10470E+03, 0.10480E+03, 0.10490E+03,
     &  0.10500E+03, 0.10510E+03, 0.10520E+03, 0.10530E+03, 0.10540E+03,
     &  0.10550E+03, 0.10560E+03, 0.10570E+03, 0.10580E+03, 0.10590E+03,
     &  0.10600E+03, 0.10610E+03, 0.10620E+03, 0.10630E+03, 0.10640E+03,
     &  0.10650E+03, 0.10660E+03, 0.10670E+03, 0.10680E+03, 0.10690E+03,
     &  0.10700E+03, 0.10710E+03, 0.10720E+03, 0.10730E+03, 0.10740E+03,
     &  0.10750E+03, 0.10760E+03, 0.10770E+03, 0.10780E+03, 0.10790E+03,
     &  0.10800E+03, 0.10810E+03, 0.10820E+03, 0.10830E+03, 0.10840E+03,
     &  0.10850E+03, 0.10860E+03, 0.10870E+03, 0.10880E+03, 0.10890E+03,
     &  0.10900E+03, 0.10910E+03, 0.10920E+03, 0.10930E+03, 0.10940E+03,
     &  0.10950E+03,
     &  0.10960E+03,
     &  0.10970E+03,
     &  0.10980E+03,
     &  0.10990E+03,
     &  0.11000E+03/
      Data (idata(i),i=       1,     701)/
     &      5,     5,     5,     5,     5,     5,     6,     6,
     &      6,     6,     6,     6,     5,     5,     5,     5,
     &      4,     4,     4,     4,     4,     5,     5,     5,
     &      5,     5,     5,     5,     5,     5,     5,     6,
     &      6,     7,     7,     7,     7,     7,     8,     8,
     &      8,     8,     5,     5,     5,     4,     4,     4,
     &      4,     4,     4,     4,     4,     4,     4,     5,
     &      5,     5,     6,     6,     7,     7,     8,     8,
     &      8,     8,     8,     8,     7,     8,     9,    10,
     &     10,     9,     9,     9,     9,     9,     9,     9,
     &      9,     9,     9,     9,     9,     9,     8,     8,
     &      8,     8,     8,     8,     8,     9,     9,     9,
     &      9,     9,     9,     9,     9,     9,     9,    10,
     &     10,    11,    11,    11,    11,    11,    11,    11,
     &     12,    12,    11,     9,     9,     9,     9,     9,
     &      9,     9,     9,     9,     9,     9,     8,     7,
     &      7,     7,     7,     6,     7,     7,     7,     7,
     &      7,     8,     8,     8,     8,     8,     8,     8,
     &      8,     8,     7,     7,     8,     8,     9,     9,
     &      9,     9,     8,    10,    10,    10,     8,     8,
     &      8,     8,     8,     8,     7,     7,     8,     8,
     &      8,     8,     9,     9,     9,     9,     8,     8,
     &      8,     8,     8,     8,     8,     8,     8,     9,
     &      9,     9,     9,     9,     9,     9,     9,     9,
     &      9,    10,    11,    11,    11,    10,    10,     9,
     &      8,     8,     8,     8,     7,     7,     7,     7,
     &      8,     8,     9,     8,     8,     8,     8,     8,
     &      8,     8,     8,     8,     8,     8,     8,     7,
     &      7,     6,     7,     8,     8,     9,     9,     9,
     &      9,     9,     9,     9,     8,     7,     7,     7,
     &      7,     7,     7,     8,     8,     7,     7,     7,
     &      7,     7,     7,     7,     7,     7,     8,     8,
     &      8,     8,     8,     8,     8,     8,     8,     8,
     &      8,     8,     8,     7,     9,     9,     8,     7,
     &      7,     7,     7,     7,     7,     6,     7,     8,
     &      9,     9,     9,     8,     8,     8,     8,     8,
     &      7,     7,     8,     8,     8,     8,     8,     7,
     &      7,     7,     7,     7,     7,     7,     7,     7,
     &      8,     6,     6,     6,     6,     6,     6,     5,
     &      6,     6,     6,     6,     6,     6,     8,     8,
     &      8,     8,     7,     8,     8,    10,    10,    10,
     &      9,     9,     9,     9,     9,    10,    10,    10,
     &     10,    10,    10,    11,    10,     9,     8,     8,
     &      7,     7,     7,     7,     7,     7,     8,     8,
     &      8,     8,     9,     8,     8,    11,    12,    12,
     &     13,    15,    15,    16,    16,    16,    17,    17,
     &     17,    17,    18,    17,    18,    17,    17,    16,
     &     16,    16,    16,    16,    15,    15,    15,    15,
     &     16,    16,    16,    16,    17,    17,    17,    17,
     &     17,    17,    18,    18,    19,    20,    19,    19,
     &     19,    19,    19,    18,    18,    18,    18,    18,
     &     18,    18,    18,    17,    17,    17,    16,    16,
     &     16,    17,    16,    16,    16,    16,    16,    16,
     &     16,    16,    16,    16,    14,    14,    14,    14,
     &     14,    15,    15,    14,    13,    13,    13,    13,
     &     14,    14,    13,    13,    14,    14,    14,    14,
     &     12,    12,    12,    11,    11,    11,    12,    12,
     &     12,    12,    11,    11,    10,    10,    10,    10,
     &      9,     9,     9,     9,    10,    10,    10,    11,
     &     11,    13,    13,    13,    13,    13,    13,    12,
     &     12,    13,    14,    13,    14,    14,    14,    14,
     &     14,    14,    14,    14,    14,    15,    15,    15,
     &     15,    15,    15,    15,    15,    15,    15,    15,
     &     15,    14,    14,    14,    13,    13,    12,    13,
     &     13,    11,    11,    12,    12,    12,    12,    12,
     &     12,    12,    12,    12,    12,    12,    12,    12,
     &     13,    12,    13,    13,    13,    13,    13,    13,
     &     13,    13,    13,    13,    14,    13,    12,    11,
     &     12,    12,    12,    12,    13,    14,    14,    14,
     &     14,    15,    14,    13,    13,    13,    13,    12,
     &     12,    12,    12,    12,    12,    12,    12,    12,
     &     11,    12,    12,    12,    12,    12,    13,    14,
     &     14,    14,    14,    14,    14,    14,    14,    13,
     &     14,    13,    13,    14,    14,    14,    13,    13,
     &     12,    12,    12,    13,    13,    13,    12,    13,
     &     13,    13,    13,    11,    11,    11,    11,    11,
     &     11,    12,    12,    12,    12,    11,    10,    10,
     &     10,    10,    10,     9,     9,     9,     7,     7,
     &      7,     7,     7,     7,     7,     7,     7,     7,
     &      7,     8,    11,    11,    11,    10,    10,    10,
     &     11,    11,    11,    11,    12,    12,    13,    13,
     &     13,    13,    13,    13,    13,    14,    15,    15,
     &     16,    16,    16,    18,    16,    15,    16,    15,
     &     15,    15,    15,    16,    17,    17,    16,    18,
     &     18,    18,    19,    20,    20,    21,    21,    21,
     &     22,    21,    21,    21,    21,    21,    21,    21,
     &     18,    18,    18,    18,    17,    18,    19,    19,
     &     19,
     &     19,
     &     19,
     &     18,
     &     20/
c
      massi = hmass(1)
      massx = hmass(npoint)
      dmass = (massx-massi)/Real(npoint-1)
c      
      imass = int( (mh-massi)/dmass ) + 1
c
      if (imass.eq.npoint) then
        imass = npoint
        jmass = npoint
        rmass = 0.0
      Endif
cjm Modifie le 24Fevrier
      If (imass.le.0 .or. imass.gt.npoint) then
        A202_HGG_CAND = 0
        RETURN
      Endif
      If (imass.ge.1..and.imass.lt.npoint) then
        jmass = imass + 1
        rmass = mh - hmass(imass)
      endif
      If ( mh*10. - Real(INT(mh*10.)) .ne.0. .and.debug) then
        Print*,
     &'Warning : Number of data is interpolated !!! (A202_HGG_CAND)'
      Endif
c
      A202_HGG_CAND = INT( Real(idata(imass))+Real(idata(jmass)
     &     -idata(imass))*rmass/dmass + 0.5)
c
      RETURN
      END
      Real FUNCTION A2000_HGG_BACKG(mhiggs,sqrts,iana,err)
      Implicit none
      Real mhiggs
      Real sqrts
      Real*8 dsqrts
      Integer iana
c300 (iana=1) analyse flavor independante en totalite, efficacites sur ggluons
c301 (iana=2) analyse flavor independante et .not. bbbar, efficacites sur ggluons
c
      Real Bkg
      Real bkgpart
      Integer ibkg
      Integer nback,necms
      Parameter (nback = 7)     ! 7 bruits de fond a additionner
      Parameter (necms = 9)
c
      Logical first,err
      Data first /.TRUE./
c
      Integer i,j,k,indmh,im1,im2
      Real ecms(necms),mh,m1,m2
      Character*5 nameecms(necms)
      Integer genmc(nback,necms) ! Nombre d''evenements generes
      Data ecms     /201.3,204.0,205.0,206.0,206.7,207.0,208.0,209.0,210
     &     .0/
      Data nameecms /'201.6','204.0','205.0','206.0','206.7','207.0'
     &     ,'208.0','209.0','210.0'/
c genmc = 0 si MC n''existe pas
c et -1 si il existe, mais il reste a le processer
c                                 201.6  204    205    206    206.7  
      Data (genmc(1,i),i=1,necms)/100000,250000,250000,250000,0,
c          207    208    209    210
     &     250000,250000,250000,0/
      Data (genmc(2,i),i=1,necms)/50000 ,50000 ,50000 ,50000 ,250000,
     &     50000 ,50000,50000,  0/
      Data (genmc(3,i),i=1,necms)/100000,100000,0     ,100000,200000,
     &     400000,100000,0,     100000/
      Data (genmc(4,i),i=1,necms)/100000,100000,0     ,100000,200000,
     &     400000,100000,0,     100000/
      Data (genmc(5,i),i=1,necms)/95000 ,100000,0     ,100000,0,    
     &     400000,100000,0,     100000/
      Data (genmc(6,i),i=1,necms)/100000,100000,0     ,100000,0,    
     &     400000,100000,0,     100000/
      Data (genmc(7,i),i=1,necms)/100000,100000,0     ,100000,0,    
     &     400000,100000,0,     100000/
c
      Character*2 name(nback)
      Data name/'ww','zz','bb','cc','ss','dd','uu'/
cjm      Data name/'wwnew','zznew','bbnew','ccnew','ssnew','ddnew','uunew'/
c
      Character*50 file
c
      Integer j1,j2
      Integer nmhmax,niana
      Parameter (nmhmax = 1000)
      Integer tablebkg(751,nback,necms)
      Save tablebkg
c
      Integer imax,nevent,n1,n2
      Parameter (imax=1000000)
      Real mhmin,stepmh
      Parameter (mhmin = 40E0 , stepmh = 0.1E0)
c
      Real b,b1,b2
      Real bb,bb1,bb2
      Real tmp1,tmp2,errb1,errb2,errbb1,errbb2,errb,errbb,errpart,errbkg
c
      Real*8 al_xsect_ww,al_xsect_zz,al_xsect_bb,al_xsect_cc
     &     ,al_xsect_ss,al_xsect_dd,al_xsect_uu
      External al_xsect_ww,al_xsect_zz,al_xsect_bb,al_xsect_cc
     &     ,al_xsect_ss,al_xsect_dd,al_xsect_uu
c
      Integer writetable(47313),ind
      Data (writetable(i),i=       1,     800)/
     &    704,   703,   706,   709,   706,   707,   710,   711,
     &    709,   699,   697,   697,   682,   670,   666,   670,
     &    664,   668,   663,   659,   646,   645,   642,   654,
     &    646,   648,   646,   649,   635,   629,   627,   642,
     &    637,   638,   650,   660,   668,   675,   678,   675,
     &    687,   699,   699,   702,   706,   704,   706,   715,
     &    710,   719,   715,   710,   700,   695,   700,   709,
     &    720,   724,   723,   725,   727,   728,   733,   738,
     &    736,   745,   752,   758,   756,   756,   760,   770,
     &    774,   783,   791,   803,   810,   817,   818,   826,
     &    836,   856,   869,   878,   888,   895,   906,   904,
     &    911,   926,   938,   938,   944,   948,   944,   952,
     &    949,   967,   974,   980,   989,   977,   974,   967,
     &    964,   957,   948,   943,   944,   950,   940,   947,
     &    943,   936,   926,   927,   925,   929,   924,   926,
     &    918,   922,   921,   908,   910,   910,   912,   915,
     &    915,   915,   920,   915,   914,   911,   905,   906,
     &    908,   903,   906,   909,   913,   910,   911,   914,
     &    919,   916,   912,   925,   926,   927,   928,   936,
     &    941,   931,   935,   933,   939,   937,   946,   938,
     &    941,   940,   934,   928,   923,   927,   931,   938,
     &    958,   951,   960,   956,   958,   960,   965,   969,
     &    971,   969,   965,   977,   975,   970,   974,   987,
     &    986,   991,   981,   982,   985,   997,  1001,  1007,
     &   1013,  1019,  1013,  1014,  1022,  1028,  1030,  1045,
     &   1036,  1034,  1046,  1054,  1055,  1064,  1075,  1080,
     &   1075,  1066,  1073,  1078,  1091,  1098,  1105,  1108,
     &   1115,  1123,  1120,  1125,  1132,  1142,  1148,  1159,
     &   1169,  1178,  1190,  1191,  1197,  1221,  1229,  1236,
     &   1249,  1260,  1274,  1273,  1289,  1308,  1321,  1327,
     &   1345,  1364,  1382,  1391,  1401,  1411,  1419,  1431,
     &   1440,  1457,  1462,  1473,  1469,  1479,  1466,  1460,
     &   1460,  1453,  1437,  1440,  1431,  1433,  1432,  1425,
     &   1413,  1410,  1407,  1394,  1398,  1394,  1399,  1402,
     &   1397,  1404,  1407,  1402,  1410,  1412,  1404,  1396,
     &   1389,  1390,  1377,  1370,  1361,  1358,  1351,  1360,
     &   1359,  1357,  1356,  1358,  1351,  1347,  1354,  1357,
     &   1358,  1360,  1368,  1367,  1374,  1388,  1390,  1395,
     &   1409,  1426,  1440,  1456,  1469,  1491,  1506,  1517,
     &   1524,  1547,  1553,  1564,  1581,  1588,  1600,  1609,
     &   1621,  1635,  1651,  1675,  1694,  1708,  1721,  1734,
     &   1741,  1762,  1770,  1784,  1810,  1814,  1816,  1826,
     &   1849,  1864,  1899,  1918,  1930,  1956,  1968,  1987,
     &   2002,  2009,  2024,  2041,  2063,  2090,  2111,  2125,
     &   2144,  2149,  2148,  2163,  2184,  2187,  2195,  2225,
     &   2226,  2264,  2279,  2297,  2314,  2321,  2336,  2374,
     &   2412,  2449,  2471,  2513,  2544,  2581,  2607,  2637,
     &   2660,  2700,  2721,  2745,  2782,  2824,  2850,  2878,
     &   2899,  2948,  2991,  3028,  3056,  3080,  3122,  3151,
     &   3190,  3208,  3218,  3239,  3248,  3258,  3264,  3264,
     &   3290,  3274,  3263,  3257,  3246,  3221,  3193,  3164,
     &   3129,  3113,  3073,  3044,  3012,  2979,  2943,  2922,
     &   2885,  2854,  2837,  2823,  2793,  2757,  2731,  2700,
     &   2666,  2637,  2620,  2594,  2571,  2546,  2514,  2501,
     &   2475,  2454,  2426,  2415,  2403,  2382,  2382,  2369,
     &   2335,  2308,  2298,  2281,  2271,  2254,  2249,  2244,
     &   2241,  2248,  2238,  2232,  2238,  2244,  2243,  2226,
     &   2217,  2204,  2205,  2197,  2196,  2183,  2165,  2163,
     &   2164,  2172,  2173,  2165,  2156,  2141,  2128,  2111,
     &   2110,  2094,  2083,  2066,  2048,  2039,  2037,  2019,
     &   2010,  2010,  1995,  1993,  1967,  1959,  1947,  1940,
     &   1919,  1918,  1919,  1907,  1898,  1879,  1868,  1863,
     &   1846,  1836,  1834,  1828,  1821,  1804,  1781,  1755,
     &   1749,  1723,  1691,  1669,  1654,  1637,  1626,  1604,
     &   1591,  1574,  1551,  1534,  1528,  1500,  1491,  1484,
     &   1468,  1459,  1439,  1441,  1431,  1415,  1411,  1395,
     &   1380,  1364,  1344,  1319,  1313,  1300,  1296,  1292,
     &   1282,  1275,  1276,  1281,  1266,  1266,  1267,  1265,
     &   1246,  1245,  1258,  1263,  1266,  1259,  1271,  1253,
     &   1241,  1231,  1222,  1210,  1215,  1209,  1208,  1193,
     &   1174,  1173,  1166,  1163,  1154,  1149,  1144,  1148,
     &   1145,  1143,  1129,  1117,  1109,  1101,  1110,  1106,
     &   1092,  1085,  1077,  1070,  1073,  1071,  1063,  1058,
     &   1056,  1052,  1050,  1042,  1044,  1046,  1041,  1040,
     &   1047,  1030,  1026,  1021,  1017,  1023,  1020,  1023,
     &   1018,  1009,  1001,  1001,   993,   982,   966,   965,
     &    962,   953,   948,   943,   935,   929,   925,   914,
     &    911,   905,   911,   909,   904,   900,   895,   895,
     &    882,   880,   866,   863,   861,   858,   851,   843,
     &    828,   822,   809,   799,   797,   793,   779,   776,
     &    779,   773,   765,   767,   759,   744,   735,   724,
     &    714,   691,   677,   652,   636,   614,   609,   603,
     &    593,   581,   572,   563,   550,   543,   535,   533,
     &    532,   525,   522,   513,   495,   482,   480,   471,
     &    473,   472,   467,   458,   453,   448,   441,   436,
     &    426,   418,   414,   409,   403,   394,   382,   372,
     &    365,   352,   336,   323,   322,   314,   306,   295,
     &    285,   274,   265,   253,   241,   225,   217,   202,
     &    186,   172,   165,   157,   154,   143,   136,   130,
     &    118,   107,   103,    98,    93,    87,    81,    71,
     &     67,    64,    61,    57,    55,    52,    48,    44,
     &     43,    40,    38,    33,    33,    30,    29,    25,
     &     23,    20,    20,    18,    17,    16,    14,    12,
     &     13,    12,    12,    12,    11,    11,    11,   202,
     &    203,   200,   197,   196,   194,   193,   193,   195,
     &    195,   196,   195,   197,   193,   189,   192,   189,
     &    188,   182,   182,   176,   176,   174,   178,   178,
     &    180,   180,   184,   184,   180,   180,   185,   184,
     &    189,   189,   190,   193,   194,   194,   196,   199,
     &    202,   202,   202,   209,   210,   211,   213,   223/
      Data (writetable(i),i=     801,    1600)/
     &    223,   223,   224,   223,   225,   232,   229,   225,
     &    225,   230,   235,   231,   230,   228,   229,   231,
     &    230,   233,   227,   226,   227,   230,   234,   236,
     &    238,   235,   233,   236,   238,   235,   237,   238,
     &    237,   239,   245,   248,   253,   257,   257,   259,
     &    259,   261,   264,   266,   269,   275,   279,   286,
     &    296,   300,   306,   315,   315,   315,   317,   318,
     &    317,   311,   311,   317,   313,   312,   310,   311,
     &    307,   304,   303,   292,   294,   293,   295,   288,
     &    290,   287,   290,   288,   288,   282,   285,   282,
     &    281,   283,   285,   284,   279,   278,   274,   272,
     &    272,   271,   270,   273,   275,   270,   267,   264,
     &    262,   259,   259,   258,   259,   254,   251,   251,
     &    253,   252,   249,   249,   252,   254,   257,   257,
     &    255,   252,   255,   256,   253,   251,   251,   251,
     &    250,   249,   249,   246,   254,   256,   258,   264,
     &    267,   269,   266,   267,   266,   267,   268,   274,
     &    270,   267,   268,   266,   264,   270,   269,   267,
     &    266,   265,   264,   266,   270,   272,   272,   269,
     &    269,   270,   273,   272,   271,   272,   271,   272,
     &    271,   268,   271,   271,   273,   275,   275,   280,
     &    285,   282,   284,   284,   288,   293,   295,   293,
     &    292,   297,   298,   303,   302,   293,   293,   295,
     &    305,   315,   315,   321,   321,   325,   331,   336,
     &    337,   339,   344,   343,   348,   344,   351,   355,
     &    357,   360,   366,   365,   370,   367,   369,   372,
     &    369,   371,   369,   364,   361,   358,   356,   353,
     &    353,   352,   348,   338,   338,   333,   330,   335,
     &    330,   323,   324,   321,   324,   328,   331,   327,
     &    326,   330,   331,   329,   327,   328,   325,   322,
     &    319,   315,   315,   314,   311,   300,   301,   309,
     &    310,   307,   308,   310,   311,   309,   314,   316,
     &    320,   326,   327,   335,   343,   340,   344,   347,
     &    349,   351,   349,   346,   348,   346,   340,   340,
     &    337,   336,   342,   346,   348,   353,   363,   367,
     &    369,   370,   368,   371,   370,   373,   376,   371,
     &    378,   382,   385,   381,   387,   392,   390,   391,
     &    399,   407,   411,   412,   411,   418,   417,   427,
     &    426,   428,   433,   434,   438,   447,   459,   461,
     &    462,   465,   470,   479,   486,   496,   510,   516,
     &    520,   534,   535,   543,   543,   547,   562,   572,
     &    576,   590,   598,   611,   618,   629,   643,   659,
     &    675,   682,   698,   712,   723,   733,   740,   753,
     &    763,   773,   776,   784,   792,   800,   797,   809,
     &    811,   821,   833,   837,   841,   847,   854,   858,
     &    863,   868,   877,   883,   891,   895,   903,   905,
     &    910,   915,   923,   928,   939,   946,   955,   972,
     &    983,   998,  1002,  1007,  1036,  1054,  1064,  1073,
     &   1084,  1097,  1111,  1128,  1145,  1148,  1174,  1169,
     &   1190,  1211,  1221,  1236,  1243,  1250,  1264,  1289,
     &   1308,  1327,  1347,  1383,  1407,  1420,  1445,  1470,
     &   1492,  1503,  1526,  1555,  1572,  1591,  1626,  1660,
     &   1683,  1703,  1726,  1747,  1772,  1800,  1827,  1842,
     &   1874,  1905,  1932,  1950,  1983,  2008,  2035,  2054,
     &   2084,  2112,  2130,  2142,  2163,  2194,  2203,  2228,
     &   2242,  2264,  2289,  2299,  2331,  2338,  2361,  2373,
     &   2400,  2416,  2426,  2461,  2457,  2455,  2455,  2449,
     &   2452,  2444,  2442,  2437,  2431,  2420,  2422,  2419,
     &   2443,  2449,  2443,  2438,  2439,  2443,  2449,  2447,
     &   2447,  2423,  2408,  2380,  2368,  2352,  2340,  2329,
     &   2298,  2251,  2213,  2200,  2171,  2140,  2127,  2094,
     &   2062,  2029,  1990,  1969,  1949,  1921,  1893,  1878,
     &   1858,  1820,  1789,  1753,  1729,  1701,  1666,  1639,
     &   1630,  1617,  1600,  1594,  1580,  1572,  1555,  1527,
     &   1498,  1483,  1475,  1460,  1449,  1426,  1417,  1403,
     &   1380,  1363,  1352,  1339,  1335,  1318,  1307,  1292,
     &   1273,  1265,  1252,  1230,  1216,  1209,  1208,  1198,
     &   1201,  1193,  1185,  1183,  1167,  1156,  1145,  1141,
     &   1130,  1115,  1100,  1084,  1072,  1065,  1053,  1043,
     &   1031,  1016,  1005,   995,   994,   985,   970,   954,
     &    943,   937,   916,   903,   893,   881,   873,   859,
     &    848,   832,   824,   824,   809,   798,   783,   768,
     &    762,   753,   740,   732,   723,   715,   704,   689,
     &    675,   667,   651,   647,   634,   614,   608,   598,
     &    587,   575,   560,   548,   530,   519,   503,   495,
     &    490,   477,   467,   458,   453,   442,   430,   422,
     &    413,   410,   403,   398,   383,   373,   373,   367,
     &    364,   349,   343,   331,   331,   330,   318,   307,
     &    304,   298,   292,   280,   271,   265,   261,   253,
     &    248,   243,   239,   233,   226,   217,   213,   207,
     &    198,   191,   180,   174,   173,   170,   165,   156,
     &    147,   145,   136,   132,   125,   108,    97,    89,
     &     85,    77,    68,    64,    53,    48,    45,    42,
     &     38,    33,    32,    27,    24,    22,    21,    17,
     &     16,    16,    15,    14,    13,    11,     9,     8,
     &      8,     7,     7,     7,     7,     7,     7,     7,
     &      7,     6,     6,     5,     5,     5,     4,     4,
     &      4,     4,     4,     4,     4,     3,    21,    22,
     &     23,    22,    20,    20,    20,    22,    22,    23,
     &     22,    22,    21,    21,    20,    19,    19,    20,
     &     20,    20,    20,    20,    19,    19,    18,    19,
     &     20,    21,    21,    21,    22,    23,    25,    25,
     &     26,    27,    26,    26,    28,    28,    26,    28,
     &     29,    29,    28,    29,    28,    28,    28,    28,
     &     28,    27,    27,    27,    27,    26,    26,    26,
     &     24,    26,    27,    27,    27,    27,    27,    27,
     &     27,    26,    26,    24,    24,    22,    22,    24,
     &     25,    26,    28,    28,    29,    29,    29,    29,
     &     31,    32,    33,    33,    33,    33,    33,    32,
     &     33,    34,    35,    34,    34,    32,    32,    32/
      Data (writetable(i),i=    1601,    2400)/
     &     33,    32,    32,    29,    28,    26,    26,    25,
     &     25,    26,    26,    26,    26,    27,    28,    26,
     &     26,    26,    27,    26,    26,    25,    24,    27,
     &     27,    27,    26,    25,    22,    21,    22,    23,
     &     23,    23,    23,    23,    23,    24,    23,    23,
     &     22,    22,    22,    23,    25,    25,    25,    25,
     &     24,    23,    23,    23,    23,    24,    24,    24,
     &     22,    20,    20,    18,    19,    20,    23,    23,
     &     22,    23,    23,    23,    23,    24,    26,    26,
     &     26,    27,    26,    29,    29,    28,    28,    28,
     &     29,    29,    27,    26,    26,    27,    26,    25,
     &     26,    26,    26,    27,    27,    25,    25,    25,
     &     24,    23,    24,    24,    24,    24,    24,    22,
     &     22,    23,    23,    23,    24,    23,    23,    23,
     &     23,    23,    22,    21,    21,    21,    22,    22,
     &     22,    22,    22,    21,    21,    21,    21,    22,
     &     22,    21,    20,    21,    22,    22,    22,    20,
     &     20,    19,    19,    17,    17,    17,    16,    16,
     &     16,    16,    16,    17,    17,    17,    16,    16,
     &     15,    15,    15,    16,    16,    14,    14,    15,
     &     16,    17,    17,    18,    18,    18,    18,    18,
     &     17,    17,    17,    17,    17,    17,    16,    16,
     &     15,    15,    17,    18,    19,    19,    19,    19,
     &     19,    20,    19,    19,    17,    17,    17,    16,
     &     16,    15,    16,    17,    17,    18,    17,    16,
     &     16,    15,    15,    14,    16,    16,    17,    17,
     &     18,    19,    21,    22,    21,    21,    21,    21,
     &     20,    20,    21,    21,    23,    23,    23,    24,
     &     25,    25,    25,    26,    24,    24,    25,    23,
     &     23,    24,    24,    24,    23,    25,    26,    26,
     &     26,    29,    29,    31,    31,    32,    32,    32,
     &     30,    30,    29,    29,    28,    29,    28,    28,
     &     28,    29,    30,    31,    30,    30,    28,    28,
     &     28,    28,    28,    28,    30,    30,    30,    31,
     &     30,    32,    33,    33,    31,    31,    30,    30,
     &     30,    28,    29,    28,    31,    32,    32,    31,
     &     31,    30,    29,    32,    33,    34,    36,    38,
     &     38,    38,    39,    36,    36,    36,    35,    35,
     &     35,    35,    34,    34,    32,    32,    31,    31,
     &     32,    33,    33,    34,    35,    38,    37,    36,
     &     36,    35,    35,    36,    37,    37,    36,    37,
     &     37,    37,    36,    36,    36,    35,    35,    35,
     &     34,    34,    35,    35,    35,    34,    33,    32,
     &     30,    30,    29,    30,    29,    27,    28,    25,
     &     26,    26,    26,    26,    27,    27,    27,    27,
     &     27,    27,    27,    27,    28,    28,    28,    28,
     &     28,    29,    30,    30,    32,    33,    33,    33,
     &     32,    31,    31,    31,    32,    33,    31,    31,
     &     32,    32,    34,    36,    36,    34,    34,    35,
     &     36,    37,    38,    38,    41,    41,    41,    44,
     &     46,    46,    45,    46,    46,    47,    48,    50,
     &     50,    49,    48,    48,    48,    47,    46,    47,
     &     47,    49,    49,    49,    48,    49,    47,    46,
     &     48,    49,    49,    49,    49,    53,    54,    53,
     &     53,    54,    53,    52,    52,    53,    53,    54,
     &     52,    50,    52,    49,    51,    51,    49,    50,
     &     52,    52,    52,    52,    54,    56,    55,    56,
     &     57,    57,    56,    55,    54,    54,    53,    54,
     &     53,    53,    54,    54,    54,    55,    55,    55,
     &     54,    58,    58,    57,    58,    58,    60,    61,
     &     63,    64,    67,    67,    67,    68,    69,    70,
     &     70,    72,    74,    76,    76,    76,    77,    74,
     &     71,    71,    73,    73,    74,    76,    76,    76,
     &     76,    77,    76,    74,    72,    70,    69,    69,
     &     70,    69,    68,    68,    67,    68,    68,    67,
     &     66,    63,    61,    60,    59,    59,    57,    55,
     &     55,    54,    54,    53,    52,    52,    52,    53,
     &     51,    51,    49,    49,    49,    48,    45,    43,
     &     43,    43,    44,    44,    43,    41,    39,    37,
     &     37,    36,    37,    36,    34,    33,    35,    33,
     &     32,    30,    30,    29,    31,    28,    28,    27,
     &     27,    27,    26,    25,    25,    26,    25,    24,
     &     24,    22,    23,    23,    21,    20,    20,    19,
     &     20,    21,    21,    23,    22,    21,    21,    21,
     &     20,    17,    16,    16,    15,    15,    15,    16,
     &     15,    14,    13,    13,    13,    12,    12,     9,
     &      8,     7,     5,     5,     4,     4,     4,     4,
     &      4,     4,     4,     4,     4,     4,     4,     4,
     &      4,     4,     4,     4,     4,     2,     2,     2,
     &      2,     2,     2,     2,     1,     1,     1,     1,
     &      1,     1,     1,     1,     1,     1,     1,     1,
     &      1,     1,     1,     1,     1,    38,    36,    36,
     &     36,    34,    33,    31,    31,    32,    32,    33,
     &     32,    31,    30,    30,    32,    32,    29,    29,
     &     30,    31,    33,    33,    34,    36,    36,    37,
     &     38,    39,    39,    40,    40,    41,    41,    42,
     &     40,    40,    41,    41,    40,    35,    35,    34,
     &     34,    34,    34,    34,    34,    35,    35,    36,
     &     38,    36,    35,    34,    34,    33,    35,    35,
     &     36,    38,    37,    35,    34,    33,    34,    35,
     &     36,    36,    39,    39,    36,    37,    39,    39,
     &     42,    42,    45,    45,    44,    45,    46,    47,
     &     45,    45,    45,    44,    44,    44,    44,    43,
     &     42,    43,    44,    44,    44,    47,    46,    48,
     &     48,    48,    48,    48,    46,    45,    44,    44,
     &     44,    43,    43,    43,    43,    43,    43,    43,
     &     43,    41,    40,    39,    39,    38,    37,    35,
     &     34,    32,    33,    33,    33,    32,    32,    31,
     &     32,    31,    29,    29,    28,    28,    28,    27,
     &     28,    27,    27,    28,    28,    26,    26,    26/
      Data (writetable(i),i=    2401,    3200)/
     &     27,    27,    28,    29,    29,    29,    30,    29,
     &     28,    28,    28,    28,    30,    29,    30,    30,
     &     30,    30,    31,    31,    32,    34,    35,    36,
     &     38,    37,    37,    36,    35,    35,    33,    33,
     &     33,    31,    32,    32,    32,    32,    32,    32,
     &     32,    32,    31,    31,    30,    31,    31,    32,
     &     32,    32,    32,    31,    31,    31,    31,    30,
     &     30,    31,    31,    31,    30,    28,    28,    29,
     &     28,    28,    28,    29,    29,    29,    30,    31,
     &     32,    32,    29,    30,    29,    28,    28,    30,
     &     31,    31,    31,    31,    31,    32,    33,    33,
     &     33,    36,    35,    37,    37,    37,    37,    36,
     &     36,    37,    38,    37,    37,    38,    39,    43,
     &     43,    44,    44,    45,    45,    44,    44,    43,
     &     43,    41,    42,    42,    43,    45,    45,    44,
     &     42,    41,    40,    39,    39,    36,    36,    36,
     &     35,    36,    36,    36,    35,    34,    34,    36,
     &     35,    34,    36,    36,    36,    37,    36,    35,
     &     35,    35,    34,    35,    33,    33,    30,    28,
     &     28,    28,    27,    28,    29,    28,    27,    27,
     &     26,    26,    27,    28,    31,    30,    30,    30,
     &     29,    28,    28,    28,    30,    30,    29,    31,
     &     32,    32,    31,    31,    31,    32,    32,    32,
     &     34,    34,    34,    35,    34,    35,    36,    36,
     &     38,    38,    37,    39,    41,    44,    45,    46,
     &     47,    50,    50,    50,    48,    48,    50,    50,
     &     51,    54,    56,    55,    54,    53,    55,    55,
     &     52,    50,    50,    51,    52,    54,    56,    56,
     &     57,    59,    60,    62,    63,    63,    64,    63,
     &     66,    69,    70,    70,    73,    74,    75,    76,
     &     76,    77,    77,    76,    79,    81,    81,    82,
     &     83,    83,    84,    84,    84,    84,    84,    85,
     &     85,    85,    84,    82,    77,    76,    76,    75,
     &     77,    76,    75,    74,    75,    74,    73,    73,
     &     72,    72,    69,    70,    70,    72,    71,    72,
     &     72,    71,    68,    67,    67,    66,    69,    69,
     &     69,    71,    73,    72,    74,    74,    74,    73,
     &     74,    75,    79,    76,    77,    79,    78,    79,
     &     80,    79,    80,    78,    78,    75,    74,    75,
     &     77,    79,    79,    80,    81,    82,    82,    77,
     &     78,    78,    79,    78,    77,    77,    80,    79,
     &     82,    81,    82,    82,    80,    80,    79,    79,
     &     79,    79,    78,    77,    78,    80,    80,    81,
     &     79,    79,    82,    80,    80,    81,    81,    82,
     &     82,    82,    82,    78,    80,    80,    78,    77,
     &     76,    75,    74,    70,    69,    71,    71,    70,
     &     68,    64,    63,    62,    62,    61,    61,    60,
     &     59,    57,    58,    60,    60,    60,    61,    61,
     &     61,    61,    60,    62,    62,    65,    64,    66,
     &     68,    71,    70,    74,    77,    79,    82,    81,
     &     84,    89,    90,    91,    91,    90,    90,    92,
     &     90,    89,    90,    92,    92,    92,    92,    91,
     &     94,    93,    94,    95,    97,    99,    99,    99,
     &    102,   101,    99,    99,    98,   100,    97,    98,
     &     98,   101,    99,    96,    96,    99,    98,   101,
     &    101,   103,   105,   106,   105,   106,   106,   108,
     &    111,   110,   111,   112,   113,   113,   113,   114,
     &    113,   114,   112,   110,   112,   114,   113,   113,
     &    113,   112,   115,   116,   118,   118,   118,   119,
     &    121,   119,   120,   116,   114,   115,   117,   117,
     &    114,   114,   114,   112,   114,   114,   115,   115,
     &    109,   107,   108,   106,   106,   105,   103,   100,
     &     99,    96,    93,    94,    90,    88,    89,    86,
     &     83,    81,    79,    77,    76,    75,    76,    74,
     &     69,    65,    62,    56,    56,    55,    54,    50,
     &     48,    48,    48,    45,    45,    44,    42,    39,
     &     41,    40,    40,    39,    38,    36,    37,    37,
     &     38,    36,    35,    33,    31,    30,    32,    31,
     &     32,    30,    25,    25,    24,    24,    24,    23,
     &     22,    19,    17,    17,    17,    14,    13,     9,
     &      9,     8,     6,     5,     5,     5,     5,     4,
     &      4,     4,     4,     4,     4,     4,     4,     4,
     &      4,     4,     4,     4,     4,     4,     4,     4,
     &      3,     2,     2,     2,     2,     2,     2,     2,
     &      2,     1,     1,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,    18,    18,    18,    18,
     &     19,    20,    20,    21,    22,    21,    20,    21,
     &     22,    21,    21,    21,    22,    22,    21,    21,
     &     21,    20,    19,    19,    18,    18,    18,    16,
     &     17,    17,    16,    15,    15,    15,    14,    14,
     &     14,    13,    14,    14,    14,    14,    13,    13,
     &     13,    13,    13,    13,    12,    12,    11,    11,
     &     11,    11,    12,    12,    12,    13,    13,    13,
     &     14,    15,    16,    16,    16,    16,    18,    18,
     &     18,    19,    20,    20,    22,    21,    23,    22,
     &     22,    22,    22,    23,    24,    24,    24,    24,
     &     24,    24,    24,    24,    24,    25,    25,    26,
     &     27,    27,    27,    27,    27,    28,    30,    30,
     &     31,    31,    32,    31,    31,    32,    31,    30,
     &     29,    28,    29,    28,    28,    28,    26,    26,
     &     27,    26,    24,    24,    23,    21,    21,    22,
     &     22,    22,    21,    21,    21,    21,    22,    23,
     &     22,    24,    23,    23,    24,    24,    24,    24,
     &     24,    26,    25,    25,    25,    25,    24,    24,
     &     25,    24,    24,    25,    25,    25,    24,    22,
     &     22,    22,    22,    22,    22,    21,    21,    21,
     &     20,    20,    18,    18,    16,    16,    16,    16,
     &     17,    17,    16,    16,    17,    17,    17,    17,
     &     17,    17,    17,    17,    17,    16,    17,    16,
     &     16,    16,    15,    15,    15,    16,    16,    16/
      Data (writetable(i),i=    3201,    4000)/
     &     15,    17,    17,    17,    17,    18,    18,    17,
     &     17,    18,    17,    16,    14,    13,    13,    14,
     &     14,    14,    15,    15,    17,    17,    19,    19,
     &     20,    21,    21,    21,    20,    20,    20,    20,
     &     20,    20,    20,    20,    20,    21,    20,    19,
     &     18,    18,    17,    17,    17,    17,    17,    17,
     &     17,    19,    19,    20,    20,    20,    20,    23,
     &     23,    23,    22,    22,    23,    23,    23,    23,
     &     23,    23,    24,    23,    23,    22,    21,    22,
     &     22,    22,    22,    22,    23,    23,    21,    21,
     &     20,    19,    18,    17,    18,    17,    17,    17,
     &     18,    19,    20,    20,    20,    20,    20,    19,
     &     20,    20,    19,    19,    18,    20,    22,    22,
     &     21,    21,    21,    20,    20,    20,    21,    20,
     &     21,    22,    22,    22,    22,    22,    21,    23,
     &     23,    23,    22,    24,    24,    24,    24,    24,
     &     24,    24,    23,    23,    23,    22,    22,    23,
     &     23,    22,    24,    24,    24,    24,    23,    24,
     &     25,    25,    27,    27,    29,    30,    31,    30,
     &     31,    32,    31,    32,    34,    33,    34,    33,
     &     31,    31,    30,    31,    31,    30,    30,    29,
     &     28,    27,    27,    28,    29,    28,    28,    28,
     &     28,    29,    29,    32,    33,    34,    34,    35,
     &     35,    36,    37,    38,    41,    42,    42,    43,
     &     42,    42,    43,    44,    44,    44,    42,    43,
     &     43,    43,    42,    44,    42,    42,    42,    42,
     &     42,    42,    43,    42,    44,    44,    44,    44,
     &     42,    41,    40,    39,    40,    40,    38,    39,
     &     40,    39,    39,    37,    38,    38,    39,    39,
     &     39,    41,    41,    42,    43,    44,    43,    44,
     &     44,    46,    46,    46,    47,    47,    48,    51,
     &     52,    52,    52,    50,    50,    49,    49,    49,
     &     50,    49,    49,    49,    48,    47,    45,    45,
     &     47,    46,    46,    48,    46,    48,    49,    49,
     &     49,    49,    51,    51,    50,    50,    49,    49,
     &     49,    51,    50,    50,    49,    49,    49,    49,
     &     46,    45,    46,    47,    49,    49,    50,    49,
     &     49,    47,    48,    47,    46,    47,    46,    46,
     &     48,    49,    47,    46,    48,    47,    45,    45,
     &     46,    45,    45,    44,    44,    43,    44,    46,
     &     45,    44,    45,    46,    46,    45,    46,    47,
     &     46,    47,    49,    50,    51,    53,    54,    54,
     &     53,    56,    54,    55,    53,    53,    50,    51,
     &     51,    51,    51,    54,    56,    60,    61,    61,
     &     61,    61,    62,    62,    62,    62,    65,    66,
     &     66,    66,    70,    71,    72,    72,    74,    74,
     &     74,    73,    73,    71,    72,    73,    73,    73,
     &     75,    78,    80,    82,    84,    85,    84,    83,
     &     82,    83,    84,    87,    86,    85,    85,    83,
     &     84,    84,    84,    84,    84,    83,    85,    84,
     &     84,    84,    84,    81,    80,    80,    80,    79,
     &     77,    78,    79,    79,    76,    74,    73,    73,
     &     74,    71,    70,    73,    72,    70,    68,    69,
     &     69,    69,    68,    67,    67,    67,    68,    67,
     &     66,    64,    65,    63,    62,    63,    63,    62,
     &     61,    61,    61,    61,    61,    60,    61,    62,
     &     61,    59,    57,    55,    53,    51,    48,    47,
     &     47,    46,    45,    42,    42,    41,    41,    37,
     &     38,    37,    36,    36,    36,    34,    32,    32,
     &     32,    29,    29,    27,    28,    28,    28,    26,
     &     27,    26,    26,    27,    27,    25,    24,    23,
     &     22,    21,    21,    19,    19,    19,    18,    18,
     &     17,    17,    17,    16,    16,    15,    15,    13,
     &     11,     9,     9,     8,     7,     6,     6,     4,
     &      4,     4,     4,     4,     4,     4,     3,     3,
     &      2,     2,     2,     2,     2,     2,     2,     2,
     &      2,     2,     2,     2,     2,     2,     2,     1,
     &      1,     1,     1,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,    27,    25,    25,    25,    25,
     &     25,    23,    23,    23,    23,    21,    22,    22,
     &     22,    22,    23,    23,    21,    20,    19,    18,
     &     17,    17,    17,    16,    15,    16,    16,    16,
     &     16,    17,    18,    18,    17,    17,    18,    18,
     &     17,    17,    18,    17,    17,    18,    19,    18,
     &     18,    18,    17,    18,    18,    18,    18,    18,
     &     20,    22,    22,    22,    21,    22,    22,    22,
     &     22,    23,    23,    24,    23,    23,    23,    23,
     &     25,    25,    25,    25,    25,    26,    26,    25,
     &     25,    25,    25,    23,    25,    26,    26,    26,
     &     28,    29,    28,    27,    27,    27,    26,    26,
     &     26,    26,    26,    25,    25,    27,    27,    28,
     &     28,    26,    26,    24,    24,    25,    26,    26,
     &     27,    27,    27,    26,    25,    26,    25,    25,
     &     27,    26,    25,    25,    25,    24,    24,    23,
     &     23,    23,    23,    25,    24,    24,    23,    22,
     &     22,    24,    24,    24,    24,    25,    25,    23,
     &     23,    22,    22,    22,    22,    21,    23,    23,
     &     22,    22,    23,    22,    20,    19,    18,    19,
     &     19,    19,    19,    19,    19,    19,    21,    21,
     &     20,    20,    19,    19,    19,    19,    19,    19,
     &     18,    19,    20,    22,    23,    24,    25,    26,
     &     24,    23,    22,    23,    23,    21,    21,    22,
     &     22,    22,    22,    22,    20,    21,    21,    20,
     &     21,    22,    22,    23,    24,    25,    25,    25,
     &     25,    23,    23,    24,    24,    23,    23,    24,
     &     25,    26,    26,    26,    26,    27,    27,    28,
     &     26,    26,    26,    26,    27,    27,    27,    29,
     &     30,    32,    32,    32,    32,    30,    31,    30,
     &     30,    31,    32,    34,    35,    33,    34,    34/
      Data (writetable(i),i=    4001,    4800)/
     &     33,    34,    34,    32,    31,    30,    30,    30,
     &     29,    29,    28,    28,    28,    28,    29,    29,
     &     28,    27,    27,    27,    27,    27,    27,    28,
     &     26,    22,    24,    23,    21,    21,    21,    22,
     &     21,    21,    21,    21,    20,    20,    20,    18,
     &     18,    17,    16,    15,    15,    14,    14,    14,
     &     16,    15,    15,    14,    14,    14,    14,    13,
     &     13,    14,    14,    14,    14,    14,    15,    16,
     &     16,    16,    16,    16,    16,    16,    17,    17,
     &     16,    18,    19,    18,    18,    18,    18,    17,
     &     17,    19,    20,    16,    16,    15,    16,    17,
     &     17,    17,    16,    16,    16,    17,    17,    17,
     &     16,    15,    15,    16,    17,    17,    19,    19,
     &     18,    17,    17,    17,    17,    16,    16,    16,
     &     15,    16,    17,    16,    17,    18,    17,    18,
     &     19,    20,    20,    22,    22,    22,    22,    23,
     &     22,    23,    23,    24,    24,    23,    23,    24,
     &     24,    24,    25,    27,    27,    29,    30,    30,
     &     33,    34,    36,    36,    37,    36,    34,    34,
     &     34,    35,    37,    36,    35,    36,    36,    36,
     &     36,    35,    34,    34,    34,    34,    36,    36,
     &     36,    36,    36,    37,    37,    37,    35,    37,
     &     36,    37,    39,    39,    39,    42,    42,    42,
     &     40,    41,    42,    43,    43,    43,    42,    42,
     &     41,    40,    39,    39,    39,    40,    41,    43,
     &     42,    41,    45,    44,    45,    45,    47,    47,
     &     47,    47,    47,    49,    48,    48,    49,    49,
     &     49,    50,    49,    49,    49,    49,    50,    49,
     &     48,    49,    49,    48,    49,    49,    48,    48,
     &     48,    49,    48,    47,    48,    48,    48,    48,
     &     47,    46,    47,    47,    48,    48,    48,    49,
     &     49,    48,    49,    49,    51,    52,    53,    53,
     &     52,    50,    50,    48,    49,    49,    49,    49,
     &     46,    47,    46,    45,    43,    44,    43,    43,
     &     42,    43,    42,    42,    41,    41,    39,    39,
     &     41,    43,    43,    43,    44,    47,    46,    47,
     &     48,    48,    49,    48,    49,    49,    52,    53,
     &     53,    53,    55,    57,    57,    57,    58,    58,
     &     58,    60,    57,    58,    56,    55,    55,    54,
     &     56,    56,    55,    57,    59,    57,    57,    56,
     &     57,    59,    59,    60,    59,    59,    60,    61,
     &     62,    63,    63,    64,    63,    63,    64,    65,
     &     67,    67,    68,    68,    70,    68,    65,    65,
     &     63,    63,    66,    66,    65,    65,    66,    66,
     &     69,    71,    72,    72,    71,    71,    72,    72,
     &     72,    71,    69,    70,    70,    70,    71,    72,
     &     72,    71,    69,    68,    70,    71,    70,    70,
     &     70,    70,    72,    70,    70,    70,    70,    70,
     &     70,    68,    68,    67,    65,    62,    62,    62,
     &     62,    62,    58,    53,    51,    50,    49,    49,
     &     46,    44,    43,    43,    40,    40,    40,    38,
     &     38,    39,    38,    39,    38,    36,    34,    34,
     &     32,    32,    29,    28,    28,    28,    26,    25,
     &     23,    23,    23,    22,    22,    20,    19,    17,
     &     17,    17,    17,    17,    17,    16,    16,    14,
     &     13,    12,    12,    12,    12,    12,     9,     7,
     &      6,     6,     6,     6,     6,     6,     6,     5,
     &      4,     4,     3,     2,     2,     2,     2,     2,
     &      2,     2,     2,     1,     1,     1,     1,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,    47,    47,    45,    44,    44,    44,
     &     44,    42,    41,    41,    40,    39,    40,    41,
     &     42,    41,    39,    40,    40,    38,    36,    35,
     &     36,    36,    38,    38,    38,    39,    38,    36,
     &     37,    35,    36,    36,    36,    36,    36,    36,
     &     35,    36,    35,    35,    35,    34,    34,    34,
     &     34,    33,    33,    34,    36,    36,    37,    38,
     &     40,    39,    40,    39,    39,    37,    38,    37,
     &     37,    38,    38,    37,    37,    38,    37,    37,
     &     38,    37,    36,    35,    35,    35,    35,    38,
     &     39,    40,    41,    42,    42,    42,    42,    42,
     &     41,    40,    42,    42,    40,    40,    40,    39,
     &     40,    41,    42,    44,    46,    45,    46,    46,
     &     45,    44,    41,    38,    39,    40,    42,    40,
     &     40,    39,    39,    38,    38,    38,    37,    37,
     &     37,    40,    41,    39,    37,    37,    38,    40,
     &     41,    41,    42,    44,    44,    44,    43,    42,
     &     40,    40,    39,    39,    38,    37,    38,    39,
     &     40,    40,    39,    37,    38,    38,    37,    39,
     &     38,    38,    36,    35,    35,    36,    36,    36,
     &     36,    36,    35,    35,    35,    35,    34,    32,
     &     33,    32,    33,    32,    33,    34,    36,    36,
     &     36,    36,    36,    34,    34,    36,    35,    33,
     &     34,    35,    35,    32,    30,    30,    30,    30,
     &     30,    31,    31,    30,    28,    29,    29,    30,
     &     30,    30,    30,    29,    28,    28,    27,    28,
     &     29,    27,    28,    28,    28,    30,    33,    34,
     &     36,    36,    35,    34,    33,    33,    33,    35,
     &     37,    38,    40,    42,    43,    44,    44,    44,
     &     41,    43,    43,    42,    43,    42,    42,    40,
     &     40,    41,    42,    43,    41,    43,    42,    42,
     &     43,    43,    44,    44,    45,    44,    44,    45,
     &     48,    47,    46,    44,    44,    42,    41,    41,
     &     41,    43,    42,    43,    43,    44,    45,    45,
     &     44,    41,    41,    42,    44,    43,    43,    43,
     &     43,    40,    39,    39,    38,    38,    39,    40,
     &     38,    39,    39,    39,    38,    39,    39,    39/
      Data (writetable(i),i=    4801,    5600)/
     &     38,    37,    37,    36,    35,    35,    35,    36,
     &     34,    35,    37,    38,    36,    36,    36,    38,
     &     37,    37,    37,    36,    36,    36,    38,    37,
     &     37,    38,    37,    37,    37,    37,    37,    36,
     &     37,    38,    38,    39,    39,    40,    39,    40,
     &     39,    40,    41,    41,    40,    41,    42,    43,
     &     45,    47,    47,    45,    44,    45,    43,    43,
     &     43,    44,    44,    45,    43,    43,    43,    42,
     &     44,    43,    42,    43,    45,    45,    44,    44,
     &     43,    43,    42,    43,    44,    44,    46,    47,
     &     48,    49,    53,    56,    57,    58,    59,    59,
     &     58,    60,    64,    65,    64,    67,    68,    69,
     &     69,    72,    74,    74,    74,    74,    74,    74,
     &     75,    77,    77,    77,    75,    77,    78,    80,
     &     80,    80,    81,    82,    81,    81,    82,    83,
     &     83,    83,    84,    83,    84,    81,    81,    80,
     &     78,    79,    79,    78,    79,    81,    81,    80,
     &     80,    80,    82,    82,    83,    84,    85,    86,
     &     88,    88,    84,    86,    89,    90,    89,    91,
     &     92,    93,    93,    95,    90,    91,    91,    95,
     &     93,    92,    93,    92,    93,    93,    92,    92,
     &     89,    88,    89,    89,    89,    91,    92,    92,
     &     92,    88,    87,    87,    87,    84,    83,    82,
     &     83,    82,    84,    84,    82,    83,    82,    81,
     &     81,    81,    82,    82,    80,    80,    79,    78,
     &     78,    79,    79,    81,    82,    82,    84,    82,
     &     81,    81,    79,    78,    76,    74,    73,    72,
     &     72,    73,    70,    73,    72,    71,    70,    68,
     &     67,    68,    66,    64,    65,    66,    64,    64,
     &     62,    62,    60,    61,    63,    66,    64,    63,
     &     63,    64,    68,    68,    66,    70,    71,    75,
     &     72,    75,    81,    82,    82,    83,    85,    87,
     &     90,    89,    90,    93,    91,    90,    93,    93,
     &     92,    92,    92,    93,    94,    99,    99,   101,
     &    101,   101,   101,   100,   100,   100,   101,   102,
     &    100,    99,   101,   107,   106,   104,   104,   105,
     &    105,   105,   106,   104,   104,   104,   105,   108,
     &    108,   108,   106,   106,   108,   108,   107,   107,
     &    106,   108,   106,   103,   103,   103,   106,   103,
     &    103,   104,   108,   107,   107,   106,   105,   106,
     &    104,   105,   105,   104,   103,   103,   102,   100,
     &     98,    96,    93,    93,    89,    87,    84,    83,
     &     81,    80,    75,    75,    75,    75,    74,    73,
     &     70,    69,    69,    67,    69,    66,    65,    62,
     &     62,    62,    60,    57,    60,    61,    60,    57,
     &     57,    57,    58,    57,    57,    56,    53,    52,
     &     52,    51,    51,    51,    49,    48,    47,    46,
     &     45,    43,    40,    38,    38,    39,    36,    37,
     &     35,    35,    35,    31,    32,    31,    30,    29,
     &     29,    30,    29,    29,    25,    25,    23,    20,
     &     18,    18,    18,    18,    18,    18,    16,    14,
     &     13,    12,    12,     9,     9,     9,     9,     7,
     &      6,     6,     6,     6,     6,     6,     6,     5,
     &      5,     5,     5,     5,     4,     2,     1,     1,
     &      1,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     1,     1,     1,     1,     1,
     &      1,     1,     1,     1,     1,     1,     1,     1,
     &      1,  1479,  1479,  1478,  1456,  1452,  1450,  1446,
     &   1442,  1445,  1443,  1448,  1451,  1443,  1441,  1429,
     &   1445,  1448,  1450,  1461,  1449,  1456,  1445,  1451,
     &   1449,  1436,  1442,  1442,  1448,  1440,  1442,  1442,
     &   1435,  1433,  1439,  1434,  1449,  1468,  1474,  1473,
     &   1470,  1474,  1463,  1471,  1486,  1505,  1515,  1527,
     &   1538,  1541,  1553,  1557,  1571,  1564,  1582,  1588,
     &   1595,  1609,  1631,  1634,  1640,  1656,  1671,  1690,
     &   1698,  1707,  1713,  1723,  1716,  1740,  1747,  1772,
     &   1802,  1824,  1820,  1837,  1845,  1858,  1875,  1873,
     &   1888,  1884,  1911,  1939,  1963,  1989,  2019,  2031,
     &   2067,  2110,  2127,  2139,  2148,  2176,  2205,  2234,
     &   2264,  2285,  2307,  2318,  2333,  2344,  2313,  2306,
     &   2292,  2283,  2280,  2264,  2255,  2248,  2248,  2244,
     &   2220,  2219,  2209,  2206,  2206,  2205,  2190,  2187,
     &   2183,  2176,  2179,  2168,  2164,  2159,  2155,  2142,
     &   2158,  2162,  2160,  2167,  2159,  2150,  2157,  2162,
     &   2160,  2147,  2154,  2145,  2130,  2126,  2127,  2136,
     &   2139,  2157,  2153,  2159,  2159,  2163,  2171,  2159,
     &   2162,  2174,  2183,  2188,  2198,  2211,  2212,  2201,
     &   2184,  2186,  2170,  2165,  2167,  2160,  2163,  2189,
     &   2179,  2186,  2187,  2202,  2212,  2230,  2244,  2236,
     &   2230,  2247,  2253,  2257,  2271,  2283,  2281,  2298,
     &   2304,  2322,  2334,  2339,  2345,  2368,  2363,  2358,
     &   2362,  2373,  2398,  2403,  2418,  2436,  2452,  2468,
     &   2484,  2497,  2510,  2517,  2533,  2543,  2534,  2564,
     &   2585,  2594,  2621,  2658,  2672,  2684,  2718,  2741,
     &   2756,  2791,  2825,  2834,  2846,  2858,  2865,  2883,
     &   2895,  2924,  2944,  2963,  2977,  3010,  3020,  3040,
     &   3062,  3090,  3135,  3153,  3169,  3196,  3214,  3249,
     &   3268,  3270,  3281,  3295,  3337,  3361,  3380,  3395,
     &   3429,  3464,  3486,  3523,  3541,  3542,  3539,  3533,
     &   3521,  3501,  3504,  3482,  3470,  3466,  3457,  3441,
     &   3432,  3435,  3404,  3389,  3379,  3380,  3356,  3354,
     &   3341,  3334,  3327,  3317,  3305,  3289,  3284,  3272,
     &   3249,  3219,  3210,  3189,  3177,  3152,  3157,  3155,
     &   3156,  3154,  3125,  3087,  3086,  3088,  3079,  3081,
     &   3080,  3065,  3068,  3058,  3064,  3065,  3085,  3097,
     &   3091,  3115,  3140,  3168,  3202,  3220,  3248,  3255,
     &   3247,  3274,  3291,  3290,  3312,  3336,  3340,  3364,
     &   3400,  3436,  3477,  3496,  3517,  3553,  3596,  3626,
     &   3661,  3691,  3707,  3726,  3777,  3825,  3844,  3870,
     &   3892,  3950,  3976,  3996,  4031,  4044,  4090,  4120/
      Data (writetable(i),i=    5601,    6400)/
     &   4158,  4196,  4251,  4282,  4334,  4394,  4420,  4465,
     &   4487,  4509,  4535,  4572,  4607,  4639,  4673,  4731,
     &   4757,  4802,  4827,  4872,  4917,  4974,  5013,  5087,
     &   5148,  5212,  5260,  5326,  5384,  5470,  5547,  5645,
     &   5717,  5769,  5857,  5943,  6011,  6099,  6165,  6247,
     &   6308,  6380,  6465,  6550,  6614,  6692,  6755,  6825,
     &   6911,  6979,  7027,  7052,  7094,  7136,  7148,  7168,
     &   7189,  7184,  7166,  7137,  7099,  7083,  7032,  7007,
     &   6979,  6951,  6911,  6855,  6818,  6762,  6705,  6646,
     &   6591,  6519,  6474,  6418,  6378,  6312,  6268,  6210,
     &   6192,  6144,  6105,  6080,  6033,  5984,  5956,  5923,
     &   5887,  5837,  5798,  5751,  5707,  5659,  5613,  5598,
     &   5574,  5546,  5511,  5489,  5448,  5434,  5403,  5371,
     &   5347,  5343,  5342,  5328,  5319,  5302,  5285,  5265,
     &   5252,  5243,  5229,  5221,  5187,  5175,  5165,  5156,
     &   5127,  5105,  5087,  5058,  5034,  4994,  4951,  4921,
     &   4884,  4861,  4846,  4807,  4795,  4760,  4723,  4707,
     &   4682,  4661,  4633,  4590,  4552,  4514,  4467,  4442,
     &   4404,  4362,  4341,  4327,  4282,  4255,  4225,  4194,
     &   4161,  4123,  4111,  4086,  4054,  4023,  3962,  3902,
     &   3857,  3834,  3792,  3761,  3722,  3694,  3650,  3599,
     &   3552,  3553,  3577,  3527,  3483,  3440,  3421,  3391,
     &   3355,  3333,  3331,  3313,  3306,  3282,  3266,  3240,
     &   3215,  3187,  3187,  3155,  3153,  3132,  3125,  3124,
     &   3124,  3120,  3116,  3118,  3117,  3115,  3128,  3136,
     &   3151,  3157,  3143,  3165,  3180,  3182,  3195,  3202,
     &   3172,  3136,  3097,  3071,  3048,  3013,  3003,  2971,
     &   2949,  2940,  2909,  2885,  2853,  2835,  2835,  2820,
     &   2812,  2805,  2801,  2803,  2803,  2790,  2779,  2766,
     &   2772,  2762,  2750,  2746,  2747,  2739,  2729,  2730,
     &   2736,  2733,  2724,  2736,  2729,  2725,  2731,  2721,
     &   2731,  2710,  2704,  2696,  2707,  2699,  2694,  2680,
     &   2666,  2665,  2651,  2639,  2629,  2627,  2614,  2618,
     &   2608,  2588,  2572,  2566,  2547,  2527,  2521,  2514,
     &   2504,  2505,  2497,  2496,  2486,  2480,  2474,  2450,
     &   2444,  2428,  2432,  2421,  2414,  2404,  2389,  2382,
     &   2370,  2367,  2359,  2334,  2321,  2316,  2311,  2305,
     &   2266,  2246,  2231,  2221,  2203,  2198,  2191,  2160,
     &   2133,  2134,  2126,  2106,  2065,  2048,  2025,  1981,
     &   1961,  1931,  1923,  1884,  1865,  1852,  1844,  1834,
     &   1823,  1821,  1806,  1791,  1783,  1772,  1755,  1741,
     &   1725,  1723,  1711,  1703,  1691,  1677,  1677,  1667,
     &   1655,  1642,  1623,  1609,  1591,  1588,  1583,  1571,
     &   1556,  1555,  1544,  1545,  1524,  1514,  1502,  1480,
     &   1474,  1448,  1428,  1410,  1400,  1386,  1348,  1312,
     &   1277,  1239,  1213,  1183,  1152,  1128,  1092,  1059,
     &   1020,   991,   970,   939,   911,   885,   861,   842,
     &    817,   803,   771,   754,   731,   711,   692,   670,
     &    660,   640,   628,   609,   588,   562,   542,   519,
     &    503,   488,   473,   456,   441,   420,   402,   388,
     &    376,   361,   351,   340,   326,   319,   306,   292,
     &    244,   246,   246,   247,   246,   245,   241,   242,
     &    238,   232,   231,   234,   235,   229,   232,   235,
     &    230,   232,   234,   234,   238,   241,   242,   247,
     &    241,   243,   241,   240,   242,   241,   241,   241,
     &    244,   241,   245,   247,   247,   245,   244,   242,
     &    241,   240,   242,   247,   251,   247,   246,   249,
     &    252,   250,   259,   260,   258,   256,   259,   255,
     &    256,   257,   258,   270,   275,   272,   279,   282,
     &    288,   289,   286,   290,   291,   297,   293,   293,
     &    294,   298,   297,   294,   297,   299,   303,   304,
     &    302,   307,   305,   309,   312,   309,   309,   311,
     &    310,   311,   315,   314,   311,   317,   318,   321,
     &    328,   326,   325,   327,   323,   321,   327,   324,
     &    323,   324,   320,   321,   316,   316,   314,   311,
     &    314,   310,   309,   310,   304,   302,   300,   300,
     &    292,   296,   289,   288,   292,   288,   286,   286,
     &    288,   285,   280,   280,   280,   283,   280,   283,
     &    277,   280,   274,   274,   273,   268,   271,   267,
     &    269,   271,   273,   273,   277,   277,   265,   263,
     &    262,   265,   265,   263,   265,   260,   259,   259,
     &    257,   260,   260,   262,   266,   267,   267,   266,
     &    267,   273,   279,   281,   286,   286,   284,   285,
     &    287,   283,   281,   279,   276,   275,   279,   282,
     &    283,   286,   282,   283,   284,   286,   284,   283,
     &    281,   282,   282,   286,   292,   290,   292,   291,
     &    291,   286,   287,   287,   290,   293,   292,   294,
     &    294,   297,   298,   298,   294,   299,   296,   296,
     &    295,   298,   294,   288,   289,   293,   295,   293,
     &    295,   292,   297,   299,   300,   301,   307,   306,
     &    309,   306,   310,   312,   316,   326,   325,   325,
     &    322,   326,   329,   332,   330,   335,   336,   335,
     &    339,   340,   343,   347,   345,   348,   348,   347,
     &    344,   343,   343,   342,   337,   339,   337,   335,
     &    329,   328,   323,   328,   320,   320,   326,   324,
     &    321,   321,   320,   319,   317,   318,   318,   316,
     &    315,   307,   307,   305,   301,   300,   298,   302,
     &    299,   300,   299,   296,   293,   292,   289,   285,
     &    285,   281,   271,   269,   266,   270,   274,   280,
     &    279,   281,   283,   288,   286,   284,   284,   283,
     &    286,   286,   286,   291,   288,   285,   282,   290,
     &    290,   289,   294,   294,   295,   294,   297,   304,
     &    307,   307,   304,   305,   302,   307,   310,   317,
     &    319,   320,   321,   320,   328,   331,   334,   335,
     &    339,   344,   345,   347,   356,   359,   361,   367,
     &    371,   372,   376,   374,   375,   381,   385,   394,
     &    397,   406,   414,   424,   438,   445,   444,   450,
     &    453,   457,   462,   461,   472,   475,   482,   495,
     &    505,   515,   523,   524,   534,   546,   552,   557,
     &    568,   587,   601,   616,   631,   637,   643,   656/
      Data (writetable(i),i=    6401,    7200)/
     &    668,   669,   684,   688,   704,   715,   732,   740,
     &    748,   752,   767,   773,   784,   795,   812,   824,
     &    825,   835,   845,   863,   876,   887,   892,   909,
     &    913,   926,   928,   941,   952,   962,   964,   976,
     &    985,   996,  1008,  1014,  1022,  1035,  1047,  1057,
     &   1073,  1081,  1083,  1102,  1116,  1131,  1150,  1152,
     &   1164,  1179,  1187,  1208,  1223,  1241,  1261,  1287,
     &   1298,  1317,  1325,  1344,  1371,  1398,  1418,  1433,
     &   1456,  1473,  1489,  1510,  1540,  1565,  1584,  1608,
     &   1616,  1632,  1650,  1668,  1690,  1719,  1737,  1767,
     &   1789,  1802,  1824,  1842,  1878,  1899,  1919,  1944,
     &   1968,  1984,  1997,  2020,  2043,  2073,  2086,  2112,
     &   2131,  2157,  2166,  2190,  2216,  2232,  2253,  2275,
     &   2303,  2325,  2339,  2356,  2376,  2387,  2391,  2385,
     &   2379,  2388,  2391,  2398,  2387,  2392,  2393,  2384,
     &   2383,  2413,  2420,  2428,  2413,  2398,  2404,  2405,
     &   2399,  2383,  2370,  2369,  2359,  2344,  2342,  2332,
     &   2322,  2306,  2289,  2275,  2259,  2243,  2224,  2206,
     &   2183,  2162,  2137,  2107,  2091,  2062,  2038,  2017,
     &   1984,  1963,  1947,  1917,  1887,  1853,  1810,  1792,
     &   1767,  1741,  1722,  1703,  1688,  1666,  1650,  1627,
     &   1601,  1586,  1573,  1544,  1525,  1510,  1492,  1474,
     &   1466,  1444,  1424,  1411,  1394,  1390,  1374,  1368,
     &   1358,  1339,  1320,  1296,  1288,  1272,  1262,  1246,
     &   1231,  1230,  1219,  1205,  1186,  1184,  1173,  1162,
     &   1160,  1141,  1133,  1118,  1104,  1084,  1068,  1054,
     &   1046,  1040,  1034,  1024,  1018,  1012,  1008,  1001,
     &   1001,   981,   976,   972,   966,   959,   945,   934,
     &    926,   927,   924,   917,   897,   885,   863,   859,
     &    852,   833,   831,   824,   826,   816,   809,   801,
     &    796,   786,   782,   765,   754,   745,   733,   727,
     &    725,   717,   705,   698,   689,   676,   667,   649,
     &    634,   627,   622,   616,   610,   595,   587,   580,
     &    573,   567,   558,   553,   544,   539,   528,   513,
     &    507,   504,   500,   491,   480,   475,   466,   460,
     &    458,   447,   442,   428,   424,   423,   414,   408,
     &    397,   390,   389,   385,   380,   376,   368,   360,
     &    350,   344,   334,   327,   323,   318,   317,   306,
     &    308,   308,   307,   303,   288,   284,   278,   267,
     &    263,   252,   243,   240,   226,   218,   212,   211,
     &    199,   192,   188,   185,   178,   168,   161,   159,
     &    156,   151,   145,   143,   140,   134,   126,   121,
     &    120,   117,   115,   110,   100,    97,    93,    90,
     &     82,    81,    76,    76,    73,    70,    68,    62,
     &     59,    58,    55,    51,    51,    49,    43,    36,
     &     36,    35,    34,    35,    36,    37,    35,    35,
     &     34,    34,    33,    33,    32,    32,    32,    32,
     &     32,    30,    29,    29,    28,    28,    31,    31,
     &     31,    31,    31,    29,    29,    29,    28,    27,
     &     28,    28,    30,    32,    30,    28,    28,    27,
     &     26,    26,    27,    27,    25,    25,    24,    23,
     &     25,    25,    25,    27,    27,    28,    27,    26,
     &     26,    25,    29,    30,    30,    30,    31,    30,
     &     29,    29,    29,    29,    29,    30,    29,    29,
     &     28,    27,    27,    28,    30,    31,    31,    32,
     &     32,    30,    29,    28,    28,    26,    27,    27,
     &     27,    28,    28,    28,    29,    29,    28,    29,
     &     31,    31,    33,    33,    32,    32,    31,    29,
     &     29,    28,    25,    26,    26,    26,    27,    25,
     &     25,    25,    26,    27,    28,    27,    27,    26,
     &     25,    24,    24,    23,    23,    23,    23,    23,
     &     23,    22,    24,    24,    24,    24,    24,    25,
     &     25,    25,    25,    25,    25,    25,    27,    27,
     &     27,    28,    27,    27,    26,    25,    25,    25,
     &     25,    24,    25,    25,    24,    22,    23,    23,
     &     24,    24,    25,    26,    26,    26,    27,    26,
     &     26,    25,    25,    26,    26,    26,    25,    24,
     &     24,    24,    24,    24,    25,    23,    23,    22,
     &     18,    18,    18,    17,    16,    16,    16,    16,
     &     17,    17,    17,    20,    19,    19,    19,    19,
     &     19,    20,    20,    21,    22,    23,    23,    23,
     &     23,    23,    23,    22,    22,    20,    20,    20,
     &     20,    20,    20,    19,    19,    21,    21,    20,
     &     19,    18,    18,    18,    19,    18,    18,    20,
     &     21,    22,    22,    23,    23,    22,    22,    22,
     &     23,    23,    22,    22,    22,    20,    21,    23,
     &     23,    23,    22,    22,    22,    21,    21,    22,
     &     20,    19,    19,    18,    18,    17,    18,    18,
     &     19,    19,    19,    20,    20,    19,    18,    19,
     &     19,    19,    18,    18,    18,    18,    18,    17,
     &     17,    17,    17,    17,    17,    17,    16,    15,
     &     15,    15,    15,    15,    16,    16,    16,    17,
     &     17,    18,    18,    18,    18,    18,    18,    19,
     &     19,    19,    19,    18,    18,    18,    17,    16,
     &     16,    17,    18,    19,    20,    22,    22,    22,
     &     22,    23,    23,    23,    23,    23,    24,    24,
     &     25,    24,    25,    25,    26,    24,    25,    22,
     &     22,    22,    22,    22,    22,    23,    24,    24,
     &     23,    22,    22,    23,    23,    25,    24,    25,
     &     26,    26,    26,    25,    24,    24,    24,    24,
     &     25,    24,    26,    26,    26,    26,    27,    27,
     &     27,    26,    26,    27,    27,    29,    28,    30,
     &     30,    30,    30,    30,    32,    31,    32,    31,
     &     33,    33,    33,    32,    30,    31,    32,    32,
     &     31,    31,    31,    32,    33,    33,    34,    34,
     &     34,    33,    32,    33,    33,    33,    37,    37,
     &     36,    37,    36,    36,    37,    38,    39,    39,
     &     40,    41,    40,    42,    42,    42,    41,    41,
     &     40,    41,    40,    40,    39,    39,    41,    41,
     &     41,    40,    39,    38,    38,    37,    37,    37/
      Data (writetable(i),i=    7201,    8000)/
     &     37,    37,    37,    36,    36,    37,    36,    36,
     &     36,    38,    39,    40,    40,    41,    41,    42,
     &     42,    42,    42,    41,    40,    40,    40,    40,
     &     41,    44,    45,    44,    43,    43,    43,    42,
     &     41,    41,    42,    43,    44,    44,    43,    43,
     &     45,    43,    44,    42,    42,    41,    40,    38,
     &     38,    39,    39,    39,    36,    36,    34,    34,
     &     34,    36,    36,    35,    35,    33,    31,    31,
     &     30,    32,    31,    31,    30,    29,    27,    30,
     &     29,    29,    29,    29,    29,    29,    29,    31,
     &     31,    31,    31,    35,    35,    35,    36,    37,
     &     37,    36,    35,    36,    36,    37,    38,    37,
     &     37,    39,    39,    39,    42,    42,    43,    43,
     &     45,    45,    47,    47,    45,    46,    46,    46,
     &     43,    44,    45,    45,    44,    44,    44,    46,
     &     45,    49,    49,    49,    48,    49,    51,    51,
     &     53,    56,    55,    57,    57,    57,    58,    59,
     &     59,    60,    60,    61,    62,    62,    64,    64,
     &     65,    65,    65,    67,    70,    68,    68,    69,
     &     70,    71,    73,    71,    71,    71,    72,    72,
     &     71,    72,    71,    70,    71,    71,    70,    71,
     &     71,    70,    70,    71,    70,    70,    69,    68,
     &     69,    69,    68,    67,    65,    62,    62,    62,
     &     62,    62,    60,    58,    58,    55,    55,    54,
     &     53,    52,    52,    52,    51,    49,    46,    45,
     &     43,    41,    42,    42,    42,    39,    39,    38,
     &     37,    37,    36,    35,    34,    32,    33,    33,
     &     33,    33,    31,    33,    33,    34,    34,    35,
     &     33,    33,    33,    32,    31,    32,    30,    30,
     &     30,    30,    30,    29,    30,    30,    29,    28,
     &     27,    29,    31,    32,    31,    30,    30,    32,
     &     32,    32,    33,    34,    37,    37,    39,    39,
     &     39,    40,    41,    41,    38,    37,    37,    36,
     &     33,    32,    30,    28,    26,    25,    23,    23,
     &     21,    17,    16,    16,    15,    13,    13,    12,
     &     12,    11,    11,    11,    10,     9,     8,     8,
     &      8,     7,     7,     7,     6,     5,     5,     5,
     &      5,     5,     5,     5,     5,     5,     4,     4,
     &      3,     3,     3,     3,     3,     3,    51,    50,
     &     50,    50,    50,    50,    50,    52,    52,    50,
     &     53,    53,    51,    52,    50,    50,    50,    49,
     &     47,    48,    47,    48,    47,    48,    49,    48,
     &     49,    49,    50,    50,    48,    45,    45,    43,
     &     43,    41,    41,    44,    44,    44,    44,    46,
     &     45,    44,    43,    43,    42,    43,    43,    42,
     &     42,    42,    44,    44,    42,    42,    42,    42,
     &     42,    42,    42,    43,    44,    44,    44,    45,
     &     44,    43,    43,    43,    44,    43,    46,    47,
     &     47,    47,    47,    46,    48,    48,    49,    51,
     &     53,    53,    54,    55,    55,    56,    54,    55,
     &     52,    55,    57,    58,    56,    58,    59,    57,
     &     55,    55,    56,    56,    55,    55,    54,    51,
     &     52,    52,    50,    49,    49,    50,    49,    48,
     &     48,    47,    46,    45,    44,    45,    43,    41,
     &     41,    42,    40,    40,    38,    39,    38,    39,
     &     39,    38,    34,    33,    32,    30,    30,    32,
     &     30,    31,    31,    31,    30,    31,    31,    31,
     &     30,    28,    29,    29,    29,    29,    29,    28,
     &     29,    30,    31,    32,    29,    28,    28,    28,
     &     28,    28,    28,    29,    28,    27,    26,    26,
     &     25,    23,    23,    24,    24,    24,    23,    22,
     &     23,    23,    22,    22,    24,    24,    24,    24,
     &     26,    27,    27,    27,    27,    28,    27,    27,
     &     27,    27,    27,    28,    27,    27,    27,    29,
     &     27,    27,    28,    28,    30,    31,    31,    29,
     &     29,    29,    29,    30,    31,    30,    30,    30,
     &     29,    31,    32,    30,    31,    32,    33,    34,
     &     34,    32,    32,    32,    34,    34,    36,    36,
     &     37,    41,    38,    38,    38,    39,    39,    39,
     &     41,    42,    43,    43,    43,    43,    45,    45,
     &     47,    47,    45,    45,    45,    46,    46,    46,
     &     46,    44,    43,    40,    40,    38,    38,    38,
     &     38,    38,    40,    40,    40,    40,    40,    41,
     &     39,    39,    41,    41,    37,    35,    32,    32,
     &     31,    29,    27,    28,    29,    29,    29,    29,
     &     29,    28,    28,    28,    28,    28,    27,    26,
     &     27,    28,    29,    29,    29,    30,    30,    30,
     &     30,    32,    32,    34,    34,    34,    33,    32,
     &     32,    34,    34,    35,    36,    36,    36,    35,
     &     35,    35,    33,    33,    34,    33,    33,    33,
     &     32,    32,    34,    34,    32,    33,    33,    34,
     &     32,    32,    33,    33,    34,    34,    35,    35,
     &     36,    37,    37,    38,    40,    40,    40,    41,
     &     41,    40,    42,    41,    42,    41,    40,    42,
     &     42,    41,    41,    42,    42,    42,    42,    41,
     &     42,    41,    42,    43,    43,    44,    45,    46,
     &     47,    47,    49,    50,    50,    51,    53,    54,
     &     54,    55,    58,    59,    59,    60,    59,    60,
     &     61,    63,    63,    65,    64,    64,    64,    64,
     &     66,    67,    68,    67,    66,    66,    67,    67,
     &     66,    65,    65,    63,    64,    64,    65,    66,
     &     62,    60,    58,    58,    59,    59,    59,    58,
     &     59,    59,    59,    60,    60,    60,    61,    61,
     &     62,    64,    65,    65,    66,    67,    69,    68,
     &     72,    74,    74,    73,    75,    74,    74,    73,
     &     73,    73,    75,    73,    73,    72,    72,    73,
     &     73,    72,    74,    74,    74,    76,    75,    74,
     &     72,    72,    72,    73,    72,    71,    71,    74,
     &     75,    75,    77,    77,    78,    74,    74,    76,
     &     75,    77,    77,    77,    77,    76,    75,    75/
      Data (writetable(i),i=    8001,    8800)/
     &     74,    77,    75,    74,    73,    74,    76,    76,
     &     75,    76,    78,    76,    74,    75,    76,    75,
     &     73,    73,    72,    74,    74,    72,    76,    76,
     &     71,    70,    70,    70,    70,    69,    68,    69,
     &     67,    67,    64,    67,    66,    66,    69,    70,
     &     72,    75,    74,    75,    76,    77,    80,    84,
     &     87,    89,    88,    87,    88,    88,    92,    93,
     &     94,    93,    94,    97,    98,    98,    95,    93,
     &     90,    91,    90,    92,    95,    96,    97,    98,
     &     99,    98,    99,   100,   101,   100,    99,    98,
     &     98,    99,   100,   103,   103,   102,   102,   102,
     &    102,   105,   105,   106,   106,   108,   108,   108,
     &    111,   111,   110,   112,   111,   110,   112,   112,
     &    108,   110,   113,   112,   109,   106,   108,   105,
     &    104,   103,   105,   105,   104,   103,   106,   105,
     &    106,   109,   111,   112,   112,   110,   110,   110,
     &    110,   107,   106,   105,   105,   106,   108,   110,
     &    111,   113,   112,   112,   113,   112,   110,   107,
     &    105,   107,   106,   105,   103,   102,   100,    99,
     &     95,    94,    92,    93,    91,    88,    88,    88,
     &     88,    88,    87,    87,    83,    85,    82,    83,
     &     84,    83,    82,    83,    80,    78,    79,    81,
     &     80,    79,    77,    76,    76,    74,    75,    76,
     &     76,    76,    75,    77,    77,    77,    72,    71,
     &     72,    70,    70,    72,    74,    76,    75,    76,
     &     77,    74,    69,    69,    66,    66,    63,    62,
     &     62,    64,    61,    59,    56,    55,    51,    48,
     &     46,    46,    43,    42,    40,    40,    38,    36,
     &     33,    32,    32,    30,    29,    27,    26,    24,
     &     25,    24,    22,    21,    19,    19,    18,    17,
     &     17,    16,    15,    15,    14,    14,    14,    14,
     &     12,    12,    11,    11,    10,    10,    10,     9,
     &      8,     7,     7,     7,     6,    27,    27,    26,
     &     25,    24,    25,    25,    24,    24,    24,    25,
     &     25,    25,    24,    24,    23,    25,    25,    25,
     &     25,    26,    24,    24,    23,    24,    23,    22,
     &     22,    22,    22,    22,    23,    24,    23,    22,
     &     22,    23,    24,    24,    24,    22,    21,    22,
     &     23,    23,    23,    22,    21,    20,    19,    19,
     &     19,    20,    22,    22,    22,    22,    23,    25,
     &     25,    25,    26,    27,    28,    28,    28,    28,
     &     29,    31,    30,    29,    29,    31,    32,    33,
     &     33,    33,    33,    31,    32,    32,    33,    33,
     &     33,    34,    34,    33,    35,    35,    37,    35,
     &     37,    37,    39,    38,    37,    36,    36,    33,
     &     33,    35,    38,    39,    40,    40,    39,    36,
     &     35,    32,    32,    29,    30,    29,    30,    30,
     &     30,    32,    35,    35,    35,    35,    32,    31,
     &     31,    31,    31,    31,    32,    32,    31,    31,
     &     31,    31,    30,    30,    29,    29,    28,    27,
     &     27,    25,    26,    25,    25,    22,    22,    22,
     &     22,    21,    22,    22,    22,    23,    23,    22,
     &     22,    22,    22,    22,    20,    21,    20,    17,
     &     18,    18,    17,    17,    18,    17,    17,    16,
     &     16,    15,    14,    13,    13,    13,    13,    13,
     &     14,    13,    12,    11,    13,    14,    14,    13,
     &     13,    13,    12,    12,    13,    14,    15,    14,
     &     13,    12,    12,    11,    12,    12,    11,    12,
     &     12,    12,    12,    13,    13,    13,    13,    14,
     &     14,    14,    14,    15,    15,    17,    17,    17,
     &     19,    19,    19,    19,    19,    19,    19,    19,
     &     19,    20,    19,    19,    19,    19,    19,    19,
     &     20,    20,    19,    20,    20,    20,    21,    21,
     &     21,    21,    21,    21,    21,    21,    23,    24,
     &     23,    22,    21,    21,    20,    20,    21,    22,
     &     21,    21,    22,    21,    21,    21,    20,    20,
     &     20,    20,    21,    21,    21,    21,    21,    21,
     &     21,    21,    21,    21,    22,    22,    20,    21,
     &     21,    22,    20,    21,    21,    22,    22,    21,
     &     21,    21,    20,    20,    19,    19,    19,    19,
     &     18,    18,    18,    18,    18,    17,    16,    16,
     &     17,    18,    18,    19,    19,    20,    19,    18,
     &     18,    18,    19,    19,    20,    18,    20,    20,
     &     20,    20,    21,    22,    23,    23,    23,    24,
     &     24,    23,    23,    22,    21,    21,    21,    21,
     &     23,    23,    24,    25,    25,    25,    26,    26,
     &     26,    26,    27,    29,    30,    30,    30,    30,
     &     29,    28,    30,    30,    29,    29,    31,    31,
     &     31,    32,    32,    33,    33,    33,    31,    31,
     &     31,    31,    31,    31,    31,    30,    29,    29,
     &     31,    32,    32,    31,    30,    29,    29,    29,
     &     30,    31,    32,    32,    32,    33,    32,    35,
     &     35,    35,    34,    33,    34,    34,    35,    35,
     &     37,    36,    37,    38,    38,    39,    39,    39,
     &     37,    37,    37,    37,    35,    35,    34,    34,
     &     34,    35,    35,    34,    33,    33,    33,    33,
     &     33,    33,    33,    33,    33,    34,    34,    34,
     &     33,    30,    30,    30,    29,    29,    31,    30,
     &     31,    30,    29,    31,    31,    31,    31,    31,
     &     30,    30,    31,    31,    31,    31,    31,    29,
     &     30,    29,    29,    29,    30,    29,    29,    30,
     &     30,    31,    31,    30,    32,    33,    33,    33,
     &     33,    33,    34,    34,    33,    33,    33,    33,
     &     33,    33,    33,    35,    35,    35,    35,    35,
     &     35,    35,    35,    38,    37,    38,    37,    36,
     &     38,    37,    36,    35,    37,    36,    38,    37,
     &     37,    37,    37,    36,    36,    36,    34,    33,
     &     35,    38,    39,    39,    39,    38,    38,    38,
     &     39,    39,    39,    40,    40,    41,    41,    43,
     &     46,    48,    50,    52,    53,    54,    54,    55/
      Data (writetable(i),i=    8801,    9600)/
     &     54,    55,    55,    56,    54,    55,    55,    57,
     &     58,    57,    58,    56,    56,    56,    55,    56,
     &     58,    58,    58,    58,    58,    58,    55,    55,
     &     54,    53,    54,    53,    52,    50,    50,    52,
     &     53,    53,    54,    54,    53,    55,    55,    55,
     &     54,    55,    56,    56,    56,    57,    55,    53,
     &     55,    56,    56,    55,    55,    55,    57,    56,
     &     56,    56,    57,    58,    58,    59,    60,    58,
     &     57,    56,    57,    57,    57,    56,    56,    56,
     &     54,    55,    56,    56,    57,    58,    58,    58,
     &     58,    56,    55,    53,    51,    51,    51,    52,
     &     53,    54,    57,    56,    56,    55,    57,    57,
     &     56,    57,    57,    55,    54,    53,    53,    54,
     &     53,    51,    49,    47,    47,    47,    47,    45,
     &     46,    45,    46,    45,    43,    43,    44,    44,
     &     44,    43,    41,    42,    42,    44,    43,    43,
     &     44,    45,    43,    42,    43,    41,    42,    41,
     &     41,    40,    39,    38,    38,    37,    36,    36,
     &     36,    36,    34,    35,    35,    35,    32,    32,
     &     31,    32,    31,    30,    30,    29,    28,    27,
     &     26,    26,    23,    23,    22,    22,    21,    19,
     &     18,    18,    17,    15,    15,    16,    16,    14,
     &     13,    12,    11,    10,    10,    10,     9,     8,
     &      7,     6,     6,     6,     6,     4,     4,     5,
     &      6,     6,     6,     5,     5,     5,     5,     5,
     &      5,     4,     4,     3,     3,     3,     3,     2,
     &      2,     2,     2,     2,    25,    24,    24,    22,
     &     22,    21,    20,    19,    19,    18,    18,    19,
     &     19,    18,    18,    19,    19,    19,    19,    20,
     &     20,    20,    21,    20,    20,    20,    19,    19,
     &     20,    19,    19,    18,    18,    18,    18,    18,
     &     17,    18,    18,    20,    19,    19,    19,    19,
     &     18,    18,    18,    18,    18,    18,    15,    15,
     &     13,    14,    13,    13,    14,    15,    15,    16,
     &     16,    17,    16,    16,    19,    20,    21,    21,
     &     21,    22,    23,    23,    23,    25,    24,    25,
     &     25,    24,    24,    24,    25,    24,    25,    25,
     &     25,    25,    26,    26,    26,    26,    28,    27,
     &     28,    28,    28,    27,    28,    29,    31,    30,
     &     30,    29,    28,    28,    30,    30,    29,    28,
     &     27,    28,    30,    29,    29,    30,    30,    30,
     &     30,    30,    27,    27,    27,    26,    26,    25,
     &     25,    25,    26,    27,    27,    24,    23,    23,
     &     23,    23,    23,    23,    23,    24,    23,    22,
     &     21,    20,    18,    18,    20,    20,    20,    21,
     &     21,    20,    19,    20,    19,    18,    18,    18,
     &     21,    21,    21,    20,    20,    20,    19,    19,
     &     19,    19,    20,    20,    20,    21,    22,    22,
     &     23,    23,    21,    21,    21,    21,    22,    22,
     &     22,    21,    21,    21,    21,    20,    20,    21,
     &     21,    21,    22,    22,    22,    22,    21,    21,
     &     22,    22,    23,    21,    22,    22,    22,    21,
     &     21,    21,    21,    21,    21,    21,    20,    20,
     &     21,    21,    19,    18,    18,    18,    19,    19,
     &     18,    17,    17,    15,    15,    17,    17,    17,
     &     18,    18,    17,    18,    19,    18,    18,    18,
     &     18,    19,    18,    18,    18,    18,    18,    18,
     &     17,    16,    16,    17,    18,    18,    17,    16,
     &     16,    16,    16,    17,    17,    17,    18,    20,
     &     20,    20,    20,    20,    21,    22,    22,    22,
     &     21,    21,    23,    24,    23,    23,    24,    22,
     &     23,    23,    22,    22,    21,    21,    21,    22,
     &     21,    22,    21,    21,    21,    21,    20,    20,
     &     20,    20,    20,    20,    20,    20,    20,    20,
     &     20,    19,    18,    17,    18,    19,    19,    19,
     &     20,    20,    19,    20,    20,    21,    21,    21,
     &     21,    20,    21,    21,    21,    22,    22,    22,
     &     23,    23,    22,    22,    20,    20,    20,    19,
     &     20,    19,    18,    19,    18,    17,    17,    15,
     &     16,    15,    15,    16,    16,    17,    18,    18,
     &     17,    18,    18,    18,    19,    21,    21,    21,
     &     20,    20,    20,    19,    20,    20,    21,    21,
     &     22,    23,    22,    22,    22,    24,    23,    24,
     &     24,    25,    28,    28,    28,    28,    27,    27,
     &     28,    30,    31,    32,    33,    37,    38,    39,
     &     40,    42,    41,    41,    41,    43,    43,    44,
     &     45,    45,    44,    45,    45,    45,    46,    46,
     &     46,    47,    46,    46,    47,    48,    48,    48,
     &     49,    47,    48,    48,    49,    50,    50,    48,
     &     48,    47,    48,    50,    51,    52,    49,    49,
     &     52,    52,    52,    47,    47,    49,    48,    48,
     &     49,    49,    50,    51,    52,    51,    50,    50,
     &     49,    50,    51,    51,    49,    49,    49,    48,
     &     48,    49,    48,    49,    50,    49,    49,    50,
     &     51,    51,    52,    52,    52,    55,    55,    54,
     &     54,    53,    52,    52,    53,    52,    54,    54,
     &     55,    56,    56,    56,    56,    55,    53,    54,
     &     54,    54,    56,    56,    57,    57,    55,    54,
     &     53,    52,    52,    52,    53,    55,    55,    54,
     &     55,    55,    52,    52,    51,    51,    49,    49,
     &     45,    43,    42,    42,    41,    44,    45,    45,
     &     45,    45,    45,    43,    41,    41,    41,    41,
     &     43,    44,    45,    43,    44,    43,    41,    41,
     &     42,    43,    45,    43,    46,    46,    46,    46,
     &     48,    49,    49,    47,    49,    53,    52,    55,
     &     55,    55,    56,    57,    58,    56,    56,    57,
     &     57,    55,    55,    53,    54,    56,    56,    57,
     &     57,    57,    58,    60,    60,    59,    59,    60,
     &     61,    61,    60,    61,    61,    62,    60,    60,
     &     63,    63,    62,    63,    64,    64,    64,    62/
      Data (writetable(i),i=    9601,   10400)/
     &     61,    61,    62,    65,    66,    69,    68,    68,
     &     69,    70,    72,    74,    76,    76,    76,    77,
     &     76,    74,    74,    75,    76,    75,    74,    74,
     &     74,    75,    74,    74,    77,    77,    78,    77,
     &     75,    75,    75,    75,    74,    74,    74,    73,
     &     72,    73,    74,    72,    72,    69,    69,    67,
     &     68,    68,    69,    67,    67,    67,    66,    65,
     &     63,    62,    64,    63,    64,    63,    64,    62,
     &     62,    62,    61,    61,    60,    60,    59,    56,
     &     55,    55,    54,    53,    53,    52,    51,    52,
     &     52,    52,    50,    48,    46,    46,    44,    43,
     &     40,    40,    40,    39,    40,    40,    41,    41,
     &     41,    39,    40,    39,    38,    37,    38,    35,
     &     34,    31,    31,    31,    33,    33,    31,    29,
     &     29,    28,    28,    25,    23,    23,    23,    24,
     &     20,    20,    18,    19,    18,    18,    18,    18,
     &     17,    16,    16,    16,    13,    13,    11,    10,
     &     10,     9,     9,     8,     8,     9,     9,     8,
     &      8,     7,     7,     7,     6,     6,     6,     5,
     &      5,     4,     4,     3,     3,     3,     2,     2,
     &      2,     1,     1,    44,    44,    42,    41,    42,
     &     42,    41,    42,    40,    37,    37,    36,    36,
     &     33,    34,    35,    34,    33,    32,    32,    32,
     &     30,    29,    28,    28,    31,    29,    29,    32,
     &     33,    33,    31,    32,    32,    32,    32,    32,
     &     32,    30,    29,    30,    31,    32,    32,    31,
     &     31,    31,    31,    32,    31,    31,    32,    32,
     &     32,    32,    33,    33,    33,    32,    34,    33,
     &     33,    33,    33,    34,    36,    37,    38,    38,
     &     39,    38,    38,    37,    37,    37,    37,    37,
     &     38,    37,    37,    39,    39,    38,    40,    42,
     &     42,    42,    43,    45,    45,    43,    42,    45,
     &     45,    45,    46,    46,    46,    47,    43,    45,
     &     45,    44,    45,    45,    44,    42,    40,    39,
     &     40,    39,    41,    40,    40,    40,    40,    38,
     &     38,    37,    37,    37,    39,    39,    40,    40,
     &     40,    38,    37,    35,    34,    33,    34,    34,
     &     33,    33,    32,    32,    33,    33,    33,    32,
     &     31,    31,    31,    32,    35,    36,    35,    37,
     &     39,    38,    39,    39,    39,    39,    39,    40,
     &     39,    42,    43,    44,    43,    43,    43,    43,
     &     43,    42,    41,    40,    39,    38,    39,    38,
     &     37,    36,    36,    35,    34,    34,    33,    33,
     &     31,    31,    31,    30,    30,    30,    30,    31,
     &     31,    31,    30,    28,    29,    29,    28,    26,
     &     26,    25,    25,    24,    24,    23,    23,    24,
     &     23,    24,    26,    26,    26,    27,    27,    27,
     &     28,    27,    29,    28,    28,    28,    29,    29,
     &     28,    28,    30,    30,    28,    29,    30,    31,
     &     31,    31,    32,    31,    30,    31,    31,    32,
     &     32,    31,    31,    31,    33,    32,    31,    32,
     &     33,    32,    32,    33,    32,    32,    31,    31,
     &     31,    29,    29,    29,    28,    29,    29,    29,
     &     29,    29,    29,    29,    29,    29,    30,    29,
     &     29,    30,    31,    31,    33,    33,    33,    32,
     &     33,    34,    34,    34,    33,    31,    31,    31,
     &     31,    30,    28,    28,    26,    26,    25,    25,
     &     24,    24,    23,    23,    25,    26,    26,    26,
     &     27,    28,    29,    29,    29,    29,    30,    31,
     &     32,    34,    34,    35,    35,    34,    34,    36,
     &     35,    34,    34,    34,    34,    35,    36,    36,
     &     35,    35,    34,    35,    35,    36,    37,    36,
     &     36,    36,    37,    37,    38,    39,    39,    39,
     &     40,    41,    42,    42,    42,    42,    44,    45,
     &     46,    45,    45,    47,    45,    43,    43,    42,
     &     41,    40,    39,    41,    41,    44,    43,    45,
     &     46,    47,    48,    49,    48,    48,    49,    50,
     &     51,    52,    54,    54,    58,    61,    62,    63,
     &     64,    64,    63,    61,    62,    61,    61,    62,
     &     64,    66,    67,    66,    64,    67,    67,    67,
     &     68,    67,    68,    68,    71,    73,    73,    74,
     &     72,    71,    72,    74,    76,    75,    75,    75,
     &     74,    73,    71,    71,    69,    69,    68,    68,
     &     70,    69,    70,    70,    71,    74,    75,    75,
     &     75,    73,    72,    75,    77,    77,    77,    75,
     &     76,    75,    76,    75,    74,    72,    71,    71,
     &     72,    72,    73,    76,    77,    77,    79,    79,
     &     80,    79,    76,    75,    76,    76,    76,    76,
     &     77,    75,    76,    78,    77,    74,    73,    74,
     &     74,    73,    74,    73,    74,    74,    74,    75,
     &     76,    72,    70,    72,    71,    71,    69,    70,
     &     71,    70,    67,    66,    66,    63,    64,    66,
     &     68,    68,    67,    69,    68,    70,    72,    69,
     &     68,    66,    67,    67,    68,    69,    70,    69,
     &     71,    71,    72,    67,    67,    67,    67,    70,
     &     70,    72,    73,    74,    73,    71,    73,    72,
     &     70,    73,    72,    72,    74,    75,    74,    77,
     &     82,    84,    82,    83,    83,    83,    88,    87,
     &     87,    84,    86,    92,    92,    92,    93,    95,
     &     96,    95,    95,    95,    93,    91,    91,    92,
     &     92,    93,    95,    95,    92,    92,    93,    93,
     &     93,    91,    90,    89,    89,    90,    88,    89,
     &     87,    87,    87,    88,    87,    87,    87,    87,
     &     86,    87,    92,    91,    92,    92,    91,    91,
     &     92,    91,    92,    96,    98,    99,   101,   101,
     &    101,   100,    99,   100,    98,   101,   100,    99,
     &     98,    97,    95,    96,    96,    97,   100,   102,
     &    101,    99,   100,    98,    95,    94,    95,    96,
     &     95,    97,    93,    92,    90,    90,    90,    88,
     &     88,    88,    89,    88,    89,    86,    84,    85/
      Data (writetable(i),i=   10401,   11200)/
     &     87,    85,    86,    87,    88,    86,    84,    82,
     &     80,    78,    80,    80,    80,    79,    77,    77,
     &     78,    78,    82,    82,    82,    81,    78,    79,
     &     75,    75,    72,    71,    71,    69,    70,    69,
     &     68,    69,    70,    69,    71,    70,    70,    66,
     &     68,    67,    65,    65,    64,    63,    64,    63,
     &     60,    58,    61,    62,    63,    59,    56,    57,
     &     56,    56,    57,    58,    59,    58,    56,    56,
     &     55,    50,    49,    47,    47,    42,    39,    33,
     &     32,    29,    29,    27,    23,    23,    19,    18,
     &     15,    14,    15,    13,    13,    13,    13,    14,
     &     14,    13,    14,    12,    12,    11,    10,    11,
     &     10,     9,     9,     8,     7,     6,     6,     6,
     &      6,     6,     5,     5,     4,     4,     3,     2,
     &      2,     2,  1438,  1428,  1417,  1421,  1405,  1398,
     &   1383,  1381,  1369,  1366,  1359,  1353,  1351,  1347,
     &   1351,  1351,  1347,  1339,  1334,  1341,  1353,  1352,
     &   1353,  1361,  1365,  1374,  1373,  1359,  1347,  1354,
     &   1345,  1342,  1342,  1355,  1358,  1365,  1377,  1379,
     &   1386,  1398,  1423,  1439,  1455,  1455,  1469,  1483,
     &   1482,  1505,  1522,  1534,  1538,  1547,  1556,  1559,
     &   1588,  1608,  1614,  1617,  1628,  1629,  1644,  1681,
     &   1675,  1685,  1690,  1687,  1715,  1719,  1738,  1757,
     &   1783,  1807,  1829,  1836,  1854,  1862,  1885,  1896,
     &   1910,  1916,  1924,  1953,  1960,  1961,  1990,  1985,
     &   1988,  1992,  2009,  2007,  2023,  2041,  2048,  2068,
     &   2076,  2112,  2112,  2125,  2147,  2160,  2190,  2171,
     &   2154,  2157,  2144,  2138,  2132,  2129,  2134,  2144,
     &   2126,  2125,  2119,  2110,  2105,  2088,  2090,  2086,
     &   2097,  2083,  2071,  2051,  2059,  2056,  2045,  2054,
     &   2048,  2056,  2067,  2064,  2051,  2053,  2061,  2046,
     &   2045,  2068,  2070,  2063,  2057,  2066,  2094,  2089,
     &   2101,  2104,  2111,  2111,  2111,  2120,  2122,  2130,
     &   2123,  2126,  2110,  2122,  2113,  2111,  2112,  2096,
     &   2101,  2104,  2103,  2103,  2104,  2123,  2125,  2135,
     &   2149,  2161,  2151,  2153,  2152,  2173,  2176,  2180,
     &   2182,  2189,  2190,  2182,  2183,  2189,  2192,  2193,
     &   2212,  2224,  2240,  2255,  2274,  2283,  2300,  2292,
     &   2301,  2324,  2326,  2342,  2349,  2364,  2377,  2395,
     &   2407,  2416,  2448,  2462,  2488,  2519,  2517,  2528,
     &   2543,  2570,  2596,  2609,  2644,  2662,  2674,  2693,
     &   2685,  2690,  2710,  2725,  2745,  2766,  2793,  2795,
     &   2822,  2845,  2859,  2887,  2907,  2915,  2915,  2940,
     &   2969,  2987,  3010,  3030,  3058,  3076,  3088,  3109,
     &   3123,  3152,  3184,  3197,  3223,  3227,  3240,  3245,
     &   3274,  3303,  3331,  3354,  3372,  3378,  3363,  3368,
     &   3381,  3372,  3386,  3382,  3382,  3373,  3374,  3380,
     &   3370,  3360,  3358,  3359,  3352,  3352,  3350,  3337,
     &   3338,  3327,  3331,  3327,  3310,  3289,  3258,  3245,
     &   3231,  3207,  3189,  3182,  3160,  3157,  3145,  3134,
     &   3131,  3148,  3132,  3137,  3132,  3123,  3103,  3076,
     &   3053,  3026,  3023,  3004,  3016,  3014,  3010,  3021,
     &   3033,  3051,  3073,  3107,  3119,  3142,  3160,  3189,
     &   3219,  3242,  3247,  3278,  3315,  3323,  3340,  3355,
     &   3379,  3403,  3426,  3442,  3461,  3483,  3492,  3499,
     &   3527,  3548,  3574,  3610,  3645,  3656,  3694,  3723,
     &   3754,  3793,  3818,  3854,  3875,  3892,  3914,  3939,
     &   3984,  4030,  4088,  4109,  4153,  4183,  4221,  4255,
     &   4296,  4337,  4362,  4404,  4422,  4462,  4482,  4502,
     &   4527,  4564,  4584,  4628,  4695,  4730,  4755,  4784,
     &   4850,  4909,  4952,  5004,  5049,  5106,  5155,  5218,
     &   5294,  5354,  5426,  5495,  5560,  5639,  5694,  5757,
     &   5840,  5924,  6010,  6064,  6157,  6260,  6331,  6413,
     &   6476,  6548,  6607,  6649,  6689,  6724,  6777,  6805,
     &   6825,  6850,  6876,  6883,  6869,  6859,  6845,  6792,
     &   6759,  6722,  6708,  6669,  6623,  6568,  6514,  6465,
     &   6426,  6386,  6334,  6269,  6222,  6171,  6121,  6064,
     &   6043,  6009,  5966,  5915,  5867,  5834,  5786,  5761,
     &   5706,  5678,  5623,  5593,  5552,  5528,  5491,  5446,
     &   5390,  5346,  5314,  5284,  5268,  5255,  5219,  5208,
     &   5194,  5178,  5143,  5140,  5129,  5130,  5104,  5090,
     &   5074,  5077,  5055,  5030,  5025,  5013,  5010,  4994,
     &   4978,  4953,  4923,  4897,  4886,  4860,  4825,  4804,
     &   4754,  4717,  4694,  4671,  4633,  4615,  4595,  4580,
     &   4556,  4521,  4497,  4479,  4451,  4402,  4365,  4335,
     &   4299,  4254,  4218,  4183,  4150,  4111,  4095,  4035,
     &   4018,  3996,  3979,  3963,  3950,  3925,  3919,  3868,
     &   3816,  3755,  3714,  3658,  3613,  3576,  3546,  3526,
     &   3504,  3487,  3469,  3444,  3404,  3406,  3395,  3360,
     &   3341,  3320,  3290,  3277,  3254,  3227,  3215,  3192,
     &   3180,  3177,  3179,  3179,  3175,  3166,  3170,  3174,
     &   3168,  3154,  3149,  3142,  3145,  3168,  3167,  3185,
     &   3176,  3180,  3190,  3197,  3200,  3209,  3224,  3227,
     &   3228,  3211,  3186,  3157,  3131,  3104,  3078,  3053,
     &   3030,  3025,  2997,  2994,  2987,  2974,  2957,  2945,
     &   2940,  2921,  2918,  2912,  2918,  2904,  2888,  2883,
     &   2869,  2853,  2853,  2839,  2828,  2817,  2809,  2811,
     &   2817,  2805,  2803,  2787,  2774,  2770,  2753,  2740,
     &   2731,  2721,  2717,  2709,  2718,  2722,  2710,  2692,
     &   2697,  2687,  2674,  2661,  2664,  2651,  2636,  2635,
     &   2643,  2628,  2626,  2617,  2607,  2609,  2583,  2583,
     &   2580,  2574,  2578,  2574,  2570,  2559,  2553,  2531,
     &   2525,  2519,  2511,  2499,  2489,  2483,  2476,  2464,
     &   2464,  2469,  2462,  2451,  2447,  2446,  2427,  2421,
     &   2423,  2404,  2386,  2376,  2383,  2375,  2359,  2346,
     &   2333,  2320,  2286,  2271,  2233,  2211,  2200,  2187,
     &   2159,  2123,  2109,  2072,  2031,  2020,  1995,  1967,
     &   1954,  1934,  1925,  1911,  1909,  1895,  1878,  1866,
     &   1858,  1850,  1834,  1829,  1827,  1821,  1809,  1813,
     &   1812,  1803,  1794,  1794,  1785,  1781,  1770,  1752/
      Data (writetable(i),i=   11201,   12000)/
     &   1746,  1741,  1725,  1718,  1718,  1710,  1710,  1717,
     &   1697,  1689,  1672,  1653,  1646,  1643,  1635,  1598,
     &   1570,  1549,  1534,  1501,  1486,  1458,  1437,  1403,
     &   1367,  1338,  1319,  1302,  1271,  1248,  1226,  1192,
     &   1160,  1143,  1132,  1110,  1086,  1073,  1049,  1030,
     &   1006,   980,   970,   963,   956,   934,   920,   908,
     &    896,   875,   858,   847,   836,   826,   810,   797,
     &    782,   767,   749,   734,   710,   699,   682,   666,
     &    651,   218,   219,   216,   215,   216,   214,   214,
     &    218,   212,   214,   212,   211,   213,   214,   214,
     &    210,   211,   211,   211,   213,   211,   209,   210,
     &    214,   217,   221,   226,   224,   219,   220,   220,
     &    214,   219,   218,   220,   222,   223,   224,   223,
     &    225,   230,   233,   227,   229,   229,   232,   233,
     &    238,   237,   237,   237,   236,   234,   233,   234,
     &    235,   233,   230,   236,   239,   245,   245,   248,
     &    255,   258,   267,   270,   275,   275,   272,   269,
     &    269,   268,   271,   275,   276,   275,   278,   280,
     &    287,   287,   291,   295,   298,   295,   304,   305,
     &    307,   305,   308,   307,   311,   315,   316,   318,
     &    325,   322,   325,   325,   332,   339,   338,   337,
     &    336,   341,   345,   340,   339,   336,   335,   334,
     &    338,   337,   336,   336,   338,   338,   333,   336,
     &    337,   333,   329,   326,   327,   324,   322,   320,
     &    317,   316,   312,   306,   308,   306,   307,   300,
     &    295,   295,   293,   292,   292,   284,   282,   268,
     &    268,   270,   269,   271,   276,   277,   279,   275,
     &    274,   275,   276,   273,   269,   269,   274,   270,
     &    277,   278,   275,   274,   276,   275,   276,   267,
     &    264,   272,   266,   262,   262,   263,   264,   264,
     &    260,   262,   265,   271,   272,   274,   278,   278,
     &    273,   279,   277,   261,   260,   257,   257,   257,
     &    254,   254,   252,   255,   257,   259,   262,   264,
     &    265,   263,   269,   267,   267,   265,   271,   268,
     &    272,   275,   278,   272,   272,   272,   271,   267,
     &    267,   268,   272,   271,   275,   280,   284,   291,
     &    290,   296,   293,   297,   299,   304,   305,   300,
     &    302,   303,   305,   296,   299,   300,   301,   301,
     &    301,   305,   302,   310,   314,   313,   317,   320,
     &    325,   322,   326,   329,   329,   325,   323,   322,
     &    325,   322,   321,   311,   307,   311,   306,   304,
     &    308,   303,   302,   301,   298,   297,   302,   297,
     &    294,   293,   297,   297,   293,   292,   285,   284,
     &    280,   282,   281,   281,   282,   284,   284,   282,
     &    285,   284,   286,   289,   289,   285,   283,   277,
     &    278,   278,   280,   279,   280,   281,   278,   280,
     &    276,   274,   273,   275,   274,   275,   275,   277,
     &    277,   283,   283,   282,   279,   275,   277,   281,
     &    284,   287,   288,   289,   288,   285,   285,   287,
     &    291,   291,   290,   290,   287,   283,   290,   291,
     &    292,   294,   296,   299,   302,   306,   312,   311,
     &    312,   311,   316,   323,   326,   332,   331,   330,
     &    335,   336,   343,   351,   354,   357,   359,   362,
     &    373,   374,   379,   386,   390,   397,   402,   410,
     &    417,   426,   436,   445,   462,   465,   479,   486,
     &    493,   500,   513,   522,   535,   543,   554,   566,
     &    572,   579,   601,   611,   616,   622,   637,   648,
     &    661,   668,   686,   699,   708,   710,   714,   723,
     &    731,   739,   745,   752,   766,   777,   790,   805,
     &    803,   815,   820,   840,   853,   858,   870,   886,
     &    896,   903,   909,   914,   917,   929,   934,   952,
     &    960,   975,   984,   987,   999,  1007,  1010,  1021,
     &   1038,  1050,  1058,  1066,  1078,  1092,  1107,  1122,
     &   1133,  1147,  1161,  1173,  1192,  1205,  1229,  1252,
     &   1268,  1281,  1290,  1309,  1340,  1361,  1389,  1420,
     &   1439,  1461,  1487,  1510,  1527,  1562,  1581,  1598,
     &   1614,  1631,  1645,  1665,  1680,  1698,  1729,  1754,
     &   1772,  1792,  1817,  1849,  1859,  1872,  1895,  1926,
     &   1943,  1983,  2005,  2025,  2048,  2064,  2072,  2093,
     &   2122,  2151,  2157,  2179,  2189,  2201,  2215,  2240,
     &   2258,  2281,  2318,  2336,  2361,  2384,  2376,  2377,
     &   2383,  2391,  2395,  2389,  2397,  2399,  2400,  2400,
     &   2392,  2392,  2410,  2404,  2410,  2409,  2418,  2417,
     &   2416,  2392,  2378,  2375,  2378,  2356,  2364,  2350,
     &   2336,  2324,  2307,  2300,  2287,  2265,  2239,  2232,
     &   2211,  2195,  2174,  2157,  2131,  2116,  2096,  2077,
     &   2059,  2050,  2038,  2003,  1970,  1950,  1928,  1898,
     &   1869,  1847,  1812,  1791,  1767,  1742,  1721,  1703,
     &   1692,  1663,  1641,  1618,  1589,  1577,  1555,  1532,
     &   1517,  1501,  1492,  1475,  1462,  1439,  1421,  1407,
     &   1396,  1389,  1369,  1352,  1337,  1328,  1311,  1299,
     &   1290,  1273,  1257,  1234,  1220,  1207,  1190,  1187,
     &   1180,  1164,  1147,  1136,  1125,  1118,  1096,  1083,
     &   1076,  1057,  1047,  1043,  1038,  1028,  1019,  1013,
     &   1006,  1000,   996,   985,   974,   970,   955,   937,
     &    933,   927,   917,   912,   901,   895,   890,   883,
     &    885,   880,   866,   856,   842,   837,   827,   822,
     &    820,   805,   791,   783,   776,   761,   747,   745,
     &    742,   733,   730,   723,   714,   709,   693,   685,
     &    678,   672,   652,   634,   629,   615,   606,   599,
     &    590,   581,   573,   570,   559,   548,   535,   535,
     &    533,   525,   519,   505,   502,   495,   493,   496,
     &    483,   479,   473,   477,   472,   469,   465,   454,
     &    451,   447,   444,   446,   444,   447,   446,   437,
     &    435,   426,   416,   417,   424,   429,   427,   426,
     &    420,   411,   407,   406,   404,   403,   401,   396,
     &    388,   381,   376,   361,   354,   347,   335,   321,
     &    320,   313,   304,   294,   293,   287,   274,   266,
     &    258,   253,   243,   241,   239,   236,   225,   218,
     &    211,   202,   200,   191,   183,   181,   177,   174/
      Data (writetable(i),i=   12001,   12800)/
     &    173,   171,   166,   165,   162,   156,   151,   147,
     &    143,   137,   133,   130,   127,   125,   116,   110,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0/
      Data (writetable(i),i=   12801,   13600)/
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0/
      Data (writetable(i),i=   13601,   14400)/
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0/
      Data (writetable(i),i=   14401,   15200)/
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0/
      Data (writetable(i),i=   15201,   16000)/
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,  1367,  1369,  1357,  1367,  1360,
     &   1348,  1345,  1341,  1343,  1337,  1343,  1337,  1332,
     &   1323,  1320,  1317,  1306,  1307,  1305,  1296,  1278,
     &   1276,  1276,  1280,  1277,  1281,  1284,  1291,  1290,
     &   1302,  1309,  1309,  1308,  1312,  1315,  1322,  1322,
     &   1327,  1329,  1345,  1339,  1355,  1350,  1352,  1360,
     &   1368,  1374,  1395,  1419,  1431,  1428,  1444,  1456,
     &   1472,  1481,  1495,  1509,  1529,  1539,  1558,  1577,
     &   1598,  1623,  1627,  1649,  1653,  1663,  1681,  1695,
     &   1702,  1706,  1725,  1734,  1753,  1782,  1801,  1814,
     &   1824,  1848,  1854,  1865,  1881,  1902,  1917,  1940,
     &   1963,  1981,  2008,  2023,  2052,  2066,  2090,  2102,
     &   2100,  2113,  2110,  2132,  2149,  2165,  2184,  2207,
     &   2203,  2186,  2159,  2145,  2146,  2139,  2137,  2128,
     &   2123,  2122,  2101,  2105,  2105,  2101,  2088,  2097,
     &   2093,  2084,  2070,  2075,  2062,  2072,  2076,  2077,
     &   2074,  2070,  2067,  2061,  2063,  2064,  2067,  2078,
     &   2073,  2073,  2082,  2084,  2082,  2075,  2071,  2067,
     &   2081,  2082,  2079,  2071,  2077,  2073,  2078,  2084,
     &   2086,  2088,  2084,  2071,  2085,  2078,  2081,  2067,
     &   2044,  2049,  2068,  2073,  2080,  2101,  2106,  2111,
     &   2116,  2134,  2148,  2151,  2156,  2172,  2175,  2175,
     &   2161,  2161,  2165,  2169,  2166,  2175,  2183,  2207,
     &   2217,  2230,  2233,  2225,  2223,  2241,  2245,  2257,
     &   2272,  2284,  2287,  2307,  2312,  2301,  2329,  2344,
     &   2351,  2362,  2386,  2392,  2407,  2421,  2436,  2448,
     &   2447,  2482,  2481,  2489,  2517,  2533,  2550,  2572,
     &   2587,  2599,  2610,  2610,  2630,  2663,  2696,  2720,
     &   2732,  2731,  2751,  2781,  2785,  2802,  2837,  2853/
      Data (writetable(i),i=   16001,   16800)/
     &   2870,  2888,  2907,  2936,  2944,  2965,  2972,  2987,
     &   3011,  3040,  3076,  3091,  3120,  3132,  3144,  3175,
     &   3198,  3240,  3279,  3321,  3360,  3390,  3402,  3399,
     &   3394,  3381,  3377,  3377,  3376,  3379,  3381,  3379,
     &   3367,  3360,  3351,  3341,  3324,  3321,  3317,  3306,
     &   3282,  3271,  3268,  3237,  3241,  3226,  3227,  3213,
     &   3210,  3196,  3175,  3178,  3155,  3144,  3141,  3134,
     &   3121,  3122,  3096,  3091,  3089,  3086,  3054,  3038,
     &   3042,  3032,  3033,  3029,  3018,  2996,  2988,  2994,
     &   3035,  3050,  3073,  3094,  3119,  3149,  3160,  3182,
     &   3187,  3214,  3241,  3249,  3246,  3261,  3276,  3295,
     &   3296,  3318,  3336,  3356,  3366,  3373,  3368,  3387,
     &   3384,  3403,  3435,  3447,  3459,  3493,  3511,  3532,
     &   3557,  3578,  3620,  3662,  3678,  3692,  3717,  3746,
     &   3767,  3796,  3818,  3853,  3884,  3915,  3948,  3998,
     &   4041,  4070,  4090,  4115,  4160,  4225,  4258,  4293,
     &   4332,  4381,  4409,  4451,  4507,  4566,  4629,  4679,
     &   4722,  4756,  4784,  4827,  4874,  4950,  5000,  5074,
     &   5157,  5240,  5324,  5385,  5485,  5536,  5630,  5701,
     &   5785,  5861,  5926,  6001,  6103,  6166,  6240,  6317,
     &   6377,  6431,  6478,  6564,  6635,  6701,  6748,  6792,
     &   6817,  6863,  6888,  6895,  6892,  6875,  6836,  6823,
     &   6768,  6722,  6680,  6632,  6586,  6572,  6518,  6474,
     &   6444,  6383,  6341,  6292,  6244,  6214,  6169,  6120,
     &   6042,  5983,  5947,  5915,  5863,  5793,  5741,  5684,
     &   5652,  5613,  5572,  5517,  5481,  5438,  5405,  5384,
     &   5333,  5307,  5265,  5240,  5198,  5165,  5127,  5096,
     &   5090,  5058,  5026,  4993,  4971,  4946,  4931,  4921,
     &   4920,  4908,  4907,  4905,  4909,  4918,  4900,  4872,
     &   4867,  4844,  4814,  4805,  4762,  4748,  4744,  4725,
     &   4714,  4681,  4626,  4602,  4549,  4517,  4494,  4465,
     &   4430,  4406,  4372,  4343,  4304,  4276,  4240,  4226,
     &   4208,  4180,  4128,  4083,  4040,  4008,  3976,  3931,
     &   3899,  3882,  3860,  3873,  3853,  3837,  3820,  3805,
     &   3755,  3713,  3661,  3610,  3570,  3532,  3507,  3486,
     &   3441,  3417,  3393,  3360,  3372,  3351,  3319,  3308,
     &   3290,  3277,  3254,  3228,  3199,  3173,  3149,  3159,
     &   3159,  3134,  3129,  3116,  3119,  3103,  3095,  3095,
     &   3080,  3077,  3064,  3067,  3066,  3061,  3053,  3043,
     &   3048,  3071,  3078,  3068,  3077,  3085,  3091,  3089,
     &   3086,  3111,  3084,  3063,  3048,  3020,  2991,  2959,
     &   2931,  2918,  2924,  2904,  2901,  2877,  2887,  2878,
     &   2877,  2865,  2871,  2868,  2862,  2839,  2832,  2827,
     &   2814,  2790,  2796,  2791,  2789,  2780,  2771,  2766,
     &   2747,  2746,  2740,  2718,  2717,  2726,  2728,  2720,
     &   2726,  2715,  2688,  2671,  2668,  2668,  2661,  2649,
     &   2655,  2631,  2605,  2585,  2570,  2560,  2556,  2541,
     &   2541,  2536,  2536,  2533,  2545,  2552,  2546,  2532,
     &   2532,  2528,  2548,  2543,  2529,  2517,  2519,  2516,
     &   2522,  2519,  2528,  2537,  2550,  2540,  2535,  2539,
     &   2525,  2533,  2531,  2521,  2518,  2508,  2491,  2493,
     &   2484,  2486,  2476,  2475,  2456,  2455,  2459,  2448,
     &   2448,  2425,  2420,  2411,  2393,  2381,  2351,  2323,
     &   2294,  2268,  2246,  2225,  2195,  2181,  2161,  2141,
     &   2127,  2110,  2098,  2087,  2087,  2078,  2068,  2063,
     &   2051,  2057,  2039,  2043,  2053,  2037,  2037,  2038,
     &   2026,  2026,  2023,  2014,  2010,  2015,  2006,  1996,
     &   1990,  1981,  1985,  1986,  1988,  1985,  1982,  1966,
     &   1968,  1973,  1988,  1998,  2008,  2017,  2004,  2004,
     &   1997,  1971,  1959,  1931,  1923,  1906,  1889,  1859,
     &   1827,  1806,  1789,  1784,  1775,  1754,  1732,  1708,
     &   1699,  1677,  1652,  1628,  1606,  1585,  1579,  1560,
     &   1544,  1518,  1488,  1457,  1449,  1437,  1431,  1410,
     &   1399,  1389,  1383,  1380,  1361,  1347,  1338,  1322,
     &   1309,  1296,  1291,  1280,  1274,  1263,  1256,  1252,
     &   1242,  1220,   220,   220,   223,   221,   223,   222,
     &    226,   225,   229,   226,   227,   231,   233,   235,
     &    234,   230,   229,   231,   226,   224,   223,   223,
     &    220,   222,   221,   222,   225,   226,   224,   226,
     &    224,   228,   232,   235,   233,   232,   235,   235,
     &    233,   235,   229,   233,   237,   242,   240,   237,
     &    245,   248,   251,   251,   253,   254,   258,   262,
     &    268,   272,   277,   275,   281,   282,   285,   290,
     &    292,   290,   290,   292,   289,   288,   295,   294,
     &    295,   291,   289,   290,   291,   293,   296,   300,
     &    302,   307,   310,   311,   314,   315,   319,   321,
     &    328,   327,   325,   324,   327,   329,   328,   331,
     &    337,   334,   334,   341,   347,   353,   349,   347,
     &    338,   328,   330,   324,   325,   326,   325,   325,
     &    322,   327,   326,   325,   327,   329,   324,   323,
     &    323,   324,   323,   320,   320,   319,   317,   314,
     &    310,   313,   311,   314,   311,   307,   304,   300,
     &    298,   296,   295,   290,   289,   288,   285,   288,
     &    285,   287,   285,   285,   281,   285,   284,   283,
     &    279,   280,   281,   280,   278,   279,   276,   277,
     &    276,   281,   280,   282,   275,   275,   274,   280,
     &    283,   280,   280,   280,   277,   280,   284,   279,
     &    277,   281,   285,   287,   285,   283,   283,   282,
     &    282,   280,   283,   281,   281,   284,   288,   292,
     &    292,   298,   298,   300,   301,   299,   301,   310,
     &    309,   316,   321,   328,   324,   328,   332,   337,
     &    338,   337,   335,   334,   328,   333,   333,   334,
     &    334,   335,   335,   329,   327,   329,   328,   324,
     &    326,   332,   333,   336,   330,   331,   337,   336,
     &    335,   337,   340,   342,   341,   341,   339,   342,
     &    346,   348,   346,   344,   346,   348,   349,   352,
     &    346,   350,   353,   356,   351,   349,   347,   343,
     &    342,   340,   336,   330,   333,   328,   327,   324,
     &    319,   314,   306,   302,   301,   299,   295,   294,
     &    299,   297,   295,   299,   300,   299,   295,   299/
      Data (writetable(i),i=   16801,   17600)/
     &    293,   286,   284,   281,   283,   281,   278,   273,
     &    269,   264,   272,   266,   265,   262,   266,   262,
     &    261,   264,   263,   267,   262,   262,   261,   262,
     &    256,   257,   259,   261,   260,   271,   273,   273,
     &    274,   278,   280,   284,   277,   279,   285,   285,
     &    286,   287,   291,   296,   301,   302,   304,   307,
     &    306,   304,   310,   314,   317,   316,   317,   317,
     &    315,   318,   317,   320,   319,   319,   321,   325,
     &    329,   332,   337,   339,   341,   347,   346,   347,
     &    354,   357,   361,   362,   369,   368,   372,   377,
     &    382,   389,   397,   406,   407,   408,   414,   421,
     &    432,   436,   447,   455,   460,   464,   477,   478,
     &    486,   491,   492,   495,   510,   525,   534,   533,
     &    539,   557,   565,   579,   590,   601,   608,   622,
     &    634,   642,   646,   653,   666,   668,   682,   693,
     &    699,   702,   708,   715,   726,   727,   735,   744,
     &    746,   759,   769,   780,   781,   777,   790,   790,
     &    800,   802,   815,   819,   830,   836,   847,   845,
     &    848,   856,   872,   884,   902,   917,   932,   944,
     &    965,   978,   998,  1009,  1025,  1034,  1047,  1066,
     &   1070,  1087,  1095,  1105,  1125,  1136,  1165,  1167,
     &   1184,  1194,  1221,  1233,  1249,  1268,  1288,  1306,
     &   1313,  1323,  1347,  1369,  1391,  1425,  1447,  1477,
     &   1493,  1511,  1528,  1548,  1568,  1598,  1624,  1653,
     &   1672,  1697,  1710,  1727,  1750,  1768,  1798,  1817,
     &   1841,  1855,  1869,  1892,  1919,  1937,  1967,  1992,
     &   2004,  2024,  2042,  2060,  2083,  2117,  2145,  2167,
     &   2196,  2227,  2258,  2275,  2310,  2351,  2384,  2374,
     &   2368,  2379,  2360,  2353,  2364,  2367,  2366,  2367,
     &   2366,  2376,  2376,  2397,  2402,  2411,  2413,  2404,
     &   2405,  2407,  2407,  2396,  2397,  2384,  2372,  2359,
     &   2346,  2339,  2325,  2314,  2288,  2270,  2250,  2232,
     &   2204,  2189,  2175,  2150,  2128,  2101,  2072,  2049,
     &   2022,  1987,  1973,  1957,  1926,  1920,  1905,  1881,
     &   1861,  1832,  1814,  1796,  1772,  1754,  1726,  1710,
     &   1692,  1670,  1652,  1623,  1599,  1582,  1563,  1556,
     &   1536,  1521,  1504,  1492,  1485,  1475,  1463,  1445,
     &   1430,  1414,  1394,  1383,  1362,  1359,  1361,  1349,
     &   1341,  1329,  1315,  1299,  1284,  1271,  1260,  1245,
     &   1232,  1209,  1194,  1174,  1168,  1154,  1142,  1128,
     &   1114,  1107,  1091,  1073,  1063,  1058,  1059,  1044,
     &   1036,  1037,  1037,  1030,  1023,  1017,  1003,  1000,
     &    997,   994,   977,   973,   964,   951,   941,   932,
     &    917,   910,   902,   894,   888,   877,   867,   860,
     &    857,   855,   859,   850,   835,   829,   815,   798,
     &    791,   783,   765,   757,   744,   742,   738,   725,
     &    720,   708,   700,   691,   686,   681,   675,   667,
     &    671,   667,   661,   652,   643,   638,   627,   619,
     &    610,   609,   602,   597,   591,   573,   574,   576,
     &    565,   558,   548,   542,   532,   533,   527,   527,
     &    524,   515,   517,   510,   501,   497,   497,   500,
     &    492,   490,   482,   480,   479,   480,   476,   471,
     &    467,   462,   454,   450,   449,   448,   445,   449,
     &    441,   445,   435,   431,   426,   424,   422,   422,
     &    414,   409,   406,   399,   390,   379,   368,   359,
     &    354,   349,   347,   339,   336,   329,   319,   312,
     &    310,   306,   297,   300,   294,   288,   283,   281,
     &    277,   270,   268,   268,   267,   262,   265,   262,
     &    261,   256,   256,   252,   251,   246,   243,   230,
     &    225,    20,    19,    19,    18,    18,    19,    18,
     &     17,    16,    17,    16,    16,    16,    16,    17,
     &     17,    17,    17,    16,    16,    16,    16,    15,
     &     16,    17,    17,    18,    18,    17,    17,    16,
     &     16,    16,    16,    16,    16,    16,    16,    17,
     &     18,    18,    19,    19,    20,    21,    23,    20,
     &     20,    21,    21,    21,    21,    22,    22,    20,
     &     19,    19,    20,    20,    21,    21,    23,    23,
     &     23,    23,    23,    23,    24,    24,    24,    24,
     &     23,    25,    26,    28,    27,    27,    27,    28,
     &     28,    29,    29,    29,    30,    31,    31,    31,
     &     31,    29,    29,    30,    29,    29,    29,    29,
     &     32,    35,    36,    36,    37,    36,    35,    35,
     &     34,    33,    34,    34,    33,    33,    30,    30,
     &     30,    32,    31,    30,    29,    30,    28,    28,
     &     28,    28,    30,    30,    29,    29,    27,    27,
     &     27,    27,    26,    26,    24,    25,    26,    26,
     &     26,    26,    26,    25,    25,    24,    23,    23,
     &     23,    23,    23,    23,    22,    21,    21,    23,
     &     23,    22,    21,    20,    19,    18,    17,    18,
     &     19,    17,    18,    19,    19,    19,    20,    20,
     &     20,    21,    22,    22,    20,    21,    22,    22,
     &     24,    23,    23,    23,    24,    23,    23,    22,
     &     22,    22,    22,    23,    23,    23,    22,    22,
     &     22,    22,    22,    23,    23,    23,    22,    21,
     &     20,    20,    19,    21,    22,    22,    22,    22,
     &     22,    22,    20,    19,    19,    20,    20,    21,
     &     21,    21,    22,    21,    19,    19,    19,    19,
     &     20,    21,    20,    19,    19,    19,    17,    17,
     &     17,    19,    18,    17,    17,    17,    18,    17,
     &     18,    18,    17,    17,    17,    17,    18,    17,
     &     16,    17,    17,    16,    15,    16,    14,    14,
     &     14,    14,    15,    15,    15,    15,    16,    16,
     &     16,    16,    15,    13,    12,    13,    14,    14,
     &     13,    14,    15,    15,    16,    16,    16,    16,
     &     15,    15,    15,    15,    15,    17,    18,    18,
     &     17,    17,    17,    16,    15,    14,    15,    15,
     &     16,    16,    17,    17,    15,    16,    16,    16,
     &     15,    16,    16,    16,    15,    15,    15,    15,
     &     15,    16,    16,    16,    17,    20,    20,    19,
     &     20,    25,    25,    25,    25,    25,    25,    26/
      Data (writetable(i),i=   17601,   18400)/
     &     27,    27,    27,    26,    26,    26,    26,    25,
     &     25,    25,    25,    25,    25,    26,    27,    28,
     &     28,    26,    27,    30,    30,    30,    30,    30,
     &     29,    29,    29,    29,    29,    29,    30,    29,
     &     29,    26,    24,    24,    24,    23,    23,    24,
     &     24,    26,    28,    28,    28,    29,    28,    29,
     &     27,    28,    28,    27,    27,    27,    30,    30,
     &     30,    31,    32,    34,    34,    33,    33,    33,
     &     34,    33,    34,    35,    34,    33,    33,    34,
     &     34,    34,    31,    31,    32,    32,    32,    32,
     &     30,    29,    29,    29,    29,    29,    27,    26,
     &     27,    26,    26,    25,    25,    24,    24,    25,
     &     25,    26,    27,    27,    27,    27,    29,    30,
     &     32,    32,    31,    31,    30,    30,    30,    30,
     &     30,    30,    30,    31,    31,    31,    30,    29,
     &     30,    33,    33,    33,    32,    32,    31,    32,
     &     32,    31,    33,    34,    35,    35,    36,    36,
     &     36,    37,    37,    37,    36,    37,    38,    38,
     &     38,    38,    38,    37,    36,    36,    37,    36,
     &     37,    39,    39,    40,    39,    40,    38,    38,
     &     35,    38,    39,    38,    38,    37,    37,    38,
     &     38,    38,    37,    36,    37,    37,    37,    38,
     &     38,    38,    38,    40,    38,    39,    37,    37,
     &     38,    38,    40,    40,    40,    40,    42,    41,
     &     43,    42,    42,    42,    42,    41,    39,    39,
     &     39,    40,    37,    38,    38,    39,    40,    40,
     &     40,    42,    43,    43,    44,    44,    44,    46,
     &     48,    47,    46,    47,    48,    49,    48,    48,
     &     48,    46,    45,    46,    47,    48,    49,    49,
     &     49,    50,    52,    53,    52,    53,    55,    56,
     &     57,    57,    58,    58,    59,    58,    59,    60,
     &     60,    60,    59,    59,    59,    60,    62,    63,
     &     64,    63,    63,    62,    64,    64,    62,    64,
     &     64,    65,    66,    65,    66,    65,    66,    66,
     &     69,    70,    71,    69,    68,    69,    68,    68,
     &     69,    69,    69,    68,    69,    71,    71,    71,
     &     71,    69,    70,    71,    71,    72,    72,    72,
     &     72,    71,    71,    70,    69,    68,    70,    72,
     &     72,    70,    70,    72,    72,    69,    68,    67,
     &     67,    66,    64,    65,    64,    65,    65,    64,
     &     63,    61,    60,    60,    59,    60,    60,    59,
     &     58,    57,    55,    55,    57,    57,    57,    56,
     &     57,    56,    53,    53,    53,    52,    52,    53,
     &     53,    54,    53,    52,    50,    50,    48,    50,
     &     49,    48,    46,    45,    45,    45,    43,    43,
     &     48,    51,    50,    52,    50,    50,    50,    52,
     &     53,    55,    54,    55,    54,    56,    58,    57,
     &     57,    57,    58,    57,    58,    54,    54,    51,
     &     48,    47,    48,    48,    46,    46,    45,    44,
     &     46,    46,    46,    45,    45,    46,    47,    46,
     &     46,    44,    41,    40,    41,    41,    40,    40,
     &     40,    40,    40,    40,    41,    40,    40,    40,
     &     40,    40,    40,    40,    40,    39,    39,    39,
     &     40,    40,    40,    38,    38,    40,    39,    39,
     &     37,    37,    38,    39,    39,    39,    38,    37,
     &     36,    36,    36,    36,    36,    36,    36,    34,
     &     34,    34,    34,    33,    31,    31,    31,    32,
     &     32,    31,    32,    33,    34,    35,    35,    35,
     &     35,    36,    34,    34,    34,    34,    35,    35,
     &     37,    38,    38,    38,    37,    37,    38,    37,
     &     38,    38,    39,    37,    39,    39,    40,    40,
     &     42,    42,    42,    44,    44,    42,    40,    41,
     &     42,    42,    42,    42,    41,    41,    40,    43,
     &     45,    47,    45,    46,    45,    46,    49,    49,
     &     49,    50,    49,    51,    52,    53,    55,    58,
     &     60,    61,    62,    61,    61,    62,    61,    62,
     &     62,    61,    61,    63,    60,    60,    59,    59,
     &     60,    59,    59,    58,    58,    58,    55,    51,
     &     52,    52,    52,    51,    51,    50,    48,    48,
     &     47,    47,    47,    47,    47,    46,    44,    45,
     &     46,    45,    44,    45,    46,    46,    47,    47,
     &     47,    48,    48,    48,    48,    46,    44,    43,
     &     41,    40,    40,    40,    38,    39,    37,    38,
     &     38,    38,    38,    39,    38,    37,    38,    37,
     &     39,    39,    38,    36,    36,    38,    37,    39,
     &     40,    38,    38,    40,    41,    41,    41,    41,
     &     41,    41,    40,    38,    38,    38,    38,    36,
     &     38,    38,    40,    37,    38,    37,    36,    35,
     &     36,    35,    35,    36,    38,    39,    37,    38,
     &     39,    39,    40,    40,    43,    43,    43,    43,
     &     44,    45,    48,    47,    46,    46,    46,    46,
     &     45,    45,    46,    48,    49,    47,    47,    47,
     &     47,    47,    46,    46,    48,    48,    47,    45,
     &     46,    48,    47,    46,    48,    47,    46,    47,
     &     47,    46,    47,    48,    50,    48,    50,    50,
     &     46,    45,    44,    46,    46,    45,    46,    44,
     &     42,    40,    40,    39,    38,    39,    39,    40,
     &     40,    40,    37,    37,    35,    35,    35,    34,
     &     34,    34,    35,    34,    35,    35,    35,    33,
     &     34,    34,    33,    32,    33,    31,    30,    30,
     &     32,    31,    30,    31,    32,    33,    32,    32,
     &     32,    32,    31,    30,    31,    30,    27,    26,
     &     25,    25,    26,    24,    23,    23,    23,    22,
     &     23,    24,    24,    24,    23,    24,    25,    26,
     &     28,    28,    27,    26,    26,    26,    26,    27,
     &     27,    25,    25,    25,    26,    25,    26,    26,
     &     27,    27,    27,    27,    26,    24,    24,    25,
     &     25,    27,    26,    26,    26,    26,    26,    28,
     &     30,    30,    28,    28,    28,    27,    27,    29,
     &     31,    33,    31,    34,    33,    35,    39,    40/
      Data (writetable(i),i=   18401,   19200)/
     &     39,    39,    38,    38,    40,    39,    40,    40,
     &     40,    39,    40,    40,    40,    40,    40,    42,
     &     43,    44,    43,    43,    47,    50,    52,    55,
     &     56,    57,    59,    58,    60,    59,    59,    61,
     &     62,    62,    63,    65,    68,    65,    66,    68,
     &     68,    66,    66,    67,    68,    69,    68,    69,
     &     70,    71,    72,    73,    73,    72,    73,    74,
     &     76,    76,    77,    78,    78,    78,    79,    77,
     &     79,    80,    80,    79,    79,    79,    76,    77,
     &     78,    80,    80,    81,    82,    81,    83,    88,
     &     88,    88,    90,    89,    91,    93,    93,    93,
     &     91,    92,    90,    90,    92,    92,    92,    91,
     &     91,    90,    90,    88,    87,    88,    87,    85,
     &     84,    83,    82,    80,    79,    77,    76,    78,
     &     76,    74,    76,    74,    71,    67,    65,    65,
     &     66,    64,    66,    62,    61,    58,    54,    51,
     &     52,    52,    51,    49,    51,    51,    51,    50,
     &     52,    54,    54,    55,    55,    54,    56,    56,
     &     55,    55,    56,    55,    53,    55,    57,    58,
     &     59,    59,    61,    62,    62,    63,    66,    64,
     &     64,    66,    68,    67,    72,    74,    76,    78,
     &     81,    82,    81,    82,    81,    85,    88,    90,
     &     87,    87,    85,    85,    85,    83,    85,    86,
     &     87,    86,    85,    85,    86,    86,    86,    86,
     &     87,    89,    87,    91,    92,    92,    93,    92,
     &     92,    93,    92,    91,    90,    87,    87,    86,
     &     87,    86,    88,    89,    92,    93,    94,    91,
     &     91,    93,    94,    93,    92,    93,    94,    94,
     &     93,    94,    95,    95,    98,    98,    98,    99,
     &    100,   101,   103,   101,   104,   104,   105,   107,
     &    107,   107,   109,   113,   111,   111,   112,   110,
     &    108,   107,   106,   107,   108,   109,   111,   113,
     &    112,   113,   111,   113,   111,   109,   110,   107,
     &    108,   108,   107,   106,   105,   103,   103,   102,
     &    105,    99,    99,   100,   100,   100,    99,   101,
     &    100,   102,   104,   105,   105,   106,   105,   106,
     &    107,   107,   105,   103,   102,   101,   101,    99,
     &     98,    98,    99,    97,    98,    94,    95,    96,
     &     95,    94,    93,    92,    87,    88,    86,    82,
     &     79,    77,    75,    75,    76,    77,    77,    76,
     &     75,    72,    71,    71,    74,    75,    75,    75,
     &     75,    73,    75,    73,    72,    73,    73,    72,
     &     70,    70,    69,    68,    64,    62,    61,    60,
     &     59,    57,    54,    55,    53,    50,    48,    48,
     &     48,    50,    49,    48,    47,    46,    46,    45,
     &     43,    44,    43,    43,    42,    42,    42,    42,
     &     41,    39,    38,    39,    39,    38,    38,    34,
     &     34,    34,    34,    34,    35,    37,    38,    39,
     &     39,    40,    40,    40,    37,    38,    37,    37,
     &     37,    36,    36,    36,    35,    35,    35,    35,
     &     35,    36,    35,    36,    36,    37,    38,    39,
     &     39,    40,    40,    39,    40,    40,    42,    42,
     &     43,    43,    41,    41,    40,    40,    39,    38,
     &     37,    38,    39,    38,    38,    39,    38,    38,
     &     38,    38,    38,    38,    41,    41,    41,    41,
     &     40,    40,    41,    40,    40,    41,    42,    41,
     &     38,    39,    39,    38,    39,    37,    36,    35,
     &     36,    36,    36,    36,    35,    35,    34,    34,
     &     33,    32,    30,    30,    30,    31,    32,    32,
     &     32,    30,    30,    30,    30,    29,    29,    26,
     &     27,    25,    24,    24,    24,    22,    22,    22,
     &     22,    23,    22,    22,    22,    22,    22,    22,
     &     21,    19,    19,    18,    18,    19,    19,    19,
     &     19,    19,    19,    19,    19,    19,    18,    19,
     &     20,    20,    19,    19,    18,    18,    20,    20,
     &     21,    22,    22,    19,    21,    21,    22,    22,
     &     23,    24,    24,    24,    24,    24,    25,    26,
     &     26,    26,    25,    27,    27,    27,    27,    27,
     &     29,    28,    27,    27,    27,    27,    27,    26,
     &     26,    26,    27,    27,    26,    26,    26,    26,
     &     25,    24,    24,    23,    23,    23,    22,    22,
     &     22,    22,    23,    23,    23,    23,    23,    22,
     &     22,    22,    22,    22,    23,    21,    20,    19,
     &     19,    20,    20,    20,    20,    20,    20,    20,
     &     19,    19,    20,    19,    19,    19,    19,    19,
     &     20,    21,    20,    20,    19,    20,    19,    20,
     &     19,    19,    19,    19,    19,    19,    19,    20,
     &     18,    21,    21,    21,    21,    22,    24,    23,
     &     21,    21,    20,    21,    22,    22,    22,    22,
     &     21,    20,    20,    20,    18,    18,    19,    20,
     &     20,    20,    20,    21,    21,    22,    21,    21,
     &     21,    21,    23,    22,    22,    22,    21,    21,
     &     20,    19,    19,    19,    19,    19,    19,    20,
     &     20,    18,    18,    18,    18,    18,    18,    17,
     &     16,    16,    14,    13,    15,    14,    14,    16,
     &     17,    19,    19,    19,    19,    19,    20,    19,
     &     19,    20,    20,    19,    19,    20,    20,    20,
     &     20,    21,    21,    20,    21,    20,    19,    18,
     &     18,    18,    17,    16,    16,    16,    16,    17,
     &     18,    18,    18,    18,    17,    18,    17,    16,
     &     16,    16,    16,    17,    17,    19,    19,    19,
     &     19,    19,    19,    19,    19,    21,    21,    21,
     &     22,    23,    24,    25,    26,    25,    28,    28,
     &     29,    30,    30,    30,    30,    30,    30,    31,
     &     31,    31,    32,    32,    32,    33,    32,    34,
     &     36,    36,    36,    36,    35,    34,    37,    38,
     &     39,    41,    41,    42,    42,    42,    39,    39,
     &     39,    43,    44,    45,    46,    45,    44,    44,
     &     44,    44,    44,    44,    44,    44,    42,    43,
     &     43,    45,    44,    43,    43,    44,    46,    45/
      Data (writetable(i),i=   19201,   20000)/
     &     47,    49,    52,    52,    52,    52,    52,    53,
     &     52,    52,    52,    51,    52,    53,    52,    53,
     &     53,    52,    53,    54,    56,    57,    57,    58,
     &     58,    57,    57,    55,    54,    54,    52,    51,
     &     50,    49,    49,    49,    49,    47,    47,    45,
     &     45,    44,    47,    46,    44,    43,    45,    44,
     &     44,    44,    43,    43,    43,    43,    45,    45,
     &     44,    44,    45,    45,    45,    45,    43,    45,
     &     45,    44,    42,    40,    41,    41,    43,    44,
     &     44,    43,    44,    42,    42,    41,    40,    40,
     &     41,    40,    40,    37,    36,    35,    35,    34,
     &     33,    33,    32,    30,    30,    33,    34,    34,
     &     35,    35,    35,    34,    33,    32,    35,    35,
     &     35,    37,    37,    36,    37,    37,    40,    42,
     &     43,    44,    43,    45,    45,    45,    49,    50,
     &     50,    54,    55,    57,    56,    55,    55,    53,
     &     54,    54,    53,    50,    50,    49,    47,    46,
     &     49,    47,    47,    47,    49,    49,    50,    53,
     &     54,    54,    53,    53,    52,    51,    52,    53,
     &     54,    53,    52,    54,    54,    54,    53,    52,
     &     53,    55,    55,    53,    57,    57,    57,    56,
     &     57,    56,    60,    60,    59,    59,    62,    62,
     &     64,    64,    64,    65,    66,    67,    68,    69,
     &     69,    69,    71,    71,    72,    71,    71,    71,
     &     72,    72,    72,    72,    71,    72,    72,    74,
     &     74,    74,    74,    75,    76,    75,    76,    77,
     &     77,    76,    76,    77,    76,    77,    76,    77,
     &     76,    76,    74,    73,    70,    70,    69,    65,
     &     62,    61,    60,    60,    60,    61,    61,    61,
     &     61,    62,    62,    62,    66,    65,    64,    66,
     &     65,    65,    65,    67,    64,    64,    64,    62,
     &     61,    61,    62,    62,    62,    60,    58,    57,
     &     58,    61,    62,    60,    58,    59,    58,    56,
     &     56,    56,    55,    55,    55,    53,    56,    54,
     &     53,    53,    52,    53,    50,    50,    49,    47,
     &     47,    47,    47,    45,    45,    46,    47,    47,
     &     48,    48,    45,    45,    46,    46,    45,    45,
     &     42,    43,    44,    46,    45,    46,    46,    45,
     &     42,    42,    41,    41,    43,    44,    44,    44,
     &     44,    42,    43,    43,    43,    42,    41,    38,
     &     35,    35,    33,    34,    35,    35,    23,    22,
     &     22,    22,    22,    22,    22,    23,    23,    23,
     &     23,    22,    23,    22,    22,    21,    18,    18,
     &     18,    19,    19,    19,    19,    19,    18,    18,
     &     17,    17,    17,    17,    18,    18,    19,    19,
     &     19,    18,    18,    18,    18,    18,    17,    17,
     &     17,    17,    17,    17,    18,    18,    17,    17,
     &     18,    18,    16,    17,    18,    18,    19,    19,
     &     19,    20,    22,    22,    23,    24,    24,    24,
     &     23,    24,    24,    24,    25,    26,    26,    27,
     &     27,    27,    26,    27,    28,    28,    28,    28,
     &     28,    29,    29,    29,    30,    29,    29,    28,
     &     27,    27,    26,    27,    26,    27,    27,    27,
     &     27,    26,    25,    24,    23,    23,    23,    24,
     &     22,    19,    19,    20,    20,    19,    19,    20,
     &     20,    20,    18,    17,    17,    17,    18,    19,
     &     20,    19,    19,    19,    19,    18,    18,    18,
     &     18,    18,    18,    18,    18,    17,    17,    17,
     &     17,    16,    15,    15,    16,    17,    18,    18,
     &     17,    17,    17,    17,    19,    20,    20,    22,
     &     22,    21,    21,    20,    19,    19,    18,    17,
     &     17,    17,    17,    16,    16,    15,    15,    15,
     &     15,    15,    15,    15,    15,    15,    15,    17,
     &     20,    21,    21,    21,    21,    21,    21,    21,
     &     21,    21,    21,    21,    21,    21,    20,    20,
     &     20,    19,    18,    17,    18,    19,    20,    20,
     &     20,    19,    19,    18,    17,    17,    16,    17,
     &     17,    17,    19,    20,    19,    18,    18,    19,
     &     17,    17,    19,    19,    19,    20,    20,    19,
     &     19,    19,    18,    18,    18,    18,    18,    18,
     &     19,    20,    20,    20,    20,    21,    21,    22,
     &     21,    22,    22,    21,    22,    22,    22,    22,
     &     22,    22,    21,    23,    23,    24,    22,    22,
     &     22,    22,    24,    25,    25,    25,    25,    25,
     &     26,    27,    27,    25,    25,    24,    24,    24,
     &     24,    23,    23,    24,    24,    25,    24,    24,
     &     25,    24,    24,    27,    27,    27,    26,    26,
     &     28,    28,    28,    28,    28,    28,    28,    27,
     &     27,    27,    28,    27,    26,    26,    26,    26,
     &     24,    25,    23,    24,    24,    26,    26,    26,
     &     26,    27,    26,    26,    26,    26,    27,    27,
     &     27,    27,    27,    27,    28,    28,    27,    27,
     &     26,    26,    27,    27,    26,    26,    24,    24,
     &     25,    25,    26,    26,    22,    21,    22,    22,
     &     22,    22,    22,    22,    22,    21,    23,    23,
     &     23,    23,    23,    24,    23,    24,    23,    22,
     &     22,    22,    21,    21,    22,    23,    22,    22,
     &     22,    22,    22,    22,    22,    23,    25,    25,
     &     24,    24,    24,    23,    24,    24,    24,    24,
     &     23,    23,    24,    24,    25,    25,    24,    25,
     &     25,    25,    25,    25,    27,    26,    27,    26,
     &     25,    24,    22,    23,    25,    24,    24,    23,
     &     22,    21,    22,    24,    24,    23,    23,    23,
     &     25,    24,    24,    24,    24,    24,    25,    26,
     &     26,    26,    25,    26,    27,    27,    27,    27,
     &     28,    28,    28,    28,    30,    30,    29,    29,
     &     29,    29,    31,    32,    32,    32,    31,    31,
     &     31,    29,    28,    29,    29,    32,    32,    33,
     &     33,    32,    31,    31,    31,    32,    33,    34,
     &     33,    33,    33,    33,    33,    33,    34,    34/
      Data (writetable(i),i=   20001,   20800)/
     &     34,    36,    37,    37,    38,    38,    39,    41,
     &     40,    40,    41,    42,    42,    41,    42,    42,
     &     40,    42,    42,    42,    42,    43,    43,    43,
     &     44,    44,    44,    41,    39,    38,    37,    37,
     &     36,    35,    35,    36,    37,    38,    39,    38,
     &     37,    39,    38,    37,    38,    38,    39,    37,
     &     39,    41,    41,    41,    39,    40,    42,    43,
     &     44,    45,    44,    45,    46,    46,    45,    45,
     &     45,    44,    42,    39,    40,    40,    39,    40,
     &     42,    42,    42,    41,    42,    39,    40,    40,
     &     41,    42,    43,    42,    43,    45,    47,    48,
     &     48,    49,    49,    47,    47,    46,    46,    46,
     &     47,    47,    47,    47,    49,    49,    52,    52,
     &     51,    51,    53,    55,    54,    55,    53,    54,
     &     52,    52,    54,    55,    56,    57,    56,    56,
     &     56,    55,    54,    53,    52,    52,    51,    54,
     &     54,    53,    54,    55,    54,    55,    57,    59,
     &     58,    58,    58,    56,    56,    56,    58,    59,
     &     62,    62,    63,    63,    64,    66,    67,    68,
     &     67,    67,    66,    65,    65,    65,    64,    63,
     &     59,    58,    57,    58,    57,    59,    61,    63,
     &     63,    64,    63,    63,    61,    61,    60,    59,
     &     60,    60,    60,    60,    59,    59,    60,    59,
     &     57,    57,    59,    58,    60,    61,    60,    60,
     &     61,    61,    61,    60,    57,    57,    54,    56,
     &     57,    58,    58,    58,    57,    58,    60,    61,
     &     61,    60,    63,    62,    62,    63,    62,    60,
     &     60,    57,    56,    53,    55,    56,    57,    58,
     &     59,    59,    59,    59,    54,    55,    54,    55,
     &     53,    51,    51,    51,    53,    54,    53,    54,
     &     56,    55,    55,    55,    54,    54,    54,    54,
     &     53,    54,    54,    52,    51,    49,    47,    46,
     &     43,    43,    43,    41,    41,    41,    40,    39,
     &     38,    38,    36,    35,    35,    35,    34,    34,
     &     35,    34,    34,    34,    33,    41,    41,    40,
     &     38,    37,    39,    39,    41,    41,    41,    40,
     &     38,    39,    39,    39,    39,    39,    38,    37,
     &     35,    35,    33,    35,    34,    34,    35,    34,
     &     32,    33,    32,    32,    30,    29,    28,    28,
     &     28,    27,    28,    27,    29,    30,    30,    29,
     &     26,    27,    27,    28,    28,    29,    31,    33,
     &     32,    33,    34,    35,    34,    35,    35,    35,
     &     33,    33,    32,    32,    33,    33,    33,    33,
     &     33,    34,    35,    35,    35,    35,    35,    37,
     &     39,    39,    39,    40,    39,    39,    39,    39,
     &     40,    41,    41,    42,    41,    40,    40,    41,
     &     42,    43,    42,    42,    42,    41,    42,    44,
     &     45,    47,    46,    43,    43,    42,    43,    42,
     &     41,    40,    40,    40,    39,    37,    37,    37,
     &     34,    35,    35,    36,    35,    33,    34,    35,
     &     35,    37,    39,    38,    40,    42,    42,    43,
     &     43,    41,    41,    42,    39,    39,    39,    35,
     &     36,    35,    34,    35,    34,    34,    34,    34,
     &     35,    35,    36,    35,    36,    35,    36,    37,
     &     36,    37,    37,    39,    38,    37,    35,    35,
     &     36,    37,    37,    37,    37,    36,    36,    34,
     &     34,    34,    34,    35,    35,    34,    34,    32,
     &     32,    34,    33,    32,    31,    30,    31,    31,
     &     30,    30,    32,    33,    34,    35,    35,    36,
     &     34,    34,    34,    35,    35,    33,    34,    34,
     &     35,    35,    35,    35,    35,    34,    35,    35,
     &     36,    36,    36,    37,    38,    35,    33,    32,
     &     32,    33,    31,    30,    29,    29,    27,    28,
     &     29,    29,    29,    28,    28,    30,    30,    30,
     &     30,    30,    29,    29,    30,    31,    30,    30,
     &     31,    33,    32,    32,    33,    32,    32,    32,
     &     32,    31,    31,    33,    34,    32,    33,    33,
     &     33,    33,    33,    33,    31,    31,    31,    31,
     &     31,    32,    32,    32,    33,    33,    32,    32,
     &     33,    34,    35,    36,    36,    36,    36,    37,
     &     35,    34,    34,    34,    33,    34,    33,    33,
     &     33,    32,    32,    32,    33,    32,    32,    34,
     &     35,    34,    34,    35,    34,    34,    33,    32,
     &     32,    32,    33,    33,    35,    33,    33,    33,
     &     32,    31,    31,    31,    31,    31,    32,    31,
     &     31,    30,    31,    31,    31,    31,    32,    31,
     &     31,    29,    29,    29,    29,    30,    31,    33,
     &     34,    34,    32,    33,    33,    34,    35,    35,
     &     35,    35,    35,    32,    32,    32,    32,    33,
     &     32,    30,    32,    33,    33,    34,    33,    35,
     &     35,    36,    37,    36,    36,    34,    35,    35,
     &     34,    33,    33,    33,    35,    39,    39,    40,
     &     39,    40,    41,    40,    40,    40,    41,    41,
     &     41,    42,    41,    39,    40,    40,    41,    41,
     &     43,    44,    44,    46,    46,    45,    46,    45,
     &     44,    45,    45,    46,    46,    47,    47,    50,
     &     49,    49,    51,    51,    50,    49,    48,    47,
     &     49,    48,    48,    49,    47,    46,    47,    47,
     &     50,    50,    49,    50,    52,    52,    52,    52,
     &     52,    54,    53,    54,    55,    55,    54,    54,
     &     54,    54,    55,    55,    56,    60,    59,    59,
     &     58,    58,    58,    59,    59,    61,    61,    62,
     &     61,    61,    62,    63,    63,    62,    62,    64,
     &     66,    66,    67,    67,    66,    67,    69,    68,
     &     67,    67,    67,    67,    67,    69,    69,    69,
     &     67,    66,    64,    64,    62,    63,    64,    63,
     &     62,    61,    60,    60,    58,    59,    60,    60,
     &     60,    61,    62,    58,    59,    57,    57,    55,
     &     55,    55,    56,    57,    58,    59,    60,    63,
     &     63,    62,    63,    62,    62,    63,    65,    66/
      Data (writetable(i),i=   20801,   21600)/
     &     65,    67,    64,    66,    69,    69,    68,    66,
     &     65,    68,    67,    67,    66,    68,    68,    69,
     &     74,    77,    78,    81,    82,    83,    82,    81,
     &     83,    85,    87,    89,    88,    88,    88,    88,
     &     87,    86,    86,    85,    84,    83,    82,    81,
     &     79,    81,    83,    84,    82,    84,    83,    85,
     &     85,    85,    83,    87,    87,    88,    90,    92,
     &     92,    94,    96,    97,    98,   100,    99,    98,
     &     98,   101,   101,   101,    98,    96,    97,   100,
     &     99,    99,   101,   101,   103,   105,   102,   104,
     &    102,   105,   107,   105,   104,   104,   103,   101,
     &    101,   102,   102,   100,   101,   101,   101,   103,
     &    103,    99,   102,   101,   103,   102,   102,   102,
     &    105,   104,   103,   103,   104,   103,   103,   102,
     &    101,   102,   102,   103,   101,    99,    97,    98,
     &     99,    99,    98,    95,    90,    90,    89,    88,
     &     87,    85,    86,    84,    83,    82,    81,    81,
     &     80,    80,    81,    80,    79,    81,    80,    81,
     &     81,    82,    81,    80,    83,    82,    83,    79,
     &     78,    79,    80,    81,    83,    83,    81,    82,
     &     80,    81,    81,    82,    83,    83,    87,    86,
     &     86,    84,    85,    89,    88,    85,    89,    89,
     &     87,    88,    87,    88,    86,    86,    87,    86,
     &     85,    83,    82,    78,    77,    80,    79,    78,
     &     74,    73,    69,    65,    64,    62,    58,    58,
     &     58,    57,    56,    54,    54,    52,    50,    49,
     &     49,    47,    44,    44,    43,    42,    42,    42,
     &     40,    40,    40,    41,    41,    41,    40,    40,
     &     37,    38,    38,    36,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0/
      Data (writetable(i),i=   21601,   22400)/
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,  1103,  1099,  1092,  1091,  1077,
     &   1075,  1065,  1062,  1052,  1049,  1049,  1042,  1048,
     &   1053,  1068,  1075,  1088,  1094,  1091,  1084,  1074,
     &   1067,  1063,  1062,  1069,  1068,  1069,  1074,  1073,
     &   1075,  1080,  1089,  1090,  1095,  1092,  1099,  1108,
     &   1120,  1132,  1141,  1142,  1151,  1154,  1163,  1170,
     &   1181,  1198,  1212,  1214,  1232,  1233,  1249,  1259,
     &   1257,  1261,  1261,  1267,  1270,  1274,  1273,  1272,
     &   1292,  1288,  1290,  1291,  1299,  1303,  1308,  1321,
     &   1318,  1318,  1320,  1326,  1339,  1340,  1350,  1347,
     &   1359,  1368,  1366,  1367,  1368,  1380,  1392,  1407,
     &   1419,  1412,  1416,  1428,  1444,  1453,  1466,  1464,
     &   1470,  1473,  1489,  1509,  1514,  1515,  1527,  1534,
     &   1526,  1529,  1525,  1525,  1516,  1508,  1513,  1500,
     &   1498,  1492,  1496,  1489,  1482,  1483,  1489,  1488,
     &   1487,  1485,  1492,  1506,  1495,  1495,  1493,  1489,
     &   1481,  1481,  1489,  1470,  1459,  1450,  1449,  1447,
     &   1442,  1442,  1433,  1421,  1412,  1410,  1421,  1418,
     &   1405,  1403,  1405,  1397,  1394,  1395,  1396,  1388,
     &   1371,  1374,  1365,  1360,  1343,  1343,  1350,  1349,
     &   1346,  1341,  1340,  1347,  1355,  1360,  1358,  1352,
     &   1352,  1361,  1366,  1359,  1373,  1385,  1379,  1366,
     &   1361,  1364,  1367,  1356,  1369,  1378,  1379,  1387,
     &   1392,  1399,  1404,  1412,  1409,  1404,  1406,  1411,
     &   1419,  1417,  1406,  1413,  1412,  1413,  1410,  1420,
     &   1423,  1431,  1434,  1441,  1452,  1462,  1478,  1491,
     &   1482,  1477,  1486,  1486,  1481,  1480,  1487,  1500,
     &   1513,  1525,  1541,  1550,  1546,  1550,  1558,  1567,
     &   1564,  1566,  1577,  1593,  1592,  1607,  1609,  1621,
     &   1629,  1647,  1645,  1654,  1648,  1654,  1659,  1668,
     &   1670,  1674,  1677,  1676,  1673,  1682,  1687,  1698,
     &   1715,  1715,  1730,  1737,  1756,  1755,  1748,  1739,
     &   1727,  1715,  1712,  1705,  1694,  1693,  1685,  1678,
     &   1661,  1652,  1635,  1627,  1621,  1601,  1603,  1608,
     &   1592,  1587,  1576,  1562,  1551,  1554,  1535,  1531,
     &   1519,  1513,  1506,  1501,  1487,  1464,  1454,  1439,
     &   1429,  1416,  1404,  1405,  1398,  1394,  1384,  1369,
     &   1376,  1377,  1364,  1345,  1341,  1332,  1322,  1318,
     &   1321,  1326,  1319,  1327,  1340,  1357,  1360,  1368,
     &   1370,  1384,  1393,  1392,  1395,  1397,  1401,  1397,
     &   1405,  1404,  1404,  1409,  1413,  1422,  1433,  1440,
     &   1438,  1452,  1454,  1454,  1457,  1457,  1471,  1469,
     &   1478,  1498,  1506,  1522,  1538,  1554,  1572,  1588,
     &   1597,  1604,  1617,  1622,  1635,  1637,  1655,  1659,
     &   1685,  1706,  1703,  1710,  1718,  1723,  1757,  1767,
     &   1780,  1805,  1826,  1837,  1851,  1858,  1879,  1894,
     &   1908,  1941,  1958,  1985,  2018,  2046,  2078,  2122,
     &   2155,  2199,  2257,  2284,  2338,  2393,  2419,  2439,
     &   2479,  2535,  2593,  2642,  2682,  2727,  2782,  2845,
     &   2887,  2936,  2995,  3049,  3084,  3146,  3193,  3222,
     &   3244,  3278,  3309,  3338,  3412,  3479,  3521,  3564,
     &   3624,  3685,  3735,  3779,  3823,  3870,  3909,  3974,
     &   4022,  4066,  4120,  4160,  4209,  4238,  4290,  4349,
     &   4396,  4446,  4503,  4551,  4596,  4648,  4715,  4784,
     &   4855,  4942,  4999,  5070,  5125,  5205,  5264,  5325,
     &   5407,  5455,  5526,  5607,  5671,  5740,  5807,  5890,
     &   5978,  6063,  6148,  6238,  6313,  6405,  6517,  6623,
     &   6725,  6829,  6928,  7029,  7127,  7221,  7291,  7404,
     &   7504,  7611,  7708,  7771,  7860,  7972,  8078,  8193,
     &   8309,  8443,  8551,  8643,  8746,  8848,  8957,  9036,
     &   9140,  9260,  9362,  9460,  9563,  9641,  9751,  9874,
     &   9971, 10056, 10154, 10263, 10352, 10427, 10527, 10655,
     &  10773, 10893, 11003, 11113, 11255, 11372, 11520, 11651,
     &  11666, 11674, 11673, 11654, 11667, 11716, 11727, 11739,
     &  11775, 11783, 11795, 11746, 11751, 11781, 11801, 11774,
     &  11731, 11755, 11744, 11748, 11718, 11662, 11614, 11561,
     &  11527, 11490, 11432, 11372, 11308, 11289, 11231, 11160,
     &  11097, 11044, 10947, 10885, 10804, 10721, 10639, 10544,
     &  10443, 10354, 10244, 10141, 10078,  9967,  9844,  9743,
     &   9659,  9554,  9448,  9329,  9191,  9074,  8947,  8823,
     &   8725,  8626,  8538,  8425,  8314,  8216,  8120,  8045,
     &   7951,  7872,  7801,  7722,  7665,  7553,  7520,  7445,
     &   7342,  7283,  7188,  7113,  7048,  6973,  6897,  6818,
     &   6749,  6668,  6583,  6508,  6445,  6357,  6301,  6252,
     &   6218,  6155,  6102,  6052,  5973,  5907,  5844,  5788,
     &   5729,  5654,  5586,  5524,  5463,  5428,  5383,  5350,
     &   5320,  5282,  5253,  5232,  5219,  5172,  5137,  5111,
     &   5069,  5021,  4997,  4960,  4935,  4915,  4888,  4856/
      Data (writetable(i),i=   22401,   23200)/
     &   4816,  4792,  4743,  4707,  4663,  4629,  4587,  4550,
     &   4529,  4506,  4467,  4435,  4400,  4365,  4334,  4309,
     &   4270,  4221,  4178,  4148,  4127,  4095,  4078,  4044,
     &   4005,  3959,  3935,  3880,  3830,  3782,  3749,  3685,
     &   3618,  3573,  3534,  3502,  3471,  3446,  3399,  3370,
     &   3343,  3309,  3275,  3259,  3244,  3201,  3163,  3129,
     &   3110,  3089,  3056,  3032,  3002,  2975,  2942,  2926,
     &   2891,  2870,  2851,  2826,  2816,  2799,  2783,  2768,
     &   2742,  2723,  2722,  2728,  2713,  2707,  2688,  2664,
     &   2657,  2650,  2626,  2599,  2598,  2593,  2572,  2553,
     &   2522,  2500,  2489,  2459,  2453,  2435,  2408,  2367,
     &   2367,  2344,  2312,  2275,  2272,  2262,  2241,  2219,
     &   2207,  2182,  2151,  2130,  2098,  2072,  2041,  2021,
     &   1990,  1974,  1936,  1910,  1886,  1863,  1851,  1838,
     &   1821,  1801,  1780,  1758,  1756,  1747,  1733,  1725,
     &   1726,  1699,  1692,  1675,  1663,  1653,  1644,  1628,
     &   1616,  1607,    62,    61,    60,    58,    57,    57,
     &     57,    56,    57,    55,    54,    53,    51,    50,
     &     49,    49,    49,    49,    49,    48,    48,    49,
     &     49,    49,    47,    46,    44,    43,    42,    39,
     &     40,    40,    39,    40,    37,    37,    38,    37,
     &     37,    36,    38,    37,    36,    35,    38,    39,
     &     38,    37,    38,    39,    39,    41,    42,    44,
     &     44,    44,    45,    48,    47,    47,    49,    49,
     &     51,    52,    53,    53,    53,    52,    53,    53,
     &     55,    58,    62,    62,    61,    63,    65,    65,
     &     66,    67,    68,    72,    71,    71,    69,    68,
     &     66,    66,    66,    67,    68,    70,    70,    72,
     &     76,    77,    77,    76,    76,    75,    75,    74,
     &     72,    72,    71,    70,    68,    65,    65,    64,
     &     64,    64,    61,    61,    60,    59,    58,    57,
     &     55,    55,    55,    54,    55,    51,    50,    50,
     &     49,    49,    48,    47,    48,    47,    47,    44,
     &     44,    44,    44,    44,    44,    43,    42,    41,
     &     41,    40,    39,    38,    39,    39,    38,    38,
     &     37,    39,    38,    37,    37,    38,    39,    36,
     &     35,    33,    34,    35,    36,    36,    35,    34,
     &     35,    35,    36,    35,    36,    37,    38,    40,
     &     41,    42,    42,    41,    42,    43,    45,    45,
     &     45,    46,    46,    48,    49,    49,    49,    49,
     &     49,    50,    54,    54,    54,    54,    55,    55,
     &     56,    56,    57,    57,    55,    56,    56,    59,
     &     60,    58,    58,    57,    58,    57,    57,    57,
     &     59,    57,    56,    55,    55,    54,    55,    54,
     &     53,    54,    54,    54,    54,    56,    56,    58,
     &     57,    57,    58,    59,    61,    62,    59,    60,
     &     58,    57,    55,    55,    57,    54,    52,    51,
     &     48,    49,    51,    52,    52,    54,    54,    53,
     &     51,    48,    46,    46,    46,    46,    46,    45,
     &     41,    41,    40,    39,    38,    38,    37,    35,
     &     34,    34,    32,    32,    32,    33,    33,    34,
     &     34,    34,    33,    33,    32,    31,    32,    32,
     &     31,    31,    33,    34,    35,    36,    35,    32,
     &     32,    32,    32,    31,    31,    32,    31,    33,
     &     32,    33,    31,    32,    33,    34,    35,    37,
     &     38,    38,    38,    37,    36,    39,    40,    40,
     &     41,    42,    42,    42,    42,    42,    43,    44,
     &     44,    44,    44,    44,    46,    48,    47,    47,
     &     47,    45,    45,    47,    47,    47,    46,    47,
     &     45,    44,    43,    42,    42,    43,    44,    44,
     &     45,    44,    46,    46,    47,    46,    44,    44,
     &     44,    44,    45,    45,    45,    46,    46,    46,
     &     46,    45,    45,    45,    45,    47,    48,    48,
     &     48,    45,    43,    44,    44,    42,    42,    44,
     &     45,    44,    46,    48,    46,    45,    47,    46,
     &     46,    44,    45,    46,    45,    48,    49,    52,
     &     52,    52,    54,    54,    53,    54,    53,    53,
     &     52,    53,    52,    51,    49,    52,    53,    53,
     &     56,    57,    59,    59,    58,    58,    59,    59,
     &     61,    62,    61,    61,    60,    61,    60,    61,
     &     61,    61,    60,    58,    57,    59,    61,    62,
     &     62,    61,    61,    62,    63,    62,    61,    61,
     &     61,    59,    58,    58,    57,    58,    60,    62,
     &     64,    65,    65,    66,    67,    65,    65,    65,
     &     65,    65,    65,    65,    67,    68,    71,    74,
     &     73,    74,    74,    75,    74,    73,    74,    74,
     &     75,    75,    75,    74,    75,    76,    75,    75,
     &     75,    74,    71,    71,    70,    70,    71,    70,
     &     70,    69,    67,    66,    68,    72,    75,    73,
     &     71,    71,    71,    71,    71,    68,    66,    60,
     &     62,    66,    64,    66,    69,    69,    66,    64,
     &     69,    70,    71,    70,    71,    73,    73,    74,
     &     77,    75,    79,    81,    79,    81,    86,    88,
     &     88,    94,    94,    96,    97,    99,   100,    99,
     &    100,   101,   104,   104,   111,   111,   113,   117,
     &    114,   115,   117,   116,   117,   117,   120,   120,
     &    122,   125,   124,   124,   124,   127,   129,   127,
     &    130,   129,   126,   125,   124,   125,   125,   129,
     &    128,   127,   131,   130,   132,   133,   131,   133,
     &    133,   132,   134,   136,   138,   137,   137,   139,
     &    140,   140,   136,   134,   135,   135,   141,   141,
     &    141,   139,   141,   142,   144,   148,   151,   150,
     &    152,   152,   154,   155,   155,   156,   157,   156,
     &    155,   159,   160,   164,   164,   164,   160,   162,
     &    162,   161,   163,   162,   163,   166,   166,   167,
     &    170,   172,   175,   173,   171,   173,   175,   173,
     &    171,   170,   169,   164,   164,   163,   156,   155,
     &    152,   151,   149,   146,   145,   144,   142,   141,
     &    140,   139,   137,   136,   132,   133,   132,   132,
     &    133,   130,   129,   130,   132,   130,   129,   127/
      Data (writetable(i),i=   23201,   24000)/
     &    125,   126,   125,   123,   121,   126,   125,   126,
     &    124,   127,   126,   128,   125,   121,   122,   121,
     &    120,   122,   118,   120,   119,   118,   117,   112,
     &    109,   107,   108,   106,   106,   106,   106,   103,
     &    104,   104,   102,   102,   101,    99,    99,   100,
     &    102,   104,   100,   100,   100,   100,   101,   102,
     &    102,   106,   108,   108,   108,   109,   108,   106,
     &    109,   108,   105,   106,   106,   105,   107,   107,
     &    107,   107,   106,   104,   104,    99,   100,   101,
     &    101,    97,    95,    94,    95,    95,    97,    96,
     &     96,    99,    97,    95,    96,    97,    96,    95,
     &     92,    94,    94,    92,    92,    91,    91,    92,
     &     91,    90,    88,    87,    87,    86,    84,    83,
     &     82,    83,    82,    81,    80,    81,    82,    83,
     &     81,    82,    83,    80,    81,    79,    78,    75,
     &     79,    78,    82,    83,    84,    81,    82,    82,
     &     83,    85,    83,    84,    82,    85,    88,    88,
     &     88,    91,    89,    88,    90,    90,    88,    89,
     &     86,    89,    91,    92,    90,    89,    88,    89,
     &     89,    89,    91,    92,    91,    91,    90,    91,
     &     91,    92,    93,    95,    95,    98,    99,    97,
     &     97,    98,    97,    99,    98,    98,   100,    98,
     &    101,   102,   101,   100,   101,   101,    99,   101,
     &    101,   100,    98,    99,    99,    97,    95,    94,
     &     95,    95,    92,    91,    85,    87,    85,    81,
     &     82,    79,    76,    74,    73,    72,    76,    76,
     &     76,    73,    75,    72,    71,    70,    68,    69,
     &     66,    66,    66,    66,    66,    66,    68,    69,
     &     67,    66,    70,    73,    71,    73,    74,    72,
     &     72,    72,    71,    72,    72,    72,    71,    73,
     &     74,    73,    74,    73,    73,    74,    75,    75,
     &     74,    78,    78,    79,    81,    81,    83,    84,
     &     82,    82,    81,    80,    78,    79,    77,    71,
     &     70,    70,    69,    67,    65,    67,    68,    68,
     &     70,    70,    70,    71,    69,    69,    68,    66,
     &     65,    65,    66,    62,    62,    64,    64,    66,
     &     62,    62,    63,    61,    61,    62,    63,    62,
     &     65,    64,    64,    65,    66,    67,    68,    70,
     &     67,    65,    64,    63,    66,    68,    69,    74,
     &     75,    78,    79,    76,    78,    79,    79,    81,
     &     84,    84,    81,    82,    83,    83,    84,    84,
     &     84,    84,    83,    82,    82,    85,    84,    83,
     &     81,    78,    79,    79,    80,    81,    80,    81,
     &     81,    77,    74,    71,    71,    71,    71,    69,
     &     69,    68,    67,    67,    67,    68,    69,    68,
     &     66,    64,    62,    61,    61,    58,    54,    54,
     &     52,    51,    53,    50,    49,    49,    48,    48,
     &     45,    43,    45,    45,    42,    44,    46,    44,
     &     45,    46,    46,    48,    48,    48,    50,    49,
     &     50,    52,    53,    52,    51,    52,    51,    50,
     &     51,    50,    49,    53,    52,    53,    53,    54,
     &     53,    53,    53,    51,    51,    50,    49,    49,
     &     51,    51,    51,    51,    51,    52,    52,    53,
     &     53,    57,    60,    62,    63,    63,    64,    64,
     &     64,    63,    65,    69,    70,    70,    70,    71,
     &     71,    72,    73,    75,    73,    72,    75,    76,
     &     74,    72,    72,    73,    73,    73,    72,    71,
     &     71,    72,    72,    71,    75,    77,    75,    77,
     &     79,    79,    79,    79,    80,    81,    81,    83,
     &     86,    87,    85,    83,    83,    83,    84,    85,
     &     88,    86,    87,    89,    91,    90,    90,    90,
     &     90,    90,    89,    89,    91,    90,    91,    94,
     &     95,    95,    92,    92,    94,    97,    98,   101,
     &    102,   103,   104,   107,   108,   111,   112,   111,
     &    108,   106,   106,   106,   109,   110,   109,   107,
     &    109,   109,   111,   110,   111,   110,   110,   109,
     &    108,   110,   112,   110,   112,   111,   113,   112,
     &    111,   114,   113,   113,   116,   117,   115,   116,
     &    119,   120,   119,   120,   121,   121,   119,   119,
     &    121,   121,   116,   119,   119,   120,   119,   119,
     &    118,   118,   118,   117,   117,   118,   117,   118,
     &    115,   116,   115,   115,   114,   115,   113,   112,
     &    110,   114,   116,   118,   120,   122,   123,   119,
     &    118,   116,   116,   115,   113,   117,   116,   116,
     &    117,   116,   112,   114,   116,   115,   113,   112,
     &    109,   112,   113,   110,   109,   109,   111,   112,
     &    114,   115,   117,   115,   117,   117,   116,   119,
     &    122,   123,   125,   124,   127,   129,   132,   133,
     &    135,   140,   144,   141,   141,   146,   148,   149,
     &    150,   153,   155,   160,   162,   166,   164,   164,
     &    165,   165,   165,   167,   166,   166,   169,   168,
     &    169,   170,   165,   163,   166,   170,   171,   169,
     &    165,   164,   166,   168,   167,   168,   167,   167,
     &    171,   172,   174,   181,   182,   183,   183,   187,
     &    185,   189,   189,   186,   186,   190,   187,   183,
     &    186,   187,   184,   186,   186,   186,   187,   191,
     &    193,   195,   200,   202,   205,   205,   211,   209,
     &    207,   206,   203,   202,   203,   203,   202,   204,
     &    204,   206,   201,   198,   199,   201,   203,   204,
     &    203,   205,   205,   204,   204,   204,   204,   205,
     &    203,   206,   205,   206,   209,   210,   209,   207,
     &    206,   206,   203,   201,   202,   203,   206,   207,
     &    207,   205,   205,   205,   208,   205,   205,   202,
     &    204,   201,   199,   197,   195,   196,   195,   193,
     &    194,   197,   194,   196,   202,   199,   199,   197,
     &    198,   195,   195,   195,   197,   200,   200,   202,
     &    201,   199,   200,   203,   203,   205,   206,   204,
     &    202,   197,   202,   202,   200,   198,   197,   194,
     &    191,   190,   188,   194,   190,   187,   185,   182,
     &    174,   174,   173,   168,   166,   167,   167,   165/
      Data (writetable(i),i=   24001,   24800)/
     &    167,   165,   161,   159,   158,   156,   152,   151,
     &    152,   150,   149,   147,   143,   142,   142,   142,
     &    142,   142,   140,   137,   136,   134,   130,   130,
     &    130,   129,   129,   130,   129,   128,   130,   129,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0/
      Data (writetable(i),i=   24801,   25600)/
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0/
      Data (writetable(i),i=   25601,   26400)/
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,  1255,  1258,  1258,
     &   1263,  1267,  1255,  1254,  1245,  1248,  1252,  1251,
     &   1246,  1254,  1246,  1235,  1218,  1214,  1220,  1215,
     &   1200,  1194,  1195,  1188,  1184,  1195,  1205,  1209,
     &   1214,  1218,  1220,  1235,  1226,  1235,  1244,  1246,
     &   1255,  1259,  1246,  1255,  1264,  1272,  1270,  1276,
     &   1293,  1309,  1337,  1353,  1376,  1377,  1374,  1379,
     &   1395,  1391,  1396,  1408,  1429,  1448,  1462,  1475,
     &   1486,  1508,  1515,  1520,  1536,  1533,  1542,  1543,
     &   1544,  1564,  1600,  1621,  1646,  1660,  1655,  1663,
     &   1672,  1687,  1706,  1711,  1707,  1725,  1735,  1752,
     &   1765,  1780,  1823,  1863,  1887,  1913,  1924,  1938,
     &   1958,  1963,  1963,  1982,  2000,  2011,  2033,  2066,
     &   2074,  2101,  2101,  2096,  2097,  2087,  2085,  2072,
     &   2071,  2067,  2057,  2049,  2051,  2060,  2068,  2052/
      Data (writetable(i),i=   26401,   27200)/
     &   2055,  2067,  2071,  2083,  2085,  2085,  2083,  2068,
     &   2070,  2073,  2068,  2056,  2061,  2081,  2082,  2094,
     &   2086,  2077,  2091,  2104,  2110,  2130,  2138,  2145,
     &   2133,  2133,  2135,  2129,  2121,  2115,  2106,  2080,
     &   2080,  2078,  2098,  2103,  2100,  2100,  2091,  2084,
     &   2073,  2057,  2064,  2086,  2080,  2075,  2084,  2094,
     &   2104,  2099,  2095,  2109,  2118,  2115,  2126,  2118,
     &   2128,  2130,  2143,  2160,  2169,  2176,  2191,  2185,
     &   2185,  2180,  2193,  2212,  2230,  2225,  2240,  2240,
     &   2253,  2264,  2275,  2284,  2290,  2292,  2292,  2299,
     &   2323,  2342,  2348,  2362,  2372,  2379,  2400,  2430,
     &   2450,  2462,  2464,  2458,  2481,  2514,  2530,  2547,
     &   2558,  2581,  2598,  2603,  2606,  2606,  2622,  2636,
     &   2669,  2668,  2680,  2701,  2717,  2728,  2722,  2759,
     &   2790,  2808,  2819,  2836,  2842,  2861,  2877,  2891,
     &   2917,  2924,  2938,  2948,  2965,  2968,  2983,  3002,
     &   3009,  3036,  3062,  3073,  3094,  3118,  3172,  3177,
     &   3174,  3169,  3155,  3160,  3173,  3164,  3137,  3123,
     &   3130,  3120,  3113,  3109,  3103,  3101,  3094,  3081,
     &   3074,  3062,  3052,  3046,  3037,  3022,  3008,  2987,
     &   2992,  2986,  3003,  2996,  2976,  2964,  2962,  2943,
     &   2932,  2929,  2915,  2902,  2889,  2877,  2869,  2868,
     &   2884,  2876,  2871,  2867,  2859,  2854,  2826,  2800,
     &   2813,  2793,  2808,  2820,  2821,  2844,  2871,  2896,
     &   2908,  2924,  2944,  2948,  2937,  2954,  2961,  2989,
     &   2982,  2991,  3015,  3024,  3028,  3053,  3080,  3108,
     &   3128,  3153,  3166,  3194,  3225,  3258,  3284,  3300,
     &   3324,  3335,  3353,  3370,  3407,  3423,  3461,  3499,
     &   3515,  3534,  3545,  3587,  3620,  3634,  3666,  3709,
     &   3746,  3766,  3799,  3837,  3880,  3926,  3950,  3959,
     &   3995,  4038,  4063,  4078,  4117,  4148,  4205,  4235,
     &   4254,  4306,  4385,  4438,  4517,  4584,  4662,  4729,
     &   4785,  4836,  4906,  4990,  5052,  5111,  5168,  5241,
     &   5280,  5352,  5431,  5485,  5568,  5654,  5699,  5799,
     &   5865,  5955,  6043,  6111,  6143,  6213,  6276,  6320,
     &   6398,  6462,  6499,  6508,  6529,  6553,  6557,  6556,
     &   6547,  6540,  6507,  6447,  6418,  6372,  6343,  6322,
     &   6259,  6206,  6151,  6111,  6090,  6050,  6022,  5978,
     &   5929,  5905,  5865,  5821,  5777,  5716,  5671,  5640,
     &   5582,  5571,  5542,  5520,  5473,  5430,  5393,  5354,
     &   5289,  5252,  5211,  5192,  5167,  5106,  5068,  5045,
     &   5031,  4990,  4977,  4941,  4928,  4911,  4900,  4880,
     &   4877,  4883,  4871,  4847,  4855,  4827,  4818,  4792,
     &   4785,  4753,  4717,  4695,  4681,  4658,  4637,  4623,
     &   4590,  4561,  4533,  4510,  4482,  4471,  4435,  4396,
     &   4372,  4331,  4301,  4272,  4225,  4179,  4147,  4108,
     &   4071,  4033,  3992,  3970,  3947,  3906,  3865,  3826,
     &   3793,  3753,  3743,  3718,  3699,  3676,  3671,  3656,
     &   3660,  3648,  3606,  3561,  3520,  3490,  3466,  3416,
     &   3391,  3378,  3336,  3313,  3280,  3282,  3244,  3230,
     &   3220,  3179,  3159,  3140,  3107,  3082,  3071,  3071,
     &   3047,  3034,  3016,  3021,  3016,  2994,  2981,  2993,
     &   2982,  2969,  2995,  2984,  3012,  3025,  3050,  3046,
     &   3065,  3083,  3097,  3112,  3125,  3129,  3142,  3151,
     &   3177,  3204,  3216,  3218,  3191,  3173,  3140,  3126,
     &   3107,  3089,  3060,  3045,  3019,  3012,  3001,  2968,
     &   2940,  2932,  2929,  2920,  2906,  2912,  2922,  2919,
     &   2899,  2886,  2877,  2874,  2860,  2863,  2860,  2864,
     &   2855,  2838,  2815,  2817,  2814,  2813,  2818,  2819,
     &   2816,  2804,  2783,  2772,  2756,  2743,  2728,  2719,
     &   2697,  2684,  2673,  2653,  2632,  2618,  2620,  2623,
     &   2614,  2603,  2605,  2591,  2590,  2596,  2590,  2574,
     &   2577,  2597,  2603,  2589,  2597,  2579,  2566,  2569,
     &   2559,  2561,  2547,  2573,  2566,  2553,  2552,  2565,
     &   2573,  2564,  2563,  2552,  2567,  2574,  2577,  2570,
     &   2578,  2568,  2563,  2561,  2563,  2562,  2546,  2536,
     &   2526,  2510,  2508,  2488,  2472,  2469,  2453,  2422,
     &   2420,  2386,  2363,  2320,  2298,  2279,  2256,  2253,
     &   2256,  2256,  2243,  2236,  2226,  2210,  2211,  2218,
     &   2216,  2218,  2224,  2221,  2213,  2207,  2213,  2207,
     &   2222,  2224,  2240,  2237,  2238,  2234,  2234,  2241,
     &   2241,  2234,  2225,  2223,  2212,  2201,  2200,  2191,
     &   2184,  2179,  2185,  2195,  2199,  2165,  2181,  2193,
     &   2197,  2190,  2184,  2167,  2155,  2144,  2144,  2140,
     &   2111,  2107,  2107,  2103,  2092,  2085,  2067,  2057,
     &   2033,  2025,  2014,  1992,  1984,  1989,  1987,  1979,
     &   1973,  1963,  1954,  1943,  1922,  1904,  1904,  1891,
     &   1882,  1881,  1877,  1868,  1857,  1848,  1833,  1825,
     &   1820,  1831,  1823,  1828,  1830,  1837,  1838,  1846,
     &   1853,  1869,  1875,  1876,   187,   188,   191,   191,
     &    192,   191,   191,   192,   196,   195,   195,   195,
     &    197,   193,   190,   197,   198,   197,   197,   192,
     &    194,   191,   189,   190,   189,   195,   195,   197,
     &    201,   199,   200,   204,   203,   198,   199,   201,
     &    197,   203,   209,   213,   221,   226,   229,   229,
     &    224,   225,   223,   226,   233,   228,   230,   232,
     &    235,   240,   243,   240,   245,   246,   248,   246,
     &    247,   250,   254,   255,   258,   260,   261,   258,
     &    255,   265,   266,   272,   276,   274,   276,   279,
     &    278,   281,   275,   276,   277,   277,   280,   279,
     &    279,   286,   288,   291,   298,   301,   305,   304,
     &    306,   314,   313,   307,   311,   311,   314,   316,
     &    321,   323,   323,   325,   326,   322,   318,   319,
     &    322,   322,   314,   311,   310,   308,   308,   307,
     &    310,   311,   307,   310,   303,   307,   311,   314,
     &    313,   315,   320,   318,   322,   323,   318,   320,
     &    314,   311,   308,   307,   304,   308,   312,   309,
     &    308,   306,   301,   300,   302,   302,   298,   295,
     &    292,   291,   290,   291,   288,   284,   278,   278,
     &    280,   278,   282,   285,   282,   278,   273,   279/
      Data (writetable(i),i=   27201,   28000)/
     &    279,   276,   274,   272,   274,   273,   274,   271,
     &    267,   269,   270,   269,   272,   268,   266,   265,
     &    261,   263,   262,   261,   258,   256,   259,   258,
     &    261,   264,   264,   263,   269,   272,   278,   280,
     &    286,   287,   291,   286,   287,   288,   291,   296,
     &    294,   296,   301,   300,   307,   313,   317,   319,
     &    318,   317,   322,   325,   329,   327,   328,   330,
     &    332,   333,   332,   334,   334,   339,   338,   340,
     &    339,   339,   343,   341,   342,   338,   343,   343,
     &    340,   338,   336,   344,   350,   353,   356,   353,
     &    356,   365,   365,   363,   363,   361,   364,   361,
     &    358,   362,   363,   361,   356,   361,   357,   349,
     &    348,   345,   343,   343,   342,   339,   335,   329,
     &    323,   322,   323,   324,   326,   321,   322,   321,
     &    320,   324,   326,   326,   323,   321,   315,   311,
     &    307,   306,   302,   301,   301,   297,   299,   303,
     &    302,   300,   305,   300,   300,   294,   292,   291,
     &    285,   287,   286,   283,   284,   284,   289,   286,
     &    285,   285,   291,   291,   291,   291,   292,   287,
     &    288,   284,   286,   285,   282,   284,   279,   290,
     &    297,   297,   298,   296,   300,   295,   292,   290,
     &    290,   288,   288,   289,   294,   291,   290,   289,
     &    289,   291,   301,   302,   303,   312,   318,   322,
     &    325,   331,   329,   332,   336,   334,   340,   341,
     &    341,   340,   339,   338,   341,   343,   343,   355,
     &    360,   362,   364,   370,   372,   375,   379,   383,
     &    387,   397,   399,   402,   414,   423,   431,   439,
     &    452,   465,   472,   492,   508,   522,   537,   547,
     &    563,   581,   588,   598,   599,   614,   622,   633,
     &    642,   645,   650,   657,   666,   678,   691,   699,
     &    708,   724,   729,   748,   758,   768,   777,   783,
     &    790,   801,   808,   820,   836,   840,   856,   868,
     &    876,   877,   884,   887,   897,   906,   919,   930,
     &    941,   957,   970,   985,   993,   998,  1005,  1020,
     &   1031,  1048,  1067,  1079,  1093,  1106,  1125,  1131,
     &   1139,  1153,  1161,  1178,  1183,  1198,  1209,  1223,
     &   1247,  1264,  1284,  1309,  1333,  1349,  1366,  1394,
     &   1420,  1431,  1449,  1470,  1489,  1514,  1534,  1548,
     &   1569,  1583,  1605,  1621,  1639,  1674,  1696,  1724,
     &   1745,  1767,  1788,  1802,  1814,  1836,  1859,  1891,
     &   1913,  1931,  1959,  1982,  2002,  2026,  2041,  2073,
     &   2083,  2106,  2126,  2163,  2184,  2221,  2255,  2287,
     &   2324,  2328,  2329,  2327,  2342,  2336,  2329,  2325,
     &   2329,  2322,  2324,  2330,  2311,  2325,  2336,  2344,
     &   2352,  2351,  2347,  2344,  2342,  2333,  2327,  2312,
     &   2291,  2280,  2282,  2275,  2261,  2251,  2242,  2234,
     &   2231,  2215,  2213,  2191,  2175,  2158,  2142,  2125,
     &   2112,  2089,  2068,  2046,  2022,  1997,  1968,  1935,
     &   1911,  1885,  1872,  1839,  1823,  1795,  1773,  1749,
     &   1728,  1700,  1671,  1655,  1646,  1616,  1608,  1593,
     &   1575,  1557,  1541,  1536,  1527,  1505,  1486,  1474,
     &   1453,  1440,  1422,  1411,  1396,  1373,  1359,  1349,
     &   1338,  1324,  1309,  1297,  1287,  1276,  1258,  1244,
     &   1230,  1216,  1203,  1196,  1188,  1164,  1166,  1160,
     &   1145,  1124,  1126,  1117,  1085,  1077,  1071,  1062,
     &   1050,  1049,  1043,  1043,  1035,  1030,  1030,  1020,
     &   1016,  1010,  1004,  1006,  1002,   996,   985,   983,
     &    976,   970,   971,   971,   957,   953,   951,   947,
     &    942,   933,   924,   921,   909,   908,   898,   889,
     &    878,   863,   865,   850,   851,   841,   838,   823,
     &    813,   813,   799,   781,   785,   781,   768,   761,
     &    748,   741,   740,   732,   731,   728,   723,   710,
     &    703,   694,   690,   681,   668,   669,   660,   659,
     &    653,   651,   646,   641,   642,   638,   630,   623,
     &    620,   621,   623,   619,   614,   615,   611,   605,
     &    592,   582,   570,   567,   561,   554,   555,   556,
     &    550,   545,   536,   538,   539,   540,   532,   529,
     &    523,   520,   514,   513,   514,   509,   508,   506,
     &    493,   488,   488,   486,   488,   483,   481,   480,
     &    472,   476,   474,   463,   455,   449,   448,   448,
     &    435,   431,   434,   434,   431,   427,   416,   410,
     &    405,   397,   399,   395,   394,   391,   387,   381,
     &    377,   371,   371,   367,   364,   365,   357,   356,
     &    356,   355,   350,   113,   115,   115,   113,   114,
     &    110,   108,   107,   105,   104,   102,   103,    97,
     &     96,    97,    95,    94,    93,    92,    94,    93,
     &     91,    90,    87,    85,    85,    87,    83,    82,
     &     82,    83,    85,    82,    82,    81,    84,    83,
     &     83,    83,    82,    78,    76,    76,    73,    73,
     &     76,    75,    73,    72,    69,    70,    70,    74,
     &     74,    75,    78,    79,    82,    84,    84,    85,
     &     83,    81,    84,    86,    89,    92,    95,    96,
     &     99,   100,   101,   103,   105,   104,   104,   108,
     &    111,   113,   114,   116,   115,   113,   113,   113,
     &    114,   114,   114,   115,   119,   121,   123,   123,
     &    125,   123,   123,   125,   125,   128,   130,   128,
     &    128,   124,   121,   121,   118,   114,   110,   109,
     &    110,   109,   109,   108,   111,   111,   112,   107,
     &    107,   106,   102,   102,   103,   100,    99,   104,
     &    103,   104,   104,   103,   104,   102,   103,   103,
     &    104,   104,   101,   104,   102,    98,    94,    93,
     &     92,    90,    89,    87,    86,    83,    80,    83,
     &     83,    81,    81,    81,    82,    83,    83,    84,
     &     83,    84,    80,    82,    80,    78,    76,    77,
     &     78,    76,    74,    73,    73,    74,    74,    75,
     &     76,    78,    78,    76,    76,    77,    77,    75,
     &     73,    70,    69,    68,    70,    69,    68,    69,
     &     71,    71,    73,    73,    72,    73,    73,    77,
     &     75,    77,    79,    74,    74,    73,    74,    76,
     &     74,    74,    75,    74,    74,    73,    79,    81/
      Data (writetable(i),i=   28001,   28800)/
     &     79,    76,    76,    77,    82,    80,    79,    82,
     &     80,    80,    80,    79,    78,    78,    77,    77,
     &     74,    77,    76,    76,    74,    73,    71,    71,
     &     70,    69,    72,    73,    72,    74,    74,    73,
     &     74,    75,    75,    74,    79,    81,    82,    80,
     &     81,    80,    81,    80,    82,    82,    79,    81,
     &     81,    81,    81,    80,    80,    81,    80,    80,
     &     77,    79,    80,    80,    77,    76,    77,    77,
     &     77,    73,    74,    74,    77,    76,    73,    72,
     &     71,    69,    67,    65,    66,    67,    67,    68,
     &     67,    67,    67,    67,    68,    66,    65,    66,
     &     68,    67,    69,    68,    69,    68,    69,    68,
     &     70,    70,    72,    70,    67,    69,    68,    67,
     &     70,    71,    69,    69,    69,    69,    70,    70,
     &     70,    69,    70,    71,    70,    70,    68,    68,
     &     68,    67,    67,    67,    67,    67,    69,    72,
     &     70,    70,    69,    69,    70,    69,    69,    70,
     &     69,    70,    70,    70,    71,    73,    73,    76,
     &     77,    78,    77,    79,    81,    82,    83,    84,
     &     86,    86,    86,    87,    87,    87,    88,    86,
     &     87,    90,    94,    92,    93,    96,    98,    97,
     &     99,   101,   101,   101,   102,   103,   103,   102,
     &    100,   101,   102,   105,   106,   105,   109,   108,
     &    112,   115,   118,   117,   113,   114,   113,   113,
     &    113,   113,   114,   113,   113,   113,   114,   111,
     &    112,   113,   115,   114,   116,   115,   118,   120,
     &    123,   123,   127,   129,   127,   126,   126,   130,
     &    130,   135,   134,   133,   132,   133,   134,   134,
     &    134,   137,   135,   135,   135,   136,   137,   140,
     &    143,   141,   143,   145,   146,   148,   149,   149,
     &    152,   155,   156,   156,   156,   156,   157,   159,
     &    157,   155,   152,   151,   153,   152,   156,   159,
     &    161,   162,   159,   159,   158,   158,   157,   160,
     &    159,   158,   161,   164,   158,   158,   159,   160,
     &    161,   166,   165,   163,   164,   163,   162,   162,
     &    163,   164,   166,   169,   171,   172,   178,   180,
     &    177,   174,   174,   173,   171,   169,   167,   167,
     &    166,   161,   159,   163,   156,   160,   157,   154,
     &    148,   150,   156,   159,   157,   155,   155,   158,
     &    156,   155,   161,   165,   168,   169,   172,   175,
     &    170,   171,   170,   172,   178,   179,   181,   182,
     &    185,   186,   188,   192,   195,   197,   202,   206,
     &    211,   209,   208,   211,   210,   209,   207,   210,
     &    211,   211,   207,   207,   209,   210,   213,   217,
     &    220,   225,   229,   228,   233,   237,   236,   235,
     &    234,   235,   237,   237,   240,   238,   239,   241,
     &    245,   246,   247,   246,   246,   245,   252,   251,
     &    253,   253,   256,   252,   256,   256,   253,   259,
     &    252,   251,   250,   251,   248,   245,   243,   243,
     &    242,   244,   243,   246,   247,   251,   254,   251,
     &    251,   251,   253,   257,   253,   251,   253,   253,
     &    255,   255,   255,   255,   257,   256,   254,   255,
     &    258,   258,   255,   254,   253,   255,   257,   256,
     &    251,   249,   251,   251,   252,   249,   246,   245,
     &    241,   236,   235,   234,   232,   231,   228,   229,
     &    230,   222,   223,   222,   223,   221,   222,   224,
     &    221,   223,   223,   221,   227,   226,   229,   224,
     &    222,   223,   223,   224,   224,   224,   223,   228,
     &    230,   232,   233,   241,   243,   243,   242,   242,
     &    246,   246,   245,   250,   251,   247,   246,   243,
     &    243,   241,   247,   252,   254,   254,   249,   256,
     &    254,   254,   257,   254,   254,   254,   251,   249,
     &    248,   251,   251,   251,   250,   247,   244,   239,
     &    242,   237,   231,   227,   226,   230,   230,   232,
     &    233,   233,   230,   233,   228,   229,   226,   223,
     &    222,   224,   222,   222,   221,   222,   220,   219,
     &    218,   217,   216,   216,   214,   214,   209,   209,
     &    204,   202,   181,   180,   174,   175,   169,   165,
     &    164,   162,   160,   161,   160,   161,   163,   161,
     &    160,   157,   153,   152,   144,   145,   140,   141,
     &    135,   135,   134,   135,   139,   137,   139,   140,
     &    135,   134,   133,   130,   127,   127,   126,   126,
     &    125,   125,   123,   125,   125,   124,   124,   126,
     &    127,   126,   125,   127,   127,   128,   130,   138,
     &    139,   143,   144,   145,   142,   146,   147,   152,
     &    153,   157,   158,   160,   159,   158,   160,   161,
     &    166,   167,   165,   168,   170,   169,   171,   173,
     &    171,   173,   175,   175,   182,   184,   186,   188,
     &    190,   190,   191,   195,   195,   199,   203,   207,
     &    207,   211,   210,   214,   212,   215,   221,   217,
     &    210,   211,   215,   217,   218,   209,   205,   206,
     &    207,   203,   198,   200,   197,   191,   185,   185,
     &    183,   176,   173,   172,   171,   169,   168,   169,
     &    169,   163,   167,   171,   174,   176,   175,   176,
     &    177,   179,   177,   179,   177,   176,   175,   180,
     &    179,   180,   180,   179,   177,   176,   171,   173,
     &    172,   173,   175,   174,   173,   175,   171,   171,
     &    165,   167,   169,   169,   166,   164,   163,   163,
     &    159,   161,   166,   165,   163,   166,   163,   162,
     &    159,   161,   159,   159,   161,   161,   162,   165,
     &    165,   163,   160,   159,   157,   157,   156,   157,
     &    161,   161,   157,   155,   154,   153,   152,   149,
     &    149,   147,   146,   146,   148,   148,   145,   145,
     &    146,   141,   140,   140,   138,   142,   146,   151,
     &    150,   151,   151,   158,   155,   155,   155,   155,
     &    154,   157,   152,   152,   151,   151,   153,   153,
     &    153,   153,   154,   153,   150,   152,   158,   156,
     &    156,   156,   157,   157,   157,   158,   162,   163,
     &    164,   172,   173,   174,   174,   173,   175,   170,
     &    166,   162,   159,   155,   154,   149,   148,   145/
      Data (writetable(i),i=   28801,   29600)/
     &    144,   146,   144,   140,   135,   132,   131,   129,
     &    129,   129,   128,   128,   128,   130,   126,   125,
     &    124,   122,   121,   118,   119,   118,   118,   117,
     &    114,   111,   110,   112,   111,   110,   106,   101,
     &    101,   102,    99,    99,   102,   100,   101,   102,
     &    102,   100,    97,    97,    97,   102,   100,   101,
     &     99,   102,   103,   104,   104,   101,    99,    97,
     &    100,   100,   104,   104,   105,   106,   107,   109,
     &    111,   109,   111,   111,   111,   117,   113,   114,
     &    114,   115,   114,   117,   117,   115,   114,   111,
     &    115,   118,   120,   121,   121,   124,   124,   129,
     &    131,   134,   135,   135,   136,   141,   141,   145,
     &    145,   149,   147,   146,   147,   149,   155,   160,
     &    163,   167,   166,   171,   173,   173,   172,   172,
     &    173,   172,   177,   179,   179,   176,   178,   178,
     &    178,   185,   186,   192,   198,   201,   203,   207,
     &    210,   212,   216,   214,   216,   215,   214,   215,
     &    216,   217,   218,   218,   216,   213,   214,   215,
     &    216,   213,   214,   206,   202,   203,   204,   203,
     &    205,   207,   212,   212,   216,   215,   217,   219,
     &    223,   225,   223,   221,   218,   216,   216,   216,
     &    219,   219,   218,   217,   215,   218,   223,   225,
     &    225,   226,   231,   231,   231,   227,   227,   224,
     &    227,   230,   231,   239,   240,   243,   243,   237,
     &    238,   237,   238,   235,   234,   235,   235,   235,
     &    234,   231,   232,   230,   229,   228,   225,   227,
     &    228,   230,   232,   231,   231,   230,   229,   231,
     &    232,   234,   234,   233,   230,   230,   232,   231,
     &    233,   233,   231,   234,   236,   231,   232,   233,
     &    234,   234,   232,   228,   237,   241,   246,   242,
     &    239,   236,   231,   231,   229,   231,   231,   231,
     &    233,   231,   228,   242,   235,   234,   234,   231,
     &    231,   233,   235,   233,   229,   230,   233,   234,
     &    234,   239,   241,   245,   249,   255,   253,   257,
     &    258,   258,   264,   273,   279,   283,   284,   288,
     &    296,   299,   306,   309,   315,   321,   323,   327,
     &    334,   335,   338,   336,   332,   334,   340,   345,
     &    345,   350,   351,   354,   352,   353,   349,   349,
     &    349,   349,   347,   346,   350,   347,   346,   350,
     &    348,   351,   348,   352,   352,   351,   353,   358,
     &    364,   364,   369,   372,   372,   379,   378,   376,
     &    376,   379,   378,   381,   382,   383,   389,   388,
     &    389,   385,   390,   392,   393,   390,   397,   397,
     &    398,   403,   404,   405,   411,   415,   418,   420,
     &    420,   417,   415,   412,   416,   416,   420,   422,
     &    421,   426,   426,   426,   426,   427,   427,   427,
     &    430,   433,   432,   432,   434,   430,   428,   428,
     &    427,   425,   426,   428,   427,   424,   427,   426,
     &    420,   413,   404,   402,   401,   402,   396,   395,
     &    398,   398,   397,   398,   397,   399,   399,   399,
     &    397,   391,   396,   394,   394,   397,   391,   391,
     &    394,   394,   393,   399,   403,   400,   399,   401,
     &    409,   407,   406,   404,   406,   410,   413,   415,
     &    421,   422,   419,   414,   415,   411,   414,   412,
     &    414,   415,   416,   421,   419,   416,   420,   415,
     &    420,   417,   412,   406,   409,   408,   413,   415,
     &    415,   413,   413,   411,   414,   418,   418,   411,
     &    400,   397,   391,   391,   389,   390,   389,   382,
     &    385,   377,   372,   370,   368,   360,   358,   351,
     &    348,   345,   345,   338,   339,   340,   341,   339,
     &    343,   345,   342,   344,   345,   342,   337,   334,
     &    333,   103,   101,   101,   100,   100,    97,    95,
     &     95,    95,    92,    95,    97,    97,    99,    96,
     &     94,    96,    94,    92,    92,    90,    85,    85,
     &     84,    85,    88,    88,    84,    83,    86,    88,
     &     88,    90,    89,    87,    82,    80,    79,    83,
     &     85,    84,    86,    87,    91,    92,    90,    87,
     &     87,    91,    90,    91,    92,    92,    93,    94,
     &     95,   100,   101,   101,    99,   101,   102,   103,
     &    102,   100,    99,   100,    97,    97,   100,   100,
     &    100,   106,   108,   106,   107,   111,   115,   117,
     &    117,   119,   122,   121,   123,   124,   128,   131,
     &    133,   131,   129,   132,   134,   141,   144,   143,
     &    143,   144,   147,   153,   156,   158,   155,   152,
     &    147,   145,   144,   144,   145,   146,   146,   144,
     &    143,   140,   139,   140,   135,   134,   135,   133,
     &    129,   130,   124,   122,   124,   122,   122,   123,
     &    124,   123,   125,   126,   121,   122,   122,   119,
     &    116,   115,   117,   115,   114,   112,   112,   110,
     &    113,   116,   117,   116,   113,   114,   111,   109,
     &    108,   114,   114,   110,   107,   107,   107,   106,
     &    106,   106,   104,   106,   107,   103,   103,   102,
     &    101,   100,    97,    96,    95,    94,    95,    95,
     &     94,    95,    94,    95,    95,    94,    96,    96,
     &     97,    99,    98,    97,    97,    96,    94,    93,
     &     94,    96,    89,    87,    89,    91,    92,    90,
     &     91,    91,    88,    88,    87,    89,    87,    85,
     &     94,    92,    88,    86,    91,    91,    90,    92,
     &     93,    93,    92,    94,    94,    95,    96,    94,
     &     97,    99,    99,   100,    98,    94,    93,    91,
     &     90,    91,    92,    89,    91,    93,    92,    89,
     &     88,    89,    90,    93,    92,    91,    90,    88,
     &     87,    86,    87,    89,    84,    87,    90,    92,
     &     91,    91,    92,    90,    89,    91,    91,    91,
     &     88,    88,    86,    87,    86,    87,    86,    86,
     &     85,    85,    80,    78,    77,    78,    78,    77,
     &     78,    77,    76,    80,    77,    75,    72,    71,
     &     70,    69,    70,    66,    64,    66,    65,    65,
     &     65,    64,    64,    64,    65,    64,    64,    62,
     &     62,    63,    64,    60,    60,    61,    62,    63/
      Data (writetable(i),i=   29601,   30400)/
     &     64,    65,    65,    66,    70,    71,    70,    70,
     &     71,    71,    69,    71,    72,    72,    71,    72,
     &     71,    75,    75,    75,    76,    78,    78,    79,
     &     78,    78,    76,    77,    78,    78,    75,    74,
     &     76,    76,    77,    77,    79,    78,    78,    80,
     &     78,    78,    77,    80,    80,    79,    81,    81,
     &     82,    81,    83,    82,    87,    88,    89,    89,
     &     90,    90,    86,    89,    90,    94,    95,    97,
     &     97,   100,   105,   106,   109,   108,   109,   113,
     &    114,   116,   118,   118,   121,   125,   129,   130,
     &    130,   130,   134,   137,   140,   139,   140,   138,
     &    138,   138,   137,   136,   140,   138,   139,   141,
     &    140,   141,   139,   142,   140,   140,   140,   140,
     &    141,   144,   146,   145,   145,   145,   142,   141,
     &    142,   139,   137,   136,   137,   137,   137,   139,
     &    138,   141,   142,   141,   140,   140,   138,   140,
     &    141,   141,   139,   138,   140,   144,   144,   149,
     &    149,   152,   152,   154,   154,   153,   155,   156,
     &    154,   154,   155,   157,   158,   158,   159,   160,
     &    162,   161,   161,   162,   163,   165,   167,   170,
     &    173,   175,   179,   180,   177,   173,   175,   172,
     &    172,   169,   170,   173,   172,   172,   168,   164,
     &    164,   163,   165,   163,   162,   162,   162,   162,
     &    160,   163,   165,   169,   169,   177,   175,   172,
     &    173,   173,   173,   173,   168,   161,   158,   156,
     &    153,   156,   158,   157,   156,   155,   154,   151,
     &    150,   151,   148,   146,   142,   141,   148,   148,
     &    154,   153,   161,   167,   180,   184,   188,   191,
     &    196,   198,   204,   210,   208,   206,   208,   208,
     &    206,   208,   208,   212,   214,   215,   219,   216,
     &    216,   217,   215,   212,   213,   215,   214,   219,
     &    218,   216,   222,   222,   224,   220,   220,   222,
     &    226,   227,   224,   232,   238,   241,   241,   246,
     &    248,   249,   248,   248,   250,   255,   255,   253,
     &    254,   254,   253,   256,   260,   262,   266,   266,
     &    268,   273,   273,   276,   278,   281,   282,   281,
     &    279,   280,   280,   285,   282,   281,   283,   284,
     &    289,   290,   292,   292,   292,   292,   289,   285,
     &    288,   295,   298,   300,   299,   297,   298,   297,
     &    294,   298,   298,   300,   301,   303,   308,   306,
     &    303,   302,   303,   304,   301,   292,   290,   288,
     &    284,   280,   276,   276,   276,   273,   271,   267,
     &    262,   261,   262,   256,   262,   261,   260,   257,
     &    255,   252,   247,   246,   250,   250,   247,   243,
     &    244,   248,   248,   242,   242,   248,   247,   245,
     &    241,   245,   241,   235,   239,   241,   247,   250,
     &    247,   248,   246,   245,   239,   243,   242,   243,
     &    244,   247,   252,   253,   255,   258,   257,   257,
     &    254,   251,   250,   250,   248,   254,   249,   245,
     &    244,   243,   243,   247,   245,   245,   241,   239,
     &    239,   241,   239,   232,   229,   229,   231,   228,
     &    226,   225,   223,   226,   229,   225,   229,   231,
     &    227,   222,   218,   218,   214,   213,   213,   206,
     &    204,   204,   204,   204,   198,   197,   200,   200,
     &    198,   196,   193,   194,   195,   193,   189,   192,
     &    123,   128,   126,   126,   125,   122,   119,   116,
     &    114,   116,   116,   114,   109,   109,   111,   109,
     &    107,   107,   106,   109,   107,   106,   106,   107,
     &    107,   108,   105,   106,   106,   104,   103,   103,
     &    102,   102,   103,   104,   102,    98,    97,    92,
     &     93,    90,    89,    88,    88,    92,    93,    93,
     &     89,    88,    87,    84,    83,    82,    80,    83,
     &     85,    86,    88,    89,    87,    89,    91,    92,
     &     89,    90,    89,    91,    93,    95,    95,    98,
     &     97,    97,    98,    96,   102,   102,   104,   103,
     &    107,   110,   112,   115,   116,   119,   119,   120,
     &    120,   119,   120,   120,   123,   122,   123,   124,
     &    124,   122,   121,   121,   123,   124,   127,   122,
     &    119,   121,   116,   115,   117,   116,   117,   116,
     &    119,   118,   118,   116,   116,   112,   112,   111,
     &    108,   109,   104,   106,   105,   105,   104,   101,
     &     99,   100,   102,   100,   101,   100,   100,   100,
     &     99,   100,    97,    97,    97,    98,    97,    98,
     &     97,    96,    97,    99,   100,   103,   103,    99,
     &     99,    94,    94,    94,    95,    97,    97,    97,
     &     97,    96,    97,    98,    95,    92,    87,    87,
     &     88,    88,    87,    88,    88,    86,    87,    86,
     &     83,    83,    82,    81,    84,    85,    85,    86,
     &     86,    87,    86,    83,    85,    86,    84,    84,
     &     81,    85,    85,    85,    88,    88,    89,    88,
     &     89,    89,    87,    87,    87,    85,    81,    84,
     &     81,    81,    81,    80,    81,    79,    77,    77,
     &     81,    79,    80,    78,    75,    77,    79,    78,
     &     79,    76,    74,    76,    81,    81,    79,    81,
     &     81,    81,    81,    79,    81,    80,    83,    83,
     &     85,    83,    83,    81,    83,    83,    82,    80,
     &     80,    81,    81,    81,    82,    81,    82,    84,
     &     81,    79,    79,    77,    80,    79,    79,    80,
     &     80,    81,    79,    77,    78,    75,    75,    74,
     &     73,    71,    70,    71,    69,    70,    69,    70,
     &     70,    69,    66,    66,    65,    66,    66,    66,
     &     64,    66,    67,    66,    67,    65,    63,    64,
     &     63,    63,    62,    60,    58,    59,    59,    61,
     &     60,    58,    61,    60,    60,    58,    59,    61,
     &     61,    62,    61,    60,    61,    62,    64,    65,
     &     65,    65,    64,    65,    64,    63,    62,    61,
     &     63,    63,    64,    64,    65,    67,    69,    72,
     &     74,    75,    74,    74,    77,    76,    76,    79,
     &     79,    80,    80,    83,    84,    85,    87,    91,
     &     93,    93,    94,    92,    90,    90,    90,    88/
      Data (writetable(i),i=   30401,   31200)/
     &     88,    88,    90,    90,    91,    94,    97,   101,
     &    100,    98,    99,   100,   101,   105,   108,   107,
     &    106,   109,   111,   117,   120,   123,   122,   124,
     &    125,   133,   136,   135,   135,   137,   139,   140,
     &    145,   145,   151,   151,   152,   150,   149,   148,
     &    149,   146,   145,   146,   148,   146,   149,   152,
     &    154,   156,   156,   155,   153,   154,   156,   159,
     &    160,   157,   158,   162,   161,   160,   158,   158,
     &    157,   156,   157,   157,   155,   155,   155,   150,
     &    149,   150,   148,   150,   152,   152,   151,   151,
     &    151,   152,   152,   151,   149,   148,   151,   153,
     &    149,   149,   153,   155,   154,   157,   158,   160,
     &    161,   160,   159,   160,   161,   164,   161,   160,
     &    160,   161,   162,   159,   158,   157,   156,   155,
     &    155,   154,   154,   156,   155,   150,   149,   145,
     &    143,   145,   143,   144,   146,   147,   147,   145,
     &    143,   149,   147,   148,   149,   149,   149,   150,
     &    152,   151,   154,   157,   162,   159,   157,   154,
     &    150,   152,   150,   143,   141,   139,   136,   136,
     &    133,   132,   131,   127,   125,   126,   126,   130,
     &    131,   127,   128,   130,   135,   137,   135,   131,
     &    134,   136,   138,   138,   140,   145,   145,   145,
     &    144,   144,   151,   159,   164,   167,   172,   176,
     &    179,   183,   191,   191,   194,   199,   199,   199,
     &    200,   201,   203,   201,   201,   202,   202,   204,
     &    204,   205,   204,   201,   203,   205,   205,   207,
     &    207,   203,   202,   203,   208,   207,   208,   211,
     &    217,   224,   227,   229,   230,   229,   232,   236,
     &    234,   236,   235,   237,   242,   241,   245,   247,
     &    247,   244,   243,   246,   249,   248,   253,   256,
     &    254,   254,   256,   260,   265,   266,   265,   264,
     &    258,   259,   254,   256,   257,   261,   262,   260,
     &    262,   259,   261,   262,   261,   261,   267,   269,
     &    274,   275,   273,   278,   278,   284,   288,   291,
     &    292,   292,   293,   288,   288,   286,   287,   285,
     &    282,   282,   279,   278,   274,   269,   271,   271,
     &    269,   263,   263,   264,   262,   260,   260,   257,
     &    258,   253,   249,   249,   251,   249,   249,   249,
     &    247,   250,   250,   251,   255,   253,   252,   252,
     &    248,   250,   251,   252,   251,   251,   247,   253,
     &    253,   249,   253,   259,   259,   264,   265,   266,
     &    268,   266,   261,   263,   263,   266,   263,   262,
     &    257,   261,   259,   257,   255,   253,   255,   249,
     &    250,   249,   246,   240,   242,   238,   238,   237,
     &    240,   245,   243,   249,   252,   252,   255,   257,
     &    256,   261,   262,   258,   256,   257,   257,   255,
     &    255,   253,   252,   250,   247,   247,   250,   246,
     &    244,   240,   235,   232,   231,   232,   229,   228,
     &    228,   229,   228,   229,   227,   224,   225,   171,
     &    170,   166,   167,   164,   161,   163,   164,   158,
     &    159,   157,   156,   156,   158,   160,   164,   164,
     &    166,   164,   161,   162,   160,   154,   152,   152,
     &    148,   149,   152,   152,   151,   149,   147,   144,
     &    142,   141,   138,   136,   135,   135,   134,   135,
     &    128,   128,   127,   125,   124,   127,   128,   126,
     &    128,   128,   125,   122,   118,   122,   127,   125,
     &    123,   127,   125,   127,   129,   129,   133,   131,
     &    134,   129,   130,   131,   134,   134,   138,   138,
     &    140,   137,   138,   143,   145,   141,   145,   147,
     &    150,   153,   149,   150,   156,   158,   161,   163,
     &    164,   167,   169,   174,   178,   182,   186,   187,
     &    188,   189,   190,   194,   193,   193,   190,   185,
     &    182,   185,   182,   182,   186,   188,   187,   184,
     &    184,   182,   184,   184,   182,   183,   184,   187,
     &    189,   189,   186,   188,   189,   187,   184,   187,
     &    184,   181,   180,   182,   181,   178,   178,   177,
     &    176,   170,   172,   175,   170,   164,   160,   159,
     &    157,   157,   156,   156,   158,   159,   160,   167,
     &    168,   163,   165,   164,   163,   163,   166,   162,
     &    161,   161,   164,   161,   159,   160,   157,   156,
     &    155,   154,   154,   155,   153,   150,   149,   144,
     &    142,   142,   141,   143,   143,   147,   145,   143,
     &    143,   142,   144,   145,   140,   139,   137,   140,
     &    140,   140,   141,   140,   137,   135,   133,   130,
     &    133,   137,   137,   138,   136,   138,   140,   142,
     &    142,   140,   140,   139,   135,   134,   131,   133,
     &    133,   137,   141,   139,   138,   139,   138,   136,
     &    138,   136,   134,   133,   134,   138,   139,   138,
     &    141,   139,   136,   138,   139,   141,   142,   140,
     &    145,   143,   142,   141,   143,   143,   144,   141,
     &    143,   146,   143,   144,   144,   143,   142,   144,
     &    140,   138,   140,   140,   140,   138,   137,   132,
     &    134,   131,   129,   130,   132,   131,   133,   132,
     &    129,   124,   123,   121,   120,   121,   118,   118,
     &    118,   118,   117,   110,   108,   107,   106,   104,
     &    102,   103,   103,   103,   102,   100,   101,    99,
     &    100,    97,    94,    94,    92,    89,    88,    88,
     &     90,    89,    89,    88,    91,    89,    87,    83,
     &     80,    81,    79,    81,    81,    83,    84,    86,
     &     83,    83,    88,    85,    83,    86,    88,    87,
     &     89,    96,    96,   101,   102,   102,   103,   101,
     &    103,   106,   107,   112,   114,   118,   118,   120,
     &    124,   125,   125,   126,   130,   130,   132,   131,
     &    135,   134,   132,   133,   135,   135,   134,   132,
     &    131,   133,   134,   135,   137,   140,   141,   141,
     &    143,   145,   145,   150,   153,   150,   149,   150,
     &    154,   155,   156,   159,   158,   161,   162,   163,
     &    166,   170,   176,   178,   182,   186,   189,   199,
     &    198,   199,   205,   209,   213,   212,   212,   214,
     &    213,   211,   213,   216,   219,   219,   218,   221/
      Data (writetable(i),i=   31201,   32000)/
     &    221,   221,   226,   224,   225,   223,   222,   222,
     &    226,   226,   226,   226,   225,   226,   226,   225,
     &    227,   229,   226,   226,   230,   228,   226,   230,
     &    235,   232,   236,   242,   244,   241,   246,   249,
     &    247,   246,   246,   249,   245,   250,   250,   253,
     &    257,   254,   255,   254,   255,   258,   256,   256,
     &    257,   256,   252,   253,   252,   252,   251,   252,
     &    252,   256,   257,   254,   252,   250,   250,   252,
     &    252,   250,   252,   249,   249,   249,   250,   252,
     &    253,   251,   252,   251,   245,   245,   240,   238,
     &    236,   239,   239,   233,   233,   234,   231,   230,
     &    230,   226,   228,   234,   231,   225,   217,   217,
     &    218,   217,   215,   211,   212,   211,   208,   214,
     &    209,   207,   203,   201,   197,   202,   204,   206,
     &    208,   206,   205,   210,   214,   210,   213,   216,
     &    227,   229,   226,   228,   226,   228,   231,   235,
     &    235,   239,   242,   247,   254,   259,   265,   276,
     &    280,   287,   287,   289,   295,   294,   296,   300,
     &    305,   301,   301,   302,   302,   300,   306,   305,
     &    305,   302,   303,   302,   301,   304,   307,   306,
     &    311,   308,   306,   308,   313,   314,   316,   326,
     &    326,   328,   332,   338,   336,   337,   340,   338,
     &    342,   345,   346,   351,   356,   359,   359,   360,
     &    363,   366,   371,   370,   375,   376,   378,   382,
     &    382,   381,   382,   383,   388,   395,   402,   408,
     &    410,   409,   413,   420,   423,   424,   427,   432,
     &    444,   443,   445,   441,   443,   444,   441,   452,
     &    451,   452,   454,   454,   450,   451,   456,   459,
     &    463,   461,   456,   456,   458,   454,   458,   461,
     &    456,   452,   447,   442,   438,   435,   428,   424,
     &    414,   410,   409,   407,   405,   403,   407,   407,
     &    409,   403,   401,   403,   406,   410,   406,   404,
     &    403,   398,   400,   395,   385,   381,   381,   379,
     &    373,   371,   375,   370,   362,   361,   353,   358,
     &    351,   354,   357,   355,   356,   353,   357,   357,
     &    357,   353,   354,   352,   350,   353,   359,   366,
     &    367,   374,   373,   371,   375,   380,   377,   376,
     &    378,   377,   365,   364,   364,   362,   364,   364,
     &    362,   360,   356,   354,   347,   342,   342,   342,
     &    343,   340,   338,   339,   336,   331,   330,   330,
     &    324,   322,   320,   324,   320,   320,   324,   322,
     &    323,   316,   308,   309,   306,   301,   304,   300,
     &    295,   291,   291,   295,   294,   292,  1240,  1227,
     &   1229,  1240,  1251,  1254,  1237,  1231,  1233,  1232,
     &   1216,  1215,  1213,  1212,  1213,  1205,  1194,  1195,
     &   1192,  1195,  1190,  1198,  1201,  1207,  1208,  1215,
     &   1212,  1218,  1209,  1202,  1212,  1214,  1219,  1209,
     &   1215,  1217,  1225,  1228,  1233,  1228,  1242,  1260,
     &   1257,  1263,  1264,  1282,  1307,  1320,  1338,  1354,
     &   1348,  1354,  1353,  1353,  1365,  1370,  1376,  1399,
     &   1412,  1420,  1430,  1454,  1471,  1485,  1506,  1513,
     &   1540,  1536,  1529,  1548,  1556,  1572,  1587,  1602,
     &   1618,  1632,  1637,  1656,  1670,  1694,  1729,  1747,
     &   1744,  1751,  1759,  1774,  1802,  1827,  1826,  1846,
     &   1853,  1881,  1887,  1918,  1929,  1951,  1972,  1998,
     &   2021,  2054,  2075,  2061,  2060,  2053,  2055,  2058,
     &   2059,  2053,  2048,  2035,  2034,  2018,  2021,  2024,
     &   2027,  2007,  2014,  2010,  2005,  2000,  1991,  1989,
     &   1997,  2008,  2008,  2016,  2012,  2012,  2017,  2020,
     &   2021,  2030,  2045,  2061,  2052,  2047,  2049,  2057,
     &   2058,  2051,  2057,  2040,  2043,  2051,  2067,  2065,
     &   2065,  2064,  2062,  2068,  2077,  2070,  2080,  2074,
     &   2078,  2082,  2088,  2092,  2103,  2095,  2102,  2097,
     &   2097,  2094,  2086,  2091,  2115,  2118,  2127,  2139,
     &   2142,  2148,  2146,  2154,  2146,  2142,  2151,  2154,
     &   2152,  2150,  2175,  2175,  2194,  2200,  2214,  2224,
     &   2231,  2248,  2265,  2270,  2295,  2296,  2315,  2321,
     &   2334,  2338,  2350,  2368,  2386,  2401,  2420,  2424,
     &   2423,  2433,  2439,  2447,  2463,  2473,  2464,  2473,
     &   2489,  2501,  2514,  2518,  2535,  2556,  2575,  2589,
     &   2612,  2643,  2645,  2688,  2705,  2726,  2743,  2760,
     &   2771,  2811,  2815,  2851,  2861,  2886,  2903,  2919,
     &   2955,  2973,  3014,  3013,  3027,  3046,  3050,  3045,
     &   3072,  3103,  3123,  3142,  3166,  3177,  3189,  3200,
     &   3221,  3200,  3176,  3172,  3160,  3165,  3147,  3132,
     &   3119,  3117,  3120,  3114,  3117,  3094,  3086,  3079,
     &   3091,  3066,  3041,  3043,  3020,  3026,  3007,  3004,
     &   3000,  2985,  2974,  2951,  2938,  2902,  2902,  2884,
     &   2892,  2889,  2875,  2864,  2831,  2820,  2831,  2819,
     &   2802,  2783,  2793,  2801,  2794,  2788,  2782,  2780,
     &   2779,  2777,  2789,  2800,  2819,  2824,  2825,  2860,
     &   2845,  2849,  2867,  2877,  2907,  2926,  2944,  2931,
     &   2934,  2932,  2942,  2974,  2991,  3011,  3016,  3027,
     &   3046,  3059,  3054,  3062,  3085,  3088,  3100,  3094,
     &   3115,  3129,  3139,  3165,  3194,  3221,  3242,  3258,
     &   3286,  3315,  3346,  3378,  3424,  3481,  3500,  3540,
     &   3576,  3601,  3656,  3694,  3709,  3762,  3797,  3826,
     &   3855,  3891,  3930,  3972,  4008,  4048,  4072,  4125,
     &   4169,  4203,  4242,  4277,  4327,  4374,  4441,  4513,
     &   4567,  4646,  4715,  4786,  4870,  4968,  5026,  5079,
     &   5168,  5256,  5342,  5413,  5490,  5571,  5630,  5708,
     &   5782,  5839,  5911,  5988,  6095,  6141,  6178,  6245,
     &   6282,  6357,  6394,  6431,  6463,  6474,  6488,  6464,
     &   6479,  6457,  6425,  6397,  6364,  6318,  6284,  6258,
     &   6208,  6177,  6109,  6029,  5974,  5953,  5896,  5841,
     &   5794,  5763,  5743,  5681,  5643,  5604,  5559,  5522,
     &   5486,  5450,  5434,  5403,  5361,  5320,  5300,  5268,
     &   5233,  5185,  5163,  5112,  5099,  5062,  5043,  5044,
     &   5032,  5012,  5003,  4971,  4949,  4908,  4880,  4877,
     &   4855,  4859,  4856,  4834,  4814,  4797,  4782,  4779/
      Data (writetable(i),i=   32001,   32800)/
     &   4769,  4757,  4735,  4734,  4715,  4702,  4686,  4677,
     &   4653,  4643,  4618,  4605,  4592,  4553,  4522,  4498,
     &   4476,  4450,  4411,  4389,  4370,  4322,  4285,  4250,
     &   4206,  4175,  4160,  4113,  4081,  4055,  4019,  3976,
     &   3948,  3931,  3910,  3893,  3862,  3847,  3837,  3841,
     &   3833,  3815,  3813,  3781,  3731,  3694,  3638,  3587,
     &   3554,  3513,  3503,  3466,  3444,  3415,  3430,  3414,
     &   3388,  3363,  3338,  3312,  3280,  3253,  3243,  3228,
     &   3213,  3201,  3186,  3162,  3151,  3152,  3138,  3135,
     &   3127,  3136,  3139,  3143,  3146,  3152,  3161,  3170,
     &   3149,  3145,  3143,  3148,  3148,  3152,  3146,  3153,
     &   3148,  3153,  3161,  3179,  3181,  3148,  3127,  3112,
     &   3099,  3071,  3045,  3036,  3020,  3025,  3017,  3003,
     &   2985,  2968,  2950,  2936,  2924,  2918,  2913,  2891,
     &   2890,  2886,  2880,  2838,  2831,  2830,  2824,  2825,
     &   2808,  2797,  2804,  2791,  2798,  2801,  2786,  2784,
     &   2794,  2800,  2795,  2800,  2798,  2784,  2786,  2781,
     &   2769,  2774,  2762,  2762,  2750,  2724,  2718,  2711,
     &   2709,  2703,  2697,  2694,  2716,  2719,  2724,  2719,
     &   2720,  2721,  2725,  2719,  2724,  2725,  2736,  2727,
     &   2726,  2719,  2723,  2723,  2720,  2742,  2749,  2753,
     &   2753,  2762,  2759,  2745,  2744,  2736,  2742,  2747,
     &   2742,  2744,  2737,  2724,  2726,  2738,  2741,  2743,
     &   2741,  2754,  2758,  2769,  2781,  2776,  2768,  2754,
     &   2766,  2745,  2704,  2670,  2658,  2623,  2604,  2589,
     &   2581,  2564,  2551,  2526,  2521,  2506,  2488,  2480,
     &   2497,  2484,  2488,  2476,  2452,  2446,  2443,  2443,
     &   2448,  2452,  2454,  2472,  2466,  2463,  2468,  2476,
     &   2479,  2474,  2464,  2485,  2483,  2483,  2480,  2481,
     &   2491,  2491,  2480,  2475,  2489,  2502,  2504,  2511,
     &   2519,  2515,  2524,  2515,  2517,  2507,  2505,  2496,
     &   2472,  2462,  2462,  2452,  2445,  2437,  2420,  2430,
     &   2426,  2416,  2415,  2402,  2391,  2389,  2379,  2376,
     &   2360,  2348,  2338,  2327,  2328,  2316,  2316,  2314,
     &   2299,  2288,  2274,  2269,  2266,  2263,  2252,  2257,
     &   2265,  2262,  2260,  2255,  2248,  2252,  2273,  2283,
     &   2292,  2302,  2326,  2344,  2355,   254,   253,   253,
     &    253,   252,   250,   253,   251,   242,   241,   238,
     &    232,   232,   231,   239,   235,   238,   239,   237,
     &    229,   229,   227,   223,   222,   219,   220,   215,
     &    213,   212,   212,   209,   210,   215,   215,   218,
     &    215,   216,   216,   221,   216,   218,   217,   214,
     &    213,   212,   217,   221,   221,   223,   226,   228,
     &    235,   236,   233,   238,   240,   243,   247,   245,
     &    244,   251,   253,   256,   259,   262,   264,   268,
     &    273,   277,   273,   280,   285,   288,   288,   292,
     &    290,   290,   288,   289,   282,   290,   294,   299,
     &    302,   301,   302,   305,   298,   303,   301,   305,
     &    300,   303,   302,   300,   297,   301,   304,   306,
     &    306,   304,   307,   304,   297,   291,   289,   288,
     &    286,   281,   279,   277,   276,   275,   275,   276,
     &    273,   275,   282,   282,   282,   275,   278,   279,
     &    278,   274,   270,   268,   272,   267,   262,   261,
     &    263,   263,   260,   251,   249,   246,   245,   244,
     &    240,   240,   238,   243,   241,   246,   245,   242,
     &    245,   247,   247,   242,   246,   244,   247,   245,
     &    246,   244,   241,   243,   244,   243,   245,   253,
     &    255,   255,   263,   265,   266,   275,   272,   269,
     &    267,   273,   274,   272,   272,   276,   279,   278,
     &    281,   286,   290,   290,   293,   294,   290,   295,
     &    299,   301,   301,   303,   301,   298,   304,   305,
     &    304,   305,   305,   306,   308,   311,   314,   312,
     &    310,   307,   311,   318,   307,   310,   312,   312,
     &    315,   315,   319,   317,   319,   321,   321,   320,
     &    317,   319,   325,   326,   331,   334,   339,   338,
     &    335,   331,   338,   339,   343,   336,   336,   336,
     &    337,   338,   343,   344,   337,   341,   343,   345,
     &    351,   352,   349,   351,   353,   357,   349,   348,
     &    344,   344,   342,   345,   342,   336,   336,   328,
     &    324,   322,   320,   317,   317,   312,   313,   309,
     &    303,   296,   296,   295,   295,   296,   295,   286,
     &    285,   283,   278,   278,   274,   279,   279,   275,
     &    271,   270,   269,   270,   275,   271,   274,   274,
     &    274,   274,   265,   263,   260,   260,   262,   263,
     &    261,   259,   261,   262,   264,   263,   264,   260,
     &    257,   259,   262,   268,   264,   265,   262,   266,
     &    265,   266,   267,   274,   273,   276,   277,   272,
     &    275,   278,   276,   283,   287,   291,   296,   299,
     &    300,   301,   303,   301,   302,   302,   310,   311,
     &    310,   309,   312,   319,   325,   325,   331,   336,
     &    335,   334,   333,   336,   340,   341,   342,   342,
     &    347,   344,   348,   347,   348,   351,   353,   361,
     &    364,   372,   380,   382,   380,   387,   387,   390,
     &    402,   408,   417,   423,   431,   437,   438,   455,
     &    453,   455,   467,   475,   485,   504,   518,   531,
     &    545,   552,   564,   574,   588,   600,   606,   614,
     &    623,   637,   650,   647,   657,   667,   672,   683,
     &    690,   699,   710,   711,   716,   727,   734,   738,
     &    741,   742,   752,   761,   767,   776,   783,   795,
     &    804,   819,   827,   845,   853,   864,   877,   893,
     &    923,   940,   946,   961,   985,   995,   999,  1015,
     &   1015,  1038,  1052,  1060,  1068,  1077,  1101,  1114,
     &   1135,  1141,  1168,  1185,  1198,  1203,  1217,  1244,
     &   1264,  1281,  1300,  1319,  1339,  1352,  1378,  1411,
     &   1434,  1449,  1476,  1498,  1521,  1541,  1566,  1586,
     &   1606,  1634,  1645,  1661,  1679,  1695,  1703,  1714,
     &   1732,  1740,  1768,  1783,  1808,  1825,  1841,  1861,
     &   1887,  1909,  1925,  1958,  1981,  2003,  2015,  2043,
     &   2062,  2094,  2101,  2122,  2135,  2170,  2200,  2245,
     &   2259,  2297,  2298,  2292,  2296,  2293,  2295,  2297/
      Data (writetable(i),i=   32801,   33600)/
     &   2307,  2309,  2304,  2302,  2295,  2292,  2290,  2296,
     &   2308,  2320,  2316,  2293,  2295,  2296,  2284,  2267,
     &   2260,  2249,  2249,  2235,  2226,  2218,  2205,  2204,
     &   2203,  2191,  2179,  2146,  2116,  2093,  2076,  2072,
     &   2044,  2023,  2000,  1975,  1950,  1926,  1915,  1895,
     &   1873,  1854,  1816,  1799,  1787,  1766,  1754,  1740,
     &   1714,  1705,  1689,  1670,  1650,  1647,  1634,  1619,
     &   1598,  1590,  1573,  1557,  1545,  1531,  1519,  1510,
     &   1490,  1473,  1458,  1451,  1436,  1413,  1404,  1394,
     &   1378,  1369,  1357,  1342,  1323,  1309,  1303,  1291,
     &   1273,  1259,  1247,  1232,  1215,  1202,  1189,  1174,
     &   1161,  1153,  1141,  1128,  1114,  1104,  1092,  1092,
     &   1082,  1068,  1060,  1047,  1044,  1043,  1035,  1015,
     &   1011,   996,   992,   988,   982,   979,   976,   974,
     &    979,   973,   960,   952,   958,   948,   939,   933,
     &    930,   907,   899,   894,   889,   882,   872,   864,
     &    847,   842,   833,   829,   827,   826,   818,   815,
     &    806,   802,   802,   797,   786,   787,   781,   775,
     &    764,   757,   747,   734,   733,   726,   721,   713,
     &    707,   700,   703,   693,   691,   688,   684,   672,
     &    664,   664,   656,   652,   655,   653,   657,   660,
     &    648,   644,   640,   638,   634,   633,   631,   620,
     &    612,   602,   609,   606,   608,   608,   602,   595,
     &    592,   594,   593,   590,   584,   588,   588,   588,
     &    593,   596,   593,   587,   578,   585,   584,   583,
     &    583,   585,   582,   585,   581,   579,   586,   578,
     &    584,   587,   589,   588,   586,   583,   582,   581,
     &    581,   585,   589,   590,   591,   590,   589,   583,
     &    578,   582,   581,   573,   569,   566,   560,   553,
     &    555,   551,   550,   547,   544,   544,   545,   542,
     &    535,   530,   530,   529,    25,    25,    25,    25,
     &     26,    26,    26,    28,    27,    27,    28,    28,
     &     28,    28,    28,    26,    26,    25,    26,    27,
     &     27,    27,    27,    26,    26,    26,    26,    27,
     &     28,    26,    26,    25,    25,    23,    22,    21,
     &     18,    17,    17,    16,    15,    15,    15,    15,
     &     16,    16,    16,    16,    16,    14,    13,    13,
     &     14,    15,    15,    15,    15,    15,    17,    19,
     &     19,    19,    19,    19,    19,    21,    22,    22,
     &     22,    22,    22,    22,    22,    23,    23,    23,
     &     23,    22,    24,    25,    25,    26,    27,    27,
     &     26,    26,    26,    26,    26,    25,    25,    25,
     &     25,    26,    26,    27,    27,    27,    28,    29,
     &     30,    29,    28,    27,    27,    27,    27,    26,
     &     25,    25,    24,    24,    24,    24,    25,    25,
     &     25,    26,    26,    25,    26,    26,    26,    26,
     &     24,    25,    26,    26,    26,    22,    23,    25,
     &     24,    23,    23,    24,    25,    27,    26,    25,
     &     26,    26,    27,    26,    25,    25,    25,    24,
     &     24,    24,    24,    25,    25,    24,    25,    24,
     &     25,    26,    23,    23,    24,    24,    24,    24,
     &     24,    25,    25,    26,    26,    25,    23,    23,
     &     23,    23,    24,    23,    22,    21,    21,    21,
     &     24,    25,    24,    25,    25,    25,    24,    25,
     &     24,    24,    24,    24,    26,    26,    26,    26,
     &     26,    25,    25,    25,    24,    22,    22,    22,
     &     22,    22,    22,    20,    21,    21,    21,    21,
     &     23,    23,    23,    24,    25,    25,    25,    25,
     &     26,    27,    27,    27,    27,    25,    25,    24,
     &     25,    24,    24,    25,    25,    24,    23,    23,
     &     21,    22,    21,    21,    19,    20,    19,    21,
     &     20,    21,    20,    21,    21,    20,    20,    20,
     &     20,    18,    18,    18,    18,    19,    18,    19,
     &     19,    18,    18,    17,    17,    16,    16,    16,
     &     16,    16,    15,    15,    15,    15,    15,    15,
     &     15,    15,    15,    15,    14,    14,    14,    14,
     &     15,    15,    16,    16,    16,    16,    17,    18,
     &     18,    17,    17,    17,    17,    17,    17,    18,
     &     18,    17,    16,    16,    16,    17,    17,    16,
     &     15,    15,    17,    17,    18,    17,    17,    17,
     &     17,    17,    17,    17,    16,    15,    16,    16,
     &     16,    15,    15,    15,    16,    16,    15,    14,
     &     13,    13,    13,    15,    15,    16,    16,    16,
     &     16,    17,    17,    17,    17,    17,    17,    18,
     &     19,    19,    21,    21,    22,    23,    22,    21,
     &     20,    20,    21,    21,    22,    22,    22,    23,
     &     24,    24,    25,    26,    27,    27,    26,    25,
     &     25,    26,    26,    27,    28,    28,    29,    29,
     &     29,    30,    30,    31,    30,    32,    31,    33,
     &     33,    33,    34,    34,    33,    33,    33,    33,
     &     34,    35,    35,    34,    35,    33,    35,    36,
     &     38,    37,    36,    36,    36,    34,    32,    32,
     &     32,    30,    30,    30,    29,    29,    28,    28,
     &     28,    28,    27,    28,    28,    29,    30,    30,
     &     30,    30,    32,    33,    33,    34,    34,    34,
     &     33,    33,    33,    35,    34,    35,    36,    35,
     &     36,    35,    35,    36,    37,    37,    37,    36,
     &     37,    37,    36,    36,    37,    38,    38,    39,
     &     37,    37,    38,    38,    39,    41,    40,    40,
     &     40,    40,    40,    40,    41,    41,    42,    42,
     &     42,    43,    44,    44,    44,    45,    45,    45,
     &     45,    45,    45,    45,    46,    43,    44,    45,
     &     47,    49,    48,    49,    48,    49,    53,    51,
     &     52,    53,    51,    51,    50,    50,    49,    48,
     &     49,    47,    46,    44,    45,    44,    43,    44,
     &     44,    45,    45,    45,    47,    48,    47,    46,
     &     42,    45,    46,    48,    46,    47,    46,    46,
     &     47,    48,    49,    47,    47,    48,    52,    55,
     &     56,    57,    57,    55,    55,    57,    58,    58,
     &     59,    57,    59,    57,    57,    56,    55,    53/
      Data (writetable(i),i=   33601,   34400)/
     &     54,    55,    55,    56,    55,    54,    52,    52,
     &     53,    53,    53,    54,    53,    54,    54,    55,
     &     57,    56,    56,    56,    57,    58,    59,    59,
     &     57,    59,    59,    61,    63,    62,    62,    63,
     &     62,    63,    62,    62,    63,    63,    67,    67,
     &     67,    67,    66,    67,    68,    69,    71,    72,
     &     72,    71,    74,    74,    74,    75,    76,    76,
     &     74,    73,    73,    74,    76,    76,    77,    76,
     &     79,    77,    77,    74,    73,    72,    72,    70,
     &     71,    70,    69,    69,    72,    72,    73,    72,
     &     72,    73,    75,    73,    70,    71,    70,    70,
     &     70,    69,    69,    68,    69,    68,    67,    66,
     &     70,    70,    71,    73,    74,    74,    74,    76,
     &     76,    77,    75,    73,    74,    72,    72,    72,
     &     72,    70,    69,    66,    65,    63,    65,    69,
     &     68,    67,    66,    67,    68,    67,    65,    66,
     &     65,    64,    62,    61,    64,    65,    66,    68,
     &     69,    69,    69,    69,    69,    68,    71,    70,
     &     72,    70,    71,    72,    70,    70,    70,    70,
     &     72,    72,    71,    68,    67,    67,    69,    70,
     &     71,    69,    70,    69,    70,    69,    72,    73,
     &     73,    74,    73,    73,    72,    72,    73,    73,
     &     70,    70,    70,    69,    69,    70,    68,    68,
     &     69,    68,    68,    70,    70,    71,    70,    70,
     &     70,    71,    73,    41,    42,    42,    42,    38,
     &     38,    39,    36,    35,    35,    37,    38,    38,
     &     38,    39,    41,    40,    40,    38,    38,    39,
     &     37,    37,    38,    37,    36,    36,    36,    35,
     &     37,    35,    35,    35,    37,    36,    37,    36,
     &     37,    35,    36,    36,    36,    36,    39,    39,
     &     40,    39,    38,    36,    36,    37,    38,    38,
     &     36,    35,    36,    34,    34,    32,    30,    31,
     &     32,    32,    33,    34,    35,    37,    38,    39,
     &     39,    38,    39,    39,    40,    43,    44,    45,
     &     46,    45,    44,    44,    44,    45,    44,    43,
     &     44,    47,    47,    48,    49,    47,    48,    48,
     &     48,    49,    51,    51,    51,    51,    51,    53,
     &     55,    55,    55,    53,    53,    51,    52,    54,
     &     54,    53,    52,    50,    49,    47,    47,    46,
     &     44,    44,    42,    41,    41,    39,    38,    38,
     &     35,    35,    35,    38,    40,    41,    42,    43,
     &     42,    42,    42,    43,    42,    45,    45,    44,
     &     43,    43,    43,    43,    43,    44,    42,    42,
     &     42,    41,    40,    39,    39,    38,    38,    37,
     &     38,    38,    35,    31,    31,    31,    33,    34,
     &     34,    32,    31,    33,    34,    34,    35,    35,
     &     34,    34,    34,    35,    37,    37,    38,    37,
     &     35,    34,    33,    32,    33,    31,    30,    29,
     &     29,    28,    29,    29,    30,    30,    31,    31,
     &     30,    30,    31,    31,    31,    30,    30,    30,
     &     30,    31,    32,    31,    32,    32,    31,    31,
     &     32,    32,    31,    31,    32,    34,    33,    34,
     &     32,    32,    31,    31,    31,    31,    29,    27,
     &     28,    28,    29,    30,    31,    31,    31,    30,
     &     30,    28,    29,    27,    27,    27,    26,    26,
     &     23,    24,    25,    27,    27,    27,    27,    26,
     &     25,    25,    26,    28,    29,    29,    30,    30,
     &     29,    28,    28,    28,    28,    26,    26,    25,
     &     25,    25,    25,    25,    25,    25,    25,    23,
     &     23,    23,    24,    24,    24,    24,    23,    23,
     &     24,    23,    24,    24,    24,    24,    23,    22,
     &     22,    23,    23,    23,    23,    23,    22,    22,
     &     20,    20,    22,    23,    25,    26,    25,    25,
     &     25,    25,    25,    24,    23,    23,    23,    25,
     &     26,    26,    27,    27,    27,    28,    28,    28,
     &     29,    29,    28,    30,    32,    32,    33,    33,
     &     34,    32,    33,    33,    33,    36,    35,    35,
     &     35,    33,    32,    31,    31,    32,    32,    32,
     &     32,    33,    32,    31,    31,    32,    32,    32,
     &     32,    32,    32,    30,    32,    31,    33,    34,
     &     34,    35,    36,    36,    35,    36,    36,    35,
     &     35,    35,    33,    33,    33,    33,    34,    35,
     &     34,    34,    35,    36,    36,    37,    39,    38,
     &     38,    38,    41,    42,    43,    44,    44,    44,
     &     45,    43,    43,    43,    44,    43,    43,    44,
     &     44,    44,    43,    42,    43,    46,    45,    45,
     &     46,    46,    47,    46,    46,    47,    47,    46,
     &     46,    47,    44,    43,    44,    44,    44,    45,
     &     47,    51,    52,    53,    53,    55,    55,    55,
     &     55,    58,    59,    61,    61,    64,    64,    63,
     &     64,    64,    64,    65,    66,    67,    69,    70,
     &     69,    70,    67,    68,    71,    71,    70,    69,
     &     69,    71,    71,    72,    72,    72,    72,    74,
     &     77,    77,    76,    74,    74,    73,    74,    73,
     &     72,    71,    72,    71,    70,    70,    70,    70,
     &     71,    71,    72,    73,    71,    71,    70,    70,
     &     70,    66,    67,    66,    68,    70,    70,    70,
     &     68,    67,    66,    67,    67,    64,    64,    64,
     &     63,    61,    61,    61,    60,    60,    58,    56,
     &     57,    57,    56,    57,    57,    58,    59,    58,
     &     56,    55,    56,    54,    55,    53,    53,    54,
     &     56,    58,    61,    62,    64,    64,    65,    65,
     &     65,    63,    62,    65,    64,    66,    71,    71,
     &     75,    75,    75,    77,    77,    77,    74,    74,
     &     74,    75,    74,    74,    73,    72,    73,    72,
     &     74,    75,    74,    75,    77,    79,    79,    77,
     &     75,    76,    77,    79,    81,    80,    82,    82,
     &     82,    82,    83,    87,    88,    88,    89,    89,
     &     88,    89,    88,    90,    93,    94,    95,    94,
     &     95,    99,   101,   101,    99,   100,   100,   100/
      Data (writetable(i),i=   34401,   35200)/
     &    102,   102,   101,   102,   103,   104,   104,   105,
     &    104,    98,    99,    98,    98,    96,    99,    98,
     &    101,   100,   104,   108,   108,   108,   110,   112,
     &    112,   114,   114,   114,   114,   113,   113,   113,
     &    111,   111,   113,   114,   116,   117,   117,   117,
     &    117,   115,   116,   113,   111,   111,   112,   111,
     &    111,   113,   112,   111,   109,   108,   109,   108,
     &    107,   105,   103,   104,   102,    99,    97,    98,
     &     96,    97,    95,    95,    98,    98,   100,   100,
     &    101,   100,   101,   100,   103,   104,   105,   104,
     &    105,   104,   104,   102,   104,   103,   103,   104,
     &    105,   107,   110,   112,   116,   116,   116,   119,
     &    119,   117,   121,   121,   121,   122,   124,   123,
     &    121,   122,   125,   124,   123,   123,   123,   124,
     &    123,   124,   126,   126,   127,   128,   128,   126,
     &    125,   123,   124,   125,   127,   127,   128,   129,
     &    128,   128,   128,   126,   126,   126,   124,   128,
     &    130,   126,   125,   127,   123,   123,   123,   120,
     &    119,   119,    27,    29,    29,    29,    30,    29,
     &     28,    29,    30,    31,    32,    32,    31,    31,
     &     32,    33,    33,    33,    33,    32,    32,    32,
     &     32,    32,    32,    32,    33,    33,    33,    33,
     &     32,    30,    30,    31,    31,    31,    30,    30,
     &     30,    30,    30,    31,    30,    30,    30,    30,
     &     30,    30,    30,    32,    31,    32,    31,    31,
     &     30,    30,    29,    31,    31,    32,    33,    33,
     &     33,    33,    34,    33,    33,    32,    31,    29,
     &     29,    29,    29,    29,    29,    32,    33,    32,
     &     33,    33,    33,    32,    30,    32,    31,    32,
     &     32,    32,    31,    30,    30,    29,    29,    30,
     &     30,    29,    27,    26,    28,    30,    28,    27,
     &     27,    28,    29,    31,    30,    29,    31,    29,
     &     27,    28,    28,    29,    29,    29,    29,    28,
     &     28,    28,    27,    27,    27,    27,    27,    26,
     &     27,    27,    25,    26,    26,    26,    27,    27,
     &     27,    27,    29,    29,    29,    29,    27,    27,
     &     27,    27,    25,    22,    22,    24,    24,    24,
     &     25,    26,    26,    27,    27,    28,    28,    27,
     &     26,    26,    25,    25,    24,    24,    23,    21,
     &     21,    21,    21,    22,    23,    23,    22,    22,
     &     22,    21,    20,    20,    20,    21,    21,    20,
     &     21,    21,    21,    20,    20,    19,    21,    20,
     &     18,    18,    18,    18,    18,    18,    19,    19,
     &     19,    20,    20,    20,    21,    20,    20,    20,
     &     20,    21,    21,    20,    20,    20,    20,    20,
     &     20,    18,    19,    19,    19,    20,    21,    21,
     &     20,    20,    20,    20,    20,    21,    21,    23,
     &     24,    24,    22,    22,    22,    21,    21,    20,
     &     19,    20,    20,    20,    19,    20,    20,    20,
     &     19,    19,    19,    19,    18,    18,    17,    17,
     &     17,    16,    16,    16,    17,    14,    13,    15,
     &     14,    13,    13,    12,    11,    11,    12,    13,
     &     13,    13,    13,    13,    13,    13,    14,    14,
     &     15,    15,    15,    16,    16,    18,    16,    16,
     &     15,    15,    15,    15,    15,    15,    14,    13,
     &     12,    12,    12,    12,    12,    12,    13,    15,
     &     15,    15,    16,    16,    16,    17,    16,    16,
     &     16,    16,    17,    17,    17,    17,    16,    17,
     &     19,    19,    20,    19,    20,    20,    20,    19,
     &     19,    19,    19,    20,    20,    20,    21,    21,
     &     21,    23,    23,    23,    22,    21,    21,    21,
     &     21,    23,    23,    22,    23,    23,    23,    22,
     &     22,    23,    22,    22,    22,    21,    20,    22,
     &     21,    22,    22,    22,    20,    21,    22,    22,
     &     22,    22,    21,    21,    22,    22,    23,    23,
     &     24,    24,    25,    24,    24,    25,    25,    25,
     &     25,    25,    26,    28,    28,    29,    29,    30,
     &     30,    30,    31,    32,    32,    32,    32,    32,
     &     33,    33,    34,    34,    33,    34,    34,    33,
     &     34,    33,    35,    36,    35,    35,    36,    35,
     &     35,    35,    35,    36,    36,    36,    36,    37,
     &     35,    35,    34,    34,    35,    35,    35,    35,
     &     36,    36,    35,    34,    34,    35,    36,    36,
     &     37,    38,    38,    38,    38,    39,    39,    39,
     &     39,    40,    38,    41,    39,    40,    40,    40,
     &     40,    42,    42,    42,    42,    43,    41,    39,
     &     41,    42,    41,    40,    38,    38,    39,    39,
     &     38,    38,    39,    40,    40,    39,    40,    40,
     &     42,    42,    41,    40,    42,    42,    43,    44,
     &     44,    44,    43,    40,    40,    39,    40,    39,
     &     41,    42,    42,    42,    42,    41,    39,    39,
     &     39,    39,    37,    37,    37,    35,    34,    33,
     &     35,    35,    35,    39,    38,    37,    36,    36,
     &     37,    37,    37,    40,    42,    43,    43,    43,
     &     44,    45,    45,    45,    48,    51,    51,    51,
     &     48,    51,    49,    50,    52,    53,    52,    53,
     &     54,    54,    55,    55,    56,    58,    60,    64,
     &     62,    60,    61,    63,    63,    64,    64,    64,
     &     63,    64,    64,    64,    64,    65,    67,    67,
     &     66,    67,    66,    66,    64,    62,    59,    61,
     &     60,    60,    60,    62,    61,    61,    61,    60,
     &     60,    61,    59,    57,    56,    57,    57,    56,
     &     55,    57,    56,    54,    57,    59,    58,    59,
     &     59,    58,    59,    58,    58,    58,    59,    58,
     &     58,    59,    60,    63,    63,    63,    63,    65,
     &     65,    62,    60,    61,    62,    62,    64,    63,
     &     63,    62,    62,    62,    63,    63,    64,    64,
     &     67,    68,    67,    67,    69,    70,    73,    75,
     &     75,    74,    70,    69,    70,    69,    69,    69,
     &     68,    69,    67,    67,    68,    68,    67,    70/
      Data (writetable(i),i=   35201,   36000)/
     &     69,    69,    71,    72,    72,    69,    68,    70,
     &     68,    68,    68,    69,    67,    68,    68,    70,
     &     68,    71,    68,    66,    62,    63,    65,    66,
     &     67,    71,    70,    70,    71,    71,    73,    74,
     &     77,    76,    76,    75,    75,    74,    74,    75,
     &     72,    74,    74,    75,    75,    77,    75,    75,
     &     78,    78,    79,    81,    81,    83,    86,    85,
     &     86,    87,    88,    88,    89,    89,    89,    88,
     &     87,    88,    89,    90,    92,    91,    90,    90,
     &     90,    91,    90,    90,    88,    89,    89,    88,
     &     89,    90,    89,    90,    88,    86,    84,    83,
     &     84,    84,    83,    80,    78,    79,    77,    77,
     &     78,    33,    33,    34,    33,    34,    33,    33,
     &     33,    34,    32,    31,    32,    31,    30,    31,
     &     32,    34,    34,    35,    33,    33,    32,    32,
     &     32,    32,    31,    31,    31,    31,    30,    28,
     &     29,    28,    28,    27,    27,    26,    26,    26,
     &     26,    26,    26,    26,    29,    29,    28,    28,
     &     26,    24,    24,    24,    26,    26,    25,    25,
     &     26,    27,    27,    27,    26,    26,    26,    26,
     &     24,    24,    26,    25,    25,    24,    24,    24,
     &     24,    24,    25,    26,    26,    26,    27,    28,
     &     28,    28,    29,    27,    27,    28,    30,    29,
     &     29,    27,    27,    26,    28,    28,    28,    29,
     &     29,    30,    29,    30,    30,    29,    29,    29,
     &     29,    28,    25,    24,    25,    25,    27,    30,
     &     31,    31,    31,    32,    30,    30,    29,    30,
     &     29,    29,    29,    29,    29,    28,    29,    28,
     &     28,    28,    28,    29,    27,    27,    27,    27,
     &     28,    28,    27,    28,    28,    27,    27,    28,
     &     27,    27,    26,    25,    26,    25,    25,    25,
     &     26,    26,    27,    27,    28,    27,    26,    26,
     &     26,    27,    27,    28,    27,    27,    25,    24,
     &     23,    23,    23,    23,    23,    23,    23,    23,
     &     24,    23,    23,    23,    23,    23,    23,    23,
     &     23,    23,    23,    23,    21,    20,    19,    17,
     &     16,    18,    18,    17,    16,    16,    16,    17,
     &     18,    18,    17,    16,    16,    16,    16,    16,
     &     16,    17,    17,    17,    18,    18,    19,    19,
     &     19,    20,    19,    19,    18,    18,    19,    20,
     &     20,    20,    20,    19,    19,    19,    19,    19,
     &     20,    19,    20,    18,    20,    19,    20,    20,
     &     20,    21,    21,    21,    21,    21,    21,    21,
     &     21,    22,    22,    22,    22,    21,    21,    20,
     &     20,    20,    20,    19,    19,    19,    21,    21,
     &     20,    19,    17,    17,    16,    17,    17,    17,
     &     17,    14,    16,    15,    15,    15,    15,    15,
     &     15,    15,    15,    16,    16,    16,    15,    16,
     &     16,    15,    15,    16,    17,    17,    17,    15,
     &     15,    15,    15,    15,    13,    12,    11,    11,
     &     11,    11,    12,    12,    14,    14,    14,    13,
     &     13,    13,    13,    13,    13,    13,    12,    13,
     &     13,    13,    15,    15,    16,    17,    18,    18,
     &     18,    18,    18,    18,    17,    18,    19,    20,
     &     21,    20,    20,    20,    20,    20,    19,    19,
     &     22,    23,    23,    25,    25,    25,    25,    24,
     &     24,    23,    23,    23,    23,    23,    24,    25,
     &     24,    25,    25,    25,    24,    24,    23,    23,
     &     24,    23,    23,    24,    24,    22,    22,    22,
     &     22,    23,    23,    23,    24,    25,    26,    26,
     &     26,    27,    27,    27,    27,    27,    25,    25,
     &     25,    25,    26,    27,    26,    26,    27,    27,
     &     26,    26,    27,    26,    26,    28,    28,    28,
     &     27,    28,    28,    28,    26,    25,    25,    26,
     &     26,    27,    27,    27,    27,    28,    28,    28,
     &     29,    29,    28,    28,    29,    28,    29,    28,
     &     30,    31,    31,    31,    32,    32,    33,    31,
     &     31,    31,    31,    32,    34,    33,    35,    34,
     &     33,    34,    36,    35,    36,    36,    36,    35,
     &     35,    36,    36,    37,    39,    39,    40,    42,
     &     42,    43,    43,    42,    43,    43,    45,    45,
     &     44,    44,    43,    42,    39,    40,    42,    42,
     &     45,    44,    44,    44,    44,    42,    43,    43,
     &     43,    43,    43,    42,    41,    42,    41,    43,
     &     42,    41,    41,    40,    39,    39,    38,    38,
     &     39,    38,    37,    37,    37,    35,    35,    35,
     &     35,    38,    38,    38,    38,    39,    39,    38,
     &     38,    38,    38,    38,    36,    38,    38,    38,
     &     40,    41,    41,    40,    41,    41,    42,    42,
     &     41,    40,    41,    41,    41,    41,    41,    43,
     &     42,    42,    40,    39,    39,    41,    41,    39,
     &     39,    39,    38,    38,    37,    36,    35,    36,
     &     34,    34,    34,    36,    37,    37,    39,    42,
     &     44,    44,    45,    46,    46,    46,    47,    47,
     &     46,    45,    44,    43,    43,    44,    45,    45,
     &     46,    49,    48,    49,    47,    47,    49,    49,
     &     48,    48,    49,    49,    49,    51,    50,    50,
     &     50,    50,    49,    50,    53,    53,    53,    54,
     &     54,    54,    54,    54,    55,    56,    56,    56,
     &     56,    55,    55,    56,    54,    56,    57,    59,
     &     58,    58,    58,    58,    58,    59,    57,    58,
     &     60,    60,    61,    61,    61,    61,    63,    63,
     &     63,    63,    62,    63,    62,    62,    62,    61,
     &     63,    64,    64,    62,    62,    60,    58,    61,
     &     62,    62,    64,    66,    68,    67,    66,    68,
     &     69,    68,    70,    68,    69,    69,    72,    73,
     &     75,    76,    77,    77,    78,    80,    79,    79,
     &     79,    78,    78,    78,    77,    78,    79,    80,
     &     80,    81,    81,    79,    79,    79,    78,    76,
     &     75,    77,    79,    80,    82,    83,    83,    78/
      Data (writetable(i),i=   36001,   36800)/
     &     75,    77,    78,    81,    80,    79,    78,    74,
     &     74,    69,    68,    68,    67,    66,    67,    67,
     &     67,    67,    66,    65,    66,    67,    66,    66,
     &     65,    65,    64,    62,    63,    62,    63,    61,
     &     62,    63,    63,    62,    63,    62,    60,    61,
     &     61,    61,    60,    60,    58,    58,    60,    59,
     &     39,    38,    39,    39,    37,    37,    38,    37,
     &     36,    36,    36,    35,    35,    34,    33,    33,
     &     34,    32,    34,    34,    33,    32,    29,    28,
     &     29,    28,    28,    28,    29,    29,    29,    28,
     &     29,    30,    32,    33,    33,    34,    34,    34,
     &     34,    35,    35,    35,    35,    35,    35,    35,
     &     32,    32,    32,    33,    32,    32,    34,    35,
     &     34,    33,    33,    33,    34,    34,    35,    36,
     &     36,    35,    36,    34,    34,    36,    36,    38,
     &     39,    38,    38,    40,    42,    42,    41,    41,
     &     41,    43,    42,    43,    45,    46,    45,    44,
     &     45,    45,    46,    45,    44,    42,    40,    42,
     &     43,    43,    43,    44,    42,    40,    40,    40,
     &     40,    41,    41,    41,    43,    43,    42,    39,
     &     39,    37,    39,    37,    37,    36,    35,    37,
     &     39,    39,    40,    41,    42,    42,    41,    40,
     &     37,    37,    36,    36,    36,    36,    37,    35,
     &     34,    33,    34,    35,    35,    33,    33,    32,
     &     35,    33,    33,    33,    32,    33,    35,    35,
     &     33,    33,    33,    35,    35,    34,    33,    32,
     &     33,    32,    35,    36,    37,    38,    39,    38,
     &     37,    37,    37,    37,    37,    35,    36,    38,
     &     38,    40,    39,    39,    39,    39,    39,    39,
     &     38,    39,    38,    42,    41,    42,    42,    41,
     &     37,    36,    36,    37,    36,    34,    36,    34,
     &     34,    33,    33,    34,    35,    35,    35,    36,
     &     36,    37,    39,    40,    38,    38,    38,    39,
     &     39,    38,    39,    40,    40,    41,    41,    42,
     &     42,    42,    41,    41,    41,    41,    40,    40,
     &     41,    41,    37,    39,    38,    41,    42,    42,
     &     42,    42,    43,    42,    42,    43,    44,    43,
     &     43,    44,    43,    43,    44,    42,    42,    41,
     &     41,    41,    40,    39,    39,    39,    38,    38,
     &     39,    40,    41,    41,    40,    40,    35,    36,
     &     37,    37,    34,    34,    34,    34,    34,    33,
     &     33,    34,    33,    32,    31,    32,    33,    33,
     &     32,    31,    31,    33,    30,    30,    29,    30,
     &     30,    30,    30,    32,    32,    31,    31,    33,
     &     33,    35,    35,    34,    35,    34,    34,    35,
     &     35,    34,    32,    31,    32,    32,    32,    32,
     &     33,    33,    34,    35,    35,    34,    34,    34,
     &     35,    35,    36,    38,    38,    37,    36,    36,
     &     36,    37,    37,    36,    36,    33,    33,    33,
     &     32,    32,    32,    32,    33,    33,    34,    35,
     &     37,    37,    38,    39,    39,    39,    40,    42,
     &     42,    42,    40,    43,    42,    43,    43,    42,
     &     43,    43,    43,    42,    43,    41,    40,    42,
     &     44,    45,    46,    48,    46,    47,    48,    48,
     &     48,    50,    51,    52,    52,    54,    55,    55,
     &     56,    56,    52,    51,    51,    51,    51,    50,
     &     50,    49,    49,    49,    49,    51,    51,    51,
     &     53,    51,    50,    52,    52,    53,    52,    53,
     &     53,    54,    55,    56,    57,    58,    59,    57,
     &     58,    61,    61,    59,    59,    54,    53,    55,
     &     54,    54,    55,    57,    55,    54,    53,    54,
     &     54,    56,    56,    57,    57,    58,    60,    61,
     &     60,    60,    61,    61,    61,    61,    64,    64,
     &     64,    65,    64,    62,    63,    63,    64,    64,
     &     61,    61,    63,    64,    64,    64,    65,    65,
     &     64,    65,    65,    63,    65,    65,    63,    60,
     &     61,    61,    61,    62,    62,    61,    60,    59,
     &     59,    58,    57,    56,    60,    60,    62,    63,
     &     62,    64,    64,    65,    64,    63,    64,    64,
     &     65,    65,    67,    68,    66,    67,    70,    69,
     &     69,    70,    71,    71,    72,    72,    71,    72,
     &     70,    69,    67,    69,    69,    69,    68,    71,
     &     71,    73,    73,    76,    77,    78,    82,    82,
     &     84,    85,    82,    84,    85,    87,    87,    86,
     &     86,    84,    85,    86,    88,    89,    89,    88,
     &     85,    87,    87,    87,    85,    85,    85,    83,
     &     83,    83,    86,    87,    89,    88,    88,    87,
     &     87,    87,    87,    88,    88,    90,    88,    85,
     &     83,    82,    82,    85,    83,    82,    84,    84,
     &     83,    84,    83,    85,    85,    83,    83,    83,
     &     83,    84,    82,    84,    89,    89,    88,    88,
     &     90,    92,    94,    97,    98,    97,    97,    97,
     &     98,   103,   105,   104,   104,   100,    98,    99,
     &    101,   104,   108,   108,   110,   110,   111,   112,
     &    112,   111,   111,   113,   114,   117,   117,   117,
     &    119,   116,   114,   117,   117,   114,   114,   117,
     &    117,   115,   115,   109,   105,   104,   104,   106,
     &    107,   108,   105,   104,   104,   105,   104,   106,
     &    107,   105,   103,   103,   103,   103,   101,   103,
     &    101,    99,   101,   100,   101,   103,   103,   101,
     &    101,   101,   100,    98,    99,    98,   102,   103,
     &     99,    97,    97,    97,   100,    99,   102,   102,
     &    103,   105,   104,   103,   104,   104,   104,   104,
     &    104,   104,   106,   110,   110,   110,   110,   111,
     &    107,   107,   106,   111,   115,   113,   113,   117,
     &    118,   120,   115,   114,   116,   116,   112,   111,
     &    112,   111,   112,   113,   113,   114,   115,   115,
     &    111,   111,   110,   109,   107,   105,   103,   104,
     &    105,   107,   107,   108,   108,   109,   111,   115,
     &    115,   116,   115,   116,   118,   117,   117,  1218/
      Data (writetable(i),i=   36801,   37600)/
     &   1225,  1226,  1221,  1226,  1229,  1234,  1228,  1224,
     &   1217,  1215,  1209,  1208,  1212,  1207,  1193,  1195,
     &   1201,  1200,  1196,  1195,  1181,  1185,  1197,  1203,
     &   1207,  1212,  1212,  1220,  1223,  1218,  1218,  1224,
     &   1229,  1225,  1230,  1236,  1245,  1256,  1270,  1286,
     &   1291,  1282,  1296,  1305,  1315,  1316,  1331,  1336,
     &   1348,  1373,  1388,  1415,  1412,  1427,  1438,  1464,
     &   1473,  1481,  1489,  1503,  1509,  1523,  1532,  1542,
     &   1555,  1563,  1584,  1598,  1614,  1630,  1632,  1659,
     &   1673,  1678,  1689,  1710,  1727,  1738,  1744,  1760,
     &   1760,  1763,  1780,  1789,  1815,  1831,  1842,  1856,
     &   1872,  1883,  1893,  1906,  1931,  1960,  1958,  1979,
     &   2004,  2023,  2049,  2060,  2036,  2050,  2046,  2037,
     &   2035,  2027,  2034,  2029,  2016,  2002,  2005,  2003,
     &   2009,  2007,  1998,  1992,  1982,  1975,  1979,  1974,
     &   1972,  1970,  1969,  1978,  1978,  1975,  1983,  1981,
     &   1975,  1975,  1978,  1973,  1981,  1975,  1966,  1980,
     &   1963,  1964,  1973,  1975,  1968,  1967,  1976,  1975,
     &   1980,  1974,  1990,  2002,  1984,  1984,  1982,  1984,
     &   1985,  1995,  2001,  2012,  2016,  2029,  2024,  2031,
     &   2030,  2035,  2057,  2077,  2084,  2099,  2098,  2092,
     &   2088,  2084,  2096,  2114,  2125,  2132,  2128,  2130,
     &   2121,  2134,  2168,  2170,  2194,  2206,  2217,  2223,
     &   2248,  2267,  2290,  2303,  2314,  2323,  2344,  2370,
     &   2378,  2403,  2403,  2406,  2417,  2427,  2438,  2452,
     &   2447,  2464,  2467,  2474,  2478,  2494,  2500,  2504,
     &   2528,  2548,  2550,  2564,  2579,  2590,  2599,  2623,
     &   2626,  2652,  2674,  2690,  2710,  2732,  2763,  2776,
     &   2798,  2824,  2839,  2867,  2894,  2905,  2931,  2961,
     &   2989,  3019,  3028,  3038,  3049,  3074,  3097,  3111,
     &   3121,  3131,  3144,  3170,  3202,  3212,  3210,  3228,
     &   3254,  3281,  3285,  3297,  3282,  3274,  3272,  3273,
     &   3279,  3251,  3238,  3224,  3211,  3198,  3194,  3191,
     &   3180,  3155,  3144,  3138,  3142,  3124,  3104,  3098,
     &   3074,  3057,  3043,  3030,  3022,  3019,  3023,  3012,
     &   2993,  2980,  2967,  2952,  2938,  2930,  2921,  2903,
     &   2897,  2882,  2872,  2867,  2864,  2877,  2879,  2861,
     &   2867,  2836,  2827,  2818,  2822,  2814,  2822,  2844,
     &   2828,  2844,  2862,  2872,  2870,  2885,  2885,  2911,
     &   2931,  2930,  2914,  2921,  2934,  2922,  2930,  2960,
     &   2963,  2976,  2978,  3011,  3014,  3030,  3053,  3060,
     &   3083,  3117,  3134,  3161,  3169,  3185,  3193,  3231,
     &   3254,  3270,  3295,  3319,  3360,  3380,  3403,  3438,
     &   3423,  3464,  3488,  3507,  3542,  3581,  3637,  3640,
     &   3687,  3714,  3731,  3750,  3773,  3811,  3835,  3880,
     &   3928,  3984,  4030,  4076,  4113,  4169,  4230,  4269,
     &   4328,  4392,  4461,  4522,  4591,  4637,  4690,  4775,
     &   4856,  4945,  5009,  5089,  5168,  5245,  5309,  5393,
     &   5468,  5564,  5635,  5686,  5765,  5831,  5892,  5945,
     &   6019,  6089,  6130,  6168,  6197,  6217,  6247,  6285,
     &   6273,  6243,  6242,  6202,  6172,  6149,  6110,  6069,
     &   6072,  6040,  6011,  5995,  5939,  5906,  5862,  5804,
     &   5754,  5703,  5657,  5620,  5599,  5567,  5523,  5481,
     &   5440,  5401,  5340,  5297,  5267,  5206,  5170,  5141,
     &   5119,  5080,  5044,  5025,  5012,  4985,  4937,  4898,
     &   4875,  4846,  4827,  4822,  4820,  4794,  4757,  4729,
     &   4732,  4710,  4715,  4692,  4682,  4689,  4677,  4671,
     &   4668,  4646,  4637,  4617,  4589,  4575,  4563,  4542,
     &   4523,  4479,  4468,  4447,  4438,  4430,  4412,  4385,
     &   4368,  4339,  4332,  4305,  4268,  4267,  4227,  4198,
     &   4161,  4140,  4097,  4061,  4020,  3982,  3949,  3918,
     &   3890,  3865,  3842,  3833,  3820,  3832,  3816,  3825,
     &   3826,  3836,  3838,  3851,  3803,  3750,  3693,  3665,
     &   3636,  3627,  3609,  3591,  3552,  3537,  3517,  3466,
     &   3471,  3453,  3456,  3440,  3433,  3401,  3374,  3336,
     &   3335,  3326,  3318,  3292,  3282,  3278,  3280,  3288,
     &   3269,  3271,  3268,  3272,  3276,  3278,  3287,  3281,
     &   3296,  3318,  3331,  3340,  3352,  3382,  3413,  3415,
     &   3404,  3412,  3458,  3466,  3470,  3478,  3443,  3429,
     &   3429,  3399,  3381,  3346,  3333,  3323,  3320,  3295,
     &   3290,  3299,  3284,  3268,  3245,  3221,  3218,  3194,
     &   3171,  3173,  3153,  3154,  3144,  3149,  3136,  3139,
     &   3106,  3091,  3063,  3060,  3051,  3036,  3043,  3022,
     &   2989,  2978,  2977,  2973,  2974,  2966,  2957,  2948,
     &   2928,  2921,  2912,  2910,  2896,  2877,  2845,  2829,
     &   2849,  2835,  2839,  2832,  2837,  2857,  2860,  2862,
     &   2863,  2873,  2880,  2893,  2897,  2892,  2900,  2896,
     &   2898,  2916,  2928,  2926,  2950,  2955,  2963,  2971,
     &   2978,  2992,  2992,  2994,  2992,  2986,  2986,  2993,
     &   3002,  3014,  3016,  3018,  3028,  3042,  3048,  3059,
     &   3074,  3082,  3084,  3089,  3079,  3083,  3069,  3051,
     &   3042,  3038,  3006,  2972,  2937,  2907,  2863,  2833,
     &   2808,  2780,  2771,  2763,  2735,  2711,  2710,  2693,
     &   2693,  2679,  2683,  2679,  2683,  2691,  2695,  2690,
     &   2689,  2713,  2707,  2706,  2704,  2675,  2688,  2690,
     &   2700,  2698,  2703,  2701,  2688,  2692,  2682,  2688,
     &   2699,  2691,  2698,  2707,  2710,  2740,  2736,  2762,
     &   2762,  2790,  2794,  2811,  2808,  2804,  2795,  2801,
     &   2797,  2801,  2791,  2786,  2779,  2772,  2755,  2763,
     &   2739,  2716,  2722,  2703,  2702,  2717,  2713,  2720,
     &   2720,  2721,  2726,  2729,  2735,  2728,  2726,  2725,
     &   2725,  2732,  2740,  2752,  2764,  2774,  2765,  2762,
     &   2758,  2763,  2765,  2758,  2755,  2757,  2766,  2775,
     &   2780,  2794,  2799,  2802,  2823,  2845,   217,   220,
     &    222,   224,   226,   227,   228,   227,   229,   227,
     &    225,   222,   226,   221,   223,   224,   224,   223,
     &    223,   223,   223,   223,   224,   226,   224,   229,
     &    225,   227,   224,   223,   226,   227,   229,   233,
     &    237,   240,   239,   240,   240,   241,   245,   245,
     &    244,   246,   246,   253,   257,   258,   260,   261/
      Data (writetable(i),i=   37601,   38400)/
     &    257,   255,   259,   256,   254,   251,   249,   250,
     &    255,   255,   256,   259,   260,   262,   262,   259,
     &    258,   254,   258,   253,   258,   261,   262,   264,
     &    265,   263,   266,   273,   274,   281,   284,   286,
     &    291,   294,   290,   292,   291,   289,   289,   289,
     &    288,   292,   296,   295,   298,   297,   300,   298,
     &    299,   304,   307,   307,   308,   309,   309,   310,
     &    306,   310,   303,   299,   300,   298,   299,   297,
     &    297,   295,   294,   294,   298,   295,   292,   293,
     &    292,   288,   288,   287,   292,   290,   293,   291,
     &    287,   287,   292,   294,   295,   295,   295,   287,
     &    285,   284,   288,   288,   289,   283,   285,   282,
     &    279,   273,   272,   267,   267,   267,   264,   266,
     &    263,   266,   260,   256,   259,   258,   256,   256,
     &    253,   252,   257,   262,   264,   259,   264,   263,
     &    263,   262,   263,   259,   261,   262,   260,   261,
     &    259,   260,   260,   257,   258,   261,   262,   261,
     &    264,   264,   268,   268,   269,   268,   265,   263,
     &    270,   274,   273,   274,   271,   269,   273,   282,
     &    279,   283,   286,   287,   288,   286,   287,   287,
     &    288,   292,   292,   298,   302,   305,   312,   313,
     &    315,   318,   320,   317,   316,   316,   319,   319,
     &    321,   319,   321,   317,   319,   319,   316,   321,
     &    324,   325,   332,   335,   337,   337,   344,   346,
     &    340,   341,   341,   341,   347,   347,   343,   343,
     &    343,   343,   343,   339,   339,   340,   340,   337,
     &    338,   334,   326,   321,   319,   320,   319,   321,
     &    319,   321,   321,   321,   322,   316,   317,   317,
     &    317,   314,   311,   309,   307,   312,   311,   304,
     &    300,   299,   293,   290,   290,   289,   292,   295,
     &    294,   290,   289,   286,   282,   280,   279,   277,
     &    270,   269,   262,   261,   261,   264,   261,   261,
     &    263,   268,   267,   265,   264,   261,   262,   262,
     &    265,   259,   260,   257,   262,   263,   261,   257,
     &    260,   262,   261,   263,   265,   262,   272,   273,
     &    276,   280,   278,   280,   283,   281,   281,   284,
     &    291,   293,   297,   300,   305,   309,   313,   314,
     &    317,   320,   312,   316,   314,   319,   326,   331,
     &    336,   341,   339,   346,   346,   348,   342,   346,
     &    346,   350,   357,   366,   377,   383,   392,   401,
     &    406,   405,   412,   412,   412,   424,   436,   443,
     &    456,   466,   475,   481,   499,   516,   527,   534,
     &    542,   556,   572,   582,   588,   594,   608,   615,
     &    622,   628,   639,   644,   649,   655,   664,   670,
     &    680,   689,   701,   713,   725,   735,   741,   750,
     &    757,   776,   787,   800,   812,   820,   827,   840,
     &    852,   862,   866,   875,   880,   893,   908,   930,
     &    951,   957,   967,   980,   987,   991,  1008,  1026,
     &   1030,  1041,  1056,  1072,  1094,  1119,  1128,  1141,
     &   1158,  1172,  1190,  1206,  1219,  1238,  1258,  1279,
     &   1298,  1316,  1330,  1352,  1376,  1389,  1410,  1432,
     &   1465,  1485,  1506,  1515,  1530,  1550,  1580,  1598,
     &   1615,  1633,  1657,  1684,  1708,  1729,  1742,  1760,
     &   1790,  1822,  1842,  1863,  1891,  1916,  1938,  1959,
     &   1986,  2019,  2041,  2060,  2090,  2103,  2129,  2152,
     &   2177,  2199,  2211,  2243,  2267,  2294,  2330,  2356,
     &   2392,  2429,  2471,  2465,  2466,  2464,  2476,  2468,
     &   2459,  2451,  2452,  2453,  2459,  2468,  2437,  2437,
     &   2444,  2446,  2445,  2448,  2444,  2436,  2428,  2423,
     &   2425,  2410,  2395,  2374,  2357,  2359,  2333,  2323,
     &   2316,  2300,  2295,  2284,  2264,  2243,  2227,  2203,
     &   2193,  2174,  2155,  2142,  2108,  2087,  2056,  2038,
     &   2014,  1994,  1988,  1957,  1928,  1912,  1896,  1871,
     &   1852,  1828,  1800,  1778,  1757,  1729,  1695,  1673,
     &   1662,  1638,  1623,  1621,  1598,  1584,  1559,  1540,
     &   1525,  1496,  1473,  1457,  1441,  1426,  1422,  1412,
     &   1407,  1388,  1387,  1371,  1360,  1337,  1319,  1302,
     &   1286,  1271,  1262,  1249,  1230,  1213,  1204,  1192,
     &   1176,  1168,  1162,  1148,  1137,  1125,  1104,  1095,
     &   1096,  1093,  1095,  1094,  1100,  1091,  1075,  1071,
     &   1058,  1057,  1057,  1047,  1033,  1024,  1012,  1002,
     &   1007,  1000,   989,   985,   979,   977,   979,   975,
     &    975,   970,   969,   969,   967,   958,   959,   949,
     &    942,   938,   930,   927,   921,   917,   905,   900,
     &    899,   900,   907,   908,   910,   911,   903,   891,
     &    887,   877,   879,   877,   868,   856,   848,   839,
     &    829,   819,   817,   817,   807,   801,   787,   781,
     &    785,   785,   786,   785,   776,   772,   767,   759,
     &    757,   760,   767,   769,   769,   766,   763,   756,
     &    748,   739,   735,   734,   733,   727,   720,   721,
     &    724,   720,   724,   730,   725,   719,   716,   715,
     &    704,   698,   700,   702,   701,   694,   696,   696,
     &    685,   687,   689,   691,   695,   693,   695,   694,
     &    697,   703,   706,   696,   701,   696,   696,   705,
     &    706,   714,   714,   710,   717,   714,   711,   711,
     &    719,   721,   719,   715,   717,   714,   707,   707,
     &    712,   707,   704,   698,   703,   704,   702,   697,
     &    695,   690,   690,   687,   684,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0/
      Data (writetable(i),i=   38401,   39200)/
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0/
      Data (writetable(i),i=   39201,   40000)/
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0/
      Data (writetable(i),i=   40001,   40800)/
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0/
      Data (writetable(i),i=   40801,   41600)/
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0/
      Data (writetable(i),i=   41601,   42400)/
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0/
      Data (writetable(i),i=   42401,   43200)/
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0/
      Data (writetable(i),i=   43201,   44000)/
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,     0,     0,
     &      0,     0,     0,     0,     0,     0,    42,    41,
     &     41,    40,    39,    38,    37,    38,    39,    37,
     &     37,    38,    37,    37,    36,    35,    34,    33,
     &     33,    33,    33,    33,    33,    34,    34,    32,
     &     31,    28,    29,    29,    27,    27,    27,    24,
     &     23,    23,    24,    23,    21,    20,    19,    18,
     &     18,    18,    18,    16,    15,    15,    15,    16,
     &     17,    17,    17,    17,    17,    17,    17,    17,
     &     17,    17,    16,    16,    17,    17,    19,    19,
     &     19,    19,    19,    20,    20,    22,    22,    22,
     &     22,    21,    23,    22,    22,    22,    23,    23,
     &     24,    25,    26,    26,    27,    27,    28,    27,
     &     27,    27,    27,    28,    29,    29,    30,    29,
     &     29,    28,    29,    29,    29,    29,    29,    29,
     &     29,    29,    28,    27,    26,    26,    26,    25,
     &     25,    24,    24,    24,    24,    24,    23,    23,
     &     24,    22,    23,    23,    23,    23,    24,    25,
     &     26,    25,    23,    23,    23,    20,    20,    19,
     &     19,    19,    18,    18,    18,    18,    19,    20,
     &     19,    19,    19,    19,    19,    19,    19,    18,
     &     18,    17,    17,    17,    17,    16,    16,    15,
     &     15,    15,    14,    14,    14,    13,    14,    15,
     &     15,    15,    17,    18,    18,    19,    17,    18,
     &     17,    19,    19,    19,    19,    20,    19,    21,
     &     20,    20,    20,    21,    21,    21,    21,    23,
     &     23,    23,    23,    23,    23,    23,    24,    24,
     &     25,    25,    26,    25,    25,    26,    26,    28,
     &     28,    28,    28,    28,    28,    28,    27,    27,
     &     28,    27,    28,    28,    28,    28,    27,    28,
     &     28,    28,    28,    27,    27,    26,    26,    26,
     &     26,    25,    26,    26,    23,    24,    23,    22,
     &     20,    21,    20,    21,    22,    21,    21,    20,
     &     20,    21,    21,    21,    21,    21,    22,    23,
     &     23,    23,    23,    22,    21,    20,    20,    21,
     &     20,    20,    20,    20,    19,    19,    19,    18,
     &     18,    20,    19,    19,    19,    19,    19,    19,
     &     19,    18,    18,    18,    18,    18,    18,    17,
     &     16,    17,    17,    17,    18,    18,    18,    17,
     &     17,    17,    17,    17,    17,    18,    18,    18,
     &     19,    19,    19,    18,    18,    19,    19,    19,
     &     20,    19,    19,    20,    20,    20,    20,    18,
     &     18,    18,    18,    17,    17,    17,    17,    17,
     &     17,    16,    16,    16,    15,    15,    15,    16,
     &     16,    17,    15,    14,    13,    12,    11,    11,
     &     13,    13,    13,    14,    15,    15,    16,    16,
     &     16,    16,    18,    17,    17,    17,    19,    19,
     &     20,    19,    17,    19,    19,    19,    19,    19,
     &     19,    19,    20,    22,    21,    21,    22,    22,
     &     23,    24,    25,    25,    25,    24,    25,    27,
     &     27,    27,    25,    25,    26,    26,    24,    25,
     &     25,    27,    27,    27,    27,    27,    27,    27,
     &     28,    29,    29,    28,    29,    29,    30,    32,
     &     31,    31,    30,    28,    28,    27,    27,    27,
     &     27,    27,    28,    28,    28,    28,    28,    27,
     &     27,    27,    28,    29,    29,    30,    29,    30,
     &     31,    33,    33,    33,    34,    34,    33,    34/
      Data (writetable(i),i=   44001,   44800)/
     &     33,    33,    32,    33,    33,    34,    34,    35,
     &     35,    35,    35,    34,    35,    33,    34,    35,
     &     35,    35,    35,    36,    36,    35,    35,    35,
     &     35,    35,    37,    37,    38,    37,    37,    37,
     &     37,    36,    37,    36,    37,    36,    37,    37,
     &     37,    37,    38,    38,    37,    36,    36,    34,
     &     32,    32,    32,    32,    32,    35,    36,    36,
     &     36,    37,    38,    38,    38,    37,    37,    36,
     &     37,    37,    36,    34,    32,    31,    31,    33,
     &     32,    32,    31,    29,    30,    31,    31,    30,
     &     29,    29,    30,    31,    34,    35,    38,    37,
     &     38,    38,    39,    41,    40,    40,    43,    45,
     &     45,    45,    45,    48,    49,    49,    49,    50,
     &     50,    51,    52,    53,    54,    51,    51,    51,
     &     50,    49,    49,    50,    51,    51,    53,    54,
     &     53,    54,    55,    55,    56,    55,    55,    56,
     &     57,    58,    59,    60,    60,    60,    61,    60,
     &     58,    57,    57,    57,    58,    57,    56,    57,
     &     57,    57,    56,    54,    53,    53,    53,    53,
     &     51,    51,    51,    50,    52,    55,    53,    58,
     &     58,    57,    57,    56,    56,    56,    56,    56,
     &     56,    58,    57,    59,    61,    63,    63,    64,
     &     66,    66,    64,    63,    62,    60,    59,    58,
     &     60,    60,    59,    58,    59,    59,    57,    59,
     &     59,    59,    59,    60,    59,    59,    60,    60,
     &     61,    61,    59,    59,    60,    57,    54,    55,
     &     54,    54,    56,    59,    56,    55,    56,    55,
     &     55,    56,    57,    59,    60,    57,    55,    55,
     &     54,    56,    56,    56,    56,    55,    55,    55,
     &     57,    56,    58,    61,    64,    64,    65,    64,
     &     63,    63,    65,    67,    68,    71,    71,    71,
     &     71,    72,    75,    77,    77,    74,    75,    76,
     &     77,    78,    79,    80,    82,    80,    80,    78,
     &     78,    80,    79,    80,    80,    82,    83,    85,
     &     84,    85,    86,    88,    91,    91,    92,    92,
     &     93,    95,    94,    92,    95,    96,    98,    98,
     &     99,   101,   103,   105,   105,   106,   106,   107,
     &    106,   107,   108,   107,   105,   105,   108,   109,
     &    110,   113,   113,   112,   111,    37,    38,    37,
     &     37,    39,    38,    37,    38,    37,    38,    40,
     &     40,    41,    40,    41,    43,    43,    45,    46,
     &     46,    46,    46,    48,    48,    49,    49,    50,
     &     49,    49,    48,    48,    50,    50,    50,    49,
     &     47,    45,    43,    43,    43,    41,    43,    42,
     &     43,    43,    43,    43,    43,    43,    42,    41,
     &     41,    44,    43,    43,    42,    43,    43,    42,
     &     42,    43,    43,    45,    46,    47,    47,    49,
     &     48,    47,    48,    47,    48,    48,    47,    48,
     &     47,    46,    49,    48,    49,    50,    48,    49,
     &     49,    51,    50,    51,    51,    54,    52,    52,
     &     51,    54,    55,    56,    57,    57,    58,    58,
     &     58,    60,    58,    55,    53,    47,    46,    45,
     &     45,    44,    42,    43,    42,    42,    41,    40,
     &     39,    40,    40,    39,    39,    36,    38,    38,
     &     38,    38,    40,    41,    40,    40,    40,    40,
     &     41,    41,    41,    39,    38,    37,    36,    35,
     &     35,    35,    34,    36,    31,    32,    33,    34,
     &     33,    37,    36,    35,    36,    36,    34,    35,
     &     34,    35,    34,    33,    34,    34,    35,    37,
     &     36,    35,    34,    33,    34,    33,    33,    34,
     &     36,    36,    37,    37,    34,    35,    34,    32,
     &     33,    34,    34,    34,    34,    37,    36,    37,
     &     36,    37,    37,    37,    38,    37,    37,    37,
     &     36,    37,    37,    39,    39,    39,    39,    39,
     &     39,    40,    41,    42,    41,    40,    40,    41,
     &     41,    41,    42,    42,    43,    43,    40,    42,
     &     42,    43,    44,    42,    41,    40,    39,    41,
     &     41,    38,    38,    37,    36,    36,    36,    37,
     &     38,    38,    37,    38,    38,    37,    37,    38,
     &     38,    37,    35,    33,    31,    30,    30,    28,
     &     29,    30,    30,    30,    30,    28,    29,    30,
     &     28,    28,    28,    27,    27,    27,    27,    27,
     &     26,    27,    28,    28,    27,    28,    29,    28,
     &     27,    27,    26,    27,    27,    26,    26,    26,
     &     26,    26,    25,    25,    25,    25,    24,    25,
     &     24,    24,    24,    25,    25,    25,    25,    25,
     &     24,    24,    25,    26,    26,    26,    24,    23,
     &     23,    22,    25,    24,    24,    24,    23,    22,
     &     23,    24,    24,    24,    25,    24,    24,    22,
     &     22,    22,    22,    23,    22,    22,    22,    23,
     &     23,    23,    23,    23,    23,    22,    22,    20,
     &     19,    18,    19,    20,    21,    22,    22,    23,
     &     26,    26,    25,    27,    29,    28,    29,    29,
     &     27,    27,    27,    27,    26,    26,    26,    29,
     &     28,    31,    32,    32,    29,    30,    33,    33,
     &     35,    35,    35,    35,    35,    38,    38,    38,
     &     39,    37,    39,    39,    38,    39,    40,    39,
     &     40,    41,    42,    41,    42,    42,    42,    42,
     &     42,    43,    42,    42,    42,    42,    42,    43,
     &     43,    42,    42,    42,    42,    44,    44,    44,
     &     45,    45,    46,    46,    46,    46,    46,    46,
     &     46,    46,    44,    45,    45,    45,    45,    45,
     &     43,    43,    43,    43,    43,    44,    44,    42,
     &     42,    42,    45,    44,    43,    44,    45,    45,
     &     45,    45,    43,    44,    44,    43,    44,    45,
     &     45,    44,    47,    49,    48,    49,    51,    49,
     &     50,    50,    51,    52,    54,    55,    55,    54,
     &     55,    56,    55,    56,    57,    57,    57,    58,
     &     59,    60,    61,    61,    61,    61,    61,    60,
     &     58,    58,    60,    60,    60,    60,    61,    63/
      Data (writetable(i),i=   44801,   45600)/
     &     61,    61,    61,    61,    61,    61,    62,    69,
     &     68,    76,    75,    71,    71,    69,    68,    68,
     &     68,    67,    66,    68,    64,    60,    65,    63,
     &     63,    64,    63,    61,    57,    56,    56,    58,
     &     59,    61,    62,    62,    59,    59,    63,    63,
     &     62,    66,    70,    72,    74,    76,    77,    80,
     &     81,    82,    83,    84,    85,    86,    87,    90,
     &     93,    95,    94,    94,    94,    94,    93,    93,
     &     94,    91,    91,    92,    92,    92,    91,    92,
     &     92,    92,    90,    88,    87,    88,    90,    90,
     &     90,    87,    90,    90,    90,    91,    91,    90,
     &     91,    92,    91,    92,    93,    92,    91,    97,
     &     94,    92,    89,    90,    89,    89,    91,    89,
     &     89,    90,    92,    92,    92,    91,    95,    97,
     &     97,    96,    98,   100,    99,   100,   100,   100,
     &     99,   100,   102,   104,   105,   105,   103,   103,
     &    105,   109,   109,   112,   115,   116,   117,   118,
     &    118,   117,   115,   117,   117,   118,   118,   119,
     &    117,   118,   119,   118,   113,   112,   113,   113,
     &    109,   110,   109,   110,   113,   113,   110,   109,
     &    111,   111,   110,   108,   108,   110,   111,   113,
     &    114,   117,   117,   116,   119,   118,   120,   119,
     &    119,   120,   118,   121,   123,   123,   124,   127,
     &    128,   131,   131,   134,   136,   137,   142,   142,
     &    142,   142,   144,   141,   142,   144,   148,   145,
     &    147,   150,   145,   142,   147,   152,   159,   163,
     &    166,   166,   168,   171,   172,   175,   176,   179,
     &    181,   180,   180,   179,   180,   182,   182,   181,
     &    182,   182,   181,   183,   185,   185,   190,   187,
     &    188,   191,   191,   192,   194,   192,   195,   195,
     &    198,   198,   201,   198,   202,   200,   203,   205,
     &    206,   204,   205,   203,   201,   199,   198,   200,
     &    203,   204,   204,   201,    32,    32,    32,    32,
     &     31,    31,    30,    30,    31,    30,    30,    29,
     &     29,    30,    30,    30,    30,    31,    31,    28,
     &     28,    28,    26,    24,    23,    24,    24,    23,
     &     22,    19,    17,    18,    17,    18,    18,    18,
     &     19,    18,    18,    17,    17,    17,    17,    17,
     &     18,    19,    21,    21,    20,    22,    23,    22,
     &     23,    22,    22,    22,    22,    22,    21,    23,
     &     25,    25,    25,    26,    27,    27,    26,    26,
     &     26,    26,    27,    29,    29,    30,    32,    32,
     &     32,    32,    32,    32,    32,    31,    30,    30,
     &     33,    33,    31,    33,    35,    37,    38,    38,
     &     39,    40,    39,    39,    37,    36,    35,    36,
     &     35,    35,    36,    35,    35,    35,    33,    34,
     &     36,    36,    34,    34,    35,    35,    36,    35,
     &     34,    31,    29,    29,    28,    28,    29,    28,
     &     28,    27,    26,    25,    24,    24,    23,    21,
     &     19,    19,    19,    18,    19,    19,    19,    18,
     &     19,    18,    19,    20,    18,    18,    18,    19,
     &     19,    19,    19,    18,    18,    18,    17,    17,
     &     16,    17,    17,    17,    17,    17,    17,    17,
     &     17,    16,    16,    16,    15,    15,    16,    16,
     &     17,    17,    17,    18,    18,    17,    15,    17,
     &     17,    17,    18,    19,    19,    17,    17,    18,
     &     18,    19,    19,    19,    19,    20,    20,    18,
     &     18,    19,    19,    19,    19,    18,    19,    19,
     &     19,    19,    19,    20,    22,    23,    23,    21,
     &     21,    21,    21,    22,    21,    20,    20,    20,
     &     20,    20,    20,    22,    22,    23,    23,    22,
     &     22,    21,    21,    22,    23,    23,    24,    24,
     &     23,    22,    22,    24,    24,    26,    26,    27,
     &     26,    29,    29,    30,    31,    33,    32,    32,
     &     31,    31,    31,    32,    32,    33,    32,    32,
     &     31,    32,    31,    31,    31,    31,    30,    30,
     &     31,    31,    30,    30,    30,    30,    30,    30,
     &     30,    28,    28,    28,    28,    27,    26,    26,
     &     26,    26,    26,    24,    21,    21,    20,    20,
     &     21,    21,    23,    21,    22,    21,    21,    20,
     &     20,    20,    20,    20,    20,    20,    20,    19,
     &     19,    19,    19,    19,    20,    19,    19,    19,
     &     19,    19,    19,    18,    18,    18,    18,    18,
     &     18,    18,    20,    21,    21,    22,    21,    20,
     &     18,    18,    18,    17,    18,    17,    15,    16,
     &     16,    16,    16,    15,    15,    16,    16,    17,
     &     16,    16,    16,    16,    16,    16,    15,    16,
     &     15,    13,    13,    13,    14,    14,    15,    15,
     &     15,    14,    14,    13,    13,    14,    15,    13,
     &     13,    13,    13,    15,    15,    15,    14,    14,
     &     14,    14,    15,    14,    15,    15,    15,    16,
     &     18,    18,    18,    18,    18,    18,    20,    20,
     &     20,    21,    22,    23,    21,    22,    22,    20,
     &     22,    22,    24,    23,    23,    24,    23,    24,
     &     26,    27,    26,    25,    25,    26,    26,    26,
     &     26,    26,    26,    27,    28,    28,    29,    29,
     &     29,    30,    31,    31,    31,    31,    31,    32,
     &     33,    32,    32,    33,    33,    33,    34,    33,
     &     33,    34,    34,    34,    35,    36,    37,    37,
     &     38,    38,    37,    39,    39,    39,    39,    38,
     &     38,    39,    37,    37,    38,    38,    39,    39,
     &     39,    39,    39,    39,    39,    40,    40,    39,
     &     41,    40,    40,    41,    41,    41,    41,    41,
     &     40,    39,    40,    40,    42,    42,    41,    43,
     &     44,    42,    42,    42,    42,    44,    45,    45,
     &     45,    45,    43,    42,    42,    42,    42,    42,
     &     43,    43,    42,    42,    40,    42,    40,    38,
     &     37,    35,    39,    39,    37,    37,    40,    38,
     &     36,    38,    38,    38,    39,    38,    37,    36,
     &     39,    39,    37,    39,    39,    41,    40,    41/
      Data (writetable(i),i=   45601,   46400)/
     &     42,    41,    41,    38,    38,    39,    41,    41,
     &     43,    43,    44,    46,    45,    46,    46,    46,
     &     44,    45,    44,    43,    43,    45,    45,    45,
     &     45,    47,    49,    50,    51,    50,    47,    50,
     &     51,    51,    52,    51,    51,    52,    53,    53,
     &     52,    51,    50,    51,    52,    51,    51,    51,
     &     50,    50,    49,    51,    51,    53,    51,    52,
     &     54,    53,    53,    51,    53,    50,    53,    54,
     &     54,    55,    55,    54,    55,    55,    55,    57,
     &     55,    56,    56,    56,    57,    56,    58,    57,
     &     55,    55,    54,    55,    56,    55,    56,    56,
     &     58,    59,    59,    59,    59,    59,    59,    58,
     &     59,    57,    57,    59,    60,    60,    59,    59,
     &     61,    61,    60,    60,    60,    58,    57,    57,
     &     58,    58,    56,    56,    56,    57,    58,    58,
     &     58,    58,    59,    60,    64,    66,    66,    69,
     &     70,    71,    72,    73,    78,    80,    82,    80,
     &     79,    81,    79,    82,    86,    85,    84,    88,
     &     85,    84,    84,    85,    86,    87,    87,    88,
     &     88,    92,    93,    95,    97,    97,   101,   105,
     &    106,   105,   106,   106,   106,   107,   111,   109,
     &    108,   110,   112,   109,   112,   115,   117,   117,
     &    117,   120,   122,   121,   122,   123,   124,   123,
     &    122,   124,   124,   126,   127,   127,   126,   126,
     &    128,   128,   126,   126,   127,   128,   129,   131,
     &    130,   127,   125,   124,   125,   127,   125,   125,
     &    126,   127,   127,    32,    32,    31,    31,    31,
     &     31,    31,    32,    32,    32,    32,    32,    32,
     &     33,    33,    32,    31,    29,    29,    29,    28,
     &     28,    28,    28,    27,    26,    25,    23,    23,
     &     23,    22,    23,    21,    21,    21,    20,    20,
     &     21,    20,    22,    22,    21,    21,    19,    19,
     &     18,    18,    18,    20,    21,    21,    20,    20,
     &     20,    19,    19,    19,    19,    18,    18,    19,
     &     18,    18,    19,    19,    20,    20,    21,    21,
     &     21,    22,    22,    22,    22,    22,    21,    23,
     &     25,    26,    26,    26,    25,    25,    25,    25,
     &     25,    25,    24,    26,    26,    25,    26,    27,
     &     27,    28,    26,    27,    27,    27,    27,    26,
     &     24,    24,    24,    24,    25,    25,    25,    25,
     &     25,    25,    25,    27,    27,    26,    25,    25,
     &     24,    25,    25,    27,    28,    28,    28,    27,
     &     25,    25,    26,    24,    24,    24,    24,    25,
     &     23,    23,    24,    24,    22,    22,    23,    22,
     &     22,    20,    21,    22,    21,    21,    21,    21,
     &     21,    21,    21,    21,    21,    20,    20,    20,
     &     20,    21,    21,    21,    20,    20,    21,    22,
     &     22,    22,    22,    22,    22,    21,    21,    20,
     &     20,    21,    21,    20,    21,    21,    22,    22,
     &     23,    23,    23,    22,    22,    23,    24,    23,
     &     23,    22,    22,    22,    22,    22,    23,    24,
     &     24,    24,    23,    23,    24,    25,    26,    26,
     &     27,    28,    28,    28,    28,    27,    27,    27,
     &     27,    27,    28,    28,    27,    26,    26,    26,
     &     29,    29,    27,    26,    28,    28,    30,    30,
     &     29,    29,    28,    28,    30,    30,    30,    30,
     &     30,    30,    29,    29,    28,    28,    28,    29,
     &     28,    28,    28,    28,    28,    28,    27,    27,
     &     26,    26,    26,    26,    27,    26,    26,    24,
     &     23,    20,    20,    20,    20,    19,    19,    18,
     &     19,    19,    19,    19,    19,    19,    17,    17,
     &     15,    15,    15,    15,    15,    14,    14,    14,
     &     14,    15,    15,    14,    15,    15,    14,    15,
     &     14,    14,    14,    15,    14,    13,    13,    13,
     &     12,    13,    13,    13,    13,    13,    14,    13,
     &     13,    13,    13,    13,    13,    13,    13,    14,
     &     14,    15,    15,    15,    15,    16,    16,    15,
     &     15,    16,    16,    16,    16,    15,    16,    16,
     &     16,    16,    16,    16,    17,    17,    18,    18,
     &     18,    18,    18,    18,    17,    19,    19,    19,
     &     19,    19,    19,    20,    20,    21,    19,    19,
     &     19,    18,    18,    19,    21,    21,    21,    21,
     &     20,    20,    20,    20,    20,    20,    20,    19,
     &     19,    19,    19,    18,    19,    19,    19,    19,
     &     19,    20,    20,    21,    22,    22,    23,    23,
     &     23,    24,    24,    24,    24,    24,    24,    23,
     &     24,    24,    24,    25,    28,    29,    29,    28,
     &     28,    25,    25,    26,    26,    27,    28,    28,
     &     29,    28,    28,    28,    27,    28,    28,    29,
     &     29,    29,    28,    28,    27,    26,    27,    27,
     &     26,    26,    25,    25,    25,    26,    26,    27,
     &     26,    26,    27,    29,    28,    29,    30,    31,
     &     33,    32,    31,    31,    31,    33,    31,    31,
     &     31,    30,    29,    29,    30,    33,    33,    33,
     &     33,    34,    34,    34,    34,    34,    34,    35,
     &     34,    33,    33,    33,    33,    33,    34,    34,
     &     33,    33,    35,    35,    37,    37,    38,    39,
     &     38,    38,    38,    38,    39,    39,    39,    38,
     &     37,    38,    38,    39,    39,    41,    42,    43,
     &     43,    43,    41,    40,    40,    38,    39,    38,
     &     39,    39,    39,    37,    40,    40,    37,    38,
     &     37,    37,    37,    38,    36,    36,    38,    38,
     &     37,    35,    35,    35,    36,    36,    34,    34,
     &     33,    35,    36,    39,    42,    44,    47,    47,
     &     46,    44,    43,    46,    48,    50,    50,    50,
     &     51,    51,    51,    52,    52,    50,    51,    51,
     &     50,    48,    48,    49,    52,    52,    52,    53,
     &     53,    53,    53,    54,    54,    54,    54,    53,
     &     52,    53,    54,    56,    54,    54,    53,    53,
     &     52,    52,    54,    55,    55,    58,    60,    60/
      Data (writetable(i),i=   46401,   47200)/
     &     61,    63,    62,    60,    60,    61,    61,    61,
     &     62,    60,    59,    57,    59,    59,    60,    64,
     &     65,    66,    68,    68,    67,    65,    65,    64,
     &     65,    65,    66,    68,    69,    69,    69,    71,
     &     72,    74,    75,    74,    72,    71,    72,    71,
     &     72,    73,    74,    74,    75,    76,    73,    73,
     &     71,    71,    70,    70,    69,    70,    72,    70,
     &     70,    68,    68,    66,    68,    69,    65,    63,
     &     66,    66,    67,    67,    68,    65,    68,    70,
     &     72,    71,    72,    72,    73,    75,    75,    72,
     &     73,    73,    74,    75,    75,    80,    80,    81,
     &     80,    82,    82,    82,    82,    87,    87,    87,
     &     90,    90,    89,    92,    91,    90,    91,    92,
     &     92,    92,    93,    95,    99,    99,   100,    99,
     &     97,    94,    94,    92,    92,    95,    95,    94,
     &     94,    95,    95,    94,    94,    92,    94,    93,
     &     93,    95,    97,    97,    99,   100,    99,   100,
     &     98,   101,   100,   104,   102,   103,   108,   110,
     &    110,   109,   107,   107,   105,   106,   105,   103,
     &    104,   103,   104,   105,   105,   106,   102,   101,
     &    101,   101,    46,    46,    45,    46,    40,    38,
     &     38,    39,    37,    36,    36,    35,    35,    35,
     &     36,    37,    34,    33,    32,    34,    33,    33,
     &     34,    33,    34,    34,    33,    32,    31,    31,
     &     31,    31,    29,    29,    28,    28,    27,    26,
     &     27,    26,    26,    27,    27,    26,    27,    26,
     &     26,    27,    30,    31,    33,    34,    33,    34,
     &     36,    37,    38,    38,    38,    39,    41,    43,
     &     44,    44,    45,    45,    45,    45,    46,    45,
     &     47,    44,    44,    44,    45,    46,    47,    47,
     &     48,    49,    50,    51,    51,    51,    51,    51,
     &     52,    54,    54,    53,    55,    56,    57,    57,
     &     56,    59,    55,    53,    53,    51,    54,    52,
     &     52,    53,    53,    55,    57,    56,    54,    53,
     &     51,    49,    48,    46,    46,    46,    44,    44,
     &     43,    44,    43,    42,    42,    42,    43,    41,
     &     40,    40,    36,    34,    34,    33,    33,    34,
     &     33,    33,    33,    31,    31,    32,    31,    29,
     &     29,    29,    31,    32,    32,    32,    31,    29,
     &     32,    34,    32,    33,    32,    33,    33,    33,
     &     33,    33,    31,    31,    32,    32,    32,    33,
     &     33,    34,    33,    33,    33,    33,    30,    31,
     &     31,    31,    32,    31,    31,    29,    29,    29,
     &     31,    31,    30,    29,    29,    32,    32,    35,
     &     35,    34,    34,    34,    34,    34,    36,    38,
     &     38,    38,    38,    40,    39,    38,    38,    37,
     &     37,    36,    36,    38,    37,    39,    38,    41,
     &     42,    40,    37,    40,    39,    39,    37,    38,
     &     38,    37,    37,    37,    38,    37,    36,    37,
     &     38,    38,    38,    38,    37,    37,    36,    36,
     &     35,    35,    33,    33,    34,    35,    36,    35,
     &     35,    33,    32,    32,    32,    31,    30,    31,
     &     33,    32,    32,    33,    32,    31,    30,    29,
     &     28,    28,    29,    27,    27,    27,    26,    24,
     &     24,    24,    24,    26,    25,    25,    25,    25,
     &     25,    25,    24,    23,    23,    22,    20,    20,
     &     21,    21,    21,    21,    20,    21,    21,    22,
     &     22,    22,    21,    21,    19,    20,    20,    20,
     &     18,    18,    18,    19,    19,    19,    19,    19,
     &     21,    21,    22,    24,    24,    23,    23,    22,
     &     23,    24,    24,    23,    24,    24,    24,    25,
     &     26,    26,    26,    26,    25,    25,    24,    24,
     &     25,    25,    25,    24,    25,    26,    26,    26,
     &     26,    27,    28,    29,    28,    28,    28,    29,
     &     31,    31,    31,    32,    32,    32,    31,    32,
     &     29,    29,    29,    29,    31,    31,    32,    34,
     &     35,    36,    37,    39,    38,    40,    40,    41,
     &     42,    42,    43,    43,    43,    44,    42,    42,
     &     43,    43,    44,    44,    43,    42,    44,    45,
     &     45,    46,    45,    46,    45,    47,    46,    47,
     &     47,    47,    46,    46,    46,    47,    48,    48,
     &     46,    46,    48,    48,    45,    44,    45,    46,
     &     45,    45,    43,    42,    43,    45,    44,    43,
     &     42,    43,    43,    44,    44,    45,    46,    46,
     &     48,    47,    48,    48,    48,    49,    49,    49,
     &     50,    50,    50,    50,    50,    49,    48,    48,
     &     45,    49,    50,    51,    54,    53,    51,    52,
     &     52,    54,    56,    55,    53,    52,    54,    54,
     &     57,    58,    59,    57,    57,    57,    59,    58,
     &     58,    58,    56,    55,    54,    54,    53,    53,
     &     52,    51,    51,    53,    52,    51,    51,    51,
     &     50,    52,    50,    51,    49,    50,    50,    48,
     &     50,    52,    55,    57,    55,    58,    58,    58,
     &     57,    57,    54,    54,    55,    59,    61,    61,
     &     61,    60,    64,    63,    65,    66,    67,    67,
     &     67,    67,    68,    68,    68,    67,    69,    71,
     &     69,    71,    73,    72,    71,    73,    74,    75,
     &     76,    77,    77,    79,    79,    82,    83,    85,
     &     84,    88,    85,    83,    83,    84,    85,    85,
     &     85,    81,    79,    78,    77,    74,    75,    74,
     &     73,    75,    75,    74,    73,    73,    74,    71,
     &     69,    67,    67,    69,    70,    71,    71,    72,
     &     73,    74,    74,    74,    75,    76,    77,    80,
     &     81,    80,    82,    81,    81,    81,    82,    82,
     &     82,    80,    83,    85,    82,    83,    84,    83,
     &     81,    84,    85,    85,    84,    85,    86,    87,
     &     87,    91,    90,    90,    90,    93,    91,    90,
     &     92,    92,    93,    92,    93,    96,   100,   102,
     &    104,   103,   102,   105,   106,   105,   104,   108,
     &    106,   103,   103,   106,   107,   108,   108,   106/
      Data (writetable(i),i=   47201,   47313)/
     &    107,   104,   103,   103,   100,   100,   101,   102,
     &    104,   102,   101,   100,   100,   101,    99,    99,
     &    100,   101,   101,   106,   106,   103,   104,   105,
     &    105,   106,   102,   103,   107,   106,   108,   108,
     &    109,   109,   110,   111,   111,   112,   112,   114,
     &    113,   113,   119,   122,   130,   132,   134,   136,
     &    139,   139,   138,   140,   145,   148,   153,   155,
     &    158,   158,   162,   164,   169,   175,   178,   179,
     &    177,   179,   179,   181,   182,   180,   181,   179,
     &    178,   179,   182,   183,   186,   187,   187,   186,
     &    185,   188,   188,   188,   190,   191,   190,   190,
     &    190,   190,   190,   195,   196,   197,   197,   199,
     &    199,   202,   202,   205,   200,   201,   198,   198,
     &    200,
     &    199,
     &    199,
     &    201,
     &    199,
     &    203,
     &    202,
     &    204,
     &    204/
c
      A2000_HGG_BACKG = 0.
      dsqrts = Dble(sqrts)
      If (first) then           ! Lecture des bruits de fond
        first = .FALSE.
c
        ind = 0
        Do i=1,9
          Do j=1,7
            Do k=1,751
              ind = ind + 1
              tablebkg(k,j,i) = writetable(ind)
            Enddo
          Enddo
        Enddo
      Endif
c
      If (mhiggs.lt.mhmin) return
      Bkg = 0.
      errBkg = 0.
      Do ibkg=1,nback           ! Boucle sur tous les bruits de fond
c
        Do i=1,necms-1
          If (sqrts.ge.ecms(i) .and. sqrts.le.(ecms(i+1))) then
            j1 = i
            j2 = i + 1
          Endif
        Enddo
 10     If (genmc(ibkg,j1).gt.0) goto 11
        j1 = j1 - 1
        If (j1.eq.0) STOP 10
        goto 10
 11     If (genmc(ibkg,j2).gt.0) goto 12
        j2 = j2 + 1
        If (j2.eq.necms+1) STOP 11
        goto 11
 12     CONTINUE
C
        im1 = INT((mhiggs-mhmin)/stepmh+0.1) + 1
        m1  = mhmin + stepmh*Real(im1-1)
        im2 = im1 + 1
        m2  = m1 + stepmh
C
ccccccccccccccccccccccccccccccccc
        tmp1 = Real(tablebkg(im1,ibkg,j1))
        tmp2 = Real(genmc(ibkg,j1))
        b1 = tmp1/tmp2
        errb1 = 0.
        If (tmp1.ne.0.) errb1 = sqrt( (tmp2-tmp1)/(tmp2*tmp1) )
        tmp1 = Real(tablebkg(im2,ibkg,j1))
        b2 = tmp1/tmp2
        errb2 = 0.
        If (tmp1.ne.0.) errb2 = sqrt( (tmp2-tmp1)/(tmp2*tmp1) )
        b  = b1*(m2-mhiggs) + b2*(mhiggs-m1) ! Pour le premier centre de masse
        b  = b / (m2-m1)
        errb  = errb1*(m2-mhiggs) + errb2*(mhiggs-m1) ! Pour le premier centre de masse
        errb  = errb / (m2-m1)
ccccccccccccccccccccccccccccccccc
        tmp1 = Real(tablebkg(im1,ibkg,j2))
        tmp2 = Real(genmc(ibkg,j2))
        bb1 = tmp1/tmp2
        errbb1 = 0.
        If (tmp1.ne.0.) errbb1 = sqrt( (tmp2-tmp1)/(tmp2*tmp1) )
        tmp1 = Real(tablebkg(im2,ibkg,j2))
        bb2 = tmp1/tmp2
        errbb2 = 0.
        If (tmp1.ne.0.) errbb2 = sqrt( (tmp2-tmp1)/(tmp2*tmp1) )
        bb  = bb1*(m2-mhiggs) + bb2*(mhiggs-m1) ! Pour le premier centre de masse
        bb  = bb / (m2-m1)
        errbb  = errbb1*(m2-mhiggs) + errbb2*(mhiggs-m1) ! Pour le premier centre de masse
        errbb  = errbb / (m2-m1)
c
        bkgpart = b*(ecms(j2)-sqrts) + bb*(sqrts-ecms(j1))
        bkgpart = bkgpart / (ecms(j2)-ecms(j1))
        errpart = errb*(ecms(j2)-sqrts) + errbb*(sqrts-ecms(j1))
        errpart = errpart / (ecms(j2)-ecms(j1))
c
 13     continue
        If (ibkg.eq.1) bkgpart = bkgpart*Real(al_xsect_ww(dsqrts))
        If (ibkg.eq.2) bkgpart = bkgpart*Real(al_xsect_zz(dsqrts))
        If (ibkg.eq.3) bkgpart = bkgpart*Real(al_xsect_bb(dsqrts))
        If (ibkg.eq.4) bkgpart = bkgpart*Real(al_xsect_cc(dsqrts))
        If (ibkg.eq.5) bkgpart = bkgpart*Real(al_xsect_dd(dsqrts))
        If (ibkg.eq.6) bkgpart = bkgpart*Real(al_xsect_ss(dsqrts))
        If (ibkg.eq.7) bkgpart = bkgpart*Real(al_xsect_uu(dsqrts))
c
        Bkg = Bkg + bkgpart
        errbkg = errbkg + (bkgpart*errpart)**2
      Enddo
      If (bkg.eq.0.) errbkg = 0.
      If (bkg.ne.0.) errbkg = sqrt(errbkg)/Bkg
      If (.not.err) A2000_HGG_BACKG = Bkg
      If (err) A2000_HGG_BACKG = errbkg
      goto 999
 998  Print*,'Probleme avec le fichier ',file
      STOP
 999  RETURN
      END
      INTEGER FUNCTION A2000_HGG_CAND(mhiggs,jch,debug)
c================ for NEUTRAL Higgs searches ==============
c jch  BinName    Emin      Emax       nbins   L (/pb)
c ==========================================================
c  1    201.3    199.00    203.50        45   3.30949
c  2    204.0    203.50    204.50        10   7.05354
c  3    205.0    204.50    205.50        10  72.06574
c  4    205.8    205.50    206.10         6   3.28531
c  5    206.5    206.10    206.80         7 115.91679
c  6    207.3    206.80    207.80        10   7.02231
c  7    208.2    207.80    208.50         7   7.39627
c  8    209.0    208.50    210.00        15   0.09067
c ==========================================================
c Results
c   ecms       201.3  204.0  205.0  205.8  206.5  207.3  208.2  209.0
c   40    2    2    6    1   10    0    1
c   41    2    3    9    1   12    0    0
c   42    1    2   10    1   12    0    0
c   43    1    3   10    1   13    0    0
c   44    0    3   10    1   14    0    0
c   45    0    3    6    1   17    0    0
c   46    0    3    9    1   14    0    1
c   47    1    1   10    0   13    0    1
c   48    2    2    9    0   16    0    1
c   49    2    1   11    0   18    0    1
c   50    2    1   14    0   20    0    2
c   51    2    2   16    0   21    1    2
c   52    1    2   16    0   27    1    1
c   53    1    2   18    1   26    1    1
c   54    1    2   19    1   28    1    1
c   55    1    2   17    1   27    1    1
c   56    0    2   18    1   25    0    1
c   57    0    1   14    1   25    0    0
c   58    0    1   13    1   18    0    0
c   59    0    2   15    2   13    0    0
c   60    0    3   17    2   14    0    0
c   61    0    1   16    1   15    0    0
c   62    0    1   16    1   19    0    0
c   63    0    3   13    1   20    0    0
c   64    0    3   13    1   25    0    0
c   65    0    2   12    1   31    0    0
c   66    0    2   12    1   31    0    0
c   67    1    3   12    1   28    2    0
c   68    1    3   17    1   29    2    0
c   69    1    3   19    1   23    2    1
c   70    1    3   18    1   23    2    1
c   71    1    2   19    2   23    2    0
c   72    1    3   23    2   26    3    1
c   73    1    2   27    2   27    3    2
c   74    2    2   32    2   34    2    2
c   75    1    2   32    2   35    2    2
c   76    2    1   29    2   37    3    3
c   77    2    3   32    1   38    2    4
c   78    3    6   38    1   47    2    3
c   79    5    5   42    1   53    2    3
c   80    3    7   46    0   64    3    3
c   81    3    6   41    1   59    3    4
c   82    3    7   40    1   58    3    4
c   83    2    5   39    2   60    3    4
c   84    1    5   34    2   53    1    3
c   85    1    3   36    2   51    1    4
c   86    3    3   38    3   51    1    4
c   87    2    3   38    3   51    1    2
c   88    2    5   35    3   48    1    1
c   89    2    5   34    3   48    1    1
c   90    2    5   34    2   44    1    0
c   91    2    5   30    2   44    0    0
c   92    2    6   33    2   43    2    1
c   93    2    6   29    3   43    3    1
c   94    2    6   33    3   50    2    2
c   95    2    6   28    2   52    2    2
c   96    1    4   26    2   47    3    2
c   97    1    3   26    2   44    4    2
c   98    1    2   23    2   47    4    2
c   99    1    2   23    0   42    2    1
c  100    1    1   18    0   38    2    3
c  101    0    2   20    0   39    3    3
c  102    0    3   19    0   38    2    3
c  103    0    3   18    0   38    1    4
c  104    0    2   16    0   37    1    4
c  105    0    2   14    0   37    1    2
c  106    0    2    9    0   31    0    2
c  107    0    2    7    1   27    0    1
c  108    0    2    9    1   27    1    1
c  109    0    2    9    1   29    1    0
c  110    0    1   11    1   31    2    0
c  111    0    2   10    1   26    2    0
c  112    0    1    8    1   26    2    0
c  113    0    1    4    1   24    3    0
c  114    0    1    3    2   23    3    0
c  115    0    1    3    1   22    3    0
      Implicit none
      Real mhiggs
      Integer jch
      Include 'a_2000_vars.inc'
c
      Character*50 leFILE
      data leFILE /'data300new_100mev_allmh_bis.txt'/
      Logical first
      Data first /.TRUE./
      Integer imax
      Parameter (imax=1000000)
      Real mh,sqrts
c
      Integer i,j,idc,indmh,krun,kevt
      Real ecmtemp1,ecmtemp2
      Real xd1,xd2,rmass
      Integer imass,jmass
      Logical debug
c
      Real mhmin,mhmax,stepmh
      Parameter (mhmin = 40E0 , stepmh = 0.1E0)
      Integer nmhmax
      Parameter (nmhmax = 1000)
      Integer ncand(nmhmax,nbinsmax)
      Save ncand,mhmax
c
      If (first) then
        first = .FALSE.
        OPEN(UNIT=97,STATUS='old',FILE=leFILE,ERR=998) 
        Do i=1,nmhmax
          Do j=1,n_ebins_2000
            ncand(i,j) = 0
          Enddo
        Enddo
c
        mhmax = -10E0
        Do i=1,imax
          Read(97,501,END=990)mh,sqrts,krun,kevt ! Lit le premier candidat, selectionne par l''analyse mh
          If (mh.gt.mhmax) then
            mhmax = mh
          Endif
 501      FORMAT(2F10.4,2I8)
          indmh = INT((mh-mhmin)/stepmh  + 1.1)
          Do idc=1,n_ebins_2000
            ecmtemp1 = 199.+(0.1*(ilow_energy(idc)-1))
            ecmtemp2 = 199.+(0.1*ihigh_energy(idc))
            If (sqrts.ge.ecmtemp1 .and. sqrts.le.ecmtemp2)
     &           then
              ncand(indmh,idc) = ncand(indmh,idc) + 1
              goto 10
            Endif
          enddo
 10       CONTINUE
        Enddo
      Endif
c
 990  CONTINUE
c
      If (mhiggs.lt.mhmin .or. mhiggs.gt.mhmax) then
        A2000_HGG_CAND = 0
        Return
      Endif
c
      imass = int( (mhiggs-mhmin)/stepmh ) + 1
      If (imass.le.0) stop 112
      if (mhiggs.eq.mhmax) then
        A2000_HGG_CAND = ncand(imass,jch)
        return
      Endif
c
      jmass = imass + 1
      rmass = mhiggs - (mhmin+Real(imass-1)*stepmh)
c
      If ( mh*10. - Real(INT(mh*10.)) .ne.0. .and.debug) then
        Print*,
     &'Warning : Number of data is interpolated !!! (A2000_HGG_CAND)'
      Endif
c
      xd1 = Real(ncand(imass,jch))
      xd2 = Real(ncand(jmass,jch))
      A2000_HGG_CAND = INT( xd1+(xd2-xd1)*rmass / stepmh + 0.5)
ccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      goto 999
 998  Print*,'Probleme avec le fichier data300new.txt'
      STOP
 999  RETURN
      END
      Real FUNCTION A189_HLL_HGG_EFF(amass)
      implicit none
      integer i,nmas
      parameter (nmas=20)
      real hmass(nmas),effi(nmas)
      real eff,eff1,eff2,del1,del2,amass
c
      data hmass /60.,65.,70.,75.,80.,85.,90.,95.,100.,101.,102.,103.
     &     ,104.,105.,106.,107.,108.,109.,109.01,115./
      data effi  /80.81,83.12,83.23,83.15,83.38,82.71,81.79,80.76,58.23
     &     ,54.20,48.10,42.00,36.00,28.46,25.44,20.97,16.50,12.00,00.01
     &     ,00.01/
      A189_HLL_HGG_EFF = 0.
      If (amass.lt.hmass(1))    return
      If (amass.gt.hmass(nmas)) return
      Do i=2,nmas
        If (amass.le.hmass(i)) then
            eff1 = effi(i-1)
            eff2 = effi(i)
            del1 = amass - hmass(i-1)
            del2 = hmass(i) - amass
            goto 1000
         endif
      Enddo
 1000 continue
      eff = (eff1*del2 + eff2*del1) / (del1 + del2)
      A189_HLL_HGG_EFF = max(eff,0.) / 100.
      RETURN 
      END
      Real FUNCTION A99_HLL_HGG_EFF(amass,iana)
      Implicit none
      Real amass
      Integer iana
      Real A192_HLL_HGG_EFF,A196_HLL_HGG_EFF,A200_HLL_HGG_EFF
     &     ,A202_HLL_HGG_EFF
      External A192_HLL_HGG_EFF,A196_HLL_HGG_EFF,A200_HLL_HGG_EFF
     &     ,A202_HLL_HGG_EFF
      If (iana.eq.3) A99_HLL_HGG_EFF = A192_HLL_HGG_EFF(amass)
      If (iana.eq.4) A99_HLL_HGG_EFF = A196_HLL_HGG_EFF(amass)
      If (iana.eq.5) A99_HLL_HGG_EFF = A200_HLL_HGG_EFF(amass)
      If (iana.eq.6) A99_HLL_HGG_EFF = A202_HLL_HGG_EFF(amass)
      RETURN
      END
      Real FUNCTION A192_HLL_HGG_EFF(amass)
      implicit none
      integer i,nmas
      parameter (nmas=23)
      real hmass(nmas),effi(nmas)
      real eff,eff1,eff2,del1,del2,amass
c
      data hmass /60.,65.,70.,75.,80.,85.,90.,95.,100.,101.,102.,103.
     &     ,104.,105.,106.,107.,108.,109.,110.,111.,112.,112.01,115./
      data effi  /80.38,82.87,83.27,83.09,82.88,83.19,82.72,81.59,75.63
     &     ,70.07,63.35,56.64,49.93,43.11,36.96,30.70,25.88,21.05,16.23
     &     ,13.39,10.55,0.01,0.01/
      A192_HLL_HGG_EFF = 0.
      If (amass.lt.hmass(1))    return
      If (amass.gt.hmass(nmas)) return
      Do i=2,nmas
        If (amass.le.hmass(i)) then
            eff1 = effi(i-1)
            eff2 = effi(i)
            del1 = amass - hmass(i-1)
            del2 = hmass(i) - amass
            goto 1000
         endif
      Enddo
 1000 continue
      eff = (eff1*del2 + eff2*del1) / (del1 + del2)
      A192_HLL_HGG_EFF = max(eff,0.) / 100.
      RETURN 
      END
      Real FUNCTION A196_HLL_HGG_EFF(amass)
      implicit none
      integer i,nmas
      parameter (nmas=20)
      real hmass(nmas),effi(nmas)
      real eff,eff1,eff2,del1,del2,amass
c
      data hmass /60.,65.,70.,75.,80.,85.,90.,95.,100.,105.,106.,107.
     &     ,108.,109.,110.,111.,112.,113.,114.,115./
      data effi  /80.66,82.58,82.15,82.74,83.57,82.55,82.01,82.36,80.10
     &     ,68.48,62.84,55.71,49.10,42.48,35.87,30.96,26.04,21.13,16.22
     &     ,11.30/
      A196_HLL_HGG_EFF = 0.
      If (amass.lt.hmass(1))    return
      If (amass.gt.hmass(nmas)) return
      Do i=2,nmas
        If (amass.le.hmass(i)) then
            eff1 = effi(i-1)
            eff2 = effi(i)
            del1 = amass - hmass(i-1)
            del2 = hmass(i) - amass
            goto 1000
         endif
      Enddo
 1000 continue
      eff = (eff1*del2 + eff2*del1) / (del1 + del2)
      A196_HLL_HGG_EFF = max(eff,0.) / 100.
      RETURN 
      END
      Real FUNCTION A200_HLL_HGG_EFF(amass)
      implicit none
      integer i,nmas
      parameter (nmas=20)
      real hmass(nmas),effi(nmas)
      real eff,eff1,eff2,del1,del2,amass
c
      data hmass /60.,65.,70.,75.,80.,85.,90.,95.,100.,105.,106.,107.
     &     ,108.,109.,110.,111.,112.,113.,114.,115./
      data effi  /80.34,82.73,83.96,83.43,83.46,83.57,83.50,83.67,82.85
     &     ,80.69,80.16,78.96,73.10,67.23,61.37,55.00,48.60,42.21,35.83
     &     ,29.45/
      A200_HLL_HGG_EFF = 0.
      If (amass.lt.hmass(1))    return
      If (amass.gt.hmass(nmas)) return
      Do i=2,nmas
        If (amass.le.hmass(i)) then
            eff1 = effi(i-1)
            eff2 = effi(i)
            del1 = amass - hmass(i-1)
            del2 = hmass(i) - amass
            goto 1000
         endif
      Enddo
 1000 continue
      eff = (eff1*del2 + eff2*del1) / (del1 + del2)
      A200_HLL_HGG_EFF = max(eff,0.) / 100.
      RETURN 
      END
      Real FUNCTION A202_HLL_HGG_EFF(amass)
      implicit none
      integer i,nmas
      parameter (nmas=16)
      real hmass(nmas),effi(nmas)
      real eff,eff1,eff2,del1,del2,amass
c
      data hmass /60.,65.,70.,75.,80.,85.,90.,95.,100.,105.,110.,111.
     &     ,112.,113.,114.,115./
      data effi  /79.34,82.34,83.61,82.48,84.60,82.79,83.54,83.09,82.84
     &     ,81.42,75.70,68.76,61.85,54.93,48.01,41.10/
      A202_HLL_HGG_EFF = 0.
      If (amass.lt.hmass(1))    return
      If (amass.gt.hmass(nmas)) return
      Do i=2,nmas
        If (amass.le.hmass(i)) then
            eff1 = effi(i-1)
            eff2 = effi(i)
            del1 = amass - hmass(i-1)
            del2 = hmass(i) - amass
            goto 1000
         endif
      Enddo
 1000 continue
      eff = (eff1*del2 + eff2*del1) / (del1 + del2)
      A202_HLL_HGG_EFF = max(eff,0.) / 100.
      RETURN 
      END
      Real FUNCTION A189_HVV_HGG_EFF(amass)
      Implicit none
      Real amass
      Real effbb189_hvv,effcc189_hvv,effgg189_hvv
      External effbb189_hvv,effcc189_hvv,effgg189_hvv
c
      Integer j
      Real effmin,eff(3)
c
      eff(1) = effbb189_hvv(amass)
      eff(2) = effcc189_hvv(amass)
      eff(3) = effgg189_hvv(amass)
      effmin = 1000.
      Do j=1,3
        If (eff(j).ne.0. .and. eff(j).lt.effmin) effmin = eff(j)
      Enddo
      If (effmin.eq.1000.) effmin = 0.
      A189_HVV_HGG_EFF = effmin
      RETURN
      END
c
      Real function effbb189_hvv(x)
      implicit none
      real xmh(8),x,corbb189
      real eh(8)
      data xmh /74.5,75.,80.,85.,90.,95.,97.5,98./
c      data eh /0.,0.490,0.527,0.580,0.472,0.394,0.260,0./ ! + fusion
      data eh /0.,0.497,0.539,0.598,0.496,0.437,0.307,0./

      corbb189 = 0.
      if (x.lt.xmh(1)) then
         effbb189_hvv = 0.
      elseif (x.gt.xmh(1).and.x.le.xmh(2)) then
         effbb189_hvv = ((eh(2)-eh(1))*x+(eh(1)*xmh(2)-eh(2)*xmh(1)))
     .           /(xmh(2)-xmh(1))
         corbb189 = 0.05-0.1/(xmh(2)-xmh(1))*abs(x-(xmh(2)+xmh(1))/2.)
      elseif (x.gt.xmh(2).and.x.le.xmh(3)) then
         effbb189_hvv = ((eh(3)-eh(2))*x+(eh(2)*xmh(3)-eh(3)*xmh(2)))
     .           /(xmh(3)-xmh(2))
         corbb189 = 0.05-0.1/(xmh(3)-xmh(2))*abs(x-(xmh(3)+xmh(2))/2.)
      elseif (x.gt.xmh(3).and.x.le.xmh(4)) then
         effbb189_hvv = ((eh(4)-eh(3))*x+(eh(3)*xmh(4)-eh(4)*xmh(3)))
     .           /(xmh(4)-xmh(3))
         corbb189 = 0.05-0.1/(xmh(4)-xmh(3))*abs(x-(xmh(4)+xmh(3))/2.)
      elseif (x.gt.xmh(4).and.x.le.xmh(5)) then
         effbb189_hvv = ((eh(5)-eh(4))*x+(eh(4)*xmh(5)-eh(5)*xmh(4)))
     .           /(xmh(5)-xmh(4))
         corbb189 = 0.05-0.1/(xmh(5)-xmh(4))*abs(x-(xmh(5)+xmh(4))/2.)
      elseif (x.gt.xmh(5).and.x.le.xmh(6)) then
         effbb189_hvv = ((eh(6)-eh(5))*x+(eh(5)*xmh(6)-eh(6)*xmh(5)))
     .           /(xmh(6)-xmh(5))
         corbb189 = 0.05-0.1/(xmh(6)-xmh(5))*abs(x-(xmh(6)+xmh(5))/2.)
      elseif (x.gt.xmh(6).and.x.le.xmh(7)) then
         effbb189_hvv = ((eh(7)-eh(6))*x+(eh(6)*xmh(7)-eh(7)*xmh(6)))
     .           /(xmh(7)-xmh(6))
      elseif (x.gt.xmh(7).and.x.le.xmh(8)) then
         effbb189_hvv = ((eh(8)-eh(7))*x+(eh(7)*xmh(8)-eh(8)*xmh(7)))
     .           /(xmh(8)-xmh(7))
      elseif (x.gt.xmh(8)) then
         effbb189_hvv = 0.
      endif
      effbb189_hvv = 0.98*(effbb189_hvv-corbb189)
      end

      Real function effcc189_hvv(x)
      Implicit none
      real xmh(13),x
      real eh(13)
c
c Avant le sliding (analyse basse/haute masse)
c
c      data xmh /59.9,60.,65.,70.,75.,80.,82.,85.,90.,95.,100.,100.1/
c      data eh  /0.,0.612,0.670,0.621,0.463,0.239,
c     .          0.158,0.283,0.554,0.530,0.291,0./
c
c Sliding 
c
      data xmh /59.9,60.,65.,70.,75.,80,85.,88.,
     .               90.,92.,95.,100.,100.1/
      data eh  /0.,0.542,0.613,0.561,0.426,0.488,0.555,0.517,
     .          0.51,0.474,0.411,0.205,0./

      if (x.lt.xmh(1)) then
         effcc189_hvv = 0.
      elseif (x.gt.xmh(1).and.x.le.xmh(2)) then
         effcc189_hvv = ((eh(2)-eh(1))*x+(eh(1)*xmh(2)-eh(2)*xmh(1)))
     .           /(xmh(2)-xmh(1))
      elseif (x.gt.xmh(2).and.x.le.xmh(3)) then
         effcc189_hvv = ((eh(3)-eh(2))*x+(eh(2)*xmh(3)-eh(3)*xmh(2)))
     .           /(xmh(3)-xmh(2))
      elseif (x.gt.xmh(3).and.x.le.xmh(4)) then
         effcc189_hvv = ((eh(4)-eh(3))*x+(eh(3)*xmh(4)-eh(4)*xmh(3)))
     .           /(xmh(4)-xmh(3))
      elseif (x.gt.xmh(4).and.x.le.xmh(5)) then
         effcc189_hvv = ((eh(5)-eh(4))*x+(eh(4)*xmh(5)-eh(5)*xmh(4)))
     .           /(xmh(5)-xmh(4))
      elseif (x.gt.xmh(5).and.x.le.xmh(6)) then
c         effcc189_hvv = ((eh(6)-eh(5))*x+(eh(5)*xmh(6)-eh(6)*xmh(5)))
c     .           /(xmh(6)-xmh(5))
         effcc189_hvv = 68.064-1.7594*x+0.11433E-01*x**2
      elseif (x.gt.xmh(6).and.x.le.xmh(7)) then
         effcc189_hvv = ((eh(7)-eh(6))*x+(eh(6)*xmh(7)-eh(7)*xmh(6)))
     .           /(xmh(7)-xmh(6))
         effcc189_hvv = 65.771-1.5984*x+0.97795E-02*x**2
      elseif (x.gt.xmh(7).and.x.le.xmh(8)) then
         effcc189_hvv = ((eh(8)-eh(7))*x+(eh(7)*xmh(8)-eh(8)*xmh(7)))
     .           /(xmh(8)-xmh(7))
      elseif (x.gt.xmh(8).and.x.le.xmh(9)) then
         effcc189_hvv = ((eh(9)-eh(8))*x+(eh(8)*xmh(9)-eh(9)*xmh(8)))
     .           /(xmh(9)-xmh(8))
      elseif (x.gt.xmh(9).and.x.le.xmh(10)) then
         effcc189_hvv = ((eh(10)-eh(9))*x+(eh(9)*xmh(10)-eh(10)*xmh(9)))
     .           /(xmh(10)-xmh(9))
      elseif (x.gt.xmh(10).and.x.le.xmh(11)) then
        effcc189_hvv = ((eh(11)-eh(10))*x+(eh(10)*xmh(11)-eh(11)*xmh(10)
     &       ))/(xmh(11)-xmh(10))
      elseif (x.gt.xmh(11).and.x.le.xmh(12)) then
        effcc189_hvv = ((eh(12)-eh(11))*x+(eh(11)*xmh(12)-eh(12)*xmh(11)
     &       ))/(xmh(12)-xmh(11))
      elseif (x.gt.xmh(12).and.x.le.xmh(13)) then
        effcc189_hvv = ((eh(13)-eh(12))*x+(eh(12)*xmh(13)-eh(13)*xmh(12)
     &       ))/(xmh(13)-xmh(12))
      elseif (x.gt.xmh(13)) then
         effcc189_hvv = 0.
      endif
      effcc189_hvv = 0.98*effcc189_hvv
      end
      Real function effgg189_hvv(x)
      Implicit none
      real xmh(13),x
      real eh(13)
c
c Avant le sliding (analyse basse/haute masse)
c
c      data xmh /59.5,60.,65.,70.,75.,80.,82.,85.,90.,95.,100.,100.5/
c      data eh  /0.,0.498,0.655,0.626,0.451,0.191,
c     .          0.128,0.231,0.563,0.484,0.274,0./
c
c Sliding 
c
      data xmh /59.9,60.,65.,70.,75.,80.,85.,88.,
     .               90.,92.,95.,100.,100.1/
      data eh  /0.,0.426,0.569,0.544,0.395,0.453,0.553,0.508,
     .          0.527,0.515,0.395,0.195,0./

      if (x.lt.xmh(1)) then
         effgg189_hvv = 0.
      elseif (x.gt.xmh(1).and.x.le.xmh(2)) then
         effgg189_hvv = ((eh(2)-eh(1))*x+(eh(1)*xmh(2)-eh(2)*xmh(1)))
     .           /(xmh(2)-xmh(1))
      elseif (x.gt.xmh(2).and.x.le.xmh(3)) then
         effgg189_hvv = ((eh(3)-eh(2))*x+(eh(2)*xmh(3)-eh(3)*xmh(2)))
     .           /(xmh(3)-xmh(2))
      elseif (x.gt.xmh(3).and.x.le.xmh(4)) then
         effgg189_hvv = ((eh(4)-eh(3))*x+(eh(3)*xmh(4)-eh(4)*xmh(3)))
     .           /(xmh(4)-xmh(3))
      elseif (x.gt.xmh(4).and.x.le.xmh(5)) then
         effgg189_hvv = ((eh(5)-eh(4))*x+(eh(4)*xmh(5)-eh(5)*xmh(4)))
     .           /(xmh(5)-xmh(4))
      elseif (x.gt.xmh(5).and.x.le.xmh(6)) then
c         effgg189_hvv = ((eh(6)-eh(5))*x+(eh(5)*xmh(6)-eh(6)*xmh(5)))
c     .           /(xmh(6)-xmh(5))
         effgg189_hvv =  122.58-3.1665*x+0.20497E-01*x**2
      elseif (x.gt.xmh(6).and.x.le.xmh(7)) then
c         effgg189_hvv = ((eh(7)-eh(6))*x+(eh(6)*xmh(7)-eh(7)*xmh(6)))
c     .           /(xmh(7)-xmh(6))
         effgg189_hvv =  103.83-2.5286*x+0.15454E-01*x**2
      elseif (x.gt.xmh(7).and.x.le.xmh(8)) then
         effgg189_hvv = ((eh(8)-eh(7))*x+(eh(7)*xmh(8)-eh(8)*xmh(7)))
     .           /(xmh(8)-xmh(7))
      elseif (x.gt.xmh(8).and.x.le.xmh(9)) then
         effgg189_hvv = ((eh(9)-eh(8))*x+(eh(8)*xmh(9)-eh(9)*xmh(8)))
     .           /(xmh(9)-xmh(8))
      elseif (x.gt.xmh(9).and.x.le.xmh(10)) then
         effgg189_hvv = ((eh(10)-eh(9))*x+(eh(9)*xmh(10)-eh(10)*xmh(9)))
     .           /(xmh(10)-xmh(9))
      elseif (x.gt.xmh(10).and.x.le.xmh(11)) then
        effgg189_hvv = ((eh(11)-eh(10))*x+(eh(10)*xmh(11)-eh(11)*xmh(10)
     &       ))/(xmh(11)-xmh(10))
      elseif (x.gt.xmh(11).and.x.le.xmh(12)) then
        effgg189_hvv = ((eh(12)-eh(11))*x+(eh(11)*xmh(12)-eh(12)*xmh(11)
     &       ))/(xmh(12)-xmh(11))
      elseif (x.gt.xmh(12).and.x.le.xmh(13)) then
        effgg189_hvv = ((eh(13)-eh(12))*x+(eh(12)*xmh(13)-eh(13)*xmh(12)
     &       ))/(xmh(13)-xmh(12))
      elseif (x.gt.xmh(13)) then
         effgg189_hvv = 0.
      endif
      effgg189_hvv = 0.98*effgg189_hvv
      end
c
      Real FUNCTION A192_HVV_HGG_EFF(amass)
      Implicit none
      Real amass
      Real effbb192_hvv,effcc192_hvv,effgg192_hvv
      External effbb192_hvv,effcc192_hvv,effgg192_hvv
c
      Integer j
      Real effmin,eff(3)
c
      eff(1) = effbb192_hvv(amass)
      eff(2) = effcc192_hvv(amass)
      eff(3) = effgg192_hvv(amass)
      effmin = 1000.
      Do j=1,3
        If (eff(j).ne.0. .and. eff(j).lt.effmin) effmin = eff(j)
      Enddo
      If (effmin.eq.1000.) effmin = 0.
      A192_HVV_HGG_EFF = effmin
      RETURN
      END
c
      Real function effbb192_hvv(x)
      Implicit none
      real xmh(12),x
      real eh(12)
      data xmh /59.5,60.,65.,70.,75.,80.,85.,90.,95.,100.,105.,105.5/
c      data eh /0.,0.,0.,0.,0.007,0.027,0.116,0.369,0.373,0.18,0.146,0./  ! + fusion
      data eh /0.,0.,0.,0.003,0.008,0.029,
     .           0.132,0.394,0.413,0.186,0.161,0./

      if (x.lt.xmh(1)) then
         effbb192_hvv = 0.
      elseif (x.gt.xmh(1).and.x.le.xmh(2)) then
         effbb192_hvv = ((eh(2)-eh(1))*x+(eh(1)*xmh(2)-eh(2)*xmh(1)))
     .           /(xmh(2)-xmh(1))
      elseif (x.gt.xmh(2).and.x.le.xmh(3)) then
         effbb192_hvv = ((eh(3)-eh(2))*x+(eh(2)*xmh(3)-eh(3)*xmh(2)))
     .           /(xmh(3)-xmh(2))
      elseif (x.gt.xmh(3).and.x.le.xmh(4)) then
         effbb192_hvv = ((eh(4)-eh(3))*x+(eh(3)*xmh(4)-eh(4)*xmh(3)))
     .           /(xmh(4)-xmh(3))
      elseif (x.gt.xmh(4).and.x.le.xmh(5)) then
         effbb192_hvv = ((eh(5)-eh(4))*x+(eh(4)*xmh(5)-eh(5)*xmh(4)))
     .           /(xmh(5)-xmh(4))
      elseif (x.gt.xmh(5).and.x.le.xmh(6)) then
         effbb192_hvv = ((eh(6)-eh(5))*x+(eh(5)*xmh(6)-eh(6)*xmh(5)))
     .           /(xmh(6)-xmh(5))
      elseif (x.gt.xmh(6).and.x.le.xmh(7)) then
         effbb192_hvv = ((eh(7)-eh(6))*x+(eh(6)*xmh(7)-eh(7)*xmh(6)))
     .           /(xmh(7)-xmh(6))
      elseif (x.gt.xmh(7).and.x.le.xmh(8)) then
         effbb192_hvv = ((eh(8)-eh(7))*x+(eh(7)*xmh(8)-eh(8)*xmh(7)))
     .           /(xmh(8)-xmh(7))
      elseif (x.gt.xmh(8).and.x.le.xmh(9)) then
         effbb192_hvv = ((eh(9)-eh(8))*x+(eh(8)*xmh(9)-eh(9)*xmh(8)))
     .           /(xmh(9)-xmh(8))
      elseif (x.gt.xmh(9).and.x.le.xmh(10)) then
         effbb192_hvv = ((eh(10)-eh(9))*x+(eh(9)*xmh(10)-eh(10)*xmh(9)))
     .           /(xmh(10)-xmh(9))
      elseif (x.gt.xmh(10).and.x.le.xmh(11)) then
        effbb192_hvv = ((eh(11)-eh(10))*x+(eh(10)*xmh(11)-eh(11)*xmh(10)
     &       ))/(xmh(11)-xmh(10))
      elseif (x.gt.xmh(11).and.x.le.xmh(12)) then
        effbb192_hvv = ((eh(12)-eh(11))*x+(eh(11)*xmh(12)-eh(12)*xmh(11)
     &       ))/(xmh(12)-xmh(11))
      elseif (x.gt.xmh(12)) then
         effbb192_hvv = 0.
      endif
      effbb192_hvv = 0.98*effbb192_hvv
      end
      Real function effcc192_hvv(x)
      Implicit none
      real xmh(11),x
      real eh(11)
      data xmh /59.5,60.,65.,70.,75.,80.,85.,90.,95.,100.,100.5/
      data eh  /0.,0.,0.,0.,0.01,0.031,0.138,0.411,0.403,0.17,0./
      if (x.lt.xmh(1)) then
         effcc192_hvv = 0.
      elseif (x.gt.xmh(1).and.x.le.xmh(2)) then
         effcc192_hvv = ((eh(2)-eh(1))*x+(eh(1)*xmh(2)-eh(2)*xmh(1)))
     .           /(xmh(2)-xmh(1))
      elseif (x.gt.xmh(2).and.x.le.xmh(3)) then
         effcc192_hvv = ((eh(3)-eh(2))*x+(eh(2)*xmh(3)-eh(3)*xmh(2)))
     .           /(xmh(3)-xmh(2))
      elseif (x.gt.xmh(3).and.x.le.xmh(4)) then
         effcc192_hvv = ((eh(4)-eh(3))*x+(eh(3)*xmh(4)-eh(4)*xmh(3)))
     .           /(xmh(4)-xmh(3))
      elseif (x.gt.xmh(4).and.x.le.xmh(5)) then
         effcc192_hvv = ((eh(5)-eh(4))*x+(eh(4)*xmh(5)-eh(5)*xmh(4)))
     .           /(xmh(5)-xmh(4))
      elseif (x.gt.xmh(5).and.x.le.xmh(6)) then
         effcc192_hvv = ((eh(6)-eh(5))*x+(eh(5)*xmh(6)-eh(6)*xmh(5)))
     .           /(xmh(6)-xmh(5))
      elseif (x.gt.xmh(6).and.x.le.xmh(7)) then
         effcc192_hvv = ((eh(7)-eh(6))*x+(eh(6)*xmh(7)-eh(7)*xmh(6)))
     .           /(xmh(7)-xmh(6))
      elseif (x.gt.xmh(7).and.x.le.xmh(8)) then
         effcc192_hvv = ((eh(8)-eh(7))*x+(eh(7)*xmh(8)-eh(8)*xmh(7)))
     .           /(xmh(8)-xmh(7))
      elseif (x.gt.xmh(8).and.x.le.xmh(9)) then
         effcc192_hvv = ((eh(9)-eh(8))*x+(eh(8)*xmh(9)-eh(9)*xmh(8)))
     .           /(xmh(9)-xmh(8))
      elseif (x.gt.xmh(9).and.x.le.xmh(10)) then
         effcc192_hvv = ((eh(10)-eh(9))*x+(eh(9)*xmh(10)-eh(10)*xmh(9)))
     .           /(xmh(10)-xmh(9))
      elseif (x.gt.xmh(10).and.x.le.xmh(11)) then
        effcc192_hvv = ((eh(11)-eh(10))*x+(eh(10)*xmh(11)-eh(11)*xmh(10)
     &       ))/(xmh(11)-xmh(10))
      elseif (x.gt.xmh(11)) then
         effcc192_hvv = 0.
      endif
      effcc192_hvv = 0.98*effcc192_hvv
      end
      Real function effgg192_hvv(x)
      Implicit none
      real xmh(11),x
      real eh(11)
      data xmh /59.5,60.,65.,70.,75.,80.,85.,90.,95.,100.,100.5/
      data eh  /0.,0.,0.,0.,0.011,0.029,0.156,0.453,0.414,0.14,0./
      if (x.lt.xmh(1)) then
         effgg192_hvv = 0.
      elseif (x.gt.xmh(1).and.x.le.xmh(2)) then
         effgg192_hvv = ((eh(2)-eh(1))*x+(eh(1)*xmh(2)-eh(2)*xmh(1)))
     .           /(xmh(2)-xmh(1))
      elseif (x.gt.xmh(2).and.x.le.xmh(3)) then
         effgg192_hvv = ((eh(3)-eh(2))*x+(eh(2)*xmh(3)-eh(3)*xmh(2)))
     .           /(xmh(3)-xmh(2))
      elseif (x.gt.xmh(3).and.x.le.xmh(4)) then
         effgg192_hvv = ((eh(4)-eh(3))*x+(eh(3)*xmh(4)-eh(4)*xmh(3)))
     .           /(xmh(4)-xmh(3))
      elseif (x.gt.xmh(4).and.x.le.xmh(5)) then
         effgg192_hvv = ((eh(5)-eh(4))*x+(eh(4)*xmh(5)-eh(5)*xmh(4)))
     .           /(xmh(5)-xmh(4))
      elseif (x.gt.xmh(5).and.x.le.xmh(6)) then
         effgg192_hvv = ((eh(6)-eh(5))*x+(eh(5)*xmh(6)-eh(6)*xmh(5)))
     .           /(xmh(6)-xmh(5))
      elseif (x.gt.xmh(6).and.x.le.xmh(7)) then
         effgg192_hvv = ((eh(7)-eh(6))*x+(eh(6)*xmh(7)-eh(7)*xmh(6)))
     .           /(xmh(7)-xmh(6))
      elseif (x.gt.xmh(7).and.x.le.xmh(8)) then
         effgg192_hvv = ((eh(8)-eh(7))*x+(eh(7)*xmh(8)-eh(8)*xmh(7)))
     .           /(xmh(8)-xmh(7))
      elseif (x.gt.xmh(8).and.x.le.xmh(9)) then
         effgg192_hvv = ((eh(9)-eh(8))*x+(eh(8)*xmh(9)-eh(9)*xmh(8)))
     .           /(xmh(9)-xmh(8))
      elseif (x.gt.xmh(9).and.x.le.xmh(10)) then
         effgg192_hvv = ((eh(10)-eh(9))*x+(eh(9)*xmh(10)-eh(10)*xmh(9)))
     .           /(xmh(10)-xmh(9))
      elseif (x.gt.xmh(10).and.x.le.xmh(11)) then
        effgg192_hvv = ((eh(11)-eh(10))*x+(eh(10)*xmh(11)-eh(11)*xmh(10)
     &       ))/(xmh(11)-xmh(10))
      elseif (x.gt.xmh(11)) then
         effgg192_hvv = 0.
      endif
      effgg192_hvv = 0.98*effgg192_hvv
      end
c
      Real FUNCTION A196_HVV_HGG_EFF(amass)
      Implicit none
      Real amass
      Real effbb196_hvv,effcc196_hvv,effgg196_hvv
      External effbb196_hvv,effcc196_hvv,effgg196_hvv
c
      Integer j
      Real effmin,eff(3)
c
      eff(1) = effbb196_hvv(amass)
      eff(2) = effcc196_hvv(amass)
      eff(3) = effgg196_hvv(amass)
      effmin = 1000.
      Do j=1,3
        If (eff(j).ne.0. .and. eff(j).lt.effmin) effmin = eff(j)
      Enddo
      If (effmin.eq.1000.) effmin = 0.
      A196_HVV_HGG_EFF = effmin
      RETURN
      END
c
      Real function effbb196_hvv(x)
      Implicit none
      real xmh(12),corbb196,x
      real eh(12)
      data xmh /59.5,60.,65.,70.,75.,80.,85.,90.,95.,100.,105.,105.5/
c      data eh /0.,0.269,0.365,0.470,0.415,0.422,
c     .         0.442,0.421,0.376,0.327,0.174,0./  ! + fusion
      data eh /0.,0.279,0.377,0.491,0.439,0.450,
     .            0.475,0.455,0.409,0.357,0.187,0./
      corbb196 = 0.
      if (x.lt.xmh(1)) then
         effbb196_hvv = 0.
      elseif (x.gt.xmh(1).and.x.le.xmh(2)) then
         effbb196_hvv = ((eh(2)-eh(1))*x+(eh(1)*xmh(2)-eh(2)*xmh(1)))
     .           /(xmh(2)-xmh(1))
      elseif (x.gt.xmh(2).and.x.le.xmh(3)) then
         effbb196_hvv = ((eh(3)-eh(2))*x+(eh(2)*xmh(3)-eh(3)*xmh(2)))
     .           /(xmh(3)-xmh(2))
      elseif (x.gt.xmh(3).and.x.le.xmh(4)) then
         effbb196_hvv = ((eh(4)-eh(3))*x+(eh(3)*xmh(4)-eh(4)*xmh(3)))
     .           /(xmh(4)-xmh(3))
         corbb196 = 0.05-0.1/(xmh(4)-xmh(3))*abs(x-(xmh(4)+xmh(3))/2.)
      elseif (x.gt.xmh(4).and.x.le.xmh(5)) then
         effbb196_hvv = ((eh(5)-eh(4))*x+(eh(4)*xmh(5)-eh(5)*xmh(4)))
     .           /(xmh(5)-xmh(4))
         corbb196 = 0.05-0.1/(xmh(5)-xmh(4))*abs(x-(xmh(5)+xmh(4))/2.)
      elseif (x.gt.xmh(5).and.x.le.xmh(6)) then
         effbb196_hvv = ((eh(6)-eh(5))*x+(eh(5)*xmh(6)-eh(6)*xmh(5)))
     .           /(xmh(6)-xmh(5))
         corbb196 = 0.05-0.1/(xmh(6)-xmh(5))*abs(x-(xmh(6)+xmh(5))/2.)
      elseif (x.gt.xmh(6).and.x.le.xmh(7)) then
         effbb196_hvv = ((eh(7)-eh(6))*x+(eh(6)*xmh(7)-eh(7)*xmh(6)))
     .           /(xmh(7)-xmh(6))
         corbb196 = 0.05-0.1/(xmh(7)-xmh(6))*abs(x-(xmh(7)+xmh(6))/2.)
      elseif (x.gt.xmh(7).and.x.le.xmh(8)) then
         effbb196_hvv = ((eh(8)-eh(7))*x+(eh(7)*xmh(8)-eh(8)*xmh(7)))
     .           /(xmh(8)-xmh(7))
         corbb196 = 0.05-0.1/(xmh(8)-xmh(7))*abs(x-(xmh(8)+xmh(7))/2.)
      elseif (x.gt.xmh(8).and.x.le.xmh(9)) then
         effbb196_hvv = ((eh(9)-eh(8))*x+(eh(8)*xmh(9)-eh(9)*xmh(8)))
     .           /(xmh(9)-xmh(8))
         corbb196 = 0.05-0.1/(xmh(9)-xmh(8))*abs(x-(xmh(9)+xmh(8))/2.)
      elseif (x.gt.xmh(9).and.x.le.xmh(10)) then
         effbb196_hvv = ((eh(10)-eh(9))*x+(eh(9)*xmh(10)-eh(10)*xmh(9)))
     .           /(xmh(10)-xmh(9))
      elseif (x.gt.xmh(10).and.x.le.xmh(11)) then
        effbb196_hvv = ((eh(11)-eh(10))*x+(eh(10)*xmh(11)-eh(11)*xmh(10)
     &       ))/(xmh(11)-xmh(10))
      elseif (x.gt.xmh(11).and.x.le.xmh(12)) then
        effbb196_hvv = ((eh(12)-eh(11))*x+(eh(11)*xmh(12)-eh(12)*xmh(11)
     &       ))/(xmh(12)-xmh(11))
      elseif (x.gt.xmh(12)) then
         effbb196_hvv = 0.
      endif
      effbb196_hvv = 0.98*(effbb196_hvv-corbb196)
      end
      Real function effcc196_hvv(x)
      Implicit none
      real xmh(12),x,corcc196
      real eh(12)
      data xmh /59.5,60.,65.,70.,75.,80.,85.,90.,95.,100.,104.,104.5/
      data eh  /0.,0.3,0.363,0.476,0.437,0.442,
     .          0.504,0.477,0.444,0.362,0.174,0./
      corcc196 = 0.
      if (x.lt.xmh(1)) then
         effcc196_hvv = 0.
      elseif (x.gt.xmh(1).and.x.le.xmh(2)) then
         effcc196_hvv = ((eh(2)-eh(1))*x+(eh(1)*xmh(2)-eh(2)*xmh(1)))
     .           /(xmh(2)-xmh(1))
      elseif (x.gt.xmh(2).and.x.le.xmh(3)) then
         effcc196_hvv = ((eh(3)-eh(2))*x+(eh(2)*xmh(3)-eh(3)*xmh(2)))
     .           /(xmh(3)-xmh(2))
      elseif (x.gt.xmh(3).and.x.le.xmh(4)) then
         effcc196_hvv = ((eh(4)-eh(3))*x+(eh(3)*xmh(4)-eh(4)*xmh(3)))
     .           /(xmh(4)-xmh(3))
         corcc196 = 0.05-0.1/(xmh(4)-xmh(3))*abs(x-(xmh(4)+xmh(3))/2.)
      elseif (x.gt.xmh(4).and.x.le.xmh(5)) then
         effcc196_hvv = ((eh(5)-eh(4))*x+(eh(4)*xmh(5)-eh(5)*xmh(4)))
     .           /(xmh(5)-xmh(4))
         corcc196 = 0.05-0.1/(xmh(5)-xmh(4))*abs(x-(xmh(5)+xmh(4))/2.)
      elseif (x.gt.xmh(5).and.x.le.xmh(6)) then
         effcc196_hvv = ((eh(6)-eh(5))*x+(eh(5)*xmh(6)-eh(6)*xmh(5)))
     .           /(xmh(6)-xmh(5))
         corcc196 = 0.05-0.1/(xmh(6)-xmh(5))*abs(x-(xmh(6)+xmh(5))/2.)
      elseif (x.gt.xmh(6).and.x.le.xmh(7)) then
         effcc196_hvv = ((eh(7)-eh(6))*x+(eh(6)*xmh(7)-eh(7)*xmh(6)))
     .           /(xmh(7)-xmh(6))
         corcc196 = 0.05-0.1/(xmh(7)-xmh(6))*abs(x-(xmh(7)+xmh(6))/2.)
      elseif (x.gt.xmh(7).and.x.le.xmh(8)) then
         effcc196_hvv = ((eh(8)-eh(7))*x+(eh(7)*xmh(8)-eh(8)*xmh(7)))
     .           /(xmh(8)-xmh(7))
         corcc196 = 0.05-0.1/(xmh(8)-xmh(7))*abs(x-(xmh(8)+xmh(7))/2.)
      elseif (x.gt.xmh(8).and.x.le.xmh(9)) then
         effcc196_hvv = ((eh(9)-eh(8))*x+(eh(8)*xmh(9)-eh(9)*xmh(8)))
     .           /(xmh(9)-xmh(8))
         corcc196 = 0.05-0.1/(xmh(9)-xmh(8))*abs(x-(xmh(9)+xmh(8))/2.)
      elseif (x.gt.xmh(9).and.x.le.xmh(10)) then
         effcc196_hvv = ((eh(10)-eh(9))*x+(eh(9)*xmh(10)-eh(10)*xmh(9)))
     .           /(xmh(10)-xmh(9))
      elseif (x.gt.xmh(10).and.x.le.xmh(11)) then
        effcc196_hvv = ((eh(11)-eh(10))*x+(eh(10)*xmh(11)-eh(11)*xmh(10)
     &       ))/(xmh(11)-xmh(10))
      elseif (x.gt.xmh(11).and.x.le.xmh(12)) then
        effcc196_hvv = ((eh(12)-eh(11))*x+(eh(11)*xmh(12)-eh(12)*xmh(11)
     &       ))/(xmh(12)-xmh(11))
      elseif (x.gt.xmh(12)) then
         effcc196_hvv = 0.
      endif
      effcc196_hvv = 0.98*(effcc196_hvv - corcc196)
      end
      Real function effgg196_hvv(x)
      Implicit none
      real xmh(12),x,corgg196
      real eh(12)
      data xmh /59.5,60.,65.,70.,75.,80.,85.,90.,95.,100.,104.,104.5/
      data eh  /0.,0.227,0.301,0.457,0.429,0.466,
     .          0.526,0.505,0.464,0.36,0.146,0./
      corgg196 = 0.
      if (x.lt.xmh(1)) then
         effgg196_hvv = 0.
      elseif (x.gt.xmh(1).and.x.le.xmh(2)) then
         effgg196_hvv = ((eh(2)-eh(1))*x+(eh(1)*xmh(2)-eh(2)*xmh(1)))
     .           /(xmh(2)-xmh(1))
      elseif (x.gt.xmh(2).and.x.le.xmh(3)) then
         effgg196_hvv = ((eh(3)-eh(2))*x+(eh(2)*xmh(3)-eh(3)*xmh(2)))
     .           /(xmh(3)-xmh(2))
      elseif (x.gt.xmh(3).and.x.le.xmh(4)) then
         effgg196_hvv = ((eh(4)-eh(3))*x+(eh(3)*xmh(4)-eh(4)*xmh(3)))
     .           /(xmh(4)-xmh(3))
         corgg196 = 0.05-0.1/(xmh(4)-xmh(3))*abs(x-(xmh(4)+xmh(3))/2.)
      elseif (x.gt.xmh(4).and.x.le.xmh(5)) then
         effgg196_hvv = ((eh(5)-eh(4))*x+(eh(4)*xmh(5)-eh(5)*xmh(4)))
     .           /(xmh(5)-xmh(4))
         corgg196 = 0.05-0.1/(xmh(5)-xmh(4))*abs(x-(xmh(5)+xmh(4))/2.)
      elseif (x.gt.xmh(5).and.x.le.xmh(6)) then
         effgg196_hvv = ((eh(6)-eh(5))*x+(eh(5)*xmh(6)-eh(6)*xmh(5)))
     .           /(xmh(6)-xmh(5))
         corgg196 = 0.05-0.1/(xmh(6)-xmh(5))*abs(x-(xmh(6)+xmh(5))/2.)
      elseif (x.gt.xmh(6).and.x.le.xmh(7)) then
         effgg196_hvv = ((eh(7)-eh(6))*x+(eh(6)*xmh(7)-eh(7)*xmh(6)))
     .           /(xmh(7)-xmh(6))
         corgg196 = 0.05-0.1/(xmh(7)-xmh(6))*abs(x-(xmh(7)+xmh(6))/2.)
      elseif (x.gt.xmh(7).and.x.le.xmh(8)) then
         effgg196_hvv = ((eh(8)-eh(7))*x+(eh(7)*xmh(8)-eh(8)*xmh(7)))
     .           /(xmh(8)-xmh(7))
         corgg196 = 0.05-0.1/(xmh(8)-xmh(7))*abs(x-(xmh(8)+xmh(7))/2.)
      elseif (x.gt.xmh(8).and.x.le.xmh(9)) then
         effgg196_hvv = ((eh(9)-eh(8))*x+(eh(8)*xmh(9)-eh(9)*xmh(8)))
     .           /(xmh(9)-xmh(8))
         corgg196 = 0.05-0.1/(xmh(9)-xmh(8))*abs(x-(xmh(9)+xmh(8))/2.)
      elseif (x.gt.xmh(9).and.x.le.xmh(10)) then
         effgg196_hvv = ((eh(10)-eh(9))*x+(eh(9)*xmh(10)-eh(10)*xmh(9)))
     .           /(xmh(10)-xmh(9))
       elseif (x.gt.xmh(10).and.x.le.xmh(11)) then
         effgg196_hvv = ((eh(11)-eh(10))*x+(eh(10)*xmh(11)-eh(11)*xmh(10
     &        )))/(xmh(11)-xmh(10))
      elseif (x.gt.xmh(11).and.x.le.xmh(12)) then
        effgg196_hvv = ((eh(12)-eh(11))*x+(eh(11)*xmh(12)-eh(12)*xmh(11)
     &       ))/(xmh(12)-xmh(11))
      elseif (x.gt.xmh(12)) then
         effgg196_hvv = 0.
      endif
      effgg196_hvv = 0.98*(effgg196_hvv - corgg196)
      end
c
      Real FUNCTION A200_HVV_HGG_EFF(amass)
      Implicit none
      Real amass
      Real effbb200_hvv,effcc200_hvv,effgg200_hvv
      External effbb200_hvv,effcc200_hvv,effgg200_hvv
c
      Integer j
      Real effmin,eff(3)
c
      eff(1) = effbb200_hvv(amass)
      eff(2) = effcc200_hvv(amass)
      eff(3) = effgg200_hvv(amass)
      effmin = 1000.
      Do j=1,3
        If (eff(j).ne.0. .and. eff(j).lt.effmin) effmin = eff(j)
      Enddo
      If (effmin.eq.1000.) effmin = 0.
      A200_HVV_HGG_EFF = effmin
      RETURN
      END
c
      Real function effbb200_hvv(x)
      Implicit none
      real xmh(14),x,corbb200
      real eh(14)
      data xmh /59.5,60.,65.,70.,75.,80.,85.,90.,
     .               95.,100.,105.,107.,110.,110.5/
c      data eh /0.,0.191,0.363,0.393,0.479,0.404,0.396,
c     .            0.437,0.421,0.373,0.282,0.203,0.172,0./   ! + fusion
      data eh /0.,0.200,0.378,0.400,0.497,0.429,0.420,0.464,
     .         0.451,0.416,0.306,0.210,0.192,0./

      corbb200 = 0.
      if (x.lt.xmh(1)) then
         effbb200_hvv = 0.
      elseif (x.gt.xmh(1).and.x.le.xmh(2)) then
         effbb200_hvv = ((eh(2)-eh(1))*x+(eh(1)*xmh(2)-eh(2)*xmh(1)))
     .           /(xmh(2)-xmh(1))
      elseif (x.gt.xmh(2).and.x.le.xmh(3)) then
         effbb200_hvv = ((eh(3)-eh(2))*x+(eh(2)*xmh(3)-eh(3)*xmh(2)))
     .           /(xmh(3)-xmh(2))
      elseif (x.gt.xmh(3).and.x.le.xmh(4)) then
         effbb200_hvv = ((eh(4)-eh(3))*x+(eh(3)*xmh(4)-eh(4)*xmh(3)))
     .           /(xmh(4)-xmh(3))
      elseif (x.gt.xmh(4).and.x.le.xmh(5)) then
         effbb200_hvv = ((eh(5)-eh(4))*x+(eh(4)*xmh(5)-eh(5)*xmh(4)))
     .           /(xmh(5)-xmh(4))
         corbb200 = 0.05-0.1/(xmh(5)-xmh(4))*abs(x-(xmh(5)+xmh(4))/2.)
      elseif (x.gt.xmh(5).and.x.le.xmh(6)) then
         effbb200_hvv = ((eh(6)-eh(5))*x+(eh(5)*xmh(6)-eh(6)*xmh(5)))
     .           /(xmh(6)-xmh(5))
         corbb200 = 0.05-0.1/(xmh(6)-xmh(5))*abs(x-(xmh(6)+xmh(5))/2.)
      elseif (x.gt.xmh(6).and.x.le.xmh(7)) then
         effbb200_hvv = ((eh(7)-eh(6))*x+(eh(6)*xmh(7)-eh(7)*xmh(6)))
     .           /(xmh(7)-xmh(6))
         corbb200 = 0.05-0.1/(xmh(7)-xmh(6))*abs(x-(xmh(7)+xmh(6))/2.)
      elseif (x.gt.xmh(7).and.x.le.xmh(8)) then
         effbb200_hvv = ((eh(8)-eh(7))*x+(eh(7)*xmh(8)-eh(8)*xmh(7)))
     .           /(xmh(8)-xmh(7))
         corbb200 = 0.05-0.1/(xmh(8)-xmh(7))*abs(x-(xmh(8)+xmh(7))/2.)
      elseif (x.gt.xmh(8).and.x.le.xmh(9)) then
         effbb200_hvv = ((eh(9)-eh(8))*x+(eh(8)*xmh(9)-eh(9)*xmh(8)))
     .           /(xmh(9)-xmh(8))
         corbb200 = 0.05-0.1/(xmh(9)-xmh(8))*abs(x-(xmh(9)+xmh(8))/2.)
      elseif (x.gt.xmh(9).and.x.le.xmh(10)) then
         effbb200_hvv = ((eh(10)-eh(9))*x+(eh(9)*xmh(10)-eh(10)*xmh(9)))
     .           /(xmh(10)-xmh(9))
         corbb200 = 0.05-0.1/(xmh(10)-xmh(9))*abs(x-(xmh(10)+xmh(9))/2.)
      elseif (x.gt.xmh(10).and.x.le.xmh(11)) then
        effbb200_hvv = ((eh(11)-eh(10))*x+(eh(10)*xmh(11)-eh(11)*xmh(10)
     &       ))/(xmh(11)-xmh(10))
      elseif (x.gt.xmh(11).and.x.le.xmh(12)) then
        effbb200_hvv = ((eh(12)-eh(11))*x+(eh(11)*xmh(12)-eh(12)*xmh(11)
     &       ))/(xmh(12)-xmh(11))
      elseif (x.gt.xmh(12).and.x.le.xmh(13)) then
        effbb200_hvv = ((eh(13)-eh(12))*x+(eh(12)*xmh(13)-eh(13)*xmh(12)
     &       ))/(xmh(13)-xmh(12))
      elseif (x.gt.xmh(13).and.x.le.xmh(14)) then
        effbb200_hvv = ((eh(14)-eh(13))*x+(eh(13)*xmh(14)-eh(14)*xmh(13)
     &       ))/(xmh(14)-xmh(13))
      elseif (x.gt.xmh(14)) then
         effbb200_hvv = 0.
      endif
      effbb200_hvv = 0.98*(effbb200_hvv-corbb200)
      end
      Real function effcc200_hvv(x)
      Implicit none
      real xmh(13),eh(13),x
c
      data xmh /59.5,60.,65.,70.,75.,80.,85.,88.,
     .          90.,95.,100.,105.,105.5/
      data eh /1E-2,19.4,37.1,37.,44.3,40.2,40.6,42.6,
     .         46.2,46.2,40.1,30.3,1E-2/

      if (x.le.xmh(1)) then
         effcc200_hvv = 0.
      elseif (x.gt.xmh(1).and.x.le.xmh(2)) then
         effcc200_hvv = ((eh(2)-eh(1))*x+(eh(1)*xmh(2)-eh(2)*xmh(1)))
     .           /(xmh(2)-xmh(1))
      elseif (x.gt.xmh(2).and.x.le.xmh(3)) then
         effcc200_hvv = ((eh(3)-eh(2))*x+(eh(2)*xmh(3)-eh(3)*xmh(2)))
     .           /(xmh(3)-xmh(2))
      elseif (x.gt.xmh(3).and.x.le.xmh(4)) then
         effcc200_hvv = ((eh(4)-eh(3))*x+(eh(3)*xmh(4)-eh(4)*xmh(3)))
     .           /(xmh(4)-xmh(3))
      elseif (x.gt.xmh(4).and.x.le.xmh(5)) then
c         effcc200_hvv = ((eh(5)-eh(4))*x+(eh(4)*xmh(5)-eh(5)*xmh(4)))
c     .           /(xmh(5)-xmh(4))
         effcc200_hvv =   100.*(35.412-0.98127*x+0.68667E-02*x**2)
      elseif (x.gt.xmh(5).and.x.le.xmh(6)) then
c         effcc200_hvv = ((eh(6)-eh(5))*x+(eh(5)*xmh(6)-eh(6)*xmh(5)))
c     .           /(xmh(6)-xmh(5))
         effcc200_hvv =   100.*(57.294-1.4607*x+0.93695E-02*x**2)
      elseif (x.gt.xmh(6).and.x.le.xmh(7)) then
         effcc200_hvv = ((eh(7)-eh(6))*x+(eh(6)*xmh(7)-eh(7)*xmh(6)))
     .           /(xmh(7)-xmh(6))
         effcc200_hvv =   100.*(48.099-1.1589*x+0.70333E-02*x**2)
      elseif (x.gt.xmh(7).and.x.le.xmh(8)) then
         effcc200_hvv = ((eh(8)-eh(7))*x+(eh(7)*xmh(8)-eh(8)*xmh(7)))
     .           /(xmh(8)-xmh(7))
      elseif (x.gt.xmh(8).and.x.le.xmh(9)) then
         effcc200_hvv = ((eh(9)-eh(8))*x+(eh(8)*xmh(9)-eh(9)*xmh(8)))
     .           /(xmh(9)-xmh(8))
      elseif (x.gt.xmh(9).and.x.le.xmh(10)) then
c         effcc200_hvv = ((eh(10)-eh(9))*x+(eh(9)*xmh(10)-eh(10)*xmh(9)))
c     .           /(xmh(10)-xmh(9))
         effcc200_hvv =   100.*(46.065-0.98692*x+0.53356E-02*x**2)
      elseif (x.gt.xmh(10).and.x.le.xmh(11)) then
c         effcc200_hvv = ((eh(11)-eh(10))*x+(eh(10)*xmh(11)-eh(11)*xmh(10)))
c     .           /(xmh(11)-xmh(10))
         effcc200_hvv =   100.*(46.562-0.93394*x+0.47230E-02*x**2)
      elseif (x.gt.xmh(11).and.x.le.xmh(12)) then
        effcc200_hvv = ((eh(12)-eh(11))*x+(eh(11)*xmh(12)-eh(12)*xmh(11)
     &       ))/(xmh(12)-xmh(11))
      elseif (x.gt.xmh(12).and.x.le.xmh(13)) then
        effcc200_hvv = ((eh(13)-eh(12))*x+(eh(12)*xmh(13)-eh(13)*xmh(12)
     &       ))/(xmh(13)-xmh(12))
      elseif (x.gt.xmh(13)) then
         effcc200_hvv = 0.
      endif
      effcc200_hvv = 0.98*effcc200_hvv/100.
      end
      Real function effgg200_hvv(x)
      Implicit none
      real xmh(13),eh(13),x
c
      data xmh /59.,60.,65.,70.,75.,80.,85.,88.,
     .          90.,95.,100.,105.,105.5/
      data eh /1E-2,15.4,28.3,36.7,43.1,40.2,43.8,47.1,
     .         50.8,47.1,43.2,27.0,1E-2/

      if (x.le.xmh(1)) then
         effgg200_hvv = 0.
      elseif (x.gt.xmh(1).and.x.le.xmh(2)) then
         effgg200_hvv = ((eh(2)-eh(1))*x+(eh(1)*xmh(2)-eh(2)*xmh(1)))
     .           /(xmh(2)-xmh(1))
      elseif (x.gt.xmh(2).and.x.le.xmh(3)) then
         effgg200_hvv = ((eh(3)-eh(2))*x+(eh(2)*xmh(3)-eh(3)*xmh(2)))
     .           /(xmh(3)-xmh(2))
      elseif (x.gt.xmh(3).and.x.le.xmh(4)) then
         effgg200_hvv = ((eh(4)-eh(3))*x+(eh(3)*xmh(4)-eh(4)*xmh(3)))
     .           /(xmh(4)-xmh(3))
      elseif (x.gt.xmh(4).and.x.le.xmh(5)) then
c         effgg200_hvv = ((eh(5)-eh(4))*x+(eh(4)*xmh(5)-eh(5)*xmh(4)))
c     .           /(xmh(5)-xmh(4))
         effgg200_hvv = 100.*(35.262-0.97683*x+0.68333E-02*x**2)
      elseif (x.gt.xmh(5).and.x.le.xmh(6)) then
c         effgg200_hvv = ((eh(6)-eh(5))*x+(eh(5)*xmh(6)-eh(6)*xmh(5)))
c     .           /(xmh(6)-xmh(5))
         effgg200_hvv = 100.*(45.684-1.1616*x+0.74443E-02*x**2)
      elseif (x.gt.xmh(6).and.x.le.xmh(7)) then
c         effgg200_hvv = ((eh(7)-eh(6))*x+(eh(6)*xmh(7)-eh(7)*xmh(6)))
c     .           /(xmh(7)-xmh(6))
         effgg200_hvv = 100.*(36.109-0.87300*x+0.53333E-02*x**2)
      elseif (x.gt.xmh(7).and.x.le.xmh(8)) then
         effgg200_hvv = ((eh(8)-eh(7))*x+(eh(7)*xmh(8)-eh(8)*xmh(7)))
     .           /(xmh(8)-xmh(7))
      elseif (x.gt.xmh(8).and.x.le.xmh(9)) then
         effgg200_hvv = ((eh(9)-eh(8))*x+(eh(8)*xmh(9)-eh(9)*xmh(8)))
     .           /(xmh(9)-xmh(8))
      elseif (x.gt.xmh(9).and.x.le.xmh(10)) then
c         effgg200_hvv = ((eh(10)-eh(9))*x+(eh(9)*xmh(10)-eh(10)*xmh(9)))
c     .           /(xmh(10)-xmh(9))
         effgg200_hvv =  100.*(40.656-0.86238*x+0.46254E-02*x**2)
      elseif (x.gt.xmh(10).and.x.le.xmh(11)) then
c         effgg200_hvv = ((eh(11)-eh(10))*x+(eh(10)*xmh(11)-eh(11)*xmh(10)))
c     .           /(xmh(11)-xmh(10))
         effgg200_hvv =   101.2*(49.704-1.0032*x+0.51043E-02*x**2)
      elseif (x.gt.xmh(11).and.x.le.xmh(12)) then
        effgg200_hvv = ((eh(12)-eh(11))*x+(eh(11)*xmh(12)-eh(12)*xmh(11)
     &       ))/(xmh(12)-xmh(11))
      elseif (x.gt.xmh(12).and.x.le.xmh(13)) then
        effgg200_hvv = ((eh(13)-eh(12))*x+(eh(12)*xmh(13)-eh(13)*xmh(12)
     &       ))/(xmh(13)-xmh(12))
      elseif (x.gt.xmh(13)) then
         effgg200_hvv = 0.
      endif
      effgg200_hvv = 0.98*effgg200_hvv/100.
      end
c
      Real FUNCTION A202_HVV_HGG_EFF(amass)
      Implicit none
      Real amass
      Real effbb202_hvv,effcc202_hvv,effgg202_hvv
      External effbb202_hvv,effcc202_hvv,effgg202_hvv
c
      Integer j
      Real effmin,eff(3)
c
      eff(1) = effbb202_hvv(amass)
      eff(2) = effcc202_hvv(amass)
      eff(3) = effgg202_hvv(amass)
      effmin = 1000.
      Do j=1,3
        If (eff(j).ne.0. .and. eff(j).lt.effmin) effmin = eff(j)
      Enddo
      If (effmin.eq.1000.) effmin = 0.
      A202_HVV_HGG_EFF = effmin
      RETURN
      END
c
      Real function effbb202_hvv(x)
      Implicit none
      real xmh(15),x,corbb202
      real eh(15)
      data xmh /59.5,60.,65.,70.,75.,80.,85.,90.,
     .               95.,100.,105.,107.,110.,115.,115.5/
c      data eh /0.,0.133,0.312,0.443,0.498,0.378,0.326,
c     .            0.353,0.322,0.310,0.345,0.295,0.182,0.145,0./ ! + fusion
      data eh /0.,0.140,0.334,0.459,0.527,0.399,0.350,0.398,
     .            0.352,0.352,0.378,0.322,0.193,0.180,0./

      corbb202 = 0.
      if (x.lt.xmh(1)) then
         effbb202_hvv = 0.
      elseif (x.gt.xmh(1).and.x.le.xmh(2)) then
         effbb202_hvv = ((eh(2)-eh(1))*x+(eh(1)*xmh(2)-eh(2)*xmh(1)))
     .           /(xmh(2)-xmh(1))
      elseif (x.gt.xmh(2).and.x.le.xmh(3)) then
         effbb202_hvv = ((eh(3)-eh(2))*x+(eh(2)*xmh(3)-eh(3)*xmh(2)))
     .           /(xmh(3)-xmh(2))
      elseif (x.gt.xmh(3).and.x.le.xmh(4)) then
         effbb202_hvv = ((eh(4)-eh(3))*x+(eh(3)*xmh(4)-eh(4)*xmh(3)))
     .           /(xmh(4)-xmh(3))
      elseif (x.gt.xmh(4).and.x.le.xmh(5)) then
         effbb202_hvv = ((eh(5)-eh(4))*x+(eh(4)*xmh(5)-eh(5)*xmh(4)))
     .           /(xmh(5)-xmh(4))
         corbb202 = 0.05-0.1/(xmh(5)-xmh(4))*abs(x-(xmh(5)+xmh(4))/2.)
      elseif (x.gt.xmh(5).and.x.le.xmh(6)) then
         effbb202_hvv = ((eh(6)-eh(5))*x+(eh(5)*xmh(6)-eh(6)*xmh(5)))
     .           /(xmh(6)-xmh(5))
         corbb202 = 0.05-0.1/(xmh(6)-xmh(5))*abs(x-(xmh(6)+xmh(5))/2.)
      elseif (x.gt.xmh(6).and.x.le.xmh(7)) then
         effbb202_hvv = ((eh(7)-eh(6))*x+(eh(6)*xmh(7)-eh(7)*xmh(6)))
     .           /(xmh(7)-xmh(6))
         corbb202 = 0.05-0.1/(xmh(7)-xmh(6))*abs(x-(xmh(7)+xmh(6))/2.)
      elseif (x.gt.xmh(7).and.x.le.xmh(8)) then
         effbb202_hvv = ((eh(8)-eh(7))*x+(eh(7)*xmh(8)-eh(8)*xmh(7)))
     .           /(xmh(8)-xmh(7))
         corbb202 = 0.05-0.1/(xmh(8)-xmh(7))*abs(x-(xmh(8)+xmh(7))/2.)
      elseif (x.gt.xmh(8).and.x.le.xmh(9)) then
         effbb202_hvv = ((eh(9)-eh(8))*x+(eh(8)*xmh(9)-eh(9)*xmh(8)))
     .           /(xmh(9)-xmh(8))
         corbb202 = 0.05-0.1/(xmh(9)-xmh(8))*abs(x-(xmh(9)+xmh(8))/2.)
      elseif (x.gt.xmh(9).and.x.le.xmh(10)) then
         effbb202_hvv = ((eh(10)-eh(9))*x+(eh(9)*xmh(10)-eh(10)*xmh(9)))
     .           /(xmh(10)-xmh(9))
         corbb202 = 0.05-0.1/(xmh(10)-xmh(9))*abs(x-(xmh(10)+xmh(9))/2.)
      elseif (x.gt.xmh(10).and.x.le.xmh(11)) then
        effbb202_hvv = ((eh(11)-eh(10))*x+(eh(10)*xmh(11)-eh(11)*xmh(10)
     &       ))/(xmh(11)-xmh(10))
      elseif (x.gt.xmh(11).and.x.le.xmh(12)) then
        effbb202_hvv = ((eh(12)-eh(11))*x+(eh(11)*xmh(12)-eh(12)*xmh(11)
     &       ))/(xmh(12)-xmh(11))
      elseif (x.gt.xmh(12).and.x.le.xmh(13)) then
        effbb202_hvv = ((eh(13)-eh(12))*x+(eh(12)*xmh(13)-eh(13)*xmh(12)
     &       ))/(xmh(13)-xmh(12))
      elseif (x.gt.xmh(13).and.x.le.xmh(14)) then
        effbb202_hvv = ((eh(14)-eh(13))*x+(eh(13)*xmh(14)-eh(14)*xmh(13)
     &       ))/(xmh(14)-xmh(13))
      elseif (x.gt.xmh(14).and.x.le.xmh(15)) then
        effbb202_hvv = ((eh(15)-eh(14))*x+(eh(14)*xmh(15)-eh(15)*xmh(14)
     &       ))/(xmh(15)-xmh(14))
      elseif (x.gt.xmh(15)) then
         effbb202_hvv = 0.
      endif
      effbb202_hvv = 0.98*(effbb202_hvv-corbb202)
      end
      Real function effcc202_hvv(x)
      Implicit none
      real xmh(12),x,corcc202
      real eh(12)
      data xmh /59.5,60.,65.,70.,75.,80.,85.,90.,95.,100.,105.,105.5/
      data eh  /0.,0.159,0.336,0.455,0.509,0.378,
     .          0.359,0.45,0.41,0.408,0.363,0./
      corcc202 = 0.
      if (x.lt.xmh(1)) then
         effcc202_hvv = 0.
      elseif (x.gt.xmh(1).and.x.le.xmh(2)) then
         effcc202_hvv = ((eh(2)-eh(1))*x+(eh(1)*xmh(2)-eh(2)*xmh(1)))
     .           /(xmh(2)-xmh(1))
      elseif (x.gt.xmh(2).and.x.le.xmh(3)) then
         effcc202_hvv = ((eh(3)-eh(2))*x+(eh(2)*xmh(3)-eh(3)*xmh(2)))
     .           /(xmh(3)-xmh(2))
      elseif (x.gt.xmh(3).and.x.le.xmh(4)) then
         effcc202_hvv = ((eh(4)-eh(3))*x+(eh(3)*xmh(4)-eh(4)*xmh(3)))
     .           /(xmh(4)-xmh(3))
      elseif (x.gt.xmh(4).and.x.le.xmh(5)) then
         effcc202_hvv = ((eh(5)-eh(4))*x+(eh(4)*xmh(5)-eh(5)*xmh(4)))
     .           /(xmh(5)-xmh(4))
         corcc202 = 0.05-0.1/(xmh(5)-xmh(4))*abs(x-(xmh(5)+xmh(4))/2.)
      elseif (x.gt.xmh(5).and.x.le.xmh(6)) then
         effcc202_hvv = ((eh(6)-eh(5))*x+(eh(5)*xmh(6)-eh(6)*xmh(5)))
     .           /(xmh(6)-xmh(5))
         corcc202 = 0.05-0.1/(xmh(6)-xmh(5))*abs(x-(xmh(6)+xmh(5))/2.)
      elseif (x.gt.xmh(6).and.x.le.xmh(7)) then
         effcc202_hvv = ((eh(7)-eh(6))*x+(eh(6)*xmh(7)-eh(7)*xmh(6)))
     .           /(xmh(7)-xmh(6))
         corcc202 = 0.05-0.1/(xmh(7)-xmh(6))*abs(x-(xmh(7)+xmh(6))/2.)
      elseif (x.gt.xmh(7).and.x.le.xmh(8)) then
         effcc202_hvv = ((eh(8)-eh(7))*x+(eh(7)*xmh(8)-eh(8)*xmh(7)))
     .           /(xmh(8)-xmh(7))
         corcc202 = 0.05-0.1/(xmh(8)-xmh(7))*abs(x-(xmh(8)+xmh(7))/2.)
      elseif (x.gt.xmh(8).and.x.le.xmh(9)) then
         effcc202_hvv = ((eh(9)-eh(8))*x+(eh(8)*xmh(9)-eh(9)*xmh(8)))
     .           /(xmh(9)-xmh(8))
         corcc202 = 0.05-0.1/(xmh(9)-xmh(8))*abs(x-(xmh(9)+xmh(8))/2.)
      elseif (x.gt.xmh(9).and.x.le.xmh(10)) then
         effcc202_hvv = ((eh(10)-eh(9))*x+(eh(9)*xmh(10)-eh(10)*xmh(9)))
     .           /(xmh(10)-xmh(9))
         corcc202 = 0.05-0.1/(xmh(10)-xmh(9))*abs(x-(xmh(10)+xmh(9))/2.)
      elseif (x.gt.xmh(10).and.x.le.xmh(11)) then
        effcc202_hvv = ((eh(11)-eh(10))*x+(eh(10)*xmh(11)-eh(11)*xmh(10)
     &       ))/(xmh(11)-xmh(10))
      elseif (x.gt.xmh(11).and.x.le.xmh(12)) then
        effcc202_hvv = ((eh(12)-eh(11))*x+(eh(11)*xmh(12)-eh(12)*xmh(11)
     &       ))/(xmh(12)-xmh(11))
      elseif (x.gt.xmh(12)) then
         effcc202_hvv = 0.
      endif
      effcc202_hvv = 0.98*(effcc202_hvv - corcc202)
      end
      Real function effgg202_hvv(x)
      Implicit none
      real xmh(12),x,corgg202
      real eh(12)
      data xmh /59.5,60.,65.,70.,75.,80.,85.,90.,95.,100.,105.,105.5/
      data eh  /0.,0.111,0.277,0.428,0.512,0.392,
     .          0.383,0.452,0.447,0.416,0.381,0./
      corgg202 = 0.
      if (x.lt.xmh(1)) then
         effgg202_hvv = 0.
      elseif (x.gt.xmh(1).and.x.le.xmh(2)) then
         effgg202_hvv = ((eh(2)-eh(1))*x+(eh(1)*xmh(2)-eh(2)*xmh(1)))
     .           /(xmh(2)-xmh(1))
      elseif (x.gt.xmh(2).and.x.le.xmh(3)) then
         effgg202_hvv = ((eh(3)-eh(2))*x+(eh(2)*xmh(3)-eh(3)*xmh(2)))
     .           /(xmh(3)-xmh(2))
      elseif (x.gt.xmh(3).and.x.le.xmh(4)) then
         effgg202_hvv = ((eh(4)-eh(3))*x+(eh(3)*xmh(4)-eh(4)*xmh(3)))
     .           /(xmh(4)-xmh(3))
      elseif (x.gt.xmh(4).and.x.le.xmh(5)) then
         effgg202_hvv = ((eh(5)-eh(4))*x+(eh(4)*xmh(5)-eh(5)*xmh(4)))
     .           /(xmh(5)-xmh(4))
         corgg202 = 0.05-0.1/(xmh(5)-xmh(4))*abs(x-(xmh(5)+xmh(4))/2.)
      elseif (x.gt.xmh(5).and.x.le.xmh(6)) then
         effgg202_hvv = ((eh(6)-eh(5))*x+(eh(5)*xmh(6)-eh(6)*xmh(5)))
     .           /(xmh(6)-xmh(5))
         corgg202 = 0.05-0.1/(xmh(6)-xmh(5))*abs(x-(xmh(6)+xmh(5))/2.)
      elseif (x.gt.xmh(6).and.x.le.xmh(7)) then
         effgg202_hvv = ((eh(7)-eh(6))*x+(eh(6)*xmh(7)-eh(7)*xmh(6)))
     .           /(xmh(7)-xmh(6))
         corgg202 = 0.05-0.1/(xmh(7)-xmh(6))*abs(x-(xmh(7)+xmh(6))/2.)
      elseif (x.gt.xmh(7).and.x.le.xmh(8)) then
         effgg202_hvv = ((eh(8)-eh(7))*x+(eh(7)*xmh(8)-eh(8)*xmh(7)))
     .           /(xmh(8)-xmh(7))
         corgg202 = 0.05-0.1/(xmh(8)-xmh(7))*abs(x-(xmh(8)+xmh(7))/2.)
      elseif (x.gt.xmh(8).and.x.le.xmh(9)) then
         effgg202_hvv = ((eh(9)-eh(8))*x+(eh(8)*xmh(9)-eh(9)*xmh(8)))
     .           /(xmh(9)-xmh(8))
         corgg202 = 0.05-0.1/(xmh(9)-xmh(8))*abs(x-(xmh(9)+xmh(8))/2.)
      elseif (x.gt.xmh(9).and.x.le.xmh(10)) then
         effgg202_hvv = ((eh(10)-eh(9))*x+(eh(9)*xmh(10)-eh(10)*xmh(9)))
     .           /(xmh(10)-xmh(9))
         corgg202 = 0.05-0.1/(xmh(10)-xmh(9))*abs(x-(xmh(10)+xmh(9))/2.)
      elseif (x.gt.xmh(10).and.x.le.xmh(11)) then
        effgg202_hvv = ((eh(11)-eh(10))*x+(eh(10)*xmh(11)-eh(11)*xmh(10)
     &       ))/(xmh(11)-xmh(10))
      elseif (x.gt.xmh(11).and.x.le.xmh(12)) then
        effgg202_hvv = ((eh(12)-eh(11))*x+(eh(11)*xmh(12)-eh(12)*xmh(11)
     &       ))/(xmh(12)-xmh(11))
      elseif (x.gt.xmh(12)) then
         effgg202_hvv = 0.
      endif
      effgg202_hvv = 0.98*(effgg202_hvv - corgg202)
      end
c
      REAL FUNCTION A189_HVV_HGG_BACKG(mhiggs)
      Implicit none
      Real mhiggs
      Real mh
c
      Integer npoint
      Parameter (npoint=201)
      Real hmass(npoint),bdf(npoint)
      Real massi,massx,dmass,rmass
      Integer i,imass,jmass
      Data (hmass(i),i=       1,     201)/
     &  0.75000E+02, 0.75100E+02, 0.75200E+02, 0.75300E+02, 0.75400E+02,
     &  0.75500E+02, 0.75600E+02, 0.75700E+02, 0.75800E+02, 0.75900E+02,
     &  0.76000E+02, 0.76100E+02, 0.76200E+02, 0.76300E+02, 0.76400E+02,
     &  0.76500E+02, 0.76600E+02, 0.76700E+02, 0.76800E+02, 0.76900E+02,
     &  0.77000E+02, 0.77100E+02, 0.77200E+02, 0.77300E+02, 0.77400E+02,
     &  0.77500E+02, 0.77600E+02, 0.77700E+02, 0.77800E+02, 0.77900E+02,
     &  0.78000E+02, 0.78100E+02, 0.78200E+02, 0.78300E+02, 0.78400E+02,
     &  0.78500E+02, 0.78600E+02, 0.78700E+02, 0.78800E+02, 0.78900E+02,
     &  0.79000E+02, 0.79100E+02, 0.79200E+02, 0.79300E+02, 0.79400E+02,
     &  0.79500E+02, 0.79600E+02, 0.79700E+02, 0.79800E+02, 0.79900E+02,
     &  0.80000E+02, 0.80100E+02, 0.80200E+02, 0.80300E+02, 0.80400E+02,
     &  0.80500E+02, 0.80600E+02, 0.80700E+02, 0.80800E+02, 0.80900E+02,
     &  0.81000E+02, 0.81100E+02, 0.81200E+02, 0.81300E+02, 0.81400E+02,
     &  0.81500E+02, 0.81600E+02, 0.81700E+02, 0.81800E+02, 0.81900E+02,
     &  0.82000E+02, 0.82100E+02, 0.82200E+02, 0.82300E+02, 0.82400E+02,
     &  0.82500E+02, 0.82600E+02, 0.82700E+02, 0.82800E+02, 0.82900E+02,
     &  0.83000E+02, 0.83100E+02, 0.83200E+02, 0.83300E+02, 0.83400E+02,
     &  0.83500E+02, 0.83600E+02, 0.83700E+02, 0.83800E+02, 0.83900E+02,
     &  0.84000E+02, 0.84100E+02, 0.84200E+02, 0.84300E+02, 0.84400E+02,
     &  0.84500E+02, 0.84600E+02, 0.84700E+02, 0.84800E+02, 0.84900E+02,
     &  0.85000E+02, 0.85100E+02, 0.85200E+02, 0.85300E+02, 0.85400E+02,
     &  0.85500E+02, 0.85600E+02, 0.85700E+02, 0.85800E+02, 0.85900E+02,
     &  0.86000E+02, 0.86100E+02, 0.86200E+02, 0.86300E+02, 0.86400E+02,
     &  0.86500E+02, 0.86600E+02, 0.86700E+02, 0.86800E+02, 0.86900E+02,
     &  0.87000E+02, 0.87100E+02, 0.87200E+02, 0.87300E+02, 0.87400E+02,
     &  0.87500E+02, 0.87600E+02, 0.87700E+02, 0.87800E+02, 0.87900E+02,
     &  0.88000E+02, 0.88100E+02, 0.88200E+02, 0.88300E+02, 0.88400E+02,
     &  0.88500E+02, 0.88600E+02, 0.88700E+02, 0.88800E+02, 0.88900E+02,
     &  0.89000E+02, 0.89100E+02, 0.89200E+02, 0.89300E+02, 0.89400E+02,
     &  0.89500E+02, 0.89600E+02, 0.89700E+02, 0.89800E+02, 0.89900E+02,
     &  0.90000E+02, 0.90100E+02, 0.90200E+02, 0.90300E+02, 0.90400E+02,
     &  0.90500E+02, 0.90600E+02, 0.90700E+02, 0.90800E+02, 0.90900E+02,
     &  0.91000E+02, 0.91100E+02, 0.91200E+02, 0.91300E+02, 0.91400E+02,
     &  0.91500E+02, 0.91600E+02, 0.91700E+02, 0.91800E+02, 0.91900E+02,
     &  0.92000E+02, 0.92100E+02, 0.92200E+02, 0.92300E+02, 0.92400E+02,
     &  0.92500E+02, 0.92600E+02, 0.92700E+02, 0.92800E+02, 0.92900E+02,
     &  0.93000E+02, 0.93100E+02, 0.93200E+02, 0.93300E+02, 0.93400E+02,
     &  0.93500E+02, 0.93600E+02, 0.93700E+02, 0.93800E+02, 0.93900E+02,
     &  0.94000E+02, 0.94100E+02, 0.94200E+02, 0.94300E+02, 0.94400E+02,
     &  0.94500E+02,
     &  0.94600E+02,
     &  0.94700E+02,
     &  0.94800E+02,
     &  0.94900E+02,
     &  0.95000E+02/
      Data (bdf(i),i=       1,     201)/
     &  0.11900E+02, 0.11770E+02, 0.11800E+02, 0.11740E+02, 0.11710E+02,
     &  0.11690E+02, 0.11680E+02, 0.11660E+02, 0.11710E+02, 0.11720E+02,
     &  0.11680E+02, 0.11540E+02, 0.11500E+02, 0.11430E+02, 0.11340E+02,
     &  0.11350E+02, 0.11400E+02, 0.11420E+02, 0.11400E+02, 0.11370E+02,
     &  0.11270E+02, 0.11200E+02, 0.11230E+02, 0.11330E+02, 0.11370E+02,
     &  0.11470E+02, 0.11550E+02, 0.11700E+02, 0.11900E+02, 0.12020E+02,
     &  0.12130E+02, 0.12220E+02, 0.12340E+02, 0.12480E+02, 0.12680E+02,
     &  0.12930E+02, 0.13200E+02, 0.13430E+02, 0.13730E+02, 0.13900E+02,
     &  0.14200E+02, 0.14540E+02, 0.14860E+02, 0.15300E+02, 0.15620E+02,
     &  0.15990E+02, 0.16390E+02, 0.16690E+02, 0.17100E+02, 0.17430E+02,
     &  0.17800E+02, 0.17830E+02, 0.17860E+02, 0.17910E+02, 0.18030E+02,
     &  0.18060E+02, 0.18080E+02, 0.18200E+02, 0.18130E+02, 0.18210E+02,
     &  0.18360E+02, 0.18360E+02, 0.18480E+02, 0.18480E+02, 0.18520E+02,
     &  0.18550E+02, 0.18670E+02, 0.18740E+02, 0.18870E+02, 0.18930E+02,
     &  0.19090E+02, 0.19230E+02, 0.19430E+02, 0.19510E+02, 0.19700E+02,
     &  0.19860E+02, 0.19990E+02, 0.20140E+02, 0.20330E+02, 0.20510E+02,
     &  0.20640E+02, 0.20830E+02, 0.20990E+02, 0.21260E+02, 0.21500E+02,
     &  0.21850E+02, 0.22170E+02, 0.22460E+02, 0.22740E+02, 0.23040E+02,
     &  0.23330E+02, 0.23500E+02, 0.23890E+02, 0.24140E+02, 0.24410E+02,
     &  0.24770E+02, 0.25050E+02, 0.25500E+02, 0.25790E+02, 0.26090E+02,
     &  0.26450E+02, 0.26260E+02, 0.25490E+02, 0.25140E+02, 0.24880E+02,
     &  0.24690E+02, 0.24580E+02, 0.24290E+02, 0.24030E+02, 0.23900E+02,
     &  0.23690E+02, 0.23450E+02, 0.23210E+02, 0.23080E+02, 0.22800E+02,
     &  0.22680E+02, 0.22500E+02, 0.22500E+02, 0.22460E+02, 0.22470E+02,
     &  0.22350E+02, 0.22390E+02, 0.22470E+02, 0.22590E+02, 0.22710E+02,
     &  0.22790E+02, 0.22940E+02, 0.23080E+02, 0.23140E+02, 0.23320E+02,
     &  0.23450E+02, 0.23290E+02, 0.23060E+02, 0.22880E+02, 0.22650E+02,
     &  0.22530E+02, 0.22450E+02, 0.22410E+02, 0.22240E+02, 0.22140E+02,
     &  0.21970E+02, 0.21860E+02, 0.21710E+02, 0.21700E+02, 0.21620E+02,
     &  0.21680E+02, 0.21640E+02, 0.21570E+02, 0.21660E+02, 0.21580E+02,
     &  0.21620E+02, 0.21460E+02, 0.21330E+02, 0.21290E+02, 0.21140E+02,
     &  0.21070E+02, 0.20950E+02, 0.20780E+02, 0.20660E+02, 0.20570E+02,
     &  0.20520E+02, 0.20540E+02, 0.20450E+02, 0.20440E+02, 0.20420E+02,
     &  0.20430E+02, 0.20450E+02, 0.20520E+02, 0.20540E+02, 0.20490E+02,
     &  0.20480E+02, 0.20220E+02, 0.20090E+02, 0.19900E+02, 0.19690E+02,
     &  0.19510E+02, 0.19290E+02, 0.19130E+02, 0.18890E+02, 0.18710E+02,
     &  0.18550E+02, 0.18410E+02, 0.18240E+02, 0.18070E+02, 0.17870E+02,
     &  0.17720E+02, 0.17550E+02, 0.17530E+02, 0.17410E+02, 0.17390E+02,
     &  0.17400E+02, 0.17300E+02, 0.17360E+02, 0.17320E+02, 0.17360E+02,
     &  0.17510E+02,
     &  0.17740E+02,
     &  0.17810E+02,
     &  0.18030E+02,
     &  0.18260E+02,
     &  0.18420E+02/
c
      massi = hmass(1)
      massx = hmass(npoint)
      dmass = (massx-massi)/Real(npoint-1)
c      
      imass = int( (mhiggs-massi)/dmass ) + 1
      If (imass.ge.1 .and. imass.lt.npoint) then
        jmass = imass + 1
        rmass = mhiggs - hmass(imass)
      Endif
      if (imass.le.0) then
        imass = 1
        jmass = 1
        rmass = 0.
      Endif
      if (imass.ge.npoint) then
        imass = npoint
        jmass = npoint
        rmass = 0.
      Endif
c
      A189_HVV_HGG_BACKG=bdf(imass)+(bdf(jmass)-bdf(imass))*rmass/dmass
c
      RETURN
      END
      REAL FUNCTION A192_HVV_HGG_BACKG(mhiggs)
      Implicit none
      Real mhiggs
      A192_HVV_HGG_BACKG = 3.9
      RETURN
      END
      INTEGER FUNCTION A192_HVV_HGG_CAND(mhiggs)
      Implicit none
      Real mhiggs
      A192_HVV_HGG_CAND = 2
      RETURN
      END
      REAL FUNCTION A196_HVV_HGG_BACKG(mhiggs)
      Implicit none
      Real mhiggs
      Real mh
c
      Integer npoint
      Parameter (npoint=301)
      Real hmass(npoint),bdf(npoint)
      Real massi,massx,dmass,rmass
      Integer i,imass,jmass
      Data (hmass(i),i=       1,     301)/
     &  0.65000E+02, 0.65100E+02, 0.65200E+02, 0.65300E+02, 0.65400E+02,
     &  0.65500E+02, 0.65600E+02, 0.65700E+02, 0.65800E+02, 0.65900E+02,
     &  0.66000E+02, 0.66100E+02, 0.66200E+02, 0.66300E+02, 0.66400E+02,
     &  0.66500E+02, 0.66600E+02, 0.66700E+02, 0.66800E+02, 0.66900E+02,
     &  0.67000E+02, 0.67100E+02, 0.67200E+02, 0.67300E+02, 0.67400E+02,
     &  0.67500E+02, 0.67600E+02, 0.67700E+02, 0.67800E+02, 0.67900E+02,
     &  0.68000E+02, 0.68100E+02, 0.68200E+02, 0.68300E+02, 0.68400E+02,
     &  0.68500E+02, 0.68600E+02, 0.68700E+02, 0.68800E+02, 0.68900E+02,
     &  0.69000E+02, 0.69100E+02, 0.69200E+02, 0.69300E+02, 0.69400E+02,
     &  0.69500E+02, 0.69600E+02, 0.69700E+02, 0.69800E+02, 0.69900E+02,
     &  0.70000E+02, 0.70100E+02, 0.70200E+02, 0.70300E+02, 0.70400E+02,
     &  0.70500E+02, 0.70600E+02, 0.70700E+02, 0.70800E+02, 0.70900E+02,
     &  0.71000E+02, 0.71100E+02, 0.71200E+02, 0.71300E+02, 0.71400E+02,
     &  0.71500E+02, 0.71600E+02, 0.71700E+02, 0.71800E+02, 0.71900E+02,
     &  0.72000E+02, 0.72100E+02, 0.72200E+02, 0.72300E+02, 0.72400E+02,
     &  0.72500E+02, 0.72600E+02, 0.72700E+02, 0.72800E+02, 0.72900E+02,
     &  0.73000E+02, 0.73100E+02, 0.73200E+02, 0.73300E+02, 0.73400E+02,
     &  0.73500E+02, 0.73600E+02, 0.73700E+02, 0.73800E+02, 0.73900E+02,
     &  0.74000E+02, 0.74100E+02, 0.74200E+02, 0.74300E+02, 0.74400E+02,
     &  0.74500E+02, 0.74600E+02, 0.74700E+02, 0.74800E+02, 0.74900E+02,
     &  0.75000E+02, 0.75100E+02, 0.75200E+02, 0.75300E+02, 0.75400E+02,
     &  0.75500E+02, 0.75600E+02, 0.75700E+02, 0.75800E+02, 0.75900E+02,
     &  0.76000E+02, 0.76100E+02, 0.76200E+02, 0.76300E+02, 0.76400E+02,
     &  0.76500E+02, 0.76600E+02, 0.76700E+02, 0.76800E+02, 0.76900E+02,
     &  0.77000E+02, 0.77100E+02, 0.77200E+02, 0.77300E+02, 0.77400E+02,
     &  0.77500E+02, 0.77600E+02, 0.77700E+02, 0.77800E+02, 0.77900E+02,
     &  0.78000E+02, 0.78100E+02, 0.78200E+02, 0.78300E+02, 0.78400E+02,
     &  0.78500E+02, 0.78600E+02, 0.78700E+02, 0.78800E+02, 0.78900E+02,
     &  0.79000E+02, 0.79100E+02, 0.79200E+02, 0.79300E+02, 0.79400E+02,
     &  0.79500E+02, 0.79600E+02, 0.79700E+02, 0.79800E+02, 0.79900E+02,
     &  0.80000E+02, 0.80100E+02, 0.80200E+02, 0.80300E+02, 0.80400E+02,
     &  0.80500E+02, 0.80600E+02, 0.80700E+02, 0.80800E+02, 0.80900E+02,
     &  0.81000E+02, 0.81100E+02, 0.81200E+02, 0.81300E+02, 0.81400E+02,
     &  0.81500E+02, 0.81600E+02, 0.81700E+02, 0.81800E+02, 0.81900E+02,
     &  0.82000E+02, 0.82100E+02, 0.82200E+02, 0.82300E+02, 0.82400E+02,
     &  0.82500E+02, 0.82600E+02, 0.82700E+02, 0.82800E+02, 0.82900E+02,
     &  0.83000E+02, 0.83100E+02, 0.83200E+02, 0.83300E+02, 0.83400E+02,
     &  0.83500E+02, 0.83600E+02, 0.83700E+02, 0.83800E+02, 0.83900E+02,
     &  0.84000E+02, 0.84100E+02, 0.84200E+02, 0.84300E+02, 0.84400E+02,
     &  0.84500E+02, 0.84600E+02, 0.84700E+02, 0.84800E+02, 0.84900E+02,
     &  0.85000E+02, 0.85100E+02, 0.85200E+02, 0.85300E+02, 0.85400E+02,
     &  0.85500E+02, 0.85600E+02, 0.85700E+02, 0.85800E+02, 0.85900E+02,
     &  0.86000E+02, 0.86100E+02, 0.86200E+02, 0.86300E+02, 0.86400E+02,
     &  0.86500E+02, 0.86600E+02, 0.86700E+02, 0.86800E+02, 0.86900E+02,
     &  0.87000E+02, 0.87100E+02, 0.87200E+02, 0.87300E+02, 0.87400E+02,
     &  0.87500E+02, 0.87600E+02, 0.87700E+02, 0.87800E+02, 0.87900E+02,
     &  0.88000E+02, 0.88100E+02, 0.88200E+02, 0.88300E+02, 0.88400E+02,
     &  0.88500E+02, 0.88600E+02, 0.88700E+02, 0.88800E+02, 0.88900E+02,
     &  0.89000E+02, 0.89100E+02, 0.89200E+02, 0.89300E+02, 0.89400E+02,
     &  0.89500E+02, 0.89600E+02, 0.89700E+02, 0.89800E+02, 0.89900E+02,
     &  0.90000E+02, 0.90100E+02, 0.90200E+02, 0.90300E+02, 0.90400E+02,
     &  0.90500E+02, 0.90600E+02, 0.90700E+02, 0.90800E+02, 0.90900E+02,
     &  0.91000E+02, 0.91100E+02, 0.91200E+02, 0.91300E+02, 0.91400E+02,
     &  0.91500E+02, 0.91600E+02, 0.91700E+02, 0.91800E+02, 0.91900E+02,
     &  0.92000E+02, 0.92100E+02, 0.92200E+02, 0.92300E+02, 0.92400E+02,
     &  0.92500E+02, 0.92600E+02, 0.92700E+02, 0.92800E+02, 0.92900E+02,
     &  0.93000E+02, 0.93100E+02, 0.93200E+02, 0.93300E+02, 0.93400E+02,
     &  0.93500E+02, 0.93600E+02, 0.93700E+02, 0.93800E+02, 0.93900E+02,
     &  0.94000E+02, 0.94100E+02, 0.94200E+02, 0.94300E+02, 0.94400E+02,
     &  0.94500E+02,
     &  0.94600E+02,
     &  0.94700E+02,
     &  0.94800E+02,
     &  0.94900E+02,
     &  0.95000E+02/
      Data (bdf(i),i=       1,     301)/
     &  0.76000E+00, 0.77000E+00, 0.78000E+00, 0.79000E+00, 0.80000E+00,
     &  0.82000E+00, 0.84000E+00, 0.85000E+00, 0.87000E+00, 0.89000E+00,
     &  0.90000E+00, 0.90000E+00, 0.92000E+00, 0.94000E+00, 0.95000E+00,
     &  0.97000E+00, 0.97000E+00, 0.99000E+00, 0.99000E+00, 0.10000E+01,
     &  0.10300E+01, 0.10700E+01, 0.10700E+01, 0.11000E+01, 0.11300E+01,
     &  0.11600E+01, 0.11700E+01, 0.12100E+01, 0.12300E+01, 0.12600E+01,
     &  0.13200E+01, 0.13500E+01, 0.14100E+01, 0.14800E+01, 0.15200E+01,
     &  0.15900E+01, 0.16600E+01, 0.17300E+01, 0.17800E+01, 0.18300E+01,
     &  0.19300E+01, 0.20000E+01, 0.20500E+01, 0.21600E+01, 0.22500E+01,
     &  0.23700E+01, 0.24800E+01, 0.25900E+01, 0.26900E+01, 0.28100E+01,
     &  0.29300E+01, 0.29000E+01, 0.29000E+01, 0.28900E+01, 0.28600E+01,
     &  0.28400E+01, 0.28600E+01, 0.28500E+01, 0.28500E+01, 0.28200E+01,
     &  0.28200E+01, 0.28100E+01, 0.28100E+01, 0.28000E+01, 0.28000E+01,
     &  0.28200E+01, 0.28500E+01, 0.28600E+01, 0.28800E+01, 0.29200E+01,
     &  0.29200E+01, 0.29100E+01, 0.29900E+01, 0.30200E+01, 0.30400E+01,
     &  0.30700E+01, 0.31100E+01, 0.31900E+01, 0.32300E+01, 0.33600E+01,
     &  0.34500E+01, 0.35400E+01, 0.35900E+01, 0.37300E+01, 0.38500E+01,
     &  0.40200E+01, 0.41600E+01, 0.43100E+01, 0.44200E+01, 0.45000E+01,
     &  0.46600E+01, 0.47900E+01, 0.48900E+01, 0.50000E+01, 0.51100E+01,
     &  0.52300E+01, 0.53600E+01, 0.54100E+01, 0.55100E+01, 0.55500E+01,
     &  0.56900E+01, 0.56800E+01, 0.57500E+01, 0.58000E+01, 0.58100E+01,
     &  0.58500E+01, 0.58800E+01, 0.58300E+01, 0.58600E+01, 0.59000E+01,
     &  0.58900E+01, 0.59000E+01, 0.59300E+01, 0.59000E+01, 0.59200E+01,
     &  0.59400E+01, 0.59100E+01, 0.59200E+01, 0.59200E+01, 0.59300E+01,
     &  0.59600E+01, 0.60000E+01, 0.60400E+01, 0.61500E+01, 0.61600E+01,
     &  0.61700E+01, 0.62800E+01, 0.63800E+01, 0.65100E+01, 0.65800E+01,
     &  0.66900E+01, 0.68100E+01, 0.69600E+01, 0.70400E+01, 0.71800E+01,
     &  0.72900E+01, 0.74300E+01, 0.75900E+01, 0.77000E+01, 0.78800E+01,
     &  0.80300E+01, 0.81500E+01, 0.82600E+01, 0.83800E+01, 0.85400E+01,
     &  0.86900E+01, 0.88100E+01, 0.89700E+01, 0.91000E+01, 0.92400E+01,
     &  0.93300E+01, 0.93800E+01, 0.93800E+01, 0.93700E+01, 0.93900E+01,
     &  0.94600E+01, 0.95400E+01, 0.96100E+01, 0.97000E+01, 0.97700E+01,
     &  0.97200E+01, 0.97200E+01, 0.97800E+01, 0.98600E+01, 0.99100E+01,
     &  0.10020E+02, 0.10170E+02, 0.10290E+02, 0.10380E+02, 0.10510E+02,
     &  0.10650E+02, 0.10810E+02, 0.10930E+02, 0.11060E+02, 0.11220E+02,
     &  0.11410E+02, 0.11560E+02, 0.11750E+02, 0.11890E+02, 0.12110E+02,
     &  0.12360E+02, 0.12520E+02, 0.12700E+02, 0.12850E+02, 0.12970E+02,
     &  0.13130E+02, 0.13270E+02, 0.13410E+02, 0.13560E+02, 0.13710E+02,
     &  0.13910E+02, 0.14080E+02, 0.14230E+02, 0.14360E+02, 0.14520E+02,
     &  0.14650E+02, 0.14760E+02, 0.14860E+02, 0.15040E+02, 0.15190E+02,
     &  0.15290E+02, 0.15230E+02, 0.15230E+02, 0.15220E+02, 0.15170E+02,
     &  0.15030E+02, 0.14950E+02, 0.14860E+02, 0.14820E+02, 0.14700E+02,
     &  0.14640E+02, 0.14540E+02, 0.14440E+02, 0.14380E+02, 0.14290E+02,
     &  0.14170E+02, 0.14150E+02, 0.14090E+02, 0.14040E+02, 0.14000E+02,
     &  0.13910E+02, 0.13870E+02, 0.13800E+02, 0.13770E+02, 0.13700E+02,
     &  0.13660E+02, 0.13640E+02, 0.13630E+02, 0.13680E+02, 0.13670E+02,
     &  0.13690E+02, 0.13670E+02, 0.13650E+02, 0.13690E+02, 0.13660E+02,
     &  0.13680E+02, 0.13720E+02, 0.13800E+02, 0.13840E+02, 0.13870E+02,
     &  0.13910E+02, 0.13940E+02, 0.13970E+02, 0.13990E+02, 0.14000E+02,
     &  0.13990E+02, 0.14030E+02, 0.14020E+02, 0.14060E+02, 0.14050E+02,
     &  0.14110E+02, 0.13930E+02, 0.13770E+02, 0.13610E+02, 0.13400E+02,
     &  0.13250E+02, 0.13100E+02, 0.12930E+02, 0.12730E+02, 0.12550E+02,
     &  0.12420E+02, 0.12270E+02, 0.12090E+02, 0.11910E+02, 0.11770E+02,
     &  0.11640E+02, 0.11490E+02, 0.11310E+02, 0.11090E+02, 0.10960E+02,
     &  0.10820E+02, 0.10690E+02, 0.10570E+02, 0.10390E+02, 0.10210E+02,
     &  0.10060E+02, 0.98700E+01, 0.97300E+01, 0.96300E+01, 0.95100E+01,
     &  0.94000E+01, 0.93100E+01, 0.92000E+01, 0.90700E+01, 0.89600E+01,
     &  0.88500E+01, 0.87600E+01, 0.87100E+01, 0.86100E+01, 0.85100E+01,
     &  0.83900E+01, 0.82900E+01, 0.81900E+01, 0.81200E+01, 0.80100E+01,
     &  0.79300E+01,
     &  0.78600E+01,
     &  0.77900E+01,
     &  0.77200E+01,
     &  0.76400E+01,
     &  0.75700E+01/
c
      massi = hmass(1)
      massx = hmass(npoint)
      dmass = (massx-massi)/Real(npoint-1)
c      
      imass = int( (mhiggs-massi)/dmass ) + 1
      If (imass.ge.1 .and. imass.lt.npoint) then
        jmass = imass + 1
        rmass = mhiggs - hmass(imass)
      Endif
      if (imass.le.0) then
        imass = 1
        jmass = 1
        rmass = 0.
      Endif
      if (imass.ge.npoint) then
        imass = npoint
        jmass = npoint
        rmass = 0.
      Endif
c
      A196_HVV_HGG_BACKG=bdf(imass)+(bdf(jmass)-bdf(imass))*rmass/dmass
c
      RETURN
      END
      REAL FUNCTION A200_HVV_HGG_BACKG(mhiggs)
      Implicit none
      Real mhiggs
      Real mh
c
      Integer npoint
      Parameter (npoint=301)
      Real hmass(npoint),bdf(npoint)
      Real massi,massx,dmass,rmass
      Integer i,imass,jmass
      Data (hmass(i),i=       1,     301)/
     &  0.70000E+02, 0.70100E+02, 0.70200E+02, 0.70300E+02, 0.70400E+02,
     &  0.70500E+02, 0.70600E+02, 0.70700E+02, 0.70800E+02, 0.70900E+02,
     &  0.71000E+02, 0.71100E+02, 0.71200E+02, 0.71300E+02, 0.71400E+02,
     &  0.71500E+02, 0.71600E+02, 0.71700E+02, 0.71800E+02, 0.71900E+02,
     &  0.72000E+02, 0.72100E+02, 0.72200E+02, 0.72300E+02, 0.72400E+02,
     &  0.72500E+02, 0.72600E+02, 0.72700E+02, 0.72800E+02, 0.72900E+02,
     &  0.73000E+02, 0.73100E+02, 0.73200E+02, 0.73300E+02, 0.73400E+02,
     &  0.73500E+02, 0.73600E+02, 0.73700E+02, 0.73800E+02, 0.73900E+02,
     &  0.74000E+02, 0.74100E+02, 0.74200E+02, 0.74300E+02, 0.74400E+02,
     &  0.74500E+02, 0.74600E+02, 0.74700E+02, 0.74800E+02, 0.74900E+02,
     &  0.75000E+02, 0.75100E+02, 0.75200E+02, 0.75300E+02, 0.75400E+02,
     &  0.75500E+02, 0.75600E+02, 0.75700E+02, 0.75800E+02, 0.75900E+02,
     &  0.76000E+02, 0.76100E+02, 0.76200E+02, 0.76300E+02, 0.76400E+02,
     &  0.76500E+02, 0.76600E+02, 0.76700E+02, 0.76800E+02, 0.76900E+02,
     &  0.77000E+02, 0.77100E+02, 0.77200E+02, 0.77300E+02, 0.77400E+02,
     &  0.77500E+02, 0.77600E+02, 0.77700E+02, 0.77800E+02, 0.77900E+02,
     &  0.78000E+02, 0.78100E+02, 0.78200E+02, 0.78300E+02, 0.78400E+02,
     &  0.78500E+02, 0.78600E+02, 0.78700E+02, 0.78800E+02, 0.78900E+02,
     &  0.79000E+02, 0.79100E+02, 0.79200E+02, 0.79300E+02, 0.79400E+02,
     &  0.79500E+02, 0.79600E+02, 0.79700E+02, 0.79800E+02, 0.79900E+02,
     &  0.80000E+02, 0.80100E+02, 0.80200E+02, 0.80300E+02, 0.80400E+02,
     &  0.80500E+02, 0.80600E+02, 0.80700E+02, 0.80800E+02, 0.80900E+02,
     &  0.81000E+02, 0.81100E+02, 0.81200E+02, 0.81300E+02, 0.81400E+02,
     &  0.81500E+02, 0.81600E+02, 0.81700E+02, 0.81800E+02, 0.81900E+02,
     &  0.82000E+02, 0.82100E+02, 0.82200E+02, 0.82300E+02, 0.82400E+02,
     &  0.82500E+02, 0.82600E+02, 0.82700E+02, 0.82800E+02, 0.82900E+02,
     &  0.83000E+02, 0.83100E+02, 0.83200E+02, 0.83300E+02, 0.83400E+02,
     &  0.83500E+02, 0.83600E+02, 0.83700E+02, 0.83800E+02, 0.83900E+02,
     &  0.84000E+02, 0.84100E+02, 0.84200E+02, 0.84300E+02, 0.84400E+02,
     &  0.84500E+02, 0.84600E+02, 0.84700E+02, 0.84800E+02, 0.84900E+02,
     &  0.85000E+02, 0.85100E+02, 0.85200E+02, 0.85300E+02, 0.85400E+02,
     &  0.85500E+02, 0.85600E+02, 0.85700E+02, 0.85800E+02, 0.85900E+02,
     &  0.86000E+02, 0.86100E+02, 0.86200E+02, 0.86300E+02, 0.86400E+02,
     &  0.86500E+02, 0.86600E+02, 0.86700E+02, 0.86800E+02, 0.86900E+02,
     &  0.87000E+02, 0.87100E+02, 0.87200E+02, 0.87300E+02, 0.87400E+02,
     &  0.87500E+02, 0.87600E+02, 0.87700E+02, 0.87800E+02, 0.87900E+02,
     &  0.88000E+02, 0.88100E+02, 0.88200E+02, 0.88300E+02, 0.88400E+02,
     &  0.88500E+02, 0.88600E+02, 0.88700E+02, 0.88800E+02, 0.88900E+02,
     &  0.89000E+02, 0.89100E+02, 0.89200E+02, 0.89300E+02, 0.89400E+02,
     &  0.89500E+02, 0.89600E+02, 0.89700E+02, 0.89800E+02, 0.89900E+02,
     &  0.90000E+02, 0.90100E+02, 0.90200E+02, 0.90300E+02, 0.90400E+02,
     &  0.90500E+02, 0.90600E+02, 0.90700E+02, 0.90800E+02, 0.90900E+02,
     &  0.91000E+02, 0.91100E+02, 0.91200E+02, 0.91300E+02, 0.91400E+02,
     &  0.91500E+02, 0.91600E+02, 0.91700E+02, 0.91800E+02, 0.91900E+02,
     &  0.92000E+02, 0.92100E+02, 0.92200E+02, 0.92300E+02, 0.92400E+02,
     &  0.92500E+02, 0.92600E+02, 0.92700E+02, 0.92800E+02, 0.92900E+02,
     &  0.93000E+02, 0.93100E+02, 0.93200E+02, 0.93300E+02, 0.93400E+02,
     &  0.93500E+02, 0.93600E+02, 0.93700E+02, 0.93800E+02, 0.93900E+02,
     &  0.94000E+02, 0.94100E+02, 0.94200E+02, 0.94300E+02, 0.94400E+02,
     &  0.94500E+02, 0.94600E+02, 0.94700E+02, 0.94800E+02, 0.94900E+02,
     &  0.95000E+02, 0.95100E+02, 0.95200E+02, 0.95300E+02, 0.95400E+02,
     &  0.95500E+02, 0.95600E+02, 0.95700E+02, 0.95800E+02, 0.95900E+02,
     &  0.96000E+02, 0.96100E+02, 0.96200E+02, 0.96300E+02, 0.96400E+02,
     &  0.96500E+02, 0.96600E+02, 0.96700E+02, 0.96800E+02, 0.96900E+02,
     &  0.97000E+02, 0.97100E+02, 0.97200E+02, 0.97300E+02, 0.97400E+02,
     &  0.97500E+02, 0.97600E+02, 0.97700E+02, 0.97800E+02, 0.97900E+02,
     &  0.98000E+02, 0.98100E+02, 0.98200E+02, 0.98300E+02, 0.98400E+02,
     &  0.98500E+02, 0.98600E+02, 0.98700E+02, 0.98800E+02, 0.98900E+02,
     &  0.99000E+02, 0.99100E+02, 0.99200E+02, 0.99300E+02, 0.99400E+02,
     &  0.99500E+02,
     &  0.99600E+02,
     &  0.99700E+02,
     &  0.99800E+02,
     &  0.99900E+02,
     &  0.10000E+03/
      Data (bdf(i),i=       1,     301)/
     &  0.21600E+01, 0.21900E+01, 0.22200E+01, 0.22300E+01, 0.22800E+01,
     &  0.23200E+01, 0.23200E+01, 0.23800E+01, 0.24000E+01, 0.24600E+01,
     &  0.25200E+01, 0.25300E+01, 0.25800E+01, 0.26200E+01, 0.26600E+01,
     &  0.26900E+01, 0.27300E+01, 0.27500E+01, 0.28100E+01, 0.28400E+01,
     &  0.29000E+01, 0.29800E+01, 0.30400E+01, 0.31100E+01, 0.31600E+01,
     &  0.32300E+01, 0.33100E+01, 0.33700E+01, 0.34600E+01, 0.35700E+01,
     &  0.36500E+01, 0.37500E+01, 0.38600E+01, 0.39500E+01, 0.40700E+01,
     &  0.41500E+01, 0.43100E+01, 0.44500E+01, 0.46000E+01, 0.47300E+01,
     &  0.49200E+01, 0.50900E+01, 0.52700E+01, 0.54500E+01, 0.57100E+01,
     &  0.59100E+01, 0.61200E+01, 0.63100E+01, 0.64600E+01, 0.66900E+01,
     &  0.68900E+01, 0.69000E+01, 0.69300E+01, 0.69300E+01, 0.69200E+01,
     &  0.69200E+01, 0.69000E+01, 0.68800E+01, 0.68900E+01, 0.68900E+01,
     &  0.69100E+01, 0.68600E+01, 0.68700E+01, 0.68700E+01, 0.68700E+01,
     &  0.68600E+01, 0.68700E+01, 0.68600E+01, 0.68400E+01, 0.67600E+01,
     &  0.67400E+01, 0.67200E+01, 0.67600E+01, 0.68100E+01, 0.67700E+01,
     &  0.67600E+01, 0.68100E+01, 0.68400E+01, 0.69000E+01, 0.70000E+01,
     &  0.70800E+01, 0.71900E+01, 0.72700E+01, 0.73600E+01, 0.74500E+01,
     &  0.75900E+01, 0.77300E+01, 0.78000E+01, 0.78400E+01, 0.79800E+01,
     &  0.81300E+01, 0.83000E+01, 0.84000E+01, 0.84600E+01, 0.85300E+01,
     &  0.86400E+01, 0.87000E+01, 0.87200E+01, 0.87800E+01, 0.87700E+01,
     &  0.87700E+01, 0.88000E+01, 0.88800E+01, 0.88800E+01, 0.89100E+01,
     &  0.88800E+01, 0.88600E+01, 0.88400E+01, 0.88500E+01, 0.87900E+01,
     &  0.87600E+01, 0.87500E+01, 0.87800E+01, 0.87500E+01, 0.87500E+01,
     &  0.87700E+01, 0.87100E+01, 0.87700E+01, 0.87700E+01, 0.87200E+01,
     &  0.87500E+01, 0.87100E+01, 0.86800E+01, 0.86800E+01, 0.86900E+01,
     &  0.87300E+01, 0.88100E+01, 0.87900E+01, 0.88400E+01, 0.90000E+01,
     &  0.90500E+01, 0.91700E+01, 0.92100E+01, 0.93400E+01, 0.94100E+01,
     &  0.95300E+01, 0.97300E+01, 0.98100E+01, 0.99600E+01, 0.10130E+02,
     &  0.10270E+02, 0.10410E+02, 0.10560E+02, 0.10700E+02, 0.10850E+02,
     &  0.11040E+02, 0.11080E+02, 0.11210E+02, 0.11370E+02, 0.11540E+02,
     &  0.11660E+02, 0.11710E+02, 0.11830E+02, 0.11950E+02, 0.11990E+02,
     &  0.12030E+02, 0.12010E+02, 0.12100E+02, 0.12260E+02, 0.12390E+02,
     &  0.12460E+02, 0.12590E+02, 0.12670E+02, 0.12820E+02, 0.12960E+02,
     &  0.13050E+02, 0.13180E+02, 0.13380E+02, 0.13560E+02, 0.13720E+02,
     &  0.13800E+02, 0.13960E+02, 0.14170E+02, 0.14290E+02, 0.14400E+02,
     &  0.14490E+02, 0.14660E+02, 0.14820E+02, 0.14920E+02, 0.15100E+02,
     &  0.15270E+02, 0.15440E+02, 0.15610E+02, 0.15770E+02, 0.15940E+02,
     &  0.16010E+02, 0.16130E+02, 0.16200E+02, 0.16300E+02, 0.16380E+02,
     &  0.16480E+02, 0.16570E+02, 0.16730E+02, 0.16820E+02, 0.16940E+02,
     &  0.17020E+02, 0.17100E+02, 0.17210E+02, 0.17250E+02, 0.17380E+02,
     &  0.17470E+02, 0.17270E+02, 0.17140E+02, 0.16950E+02, 0.16790E+02,
     &  0.16600E+02, 0.16380E+02, 0.16160E+02, 0.15930E+02, 0.15730E+02,
     &  0.15500E+02, 0.15360E+02, 0.15210E+02, 0.15000E+02, 0.14840E+02,
     &  0.14650E+02, 0.14510E+02, 0.14320E+02, 0.14160E+02, 0.14020E+02,
     &  0.13860E+02, 0.13670E+02, 0.13490E+02, 0.13330E+02, 0.13140E+02,
     &  0.12990E+02, 0.12900E+02, 0.12770E+02, 0.12680E+02, 0.12570E+02,
     &  0.12440E+02, 0.12310E+02, 0.12270E+02, 0.12180E+02, 0.12080E+02,
     &  0.11990E+02, 0.11940E+02, 0.11880E+02, 0.11780E+02, 0.11790E+02,
     &  0.11750E+02, 0.11700E+02, 0.11650E+02, 0.11600E+02, 0.11550E+02,
     &  0.11530E+02, 0.11490E+02, 0.11480E+02, 0.11470E+02, 0.11420E+02,
     &  0.11390E+02, 0.11130E+02, 0.10880E+02, 0.10680E+02, 0.10440E+02,
     &  0.10210E+02, 0.99400E+01, 0.96900E+01, 0.94800E+01, 0.92500E+01,
     &  0.90500E+01, 0.88500E+01, 0.86300E+01, 0.83900E+01, 0.82200E+01,
     &  0.79900E+01, 0.78300E+01, 0.76200E+01, 0.74600E+01, 0.72300E+01,
     &  0.70400E+01, 0.68000E+01, 0.66000E+01, 0.64500E+01, 0.62700E+01,
     &  0.61600E+01, 0.60500E+01, 0.59300E+01, 0.58400E+01, 0.57400E+01,
     &  0.56400E+01, 0.55700E+01, 0.54600E+01, 0.53500E+01, 0.52700E+01,
     &  0.52300E+01, 0.51800E+01, 0.51400E+01, 0.50600E+01, 0.49700E+01,
     &  0.48800E+01, 0.48100E+01, 0.47300E+01, 0.46800E+01, 0.46700E+01,
     &  0.46000E+01,
     &  0.45400E+01,
     &  0.44700E+01,
     &  0.44400E+01,
     &  0.44100E+01,
     &  0.43600E+01/
c
      massi = hmass(1)
      massx = hmass(npoint)
      dmass = (massx-massi)/Real(npoint-1)
c      
      imass = int( (mhiggs-massi)/dmass ) + 1
      If (imass.ge.1 .and. imass.lt.npoint) then
        jmass = imass + 1
        rmass = mhiggs - hmass(imass)
      Endif
      if (imass.le.0) then
        imass = 1
        jmass = 1
        rmass = 0.
      Endif
      if (imass.ge.npoint) then
        imass = npoint
        jmass = npoint
        rmass = 0.
      Endif
c
      A200_HVV_HGG_BACKG=bdf(imass)+(bdf(jmass)-bdf(imass))*rmass/dmass
c
      RETURN
      END
      REAL FUNCTION A202_HVV_HGG_BACKG(mhiggs)
      Implicit none
      Real mhiggs
      Real mh
c
      Integer npoint
      Parameter (npoint=301)
      Real hmass(npoint),bdf(npoint)
      Real massi,massx,dmass,rmass
      Integer i,imass,jmass
      Data (hmass(i),i=       1,     301)/
     &  0.70000E+02, 0.70100E+02, 0.70200E+02, 0.70300E+02, 0.70400E+02,
     &  0.70500E+02, 0.70600E+02, 0.70700E+02, 0.70800E+02, 0.70900E+02,
     &  0.71000E+02, 0.71100E+02, 0.71200E+02, 0.71300E+02, 0.71400E+02,
     &  0.71500E+02, 0.71600E+02, 0.71700E+02, 0.71800E+02, 0.71900E+02,
     &  0.72000E+02, 0.72100E+02, 0.72200E+02, 0.72300E+02, 0.72400E+02,
     &  0.72500E+02, 0.72600E+02, 0.72700E+02, 0.72800E+02, 0.72900E+02,
     &  0.73000E+02, 0.73100E+02, 0.73200E+02, 0.73300E+02, 0.73400E+02,
     &  0.73500E+02, 0.73600E+02, 0.73700E+02, 0.73800E+02, 0.73900E+02,
     &  0.74000E+02, 0.74100E+02, 0.74200E+02, 0.74300E+02, 0.74400E+02,
     &  0.74500E+02, 0.74600E+02, 0.74700E+02, 0.74800E+02, 0.74900E+02,
     &  0.75000E+02, 0.75100E+02, 0.75200E+02, 0.75300E+02, 0.75400E+02,
     &  0.75500E+02, 0.75600E+02, 0.75700E+02, 0.75800E+02, 0.75900E+02,
     &  0.76000E+02, 0.76100E+02, 0.76200E+02, 0.76300E+02, 0.76400E+02,
     &  0.76500E+02, 0.76600E+02, 0.76700E+02, 0.76800E+02, 0.76900E+02,
     &  0.77000E+02, 0.77100E+02, 0.77200E+02, 0.77300E+02, 0.77400E+02,
     &  0.77500E+02, 0.77600E+02, 0.77700E+02, 0.77800E+02, 0.77900E+02,
     &  0.78000E+02, 0.78100E+02, 0.78200E+02, 0.78300E+02, 0.78400E+02,
     &  0.78500E+02, 0.78600E+02, 0.78700E+02, 0.78800E+02, 0.78900E+02,
     &  0.79000E+02, 0.79100E+02, 0.79200E+02, 0.79300E+02, 0.79400E+02,
     &  0.79500E+02, 0.79600E+02, 0.79700E+02, 0.79800E+02, 0.79900E+02,
     &  0.80000E+02, 0.80100E+02, 0.80200E+02, 0.80300E+02, 0.80400E+02,
     &  0.80500E+02, 0.80600E+02, 0.80700E+02, 0.80800E+02, 0.80900E+02,
     &  0.81000E+02, 0.81100E+02, 0.81200E+02, 0.81300E+02, 0.81400E+02,
     &  0.81500E+02, 0.81600E+02, 0.81700E+02, 0.81800E+02, 0.81900E+02,
     &  0.82000E+02, 0.82100E+02, 0.82200E+02, 0.82300E+02, 0.82400E+02,
     &  0.82500E+02, 0.82600E+02, 0.82700E+02, 0.82800E+02, 0.82900E+02,
     &  0.83000E+02, 0.83100E+02, 0.83200E+02, 0.83300E+02, 0.83400E+02,
     &  0.83500E+02, 0.83600E+02, 0.83700E+02, 0.83800E+02, 0.83900E+02,
     &  0.84000E+02, 0.84100E+02, 0.84200E+02, 0.84300E+02, 0.84400E+02,
     &  0.84500E+02, 0.84600E+02, 0.84700E+02, 0.84800E+02, 0.84900E+02,
     &  0.85000E+02, 0.85100E+02, 0.85200E+02, 0.85300E+02, 0.85400E+02,
     &  0.85500E+02, 0.85600E+02, 0.85700E+02, 0.85800E+02, 0.85900E+02,
     &  0.86000E+02, 0.86100E+02, 0.86200E+02, 0.86300E+02, 0.86400E+02,
     &  0.86500E+02, 0.86600E+02, 0.86700E+02, 0.86800E+02, 0.86900E+02,
     &  0.87000E+02, 0.87100E+02, 0.87200E+02, 0.87300E+02, 0.87400E+02,
     &  0.87500E+02, 0.87600E+02, 0.87700E+02, 0.87800E+02, 0.87900E+02,
     &  0.88000E+02, 0.88100E+02, 0.88200E+02, 0.88300E+02, 0.88400E+02,
     &  0.88500E+02, 0.88600E+02, 0.88700E+02, 0.88800E+02, 0.88900E+02,
     &  0.89000E+02, 0.89100E+02, 0.89200E+02, 0.89300E+02, 0.89400E+02,
     &  0.89500E+02, 0.89600E+02, 0.89700E+02, 0.89800E+02, 0.89900E+02,
     &  0.90000E+02, 0.90100E+02, 0.90200E+02, 0.90300E+02, 0.90400E+02,
     &  0.90500E+02, 0.90600E+02, 0.90700E+02, 0.90800E+02, 0.90900E+02,
     &  0.91000E+02, 0.91100E+02, 0.91200E+02, 0.91300E+02, 0.91400E+02,
     &  0.91500E+02, 0.91600E+02, 0.91700E+02, 0.91800E+02, 0.91900E+02,
     &  0.92000E+02, 0.92100E+02, 0.92200E+02, 0.92300E+02, 0.92400E+02,
     &  0.92500E+02, 0.92600E+02, 0.92700E+02, 0.92800E+02, 0.92900E+02,
     &  0.93000E+02, 0.93100E+02, 0.93200E+02, 0.93300E+02, 0.93400E+02,
     &  0.93500E+02, 0.93600E+02, 0.93700E+02, 0.93800E+02, 0.93900E+02,
     &  0.94000E+02, 0.94100E+02, 0.94200E+02, 0.94300E+02, 0.94400E+02,
     &  0.94500E+02, 0.94600E+02, 0.94700E+02, 0.94800E+02, 0.94900E+02,
     &  0.95000E+02, 0.95100E+02, 0.95200E+02, 0.95300E+02, 0.95400E+02,
     &  0.95500E+02, 0.95600E+02, 0.95700E+02, 0.95800E+02, 0.95900E+02,
     &  0.96000E+02, 0.96100E+02, 0.96200E+02, 0.96300E+02, 0.96400E+02,
     &  0.96500E+02, 0.96600E+02, 0.96700E+02, 0.96800E+02, 0.96900E+02,
     &  0.97000E+02, 0.97100E+02, 0.97200E+02, 0.97300E+02, 0.97400E+02,
     &  0.97500E+02, 0.97600E+02, 0.97700E+02, 0.97800E+02, 0.97900E+02,
     &  0.98000E+02, 0.98100E+02, 0.98200E+02, 0.98300E+02, 0.98400E+02,
     &  0.98500E+02, 0.98600E+02, 0.98700E+02, 0.98800E+02, 0.98900E+02,
     &  0.99000E+02, 0.99100E+02, 0.99200E+02, 0.99300E+02, 0.99400E+02,
     &  0.99500E+02,
     &  0.99600E+02,
     &  0.99700E+02,
     &  0.99800E+02,
     &  0.99900E+02,
     &  0.10000E+03/
      Data (bdf(i),i=       1,     301)/
     &  0.17500E+01, 0.17600E+01, 0.17600E+01, 0.17800E+01, 0.18000E+01,
     &  0.18000E+01, 0.18000E+01, 0.18100E+01, 0.18300E+01, 0.18300E+01,
     &  0.18400E+01, 0.18500E+01, 0.18800E+01, 0.18900E+01, 0.19300E+01,
     &  0.19700E+01, 0.19800E+01, 0.20200E+01, 0.20300E+01, 0.20500E+01,
     &  0.20800E+01, 0.21300E+01, 0.21800E+01, 0.22200E+01, 0.22500E+01,
     &  0.23000E+01, 0.23300E+01, 0.23900E+01, 0.24500E+01, 0.25100E+01,
     &  0.25900E+01, 0.26600E+01, 0.27400E+01, 0.28200E+01, 0.29000E+01,
     &  0.29700E+01, 0.30500E+01, 0.31300E+01, 0.32100E+01, 0.33000E+01,
     &  0.33900E+01, 0.34900E+01, 0.35700E+01, 0.36600E+01, 0.38000E+01,
     &  0.39100E+01, 0.40100E+01, 0.41400E+01, 0.42300E+01, 0.43400E+01,
     &  0.44600E+01, 0.44900E+01, 0.44600E+01, 0.44300E+01, 0.44200E+01,
     &  0.44100E+01, 0.44000E+01, 0.43800E+01, 0.43600E+01, 0.43500E+01,
     &  0.43400E+01, 0.43500E+01, 0.43400E+01, 0.43200E+01, 0.43200E+01,
     &  0.42900E+01, 0.42800E+01, 0.42700E+01, 0.42600E+01, 0.42400E+01,
     &  0.42200E+01, 0.42000E+01, 0.41900E+01, 0.41600E+01, 0.41400E+01,
     &  0.41400E+01, 0.41300E+01, 0.41100E+01, 0.41100E+01, 0.41200E+01,
     &  0.41100E+01, 0.41200E+01, 0.41200E+01, 0.41600E+01, 0.41700E+01,
     &  0.42100E+01, 0.42200E+01, 0.42300E+01, 0.42600E+01, 0.43000E+01,
     &  0.43400E+01, 0.44000E+01, 0.44400E+01, 0.44600E+01, 0.45200E+01,
     &  0.45600E+01, 0.45900E+01, 0.45900E+01, 0.46100E+01, 0.46200E+01,
     &  0.46000E+01, 0.46400E+01, 0.46400E+01, 0.46600E+01, 0.46500E+01,
     &  0.46700E+01, 0.46600E+01, 0.46500E+01, 0.46800E+01, 0.46800E+01,
     &  0.46900E+01, 0.46800E+01, 0.46500E+01, 0.46500E+01, 0.46400E+01,
     &  0.46300E+01, 0.46500E+01, 0.46600E+01, 0.46900E+01, 0.46900E+01,
     &  0.46800E+01, 0.46800E+01, 0.46900E+01, 0.46800E+01, 0.47100E+01,
     &  0.47100E+01, 0.47200E+01, 0.47400E+01, 0.47800E+01, 0.48500E+01,
     &  0.48900E+01, 0.49500E+01, 0.49800E+01, 0.50400E+01, 0.51000E+01,
     &  0.51500E+01, 0.52400E+01, 0.52900E+01, 0.53800E+01, 0.54400E+01,
     &  0.55500E+01, 0.56200E+01, 0.57200E+01, 0.58200E+01, 0.59200E+01,
     &  0.59800E+01, 0.60500E+01, 0.61100E+01, 0.61900E+01, 0.62700E+01,
     &  0.63200E+01, 0.63200E+01, 0.63800E+01, 0.63900E+01, 0.64200E+01,
     &  0.64500E+01, 0.64800E+01, 0.65300E+01, 0.65600E+01, 0.65800E+01,
     &  0.66100E+01, 0.66400E+01, 0.66600E+01, 0.66700E+01, 0.67500E+01,
     &  0.67800E+01, 0.68200E+01, 0.68300E+01, 0.68300E+01, 0.68600E+01,
     &  0.68900E+01, 0.69300E+01, 0.69800E+01, 0.69800E+01, 0.70200E+01,
     &  0.70400E+01, 0.70800E+01, 0.71500E+01, 0.71800E+01, 0.72000E+01,
     &  0.72300E+01, 0.72400E+01, 0.73000E+01, 0.73300E+01, 0.73300E+01,
     &  0.73400E+01, 0.74000E+01, 0.74400E+01, 0.74300E+01, 0.74600E+01,
     &  0.74800E+01, 0.74900E+01, 0.75200E+01, 0.75200E+01, 0.75600E+01,
     &  0.75500E+01, 0.75500E+01, 0.75500E+01, 0.75400E+01, 0.75200E+01,
     &  0.75200E+01, 0.74500E+01, 0.73500E+01, 0.72600E+01, 0.71700E+01,
     &  0.70300E+01, 0.69200E+01, 0.68100E+01, 0.67100E+01, 0.65900E+01,
     &  0.64700E+01, 0.63600E+01, 0.62600E+01, 0.61400E+01, 0.60300E+01,
     &  0.59300E+01, 0.58500E+01, 0.57300E+01, 0.56300E+01, 0.55200E+01,
     &  0.54100E+01, 0.53100E+01, 0.52000E+01, 0.50800E+01, 0.50000E+01,
     &  0.49400E+01, 0.48700E+01, 0.47600E+01, 0.46900E+01, 0.46300E+01,
     &  0.45500E+01, 0.44900E+01, 0.44700E+01, 0.44200E+01, 0.43700E+01,
     &  0.43100E+01, 0.42600E+01, 0.42300E+01, 0.42100E+01, 0.41900E+01,
     &  0.41800E+01, 0.41400E+01, 0.40800E+01, 0.40400E+01, 0.40100E+01,
     &  0.39800E+01, 0.39700E+01, 0.39400E+01, 0.39100E+01, 0.38900E+01,
     &  0.38900E+01, 0.38100E+01, 0.37200E+01, 0.36500E+01, 0.35800E+01,
     &  0.35000E+01, 0.34400E+01, 0.33700E+01, 0.32900E+01, 0.32000E+01,
     &  0.31200E+01, 0.30500E+01, 0.29700E+01, 0.28900E+01, 0.28300E+01,
     &  0.27600E+01, 0.26800E+01, 0.25900E+01, 0.25300E+01, 0.24700E+01,
     &  0.23800E+01, 0.23200E+01, 0.22800E+01, 0.22300E+01, 0.21900E+01,
     &  0.21500E+01, 0.21100E+01, 0.20600E+01, 0.20000E+01, 0.19800E+01,
     &  0.19400E+01, 0.19100E+01, 0.18800E+01, 0.18500E+01, 0.18300E+01,
     &  0.18100E+01, 0.17900E+01, 0.17500E+01, 0.17300E+01, 0.17000E+01,
     &  0.16800E+01, 0.16500E+01, 0.16300E+01, 0.16300E+01, 0.16200E+01,
     &  0.16000E+01,
     &  0.15800E+01,
     &  0.15700E+01,
     &  0.15600E+01,
     &  0.15600E+01,
     &  0.15500E+01/
c
      massi = hmass(1)
      massx = hmass(npoint)
      dmass = (massx-massi)/Real(npoint-1)
c      
      imass = int( (mhiggs-massi)/dmass ) + 1
      If (imass.ge.1 .and. imass.lt.npoint) then
        jmass = imass + 1
        rmass = mhiggs - hmass(imass)
      Endif
      if (imass.le.0) then
        imass = 1
        jmass = 1
        rmass = 0.
      Endif
      if (imass.ge.npoint) then
        imass = npoint
        jmass = npoint
        rmass = 0.
      Endif
c
      A202_HVV_HGG_BACKG=bdf(imass)+(bdf(jmass)-bdf(imass))*rmass/dmass
c
      RETURN
      END
      INTEGER FUNCTION A189_HVV_HGG_CAND(mhiggs,debug)
      Implicit none
      Real mhiggs
c
      Logical debug
      Integer npoint
      Parameter (npoint=201)
      Real hmass(npoint)
      Integer idata(npoint)
      Real massi,massx,dmass,rmass
      Integer i,imass,jmass,ndata
      Data (hmass(i),i=       1,     201)/
     &  0.75000E+02, 0.75100E+02, 0.75200E+02, 0.75300E+02, 0.75400E+02,
     &  0.75500E+02, 0.75600E+02, 0.75700E+02, 0.75800E+02, 0.75900E+02,
     &  0.76000E+02, 0.76100E+02, 0.76200E+02, 0.76300E+02, 0.76400E+02,
     &  0.76500E+02, 0.76600E+02, 0.76700E+02, 0.76800E+02, 0.76900E+02,
     &  0.77000E+02, 0.77100E+02, 0.77200E+02, 0.77300E+02, 0.77400E+02,
     &  0.77500E+02, 0.77600E+02, 0.77700E+02, 0.77800E+02, 0.77900E+02,
     &  0.78000E+02, 0.78100E+02, 0.78200E+02, 0.78300E+02, 0.78400E+02,
     &  0.78500E+02, 0.78600E+02, 0.78700E+02, 0.78800E+02, 0.78900E+02,
     &  0.79000E+02, 0.79100E+02, 0.79200E+02, 0.79300E+02, 0.79400E+02,
     &  0.79500E+02, 0.79600E+02, 0.79700E+02, 0.79800E+02, 0.79900E+02,
     &  0.80000E+02, 0.80100E+02, 0.80200E+02, 0.80300E+02, 0.80400E+02,
     &  0.80500E+02, 0.80600E+02, 0.80700E+02, 0.80800E+02, 0.80900E+02,
     &  0.81000E+02, 0.81100E+02, 0.81200E+02, 0.81300E+02, 0.81400E+02,
     &  0.81500E+02, 0.81600E+02, 0.81700E+02, 0.81800E+02, 0.81900E+02,
     &  0.82000E+02, 0.82100E+02, 0.82200E+02, 0.82300E+02, 0.82400E+02,
     &  0.82500E+02, 0.82600E+02, 0.82700E+02, 0.82800E+02, 0.82900E+02,
     &  0.83000E+02, 0.83100E+02, 0.83200E+02, 0.83300E+02, 0.83400E+02,
     &  0.83500E+02, 0.83600E+02, 0.83700E+02, 0.83800E+02, 0.83900E+02,
     &  0.84000E+02, 0.84100E+02, 0.84200E+02, 0.84300E+02, 0.84400E+02,
     &  0.84500E+02, 0.84600E+02, 0.84700E+02, 0.84800E+02, 0.84900E+02,
     &  0.85000E+02, 0.85100E+02, 0.85200E+02, 0.85300E+02, 0.85400E+02,
     &  0.85500E+02, 0.85600E+02, 0.85700E+02, 0.85800E+02, 0.85900E+02,
     &  0.86000E+02, 0.86100E+02, 0.86200E+02, 0.86300E+02, 0.86400E+02,
     &  0.86500E+02, 0.86600E+02, 0.86700E+02, 0.86800E+02, 0.86900E+02,
     &  0.87000E+02, 0.87100E+02, 0.87200E+02, 0.87300E+02, 0.87400E+02,
     &  0.87500E+02, 0.87600E+02, 0.87700E+02, 0.87800E+02, 0.87900E+02,
     &  0.88000E+02, 0.88100E+02, 0.88200E+02, 0.88300E+02, 0.88400E+02,
     &  0.88500E+02, 0.88600E+02, 0.88700E+02, 0.88800E+02, 0.88900E+02,
     &  0.89000E+02, 0.89100E+02, 0.89200E+02, 0.89300E+02, 0.89400E+02,
     &  0.89500E+02, 0.89600E+02, 0.89700E+02, 0.89800E+02, 0.89900E+02,
     &  0.90000E+02, 0.90100E+02, 0.90200E+02, 0.90300E+02, 0.90400E+02,
     &  0.90500E+02, 0.90600E+02, 0.90700E+02, 0.90800E+02, 0.90900E+02,
     &  0.91000E+02, 0.91100E+02, 0.91200E+02, 0.91300E+02, 0.91400E+02,
     &  0.91500E+02, 0.91600E+02, 0.91700E+02, 0.91800E+02, 0.91900E+02,
     &  0.92000E+02, 0.92100E+02, 0.92200E+02, 0.92300E+02, 0.92400E+02,
     &  0.92500E+02, 0.92600E+02, 0.92700E+02, 0.92800E+02, 0.92900E+02,
     &  0.93000E+02, 0.93100E+02, 0.93200E+02, 0.93300E+02, 0.93400E+02,
     &  0.93500E+02, 0.93600E+02, 0.93700E+02, 0.93800E+02, 0.93900E+02,
     &  0.94000E+02, 0.94100E+02, 0.94200E+02, 0.94300E+02, 0.94400E+02,
     &  0.94500E+02,
     &  0.94600E+02,
     &  0.94700E+02,
     &  0.94800E+02,
     &  0.94900E+02,
     &  0.95000E+02/
      Data (idata(i),i=       1,     201)/
     &     10,    10,    10,     9,     9,     8,     9,     9,
     &     10,    10,    10,    10,    10,    11,    11,    11,
     &     11,    11,    11,    11,    13,    13,    11,    11,
     &     11,    11,    11,    11,    11,    11,    11,    11,
     &     11,    11,    11,    11,    11,    11,    11,    11,
     &     12,    12,    12,    12,    12,    13,    14,    14,
     &     14,    16,    16,    16,    16,    16,    16,    16,
     &     17,    17,    18,    18,    18,    18,    18,    18,
     &     18,    18,    18,    18,    18,    18,    19,    19,
     &     19,    19,    20,    20,    19,    19,    18,    18,
     &     18,    18,    18,    19,    19,    22,    22,    21,
     &     21,    21,    21,    21,    23,    24,    24,    24,
     &     24,    25,    25,    25,    25,    24,    24,    22,
     &     22,    22,    22,    22,    22,    22,    24,    24,
     &     25,    26,    26,    25,    25,    26,    25,    25,
     &     24,    24,    25,    24,    23,    23,    23,    23,
     &     23,    23,    23,    23,    23,    22,    22,    22,
     &     22,    22,    22,    23,    23,    23,    21,    21,
     &     21,    21,    20,    20,    22,    23,    23,    23,
     &     23,    23,    23,    24,    23,    23,    22,    23,
     &     23,    23,    23,    23,    23,    23,    23,    23,
     &     23,    24,    24,    24,    24,    24,    24,    24,
     &     24,    24,    24,    24,    24,    24,    24,    24,
     &     24,    24,    24,    23,    23,    23,    22,    22,
     &     22,
     &     22,
     &     22,
     &     22,
     &     22,
     &     22,
     &     22,
     &     23,
     &     24/
c
      massi = hmass(1)
      massx = hmass(npoint)
      dmass = (massx-massi)/Real(npoint-1)
c      
      imass = int( (mhiggs-massi)/dmass ) + 1
      If (imass.ge.1 .and. imass.lt.npoint) then
        jmass = imass + 1
        rmass = mhiggs - hmass(imass)
      Endif
      if (imass.le.0) then
        imass = 1
        jmass = 1
        rmass = 0.
      Endif
      if (imass.ge.npoint) then
        imass = npoint
        jmass = npoint
        rmass = 0.
      Endif
      If ( mhiggs*10. - Real(INT(mhiggs*10.)) .ne.0. .and.debug) then
        Print*,
     &'Warning : Number of data is interpolated !!! (A189_HVV_HGG_CAND)'
      Endif
c
      A189_HVV_HGG_CAND= INT(
     &     Real(idata(imass))+(Real(idata(jmass)-idata(imass)))*rmass
     &     /dmass + 0.5)
c
      RETURN
      END
      INTEGER FUNCTION A196_HVV_HGG_CAND(mhiggs,debug)
      Implicit none
      Real mhiggs
c
      Logical debug
      Integer npoint
      Parameter (npoint=301)
      Real hmass(npoint)
      Integer idata(npoint)
      Real massi,massx,dmass,rmass
      Integer i,imass,jmass,ndata
      Data (hmass(i),i=       1,     301)/
     &  0.65000E+02, 0.65100E+02, 0.65200E+02, 0.65300E+02, 0.65400E+02,
     &  0.65500E+02, 0.65600E+02, 0.65700E+02, 0.65800E+02, 0.65900E+02,
     &  0.66000E+02, 0.66100E+02, 0.66200E+02, 0.66300E+02, 0.66400E+02,
     &  0.66500E+02, 0.66600E+02, 0.66700E+02, 0.66800E+02, 0.66900E+02,
     &  0.67000E+02, 0.67100E+02, 0.67200E+02, 0.67300E+02, 0.67400E+02,
     &  0.67500E+02, 0.67600E+02, 0.67700E+02, 0.67800E+02, 0.67900E+02,
     &  0.68000E+02, 0.68100E+02, 0.68200E+02, 0.68300E+02, 0.68400E+02,
     &  0.68500E+02, 0.68600E+02, 0.68700E+02, 0.68800E+02, 0.68900E+02,
     &  0.69000E+02, 0.69100E+02, 0.69200E+02, 0.69300E+02, 0.69400E+02,
     &  0.69500E+02, 0.69600E+02, 0.69700E+02, 0.69800E+02, 0.69900E+02,
     &  0.70000E+02, 0.70100E+02, 0.70200E+02, 0.70300E+02, 0.70400E+02,
     &  0.70500E+02, 0.70600E+02, 0.70700E+02, 0.70800E+02, 0.70900E+02,
     &  0.71000E+02, 0.71100E+02, 0.71200E+02, 0.71300E+02, 0.71400E+02,
     &  0.71500E+02, 0.71600E+02, 0.71700E+02, 0.71800E+02, 0.71900E+02,
     &  0.72000E+02, 0.72100E+02, 0.72200E+02, 0.72300E+02, 0.72400E+02,
     &  0.72500E+02, 0.72600E+02, 0.72700E+02, 0.72800E+02, 0.72900E+02,
     &  0.73000E+02, 0.73100E+02, 0.73200E+02, 0.73300E+02, 0.73400E+02,
     &  0.73500E+02, 0.73600E+02, 0.73700E+02, 0.73800E+02, 0.73900E+02,
     &  0.74000E+02, 0.74100E+02, 0.74200E+02, 0.74300E+02, 0.74400E+02,
     &  0.74500E+02, 0.74600E+02, 0.74700E+02, 0.74800E+02, 0.74900E+02,
     &  0.75000E+02, 0.75100E+02, 0.75200E+02, 0.75300E+02, 0.75400E+02,
     &  0.75500E+02, 0.75600E+02, 0.75700E+02, 0.75800E+02, 0.75900E+02,
     &  0.76000E+02, 0.76100E+02, 0.76200E+02, 0.76300E+02, 0.76400E+02,
     &  0.76500E+02, 0.76600E+02, 0.76700E+02, 0.76800E+02, 0.76900E+02,
     &  0.77000E+02, 0.77100E+02, 0.77200E+02, 0.77300E+02, 0.77400E+02,
     &  0.77500E+02, 0.77600E+02, 0.77700E+02, 0.77800E+02, 0.77900E+02,
     &  0.78000E+02, 0.78100E+02, 0.78200E+02, 0.78300E+02, 0.78400E+02,
     &  0.78500E+02, 0.78600E+02, 0.78700E+02, 0.78800E+02, 0.78900E+02,
     &  0.79000E+02, 0.79100E+02, 0.79200E+02, 0.79300E+02, 0.79400E+02,
     &  0.79500E+02, 0.79600E+02, 0.79700E+02, 0.79800E+02, 0.79900E+02,
     &  0.80000E+02, 0.80100E+02, 0.80200E+02, 0.80300E+02, 0.80400E+02,
     &  0.80500E+02, 0.80600E+02, 0.80700E+02, 0.80800E+02, 0.80900E+02,
     &  0.81000E+02, 0.81100E+02, 0.81200E+02, 0.81300E+02, 0.81400E+02,
     &  0.81500E+02, 0.81600E+02, 0.81700E+02, 0.81800E+02, 0.81900E+02,
     &  0.82000E+02, 0.82100E+02, 0.82200E+02, 0.82300E+02, 0.82400E+02,
     &  0.82500E+02, 0.82600E+02, 0.82700E+02, 0.82800E+02, 0.82900E+02,
     &  0.83000E+02, 0.83100E+02, 0.83200E+02, 0.83300E+02, 0.83400E+02,
     &  0.83500E+02, 0.83600E+02, 0.83700E+02, 0.83800E+02, 0.83900E+02,
     &  0.84000E+02, 0.84100E+02, 0.84200E+02, 0.84300E+02, 0.84400E+02,
     &  0.84500E+02, 0.84600E+02, 0.84700E+02, 0.84800E+02, 0.84900E+02,
     &  0.85000E+02, 0.85100E+02, 0.85200E+02, 0.85300E+02, 0.85400E+02,
     &  0.85500E+02, 0.85600E+02, 0.85700E+02, 0.85800E+02, 0.85900E+02,
     &  0.86000E+02, 0.86100E+02, 0.86200E+02, 0.86300E+02, 0.86400E+02,
     &  0.86500E+02, 0.86600E+02, 0.86700E+02, 0.86800E+02, 0.86900E+02,
     &  0.87000E+02, 0.87100E+02, 0.87200E+02, 0.87300E+02, 0.87400E+02,
     &  0.87500E+02, 0.87600E+02, 0.87700E+02, 0.87800E+02, 0.87900E+02,
     &  0.88000E+02, 0.88100E+02, 0.88200E+02, 0.88300E+02, 0.88400E+02,
     &  0.88500E+02, 0.88600E+02, 0.88700E+02, 0.88800E+02, 0.88900E+02,
     &  0.89000E+02, 0.89100E+02, 0.89200E+02, 0.89300E+02, 0.89400E+02,
     &  0.89500E+02, 0.89600E+02, 0.89700E+02, 0.89800E+02, 0.89900E+02,
     &  0.90000E+02, 0.90100E+02, 0.90200E+02, 0.90300E+02, 0.90400E+02,
     &  0.90500E+02, 0.90600E+02, 0.90700E+02, 0.90800E+02, 0.90900E+02,
     &  0.91000E+02, 0.91100E+02, 0.91200E+02, 0.91300E+02, 0.91400E+02,
     &  0.91500E+02, 0.91600E+02, 0.91700E+02, 0.91800E+02, 0.91900E+02,
     &  0.92000E+02, 0.92100E+02, 0.92200E+02, 0.92300E+02, 0.92400E+02,
     &  0.92500E+02, 0.92600E+02, 0.92700E+02, 0.92800E+02, 0.92900E+02,
     &  0.93000E+02, 0.93100E+02, 0.93200E+02, 0.93300E+02, 0.93400E+02,
     &  0.93500E+02, 0.93600E+02, 0.93700E+02, 0.93800E+02, 0.93900E+02,
     &  0.94000E+02, 0.94100E+02, 0.94200E+02, 0.94300E+02, 0.94400E+02,
     &  0.94500E+02,
     &  0.94600E+02,
     &  0.94700E+02,
     &  0.94800E+02,
     &  0.94900E+02,
     &  0.95000E+02/
      Data (idata(i),i=       1,     301)/
     &      1,     1,     2,     2,     2,     2,     2,     2,
     &      2,     2,     2,     2,     2,     2,     2,     2,
     &      2,     2,     2,     2,     2,     2,     2,     2,
     &      2,     2,     2,     2,     2,     2,     2,     2,
     &      2,     2,     2,     2,     2,     2,     2,     2,
     &      2,     2,     2,     2,     2,     2,     2,     2,
     &      3,     4,     4,     4,     4,     4,     4,     4,
     &      4,     4,     4,     4,     4,     4,     4,     4,
     &      4,     4,     5,     5,     4,     4,     4,     3,
     &      3,     3,     3,     3,     3,     3,     3,     3,
     &      3,     3,     3,     3,     3,     3,     3,     3,
     &      4,     4,     4,     4,     4,     4,     4,     4,
     &      5,     5,     5,     5,     5,     5,     5,     5,
     &      4,     4,     4,     4,     4,     4,     3,     3,
     &      3,     3,     3,     3,     3,     3,     3,     4,
     &      4,     4,     5,     6,     6,     6,     6,     6,
     &      6,     6,     6,     6,     7,     7,     7,     7,
     &      7,     7,     7,     7,     7,     7,     7,     8,
     &      8,     8,     8,     9,     9,     9,    10,    10,
     &      9,     9,     9,    10,    10,     9,     9,     9,
     &      9,    10,     9,    10,     9,     9,     9,     9,
     &      9,     9,    11,    12,    12,    13,    13,    13,
     &     13,    13,    13,    13,    14,    14,    14,    15,
     &     14,    14,    14,    14,    14,    14,    14,    14,
     &     14,    14,    14,    14,    14,    15,    15,    15,
     &     16,    16,    16,    16,    16,    16,    16,    16,
     &     17,    17,    17,    17,    17,    17,    16,    16,
     &     16,    16,    13,    13,    13,    14,    15,    15,
     &     15,    15,    15,    15,    17,    17,    17,    17,
     &     17,    17,    17,    17,    16,    16,    16,    16,
     &     16,    16,    16,    16,    16,    16,    16,    16,
     &     16,    16,    17,    17,    17,    17,    17,    17,
     &     17,    17,    17,    16,    16,    16,    15,    15,
     &     15,    14,    13,    13,    13,    12,    12,    11,
     &     12,    11,    11,    11,    10,    10,     9,     9,
     &      9,     8,     8,     8,     7,     6,     6,     6,
     &      6,     5,     5,     5,     5,     5,     5,     5,
     &      5,
     &      5,
     &      5,
     &      5,
     &      5/
c
      massi = hmass(1)
      massx = hmass(npoint)
      dmass = (massx-massi)/Real(npoint-1)
c      
      imass = int( (mhiggs-massi)/dmass ) + 1
      If (imass.ge.1 .and. imass.lt.npoint) then
        jmass = imass + 1
        rmass = mhiggs - hmass(imass)
      Endif
      if (imass.le.0) then
        imass = 1
        jmass = 1
        rmass = 0.
      Endif
      if (imass.ge.npoint) then
        imass = npoint
        jmass = npoint
        rmass = 0.
      Endif
      If ( mhiggs*10. - Real(INT(mhiggs*10.)) .ne.0. .and.debug) then
        Print*,
     &'Warning : Number of data is interpolated !!! (A196_HVV_HGG_CAND)'
      Endif
c
      A196_HVV_HGG_CAND= INT(
     &     Real(idata(imass))+(Real(idata(jmass)-idata(imass)))*rmass
     &     /dmass + 0.5)
c
      RETURN
      END
      INTEGER FUNCTION A200_HVV_HGG_CAND(mhiggs,debug)
      Implicit none
      Real mhiggs
c
      Logical debug
      Integer npoint
      Parameter (npoint=301)
      Real hmass(npoint)
      Integer idata(npoint)
      Real massi,massx,dmass,rmass
      Integer i,imass,jmass,ndata
      Data (hmass(i),i=       1,     301)/
     &  0.70000E+02, 0.70100E+02, 0.70200E+02, 0.70300E+02, 0.70400E+02,
     &  0.70500E+02, 0.70600E+02, 0.70700E+02, 0.70800E+02, 0.70900E+02,
     &  0.71000E+02, 0.71100E+02, 0.71200E+02, 0.71300E+02, 0.71400E+02,
     &  0.71500E+02, 0.71600E+02, 0.71700E+02, 0.71800E+02, 0.71900E+02,
     &  0.72000E+02, 0.72100E+02, 0.72200E+02, 0.72300E+02, 0.72400E+02,
     &  0.72500E+02, 0.72600E+02, 0.72700E+02, 0.72800E+02, 0.72900E+02,
     &  0.73000E+02, 0.73100E+02, 0.73200E+02, 0.73300E+02, 0.73400E+02,
     &  0.73500E+02, 0.73600E+02, 0.73700E+02, 0.73800E+02, 0.73900E+02,
     &  0.74000E+02, 0.74100E+02, 0.74200E+02, 0.74300E+02, 0.74400E+02,
     &  0.74500E+02, 0.74600E+02, 0.74700E+02, 0.74800E+02, 0.74900E+02,
     &  0.75000E+02, 0.75100E+02, 0.75200E+02, 0.75300E+02, 0.75400E+02,
     &  0.75500E+02, 0.75600E+02, 0.75700E+02, 0.75800E+02, 0.75900E+02,
     &  0.76000E+02, 0.76100E+02, 0.76200E+02, 0.76300E+02, 0.76400E+02,
     &  0.76500E+02, 0.76600E+02, 0.76700E+02, 0.76800E+02, 0.76900E+02,
     &  0.77000E+02, 0.77100E+02, 0.77200E+02, 0.77300E+02, 0.77400E+02,
     &  0.77500E+02, 0.77600E+02, 0.77700E+02, 0.77800E+02, 0.77900E+02,
     &  0.78000E+02, 0.78100E+02, 0.78200E+02, 0.78300E+02, 0.78400E+02,
     &  0.78500E+02, 0.78600E+02, 0.78700E+02, 0.78800E+02, 0.78900E+02,
     &  0.79000E+02, 0.79100E+02, 0.79200E+02, 0.79300E+02, 0.79400E+02,
     &  0.79500E+02, 0.79600E+02, 0.79700E+02, 0.79800E+02, 0.79900E+02,
     &  0.80000E+02, 0.80100E+02, 0.80200E+02, 0.80300E+02, 0.80400E+02,
     &  0.80500E+02, 0.80600E+02, 0.80700E+02, 0.80800E+02, 0.80900E+02,
     &  0.81000E+02, 0.81100E+02, 0.81200E+02, 0.81300E+02, 0.81400E+02,
     &  0.81500E+02, 0.81600E+02, 0.81700E+02, 0.81800E+02, 0.81900E+02,
     &  0.82000E+02, 0.82100E+02, 0.82200E+02, 0.82300E+02, 0.82400E+02,
     &  0.82500E+02, 0.82600E+02, 0.82700E+02, 0.82800E+02, 0.82900E+02,
     &  0.83000E+02, 0.83100E+02, 0.83200E+02, 0.83300E+02, 0.83400E+02,
     &  0.83500E+02, 0.83600E+02, 0.83700E+02, 0.83800E+02, 0.83900E+02,
     &  0.84000E+02, 0.84100E+02, 0.84200E+02, 0.84300E+02, 0.84400E+02,
     &  0.84500E+02, 0.84600E+02, 0.84700E+02, 0.84800E+02, 0.84900E+02,
     &  0.85000E+02, 0.85100E+02, 0.85200E+02, 0.85300E+02, 0.85400E+02,
     &  0.85500E+02, 0.85600E+02, 0.85700E+02, 0.85800E+02, 0.85900E+02,
     &  0.86000E+02, 0.86100E+02, 0.86200E+02, 0.86300E+02, 0.86400E+02,
     &  0.86500E+02, 0.86600E+02, 0.86700E+02, 0.86800E+02, 0.86900E+02,
     &  0.87000E+02, 0.87100E+02, 0.87200E+02, 0.87300E+02, 0.87400E+02,
     &  0.87500E+02, 0.87600E+02, 0.87700E+02, 0.87800E+02, 0.87900E+02,
     &  0.88000E+02, 0.88100E+02, 0.88200E+02, 0.88300E+02, 0.88400E+02,
     &  0.88500E+02, 0.88600E+02, 0.88700E+02, 0.88800E+02, 0.88900E+02,
     &  0.89000E+02, 0.89100E+02, 0.89200E+02, 0.89300E+02, 0.89400E+02,
     &  0.89500E+02, 0.89600E+02, 0.89700E+02, 0.89800E+02, 0.89900E+02,
     &  0.90000E+02, 0.90100E+02, 0.90200E+02, 0.90300E+02, 0.90400E+02,
     &  0.90500E+02, 0.90600E+02, 0.90700E+02, 0.90800E+02, 0.90900E+02,
     &  0.91000E+02, 0.91100E+02, 0.91200E+02, 0.91300E+02, 0.91400E+02,
     &  0.91500E+02, 0.91600E+02, 0.91700E+02, 0.91800E+02, 0.91900E+02,
     &  0.92000E+02, 0.92100E+02, 0.92200E+02, 0.92300E+02, 0.92400E+02,
     &  0.92500E+02, 0.92600E+02, 0.92700E+02, 0.92800E+02, 0.92900E+02,
     &  0.93000E+02, 0.93100E+02, 0.93200E+02, 0.93300E+02, 0.93400E+02,
     &  0.93500E+02, 0.93600E+02, 0.93700E+02, 0.93800E+02, 0.93900E+02,
     &  0.94000E+02, 0.94100E+02, 0.94200E+02, 0.94300E+02, 0.94400E+02,
     &  0.94500E+02, 0.94600E+02, 0.94700E+02, 0.94800E+02, 0.94900E+02,
     &  0.95000E+02, 0.95100E+02, 0.95200E+02, 0.95300E+02, 0.95400E+02,
     &  0.95500E+02, 0.95600E+02, 0.95700E+02, 0.95800E+02, 0.95900E+02,
     &  0.96000E+02, 0.96100E+02, 0.96200E+02, 0.96300E+02, 0.96400E+02,
     &  0.96500E+02, 0.96600E+02, 0.96700E+02, 0.96800E+02, 0.96900E+02,
     &  0.97000E+02, 0.97100E+02, 0.97200E+02, 0.97300E+02, 0.97400E+02,
     &  0.97500E+02, 0.97600E+02, 0.97700E+02, 0.97800E+02, 0.97900E+02,
     &  0.98000E+02, 0.98100E+02, 0.98200E+02, 0.98300E+02, 0.98400E+02,
     &  0.98500E+02, 0.98600E+02, 0.98700E+02, 0.98800E+02, 0.98900E+02,
     &  0.99000E+02, 0.99100E+02, 0.99200E+02, 0.99300E+02, 0.99400E+02,
     &  0.99500E+02,
     &  0.99600E+02,
     &  0.99700E+02,
     &  0.99800E+02,
     &  0.99900E+02,
     &  0.10000E+03/
      Data (idata(i),i=       1,     301)/
     &      1,     1,     1,     1,     1,     1,     1,     2,
     &      2,     2,     2,     2,     3,     3,     4,     4,
     &      4,     4,     4,     4,     4,     4,     4,     4,
     &      4,     4,     4,     4,     4,     4,     4,     4,
     &      4,     5,     5,     5,     5,     6,     6,     7,
     &      7,     7,     7,     7,     7,     7,     7,     7,
     &      8,     8,     8,     8,     8,     9,     9,     9,
     &      9,     9,     9,     9,     9,     9,     9,     9,
     &      9,    10,    10,    10,    10,    10,    11,    11,
     &     11,    11,    11,    10,     9,     9,     9,     9,
     &      9,     9,    10,     9,     9,    10,     8,     8,
     &      8,     8,     8,    10,    10,    11,    11,    11,
     &     11,    11,    11,    10,    10,    10,    12,    12,
     &     11,    11,    11,    11,    11,    11,    11,    12,
     &     12,    13,    14,    14,    14,    14,    14,    14,
     &     14,    16,    16,    16,    16,    16,    16,    16,
     &     16,    16,    17,    16,    16,    16,    16,    16,
     &     16,    15,    15,    15,    14,    16,    16,    15,
     &     15,    16,    15,    15,    15,    17,    17,    17,
     &     17,    18,    17,    17,    17,    16,    16,    16,
     &     16,    15,    14,    14,    14,    14,    14,    14,
     &     14,    14,    15,    15,    15,    15,    14,    14,
     &     14,    14,    15,    15,    16,    15,    15,    15,
     &     15,    15,    15,    13,    13,    13,    13,    13,
     &     14,    14,    14,    13,    13,    14,    14,    15,
     &     15,    15,    15,    15,    15,    15,    15,    14,
     &     14,    13,    13,    13,    13,    13,    13,    13,
     &     13,    13,    13,    13,    13,    13,    13,    13,
     &     13,    13,    13,    13,    13,    13,    12,    13,
     &     13,    13,    13,    13,    13,    13,    13,    13,
     &     12,    12,    12,    12,    12,    12,    12,    12,
     &     12,    12,    12,    12,    11,     9,    10,    10,
     &     10,     9,     9,     9,     9,     8,     8,     8,
     &      8,     8,     8,     7,     7,     7,     7,     7,
     &      7,     7,     7,     7,     7,     7,     7,     7,
     &      6,     6,     6,     6,     6,     6,     6,     5,
     &      5,     5,     5,     5,     5,     5,     5,     5,
     &      5,
     &      5,
     &      6,
     &      6,
     &      6/
c
      massi = hmass(1)
      massx = hmass(npoint)
      dmass = (massx-massi)/Real(npoint-1)
c      
      imass = int( (mhiggs-massi)/dmass ) + 1
      If (imass.ge.1 .and. imass.lt.npoint) then
        jmass = imass + 1
        rmass = mhiggs - hmass(imass)
      Endif
      if (imass.le.0) then
        imass = 1
        jmass = 1
        rmass = 0.
      Endif
      if (imass.ge.npoint) then
        imass = npoint
        jmass = npoint
        rmass = 0.
      Endif
      If ( mhiggs*10. - Real(INT(mhiggs*10.)) .ne.0. .and.debug) then
        Print*,
     &'Warning : Number of data is interpolated !!! (A200_HVV_HGG_CAND)'
      Endif
c
      A200_HVV_HGG_CAND= INT(
     &     Real(idata(imass))+(Real(idata(jmass)-idata(imass)))*rmass
     &     /dmass + 0.5)
c
      RETURN
      END
      INTEGER FUNCTION A202_HVV_HGG_CAND(mhiggs,debug)
      Implicit none
      Real mhiggs
c
      Logical debug
      Integer npoint
      Parameter (npoint=301)
      Real hmass(npoint)
      Integer idata(npoint)
      Real massi,massx,dmass,rmass
      Integer i,imass,jmass,ndata
      Data (hmass(i),i=       1,     301)/
     &  0.70000E+02, 0.70100E+02, 0.70200E+02, 0.70300E+02, 0.70400E+02,
     &  0.70500E+02, 0.70600E+02, 0.70700E+02, 0.70800E+02, 0.70900E+02,
     &  0.71000E+02, 0.71100E+02, 0.71200E+02, 0.71300E+02, 0.71400E+02,
     &  0.71500E+02, 0.71600E+02, 0.71700E+02, 0.71800E+02, 0.71900E+02,
     &  0.72000E+02, 0.72100E+02, 0.72200E+02, 0.72300E+02, 0.72400E+02,
     &  0.72500E+02, 0.72600E+02, 0.72700E+02, 0.72800E+02, 0.72900E+02,
     &  0.73000E+02, 0.73100E+02, 0.73200E+02, 0.73300E+02, 0.73400E+02,
     &  0.73500E+02, 0.73600E+02, 0.73700E+02, 0.73800E+02, 0.73900E+02,
     &  0.74000E+02, 0.74100E+02, 0.74200E+02, 0.74300E+02, 0.74400E+02,
     &  0.74500E+02, 0.74600E+02, 0.74700E+02, 0.74800E+02, 0.74900E+02,
     &  0.75000E+02, 0.75100E+02, 0.75200E+02, 0.75300E+02, 0.75400E+02,
     &  0.75500E+02, 0.75600E+02, 0.75700E+02, 0.75800E+02, 0.75900E+02,
     &  0.76000E+02, 0.76100E+02, 0.76200E+02, 0.76300E+02, 0.76400E+02,
     &  0.76500E+02, 0.76600E+02, 0.76700E+02, 0.76800E+02, 0.76900E+02,
     &  0.77000E+02, 0.77100E+02, 0.77200E+02, 0.77300E+02, 0.77400E+02,
     &  0.77500E+02, 0.77600E+02, 0.77700E+02, 0.77800E+02, 0.77900E+02,
     &  0.78000E+02, 0.78100E+02, 0.78200E+02, 0.78300E+02, 0.78400E+02,
     &  0.78500E+02, 0.78600E+02, 0.78700E+02, 0.78800E+02, 0.78900E+02,
     &  0.79000E+02, 0.79100E+02, 0.79200E+02, 0.79300E+02, 0.79400E+02,
     &  0.79500E+02, 0.79600E+02, 0.79700E+02, 0.79800E+02, 0.79900E+02,
     &  0.80000E+02, 0.80100E+02, 0.80200E+02, 0.80300E+02, 0.80400E+02,
     &  0.80500E+02, 0.80600E+02, 0.80700E+02, 0.80800E+02, 0.80900E+02,
     &  0.81000E+02, 0.81100E+02, 0.81200E+02, 0.81300E+02, 0.81400E+02,
     &  0.81500E+02, 0.81600E+02, 0.81700E+02, 0.81800E+02, 0.81900E+02,
     &  0.82000E+02, 0.82100E+02, 0.82200E+02, 0.82300E+02, 0.82400E+02,
     &  0.82500E+02, 0.82600E+02, 0.82700E+02, 0.82800E+02, 0.82900E+02,
     &  0.83000E+02, 0.83100E+02, 0.83200E+02, 0.83300E+02, 0.83400E+02,
     &  0.83500E+02, 0.83600E+02, 0.83700E+02, 0.83800E+02, 0.83900E+02,
     &  0.84000E+02, 0.84100E+02, 0.84200E+02, 0.84300E+02, 0.84400E+02,
     &  0.84500E+02, 0.84600E+02, 0.84700E+02, 0.84800E+02, 0.84900E+02,
     &  0.85000E+02, 0.85100E+02, 0.85200E+02, 0.85300E+02, 0.85400E+02,
     &  0.85500E+02, 0.85600E+02, 0.85700E+02, 0.85800E+02, 0.85900E+02,
     &  0.86000E+02, 0.86100E+02, 0.86200E+02, 0.86300E+02, 0.86400E+02,
     &  0.86500E+02, 0.86600E+02, 0.86700E+02, 0.86800E+02, 0.86900E+02,
     &  0.87000E+02, 0.87100E+02, 0.87200E+02, 0.87300E+02, 0.87400E+02,
     &  0.87500E+02, 0.87600E+02, 0.87700E+02, 0.87800E+02, 0.87900E+02,
     &  0.88000E+02, 0.88100E+02, 0.88200E+02, 0.88300E+02, 0.88400E+02,
     &  0.88500E+02, 0.88600E+02, 0.88700E+02, 0.88800E+02, 0.88900E+02,
     &  0.89000E+02, 0.89100E+02, 0.89200E+02, 0.89300E+02, 0.89400E+02,
     &  0.89500E+02, 0.89600E+02, 0.89700E+02, 0.89800E+02, 0.89900E+02,
     &  0.90000E+02, 0.90100E+02, 0.90200E+02, 0.90300E+02, 0.90400E+02,
     &  0.90500E+02, 0.90600E+02, 0.90700E+02, 0.90800E+02, 0.90900E+02,
     &  0.91000E+02, 0.91100E+02, 0.91200E+02, 0.91300E+02, 0.91400E+02,
     &  0.91500E+02, 0.91600E+02, 0.91700E+02, 0.91800E+02, 0.91900E+02,
     &  0.92000E+02, 0.92100E+02, 0.92200E+02, 0.92300E+02, 0.92400E+02,
     &  0.92500E+02, 0.92600E+02, 0.92700E+02, 0.92800E+02, 0.92900E+02,
     &  0.93000E+02, 0.93100E+02, 0.93200E+02, 0.93300E+02, 0.93400E+02,
     &  0.93500E+02, 0.93600E+02, 0.93700E+02, 0.93800E+02, 0.93900E+02,
     &  0.94000E+02, 0.94100E+02, 0.94200E+02, 0.94300E+02, 0.94400E+02,
     &  0.94500E+02, 0.94600E+02, 0.94700E+02, 0.94800E+02, 0.94900E+02,
     &  0.95000E+02, 0.95100E+02, 0.95200E+02, 0.95300E+02, 0.95400E+02,
     &  0.95500E+02, 0.95600E+02, 0.95700E+02, 0.95800E+02, 0.95900E+02,
     &  0.96000E+02, 0.96100E+02, 0.96200E+02, 0.96300E+02, 0.96400E+02,
     &  0.96500E+02, 0.96600E+02, 0.96700E+02, 0.96800E+02, 0.96900E+02,
     &  0.97000E+02, 0.97100E+02, 0.97200E+02, 0.97300E+02, 0.97400E+02,
     &  0.97500E+02, 0.97600E+02, 0.97700E+02, 0.97800E+02, 0.97900E+02,
     &  0.98000E+02, 0.98100E+02, 0.98200E+02, 0.98300E+02, 0.98400E+02,
     &  0.98500E+02, 0.98600E+02, 0.98700E+02, 0.98800E+02, 0.98900E+02,
     &  0.99000E+02, 0.99100E+02, 0.99200E+02, 0.99300E+02, 0.99400E+02,
     &  0.99500E+02,
     &  0.99600E+02,
     &  0.99700E+02,
     &  0.99800E+02,
     &  0.99900E+02,
     &  0.10000E+03/
      Data (idata(i),i=       1,     301)/
     &      3,     3,     3,     3,     3,     3,     3,     3,
     &      3,     3,     3,     3,     3,     3,     3,     3,
     &      3,     3,     3,     3,     3,     3,     3,     3,
     &      3,     3,     3,     3,     3,     3,     3,     3,
     &      3,     3,     4,     4,     5,     5,     5,     5,
     &      5,     5,     5,     5,     5,     5,     6,     6,
     &      6,     6,     6,     6,     6,     6,     6,     6,
     &      6,     6,     6,     6,     6,     6,     6,     6,
     &      6,     6,     6,     6,     6,     5,     4,     4,
     &      4,     5,     5,     5,     5,     5,     5,     5,
     &      5,     4,     4,     4,     4,     4,     4,     4,
     &      4,     4,     4,     4,     3,     3,     4,     4,
     &      4,     4,     4,     4,     4,     5,     5,     5,
     &      5,     6,     6,     6,     6,     6,     6,     6,
     &      6,     6,     6,     7,     6,     6,     6,     6,
     &      6,     6,     6,     6,     6,     7,     6,     6,
     &      6,     6,     6,     6,     6,     5,     5,     5,
     &      5,     5,     5,     6,     6,     6,     6,     6,
     &      6,     6,     7,     8,     8,     8,     8,     8,
     &      8,     8,     8,     8,     8,     8,     8,     8,
     &      8,     7,     7,     7,     7,     7,     7,     7,
     &      6,     5,     5,     5,     5,     5,     5,     5,
     &      5,     5,     5,     5,     5,     5,     6,     6,
     &      6,     6,     5,     5,     5,     5,     6,     6,
     &      6,     5,     5,     5,     5,     5,     5,     5,
     &      5,     5,     5,     5,     5,     5,     5,     5,
     &      5,     5,     4,     3,     3,     3,     3,     3,
     &      3,     3,     3,     3,     3,     3,     3,     3,
     &      3,     2,     2,     2,     2,     2,     2,     2,
     &      2,     2,     2,     2,     2,     2,     2,     2,
     &      2,     2,     2,     2,     2,     2,     2,     2,
     &      2,     2,     2,     2,     2,     2,     2,     2,
     &      1,     1,     1,     1,     1,     1,     1,     1,
     &      1,     1,     1,     1,     1,     1,     1,     1,
     &      1,     1,     1,     1,     1,     1,     1,     1,
     &      1,     2,     2,     2,     2,     2,     2,     2,
     &      2,     2,     2,     2,     2,     2,     2,     2,
     &      2,
     &      2,
     &      2,
     &      2,
     &      2/
c
      massi = hmass(1)
      massx = hmass(npoint)
      dmass = (massx-massi)/Real(npoint-1)
c      
      imass = int( (mhiggs-massi)/dmass ) + 1
      If (imass.ge.1 .and. imass.lt.npoint) then
        jmass = imass + 1
        rmass = mhiggs - hmass(imass)
      Endif
      if (imass.le.0) then
        imass = 1
        jmass = 1
        rmass = 0.
      Endif
      if (imass.ge.npoint) then
        imass = npoint
        jmass = npoint
        rmass = 0.
      Endif
      If ( mhiggs*10. - Real(INT(mhiggs*10.)) .ne.0. .and.debug) then
        Print*,
     &'Warning : Number of data is interpolated !!! (A202_HVV_HGG_CAND)'
      Endif
c
      A202_HVV_HGG_CAND= INT(
     &     Real(idata(imass))+(Real(idata(jmass)-idata(imass)))*rmass
     &     /dmass + 0.5)
c
      RETURN
      END
      Real function A2000_hvv_hgg_eff(ecm,mh)
      implicit none
      real ecm,mh
      Real A2000_hvv_hgg_eff_2013,A2000_hvv_hgg_eff_2052
     &     ,A2000_hvv_hgg_eff_2067,A2000_hvv_hgg_eff_2082
      External A2000_hvv_hgg_eff_2013,A2000_hvv_hgg_eff_2052
     &     ,A2000_hvv_hgg_eff_2067,A2000_hvv_hgg_eff_2082
      integer i,ecmindx
      integer numecm
      parameter (numecm=4)
      real sigecm(numecm)
      real val1,val2
      data sigecm /201.3,205.2,206.7,208.2/
      ecmindx = 0               ! pointe sur l''energie la plus proche a ecm mais en dessous
      do i=1,numecm
         if (sigecm(i).le.ecm) ecmindx = i
      enddo
      if (ecmindx.eq.numecm) then
         A2000_hvv_hgg_eff = A2000_hvv_hgg_eff_2082(mh-ecm+208.2)
      elseif (ecmindx.eq.0) then
         A2000_hvv_hgg_eff = A2000_hvv_hgg_eff_2013(mh)
      else
         if (ecmindx.eq.1) then
            val1=A2000_hvv_hgg_eff_2013(mh-ecm+201.3)
            val2=A2000_hvv_hgg_eff_2052(mh-ecm+205.2)
         elseif (ecmindx.eq.2) then    
            val1=A2000_hvv_hgg_eff_2052(mh-ecm+205.2)
            val2=A2000_hvv_hgg_eff_2067(mh-ecm+206.7)
         elseif (ecmindx.eq.3) then    
            val1=A2000_hvv_hgg_eff_2067(mh-ecm+206.7)
            val2=A2000_hvv_hgg_eff_2082(mh-ecm+208.2)
         else
            val1=0.
            val2=0.
         endif
         
         A2000_hvv_hgg_eff = (val2*(ecm-sigecm(ecmindx))
     &        +val1*(sigecm(ecmindx+1)-ecm))
     &        /(sigecm(ecmindx+1)-sigecm(ecmindx))
      endif
      if (mh.lt.75. .or. mh.gt.120.) A2000_hvv_hgg_eff = 0.
      end
      
      Real FUNCTION A2000_hvv_hgg_eff_2013(amass)
      implicit none
      integer i,nmas
      parameter (nmas=6)
      real hmass(nmas),effi(nmas)
      real eff,eff1,eff2,del1,del2,amass
c
      data hmass /75.,80.,85.,90.,95.,100./
      data effi  /3.35,4.80,13.85,29.65,51.75,64.35/
      A2000_hvv_hgg_eff_2013 = 0.
      If (amass.lt.hmass(1))    return
      If (amass.gt.hmass(nmas)) return
      Do i=2,nmas
        If (amass.le.hmass(i)) then
            eff1 = effi(i-1)
            eff2 = effi(i)
            del1 = amass - hmass(i-1)
            del2 = hmass(i) - amass
            goto 1000
         endif
      Enddo
 1000 continue
      eff = (eff1*del2 + eff2*del1) / (del1 + del2)
      A2000_hvv_hgg_eff_2013 = max(eff,0.) / 100.
      RETURN 
      END
      Real FUNCTION A2000_hvv_hgg_eff_2052(amass)
      implicit none
      integer i,nmas
      parameter (nmas=9)
      real hmass(nmas),effi(nmas)
      real eff,eff1,eff2,del1,del2,amass
c
      data hmass /75.,80.,85.,90.,95.,100.,105.,110.,115./
      data effi  /2.02,2.35,9.17,16.07,35.07,58.17,63.82,55.97,37.82/
      A2000_hvv_hgg_eff_2052 = 0.
      If (amass.lt.hmass(1))    return
      If (amass.gt.hmass(nmas)) return
      Do i=2,nmas
        If (amass.le.hmass(i)) then
            eff1 = effi(i-1)
            eff2 = effi(i)
            del1 = amass - hmass(i-1)
            del2 = hmass(i) - amass
            goto 1000
         endif
      Enddo
 1000 continue
      eff = (eff1*del2 + eff2*del1) / (del1 + del2)
      A2000_hvv_hgg_eff_2052 = max(eff,0.) / 100.
      RETURN 
      END
      Real FUNCTION A2000_hvv_hgg_eff_2067(amass)
      implicit none
      integer i,nmas
      parameter (nmas=9)
      real hmass(nmas),effi(nmas)
      real eff,eff1,eff2,del1,del2,amass
c
      data hmass /75.,80.,85.,90.,95.,100.,105.,110.,115./
      data effi  /1.8,3.32,7.22,12.67,28.62,50.67,61.2,57.92,41.57/
      A2000_hvv_hgg_eff_2067 = 0.
      If (amass.lt.hmass(1))    return
      If (amass.gt.hmass(nmas)) return
      Do i=2,nmas
        If (amass.le.hmass(i)) then
            eff1 = effi(i-1)
            eff2 = effi(i)
            del1 = amass - hmass(i-1)
            del2 = hmass(i) - amass
            goto 1000
         endif
      Enddo
 1000 continue
      eff = (eff1*del2 + eff2*del1) / (del1 + del2)
      A2000_hvv_hgg_eff_2067 = max(eff,0.) / 100.
      RETURN 
      END
      Real FUNCTION A2000_hvv_hgg_eff_2082(amass)
      implicit none
      integer i,nmas
      parameter (nmas=9)
      real hmass(nmas),effi(nmas)
      real eff,eff1,eff2,del1,del2,amass
c
      data hmass /75.,80.,85.,90.,95.,100.,105.,110.,115./
      data effi  /1.4,2.65,5.27,9.07,21.8,44.2,60.3,61.3,47.6/
      A2000_hvv_hgg_eff_2082 = 0.
      If (amass.lt.hmass(1))    return
      If (amass.gt.hmass(nmas)) return
      Do i=2,nmas
        If (amass.le.hmass(i)) then
            eff1 = effi(i-1)
            eff2 = effi(i)
            del1 = amass - hmass(i-1)
            del2 = hmass(i) - amass
            goto 1000
         endif
      Enddo
 1000 continue
      eff = (eff1*del2 + eff2*del1) / (del1 + del2)
      A2000_hvv_hgg_eff_2082 = max(eff,0.) / 100.
      RETURN 
      END
	SUBROUTINE A_HLL_SYSTEMATICS_flavind(iener_s,ratebgd_s, !input
     +                   dsig_s,dback_s,sysname_s,nerrch_s) !output
c
c       Returns the FRACTIONAL errors DSIG_S(isource) and DBACK_S(isource)
c       for the hll channels. The errors are detailed by source for the 
c       given channel NCHAN_S. (isource runs from 1 to nerrch_s)
c
c       NB How it works:
c       what the call to this  subroutine does is to insert the 1D arrays
c       DSIG_S(i=1 to a_maxnerr) and 
c       DBACK_S(i=1 to a_maxnerr) into the appropriate row of the  
c       big-picture 2D arrays DSIG(isource,nchan) and DBACK(isource,nchan)
c       defined in the main code.
c
c       Created: Pedro Teixeira-Dias, 22-Feb-2000.
c
c       Mods:
c       - For the 1999 analysis:---------------------------
c	iener = 3,6 --> 192-202 GeV
c       ratesig(1) =  bbll
c       ratesig(2) =  ttll
c       ratesig(3) =  (cc+gg)ll
c       ratebgd(1/2/3) = ZZ/eeZ/other 
c
      implicit none
      include 'a_inputs.inc'
      integer iener_s,ismbin,i
c
      integer nerrch_s!(a_maxnchan)
      real dsig_s(a_maxnerr)
      real dback_s(a_maxnerr)
      character*20 sysname_s(a_maxnerr)
c
      real ratebgd_s(5) ! to match dimensions in taus_decl.inc
      real aux(3)
c
c       Reported sources are:
c
      if (iener_s.eq.3) then	! 192 GeV
	 nerrch_s = 11	! total number of sources (s and b)
	 sysname_s(1) = 'A192-HLL-MCSTATS-SIG'
	 sysname_s(2) = 'A192-HLL-MCSTATS-BKG'
	 sysname_s(3) = 'A19X-HLL-LID'
	 sysname_s(4) = 'A192-HLL-LOANGLE-SIG'
	 sysname_s(5) = 'A192-HLL-LOANGLE-BKG'
	 sysname_s(6) = 'A192-HLL-ISOLANG-SIG'
	 sysname_s(7) = 'A192-HLL-ISOLANG-BKG'
	 sysname_s(8) = 'A192-HLL-PTSUM-SIG'
	 sysname_s(9) = 'A192-HLL-PTSUM-BKG'
	 sysname_s(10) = 'A192-HLL-TRACKSM-SIG'
	 sysname_s(11) = 'A192-HLL-TRACKSM-BKG'
      else if (iener_s.eq.4) then	! 196 GeV
	 nerrch_s = 11	! total number of sources (s and b)
	 sysname_s(1) = 'A196-HLL-MCSTATS-SIG'
	 sysname_s(2) = 'A196-HLL-MCSTATS-BKG'
	 sysname_s(3) = 'A19X-HLL-LID'
	 sysname_s(4) = 'A196-HLL-LOANGLE-SIG'
	 sysname_s(5) = 'A196-HLL-LOANGLE-BKG'
	 sysname_s(6) = 'A196-HLL-ISOLANG-SIG'
	 sysname_s(7) = 'A196-HLL-ISOLANG-BKG'
	 sysname_s(8) = 'A196-HLL-PTSUM-SIG'
	 sysname_s(9) = 'A196-HLL-PTSUM-BKG'
	 sysname_s(10) = 'A196-HLL-TRACKSM-SIG'
	 sysname_s(11) = 'A196-HLL-TRACKSM-BKG'
      else if (iener_s.eq.5) then	! 200 GeV
	 nerrch_s = 11	! total number of sources (s and b)
	 sysname_s(1) = 'A200-HLL-MCSTATS-SIG'
	 sysname_s(2) = 'A200-HLL-MCSTATS-BKG'
	 sysname_s(3) = 'A19X-HLL-LID'
	 sysname_s(4) = 'A200-HLL-LOANGLE-SIG'
	 sysname_s(5) = 'A200-HLL-LOANGLE-BKG'
	 sysname_s(6) = 'A200-HLL-ISOLANG-SIG'
	 sysname_s(7) = 'A200-HLL-ISOLANG-BKG'
	 sysname_s(8) = 'A200-HLL-PTSUM-SIG'
	 sysname_s(9) = 'A200-HLL-PTSUM-BKG'
	 sysname_s(10) = 'A200-HLL-TRACKSM-SIG'
	 sysname_s(11) = 'A200-HLL-TRACKSM-BKG'
      else if (iener_s.eq.6) then	! 202 GeV
	 nerrch_s = 11	! total number of sources (s and b)
	 sysname_s(1) = 'A202-HLL-MCSTATS-SIG'
	 sysname_s(2) = 'A202-HLL-MCSTATS-BKG'
	 sysname_s(3) = 'A19X-HLL-LID'
	 sysname_s(4) = 'A202-HLL-LOANGLE-SIG'
	 sysname_s(5) = 'A202-HLL-LOANGLE-BKG'
	 sysname_s(6) = 'A202-HLL-ISOLANG-SIG'
	 sysname_s(7) = 'A202-HLL-ISOLANG-BKG'
	 sysname_s(8) = 'A202-HLL-PTSUM-SIG'
	 sysname_s(9) = 'A202-HLL-PTSUM-BKG'
	 sysname_s(10) = 'A202-HLL-TRACKSM-SIG'
	 sysname_s(11) = 'A202-HLL-TRACKSM-BKG'
      end if			! IENER_S
c
c     Initialize error arrays
      do i=1,nerrch_s
	 dsig_s(i) = 0.00
	 dback_s(i) = 0.00
      end do
c
c     Here, use the typical numbers that Tom Greening reported for hll
c     (for mh=107 and ECM=200 GeV);
c
      IF (IENER_S.GE.3 .AND. IENER_S.LE.6) THEN ! 192 - 202 GeV ------------------
c       MC stats; sig and background
cjm changed 0.005 into 0.01 (2000 events with 80% of efficiency)
	dsig_s(1) = 0.01
	dback_s(2) = sqrt( (ratebgd_s(1)*0.025)**2 + 
     +                   (ratebgd_s(2)*0.059)**2 + 
     +                   (ratebgd_s(3)*0.086)**2 ) 
     + / (ratebgd_s(1) + ratebgd_s(2) + ratebgd_s(3))
c
	dsig_s(3) = 0.002
	dback_s(3) = 0.002
c
	dsig_s(4) = 0.00
	dback_s(5) = 0.07*ratebgd_s(3) 
     + / (ratebgd_s(1) + ratebgd_s(2) + ratebgd_s(3))
c
	dsig_s(6) = 0.002 
	dback_s(7) = sqrt( (ratebgd_s(1)*0.002)**2 + 
     +                   (ratebgd_s(2)*0.011)**2 + 
     +                   (ratebgd_s(3)*0.055)**2 ) 
     + / (ratebgd_s(1) + ratebgd_s(2) + ratebgd_s(3))
c
	dsig_s(8) = 0.00
	dback_s(9) = 0.166*ratebgd_s(3) 
     + / (ratebgd_s(1) + ratebgd_s(2) + ratebgd_s(3))
c
	dsig_s(10) = 0.001
	dback_s(11) = sqrt( (ratebgd_s(1)*0.001)**2 + 
     +                   (ratebgd_s(2)*0.011)**2 ) 
     + / (ratebgd_s(1) + ratebgd_s(2) + ratebgd_s(3))
c
      END IF ! IENER_S
c
      if (.FALSE.) then
	 write (6,*) '<a_hll_systematics> iener/ismbin=',iener_s,ismbin
	 write (6,*) (i,sysname_s(i),
     +    dsig_s(i),dback_s(i),i=1,nerrch_s)
      end if
c
      end




