C-*-FORTRAN-*-
C
C This file was prepared by PTD on Sun Feb  6 16:17:17 MET 2000
C This file collects the following inputs:
C
C -rw-r--r--   1 ptd      xu         61761 Feb  4 19:07 A192_tt_sig_mass_flav.F
C -rw-r--r--   1 ptd      xu         61761 Feb  4 19:07 A196_tt_sig_mass_flav.F
C -rw-r--r--   1 ptd      xu         61761 Feb  4 19:07 A200_tt_sig_mass_flav.F
C -rw-r--r--   1 ptd      xu         61761 Feb  4 19:07 A202_tt_sig_mass_flav.F
C
C 
C---- New file --- 
C 
      DOUBLE PRECISION FUNCTION A192_TT_SIG_MASS(REC_MASS,
     $     HYP_MASS, IANA, ISIG)
      IMPLICIT NONE
      DOUBLE PRECISION REC_MASS, HYP_MASS
      INTEGER IANA, ISIG
      DOUBLE PRECISION A192_TT_M_HAONLY_ONHTT, A192_TT_M_HZONLY_ONHTT,
     $     A192_TT_M_ASHA_ONHTT, A192_TT_M_ASHZ_ONHTT
      DOUBLE PRECISION A192_TT_M_HAONLY_ONHA, A192_TT_M_HZONLY_ONHA,
     $     A192_TT_M_ASHA_ONHA, A192_TT_M_ASHZ_ONHA
      DOUBLE PRECISION A192_TT_M_HAONLY_ONTTZ, A192_TT_M_HZONLY_ONTTZ,
     $     A192_TT_M_ASHA_ONTTZ, A192_TT_M_ASHZ_ONTTZ

C REC_MASS is the reconstructed mass 
C MASS_HYP is the Higgs mass hypothesis
C IANA defines the analysis branch
C  This index: 1=hAonly, 2=hZonly, 3=overlap (as hA), 4=overlap (as hZ)
C ISIG gives the signal 
C     1 to 4 =Htt
C     5      =ttZ,
C     6 to 9 =hA->ttX

      IF (ISIG.GE.1 .AND. ISIG.LE.4) THEN
         IF (IANA.EQ.1) THEN
            A192_TT_SIG_MASS = A192_TT_M_HAONLY_ONHTT(REC_MASS,HYP_MASS)
         ELSE IF (IANA.EQ.2) THEN
            A192_TT_SIG_MASS = A192_TT_M_HZONLY_ONHTT(REC_MASS,HYP_MASS)
         ELSE IF (IANA.EQ.3) THEN
            A192_TT_SIG_MASS = A192_TT_M_ASHA_ONHTT(REC_MASS,HYP_MASS)
         ELSE IF (IANA.EQ.4) THEN
            A192_TT_SIG_MASS = A192_TT_M_ASHZ_ONHTT(REC_MASS,HYP_MASS)
         ENDIF
      ELSE IF (ISIG.EQ.5) THEN
         IF (IANA.EQ.1) THEN
            A192_TT_SIG_MASS = A192_TT_M_HAONLY_ONTTZ(REC_MASS,HYP_MASS)
         ELSE IF (IANA.EQ.2) THEN
            A192_TT_SIG_MASS = A192_TT_M_HZONLY_ONTTZ(REC_MASS,HYP_MASS)
         ELSE IF (IANA.EQ.3) THEN
            A192_TT_SIG_MASS = A192_TT_M_ASHA_ONTTZ(REC_MASS,HYP_MASS)
         ELSE IF (IANA.EQ.4) THEN
            A192_TT_SIG_MASS = A192_TT_M_ASHZ_ONTTZ(REC_MASS,HYP_MASS)
         ENDIF
      ELSE IF (ISIG.GE.6 .AND. ISIG.LE.9) THEN
         IF (IANA.EQ.1) THEN
            A192_TT_SIG_MASS = A192_TT_M_HAONLY_ONHA(REC_MASS,HYP_MASS)
         ELSE IF (IANA.EQ.2) THEN
            A192_TT_SIG_MASS = A192_TT_M_HZONLY_ONHA(REC_MASS,HYP_MASS)
         ELSE IF (IANA.EQ.3) THEN
            A192_TT_SIG_MASS = A192_TT_M_ASHA_ONHA(REC_MASS,HYP_MASS)
         ELSE IF (IANA.EQ.4) THEN
            A192_TT_SIG_MASS = A192_TT_M_ASHZ_ONHA(REC_MASS,HYP_MASS)
         ENDIF
      ENDIF
      RETURN
      END


      DOUBLE PRECISION FUNCTION
     $     A192_TT_M_HAONLY_ONHA(REC_MASS, HYP_MASS)
      IMPLICIT NONE
      DOUBLE PRECISION REC_MASS, HYP_MASS
      DOUBLE PRECISION DELTA1, DELTA2, REFMH1, REFMH2, F1, F2
      DOUBLE PRECISION
     $     A192_TT_HAONLY_HATT60_MASS, A192_TT_HAONLY_HATT65_MASS,
     $     A192_TT_HAONLY_HATT70_MASS, A192_TT_HAONLY_HATT75_MASS,
     $     A192_TT_HAONLY_HATT80_MASS, A192_TT_HAONLY_HATT85_MASS,
     $     A192_TT_HAONLY_HATT90_MASS, A192_TT_HAONLY_HATT95_MASS,
     $     A192_TT_HAONLY_HATT100_MASS, A192_TT_HAONLY_HATT105_MASS,
     $     A192_TT_HAONLY_HATT107_MASS, A192_TT_HAONLY_HATT110_MASS,
     $     A192_TT_HAONLY_HATT115_MASS, A192_TT_HAONLY_HATT120_MASS
C 
C (No integration since shapes made with KEYS are by default 
C  normalized when created.)
C
      IF (HYP_MASS.GE.60D0 .AND. HYP_MASS.LE.65D0) THEN
         REFMH1 = 60D0
         REFMH2 = 65D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HAONLY_HATT60_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_HAONLY_HATT65_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.65D0 .AND. HYP_MASS.LE.70D0) THEN
         REFMH1 = 65D0
         REFMH2 = 70D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HAONLY_HATT65_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_HAONLY_HATT70_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.70D0 .AND. HYP_MASS.LE.75D0) THEN
         REFMH1 = 70D0
         REFMH2 = 75D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HAONLY_HATT70_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_HAONLY_HATT75_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.75D0 .AND. HYP_MASS.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HAONLY_HATT75_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_HAONLY_HATT80_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.80D0 .AND. HYP_MASS.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HAONLY_HATT80_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_HAONLY_HATT85_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.85D0 .AND. HYP_MASS.LE.90D0) THEN 
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HAONLY_HATT85_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_HAONLY_HATT90_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.90D0 .AND. HYP_MASS.LE.95D0) THEN 
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HAONLY_HATT90_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_HAONLY_HATT95_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.95D0 .AND. HYP_MASS.LE.100D0) THEN 
         REFMH1 = 95D0
         REFMH2 = 100D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HAONLY_HATT95_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_HAONLY_HATT100_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.100D0 .AND. HYP_MASS.LE.105D0) THEN 
         REFMH1 = 100D0
         REFMH2 = 105D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HAONLY_HATT100_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_HAONLY_HATT105_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.105D0 .AND. HYP_MASS.LE.107D0) THEN 
         REFMH1 = 105D0
         REFMH2 = 107D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HAONLY_HATT105_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_HAONLY_HATT107_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.107D0 .AND. HYP_MASS.LE.110D0) THEN 
         REFMH1 = 107D0
         REFMH2 = 110D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HAONLY_HATT107_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_HAONLY_HATT110_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.110D0 .AND. HYP_MASS.LE.115D0) THEN 
         REFMH1 = 110D0
         REFMH2 = 115D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HAONLY_HATT110_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_HAONLY_HATT115_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.115D0 .AND. HYP_MASS.LE.120D0) THEN 
         REFMH1 = 115D0
         REFMH2 = 120D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HAONLY_HATT115_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_HAONLY_HATT120_MASS(REC_MASS+DELTA2)
      ELSE
         A192_TT_M_HAONLY_ONHA = 0.D0
         RETURN
      ENDIF

      A192_TT_M_HAONLY_ONHA = (DELTA2 * F1 + DELTA1 * F2)
     $     / (REFMH2 - REFMH1)
      IF (A192_TT_M_HAONLY_ONHA.LT.1.D-05) THEN
         A192_TT_M_HAONLY_ONHA = 1.D-05 
      ENDIF
      
      RETURN
      END

      DOUBLE PRECISION FUNCTION
     $     A192_TT_M_HZONLY_ONHA(REC_MASS, HYP_MASS)
      IMPLICIT NONE
      DOUBLE PRECISION REC_MASS, HYP_MASS
      DOUBLE PRECISION DELTA1, DELTA2, REFMH1, REFMH2, F1, F2
      DOUBLE PRECISION
     $     A192_TT_HZONLY_HATT60_MASS, A192_TT_HZONLY_HATT65_MASS,
     $     A192_TT_HZONLY_HATT70_MASS, A192_TT_HZONLY_HATT75_MASS,
     $     A192_TT_HZONLY_HATT80_MASS, A192_TT_HZONLY_HATT85_MASS,
     $     A192_TT_HZONLY_HATT90_MASS, A192_TT_HZONLY_HATT95_MASS,
     $     A192_TT_HZONLY_HATT100_MASS, A192_TT_HZONLY_HATT105_MASS,
     $     A192_TT_HZONLY_HATT107_MASS, A192_TT_HZONLY_HATT110_MASS,
     $     A192_TT_HZONLY_HATT115_MASS, A192_TT_HZONLY_HATT120_MASS
C 
C (No integration since shapes made with KEYS are by default 
C  normalized when created.)
C
      IF (HYP_MASS.GE.60D0 .AND. HYP_MASS.LE.65D0) THEN
         REFMH1 = 60D0
         REFMH2 = 65D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HZONLY_HATT60_MASS(REC_MASS-DELTA1*2.)
         F2 = A192_TT_HZONLY_HATT65_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.65D0 .AND. HYP_MASS.LE.70D0) THEN
         REFMH1 = 65D0
         REFMH2 = 70D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HZONLY_HATT65_MASS(REC_MASS-DELTA1*2.)
         F2 = A192_TT_HZONLY_HATT70_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.70D0 .AND. HYP_MASS.LE.75D0) THEN
         REFMH1 = 70D0
         REFMH2 = 75D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HZONLY_HATT70_MASS(REC_MASS-DELTA1*2.)
         F2 = A192_TT_HZONLY_HATT75_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.75D0 .AND. HYP_MASS.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HZONLY_HATT75_MASS(REC_MASS-DELTA1*2.)
         F2 = A192_TT_HZONLY_HATT80_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.80D0 .AND. HYP_MASS.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HZONLY_HATT80_MASS(REC_MASS-DELTA1*2.)
         F2 = A192_TT_HZONLY_HATT85_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.85D0 .AND. HYP_MASS.LE.90D0) THEN 
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HZONLY_HATT85_MASS(REC_MASS-DELTA1*2.)
         F2 = A192_TT_HZONLY_HATT90_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.90D0 .AND. HYP_MASS.LE.95D0) THEN 
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HZONLY_HATT90_MASS(REC_MASS-DELTA1*2.)
         F2 = A192_TT_HZONLY_HATT95_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.95D0 .AND. HYP_MASS.LE.100D0) THEN 
         REFMH1 = 95D0
         REFMH2 = 100D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HZONLY_HATT95_MASS(REC_MASS-DELTA1*2.)
         F2 = A192_TT_HZONLY_HATT100_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.100D0 .AND. HYP_MASS.LE.105D0) THEN 
         REFMH1 = 100D0
         REFMH2 = 105D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HZONLY_HATT100_MASS(REC_MASS-DELTA1*2.)
         F2 = A192_TT_HZONLY_HATT105_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.105D0 .AND. HYP_MASS.LE.107D0) THEN 
         REFMH1 = 105D0
         REFMH2 = 107D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HZONLY_HATT105_MASS(REC_MASS-DELTA1*2.)
         F2 = A192_TT_HZONLY_HATT107_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.107D0 .AND. HYP_MASS.LE.110D0) THEN 
         REFMH1 = 107D0
         REFMH2 = 110D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HZONLY_HATT107_MASS(REC_MASS-DELTA1*2.)
         F2 = A192_TT_HZONLY_HATT110_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.110D0 .AND. HYP_MASS.LE.115D0) THEN 
         REFMH1 = 110D0
         REFMH2 = 115D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HZONLY_HATT110_MASS(REC_MASS-DELTA1*2.)
         F2 = A192_TT_HZONLY_HATT115_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.115D0 .AND. HYP_MASS.LE.120D0) THEN 
         REFMH1 = 115D0
         REFMH2 = 120D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HZONLY_HATT115_MASS(REC_MASS-DELTA1*2.)
         F2 = A192_TT_HZONLY_HATT120_MASS(REC_MASS+DELTA2*2.)
      ELSE
         A192_TT_M_HZONLY_ONHA = 0.D0
         RETURN
      ENDIF

      A192_TT_M_HZONLY_ONHA = (DELTA2 * F1 + DELTA1 * F2)
     $     / (REFMH2 - REFMH1)
      IF (A192_TT_M_HZONLY_ONHA.LT.1.D-05) THEN
         A192_TT_M_HZONLY_ONHA = 1.D-05 
      ENDIF
      
      RETURN
      END

      DOUBLE PRECISION FUNCTION
     $     A192_TT_M_ASHA_ONHA(REC_MASS, HYP_MASS)
      IMPLICIT NONE
      DOUBLE PRECISION REC_MASS, HYP_MASS
      DOUBLE PRECISION DELTA1, DELTA2, REFMH1, REFMH2, F1, F2
      DOUBLE PRECISION
     $     A192_TT_ASHA_HATT60_MASS, A192_TT_ASHA_HATT65_MASS,
     $     A192_TT_ASHA_HATT70_MASS, A192_TT_ASHA_HATT75_MASS,
     $     A192_TT_ASHA_HATT80_MASS, A192_TT_ASHA_HATT85_MASS,
     $     A192_TT_ASHA_HATT90_MASS, A192_TT_ASHA_HATT95_MASS,
     $     A192_TT_ASHA_HATT100_MASS, A192_TT_ASHA_HATT105_MASS,
     $     A192_TT_ASHA_HATT107_MASS, A192_TT_ASHA_HATT110_MASS,
     $     A192_TT_ASHA_HATT115_MASS, A192_TT_ASHA_HATT120_MASS
C 
C (No integration since shapes made with KEYS are by default 
C  normalized when created.)
C
      IF (HYP_MASS.GE.60D0 .AND. HYP_MASS.LE.65D0) THEN
         REFMH1 = 60D0
         REFMH2 = 65D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHA_HATT60_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_ASHA_HATT65_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.65D0 .AND. HYP_MASS.LE.70D0) THEN
         REFMH1 = 65D0
         REFMH2 = 70D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHA_HATT65_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_ASHA_HATT70_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.70D0 .AND. HYP_MASS.LE.75D0) THEN
         REFMH1 = 70D0
         REFMH2 = 75D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHA_HATT70_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_ASHA_HATT75_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.75D0 .AND. HYP_MASS.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHA_HATT75_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_ASHA_HATT80_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.80D0 .AND. HYP_MASS.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHA_HATT80_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_ASHA_HATT85_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.85D0 .AND. HYP_MASS.LE.90D0) THEN 
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHA_HATT85_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_ASHA_HATT90_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.90D0 .AND. HYP_MASS.LE.95D0) THEN 
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHA_HATT90_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_ASHA_HATT95_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.95D0 .AND. HYP_MASS.LE.100D0) THEN 
         REFMH1 = 95D0
         REFMH2 = 100D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHA_HATT95_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_ASHA_HATT100_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.100D0 .AND. HYP_MASS.LE.105D0) THEN 
         REFMH1 = 100D0
         REFMH2 = 105D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHA_HATT100_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_ASHA_HATT105_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.105D0 .AND. HYP_MASS.LE.107D0) THEN 
         REFMH1 = 105D0
         REFMH2 = 107D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHA_HATT105_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_ASHA_HATT107_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.107D0 .AND. HYP_MASS.LE.110D0) THEN 
         REFMH1 = 107D0
         REFMH2 = 110D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHA_HATT107_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_ASHA_HATT110_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.110D0 .AND. HYP_MASS.LE.115D0) THEN 
         REFMH1 = 110D0
         REFMH2 = 115D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHA_HATT110_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_ASHA_HATT115_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.115D0 .AND. HYP_MASS.LE.120D0) THEN 
         REFMH1 = 115D0
         REFMH2 = 120D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHA_HATT115_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_ASHA_HATT120_MASS(REC_MASS+DELTA2)
      ELSE
         A192_TT_M_ASHA_ONHA = 0.D0
         RETURN
      ENDIF

      A192_TT_M_ASHA_ONHA = (DELTA2 * F1 + DELTA1 * F2)
     $     / (REFMH2 - REFMH1)
      IF (A192_TT_M_ASHA_ONHA.LT.1.D-05) THEN
         A192_TT_M_ASHA_ONHA = 1.D-05 
      ENDIF
      
      RETURN
      END

      DOUBLE PRECISION FUNCTION
     $     A192_TT_M_ASHZ_ONHA(REC_MASS, HYP_MASS)
      IMPLICIT NONE
      DOUBLE PRECISION REC_MASS, HYP_MASS
      DOUBLE PRECISION DELTA1, DELTA2, REFMH1, REFMH2, F1, F2
      DOUBLE PRECISION
     $     A192_TT_ASHZ_HATT60_MASS, A192_TT_ASHZ_HATT65_MASS,
     $     A192_TT_ASHZ_HATT70_MASS, A192_TT_ASHZ_HATT75_MASS,
     $     A192_TT_ASHZ_HATT80_MASS, A192_TT_ASHZ_HATT85_MASS,
     $     A192_TT_ASHZ_HATT90_MASS, A192_TT_ASHZ_HATT95_MASS,
     $     A192_TT_ASHZ_HATT100_MASS, A192_TT_ASHZ_HATT105_MASS,
     $     A192_TT_ASHZ_HATT107_MASS, A192_TT_ASHZ_HATT110_MASS,
     $     A192_TT_ASHZ_HATT115_MASS, A192_TT_ASHZ_HATT120_MASS
C 
C (No integration since shapes made with KEYS are by default 
C  normalized when created.)
C
      IF (HYP_MASS.GE.60D0 .AND. HYP_MASS.LE.65D0) THEN
         REFMH1 = 60D0
         REFMH2 = 65D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHZ_HATT60_MASS(REC_MASS-DELTA1*2.)
         F2 = A192_TT_ASHZ_HATT65_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.65D0 .AND. HYP_MASS.LE.70D0) THEN
         REFMH1 = 65D0
         REFMH2 = 70D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHZ_HATT65_MASS(REC_MASS-DELTA1*2.)
         F2 = A192_TT_ASHZ_HATT70_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.70D0 .AND. HYP_MASS.LE.75D0) THEN
         REFMH1 = 70D0
         REFMH2 = 75D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHZ_HATT70_MASS(REC_MASS-DELTA1*2.)
         F2 = A192_TT_ASHZ_HATT75_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.75D0 .AND. HYP_MASS.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHZ_HATT75_MASS(REC_MASS-DELTA1*2.)
         F2 = A192_TT_ASHZ_HATT80_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.80D0 .AND. HYP_MASS.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHZ_HATT80_MASS(REC_MASS-DELTA1*2.)
         F2 = A192_TT_ASHZ_HATT85_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.85D0 .AND. HYP_MASS.LE.90D0) THEN 
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHZ_HATT85_MASS(REC_MASS-DELTA1*2.)
         F2 = A192_TT_ASHZ_HATT90_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.90D0 .AND. HYP_MASS.LE.95D0) THEN 
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHZ_HATT90_MASS(REC_MASS-DELTA1*2.)
         F2 = A192_TT_ASHZ_HATT95_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.95D0 .AND. HYP_MASS.LE.100D0) THEN 
         REFMH1 = 95D0
         REFMH2 = 100D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHZ_HATT95_MASS(REC_MASS-DELTA1*2.)
         F2 = A192_TT_ASHZ_HATT100_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.100D0 .AND. HYP_MASS.LE.105D0) THEN 
         REFMH1 = 100D0
         REFMH2 = 105D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHZ_HATT100_MASS(REC_MASS-DELTA1*2.)
         F2 = A192_TT_ASHZ_HATT105_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.105D0 .AND. HYP_MASS.LE.107D0) THEN 
         REFMH1 = 105D0
         REFMH2 = 107D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHZ_HATT105_MASS(REC_MASS-DELTA1*2.)
         F2 = A192_TT_ASHZ_HATT107_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.107D0 .AND. HYP_MASS.LE.110D0) THEN 
         REFMH1 = 107D0
         REFMH2 = 110D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHZ_HATT107_MASS(REC_MASS-DELTA1*2.)
         F2 = A192_TT_ASHZ_HATT110_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.110D0 .AND. HYP_MASS.LE.115D0) THEN 
         REFMH1 = 110D0
         REFMH2 = 115D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHZ_HATT110_MASS(REC_MASS-DELTA1*2.)
         F2 = A192_TT_ASHZ_HATT115_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.115D0 .AND. HYP_MASS.LE.120D0) THEN 
         REFMH1 = 115D0
         REFMH2 = 120D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHZ_HATT115_MASS(REC_MASS-DELTA1*2.)
         F2 = A192_TT_ASHZ_HATT120_MASS(REC_MASS+DELTA2*2.)
      ELSE
         A192_TT_M_ASHZ_ONHA = 0.D0
         RETURN
      ENDIF

      A192_TT_M_ASHZ_ONHA = (DELTA2 * F1 + DELTA1 * F2)
     $     / (REFMH2 - REFMH1)
      IF (A192_TT_M_ASHZ_ONHA.LT.1.D-05) THEN
         A192_TT_M_ASHZ_ONHA = 1.D-05 
      ENDIF
      
      RETURN
      END

      DOUBLE PRECISION FUNCTION
     $     A192_TT_M_HAONLY_ONHTT(REC_MASS, HYP_MASS)
      IMPLICIT NONE
      DOUBLE PRECISION REC_MASS, HYP_MASS
      DOUBLE PRECISION DELTA1, DELTA2, REFMH1, REFMH2, F1, F2
      DOUBLE PRECISION
     $     A192_TT_HAONLY_HTT60_MASS, A192_TT_HAONLY_HTT65_MASS,
     $     A192_TT_HAONLY_HTT70_MASS, A192_TT_HAONLY_HTT75_MASS,
     $     A192_TT_HAONLY_HTT80_MASS, A192_TT_HAONLY_HTT85_MASS,
     $     A192_TT_HAONLY_HTT90_MASS, A192_TT_HAONLY_HTT95_MASS,
     $     A192_TT_HAONLY_HTT100_MASS, A192_TT_HAONLY_HTT105_MASS,
     $     A192_TT_HAONLY_HTT107_MASS, A192_TT_HAONLY_HTT110_MASS,
     $     A192_TT_HAONLY_HTT115_MASS, A192_TT_HAONLY_HTT120_MASS
C 
C (No integration since shapes made with KEYS are by default 
C  normalized when created.)
C
      IF (HYP_MASS.GE.60D0 .AND. HYP_MASS.LE.65D0) THEN
         REFMH1 = 60D0
         REFMH2 = 65D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HAONLY_HTT60_MASS(REC_MASS-DELTA1/2.)
         F2 = A192_TT_HAONLY_HTT65_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.65D0 .AND. HYP_MASS.LE.70D0) THEN
         REFMH1 = 65D0
         REFMH2 = 70D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HAONLY_HTT65_MASS(REC_MASS-DELTA1/2.)
         F2 = A192_TT_HAONLY_HTT70_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.70D0 .AND. HYP_MASS.LE.75D0) THEN
         REFMH1 = 70D0
         REFMH2 = 75D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HAONLY_HTT70_MASS(REC_MASS-DELTA1/2.)
         F2 = A192_TT_HAONLY_HTT75_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.75D0 .AND. HYP_MASS.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HAONLY_HTT75_MASS(REC_MASS-DELTA1/2.)
         F2 = A192_TT_HAONLY_HTT80_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.80D0 .AND. HYP_MASS.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HAONLY_HTT80_MASS(REC_MASS-DELTA1/2.)
         F2 = A192_TT_HAONLY_HTT85_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.85D0 .AND. HYP_MASS.LE.90D0) THEN 
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HAONLY_HTT85_MASS(REC_MASS-DELTA1/2.)
         F2 = A192_TT_HAONLY_HTT90_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.90D0 .AND. HYP_MASS.LE.95D0) THEN 
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HAONLY_HTT90_MASS(REC_MASS-DELTA1/2.)
         F2 = A192_TT_HAONLY_HTT95_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.95D0 .AND. HYP_MASS.LE.100D0) THEN 
         REFMH1 = 95D0
         REFMH2 = 100D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HAONLY_HTT95_MASS(REC_MASS-DELTA1/2.)
         F2 = A192_TT_HAONLY_HTT100_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.100D0 .AND. HYP_MASS.LE.105D0) THEN 
         REFMH1 = 100D0
         REFMH2 = 105D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HAONLY_HTT100_MASS(REC_MASS-DELTA1/2.)
         F2 = A192_TT_HAONLY_HTT105_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.105D0 .AND. HYP_MASS.LE.107D0) THEN 
         REFMH1 = 105D0
         REFMH2 = 107D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HAONLY_HTT105_MASS(REC_MASS-DELTA1/2.)
         F2 = A192_TT_HAONLY_HTT107_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.107D0 .AND. HYP_MASS.LE.110D0) THEN 
         REFMH1 = 107D0
         REFMH2 = 110D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HAONLY_HTT107_MASS(REC_MASS-DELTA1/2.)
         F2 = A192_TT_HAONLY_HTT110_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.110D0 .AND. HYP_MASS.LE.115D0) THEN 
         REFMH1 = 110D0
         REFMH2 = 115D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HAONLY_HTT110_MASS(REC_MASS-DELTA1/2.)
         F2 = A192_TT_HAONLY_HTT115_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.115D0 .AND. HYP_MASS.LE.120D0) THEN 
         REFMH1 = 115D0
         REFMH2 = 120D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HAONLY_HTT115_MASS(REC_MASS-DELTA1/2.)
         F2 = A192_TT_HAONLY_HTT120_MASS(REC_MASS+DELTA2/2.)
      ELSE
         A192_TT_M_HAONLY_ONHTT = 0.D0
         RETURN
      ENDIF

      A192_TT_M_HAONLY_ONHTT = (DELTA2 * F1 + DELTA1 * F2)
     $     / (REFMH2 - REFMH1)
      IF (A192_TT_M_HAONLY_ONHTT.LT.1.D-05) THEN
         A192_TT_M_HAONLY_ONHTT = 1.D-05 
      ENDIF
      
      RETURN
      END

      DOUBLE PRECISION FUNCTION
     $     A192_TT_M_HZONLY_ONHTT(REC_MASS, HYP_MASS)
      IMPLICIT NONE
      DOUBLE PRECISION REC_MASS, HYP_MASS
      DOUBLE PRECISION DELTA1, DELTA2, REFMH1, REFMH2, F1, F2
      DOUBLE PRECISION
     $     A192_TT_HZONLY_HTT60_MASS, A192_TT_HZONLY_HTT65_MASS,
     $     A192_TT_HZONLY_HTT70_MASS, A192_TT_HZONLY_HTT75_MASS,
     $     A192_TT_HZONLY_HTT80_MASS, A192_TT_HZONLY_HTT85_MASS,
     $     A192_TT_HZONLY_HTT90_MASS, A192_TT_HZONLY_HTT95_MASS,
     $     A192_TT_HZONLY_HTT100_MASS, A192_TT_HZONLY_HTT105_MASS,
     $     A192_TT_HZONLY_HTT107_MASS, A192_TT_HZONLY_HTT110_MASS,
     $     A192_TT_HZONLY_HTT115_MASS, A192_TT_HZONLY_HTT120_MASS
C 
C (No integration since shapes made with KEYS are by default 
C  normalized when created.)
C
      IF (HYP_MASS.GE.60D0 .AND. HYP_MASS.LE.65D0) THEN
         REFMH1 = 60D0
         REFMH2 = 65D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HZONLY_HTT60_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_HZONLY_HTT65_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.65D0 .AND. HYP_MASS.LE.70D0) THEN
         REFMH1 = 65D0
         REFMH2 = 70D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HZONLY_HTT65_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_HZONLY_HTT70_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.70D0 .AND. HYP_MASS.LE.75D0) THEN
         REFMH1 = 70D0
         REFMH2 = 75D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HZONLY_HTT70_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_HZONLY_HTT75_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.75D0 .AND. HYP_MASS.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HZONLY_HTT75_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_HZONLY_HTT80_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.80D0 .AND. HYP_MASS.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HZONLY_HTT80_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_HZONLY_HTT85_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.85D0 .AND. HYP_MASS.LE.90D0) THEN 
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HZONLY_HTT85_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_HZONLY_HTT90_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.90D0 .AND. HYP_MASS.LE.95D0) THEN 
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HZONLY_HTT90_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_HZONLY_HTT95_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.95D0 .AND. HYP_MASS.LE.100D0) THEN 
         REFMH1 = 95D0
         REFMH2 = 100D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HZONLY_HTT95_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_HZONLY_HTT100_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.100D0 .AND. HYP_MASS.LE.105D0) THEN 
         REFMH1 = 100D0
         REFMH2 = 105D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HZONLY_HTT100_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_HZONLY_HTT105_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.105D0 .AND. HYP_MASS.LE.107D0) THEN 
         REFMH1 = 105D0
         REFMH2 = 107D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HZONLY_HTT105_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_HZONLY_HTT107_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.107D0 .AND. HYP_MASS.LE.110D0) THEN 
         REFMH1 = 107D0
         REFMH2 = 110D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HZONLY_HTT107_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_HZONLY_HTT110_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.110D0 .AND. HYP_MASS.LE.115D0) THEN 
         REFMH1 = 110D0
         REFMH2 = 115D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HZONLY_HTT110_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_HZONLY_HTT115_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.115D0 .AND. HYP_MASS.LE.120D0) THEN 
         REFMH1 = 115D0
         REFMH2 = 120D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HZONLY_HTT115_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_HZONLY_HTT120_MASS(REC_MASS+DELTA2)
      ELSE
         A192_TT_M_HZONLY_ONHTT = 0.D0
         RETURN
      ENDIF

      A192_TT_M_HZONLY_ONHTT = (DELTA2 * F1 + DELTA1 * F2)
     $     / (REFMH2 - REFMH1)
      IF (A192_TT_M_HZONLY_ONHTT.LT.1.D-05) THEN
         A192_TT_M_HZONLY_ONHTT = 1.D-05 
      ENDIF
      
      RETURN
      END

      DOUBLE PRECISION FUNCTION
     $     A192_TT_M_ASHA_ONHTT(REC_MASS, HYP_MASS)
      IMPLICIT NONE
      DOUBLE PRECISION REC_MASS, HYP_MASS
      DOUBLE PRECISION DELTA1, DELTA2, REFMH1, REFMH2, F1, F2
      DOUBLE PRECISION
     $     A192_TT_ASHA_HTT60_MASS, A192_TT_ASHA_HTT65_MASS,
     $     A192_TT_ASHA_HTT70_MASS, A192_TT_ASHA_HTT75_MASS,
     $     A192_TT_ASHA_HTT80_MASS, A192_TT_ASHA_HTT85_MASS,
     $     A192_TT_ASHA_HTT90_MASS, A192_TT_ASHA_HTT95_MASS,
     $     A192_TT_ASHA_HTT100_MASS, A192_TT_ASHA_HTT105_MASS,
     $     A192_TT_ASHA_HTT107_MASS, A192_TT_ASHA_HTT110_MASS,
     $     A192_TT_ASHA_HTT115_MASS, A192_TT_ASHA_HTT120_MASS
C 
C (No integration since shapes made with KEYS are by default 
C  normalized when created.)
C
      IF (HYP_MASS.GE.60D0 .AND. HYP_MASS.LE.65D0) THEN
         REFMH1 = 60D0
         REFMH2 = 65D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHA_HTT60_MASS(REC_MASS-DELTA1/2.)
         F2 = A192_TT_ASHA_HTT65_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.65D0 .AND. HYP_MASS.LE.70D0) THEN
         REFMH1 = 65D0
         REFMH2 = 70D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHA_HTT65_MASS(REC_MASS-DELTA1/2.)
         F2 = A192_TT_ASHA_HTT70_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.70D0 .AND. HYP_MASS.LE.75D0) THEN
         REFMH1 = 70D0
         REFMH2 = 75D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHA_HTT70_MASS(REC_MASS-DELTA1/2.)
         F2 = A192_TT_ASHA_HTT75_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.75D0 .AND. HYP_MASS.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHA_HTT75_MASS(REC_MASS-DELTA1/2.)
         F2 = A192_TT_ASHA_HTT80_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.80D0 .AND. HYP_MASS.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHA_HTT80_MASS(REC_MASS-DELTA1/2.)
         F2 = A192_TT_ASHA_HTT85_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.85D0 .AND. HYP_MASS.LE.90D0) THEN 
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHA_HTT85_MASS(REC_MASS-DELTA1/2.)
         F2 = A192_TT_ASHA_HTT90_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.90D0 .AND. HYP_MASS.LE.95D0) THEN 
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHA_HTT90_MASS(REC_MASS-DELTA1/2.)
         F2 = A192_TT_ASHA_HTT95_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.95D0 .AND. HYP_MASS.LE.100D0) THEN 
         REFMH1 = 95D0
         REFMH2 = 100D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHA_HTT95_MASS(REC_MASS-DELTA1/2.)
         F2 = A192_TT_ASHA_HTT100_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.100D0 .AND. HYP_MASS.LE.105D0) THEN 
         REFMH1 = 100D0
         REFMH2 = 105D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHA_HTT100_MASS(REC_MASS-DELTA1/2.)
         F2 = A192_TT_ASHA_HTT105_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.105D0 .AND. HYP_MASS.LE.107D0) THEN 
         REFMH1 = 105D0
         REFMH2 = 107D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHA_HTT105_MASS(REC_MASS-DELTA1/2.)
         F2 = A192_TT_ASHA_HTT107_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.107D0 .AND. HYP_MASS.LE.110D0) THEN 
         REFMH1 = 107D0
         REFMH2 = 110D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHA_HTT107_MASS(REC_MASS-DELTA1/2.)
         F2 = A192_TT_ASHA_HTT110_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.110D0 .AND. HYP_MASS.LE.115D0) THEN 
         REFMH1 = 110D0
         REFMH2 = 115D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHA_HTT110_MASS(REC_MASS-DELTA1/2.)
         F2 = A192_TT_ASHA_HTT115_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.115D0 .AND. HYP_MASS.LE.120D0) THEN 
         REFMH1 = 115D0
         REFMH2 = 120D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHA_HTT115_MASS(REC_MASS-DELTA1/2.)
         F2 = A192_TT_ASHA_HTT120_MASS(REC_MASS+DELTA2/2.)
      ELSE
         A192_TT_M_ASHA_ONHTT = 0.D0
         RETURN
      ENDIF

      A192_TT_M_ASHA_ONHTT = (DELTA2 * F1 + DELTA1 * F2)
     $     / (REFMH2 - REFMH1)
      IF (A192_TT_M_ASHA_ONHTT.LT.1.D-05) THEN
         A192_TT_M_ASHA_ONHTT = 1.D-05 
      ENDIF
      
      RETURN
      END

      DOUBLE PRECISION FUNCTION
     $     A192_TT_M_ASHZ_ONHTT(REC_MASS, HYP_MASS)
      IMPLICIT NONE
      DOUBLE PRECISION REC_MASS, HYP_MASS
      DOUBLE PRECISION DELTA1, DELTA2, REFMH1, REFMH2, F1, F2
      DOUBLE PRECISION
     $     A192_TT_ASHZ_HTT60_MASS, A192_TT_ASHZ_HTT65_MASS,
     $     A192_TT_ASHZ_HTT70_MASS, A192_TT_ASHZ_HTT75_MASS,
     $     A192_TT_ASHZ_HTT80_MASS, A192_TT_ASHZ_HTT85_MASS,
     $     A192_TT_ASHZ_HTT90_MASS, A192_TT_ASHZ_HTT95_MASS,
     $     A192_TT_ASHZ_HTT100_MASS, A192_TT_ASHZ_HTT105_MASS,
     $     A192_TT_ASHZ_HTT107_MASS, A192_TT_ASHZ_HTT110_MASS,
     $     A192_TT_ASHZ_HTT115_MASS, A192_TT_ASHZ_HTT120_MASS
C 
C (No integration since shapes made with KEYS are by default 
C  normalized when created.)
C
      IF (HYP_MASS.GE.60D0 .AND. HYP_MASS.LE.65D0) THEN
         REFMH1 = 60D0
         REFMH2 = 65D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHZ_HTT60_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_ASHZ_HTT65_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.65D0 .AND. HYP_MASS.LE.70D0) THEN
         REFMH1 = 65D0
         REFMH2 = 70D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHZ_HTT65_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_ASHZ_HTT70_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.70D0 .AND. HYP_MASS.LE.75D0) THEN
         REFMH1 = 70D0
         REFMH2 = 75D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHZ_HTT70_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_ASHZ_HTT75_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.75D0 .AND. HYP_MASS.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHZ_HTT75_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_ASHZ_HTT80_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.80D0 .AND. HYP_MASS.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHZ_HTT80_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_ASHZ_HTT85_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.85D0 .AND. HYP_MASS.LE.90D0) THEN 
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHZ_HTT85_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_ASHZ_HTT90_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.90D0 .AND. HYP_MASS.LE.95D0) THEN 
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHZ_HTT90_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_ASHZ_HTT95_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.95D0 .AND. HYP_MASS.LE.100D0) THEN 
         REFMH1 = 95D0
         REFMH2 = 100D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHZ_HTT95_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_ASHZ_HTT100_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.100D0 .AND. HYP_MASS.LE.105D0) THEN 
         REFMH1 = 100D0
         REFMH2 = 105D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHZ_HTT100_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_ASHZ_HTT105_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.105D0 .AND. HYP_MASS.LE.107D0) THEN 
         REFMH1 = 105D0
         REFMH2 = 107D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHZ_HTT105_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_ASHZ_HTT107_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.107D0 .AND. HYP_MASS.LE.110D0) THEN 
         REFMH1 = 107D0
         REFMH2 = 110D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHZ_HTT107_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_ASHZ_HTT110_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.110D0 .AND. HYP_MASS.LE.115D0) THEN 
         REFMH1 = 110D0
         REFMH2 = 115D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHZ_HTT110_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_ASHZ_HTT115_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.115D0 .AND. HYP_MASS.LE.120D0) THEN 
         REFMH1 = 115D0
         REFMH2 = 120D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHZ_HTT115_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_ASHZ_HTT120_MASS(REC_MASS+DELTA2)
      ELSE
         A192_TT_M_ASHZ_ONHTT = 0.D0
         RETURN
      ENDIF

      A192_TT_M_ASHZ_ONHTT = (DELTA2 * F1 + DELTA1 * F2)
     $     / (REFMH2 - REFMH1)
      IF (A192_TT_M_ASHZ_ONHTT.LT.1.D-05) THEN
         A192_TT_M_ASHZ_ONHTT = 1.D-05 
      ENDIF
      
      RETURN
      END

      DOUBLE PRECISION FUNCTION
     $     A192_TT_M_HAONLY_ONTTZ(REC_MASS, HYP_MASS)
      IMPLICIT NONE
      DOUBLE PRECISION REC_MASS, HYP_MASS
      DOUBLE PRECISION DELTA1, DELTA2, REFMH1, REFMH2, F1, F2
      DOUBLE PRECISION
     $     A192_TT_HAONLY_TTZ60_MASS, A192_TT_HAONLY_TTZ65_MASS,
     $     A192_TT_HAONLY_TTZ70_MASS, A192_TT_HAONLY_TTZ75_MASS,
     $     A192_TT_HAONLY_TTZ80_MASS, A192_TT_HAONLY_TTZ85_MASS,
     $     A192_TT_HAONLY_TTZ90_MASS, A192_TT_HAONLY_TTZ95_MASS,
     $     A192_TT_HAONLY_TTZ100_MASS, A192_TT_HAONLY_TTZ105_MASS,
     $     A192_TT_HAONLY_TTZ107_MASS, A192_TT_HAONLY_TTZ110_MASS,
     $     A192_TT_HAONLY_TTZ115_MASS, A192_TT_HAONLY_TTZ120_MASS
C 
C (No integration since shapes made with KEYS are by default 
C  normalized when created.)
C
      IF (HYP_MASS.GE.60D0 .AND. HYP_MASS.LE.65D0) THEN
         REFMH1 = 60D0
         REFMH2 = 65D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HAONLY_TTZ60_MASS(REC_MASS-DELTA1/2.)
         F2 = A192_TT_HAONLY_TTZ65_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.65D0 .AND. HYP_MASS.LE.70D0) THEN
         REFMH1 = 65D0
         REFMH2 = 70D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HAONLY_TTZ65_MASS(REC_MASS-DELTA1/2.)
         F2 = A192_TT_HAONLY_TTZ70_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.70D0 .AND. HYP_MASS.LE.75D0) THEN
         REFMH1 = 70D0
         REFMH2 = 75D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HAONLY_TTZ70_MASS(REC_MASS-DELTA1/2.)
         F2 = A192_TT_HAONLY_TTZ75_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.75D0 .AND. HYP_MASS.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HAONLY_TTZ75_MASS(REC_MASS-DELTA1/2.)
         F2 = A192_TT_HAONLY_TTZ80_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.80D0 .AND. HYP_MASS.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HAONLY_TTZ80_MASS(REC_MASS-DELTA1/2.)
         F2 = A192_TT_HAONLY_TTZ85_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.85D0 .AND. HYP_MASS.LE.90D0) THEN 
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HAONLY_TTZ85_MASS(REC_MASS-DELTA1/2.)
         F2 = A192_TT_HAONLY_TTZ90_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.90D0 .AND. HYP_MASS.LE.95D0) THEN 
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HAONLY_TTZ90_MASS(REC_MASS-DELTA1/2.)
         F2 = A192_TT_HAONLY_TTZ95_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.95D0 .AND. HYP_MASS.LE.100D0) THEN 
         REFMH1 = 95D0
         REFMH2 = 100D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HAONLY_TTZ95_MASS(REC_MASS-DELTA1/2.)
         F2 = A192_TT_HAONLY_TTZ100_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.100D0 .AND. HYP_MASS.LE.105D0) THEN 
         REFMH1 = 100D0
         REFMH2 = 105D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HAONLY_TTZ100_MASS(REC_MASS-DELTA1/2.)
         F2 = A192_TT_HAONLY_TTZ105_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.105D0 .AND. HYP_MASS.LE.107D0) THEN 
         REFMH1 = 105D0
         REFMH2 = 107D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HAONLY_TTZ105_MASS(REC_MASS-DELTA1/2.)
         F2 = A192_TT_HAONLY_TTZ107_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.107D0 .AND. HYP_MASS.LE.110D0) THEN 
         REFMH1 = 107D0
         REFMH2 = 110D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HAONLY_TTZ107_MASS(REC_MASS-DELTA1/2.)
         F2 = A192_TT_HAONLY_TTZ110_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.110D0 .AND. HYP_MASS.LE.115D0) THEN 
         REFMH1 = 110D0
         REFMH2 = 115D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HAONLY_TTZ110_MASS(REC_MASS-DELTA1/2.)
         F2 = A192_TT_HAONLY_TTZ115_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.115D0 .AND. HYP_MASS.LE.120D0) THEN 
         REFMH1 = 115D0
         REFMH2 = 120D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HAONLY_TTZ115_MASS(REC_MASS-DELTA1/2.)
         F2 = A192_TT_HAONLY_TTZ120_MASS(REC_MASS+DELTA2/2.)
      ELSE
         A192_TT_M_HAONLY_ONTTZ = 0.D0
         RETURN
      ENDIF

      A192_TT_M_HAONLY_ONTTZ = (DELTA2 * F1 + DELTA1 * F2)
     $     / (REFMH2 - REFMH1)
      IF (A192_TT_M_HAONLY_ONTTZ.LT.1.D-05) THEN
         A192_TT_M_HAONLY_ONTTZ = 1.D-05 
      ENDIF
      
      RETURN
      END

      DOUBLE PRECISION FUNCTION
     $     A192_TT_M_HZONLY_ONTTZ(REC_MASS, HYP_MASS)
      IMPLICIT NONE
      DOUBLE PRECISION REC_MASS, HYP_MASS
      DOUBLE PRECISION DELTA1, DELTA2, REFMH1, REFMH2, F1, F2
      DOUBLE PRECISION
     $     A192_TT_HZONLY_TTZ60_MASS, A192_TT_HZONLY_TTZ65_MASS,
     $     A192_TT_HZONLY_TTZ70_MASS, A192_TT_HZONLY_TTZ75_MASS,
     $     A192_TT_HZONLY_TTZ80_MASS, A192_TT_HZONLY_TTZ85_MASS,
     $     A192_TT_HZONLY_TTZ90_MASS, A192_TT_HZONLY_TTZ95_MASS,
     $     A192_TT_HZONLY_TTZ100_MASS, A192_TT_HZONLY_TTZ105_MASS,
     $     A192_TT_HZONLY_TTZ107_MASS, A192_TT_HZONLY_TTZ110_MASS,
     $     A192_TT_HZONLY_TTZ115_MASS, A192_TT_HZONLY_TTZ120_MASS
C 
C (No integration since shapes made with KEYS are by default 
C  normalized when created.)
C
      IF (HYP_MASS.GE.60D0 .AND. HYP_MASS.LE.65D0) THEN
         REFMH1 = 60D0
         REFMH2 = 65D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HZONLY_TTZ60_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_HZONLY_TTZ65_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.65D0 .AND. HYP_MASS.LE.70D0) THEN
         REFMH1 = 65D0
         REFMH2 = 70D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HZONLY_TTZ65_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_HZONLY_TTZ70_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.70D0 .AND. HYP_MASS.LE.75D0) THEN
         REFMH1 = 70D0
         REFMH2 = 75D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HZONLY_TTZ70_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_HZONLY_TTZ75_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.75D0 .AND. HYP_MASS.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HZONLY_TTZ75_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_HZONLY_TTZ80_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.80D0 .AND. HYP_MASS.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HZONLY_TTZ80_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_HZONLY_TTZ85_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.85D0 .AND. HYP_MASS.LE.90D0) THEN 
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HZONLY_TTZ85_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_HZONLY_TTZ90_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.90D0 .AND. HYP_MASS.LE.95D0) THEN 
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HZONLY_TTZ90_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_HZONLY_TTZ95_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.95D0 .AND. HYP_MASS.LE.100D0) THEN 
         REFMH1 = 95D0
         REFMH2 = 100D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HZONLY_TTZ95_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_HZONLY_TTZ100_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.100D0 .AND. HYP_MASS.LE.105D0) THEN 
         REFMH1 = 100D0
         REFMH2 = 105D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HZONLY_TTZ100_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_HZONLY_TTZ105_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.105D0 .AND. HYP_MASS.LE.107D0) THEN 
         REFMH1 = 105D0
         REFMH2 = 107D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HZONLY_TTZ105_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_HZONLY_TTZ107_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.107D0 .AND. HYP_MASS.LE.110D0) THEN 
         REFMH1 = 107D0
         REFMH2 = 110D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HZONLY_TTZ107_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_HZONLY_TTZ110_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.110D0 .AND. HYP_MASS.LE.115D0) THEN 
         REFMH1 = 110D0
         REFMH2 = 115D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HZONLY_TTZ110_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_HZONLY_TTZ115_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.115D0 .AND. HYP_MASS.LE.120D0) THEN 
         REFMH1 = 115D0
         REFMH2 = 120D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_HZONLY_TTZ115_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_HZONLY_TTZ120_MASS(REC_MASS+DELTA2)
      ELSE
         A192_TT_M_HZONLY_ONTTZ = 0.D0
         RETURN
      ENDIF

      A192_TT_M_HZONLY_ONTTZ = (DELTA2 * F1 + DELTA1 * F2)
     $     / (REFMH2 - REFMH1)
      IF (A192_TT_M_HZONLY_ONTTZ.LT.1.D-05) THEN
         A192_TT_M_HZONLY_ONTTZ = 1.D-05 
      ENDIF
      
      RETURN
      END

      DOUBLE PRECISION FUNCTION
     $     A192_TT_M_ASHA_ONTTZ(REC_MASS, HYP_MASS)
      IMPLICIT NONE
      DOUBLE PRECISION REC_MASS, HYP_MASS
      DOUBLE PRECISION DELTA1, DELTA2, REFMH1, REFMH2, F1, F2
      DOUBLE PRECISION
     $     A192_TT_ASHA_TTZ60_MASS, A192_TT_ASHA_TTZ65_MASS,
     $     A192_TT_ASHA_TTZ70_MASS, A192_TT_ASHA_TTZ75_MASS,
     $     A192_TT_ASHA_TTZ80_MASS, A192_TT_ASHA_TTZ85_MASS,
     $     A192_TT_ASHA_TTZ90_MASS, A192_TT_ASHA_TTZ95_MASS,
     $     A192_TT_ASHA_TTZ100_MASS, A192_TT_ASHA_TTZ105_MASS,
     $     A192_TT_ASHA_TTZ107_MASS, A192_TT_ASHA_TTZ110_MASS,
     $     A192_TT_ASHA_TTZ115_MASS, A192_TT_ASHA_TTZ120_MASS
C 
C (No integration since shapes made with KEYS are by default 
C  normalized when created.)
C
      IF (HYP_MASS.GE.60D0 .AND. HYP_MASS.LE.65D0) THEN
         REFMH1 = 60D0
         REFMH2 = 65D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHA_TTZ60_MASS(REC_MASS-DELTA1/2.)
         F2 = A192_TT_ASHA_TTZ65_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.65D0 .AND. HYP_MASS.LE.70D0) THEN
         REFMH1 = 65D0
         REFMH2 = 70D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHA_TTZ65_MASS(REC_MASS-DELTA1/2.)
         F2 = A192_TT_ASHA_TTZ70_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.70D0 .AND. HYP_MASS.LE.75D0) THEN
         REFMH1 = 70D0
         REFMH2 = 75D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHA_TTZ70_MASS(REC_MASS-DELTA1/2.)
         F2 = A192_TT_ASHA_TTZ75_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.75D0 .AND. HYP_MASS.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHA_TTZ75_MASS(REC_MASS-DELTA1/2.)
         F2 = A192_TT_ASHA_TTZ80_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.80D0 .AND. HYP_MASS.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHA_TTZ80_MASS(REC_MASS-DELTA1/2.)
         F2 = A192_TT_ASHA_TTZ85_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.85D0 .AND. HYP_MASS.LE.90D0) THEN 
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHA_TTZ85_MASS(REC_MASS-DELTA1/2.)
         F2 = A192_TT_ASHA_TTZ90_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.90D0 .AND. HYP_MASS.LE.95D0) THEN 
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHA_TTZ90_MASS(REC_MASS-DELTA1/2.)
         F2 = A192_TT_ASHA_TTZ95_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.95D0 .AND. HYP_MASS.LE.100D0) THEN 
         REFMH1 = 95D0
         REFMH2 = 100D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHA_TTZ95_MASS(REC_MASS-DELTA1/2.)
         F2 = A192_TT_ASHA_TTZ100_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.100D0 .AND. HYP_MASS.LE.105D0) THEN 
         REFMH1 = 100D0
         REFMH2 = 105D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHA_TTZ100_MASS(REC_MASS-DELTA1/2.)
         F2 = A192_TT_ASHA_TTZ105_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.105D0 .AND. HYP_MASS.LE.107D0) THEN 
         REFMH1 = 105D0
         REFMH2 = 107D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHA_TTZ105_MASS(REC_MASS-DELTA1/2.)
         F2 = A192_TT_ASHA_TTZ107_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.107D0 .AND. HYP_MASS.LE.110D0) THEN 
         REFMH1 = 107D0
         REFMH2 = 110D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHA_TTZ107_MASS(REC_MASS-DELTA1/2.)
         F2 = A192_TT_ASHA_TTZ110_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.110D0 .AND. HYP_MASS.LE.115D0) THEN 
         REFMH1 = 110D0
         REFMH2 = 115D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHA_TTZ110_MASS(REC_MASS-DELTA1/2.)
         F2 = A192_TT_ASHA_TTZ115_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.115D0 .AND. HYP_MASS.LE.120D0) THEN 
         REFMH1 = 115D0
         REFMH2 = 120D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHA_TTZ115_MASS(REC_MASS-DELTA1/2.)
         F2 = A192_TT_ASHA_TTZ120_MASS(REC_MASS+DELTA2/2.)
      ELSE
         A192_TT_M_ASHA_ONTTZ = 0.D0
         RETURN
      ENDIF

      A192_TT_M_ASHA_ONTTZ = (DELTA2 * F1 + DELTA1 * F2)
     $     / (REFMH2 - REFMH1)
      IF (A192_TT_M_ASHA_ONTTZ.LT.1.D-05) THEN
         A192_TT_M_ASHA_ONTTZ = 1.D-05 
      ENDIF
      
      RETURN
      END

      DOUBLE PRECISION FUNCTION
     $     A192_TT_M_ASHZ_ONTTZ(REC_MASS, HYP_MASS)
      IMPLICIT NONE
      DOUBLE PRECISION REC_MASS, HYP_MASS
      DOUBLE PRECISION DELTA1, DELTA2, REFMH1, REFMH2, F1, F2
      DOUBLE PRECISION
     $     A192_TT_ASHZ_TTZ60_MASS, A192_TT_ASHZ_TTZ65_MASS,
     $     A192_TT_ASHZ_TTZ70_MASS, A192_TT_ASHZ_TTZ75_MASS,
     $     A192_TT_ASHZ_TTZ80_MASS, A192_TT_ASHZ_TTZ85_MASS,
     $     A192_TT_ASHZ_TTZ90_MASS, A192_TT_ASHZ_TTZ95_MASS,
     $     A192_TT_ASHZ_TTZ100_MASS, A192_TT_ASHZ_TTZ105_MASS,
     $     A192_TT_ASHZ_TTZ107_MASS, A192_TT_ASHZ_TTZ110_MASS,
     $     A192_TT_ASHZ_TTZ115_MASS, A192_TT_ASHZ_TTZ120_MASS
C 
C (No integration since shapes made with KEYS are by default 
C  normalized when created.)
C
      IF (HYP_MASS.GE.60D0 .AND. HYP_MASS.LE.65D0) THEN
         REFMH1 = 60D0
         REFMH2 = 65D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHZ_TTZ60_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_ASHZ_TTZ65_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.65D0 .AND. HYP_MASS.LE.70D0) THEN
         REFMH1 = 65D0
         REFMH2 = 70D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHZ_TTZ65_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_ASHZ_TTZ70_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.70D0 .AND. HYP_MASS.LE.75D0) THEN
         REFMH1 = 70D0
         REFMH2 = 75D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHZ_TTZ70_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_ASHZ_TTZ75_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.75D0 .AND. HYP_MASS.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHZ_TTZ75_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_ASHZ_TTZ80_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.80D0 .AND. HYP_MASS.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHZ_TTZ80_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_ASHZ_TTZ85_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.85D0 .AND. HYP_MASS.LE.90D0) THEN 
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHZ_TTZ85_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_ASHZ_TTZ90_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.90D0 .AND. HYP_MASS.LE.95D0) THEN 
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHZ_TTZ90_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_ASHZ_TTZ95_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.95D0 .AND. HYP_MASS.LE.100D0) THEN 
         REFMH1 = 95D0
         REFMH2 = 100D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHZ_TTZ95_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_ASHZ_TTZ100_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.100D0 .AND. HYP_MASS.LE.105D0) THEN 
         REFMH1 = 100D0
         REFMH2 = 105D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHZ_TTZ100_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_ASHZ_TTZ105_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.105D0 .AND. HYP_MASS.LE.107D0) THEN 
         REFMH1 = 105D0
         REFMH2 = 107D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHZ_TTZ105_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_ASHZ_TTZ107_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.107D0 .AND. HYP_MASS.LE.110D0) THEN 
         REFMH1 = 107D0
         REFMH2 = 110D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHZ_TTZ107_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_ASHZ_TTZ110_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.110D0 .AND. HYP_MASS.LE.115D0) THEN 
         REFMH1 = 110D0
         REFMH2 = 115D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHZ_TTZ110_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_ASHZ_TTZ115_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.115D0 .AND. HYP_MASS.LE.120D0) THEN 
         REFMH1 = 115D0
         REFMH2 = 120D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A192_TT_ASHZ_TTZ115_MASS(REC_MASS-DELTA1)
         F2 = A192_TT_ASHZ_TTZ120_MASS(REC_MASS+DELTA2)
      ELSE
         A192_TT_M_ASHZ_ONTTZ = 0.D0
         RETURN
      ENDIF

      A192_TT_M_ASHZ_ONTTZ = (DELTA2 * F1 + DELTA1 * F2)
     $     / (REFMH2 - REFMH1)
      IF (A192_TT_M_ASHZ_ONTTZ.LT.1.D-05) THEN
         A192_TT_M_ASHZ_ONTTZ = 1.D-05 
      ENDIF
      
      RETURN
      END

C 
C---- New file --- 
C 
      DOUBLE PRECISION FUNCTION A196_TT_SIG_MASS(REC_MASS,
     $     HYP_MASS, IANA, ISIG)
      IMPLICIT NONE
      DOUBLE PRECISION REC_MASS, HYP_MASS
      INTEGER IANA, ISIG
      DOUBLE PRECISION A196_TT_M_HAONLY_ONHTT, A196_TT_M_HZONLY_ONHTT,
     $     A196_TT_M_ASHA_ONHTT, A196_TT_M_ASHZ_ONHTT
      DOUBLE PRECISION A196_TT_M_HAONLY_ONHA, A196_TT_M_HZONLY_ONHA,
     $     A196_TT_M_ASHA_ONHA, A196_TT_M_ASHZ_ONHA
      DOUBLE PRECISION A196_TT_M_HAONLY_ONTTZ, A196_TT_M_HZONLY_ONTTZ,
     $     A196_TT_M_ASHA_ONTTZ, A196_TT_M_ASHZ_ONTTZ

C REC_MASS is the reconstructed mass 
C MASS_HYP is the Higgs mass hypothesis
C IANA defines the analysis branch
C  This index: 1=hAonly, 2=hZonly, 3=overlap (as hA), 4=overlap (as hZ)
C ISIG gives the signal 
C     1 to 4 =Htt
C     5      =ttZ,
C     6 to 9 =hA->ttX

      IF (ISIG.GE.1 .AND. ISIG.LE.4) THEN
         IF (IANA.EQ.1) THEN
            A196_TT_SIG_MASS = A196_TT_M_HAONLY_ONHTT(REC_MASS,HYP_MASS)
         ELSE IF (IANA.EQ.2) THEN
            A196_TT_SIG_MASS = A196_TT_M_HZONLY_ONHTT(REC_MASS,HYP_MASS)
         ELSE IF (IANA.EQ.3) THEN
            A196_TT_SIG_MASS = A196_TT_M_ASHA_ONHTT(REC_MASS,HYP_MASS)
         ELSE IF (IANA.EQ.4) THEN
            A196_TT_SIG_MASS = A196_TT_M_ASHZ_ONHTT(REC_MASS,HYP_MASS)
         ENDIF
      ELSE IF (ISIG.EQ.5) THEN
         IF (IANA.EQ.1) THEN
            A196_TT_SIG_MASS = A196_TT_M_HAONLY_ONTTZ(REC_MASS,HYP_MASS)
         ELSE IF (IANA.EQ.2) THEN
            A196_TT_SIG_MASS = A196_TT_M_HZONLY_ONTTZ(REC_MASS,HYP_MASS)
         ELSE IF (IANA.EQ.3) THEN
            A196_TT_SIG_MASS = A196_TT_M_ASHA_ONTTZ(REC_MASS,HYP_MASS)
         ELSE IF (IANA.EQ.4) THEN
            A196_TT_SIG_MASS = A196_TT_M_ASHZ_ONTTZ(REC_MASS,HYP_MASS)
         ENDIF
      ELSE IF (ISIG.GE.6 .AND. ISIG.LE.9) THEN
         IF (IANA.EQ.1) THEN
            A196_TT_SIG_MASS = A196_TT_M_HAONLY_ONHA(REC_MASS,HYP_MASS)
         ELSE IF (IANA.EQ.2) THEN
            A196_TT_SIG_MASS = A196_TT_M_HZONLY_ONHA(REC_MASS,HYP_MASS)
         ELSE IF (IANA.EQ.3) THEN
            A196_TT_SIG_MASS = A196_TT_M_ASHA_ONHA(REC_MASS,HYP_MASS)
         ELSE IF (IANA.EQ.4) THEN
            A196_TT_SIG_MASS = A196_TT_M_ASHZ_ONHA(REC_MASS,HYP_MASS)
         ENDIF
      ENDIF
      RETURN
      END


      DOUBLE PRECISION FUNCTION
     $     A196_TT_M_HAONLY_ONHA(REC_MASS, HYP_MASS)
      IMPLICIT NONE
      DOUBLE PRECISION REC_MASS, HYP_MASS
      DOUBLE PRECISION DELTA1, DELTA2, REFMH1, REFMH2, F1, F2
      DOUBLE PRECISION
     $     A196_TT_HAONLY_HATT60_MASS, A196_TT_HAONLY_HATT65_MASS,
     $     A196_TT_HAONLY_HATT70_MASS, A196_TT_HAONLY_HATT75_MASS,
     $     A196_TT_HAONLY_HATT80_MASS, A196_TT_HAONLY_HATT85_MASS,
     $     A196_TT_HAONLY_HATT90_MASS, A196_TT_HAONLY_HATT95_MASS,
     $     A196_TT_HAONLY_HATT100_MASS, A196_TT_HAONLY_HATT105_MASS,
     $     A196_TT_HAONLY_HATT107_MASS, A196_TT_HAONLY_HATT110_MASS,
     $     A196_TT_HAONLY_HATT115_MASS, A196_TT_HAONLY_HATT120_MASS
C 
C (No integration since shapes made with KEYS are by default 
C  normalized when created.)
C
      IF (HYP_MASS.GE.60D0 .AND. HYP_MASS.LE.65D0) THEN
         REFMH1 = 60D0
         REFMH2 = 65D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HAONLY_HATT60_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_HAONLY_HATT65_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.65D0 .AND. HYP_MASS.LE.70D0) THEN
         REFMH1 = 65D0
         REFMH2 = 70D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HAONLY_HATT65_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_HAONLY_HATT70_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.70D0 .AND. HYP_MASS.LE.75D0) THEN
         REFMH1 = 70D0
         REFMH2 = 75D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HAONLY_HATT70_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_HAONLY_HATT75_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.75D0 .AND. HYP_MASS.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HAONLY_HATT75_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_HAONLY_HATT80_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.80D0 .AND. HYP_MASS.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HAONLY_HATT80_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_HAONLY_HATT85_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.85D0 .AND. HYP_MASS.LE.90D0) THEN 
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HAONLY_HATT85_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_HAONLY_HATT90_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.90D0 .AND. HYP_MASS.LE.95D0) THEN 
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HAONLY_HATT90_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_HAONLY_HATT95_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.95D0 .AND. HYP_MASS.LE.100D0) THEN 
         REFMH1 = 95D0
         REFMH2 = 100D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HAONLY_HATT95_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_HAONLY_HATT100_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.100D0 .AND. HYP_MASS.LE.105D0) THEN 
         REFMH1 = 100D0
         REFMH2 = 105D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HAONLY_HATT100_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_HAONLY_HATT105_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.105D0 .AND. HYP_MASS.LE.107D0) THEN 
         REFMH1 = 105D0
         REFMH2 = 107D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HAONLY_HATT105_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_HAONLY_HATT107_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.107D0 .AND. HYP_MASS.LE.110D0) THEN 
         REFMH1 = 107D0
         REFMH2 = 110D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HAONLY_HATT107_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_HAONLY_HATT110_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.110D0 .AND. HYP_MASS.LE.115D0) THEN 
         REFMH1 = 110D0
         REFMH2 = 115D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HAONLY_HATT110_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_HAONLY_HATT115_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.115D0 .AND. HYP_MASS.LE.120D0) THEN 
         REFMH1 = 115D0
         REFMH2 = 120D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HAONLY_HATT115_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_HAONLY_HATT120_MASS(REC_MASS+DELTA2)
      ELSE
         A196_TT_M_HAONLY_ONHA = 0.D0
         RETURN
      ENDIF

      A196_TT_M_HAONLY_ONHA = (DELTA2 * F1 + DELTA1 * F2)
     $     / (REFMH2 - REFMH1)
      IF (A196_TT_M_HAONLY_ONHA.LT.1.D-05) THEN
         A196_TT_M_HAONLY_ONHA = 1.D-05 
      ENDIF
      
      RETURN
      END

      DOUBLE PRECISION FUNCTION
     $     A196_TT_M_HZONLY_ONHA(REC_MASS, HYP_MASS)
      IMPLICIT NONE
      DOUBLE PRECISION REC_MASS, HYP_MASS
      DOUBLE PRECISION DELTA1, DELTA2, REFMH1, REFMH2, F1, F2
      DOUBLE PRECISION
     $     A196_TT_HZONLY_HATT60_MASS, A196_TT_HZONLY_HATT65_MASS,
     $     A196_TT_HZONLY_HATT70_MASS, A196_TT_HZONLY_HATT75_MASS,
     $     A196_TT_HZONLY_HATT80_MASS, A196_TT_HZONLY_HATT85_MASS,
     $     A196_TT_HZONLY_HATT90_MASS, A196_TT_HZONLY_HATT95_MASS,
     $     A196_TT_HZONLY_HATT100_MASS, A196_TT_HZONLY_HATT105_MASS,
     $     A196_TT_HZONLY_HATT107_MASS, A196_TT_HZONLY_HATT110_MASS,
     $     A196_TT_HZONLY_HATT115_MASS, A196_TT_HZONLY_HATT120_MASS
C 
C (No integration since shapes made with KEYS are by default 
C  normalized when created.)
C
      IF (HYP_MASS.GE.60D0 .AND. HYP_MASS.LE.65D0) THEN
         REFMH1 = 60D0
         REFMH2 = 65D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HZONLY_HATT60_MASS(REC_MASS-DELTA1*2.)
         F2 = A196_TT_HZONLY_HATT65_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.65D0 .AND. HYP_MASS.LE.70D0) THEN
         REFMH1 = 65D0
         REFMH2 = 70D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HZONLY_HATT65_MASS(REC_MASS-DELTA1*2.)
         F2 = A196_TT_HZONLY_HATT70_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.70D0 .AND. HYP_MASS.LE.75D0) THEN
         REFMH1 = 70D0
         REFMH2 = 75D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HZONLY_HATT70_MASS(REC_MASS-DELTA1*2.)
         F2 = A196_TT_HZONLY_HATT75_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.75D0 .AND. HYP_MASS.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HZONLY_HATT75_MASS(REC_MASS-DELTA1*2.)
         F2 = A196_TT_HZONLY_HATT80_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.80D0 .AND. HYP_MASS.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HZONLY_HATT80_MASS(REC_MASS-DELTA1*2.)
         F2 = A196_TT_HZONLY_HATT85_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.85D0 .AND. HYP_MASS.LE.90D0) THEN 
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HZONLY_HATT85_MASS(REC_MASS-DELTA1*2.)
         F2 = A196_TT_HZONLY_HATT90_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.90D0 .AND. HYP_MASS.LE.95D0) THEN 
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HZONLY_HATT90_MASS(REC_MASS-DELTA1*2.)
         F2 = A196_TT_HZONLY_HATT95_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.95D0 .AND. HYP_MASS.LE.100D0) THEN 
         REFMH1 = 95D0
         REFMH2 = 100D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HZONLY_HATT95_MASS(REC_MASS-DELTA1*2.)
         F2 = A196_TT_HZONLY_HATT100_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.100D0 .AND. HYP_MASS.LE.105D0) THEN 
         REFMH1 = 100D0
         REFMH2 = 105D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HZONLY_HATT100_MASS(REC_MASS-DELTA1*2.)
         F2 = A196_TT_HZONLY_HATT105_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.105D0 .AND. HYP_MASS.LE.107D0) THEN 
         REFMH1 = 105D0
         REFMH2 = 107D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HZONLY_HATT105_MASS(REC_MASS-DELTA1*2.)
         F2 = A196_TT_HZONLY_HATT107_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.107D0 .AND. HYP_MASS.LE.110D0) THEN 
         REFMH1 = 107D0
         REFMH2 = 110D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HZONLY_HATT107_MASS(REC_MASS-DELTA1*2.)
         F2 = A196_TT_HZONLY_HATT110_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.110D0 .AND. HYP_MASS.LE.115D0) THEN 
         REFMH1 = 110D0
         REFMH2 = 115D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HZONLY_HATT110_MASS(REC_MASS-DELTA1*2.)
         F2 = A196_TT_HZONLY_HATT115_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.115D0 .AND. HYP_MASS.LE.120D0) THEN 
         REFMH1 = 115D0
         REFMH2 = 120D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HZONLY_HATT115_MASS(REC_MASS-DELTA1*2.)
         F2 = A196_TT_HZONLY_HATT120_MASS(REC_MASS+DELTA2*2.)
      ELSE
         A196_TT_M_HZONLY_ONHA = 0.D0
         RETURN
      ENDIF

      A196_TT_M_HZONLY_ONHA = (DELTA2 * F1 + DELTA1 * F2)
     $     / (REFMH2 - REFMH1)
      IF (A196_TT_M_HZONLY_ONHA.LT.1.D-05) THEN
         A196_TT_M_HZONLY_ONHA = 1.D-05 
      ENDIF
      
      RETURN
      END

      DOUBLE PRECISION FUNCTION
     $     A196_TT_M_ASHA_ONHA(REC_MASS, HYP_MASS)
      IMPLICIT NONE
      DOUBLE PRECISION REC_MASS, HYP_MASS
      DOUBLE PRECISION DELTA1, DELTA2, REFMH1, REFMH2, F1, F2
      DOUBLE PRECISION
     $     A196_TT_ASHA_HATT60_MASS, A196_TT_ASHA_HATT65_MASS,
     $     A196_TT_ASHA_HATT70_MASS, A196_TT_ASHA_HATT75_MASS,
     $     A196_TT_ASHA_HATT80_MASS, A196_TT_ASHA_HATT85_MASS,
     $     A196_TT_ASHA_HATT90_MASS, A196_TT_ASHA_HATT95_MASS,
     $     A196_TT_ASHA_HATT100_MASS, A196_TT_ASHA_HATT105_MASS,
     $     A196_TT_ASHA_HATT107_MASS, A196_TT_ASHA_HATT110_MASS,
     $     A196_TT_ASHA_HATT115_MASS, A196_TT_ASHA_HATT120_MASS
C 
C (No integration since shapes made with KEYS are by default 
C  normalized when created.)
C
      IF (HYP_MASS.GE.60D0 .AND. HYP_MASS.LE.65D0) THEN
         REFMH1 = 60D0
         REFMH2 = 65D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHA_HATT60_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_ASHA_HATT65_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.65D0 .AND. HYP_MASS.LE.70D0) THEN
         REFMH1 = 65D0
         REFMH2 = 70D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHA_HATT65_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_ASHA_HATT70_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.70D0 .AND. HYP_MASS.LE.75D0) THEN
         REFMH1 = 70D0
         REFMH2 = 75D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHA_HATT70_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_ASHA_HATT75_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.75D0 .AND. HYP_MASS.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHA_HATT75_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_ASHA_HATT80_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.80D0 .AND. HYP_MASS.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHA_HATT80_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_ASHA_HATT85_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.85D0 .AND. HYP_MASS.LE.90D0) THEN 
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHA_HATT85_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_ASHA_HATT90_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.90D0 .AND. HYP_MASS.LE.95D0) THEN 
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHA_HATT90_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_ASHA_HATT95_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.95D0 .AND. HYP_MASS.LE.100D0) THEN 
         REFMH1 = 95D0
         REFMH2 = 100D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHA_HATT95_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_ASHA_HATT100_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.100D0 .AND. HYP_MASS.LE.105D0) THEN 
         REFMH1 = 100D0
         REFMH2 = 105D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHA_HATT100_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_ASHA_HATT105_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.105D0 .AND. HYP_MASS.LE.107D0) THEN 
         REFMH1 = 105D0
         REFMH2 = 107D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHA_HATT105_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_ASHA_HATT107_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.107D0 .AND. HYP_MASS.LE.110D0) THEN 
         REFMH1 = 107D0
         REFMH2 = 110D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHA_HATT107_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_ASHA_HATT110_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.110D0 .AND. HYP_MASS.LE.115D0) THEN 
         REFMH1 = 110D0
         REFMH2 = 115D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHA_HATT110_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_ASHA_HATT115_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.115D0 .AND. HYP_MASS.LE.120D0) THEN 
         REFMH1 = 115D0
         REFMH2 = 120D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHA_HATT115_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_ASHA_HATT120_MASS(REC_MASS+DELTA2)
      ELSE
         A196_TT_M_ASHA_ONHA = 0.D0
         RETURN
      ENDIF

      A196_TT_M_ASHA_ONHA = (DELTA2 * F1 + DELTA1 * F2)
     $     / (REFMH2 - REFMH1)
      IF (A196_TT_M_ASHA_ONHA.LT.1.D-05) THEN
         A196_TT_M_ASHA_ONHA = 1.D-05 
      ENDIF
      
      RETURN
      END

      DOUBLE PRECISION FUNCTION
     $     A196_TT_M_ASHZ_ONHA(REC_MASS, HYP_MASS)
      IMPLICIT NONE
      DOUBLE PRECISION REC_MASS, HYP_MASS
      DOUBLE PRECISION DELTA1, DELTA2, REFMH1, REFMH2, F1, F2
      DOUBLE PRECISION
     $     A196_TT_ASHZ_HATT60_MASS, A196_TT_ASHZ_HATT65_MASS,
     $     A196_TT_ASHZ_HATT70_MASS, A196_TT_ASHZ_HATT75_MASS,
     $     A196_TT_ASHZ_HATT80_MASS, A196_TT_ASHZ_HATT85_MASS,
     $     A196_TT_ASHZ_HATT90_MASS, A196_TT_ASHZ_HATT95_MASS,
     $     A196_TT_ASHZ_HATT100_MASS, A196_TT_ASHZ_HATT105_MASS,
     $     A196_TT_ASHZ_HATT107_MASS, A196_TT_ASHZ_HATT110_MASS,
     $     A196_TT_ASHZ_HATT115_MASS, A196_TT_ASHZ_HATT120_MASS
C 
C (No integration since shapes made with KEYS are by default 
C  normalized when created.)
C
      IF (HYP_MASS.GE.60D0 .AND. HYP_MASS.LE.65D0) THEN
         REFMH1 = 60D0
         REFMH2 = 65D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHZ_HATT60_MASS(REC_MASS-DELTA1*2.)
         F2 = A196_TT_ASHZ_HATT65_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.65D0 .AND. HYP_MASS.LE.70D0) THEN
         REFMH1 = 65D0
         REFMH2 = 70D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHZ_HATT65_MASS(REC_MASS-DELTA1*2.)
         F2 = A196_TT_ASHZ_HATT70_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.70D0 .AND. HYP_MASS.LE.75D0) THEN
         REFMH1 = 70D0
         REFMH2 = 75D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHZ_HATT70_MASS(REC_MASS-DELTA1*2.)
         F2 = A196_TT_ASHZ_HATT75_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.75D0 .AND. HYP_MASS.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHZ_HATT75_MASS(REC_MASS-DELTA1*2.)
         F2 = A196_TT_ASHZ_HATT80_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.80D0 .AND. HYP_MASS.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHZ_HATT80_MASS(REC_MASS-DELTA1*2.)
         F2 = A196_TT_ASHZ_HATT85_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.85D0 .AND. HYP_MASS.LE.90D0) THEN 
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHZ_HATT85_MASS(REC_MASS-DELTA1*2.)
         F2 = A196_TT_ASHZ_HATT90_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.90D0 .AND. HYP_MASS.LE.95D0) THEN 
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHZ_HATT90_MASS(REC_MASS-DELTA1*2.)
         F2 = A196_TT_ASHZ_HATT95_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.95D0 .AND. HYP_MASS.LE.100D0) THEN 
         REFMH1 = 95D0
         REFMH2 = 100D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHZ_HATT95_MASS(REC_MASS-DELTA1*2.)
         F2 = A196_TT_ASHZ_HATT100_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.100D0 .AND. HYP_MASS.LE.105D0) THEN 
         REFMH1 = 100D0
         REFMH2 = 105D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHZ_HATT100_MASS(REC_MASS-DELTA1*2.)
         F2 = A196_TT_ASHZ_HATT105_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.105D0 .AND. HYP_MASS.LE.107D0) THEN 
         REFMH1 = 105D0
         REFMH2 = 107D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHZ_HATT105_MASS(REC_MASS-DELTA1*2.)
         F2 = A196_TT_ASHZ_HATT107_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.107D0 .AND. HYP_MASS.LE.110D0) THEN 
         REFMH1 = 107D0
         REFMH2 = 110D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHZ_HATT107_MASS(REC_MASS-DELTA1*2.)
         F2 = A196_TT_ASHZ_HATT110_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.110D0 .AND. HYP_MASS.LE.115D0) THEN 
         REFMH1 = 110D0
         REFMH2 = 115D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHZ_HATT110_MASS(REC_MASS-DELTA1*2.)
         F2 = A196_TT_ASHZ_HATT115_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.115D0 .AND. HYP_MASS.LE.120D0) THEN 
         REFMH1 = 115D0
         REFMH2 = 120D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHZ_HATT115_MASS(REC_MASS-DELTA1*2.)
         F2 = A196_TT_ASHZ_HATT120_MASS(REC_MASS+DELTA2*2.)
      ELSE
         A196_TT_M_ASHZ_ONHA = 0.D0
         RETURN
      ENDIF

      A196_TT_M_ASHZ_ONHA = (DELTA2 * F1 + DELTA1 * F2)
     $     / (REFMH2 - REFMH1)
      IF (A196_TT_M_ASHZ_ONHA.LT.1.D-05) THEN
         A196_TT_M_ASHZ_ONHA = 1.D-05 
      ENDIF
      
      RETURN
      END

      DOUBLE PRECISION FUNCTION
     $     A196_TT_M_HAONLY_ONHTT(REC_MASS, HYP_MASS)
      IMPLICIT NONE
      DOUBLE PRECISION REC_MASS, HYP_MASS
      DOUBLE PRECISION DELTA1, DELTA2, REFMH1, REFMH2, F1, F2
      DOUBLE PRECISION
     $     A196_TT_HAONLY_HTT60_MASS, A196_TT_HAONLY_HTT65_MASS,
     $     A196_TT_HAONLY_HTT70_MASS, A196_TT_HAONLY_HTT75_MASS,
     $     A196_TT_HAONLY_HTT80_MASS, A196_TT_HAONLY_HTT85_MASS,
     $     A196_TT_HAONLY_HTT90_MASS, A196_TT_HAONLY_HTT95_MASS,
     $     A196_TT_HAONLY_HTT100_MASS, A196_TT_HAONLY_HTT105_MASS,
     $     A196_TT_HAONLY_HTT107_MASS, A196_TT_HAONLY_HTT110_MASS,
     $     A196_TT_HAONLY_HTT115_MASS, A196_TT_HAONLY_HTT120_MASS
C 
C (No integration since shapes made with KEYS are by default 
C  normalized when created.)
C
      IF (HYP_MASS.GE.60D0 .AND. HYP_MASS.LE.65D0) THEN
         REFMH1 = 60D0
         REFMH2 = 65D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HAONLY_HTT60_MASS(REC_MASS-DELTA1/2.)
         F2 = A196_TT_HAONLY_HTT65_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.65D0 .AND. HYP_MASS.LE.70D0) THEN
         REFMH1 = 65D0
         REFMH2 = 70D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HAONLY_HTT65_MASS(REC_MASS-DELTA1/2.)
         F2 = A196_TT_HAONLY_HTT70_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.70D0 .AND. HYP_MASS.LE.75D0) THEN
         REFMH1 = 70D0
         REFMH2 = 75D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HAONLY_HTT70_MASS(REC_MASS-DELTA1/2.)
         F2 = A196_TT_HAONLY_HTT75_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.75D0 .AND. HYP_MASS.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HAONLY_HTT75_MASS(REC_MASS-DELTA1/2.)
         F2 = A196_TT_HAONLY_HTT80_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.80D0 .AND. HYP_MASS.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HAONLY_HTT80_MASS(REC_MASS-DELTA1/2.)
         F2 = A196_TT_HAONLY_HTT85_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.85D0 .AND. HYP_MASS.LE.90D0) THEN 
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HAONLY_HTT85_MASS(REC_MASS-DELTA1/2.)
         F2 = A196_TT_HAONLY_HTT90_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.90D0 .AND. HYP_MASS.LE.95D0) THEN 
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HAONLY_HTT90_MASS(REC_MASS-DELTA1/2.)
         F2 = A196_TT_HAONLY_HTT95_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.95D0 .AND. HYP_MASS.LE.100D0) THEN 
         REFMH1 = 95D0
         REFMH2 = 100D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HAONLY_HTT95_MASS(REC_MASS-DELTA1/2.)
         F2 = A196_TT_HAONLY_HTT100_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.100D0 .AND. HYP_MASS.LE.105D0) THEN 
         REFMH1 = 100D0
         REFMH2 = 105D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HAONLY_HTT100_MASS(REC_MASS-DELTA1/2.)
         F2 = A196_TT_HAONLY_HTT105_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.105D0 .AND. HYP_MASS.LE.107D0) THEN 
         REFMH1 = 105D0
         REFMH2 = 107D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HAONLY_HTT105_MASS(REC_MASS-DELTA1/2.)
         F2 = A196_TT_HAONLY_HTT107_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.107D0 .AND. HYP_MASS.LE.110D0) THEN 
         REFMH1 = 107D0
         REFMH2 = 110D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HAONLY_HTT107_MASS(REC_MASS-DELTA1/2.)
         F2 = A196_TT_HAONLY_HTT110_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.110D0 .AND. HYP_MASS.LE.115D0) THEN 
         REFMH1 = 110D0
         REFMH2 = 115D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HAONLY_HTT110_MASS(REC_MASS-DELTA1/2.)
         F2 = A196_TT_HAONLY_HTT115_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.115D0 .AND. HYP_MASS.LE.120D0) THEN 
         REFMH1 = 115D0
         REFMH2 = 120D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HAONLY_HTT115_MASS(REC_MASS-DELTA1/2.)
         F2 = A196_TT_HAONLY_HTT120_MASS(REC_MASS+DELTA2/2.)
      ELSE
         A196_TT_M_HAONLY_ONHTT = 0.D0
         RETURN
      ENDIF

      A196_TT_M_HAONLY_ONHTT = (DELTA2 * F1 + DELTA1 * F2)
     $     / (REFMH2 - REFMH1)
      IF (A196_TT_M_HAONLY_ONHTT.LT.1.D-05) THEN
         A196_TT_M_HAONLY_ONHTT = 1.D-05 
      ENDIF
      
      RETURN
      END

      DOUBLE PRECISION FUNCTION
     $     A196_TT_M_HZONLY_ONHTT(REC_MASS, HYP_MASS)
      IMPLICIT NONE
      DOUBLE PRECISION REC_MASS, HYP_MASS
      DOUBLE PRECISION DELTA1, DELTA2, REFMH1, REFMH2, F1, F2
      DOUBLE PRECISION
     $     A196_TT_HZONLY_HTT60_MASS, A196_TT_HZONLY_HTT65_MASS,
     $     A196_TT_HZONLY_HTT70_MASS, A196_TT_HZONLY_HTT75_MASS,
     $     A196_TT_HZONLY_HTT80_MASS, A196_TT_HZONLY_HTT85_MASS,
     $     A196_TT_HZONLY_HTT90_MASS, A196_TT_HZONLY_HTT95_MASS,
     $     A196_TT_HZONLY_HTT100_MASS, A196_TT_HZONLY_HTT105_MASS,
     $     A196_TT_HZONLY_HTT107_MASS, A196_TT_HZONLY_HTT110_MASS,
     $     A196_TT_HZONLY_HTT115_MASS, A196_TT_HZONLY_HTT120_MASS
C 
C (No integration since shapes made with KEYS are by default 
C  normalized when created.)
C
      IF (HYP_MASS.GE.60D0 .AND. HYP_MASS.LE.65D0) THEN
         REFMH1 = 60D0
         REFMH2 = 65D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HZONLY_HTT60_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_HZONLY_HTT65_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.65D0 .AND. HYP_MASS.LE.70D0) THEN
         REFMH1 = 65D0
         REFMH2 = 70D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HZONLY_HTT65_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_HZONLY_HTT70_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.70D0 .AND. HYP_MASS.LE.75D0) THEN
         REFMH1 = 70D0
         REFMH2 = 75D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HZONLY_HTT70_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_HZONLY_HTT75_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.75D0 .AND. HYP_MASS.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HZONLY_HTT75_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_HZONLY_HTT80_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.80D0 .AND. HYP_MASS.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HZONLY_HTT80_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_HZONLY_HTT85_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.85D0 .AND. HYP_MASS.LE.90D0) THEN 
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HZONLY_HTT85_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_HZONLY_HTT90_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.90D0 .AND. HYP_MASS.LE.95D0) THEN 
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HZONLY_HTT90_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_HZONLY_HTT95_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.95D0 .AND. HYP_MASS.LE.100D0) THEN 
         REFMH1 = 95D0
         REFMH2 = 100D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HZONLY_HTT95_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_HZONLY_HTT100_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.100D0 .AND. HYP_MASS.LE.105D0) THEN 
         REFMH1 = 100D0
         REFMH2 = 105D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HZONLY_HTT100_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_HZONLY_HTT105_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.105D0 .AND. HYP_MASS.LE.107D0) THEN 
         REFMH1 = 105D0
         REFMH2 = 107D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HZONLY_HTT105_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_HZONLY_HTT107_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.107D0 .AND. HYP_MASS.LE.110D0) THEN 
         REFMH1 = 107D0
         REFMH2 = 110D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HZONLY_HTT107_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_HZONLY_HTT110_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.110D0 .AND. HYP_MASS.LE.115D0) THEN 
         REFMH1 = 110D0
         REFMH2 = 115D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HZONLY_HTT110_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_HZONLY_HTT115_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.115D0 .AND. HYP_MASS.LE.120D0) THEN 
         REFMH1 = 115D0
         REFMH2 = 120D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HZONLY_HTT115_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_HZONLY_HTT120_MASS(REC_MASS+DELTA2)
      ELSE
         A196_TT_M_HZONLY_ONHTT = 0.D0
         RETURN
      ENDIF

      A196_TT_M_HZONLY_ONHTT = (DELTA2 * F1 + DELTA1 * F2)
     $     / (REFMH2 - REFMH1)
      IF (A196_TT_M_HZONLY_ONHTT.LT.1.D-05) THEN
         A196_TT_M_HZONLY_ONHTT = 1.D-05 
      ENDIF
      
      RETURN
      END

      DOUBLE PRECISION FUNCTION
     $     A196_TT_M_ASHA_ONHTT(REC_MASS, HYP_MASS)
      IMPLICIT NONE
      DOUBLE PRECISION REC_MASS, HYP_MASS
      DOUBLE PRECISION DELTA1, DELTA2, REFMH1, REFMH2, F1, F2
      DOUBLE PRECISION
     $     A196_TT_ASHA_HTT60_MASS, A196_TT_ASHA_HTT65_MASS,
     $     A196_TT_ASHA_HTT70_MASS, A196_TT_ASHA_HTT75_MASS,
     $     A196_TT_ASHA_HTT80_MASS, A196_TT_ASHA_HTT85_MASS,
     $     A196_TT_ASHA_HTT90_MASS, A196_TT_ASHA_HTT95_MASS,
     $     A196_TT_ASHA_HTT100_MASS, A196_TT_ASHA_HTT105_MASS,
     $     A196_TT_ASHA_HTT107_MASS, A196_TT_ASHA_HTT110_MASS,
     $     A196_TT_ASHA_HTT115_MASS, A196_TT_ASHA_HTT120_MASS
C 
C (No integration since shapes made with KEYS are by default 
C  normalized when created.)
C
      IF (HYP_MASS.GE.60D0 .AND. HYP_MASS.LE.65D0) THEN
         REFMH1 = 60D0
         REFMH2 = 65D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHA_HTT60_MASS(REC_MASS-DELTA1/2.)
         F2 = A196_TT_ASHA_HTT65_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.65D0 .AND. HYP_MASS.LE.70D0) THEN
         REFMH1 = 65D0
         REFMH2 = 70D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHA_HTT65_MASS(REC_MASS-DELTA1/2.)
         F2 = A196_TT_ASHA_HTT70_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.70D0 .AND. HYP_MASS.LE.75D0) THEN
         REFMH1 = 70D0
         REFMH2 = 75D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHA_HTT70_MASS(REC_MASS-DELTA1/2.)
         F2 = A196_TT_ASHA_HTT75_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.75D0 .AND. HYP_MASS.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHA_HTT75_MASS(REC_MASS-DELTA1/2.)
         F2 = A196_TT_ASHA_HTT80_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.80D0 .AND. HYP_MASS.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHA_HTT80_MASS(REC_MASS-DELTA1/2.)
         F2 = A196_TT_ASHA_HTT85_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.85D0 .AND. HYP_MASS.LE.90D0) THEN 
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHA_HTT85_MASS(REC_MASS-DELTA1/2.)
         F2 = A196_TT_ASHA_HTT90_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.90D0 .AND. HYP_MASS.LE.95D0) THEN 
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHA_HTT90_MASS(REC_MASS-DELTA1/2.)
         F2 = A196_TT_ASHA_HTT95_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.95D0 .AND. HYP_MASS.LE.100D0) THEN 
         REFMH1 = 95D0
         REFMH2 = 100D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHA_HTT95_MASS(REC_MASS-DELTA1/2.)
         F2 = A196_TT_ASHA_HTT100_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.100D0 .AND. HYP_MASS.LE.105D0) THEN 
         REFMH1 = 100D0
         REFMH2 = 105D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHA_HTT100_MASS(REC_MASS-DELTA1/2.)
         F2 = A196_TT_ASHA_HTT105_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.105D0 .AND. HYP_MASS.LE.107D0) THEN 
         REFMH1 = 105D0
         REFMH2 = 107D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHA_HTT105_MASS(REC_MASS-DELTA1/2.)
         F2 = A196_TT_ASHA_HTT107_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.107D0 .AND. HYP_MASS.LE.110D0) THEN 
         REFMH1 = 107D0
         REFMH2 = 110D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHA_HTT107_MASS(REC_MASS-DELTA1/2.)
         F2 = A196_TT_ASHA_HTT110_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.110D0 .AND. HYP_MASS.LE.115D0) THEN 
         REFMH1 = 110D0
         REFMH2 = 115D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHA_HTT110_MASS(REC_MASS-DELTA1/2.)
         F2 = A196_TT_ASHA_HTT115_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.115D0 .AND. HYP_MASS.LE.120D0) THEN 
         REFMH1 = 115D0
         REFMH2 = 120D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHA_HTT115_MASS(REC_MASS-DELTA1/2.)
         F2 = A196_TT_ASHA_HTT120_MASS(REC_MASS+DELTA2/2.)
      ELSE
         A196_TT_M_ASHA_ONHTT = 0.D0
         RETURN
      ENDIF

      A196_TT_M_ASHA_ONHTT = (DELTA2 * F1 + DELTA1 * F2)
     $     / (REFMH2 - REFMH1)
      IF (A196_TT_M_ASHA_ONHTT.LT.1.D-05) THEN
         A196_TT_M_ASHA_ONHTT = 1.D-05 
      ENDIF
      
      RETURN
      END

      DOUBLE PRECISION FUNCTION
     $     A196_TT_M_ASHZ_ONHTT(REC_MASS, HYP_MASS)
      IMPLICIT NONE
      DOUBLE PRECISION REC_MASS, HYP_MASS
      DOUBLE PRECISION DELTA1, DELTA2, REFMH1, REFMH2, F1, F2
      DOUBLE PRECISION
     $     A196_TT_ASHZ_HTT60_MASS, A196_TT_ASHZ_HTT65_MASS,
     $     A196_TT_ASHZ_HTT70_MASS, A196_TT_ASHZ_HTT75_MASS,
     $     A196_TT_ASHZ_HTT80_MASS, A196_TT_ASHZ_HTT85_MASS,
     $     A196_TT_ASHZ_HTT90_MASS, A196_TT_ASHZ_HTT95_MASS,
     $     A196_TT_ASHZ_HTT100_MASS, A196_TT_ASHZ_HTT105_MASS,
     $     A196_TT_ASHZ_HTT107_MASS, A196_TT_ASHZ_HTT110_MASS,
     $     A196_TT_ASHZ_HTT115_MASS, A196_TT_ASHZ_HTT120_MASS
C 
C (No integration since shapes made with KEYS are by default 
C  normalized when created.)
C
      IF (HYP_MASS.GE.60D0 .AND. HYP_MASS.LE.65D0) THEN
         REFMH1 = 60D0
         REFMH2 = 65D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHZ_HTT60_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_ASHZ_HTT65_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.65D0 .AND. HYP_MASS.LE.70D0) THEN
         REFMH1 = 65D0
         REFMH2 = 70D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHZ_HTT65_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_ASHZ_HTT70_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.70D0 .AND. HYP_MASS.LE.75D0) THEN
         REFMH1 = 70D0
         REFMH2 = 75D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHZ_HTT70_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_ASHZ_HTT75_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.75D0 .AND. HYP_MASS.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHZ_HTT75_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_ASHZ_HTT80_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.80D0 .AND. HYP_MASS.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHZ_HTT80_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_ASHZ_HTT85_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.85D0 .AND. HYP_MASS.LE.90D0) THEN 
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHZ_HTT85_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_ASHZ_HTT90_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.90D0 .AND. HYP_MASS.LE.95D0) THEN 
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHZ_HTT90_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_ASHZ_HTT95_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.95D0 .AND. HYP_MASS.LE.100D0) THEN 
         REFMH1 = 95D0
         REFMH2 = 100D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHZ_HTT95_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_ASHZ_HTT100_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.100D0 .AND. HYP_MASS.LE.105D0) THEN 
         REFMH1 = 100D0
         REFMH2 = 105D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHZ_HTT100_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_ASHZ_HTT105_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.105D0 .AND. HYP_MASS.LE.107D0) THEN 
         REFMH1 = 105D0
         REFMH2 = 107D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHZ_HTT105_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_ASHZ_HTT107_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.107D0 .AND. HYP_MASS.LE.110D0) THEN 
         REFMH1 = 107D0
         REFMH2 = 110D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHZ_HTT107_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_ASHZ_HTT110_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.110D0 .AND. HYP_MASS.LE.115D0) THEN 
         REFMH1 = 110D0
         REFMH2 = 115D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHZ_HTT110_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_ASHZ_HTT115_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.115D0 .AND. HYP_MASS.LE.120D0) THEN 
         REFMH1 = 115D0
         REFMH2 = 120D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHZ_HTT115_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_ASHZ_HTT120_MASS(REC_MASS+DELTA2)
      ELSE
         A196_TT_M_ASHZ_ONHTT = 0.D0
         RETURN
      ENDIF

      A196_TT_M_ASHZ_ONHTT = (DELTA2 * F1 + DELTA1 * F2)
     $     / (REFMH2 - REFMH1)
      IF (A196_TT_M_ASHZ_ONHTT.LT.1.D-05) THEN
         A196_TT_M_ASHZ_ONHTT = 1.D-05 
      ENDIF
      
      RETURN
      END

      DOUBLE PRECISION FUNCTION
     $     A196_TT_M_HAONLY_ONTTZ(REC_MASS, HYP_MASS)
      IMPLICIT NONE
      DOUBLE PRECISION REC_MASS, HYP_MASS
      DOUBLE PRECISION DELTA1, DELTA2, REFMH1, REFMH2, F1, F2
      DOUBLE PRECISION
     $     A196_TT_HAONLY_TTZ60_MASS, A196_TT_HAONLY_TTZ65_MASS,
     $     A196_TT_HAONLY_TTZ70_MASS, A196_TT_HAONLY_TTZ75_MASS,
     $     A196_TT_HAONLY_TTZ80_MASS, A196_TT_HAONLY_TTZ85_MASS,
     $     A196_TT_HAONLY_TTZ90_MASS, A196_TT_HAONLY_TTZ95_MASS,
     $     A196_TT_HAONLY_TTZ100_MASS, A196_TT_HAONLY_TTZ105_MASS,
     $     A196_TT_HAONLY_TTZ107_MASS, A196_TT_HAONLY_TTZ110_MASS,
     $     A196_TT_HAONLY_TTZ115_MASS, A196_TT_HAONLY_TTZ120_MASS
C 
C (No integration since shapes made with KEYS are by default 
C  normalized when created.)
C
      IF (HYP_MASS.GE.60D0 .AND. HYP_MASS.LE.65D0) THEN
         REFMH1 = 60D0
         REFMH2 = 65D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HAONLY_TTZ60_MASS(REC_MASS-DELTA1/2.)
         F2 = A196_TT_HAONLY_TTZ65_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.65D0 .AND. HYP_MASS.LE.70D0) THEN
         REFMH1 = 65D0
         REFMH2 = 70D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HAONLY_TTZ65_MASS(REC_MASS-DELTA1/2.)
         F2 = A196_TT_HAONLY_TTZ70_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.70D0 .AND. HYP_MASS.LE.75D0) THEN
         REFMH1 = 70D0
         REFMH2 = 75D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HAONLY_TTZ70_MASS(REC_MASS-DELTA1/2.)
         F2 = A196_TT_HAONLY_TTZ75_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.75D0 .AND. HYP_MASS.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HAONLY_TTZ75_MASS(REC_MASS-DELTA1/2.)
         F2 = A196_TT_HAONLY_TTZ80_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.80D0 .AND. HYP_MASS.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HAONLY_TTZ80_MASS(REC_MASS-DELTA1/2.)
         F2 = A196_TT_HAONLY_TTZ85_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.85D0 .AND. HYP_MASS.LE.90D0) THEN 
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HAONLY_TTZ85_MASS(REC_MASS-DELTA1/2.)
         F2 = A196_TT_HAONLY_TTZ90_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.90D0 .AND. HYP_MASS.LE.95D0) THEN 
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HAONLY_TTZ90_MASS(REC_MASS-DELTA1/2.)
         F2 = A196_TT_HAONLY_TTZ95_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.95D0 .AND. HYP_MASS.LE.100D0) THEN 
         REFMH1 = 95D0
         REFMH2 = 100D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HAONLY_TTZ95_MASS(REC_MASS-DELTA1/2.)
         F2 = A196_TT_HAONLY_TTZ100_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.100D0 .AND. HYP_MASS.LE.105D0) THEN 
         REFMH1 = 100D0
         REFMH2 = 105D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HAONLY_TTZ100_MASS(REC_MASS-DELTA1/2.)
         F2 = A196_TT_HAONLY_TTZ105_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.105D0 .AND. HYP_MASS.LE.107D0) THEN 
         REFMH1 = 105D0
         REFMH2 = 107D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HAONLY_TTZ105_MASS(REC_MASS-DELTA1/2.)
         F2 = A196_TT_HAONLY_TTZ107_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.107D0 .AND. HYP_MASS.LE.110D0) THEN 
         REFMH1 = 107D0
         REFMH2 = 110D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HAONLY_TTZ107_MASS(REC_MASS-DELTA1/2.)
         F2 = A196_TT_HAONLY_TTZ110_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.110D0 .AND. HYP_MASS.LE.115D0) THEN 
         REFMH1 = 110D0
         REFMH2 = 115D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HAONLY_TTZ110_MASS(REC_MASS-DELTA1/2.)
         F2 = A196_TT_HAONLY_TTZ115_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.115D0 .AND. HYP_MASS.LE.120D0) THEN 
         REFMH1 = 115D0
         REFMH2 = 120D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HAONLY_TTZ115_MASS(REC_MASS-DELTA1/2.)
         F2 = A196_TT_HAONLY_TTZ120_MASS(REC_MASS+DELTA2/2.)
      ELSE
         A196_TT_M_HAONLY_ONTTZ = 0.D0
         RETURN
      ENDIF

      A196_TT_M_HAONLY_ONTTZ = (DELTA2 * F1 + DELTA1 * F2)
     $     / (REFMH2 - REFMH1)
      IF (A196_TT_M_HAONLY_ONTTZ.LT.1.D-05) THEN
         A196_TT_M_HAONLY_ONTTZ = 1.D-05 
      ENDIF
      
      RETURN
      END

      DOUBLE PRECISION FUNCTION
     $     A196_TT_M_HZONLY_ONTTZ(REC_MASS, HYP_MASS)
      IMPLICIT NONE
      DOUBLE PRECISION REC_MASS, HYP_MASS
      DOUBLE PRECISION DELTA1, DELTA2, REFMH1, REFMH2, F1, F2
      DOUBLE PRECISION
     $     A196_TT_HZONLY_TTZ60_MASS, A196_TT_HZONLY_TTZ65_MASS,
     $     A196_TT_HZONLY_TTZ70_MASS, A196_TT_HZONLY_TTZ75_MASS,
     $     A196_TT_HZONLY_TTZ80_MASS, A196_TT_HZONLY_TTZ85_MASS,
     $     A196_TT_HZONLY_TTZ90_MASS, A196_TT_HZONLY_TTZ95_MASS,
     $     A196_TT_HZONLY_TTZ100_MASS, A196_TT_HZONLY_TTZ105_MASS,
     $     A196_TT_HZONLY_TTZ107_MASS, A196_TT_HZONLY_TTZ110_MASS,
     $     A196_TT_HZONLY_TTZ115_MASS, A196_TT_HZONLY_TTZ120_MASS
C 
C (No integration since shapes made with KEYS are by default 
C  normalized when created.)
C
      IF (HYP_MASS.GE.60D0 .AND. HYP_MASS.LE.65D0) THEN
         REFMH1 = 60D0
         REFMH2 = 65D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HZONLY_TTZ60_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_HZONLY_TTZ65_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.65D0 .AND. HYP_MASS.LE.70D0) THEN
         REFMH1 = 65D0
         REFMH2 = 70D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HZONLY_TTZ65_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_HZONLY_TTZ70_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.70D0 .AND. HYP_MASS.LE.75D0) THEN
         REFMH1 = 70D0
         REFMH2 = 75D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HZONLY_TTZ70_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_HZONLY_TTZ75_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.75D0 .AND. HYP_MASS.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HZONLY_TTZ75_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_HZONLY_TTZ80_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.80D0 .AND. HYP_MASS.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HZONLY_TTZ80_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_HZONLY_TTZ85_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.85D0 .AND. HYP_MASS.LE.90D0) THEN 
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HZONLY_TTZ85_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_HZONLY_TTZ90_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.90D0 .AND. HYP_MASS.LE.95D0) THEN 
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HZONLY_TTZ90_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_HZONLY_TTZ95_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.95D0 .AND. HYP_MASS.LE.100D0) THEN 
         REFMH1 = 95D0
         REFMH2 = 100D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HZONLY_TTZ95_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_HZONLY_TTZ100_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.100D0 .AND. HYP_MASS.LE.105D0) THEN 
         REFMH1 = 100D0
         REFMH2 = 105D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HZONLY_TTZ100_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_HZONLY_TTZ105_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.105D0 .AND. HYP_MASS.LE.107D0) THEN 
         REFMH1 = 105D0
         REFMH2 = 107D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HZONLY_TTZ105_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_HZONLY_TTZ107_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.107D0 .AND. HYP_MASS.LE.110D0) THEN 
         REFMH1 = 107D0
         REFMH2 = 110D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HZONLY_TTZ107_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_HZONLY_TTZ110_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.110D0 .AND. HYP_MASS.LE.115D0) THEN 
         REFMH1 = 110D0
         REFMH2 = 115D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HZONLY_TTZ110_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_HZONLY_TTZ115_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.115D0 .AND. HYP_MASS.LE.120D0) THEN 
         REFMH1 = 115D0
         REFMH2 = 120D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_HZONLY_TTZ115_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_HZONLY_TTZ120_MASS(REC_MASS+DELTA2)
      ELSE
         A196_TT_M_HZONLY_ONTTZ = 0.D0
         RETURN
      ENDIF

      A196_TT_M_HZONLY_ONTTZ = (DELTA2 * F1 + DELTA1 * F2)
     $     / (REFMH2 - REFMH1)
      IF (A196_TT_M_HZONLY_ONTTZ.LT.1.D-05) THEN
         A196_TT_M_HZONLY_ONTTZ = 1.D-05 
      ENDIF
      
      RETURN
      END

      DOUBLE PRECISION FUNCTION
     $     A196_TT_M_ASHA_ONTTZ(REC_MASS, HYP_MASS)
      IMPLICIT NONE
      DOUBLE PRECISION REC_MASS, HYP_MASS
      DOUBLE PRECISION DELTA1, DELTA2, REFMH1, REFMH2, F1, F2
      DOUBLE PRECISION
     $     A196_TT_ASHA_TTZ60_MASS, A196_TT_ASHA_TTZ65_MASS,
     $     A196_TT_ASHA_TTZ70_MASS, A196_TT_ASHA_TTZ75_MASS,
     $     A196_TT_ASHA_TTZ80_MASS, A196_TT_ASHA_TTZ85_MASS,
     $     A196_TT_ASHA_TTZ90_MASS, A196_TT_ASHA_TTZ95_MASS,
     $     A196_TT_ASHA_TTZ100_MASS, A196_TT_ASHA_TTZ105_MASS,
     $     A196_TT_ASHA_TTZ107_MASS, A196_TT_ASHA_TTZ110_MASS,
     $     A196_TT_ASHA_TTZ115_MASS, A196_TT_ASHA_TTZ120_MASS
C 
C (No integration since shapes made with KEYS are by default 
C  normalized when created.)
C
      IF (HYP_MASS.GE.60D0 .AND. HYP_MASS.LE.65D0) THEN
         REFMH1 = 60D0
         REFMH2 = 65D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHA_TTZ60_MASS(REC_MASS-DELTA1/2.)
         F2 = A196_TT_ASHA_TTZ65_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.65D0 .AND. HYP_MASS.LE.70D0) THEN
         REFMH1 = 65D0
         REFMH2 = 70D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHA_TTZ65_MASS(REC_MASS-DELTA1/2.)
         F2 = A196_TT_ASHA_TTZ70_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.70D0 .AND. HYP_MASS.LE.75D0) THEN
         REFMH1 = 70D0
         REFMH2 = 75D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHA_TTZ70_MASS(REC_MASS-DELTA1/2.)
         F2 = A196_TT_ASHA_TTZ75_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.75D0 .AND. HYP_MASS.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHA_TTZ75_MASS(REC_MASS-DELTA1/2.)
         F2 = A196_TT_ASHA_TTZ80_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.80D0 .AND. HYP_MASS.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHA_TTZ80_MASS(REC_MASS-DELTA1/2.)
         F2 = A196_TT_ASHA_TTZ85_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.85D0 .AND. HYP_MASS.LE.90D0) THEN 
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHA_TTZ85_MASS(REC_MASS-DELTA1/2.)
         F2 = A196_TT_ASHA_TTZ90_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.90D0 .AND. HYP_MASS.LE.95D0) THEN 
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHA_TTZ90_MASS(REC_MASS-DELTA1/2.)
         F2 = A196_TT_ASHA_TTZ95_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.95D0 .AND. HYP_MASS.LE.100D0) THEN 
         REFMH1 = 95D0
         REFMH2 = 100D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHA_TTZ95_MASS(REC_MASS-DELTA1/2.)
         F2 = A196_TT_ASHA_TTZ100_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.100D0 .AND. HYP_MASS.LE.105D0) THEN 
         REFMH1 = 100D0
         REFMH2 = 105D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHA_TTZ100_MASS(REC_MASS-DELTA1/2.)
         F2 = A196_TT_ASHA_TTZ105_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.105D0 .AND. HYP_MASS.LE.107D0) THEN 
         REFMH1 = 105D0
         REFMH2 = 107D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHA_TTZ105_MASS(REC_MASS-DELTA1/2.)
         F2 = A196_TT_ASHA_TTZ107_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.107D0 .AND. HYP_MASS.LE.110D0) THEN 
         REFMH1 = 107D0
         REFMH2 = 110D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHA_TTZ107_MASS(REC_MASS-DELTA1/2.)
         F2 = A196_TT_ASHA_TTZ110_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.110D0 .AND. HYP_MASS.LE.115D0) THEN 
         REFMH1 = 110D0
         REFMH2 = 115D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHA_TTZ110_MASS(REC_MASS-DELTA1/2.)
         F2 = A196_TT_ASHA_TTZ115_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.115D0 .AND. HYP_MASS.LE.120D0) THEN 
         REFMH1 = 115D0
         REFMH2 = 120D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHA_TTZ115_MASS(REC_MASS-DELTA1/2.)
         F2 = A196_TT_ASHA_TTZ120_MASS(REC_MASS+DELTA2/2.)
      ELSE
         A196_TT_M_ASHA_ONTTZ = 0.D0
         RETURN
      ENDIF

      A196_TT_M_ASHA_ONTTZ = (DELTA2 * F1 + DELTA1 * F2)
     $     / (REFMH2 - REFMH1)
      IF (A196_TT_M_ASHA_ONTTZ.LT.1.D-05) THEN
         A196_TT_M_ASHA_ONTTZ = 1.D-05 
      ENDIF
      
      RETURN
      END

      DOUBLE PRECISION FUNCTION
     $     A196_TT_M_ASHZ_ONTTZ(REC_MASS, HYP_MASS)
      IMPLICIT NONE
      DOUBLE PRECISION REC_MASS, HYP_MASS
      DOUBLE PRECISION DELTA1, DELTA2, REFMH1, REFMH2, F1, F2
      DOUBLE PRECISION
     $     A196_TT_ASHZ_TTZ60_MASS, A196_TT_ASHZ_TTZ65_MASS,
     $     A196_TT_ASHZ_TTZ70_MASS, A196_TT_ASHZ_TTZ75_MASS,
     $     A196_TT_ASHZ_TTZ80_MASS, A196_TT_ASHZ_TTZ85_MASS,
     $     A196_TT_ASHZ_TTZ90_MASS, A196_TT_ASHZ_TTZ95_MASS,
     $     A196_TT_ASHZ_TTZ100_MASS, A196_TT_ASHZ_TTZ105_MASS,
     $     A196_TT_ASHZ_TTZ107_MASS, A196_TT_ASHZ_TTZ110_MASS,
     $     A196_TT_ASHZ_TTZ115_MASS, A196_TT_ASHZ_TTZ120_MASS
C 
C (No integration since shapes made with KEYS are by default 
C  normalized when created.)
C
      IF (HYP_MASS.GE.60D0 .AND. HYP_MASS.LE.65D0) THEN
         REFMH1 = 60D0
         REFMH2 = 65D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHZ_TTZ60_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_ASHZ_TTZ65_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.65D0 .AND. HYP_MASS.LE.70D0) THEN
         REFMH1 = 65D0
         REFMH2 = 70D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHZ_TTZ65_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_ASHZ_TTZ70_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.70D0 .AND. HYP_MASS.LE.75D0) THEN
         REFMH1 = 70D0
         REFMH2 = 75D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHZ_TTZ70_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_ASHZ_TTZ75_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.75D0 .AND. HYP_MASS.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHZ_TTZ75_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_ASHZ_TTZ80_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.80D0 .AND. HYP_MASS.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHZ_TTZ80_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_ASHZ_TTZ85_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.85D0 .AND. HYP_MASS.LE.90D0) THEN 
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHZ_TTZ85_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_ASHZ_TTZ90_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.90D0 .AND. HYP_MASS.LE.95D0) THEN 
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHZ_TTZ90_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_ASHZ_TTZ95_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.95D0 .AND. HYP_MASS.LE.100D0) THEN 
         REFMH1 = 95D0
         REFMH2 = 100D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHZ_TTZ95_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_ASHZ_TTZ100_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.100D0 .AND. HYP_MASS.LE.105D0) THEN 
         REFMH1 = 100D0
         REFMH2 = 105D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHZ_TTZ100_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_ASHZ_TTZ105_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.105D0 .AND. HYP_MASS.LE.107D0) THEN 
         REFMH1 = 105D0
         REFMH2 = 107D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHZ_TTZ105_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_ASHZ_TTZ107_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.107D0 .AND. HYP_MASS.LE.110D0) THEN 
         REFMH1 = 107D0
         REFMH2 = 110D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHZ_TTZ107_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_ASHZ_TTZ110_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.110D0 .AND. HYP_MASS.LE.115D0) THEN 
         REFMH1 = 110D0
         REFMH2 = 115D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHZ_TTZ110_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_ASHZ_TTZ115_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.115D0 .AND. HYP_MASS.LE.120D0) THEN 
         REFMH1 = 115D0
         REFMH2 = 120D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A196_TT_ASHZ_TTZ115_MASS(REC_MASS-DELTA1)
         F2 = A196_TT_ASHZ_TTZ120_MASS(REC_MASS+DELTA2)
      ELSE
         A196_TT_M_ASHZ_ONTTZ = 0.D0
         RETURN
      ENDIF

      A196_TT_M_ASHZ_ONTTZ = (DELTA2 * F1 + DELTA1 * F2)
     $     / (REFMH2 - REFMH1)
      IF (A196_TT_M_ASHZ_ONTTZ.LT.1.D-05) THEN
         A196_TT_M_ASHZ_ONTTZ = 1.D-05 
      ENDIF
      
      RETURN
      END

C 
C---- New file --- 
C 
      DOUBLE PRECISION FUNCTION A200_TT_SIG_MASS(REC_MASS,
     $     HYP_MASS, IANA, ISIG)
      IMPLICIT NONE
      DOUBLE PRECISION REC_MASS, HYP_MASS
      INTEGER IANA, ISIG
      DOUBLE PRECISION A200_TT_M_HAONLY_ONHTT, A200_TT_M_HZONLY_ONHTT,
     $     A200_TT_M_ASHA_ONHTT, A200_TT_M_ASHZ_ONHTT
      DOUBLE PRECISION A200_TT_M_HAONLY_ONHA, A200_TT_M_HZONLY_ONHA,
     $     A200_TT_M_ASHA_ONHA, A200_TT_M_ASHZ_ONHA
      DOUBLE PRECISION A200_TT_M_HAONLY_ONTTZ, A200_TT_M_HZONLY_ONTTZ,
     $     A200_TT_M_ASHA_ONTTZ, A200_TT_M_ASHZ_ONTTZ

C REC_MASS is the reconstructed mass 
C MASS_HYP is the Higgs mass hypothesis
C IANA defines the analysis branch
C  This index: 1=hAonly, 2=hZonly, 3=overlap (as hA), 4=overlap (as hZ)
C ISIG gives the signal 
C     1 to 4 =Htt
C     5      =ttZ,
C     6 to 9 =hA->ttX

      IF (ISIG.GE.1 .AND. ISIG.LE.4) THEN
         IF (IANA.EQ.1) THEN
            A200_TT_SIG_MASS = A200_TT_M_HAONLY_ONHTT(REC_MASS,HYP_MASS)
         ELSE IF (IANA.EQ.2) THEN
            A200_TT_SIG_MASS = A200_TT_M_HZONLY_ONHTT(REC_MASS,HYP_MASS)
         ELSE IF (IANA.EQ.3) THEN
            A200_TT_SIG_MASS = A200_TT_M_ASHA_ONHTT(REC_MASS,HYP_MASS)
         ELSE IF (IANA.EQ.4) THEN
            A200_TT_SIG_MASS = A200_TT_M_ASHZ_ONHTT(REC_MASS,HYP_MASS)
         ENDIF
      ELSE IF (ISIG.EQ.5) THEN
         IF (IANA.EQ.1) THEN
            A200_TT_SIG_MASS = A200_TT_M_HAONLY_ONTTZ(REC_MASS,HYP_MASS)
         ELSE IF (IANA.EQ.2) THEN
            A200_TT_SIG_MASS = A200_TT_M_HZONLY_ONTTZ(REC_MASS,HYP_MASS)
         ELSE IF (IANA.EQ.3) THEN
            A200_TT_SIG_MASS = A200_TT_M_ASHA_ONTTZ(REC_MASS,HYP_MASS)
         ELSE IF (IANA.EQ.4) THEN
            A200_TT_SIG_MASS = A200_TT_M_ASHZ_ONTTZ(REC_MASS,HYP_MASS)
         ENDIF
      ELSE IF (ISIG.GE.6 .AND. ISIG.LE.9) THEN
         IF (IANA.EQ.1) THEN
            A200_TT_SIG_MASS = A200_TT_M_HAONLY_ONHA(REC_MASS,HYP_MASS)
         ELSE IF (IANA.EQ.2) THEN
            A200_TT_SIG_MASS = A200_TT_M_HZONLY_ONHA(REC_MASS,HYP_MASS)
         ELSE IF (IANA.EQ.3) THEN
            A200_TT_SIG_MASS = A200_TT_M_ASHA_ONHA(REC_MASS,HYP_MASS)
         ELSE IF (IANA.EQ.4) THEN
            A200_TT_SIG_MASS = A200_TT_M_ASHZ_ONHA(REC_MASS,HYP_MASS)
         ENDIF
      ENDIF
      RETURN
      END


      DOUBLE PRECISION FUNCTION
     $     A200_TT_M_HAONLY_ONHA(REC_MASS, HYP_MASS)
      IMPLICIT NONE
      DOUBLE PRECISION REC_MASS, HYP_MASS
      DOUBLE PRECISION DELTA1, DELTA2, REFMH1, REFMH2, F1, F2
      DOUBLE PRECISION
     $     A200_TT_HAONLY_HATT60_MASS, A200_TT_HAONLY_HATT65_MASS,
     $     A200_TT_HAONLY_HATT70_MASS, A200_TT_HAONLY_HATT75_MASS,
     $     A200_TT_HAONLY_HATT80_MASS, A200_TT_HAONLY_HATT85_MASS,
     $     A200_TT_HAONLY_HATT90_MASS, A200_TT_HAONLY_HATT95_MASS,
     $     A200_TT_HAONLY_HATT100_MASS, A200_TT_HAONLY_HATT105_MASS,
     $     A200_TT_HAONLY_HATT107_MASS, A200_TT_HAONLY_HATT110_MASS,
     $     A200_TT_HAONLY_HATT115_MASS, A200_TT_HAONLY_HATT120_MASS
C 
C (No integration since shapes made with KEYS are by default 
C  normalized when created.)
C
      IF (HYP_MASS.GE.60D0 .AND. HYP_MASS.LE.65D0) THEN
         REFMH1 = 60D0
         REFMH2 = 65D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HAONLY_HATT60_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_HAONLY_HATT65_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.65D0 .AND. HYP_MASS.LE.70D0) THEN
         REFMH1 = 65D0
         REFMH2 = 70D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HAONLY_HATT65_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_HAONLY_HATT70_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.70D0 .AND. HYP_MASS.LE.75D0) THEN
         REFMH1 = 70D0
         REFMH2 = 75D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HAONLY_HATT70_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_HAONLY_HATT75_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.75D0 .AND. HYP_MASS.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HAONLY_HATT75_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_HAONLY_HATT80_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.80D0 .AND. HYP_MASS.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HAONLY_HATT80_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_HAONLY_HATT85_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.85D0 .AND. HYP_MASS.LE.90D0) THEN 
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HAONLY_HATT85_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_HAONLY_HATT90_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.90D0 .AND. HYP_MASS.LE.95D0) THEN 
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HAONLY_HATT90_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_HAONLY_HATT95_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.95D0 .AND. HYP_MASS.LE.100D0) THEN 
         REFMH1 = 95D0
         REFMH2 = 100D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HAONLY_HATT95_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_HAONLY_HATT100_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.100D0 .AND. HYP_MASS.LE.105D0) THEN 
         REFMH1 = 100D0
         REFMH2 = 105D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HAONLY_HATT100_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_HAONLY_HATT105_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.105D0 .AND. HYP_MASS.LE.107D0) THEN 
         REFMH1 = 105D0
         REFMH2 = 107D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HAONLY_HATT105_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_HAONLY_HATT107_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.107D0 .AND. HYP_MASS.LE.110D0) THEN 
         REFMH1 = 107D0
         REFMH2 = 110D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HAONLY_HATT107_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_HAONLY_HATT110_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.110D0 .AND. HYP_MASS.LE.115D0) THEN 
         REFMH1 = 110D0
         REFMH2 = 115D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HAONLY_HATT110_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_HAONLY_HATT115_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.115D0 .AND. HYP_MASS.LE.120D0) THEN 
         REFMH1 = 115D0
         REFMH2 = 120D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HAONLY_HATT115_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_HAONLY_HATT120_MASS(REC_MASS+DELTA2)
      ELSE
         A200_TT_M_HAONLY_ONHA = 0.D0
         RETURN
      ENDIF

      A200_TT_M_HAONLY_ONHA = (DELTA2 * F1 + DELTA1 * F2)
     $     / (REFMH2 - REFMH1)
      IF (A200_TT_M_HAONLY_ONHA.LT.1.D-05) THEN
         A200_TT_M_HAONLY_ONHA = 1.D-05 
      ENDIF
      
      RETURN
      END

      DOUBLE PRECISION FUNCTION
     $     A200_TT_M_HZONLY_ONHA(REC_MASS, HYP_MASS)
      IMPLICIT NONE
      DOUBLE PRECISION REC_MASS, HYP_MASS
      DOUBLE PRECISION DELTA1, DELTA2, REFMH1, REFMH2, F1, F2
      DOUBLE PRECISION
     $     A200_TT_HZONLY_HATT60_MASS, A200_TT_HZONLY_HATT65_MASS,
     $     A200_TT_HZONLY_HATT70_MASS, A200_TT_HZONLY_HATT75_MASS,
     $     A200_TT_HZONLY_HATT80_MASS, A200_TT_HZONLY_HATT85_MASS,
     $     A200_TT_HZONLY_HATT90_MASS, A200_TT_HZONLY_HATT95_MASS,
     $     A200_TT_HZONLY_HATT100_MASS, A200_TT_HZONLY_HATT105_MASS,
     $     A200_TT_HZONLY_HATT107_MASS, A200_TT_HZONLY_HATT110_MASS,
     $     A200_TT_HZONLY_HATT115_MASS, A200_TT_HZONLY_HATT120_MASS
C 
C (No integration since shapes made with KEYS are by default 
C  normalized when created.)
C
      IF (HYP_MASS.GE.60D0 .AND. HYP_MASS.LE.65D0) THEN
         REFMH1 = 60D0
         REFMH2 = 65D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HZONLY_HATT60_MASS(REC_MASS-DELTA1*2.)
         F2 = A200_TT_HZONLY_HATT65_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.65D0 .AND. HYP_MASS.LE.70D0) THEN
         REFMH1 = 65D0
         REFMH2 = 70D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HZONLY_HATT65_MASS(REC_MASS-DELTA1*2.)
         F2 = A200_TT_HZONLY_HATT70_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.70D0 .AND. HYP_MASS.LE.75D0) THEN
         REFMH1 = 70D0
         REFMH2 = 75D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HZONLY_HATT70_MASS(REC_MASS-DELTA1*2.)
         F2 = A200_TT_HZONLY_HATT75_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.75D0 .AND. HYP_MASS.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HZONLY_HATT75_MASS(REC_MASS-DELTA1*2.)
         F2 = A200_TT_HZONLY_HATT80_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.80D0 .AND. HYP_MASS.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HZONLY_HATT80_MASS(REC_MASS-DELTA1*2.)
         F2 = A200_TT_HZONLY_HATT85_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.85D0 .AND. HYP_MASS.LE.90D0) THEN 
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HZONLY_HATT85_MASS(REC_MASS-DELTA1*2.)
         F2 = A200_TT_HZONLY_HATT90_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.90D0 .AND. HYP_MASS.LE.95D0) THEN 
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HZONLY_HATT90_MASS(REC_MASS-DELTA1*2.)
         F2 = A200_TT_HZONLY_HATT95_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.95D0 .AND. HYP_MASS.LE.100D0) THEN 
         REFMH1 = 95D0
         REFMH2 = 100D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HZONLY_HATT95_MASS(REC_MASS-DELTA1*2.)
         F2 = A200_TT_HZONLY_HATT100_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.100D0 .AND. HYP_MASS.LE.105D0) THEN 
         REFMH1 = 100D0
         REFMH2 = 105D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HZONLY_HATT100_MASS(REC_MASS-DELTA1*2.)
         F2 = A200_TT_HZONLY_HATT105_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.105D0 .AND. HYP_MASS.LE.107D0) THEN 
         REFMH1 = 105D0
         REFMH2 = 107D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HZONLY_HATT105_MASS(REC_MASS-DELTA1*2.)
         F2 = A200_TT_HZONLY_HATT107_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.107D0 .AND. HYP_MASS.LE.110D0) THEN 
         REFMH1 = 107D0
         REFMH2 = 110D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HZONLY_HATT107_MASS(REC_MASS-DELTA1*2.)
         F2 = A200_TT_HZONLY_HATT110_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.110D0 .AND. HYP_MASS.LE.115D0) THEN 
         REFMH1 = 110D0
         REFMH2 = 115D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HZONLY_HATT110_MASS(REC_MASS-DELTA1*2.)
         F2 = A200_TT_HZONLY_HATT115_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.115D0 .AND. HYP_MASS.LE.120D0) THEN 
         REFMH1 = 115D0
         REFMH2 = 120D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HZONLY_HATT115_MASS(REC_MASS-DELTA1*2.)
         F2 = A200_TT_HZONLY_HATT120_MASS(REC_MASS+DELTA2*2.)
      ELSE
         A200_TT_M_HZONLY_ONHA = 0.D0
         RETURN
      ENDIF

      A200_TT_M_HZONLY_ONHA = (DELTA2 * F1 + DELTA1 * F2)
     $     / (REFMH2 - REFMH1)
      IF (A200_TT_M_HZONLY_ONHA.LT.1.D-05) THEN
         A200_TT_M_HZONLY_ONHA = 1.D-05 
      ENDIF
      
      RETURN
      END

      DOUBLE PRECISION FUNCTION
     $     A200_TT_M_ASHA_ONHA(REC_MASS, HYP_MASS)
      IMPLICIT NONE
      DOUBLE PRECISION REC_MASS, HYP_MASS
      DOUBLE PRECISION DELTA1, DELTA2, REFMH1, REFMH2, F1, F2
      DOUBLE PRECISION
     $     A200_TT_ASHA_HATT60_MASS, A200_TT_ASHA_HATT65_MASS,
     $     A200_TT_ASHA_HATT70_MASS, A200_TT_ASHA_HATT75_MASS,
     $     A200_TT_ASHA_HATT80_MASS, A200_TT_ASHA_HATT85_MASS,
     $     A200_TT_ASHA_HATT90_MASS, A200_TT_ASHA_HATT95_MASS,
     $     A200_TT_ASHA_HATT100_MASS, A200_TT_ASHA_HATT105_MASS,
     $     A200_TT_ASHA_HATT107_MASS, A200_TT_ASHA_HATT110_MASS,
     $     A200_TT_ASHA_HATT115_MASS, A200_TT_ASHA_HATT120_MASS
C 
C (No integration since shapes made with KEYS are by default 
C  normalized when created.)
C
      IF (HYP_MASS.GE.60D0 .AND. HYP_MASS.LE.65D0) THEN
         REFMH1 = 60D0
         REFMH2 = 65D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHA_HATT60_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_ASHA_HATT65_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.65D0 .AND. HYP_MASS.LE.70D0) THEN
         REFMH1 = 65D0
         REFMH2 = 70D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHA_HATT65_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_ASHA_HATT70_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.70D0 .AND. HYP_MASS.LE.75D0) THEN
         REFMH1 = 70D0
         REFMH2 = 75D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHA_HATT70_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_ASHA_HATT75_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.75D0 .AND. HYP_MASS.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHA_HATT75_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_ASHA_HATT80_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.80D0 .AND. HYP_MASS.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHA_HATT80_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_ASHA_HATT85_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.85D0 .AND. HYP_MASS.LE.90D0) THEN 
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHA_HATT85_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_ASHA_HATT90_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.90D0 .AND. HYP_MASS.LE.95D0) THEN 
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHA_HATT90_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_ASHA_HATT95_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.95D0 .AND. HYP_MASS.LE.100D0) THEN 
         REFMH1 = 95D0
         REFMH2 = 100D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHA_HATT95_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_ASHA_HATT100_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.100D0 .AND. HYP_MASS.LE.105D0) THEN 
         REFMH1 = 100D0
         REFMH2 = 105D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHA_HATT100_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_ASHA_HATT105_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.105D0 .AND. HYP_MASS.LE.107D0) THEN 
         REFMH1 = 105D0
         REFMH2 = 107D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHA_HATT105_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_ASHA_HATT107_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.107D0 .AND. HYP_MASS.LE.110D0) THEN 
         REFMH1 = 107D0
         REFMH2 = 110D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHA_HATT107_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_ASHA_HATT110_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.110D0 .AND. HYP_MASS.LE.115D0) THEN 
         REFMH1 = 110D0
         REFMH2 = 115D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHA_HATT110_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_ASHA_HATT115_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.115D0 .AND. HYP_MASS.LE.120D0) THEN 
         REFMH1 = 115D0
         REFMH2 = 120D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHA_HATT115_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_ASHA_HATT120_MASS(REC_MASS+DELTA2)
      ELSE
         A200_TT_M_ASHA_ONHA = 0.D0
         RETURN
      ENDIF

      A200_TT_M_ASHA_ONHA = (DELTA2 * F1 + DELTA1 * F2)
     $     / (REFMH2 - REFMH1)
      IF (A200_TT_M_ASHA_ONHA.LT.1.D-05) THEN
         A200_TT_M_ASHA_ONHA = 1.D-05 
      ENDIF
      
      RETURN
      END

      DOUBLE PRECISION FUNCTION
     $     A200_TT_M_ASHZ_ONHA(REC_MASS, HYP_MASS)
      IMPLICIT NONE
      DOUBLE PRECISION REC_MASS, HYP_MASS
      DOUBLE PRECISION DELTA1, DELTA2, REFMH1, REFMH2, F1, F2
      DOUBLE PRECISION
     $     A200_TT_ASHZ_HATT60_MASS, A200_TT_ASHZ_HATT65_MASS,
     $     A200_TT_ASHZ_HATT70_MASS, A200_TT_ASHZ_HATT75_MASS,
     $     A200_TT_ASHZ_HATT80_MASS, A200_TT_ASHZ_HATT85_MASS,
     $     A200_TT_ASHZ_HATT90_MASS, A200_TT_ASHZ_HATT95_MASS,
     $     A200_TT_ASHZ_HATT100_MASS, A200_TT_ASHZ_HATT105_MASS,
     $     A200_TT_ASHZ_HATT107_MASS, A200_TT_ASHZ_HATT110_MASS,
     $     A200_TT_ASHZ_HATT115_MASS, A200_TT_ASHZ_HATT120_MASS
C 
C (No integration since shapes made with KEYS are by default 
C  normalized when created.)
C
      IF (HYP_MASS.GE.60D0 .AND. HYP_MASS.LE.65D0) THEN
         REFMH1 = 60D0
         REFMH2 = 65D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHZ_HATT60_MASS(REC_MASS-DELTA1*2.)
         F2 = A200_TT_ASHZ_HATT65_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.65D0 .AND. HYP_MASS.LE.70D0) THEN
         REFMH1 = 65D0
         REFMH2 = 70D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHZ_HATT65_MASS(REC_MASS-DELTA1*2.)
         F2 = A200_TT_ASHZ_HATT70_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.70D0 .AND. HYP_MASS.LE.75D0) THEN
         REFMH1 = 70D0
         REFMH2 = 75D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHZ_HATT70_MASS(REC_MASS-DELTA1*2.)
         F2 = A200_TT_ASHZ_HATT75_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.75D0 .AND. HYP_MASS.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHZ_HATT75_MASS(REC_MASS-DELTA1*2.)
         F2 = A200_TT_ASHZ_HATT80_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.80D0 .AND. HYP_MASS.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHZ_HATT80_MASS(REC_MASS-DELTA1*2.)
         F2 = A200_TT_ASHZ_HATT85_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.85D0 .AND. HYP_MASS.LE.90D0) THEN 
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHZ_HATT85_MASS(REC_MASS-DELTA1*2.)
         F2 = A200_TT_ASHZ_HATT90_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.90D0 .AND. HYP_MASS.LE.95D0) THEN 
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHZ_HATT90_MASS(REC_MASS-DELTA1*2.)
         F2 = A200_TT_ASHZ_HATT95_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.95D0 .AND. HYP_MASS.LE.100D0) THEN 
         REFMH1 = 95D0
         REFMH2 = 100D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHZ_HATT95_MASS(REC_MASS-DELTA1*2.)
         F2 = A200_TT_ASHZ_HATT100_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.100D0 .AND. HYP_MASS.LE.105D0) THEN 
         REFMH1 = 100D0
         REFMH2 = 105D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHZ_HATT100_MASS(REC_MASS-DELTA1*2.)
         F2 = A200_TT_ASHZ_HATT105_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.105D0 .AND. HYP_MASS.LE.107D0) THEN 
         REFMH1 = 105D0
         REFMH2 = 107D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHZ_HATT105_MASS(REC_MASS-DELTA1*2.)
         F2 = A200_TT_ASHZ_HATT107_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.107D0 .AND. HYP_MASS.LE.110D0) THEN 
         REFMH1 = 107D0
         REFMH2 = 110D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHZ_HATT107_MASS(REC_MASS-DELTA1*2.)
         F2 = A200_TT_ASHZ_HATT110_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.110D0 .AND. HYP_MASS.LE.115D0) THEN 
         REFMH1 = 110D0
         REFMH2 = 115D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHZ_HATT110_MASS(REC_MASS-DELTA1*2.)
         F2 = A200_TT_ASHZ_HATT115_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.115D0 .AND. HYP_MASS.LE.120D0) THEN 
         REFMH1 = 115D0
         REFMH2 = 120D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHZ_HATT115_MASS(REC_MASS-DELTA1*2.)
         F2 = A200_TT_ASHZ_HATT120_MASS(REC_MASS+DELTA2*2.)
      ELSE
         A200_TT_M_ASHZ_ONHA = 0.D0
         RETURN
      ENDIF

      A200_TT_M_ASHZ_ONHA = (DELTA2 * F1 + DELTA1 * F2)
     $     / (REFMH2 - REFMH1)
      IF (A200_TT_M_ASHZ_ONHA.LT.1.D-05) THEN
         A200_TT_M_ASHZ_ONHA = 1.D-05 
      ENDIF
      
      RETURN
      END

      DOUBLE PRECISION FUNCTION
     $     A200_TT_M_HAONLY_ONHTT(REC_MASS, HYP_MASS)
      IMPLICIT NONE
      DOUBLE PRECISION REC_MASS, HYP_MASS
      DOUBLE PRECISION DELTA1, DELTA2, REFMH1, REFMH2, F1, F2
      DOUBLE PRECISION
     $     A200_TT_HAONLY_HTT60_MASS, A200_TT_HAONLY_HTT65_MASS,
     $     A200_TT_HAONLY_HTT70_MASS, A200_TT_HAONLY_HTT75_MASS,
     $     A200_TT_HAONLY_HTT80_MASS, A200_TT_HAONLY_HTT85_MASS,
     $     A200_TT_HAONLY_HTT90_MASS, A200_TT_HAONLY_HTT95_MASS,
     $     A200_TT_HAONLY_HTT100_MASS, A200_TT_HAONLY_HTT105_MASS,
     $     A200_TT_HAONLY_HTT107_MASS, A200_TT_HAONLY_HTT110_MASS,
     $     A200_TT_HAONLY_HTT115_MASS, A200_TT_HAONLY_HTT120_MASS
C 
C (No integration since shapes made with KEYS are by default 
C  normalized when created.)
C
      IF (HYP_MASS.GE.60D0 .AND. HYP_MASS.LE.65D0) THEN
         REFMH1 = 60D0
         REFMH2 = 65D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HAONLY_HTT60_MASS(REC_MASS-DELTA1/2.)
         F2 = A200_TT_HAONLY_HTT65_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.65D0 .AND. HYP_MASS.LE.70D0) THEN
         REFMH1 = 65D0
         REFMH2 = 70D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HAONLY_HTT65_MASS(REC_MASS-DELTA1/2.)
         F2 = A200_TT_HAONLY_HTT70_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.70D0 .AND. HYP_MASS.LE.75D0) THEN
         REFMH1 = 70D0
         REFMH2 = 75D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HAONLY_HTT70_MASS(REC_MASS-DELTA1/2.)
         F2 = A200_TT_HAONLY_HTT75_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.75D0 .AND. HYP_MASS.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HAONLY_HTT75_MASS(REC_MASS-DELTA1/2.)
         F2 = A200_TT_HAONLY_HTT80_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.80D0 .AND. HYP_MASS.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HAONLY_HTT80_MASS(REC_MASS-DELTA1/2.)
         F2 = A200_TT_HAONLY_HTT85_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.85D0 .AND. HYP_MASS.LE.90D0) THEN 
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HAONLY_HTT85_MASS(REC_MASS-DELTA1/2.)
         F2 = A200_TT_HAONLY_HTT90_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.90D0 .AND. HYP_MASS.LE.95D0) THEN 
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HAONLY_HTT90_MASS(REC_MASS-DELTA1/2.)
         F2 = A200_TT_HAONLY_HTT95_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.95D0 .AND. HYP_MASS.LE.100D0) THEN 
         REFMH1 = 95D0
         REFMH2 = 100D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HAONLY_HTT95_MASS(REC_MASS-DELTA1/2.)
         F2 = A200_TT_HAONLY_HTT100_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.100D0 .AND. HYP_MASS.LE.105D0) THEN 
         REFMH1 = 100D0
         REFMH2 = 105D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HAONLY_HTT100_MASS(REC_MASS-DELTA1/2.)
         F2 = A200_TT_HAONLY_HTT105_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.105D0 .AND. HYP_MASS.LE.107D0) THEN 
         REFMH1 = 105D0
         REFMH2 = 107D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HAONLY_HTT105_MASS(REC_MASS-DELTA1/2.)
         F2 = A200_TT_HAONLY_HTT107_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.107D0 .AND. HYP_MASS.LE.110D0) THEN 
         REFMH1 = 107D0
         REFMH2 = 110D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HAONLY_HTT107_MASS(REC_MASS-DELTA1/2.)
         F2 = A200_TT_HAONLY_HTT110_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.110D0 .AND. HYP_MASS.LE.115D0) THEN 
         REFMH1 = 110D0
         REFMH2 = 115D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HAONLY_HTT110_MASS(REC_MASS-DELTA1/2.)
         F2 = A200_TT_HAONLY_HTT115_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.115D0 .AND. HYP_MASS.LE.120D0) THEN 
         REFMH1 = 115D0
         REFMH2 = 120D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HAONLY_HTT115_MASS(REC_MASS-DELTA1/2.)
         F2 = A200_TT_HAONLY_HTT120_MASS(REC_MASS+DELTA2/2.)
      ELSE
         A200_TT_M_HAONLY_ONHTT = 0.D0
         RETURN
      ENDIF

      A200_TT_M_HAONLY_ONHTT = (DELTA2 * F1 + DELTA1 * F2)
     $     / (REFMH2 - REFMH1)
      IF (A200_TT_M_HAONLY_ONHTT.LT.1.D-05) THEN
         A200_TT_M_HAONLY_ONHTT = 1.D-05 
      ENDIF
      
      RETURN
      END

      DOUBLE PRECISION FUNCTION
     $     A200_TT_M_HZONLY_ONHTT(REC_MASS, HYP_MASS)
      IMPLICIT NONE
      DOUBLE PRECISION REC_MASS, HYP_MASS
      DOUBLE PRECISION DELTA1, DELTA2, REFMH1, REFMH2, F1, F2
      DOUBLE PRECISION
     $     A200_TT_HZONLY_HTT60_MASS, A200_TT_HZONLY_HTT65_MASS,
     $     A200_TT_HZONLY_HTT70_MASS, A200_TT_HZONLY_HTT75_MASS,
     $     A200_TT_HZONLY_HTT80_MASS, A200_TT_HZONLY_HTT85_MASS,
     $     A200_TT_HZONLY_HTT90_MASS, A200_TT_HZONLY_HTT95_MASS,
     $     A200_TT_HZONLY_HTT100_MASS, A200_TT_HZONLY_HTT105_MASS,
     $     A200_TT_HZONLY_HTT107_MASS, A200_TT_HZONLY_HTT110_MASS,
     $     A200_TT_HZONLY_HTT115_MASS, A200_TT_HZONLY_HTT120_MASS
C 
C (No integration since shapes made with KEYS are by default 
C  normalized when created.)
C
      IF (HYP_MASS.GE.60D0 .AND. HYP_MASS.LE.65D0) THEN
         REFMH1 = 60D0
         REFMH2 = 65D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HZONLY_HTT60_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_HZONLY_HTT65_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.65D0 .AND. HYP_MASS.LE.70D0) THEN
         REFMH1 = 65D0
         REFMH2 = 70D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HZONLY_HTT65_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_HZONLY_HTT70_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.70D0 .AND. HYP_MASS.LE.75D0) THEN
         REFMH1 = 70D0
         REFMH2 = 75D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HZONLY_HTT70_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_HZONLY_HTT75_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.75D0 .AND. HYP_MASS.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HZONLY_HTT75_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_HZONLY_HTT80_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.80D0 .AND. HYP_MASS.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HZONLY_HTT80_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_HZONLY_HTT85_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.85D0 .AND. HYP_MASS.LE.90D0) THEN 
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HZONLY_HTT85_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_HZONLY_HTT90_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.90D0 .AND. HYP_MASS.LE.95D0) THEN 
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HZONLY_HTT90_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_HZONLY_HTT95_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.95D0 .AND. HYP_MASS.LE.100D0) THEN 
         REFMH1 = 95D0
         REFMH2 = 100D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HZONLY_HTT95_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_HZONLY_HTT100_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.100D0 .AND. HYP_MASS.LE.105D0) THEN 
         REFMH1 = 100D0
         REFMH2 = 105D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HZONLY_HTT100_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_HZONLY_HTT105_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.105D0 .AND. HYP_MASS.LE.107D0) THEN 
         REFMH1 = 105D0
         REFMH2 = 107D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HZONLY_HTT105_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_HZONLY_HTT107_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.107D0 .AND. HYP_MASS.LE.110D0) THEN 
         REFMH1 = 107D0
         REFMH2 = 110D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HZONLY_HTT107_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_HZONLY_HTT110_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.110D0 .AND. HYP_MASS.LE.115D0) THEN 
         REFMH1 = 110D0
         REFMH2 = 115D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HZONLY_HTT110_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_HZONLY_HTT115_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.115D0 .AND. HYP_MASS.LE.120D0) THEN 
         REFMH1 = 115D0
         REFMH2 = 120D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HZONLY_HTT115_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_HZONLY_HTT120_MASS(REC_MASS+DELTA2)
      ELSE
         A200_TT_M_HZONLY_ONHTT = 0.D0
         RETURN
      ENDIF

      A200_TT_M_HZONLY_ONHTT = (DELTA2 * F1 + DELTA1 * F2)
     $     / (REFMH2 - REFMH1)
      IF (A200_TT_M_HZONLY_ONHTT.LT.1.D-05) THEN
         A200_TT_M_HZONLY_ONHTT = 1.D-05 
      ENDIF
      
      RETURN
      END

      DOUBLE PRECISION FUNCTION
     $     A200_TT_M_ASHA_ONHTT(REC_MASS, HYP_MASS)
      IMPLICIT NONE
      DOUBLE PRECISION REC_MASS, HYP_MASS
      DOUBLE PRECISION DELTA1, DELTA2, REFMH1, REFMH2, F1, F2
      DOUBLE PRECISION
     $     A200_TT_ASHA_HTT60_MASS, A200_TT_ASHA_HTT65_MASS,
     $     A200_TT_ASHA_HTT70_MASS, A200_TT_ASHA_HTT75_MASS,
     $     A200_TT_ASHA_HTT80_MASS, A200_TT_ASHA_HTT85_MASS,
     $     A200_TT_ASHA_HTT90_MASS, A200_TT_ASHA_HTT95_MASS,
     $     A200_TT_ASHA_HTT100_MASS, A200_TT_ASHA_HTT105_MASS,
     $     A200_TT_ASHA_HTT107_MASS, A200_TT_ASHA_HTT110_MASS,
     $     A200_TT_ASHA_HTT115_MASS, A200_TT_ASHA_HTT120_MASS
C 
C (No integration since shapes made with KEYS are by default 
C  normalized when created.)
C
      IF (HYP_MASS.GE.60D0 .AND. HYP_MASS.LE.65D0) THEN
         REFMH1 = 60D0
         REFMH2 = 65D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHA_HTT60_MASS(REC_MASS-DELTA1/2.)
         F2 = A200_TT_ASHA_HTT65_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.65D0 .AND. HYP_MASS.LE.70D0) THEN
         REFMH1 = 65D0
         REFMH2 = 70D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHA_HTT65_MASS(REC_MASS-DELTA1/2.)
         F2 = A200_TT_ASHA_HTT70_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.70D0 .AND. HYP_MASS.LE.75D0) THEN
         REFMH1 = 70D0
         REFMH2 = 75D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHA_HTT70_MASS(REC_MASS-DELTA1/2.)
         F2 = A200_TT_ASHA_HTT75_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.75D0 .AND. HYP_MASS.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHA_HTT75_MASS(REC_MASS-DELTA1/2.)
         F2 = A200_TT_ASHA_HTT80_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.80D0 .AND. HYP_MASS.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHA_HTT80_MASS(REC_MASS-DELTA1/2.)
         F2 = A200_TT_ASHA_HTT85_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.85D0 .AND. HYP_MASS.LE.90D0) THEN 
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHA_HTT85_MASS(REC_MASS-DELTA1/2.)
         F2 = A200_TT_ASHA_HTT90_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.90D0 .AND. HYP_MASS.LE.95D0) THEN 
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHA_HTT90_MASS(REC_MASS-DELTA1/2.)
         F2 = A200_TT_ASHA_HTT95_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.95D0 .AND. HYP_MASS.LE.100D0) THEN 
         REFMH1 = 95D0
         REFMH2 = 100D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHA_HTT95_MASS(REC_MASS-DELTA1/2.)
         F2 = A200_TT_ASHA_HTT100_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.100D0 .AND. HYP_MASS.LE.105D0) THEN 
         REFMH1 = 100D0
         REFMH2 = 105D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHA_HTT100_MASS(REC_MASS-DELTA1/2.)
         F2 = A200_TT_ASHA_HTT105_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.105D0 .AND. HYP_MASS.LE.107D0) THEN 
         REFMH1 = 105D0
         REFMH2 = 107D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHA_HTT105_MASS(REC_MASS-DELTA1/2.)
         F2 = A200_TT_ASHA_HTT107_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.107D0 .AND. HYP_MASS.LE.110D0) THEN 
         REFMH1 = 107D0
         REFMH2 = 110D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHA_HTT107_MASS(REC_MASS-DELTA1/2.)
         F2 = A200_TT_ASHA_HTT110_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.110D0 .AND. HYP_MASS.LE.115D0) THEN 
         REFMH1 = 110D0
         REFMH2 = 115D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHA_HTT110_MASS(REC_MASS-DELTA1/2.)
         F2 = A200_TT_ASHA_HTT115_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.115D0 .AND. HYP_MASS.LE.120D0) THEN 
         REFMH1 = 115D0
         REFMH2 = 120D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHA_HTT115_MASS(REC_MASS-DELTA1/2.)
         F2 = A200_TT_ASHA_HTT120_MASS(REC_MASS+DELTA2/2.)
      ELSE
         A200_TT_M_ASHA_ONHTT = 0.D0
         RETURN
      ENDIF

      A200_TT_M_ASHA_ONHTT = (DELTA2 * F1 + DELTA1 * F2)
     $     / (REFMH2 - REFMH1)
      IF (A200_TT_M_ASHA_ONHTT.LT.1.D-05) THEN
         A200_TT_M_ASHA_ONHTT = 1.D-05 
      ENDIF
      
      RETURN
      END

      DOUBLE PRECISION FUNCTION
     $     A200_TT_M_ASHZ_ONHTT(REC_MASS, HYP_MASS)
      IMPLICIT NONE
      DOUBLE PRECISION REC_MASS, HYP_MASS
      DOUBLE PRECISION DELTA1, DELTA2, REFMH1, REFMH2, F1, F2
      DOUBLE PRECISION
     $     A200_TT_ASHZ_HTT60_MASS, A200_TT_ASHZ_HTT65_MASS,
     $     A200_TT_ASHZ_HTT70_MASS, A200_TT_ASHZ_HTT75_MASS,
     $     A200_TT_ASHZ_HTT80_MASS, A200_TT_ASHZ_HTT85_MASS,
     $     A200_TT_ASHZ_HTT90_MASS, A200_TT_ASHZ_HTT95_MASS,
     $     A200_TT_ASHZ_HTT100_MASS, A200_TT_ASHZ_HTT105_MASS,
     $     A200_TT_ASHZ_HTT107_MASS, A200_TT_ASHZ_HTT110_MASS,
     $     A200_TT_ASHZ_HTT115_MASS, A200_TT_ASHZ_HTT120_MASS
C 
C (No integration since shapes made with KEYS are by default 
C  normalized when created.)
C
      IF (HYP_MASS.GE.60D0 .AND. HYP_MASS.LE.65D0) THEN
         REFMH1 = 60D0
         REFMH2 = 65D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHZ_HTT60_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_ASHZ_HTT65_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.65D0 .AND. HYP_MASS.LE.70D0) THEN
         REFMH1 = 65D0
         REFMH2 = 70D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHZ_HTT65_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_ASHZ_HTT70_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.70D0 .AND. HYP_MASS.LE.75D0) THEN
         REFMH1 = 70D0
         REFMH2 = 75D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHZ_HTT70_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_ASHZ_HTT75_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.75D0 .AND. HYP_MASS.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHZ_HTT75_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_ASHZ_HTT80_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.80D0 .AND. HYP_MASS.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHZ_HTT80_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_ASHZ_HTT85_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.85D0 .AND. HYP_MASS.LE.90D0) THEN 
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHZ_HTT85_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_ASHZ_HTT90_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.90D0 .AND. HYP_MASS.LE.95D0) THEN 
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHZ_HTT90_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_ASHZ_HTT95_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.95D0 .AND. HYP_MASS.LE.100D0) THEN 
         REFMH1 = 95D0
         REFMH2 = 100D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHZ_HTT95_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_ASHZ_HTT100_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.100D0 .AND. HYP_MASS.LE.105D0) THEN 
         REFMH1 = 100D0
         REFMH2 = 105D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHZ_HTT100_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_ASHZ_HTT105_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.105D0 .AND. HYP_MASS.LE.107D0) THEN 
         REFMH1 = 105D0
         REFMH2 = 107D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHZ_HTT105_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_ASHZ_HTT107_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.107D0 .AND. HYP_MASS.LE.110D0) THEN 
         REFMH1 = 107D0
         REFMH2 = 110D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHZ_HTT107_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_ASHZ_HTT110_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.110D0 .AND. HYP_MASS.LE.115D0) THEN 
         REFMH1 = 110D0
         REFMH2 = 115D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHZ_HTT110_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_ASHZ_HTT115_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.115D0 .AND. HYP_MASS.LE.120D0) THEN 
         REFMH1 = 115D0
         REFMH2 = 120D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHZ_HTT115_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_ASHZ_HTT120_MASS(REC_MASS+DELTA2)
      ELSE
         A200_TT_M_ASHZ_ONHTT = 0.D0
         RETURN
      ENDIF

      A200_TT_M_ASHZ_ONHTT = (DELTA2 * F1 + DELTA1 * F2)
     $     / (REFMH2 - REFMH1)
      IF (A200_TT_M_ASHZ_ONHTT.LT.1.D-05) THEN
         A200_TT_M_ASHZ_ONHTT = 1.D-05 
      ENDIF
      
      RETURN
      END

      DOUBLE PRECISION FUNCTION
     $     A200_TT_M_HAONLY_ONTTZ(REC_MASS, HYP_MASS)
      IMPLICIT NONE
      DOUBLE PRECISION REC_MASS, HYP_MASS
      DOUBLE PRECISION DELTA1, DELTA2, REFMH1, REFMH2, F1, F2
      DOUBLE PRECISION
     $     A200_TT_HAONLY_TTZ60_MASS, A200_TT_HAONLY_TTZ65_MASS,
     $     A200_TT_HAONLY_TTZ70_MASS, A200_TT_HAONLY_TTZ75_MASS,
     $     A200_TT_HAONLY_TTZ80_MASS, A200_TT_HAONLY_TTZ85_MASS,
     $     A200_TT_HAONLY_TTZ90_MASS, A200_TT_HAONLY_TTZ95_MASS,
     $     A200_TT_HAONLY_TTZ100_MASS, A200_TT_HAONLY_TTZ105_MASS,
     $     A200_TT_HAONLY_TTZ107_MASS, A200_TT_HAONLY_TTZ110_MASS,
     $     A200_TT_HAONLY_TTZ115_MASS, A200_TT_HAONLY_TTZ120_MASS
C 
C (No integration since shapes made with KEYS are by default 
C  normalized when created.)
C
      IF (HYP_MASS.GE.60D0 .AND. HYP_MASS.LE.65D0) THEN
         REFMH1 = 60D0
         REFMH2 = 65D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HAONLY_TTZ60_MASS(REC_MASS-DELTA1/2.)
         F2 = A200_TT_HAONLY_TTZ65_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.65D0 .AND. HYP_MASS.LE.70D0) THEN
         REFMH1 = 65D0
         REFMH2 = 70D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HAONLY_TTZ65_MASS(REC_MASS-DELTA1/2.)
         F2 = A200_TT_HAONLY_TTZ70_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.70D0 .AND. HYP_MASS.LE.75D0) THEN
         REFMH1 = 70D0
         REFMH2 = 75D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HAONLY_TTZ70_MASS(REC_MASS-DELTA1/2.)
         F2 = A200_TT_HAONLY_TTZ75_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.75D0 .AND. HYP_MASS.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HAONLY_TTZ75_MASS(REC_MASS-DELTA1/2.)
         F2 = A200_TT_HAONLY_TTZ80_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.80D0 .AND. HYP_MASS.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HAONLY_TTZ80_MASS(REC_MASS-DELTA1/2.)
         F2 = A200_TT_HAONLY_TTZ85_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.85D0 .AND. HYP_MASS.LE.90D0) THEN 
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HAONLY_TTZ85_MASS(REC_MASS-DELTA1/2.)
         F2 = A200_TT_HAONLY_TTZ90_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.90D0 .AND. HYP_MASS.LE.95D0) THEN 
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HAONLY_TTZ90_MASS(REC_MASS-DELTA1/2.)
         F2 = A200_TT_HAONLY_TTZ95_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.95D0 .AND. HYP_MASS.LE.100D0) THEN 
         REFMH1 = 95D0
         REFMH2 = 100D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HAONLY_TTZ95_MASS(REC_MASS-DELTA1/2.)
         F2 = A200_TT_HAONLY_TTZ100_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.100D0 .AND. HYP_MASS.LE.105D0) THEN 
         REFMH1 = 100D0
         REFMH2 = 105D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HAONLY_TTZ100_MASS(REC_MASS-DELTA1/2.)
         F2 = A200_TT_HAONLY_TTZ105_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.105D0 .AND. HYP_MASS.LE.107D0) THEN 
         REFMH1 = 105D0
         REFMH2 = 107D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HAONLY_TTZ105_MASS(REC_MASS-DELTA1/2.)
         F2 = A200_TT_HAONLY_TTZ107_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.107D0 .AND. HYP_MASS.LE.110D0) THEN 
         REFMH1 = 107D0
         REFMH2 = 110D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HAONLY_TTZ107_MASS(REC_MASS-DELTA1/2.)
         F2 = A200_TT_HAONLY_TTZ110_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.110D0 .AND. HYP_MASS.LE.115D0) THEN 
         REFMH1 = 110D0
         REFMH2 = 115D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HAONLY_TTZ110_MASS(REC_MASS-DELTA1/2.)
         F2 = A200_TT_HAONLY_TTZ115_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.115D0 .AND. HYP_MASS.LE.120D0) THEN 
         REFMH1 = 115D0
         REFMH2 = 120D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HAONLY_TTZ115_MASS(REC_MASS-DELTA1/2.)
         F2 = A200_TT_HAONLY_TTZ120_MASS(REC_MASS+DELTA2/2.)
      ELSE
         A200_TT_M_HAONLY_ONTTZ = 0.D0
         RETURN
      ENDIF

      A200_TT_M_HAONLY_ONTTZ = (DELTA2 * F1 + DELTA1 * F2)
     $     / (REFMH2 - REFMH1)
      IF (A200_TT_M_HAONLY_ONTTZ.LT.1.D-05) THEN
         A200_TT_M_HAONLY_ONTTZ = 1.D-05 
      ENDIF
      
      RETURN
      END

      DOUBLE PRECISION FUNCTION
     $     A200_TT_M_HZONLY_ONTTZ(REC_MASS, HYP_MASS)
      IMPLICIT NONE
      DOUBLE PRECISION REC_MASS, HYP_MASS
      DOUBLE PRECISION DELTA1, DELTA2, REFMH1, REFMH2, F1, F2
      DOUBLE PRECISION
     $     A200_TT_HZONLY_TTZ60_MASS, A200_TT_HZONLY_TTZ65_MASS,
     $     A200_TT_HZONLY_TTZ70_MASS, A200_TT_HZONLY_TTZ75_MASS,
     $     A200_TT_HZONLY_TTZ80_MASS, A200_TT_HZONLY_TTZ85_MASS,
     $     A200_TT_HZONLY_TTZ90_MASS, A200_TT_HZONLY_TTZ95_MASS,
     $     A200_TT_HZONLY_TTZ100_MASS, A200_TT_HZONLY_TTZ105_MASS,
     $     A200_TT_HZONLY_TTZ107_MASS, A200_TT_HZONLY_TTZ110_MASS,
     $     A200_TT_HZONLY_TTZ115_MASS, A200_TT_HZONLY_TTZ120_MASS
C 
C (No integration since shapes made with KEYS are by default 
C  normalized when created.)
C
      IF (HYP_MASS.GE.60D0 .AND. HYP_MASS.LE.65D0) THEN
         REFMH1 = 60D0
         REFMH2 = 65D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HZONLY_TTZ60_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_HZONLY_TTZ65_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.65D0 .AND. HYP_MASS.LE.70D0) THEN
         REFMH1 = 65D0
         REFMH2 = 70D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HZONLY_TTZ65_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_HZONLY_TTZ70_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.70D0 .AND. HYP_MASS.LE.75D0) THEN
         REFMH1 = 70D0
         REFMH2 = 75D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HZONLY_TTZ70_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_HZONLY_TTZ75_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.75D0 .AND. HYP_MASS.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HZONLY_TTZ75_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_HZONLY_TTZ80_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.80D0 .AND. HYP_MASS.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HZONLY_TTZ80_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_HZONLY_TTZ85_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.85D0 .AND. HYP_MASS.LE.90D0) THEN 
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HZONLY_TTZ85_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_HZONLY_TTZ90_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.90D0 .AND. HYP_MASS.LE.95D0) THEN 
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HZONLY_TTZ90_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_HZONLY_TTZ95_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.95D0 .AND. HYP_MASS.LE.100D0) THEN 
         REFMH1 = 95D0
         REFMH2 = 100D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HZONLY_TTZ95_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_HZONLY_TTZ100_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.100D0 .AND. HYP_MASS.LE.105D0) THEN 
         REFMH1 = 100D0
         REFMH2 = 105D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HZONLY_TTZ100_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_HZONLY_TTZ105_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.105D0 .AND. HYP_MASS.LE.107D0) THEN 
         REFMH1 = 105D0
         REFMH2 = 107D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HZONLY_TTZ105_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_HZONLY_TTZ107_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.107D0 .AND. HYP_MASS.LE.110D0) THEN 
         REFMH1 = 107D0
         REFMH2 = 110D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HZONLY_TTZ107_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_HZONLY_TTZ110_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.110D0 .AND. HYP_MASS.LE.115D0) THEN 
         REFMH1 = 110D0
         REFMH2 = 115D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HZONLY_TTZ110_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_HZONLY_TTZ115_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.115D0 .AND. HYP_MASS.LE.120D0) THEN 
         REFMH1 = 115D0
         REFMH2 = 120D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_HZONLY_TTZ115_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_HZONLY_TTZ120_MASS(REC_MASS+DELTA2)
      ELSE
         A200_TT_M_HZONLY_ONTTZ = 0.D0
         RETURN
      ENDIF

      A200_TT_M_HZONLY_ONTTZ = (DELTA2 * F1 + DELTA1 * F2)
     $     / (REFMH2 - REFMH1)
      IF (A200_TT_M_HZONLY_ONTTZ.LT.1.D-05) THEN
         A200_TT_M_HZONLY_ONTTZ = 1.D-05 
      ENDIF
      
      RETURN
      END

      DOUBLE PRECISION FUNCTION
     $     A200_TT_M_ASHA_ONTTZ(REC_MASS, HYP_MASS)
      IMPLICIT NONE
      DOUBLE PRECISION REC_MASS, HYP_MASS
      DOUBLE PRECISION DELTA1, DELTA2, REFMH1, REFMH2, F1, F2
      DOUBLE PRECISION
     $     A200_TT_ASHA_TTZ60_MASS, A200_TT_ASHA_TTZ65_MASS,
     $     A200_TT_ASHA_TTZ70_MASS, A200_TT_ASHA_TTZ75_MASS,
     $     A200_TT_ASHA_TTZ80_MASS, A200_TT_ASHA_TTZ85_MASS,
     $     A200_TT_ASHA_TTZ90_MASS, A200_TT_ASHA_TTZ95_MASS,
     $     A200_TT_ASHA_TTZ100_MASS, A200_TT_ASHA_TTZ105_MASS,
     $     A200_TT_ASHA_TTZ107_MASS, A200_TT_ASHA_TTZ110_MASS,
     $     A200_TT_ASHA_TTZ115_MASS, A200_TT_ASHA_TTZ120_MASS
C 
C (No integration since shapes made with KEYS are by default 
C  normalized when created.)
C
      IF (HYP_MASS.GE.60D0 .AND. HYP_MASS.LE.65D0) THEN
         REFMH1 = 60D0
         REFMH2 = 65D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHA_TTZ60_MASS(REC_MASS-DELTA1/2.)
         F2 = A200_TT_ASHA_TTZ65_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.65D0 .AND. HYP_MASS.LE.70D0) THEN
         REFMH1 = 65D0
         REFMH2 = 70D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHA_TTZ65_MASS(REC_MASS-DELTA1/2.)
         F2 = A200_TT_ASHA_TTZ70_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.70D0 .AND. HYP_MASS.LE.75D0) THEN
         REFMH1 = 70D0
         REFMH2 = 75D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHA_TTZ70_MASS(REC_MASS-DELTA1/2.)
         F2 = A200_TT_ASHA_TTZ75_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.75D0 .AND. HYP_MASS.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHA_TTZ75_MASS(REC_MASS-DELTA1/2.)
         F2 = A200_TT_ASHA_TTZ80_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.80D0 .AND. HYP_MASS.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHA_TTZ80_MASS(REC_MASS-DELTA1/2.)
         F2 = A200_TT_ASHA_TTZ85_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.85D0 .AND. HYP_MASS.LE.90D0) THEN 
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHA_TTZ85_MASS(REC_MASS-DELTA1/2.)
         F2 = A200_TT_ASHA_TTZ90_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.90D0 .AND. HYP_MASS.LE.95D0) THEN 
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHA_TTZ90_MASS(REC_MASS-DELTA1/2.)
         F2 = A200_TT_ASHA_TTZ95_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.95D0 .AND. HYP_MASS.LE.100D0) THEN 
         REFMH1 = 95D0
         REFMH2 = 100D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHA_TTZ95_MASS(REC_MASS-DELTA1/2.)
         F2 = A200_TT_ASHA_TTZ100_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.100D0 .AND. HYP_MASS.LE.105D0) THEN 
         REFMH1 = 100D0
         REFMH2 = 105D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHA_TTZ100_MASS(REC_MASS-DELTA1/2.)
         F2 = A200_TT_ASHA_TTZ105_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.105D0 .AND. HYP_MASS.LE.107D0) THEN 
         REFMH1 = 105D0
         REFMH2 = 107D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHA_TTZ105_MASS(REC_MASS-DELTA1/2.)
         F2 = A200_TT_ASHA_TTZ107_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.107D0 .AND. HYP_MASS.LE.110D0) THEN 
         REFMH1 = 107D0
         REFMH2 = 110D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHA_TTZ107_MASS(REC_MASS-DELTA1/2.)
         F2 = A200_TT_ASHA_TTZ110_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.110D0 .AND. HYP_MASS.LE.115D0) THEN 
         REFMH1 = 110D0
         REFMH2 = 115D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHA_TTZ110_MASS(REC_MASS-DELTA1/2.)
         F2 = A200_TT_ASHA_TTZ115_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.115D0 .AND. HYP_MASS.LE.120D0) THEN 
         REFMH1 = 115D0
         REFMH2 = 120D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHA_TTZ115_MASS(REC_MASS-DELTA1/2.)
         F2 = A200_TT_ASHA_TTZ120_MASS(REC_MASS+DELTA2/2.)
      ELSE
         A200_TT_M_ASHA_ONTTZ = 0.D0
         RETURN
      ENDIF

      A200_TT_M_ASHA_ONTTZ = (DELTA2 * F1 + DELTA1 * F2)
     $     / (REFMH2 - REFMH1)
      IF (A200_TT_M_ASHA_ONTTZ.LT.1.D-05) THEN
         A200_TT_M_ASHA_ONTTZ = 1.D-05 
      ENDIF
      
      RETURN
      END

      DOUBLE PRECISION FUNCTION
     $     A200_TT_M_ASHZ_ONTTZ(REC_MASS, HYP_MASS)
      IMPLICIT NONE
      DOUBLE PRECISION REC_MASS, HYP_MASS
      DOUBLE PRECISION DELTA1, DELTA2, REFMH1, REFMH2, F1, F2
      DOUBLE PRECISION
     $     A200_TT_ASHZ_TTZ60_MASS, A200_TT_ASHZ_TTZ65_MASS,
     $     A200_TT_ASHZ_TTZ70_MASS, A200_TT_ASHZ_TTZ75_MASS,
     $     A200_TT_ASHZ_TTZ80_MASS, A200_TT_ASHZ_TTZ85_MASS,
     $     A200_TT_ASHZ_TTZ90_MASS, A200_TT_ASHZ_TTZ95_MASS,
     $     A200_TT_ASHZ_TTZ100_MASS, A200_TT_ASHZ_TTZ105_MASS,
     $     A200_TT_ASHZ_TTZ107_MASS, A200_TT_ASHZ_TTZ110_MASS,
     $     A200_TT_ASHZ_TTZ115_MASS, A200_TT_ASHZ_TTZ120_MASS
C 
C (No integration since shapes made with KEYS are by default 
C  normalized when created.)
C
      IF (HYP_MASS.GE.60D0 .AND. HYP_MASS.LE.65D0) THEN
         REFMH1 = 60D0
         REFMH2 = 65D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHZ_TTZ60_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_ASHZ_TTZ65_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.65D0 .AND. HYP_MASS.LE.70D0) THEN
         REFMH1 = 65D0
         REFMH2 = 70D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHZ_TTZ65_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_ASHZ_TTZ70_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.70D0 .AND. HYP_MASS.LE.75D0) THEN
         REFMH1 = 70D0
         REFMH2 = 75D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHZ_TTZ70_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_ASHZ_TTZ75_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.75D0 .AND. HYP_MASS.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHZ_TTZ75_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_ASHZ_TTZ80_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.80D0 .AND. HYP_MASS.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHZ_TTZ80_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_ASHZ_TTZ85_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.85D0 .AND. HYP_MASS.LE.90D0) THEN 
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHZ_TTZ85_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_ASHZ_TTZ90_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.90D0 .AND. HYP_MASS.LE.95D0) THEN 
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHZ_TTZ90_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_ASHZ_TTZ95_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.95D0 .AND. HYP_MASS.LE.100D0) THEN 
         REFMH1 = 95D0
         REFMH2 = 100D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHZ_TTZ95_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_ASHZ_TTZ100_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.100D0 .AND. HYP_MASS.LE.105D0) THEN 
         REFMH1 = 100D0
         REFMH2 = 105D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHZ_TTZ100_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_ASHZ_TTZ105_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.105D0 .AND. HYP_MASS.LE.107D0) THEN 
         REFMH1 = 105D0
         REFMH2 = 107D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHZ_TTZ105_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_ASHZ_TTZ107_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.107D0 .AND. HYP_MASS.LE.110D0) THEN 
         REFMH1 = 107D0
         REFMH2 = 110D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHZ_TTZ107_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_ASHZ_TTZ110_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.110D0 .AND. HYP_MASS.LE.115D0) THEN 
         REFMH1 = 110D0
         REFMH2 = 115D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHZ_TTZ110_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_ASHZ_TTZ115_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.115D0 .AND. HYP_MASS.LE.120D0) THEN 
         REFMH1 = 115D0
         REFMH2 = 120D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A200_TT_ASHZ_TTZ115_MASS(REC_MASS-DELTA1)
         F2 = A200_TT_ASHZ_TTZ120_MASS(REC_MASS+DELTA2)
      ELSE
         A200_TT_M_ASHZ_ONTTZ = 0.D0
         RETURN
      ENDIF

      A200_TT_M_ASHZ_ONTTZ = (DELTA2 * F1 + DELTA1 * F2)
     $     / (REFMH2 - REFMH1)
      IF (A200_TT_M_ASHZ_ONTTZ.LT.1.D-05) THEN
         A200_TT_M_ASHZ_ONTTZ = 1.D-05 
      ENDIF
      
      RETURN
      END

C 
C---- New file --- 
C 
      DOUBLE PRECISION FUNCTION A202_TT_SIG_MASS(REC_MASS,
     $     HYP_MASS, IANA, ISIG)
      IMPLICIT NONE
      DOUBLE PRECISION REC_MASS, HYP_MASS
      INTEGER IANA, ISIG
      DOUBLE PRECISION A202_TT_M_HAONLY_ONHTT, A202_TT_M_HZONLY_ONHTT,
     $     A202_TT_M_ASHA_ONHTT, A202_TT_M_ASHZ_ONHTT
      DOUBLE PRECISION A202_TT_M_HAONLY_ONHA, A202_TT_M_HZONLY_ONHA,
     $     A202_TT_M_ASHA_ONHA, A202_TT_M_ASHZ_ONHA
      DOUBLE PRECISION A202_TT_M_HAONLY_ONTTZ, A202_TT_M_HZONLY_ONTTZ,
     $     A202_TT_M_ASHA_ONTTZ, A202_TT_M_ASHZ_ONTTZ

C REC_MASS is the reconstructed mass 
C MASS_HYP is the Higgs mass hypothesis
C IANA defines the analysis branch
C  This index: 1=hAonly, 2=hZonly, 3=overlap (as hA), 4=overlap (as hZ)
C ISIG gives the signal 
C     1 to 4 =Htt
C     5      =ttZ,
C     6 to 9 =hA->ttX

      IF (ISIG.GE.1 .AND. ISIG.LE.4) THEN
         IF (IANA.EQ.1) THEN
            A202_TT_SIG_MASS = A202_TT_M_HAONLY_ONHTT(REC_MASS,HYP_MASS)
         ELSE IF (IANA.EQ.2) THEN
            A202_TT_SIG_MASS = A202_TT_M_HZONLY_ONHTT(REC_MASS,HYP_MASS)
         ELSE IF (IANA.EQ.3) THEN
            A202_TT_SIG_MASS = A202_TT_M_ASHA_ONHTT(REC_MASS,HYP_MASS)
         ELSE IF (IANA.EQ.4) THEN
            A202_TT_SIG_MASS = A202_TT_M_ASHZ_ONHTT(REC_MASS,HYP_MASS)
         ENDIF
      ELSE IF (ISIG.EQ.5) THEN
         IF (IANA.EQ.1) THEN
            A202_TT_SIG_MASS = A202_TT_M_HAONLY_ONTTZ(REC_MASS,HYP_MASS)
         ELSE IF (IANA.EQ.2) THEN
            A202_TT_SIG_MASS = A202_TT_M_HZONLY_ONTTZ(REC_MASS,HYP_MASS)
         ELSE IF (IANA.EQ.3) THEN
            A202_TT_SIG_MASS = A202_TT_M_ASHA_ONTTZ(REC_MASS,HYP_MASS)
         ELSE IF (IANA.EQ.4) THEN
            A202_TT_SIG_MASS = A202_TT_M_ASHZ_ONTTZ(REC_MASS,HYP_MASS)
         ENDIF
      ELSE IF (ISIG.GE.6 .AND. ISIG.LE.9) THEN
         IF (IANA.EQ.1) THEN
            A202_TT_SIG_MASS = A202_TT_M_HAONLY_ONHA(REC_MASS,HYP_MASS)
         ELSE IF (IANA.EQ.2) THEN
            A202_TT_SIG_MASS = A202_TT_M_HZONLY_ONHA(REC_MASS,HYP_MASS)
         ELSE IF (IANA.EQ.3) THEN
            A202_TT_SIG_MASS = A202_TT_M_ASHA_ONHA(REC_MASS,HYP_MASS)
         ELSE IF (IANA.EQ.4) THEN
            A202_TT_SIG_MASS = A202_TT_M_ASHZ_ONHA(REC_MASS,HYP_MASS)
         ENDIF
      ENDIF
      RETURN
      END


      DOUBLE PRECISION FUNCTION
     $     A202_TT_M_HAONLY_ONHA(REC_MASS, HYP_MASS)
      IMPLICIT NONE
      DOUBLE PRECISION REC_MASS, HYP_MASS
      DOUBLE PRECISION DELTA1, DELTA2, REFMH1, REFMH2, F1, F2
      DOUBLE PRECISION
     $     A202_TT_HAONLY_HATT60_MASS, A202_TT_HAONLY_HATT65_MASS,
     $     A202_TT_HAONLY_HATT70_MASS, A202_TT_HAONLY_HATT75_MASS,
     $     A202_TT_HAONLY_HATT80_MASS, A202_TT_HAONLY_HATT85_MASS,
     $     A202_TT_HAONLY_HATT90_MASS, A202_TT_HAONLY_HATT95_MASS,
     $     A202_TT_HAONLY_HATT100_MASS, A202_TT_HAONLY_HATT105_MASS,
     $     A202_TT_HAONLY_HATT107_MASS, A202_TT_HAONLY_HATT110_MASS,
     $     A202_TT_HAONLY_HATT115_MASS, A202_TT_HAONLY_HATT120_MASS
C 
C (No integration since shapes made with KEYS are by default 
C  normalized when created.)
C
      IF (HYP_MASS.GE.60D0 .AND. HYP_MASS.LE.65D0) THEN
         REFMH1 = 60D0
         REFMH2 = 65D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HAONLY_HATT60_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_HAONLY_HATT65_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.65D0 .AND. HYP_MASS.LE.70D0) THEN
         REFMH1 = 65D0
         REFMH2 = 70D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HAONLY_HATT65_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_HAONLY_HATT70_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.70D0 .AND. HYP_MASS.LE.75D0) THEN
         REFMH1 = 70D0
         REFMH2 = 75D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HAONLY_HATT70_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_HAONLY_HATT75_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.75D0 .AND. HYP_MASS.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HAONLY_HATT75_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_HAONLY_HATT80_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.80D0 .AND. HYP_MASS.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HAONLY_HATT80_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_HAONLY_HATT85_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.85D0 .AND. HYP_MASS.LE.90D0) THEN 
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HAONLY_HATT85_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_HAONLY_HATT90_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.90D0 .AND. HYP_MASS.LE.95D0) THEN 
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HAONLY_HATT90_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_HAONLY_HATT95_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.95D0 .AND. HYP_MASS.LE.100D0) THEN 
         REFMH1 = 95D0
         REFMH2 = 100D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HAONLY_HATT95_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_HAONLY_HATT100_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.100D0 .AND. HYP_MASS.LE.105D0) THEN 
         REFMH1 = 100D0
         REFMH2 = 105D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HAONLY_HATT100_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_HAONLY_HATT105_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.105D0 .AND. HYP_MASS.LE.107D0) THEN 
         REFMH1 = 105D0
         REFMH2 = 107D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HAONLY_HATT105_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_HAONLY_HATT107_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.107D0 .AND. HYP_MASS.LE.110D0) THEN 
         REFMH1 = 107D0
         REFMH2 = 110D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HAONLY_HATT107_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_HAONLY_HATT110_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.110D0 .AND. HYP_MASS.LE.115D0) THEN 
         REFMH1 = 110D0
         REFMH2 = 115D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HAONLY_HATT110_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_HAONLY_HATT115_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.115D0 .AND. HYP_MASS.LE.120D0) THEN 
         REFMH1 = 115D0
         REFMH2 = 120D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HAONLY_HATT115_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_HAONLY_HATT120_MASS(REC_MASS+DELTA2)
      ELSE
         A202_TT_M_HAONLY_ONHA = 0.D0
         RETURN
      ENDIF

      A202_TT_M_HAONLY_ONHA = (DELTA2 * F1 + DELTA1 * F2)
     $     / (REFMH2 - REFMH1)
      IF (A202_TT_M_HAONLY_ONHA.LT.1.D-05) THEN
         A202_TT_M_HAONLY_ONHA = 1.D-05 
      ENDIF
      
      RETURN
      END

      DOUBLE PRECISION FUNCTION
     $     A202_TT_M_HZONLY_ONHA(REC_MASS, HYP_MASS)
      IMPLICIT NONE
      DOUBLE PRECISION REC_MASS, HYP_MASS
      DOUBLE PRECISION DELTA1, DELTA2, REFMH1, REFMH2, F1, F2
      DOUBLE PRECISION
     $     A202_TT_HZONLY_HATT60_MASS, A202_TT_HZONLY_HATT65_MASS,
     $     A202_TT_HZONLY_HATT70_MASS, A202_TT_HZONLY_HATT75_MASS,
     $     A202_TT_HZONLY_HATT80_MASS, A202_TT_HZONLY_HATT85_MASS,
     $     A202_TT_HZONLY_HATT90_MASS, A202_TT_HZONLY_HATT95_MASS,
     $     A202_TT_HZONLY_HATT100_MASS, A202_TT_HZONLY_HATT105_MASS,
     $     A202_TT_HZONLY_HATT107_MASS, A202_TT_HZONLY_HATT110_MASS,
     $     A202_TT_HZONLY_HATT115_MASS, A202_TT_HZONLY_HATT120_MASS
C 
C (No integration since shapes made with KEYS are by default 
C  normalized when created.)
C
      IF (HYP_MASS.GE.60D0 .AND. HYP_MASS.LE.65D0) THEN
         REFMH1 = 60D0
         REFMH2 = 65D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HZONLY_HATT60_MASS(REC_MASS-DELTA1*2.)
         F2 = A202_TT_HZONLY_HATT65_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.65D0 .AND. HYP_MASS.LE.70D0) THEN
         REFMH1 = 65D0
         REFMH2 = 70D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HZONLY_HATT65_MASS(REC_MASS-DELTA1*2.)
         F2 = A202_TT_HZONLY_HATT70_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.70D0 .AND. HYP_MASS.LE.75D0) THEN
         REFMH1 = 70D0
         REFMH2 = 75D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HZONLY_HATT70_MASS(REC_MASS-DELTA1*2.)
         F2 = A202_TT_HZONLY_HATT75_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.75D0 .AND. HYP_MASS.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HZONLY_HATT75_MASS(REC_MASS-DELTA1*2.)
         F2 = A202_TT_HZONLY_HATT80_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.80D0 .AND. HYP_MASS.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HZONLY_HATT80_MASS(REC_MASS-DELTA1*2.)
         F2 = A202_TT_HZONLY_HATT85_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.85D0 .AND. HYP_MASS.LE.90D0) THEN 
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HZONLY_HATT85_MASS(REC_MASS-DELTA1*2.)
         F2 = A202_TT_HZONLY_HATT90_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.90D0 .AND. HYP_MASS.LE.95D0) THEN 
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HZONLY_HATT90_MASS(REC_MASS-DELTA1*2.)
         F2 = A202_TT_HZONLY_HATT95_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.95D0 .AND. HYP_MASS.LE.100D0) THEN 
         REFMH1 = 95D0
         REFMH2 = 100D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HZONLY_HATT95_MASS(REC_MASS-DELTA1*2.)
         F2 = A202_TT_HZONLY_HATT100_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.100D0 .AND. HYP_MASS.LE.105D0) THEN 
         REFMH1 = 100D0
         REFMH2 = 105D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HZONLY_HATT100_MASS(REC_MASS-DELTA1*2.)
         F2 = A202_TT_HZONLY_HATT105_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.105D0 .AND. HYP_MASS.LE.107D0) THEN 
         REFMH1 = 105D0
         REFMH2 = 107D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HZONLY_HATT105_MASS(REC_MASS-DELTA1*2.)
         F2 = A202_TT_HZONLY_HATT107_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.107D0 .AND. HYP_MASS.LE.110D0) THEN 
         REFMH1 = 107D0
         REFMH2 = 110D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HZONLY_HATT107_MASS(REC_MASS-DELTA1*2.)
         F2 = A202_TT_HZONLY_HATT110_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.110D0 .AND. HYP_MASS.LE.115D0) THEN 
         REFMH1 = 110D0
         REFMH2 = 115D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HZONLY_HATT110_MASS(REC_MASS-DELTA1*2.)
         F2 = A202_TT_HZONLY_HATT115_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.115D0 .AND. HYP_MASS.LE.120D0) THEN 
         REFMH1 = 115D0
         REFMH2 = 120D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HZONLY_HATT115_MASS(REC_MASS-DELTA1*2.)
         F2 = A202_TT_HZONLY_HATT120_MASS(REC_MASS+DELTA2*2.)
      ELSE
         A202_TT_M_HZONLY_ONHA = 0.D0
         RETURN
      ENDIF

      A202_TT_M_HZONLY_ONHA = (DELTA2 * F1 + DELTA1 * F2)
     $     / (REFMH2 - REFMH1)
      IF (A202_TT_M_HZONLY_ONHA.LT.1.D-05) THEN
         A202_TT_M_HZONLY_ONHA = 1.D-05 
      ENDIF
      
      RETURN
      END

      DOUBLE PRECISION FUNCTION
     $     A202_TT_M_ASHA_ONHA(REC_MASS, HYP_MASS)
      IMPLICIT NONE
      DOUBLE PRECISION REC_MASS, HYP_MASS
      DOUBLE PRECISION DELTA1, DELTA2, REFMH1, REFMH2, F1, F2
      DOUBLE PRECISION
     $     A202_TT_ASHA_HATT60_MASS, A202_TT_ASHA_HATT65_MASS,
     $     A202_TT_ASHA_HATT70_MASS, A202_TT_ASHA_HATT75_MASS,
     $     A202_TT_ASHA_HATT80_MASS, A202_TT_ASHA_HATT85_MASS,
     $     A202_TT_ASHA_HATT90_MASS, A202_TT_ASHA_HATT95_MASS,
     $     A202_TT_ASHA_HATT100_MASS, A202_TT_ASHA_HATT105_MASS,
     $     A202_TT_ASHA_HATT107_MASS, A202_TT_ASHA_HATT110_MASS,
     $     A202_TT_ASHA_HATT115_MASS, A202_TT_ASHA_HATT120_MASS
C 
C (No integration since shapes made with KEYS are by default 
C  normalized when created.)
C
      IF (HYP_MASS.GE.60D0 .AND. HYP_MASS.LE.65D0) THEN
         REFMH1 = 60D0
         REFMH2 = 65D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHA_HATT60_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_ASHA_HATT65_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.65D0 .AND. HYP_MASS.LE.70D0) THEN
         REFMH1 = 65D0
         REFMH2 = 70D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHA_HATT65_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_ASHA_HATT70_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.70D0 .AND. HYP_MASS.LE.75D0) THEN
         REFMH1 = 70D0
         REFMH2 = 75D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHA_HATT70_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_ASHA_HATT75_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.75D0 .AND. HYP_MASS.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHA_HATT75_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_ASHA_HATT80_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.80D0 .AND. HYP_MASS.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHA_HATT80_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_ASHA_HATT85_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.85D0 .AND. HYP_MASS.LE.90D0) THEN 
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHA_HATT85_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_ASHA_HATT90_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.90D0 .AND. HYP_MASS.LE.95D0) THEN 
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHA_HATT90_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_ASHA_HATT95_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.95D0 .AND. HYP_MASS.LE.100D0) THEN 
         REFMH1 = 95D0
         REFMH2 = 100D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHA_HATT95_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_ASHA_HATT100_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.100D0 .AND. HYP_MASS.LE.105D0) THEN 
         REFMH1 = 100D0
         REFMH2 = 105D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHA_HATT100_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_ASHA_HATT105_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.105D0 .AND. HYP_MASS.LE.107D0) THEN 
         REFMH1 = 105D0
         REFMH2 = 107D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHA_HATT105_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_ASHA_HATT107_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.107D0 .AND. HYP_MASS.LE.110D0) THEN 
         REFMH1 = 107D0
         REFMH2 = 110D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHA_HATT107_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_ASHA_HATT110_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.110D0 .AND. HYP_MASS.LE.115D0) THEN 
         REFMH1 = 110D0
         REFMH2 = 115D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHA_HATT110_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_ASHA_HATT115_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.115D0 .AND. HYP_MASS.LE.120D0) THEN 
         REFMH1 = 115D0
         REFMH2 = 120D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHA_HATT115_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_ASHA_HATT120_MASS(REC_MASS+DELTA2)
      ELSE
         A202_TT_M_ASHA_ONHA = 0.D0
         RETURN
      ENDIF

      A202_TT_M_ASHA_ONHA = (DELTA2 * F1 + DELTA1 * F2)
     $     / (REFMH2 - REFMH1)
      IF (A202_TT_M_ASHA_ONHA.LT.1.D-05) THEN
         A202_TT_M_ASHA_ONHA = 1.D-05 
      ENDIF
      
      RETURN
      END

      DOUBLE PRECISION FUNCTION
     $     A202_TT_M_ASHZ_ONHA(REC_MASS, HYP_MASS)
      IMPLICIT NONE
      DOUBLE PRECISION REC_MASS, HYP_MASS
      DOUBLE PRECISION DELTA1, DELTA2, REFMH1, REFMH2, F1, F2
      DOUBLE PRECISION
     $     A202_TT_ASHZ_HATT60_MASS, A202_TT_ASHZ_HATT65_MASS,
     $     A202_TT_ASHZ_HATT70_MASS, A202_TT_ASHZ_HATT75_MASS,
     $     A202_TT_ASHZ_HATT80_MASS, A202_TT_ASHZ_HATT85_MASS,
     $     A202_TT_ASHZ_HATT90_MASS, A202_TT_ASHZ_HATT95_MASS,
     $     A202_TT_ASHZ_HATT100_MASS, A202_TT_ASHZ_HATT105_MASS,
     $     A202_TT_ASHZ_HATT107_MASS, A202_TT_ASHZ_HATT110_MASS,
     $     A202_TT_ASHZ_HATT115_MASS, A202_TT_ASHZ_HATT120_MASS
C 
C (No integration since shapes made with KEYS are by default 
C  normalized when created.)
C
      IF (HYP_MASS.GE.60D0 .AND. HYP_MASS.LE.65D0) THEN
         REFMH1 = 60D0
         REFMH2 = 65D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHZ_HATT60_MASS(REC_MASS-DELTA1*2.)
         F2 = A202_TT_ASHZ_HATT65_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.65D0 .AND. HYP_MASS.LE.70D0) THEN
         REFMH1 = 65D0
         REFMH2 = 70D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHZ_HATT65_MASS(REC_MASS-DELTA1*2.)
         F2 = A202_TT_ASHZ_HATT70_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.70D0 .AND. HYP_MASS.LE.75D0) THEN
         REFMH1 = 70D0
         REFMH2 = 75D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHZ_HATT70_MASS(REC_MASS-DELTA1*2.)
         F2 = A202_TT_ASHZ_HATT75_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.75D0 .AND. HYP_MASS.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHZ_HATT75_MASS(REC_MASS-DELTA1*2.)
         F2 = A202_TT_ASHZ_HATT80_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.80D0 .AND. HYP_MASS.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHZ_HATT80_MASS(REC_MASS-DELTA1*2.)
         F2 = A202_TT_ASHZ_HATT85_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.85D0 .AND. HYP_MASS.LE.90D0) THEN 
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHZ_HATT85_MASS(REC_MASS-DELTA1*2.)
         F2 = A202_TT_ASHZ_HATT90_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.90D0 .AND. HYP_MASS.LE.95D0) THEN 
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHZ_HATT90_MASS(REC_MASS-DELTA1*2.)
         F2 = A202_TT_ASHZ_HATT95_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.95D0 .AND. HYP_MASS.LE.100D0) THEN 
         REFMH1 = 95D0
         REFMH2 = 100D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHZ_HATT95_MASS(REC_MASS-DELTA1*2.)
         F2 = A202_TT_ASHZ_HATT100_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.100D0 .AND. HYP_MASS.LE.105D0) THEN 
         REFMH1 = 100D0
         REFMH2 = 105D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHZ_HATT100_MASS(REC_MASS-DELTA1*2.)
         F2 = A202_TT_ASHZ_HATT105_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.105D0 .AND. HYP_MASS.LE.107D0) THEN 
         REFMH1 = 105D0
         REFMH2 = 107D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHZ_HATT105_MASS(REC_MASS-DELTA1*2.)
         F2 = A202_TT_ASHZ_HATT107_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.107D0 .AND. HYP_MASS.LE.110D0) THEN 
         REFMH1 = 107D0
         REFMH2 = 110D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHZ_HATT107_MASS(REC_MASS-DELTA1*2.)
         F2 = A202_TT_ASHZ_HATT110_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.110D0 .AND. HYP_MASS.LE.115D0) THEN 
         REFMH1 = 110D0
         REFMH2 = 115D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHZ_HATT110_MASS(REC_MASS-DELTA1*2.)
         F2 = A202_TT_ASHZ_HATT115_MASS(REC_MASS+DELTA2*2.)
      ELSE IF (HYP_MASS.GT.115D0 .AND. HYP_MASS.LE.120D0) THEN 
         REFMH1 = 115D0
         REFMH2 = 120D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHZ_HATT115_MASS(REC_MASS-DELTA1*2.)
         F2 = A202_TT_ASHZ_HATT120_MASS(REC_MASS+DELTA2*2.)
      ELSE
         A202_TT_M_ASHZ_ONHA = 0.D0
         RETURN
      ENDIF

      A202_TT_M_ASHZ_ONHA = (DELTA2 * F1 + DELTA1 * F2)
     $     / (REFMH2 - REFMH1)
      IF (A202_TT_M_ASHZ_ONHA.LT.1.D-05) THEN
         A202_TT_M_ASHZ_ONHA = 1.D-05 
      ENDIF
      
      RETURN
      END

      DOUBLE PRECISION FUNCTION
     $     A202_TT_M_HAONLY_ONHTT(REC_MASS, HYP_MASS)
      IMPLICIT NONE
      DOUBLE PRECISION REC_MASS, HYP_MASS
      DOUBLE PRECISION DELTA1, DELTA2, REFMH1, REFMH2, F1, F2
      DOUBLE PRECISION
     $     A202_TT_HAONLY_HTT60_MASS, A202_TT_HAONLY_HTT65_MASS,
     $     A202_TT_HAONLY_HTT70_MASS, A202_TT_HAONLY_HTT75_MASS,
     $     A202_TT_HAONLY_HTT80_MASS, A202_TT_HAONLY_HTT85_MASS,
     $     A202_TT_HAONLY_HTT90_MASS, A202_TT_HAONLY_HTT95_MASS,
     $     A202_TT_HAONLY_HTT100_MASS, A202_TT_HAONLY_HTT105_MASS,
     $     A202_TT_HAONLY_HTT107_MASS, A202_TT_HAONLY_HTT110_MASS,
     $     A202_TT_HAONLY_HTT115_MASS, A202_TT_HAONLY_HTT120_MASS
C 
C (No integration since shapes made with KEYS are by default 
C  normalized when created.)
C
      IF (HYP_MASS.GE.60D0 .AND. HYP_MASS.LE.65D0) THEN
         REFMH1 = 60D0
         REFMH2 = 65D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HAONLY_HTT60_MASS(REC_MASS-DELTA1/2.)
         F2 = A202_TT_HAONLY_HTT65_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.65D0 .AND. HYP_MASS.LE.70D0) THEN
         REFMH1 = 65D0
         REFMH2 = 70D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HAONLY_HTT65_MASS(REC_MASS-DELTA1/2.)
         F2 = A202_TT_HAONLY_HTT70_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.70D0 .AND. HYP_MASS.LE.75D0) THEN
         REFMH1 = 70D0
         REFMH2 = 75D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HAONLY_HTT70_MASS(REC_MASS-DELTA1/2.)
         F2 = A202_TT_HAONLY_HTT75_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.75D0 .AND. HYP_MASS.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HAONLY_HTT75_MASS(REC_MASS-DELTA1/2.)
         F2 = A202_TT_HAONLY_HTT80_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.80D0 .AND. HYP_MASS.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HAONLY_HTT80_MASS(REC_MASS-DELTA1/2.)
         F2 = A202_TT_HAONLY_HTT85_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.85D0 .AND. HYP_MASS.LE.90D0) THEN 
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HAONLY_HTT85_MASS(REC_MASS-DELTA1/2.)
         F2 = A202_TT_HAONLY_HTT90_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.90D0 .AND. HYP_MASS.LE.95D0) THEN 
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HAONLY_HTT90_MASS(REC_MASS-DELTA1/2.)
         F2 = A202_TT_HAONLY_HTT95_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.95D0 .AND. HYP_MASS.LE.100D0) THEN 
         REFMH1 = 95D0
         REFMH2 = 100D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HAONLY_HTT95_MASS(REC_MASS-DELTA1/2.)
         F2 = A202_TT_HAONLY_HTT100_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.100D0 .AND. HYP_MASS.LE.105D0) THEN 
         REFMH1 = 100D0
         REFMH2 = 105D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HAONLY_HTT100_MASS(REC_MASS-DELTA1/2.)
         F2 = A202_TT_HAONLY_HTT105_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.105D0 .AND. HYP_MASS.LE.107D0) THEN 
         REFMH1 = 105D0
         REFMH2 = 107D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HAONLY_HTT105_MASS(REC_MASS-DELTA1/2.)
         F2 = A202_TT_HAONLY_HTT107_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.107D0 .AND. HYP_MASS.LE.110D0) THEN 
         REFMH1 = 107D0
         REFMH2 = 110D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HAONLY_HTT107_MASS(REC_MASS-DELTA1/2.)
         F2 = A202_TT_HAONLY_HTT110_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.110D0 .AND. HYP_MASS.LE.115D0) THEN 
         REFMH1 = 110D0
         REFMH2 = 115D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HAONLY_HTT110_MASS(REC_MASS-DELTA1/2.)
         F2 = A202_TT_HAONLY_HTT115_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.115D0 .AND. HYP_MASS.LE.120D0) THEN 
         REFMH1 = 115D0
         REFMH2 = 120D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HAONLY_HTT115_MASS(REC_MASS-DELTA1/2.)
         F2 = A202_TT_HAONLY_HTT120_MASS(REC_MASS+DELTA2/2.)
      ELSE
         A202_TT_M_HAONLY_ONHTT = 0.D0
         RETURN
      ENDIF

      A202_TT_M_HAONLY_ONHTT = (DELTA2 * F1 + DELTA1 * F2)
     $     / (REFMH2 - REFMH1)
      IF (A202_TT_M_HAONLY_ONHTT.LT.1.D-05) THEN
         A202_TT_M_HAONLY_ONHTT = 1.D-05 
      ENDIF
      
      RETURN
      END

      DOUBLE PRECISION FUNCTION
     $     A202_TT_M_HZONLY_ONHTT(REC_MASS, HYP_MASS)
      IMPLICIT NONE
      DOUBLE PRECISION REC_MASS, HYP_MASS
      DOUBLE PRECISION DELTA1, DELTA2, REFMH1, REFMH2, F1, F2
      DOUBLE PRECISION
     $     A202_TT_HZONLY_HTT60_MASS, A202_TT_HZONLY_HTT65_MASS,
     $     A202_TT_HZONLY_HTT70_MASS, A202_TT_HZONLY_HTT75_MASS,
     $     A202_TT_HZONLY_HTT80_MASS, A202_TT_HZONLY_HTT85_MASS,
     $     A202_TT_HZONLY_HTT90_MASS, A202_TT_HZONLY_HTT95_MASS,
     $     A202_TT_HZONLY_HTT100_MASS, A202_TT_HZONLY_HTT105_MASS,
     $     A202_TT_HZONLY_HTT107_MASS, A202_TT_HZONLY_HTT110_MASS,
     $     A202_TT_HZONLY_HTT115_MASS, A202_TT_HZONLY_HTT120_MASS
C 
C (No integration since shapes made with KEYS are by default 
C  normalized when created.)
C
      IF (HYP_MASS.GE.60D0 .AND. HYP_MASS.LE.65D0) THEN
         REFMH1 = 60D0
         REFMH2 = 65D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HZONLY_HTT60_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_HZONLY_HTT65_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.65D0 .AND. HYP_MASS.LE.70D0) THEN
         REFMH1 = 65D0
         REFMH2 = 70D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HZONLY_HTT65_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_HZONLY_HTT70_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.70D0 .AND. HYP_MASS.LE.75D0) THEN
         REFMH1 = 70D0
         REFMH2 = 75D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HZONLY_HTT70_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_HZONLY_HTT75_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.75D0 .AND. HYP_MASS.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HZONLY_HTT75_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_HZONLY_HTT80_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.80D0 .AND. HYP_MASS.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HZONLY_HTT80_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_HZONLY_HTT85_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.85D0 .AND. HYP_MASS.LE.90D0) THEN 
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HZONLY_HTT85_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_HZONLY_HTT90_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.90D0 .AND. HYP_MASS.LE.95D0) THEN 
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HZONLY_HTT90_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_HZONLY_HTT95_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.95D0 .AND. HYP_MASS.LE.100D0) THEN 
         REFMH1 = 95D0
         REFMH2 = 100D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HZONLY_HTT95_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_HZONLY_HTT100_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.100D0 .AND. HYP_MASS.LE.105D0) THEN 
         REFMH1 = 100D0
         REFMH2 = 105D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HZONLY_HTT100_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_HZONLY_HTT105_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.105D0 .AND. HYP_MASS.LE.107D0) THEN 
         REFMH1 = 105D0
         REFMH2 = 107D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HZONLY_HTT105_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_HZONLY_HTT107_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.107D0 .AND. HYP_MASS.LE.110D0) THEN 
         REFMH1 = 107D0
         REFMH2 = 110D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HZONLY_HTT107_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_HZONLY_HTT110_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.110D0 .AND. HYP_MASS.LE.115D0) THEN 
         REFMH1 = 110D0
         REFMH2 = 115D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HZONLY_HTT110_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_HZONLY_HTT115_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.115D0 .AND. HYP_MASS.LE.120D0) THEN 
         REFMH1 = 115D0
         REFMH2 = 120D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HZONLY_HTT115_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_HZONLY_HTT120_MASS(REC_MASS+DELTA2)
      ELSE
         A202_TT_M_HZONLY_ONHTT = 0.D0
         RETURN
      ENDIF

      A202_TT_M_HZONLY_ONHTT = (DELTA2 * F1 + DELTA1 * F2)
     $     / (REFMH2 - REFMH1)
      IF (A202_TT_M_HZONLY_ONHTT.LT.1.D-05) THEN
         A202_TT_M_HZONLY_ONHTT = 1.D-05 
      ENDIF
      
      RETURN
      END

      DOUBLE PRECISION FUNCTION
     $     A202_TT_M_ASHA_ONHTT(REC_MASS, HYP_MASS)
      IMPLICIT NONE
      DOUBLE PRECISION REC_MASS, HYP_MASS
      DOUBLE PRECISION DELTA1, DELTA2, REFMH1, REFMH2, F1, F2
      DOUBLE PRECISION
     $     A202_TT_ASHA_HTT60_MASS, A202_TT_ASHA_HTT65_MASS,
     $     A202_TT_ASHA_HTT70_MASS, A202_TT_ASHA_HTT75_MASS,
     $     A202_TT_ASHA_HTT80_MASS, A202_TT_ASHA_HTT85_MASS,
     $     A202_TT_ASHA_HTT90_MASS, A202_TT_ASHA_HTT95_MASS,
     $     A202_TT_ASHA_HTT100_MASS, A202_TT_ASHA_HTT105_MASS,
     $     A202_TT_ASHA_HTT107_MASS, A202_TT_ASHA_HTT110_MASS,
     $     A202_TT_ASHA_HTT115_MASS, A202_TT_ASHA_HTT120_MASS
C 
C (No integration since shapes made with KEYS are by default 
C  normalized when created.)
C
      IF (HYP_MASS.GE.60D0 .AND. HYP_MASS.LE.65D0) THEN
         REFMH1 = 60D0
         REFMH2 = 65D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHA_HTT60_MASS(REC_MASS-DELTA1/2.)
         F2 = A202_TT_ASHA_HTT65_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.65D0 .AND. HYP_MASS.LE.70D0) THEN
         REFMH1 = 65D0
         REFMH2 = 70D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHA_HTT65_MASS(REC_MASS-DELTA1/2.)
         F2 = A202_TT_ASHA_HTT70_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.70D0 .AND. HYP_MASS.LE.75D0) THEN
         REFMH1 = 70D0
         REFMH2 = 75D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHA_HTT70_MASS(REC_MASS-DELTA1/2.)
         F2 = A202_TT_ASHA_HTT75_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.75D0 .AND. HYP_MASS.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHA_HTT75_MASS(REC_MASS-DELTA1/2.)
         F2 = A202_TT_ASHA_HTT80_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.80D0 .AND. HYP_MASS.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHA_HTT80_MASS(REC_MASS-DELTA1/2.)
         F2 = A202_TT_ASHA_HTT85_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.85D0 .AND. HYP_MASS.LE.90D0) THEN 
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHA_HTT85_MASS(REC_MASS-DELTA1/2.)
         F2 = A202_TT_ASHA_HTT90_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.90D0 .AND. HYP_MASS.LE.95D0) THEN 
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHA_HTT90_MASS(REC_MASS-DELTA1/2.)
         F2 = A202_TT_ASHA_HTT95_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.95D0 .AND. HYP_MASS.LE.100D0) THEN 
         REFMH1 = 95D0
         REFMH2 = 100D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHA_HTT95_MASS(REC_MASS-DELTA1/2.)
         F2 = A202_TT_ASHA_HTT100_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.100D0 .AND. HYP_MASS.LE.105D0) THEN 
         REFMH1 = 100D0
         REFMH2 = 105D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHA_HTT100_MASS(REC_MASS-DELTA1/2.)
         F2 = A202_TT_ASHA_HTT105_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.105D0 .AND. HYP_MASS.LE.107D0) THEN 
         REFMH1 = 105D0
         REFMH2 = 107D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHA_HTT105_MASS(REC_MASS-DELTA1/2.)
         F2 = A202_TT_ASHA_HTT107_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.107D0 .AND. HYP_MASS.LE.110D0) THEN 
         REFMH1 = 107D0
         REFMH2 = 110D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHA_HTT107_MASS(REC_MASS-DELTA1/2.)
         F2 = A202_TT_ASHA_HTT110_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.110D0 .AND. HYP_MASS.LE.115D0) THEN 
         REFMH1 = 110D0
         REFMH2 = 115D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHA_HTT110_MASS(REC_MASS-DELTA1/2.)
         F2 = A202_TT_ASHA_HTT115_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.115D0 .AND. HYP_MASS.LE.120D0) THEN 
         REFMH1 = 115D0
         REFMH2 = 120D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHA_HTT115_MASS(REC_MASS-DELTA1/2.)
         F2 = A202_TT_ASHA_HTT120_MASS(REC_MASS+DELTA2/2.)
      ELSE
         A202_TT_M_ASHA_ONHTT = 0.D0
         RETURN
      ENDIF

      A202_TT_M_ASHA_ONHTT = (DELTA2 * F1 + DELTA1 * F2)
     $     / (REFMH2 - REFMH1)
      IF (A202_TT_M_ASHA_ONHTT.LT.1.D-05) THEN
         A202_TT_M_ASHA_ONHTT = 1.D-05 
      ENDIF
      
      RETURN
      END

      DOUBLE PRECISION FUNCTION
     $     A202_TT_M_ASHZ_ONHTT(REC_MASS, HYP_MASS)
      IMPLICIT NONE
      DOUBLE PRECISION REC_MASS, HYP_MASS
      DOUBLE PRECISION DELTA1, DELTA2, REFMH1, REFMH2, F1, F2
      DOUBLE PRECISION
     $     A202_TT_ASHZ_HTT60_MASS, A202_TT_ASHZ_HTT65_MASS,
     $     A202_TT_ASHZ_HTT70_MASS, A202_TT_ASHZ_HTT75_MASS,
     $     A202_TT_ASHZ_HTT80_MASS, A202_TT_ASHZ_HTT85_MASS,
     $     A202_TT_ASHZ_HTT90_MASS, A202_TT_ASHZ_HTT95_MASS,
     $     A202_TT_ASHZ_HTT100_MASS, A202_TT_ASHZ_HTT105_MASS,
     $     A202_TT_ASHZ_HTT107_MASS, A202_TT_ASHZ_HTT110_MASS,
     $     A202_TT_ASHZ_HTT115_MASS, A202_TT_ASHZ_HTT120_MASS
C 
C (No integration since shapes made with KEYS are by default 
C  normalized when created.)
C
      IF (HYP_MASS.GE.60D0 .AND. HYP_MASS.LE.65D0) THEN
         REFMH1 = 60D0
         REFMH2 = 65D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHZ_HTT60_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_ASHZ_HTT65_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.65D0 .AND. HYP_MASS.LE.70D0) THEN
         REFMH1 = 65D0
         REFMH2 = 70D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHZ_HTT65_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_ASHZ_HTT70_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.70D0 .AND. HYP_MASS.LE.75D0) THEN
         REFMH1 = 70D0
         REFMH2 = 75D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHZ_HTT70_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_ASHZ_HTT75_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.75D0 .AND. HYP_MASS.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHZ_HTT75_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_ASHZ_HTT80_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.80D0 .AND. HYP_MASS.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHZ_HTT80_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_ASHZ_HTT85_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.85D0 .AND. HYP_MASS.LE.90D0) THEN 
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHZ_HTT85_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_ASHZ_HTT90_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.90D0 .AND. HYP_MASS.LE.95D0) THEN 
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHZ_HTT90_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_ASHZ_HTT95_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.95D0 .AND. HYP_MASS.LE.100D0) THEN 
         REFMH1 = 95D0
         REFMH2 = 100D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHZ_HTT95_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_ASHZ_HTT100_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.100D0 .AND. HYP_MASS.LE.105D0) THEN 
         REFMH1 = 100D0
         REFMH2 = 105D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHZ_HTT100_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_ASHZ_HTT105_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.105D0 .AND. HYP_MASS.LE.107D0) THEN 
         REFMH1 = 105D0
         REFMH2 = 107D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHZ_HTT105_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_ASHZ_HTT107_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.107D0 .AND. HYP_MASS.LE.110D0) THEN 
         REFMH1 = 107D0
         REFMH2 = 110D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHZ_HTT107_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_ASHZ_HTT110_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.110D0 .AND. HYP_MASS.LE.115D0) THEN 
         REFMH1 = 110D0
         REFMH2 = 115D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHZ_HTT110_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_ASHZ_HTT115_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.115D0 .AND. HYP_MASS.LE.120D0) THEN 
         REFMH1 = 115D0
         REFMH2 = 120D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHZ_HTT115_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_ASHZ_HTT120_MASS(REC_MASS+DELTA2)
      ELSE
         A202_TT_M_ASHZ_ONHTT = 0.D0
         RETURN
      ENDIF

      A202_TT_M_ASHZ_ONHTT = (DELTA2 * F1 + DELTA1 * F2)
     $     / (REFMH2 - REFMH1)
      IF (A202_TT_M_ASHZ_ONHTT.LT.1.D-05) THEN
         A202_TT_M_ASHZ_ONHTT = 1.D-05 
      ENDIF
      
      RETURN
      END

      DOUBLE PRECISION FUNCTION
     $     A202_TT_M_HAONLY_ONTTZ(REC_MASS, HYP_MASS)
      IMPLICIT NONE
      DOUBLE PRECISION REC_MASS, HYP_MASS
      DOUBLE PRECISION DELTA1, DELTA2, REFMH1, REFMH2, F1, F2
      DOUBLE PRECISION
     $     A202_TT_HAONLY_TTZ60_MASS, A202_TT_HAONLY_TTZ65_MASS,
     $     A202_TT_HAONLY_TTZ70_MASS, A202_TT_HAONLY_TTZ75_MASS,
     $     A202_TT_HAONLY_TTZ80_MASS, A202_TT_HAONLY_TTZ85_MASS,
     $     A202_TT_HAONLY_TTZ90_MASS, A202_TT_HAONLY_TTZ95_MASS,
     $     A202_TT_HAONLY_TTZ100_MASS, A202_TT_HAONLY_TTZ105_MASS,
     $     A202_TT_HAONLY_TTZ107_MASS, A202_TT_HAONLY_TTZ110_MASS,
     $     A202_TT_HAONLY_TTZ115_MASS, A202_TT_HAONLY_TTZ120_MASS
C 
C (No integration since shapes made with KEYS are by default 
C  normalized when created.)
C
      IF (HYP_MASS.GE.60D0 .AND. HYP_MASS.LE.65D0) THEN
         REFMH1 = 60D0
         REFMH2 = 65D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HAONLY_TTZ60_MASS(REC_MASS-DELTA1/2.)
         F2 = A202_TT_HAONLY_TTZ65_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.65D0 .AND. HYP_MASS.LE.70D0) THEN
         REFMH1 = 65D0
         REFMH2 = 70D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HAONLY_TTZ65_MASS(REC_MASS-DELTA1/2.)
         F2 = A202_TT_HAONLY_TTZ70_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.70D0 .AND. HYP_MASS.LE.75D0) THEN
         REFMH1 = 70D0
         REFMH2 = 75D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HAONLY_TTZ70_MASS(REC_MASS-DELTA1/2.)
         F2 = A202_TT_HAONLY_TTZ75_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.75D0 .AND. HYP_MASS.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HAONLY_TTZ75_MASS(REC_MASS-DELTA1/2.)
         F2 = A202_TT_HAONLY_TTZ80_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.80D0 .AND. HYP_MASS.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HAONLY_TTZ80_MASS(REC_MASS-DELTA1/2.)
         F2 = A202_TT_HAONLY_TTZ85_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.85D0 .AND. HYP_MASS.LE.90D0) THEN 
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HAONLY_TTZ85_MASS(REC_MASS-DELTA1/2.)
         F2 = A202_TT_HAONLY_TTZ90_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.90D0 .AND. HYP_MASS.LE.95D0) THEN 
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HAONLY_TTZ90_MASS(REC_MASS-DELTA1/2.)
         F2 = A202_TT_HAONLY_TTZ95_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.95D0 .AND. HYP_MASS.LE.100D0) THEN 
         REFMH1 = 95D0
         REFMH2 = 100D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HAONLY_TTZ95_MASS(REC_MASS-DELTA1/2.)
         F2 = A202_TT_HAONLY_TTZ100_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.100D0 .AND. HYP_MASS.LE.105D0) THEN 
         REFMH1 = 100D0
         REFMH2 = 105D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HAONLY_TTZ100_MASS(REC_MASS-DELTA1/2.)
         F2 = A202_TT_HAONLY_TTZ105_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.105D0 .AND. HYP_MASS.LE.107D0) THEN 
         REFMH1 = 105D0
         REFMH2 = 107D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HAONLY_TTZ105_MASS(REC_MASS-DELTA1/2.)
         F2 = A202_TT_HAONLY_TTZ107_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.107D0 .AND. HYP_MASS.LE.110D0) THEN 
         REFMH1 = 107D0
         REFMH2 = 110D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HAONLY_TTZ107_MASS(REC_MASS-DELTA1/2.)
         F2 = A202_TT_HAONLY_TTZ110_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.110D0 .AND. HYP_MASS.LE.115D0) THEN 
         REFMH1 = 110D0
         REFMH2 = 115D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HAONLY_TTZ110_MASS(REC_MASS-DELTA1/2.)
         F2 = A202_TT_HAONLY_TTZ115_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.115D0 .AND. HYP_MASS.LE.120D0) THEN 
         REFMH1 = 115D0
         REFMH2 = 120D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HAONLY_TTZ115_MASS(REC_MASS-DELTA1/2.)
         F2 = A202_TT_HAONLY_TTZ120_MASS(REC_MASS+DELTA2/2.)
      ELSE
         A202_TT_M_HAONLY_ONTTZ = 0.D0
         RETURN
      ENDIF

      A202_TT_M_HAONLY_ONTTZ = (DELTA2 * F1 + DELTA1 * F2)
     $     / (REFMH2 - REFMH1)
      IF (A202_TT_M_HAONLY_ONTTZ.LT.1.D-05) THEN
         A202_TT_M_HAONLY_ONTTZ = 1.D-05 
      ENDIF
      
      RETURN
      END

      DOUBLE PRECISION FUNCTION
     $     A202_TT_M_HZONLY_ONTTZ(REC_MASS, HYP_MASS)
      IMPLICIT NONE
      DOUBLE PRECISION REC_MASS, HYP_MASS
      DOUBLE PRECISION DELTA1, DELTA2, REFMH1, REFMH2, F1, F2
      DOUBLE PRECISION
     $     A202_TT_HZONLY_TTZ60_MASS, A202_TT_HZONLY_TTZ65_MASS,
     $     A202_TT_HZONLY_TTZ70_MASS, A202_TT_HZONLY_TTZ75_MASS,
     $     A202_TT_HZONLY_TTZ80_MASS, A202_TT_HZONLY_TTZ85_MASS,
     $     A202_TT_HZONLY_TTZ90_MASS, A202_TT_HZONLY_TTZ95_MASS,
     $     A202_TT_HZONLY_TTZ100_MASS, A202_TT_HZONLY_TTZ105_MASS,
     $     A202_TT_HZONLY_TTZ107_MASS, A202_TT_HZONLY_TTZ110_MASS,
     $     A202_TT_HZONLY_TTZ115_MASS, A202_TT_HZONLY_TTZ120_MASS
C 
C (No integration since shapes made with KEYS are by default 
C  normalized when created.)
C
      IF (HYP_MASS.GE.60D0 .AND. HYP_MASS.LE.65D0) THEN
         REFMH1 = 60D0
         REFMH2 = 65D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HZONLY_TTZ60_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_HZONLY_TTZ65_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.65D0 .AND. HYP_MASS.LE.70D0) THEN
         REFMH1 = 65D0
         REFMH2 = 70D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HZONLY_TTZ65_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_HZONLY_TTZ70_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.70D0 .AND. HYP_MASS.LE.75D0) THEN
         REFMH1 = 70D0
         REFMH2 = 75D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HZONLY_TTZ70_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_HZONLY_TTZ75_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.75D0 .AND. HYP_MASS.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HZONLY_TTZ75_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_HZONLY_TTZ80_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.80D0 .AND. HYP_MASS.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HZONLY_TTZ80_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_HZONLY_TTZ85_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.85D0 .AND. HYP_MASS.LE.90D0) THEN 
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HZONLY_TTZ85_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_HZONLY_TTZ90_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.90D0 .AND. HYP_MASS.LE.95D0) THEN 
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HZONLY_TTZ90_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_HZONLY_TTZ95_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.95D0 .AND. HYP_MASS.LE.100D0) THEN 
         REFMH1 = 95D0
         REFMH2 = 100D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HZONLY_TTZ95_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_HZONLY_TTZ100_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.100D0 .AND. HYP_MASS.LE.105D0) THEN 
         REFMH1 = 100D0
         REFMH2 = 105D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HZONLY_TTZ100_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_HZONLY_TTZ105_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.105D0 .AND. HYP_MASS.LE.107D0) THEN 
         REFMH1 = 105D0
         REFMH2 = 107D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HZONLY_TTZ105_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_HZONLY_TTZ107_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.107D0 .AND. HYP_MASS.LE.110D0) THEN 
         REFMH1 = 107D0
         REFMH2 = 110D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HZONLY_TTZ107_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_HZONLY_TTZ110_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.110D0 .AND. HYP_MASS.LE.115D0) THEN 
         REFMH1 = 110D0
         REFMH2 = 115D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HZONLY_TTZ110_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_HZONLY_TTZ115_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.115D0 .AND. HYP_MASS.LE.120D0) THEN 
         REFMH1 = 115D0
         REFMH2 = 120D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_HZONLY_TTZ115_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_HZONLY_TTZ120_MASS(REC_MASS+DELTA2)
      ELSE
         A202_TT_M_HZONLY_ONTTZ = 0.D0
         RETURN
      ENDIF

      A202_TT_M_HZONLY_ONTTZ = (DELTA2 * F1 + DELTA1 * F2)
     $     / (REFMH2 - REFMH1)
      IF (A202_TT_M_HZONLY_ONTTZ.LT.1.D-05) THEN
         A202_TT_M_HZONLY_ONTTZ = 1.D-05 
      ENDIF
      
      RETURN
      END

      DOUBLE PRECISION FUNCTION
     $     A202_TT_M_ASHA_ONTTZ(REC_MASS, HYP_MASS)
      IMPLICIT NONE
      DOUBLE PRECISION REC_MASS, HYP_MASS
      DOUBLE PRECISION DELTA1, DELTA2, REFMH1, REFMH2, F1, F2
      DOUBLE PRECISION
     $     A202_TT_ASHA_TTZ60_MASS, A202_TT_ASHA_TTZ65_MASS,
     $     A202_TT_ASHA_TTZ70_MASS, A202_TT_ASHA_TTZ75_MASS,
     $     A202_TT_ASHA_TTZ80_MASS, A202_TT_ASHA_TTZ85_MASS,
     $     A202_TT_ASHA_TTZ90_MASS, A202_TT_ASHA_TTZ95_MASS,
     $     A202_TT_ASHA_TTZ100_MASS, A202_TT_ASHA_TTZ105_MASS,
     $     A202_TT_ASHA_TTZ107_MASS, A202_TT_ASHA_TTZ110_MASS,
     $     A202_TT_ASHA_TTZ115_MASS, A202_TT_ASHA_TTZ120_MASS
C 
C (No integration since shapes made with KEYS are by default 
C  normalized when created.)
C
      IF (HYP_MASS.GE.60D0 .AND. HYP_MASS.LE.65D0) THEN
         REFMH1 = 60D0
         REFMH2 = 65D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHA_TTZ60_MASS(REC_MASS-DELTA1/2.)
         F2 = A202_TT_ASHA_TTZ65_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.65D0 .AND. HYP_MASS.LE.70D0) THEN
         REFMH1 = 65D0
         REFMH2 = 70D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHA_TTZ65_MASS(REC_MASS-DELTA1/2.)
         F2 = A202_TT_ASHA_TTZ70_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.70D0 .AND. HYP_MASS.LE.75D0) THEN
         REFMH1 = 70D0
         REFMH2 = 75D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHA_TTZ70_MASS(REC_MASS-DELTA1/2.)
         F2 = A202_TT_ASHA_TTZ75_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.75D0 .AND. HYP_MASS.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHA_TTZ75_MASS(REC_MASS-DELTA1/2.)
         F2 = A202_TT_ASHA_TTZ80_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.80D0 .AND. HYP_MASS.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHA_TTZ80_MASS(REC_MASS-DELTA1/2.)
         F2 = A202_TT_ASHA_TTZ85_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.85D0 .AND. HYP_MASS.LE.90D0) THEN 
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHA_TTZ85_MASS(REC_MASS-DELTA1/2.)
         F2 = A202_TT_ASHA_TTZ90_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.90D0 .AND. HYP_MASS.LE.95D0) THEN 
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHA_TTZ90_MASS(REC_MASS-DELTA1/2.)
         F2 = A202_TT_ASHA_TTZ95_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.95D0 .AND. HYP_MASS.LE.100D0) THEN 
         REFMH1 = 95D0
         REFMH2 = 100D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHA_TTZ95_MASS(REC_MASS-DELTA1/2.)
         F2 = A202_TT_ASHA_TTZ100_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.100D0 .AND. HYP_MASS.LE.105D0) THEN 
         REFMH1 = 100D0
         REFMH2 = 105D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHA_TTZ100_MASS(REC_MASS-DELTA1/2.)
         F2 = A202_TT_ASHA_TTZ105_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.105D0 .AND. HYP_MASS.LE.107D0) THEN 
         REFMH1 = 105D0
         REFMH2 = 107D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHA_TTZ105_MASS(REC_MASS-DELTA1/2.)
         F2 = A202_TT_ASHA_TTZ107_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.107D0 .AND. HYP_MASS.LE.110D0) THEN 
         REFMH1 = 107D0
         REFMH2 = 110D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHA_TTZ107_MASS(REC_MASS-DELTA1/2.)
         F2 = A202_TT_ASHA_TTZ110_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.110D0 .AND. HYP_MASS.LE.115D0) THEN 
         REFMH1 = 110D0
         REFMH2 = 115D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHA_TTZ110_MASS(REC_MASS-DELTA1/2.)
         F2 = A202_TT_ASHA_TTZ115_MASS(REC_MASS+DELTA2/2.)
      ELSE IF (HYP_MASS.GT.115D0 .AND. HYP_MASS.LE.120D0) THEN 
         REFMH1 = 115D0
         REFMH2 = 120D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHA_TTZ115_MASS(REC_MASS-DELTA1/2.)
         F2 = A202_TT_ASHA_TTZ120_MASS(REC_MASS+DELTA2/2.)
      ELSE
         A202_TT_M_ASHA_ONTTZ = 0.D0
         RETURN
      ENDIF

      A202_TT_M_ASHA_ONTTZ = (DELTA2 * F1 + DELTA1 * F2)
     $     / (REFMH2 - REFMH1)
      IF (A202_TT_M_ASHA_ONTTZ.LT.1.D-05) THEN
         A202_TT_M_ASHA_ONTTZ = 1.D-05 
      ENDIF
      
      RETURN
      END

      DOUBLE PRECISION FUNCTION
     $     A202_TT_M_ASHZ_ONTTZ(REC_MASS, HYP_MASS)
      IMPLICIT NONE
      DOUBLE PRECISION REC_MASS, HYP_MASS
      DOUBLE PRECISION DELTA1, DELTA2, REFMH1, REFMH2, F1, F2
      DOUBLE PRECISION
     $     A202_TT_ASHZ_TTZ60_MASS, A202_TT_ASHZ_TTZ65_MASS,
     $     A202_TT_ASHZ_TTZ70_MASS, A202_TT_ASHZ_TTZ75_MASS,
     $     A202_TT_ASHZ_TTZ80_MASS, A202_TT_ASHZ_TTZ85_MASS,
     $     A202_TT_ASHZ_TTZ90_MASS, A202_TT_ASHZ_TTZ95_MASS,
     $     A202_TT_ASHZ_TTZ100_MASS, A202_TT_ASHZ_TTZ105_MASS,
     $     A202_TT_ASHZ_TTZ107_MASS, A202_TT_ASHZ_TTZ110_MASS,
     $     A202_TT_ASHZ_TTZ115_MASS, A202_TT_ASHZ_TTZ120_MASS
C 
C (No integration since shapes made with KEYS are by default 
C  normalized when created.)
C
      IF (HYP_MASS.GE.60D0 .AND. HYP_MASS.LE.65D0) THEN
         REFMH1 = 60D0
         REFMH2 = 65D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHZ_TTZ60_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_ASHZ_TTZ65_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.65D0 .AND. HYP_MASS.LE.70D0) THEN
         REFMH1 = 65D0
         REFMH2 = 70D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHZ_TTZ65_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_ASHZ_TTZ70_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.70D0 .AND. HYP_MASS.LE.75D0) THEN
         REFMH1 = 70D0
         REFMH2 = 75D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHZ_TTZ70_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_ASHZ_TTZ75_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.75D0 .AND. HYP_MASS.LE.80D0) THEN
         REFMH1 = 75D0
         REFMH2 = 80D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHZ_TTZ75_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_ASHZ_TTZ80_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.80D0 .AND. HYP_MASS.LE.85D0) THEN
         REFMH1 = 80D0
         REFMH2 = 85D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHZ_TTZ80_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_ASHZ_TTZ85_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.85D0 .AND. HYP_MASS.LE.90D0) THEN 
         REFMH1 = 85D0
         REFMH2 = 90D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHZ_TTZ85_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_ASHZ_TTZ90_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.90D0 .AND. HYP_MASS.LE.95D0) THEN 
         REFMH1 = 90D0
         REFMH2 = 95D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHZ_TTZ90_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_ASHZ_TTZ95_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.95D0 .AND. HYP_MASS.LE.100D0) THEN 
         REFMH1 = 95D0
         REFMH2 = 100D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHZ_TTZ95_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_ASHZ_TTZ100_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.100D0 .AND. HYP_MASS.LE.105D0) THEN 
         REFMH1 = 100D0
         REFMH2 = 105D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHZ_TTZ100_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_ASHZ_TTZ105_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.105D0 .AND. HYP_MASS.LE.107D0) THEN 
         REFMH1 = 105D0
         REFMH2 = 107D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHZ_TTZ105_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_ASHZ_TTZ107_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.107D0 .AND. HYP_MASS.LE.110D0) THEN 
         REFMH1 = 107D0
         REFMH2 = 110D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHZ_TTZ107_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_ASHZ_TTZ110_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.110D0 .AND. HYP_MASS.LE.115D0) THEN 
         REFMH1 = 110D0
         REFMH2 = 115D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHZ_TTZ110_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_ASHZ_TTZ115_MASS(REC_MASS+DELTA2)
      ELSE IF (HYP_MASS.GT.115D0 .AND. HYP_MASS.LE.120D0) THEN 
         REFMH1 = 115D0
         REFMH2 = 120D0
         DELTA1 = HYP_MASS - REFMH1
         DELTA2 = REFMH2 - HYP_MASS
         F1 = A202_TT_ASHZ_TTZ115_MASS(REC_MASS-DELTA1)
         F2 = A202_TT_ASHZ_TTZ120_MASS(REC_MASS+DELTA2)
      ELSE
         A202_TT_M_ASHZ_ONTTZ = 0.D0
         RETURN
      ENDIF

      A202_TT_M_ASHZ_ONTTZ = (DELTA2 * F1 + DELTA1 * F2)
     $     / (REFMH2 - REFMH1)
      IF (A202_TT_M_ASHZ_ONTTZ.LT.1.D-05) THEN
         A202_TT_M_ASHZ_ONTTZ = 1.D-05 
      ENDIF
      
      RETURN
      END

C-*-FORTRAN-*-
C
C This file was prepared by PTD on Sun Feb  6 20:06:49 MET 2000
C This file collects the following inputs:
C
C -rw-r--r--   1 ptd      xu        269464 Jan 24 17:42 taus/A192_tt_sig_mass_asha.F
C -rw-r--r--   1 ptd      xu        269464 Jan 24 17:42 taus/A192_tt_sig_mass_ashz.F
C -rw-r--r--   1 ptd      xu        269609 Jan 24 17:42 taus/A192_tt_sig_mass_haonly.F
C -rw-r--r--   1 ptd      xu        269709 Jan 24 17:42 taus/A192_tt_sig_mass_hzonly.F
C -rw-r--r--   1 ptd      xu        269493 Jan 24 22:09 taus/A196_tt_sig_mass_asha.F
C -rw-r--r--   1 ptd      xu        269493 Jan 24 22:10 taus/A196_tt_sig_mass_ashz.F
C -rw-r--r--   1 ptd      xu        269634 Jan 24 22:09 taus/A196_tt_sig_mass_haonly.F
C -rw-r--r--   1 ptd      xu        269697 Jan 24 22:09 taus/A196_tt_sig_mass_hzonly.F
C -rw-r--r--   1 ptd      xu        269453 Jan 24 22:14 taus/A200_tt_sig_mass_asha.F
C -rw-r--r--   1 ptd      xu        269453 Jan 24 22:15 taus/A200_tt_sig_mass_ashz.F
C -rw-r--r--   1 ptd      xu        269634 Jan 24 22:14 taus/A200_tt_sig_mass_haonly.F
C -rw-r--r--   1 ptd      xu        269687 Jan 24 22:14 taus/A200_tt_sig_mass_hzonly.F
C -rw-r--r--   1 ptd      xu        269468 Jan 24 22:22 taus/A202_tt_sig_mass_asha.F
C -rw-r--r--   1 ptd      xu        269468 Jan 24 22:22 taus/A202_tt_sig_mass_ashz.F
C -rw-r--r--   1 ptd      xu        269613 Jan 24 22:21 taus/A202_tt_sig_mass_haonly.F
C -rw-r--r--   1 ptd      xu        269682 Jan 24 22:21 taus/A202_tt_sig_mass_hzonly.F
C
C 
C---- New file --- 
C 
      DOUBLE PRECISION FUNCTION A192_tt_asha_hatt100_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  9.0241723E-04,   9.4006315E-04
     +,   9.7906811E-04,   1.0194354E-03,   1.0611645E-03
     +,   1.1042503E-03,   1.1486835E-03,   1.1944501E-03
     +,   1.2415305E-03,   1.2899030E-03,   1.3395387E-03
     +,   1.3904053E-03,   1.4424656E-03,   1.4956780E-03
     +,   1.5499973E-03,   1.6053742E-03,   1.6617561E-03
     +,   1.7190874E-03,   1.7773105E-03,   1.8363654E-03
     +,   1.8961923E-03,   1.9567299E-03,   2.0179183E-03
     +,   2.0797038E-03,   2.1420280E-03,   2.2048457E-03
     +,   2.2681148E-03,   2.3318019E-03,   2.3958858E-03
     +,   2.4603573E-03,   2.5252227E-03,   2.5905089E-03
     +,   2.6562624E-03,   2.7225558E-03,   2.7894895E-03
     +,   2.8571968E-03,   2.9258467E-03,   2.9956466E-03
     +,   3.0668548E-03,   3.1397697E-03,   3.2147516E-03
     +,   3.2922151E-03,   3.3726383E-03,   3.4565665E-03
     +,   3.5446188E-03,   3.6374885E-03,   3.7359486E-03
     +,   3.8408572E-03,   3.9531551E-03,   4.0738727E-03
     +,   4.2041265E-03,   4.3451227E-03,   4.4981502E-03
     +,   4.6645943E-03,   4.8458981E-03,   5.0436007E-03
     +,   5.2593104E-03,   5.4946966E-03,   5.7514957E-03
     +,   6.0315053E-03,   6.3365856E-03,   6.6686654E-03
     +,   7.0297206E-03,   7.4218377E-03,   7.8472011E-03
     +,   8.3080670E-03,   8.8068778E-03,   9.3461685E-03
     +,   9.9286968E-03,   1.0557315E-02,   1.1235119E-02
     +,   1.1965232E-02,   1.2750958E-02,   1.3595482E-02
     +,   1.4501949E-02,   1.5473257E-02,   1.6511807E-02
     +,   1.7619409E-02,   1.8797154E-02,   2.0045213E-02
     +,   2.1362603E-02,   2.2747383E-02,   2.4196388E-02
     +,   2.5705673E-02,   2.7270393E-02,   2.8885448E-02
     +,   3.0545600E-02,   3.2246210E-02,   3.3983499E-02
     +,   3.5755217E-02,   3.7561070E-02,   3.9402954E-02
     +,   4.1285213E-02,   4.3215048E-02,   4.5202147E-02
     +,   4.7258377E-02,   4.9397681E-02,   5.1634714E-02
     +,   5.3984530E-02,   5.6460463E-02,   5.9073217E-02
     +,   6.1828427E-02,   6.4725347E-02,   6.7754418E-02
     +,   7.0896178E-02,   7.4120775E-02,   7.7387393E-02
     +,   8.0646813E-02,   8.3844684E-02,   8.6927004E-02
     +,   8.9846887E-02,   9.2573673E-02,   9.5101655E-02
     +,   9.7458541E-02,   9.9711515E-02,   0.1019697    
     +,   0.1043803    ,   0.1071185    ,   0.1103677    
     +,   0.1142939    ,   0.1190129    ,   0.1245562    
     +,   0.1308452    ,   0.1376816    ,   0.1447635    
     +,   0.1517318    ,   0.1582466    ,   0.1640714    
     +,   0.1691489    ,   0.1736339    ,   0.1778709    
     +,   0.1823100    ,   0.1873908    ,   0.1934259    
     +,   0.2005339    ,   0.2086406    ,   0.2175500    
     +,   0.2270529    ,   0.2370316    ,   0.2475298    
     +,   0.2587743    ,   0.2711597    ,   0.2851866    
     +,   0.3013320    ,   0.3198320    ,   0.3404355    
     +,   0.3622750    ,   0.3839984    ,   0.4041635    
     +,   0.4216532    ,   0.4358510    ,   0.4466046    
     +,   0.4542351    ,   0.4597109    ,   0.4646923    
     +,   0.4710172    ,   0.4797085    ,   0.4901983    
     +,   0.5004502    ,   0.5079381    ,   0.5108059    
     +,   0.5086036    ,   0.5024683    ,   0.4947822    
     +,   0.4883756    ,   0.4855806    ,   0.4878085    
     +,   0.4959004    ,   0.5105094    ,   0.5314744    
     +,   0.5563716    ,   0.5798928    ,   0.5953774    
     +,   0.5979486    ,   0.5871385    ,   0.5671562    
     +,   0.5446367    ,   0.5253499    ,   0.5118250    
     +,   0.5030044    ,   0.4956070    ,   0.4860391    
     +,   0.4718050    ,   0.4520098    ,   0.4270782    
     +,   0.3980880    ,   0.3661782    ,   0.3323056    
     +,   0.2973049    ,   0.2619998    ,   0.2271909    
     +,   0.1935835    ,   0.1617568    ,   0.1322068    
     +,   0.1053973    ,   8.1755087E-02,   6.1599012E-02
     +,   4.5052186E-02,   3.1998102E-02,   2.2102784E-02
     +,   1.4885651E-02,   9.8068332E-03,   6.3446481E-03
     +,   4.0473812E-03,   2.5556167E-03,   1.6020202E-03
     +,   9.9870353E-04,   6.1932846E-04,   3.8163125E-04
     +,   2.3317107E-04,   1.4087958E-04,   8.3940118E-05
     +,   4.9197133E-05,   2.8302062E-05,   1.5954087E-05
     +,   8.8027355E-06,   4.7515969E-06,   2.5099373E-06
     +,   1.2994963E-06,   6.6204092E-07,   3.3456519E-07
     +,   1.7029882E-07,   8.9639364E-08,   5.0645387E-08
     +,   3.1864076E-08,   2.2645875E-08,   1.7858452E-08
     +,   1.5098868E-08,   1.3273080E-08,   1.1895477E-08
     +,   1.0754469E-08,   9.7582049E-09,   8.8656416E-09
     +,   8.0569018E-09,   7.3208573E-09,   6.6499015E-09
     +,   6.0380456E-09,   5.4802007E-09,   4.9717865E-09
     +,   4.5085948E-09,   4.0867731E-09,   3.7028187E-09
     +,   3.3534926E-09,   3.0358132E-09,   2.7470286E-09
     +,   2.4846378E-09,   2.2463442E-09,   2.0300275E-09
     +,   1.8337406E-09,   1.6557222E-09,   1.4943371E-09
     +,   1.3480953E-09,   1.2156388E-09,   1.0957256E-09
     +,   9.8721387E-10,   8.8905905E-10,   8.0031715E-10
     +,   7.2012357E-10,   6.4768513E-10,   5.8227911E-10
     +,   5.2325144E-10,   4.7000548E-10,   4.2199497E-10
     +,   3.7872311E-10,   3.3974260E-10,   3.0464223E-10
     +,   2.7304883E-10,   2.4462596E-10,   2.1906757E-10
     +,   1.9609439E-10,   1.7545396E-10,   1.5691794E-10
     +,   1.4027980E-10,   1.2535160E-10,   1.1196297E-10
     +,   9.9961574E-11,   8.9207398E-11,   7.9576117E-11
     +,   7.0953639E-11,   6.3238297E-11,   5.6337268E-11
     +,   5.0167679E-11,   4.4654242E-11,   3.9729733E-11
     +,   3.5332799E-11,   3.1408921E-11,   2.7908786E-11
     +,   2.4787838E-11,   2.2006392E-11,   1.9528532E-11
     +,   1.7322272E-11,   1.5358503E-11,   1.3611510E-11
     +,   1.2057952E-11,   1.0677144E-11,   9.4503077E-12
     +,   8.3608381E-12,   7.3937488E-12,   6.5357038E-12
     +,   5.7747097E-12,   5.1001187E-12
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_asha_hatt100_mass = Yx/7.04652306521739
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_asha_hatt105_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.9030175E-04,   5.0678785E-04
     +,   5.2525231E-04,   5.4591853E-04,   5.6902569E-04
     +,   5.9482787E-04,   6.2359462E-04,   6.5560924E-04
     +,   6.9116749E-04,   7.3057815E-04,   7.7415857E-04
     +,   8.2223432E-04,   8.7513513E-04,   9.3319319E-04
     +,   9.9673960E-04,   1.0660996E-03,   1.1415904E-03
     +,   1.2235146E-03,   1.3121564E-03,   1.4077767E-03
     +,   1.5106074E-03,   1.6208462E-03,   1.7386494E-03
     +,   1.8641353E-03,   1.9973579E-03,   2.1383304E-03
     +,   2.2869965E-03,   2.4432368E-03,   2.6068641E-03
     +,   2.7776184E-03,   2.9551650E-03,   3.1390954E-03
     +,   3.3289231E-03,   3.5240871E-03,   3.7239506E-03
     +,   3.9278069E-03,   4.1348841E-03,   4.3443432E-03
     +,   4.5553050E-03,   4.7668191E-03,   4.9779247E-03
     +,   5.1876148E-03,   5.3948751E-03,   5.5986852E-03
     +,   5.7980344E-03,   5.9919357E-03,   6.1794431E-03
     +,   6.3596601E-03,   6.5317652E-03,   6.6950154E-03
     +,   6.8487730E-03,   6.9925212E-03,   7.1258731E-03
     +,   7.2486056E-03,   7.3606512E-03,   7.4621420E-03
     +,   7.5534214E-03,   7.6350532E-03,   7.7078491E-03
     +,   7.7728895E-03,   7.8315418E-03,   7.8854850E-03
     +,   7.9367179E-03,   7.9875970E-03,   8.0408463E-03
     +,   8.0995681E-03,   8.1672706E-03,   8.2478775E-03
     +,   8.3457381E-03,   8.4656188E-03,   8.6127352E-03
     +,   8.7926816E-03,   9.0114772E-03,   9.2754643E-03
     +,   9.5913000E-03,   9.9658594E-03,   1.0406109E-02
     +,   1.0918997E-02,   1.1511319E-02,   1.2189516E-02
     +,   1.2959381E-02,   1.3825979E-02,   1.4793208E-02
     +,   1.5863750E-02,   1.7038601E-02,   1.8317100E-02
     +,   1.9696459E-02,   2.1171926E-02,   2.2736395E-02
     +,   2.4380742E-02,   2.6093746E-02,   2.7862228E-02
     +,   2.9671457E-02,   3.1505700E-02,   3.3348665E-02
     +,   3.5184018E-02,   3.6996584E-02,   3.8772777E-02
     +,   4.0501982E-02,   4.2177044E-02,   4.3795478E-02
     +,   4.5359664E-02,   4.6877533E-02,   4.8361946E-02
     +,   4.9830273E-02,   5.1302955E-02,   5.2801628E-02
     +,   5.4346990E-02,   5.5956963E-02,   5.7644721E-02
     +,   5.9417747E-02,   6.1278488E-02,   6.3225634E-02
     +,   6.5257005E-02,   6.7372747E-02,   6.9578648E-02
     +,   7.1887255E-02,   7.4318200E-02,   7.6894656E-02
     +,   7.9639040E-02,   8.2567044E-02,   8.5682794E-02
     +,   8.8976949E-02,   9.2428826E-02,   9.6012279E-02
     +,   9.9703684E-02,   0.1034912    ,   0.1073791    
     +,   0.1113898    ,   0.1155587    ,   0.1199315    
     +,   0.1245615    ,   0.1295181    ,   0.1348960    
     +,   0.1408255    ,   0.1474666    ,   0.1549787    
     +,   0.1634703    ,   0.1729423    ,   0.1832476    
     +,   0.1940898    ,   0.2050575    ,   0.2156816    
     +,   0.2254844    ,   0.2340231    ,   0.2409497    
     +,   0.2461090    ,   0.2496661    ,   0.2521940    
     +,   0.2546199    ,   0.2579709    ,   0.2629816    
     +,   0.2697357    ,   0.2775627    ,   0.2853066    
     +,   0.2918861    ,   0.2968712    ,   0.3007608    
     +,   0.3048125    ,   0.3105416    ,   0.3191861    
     +,   0.3313624    ,   0.3469350    ,   0.3649818    
     +,   0.3838236    ,   0.4012189    ,   0.4148177    
     +,   0.4227306    ,   0.4239373    ,   0.4184170    
     +,   0.4071566    ,   0.3921791    ,   0.3763983    
     +,   0.3629741    ,   0.3542084    ,   0.3505656    
     +,   0.3505288    ,   0.3513734    ,   0.3503083    
     +,   0.3452755    ,   0.3351524    ,   0.3196004    
     +,   0.2988985    ,   0.2738861    ,   0.2459159    
     +,   0.2166763    ,   0.1878760    ,   0.1609031    
     +,   0.1366076    ,   0.1152735    ,   9.6753195E-02
     +,   8.0687150E-02,   6.6699661E-02,   5.4508585E-02
     +,   4.3944526E-02,   3.4912784E-02,   2.7338495E-02
     +,   2.1124769E-02,   1.6137540E-02,   1.2212653E-02
     +,   9.1734342E-03,   6.8484321E-03,   5.0845337E-03
     +,   3.7535946E-03,   2.7532836E-03,   2.0041512E-03
     +,   1.4456376E-03,   1.0318176E-03,   7.2772132E-04
     +,   5.0653145E-04,   3.4758434E-04,   2.3493193E-04
     +,   1.5629001E-04,   1.0227044E-04,   6.5790933E-05
     +,   4.1591211E-05,   2.5829948E-05,   1.5755590E-05
     +,   9.4384086E-06,   5.5538198E-06,   3.2114995E-06
     +,   1.8267169E-06,   1.0240343E-06,   5.6773501E-07
     +,   3.1318075E-07,   1.7366357E-07,   9.8378855E-08
     +,   5.8221787E-08,   3.6893130E-08,   2.5470985E-08
     +,   1.9178641E-08,   1.5512921E-08,   1.3188991E-08
     +,   1.1560117E-08,   1.0305940E-08,   9.2691916E-09
     +,   8.3725062E-09,   7.5770181E-09,   6.8619843E-09
     +,   6.2151804E-09,   5.6284311E-09,   5.0955982E-09
     +,   4.6116102E-09,   4.1720303E-09,   3.7728842E-09
     +,   3.4105967E-09,   3.0819014E-09,   2.7837979E-09
     +,   2.5135367E-09,   2.2686359E-09,   2.0467998E-09
     +,   1.8459317E-09,   1.6641299E-09,   1.4996580E-09
     +,   1.3509184E-09,   1.2164572E-09,   1.0949573E-09
     +,   9.8521769E-10,   8.8613550E-10,   7.9670948E-10
     +,   7.1603395E-10,   6.4328315E-10,   5.7770383E-10
     +,   5.1861004E-10,   4.6538520E-10,   4.1746459E-10
     +,   3.7433423E-10,   3.3553277E-10,   3.0064029E-10
     +,   2.6927435E-10,   2.4108890E-10,   2.1577207E-10
     +,   1.9304162E-10,   1.7264055E-10,   1.5433682E-10
     +,   1.3792251E-10,   1.2320681E-10,   1.1002053E-10
     +,   9.8208192E-11,   8.7631534E-11,   7.8164350E-11
     +,   6.9694049E-11,   6.2118206E-11,   5.5345312E-11
     +,   4.9292282E-11,   4.3885031E-11,   3.9056303E-11
     +,   3.4745814E-11,   3.0899672E-11,   2.7468855E-11
     +,   2.4409889E-11,   2.1683457E-11,   1.9254492E-11
     +,   1.7091106E-11,   1.5165189E-11,   1.3451238E-11
     +,   1.1926625E-11,   1.0570807E-11,   9.3656263E-12
     +,   8.2947529E-12,   7.3436231E-12
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_asha_hatt105_mass = Yx/4.67072818604651
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_asha_hatt107_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  6.6326564E-04,   6.8742665E-04
     +,   7.1252091E-04,   7.3859579E-04,   7.6570152E-04
     +,   7.9389301E-04,   8.2322862E-04,   8.5377158E-04
     +,   8.8558916E-04,   9.1875572E-04,   9.5334969E-04
     +,   9.8945573E-04,   1.0271657E-03,   1.0665782E-03
     +,   1.1077999E-03,   1.1509446E-03,   1.1961358E-03
     +,   1.2435050E-03,   1.2931942E-03,   1.3453561E-03
     +,   1.4001512E-03,   1.4577534E-03,   1.5183460E-03
     +,   1.5821271E-03,   1.6492999E-03,   1.7200856E-03
     +,   1.7947132E-03,   1.8734229E-03,   1.9564657E-03
     +,   2.0441040E-03,   2.1366067E-03,   2.2342543E-03
     +,   2.3373310E-03,   2.4461295E-03,   2.5609464E-03
     +,   2.6820810E-03,   2.8098358E-03,   2.9445100E-03
     +,   3.0864112E-03,   3.2358286E-03,   3.3930659E-03
     +,   3.5584096E-03,   3.7321472E-03,   3.9145579E-03
     +,   4.1059190E-03,   4.3065022E-03,   4.5165764E-03
     +,   4.7364123E-03,   4.9662776E-03,   5.2064494E-03
     +,   5.4572090E-03,   5.7188510E-03,   5.9916773E-03
     +,   6.2760366E-03,   6.5722535E-03,   6.8807211E-03
     +,   7.2018341E-03,   7.5360164E-03,   7.8837145E-03
     +,   8.2453955E-03,   8.6215353E-03,   9.0126107E-03
     +,   9.4190659E-03,   9.8413387E-03,   1.0279816E-02
     +,   1.0734775E-02,   1.1206451E-02,   1.1694909E-02
     +,   1.2200137E-02,   1.2721917E-02,   1.3259928E-02
     +,   1.3813637E-02,   1.4382439E-02,   1.4965528E-02
     +,   1.5562098E-02,   1.6171305E-02,   1.6792344E-02
     +,   1.7424578E-02,   1.8067699E-02,   1.8721836E-02
     +,   1.9387703E-02,   2.0066924E-02,   2.0762093E-02
     +,   2.1477167E-02,   2.2217540E-02,   2.2990372E-02
     +,   2.3804510E-02,   2.4670584E-02,   2.5600655E-02
     +,   2.6607867E-02,   2.7705641E-02,   2.8906550E-02
     +,   3.0221077E-02,   3.1656165E-02,   3.3213601E-02
     +,   3.4888316E-02,   3.6667563E-02,   3.8529836E-02
     +,   4.0445320E-02,   4.2376388E-02,   4.4279840E-02
     +,   4.6109058E-02,   4.7817934E-02,   4.9363948E-02
     +,   5.0712429E-02,   5.1839456E-02,   5.2734613E-02
     +,   5.3402387E-02,   5.3862803E-02,   5.4150499E-02
     +,   5.4313142E-02,   5.4409325E-02,   5.4505721E-02
     +,   5.4674800E-02,   5.4992218E-02,   5.5534709E-02
     +,   5.6377858E-02,   5.7593659E-02,   5.9246790E-02
     +,   6.1390139E-02,   6.4058535E-02,   6.7261212E-02
     +,   7.0974387E-02,   7.5135715E-02,   7.9642639E-02
     +,   8.4356561E-02,   8.9116924E-02,   9.3761645E-02
     +,   9.8154671E-02,   0.1022118    ,   0.1059218    
     +,   0.1093505    ,   0.1126290    ,   0.1159223    
     +,   0.1193905    ,   0.1231527    ,   0.1272671    
     +,   0.1317386    ,   0.1365488    ,   0.1416964    
     +,   0.1472221    ,   0.1532024    ,   0.1596988    
     +,   0.1666805    ,   0.1739510    ,   0.1811296    
     +,   0.1877175    ,   0.1932514    ,   0.1975118    
     +,   0.2007056    ,   0.2035452    ,   0.2071540    
     +,   0.2127873    ,   0.2214243    ,   0.2333447    
     +,   0.2478581    ,   0.2633420    ,   0.2776641    
     +,   0.2888960    ,   0.2960396    ,   0.2994163    
     +,   0.3004711    ,   0.3010561    ,   0.3025639    
     +,   0.3053690    ,   0.3088467    ,   0.3118976    
     +,   0.3136277    ,   0.3138322    ,   0.3130894    
     +,   0.3125017    ,   0.3132296    ,   0.3159981    
     +,   0.3207374    ,   0.3264942    ,   0.3316740    
     +,   0.3345397    ,   0.3337429    ,   0.3286539    
     +,   0.3193586    ,   0.3064079    ,   0.2905221    
     +,   0.2724027    ,   0.2526872    ,   0.2319712    
     +,   0.2108261    ,   0.1897855    ,   0.1693136    
     +,   0.1497807    ,   0.1314423    ,   0.1144299    
     +,   9.8769747E-02,   8.4425487E-02,   7.1346819E-02
     +,   5.9506092E-02,   4.8908759E-02,   3.9577913E-02
     +,   3.1525254E-02,   2.4727071E-02,   1.9114736E-02
     +,   1.4579069E-02,   1.0983534E-02,   8.1806639E-03
     +,   6.0268668E-03,   4.3923082E-03,   3.1653990E-03
     +,   2.2540898E-03,   1.5844838E-03,   1.0982028E-03
     +,   7.4961112E-04,   5.0332764E-04,   3.3211653E-04
     +,   2.1517041E-04,   1.3677582E-04,   8.5254629E-05
     +,   5.2087074E-05,   3.1183390E-05,   1.8289995E-05
     +,   1.0509140E-05,   5.9160980E-06,   3.2638311E-06
     +,   1.7655680E-06,   9.3754375E-07,   4.8972760E-07
     +,   2.5260306E-07,   1.2957730E-07,   6.6954705E-08
     +,   3.5598838E-08,   2.0076840E-08,   1.2408367E-08
     +,   8.5618925E-09,   6.5463577E-09,   5.4000528E-09
     +,   4.6682067E-09,   4.1397668E-09,   3.7180625E-09
     +,   3.3590233E-09,   3.0422724E-09,   2.7578797E-09
     +,   2.5004747E-09,   2.2666997E-09,   2.0541355E-09
     +,   1.8608104E-09,   1.6849991E-09,   1.5251655E-09
     +,   1.3799141E-09,   1.2479754E-09,   1.1281770E-09
     +,   1.0194446E-09,   9.2080593E-10,   8.3135987E-10
     +,   7.5028173E-10,   6.7682360E-10,   6.1030081E-10
     +,   5.5008376E-10,   4.9559518E-10,   4.4631496E-10
     +,   4.0176518E-10,   3.6150835E-10,   3.2514602E-10
     +,   2.9231664E-10,   2.6269104E-10,   2.3596719E-10
     +,   2.1187097E-10,   1.9015509E-10,   1.7059201E-10
     +,   1.5297590E-10,   1.3712033E-10,   1.2285618E-10
     +,   1.1002876E-10,   9.8498223E-11,   8.8138427E-11
     +,   7.8834730E-11,   7.0483078E-11,   6.2988996E-11
     +,   5.6267824E-11,   5.0242172E-11,   4.4842768E-11
     +,   4.0006332E-11,   3.5676403E-11,   3.1801367E-11
     +,   2.8335209E-11,   2.5235952E-11,   2.2466124E-11
     +,   1.9991696E-11,   1.7782210E-11,   1.5810155E-11
     +,   1.4050750E-11,   1.2481857E-11,   1.1083349E-11
     +,   9.8372950E-12,   8.7276028E-12,   7.7398149E-12
     +,   6.8608543E-12,   6.0790921E-12,   5.3840994E-12
     +,   4.7665604E-12,   4.2180022E-12,   3.7309886E-12
     +,   3.2987833E-12,   2.9154229E-12
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_asha_hatt107_mass = Yx/4.0868871627907
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_asha_hatt110_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.2281710E-04,   3.4772183E-04
     +,   3.7404386E-04,   4.0182611E-04,   4.3111111E-04
     +,   4.6194153E-04,   4.9436017E-04,   5.2841037E-04
     +,   5.6413596E-04,   6.0158345E-04,   6.4079964E-04
     +,   6.8183395E-04,   7.2473841E-04,   7.6956884E-04
     +,   8.1638451E-04,   8.6524925E-04,   9.1623235E-04
     +,   9.6940791E-04,   1.0248572E-03,   1.0826677E-03
     +,   1.1429343E-03,   1.2057594E-03,   1.2712522E-03
     +,   1.3395338E-03,   1.4107262E-03,   1.4849667E-03
     +,   1.5623965E-03,   1.6431643E-03,   1.7274262E-03
     +,   1.8153446E-03,   1.9070872E-03,   2.0028243E-03
     +,   2.1027338E-03,   2.2069933E-03,   2.3157818E-03
     +,   2.4292811E-03,   2.5476706E-03,   2.6711281E-03
     +,   2.7998395E-03,   2.9339700E-03,   3.0737019E-03
     +,   3.2192059E-03,   3.3706517E-03,   3.5282127E-03
     +,   3.6920581E-03,   3.8623642E-03,   4.0393053E-03
     +,   4.2230659E-03,   4.4138348E-03,   4.6118107E-03
     +,   4.8172022E-03,   5.0302302E-03,   5.2511250E-03
     +,   5.4801460E-03,   5.7175378E-03,   5.9635872E-03
     +,   6.2185731E-03,   6.4827851E-03,   6.7565227E-03
     +,   7.0400764E-03,   7.3337373E-03,   7.6377783E-03
     +,   7.9524312E-03,   8.2779210E-03,   8.6144255E-03
     +,   8.9620342E-03,   9.3208114E-03,   9.6906945E-03
     +,   1.0071569E-02,   1.0463169E-02,   1.0865156E-02
     +,   1.1277015E-02,   1.1698158E-02,   1.2127801E-02
     +,   1.2565075E-02,   1.3008999E-02,   1.3458452E-02
     +,   1.3912247E-02,   1.4369174E-02,   1.4828022E-02
     +,   1.5287574E-02,   1.5746778E-02,   1.6204640E-02
     +,   1.6660409E-02,   1.7113501E-02,   1.7563645E-02
     +,   1.8010734E-02,   1.8454965E-02,   1.8896690E-02
     +,   1.9336458E-02,   1.9774893E-02,   2.0212643E-02
     +,   2.0650325E-02,   2.1088574E-02,   2.1527981E-02
     +,   2.1969244E-02,   2.2413395E-02,   2.2861984E-02
     +,   2.3317544E-02,   2.3783974E-02,   2.4267036E-02
     +,   2.4774715E-02,   2.5317747E-02,   2.5909605E-02
     +,   2.6566625E-02,   2.7307726E-02,   2.8153649E-02
     +,   2.9126158E-02,   3.0246973E-02,   3.1536434E-02
     +,   3.3011954E-02,   3.4687061E-02,   3.6569789E-02
     +,   3.8662113E-02,   4.0958762E-02,   4.3447416E-02
     +,   4.6108071E-02,   4.8914436E-02,   5.1834233E-02
     +,   5.4831866E-02,   5.7870425E-02,   6.0914248E-02
     +,   6.3931555E-02,   6.6896610E-02,   6.9791369E-02
     +,   7.2606169E-02,   7.5342014E-02,   7.8012593E-02
     +,   8.0648161E-02,   8.3298326E-02,   8.6033352E-02
     +,   8.8938795E-02,   9.2103325E-02,   9.5597424E-02
     +,   9.9448964E-02,   0.1036195    ,   0.1079913    
     +,   0.1123722    ,   0.1165210    ,   0.1201902    
     +,   0.1231782    ,   0.1253805    ,   0.1268257    
     +,   0.1276892    ,   0.1282766    ,   0.1289769    
     +,   0.1301923    ,   0.1322553    ,   0.1353557    
     +,   0.1395016    ,   0.1445349    ,   0.1502073    
     +,   0.1563039    ,   0.1627754    ,   0.1698204    
     +,   0.1778627    ,   0.1873953    ,   0.1987160    
     +,   0.2116430    ,   0.2253472    ,   0.2384246    
     +,   0.2492483    ,   0.2565167    ,   0.2597969    
     +,   0.2598111    ,   0.2582822    ,   0.2573479    
     +,   0.2587574    ,   0.2632007    ,   0.2700758    
     +,   0.2778025    ,   0.2845337    ,   0.2889368    
     +,   0.2906638    ,   0.2902948    ,   0.2887999    
     +,   0.2868545    ,   0.2844183    ,   0.2807973    
     +,   0.2750851    ,   0.2666378    ,   0.2553102    
     +,   0.2413869    ,   0.2253652    ,   0.2077747    
     +,   0.1891084    ,   0.1698316    ,   0.1504021    
     +,   0.1312682    ,   0.1128508    ,   9.5517308E-02
     +,   7.9568900E-02,   6.5232530E-02,   5.2650813E-02
     +,   4.1874543E-02,   3.2862715E-02,   2.5493504E-02
     +,   1.9584814E-02,   1.4922404E-02,   1.1287893E-02
     +,   8.4799277E-03,   6.3253311E-03,   4.6822163E-03
     +,   3.4376325E-03,   2.5025895E-03,   1.8066630E-03
     +,   1.2939567E-03,   9.2010369E-04,   6.5009593E-04
     +,   4.5668500E-04,   3.1907056E-04,   2.2168546E-04
     +,   1.5307960E-04,   1.0495145E-04,   7.1348681E-05
     +,   4.8027199E-05,   3.1963678E-05,   2.1002765E-05
     +,   1.3607719E-05,   8.6838254E-06,   5.4530224E-06
     +,   3.3668080E-06,   2.0426091E-06,   1.2170967E-06
     +,   7.1196200E-07,   4.0872925E-07,   2.3023023E-07
     +,   1.2722231E-07,   6.8955273E-08,   3.6653582E-08
     +,   1.9106588E-08,   9.7667332E-09,   4.8953512E-09
     +,   2.4058162E-09,   1.1592930E-09,   5.4771937E-10
     +,   2.5371133E-10,   1.1522425E-10,   5.1307333E-11
     +,   2.2399169E-11,   9.5871523E-12,   4.0230987E-12
     +,   1.6552332E-12,   6.6768471E-13,   2.6404860E-13
     +,   1.0237878E-13,   3.8919050E-14,   1.4505416E-14
     +,   5.3002951E-15,   1.8989219E-15,   6.6702881E-16
     +,   2.2973093E-16,   7.7587543E-17,   2.5703102E-17
     +,   8.3564954E-18,   2.6695798E-18,   8.4053157E-19
     +,   2.6265166E-19,   8.2749119E-20,   2.7174302E-20
     +,   9.8602482E-21,   4.2276599E-21,   2.1935715E-21
     +,   1.3195215E-21,   8.6275948E-22,   5.8591100E-22
     +,   4.0386091E-22,   2.7974462E-22,   1.9395014E-22
     +,   1.3438129E-22,   9.2993309E-23,   6.4260584E-23
     +,   4.4339167E-23,   3.0546496E-23,   2.1011567E-23
     +,   1.4430672E-23,   9.8953608E-24,   6.7750009E-24
     +,   4.6313156E-24,   3.1610114E-24,   2.1540987E-24
     +,   1.4656576E-24,   9.9566848E-25,   6.7534417E-25
     +,   4.5735133E-25,   3.0924341E-25,   2.0877150E-25
     +,   1.4071982E-25,   9.4703035E-26,   6.3633391E-26
     +,   4.2690564E-26,   2.8595031E-26,   1.9123732E-26
     +,   1.2769269E-26,   8.5129932E-27,   5.6664703E-27
     +,   3.7658394E-27,   2.4987610E-27,   1.6554183E-27
     +,   1.0949663E-27,   7.2313320E-28
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_asha_hatt110_mass = Yx/3.29369480487805
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_asha_hatt115_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.6608939E-03,   1.7304186E-03
     +,   1.8010119E-03,   1.8725304E-03,   1.9448254E-03
     +,   2.0177450E-03,   2.0911358E-03,   2.1648421E-03
     +,   2.2387127E-03,   2.3126027E-03,   2.3863707E-03
     +,   2.4598863E-03,   2.5330316E-03,   2.6057018E-03
     +,   2.6778111E-03,   2.7492938E-03,   2.8201044E-03
     +,   2.8902248E-03,   2.9596614E-03,   3.0284505E-03
     +,   3.0966601E-03,   3.1643892E-03,   3.2317673E-03
     +,   3.2989653E-03,   3.3661760E-03,   3.4336385E-03
     +,   3.5016136E-03,   3.5703990E-03,   3.6403204E-03
     +,   3.7117274E-03,   3.7849939E-03,   3.8605130E-03
     +,   3.9386898E-03,   4.0199379E-03,   4.1046785E-03
     +,   4.1933227E-03,   4.2862771E-03,   4.3839281E-03
     +,   4.4866451E-03,   4.5947568E-03,   4.7085630E-03
     +,   4.8283185E-03,   4.9542258E-03,   5.0864397E-03
     +,   5.2250526E-03,   5.3701014E-03,   5.5215615E-03
     +,   5.6793517E-03,   5.8433372E-03,   6.0133371E-03
     +,   6.1891349E-03,   6.3704895E-03,   6.5571517E-03
     +,   6.7489017E-03,   6.9455300E-03,   7.1469229E-03
     +,   7.3530455E-03,   7.5639985E-03,   7.7800499E-03
     +,   8.0016619E-03,   8.2295416E-03,   8.4646503E-03
     +,   8.7082293E-03,   8.9618461E-03,   9.2273699E-03
     +,   9.5069511E-03,   9.8030381E-03,   1.0118277E-02
     +,   1.0455505E-02,   1.0817577E-02,   1.1207352E-02
     +,   1.1627455E-02,   1.2080237E-02,   1.2567491E-02
     +,   1.3090394E-02,   1.3649321E-02,   1.4243628E-02
     +,   1.4871594E-02,   1.5530370E-02,   1.6215924E-02
     +,   1.6922981E-02,   1.7645275E-02,   1.8375548E-02
     +,   1.9105928E-02,   1.9828035E-02,   2.0533472E-02
     +,   2.1214038E-02,   2.1862239E-02,   2.2471467E-02
     +,   2.3036454E-02,   2.3553489E-02,   2.4020523E-02
     +,   2.4437297E-02,   2.4805382E-02,   2.5128009E-02
     +,   2.5409807E-02,   2.5656635E-02,   2.5875162E-02
     +,   2.6072534E-02,   2.6256043E-02,   2.6432779E-02
     +,   2.6609346E-02,   2.6791748E-02,   2.6985252E-02
     +,   2.7194470E-02,   2.7423423E-02,   2.7675817E-02
     +,   2.7955294E-02,   2.8265741E-02,   2.8611612E-02
     +,   2.8998151E-02,   2.9431537E-02,   2.9918749E-02
     +,   3.0467583E-02,   3.1085959E-02,   3.1781480E-02
     +,   3.2560453E-02,   3.3427190E-02,   3.4382772E-02
     +,   3.5424411E-02,   3.6544710E-02,   3.7731286E-02
     +,   3.8966872E-02,   4.0230252E-02,   4.1497380E-02
     +,   4.2743225E-02,   4.3944523E-02,   4.5082297E-02
     +,   4.6145413E-02,   4.7133416E-02,   4.8059862E-02
     +,   4.8954856E-02,   4.9867395E-02,   5.0866719E-02
     +,   5.2042454E-02,   5.3502813E-02,   5.5369336E-02
     +,   5.7768386E-02,   6.0818113E-02,   6.4612813E-02
     +,   6.9205478E-02,   7.4594572E-02,   8.0717370E-02
     +,   8.7452263E-02,   9.4629027E-02,   0.1020474    
     +,   0.1094945    ,   0.1167617    ,   0.1236600    
     +,   0.1300374    ,   0.1358011    ,   0.1409444    
     +,   0.1455711    ,   0.1498994    ,   0.1542313    
     +,   0.1588812    ,   0.1640772    ,   0.1698681    
     +,   0.1760750    ,   0.1823144    ,   0.1880965    
     +,   0.1929607    ,   0.1965963    ,   0.1989056    
     +,   0.1999881    ,   0.2000669    ,   0.1993968    
     +,   0.1981926    ,   0.1965983    ,   0.1946949    
     +,   0.1925324    ,   0.1901682    ,   0.1876959    
     +,   0.1852499    ,   0.1829752    ,   0.1809666    
     +,   0.1791935    ,   0.1774434    ,   0.1753180    
     +,   0.1722930    ,   0.1678334    ,   0.1615264    
     +,   0.1531886    ,   0.1429145    ,   0.1310538    
     +,   0.1181350    ,   0.1047601    ,   9.1502734E-02
     +,   7.8837477E-02,   6.7106567E-02,   5.6515906E-02
     +,   4.7156643E-02,   3.9034743E-02,   3.2097820E-02
     +,   2.6256828E-02,   2.1402379E-02,   1.7415660E-02
     +,   1.4175771E-02,   1.1565614E-02,   9.4769197E-03
     +,   7.8135561E-03,   6.4929724E-03,   5.4463516E-03
     +,   4.6176664E-03,   3.9619743E-03,   3.4432278E-03
     +,   3.0325034E-03,   2.7064264E-03,   2.4459620E-03
     +,   2.2355705E-03,   2.0626457E-03,   1.9171041E-03
     +,   1.7910394E-03,   1.6784144E-03,   1.5747928E-03
     +,   1.4770704E-03,   1.3832037E-03,   1.2919683E-03
     +,   1.2027543E-03,   1.1153938E-03,   1.0299998E-03
     +,   9.4685965E-04,   8.6635479E-04,   7.8889105E-04
     +,   7.1485090E-04,   6.4457074E-04,   5.7832681E-04
     +,   5.1632314E-04,   4.5868417E-04,   4.0546266E-04
     +,   3.5664722E-04,   3.1216556E-04,   2.7189028E-04
     +,   2.3565095E-04,   2.0324608E-04,   1.7444437E-04
     +,   1.4899721E-04,   1.2664672E-04,   1.0713054E-04
     +,   9.0186157E-05,   7.5557437E-05,   6.2998944E-05
     +,   5.2277650E-05,   4.3174605E-05,   3.5487210E-05
     +,   2.9030483E-05,   2.3636463E-05,   1.9153917E-05
     +,   1.5448290E-05,   1.2401093E-05,   9.9082372E-06
     +,   7.8793219E-06,   6.2365266E-06,   4.9131918E-06
     +,   3.8525618E-06,   3.0067599E-06,   2.3356911E-06
     +,   1.8059411E-06,   1.3898273E-06,   1.0645932E-06
     +,   8.1166172E-07,   6.1594181E-07,   4.6523587E-07
     +,   3.4976088E-07,   2.6172273E-07,   1.9493068E-07
     +,   1.4450491E-07,   1.0662365E-07,   7.8306400E-08
     +,   5.7241579E-08,   4.1647954E-08,   3.0161402E-08
     +,   2.1741764E-08,   1.5600030E-08,   1.1141652E-08
     +,   7.9211793E-09,   5.6060458E-09,   3.9498929E-09
     +,   2.7707792E-09,   1.9353792E-09,   1.3462707E-09
     +,   9.3282715E-10,   6.4399569E-10,   4.4315063E-10
     +,   3.0409911E-10,   2.0824774E-10,   1.4244053E-10
     +,   9.7429086E-11,   6.6747260E-11,   4.5890299E-11
     +,   3.1742435E-11,   2.2155059E-11,   1.5656873E-11
     +,   1.1243258E-11,   8.2328658E-12,   6.1648252E-12
     +,   4.7293098E-12,   3.7184557E-12,   2.9935841E-12
     +,   2.4622227E-12,   2.0629692E-12
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_asha_hatt115_mass = Yx/2.43472330769231
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_asha_hatt120_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.3317697E-03,   1.3821248E-03
     +,   1.4333260E-03,   1.4852806E-03,   1.5378873E-03
     +,   1.5910382E-03,   1.6446178E-03,   1.6985040E-03
     +,   1.7525681E-03,   1.8066792E-03,   1.8607005E-03
     +,   1.9144919E-03,   1.9679121E-03,   2.0208196E-03
     +,   2.0730733E-03,   2.1245359E-03,   2.1750720E-03
     +,   2.2245531E-03,   2.2728583E-03,   2.3198756E-03
     +,   2.3655039E-03,   2.4096544E-03,   2.4522550E-03
     +,   2.4932497E-03,   2.5326009E-03,   2.5702931E-03
     +,   2.6063344E-03,   2.6407577E-03,   2.6736245E-03
     +,   2.7050276E-03,   2.7350923E-03,   2.7639810E-03
     +,   2.7918946E-03,   2.8190780E-03,   2.8458196E-03
     +,   2.8724615E-03,   2.8993965E-03,   2.9270768E-03
     +,   2.9560169E-03,   2.9867971E-03,   3.0200724E-03
     +,   3.0565676E-03,   3.0970899E-03,   3.1425261E-03
     +,   3.1938471E-03,   3.2521053E-03,   3.3184395E-03
     +,   3.3940636E-03,   3.4802642E-03,   3.5783937E-03
     +,   3.6898497E-03,   3.8160719E-03,   3.9585051E-03
     +,   4.1185962E-03,   4.2977356E-03,   4.4972585E-03
     +,   4.7183828E-03,   4.9621826E-03,   5.2295416E-03
     +,   5.5211172E-03,   5.8372868E-03,   6.1781239E-03
     +,   6.5433295E-03,   6.9322377E-03,   7.3437840E-03
     +,   7.7764313E-03,   8.2282620E-03,   8.6968597E-03
     +,   9.1794590E-03,   9.6728439E-03,   1.0173507E-02
     +,   1.0677611E-02,   1.1181152E-02,   1.1679945E-02
     +,   1.2169811E-02,   1.2646657E-02,   1.3106530E-02
     +,   1.3545788E-02,   1.3961236E-02,   1.4350218E-02
     +,   1.4710657E-02,   1.5041270E-02,   1.5341532E-02
     +,   1.5611807E-02,   1.5853304E-02,   1.6068146E-02
     +,   1.6259264E-02,   1.6430378E-02,   1.6585827E-02
     +,   1.6730493E-02,   1.6869567E-02,   1.7008383E-02
     +,   1.7152173E-02,   1.7305886E-02,   1.7473957E-02
     +,   1.7660098E-02,   1.7867196E-02,   1.8097131E-02
     +,   1.8350787E-02,   1.8628020E-02,   1.8927766E-02
     +,   1.9248106E-02,   1.9586522E-02,   1.9940043E-02
     +,   2.0305490E-02,   2.0679744E-02,   2.1059807E-02
     +,   2.1443114E-02,   2.1827457E-02,   2.2211133E-02
     +,   2.2592761E-02,   2.2971282E-02,   2.3345726E-02
     +,   2.3715118E-02,   2.4078278E-02,   2.4433874E-02
     +,   2.4780305E-02,   2.5115995E-02,   2.5439583E-02
     +,   2.5750436E-02,   2.6049105E-02,   2.6337966E-02
     +,   2.6621755E-02,   2.6908197E-02,   2.7208334E-02
     +,   2.7536798E-02,   2.7911875E-02,   2.8355254E-02
     +,   2.8891852E-02,   2.9549144E-02,   3.0356774E-02
     +,   3.1345598E-02,   3.2547005E-02,   3.3991382E-02
     +,   3.5706528E-02,   3.7715301E-02,   4.0032499E-02
     +,   4.2661618E-02,   4.5592003E-02,   4.8796661E-02
     +,   5.2231800E-02,   5.5839788E-02,   5.9555355E-02
     +,   6.3313909E-02,   6.7061983E-02,   7.0767574E-02
     +,   7.4426852E-02,   7.8065246E-02,   8.1731871E-02
     +,   8.5487604E-02,   8.9387260E-02,   9.3461059E-02
     +,   9.7699746E-02,   0.1020470    ,   0.1064006    
     +,   0.1106234    ,   0.1145613    ,   0.1180647    
     +,   0.1210087    ,   0.1233097    ,   0.1249382    
     +,   0.1259249    ,   0.1263644    ,   0.1264139    
     +,   0.1262896    ,   0.1262572    ,   0.1266121    
     +,   0.1276479    ,   0.1296054    ,   0.1326124    
     +,   0.1366225    ,   0.1413775    ,   0.1464125    
     +,   0.1511135    ,   0.1548221    ,   0.1569608    
     +,   0.1571441    ,   0.1552414    ,   0.1513789    
     +,   0.1458815    ,   0.1391800    ,   0.1317133    
     +,   0.1238499    ,   0.1158453    ,   0.1078373    
     +,   9.9868998E-02,   9.1927670E-02,   8.3985209E-02
     +,   7.6032862E-02,   6.8102263E-02,   6.0270052E-02
     +,   5.2650981E-02,   4.5381542E-02,   3.8598835E-02
     +,   3.2420237E-02,   2.6929216E-02,   2.2167968E-02
     +,   1.8136419E-02,   1.4797496E-02,   1.2086670E-02
     +,   9.9227298E-03,   8.2176868E-03,   6.8850531E-03
     +,   5.8459006E-03,   5.0323424E-03,   4.3886015E-03
     +,   3.8708455E-03,   3.4458926E-03,   3.0893891E-03
     +,   2.7838964E-03,   2.5171870E-03,   2.2807876E-03
     +,   2.0688123E-03,   1.8771051E-03,   1.7026635E-03
     +,   1.5432552E-03,   1.3971471E-03,   1.2629426E-03
     +,   1.1394974E-03,   1.0258693E-03,   9.2125428E-04
     +,   8.2497252E-04,   7.3645083E-04,   6.5519381E-04
     +,   5.8076304E-04,   5.1276671E-04,   4.5085093E-04
     +,   3.9468191E-04,   3.4393507E-04,   2.9829252E-04
     +,   2.5744163E-04,   2.2106888E-04,   1.8885711E-04
     +,   1.6048974E-04,   1.3565448E-04,   1.1403999E-04
     +,   9.5342133E-05,   7.9267571E-05,   6.5534769E-05
     +,   5.3875978E-05,   4.4040269E-05,   3.5795543E-05
     +,   2.8928656E-05,   2.3245540E-05,   1.8571915E-05
     +,   1.4753006E-05,   1.1652371E-05,   9.1507236E-06
     +,   7.1449876E-06,   5.5470477E-06,   4.2818888E-06
     +,   3.2864107E-06,   2.5080010E-06,   1.9030965E-06
     +,   1.4358886E-06,   1.0772274E-06,   8.0357859E-07
     +,   5.9606288E-07,   4.3964059E-07,   3.2243693E-07
     +,   2.3514804E-07,   1.7052777E-07,   1.2297170E-07
     +,   8.8180073E-08,   6.2878549E-08,   4.4586233E-08
     +,   3.1438496E-08,   2.2044166E-08,   1.5371059E-08
     +,   1.0658344E-08,   7.3493238E-09,   5.0394728E-09
     +,   3.4364391E-09,   2.3303204E-09,   1.5714496E-09
     +,   1.0538446E-09,   7.0280365E-10,   4.6610577E-10
     +,   3.0741015E-10,   2.0162656E-10,   1.3151144E-10
     +,   8.5305728E-11,   5.5027989E-11,   3.5301581E-11
     +,   2.2521722E-11,   1.4289763E-11,   9.0171438E-12
     +,   5.6589637E-12,   3.5323504E-12,   2.1931101E-12
     +,   1.3545015E-12,   8.3226834E-13,   5.0886574E-13
     +,   3.0967077E-13,   1.8764291E-13,   1.1327185E-13
     +,   6.8174517E-14,   4.0954751E-14,   2.4596131E-14
     +,   1.4799705E-14,   8.9492597E-15
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_asha_hatt120_mass = Yx/1.822149
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_asha_hatt60_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.6887918E-03,   3.9407001E-03
     +,   4.2081974E-03,   4.4951206E-03,   4.8073172E-03
     +,   5.1534474E-03,   5.5460283E-03,   6.0027451E-03
     +,   6.5481025E-03,   7.2154682E-03,   8.0493763E-03
     +,   9.1081103E-03,   1.0466127E-02,   1.2215736E-02
     +,   1.4467084E-02,   1.7345406E-02,   2.0985063E-02
     +,   2.5521519E-02,   3.1085527E-02,   3.7807036E-02
     +,   4.5837697E-02,   5.5394307E-02,   6.6811003E-02
     +,   8.0569386E-02,   9.7266629E-02,   0.1175315    
     +,   0.1419582    ,   0.1712182    ,   0.2064488    
     +,   0.2497773    ,   0.3043821    ,   0.3732331    
     +,   0.4564899    ,   0.5497382    ,   0.6461276    
     +,   0.7414435    ,   0.8360443    ,   0.9317665    
     +,    1.031372    ,    1.141970    ,    1.266888    
     +,    1.385008    ,    1.453126    ,    1.443466    
     +,    1.368850    ,    1.264970    ,    1.159939    
     +,    1.064969    ,   0.9821205    ,   0.9098113    
     +,   0.8432021    ,   0.7768813    ,   0.7084703    
     +,   0.6383739    ,   0.5679690    ,   0.4994551    
     +,   0.4358374    ,   0.3795250    ,   0.3312465    
     +,   0.2904817    ,   0.2564268    ,   0.2283946    
     +,   0.2057047    ,   0.1875362    ,   0.1729341    
     +,   0.1609049    ,   0.1505356    ,   0.1411151    
     +,   0.1322082    ,   0.1236563    ,   0.1154971    
     +,   0.1078589    ,   0.1008652    ,   9.4589464E-02
     +,   8.9045577E-02,   8.4204711E-02,   8.0015287E-02
     +,   7.6416433E-02,   7.3343642E-02,   7.0729420E-02
     +,   6.8502627E-02,   6.6587918E-02,   6.4908169E-02
     +,   6.3387506E-02,   6.1955657E-02,   6.0551684E-02
     +,   5.9127297E-02,   5.7648633E-02,   5.6097079E-02
     +,   5.4468311E-02,   5.2770779E-02,   5.1023018E-02
     +,   4.9250502E-02,   4.7481962E-02,   4.5746647E-02
     +,   4.4071671E-02,   4.2479645E-02,   4.0987838E-02
     +,   3.9607245E-02,   3.8343091E-02,   3.7195079E-02
     +,   3.6158562E-02,   3.5225317E-02,   3.4384821E-02
     +,   3.3625063E-02,   3.2933403E-02,   3.2297187E-02
     +,   3.1704303E-02,   3.1143321E-02,   3.0603835E-02
     +,   3.0076580E-02,   2.9553486E-02,   2.9027682E-02
     +,   2.8493540E-02,   2.7946716E-02,   2.7384046E-02
     +,   2.6803644E-02,   2.6204735E-02,   2.5587685E-02
     +,   2.4953855E-02,   2.4305496E-02,   2.3645690E-02
     +,   2.2978103E-02,   2.2306813E-02,   2.1636240E-02
     +,   2.0970894E-02,   2.0315211E-02,   1.9673487E-02
     +,   1.9049598E-02,   1.8447062E-02,   1.7868819E-02
     +,   1.7317297E-02,   1.6794233E-02,   1.6300837E-02
     +,   1.5837695E-02,   1.5404823E-02,   1.5001784E-02
     +,   1.4627688E-02,   1.4281271E-02,   1.3960972E-02
     +,   1.3665053E-02,   1.3391617E-02,   1.3138705E-02
     +,   1.2904336E-02,   1.2686602E-02,   1.2483663E-02
     +,   1.2293798E-02,   1.2115459E-02,   1.1947256E-02
     +,   1.1787955E-02,   1.1636490E-02,   1.1491972E-02
     +,   1.1353664E-02,   1.1220925E-02,   1.1093240E-02
     +,   1.0970171E-02,   1.0851353E-02,   1.0736431E-02
     +,   1.0625076E-02,   1.0516948E-02,   1.0411686E-02
     +,   1.0308882E-02,   1.0208086E-02,   1.0108798E-02
     +,   1.0010445E-02,   9.9124014E-03,   9.8140026E-03
     +,   9.7145438E-03,   9.6132597E-03,   9.5093902E-03
     +,   9.4021661E-03,   9.2908312E-03,   9.1746515E-03
     +,   9.0529276E-03,   8.9250430E-03,   8.7904353E-03
     +,   8.6486293E-03,   8.4992545E-03,   8.3420444E-03
     +,   8.1768399E-03,   8.0035944E-03,   7.8223888E-03
     +,   7.6334230E-03,   7.4370005E-03,   7.2335219E-03
     +,   7.0235129E-03,   6.8075806E-03,   6.5864022E-03
     +,   6.3607255E-03,   6.1313673E-03,   5.8991690E-03
     +,   5.6650033E-03,   5.4297638E-03,   5.1943567E-03
     +,   4.9596587E-03,   4.7265217E-03,   4.4957842E-03
     +,   4.2682430E-03,   4.0446292E-03,   3.8256184E-03
     +,   3.6118398E-03,   3.4038548E-03,   3.2021441E-03
     +,   3.0071179E-03,   2.8191365E-03,   2.6384720E-03
     +,   2.4653289E-03,   2.2998580E-03,   2.1421511E-03
     +,   1.9922266E-03,   1.8500555E-03,   1.7155680E-03
     +,   1.5886502E-03,   1.4691423E-03,   1.3568513E-03
     +,   1.2515647E-03,   1.1530453E-03,   1.0610312E-03
     +,   9.7524672E-04,   8.9541468E-04,   8.2124275E-04
     +,   7.5243658E-04,   6.8870600E-04,   6.2976300E-04
     +,   5.7532004E-04,   5.2509684E-04,   4.7882489E-04
     +,   4.3624445E-04,   3.9710317E-04,   3.6116043E-04
     +,   3.2818934E-04,   2.9797485E-04,   2.7031143E-04
     +,   2.4500614E-04,   2.2187980E-04,   2.0076249E-04
     +,   1.8149552E-04,   1.6393216E-04,   1.4793573E-04
     +,   1.3337820E-04,   1.2014085E-04,   1.0811471E-04
     +,   9.7198703E-05,   8.7298729E-05,   7.8328012E-05
     +,   7.0207061E-05,   6.2862491E-05,   5.6226294E-05
     +,   5.0235849E-05,   4.4834182E-05,   3.9968312E-05
     +,   3.5589615E-05,   3.1653777E-05,   2.8120072E-05
     +,   2.4950925E-05,   2.2111981E-05,   1.9571931E-05
     +,   1.7302165E-05,   1.5276355E-05,   1.3470511E-05
     +,   1.1862864E-05,   1.0433568E-05,   9.1644597E-06
     +,   8.0390719E-06,   7.0425294E-06,   6.1612559E-06
     +,   5.3829740E-06,   4.6966225E-06,   4.0922137E-06
     +,   3.5606961E-06,   3.0939316E-06,   2.6846315E-06
     +,   2.3262505E-06,   2.0128971E-06,   1.7393033E-06
     +,   1.5007884E-06,   1.2931479E-06,   1.1126625E-06
     +,   9.5600228E-07,   8.2023212E-07,   7.0273467E-07
     +,   6.0120789E-07,   5.1360678E-07,   4.3813955E-07
     +,   3.7321846E-07,   3.1745762E-07,   2.6963536E-07
     +,   2.2868169E-07,   1.9366595E-07,   1.6377038E-07
     +,   1.3828704E-07,   1.1659613E-07,   9.8162779E-08
     +,   8.2520820E-08,   6.9268687E-08,   5.8057701E-08
     +,   4.8588841E-08,   4.0603055E-08,   3.3879076E-08
     +,   2.8225852E-08,   2.3480560E-08
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_asha_hatt60_mass = Yx/7.37222119565217
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_asha_hatt65_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.1782481E-03,   1.2807862E-03
     +,   1.3927105E-03,   1.5145354E-03,   1.6467733E-03
     +,   1.7899364E-03,   1.9445481E-03,   2.1111479E-03
     +,   2.2903096E-03,   2.4826694E-03,   2.6889371E-03
     +,   2.9099390E-03,   3.1466614E-03,   3.4002918E-03
     +,   3.6722864E-03,   3.9644344E-03,   4.2789429E-03
     +,   4.6185106E-03,   4.9864459E-03,   5.3867409E-03
     +,   5.8241952E-03,   6.3045211E-03,   6.8344362E-03
     +,   7.4218488E-03,   8.0758817E-03,   8.8071674E-03
     +,   9.6279467E-03,   1.0552345E-02,   1.1596675E-02
     +,   1.2779843E-02,   1.4123973E-02,   1.5655296E-02
     +,   1.7405666E-02,   1.9414840E-02,   2.1733733E-02
     +,   2.4428550E-02,   2.7585160E-02,   3.1312093E-02
     +,   3.5740998E-02,   4.1021306E-02,   4.7312744E-02
     +,   5.4775827E-02,   6.3571490E-02,   7.3877476E-02
     +,   8.5927106E-02,   0.1000664    ,   0.1168149    
     +,   0.1369185    ,   0.1614121    ,   0.1917268    
     +,   0.2298077    ,   0.2781176    ,   0.3396549    
     +,   0.4188279    ,   0.5232959    ,   0.6629975    
     +,   0.8405291    ,    1.037185    ,    1.214150    
     +,    1.341543    ,    1.432997    ,    1.537543    
     +,    1.671775    ,    1.769336    ,    1.748811    
     +,    1.629483    ,    1.510491    ,    1.443843    
     +,    1.395103    ,    1.310985    ,    1.179062    
     +,    1.029435    ,   0.8974108    ,   0.7924703    
     +,   0.7028618    ,   0.6177670    ,   0.5369686    
     +,   0.4654633    ,   0.4066552    ,   0.3610599    
     +,   0.3277416    ,   0.3047592    ,   0.2887761    
     +,   0.2755231    ,   0.2613083    ,   0.2443098    
     +,   0.2247685    ,   0.2042220    ,   0.1844906    
     +,   0.1669432    ,   0.1522322    ,   0.1403832    
     +,   0.1310392    ,   0.1237006    ,   0.1178861    
     +,   0.1132027    ,   0.1093573    ,   0.1061395    
     +,   0.1033955    ,   0.1010041    ,   9.8856188E-02
     +,   9.6842557E-02,   9.4848886E-02,   9.2759453E-02
     +,   9.0466850E-02,   8.7884717E-02,   8.4959626E-02
     +,   8.1678264E-02,   7.8067988E-02,   7.4192129E-02
     +,   7.0140503E-02,   6.6015892E-02,   6.1922863E-02
     +,   5.7955798E-02,   5.4192677E-02,   5.0689787E-02
     +,   4.7481932E-02,   4.4582970E-02,   4.1989911E-02
     +,   3.9686233E-02,   3.7646264E-02,   3.5839066E-02
     +,   3.4231674E-02,   3.2791667E-02,   3.1489417E-02
     +,   3.0299518E-02,   2.9201481E-02,   2.8180342E-02
     +,   2.7226256E-02,   2.6334262E-02,   2.5503257E-02
     +,   2.4735318E-02,   2.4034377E-02,   2.3405414E-02
     +,   2.2853356E-02,   2.2382321E-02,   2.1995023E-02
     +,   2.1692291E-02,   2.1472797E-02,   2.1332998E-02
     +,   2.1267276E-02,   2.1268003E-02,   2.1325922E-02
     +,   2.1430422E-02,   2.1569930E-02,   2.1732321E-02
     +,   2.1905247E-02,   2.2076502E-02,   2.2234349E-02
     +,   2.2367828E-02,   2.2466976E-02,   2.2523044E-02
     +,   2.2528620E-02,   2.2477826E-02,   2.2366308E-02
     +,   2.2191284E-02,   2.1951571E-02,   2.1647494E-02
     +,   2.1280777E-02,   2.0854507E-02,   2.0372914E-02
     +,   1.9841202E-02,   1.9265400E-02,   1.8652156E-02
     +,   1.8008463E-02,   1.7341528E-02,   1.6658559E-02
     +,   1.5966598E-02,   1.5272298E-02,   1.4581799E-02
     +,   1.3900704E-02,   1.3233916E-02,   1.2585574E-02
     +,   1.1959030E-02,   1.1356950E-02,   1.0781192E-02
     +,   1.0232920E-02,   9.7127110E-03,   9.2205685E-03
     +,   8.7559894E-03,   8.3180713E-03,   7.9056397E-03
     +,   7.5172838E-03,   7.1514198E-03,   6.8063773E-03
     +,   6.4804913E-03,   6.1721178E-03,   5.8796667E-03
     +,   5.6016473E-03,   5.3367135E-03,   5.0836345E-03
     +,   4.8413188E-03,   4.6088416E-03,   4.3854071E-03
     +,   4.1703433E-03,   3.9630975E-03,   3.7632373E-03
     +,   3.5704239E-03,   3.3843860E-03,   3.2049166E-03
     +,   3.0318743E-03,   2.8651562E-03,   2.7046744E-03
     +,   2.5503617E-03,   2.4021761E-03,   2.2600628E-03
     +,   2.1239640E-03,   1.9938254E-03,   1.8695806E-03
     +,   1.7511442E-03,   1.6384166E-03,   1.5312912E-03
     +,   1.4296500E-03,   1.3333525E-03,   1.2422490E-03
     +,   1.1561851E-03,   1.0749969E-03,   9.9850795E-04
     +,   9.2653744E-04,   8.5890788E-04,   7.9543219E-04
     +,   7.3592347E-04,   6.8019901E-04,   6.2807824E-04
     +,   5.7937898E-04,   5.3392380E-04,   4.9154233E-04
     +,   4.5206890E-04,   4.1534068E-04,   3.8120057E-04
     +,   3.4950001E-04,   3.2009589E-04,   2.9284947E-04
     +,   2.6762823E-04,   2.4430800E-04,   2.2276836E-04
     +,   2.0289462E-04,   1.8457926E-04,   1.6772003E-04
     +,   1.5221880E-04,   1.3798276E-04,   1.2492499E-04
     +,   1.1296318E-04,   1.0201884E-04,   9.2017908E-05
     +,   8.2891405E-05,   7.4574062E-05,   6.7004119E-05
     +,   6.0123570E-05,   5.3878648E-05,   4.8218342E-05
     +,   4.3094973E-05,   3.8464346E-05,   3.4285196E-05
     +,   3.0518797E-05,   2.7129201E-05,   2.4083251E-05
     +,   2.1350212E-05,   1.8901443E-05,   1.6710546E-05
     +,   1.4753331E-05,   1.3007507E-05,   1.1452501E-05
     +,   1.0069469E-05,   8.8412953E-06,   7.7522200E-06
     +,   6.7878973E-06,   5.9353320E-06,   5.1827119E-06
     +,   4.5192810E-06,   3.9353172E-06,   3.4220830E-06
     +,   2.9716875E-06,   2.5770084E-06,   2.2316510E-06
     +,   1.9299159E-06,   1.6666635E-06,   1.4373367E-06
     +,   1.2378442E-06,   1.0645701E-06,   9.1427819E-07
     +,   7.8411887E-07,   6.7155355E-07,   5.7435147E-07
     +,   4.9053273E-07,   4.1836498E-07,   3.5631714E-07
     +,   3.0304597E-07,   2.5737987E-07,   2.1828752E-07
     +,   1.8487367E-07,   1.5635331E-07,   1.3204688E-07
     +,   1.1136079E-07,   9.3782589E-08,   7.8866485E-08
     +,   6.6228580E-08,   5.5535988E-08,   4.6503317E-08
     +,   3.8883538E-08,   3.2465611E-08
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_asha_hatt65_mass = Yx/8.70151531914894
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_asha_hatt70_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.0287396E-04,   4.3057927E-04
     +,   4.6093352E-04,   4.9411575E-04,   5.3030340E-04
     +,   5.6967017E-04,   6.1238441E-04,   6.5860787E-04
     +,   7.0849265E-04,   7.6218433E-04,   8.1981550E-04
     +,   8.8150817E-04,   9.4737380E-04,   1.0175138E-03
     +,   1.0920198E-03,   1.1709771E-03,   1.2544669E-03
     +,   1.3425701E-03,   1.4353732E-03,   1.5329744E-03
     +,   1.6354908E-03,   1.7430676E-03,   1.8558867E-03
     +,   1.9741885E-03,   2.0982616E-03,   2.2284887E-03
     +,   2.3653370E-03,   2.5093870E-03,   2.6613467E-03
     +,   2.8220729E-03,   2.9925844E-03,   3.1740875E-03
     +,   3.3679907E-03,   3.5759259E-03,   3.7997698E-03
     +,   4.0416638E-03,   4.3040426E-03,   4.5896526E-03
     +,   4.9016145E-03,   5.2434071E-03,   5.6189741E-03
     +,   6.0327211E-03,   6.4895833E-03,   6.9950526E-03
     +,   7.5552179E-03,   8.1767663E-03,   8.8669844E-03
     +,   9.6337423E-03,   1.0485463E-02,   1.1431155E-02
     +,   1.2480490E-02,   1.3644142E-02,   1.4934457E-02
     +,   1.6367003E-02,   1.7962845E-02,   1.9753033E-02
     +,   2.1784695E-02,   2.4129739E-02,   2.6895721E-02
     +,   3.0238749E-02,   3.4378942E-02,   3.9620921E-02
     +,   4.6380870E-02,   5.5218391E-02,   6.6853620E-02
     +,   8.2139827E-02,   0.1019797    ,   0.1272119    
     +,   0.1585911    ,   0.1969258    ,   0.2432767    
     +,   0.2988018    ,   0.3643247    ,   0.4408664    
     +,   0.5323771    ,   0.6482885    ,   0.8006965    
     +,   0.9964767    ,    1.232556    ,    1.484519    
     +,    1.686430    ,    1.788237    ,    1.840707    
     +,    1.922748    ,    2.044721    ,    2.162084    
     +,    2.212811    ,    2.124296    ,    1.896905    
     +,    1.621969    ,    1.381644    ,    1.198333    
     +,    1.054633    ,   0.9335952    ,   0.8288549    
     +,   0.7336166    ,   0.6435473    ,   0.5624890    
     +,   0.4961952    ,   0.4457801    ,   0.4082550    
     +,   0.3794520    ,   0.3557436    ,   0.3347090    
     +,   0.3149937    ,   0.2957188    ,   0.2761633    
     +,   0.2559698    ,   0.2354141    ,   0.2153303    
     +,   0.1966938    ,   0.1801696    ,   0.1658987    
     +,   0.1535676    ,   0.1426569    ,   0.1326914    
     +,   0.1233920    ,   0.1146973    ,   0.1067029    
     +,   9.9564843E-02,   9.3417160E-02,   8.8318907E-02
     +,   8.4233634E-02,   8.1034251E-02,   7.8524746E-02
     +,   7.6469190E-02,   7.4622273E-02,   7.2758295E-02
     +,   7.0693955E-02,   6.8305016E-02,   6.5532848E-02
     +,   6.2383868E-02,   5.8919609E-02,   5.5242442E-02
     +,   5.1477157E-02,   4.7753055E-02,   4.4188671E-02
     +,   4.0879957E-02,   3.7893746E-02,   3.5266370E-02
     +,   3.3006549E-02,   3.1100174E-02,   2.9516879E-02
     +,   2.8216681E-02,   2.7155722E-02,   2.6290214E-02
     +,   2.5579395E-02,   2.4986964E-02,   2.4481408E-02
     +,   2.4035901E-02,   2.3627779E-02,   2.3238150E-02
     +,   2.2851501E-02,   2.2455433E-02,   2.2040609E-02
     +,   2.1600796E-02,   2.1132790E-02,   2.0636288E-02
     +,   2.0113708E-02,   1.9569853E-02,   1.9011341E-02
     +,   1.8446043E-02,   1.7882502E-02,   1.7329177E-02
     +,   1.6793851E-02,   1.6283117E-02,   1.5801981E-02
     +,   1.5353578E-02,   1.4939012E-02,   1.4557431E-02
     +,   1.4206166E-02,   1.3881022E-02,   1.3576541E-02
     +,   1.3286465E-02,   1.3004127E-02,   1.2722824E-02
     +,   1.2436207E-02,   1.2138617E-02,   1.1825297E-02
     +,   1.1492568E-02,   1.1137961E-02,   1.0760251E-02
     +,   1.0359432E-02,   9.9365804E-03,   9.4937719E-03
     +,   9.0339305E-03,   8.5606454E-03,   8.0779176E-03
     +,   7.5900359E-03,   7.1014105E-03,   6.6163428E-03
     +,   6.1389180E-03,   5.6729270E-03,   5.2217417E-03
     +,   4.7882311E-03,   4.3747453E-03,   3.9831372E-03
     +,   3.6147430E-03,   3.2703711E-03,   2.9503815E-03
     +,   2.6547459E-03,   2.3830805E-03,   2.1346814E-03
     +,   1.9086115E-03,   1.7037699E-03,   1.5189000E-03
     +,   1.3526630E-03,   1.2036867E-03,   1.0705867E-03
     +,   9.5198955E-04,   8.4656419E-04,   7.5304671E-04
     +,   6.7024294E-04,   5.9703202E-04,   5.3237821E-04
     +,   4.7533540E-04,   4.2504046E-04,   3.8070849E-04
     +,   3.4163339E-04,   3.0718537E-04,   2.7679896E-04
     +,   2.4997161E-04,   2.2625971E-04,   2.0527125E-04
     +,   1.8665929E-04,   1.7011963E-04,   1.5538663E-04
     +,   1.4222816E-04,   1.3044108E-04,   1.1984885E-04
     +,   1.1029924E-04,   1.0166038E-04,   9.3818002E-05
     +,   8.6673921E-05,   8.0144338E-05,   7.4156946E-05
     +,   6.8649802E-05,   6.3570355E-05,   5.8873688E-05
     +,   5.4521162E-05,   5.0479779E-05,   4.6721430E-05
     +,   4.3222102E-05,   3.9960694E-05,   3.6919031E-05
     +,   3.4081353E-05,   3.1433789E-05,   2.8963837E-05
     +,   2.6660306E-05,   2.4513258E-05,   2.2513372E-05
     +,   2.0652078E-05,   1.8921497E-05,   1.7314223E-05
     +,   1.5823151E-05,   1.4441554E-05,   1.3163119E-05
     +,   1.1981779E-05,   1.0891660E-05,   9.8871369E-06
     +,   8.9628857E-06,   8.1137878E-06,   7.3348942E-06
     +,   6.6214698E-06,   5.9690597E-06,   5.3733565E-06
     +,   4.8302581E-06,   4.3359169E-06,   3.8866688E-06
     +,   3.4790303E-06,   3.1097131E-06,   2.7756544E-06
     +,   2.4739697E-06,   2.2019406E-06,   1.9570289E-06
     +,   1.7368891E-06,   1.5393121E-06,   1.3622741E-06
     +,   1.2038764E-06,   1.0623861E-06,   9.3618581E-07
     +,   8.2380564E-07,   7.2387991E-07,   6.3517223E-07
     +,   5.5653885E-07,   4.8694795E-07,   4.2545193E-07
     +,   3.7119099E-07,   3.2339045E-07,   2.8134320E-07
     +,   2.4441539E-07,   2.1203091E-07,   1.8367638E-07
     +,   1.5888614E-07,   1.3724672E-07,   1.1838495E-07
     +,   1.0197044E-07,   8.7706390E-08,   7.5330469E-08
     +,   6.4608436E-08,   5.5333924E-08
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_asha_hatt70_mass = Yx/9.945896625
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_asha_hatt75_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  5.0371728E-04,   5.3234381E-04
     +,   5.6234235E-04,   5.9375371E-04,   6.2661717E-04
     +,   6.6097104E-04,   6.9685152E-04,   7.3429267E-04
     +,   7.7332574E-04,   8.1398070E-04,   8.5628201E-04
     +,   9.0025144E-04,   9.4590586E-04,   9.9325727E-04
     +,   1.0423124E-03,   1.0930717E-03,   1.1455292E-03
     +,   1.1996723E-03,   1.2554810E-03,   1.3129280E-03
     +,   1.3719789E-03,   1.4325919E-03,   1.4947178E-03
     +,   1.5583066E-03,   1.6232961E-03,   1.6896297E-03
     +,   1.7572469E-03,   1.8260911E-03,   1.8961136E-03
     +,   1.9672760E-03,   2.0395592E-03,   2.1129658E-03
     +,   2.1875298E-03,   2.2633255E-03,   2.3404739E-03
     +,   2.4191572E-03,   2.4996267E-03,   2.5822192E-03
     +,   2.6673744E-03,   2.7556387E-03,   2.8477018E-03
     +,   2.9444038E-03,   3.0467613E-03,   3.1559961E-03
     +,   3.2735567E-03,   3.4011554E-03,   3.5407953E-03
     +,   3.6948018E-03,   3.8658602E-03,   4.0570404E-03
     +,   4.2718221E-03,   4.5141061E-03,   4.7882115E-03
     +,   5.0988779E-03,   5.4511609E-03,   5.8504296E-03
     +,   6.3021751E-03,   6.8118973E-03,   7.3848758E-03
     +,   8.0259275E-03,   8.7391241E-03,   9.5274951E-03
     +,   1.0392655E-02,   1.1334628E-02,   1.2351559E-02
     +,   1.3439471E-02,   1.4592498E-02,   1.5802767E-02
     +,   1.7061118E-02,   1.8357493E-02,   1.9682316E-02
     +,   2.1027735E-02,   2.2390103E-02,   2.3772588E-02
     +,   2.5189467E-02,   2.6670862E-02,   2.8268646E-02
     +,   3.0063013E-02,   3.2168988E-02,   3.4741540E-02
     +,   3.7978239E-02,   4.2119786E-02,   4.7445990E-02
     +,   5.4271579E-02,   6.2938251E-02,   7.3807471E-02
     +,   8.7245189E-02,   0.1036338    ,   0.1235097    
     +,   0.1480514    ,   0.1799432    ,   0.2238439    
     +,   0.2848933    ,   0.3651782    ,   0.4624042    
     +,   0.5758933    ,   0.7153109    ,   0.8957182    
     +,    1.112826    ,    1.338232    ,    1.593467    
     +,    1.947666    ,    2.304761    ,    2.560801    
     +,    2.771507    ,    2.883195    ,    2.895209    
     +,    2.894431    ,    2.771472    ,    2.451629    
     +,    2.111417    ,    1.871152    ,    1.657062    
     +,    1.430231    ,    1.218181    ,    1.047153    
     +,   0.9066260    ,   0.7822496    ,   0.6757712    
     +,   0.5855985    ,   0.5076970    ,   0.4420393    
     +,   0.3895144    ,   0.3488128    ,   0.3170181    
     +,   0.2912257    ,   0.2693524    ,   0.2501759    
     +,   0.2331091    ,   0.2179719    ,   0.2047504    
     +,   0.1933675    ,   0.1835265    ,   0.1747116    
     +,   0.1663170    ,   0.1578271    ,   0.1489448    
     +,   0.1396254    ,   0.1300285    ,   0.1204304    
     +,   0.1111344    ,   0.1024021    ,   9.4415173E-02
     +,   8.7265529E-02,   8.0966450E-02,   7.5470962E-02
     +,   7.0695154E-02,   6.6537164E-02,   6.2889509E-02
     +,   5.9647121E-02,   5.6712355E-02,   5.3998701E-02
     +,   5.1433917E-02,   4.8962239E-02,   4.6546463E-02
     +,   4.4168033E-02,   4.1825376E-02,   3.9530355E-02
     +,   3.7304111E-02,   3.5172377E-02,   3.3160366E-02
     +,   3.1289037E-02,   2.9572509E-02,   2.8016381E-02
     +,   2.6617443E-02,   2.5364894E-02,   2.4241965E-02
     +,   2.3228215E-02,   2.2301622E-02,   2.1440787E-02
     +,   2.0626659E-02,   1.9843519E-02,   1.9079531E-02
     +,   1.8326838E-02,   1.7581290E-02,   1.6841633E-02
     +,   1.6108878E-02,   1.5385538E-02,   1.4674819E-02
     +,   1.3979978E-02,   1.3303948E-02,   1.2649038E-02
     +,   1.2016780E-02,   1.1407837E-02,   1.0822154E-02
     +,   1.0259114E-02,   9.7176852E-03,   9.1965590E-03
     +,   8.6943712E-03,   8.2098506E-03,   7.7418624E-03
     +,   7.2894939E-03,   6.8521244E-03,   6.4293807E-03
     +,   6.0210838E-03,   5.6272452E-03,   5.2480269E-03
     +,   4.8836744E-03,   4.5344364E-03,   4.2005461E-03
     +,   3.8822198E-03,   3.5796000E-03,   3.2927252E-03
     +,   3.0215473E-03,   2.7659540E-03,   2.5257226E-03
     +,   2.3005549E-03,   2.0901028E-03,   1.8939590E-03
     +,   1.7116569E-03,   1.5426952E-03,   1.3865546E-03
     +,   1.2426918E-03,   1.1105369E-03,   9.8950940E-04
     +,   8.7903033E-04,   7.7851274E-04,   6.8736280E-04
     +,   6.0498953E-04,   5.3081405E-04,   4.6425749E-04
     +,   4.0475233E-04,   3.5174919E-04,   3.0471417E-04
     +,   2.6312965E-04,   2.2650047E-04,   1.9435780E-04
     +,   1.6625811E-04,   1.4178296E-04,   1.2054233E-04
     +,   1.0217632E-04,   8.6353153E-05,   7.2768278E-05
     +,   6.1145081E-05,   5.1234649E-05,   4.2812339E-05
     +,   3.5677727E-05,   2.9653298E-05,   2.4582190E-05
     +,   2.0326253E-05,   1.6764850E-05,   1.3793279E-05
     +,   1.1320859E-05,   9.2692808E-06,   7.5713897E-06
     +,   6.1699307E-06,   5.0161393E-06,   4.0685964E-06
     +,   3.2923394E-06,   2.6579974E-06,   2.1408609E-06
     +,   1.7202764E-06,   1.3790481E-06,   1.1028742E-06
     +,   8.7988127E-07,   7.0025715E-07,   5.5592432E-07
     +,   4.4023744E-07,   3.4773774E-07,   2.7396177E-07
     +,   2.1527202E-07,   1.6870591E-07,   1.3185510E-07
     +,   1.0276984E-07,   7.9877800E-08,   6.1909432E-08
     +,   4.7845088E-08,   3.6868389E-08,   2.8326566E-08
     +,   2.1698980E-08,   1.6571787E-08,   1.2617533E-08
     +,   9.5773274E-09,   7.2470647E-09,   5.4665361E-09
     +,   4.1104617E-09,   3.0809033E-09,   2.3018270E-09
     +,   1.7141821E-09,   1.2724201E-09,   9.4140340E-10
     +,   6.9421602E-10,   5.1023480E-10,   3.7377085E-10
     +,   2.7288871E-10,   1.9857001E-10,   1.4400561E-10
     +,   1.0408181E-10,   7.4972840E-11,   5.3821274E-11
     +,   3.8506111E-11,   2.7454839E-11,   1.9508716E-11
     +,   1.3814849E-11,   9.7494027E-12,   6.8566758E-12
     +,   4.8057183E-12,   3.3566188E-12,   2.3364301E-12
     +,   1.6206874E-12,   1.1203381E-12
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_asha_hatt75_mass = Yx/12.05047872
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_asha_hatt80_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.8111664E-04,   1.9655724E-04
     +,   2.1288769E-04,   2.3011683E-04,   2.4824962E-04
     +,   2.6728690E-04,   2.8722538E-04,   3.0805735E-04
     +,   3.2977047E-04,   3.5234910E-04,   3.7577224E-04
     +,   4.0001527E-04,   4.2504948E-04,   4.5084261E-04
     +,   4.7735908E-04,   5.0456001E-04,   5.3240452E-04
     +,   5.6084909E-04,   5.8984890E-04,   6.1935780E-04
     +,   6.4932939E-04,   6.7971717E-04,   7.1047462E-04
     +,   7.4155827E-04,   7.7292329E-04,   8.0452964E-04
     +,   8.3633914E-04,   8.6831633E-04,   9.0043008E-04
     +,   9.3265274E-04,   9.6496195E-04,   9.9733984E-04
     +,   1.0297751E-03,   1.0622633E-03,   1.0948064E-03
     +,   1.1274174E-03,   1.1601200E-03,   1.1929513E-03
     +,   1.2259675E-03,   1.2592447E-03,   1.2928884E-03
     +,   1.3270386E-03,   1.3618792E-03,   1.3976494E-03
     +,   1.4346549E-03,   1.4732841E-03,   1.5140245E-03
     +,   1.5574784E-03,   1.6043844E-03,   1.6556330E-03
     +,   1.7122866E-03,   1.7755938E-03,   1.8469985E-03
     +,   1.9281508E-03,   2.0208918E-03,   2.1272574E-03
     +,   2.2494392E-03,   2.3897546E-03,   2.5505929E-03
     +,   2.7343503E-03,   2.9433535E-03,   3.1797721E-03
     +,   3.4455028E-03,   3.7421063E-03,   4.0706908E-03
     +,   4.4317851E-03,   4.8253415E-03,   5.2505829E-03
     +,   5.7060793E-03,   6.1896420E-03,   6.6984803E-03
     +,   7.2291647E-03,   7.7778776E-03,   8.3404500E-03
     +,   8.9127021E-03,   9.4906343E-03,   1.0070671E-02
     +,   1.0650037E-02,   1.1227105E-02,   1.1801702E-02
     +,   1.2375390E-02,   1.2951870E-02,   1.3537076E-02
     +,   1.4139450E-02,   1.4769809E-02,   1.5441396E-02
     +,   1.6169460E-02,   1.6971078E-02,   1.7864611E-02
     +,   1.8869596E-02,   2.0006651E-02,   2.1297814E-02
     +,   2.2767711E-02,   2.4445593E-02,   2.6368422E-02
     +,   2.8584890E-02,   3.1161506E-02,   3.4188088E-02
     +,   3.7783679E-02,   4.2096943E-02,   4.7299653E-02
     +,   5.3564951E-02,   6.1034705E-02,   6.9779523E-02
     +,   7.9783686E-02,   9.0989806E-02,   0.1034525    
     +,   0.1176221    ,   0.1347031    ,   0.1568699    
     +,   0.1869467    ,   0.2273341    ,   0.2789029    
     +,   0.3416885    ,   0.4177020    ,   0.5122926    
     +,   0.6319854    ,   0.7847406    ,   0.9877371    
     +,    1.282877    ,    1.685820    ,    2.107559    
     +,    2.531274    ,    2.960505    ,    3.377283    
     +,    3.670848    ,    3.910684    ,    4.147094    
     +,    3.923935    ,    3.520947    ,    3.047138    
     +,    2.636524    ,    2.246994    ,    1.916452    
     +,    1.665551    ,    1.430954    ,    1.154675    
     +,   0.9006839    ,   0.7419475    ,   0.6527572    
     +,   0.5819990    ,   0.5115836    ,   0.4442380    
     +,   0.3852682    ,   0.3372212    ,   0.2995584    
     +,   0.2698304    ,   0.2453713    ,   0.2242888    
     +,   0.2054840    ,   0.1883417    ,   0.1725387    
     +,   0.1579588    ,   0.1446193    ,   0.1325954    
     +,   0.1219574    ,   0.1127217    ,   0.1048228    
     +,   9.8111339E-02,   9.2378080E-02,   8.7386735E-02
     +,   8.2906388E-02,   7.8732878E-02,   7.4699529E-02
     +,   7.0682272E-02,   6.6600852E-02,   6.2417734E-02
     +,   5.8133449E-02,   5.3779718E-02,   4.9411740E-02
     +,   4.5100026E-02,   4.0921651E-02,   3.6952101E-02
     +,   3.3258617E-02,   2.9894751E-02,   2.6895398E-02
     +,   2.4275178E-02,   2.2028642E-02,   2.0132124E-02
     +,   1.8547516E-02,   1.7227162E-02,   1.6118973E-02
     +,   1.5171045E-02,   1.4335346E-02,   1.3570605E-02
     +,   1.2843878E-02,   1.2131028E-02,   1.1416364E-02
     +,   1.0691753E-02,   9.9554192E-03,   9.2103519E-03
     +,   8.4629087E-03,   7.7215065E-03,   6.9953976E-03
     +,   6.2936679E-03,   5.6245369E-03,   4.9949130E-03
     +,   4.4100359E-03,   3.8733322E-03,   3.3864977E-03
     +,   2.9496709E-03,   2.5616130E-03,   2.2199638E-03
     +,   1.9215525E-03,   1.6626968E-03,   1.4393956E-03
     +,   1.2475753E-03,   1.0832708E-03,   9.4273611E-04
     +,   8.2252402E-04,   7.1954931E-04,   6.3111342E-04
     +,   5.5489095E-04,   4.8890646E-04,   4.3150960E-04
     +,   3.8133963E-04,   3.3728059E-04,   2.9842072E-04
     +,   2.6401921E-04,   2.3347668E-04,   2.0630026E-04
     +,   1.8208445E-04,   1.6049284E-04,   1.4124121E-04
     +,   1.2408466E-04,   1.0881011E-04,   9.5230571E-05
     +,   8.3178726E-05,   7.2502873E-05,   6.3065345E-05
     +,   5.4741115E-05,   4.7415790E-05,   4.0984196E-05
     +,   3.5350273E-05,   3.0426918E-05,   2.6134336E-05
     +,   2.2400205E-05,   1.9159368E-05,   1.6353091E-05
     +,   1.3928427E-05,   1.1838067E-05,   1.0039947E-05
     +,   8.4966496E-06,   7.1749237E-06,   6.0454176E-06
     +,   5.0823469E-06,   4.2630400E-06,   3.5675891E-06
     +,   2.9785988E-06,   2.4809649E-06,   2.0614912E-06
     +,   1.7087364E-06,   1.4128237E-06,   1.1652152E-06
     +,   9.5854261E-07,   7.8647537E-07,   6.4359818E-07
     +,   5.2527804E-07,   4.2755428E-07,   3.4706059E-07
     +,   2.8094476E-07,   2.2679346E-07,   1.8256573E-07
     +,   1.4654604E-07,   1.1729839E-07,   9.3618233E-08
     +,   7.4502147E-08,   5.9116921E-08,   4.6772094E-08
     +,   3.6896381E-08,   2.9019777E-08,   2.2757025E-08
     +,   1.7792919E-08,   1.3870160E-08,   1.0779796E-08
     +,   8.3529361E-09,   6.4529115E-09,   4.9701017E-09
     +,   3.8164392E-09,   2.9217317E-09,   2.2299820E-09
     +,   1.6968650E-09,   1.2872695E-09,   9.7358543E-10
     +,   7.3409429E-10,   5.5183624E-10,   4.1356504E-10
     +,   3.0899272E-10,   2.3016064E-10,   1.7091591E-10
     +,   1.2653516E-10,   9.3391746E-11,   6.8719849E-11
     +,   5.0410717E-11,   3.6867179E-11,   2.6879610E-11
     +,   1.9538076E-11,   1.4158200E-11,   1.0228407E-11
     +,   7.3667209E-12,   5.2895232E-12
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_asha_hatt80_mass = Yx/14.3429724117647
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_asha_hatt85_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.7616591E-04,   1.8625217E-04
     +,   1.9657357E-04,   2.0710951E-04,   2.1783783E-04
     +,   2.2873509E-04,   2.3977646E-04,   2.5093617E-04
     +,   2.6218715E-04,   2.7350246E-04,   2.8485426E-04
     +,   2.9621460E-04,   3.0755575E-04,   3.1885045E-04
     +,   3.3007230E-04,   3.4119608E-04,   3.5219773E-04
     +,   3.6305544E-04,   3.7374959E-04,   3.8426326E-04
     +,   3.9458254E-04,   4.0469709E-04,   4.1460071E-04
     +,   4.2429211E-04,   4.3377402E-04,   4.4305599E-04
     +,   4.5215269E-04,   4.6108608E-04,   4.6988478E-04
     +,   4.7858551E-04,   4.8723316E-04,   4.9588137E-04
     +,   5.0459272E-04,   5.1344006E-04,   5.2250555E-04
     +,   5.3188205E-04,   5.4167275E-04,   5.5199076E-04
     +,   5.6296081E-04,   5.7471578E-04,   5.8740017E-04
     +,   6.0116540E-04,   6.1617239E-04,   6.3258805E-04
     +,   6.5058534E-04,   6.7034119E-04,   6.9203530E-04
     +,   7.1584800E-04,   7.4195891E-04,   7.7054492E-04
     +,   8.0177980E-04,   8.3583198E-04,   8.7286468E-04
     +,   9.1303949E-04,   9.5651060E-04,   1.0034376E-03
     +,   1.0539829E-03,   1.1083231E-03,   1.1666567E-03
     +,   1.2292168E-03,   1.2962862E-03,   1.3682155E-03
     +,   1.4454377E-03,   1.5284984E-03,   1.6180745E-03
     +,   1.7149821E-03,   1.8202174E-03,   1.9349401E-03
     +,   2.0605058E-03,   2.1984226E-03,   2.3503623E-03
     +,   2.5180781E-03,   2.7033812E-03,   2.9080103E-03
     +,   3.1335673E-03,   3.3813748E-03,   3.6523184E-03
     +,   3.9467197E-03,   4.2642108E-03,   4.6036039E-03
     +,   4.9627591E-03,   5.3386134E-03,   5.7271044E-03
     +,   6.1233412E-03,   6.5216529E-03,   6.9159353E-03
     +,   7.2998335E-03,   7.6672221E-03,   8.0125080E-03
     +,   8.3311591E-03,   8.6200917E-03,   8.8780709E-03
     +,   9.1060754E-03,   9.3075801E-03,   9.4887018E-03
     +,   9.6582100E-03,   9.8274518E-03,   1.0010048E-02
     +,   1.0221510E-02,   1.0478598E-02,   1.0798660E-02
     +,   1.1198727E-02,   1.1694675E-02,   1.2300187E-02
     +,   1.3025942E-02,   1.3878822E-02,   1.4861258E-02
     +,   1.5970953E-02,   1.7201085E-02,   1.8540770E-02
     +,   1.9976078E-02,   2.1492098E-02,   2.3075057E-02
     +,   2.4715869E-02,   2.6413405E-02,   2.8179053E-02
     +,   3.0040167E-02,   3.2044314E-02,   3.4261856E-02
     +,   3.6789421E-02,   3.9752938E-02,   4.3311004E-02
     +,   4.7656719E-02,   5.3012438E-02,   5.9609029E-02
     +,   6.7644618E-02,   7.7239059E-02,   8.8419601E-02
     +,   0.1012147    ,   0.1158950    ,   0.1333111    
     +,   0.1550763    ,   0.1833506    ,   0.2203863    
     +,   0.2687370    ,   0.3325822    ,   0.4183539    
     +,   0.5345095    ,   0.6978595    ,   0.9356694    
     +,    1.254391    ,    1.623934    ,    2.111181    
     +,    2.882115    ,    3.595869    ,    4.210650    
     +,    4.733350    ,    4.939591    ,    4.738362    
     +,    4.467772    ,    3.952625    ,    3.270524    
     +,    2.630594    ,    2.118519    ,    1.699395    
     +,    1.307265    ,    1.034752    ,   0.8673260    
     +,   0.7231578    ,   0.5967950    ,   0.5017436    
     +,   0.4376050    ,   0.3944042    ,   0.3594525    
     +,   0.3239383    ,   0.2855864    ,   0.2471519    
     +,   0.2125161    ,   0.1836220    ,   0.1601738    
     +,   0.1409830    ,   0.1250513    ,   0.1117575    
     +,   0.1005987    ,   9.1007508E-02,   8.2391992E-02
     +,   7.4281141E-02,   6.6425353E-02,   5.8795996E-02
     +,   5.1511075E-02,   4.4742573E-02,   3.8643192E-02
     +,   3.3306286E-02,   2.8755611E-02,   2.4954785E-02
     +,   2.1824997E-02,   1.9263593E-02,   1.7160688E-02
     +,   1.5412006E-02,   1.3927080E-02,   1.2632866E-02
     +,   1.1474618E-02,   1.0414342E-02,   9.4278427E-03
     +,   8.5013648E-03,   7.6285070E-03,   6.8075284E-03
     +,   6.0391887E-03,   5.3251400E-03,   4.6669804E-03
     +,   4.0656775E-03,   3.5212317E-03,   3.0325707E-03
     +,   2.5976736E-03,   2.2137568E-03,   1.8773889E-03
     +,   1.5847461E-03,   1.3318154E-03,   1.1145350E-03
     +,   9.2891656E-04,   7.7116297E-04,   6.3774321E-04
     +,   5.2541902E-04,   4.3125785E-04,   3.5264605E-04
     +,   2.8728080E-04,   2.3314514E-04,   1.8848325E-04
     +,   1.5177994E-04,   1.2173791E-04,   9.7245538E-05
     +,   7.7358243E-05,   6.1277788E-05,   4.8330963E-05
     +,   3.7951897E-05,   2.9667919E-05,   2.3086270E-05
     +,   1.7881413E-05,   1.3784575E-05,   1.0575249E-05
     +,   8.0735490E-06,   6.1331980E-06,   4.6357804E-06
     +,   3.4860818E-06,   2.6080133E-06,   1.9409174E-06
     +,   1.4368026E-06,   1.0579308E-06,   7.7475772E-07
     +,   5.6427899E-07,   4.0870754E-07,   2.9437649E-07
     +,   2.1083761E-07,   1.5014889E-07,   1.0631601E-07
     +,   7.4845254E-08,   5.2384692E-08,   3.6449933E-08
     +,   2.5212692E-08,   1.7336680E-08,   1.1849926E-08
     +,   8.0509732E-09,   5.4369553E-09,   3.6494721E-09
     +,   2.4347393E-09,   1.6143801E-09,   1.0638568E-09
     +,   6.9675526E-10,   4.5350362E-10,   2.9333838E-10
     +,   1.8855596E-10,   1.2044608E-10,   7.6456022E-11
     +,   4.8226256E-11,   3.0228143E-11,   1.8827136E-11
     +,   1.1651633E-11,   7.1650533E-12,   4.3780964E-12
     +,   2.6580914E-12,   1.6034713E-12,   9.6108310E-13
     +,   5.7236605E-13,   3.3867703E-13,   1.9910785E-13
     +,   1.1630273E-13,   6.7495448E-14,   3.8918148E-14
     +,   2.2294927E-14,   1.2689593E-14,   7.1756489E-15
     +,   4.0314186E-15,   2.2501970E-15,   1.2478548E-15
     +,   6.8749445E-16,   3.7631612E-16,   2.0464652E-16
     +,   1.1056391E-16,   5.9346655E-17,   3.1647196E-17
     +,   1.6766579E-17,   8.8248988E-18,   4.6147017E-18
     +,   2.3973495E-18,   1.2373349E-18,   6.3444774E-19
     +,   3.2320022E-19,   1.6356711E-19,   8.2241599E-20
     +,   4.1080429E-20,   2.0386569E-20
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_asha_hatt85_mass = Yx/14.5533730588235
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_asha_hatt90_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  6.3025742E-05,   7.2055082E-05
     +,   8.2143473E-05,   9.3377916E-05,   1.0584718E-04
     +,   1.1964100E-04,   1.3484912E-04,   1.5156042E-04
     +,   1.6986144E-04,   1.8983647E-04,   2.1156436E-04
     +,   2.3511864E-04,   2.6056566E-04,   2.8796334E-04
     +,   3.1735963E-04,   3.4879139E-04,   3.8228309E-04
     +,   4.1784524E-04,   4.5547381E-04,   4.9514894E-04
     +,   5.3683436E-04,   5.8047683E-04,   6.2600477E-04
     +,   6.7333260E-04,   7.2235172E-04,   7.7294273E-04
     +,   8.2496676E-04,   8.7827153E-04,   9.3269104E-04
     +,   9.8804804E-04,   1.0441563E-03,   1.1008221E-03
     +,   1.1578476E-03,   1.2150347E-03,   1.2721864E-03
     +,   1.3291116E-03,   1.3856285E-03,   1.4415678E-03
     +,   1.4967805E-03,   1.5511330E-03,   1.6045227E-03
     +,   1.6568723E-03,   1.7081402E-03,   1.7583200E-03
     +,   1.8074474E-03,   1.8556003E-03,   1.9029046E-03
     +,   1.9495343E-03,   1.9957144E-03,   2.0417189E-03
     +,   2.0878750E-03,   2.1345576E-03,   2.1821870E-03
     +,   2.2312291E-03,   2.2821811E-03,   2.3355728E-03
     +,   2.3919523E-03,   2.4518750E-03,   2.5158916E-03
     +,   2.5845352E-03,   2.6583038E-03,   2.7376455E-03
     +,   2.8229370E-03,   2.9144757E-03,   3.0124607E-03
     +,   3.1169686E-03,   3.2279622E-03,   3.3452592E-03
     +,   3.4685533E-03,   3.5973864E-03,   3.7311893E-03
     +,   3.8692555E-03,   4.0108017E-03,   4.1549504E-03
     +,   4.3007988E-03,   4.4474346E-03,   4.5939712E-03
     +,   4.7395998E-03,   4.8836386E-03,   5.0255652E-03
     +,   5.1650433E-03,   5.3019864E-03,   5.4365462E-03
     +,   5.5691614E-03,   5.7005221E-03,   5.8316006E-03
     +,   5.9635839E-03,   6.0978746E-03,   6.2360018E-03
     +,   6.3795969E-03,   6.5302951E-03,   6.6896677E-03
     +,   6.8591330E-03,   7.0399041E-03,   7.2329170E-03
     +,   7.4387342E-03,   7.6575573E-03,   7.8891413E-03
     +,   8.1328405E-03,   8.3875610E-03,   8.6518507E-03
     +,   8.9238891E-03,   9.2016133E-03,   9.4827358E-03
     +,   9.7649116E-03,   1.0045823E-02,   1.0323293E-02
     +,   1.0595443E-02,   1.0860857E-02,   1.1118725E-02
     +,   1.1368973E-02,   1.1612446E-02,   1.1850969E-02
     +,   1.2087469E-02,   1.2325918E-02,   1.2571291E-02
     +,   1.2829334E-02,   1.3106280E-02,   1.3408395E-02
     +,   1.3741491E-02,   1.4110354E-02,   1.4518164E-02
     +,   1.4966052E-02,   1.5452912E-02,   1.5975410E-02
     +,   1.6528420E-02,   1.7106052E-02,   1.7702928E-02
     +,   1.8316112E-02,   1.8947067E-02,   1.9603921E-02
     +,   2.0303158E-02,   2.1071067E-02,   2.1943823E-02
     +,   2.2966737E-02,   2.4191843E-02,   2.5674198E-02
     +,   2.7467433E-02,   2.9619429E-02,   3.2168921E-02
     +,   3.5144106E-02,   3.8564280E-02,   4.2443875E-02
     +,   4.6796020E-02,   5.1634196E-02,   5.6972094E-02
     +,   6.2824704E-02,   6.9221452E-02,   7.6246783E-02
     +,   8.4109724E-02,   9.3222246E-02,   0.1042499    
     +,   0.1181335    ,   0.1361911    ,   0.1605161    
     +,   0.1948318    ,   0.2455096    ,   0.3213850    
     +,   0.4305743    ,   0.5770640    ,   0.7696190    
     +,    1.056234    ,    1.514396    ,    2.113332    
     +,    2.721034    ,    3.490603    ,    4.617258    
     +,    5.449035    ,    5.915120    ,    6.001424    
     +,    5.284610    ,    4.307123    ,    3.418855    
     +,    2.658084    ,    1.917371    ,    1.371765    
     +,    1.005905    ,   0.7728826    ,   0.6336234    
     +,   0.5329710    ,   0.4483467    ,   0.3734926    
     +,   0.3055054    ,   0.2458964    ,   0.1972329    
     +,   0.1595720    ,   0.1305626    ,   0.1073551    
     +,   8.7973356E-02,   7.1487673E-02,   5.7560477E-02
     +,   4.6014573E-02,   3.6630895E-02,   2.9116852E-02
     +,   2.3145901E-02,   1.8405952E-02,   1.4630297E-02
     +,   1.1608106E-02,   9.1806492E-03,   7.2306301E-03
     +,   5.6699426E-03,   4.4292994E-03,   3.4513557E-03
     +,   2.6870903E-03,   2.0942367E-03,   1.6366256E-03
     +,   1.2841019E-03,   1.0122383E-03,   8.0176943E-04
     +,   6.3785969E-04,   5.0930917E-04,   4.0776728E-04
     +,   3.2702714E-04,   2.6246245E-04,   2.1060366E-04
     +,   1.6882156E-04,   1.3509484E-04,   1.0784775E-04
     +,   8.5839260E-05,   6.8083027E-05,   5.3784497E-05
     +,   4.2300773E-05,   3.3108885E-05,   2.5780759E-05
     +,   1.9964553E-05,   1.5371208E-05,   1.1763390E-05
     +,   8.9461491E-06,   6.7596457E-06,   5.0735198E-06
     +,   3.7820037E-06,   2.7996068E-06,   2.0576420E-06
     +,   1.5013406E-06,   1.0873875E-06,   7.8168972E-07
     +,   5.5767936E-07,   3.9482327E-07,   2.7737133E-07
     +,   1.9334264E-07,   1.3371232E-07,   9.1743665E-08
     +,   6.2449374E-08,   4.2170271E-08,   2.8248282E-08
     +,   1.8770608E-08,   1.2372628E-08,   8.0896356E-09
     +,   5.2464602E-09,   3.3750607E-09,   2.1535902E-09
     +,   1.3630157E-09,   8.5565571E-10,   5.3279559E-10
     +,   3.2906269E-10,   2.0157838E-10,   1.2247893E-10
     +,   7.3813941E-11,   4.4123233E-11,   2.6160058E-11
     +,   1.5383696E-11,   8.9730541E-12,   5.1912368E-12
     +,   2.9788127E-12,   1.6954036E-12,   9.5709085E-13
     +,   5.3589061E-13,   2.9761114E-13,   1.6393911E-13
     +,   8.9570949E-14,   4.8539555E-14,   2.6090334E-14
     +,   1.3910032E-14,   7.3559111E-15,   3.8583138E-15
     +,   2.0074075E-15,   1.0359512E-15,   5.3031886E-16
     +,   2.6929319E-16,   1.3565634E-16,   6.7794261E-17
     +,   3.3615806E-17,   1.6539829E-17,   8.0771374E-18
     +,   3.9158403E-18,   1.8855071E-18,   9.0222192E-19
     +,   4.2937751E-19,   2.0349522E-19,   9.6206114E-20
     +,   4.5485951E-20,   2.1579307E-20,   1.0319808E-20
     +,   5.0031078E-21,   2.4753919E-21,   1.2584576E-21
     +,   6.6126749E-22,   3.6036630E-22,   2.0371807E-22
     +,   1.1908837E-22,   7.1606312E-23
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_asha_hatt90_mass = Yx/14.4223688823529
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_asha_hatt95_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  6.7855191E-04,   6.9655885E-04
     +,   7.1431068E-04,   7.3178479E-04,   7.4896100E-04
     +,   7.6582277E-04,   7.8235625E-04,   7.9855166E-04
     +,   8.1440213E-04,   8.2990568E-04,   8.4506371E-04
     +,   8.5988088E-04,   8.7436684E-04,   8.8853505E-04
     +,   9.0240280E-04,   9.1599085E-04,   9.2932500E-04
     +,   9.4243384E-04,   9.5534982E-04,   9.6810941E-04
     +,   9.8075171E-04,   9.9331944E-04,   1.0058578E-03
     +,   1.0184156E-03,   1.0310421E-03,   1.0437916E-03
     +,   1.0567184E-03,   1.0698788E-03,   1.0833316E-03
     +,   1.0971361E-03,   1.1113532E-03,   1.1260442E-03
     +,   1.1412723E-03,   1.1571004E-03,   1.1735929E-03
     +,   1.1908144E-03,   1.2088307E-03,   1.2277078E-03
     +,   1.2475145E-03,   1.2683178E-03,   1.2901903E-03
     +,   1.3132032E-03,   1.3374339E-03,   1.3629609E-03
     +,   1.3898682E-03,   1.4182454E-03,   1.4481895E-03
     +,   1.4798056E-03,   1.5132088E-03,   1.5485280E-03
     +,   1.5859046E-03,   1.6254998E-03,   1.6674920E-03
     +,   1.7120881E-03,   1.7595156E-03,   1.8100378E-03
     +,   1.8639504E-03,   1.9215872E-03,   1.9833238E-03
     +,   2.0495828E-03,   2.1208336E-03,   2.1976009E-03
     +,   2.2804542E-03,   2.3700241E-03,   2.4669955E-03
     +,   2.5720908E-03,   2.6860929E-03,   2.8098056E-03
     +,   2.9440799E-03,   3.0897651E-03,   3.2477290E-03
     +,   3.4188079E-03,   3.6038244E-03,   3.8035235E-03
     +,   4.0185917E-03,   4.2496198E-03,   4.4970624E-03
     +,   4.7612330E-03,   5.0423006E-03,   5.3402670E-03
     +,   5.6549199E-03,   5.9858998E-03,   6.3326173E-03
     +,   6.6943574E-03,   7.0701856E-03,   7.4590831E-03
     +,   7.8598643E-03,   8.2713095E-03,   8.6920988E-03
     +,   9.1209393E-03,   9.5565636E-03,   9.9977264E-03
     +,   1.0443287E-02,   1.0892238E-02,   1.1343727E-02
     +,   1.1797028E-02,   1.2251662E-02,   1.2707320E-02
     +,   1.3164031E-02,   1.3622083E-02,   1.4082241E-02
     +,   1.4545710E-02,   1.5014417E-02,   1.5491034E-02
     +,   1.5979273E-02,   1.6484052E-02,   1.7011613E-02
     +,   1.7569687E-02,   1.8167596E-02,   1.8816127E-02
     +,   1.9527227E-02,   2.0313706E-02,   2.1188380E-02
     +,   2.2163397E-02,   2.3248874E-02,   2.4451956E-02
     +,   2.5775360E-02,   2.7216431E-02,   2.8766040E-02
     +,   3.0408323E-02,   3.2120705E-02,   3.3874433E-02
     +,   3.5635903E-02,   3.7368916E-02,   3.9036762E-02
     +,   4.0604692E-02,   4.2042986E-02,   4.3328762E-02
     +,   4.4448324E-02,   4.5397725E-02,   4.6183467E-02
     +,   4.6821646E-02,   4.7336925E-02,   4.7760438E-02
     +,   4.8127908E-02,   4.8477147E-02,   4.8845999E-02
     +,   4.9270369E-02,   4.9782701E-02,   5.0410721E-02
     +,   5.1176678E-02,   5.2096747E-02,   5.3181209E-02
     +,   5.4434545E-02,   5.5855960E-02,   5.7440631E-02
     +,   5.9181221E-02,   6.1070256E-02,   6.3103646E-02
     +,   6.5285847E-02,   6.7635931E-02,   7.0194863E-02
     +,   7.3032804E-02,   7.6254301E-02,   7.9997599E-02
     +,   8.4424421E-02,   8.9697644E-02,   9.5945455E-02
     +,   0.1032151    ,   0.1114273    ,   0.1203499    
     +,   0.1296035    ,   0.1387123    ,   0.1471974    
     +,   0.1546920    ,   0.1610463    ,   0.1663949    
     +,   0.1711634    ,   0.1760070    ,   0.1816739    
     +,   0.1888018    ,   0.1976757    ,   0.2080385    
     +,   0.2191047    ,   0.2299444    ,   0.2402822    
     +,   0.2514535    ,   0.2671083    ,   0.2936543    
     +,   0.3405519    ,   0.4187892    ,   0.5421446    
     +,   0.7511455    ,    1.123317    ,    1.685096    
     +,    2.502652    ,    3.955474    ,    6.064822    
     +,    8.137801    ,    8.588675    ,    6.790650    
     +,    3.891541    ,    1.895936    ,   0.9383194    
     +,   0.4433497    ,   0.1890075    ,   7.7360690E-02
     +,   3.5205811E-02,   1.8062808E-02,   1.0055870E-02
     +,   6.3685877E-03,   4.7349408E-03,   3.9180880E-03
     +,   3.3787119E-03,   2.9414587E-03,   2.5677998E-03
     +,   2.2552814E-03,   2.0038700E-03,   1.8083397E-03
     +,   1.6591855E-03,   1.5453530E-03,   1.4564351E-03
     +,   1.3838422E-03,   1.3211444E-03,   1.2639138E-03
     +,   1.2093415E-03,   1.1558071E-03,   1.1025004E-03
     +,   1.0491344E-03,   9.9574041E-04,   9.4251597E-04
     +,   8.8974118E-04,   8.3772594E-04,   7.8677433E-04
     +,   7.3716458E-04,   6.8914221E-04,   6.4291898E-04
     +,   5.9866771E-04,   5.5651995E-04,   5.1657070E-04
     +,   4.7888228E-04,   4.4348449E-04,   4.1037524E-04
     +,   3.7952655E-04,   3.5089065E-04,   3.2439720E-04
     +,   2.9996032E-04,   2.7748325E-04,   2.5685944E-04
     +,   2.3797422E-04,   2.2070958E-04,   2.0494699E-04
     +,   1.9056829E-04,   1.7745671E-04,   1.6549953E-04
     +,   1.5458977E-04,   1.4462620E-04,   1.3551344E-04
     +,   1.2716316E-04,   1.1949502E-04,   1.1243497E-04
     +,   1.0591622E-04,   9.9879173E-05,   9.4270763E-05
     +,   8.9043679E-05,   8.4156360E-05,   7.9572783E-05
     +,   7.5261698E-05,   7.1195813E-05,   6.7351655E-05
     +,   6.3709391E-05,   6.0252081E-05,   5.6965091E-05
     +,   5.3835978E-05,   5.0854440E-05,   4.8011425E-05
     +,   4.5299206E-05,   4.2711272E-05,   4.0241990E-05
     +,   3.7886235E-05,   3.5639478E-05,   3.3497767E-05
     +,   3.1457465E-05,   2.9515077E-05,   2.7667302E-05
     +,   2.5911164E-05,   2.4243551E-05,   2.2661639E-05
     +,   2.1162461E-05,   1.9743267E-05,   1.8401157E-05
     +,   1.7133418E-05,   1.5937185E-05,   1.4809768E-05
     +,   1.3748356E-05,   1.2750290E-05,   1.1812836E-05
     +,   1.0933303E-05,   1.0109121E-05,   9.3376457E-06
     +,   8.6163927E-06,   7.9428200E-06,   7.3145507E-06
     +,   6.7291680E-06,   6.1844103E-06,   5.6780073E-06
     +,   5.2078285E-06,   4.7717517E-06,   4.3677924E-06
     +,   3.9939850E-06,   3.6484964E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_asha_hatt95_mass = Yx/12.86842116
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_asha_htt100_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.1210548E-04,   1.1772561E-04
     +,   1.2351658E-04,   1.2948058E-04,   1.3562030E-04
     +,   1.4193910E-04,   1.4844113E-04,   1.5513154E-04
     +,   1.6201621E-04,   1.6910264E-04,   1.7639929E-04
     +,   1.8391610E-04,   1.9166441E-04,   1.9965725E-04
     +,   2.0790931E-04,   2.1643694E-04,   2.2525841E-04
     +,   2.3439365E-04,   2.4386449E-04,   2.5369448E-04
     +,   2.6390897E-04,   2.7453480E-04,   2.8560025E-04
     +,   2.9713564E-04,   3.0917092E-04,   3.2173845E-04
     +,   3.3487027E-04,   3.4859893E-04,   3.6295678E-04
     +,   3.7797587E-04,   3.9368696E-04,   4.1011980E-04
     +,   4.2730189E-04,   4.4525854E-04,   4.6401226E-04
     +,   4.8358197E-04,   5.0398300E-04,   5.2522559E-04
     +,   5.4731668E-04,   5.7025556E-04,   5.9403834E-04
     +,   6.1865378E-04,   6.4408476E-04,   6.7030749E-04
     +,   6.9729192E-04,   7.2500168E-04,   7.5339345E-04
     +,   7.8241772E-04,   8.1201934E-04,   8.4213732E-04
     +,   8.7270566E-04,   9.0365368E-04,   9.3490654E-04
     +,   9.6638838E-04,   9.9801784E-04,   1.0297156E-03
     +,   1.0614009E-03,   1.0929938E-03,   1.1244165E-03
     +,   1.1555951E-03,   1.1864594E-03,   1.2169463E-03
     +,   1.2469962E-03,   1.2765614E-03,   1.3056018E-03
     +,   1.3340855E-03,   1.3619949E-03,   1.3893213E-03
     +,   1.4160716E-03,   1.4422628E-03,   1.4679310E-03
     +,   1.4931216E-03,   1.5179004E-03,   1.5423455E-03
     +,   1.5665526E-03,   1.5906360E-03,   1.6147241E-03
     +,   1.6389617E-03,   1.6635153E-03,   1.6885665E-03
     +,   1.7143131E-03,   1.7409746E-03,   1.7687839E-03
     +,   1.7979953E-03,   1.8288781E-03,   1.8617208E-03
     +,   1.8968274E-03,   1.9345216E-03,   1.9751387E-03
     +,   2.0190345E-03,   2.0665808E-03,   2.1181630E-03
     +,   2.1741821E-03,   2.2350587E-03,   2.3012343E-03
     +,   2.3731638E-03,   2.4513353E-03,   2.5362559E-03
     +,   2.6284771E-03,   2.7285807E-03,   2.8372090E-03
     +,   2.9550518E-03,   3.0828810E-03,   3.2215326E-03
     +,   3.3719467E-03,   3.5351661E-03,   3.7123305E-03
     +,   3.9046973E-03,   4.1136523E-03,   4.3407055E-03
     +,   4.5874584E-03,   4.8556570E-03,   5.1471088E-03
     +,   5.4637510E-03,   5.8075464E-03,   6.1805607E-03
     +,   6.5848543E-03,   7.0225541E-03,   7.4957325E-03
     +,   8.0064824E-03,   8.5568475E-03,   9.1487607E-03
     +,   9.7840391E-03,   1.0464435E-02,   1.1191616E-02
     +,   1.1967186E-02,   1.2793071E-02,   1.3671678E-02
     +,   1.4606747E-02,   1.5603953E-02,   1.6672412E-02
     +,   1.7825861E-02,   1.9084558E-02,   2.0476524E-02
     +,   2.2038834E-02,   2.3817429E-02,   2.5865272E-02
     +,   2.8238308E-02,   3.0989025E-02,   3.4157317E-02
     +,   3.7759803E-02,   4.1779786E-02,   4.6160314E-02
     +,   5.0801713E-02,   5.5566564E-02,   6.0293872E-02
     +,   6.4819008E-02,   6.8998024E-02,   7.2732188E-02
     +,   7.5988181E-02,   7.8810781E-02,   8.1328094E-02
     +,   8.3751500E-02,   8.6371817E-02,   8.9549869E-02
     +,   9.3694240E-02,   9.9214546E-02,   0.1064425    
     +,   0.1155300    ,   0.1263618    ,   0.1385406    
     +,   0.1514755    ,   0.1645602    ,   0.1773669    
     +,   0.1897704    ,   0.2019754    ,   0.2144859    
     +,   0.2280329    ,   0.2434227    ,   0.2613450    
     +,   0.2823588    ,   0.3071591    ,   0.3366240    
     +,   0.3709906    ,   0.4088520    ,   0.4479125    
     +,   0.4873453    ,   0.5280288    ,   0.5692785    
     +,   0.6095859    ,   0.6587481    ,   0.7463263    
     +,   0.8943980    ,    1.070685    ,    1.204875    
     +,    1.281472    ,    1.383387    ,    1.566841    
     +,    1.806517    ,    2.193921    ,    2.748460    
     +,    3.353940    ,    3.959071    ,    4.692635    
     +,    5.217157    ,    4.401742    ,    2.338037    
     +,   0.6479017    ,   8.1175223E-02,   4.2025866E-03
     +,   8.5651787E-05,   9.9225542E-07,   2.8923515E-07
     +,   2.4712219E-07,   2.1233453E-07,   1.8226650E-07
     +,   1.5629739E-07,   1.3388907E-07,   1.1457210E-07
     +,   9.7935583E-08,   8.3621444E-08,   7.1318894E-08
     +,   6.0756676E-08,   5.1698425E-08,   4.3938439E-08
     +,   3.7298506E-08,   3.1623795E-08,   2.6779597E-08
     +,   2.2649262E-08,   1.9132125E-08,   1.6140813E-08
     +,   1.3599806E-08,   1.1444159E-08,   9.6178479E-09
     +,   8.0725133E-09,   6.7665957E-09,   5.6644969E-09
     +,   4.7356856E-09,   3.9539247E-09,   3.2968079E-09
     +,   2.7452285E-09,   2.2828806E-09,   1.8958484E-09
     +,   1.5722977E-09,   1.3022069E-09,   1.0770491E-09
     +,   8.8960428E-10,   7.3377782E-10,   6.0442307E-10
     +,   4.9718918E-10,   4.0841605E-10,   3.3503184E-10
     +,   2.7445546E-10,   2.2452179E-10,   1.8341761E-10
     +,   1.4963109E-10,   1.2189948E-10,   9.9169666E-11
     +,   8.0565388E-11,   6.5360509E-11,   5.2951379E-11
     +,   4.2838053E-11,   3.4607879E-11,   2.7920003E-11
     +,   2.2493040E-11,   1.8095438E-11,   1.4537187E-11
     +,   1.1662341E-11,   9.3428893E-12,   7.4741602E-12
     +,   5.9708063E-12,   4.7631673E-12,   3.7944292E-12
     +,   3.0184366E-12,   2.3977775E-12,   1.9020486E-12
     +,   1.5066730E-12,   1.1918002E-12,   9.4140602E-13
     +,   7.4256909E-13,   5.8489612E-13,   4.6005148E-13
     +,   3.6134577E-13,   2.8341636E-13,   2.2197644E-13
     +,   1.7361123E-13,   1.3559051E-13,   1.0574712E-13
     +,   8.2354757E-14,   6.4046492E-14,   4.9737331E-14
     +,   3.8570618E-14,   2.9868208E-14,   2.3096708E-14
     +,   1.7834836E-14,   1.3752272E-14,   1.0589206E-14
     +,   8.1419805E-15,   6.2514640E-15,   4.7930638E-15
     +,   3.6696978E-15,   2.8055925E-15,   2.1419284E-15
     +,   1.6329130E-15,   1.2431028E-15,   9.4499104E-16
     +,   7.1735337E-16,   5.4377292E-16,   4.1160830E-16
     +,   3.1112108E-16,   2.3483345E-16
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_asha_htt100_mass = Yx/11.3543434285714
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_asha_htt105_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.9624937E-04,   3.0282518E-04
     +,   3.0945014E-04,   3.1612764E-04,   3.2286186E-04
     +,   3.2965769E-04,   3.3652081E-04,   3.4345771E-04
     +,   3.5047549E-04,   3.5758247E-04,   3.6478747E-04
     +,   3.7210018E-04,   3.7953144E-04,   3.8709247E-04
     +,   3.9479564E-04,   4.0265417E-04,   4.1068182E-04
     +,   4.1889347E-04,   4.2730451E-04,   4.3593085E-04
     +,   4.4478948E-04,   4.5389769E-04,   4.6327323E-04
     +,   4.7293492E-04,   4.8290059E-04,   4.9319002E-04
     +,   5.0382200E-04,   5.1481579E-04,   5.2619068E-04
     +,   5.3796580E-04,   5.5015984E-04,   5.6279142E-04
     +,   5.7587877E-04,   5.8943918E-04,   6.0348946E-04
     +,   6.1804586E-04,   6.3312339E-04,   6.4873643E-04
     +,   6.6489895E-04,   6.8162277E-04,   6.9892005E-04
     +,   7.1680156E-04,   7.3527748E-04,   7.5435778E-04
     +,   7.7405205E-04,   7.9437043E-04,   8.1532350E-04
     +,   8.3692349E-04,   8.5918489E-04,   8.8212476E-04
     +,   9.0576505E-04,   9.3013293E-04,   9.5526181E-04
     +,   9.8119606E-04,   1.0079871E-03,   1.0357028E-03
     +,   1.0644238E-03,   1.0942497E-03,   1.1252996E-03
     +,   1.1577170E-03,   1.1916705E-03,   1.2273596E-03
     +,   1.2650124E-03,   1.3048952E-03,   1.3473111E-03
     +,   1.3925976E-03,   1.4411372E-03,   1.4933464E-03
     +,   1.5496860E-03,   1.6106472E-03,   1.6767607E-03
     +,   1.7485770E-03,   1.8266749E-03,   1.9116350E-03
     +,   2.0040458E-03,   2.1044845E-03,   2.2134939E-03
     +,   2.3315742E-03,   2.4591731E-03,   2.5966621E-03
     +,   2.7443049E-03,   2.9022738E-03,   3.0705938E-03
     +,   3.2491763E-03,   3.4377654E-03,   3.6359797E-03
     +,   3.8432707E-03,   4.0589822E-03,   4.2823176E-03
     +,   4.5124139E-03,   4.7483621E-03,   4.9892440E-03
     +,   5.2341931E-03,   5.4824883E-03,   5.7336162E-03
     +,   5.9873234E-03,   6.2437775E-03,   6.5035857E-03
     +,   6.7679645E-03,   7.0387796E-03,   7.3186955E-03
     +,   7.6112091E-03,   7.9208026E-03,   8.2529327E-03
     +,   8.6141666E-03,   9.0121804E-03,   9.4557479E-03
     +,   9.9547710E-03,   1.0520247E-02,   1.1164199E-02
     +,   1.1899488E-02,   1.2739830E-02,   1.3699368E-02
     +,   1.4792612E-02,   1.6033782E-02,   1.7436581E-02
     +,   1.9013159E-02,   2.0773649E-02,   2.2724751E-02
     +,   2.4869120E-02,   2.7204212E-02,   2.9721346E-02
     +,   3.2405507E-02,   3.5235841E-02,   3.8186289E-02
     +,   4.1227009E-02,   4.4327036E-02,   4.7455650E-02
     +,   5.0585069E-02,   5.3690892E-02,   5.6753568E-02
     +,   5.9757464E-02,   6.2692069E-02,   6.5552071E-02
     +,   6.8341069E-02,   7.1075998E-02,   7.3793195E-02
     +,   7.6554261E-02,   7.9449348E-02,   8.2594112E-02
     +,   8.6119711E-02,   9.0155929E-02,   9.4812408E-02
     +,   0.1001628    ,   0.1062410    ,   0.1130545    
     +,   0.1206093    ,   0.1289302    ,   0.1380578    
     +,   0.1480030    ,   0.1586679    ,   0.1697779    
     +,   0.1808910    ,   0.1915232    ,   0.2013635    
     +,   0.2104633    ,   0.2192728    ,   0.2284640    
     +,   0.2386169    ,   0.2499384    ,   0.2621539    
     +,   0.2746183    ,   0.2866457    ,   0.2980705    
     +,   0.3099098    ,   0.3246772    ,   0.3456776    
     +,   0.3751602    ,   0.4125120    ,   0.4542733    
     +,   0.4961782    ,   0.5351992    ,   0.5702853    
     +,   0.6031372    ,   0.6392572    ,   0.6852148    
     +,   0.7401984    ,   0.7909871    ,   0.8228244    
     +,   0.8384041    ,   0.8570017    ,   0.8919476    
     +,   0.9435166    ,    1.012758    ,    1.098208    
     +,    1.187908    ,    1.278941    ,    1.371625    
     +,    1.453370    ,    1.531141    ,    1.616659    
     +,    1.695193    ,    1.739156    ,    1.691451    
     +,    1.481106    ,    1.115276    ,   0.7037846    
     +,   0.3664306    ,   0.1546513    ,   5.1838063E-02
     +,   1.3555801E-02,   2.7316136E-03,   4.2110597E-04
     +,   4.9576589E-05,   4.5693487E-06,   4.4443115E-07
     +,   1.4419763E-07,   1.1375537E-07,   9.9243046E-08
     +,   8.6937668E-08,   7.6112180E-08,   6.6583176E-08
     +,   5.8201557E-08,   5.0834426E-08,   4.4363716E-08
     +,   3.8684981E-08,   3.3705390E-08,   2.9342196E-08
     +,   2.5522111E-08,   2.2180565E-08,   1.9259943E-08
     +,   1.6709322E-08,   1.4483834E-08,   1.2543786E-08
     +,   1.0853989E-08,   9.3834274E-09,   8.1048670E-09
     +,   6.9942638E-09,   6.0304113E-09,   5.1946474E-09
     +,   4.4706532E-09,   3.8440842E-09,   3.3023118E-09
     +,   2.8342853E-09,   2.4303777E-09,   2.0821174E-09
     +,   1.7821150E-09,   1.5239366E-09,   1.3019706E-09
     +,   1.1113136E-09,   9.4769881E-10,   8.0743073E-10
     +,   6.8729633E-10,   5.8450045E-10,   4.9662230E-10
     +,   4.2157117E-10,   3.5753750E-10,   3.0295477E-10
     +,   2.5647046E-10,   2.1692359E-10,   1.8330926E-10
     +,   1.5476373E-10,   1.3054650E-10,   1.1002116E-10
     +,   9.2640638E-11,   7.7936303E-11,   6.5508272E-11
     +,   5.5014167E-11,   4.6160839E-11,   3.8698513E-11
     +,   3.2414568E-11,   2.7127954E-11,   2.2684183E-11
     +,   1.8952220E-11,   1.5820997E-11,   1.3196088E-11
     +,   1.0997513E-11,   9.1577058E-12,   7.6194953E-12
     +,   6.3345397E-12,   5.2620287E-12,   4.3676195E-12
     +,   3.6224131E-12,   3.0020034E-12,   2.4859125E-12
     +,   2.0569857E-12,   1.7007676E-12,   1.4051905E-12
     +,   1.1601159E-12,   9.5708662E-13,   7.8901333E-13
     +,   6.4999368E-13,   5.3508592E-13,   4.4018858E-13
     +,   3.6186809E-13,   2.9728303E-13,   2.4406104E-13
     +,   2.0023317E-13,   1.6416966E-13,   1.3451416E-13
     +,   1.1014643E-13,   9.0136123E-14,   7.3716220E-14
     +,   6.0250545E-14,   4.9215562E-14,   4.0177839E-14
     +,   3.2781032E-14,   2.6730586E-14,   2.1784829E-14
     +,   1.7744239E-14,   1.4445351E-14
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_asha_htt105_mass = Yx/8.64120778723404
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_asha_htt107_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.5089156E-05,   1.6378855E-05
     +,   1.7763066E-05,   1.9247198E-05,   2.0836866E-05
     +,   2.2537852E-05,   2.4356110E-05,   2.6297746E-05
     +,   2.8369011E-05,   3.0576397E-05,   3.2926451E-05
     +,   3.5425895E-05,   3.8081595E-05,   4.0900559E-05
     +,   4.3889930E-05,   4.7057012E-05,   5.0409260E-05
     +,   5.3954333E-05,   5.7700054E-05,   6.1654508E-05
     +,   6.5826076E-05,   7.0223461E-05,   7.4855707E-05
     +,   7.9732694E-05,   8.4864405E-05,   9.0262110E-05
     +,   9.5937707E-05,   1.0190426E-04,   1.0817627E-04
     +,   1.1476975E-04,   1.2170267E-04,   1.2899528E-04
     +,   1.3667037E-04,   1.4475385E-04,   1.5327508E-04
     +,   1.6226736E-04,   1.7176865E-04,   1.8182164E-04
     +,   1.9247552E-04,   2.0378442E-04,   2.1581064E-04
     +,   2.2862318E-04,   2.4229930E-04,   2.5692486E-04
     +,   2.7259468E-04,   2.8941300E-04,   3.0749402E-04
     +,   3.2696174E-04,   3.4795006E-04,   3.7060265E-04
     +,   3.9507283E-04,   4.2152256E-04,   4.5012191E-04
     +,   4.8104968E-04,   5.1448710E-04,   5.5062363E-04
     +,   5.8964913E-04,   6.3175510E-04,   6.7713147E-04
     +,   7.2596461E-04,   7.7843550E-04,   8.3471747E-04
     +,   8.9496997E-04,   9.5934456E-04,   1.0279785E-03
     +,   1.1009864E-03,   1.1784753E-03,   1.2605235E-03
     +,   1.3472022E-03,   1.4385539E-03,   1.5346156E-03
     +,   1.6353985E-03,   1.7409129E-03,   1.8511480E-03
     +,   1.9660979E-03,   2.0857563E-03,   2.2101155E-03
     +,   2.3391754E-03,   2.4729604E-03,   2.6115165E-03
     +,   2.7549025E-03,   2.9032321E-03,   3.0566365E-03
     +,   3.2153146E-03,   3.3794988E-03,   3.5495060E-03
     +,   3.7257031E-03,   3.9085685E-03,   4.0986622E-03
     +,   4.2966916E-03,   4.5035207E-03,   4.7202031E-03
     +,   4.9480358E-03,   5.1886416E-03,   5.4440242E-03
     +,   5.7166326E-03,   6.0095093E-03,   6.3263215E-03
     +,   6.6715414E-03,   7.0504420E-03,   7.4692504E-03
     +,   7.9350537E-03,   8.4558735E-03,   9.0403697E-03
     +,   9.6977269E-03,   1.0437194E-02,   1.1267526E-02
     +,   1.2196323E-02,   1.3229333E-02,   1.4369534E-02
     +,   1.5616167E-02,   1.6964169E-02,   1.8403288E-02
     +,   1.9918047E-02,   2.1487473E-02,   2.3085963E-02
     +,   2.4683980E-02,   2.6249966E-02,   2.7752070E-02
     +,   2.9161008E-02,   3.0452684E-02,   3.1611156E-02
     +,   3.2631755E-02,   3.3524066E-02,   3.4314141E-02
     +,   3.5046455E-02,   3.5784684E-02,   3.6610853E-02
     +,   3.7622906E-02,   3.8929418E-02,   4.0642235E-02
     +,   4.2866670E-02,   4.5691106E-02,   4.9176835E-02
     +,   5.3352483E-02,   5.8213532E-02,   6.3728832E-02
     +,   6.9853246E-02,   7.6542825E-02,   8.3764441E-02
     +,   9.1495737E-02,   9.9714108E-02,   0.1083776    
     +,   0.1174060    ,   0.1266730    ,   0.1360175    
     +,   0.1452663    ,   0.1542610    ,   0.1628778    
     +,   0.1710341    ,   0.1786849    ,   0.1858160    
     +,   0.1924501    ,   0.1986771    ,   0.2047058    
     +,   0.2109212    ,   0.2178912    ,   0.2262619    
     +,   0.2365301    ,   0.2487833    ,   0.2625636    
     +,   0.2769587    ,   0.2908894    ,   0.3034567    
     +,   0.3142495    ,   0.3237200    ,   0.3337823    
     +,   0.3484211    ,   0.3734927    ,   0.4149703    
     +,   0.4757616    ,   0.5521363    ,   0.6323443    
     +,   0.7009832    ,   0.7474050    ,   0.7695565    
     +,   0.7715433    ,   0.7633553    ,   0.7621251    
     +,   0.7853708    ,   0.8387973    ,   0.9096472    
     +,   0.9729252    ,    1.017041    ,    1.064841    
     +,    1.141129    ,    1.223793    ,    1.274411    
     +,    1.305291    ,    1.356079    ,    1.417425    
     +,    1.437771    ,    1.387175    ,    1.257231    
     +,    1.041249    ,   0.7642930    ,   0.4887550    
     +,   0.2698833    ,   0.1270372    ,   5.0013084E-02
     +,   1.6154615E-02,   4.2200997E-03,   8.8374375E-04
     +,   1.4770558E-04,   1.9721972E-05,   2.1627848E-06
     +,   2.5260329E-07,   8.0347242E-08,   6.0626014E-08
     +,   5.2350998E-08,   4.5584596E-08,   3.9678778E-08
     +,   3.4510965E-08,   2.9991785E-08,   2.6042922E-08
     +,   2.2595341E-08,   1.9587974E-08,   1.6966714E-08
     +,   1.4683840E-08,   1.2697495E-08,   1.0970553E-08
     +,   9.4703845E-09,   8.1683780E-09,   7.0393855E-09
     +,   6.0612195E-09,   5.2144462E-09,   4.4820960E-09
     +,   3.8492773E-09,   3.3029277E-09,   2.8316383E-09
     +,   2.4254729E-09,   2.0757585E-09,   1.7749022E-09
     +,   1.5163083E-09,   1.2942536E-09,   1.1037377E-09
     +,   9.4042696E-10,   8.0056689E-10,   6.8090389E-10
     +,   5.7860911E-10,   4.9123988E-10,   4.1668924E-10
     +,   3.5313646E-10,   2.9900737E-10,   2.5294497E-10
     +,   2.1378523E-10,   1.8052507E-10,   1.5230112E-10
     +,   1.2837190E-10,   1.0810451E-10,   9.0953585E-11
     +,   7.6453288E-11,   6.4205675E-11,   5.3870800E-11
     +,   4.5157870E-11,   3.7818953E-11,   3.1643448E-11
     +,   2.6451990E-11,   2.2091700E-11,   1.8432882E-11
     +,   1.5365704E-11,   1.2797038E-11,   1.0647764E-11
     +,   8.8511273E-12,   7.3507962E-12,   6.0990189E-12
     +,   5.0556235E-12,   4.1867755E-12,   3.4639837E-12
     +,   2.8632654E-12,   2.3644615E-12,   1.9507035E-12
     +,   1.6078289E-12,   1.3239570E-12,   1.0891610E-12
     +,   8.9515271E-13,   7.3499502E-13,   6.0291914E-13
     +,   4.9409988E-13,   4.0453421E-13,   3.3088341E-13
     +,   2.7038398E-13,   2.2073153E-13,   1.8002475E-13
     +,   1.4668277E-13,   1.1940100E-13,   9.7099425E-14
     +,   7.8886421E-14,   6.4027925E-14,   5.1917279E-14
     +,   4.2056785E-14,   3.4035712E-14,   2.7517896E-14
     +,   2.2226431E-14,   1.7935059E-14,   1.4458085E-14
     +,   1.1643855E-14,   9.3682047E-15,   7.5300009E-15
     +,   6.0465261E-15,   4.8505998E-15
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_asha_htt107_mass = Yx/8.02090174468085
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_asha_htt110_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.1881951E-04,   2.2923070E-04
     +,   2.3995650E-04,   2.5099458E-04,   2.6234178E-04
     +,   2.7399411E-04,   2.8594671E-04,   2.9819369E-04
     +,   3.1072812E-04,   3.2354286E-04,   3.3662913E-04
     +,   3.4997743E-04,   3.6357748E-04,   3.7741812E-04
     +,   3.9148735E-04,   4.0577239E-04,   4.2025972E-04
     +,   4.3493524E-04,   4.4978419E-04,   4.6479117E-04
     +,   4.7994050E-04,   4.9521599E-04,   5.1060098E-04
     +,   5.2607956E-04,   5.4163404E-04,   5.5724860E-04
     +,   5.7290640E-04,   5.8859127E-04,   6.0428726E-04
     +,   6.1997911E-04,   6.3565205E-04,   6.5129215E-04
     +,   6.6688634E-04,   6.8242248E-04,   6.9788971E-04
     +,   7.1327831E-04,   7.2857982E-04,   7.4378721E-04
     +,   7.5889571E-04,   7.7390071E-04,   7.8880077E-04
     +,   8.0359564E-04,   8.1828685E-04,   8.3287794E-04
     +,   8.4737421E-04,   8.6178363E-04,   8.7611540E-04
     +,   8.9038117E-04,   9.0459461E-04,   9.1877178E-04
     +,   9.3293044E-04,   9.4709080E-04,   9.6127472E-04
     +,   9.7550778E-04,   9.8981569E-04,   1.0042284E-03
     +,   1.0187769E-03,   1.0334956E-03,   1.0484214E-03
     +,   1.0635935E-03,   1.0790548E-03,   1.0948511E-03
     +,   1.1110307E-03,   1.1276475E-03,   1.1447591E-03
     +,   1.1624257E-03,   1.1807153E-03,   1.1996982E-03
     +,   1.2194534E-03,   1.2400630E-03,   1.2616192E-03
     +,   1.2842182E-03,   1.3079668E-03,   1.3329769E-03
     +,   1.3593712E-03,   1.3872816E-03,   1.4168470E-03
     +,   1.4482155E-03,   1.4815464E-03,   1.5170078E-03
     +,   1.5547740E-03,   1.5950323E-03,   1.6379717E-03
     +,   1.6837950E-03,   1.7327048E-03,   1.7849148E-03
     +,   1.8406379E-03,   1.9000957E-03,   1.9635074E-03
     +,   2.0311002E-03,   2.1031059E-03,   2.1797593E-03
     +,   2.2613059E-03,   2.3480139E-03,   2.4401823E-03
     +,   2.5381469E-03,   2.6423242E-03,   2.7532163E-03
     +,   2.8714836E-03,   2.9979630E-03,   3.1337745E-03
     +,   3.2803675E-03,   3.4396555E-03,   3.6140967E-03
     +,   3.8068551E-03,   4.0219221E-03,   4.2642476E-03
     +,   4.5398688E-03,   4.8560579E-03,   5.2213711E-03
     +,   5.6456439E-03,   6.1400323E-03,   6.7167636E-03
     +,   7.3890248E-03,   8.1704324E-03,   9.0746945E-03
     +,   1.0114728E-02,   1.1302044E-02,   1.2645506E-02
     +,   1.4150497E-02,   1.5817657E-02,   1.7641691E-02
     +,   1.9610509E-02,   2.1704821E-02,   2.3897963E-02
     +,   2.6156379E-02,   2.8441744E-02,   3.0712973E-02
     +,   3.2930575E-02,   3.5060856E-02,   3.7082072E-02
     +,   3.8990144E-02,   4.0805090E-02,   4.2575691E-02
     +,   4.4382855E-02,   4.6339065E-02,   4.8582949E-02
     +,   5.1268499E-02,   5.4548372E-02,   5.8551896E-02
     +,   6.3360438E-02,   6.8985723E-02,   7.5356692E-02
     +,   8.2322530E-02,   8.9678921E-02,   9.7222671E-02
     +,   0.1048225    ,   0.1124841    ,   0.1203740    
     +,   0.1287669    ,   0.1379149    ,   0.1478863    
     +,   0.1584735    ,   0.1692536    ,   0.1798136    
     +,   0.1900290    ,   0.2002116    ,   0.2109751    
     +,   0.2228287    ,   0.2357136    ,   0.2487971    
     +,   0.2607499    ,   0.2704407    ,   0.2776195    
     +,   0.2830384    ,   0.2878356    ,   0.2927627    
     +,   0.2982011    ,   0.3052118    ,   0.3165844    
     +,   0.3363602    ,   0.3674828    ,   0.4092310    
     +,   0.4568684    ,   0.5038956    ,   0.5443793    
     +,   0.5738693    ,   0.5914034    ,   0.6024433    
     +,   0.6166613    ,   0.6415852    ,   0.6820452    
     +,   0.7452477    ,   0.8367163    ,   0.9404818    
     +,    1.014795    ,    1.028019    ,   0.9901246    
     +,   0.9483231    ,   0.9538236    ,    1.006787    
     +,    1.046132    ,    1.013150    ,   0.8989871    
     +,   0.7289463    ,   0.5351632    ,   0.3497347    
     +,   0.2001698    ,   9.9225469E-02,   4.2267483E-02
     +,   1.5355594E-02,   4.7180443E-03,   1.2155795E-03
     +,   2.6069826E-04,   4.6327903E-05,   6.8420586E-06
     +,   8.8148295E-07,   1.3805050E-07,   5.5209675E-08
     +,   4.1472152E-08,   3.4575624E-08,   2.9062141E-08
     +,   2.4417819E-08,   2.0495083E-08,   1.7184517E-08
     +,   1.4393605E-08,   1.2043350E-08,   1.0066199E-08
     +,   8.4046592E-09,   7.0099371E-09,   5.8404126E-09
     +,   4.8607545E-09,   4.0410626E-09,   3.3559890E-09
     +,   2.7840332E-09,   2.3070290E-09,   1.9096682E-09
     +,   1.5790292E-09,   1.3042055E-09,   1.0760233E-09
     +,   8.8678526E-10,   7.3002582E-10,   6.0031236E-10
     +,   4.9309651E-10,   4.0458184E-10,   3.3158648E-10
     +,   2.7145666E-10,   2.2198243E-10,   1.8132312E-10
     +,   1.4794534E-10,   1.2057536E-10,   9.8158308E-11
     +,   7.9819637E-11,   6.4833965E-11,   5.2601895E-11
     +,   4.2629372E-11,   3.4508639E-11,   2.7903180E-11
     +,   2.2536318E-11,   1.8181187E-11,   1.4650935E-11
     +,   1.1792642E-11,   9.4811520E-12,   7.6140578E-12
     +,   6.1076578E-12,   4.8936363E-12,   3.9164345E-12
     +,   3.1307858E-12,   2.4998562E-12,   1.9937634E-12
     +,   1.5882967E-12,   1.2638350E-12,   1.0044909E-12
     +,   7.9743612E-13,   6.3233251E-13,   5.0083050E-13
     +,   3.9621236E-13,   3.1308335E-13,   2.4710914E-13
     +,   1.9481034E-13,   1.5340000E-13,   1.2065097E-13
     +,   9.4783542E-14,   7.4374921E-14,   5.8292069E-14
     +,   4.5633836E-14,   3.5682344E-14,   2.7868517E-14
     +,   2.1740181E-14,   1.6939732E-14,   1.3183752E-14
     +,   1.0248623E-14,   7.9575772E-15,   6.1715134E-15
     +,   4.7807132E-15,   3.6990361E-15,   2.8587783E-15
     +,   2.2067912E-15,   1.7015429E-15,   1.3104337E-15
     +,   1.0080647E-15,   7.7456324E-16,   5.9446763E-16
     +,   4.5571828E-16,   3.4895770E-16,   2.6689953E-16
     +,   2.0390745E-16,   1.5560451E-16,   1.1861143E-16
     +,   9.0310573E-17,   6.8686246E-17
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_asha_htt110_mass = Yx/6.141317
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_asha_htt115_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.0986994E-05,   1.2251999E-05
     +,   1.3645185E-05,   1.5177363E-05,   1.6859998E-05
     +,   1.8705232E-05,   2.0725856E-05,   2.2935375E-05
     +,   2.5347917E-05,   2.7978404E-05,   3.0842315E-05
     +,   3.3955832E-05,   3.7335732E-05,   4.0999439E-05
     +,   4.4964927E-05,   4.9250684E-05,   5.3875701E-05
     +,   5.8859383E-05,   6.4221509E-05,   6.9982081E-05
     +,   7.6161392E-05,   8.2779770E-05,   8.9857444E-05
     +,   9.7415068E-05,   1.0547221E-04,   1.1404892E-04
     +,   1.2316434E-04,   1.3283706E-04,   1.4308501E-04
     +,   1.5392514E-04,   1.6537329E-04,   1.7744424E-04
     +,   1.9015126E-04,   2.0350612E-04,   2.1751893E-04
     +,   2.3219800E-04,   2.4754956E-04,   2.6357753E-04
     +,   2.8028476E-04,   2.9766976E-04,   3.1573063E-04
     +,   3.3446189E-04,   3.5385598E-04,   3.7390276E-04
     +,   3.9458973E-04,   4.1590221E-04,   4.3782339E-04
     +,   4.6033438E-04,   4.8341503E-04,   5.0704350E-04
     +,   5.3119747E-04,   5.5585423E-04,   5.8099121E-04
     +,   6.0658832E-04,   6.3262437E-04,   6.5908430E-04
     +,   6.8595493E-04,   7.1322883E-04,   7.4090477E-04
     +,   7.6898868E-04,   7.9749629E-04,   8.2645379E-04
     +,   8.5589790E-04,   8.8588108E-04,   9.1647112E-04
     +,   9.4774930E-04,   9.7981945E-04,   1.0127997E-03
     +,   1.0468331E-03,   1.0820790E-03,   1.1187226E-03
     +,   1.1569652E-03,   1.1970336E-03,   1.2391697E-03
     +,   1.2836360E-03,   1.3307119E-03,   1.3806862E-03
     +,   1.4338563E-03,   1.4905299E-03,   1.5510145E-03
     +,   1.6156100E-03,   1.6846152E-03,   1.7583088E-03
     +,   1.8369622E-03,   1.9208180E-03,   2.0101080E-03
     +,   2.1050321E-03,   2.2057840E-03,   2.3125284E-03
     +,   2.4254355E-03,   2.5446790E-03,   2.6704445E-03
     +,   2.8029559E-03,   2.9425032E-03,   3.0894654E-03
     +,   3.2443227E-03,   3.4077272E-03,   3.5804925E-03
     +,   3.7636799E-03,   3.9585889E-03,   4.1668452E-03
     +,   4.3903841E-03,   4.6315356E-03,   4.8929951E-03
     +,   5.1778853E-03,   5.4897359E-03,   5.8324407E-03
     +,   6.2102280E-03,   6.6276030E-03,   7.0892270E-03
     +,   7.5997091E-03,   8.1635481E-03,   8.7847942E-03
     +,   9.4669880E-03,   1.0212811E-02,   1.1024133E-02
     +,   1.1901737E-02,   1.2845624E-02,   1.3854916E-02
     +,   1.4928417E-02,   1.6064899E-02,   1.7263507E-02
     +,   1.8524181E-02,   1.9848013E-02,   2.1237088E-02
     +,   2.2693975E-02,   2.4221152E-02,   2.5819357E-02
     +,   2.7486429E-02,   2.9215166E-02,   3.0992376E-02
     +,   3.2797668E-02,   3.4604426E-02,   3.6381658E-02
     +,   3.8098820E-02,   3.9732348E-02,   4.1273944E-02
     +,   4.2739499E-02,   4.4176392E-02,   4.5666717E-02
     +,   4.7324419E-02,   4.9286347E-02,   5.1698275E-02
     +,   5.4699775E-02,   5.8412768E-02,   6.2938094E-02
     +,   6.8357542E-02,   7.4734963E-02,   8.2107015E-02
     +,   9.0452634E-02,   9.9641502E-02,   0.1093774    
     +,   0.1191722    ,   0.1283883    ,   0.1363719    
     +,   0.1426565    ,   0.1471600    ,   0.1502615    
     +,   0.1526773    ,   0.1551629    ,   0.1581929    
     +,   0.1618194    ,   0.1658240    ,   0.1701065    
     +,   0.1751119    ,   0.1820724    ,   0.1929022    
     +,   0.2096372    ,   0.2334327    ,   0.2634712    
     +,   0.2966014    ,   0.3284307    ,   0.3553507    
     +,   0.3759618    ,   0.3913863    ,   0.4053999    
     +,   0.4239544    ,   0.4518229    ,   0.4873942    
     +,   0.5222990    ,   0.5492381    ,   0.5690453    
     +,   0.5862238    ,   0.6000357    ,   0.6087299    
     +,   0.6223862    ,   0.6585661    ,   0.7190238    
     +,   0.7780140    ,   0.8018981    ,   0.7811124    
     +,   0.7329260    ,   0.6712325    ,   0.5907485    
     +,   0.4849096    ,   0.3632332    ,   0.2458934    
     +,   0.1496771    ,   8.1412010E-02,   3.9248277E-02
     +,   1.6641792E-02,   6.1715622E-03,   1.9949228E-03
     +,   5.6093791E-04,   1.3701576E-04,   2.9048089E-05
     +,   5.3645294E-06,   8.9181111E-07,   1.6139300E-07
     +,   5.4067407E-08,   3.5914400E-08,   2.9313718E-08
     +,   2.4609344E-08,   2.0695168E-08,   1.7383714E-08
     +,   1.4581909E-08,   1.2214604E-08,   1.0217249E-08
     +,   8.5344585E-09,   7.1188659E-09,   5.9297451E-09
     +,   4.9323021E-09,   4.0968877E-09,   3.3982266E-09
     +,   2.8147649E-09,   2.3282052E-09,   1.9230586E-09
     +,   1.5862049E-09,   1.3065287E-09,   1.0746549E-09
     +,   8.8269914E-10,   7.2402506E-10,   5.9304645E-10
     +,   4.8508342E-10,   3.9622555E-10,   3.2319444E-10
     +,   2.6325667E-10,   2.1413689E-10,   1.7394174E-10
     +,   1.4109602E-10,   1.1429321E-10,   9.2454031E-11
     +,   7.4684994E-11,   6.0247814E-11,   4.8534142E-11
     +,   3.9044015E-11,   3.1366527E-11,   2.5164107E-11
     +,   2.0160262E-11,   1.6129428E-11,   1.2886801E-11
     +,   1.0281926E-11,   8.1923591E-12,   6.5185882E-12
     +,   5.1797100E-12,   4.1101996E-12,   3.2570789E-12
     +,   2.5775473E-12,   2.0370196E-12,   1.6076501E-12
     +,   1.2670670E-12,   9.9729632E-13,   7.8390121E-13
     +,   6.1533108E-13,   4.8236442E-13,   3.7762163E-13
     +,   2.9522362E-13,   2.3049574E-13,   1.7971998E-13
     +,   1.3994209E-13,   1.0882182E-13,   8.4509277E-14
     +,   6.5541621E-14,   5.0763528E-14,   3.9264995E-14
     +,   3.0330979E-14,   2.3398489E-14,   1.8026779E-14
     +,   1.3869822E-14,   1.0657450E-14,   8.1782352E-15
     +,   6.2675530E-15,   4.7969128E-15,   3.6665570E-15
     +,   2.7988688E-15,   2.1337361E-15,   1.6245446E-15
     +,   1.2352363E-15,   9.3800937E-16,   7.1136649E-16
     +,   5.3878929E-16,   4.0754450E-16,   3.0787384E-16
     +,   2.3227520E-16,   1.7501420E-16,   1.3169791E-16
     +,   9.8975112E-17,   7.4286311E-17,   5.5684694E-17
     +,   4.1686879E-17,   3.1167970E-17
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_asha_htt115_mass = Yx/4.53889311627907
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_asha_htt120_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.2660620E-04,   1.3797858E-04
     +,   1.5017125E-04,   1.6322084E-04,   1.7716290E-04
     +,   1.9203174E-04,   2.0786002E-04,   2.2467822E-04
     +,   2.4251411E-04,   2.6139343E-04,   2.8133753E-04
     +,   3.0236435E-04,   3.2448731E-04,   3.4771519E-04
     +,   3.7205167E-04,   3.9749430E-04,   4.2403504E-04
     +,   4.5165903E-04,   4.8034481E-04,   5.1006372E-04
     +,   5.4077944E-04,   5.7244848E-04,   6.0501910E-04
     +,   6.3843350E-04,   6.7262305E-04,   7.0751458E-04
     +,   7.4302609E-04,   7.7906868E-04,   8.1554655E-04
     +,   8.5235847E-04,   8.8939694E-04,   9.2654978E-04
     +,   9.6370105E-04,   1.0007316E-03,   1.0375195E-03
     +,   1.0739428E-03,   1.1098788E-03,   1.1452053E-03
     +,   1.1798055E-03,   1.2135621E-03,   1.2463666E-03
     +,   1.2781149E-03,   1.3087108E-03,   1.3380678E-03
     +,   1.3661088E-03,   1.3927685E-03,   1.4179946E-03
     +,   1.4417478E-03,   1.4640033E-03,   1.4847530E-03
     +,   1.5040041E-03,   1.5217803E-03,   1.5381230E-03
     +,   1.5530916E-03,   1.5667612E-03,   1.5792273E-03
     +,   1.5906000E-03,   1.6010078E-03,   1.6105941E-03
     +,   1.6195184E-03,   1.6279537E-03,   1.6360860E-03
     +,   1.6441122E-03,   1.6522390E-03,   1.6606809E-03
     +,   1.6696574E-03,   1.6793923E-03,   1.6901088E-03
     +,   1.7020303E-03,   1.7153745E-03,   1.7303533E-03
     +,   1.7471692E-03,   1.7660123E-03,   1.7870576E-03
     +,   1.8104647E-03,   1.8363744E-03,   1.8649044E-03
     +,   1.8961508E-03,   1.9301863E-03,   1.9670599E-03
     +,   2.0067927E-03,   2.0493851E-03,   2.0948078E-03
     +,   2.1430159E-03,   2.1939366E-03,   2.2474844E-03
     +,   2.3035535E-03,   2.3620313E-03,   2.4227907E-03
     +,   2.4857062E-03,   2.5506520E-03,   2.6175031E-03
     +,   2.6861436E-03,   2.7564755E-03,   2.8284166E-03
     +,   2.9019017E-03,   2.9768983E-03,   3.0533955E-03
     +,   3.1314245E-03,   3.2110475E-03,   3.2923820E-03
     +,   3.3755926E-03,   3.4609218E-03,   3.5486831E-03
     +,   3.6393050E-03,   3.7333425E-03,   3.8315065E-03
     +,   3.9347038E-03,   4.0440890E-03,   4.1611097E-03
     +,   4.2875367E-03,   4.4255625E-03,   4.5778127E-03
     +,   4.7474438E-03,   4.9381475E-03,   5.1542455E-03
     +,   5.4006623E-03,   5.6830142E-03,   6.0075307E-03
     +,   6.3811345E-03,   6.8113836E-03,   7.3064379E-03
     +,   7.8750541E-03,   8.5266484E-03,   9.2713153E-03
     +,   1.0119824E-02,   1.1083952E-02,   1.2176406E-02
     +,   1.3411210E-02,   1.4803428E-02,   1.6369220E-02
     +,   1.8124692E-02,   2.0084914E-02,   2.2261163E-02
     +,   2.4658117E-02,   2.7269866E-02,   3.0075464E-02
     +,   3.3035416E-02,   3.6089696E-02,   3.9158151E-02
     +,   4.2144608E-02,   4.4946197E-02,   4.7467448E-02
     +,   4.9638439E-02,   5.1435206E-02,   5.2899800E-02
     +,   5.4153249E-02,   5.5396453E-02,   5.6892999E-02
     +,   5.8930900E-02,   6.1766054E-02,   6.5557271E-02
     +,   7.0310526E-02,   7.5853847E-02,   8.1860386E-02
     +,   8.7928206E-02,   9.3707919E-02,   9.9042378E-02
     +,   0.1040645    ,   0.1091966    ,   0.1150233    
     +,   0.1220605    ,   0.1305111    ,   0.1401326    
     +,   0.1502984    ,   0.1602219    ,   0.1691997    
     +,   0.1767328    ,   0.1825438    ,   0.1866622    
     +,   0.1896667    ,   0.1928422    ,   0.1978775    
     +,   0.2061270    ,   0.2179982    ,   0.2330435    
     +,   0.2506889    ,   0.2708770    ,   0.2937712    
     +,   0.3184783    ,   0.3423349    ,   0.3626422    
     +,   0.3796513    ,   0.3963853    ,   0.4145145    
     +,   0.4323876    ,   0.4486060    ,   0.4650317    
     +,   0.4838377    ,   0.5026572    ,   0.5138164    
     +,   0.5076383    ,   0.4769002    ,   0.4205984    
     +,   0.3452485    ,   0.2624203    ,   0.1840137    
     +,   0.1185004    ,   6.9651358E-02,   3.7105557E-02
     +,   1.7799167E-02,   7.6465495E-03,   2.9294696E-03
     +,   9.9749921E-04,   3.0108611E-04,   8.0380050E-05
     +,   1.8952200E-05,   3.9522711E-06,   7.3975610E-07
     +,   1.3494792E-07,   3.3229171E-08,   1.6411430E-08
     +,   1.2364110E-08,   1.0243839E-08,   8.5963379E-09
     +,   7.2183992E-09,   6.0563168E-09,   5.0762017E-09
     +,   4.2502291E-09,   3.5548746E-09,   2.9700566E-09
     +,   2.4786926E-09,   2.0663062E-09,   1.7205871E-09
     +,   1.4310708E-09,   1.1888857E-09,   9.8653485E-10
     +,   8.1766804E-10,   6.7690403E-10,   5.5970328E-10
     +,   4.6224105E-10,   3.8129425E-10,   3.1414366E-10
     +,   2.5850450E-10,   2.1246316E-10,   1.7440992E-10
     +,   1.4299679E-10,   1.1709864E-10,   9.5774333E-11
     +,   7.8237659E-11,   6.3833265E-11,   5.2017248E-11
     +,   4.2336776E-11,   3.4415706E-11,   2.7942201E-11
     +,   2.2658564E-11,   1.8351669E-11,   1.4845222E-11
     +,   1.1994007E-11,   9.6786208E-12,   7.8006872E-12
     +,   6.2794071E-12,   5.0486455E-12,   4.0541949E-12
     +,   3.2516680E-12,   2.6048172E-12,   2.0841081E-12
     +,   1.6654825E-12,   1.3293325E-12,   1.0597373E-12
     +,   8.4379763E-13,   6.7105414E-13,   5.3303141E-13
     +,   4.2288484E-13,   3.3509830E-13,   2.6521707E-13
     +,   2.0965547E-13,   1.6553503E-13,   1.3054449E-13
     +,   1.0282733E-13,   8.0897820E-14,   6.3569287E-14
     +,   4.9893676E-14,   3.9113474E-14,   3.0625896E-14
     +,   2.3951918E-14,   1.8710036E-14,   1.4598183E-14
     +,   1.1376436E-14,   8.8553356E-15,   6.8847613E-15
     +,   5.3464631E-15,   4.1469526E-15,   3.2128127E-15
     +,   2.4861620E-15,   1.9216253E-15,   1.4835410E-15
     +,   1.1439839E-15,   8.8112338E-16,   6.7786422E-16
     +,   5.2089122E-16,   3.9979955E-16,   3.0650372E-16
     +,   2.3470423E-16,   1.7951712E-16,   1.3714607E-16
     +,   1.0465523E-16,   7.9768686E-17,   6.0730171E-17
     +,   4.6181725E-17,   3.5078258E-17
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_asha_htt120_mass = Yx/3.04703805
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_asha_htt60_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.5350938E-03,   2.6256863E-03
     +,   2.7188698E-03,   2.8146955E-03,   2.9132150E-03
     +,   3.0144756E-03,   3.1185220E-03,   3.2253980E-03
     +,   3.3351420E-03,   3.4477988E-03,   3.5634092E-03
     +,   3.6820180E-03,   3.8036765E-03,   3.9284448E-03
     +,   4.0563955E-03,   4.1876165E-03,   4.3222182E-03
     +,   4.4603311E-03,   4.6021221E-03,   4.7477884E-03
     +,   4.8975660E-03,   5.0517377E-03,   5.2106287E-03
     +,   5.3746221E-03,   5.5441372E-03,   5.7196622E-03
     +,   5.9017297E-03,   6.0909200E-03,   6.2878551E-03
     +,   6.4932075E-03,   6.7076706E-03,   6.9319648E-03
     +,   7.1668220E-03,   7.4129836E-03,   7.6711746E-03
     +,   7.9421019E-03,   8.2264487E-03,   8.5248519E-03
     +,   8.8379215E-03,   9.1661764E-03,   9.5101213E-03
     +,   9.8701818E-03,   1.0246723E-02,   1.0640060E-02
     +,   1.1050441E-02,   1.1478073E-02,   1.1923120E-02
     +,   1.2385708E-02,   1.2865947E-02,   1.3363963E-02
     +,   1.3879971E-02,   1.4414282E-02,   1.4967490E-02
     +,   1.5540631E-02,   1.6135307E-02,   1.6754156E-02
     +,   1.7401116E-02,   1.8081961E-02,   1.8804895E-02
     +,   1.9581126E-02,   2.0425603E-02,   2.1357605E-02
     +,   2.2401173E-02,   2.3585469E-02,   2.4944657E-02
     +,   2.6517216E-02,   2.8345339E-02,   3.0473070E-02
     +,   3.2945182E-02,   3.5804704E-02,   3.9091878E-02
     +,   4.2841855E-02,   4.7084074E-02,   5.1840041E-02
     +,   5.7122696E-02,   6.2934674E-02,   6.9266260E-02
     +,   7.6095194E-02,   8.3388679E-02,   9.1108359E-02
     +,   9.9219248E-02,   0.1077053    ,   0.1165819    
     +,   0.1259073    ,   0.1357756    ,   0.1462940    
     +,   0.1575309    ,   0.1694605    ,   0.1819090    
     +,   0.1945548    ,   0.2069901    ,   0.2188502    
     +,   0.2299666    ,   0.2404640    ,   0.2507237    
     +,   0.2611845    ,   0.2720527    ,   0.2830476    
     +,   0.2933566    ,   0.3018757    ,   0.3076856    
     +,   0.3105599    ,   0.3112592    ,   0.3114273    
     +,   0.3131168    ,   0.3181285    ,   0.3274516    
     +,   0.3409943    ,   0.3576498    ,   0.3756401    
     +,   0.3930570    ,   0.4085370    ,   0.4218822    
     +,   0.4343012    ,   0.4479588    ,   0.4649410    
     +,   0.4862738    ,   0.5116891    ,   0.5401798    
     +,   0.5707814    ,   0.6031748    ,   0.6379817    
     +,   0.6762899    ,   0.7180049    ,   0.7601109    
     +,   0.7971094    ,   0.8241695    ,   0.8402244    
     +,   0.8476700    ,   0.8489503    ,   0.8439011    
     +,   0.8304408    ,   0.8070387    ,   0.7741638    
     +,   0.7339209    ,   0.6888061    ,   0.6405666    
     +,   0.5900778    ,   0.5384373    ,   0.4880461    
     +,   0.4421888    ,   0.4032967    ,   0.3715740    
     +,   0.3452121    ,   0.3217817    ,   0.2995628    
     +,   0.2780538    ,   0.2577125    ,   0.2393895    
     +,   0.2238241    ,   0.2113418    ,   0.2017531    
     +,   0.1944136    ,   0.1883931    ,   0.1827034    
     +,   0.1765074    ,   0.1692661    ,   0.1607915    
     +,   0.1512134    ,   0.1408866    ,   0.1302744    
     +,   0.1198406    ,   0.1099747    ,   0.1009504    
     +,   9.2918955E-02,   8.5923404E-02,   7.9925388E-02
     +,   7.4831896E-02,   7.0518784E-02,   6.6849887E-02
     +,   6.3690081E-02,   6.0913015E-02,   5.8405891E-02
     +,   5.6072008E-02,   5.3832158E-02,   5.1624220E-02
     +,   4.9402706E-02,   4.7138106E-02,   4.4814683E-02
     +,   4.2428743E-02,   3.9986435E-02,   3.7501551E-02
     +,   3.4993090E-02,   3.2483090E-02,   2.9994922E-02
     +,   2.7551960E-02,   2.5176294E-02,   2.2887727E-02
     +,   2.0703366E-02,   1.8637514E-02,   1.6701035E-02
     +,   1.4901600E-02,   1.3243842E-02,   1.1729435E-02
     +,   1.0357220E-02,   9.1236774E-03,   8.0233123E-03
     +,   7.0489421E-03,   6.1920411E-03,   5.4432079E-03
     +,   4.7925753E-03,   4.2300834E-03,   3.7457487E-03
     +,   3.3299606E-03,   2.9737086E-03,   2.6686352E-03
     +,   2.4071762E-03,   2.1826162E-03,   1.9890696E-03
     +,   1.8214434E-03,   1.6754090E-03,   1.5473377E-03
     +,   1.4342159E-03,   1.3335631E-03,   1.2433589E-03
     +,   1.1619781E-03,   1.0881148E-03,   1.0207178E-03
     +,   9.5894700E-04,   9.0213161E-04,   8.4972539E-04
     +,   8.0128096E-04,   7.5643120E-04,   7.1486575E-04
     +,   6.7631539E-04,   6.4054452E-04,   6.0734496E-04
     +,   5.7652785E-04,   5.4791762E-04,   5.2135112E-04
     +,   4.9667771E-04,   4.7375550E-04,   4.5244885E-04
     +,   4.3263056E-04,   4.1418168E-04,   3.9698899E-04
     +,   3.8094562E-04,   3.6595235E-04,   3.5191656E-04
     +,   3.3875080E-04,   3.2637393E-04,   3.1471177E-04
     +,   3.0369565E-04,   2.9326216E-04,   2.8335329E-04
     +,   2.7391684E-04,   2.6490577E-04,   2.5627681E-04
     +,   2.4799164E-04,   2.4001666E-04,   2.3232141E-04
     +,   2.2487917E-04,   2.1766705E-04,   2.1066511E-04
     +,   2.0385582E-04,   1.9722416E-04,   1.9075784E-04
     +,   1.8444659E-04,   1.7828149E-04,   1.7225521E-04
     +,   1.6636222E-04,   1.6059811E-04,   1.5495914E-04
     +,   1.4944241E-04,   1.4404632E-04,   1.3876923E-04
     +,   1.3361002E-04,   1.2856832E-04,   1.2364396E-04
     +,   1.1883662E-04,   1.1414615E-04,   1.0957281E-04
     +,   1.0511687E-04,   1.0077820E-04,   9.6556723E-05
     +,   9.2452654E-05,   8.8465538E-05,   8.4595384E-05
     +,   8.0841535E-05,   7.7203673E-05,   7.3680872E-05
     +,   7.0272523E-05,   6.6977409E-05,   6.3794621E-05
     +,   6.0722687E-05,   5.7760379E-05,   5.4906061E-05
     +,   5.2157990E-05,   4.9514558E-05,   4.6973724E-05
     +,   4.4533663E-05,   4.2192143E-05,   3.9947157E-05
     +,   3.7796344E-05,   3.5737565E-05,   3.3768334E-05
     +,   3.1886404E-05,   3.0089228E-05,   2.8374465E-05
     +,   2.6739541E-05,   2.5182069E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_asha_htt60_mass = Yx/8.10705536170213
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_asha_htt65_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  7.7069207E-04,   8.0891547E-04
     +,   8.4925123E-04,   8.9181215E-04,   9.3671534E-04
     +,   9.8408444E-04,   1.0340480E-03,   1.0867405E-03
     +,   1.1423024E-03,   1.2008824E-03,   1.2626342E-03
     +,   1.3277194E-03,   1.3963071E-03,   1.4685742E-03
     +,   1.5447058E-03,   1.6248970E-03,   1.7093504E-03
     +,   1.7982788E-03,   1.8919050E-03,   1.9904613E-03
     +,   2.0941906E-03,   2.2033453E-03,   2.3181855E-03
     +,   2.4389878E-03,   2.5660235E-03,   2.6995826E-03
     +,   2.8399539E-03,   2.9874279E-03,   3.1422945E-03
     +,   3.3048384E-03,   3.4753354E-03,   3.6540471E-03
     +,   3.8412123E-03,   4.0370477E-03,   4.2417380E-03
     +,   4.4554323E-03,   4.6782363E-03,   4.9102111E-03
     +,   5.1513878E-03,   5.4017315E-03,   5.6611993E-03
     +,   5.9297131E-03,   6.2071984E-03,   6.4936085E-03
     +,   6.7889569E-03,   7.0933755E-03,   7.4071614E-03
     +,   7.7308458E-03,   8.0652852E-03,   8.4117204E-03
     +,   8.7718908E-03,   9.1481060E-03,   9.5433276E-03
     +,   9.9612651E-03,   1.0406343E-02,   1.0883812E-02
     +,   1.1399642E-02,   1.1960466E-02,   1.2573451E-02
     +,   1.3246089E-02,   1.3985956E-02,   1.4800385E-02
     +,   1.5696095E-02,   1.6678896E-02,   1.7753303E-02
     +,   1.8922057E-02,   2.0186145E-02,   2.1544298E-02
     +,   2.2993298E-02,   2.4527760E-02,   2.6140766E-02
     +,   2.7823957E-02,   2.9568555E-02,   3.1365637E-02
     +,   3.3207379E-02,   3.5087541E-02,   3.7002213E-02
     +,   3.8950313E-02,   4.0934101E-02,   4.2959161E-02
     +,   4.5034178E-02,   4.7171120E-02,   4.9384847E-02
     +,   5.1693659E-02,   5.4119531E-02,   5.6689639E-02
     +,   5.9437420E-02,   6.2406007E-02,   6.5651640E-02
     +,   6.9251068E-02,   7.3311150E-02,   7.7980369E-02
     +,   8.3459929E-02,   9.0007313E-02,   9.7923614E-02
     +,   0.1075224    ,   0.1190859    ,   0.1328192    
     +,   0.1488288    ,   0.1671200    ,   0.1876210    
     +,   0.2101869    ,   0.2345847    ,   0.2604275    
     +,   0.2870897    ,   0.3136061    ,   0.3386268    
     +,   0.3605341    ,   0.3778191    ,   0.3896837    
     +,   0.3966135    ,   0.4005745    ,   0.4046302    
     +,   0.4121494    ,   0.4259745    ,   0.4478361    
     +,   0.4781231    ,   0.5159641    ,   0.5593737    
     +,   0.6052031    ,   0.6491676    ,   0.6869945    
     +,   0.7167224    ,   0.7396795    ,   0.7585860    
     +,   0.7756237    ,   0.7929578    ,   0.8132159    
     +,   0.8386342    ,   0.8711566    ,   0.9122002    
     +,   0.9604154    ,    1.012223    ,    1.065204    
     +,    1.116267    ,    1.156490    ,    1.173794    
     +,    1.162401    ,    1.126269    ,    1.073309    
     +,    1.010522    ,   0.9435380    ,   0.8747063    
     +,   0.8023548    ,   0.7256550    ,   0.6483449    
     +,   0.5762666    ,   0.5134296    ,   0.4609159    
     +,   0.4176439    ,   0.3813304    ,   0.3494249    
     +,   0.3199646    ,   0.2919953    ,   0.2654711    
     +,   0.2409154    ,   0.2190801    ,   0.2006721    
     +,   0.1861326    ,   0.1754867    ,   0.1683061    
     +,   0.1638063    ,   0.1610253    ,   0.1590156    
     +,   0.1569860    ,   0.1543716    ,   0.1508371    
     +,   0.1462419    ,   0.1405901    ,   0.1339846    
     +,   0.1265922    ,   0.1186175    ,   0.1102849    
     +,   0.1018225    ,   9.3449302E-02,   8.5357964E-02
     +,   7.7703096E-02,   7.0593037E-02,   6.4086318E-02
     +,   5.8194645E-02,   5.2892312E-02,   4.8127763E-02
     +,   4.3835741E-02,   3.9947499E-02,   3.6399379E-02
     +,   3.3137728E-02,   3.0120810E-02,   2.7318332E-02
     +,   2.4710080E-02,   2.2283757E-02,   2.0031936E-02
     +,   1.7950131E-02,   1.6035011E-02,   1.4282951E-02
     +,   1.2689168E-02,   1.1247473E-02,   9.9503556E-03
     +,   8.7890476E-03,   7.7537955E-03,   6.8343179E-03
     +,   6.0202163E-03,   5.3012292E-03,   4.6674190E-03
     +,   4.1094492E-03,   3.6187302E-03,   3.1873768E-03
     +,   2.8082938E-03,   2.4751739E-03,   2.1824334E-03
     +,   1.9251326E-03,   1.6989438E-03,   1.5000943E-03
     +,   1.3252835E-03,   1.1716124E-03,   1.0365453E-03
     +,   9.1786595E-04,   8.1362575E-04,   7.2210090E-04
     +,   6.4177130E-04,   5.7129940E-04,   5.0949369E-04
     +,   4.5529840E-04,   4.0778090E-04,   3.6611297E-04
     +,   3.2955795E-04,   2.9746396E-04,   2.6925703E-04
     +,   2.4443015E-04,   2.2253582E-04,   2.0318160E-04
     +,   1.8602540E-04,   1.7076900E-04,   1.5715242E-04
     +,   1.4495091E-04,   1.3397189E-04,   1.2404904E-04
     +,   1.1504029E-04,   1.0682504E-04,   9.9301134E-05
     +,   9.2381524E-05,   8.5992884E-05,   8.0073922E-05
     +,   7.4573123E-05,   6.9446854E-05,   6.4658547E-05
     +,   6.0177721E-05,   5.5978657E-05,   5.2039253E-05
     +,   4.8340687E-05,   4.4867127E-05,   4.1604435E-05
     +,   3.8540205E-05,   3.5663565E-05,   3.2964723E-05
     +,   3.0434496E-05,   2.8064438E-05,   2.5846759E-05
     +,   2.3774077E-05,   2.1839214E-05,   2.0035295E-05
     +,   1.8355799E-05,   1.6794378E-05,   1.5344800E-05
     +,   1.4001006E-05,   1.2757230E-05,   1.1607761E-05
     +,   1.0547047E-05,   9.5698078E-06,   8.6709097E-06
     +,   7.8453513E-06,   7.0883248E-06,   6.3952712E-06
     +,   5.7618081E-06,   5.1837123E-06,   4.6569662E-06
     +,   4.1778098E-06,   3.7426009E-06,   3.3479585E-06
     +,   2.9906516E-06,   2.6676767E-06,   2.3761788E-06
     +,   2.1135197E-06,   1.8772059E-06,   1.6649417E-06
     +,   1.4745635E-06,   1.3040961E-06,   1.1516890E-06
     +,   1.0156374E-06,   8.9438242E-07,   7.8647645E-07
     +,   6.9060440E-07,   6.0555084E-07,   5.3021614E-07
     +,   4.6358895E-07,   4.0475703E-07,   3.5288502E-07
     +,   3.0722273E-07,   2.6708599E-07,   2.3186226E-07
     +,   2.0099563E-07,   1.7399010E-07
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_asha_htt65_mass = Yx/9.583154
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_asha_htt70_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  9.8816119E-04,   1.0186506E-03
     +,   1.0493785E-03,   1.0803146E-03,   1.1114316E-03
     +,   1.1427047E-03,   1.1741143E-03,   1.2056446E-03
     +,   1.2372852E-03,   1.2690332E-03,   1.3008915E-03
     +,   1.3328702E-03,   1.3649892E-03,   1.3972756E-03
     +,   1.4297675E-03,   1.4625126E-03,   1.4955695E-03
     +,   1.5290075E-03,   1.5629082E-03,   1.5973655E-03
     +,   1.6324844E-03,   1.6683833E-03,   1.7051917E-03
     +,   1.7430533E-03,   1.7821215E-03,   1.8225639E-03
     +,   1.8645570E-03,   1.9082890E-03,   1.9539574E-03
     +,   2.0017682E-03,   2.0519346E-03,   2.1046761E-03
     +,   2.1602164E-03,   2.2187822E-03,   2.2806015E-03
     +,   2.3459003E-03,   2.4149027E-03,   2.4878257E-03
     +,   2.5648838E-03,   2.6462746E-03,   2.7321931E-03
     +,   2.8228175E-03,   2.9183135E-03,   3.0188330E-03
     +,   3.1245113E-03,   3.2354749E-03,   3.3518383E-03
     +,   3.4737063E-03,   3.6011830E-03,   3.7343763E-03
     +,   3.8734023E-03,   4.0184003E-03,   4.1695395E-03
     +,   4.3270444E-03,   4.4911783E-03,   4.6623014E-03
     +,   4.8408494E-03,   5.0273705E-03,   5.2225268E-03
     +,   5.4271184E-03,   5.6420811E-03,   5.8685006E-03
     +,   6.1075916E-03,   6.3607246E-03,   6.6293892E-03
     +,   6.9151577E-03,   7.2197029E-03,   7.5447024E-03
     +,   7.8918654E-03,   8.2628168E-03,   8.6591337E-03
     +,   9.0822149E-03,   9.5333280E-03,   1.0013497E-02
     +,   1.0523549E-02,   1.1064094E-02,   1.1635479E-02
     +,   1.2237854E-02,   1.2871253E-02,   1.3535646E-02
     +,   1.4230942E-02,   1.4957293E-02,   1.5715033E-02
     +,   1.6505038E-02,   1.7328817E-02,   1.8188931E-02
     +,   1.9089216E-02,   2.0035584E-02,   2.1036599E-02
     +,   2.2104889E-02,   2.3258662E-02,   2.4523722E-02
     +,   2.5935877E-02,   2.7543617E-02,   2.9410174E-02
     +,   3.1614609E-02,   3.4252089E-02,   3.7431616E-02
     +,   4.1273348E-02,   4.5903906E-02,   5.1454123E-02
     +,   5.8056861E-02,   6.5849252E-02,   7.4973270E-02
     +,   8.5575767E-02,   9.7797595E-02,   0.1117494    
     +,   0.1274778    ,   0.1449332    ,   0.1639536    
     +,   0.1842830    ,   0.2056447    ,   0.2278544    
     +,   0.2509769    ,   0.2754233    ,   0.3018578    
     +,   0.3307704    ,   0.3619082    ,   0.3940675    
     +,   0.4257767    ,   0.4566611    ,   0.4884047    
     +,   0.5241057    ,   0.5660724    ,   0.6138653    
     +,   0.6643372    ,   0.7134865    ,   0.7593714    
     +,   0.8058938    ,   0.8626572    ,   0.9335386    
     +,    1.003809    ,    1.051176    ,    1.071369    
     +,    1.080462    ,    1.100479    ,    1.148913    
     +,    1.224780    ,    1.313579    ,    1.409646    
     +,    1.513004    ,    1.614304    ,    1.687101    
     +,    1.696874    ,    1.633029    ,    1.519284    
     +,    1.386806    ,    1.254012    ,    1.128576    
     +,    1.011425    ,   0.9023420    ,   0.8071294    
     +,   0.7313954    ,   0.6703773    ,   0.6135803    
     +,   0.5554296    ,   0.4966133    ,   0.4392104    
     +,   0.3845728    ,   0.3342320    ,   0.2900731    
     +,   0.2533459    ,   0.2241353    ,   0.2017329    
     +,   0.1851735    ,   0.1734500    ,   0.1655102    
     +,   0.1602706    ,   0.1567001    ,   0.1539112    
     +,   0.1512038    ,   0.1480612    ,   0.1441270    
     +,   0.1391828    ,   0.1331391    ,   0.1260302    
     +,   0.1180049    ,   0.1093044    ,   0.1002257    
     +,   9.1078110E-02,   8.2143202E-02,   7.3646061E-02
     +,   6.5741003E-02,   5.8511455E-02,   5.1981810E-02
     +,   4.6134077E-02,   4.0923897E-02,   3.6294088E-02
     +,   3.2184679E-02,   2.8538819E-02,   2.5304528E-02
     +,   2.2435661E-02,   1.9891517E-02,   1.7635938E-02
     +,   1.5636431E-02,   1.3863905E-02,   1.2292412E-02
     +,   1.0898803E-02,   9.6624792E-03,   8.5652946E-03
     +,   7.5914017E-03,   6.7268889E-03,   5.9595131E-03
     +,   5.2785138E-03,   4.6744552E-03,   4.1389107E-03
     +,   3.6643806E-03,   3.2442000E-03,   2.8723988E-03
     +,   2.5436047E-03,   2.2530099E-03,   1.9963288E-03
     +,   1.7697270E-03,   1.5697624E-03,   1.3933660E-03
     +,   1.2378136E-03,   1.1006754E-03,   9.7978057E-04
     +,   8.7319786E-04,   7.7922182E-04,   6.9632864E-04
     +,   6.2316825E-04,   5.5855123E-04,   5.0142605E-04
     +,   4.5086254E-04,   4.0604340E-04,   3.6625488E-04
     +,   3.3087164E-04,   2.9934553E-04,   2.7119895E-04
     +,   2.4601826E-04,   2.2344357E-04,   2.0316105E-04
     +,   1.8489835E-04,   1.6842101E-04,   1.5352371E-04
     +,   1.4002831E-04,   1.2778075E-04,   1.1664689E-04
     +,   1.0650900E-04,   9.7264347E-05,   8.8823552E-05
     +,   8.1108141E-05,   7.4048541E-05,   6.7583460E-05
     +,   6.1659004E-05,   5.6227334E-05,   5.1245443E-05
     +,   4.6674893E-05,   4.2481679E-05,   3.8634720E-05
     +,   3.5105953E-05,   3.1870168E-05,   2.8904418E-05
     +,   2.6187503E-05,   2.3700086E-05,   2.1424530E-05
     +,   1.9344598E-05,   1.7445147E-05,   1.5712201E-05
     +,   1.4132916E-05,   1.2695357E-05,   1.1388353E-05
     +,   1.0201509E-05,   9.1252832E-06,   8.1506751E-06
     +,   7.2693197E-06,   6.4734963E-06,   5.7560064E-06
     +,   5.1101183E-06,   4.5295878E-06,   4.0086570E-06
     +,   3.5419864E-06,   3.1246050E-06,   2.7519238E-06
     +,   2.4197448E-06,   2.1241547E-06,   1.8615991E-06
     +,   1.6287808E-06,   1.4227063E-06,   1.2406167E-06
     +,   1.0800187E-06,   9.3861928E-07,   8.1435633E-07
     +,   7.0534264E-07,   6.0988663E-07,   5.2645026E-07
     +,   4.5365135E-07,   3.9025323E-07,   3.3513854E-07
     +,   2.8731620E-07,   2.4589394E-07,   2.1008339E-07
     +,   1.7917897E-07,   1.5255868E-07,   1.2966919E-07
     +,   1.1002493E-07,   9.3195382E-08,   7.8804540E-08
     +,   6.6520769E-08,   5.6055168E-08
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_asha_htt70_mass = Yx/10.9494214285714
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_asha_htt75_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.2801697E-04,   4.4395198E-04
     +,   4.6110078E-04,   4.7955621E-04,   4.9941341E-04
     +,   5.2076927E-04,   5.4372218E-04,   5.6837074E-04
     +,   5.9481297E-04,   6.2314660E-04,   6.5346627E-04
     +,   6.8586343E-04,   7.2042493E-04,   7.5723237E-04
     +,   7.9636020E-04,   8.3787466E-04,   8.8183291E-04
     +,   9.2828140E-04,   9.7725389E-04,   1.0287730E-03
     +,   1.0828454E-03,   1.1394642E-03,   1.1986052E-03
     +,   1.2602324E-03,   1.3242854E-03,   1.3906956E-03
     +,   1.4593726E-03,   1.5302115E-03,   1.6030925E-03
     +,   1.6778819E-03,   1.7544330E-03,   1.8325890E-03
     +,   1.9121852E-03,   1.9930510E-03,   2.0750146E-03
     +,   2.1579042E-03,   2.2415549E-03,   2.3258096E-03
     +,   2.4105308E-03,   2.4955906E-03,   2.5808970E-03
     +,   2.6663805E-03,   2.7520107E-03,   2.8377965E-03
     +,   2.9237939E-03,   3.0101109E-03,   3.0969104E-03
     +,   3.1844163E-03,   3.2729174E-03,   3.3627644E-03
     +,   3.4543786E-03,   3.5482452E-03,   3.6449113E-03
     +,   3.7449955E-03,   3.8491553E-03,   3.9581088E-03
     +,   4.0726052E-03,   4.1934229E-03,   4.3213512E-03
     +,   4.4571771E-03,   4.6016695E-03,   4.7555678E-03
     +,   4.9195415E-03,   5.0942050E-03,   5.2800905E-03
     +,   5.4776045E-03,   5.6870640E-03,   5.9086340E-03
     +,   6.1423769E-03,   6.3881944E-03,   6.6458792E-03
     +,   6.9150715E-03,   7.1953367E-03,   7.4861157E-03
     +,   7.7868239E-03,   8.0968579E-03,   8.4156459E-03
     +,   8.7427013E-03,   9.0777716E-03,   9.4208987E-03
     +,   9.7724907E-03,   1.0133595E-02,   1.0505931E-02
     +,   1.0892189E-02,   1.1296114E-02,   1.1722798E-02
     +,   1.2178765E-02,   1.2672175E-02,   1.3212823E-02
     +,   1.3812159E-02,   1.4483135E-02,   1.5239812E-02
     +,   1.6096892E-02,   1.7069088E-02,   1.8170193E-02
     +,   1.9411948E-02,   2.0803224E-02,   2.2348706E-02
     +,   2.4048455E-02,   2.5897210E-02,   2.7885098E-02
     +,   2.9998166E-02,   3.2220822E-02,   3.4537852E-02
     +,   3.6938008E-02,   3.9417230E-02,   4.1981775E-02
     +,   4.4651374E-02,   4.7461782E-02,   5.0466448E-02
     +,   5.3737357E-02,   5.7365663E-02,   6.1460186E-02
     +,   6.6148251E-02,   7.1576290E-02,   7.7919573E-02
     +,   8.5399106E-02,   9.4314434E-02,   0.1050760    
     +,   0.1182218    ,   0.1343732    ,   0.1540958    
     +,   0.1776865    ,   0.2049935    ,   0.2354324    
     +,   0.2682783    ,   0.3030525    ,   0.3395291    
     +,   0.3771549    ,   0.4144349    ,   0.4495292    
     +,   0.4822793    ,   0.5161409    ,   0.5585893    
     +,   0.6196101    ,   0.7057326    ,   0.8128058    
     +,   0.9340597    ,    1.075422    ,    1.236656    
     +,    1.385517    ,    1.491727    ,    1.562794    
     +,    1.621363    ,    1.682565    ,    1.765303    
     +,    1.880201    ,    1.972504    ,    1.969341    
     +,    1.902740    ,    1.837930    ,    1.774110    
     +,    1.677671    ,    1.518658    ,    1.314903    
     +,    1.133850    ,    1.012204    ,   0.9282945    
     +,   0.8479401    ,   0.7577837    ,   0.6634511    
     +,   0.5769809    ,   0.5071206    ,   0.4550663    
     +,   0.4165757    ,   0.3863142    ,   0.3604341    
     +,   0.3371467    ,   0.3160982    ,   0.2972631    
     +,   0.2801903    ,   0.2639966    ,   0.2477939    
     +,   0.2310519    ,   0.2137157    ,   0.1961282    
     +,   0.1788694    ,   0.1625575    ,   0.1476696    
     +,   0.1344332    ,   0.1228201    ,   0.1126164    
     +,   0.1035188    ,   9.5219173E-02,   8.7459035E-02
     +,   8.0053866E-02,   7.2895482E-02,   6.5941989E-02
     +,   5.9202742E-02,   5.2720390E-02,   4.6552241E-02
     +,   4.0756404E-02,   3.5382170E-02,   3.0463981E-02
     +,   2.6019573E-02,   2.2051174E-02,   1.8548155E-02
     +,   1.5489395E-02,   1.2846036E-02,   1.0584186E-02
     +,   8.6670844E-03,   7.0567299E-03,   5.7152114E-03
     +,   4.6060947E-03,   3.6954142E-03,   2.9521128E-03
     +,   2.3485699E-03,   1.8607519E-03,   1.4680814E-03
     +,   1.1531822E-03,   9.0158568E-04,   7.0135272E-04
     +,   5.4267212E-04,   4.1749876E-04,   3.1926073E-04
     +,   2.4259844E-04,   1.8313929E-04,   1.3732100E-04
     +,   1.0225460E-04,   7.5609605E-05,   5.5510693E-05
     +,   4.0462168E-05,   2.9280387E-05,   2.1035215E-05
     +,   1.5001647E-05,   1.0620182E-05,   7.4629925E-06
     +,   5.2055625E-06,   3.6038653E-06,   2.4761932E-06
     +,   1.6884644E-06,   1.1425237E-06,   7.6712172E-07
     +,   5.1103115E-07,   3.3774415E-07,   2.2143219E-07
     +,   1.4399927E-07,   9.2877755E-08,   5.9410386E-08
     +,   3.7684853E-08,   2.3701785E-08,   1.4780029E-08
     +,   9.1374206E-09,   5.6000076E-09,   3.4020056E-09
     +,   2.0485604E-09,   1.2227028E-09,   7.2333034E-10
     +,   4.2412393E-10,   2.4650507E-10,   1.4202819E-10
     +,   8.1136452E-11,   4.5972875E-11,   2.5850624E-11
     +,   1.4437316E-11,   8.0190212E-12,   4.4389869E-12
     +,   2.4567308E-12,   1.3657636E-12,   7.6778417E-13
     +,   4.4038777E-13,   2.6050819E-13,   1.6065828E-13
     +,   1.0414659E-13,   7.1168271E-14,   5.1086011E-14
     +,   3.8204147E-14,   2.9467937E-14,   2.3224444E-14
     +,   1.8562881E-14,   1.4966266E-14,   1.2127664E-14
     +,   9.8544304E-15,   8.0175675E-15,   6.5256693E-15
     +,   5.3107200E-15,   4.3200133E-15,   3.5119661E-15
     +,   2.8529514E-15,   2.3157915E-15,   1.8782068E-15
     +,   1.5220352E-15,   1.2323468E-15,   9.9694338E-16
     +,   8.0580701E-16,   6.5075842E-16,   5.2508896E-16
     +,   4.2331901E-16,   3.4098090E-16,   2.7441827E-16
     +,   2.2065985E-16,   1.7727808E-16,   1.4230275E-16
     +,   1.1412821E-16,   9.1453446E-17,   7.3219804E-17
     +,   5.8571131E-17,   4.6812295E-17,   3.7382102E-17
     +,   2.9825522E-17,   2.3776048E-17
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_asha_htt75_mass = Yx/11.5072221428571
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_asha_htt80_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  5.3177855E-04,   5.4446975E-04
     +,   5.5702671E-04,   5.6943268E-04,   5.8167148E-04
     +,   5.9372815E-04,   6.0558866E-04,   6.1724056E-04
     +,   6.2867213E-04,   6.3987396E-04,   6.5083761E-04
     +,   6.6155667E-04,   6.7202648E-04,   6.8224466E-04
     +,   6.9221057E-04,   7.0192601E-04,   7.1139500E-04
     +,   7.2062417E-04,   7.2962255E-04,   7.3840172E-04
     +,   7.4697618E-04,   7.5536297E-04,   7.6358201E-04
     +,   7.7165704E-04,   7.7961345E-04,   7.8748056E-04
     +,   7.9529115E-04,   8.0308114E-04,   8.1088929E-04
     +,   8.1875885E-04,   8.2673662E-04,   8.3487271E-04
     +,   8.4322179E-04,   8.5184298E-04,   8.6079969E-04
     +,   8.7016018E-04,   8.7999826E-04,   8.9039258E-04
     +,   9.0142834E-04,   9.1319665E-04,   9.2579576E-04
     +,   9.3933084E-04,   9.5391495E-04,   9.6966879E-04
     +,   9.8672218E-04,   1.0052137E-03,   1.0252910E-03
     +,   1.0471115E-03,   1.0708421E-03,   1.0966593E-03
     +,   1.1247485E-03,   1.1553043E-03,   1.1885287E-03
     +,   1.2246333E-03,   1.2638307E-03,   1.3063434E-03
     +,   1.3523923E-03,   1.4021992E-03,   1.4559834E-03
     +,   1.5139596E-03,   1.5763333E-03,   1.6432997E-03
     +,   1.7150351E-03,   1.7917034E-03,   1.8734480E-03
     +,   1.9603840E-03,   2.0526112E-03,   2.1501940E-03
     +,   2.2531867E-03,   2.3616077E-03,   2.4754736E-03
     +,   2.5947748E-03,   2.7195185E-03,   2.8497060E-03
     +,   2.9853773E-03,   3.1266182E-03,   3.2735770E-03
     +,   3.4264917E-03,   3.5857405E-03,   3.7518605E-03
     +,   3.9255721E-03,   4.1078618E-03,   4.2999778E-03
     +,   4.5035314E-03,   4.7204914E-03,   4.9532987E-03
     +,   5.2048438E-03,   5.4785907E-03,   5.7785455E-03
     +,   6.1093578E-03,   6.4763264E-03,   6.8853875E-03
     +,   7.3431465E-03,   7.8569120E-03,   8.4346738E-03
     +,   9.0850461E-03,   9.8174019E-03,   1.0641751E-02
     +,   1.1568941E-02,   1.2610514E-02,   1.3778960E-02
     +,   1.5087400E-02,   1.6549774E-02,   1.8180156E-02
     +,   1.9992581E-02,   2.2000207E-02,   2.4214189E-02
     +,   2.6642900E-02,   2.9291213E-02,   3.2159865E-02
     +,   3.5245098E-02,   3.8539931E-02,   4.2034224E-02
     +,   4.5716636E-02,   4.9574248E-02,   5.3593170E-02
     +,   5.7755809E-02,   6.2039252E-02,   6.6411309E-02
     +,   7.0830271E-02,   7.5246856E-02,   7.9612464E-02
     +,   8.3895534E-02,   8.8105008E-02,   9.2318833E-02
     +,   9.6710369E-02,   0.1015658    ,   0.1072756    
     +,   0.1142967    ,   0.1230830    ,   0.1340078    
     +,   0.1472980    ,   0.1630125    ,   0.1810687    
     +,   0.2013670    ,   0.2240442    ,   0.2497682    
     +,   0.2796845    ,   0.3145292    ,   0.3532109    
     +,   0.3926362    ,   0.4311142    ,   0.4754884    
     +,   0.5466097    ,   0.6703647    ,   0.8497573    
     +,    1.052496    ,    1.242700    ,    1.418924    
     +,    1.625161    ,    1.860981    ,    2.038198    
     +,    2.123770    ,    2.233845    ,    2.496802    
     +,    2.674496    ,    2.616260    ,    2.519206    
     +,    2.440868    ,    2.272892    ,    2.044150    
     +,    1.799072    ,    1.563321    ,    1.368381    
     +,    1.179495    ,   0.9877168    ,   0.8391197    
     +,   0.7477077    ,   0.6859999    ,   0.6299062    
     +,   0.5734119    ,   0.5187302    ,   0.4666373    
     +,   0.4151699    ,   0.3636439    ,   0.3147010    
     +,   0.2720893    ,   0.2377616    ,   0.2112189    
     +,   0.1906002    ,   0.1739016    ,   0.1595672    
     +,   0.1465629    ,   0.1342472    ,   0.1222421    
     +,   0.1103631    ,   9.8589838E-02,   8.7037899E-02
     +,   7.5915262E-02,   6.5462440E-02,   5.5892706E-02
     +,   4.7352359E-02,   3.9904542E-02,   3.3533502E-02
     +,   2.8162647E-02,   2.3678536E-02,   1.9952780E-02
     +,   1.6858133E-02,   1.4279090E-02,   1.2117401E-02
     +,   1.0293497E-02,   8.7449951E-03,   7.4239676E-03
     +,   6.2939450E-03,   5.3269854E-03,   4.5009712E-03
     +,   3.7977982E-03,   3.2021063E-03,   2.7003649E-03
     +,   2.2803682E-03,   1.9310360E-03,   1.6423194E-03
     +,   1.4051319E-03,   1.2113224E-03,   1.0536792E-03
     +,   9.2590309E-04,   8.2254689E-04,   7.3895004E-04
     +,   6.7117944E-04,   6.1595876E-04,   5.7057920E-04
     +,   5.3283438E-04,   5.0095038E-04,   4.7351769E-04
     +,   4.4942941E-04,   4.2783146E-04,   4.0807613E-04
     +,   3.8967942E-04,   3.7228686E-04,   3.5564502E-04
     +,   3.3957962E-04,   3.2397473E-04,   3.0875692E-04
     +,   2.9388414E-04,   2.7933845E-04,   2.6511538E-04
     +,   2.5122086E-04,   2.3766764E-04,   2.2447197E-04
     +,   2.1165033E-04,   1.9921921E-04,   1.8719480E-04
     +,   1.7559154E-04,   1.6442082E-04,   1.5369176E-04
     +,   1.4341161E-04,   1.3358523E-04,   1.2421420E-04
     +,   1.1529787E-04,   1.0683424E-04,   9.8818375E-05
     +,   9.1243426E-05,   8.4101404E-05,   7.7382698E-05
     +,   7.1075890E-05,   6.5168446E-05,   5.9647224E-05
     +,   5.4498203E-05,   4.9706374E-05,   4.5256245E-05
     +,   4.1132291E-05,   3.7318714E-05,   3.3799352E-05
     +,   3.0558134E-05,   2.7579390E-05,   2.4847386E-05
     +,   2.2346696E-05,   2.0062460E-05,   1.7980206E-05
     +,   1.6085831E-05,   1.4365773E-05,   1.2807158E-05
     +,   1.1397681E-05,   1.0125548E-05,   8.9796085E-06
     +,   7.9494375E-06,   7.0250931E-06,   6.1973788E-06
     +,   5.4575876E-06,   4.7977087E-06,   4.2102088E-06
     +,   3.6881963E-06,   3.2252335E-06,   2.8154559E-06
     +,   2.4534279E-06,   2.1342166E-06,   1.8532864E-06
     +,   1.6065094E-06,   1.3901612E-06,   1.2008360E-06
     +,   1.0354831E-06,   8.9133209E-07,   7.6590896E-07
     +,   6.5697901E-07,   5.6255772E-07,   4.8086099E-07
     +,   4.1031137E-07,   3.4949761E-07,   2.9717779E-07
     +,   2.5224674E-07,   2.1373539E-07
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_asha_htt80_mass = Yx/12.39871164
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_asha_htt85_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  9.9751422E-05,   1.0714962E-04
     +,   1.1499059E-04,   1.2329184E-04,   1.3207093E-04
     +,   1.4134523E-04,   1.5113184E-04,   1.6144777E-04
     +,   1.7230939E-04,   1.8373327E-04,   1.9573508E-04
     +,   2.0833006E-04,   2.2153325E-04,   2.3535889E-04
     +,   2.4982126E-04,   2.6493394E-04,   2.8071049E-04
     +,   2.9716454E-04,   3.1430993E-04,   3.3216126E-04
     +,   3.5073396E-04,   3.7004534E-04,   3.9011455E-04
     +,   4.1096521E-04,   4.3262224E-04,   4.5511828E-04
     +,   4.7849084E-04,   5.0278503E-04,   5.2805553E-04
     +,   5.5436726E-04,   5.8179785E-04,   6.1043922E-04
     +,   6.4039946E-04,   6.7180506E-04,   7.0480246E-04
     +,   7.3956006E-04,   7.7626976E-04,   8.1514783E-04
     +,   8.5643958E-04,   9.0041186E-04,   9.4736309E-04
     +,   9.9761516E-04,   1.0515151E-03,   1.1094328E-03
     +,   1.1717570E-03,   1.2388905E-03,   1.3112461E-03
     +,   1.3892393E-03,   1.4732805E-03,   1.5637650E-03
     +,   1.6610648E-03,   1.7655179E-03,   1.8774130E-03
     +,   1.9969887E-03,   2.1243987E-03,   2.2597294E-03
     +,   2.4029650E-03,   2.5539866E-03,   2.7125606E-03
     +,   2.8783332E-03,   3.0508228E-03,   3.2294199E-03
     +,   3.4133717E-03,   3.6018144E-03,   3.7937581E-03
     +,   3.9880835E-03,   4.1835904E-03,   4.3789716E-03
     +,   4.5728749E-03,   4.7638705E-03,   4.9505341E-03
     +,   5.1314100E-03,   5.3050919E-03,   5.4701976E-03
     +,   5.6254370E-03,   5.7696146E-03,   5.9016473E-03
     +,   6.0205939E-03,   6.1256830E-03,   6.2163183E-03
     +,   6.2920861E-03,   6.3527916E-03,   6.3984385E-03
     +,   6.4292722E-03,   6.4457674E-03,   6.4486526E-03
     +,   6.4389240E-03,   6.4178701E-03,   6.3871103E-03
     +,   6.3486248E-03,   6.3048187E-03,   6.2585934E-03
     +,   6.2134345E-03,   6.1735115E-03,   6.1437846E-03
     +,   6.1301375E-03,   6.1394675E-03,   6.1797998E-03
     +,   6.2603252E-03,   6.3913758E-03,   6.5843491E-03
     +,   6.8514566E-03,   7.2054262E-03,   7.6589794E-03
     +,   8.2243048E-03,   8.9123948E-03,   9.7322948E-03
     +,   1.0690527E-02,   1.1790673E-02,   1.3033092E-02
     +,   1.4414799E-02,   1.5930099E-02,   1.7570755E-02
     +,   1.9327058E-02,   2.1187980E-02,   2.3141997E-02
     +,   2.5176441E-02,   2.7277362E-02,   2.9427849E-02
     +,   3.1607106E-02,   3.3789009E-02,   3.5941541E-02
     +,   3.8027909E-02,   4.0009547E-02,   4.1851018E-02
     +,   4.3526724E-02,   4.5029413E-02,   4.6377327E-02
     +,   4.7620337E-02,   4.8840676E-02,   5.0148383E-02
     +,   5.1669545E-02,   5.3529564E-02,   5.5834185E-02
     +,   5.8656938E-02,   6.2040620E-02,   6.6022754E-02
     +,   7.0691578E-02,   7.6269217E-02,   8.3201125E-02
     +,   9.2207812E-02,   0.1042403    ,   0.1202941    
     +,   0.1410985    ,   0.1667908    ,   0.1967789    
     +,   0.2300171    ,   0.2658359    ,   0.3049812    
     +,   0.3498103    ,   0.4030334    ,   0.4663880    
     +,   0.5408255    ,   0.6268368    ,   0.7255839    
     +,   0.8467277    ,    1.006605    ,    1.206159    
     +,    1.459688    ,    1.824016    ,    2.249140    
     +,    2.548826    ,    2.695143    ,    2.865433    
     +,    3.061762    ,    3.152882    ,    3.087986    
     +,    2.807869    ,    2.351101    ,    2.068755    
     +,    1.916740    ,    1.694035    ,    1.448122    
     +,    1.258148    ,    1.090371    ,   0.9108880    
     +,   0.7391965    ,   0.6066170    ,   0.5155852    
     +,   0.4518619    ,   0.4032707    ,   0.3623147    
     +,   0.3252598    ,   0.2908140    ,   0.2586406    
     +,   0.2287987    ,   0.2015110    ,   0.1767737    
     +,   0.1542030    ,   0.1333050    ,   0.1138197    
     +,   9.5813796E-02,   7.9524733E-02,   6.5158188E-02
     +,   5.2781779E-02,   4.2324629E-02,   3.3623744E-02
     +,   2.6471954E-02,   2.0651961E-02,   1.5957229E-02
     +,   1.2202397E-02,   9.2263408E-03,   6.8913861E-03
     +,   5.0807409E-03,   3.6952782E-03,   2.6504321E-03
     +,   1.8745123E-03,   1.3074152E-03,   8.9952967E-04
     +,   6.1074126E-04,   4.0938600E-04,   2.7105748E-04
     +,   1.7736167E-04,   1.1474030E-04,   7.3415242E-05
     +,   4.6472731E-05,   2.9109080E-05,   1.8041965E-05
     +,   1.1063995E-05,   6.7115543E-06,   4.0258124E-06
     +,   2.3866867E-06,   1.3977170E-06,   8.0811793E-07
     +,   4.6098231E-07,   2.5927952E-07,   1.4370477E-07
     +,   7.8442710E-08,   4.2147828E-08,   2.2280371E-08
     +,   1.1582973E-08,   5.9199459E-09,   2.9735123E-09
     +,   1.4674164E-09,   7.1136996E-10,   3.3870093E-10
     +,   1.5836418E-10,   7.2712808E-11,   3.2787627E-11
     +,   1.4521977E-11,   6.3202490E-12,   2.7053396E-12
     +,   1.1408470E-12,   4.7545393E-13,   1.9697397E-13
     +,   8.1992647E-14,   3.4922260E-14,   1.5639310E-14
     +,   7.6051141E-15,   4.1118710E-15,   2.4726656E-15
     +,   1.6178716E-15,   1.1188053E-15,   7.9859749E-16
     +,   5.7959833E-16,   4.2415612E-16,   3.1165910E-16
     +,   2.2945233E-16,   1.6909705E-16,   1.2468426E-16
     +,   9.1967449E-17,   6.7852441E-17,   5.0069931E-17
     +,   3.6952858E-17,   2.7275391E-17,   2.0133965E-17
     +,   1.4862809E-17,   1.0971676E-17,   8.0989700E-18
     +,   5.9779102E-18,   4.4117091E-18,   3.2552448E-18
     +,   2.4014013E-18,   1.7710150E-18,   1.3056648E-18
     +,   9.6222736E-19,   7.0881794E-19,   5.2190046E-19
     +,   3.8406671E-19,   2.8247833E-19,   2.0763053E-19
     +,   1.5251716E-19,   1.1195411E-19,   8.2119771E-20
     +,   6.0189526E-20,   4.4080759E-20,   3.2256325E-20
     +,   2.3583320E-20,   1.7227135E-20,   1.2572433E-20
     +,   9.1668842E-21,   6.6773214E-21,   4.8591659E-21
     +,   3.5324966E-21,   2.5654577E-21,   1.8612028E-21
     +,   1.3488699E-21,   9.7651630E-22,   7.0619777E-22
     +,   5.1014718E-22,   3.6812092E-22
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_asha_htt85_mass = Yx/12.4513515
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_asha_htt90_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.9639954E-05,   3.2712138E-05
     +,   3.6066511E-05,   3.9725568E-05,   4.3713269E-05
     +,   4.8055055E-05,   5.2777981E-05,   5.7910656E-05
     +,   6.3483247E-05,   6.9527821E-05,   7.6077835E-05
     +,   8.3168416E-05,   9.0836314E-05,   9.9119745E-05
     +,   1.0805833E-04,   1.1769302E-04,   1.2806589E-04
     +,   1.3921990E-04,   1.5119884E-04,   1.6404680E-04
     +,   1.7780812E-04,   1.9252683E-04,   2.0824609E-04
     +,   2.2500912E-04,   2.4285569E-04,   2.6182531E-04
     +,   2.8195410E-04,   3.0327486E-04,   3.2581689E-04
     +,   3.4960505E-04,   3.7465911E-04,   4.0099336E-04
     +,   4.2861552E-04,   4.5752691E-04,   4.8772132E-04
     +,   5.1918440E-04,   5.5189402E-04,   5.8581878E-04
     +,   6.2092056E-04,   6.5714848E-04,   6.9444656E-04
     +,   7.3274830E-04,   7.7197846E-04,   8.1205473E-04
     +,   8.5288723E-04,   8.9437922E-04,   9.3642960E-04
     +,   9.7893190E-04,   1.0217784E-03,   1.0648596E-03
     +,   1.1080671E-03,   1.1512958E-03,   1.1944445E-03
     +,   1.2374233E-03,   1.2801462E-03,   1.3225459E-03
     +,   1.3645674E-03,   1.4061731E-03,   1.4473471E-03
     +,   1.4880951E-03,   1.5284492E-03,   1.5684674E-03
     +,   1.6082342E-03,   1.6478671E-03,   1.6875131E-03
     +,   1.7273463E-03,   1.7675748E-03,   1.8084302E-03
     +,   1.8501768E-03,   1.8930961E-03,   1.9374974E-03
     +,   1.9837022E-03,   2.0320527E-03,   2.0828957E-03
     +,   2.1365902E-03,   2.1935063E-03,   2.2540109E-03
     +,   2.3184808E-03,   2.3873043E-03,   2.4608881E-03
     +,   2.5396522E-03,   2.6240617E-03,   2.7146186E-03
     +,   2.8118992E-03,   2.9165472E-03,   3.0293183E-03
     +,   3.1510650E-03,   3.2827856E-03,   3.4255926E-03
     +,   3.5807497E-03,   3.7496504E-03,   3.9337808E-03
     +,   4.1347039E-03,   4.3540169E-03,   4.5932839E-03
     +,   4.8539303E-03,   5.1372140E-03,   5.4440578E-03
     +,   5.7750260E-03,   6.1301417E-03,   6.5088868E-03
     +,   6.9100386E-03,   7.3317103E-03,   7.7712289E-03
     +,   8.2252380E-03,   8.6897155E-03,   9.1600139E-03
     +,   9.6310405E-03,   1.0097428E-02,   1.0553712E-02
     +,   1.0994496E-02,   1.1414794E-02,   1.1810168E-02
     +,   1.2177081E-02,   1.2513072E-02,   1.2817092E-02
     +,   1.3089681E-02,   1.3333312E-02,   1.3552584E-02
     +,   1.3754511E-02,   1.3948783E-02,   1.4147915E-02
     +,   1.4367454E-02,   1.4626068E-02,   1.4945457E-02
     +,   1.5350149E-02,   1.5867164E-02,   1.6525278E-02
     +,   1.7354317E-02,   1.8383995E-02,   1.9642860E-02
     +,   2.1156769E-02,   2.2948105E-02,   2.5034564E-02
     +,   2.7429694E-02,   3.0144144E-02,   3.3188686E-02
     +,   3.6579516E-02,   4.0344261E-02,   4.4526082E-02
     +,   4.9182847E-02,   5.4377798E-02,   6.0162582E-02
     +,   6.6556163E-02,   7.3533833E-02,   8.1040703E-02
     +,   8.9032248E-02,   9.7526461E-02,   0.1066334    
     +,   0.1165262    ,   0.1273521    ,   0.1391475    
     +,   0.1518576    ,   0.1655383    ,   0.1806737    
     +,   0.1983366    ,   0.2198398    ,   0.2458633    
     +,   0.2757535    ,   0.3079465    ,   0.3415223    
     +,   0.3776113    ,   0.4202650    ,   0.4793015    
     +,   0.5763002    ,   0.7394726    ,   0.9652396    
     +,    1.201632    ,    1.443458    ,    1.740951    
     +,    2.116959    ,    2.619717    ,    3.168608    
     +,    3.532742    ,    3.619418    ,    3.606105    
     +,    3.436669    ,    3.106201    ,    2.625471    
     +,    2.301863    ,    1.995515    ,    1.610367    
     +,    1.285436    ,    1.025830    ,   0.8276984    
     +,   0.6924217    ,   0.6036469    ,   0.5394061    
     +,   0.4803716    ,   0.4155965    ,   0.3456031    
     +,   0.2769257    ,   0.2152001    ,   0.1629185    
     +,   0.1203344    ,   8.6728714E-02,   6.1038692E-02
     +,   4.2042062E-02,   2.8444899E-02,   1.8988384E-02
     +,   1.2556166E-02,   8.2448516E-03,   5.3797397E-03
     +,   3.4858433E-03,   2.2399421E-03,   1.4249411E-03
     +,   8.9571491E-04,   5.5530580E-04,   3.3891544E-04
     +,   2.0328963E-04,   1.1966636E-04,   6.9047463E-05
     +,   3.9013295E-05,   2.1566546E-05,   1.1654647E-05
     +,   6.1524997E-06,   3.1705447E-06,   1.5937954E-06
     +,   7.8098816E-07,   3.7283164E-07,   1.7328951E-07
     +,   7.8375997E-08,   3.4480109E-08,   1.4750774E-08
     +,   6.1361067E-09,   2.4830105E-09,   9.7881225E-10
     +,   3.7721717E-10,   1.4325324E-10,   5.4534634E-11
     +,   2.1523202E-11,   9.2946128E-12,   4.6473316E-12
     +,   2.7371768E-12,   1.8311479E-12,   1.3186434E-12
     +,   9.8301152E-13,   7.4312063E-13,   5.6441803E-13
     +,   4.2906046E-13,   3.2595842E-13,   2.4734097E-13
     +,   1.8743008E-13,   1.4182736E-13,   1.0716365E-13
     +,   8.0854763E-14,   6.0917146E-14,   4.5829907E-14
     +,   3.4429633E-14,   2.5828577E-14,   1.9348745E-14
     +,   1.4473986E-14,   1.0812126E-14,   8.0654977E-15
     +,   6.0081995E-15,   4.4694104E-15,   3.3201265E-15
     +,   2.4629946E-15,   1.8246271E-15,   1.3498510E-15
     +,   9.9724609E-16,   7.3575008E-16,   5.4208531E-16
     +,   3.9884971E-16,   2.9306699E-16,   2.1504799E-16
     +,   1.5758372E-16,   1.1531890E-16,   8.4276847E-17
     +,   6.1507489E-17,   4.4828888E-17,   3.2628814E-17
     +,   2.3717096E-17,   1.7216171E-17,   1.2480122E-17
     +,   9.0347884E-18,   6.5316688E-18,   4.7156773E-18
     +,   3.3999394E-18,   2.4479899E-18,   1.7601640E-18
     +,   1.2638762E-18,   9.0627180E-19,   6.4896398E-19
     +,   4.6406549E-19,   3.3139190E-19,   2.3632274E-19
     +,   1.6829114E-19,   1.1967822E-19,   8.4988233E-20
     +,   6.0269640E-20,   4.2679977E-20,   3.0181494E-20
     +,   2.1312741E-20,   1.5028870E-20,   1.0582499E-20
     +,   7.4411100E-21,   5.2246585E-21,   3.6631960E-21
     +,   2.5646666E-21,   1.7929905E-21
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_asha_htt90_mass = Yx/12.34607178
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_asha_htt95_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  7.9891855E-05,   8.6387110E-05
     +,   9.3344897E-05,   1.0079543E-04,   1.0877085E-04
     +,   1.1730512E-04,   1.2643413E-04,   1.3619565E-04
     +,   1.4662916E-04,   1.5777642E-04,   1.6968031E-04
     +,   1.8238543E-04,   1.9593768E-04,   2.1038395E-04
     +,   2.2577187E-04,   2.4214957E-04,   2.5956478E-04
     +,   2.7806516E-04,   2.9769691E-04,   3.1850455E-04
     +,   3.4053059E-04,   3.6381435E-04,   3.8839079E-04
     +,   4.1429239E-04,   4.4154309E-04,   4.7016406E-04
     +,   5.0016731E-04,   5.3155818E-04,   5.6433340E-04
     +,   5.9848034E-04,   6.3397712E-04,   6.7079073E-04
     +,   7.0887804E-04,   7.4818410E-04,   7.8864279E-04
     +,   8.3017588E-04,   8.7269419E-04,   9.1609528E-04
     +,   9.6026948E-04,   1.0050901E-03,   1.0504263E-03
     +,   1.0961351E-03,   1.1420647E-03,   1.1880577E-03
     +,   1.2339494E-03,   1.2795718E-03,   1.3247533E-03
     +,   1.3693218E-03,   1.4131058E-03,   1.4559359E-03
     +,   1.4976485E-03,   1.5380863E-03,   1.5771012E-03
     +,   1.6145582E-03,   1.6503322E-03,   1.6843176E-03
     +,   1.7164262E-03,   1.7465890E-03,   1.7747609E-03
     +,   1.8009209E-03,   1.8250751E-03,   1.8472580E-03
     +,   1.8675345E-03,   1.8860011E-03,   1.9027881E-03
     +,   1.9180585E-03,   1.9320116E-03,   1.9448795E-03
     +,   1.9569315E-03,   1.9684685E-03,   1.9798258E-03
     +,   1.9913688E-03,   2.0034916E-03,   2.0166126E-03
     +,   2.0311722E-03,   2.0476279E-03,   2.0664460E-03
     +,   2.0880974E-03,   2.1130531E-03,   2.1417739E-03
     +,   2.1746997E-03,   2.2122483E-03,   2.2547985E-03
     +,   2.3026916E-03,   2.3562096E-03,   2.4155853E-03
     +,   2.4809761E-03,   2.5524767E-03,   2.6300985E-03
     +,   2.7137843E-03,   2.8034009E-03,   2.8987383E-03
     +,   2.9995209E-03,   3.1054260E-03,   3.2160922E-03
     +,   3.3311278E-03,   3.4501615E-03,   3.5728377E-03
     +,   3.6988859E-03,   3.8281213E-03,   3.9605233E-03
     +,   4.0962398E-03,   4.2356714E-03,   4.3794736E-03
     +,   4.5286301E-03,   4.6844673E-03,   4.8486702E-03
     +,   5.0232890E-03,   5.2107465E-03,   5.4137995E-03
     +,   5.6354613E-03,   5.8789831E-03,   6.1477101E-03
     +,   6.4450488E-03,   6.7742891E-03,   7.1386029E-03
     +,   7.5408593E-03,   7.9836873E-03,   8.4693357E-03
     +,   8.9998012E-03,   9.5768226E-03,   1.0201917E-02
     +,   1.0876491E-02,   1.1601891E-02,   1.2379405E-02
     +,   1.3210049E-02,   1.4094575E-02,   1.5032945E-02
     +,   1.6024182E-02,   1.7065758E-02,   1.8153502E-02
     +,   1.9281257E-02,   2.0441344E-02,   2.1625105E-02
     +,   2.2824515E-02,   2.4034033E-02,   2.5253121E-02
     +,   2.6489010E-02,   2.7759323E-02,   2.9093528E-02
     +,   3.0532796E-02,   3.2127868E-02,   3.3934329E-02
     +,   3.6005720E-02,   3.8385328E-02,   4.1099157E-02
     +,   4.4151597E-02,   4.7526129E-02,   5.1193316E-02
     +,   5.5124935E-02,   5.9311450E-02,   6.3776061E-02
     +,   6.8581186E-02,   7.3820084E-02,   7.9593353E-02
     +,   8.5975684E-02,   9.2984065E-02,   0.1005579    
     +,   0.1085572    ,   0.1167804    ,   0.1250002    
     +,   0.1330195    ,   0.1407679    ,   0.1484610    
     +,   0.1567952    ,   0.1670477    ,   0.1809202    
     +,   0.2001213    ,   0.2259614    ,   0.2593150    
     +,   0.3010456    ,   0.3525355    ,   0.4158934    
     +,   0.4950331    ,   0.5976276    ,   0.7293296    
     +,   0.8821689    ,    1.058401    ,    1.315456    
     +,    1.676273    ,    2.095326    ,    2.607008    
     +,    3.189562    ,    3.747169    ,    4.173181    
     +,    4.300635    ,    3.981193    ,    3.396498    
     +,    2.672615    ,    2.132136    ,    1.760439    
     +,    1.394578    ,    1.079561    ,   0.7796780    
     +,   0.5075333    ,   0.3085810    ,   0.1804013    
     +,   0.1009687    ,   5.3124275E-02,   2.5878888E-02
     +,   1.1704979E-02,   5.0797607E-03,   2.2613010E-03
     +,   1.1133743E-03,   6.1965955E-04,   3.7101109E-04
     +,   2.2409046E-04,   1.3116057E-04,   7.3072653E-05
     +,   3.8495047E-05,   1.9134699E-05,   8.9694868E-06
     +,   3.9649776E-06,   1.6532870E-06,   6.5072379E-07
     +,   2.4221558E-07,   8.5676753E-08,   2.9165465E-08
     +,   9.8736805E-09,   3.5844778E-09,   1.5726801E-09
     +,   8.9661906E-10,   6.2532729E-10,   4.8047694E-10
     +,   3.8204806E-10,   3.0671601E-10,   2.4663435E-10
     +,   1.9817796E-10,   1.5902299E-10,   1.2740660E-10
     +,   1.0191446E-10,   8.1393683E-11,   6.4900717E-11
     +,   5.1666532E-11,   4.1065266E-11,   3.2586819E-11
     +,   2.5817001E-11,   2.0420712E-11,   1.6126440E-11
     +,   1.2714685E-11,   1.0008475E-11,   7.8655485E-12
     +,   6.1715069E-12,   4.8345004E-12,   3.7810011E-12
     +,   2.9522892E-12,   2.3015066E-12,   1.7912783E-12
     +,   1.3918955E-12,   1.0798200E-12,   8.3635892E-13
     +,   6.4673679E-13,   4.9929711E-13,   3.8484865E-13
     +,   2.9615457E-13,   2.2753056E-13,   1.7452467E-13
     +,   1.3365187E-13,   1.0218543E-13,   7.8000174E-14
     +,   5.9442712E-14,   4.5227334E-14,   3.4355829E-14
     +,   2.6055025E-14,   1.9727967E-14,   1.4913177E-14
     +,   1.1255108E-14,   8.4805565E-15,   6.3796933E-15
     +,   4.7914977E-15,   3.5928076E-15,   2.6896324E-15
     +,   2.0102561E-15,   1.5000505E-15,   1.1175116E-15
     +,   8.3118533E-16,   6.1721348E-16,   4.5758546E-16
     +,   3.3868874E-16,   2.5028137E-16,   1.8464948E-16
     +,   1.3600897E-16,   1.0001790E-16,   7.3432383E-17
     +,   5.3825566E-17,   3.9390245E-17,   2.8779605E-17
     +,   2.0992873E-17,   1.5288293E-17,   1.1115670E-17
     +,   8.0688632E-18,   5.8476280E-18,   4.2310425E-18
     +,   3.0563676E-18,   2.2042504E-18,   1.5871189E-18
     +,   1.1409253E-18,   8.1882919E-19,   5.8672055E-19
     +,   4.1971822E-19,   2.9976764E-19
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_asha_htt95_mass = Yx/11.655969
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_asha_ttz100_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  5.6199915E-06,   6.3023017E-06
     +,   7.0560909E-06,   7.8873618E-06,   8.8024390E-06
     +,   9.8079636E-06,   1.0910911E-05,   1.2118555E-05
     +,   1.3438459E-05,   1.4878546E-05,   1.6446949E-05
     +,   1.8152094E-05,   2.0002655E-05,   2.2007538E-05
     +,   2.4175863E-05,   2.6516936E-05,   2.9040246E-05
     +,   3.1755430E-05,   3.4672303E-05,   3.7800764E-05
     +,   4.1150884E-05,   4.4732809E-05,   4.8556798E-05
     +,   5.2633481E-05,   5.6973196E-05,   6.1586950E-05
     +,   6.6485722E-05,   7.1680857E-05,   7.7184086E-05
     +,   8.3007530E-05,   8.9163965E-05,   9.5666757E-05
     +,   1.0253007E-04,   1.0976903E-04,   1.1739985E-04
     +,   1.2543994E-04,   1.3390822E-04,   1.4282487E-04
     +,   1.5221249E-04,   1.6209458E-04,   1.7249773E-04
     +,   1.8344996E-04,   1.9498194E-04,   2.0712652E-04
     +,   2.1991915E-04,   2.3339756E-04,   2.4760194E-04
     +,   2.6257496E-04,   2.7836126E-04,   2.9500783E-04
     +,   3.1256324E-04,   3.3107778E-04,   3.5060282E-04
     +,   3.7119177E-04,   3.9289673E-04,   4.1577223E-04
     +,   4.3987113E-04,   4.6524685E-04,   4.9195124E-04
     +,   5.2003562E-04,   5.4954982E-04,   5.8054231E-04
     +,   6.1305793E-04,   6.4714171E-04,   6.8283704E-04
     +,   7.2018075E-04,   7.5921277E-04,   7.9996441E-04
     +,   8.4246951E-04,   8.8675262E-04,   9.3284028E-04
     +,   9.8074728E-04,   1.0304893E-03,   1.0820681E-03
     +,   1.1354812E-03,   1.1907156E-03,   1.2477416E-03
     +,   1.3065136E-03,   1.3669709E-03,   1.4290328E-03
     +,   1.4925870E-03,   1.5575031E-03,   1.6236126E-03
     +,   1.6907230E-03,   1.7586007E-03,   1.8269862E-03
     +,   1.8955785E-03,   1.9640552E-03,   2.0320567E-03
     +,   2.0992104E-03,   2.1651294E-03,   2.2294193E-03
     +,   2.2916968E-03,   2.3516063E-03,   2.4088365E-03
     +,   2.4631314E-03,   2.5143283E-03,   2.5623653E-03
     +,   2.6073207E-03,   2.6494304E-03,   2.6891250E-03
     +,   2.7270487E-03,   2.7640995E-03,   2.8014490E-03
     +,   2.8405818E-03,   2.8833176E-03,   2.9318400E-03
     +,   2.9887171E-03,   3.0569250E-03,   3.1398584E-03
     +,   3.2413157E-03,   3.3655008E-03,   3.5169572E-03
     +,   3.7005323E-03,   3.9212340E-03,   4.1841432E-03
     +,   4.4941679E-03,   4.8558926E-03,   5.2732299E-03
     +,   5.7491958E-03,   6.2855785E-03,   6.8825623E-03
     +,   7.5384686E-03,   8.2495445E-03,   9.0097599E-03
     +,   9.8106572E-03,   1.0641572E-02,   1.1489642E-02
     +,   1.2340344E-02,   1.3177771E-02,   1.3985457E-02
     +,   1.4746841E-02,   1.5446224E-02,   1.6069293E-02
     +,   1.6603984E-02,   1.7040985E-02,   1.7374191E-02
     +,   1.7601069E-02,   1.7722787E-02,   1.7744260E-02
     +,   1.7673962E-02,   1.7523725E-02,   1.7308421E-02
     +,   1.7045543E-02,   1.6754892E-02,   1.6458130E-02
     +,   1.6178448E-02,   1.5940359E-02,   1.5769385E-02
     +,   1.5691923E-02,   1.5735080E-02,   1.5926266E-02
     +,   1.6292570E-02,   1.6859498E-02,   1.7649030E-02
     +,   1.8676590E-02,   1.9947320E-02,   2.1452064E-02
     +,   2.3163788E-02,   2.5035899E-02,   2.7004994E-02
     +,   2.8999096E-02,   3.0953323E-02,   3.2834072E-02
     +,   3.4669846E-02,   3.6583927E-02,   3.8819637E-02
     +,   4.1743308E-02,   4.5806516E-02,   5.1453952E-02
     +,   5.8981907E-02,   6.8383701E-02,   7.9251572E-02
     +,   9.0826213E-02,   0.1022867    ,   0.1132997    
     +,   0.1246173    ,   0.1382255    ,   0.1564858    
     +,   0.1802831    ,   0.2072879    ,   0.2321327    
     +,   0.2493628    ,   0.2579179    ,   0.2654221    
     +,   0.2898140    ,   0.3512141    ,   0.4566116    
     +,   0.5970085    ,   0.7474560    ,   0.8863801    
     +,    1.056951    ,    1.304866    ,    1.538717    
     +,    1.576485    ,    1.299031    ,   0.8018041    
     +,   0.3533289    ,   0.1110364    ,   2.8898284E-02
     +,   1.0100496E-02,   5.8663869E-03,   4.0761004E-03
     +,   3.0447671E-03,   2.5125537E-03,   2.2768318E-03
     +,   2.1624079E-03,   2.0682230E-03,   1.9566049E-03
     +,   1.8217411E-03,   1.6688134E-03,   1.5055710E-03
     +,   1.3396088E-03,   1.1774187E-03,   1.0240085E-03
     +,   8.8279630E-04,   7.5568602E-04,   6.4329308E-04
     +,   5.4526248E-04,   4.6060025E-04,   3.8794757E-04
     +,   3.2582434E-04,   2.7279530E-04,   2.2755913E-04
     +,   1.8898874E-04,   1.5613738E-04,   1.2822053E-04
     +,   1.0458382E-04,   8.4671759E-05,   6.8004403E-05
     +,   5.4158947E-05,   4.2755451E-05,   3.3449109E-05
     +,   2.5927602E-05,   1.9910080E-05,   1.5145055E-05
     +,   1.1410996E-05,   8.5156107E-06,   6.2941872E-06
     +,   4.6076816E-06,   3.3406793E-06,   2.3988230E-06
     +,   1.7059849E-06,   1.2016012E-06,   8.3819987E-07
     +,   5.7908437E-07,   3.9623040E-07,   2.6851004E-07
     +,   1.8020805E-07,   1.1978427E-07,   7.8855543E-08
     +,   5.1412062E-08,   3.3197413E-08,   2.1230305E-08
     +,   1.3446652E-08,   8.4347622E-09,   5.2400657E-09
     +,   3.2241452E-09,   1.9647117E-09,   1.1857212E-09
     +,   7.0871620E-10,   4.1954262E-10,   2.4597213E-10
     +,   1.4282199E-10,   8.2133113E-11,   4.6778671E-11
     +,   2.6386157E-11,   1.4740442E-11,   8.1556767E-12
     +,   4.4690549E-12,   2.4253204E-12,   1.3035556E-12
     +,   6.9391330E-13,   3.6583657E-13,   1.9101441E-13
     +,   9.8778279E-14,   5.0588867E-14,   2.5660457E-14
     +,   1.2890553E-14,   6.4135154E-15,   3.1602374E-15
     +,   1.5422802E-15,   7.4543002E-16,   3.5684087E-16
     +,   1.6918021E-16,   7.9443736E-17,   3.6949033E-17
     +,   1.7020986E-17,   7.7669522E-18,   3.5109474E-18
     +,   1.5724935E-18,   6.9796761E-19,   3.0715894E-19
     +,   1.3410598E-19,   5.8157033E-20,   2.5097010E-20
     +,   1.0810783E-20,   4.6711758E-21,   2.0402133E-21
     +,   9.1077876E-22,   4.2167107E-22
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_asha_ttz100_mass = Yx/3.47640351219512
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_asha_ttz105_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.2810131E-04,   1.3826681E-04
     +,   1.4898181E-04,   1.6025061E-04,   1.7207487E-04
     +,   1.8445346E-04,   1.9738224E-04,   2.1085386E-04
     +,   2.2485745E-04,   2.3937934E-04,   2.5440165E-04
     +,   2.6990290E-04,   2.8585814E-04,   3.0223859E-04
     +,   3.1901189E-04,   3.3614182E-04,   3.5358901E-04
     +,   3.7131080E-04,   3.8926129E-04,   4.0739201E-04
     +,   4.2565205E-04,   4.4398848E-04,   4.6234686E-04
     +,   4.8067287E-04,   4.9891003E-04,   5.1700452E-04
     +,   5.3490268E-04,   5.5255345E-04,   5.6990935E-04
     +,   5.8692694E-04,   6.0356891E-04,   6.1980484E-04
     +,   6.3561270E-04,   6.5098068E-04,   6.6590833E-04
     +,   6.8040891E-04,   6.9451047E-04,   7.0825819E-04
     +,   7.2171696E-04,   7.3497073E-04,   7.4812828E-04
     +,   7.6132157E-04,   7.7470933E-04,   7.8847795E-04
     +,   8.0284296E-04,   8.1805000E-04,   8.3437510E-04
     +,   8.5212488E-04,   8.7163568E-04,   8.9327275E-04
     +,   9.1742753E-04,   9.4451470E-04,   9.7496802E-04
     +,   1.0092374E-03,   1.0477760E-03,   1.0910431E-03
     +,   1.1394864E-03,   1.1935375E-03,   1.2535997E-03
     +,   1.3200369E-03,   1.3931636E-03,   1.4732307E-03
     +,   1.5604086E-03,   1.6547889E-03,   1.7563639E-03
     +,   1.8650088E-03,   1.9804954E-03,   2.1024593E-03
     +,   2.2304233E-03,   2.3637665E-03,   2.5017608E-03
     +,   2.6435391E-03,   2.7881442E-03,   2.9345029E-03
     +,   3.0814756E-03,   3.2278656E-03,   3.3724341E-03
     +,   3.5139332E-03,   3.6511510E-03,   3.7829294E-03
     +,   3.9081885E-03,   4.0259878E-03,   4.1355272E-03
     +,   4.2362115E-03,   4.3276455E-03,   4.4096909E-03
     +,   4.4824574E-03,   4.5463461E-03,   4.6020290E-03
     +,   4.6504717E-03,   4.6929130E-03,   4.7308486E-03
     +,   4.7660079E-03,   4.8003145E-03,   4.8358510E-03
     +,   4.8747887E-03,   4.9193460E-03,   4.9717040E-03
     +,   5.0339564E-03,   5.1080124E-03,   5.1955516E-03
     +,   5.2979290E-03,   5.4161390E-03,   5.5507417E-03
     +,   5.7018423E-03,   5.8690761E-03,   6.0515827E-03
     +,   6.2480532E-03,   6.4567868E-03,   6.6757686E-03
     +,   6.9027515E-03,   7.1354499E-03,   7.3716450E-03
     +,   7.6094540E-03,   7.8474730E-03,   8.0850758E-03
     +,   8.3225993E-03,   8.5616224E-03,   8.8051157E-03
     +,   9.0576615E-03,   9.3255090E-03,   9.6165622E-03
     +,   9.9402638E-03,   1.0307330E-02,   1.0729332E-02
     +,   1.1218029E-02,   1.1784718E-02,   1.2439241E-02
     +,   1.3189181E-02,   1.4038739E-02,   1.4988104E-02
     +,   1.6032580E-02,   1.7162509E-02,   1.8363135E-02
     +,   1.9615412E-02,   2.0897090E-02,   2.2184279E-02
     +,   2.3453623E-02,   2.4684848E-02,   2.5863156E-02
     +,   2.6981458E-02,   2.8042417E-02,   2.9059559E-02
     +,   3.0057371E-02,   3.1070089E-02,   3.2139443E-02
     +,   3.3310790E-02,   3.4628075E-02,   3.6127884E-02
     +,   3.7833489E-02,   3.9748970E-02,   4.1855261E-02
     +,   4.4109594E-02,   4.6450049E-02,   4.8805624E-02
     +,   5.1112443E-02,   5.3334359E-02,   5.5483066E-02
     +,   5.7631683E-02,   5.9913944E-02,   6.2507533E-02
     +,   6.5600961E-02,   6.9356114E-02,   7.3881209E-02
     +,   7.9223692E-02,   8.5379511E-02,   9.2298806E-02
     +,   9.9867381E-02,   0.1078631    ,   0.1159202    
     +,   0.1235564    ,   0.1302949    ,   0.1358692    
     +,   0.1404591    ,   0.1448950    ,   0.1507090    
     +,   0.1598468    ,   0.1739483    ,   0.1934707    
     +,   0.2172630    ,   0.2430243    ,   0.2684965    
     +,   0.2929019    ,   0.3179591    ,   0.3473643    
     +,   0.3840524    ,   0.4270319    ,   0.4711341    
     +,   0.5098303    ,   0.5374625    ,   0.5492667    
     +,   0.5414142    ,   0.5121340    ,   0.4623254    
     +,   0.3953570    ,   0.3171529    ,   0.2361530    
     +,   0.1617496    ,   0.1014018    ,   5.8324158E-02
     +,   3.1278238E-02,   1.6288271E-02,   8.8689737E-03
     +,   5.4927059E-03,   3.9801826E-03,   3.2232602E-03
     +,   2.7476954E-03,   2.3819427E-03,   2.0748200E-03
     +,   1.8139385E-03,   1.5949452E-03,   1.4124995E-03
     +,   1.2594769E-03,   1.1285412E-03,   1.0136553E-03
     +,   9.1074558E-04,   8.1759033E-04,   7.3329220E-04
     +,   6.5767637E-04,   5.9080118E-04,   5.3262664E-04
     +,   4.8287696E-04,   4.4101747E-04,   4.0629509E-04
     +,   3.7781280E-04,   3.5461361E-04,   3.3575090E-04
     +,   3.2033992E-04,   3.0759175E-04,   2.9683259E-04
     +,   2.8750877E-04,   2.7918030E-04,   2.7150894E-04
     +,   2.6424389E-04,   2.5720664E-04,   2.5027446E-04
     +,   2.4336786E-04,   2.3643968E-04,   2.2946570E-04
     +,   2.2243711E-04,   2.1535598E-04,   2.0823165E-04
     +,   2.0107787E-04,   1.9391034E-04,   1.8674601E-04
     +,   1.7960276E-04,   1.7249826E-04,   1.6544935E-04
     +,   1.5847209E-04,   1.5158241E-04,   1.4479458E-04
     +,   1.3812192E-04,   1.3157706E-04,   1.2517162E-04
     +,   1.1891560E-04,   1.1281799E-04,   1.0688708E-04
     +,   1.0113003E-04,   9.5552576E-05,   9.0159418E-05
     +,   8.4954641E-05,   7.9941317E-05,   7.5121265E-05
     +,   7.0495400E-05,   6.6064320E-05,   6.1827333E-05
     +,   5.7783029E-05,   5.3929627E-05,   5.0264669E-05
     +,   4.6784884E-05,   4.3486521E-05,   4.0365547E-05
     +,   3.7417572E-05,   3.4637585E-05,   3.2020333E-05
     +,   2.9560546E-05,   2.7252436E-05,   2.5090341E-05
     +,   2.3068216E-05,   2.1180189E-05,   1.9420120E-05
     +,   1.7782073E-05,   1.6259941E-05,   1.4847872E-05
     +,   1.3539896E-05,   1.2330343E-05,   1.1213527E-05
     +,   1.0183930E-05,   9.2362816E-06,   8.3653640E-06
     +,   7.5662601E-06,   6.8341346E-06,   6.1644528E-06
     +,   5.5527903E-06,   4.9950190E-06,   4.4871281E-06
     +,   4.0253999E-06,   3.6062413E-06,   3.2263383E-06
     +,   2.8825068E-06,   2.5718173E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_asha_ttz105_mass = Yx/2.5915008
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_asha_ttz107_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.9082906E-04,   1.9876762E-04
     +,   2.0687892E-04,   2.1515902E-04,   2.2360403E-04
     +,   2.3220971E-04,   2.4097213E-04,   2.4988738E-04
     +,   2.5895174E-04,   2.6816232E-04,   2.7751649E-04
     +,   2.8701237E-04,   2.9664917E-04,   3.0642710E-04
     +,   3.1634801E-04,   3.2641526E-04,   3.3663417E-04
     +,   3.4701230E-04,   3.5756003E-04,   3.6829049E-04
     +,   3.7922000E-04,   3.9036889E-04,   4.0176141E-04
     +,   4.1342684E-04,   4.2539873E-04,   4.3771695E-04
     +,   4.5042689E-04,   4.6358080E-04,   4.7723754E-04
     +,   4.9146370E-04,   5.0633372E-04,   5.2193046E-04
     +,   5.3834578E-04,   5.5568042E-04,   5.7404471E-04
     +,   5.9355848E-04,   6.1435159E-04,   6.3656271E-04
     +,   6.6034205E-04,   6.8584620E-04,   7.1324286E-04
     +,   7.4270612E-04,   7.7441765E-04,   8.0856442E-04
     +,   8.4533711E-04,   8.8492921E-04,   9.2753419E-04
     +,   9.7334269E-04,   1.0225406E-03,   1.0753054E-03
     +,   1.1318035E-03,   1.1921858E-03,   1.2565845E-03
     +,   1.3251131E-03,   1.3978513E-03,   1.4748574E-03
     +,   1.5561520E-03,   1.6417204E-03,   1.7315089E-03
     +,   1.8254218E-03,   1.9233213E-03,   2.0250275E-03
     +,   2.1303105E-03,   2.2389060E-03,   2.3505099E-03
     +,   2.4647701E-03,   2.5813174E-03,   2.6997395E-03
     +,   2.8196212E-03,   2.9405165E-03,   3.0619919E-03
     +,   3.1836014E-03,   3.3049309E-03,   3.4255695E-03
     +,   3.5451544E-03,   3.6633608E-03,   3.7799047E-03
     +,   3.8945605E-03,   4.0071667E-03,   4.1176304E-03
     +,   4.2259088E-03,   4.3320418E-03,   4.4361181E-03
     +,   4.5382953E-03,   4.6387701E-03,   4.7377949E-03
     +,   4.8356373E-03,   4.9325982E-03,   5.0289733E-03
     +,   5.1250597E-03,   5.2211350E-03,   5.3174389E-03
     +,   5.4141651E-03,   5.5114646E-03,   5.6094285E-03
     +,   5.7080733E-03,   5.8073704E-03,   5.9072096E-03
     +,   6.0074450E-03,   6.1078668E-03,   6.2082456E-03
     +,   6.3083190E-03,   6.4078388E-03,   6.5065469E-03
     +,   6.6042384E-03,   6.7007570E-03,   6.7960038E-03
     +,   6.8899598E-03,   6.9827121E-03,   7.0744380E-03
     +,   7.1654115E-03,   7.2560161E-03,   7.3467074E-03
     +,   7.4380329E-03,   7.5305742E-03,   7.6249549E-03
     +,   7.7217761E-03,   7.8216176E-03,   7.9249628E-03
     +,   8.0321990E-03,   8.1435656E-03,   8.2591353E-03
     +,   8.3787832E-03,   8.5022198E-03,   8.6289821E-03
     +,   8.7584723E-03,   8.8900505E-03,   9.0231057E-03
     +,   9.1571975E-03,   9.2922105E-03,   9.4285384E-03
     +,   9.5672971E-03,   9.7105596E-03,   9.8615792E-03
     +,   1.0025074E-02,   1.0207466E-02,   1.0417162E-02
     +,   1.0664869E-02,   1.0963942E-02,   1.1330749E-02
     +,   1.1785095E-02,   1.2350661E-02,   1.3055472E-02
     +,   1.3932196E-02,   1.5018033E-02,   1.6354397E-02
     +,   1.7985547E-02,   1.9955937E-02,   2.2306249E-02
     +,   2.5067788E-02,   2.8255073E-02,   3.1857155E-02
     +,   3.5829693E-02,   4.0089171E-02,   4.4511095E-02
     +,   4.8934579E-02,   5.3176045E-02,   5.7051253E-02
     +,   6.0403381E-02,   6.3132867E-02,   6.5223075E-02
     +,   6.6750862E-02,   6.7876860E-02,   6.8814263E-02
     +,   6.9783665E-02,   7.0972823E-02,   7.2526813E-02
     +,   7.4589238E-02,   7.7396229E-02,   8.1388123E-02
     +,   8.7268807E-02,   9.5927879E-02,   0.1081809    
     +,   0.1243708    ,   0.1439712    ,   0.1653867    
     +,   0.1861124    ,   0.2033856    ,   0.2153371    
     +,   0.2222811    ,   0.2272703    ,   0.2350060    
     +,   0.2493570    ,   0.2714555    ,   0.3003173    
     +,   0.3350980    ,   0.3756035    ,   0.4195212    
     +,   0.4595670    ,   0.4849503    ,   0.4869080    
     +,   0.4632487    ,   0.4181913    ,   0.3589731    
     +,   0.2930166    ,   0.2270508    ,   0.1668975    
     +,   0.1167870    ,   7.8579783E-02,   5.1712874E-02
     +,   3.4001622E-02,   2.2757329E-02,   1.5637469E-02
     +,   1.0996652E-02,   7.8459447E-03,   5.6461906E-03
     +,   4.1056783E-03,   3.0472369E-03,   2.3432758E-03
     +,   1.8925708E-03,   1.6146791E-03,   1.4484943E-03
     +,   1.3502220E-03,   1.2902818E-03,   1.2498276E-03
     +,   1.2175413E-03,   1.1870622E-03,   1.1551137E-03
     +,   1.1202371E-03,   1.0819960E-03,   1.0404907E-03
     +,   9.9609292E-04,   9.4930414E-04,   9.0067671E-04
     +,   8.5077033E-04,   8.0013205E-04,   7.4928516E-04
     +,   6.9871719E-04,   6.4886810E-04,   6.0013001E-04
     +,   5.5284624E-04,   5.0730736E-04,   4.6374719E-04
     +,   4.2234830E-04,   3.8324777E-04,   3.4653256E-04
     +,   3.1224772E-04,   2.8040327E-04,   2.5097583E-04
     +,   2.2391240E-04,   1.9913702E-04,   1.7655699E-04
     +,   1.5606532E-04,   1.3754338E-04,   1.2086629E-04
     +,   1.0590682E-04,   9.2536662E-05,   8.0628022E-05
     +,   7.0056463E-05,   6.0703045E-05,   5.2453528E-05
     +,   4.5200042E-05,   3.8842059E-05,   3.3286073E-05
     +,   2.8445240E-05,   2.4239947E-05,   2.0597752E-05
     +,   1.7452716E-05,   1.4745011E-05,   1.2420765E-05
     +,   1.0431798E-05,   8.7350209E-06,   7.2919452E-06
     +,   6.0684615E-06,   5.0345257E-06,   4.1635553E-06
     +,   3.4322445E-06,   2.8202476E-06,   2.3098326E-06
     +,   1.8855660E-06,   1.5341042E-06,   1.2439740E-06
     +,   1.0053172E-06,   8.0968658E-07,   6.4988990E-07
     +,   5.1984057E-07,   4.1437468E-07,   3.2916088E-07
     +,   2.6055687E-07,   2.0553085E-07,   1.6155461E-07
     +,   1.2654115E-07,   9.8765156E-08,   7.6813571E-08
     +,   5.9528425E-08,   4.5969262E-08,   3.5372128E-08
     +,   2.7120606E-08,   2.0719884E-08,   1.5773074E-08
     +,   1.1964452E-08,   9.0428802E-09,   6.8103017E-09
     +,   5.1104783E-09,   3.8212034E-09,   2.8469078E-09
     +,   2.1134330E-09,   1.5632823E-09,   1.1521987E-09
     +,   8.4615537E-10,   6.1917577E-10
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_asha_ttz107_mass = Yx/2.23772684210526
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_asha_ttz110_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  6.6290796E-04,   6.8047165E-04
     +,   6.9866504E-04,   7.1749161E-04,   7.3695247E-04
     +,   7.5704727E-04,   7.7777350E-04,   7.9912646E-04
     +,   8.2109886E-04,   8.4368221E-04,   8.6686463E-04
     +,   8.9063181E-04,   9.1496739E-04,   9.3985209E-04
     +,   9.6526399E-04,   9.9117891E-04,   1.0175697E-03
     +,   1.0444066E-03,   1.0716578E-03,   1.0992887E-03
     +,   1.1272621E-03,   1.1555395E-03,   1.1840791E-03
     +,   1.2128390E-03,   1.2417731E-03,   1.2708369E-03
     +,   1.2999831E-03,   1.3291638E-03,   1.3583316E-03
     +,   1.3874386E-03,   1.4164379E-03,   1.4452833E-03
     +,   1.4739304E-03,   1.5023374E-03,   1.5304653E-03
     +,   1.5582783E-03,   1.5857454E-03,   1.6128393E-03
     +,   1.6395408E-03,   1.6658341E-03,   1.6917133E-03
     +,   1.7171787E-03,   1.7422399E-03,   1.7669159E-03
     +,   1.7912351E-03,   1.8152375E-03,   1.8389736E-03
     +,   1.8625055E-03,   1.8859073E-03,   1.9092659E-03
     +,   1.9326789E-03,   1.9562582E-03,   1.9801264E-03
     +,   2.0044199E-03,   2.0292827E-03,   2.0548732E-03
     +,   2.0813586E-03,   2.1089145E-03,   2.1377250E-03
     +,   2.1679823E-03,   2.1998831E-03,   2.2336291E-03
     +,   2.2694252E-03,   2.3074795E-03,   2.3480025E-03
     +,   2.3912019E-03,   2.4372889E-03,   2.4864697E-03
     +,   2.5389555E-03,   2.5949494E-03,   2.6546614E-03
     +,   2.7182945E-03,   2.7860601E-03,   2.8581619E-03
     +,   2.9348177E-03,   3.0162465E-03,   3.1026718E-03
     +,   3.1943240E-03,   3.2914502E-03,   3.3943078E-03
     +,   3.5031608E-03,   3.6182972E-03,   3.7400103E-03
     +,   3.8686213E-03,   4.0044566E-03,   4.1478761E-03
     +,   4.2992388E-03,   4.4589494E-03,   4.6274080E-03
     +,   4.8050592E-03,   4.9923738E-03,   5.1898398E-03
     +,   5.3979792E-03,   5.6173676E-03,   5.8486187E-03
     +,   6.0923705E-03,   6.3493457E-03,   6.6202716E-03
     +,   6.9059655E-03,   7.2072432E-03,   7.5249965E-03
     +,   7.8600887E-03,   8.2134269E-03,   8.5858526E-03
     +,   8.9781703E-03,   9.3911020E-03,   9.8252064E-03
     +,   1.0280858E-02,   1.0758230E-02,   1.1257226E-02
     +,   1.1777383E-02,   1.2317948E-02,   1.2877704E-02
     +,   1.3455112E-02,   1.4048138E-02,   1.4654435E-02
     +,   1.5271209E-02,   1.5895421E-02,   1.6523700E-02
     +,   1.7152550E-02,   1.7778354E-02,   1.8397456E-02
     +,   1.9006202E-02,   1.9601112E-02,   2.0178784E-02
     +,   2.0735919E-02,   2.1269357E-02,   2.1775937E-02
     +,   2.2252521E-02,   2.2695808E-02,   2.3102360E-02
     +,   2.3468530E-02,   2.3790469E-02,   2.4064200E-02
     +,   2.4285840E-02,   2.4451800E-02,   2.4559233E-02
     +,   2.4606423E-02,   2.4593487E-02,   2.4522929E-02
     +,   2.4400394E-02,   2.4235392E-02,   2.4041897E-02
     +,   2.3838826E-02,   2.3650425E-02,   2.3506105E-02
     +,   2.3440108E-02,   2.3490682E-02,   2.3698814E-02
     +,   2.4106713E-02,   2.4756011E-02,   2.5685856E-02
     +,   2.6931133E-02,   2.8521059E-02,   3.0478010E-02
     +,   3.2816764E-02,   3.5544544E-02,   3.8661510E-02
     +,   4.2161554E-02,   4.6032555E-02,   5.0257534E-02
     +,   5.4814119E-02,   5.9672646E-02,   6.4793706E-02
     +,   7.0125006E-02,   7.5598612E-02,   8.1131674E-02
     +,   8.6635500E-02,   9.2034183E-02,   9.7290389E-02
     +,   0.1024314    ,   0.1075590    ,   0.1128320    
     +,   0.1184144    ,   0.1244110    ,   0.1308255    
     +,   0.1375771    ,   0.1445790    ,   0.1518493    
     +,   0.1595818    ,   0.1681228    ,   0.1778560    
     +,   0.1890552    ,   0.2017819    ,   0.2158555    
     +,   0.2308583    ,   0.2461096    ,   0.2605913    
     +,   0.2728880    ,   0.2812499    ,   0.2838459    
     +,   0.2791584    ,   0.2664025    ,   0.2458142    
     +,   0.2187011    ,   0.1872372    ,   0.1540613    
     +,   0.1217850    ,   9.2548028E-02,   6.7737140E-02
     +,   4.7912017E-02,   3.2917496E-02,   2.2115016E-02
     +,   1.4643485E-02,   9.6331397E-03,   6.3365833E-03
     +,   4.1820961E-03,   2.7687340E-03,   1.8324394E-03
     +,   1.2059404E-03,   7.8458741E-04,   5.0193304E-04
     +,   3.1431933E-04,   1.9195932E-04,   1.1399067E-04
     +,   6.5663698E-05,   3.6622612E-05,   1.9744750E-05
     +,   1.0277154E-05,   5.1594170E-06,   2.4964188E-06
     +,   1.1637500E-06,   5.2279569E-07,   2.2663853E-07
     +,   9.5176091E-08,   3.9092139E-08,   1.6064336E-08
     +,   6.9269750E-09,   3.3863758E-09,   2.0120983E-09
     +,   1.4469641E-09,   1.1768961E-09,   1.0151064E-09
     +,   8.9616109E-10,   7.9764095E-10,   7.1173123E-10
     +,   6.3541028E-10,   5.6720306E-10,   5.0615151E-10
     +,   4.5149076E-10,   4.0256087E-10,   3.5877759E-10
     +,   3.1961669E-10,   2.8460340E-10,   2.5331079E-10
     +,   2.2535653E-10,   2.0039581E-10,   1.7811785E-10
     +,   1.5824243E-10,   1.4051961E-10,   1.2472311E-10
     +,   1.1064970E-10,   9.8117785E-11,   8.6964116E-11
     +,   7.7041366E-11,   6.8217973E-11,   6.0375975E-11
     +,   5.3409895E-11,   4.7224589E-11,   4.1735278E-11
     +,   3.6866073E-11,   3.2549227E-11,   2.8723782E-11
     +,   2.5335485E-11,   2.2336050E-11,   1.9682029E-11
     +,   1.7334830E-11,   1.5260017E-11,   1.3426987E-11
     +,   1.1808333E-11,   1.0379659E-11,   9.1193260E-12
     +,   8.0081063E-12,   7.0288371E-12,   6.1662381E-12
     +,   5.4068603E-12,   4.7386309E-12,   4.1509426E-12
     +,   3.6343361E-12,   3.1804626E-12,   2.7818841E-12
     +,   2.4320606E-12,   2.1251601E-12,   1.8560815E-12
     +,   1.6202644E-12,   1.4137049E-12,   1.2328772E-12
     +,   1.0746407E-12,   9.3624598E-13,   8.1526989E-13
     +,   7.0958219E-13,   6.1728091E-13,   5.3672111E-13
     +,   4.6644470E-13,   4.0517137E-13,   3.5176934E-13
     +,   3.0525558E-13,   2.6475995E-13,   2.2952446E-13
     +,   1.9887815E-13,   1.7223867E-13
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_asha_ttz110_mass = Yx/1.83309283783784
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_asha_ttz115_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  5.5995671E-04,   5.7793432E-04
     +,   5.9651665E-04,   6.1574852E-04,   6.3567882E-04
     +,   6.5636128E-04,   6.7785406E-04,   7.0022041E-04
     +,   7.2352827E-04,   7.4785179E-04,   7.7326910E-04
     +,   7.9986471E-04,   8.2772784E-04,   8.5695297E-04
     +,   8.8763988E-04,   9.1989309E-04,   9.5382158E-04
     +,   9.8953873E-04,   1.0271610E-03,   1.0668078E-03
     +,   1.1086009E-03,   1.1526627E-03,   1.1991155E-03
     +,   1.2480826E-03,   1.2996804E-03,   1.3540253E-03
     +,   1.4112263E-03,   1.4713848E-03,   1.5345927E-03
     +,   1.6009301E-03,   1.6704651E-03,   1.7432473E-03
     +,   1.8193104E-03,   1.8986675E-03,   1.9813085E-03
     +,   2.0671997E-03,   2.1562797E-03,   2.2484581E-03
     +,   2.3436206E-03,   2.4416104E-03,   2.5422506E-03
     +,   2.6453217E-03,   2.7505765E-03,   2.8577328E-03
     +,   2.9664757E-03,   3.0764586E-03,   3.1873090E-03
     +,   3.2986219E-03,   3.4099719E-03,   3.5209097E-03
     +,   3.6309701E-03,   3.7396764E-03,   3.8465383E-03
     +,   3.9510708E-03,   4.0527796E-03,   4.1511897E-03
     +,   4.2458321E-03,   4.3362565E-03,   4.4220421E-03
     +,   4.5027938E-03,   4.5781536E-03,   4.6478035E-03
     +,   4.7114682E-03,   4.7689220E-03,   4.8199953E-03
     +,   4.8645646E-03,   4.9025705E-03,   4.9340082E-03
     +,   4.9589342E-03,   4.9774614E-03,   4.9897679E-03
     +,   4.9960897E-03,   4.9967198E-03,   4.9920133E-03
     +,   4.9823825E-03,   4.9682967E-03,   4.9502864E-03
     +,   4.9289376E-03,   4.9048983E-03,   4.8788749E-03
     +,   4.8516449E-03,   4.8240428E-03,   4.7969865E-03
     +,   4.7714594E-03,   4.7485325E-03,   4.7293589E-03
     +,   4.7151847E-03,   4.7073518E-03,   4.7072978E-03
     +,   4.7165588E-03,   4.7367737E-03,   4.7696694E-03
     +,   4.8170569E-03,   4.8808255E-03,   4.9629156E-03
     +,   5.0652949E-03,   5.1899380E-03,   5.3387764E-03
     +,   5.5136723E-03,   5.7163481E-03,   5.9483694E-03
     +,   6.2110391E-03,   6.5053920E-03,   6.8320800E-03
     +,   7.1913651E-03,   7.5830435E-03,   8.0063688E-03
     +,   8.4600449E-03,   8.9422064E-03,   9.4504049E-03
     +,   9.9815335E-03,   1.0531980E-02,   1.1097504E-02
     +,   1.1673454E-02,   1.2254663E-02,   1.2835684E-02
     +,   1.3410756E-02,   1.3974024E-02,   1.4519527E-02
     +,   1.5041416E-02,   1.5534040E-02,   1.5992023E-02
     +,   1.6410423E-02,   1.6784873E-02,   1.7111678E-02
     +,   1.7387901E-02,   1.7611586E-02,   1.7781762E-02
     +,   1.7898699E-02,   1.7963937E-02,   1.7980443E-02
     +,   1.7952731E-02,   1.7886914E-02,   1.7790781E-02
     +,   1.7673785E-02,   1.7547034E-02,   1.7423162E-02
     +,   1.7316222E-02,   1.7241407E-02,   1.7214803E-02
     +,   1.7253006E-02,   1.7372681E-02,   1.7590072E-02
     +,   1.7920395E-02,   1.8377161E-02,   1.8971546E-02
     +,   1.9711636E-02,   2.0601708E-02,   2.1641694E-02
     +,   2.2826906E-02,   2.4147928E-02,   2.5590925E-02
     +,   2.7138552E-02,   2.8771402E-02,   3.0469837E-02
     +,   3.2215830E-02,   3.3995230E-02,   3.5799511E-02
     +,   3.7626609E-02,   3.9480381E-02,   4.1369643E-02
     +,   4.3305483E-02,   4.5298249E-02,   4.7355197E-02
     +,   4.9479425E-02,   5.1670641E-02,   5.3927992E-02
     +,   5.6255899E-02,   5.8670722E-02,   6.1208174E-02
     +,   6.3928686E-02,   6.6918537E-02,   7.0284076E-02
     +,   7.4136049E-02,   7.8566171E-02,   8.3622560E-02
     +,   8.9291997E-02,   9.5499553E-02,   0.1021316    
     +,   0.1090775    ,   0.1162748    ,   0.1237371    
     +,   0.1315491    ,   0.1398220    ,   0.1486138    
     +,   0.1578394    ,   0.1671981    ,   0.1761425    
     +,   0.1839027    ,   0.1895690    ,   0.1922222    
     +,   0.1910876    ,   0.1856841    ,   0.1759398    
     +,   0.1622422    ,   0.1454094    ,   0.1265821    
     +,   0.1070554    ,   8.8084720E-02,   7.0716858E-02
     +,   5.5674814E-02,   4.3314453E-02,   3.3652589E-02
     +,   2.6447596E-02,   2.1301400E-02,   1.7755862E-02
     +,   1.5369589E-02,   1.3764856E-02,   1.2647352E-02
     +,   1.1806212E-02,   1.1102409E-02,   1.0452578E-02
     +,   9.8127490E-03,   9.1646854E-03,   8.5055185E-03
     +,   7.8405188E-03,   7.1783219E-03,   6.5280721E-03
     +,   5.8979816E-03,   5.2947830E-03,   4.7234944E-03
     +,   4.1876370E-03,   3.6895096E-03,   3.2303750E-03
     +,   2.8106284E-03,   2.4299705E-03,   2.0875365E-03
     +,   1.7819519E-03,   1.5113984E-03,   1.2737251E-03
     +,   1.0665520E-03,   8.8733854E-04,   7.3346042E-04
     +,   6.0230267E-04,   4.9133075E-04,   3.9811523E-04
     +,   3.2038105E-04,   2.5603391E-04,   2.0316467E-04
     +,   1.6005139E-04,   1.2516225E-04,   9.7149743E-05
     +,   7.4837801E-05,   5.7209138E-05,   4.3394415E-05
     +,   3.2658645E-05,   2.4385708E-05,   1.8064218E-05
     +,   1.3274757E-05,   9.6772319E-06,   6.9980301E-06
     +,   5.0197914E-06,   3.5717110E-06,   2.5208371E-06
     +,   1.7647354E-06,   1.2253719E-06,   8.4393469E-07
     +,   5.7650129E-07,   3.9059822E-07,   2.6247312E-07
     +,   1.7492916E-07,   1.1562710E-07,   7.5798845E-08
     +,   4.9278313E-08,   3.1771823E-08,   2.0314474E-08
     +,   1.2880419E-08,   8.0986240E-09,   5.0494773E-09
     +,   3.1218994E-09,   1.9138633E-09,   1.1633753E-09
     +,   7.0120199E-10,   4.1904785E-10,   2.4829347E-10
     +,   1.4586603E-10,   8.4958533E-11,   4.9060297E-11
     +,   2.8086828E-11,   1.5941685E-11,   8.9702716E-12
     +,   5.0041807E-12,   2.7676062E-12,   1.5175584E-12
     +,   8.2501475E-13,   4.4474298E-13,   2.3776253E-13
     +,   1.2608584E-13,   6.6355653E-14,   3.4678437E-14
     +,   1.8018537E-14,   9.3247799E-15,   4.8208355E-15
     +,   2.5014245E-15,   1.3120586E-15,   7.0283109E-16
     +,   3.8963524E-16,   2.2680461E-16,   1.4027196E-16
     +,   9.2594604E-17,   6.4940600E-17
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_asha_ttz115_mass = Yx/1.417227
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_asha_ttz120_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.5918074E-04,   4.7700887E-04
     +,   4.9518485E-04,   5.1370572E-04,   5.3256890E-04
     +,   5.5177201E-04,   5.7131308E-04,   5.9119053E-04
     +,   6.1140279E-04,   6.3194952E-04,   6.5282977E-04
     +,   6.7404303E-04,   6.9558894E-04,   7.1746734E-04
     +,   7.3967769E-04,   7.6221960E-04,   7.8509183E-04
     +,   8.0829283E-04,   8.3182059E-04,   8.5567153E-04
     +,   8.7984139E-04,   9.0432441E-04,   9.2911266E-04
     +,   9.5419819E-04,   9.7956788E-04,   1.0052094E-03
     +,   1.0311063E-03,   1.0572394E-03,   1.0835873E-03
     +,   1.1101248E-03,   1.1368241E-03,   1.1636548E-03
     +,   1.1905819E-03,   1.2175688E-03,   1.2445746E-03
     +,   1.2715567E-03,   1.2984696E-03,   1.3252650E-03
     +,   1.3518952E-03,   1.3783079E-03,   1.4044539E-03
     +,   1.4302824E-03,   1.4557448E-03,   1.4807946E-03
     +,   1.5053890E-03,   1.5294907E-03,   1.5530676E-03
     +,   1.5760971E-03,   1.5985650E-03,   1.6204697E-03
     +,   1.6418225E-03,   1.6626508E-03,   1.6829990E-03
     +,   1.7029324E-03,   1.7225367E-03,   1.7419241E-03
     +,   1.7612310E-03,   1.7806235E-03,   1.8002974E-03
     +,   1.8204811E-03,   1.8414361E-03,   1.8634585E-03
     +,   1.8868796E-03,   1.9120665E-03,   1.9394230E-03
     +,   1.9693854E-03,   2.0024264E-03,   2.0390467E-03
     +,   2.0797804E-03,   2.1251827E-03,   2.1758364E-03
     +,   2.2323332E-03,   2.2952869E-03,   2.3653076E-03
     +,   2.4430128E-03,   2.5290118E-03,   2.6238966E-03
     +,   2.7282352E-03,   2.8425711E-03,   2.9674149E-03
     +,   3.1032166E-03,   3.2503912E-03,   3.4092723E-03
     +,   3.5801481E-03,   3.7632061E-03,   3.9585787E-03
     +,   4.1662799E-03,   4.3862602E-03,   4.6183411E-03
     +,   4.8622629E-03,   5.1176539E-03,   5.3840238E-03
     +,   5.6607593E-03,   5.9471535E-03,   6.2423777E-03
     +,   6.5454585E-03,   6.8553435E-03,   7.1708169E-03
     +,   7.4905884E-03,   7.8132097E-03,   8.1371618E-03
     +,   8.4607815E-03,   8.7823579E-03,   9.1000386E-03
     +,   9.4119580E-03,   9.7161988E-03,   1.0010812E-02
     +,   1.0293866E-02,   1.0563524E-02,   1.0818048E-02
     +,   1.1055856E-02,   1.1275609E-02,   1.1476237E-02
     +,   1.1657048E-02,   1.1817737E-02,   1.1958497E-02
     +,   1.2079993E-02,   1.2183482E-02,   1.2270734E-02
     +,   1.2344089E-02,   1.2406389E-02,   1.2460911E-02
     +,   1.2511283E-02,   1.2561345E-02,   1.2615015E-02
     +,   1.2676102E-02,   1.2748127E-02,   1.2834133E-02
     +,   1.2936515E-02,   1.3056859E-02,   1.3195866E-02
     +,   1.3353276E-02,   1.3527940E-02,   1.3717908E-02
     +,   1.3920713E-02,   1.4133627E-02,   1.4354108E-02
     +,   1.4580234E-02,   1.4811234E-02,   1.5047903E-02
     +,   1.5292999E-02,   1.5551450E-02,   1.5830437E-02
     +,   1.6139193E-02,   1.6488461E-02,   1.6889937E-02
     +,   1.7355310E-02,   1.7895272E-02,   1.8518563E-02
     +,   1.9231169E-02,   2.0035690E-02,   2.0931000E-02
     +,   2.1912389E-02,   2.2972060E-02,   2.4099866E-02
     +,   2.5284301E-02,   2.6513861E-02,   2.7778644E-02
     +,   2.9072078E-02,   3.0392641E-02,   3.1746261E-02
     +,   3.3147708E-02,   3.4621466E-02,   3.6201060E-02
     +,   3.7926260E-02,   3.9837629E-02,   4.1968901E-02
     +,   4.4338774E-02,   4.6943750E-02,   4.9754411E-02
     +,   5.2716482E-02,   5.5758417E-02,   5.8804404E-02
     +,   6.1790004E-02,   6.4678371E-02,   6.7475073E-02
     +,   7.0237726E-02,   7.3079616E-02,   7.6165937E-02
     +,   7.9699330E-02,   8.3892196E-02,   8.8924557E-02
     +,   9.4890594E-02,   0.1017420    ,   0.1092420    
     +,   0.1169472    ,   0.1242328    ,   0.1303654    
     +,   0.1346118    ,   0.1363641    ,   0.1352500    
     +,   0.1311987    ,   0.1244494    ,   0.1155002    
     +,   0.1050131    ,   9.3704283E-02,   8.2243271E-02
     +,   7.1179658E-02,   6.0906276E-02,   5.1657867E-02
     +,   4.3533489E-02,   3.6530208E-02,   3.0578353E-02
     +,   2.5572591E-02,   2.1394415E-02,   1.7925069E-02
     +,   1.5053719E-02,   1.2680946E-02,   1.0719530E-02
     +,   9.0944134E-03,   7.7424012E-03,   6.6115446E-03
     +,   5.6600878E-03,   4.8552561E-03,   4.1719424E-03
     +,   3.5911934E-03,   3.0986175E-03,   2.6829727E-03
     +,   2.3350718E-03,   2.0469595E-03,   1.8113083E-03
     +,   1.6211742E-03,   1.4699161E-03,   1.3512137E-03
     +,   1.2591579E-03,   1.1883713E-03,   1.1340944E-03
     +,   1.0922292E-03,   1.0593456E-03,   1.0326590E-03
     +,   1.0099764E-03,   9.8962069E-04,   9.7035029E-04
     +,   9.5128210E-04,   9.3181833E-04,   9.1157854E-04
     +,   8.9034654E-04,   8.6802797E-04,   8.4461458E-04
     +,   8.2015625E-04,   7.9474272E-04,   7.6849142E-04
     +,   7.4153510E-04,   7.1401359E-04,   6.8606902E-04
     +,   6.5784494E-04,   6.2948168E-04,   6.0111185E-04
     +,   5.7286170E-04,   5.4485182E-04,   5.1719160E-04
     +,   4.8998132E-04,   4.6331313E-04,   4.3726937E-04
     +,   4.1192083E-04,   3.8732847E-04,   3.6354529E-04
     +,   3.4061490E-04,   3.1857044E-04,   2.9743655E-04
     +,   2.7723133E-04,   2.5796547E-04,   2.3964135E-04
     +,   2.2225532E-04,   2.0579979E-04,   1.9026049E-04
     +,   1.7561890E-04,   1.6185368E-04,   1.4894021E-04
     +,   1.3685030E-04,   1.2555375E-04,   1.1501946E-04
     +,   1.0521499E-04,   9.6106414E-05,   8.7659428E-05
     +,   7.9840378E-05,   7.2614726E-05,   6.5949265E-05
     +,   5.9810485E-05,   5.4166441E-05,   4.8985414E-05
     +,   4.4237353E-05,   3.9892722E-05,   3.5923778E-05
     +,   3.2303451E-05,   2.9006513E-05,   2.6008596E-05
     +,   2.3286739E-05,   2.0819496E-05,   1.8586348E-05
     +,   1.6568361E-05,   1.4747512E-05,   1.3107210E-05
     +,   1.1631774E-05,   1.0306808E-05,   9.1187721E-06
     +,   8.0552863E-06,   7.1047593E-06,   6.2566173E-06
     +,   5.5010173E-06,   4.8290181E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_asha_ttz120_mass = Yx/1.06752163636364
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_asha_ttz60_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.5055916E-04,   1.5825311E-04
     +,   1.6611967E-04,   1.7415179E-04,   1.8234387E-04
     +,   1.9069266E-04,   1.9919840E-04,   2.0786606E-04
     +,   2.1670698E-04,   2.2574120E-04,   2.3499913E-04
     +,   2.4452477E-04,   2.5437871E-04,   2.6464215E-04
     +,   2.7542067E-04,   2.8684948E-04,   2.9909864E-04
     +,   3.1237942E-04,   3.2695066E-04,   3.4312697E-04
     +,   3.6128663E-04,   3.8188155E-04,   4.0544657E-04
     +,   4.3261313E-04,   4.6411666E-04,   5.0081563E-04
     +,   5.4370012E-04,   5.9390767E-04,   6.5273489E-04
     +,   7.2165002E-04,   8.0230052E-04,   8.9651911E-04
     +,   1.0063238E-03,   1.1339149E-03,   1.2816652E-03
     +,   1.4521101E-03,   1.6479368E-03,   1.8719737E-03
     +,   2.1272192E-03,   2.4168200E-03,   2.7441853E-03
     +,   3.1130151E-03,   3.5274404E-03,   3.9921533E-03
     +,   4.5125610E-03,   5.0949352E-03,   5.7465141E-03
     +,   6.4755632E-03,   7.2913268E-03,   8.2038976E-03
     +,   9.2239510E-03,   1.0362403E-02,   1.1629974E-02
     +,   1.3036877E-02,   1.4592186E-02,   1.6303902E-02
     +,   1.8178571E-02,   2.0221498E-02,   2.2437010E-02
     +,   2.4828842E-02,   2.7400693E-02,   3.0156597E-02
     +,   3.3100758E-02,   3.6237501E-02,   3.9569575E-02
     +,   4.3095473E-02,   4.6806723E-02,   5.0682843E-02
     +,   5.4687962E-02,   5.8766641E-02,   6.2843733E-02
     +,   6.6825464E-02,   7.0606381E-02,   7.4078165E-02
     +,   7.7142008E-02,   7.9720773E-02,   8.1767924E-02
     +,   8.3272375E-02,   8.4256597E-02,   8.4767744E-02
     +,   8.4865093E-02,   8.4606163E-02,   8.4035128E-02
     +,   8.3177410E-02,   8.2040980E-02,   8.0624394E-02
     +,   7.8929387E-02,   7.6973312E-02,   7.4799366E-02
     +,   7.2480291E-02,   7.0115767E-02,   6.7823395E-02
     +,   6.5725841E-02,   6.3936055E-02,   6.2544622E-02
     +,   6.1610285E-02,   6.1154958E-02,   6.1164323E-02
     +,   6.1591990E-02,   6.2367205E-02,   6.3404262E-02
     +,   6.4611644E-02,   6.5899990E-02,   6.7187697E-02
     +,   6.8404369E-02,   6.9491632E-02,   7.0402518E-02
     +,   7.1101174E-02,   7.1562722E-02,   7.1774006E-02
     +,   7.1735039E-02,   7.1460754E-02,   7.0981026E-02
     +,   7.0338964E-02,   6.9586679E-02,   6.8779454E-02
     +,   6.7969173E-02,   6.7197926E-02,   6.6494294E-02
     +,   6.5871432E-02,   6.5327995E-02,   6.4851120E-02
     +,   6.4419858E-02,   6.4008921E-02,   6.3591592E-02
     +,   6.3141659E-02,   6.2634692E-02,   6.2048696E-02
     +,   6.1365198E-02,   6.0569603E-02,   5.9652153E-02
     +,   5.8608521E-02,   5.7439916E-02,   5.6152873E-02
     +,   5.4758221E-02,   5.3269699E-02,   5.1702764E-02
     +,   5.0073121E-02,   4.8395436E-02,   4.6682987E-02
     +,   4.4947572E-02,   4.3199632E-02,   4.1448817E-02
     +,   3.9704707E-02,   3.7977725E-02,   3.6279358E-02
     +,   3.4622725E-02,   3.3022601E-02,   3.1495053E-02
     +,   3.0056700E-02,   2.8723890E-02,   2.7511794E-02
     +,   2.6433110E-02,   2.5497094E-02,   2.4708867E-02
     +,   2.4068942E-02,   2.3573076E-02,   2.3212440E-02
     +,   2.2974165E-02,   2.2842098E-02,   2.2797564E-02
     +,   2.2820281E-02,   2.2889167E-02,   2.2983138E-02
     +,   2.3081698E-02,   2.3165531E-02,   2.3216944E-02
     +,   2.3220187E-02,   2.3161834E-02,   2.3031004E-02
     +,   2.2819577E-02,   2.2522319E-02,   2.2137001E-02
     +,   2.1664312E-02,   2.1107811E-02,   2.0473627E-02
     +,   1.9770155E-02,   1.9007653E-02,   1.8197751E-02
     +,   1.7352812E-02,   1.6485469E-02,   1.5608121E-02
     +,   1.4732430E-02,   1.3868853E-02,   1.3026403E-02
     +,   1.2212504E-02,   1.1432827E-02,   1.0691278E-02
     +,   9.9901147E-03,   9.3302056E-03,   8.7110959E-03
     +,   8.1313262E-03,   7.5887493E-03,   7.0807138E-03
     +,   6.6042859E-03,   6.1564939E-03,   5.7345061E-03
     +,   5.3357380E-03,   4.9578999E-03,   4.5990809E-03
     +,   4.2577782E-03,   3.9328588E-03,   3.6234977E-03
     +,   3.3291534E-03,   3.0495396E-03,   2.7844976E-03
     +,   2.5339767E-03,   2.2979863E-03,   2.0765397E-03
     +,   1.8695947E-03,   1.6770494E-03,   1.4987321E-03
     +,   1.3343777E-03,   1.1836134E-03,   1.0459804E-03
     +,   9.2094380E-04,   8.0789847E-04,   7.0617488E-04
     +,   6.1506225E-04,   5.3383206E-04,   4.6173413E-04
     +,   3.9801956E-04,   3.4195583E-04,   2.9283096E-04
     +,   2.4995909E-04,   2.1269076E-04,   1.8041901E-04
     +,   1.5257928E-04,   1.2864942E-04,   1.0815262E-04
     +,   9.0657566E-05,   7.5775395E-05,   6.3157058E-05
     +,   5.2492276E-05,   4.3507527E-05,   3.5961275E-05
     +,   2.9642229E-05,   2.4366780E-05,   1.9975691E-05
     +,   1.6331205E-05,   1.3315025E-05,   1.0826059E-05
     +,   8.7780945E-06,   7.0977267E-06,   5.7228713E-06
     +,   4.6012360E-06,   3.6888491E-06,   2.9487933E-06
     +,   2.3502575E-06,   1.8676418E-06,   1.4796448E-06
     +,   1.1686509E-06,   9.2015381E-07,   7.2221775E-07
     +,   5.6504837E-07,   4.4064547E-07,   3.4250317E-07
     +,   2.6533556E-07,   2.0486155E-07,   1.5762970E-07
     +,   1.2086889E-07,   9.2358498E-08,   7.0324305E-08
     +,   5.3355752E-08,   4.0336456E-08,   3.0383447E-08
     +,   2.2802499E-08,   1.7050050E-08,   1.2701614E-08
     +,   9.4268877E-09,   6.9701125E-09,   5.1341358E-09
     +,   3.7674455E-09,   2.7540239E-09,   2.0054702E-09
     +,   1.4547749E-09,   1.0512134E-09,   7.5666634E-10
     +,   5.4252974E-10,   3.8748177E-10,   2.7566063E-10
     +,   1.9534378E-10,   1.3788366E-10,   9.6943939E-11
     +,   6.7890644E-11,   4.7357514E-11,   3.2904110E-11
     +,   2.2771195E-11,   1.5696576E-11,   1.0776926E-11
     +,   7.3699562E-12,   5.0199927E-12,   3.4058043E-12
     +,   2.3014481E-12,   1.5490274E-12,   1.0384372E-12
     +,   6.9338914E-13,   4.6114295E-13,   3.0546881E-13
     +,   2.0153889E-13,   1.3244157E-13
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_asha_ttz60_mass = Yx/1.56344883333333
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_asha_ttz65_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  6.2174011E-05,   6.5733169E-05
     +,   6.9427595E-05,   7.3257914E-05,   7.7224657E-05
     +,   8.1328209E-05,   8.5568965E-05,   8.9947258E-05
     +,   9.4463576E-05,   9.9118806E-05,   1.0391408E-04
     +,   1.0885123E-04,   1.1393287E-04,   1.1916271E-04
     +,   1.2454587E-04,   1.3008923E-04,   1.3580173E-04
     +,   1.4169507E-04,   1.4778387E-04,   1.5408646E-04
     +,   1.6062563E-04,   1.6742892E-04,   1.7452963E-04
     +,   1.8196797E-04,   1.8979069E-04,   1.9805372E-04
     +,   2.0682163E-04,   2.1616949E-04,   2.2618346E-04
     +,   2.3696230E-04,   2.4861807E-04,   2.6127763E-04
     +,   2.7508358E-04,   2.9019578E-04,   3.0679212E-04
     +,   3.2507052E-04,   3.4524943E-04,   3.6756913E-04
     +,   3.9229458E-04,   4.1971239E-04,   4.5013704E-04
     +,   4.8390683E-04,   5.2138563E-04,   5.6296220E-04
     +,   6.0904806E-04,   6.6007447E-04,   7.1648799E-04
     +,   7.7874423E-04,   8.4729819E-04,   9.2259463E-04
     +,   1.0050519E-03,   1.0950463E-03,   1.1928898E-03
     +,   1.2988143E-03,   1.4129290E-03,   1.5352159E-03
     +,   1.6654823E-03,   1.8033423E-03,   1.9481883E-03
     +,   2.0991703E-03,   2.2551809E-03,   2.4148526E-03
     +,   2.5765589E-03,   2.7384704E-03,   2.8986193E-03
     +,   3.0550146E-03,   3.2059120E-03,   3.3501468E-03
     +,   3.4877739E-03,   3.6209440E-03,   3.7552617E-03
     +,   3.9016008E-03,   4.0785912E-03,   4.3156100E-03
     +,   4.6563689E-03,   5.1626726E-03,   5.9178662E-03
     +,   7.0291869E-03,   8.6279614E-03,   1.0865958E-02
     +,   1.3906392E-02,   1.7909804E-02,   2.3013616E-02
     +,   2.9311623E-02,   3.6834564E-02,   4.5542631E-02
     +,   5.5325385E-02,   6.6012353E-02,   7.7373952E-02
     +,   8.9114934E-02,   0.1008595    ,   0.1121627    
     +,   0.1225895    ,   0.1318628    ,   0.1400144    
     +,   0.1474124    ,   0.1545708    ,   0.1617771    
     +,   0.1687686    ,   0.1747212    ,   0.1786589    
     +,   0.1800704    ,   0.1793233    ,   0.1775525    
     +,   0.1760528    ,   0.1755456    ,   0.1757758    
     +,   0.1756646    ,   0.1739022    ,   0.1696341    
     +,   0.1629044    ,   0.1546800    ,   0.1464990    
     +,   0.1399152    ,   0.1359782    ,   0.1349350    
     +,   0.1362617    ,   0.1389889    ,   0.1421623    
     +,   0.1452121    ,   0.1480498    ,   0.1508646    
     +,   0.1537644    ,   0.1564930    ,   0.1583920    
     +,   0.1586202    ,   0.1564968    ,   0.1517829    
     +,   0.1447757    ,   0.1362030    ,   0.1269922    
     +,   0.1180274    ,   0.1099734    ,   0.1032060    
     +,   9.7827122E-02,   9.3729094E-02,   9.0669706E-02
     +,   8.8335469E-02,   8.6390145E-02,   8.4512420E-02
     +,   8.2426690E-02,   7.9928249E-02,   7.6899886E-02
     +,   7.3318429E-02,   6.9249824E-02,   6.4832218E-02
     +,   6.0251214E-02,   5.5710305E-02,   5.1400758E-02
     +,   4.7476131E-02,   4.4035938E-02,   4.1120019E-02
     +,   3.8712673E-02,   3.6754981E-02,   3.5161760E-02
     +,   3.3838771E-02,   3.2697115E-02,   3.1663220E-02
     +,   3.0683836E-02,   2.9726738E-02,   2.8777832E-02
     +,   2.7836608E-02,   2.6911089E-02,   2.6012788E-02
     +,   2.5152819E-02,   2.4339179E-02,   2.3575373E-02
     +,   2.2859883E-02,   2.2186667E-02,   2.1546192E-02
     +,   2.0926788E-02,   2.0316092E-02,   1.9702239E-02
     +,   1.9075055E-02,   1.8426834E-02,   1.7752696E-02
     +,   1.7050726E-02,   1.6321858E-02,   1.5569438E-02
     +,   1.4798620E-02,   1.4015800E-02,   1.3228058E-02
     +,   1.2442540E-02,   1.1665944E-02,   1.0904222E-02
     +,   1.0162424E-02,   9.4445432E-03,   8.7534767E-03
     +,   8.0911703E-03,   7.4588261E-03,   6.8569379E-03
     +,   6.2855305E-03,   5.7443585E-03,   5.2330019E-03
     +,   4.7509256E-03,   4.2975894E-03,   3.8725080E-03
     +,   3.4752195E-03,   3.1052507E-03,   2.7621225E-03
     +,   2.4453346E-03,   2.1543114E-03,   1.8883569E-03
     +,   1.6466604E-03,   1.4283062E-03,   1.2322285E-03
     +,   1.0572458E-03,   9.0208772E-04,   7.6540135E-04
     +,   6.4576924E-04,   5.4174860E-04,   4.5190135E-04
     +,   3.7481074E-04,   3.0909904E-04,   2.5345274E-04
     +,   2.0663996E-04,   1.6751575E-04,   1.3502761E-04
     +,   1.0822240E-04,   8.6248518E-05,   6.8348563E-05
     +,   5.3858461E-05,   4.2202224E-05,   3.2883978E-05
     +,   2.5480271E-05,   1.9633486E-05,   1.5044370E-05
     +,   1.1464183E-05,   8.6877317E-06,   6.5473255E-06
     +,   4.9070859E-06,   3.6575696E-06,   2.7112449E-06
     +,   1.9987087E-06,   1.4653594E-06,   1.0684356E-06
     +,   7.7474118E-07,   5.5869111E-07,   4.0067923E-07
     +,   2.8577446E-07,   2.0269528E-07,   1.4297436E-07
     +,   1.0029219E-07,   6.9961779E-08,   4.8532037E-08
     +,   3.3478795E-08,   2.2965898E-08,   1.5666005E-08
     +,   1.0626299E-08,   7.1673703E-09,   4.8070623E-09
     +,   3.2057499E-09,   2.1257365E-09,   1.4015838E-09
     +,   9.1885649E-10,   5.9894284E-10,   3.8818113E-10
     +,   2.5014954E-10,   1.6027815E-10,   1.0210689E-10
     +,   6.4677520E-11,   4.0736740E-11,   2.5513149E-11
     +,   1.5889285E-11,   9.8414063E-12,   6.0627011E-12
     +,   3.7153505E-12,   2.2655057E-12,   1.3750304E-12
     +,   8.3106341E-13,   5.0048941E-13,   3.0059299E-13
     +,   1.8026207E-13,   1.0810599E-13,   6.4970314E-14
     +,   3.9235915E-14,   2.3888818E-14,   1.4722369E-14
     +,   9.2237865E-15,   5.9004239E-15,   3.8680729E-15
     +,   2.6049952E-15,   1.8033984E-15,   1.2818386E-15
     +,   9.3287434E-16,   6.9257644E-16,   5.2243219E-16
     +,   3.9890524E-16,   3.0730969E-16,   2.3822857E-16
     +,   1.8545487E-16,   1.4475647E-16,   1.1316620E-16
     +,   8.8535603E-17,   6.9280003E-17,   5.4201076E-17
     +,   4.2384764E-17,   3.3122691E-17,   2.5864800E-17
     +,   2.0179865E-17,   1.5730241E-17
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_asha_ttz65_mass = Yx/2.17379178947368
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_asha_ttz70_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  7.1488459E-05,   8.0284080E-05
     +,   8.9949295E-05,   1.0054029E-04,   1.1211306E-04
     +,   1.2472266E-04,   1.3842281E-04,   1.5326477E-04
     +,   1.6929688E-04,   1.8656431E-04,   2.0510705E-04
     +,   2.2495995E-04,   2.4615155E-04,   2.6870344E-04
     +,   2.9262918E-04,   3.1793385E-04,   3.4461284E-04
     +,   3.7265156E-04,   4.0202469E-04,   4.3269561E-04
     +,   4.6461629E-04,   4.9772672E-04,   5.3195446E-04
     +,   5.6721759E-04,   6.0341856E-04,   6.4045266E-04
     +,   6.7820272E-04,   7.1654236E-04,   7.5533730E-04
     +,   7.9444511E-04,   8.3371869E-04,   8.7300688E-04
     +,   9.1215631E-04,   9.5101399E-04,   9.8942930E-04
     +,   1.0272564E-03,   1.0643569E-03,   1.1006016E-03
     +,   1.1358763E-03,   1.1700778E-03,   1.2031249E-03
     +,   1.2349540E-03,   1.2655252E-03,   1.2948235E-03
     +,   1.3228605E-03,   1.3496766E-03,   1.3753423E-03
     +,   1.3999592E-03,   1.4236603E-03,   1.4466100E-03
     +,   1.4690047E-03,   1.4910700E-03,   1.5130601E-03
     +,   1.5352565E-03,   1.5579618E-03,   1.5814999E-03
     +,   1.6062103E-03,   1.6324427E-03,   1.6605549E-03
     +,   1.6909061E-03,   1.7238549E-03,   1.7597544E-03
     +,   1.7989494E-03,   1.8417804E-03,   1.8885847E-03
     +,   1.9396975E-03,   1.9954739E-03,   2.0562920E-03
     +,   2.1225936E-03,   2.1949010E-03,   2.2738858E-03
     +,   2.3604117E-03,   2.4556464E-03,   2.5611517E-03
     +,   2.6790600E-03,   2.8122514E-03,   2.9645870E-03
     +,   3.1411857E-03,   3.3487496E-03,   3.5958805E-03
     +,   3.8933584E-03,   4.2544412E-03,   4.6949293E-03
     +,   5.2332561E-03,   5.8901962E-03,   6.6886591E-03
     +,   7.6530324E-03,   8.8087665E-03,   1.0181317E-02
     +,   1.1795331E-02,   1.3672931E-02,   1.5831126E-02
     +,   1.8278370E-02,   2.1010436E-02,   2.4006004E-02
     +,   2.7224071E-02,   3.0607114E-02,   3.4090828E-02
     +,   3.7626274E-02,   4.1210435E-02,   4.4924334E-02
     +,   4.8962157E-02,   5.3638790E-02,   5.9355952E-02
     +,   6.6530667E-02,   7.5506441E-02,   8.6491615E-02
     +,   9.9573717E-02,   0.1148236    ,   0.1324406    
     +,   0.1528040    ,   0.1762389    ,   0.2023837    
     +,   0.2294447    ,   0.2540452    ,   0.2723427    
     +,   0.2820503    ,   0.2838697    ,   0.2809466    
     +,   0.2767347    ,   0.2732113    ,   0.2709148    
     +,   0.2702515    ,   0.2722836    ,   0.2779991    
     +,   0.2867577    ,   0.2954535    ,   0.2993844    
     +,   0.2946402    ,   0.2806233    ,   0.2609268    
     +,   0.2417489    ,   0.2287405    ,   0.2242052    
     +,   0.2261701    ,   0.2297184    ,   0.2297313    
     +,   0.2234033    ,   0.2110863    ,   0.1952206    
     +,   0.1784577    ,   0.1623930    ,   0.1475099    
     +,   0.1338630    ,   0.1216646    ,   0.1113355    
     +,   0.1031863    ,   9.7117424E-02,   9.2591129E-02
     +,   8.8850655E-02,   8.5207500E-02,   8.1234381E-02
     +,   7.6808929E-02,   7.2044224E-02,   6.7174725E-02
     +,   6.2453039E-02,   5.8080982E-02,   5.4179762E-02
     +,   5.0790831E-02,   4.7895066E-02,   4.5438152E-02
     +,   4.3355267E-02,   4.1587759E-02,   4.0089741E-02
     +,   3.8826477E-02,   3.7767958E-02,   3.6881767E-02
     +,   3.6128141E-02,   3.5459321E-02,   3.4822691E-02
     +,   3.4166291E-02,   3.3444751E-02,   3.2624021E-02
     +,   3.1684030E-02,   3.0618947E-02,   2.9435212E-02
     +,   2.8148523E-02,   2.6780348E-02,   2.5354551E-02
     +,   2.3894615E-02,   2.2421990E-02,   2.0955192E-02
     +,   1.9509492E-02,   1.8096995E-02,   1.6727131E-02
     +,   1.5407238E-02,   1.4142890E-02,   1.2938117E-02
     +,   1.1795785E-02,   1.0717823E-02,   9.7051486E-03
     +,   8.7579004E-03,   7.8756018E-03,   7.0571969E-03
     +,   6.3011241E-03,   5.6054750E-03,   4.9681161E-03
     +,   4.3867012E-03,   3.8586743E-03,   3.3813459E-03
     +,   2.9519389E-03,   2.5675558E-03,   2.2251820E-03
     +,   1.9217370E-03,   1.6541345E-03,   1.4192550E-03
     +,   1.2140268E-03,   1.0354782E-03,   8.8075839E-04
     +,   7.4716646E-04,   6.3219131E-04,   5.3353416E-04
     +,   4.4910863E-04,   3.7703710E-04,   3.1565275E-04
     +,   2.6349066E-04,   2.1926765E-04,   1.8186320E-04
     +,   1.5030563E-04,   1.2375682E-04,   1.0148919E-04
     +,   8.2874649E-05,   6.7371831E-05,   5.4512817E-05
     +,   4.3892629E-05,   3.5161953E-05,   2.8020284E-05
     +,   2.2208917E-05,   1.7505537E-05,   1.3720244E-05
     +,   1.0691660E-05,   8.2830411E-06,   6.3790962E-06
     +,   4.8833831E-06,   3.7158516E-06,   2.8102709E-06
     +,   2.1123676E-06,   1.5780200E-06,   1.1715756E-06
     +,   8.6443004E-07,   6.3383948E-07,   4.6186790E-07
     +,   3.3446094E-07,   2.4068791E-07,   1.7212263E-07
     +,   1.2232051E-07,   8.6385775E-08,   6.0626441E-08
     +,   4.2281780E-08,   2.9303992E-08,   2.0182643E-08
     +,   1.3813480E-08,   9.3952259E-09,   6.3503642E-09
     +,   4.2655208E-09,   2.8472367E-09,   1.8886894E-09
     +,   1.2450599E-09,   8.1565804E-10,   5.3101917E-10
     +,   3.4356065E-10,   2.2090046E-10,   1.4115094E-10
     +,   8.9631476E-11,   5.6564219E-11,   3.5475005E-11
     +,   2.2110409E-11,   1.3695345E-11,   8.4306251E-12
     +,   5.1576451E-12,   3.1357538E-12,   1.8946966E-12
     +,   1.1377666E-12,   6.7901083E-13,   4.0271971E-13
     +,   2.3738289E-13,   1.3905951E-13,   8.0960595E-14
     +,   4.6843927E-14,   2.6937449E-14,   1.5394609E-14
     +,   8.7439126E-15,   4.9357431E-15,   2.7690227E-15
     +,   1.5438693E-15,   8.5550418E-16,   4.7114508E-16
     +,   2.5786918E-16,   1.4027263E-16,   7.5833073E-17
     +,   4.0745067E-17,   2.1757249E-17,   1.1546860E-17
     +,   6.0902748E-18,   3.1925631E-18,   1.6632394E-18
     +,   8.6119443E-19,   4.4316134E-19,   2.2664780E-19
     +,   1.1519994E-19,   5.8194896E-20
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_asha_ttz70_mass = Yx/2.6927313
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_asha_ttz75_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  7.0644946E-06,   8.2431170E-06
     +,   9.5984515E-06,   1.1153286E-05,   1.2932681E-05
     +,   1.4964113E-05,   1.7277585E-05,   1.9905710E-05
     +,   2.2883771E-05,   2.6249925E-05,   3.0045012E-05
     +,   3.4312681E-05,   3.9099348E-05,   4.4454129E-05
     +,   5.0428691E-05,   5.7077134E-05,   6.4455700E-05
     +,   7.2622672E-05,   8.1637889E-05,   9.1562499E-05
     +,   1.0245852E-04,   1.1438833E-04,   1.2741401E-04
     +,   1.4159791E-04,   1.5699955E-04,   1.7367837E-04
     +,   1.9169037E-04,   2.1108899E-04,   2.3192399E-04
     +,   2.5424128E-04,   2.7808215E-04,   3.0348316E-04
     +,   3.3047560E-04,   3.5908571E-04,   3.8933425E-04
     +,   4.2123688E-04,   4.5480451E-04,   4.9004302E-04
     +,   5.2695710E-04,   5.6554453E-04,   6.0580531E-04
     +,   6.4773689E-04,   6.9133809E-04,   7.3661009E-04
     +,   7.8355829E-04,   8.3219347E-04,   8.8253414E-04
     +,   9.3460747E-04,   9.8845107E-04,   1.0441144E-03
     +,   1.1016593E-03,   1.1611618E-03,   1.2227092E-03
     +,   1.2864079E-03,   1.3523692E-03,   1.4207235E-03
     +,   1.4916067E-03,   1.5651641E-03,   1.6415452E-03
     +,   1.7209019E-03,   1.8033829E-03,   1.8891332E-03
     +,   1.9782807E-03,   2.0709473E-03,   2.1672349E-03
     +,   2.2672135E-03,   2.3709398E-03,   2.4784275E-03
     +,   2.5896714E-03,   2.7046201E-03,   2.8232031E-03
     +,   2.9452997E-03,   3.0707775E-03,   3.1994584E-03
     +,   3.3311567E-03,   3.4656699E-03,   3.6027839E-03
     +,   3.7422886E-03,   3.8840040E-03,   4.0277885E-03
     +,   4.1735428E-03,   4.3212725E-03,   4.4710767E-03
     +,   4.6232189E-03,   4.7781365E-03,   4.9365135E-03
     +,   5.0993008E-03,   5.2677998E-03,   5.4436754E-03
     +,   5.6290370E-03,   5.8264602E-03,   6.0389889E-03
     +,   6.2701432E-03,   6.5239086E-03,   6.8046809E-03
     +,   7.1171983E-03,   7.4666031E-03,   7.8584496E-03
     +,   8.2990481E-03,   8.7958593E-03,   9.3583325E-03
     +,   9.9987583E-03,   1.0733432E-02,   1.1583221E-02
     +,   1.2573747E-02,   1.3734139E-02,   1.5094239E-02
     +,   1.6680744E-02,   1.8513426E-02,   2.0603441E-02
     +,   2.2957141E-02,   2.5589084E-02,   2.8543500E-02
     +,   3.1923536E-02,   3.5918768E-02,   4.0826857E-02
     +,   4.7062483E-02,   5.5158179E-02,   6.5738268E-02
     +,   7.9427652E-02,   9.6629053E-02,   0.1171795    
     +,   0.1400838    ,   0.1636737    ,   0.1863973    
     +,   0.2079926    ,   0.2304116    ,   0.2577777    
     +,   0.2945833    ,   0.3418030    ,   0.3939147    
     +,   0.4424489    ,   0.4843657    ,   0.5220613    
     +,   0.5515116    ,   0.5587774    ,   0.5360404    
     +,   0.4942333    ,   0.4547647    ,   0.4342033    
     +,   0.4357197    ,   0.4488287    ,   0.4576415    
     +,   0.4525998    ,   0.4364237    ,   0.4195857    
     +,   0.4089305    ,   0.4009110    ,   0.3871582    
     +,   0.3643065    ,   0.3356672    ,   0.3056127    
     +,   0.2757009    ,   0.2457078    ,   0.2160871    
     +,   0.1886335    ,   0.1653984    ,   0.1475005    
     +,   0.1347941    ,   0.1262052    ,   0.1202212    
     +,   0.1152984    ,   0.1101659    ,   0.1040266    
     +,   9.6620627E-02,   8.8147670E-02,   7.9095431E-02
     +,   7.0048533E-02,   6.1534841E-02,   5.3935885E-02
     +,   4.7456156E-02,   4.2135481E-02,   3.7887435E-02
     +,   3.4548346E-02,   3.1922970E-02,   2.9818662E-02
     +,   2.8067544E-02,   2.6536586E-02,   2.5128966E-02
     +,   2.3780482E-02,   2.2453690E-02,   2.1131257E-02
     +,   1.9809408E-02,   1.8492365E-02,   1.7188257E-02
     +,   1.5906379E-02,   1.4655493E-02,   1.3443079E-02
     +,   1.2275292E-02,   1.1157284E-02,   1.0093201E-02
     +,   9.0865176E-03,   8.1401533E-03,   7.2564096E-03
     +,   6.4368402E-03,   5.6822263E-03,   4.9925549E-03
     +,   4.3669320E-03,   3.8035724E-03,   3.2999197E-03
     +,   2.8527973E-03,   2.4585000E-03,   2.1129369E-03
     +,   1.8118137E-03,   1.5508025E-03,   1.3256051E-03
     +,   1.1320903E-03,   9.6637942E-04,   8.2488003E-04
     +,   7.0431246E-04,   6.0173444E-04,   5.1454245E-04
     +,   4.4045135E-04,   3.7747019E-04,   3.2388480E-04
     +,   2.7823262E-04,   2.3927045E-04,   2.0594605E-04
     +,   1.7737586E-04,   1.5282320E-04,   1.3167148E-04
     +,   1.1340779E-04,   9.7607313E-05,   8.3916428E-05
     +,   7.2039773E-05,   6.1730505E-05,   5.2781765E-05
     +,   4.5018416E-05,   3.8290553E-05,   3.2469332E-05
     +,   2.7443422E-05,   2.3115401E-05,   1.9399227E-05
     +,   1.6218826E-05,   1.3506919E-05,   1.1203284E-05
     +,   9.2543305E-06,   7.6124675E-06,   6.2353697E-06
     +,   5.0854665E-06,   4.1296248E-06,   3.3387951E-06
     +,   2.6875725E-06,   2.1538201E-06,   1.7184100E-06
     +,   1.3649277E-06,   1.0793374E-06,   8.4969423E-07
     +,   6.6591588E-07,   5.1955629E-07,   4.0354965E-07
     +,   3.1203845E-07,   2.4019747E-07,   1.8406891E-07
     +,   1.4042386E-07,   1.0664609E-07,   8.0629974E-08
     +,   6.0687420E-08,   4.5472412E-08,   3.3918766E-08
     +,   2.5187136E-08,   1.8619522E-08,   1.3702653E-08
     +,   1.0038829E-08,   7.3217228E-09,   5.3160543E-09
     +,   3.8424455E-09,   2.7648555E-09,   1.9805619E-09
     +,   1.4123788E-09,   1.0026638E-09,   7.0860823E-10
     +,   4.9855009E-10,   3.4918674E-10,   2.4347147E-10
     +,   1.6900133E-10,   1.1678146E-10,   8.0335773E-11
     +,   5.5015492E-11,   3.7507154E-11,   2.5455592E-11
     +,   1.7199100E-11,   1.1568245E-11,   7.7460928E-12
     +,   5.1634270E-12,   3.4264618E-12,   2.2636042E-12
     +,   1.4886588E-12,   9.7463780E-13,   6.3523075E-13
     +,   4.1216610E-13,   2.6622766E-13,   1.7119356E-13
     +,   1.0958790E-13,   6.9837636E-14,   4.4305393E-14
     +,   2.7981889E-14,   1.7592871E-14,   1.1011585E-14
     +,   6.8612604E-15,   4.2560869E-15
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_asha_ttz75_mass = Yx/3.6201955
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_asha_ttz80_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.1638598E-04,   2.2529408E-04
     +,   2.3415031E-04,   2.4292048E-04,   2.5156938E-04
     +,   2.6006135E-04,   2.6836022E-04,   2.7642981E-04
     +,   2.8423383E-04,   2.9173677E-04,   2.9890347E-04
     +,   3.0569977E-04,   3.1209266E-04,   3.1805070E-04
     +,   3.2354414E-04,   3.2854514E-04,   3.3302809E-04
     +,   3.3696985E-04,   3.4034991E-04,   3.4315043E-04
     +,   3.4535662E-04,   3.4695677E-04,   3.4794243E-04
     +,   3.4830818E-04,   3.4805227E-04,   3.4717590E-04
     +,   3.4568386E-04,   3.4358414E-04,   3.4088787E-04
     +,   3.3760947E-04,   3.3376616E-04,   3.2937824E-04
     +,   3.2446848E-04,   3.1906241E-04,   3.1318760E-04
     +,   3.0687399E-04,   3.0015336E-04,   2.9305936E-04
     +,   2.8562671E-04,   2.7789210E-04,   2.6989295E-04
     +,   2.6166817E-04,   2.5325725E-04,   2.4470122E-04
     +,   2.3604183E-04,   2.2732223E-04,   2.1858710E-04
     +,   2.0988288E-04,   2.0125850E-04,   1.9276592E-04
     +,   1.8446099E-04,   1.7640447E-04,   1.6866336E-04
     +,   1.6131179E-04,   1.5443387E-04,   1.4812403E-04
     +,   1.4249013E-04,   1.3765534E-04,   1.3376039E-04
     +,   1.3096622E-04,   1.2945624E-04,   1.2943901E-04
     +,   1.3115018E-04,   1.3485485E-04,   1.4084925E-04
     +,   1.4946124E-04,   1.6105226E-04,   1.7601490E-04
     +,   1.9477520E-04,   2.1778615E-04,   2.4553036E-04
     +,   2.7850989E-04,   3.1724898E-04,   3.6228038E-04
     +,   4.1414867E-04,   4.7340250E-04,   5.4058683E-04
     +,   6.1624486E-04,   7.0092472E-04,   7.9518440E-04
     +,   8.9959439E-04,   1.0147813E-03,   1.1414308E-03
     +,   1.2803593E-03,   1.4325305E-03,   1.5991520E-03
     +,   1.7817006E-03,   1.9820330E-03,   2.2023993E-03
     +,   2.4455318E-03,   2.7146463E-03,   3.0133964E-03
     +,   3.3458080E-03,   3.7161510E-03,   4.1286931E-03
     +,   4.5873364E-03,   5.0953259E-03,   5.6546652E-03
     +,   6.2657562E-03,   6.9267624E-03,   7.6333359E-03
     +,   8.3781322E-03,   9.1508524E-03,   9.9381544E-03
     +,   1.0724210E-02,   1.1491297E-02,   1.2220726E-02
     +,   1.2894142E-02,   1.3494997E-02,   1.4010081E-02
     +,   1.4431163E-02,   1.4756850E-02,   1.4994317E-02
     +,   1.5161490E-02,   1.5289402E-02,   1.5425167E-02
     +,   1.5635267E-02,   1.6008684E-02,   1.6658556E-02
     +,   1.7720426E-02,   1.9344699E-02,   2.1681763E-02
     +,   2.4861483E-02,   2.8972700E-02,   3.4051012E-02
     +,   4.0083218E-02,   4.7031842E-02,   5.4864541E-02
     +,   6.3574873E-02,   7.3170640E-02,   8.3639212E-02
     +,   9.4909877E-02,   0.1068763    ,   0.1195140    
     +,   0.1330598    ,   0.1480094    ,   0.1646421    
     +,   0.1823561    ,   0.2001195    ,   0.2191239    
     +,   0.2458467    ,   0.2907512    ,   0.3597684    
     +,   0.4447486    ,   0.5279854    ,   0.6022696    
     +,   0.6792761    ,   0.7660648    ,   0.8379607    
     +,   0.8609265    ,   0.8314505    ,   0.7729788    
     +,   0.7163583    ,   0.6828690    ,   0.6684525    
     +,   0.6521310    ,   0.6173171    ,   0.5586424    
     +,   0.4819525    ,   0.4021315    ,   0.3341962    
     +,   0.2837525    ,   0.2484063    ,   0.2235699    
     +,   0.2040943    ,   0.1857955    ,   0.1676643    
     +,   0.1512139    ,   0.1378473    ,   0.1274028    
     +,   0.1186245    ,   0.1102949    ,   0.1018821    
     +,   9.3481421E-02,   8.5410886E-02,   7.7868849E-02
     +,   7.0836447E-02,   6.4172462E-02,   5.7758186E-02
     +,   5.1585555E-02,   4.5757990E-02,   4.0431347E-02
     +,   3.5741255E-02,   3.1753134E-02,   2.8447976E-02
     +,   2.5737090E-02,   2.3491131E-02,   2.1570923E-02
     +,   1.9851560E-02,   1.8236591E-02,   1.6662627E-02
     +,   1.5097856E-02,   1.3536442E-02,   1.1991014E-02
     +,   1.0484912E-02,   9.0455916E-03,   7.6994225E-03
     +,   6.4679636E-03,   5.3658709E-03,   4.4003674E-03
     +,   3.5717008E-03,   2.8741707E-03,   2.2975679E-03
     +,   1.8288007E-03,   1.4533798E-03,   1.1565431E-03
     +,   9.2423538E-04,   7.4373354E-04,   6.0397113E-04
     +,   4.9565762E-04,   4.1125086E-04,   3.4480687E-04
     +,   2.9175938E-04,   2.4868367E-04,   2.1307073E-04
     +,   1.8311938E-04,   1.5755421E-04,   1.3547925E-04
     +,   1.1626623E-04,   9.9470853E-05,   8.4767147E-05
     +,   7.1906616E-05,   6.0690214E-05,   5.0948649E-05
     +,   4.2530944E-05,   3.5298817E-05,   2.9124001E-05
     +,   2.3886163E-05,   1.9472469E-05,   1.5778171E-05
     +,   1.2707098E-05,   1.0171553E-05,   8.0922982E-06
     +,   6.3987382E-06,   5.0287485E-06,   3.9279330E-06
     +,   3.0493186E-06,   2.3527675E-06,   1.8042500E-06
     +,   1.3751546E-06,   1.0416932E-06,   7.8426956E-07
     +,   5.8685652E-07,   4.3645156E-07,   3.2260633E-07
     +,   2.3699910E-07,   1.7304625E-07,   1.2557834E-07
     +,   9.0573330E-08,   6.4927313E-08,   4.6258521E-08
     +,   3.2755846E-08,   2.3052751E-08,   1.6124952E-08
     +,   1.1210162E-08,   7.7456370E-09,   5.3191189E-09
     +,   3.6304801E-09,   2.4627853E-09,   1.6604281E-09
     +,   1.1126313E-09,   7.4101109E-10,   4.9049637E-10
     +,   3.2268438E-10,   2.1099085E-10,   1.3711510E-10
     +,   8.8560340E-11,   5.6849893E-11,   3.6271403E-11
     +,   2.3000428E-11,   1.4495650E-11,   9.0798185E-12
     +,   5.6527547E-12,   3.4976854E-12,   2.1509522E-12
     +,   1.3146977E-12,   7.9863893E-13,   4.8219127E-13
     +,   2.8934662E-13,   1.7256860E-13,   1.0229052E-13
     +,   6.0263365E-14,   3.5285922E-14,   2.0534923E-14
     +,   1.1877225E-14,   6.8278182E-15,   3.9010882E-15
     +,   2.2152311E-15,   1.2502514E-15,   7.0130215E-16
     +,   3.9098239E-16,   2.1664003E-16,   1.1930705E-16
     +,   6.5301469E-17,   3.5524178E-17,   1.9206745E-17
     +,   1.0321182E-17,   5.5123109E-18,   2.9260811E-18
     +,   1.5437079E-18,   8.0944969E-19
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_asha_ttz80_mass = Yx/4.087784
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_asha_ttz85_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  5.0158142E-11,   7.1621306E-11
     +,   1.0200935E-10,   1.4491269E-10,   2.0531117E-10
     +,   2.9008745E-10,   4.0871997E-10,   5.7421390E-10
     +,   8.0434093E-10,   1.1233138E-09,   1.5639582E-09
     +,   2.1706206E-09,   3.0029623E-09,   4.1409156E-09
     +,   5.6911169E-09,   7.7952231E-09,   1.0640560E-08
     +,   1.4473831E-08,   1.9618373E-08,   2.6496116E-08
     +,   3.5655045E-08,   4.7803631E-08,   6.3853051E-08
     +,   8.4971319E-08,   1.1264433E-07,   1.4875903E-07
     +,   1.9569445E-07,   2.5643746E-07,   3.3471898E-07
     +,   4.3517409E-07,   5.6353252E-07,   7.2683957E-07
     +,   9.3370954E-07,   1.1946216E-06,   1.5222515E-06
     +,   1.9318459E-06,   2.4416415E-06,   3.0733124E-06
     +,   3.8525295E-06,   4.8093739E-06,   5.9790796E-06
     +,   7.4024802E-06,   9.1267038E-06,   1.1205751E-05
     +,   1.3701097E-05,   1.6682257E-05,   2.0227260E-05
     +,   2.4423085E-05,   2.9365936E-05,   3.5161389E-05
     +,   4.1924370E-05,   4.9778890E-05,   5.8857364E-05
     +,   6.9300702E-05,   8.1255268E-05,   9.4874064E-05
     +,   1.1031279E-04,   1.2772871E-04,   1.4727804E-04
     +,   1.6911297E-04,   1.9337871E-04,   2.2021031E-04
     +,   2.4972696E-04,   2.8203207E-04,   3.1720762E-04
     +,   3.5530672E-04,   3.9635823E-04,   4.4035312E-04
     +,   4.8725287E-04,   5.3697568E-04,   5.8940687E-04
     +,   6.4438599E-04,   7.0172071E-04,   7.6117500E-04
     +,   8.2248490E-04,   8.8535913E-04,   9.4948144E-04
     +,   1.0145246E-03,   1.0801653E-03,   1.1460949E-03
     +,   1.2120282E-03,   1.2777388E-03,   1.3430604E-03
     +,   1.4079291E-03,   1.4723883E-03,   1.5366317E-03
     +,   1.6010089E-03,   1.6660645E-03,   1.7325389E-03
     +,   1.8013953E-03,   1.8738171E-03,   1.9511961E-03
     +,   2.0351175E-03,   2.1273314E-03,   2.2296992E-03
     +,   2.3441140E-03,   2.4724447E-03,   2.6164073E-03
     +,   2.7774938E-03,   2.9568209E-03,   3.1550631E-03
     +,   3.3723039E-03,   3.6080068E-03,   3.8609030E-03
     +,   4.1290261E-03,   4.4097146E-03,   4.6996675E-03
     +,   4.9950778E-03,   5.2918298E-03,   5.5856877E-03
     +,   5.8725048E-03,   6.1485604E-03,   6.4107412E-03
     +,   6.6568721E-03,   6.8858773E-03,   7.0980587E-03
     +,   7.2952295E-03,   7.4809832E-03,   7.6608961E-03
     +,   7.8429459E-03,   8.0379900E-03,   8.2604308E-03
     +,   8.5289991E-03,   8.8675125E-03,   9.3052844E-03
     +,   9.8767290E-03,   1.0619926E-02,   1.1573246E-02
     +,   1.2770445E-02,   1.4233714E-02,   1.5966533E-02
     +,   1.7946690E-02,   2.0123143E-02,   2.2417251E-02
     +,   2.4732292E-02,   2.6969930E-02,   2.9053075E-02
     +,   3.0950889E-02,   3.2699626E-02,   3.4413863E-02
     +,   3.6288772E-02,   3.8606394E-02,   4.1769635E-02
     +,   4.6379272E-02,   5.3312667E-02,   6.3662484E-02
     +,   7.8350581E-02,   9.7473547E-02,   0.1200029    
     +,   0.1446760    ,   0.1717263    ,   0.2035537    
     +,   0.2440204    ,   0.2990173    ,   0.3764157    
     +,   0.4756569    ,   0.5729653    ,   0.6427062    
     +,   0.7043028    ,   0.7937692    ,   0.8979326    
     +,    1.006156    ,    1.142333    ,    1.235647    
     +,    1.205323    ,    1.080116    ,   0.9228588    
     +,   0.7790500    ,   0.6662518    ,   0.5943179    
     +,   0.5355242    ,   0.4592797    ,   0.3733313    
     +,   0.3003182    ,   0.2470581    ,   0.2099406    
     +,   0.1857598    ,   0.1715646    ,   0.1628150    
     +,   0.1543358    ,   0.1425051    ,   0.1265230    
     +,   0.1079293    ,   8.9125983E-02,   7.2107077E-02
     +,   5.7946842E-02,   4.6885535E-02,   3.8631558E-02
     +,   3.2637585E-02,   2.8287757E-02,   2.5013553E-02
     +,   2.2360707E-02,   2.0014120E-02,   1.7790807E-02
     +,   1.5613862E-02,   1.3479318E-02,   1.1424003E-02
     +,   9.4990674E-03,   7.7514653E-03,   6.2137516E-03
     +,   4.9005183E-03,   3.8093785E-03,   2.9247254E-03
     +,   2.2226311E-03,   1.6754052E-03,   1.2550501E-03
     +,   9.3575323E-04,   6.9519825E-04,   5.1496841E-04
     +,   3.8040016E-04,   2.8014128E-04,   2.0556645E-04
     +,   1.5019049E-04,   1.0916143E-04,   7.8857105E-05
     +,   5.6569508E-05,   4.0266044E-05,   2.8416516E-05
     +,   1.9868457E-05,   1.3754506E-05,   9.4221305E-06
     +,   6.3831540E-06,   4.2745964E-06,   2.8284212E-06
     +,   1.8484477E-06,   1.1926983E-06,   7.5961213E-07
     +,   4.7740701E-07,   2.9602137E-07,   1.8105531E-07
     +,   1.0921861E-07,   6.4973385E-08,   3.8113615E-08
     +,   2.2043963E-08,   1.2570542E-08,   7.0671589E-09
     +,   3.9168606E-09,   2.1400854E-09,   1.1527164E-09
     +,   6.1206573E-10,   3.2036282E-10,   1.6529557E-10
     +,   8.4073901E-11,   4.2153336E-11,   2.0833411E-11
     +,   1.0149770E-11,   4.8744936E-12,   2.3076445E-12
     +,   1.0768704E-12,   4.9537430E-13,   2.2463151E-13
     +,   1.0040627E-13,   4.4240206E-14,   1.9215412E-14
     +,   8.2271370E-15,   3.4721776E-15,   1.4445073E-15
     +,   5.9240362E-16,   2.3948798E-16,   9.5434898E-17
     +,   3.7488897E-17,   1.4517409E-17,   5.5419443E-18
     +,   2.0855554E-18,   7.7377928E-19,   2.8305916E-19
     +,   1.0210754E-19,   3.6332681E-20,   1.2759278E-20
     +,   4.4261086E-21,   1.5190014E-21,   5.1723234E-22
     +,   1.7562658E-22,   5.9975271E-23,   2.0884709E-23
     +,   7.5667286E-24,   2.9215487E-24,   1.2264682E-24
     +,   5.6299997E-25,   2.7935524E-25,   1.4664547E-25
     +,   7.9734005E-26,   4.4196585E-26,   2.4726252E-26
     +,   1.3880760E-26,   7.7944835E-27,   4.3706449E-27
     +,   2.4451504E-27,   1.3642345E-27,   7.5890807E-28
     +,   4.2089528E-28,   2.3270422E-28,   1.2825771E-28
     +,   7.0468212E-29,   3.8596154E-29,   2.1072758E-29
     +,   1.1469322E-29,   6.2226853E-30,   3.3655788E-30
     +,   1.8145260E-30,   9.7522472E-31
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_asha_ttz85_mass = Yx/4.42589162790698
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_asha_ttz90_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.1923453E-04,   3.2783582E-04
     +,   3.3592290E-04,   3.4344706E-04,   3.5036216E-04
     +,   3.5662521E-04,   3.6219688E-04,   3.6704208E-04
     +,   3.7112980E-04,   3.7443425E-04,   3.7693448E-04
     +,   3.7861479E-04,   3.7946529E-04,   3.7948159E-04
     +,   3.7866531E-04,   3.7702351E-04,   3.7456932E-04
     +,   3.7132145E-04,   3.6730411E-04,   3.6254677E-04
     +,   3.5708395E-04,   3.5095518E-04,   3.4420440E-04
     +,   3.3687893E-04,   3.2903100E-04,   3.2071499E-04
     +,   3.1198878E-04,   3.0291238E-04,   2.9354793E-04
     +,   2.8395909E-04,   2.7421073E-04,   2.6436837E-04
     +,   2.5449815E-04,   2.4466618E-04,   2.3493836E-04
     +,   2.2538024E-04,   2.1605669E-04,   2.0703196E-04
     +,   1.9836861E-04,   1.9012942E-04,   1.8237492E-04
     +,   1.7516533E-04,   1.6855961E-04,   1.6261579E-04
     +,   1.5739122E-04,   1.5294229E-04,   1.4932512E-04
     +,   1.4659512E-04,   1.4480767E-04,   1.4401789E-04
     +,   1.4428096E-04,   1.4565211E-04,   1.4818677E-04
     +,   1.5194069E-04,   1.5696947E-04,   1.6332923E-04
     +,   1.7107584E-04,   1.8026501E-04,   1.9095201E-04
     +,   2.0319130E-04,   2.1703621E-04,   2.3253875E-04
     +,   2.4974771E-04,   2.6871069E-04,   2.8947223E-04
     +,   3.1207115E-04,   3.3654479E-04,   3.6292284E-04
     +,   3.9123275E-04,   4.2149308E-04,   4.5372013E-04
     +,   4.8792010E-04,   5.2409747E-04,   5.6224619E-04
     +,   6.0235808E-04,   6.4442033E-04,   6.8841269E-04
     +,   7.3431153E-04,   7.8209332E-04,   8.3173369E-04
     +,   8.8320323E-04,   9.3647983E-04,   9.9153747E-04
     +,   1.0483605E-03,   1.1069302E-03,   1.1672414E-03
     +,   1.2292861E-03,   1.2930708E-03,   1.3585995E-03
     +,   1.4258871E-03,   1.4949542E-03,   1.5658197E-03
     +,   1.6385042E-03,   1.7130352E-03,   1.7894399E-03
     +,   1.8677410E-03,   1.9479725E-03,   2.0301654E-03
     +,   2.1143740E-03,   2.2006638E-03,   2.2891476E-03
     +,   2.3799825E-03,   2.4734156E-03,   2.5697905E-03
     +,   2.6696019E-03,   2.7735303E-03,   2.8824727E-03
     +,   2.9975921E-03,   3.1203635E-03,   3.2525947E-03
     +,   3.3964238E-03,   3.5543421E-03,   3.7291148E-03
     +,   3.9237537E-03,   4.1413549E-03,   4.3850029E-03
     +,   4.6575340E-03,   4.9613961E-03,   5.2983612E-03
     +,   5.6694034E-03,   6.0745003E-03,   6.5125274E-03
     +,   6.9812597E-03,   7.4775177E-03,   7.9973647E-03
     +,   8.5364087E-03,   9.0903873E-03,   9.6555790E-03
     +,   1.0229578E-02,   1.0811741E-02,   1.1403925E-02
     +,   1.2010765E-02,   1.2640078E-02,   1.3302661E-02
     +,   1.4012005E-02,   1.4783378E-02,   1.5632413E-02
     +,   1.6573297E-02,   1.7616596E-02,   1.8766807E-02
     +,   2.0019900E-02,   2.1361753E-02,   2.2767797E-02
     +,   2.4204738E-02,   2.5635403E-02,   2.7028177E-02
     +,   2.8370634E-02,   2.9686932E-02,   3.1056132E-02
     +,   3.2626264E-02,   3.4617640E-02,   3.7309770E-02
     +,   4.1010220E-02,   4.6010245E-02,   5.2540071E-02
     +,   6.0741682E-02,   7.0666932E-02,   8.2286239E-02
     +,   9.5498927E-02,   0.1102115    ,   0.1265898    
     +,   0.1454010    ,   0.1680949    ,   0.1962275    
     +,   0.2301399    ,   0.2687240    ,   0.3151176    
     +,   0.3867539    ,   0.5116568    ,   0.7041159    
     +,   0.9420635    ,    1.149157    ,    1.258316    
     +,    1.307630    ,    1.328874    ,    1.294973    
     +,    1.178071    ,    1.000704    ,   0.8090490    
     +,   0.6319234    ,   0.5092634    ,   0.4354165    
     +,   0.3699763    ,   0.3033372    ,   0.2516770    
     +,   0.2222654    ,   0.2057154    ,   0.1901611    
     +,   0.1707250    ,   0.1482942    ,   0.1252690    
     +,   0.1033133    ,   8.3225317E-02,   6.5417178E-02
     +,   5.0131246E-02,   3.7427403E-02,   2.7187377E-02
     +,   1.9181365E-02,   1.3128559E-02,   8.7231835E-03
     +,   5.6463038E-03,   3.5841595E-03,   2.2528479E-03
     +,   1.4182285E-03,   9.0375706E-04,   5.8678305E-04
     +,   3.8824993E-04,   2.6029808E-04,   1.7523830E-04
     +,   1.1735404E-04,   7.7563243E-05,   5.0304934E-05
     +,   3.1893327E-05,   1.9718320E-05,   1.1870926E-05
     +,   6.9532202E-06,   3.9607362E-06,   2.1934777E-06
     +,   1.1808328E-06,   6.1791212E-07,   3.1428402E-07
     +,   1.5536672E-07,   7.4651467E-08,   3.4863625E-08
     +,   1.5825234E-08,   6.9816899E-09,   2.9937499E-09
     +,   1.2477657E-09,   5.0548382E-10,   1.9903969E-10
     +,   7.6185593E-11,   2.8351980E-11,   1.0260934E-11
     +,   3.6137187E-12,   1.2403334E-12,   4.1622508E-13
     +,   1.3754930E-13,   4.5488410E-14,   1.5558044E-14
     +,   5.8217968E-15,   2.5419444E-15,   1.3273702E-15
     +,   7.9807021E-16,   5.2011248E-16,   3.5166280E-16
     +,   2.4114795E-16,   1.6605403E-16,   1.1436053E-16
     +,   7.8648511E-17,   5.3982601E-17,   3.6971618E-17
     +,   2.5263585E-17,   1.7223593E-17,   1.1715357E-17
     +,   7.9502140E-18,   5.3825176E-18,   3.6356275E-18
     +,   2.4499853E-18,   1.6471341E-18,   1.1047667E-18
     +,   7.3925080E-19,   4.9350609E-19,   3.2867851E-19
     +,   2.1838295E-19,   1.4475835E-19,   9.5728914E-20
     +,   6.3154807E-20,   4.1566249E-20,   2.7292963E-20
     +,   1.7878462E-20,   1.1683475E-20,   7.6169133E-21
     +,   4.9540513E-21,   3.2144707E-21,   2.0807446E-21
     +,   1.3436914E-21,   8.6564512E-22,   5.5635388E-22
     +,   3.5671354E-22,   2.2817078E-22,   1.4559973E-22
     +,   9.2688866E-23,   5.8864826E-23,   3.7295116E-23
     +,   2.3572506E-23,   1.4863817E-23,   9.3500843E-24
     +,   5.8675896E-24,   3.6734381E-24,   2.2942605E-24
     +,   1.4294906E-24,   8.8853969E-25,   5.5098626E-25
     +,   3.4084998E-25,   2.1035472E-25,   1.2950844E-25
     +,   7.9544833E-26,   4.8739663E-26,   2.9793591E-26
     +,   1.8168456E-26,   1.1053115E-26
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_asha_ttz90_mass = Yx/4.33172372093023
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_asha_ttz95_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  7.2869254E-05,   7.9603706E-05
     +,   8.6826003E-05,   9.4559568E-05,   1.0282822E-04
     +,   1.1165602E-04,   1.2106727E-04,   1.3108656E-04
     +,   1.4173823E-04,   1.5304734E-04,   1.6503832E-04
     +,   1.7773554E-04,   1.9116305E-04,   2.0534436E-04
     +,   2.2030222E-04,   2.3605843E-04,   2.5263347E-04
     +,   2.7004629E-04,   2.8831369E-04,   3.0745022E-04
     +,   3.2746748E-04,   3.4837367E-04,   3.7017275E-04
     +,   3.9286571E-04,   4.1644566E-04,   4.4090269E-04
     +,   4.6621909E-04,   4.9237040E-04,   5.1932456E-04
     +,   5.4704124E-04,   5.7547161E-04,   6.0455734E-04
     +,   6.3423073E-04,   6.6441396E-04,   6.9501938E-04
     +,   7.2594918E-04,   7.5709570E-04,   7.8834093E-04
     +,   8.1956002E-04,   8.5061614E-04,   8.8136812E-04
     +,   9.1166637E-04,   9.4135670E-04,   9.7028108E-04
     +,   9.9827966E-04,   1.0251917E-03,   1.0508590E-03
     +,   1.0751263E-03,   1.0978451E-03,   1.1188752E-03
     +,   1.1380863E-03,   1.1553621E-03,   1.1706003E-03
     +,   1.1837173E-03,   1.1946482E-03,   1.2033500E-03
     +,   1.2098028E-03,   1.2140119E-03,   1.2160081E-03
     +,   1.2158500E-03,   1.2136244E-03,   1.2094455E-03
     +,   1.2034570E-03,   1.1958305E-03,   1.1867653E-03
     +,   1.1764881E-03,   1.1652504E-03,   1.1533289E-03
     +,   1.1410217E-03,   1.1286475E-03,   1.1165414E-03
     +,   1.1050557E-03,   1.0945518E-03,   1.0854022E-03
     +,   1.0779828E-03,   1.0726724E-03,   1.0698477E-03
     +,   1.0698787E-03,   1.0731266E-03,   1.0799390E-03
     +,   1.0906449E-03,   1.1055539E-03,   1.1249484E-03
     +,   1.1490843E-03,   1.1781825E-03,   1.2124331E-03
     +,   1.2519828E-03,   1.2969436E-03,   1.3473791E-03
     +,   1.4033125E-03,   1.4647230E-03,   1.5315394E-03
     +,   1.6036429E-03,   1.6808743E-03,   1.7630284E-03
     +,   1.8498487E-03,   1.9410468E-03,   2.0362833E-03
     +,   2.1351918E-03,   2.2373600E-03,   2.3423559E-03
     +,   2.4497057E-03,   2.5589243E-03,   2.6694920E-03
     +,   2.7808817E-03,   2.8925508E-03,   3.0039412E-03
     +,   3.1144882E-03,   3.2236311E-03,   3.3308109E-03
     +,   3.4354655E-03,   3.5370588E-03,   3.6350572E-03
     +,   3.7289681E-03,   3.8183196E-03,   3.9026944E-03
     +,   3.9817258E-03,   4.0551280E-03,   4.1227005E-03
     +,   4.1843615E-03,   4.2401748E-03,   4.2903614E-03
     +,   4.3353480E-03,   4.3757958E-03,   4.4126282E-03
     +,   4.4470602E-03,   4.4806283E-03,   4.5152013E-03
     +,   4.5529865E-03,   4.5965123E-03,   4.6486105E-03
     +,   4.7123474E-03,   4.7909673E-03,   4.8877955E-03
     +,   5.0061424E-03,   5.1492187E-03,   5.3200372E-03
     +,   5.5213734E-03,   5.7558077E-03,   6.0258023E-03
     +,   6.3338690E-03,   6.6828383E-03,   7.0762299E-03
     +,   7.5185806E-03,   8.0157332E-03,   8.5751088E-03
     +,   9.2056897E-03,   9.9177016E-03,   1.0722074E-02
     +,   1.1629633E-02,   1.2649965E-02,   1.3790128E-02
     +,   1.5053604E-02,   1.6439525E-02,   1.7942294E-02
     +,   1.9551791E-02,   2.1254631E-02,   2.3036232E-02
     +,   2.4883194E-02,   2.6785703E-02,   2.8740032E-02
     +,   3.0750051E-02,   3.2829769E-02,   3.5011027E-02
     +,   3.7363961E-02,   4.0042214E-02,   4.3366693E-02
     +,   4.7946118E-02,   5.4780152E-02,   6.5212309E-02
     +,   8.0599040E-02,   0.1017809    ,   0.1287036    
     +,   0.1603142    ,   0.1946115    ,   0.2301270    
     +,   0.2705742    ,   0.3266678    ,   0.4041612    
     +,   0.4945330    ,   0.5956393    ,   0.7322975    
     +,   0.9523199    ,    1.230233    ,    1.407778    
     +,    1.416102    ,    1.320454    ,    1.173929    
     +,   0.9808165    ,   0.7771056    ,   0.6206952    
     +,   0.4946103    ,   0.3649105    ,   0.2443917    
     +,   0.1559713    ,   9.9026926E-02,   6.1747190E-02
     +,   3.6870401E-02,   2.1308543E-02,   1.2503345E-02
     +,   7.9024248E-03,   5.5542290E-03,   4.2821616E-03
     +,   3.4875951E-03,   2.9028235E-03,   2.4208617E-03
     +,   2.0035785E-03,   1.6388000E-03,   1.3224132E-03
     +,   1.0517649E-03,   8.2378153E-04,   6.3478167E-04
     +,   4.8070235E-04,   3.5733034E-04,   2.6046144E-04
     +,   1.8599990E-04,   1.3003984E-04,   8.8961460E-05
     +,   5.9528171E-05,   3.8953112E-05,   2.4922185E-05
     +,   1.5588565E-05,   9.5320029E-06,   5.6979147E-06
     +,   3.3295848E-06,   1.9019531E-06,   1.0620820E-06
     +,   5.7980833E-07,   3.0944821E-07,   1.6146807E-07
     +,   8.2381938E-08,   4.1105739E-08,   2.0063181E-08
     +,   9.5828776E-09,   4.4824420E-09,   2.0556821E-09
     +,   9.2612479E-10,   4.1126916E-10,   1.8104250E-10
     +,   7.9724762E-11,   3.5615403E-11,   1.6453533E-11
     +,   8.0321843E-12,   4.2135592E-12,   2.3849588E-12
     +,   1.4418410E-12,   9.1436169E-13,   5.9742819E-13
     +,   3.9674525E-13,   2.6545297E-13,   1.7801743E-13
     +,   1.1931318E-13,   7.9802498E-14,   5.3225199E-14
     +,   3.5384771E-14,   2.3443676E-14,   1.5477935E-14
     +,   1.0182779E-14,   6.6753040E-15,   4.3603325E-15
     +,   2.8380176E-15,   1.8406223E-15,   1.1894915E-15
     +,   7.6595035E-16,   4.9146736E-16,   3.1422355E-16
     +,   2.0018320E-16,   1.2707694E-16,   8.0383334E-17
     +,   5.0666232E-17,   3.1821453E-17,   1.9914944E-17
     +,   1.2419449E-17,   7.7176663E-18,   4.7788610E-18
     +,   2.9487326E-18,   1.8130337E-18,   1.1108403E-18
     +,   6.7820688E-19,   4.1262677E-19,   2.5016276E-19
     +,   1.5113965E-19,   9.0994268E-20,   5.4594347E-20
     +,   3.2641843E-20,   1.9449600E-20,   1.1549301E-20
     +,   6.8345588E-21,   4.0308592E-21,   2.3692517E-21
     +,   1.3879514E-21,   8.1037487E-22,   4.7159761E-22
     +,   2.7354556E-22,   1.5815685E-22,   9.1148921E-23
     +,   5.2366250E-23,   2.9991024E-23,   1.7124174E-23
     +,   9.7480504E-24,   5.5329114E-24
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_asha_ttz95_mass = Yx/3.750349
      RETURN
      END
C 
C---- New file --- 
C 
      DOUBLE PRECISION FUNCTION A192_tt_ashz_hatt100_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  8.4305005E-03,   8.9168018E-03
     +,   9.4240624E-03,   9.9528693E-03,   1.0503757E-02
     +,   1.1077221E-02,   1.1673686E-02,   1.2293492E-02
     +,   1.2936854E-02,   1.3603926E-02,   1.4294667E-02
     +,   1.5008915E-02,   1.5746340E-02,   1.6506463E-02
     +,   1.7288676E-02,   1.8092232E-02,   1.8916240E-02
     +,   1.9759817E-02,   2.0622058E-02,   2.1502109E-02
     +,   2.2399306E-02,   2.3313237E-02,   2.4243869E-02
     +,   2.5191732E-02,   2.6157888E-02,   2.7144285E-02
     +,   2.8153723E-02,   2.9189929E-02,   3.0257748E-02
     +,   3.1363074E-02,   3.2512821E-02,   3.3714842E-02
     +,   3.4977768E-02,   3.6310654E-02,   3.7722822E-02
     +,   3.9223138E-02,   4.0819872E-02,   4.2519856E-02
     +,   4.4328194E-02,   4.6247400E-02,   4.8277121E-02
     +,   5.0413597E-02,   5.2649409E-02,   5.4973196E-02
     +,   5.7369843E-02,   5.9820637E-02,   6.2303677E-02
     +,   6.4794607E-02,   6.7267671E-02,   6.9696255E-02
     +,   7.2054766E-02,   7.4319124E-02,   7.6468647E-02
     +,   7.8486905E-02,   8.0362447E-02,   8.2090370E-02
     +,   8.3671950E-02,   8.5115269E-02,   8.6434804E-02
     +,   8.7650947E-02,   8.8788591E-02,   8.9875922E-02
     +,   9.0942696E-02,   9.2018083E-02,   9.3129031E-02
     +,   9.4297782E-02,   9.5540591E-02,   9.6865967E-02
     +,   9.8274209E-02,   9.9756673E-02,   0.1012966    
     +,   0.1028698    ,   0.1044472    ,   0.1059965    
     +,   0.1074853    ,   0.1088842    ,   0.1101695    
     +,   0.1113261    ,   0.1123494    ,   0.1132468    
     +,   0.1140375    ,   0.1147526    ,   0.1154324    
     +,   0.1161248    ,   0.1168805    ,   0.1177502    
     +,   0.1187810    ,   0.1200108    ,   0.1214666    
     +,   0.1231621    ,   0.1250958    ,   0.1272509    
     +,   0.1295973    ,   0.1320919    ,   0.1346838    
     +,   0.1373153    ,   0.1399274    ,   0.1424631    
     +,   0.1448709    ,   0.1471076    ,   0.1491416    
     +,   0.1509541    ,   0.1525418    ,   0.1539162    
     +,   0.1551042    ,   0.1561480    ,   0.1571021    
     +,   0.1580316    ,   0.1590092    ,   0.1601103    
     +,   0.1614094    ,   0.1629758    ,   0.1648685    
     +,   0.1671335    ,   0.1697994    ,   0.1728768    
     +,   0.1763544    ,   0.1801999    ,   0.1843584    
     +,   0.1887531    ,   0.1932880    ,   0.1978491    
     +,   0.2023117    ,   0.2065455    ,   0.2104266    
     +,   0.2138436    ,   0.2167117    ,   0.2189789    
     +,   0.2206347    ,   0.2217122    ,   0.2222864    
     +,   0.2224685    ,   0.2223948    ,   0.2222117    
     +,   0.2220591    ,   0.2220537    ,   0.2222742    
     +,   0.2227527    ,   0.2234739    ,   0.2243804    
     +,   0.2253876    ,   0.2264021    ,   0.2273437    
     +,   0.2281607    ,   0.2288429    ,   0.2294234    
     +,   0.2299725    ,   0.2305823    ,   0.2313492    
     +,   0.2323523    ,   0.2336359    ,   0.2351979    
     +,   0.2369823    ,   0.2388797    ,   0.2407346    
     +,   0.2423533    ,   0.2435197    ,   0.2440088    
     +,   0.2436047    ,   0.2421182    ,   0.2394027    
     +,   0.2353744    ,   0.2300240    ,   0.2234267    
     +,   0.2157448    ,   0.2072220    ,   0.1981720    
     +,   0.1889558    ,   0.1799579    ,   0.1715573    
     +,   0.1641035    ,   0.1578923    ,   0.1531496    
     +,   0.1500234    ,   0.1485839    ,   0.1488278    
     +,   0.1506912    ,   0.1540641    ,   0.1588043    
     +,   0.1647507    ,   0.1717321    ,   0.1795698    
     +,   0.1880774    ,   0.1970563    ,   0.2062906    
     +,   0.2155426    ,   0.2245542    ,   0.2330553    
     +,   0.2407754    ,   0.2474584    ,   0.2528834    
     +,   0.2568772    ,   0.2593241    ,   0.2601686    
     +,   0.2594099    ,   0.2570915    ,   0.2532884    
     +,   0.2480949    ,   0.2416135    ,   0.2339503    
     +,   0.2252144    ,   0.2155194    ,   0.2049866    
     +,   0.1937492    ,   0.1819548    ,   0.1697628    
     +,   0.1573422    ,   0.1448654    ,   0.1325021    
     +,   0.1204107    ,   0.1087327    ,   9.7589038E-02
     +,   8.7076180E-02,   7.7264413E-02,   6.8199076E-02
     +,   5.9903100E-02,   5.2378818E-02,   4.5610808E-02
     +,   3.9569646E-02,   3.4215812E-02,   2.9501604E-02
     +,   2.5374655E-02,   2.1780543E-02,   1.8664533E-02
     +,   1.5973194E-02,   1.3655839E-02,   1.1665543E-02
     +,   9.9595068E-03,   8.4991753E-03,   7.2504035E-03
     +,   6.1833328E-03,   5.2719763E-03,   4.4938279E-03
     +,   3.8295467E-03,   3.2626123E-03,   2.7788347E-03
     +,   2.3660958E-03,   2.0140717E-03,   1.7139377E-03
     +,   1.4581329E-03,   1.2401964E-03,   1.0546150E-03
     +,   8.9666457E-04,   7.6228956E-04,   6.4801716E-04
     +,   5.5087957E-04,   4.6833322E-04,   3.9819564E-04
     +,   3.3860188E-04,   2.8796488E-04,   2.4492620E-04
     +,   2.0833057E-04,   1.7719895E-04,   1.5070081E-04
     +,   1.2813151E-04,   1.0889571E-04,   9.2492024E-05
     +,   7.8496989E-05,   6.6552384E-05,   5.6355882E-05
     +,   4.7652535E-05,   4.0226318E-05,   3.3893422E-05
     +,   2.8497549E-05,   2.3905810E-05,   2.0004063E-05
     +,   1.6694406E-05,   1.3892862E-05,   1.1526998E-05
     +,   9.5341056E-06,   7.8600297E-06,   6.4580395E-06
     +,   5.2876931E-06,   4.3139639E-06,   3.5066460E-06
     +,   2.8397806E-06,   2.2909735E-06,   1.8411008E-06
     +,   1.4737659E-06,   1.1750557E-06,   9.3313332E-07
     +,   7.3803176E-07,   5.8134253E-07,   4.5604781E-07
     +,   3.5628062E-07,   2.7718912E-07,   2.1475891E-07
     +,   1.6569412E-07,   1.2730484E-07,   9.7398804E-08
     +,   7.4205374E-08,   5.6296315E-08,   4.2529678E-08
     +,   3.1993469E-08,   2.3965862E-08,   1.7876314E-08
     +,   1.3277704E-08,   9.8201518E-09,   7.2322131E-09
     +,   5.3036215E-09,   3.8728447E-09
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_ashz_hatt100_mass = Yx/7.04652306521739
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_ashz_hatt105_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  7.9125678E-03,   8.4355613E-03
     +,   8.9857336E-03,   9.5636528E-03,   1.0169807E-02
     +,   1.0804592E-02,   1.1468324E-02,   1.2161251E-02
     +,   1.2883531E-02,   1.3635350E-02,   1.4416797E-02
     +,   1.5228022E-02,   1.6069185E-02,   1.6940519E-02
     +,   1.7842349E-02,   1.8775083E-02,   1.9739248E-02
     +,   2.0735489E-02,   2.1764502E-02,   2.2827022E-02
     +,   2.3923799E-02,   2.5055425E-02,   2.6222311E-02
     +,   2.7424600E-02,   2.8661884E-02,   2.9933315E-02
     +,   3.1237297E-02,   3.2571398E-02,   3.3932380E-02
     +,   3.5315961E-02,   3.6716972E-02,   3.8129251E-02
     +,   3.9545786E-02,   4.0958751E-02,   4.2359814E-02
     +,   4.3740209E-02,   4.5091018E-02,   4.6403442E-02
     +,   4.7669113E-02,   4.8880205E-02,   5.0029863E-02
     +,   5.1112249E-02,   5.2122731E-02,   5.3057995E-02
     +,   5.3916056E-02,   5.4696087E-02,   5.5398617E-02
     +,   5.6024972E-02,   5.6577355E-02,   5.7058644E-02
     +,   5.7471812E-02,   5.7820335E-02,   5.8107369E-02
     +,   5.8336101E-02,   5.8509618E-02,   5.8630846E-02
     +,   5.8702789E-02,   5.8728691E-02,   5.8712415E-02
     +,   5.8658578E-02,   5.8573205E-02,   5.8463622E-02
     +,   5.8339089E-02,   5.8210786E-02,   5.8091830E-02
     +,   5.7997357E-02,   5.7943907E-02,   5.7949267E-02
     +,   5.8031742E-02,   5.8209367E-02,   5.8498967E-02
     +,   5.8915537E-02,   5.9471000E-02,   6.0173675E-02
     +,   6.1027519E-02,   6.2031757E-02,   6.3180663E-02
     +,   6.4463794E-02,   6.5866493E-02,   6.7370795E-02
     +,   6.8956204E-02,   7.0601672E-02,   7.2286561E-02
     +,   7.3992573E-02,   7.5704940E-02,   7.7414267E-02
     +,   7.9116546E-02,   8.0814607E-02,   8.2517065E-02
     +,   8.4237814E-02,   8.5994877E-02,   8.7807521E-02
     +,   8.9694403E-02,   9.1670662E-02,   9.3745664E-02
     +,   9.5920354E-02,   9.8186314E-02,   0.1005254    
     +,   0.1029107    ,   0.1053081    ,   0.1076799    
     +,   0.1099875    ,   0.1121967    ,   0.1142794    
     +,   0.1162175    ,   0.1180038    ,   0.1196418    
     +,   0.1211444    ,   0.1225310    ,   0.1238240    
     +,   0.1250451    ,   0.1262117    ,   0.1273341    
     +,   0.1284150    ,   0.1294474    ,   0.1304175    
     +,   0.1313052    ,   0.1320868    ,   0.1327371    
     +,   0.1332323    ,   0.1335512    ,   0.1336773    
     +,   0.1336002    ,   0.1333170    ,   0.1328344    
     +,   0.1321707    ,   0.1313577    ,   0.1304431    
     +,   0.1294917    ,   0.1285859    ,   0.1278236    
     +,   0.1273158    ,   0.1271796    ,   0.1275313    
     +,   0.1284754    ,   0.1300950    ,   0.1324389    
     +,   0.1355118    ,   0.1392667    ,   0.1436005    
     +,   0.1483546    ,   0.1533228    ,   0.1582648    
     +,   0.1629241    ,   0.1670498    ,   0.1704203    
     +,   0.1728619    ,   0.1742636    ,   0.1745852    
     +,   0.1738543    ,   0.1721576    ,   0.1696250    
     +,   0.1664110    ,   0.1626755    ,   0.1585674    
     +,   0.1542137    ,   0.1497139    ,   0.1451387    
     +,   0.1405353    ,   0.1359336    ,   0.1313545    
     +,   0.1268155    ,   0.1223377    ,   0.1179481    
     +,   0.1136798    ,   0.1095721    ,   0.1056684    
     +,   0.1020137    ,   9.8651774E-02,   9.5624372E-02
     +,   9.2969805E-02,   9.0723410E-02,   8.8917241E-02
     +,   8.7581374E-02,   8.6744726E-02,   8.6435087E-02
     +,   8.6679056E-02,   8.7500505E-02,   8.8918060E-02
     +,   9.0942428E-02,   9.3571931E-02,   9.6788973E-02
     +,   0.1005560    ,   0.1048135    ,   0.1094789    
     +,   0.1144459    ,   0.1195884    ,   0.1247646    
     +,   0.1298220    ,   0.1346053    ,   0.1389628    
     +,   0.1427546    ,   0.1458572    ,   0.1481705    
     +,   0.1496200    ,   0.1501591    ,   0.1497686    
     +,   0.1484564    ,   0.1462540    ,   0.1432130    
     +,   0.1394018    ,   0.1349009    ,   0.1297990    
     +,   0.1241901    ,   0.1181705    ,   0.1118359    
     +,   0.1052801    ,   9.8593615E-02,   9.1862783E-02
     +,   8.5167624E-02,   7.8581423E-02,   7.2170503E-02
     +,   6.5992467E-02,   6.0095161E-02,   5.4516390E-02
     +,   4.9284082E-02,   4.4416122E-02,   3.9920196E-02
     +,   3.5795383E-02,   3.2033648E-02,   2.8620400E-02
     +,   2.5536511E-02,   2.2759980E-02,   2.0267026E-02
     +,   1.8033139E-02,   1.6034255E-02,   1.4247498E-02
     +,   1.2651481E-02,   1.1226458E-02,   9.9545298E-03
     +,   8.8196853E-03,   7.8075556E-03,   6.9052405E-03
     +,   6.1012045E-03,   5.3852089E-03,   4.7479738E-03
     +,   4.1811923E-03,   3.6774301E-03,   3.2299983E-03
     +,   2.8328663E-03,   2.4806291E-03,   2.1684696E-03
     +,   1.8920820E-03,   1.6476035E-03,   1.4315909E-03
     +,   1.2409915E-03,   1.0730783E-03,   9.2540553E-04
     +,   7.9578877E-04,   6.8228215E-04,   5.8312662E-04
     +,   4.9674045E-04,   4.2170408E-04,   3.5673447E-04
     +,   3.0066902E-04,   2.5245798E-04,   2.1115721E-04
     +,   1.7591479E-04,   1.4596207E-04,   1.2061003E-04
     +,   9.9244273E-05,   8.1317077E-05,   6.6341483E-05
     +,   5.3887750E-05,   4.3579501E-05,   3.5086498E-05
     +,   2.8121824E-05,   2.2437796E-05,   1.7821305E-05
     +,   1.4089816E-05,   1.1088237E-05,   8.6856708E-06
     +,   6.7720775E-06,   5.2553960E-06,   4.0592126E-06
     +,   3.1205468E-06,   2.3875796E-06,   1.8181258E-06
     +,   1.3778931E-06,   1.0392861E-06,   7.8013557E-07
     +,   5.8280648E-07,   4.3329752E-07,   3.2059864E-07
     +,   2.3606960E-07,   1.7299384E-07,   1.2616236E-07
     +,   9.1566569E-08,   6.6140544E-08,   4.7547058E-08
     +,   3.4019692E-08,   2.4227168E-08,   1.7174518E-08
     +,   1.2120376E-08,   8.5168361E-09,   5.9602132E-09
     +,   4.1554555E-09,   2.8876097E-09,   2.0013029E-09
     +,   1.3846017E-09,   9.5747898E-10
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_ashz_hatt105_mass = Yx/4.67072818604651
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_ashz_hatt107_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  7.2294613E-03,   7.6321582E-03
     +,   8.0509149E-03,   8.4861564E-03,   8.9383600E-03
     +,   9.4080595E-03,   9.8958369E-03,   1.0402359E-02
     +,   1.0928320E-02,   1.1474516E-02,   1.2041781E-02
     +,   1.2630998E-02,   1.3243102E-02,   1.3879038E-02
     +,   1.4539758E-02,   1.5226182E-02,   1.5939219E-02
     +,   1.6679658E-02,   1.7448222E-02,   1.8245509E-02
     +,   1.9071937E-02,   1.9927805E-02,   2.0813201E-02
     +,   2.1728110E-02,   2.2672260E-02,   2.3645360E-02
     +,   2.4646897E-02,   2.5676373E-02,   2.6733184E-02
     +,   2.7816800E-02,   2.8926661E-02,   3.0062323E-02
     +,   3.1223303E-02,   3.2409221E-02,   3.3619612E-02
     +,   3.4853913E-02,   3.6111277E-02,   3.7390448E-02
     +,   3.8689688E-02,   4.0006347E-02,   4.1336887E-02
     +,   4.2676628E-02,   4.4019494E-02,   4.5358133E-02
     +,   4.6683636E-02,   4.7985740E-02,   4.9252983E-02
     +,   5.0472751E-02,   5.1631946E-02,   5.2717224E-02
     +,   5.3715613E-02,   5.4615203E-02,   5.5405810E-02
     +,   5.6079734E-02,   5.6632407E-02,   5.7063062E-02
     +,   5.7375383E-02,   5.7577677E-02,   5.7683423E-02
     +,   5.7710938E-02,   5.7683349E-02,   5.7627898E-02
     +,   5.7575427E-02,   5.7559051E-02,   5.7613052E-02
     +,   5.7771545E-02,   5.8066703E-02,   5.8527317E-02
     +,   5.9177332E-02,   6.0034152E-02,   6.1107717E-02
     +,   6.2399216E-02,   6.3900962E-02,   6.5595619E-02
     +,   6.7456938E-02,   6.9450445E-02,   7.1534045E-02
     +,   7.3660038E-02,   7.5777076E-02,   7.7832051E-02
     +,   7.9772338E-02,   8.1548482E-02,   8.3116002E-02
     +,   8.4437966E-02,   8.5486233E-02,   8.6243302E-02
     +,   8.6702615E-02,   8.6869583E-02,   8.6760879E-02
     +,   8.6403787E-02,   8.5835129E-02,   8.5099347E-02
     +,   8.4246799E-02,   8.3331175E-02,   8.2407363E-02
     +,   8.1528790E-02,   8.0745175E-02,   8.0100730E-02
     +,   7.9632170E-02,   7.9367764E-02,   7.9326339E-02
     +,   7.9517372E-02,   7.9941459E-02,   8.0591097E-02
     +,   8.1452444E-02,   8.2507074E-02,   8.3733678E-02
     +,   8.5110232E-02,   8.6616188E-02,   8.8233359E-02
     +,   8.9947253E-02,   9.1747276E-02,   9.3625963E-02
     +,   9.5578477E-02,   9.7599834E-02,   9.9683650E-02
     +,   0.1018186    ,   0.1039870    ,   0.1061621    
     +,   0.1083083    ,   0.1103802    ,   0.1123252    
     +,   0.1140866    ,   0.1156077    ,   0.1168375    
     +,   0.1177359    ,   0.1182788    ,   0.1184624    
     +,   0.1183046    ,   0.1178457    ,   0.1171449    
     +,   0.1162761    ,   0.1153211    ,   0.1143622    
     +,   0.1134741    ,   0.1127175    ,   0.1121338    
     +,   0.1117420    ,   0.1115387    ,   0.1114999    
     +,   0.1115853    ,   0.1117443    ,   0.1119216    
     +,   0.1120636    ,   0.1121227    ,   0.1120609    
     +,   0.1118510    ,   0.1114766    ,   0.1109299    
     +,   0.1102099    ,   0.1093187    ,   0.1082590    
     +,   0.1070324    ,   0.1056383    ,   0.1040736    
     +,   0.1023349    ,   0.1004192    ,   9.8327331E-02
     +,   9.6065633E-02,   9.3648963E-02,   9.1101550E-02
     +,   8.8458374E-02,   8.5765205E-02,   8.3077431E-02
     +,   8.0457874E-02,   7.7974476E-02,   7.5697102E-02
     +,   7.3693722E-02,   7.2026841E-02,   7.0750207E-02
     +,   6.9906473E-02,   6.9524825E-02,   6.9620654E-02
     +,   7.0195779E-02,   7.1239874E-02,   7.2732896E-02
     +,   7.4647754E-02,   7.6952964E-02,   7.9615250E-02
     +,   8.2601868E-02,   8.5880905E-02,   8.9420803E-02
     +,   9.3189657E-02,   9.7153425E-02,   0.1012738    
     +,   0.1055062    ,   0.1097991    ,   0.1140941    
     +,   0.1183277    ,   0.1224319    ,   0.1263392    
     +,   0.1299838    ,   0.1333052    ,   0.1362494    
     +,   0.1387692    ,   0.1408244    ,   0.1423796    
     +,   0.1434028    ,   0.1438648    ,   0.1437379    
     +,   0.1429966    ,   0.1416208    ,   0.1395967    
     +,   0.1369215    ,   0.1336066    ,   0.1296785    
     +,   0.1251810    ,   0.1201741    ,   0.1147319    
     +,   0.1089384    ,   0.1028833    ,   9.6658677E-02
     +,   9.0353131E-02,   8.4048644E-02,   7.7818036E-02
     +,   7.1724132E-02,   6.5818653E-02,   6.0142394E-02
     +,   5.4726318E-02,   4.9593467E-02,   4.4758998E-02
     +,   4.0232033E-02,   3.6016803E-02,   3.2113310E-02
     +,   2.8517634E-02,   2.5222808E-02,   2.2219406E-02
     +,   1.9495739E-02,   1.7038079E-02,   1.4831315E-02
     +,   1.2859416E-02,   1.1105726E-02,   9.5531801E-03
     +,   8.1848148E-03,   6.9841635E-03,   5.9351879E-03
     +,   5.0226566E-03,   4.2322720E-03,   3.5506836E-03
     +,   2.9654976E-03,   2.4653310E-03,   2.0398330E-03
     +,   1.6795922E-03,   1.3760878E-03,   1.1216723E-03
     +,   9.0952637E-04,   7.3358091E-04,   5.8845850E-04
     +,   4.6943151E-04,   3.7237693E-04,   2.9370227E-04
     +,   2.3030727E-04,   1.7953737E-04,   1.3913075E-04
     +,   1.0717197E-04,   8.2054015E-05,   6.2439351E-05
     +,   4.7221369E-05,   3.5490764E-05,   2.6507225E-05
     +,   1.9672971E-05,   1.4508370E-05,   1.0631341E-05
     +,   7.7402801E-06,   5.5990836E-06,   4.0239124E-06
     +,   2.8729694E-06,   2.0377645E-06,   1.4358479E-06
     +,   1.0050220E-06,   6.9877404E-07,   4.8259693E-07
     +,   3.3106403E-07,   2.2558118E-07,   1.5266531E-07
     +,   1.0261845E-07,   6.8507340E-08,   4.5423203E-08
     +,   2.9910762E-08,   1.9560970E-08,   1.2704180E-08
     +,   8.1941103E-09,   5.2485265E-09,   3.3385608E-09
     +,   2.1088673E-09,   1.3228655E-09,   8.2403595E-10
     +,   5.0971727E-10,   3.1309372E-10,   1.9096880E-10
     +,   1.1566566E-10,   6.9563327E-11,   4.1543310E-11
     +,   2.4634706E-11,   1.4505409E-11,   8.4806684E-12
     +,   4.9233096E-12,   2.8378773E-12,   1.6242294E-12
     +,   9.2299746E-13,   5.2079153E-13
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_ashz_hatt107_mass = Yx/4.0868871627907
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_ashz_hatt110_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.8744106E-03,   5.1775728E-03
     +,   5.4991171E-03,   5.8399746E-03,   6.2010735E-03
     +,   6.5833284E-03,   6.9876425E-03,   7.4148774E-03
     +,   7.8658639E-03,   8.3413953E-03,   8.8421889E-03
     +,   9.3688900E-03,   9.9220527E-03,   1.0502137E-02
     +,   1.1109477E-02,   1.1744266E-02,   1.2406559E-02
     +,   1.3096235E-02,   1.3812995E-02,   1.4556347E-02
     +,   1.5325619E-02,   1.6119925E-02,   1.6938159E-02
     +,   1.7779117E-02,   1.8641278E-02,   1.9523092E-02
     +,   2.0422783E-02,   2.1338521E-02,   2.2268346E-02
     +,   2.3210255E-02,   2.4162203E-02,   2.5122123E-02
     +,   2.6087921E-02,   2.7057521E-02,   2.8028790E-02
     +,   2.8999599E-02,   2.9967783E-02,   3.0931013E-02
     +,   3.1887073E-02,   3.2833401E-02,   3.3767536E-02
     +,   3.4686867E-02,   3.5588756E-02,   3.6470678E-02
     +,   3.7330136E-02,   3.8165074E-02,   3.8973786E-02
     +,   3.9755162E-02,   4.0508933E-02,   4.1235697E-02
     +,   4.1937139E-02,   4.2616092E-02,   4.3276507E-02
     +,   4.3923516E-02,   4.4563163E-02,   4.5202322E-02
     +,   4.5848340E-02,   4.6508662E-02,   4.7190517E-02
     +,   4.7900423E-02,   4.8643868E-02,   4.9424808E-02
     +,   5.0245482E-02,   5.1106095E-02,   5.2004889E-02
     +,   5.2937798E-02,   5.3898808E-02,   5.4880075E-02
     +,   5.5872101E-02,   5.6864105E-02,   5.7844553E-02
     +,   5.8800980E-02,   5.9721056E-02,   6.0592469E-02
     +,   6.1403386E-02,   6.2142849E-02,   6.2801011E-02
     +,   6.3369609E-02,   6.3842475E-02,   6.4215414E-02
     +,   6.4487129E-02,   6.4659186E-02,   6.4736471E-02
     +,   6.4727262E-02,   6.4643182E-02,   6.4499237E-02
     +,   6.4313419E-02,   6.4106472E-02,   6.3901119E-02
     +,   6.3721575E-02,   6.3592933E-02,   6.3540399E-02
     +,   6.3588589E-02,   6.3760787E-02,   6.4078256E-02
     +,   6.4559542E-02,   6.5219462E-02,   6.6068389E-02
     +,   6.7111194E-02,   6.8345897E-02,   6.9763623E-02
     +,   7.1346931E-02,   7.3070027E-02,   7.4898519E-02
     +,   7.6790333E-02,   7.8696929E-02,   8.0565326E-02
     +,   8.2340509E-02,   8.3968915E-02,   8.5401043E-02
     +,   8.6595058E-02,   8.7519214E-02,   8.8153996E-02
     +,   8.8493869E-02,   8.8546798E-02,   8.8334695E-02
     +,   8.7891243E-02,   8.7260328E-02,   8.6493120E-02
     +,   8.5645273E-02,   8.4774368E-02,   8.3936863E-02
     +,   8.3186127E-02,   8.2570069E-02,   8.2129672E-02
     +,   8.1897795E-02,   8.1898078E-02,   8.2144484E-02
     +,   8.2640544E-02,   8.3379388E-02,   8.4343508E-02
     +,   8.5505448E-02,   8.6827926E-02,   8.8265412E-02
     +,   8.9765422E-02,   9.1270439E-02,   9.2720270E-02
     +,   9.4054133E-02,   9.5214233E-02,   9.6147254E-02
     +,   9.6807577E-02,   9.7158432E-02,   9.7173937E-02
     +,   9.6839368E-02,   9.6151613E-02,   9.5118597E-02
     +,   9.3758136E-02,   9.2096932E-02,   9.0168424E-02
     +,   8.8011295E-02,   8.5667185E-02,   8.3179764E-02
     +,   8.0592461E-02,   7.7947356E-02,   7.5284176E-02
     +,   7.2639614E-02,   7.0046850E-02,   6.7534663E-02
     +,   6.5127984E-02,   6.2847510E-02,   6.0709868E-02
     +,   5.8727629E-02,   5.6909963E-02,   5.5262785E-02
     +,   5.3789016E-02,   5.2489419E-02,   5.1363416E-02
     +,   5.0409470E-02,   4.9626391E-02,   4.9013875E-02
     +,   4.8573900E-02,   4.8310962E-02,   4.8233245E-02
     +,   4.8352409E-02,   4.8683777E-02,   4.9245857E-02
     +,   5.0058864E-02,   5.1143706E-02,   5.2519571E-02
     +,   5.4202329E-02,   5.6201730E-02,   5.8519956E-02
     +,   6.1149288E-02,   6.4072013E-02,   6.7259617E-02
     +,   7.0673436E-02,   7.4266493E-02,   7.7986054E-02
     +,   8.1775911E-02,   8.5579649E-02,   8.9343622E-02
     +,   9.3019255E-02,   9.6564040E-02,   9.9942073E-02
     +,   0.1031239    ,   0.1060839    ,   0.1087982    
     +,   0.1112421    ,   0.1133874    ,   0.1152007    
     +,   0.1166418    ,   0.1176654    ,   0.1182222    
     +,   0.1182620    ,   0.1177378    ,   0.1166106    
     +,   0.1148528    ,   0.1124533    ,   0.1094189    
     +,   0.1057761    ,   0.1015709    ,   9.6867323E-02
     +,   9.1743819E-02,   8.6289771E-02,   8.0600642E-02
     +,   7.4773945E-02,   6.8905018E-02,   6.3082196E-02
     +,   5.7384804E-02,   5.1881392E-02,   4.6627529E-02
     +,   4.1666143E-02,   3.7028141E-02,   3.2732941E-02
     +,   2.8789494E-02,   2.5198178E-02,   2.1952420E-02
     +,   1.9039983E-02,   1.6444217E-02,   1.4145463E-02
     +,   1.2122338E-02,   1.0352336E-02,   8.8125560E-03
     +,   7.4803443E-03,   6.3338969E-03,   5.3523052E-03
     +,   4.5159371E-03,   3.8066471E-03,   3.2077797E-03
     +,   2.7041822E-03,   2.2822544E-03,   1.9299153E-03
     +,   1.6365026E-03,   1.3926742E-03,   1.1903276E-03
     +,   1.0225044E-03,   8.8326033E-04,   7.6754799E-04
     +,   6.7112391E-04,   5.9045240E-04,   5.2259362E-04
     +,   4.6512950E-04,   4.1608731E-04,   3.7386583E-04
     +,   3.3717277E-04,   3.0497496E-04,   2.7645423E-04
     +,   2.5096544E-04,   2.2800147E-04,   2.0716753E-04
     +,   1.8815881E-04,   1.7073938E-04,   1.5472554E-04
     +,   1.3997470E-04,   1.2637571E-04,   1.1383865E-04
     +,   1.0228952E-04,   9.1666523E-05,   8.1915328E-05
     +,   7.2986033E-05,   6.4831991E-05,   5.7408986E-05
     +,   5.0673942E-05,   4.4584012E-05,   3.9096903E-05
     +,   3.4171455E-05,   2.9766430E-05,   2.5842022E-05
     +,   2.2358961E-05,   1.9279685E-05,   1.6567712E-05
     +,   1.4188630E-05,   1.2109503E-05,   1.0299650E-05
     +,   8.7301596E-06,   7.3744454E-06,   6.2078443E-06
     +,   5.2077785E-06,   4.3538093E-06,   3.6273186E-06
     +,   3.0116653E-06,   2.4918745E-06,   2.0547066E-06
     +,   1.6883860E-06,   1.3826032E-06,   1.1282926E-06
     +,   9.1759171E-07,   7.4366153E-07,   6.0062723E-07
     +,   4.8342855E-07,   3.8776062E-07
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_ashz_hatt110_mass = Yx/3.29369480487805
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_ashz_hatt115_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  7.8196498E-03,   8.2774879E-03
     +,   8.7510273E-03,   9.2397127E-03,   9.7428765E-03
     +,   1.0259713E-02,   1.0789307E-02,   1.1330606E-02
     +,   1.1882432E-02,   1.2443525E-02,   1.3012486E-02
     +,   1.3587823E-02,   1.4167979E-02,   1.4751306E-02
     +,   1.5336110E-02,   1.5920661E-02,   1.6503209E-02
     +,   1.7082006E-02,   1.7655330E-02,   1.8221509E-02
     +,   1.8778939E-02,   1.9326117E-02,   1.9861642E-02
     +,   2.0384336E-02,   2.0893108E-02,   2.1387141E-02
     +,   2.1865830E-02,   2.2328820E-02,   2.2776056E-02
     +,   2.3207774E-02,   2.3624552E-02,   2.4027243E-02
     +,   2.4417071E-02,   2.4795556E-02,   2.5164517E-02
     +,   2.5526000E-02,   2.5882337E-02,   2.6235932E-02
     +,   2.6589388E-02,   2.6945168E-02,   2.7305814E-02
     +,   2.7673617E-02,   2.8050618E-02,   2.8438540E-02
     +,   2.8838670E-02,   2.9251797E-02,   2.9678198E-02
     +,   3.0117564E-02,   3.0569039E-02,   3.1031227E-02
     +,   3.1502210E-02,   3.1979688E-02,   3.2460939E-02
     +,   3.2943126E-02,   3.3423193E-02,   3.3898152E-02
     +,   3.4365140E-02,   3.4821521E-02,   3.5265036E-02
     +,   3.5693824E-02,   3.6106519E-02,   3.6502346E-02
     +,   3.6881030E-02,   3.7242904E-02,   3.7588891E-02
     +,   3.7920441E-02,   3.8239565E-02,   3.8548771E-02
     +,   3.8851134E-02,   3.9150238E-02,   3.9450120E-02
     +,   3.9755479E-02,   4.0071402E-02,   4.0403601E-02
     +,   4.0758181E-02,   4.1141756E-02,   4.1561216E-02
     +,   4.2023577E-02,   4.2535882E-02,   4.3104798E-02
     +,   4.3736376E-02,   4.4435725E-02,   4.5206692E-02
     +,   4.6051409E-02,   4.6970032E-02,   4.7960762E-02
     +,   4.9019132E-02,   5.0138664E-02,   5.1310387E-02
     +,   5.2523512E-02,   5.3765599E-02,   5.5023022E-02
     +,   5.6281507E-02,   5.7526961E-02,   5.8745950E-02
     +,   5.9926264E-02,   6.1057314E-02,   6.2130690E-02
     +,   6.3140385E-02,   6.4082347E-02,   6.4955026E-02
     +,   6.5758429E-02,   6.6494055E-02,   6.7164227E-02
     +,   6.7771532E-02,   6.8318218E-02,   6.8805993E-02
     +,   6.9235444E-02,   6.9606178E-02,   6.9916576E-02
     +,   7.0164226E-02,   7.0346251E-02,   7.0459649E-02
     +,   7.0501924E-02,   7.0471562E-02,   7.0368186E-02
     +,   7.0193119E-02,   6.9949165E-02,   6.9640890E-02
     +,   6.9273926E-02,   6.8855107E-02,   6.8391800E-02
     +,   6.7891419E-02,   6.7361183E-02,   6.6807680E-02
     +,   6.6237062E-02,   6.5654419E-02,   6.5064393E-02
     +,   6.4471021E-02,   6.3878201E-02,   6.3289896E-02
     +,   6.2710114E-02,   6.2143426E-02,   6.1594654E-02
     +,   6.1068919E-02,   6.0571361E-02,   6.0106754E-02
     +,   5.9678975E-02,   5.9290778E-02,   5.8942944E-02
     +,   5.8634318E-02,   5.8361251E-02,   5.8117453E-02
     +,   5.7894073E-02,   5.7680149E-02,   5.7462577E-02
     +,   5.7226926E-02,   5.6958154E-02,   5.6640975E-02
     +,   5.6260966E-02,   5.5805083E-02,   5.5262353E-02
     +,   5.4624371E-02,   5.3885791E-02,   5.3044312E-02
     +,   5.2101068E-02,   5.1060438E-02,   4.9929801E-02
     +,   4.8719317E-02,   4.7441542E-02,   4.6111088E-02
     +,   4.4744071E-02,   4.3357667E-02,   4.1969940E-02
     +,   4.0599022E-02,   3.9262976E-02,   3.7979566E-02
     +,   3.6765732E-02,   3.5637513E-02,   3.4609709E-02
     +,   3.3695985E-02,   3.2908592E-02,   3.2258376E-02
     +,   3.1754870E-02,   3.1406369E-02,   3.1219924E-02
     +,   3.1201543E-02,   3.1356256E-02,   3.1688154E-02
     +,   3.2200459E-02,   3.2895379E-02,   3.3773985E-02
     +,   3.4835890E-02,   3.6079027E-02,   3.7499215E-02
     +,   3.9089479E-02,   4.0839769E-02,   4.2736441E-02
     +,   4.4762027E-02,   4.6894565E-02,   4.9107969E-02
     +,   5.1372096E-02,   5.3652819E-02,   5.5912912E-02
     +,   5.8112968E-02,   6.0212374E-02,   6.2170532E-02
     +,   6.3948005E-02,   6.5508321E-02,   6.6818967E-02
     +,   6.7852363E-02,   6.8587109E-02,   6.9008626E-02
     +,   6.9109350E-02,   6.8888843E-02,   6.8353631E-02
     +,   6.7516439E-02,   6.6395618E-02,   6.5013975E-02
     +,   6.3397855E-02,   6.1575636E-02,   5.9577294E-02
     +,   5.7432853E-02,   5.5171579E-02,   5.2821428E-02
     +,   5.0408553E-02,   4.7956925E-02,   4.5487940E-02
     +,   4.3020569E-02,   4.0571682E-02,   3.8155701E-02
     +,   3.5785053E-02,   3.3470571E-02,   3.1221531E-02
     +,   2.9045636E-02,   2.6949437E-02,   2.4938524E-02
     +,   2.3017431E-02,   2.1189624E-02,   1.9457677E-02
     +,   1.7823340E-02,   1.6287480E-02,   1.4849987E-02
     +,   1.3509951E-02,   1.2265767E-02,   1.1115003E-02
     +,   1.0054569E-02,   9.0808775E-03,   8.1898645E-03
     +,   7.3770476E-03,   6.6376817E-03,   5.9669144E-03
     +,   5.3598192E-03,   4.8114504E-03,   4.3169605E-03
     +,   3.8717070E-03,   3.4712402E-03,   3.1113438E-03
     +,   2.7880799E-03,   2.4978309E-03,   2.2372503E-03
     +,   2.0032905E-03,   1.7932043E-03,   1.6045183E-03
     +,   1.4350015E-03,   1.2826639E-03,   1.1457392E-03
     +,   1.0226566E-03,   9.1200991E-04,   8.1254990E-04
     +,   7.2317035E-04,   6.4288377E-04,   5.7080132E-04
     +,   5.0612801E-04,   4.4815484E-04,   3.9623707E-04
     +,   3.4979242E-04,   3.0829650E-04,   2.7127299E-04
     +,   2.3828635E-04,   2.0894065E-04,   1.8287692E-04
     +,   1.5976792E-04,   1.3931395E-04,   1.2124230E-04
     +,   1.0530640E-04,   9.1279995E-05,   7.8959463E-05
     +,   6.8158515E-05,   5.8709957E-05,   5.0461385E-05
     +,   4.3276399E-05,   3.7031219E-05,   3.1615455E-05
     +,   2.6929361E-05,   2.2884320E-05,   1.9400777E-05
     +,   1.6407907E-05,   1.3843041E-05,   1.1650272E-05
     +,   9.7804586E-06,   8.1900016E-06,   6.8407385E-06
     +,   5.6990166E-06,   4.7355334E-06,   3.9245861E-06
     +,   3.2439152E-06,   2.6741200E-06,   2.1984840E-06
     +,   1.8025285E-06,   1.4738530E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_ashz_hatt115_mass = Yx/2.43472330769231
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_ashz_hatt120_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.1044374E-03,   3.3064638E-03
     +,   3.5215865E-03,   3.7504220E-03,   3.9935708E-03
     +,   4.2516105E-03,   4.5250910E-03,   4.8145344E-03
     +,   5.1204106E-03,   5.4431665E-03,   5.7831793E-03
     +,   6.1407792E-03,   6.5162359E-03,   6.9097523E-03
     +,   7.3214690E-03,   7.7514546E-03,   8.1997076E-03
     +,   8.6661438E-03,   9.1506131E-03,   9.6528847E-03
     +,   1.0172645E-02,   1.0709510E-02,   1.1262989E-02
     +,   1.1832558E-02,   1.2417520E-02,   1.3017158E-02
     +,   1.3630611E-02,   1.4256905E-02,   1.4894939E-02
     +,   1.5543477E-02,   1.6201109E-02,   1.6866261E-02
     +,   1.7537151E-02,   1.8211786E-02,   1.8887939E-02
     +,   1.9563118E-02,   2.0234602E-02,   2.0899333E-02
     +,   2.1554103E-02,   2.2195330E-02,   2.2819281E-02
     +,   2.3422018E-02,   2.3999469E-02,   2.4547514E-02
     +,   2.5062062E-02,   2.5539197E-02,   2.5975285E-02
     +,   2.6367113E-02,   2.6712073E-02,   2.7008317E-02
     +,   2.7254933E-02,   2.7452121E-02,   2.7601305E-02
     +,   2.7705349E-02,   2.7768547E-02,   2.7796771E-02
     +,   2.7797416E-02,   2.7779408E-02,   2.7753033E-02
     +,   2.7729793E-02,   2.7722141E-02,   2.7743168E-02
     +,   2.7806260E-02,   2.7924655E-02,   2.8110990E-02
     +,   2.8376881E-02,   2.8732462E-02,   2.9185876E-02
     +,   2.9743060E-02,   3.0407257E-02,   3.1178934E-02
     +,   3.2055534E-02,   3.3031642E-02,   3.4098879E-02
     +,   3.5246272E-02,   3.6460705E-02,   3.7727080E-02
     +,   3.9029077E-02,   4.0349755E-02,   4.1672133E-02
     +,   4.2979721E-02,   4.4257406E-02,   4.5491636E-02
     +,   4.6671212E-02,   4.7787305E-02,   4.8833903E-02
     +,   4.9807459E-02,   5.0707296E-02,   5.1534832E-02
     +,   5.2293554E-02,   5.2988499E-02,   5.3625699E-02
     +,   5.4211725E-02,   5.4753497E-02,   5.5257600E-02
     +,   5.5730242E-02,   5.6176942E-02,   5.6602370E-02
     +,   5.7010539E-02,   5.7404470E-02,   5.7786271E-02
     +,   5.8157060E-02,   5.8516920E-02,   5.8864571E-02
     +,   5.9197448E-02,   5.9511393E-02,   5.9800539E-02
     +,   6.0057200E-02,   6.0272366E-02,   6.0435347E-02
     +,   6.0534690E-02,   6.0558658E-02,   6.0495835E-02
     +,   6.0336210E-02,   6.0071830E-02,   5.9697699E-02
     +,   5.9212632E-02,   5.8619373E-02,   5.7925154E-02
     +,   5.7141442E-02,   5.6283515E-02,   5.5369735E-02
     +,   5.4420676E-02,   5.3457797E-02,   5.2502163E-02
     +,   5.1573414E-02,   5.0688241E-02,   4.9859762E-02
     +,   4.9096391E-02,   4.8401803E-02,   4.7774695E-02
     +,   4.7208939E-02,   4.6694443E-02,   4.6217751E-02
     +,   4.5763101E-02,   4.5313582E-02,   4.4852272E-02
     +,   4.4363331E-02,   4.3832842E-02,   4.3249607E-02
     +,   4.2605739E-02,   4.1896872E-02,   4.1122243E-02
     +,   4.0284336E-02,   3.9388806E-02,   3.8443629E-02
     +,   3.7458640E-02,   3.6444884E-02,   3.5413880E-02
     +,   3.4377012E-02,   3.3344932E-02,   3.2327410E-02
     +,   3.1332783E-02,   3.0367805E-02,   2.9437719E-02
     +,   2.8546259E-02,   2.7695855E-02,   2.6887702E-02
     +,   2.6122103E-02,   2.5398819E-02,   2.4717141E-02
     +,   2.4076290E-02,   2.3475491E-02,   2.2914356E-02
     +,   2.2392726E-02,   2.1910910E-02,   2.1469720E-02
     +,   2.1070397E-02,   2.0714549E-02,   2.0404134E-02
     +,   2.0141333E-02,   1.9928435E-02,   1.9767769E-02
     +,   1.9661509E-02,   1.9611683E-02,   1.9620040E-02
     +,   1.9687973E-02,   1.9816486E-02,   2.0006189E-02
     +,   2.0257263E-02,   2.0569490E-02,   2.0942301E-02
     +,   2.1374714E-02,   2.1865491E-02,   2.2413172E-02
     +,   2.3015996E-02,   2.3671990E-02,   2.4379028E-02
     +,   2.5134809E-02,   2.5936704E-02,   2.6781855E-02
     +,   2.7667092E-02,   2.8588749E-02,   2.9542625E-02
     +,   3.0523971E-02,   3.1527303E-02,   3.2546259E-02
     +,   3.3573631E-02,   3.4601316E-02,   3.5620298E-02
     +,   3.6620557E-02,   3.7591211E-02,   3.8520779E-02
     +,   3.9397057E-02,   4.0207446E-02,   4.0939298E-02
     +,   4.1579966E-02,   4.2117134E-02,   4.2539265E-02
     +,   4.2835757E-02,   4.2997252E-02,   4.3015897E-02
     +,   4.2885639E-02,   4.2602371E-02,   4.2164035E-02
     +,   4.1570846E-02,   4.0825251E-02,   3.9931919E-02
     +,   3.8897622E-02,   3.7731264E-02,   3.6443569E-02
     +,   3.5046808E-02,   3.3554789E-02,   3.1982362E-02
     +,   3.0345146E-02,   2.8659157E-02,   2.6940743E-02
     +,   2.5206035E-02,   2.3470640E-02,   2.1749437E-02
     +,   2.0056440E-02,   1.8404489E-02,   1.6804960E-02
     +,   1.5267757E-02,   1.3801371E-02,   1.2412535E-02
     +,   1.1106383E-02,   9.8865572E-03,   8.7551912E-03
     +,   7.7129318E-03,   6.7591551E-03,   5.8921631E-03
     +,   5.1092617E-03,   4.4068787E-03,   3.7807920E-03
     +,   3.2263205E-03,   2.7384255E-03,   2.3118248E-03
     +,   1.9411618E-03,   1.6211456E-03,   1.3465735E-03
     +,   1.1124498E-03,   9.1405772E-04,   7.4698380E-04
     +,   6.0714153E-04,   4.9080211E-04,   3.9460624E-04
     +,   3.1554906E-04,   2.5096504E-04,   1.9851854E-04
     +,   1.5618368E-04,   1.2221438E-04,   9.5117444E-05
     +,   7.3628762E-05,   5.6688390E-05,   4.3410870E-05
     +,   3.3064265E-05,   2.5048450E-05,   1.8874269E-05
     +,   1.4145695E-05,   1.0544849E-05,   7.8184912E-06
     +,   5.7660313E-06,   4.2295906E-06,   3.0858982E-06
     +,   2.2394183E-06,   1.6163982E-06,   1.1604558E-06
     +,   8.2863676E-07,   5.8852135E-07,   4.1572829E-07
     +,   2.9208718E-07,   2.0410685E-07,   1.4185704E-07
     +,   9.8056780E-08,   6.7413126E-08,   4.6093781E-08
     +,   3.1344602E-08,   2.1198943E-08,   1.4258851E-08
     +,   9.5386481E-09,   6.3462355E-09,   4.1994732E-09
     +,   2.7639593E-09,   1.8095556E-09,   1.1785734E-09
     +,   7.6380297E-10,   4.9267590E-10,   3.1645037E-10
     +,   2.0253374E-10,   1.2930003E-10
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_ashz_hatt120_mass = Yx/1.822149
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_ashz_hatt60_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  6.1610553E-02,   7.2746910E-02
     +,   8.4881909E-02,   9.7943485E-02,   0.1118638    
     +,   0.1265951    ,   0.1421222    ,   0.1584654    
     +,   0.1756657    ,   0.1937530    ,   0.2126947    
     +,   0.2323461    ,   0.2524216    ,   0.2725185    
     +,   0.2922090    ,   0.3111939    ,   0.3294747    
     +,   0.3474672    ,   0.3659673    ,   0.3859304    
     +,   0.4080955    ,   0.4326033    ,   0.4588248    
     +,   0.4855375    ,   0.5114132    ,   0.5355427    
     +,   0.5576515    ,   0.5778888    ,   0.5964155    
     +,   0.6132286    ,   0.6284119    ,   0.6425392    
     +,   0.6566702    ,   0.6716936    ,   0.6873887    
     +,   0.7019507    ,   0.7124516    ,   0.7159605    
     +,   0.7106208    ,   0.6961409    ,   0.6736545    
     +,   0.6452796    ,   0.6135913    ,   0.5811102    
     +,   0.5497760    ,   0.5205361    ,   0.4932622    
     +,   0.4670655    ,   0.4408679    ,   0.4139512    
     +,   0.3862323    ,   0.3582252    ,   0.3307855    
     +,   0.3048056    ,   0.2809859    ,   0.2597220    
     +,   0.2411102    ,   0.2250080    ,   0.2111187    
     +,   0.1990724    ,   0.1884945    ,   0.1790560    
     +,   0.1705052    ,   0.1626760    ,   0.1554802    
     +,   0.1488861    ,   0.1428892    ,   0.1374885    
     +,   0.1326671    ,   0.1283842    ,   0.1245734    
     +,   0.1211493    ,   0.1180154    ,   0.1150759    
     +,   0.1122436    ,   0.1094482    ,   0.1066402    
     +,   0.1037932    ,   0.1009018    ,   9.7979777E-02
     +,   9.5055304E-02,   9.2164904E-02,   8.9348815E-02
     +,   8.6644925E-02,   8.4084950E-02,   8.1690900E-02
     +,   7.9473309E-02,   7.7430569E-02,   7.5550303E-02
     +,   7.3810257E-02,   7.2181359E-02,   7.0630386E-02
     +,   6.9122940E-02,   6.7625888E-02,   6.6110045E-02
     +,   6.4551838E-02,   6.2934302E-02,   6.1247911E-02
     +,   5.9490442E-02,   5.7666361E-02,   5.5785839E-02
     +,   5.3863782E-02,   5.1918142E-02,   4.9968727E-02
     +,   4.8035692E-02,   4.6138301E-02,   4.4294219E-02
     +,   4.2518578E-02,   4.0823389E-02,   3.9217483E-02
     +,   3.7706714E-02,   3.6293641E-02,   3.4978434E-02
     +,   3.3758868E-02,   3.2631092E-02,   3.1589847E-02
     +,   3.0629259E-02,   2.9742954E-02,   2.8924590E-02
     +,   2.8168071E-02,   2.7467698E-02,   2.6818467E-02
     +,   2.6215972E-02,   2.5656465E-02,   2.5136817E-02
     +,   2.4654524E-02,   2.4207462E-02,   2.3794016E-02
     +,   2.3412710E-02,   2.3062330E-02,   2.2741728E-02
     +,   2.2449752E-02,   2.2185160E-02,   2.1946680E-02
     +,   2.1732856E-02,   2.1542074E-02,   2.1372573E-02
     +,   2.1222482E-02,   2.1089762E-02,   2.0972291E-02
     +,   2.0867899E-02,   2.0774366E-02,   2.0689476E-02
     +,   2.0611044E-02,   2.0536995E-02,   2.0465311E-02
     +,   2.0394163E-02,   2.0321811E-02,   2.0246733E-02
     +,   2.0167582E-02,   2.0083217E-02,   1.9992679E-02
     +,   1.9895250E-02,   1.9790392E-02,   1.9677760E-02
     +,   1.9557221E-02,   1.9428832E-02,   1.9292779E-02
     +,   1.9149426E-02,   1.8999308E-02,   1.8843051E-02
     +,   1.8681396E-02,   1.8515175E-02,   1.8345313E-02
     +,   1.8172767E-02,   1.7998531E-02,   1.7823646E-02
     +,   1.7649131E-02,   1.7476000E-02,   1.7305231E-02
     +,   1.7137755E-02,   1.6974453E-02,   1.6816117E-02
     +,   1.6663441E-02,   1.6517064E-02,   1.6377462E-02
     +,   1.6245015E-02,   1.6119983E-02,   1.6002500E-02
     +,   1.5892560E-02,   1.5790017E-02,   1.5694603E-02
     +,   1.5605935E-02,   1.5523470E-02,   1.5446580E-02
     +,   1.5374517E-02,   1.5306438E-02,   1.5241416E-02
     +,   1.5178435E-02,   1.5116445E-02,   1.5054336E-02
     +,   1.4990969E-02,   1.4925200E-02,   1.4855881E-02
     +,   1.4781894E-02,   1.4702142E-02,   1.4615590E-02
     +,   1.4521249E-02,   1.4418224E-02,   1.4305689E-02
     +,   1.4182935E-02,   1.4049335E-02,   1.3904394E-02
     +,   1.3747712E-02,   1.3579039E-02,   1.3398218E-02
     +,   1.3205224E-02,   1.3000152E-02,   1.2783224E-02
     +,   1.2554759E-02,   1.2315177E-02,   1.2065029E-02
     +,   1.1804921E-02,   1.1535564E-02,   1.1257722E-02
     +,   1.0972241E-02,   1.0680018E-02,   1.0381985E-02
     +,   1.0079081E-02,   9.7723147E-03,   9.4626686E-03
     +,   9.1511253E-03,   8.8386722E-03,   8.5262908E-03
     +,   8.2149012E-03,   7.9054022E-03,   7.5986651E-03
     +,   7.2955196E-03,   6.9967145E-03,   6.7029539E-03
     +,   6.4149029E-03,   6.1331545E-03,   5.8582337E-03
     +,   5.5905911E-03,   5.3306455E-03,   5.0787306E-03
     +,   4.8351125E-03,   4.6000183E-03,   4.3736105E-03
     +,   4.1559883E-03,   3.9471961E-03,   3.7472483E-03
     +,   3.5561072E-03,   3.3736825E-03,   3.1998514E-03
     +,   3.0344645E-03,   2.8773462E-03,   2.7282811E-03
     +,   2.5870332E-03,   2.4533635E-03,   2.3270017E-03
     +,   2.2076683E-03,   2.0950816E-03,   1.9889562E-03
     +,   1.8889919E-03,   1.7948931E-03,   1.7063681E-03
     +,   1.6231299E-03,   1.5448888E-03,   1.4713638E-03
     +,   1.4022867E-03,   1.3373954E-03,   1.2764345E-03
     +,   1.2191575E-03,   1.1653350E-03,   1.1147434E-03
     +,   1.0671690E-03,   1.0224131E-03,   9.8028767E-04
     +,   9.4061298E-04,   9.0321951E-04,   8.6795120E-04
     +,   8.3466206E-04,   8.0321246E-04,   7.7347364E-04
     +,   7.4532750E-04,   7.1866106E-04,   6.9337280E-04
     +,   6.6936534E-04,   6.4655126E-04,   6.2484678E-04
     +,   6.0417788E-04,   5.8447185E-04,   5.6566566E-04
     +,   5.4769771E-04,   5.3051359E-04,   5.1406136E-04
     +,   4.9829314E-04,   4.8316640E-04,   4.6863942E-04
     +,   4.5467570E-04,   4.4123971E-04,   4.2830003E-04
     +,   4.1582668E-04,   4.0379257E-04,   3.9217155E-04
     +,   3.8094106E-04,   3.7007820E-04,   3.5956345E-04
     +,   3.4937743E-04,   3.3950337E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_ashz_hatt60_mass = Yx/7.37222119565217
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_ashz_hatt65_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.0872766E-02,   2.3913892E-02
     +,   2.7314672E-02,   3.1106872E-02,   3.5324596E-02
     +,   4.0004645E-02,   4.5186549E-02,   5.0912160E-02
     +,   5.7223406E-02,   6.4159237E-02,   7.1748830E-02
     +,   8.0003805E-02,   8.8908210E-02,   9.8409541E-02
     +,   0.1084127    ,   0.1187828    ,   0.1293570    
     +,   0.1399709    ,   0.1504936    ,   0.1608666    
     +,   0.1711340    ,   0.1814527    ,   0.1920728    
     +,   0.2032881    ,   0.2153692    ,   0.2284985    
     +,   0.2427351    ,   0.2580303    ,   0.2742993    
     +,   0.2915231    ,   0.3098331    ,   0.3295086    
     +,   0.3508458    ,   0.3739304    ,   0.3984206    
     +,   0.4234988    ,   0.4480896    ,   0.4712935    
     +,   0.4928288    ,   0.5131789    ,   0.5332800    
     +,   0.5538643    ,   0.5748690    ,   0.5954647    
     +,   0.6148381    ,   0.6332732    ,   0.6525792    
     +,   0.6752965    ,   0.7030637    ,   0.7352889    
     +,   0.7690353    ,   0.8001204    ,   0.8247124    
     +,   0.8405677    ,   0.8473613    ,   0.8461345    
     +,   0.8383400    ,   0.8250989    ,   0.8069921    
     +,   0.7842090    ,   0.7567737    ,   0.7247380    
     +,   0.6883352    ,   0.6481241    ,   0.6051522    
     +,   0.5611038    ,   0.5182340    ,   0.4789168    
     +,   0.4448615    ,   0.4164845    ,   0.3928430    
     +,   0.3722035    ,   0.3528254    ,   0.3335454    
     +,   0.3139316    ,   0.2941147    ,   0.2745031    
     +,   0.2555492    ,   0.2376213    ,   0.2209670    
     +,   0.2057210    ,   0.1919195    ,   0.1795255    
     +,   0.1684441    ,   0.1585425    ,   0.1496655    
     +,   0.1416524    ,   0.1343515    ,   0.1276338    
     +,   0.1214017    ,   0.1155923    ,   0.1101759    
     +,   0.1051466    ,   0.1005105    ,   9.6273549E-02
     +,   9.2431277E-02,   8.8962406E-02,   8.5828058E-02
     +,   8.2973875E-02,   8.0336720E-02,   7.7851124E-02
     +,   7.5457186E-02,   7.3105358E-02,   7.0761122E-02
     +,   6.8406031E-02,   6.6037595E-02,   6.3667566E-02
     +,   6.1318908E-02,   5.9022069E-02,   5.6811381E-02
     +,   5.4722019E-02,   5.2786406E-02,   5.1032368E-02
     +,   4.9481079E-02,   4.8146352E-02,   4.7033731E-02
     +,   4.6141185E-02,   4.5459032E-02,   4.4971254E-02
     +,   4.4656161E-02,   4.4487752E-02,   4.4436961E-02
     +,   4.4472560E-02,   4.4562798E-02,   4.4675961E-02
     +,   4.4781815E-02,   4.4852111E-02,   4.4861458E-02
     +,   4.4787865E-02,   4.4613216E-02,   4.4323537E-02
     +,   4.3909218E-02,   4.3364838E-02,   4.2689327E-02
     +,   4.1885462E-02,   4.0959671E-02,   3.9921559E-02
     +,   3.8783364E-02,   3.7559386E-02,   3.6265343E-02
     +,   3.4917969E-02,   3.3534296E-02,   3.2131139E-02
     +,   3.0724581E-02,   2.9329846E-02,   2.7960652E-02
     +,   2.6629129E-02,   2.5345773E-02,   2.4119260E-02
     +,   2.2956410E-02,   2.1862276E-02,   2.0840401E-02
     +,   1.9892814E-02,   1.9020163E-02,   1.8221971E-02
     +,   1.7496871E-02,   1.6842747E-02,   1.6256815E-02
     +,   1.5735904E-02,   1.5276572E-02,   1.4875168E-02
     +,   1.4527978E-02,   1.4231313E-02,   1.3981549E-02
     +,   1.3775156E-02,   1.3608743E-02,   1.3479098E-02
     +,   1.3383174E-02,   1.3318037E-02,   1.3280949E-02
     +,   1.3269278E-02,   1.3280516E-02,   1.3312259E-02
     +,   1.3362172E-02,   1.3427974E-02,   1.3507432E-02
     +,   1.3598332E-02,   1.3698478E-02,   1.3805664E-02
     +,   1.3917694E-02,   1.4032366E-02,   1.4147450E-02
     +,   1.4260745E-02,   1.4370027E-02,   1.4473115E-02
     +,   1.4567856E-02,   1.4652126E-02,   1.4723895E-02
     +,   1.4781194E-02,   1.4822180E-02,   1.4845126E-02
     +,   1.4848466E-02,   1.4830786E-02,   1.4790876E-02
     +,   1.4727721E-02,   1.4640520E-02,   1.4528719E-02
     +,   1.4391995E-02,   1.4230270E-02,   1.4043699E-02
     +,   1.3832712E-02,   1.3597954E-02,   1.3340316E-02
     +,   1.3060883E-02,   1.2760972E-02,   1.2442065E-02
     +,   1.2105792E-02,   1.1753956E-02,   1.1388453E-02
     +,   1.1011263E-02,   1.0624413E-02,   1.0229986E-02
     +,   9.8300790E-03,   9.4267363E-03,   9.0219611E-03
     +,   8.6177103E-03,   8.2158567E-03,   7.8181429E-03
     +,   7.4261869E-03,   7.0415111E-03,   6.6654598E-03
     +,   6.2992200E-03,   5.9438571E-03,   5.6002731E-03
     +,   5.2691903E-03,   4.9511828E-03,   4.6467017E-03
     +,   4.3560523E-03,   4.0793908E-03,   3.8167543E-03
     +,   3.5680896E-03,   3.3332370E-03,   3.1119403E-03
     +,   2.9038659E-03,   2.7086369E-03,   2.5258034E-03
     +,   2.3548761E-03,   2.1953434E-03,   2.0466726E-03
     +,   1.9083053E-03,   1.7796797E-03,   1.6602406E-03
     +,   1.5494399E-03,   1.4467330E-03,   1.3515907E-03
     +,   1.2635083E-03,   1.1820021E-03,   1.1066047E-03
     +,   1.0368732E-03,   9.7239716E-04,   9.1278227E-04
     +,   8.5766084E-04,   8.0669258E-04,   7.5955963E-04
     +,   7.1596430E-04,   6.7563058E-04,   6.3830568E-04
     +,   6.0375564E-04,   5.7176169E-04,   5.4212316E-04
     +,   5.1465613E-04,   4.8919133E-04,   4.6557098E-04
     +,   4.4364997E-04,   4.2329662E-04,   4.0438754E-04
     +,   3.8680920E-04,   3.7045780E-04,   3.5523792E-04
     +,   3.4106043E-04,   3.2784298E-04,   3.1551055E-04
     +,   3.0399417E-04,   2.9322883E-04,   2.8315501E-04
     +,   2.7371859E-04,   2.6486834E-04,   2.5655830E-04
     +,   2.4874476E-04,   2.4138864E-04,   2.3445273E-04
     +,   2.2790379E-04,   2.2171038E-04,   2.1584409E-04
     +,   2.1027825E-04,   2.0498896E-04,   1.9995375E-04
     +,   1.9515186E-04,   1.9056497E-04,   1.8617540E-04
     +,   1.8196761E-04,   1.7792682E-04,   1.7404006E-04
     +,   1.7029482E-04,   1.6668037E-04,   1.6318625E-04
     +,   1.5980353E-04,   1.5652344E-04,   1.5333865E-04
     +,   1.5024192E-04,   1.4722711E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_ashz_hatt65_mass = Yx/8.70151531914894
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_ashz_hatt70_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.5322166E-02,   1.6555557E-02
     +,   1.7845759E-02,   1.9192021E-02,   2.0593980E-02
     +,   2.2051889E-02,   2.3566945E-02,   2.5141472E-02
     +,   2.6779119E-02,   2.8485119E-02,   3.0266149E-02
     +,   3.2130465E-02,   3.4087833E-02,   3.6149427E-02
     +,   3.8327973E-02,   4.0637791E-02,   4.3095186E-02
     +,   4.5718744E-02,   4.8529848E-02,   5.1552910E-02
     +,   5.4815225E-02,   5.8346398E-02,   6.2177081E-02
     +,   6.6337533E-02,   7.0855431E-02,   7.5755917E-02
     +,   8.1061319E-02,   8.6794116E-02,   9.2980586E-02
     +,   9.9656269E-02,   0.1068685    ,   0.1146768    
     +,   0.1231482    ,   0.1323472    ,   0.1423232    
     +,   0.1530970    ,   0.1646498    ,   0.1769165    
     +,   0.1897870    ,   0.2031169    ,   0.2167633    
     +,   0.2306421    ,   0.2448142    ,   0.2595688    
     +,   0.2754639    ,   0.2932640    ,   0.3137599    
     +,   0.3375023    ,   0.3645557    ,   0.3943993    
     +,   0.4260219    ,   0.4581616    ,   0.4895813    
     +,   0.5193530    ,   0.5471528    ,   0.5735254    
     +,   0.5998495    ,   0.6277505    ,   0.6580967    
     +,   0.6901680    ,   0.7216567    ,   0.7496325    
     +,   0.7720260    ,   0.7889365    ,   0.8030642    
     +,   0.8185458    ,   0.8381751    ,   0.8608214    
     +,   0.8818102    ,   0.8966835    ,   0.9051845    
     +,   0.9117083    ,   0.9218847    ,   0.9381074    
     +,   0.9570865    ,   0.9709449    ,   0.9713758    
     +,   0.9542547    ,   0.9213960    ,   0.8784988    
     +,   0.8313948    ,   0.7836151    ,   0.7364405    
     +,   0.6902548    ,   0.6455629    ,   0.6030458    
     +,   0.5631558    ,   0.5257820    ,   0.4902697    
     +,   0.4557251    ,   0.4214999    ,   0.3875451    
     +,   0.3544207    ,   0.3229712    ,   0.2939198    
     +,   0.2676192    ,   0.2440383    ,   0.2229215    
     +,   0.2039592    ,   0.1869022    ,   0.1715819    
     +,   0.1578809    ,   0.1456845    ,   0.1348582    
     +,   0.1252418    ,   0.1166660    ,   0.1089722    
     +,   0.1020259    ,   9.5721968E-02,   8.9982681E-02
     +,   8.4750555E-02,   7.9978742E-02,   7.5625859E-02
     +,   7.1651243E-02,   6.8015277E-02,   6.4679764E-02
     +,   6.1611041E-02,   5.8780592E-02,   5.6166824E-02
     +,   5.3753946E-02,   5.1531114E-02,   4.9491044E-02
     +,   4.7627959E-02,   4.5936439E-02,   4.4410411E-02
     +,   4.3043148E-02,   4.1826561E-02,   4.0752180E-02
     +,   3.9810732E-02,   3.8993053E-02,   3.8289718E-02
     +,   3.7691485E-02,   3.7188936E-02,   3.6772437E-02
     +,   3.6431815E-02,   3.6156163E-02,   3.5933811E-02
     +,   3.5752084E-02,   3.5597440E-02,   3.5455696E-02
     +,   3.5312276E-02,   3.5152614E-02,   3.4962554E-02
     +,   3.4728885E-02,   3.4439839E-02,   3.4085471E-02
     +,   3.3658098E-02,   3.3152662E-02,   3.2566741E-02
     +,   3.1900827E-02,   3.1158147E-02,   3.0344591E-02
     +,   2.9468495E-02,   2.8540116E-02,   2.7571378E-02
     +,   2.6575394E-02,   2.5565971E-02,   2.4557026E-02
     +,   2.3562221E-02,   2.2594646E-02,   2.1666173E-02
     +,   2.0787382E-02,   1.9967292E-02,   1.9213201E-02
     +,   1.8530509E-02,   1.7922817E-02,   1.7391985E-02
     +,   1.6938185E-02,   1.6560026E-02,   1.6254755E-02
     +,   1.6018491E-02,   1.5846357E-02,   1.5732717E-02
     +,   1.5671359E-02,   1.5655711E-02,   1.5678974E-02
     +,   1.5734298E-02,   1.5814885E-02,   1.5914150E-02
     +,   1.6025761E-02,   1.6143763E-02,   1.6262582E-02
     +,   1.6377097E-02,   1.6482688E-02,   1.6575247E-02
     +,   1.6651133E-02,   1.6707258E-02,   1.6741013E-02
     +,   1.6750315E-02,   1.6733536E-02,   1.6689518E-02
     +,   1.6617548E-02,   1.6517300E-02,   1.6388860E-02
     +,   1.6232640E-02,   1.6049363E-02,   1.5840057E-02
     +,   1.5605997E-02,   1.5348645E-02,   1.5069650E-02
     +,   1.4770794E-02,   1.4454011E-02,   1.4121228E-02
     +,   1.3774470E-02,   1.3415764E-02,   1.3047117E-02
     +,   1.2670492E-02,   1.2287810E-02,   1.1900912E-02
     +,   1.1511547E-02,   1.1121326E-02,   1.0731793E-02
     +,   1.0344370E-02,   9.9603208E-03,   9.5807929E-03
     +,   9.2068268E-03,   8.8393474E-03,   8.4791239E-03
     +,   8.1268260E-03,   7.7830455E-03,   7.4482323E-03
     +,   7.1227564E-03,   6.8069119E-03,   6.5009240E-03
     +,   6.2049213E-03,   5.9189769E-03,   5.6431233E-03
     +,   5.3773476E-03,   5.1215738E-03,   4.8756944E-03
     +,   4.6395869E-03,   4.4131000E-03,   4.1960492E-03
     +,   3.9882278E-03,   3.7894396E-03,   3.5994533E-03
     +,   3.4180311E-03,   3.2449355E-03,   3.0799259E-03
     +,   2.9227468E-03,   2.7731375E-03,   2.6308477E-03
     +,   2.4956234E-03,   2.3672034E-03,   2.2453247E-03
     +,   2.1297375E-03,   2.0201898E-03,   1.9164267E-03
     +,   1.8181955E-03,   1.7252574E-03,   1.6373675E-03
     +,   1.5542859E-03,   1.4757824E-03,   1.4016329E-03
     +,   1.3316129E-03,   1.2655047E-03,   1.2031014E-03
     +,   1.1442018E-03,   1.0886083E-03,   1.0361302E-03
     +,   9.8658830E-04,   9.3980954E-04,   8.9562603E-04
     +,   8.5387722E-04,   8.1441511E-04,   7.7709410E-04
     +,   7.4177684E-04,   7.0833630E-04,   6.7665154E-04
     +,   6.4660766E-04,   6.1809644E-04,   5.9101835E-04
     +,   5.6528044E-04,   5.4079440E-04,   5.1747810E-04
     +,   4.9525732E-04,   4.7406080E-04,   4.5382496E-04
     +,   4.3448844E-04,   4.1599773E-04,   3.9830056E-04
     +,   3.8135157E-04,   3.6510665E-04,   3.4952746E-04
     +,   3.3457717E-04,   3.2022360E-04,   3.0643595E-04
     +,   2.9318614E-04,   2.8044955E-04,   2.6820213E-04
     +,   2.5642320E-04,   2.4509232E-04,   2.3419212E-04
     +,   2.2370504E-04,   2.1361621E-04,   2.0391055E-04
     +,   1.9457517E-04,   1.8559681E-04,   1.7696425E-04
     +,   1.6866562E-04,   1.6069076E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_ashz_hatt70_mass = Yx/9.945896625
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_ashz_hatt75_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  6.3732495E-03,   6.8618641E-03
     +,   7.3957508E-03,   7.9796519E-03,   8.6183455E-03
     +,   9.3164528E-03,   1.0078270E-02,   1.0907559E-02
     +,   1.1807316E-02,   1.2779637E-02,   1.3825409E-02
     +,   1.4944253E-02,   1.6134391E-02,   1.7392637E-02
     +,   1.8714515E-02,   2.0094406E-02,   2.1525871E-02
     +,   2.3002127E-02,   2.4516519E-02,   2.6063208E-02
     +,   2.7637795E-02,   2.9238079E-02,   3.0864682E-02
     +,   3.2521740E-02,   3.4217197E-02,   3.5963360E-02
     +,   3.7776809E-02,   3.9678201E-02,   4.1691992E-02
     +,   4.3845505E-02,   4.6167921E-02,   4.8688985E-02
     +,   5.1437460E-02,   5.4439418E-02,   5.7716705E-02
     +,   6.1285459E-02,   6.5155208E-02,   6.9328353E-02
     +,   7.3801614E-02,   7.8566790E-02,   8.3615772E-02
     +,   8.8944681E-02,   9.4560251E-02,   0.1004865    
     +,   0.1067689    ,   0.1134759    ,   0.1206943    
     +,   0.1285193    ,   0.1370393    ,   0.1463194    
     +,   0.1563899    ,   0.1672415    ,   0.1788321    
     +,   0.1911084    ,   0.2040298    ,   0.2175979    
     +,   0.2318669    ,   0.2469349    ,   0.2629067    
     +,   0.2798482    ,   0.2977686    ,   0.3166590    
     +,   0.3365996    ,   0.3578993    ,   0.3811715    
     +,   0.4072737    ,   0.4370906    ,   0.4712450    
     +,   0.5099192    ,   0.5528676    ,   0.5995204    
     +,   0.6489122    ,   0.6995466    ,   0.7494898    
     +,   0.7968081    ,   0.8397880    ,   0.8768721    
     +,   0.9072745    ,   0.9324868    ,   0.9567825    
     +,   0.9854077    ,    1.021823    ,    1.065366    
     +,    1.109772    ,    1.145203    ,    1.165722    
     +,    1.175679    ,    1.186635    ,    1.207539    
     +,    1.238458    ,    1.272254    ,    1.300553    
     +,    1.317844    ,    1.321011    ,    1.307424    
     +,    1.275269    ,    1.225335    ,    1.161251    
     +,    1.087173    ,    1.005973    ,   0.9202309    
     +,   0.8339218    ,   0.7518298    ,   0.6775094    
     +,   0.6119836    ,   0.5541735    ,   0.5022454    
     +,   0.4546659    ,   0.4104805    ,   0.3691621    
     +,   0.3304930    ,   0.2945549    ,   0.2616891    
     +,   0.2323122    ,   0.2067052    ,   0.1848751    
     +,   0.1665650    ,   0.1513338    ,   0.1386688    
     +,   0.1280629    ,   0.1190634    ,   0.1112922    
     +,   0.1044496    ,   9.8310560E-02,   9.2717521E-02
     +,   8.7569349E-02,   8.2806788E-02,   7.8399077E-02
     +,   7.4329495E-02,   7.0585765E-02,   6.7152187E-02
     +,   6.4007357E-02,   6.1123110E-02,   5.8467675E-02
     +,   5.6007676E-02,   5.3711530E-02,   5.1552087E-02
     +,   4.9507957E-02,   4.7563795E-02,   4.5710377E-02
     +,   4.3943569E-02,   4.2262871E-02,   4.0670041E-02
     +,   3.9167631E-02,   3.7758190E-02,   3.6442969E-02
     +,   3.5221577E-02,   3.4091912E-02,   3.3050045E-02
     +,   3.2090392E-02,   3.1206174E-02,   3.0389940E-02
     +,   2.9633829E-02,   2.8930102E-02,   2.8271362E-02
     +,   2.7651049E-02,   2.7063366E-02,   2.6503535E-02
     +,   2.5967710E-02,   2.5453094E-02,   2.4957629E-02
     +,   2.4480071E-02,   2.4019748E-02,   2.3576427E-02
     +,   2.3150191E-02,   2.2741208E-02,   2.2349799E-02
     +,   2.1976177E-02,   2.1620430E-02,   2.1282459E-02
     +,   2.0961970E-02,   2.0658435E-02,   2.0371092E-02
     +,   2.0098943E-02,   1.9840844E-02,   1.9595455E-02
     +,   1.9361310E-02,   1.9136874E-02,   1.8920531E-02
     +,   1.8710664E-02,   1.8505642E-02,   1.8303882E-02
     +,   1.8103879E-02,   1.7904177E-02,   1.7703433E-02
     +,   1.7500397E-02,   1.7293958E-02,   1.7083088E-02
     +,   1.6866889E-02,   1.6644625E-02,   1.6415609E-02
     +,   1.6179327E-02,   1.5935345E-02,   1.5683370E-02
     +,   1.5423203E-02,   1.5154717E-02,   1.4877938E-02
     +,   1.4592958E-02,   1.4299959E-02,   1.3999197E-02
     +,   1.3691038E-02,   1.3375920E-02,   1.3054333E-02
     +,   1.2726830E-02,   1.2394057E-02,   1.2056675E-02
     +,   1.1715387E-02,   1.1370965E-02,   1.1024198E-02
     +,   1.0675883E-02,   1.0326817E-02,   9.9778222E-03
     +,   9.6297301E-03,   9.2833228E-03,   8.9393659E-03
     +,   8.5986201E-03,   8.2618175E-03,   7.9296203E-03
     +,   7.6026553E-03,   7.2815274E-03,   6.9667632E-03
     +,   6.6588419E-03,   6.3582039E-03,   6.0652397E-03
     +,   5.7802624E-03,   5.5035381E-03,   5.2352957E-03
     +,   4.9757194E-03,   4.7249245E-03,   4.4829841E-03
     +,   4.2499495E-03,   4.0258244E-03,   3.8105724E-03
     +,   3.6041171E-03,   3.4063738E-03,   3.2172168E-03
     +,   3.0364934E-03,   2.8640418E-03,   2.6996825E-03
     +,   2.5432094E-03,   2.3944045E-03,   2.2530507E-03
     +,   2.1189169E-03,   1.9917609E-03,   1.8713333E-03
     +,   1.7573916E-03,   1.6496893E-03,   1.5479741E-03
     +,   1.4519929E-03,   1.3615059E-03,   1.2762659E-03
     +,   1.1960305E-03,   1.1205667E-03,   1.0496472E-03
     +,   9.8304462E-04,   9.2053926E-04,   8.6192199E-04
     +,   8.0699002E-04,   7.5554423E-04,   7.0739217E-04
     +,   6.6235394E-04,   6.2025519E-04,   5.8092637E-04
     +,   5.4420612E-04,   5.0994358E-04,   4.7799092E-04
     +,   4.4820833E-04,   4.2046417E-04,   3.9463330E-04
     +,   3.7059546E-04,   3.4823621E-04,   3.2744894E-04
     +,   3.0813253E-04,   2.9018975E-04,   2.7352915E-04
     +,   2.5806559E-04,   2.4371692E-04,   2.3040708E-04
     +,   2.1806327E-04,   2.0661793E-04,   1.9600634E-04
     +,   1.8616889E-04,   1.7704828E-04,   1.6859196E-04
     +,   1.6074948E-04,   1.5347468E-04,   1.4672363E-04
     +,   1.4045522E-04,   1.3463177E-04,   1.2921730E-04
     +,   1.2417903E-04,   1.1948591E-04,   1.1510952E-04
     +,   1.1102308E-04,   1.0720231E-04,   1.0362422E-04
     +,   1.0026800E-04,   9.7114185E-05,   9.4145107E-05
     +,   9.1344220E-05,   8.8696681E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_ashz_hatt75_mass = Yx/12.05047872
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_ashz_hatt80_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.0164483E-03,   4.2340676E-03
     +,   4.4565820E-03,   4.6836887E-03,   4.9151271E-03
     +,   5.1507107E-03,   5.3903507E-03,   5.6340997E-03
     +,   5.8821738E-03,   6.1350167E-03,   6.3933153E-03
     +,   6.6580642E-03,   6.9306092E-03,   7.2126826E-03
     +,   7.5064637E-03,   7.8145973E-03,   8.1402324E-03
     +,   8.4870243E-03,   8.8591408E-03,   9.2612198E-03
     +,   9.6983360E-03,   1.0175891E-02,   1.0699505E-02
     +,   1.1274892E-02,   1.1907576E-02,   1.2602774E-02
     +,   1.3365111E-02,   1.4198303E-02,   1.5104963E-02
     +,   1.6086316E-02,   1.7142003E-02,   1.8269911E-02
     +,   1.9466138E-02,   2.0725043E-02,   2.2039423E-02
     +,   2.3400834E-02,   2.4800131E-02,   2.6227992E-02
     +,   2.7675888E-02,   2.9136626E-02,   3.0605583E-02
     +,   3.2081347E-02,   3.3566590E-02,   3.5068695E-02
     +,   3.6600199E-02,   3.8178910E-02,   3.9827891E-02
     +,   4.1574936E-02,   4.3452051E-02,   4.5494497E-02
     +,   4.7739793E-02,   5.0226476E-02,   5.2992724E-02
     +,   5.6075066E-02,   5.9506565E-02,   6.3316524E-02
     +,   6.7529671E-02,   7.2168350E-02,   7.7255756E-02
     +,   8.2821697E-02,   8.8910013E-02,   9.5583916E-02
     +,   0.1029275    ,   0.1110406    ,   0.1200236    
     +,   0.1299560    ,   0.1408762    ,   0.1527667    
     +,   0.1655571    ,   0.1791405    ,   0.1934084    
     +,   0.2082797    ,   0.2237208    ,   0.2397335    
     +,   0.2563122    ,   0.2733676    ,   0.2906442    
     +,   0.3076722    ,   0.3238160    ,   0.3384714    
     +,   0.3514376    ,   0.3634050    ,   0.3763329    
     +,   0.3934114    ,   0.4183469    ,   0.4540961    
     +,   0.5015590    ,   0.5590019    ,   0.6227443    
     +,   0.6890518    ,   0.7560040    ,   0.8235998    
     +,   0.8917754    ,   0.9577137    ,    1.014417    
     +,    1.053545    ,    1.074914    ,    1.094881    
     +,    1.137928    ,    1.213914    ,    1.309905    
     +,    1.408768    ,    1.504567    ,    1.593576    
     +,    1.666828    ,    1.721658    ,    1.765926    
     +,    1.808677    ,    1.856175    ,    1.900063    
     +,    1.912327    ,    1.882064    ,    1.833980    
     +,    1.780988    ,    1.698771    ,    1.568795    
     +,    1.407724    ,    1.247383    ,    1.108782    
     +,   0.9934340    ,   0.8902403    ,   0.7894505    
     +,   0.6906720    ,   0.5998271    ,   0.5218590    
     +,   0.4573582    ,   0.4040930    ,   0.3595773    
     +,   0.3220045    ,   0.2899767    ,   0.2621781    
     +,   0.2374330    ,   0.2148990    ,   0.1941518    
     +,   0.1750872    ,   0.1577585    ,   0.1422402    
     +,   0.1285558    ,   0.1166603    ,   0.1064487    
     +,   9.7770475E-02,   9.0444088E-02,   8.4271468E-02
     +,   7.9053581E-02,   7.4603803E-02,   7.0756264E-02
     +,   6.7370817E-02,   6.4333603E-02,   6.1554477E-02
     +,   5.8962777E-02,   5.6503788E-02,   5.4135405E-02
     +,   5.1825598E-02,   4.9550906E-02,   4.7295578E-02
     +,   4.5051452E-02,   4.2817131E-02,   4.0597472E-02
     +,   3.8402647E-02,   3.6247384E-02,   3.4148864E-02
     +,   3.2125585E-02,   3.0195745E-02,   2.8375939E-02
     +,   2.6679786E-02,   2.5117330E-02,   2.3694785E-02
     +,   2.2414317E-02,   2.1274222E-02,   2.0269565E-02
     +,   1.9392813E-02,   1.8634422E-02,   1.7983552E-02
     +,   1.7428733E-02,   1.6958466E-02,   1.6561549E-02
     +,   1.6227443E-02,   1.5946548E-02,   1.5710203E-02
     +,   1.5510779E-02,   1.5341617E-02,   1.5196974E-02
     +,   1.5071902E-02,   1.4962132E-02,   1.4863964E-02
     +,   1.4774146E-02,   1.4689785E-02,   1.4608252E-02
     +,   1.4527108E-02,   1.4444071E-02,   1.4356975E-02
     +,   1.4263732E-02,   1.4162339E-02,   1.4050877E-02
     +,   1.3927499E-02,   1.3790502E-02,   1.3638281E-02
     +,   1.3469441E-02,   1.3282724E-02,   1.3077115E-02
     +,   1.2851847E-02,   1.2606430E-02,   1.2340654E-02
     +,   1.2054599E-02,   1.1748700E-02,   1.1423660E-02
     +,   1.1080505E-02,   1.0720557E-02,   1.0345433E-02
     +,   9.9569531E-03,   9.5571550E-03,   9.1482708E-03
     +,   8.7326700E-03,   8.3127730E-03,   7.8910394E-03
     +,   7.4699512E-03,   7.0519424E-03,   6.6393260E-03
     +,   6.2342766E-03,   5.8388505E-03,   5.4548751E-03
     +,   5.0839568E-03,   4.7275033E-03,   4.3866779E-03
     +,   4.0623783E-03,   3.7552589E-03,   3.4657640E-03
     +,   3.1941123E-03,   2.9402932E-03,   2.7041121E-03
     +,   2.4852231E-03,   2.2831294E-03,   2.0971999E-03
     +,   1.9267050E-03,   1.7708555E-03,   1.6287877E-03
     +,   1.4996072E-03,   1.3824088E-03,   1.2762838E-03
     +,   1.1803316E-03,   1.0936754E-03,   1.0154784E-03
     +,   9.4494474E-04,   8.8131975E-04,   8.2390039E-04
     +,   7.7203981E-04,   7.2514394E-04,   6.8266806E-04
     +,   6.4411911E-04,   6.0905749E-04,   5.7708577E-04
     +,   5.4785045E-04,   5.2104000E-04,   4.9637939E-04
     +,   4.7362523E-04,   4.5256384E-04,   4.3301037E-04
     +,   4.1480246E-04,   3.9779802E-04,   3.8187322E-04
     +,   3.6692061E-04,   3.5284719E-04,   3.3957046E-04
     +,   3.2701832E-04,   3.1512874E-04,   3.0384606E-04
     +,   2.9312106E-04,   2.8291091E-04,   2.7317740E-04
     +,   2.6388577E-04,   2.5500494E-04,   2.4650732E-04
     +,   2.3836814E-04,   2.3056389E-04,   2.2307380E-04
     +,   2.1587906E-04,   2.0896173E-04,   2.0230612E-04
     +,   1.9589682E-04,   1.8972055E-04,   1.8376413E-04
     +,   1.7801613E-04,   1.7246512E-04,   1.6710132E-04
     +,   1.6191484E-04,   1.5689722E-04,   1.5204005E-04
     +,   1.4733554E-04,   1.4277680E-04,   1.3835699E-04
     +,   1.3407019E-04,   1.2991030E-04,   1.2587232E-04
     +,   1.2195095E-04,   1.1814183E-04,   1.1444034E-04
     +,   1.1084270E-04,   1.0734496E-04,   1.0394380E-04
     +,   1.0063576E-04,   9.7417986E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_ashz_hatt80_mass = Yx/14.3429724117647
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_ashz_hatt85_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  9.3244971E-04,   9.8028884E-04
     +,   1.0296964E-03,   1.0807010E-03,   1.1333392E-03
     +,   1.1876620E-03,   1.2437338E-03,   1.3016390E-03
     +,   1.3614827E-03,   1.4233993E-03,   1.4875509E-03
     +,   1.5541357E-03,   1.6233922E-03,   1.6956022E-03
     +,   1.7710977E-03,   1.8502639E-03,   1.9335432E-03
     +,   2.0214382E-03,   2.1145130E-03,   2.2133971E-03
     +,   2.3187764E-03,   2.4314011E-03,   2.5520660E-03
     +,   2.6816209E-03,   2.8209314E-03,   2.9708950E-03
     +,   3.1323985E-03,   3.3063057E-03,   3.4934329E-03
     +,   3.6945171E-03,   3.9101881E-03,   4.1409363E-03
     +,   4.3870797E-03,   4.6487297E-03,   4.9257698E-03
     +,   5.2178148E-03,   5.5242041E-03,   5.8439733E-03
     +,   6.1758733E-03,   6.5183272E-03,   6.8695000E-03
     +,   7.2272806E-03,   7.5893463E-03,   7.9532024E-03
     +,   8.3162477E-03,   8.6758733E-03,   9.0295179E-03
     +,   9.3747890E-03,   9.7095761E-03,   1.0032159E-02
     +,   1.0341318E-02,   1.0636489E-02,   1.0917854E-02
     +,   1.1186477E-02,   1.1444406E-02,   1.1694763E-02
     +,   1.1941829E-02,   1.2191048E-02,   1.2449072E-02
     +,   1.2723699E-02,   1.3023756E-02,   1.3358967E-02
     +,   1.3739663E-02,   1.4176528E-02,   1.4680199E-02
     +,   1.5260785E-02,   1.5927466E-02,   1.6687896E-02
     +,   1.7547891E-02,   1.8510835E-02,   1.9577693E-02
     +,   2.0746656E-02,   2.2013599E-02,   2.3372307E-02
     +,   2.4815610E-02,   2.6336523E-02,   2.7929949E-02
     +,   2.9595019E-02,   3.1338055E-02,   3.3175815E-02
     +,   3.5138916E-02,   3.7275743E-02,   3.9654449E-02
     +,   4.2364091E-02,   4.5511253E-02,   4.9213376E-02
     +,   5.3586051E-02,   5.8728721E-02,   6.4708628E-02
     +,   7.1553536E-02,   7.9255506E-02,   8.7790489E-02
     +,   9.7152375E-02,   0.1073886    ,   0.1186200    
     +,   0.1310277    ,   0.1448080    ,   0.1601021    
     +,   0.1769442    ,   0.1952590    ,   0.2149476    
     +,   0.2360310    ,   0.2587855    ,   0.2837312    
     +,   0.3114166    ,   0.3420735    ,   0.3754409    
     +,   0.4110756    ,   0.4490962    ,   0.4908975    
     +,   0.5394675    ,   0.5992666    ,   0.6744326    
     +,   0.7635481    ,   0.8550411    ,   0.9336484    
     +,   0.9963502    ,    1.057196    ,    1.133064    
     +,    1.232280    ,    1.350700    ,    1.461251    
     +,    1.534644    ,    1.586171    ,    1.659957    
     +,    1.784809    ,    1.945231    ,    2.078121    
     +,    2.144878    ,    2.170127    ,    2.203657    
     +,    2.256642    ,    2.290906    ,    2.268231    
     +,    2.155344    ,    1.969274    ,    1.796180    
     +,    1.675371    ,    1.565378    ,    1.424672    
     +,    1.253753    ,    1.074446    ,   0.9041594    
     +,   0.7549879    ,   0.6366078    ,   0.5505403    
     +,   0.4879793    ,   0.4367604    ,   0.3892901    
     +,   0.3440019    ,   0.3021573    ,   0.2650015    
     +,   0.2329573    ,   0.2058418    ,   0.1831572    
     +,   0.1642445    ,   0.1483841    ,   0.1348887    
     +,   0.1231759    ,   0.1128023    ,   0.1034589    
     +,   9.4946787E-02,   8.7141789E-02,   7.9962216E-02
     +,   7.3345944E-02,   6.7241162E-02,   6.1604731E-02
     +,   5.6403350E-02,   5.1614635E-02,   4.7226217E-02
     +,   4.3232728E-02,   3.9631050E-02,   3.6416356E-02
     +,   3.3579715E-02,   3.1107396E-02,   2.8980423E-02
     +,   2.7175814E-02,   2.5667896E-02,   2.4429277E-02
     +,   2.3431484E-02,   2.2645773E-02,   2.2043351E-02
     +,   2.1595499E-02,   2.1273764E-02,   2.1050273E-02
     +,   2.0897942E-02,   2.0790929E-02,   2.0705052E-02
     +,   2.0618249E-02,   2.0510990E-02,   2.0366641E-02
     +,   2.0171680E-02,   1.9915884E-02,   1.9592330E-02
     +,   1.9197315E-02,   1.8730147E-02,   1.8192904E-02
     +,   1.7590063E-02,   1.6928118E-02,   1.6215088E-02
     +,   1.5460185E-02,   1.4673353E-02,   1.3864768E-02
     +,   1.3044532E-02,   1.2222433E-02,   1.1407511E-02
     +,   1.0607935E-02,   9.8308874E-03,   9.0824254E-03
     +,   8.3673997E-03,   7.6895072E-03,   7.0513743E-03
     +,   6.4546014E-03,   5.8998163E-03,   5.3868527E-03
     +,   4.9148938E-03,   4.4825650E-03,   4.0880404E-03
     +,   3.7291842E-03,   3.4036890E-03,   3.1090986E-03
     +,   2.8429215E-03,   2.6027106E-03,   2.3860917E-03
     +,   2.1907897E-03,   2.0146691E-03,   1.8557617E-03
     +,   1.7122591E-03,   1.5825088E-03,   1.4650213E-03
     +,   1.3584690E-03,   1.2616671E-03,   1.1735591E-03
     +,   1.0932115E-03,   1.0198072E-03,   9.5262082E-04
     +,   8.9101336E-04,   8.3442725E-04,   7.8237074E-04
     +,   7.3440716E-04,   6.9015083E-04,   6.4926303E-04
     +,   6.1144296E-04,   5.7641964E-04,   5.4395146E-04
     +,   5.1382347E-04,   4.8584223E-04,   4.5983124E-04
     +,   4.3563015E-04,   4.1309599E-04,   3.9209580E-04
     +,   3.7250822E-04,   3.5422322E-04,   3.3713965E-04
     +,   3.2116345E-04,   3.0620772E-04,   2.9219358E-04
     +,   2.7904802E-04,   2.6670282E-04,   2.5509496E-04
     +,   2.4416714E-04,   2.3386636E-04,   2.2414303E-04
     +,   2.1495167E-04,   2.0625125E-04,   1.9800321E-04
     +,   1.9017220E-04,   1.8272636E-04,   1.7563655E-04
     +,   1.6887572E-04,   1.6241928E-04,   1.5624521E-04
     +,   1.5033352E-04,   1.4466578E-04,   1.3922527E-04
     +,   1.3399743E-04,   1.2896839E-04,   1.2412631E-04
     +,   1.1945996E-04,   1.1495972E-04,   1.1061646E-04
     +,   1.0642239E-04,   1.0237005E-04,   9.8453187E-05
     +,   9.4665622E-05,   9.1002265E-05,   8.7458167E-05
     +,   8.4028776E-05,   8.0710262E-05,   7.7498698E-05
     +,   7.4390889E-05,   7.1383423E-05,   6.8473571E-05
     +,   6.5658365E-05,   6.2935389E-05,   6.0301976E-05
     +,   5.7755984E-05,   5.5294993E-05,   5.2917039E-05
     +,   5.0619867E-05,   4.8401645E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_ashz_hatt85_mass = Yx/14.5533730588235
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_ashz_hatt90_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.2914937E-03,   1.3284638E-03
     +,   1.3655380E-03,   1.4027166E-03,   1.4400088E-03
     +,   1.4774344E-03,   1.5150233E-03,   1.5528169E-03
     +,   1.5908678E-03,   1.6292430E-03,   1.6680205E-03
     +,   1.7072911E-03,   1.7471608E-03,   1.7877460E-03
     +,   1.8291777E-03,   1.8715985E-03,   1.9151624E-03
     +,   1.9600340E-03,   2.0063873E-03,   2.0544042E-03
     +,   2.1042733E-03,   2.1561855E-03,   2.2103356E-03
     +,   2.2669199E-03,   2.3261262E-03,   2.3881439E-03
     +,   2.4531481E-03,   2.5213067E-03,   2.5927699E-03
     +,   2.6676720E-03,   2.7461273E-03,   2.8282243E-03
     +,   2.9140273E-03,   3.0035721E-03,   3.0968613E-03
     +,   3.1938665E-03,   3.2945229E-03,   3.3987311E-03
     +,   3.5063610E-03,   3.6172341E-03,   3.7311506E-03
     +,   3.8478698E-03,   3.9671189E-03,   4.0885983E-03
     +,   4.2119827E-03,   4.3369243E-03,   4.4630561E-03
     +,   4.5900038E-03,   4.7173789E-03,   4.8447996E-03
     +,   4.9718814E-03,   5.0982563E-03,   5.2235681E-03
     +,   5.3474889E-03,   5.4697101E-03,   5.5899681E-03
     +,   5.7080337E-03,   5.8237175E-03,   5.9368843E-03
     +,   6.0474481E-03,   6.1553782E-03,   6.2607052E-03
     +,   6.3635129E-03,   6.4639552E-03,   6.5622535E-03
     +,   6.6586835E-03,   6.7536025E-03,   6.8474244E-03
     +,   6.9406428E-03,   7.0338165E-03,   7.1275788E-03
     +,   7.2226264E-03,   7.3197372E-03,   7.4197450E-03
     +,   7.5235483E-03,   7.6321149E-03,   7.7464492E-03
     +,   7.8675849E-03,   7.9966029E-03,   8.1345811E-03
     +,   8.2825720E-03,   8.4416000E-03,   8.6126169E-03
     +,   8.7964842E-03,   8.9939237E-03,   9.2055127E-03
     +,   9.4316266E-03,   9.6724378E-03,   9.9278651E-03
     +,   1.0197593E-02,   1.0481060E-02,   1.0777453E-02
     +,   1.1085728E-02,   1.1404713E-02,   1.1733132E-02
     +,   1.2069676E-02,   1.2413196E-02,   1.2762796E-02
     +,   1.3118106E-02,   1.3479448E-02,   1.3848218E-02
     +,   1.4227176E-02,   1.4620905E-02,   1.5036215E-02
     +,   1.5482694E-02,   1.5973190E-02,   1.6524214E-02
     +,   1.7156359E-02,   1.7894592E-02,   1.8768193E-02
     +,   1.9810431E-02,   2.1058176E-02,   2.2550629E-02
     +,   2.4328388E-02,   2.6431369E-02,   2.8897509E-02
     +,   3.1760532E-02,   3.5049137E-02,   3.8785756E-02
     +,   4.2987913E-02,   4.7670435E-02,   5.2849133E-02
     +,   5.8546562E-02,   6.4798616E-02,   7.1661040E-02
     +,   7.9215743E-02,   8.7583557E-02,   9.6939489E-02
     +,   0.1075408    ,   0.1197512    ,   0.1340488    
     +,   0.1509746    ,   0.1710078    ,   0.1943780    
     +,   0.2209232    ,   0.2501279    ,   0.2814638    
     +,   0.3150028    ,   0.3520085    ,   0.3950872    
     +,   0.4477259    ,   0.5135303    ,   0.5950479    
     +,   0.6916503    ,   0.7985967    ,   0.9102385    
     +,    1.022371    ,    1.131919    ,    1.243486    
     +,    1.366463    ,    1.495313    ,    1.624121    
     +,    1.775527    ,    1.978258    ,    2.209530    
     +,    2.419579    ,    2.604158    ,    2.742726    
     +,    2.837355    ,    2.898945    ,    2.871415    
     +,    2.737136    ,    2.523490    ,    2.307292    
     +,    2.106497    ,    1.845677    ,    1.533597    
     +,    1.252276    ,    1.038641    ,   0.8749902    
     +,   0.7327307    ,   0.5999049    ,   0.4822444    
     +,   0.3895700    ,   0.3243594    ,   0.2808459    
     +,   0.2509203    ,   0.2290234    ,   0.2128088    
     +,   0.2014813    ,   0.1943758    ,   0.1905153    
     +,   0.1887255    ,   0.1878549    ,   0.1869138    
     +,   0.1851278    ,   0.1819448    ,   0.1770291    
     +,   0.1702595    ,   0.1617222    ,   0.1516877    
     +,   0.1405676    ,   0.1288547    ,   0.1170544    
     +,   0.1056213    ,   9.4913118E-02,   8.5164577E-02
     +,   7.6484412E-02,   6.8870358E-02,   6.2238868E-02
     +,   5.6459092E-02,   5.1383227E-02,   4.6870168E-02
     +,   4.2800523E-02,   3.9082903E-02,   3.5652429E-02
     +,   3.2466874E-02,   2.9500749E-02,   2.6739383E-02
     +,   2.4173915E-02,   2.1798078E-02,   1.9606261E-02
     +,   1.7592121E-02,   1.5748134E-02,   1.4065778E-02
     +,   1.2535860E-02,   1.1148774E-02,   9.8947193E-03
     +,   8.7640556E-03,   7.7475649E-03,   6.8363384E-03
     +,   6.0219048E-03,   5.2962839E-03,   4.6518887E-03
     +,   4.0814742E-03,   3.5781641E-03,   3.1354683E-03
     +,   2.7472463E-03,   2.4076912E-03,   2.1113819E-03
     +,   1.8533096E-03,   1.6288649E-03,   1.4338342E-03
     +,   1.2644152E-03,   1.1172248E-03,   9.8924618E-04
     +,   8.7782863E-04,   7.8066700E-04,   6.9576059E-04
     +,   6.2138028E-04,   5.5604347E-04,   4.9848808E-04
     +,   4.4763763E-04,   4.0257387E-04,   3.6251702E-04
     +,   3.2680779E-04,   2.9488560E-04,   2.6627176E-04
     +,   2.4055903E-04,   2.1740211E-04,   1.9650342E-04
     +,   1.7760796E-04,   1.6049756E-04,   1.4498386E-04
     +,   1.3090267E-04,   1.1811119E-04,   1.0648557E-04
     +,   9.5916876E-05,   8.6308304E-05,   7.7573990E-05
     +,   6.9637870E-05,   6.2431602E-05,   5.5893022E-05
     +,   4.9965813E-05,   4.4599154E-05,   3.9745999E-05
     +,   3.5363108E-05,   3.1410982E-05,   2.7853039E-05
     +,   2.4655192E-05,   2.1785932E-05,   1.9216204E-05
     +,   1.6919079E-05,   1.4869459E-05,   1.3044144E-05
     +,   1.1421872E-05,   9.9828139E-06,   8.7089120E-06
     +,   7.5833968E-06,   6.5910531E-06,   5.7178386E-06
     +,   4.9510577E-06,   4.2790562E-06,   3.6913520E-06
     +,   3.1783784E-06,   2.7315677E-06,   2.3431587E-06
     +,   2.0061909E-06,   1.7144584E-06,   1.4623805E-06
     +,   1.2450198E-06,   1.0579582E-06,   8.9730736E-07
     +,   7.5960418E-07,   6.4181620E-07,   5.4125798E-07
     +,   4.5558724E-07,   3.8274132E-07,   3.2092862E-07
     +,   2.6858015E-07,   2.2433876E-07
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_ashz_hatt90_mass = Yx/14.4223688823529
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_ashz_hatt95_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.0910148E-03,   2.2088811E-03
     +,   2.3336143E-03,   2.4654274E-03,   2.6044992E-03
     +,   2.7509732E-03,   2.9049474E-03,   3.0664715E-03
     +,   3.2355383E-03,   3.4120928E-03,   3.5960067E-03
     +,   3.7870873E-03,   3.9850771E-03,   4.1896417E-03
     +,   4.4003809E-03,   4.6168165E-03,   4.8384028E-03
     +,   5.0645210E-03,   5.2944906E-03,   5.5275671E-03
     +,   5.7629510E-03,   5.9997924E-03,   6.2371939E-03
     +,   6.4742486E-03,   6.7099920E-03,   6.9434764E-03
     +,   7.1737384E-03,   7.3998249E-03,   7.6208077E-03
     +,   7.8357905E-03,   8.0439234E-03,   8.2444064E-03
     +,   8.4365103E-03,   8.6195935E-03,   8.7930830E-03
     +,   8.9565236E-03,   9.1095483E-03,   9.2519047E-03
     +,   9.3834726E-03,   9.5042447E-03,   9.6143484E-03
     +,   9.7140474E-03,   9.8037412E-03,   9.8839812E-03
     +,   9.9554639E-03,   1.0019032E-02,   1.0075694E-02
     +,   1.0126616E-02,   1.0173139E-02,   1.0216788E-02
     +,   1.0259258E-02,   1.0302441E-02,   1.0348449E-02
     +,   1.0399582E-02,   1.0458379E-02,   1.0527600E-02
     +,   1.0610225E-02,   1.0709478E-02,   1.0828804E-02
     +,   1.0971845E-02,   1.1142427E-02,   1.1344530E-02
     +,   1.1582229E-02,   1.1859632E-02,   1.2180823E-02
     +,   1.2549706E-02,   1.2969980E-02,   1.3444911E-02
     +,   1.3977327E-02,   1.4569305E-02,   1.5222182E-02
     +,   1.5936268E-02,   1.6710831E-02,   1.7543813E-02
     +,   1.8431900E-02,   1.9370371E-02,   2.0353004E-02
     +,   2.1372149E-02,   2.2418866E-02,   2.3483001E-02
     +,   2.4553197E-02,   2.5617426E-02,   2.6662990E-02
     +,   2.7677108E-02,   2.8646978E-02,   2.9560413E-02
     +,   3.0406035E-02,   3.1173745E-02,   3.1854939E-02
     +,   3.2442968E-02,   3.2933213E-02,   3.3323325E-02
     +,   3.3613291E-02,   3.3805452E-02,   3.3904474E-02
     +,   3.3917107E-02,   3.3852044E-02,   3.3719644E-02
     +,   3.3531636E-02,   3.3300683E-02,   3.3040121E-02
     +,   3.2763574E-02,   3.2484602E-02,   3.2216366E-02
     +,   3.1971488E-02,   3.1761605E-02,   3.1597409E-02
     +,   3.1488396E-02,   3.1442769E-02,   3.1467520E-02
     +,   3.1568311E-02,   3.1749588E-02,   3.2014672E-02
     +,   3.2365773E-02,   3.2804098E-02,   3.3330124E-02
     +,   3.3943545E-02,   3.4643512E-02,   3.5428755E-02
     +,   3.6297791E-02,   3.7248887E-02,   3.8280297E-02
     +,   3.9390136E-02,   4.0576670E-02,   4.1837953E-02
     +,   4.3171663E-02,   4.4575166E-02,   4.6044782E-02
     +,   4.7575861E-02,   4.9162079E-02,   5.0795458E-02
     +,   5.2466013E-02,   5.4162055E-02,   5.5870287E-02
     +,   5.7576802E-02,   5.9267920E-02,   6.0931534E-02
     +,   6.2558793E-02,   6.4145729E-02,   6.5694854E-02
     +,   6.7216285E-02,   6.8728365E-02,   7.0258178E-02
     +,   7.1840368E-02,   7.3515460E-02,   7.5327553E-02
     +,   7.7321596E-02,   7.9539046E-02,   8.2015090E-02
     +,   8.4774472E-02,   8.7828383E-02,   9.1171533E-02
     +,   9.4779894E-02,   9.8609477E-02,   0.1025959    
     +,   0.1066551    ,   0.1106861    ,   0.1145758    
     +,   0.1182055    ,   0.1214591    ,   0.1242340    
     +,   0.1264508    ,   0.1280639    ,   0.1290676    
     +,   0.1295010    ,   0.1294457    ,   0.1290209    
     +,   0.1283734    ,   0.1276670    ,   0.1270720    
     +,   0.1267603    ,   0.1269045    ,   0.1276845    
     +,   0.1292981    ,   0.1319676    ,   0.1359400    
     +,   0.1414750    ,   0.1488231    ,   0.1582160    
     +,   0.1698907    ,   0.1841772    ,   0.2016366    
     +,   0.2231689    ,   0.2499285    ,   0.2828801    
     +,   0.3220790    ,   0.3662151    ,   0.4133154    
     +,   0.4631081    ,   0.5201020    ,   0.5946194    
     +,   0.6990736    ,   0.8408177    ,    1.018707    
     +,    1.230661    ,    1.488347    ,    1.818731    
     +,    2.229849    ,    2.661705    ,    3.002264    
     +,    3.177101    ,    3.196941    ,    3.115863    
     +,    2.967458    ,    2.754713    ,    2.483860    
     +,    2.171189    ,    1.837520    ,    1.512816    
     +,    1.223407    ,   0.9792682    ,   0.7790141    
     +,   0.6163259    ,   0.4831384    ,   0.3730468    
     +,   0.2827080    ,   0.2105230    ,   0.1548913    
     +,   0.1134956    ,   8.3493792E-02,   6.2009696E-02
     +,   4.6558753E-02,   3.5255246E-02,   2.6810745E-02
     +,   2.0402839E-02,   1.5510691E-02,   1.1783787E-02
     +,   8.9633344E-03,   6.8452517E-03,   5.2653467E-03
     +,   4.0925518E-03,   3.2239379E-03,   2.5801563E-03
     +,   2.1010987E-03,   1.7419175E-03,   1.4695184E-03
     +,   1.2598117E-03,   1.0954619E-03,   9.6410012E-04
     +,   8.5695944E-04,   7.6786458E-04,   6.9247460E-04
     +,   6.2772731E-04,   5.7144283E-04,   5.2205293E-04
     +,   4.7841002E-04,   4.3965099E-04,   4.0510495E-04
     +,   3.7423585E-04,   3.4660459E-04,   3.2183688E-04
     +,   2.9960964E-04,   2.7964069E-04,   2.6167999E-04
     +,   2.4550347E-04,   2.3091107E-04,   2.1772446E-04
     +,   2.0578408E-04,   1.9494603E-04,   1.8508182E-04
     +,   1.7607698E-04,   1.6782914E-04,   1.6024642E-04
     +,   1.5324683E-04,   1.4675818E-04,   1.4071575E-04
     +,   1.3506242E-04,   1.2974834E-04,   1.2472982E-04
     +,   1.1996867E-04,   1.1543190E-04,   1.1109163E-04
     +,   1.0692416E-04,   1.0290936E-04,   9.9030498E-05
     +,   9.5274219E-05,   9.1629227E-05,   8.8086956E-05
     +,   8.4640254E-05,   8.1284008E-05,   7.8013996E-05
     +,   7.4827512E-05,   7.1722243E-05,   6.8697009E-05
     +,   6.5750726E-05,   6.2883053E-05,   6.0093658E-05
     +,   5.7382360E-05,   5.4749351E-05,   5.2194508E-05
     +,   4.9718004E-05,   4.7319641E-05,   4.4999451E-05
     +,   4.2757070E-05,   4.0592295E-05,   3.8504510E-05
     +,   3.6493260E-05,   3.4557670E-05,   3.2697018E-05
     +,   3.0910196E-05,   2.9196208E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_ashz_hatt95_mass = Yx/12.86842116
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_ashz_htt100_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  5.2737969E-04,   5.3703325E-04
     +,   5.4686493E-04,   5.5688544E-04,   5.6710583E-04
     +,   5.7753763E-04,   5.8819266E-04,   5.9908355E-04
     +,   6.1022281E-04,   6.2162400E-04,   6.3330051E-04
     +,   6.4526638E-04,   6.5753568E-04,   6.7012291E-04
     +,   6.8304304E-04,   6.9631089E-04,   7.0994190E-04
     +,   7.2395115E-04,   7.3835452E-04,   7.5316732E-04
     +,   7.6840568E-04,   7.8408542E-04,   8.0022204E-04
     +,   8.1683235E-04,   8.3393126E-04,   8.5153565E-04
     +,   8.6966110E-04,   8.8832388E-04,   9.0753974E-04
     +,   9.2732487E-04,   9.4769540E-04,   9.6866750E-04
     +,   9.9025783E-04,   1.0124826E-03,   1.0353591E-03
     +,   1.0589049E-03,   1.0831375E-03,   1.1080758E-03
     +,   1.1337408E-03,   1.1601520E-03,   1.1873334E-03
     +,   1.2153091E-03,   1.2441064E-03,   1.2737546E-03
     +,   1.3042876E-03,   1.3357416E-03,   1.3681588E-03
     +,   1.4015861E-03,   1.4360758E-03,   1.4716879E-03
     +,   1.5084895E-03,   1.5465566E-03,   1.5859734E-03
     +,   1.6268380E-03,   1.6692540E-03,   1.7133424E-03
     +,   1.7592353E-03,   1.8070776E-03,   1.8570302E-03
     +,   1.9092694E-03,   1.9639863E-03,   2.0213905E-03
     +,   2.0817029E-03,   2.1451691E-03,   2.2120499E-03
     +,   2.2826188E-03,   2.3571751E-03,   2.4360262E-03
     +,   2.5195100E-03,   2.6079689E-03,   2.7017770E-03
     +,   2.8013142E-03,   2.9069930E-03,   3.0192318E-03
     +,   3.1384774E-03,   3.2651997E-03,   3.3998780E-03
     +,   3.5430135E-03,   3.6951306E-03,   3.8567744E-03
     +,   4.0284898E-03,   4.2108498E-03,   4.4044103E-03
     +,   4.6097529E-03,   4.8274137E-03,   5.0579407E-03
     +,   5.3018080E-03,   5.5594794E-03,   5.8313003E-03
     +,   6.1175651E-03,   6.4184503E-03,   6.7339963E-03
     +,   7.0640813E-03,   7.4084415E-03,   7.7666407E-03
     +,   8.1380242E-03,   8.5217869E-03,   8.9169061E-03
     +,   9.3222503E-03,   9.7364932E-03,   1.0158292E-02
     +,   1.0586214E-02,   1.1018916E-02,   1.1455134E-02
     +,   1.1893846E-02,   1.2334362E-02,   1.2776385E-02
     +,   1.3220145E-02,   1.3666515E-02,   1.4117106E-02
     +,   1.4574222E-02,   1.5041081E-02,   1.5521604E-02
     +,   1.6020583E-02,   1.6543405E-02,   1.7096128E-02
     +,   1.7685106E-02,   1.8316966E-02,   1.8998250E-02
     +,   1.9735318E-02,   2.0534093E-02,   2.1399807E-02
     +,   2.2336990E-02,   2.3349488E-02,   2.4440460E-02
     +,   2.5612477E-02,   2.6868029E-02,   2.8209561E-02
     +,   2.9640233E-02,   3.1163847E-02,   3.2785777E-02
     +,   3.4512557E-02,   3.6352493E-02,   3.8315121E-02
     +,   4.0411077E-02,   4.2651415E-02,   4.5046601E-02
     +,   4.7605384E-02,   5.0333798E-02,   5.3233575E-02
     +,   5.6300640E-02,   5.9523944E-02,   6.2884584E-02
     +,   6.6355132E-02,   6.9899395E-02,   7.3473580E-02
     +,   7.7027760E-02,   8.0508351E-02,   8.3861500E-02
     +,   8.7037362E-02,   8.9993969E-02,   9.2701085E-02
     +,   9.5143482E-02,   9.7322762E-02,   9.9257298E-02
     +,   0.1009807    ,   0.1025381    ,   0.1039821    
     +,   0.1053677    ,   0.1067468    ,   0.1081653    
     +,   0.1096600    ,   0.1112580    ,   0.1129759    
     +,   0.1148212    ,   0.1167919    ,   0.1188765    
     +,   0.1210553    ,   0.1233026    ,   0.1255928    
     +,   0.1279104    ,   0.1302668    ,   0.1327195    
     +,   0.1353942    ,   0.1385009    ,   0.1423429    
     +,   0.1473068    ,   0.1538359    ,   0.1623839    
     +,   0.1733608    ,   0.1870765    ,   0.2037052    
     +,   0.2232848    ,   0.2457758    ,   0.2711491    
     +,   0.2994351    ,   0.3306716    ,   0.3648039    
     +,   0.4017293    ,   0.4415593    ,   0.4847833    
     +,   0.5319700    ,   0.5833309    ,   0.6387699    
     +,   0.6979352    ,   0.7592369    ,   0.8190413    
     +,   0.8739648    ,   0.9252576    ,   0.9794254    
     +,    1.044080    ,    1.127284    ,    1.239590    
     +,    1.381406    ,    1.525535    ,    1.637276    
     +,    1.717438    ,    1.801778    ,    1.914591    
     +,    2.038048    ,    2.124427    ,    2.140418    
     +,    2.095603    ,    1.999262    ,    1.830345    
     +,    1.588040    ,    1.314971    ,    1.054927    
     +,   0.8249931    ,   0.6273915    ,   0.4644285    
     +,   0.3383704    ,   0.2467179    ,   0.1822765    
     +,   0.1367283    ,   0.1034872    ,   7.8388125E-02
     +,   5.9099637E-02,   4.4312704E-02,   3.3161722E-02
     +,   2.4936117E-02,   1.8992053E-02,   1.4755153E-02
     +,   1.1742256E-02,   9.5728803E-03,   7.9660397E-03
     +,   6.7275004E-03,   5.7312991E-03,   4.9004359E-03
     +,   4.1901139E-03,   3.5750044E-03,   3.0405081E-03
     +,   2.5772762E-03,   2.1781684E-03,   1.8368223E-03
     +,   1.5470904E-03,   1.3028998E-03,   1.0983314E-03
     +,   9.2778489E-04,   7.8612013E-04,   6.6870690E-04
     +,   5.7148380E-04,   4.9095694E-04,   4.2415856E-04
     +,   3.6859509E-04,   3.2219547E-04,   2.8325454E-04
     +,   2.5037379E-04,   2.2241115E-04,   1.9844064E-04
     +,   1.7771692E-04,   1.5964176E-04,   1.4373707E-04
     +,   1.2962408E-04,   1.1700558E-04,   1.0564743E-04
     +,   9.5366784E-05,   8.6021544E-05,   7.7500634E-05
     +,   6.9715912E-05,   6.2597072E-05,   5.6087283E-05
     +,   5.0139108E-05,   4.4711378E-05,   3.9767729E-05
     +,   3.5275549E-05,   3.1203919E-05,   2.7524133E-05
     +,   2.4208237E-05,   2.1229807E-05,   1.8562945E-05
     +,   1.6183069E-05,   1.4066222E-05,   1.2189789E-05
     +,   1.0531959E-05,   9.0723179E-06,   7.7914683E-06
     +,   6.6712828E-06,   5.6949657E-06,   4.8468578E-06
     +,   4.1126395E-06,   3.4790996E-06,   2.9342964E-06
     +,   2.4673277E-06,   2.0684267E-06,   1.7287770E-06
     +,   1.4405501E-06,   1.1967493E-06,   9.9121610E-07
     +,   8.1850055E-07,   6.7384531E-07
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_ashz_htt100_mass = Yx/11.3543434285714
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_ashz_htt105_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.3246930E-04,   3.3959432E-04
     +,   3.4692587E-04,   3.5447866E-04,   3.6226859E-04
     +,   3.7031271E-04,   3.7862902E-04,   3.8723694E-04
     +,   3.9615677E-04,   4.0541060E-04,   4.1502115E-04
     +,   4.2501278E-04,   4.3541091E-04,   4.4624231E-04
     +,   4.5753506E-04,   4.6931836E-04,   4.8162273E-04
     +,   4.9447984E-04,   5.0792255E-04,   5.2198465E-04
     +,   5.3670112E-04,   5.5210793E-04,   5.6824146E-04
     +,   5.8514019E-04,   6.0284138E-04,   6.2138453E-04
     +,   6.4080872E-04,   6.6115364E-04,   6.8245904E-04
     +,   7.0476497E-04,   7.2811136E-04,   7.5253792E-04
     +,   7.7808427E-04,   8.0478896E-04,   8.3269086E-04
     +,   8.6182752E-04,   8.9223642E-04,   9.2395319E-04
     +,   9.5701503E-04,   9.9145493E-04,   1.0273085E-03
     +,   1.0646092E-03,   1.1033898E-03,   1.1436845E-03
     +,   1.1855263E-03,   1.2289488E-03,   1.2739885E-03
     +,   1.3206823E-03,   1.3690694E-03,   1.4191942E-03
     +,   1.4711038E-03,   1.5248524E-03,   1.5804993E-03
     +,   1.6381171E-03,   1.6977811E-03,   1.7595850E-03
     +,   1.8236336E-03,   1.8900465E-03,   1.9589642E-03
     +,   2.0305438E-03,   2.1049660E-03,   2.1824378E-03
     +,   2.2631863E-03,   2.3474724E-03,   2.4355880E-03
     +,   2.5278463E-03,   2.6246060E-03,   2.7262424E-03
     +,   2.8331794E-03,   2.9458539E-03,   3.0647491E-03
     +,   3.1903600E-03,   3.3232204E-03,   3.4638653E-03
     +,   3.6128622E-03,   3.7707847E-03,   3.9382027E-03
     +,   4.1156807E-03,   4.3037892E-03,   4.5030806E-03
     +,   4.7140736E-03,   4.9372851E-03,   5.1731830E-03
     +,   5.4222336E-03,   5.6848517E-03,   5.9614624E-03
     +,   6.2524462E-03,   6.5582260E-03,   6.8792012E-03
     +,   7.2158338E-03,   7.5686527E-03,   7.9382481E-03
     +,   8.3253169E-03,   8.7307282E-03,   9.1555100E-03
     +,   9.6008442E-03,   1.0068179E-02,   1.0559121E-02
     +,   1.1075571E-02,   1.1619586E-02,   1.2193491E-02
     +,   1.2799735E-02,   1.3440991E-02,   1.4119953E-02
     +,   1.4839453E-02,   1.5602369E-02,   1.6411491E-02
     +,   1.7269593E-02,   1.8179450E-02,   1.9143822E-02
     +,   2.0165369E-02,   2.1246949E-02,   2.2391472E-02
     +,   2.3602230E-02,   2.4882736E-02,   2.6237261E-02
     +,   2.7670458E-02,   2.9187912E-02,   3.0795712E-02
     +,   3.2500740E-02,   3.4310278E-02,   3.6231574E-02
     +,   3.8271293E-02,   4.0435147E-02,   4.2726811E-02
     +,   4.5146994E-02,   4.7693282E-02,   5.0359175E-02
     +,   5.3134792E-02,   5.6006875E-02,   5.8960989E-02
     +,   6.1982591E-02,   6.5060355E-02,   6.8187304E-02
     +,   7.1363881E-02,   7.4598007E-02,   7.7904850E-02
     +,   8.1305005E-02,   8.4821068E-02,   8.8474028E-02
     +,   9.2278153E-02,   9.6238241E-02,   0.1003475    
     +,   0.1045877    ,   0.1089301    ,   0.1133392    
     +,   0.1177764    ,   0.1222003    ,   0.1265687    
     +,   0.1308367    ,   0.1349536    ,   0.1388610    
     +,   0.1424933    ,   0.1457840    ,   0.1486740    
     +,   0.1511243    ,   0.1531253    ,   0.1547005    
     +,   0.1559009    ,   0.1567879    ,   0.1574136    
     +,   0.1578000    ,   0.1579285    ,   0.1577436    
     +,   0.1571721    ,   0.1561529    ,   0.1546698    
     +,   0.1527769    ,   0.1506129    ,   0.1483973    
     +,   0.1464173    ,   0.1450048    ,   0.1445164    
     +,   0.1453130    ,   0.1477447    ,   0.1521333    
     +,   0.1587481    ,   0.1677687    ,   0.1792342    
     +,   0.1929975    ,   0.2087053    ,   0.2258418    
     +,   0.2438511    ,   0.2623121    ,   0.2810948    
     +,   0.3004238    ,   0.3208216    ,   0.3429986    
     +,   0.3678048    ,   0.3963020    ,   0.4298092    
     +,   0.4695736    ,   0.5159672    ,   0.5677204    
     +,   0.6218952    ,   0.6747229    ,   0.7229320    
     +,   0.7653192    ,   0.8038049    ,   0.8418435    
     +,   0.8800015    ,   0.9139398    ,   0.9395278    
     +,   0.9591945    ,   0.9794937    ,    1.002986    
     +,    1.027178    ,    1.051161    ,    1.077480    
     +,    1.104962    ,    1.122854    ,    1.115570    
     +,    1.074415    ,    1.004071    ,   0.9174755    
     +,   0.8253985    ,   0.7313954    ,   0.6349916    
     +,   0.5371310    ,   0.4421072    ,   0.3556119    
     +,   0.2818818    ,   0.2222484    ,   0.1755087    
     +,   0.1392413    ,   0.1109871    ,   8.8788643E-02
     +,   7.1212307E-02,   5.7193816E-02,   4.5919660E-02
     +,   3.6774658E-02,   2.9312149E-02,   2.3218153E-02
     +,   1.8268067E-02,   1.4288172E-02,   1.1129276E-02
     +,   8.6560762E-03,   6.7449608E-03,   5.2852561E-03
     +,   4.1809422E-03,   3.3514430E-03,   2.7309901E-03
     +,   2.2670676E-03,   1.9185542E-03,   1.6538705E-03
     +,   1.4492201E-03,   1.2870068E-03,   1.1544976E-03
     +,   1.0427149E-03,   9.4551145E-04,   8.5879199E-04
     +,   7.7992911E-04,   7.0730242E-04,   6.3995062E-04
     +,   5.7731854E-04,   5.1909208E-04,   4.6508783E-04
     +,   4.1517752E-04,   3.6924347E-04,   3.2716006E-04
     +,   2.8878657E-04,   2.5396145E-04,   2.2250225E-04
     +,   1.9421235E-04,   1.6888797E-04,   1.4631699E-04
     +,   1.2628641E-04,   1.0858686E-04,   9.3013812E-05
     +,   7.9369158E-05,   6.7464149E-05,   5.7121226E-05
     +,   4.8173802E-05,   4.0466370E-05,   3.3855446E-05
     +,   2.8209963E-05,   2.3409713E-05,   1.9346393E-05
     +,   1.5921929E-05,   1.3048985E-05,   1.0649453E-05
     +,   8.6545324E-06,   7.0034562E-06,   5.6433032E-06
     +,   4.5278889E-06,   3.6174486E-06,   2.8777201E-06
     +,   2.2794538E-06,   1.7978640E-06,   1.4119623E-06
     +,   1.1041832E-06,   8.5982646E-07,   6.6672641E-07
     +,   5.1482147E-07,   3.9587661E-07,   3.0315681E-07
     +,   2.3121217E-07,   1.7563448E-07,   1.3289493E-07
     +,   1.0017128E-07,   7.5227689E-08
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_ashz_htt105_mass = Yx/8.64120778723404
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_ashz_htt107_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.2052081E-04,   4.3954360E-04
     +,   4.5905579E-04,   4.7904791E-04,   4.9950916E-04
     +,   5.2042730E-04,   5.4178888E-04,   5.6357897E-04
     +,   5.8578118E-04,   6.0837885E-04,   6.3135300E-04
     +,   6.5468426E-04,   6.7835191E-04,   7.0233434E-04
     +,   7.2660943E-04,   7.5115386E-04,   7.7594450E-04
     +,   8.0095744E-04,   8.2616881E-04,   8.5155462E-04
     +,   8.7709172E-04,   9.0275705E-04,   9.2852855E-04
     +,   9.5438689E-04,   9.8031177E-04,   1.0062875E-03
     +,   1.0323004E-03,   1.0583393E-03,   1.0843973E-03
     +,   1.1104723E-03,   1.1365663E-03,   1.1626886E-03
     +,   1.1888540E-03,   1.2150856E-03,   1.2414152E-03
     +,   1.2678836E-03,   1.2945425E-03,   1.3214551E-03
     +,   1.3486989E-03,   1.3763623E-03,   1.4045524E-03
     +,   1.4333908E-03,   1.4630161E-03,   1.4935869E-03
     +,   1.5252806E-03,   1.5582950E-03,   1.5928493E-03
     +,   1.6291846E-03,   1.6675639E-03,   1.7082726E-03
     +,   1.7516180E-03,   1.7979286E-03,   1.8475525E-03
     +,   1.9008594E-03,   1.9582310E-03,   2.0200692E-03
     +,   2.0867828E-03,   2.1587913E-03,   2.2365146E-03
     +,   2.3203739E-03,   2.4107827E-03,   2.5081441E-03
     +,   2.6128346E-03,   2.7252135E-03,   2.8456093E-03
     +,   2.9742948E-03,   3.1115150E-03,   3.2574411E-03
     +,   3.4121990E-03,   3.5758275E-03,   3.7483121E-03
     +,   3.9295331E-03,   4.1193110E-03,   4.3173567E-03
     +,   4.5233099E-03,   4.7367220E-03,   4.9570459E-03
     +,   5.1836539E-03,   5.4158596E-03,   5.6529082E-03
     +,   5.8939732E-03,   6.1382116E-03,   6.3847350E-03
     +,   6.6326754E-03,   6.8811504E-03,   7.1293516E-03
     +,   7.3764976E-03,   7.6219360E-03,   7.8650946E-03
     +,   8.1055751E-03,   8.3431620E-03,   8.5778246E-03
     +,   8.8097742E-03,   9.0395221E-03,   9.2678601E-03
     +,   9.4959103E-03,   9.7251721E-03,   9.9575203E-03
     +,   1.0195272E-02,   1.0441152E-02,   1.0698391E-02
     +,   1.0970675E-02,   1.1262230E-02,   1.1577751E-02
     +,   1.1922524E-02,   1.2302352E-02,   1.2723587E-02
     +,   1.3193113E-02,   1.3718353E-02,   1.4307250E-02
     +,   1.4968104E-02,   1.5709596E-02,   1.6540485E-02
     +,   1.7469514E-02,   1.8504914E-02,   1.9654177E-02
     +,   2.0923298E-02,   2.2316488E-02,   2.3835134E-02
     +,   2.5477514E-02,   2.7237978E-02,   2.9106470E-02
     +,   3.1068275E-02,   3.3104260E-02,   3.5191260E-02
     +,   3.7302740E-02,   3.9410703E-02,   4.1486971E-02
     +,   4.3505985E-02,   4.5446776E-02,   4.7296066E-02
     +,   4.9050089E-02,   5.0717246E-02,   5.2318595E-02
     +,   5.3888734E-02,   5.5474438E-02,   5.7132293E-02
     +,   5.8924589E-02,   6.0914595E-02,   6.3160248E-02
     +,   6.5707639E-02,   6.8585359E-02,   7.1799949E-02
     +,   7.5333029E-02,   7.9141043E-02,   8.3158247E-02
     +,   8.7302051E-02,   9.1479741E-02,   9.5597766E-02
     +,   9.9571452E-02,   0.1033330    ,   0.1068395    
     +,   0.1100770    ,   0.1130621    ,   0.1158375    
     +,   0.1184628    ,   0.1210009    ,   0.1235018    
     +,   0.1259864    ,   0.1284337    ,   0.1307780    
     +,   0.1329136    ,   0.1347122    ,   0.1360458    
     +,   0.1368148    ,   0.1369711    ,   0.1365352    
     +,   0.1356025    ,   0.1343383    ,   0.1329633    
     +,   0.1317346    ,   0.1309256    ,   0.1308066    
     +,   0.1316273    ,   0.1336030    ,   0.1368969    
     +,   0.1416034    ,   0.1477328    ,   0.1552139    
     +,   0.1639280    ,   0.1737824    ,   0.1848094    
     +,   0.1972544    ,   0.2116078    ,   0.2285531    
     +,   0.2488480    ,   0.2731748    ,   0.3019932    
     +,   0.3354191    ,   0.3731713    ,   0.4146727    
     +,   0.4592942    ,   0.5066042    ,   0.5562857    
     +,   0.6074130    ,   0.6574400    ,   0.7021416    
     +,   0.7375237    ,   0.7625943    ,   0.7802338    
     +,   0.7950648    ,   0.8109015    ,   0.8306599    
     +,   0.8573360    ,   0.8925935    ,   0.9340503    
     +,   0.9755031    ,    1.010097    ,    1.032534    
     +,    1.039454    ,    1.029555    ,    1.003285    
     +,   0.9619759    ,   0.9075661    ,   0.8428101    
     +,   0.7711943    ,   0.6967293    ,   0.6232793    
     +,   0.5531557    ,   0.4863181    ,   0.4215224    
     +,   0.3584127    ,   0.2984062    ,   0.2438449    
     +,   0.1965940    ,   0.1572962    ,   0.1254749    
     +,   0.1000528    ,   7.9835162E-02,   6.3772552E-02
     +,   5.1025126E-02,   4.0929910E-02,   3.2952208E-02
     +,   2.6653025E-02,   2.1671956E-02,   1.7716512E-02
     +,   1.4555407E-02,   1.2010109E-02,   9.9450806E-03
     +,   8.2581611E-03,   6.8722852E-03,   5.7287114E-03
     +,   4.7818990E-03,   3.9959890E-03,   3.3425025E-03
     +,   2.7986609E-03,   2.3460442E-03,   1.9695833E-03
     +,   1.6568317E-03,   1.3974039E-03,   1.1824963E-03
     +,   1.0046269E-03,   8.5743895E-04,   7.3553436E-04
     +,   6.3435128E-04,   5.5007770E-04,   4.7955930E-04
     +,   4.2020768E-04,   3.6991376E-04,   3.2697778E-04
     +,   2.9004089E-04,   2.5802050E-04,   2.3005497E-04
     +,   2.0546219E-04,   1.8370349E-04,   1.6434866E-04
     +,   1.4705442E-04,   1.3154588E-04,   1.1759996E-04
     +,   1.0503305E-04,   9.3693088E-05,   8.3453109E-05
     +,   7.4205127E-05,   6.5855471E-05,   5.8322483E-05
     +,   5.1534640E-05,   4.5427121E-05,   3.9942192E-05
     +,   3.5026442E-05,   3.0631443E-05,   2.6711843E-05
     +,   2.3226061E-05,   2.0134890E-05,   1.7402182E-05
     +,   1.4993847E-05,   1.2878431E-05,   1.1026445E-05
     +,   9.4105544E-06,   8.0056279E-06,   6.7883207E-06
     +,   5.7373736E-06,   4.8332199E-06,   4.0581867E-06
     +,   3.3961817E-06,   2.8327925E-06,   2.3550253E-06
     +,   1.9513557E-06,   1.6115004E-06,   1.3264212E-06
     +,   1.0881358E-06,   8.8969244E-07
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_ashz_htt107_mass = Yx/8.02090174468085
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_ashz_htt110_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.5021925E-04,   2.5498131E-04
     +,   2.5981767E-04,   2.6472969E-04,   2.6971876E-04
     +,   2.7478620E-04,   2.7993348E-04,   2.8516195E-04
     +,   2.9047285E-04,   2.9586782E-04,   3.0134816E-04
     +,   3.0691520E-04,   3.1257063E-04,   3.1831578E-04
     +,   3.2415235E-04,   3.3008211E-04,   3.3610681E-04
     +,   3.4222860E-04,   3.4844989E-04,   3.5477304E-04
     +,   3.6120118E-04,   3.6773758E-04,   3.7438600E-04
     +,   3.8115139E-04,   3.8803837E-04,   3.9505353E-04
     +,   4.0220382E-04,   4.0949736E-04,   4.1694395E-04
     +,   4.2455443E-04,   4.3234191E-04,   4.4032108E-04
     +,   4.4850906E-04,   4.5692545E-04,   4.6559266E-04
     +,   4.7453624E-04,   4.8378520E-04,   4.9337232E-04
     +,   5.0333486E-04,   5.1371398E-04,   5.2455673E-04
     +,   5.3591520E-04,   5.4784684E-04,   5.6041603E-04
     +,   5.7369331E-04,   5.8775663E-04,   6.0269138E-04
     +,   6.1859033E-04,   6.3555484E-04,   6.5369456E-04
     +,   6.7312794E-04,   6.9398235E-04,   7.1639393E-04
     +,   7.4050925E-04,   7.6648168E-04,   7.9447665E-04
     +,   8.2466617E-04,   8.5723231E-04,   8.9236489E-04
     +,   9.3026215E-04,   9.7112975E-04,   1.0151806E-03
     +,   1.0626310E-03,   1.1137063E-03,   1.1686363E-03
     +,   1.2276488E-03,   1.2909821E-03,   1.3588665E-03
     +,   1.4315411E-03,   1.5092351E-03,   1.5921837E-03
     +,   1.6806083E-03,   1.7747351E-03,   1.8747713E-03
     +,   1.9809259E-03,   2.0933968E-03,   2.2123661E-03
     +,   2.3379985E-03,   2.4704561E-03,   2.6098860E-03
     +,   2.7564052E-03,   2.9101311E-03,   3.0711468E-03
     +,   3.2395385E-03,   3.4153517E-03,   3.5986404E-03
     +,   3.7894165E-03,   3.9877077E-03,   4.1935015E-03
     +,   4.4067968E-03,   4.6275933E-03,   4.8558749E-03
     +,   5.0916332E-03,   5.3348877E-03,   5.5856844E-03
     +,   5.8440776E-03,   6.1101955E-03,   6.3841976E-03
     +,   6.6663409E-03,   6.9569452E-03,   7.2564692E-03
     +,   7.5654727E-03,   7.8846943E-03,   8.2150204E-03
     +,   8.5575664E-03,   8.9136679E-03,   9.2849014E-03
     +,   9.6730944E-03,   1.0080377E-02,   1.0509163E-02
     +,   1.0962074E-02,   1.1442035E-02,   1.1952069E-02
     +,   1.2495385E-02,   1.3075121E-02,   1.3694408E-02
     +,   1.4356053E-02,   1.5062660E-02,   1.5816262E-02
     +,   1.6618524E-02,   1.7470632E-02,   1.8373366E-02
     +,   1.9327398E-02,   2.0333687E-02,   2.1394011E-02
     +,   2.2511419E-02,   2.3691341E-02,   2.4941981E-02
     +,   2.6275381E-02,   2.7707603E-02,   2.9259155E-02
     +,   3.0954255E-02,   3.2820020E-02,   3.4884162E-02
     +,   3.7172437E-02,   3.9704945E-02,   4.2491738E-02
     +,   4.5528658E-02,   4.8793864E-02,   5.2244898E-02
     +,   5.5817746E-02,   5.9428718E-02,   6.2978990E-02
     +,   6.6361561E-02,   6.9470003E-02,   7.2209515E-02
     +,   7.4506536E-02,   7.6317228E-02,   7.7632777E-02
     +,   7.8481250E-02,   7.8923896E-02,   7.9048924E-02
     +,   7.8960970E-02,   7.8769945E-02,   7.8579135E-02
     +,   7.8475893E-02,   7.8524031E-02,   7.8760378E-02
     +,   7.9194143E-02,   7.9809152E-02,   8.0567934E-02
     +,   8.1417292E-02,   8.2293421E-02,   8.3127797E-02
     +,   8.3852649E-02,   8.4405906E-02,   8.4736742E-02
     +,   8.4810235E-02,   8.4612206E-02,   8.4152713E-02
     +,   8.3468884E-02,   8.2627267E-02,   8.1727520E-02
     +,   8.0908008E-02,   8.0356739E-02,   8.0324277E-02
     +,   8.1135966E-02,   8.3193295E-02,   8.6952612E-02
     +,   9.2871368E-02,   0.1013224    ,   0.1124891    
     +,   0.1262786    ,   0.1422914    ,   0.1598768    
     +,   0.1782774    ,   0.1968313    ,   0.2151677    
     +,   0.2333321    ,   0.2518016    ,   0.2713990    
     +,   0.2931073    ,   0.3178121    ,   0.3460024    
     +,   0.3775114    ,   0.4114254    ,   0.4462571    
     +,   0.4803910    ,   0.5126669    ,   0.5427648    
     +,   0.5711042    ,   0.5984339    ,   0.6255850    
     +,   0.6531507    ,   0.6803856    ,   0.7041161    
     +,   0.7198193    ,   0.7251799    ,   0.7229929    
     +,   0.7199386    ,   0.7213628    ,   0.7265313    
     +,   0.7290448    ,   0.7218912    ,   0.7019264    
     +,   0.6702356    ,   0.6298968    ,   0.5842117    
     +,   0.5362445    ,   0.4885512    ,   0.4425870    
     +,   0.3985272    ,   0.3559578    ,   0.3147870    
     +,   0.2755204    ,   0.2388721    ,   0.2052971    
     +,   0.1748658    ,   0.1474513    ,   0.1229548    
     +,   0.1013842    ,   8.2781278E-02,   6.7107454E-02
     +,   5.4179393E-02,   4.3680400E-02,   3.5220180E-02
     +,   2.8408609E-02,   2.2907361E-02,   1.8449478E-02
     +,   1.4834948E-02,   1.1914480E-02,   9.5717125E-03
     +,   7.7096508E-03,   6.2433560E-03,   5.0974768E-03
     +,   4.2060772E-03,   3.5129657E-03,   2.9718170E-03
     +,   2.5457132E-03,   2.2060976E-03,   1.9313226E-03
     +,   1.7052856E-03,   1.5161418E-03,   1.3552069E-03
     +,   1.2161036E-03,   1.0941444E-03,   9.8587945E-04
     +,   8.8875898E-04,   8.0089539E-04,   7.2089874E-04
     +,   6.4775342E-04,   5.8071280E-04,   5.1921990E-04
     +,   4.6285152E-04,   4.1127825E-04,   3.6421881E-04
     +,   3.2142180E-04,   2.8265230E-04,   2.4767802E-04
     +,   2.1626298E-04,   1.8816844E-04,   1.6315538E-04
     +,   1.4098380E-04,   1.2141468E-04,   1.0421457E-04
     +,   8.9159468E-05,   7.6033437E-05,   6.4634289E-05
     +,   5.4771353E-05,   4.6269437E-05,   3.8966398E-05
     +,   3.2715503E-05,   2.7383152E-05,   2.2849999E-05
     +,   1.9008841E-05,   1.5764970E-05,   1.3034379E-05
     +,   1.0743271E-05,   8.8272891E-06,   7.2301345E-06
     +,   5.9031900E-06,   4.8042889E-06,   3.8973153E-06
     +,   3.1511925E-06,   2.5394991E-06,   2.0396878E-06
     +,   1.6327219E-06,   1.3024825E-06,   1.0354613E-06
     +,   8.2030766E-07,   6.4757813E-07
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_ashz_htt110_mass = Yx/6.141317
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_ashz_htt115_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.5689561E-04,   2.6255200E-04
     +,   2.6825318E-04,   2.7399990E-04,   2.7979340E-04
     +,   2.8563495E-04,   2.9152638E-04,   2.9746990E-04
     +,   3.0346782E-04,   3.0952340E-04,   3.1563971E-04
     +,   3.2182067E-04,   3.2807048E-04,   3.3439382E-04
     +,   3.4079584E-04,   3.4728213E-04,   3.5385886E-04
     +,   3.6053258E-04,   3.6731042E-04,   3.7420014E-04
     +,   3.8120977E-04,   3.8834810E-04,   3.9562405E-04
     +,   4.0304798E-04,   4.1062964E-04,   4.1838016E-04
     +,   4.2631102E-04,   4.3443413E-04,   4.4276225E-04
     +,   4.5130844E-04,   4.6008686E-04,   4.6911190E-04
     +,   4.7839893E-04,   4.8796396E-04,   4.9782376E-04
     +,   5.0799607E-04,   5.1849952E-04,   5.2935339E-04
     +,   5.4057909E-04,   5.5219739E-04,   5.6423224E-04
     +,   5.7670765E-04,   5.8964972E-04,   6.0308614E-04
     +,   6.1704597E-04,   6.3156098E-04,   6.4666441E-04
     +,   6.6239189E-04,   6.7878218E-04,   6.9587596E-04
     +,   7.1371743E-04,   7.3235354E-04,   7.5183483E-04
     +,   7.7221636E-04,   7.9355517E-04,   8.1591483E-04
     +,   8.3936233E-04,   8.6396985E-04,   8.8981411E-04
     +,   9.1697898E-04,   9.4555289E-04,   9.7563217E-04
     +,   1.0073180E-03,   1.0407215E-03,   1.0759616E-03
     +,   1.1131632E-03,   1.1524652E-03,   1.1940118E-03
     +,   1.2379629E-03,   1.2844859E-03,   1.3337670E-03
     +,   1.3860002E-03,   1.4414017E-03,   1.5001980E-03
     +,   1.5626398E-03,   1.6289982E-03,   1.6995617E-03
     +,   1.7746428E-03,   1.8545833E-03,   1.9397550E-03
     +,   2.0305486E-03,   2.1273999E-03,   2.2307639E-03
     +,   2.3411429E-03,   2.4590632E-03,   2.5851014E-03
     +,   2.7198538E-03,   2.8639713E-03,   3.0181222E-03
     +,   3.1830205E-03,   3.3594116E-03,   3.5480526E-03
     +,   3.7497170E-03,   3.9651990E-03,   4.1952892E-03
     +,   4.4407453E-03,   4.7023213E-03,   4.9806884E-03
     +,   5.2764863E-03,   5.5902265E-03,   5.9223459E-03
     +,   6.2731053E-03,   6.6426443E-03,   7.0308847E-03
     +,   7.4375793E-03,   7.8622783E-03,   8.3042877E-03
     +,   8.7627079E-03,   9.2364792E-03,   9.7243777E-03
     +,   1.0225024E-02,   1.0737041E-02,   1.1259015E-02
     +,   1.1789712E-02,   1.2328037E-02,   1.2873285E-02
     +,   1.3425090E-02,   1.3983693E-02,   1.4549825E-02
     +,   1.5124928E-02,   1.5711060E-02,   1.6310848E-02
     +,   1.6927397E-02,   1.7564192E-02,   1.8224804E-02
     +,   1.8912578E-02,   1.9630458E-02,   2.0380456E-02
     +,   2.1163508E-02,   2.1978961E-02,   2.2824569E-02
     +,   2.3696069E-02,   2.4587415E-02,   2.5490642E-02
     +,   2.6396329E-02,   2.7293928E-02,   2.8172225E-02
     +,   2.9020045E-02,   2.9826984E-02,   3.0584035E-02
     +,   3.1284124E-02,   3.1922728E-02,   3.2498155E-02
     +,   3.3011701E-02,   3.3467360E-02,   3.3871770E-02
     +,   3.4233503E-02,   3.4562450E-02,   3.4869116E-02
     +,   3.5163932E-02,   3.5456706E-02,   3.5755973E-02
     +,   3.6068927E-02,   3.6401335E-02,   3.6757752E-02
     +,   3.7141830E-02,   3.7556887E-02,   3.8006335E-02
     +,   3.8494252E-02,   3.9025567E-02,   3.9606318E-02
     +,   4.0243559E-02,   4.0944960E-02,   4.1718457E-02
     +,   4.2571560E-02,   4.3510962E-02,   4.4541650E-02
     +,   4.5666873E-02,   4.6888303E-02,   4.8206776E-02
     +,   4.9623918E-02,   5.1144764E-02,   5.2781183E-02
     +,   5.4555651E-02,   5.6503996E-02,   5.8677692E-02
     +,   6.1142273E-02,   6.3973002E-02,   6.7247048E-02
     +,   7.1033239E-02,   7.5380430E-02,   8.0306597E-02
     +,   8.5791178E-02,   9.1772862E-02,   9.8154314E-02
     +,   0.1048175    ,   0.1116528    ,   0.1186016    
     +,   0.1257015    ,   0.1331252    ,   0.1411916    
     +,   0.1503350    ,   0.1610325    ,   0.1737034    
     +,   0.1885978    ,   0.2056839    ,   0.2245660    
     +,   0.2445183    ,   0.2647529    ,   0.2849399    
     +,   0.3057212    ,   0.3287190    ,   0.3557130    
     +,   0.3873291    ,   0.4222167    ,   0.4575227    
     +,   0.4903544    ,   0.5189779    ,   0.5428337    
     +,   0.5616780    ,   0.5747772    ,   0.5806556    
     +,   0.5777476    ,   0.5661155    ,   0.5490324    
     +,   0.5321651    ,   0.5200964    ,   0.5131087    
     +,   0.5071293    ,   0.4965760    ,   0.4775452    
     +,   0.4493051    ,   0.4138524    ,   0.3744574    
     +,   0.3342379    ,   0.2953717    ,   0.2590025    
     +,   0.2255580    ,   0.1951359    ,   0.1677473    
     +,   0.1433793    ,   0.1219555    ,   0.1032960    
     +,   8.7131061E-02,   7.3158540E-02,   6.1102178E-02
     +,   5.0744206E-02,   4.1920196E-02,   3.4492061E-02
     +,   2.8322827E-02,   2.3265222E-02,   1.9162942E-02
     +,   1.5858708E-02,   1.3204059E-02,   1.1067112E-02
     +,   9.3364930E-03,   7.9217944E-03,   6.7519606E-03
     +,   5.7726665E-03,   4.9432404E-03,   4.2334474E-03
     +,   3.6210087E-03,   3.0895043E-03,   2.6266838E-03
     +,   2.2232116E-03,   1.8718020E-03,   1.5665910E-03
     +,   1.3026426E-03,   1.0756302E-03,   8.8165200E-04
     +,   7.1712013E-04,   5.7867711E-04,   4.6316205E-04
     +,   3.6762087E-04,   2.8931993E-04,   2.2573976E-04
     +,   1.7459701E-04,   1.3385223E-04,   1.0170471E-04
     +,   7.6585355E-05,   5.7148623E-05,   4.2257012E-05
     +,   3.0960302E-05,   2.2474997E-05,   1.6164367E-05
     +,   1.1517938E-05,   8.1306216E-06,   5.6859458E-06
     +,   3.9390370E-06,   2.7032534E-06,   1.8376986E-06
     +,   1.2375323E-06,   8.2550190E-07,   5.4546410E-07
     +,   3.5701603E-07,   2.3147024E-07,   1.4865715E-07
     +,   9.4571291E-08,   5.9599223E-08,   3.7207855E-08
     +,   2.3013591E-08,   1.4103303E-08,   8.5649949E-09
     +,   5.1557865E-09,   3.0775376E-09,   1.8226037E-09
     +,   1.0719474E-09,   6.2697009E-10,   3.6549383E-10
     +,   2.1306536E-10,   1.2483271E-10
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_ashz_htt115_mass = Yx/4.53889311627907
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_ashz_htt120_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.9050445E-04,   1.9536933E-04
     +,   2.0036333E-04,   2.0549342E-04,   2.1076668E-04
     +,   2.1619079E-04,   2.2177401E-04,   2.2752475E-04
     +,   2.3345223E-04,   2.3956613E-04,   2.4587652E-04
     +,   2.5239415E-04,   2.5913035E-04,   2.6609679E-04
     +,   2.7330616E-04,   2.8077146E-04,   2.8850653E-04
     +,   2.9652577E-04,   3.0484446E-04,   3.1347855E-04
     +,   3.2244480E-04,   3.3176073E-04,   3.4144483E-04
     +,   3.5151679E-04,   3.6199650E-04,   3.7290584E-04
     +,   3.8426716E-04,   3.9610418E-04,   4.0844193E-04
     +,   4.2130647E-04,   4.3472569E-04,   4.4872853E-04
     +,   4.6334570E-04,   4.7860958E-04,   4.9455411E-04
     +,   5.1121501E-04,   5.2863022E-04,   5.4683868E-04
     +,   5.6588312E-04,   5.8580592E-04,   6.0665357E-04
     +,   6.2847364E-04,   6.5131579E-04,   6.7523186E-04
     +,   7.0027541E-04,   7.2650216E-04,   7.5396930E-04
     +,   7.8273553E-04,   8.1286044E-04,   8.4440515E-04
     +,   8.7743090E-04,   9.1199920E-04,   9.4817043E-04
     +,   9.8600646E-04,   1.0255640E-03,   1.0669010E-03
     +,   1.1100706E-03,   1.1551221E-03,   1.2021010E-03
     +,   1.2510469E-03,   1.3019932E-03,   1.3549665E-03
     +,   1.4099815E-03,   1.4670484E-03,   1.5261673E-03
     +,   1.5873215E-03,   1.6504911E-03,   1.7156347E-03
     +,   1.7827076E-03,   1.8516438E-03,   1.9223717E-03
     +,   1.9948001E-03,   2.0688339E-03,   2.1443574E-03
     +,   2.2212544E-03,   2.2993982E-03,   2.3786537E-03
     +,   2.4588821E-03,   2.5399497E-03,   2.6217285E-03
     +,   2.7040881E-03,   2.7869248E-03,   2.8701399E-03
     +,   2.9536679E-03,   3.0374643E-03,   3.1215262E-03
     +,   3.2058840E-03,   3.2906211E-03,   3.3758655E-03
     +,   3.4618089E-03,   3.5487036E-03,   3.6368645E-03
     +,   3.7266731E-03,   3.8185907E-03,   3.9131502E-03
     +,   4.0109502E-03,   4.1126753E-03,   4.2190659E-03
     +,   4.3309466E-03,   4.4491915E-03,   4.5747487E-03
     +,   4.7086040E-03,   4.8518102E-03,   5.0054369E-03
     +,   5.1706028E-03,   5.3484477E-03,   5.5401162E-03
     +,   5.7467483E-03,   5.9694862E-03,   6.2094489E-03
     +,   6.4676921E-03,   6.7452332E-03,   7.0429780E-03
     +,   7.3617552E-03,   7.7022123E-03,   8.0648744E-03
     +,   8.4500043E-03,   8.8576693E-03,   9.2876079E-03
     +,   9.7392676E-03,   1.0211743E-02,   1.0703724E-02
     +,   1.1213465E-02,   1.1738842E-02,   1.2277307E-02
     +,   1.2825842E-02,   1.3381114E-02,   1.3939383E-02
     +,   1.4496700E-02,   1.5048831E-02,   1.5591514E-02
     +,   1.6120378E-02,   1.6631234E-02,   1.7119994E-02
     +,   1.7582953E-02,   1.8016770E-02,   1.8418584E-02
     +,   1.8786076E-02,   1.9117577E-02,   1.9412065E-02
     +,   1.9669140E-02,   1.9889113E-02,   2.0072956E-02
     +,   2.0222254E-02,   2.0339211E-02,   2.0426596E-02
     +,   2.0487677E-02,   2.0526242E-02,   2.0546472E-02
     +,   2.0552967E-02,   2.0550650E-02,   2.0544695E-02
     +,   2.0540472E-02,   2.0543439E-02,   2.0558991E-02
     +,   2.0592349E-02,   2.0648381E-02,   2.0731408E-02
     +,   2.0845057E-02,   2.0992065E-02,   2.1174209E-02
     +,   2.1392245E-02,   2.1645937E-02,   2.1934275E-02
     +,   2.2255741E-02,   2.2608815E-02,   2.2992447E-02
     +,   2.3406796E-02,   2.3853872E-02,   2.4338260E-02
     +,   2.4867645E-02,   2.5453297E-02,   2.6110476E-02
     +,   2.6858635E-02,   2.7721573E-02,   2.8727852E-02
     +,   2.9911412E-02,   3.1312238E-02,   3.2977678E-02
     +,   3.4963783E-02,   3.7336141E-02,   4.0169206E-02
     +,   4.3543063E-02,   4.7536351E-02,   5.2213263E-02
     +,   5.7605408E-02,   6.3692503E-02,   7.0388049E-02
     +,   7.7538848E-02,   8.4946685E-02,   9.2417121E-02
     +,   9.9822424E-02,   0.1071585    ,   0.1145709    
     +,   0.1223303    ,   0.1307606    ,   0.1401555    
     +,   0.1507318    ,   0.1626586    ,   0.1761323    
     +,   0.1914106    ,   0.2086948    ,   0.2278343    
     +,   0.2479985    ,   0.2675908    ,   0.2846239    
     +,   0.2974522    ,   0.3054712    ,   0.3093200    
     +,   0.3104304    ,   0.3102287    ,   0.3095202    
     +,   0.3083904    ,   0.3065625    ,   0.3038984    
     +,   0.3006956    ,   0.2975961    ,   0.2951381    
     +,   0.2932708    ,   0.2912614    ,   0.2881915    
     +,   0.2837059    ,   0.2783713    ,   0.2732681    
     +,   0.2690838    ,   0.2654088    ,   0.2607588    
     +,   0.2532713    ,   0.2415768    ,   0.2253242    
     +,   0.2051883    ,   0.1825083    ,   0.1588414    
     +,   0.1356205    ,   0.1139681    ,   9.4625026E-02
     +,   7.7963226E-02,   6.4042121E-02,   5.2686982E-02
     +,   4.3576933E-02,   3.6327839E-02,   3.0557120E-02
     +,   2.5925022E-02,   2.2154653E-02,   1.9034803E-02
     +,   1.6411511E-02,   1.4174764E-02,   1.2245822E-02
     +,   1.0567588E-02,   9.0981005E-03,   7.8060608E-03
     +,   6.6682408E-03,   5.6674657E-03,   4.7906712E-03
     +,   4.0272879E-03,   3.3680371E-03,   2.8040884E-03
     +,   2.3265132E-03,   1.9261299E-03,   1.5936389E-03
     +,   1.3198684E-03,   1.0960104E-03,   9.1386272E-04
     +,   7.6603139E-04,   6.4604945E-04,   5.4838526E-04
     +,   4.6843593E-04,   4.0246066E-04,   3.4747698E-04
     +,   3.0114796E-04,   2.6167525E-04,   2.2769489E-04
     +,   1.9817987E-04,   1.7235862E-04,   1.4965201E-04
     +,   1.2962287E-04,   1.1193129E-04,   9.6310003E-05
     +,   8.2538223E-05,   7.0430506E-05,   5.9822964E-05
     +,   5.0569546E-05,   4.2534994E-05,   3.5594887E-05
     +,   2.9632136E-05,   2.4538180E-05,   2.0211388E-05
     +,   1.6557706E-05,   1.3490991E-05,   1.0932242E-05
     +,   8.8103297E-06,   7.0612205E-06,   5.6282433E-06
     +,   4.4612948E-06,   3.5168005E-06,   2.7569197E-06
     +,   2.1492920E-06,   1.6663007E-06,   1.2847088E-06
     +,   9.8501096E-07,   7.5105180E-07
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_ashz_htt120_mass = Yx/3.04703805
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_ashz_htt60_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.3046362E-02,   1.4750126E-02
     +,   1.6646644E-02,   1.8753642E-02,   2.1090955E-02
     +,   2.3681061E-02,   2.6549624E-02,   2.9725870E-02
     +,   3.3242725E-02,   3.7136842E-02,   4.1447800E-02
     +,   4.6217568E-02,   5.1489934E-02,   5.7310279E-02
     +,   6.3726656E-02,   7.0792124E-02,   7.8569084E-02
     +,   8.7135158E-02,   9.6591465E-02,   0.1070723    
     +,   0.1187566    ,   0.1318779    ,   0.1467277    
     +,   0.1636449    ,   0.1829776    ,   0.2050259    
     +,   0.2299698    ,   0.2578328    ,   0.2885225    
     +,   0.3219944    ,   0.3584948    ,   0.3987471    
     +,   0.4438767    ,   0.4949599    ,   0.5523294    
     +,   0.6150017    ,   0.6805921    ,   0.7458171    
     +,   0.8073114    ,   0.8622293    ,   0.9083363    
     +,   0.9436321    ,   0.9661268    ,   0.9741596    
     +,   0.9670851    ,   0.9456491    ,   0.9117665    
     +,   0.8680400    ,   0.8175675    ,   0.7639439    
     +,   0.7109575    ,   0.6618550    ,   0.6185789    
     +,   0.5814511    ,   0.5494235    ,   0.5206775    
     +,   0.4933448    ,   0.4660661    ,   0.4382513    
     +,   0.4100306    ,   0.3820248    ,   0.3550567    
     +,   0.3298956    ,   0.3070669    ,   0.2867779    
     +,   0.2689625    ,   0.2533900    ,   0.2397934    
     +,   0.2279389    ,   0.2176401    ,   0.2087225    
     +,   0.2009873    ,   0.1941926    ,   0.1880671    
     +,   0.1823453    ,   0.1768074    ,   0.1713090    
     +,   0.1657896    ,   0.1602612    ,   0.1547849    
     +,   0.1494422    ,   0.1443075    ,   0.1394339    
     +,   0.1348448    ,   0.1305382    ,   0.1264947    
     +,   0.1226891    ,   0.1190982    ,   0.1157082    
     +,   0.1125156    ,   0.1095255    ,   0.1067477    
     +,   0.1041919    ,   0.1018623    ,   9.9755876E-02
     +,   9.7860731E-02,   9.6156858E-02,   9.4618551E-02
     +,   9.3217209E-02,   9.1924660E-02,   9.0715215E-02
     +,   8.9568183E-02,   8.8467777E-02,   8.7403350E-02
     +,   8.6368501E-02,   8.5359395E-02,   8.4373750E-02
     +,   8.3409429E-02,   8.2463831E-02,   8.1532918E-02
     +,   8.0612279E-02,   7.9696290E-02,   7.8779429E-02
     +,   7.7856198E-02,   7.6921709E-02,   7.5971775E-02
     +,   7.5003125E-02,   7.4012913E-02,   7.2998956E-02
     +,   7.1959272E-02,   7.0892006E-02,   6.9795586E-02
     +,   6.8668462E-02,   6.7509390E-02,   6.6317469E-02
     +,   6.5092601E-02,   6.3835181E-02,   6.2546521E-02
     +,   6.1228622E-02,   5.9884295E-02,   5.8516838E-02
     +,   5.7130136E-02,   5.5728175E-02,   5.4315284E-02
     +,   5.2895654E-02,   5.1473506E-02,   5.0052993E-02
     +,   4.8638191E-02,   4.7232971E-02,   4.5841165E-02
     +,   4.4466577E-02,   4.3112934E-02,   4.1783787E-02
     +,   4.0482517E-02,   3.9212406E-02,   3.7976395E-02
     +,   3.6776964E-02,   3.5616338E-02,   3.4496196E-02
     +,   3.3417679E-02,   3.2381311E-02,   3.1387217E-02
     +,   3.0434942E-02,   2.9523527E-02,   2.8651565E-02
     +,   2.7817391E-02,   2.7019074E-02,   2.6254486E-02
     +,   2.5521396E-02,   2.4817662E-02,   2.4141168E-02
     +,   2.3489930E-02,   2.2862213E-02,   2.2256501E-02
     +,   2.1671459E-02,   2.1106020E-02,   2.0559343E-02
     +,   2.0030797E-02,   1.9519854E-02,   1.9026089E-02
     +,   1.8549182E-02,   1.8088816E-02,   1.7644605E-02
     +,   1.7216090E-02,   1.6802764E-02,   1.6403962E-02
     +,   1.6018866E-02,   1.5646549E-02,   1.5285967E-02
     +,   1.4935940E-02,   1.4595178E-02,   1.4262350E-02
     +,   1.3936106E-02,   1.3615050E-02,   1.3297820E-02
     +,   1.2983138E-02,   1.2669817E-02,   1.2356753E-02
     +,   1.2042992E-02,   1.1727759E-02,   1.1410411E-02
     +,   1.1090491E-02,   1.0767733E-02,   1.0442050E-02
     +,   1.0113505E-02,   9.7823236E-03,   9.4489008E-03
     +,   9.1137700E-03,   8.7775523E-03,   8.4409704E-03
     +,   8.1048496E-03,   7.7700680E-03,   7.4375216E-03
     +,   7.1081296E-03,   6.7828353E-03,   6.4625340E-03
     +,   6.1480980E-03,   5.8403611E-03,   5.5401064E-03
     +,   5.2480223E-03,   4.9647260E-03,   4.6907673E-03
     +,   4.4266111E-03,   4.1726157E-03,   3.9290525E-03
     +,   3.6961192E-03,   3.4739319E-03,   3.2625094E-03
     +,   3.0617954E-03,   2.8716875E-03,   2.6919970E-03
     +,   2.5224851E-03,   2.3628725E-03,   2.2128383E-03
     +,   2.0720207E-03,   1.9400286E-03,   1.8164625E-03
     +,   1.7009078E-03,   1.5929340E-03,   1.4921096E-03
     +,   1.3980130E-03,   1.3102276E-03,   1.2283409E-03
     +,   1.1519556E-03,   1.0806958E-03,   1.0141963E-03
     +,   9.5211115E-04,   8.9411810E-04,   8.3991460E-04
     +,   7.8921480E-04,   7.4175379E-04,   6.9728878E-04
     +,   6.5559655E-04,   6.1646861E-04,   5.7971431E-04
     +,   5.4516247E-04,   5.1265577E-04,   4.8204942E-04
     +,   4.5321186E-04,   4.2602583E-04,   4.0038212E-04
     +,   3.7618182E-04,   3.5333598E-04,   3.3176370E-04
     +,   3.1138916E-04,   2.9214352E-04,   2.7396428E-04
     +,   2.5679404E-04,   2.4057842E-04,   2.2526699E-04
     +,   2.1081386E-04,   1.9717579E-04,   1.8431149E-04
     +,   1.7218203E-04,   1.6075168E-04,   1.4998556E-04
     +,   1.3985044E-04,   1.3031541E-04,   1.2135079E-04
     +,   1.1292773E-04,   1.0501857E-04,   9.7597367E-05
     +,   9.0639158E-05,   8.4119565E-05,   7.8015248E-05
     +,   7.2304363E-05,   6.6965200E-05,   6.1977706E-05
     +,   5.7321944E-05,   5.2979467E-05,   4.8932037E-05
     +,   4.5162775E-05,   4.1655025E-05,   3.8393366E-05
     +,   3.5362693E-05,   3.2548971E-05,   2.9938619E-05
     +,   2.7518689E-05,   2.5277168E-05,   2.3202345E-05
     +,   2.1283397E-05,   1.9509847E-05,   1.7872024E-05
     +,   1.6360569E-05,   1.4966875E-05,   1.3682631E-05
     +,   1.2500203E-05,   1.1412251E-05,   1.0412022E-05
     +,   9.4930592E-06,   8.6494329E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_ashz_htt60_mass = Yx/8.10705536170213
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_ashz_htt65_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.8901519E-03,   3.0686483E-03
     +,   3.2624367E-03,   3.4737671E-03,   3.7053390E-03
     +,   3.9603696E-03,   4.2426623E-03,   4.5566633E-03
     +,   4.9075061E-03,   5.3010532E-03,   5.7438770E-03
     +,   6.2432331E-03,   6.8069967E-03,   7.4435417E-03
     +,   8.1615942E-03,   8.9700390E-03,   9.8777059E-03
     +,   1.0893199E-02,   1.2024726E-02,   1.3280086E-02
     +,   1.4666862E-02,   1.6192876E-02,   1.7867073E-02
     +,   1.9701106E-02,   2.1711044E-02,   2.3920476E-02
     +,   2.6363220E-02,   2.9086832E-02,   3.2155268E-02
     +,   3.5650548E-02,   3.9671984E-02,   4.4332508E-02
     +,   4.9751353E-02,   5.6043878E-02,   6.3310817E-02
     +,   7.1629502E-02,   8.1052303E-02,   9.1614865E-02
     +,   0.1033563    ,   0.1163455    ,   0.1307133    
     +,   0.1466753    ,   0.1645397    ,   0.1846864    
     +,   0.2075046    ,   0.2333009    ,   0.2622145    
     +,   0.2942145    ,   0.3292505    ,   0.3675598    
     +,   0.4100194    ,   0.4583019    ,   0.5145491    
     +,   0.5804455    ,   0.6559757    ,   0.7386917    
     +,   0.8241300    ,   0.9071370    ,   0.9828615    
     +,    1.046963    ,    1.096058    ,    1.128868    
     +,    1.146629    ,    1.151527    ,    1.144621    
     +,    1.126056    ,    1.097477    ,    1.062892    
     +,    1.025870    ,   0.9866192    ,   0.9430969    
     +,   0.8944998    ,   0.8422891    ,   0.7882230    
     +,   0.7327644    ,   0.6758888    ,   0.6188011    
     +,   0.5644577    ,   0.5165142    ,   0.4777180    
     +,   0.4487685    ,   0.4281521    ,   0.4129021    
     +,   0.3998029    ,   0.3864509    ,   0.3717371    
     +,   0.3557044    ,   0.3390501    ,   0.3226030    
     +,   0.3069949    ,   0.2925417    ,   0.2792781    
     +,   0.2670475    ,   0.2556030    ,   0.2447015    
     +,   0.2341762    ,   0.2239647    ,   0.2140992    
     +,   0.2046584    ,   0.1957129    ,   0.1872821    
     +,   0.1793246    ,   0.1717534    ,   0.1644699    
     +,   0.1573945    ,   0.1504863    ,   0.1437457    
     +,   0.1372036    ,   0.1309041    ,   0.1248896    
     +,   0.1191920    ,   0.1138278    ,   0.1088021    
     +,   0.1041113    ,   9.9749461E-02,   9.5709145E-02
     +,   9.1984242E-02,   8.8567711E-02,   8.5451715E-02
     +,   8.2625583E-02,   8.0075257E-02,   7.7783935E-02
     +,   7.5732134E-02,   7.3898666E-02,   7.2262548E-02
     +,   7.0803732E-02,   6.9503903E-02,   6.8347529E-02
     +,   6.7322008E-02,   6.6417851E-02,   6.5628044E-02
     +,   6.4948007E-02,   6.4374745E-02,   6.3905880E-02
     +,   6.3539110E-02,   6.3271336E-02,   6.3097775E-02
     +,   6.3011341E-02,   6.3002206E-02,   6.3057438E-02
     +,   6.3160695E-02,   6.3292891E-02,   6.3431792E-02
     +,   6.3553318E-02,   6.3631877E-02,   6.3641347E-02
     +,   6.3556314E-02,   6.3352838E-02,   6.3009784E-02
     +,   6.2509485E-02,   6.1838526E-02,   6.0988467E-02
     +,   5.9956204E-02,   5.8743760E-02,   5.7358474E-02
     +,   5.5812489E-02,   5.4122265E-02,   5.2307647E-02
     +,   5.0391212E-02,   4.8397545E-02,   4.6351928E-02
     +,   4.4279799E-02,   4.2205941E-02,   4.0153742E-02
     +,   3.8144518E-02,   3.6197130E-02,   3.4327898E-02
     +,   3.2550201E-02,   3.0874394E-02,   2.9307919E-02
     +,   2.7855620E-02,   2.6519705E-02,   2.5300048E-02
     +,   2.4194520E-02,   2.3199370E-02,   2.2309370E-02
     +,   2.1518154E-02,   2.0818584E-02,   2.0202924E-02
     +,   1.9663010E-02,   1.9190487E-02,   1.8777067E-02
     +,   1.8414501E-02,   1.8094780E-02,   1.7810203E-02
     +,   1.7553458E-02,   1.7317690E-02,   1.7096490E-02
     +,   1.6883979E-02,   1.6674833E-02,   1.6464259E-02
     +,   1.6248045E-02,   1.6022578E-02,   1.5784817E-02
     +,   1.5532264E-02,   1.5263018E-02,   1.4975724E-02
     +,   1.4669567E-02,   1.4344204E-02,   1.3999770E-02
     +,   1.3636838E-02,   1.3256374E-02,   1.2859669E-02
     +,   1.2448292E-02,   1.2024104E-02,   1.1589102E-02
     +,   1.1145435E-02,   1.0695363E-02,   1.0241183E-02
     +,   9.7851716E-03,   9.3295584E-03,   8.8765277E-03
     +,   8.4281554E-03,   7.9863491E-03,   7.5528701E-03
     +,   7.1293325E-03,   6.7171711E-03,   6.3176076E-03
     +,   5.9316666E-03,   5.5602281E-03,   5.2039493E-03
     +,   4.8633106E-03,   4.5386497E-03,   4.2301463E-03
     +,   3.9378176E-03,   3.6615527E-03,   3.4011479E-03
     +,   3.1562941E-03,   2.9265822E-03,   2.7115347E-03
     +,   2.5106273E-03,   2.3232903E-03,   2.1489072E-03
     +,   1.9868372E-03,   1.8364449E-03,   1.6970701E-03
     +,   1.5680569E-03,   1.4487657E-03,   1.3385699E-03
     +,   1.2368534E-03,   1.1430213E-03,   1.0565113E-03
     +,   9.7678520E-04,   9.0332777E-04,   8.3565299E-04
     +,   7.7330880E-04,   7.1587163E-04,   6.6294242E-04
     +,   6.1415083E-04,   5.6915882E-04,   5.2764913E-04
     +,   4.8933015E-04,   4.5393631E-04,   4.2122399E-04
     +,   3.9096829E-04,   3.6296391E-04,   3.3702550E-04
     +,   3.1298411E-04,   2.9068449E-04,   2.6998561E-04
     +,   2.5076064E-04,   2.3289440E-04,   2.1628087E-04
     +,   2.0082400E-04,   1.8643784E-04,   1.7304259E-04
     +,   1.6056585E-04,   1.4894210E-04,   1.3811157E-04
     +,   1.2801886E-04,   1.1861308E-04,   1.0984809E-04
     +,   1.0168146E-04,   9.4073301E-05,   8.6986889E-05
     +,   8.0388789E-05,   7.4247022E-05,   6.8532725E-05
     +,   6.3218118E-05,   5.8277994E-05,   5.3688080E-05
     +,   4.9426246E-05,   4.5471163E-05,   4.1803276E-05
     +,   3.8403759E-05,   3.5255340E-05,   3.2341413E-05
     +,   2.9646384E-05,   2.7155826E-05,   2.4855814E-05
     +,   2.2733542E-05,   2.0776672E-05,   1.8973864E-05
     +,   1.7314205E-05,   1.5787668E-05,   1.4384610E-05
     +,   1.3096190E-05,   1.1913929E-05,   1.0830050E-05
     +,   9.8371183E-06,   8.9283130E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_ashz_htt65_mass = Yx/9.583154
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_ashz_htt70_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.5461271E-03,   1.6320492E-03
     +,   1.7223571E-03,   1.8172286E-03,   1.9168527E-03
     +,   2.0214322E-03,   2.1311871E-03,   2.2463647E-03
     +,   2.3672390E-03,   2.4941296E-03,   2.6273995E-03
     +,   2.7674721E-03,   2.9148466E-03,   3.0701102E-03
     +,   3.2339557E-03,   3.4072057E-03,   3.5908269E-03
     +,   3.7859622E-03,   3.9939536E-03,   4.2163706E-03
     +,   4.4550397E-03,   4.7120689E-03,   4.9898745E-03
     +,   5.2912249E-03,   5.6192051E-03,   5.9773037E-03
     +,   6.3693449E-03,   6.7995158E-03,   7.2723310E-03
     +,   7.7925958E-03,   8.3653592E-03,   8.9958487E-03
     +,   9.6894084E-03,   1.0451445E-02,   1.1287356E-02
     +,   1.2202516E-02,   1.3202249E-02,   1.4291853E-02
     +,   1.5476773E-02,   1.6762504E-02,   1.8155023E-02
     +,   1.9660890E-02,   2.1287635E-02,   2.3044283E-02
     +,   2.4942145E-02,   2.6995948E-02,   2.9225560E-02
     +,   3.1658370E-02,   3.4332562E-02,   3.7300862E-02
     +,   4.0635031E-02,   4.4429585E-02,   4.8804283E-02
     +,   5.3903904E-02,   5.9892841E-02,   6.6946901E-02
     +,   7.5240463E-02,   8.4936984E-02,   9.6187614E-02
     +,   0.1091430    ,   0.1239785    ,   0.1409222    
     +,   0.1602743    ,   0.1824247    ,   0.2078796    
     +,   0.2373329    ,   0.2717928    ,   0.3126455    
     +,   0.3614592    ,   0.4192276    ,   0.4851912    
     +,   0.5559973    ,   0.6264174    ,   0.6917841    
     +,   0.7505582    ,   0.8046920    ,   0.8575920    
     +,   0.9120542    ,   0.9700097    ,    1.032637    
     +,    1.098886    ,    1.164306    ,    1.222194    
     +,    1.265360    ,    1.288562    ,    1.293368    
     +,    1.290109    ,    1.291449    ,    1.302081    
     +,    1.312547    ,    1.302819    ,    1.256699    
     +,    1.176820    ,    1.084159    ,    1.000544    
     +,   0.9326923    ,   0.8733938    ,   0.8136392    
     +,   0.7503610    ,   0.6859389    ,   0.6248320    
     +,   0.5709953    ,   0.5263432    ,   0.4904603    
     +,   0.4615682    ,   0.4378418    ,   0.4180594    
     +,   0.4014878    ,   0.3875256    ,   0.3754888    
     +,   0.3645568    ,   0.3537981    ,   0.3422788    
     +,   0.3292547    ,   0.3143972    ,   0.2979103    
     +,   0.2804660    ,   0.2629552    ,   0.2461892    
     +,   0.2306680    ,   0.2165150    ,   0.2035630    
     +,   0.1915197    ,   0.1801247    ,   0.1692438    
     +,   0.1588879    ,   0.1491713    ,   0.1402572    
     +,   0.1322998    ,   0.1254095    ,   0.1196324    
     +,   0.1149480    ,   0.1112737    ,   0.1084791    
     +,   0.1063994    ,   0.1048511    ,   0.1036471    
     +,   0.1026086    ,   0.1015748    ,   0.1004095    
     +,   9.9006653E-02,   9.7292125E-02,   9.5224597E-02
     +,   9.2794359E-02,   9.0020634E-02,   8.6947136E-02
     +,   8.3636448E-02,   8.0163985E-02,   7.6611087E-02
     +,   7.3058233E-02,   6.9579124E-02,   6.6236749E-02
     +,   6.3079625E-02,   6.0140144E-02,   5.7434883E-02
     +,   5.4965891E-02,   5.2722864E-02,   5.0685674E-02
     +,   4.8827797E-02,   4.7119271E-02,   4.5529015E-02
     +,   4.4027265E-02,   4.2587336E-02,   4.1186646E-02
     +,   3.9807301E-02,   3.8436446E-02,   3.7066244E-02
     +,   3.5693455E-02,   3.4318842E-02,   3.2946520E-02
     +,   3.1583376E-02,   3.0238200E-02,   2.8920809E-02
     +,   2.7641507E-02,   2.6410466E-02,   2.5236994E-02
     +,   2.4129115E-02,   2.3093401E-02,   2.2134544E-02
     +,   2.1255247E-02,   2.0456273E-02,   1.9736568E-02
     +,   1.9093338E-02,   1.8522304E-02,   1.8017929E-02
     +,   1.7573822E-02,   1.7182924E-02,   1.6837796E-02
     +,   1.6530897E-02,   1.6254848E-02,   1.6002567E-02
     +,   1.5767438E-02,   1.5543429E-02,   1.5325196E-02
     +,   1.5108057E-02,   1.4888058E-02,   1.4661968E-02
     +,   1.4427240E-02,   1.4181945E-02,   1.3924753E-02
     +,   1.3654871E-02,   1.3371984E-02,   1.3076169E-02
     +,   1.2767831E-02,   1.2447728E-02,   1.2116796E-02
     +,   1.1776155E-02,   1.1427096E-02,   1.1070997E-02
     +,   1.0709267E-02,   1.0343356E-02,   9.9747162E-03
     +,   9.6047791E-03,   9.2349118E-03,   8.8664126E-03
     +,   8.5005295E-03,   8.1384247E-03,   7.7811447E-03
     +,   7.4296459E-03,   7.0848092E-03,   6.7473873E-03
     +,   6.4180424E-03,   6.0973596E-03,   5.7858303E-03
     +,   5.4838359E-03,   5.1916870E-03,   4.9096276E-03
     +,   4.6378393E-03,   4.3764119E-03,   4.1253846E-03
     +,   3.8847567E-03,   3.6544793E-03,   3.4344462E-03
     +,   3.2245177E-03,   3.0245367E-03,   2.8343017E-03
     +,   2.6535867E-03,   2.4821570E-03,   2.3197595E-03
     +,   2.1661164E-03,   2.0209400E-03,   1.8839426E-03
     +,   1.7548298E-03,   1.6332945E-03,   1.5190270E-03
     +,   1.4117244E-03,   1.3110838E-03,   1.2167966E-03
     +,   1.1285592E-03,   1.0460798E-03,   9.6906308E-04
     +,   8.9722028E-04,   8.3027402E-04,   7.6795433E-04
     +,   7.0999382E-04,   6.5613486E-04,   6.0613174E-04
     +,   5.5974768E-04,   5.1675254E-04,   4.7692528E-04
     +,   4.4005833E-04,   4.0595318E-04,   3.7441909E-04
     +,   3.4527504E-04,   3.1835341E-04,   2.9349260E-04
     +,   2.7054126E-04,   2.4935851E-04,   2.2981234E-04
     +,   2.1177813E-04,   1.9513977E-04,   1.7979030E-04
     +,   1.6563034E-04,   1.5256666E-04,   1.4051326E-04
     +,   1.2939167E-04,   1.1912815E-04,   1.0965595E-04
     +,   1.0091249E-04,   9.2841314E-05,   8.5389518E-05
     +,   7.8509445E-05,   7.2156457E-05,   6.6290428E-05
     +,   6.0873714E-05,   5.5872482E-05,   5.1255181E-05
     +,   4.6992798E-05,   4.3059095E-05,   3.9429367E-05
     +,   3.6081376E-05,   3.2994154E-05,   3.0148758E-05
     +,   2.7527285E-05,   2.5113548E-05,   2.2892211E-05
     +,   2.0849349E-05,   1.8971779E-05,   1.7247487E-05
     +,   1.5665073E-05,   1.4214147E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_ashz_htt70_mass = Yx/10.9494214285714
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_ashz_htt75_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.8551161E-03,   1.9429773E-03
     +,   2.0339401E-03,   2.1279701E-03,   2.2250253E-03
     +,   2.3250605E-03,   2.4280204E-03,   2.5338512E-03
     +,   2.6424979E-03,   2.7539157E-03,   2.8680591E-03
     +,   2.9848979E-03,   3.1044190E-03,   3.2266253E-03
     +,   3.3515478E-03,   3.4792449E-03,   3.6098105E-03
     +,   3.7433747E-03,   3.8801115E-03,   4.0202416E-03
     +,   4.1640303E-03,   4.3118033E-03,   4.4639320E-03
     +,   4.6208538E-03,   4.7830446E-03,   4.9510533E-03
     +,   5.1254728E-03,   5.3069475E-03,   5.4961736E-03
     +,   5.6938939E-03,   5.9008924E-03,   6.1179991E-03
     +,   6.3460851E-03,   6.5860627E-03,   6.8389005E-03
     +,   7.1056164E-03,   7.3873186E-03,   7.6851924E-03
     +,   8.0006029E-03,   8.3350455E-03,   8.6903181E-03
     +,   9.0685282E-03,   9.4722295E-03,   9.9045495E-03
     +,   1.0369322E-02,   1.0871262E-02,   1.1416123E-02
     +,   1.2010880E-02,   1.2663832E-02,   1.3384713E-02
     +,   1.4184709E-02,   1.5076363E-02,   1.6073365E-02
     +,   1.7190296E-02,   1.8441992E-02,   1.9843295E-02
     +,   2.1408174E-02,   2.3149362E-02,   2.5077734E-02
     +,   2.7202077E-02,   2.9528944E-02,   3.2062866E-02
     +,   3.4806546E-02,   3.7761997E-02,   4.0931258E-02
     +,   4.4317417E-02,   4.7926791E-02,   5.1769756E-02
     +,   5.5864107E-02,   6.0236417E-02,   6.4926602E-02
     +,   6.9990627E-02,   7.5507514E-02,   8.1583664E-02
     +,   8.8360526E-02,   9.6017443E-02,   0.1047695    
     +,   0.1148575    ,   0.1265342    ,   0.1400546    
     +,   0.1556866    ,   0.1737547    ,   0.1946842    
     +,   0.2189978    ,   0.2471685    ,   0.2793502    
     +,   0.3151040    ,   0.3534263    ,   0.3932176    
     +,   0.4340242    ,   0.4764510    ,   0.5218615    
     +,   0.5717697    ,   0.6280518    ,   0.6941975    
     +,   0.7752064    ,   0.8731624    ,   0.9811518    
     +,    1.084754    ,    1.173584    ,    1.249811    
     +,    1.321524    ,    1.390108    ,    1.446982    
     +,    1.479997    ,    1.482126    ,    1.456656    
     +,    1.414527    ,    1.365945    ,    1.313975    
     +,    1.257050    ,    1.196353    ,    1.136174    
     +,    1.078922    ,    1.024029    ,   0.9698539    
     +,   0.9163011    ,   0.8669242    ,   0.8262504    
     +,   0.7937359    ,   0.7624626    ,   0.7248092    
     +,   0.6783438    ,   0.6262035    ,   0.5735385    
     +,   0.5243625    ,   0.4805447    ,   0.4421412    
     +,   0.4080822    ,   0.3769618    ,   0.3477509    
     +,   0.3201860    ,   0.2946764    ,   0.2719035    
     +,   0.2523917    ,   0.2362882    ,   0.2233682    
     +,   0.2131582    ,   0.2050752    ,   0.1985244    
     +,   0.1929508    ,   0.1878707    ,   0.1828877    
     +,   0.1777028    ,   0.1721117    ,   0.1659956    
     +,   0.1593093    ,   0.1520720    ,   0.1443578    
     +,   0.1362892    ,   0.1280260    ,   0.1197518    
     +,   0.1116561    ,   0.1039142    ,   9.6673332E-02
     +,   9.0041637E-02,   8.4083341E-02,   7.8819014E-02
     +,   7.4231118E-02,   7.0271917E-02,   6.6870697E-02
     +,   6.3943073E-02,   6.1398454E-02,   5.9146885E-02
     +,   5.7104480E-02,   5.5197861E-02,   5.3367753E-02
     +,   5.1570475E-02,   4.9778704E-02,   4.7980770E-02
     +,   4.6179276E-02,   4.4388440E-02,   4.2630974E-02
     +,   4.0934894E-02,   3.9330252E-02,   3.7845772E-02
     +,   3.6506463E-02,   3.5331629E-02,   3.4333497E-02
     +,   3.3516463E-02,   3.2877401E-02,   3.2406066E-02
     +,   3.2086164E-02,   3.1896584E-02,   3.1812925E-02
     +,   3.1808853E-02,   3.1857468E-02,   3.1932585E-02
     +,   3.2009643E-02,   3.2066572E-02,   3.2084264E-02
     +,   3.2046892E-02,   3.1942137E-02,   3.1761017E-02
     +,   3.1497810E-02,   3.1149667E-02,   3.0716397E-02
     +,   3.0200003E-02,   2.9604273E-02,   2.8934335E-02
     +,   2.8196448E-02,   2.7397513E-02,   2.6544794E-02
     +,   2.5645759E-02,   2.4707846E-02,   2.3738304E-02
     +,   2.2744073E-02,   2.1731861E-02,   2.0707976E-02
     +,   1.9678369E-02,   1.8648580E-02,   1.7623886E-02
     +,   1.6609251E-02,   1.5609259E-02,   1.4628164E-02
     +,   1.3669983E-02,   1.2738422E-02,   1.1836766E-02
     +,   1.0967964E-02,   1.0134648E-02,   9.3389843E-03
     +,   8.5827122E-03,   7.8671901E-03,   7.1933353E-03
     +,   6.5615857E-03,   5.9719584E-03,   5.4241051E-03
     +,   4.9173008E-03,   4.4504390E-03,   4.0221317E-03
     +,   3.6307524E-03,   3.2744710E-03,   2.9512721E-03
     +,   2.6590324E-03,   2.3955933E-03,   2.1587412E-03
     +,   1.9462779E-03,   1.7560658E-03,   1.5860372E-03
     +,   1.4342103E-03,   1.2987145E-03,   1.1778157E-03
     +,   1.0699081E-03,   9.7351475E-04,   8.8729506E-04
     +,   8.1004854E-04,   7.4069982E-04,   6.7829061E-04
     +,   6.2197563E-04,   5.7101931E-04,   5.2477472E-04
     +,   4.8268063E-04,   4.4425466E-04,   4.0908085E-04
     +,   3.7679891E-04,   3.4710031E-04,   3.1972196E-04
     +,   2.9443804E-04,   2.7105262E-04,   2.4939678E-04
     +,   2.2932570E-04,   2.1071298E-04,   1.9344660E-04
     +,   1.7742765E-04,   1.6256946E-04,   1.4879271E-04
     +,   1.3602550E-04,   1.2420288E-04,   1.1326497E-04
     +,   1.0315533E-04,   9.3821422E-05,   8.5214459E-05
     +,   7.7288409E-05,   6.9999056E-05,   6.3304709E-05
     +,   5.7166282E-05,   5.1545838E-05,   4.6408084E-05
     +,   4.1718737E-05,   3.7445912E-05,   3.3558783E-05
     +,   3.0028645E-05,   2.6827931E-05,   2.3930996E-05
     +,   2.1313330E-05,   1.8952227E-05,   1.6826134E-05
     +,   1.4914926E-05,   1.3199970E-05,   1.1663689E-05
     +,   1.0289950E-05,   9.0636140E-06,   7.9708407E-06
     +,   6.9987132E-06,   6.1354654E-06,   5.3701838E-06
     +,   4.6929708E-06,   4.0946857E-06,   3.5670766E-06
     +,   3.1025627E-06,   2.6943260E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_ashz_htt75_mass = Yx/11.5072221428571
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_ashz_htt80_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  9.8443613E-04,   1.0202050E-03
     +,   1.0573704E-03,   1.0959463E-03,   1.1359387E-03
     +,   1.1773481E-03,   1.2201655E-03,   1.2643761E-03
     +,   1.3099547E-03,   1.3568713E-03,   1.4050863E-03
     +,   1.4545517E-03,   1.5052143E-03,   1.5570140E-03
     +,   1.6098857E-03,   1.6637634E-03,   1.7185755E-03
     +,   1.7742558E-03,   1.8307401E-03,   1.8879717E-03
     +,   1.9459057E-03,   2.0045135E-03,   2.0637871E-03
     +,   2.1237491E-03,   2.1844502E-03,   2.2459878E-03
     +,   2.3085070E-03,   2.3722083E-03,   2.4373606E-03
     +,   2.5043071E-03,   2.5734759E-03,   2.6453894E-03
     +,   2.7206701E-03,   2.8000511E-03,   2.8843812E-03
     +,   2.9746294E-03,   3.0718918E-03,   3.1773811E-03
     +,   3.2924439E-03,   3.4185261E-03,   3.5571898E-03
     +,   3.7100865E-03,   3.8789352E-03,   4.0655076E-03
     +,   4.2715962E-03,   4.4989819E-03,   4.7493987E-03
     +,   5.0244960E-03,   5.3257924E-03,   5.6546405E-03
     +,   6.0121706E-03,   6.3992543E-03,   6.8164547E-03
     +,   7.2640264E-03,   7.7417968E-03,   8.2492512E-03
     +,   8.7854266E-03,   9.3489625E-03,   9.9380855E-03
     +,   1.0550658E-02,   1.1184235E-02,   1.1836150E-02
     +,   1.2503600E-02,   1.3183906E-02,   1.3874676E-02
     +,   1.4574032E-02,   1.5281105E-02,   1.5996264E-02
     +,   1.6721768E-02,   1.7462127E-02,   1.8224794E-02
     +,   1.9020526E-02,   1.9864053E-02,   2.0774169E-02
     +,   2.1774072E-02,   2.2891171E-02,   2.4156557E-02
     +,   2.5604255E-02,   2.7270101E-02,   2.9190276E-02
     +,   3.1399343E-02,   3.3929043E-02,   3.6806382E-02
     +,   4.0053591E-02,   4.3687835E-02,   4.7724068E-02
     +,   5.2177668E-02,   5.7070717E-02,   6.2436391E-02
     +,   6.8325251E-02,   7.4807249E-02,   8.1969500E-02
     +,   8.9909196E-02,   9.8721929E-02,   0.1084865    
     +,   0.1192544    ,   0.1310537    ,   0.1439083    
     +,   0.1578844    ,   0.1731407    ,   0.1899811    
     +,   0.2088764    ,   0.2304689    ,   0.2555449    
     +,   0.2849774    ,   0.3195597    ,   0.3596536    
     +,   0.4047176    ,   0.4530788    ,   0.5025192    
     +,   0.5517460    ,   0.6016197    ,   0.6545693    
     +,   0.7126039    ,   0.7763413    ,   0.8459509    
     +,   0.9219151    ,    1.005221    ,    1.097215    
     +,    1.195774    ,    1.290311    ,    1.367696    
     +,    1.425321    ,    1.472815    ,    1.520962    
     +,    1.568080    ,    1.600203    ,    1.613289    
     +,    1.621023    ,    1.629024    ,    1.619299    
     +,    1.570656    ,    1.483214    ,    1.375473    
     +,    1.264718    ,    1.157547    ,    1.057554    
     +,   0.9733558    ,   0.9117019    ,   0.8678754    
     +,   0.8296094    ,   0.7870426    ,   0.7363438    
     +,   0.6782855    ,   0.6165825    ,   0.5562145    
     +,   0.5013828    ,   0.4542812    ,   0.4151139    
     +,   0.3826987    ,   0.3551357    ,   0.3304753    
     +,   0.3072811    ,   0.2848888    ,   0.2632860    
     +,   0.2427925    ,   0.2237610    ,   0.2064121    
     +,   0.1907920    ,   0.1767877    ,   0.1641576    
     +,   0.1525806    ,   0.1417187    ,   0.1312824    
     +,   0.1210837    ,   0.1110619    ,   0.1012787    
     +,   9.1885455E-02,   8.3078519E-02,   7.5055547E-02
     +,   6.7980304E-02,   6.1959721E-02,   5.7034995E-02
     +,   5.3184249E-02,   5.0333124E-02,   4.8367601E-02
     +,   4.7149856E-02,   4.6532366E-02,   4.6369676E-02
     +,   4.6527464E-02,   4.6888445E-02,   4.7355555E-02
     +,   4.7852699E-02,   4.8323814E-02,   4.8730616E-02
     +,   4.9049705E-02,   4.9269546E-02,   4.9387090E-02
     +,   4.9405266E-02,   4.9330134E-02,   4.9168997E-02
     +,   4.8928890E-02,   4.8615288E-02,   4.8231520E-02
     +,   4.7778390E-02,   4.7254227E-02,   4.6655186E-02
     +,   4.5975782E-02,   4.5209404E-02,   4.4349302E-02
     +,   4.3389115E-02,   4.2323917E-02,   4.1150488E-02
     +,   3.9868072E-02,   3.8478903E-02,   3.6988124E-02
     +,   3.5403930E-02,   3.3737622E-02,   3.2003134E-02
     +,   3.0216489E-02,   2.8395334E-02,   2.6558453E-02
     +,   2.4724932E-02,   2.2913398E-02,   2.1141477E-02
     +,   1.9425362E-02,   1.7779207E-02,   1.6214728E-02
     +,   1.4741066E-02,   1.3364880E-02,   1.2090061E-02
     +,   1.0918088E-02,   9.8482929E-03,   8.8781118E-03
     +,   8.0033178E-03,   7.2185029E-03,   6.5174573E-03
     +,   5.8934027E-03,   5.3392914E-03,   4.8480835E-03
     +,   4.4129761E-03,   4.0275101E-03,   3.6856618E-03
     +,   3.3819338E-03,   3.1114127E-03,   2.8697085E-03
     +,   2.6529699E-03,   2.4578655E-03,   2.2815201E-03
     +,   2.1214599E-03,   1.9755757E-03,   1.8420847E-03
     +,   1.7194768E-03,   1.6064639E-03,   1.5019580E-03
     +,   1.4050434E-03,   1.3149434E-03,   1.2309919E-03
     +,   1.1526217E-03,   1.0793547E-03,   1.0107741E-03
     +,   9.4651926E-04,   8.8628248E-04,   8.2979439E-04
     +,   7.7681342E-04,   7.2712573E-04,   6.8054255E-04
     +,   6.3689193E-04,   5.9601350E-04,   5.5775890E-04
     +,   5.2199123E-04,   4.8858073E-04,   4.5740191E-04
     +,   4.2833399E-04,   4.0126353E-04,   3.7607798E-04
     +,   3.5266843E-04,   3.3093069E-04,   3.1076357E-04
     +,   2.9206774E-04,   2.7474735E-04,   2.5871114E-04
     +,   2.4387127E-04,   2.3014238E-04,   2.1744346E-04
     +,   2.0569813E-04,   1.9483281E-04,   1.8477916E-04
     +,   1.7547158E-04,   1.6684980E-04,   1.5885623E-04
     +,   1.5143826E-04,   1.4454617E-04,   1.3813465E-04
     +,   1.3216116E-04,   1.2658726E-04,   1.2137717E-04
     +,   1.1649803E-04,   1.1192042E-04,   1.0761689E-04
     +,   1.0356303E-04,   9.9736229E-05,   9.6116411E-05
     +,   9.2685033E-05,   8.9425834E-05,   8.6323686E-05
     +,   8.3365390E-05,   8.0538732E-05,   7.7833101E-05
     +,   7.5238655E-05,   7.2746865E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_ashz_htt80_mass = Yx/12.39871164
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_ashz_htt85_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.4368121E-03,   1.4802336E-03
     +,   1.5239766E-03,   1.5679637E-03,   1.6121138E-03
     +,   1.6563419E-03,   1.7005606E-03,   1.7446788E-03
     +,   1.7886049E-03,   1.8322464E-03,   1.8755095E-03
     +,   1.9183008E-03,   1.9605297E-03,   2.0021079E-03
     +,   2.0429492E-03,   2.0829733E-03,   2.1221046E-03
     +,   2.1602765E-03,   2.1974274E-03,   2.2335087E-03
     +,   2.2684792E-03,   2.3023116E-03,   2.3349924E-03
     +,   2.3665223E-03,   2.3969170E-03,   2.4262113E-03
     +,   2.4544580E-03,   2.4817314E-03,   2.5081246E-03
     +,   2.5337564E-03,   2.5587659E-03,   2.5833200E-03
     +,   2.6076077E-03,   2.6318482E-03,   2.6562838E-03
     +,   2.6811848E-03,   2.7068486E-03,   2.7335985E-03
     +,   2.7617854E-03,   2.7917812E-03,   2.8239868E-03
     +,   2.8588229E-03,   2.8967301E-03,   2.9381674E-03
     +,   2.9836118E-03,   3.0335514E-03,   3.0884878E-03
     +,   3.1489276E-03,   3.2153882E-03,   3.2883831E-03
     +,   3.3684373E-03,   3.4560713E-03,   3.5518054E-03
     +,   3.6561717E-03,   3.7696920E-03,   3.8929149E-03
     +,   4.0263925E-03,   4.1707093E-03,   4.3264804E-03
     +,   4.4943760E-03,   4.6751285E-03,   4.8695602E-03
     +,   5.0785933E-03,   5.3032902E-03,   5.5448790E-03
     +,   5.8047352E-03,   6.0844868E-03,   6.3859429E-03
     +,   6.7111999E-03,   7.0625623E-03,   7.4426294E-03
     +,   7.8541869E-03,   8.3002793E-03,   8.7840362E-03
     +,   9.3087154E-03,   9.8775569E-03,   1.0493632E-02
     +,   1.1159721E-02,   1.1878223E-02,   1.2650939E-02
     +,   1.3478843E-02,   1.4362105E-02,   1.5299750E-02
     +,   1.6289830E-02,   1.7329140E-02,   1.8413577E-02
     +,   1.9538030E-02,   2.0696910E-02,   2.1884268E-02
     +,   2.3094591E-02,   2.4323264E-02,   2.5567213E-02
     +,   2.6825653E-02,   2.8101040E-02,   2.9399568E-02
     +,   3.0731775E-02,   3.2113310E-02,   3.3565093E-02
     +,   3.5114061E-02,   3.6793314E-02,   3.8643058E-02
     +,   4.0710840E-02,   4.3052640E-02,   4.5732826E-02
     +,   4.8824552E-02,   5.2408788E-02,   5.6572441E-02
     +,   6.1406072E-02,   6.7002431E-02,   7.3453821E-02
     +,   8.0850519E-02,   8.9281395E-02,   9.8831721E-02
     +,   0.1095861    ,   0.1216293    ,   0.1350577    
     +,   0.1499862    ,   0.1665540    ,   0.1848999    
     +,   0.2051188    ,   0.2272070    ,   0.2510553    
     +,   0.2765219    ,   0.3035453    ,   0.3321553    
     +,   0.3622870    ,   0.3935089    ,   0.4250105    
     +,   0.4562113    ,   0.4877102    ,   0.5215824    
     +,   0.5600823    ,   0.6037040    ,   0.6516028    
     +,   0.7060338    ,   0.7763707    ,   0.8749994    
     +,    1.005105    ,    1.152388    ,    1.293157    
     +,    1.412809    ,    1.510252    ,    1.582020    
     +,    1.615241    ,    1.607972    ,    1.586763    
     +,    1.586676    ,    1.620434    ,    1.673561    
     +,    1.718614    ,    1.733366    ,    1.709362    
     +,    1.643869    ,    1.538340    ,    1.412061    
     +,    1.292352    ,    1.186267    ,    1.082445    
     +,   0.9758686    ,   0.8742768    ,   0.7857435    
     +,   0.7101591    ,   0.6410415    ,   0.5723084    
     +,   0.5032216    ,   0.4374631    ,   0.3790070    
     +,   0.3296358    ,   0.2891120    ,   0.2562282    
     +,   0.2294756    ,   0.2073125    ,   0.1883370    
     +,   0.1714663    ,   0.1560573    ,   0.1418991    
     +,   0.1290964    ,   0.1179008    ,   0.1085577    
     +,   0.1012119    ,   9.5877044E-02,   9.2447035E-02
     +,   9.0728216E-02,   9.0477332E-02,   9.1434367E-02
     +,   9.3347050E-02,   9.5984608E-02,   9.9143080E-02
     +,   0.1026410    ,   0.1063089    ,   0.1099763    
     +,   0.1134602    ,   0.1165577    ,   0.1190490    
     +,   0.1207089    ,   0.1213275    ,   0.1207349    
     +,   0.1188259    ,   0.1155786    ,   0.1110615    
     +,   0.1054293    ,   9.8905407E-02,   9.1755927E-02
     +,   8.4260523E-02,   7.6684885E-02,   6.9257215E-02
     +,   6.2155452E-02,   5.5502575E-02,   4.9369209E-02
     +,   4.3781698E-02,   3.8733691E-02,   3.4197878E-02
     +,   3.0135544E-02,   2.6503930E-02,   2.3261508E-02
     +,   2.0370642E-02,   1.7798200E-02,   1.5515089E-02
     +,   1.3495612E-02,   1.1716723E-02,   1.0156767E-02
     +,   8.7952018E-03,   7.6123509E-03,   6.5892437E-03
     +,   5.7076528E-03,   4.9503678E-03,   4.3014074E-03
     +,   3.7461172E-03,   3.2712438E-03,   2.8650344E-03
     +,   2.5172338E-03,   2.2189789E-03,   1.9626820E-03
     +,   1.7419223E-03,   1.5513215E-03,   1.3863589E-03
     +,   1.2432567E-03,   1.1188691E-03,   1.0105576E-03
     +,   9.1609609E-04,   8.3360326E-04,   7.6148438E-04
     +,   6.9837284E-04,   6.4308918E-04,   5.9461314E-04
     +,   5.5206189E-04,   5.1466515E-04,   4.8174788E-04
     +,   4.5271951E-04,   4.2706626E-04,   4.0433512E-04
     +,   3.8413002E-04,   3.6610584E-04,   3.4996102E-04
     +,   3.3543131E-04,   3.2228677E-04,   3.1032861E-04
     +,   2.9938400E-04,   2.8930308E-04,   2.7995635E-04
     +,   2.7123332E-04,   2.6303914E-04,   2.5529234E-04
     +,   2.4792389E-04,   2.4087589E-04,   2.3409925E-04
     +,   2.2755291E-04,   2.2120326E-04,   2.1502272E-04
     +,   2.0898841E-04,   2.0308215E-04,   1.9728972E-04
     +,   1.9160022E-04,   1.8600505E-04,   1.8049784E-04
     +,   1.7507466E-04,   1.6973240E-04,   1.6446983E-04
     +,   1.5928611E-04,   1.5418172E-04,   1.4915710E-04
     +,   1.4421385E-04,   1.3935314E-04,   1.3457704E-04
     +,   1.2988705E-04,   1.2528531E-04,   1.2077355E-04
     +,   1.1635338E-04,   1.1202674E-04,   1.0779488E-04
     +,   1.0365944E-04,   9.9621386E-05,   9.5681957E-05
     +,   9.1841743E-05,   8.8101609E-05,   8.4461804E-05
     +,   8.0922786E-05,   7.7484387E-05,   7.4146737E-05
     +,   7.0909293E-05,   6.7771842E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_ashz_htt85_mass = Yx/12.4513515
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_ashz_htt90_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.0384452E-03,   1.0707059E-03
     +,   1.1036631E-03,   1.1373138E-03,   1.1716535E-03
     +,   1.2066752E-03,   1.2423695E-03,   1.2787231E-03
     +,   1.3157198E-03,   1.3533424E-03,   1.3915674E-03
     +,   1.4303691E-03,   1.4697176E-03,   1.5095794E-03
     +,   1.5499167E-03,   1.5906885E-03,   1.6318500E-03
     +,   1.6733517E-03,   1.7151410E-03,   1.7571622E-03
     +,   1.7993556E-03,   1.8416591E-03,   1.8840074E-03
     +,   1.9263361E-03,   1.9685733E-03,   2.0106519E-03
     +,   2.0525013E-03,   2.0940534E-03,   2.1352386E-03
     +,   2.1759912E-03,   2.2162483E-03,   2.2559499E-03
     +,   2.2950426E-03,   2.3334769E-03,   2.3712118E-03
     +,   2.4082134E-03,   2.4444587E-03,   2.4799316E-03
     +,   2.5146334E-03,   2.5485714E-03,   2.5817724E-03
     +,   2.6142742E-03,   2.6461317E-03,   2.6774162E-03
     +,   2.7082181E-03,   2.7386444E-03,   2.7688218E-03
     +,   2.7988963E-03,   2.8290343E-03,   2.8594225E-03
     +,   2.8902655E-03,   2.9217931E-03,   2.9542483E-03
     +,   2.9878984E-03,   3.0230249E-03,   3.0599309E-03
     +,   3.0989312E-03,   3.1403578E-03,   3.1845556E-03
     +,   3.2318807E-03,   3.2826953E-03,   3.3373749E-03
     +,   3.3962920E-03,   3.4598277E-03,   3.5283687E-03
     +,   3.6022887E-03,   3.6819770E-03,   3.7678038E-03
     +,   3.8601568E-03,   3.9594052E-03,   4.0659392E-03
     +,   4.1801399E-03,   4.3024146E-03,   4.4331760E-03
     +,   4.5728753E-03,   4.7220062E-03,   4.8811045E-03
     +,   5.0507658E-03,   5.2316878E-03,   5.4246597E-03
     +,   5.6305709E-03,   5.8504748E-03,   6.0855383E-03
     +,   6.3371225E-03,   6.6067353E-03,   6.8960884E-03
     +,   7.2070337E-03,   7.5416253E-03,   7.9020225E-03
     +,   8.2905265E-03,   8.7095033E-03,   9.1613149E-03
     +,   9.6482597E-03,   1.0172528E-02,   1.0736100E-02
     +,   1.1340597E-02,   1.1987341E-02,   1.2677095E-02
     +,   1.3410246E-02,   1.4186576E-02,   1.5005528E-02
     +,   1.5866101E-02,   1.6767258E-02,   1.7707987E-02
     +,   1.8687872E-02,   1.9707428E-02,   2.0768546E-02
     +,   2.1875057E-02,   2.3033369E-02,   2.4252784E-02
     +,   2.5545781E-02,   2.6928470E-02,   2.8420329E-02
     +,   3.0044578E-02,   3.1827591E-02,   3.3799399E-02
     +,   3.5993177E-02,   3.8446262E-02,   4.1199986E-02
     +,   4.4301067E-02,   4.7802191E-02,   5.1762216E-02
     +,   5.6246132E-02,   6.1324041E-02,   6.7067817E-02
     +,   7.3544979E-02,   8.0811210E-02,   8.8896453E-02
     +,   9.7791627E-02,   0.1074293    ,   0.1176714    
     +,   0.1283003    ,   0.1390293    ,   0.1495277    
     +,   0.1594751    ,   0.1686363    ,   0.1769604    
     +,   0.1847000    ,   0.1925321    ,   0.2016422    
     +,   0.2136962    ,   0.2306079    ,   0.2540393    
     +,   0.2846888    ,   0.3216371    ,   0.3622278    
     +,   0.4028673    ,   0.4406630    ,   0.4750910    
     +,   0.5085446    ,   0.5453382    ,   0.5899559    
     +,   0.6456726    ,   0.7136346    ,   0.7916960    
     +,   0.8738618    ,   0.9529979    ,    1.026188    
     +,    1.096493    ,    1.169300    ,    1.249710    
     +,    1.339540    ,    1.429605    ,    1.503978    
     +,    1.560083    ,    1.607775    ,    1.644956    
     +,    1.652716    ,    1.609990    ,    1.504968    
     +,    1.347209    ,    1.170222    ,    1.009104    
     +,   0.8786623    ,   0.7770679    ,   0.7005134    
     +,   0.6483579    ,   0.6194293    ,   0.6096840    
     +,   0.6145552    ,   0.6314316    ,   0.6583006    
     +,   0.6905296    ,   0.7199942    ,   0.7375810    
     +,   0.7369336    ,   0.7170192    ,   0.6823408    
     +,   0.6407937    ,   0.6002800    ,   0.5658395    
     +,   0.5385670    ,   0.5163893    ,   0.4959127    
     +,   0.4742861    ,   0.4501759    ,   0.4236464    
     +,   0.3954529    ,   0.3664343    ,   0.3372875    
     +,   0.3085927    ,   0.2808572    ,   0.2544876    
     +,   0.2297436    ,   0.2067334    ,   0.1854612    
     +,   0.1658971    ,   0.1480187    ,   0.1318044    
     +,   0.1172069    ,   0.1041340    ,   9.2449978E-02
     +,   8.1991434E-02,   7.2592154E-02,   6.4104408E-02
     +,   5.6410830E-02,   4.9425989E-02,   4.3091089E-02
     +,   3.7366737E-02,   3.2224637E-02,   2.7639367E-02
     +,   2.3584159E-02,   2.0028546E-02,   1.6937405E-02
     +,   1.4271528E-02,   1.1989324E-02,   1.0048634E-02
     +,   8.4080501E-03,   7.0281355E-03,   5.8724862E-03
     +,   4.9082879E-03,   4.1064285E-03,   3.4414320E-03
     +,   2.8913224E-03,   2.4373487E-03,   2.0635212E-03
     +,   1.7563128E-03,   1.5043268E-03,   1.2979615E-03
     +,   1.1291325E-03,   9.9106575E-04,   8.7810622E-04
     +,   7.8554504E-04,   7.0947449E-04,   6.4667931E-04
     +,   5.9453363E-04,   5.5090489E-04,   5.1407190E-04
     +,   4.8265871E-04,   4.5557605E-04,   4.3196176E-04
     +,   4.1114012E-04,   3.9258451E-04,   3.7588397E-04
     +,   3.6071779E-04,   3.4683547E-04,   3.3404093E-04
     +,   3.2217926E-04,   3.1112565E-04,   3.0077883E-04
     +,   2.9105623E-04,   2.8188899E-04,   2.7321780E-04
     +,   2.6499206E-04,   2.5716863E-04,   2.4970880E-04
     +,   2.4257877E-04,   2.3574891E-04,   2.2919320E-04
     +,   2.2288808E-04,   2.1681284E-04,   2.1094964E-04
     +,   2.0528267E-04,   1.9979781E-04,   1.9448272E-04
     +,   1.8932705E-04,   1.8432116E-04,   1.7945722E-04
     +,   1.7472780E-04,   1.7012699E-04,   1.6564901E-04
     +,   1.6128919E-04,   1.5704294E-04,   1.5290650E-04
     +,   1.4887600E-04,   1.4494831E-04,   1.4112018E-04
     +,   1.3738850E-04,   1.3375068E-04,   1.3020370E-04
     +,   1.2674513E-04,   1.2337221E-04,   1.2008257E-04
     +,   1.1687353E-04,   1.1374288E-04,   1.1068802E-04
     +,   1.0770682E-04,   1.0479681E-04,   1.0195595E-04
     +,   9.9181903E-05,   9.6472759E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_ashz_htt90_mass = Yx/12.34607178
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_ashz_htt95_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  9.2090282E-04,   9.5280958E-04
     +,   9.8540250E-04,   1.0186530E-03,   1.0525290E-03
     +,   1.0869930E-03,   1.1220066E-03,   1.1575255E-03
     +,   1.1935018E-03,   1.2298869E-03,   1.2666259E-03
     +,   1.3036636E-03,   1.3409404E-03,   1.3783955E-03
     +,   1.4159669E-03,   1.4535898E-03,   1.4912004E-03
     +,   1.5287328E-03,   1.5661219E-03,   1.6033041E-03
     +,   1.6402166E-03,   1.6767983E-03,   1.7129900E-03
     +,   1.7487383E-03,   1.7839903E-03,   1.8186993E-03
     +,   1.8528238E-03,   1.8863268E-03,   1.9191785E-03
     +,   1.9513551E-03,   1.9828400E-03,   2.0136249E-03
     +,   2.0437089E-03,   2.0731005E-03,   2.1018144E-03
     +,   2.1298775E-03,   2.1573228E-03,   2.1841943E-03
     +,   2.2105454E-03,   2.2364359E-03,   2.2619381E-03
     +,   2.2871306E-03,   2.3121017E-03,   2.3369470E-03
     +,   2.3617689E-03,   2.3866801E-03,   2.4117962E-03
     +,   2.4372428E-03,   2.4631477E-03,   2.4896464E-03
     +,   2.5168781E-03,   2.5449852E-03,   2.5741146E-03
     +,   2.6044184E-03,   2.6360471E-03,   2.6691600E-03
     +,   2.7039149E-03,   2.7404742E-03,   2.7790053E-03
     +,   2.8196787E-03,   2.8626714E-03,   2.9081670E-03
     +,   2.9563564E-03,   3.0074457E-03,   3.0616538E-03
     +,   3.1192114E-03,   3.1803790E-03,   3.2454338E-03
     +,   3.3146902E-03,   3.3884919E-03,   3.4672297E-03
     +,   3.5513337E-03,   3.6412980E-03,   3.7376639E-03
     +,   3.8410497E-03,   3.9521470E-03,   4.0717195E-03
     +,   4.2006085E-03,   4.3397546E-03,   4.4901851E-03
     +,   4.6530012E-03,   4.8294077E-03,   5.0206715E-03
     +,   5.2281497E-03,   5.4532327E-03,   5.6973854E-03
     +,   5.9620570E-03,   6.2487316E-03,   6.5588234E-03
     +,   6.8937107E-03,   7.2546629E-03,   7.6427907E-03
     +,   8.0590127E-03,   8.5040387E-03,   8.9782914E-03
     +,   9.4818315E-03,   1.0014396E-02,   1.0575251E-02
     +,   1.1163273E-02,   1.1776788E-02,   1.2413705E-02
     +,   1.3071341E-02,   1.3746630E-02,   1.4435944E-02
     +,   1.5135317E-02,   1.5840454E-02,   1.6546788E-02
     +,   1.7249636E-02,   1.7944423E-02,   1.8626794E-02
     +,   1.9292742E-02,   1.9939037E-02,   2.0563219E-02
     +,   2.1164121E-02,   2.1741897E-02,   2.2298507E-02
     +,   2.2837834E-02,   2.3366053E-02,   2.3891782E-02
     +,   2.4426362E-02,   2.4983875E-02,   2.5581229E-02
     +,   2.6237996E-02,   2.6976215E-02,   2.7819812E-02
     +,   2.8793786E-02,   2.9923426E-02,   3.1232681E-02
     +,   3.2742884E-02,   3.4470670E-02,   3.6426526E-02
     +,   3.8612422E-02,   4.1020956E-02,   4.3633696E-02
     +,   4.6421625E-02,   4.9345739E-02,   5.2359082E-02
     +,   5.5410340E-02,   5.8448765E-02,   6.1429691E-02
     +,   6.4320311E-02,   6.7105919E-02,   6.9795176E-02
     +,   7.2423920E-02,   7.5056776E-02,   7.7788003E-02
     +,   8.0739044E-02,   8.4053807E-02,   8.7891251E-02
     +,   9.2414565E-02,   9.7775787E-02,   0.1040974    
     +,   0.1114503    ,   0.1198341    ,   0.1291592    
     +,   0.1392374    ,   0.1497904    ,   0.1604762    
     +,   0.1709363    ,   0.1808584    ,   0.1900408    
     +,   0.1984374    ,   0.2061596    ,   0.2134276    
     +,   0.2204769    ,   0.2274419    ,   0.2342706    
     +,   0.2407110    ,   0.2464065    ,   0.2510853    
     +,   0.2547901    ,   0.2580387    ,   0.2618251    
     +,   0.2674187    ,   0.2760537    ,   0.2887126    
     +,   0.3062083    ,   0.3295708    ,   0.3603821    
     +,   0.4005532    ,   0.4515429    ,   0.5138232    
     +,   0.5873557    ,   0.6733657    ,   0.7771021    
     +,   0.9077154    ,    1.068378    ,    1.241872    
     +,    1.396710    ,    1.522183    ,    1.642840    
     +,    1.774081    ,    1.883784    ,    1.929570    
     +,    1.918696    ,    1.889184    ,    1.853634    
     +,    1.816298    ,    1.788665    ,    1.749059    
     +,    1.660902    ,    1.525464    ,    1.369850    
     +,    1.216280    ,    1.077530    ,   0.9569953    
     +,   0.8497894    ,   0.7507072    ,   0.6599334    
     +,   0.5798957    ,   0.5096371    ,   0.4450405    
     +,   0.3832125    ,   0.3244146    ,   0.2703725    
     +,   0.2222877    ,   0.1804408    ,   0.1446822    
     +,   0.1147652    ,   9.0330735E-02,   7.0822686E-02
     +,   5.5521294E-02,   4.3652125E-02,   3.4488037E-02
     +,   2.7407994E-02,   2.1914732E-02,   1.7626103E-02
     +,   1.4255206E-02,   1.1588869E-02,   9.4688227E-03
     +,   7.7765966E-03,   6.4220852E-03,   5.3355941E-03
     +,   4.4624731E-03,   3.7594400E-03,   3.1918082E-03
     +,   2.7317628E-03,   2.3570375E-03,   2.0498384E-03
     +,   1.7960200E-03,   1.5844289E-03,   1.4063475E-03
     +,   1.2549912E-03,   1.1251029E-03,   1.0126290E-03
     +,   9.1445254E-04,   8.2816306E-04,   7.5187895E-04
     +,   6.8412133E-04,   6.2371499E-04,   5.6970038E-04
     +,   5.2128412E-04,   4.7780099E-04,   4.3868111E-04
     +,   4.0342752E-04,   3.7160455E-04,   3.4283014E-04
     +,   3.1676493E-04,   2.9310625E-04,   2.7158577E-04
     +,   2.5196697E-04,   2.3404059E-04,   2.1762111E-04
     +,   2.0254518E-04,   1.8867107E-04,   1.7587311E-04
     +,   1.6404153E-04,   1.5308108E-04,   1.4290844E-04
     +,   1.3345003E-04,   1.2464140E-04,   1.1642645E-04
     +,   1.0875570E-04,   1.0158495E-04,   9.4874871E-05
     +,   8.8591136E-05,   8.2702172E-05,   7.7180317E-05
     +,   7.1999959E-05,   6.7138535E-05,   6.2574894E-05
     +,   5.8290363E-05,   5.4267290E-05,   5.0490027E-05
     +,   4.6943649E-05,   4.3614866E-05,   4.0491064E-05
     +,   3.7560527E-05,   3.4812667E-05,   3.2237192E-05
     +,   2.9824852E-05,   2.7566644E-05,   2.5454379E-05
     +,   2.3480032E-05,   2.1636310E-05,   1.9916000E-05
     +,   1.8312505E-05,   1.6819298E-05,   1.5430371E-05
     +,   1.4139782E-05,   1.2942023E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_ashz_htt95_mass = Yx/11.655969
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_ashz_ttz100_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.7215220E-04,   4.8277283E-04
     +,   4.9376953E-04,   5.0517992E-04,   5.1704684E-04
     +,   5.2941887E-04,   5.4235134E-04,   5.5590662E-04
     +,   5.7015498E-04,   5.8517599E-04,   6.0105824E-04
     +,   6.1790075E-04,   6.3581369E-04,   6.5491948E-04
     +,   6.7535270E-04,   6.9726194E-04,   7.2080910E-04
     +,   7.4617140E-04,   7.7354029E-04,   8.0312300E-04
     +,   8.3514163E-04,   8.6983311E-04,   9.0744888E-04
     +,   9.4825635E-04,   9.9253166E-04,   1.0405668E-03
     +,   1.0926604E-03,   1.1491200E-03,   1.2102578E-03
     +,   1.2763871E-03,   1.3478209E-03,   1.4248660E-03
     +,   1.5078193E-03,   1.5969636E-03,   1.6925620E-03
     +,   1.7948524E-03,   1.9040429E-03,   2.0203025E-03
     +,   2.1437674E-03,   2.2745105E-03,   2.4125664E-03
     +,   2.5579042E-03,   2.7104283E-03,   2.8699783E-03
     +,   3.0363193E-03,   3.2091457E-03,   3.3880717E-03
     +,   3.5726365E-03,   3.7623022E-03,   3.9564553E-03
     +,   4.1544097E-03,   4.3554120E-03,   4.5586419E-03
     +,   4.7632419E-03,   4.9682786E-03,   5.1728096E-03
     +,   5.3758533E-03,   5.5764178E-03,   5.7735136E-03
     +,   5.9661618E-03,   6.1534173E-03,   6.3343775E-03
     +,   6.5081902E-03,   6.6740909E-03,   6.8314066E-03
     +,   6.9795456E-03,   7.1180589E-03,   7.2466047E-03
     +,   7.3649967E-03,   7.4731889E-03,   7.5712912E-03
     +,   7.6595815E-03,   7.7384966E-03,   7.8086420E-03
     +,   7.8707943E-03,   7.9258820E-03,   7.9749897E-03
     +,   8.0193533E-03,   8.0603343E-03,   8.0994228E-03
     +,   8.1381993E-03,   8.1783263E-03,   8.2215248E-03
     +,   8.2695466E-03,   8.3241379E-03,   8.3870245E-03
     +,   8.4598660E-03,   8.5442318E-03,   8.6415578E-03
     +,   8.7531218E-03,   8.8800089E-03,   9.0230824E-03
     +,   9.1829412E-03,   9.3599269E-03,   9.5540825E-03
     +,   9.7651500E-03,   9.9925715E-03,   1.0235482E-02
     +,   1.0492748E-02,   1.0762958E-02,   1.1044513E-02
     +,   1.1335598E-02,   1.1634325E-02,   1.1938710E-02
     +,   1.2246811E-02,   1.2556789E-02,   1.2866946E-02
     +,   1.3175838E-02,   1.3482369E-02,   1.3785817E-02
     +,   1.4085892E-02,   1.4382817E-02,   1.4677288E-02
     +,   1.4970558E-02,   1.5264320E-02,   1.5560781E-02
     +,   1.5862465E-02,   1.6172240E-02,   1.6493103E-02
     +,   1.6828120E-02,   1.7180281E-02,   1.7552242E-02
     +,   1.7946268E-02,   1.8364051E-02,   1.8806582E-02
     +,   1.9273944E-02,   1.9765366E-02,   2.0279016E-02
     +,   2.0812176E-02,   2.1361094E-02,   2.1921286E-02
     +,   2.2487534E-02,   2.3054255E-02,   2.3615586E-02
     +,   2.4165895E-02,   2.4699979E-02,   2.5213387E-02
     +,   2.5702773E-02,   2.6166210E-02,   2.6603363E-02
     +,   2.7015606E-02,   2.7406072E-02,   2.7779598E-02
     +,   2.8142506E-02,   2.8502205E-02,   2.8866846E-02
     +,   2.9244784E-02,   2.9643886E-02,   3.0070981E-02
     +,   3.0531369E-02,   3.1028103E-02,   3.1561684E-02
     +,   3.2129750E-02,   3.2727078E-02,   3.3345636E-02
     +,   3.3974923E-02,   3.4602568E-02,   3.5215005E-02
     +,   3.5798497E-02,   3.6339890E-02,   3.6827791E-02
     +,   3.7253428E-02,   3.7611548E-02,   3.7900977E-02
     +,   3.8125269E-02,   3.8292728E-02,   3.8416523E-02
     +,   3.8514487E-02,   3.8608875E-02,   3.8726028E-02
     +,   3.8896147E-02,   3.9153032E-02,   3.9534021E-02
     +,   4.0079515E-02,   4.0832505E-02,   4.1837391E-02
     +,   4.3138430E-02,   4.4777133E-02,   4.6789579E-02
     +,   4.9203649E-02,   5.2037343E-02,   5.5299334E-02
     +,   5.8994345E-02,   6.3134693E-02,   6.7757405E-02
     +,   7.2944991E-02,   7.8842916E-02,   8.5664883E-02
     +,   9.3671948E-02,   0.1031203    ,   0.1141826    
     +,   0.1268573    ,   0.1409027    ,   0.1558453    
     +,   0.1710960    ,   0.1861700    ,   0.2009404    
     +,   0.2157930    ,   0.2315501    ,   0.2491508    
     +,   0.2692652    ,   0.2921473    ,   0.3178973    
     +,   0.3469763    ,   0.3804940    ,   0.4197984    
     +,   0.4653326    ,   0.5153607    ,   0.5654594    
     +,   0.6092439    ,   0.6399807    ,   0.6522496    
     +,   0.6430340    ,   0.6121466    ,   0.5622048    
     +,   0.4981755    ,   0.4264311    ,   0.3534669    
     +,   0.2847119    ,   0.2238275    ,   0.1725784    
     +,   0.1311602    ,   9.8707989E-02,   7.3805623E-02
     +,   5.4902386E-02,   4.0596362E-02,   2.9767662E-02
     +,   2.1588309E-02,   1.5460886E-02,   1.0940183E-02
     +,   7.6724929E-03,   5.3632362E-03,   3.7664848E-03
     +,   2.6834493E-03,   1.9605313E-03,   1.4840036E-03
     +,   1.1727478E-03,   9.7041891E-04,   8.3856314E-04
     +,   7.5128453E-04,   6.9136906E-04,   6.4754952E-04
     +,   6.1260496E-04,   5.8204989E-04,   5.5322883E-04
     +,   5.2468863E-04,   4.9574400E-04,   4.6618120E-04
     +,   4.3606528E-04,   4.0561552E-04,   3.7512009E-04
     +,   3.4488883E-04,   3.1522679E-04,   2.8641391E-04
     +,   2.5869417E-04,   2.3227208E-04,   2.0731271E-04
     +,   1.8393931E-04,   1.6223383E-04,   1.4224087E-04
     +,   1.2397248E-04,   1.0741034E-04,   9.2509224E-05
     +,   7.9202684E-05,   6.7408539E-05,   5.7030633E-05
     +,   4.7964208E-05,   4.0100003E-05,   3.3326702E-05
     +,   2.7533320E-05,   2.2612085E-05,   1.8460400E-05
     +,   1.4981770E-05,   1.2086596E-05,   9.6930635E-06
     +,   7.7275226E-06,   6.1240125E-06,   4.8245342E-06
     +,   3.7782570E-06,   2.9413895E-06,   2.2763120E-06
     +,   1.7512078E-06,   1.3392577E-06,   1.0181701E-06
     +,   7.6948555E-07,   5.7811673E-07,   4.3178207E-07
     +,   3.2058887E-07,   2.3663597E-07,   1.7364462E-07
     +,   1.2668026E-07,   9.1881425E-08,   6.6259020E-08
     +,   4.7508898E-08,   3.3873391E-08,   2.4017575E-08
     +,   1.6937644E-08,   1.1882221E-08,   8.2942408E-09
     +,   5.7626437E-09,   3.9868833E-09
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_ashz_ttz100_mass = Yx/3.47640351219512
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_ashz_ttz105_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  6.3768547E-04,   6.6215906E-04
     +,   6.8772322E-04,   7.1443047E-04,   7.4233545E-04
     +,   7.7149650E-04,   8.0197526E-04,   8.3383656E-04
     +,   8.6714892E-04,   9.0198725E-04,   9.3842909E-04
     +,   9.7655813E-04,   1.0164643E-03,   1.0582430E-03
     +,   1.1019974E-03,   1.1478376E-03,   1.1958828E-03
     +,   1.2462600E-03,   1.2991064E-03,   1.3545695E-03
     +,   1.4128070E-03,   1.4739895E-03,   1.5382976E-03
     +,   1.6059302E-03,   1.6770920E-03,   1.7520083E-03
     +,   1.8309178E-03,   1.9140724E-03,   2.0017407E-03
     +,   2.0942076E-03,   2.1917734E-03,   2.2947553E-03
     +,   2.4034851E-03,   2.5183111E-03,   2.6395964E-03
     +,   2.7677203E-03,   2.9030736E-03,   3.0460572E-03
     +,   3.1970970E-03,   3.3566053E-03,   3.5250257E-03
     +,   3.7027930E-03,   3.8903516E-03,   4.0881420E-03
     +,   4.2966041E-03,   4.5161690E-03,   4.7472566E-03
     +,   4.9902704E-03,   5.2455892E-03,   5.5135638E-03
     +,   5.7945075E-03,   6.0886894E-03,   6.3963183E-03
     +,   6.7175590E-03,   7.0524649E-03,   7.4010375E-03
     +,   7.7631632E-03,   8.1386128E-03,   8.5270330E-03
     +,   8.9279339E-03,   9.3406681E-03,   9.7644292E-03
     +,   1.0198207E-02,   1.0640830E-02,   1.1090942E-02
     +,   1.1546928E-02,   1.2007049E-02,   1.2469281E-02
     +,   1.2931498E-02,   1.3391311E-02,   1.3846248E-02
     +,   1.4293640E-02,   1.4730791E-02,   1.5154867E-02
     +,   1.5563094E-02,   1.5952714E-02,   1.6321065E-02
     +,   1.6665634E-02,   1.6984181E-02,   1.7274762E-02
     +,   1.7535778E-02,   1.7766118E-02,   1.7965151E-02
     +,   1.8132862E-02,   1.8269839E-02,   1.8377408E-02
     +,   1.8457603E-02,   1.8513232E-02,   1.8547928E-02
     +,   1.8566104E-02,   1.8572967E-02,   1.8574560E-02
     +,   1.8577646E-02,   1.8589722E-02,   1.8618956E-02
     +,   1.8674068E-02,   1.8764308E-02,   1.8899288E-02
     +,   1.9088877E-02,   1.9343058E-02,   1.9671770E-02
     +,   2.0084675E-02,   2.0591013E-02,   2.1199292E-02
     +,   2.1917112E-02,   2.2750905E-02,   2.3705592E-02
     +,   2.4784312E-02,   2.5988279E-02,   2.7316468E-02
     +,   2.8765241E-02,   3.0328406E-02,   3.1996857E-02
     +,   3.3758748E-02,   3.5599142E-02,   3.7500586E-02
     +,   3.9442893E-02,   4.1403942E-02,   4.3359842E-02
     +,   4.5285881E-02,   4.7157403E-02,   4.8950378E-02
     +,   5.0642911E-02,   5.2216053E-02,   5.3654835E-02
     +,   5.4948866E-02,   5.6093197E-02,   5.7088170E-02
     +,   5.7939548E-02,   5.8657568E-02,   5.9256300E-02
     +,   5.9752259E-02,   6.0163163E-02,   6.0506631E-02
     +,   6.0799085E-02,   6.1054982E-02,   6.1286580E-02
     +,   6.1503831E-02,   6.1715018E-02,   6.1927341E-02
     +,   6.2147766E-02,   6.2383387E-02,   6.2641822E-02
     +,   6.2930800E-02,   6.3257292E-02,   6.3626356E-02
     +,   6.4039506E-02,   6.4492874E-02,   6.4976081E-02
     +,   6.5471075E-02,   6.5952279E-02,   6.6386953E-02
     +,   6.6737108E-02,   6.6961959E-02,   6.7020550E-02
     +,   6.6875279E-02,   6.6494830E-02,   6.5857016E-02
     +,   6.4950667E-02,   6.3776940E-02,   6.2349476E-02
     +,   6.0693655E-02,   5.8845282E-02,   5.6848437E-02
     +,   5.4752715E-02,   5.2610353E-02,   5.0473899E-02
     +,   4.8393287E-02,   4.6413321E-02,   4.4572148E-02
     +,   4.2900175E-02,   4.1419350E-02,   4.0143508E-02
     +,   3.9079323E-02,   3.8228400E-02,   3.7589625E-02
     +,   3.7162285E-02,   3.6949508E-02,   3.6961462E-02
     +,   3.7217781E-02,   3.7749216E-02,   3.8597319E-02
     +,   3.9812498E-02,   4.1450072E-02,   4.3565165E-02
     +,   4.6206746E-02,   4.9412671E-02,   5.3206991E-02
     +,   5.7599708E-02,   6.2589720E-02,   6.8171643E-02
     +,   7.4342981E-02,   8.1110932E-02,   8.8497244E-02
     +,   9.6540608E-02,   0.1052932    ,   0.1148150    
     +,   0.1251644    ,   0.1363874    ,   0.1485000    
     +,   0.1614661    ,   0.1751701    ,   0.1893897    
     +,   0.2037702    ,   0.2178131    ,   0.2308918    
     +,   0.2422943    ,   0.2512897    ,   0.2572171    
     +,   0.2595691    ,   0.2580581    ,   0.2526511    
     +,   0.2435663    ,   0.2312366    ,   0.2162492    
     +,   0.1992808    ,   0.1810330    ,   0.1621797    
     +,   0.1433315    ,   0.1250143    ,   0.1076523    
     +,   9.1565959E-02,   7.6972112E-02,   6.3990116E-02
     +,   5.2650608E-02,   4.2911224E-02,   3.4674108E-02
     +,   2.7802672E-02,   2.2138471E-02,   1.7516462E-02
     +,   1.3776669E-02,   1.0771562E-02,   8.3704581E-03
     +,   6.4614117E-03,   4.9509392E-03,   3.7619374E-03
     +,   2.8315855E-03,   2.1089232E-03,   1.5524988E-03
     +,   1.1284613E-03,   8.0912106E-04,   5.7181553E-04
     +,   3.9802390E-04,   2.7271447E-04,   1.8383596E-04
     +,   1.2187196E-04,   7.9430632E-05,   5.0881263E-05
     +,   3.2026270E-05,   1.9804409E-05,   1.2029414E-05
     +,   7.1760196E-06,   4.2036822E-06,   2.4179437E-06
     +,   1.3655077E-06,   7.5710904E-07,   4.1217692E-07
     +,   2.2039086E-07,   1.1580899E-07,   5.9876712E-08
     +,   3.0535816E-08,   1.5432663E-08,   7.7972109E-09
     +,   3.9996788E-09,   2.1354707E-09,   1.2261023E-09
     +,   7.7975271E-10,   5.5439625E-10,   4.3335716E-10
     +,   3.6150169E-10,   3.1325303E-10,   2.7691674E-10
     +,   2.4718030E-10,   2.2160757E-10,   1.9903831E-10
     +,   1.7887310E-10,   1.6075587E-10,   1.4444337E-10
     +,   1.2974440E-10,   1.1649884E-10,   1.0456485E-10
     +,   9.3816829E-11,   8.4139959E-11,   7.5431404E-11
     +,   6.7596963E-11,   6.0552209E-11,   5.4219955E-11
     +,   4.8530388E-11,   4.3420552E-11,   3.8833027E-11
     +,   3.4716403E-11,   3.1023607E-11,   2.7712568E-11
     +,   2.4744892E-11,   2.2086225E-11,   1.9705196E-11
     +,   1.7573849E-11,   1.5666680E-11,   1.3960928E-11
     +,   1.2435798E-11,   1.1072867E-11
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_ashz_ttz105_mass = Yx/2.5915008
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_ashz_ttz107_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.1099712E-03,   1.1504217E-03
     +,   1.1927101E-03,   1.2369296E-03,   1.2831747E-03
     +,   1.3315453E-03,   1.3821436E-03,   1.4350766E-03
     +,   1.4904524E-03,   1.5483877E-03,   1.6089982E-03
     +,   1.6724052E-03,   1.7387335E-03,   1.8081114E-03
     +,   1.8806722E-03,   1.9565520E-03,   2.0358907E-03
     +,   2.1188315E-03,   2.2055220E-03,   2.2961134E-03
     +,   2.3907591E-03,   2.4896150E-03,   2.5928391E-03
     +,   2.7005966E-03,   2.8130424E-03,   2.9303432E-03
     +,   3.0526575E-03,   3.1801441E-03,   3.3129565E-03
     +,   3.4512430E-03,   3.5951440E-03,   3.7447894E-03
     +,   3.9002961E-03,   4.0617650E-03,   4.2292778E-03
     +,   4.4028941E-03,   4.5826444E-03,   4.7685308E-03
     +,   4.9605290E-03,   5.1585580E-03,   5.3625149E-03
     +,   5.5722413E-03,   5.7875318E-03,   6.0081286E-03
     +,   6.2337257E-03,   6.4639552E-03,   6.6984040E-03
     +,   6.9365990E-03,   7.1780253E-03,   7.4221129E-03
     +,   7.6682619E-03,   7.9158377E-03,   8.1641879E-03
     +,   8.4126703E-03,   8.6606210E-03,   8.9074429E-03
     +,   9.1525735E-03,   9.3955258E-03,   9.6359178E-03
     +,   9.8734973E-03,   1.0108165E-02,   1.0340017E-02
     +,   1.0569341E-02,   1.0796690E-02,   1.1022874E-02
     +,   1.1248963E-02,   1.1476361E-02,   1.1706737E-02
     +,   1.1942082E-02,   1.2184666E-02,   1.2437039E-02
     +,   1.2701967E-02,   1.2982426E-02,   1.3281493E-02
     +,   1.3602339E-02,   1.3948106E-02,   1.4321821E-02
     +,   1.4726287E-02,   1.5164021E-02,   1.5637133E-02
     +,   1.6147142E-02,   1.6695002E-02,   1.7280860E-02
     +,   1.7904129E-02,   1.8563224E-02,   1.9255731E-02
     +,   1.9978130E-02,   2.0726047E-02,   2.1494037E-02
     +,   2.2275800E-02,   2.3064297E-02,   2.3851685E-02
     +,   2.4629660E-02,   2.5389599E-02,   2.6122816E-02
     +,   2.6820691E-02,   2.7475165E-02,   2.8078787E-02
     +,   2.8625220E-02,   2.9109344E-02,   2.9527657E-02
     +,   2.9878402E-02,   3.0161818E-02,   3.0380208E-02
     +,   3.0538026E-02,   3.0641830E-02,   3.0700183E-02
     +,   3.0723425E-02,   3.0723466E-02,   3.0713404E-02
     +,   3.0707078E-02,   3.0718775E-02,   3.0762590E-02
     +,   3.0852113E-02,   3.0999934E-02,   3.1217270E-02
     +,   3.1513553E-02,   3.1896301E-02,   3.2370809E-02
     +,   3.2940105E-02,   3.3604864E-02,   3.4363542E-02
     +,   3.5212282E-02,   3.6145303E-02,   3.7154973E-02
     +,   3.8231906E-02,   3.9365515E-02,   4.0543836E-02
     +,   4.1754279E-02,   4.2983469E-02,   4.4217933E-02
     +,   4.5443952E-02,   4.6648268E-02,   4.7818076E-02
     +,   4.8941374E-02,   5.0007276E-02,   5.1006015E-02
     +,   5.1929116E-02,   5.2769661E-02,   5.3522047E-02
     +,   5.4182079E-02,   5.4746944E-02,   5.5214942E-02
     +,   5.5585656E-02,   5.5859577E-02,   5.6038246E-02
     +,   5.6124050E-02,   5.6120388E-02,   5.6031428E-02
     +,   5.5862270E-02,   5.5618703E-02,   5.5307079E-02
     +,   5.4934125E-02,   5.4506578E-02,   5.4030802E-02
     +,   5.3512454E-02,   5.2955996E-02,   5.2364543E-02
     +,   5.1739551E-02,   5.1081069E-02,   5.0387863E-02
     +,   4.9657971E-02,   4.8889551E-02,   4.8081622E-02
     +,   4.7234986E-02,   4.6353322E-02,   4.5443945E-02
     +,   4.4518296E-02,   4.3592222E-02,   4.2685792E-02
     +,   4.1822914E-02,   4.1030191E-02,   4.0335704E-02
     +,   3.9767552E-02,   3.9352473E-02,   3.9114259E-02
     +,   3.9072976E-02,   3.9244231E-02,   3.9639331E-02
     +,   4.0266123E-02,   4.1130103E-02,   4.2236157E-02
     +,   4.3590344E-02,   4.5201655E-02,   4.7082841E-02
     +,   4.9250878E-02,   5.1725984E-02,   5.4530848E-02
     +,   5.7688076E-02,   6.1217993E-02,   6.5137058E-02
     +,   6.9456562E-02,   7.4181765E-02,   7.9312883E-02
     +,   8.4846564E-02,   9.0776928E-02,   9.7095206E-02
     +,   0.1037890    ,   0.1108389    ,   0.1182127    
     +,   0.1258556    ,   0.1336830    ,   0.1415724    
     +,   0.1493575    ,   0.1568276    ,   0.1637335    
     +,   0.1697997    ,   0.1747395    ,   0.1782788    
     +,   0.1801775    ,   0.1802512    ,   0.1783892    
     +,   0.1745667    ,   0.1688491    ,   0.1613886    
     +,   0.1524151    ,   0.1422184    ,   0.1311278    
     +,   0.1194883    ,   0.1076417    ,   9.5902547E-02
     +,   8.4545314E-02,   7.3793747E-02,   6.3815162E-02
     +,   5.4719713E-02,   4.6564884E-02,   3.9362896E-02
     +,   3.3088833E-02,   2.7689438E-02,   2.3092853E-02
     +,   1.9216841E-02,   1.5975054E-02,   1.3282031E-02
     +,   1.1057065E-02,   9.2265857E-03,   7.7248807E-03
     +,   6.4947042E-03,   5.4871123E-03,   4.6607931E-03
     +,   3.9813006E-03,   3.4203299E-03,   2.9548977E-03
     +,   2.5665062E-03,   2.2403859E-03,   1.9648548E-03
     +,   1.7307299E-03,   1.5307880E-03,   1.3593149E-03
     +,   1.2117738E-03,   1.0845220E-03,   9.7457203E-04
     +,   8.7943638E-04,   7.9701637E-04,   7.2550774E-04
     +,   6.6333823E-04,   6.0913328E-04,   5.6169042E-04
     +,   5.1995547E-04,   4.8300734E-04,   4.5004868E-04
     +,   4.2039799E-04,   3.9347803E-04,   3.6880482E-04
     +,   3.4597993E-04,   3.2468321E-04,   3.0465904E-04
     +,   2.8570896E-04,   2.6768408E-04,   2.5047566E-04
     +,   2.3400570E-04,   2.1822199E-04,   2.0309271E-04
     +,   1.8860010E-04,   1.7473528E-04,   1.6149567E-04
     +,   1.4888354E-04,   1.3690037E-04,   1.2554896E-04
     +,   1.1482880E-04,   1.0473832E-04,   9.5271665E-05
     +,   8.6420972E-05,   7.8174067E-05,   7.0516762E-05
     +,   6.3431020E-05,   5.6897177E-05,   5.0892795E-05
     +,   4.5393652E-05,   4.0374736E-05,   3.5809273E-05
     +,   3.1670570E-05,   2.7931008E-05,   2.4563557E-05
     +,   2.1541000E-05,   1.8837100E-05,   1.6426000E-05
     +,   1.4283123E-05,   1.2384658E-05,   1.0708249E-05
     +,   9.2325599E-06,   7.9377869E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_ashz_ttz107_mass = Yx/2.23772684210526
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_ashz_ttz110_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.2664320E-03,   1.3108507E-03
     +,   1.3572557E-03,   1.4057606E-03,   1.4564836E-03
     +,   1.5095500E-03,   1.5650912E-03,   1.6232434E-03
     +,   1.6841483E-03,   1.7479546E-03,   1.8148132E-03
     +,   1.8848802E-03,   1.9583134E-03,   2.0352772E-03
     +,   2.1159337E-03,   2.2004459E-03,   2.2889806E-03
     +,   2.3817003E-03,   2.4787670E-03,   2.5803398E-03
     +,   2.6865755E-03,   2.7976264E-03,   2.9136417E-03
     +,   3.0347719E-03,   3.1611559E-03,   3.2929415E-03
     +,   3.4302743E-03,   3.5733031E-03,   3.7221846E-03
     +,   3.8770861E-03,   4.0381923E-03,   4.2057126E-03
     +,   4.3798778E-03,   4.5609605E-03,   4.7492725E-03
     +,   4.9451781E-03,   5.1490949E-03,   5.3615076E-03
     +,   5.5829822E-03,   5.8141421E-03,   6.0557150E-03
     +,   6.3085011E-03,   6.5733921E-03,   6.8513560E-03
     +,   7.1434448E-03,   7.4507738E-03,   7.7745151E-03
     +,   8.1158774E-03,   8.4760776E-03,   8.8563170E-03
     +,   9.2577534E-03,   9.6814511E-03,   1.0128353E-02
     +,   1.0599241E-02,   1.1094645E-02,   1.1614865E-02
     +,   1.2159872E-02,   1.2729266E-02,   1.3322271E-02
     +,   1.3937646E-02,   1.4573700E-02,   1.5228268E-02
     +,   1.5898652E-02,   1.6581725E-02,   1.7273894E-02
     +,   1.7971095E-02,   1.8668961E-02,   1.9362753E-02
     +,   2.0047618E-02,   2.0718485E-02,   2.1370377E-02
     +,   2.1998364E-02,   2.2597833E-02,   2.3164473E-02
     +,   2.3694539E-02,   2.4184868E-02,   2.4633015E-02
     +,   2.5037313E-02,   2.5396999E-02,   2.5712194E-02
     +,   2.5983898E-02,   2.6214028E-02,   2.6405282E-02
     +,   2.6561154E-02,   2.6685730E-02,   2.6783653E-02
     +,   2.6859887E-02,   2.6919628E-02,   2.6968118E-02
     +,   2.7010502E-02,   2.7051721E-02,   2.7096311E-02
     +,   2.7148429E-02,   2.7211700E-02,   2.7289229E-02
     +,   2.7383557E-02,   2.7496792E-02,   2.7630527E-02
     +,   2.7786044E-02,   2.7964311E-02,   2.8166136E-02
     +,   2.8392218E-02,   2.8643318E-02,   2.8920259E-02
     +,   2.9224049E-02,   2.9556008E-02,   2.9917674E-02
     +,   3.0311015E-02,   3.0738361E-02,   3.1202443E-02
     +,   3.1706464E-02,   3.2253996E-02,   3.2848928E-02
     +,   3.3495542E-02,   3.4198113E-02,   3.4961060E-02
     +,   3.5788380E-02,   3.6683626E-02,   3.7649326E-02
     +,   3.8686924E-02,   3.9796222E-02,   4.0974978E-02
     +,   4.2218879E-02,   4.3521136E-02,   4.4872541E-02
     +,   4.6261299E-02,   4.7673527E-02,   4.9093097E-02
     +,   5.0502557E-02,   5.1882982E-02,   5.3215049E-02
     +,   5.4479145E-02,   5.5656061E-02,   5.6727272E-02
     +,   5.7675373E-02,   5.8484368E-02,   5.9139747E-02
     +,   5.9628654E-02,   5.9940130E-02,   6.0065083E-02
     +,   5.9996422E-02,   5.9729345E-02,   5.9261382E-02
     +,   5.8592733E-02,   5.7726644E-02,   5.6669481E-02
     +,   5.5431113E-02,   5.4025009E-02,   5.2468386E-02
     +,   5.0781887E-02,   4.8989262E-02,   4.7117125E-02
     +,   4.5194160E-02,   4.3250069E-02,   4.1314777E-02
     +,   3.9417528E-02,   3.7585743E-02,   3.5843931E-02
     +,   3.4212977E-02,   3.2709587E-02,   3.1345617E-02
     +,   3.0127876E-02,   2.9058482E-02,   2.8134864E-02
     +,   2.7350370E-02,   2.6695043E-02,   2.6156504E-02
     +,   2.5720840E-02,   2.5373664E-02,   2.5100999E-02
     +,   2.4890218E-02,   2.4730785E-02,   2.4614817E-02
     +,   2.4537453E-02,   2.4497151E-02,   2.4495577E-02
     +,   2.4537472E-02,   2.4630362E-02,   2.4784088E-02
     +,   2.5010433E-02,   2.5322529E-02,   2.5734572E-02
     +,   2.6261333E-02,   2.6918193E-02,   2.7720788E-02
     +,   2.8685121E-02,   2.9827498E-02,   3.1164689E-02
     +,   3.2713845E-02,   3.4491986E-02,   3.6515981E-02
     +,   3.8801730E-02,   4.1362986E-02,   4.4210330E-02
     +,   4.7350001E-02,   5.0782274E-02,   5.4499809E-02
     +,   5.8486246E-02,   6.2715583E-02,   6.7150958E-02
     +,   7.1743816E-02,   7.6434001E-02,   8.1150778E-02
     +,   8.5813031E-02,   9.0330340E-02,   9.4606027E-02
     +,   9.8538943E-02,   0.1020262    ,   0.1049672    
     +,   0.1072676    ,   0.1088429    ,   0.1096228    
     +,   0.1095552    ,   0.1086096    ,   0.1067788    
     +,   0.1040818    ,   0.1005627    ,   9.6290186E-02
     +,   9.1354355E-02,   8.5864037E-02,   7.9940781E-02
     +,   7.3714159E-02,   6.7316450E-02,   6.0876798E-02
     +,   5.4515686E-02,   4.8341177E-02,   4.2446125E-02
     +,   3.6905520E-02,   3.1775210E-02,   2.7092461E-02
     +,   2.2877151E-02,   1.9133205E-02,   1.5850658E-02
     +,   1.3008549E-02,   1.0577840E-02,   8.5234381E-03
     +,   6.8069431E-03,   5.3887945E-03,   4.2298217E-03
     +,   3.2925336E-03,   2.5421795E-03,   1.9473719E-03
     +,   1.4803265E-03,   1.1169172E-03,   8.3661021E-04
     +,   6.2222558E-04,   4.5958877E-04,   3.3716348E-04
     +,   2.4569657E-04,   1.7786038E-04,   1.2790402E-04
     +,   9.1368878E-05,   6.4833119E-05,   4.5691875E-05
     +,   3.1978427E-05,   2.2221300E-05,   1.5328265E-05
     +,   1.0493871E-05,   7.1283284E-06,   4.8032471E-06
     +,   3.2097591E-06,   2.1266480E-06,   1.3966579E-06
     +,   9.0895901E-07,   5.8609714E-07,   3.7433827E-07
     +,   2.3677289E-07,   1.4828443E-07,   9.1936165E-08
     +,   5.6419342E-08,   3.4265071E-08,   2.0592591E-08
     +,   1.2245335E-08,   7.2043225E-09,   4.1933066E-09
     +,   2.4148414E-09,   1.3760226E-09,   7.7606899E-10
     +,   4.3343162E-10,   2.3994642E-10,   1.3188482E-10
     +,   7.2185577E-11,   3.9540347E-11,   2.1856435E-11
     +,   1.2349480E-11,   7.2627225E-12,   4.5395059E-12
     +,   3.0680445E-12,   2.2544471E-12,   1.7849496E-12
     +,   1.4957050E-12,   1.3019006E-12,   1.1600106E-12
     +,   1.0477496E-12,   9.5368808E-13,   8.7186074E-13
     +,   7.9905928E-13,   7.3344656E-13,   6.7388629E-13
     +,   6.1959417E-13,   5.6998622E-13
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_ashz_ttz110_mass = Yx/1.83309283783784
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_ashz_ttz115_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.0191628E-03,   2.0885635E-03
     +,   2.1591736E-03,   2.2309786E-03,   2.3039719E-03
     +,   2.3781506E-03,   2.4535221E-03,   2.5300984E-03
     +,   2.6079048E-03,   2.6869804E-03,   2.7673729E-03
     +,   2.8491449E-03,   2.9323769E-03,   3.0171620E-03
     +,   3.1036153E-03,   3.1918660E-03,   3.2820639E-03
     +,   3.3743749E-03,   3.4689854E-03,   3.5660968E-03
     +,   3.6659297E-03,   3.7687188E-03,   3.8747087E-03
     +,   3.9841649E-03,   4.0973476E-03,   4.2145373E-03
     +,   4.3360074E-03,   4.4620377E-03,   4.5929020E-03
     +,   4.7288686E-03,   4.8701991E-03,   5.0171441E-03
     +,   5.1699411E-03,   5.3288131E-03,   5.4939697E-03
     +,   5.6656054E-03,   5.8438987E-03,   6.0290149E-03
     +,   6.2211170E-03,   6.4203390E-03,   6.6268272E-03
     +,   6.8407147E-03,   7.0621287E-03,   7.2911973E-03
     +,   7.5280485E-03,   7.7728108E-03,   8.0255959E-03
     +,   8.2865236E-03,   8.5556870E-03,   8.8331616E-03
     +,   9.1189928E-03,   9.4131799E-03,   9.7156623E-03
     +,   1.0026334E-02,   1.0344967E-02,   1.0671282E-02
     +,   1.1004870E-02,   1.1345217E-02,   1.1691697E-02
     +,   1.2043565E-02,   1.2399979E-02,   1.2759995E-02
     +,   1.3122588E-02,   1.3486703E-02,   1.3851274E-02
     +,   1.4215222E-02,   1.4577590E-02,   1.4937475E-02
     +,   1.5294173E-02,   1.5647160E-02,   1.5996162E-02
     +,   1.6341157E-02,   1.6682472E-02,   1.7020678E-02
     +,   1.7356688E-02,   1.7691728E-02,   1.8027253E-02
     +,   1.8364931E-02,   1.8706597E-02,   1.9054204E-02
     +,   1.9409658E-02,   1.9774824E-02,   2.0151379E-02
     +,   2.0540763E-02,   2.0944057E-02,   2.1361971E-02
     +,   2.1794690E-02,   2.2241976E-02,   2.2702958E-02
     +,   2.3176277E-02,   2.3660028E-02,   2.4151778E-02
     +,   2.4648616E-02,   2.5147241E-02,   2.5644010E-02
     +,   2.6135001E-02,   2.6616184E-02,   2.7083386E-02
     +,   2.7532596E-02,   2.7959909E-02,   2.8361799E-02
     +,   2.8735092E-02,   2.9077280E-02,   2.9386489E-02
     +,   2.9661698E-02,   2.9902827E-02,   3.0110765E-02
     +,   3.0287471E-02,   3.0436030E-02,   3.0560536E-02
     +,   3.0666057E-02,   3.0758573E-02,   3.0844633E-02
     +,   3.0931368E-02,   3.1026056E-02,   3.1135919E-02
     +,   3.1267893E-02,   3.1428285E-02,   3.1622577E-02
     +,   3.1855308E-02,   3.2129843E-02,   3.2448370E-02
     +,   3.2811865E-02,   3.3220198E-02,   3.3672184E-02
     +,   3.4165721E-02,   3.4698013E-02,   3.5265546E-02
     +,   3.5864398E-02,   3.6490064E-02,   3.7137702E-02
     +,   3.7801977E-02,   3.8477022E-02,   3.9156273E-02
     +,   3.9832514E-02,   4.0497683E-02,   4.1142732E-02
     +,   4.1757777E-02,   4.2332131E-02,   4.2854473E-02
     +,   4.3313034E-02,   4.3695994E-02,   4.3991938E-02
     +,   4.4190235E-02,   4.4281535E-02,   4.4258267E-02
     +,   4.4114985E-02,   4.3848835E-02,   4.3459725E-02
     +,   4.2950515E-02,   4.2326931E-02,   4.1597541E-02
     +,   4.0773410E-02,   3.9867762E-02,   3.8895335E-02
     +,   3.7872143E-02,   3.6814597E-02,   3.5738945E-02
     +,   3.4660701E-02,   3.3594288E-02,   3.2552257E-02
     +,   3.1545151E-02,   3.0581269E-02,   2.9666515E-02
     +,   2.8804254E-02,   2.7995594E-02,   2.7239582E-02
     +,   2.6533483E-02,   2.5873123E-02,   2.5253337E-02
     +,   2.4668526E-02,   2.4113063E-02,   2.3581753E-02
     +,   2.3070293E-02,   2.2575786E-02,   2.2096943E-02
     +,   2.1634474E-02,   2.1191213E-02,   2.0772332E-02
     +,   2.0385217E-02,   2.0039469E-02,   1.9746786E-02
     +,   1.9520618E-02,   1.9375825E-02,   1.9328315E-02
     +,   1.9394578E-02,   1.9591112E-02,   1.9933898E-02
     +,   2.0437879E-02,   2.1116225E-02,   2.1979939E-02
     +,   2.3037188E-02,   2.4292717E-02,   2.5747394E-02
     +,   2.7397934E-02,   2.9236462E-02,   3.1250130E-02
     +,   3.3421144E-02,   3.5726920E-02,   3.8140137E-02
     +,   4.0628910E-02,   4.3157473E-02,   4.5686863E-02
     +,   4.8175734E-02,   5.0580911E-02,   5.2858945E-02
     +,   5.4966912E-02,   5.6863423E-02,   5.8509808E-02
     +,   5.9871476E-02,   6.0918484E-02,   6.1626591E-02
     +,   6.1977923E-02,   6.1961662E-02,   6.1574236E-02
     +,   6.0819525E-02,   5.9708837E-02,   5.8260538E-02
     +,   5.6499399E-02,   5.4456338E-02,   5.2166834E-02
     +,   4.9670298E-02,   4.7008846E-02,   4.4226065E-02
     +,   4.1365467E-02,   3.8469467E-02,   3.5578456E-02
     +,   3.2729596E-02,   2.9955855E-02,   2.7285554E-02
     +,   2.4742179E-02,   2.2343954E-02,   2.0103799E-02
     +,   1.8029694E-02,   1.6125239E-02,   1.4389767E-02
     +,   1.2819177E-02,   1.1406623E-02,   1.0143075E-02
     +,   9.0178763E-03,   8.0194268E-03,   7.1357810E-03
     +,   6.3549848E-03,   5.6654187E-03,   5.0561340E-03
     +,   4.5170668E-03,   4.0391311E-03,   3.6142226E-03
     +,   3.2352724E-03,   2.8962349E-03,   2.5919396E-03
     +,   2.3180398E-03,   2.0709229E-03,   1.8475871E-03
     +,   1.6455218E-03,   1.4626310E-03,   1.2971582E-03
     +,   1.1475999E-03,   1.0126359E-03,   8.9109357E-04
     +,   7.8191742E-04,   6.8413105E-04,   5.9681531E-04
     +,   5.1910279E-04,   4.5017680E-04,   3.8925398E-04
     +,   3.3559097E-04,   2.8848840E-04,   2.4728727E-04
     +,   2.1136830E-04,   1.8015649E-04,   1.5312330E-04
     +,   1.2978356E-04,   1.0969383E-04,   9.2453156E-05
     +,   7.7702294E-05,   6.5117820E-05,   5.4413515E-05
     +,   4.5334378E-05,   3.7656697E-05,   3.1182943E-05
     +,   2.5741059E-05,   2.1180298E-05,   1.7370225E-05
     +,   1.4197291E-05,   1.1563864E-05,   9.3855433E-06
     +,   7.5899156E-06,   6.1151554E-06,   4.9083123E-06
     +,   3.9245115E-06,   3.1255840E-06,   2.4794028E-06
     +,   1.9588454E-06,   1.5412467E-06,   1.2076275E-06
     +,   9.4225527E-07,   7.3206797E-07,   5.6633314E-07
     +,   4.3622015E-07,   3.3453799E-07
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_ashz_ttz115_mass = Yx/1.417227
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_ashz_ttz120_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.7629871E-03,   1.8111154E-03
     +,   1.8590115E-03,   1.9065907E-03,   1.9537720E-03
     +,   2.0004776E-03,   2.0466333E-03,   2.0921710E-03
     +,   2.1370288E-03,   2.1811542E-03,   2.2245022E-03
     +,   2.2670396E-03,   2.3087435E-03,   2.3496058E-03
     +,   2.3896324E-03,   2.4288453E-03,   2.4672842E-03
     +,   2.5050060E-03,   2.5420906E-03,   2.5786352E-03
     +,   2.6147626E-03,   2.6506165E-03,   2.6863662E-03
     +,   2.7222079E-03,   2.7583584E-03,   2.7950655E-03
     +,   2.8326015E-03,   2.8712642E-03,   2.9113789E-03
     +,   2.9532944E-03,   2.9973858E-03,   3.0440472E-03
     +,   3.0936978E-03,   3.1467725E-03,   3.2037229E-03
     +,   3.2650116E-03,   3.3311113E-03,   3.4024955E-03
     +,   3.4796426E-03,   3.5630167E-03,   3.6530779E-03
     +,   3.7502621E-03,   3.8549840E-03,   3.9676274E-03
     +,   4.0885368E-03,   4.2180172E-03,   4.3563219E-03
     +,   4.5036511E-03,   4.6601477E-03,   4.8258901E-03
     +,   5.0008926E-03,   5.1851035E-03,   5.3784032E-03
     +,   5.5806162E-03,   5.7914881E-03,   6.0107233E-03
     +,   6.2379660E-03,   6.4728195E-03,   6.7148479E-03
     +,   6.9635925E-03,   7.2185756E-03,   7.4793259E-03
     +,   7.7453624E-03,   8.0162510E-03,   8.2915882E-03
     +,   8.5709989E-03,   8.8542076E-03,   9.1409702E-03
     +,   9.4311675E-03,   9.7247455E-03,   1.0021781E-02
     +,   1.0322420E-02,   1.0626966E-02,   1.0935777E-02
     +,   1.1249355E-02,   1.1568291E-02,   1.1893234E-02
     +,   1.2224903E-02,   1.2564073E-02,   1.2911554E-02
     +,   1.3268107E-02,   1.3634512E-02,   1.4011456E-02
     +,   1.4399583E-02,   1.4799410E-02,   1.5211374E-02
     +,   1.5635731E-02,   1.6072650E-02,   1.6522123E-02
     +,   1.6984019E-02,   1.7458109E-02,   1.7943986E-02
     +,   1.8441167E-02,   1.8949121E-02,   1.9467277E-02
     +,   1.9995023E-02,   2.0531863E-02,   2.1077316E-02
     +,   2.1631155E-02,   2.2193301E-02,   2.2764007E-02
     +,   2.3343777E-02,   2.3933558E-02,   2.4534518E-02
     +,   2.5148174E-02,   2.5776207E-02,   2.6420271E-02
     +,   2.7081773E-02,   2.7761675E-02,   2.8460087E-02
     +,   2.9175913E-02,   2.9906679E-02,   3.0648047E-02
     +,   3.1393945E-02,   3.2136288E-02,   3.2865357E-02
     +,   3.3569936E-02,   3.4238070E-02,   3.4857605E-02
     +,   3.5417154E-02,   3.5906948E-02,   3.6319740E-02
     +,   3.6651619E-02,   3.6902659E-02,   3.7077222E-02
     +,   3.7184075E-02,   3.7236001E-02,   3.7249174E-02
     +,   3.7242197E-02,   3.7234843E-02,   3.7246663E-02
     +,   3.7295580E-02,   3.7396450E-02,   3.7559886E-02
     +,   3.7791271E-02,   3.8090233E-02,   3.8450249E-02
     +,   3.8859010E-02,   3.9298821E-02,   3.9747581E-02
     +,   4.0179886E-02,   4.0568329E-02,   4.0885072E-02
     +,   4.1103225E-02,   4.1198067E-02,   4.1148551E-02
     +,   4.0938027E-02,   4.0555060E-02,   3.9994005E-02
     +,   3.9254948E-02,   3.8343638E-02,   3.7271235E-02
     +,   3.6053557E-02,   3.4710251E-02,   3.3263933E-02
     +,   3.1739268E-02,   3.0161940E-02,   2.8557541E-02
     +,   2.6950797E-02,   2.5364926E-02,   2.3820730E-02
     +,   2.2336267E-02,   2.0926645E-02,   1.9603739E-02
     +,   1.8376112E-02,   1.7249264E-02,   1.6225912E-02
     +,   1.5306210E-02,   1.4488067E-02,   1.3767641E-02
     +,   1.3139748E-02,   1.2598237E-02,   1.2136314E-02
     +,   1.1746940E-02,   1.1423143E-02,   1.1158189E-02
     +,   1.0945859E-02,   1.0780606E-02,   1.0657658E-02
     +,   1.0573133E-02,   1.0524097E-02,   1.0508644E-02
     +,   1.0525892E-02,   1.0576023E-02,   1.0660276E-02
     +,   1.0780924E-02,   1.0941255E-02,   1.1145522E-02
     +,   1.1398845E-02,   1.1707092E-02,   1.2076755E-02
     +,   1.2514748E-02,   1.3028125E-02,   1.3623840E-02
     +,   1.4308409E-02,   1.5087564E-02,   1.5965771E-02
     +,   1.6945846E-02,   1.8028645E-02,   1.9212566E-02
     +,   2.0493165E-02,   2.1862904E-02,   2.3311056E-02
     +,   2.4823539E-02,   2.6382824E-02,   2.7968379E-02
     +,   2.9556885E-02,   3.1122589E-02,   3.2638017E-02
     +,   3.4074813E-02,   3.5404447E-02,   3.6599003E-02
     +,   3.7632141E-02,   3.8480114E-02,   3.9122418E-02
     +,   3.9542515E-02,   3.9728429E-02,   3.9673213E-02
     +,   3.9375100E-02,   3.8837604E-02,   3.8069308E-02
     +,   3.7083477E-02,   3.5897706E-02,   3.4533203E-02
     +,   3.3013973E-02,   3.1366043E-02,   2.9616758E-02
     +,   2.7793910E-02,   2.5924772E-02,   2.4035532E-02
     +,   2.2150828E-02,   2.0293122E-02,   1.8482208E-02
     +,   1.6735069E-02,   1.5065943E-02,   1.3485963E-02
     +,   1.2003389E-02,   1.0623870E-02,   9.3505634E-03
     +,   8.1842933E-03,   7.1239723E-03,   6.1669527E-03
     +,   5.3092460E-03,   4.5457673E-03,   3.8706912E-03
     +,   3.2777197E-03,   2.7602529E-03,   2.3115487E-03
     +,   1.9249270E-03,   1.5939210E-03,   1.3123034E-03
     +,   1.0742068E-03,   8.7418238E-04,   7.0721208E-04
     +,   5.6871719E-04,   4.5457584E-04,   3.6111815E-04
     +,   2.8509871E-04,   2.2366954E-04,   1.7436003E-04
     +,   1.3504738E-04,   1.0391909E-04,   7.9440084E-05
     +,   6.0323226E-05,   4.5499659E-05,   3.4086184E-05
     +,   2.5360852E-05,   1.8738863E-05,   1.3749801E-05
     +,   1.0018356E-05,   7.2479775E-06,   5.2064515E-06
     +,   3.7132791E-06,   2.6293083E-06,   1.8482999E-06
     +,   1.2898669E-06,   8.9358304E-07,   6.1452533E-07
     +,   4.1950446E-07,   2.8426660E-07,   1.9119921E-07
     +,   1.2764967E-07,   8.4587569E-08,   5.5635343E-08
     +,   3.6319008E-08,   2.3532159E-08,   1.5132912E-08
     +,   9.6584039E-09,   6.1181211E-09,   3.8463099E-09
     +,   2.3999005E-09,   1.4861031E-09,   9.1331803E-10
     +,   5.5705351E-10,   3.3719813E-10,   2.0256817E-10
     +,   1.2077266E-10,   7.1459623E-11,   4.1962649E-11
     +,   2.4454487E-11,   1.4143680E-11
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_ashz_ttz120_mass = Yx/1.06752163636364
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_ashz_ttz60_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  7.1747473E-04,   8.4779976E-04
     +,   9.9897233E-04,   1.1738137E-03,   1.3754208E-03
     +,   1.6071688E-03,   1.8727087E-03,   2.1759577E-03
     +,   2.5210753E-03,   2.9124676E-03,   3.3547208E-03
     +,   3.8525928E-03,   4.4109658E-03,   5.0348141E-03
     +,   5.7291528E-03,   6.4990204E-03,   7.3494273E-03
     +,   8.2853502E-03,   9.3117086E-03,   1.0433345E-02
     +,   1.1655031E-02,   1.2981430E-02,   1.4417046E-02
     +,   1.5966276E-02,   1.7633023E-02,   1.9420840E-02
     +,   2.1332389E-02,   2.3369178E-02,   2.5531035E-02
     +,   2.7815513E-02,   3.0217145E-02,   3.2726750E-02
     +,   3.5330534E-02,   3.8009457E-02,   4.0738568E-02
     +,   4.3486714E-02,   4.6216439E-02,   4.8884436E-02
     +,   5.1442511E-02,   5.3838577E-02,   5.6019112E-02
     +,   5.7930939E-02,   5.9524048E-02,   6.0754303E-02
     +,   6.1586048E-02,   6.1994653E-02,   6.1968137E-02
     +,   6.1508663E-02,   6.0632892E-02,   5.9371565E-02
     +,   5.7768088E-02,   5.5876806E-02,   5.3760052E-02
     +,   5.1485088E-02,   4.9121197E-02,   4.6735846E-02
     +,   4.4392191E-02,   4.2146385E-02,   4.0045675E-02
     +,   3.8127009E-02,   3.6416467E-02,   3.4929264E-02
     +,   3.3670392E-02,   3.2635469E-02,   3.1812269E-02
     +,   3.1182325E-02,   3.0722573E-02,   3.0407095E-02
     +,   3.0208649E-02,   3.0100262E-02,   3.0056279E-02
     +,   3.0053496E-02,   3.0071767E-02,   3.0094586E-02
     +,   3.0109173E-02,   3.0106630E-02,   3.0081669E-02
     +,   3.0032296E-02,   2.9959559E-02,   2.9866885E-02
     +,   2.9759806E-02,   2.9645450E-02,   2.9532114E-02
     +,   2.9429026E-02,   2.9345945E-02,   2.9292936E-02
     +,   2.9280189E-02,   2.9317753E-02,   2.9415324E-02
     +,   2.9581932E-02,   2.9825678E-02,   3.0153394E-02
     +,   3.0570190E-02,   3.1079257E-02,   3.1681433E-02
     +,   3.2374937E-02,   3.3155255E-02,   3.4015041E-02
     +,   3.4944292E-02,   3.5930417E-02,   3.6958810E-02
     +,   3.8013116E-02,   3.9075900E-02,   4.0129226E-02
     +,   4.1155357E-02,   4.2137410E-02,   4.3059800E-02
     +,   4.3908957E-02,   4.4673823E-02,   4.5346178E-02
     +,   4.5920864E-02,   4.6396140E-02,   4.6773609E-02
     +,   4.7058240E-02,   4.7258135E-02,   4.7384284E-02
     +,   4.7450162E-02,   4.7471106E-02,   4.7463782E-02
     +,   4.7445402E-02,   4.7432922E-02,   4.7442220E-02
     +,   4.7487214E-02,   4.7579128E-02,   4.7725692E-02
     +,   4.7930583E-02,   4.8193201E-02,   4.8508443E-02
     +,   4.8866905E-02,   4.9255352E-02,   4.9657550E-02
     +,   5.0055258E-02,   5.0429359E-02,   5.0761230E-02
     +,   5.1033873E-02,   5.1233258E-02,   5.1348992E-02
     +,   5.1374990E-02,   5.1309664E-02,   5.1155712E-02
     +,   5.0919466E-02,   5.0609991E-02,   5.0237998E-02
     +,   4.9814504E-02,   4.9349591E-02,   4.8851468E-02
     +,   4.8325449E-02,   4.7773797E-02,   4.7195457E-02
     +,   4.6586420E-02,   4.5940533E-02,   4.5250323E-02
     +,   4.4508152E-02,   4.3707155E-02,   4.2842325E-02
     +,   4.1911192E-02,   4.0914260E-02,   3.9855082E-02
     +,   3.8739998E-02,   3.7577823E-02,   3.6379009E-02
     +,   3.5154805E-02,   3.3916794E-02,   3.2675862E-02
     +,   3.1441763E-02,   3.0222630E-02,   2.9025024E-02
     +,   2.7853686E-02,   2.6711775E-02,   2.5600985E-02
     +,   2.4522109E-02,   2.3475217E-02,   2.2459827E-02
     +,   2.1475350E-02,   2.0521270E-02,   1.9597119E-02
     +,   1.8702649E-02,   1.7837852E-02,   1.7002909E-02
     +,   1.6198058E-02,   1.5423597E-02,   1.4679884E-02
     +,   1.3967214E-02,   1.3285758E-02,   1.2635567E-02
     +,   1.2016613E-02,   1.1428743E-02,   1.0871639E-02
     +,   1.0344870E-02,   9.8479651E-03,   9.3802987E-03
     +,   8.9411680E-03,   8.5298177E-03,   8.1454180E-03
     +,   7.7870311E-03,   7.4536558E-03,   7.1442495E-03
     +,   6.8576895E-03,   6.5927799E-03,   6.3482663E-03
     +,   6.1228694E-03,   5.9152627E-03,   5.7240832E-03
     +,   5.5479486E-03,   5.3855027E-03,   5.2353726E-03
     +,   5.0962181E-03,   4.9667391E-03,   4.8456891E-03
     +,   4.7318707E-03,   4.6241563E-03,   4.5215045E-03
     +,   4.4229529E-03,   4.3276274E-03,   4.2347396E-03
     +,   4.1436055E-03,   4.0536313E-03,   3.9643100E-03
     +,   3.8752232E-03,   3.7860463E-03,   3.6965252E-03
     +,   3.6064831E-03,   3.5158095E-03,   3.4244619E-03
     +,   3.3324421E-03,   3.2397979E-03,   3.1466235E-03
     +,   3.0530442E-03,   2.9592062E-03,   2.8652744E-03
     +,   2.7714316E-03,   2.6778728E-03,   2.5847857E-03
     +,   2.4923626E-03,   2.4007985E-03,   2.3102723E-03
     +,   2.2209543E-03,   2.1330102E-03,   2.0465921E-03
     +,   1.9618340E-03,   1.8788547E-03,   1.7977648E-03
     +,   1.7186595E-03,   1.6416161E-03,   1.5666964E-03
     +,   1.4939551E-03,   1.4234335E-03,   1.3551568E-03
     +,   1.2891394E-03,   1.2253915E-03,   1.1639090E-03
     +,   1.1046780E-03,   1.0476827E-03,   9.9289976E-04
     +,   9.4029604E-04,   8.8983431E-04,   8.4147591E-04
     +,   7.9517829E-04,   7.5089303E-04,   7.0856931E-04
     +,   6.6815672E-04,   6.2960351E-04,   5.9285382E-04
     +,   5.5785140E-04,   5.2454293E-04,   4.9287104E-04
     +,   4.6277873E-04,   4.3421125E-04,   4.0711407E-04
     +,   3.8143111E-04,   3.5710746E-04,   3.3409032E-04
     +,   3.1232781E-04,   2.9176744E-04,   2.7235787E-04
     +,   2.5405083E-04,   2.3679659E-04,   2.2054906E-04
     +,   2.0526101E-04,   1.9088871E-04,   1.7738761E-04
     +,   1.6471627E-04,   1.5283293E-04,   1.4169863E-04
     +,   1.3127428E-04,   1.2152350E-04,   1.1241020E-04
     +,   1.0389966E-04,   9.5959287E-05,   8.8556706E-05
     +,   8.1661856E-05,   7.5244971E-05,   6.9278438E-05
     +,   6.3734973E-05,   5.8589398E-05,   5.3816861E-05
     +,   4.9394424E-05,   4.5299636E-05,   4.1511714E-05
     +,   3.8010417E-05,   3.4777036E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_ashz_ttz60_mass = Yx/1.56344883333333
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_ashz_ttz65_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  5.9612677E-04,   6.1886280E-04
     +,   6.4323866E-04,   6.6953135E-04,   6.9807080E-04
     +,   7.2924816E-04,   7.6352281E-04,   8.0143072E-04
     +,   8.4358966E-04,   8.9070731E-04,   9.4357994E-04
     +,   1.0030958E-03,   1.0702310E-03,   1.1460420E-03
     +,   1.2316550E-03,   1.3282488E-03,   1.4370348E-03
     +,   1.5592343E-03,   1.6960528E-03,   1.8486552E-03
     +,   2.0181476E-03,   2.2055614E-03,   2.4118549E-03
     +,   2.6379486E-03,   2.8847298E-03,   3.1531819E-03
     +,   3.4444507E-03,   3.7600133E-03,   4.1018552E-03
     +,   4.4726902E-03,   4.8761908E-03,   5.3172344E-03
     +,   5.8021215E-03,   6.3387570E-03,   6.9367681E-03
     +,   7.6075355E-03,   8.3641522E-03,   9.2212558E-03
     +,   1.0194980E-02,   1.1302586E-02,   1.2562649E-02
     +,   1.3994901E-02,   1.5620534E-02,   1.7462477E-02
     +,   1.9545786E-02,   2.1897843E-02,   2.4548201E-02
     +,   2.7527930E-02,   3.0868152E-02,   3.4597933E-02
     +,   3.8741302E-02,   4.3313902E-02,   4.8319340E-02
     +,   5.3745978E-02,   5.9562679E-02,   6.5717123E-02
     +,   7.2132163E-02,   7.8704387E-02,   8.5303441E-02
     +,   9.1773570E-02,   9.7938575E-02,   0.1036115    
     +,   0.1086091    ,   0.1127716    ,   0.1159833    
     +,   0.1181921    ,   0.1194225    ,   0.1197783    
     +,   0.1194310    ,   0.1185974    ,   0.1175053    
     +,   0.1163588    ,   0.1153056    ,   0.1144161    
     +,   0.1136773    ,   0.1130028    ,   0.1122557    
     +,   0.1112785    ,   0.1099256    ,   0.1080882    
     +,   0.1057123    ,   0.1028031    ,   9.9422380E-02
     +,   9.5675379E-02,   9.1697387E-02,   8.7637126E-02
     +,   8.3642997E-02,   7.9850592E-02,   7.6374970E-02
     +,   7.3302597E-02,   7.0688285E-02,   6.8553396E-02
     +,   6.6888079E-02,   6.5655336E-02,   6.4799033E-02
     +,   6.4252749E-02,   6.3948892E-02,   6.3826263E-02
     +,   6.3835137E-02,   6.3938849E-02,   6.4112090E-02
     +,   6.4337395E-02,   6.4600088E-02,   6.4884111E-02
     +,   6.5169051E-02,   6.5429077E-02,   6.5634057E-02
     +,   6.5752573E-02,   6.5755494E-02,   6.5620027E-02
     +,   6.5333195E-02,   6.4893946E-02,   6.4314164E-02
     +,   6.3617721E-02,   6.2838361E-02,   6.2016383E-02
     +,   6.1194681E-02,   6.0414512E-02,   5.9711669E-02
     +,   5.9113447E-02,   5.8636647E-02,   5.8287319E-02
     +,   5.8061354E-02,   5.7946779E-02,   5.7926621E-02
     +,   5.7982065E-02,   5.8095638E-02,   5.8253478E-02
     +,   5.8446623E-02,   5.8671411E-02,   5.8928803E-02
     +,   5.9222609E-02,   5.9557993E-02,   5.9939593E-02
     +,   6.0370147E-02,   6.0849924E-02,   6.1376337E-02
     +,   6.1944220E-02,   6.2546320E-02,   6.3173346E-02
     +,   6.3813604E-02,   6.4452663E-02,   6.5072134E-02
     +,   6.5648876E-02,   6.6153914E-02,   6.6552810E-02
     +,   6.6806421E-02,   6.6873133E-02,   6.6711850E-02
     +,   6.6285707E-02,   6.5566011E-02,   6.4535379E-02
     +,   6.3190594E-02,   6.1543100E-02,   5.9618887E-02
     +,   5.7456385E-02,   5.5103425E-02,   5.2612994E-02
     +,   5.0039262E-02,   4.7433965E-02,   4.4842862E-02
     +,   4.2303771E-02,   3.9845675E-02,   3.7488617E-02
     +,   3.5244226E-02,   3.3117417E-02,   3.1108050E-02
     +,   2.9212598E-02,   2.7425503E-02,   2.5740540E-02
     +,   2.4151791E-02,   2.2653991E-02,   2.1242669E-02
     +,   1.9914206E-02,   1.8665766E-02,   1.7494833E-02
     +,   1.6399100E-02,   1.5376298E-02,   1.4423986E-02
     +,   1.3539420E-02,   1.2719565E-02,   1.1961193E-02
     +,   1.1260849E-02,   1.0614880E-02,   1.0019567E-02
     +,   9.4712079E-03,   8.9661516E-03,   8.5008154E-03
     +,   8.0717476E-03,   7.6757036E-03,   7.3095770E-03
     +,   6.9704596E-03,   6.6556674E-03,   6.3627120E-03
     +,   6.0892925E-03,   5.8333082E-03,   5.5928719E-03
     +,   5.3662877E-03,   5.1520234E-03,   4.9487255E-03
     +,   4.7552190E-03,   4.5704776E-03,   4.3936106E-03
     +,   4.2238515E-03,   4.0605692E-03,   3.9032213E-03
     +,   3.7513527E-03,   3.6045990E-03,   3.4626636E-03
     +,   3.3252935E-03,   3.1922848E-03,   3.0634811E-03
     +,   2.9387537E-03,   2.8179884E-03,   2.7010916E-03
     +,   2.5879883E-03,   2.4786124E-03,   2.3728965E-03
     +,   2.2707782E-03,   2.1722037E-03,   2.0771110E-03
     +,   1.9854363E-03,   1.8971208E-03,   1.8121027E-03
     +,   1.7303117E-03,   1.6516756E-03,   1.5761245E-03
     +,   1.5035861E-03,   1.4339811E-03,   1.3672283E-03
     +,   1.3032504E-03,   1.2419671E-03,   1.1832940E-03
     +,   1.1271465E-03,   1.0734444E-03,   1.0221022E-03
     +,   9.7303517E-04,   9.2616247E-04,   8.8140304E-04
     +,   8.3867443E-04,   7.9789525E-04,   7.5898826E-04
     +,   7.2187744E-04,   6.8648579E-04,   6.5273896E-04
     +,   6.2056578E-04,   5.8989786E-04,   5.6066614E-04
     +,   5.3280417E-04,   5.0625071E-04,   4.8094368E-04
     +,   4.5682376E-04,   4.3383538E-04,   4.1192543E-04
     +,   3.9104151E-04,   3.7113373E-04,   3.5215588E-04
     +,   3.3406395E-04,   3.1681493E-04,   3.0036794E-04
     +,   2.8468564E-04,   2.6973226E-04,   2.5547331E-04
     +,   2.4187610E-04,   2.2891109E-04,   2.1654920E-04
     +,   2.0476288E-04,   1.9352698E-04,   1.8281778E-04
     +,   1.7261208E-04,   1.6288797E-04,   1.5362549E-04
     +,   1.4480554E-04,   1.3640952E-04,   1.2841982E-04
     +,   1.2082038E-04,   1.1359491E-04,   1.0672879E-04
     +,   1.0020718E-04,   9.4016679E-05,   8.8143548E-05
     +,   8.2575447E-05,   7.7299665E-05,   7.2304625E-05
     +,   6.7578534E-05,   6.3110536E-05,   5.8889687E-05
     +,   5.4905362E-05,   5.1147676E-05,   4.7606514E-05
     +,   4.4272503E-05,   4.1136089E-05,   3.8188449E-05
     +,   3.5420559E-05,   3.2824068E-05,   3.0390514E-05
     +,   2.8112008E-05,   2.5980602E-05,   2.3988896E-05
     +,   2.2129452E-05,   2.0395333E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_ashz_ttz65_mass = Yx/2.17379178947368
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_ashz_ttz70_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  6.8565953E-04,   7.3077244E-04
     +,   7.7889679E-04,   8.3015615E-04,   8.8466954E-04
     +,   9.4255048E-04,   1.0039050E-03,   1.0688320E-03
     +,   1.1374190E-03,   1.2097469E-03,   1.2858808E-03
     +,   1.3658748E-03,   1.4497682E-03,   1.5375862E-03
     +,   1.6293383E-03,   1.7250169E-03,   1.8245992E-03
     +,   1.9280445E-03,   2.0352949E-03,   2.1462778E-03
     +,   2.2609015E-03,   2.3790624E-03,   2.5006372E-03
     +,   2.6255008E-03,   2.7535022E-03,   2.8844962E-03
     +,   3.0183257E-03,   3.1548322E-03,   3.2938651E-03
     +,   3.4352816E-03,   3.5789579E-03,   3.7247993E-03
     +,   3.8727524E-03,   4.0228190E-03,   4.1750758E-03
     +,   4.3296963E-03,   4.4869781E-03,   4.6473704E-03
     +,   4.8115253E-03,   4.9803038E-03,   5.1548714E-03
     +,   5.3367051E-03,   5.5276705E-03,   5.7300683E-03
     +,   5.9466921E-03,   6.1808792E-03,   6.4365515E-03
     +,   6.7182467E-03,   7.0311376E-03,   7.3810010E-03
     +,   7.7741924E-03,   8.2175462E-03,   8.7182429E-03
     +,   9.2836842E-03,   9.9211596E-03,   1.0637774E-02
     +,   1.1440086E-02,   1.2334045E-02,   1.3324957E-02
     +,   1.4417835E-02,   1.5618004E-02,   1.6932365E-02
     +,   1.8371020E-02,   1.9949766E-02,   2.1692684E-02
     +,   2.3634598E-02,   2.5823798E-02,   2.8322516E-02
     +,   3.1207135E-02,   3.4564566E-02,   3.8488008E-02
     +,   4.3068528E-02,   4.8386984E-02,   5.4502591E-02
     +,   6.1443634E-02,   6.9197610E-02,   7.7702910E-02
     +,   8.6844556E-02,   9.6454360E-02,   0.1063153    
     +,   0.1161719    ,   0.1257510    ,   0.1347837    
     +,   0.1430368    ,   0.1503388    ,   0.1566071    
     +,   0.1618567    ,   0.1661970    ,   0.1698024    
     +,   0.1728651    ,   0.1755357    ,   0.1778682    
     +,   0.1797903    ,   0.1811120    ,   0.1815787    
     +,   0.1809533    ,   0.1791076    ,   0.1760844    
     +,   0.1721113    ,   0.1675572    ,   0.1628430    
     +,   0.1583386    ,   0.1542775    ,   0.1507192    
     +,   0.1475620    ,   0.1446014    ,   0.1416066    
     +,   0.1383893    ,   0.1348459    ,   0.1309678    
     +,   0.1268259    ,   0.1225409    ,   0.1182548    
     +,   0.1141106    ,   0.1102417    ,   0.1067678    
     +,   0.1037924    ,   0.1013974    ,   9.9637009E-02
     +,   9.8528974E-02,   9.8049551E-02,   9.8133616E-02
     +,   9.8679610E-02,   9.9559709E-02,   0.1006321    
     +,   0.1017531    ,   0.1027875    ,   0.1036158    
     +,   0.1041400    ,   0.1042863    ,   0.1040074    
     +,   0.1032830    ,   0.1021189    ,   0.1005454    
     +,   9.8611601E-02,   9.6380383E-02,   9.3921140E-02
     +,   9.1302544E-02,   8.8585868E-02,   8.5820757E-02
     +,   8.3042674E-02,   8.0273323E-02,   7.7522628E-02
     +,   7.4793108E-02,   7.2085053E-02,   6.9400690E-02
     +,   6.6747800E-02,   6.4141877E-02,   6.1605699E-02
     +,   5.9167355E-02,   5.6856941E-02,   5.4703001E-02
     +,   5.2728590E-02,   5.0948061E-02,   4.9365375E-02
     +,   4.7973838E-02,   4.6756420E-02,   4.5687605E-02
     +,   4.4735961E-02,   4.3866996E-02,   4.3045796E-02
     +,   4.2239685E-02,   4.1420303E-02,   4.0565059E-02
     +,   3.9657973E-02,   3.8689911E-02,   3.7658375E-02
     +,   3.6566786E-02,   3.5423320E-02,   3.4239810E-02
     +,   3.3030547E-02,   3.1811044E-02,   3.0596783E-02
     +,   2.9402481E-02,   2.8241424E-02,   2.7124833E-02
     +,   2.6061675E-02,   2.5058711E-02,   2.4120374E-02
     +,   2.3249006E-02,   2.2445086E-02,   2.1707615E-02
     +,   2.1034313E-02,   2.0421896E-02,   1.9866342E-02
     +,   1.9363189E-02,   1.8907607E-02,   1.8494546E-02
     +,   1.8118884E-02,   1.7775474E-02,   1.7459178E-02
     +,   1.7164910E-02,   1.6887680E-02,   1.6622631E-02
     +,   1.6365014E-02,   1.6110297E-02,   1.5854198E-02
     +,   1.5592725E-02,   1.5322262E-02,   1.5039589E-02
     +,   1.4741990E-02,   1.4427294E-02,   1.4093873E-02
     +,   1.3740704E-02,   1.3367397E-02,   1.2974129E-02
     +,   1.2561630E-02,   1.2131208E-02,   1.1684621E-02
     +,   1.1224020E-02,   1.0751875E-02,   1.0270935E-02
     +,   9.7841183E-03,   9.2943944E-03,   8.8047404E-03
     +,   8.3181066E-03,   7.8373160E-03,   7.3649818E-03
     +,   6.9034980E-03,   6.4550489E-03,   6.0214973E-03
     +,   5.6044147E-03,   5.2051065E-03,   4.8245830E-03
     +,   4.4635483E-03,   4.1224379E-03,   3.8014625E-03
     +,   3.5006087E-03,   3.2196352E-03,   2.9581347E-03
     +,   2.7155632E-03,   2.4912548E-03,   2.2844295E-03
     +,   2.0942339E-03,   1.9197797E-03,   1.7601263E-03
     +,   1.6143179E-03,   1.4814078E-03,   1.3604577E-03
     +,   1.2505441E-03,   1.1507757E-03,   1.0603046E-03
     +,   9.7832491E-04,   9.0407074E-04,   8.3682616E-04
     +,   7.7592861E-04,   7.2076416E-04,   6.7076413E-04
     +,   6.2540773E-04,   5.8422401E-04,   5.4678088E-04
     +,   5.1268743E-04,   4.8159310E-04,   4.5318279E-04
     +,   4.2717173E-04,   4.0330554E-04,   3.8135884E-04
     +,   3.6113072E-04,   3.4244134E-04,   3.2513135E-04
     +,   3.0906033E-04,   2.9410419E-04,   2.8015199E-04
     +,   2.6710570E-04,   2.5488000E-04,   2.4339808E-04
     +,   2.3259208E-04,   2.2240271E-04,   2.1277725E-04
     +,   2.0366831E-04,   1.9503396E-04,   1.8683718E-04
     +,   1.7904500E-04,   1.7162749E-04,   1.6455767E-04
     +,   1.5781210E-04,   1.5136870E-04,   1.4520829E-04
     +,   1.3931279E-04,   1.3366636E-04,   1.2825396E-04
     +,   1.2306246E-04,   1.1807920E-04,   1.1329316E-04
     +,   1.0869360E-04,   1.0427121E-04,   1.0001698E-04
     +,   9.5922573E-05,   9.1980663E-05,   8.8183981E-05
     +,   8.4526240E-05,   8.1001184E-05,   7.7603429E-05
     +,   7.4327545E-05,   7.1168892E-05,   6.8122761E-05
     +,   6.5185159E-05,   6.2351974E-05,   5.9619721E-05
     +,   5.6984802E-05,   5.4444201E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_ashz_ttz70_mass = Yx/2.6927313
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_ashz_ttz75_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.4837361E-04,   4.7819089E-04
     +,   5.0943880E-04,   5.4214639E-04,   5.7634083E-04
     +,   6.1204744E-04,   6.4928993E-04,   6.8809075E-04
     +,   7.2846981E-04,   7.7044731E-04,   8.1404008E-04
     +,   8.5926458E-04,   9.0613507E-04,   9.5466553E-04
     +,   1.0048683E-03,   1.0567548E-03,   1.1103358E-03
     +,   1.1656210E-03,   1.2226200E-03,   1.2813415E-03
     +,   1.3417944E-03,   1.4039862E-03,   1.4679244E-03
     +,   1.5336201E-03,   1.6010761E-03,   1.6703039E-03
     +,   1.7413092E-03,   1.8140994E-03,   1.8886813E-03
     +,   1.9650601E-03,   2.0432419E-03,   2.1232294E-03
     +,   2.2050259E-03,   2.2886309E-03,   2.3740428E-03
     +,   2.4612555E-03,   2.5502602E-03,   2.6410404E-03
     +,   2.7335815E-03,   2.8278502E-03,   2.9238181E-03
     +,   3.0214419E-03,   3.1206692E-03,   3.2214406E-03
     +,   3.3236865E-03,   3.4273292E-03,   3.5322839E-03
     +,   3.6384636E-03,   3.7457852E-03,   3.8541749E-03
     +,   3.9635822E-03,   4.0739961E-03,   4.1854624E-03
     +,   4.2981198E-03,   4.4122129E-03,   4.5281602E-03
     +,   4.6465779E-03,   4.7683432E-03,   4.8946552E-03
     +,   5.0270911E-03,   5.1676738E-03,   5.3189262E-03
     +,   5.4839021E-03,   5.6662308E-03,   5.8701052E-03
     +,   6.1002183E-03,   6.3617448E-03,   6.6601634E-03
     +,   7.0012049E-03,   7.3906486E-03,   7.8343283E-03
     +,   8.3380546E-03,   8.9079114E-03,   9.5505901E-03
     +,   1.0274267E-02,   1.1089773E-02,   1.2012057E-02
     +,   1.3062126E-02,   1.4268948E-02,   1.5670946E-02
     +,   1.7316248E-02,   1.9261871E-02,   2.1570046E-02
     +,   2.4303576E-02,   2.7519122E-02,   3.1263053E-02
     +,   3.5569247E-02,   4.0464893E-02,   4.5981094E-02
     +,   5.2170936E-02,   5.9127763E-02,   6.6999704E-02
     +,   7.5996429E-02,   8.6383872E-02,   9.8461308E-02
     +,   0.1125149    ,   0.1287458    ,   0.1471634    
     +,   0.1674719    ,   0.1889809    ,   0.2106277    
     +,   0.2311593    ,   0.2494977    ,   0.2651493    
     +,   0.2784413    ,   0.2903414    ,   0.3018528    
     +,   0.3132936    ,   0.3239406    ,   0.3323181    
     +,   0.3369609    ,   0.3371337    ,   0.3330650    
     +,   0.3256737    ,   0.3161170    ,   0.3054979    
     +,   0.2948528    ,   0.2852467    ,   0.2777221    
     +,   0.2729687    ,   0.2708952    ,   0.2704697    
     +,   0.2700966    ,   0.2683879    ,   0.2648441    
     +,   0.2599708    ,   0.2547461    ,   0.2498127    
     +,   0.2449384    ,   0.2390866    ,   0.2310099    
     +,   0.2199684    ,   0.2061439    ,   0.1905812    
     +,   0.1747597    ,   0.1600796    ,   0.1474936    
     +,   0.1373796    ,   0.1296232    ,   0.1238031    
     +,   0.1193880    ,   0.1158839    ,   0.1129168    
     +,   0.1102576    ,   0.1078066    ,   0.1055555    
     +,   0.1035430    ,   0.1018128    ,   0.1003816    
     +,   9.9219427E-02,   9.8245822E-02,   9.7338751E-02
     +,   9.6354321E-02,   9.5150515E-02,   9.3608692E-02
     +,   9.1648117E-02,   8.9231461E-02,   8.6361520E-02
     +,   8.3072536E-02,   7.9421230E-02,   7.5476974E-02
     +,   7.1316548E-02,   6.7020938E-02,   6.2673487E-02
     +,   5.8358073E-02,   5.4156978E-02,   5.0147742E-02
     +,   4.6398688E-02,   4.2964689E-02,   3.9884370E-02
     +,   3.7178628E-02,   3.4850411E-02,   3.2886289E-02
     +,   3.1259362E-02,   2.9932866E-02,   2.8863449E-02
     +,   2.8004903E-02,   2.7311174E-02,   2.6738860E-02
     +,   2.6248986E-02,   2.5808392E-02,   2.5390312E-02
     +,   2.4974529E-02,   2.4546979E-02,   2.4099147E-02
     +,   2.3627179E-02,   2.3130875E-02,   2.2612646E-02
     +,   2.2076599E-02,   2.1527722E-02,   2.0971153E-02
     +,   2.0411694E-02,   1.9853495E-02,   1.9299801E-02
     +,   1.8752823E-02,   1.8213792E-02,   1.7683044E-02
     +,   1.7160123E-02,   1.6643899E-02,   1.6132757E-02
     +,   1.5624857E-02,   1.5118220E-02,   1.4610889E-02
     +,   1.4101112E-02,   1.3587483E-02,   1.3068965E-02
     +,   1.2544986E-02,   1.2015527E-02,   1.1481083E-02
     +,   1.0942620E-02,   1.0401563E-02,   9.8597724E-03
     +,   9.3194274E-03,   8.7829139E-03,   8.2527632E-03
     +,   7.7315890E-03,   7.2219698E-03,   6.7263311E-03
     +,   6.2469142E-03,   5.7857558E-03,   5.3445543E-03
     +,   4.9246899E-03,   4.5272294E-03,   4.1528963E-03
     +,   3.8020576E-03,   3.4747652E-03,   3.1708060E-03
     +,   2.8897077E-03,   2.6307595E-03,   2.3930715E-03
     +,   2.1756268E-03,   1.9772996E-03,   1.7968809E-03
     +,   1.6331230E-03,   1.4847849E-03,   1.3506219E-03
     +,   1.2294230E-03,   1.1200355E-03,   1.0213638E-03
     +,   9.3237543E-04,   8.5211080E-04,   7.7969348E-04
     +,   7.1432034E-04,   6.5525831E-04,   6.0184603E-04
     +,   5.5349269E-04,   5.0966884E-04,   4.6989910E-04
     +,   4.3376046E-04,   4.0088009E-04,   3.7092328E-04
     +,   3.4359269E-04,   3.1862577E-04,   2.9578875E-04
     +,   2.7487162E-04,   2.5568696E-04,   2.3806859E-04
     +,   2.2186736E-04,   2.0694843E-04,   1.9319070E-04
     +,   1.8048623E-04,   1.6873761E-04,   1.5785650E-04
     +,   1.4776328E-04,   1.3838721E-04,   1.2966375E-04
     +,   1.2153490E-04,   1.1394887E-04,   1.0685938E-04
     +,   1.0022432E-04,   9.4006064E-05,   8.8171299E-05
     +,   8.2690189E-05,   7.7535798E-05,   7.2683979E-05
     +,   6.8113630E-05,   6.3805288E-05,   5.9742069E-05
     +,   5.5908269E-05,   5.2290270E-05,   4.8875267E-05
     +,   4.5652108E-05,   4.2610216E-05,   3.9740295E-05
     +,   3.7033406E-05,   3.4481604E-05,   3.2077267E-05
     +,   2.9813231E-05,   2.7682981E-05,   2.5680059E-05
     +,   2.3798571E-05,   2.2032649E-05,   2.0376896E-05
     +,   1.8825898E-05,   1.7374641E-05,   1.6018088E-05
     +,   1.4751549E-05,   1.3570328E-05,   1.2470019E-05
     +,   1.1446231E-05,   1.0494840E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_ashz_ttz75_mass = Yx/3.6201955
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_ashz_ttz80_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  7.4217765E-04,   7.7252043E-04
     +,   8.0356590E-04,   8.3529722E-04,   8.6769823E-04
     +,   9.0075284E-04,   9.3444652E-04,   9.6876692E-04
     +,   1.0037039E-03,   1.0392515E-03,   1.0754070E-03
     +,   1.1121730E-03,   1.1495580E-03,   1.1875768E-03
     +,   1.2262518E-03,   1.2656139E-03,   1.3057030E-03
     +,   1.3465685E-03,   1.3882718E-03,   1.4308849E-03
     +,   1.4744927E-03,   1.5191915E-03,   1.5650921E-03
     +,   1.6123205E-03,   1.6610115E-03,   1.7113185E-03
     +,   1.7634055E-03,   1.8174504E-03,   1.8736424E-03
     +,   1.9321826E-03,   1.9932804E-03,   2.0571530E-03
     +,   2.1240246E-03,   2.1941199E-03,   2.2676655E-03
     +,   2.3448826E-03,   2.4259866E-03,   2.5111784E-03
     +,   2.6006505E-03,   2.6945637E-03,   2.7930632E-03
     +,   2.8962565E-03,   3.0042189E-03,   3.1169837E-03
     +,   3.2345387E-03,   3.3568195E-03,   3.4837092E-03
     +,   3.6150361E-03,   3.7505631E-03,   3.8899994E-03
     +,   4.0329895E-03,   4.1791201E-03,   4.3279245E-03
     +,   4.4788914E-03,   4.6314527E-03,   4.7850297E-03
     +,   4.9390090E-03,   5.0927787E-03,   5.2457405E-03
     +,   5.3973286E-03,   5.5470378E-03,   5.6944476E-03
     +,   5.8392468E-03,   5.9812851E-03,   6.1206035E-03
     +,   6.2574642E-03,   6.3924319E-03,   6.5263910E-03
     +,   6.6606496E-03,   6.7969565E-03,   6.9376207E-03
     +,   7.0855333E-03,   7.2442843E-03,   7.4181682E-03
     +,   7.6122694E-03,   7.8324722E-03,   8.0854092E-03
     +,   8.3783977E-03,   8.7193279E-03,   9.1164261E-03
     +,   9.5779207E-03,   1.0111784E-02,   1.0725215E-02
     +,   1.1424418E-02,   1.2214159E-02,   1.3097898E-02
     +,   1.4077838E-02,   1.5155868E-02,   1.6334482E-02
     +,   1.7618747E-02,   1.9018291E-02,   2.0549387E-02
     +,   2.2236908E-02,   2.4115432E-02,   2.6228821E-02
     +,   2.8627632E-02,   3.1365089E-02,   3.4489758E-02
     +,   3.8037989E-02,   4.2024009E-02,   4.6432726E-02
     +,   5.1213197E-02,   5.6279521E-02,   6.1516844E-02
     +,   6.6799849E-02,   7.2020754E-02,   7.7126428E-02
     +,   8.2159214E-02,   8.7289385E-02,   9.2824139E-02
     +,   9.9180594E-02,   0.1068174    ,   0.1161272    
     +,   0.1273181    ,   0.1403090    ,   0.1546914    
     +,   0.1697765    ,   0.1847549    ,   0.1989528    
     +,   0.2121846    ,   0.2251259    ,   0.2395292    
     +,   0.2579536    ,   0.2827228    ,   0.3142833    
     +,   0.3499175    ,   0.3841708    ,   0.4114201    
     +,   0.4292161    ,   0.4398836    ,   0.4490370    
     +,   0.4618507    ,   0.4793843    ,   0.4973895    
     +,   0.5088920    ,   0.5090541    ,   0.4982829    
     +,   0.4808812    ,   0.4609610    ,   0.4398832    
     +,   0.4170488    ,   0.3921336    ,   0.3660900    
     +,   0.3404357    ,   0.3161594    ,   0.2933901    
     +,   0.2718571    ,   0.2514890    ,   0.2326473    
     +,   0.2158941    ,   0.2015380    ,   0.1893246    
     +,   0.1784975    ,   0.1681547    ,   0.1576299    
     +,   0.1466698    ,   0.1353744    ,   0.1240279    
     +,   0.1129527    ,   0.1024346    ,   9.2699923E-02
     +,   8.3911374E-02,   7.6162614E-02,   6.9473267E-02
     +,   6.3794293E-02,   5.9027173E-02,   5.5049647E-02
     +,   5.1738750E-02,   4.8986118E-02,   4.6703130E-02
     +,   4.4818047E-02,   4.3269090E-02,   4.1997794E-02
     +,   4.0945306E-02,   4.0051971E-02,   3.9259098E-02
     +,   3.8512584E-02,   3.7766270E-02,   3.6984518E-02
     +,   3.6143288E-02,   3.5230197E-02,   3.4243327E-02
     +,   3.3189416E-02,   3.2081541E-02,   3.0936832E-02
     +,   2.9774562E-02,   2.8614167E-02,   2.7473705E-02
     +,   2.6368860E-02,   2.5312278E-02,   2.4313036E-02
     +,   2.3376597E-02,   2.2505062E-02,   2.1697408E-02
     +,   2.0949941E-02,   2.0256849E-02,   1.9610874E-02
     +,   1.9003773E-02,   1.8426863E-02,   1.7871538E-02
     +,   1.7329719E-02,   1.6794132E-02,   1.6258543E-02
     +,   1.5717974E-02,   1.5168802E-02,   1.4608704E-02
     +,   1.4036646E-02,   1.3452816E-02,   1.2858445E-02
     +,   1.2255581E-02,   1.1646956E-02,   1.1035824E-02
     +,   1.0425728E-02,   9.8202759E-03,   9.2230579E-03
     +,   8.6375112E-03,   8.0668181E-03,   7.5137517E-03
     +,   6.9807083E-03,   6.4696847E-03,   5.9822025E-03
     +,   5.5193524E-03,   5.0818617E-03,   4.6700793E-03
     +,   4.2839982E-03,   3.9233291E-03,   3.5875656E-03
     +,   3.2759979E-03,   2.9877385E-03,   2.7217795E-03
     +,   2.4770477E-03,   2.2524060E-03,   2.0466719E-03
     +,   1.8586507E-03,   1.6871748E-03,   1.5310750E-03
     +,   1.3892154E-03,   1.2605082E-03,   1.1439101E-03
     +,   1.0384182E-03,   9.4308483E-04,   8.5702376E-04
     +,   7.7940209E-04,   7.0943806E-04,   6.4640545E-04
     +,   5.8963679E-04,   5.3851533E-04,   4.9247214E-04
     +,   4.5098702E-04,   4.1358950E-04,   3.7984876E-04
     +,   3.4937507E-04,   3.2181881E-04,   2.9686542E-04
     +,   2.7423151E-04,   2.5366383E-04,   2.3493815E-04
     +,   2.1785476E-04,   2.0223563E-04,   1.8792329E-04
     +,   1.7477944E-04,   1.6268210E-04,   1.5152305E-04
     +,   1.4120717E-04,   1.3165169E-04,   1.2278301E-04
     +,   1.1453649E-04,   1.0685586E-04,   9.9691541E-05
     +,   9.2999464E-05,   8.6740765E-05,   8.0881546E-05
     +,   7.5391770E-05,   7.0244379E-05,   6.5415326E-05
     +,   6.0883529E-05,   5.6629491E-05,   5.2636115E-05
     +,   4.8887458E-05,   4.5369412E-05,   4.2068608E-05
     +,   3.8973169E-05,   3.6071655E-05,   3.3353797E-05
     +,   3.0809617E-05,   2.8430077E-05,   2.6206366E-05
     +,   2.4130168E-05,   2.2193757E-05,   2.0389492E-05
     +,   1.8710316E-05,   1.7149243E-05,   1.5699776E-05
     +,   1.4355489E-05,   1.3110387E-05,   1.1958547E-05
     +,   1.0894443E-05,   9.9126155E-06,   9.0079875E-06
     +,   8.1755543E-06,   7.4106597E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_ashz_ttz80_mass = Yx/4.087784
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_ashz_ttz85_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.0487568E-05,   4.6720339E-05
     +,   5.3783759E-05,   6.1766485E-05,   7.0763184E-05
     +,   8.0874153E-05,   9.2205308E-05,   1.0486750E-04
     +,   1.1897601E-04,   1.3465053E-04,   1.5201322E-04
     +,   1.7118835E-04,   1.9230100E-04,   2.1547571E-04
     +,   2.4083503E-04,   2.6849742E-04,   2.9857596E-04
     +,   3.3117572E-04,   3.6639214E-04,   4.0430835E-04
     +,   4.4499303E-04,   4.8849772E-04,   5.3485419E-04
     +,   5.8407517E-04,   6.3614396E-04,   6.9102325E-04
     +,   7.4864406E-04,   8.0890820E-04,   8.7168609E-04
     +,   9.3681522E-04,   1.0041000E-03,   1.0733109E-03
     +,   1.1441851E-03,   1.2164277E-03,   1.2897117E-03
     +,   1.3636814E-03,   1.4379546E-03,   1.5121241E-03
     +,   1.5857688E-03,   1.6584436E-03,   1.7297021E-03
     +,   1.7990896E-03,   1.8661539E-03,   1.9304529E-03
     +,   1.9915600E-03,   2.0490719E-03,   2.1026186E-03
     +,   2.1518678E-03,   2.1965387E-03,   2.2364040E-03
     +,   2.2713039E-03,   2.3011523E-03,   2.3259458E-03
     +,   2.3457713E-03,   2.3608143E-03,   2.3713647E-03
     +,   2.3778260E-03,   2.3807196E-03,   2.3806873E-03
     +,   2.3784970E-03,   2.3750439E-03,   2.3713480E-03
     +,   2.3685533E-03,   2.3679195E-03,   2.3708188E-03
     +,   2.3787187E-03,   2.3931714E-03,   2.4157946E-03
     +,   2.4482519E-03,   2.4922269E-03,   2.5494006E-03
     +,   2.6214172E-03,   2.7098693E-03,   2.8162471E-03
     +,   2.9419330E-03,   3.0881711E-03,   3.2560322E-03
     +,   3.4464085E-03,   3.6600165E-03,   3.8973857E-03
     +,   4.1588391E-03,   4.4445717E-03,   4.7545955E-03
     +,   5.0888569E-03,   5.4471870E-03,   5.8294395E-03
     +,   6.2354356E-03,   6.6651185E-03,   7.1184807E-03
     +,   7.5956974E-03,   8.0971001E-03,   8.6231455E-03
     +,   9.1744289E-03,   9.7516589E-03,   1.0355583E-02
     +,   1.0986801E-02,   1.1645803E-02,   1.2332690E-02
     +,   1.3047208E-02,   1.3788456E-02,   1.4555049E-02
     +,   1.5344896E-02,   1.6155552E-02,   1.6984288E-02
     +,   1.7828755E-02,   1.8687779E-02,   1.9562369E-02
     +,   2.0457428E-02,   2.1383826E-02,   2.2360601E-02
     +,   2.3417212E-02,   2.4595646E-02,   2.5950627E-02
     +,   2.7548585E-02,   2.9462921E-02,   3.1766962E-02
     +,   3.4523271E-02,   3.7772644E-02,   4.1523278E-02
     +,   4.5746066E-02,   5.0377790E-02,   5.5335552E-02
     +,   6.0543686E-02,   6.5968469E-02,   7.1650095E-02
     +,   7.7718958E-02,   8.4386259E-02,   9.1905221E-02
     +,   0.1005262    ,   0.1104706    ,   0.1219466    
     +,   0.1351760    ,   0.1503856    ,   0.1677178    
     +,   0.1871360    ,   0.2084297    ,   0.2313595    
     +,   0.2557865    ,   0.2815918    ,   0.3084482    
     +,   0.3357817    ,   0.3631018    ,   0.3904758    
     +,   0.4187033    ,   0.4488238    ,   0.4810224    
     +,   0.5137742    ,   0.5441514    ,   0.5690665    
     +,   0.5869426    ,   0.5992859    ,   0.6096480    
     +,   0.6195410    ,   0.6274955    ,   0.6328939    
     +,   0.6349179    ,   0.6257529    ,   0.5934368    
     +,   0.5359256    ,   0.4660141    ,   0.3998811    
     +,   0.3460212    ,   0.3052658    ,   0.2752317    
     +,   0.2524003    ,   0.2328295    ,   0.2133626    
     +,   0.1925696    ,   0.1706260    ,   0.1485839    
     +,   0.1277137    ,   0.1091217    ,   9.3579710E-02
     +,   8.1481829E-02,   7.2873920E-02,   6.7515418E-02
     +,   6.4955778E-02,   6.4606227E-02,   6.5805174E-02
     +,   6.7878895E-02,   7.0195064E-02,   7.2208576E-02
     +,   7.3497228E-02,   7.3784545E-02,   7.2946854E-02
     +,   7.1004458E-02,   6.8097040E-02,   6.4447232E-02
     +,   6.0318697E-02,   5.5976197E-02,   5.1652104E-02
     +,   4.7525752E-02,   4.3715741E-02,   4.0282544E-02
     +,   3.7238959E-02,   3.4564544E-02,   3.2219734E-02
     +,   3.0157125E-02,   2.8329346E-02,   2.6693704E-02
     +,   2.5214063E-02,   2.3860669E-02,   2.2609217E-02
     +,   2.1439847E-02,   2.0336270E-02,   1.9284762E-02
     +,   1.8273916E-02,   1.7294385E-02,   1.6338747E-02
     +,   1.5401375E-02,   1.4478454E-02,   1.3567964E-02
     +,   1.2669502E-02,   1.1784054E-02,   1.0913826E-02
     +,   1.0062054E-02,   9.2326263E-03,   8.4297359E-03
     +,   7.6576620E-03,   6.9205407E-03,   6.2220050E-03
     +,   5.5650719E-03,   4.9520601E-03,   4.3844627E-03
     +,   3.8629074E-03,   3.3872181E-03,   2.9565196E-03
     +,   2.5692848E-03,   2.2234390E-03,   1.9165027E-03
     +,   1.6457350E-03,   1.4082191E-03,   1.2009525E-03
     +,   1.0209539E-03,   8.6534664E-04,   7.3137670E-04
     +,   6.1647047E-04,   5.1826419E-04,   4.3460491E-04
     +,   3.6354989E-04,   3.0336808E-04,   2.5253333E-04
     +,   2.0970475E-04,   1.7370946E-04,   1.4353004E-04
     +,   1.1828898E-04,   9.7230477E-05,   7.9704456E-05
     +,   6.5155036E-05,   5.3109059E-05,   4.3162359E-05
     +,   3.4971799E-05,   2.8247065E-05,   2.2742477E-05
     +,   1.8250406E-05,   1.4596188E-05,   1.1633410E-05
     +,   9.2394275E-06,   7.3116867E-06,   5.7648595E-06
     +,   4.5282500E-06,   3.5433602E-06,   2.7619130E-06
     +,   2.1442779E-06,   1.6580864E-06,   1.2768983E-06
     +,   9.7925795E-07,   7.4783611E-07,   5.6867310E-07
     +,   4.3056275E-07,   3.2456344E-07,   2.4357479E-07
     +,   1.8197723E-07,   1.3534061E-07,   1.0019377E-07
     +,   7.3831878E-08,   5.4151663E-08,   3.9530715E-08
     +,   2.8720287E-08,   2.0766706E-08,   1.4943366E-08
     +,   1.0701065E-08,   7.6257480E-09,   5.4077129E-09
     +,   3.8159285E-09,   2.6794356E-09,   1.8721005E-09
     +,   1.3015043E-09,   9.0031760E-10,   6.1967292E-10
     +,   4.2437670E-10,   2.8916558E-10,   1.9604435E-10
     +,   1.3223900E-10,   8.8750396E-11,   5.9261332E-11
     +,   3.9370524E-11,   2.6023017E-11,   1.7113420E-11
     +,   1.1196919E-11,   7.2887182E-12
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_ashz_ttz85_mass = Yx/4.42589162790698
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_ashz_ttz90_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.6058080E-04,   3.7865114E-04
     +,   3.9726630E-04,   4.1641621E-04,   4.3608912E-04
     +,   4.5627082E-04,   4.7694516E-04,   4.9809366E-04
     +,   5.1969546E-04,   5.4172880E-04,   5.6416885E-04
     +,   5.8698887E-04,   6.1016122E-04,   6.3365552E-04
     +,   6.5744086E-04,   6.8148458E-04,   7.0575299E-04
     +,   7.3021220E-04,   7.5482711E-04,   7.7956321E-04
     +,   8.0438569E-04,   8.2926085E-04,   8.5415528E-04
     +,   8.7903917E-04,   9.0388174E-04,   9.2865765E-04
     +,   9.5334352E-04,   9.7791990E-04,   1.0023719E-03
     +,   1.0266904E-03,   1.0508717E-03,   1.0749194E-03
     +,   1.0988448E-03,   1.1226669E-03,   1.1464151E-03
     +,   1.1701295E-03,   1.1938604E-03,   1.2176712E-03
     +,   1.2416393E-03,   1.2658553E-03,   1.2904262E-03
     +,   1.3154757E-03,   1.3411437E-03,   1.3675902E-03
     +,   1.3949929E-03,   1.4235505E-03,   1.4534820E-03
     +,   1.4850269E-03,   1.5184464E-03,   1.5540222E-03
     +,   1.5920578E-03,   1.6328753E-03,   1.6768160E-03
     +,   1.7242410E-03,   1.7755202E-03,   1.8310429E-03
     +,   1.8912036E-03,   1.9564035E-03,   2.0270429E-03
     +,   2.1035201E-03,   2.1862208E-03,   2.2755184E-03
     +,   2.3717552E-03,   2.4752514E-03,   2.5862907E-03
     +,   2.7050998E-03,   2.8318707E-03,   2.9667204E-03
     +,   3.1097161E-03,   3.2608437E-03,   3.4200351E-03
     +,   3.5871300E-03,   3.7619225E-03,   3.9441194E-03
     +,   4.1333931E-03,   4.3293745E-03,   4.5316615E-03
     +,   4.7398498E-03,   4.9535763E-03,   5.1725353E-03
     +,   5.3964965E-03,   5.6253923E-03,   5.8592944E-03
     +,   6.0985233E-03,   6.3436190E-03,   6.5954374E-03
     +,   6.8551097E-03,   7.1241260E-03,   7.4042678E-03
     +,   7.6976335E-03,   8.0065876E-03,   8.3336700E-03
     +,   8.6815143E-03,   9.0527674E-03,   9.4499215E-03
     +,   9.8751206E-03,   1.0330094E-02,   1.0815878E-02
     +,   1.1332756E-02,   1.1880037E-02,   1.2456075E-02
     +,   1.3058096E-02,   1.3682359E-02,   1.4324117E-02
     +,   1.4977922E-02,   1.5637828E-02,   1.6297642E-02
     +,   1.6951350E-02,   1.7593576E-02,   1.8219907E-02
     +,   1.8827217E-02,   1.9414116E-02,   1.9980982E-02
     +,   2.0530246E-02,   2.1066176E-02,   2.1594886E-02
     +,   2.2123940E-02,   2.2662085E-02,   2.3218740E-02
     +,   2.3803730E-02,   2.4426771E-02,   2.5097191E-02
     +,   2.5823591E-02,   2.6613727E-02,   2.7474185E-02
     +,   2.8410003E-02,   2.9424436E-02,   3.0518351E-02
     +,   3.1690065E-02,   3.2935068E-02,   3.4247026E-02
     +,   3.5619251E-02,   3.7048236E-02,   3.8537793E-02
     +,   4.0105149E-02,   4.1786738E-02,   4.3643970E-02
     +,   4.5768481E-02,   4.8286676E-02,   5.1364169E-02
     +,   5.5209391E-02,   6.0074870E-02,   6.6249989E-02
     +,   7.4032843E-02,   8.3671920E-02,   9.5284320E-02
     +,   0.1087830    ,   0.1238833    ,   0.1402586    
     +,   0.1578309    ,   0.1770282    ,   0.1987294    
     +,   0.2237030    ,   0.2517501    ,   0.2812453    
     +,   0.3097529    ,   0.3355157    ,   0.3585802    
     +,   0.3805338    ,   0.4033510    ,   0.4287316    
     +,   0.4582127    ,   0.4929198    ,   0.5323201    
     +,   0.5732575    ,   0.6105539    ,   0.6380321    
     +,   0.6485975    ,   0.6354191    ,   0.5964209    
     +,   0.5383006    ,   0.4740086    ,   0.4149647    
     +,   0.3655945    ,   0.3244151    ,   0.2888002    
     +,   0.2583626    ,   0.2347692    ,   0.2194583    
     +,   0.2119368    ,   0.2099368    ,   0.2107143    
     +,   0.2121717    ,   0.2131836    ,   0.2133231    
     +,   0.2124350    ,   0.2103439    ,   0.2067778    
     +,   0.2014513    ,   0.1942076    ,   0.1851226    
     +,   0.1745278    ,   0.1629530    ,   0.1510171    
     +,   0.1393063    ,   0.1282728    ,   0.1181788    
     +,   0.1090951    ,   0.1009455    ,   9.3576059E-02
     +,   8.6821787E-02,   8.0548123E-02,   7.4666001E-02
     +,   6.9126122E-02,   6.3903742E-02,   5.8982115E-02
     +,   5.4343332E-02,   4.9965013E-02,   4.5821048E-02
     +,   4.1884273E-02,   3.8130362E-02,   3.4540739E-02
     +,   3.1104328E-02,   2.7817944E-02,   2.4686253E-02
     +,   2.1720491E-02,   1.8936045E-02,   1.6349606E-02
     +,   1.3976711E-02,   1.1829454E-02,   9.9143684E-03
     +,   8.2316697E-03,   6.7752772E-03,   5.5332594E-03
     +,   4.4889348E-03,   3.6224006E-03,   2.9120818E-03
     +,   2.3360273E-03,   1.8730290E-03,   1.5035117E-03
     +,   1.2100665E-03,   9.7766111E-04,   7.9365453E-04
     +,   6.4768258E-04,   5.3142814E-04,   4.3830651E-04
     +,   3.6318984E-04,   3.0212969E-04,   2.5210393E-04
     +,   2.1080561E-04,   1.7647746E-04,   1.4777808E-04
     +,   1.2367457E-04,   1.0336284E-04,   8.6210435E-05
     +,   7.1713985E-05,   5.9465543E-05,   4.9128910E-05
     +,   4.0423856E-05,   3.3114542E-05,   2.6998749E-05
     +,   2.1902579E-05,   1.7675773E-05,   1.4187745E-05
     +,   1.1324697E-05,   8.9878595E-06,   7.0917995E-06
     +,   5.5627515E-06,   4.3373002E-06,   3.3613574E-06
     +,   2.5891486E-06,   1.9821289E-06,   1.5080702E-06
     +,   1.1402775E-06,   8.5683604E-07,   6.3984123E-07
     +,   4.7481456E-07,   3.5014912E-07,   2.5660216E-07
     +,   1.8686998E-07,   1.3523318E-07,   9.7251309E-08
     +,   6.9499087E-08,   4.9354753E-08,   3.4828950E-08
     +,   2.4424278E-08,   1.7020124E-08,   1.1786224E-08
     +,   8.1104838E-09,   5.5461182E-09,   3.7687014E-09
     +,   2.5448734E-09,   1.7076622E-09,   1.1387049E-09
     +,   7.5454121E-10,   4.9685728E-10,   3.2512681E-10
     +,   2.1141847E-10,   1.3662127E-10,   8.7734757E-11
     +,   5.5991631E-11,   3.5511382E-11,   2.2383781E-11
     +,   1.4022434E-11,   8.7312458E-12,   5.4039512E-12
     +,   3.3249850E-12,   2.0340663E-12,   1.2374885E-12
     +,   7.4891699E-13,   4.5106418E-13
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_ashz_ttz90_mass = Yx/4.33172372093023
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_ashz_ttz95_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.4345838E-04,   3.5846842E-04
     +,   3.7400745E-04,   3.9008333E-04,   4.0670327E-04
     +,   4.2387325E-04,   4.4159871E-04,   4.5988362E-04
     +,   4.7873089E-04,   4.9814302E-04,   5.1812048E-04
     +,   5.3866237E-04,   5.5976678E-04,   5.8143021E-04
     +,   6.0364784E-04,   6.2641286E-04,   6.4971735E-04
     +,   6.7355158E-04,   6.9790409E-04,   7.2276162E-04
     +,   7.4810948E-04,   7.7393104E-04,   8.0020796E-04
     +,   8.2692120E-04,   8.5404731E-04,   8.8156463E-04
     +,   9.0944755E-04,   9.3766971E-04,   9.6620305E-04
     +,   9.9501805E-04,   1.0240844E-03,   1.0533697E-03
     +,   1.0828417E-03,   1.1124661E-03,   1.1422081E-03
     +,   1.1720330E-03,   1.2019048E-03,   1.2317876E-03
     +,   1.2616473E-03,   1.2914467E-03,   1.3211527E-03
     +,   1.3507310E-03,   1.3801495E-03,   1.4093777E-03
     +,   1.4383870E-03,   1.4671515E-03,   1.4956485E-03
     +,   1.5238585E-03,   1.5517669E-03,   1.5793623E-03
     +,   1.6066404E-03,   1.6336025E-03,   1.6602557E-03
     +,   1.6866181E-03,   1.7127116E-03,   1.7385727E-03
     +,   1.7642461E-03,   1.7897884E-03,   1.8152699E-03
     +,   1.8407748E-03,   1.8664027E-03,   1.8922705E-03
     +,   1.9185113E-03,   1.9452792E-03,   1.9727491E-03
     +,   2.0011130E-03,   2.0305896E-03,   2.0614155E-03
     +,   2.0938532E-03,   2.1281850E-03,   2.1647175E-03
     +,   2.2037725E-03,   2.2456965E-03,   2.2908454E-03
     +,   2.3395938E-03,   2.3923235E-03,   2.4494173E-03
     +,   2.5112566E-03,   2.5782203E-03,   2.6506714E-03
     +,   2.7289470E-03,   2.8133641E-03,   2.9041958E-03
     +,   3.0016811E-03,   3.1060011E-03,   3.2172936E-03
     +,   3.3356275E-03,   3.4610247E-03,   3.5934332E-03
     +,   3.7327555E-03,   3.8788444E-03,   4.0315008E-03
     +,   4.1904938E-03,   4.3555885E-03,   4.5265509E-03
     +,   4.7031515E-03,   4.8852297E-03,   5.0726617E-03
     +,   5.2654399E-03,   5.4636388E-03,   5.6674825E-03
     +,   5.8773072E-03,   6.0936189E-03,   6.3170395E-03
     +,   6.5483488E-03,   6.7884340E-03,   7.0382655E-03
     +,   7.2988463E-03,   7.5712013E-03,   7.8563113E-03
     +,   8.1550060E-03,   8.4679862E-03,   8.7956861E-03
     +,   9.1383057E-03,   9.4956858E-03,   9.8673841E-03
     +,   1.0252568E-02,   1.0650156E-02,   1.1058746E-02
     +,   1.1476792E-02,   1.1902662E-02,   1.2334717E-02
     +,   1.2771491E-02,   1.3211818E-02,   1.3654956E-02
     +,   1.4100635E-02,   1.4549266E-02,   1.5001833E-02
     +,   1.5460057E-02,   1.5926203E-02,   1.6403150E-02
     +,   1.6894111E-02,   1.7402623E-02,   1.7932234E-02
     +,   1.8486395E-02,   1.9068317E-02,   1.9680731E-02
     +,   2.0325935E-02,   2.1005908E-02,   2.1722486E-02
     +,   2.2477839E-02,   2.3275120E-02,   2.4119539E-02
     +,   2.5019299E-02,   2.5986787E-02,   2.7039705E-02
     +,   2.8201886E-02,   2.9503381E-02,   3.0980030E-02
     +,   3.2672226E-02,   3.4622476E-02,   3.6872096E-02
     +,   3.9457366E-02,   4.2405158E-02,   4.5727991E-02
     +,   4.9418513E-02,   5.3444475E-02,   5.7744112E-02
     +,   6.2222011E-02,   6.6747129E-02,   7.1156248E-02
     +,   7.5262018E-02,   7.8868091E-02,   8.1791930E-02
     +,   8.3892182E-02,   8.5094750E-02,   8.5413165E-02
     +,   8.4955722E-02,   8.3915323E-02,   8.2541198E-02
     +,   8.1099272E-02,   7.9828538E-02,   7.8906968E-02
     +,   7.8438826E-02,   7.8477927E-02,   7.9098500E-02
     +,   8.0517292E-02,   8.3239928E-02,   8.8157631E-02
     +,   9.6493170E-02,   0.1095493    ,   0.1283691    
     +,   0.1535702    ,   0.1855059    ,   0.2245264    
     +,   0.2708176    ,   0.3236306    ,   0.3805409    
     +,   0.4377458    ,   0.4914144    ,   0.5385911    
     +,   0.5763903    ,   0.6009853    ,   0.6096580    
     +,   0.6056005    ,   0.5990394    ,   0.5998576    
     +,   0.6078536    ,   0.6116536    ,   0.5976528    
     +,   0.5600348    ,   0.5039900    ,   0.4414259    
     +,   0.3835820    ,   0.3359274    ,   0.2979423    
     +,   0.2662573    ,   0.2377591    ,   0.2107791    
     +,   0.1847746    ,   0.1597385    ,   0.1359304    
     +,   0.1137935    ,   9.3828872E-02,   7.6424919E-02
     +,   6.1745133E-02,   4.9717497E-02,   4.0091645E-02
     +,   3.2514907E-02,   2.6598580E-02,   2.1968046E-02
     +,   1.8298654E-02,   1.5333396E-02,   1.2884262E-02
     +,   1.0822710E-02,   9.0652695E-03,   7.5588054E-03
     +,   6.2681562E-03,   5.1675485E-03,   4.2355517E-03
     +,   3.4525425E-03,   2.7997354E-03,   2.2591706E-03
     +,   1.8141337E-03,   1.4495532E-03,   1.1521347E-03
     +,   9.1046118E-04,   7.1489910E-04,   5.5738608E-04
     +,   4.3119982E-04,   3.3074882E-04,   2.5137656E-04
     +,   1.8918724E-04,   1.4091401E-04,   1.0382348E-04
     +,   7.5637661E-05,   5.4466884E-05,   3.8756651E-05
     +,   2.7243870E-05,   1.8915809E-05,   1.2970055E-05
     +,   8.7813314E-06,   5.8700894E-06,   3.8740918E-06
     +,   2.5241043E-06,   1.6234329E-06,   1.0307322E-06
     +,   6.4601306E-07,   3.9967864E-07,   2.4408772E-07
     +,   1.4714780E-07,   8.7567578E-08,   5.1441205E-08
     +,   2.9830026E-08,   1.7076268E-08,   9.6500656E-09
     +,   5.3835612E-09,   2.9651002E-09,   1.6124200E-09
     +,   8.6582053E-10,   4.5915777E-10,   2.4056254E-10
     +,   1.2458723E-10,   6.3840710E-11,   3.2418790E-11
     +,   1.6360871E-11,   8.2449360E-12,   4.1823055E-12
     +,   2.1623155E-12,   1.1600624E-12,   6.5972688E-13
     +,   4.0517465E-13,   2.7065622E-13,   1.9511354E-13
     +,   1.4910622E-13,   1.1848972E-13,   9.6422043E-14
     +,   7.9527490E-14,   6.6071762E-14,   5.5098121E-14
     +,   4.6031060E-14,   3.8486304E-14,   3.2186578E-14
     +,   2.6917088E-14,   2.2506343E-14,   1.8813344E-14
     +,   1.5721491E-14,   1.3133213E-14,   1.0967086E-14
     +,   9.1546592E-15,   7.6387583E-15
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_ashz_ttz95_mass = Yx/3.750349
      RETURN
      END
C 
C---- New file --- 
C 
      DOUBLE PRECISION FUNCTION A192_tt_haonly_hatt100_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.0865978E-03,   1.1454938E-03
     +,   1.2098205E-03,   1.2799222E-03,   1.3561413E-03
     +,   1.4388179E-03,   1.5282826E-03,   1.6248537E-03
     +,   1.7288284E-03,   1.8404857E-03,   1.9600680E-03
     +,   2.0877828E-03,   2.2237932E-03,   2.3682129E-03
     +,   2.5210963E-03,   2.6824339E-03,   2.8521453E-03
     +,   3.0300738E-03,   3.2159770E-03,   3.4095307E-03
     +,   3.6103146E-03,   3.8178223E-03,   4.0314463E-03
     +,   4.2505027E-03,   4.4741957E-03,   4.7016675E-03
     +,   4.9319770E-03,   5.1641148E-03,   5.3970148E-03
     +,   5.6295781E-03,   5.8606742E-03,   6.0891691E-03
     +,   6.3139452E-03,   6.5339142E-03,   6.7480435E-03
     +,   6.9553787E-03,   7.1550673E-03,   7.3463758E-03
     +,   7.5287120E-03,   7.7016260E-03,   7.8648599E-03
     +,   8.0183186E-03,   8.1621082E-03,   8.2965167E-03
     +,   8.4220218E-03,   8.5392892E-03,   8.6491415E-03
     +,   8.7525668E-03,   8.8506741E-03,   8.9446809E-03
     +,   9.0358714E-03,   9.1255838E-03,   9.2151472E-03
     +,   9.3058748E-03,   9.3989996E-03,   9.4956588E-03
     +,   9.5968395E-03,   9.7033698E-03,   9.8158596E-03
     +,   9.9347094E-03,   1.0060058E-02,   1.0191786E-02
     +,   1.0329501E-02,   1.0472543E-02,   1.0619991E-02
     +,   1.0770658E-02,   1.0923132E-02,   1.1075788E-02
     +,   1.1226844E-02,   1.1374367E-02,   1.1516364E-02
     +,   1.1650798E-02,   1.1775676E-02,   1.1889085E-02
     +,   1.1989285E-02,   1.2074741E-02,   1.2144228E-02
     +,   1.2196856E-02,   1.2232151E-02,   1.2250109E-02
     +,   1.2251215E-02,   1.2236509E-02,   1.2207579E-02
     +,   1.2166564E-02,   1.2116163E-02,   1.2059567E-02
     +,   1.2000442E-02,   1.1942825E-02,   1.1891043E-02
     +,   1.1849604E-02,   1.1823058E-02,   1.1815866E-02
     +,   1.1832255E-02,   1.1876040E-02,   1.1950514E-02
     +,   1.2058283E-02,   1.2201172E-02,   1.2380107E-02
     +,   1.2595095E-02,   1.2845151E-02,   1.3128385E-02
     +,   1.3441976E-02,   1.3782393E-02,   1.4145406E-02
     +,   1.4526383E-02,   1.4920423E-02,   1.5322595E-02
     +,   1.5728125E-02,   1.6132686E-02,   1.6532572E-02
     +,   1.6924806E-02,   1.7307404E-02,   1.7679347E-02
     +,   1.8040752E-02,   1.8392818E-02,   1.8737853E-02
     +,   1.9079108E-02,   1.9420812E-02,   1.9767895E-02
     +,   2.0125899E-02,   2.0500761E-02,   2.0898519E-02
     +,   2.1325110E-02,   2.1786068E-02,   2.2286247E-02
     +,   2.2829395E-02,   2.3417994E-02,   2.4052804E-02
     +,   2.4732769E-02,   2.5454681E-02,   2.6213249E-02
     +,   2.7001020E-02,   2.7808636E-02,   2.8625099E-02
     +,   2.9438296E-02,   3.0235549E-02,   3.1004226E-02
     +,   3.1732392E-02,   3.2409593E-02,   3.3027217E-02
     +,   3.3578895E-02,   3.4060717E-02,   3.4471247E-02
     +,   3.4811214E-02,   3.5083197E-02,   3.5291184E-02
     +,   3.5439979E-02,   3.5534762E-02,   3.5580646E-02
     +,   3.5582494E-02,   3.5544649E-02,   3.5470981E-02
     +,   3.5364952E-02,   3.5229720E-02,   3.5068087E-02
     +,   3.4882680E-02,   3.4675736E-02,   3.4448978E-02
     +,   3.4203295E-02,   3.3938590E-02,   3.3653475E-02
     +,   3.3345096E-02,   3.3009317E-02,   3.2640863E-02
     +,   3.2233749E-02,   3.1781837E-02,   3.1279542E-02
     +,   3.0722542E-02,   3.0108269E-02,   2.9436477E-02
     +,   2.8709518E-02,   2.7932305E-02,   2.7112020E-02
     +,   2.6257720E-02,   2.5379740E-02,   2.4488851E-02
     +,   2.3595553E-02,   2.2709444E-02,   2.1838620E-02
     +,   2.0989159E-02,   2.0165024E-02,   1.9368047E-02
     +,   1.8598072E-02,   1.7853187E-02,   1.7130209E-02
     +,   1.6425176E-02,   1.5733736E-02,   1.5051628E-02
     +,   1.4374986E-02,   1.3700811E-02,   1.3026941E-02
     +,   1.2352257E-02,   1.1676738E-02,   1.1001326E-02
     +,   1.0327784E-02,   9.6585788E-03,   8.9967009E-03
     +,   8.3454819E-03,   7.7083292E-03,   7.0886258E-03
     +,   6.4896145E-03,   5.9142509E-03,   5.3650695E-03
     +,   4.8441733E-03,   4.3532532E-03,   3.8934606E-03
     +,   3.4654837E-03,   3.0695910E-03,   2.7056255E-03
     +,   2.3730353E-03,   2.0709417E-03,   1.7982094E-03
     +,   1.5534696E-03,   1.3351578E-03,   1.1415812E-03
     +,   9.7097206E-04,   8.2151359E-04,   6.9136702E-04
     +,   5.7871774E-04,   4.8181001E-04,   3.9894765E-04
     +,   3.2852439E-04,   2.6904090E-04,   2.1910710E-04
     +,   1.7744594E-04,   1.4289991E-04,   1.1443162E-04
     +,   9.1117494E-05,   7.2141855E-05,   5.6792534E-05
     +,   4.4453940E-05,   3.4597284E-05,   2.6771826E-05
     +,   2.0597316E-05,   1.5755924E-05,   1.1983159E-05
     +,   9.0612248E-06,   6.8122918E-06,   5.0920585E-06
     +,   3.7842781E-06,   2.7961346E-06,   2.0541042E-06
     +,   1.5003124E-06,   1.0895127E-06,   7.8663095E-07
     +,   5.6468082E-07,   4.0302771E-07,   2.8599854E-07
     +,   2.0178346E-07,   1.4155083E-07,   9.8728023E-08
     +,   6.8464601E-08,   4.7205781E-08,   3.2361992E-08
     +,   2.2058810E-08,   1.4949627E-08,   1.0073649E-08
     +,   6.7492798E-09,   4.4961124E-09,   2.9779685E-09
     +,   1.9611541E-09,   1.2841560E-09,   8.3604962E-10
     +,   5.4118676E-10,   3.4831635E-10,   2.2289735E-10
     +,   1.4181827E-10,   8.9714111E-11,   5.6427942E-11
     +,   3.5287748E-11,   2.1940236E-11,   1.3562815E-11
     +,   8.3359222E-12,   5.0938151E-12,   3.0946333E-12
     +,   1.8692335E-12,   1.1225110E-12,   6.7019524E-13
     +,   3.9781619E-13,   2.3477387E-13,   1.3775031E-13
     +,   8.0358707E-14,   4.6608886E-14,   2.6880489E-14
     +,   1.5415420E-14,   8.7921529E-15,   4.9880237E-15
     +,   2.8156262E-15,   1.5821338E-15,   8.8554584E-16
     +,   4.9424134E-16,   2.7547486E-16,   1.5369175E-16
     +,   8.6115788E-17,   4.8690465E-17,   2.7956332E-17
     +,   1.6430379E-17,   9.9713571E-18,   6.3001086E-18
     +,   4.1663665E-18,   2.8867503E-18
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_haonly_hatt100_mass = Yx/0.770658
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_haonly_hatt105_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.1568144E-03,   1.2078454E-03
     +,   1.2620197E-03,   1.3195652E-03,   1.3807080E-03
     +,   1.4456682E-03,   1.5146560E-03,   1.5878663E-03
     +,   1.6654748E-03,   1.7476353E-03,   1.8344683E-03
     +,   1.9260615E-03,   2.0224610E-03,   2.1236681E-03
     +,   2.2296333E-03,   2.3402511E-03,   2.4553570E-03
     +,   2.5747214E-03,   2.6980506E-03,   2.8249819E-03
     +,   2.9550814E-03,   3.0878475E-03,   3.2227102E-03
     +,   3.3590381E-03,   3.4961288E-03,   3.6332365E-03
     +,   3.7695612E-03,   3.9042635E-03,   4.0364778E-03
     +,   4.1653183E-03,   4.2898995E-03,   4.4093435E-03
     +,   4.5228004E-03,   4.6294639E-03,   4.7285878E-03
     +,   4.8195049E-03,   4.9016429E-03,   4.9745440E-03
     +,   5.0378884E-03,   5.0914949E-03,   5.1353564E-03
     +,   5.1696426E-03,   5.1947092E-03,   5.2111219E-03
     +,   5.2196491E-03,   5.2212793E-03,   5.2172127E-03
     +,   5.2088667E-03,   5.1978631E-03,   5.1860227E-03
     +,   5.1753484E-03,   5.1680054E-03,   5.1662978E-03
     +,   5.1726359E-03,   5.1895073E-03,   5.2194307E-03
     +,   5.2649151E-03,   5.3284131E-03,   5.4122647E-03
     +,   5.5186469E-03,   5.6495140E-03,   5.8065462E-03
     +,   5.9910771E-03,   6.2040673E-03,   6.4460426E-03
     +,   6.7170314E-03,   7.0165815E-03,   7.3436731E-03
     +,   7.6967869E-03,   8.0738189E-03,   8.4721949E-03
     +,   8.8888044E-03,   9.3201660E-03,   9.7623682E-03
     +,   1.0211268E-02,   1.0662523E-02,   1.1111674E-02
     +,   1.1554279E-02,   1.1986052E-02,   1.2402940E-02
     +,   1.2801180E-02,   1.3177499E-02,   1.3529078E-02
     +,   1.3853715E-02,   1.4149779E-02,   1.4416333E-02
     +,   1.4653043E-02,   1.4860242E-02,   1.5038828E-02
     +,   1.5190276E-02,   1.5316530E-02,   1.5419917E-02
     +,   1.5503081E-02,   1.5568890E-02,   1.5620311E-02
     +,   1.5660334E-02,   1.5691880E-02,   1.5717695E-02
     +,   1.5740314E-02,   1.5761953E-02,   1.5784496E-02
     +,   1.5809439E-02,   1.5837882E-02,   1.5870502E-02
     +,   1.5907582E-02,   1.5949016E-02,   1.5994292E-02
     +,   1.6042566E-02,   1.6092656E-02,   1.6143100E-02
     +,   1.6192131E-02,   1.6237758E-02,   1.6277760E-02
     +,   1.6309768E-02,   1.6331248E-02,   1.6339624E-02
     +,   1.6332299E-02,   1.6306801E-02,   1.6260898E-02
     +,   1.6192719E-02,   1.6100954E-02,   1.5985033E-02
     +,   1.5845343E-02,   1.5683366E-02,   1.5501933E-02
     +,   1.5305318E-02,   1.5099351E-02,   1.4891441E-02
     +,   1.4690495E-02,   1.4506838E-02,   1.4351868E-02
     +,   1.4237789E-02,   1.4177103E-02,   1.4182149E-02
     +,   1.4264469E-02,   1.4434265E-02,   1.4699733E-02
     +,   1.5066542E-02,   1.5537340E-02,   1.6111402E-02
     +,   1.6784290E-02,   1.7547864E-02,   1.8390374E-02
     +,   1.9296719E-02,   2.0248793E-02,   2.1226298E-02
     +,   2.2207374E-02,   2.3169415E-02,   2.4090026E-02
     +,   2.4948027E-02,   2.5724312E-02,   2.6402541E-02
     +,   2.6969934E-02,   2.7417770E-02,   2.7741611E-02
     +,   2.7941352E-02,   2.8021082E-02,   2.7988626E-02
     +,   2.7855003E-02,   2.7633613E-02,   2.7339377E-02
     +,   2.6987823E-02,   2.6594216E-02,   2.6172729E-02
     +,   2.5735717E-02,   2.5293188E-02,   2.4852535E-02
     +,   2.4418337E-02,   2.3992412E-02,   2.3574080E-02
     +,   2.3160560E-02,   2.2747440E-02,   2.2329165E-02
     +,   2.1899657E-02,   2.1452852E-02,   2.0983111E-02
     +,   2.0485619E-02,   1.9956710E-02,   1.9394016E-02
     +,   1.8796513E-02,   1.8164469E-02,   1.7499467E-02
     +,   1.6804183E-02,   1.6082134E-02,   1.5337550E-02
     +,   1.4575201E-02,   1.3800171E-02,   1.3017633E-02
     +,   1.2232760E-02,   1.1450697E-02,   1.0676295E-02
     +,   9.9141393E-03,   9.1685401E-03,   8.4434422E-03
     +,   7.7423435E-03,   7.0683341E-03,   6.4241141E-03
     +,   5.8119339E-03,   5.2335500E-03,   4.6902634E-03
     +,   4.1829674E-03,   3.7121011E-03,   3.2776545E-03
     +,   2.8792231E-03,   2.5160764E-03,   2.1871170E-03
     +,   1.8909670E-03,   1.6260322E-03,   1.3905235E-03
     +,   1.1824945E-03,   9.9990715E-04,   8.4068615E-04
     +,   7.0274371E-04,   5.8400969E-04,   4.8247527E-04
     +,   3.9622330E-04,   3.2344044E-04,   2.6242970E-04
     +,   2.1162725E-04,   1.6961173E-04,   1.3509631E-04
     +,   1.0693342E-04,   8.4110747E-05,   6.5742366E-05
     +,   5.1059546E-05,   3.9402927E-05,   3.0212790E-05
     +,   2.3017374E-05,   1.7422435E-05,   1.3101940E-05
     +,   9.7888214E-06,   7.2658963E-06,   5.3579647E-06
     +,   3.9250972E-06,   2.8565578E-06,   2.0652226E-06
     +,   1.4832400E-06,   1.0582199E-06,   7.4999804E-07
     +,   5.2802500E-07,   3.6927420E-07,   2.5653381E-07
     +,   1.7702821E-07,   1.2134825E-07,   8.2624460E-08
     +,   5.5881653E-08,   3.7541984E-08,   2.5052087E-08
     +,   1.6605025E-08,   1.0932343E-08,   7.1491595E-09
     +,   4.6436108E-09,   2.9958378E-09,   1.9197552E-09
     +,   1.2218802E-09,   7.7242751E-10,   4.8499321E-10
     +,   3.0245900E-10,   1.8734424E-10,   1.1525193E-10
     +,   7.0419469E-11,   4.2734604E-11,   2.5757174E-11
     +,   1.5418351E-11,   9.1666700E-12,   5.4126404E-12
     +,   3.1740988E-12,   1.8486311E-12,   1.0693136E-12
     +,   6.1428965E-13,   3.5046589E-13,   1.9857679E-13
     +,   1.1174465E-13,   6.2449815E-14,   3.4660253E-14
     +,   1.9104791E-14,   1.0457930E-14,   5.6853300E-15
     +,   3.0694109E-15,   1.6457301E-15,   8.7629153E-16
     +,   4.6338393E-16,   2.4334142E-16,   1.2690864E-16
     +,   6.5727553E-17,   3.3806600E-17,   1.7268098E-17
     +,   8.7591892E-18,   4.4124581E-18,   2.2073513E-18
     +,   1.0966267E-18,   5.4102632E-19,   2.6507727E-19
     +,   1.2897363E-19,   6.2318992E-20,   2.9902841E-20
     +,   1.4249353E-20,   6.7429473E-21,   3.1688146E-21
     +,   1.4788093E-21,   6.8536074E-22
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_haonly_hatt105_mass = Yx/0.593420172413793
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_haonly_hatt107_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.2500049E-03,   4.3040570E-03
     +,   4.3587638E-03,   4.4141929E-03,   4.4704056E-03
     +,   4.5274505E-03,   4.5853704E-03,   4.6441951E-03
     +,   4.7039445E-03,   4.7646286E-03,   4.8262523E-03
     +,   4.8888032E-03,   4.9522682E-03,   5.0166254E-03
     +,   5.0818385E-03,   5.1478781E-03,   5.2147051E-03
     +,   5.2822758E-03,   5.3505478E-03,   5.4194792E-03
     +,   5.4890322E-03,   5.5591669E-03,   5.6298482E-03
     +,   5.7010548E-03,   5.7727592E-03,   5.8449497E-03
     +,   5.9176176E-03,   5.9907599E-03,   6.0643856E-03
     +,   6.1384989E-03,   6.2131141E-03,   6.2882439E-03
     +,   6.3639036E-03,   6.4400989E-03,   6.5168324E-03
     +,   6.5940926E-03,   6.6718580E-03,   6.7500877E-03
     +,   6.8287207E-03,   6.9076642E-03,   6.9868094E-03
     +,   7.0660049E-03,   7.1450779E-03,   7.2238222E-03
     +,   7.3019960E-03,   7.3793260E-03,   7.4555185E-03
     +,   7.5302529E-03,   7.6031922E-03,   7.6739877E-03
     +,   7.7422913E-03,   7.8077642E-03,   7.8700818E-03
     +,   7.9289535E-03,   7.9841223E-03,   8.0353925E-03
     +,   8.0826283E-03,   8.1257662E-03,   8.1648333E-03
     +,   8.1999395E-03,   8.2312990E-03,   8.2592200E-03
     +,   8.2841190E-03,   8.3065080E-03,   8.3269943E-03
     +,   8.3462652E-03,   8.3650863E-03,   8.3842846E-03
     +,   8.4047215E-03,   8.4272856E-03,   8.4528644E-03
     +,   8.4823212E-03,   8.5164774E-03,   8.5560773E-03
     +,   8.6017847E-03,   8.6541409E-03,   8.7135583E-03
     +,   8.7802978E-03,   8.8544600E-03,   8.9359805E-03
     +,   9.0246126E-03,   9.1199381E-03,   9.2213666E-03
     +,   9.3281483E-03,   9.4393855E-03,   9.5540602E-03
     +,   9.6710352E-03,   9.7891083E-03,   9.9070156E-03
     +,   1.0023476E-02,   1.0137230E-02,   1.0247045E-02
     +,   1.0351772E-02,   1.0450370E-02,   1.0541935E-02
     +,   1.0625714E-02,   1.0701142E-02,   1.0767835E-02
     +,   1.0825639E-02,   1.0874589E-02,   1.0914952E-02
     +,   1.0947186E-02,   1.0971952E-02,   1.0990085E-02
     +,   1.1002569E-02,   1.1010528E-02,   1.1015190E-02
     +,   1.1017845E-02,   1.1019828E-02,   1.1022492E-02
     +,   1.1027169E-02,   1.1035150E-02,   1.1047669E-02
     +,   1.1065884E-02,   1.1090855E-02,   1.1123549E-02
     +,   1.1164837E-02,   1.1215483E-02,   1.1276158E-02
     +,   1.1347469E-02,   1.1429918E-02,   1.1523965E-02
     +,   1.1629995E-02,   1.1748369E-02,   1.1879403E-02
     +,   1.2023370E-02,   1.2180535E-02,   1.2351111E-02
     +,   1.2535316E-02,   1.2733307E-02,   1.2945216E-02
     +,   1.3171121E-02,   1.3411069E-02,   1.3665001E-02
     +,   1.3932807E-02,   1.4214287E-02,   1.4509114E-02
     +,   1.4816825E-02,   1.5136820E-02,   1.5468335E-02
     +,   1.5810374E-02,   1.6161725E-02,   1.6520943E-02
     +,   1.6886296E-02,   1.7255738E-02,   1.7626939E-02
     +,   1.7997250E-02,   1.8363684E-02,   1.8722951E-02
     +,   1.9071504E-02,   1.9405557E-02,   1.9721119E-02
     +,   2.0014085E-02,   2.0280294E-02,   2.0515677E-02
     +,   2.0716231E-02,   2.0878218E-02,   2.0998225E-02
     +,   2.1073243E-02,   2.1100756E-02,   2.1078836E-02
     +,   2.1006139E-02,   2.0882022E-02,   2.0706508E-02
     +,   2.0480301E-02,   2.0204758E-02,   1.9881889E-02
     +,   1.9514300E-02,   1.9105056E-02,   1.8657699E-02
     +,   1.8176105E-02,   1.7664434E-02,   1.7126989E-02
     +,   1.6568139E-02,   1.5992295E-02,   1.5403724E-02
     +,   1.4806533E-02,   1.4204641E-02,   1.3601695E-02
     +,   1.3000985E-02,   1.2405462E-02,   1.1817759E-02
     +,   1.1240141E-02,   1.0674494E-02,   1.0122350E-02
     +,   9.5849587E-03,   9.0632821E-03,   8.5579762E-03
     +,   8.0694733E-03,   7.5980634E-03,   7.1438262E-03
     +,   6.7067225E-03,   6.2866448E-03,   5.8834101E-03
     +,   5.4967813E-03,   5.1264823E-03,   4.7722626E-03
     +,   4.4338675E-03,   4.1110301E-03,   3.8034969E-03
     +,   3.5110444E-03,   3.2334588E-03,   2.9705116E-03
     +,   2.7219749E-03,   2.4876366E-03,   2.2672480E-03
     +,   2.0605414E-03,   1.8672377E-03,   1.6870260E-03
     +,   1.5195515E-03,   1.3644259E-03,   1.2212382E-03
     +,   1.0895412E-03,   9.6884853E-04,   8.5864734E-04
     +,   7.5840898E-04,   6.6758553E-04,   5.8560923E-04
     +,   5.1190634E-04,   4.4590890E-04,   3.8704491E-04
     +,   3.3475246E-04,   2.8848668E-04,   2.4771987E-04
     +,   2.1194282E-04,   1.8067154E-04,   1.5345075E-04
     +,   1.2985316E-04,   1.0947912E-04,   9.1959599E-05
     +,   7.6956712E-05,   6.4161766E-05,   5.3294014E-05
     +,   4.4100645E-05,   3.6355956E-05,   2.9858100E-05
     +,   2.4428484E-05,   1.9910229E-05,   1.6165850E-05
     +,   1.3075413E-05,   1.0535088E-05,   8.4556004E-06
     +,   6.7603905E-06,   5.3840840E-06,   4.2712604E-06
     +,   3.3752158E-06,   2.6567250E-06,   2.0829707E-06
     +,   1.6266778E-06,   1.2653296E-06,   9.8034980E-07
     +,   7.5652758E-07,   5.8147788E-07,   4.4514897E-07
     +,   3.3941632E-07,   2.5775446E-07,   1.9495089E-07
     +,   1.4685519E-07,   1.1017683E-07,   8.2322636E-08
     +,   6.1259946E-08,   4.5400633E-08,   3.3509483E-08
     +,   2.4631216E-08,   1.8031056E-08,   1.3145169E-08
     +,   9.5436041E-09,   6.9001946E-09,   4.9683822E-09
     +,   3.5625864E-09,   2.5439308E-09,   1.8089906E-09
     +,   1.2810362E-09,   9.0338459E-10,   6.3439975E-10
     +,   4.4364989E-10,   3.0895328E-10,   2.1425346E-10
     +,   1.4795649E-10,   1.0174642E-10,   6.9674266E-11
     +,   4.7511824E-11,   3.2262287E-11,   2.1815352E-11
     +,   1.4688938E-11,   9.8489697E-12,   6.5758987E-12
     +,   4.3719711E-12,   2.8944592E-12,   1.9081551E-12
     +,   1.2526404E-12,   8.1882786E-13,   5.3299726E-13
     +,   3.4546801E-13,   2.2297482E-13,   1.4330267E-13
     +,   9.1709829E-14,   5.8442170E-14,   3.7085057E-14
     +,   2.3432574E-14,   1.4743599E-14
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_haonly_hatt107_mass = Yx/0.537568862068965
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_haonly_hatt110_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.6455333E-03,   2.7586026E-03
     +,   2.8741492E-03,   2.9920170E-03,   3.1120358E-03
     +,   3.2340132E-03,   3.3577424E-03,   3.4829977E-03
     +,   3.6095374E-03,   3.7371113E-03,   3.8654481E-03
     +,   3.9942693E-03,   4.1232817E-03,   4.2521898E-03
     +,   4.3806853E-03,   4.5084544E-03,   4.6351827E-03
     +,   4.7605508E-03,   4.8842393E-03,   5.0059310E-03
     +,   5.1253121E-03,   5.2420744E-03,   5.3559183E-03
     +,   5.4665566E-03,   5.5737067E-03,   5.6771119E-03
     +,   5.7765283E-03,   5.8717332E-03,   5.9625260E-03
     +,   6.0487357E-03,   6.1302176E-03,   6.2068580E-03
     +,   6.2785777E-03,   6.3453354E-03,   6.4071179E-03
     +,   6.4639584E-03,   6.5159230E-03,   6.5631173E-03
     +,   6.6056824E-03,   6.6437935E-03,   6.6776644E-03
     +,   6.7075305E-03,   6.7336550E-03,   6.7563271E-03
     +,   6.7758486E-03,   6.7925360E-03,   6.8067084E-03
     +,   6.8186927E-03,   6.8288124E-03,   6.8373787E-03
     +,   6.8446961E-03,   6.8510557E-03,   6.8567349E-03
     +,   6.8619912E-03,   6.8670688E-03,   6.8722023E-03
     +,   6.8776072E-03,   6.8835057E-03,   6.8901042E-03
     +,   6.8976237E-03,   6.9062910E-03,   6.9163493E-03
     +,   6.9280611E-03,   6.9417208E-03,   6.9576469E-03
     +,   6.9761877E-03,   6.9977259E-03,   7.0226677E-03
     +,   7.0514455E-03,   7.0845075E-03,   7.1223052E-03
     +,   7.1652909E-03,   7.2139003E-03,   7.2685378E-03
     +,   7.3295729E-03,   7.3973252E-03,   7.4720480E-03
     +,   7.5539295E-03,   7.6430915E-03,   7.7395886E-03
     +,   7.8433976E-03,   7.9544550E-03,   8.0726361E-03
     +,   8.1977984E-03,   8.3297659E-03,   8.4683839E-03
     +,   8.6134896E-03,   8.7649720E-03,   8.9227306E-03
     +,   9.0867206E-03,   9.2569422E-03,   9.4334036E-03
     +,   9.6161207E-03,   9.8051196E-03,   1.0000384E-02
     +,   1.0201814E-02,   1.0409237E-02,   1.0622324E-02
     +,   1.0840624E-02,   1.1063488E-02,   1.1290122E-02
     +,   1.1519522E-02,   1.1750563E-02,   1.1981966E-02
     +,   1.2212379E-02,   1.2440423E-02,   1.2664733E-02
     +,   1.2884028E-02,   1.3097208E-02,   1.3303396E-02
     +,   1.3501951E-02,   1.3692590E-02,   1.3875329E-02
     +,   1.4050542E-02,   1.4218897E-02,   1.4381366E-02
     +,   1.4539105E-02,   1.4693434E-02,   1.4845697E-02
     +,   1.4997210E-02,   1.5149152E-02,   1.5302463E-02
     +,   1.5457794E-02,   1.5615461E-02,   1.5775423E-02
     +,   1.5937254E-02,   1.6100220E-02,   1.6263288E-02
     +,   1.6425228E-02,   1.6584691E-02,   1.6740292E-02
     +,   1.6890708E-02,   1.7034730E-02,   1.7171342E-02
     +,   1.7299751E-02,   1.7419370E-02,   1.7529832E-02
     +,   1.7630925E-02,   1.7722553E-02,   1.7804639E-02
     +,   1.7877089E-02,   1.7939681E-02,   1.7992074E-02
     +,   1.8033685E-02,   1.8063743E-02,   1.8081252E-02
     +,   1.8085027E-02,   1.8073741E-02,   1.8045964E-02
     +,   1.8000256E-02,   1.7935198E-02,   1.7849484E-02
     +,   1.7741978E-02,   1.7611723E-02,   1.7458027E-02
     +,   1.7280469E-02,   1.7078910E-02,   1.6853465E-02
     +,   1.6604558E-02,   1.6332876E-02,   1.6039366E-02
     +,   1.5725208E-02,   1.5391817E-02,   1.5040851E-02
     +,   1.4674122E-02,   1.4293606E-02,   1.3901458E-02
     +,   1.3499935E-02,   1.3091357E-02,   1.2678051E-02
     +,   1.2262371E-02,   1.1846576E-02,   1.1432793E-02
     +,   1.1022951E-02,   1.0618811E-02,   1.0221821E-02
     +,   9.8331375E-03,   9.4536385E-03,   9.0838745E-03
     +,   8.7240757E-03,   8.3741918E-03,   8.0339434E-03
     +,   7.7028498E-03,   7.3802513E-03,   7.0653912E-03
     +,   6.7574908E-03,   6.4557795E-03,   6.1595263E-03
     +,   5.8680987E-03,   5.5810241E-03,   5.2979579E-03
     +,   5.0187269E-03,   4.7433451E-03,   4.4719949E-03
     +,   4.2049913E-03,   3.9427863E-03,   3.6859524E-03
     +,   3.4351430E-03,   3.1910425E-03,   2.9543559E-03
     +,   2.7257928E-03,   2.5060265E-03,   2.2956566E-03
     +,   2.0952041E-03,   1.9051189E-03,   1.7257259E-03
     +,   1.5572435E-03,   1.3997906E-03,   1.2533742E-03
     +,   1.1178880E-03,   9.9312956E-04,   8.7881798E-04
     +,   7.7459391E-04,   6.8002619E-04,   5.9463264E-04
     +,   5.1789643E-04,   4.4927132E-04,   3.8818861E-04
     +,   3.3407367E-04,   2.8635893E-04,   2.4448143E-04
     +,   2.0789556E-04,   1.7608023E-04,   1.4854039E-04
     +,   1.2480868E-04,   1.0445006E-04,   8.7064021E-05
     +,   7.2283226E-05,   5.9772665E-05,   4.9230151E-05
     +,   4.0385523E-05,   3.2998123E-05,   2.6854612E-05
     +,   2.1767659E-05,   1.7574124E-05,   1.4131938E-05
     +,   1.1318602E-05,   9.0292124E-06,   7.1742470E-06
     +,   5.6776571E-06,   4.4753260E-06,   3.5135552E-06
     +,   2.7475051E-06,   2.1399173E-06,   1.6600393E-06
     +,   1.2826446E-06,   9.8710780E-07,   7.5664053E-07
     +,   5.7766675E-07,   4.3927420E-07,   3.3270595E-07
     +,   2.5098521E-07,   1.8858246E-07,   1.4113178E-07
     +,   1.0519940E-07,   7.8102175E-08,   5.7753308E-08
     +,   4.2536225E-08,   3.1203580E-08,   2.2798577E-08
     +,   1.6590974E-08,   1.2025450E-08,   8.6814067E-09
     +,   6.2421144E-09,   4.4702841E-09,   3.1885534E-09
     +,   2.2651687E-09,   1.6027274E-09,   1.1294687E-09
     +,   7.9275037E-10,   5.5416732E-10,   3.8582407E-10
     +,   2.6753771E-10,   1.8476580E-10,   1.2708382E-10
     +,   8.7056307E-11,   5.9393421E-11,   4.0356427E-11
     +,   2.7309264E-11,   1.8405156E-11,   1.2353390E-11
     +,   8.2577166E-12,   5.4972637E-12,   3.6446388E-12
     +,   2.4064125E-12,   1.5823501E-12,   1.0361981E-12
     +,   6.7574527E-13,   4.3886658E-13,   2.8384220E-13
     +,   1.8282079E-13,   1.1726321E-13,   7.4903076E-14
     +,   4.7645414E-14,   3.0181237E-14,   1.9038489E-14
     +,   1.1959632E-14,   7.4813338E-15,   4.6604261E-15
     +,   2.8909654E-15,   1.7858381E-15
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_haonly_hatt110_mass = Yx/0.4772295
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_haonly_hatt115_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.7318292E-03,   2.9132322E-03
     +,   3.1021959E-03,   3.2984621E-03,   3.5017070E-03
     +,   3.7115351E-03,   3.9274758E-03,   4.1489825E-03
     +,   4.3754224E-03,   4.6060919E-03,   4.8401882E-03
     +,   5.0768270E-03,   5.3150384E-03,   5.5537676E-03
     +,   5.7918797E-03,   6.0281679E-03,   6.2613552E-03
     +,   6.4901118E-03,   6.7130663E-03,   6.9288206E-03
     +,   7.1359677E-03,   7.3331124E-03,   7.5189006E-03
     +,   7.6920423E-03,   7.8513213E-03,   7.9956548E-03
     +,   8.1240954E-03,   8.2358588E-03,   8.3303647E-03
     +,   8.4072426E-03,   8.4663620E-03,   8.5078403E-03
     +,   8.5320529E-03,   8.5396385E-03,   8.5314969E-03
     +,   8.5087707E-03,   8.4728459E-03,   8.4253103E-03
     +,   8.3679277E-03,   8.3026104E-03,   8.2313661E-03
     +,   8.1562586E-03,   8.0793593E-03,   8.0026975E-03
     +,   7.9282066E-03,   7.8576822E-03,   7.7927355E-03
     +,   7.7347537E-03,   7.6848711E-03,   7.6439325E-03
     +,   7.6124957E-03,   7.5908075E-03,   7.5788135E-03
     +,   7.5761708E-03,   7.5822719E-03,   7.5962702E-03
     +,   7.6171281E-03,   7.6436577E-03,   7.6745702E-03
     +,   7.7085453E-03,   7.7442783E-03,   7.7805393E-03
     +,   7.8162318E-03,   7.8504477E-03,   7.8825122E-03
     +,   7.9120221E-03,   7.9388758E-03,   7.9632942E-03
     +,   7.9858275E-03,   8.0073448E-03,   8.0290278E-03
     +,   8.0523286E-03,   8.0789356E-03,   8.1107151E-03
     +,   8.1496621E-03,   8.1978124E-03,   8.2571954E-03
     +,   8.3297398E-03,   8.4172208E-03,   8.5211927E-03
     +,   8.6429184E-03,   8.7833572E-03,   8.9430865E-03
     +,   9.1223381E-03,   9.3209445E-03,   9.5384009E-03
     +,   9.7738411E-03,   1.0026128E-02,   1.0293840E-02
     +,   1.0575378E-02,   1.0869002E-02,   1.1172851E-02
     +,   1.1485010E-02,   1.1803585E-02,   1.2126692E-02
     +,   1.2452438E-02,   1.2779025E-02,   1.3104644E-02
     +,   1.3427536E-02,   1.3745915E-02,   1.4057991E-02
     +,   1.4361897E-02,   1.4655737E-02,   1.4937486E-02
     +,   1.5205070E-02,   1.5456337E-02,   1.5689058E-02
     +,   1.5901003E-02,   1.6089953E-02,   1.6253809E-02
     +,   1.6390564E-02,   1.6498478E-02,   1.6576054E-02
     +,   1.6622169E-02,   1.6636079E-02,   1.6617524E-02
     +,   1.6566683E-02,   1.6484238E-02,   1.6371390E-02
     +,   1.6229765E-02,   1.6061433E-02,   1.5868833E-02
     +,   1.5654709E-02,   1.5422002E-02,   1.5173769E-02
     +,   1.4913145E-02,   1.4643135E-02,   1.4366658E-02
     +,   1.4086369E-02,   1.3804655E-02,   1.3523526E-02
     +,   1.3244670E-02,   1.2969322E-02,   1.2698374E-02
     +,   1.2432319E-02,   1.2171295E-02,   1.1915176E-02
     +,   1.1663568E-02,   1.1415885E-02,   1.1171399E-02
     +,   1.0929345E-02,   1.0688930E-02,   1.0449393E-02
     +,   1.0210052E-02,   9.9703567E-03,   9.7298762E-03
     +,   9.4883339E-03,   9.2456136E-03,   9.0017691E-03
     +,   8.7569710E-03,   8.5115181E-03,   8.2658343E-03
     +,   8.0204196E-03,   7.7758227E-03,   7.5326297E-03
     +,   7.2914478E-03,   7.0528877E-03,   6.8175136E-03
     +,   6.5858602E-03,   6.3584335E-03,   6.1356733E-03
     +,   5.9179571E-03,   5.7056248E-03,   5.4989629E-03
     +,   5.2981917E-03,   5.1034871E-03,   4.9149953E-03
     +,   4.7328249E-03,   4.5570377E-03,   4.3876716E-03
     +,   4.2247470E-03,   4.0682587E-03,   3.9181686E-03
     +,   3.7744194E-03,   3.6369434E-03,   3.5056367E-03
     +,   3.3803715E-03,   3.2610074E-03,   3.1473762E-03
     +,   3.0392788E-03,   2.9364906E-03,   2.8387744E-03
     +,   2.7458677E-03,   2.6574845E-03,   2.5733223E-03
     +,   2.4930718E-03,   2.4164133E-03,   2.3430199E-03
     +,   2.2725619E-03,   2.2047220E-03,   2.1391860E-03
     +,   2.0756503E-03,   2.0138337E-03,   1.9534742E-03
     +,   1.8943285E-03,   1.8361800E-03,   1.7788410E-03
     +,   1.7221542E-03,   1.6659849E-03,   1.6102284E-03
     +,   1.5548115E-03,   1.4996872E-03,   1.4448309E-03
     +,   1.3902403E-03,   1.3359407E-03,   1.2819701E-03
     +,   1.2283825E-03,   1.1752490E-03,   1.1226516E-03
     +,   1.0706763E-03,   1.0194150E-03,   9.6896576E-04
     +,   9.1942790E-04,   8.7089563E-04,   8.2345994E-04
     +,   7.7721145E-04,   7.3223334E-04,   6.8859907E-04
     +,   6.4637425E-04,   6.0561951E-04,   5.6638237E-04
     +,   5.2870082E-04,   4.9260608E-04,   4.5811935E-04
     +,   4.2525030E-04,   3.9399992E-04,   3.6436287E-04
     +,   3.3632547E-04,   3.0986482E-04,   2.8495153E-04
     +,   2.6155185E-04,   2.3962645E-04,   2.1912983E-04
     +,   2.0001274E-04,   1.8222457E-04,   1.6571008E-04
     +,   1.5041231E-04,   1.3627384E-04,   1.2323637E-04
     +,   1.1124023E-04,   1.0022618E-04,   9.0136120E-05
     +,   8.0912840E-05,   7.2499679E-05,   6.4841646E-05
     +,   5.7885962E-05,   5.1581763E-05,   4.5879824E-05
     +,   4.0733205E-05,   3.6097779E-05,   3.1931275E-05
     +,   2.8193839E-05,   2.4848277E-05,   2.1859729E-05
     +,   1.9195419E-05,   1.6824924E-05,   1.4720181E-05
     +,   1.2855226E-05,   1.1206000E-05,   9.7504289E-06
     +,   8.4683961E-06,   7.3414949E-06,   6.3528905E-06
     +,   5.4873140E-06,   4.7310027E-06,   4.0714554E-06
     +,   3.4974078E-06,   2.9987830E-06,   2.5665377E-06
     +,   2.1925605E-06,   1.8696242E-06,   1.5913196E-06
     +,   1.3519580E-06,   1.1464845E-06,   9.7044335E-07
     +,   8.1992397E-07,   6.9146927E-07,   5.8206649E-07
     +,   4.8906548E-07,   4.1016744E-07,   3.4335972E-07
     +,   2.8690400E-07,   2.3928578E-07,   1.9920262E-07
     +,   1.6552582E-07,   1.3728834E-07,   1.1365692E-07
     +,   9.3918082E-08,   7.7463781E-08,   6.3773278E-08
     +,   5.2405156E-08,   4.2983256E-08,   3.5190023E-08
     +,   2.8755986E-08,   2.3454813E-08,   1.9095177E-08
     +,   1.5517060E-08,   1.2585861E-08,   1.0189424E-08
     +,   8.2338643E-09,   6.6412613E-09
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_haonly_hatt115_mass = Yx/0.412420555555556
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_haonly_hatt120_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.2730730E-03,   1.3703817E-03
     +,   1.4759878E-03,   1.5901222E-03,   1.7129368E-03
     +,   1.8444919E-03,   1.9847436E-03,   2.1335313E-03
     +,   2.2905632E-03,   2.4554175E-03,   2.6275201E-03
     +,   2.8061473E-03,   2.9904221E-03,   3.1793173E-03
     +,   3.3716571E-03,   3.5661310E-03,   3.7613045E-03
     +,   3.9556422E-03,   4.1475273E-03,   4.3352963E-03
     +,   4.5172647E-03,   4.6917712E-03,   4.8572109E-03
     +,   5.0120899E-03,   5.1550437E-03,   5.2849110E-03
     +,   5.4007503E-03,   5.5018896E-03,   5.5879611E-03
     +,   5.6589255E-03,   5.7150945E-03,   5.7571507E-03
     +,   5.7861456E-03,   5.8035003E-03,   5.8109965E-03
     +,   5.8107474E-03,   5.8051781E-03,   5.7969820E-03
     +,   5.7890774E-03,   5.7845633E-03,   5.7866555E-03
     +,   5.7986365E-03,   5.8237906E-03,   5.8653317E-03
     +,   5.9263455E-03,   6.0097044E-03,   6.1180061E-03
     +,   6.2534823E-03,   6.4179245E-03,   6.6125994E-03
     +,   6.8381564E-03,   7.0945635E-03,   7.3810145E-03
     +,   7.6959087E-03,   8.0367494E-03,   8.4002130E-03
     +,   8.7821232E-03,   9.1775442E-03,   9.5809083E-03
     +,   9.9861799E-03,   1.0387108E-02,   1.0777469E-02
     +,   1.1151378E-02,   1.1503650E-02,   1.1830102E-02
     +,   1.2127833E-02,   1.2395535E-02,   1.2633611E-02
     +,   1.2844347E-02,   1.3031828E-02,   1.3201875E-02
     +,   1.3361751E-02,   1.3519871E-02,   1.3685352E-02
     +,   1.3867494E-02,   1.4075343E-02,   1.4317066E-02
     +,   1.4599531E-02,   1.4927834E-02,   1.5304976E-02
     +,   1.5731538E-02,   1.6205618E-02,   1.6722672E-02
     +,   1.7275682E-02,   1.7855197E-02,   1.8449727E-02
     +,   1.9045921E-02,   1.9629136E-02,   2.0183770E-02
     +,   2.0693943E-02,   2.1143986E-02,   2.1519056E-02
     +,   2.1805724E-02,   2.1992618E-02,   2.2070859E-02
     +,   2.2034498E-02,   2.1880852E-02,   2.1610610E-02
     +,   2.1227827E-02,   2.0739794E-02,   2.0156592E-02
     +,   1.9490765E-02,   1.8756561E-02,   1.7969457E-02
     +,   1.7145356E-02,   1.6299985E-02,   1.5448379E-02
     +,   1.4604351E-02,   1.3780068E-02,   1.2985853E-02
     +,   1.2230149E-02,   1.1519321E-02,   1.0857935E-02
     +,   1.0248707E-02,   9.6928729E-03,   9.1902334E-03
     +,   8.7395245E-03,   8.3384747E-03,   7.9841344E-03
     +,   7.6729367E-03,   7.4009015E-03,   7.1637742E-03
     +,   6.9571375E-03,   6.7765084E-03,   6.6174511E-03
     +,   6.4757075E-03,   6.3472404E-03,   6.2283636E-03
     +,   6.1157830E-03,   6.0066800E-03,   5.8987392E-03
     +,   5.7901894E-03,   5.6797834E-03,   5.5668135E-03
     +,   5.4510394E-03,   5.3326548E-03,   5.2122232E-03
     +,   5.0905966E-03,   4.9688211E-03,   4.8480653E-03
     +,   4.7295503E-03,   4.6144649E-03,   4.5039016E-03
     +,   4.3988083E-03,   4.2999666E-03,   4.2079380E-03
     +,   4.1230735E-03,   4.0455116E-03,   3.9751804E-03
     +,   3.9118184E-03,   3.8549991E-03,   3.8041649E-03
     +,   3.7586517E-03,   3.7177207E-03,   3.6805924E-03
     +,   3.6464722E-03,   3.6145800E-03,   3.5841637E-03
     +,   3.5545218E-03,   3.5250185E-03,   3.4950874E-03
     +,   3.4642390E-03,   3.4320650E-03,   3.3982364E-03
     +,   3.3624950E-03,   3.3246540E-03,   3.2845915E-03
     +,   3.2422417E-03,   3.1975845E-03,   3.1506408E-03
     +,   3.1014667E-03,   3.0501452E-03,   2.9967767E-03
     +,   2.9414741E-03,   2.8843670E-03,   2.8255843E-03
     +,   2.7652581E-03,   2.7035237E-03,   2.6405160E-03
     +,   2.5763635E-03,   2.5111898E-03,   2.4451218E-03
     +,   2.3782812E-03,   2.3107834E-03,   2.2427414E-03
     +,   2.1742701E-03,   2.1054840E-03,   2.0364914E-03
     +,   1.9674012E-03,   1.8983287E-03,   1.8293825E-03
     +,   1.7606716E-03,   1.6923110E-03,   1.6244140E-03
     +,   1.5570909E-03,   1.4904509E-03,   1.4246070E-03
     +,   1.3596700E-03,   1.2957441E-03,   1.2329316E-03
     +,   1.1713342E-03,   1.1110499E-03,   1.0521672E-03
     +,   9.9476869E-04,   9.3893684E-04,   8.8474125E-04
     +,   8.3224406E-04,   7.8150310E-04,   7.3256809E-04
     +,   6.8547641E-04,   6.4025767E-04,   5.9693563E-04
     +,   5.5552524E-04,   5.1603018E-04,   4.7844625E-04
     +,   4.4276370E-04,   4.0896502E-04,   3.7702339E-04
     +,   3.4690535E-04,   3.1857443E-04,   2.9198546E-04
     +,   2.6708856E-04,   2.4383119E-04,   2.2215674E-04
     +,   2.0200407E-04,   1.8330950E-04,   1.6600882E-04
     +,   1.5003617E-04,   1.3532372E-04,   1.2180343E-04
     +,   1.0940843E-04,   9.8072080E-05,   8.7728069E-05
     +,   7.8311459E-05,   6.9759873E-05,   6.2011910E-05
     +,   5.5008371E-05,   4.8692884E-05,   4.3011489E-05
     +,   3.7912403E-05,   3.3346601E-05,   2.9268118E-05
     +,   2.5633657E-05,   2.2402404E-05,   1.9536335E-05
     +,   1.7000271E-05,   1.4761583E-05,   1.2789993E-05
     +,   1.1057692E-05,   9.5393289E-06,   8.2115721E-06
     +,   7.0532092E-06,   6.0450402E-06,   5.1696993E-06
     +,   4.4114427E-06,   3.7561460E-06,   3.1911800E-06
     +,   2.7052572E-06,   2.2882889E-06,   1.9313218E-06
     +,   1.6264524E-06,   1.3666987E-06,   1.1458960E-06
     +,   9.5864038E-07,   8.0021829E-07,   6.6649994E-07
     +,   5.5389489E-07,   4.5929571E-07,   3.8001156E-07
     +,   3.1371678E-07,   2.5841160E-07,   2.1238387E-07
     +,   1.7416826E-07,   1.4251175E-07,   1.1634936E-07
     +,   9.4779388E-08,   7.7036077E-08,   6.2475571E-08
     +,   5.0554107E-08,   4.0816698E-08,   3.2881278E-08
     +,   2.6429806E-08,   2.1196717E-08,   1.6962012E-08
     +,   1.3542983E-08,   1.0789115E-08,   8.5760679E-09
     +,   6.8017139E-09,   5.3824758E-09,   4.2498476E-09
     +,   3.3480951E-09,   2.6317821E-09,   2.0641224E-09
     +,   1.6152781E-09,   1.2612252E-09,   9.8257258E-10
     +,   7.6378254E-10,   5.9238153E-10,   4.5842255E-10
     +,   3.5396239E-10,   2.7269728E-10
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_haonly_hatt120_mass = Yx/0.365987192307692
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_haonly_hatt60_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  7.1699051E-03,   7.5568967E-03
     +,   7.9889987E-03,   8.4711090E-03,   9.0090604E-03
     +,   9.6104778E-03,   1.0286058E-02,   1.1051530E-02
     +,   1.1930372E-02,   1.2957420E-02,   1.4183058E-02
     +,   1.5677607E-02,   1.7534686E-02,   1.9872008E-02
     +,   2.2828227E-02,   2.6555164E-02,   3.1206913E-02
     +,   3.6930144E-02,   4.3862525E-02,   5.2147716E-02
     +,   6.1973225E-02,   7.3626272E-02,   8.7536007E-02
     +,   0.1042352    ,   0.1241741    ,   0.1474839    
     +,   0.1740236    ,   0.2040638    ,   0.2392182    
     +,   0.2825148    ,   0.3379070    ,   0.4120918    
     +,   0.5162207    ,   0.6555453    ,   0.8162717    
     +,   0.9826885    ,    1.148560    ,    1.281889    
     +,    1.366373    ,    1.463087    ,    1.570121    
     +,    1.647810    ,    1.749070    ,    1.853259    
     +,    1.857967    ,    1.709083    ,    1.514721    
     +,    1.319869    ,    1.109489    ,   0.9443557    
     +,   0.8263496    ,   0.7108691    ,   0.5937086    
     +,   0.4915998    ,   0.4135067    ,   0.3559202    
     +,   0.3091328    ,   0.2676584    ,   0.2321467    
     +,   0.2040502    ,   0.1825281    ,   0.1653503    
     +,   0.1505377    ,   0.1369568    ,   0.1241479    
     +,   0.1120023    ,   0.1005491    ,   8.9868993E-02
     +,   8.0067456E-02,   7.1266055E-02,   6.3575871E-02
     +,   5.7066750E-02,   5.1737841E-02,   4.7512528E-02
     +,   4.4251498E-02,   4.1779831E-02,   3.9914466E-02
     +,   3.8484231E-02,   3.7341263E-02,   3.6364783E-02
     +,   3.5460711E-02,   3.4558598E-02,   3.3608753E-02
     +,   3.2579072E-02,   3.1452414E-02,   3.0223589E-02
     +,   2.8897244E-02,   2.7484933E-02,   2.6003409E-02
     +,   2.4472263E-02,   2.2912577E-02,   2.1345748E-02
     +,   1.9792419E-02,   1.8271688E-02,   1.6800689E-02
     +,   1.5394306E-02,   1.4064585E-02,   1.2820897E-02
     +,   1.1669544E-02,   1.0614100E-02,   9.6552949E-03
     +,   8.7915491E-03,   8.0190683E-03,   7.3325057E-03
     +,   6.7252116E-03,   6.1897822E-03,   5.7184855E-03
     +,   5.3035966E-03,   4.9376558E-03,   4.6137380E-03
     +,   4.3256194E-03,   4.0677884E-03,   3.8355482E-03
     +,   3.6249207E-03,   3.4326673E-03,   3.2561463E-03
     +,   3.0932880E-03,   2.9424524E-03,   2.8023932E-03
     +,   2.6721356E-03,   2.5509300E-03,   2.4381948E-03
     +,   2.3334592E-03,   2.2363171E-03,   2.1464073E-03
     +,   2.0633966E-03,   1.9869441E-03,   1.9167137E-03
     +,   1.8523466E-03,   1.7934795E-03,   1.7397266E-03
     +,   1.6906972E-03,   1.6459848E-03,   1.6051851E-03
     +,   1.5678898E-03,   1.5336955E-03,   1.5022104E-03
     +,   1.4730563E-03,   1.4458705E-03,   1.4203105E-03
     +,   1.3960589E-03,   1.3728231E-03,   1.3503351E-03
     +,   1.3283534E-03,   1.3066675E-03,   1.2850899E-03
     +,   1.2634611E-03,   1.2416479E-03,   1.2195412E-03
     +,   1.1970542E-03,   1.1741198E-03,   1.1506936E-03
     +,   1.1267479E-03,   1.1022699E-03,   1.0772612E-03
     +,   1.0517369E-03,   1.0257241E-03,   9.9925650E-04
     +,   9.7237580E-04,   9.4513287E-04,   9.1758138E-04
     +,   8.8977820E-04,   8.6178520E-04,   8.3366613E-04
     +,   8.0548372E-04,   7.7730080E-04,   7.4918178E-04
     +,   7.2118966E-04,   6.9338398E-04,   6.6582236E-04
     +,   6.3856144E-04,   6.1165518E-04,   5.8515253E-04
     +,   5.5909931E-04,   5.3354021E-04,   5.0851388E-04
     +,   4.8405537E-04,   4.6019765E-04,   4.3696974E-04
     +,   4.1439579E-04,   3.9249592E-04,   3.7128854E-04
     +,   3.5078832E-04,   3.3100520E-04,   3.1194618E-04
     +,   2.9361626E-04,   2.7601750E-04,   2.5914819E-04
     +,   2.4300389E-04,   2.2757953E-04,   2.1286614E-04
     +,   1.9885295E-04,   1.8552806E-04,   1.7287802E-04
     +,   1.6088694E-04,   1.4953774E-04,   1.3881295E-04
     +,   1.2869408E-04,   1.1916111E-04,   1.1019348E-04
     +,   1.0177067E-04,   9.3871735E-05,   8.6474975E-05
     +,   7.9558573E-05,   7.3101408E-05,   6.7081732E-05
     +,   6.1478073E-05,   5.6269564E-05,   5.1435651E-05
     +,   4.6955829E-05,   4.2810196E-05,   3.8979560E-05
     +,   3.5445319E-05,   3.2189211E-05,   2.9193649E-05
     +,   2.6441932E-05,   2.3918001E-05,   2.1606302E-05
     +,   1.9492036E-05,   1.7561297E-05,   1.5800679E-05
     +,   1.4197503E-05,   1.2739875E-05,   1.1416570E-05
     +,   1.0216931E-05,   9.1309666E-06,   8.1493827E-06
     +,   7.2634766E-06,   6.4650758E-06,   5.7465704E-06
     +,   5.1009397E-06,   4.5216689E-06,   4.0026821E-06
     +,   3.5383823E-06,   3.1236448E-06,   2.7537146E-06
     +,   2.4242297E-06,   2.1312123E-06,   1.8710199E-06
     +,   1.6403108E-06,   1.4360415E-06,   1.2554557E-06
     +,   1.0960509E-06,   9.5554685E-07,   8.3188263E-07
     +,   7.2320569E-07,   6.2784562E-07,   5.4429211E-07
     +,   4.7119013E-07,   4.0733249E-07,   3.5163097E-07
     +,   3.0311574E-07,   2.6092349E-07,   2.2428671E-07
     +,   1.9252019E-07,   1.6501703E-07,   1.4124150E-07
     +,   1.2071983E-07,   1.0303257E-07,   8.7810704E-08
     +,   7.4730671E-08,   6.3508310E-08,   5.3893935E-08
     +,   4.5669211E-08,   3.8644323E-08,   3.2653077E-08
     +,   2.7550845E-08,   2.3212447E-08,   1.9529161E-08
     +,   1.6406672E-08,   1.3763485E-08,   1.1529469E-08
     +,   9.6441806E-09,   8.0555242E-09,   6.7188024E-09
     +,   5.5958242E-09,   4.6537667E-09,   3.8647285E-09
     +,   3.2048044E-09,   2.6537310E-09,   2.1942177E-09
     +,   1.8116523E-09,   1.4936077E-09,   1.2296185E-09
     +,   1.0108129E-09,   8.2974011E-10,   6.8011474E-10
     +,   5.5665733E-10,   4.5495027E-10,   3.7128345E-10
     +,   3.0256436E-10,   2.4620339E-10,   2.0005116E-10
     +,   1.6231239E-10,   1.3150189E-10,   1.0638408E-10
     +,   8.5939138E-11,   6.9321632E-11,   5.5836200E-11
     +,   4.4908161E-11,   3.6066566E-11
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_haonly_hatt60_mass = Yx/7.70644104255319
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_haonly_hatt65_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.6857978E-03,   1.7436731E-03
     +,   1.8097174E-03,   1.8854167E-03,   1.9724513E-03
     +,   2.0726968E-03,   2.1882001E-03,   2.3211618E-03
     +,   2.4738959E-03,   2.6488046E-03,   2.8483223E-03
     +,   3.0748863E-03,   3.3309094E-03,   3.6187659E-03
     +,   3.9407979E-03,   4.2993557E-03,   4.6968539E-03
     +,   5.1358650E-03,   5.6192102E-03,   6.1500766E-03
     +,   6.7320839E-03,   7.3693246E-03,   8.0662956E-03
     +,   8.8277915E-03,   9.6584596E-03,   1.0562520E-02
     +,   1.1543054E-02,   1.2601431E-02,   1.3736726E-02
     +,   1.4945411E-02,   1.6221546E-02,   1.7557735E-02
     +,   1.8947147E-02,   2.0386936E-02,   2.1883566E-02
     +,   2.3461169E-02,   2.5174659E-02,   2.7129591E-02
     +,   2.9509511E-02,   3.2606978E-02,   3.6853362E-02
     +,   4.2840078E-02,   5.1334135E-02,   6.3280307E-02
     +,   7.9735436E-02,   0.1016067    ,   0.1291303    
     +,   0.1614493    ,   0.1971409    ,   0.2359287    
     +,   0.2798064    ,   0.3316941    ,   0.3937729    
     +,   0.4689502    ,   0.5623081    ,   0.6792617    
     +,   0.8195238    ,   0.9653993    ,    1.109306    
     +,    1.270402    ,    1.425049    ,    1.551982    
     +,    1.634528    ,    1.623984    ,    1.562873    
     +,    1.489813    ,    1.374192    ,    1.216060    
     +,    1.088035    ,   0.9951671    ,   0.8748454    
     +,   0.7409207    ,   0.6482202    ,   0.6049735    
     +,   0.5728604    ,   0.5142965    ,   0.4308554    
     +,   0.3507726    ,   0.2916447    ,   0.2504002    
     +,   0.2179357    ,   0.1900662    ,   0.1670547    
     +,   0.1495078    ,   0.1364721    ,   0.1259513    
     +,   0.1161209    ,   0.1060455    ,   9.5706053E-02
     +,   8.5616529E-02,   7.6386586E-02,   6.8432465E-02
     +,   6.1882377E-02,   5.6623287E-02,   5.2408017E-02
     +,   4.8956063E-02,   4.6018105E-02,   4.3403704E-02
     +,   4.0980700E-02,   3.8663521E-02,   3.6398195E-02
     +,   3.4152251E-02,   3.1907931E-02,   2.9659811E-02
     +,   2.7413061E-02,   2.5182342E-02,   2.2990143E-02
     +,   2.0864006E-02,   1.8833220E-02,   1.6925711E-02
     +,   1.5165319E-02,   1.3569264E-02,   1.2147349E-02
     +,   1.0901382E-02,   9.8261731E-03,   8.9105302E-03
     +,   8.1391623E-03,   7.4941427E-03,   6.9566900E-03
     +,   6.5083057E-03,   6.1317892E-03,   5.8118585E-03
     +,   5.5354149E-03,   5.2915909E-03,   5.0716647E-03
     +,   4.8688613E-03,   4.6780352E-03,   4.4954503E-03
     +,   4.3184557E-03,   4.1453028E-03,   3.9748820E-03
     +,   3.8066108E-03,   3.6402475E-03,   3.4758234E-03
     +,   3.3135281E-03,   3.1536648E-03,   2.9966063E-03
     +,   2.8427583E-03,   2.6925176E-03,   2.5462692E-03
     +,   2.4043801E-03,   2.2671800E-03,   2.1349459E-03
     +,   2.0079101E-03,   1.8862647E-03,   1.7701422E-03
     +,   1.6596235E-03,   1.5547482E-03,   1.4555099E-03
     +,   1.3618513E-03,   1.2736761E-03,   1.1908576E-03
     +,   1.1132385E-03,   1.0406283E-03,   9.7281637E-04
     +,   9.0957899E-04,   8.5067959E-04,   7.9586951E-04
     +,   7.4489648E-04,   6.9751288E-04,   6.5346865E-04
     +,   6.1252015E-04,   5.7443470E-04,   5.3898914E-04
     +,   5.0596951E-04,   4.7517507E-04,   4.4642037E-04
     +,   4.1953378E-04,   3.9435562E-04,   3.7074037E-04
     +,   3.4855722E-04,   3.2768841E-04,   3.0802659E-04
     +,   2.8947616E-04,   2.7195373E-04,   2.5538367E-04
     +,   2.3969925E-04,   2.2484259E-04,   2.1076250E-04
     +,   1.9741304E-04,   1.8475350E-04,   1.7274871E-04
     +,   1.6136724E-04,   1.5058008E-04,   1.4036101E-04
     +,   1.3068678E-04,   1.2153585E-04,   1.1288746E-04
     +,   1.0472214E-04,   9.7022014E-05,   8.9769092E-05
     +,   8.2946004E-05,   7.6536191E-05,   7.0523332E-05
     +,   6.4890948E-05,   5.9622769E-05,   5.4703072E-05
     +,   5.0116232E-05,   4.5846489E-05,   4.1878302E-05
     +,   3.8196609E-05,   3.4786557E-05,   3.1633313E-05
     +,   2.8722405E-05,   2.6039948E-05,   2.3572175E-05
     +,   2.1305728E-05,   1.9227822E-05,   1.7326112E-05
     +,   1.5588606E-05,   1.4003797E-05,   1.2560816E-05
     +,   1.1249260E-05,   1.0059175E-05,   8.9811247E-06
     +,   8.0062728E-06,   7.1262793E-06,   6.3332377E-06
     +,   5.6197596E-06,   4.9789919E-06,   4.4044855E-06
     +,   3.8902476E-06,   3.4307493E-06,   3.0208714E-06
     +,   2.6558582E-06,   2.3313382E-06,   2.0433142E-06
     +,   1.7881173E-06,   1.5623776E-06,   1.3630236E-06
     +,   1.1872701E-06,   1.0325874E-06,   8.9667066E-07
     +,   7.7743823E-07,   6.7302221E-07,   5.8173032E-07
     +,   5.0204238E-07,   4.3260101E-07,   3.7219036E-07
     +,   3.1972093E-07,   2.7422251E-07,   2.3483524E-07
     +,   2.0079527E-07,   1.7142392E-07,   1.4612186E-07
     +,   1.2436163E-07,   1.0567879E-07,   8.9663594E-08
     +,   7.5957381E-08,   6.4246990E-08,   5.4257935E-08
     +,   4.5750753E-08,   3.8517641E-08,   3.2378022E-08
     +,   2.7174865E-08,   2.2772392E-08,   1.9053553E-08
     +,   1.5917410E-08,   1.3276834E-08,   1.1057070E-08
     +,   9.1941361E-09,   7.6332585E-09,   6.3275412E-09
     +,   5.2369962E-09,   4.3277018E-09,   3.5707335E-09
     +,   2.9415721E-09,   2.4195035E-09,   1.9870103E-09
     +,   1.6292898E-09,   1.3338834E-09,   1.0903390E-09
     +,   8.8988117E-10,   7.2514678E-10,   5.8998467E-10
     +,   4.7927157E-10,   3.8872536E-10,   3.1479663E-10
     +,   2.5452884E-10,   2.0548016E-10,   1.6562357E-10
     +,   1.3329067E-10,   1.0710170E-10,   8.5924837E-11
     +,   6.8827027E-11,   5.5045867E-11,   4.3955308E-11
     +,   3.5044287E-11,   2.7896296E-11,   2.2171431E-11
     +,   1.7594056E-11,   1.3939747E-11,   1.1027264E-11
     +,   8.7095912E-12,   6.8683353E-12,   5.4078179E-12
     +,   4.2512352E-12,   3.3367640E-12,   2.6149228E-12
     +,   2.0460098E-12,   1.5983769E-12
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_haonly_hatt65_mass = Yx/7.02451643478261
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_haonly_hatt70_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.1589759E-03,   2.3064252E-03
     +,   2.4662782E-03,   2.6389086E-03,   2.8245652E-03
     +,   3.0233555E-03,   3.2352286E-03,   3.4599588E-03
     +,   3.6971278E-03,   3.9461348E-03,   4.2061619E-03
     +,   4.4761896E-03,   4.7549959E-03,   5.0411592E-03
     +,   5.3330706E-03,   5.6289551E-03,   5.9268824E-03
     +,   6.2248046E-03,   6.5205754E-03,   6.8119918E-03
     +,   7.0968275E-03,   7.3728766E-03,   7.6379892E-03
     +,   7.8901360E-03,   8.1274146E-03,   8.3481437E-03
     +,   8.5508628E-03,   8.7344078E-03,   8.8979397E-03
     +,   9.0410057E-03,   9.1635808E-03,   9.2661334E-03
     +,   9.3497001E-03,   9.4159720E-03,   9.4674146E-03
     +,   9.5074130E-03,   9.5404312E-03,   9.5722303E-03
     +,   9.6100699E-03,   9.6629243E-03,   9.7416900E-03
     +,   9.8592499E-03,   1.0030457E-02,   1.0271879E-02
     +,   1.0601273E-02,   1.1036701E-02,   1.1595389E-02
     +,   1.2292295E-02,   1.3138823E-02,   1.4141967E-02
     +,   1.5304714E-02,   1.6628347E-02,   1.8117273E-02
     +,   1.9786751E-02,   2.1671820E-02,   2.3836391E-02
     +,   2.6377728E-02,   2.9424354E-02,   3.3126220E-02
     +,   3.7641715E-02,   4.3130793E-02,   4.9762093E-02
     +,   5.7729397E-02,   6.7253657E-02,   7.8531183E-02
     +,   9.1623634E-02,   0.1063910    ,   0.1226706    
     +,   0.1408766    ,   0.1627002    ,   0.1909589    
     +,   0.2280389    ,   0.2751922    ,   0.3359065    
     +,   0.4188738    ,   0.5312050    ,   0.6662902    
     +,   0.7962714    ,   0.8827676    ,   0.9288630    
     +,    1.007761    ,    1.168715    ,    1.338266    
     +,    1.418591    ,    1.436127    ,    1.467014    
     +,    1.479356    ,    1.367273    ,    1.134341    
     +,   0.8994918    ,   0.7675549    ,   0.7040203    
     +,   0.6305727    ,   0.5381453    ,   0.4522072    
     +,   0.3815794    ,   0.3195913    ,   0.2619002    
     +,   0.2105626    ,   0.1683667    ,   0.1353067    
     +,   0.1096473    ,   8.9745104E-02,   7.4502602E-02
     +,   6.3059427E-02,   5.4614380E-02,   4.8460189E-02
     +,   4.4035014E-02,   4.0909600E-02,   3.8741380E-02
     +,   3.7237253E-02,   3.6139831E-02,   3.5231411E-02
     +,   3.4341484E-02,   3.3351168E-02,   3.2190997E-02
     +,   3.0834310E-02,   2.9287620E-02,   2.7581068E-02
     +,   2.5759241E-02,   2.3873487E-02,   2.1975966E-02
     +,   2.0114724E-02,   1.8330297E-02,   1.6653921E-02
     +,   1.5107033E-02,   1.3701350E-02,   1.2440427E-02
     +,   1.1320952E-02,   1.0334892E-02,   9.4709136E-03
     +,   8.7161511E-03,   8.0571407E-03,   7.4808672E-03
     +,   6.9751479E-03,   6.5290071E-03,   6.1328337E-03
     +,   5.7783304E-03,   5.4584341E-03,   5.1672291E-03
     +,   4.8998329E-03,   4.6522408E-03,   4.4211862E-03
     +,   4.2040409E-03,   3.9987308E-03,   3.8035999E-03
     +,   3.6173561E-03,   3.4390090E-03,   3.2678042E-03
     +,   3.1031661E-03,   2.9446697E-03,   2.7920180E-03
     +,   2.6450059E-03,   2.5034903E-03,   2.3673794E-03
     +,   2.2366303E-03,   2.1112228E-03,   1.9911421E-03
     +,   1.8763792E-03,   1.7669344E-03,   1.6627879E-03
     +,   1.5639090E-03,   1.4702557E-03,   1.3817678E-03
     +,   1.2983602E-03,   1.2199283E-03,   1.1463541E-03
     +,   1.0775010E-03,   1.0132106E-03,   9.5331093E-04
     +,   8.9762156E-04,   8.4595132E-04,   7.9809758E-04
     +,   7.5385231E-04,   7.1300846E-04,   6.7535287E-04
     +,   6.4067321E-04,   6.0876162E-04,   5.7941338E-04
     +,   5.5242679E-04,   5.2760658E-04,   5.0476636E-04
     +,   4.8372694E-04,   4.6431689E-04,   4.4637342E-04
     +,   4.2974509E-04,   4.1428936E-04,   3.9987298E-04
     +,   3.8637233E-04,   3.7367520E-04,   3.6167770E-04
     +,   3.5028544E-04,   3.3941417E-04,   3.2898839E-04
     +,   3.1894055E-04,   3.0921132E-04,   2.9974984E-04
     +,   2.9051231E-04,   2.8146134E-04,   2.7256578E-04
     +,   2.6380105E-04,   2.5514772E-04,   2.4659076E-04
     +,   2.3811952E-04,   2.2972806E-04,   2.2141293E-04
     +,   2.1317383E-04,   2.0501333E-04,   1.9693638E-04
     +,   1.8894901E-04,   1.8105858E-04,   1.7327418E-04
     +,   1.6560560E-04,   1.5806244E-04,   1.5065474E-04
     +,   1.4339290E-04,   1.3628713E-04,   1.2934678E-04
     +,   1.2258066E-04,   1.1599766E-04,   1.0960513E-04
     +,   1.0340969E-04,   9.7417476E-05,   9.1633614E-05
     +,   8.6061889E-05,   8.0705126E-05,   7.5565578E-05
     +,   7.0644499E-05,   6.5941837E-05,   6.1456747E-05
     +,   5.7187786E-05,   5.3132720E-05,   4.9288301E-05
     +,   4.5650577E-05,   4.2215408E-05,   3.8977694E-05
     +,   3.5931858E-05,   3.3072163E-05,   3.0392419E-05
     +,   2.7886017E-05,   2.5546082E-05,   2.3365756E-05
     +,   2.1338015E-05,   1.9455636E-05,   1.7711389E-05
     +,   1.6098173E-05,   1.4608935E-05,   1.3236627E-05
     +,   1.1974330E-05,   1.0815407E-05,   9.7532848E-06
     +,   8.7816024E-06,   7.8942876E-06,   7.0854881E-06
     +,   6.3495490E-06,   5.6810736E-06,   5.0749777E-06
     +,   4.5264269E-06,   4.0308159E-06,   3.5838084E-06
     +,   3.1813597E-06,   2.8196723E-06,   2.4951696E-06
     +,   2.2045303E-06,   1.9446873E-06,   1.7127718E-06
     +,   1.5061339E-06,   1.3223403E-06,   1.1591542E-06
     +,   1.0145067E-06,   8.8650830E-07,   7.7343987E-07
     +,   6.7373361E-07,   5.8595759E-07,   5.0881255E-07
     +,   4.4113119E-07,   3.8184859E-07,   3.3001442E-07
     +,   2.8476626E-07,   2.4533662E-07,   2.1103271E-07
     +,   1.8124058E-07,   1.5540860E-07,   1.3304938E-07
     +,   1.1372712E-07,   9.7058617E-08,   8.2702627E-08
     +,   7.0358894E-08,   5.9763522E-08,   5.0683653E-08
     +,   4.2915829E-08,   3.6281094E-08,   3.0624026E-08
     +,   2.5808168E-08,   2.1715541E-08,   1.8243069E-08
     +,   1.5301831E-08,   1.2814516E-08,   1.0714703E-08
     +,   8.9447969E-09,   7.4555624E-09
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_haonly_hatt70_mass = Yx/5.9118612
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_haonly_hatt75_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.0544912E-03,   3.1527886E-03
     +,   3.2466431E-03,   3.3358280E-03,   3.4202002E-03
     +,   3.4997142E-03,   3.5744191E-03,   3.6444671E-03
     +,   3.7101067E-03,   3.7716897E-03,   3.8296578E-03
     +,   3.8845381E-03,   3.9369320E-03,   3.9875046E-03
     +,   4.0369667E-03,   4.0860553E-03,   4.1355160E-03
     +,   4.1860794E-03,   4.2384411E-03,   4.2932346E-03
     +,   4.3510129E-03,   4.4122227E-03,   4.4771894E-03
     +,   4.5461054E-03,   4.6190056E-03,   4.6957755E-03
     +,   4.7761416E-03,   4.8596808E-03,   4.9458286E-03
     +,   5.0338972E-03,   5.1231044E-03,   5.2125966E-03
     +,   5.3014853E-03,   5.3888778E-03,   5.4739271E-03
     +,   5.5558514E-03,   5.6339842E-03,   5.7077943E-03
     +,   5.7769199E-03,   5.8411742E-03,   5.9005660E-03
     +,   5.9552947E-03,   6.0057458E-03,   6.0524703E-03
     +,   6.0961717E-03,   6.1376751E-03,   6.1779078E-03
     +,   6.2178671E-03,   6.2586134E-03,   6.3012494E-03
     +,   6.3469275E-03,   6.3968594E-03,   6.4523360E-03
     +,   6.5147774E-03,   6.5857563E-03,   6.6670692E-03
     +,   6.7607840E-03,   6.8692928E-03,   6.9953795E-03
     +,   7.1422807E-03,   7.3137539E-03,   7.5141853E-03
     +,   7.7486997E-03,   8.0233840E-03,   8.3455257E-03
     +,   8.7238932E-03,   9.1691995E-03,   9.6943807E-03
     +,   1.0315067E-02,   1.1049591E-02,   1.1918968E-02
     +,   1.2945910E-02,   1.4153508E-02,   1.5562451E-02
     +,   1.7188026E-02,   1.9036727E-02,   2.1104235E-02
     +,   2.3377331E-02,   2.5842002E-02,   2.8498916E-02
     +,   3.1384867E-02,   3.4595352E-02,   3.8295731E-02
     +,   4.2714447E-02,   4.8114903E-02,   5.4773308E-02
     +,   6.3004419E-02,   7.3285133E-02,   8.6428501E-02
     +,   0.1036143    ,   0.1259940    ,   0.1539044    
     +,   0.1864149    ,   0.2223427    ,   0.2636545    
     +,   0.3211115    ,   0.4142397    ,   0.5488119    
     +,   0.6938301    ,   0.8162444    ,   0.9177443    
     +,    1.007571    ,    1.091040    ,    1.146834    
     +,    1.123715    ,    1.019494    ,   0.9022509    
     +,   0.8126956    ,   0.7306095    ,   0.6450573    
     +,   0.5628309    ,   0.4845418    ,   0.4075776    
     +,   0.3352137    ,   0.2740197    ,   0.2262541    
     +,   0.1894409    ,   0.1601491    ,   0.1358806    
     +,   0.1152056    ,   9.7548746E-02,   8.2725920E-02
     +,   7.0460029E-02,   6.0257863E-02,   5.1603001E-02
     +,   4.4147752E-02,   3.7734829E-02,   3.2307029E-02
     +,   2.7811145E-02,   2.4158284E-02,   2.1226920E-02
     +,   1.8885195E-02,   1.7008368E-02,   1.5488747E-02
     +,   1.4237589E-02,   1.3184204E-02,   1.2273917E-02
     +,   1.1465882E-02,   1.0731044E-02,   1.0050218E-02
     +,   9.4120745E-03,   8.8110641E-03,   8.2454579E-03
     +,   7.7157374E-03,   7.2232708E-03,   6.7692432E-03
     +,   6.3540819E-03,   5.9771864E-03,   5.6368443E-03
     +,   5.3303507E-03,   5.0542913E-03,   4.8048357E-03
     +,   4.5780074E-03,   4.3699164E-03,   4.1769836E-03
     +,   3.9960742E-03,   3.8245628E-03,   3.6603485E-03
     +,   3.5018516E-03,   3.3479796E-03,   3.1980348E-03
     +,   3.0516554E-03,   2.9087490E-03,   2.7694104E-03
     +,   2.6338445E-03,   2.5023215E-03,   2.3751392E-03
     +,   2.2525757E-03,   2.1348582E-03,   2.0221521E-03
     +,   1.9145601E-03,   1.8121128E-03,   1.7147599E-03
     +,   1.6223899E-03,   1.5348428E-03,   1.4519050E-03
     +,   1.3733285E-03,   1.2988491E-03,   1.2281901E-03
     +,   1.1610675E-03,   1.0972050E-03,   1.0363443E-03
     +,   9.7824552E-04,   9.2268910E-04,   8.6948043E-04
     +,   8.1845577E-04,   7.6947734E-04,   7.2243036E-04
     +,   6.7722349E-04,   6.3379086E-04,   5.9208134E-04
     +,   5.5205799E-04,   5.1369949E-04,   4.7699289E-04
     +,   4.4192886E-04,   4.0850157E-04,   3.7670808E-04
     +,   3.4654449E-04,   3.1800187E-04,   2.9106744E-04
     +,   2.6572510E-04,   2.4195317E-04,   2.1972202E-04
     +,   1.9899649E-04,   1.7973747E-04,   1.6189831E-04
     +,   1.4542758E-04,   1.3027067E-04,   1.1636901E-04
     +,   1.0366023E-04,   9.2079965E-05,   8.1563201E-05
     +,   7.2043986E-05,   6.3455809E-05,   5.5732791E-05
     +,   4.8810783E-05,   4.2627165E-05,   3.7120994E-05
     +,   3.2233816E-05,   2.7910395E-05,   2.4097902E-05
     +,   2.0746676E-05,   1.7810456E-05,   1.5246172E-05
     +,   1.3013761E-05,   1.1076399E-05,   9.4004718E-06
     +,   7.9553311E-06,   6.7130777E-06,   5.6485583E-06
     +,   4.7392323E-06,   3.9649285E-06,   3.3076321E-06
     +,   2.7513818E-06,   2.2821353E-06,   1.8874989E-06
     +,   1.5566251E-06,   1.2800770E-06,   1.0496530E-06
     +,   8.5824416E-07,   6.9972674E-07,   5.6885551E-07
     +,   4.6114209E-07,   3.7275530E-07,   3.0044640E-07
     +,   2.4147269E-07,   1.9352181E-07,   1.5465031E-07
     +,   1.2323314E-07,   9.7919170E-08,   7.7583302E-08
     +,   6.1295296E-08,   4.8289024E-08,   3.7934655E-08
     +,   2.9715839E-08,   2.3211424E-08,   1.8079289E-08
     +,   1.4042098E-08,   1.0875554E-08,   8.3991729E-09
     +,   6.4683428E-09,   4.9673567E-09,   3.8039252E-09
     +,   2.9047587E-09,   2.2119180E-09,   1.6796040E-09
     +,   1.2718081E-09,   9.6032515E-10,   7.2310918E-10
     +,   5.4297011E-10,   4.0656711E-10,   3.0358460E-10
     +,   2.2606025E-10,   1.6786689E-10,   1.2430824E-10
     +,   9.1799561E-11,   6.7605213E-11,   4.9651377E-11
     +,   3.6365404E-11,   2.6562148E-11,   1.9348622E-11
     +,   1.4055982E-11,   1.0183392E-11,   7.3579285E-12
     +,   5.3020739E-12,   3.8104563E-12,   2.7311660E-12
     +,   1.9523554E-12,   1.3919507E-12,   9.8977922E-13
     +,   7.0196783E-13,   4.9654101E-13,   3.5032255E-13
     +,   2.4651957E-13,   1.7302999E-13,   1.2113585E-13
     +,   8.4590788E-14,   5.8920716E-14,   4.0937787E-14
     +,   2.8371885E-14,   1.9614508E-14
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_haonly_hatt75_mass = Yx/4.21872223255814
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_haonly_hatt80_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.0420080E-04,   3.3432778E-04
     +,   3.6675096E-04,   4.0155035E-04,   4.3879441E-04
     +,   4.7853711E-04,   5.2081537E-04,   5.6564703E-04
     +,   6.1302650E-04,   6.6292600E-04,   7.1528868E-04
     +,   7.7002880E-04,   8.2702993E-04,   8.8614330E-04
     +,   9.4718643E-04,   1.0099434E-03,   1.0741644E-03
     +,   1.1395678E-03,   1.2058401E-03,   1.2726405E-03
     +,   1.3396026E-03,   1.4063388E-03,   1.4724445E-03
     +,   1.5375086E-03,   1.6011095E-03,   1.6628347E-03
     +,   1.7222795E-03,   1.7790581E-03,   1.8328128E-03
     +,   1.8832216E-03,   1.9300090E-03,   1.9729538E-03
     +,   2.0118987E-03,   2.0467597E-03,   2.0775350E-03
     +,   2.1043126E-03,   2.1272793E-03,   2.1467274E-03
     +,   2.1630628E-03,   2.1768056E-03,   2.1886015E-03
     +,   2.1992202E-03,   2.2095572E-03,   2.2206348E-03
     +,   2.2336009E-03,   2.2497212E-03,   2.2703761E-03
     +,   2.2970496E-03,   2.3313176E-03,   2.3748346E-03
     +,   2.4293102E-03,   2.4964930E-03,   2.5781391E-03
     +,   2.6759887E-03,   2.7917146E-03,   2.9269010E-03
     +,   3.0829774E-03,   3.2611717E-03,   3.4624457E-03
     +,   3.6874304E-03,   3.9363480E-03,   4.2089438E-03
     +,   4.5043877E-03,   4.8212456E-03,   5.1573976E-03
     +,   5.5099651E-03,   5.8753733E-03,   6.2492788E-03
     +,   6.6267354E-03,   7.0022047E-03,   7.3698331E-03
     +,   7.7235843E-03,   8.0576213E-03,   8.3665540E-03
     +,   8.6458996E-03,   8.8924309E-03,   9.1045480E-03
     +,   9.2826514E-03,   9.4294297E-03,   9.5499959E-03
     +,   9.6519282E-03,   9.7451592E-03,   9.8416442E-03
     +,   9.9549340E-03,   1.0099515E-02,   1.0290126E-02
     +,   1.0540908E-02,   1.0864668E-02,   1.1272009E-02
     +,   1.1770742E-02,   1.2365202E-02,   1.3055748E-02
     +,   1.3838398E-02,   1.4704784E-02,   1.5642451E-02
     +,   1.6635843E-02,   1.7668847E-02,   1.8728431E-02
     +,   1.9810483E-02,   2.0926604E-02,   2.2111621E-02
     +,   2.3429248E-02,   2.4974598E-02,   2.6870091E-02
     +,   2.9253978E-02,   3.2259300E-02,   3.5984840E-02
     +,   4.0467359E-02,   4.5682468E-02,   5.1620539E-02
     +,   5.8465552E-02,   6.6804871E-02,   7.7678688E-02
     +,   9.2369467E-02,   0.1120655    ,   0.1375671    
     +,   0.1688915    ,   0.2047411    ,   0.2423656    
     +,   0.2790015    ,   0.3151933    ,   0.3569358    
     +,   0.4117608    ,   0.4786661    ,   0.5405151    
     +,   0.5719633    ,   0.5607145    ,   0.5156366    
     +,   0.4522183    ,   0.3811902    ,   0.3096139    
     +,   0.2420875    ,   0.1816919    ,   0.1317040    
     +,   9.4377063E-02,   6.9069952E-02,   5.2857265E-02
     +,   4.2502150E-02,   3.5681892E-02,   3.1054053E-02
     +,   2.7847636E-02,   2.5540389E-02,   2.3737196E-02
     +,   2.2153968E-02,   2.0617800E-02,   1.9051243E-02
     +,   1.7444186E-02,   1.5824065E-02,   1.4232238E-02
     +,   1.2709139E-02,   1.1287124E-02,   9.9880518E-03
     +,   8.8232206E-03,   7.7945162E-03,   6.8963622E-03
     +,   6.1179120E-03,   5.4451856E-03,   4.8630624E-03
     +,   4.3569664E-03,   3.9139781E-03,   3.5233034E-03
     +,   3.1764300E-03,   2.8669401E-03,   2.5900998E-03
     +,   2.3424097E-03,   2.1212199E-03,   1.9244065E-03
     +,   1.7501046E-03,   1.5965424E-03,   1.4619679E-03
     +,   1.3446226E-03,   1.2427340E-03,   1.1545359E-03
     +,   1.0783090E-03,   1.0124225E-03,   9.5534616E-04
     +,   9.0568233E-04,   8.6218107E-04,   8.2374050E-04
     +,   7.8940496E-04,   7.5836072E-04,   7.2992727E-04
     +,   7.0354325E-04,   6.7875028E-04,   6.5518235E-04
     +,   6.3255301E-04,   6.1064225E-04,   5.8928330E-04
     +,   5.6835485E-04,   5.4777431E-04,   5.2748586E-04
     +,   5.0745689E-04,   4.8767365E-04,   4.6813593E-04
     +,   4.4885170E-04,   4.2983601E-04,   4.1110959E-04
     +,   3.9269589E-04,   3.7461831E-04,   3.5690053E-04
     +,   3.3956676E-04,   3.2263971E-04,   3.0613950E-04
     +,   2.9008419E-04,   2.7449123E-04,   2.5937438E-04
     +,   2.4474505E-04,   2.3061338E-04,   2.1698736E-04
     +,   2.0387175E-04,   1.9126952E-04,   1.7918229E-04
     +,   1.6761002E-04,   1.5654997E-04,   1.4599788E-04
     +,   1.3594866E-04,   1.2639583E-04,   1.1733080E-04
     +,   1.0874395E-04,   1.0062537E-04,   9.2963295E-05
     +,   8.5745145E-05,   7.8958001E-05,   7.2588286E-05
     +,   6.6621331E-05,   6.1042076E-05,   5.5835455E-05
     +,   5.0986026E-05,   4.6477860E-05,   4.2294956E-05
     +,   3.8421531E-05,   3.4841836E-05,   3.1540036E-05
     +,   2.8500466E-05,   2.5708076E-05,   2.3147775E-05
     +,   2.0804930E-05,   1.8665442E-05,   1.6715670E-05
     +,   1.4942327E-05,   1.3332665E-05,   1.1874602E-05
     +,   1.0556584E-05,   9.3675526E-06,   8.2970428E-06
     +,   7.3352435E-06,   6.4729102E-06,   5.7013167E-06
     +,   5.0123040E-06,   4.3983391E-06,   3.8523499E-06
     +,   3.3677923E-06,   2.9386520E-06,   2.5593793E-06
     +,   2.2248576E-06,   1.9304036E-06,   1.6717562E-06
     +,   1.4450351E-06,   1.2466980E-06,   1.0735417E-06
     +,   9.2268471E-07,   7.9152625E-07,   6.7772339E-07
     +,   5.7917862E-07,   4.9402485E-07,   4.2059031E-07
     +,   3.5738873E-07,   3.0310702E-07,   2.5658201E-07
     +,   2.1678498E-07,   1.8281094E-07,   1.5386773E-07
     +,   1.2926093E-07,   1.0838251E-07,   9.0702656E-08
     +,   7.5762678E-08,   6.3162425E-08,   5.2557773E-08
     +,   4.3649919E-08,   3.6182918E-08,   2.9935880E-08
     +,   2.4720325E-08,   2.0374404E-08,   1.6760577E-08
     +,   1.3761348E-08,   1.1277338E-08,   9.2240882E-09
     +,   7.5302129E-09,   6.1357115E-09,   4.9898836E-09
     +,   4.0503165E-09,   3.2813732E-09,   2.6533546E-09
     +,   2.1414241E-09,   1.7249775E-09,   1.3868586E-09
     +,   1.1128946E-09,   8.9133984E-10,   7.1253481E-10
     +,   5.6850769E-10,   4.5273080E-10
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_haonly_hatt80_mass = Yx/1.95534702631579
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_haonly_hatt85_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.8020956E-04,   4.9031357E-04
     +,   5.0118036E-04,   5.1285612E-04,   5.2538817E-04
     +,   5.3882541E-04,   5.5321818E-04,   5.6861772E-04
     +,   5.8507704E-04,   6.0265051E-04,   6.2139350E-04
     +,   6.4136297E-04,   6.6261686E-04,   6.8521459E-04
     +,   7.0921722E-04,   7.3468708E-04,   7.6168810E-04
     +,   7.9028611E-04,   8.2054891E-04,   8.5254665E-04
     +,   8.8635297E-04,   9.2204398E-04,   9.5970026E-04
     +,   9.9940994E-04,   1.0412636E-03,   1.0853644E-03
     +,   1.1318229E-03,   1.1807630E-03,   1.2323237E-03
     +,   1.2866610E-03,   1.3439531E-03,   1.4044028E-03
     +,   1.4682416E-03,   1.5357333E-03,   1.6071784E-03
     +,   1.6829167E-03,   1.7633309E-03,   1.8488480E-03
     +,   1.9399460E-03,   2.0371389E-03,   2.1409942E-03
     +,   2.2521128E-03,   2.3711280E-03,   2.4986959E-03
     +,   2.6354818E-03,   2.7821427E-03,   2.9393111E-03
     +,   3.1075701E-03,   3.2874292E-03,   3.4792989E-03
     +,   3.6834588E-03,   3.9000318E-03,   4.1289530E-03
     +,   4.3699550E-03,   4.6225120E-03,   4.8858621E-03
     +,   5.1589631E-03,   5.4404940E-03,   5.7288567E-03
     +,   6.0221837E-03,   6.3183536E-03,   6.6150222E-03
     +,   6.9096363E-03,   7.1995216E-03,   7.4819005E-03
     +,   7.7539328E-03,   8.0128349E-03,   8.2558701E-03
     +,   8.4804874E-03,   8.6843129E-03,   8.8652717E-03
     +,   9.0215849E-03,   9.1518695E-03,   9.2551215E-03
     +,   9.3307933E-03,   9.3787732E-03,   9.3994066E-03
     +,   9.3934974E-03,   9.3622701E-03,   9.3073761E-03
     +,   9.2308344E-03,   9.1349948E-03,   9.0225087E-03
     +,   8.8962456E-03,   8.7592714E-03,   8.6147524E-03
     +,   8.4659318E-03,   8.3160289E-03,   8.1682261E-03
     +,   8.0255577E-03,   7.8908792E-03,   7.7668205E-03
     +,   7.6557123E-03,   7.5595467E-03,   7.4799340E-03
     +,   7.4180784E-03,   7.3747393E-03,   7.3502273E-03
     +,   7.3443973E-03,   7.3566730E-03,   7.3860767E-03
     +,   7.4312845E-03,   7.4907066E-03,   7.5625838E-03
     +,   7.6451171E-03,   7.7366251E-03,   7.8357151E-03
     +,   7.9414910E-03,   8.0538094E-03,   8.1735449E-03
     +,   8.3028795E-03,   8.4456783E-03,   8.6078178E-03
     +,   8.7976344E-03,   9.0262489E-03,   9.3079032E-03
     +,   9.6599888E-03,   1.0102757E-02,   1.0658264E-02
     +,   1.1348610E-02,   1.2193240E-02,   1.3205566E-02
     +,   1.4389902E-02,   1.5739722E-02,   1.7238468E-02
     +,   1.8863799E-02,   2.0595927E-02,   2.2427399E-02
     +,   2.4373455E-02,   2.6478766E-02,   2.8821340E-02
     +,   3.1513374E-02,   3.4705866E-02,   3.8599685E-02
     +,   4.3468811E-02,   4.9688112E-02,   5.7750564E-02
     +,   6.8247914E-02,   8.1783481E-02,   9.8796509E-02
     +,   0.1193092    ,   0.1426695    ,   0.1674008    
     +,   0.1912773    ,   0.2116829    ,   0.2261921    
     +,   0.2331629    ,   0.2321225    ,   0.2237933    
     +,   0.2097629    ,   0.1919676    ,   0.1722024    
     +,   0.1518253    ,   0.1317099    ,   0.1123833    
     +,   9.4221249E-02,   7.7580705E-02,   6.2818266E-02
     +,   5.0223250E-02,   3.9928656E-02,   3.1860735E-02
     +,   2.5760204E-02,   2.1253994E-02,   1.7941942E-02
     +,   1.5466747E-02,   1.3551176E-02,   1.2003608E-02
     +,   1.0703553E-02,   9.5803076E-03,   8.5934969E-03
     +,   7.7191638E-03,   6.9414554E-03,   6.2485221E-03
     +,   5.6308080E-03,   5.0803781E-03,   4.5903577E-03
     +,   4.1546607E-03,   3.7677288E-03,   3.4243204E-03
     +,   3.1194440E-03,   2.8484266E-03,   2.6070068E-03
     +,   2.3913938E-03,   2.1982903E-03,   2.0249127E-03
     +,   1.8689440E-03,   1.7284538E-03,   1.6018039E-03
     +,   1.4875846E-03,   1.3845583E-03,   1.2915906E-03
     +,   1.2076324E-03,   1.1317078E-03,   1.0629024E-03
     +,   1.0003607E-03,   9.4329612E-04,   8.9099811E-04
     +,   8.4283150E-04,   7.9823611E-04,   7.5672782E-04
     +,   7.1789854E-04,   6.8140717E-04,   6.4697122E-04
     +,   6.1436178E-04,   5.8339821E-04,   5.5393495E-04
     +,   5.2585645E-04,   4.9907365E-04,   4.7351496E-04
     +,   4.4912059E-04,   4.2584018E-04,   4.0363084E-04
     +,   3.8245329E-04,   3.6226885E-04,   3.4303954E-04
     +,   3.2472890E-04,   3.0730007E-04,   2.9071461E-04
     +,   2.7493417E-04,   2.5992189E-04,   2.4563976E-04
     +,   2.3205084E-04,   2.1911990E-04,   2.0681322E-04
     +,   1.9509782E-04,   1.8394268E-04,   1.7331941E-04
     +,   1.6320152E-04,   1.5356397E-04,   1.4438359E-04
     +,   1.3563977E-04,   1.2731364E-04,   1.1938722E-04
     +,   1.1184417E-04,   1.0467009E-04,   9.7850978E-05
     +,   9.1373804E-05,   8.5226748E-05,   7.9398618E-05
     +,   7.3878349E-05,   6.8655339E-05,   6.3719584E-05
     +,   5.9061320E-05,   5.4670607E-05,   5.0537648E-05
     +,   4.6653007E-05,   4.3007283E-05,   3.9590810E-05
     +,   3.6394031E-05,   3.3407709E-05,   3.0622352E-05
     +,   2.8028564E-05,   2.5617190E-05,   2.3379152E-05
     +,   2.1305383E-05,   1.9386951E-05,   1.7615255E-05
     +,   1.5981857E-05,   1.4478452E-05,   1.3096967E-05
     +,   1.1829696E-05,   1.0669192E-05,   9.6082113E-06
     +,   8.6398095E-06,   7.7574523E-06,   6.9548146E-06
     +,   6.2258928E-06,   5.5650439E-06,   4.9669266E-06
     +,   4.4264684E-06,   3.9389051E-06,   3.4998077E-06
     +,   3.1050204E-06,   2.7506462E-06,   2.4330618E-06
     +,   2.1489359E-06,   1.8951428E-06,   1.6688288E-06
     +,   1.4673362E-06,   1.2882464E-06,   1.1293183E-06
     +,   9.8852013E-07,   8.6397728E-07,   7.5399907E-07
     +,   6.5703273E-07,   5.7168268E-07,   4.9667551E-07
     +,   4.3086203E-07,   3.7321152E-07,   3.2278987E-07
     +,   2.7876371E-07,   2.4038127E-07,   2.0697424E-07
     +,   1.7794265E-07,   1.5275491E-07,   1.3093566E-07
     +,   1.1206573E-07,   9.5771199E-08,   8.1723925E-08
     +,   6.9632321E-08,   5.9241252E-08
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_haonly_hatt85_mass = Yx/1.08971655882353
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_haonly_hatt90_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.5633066E-05,   1.8689903E-05
     +,   2.2284599E-05,   2.6499963E-05,   3.1429321E-05
     +,   3.7177510E-05,   4.3861804E-05,   5.1612875E-05
     +,   6.0575567E-05,   7.0910333E-05,   8.2793209E-05
     +,   9.6416981E-05,   1.1199153E-04,   1.2974426E-04
     +,   1.4991997E-04,   1.7278080E-04,   1.9860527E-04
     +,   2.2768769E-04,   2.6033630E-04,   2.9687129E-04
     +,   3.3762216E-04,   3.8292457E-04,   4.3311549E-04
     +,   4.8853271E-04,   5.4950005E-04,   6.1633397E-04
     +,   6.8932661E-04,   7.6874357E-04,   8.5481437E-04
     +,   9.4772544E-04,   1.0476104E-03,   1.1545426E-03
     +,   1.2685257E-03,   1.3894866E-03,   1.5172665E-03
     +,   1.6516150E-03,   1.7921842E-03,   1.9385220E-03
     +,   2.0900792E-03,   2.2461866E-03,   2.4060840E-03
     +,   2.5689015E-03,   2.7336737E-03,   2.8993469E-03
     +,   3.0647884E-03,   3.2288006E-03,   3.3901322E-03
     +,   3.5474994E-03,   3.6995995E-03,   3.8451357E-03
     +,   3.9828327E-03,   4.1114604E-03,   4.2298562E-03
     +,   4.3369476E-03,   4.4317581E-03,   4.5134472E-03
     +,   4.5813094E-03,   4.6347934E-03,   4.6735150E-03
     +,   4.6972604E-03,   4.7059949E-03,   4.6998584E-03
     +,   4.6791686E-03,   4.6444107E-03,   4.5962250E-03
     +,   4.5354073E-03,   4.4628717E-03,   4.3796594E-03
     +,   4.2868922E-03,   4.1857790E-03,   4.0775673E-03
     +,   3.9635501E-03,   3.8450130E-03,   3.7232479E-03
     +,   3.5995045E-03,   3.4749857E-03,   3.3508390E-03
     +,   3.2281359E-03,   3.1078537E-03,   2.9908763E-03
     +,   2.8779972E-03,   2.7698937E-03,   2.6671519E-03
     +,   2.5702433E-03,   2.4795530E-03,   2.3953593E-03
     +,   2.3178661E-03,   2.2471852E-03,   2.1833670E-03
     +,   2.1263934E-03,   2.0761916E-03,   2.0326457E-03
     +,   1.9956050E-03,   1.9648841E-03,   1.9402771E-03
     +,   1.9215638E-03,   1.9085102E-03,   1.9008782E-03
     +,   1.8984248E-03,   1.9009070E-03,   1.9080832E-03
     +,   1.9197142E-03,   1.9355647E-03,   1.9554014E-03
     +,   1.9789969E-03,   2.0061277E-03,   2.0365722E-03
     +,   2.0701136E-03,   2.1065404E-03,   2.1456459E-03
     +,   2.1872248E-03,   2.2310796E-03,   2.2770127E-03
     +,   2.3248321E-03,   2.3743401E-03,   2.4253398E-03
     +,   2.4776198E-03,   2.5309573E-03,   2.5850977E-03
     +,   2.6397600E-03,   2.6946182E-03,   2.7492906E-03
     +,   2.8033373E-03,   2.8562583E-03,   2.9074983E-03
     +,   2.9564581E-03,   3.0025397E-03,   3.0451966E-03
     +,   3.0840354E-03,   3.1189388E-03,   3.1502543E-03
     +,   3.1790126E-03,   3.2071995E-03,   3.2380403E-03
     +,   3.2762890E-03,   3.3284673E-03,   3.4030133E-03
     +,   3.5103005E-03,   3.6625105E-03,   3.8733238E-03
     +,   4.1574184E-03,   4.5298007E-03,   5.0049485E-03
     +,   5.5956407E-03,   6.3114585E-03,   7.1574231E-03
     +,   8.1330659E-03,   9.2333425E-03,   1.0453412E-02
     +,   1.1799049E-02,   1.3303366E-02,   1.5048004E-02
     +,   1.7183831E-02,   1.9942639E-02,   2.3631353E-02
     +,   2.8605383E-02,   3.5226684E-02,   4.3819126E-02
     +,   5.4631770E-02,   6.7807712E-02,   8.3344646E-02
     +,   0.1010140    ,   0.1202359    ,   0.1399541    
     +,   0.1585981    ,   0.1742232    ,   0.1848594    
     +,   0.1889942    ,   0.1860049    ,   0.1763568    
     +,   0.1614771    ,   0.1433571    ,   0.1240516    
     +,   0.1052712    ,   8.8175677E-02,   7.3363371E-02
     +,   6.0989246E-02,   5.0914519E-02,   4.2833526E-02
     +,   3.6367364E-02,   3.1132951E-02,   2.6793443E-02
     +,   2.3089319E-02,   1.9847870E-02,   1.6972538E-02
     +,   1.4419512E-02,   1.2171634E-02,   1.0218265E-02
     +,   8.5444814E-03,   7.1280967E-03,   5.9410650E-03
     +,   4.9530659E-03,   4.1345465E-03,   3.4584466E-03
     +,   2.9008784E-03,   2.4411818E-03,   2.0616676E-03
     +,   1.7472702E-03,   1.4853027E-03,   1.2652992E-03
     +,   1.0788373E-03,   9.1930578E-04,   7.8164105E-04
     +,   6.6206470E-04,   5.5780966E-04,   4.6683787E-04
     +,   3.8762859E-04,   3.1900132E-04,   2.5997279E-04
     +,   2.0966014E-04,   1.6722812E-04,   1.3186166E-04
     +,   1.0275366E-04,   7.9109377E-05,   6.0161725E-05
     +,   4.5187047E-05,   3.3517161E-05,   2.4549496E-05
     +,   1.7754657E-05,   1.2678535E-05,   8.9392024E-06
     +,   6.2228360E-06,   4.2770007E-06,   2.9023872E-06
     +,   1.9446052E-06,   1.2863599E-06,   8.4015102E-07
     +,   5.4178435E-07,   3.4496142E-07,   2.1686618E-07
     +,   1.3462025E-07,   8.2518341E-08,   4.9949609E-08
     +,   2.9859610E-08,   1.7630914E-08,   1.0284237E-08
     +,   5.9276162E-09,   3.3772811E-09,   1.9031838E-09
     +,   1.0616060E-09,   5.8684702E-10,   3.2205830E-10
     +,   1.7591778E-10,   9.5991007E-11,   5.2588482E-11
     +,   2.9121375E-11,   1.6434763E-11,   9.5369337E-12
     +,   5.7362357E-12,   3.5946107E-12,   2.3484309E-12
     +,   1.5935610E-12,   1.1155782E-12,   7.9949014E-13
     +,   5.8236933E-13,   4.2869435E-13,   3.1755463E-13
     +,   2.3601113E-13,   1.7564555E-13,   1.3073189E-13
     +,   9.7235893E-14,   7.2237585E-14,   5.3587099E-14
     +,   3.9685835E-14,   2.9339480E-14,   2.1651041E-14
     +,   1.5947543E-14,   1.1724529E-14,   8.6035711E-15
     +,   6.3014110E-15,   4.6064392E-15,   3.3609647E-15
     +,   2.4475837E-15,   1.7790174E-15,   1.2905886E-15
     +,   9.3447417E-16,   6.7532153E-16,   4.8710753E-16
     +,   3.5067201E-16,   2.5196970E-16,   1.8069906E-16
     +,   1.2934051E-16,   9.2400402E-17,   6.5884320E-17
     +,   4.6886874E-17,   3.3303420E-17,   2.3609743E-17
     +,   1.6705258E-17,   1.1797334E-17,   8.3152075E-18
     +,   5.8496736E-18,   4.1072090E-18,   2.8782831E-18
     +,   2.0131527E-18,   1.4053667E-18,   9.7917588E-19
     +,   6.8092546E-19,   4.7260323E-19,   3.2738834E-19
     +,   2.2635291E-19,   1.5619910E-19
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_haonly_hatt90_mass = Yx/0.777189
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_haonly_hatt95_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  8.6244685E-04,   8.8551891E-04
     +,   9.0899545E-04,   9.3286979E-04,   9.5713499E-04
     +,   9.8178338E-04,   1.0068070E-03,   1.0321969E-03
     +,   1.0579434E-03,   1.0840378E-03,   1.1104693E-03
     +,   1.1372267E-03,   1.1642986E-03,   1.1916726E-03
     +,   1.2193359E-03,   1.2472748E-03,   1.2754747E-03
     +,   1.3039205E-03,   1.3325963E-03,   1.3614845E-03
     +,   1.3905677E-03,   1.4198266E-03,   1.4492412E-03
     +,   1.4787915E-03,   1.5084533E-03,   1.5382052E-03
     +,   1.5680221E-03,   1.5978789E-03,   1.6277489E-03
     +,   1.6576053E-03,   1.6874190E-03,   1.7171616E-03
     +,   1.7468034E-03,   1.7763141E-03,   1.8056638E-03
     +,   1.8348219E-03,   1.8637584E-03,   1.8924432E-03
     +,   1.9208498E-03,   1.9489485E-03,   1.9767154E-03
     +,   2.0041263E-03,   2.0311605E-03,   2.0578005E-03
     +,   2.0840317E-03,   2.1098442E-03,   2.1352328E-03
     +,   2.1601967E-03,   2.1847412E-03,   2.2088783E-03
     +,   2.2326258E-03,   2.2560093E-03,   2.2790614E-03
     +,   2.3018245E-03,   2.3243460E-03,   2.3466854E-03
     +,   2.3689088E-03,   2.3910915E-03,   2.4133183E-03
     +,   2.4356826E-03,   2.4582860E-03,   2.4812391E-03
     +,   2.5046584E-03,   2.5286695E-03,   2.5534043E-03
     +,   2.5789982E-03,   2.6055921E-03,   2.6333295E-03
     +,   2.6623553E-03,   2.6928138E-03,   2.7248480E-03
     +,   2.7585956E-03,   2.7941910E-03,   2.8317552E-03
     +,   2.8714044E-03,   2.9132387E-03,   2.9573427E-03
     +,   3.0037810E-03,   3.0526021E-03,   3.1038316E-03
     +,   3.1574639E-03,   3.2134752E-03,   3.2718042E-03
     +,   3.3323660E-03,   3.3950387E-03,   3.4596736E-03
     +,   3.5260811E-03,   3.5940486E-03,   3.6633215E-03
     +,   3.7336212E-03,   3.8046392E-03,   3.8760363E-03
     +,   3.9474489E-03,   4.0184981E-03,   4.0887878E-03
     +,   4.1579045E-03,   4.2254366E-03,   4.2909631E-03
     +,   4.3540760E-03,   4.4143703E-03,   4.4714678E-03
     +,   4.5250044E-03,   4.5746565E-03,   4.6201264E-03
     +,   4.6611624E-03,   4.6975636E-03,   4.7291750E-03
     +,   4.7558988E-03,   4.7776997E-03,   4.7945990E-03
     +,   4.8066815E-03,   4.8140963E-03,   4.8170527E-03
     +,   4.8158215E-03,   4.8107286E-03,   4.8021539E-03
     +,   4.7905259E-03,   4.7763125E-03,   4.7600213E-03
     +,   4.7421842E-03,   4.7233566E-03,   4.7041024E-03
     +,   4.6849982E-03,   4.6666157E-03,   4.6495195E-03
     +,   4.6342667E-03,   4.6213991E-03,   4.6114475E-03
     +,   4.6049347E-03,   4.6023796E-03,   4.6043070E-03
     +,   4.6112565E-03,   4.6238028E-03,   4.6425657E-03
     +,   4.6682237E-03,   4.7015334E-03,   4.7433330E-03
     +,   4.7945445E-03,   4.8561762E-03,   4.9292967E-03
     +,   5.0150109E-03,   5.1144036E-03,   5.2284985E-03
     +,   5.3581754E-03,   5.5040643E-03,   5.6664827E-03
     +,   5.8453139E-03,   6.0399054E-03,   6.2489836E-03
     +,   6.4706136E-03,   6.7021549E-03,   6.9402806E-03
     +,   7.1810819E-03,   7.4202702E-03,   7.6534497E-03
     +,   7.8764735E-03,   8.0859428E-03,   8.2797455E-03
     +,   8.4575843E-03,   8.6214561E-03,   8.7759942E-03
     +,   8.9285485E-03,   9.0888981E-03,   9.2686135E-03
     +,   9.4800210E-03,   9.7349323E-03,   1.0043450E-02
     +,   1.0413371E-02,   1.0850958E-02,   1.1363800E-02
     +,   1.1966737E-02,   1.2691727E-02,   1.3602470E-02
     +,   1.4814455E-02,   1.6520767E-02,   1.9024156E-02
     +,   2.2772036E-02,   2.8386947E-02,   3.6677025E-02
     +,   4.8601117E-02,   6.5155938E-02,   8.7159149E-02
     +,   0.1149353    ,   0.1479586    ,   0.1845582    
     +,   0.2218297    ,   0.2558856    ,   0.2824657    
     +,   0.2977922    ,   0.2994430    ,   0.2869619    
     +,   0.2619835    ,   0.2278434    ,   0.1887971    
     +,   0.1491106    ,   0.1123009    ,   8.0696821E-02
     +,   5.5355698E-02,   3.6265224E-02,   2.2696940E-02
     +,   1.3572310E-02,   7.7539124E-03,   4.2308983E-03
     +,   2.2037944E-03,   1.0951933E-03,   5.1892811E-04
     +,   2.3431217E-04,   1.0081957E-04,   4.1382980E-05
     +,   1.6260723E-05,   6.1721316E-06,   2.3116556E-06
     +,   8.9259993E-07,   3.8153462E-07,   1.9321595E-07
     +,   1.1656147E-07,   7.9148357E-08,   5.6936646E-08
     +,   4.1875154E-08,   3.0997512E-08,   2.2957137E-08
     +,   1.6976497E-08,   1.2527356E-08,   9.2236698E-09
     +,   6.7763670E-09,   4.9680202E-09,   3.6352719E-09
     +,   2.6555202E-09,   1.9369881E-09,   1.4112350E-09
     +,   1.0273937E-09,   7.4773232E-10,   5.4433480E-10
     +,   3.9662859E-10,   2.8950256E-10,   2.1186872E-10
     +,   1.5562468E-10,   1.1486787E-10,   8.5305624E-11
     +,   6.3823176E-11,   4.8167782E-11,   3.6714271E-11
     +,   2.8291369E-11,   2.2056199E-11,   1.7403459E-11
     +,   1.3899062E-11,   1.1231510E-11,   9.1770376E-12
     +,   7.5749667E-12,   6.3096911E-12,   5.2976031E-12
     +,   4.4780208E-12,   3.8066945E-12,   3.2510643E-12
     +,   2.7869092E-12,   2.3960662E-12,   2.0647390E-12
     +,   1.7823184E-12,   1.5404853E-12,   1.3326562E-12
     +,   1.1535604E-12,   9.9889953E-13,   8.6512183E-13
     +,   7.4926990E-13,   6.4887651E-13,   5.6181974E-13
     +,   4.8631542E-13,   4.2082166E-13,   3.6401936E-13
     +,   3.1475427E-13,   2.7204061E-13,   2.3501752E-13
     +,   2.0294141E-13,   1.7515804E-13,   1.5110482E-13
     +,   1.3029161E-13,   1.1228856E-13,   9.6724041E-14
     +,   8.3275251E-14,   7.1660343E-14,   6.1633600E-14
     +,   5.2982572E-14,   4.5522613E-14,   3.9093213E-14
     +,   3.3554400E-14,   2.8785402E-14,   2.4681798E-14
     +,   2.1152088E-14,   1.8117796E-14,   1.5510801E-14
     +,   1.3272174E-14,   1.1350734E-14,   9.7024143E-15
     +,   8.2891898E-15,   7.0782355E-15,   6.0409958E-15
     +,   5.1531075E-15,   4.3934400E-15,   3.7438767E-15
     +,   3.1886648E-15,   2.7143876E-15
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_haonly_hatt95_mass = Yx/1.00616981818182
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_haonly_htt100_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.1729593E-04,   4.1901961E-04
     +,   4.2076985E-04,   4.2254876E-04,   4.2435818E-04
     +,   4.2619978E-04,   4.2807526E-04,   4.2998602E-04
     +,   4.3193324E-04,   4.3391806E-04,   4.3594159E-04
     +,   4.3800450E-04,   4.4010766E-04,   4.4225153E-04
     +,   4.4443662E-04,   4.4666341E-04,   4.4893200E-04
     +,   4.5124284E-04,   4.5359600E-04,   4.5599180E-04
     +,   4.5843032E-04,   4.6091192E-04,   4.6343706E-04
     +,   4.6600614E-04,   4.6861978E-04,   4.7127888E-04
     +,   4.7398463E-04,   4.7673844E-04,   4.7954204E-04
     +,   4.8239779E-04,   4.8530815E-04,   4.8827651E-04
     +,   4.9130653E-04,   4.9440248E-04,   4.9756962E-04
     +,   5.0081359E-04,   5.0414092E-04,   5.0755887E-04
     +,   5.1107572E-04,   5.1470037E-04,   5.1844283E-04
     +,   5.2231387E-04,   5.2632508E-04,   5.3048908E-04
     +,   5.3481961E-04,   5.3933077E-04,   5.4403796E-04
     +,   5.4895726E-04,   5.5410608E-04,   5.5950193E-04
     +,   5.6516397E-04,   5.7111192E-04,   5.7736639E-04
     +,   5.8394991E-04,   5.9088517E-04,   5.9819763E-04
     +,   6.0591375E-04,   6.1406282E-04,   6.2267639E-04
     +,   6.3179038E-04,   6.4144377E-04,   6.5168156E-04
     +,   6.6255452E-04,   6.7412137E-04,   6.8645016E-04
     +,   6.9961807E-04,   7.1371702E-04,   7.2885101E-04
     +,   7.4514345E-04,   7.6273386E-04,   7.8178587E-04
     +,   8.0248452E-04,   8.2504336E-04,   8.4970205E-04
     +,   8.7673264E-04,   9.0643956E-04,   9.3915977E-04
     +,   9.7526389E-04,   1.0151591E-03,   1.0592862E-03
     +,   1.1081136E-03,   1.1621446E-03,   1.2218993E-03
     +,   1.2879238E-03,   1.3607666E-03,   1.4409873E-03
     +,   1.5291268E-03,   1.6257146E-03,   1.7312348E-03
     +,   1.8461297E-03,   1.9707761E-03,   2.1054596E-03
     +,   2.2503629E-03,   2.4055585E-03,   2.5709837E-03
     +,   2.7464069E-03,   2.9314514E-03,   3.1255381E-03
     +,   3.3279224E-03,   3.5376425E-03,   3.7535655E-03
     +,   3.9743404E-03,   4.1984632E-03,   4.4242293E-03
     +,   4.6498114E-03,   4.8732599E-03,   5.0925212E-03
     +,   5.3054905E-03,   5.5100662E-03,   5.7041859E-03
     +,   5.8858544E-03,   6.0532386E-03,   6.2046782E-03
     +,   6.3387780E-03,   6.4544203E-03,   6.5508517E-03
     +,   6.6276919E-03,   6.6849967E-03,   6.7232735E-03
     +,   6.7435117E-03,   6.7471913E-03,   6.7362804E-03
     +,   6.7132385E-03,   6.6809785E-03,   6.6428436E-03
     +,   6.6025681E-03,   6.5642032E-03,   6.5320679E-03
     +,   6.5106531E-03,   6.5045492E-03,   6.5183351E-03
     +,   6.5564858E-03,   6.6232565E-03,   6.7225760E-03
     +,   6.8579498E-03,   7.0323674E-03,   7.2482158E-03
     +,   7.5072376E-03,   7.8105447E-03,   8.1586400E-03
     +,   8.5514858E-03,   8.9886636E-03,   9.4695967E-03
     +,   9.9937674E-03,   1.0560907E-02,   1.1171351E-02
     +,   1.1826168E-02,   1.2527239E-02,   1.3277256E-02
     +,   1.4079613E-02,   1.4937998E-02,   1.5855834E-02
     +,   1.6835619E-02,   1.7878251E-02,   1.8982198E-02
     +,   2.0142663E-02,   2.1351105E-02,   2.2594946E-02
     +,   2.3857521E-02,   2.5118193E-02,   2.6353318E-02
     +,   2.7536988E-02,   2.8642118E-02,   2.9641688E-02
     +,   3.0509941E-02,   3.1223059E-02,   3.1759761E-02
     +,   3.2101691E-02,   3.2233760E-02,   3.2144897E-02
     +,   3.1829879E-02,   3.1292625E-02,   3.0551177E-02
     +,   2.9644534E-02,   2.8640473E-02,   2.7643109E-02
     +,   2.6798880E-02,   2.6299020E-02,   2.6376341E-02
     +,   2.7295390E-02,   2.9334761E-02,   3.2760490E-02
     +,   3.7791468E-02,   4.4559222E-02,   5.3064354E-02
     +,   6.3135929E-02,   7.4403591E-02,   8.6292095E-02
     +,   9.8043770E-02,   0.1087756    ,   0.1175719    
     +,   0.1235961    ,   0.1262067    ,   0.1250576    
     +,   0.1201564    ,   0.1118701    ,   0.1008740    
     +,   8.8054396E-02,   7.4381046E-02,   6.0781300E-02
     +,   4.8034940E-02,   3.6705237E-02,   2.7114106E-02
     +,   1.9359108E-02,   1.3358339E-02,   8.9073656E-03
     +,   5.7390225E-03,   3.5727597E-03,   2.1490380E-03
     +,   1.2489726E-03,   7.0134882E-04,   3.8055837E-04
     +,   1.9955823E-04,   1.0114633E-04,   4.9567137E-05
     +,   2.3500514E-05,   1.0793140E-05,   4.8141651E-06
     +,   2.0971065E-06,   9.0315154E-07,   3.9443941E-07
     +,   1.8308177E-07,   9.6346419E-08,   6.0182394E-08
     +,   4.4006914E-08,   3.5636933E-08,   3.0376906E-08
     +,   2.6464862E-08,   2.3246459E-08,   2.0472251E-08
     +,   1.8036779E-08,   1.5885250E-08,   1.3981299E-08
     +,   1.2296352E-08,   1.0806155E-08,   9.4891162E-09
     +,   8.3260190E-09,   7.2997381E-09,   6.3949628E-09
     +,   5.5979341E-09,   4.8963722E-09,   4.2793813E-09
     +,   3.7372248E-09,   3.2612018E-09,   2.8435747E-09
     +,   2.4774920E-09,   2.1568680E-09,   1.8762734E-09
     +,   1.6309054E-09,   1.4165306E-09,   1.2293787E-09
     +,   1.0661224E-09,   9.2382901E-10,   7.9991364E-10
     +,   6.9208445E-10,   5.9832606E-10,   5.1687132E-10
     +,   4.4616524E-10,   3.8483564E-10,   3.3168127E-10
     +,   2.8564978E-10,   2.4582014E-10,   2.1138338E-10
     +,   1.8163153E-10,   1.5594985E-10,   1.3379796E-10
     +,   1.1470534E-10,   9.8263168E-11,   8.4115027E-11
     +,   7.1949884E-11,   6.1497876E-11,   5.2524887E-11
     +,   4.4827992E-11,   3.8230554E-11,   3.2579849E-11
     +,   2.7743977E-11,   2.3608386E-11,   2.0074631E-11
     +,   1.7057245E-11,   1.4482893E-11,   1.2288075E-11
     +,   1.0418417E-11,   8.8267839E-12,   7.4729754E-12
     +,   6.3222448E-12,   5.3449259E-12,   4.5154783E-12
     +,   3.8120284E-12,   3.2159126E-12,   2.7111059E-12
     +,   2.2839534E-12,   1.9227612E-12,   1.6175745E-12
     +,   1.3598850E-12,   1.1424718E-12,   9.5915929E-13
     +,   8.0471952E-13,   6.7468833E-13,   5.6529369E-13
     +,   4.7331914E-13,   3.9604921E-13
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_haonly_htt100_mass = Yx/0.724941
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_haonly_htt105_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  6.3791864E-05,   6.8075591E-05
     +,   7.2561983E-05,   7.7253688E-05,   8.2152808E-05
     +,   8.7260880E-05,   9.2578928E-05,   9.8107361E-05
     +,   1.0384584E-04,   1.0979379E-04,   1.1594973E-04
     +,   1.2231176E-04,   1.2887738E-04,   1.3564374E-04
     +,   1.4260756E-04,   1.4976531E-04,   1.5711339E-04
     +,   1.6464818E-04,   1.7236636E-04,   1.8026517E-04
     +,   1.8834253E-04,   1.9659757E-04,   2.0503081E-04
     +,   2.1364525E-04,   2.2244535E-04,   2.3143968E-04
     +,   2.4063975E-04,   2.5006165E-04,   2.5972642E-04
     +,   2.6966099E-04,   2.7989896E-04,   2.9048155E-04
     +,   3.0145826E-04,   3.1288815E-04,   3.2484054E-04
     +,   3.3739582E-04,   3.5064659E-04,   3.6469783E-04
     +,   3.7966899E-04,   3.9569187E-04,   4.1291406E-04
     +,   4.3149682E-04,   4.5161575E-04,   4.7346015E-04
     +,   4.9723266E-04,   5.2314746E-04,   5.5142905E-04
     +,   5.8231049E-04,   6.1603024E-04,   6.5283017E-04
     +,   6.9295138E-04,   7.3663081E-04,   7.8409631E-04
     +,   8.3556579E-04,   8.9123368E-04,   9.5127715E-04
     +,   1.0158417E-03,   1.0850406E-03,   1.1589479E-03
     +,   1.2375945E-03,   1.3209628E-03,   1.4089843E-03
     +,   1.5015289E-03,   1.5984158E-03,   1.6994041E-03
     +,   1.8041828E-03,   1.9123931E-03,   2.0236052E-03
     +,   2.1373469E-03,   2.2530796E-03,   2.3702360E-03
     +,   2.4881929E-03,   2.6063132E-03,   2.7239216E-03
     +,   2.8403429E-03,   2.9549019E-03,   3.0669242E-03
     +,   3.1757585E-03,   3.2807924E-03,   3.3814583E-03
     +,   3.4772318E-03,   3.5676644E-03,   3.6523675E-03
     +,   3.7310410E-03,   3.8034583E-03,   3.8694849E-03
     +,   3.9290646E-03,   3.9822333E-03,   4.0290966E-03
     +,   4.0698391E-03,   4.1047074E-03,   4.1339952E-03
     +,   4.1580410E-03,   4.1772053E-03,   4.1918634E-03
     +,   4.2023854E-03,   4.2091268E-03,   4.2124200E-03
     +,   4.2125713E-03,   4.2098556E-03,   4.2045335E-03
     +,   4.1968683E-03,   4.1871564E-03,   4.1757813E-03
     +,   4.1632704E-03,   4.1503818E-03,   4.1382005E-03
     +,   4.1282540E-03,   4.1226363E-03,   4.1241311E-03
     +,   4.1363407E-03,   4.1637714E-03,   4.2118905E-03
     +,   4.2871279E-03,   4.3967715E-03,   4.5487992E-03
     +,   4.7515435E-03,   5.0133164E-03,   5.3418349E-03
     +,   5.7436707E-03,   6.2235999E-03,   6.7839627E-03
     +,   7.4241557E-03,   8.1403414E-03,   8.9252954E-03
     +,   9.7684767E-03,   1.0656657E-02,   1.1574409E-02
     +,   1.2505258E-02,   1.3432502E-02,   1.4340514E-02
     +,   1.5215520E-02,   1.6046707E-02,   1.6826747E-02
     +,   1.7552573E-02,   1.8225741E-02,   1.8852789E-02
     +,   1.9445468E-02,   2.0020725E-02,   2.0600067E-02
     +,   2.1208275E-02,   2.1871386E-02,   2.2613952E-02
     +,   2.3455992E-02,   2.4410414E-02,   2.5482208E-02
     +,   2.6669791E-02,   2.7969129E-02,   2.9380236E-02
     +,   3.0914582E-02,   3.2600798E-02,   3.4486398E-02
     +,   3.6633827E-02,   3.9110281E-02,   4.1972164E-02
     +,   4.5247082E-02,   4.8917364E-02,   5.2908242E-02
     +,   5.7082787E-02,   6.1244495E-02,   6.5150015E-02
     +,   6.8528593E-02,   7.1108587E-02,   7.2649449E-02
     +,   7.2974868E-02,   7.2001018E-02,   6.9756262E-02
     +,   6.6385232E-02,   6.2134773E-02,   5.7324242E-02
     +,   5.2303992E-02,   4.7410347E-02,   4.2925596E-02
     +,   3.9051749E-02,   3.5901055E-02,   3.3502322E-02
     +,   3.1821143E-02,   3.0785879E-02,   3.0312033E-02
     +,   3.0319732E-02,   3.0740675E-02,   3.1514969E-02
     +,   3.2580949E-02,   3.3863392E-02,   3.5264391E-02
     +,   3.6660898E-02,   3.7910394E-02,   3.8863432E-02
     +,   3.9380219E-02,   3.9347969E-02,   3.8695294E-02
     +,   3.7400924E-02,   3.5495579E-02,   3.3057019E-02
     +,   3.0199245E-02,   2.7058557E-02,   2.3778843E-02
     +,   2.0497542E-02,   1.7334409E-02,   1.4384563E-02
     +,   1.1715346E-02,   9.3663000E-03,   7.3518567E-03
     +,   5.6660566E-03,   4.2879041E-03,   3.1862303E-03
     +,   2.3245499E-03,   1.6648555E-03,   1.1703569E-03
     +,   8.0735848E-04,   5.4640108E-04,   3.6270064E-04
     +,   2.3608629E-04,   1.5064732E-04,   9.4212061E-05
     +,   5.7731257E-05,   3.4656845E-05,   2.0377378E-05
     +,   1.1732886E-05,   6.6146440E-06,   3.6507849E-06
     +,   1.9723504E-06,   1.0429503E-06,   5.3975583E-07
     +,   2.7336662E-07,   1.3547957E-07,   6.5701457E-08
     +,   3.1178399E-08,   1.4478007E-08,   6.5790866E-09
     +,   2.9263345E-09,   1.2746458E-09,   5.4419513E-10
     +,   2.2816524E-10,   9.4328947E-11,   3.8771864E-11
     +,   1.6104985E-11,   6.9641454E-12,   3.2770210E-12
     +,   1.7542136E-12,   1.0840051E-12,   7.5304547E-13
     +,   5.6300353E-13,   4.3731181E-13,   3.4565384E-13
     +,   2.7514612E-13,   2.1953217E-13,   1.7520647E-13
     +,   1.3974614E-13,   1.1135759E-13,   8.8639369E-14
     +,   7.0474862E-14,   5.5967390E-14,   4.4394671E-14
     +,   3.5173412E-14,   2.7834644E-14,   2.2001088E-14
     +,   1.7369803E-14,   1.3697338E-14,   1.0788488E-14
     +,   8.4874023E-15,   6.6693265E-15,   5.2345247E-15
     +,   4.1035273E-15,   3.2131517E-15,   2.5129998E-15
     +,   1.9630855E-15,   1.5317097E-15,   1.1937254E-15
     +,   9.2922574E-16,   7.2247490E-16,   5.6106721E-16
     +,   4.3520960E-16,   3.3718640E-16,   2.6093197E-16
     +,   2.0168721E-16,   1.5570886E-16,   1.2007170E-16
     +,   9.2481016E-17,   7.1147174E-17,   5.4669905E-17
     +,   4.1959663E-17,   3.2166189E-17,   2.4629720E-17
     +,   1.8836704E-17,   1.4389425E-17,   1.0979204E-17
     +,   8.3672231E-18,   6.3692369E-18,   4.8425866E-18
     +,   3.6775449E-18,   2.7895014E-18,   2.1134157E-18
     +,   1.5992992E-18,   1.2088366E-18,   9.1262051E-19
     +,   6.8818330E-19,   5.1832786E-19,   3.8993873E-19
     +,   2.9300472E-19,   2.1990964E-19
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_haonly_htt105_mass = Yx/0.6883674
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_haonly_htt107_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.2311720E-04,   2.4353528E-04
     +,   2.6530185E-04,   2.8844771E-04,   3.1299781E-04
     +,   3.3897048E-04,   3.6637654E-04,   3.9521881E-04
     +,   4.2549073E-04,   4.5717775E-04,   4.9025391E-04
     +,   5.2468292E-04,   5.6041736E-04,   5.9739838E-04
     +,   6.3555525E-04,   6.7480514E-04,   7.1505288E-04
     +,   7.5619167E-04,   7.9810235E-04,   8.4065401E-04
     +,   8.8370463E-04,   9.2710153E-04,   9.7068143E-04
     +,   1.0142747E-03,   1.0576984E-03,   1.1007681E-03
     +,   1.1432903E-03,   1.1850680E-03,   1.2259019E-03
     +,   1.2655903E-03,   1.3039327E-03,   1.3407307E-03
     +,   1.3757885E-03,   1.4089169E-03,   1.4399337E-03
     +,   1.4686649E-03,   1.4949479E-03,   1.5186311E-03
     +,   1.5395785E-03,   1.5576660E-03,   1.5727887E-03
     +,   1.5848570E-03,   1.5938007E-03,   1.5995675E-03
     +,   1.6021254E-03,   1.6014623E-03,   1.5975861E-03
     +,   1.5905248E-03,   1.5803266E-03,   1.5670597E-03
     +,   1.5508106E-03,   1.5316851E-03,   1.5098068E-03
     +,   1.4853149E-03,   1.4583664E-03,   1.4291304E-03
     +,   1.3977912E-03,   1.3645446E-03,   1.3295974E-03
     +,   1.2931656E-03,   1.2554736E-03,   1.2167522E-03
     +,   1.1772407E-03,   1.1371796E-03,   1.0968122E-03
     +,   1.0563891E-03,   1.0161560E-03,   9.7636547E-04
     +,   9.3726383E-04,   8.9910190E-04,   8.6212408E-04
     +,   8.2657766E-04,   7.9270353E-04,   7.6074444E-04
     +,   7.3093851E-04,   7.0352253E-04,   6.7873497E-04
     +,   6.5681484E-04,   6.3800247E-04,   6.2254391E-04
     +,   6.1069487E-04,   6.0272194E-04,   5.9891061E-04
     +,   5.9956854E-04,   6.0503365E-04,   6.1568251E-04
     +,   6.3193700E-04,   6.5427634E-04,   6.8324333E-04
     +,   7.1945705E-04,   7.6362211E-04,   8.1653008E-04
     +,   8.7906851E-04,   9.5222442E-04,   1.0370810E-03
     +,   1.1347969E-03,   1.2466133E-03,   1.3738039E-03
     +,   1.5176752E-03,   1.6794944E-03,   1.8604825E-03
     +,   2.0617207E-03,   2.2841431E-03,   2.5284297E-03
     +,   2.7949973E-03,   3.0839385E-03,   3.3949527E-03
     +,   3.7273387E-03,   4.0800022E-03,   4.4514393E-03
     +,   4.8397183E-03,   5.2426029E-03,   5.6574992E-03
     +,   6.0816309E-03,   6.5120067E-03,   6.9456100E-03
     +,   7.3793777E-03,   7.8104069E-03,   8.2359295E-03
     +,   8.6535197E-03,   9.0611456E-03,   9.4572622E-03
     +,   9.8409578E-03,   1.0212110E-02,   1.0571509E-02
     +,   1.0920946E-02,   1.1263448E-02,   1.1603265E-02
     +,   1.1946015E-02,   1.2298536E-02,   1.2668822E-02
     +,   1.3065609E-02,   1.3497987E-02,   1.3974622E-02
     +,   1.4503043E-02,   1.5088627E-02,   1.5733602E-02
     +,   1.6436132E-02,   1.7189618E-02,   1.7982330E-02
     +,   1.8797431E-02,   1.9613804E-02,   2.0407641E-02
     +,   2.1154702E-02,   2.1833396E-02,   2.2428662E-02
     +,   2.2936000E-02,   2.3365451E-02,   2.3744950E-02
     +,   2.4122128E-02,   2.4564009E-02,   2.5153803E-02
     +,   2.5984738E-02,   2.7150931E-02,   2.8736217E-02
     +,   3.0801892E-02,   3.3375677E-02,   3.6443647E-02
     +,   3.9946187E-02,   4.3778833E-02,   4.7799356E-02
     +,   5.1837642E-02,   5.5707887E-02,   5.9221648E-02
     +,   6.2199537E-02,   6.4480826E-02,   6.5931983E-02
     +,   6.6455089E-02,   6.5996163E-02,   6.4553246E-02
     +,   6.2183134E-02,   5.9004199E-02,   5.5192396E-02
     +,   5.0970506E-02,   4.6590488E-02,   4.2309944E-02
     +,   3.8368538E-02,   3.4966588E-02,   3.2248631E-02
     +,   3.0294219E-02,   2.9116567E-02,   2.8667379E-02
     +,   2.8846271E-02,   2.9513853E-02,   3.0506153E-02
     +,   3.1649292E-02,   3.2773174E-02,   3.3723634E-02
     +,   3.4371622E-02,   3.4619693E-02,   3.4405522E-02
     +,   3.3702280E-02,   3.2516789E-02,   3.0885646E-02
     +,   2.8869696E-02,   2.6547814E-02,   2.4010397E-02
     +,   2.1352407E-02,   1.8666724E-02,   1.6038584E-02
     +,   1.3541179E-02,   1.1232263E-02,   9.1523696E-03
     +,   7.3249168E-03,   5.7576559E-03,   4.4446448E-03
     +,   3.3694762E-03,   2.5085662E-03,   1.8341704E-03
     +,   1.3170923E-03,   9.2890131E-04,   6.4346747E-04
     +,   4.3783957E-04,   2.9265182E-04,   1.9215328E-04
     +,   1.2394393E-04,   7.8541787E-05,   4.8896050E-05
     +,   2.9904575E-05,   1.7968081E-05,   1.0605942E-05
     +,   6.1497731E-06,   3.5028406E-06,   1.9598374E-06
     +,   1.0770278E-06,   5.8130780E-07,   3.0813328E-07
     +,   1.6040055E-07,   8.1991729E-08,   4.1152205E-08
     +,   2.0279455E-08,   9.8116439E-09,   4.6602997E-09
     +,   2.1728792E-09,   9.9449682E-10,   4.4676979E-10
     +,   1.9698872E-10,   8.5244617E-11,   3.6203655E-11
     +,   1.5089175E-11,   6.1712740E-12,   2.4767159E-12
     +,   9.7536074E-13,   3.7688871E-13,   1.4288606E-13
     +,   5.3148783E-14,   1.9396572E-14,   6.9447257E-15
     +,   2.4392560E-15,   8.4051699E-16,   2.8411642E-16
     +,   9.4206270E-17,   3.0640947E-17,   9.7762781E-18
     +,   3.0597068E-18,   9.3932966E-19,   2.8291761E-19
     +,   8.3628393E-20,   2.4278215E-20,   6.9348714E-21
     +,   1.9578856E-21,   5.5225302E-22,   1.5946049E-22
     +,   4.9489716E-23,   1.7753660E-23,   7.7726094E-24
     +,   4.0803412E-24,   2.4004304E-24,   1.4912985E-24
     +,   9.4691589E-25,   6.0564747E-25,   3.8794333E-25
     +,   2.4831105E-25,   1.5868727E-25,   1.0122141E-25
     +,   6.4439601E-26,   4.0940454E-26,   2.5958685E-26
     +,   1.6425790E-26,   1.0372835E-26,   6.5370153E-27
     +,   4.1113913E-27,   2.5805297E-27,   1.6164268E-27
     +,   1.0104554E-27,   6.3038186E-28,   3.9247092E-28
     +,   2.4385037E-28,   1.5120511E-28,   9.3567129E-29
     +,   5.7783285E-29,   3.5612025E-29,   2.1903649E-29
     +,   1.3444565E-29,   8.2357654E-30,   5.0347179E-30
     +,   3.0716375E-30,   1.8701517E-30,   1.1363465E-30
     +,   6.8905701E-31,   4.1699082E-31
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_haonly_htt107_mass = Yx/0.62832724137931
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_haonly_htt110_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.6027847E-04,   3.7062308E-04
     +,   3.8132965E-04,   3.9243497E-04,   4.0397947E-04
     +,   4.1600715E-04,   4.2856581E-04,   4.4170741E-04
     +,   4.5548746E-04,   4.6996691E-04,   4.8521024E-04
     +,   5.0128694E-04,   5.1827094E-04,   5.3624128E-04
     +,   5.5528176E-04,   5.7548104E-04,   5.9693266E-04
     +,   6.1973510E-04,   6.4399111E-04,   6.6980789E-04
     +,   6.9729681E-04,   7.2657265E-04,   7.5775257E-04
     +,   7.9095818E-04,   8.2630839E-04,   8.6392683E-04
     +,   9.0393354E-04,   9.4644696E-04,   9.9158206E-04
     +,   1.0394481E-03,   1.0901467E-03,   1.1437710E-03
     +,   1.2004013E-03,   1.2601051E-03,   1.3229327E-03
     +,   1.3889160E-03,   1.4580658E-03,   1.5303673E-03
     +,   1.6057846E-03,   1.6842447E-03,   1.7656524E-03
     +,   1.8498754E-03,   1.9367470E-03,   2.0260660E-03
     +,   2.1175947E-03,   2.2110576E-03,   2.3061438E-03
     +,   2.4025047E-03,   2.4997580E-03,   2.5974875E-03
     +,   2.6952473E-03,   2.7925638E-03,   2.8889389E-03
     +,   2.9838611E-03,   3.0767939E-03,   3.1672041E-03
     +,   3.2545500E-03,   3.3382943E-03,   3.4179124E-03
     +,   3.4928962E-03,   3.5627626E-03,   3.6270616E-03
     +,   3.6853780E-03,   3.7373472E-03,   3.7826539E-03
     +,   3.8210377E-03,   3.8523024E-03,   3.8763173E-03
     +,   3.8930210E-03,   3.9024244E-03,   3.9046102E-03
     +,   3.8997347E-03,   3.8880277E-03,   3.8697892E-03
     +,   3.8453836E-03,   3.8152395E-03,   3.7798437E-03
     +,   3.7397337E-03,   3.6954884E-03,   3.6477214E-03
     +,   3.5970758E-03,   3.5442077E-03,   3.4897828E-03
     +,   3.4344608E-03,   3.3788916E-03,   3.3236949E-03
     +,   3.2694649E-03,   3.2167453E-03,   3.1660351E-03
     +,   3.1177686E-03,   3.0723147E-03,   3.0299725E-03
     +,   2.9909650E-03,   2.9554327E-03,   2.9234369E-03
     +,   2.8949592E-03,   2.8699010E-03,   2.8480899E-03
     +,   2.8292823E-03,   2.8131735E-03,   2.7994039E-03
     +,   2.7875742E-03,   2.7772505E-03,   2.7679864E-03
     +,   2.7593339E-03,   2.7508584E-03,   2.7421608E-03
     +,   2.7328909E-03,   2.7227667E-03,   2.7115897E-03
     +,   2.6992632E-03,   2.6858018E-03,   2.6713477E-03
     +,   2.6561755E-03,   2.6407049E-03,   2.6255015E-03
     +,   2.6112890E-03,   2.5989558E-03,   2.5895750E-03
     +,   2.5844264E-03,   2.5850406E-03,   2.5932568E-03
     +,   2.6112997E-03,   2.6418834E-03,   2.6883339E-03
     +,   2.7547092E-03,   2.8459490E-03,   2.9679658E-03
     +,   3.1277358E-03,   3.3332694E-03,   3.5935491E-03
     +,   3.9182426E-03,   4.3173945E-03,   4.8008086E-03
     +,   5.3774705E-03,   6.0547534E-03,   6.8375757E-03
     +,   7.7277049E-03,   8.7232776E-03,   9.8185064E-03
     +,   1.1003734E-02,   1.2266102E-02,   1.3590706E-02
     +,   1.4961987E-02,   1.6365312E-02,   1.7788969E-02
     +,   1.9225517E-02,   2.0672675E-02,   2.2133609E-02
     +,   2.3616374E-02,   2.5132274E-02,   2.6693448E-02
     +,   2.8310208E-02,   2.9988253E-02,   3.1725992E-02
     +,   3.3512481E-02,   3.5326418E-02,   3.7136190E-02
     +,   3.8900688E-02,   4.0570930E-02,   4.2092718E-02
     +,   4.3409586E-02,   4.4465970E-02,   4.5210723E-02
     +,   4.5600794E-02,   4.5604408E-02,   4.5204092E-02
     +,   4.4399153E-02,   4.3206908E-02,   4.1662667E-02
     +,   3.9818525E-02,   3.7740219E-02,   3.5502706E-02
     +,   3.3184920E-02,   3.0864395E-02,   2.8611366E-02
     +,   2.6484394E-02,   2.4527272E-02,   2.2767222E-02
     +,   2.1214796E-02,   1.9865563E-02,   1.8702842E-02
     +,   1.7700959E-02,   1.6828895E-02,   1.6053881E-02
     +,   1.5344429E-02,   1.4672619E-02,   1.4015649E-02
     +,   1.3356587E-02,   1.2684542E-02,   1.1994050E-02
     +,   1.1284308E-02,   1.0558186E-02,   9.8210936E-03
     +,   9.0799266E-03,   8.3422437E-03,   7.6156491E-03
     +,   6.9072638E-03,   6.2233782E-03,   5.5693514E-03
     +,   4.9496018E-03,   4.3675713E-03,   3.8257455E-03
     +,   3.3257606E-03,   2.8685150E-03,   2.4541302E-03
     +,   2.0820696E-03,   1.7512188E-03,   1.4599195E-03
     +,   1.2060317E-03,   9.8704104E-04,   8.0016308E-04
     +,   6.4241874E-04,   5.1072473E-04,   4.0199971E-04
     +,   3.1324930E-04,   2.4162621E-04,   1.8448065E-04
     +,   1.3940533E-04,   1.0425950E-04,   7.7168239E-05
     +,   5.6523670E-05,   4.0971794E-05,   2.9390025E-05
     +,   2.0862459E-05,   1.4654584E-05,   1.0186531E-05
     +,   7.0069450E-06,   4.7695280E-06,   3.2126336E-06
     +,   2.1413716E-06,   1.4124557E-06,   9.2194415E-07
     +,   5.9549194E-07,   3.8062873E-07,   2.4075518E-07
     +,   1.5069246E-07,   9.3337306E-08,   5.7210080E-08
     +,   3.4700523E-08,   2.0827487E-08,   1.2370297E-08
     +,   7.2706090E-09,   4.2286441E-09,   2.4336562E-09
     +,   1.3859645E-09,   7.8106460E-10,   4.3556800E-10
     +,   2.4035518E-10,   1.3125116E-10,   7.0926674E-11
     +,   3.7930475E-11,   2.0076578E-11,   1.0519504E-11
     +,   5.4578217E-12,   2.8051712E-12,   1.4294685E-12
     +,   7.2321099E-13,   3.6409124E-13,   1.8307938E-13
     +,   9.2516476E-14,   4.7432215E-14,   2.5008085E-14
     +,   1.3791137E-14,   8.0902006E-15,   5.1020852E-15
     +,   3.4570303E-15,   2.4889701E-15,   1.8739689E-15
     +,   1.4532434E-15,   1.1474181E-15,   9.1527680E-16
     +,   7.3410884E-16,   5.9036645E-16,   4.7527177E-16
     +,   3.8268766E-16,   3.0804431E-16,   2.4782387E-16
     +,   1.9923529E-16,   1.6005179E-16,   1.2846938E-16
     +,   1.0303489E-16,   8.2566330E-17,   6.6108923E-17
     +,   5.2886974E-17,   4.2274002E-17,   3.3762244E-17
     +,   2.6941433E-17,   2.1480524E-17,   1.7111953E-17
     +,   1.3620425E-17,   1.0832072E-17,   8.6073354E-18
     +,   6.8337100E-18,   5.4210047E-18,   4.2966863E-18
     +,   3.4026947E-18,   2.6924204E-18,   2.1286292E-18
     +,   1.6814515E-18,   1.3271117E-18
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_haonly_htt110_mass = Yx/0.442414777777778
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_haonly_htt115_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.0290724E-03,   1.0785612E-03
     +,   1.1286096E-03,   1.1790934E-03,   1.2298834E-03
     +,   1.2808474E-03,   1.3318508E-03,   1.3827572E-03
     +,   1.4334302E-03,   1.4837363E-03,   1.5335419E-03
     +,   1.5827190E-03,   1.6311429E-03,   1.6786966E-03
     +,   1.7252701E-03,   1.7707618E-03,   1.8150797E-03
     +,   1.8581429E-03,   1.8998814E-03,   1.9402376E-03
     +,   1.9791669E-03,   2.0166375E-03,   2.0526301E-03
     +,   2.0871416E-03,   2.1201782E-03,   2.1517626E-03
     +,   2.1819281E-03,   2.2107200E-03,   2.2381945E-03
     +,   2.2644177E-03,   2.2894645E-03,   2.3134162E-03
     +,   2.3363612E-03,   2.3583919E-03,   2.3796018E-03
     +,   2.4000881E-03,   2.4199444E-03,   2.4392640E-03
     +,   2.4581356E-03,   2.4766414E-03,   2.4948562E-03
     +,   2.5128480E-03,   2.5306726E-03,   2.5483754E-03
     +,   2.5659914E-03,   2.5835403E-03,   2.6010298E-03
     +,   2.6184535E-03,   2.6357917E-03,   2.6530111E-03
     +,   2.6700646E-03,   2.6868924E-03,   2.7034243E-03
     +,   2.7195769E-03,   2.7352599E-03,   2.7503732E-03
     +,   2.7648113E-03,   2.7784621E-03,   2.7912129E-03
     +,   2.8029473E-03,   2.8135525E-03,   2.8229163E-03
     +,   2.8309321E-03,   2.8375008E-03,   2.8425315E-03
     +,   2.8459425E-03,   2.8476662E-03,   2.8476475E-03
     +,   2.8458459E-03,   2.8422379E-03,   2.8368169E-03
     +,   2.8295950E-03,   2.8205991E-03,   2.8098796E-03
     +,   2.7975023E-03,   2.7835511E-03,   2.7681300E-03
     +,   2.7513590E-03,   2.7333738E-03,   2.7143238E-03
     +,   2.6943751E-03,   2.6737018E-03,   2.6524912E-03
     +,   2.6309351E-03,   2.6092341E-03,   2.5875897E-03
     +,   2.5662072E-03,   2.5452867E-03,   2.5250304E-03
     +,   2.5056310E-03,   2.4872744E-03,   2.4701394E-03
     +,   2.4543963E-03,   2.4402034E-03,   2.4277107E-03
     +,   2.4170603E-03,   2.4083890E-03,   2.4018311E-03
     +,   2.3975233E-03,   2.3956115E-03,   2.3962548E-03
     +,   2.3996383E-03,   2.4059776E-03,   2.4155302E-03
     +,   2.4286059E-03,   2.4455751E-03,   2.4668782E-03
     +,   2.4930306E-03,   2.5246297E-03,   2.5623571E-03
     +,   2.6069710E-03,   2.6593076E-03,   2.7202587E-03
     +,   2.7907686E-03,   2.8717942E-03,   2.9642985E-03
     +,   3.0691975E-03,   3.1873493E-03,   3.3194923E-03
     +,   3.4662383E-03,   3.6280288E-03,   3.8050970E-03
     +,   3.9974595E-03,   4.2049200E-03,   4.4270637E-03
     +,   4.6632462E-03,   4.9126823E-03,   5.1744143E-03
     +,   5.4474417E-03,   5.7307049E-03,   6.0232342E-03
     +,   6.3241278E-03,   6.6327080E-03,   6.9484771E-03
     +,   7.2712512E-03,   7.6011210E-03,   7.9384651E-03
     +,   8.2839224E-03,   8.6383810E-03,   9.0028923E-03
     +,   9.3785608E-03,   9.7664576E-03,   1.0167571E-02
     +,   1.0582638E-02,   1.1012033E-02,   1.1455739E-02
     +,   1.1913236E-02,   1.2383427E-02,   1.2864603E-02
     +,   1.3354497E-02,   1.3850236E-02,   1.4348340E-02
     +,   1.4844819E-02,   1.5335238E-02,   1.5814766E-02
     +,   1.6278228E-02,   1.6720215E-02,   1.7135207E-02
     +,   1.7517632E-02,   1.7861938E-02,   1.8162783E-02
     +,   1.8415082E-02,   1.8614125E-02,   1.8755715E-02
     +,   1.8836301E-02,   1.8853042E-02,   1.8803935E-02
     +,   1.8687906E-02,   1.8504862E-02,   1.8255716E-02
     +,   1.7942430E-02,   1.7567974E-02,   1.7136239E-02
     +,   1.6651962E-02,   1.6120659E-02,   1.5548386E-02
     +,   1.4941616E-02,   1.4307115E-02,   1.3651716E-02
     +,   1.2982114E-02,   1.2304751E-02,   1.1625713E-02
     +,   1.0950582E-02,   1.0284302E-02,   9.6311606E-03
     +,   8.9948187E-03,   8.3782626E-03,   7.7837799E-03
     +,   7.2130677E-03,   6.6673341E-03,   6.1472706E-03
     +,   5.6531769E-03,   5.1850821E-03,   4.7427691E-03
     +,   4.3258248E-03,   3.9337175E-03,   3.5658749E-03
     +,   3.2216776E-03,   2.9004682E-03,   2.6015809E-03
     +,   2.3243672E-03,   2.0681662E-03,   1.8322837E-03
     +,   1.6160036E-03,   1.4185969E-03,   1.2392722E-03
     +,   1.0771934E-03,   9.3148823E-04,   8.0123753E-04
     +,   6.8547204E-04,   5.8319303E-04,   4.9338763E-04
     +,   4.1503229E-04,   3.4710244E-04,   2.8859169E-04
     +,   2.3852703E-04,   1.9597482E-04,   1.6004822E-04
     +,   1.2991848E-04,   1.0482225E-04,   8.4059102E-05
     +,   6.6996610E-05,   5.3070569E-05,   4.1781590E-05
     +,   3.2691805E-05,   2.5421907E-05,   1.9646866E-05
     +,   1.5090228E-05,   1.1518875E-05,   8.7383787E-06
     +,   6.5881050E-06,   4.9363061E-06,   3.6757831E-06
     +,   2.7201861E-06,   2.0005787E-06,   1.4622270E-06
     +,   1.0621118E-06,   7.6669727E-07,   5.5002027E-07
     +,   3.9212770E-07,   2.7781965E-07,   1.9560807E-07
     +,   1.3686757E-07,   9.5169284E-08,   6.5760673E-08
     +,   4.5155517E-08,   3.0812775E-08,   2.0893825E-08
     +,   1.4078682E-08,   9.4269250E-09,   6.2723737E-09
     +,   4.1470285E-09,   2.7244997E-09,   1.7786173E-09
     +,   1.1537559E-09,   7.4365286E-10,   4.7626864E-10
     +,   3.0308328E-10,   1.9164142E-10,   1.2039894E-10
     +,   7.5156145E-11,   4.6613945E-11,   2.8725503E-11
     +,   1.7587660E-11,   1.0699100E-11,   6.4665552E-12
     +,   3.8830649E-12,   2.3166317E-12,   1.3731655E-12
     +,   8.0865008E-13,   4.7310869E-13,   2.7499609E-13
     +,   1.5880469E-13,   9.1108897E-14,   5.1928558E-14
     +,   2.9404586E-14,   1.6541212E-14,   9.2443439E-15
     +,   5.1324424E-15,   2.8309016E-15,   1.5511702E-15
     +,   8.4438740E-16,   4.5661979E-16,   2.4530879E-16
     +,   1.3091725E-16,   6.9409963E-17,   3.6557687E-17
     +,   1.9127409E-17,   9.9419194E-18,   5.1333840E-18
     +,   2.6331233E-18,   1.3416979E-18,   6.7915659E-19
     +,   3.4150521E-19,   1.7059094E-19,   8.4649599E-20
     +,   4.1727898E-20,   2.0433057E-20,   9.9396155E-21
     +,   4.8029855E-21,   2.3055838E-21
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_haonly_htt115_mass = Yx/0.278383875
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_haonly_htt120_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.1022436E-05,   1.2784190E-05
     +,   1.4790279E-05,   1.7068196E-05,   1.9647532E-05
     +,   2.2559967E-05,   2.5839281E-05,   2.9521269E-05
     +,   3.3643624E-05,   3.8246111E-05,   4.3370044E-05
     +,   4.9058286E-05,   5.5355067E-05,   6.2305728E-05
     +,   6.9956324E-05,   7.8353471E-05,   8.7543820E-05
     +,   9.7573815E-05,   1.0848926E-04,   1.2033482E-04
     +,   1.3315366E-04,   1.4698708E-04,   1.6187369E-04
     +,   1.7785045E-04,   1.9494936E-04,   2.1320085E-04
     +,   2.3263074E-04,   2.5326110E-04,   2.7511004E-04
     +,   2.9819179E-04,   3.2251669E-04,   3.4809118E-04
     +,   3.7491869E-04,   4.0299923E-04,   4.3233062E-04
     +,   4.6290876E-04,   4.9472862E-04,   5.2778411E-04
     +,   5.6207215E-04,   5.9758738E-04,   6.3433062E-04
     +,   6.7230419E-04,   7.1151525E-04,   7.5197633E-04
     +,   7.9370593E-04,   8.3672896E-04,   8.8107813E-04
     +,   9.2679291E-04,   9.7392075E-04,   1.0225162E-03
     +,   1.0726406E-03,   1.1243621E-03,   1.1777526E-03
     +,   1.2328922E-03,   1.2898569E-03,   1.3487304E-03
     +,   1.4095915E-03,   1.4725170E-03,   1.5375785E-03
     +,   1.6048402E-03,   1.6743558E-03,   1.7461685E-03
     +,   1.8203015E-03,   1.8967681E-03,   1.9755615E-03
     +,   2.0566471E-03,   2.1399776E-03,   2.2254700E-03
     +,   2.3130276E-03,   2.4025140E-03,   2.4937780E-03
     +,   2.5866255E-03,   2.6808477E-03,   2.7761925E-03
     +,   2.8723881E-03,   2.9691337E-03,   3.0660927E-03
     +,   3.1629016E-03,   3.2591750E-03,   3.3545028E-03
     +,   3.4484416E-03,   3.5405378E-03,   3.6303082E-03
     +,   3.7172637E-03,   3.8008946E-03,   3.8806910E-03
     +,   3.9561326E-03,   4.0267105E-03,   4.0919152E-03
     +,   4.1512605E-03,   4.2042825E-03,   4.2505409E-03
     +,   4.2896364E-03,   4.3212161E-03,   4.3449784E-03
     +,   4.3606777E-03,   4.3681371E-03,   4.3672477E-03
     +,   4.3579736E-03,   4.3403590E-03,   4.3145241E-03
     +,   4.2806710E-03,   4.2390758E-03,   4.1900906E-03
     +,   4.1341390E-03,   4.0717069E-03,   4.0033418E-03
     +,   3.9296453E-03,   3.8512584E-03,   3.7688583E-03
     +,   3.6831601E-03,   3.5948902E-03,   3.5048039E-03
     +,   3.4136558E-03,   3.3222190E-03,   3.2312591E-03
     +,   3.1415562E-03,   3.0538801E-03,   2.9690128E-03
     +,   2.8877289E-03,   2.8108072E-03,   2.7390330E-03
     +,   2.6731943E-03,   2.6140746E-03,   2.5624598E-03
     +,   2.5191337E-03,   2.4848648E-03,   2.4604059E-03
     +,   2.4464782E-03,   2.4437641E-03,   2.4528916E-03
     +,   2.4744160E-03,   2.5088114E-03,   2.5564437E-03
     +,   2.6175641E-03,   2.6922920E-03,   2.7805932E-03
     +,   2.8822727E-03,   2.9969751E-03,   3.1241719E-03
     +,   3.2631552E-03,   3.4130435E-03,   3.5728063E-03
     +,   3.7412636E-03,   3.9170883E-03,   4.0988624E-03
     +,   4.2850832E-03,   4.4741831E-03,   4.6645710E-03
     +,   4.8546772E-03,   5.0429744E-03,   5.2279909E-03
     +,   5.4083685E-03,   5.5828821E-03,   5.7504573E-03
     +,   5.9101768E-03,   6.0613006E-03,   6.2032724E-03
     +,   6.3357153E-03,   6.4583961E-03,   6.5712351E-03
     +,   6.6742739E-03,   6.7676296E-03,   6.8514687E-03
     +,   6.9259871E-03,   6.9913478E-03,   7.0476588E-03
     +,   7.0949402E-03,   7.1331058E-03,   7.1619297E-03
     +,   7.1810530E-03,   7.1899751E-03,   7.1880673E-03
     +,   7.1745934E-03,   7.1487343E-03,   7.1096327E-03
     +,   7.0564272E-03,   6.9883075E-03,   6.9045564E-03
     +,   6.8045934E-03,   6.6880221E-03,   6.5546697E-03
     +,   6.4046197E-03,   6.2382128E-03,   6.0560671E-03
     +,   5.8590933E-03,   5.6484640E-03,   5.4255878E-03
     +,   5.1920796E-03,   4.9497550E-03,   4.7005373E-03
     +,   4.4464325E-03,   4.1894997E-03,   3.9317845E-03
     +,   3.6752622E-03,   3.4218084E-03,   3.1731834E-03
     +,   2.9309851E-03,   2.6966103E-03,   2.4712584E-03
     +,   2.2559352E-03,   2.0514370E-03,   1.8583407E-03
     +,   1.6770283E-03,   1.5077164E-03,   1.3504368E-03
     +,   1.2050743E-03,   1.0713947E-03,   9.4905327E-04
     +,   8.3760836E-04,   7.3654880E-04,   6.4531888E-04
     +,   5.6332513E-04,   4.8994645E-04,   4.2455419E-04
     +,   3.6652538E-04,   3.1524675E-04,   2.7011926E-04
     +,   2.3056814E-04,   1.9605018E-04,   1.6604908E-04
     +,   1.4008205E-04,   1.1770224E-04,   9.8496719E-05
     +,   8.2085593E-05,   6.8122907E-05,   5.6296125E-05
     +,   4.6323490E-05,   3.7952021E-05,   3.0956588E-05
     +,   2.5138290E-05,   2.0321893E-05,   1.6353633E-05
     +,   1.3099749E-05,   1.0444724E-05,   8.2888746E-06
     +,   6.5469353E-06,   5.1464958E-06,   4.0262908E-06
     +,   3.1347354E-06,   2.4287492E-06,   1.8725848E-06
     +,   1.4367142E-06,   1.0968710E-06,   8.3326518E-07
     +,   6.2986743E-07,   4.7375008E-07,   3.5454610E-07
     +,   2.6400247E-07,   1.9559523E-07,   1.4418292E-07
     +,   1.0574635E-07,   7.7163619E-08,   5.6021673E-08
     +,   4.0465796E-08,   2.9080432E-08,   2.0791951E-08
     +,   1.4790200E-08,   1.0467207E-08,   7.3698239E-09
     +,   5.1624696E-09,   3.5977752E-09,   2.4944884E-09
     +,   1.7206488E-09,   1.1808003E-09,   8.0617052E-10
     +,   5.4756860E-10,   3.7001135E-10,   2.4874885E-10
     +,   1.6636871E-10,   1.1069777E-10,   7.3277252E-11
     +,   4.8257880E-11,   3.1617611E-11,   2.0608458E-11
     +,   1.3363768E-11,   8.6211940E-12,   5.5331603E-12
     +,   3.5329198E-12,   2.2441944E-12,   1.4182133E-12
     +,   8.9163957E-13,   5.5768693E-13,   3.4702352E-13
     +,   2.1482287E-13,   1.3230263E-13,   8.1061771E-14
     +,   4.9410213E-14,   2.9962994E-14,   1.8076142E-14
     +,   1.0849049E-14,   6.4778657E-15,   3.8480220E-15
     +,   2.2740332E-15,   1.3369739E-15,   7.8198796E-16
     +,   4.5503600E-16,   2.6341624E-16,   1.5170717E-16
     +,   8.6920721E-17,   4.9545657E-17
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_haonly_htt120_mass = Yx/0.149181789473684
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_haonly_htt60_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  8.3545462E-04,   8.9774141E-04
     +,   9.6330798E-04,   1.0322342E-03,   1.1046089E-03
     +,   1.1805337E-03,   1.2601285E-03,   1.3435390E-03
     +,   1.4309414E-03,   1.5225552E-03,   1.6186445E-03
     +,   1.7195262E-03,   1.8255798E-03,   1.9372498E-03
     +,   2.0550489E-03,   2.1795591E-03,   2.3114295E-03
     +,   2.4513686E-03,   2.6001362E-03,   2.7585248E-03
     +,   2.9273424E-03,   3.1073855E-03,   3.2994081E-03
     +,   3.5041026E-03,   3.7220302E-03,   3.9536254E-03
     +,   4.1991272E-03,   4.4585550E-03,   4.7316747E-03
     +,   5.0179753E-03,   5.3166570E-03,   5.6266137E-03
     +,   5.9464579E-03,   6.2745223E-03,   6.6089132E-03
     +,   6.9475495E-03,   7.2882273E-03,   7.6286946E-03
     +,   7.9667475E-03,   8.3002718E-03,   8.6273858E-03
     +,   8.9464746E-03,   9.2562828E-03,   9.5559629E-03
     +,   9.8451115E-03,   1.0123781E-02,   1.0392481E-02
     +,   1.0652131E-02,   1.0904013E-02,   1.1149693E-02
     +,   1.1390940E-02,   1.1629614E-02,   1.1867576E-02
     +,   1.2106613E-02,   1.2348316E-02,   1.2594085E-02
     +,   1.2845031E-02,   1.3102006E-02,   1.3365599E-02
     +,   1.3636159E-02,   1.3913833E-02,   1.4198599E-02
     +,   1.4490259E-02,   1.4788463E-02,   1.5092641E-02
     +,   1.5401899E-02,   1.5714949E-02,   1.6029932E-02
     +,   1.6344292E-02,   1.6654624E-02,   1.6956616E-02
     +,   1.7245015E-02,   1.7513741E-02,   1.7756049E-02
     +,   1.7964909E-02,   1.8133422E-02,   1.8255338E-02
     +,   1.8325681E-02,   1.8341340E-02,   1.8301615E-02
     +,   1.8208645E-02,   1.8067697E-02,   1.7887220E-02
     +,   1.7678656E-02,   1.7456025E-02,   1.7235257E-02
     +,   1.7033372E-02,   1.6867435E-02,   1.6753560E-02
     +,   1.6705843E-02,   1.6735412E-02,   1.6849671E-02
     +,   1.7051723E-02,   1.7340153E-02,   1.7709000E-02
     +,   1.8148093E-02,   1.8643703E-02,   1.9179218E-02
     +,   1.9736268E-02,   2.0295605E-02,   2.0838313E-02
     +,   2.1346588E-02,   2.1804724E-02,   2.2199571E-02
     +,   2.2521043E-02,   2.2762213E-02,   2.2919230E-02
     +,   2.2991117E-02,   2.2979366E-02,   2.2887463E-02
     +,   2.2720402E-02,   2.2484217E-02,   2.2185609E-02
     +,   2.1831548E-02,   2.1429144E-02,   2.0985393E-02
     +,   2.0507213E-02,   2.0001302E-02,   1.9474296E-02
     +,   1.8932626E-02,   1.8382603E-02,   1.7830402E-02
     +,   1.7282020E-02,   1.6743110E-02,   1.6218968E-02
     +,   1.5714433E-02,   1.5233660E-02,   1.4780104E-02
     +,   1.4356299E-02,   1.3963862E-02,   1.3603310E-02
     +,   1.3274134E-02,   1.2974697E-02,   1.2702377E-02
     +,   1.2453595E-02,   1.2224007E-02,   1.2008709E-02
     +,   1.1802453E-02,   1.1599895E-02,   1.1395881E-02
     +,   1.1185724E-02,   1.0965417E-02,   1.0731815E-02
     +,   1.0482804E-02,   1.0217381E-02,   9.9356333E-03
     +,   9.6387099E-03,   9.3287183E-03,   9.0085566E-03
     +,   8.6816885E-03,   8.3519528E-03,   8.0233710E-03
     +,   7.6999036E-03,   7.3852446E-03,   7.0826868E-03
     +,   6.7950101E-03,   6.5243887E-03,   6.2723183E-03
     +,   6.0396371E-03,   5.8265761E-03,   5.6327521E-03
     +,   5.4572821E-03,   5.2988720E-03,   5.1558968E-03
     +,   5.0264853E-03,   4.9086334E-03,   4.8002880E-03
     +,   4.6994127E-03,   4.6040574E-03,   4.5124022E-03
     +,   4.4228178E-03,   4.3338765E-03,   4.2443713E-03
     +,   4.1533243E-03,   4.0599946E-03,   3.9638551E-03
     +,   3.8645805E-03,   3.7620459E-03,   3.6562877E-03
     +,   3.5474806E-03,   3.4359167E-03,   3.3219906E-03
     +,   3.2061669E-03,   3.0889511E-03,   2.9708785E-03
     +,   2.8525009E-03,   2.7343656E-03,   2.6169939E-03
     +,   2.5008759E-03,   2.3864778E-03,   2.2742087E-03
     +,   2.1644314E-03,   2.0574655E-03,   1.9535802E-03
     +,   1.8529881E-03,   1.7558552E-03,   1.6623080E-03
     +,   1.5724327E-03,   1.4862712E-03,   1.4038328E-03
     +,   1.3251029E-03,   1.2500413E-03,   1.1785813E-03
     +,   1.1106394E-03,   1.0461236E-03,   9.8492508E-04
     +,   9.2692621E-04,   8.7200740E-04,   8.2004484E-04
     +,   7.7090896E-04,   7.2446995E-04,   6.8060181E-04
     +,   6.3917978E-04,   6.0007913E-04,   5.6317833E-04
     +,   5.2836235E-04,   4.9552007E-04,   4.6454257E-04
     +,   4.3532604E-04,   4.0777426E-04,   3.8179287E-04
     +,   3.5729309E-04,   3.3419224E-04,   3.1241236E-04
     +,   2.9187891E-04,   2.7252175E-04,   2.5427653E-04
     +,   2.3708287E-04,   2.2088314E-04,   2.0562352E-04
     +,   1.9125461E-04,   1.7773028E-04,   1.6500619E-04
     +,   1.5304101E-04,   1.4179701E-04,   1.3123754E-04
     +,   1.2132808E-04,   1.1203661E-04,   1.0333279E-04
     +,   9.5187068E-05,   8.7571447E-05,   8.0459627E-05
     +,   7.3826297E-05,   6.7646783E-05,   6.1897328E-05
     +,   5.6555462E-05,   5.1599494E-05,   4.7008063E-05
     +,   4.2760646E-05,   3.8837807E-05,   3.5220364E-05
     +,   3.1889849E-05,   2.8828665E-05,   2.6019858E-05
     +,   2.3446932E-05,   2.1094098E-05,   1.8946361E-05
     +,   1.6989383E-05,   1.5209337E-05,   1.3593105E-05
     +,   1.2128321E-05,   1.0803257E-05,   9.6067452E-06
     +,   8.5282763E-06,   7.5580588E-06,   6.6868251E-06
     +,   5.9059012E-06,   5.2072646E-06,   4.5834208E-06
     +,   4.0273944E-06,   3.5327216E-06,   3.0934723E-06
     +,   2.7041806E-06,   2.3597997E-06,   2.0557081E-06
     +,   1.7877145E-06,   1.5519601E-06,   1.3449701E-06
     +,   1.1635607E-06,   1.0048797E-06,   8.6632872E-07
     +,   7.4558909E-07,   6.4055939E-07,   5.4937243E-07
     +,   4.7034536E-07,   4.0198890E-07,   3.4296966E-07
     +,   2.9210537E-07,   2.4835347E-07,   2.1078637E-07
     +,   1.7859185E-07,   1.5105050E-07,   1.2753500E-07
     +,   1.0749240E-07,   9.0442420E-08,   7.5964131E-08
     +,   6.3692951E-08,   5.3310792E-08,   4.4543555E-08
     +,   3.7153214E-08,   3.0935265E-08
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_haonly_htt60_mass = Yx/0.491691
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_haonly_htt65_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.1121425E-03,   2.1647976E-03
     +,   2.2161948E-03,   2.2665393E-03,   2.3161182E-03
     +,   2.3653035E-03,   2.4145592E-03,   2.4644432E-03
     +,   2.5156066E-03,   2.5688005E-03,   2.6248652E-03
     +,   2.6847280E-03,   2.7493967E-03,   2.8199451E-03
     +,   2.8975015E-03,   2.9832253E-03,   3.0782924E-03
     +,   3.1838645E-03,   3.3010654E-03,   3.4309467E-03
     +,   3.5744614E-03,   3.7324252E-03,   3.9054833E-03
     +,   4.0940926E-03,   4.2984569E-03,   4.5185429E-03
     +,   4.7540232E-03,   5.0042733E-03,   5.2683577E-03
     +,   5.5450243E-03,   5.8327164E-03,   6.1295745E-03
     +,   6.4334688E-03,   6.7420173E-03,   7.0526451E-03
     +,   7.3626069E-03,   7.6690582E-03,   7.9691010E-03
     +,   8.2598720E-03,   8.5385526E-03,   8.8024996E-03
     +,   9.0492638E-03,   9.2766639E-03,   9.4828475E-03
     +,   9.6663339E-03,   9.8260734E-03,   9.9614607E-03
     +,   1.0072390E-02,   1.0159251E-02,   1.0222957E-02
     +,   1.0264927E-02,   1.0287086E-02,   1.0291834E-02
     +,   1.0282017E-02,   1.0260874E-02,   1.0231987E-02
     +,   1.0199187E-02,   1.0166497E-02,   1.0138028E-02
     +,   1.0117865E-02,   1.0109970E-02,   1.0118059E-02
     +,   1.0145481E-02,   1.0195115E-02,   1.0269248E-02
     +,   1.0369484E-02,   1.0496677E-02,   1.0650839E-02
     +,   1.0831167E-02,   1.1035983E-02,   1.1262835E-02
     +,   1.1508510E-02,   1.1769217E-02,   1.2040677E-02
     +,   1.2318371E-02,   1.2597735E-02,   1.2874389E-02
     +,   1.3144393E-02,   1.3404536E-02,   1.3652558E-02
     +,   1.3887321E-02,   1.4109036E-02,   1.4319324E-02
     +,   1.4521294E-02,   1.4719467E-02,   1.4919705E-02
     +,   1.5128965E-02,   1.5355093E-02,   1.5606447E-02
     +,   1.5891569E-02,   1.6218754E-02,   1.6595634E-02
     +,   1.7028732E-02,   1.7523138E-02,   1.8082084E-02
     +,   1.8706547E-02,   1.9395148E-02,   2.0143745E-02
     +,   2.0945629E-02,   2.1791229E-02,   2.2668622E-02
     +,   2.3563661E-02,   2.4460623E-02,   2.5342735E-02
     +,   2.6193123E-02,   2.6995538E-02,   2.7735138E-02
     +,   2.8399263E-02,   2.8977955E-02,   2.9464252E-02
     +,   2.9854083E-02,   3.0146092E-02,   3.0340984E-02
     +,   3.0440977E-02,   3.0448876E-02,   3.0367561E-02
     +,   3.0199418E-02,   2.9946107E-02,   2.9608712E-02
     +,   2.9187992E-02,   2.8685052E-02,   2.8102044E-02
     +,   2.7442861E-02,   2.6713692E-02,   2.5923343E-02
     +,   2.5083384E-02,   2.4207631E-02,   2.3311768E-02
     +,   2.2412293E-02,   2.1525744E-02,   2.0667505E-02
     +,   1.9851176E-02,   1.9087616E-02,   1.8384740E-02
     +,   1.7747192E-02,   1.7176513E-02,   1.6671520E-02
     +,   1.6228747E-02,   1.5842983E-02,   1.5507927E-02
     +,   1.5216731E-02,   1.4962440E-02,   1.4738338E-02
     +,   1.4538147E-02,   1.4356208E-02,   1.4187410E-02
     +,   1.4027194E-02,   1.3871478E-02,   1.3716537E-02
     +,   1.3558934E-02,   1.3395459E-02,   1.3223116E-02
     +,   1.3039132E-02,   1.2840954E-02,   1.2626336E-02
     +,   1.2393404E-02,   1.2140700E-02,   1.1867227E-02
     +,   1.1572517E-02,   1.1256658E-02,   1.0920255E-02
     +,   1.0564432E-02,   1.0190830E-02,   9.8015117E-03
     +,   9.3988888E-03,   8.9856526E-03,   8.5647237E-03
     +,   8.1391390E-03,   7.7119446E-03,   7.2861398E-03
     +,   6.8646292E-03,   6.4501469E-03,   6.0451557E-03
     +,   5.6518493E-03,   5.2721575E-03,   4.9076527E-03
     +,   4.5595756E-03,   4.2288755E-03,   3.9161853E-03
     +,   3.6218304E-03,   3.3458723E-03,   3.0881604E-03
     +,   2.8483388E-03,   2.6258721E-03,   2.4200899E-03
     +,   2.2302354E-03,   2.0554764E-03,   1.8949228E-03
     +,   1.7476619E-03,   1.6127916E-03,   1.4894061E-03
     +,   1.3766246E-03,   1.2736069E-03,   1.1795504E-03
     +,   1.0936899E-03,   1.0153073E-03,   9.4373559E-04
     +,   8.7835389E-04,   8.1858167E-04,   7.6388341E-04
     +,   7.1376847E-04,   6.6778605E-04,   6.2551961E-04
     +,   5.8658927E-04,   5.5065256E-04,   5.1739544E-04
     +,   4.8653423E-04,   4.5781620E-04,   4.3101501E-04
     +,   4.0592789E-04,   3.8237547E-04,   3.6020236E-04
     +,   3.3927261E-04,   3.1946765E-04,   3.0068570E-04
     +,   2.8284112E-04,   2.6586172E-04,   2.4968584E-04
     +,   2.3426213E-04,   2.1954942E-04,   2.0551230E-04
     +,   1.9212162E-04,   1.7935388E-04,   1.6718931E-04
     +,   1.5561025E-04,   1.4460128E-04,   1.3414898E-04
     +,   1.2424083E-04,   1.1486393E-04,   1.0600549E-04
     +,   9.7653035E-05,   8.9793539E-05,   8.2412895E-05
     +,   7.5496362E-05,   6.9029156E-05,   6.2995176E-05
     +,   5.7377743E-05,   5.2160056E-05,   4.7324775E-05
     +,   4.2853895E-05,   3.8729271E-05,   3.4932935E-05
     +,   3.1446838E-05,   2.8252833E-05,   2.5333051E-05
     +,   2.2670127E-05,   2.0247064E-05,   1.8047192E-05
     +,   1.6054413E-05,   1.4253435E-05,   1.2629400E-05
     +,   1.1168166E-05,   9.8564042E-06,   8.6814944E-06
     +,   7.6314600E-06,   6.6950874E-06,   5.8619430E-06
     +,   5.1223137E-06,   4.4671151E-06,   3.8879757E-06
     +,   3.3771973E-06,   2.9277112E-06,   2.5330100E-06
     +,   2.1871583E-06,   1.8847861E-06,   1.6209926E-06
     +,   1.3913436E-06,   1.1918577E-06,   1.0189517E-06
     +,   8.6939963E-07,   7.4032033E-07,   6.2915342E-07
     +,   5.3362032E-07,   4.5169472E-07,   3.8158555E-07
     +,   3.2171997E-07,   2.7070621E-07,   2.2733062E-07
     +,   1.9052483E-07,   1.5936186E-07,   1.3303061E-07
     +,   1.1083018E-07,   9.2150678E-08,   7.6467678E-08
     +,   6.3327469E-08,   5.2341392E-08,   4.3175287E-08
     +,   3.5543415E-08,   2.9202663E-08,   2.3945267E-08
     +,   1.9595497E-08,   1.6003936E-08,   1.3044803E-08
     +,   1.0611613E-08,   8.6151930E-09,   6.9804362E-09
     +,   5.6446812E-09,   4.5554360E-09,   3.6691084E-09
     +,   2.9493390E-09,   2.3660756E-09
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_haonly_htt65_mass = Yx/0.565494517241379
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_haonly_htt70_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  7.4711139E-04,   8.2236412E-04
     +,   9.0401835E-04,   9.9246681E-04,   1.0880971E-03
     +,   1.1912836E-03,   1.3023799E-03,   1.4217079E-03
     +,   1.5495475E-03,   1.6861308E-03,   1.8316206E-03
     +,   1.9861048E-03,   2.1495821E-03,   2.3219523E-03
     +,   2.5030037E-03,   2.6924028E-03,   2.8896902E-03
     +,   3.0942708E-03,   3.3054140E-03,   3.5222496E-03
     +,   3.7437761E-03,   3.9688610E-03,   4.1962531E-03
     +,   4.4246088E-03,   4.6524731E-03,   4.8783463E-03
     +,   5.1006721E-03,   5.3178729E-03,   5.5283848E-03
     +,   5.7306774E-03,   5.9232912E-03,   6.1048619E-03
     +,   6.2741591E-03,   6.4301137E-03,   6.5718568E-03
     +,   6.6987341E-03,   6.8103583E-03,   6.9066114E-03
     +,   6.9877002E-03,   7.0541431E-03,   7.1068183E-03
     +,   7.1469643E-03,   7.1761841E-03,   7.1964520E-03
     +,   7.2101005E-03,   7.2198058E-03,   7.2285472E-03
     +,   7.2395806E-03,   7.2563738E-03,   7.2825411E-03
     +,   7.3217759E-03,   7.3777572E-03,   7.4540675E-03
     +,   7.5541055E-03,   7.6809875E-03,   7.8374911E-03
     +,   8.0259740E-03,   8.2483524E-03,   8.5060718E-03
     +,   8.8001210E-03,   9.1310805E-03,   9.4991913E-03
     +,   9.9044126E-03,   1.0346591E-02,   1.0825532E-02
     +,   1.1341070E-02,   1.1893236E-02,   1.2482191E-02
     +,   1.3108336E-02,   1.3772133E-02,   1.4474100E-02
     +,   1.5214496E-02,   1.5993239E-02,   1.6809467E-02
     +,   1.7661437E-02,   1.8546179E-02,   1.9459216E-02
     +,   2.0394409E-02,   2.1343956E-02,   2.2298235E-02
     +,   2.3245789E-02,   2.4173643E-02,   2.5067259E-02
     +,   2.5911035E-02,   2.6688503E-02,   2.7382964E-02
     +,   2.7977942E-02,   2.8458053E-02,   2.8809670E-02
     +,   2.9021934E-02,   2.9087560E-02,   2.9003656E-02
     +,   2.8772350E-02,   2.8401131E-02,   2.7902804E-02
     +,   2.7295174E-02,   2.6600089E-02,   2.5842452E-02
     +,   2.5048731E-02,   2.4245584E-02,   2.3458272E-02
     +,   2.2709653E-02,   2.2018990E-02,   2.1401599E-02
     +,   2.0868458E-02,   2.0426430E-02,   2.0078639E-02
     +,   1.9824948E-02,   1.9662507E-02,   1.9586353E-02
     +,   1.9589808E-02,   1.9664828E-02,   1.9802211E-02
     +,   1.9991810E-02,   2.0222588E-02,   2.0482905E-02
     +,   2.0760635E-02,   2.1043565E-02,   2.1319780E-02
     +,   2.1578083E-02,   2.1808557E-02,   2.2002991E-02
     +,   2.2155352E-02,   2.2262175E-02,   2.2322742E-02
     +,   2.2339216E-02,   2.2316512E-02,   2.2262160E-02
     +,   2.2185769E-02,   2.2098511E-02,   2.2012368E-02
     +,   2.1939293E-02,   2.1890305E-02,   2.1874620E-02
     +,   2.1898728E-02,   2.1965781E-02,   2.2075042E-02
     +,   2.2221616E-02,   2.2396524E-02,   2.2587027E-02
     +,   2.2777217E-02,   2.2948952E-02,   2.3082843E-02
     +,   2.3159474E-02,   2.3160513E-02,   2.3069883E-02
     +,   2.2874637E-02,   2.2565741E-02,   2.2138549E-02
     +,   2.1592893E-02,   2.0933021E-02,   2.0167276E-02
     +,   1.9307500E-02,   1.8368209E-02,   1.7365830E-02
     +,   1.6317934E-02,   1.5242327E-02,   1.4156255E-02
     +,   1.3075838E-02,   1.2015671E-02,   1.0988274E-02
     +,   1.0004003E-02,   9.0710204E-03,   8.1952680E-03
     +,   7.3805419E-03,   6.6287578E-03,   5.9402357E-03
     +,   5.3139082E-03,   4.7475654E-03,   4.2381687E-03
     +,   3.7821296E-03,   3.3754897E-03,   3.0140921E-03
     +,   2.6937716E-03,   2.4105024E-03,   2.1604234E-03
     +,   1.9399384E-03,   1.7457615E-03,   1.5749101E-03
     +,   1.4246978E-03,   1.2927313E-03,   1.1768962E-03
     +,   1.0753177E-03,   9.8632975E-04,   9.0845401E-04
     +,   8.4037893E-04,   7.8093039E-04,   7.2905095E-04
     +,   6.8378868E-04,   6.4428832E-04,   6.0977309E-04
     +,   5.7954289E-04,   5.5296923E-04,   5.2948901E-04
     +,   5.0859887E-04,   4.8985396E-04,   4.7286530E-04
     +,   4.5729510E-04,   4.4285209E-04,   4.2928915E-04
     +,   4.1640055E-04,   4.0401661E-04,   3.9199955E-04
     +,   3.8024009E-04,   3.6865546E-04,   3.5718316E-04
     +,   3.4577894E-04,   3.3441506E-04,   3.2307633E-04
     +,   3.1175694E-04,   3.0045965E-04,   2.8919414E-04
     +,   2.7797511E-04,   2.6681970E-04,   2.5574770E-04
     +,   2.4478088E-04,   2.3394173E-04,   2.2325205E-04
     +,   2.1273308E-04,   2.0240637E-04,   1.9229118E-04
     +,   1.8240533E-04,   1.7276585E-04,   1.6338791E-04
     +,   1.5428443E-04,   1.4546642E-04,   1.3694375E-04
     +,   1.2872448E-04,   1.2081428E-04,   1.1321725E-04
     +,   1.0593630E-04,   9.8972785E-05,   9.2326118E-05
     +,   8.5994368E-05,   7.9974983E-05,   7.4263597E-05
     +,   6.8854832E-05,   6.3742686E-05,   5.8920330E-05
     +,   5.4379780E-05,   5.0112532E-05,   4.6109730E-05
     +,   4.2362131E-05,   3.8859805E-05,   3.5592606E-05
     +,   3.2550415E-05,   2.9722965E-05,   2.7099761E-05
     +,   2.4670326E-05,   2.2424530E-05,   2.0352110E-05
     +,   1.8443008E-05,   1.6687512E-05,   1.5076153E-05
     +,   1.3599629E-05,   1.2248976E-05,   1.1015642E-05
     +,   9.8914325E-06,   8.8684183E-06,   7.9390593E-06
     +,   7.0962633E-06,   6.3332932E-06,   5.6437389E-06
     +,   5.0215799E-06,   4.4612111E-06,   3.9573383E-06
     +,   3.5050093E-06,   3.0996521E-06,   2.7370070E-06
     +,   2.4131079E-06,   2.1242877E-06,   1.8671842E-06
     +,   1.6387052E-06,   1.4359920E-06,   1.2564311E-06
     +,   1.0976526E-06,   9.5747396E-07,   8.3392791E-07
     +,   7.2521317E-07,   6.2971270E-07,   5.4595250E-07
     +,   4.7261435E-07,   4.0850216E-07,   3.5255079E-07
     +,   3.0379761E-07,   2.6138852E-07,   2.2455711E-07
     +,   1.9262042E-07,   1.6497481E-07,   1.4108090E-07
     +,   1.2046442E-07,   1.0270325E-07,   8.7427949E-08
     +,   7.4310670E-08,   6.3065563E-08,   5.3440214E-08
     +,   4.5215192E-08,   3.8197577E-08,   3.2220107E-08
     +,   2.7136476E-08,   2.2820236E-08
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_haonly_htt70_mass = Yx/0.58643875862069
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_haonly_htt75_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  7.9874898E-04,   8.3647255E-04
     +,   8.7637297E-04,   9.1852248E-04,   9.6298859E-04
     +,   1.0098324E-03,   1.0591093E-03,   1.1108665E-03
     +,   1.1651411E-03,   1.2219640E-03,   1.2813522E-03
     +,   1.3433120E-03,   1.4078370E-03,   1.4749077E-03
     +,   1.5444901E-03,   1.6165358E-03,   1.6909799E-03
     +,   1.7677434E-03,   1.8467314E-03,   1.9278330E-03
     +,   2.0109231E-03,   2.0958628E-03,   2.1824974E-03
     +,   2.2706683E-03,   2.3601968E-03,   2.4509067E-03
     +,   2.5426124E-03,   2.6351269E-03,   2.7282671E-03
     +,   2.8218529E-03,   2.9157170E-03,   3.0097058E-03
     +,   3.1036844E-03,   3.1975410E-03,   3.2911939E-03
     +,   3.3845950E-03,   3.4777350E-03,   3.5706458E-03
     +,   3.6634121E-03,   3.7561581E-03,   3.8490733E-03
     +,   3.9423918E-03,   4.0364056E-03,   4.1314554E-03
     +,   4.2279307E-03,   4.3262625E-03,   4.4269105E-03
     +,   4.5303600E-03,   4.6370947E-03,   4.7475914E-03
     +,   4.8622978E-03,   4.9816030E-03,   5.1058237E-03
     +,   5.2351858E-03,   5.3697769E-03,   5.5095591E-03
     +,   5.6543220E-03,   5.8036912E-03,   5.9571089E-03
     +,   6.1138459E-03,   6.2730135E-03,   6.4335875E-03
     +,   6.5944376E-03,   6.7544025E-03,   6.9123362E-03
     +,   7.0671835E-03,   7.2180880E-03,   7.3644654E-03
     +,   7.5061340E-03,   7.6433956E-03,   7.7771596E-03
     +,   7.9090204E-03,   8.0413586E-03,   8.1773791E-03
     +,   8.3211707E-03,   8.4777055E-03,   8.6527849E-03
     +,   8.8529736E-03,   9.0854689E-03,   9.3579264E-03
     +,   9.6781692E-03,   1.0053935E-02,   1.0492447E-02
     +,   1.1000078E-02,   1.1581771E-02,   1.2240697E-02
     +,   1.2977597E-02,   1.3790510E-02,   1.4674170E-02
     +,   1.5619912E-02,   1.6615409E-02,   1.7644694E-02
     +,   1.8688414E-02,   1.9724431E-02,   2.0728435E-02
     +,   2.1674823E-02,   2.2538036E-02,   2.3293596E-02
     +,   2.3919636E-02,   2.4397992E-02,   2.4715520E-02
     +,   2.4864936E-02,   2.4845470E-02,   2.4663167E-02
     +,   2.4330670E-02,   2.3866773E-02,   2.3295416E-02
     +,   2.2644557E-02,   2.1944618E-02,   2.1226864E-02
     +,   2.0521967E-02,   1.9858211E-02,   1.9260414E-02
     +,   1.8748600E-02,   1.8337416E-02,   1.8035579E-02
     +,   1.7845912E-02,   1.7765511E-02,   1.7786389E-02
     +,   1.7896244E-02,   1.8079473E-02,   1.8318281E-02
     +,   1.8593796E-02,   1.8887259E-02,   1.9181024E-02
     +,   1.9459417E-02,   1.9709485E-02,   1.9921416E-02
     +,   2.0088820E-02,   2.0208653E-02,   2.0281009E-02
     +,   2.0308712E-02,   2.0296691E-02,   2.0251334E-02
     +,   2.0179795E-02,   2.0089291E-02,   1.9986531E-02
     +,   1.9877233E-02,   1.9765753E-02,   1.9654980E-02
     +,   1.9546269E-02,   1.9439600E-02,   1.9333778E-02
     +,   1.9226784E-02,   1.9116081E-02,   1.8998995E-02
     +,   1.8872982E-02,   1.8735899E-02,   1.8586159E-02
     +,   1.8422833E-02,   1.8245582E-02,   1.8054692E-02
     +,   1.7850868E-02,   1.7635122E-02,   1.7408591E-02
     +,   1.7172426E-02,   1.6927646E-02,   1.6675031E-02
     +,   1.6415153E-02,   1.6148355E-02,   1.5874790E-02
     +,   1.5594523E-02,   1.5307616E-02,   1.5014261E-02
     +,   1.4714795E-02,   1.4409817E-02,   1.4100205E-02
     +,   1.3787131E-02,   1.3471943E-02,   1.3156162E-02
     +,   1.2841362E-02,   1.2529065E-02,   1.2220579E-02
     +,   1.1916919E-02,   1.1618754E-02,   1.1326265E-02
     +,   1.1039159E-02,   1.0756705E-02,   1.0477715E-02
     +,   1.0200633E-02,   9.9236425E-03,   9.6447850E-03
     +,   9.3620829E-03,   9.0736421E-03,   8.7777749E-03
     +,   8.4731560E-03,   8.1588477E-03,   7.8343665E-03
     +,   7.4997256E-03,   7.1554701E-03,   6.8026027E-03
     +,   6.4425636E-03,   6.0771992E-03,   5.7086637E-03
     +,   5.3393082E-03,   4.9716183E-03,   4.6081473E-03
     +,   4.2514084E-03,   3.9037748E-03,   3.5674355E-03
     +,   3.2443656E-03,   2.9362603E-03,   2.6444865E-03
     +,   2.3700930E-03,   2.1138326E-03,   1.8761161E-03
     +,   1.6570605E-03,   1.4565270E-03,   1.2741333E-03
     +,   1.1092776E-03,   9.6118980E-04,   8.2897558E-04
     +,   7.1163889E-04,   6.0810865E-04,   5.1727949E-04
     +,   4.3804201E-04,   3.6929821E-04,   3.0997687E-04
     +,   2.5905453E-04,   2.1557065E-04,   1.7862521E-04
     +,   1.4738987E-04,   1.2111160E-04,   9.9110017E-05
     +,   8.0774880E-05,   6.5565189E-05,   5.3005893E-05
     +,   4.2681790E-05,   3.4232173E-05,   2.7346570E-05
     +,   2.1759841E-05,   1.7246399E-05,   1.3615328E-05
     +,   1.0706307E-05,   8.3856376E-06,   6.5419599E-06
     +,   5.0832841E-06,   3.9340507E-06,   3.0324063E-06
     +,   2.3279358E-06,   1.7798116E-06,   1.3551452E-06
     +,   1.0275320E-06,   7.7585918E-07,   5.8334871E-07
     +,   4.3673563E-07,   3.2556798E-07,   2.4164405E-07
     +,   1.7856713E-07,   1.3137384E-07,   9.6222770E-08
     +,   7.0159771E-08,   5.0924644E-08,   3.6794869E-08
     +,   2.6463498E-08,   1.8944723E-08,   1.3499002E-08
     +,   9.5737045E-09,   6.7578112E-09,   4.7474815E-09
     +,   3.3192951E-09,   2.3096611E-09,   1.5994016E-09
     +,   1.1021922E-09,   7.5587686E-10,   5.1585269E-10
     +,   3.5032333E-10,   2.3674449E-10,   1.5920576E-10
     +,   1.0653577E-10,   7.0938234E-11,   4.7001937E-11
     +,   3.0988861E-11,   2.0330338E-11,   1.3271721E-11
     +,   8.6212348E-12,   5.5726942E-12,   3.5845693E-12
     +,   2.2944923E-12,   1.4616736E-12,   9.2671541E-13
     +,   5.8483285E-13,   3.6741411E-13,   2.2983728E-13
     +,   1.4319733E-13,   8.8896074E-14,   5.5016694E-14
     +,   3.3969918E-14,   2.0948253E-14,   1.2920010E-14
     +,   7.9851515E-15,   4.9578418E-15,   3.1024168E-15
     +,   1.9642671E-15,   1.2640311E-15,   8.3062333E-16
     +,   5.5979158E-16,   3.8814210E-16,   2.7727684E-16
     +,   2.0393396E-16,   1.5403689E-16
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_haonly_htt75_mass = Yx/0.5350755
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_haonly_htt80_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.9853329E-03,   2.0273901E-03
     +,   2.0670546E-03,   2.1041923E-03,   2.1386824E-03
     +,   2.1704212E-03,   2.1993213E-03,   2.2253140E-03
     +,   2.2483487E-03,   2.2683954E-03,   2.2854412E-03
     +,   2.2994955E-03,   2.3105866E-03,   2.3187615E-03
     +,   2.3240882E-03,   2.3266522E-03,   2.3265579E-03
     +,   2.3239262E-03,   2.3188952E-03,   2.3116174E-03
     +,   2.3022606E-03,   2.2910053E-03,   2.2780448E-03
     +,   2.2635825E-03,   2.2478343E-03,   2.2310226E-03
     +,   2.2133815E-03,   2.1951518E-03,   2.1765833E-03
     +,   2.1579340E-03,   2.1394698E-03,   2.1214664E-03
     +,   2.1042088E-03,   2.0879919E-03,   2.0731231E-03
     +,   2.0599228E-03,   2.0487257E-03,   2.0398814E-03
     +,   2.0337580E-03,   2.0307400E-03,   2.0312320E-03
     +,   2.0356581E-03,   2.0444607E-03,   2.0581027E-03
     +,   2.0770631E-03,   2.1018374E-03,   2.1329345E-03
     +,   2.1708715E-03,   2.2161708E-03,   2.2693556E-03
     +,   2.3309414E-03,   2.4014304E-03,   2.4813041E-03
     +,   2.5710193E-03,   2.6709866E-03,   2.7815788E-03
     +,   2.9031099E-03,   3.0358271E-03,   3.1799064E-03
     +,   3.3354368E-03,   3.5024169E-03,   3.6807435E-03
     +,   3.8701913E-03,   4.0704291E-03,   4.2810044E-03
     +,   4.5013083E-03,   4.7306260E-03,   4.9680746E-03
     +,   5.2126665E-03,   5.4632514E-03,   5.7185926E-03
     +,   5.9773112E-03,   6.2379818E-03,   6.4990907E-03
     +,   6.7591285E-03,   7.0166090E-03,   7.2701024E-03
     +,   7.5183008E-03,   7.7600973E-03,   7.9946127E-03
     +,   8.2212426E-03,   8.4397430E-03,   8.6502107E-03
     +,   8.8531673E-03,   9.0494975E-03,   9.2404848E-03
     +,   9.4277244E-03,   9.6131032E-03,   9.7986627E-03
     +,   9.9865282E-03,   1.0178776E-02,   1.0377275E-02
     +,   1.0583580E-02,   1.0798805E-02,   1.1023503E-02
     +,   1.1257561E-02,   1.1500205E-02,   1.1749919E-02
     +,   1.2004559E-02,   1.2261382E-02,   1.2517231E-02
     +,   1.2768677E-02,   1.3012314E-02,   1.3244949E-02
     +,   1.3463953E-02,   1.3667522E-02,   1.3854958E-02
     +,   1.4026904E-02,   1.4185566E-02,   1.4334796E-02
     +,   1.4480082E-02,   1.4628479E-02,   1.4788317E-02
     +,   1.4968838E-02,   1.5179682E-02,   1.5430282E-02
     +,   1.5729131E-02,   1.6083136E-02,   1.6496863E-02
     +,   1.6972015E-02,   1.7507030E-02,   1.8096779E-02
     +,   1.8732706E-02,   1.9403197E-02,   2.0094145E-02
     +,   2.0789737E-02,   2.1473631E-02,   2.2129877E-02
     +,   2.2744248E-02,   2.3304952E-02,   2.3803676E-02
     +,   2.4235837E-02,   2.4600958E-02,   2.4902262E-02
     +,   2.5146304E-02,   2.5342099E-02,   2.5500145E-02
     +,   2.5631370E-02,   2.5746103E-02,   2.5853110E-02
     +,   2.5958858E-02,   2.6067073E-02,   2.6178541E-02
     +,   2.6291147E-02,   2.6400223E-02,   2.6498998E-02
     +,   2.6579268E-02,   2.6631970E-02,   2.6647894E-02
     +,   2.6618183E-02,   2.6534855E-02,   2.6391150E-02
     +,   2.6181731E-02,   2.5902864E-02,   2.5552411E-02
     +,   2.5129884E-02,   2.4636369E-02,   2.4074404E-02
     +,   2.3447929E-02,   2.2762235E-02,   2.2023745E-02
     +,   2.1239892E-02,   2.0419080E-02,   1.9570366E-02
     +,   1.8703241E-02,   1.7827407E-02,   1.6952571E-02
     +,   1.6088136E-02,   1.5242863E-02,   1.4424696E-02
     +,   1.3640606E-02,   1.2896365E-02,   1.2196382E-02
     +,   1.1543710E-02,   1.0940080E-02,   1.0385835E-02
     +,   9.8800743E-03,   9.4208233E-03,   9.0051442E-03
     +,   8.6292997E-03,   8.2889833E-03,   7.9795308E-03
     +,   7.6960973E-03,   7.4338196E-03,   7.1880040E-03
     +,   6.9542858E-03,   6.7287236E-03,   6.5078745E-03
     +,   6.2888586E-03,   6.0694176E-03,   5.8478639E-03
     +,   5.6230803E-03,   5.3944928E-03,   5.1620044E-03
     +,   4.9259057E-03,   4.6868264E-03,   4.4456734E-03
     +,   4.2035384E-03,   3.9616302E-03,   3.7212193E-03
     +,   3.4836042E-03,   3.2500506E-03,   3.0217422E-03
     +,   2.7997675E-03,   2.5851217E-03,   2.3786481E-03
     +,   2.1810546E-03,   1.9929202E-03,   1.8146868E-03
     +,   1.6466476E-03,   1.4889687E-03,   1.3417099E-03
     +,   1.2048199E-03,   1.0781414E-03,   9.6143299E-04
     +,   8.5438800E-04,   7.5663719E-04,   6.6775468E-04
     +,   5.8727805E-04,   5.1472383E-04,   4.4958308E-04
     +,   3.9133799E-04,   3.3947348E-04,   2.9347921E-04
     +,   2.5285323E-04,   2.1711057E-04,   1.8578942E-04
     +,   1.5845084E-04,   1.3468004E-04,   1.1409016E-04
     +,   9.6323995E-05,   8.1052676E-05,   6.7974572E-05
     +,   5.6816014E-05,   4.7331068E-05,   3.9297993E-05
     +,   3.2519201E-05,   2.6819807E-05,   2.2045422E-05
     +,   1.8060193E-05,   1.4745532E-05,   1.1998613E-05
     +,   9.7304182E-06,   7.8641606E-06,   6.3340876E-06
     +,   5.0841877E-06,   4.0668692E-06,   3.2418134E-06
     +,   2.5750903E-06,   2.0383115E-06,   1.6077154E-06
     +,   1.2635578E-06,   9.8951193E-07,   7.7211166E-07
     +,   6.0028663E-07,   4.6498857E-07,   3.5885950E-07
     +,   2.7592966E-07,   2.1137367E-07,   1.6131239E-07
     +,   1.2264309E-07,   9.2890573E-08,   7.0087388E-08
     +,   5.2678782E-08,   3.9441982E-08,   2.9416839E-08
     +,   2.1854238E-08,   1.6172427E-08,   1.1920952E-08
     +,   8.7525107E-09,   6.4007177E-09,   4.6622741E-09
     +,   3.3825098E-09,   2.4442315E-09,   1.7591286E-09
     +,   1.2609842E-09,   9.0025443E-10,   6.4013000E-10
     +,   4.5332180E-10,   3.1973099E-10,   2.2459040E-10
     +,   1.5712025E-10,   1.0946954E-10,   7.5959815E-11
     +,   5.2491667E-11,   3.6126133E-11,   2.4761013E-11
     +,   1.6901491E-11,   1.1489431E-11,   7.7781991E-12
     +,   5.2441367E-12,   3.5210355E-12,   2.3543997E-12
     +,   1.5677936E-12,   1.0397033E-12,   6.8663375E-13
     +,   4.5159571E-13,   2.9578109E-13,   1.9292939E-13
     +,   1.2531960E-13,   8.1067287E-14
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_haonly_htt80_mass = Yx/0.51338325
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_haonly_htt85_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.1368918E-04,   4.1996929E-04
     +,   4.2625749E-04,   4.3255958E-04,   4.3888181E-04
     +,   4.4523110E-04,   4.5161511E-04,   4.5804185E-04
     +,   4.6452016E-04,   4.7105941E-04,   4.7766950E-04
     +,   4.8436096E-04,   4.9114501E-04,   4.9803307E-04
     +,   5.0503749E-04,   5.1217090E-04,   5.1944668E-04
     +,   5.2687846E-04,   5.3448050E-04,   5.4226746E-04
     +,   5.5025477E-04,   5.5845798E-04,   5.6689349E-04
     +,   5.7557866E-04,   5.8453047E-04,   5.9376773E-04
     +,   6.0330983E-04,   6.1317720E-04,   6.2339148E-04
     +,   6.3397625E-04,   6.4495637E-04,   6.5635919E-04
     +,   6.6821452E-04,   6.8055541E-04,   6.9341774E-04
     +,   7.0684176E-04,   7.2087208E-04,   7.3555787E-04
     +,   7.5095502E-04,   7.6712371E-04,   7.8413234E-04
     +,   8.0205553E-04,   8.2097523E-04,   8.4098149E-04
     +,   8.6217199E-04,   8.8465225E-04,   9.0853556E-04
     +,   9.3394198E-04,   9.6099911E-04,   9.8983909E-04
     +,   1.0205994E-03,   1.0534201E-03,   1.0884426E-03
     +,   1.1258093E-03,   1.1656556E-03,   1.2081165E-03
     +,   1.2533158E-03,   1.3013686E-03,   1.3523753E-03
     +,   1.4064217E-03,   1.4635748E-03,   1.5238835E-03
     +,   1.5873704E-03,   1.6540396E-03,   1.7238732E-03
     +,   1.7968242E-03,   1.8728321E-03,   1.9518086E-03
     +,   2.0336588E-03,   2.1182662E-03,   2.2055190E-03
     +,   2.2952936E-03,   2.3874876E-03,   2.4820007E-03
     +,   2.5787677E-03,   2.6777594E-03,   2.7789832E-03
     +,   2.8825020E-03,   2.9884491E-03,   3.0970294E-03
     +,   3.2085183E-03,   3.3232903E-03,   3.4417936E-03
     +,   3.5645792E-03,   3.6922698E-03,   3.8255819E-03
     +,   3.9652823E-03,   4.1122106E-03,   4.2672148E-03
     +,   4.4311699E-03,   4.6049259E-03,   4.7892742E-03
     +,   4.9849143E-03,   5.1924414E-03,   5.4122875E-03
     +,   5.6446819E-03,   5.8896597E-03,   6.1469846E-03
     +,   6.4161946E-03,   6.6965274E-03,   6.9869985E-03
     +,   7.2863298E-03,   7.5930674E-03,   7.9055214E-03
     +,   8.2218917E-03,   8.5402904E-03,   8.8587822E-03
     +,   9.1754692E-03,   9.4885649E-03,   9.7964555E-03
     +,   1.0097709E-02,   1.0391200E-02,   1.0676059E-02
     +,   1.0951777E-02,   1.1218112E-02,   1.1475162E-02
     +,   1.1723253E-02,   1.1962952E-02,   1.2194945E-02
     +,   1.2420028E-02,   1.2639025E-02,   1.2852727E-02
     +,   1.3061887E-02,   1.3267263E-02,   1.3469652E-02
     +,   1.3669977E-02,   1.3869496E-02,   1.4069901E-02
     +,   1.4273562E-02,   1.4483628E-02,   1.4704163E-02
     +,   1.4940105E-02,   1.5197193E-02,   1.5481610E-02
     +,   1.5799619E-02,   1.6156947E-02,   1.6558094E-02
     +,   1.7005652E-02,   1.7499732E-02,   1.8037602E-02
     +,   1.8613707E-02,   1.9220399E-02,   1.9849434E-02
     +,   2.0494254E-02,   2.1153005E-02,   2.1832293E-02
     +,   2.2550695E-02,   2.3341609E-02,   2.4254588E-02
     +,   2.5354210E-02,   2.6715867E-02,   2.8418127E-02
     +,   3.0532442E-02,   3.3110987E-02,   3.6174271E-02
     +,   3.9700169E-02,   4.3617222E-02,   4.7803976E-02
     +,   5.2094568E-02,   5.6290895E-02,   6.0181845E-02
     +,   6.3564353E-02,   6.6264719E-02,   6.8156861E-02
     +,   6.9173999E-02,   6.9312640E-02,   6.8629146E-02
     +,   6.7230754E-02,   6.5262564E-02,   6.2893078E-02
     +,   6.0299300E-02,   5.7651814E-02,   5.5099986E-02
     +,   5.2758332E-02,   5.0695572E-02,   4.8927020E-02
     +,   4.7414247E-02,   4.6072062E-02,   4.4782661E-02
     +,   4.3415111E-02,   4.1846815E-02,   3.9983034E-02
     +,   3.7770707E-02,   3.5204571E-02,   3.2325316E-02
     +,   2.9211169E-02,   2.5964446E-02,   2.2696471E-02
     +,   1.9514009E-02,   1.6508821E-02,   1.3750285E-02
     +,   1.1283172E-02,   9.1286935E-03,   7.2876508E-03
     +,   5.7450426E-03,   4.4752709E-03,   3.4468216E-03
     +,   2.6259425E-03,   1.9794093E-03,   1.4764327E-03
     +,   1.0896827E-03,   7.9562952E-04,   5.7451095E-04
     +,   4.1008121E-04,   2.8921265E-04,   2.0141879E-04
     +,   1.3844260E-04,   9.3862334E-05,   6.2739346E-05
     +,   4.1323136E-05,   2.6806840E-05,   1.7120696E-05
     +,   1.0761302E-05,   6.6546427E-06,   4.0472924E-06
     +,   2.4203498E-06,   1.4228938E-06,   8.2215280E-07
     +,   4.6680239E-07,   2.6041428E-07,   1.4272041E-07
     +,   7.6833032E-08,   4.0629143E-08,   2.1104377E-08
     +,   1.0769507E-08,   5.4004441E-09,   2.6629041E-09
     +,   1.2927386E-09,   6.1926442E-10,   2.9394862E-10
     +,   1.3932029E-10,   6.6808226E-11,   3.3094031E-11
     +,   1.7413515E-11,   1.0004287E-11,   6.3590209E-12
     +,   4.4317414E-12,   3.3057895E-12,   2.5729661E-12
     +,   2.0502523E-12,   1.6531792E-12,   1.3402336E-12
     +,   1.0887970E-12,   8.8491665E-13,   7.1895408E-13
     +,   5.8369645E-13,   4.7346697E-13,   3.8368546E-13
     +,   3.1061739E-13,   2.5121311E-13,   2.0296568E-13
     +,   1.6381758E-13,   1.3208785E-13,   1.0639728E-13
     +,   8.5617907E-14,   6.8827688E-14,   5.5275090E-14
     +,   4.4347430E-14,   3.5545101E-14,   2.8461683E-14
     +,   2.2767560E-14,   1.8195050E-14,   1.4526718E-14
     +,   1.1586694E-14,   9.2329226E-15,   7.3502538E-15
     +,   5.8458771E-15,   4.6450029E-15,   3.6873890E-15
     +,   2.9244554E-15,   2.3172109E-15,   1.8343631E-15
     +,   1.4508086E-15,   1.1464152E-15,   9.0506148E-16
     +,   7.1388519E-16,   5.6258854E-16,   4.4296962E-16
     +,   3.4847809E-16,   2.7390814E-16,   2.1510963E-16
     +,   1.6879133E-16,   1.3233474E-16,   1.0366695E-16
     +,   8.1142461E-17,   6.3461211E-17,   4.9593094E-17
     +,   3.8724728E-17,   3.0214870E-17,   2.3556792E-17
     +,   1.8352142E-17,   1.4286671E-17,   1.1113737E-17
     +,   8.6391810E-18,   6.7108969E-18,   5.2093511E-18
     +,   4.0410126E-18,   3.1325940E-18,   2.4268050E-18
     +,   1.8788047E-18,   1.4536484E-18
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_haonly_htt85_mass = Yx/0.6613726
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_haonly_htt90_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.0813398E-04,   3.2835250E-04
     +,   3.4928657E-04,   3.7090888E-04,   3.9318742E-04
     +,   4.1608576E-04,   4.3956281E-04,   4.6357335E-04
     +,   4.8806763E-04,   5.1299349E-04,   5.3829415E-04
     +,   5.6391035E-04,   5.8978063E-04,   6.1584177E-04
     +,   6.4202922E-04,   6.6827796E-04,   6.9452362E-04
     +,   7.2070246E-04,   7.4675278E-04,   7.7261537E-04
     +,   7.9823495E-04,   8.2356017E-04,   8.4854465E-04
     +,   8.7314931E-04,   8.9733925E-04,   9.2108967E-04
     +,   9.4438205E-04,   9.6720684E-04,   9.8956376E-04
     +,   1.0114614E-03,   1.0329182E-03,   1.0539625E-03
     +,   1.0746318E-03,   1.0949729E-03,   1.1150421E-03
     +,   1.1349036E-03,   1.1546300E-03,   1.1742999E-03
     +,   1.1939995E-03,   1.2138176E-03,   1.2338487E-03
     +,   1.2541884E-03,   1.2749322E-03,   1.2961760E-03
     +,   1.3180120E-03,   1.3405283E-03,   1.3638070E-03
     +,   1.3879226E-03,   1.4129397E-03,   1.4389122E-03
     +,   1.4658815E-03,   1.4938752E-03,   1.5229060E-03
     +,   1.5529724E-03,   1.5840536E-03,   1.6161159E-03
     +,   1.6491070E-03,   1.6829588E-03,   1.7175884E-03
     +,   1.7528984E-03,   1.7887783E-03,   1.8251085E-03
     +,   1.8617575E-03,   1.8985911E-03,   1.9354728E-03
     +,   1.9722616E-03,   2.0088258E-03,   2.0450363E-03
     +,   2.0807788E-03,   2.1159498E-03,   2.1504681E-03
     +,   2.1842702E-03,   2.2173221E-03,   2.2496118E-03
     +,   2.2811622E-03,   2.3120272E-03,   2.3422912E-03
     +,   2.3720718E-03,   2.4015224E-03,   2.4308276E-03
     +,   2.4601992E-03,   2.4898793E-03,   2.5201319E-03
     +,   2.5512450E-03,   2.5835165E-03,   2.6172632E-03
     +,   2.6528016E-03,   2.6904563E-03,   2.7305454E-03
     +,   2.7733836E-03,   2.8192762E-03,   2.8685154E-03
     +,   2.9213764E-03,   2.9781221E-03,   3.0390006E-03
     +,   3.1042353E-03,   3.1740412E-03,   3.2486061E-03
     +,   3.3281127E-03,   3.4127135E-03,   3.5025531E-03
     +,   3.5977443E-03,   3.6983907E-03,   3.8045589E-03
     +,   3.9162999E-03,   4.0336382E-03,   4.1565639E-03
     +,   4.2850478E-03,   4.4190553E-03,   4.5585497E-03
     +,   4.7034957E-03,   4.8539164E-03,   5.0098849E-03
     +,   5.1715896E-03,   5.3393277E-03,   5.5135838E-03
     +,   5.6950077E-03,   5.8844774E-03,   6.0830498E-03
     +,   6.2919855E-03,   6.5126852E-03,   6.7466074E-03
     +,   6.9951573E-03,   7.2595994E-03,   7.5408625E-03
     +,   7.8393472E-03,   8.1548151E-03,   8.4861265E-03
     +,   8.8311946E-03,   9.1867866E-03,   9.5485859E-03
     +,   9.9111348E-03,   1.0268061E-02,   1.0612205E-02
     +,   1.0936012E-02,   1.1231859E-02,   1.1492463E-02
     +,   1.1711298E-02,   1.1883000E-02,   1.2003598E-02
     +,   1.2070715E-02,   1.2083620E-02,   1.2043229E-02
     +,   1.1952095E-02,   1.1814570E-02,   1.1637232E-02
     +,   1.1429809E-02,   1.1206600E-02,   1.0988324E-02
     +,   1.0804052E-02,   1.0692783E-02,   1.0703968E-02
     +,   1.0896508E-02,   1.1336396E-02,   1.2093837E-02
     +,   1.3241421E-02,   1.4855465E-02,   1.7021980E-02
     +,   1.9846184E-02,   2.3461983E-02,   2.8036263E-02
     +,   3.3758730E-02,   4.0810928E-02,   4.9313284E-02
     +,   5.9256133E-02,   7.0429891E-02,   8.2381964E-02
     +,   9.4432436E-02,   0.1057669    ,   0.1155969    
     +,   0.1233492    ,   0.1288150    ,   0.1321926    
     +,   0.1339880    ,   0.1348062    ,   0.1351005    
     +,   0.1349822    ,   0.1341640    ,   0.1320602    
     +,   0.1280093    ,   0.1215309    ,   0.1125239    
     +,   0.1013349    ,   8.8680223E-02,   7.5466663E-02
     +,   6.2582977E-02,   5.0732296E-02,   4.0348120E-02
     +,   3.1597108E-02,   2.4440307E-02,   1.8713428E-02
     +,   1.4201853E-02,   1.0691414E-02,   7.9931887E-03
     +,   5.9498521E-03,   4.4320947E-03,   3.3319292E-03
     +,   2.5570744E-03,   2.0280806E-03,   1.6776151E-03
     +,   1.4505130E-03,   1.3036277E-03,   1.2050417E-03
     +,   1.1325827E-03,   1.0719072E-03,   1.0145018E-03
     +,   9.5591723E-04,   8.9435180E-04,   8.2960620E-04
     +,   7.6236884E-04,   6.9376081E-04,   6.2505802E-04
     +,   5.5751589E-04,   4.9226679E-04,   4.3026896E-04
     +,   3.7228360E-04,   3.1886215E-04,   2.7034892E-04
     +,   2.2690093E-04,   1.8851357E-04,   1.5503912E-04
     +,   1.2622031E-04,   1.0172069E-04,   8.1149294E-05
     +,   6.4084408E-05,   5.0096667E-05,   3.8766568E-05
     +,   2.9696250E-05,   2.2518436E-05,   1.6902975E-05
     +,   1.2559720E-05,   9.2383261E-06,   6.7266524E-06
     +,   4.8483307E-06,   3.4592522E-06,   2.4432320E-06
     +,   1.7081829E-06,   1.1822137E-06,   8.0994459E-07
     +,   5.4929620E-07,   3.6876062E-07,   2.4506119E-07
     +,   1.6121393E-07,   1.0498398E-07,   6.7675209E-08
     +,   4.3184517E-08,   2.7278791E-08,   1.7057467E-08
     +,   1.0558193E-08,   6.4693895E-09,   3.9240065E-09
     +,   2.3560314E-09,   1.4003103E-09,   8.2388490E-10
     +,   4.7984605E-10,   2.7664435E-10,   1.5788235E-10
     +,   8.9195880E-11,   4.9882654E-11,   2.7614520E-11
     +,   1.5132749E-11,   8.2091469E-12,   4.4083023E-12
     +,   2.3433003E-12,   1.2330649E-12,   6.4229633E-13
     +,   3.3118311E-13,   1.6904150E-13,   8.5412200E-14
     +,   4.2720747E-14,   2.1151449E-14,   1.0366521E-14
     +,   5.0295580E-15,   2.4155573E-15,   1.1483822E-15
     +,   5.4045504E-16,   2.5177599E-16,   1.1611026E-16
     +,   5.3003983E-17,   2.3952530E-17,   1.0714562E-17
     +,   4.7446042E-18,   2.0797413E-18,   9.0244857E-19
     +,   3.8762774E-19,   1.6482204E-19,   6.9376052E-20
     +,   2.8905946E-20,   1.1922758E-20,   4.8680064E-21
     +,   1.9676363E-21,   7.8729681E-22,   3.1186499E-22
     +,   1.2229944E-22,   4.7486050E-23,   1.8256430E-23
     +,   6.9514092E-24,   2.6220500E-24,   9.8028540E-25
     +,   3.6352338E-25,   1.3389664E-25
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_haonly_htt90_mass = Yx/0.816375
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_haonly_htt95_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.3523818E-04,   3.3352242E-04
     +,   3.3164481E-04,   3.2962576E-04,   3.2748748E-04
     +,   3.2525376E-04,   3.2295016E-04,   3.2060410E-04
     +,   3.1824451E-04,   3.1590200E-04,   3.1360882E-04
     +,   3.1139894E-04,   3.0930762E-04,   3.0737172E-04
     +,   3.0562934E-04,   3.0411987E-04,   3.0288385E-04
     +,   3.0196278E-04,   3.0139892E-04,   3.0123536E-04
     +,   3.0151545E-04,   3.0228309E-04,   3.0358185E-04
     +,   3.0545556E-04,   3.0794702E-04,   3.1109893E-04
     +,   3.1495251E-04,   3.1954781E-04,   3.2492328E-04
     +,   3.3111527E-04,   3.3815793E-04,   3.4608290E-04
     +,   3.5491845E-04,   3.6468997E-04,   3.7541898E-04
     +,   3.8712303E-04,   3.9981553E-04,   4.1350484E-04
     +,   4.2819581E-04,   4.4388621E-04,   4.6057045E-04
     +,   4.7823627E-04,   4.9686641E-04,   5.1643775E-04
     +,   5.3692161E-04,   5.5828347E-04,   5.8048347E-04
     +,   6.0347625E-04,   6.2721112E-04,   6.5163284E-04
     +,   6.7668146E-04,   7.0229283E-04,   7.2839903E-04
     +,   7.5493095E-04,   7.8181393E-04,   8.0897496E-04
     +,   8.3633879E-04,   8.6383068E-04,   8.9137728E-04
     +,   9.1890711E-04,   9.4635272E-04,   9.7365124E-04
     +,   1.0007437E-03,   1.0275809E-03,   1.0541209E-03
     +,   1.0803298E-03,   1.1061869E-03,   1.1316804E-03
     +,   1.1568157E-03,   1.1816077E-03,   1.2060903E-03
     +,   1.2303106E-03,   1.2543354E-03,   1.2782445E-03
     +,   1.3021387E-03,   1.3261358E-03,   1.3503693E-03
     +,   1.3749895E-03,   1.4001637E-03,   1.4260747E-03
     +,   1.4529150E-03,   1.4808924E-03,   1.5102198E-03
     +,   1.5411197E-03,   1.5738148E-03,   1.6085309E-03
     +,   1.6454860E-03,   1.6848953E-03,   1.7269573E-03
     +,   1.7718571E-03,   1.8197618E-03,   1.8708096E-03
     +,   1.9251098E-03,   1.9827418E-03,   2.0437504E-03
     +,   2.1081318E-03,   2.1758501E-03,   2.2468148E-03
     +,   2.3208992E-03,   2.3979184E-03,   2.4776517E-03
     +,   2.5598218E-03,   2.6441198E-03,   2.7301842E-03
     +,   2.8176280E-03,   2.9060328E-03,   2.9949534E-03
     +,   3.0839285E-03,   3.1724994E-03,   3.2602139E-03
     +,   3.3466283E-03,   3.4313444E-03,   3.5140014E-03
     +,   3.5943107E-03,   3.6720573E-03,   3.7471335E-03
     +,   3.8195392E-03,   3.8894189E-03,   3.9570569E-03
     +,   4.0229117E-03,   4.0876134E-03,   4.1519720E-03
     +,   4.2169755E-03,   4.2837905E-03,   4.3537356E-03
     +,   4.4282544E-03,   4.5088888E-03,   4.5972173E-03
     +,   4.6948120E-03,   4.8031593E-03,   4.9236151E-03
     +,   5.0573084E-03,   5.2051176E-03,   5.3675873E-03
     +,   5.5449381E-03,   5.7370644E-03,   5.9435582E-03
     +,   6.1638085E-03,   6.3971514E-03,   6.6430280E-03
     +,   6.9011869E-03,   7.1719289E-03,   7.4563771E-03
     +,   7.7566747E-03,   8.0761239E-03,   8.4193246E-03
     +,   8.7921089E-03,   9.2013134E-03,   9.6544325E-03
     +,   1.0159078E-02,   1.0722238E-02,   1.1349342E-02
     +,   1.2043322E-02,   1.2803700E-02,   1.3625756E-02
     +,   1.4499936E-02,   1.5411863E-02,   1.6342979E-02
     +,   1.7271757E-02,   1.8175488E-02,   1.9032758E-02
     +,   1.9825613E-02,   2.0541191E-02,   2.1172369E-02
     +,   2.1717014E-02,   2.2175718E-02,   2.2548970E-02
     +,   2.2835031E-02,   2.3030458E-02,   2.3135968E-02
     +,   2.3170760E-02,   2.3198724E-02,   2.3368342E-02
     +,   2.3964869E-02,   2.5465209E-02,   2.8574765E-02
     +,   3.4212768E-02,   4.3407064E-02,   5.7075404E-02
     +,   7.5709701E-02,   9.9034190E-02,   0.1257612    
     +,   0.1535803    ,   0.1794529    ,   0.2001682    
     +,   0.2130173    ,   0.2163842    ,   0.2100665    
     +,   0.1952457    ,   0.1741463    ,   0.1494957    
     +,   0.1239582    ,   9.9690430E-02,   7.8102455E-02
     +,   5.9845060E-02,   4.4970244E-02,   3.3165187E-02
     +,   2.3968104E-02,   1.6913753E-02,   1.1599439E-02
     +,   7.6919962E-03,   4.9096104E-03,   3.0047849E-03
     +,   1.7583735E-03,   9.8204671E-04,   5.2284822E-04
     +,   2.6520685E-04,   1.2814072E-04,   5.8980164E-05
     +,   2.5862835E-05,   1.0804877E-05,   4.3008604E-06
     +,   1.6311492E-06,   5.8951861E-07,   2.0321720E-07
     +,   6.7039672E-08,   2.1378353E-08,   6.7761721E-09
     +,   2.2850344E-09,   9.2315205E-10,   4.8844662E-10
     +,   3.2274874E-10,   2.3842348E-10,   1.8339920E-10
     +,   1.4273206E-10,   1.1132905E-10,   8.6782762E-11
     +,   6.7553463E-11,   5.2497826E-11,   4.0726103E-11
     +,   3.1537398E-11,   2.4377524E-11,   1.8808313E-11
     +,   1.4484156E-11,   1.1133192E-11,   8.5412363E-12
     +,   6.5401252E-12,   4.9982149E-12,   3.8124868E-12
     +,   2.9024166E-12,   2.2052763E-12,   1.6723188E-12
     +,   1.2656980E-12,   9.5607810E-13,   7.2077576E-13
     +,   5.4231993E-13,   4.0725163E-13,   3.0522302E-13
     +,   2.2830452E-13,   1.7043666E-13,   1.2698623E-13
     +,   9.4426101E-14,   7.0076472E-14,   5.1904238E-14
     +,   3.8368770E-14,   2.8307006E-14,   2.0842794E-14
     +,   1.5316712E-14,   1.1233650E-14,   8.2227519E-15
     +,   6.0070001E-15,   4.3797439E-15,   3.1870087E-15
     +,   2.3145023E-15,   1.6775817E-15,   1.2135372E-15
     +,   8.7611831E-16,   6.3127454E-16,   4.5396577E-16
     +,   3.2581665E-16,   2.3337965E-16,   1.6683984E-16
     +,   1.1903823E-16,   8.4765274E-17,   6.0240771E-17
     +,   4.2728144E-17,   3.0246766E-17,   2.1369551E-17
     +,   1.5067934E-17,   1.0603884E-17,   7.4476265E-18
     +,   5.2206288E-18,   3.6523399E-18,   2.5502040E-18
     +,   1.7771328E-18,   1.2360131E-18,   8.5797660E-19
     +,   5.9439167E-19,   4.1098955E-19,   2.8361829E-19
     +,   1.9534354E-19,   1.3428114E-19,   9.2128068E-20
     +,   6.3084832E-20,   4.3114605E-20,   2.9409037E-20
     +,   2.0022117E-20,   1.3605047E-20,   9.2272159E-21
     +,   6.2461050E-21,   4.2202339E-21
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_haonly_htt95_mass = Yx/0.816375
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_haonly_ttz100_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.5643901E-07,   5.4817701E-07
     +,   6.5683895E-07,   7.8523180E-07,   9.3656564E-07
     +,   1.1145012E-06,   1.3232012E-06,   1.5673820E-06
     +,   1.8523666E-06,   2.1841690E-06,   2.5695203E-06
     +,   3.0159620E-06,   3.5319040E-06,   4.1266953E-06
     +,   4.8107008E-06,   5.5953569E-06,   6.4932647E-06
     +,   7.5182356E-06,   8.6853761E-06,   1.0011134E-05
     +,   1.1513365E-05,   1.3211388E-05,   1.5125985E-05
     +,   1.7279599E-05,   1.9696012E-05,   2.2400804E-05
     +,   2.5420992E-05,   2.8785189E-05,   3.2523523E-05
     +,   3.6667629E-05,   4.1250511E-05,   4.6306559E-05
     +,   5.1871342E-05,   5.7981651E-05,   6.4675180E-05
     +,   7.1990493E-05,   7.9966834E-05,   8.8643792E-05
     +,   9.8061850E-05,   1.0826051E-04,   1.1928023E-04
     +,   1.3116052E-04,   1.4394039E-04,   1.5765814E-04
     +,   1.7235080E-04,   1.8805425E-04,   2.0480275E-04
     +,   2.2262873E-04,   2.4156248E-04,   2.6163209E-04
     +,   2.8286292E-04,   3.0527773E-04,   3.2889567E-04
     +,   3.5373401E-04,   3.7980385E-04,   4.0711529E-04
     +,   4.3567244E-04,   4.6547549E-04,   4.9651996E-04
     +,   5.2879623E-04,   5.6228926E-04,   5.9697888E-04
     +,   6.3283660E-04,   6.6983007E-04,   7.0792012E-04
     +,   7.4705679E-04,   7.8718748E-04,   8.2824595E-04
     +,   8.7016303E-04,   9.1285520E-04,   9.5623569E-04
     +,   1.0002018E-03,   1.0446481E-03,   1.0894529E-03
     +,   1.1344894E-03,   1.1796214E-03,   1.2246999E-03
     +,   1.2695678E-03,   1.3140613E-03,   1.3580099E-03
     +,   1.4012309E-03,   1.4435421E-03,   1.4847504E-03
     +,   1.5246645E-03,   1.5630863E-03,   1.5998218E-03
     +,   1.6346743E-03,   1.6674533E-03,   1.6979702E-03
     +,   1.7260455E-03,   1.7515083E-03,   1.7741972E-03
     +,   1.7939629E-03,   1.8106718E-03,   1.8242061E-03
     +,   1.8344638E-03,   1.8413631E-03,   1.8448412E-03
     +,   1.8448558E-03,   1.8413869E-03,   1.8344348E-03
     +,   1.8240237E-03,   1.8101970E-03,   1.7930216E-03
     +,   1.7725845E-03,   1.7489910E-03,   1.7223671E-03
     +,   1.6928568E-03,   1.6606181E-03,   1.6258223E-03
     +,   1.5886574E-03,   1.5493173E-03,   1.5080090E-03
     +,   1.4649412E-03,   1.4203331E-03,   1.3744007E-03
     +,   1.3273665E-03,   1.2794463E-03,   1.2308590E-03
     +,   1.1818147E-03,   1.1325175E-03,   1.0831672E-03
     +,   1.0339548E-03,   9.8505977E-04,   9.3664974E-04
     +,   8.8888616E-04,   8.4191264E-04,   7.9586660E-04
     +,   7.5086672E-04,   7.0702494E-04,   6.6443440E-04
     +,   6.2318140E-04,   5.8333419E-04,   5.4495403E-04
     +,   5.0808664E-04,   4.7276643E-04,   4.3901935E-04
     +,   4.0686081E-04,   3.7629463E-04,   3.4731571E-04
     +,   3.1991262E-04,   2.9406638E-04,   2.6974909E-04
     +,   2.4692708E-04,   2.2556339E-04,   2.0561415E-04
     +,   1.8703158E-04,   1.6976574E-04,   1.5376411E-04
     +,   1.3897091E-04,   1.2532984E-04,   1.1278584E-04
     +,   1.0128664E-04,   9.0786190E-05,   8.1253413E-05
     +,   7.2687260E-05,   6.5141692E-05,   5.8770107E-05
     +,   5.3900156E-05,   5.1152336E-05,   5.1618270E-05
     +,   5.7121575E-05,   7.0573748E-05,   9.6434422E-05
     +,   1.4127025E-04,   2.1437225E-04,   3.2835154E-04
     +,   4.9960724E-04,   7.4852706E-04,   1.0992261E-03
     +,   1.5786632E-03,   2.2151496E-03,   3.0363798E-03
     +,   4.0672086E-03,   5.3276815E-03,   6.8324907E-03
     +,   8.5920105E-03,   1.0615629E-02,   1.2917639E-02
     +,   1.5524849E-02,   1.8483724E-02,   2.1864355E-02
     +,   2.5758069E-02,   3.0264830E-02,   3.5467256E-02
     +,   4.1392155E-02,   4.7965612E-02,   5.4972373E-02
     +,   6.2032823E-02,   6.8613097E-02,   7.4079268E-02
     +,   7.7788718E-02,   7.9205111E-02,   7.8009829E-02
     +,   7.4177898E-02,   6.7996651E-02,   6.0020991E-02
     +,   5.0975345E-02,   4.1628063E-02,   3.2672048E-02
     +,   2.4636658E-02,   1.7843941E-02,   1.2410961E-02
     +,   8.2877800E-03,   5.3128186E-03,   3.2687699E-03
     +,   1.9298787E-03,   1.0931595E-03,   5.9396797E-04
     +,   3.0950134E-04,   1.5462068E-04,   7.4042080E-05
     +,   3.3977809E-05,   1.4938104E-05,   6.2901236E-06
     +,   2.5362999E-06,   9.7918053E-07,   3.6192705E-07
     +,   1.2811145E-07,   4.3477581E-08,   1.4190381E-08
     +,   4.4917043E-09,   1.4093292E-09,   4.6161230E-10
     +,   1.7359950E-10,   8.2395674E-11,   4.9075119E-11
     +,   3.3470955E-11,   2.4161244E-11,   1.7767621E-11
     +,   1.3121611E-11,   9.6857496E-12,   7.1355773E-12
     +,   5.2442755E-12,   3.8446477E-12,   2.8114316E-12
     +,   2.0506270E-12,   1.4919033E-12,   1.0826590E-12
     +,   7.8367727E-13,   5.6580999E-13,   4.0747185E-13
     +,   2.9270027E-13,   2.0972074E-13,   1.4988154E-13
     +,   1.0684361E-13,   7.5970778E-14,   5.3881297E-14
     +,   3.8116943E-14,   2.6896549E-14,   1.8930741E-14
     +,   1.3290044E-14,   9.3063501E-15,   6.5002494E-15
     +,   4.5286964E-15,   3.1470645E-15,   2.1813767E-15
     +,   1.5081833E-15,   1.0400882E-15,   7.1544357E-16
     +,   4.9087756E-16,   3.3594528E-16,   2.2932853E-16
     +,   1.5614757E-16,   1.0604982E-16,   7.1842052E-17
     +,   4.8543862E-17,   3.2717739E-17,   2.1995376E-17
     +,   1.4749323E-17,   9.8650908E-18,   6.5814667E-18
     +,   4.3796823E-18,   2.9070723E-18,   1.9246679E-18
     +,   1.2710298E-18,   8.3722863E-19,   5.5008405E-19
     +,   3.6049767E-19,   2.3565362E-19,   1.5365000E-19
     +,   9.9928866E-20,   6.4824025E-20,   4.1945085E-20
     +,   2.7071427E-20,   1.7427813E-20,   1.1190935E-20
     +,   7.1676444E-21,   4.5791677E-21,   2.9179757E-21
     +,   1.8547203E-21,   1.1758725E-21,   7.4360725E-22
     +,   4.6904241E-22,   2.9510769E-22,   1.8519704E-22
     +,   1.1592822E-22,   7.2382071E-23,   4.5078671E-23
     +,   2.8002568E-23,   1.7351008E-23
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_haonly_ttz100_mass = Yx/0.3036915
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_haonly_ttz105_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.4220945E-03,   1.4484801E-03
     +,   1.4745425E-03,   1.5002561E-03,   1.5255952E-03
     +,   1.5505350E-03,   1.5750501E-03,   1.5991165E-03
     +,   1.6227086E-03,   1.6458037E-03,   1.6683771E-03
     +,   1.6904057E-03,   1.7118657E-03,   1.7327345E-03
     +,   1.7529896E-03,   1.7726088E-03,   1.7915708E-03
     +,   1.8098543E-03,   1.8274387E-03,   1.8443046E-03
     +,   1.8604328E-03,   1.8758052E-03,   1.8904045E-03
     +,   1.9042148E-03,   1.9172211E-03,   1.9294102E-03
     +,   1.9407691E-03,   1.9512881E-03,   1.9609577E-03
     +,   1.9697717E-03,   1.9777250E-03,   1.9848142E-03
     +,   1.9910403E-03,   1.9964045E-03,   2.0009121E-03
     +,   2.0045708E-03,   2.0073908E-03,   2.0093860E-03
     +,   2.0105736E-03,   2.0109729E-03,   2.0106083E-03
     +,   2.0095054E-03,   2.0076954E-03,   2.0052111E-03
     +,   2.0020898E-03,   1.9983724E-03,   1.9941020E-03
     +,   1.9893257E-03,   1.9840943E-03,   1.9784593E-03
     +,   1.9724777E-03,   1.9662064E-03,   1.9597064E-03
     +,   1.9530398E-03,   1.9462707E-03,   1.9394637E-03
     +,   1.9326848E-03,   1.9260009E-03,   1.9194786E-03
     +,   1.9131835E-03,   1.9071810E-03,   1.9015349E-03
     +,   1.8963079E-03,   1.8915592E-03,   1.8873464E-03
     +,   1.8837238E-03,   1.8807409E-03,   1.8784439E-03
     +,   1.8768752E-03,   1.8760712E-03,   1.8760640E-03
     +,   1.8768788E-03,   1.8785364E-03,   1.8810510E-03
     +,   1.8844308E-03,   1.8886771E-03,   1.8937860E-03
     +,   1.8997459E-03,   1.9065391E-03,   1.9141426E-03
     +,   1.9225260E-03,   1.9316546E-03,   1.9414863E-03
     +,   1.9519747E-03,   1.9630678E-03,   1.9747100E-03
     +,   1.9868405E-03,   1.9993952E-03,   2.0123061E-03
     +,   2.0255032E-03,   2.0389142E-03,   2.0524631E-03
     +,   2.0660737E-03,   2.0796687E-03,   2.0931708E-03
     +,   2.1065001E-03,   2.1195791E-03,   2.1323289E-03
     +,   2.1446720E-03,   2.1565310E-03,   2.1678300E-03
     +,   2.1784930E-03,   2.1884467E-03,   2.1976167E-03
     +,   2.2059318E-03,   2.2133207E-03,   2.2197135E-03
     +,   2.2250405E-03,   2.2292337E-03,   2.2322268E-03
     +,   2.2339532E-03,   2.2343476E-03,   2.2333465E-03
     +,   2.2308868E-03,   2.2269075E-03,   2.2213503E-03
     +,   2.2141577E-03,   2.2052759E-03,   2.1946549E-03
     +,   2.1822485E-03,   2.1680142E-03,   2.1519184E-03
     +,   2.1339343E-03,   2.1140424E-03,   2.0922339E-03
     +,   2.0685145E-03,   2.0429012E-03,   2.0154309E-03
     +,   1.9861565E-03,   1.9551583E-03,   1.9225375E-03
     +,   1.8884311E-03,   1.8530068E-03,   1.8164769E-03
     +,   1.7790981E-03,   1.7411797E-03,   1.7030956E-03
     +,   1.6652880E-03,   1.6282776E-03,   1.5926725E-03
     +,   1.5591838E-03,   1.5286327E-03,   1.5019603E-03
     +,   1.4802413E-03,   1.4646957E-03,   1.4566947E-03
     +,   1.4577711E-03,   1.4696256E-03,   1.4941245E-03
     +,   1.5333043E-03,   1.5893638E-03,   1.6646486E-03
     +,   1.7616316E-03,   1.8828970E-03,   2.0311042E-03
     +,   2.2089344E-03,   2.4190429E-03,   2.6640226E-03
     +,   2.9463221E-03,   3.2681450E-03,   3.6314251E-03
     +,   4.0377188E-03,   4.4880915E-03,   4.9830475E-03
     +,   5.5224900E-03,   6.1056181E-03,   6.7308121E-03
     +,   7.3956163E-03,   8.0967462E-03,   8.8300323E-03
     +,   9.5903650E-03,   1.0371771E-02,   1.1167502E-02
     +,   1.1970079E-02,   1.2771295E-02,   1.3562499E-02
     +,   1.4334664E-02,   1.5078490E-02,   1.5784651E-02
     +,   1.6444007E-02,   1.7047754E-02,   1.7587572E-02
     +,   1.8055873E-02,   1.8445967E-02,   1.8752206E-02
     +,   1.8970091E-02,   1.9096376E-02,   1.9129220E-02
     +,   1.9068114E-02,   1.8913977E-02,   1.8669074E-02
     +,   1.8336978E-02,   1.7922491E-02,   1.7431533E-02
     +,   1.6870948E-02,   1.6248360E-02,   1.5572075E-02
     +,   1.4850836E-02,   1.4093599E-02,   1.3309387E-02
     +,   1.2507177E-02,   1.1695676E-02,   1.0883139E-02
     +,   1.0077271E-02,   9.2852106E-03,   8.5132886E-03
     +,   7.7670459E-03,   7.0512393E-03,   6.3697812E-03
     +,   5.7256962E-03,   5.1211938E-03,   4.5577544E-03
     +,   4.0361281E-03,   3.5563698E-03,   3.1179590E-03
     +,   2.7198941E-03,   2.3607430E-03,   2.0387000E-03
     +,   1.7516939E-03,   1.4974825E-03,   1.2736684E-03
     +,   1.0777888E-03,   9.0738165E-04,   7.6001423E-04
     +,   6.3331635E-04,   5.2502239E-04,   4.3300173E-04
     +,   3.5526531E-04,   2.8997374E-04,   2.3544970E-04
     +,   1.9018134E-04,   1.5281474E-04,   1.2214656E-04
     +,   9.7119577E-05,   7.6814402E-05,   6.0433795E-05
     +,   4.7294383E-05,   3.6815418E-05,   2.8506152E-05
     +,   2.1954698E-05,   1.6818512E-05,   1.2814972E-05
     +,   9.7121874E-06,   7.3211136E-06,   5.4889506E-06
     +,   4.0931086E-06,   3.0357714E-06,   2.2393845E-06
     +,   1.6429466E-06,   1.1988332E-06,   8.7001484E-07
     +,   6.2794078E-07,   4.5075078E-07,   3.2179631E-07
     +,   2.2847856E-07,   1.6133224E-07,   1.1329497E-07
     +,   7.9125485E-08,   5.4957972E-08,   3.7961772E-08
     +,   2.6077512E-08,   1.7815308E-08,   1.2103778E-08
     +,   8.1778975E-09,   5.4949649E-09,   3.6718428E-09
     +,   2.4400115E-09,   1.6124765E-09,   1.0597253E-09
     +,   6.9260603E-10,   4.5015872E-10,   2.9096275E-10
     +,   1.8702910E-10,   1.1955734E-10,   7.6003634E-11
     +,   4.8050536E-11,   3.0210636E-11,   1.8890257E-11
     +,   1.1746961E-11,   7.2651720E-12,   4.4688662E-12
     +,   2.7340660E-12,   1.6637461E-12,   1.0070991E-12
     +,   6.0643336E-13,   3.6330975E-13,   2.1657272E-13
     +,   1.2847750E-13,   7.5867467E-14,   4.4606195E-14
     +,   2.6122586E-14,   1.5244177E-14,   8.8701333E-15
     +,   5.1500090E-15,   2.9865327E-15,   1.7318424E-15
     +,   1.0057340E-15,   5.8592101E-16,   3.4314795E-16
     +,   2.0248446E-16,   1.2068217E-16
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_haonly_ttz105_mass = Yx/0.237671608695652
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_haonly_ttz107_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.1361942E-04,   4.1671467E-04
     +,   4.1999255E-04,   4.2346158E-04,   4.2712991E-04
     +,   4.3100541E-04,   4.3509508E-04,   4.3940550E-04
     +,   4.4394287E-04,   4.4871258E-04,   4.5371969E-04
     +,   4.5896872E-04,   4.6446332E-04,   4.7020725E-04
     +,   4.7620336E-04,   4.8245428E-04,   4.8896245E-04
     +,   4.9573020E-04,   5.0275936E-04,   5.1005202E-04
     +,   5.1761046E-04,   5.2543683E-04,   5.3353421E-04
     +,   5.4190605E-04,   5.5055605E-04,   5.5948959E-04
     +,   5.6871265E-04,   5.7823246E-04,   5.8805797E-04
     +,   5.9819961E-04,   6.0866954E-04,   6.1948207E-04
     +,   6.3065387E-04,   6.4220355E-04,   6.5415294E-04
     +,   6.6652574E-04,   6.7934918E-04,   6.9265254E-04
     +,   7.0646941E-04,   7.2083488E-04,   7.3578849E-04
     +,   7.5137184E-04,   7.6763000E-04,   7.8461081E-04
     +,   8.0236502E-04,   8.2094589E-04,   8.4040890E-04
     +,   8.6081208E-04,   8.8221510E-04,   9.0467872E-04
     +,   9.2826562E-04,   9.5303805E-04,   9.7905891E-04
     +,   1.0063919E-03,   1.0350971E-03,   1.0652355E-03
     +,   1.0968649E-03,   1.1300405E-03,   1.1648141E-03
     +,   1.2012329E-03,   1.2393399E-03,   1.2791733E-03
     +,   1.3207623E-03,   1.3641327E-03,   1.4093034E-03
     +,   1.4562808E-03,   1.5050690E-03,   1.5556572E-03
     +,   1.6080320E-03,   1.6621638E-03,   1.7180198E-03
     +,   1.7755509E-03,   1.8347052E-03,   1.8954137E-03
     +,   1.9576037E-03,   2.0211928E-03,   2.0860860E-03
     +,   2.1521798E-03,   2.2193680E-03,   2.2875357E-03
     +,   2.3565562E-03,   2.4263058E-03,   2.4966474E-03
     +,   2.5674491E-03,   2.6385675E-03,   2.7098670E-03
     +,   2.7812012E-03,   2.8524341E-03,   2.9234220E-03
     +,   2.9940295E-03,   3.0641239E-03,   3.1335726E-03
     +,   3.2022465E-03,   3.2700251E-03,   3.3367928E-03
     +,   3.4024331E-03,   3.4668404E-03,   3.5299065E-03
     +,   3.5915361E-03,   3.6516255E-03,   3.7100825E-03
     +,   3.7668084E-03,   3.8217106E-03,   3.8746877E-03
     +,   3.9256401E-03,   3.9744624E-03,   4.0210411E-03
     +,   4.0652538E-03,   4.1069728E-03,   4.1460590E-03
     +,   4.1823569E-03,   4.2157066E-03,   4.2459290E-03
     +,   4.2728377E-03,   4.2962311E-03,   4.3158983E-03
     +,   4.3316176E-03,   4.3431614E-03,   4.3502962E-03
     +,   4.3527842E-03,   4.3503917E-03,   4.3428889E-03
     +,   4.3300563E-03,   4.3116878E-03,   4.2875959E-03
     +,   4.2576217E-03,   4.2216312E-03,   4.1795317E-03
     +,   4.1312664E-03,   4.0768324E-03,   4.0162713E-03
     +,   3.9496925E-03,   3.8772589E-03,   3.7992117E-03
     +,   3.7158597E-03,   3.6275866E-03,   3.5348679E-03
     +,   3.4382644E-03,   3.3384222E-03,   3.2360847E-03
     +,   3.1321000E-03,   3.0274193E-03,   2.9230958E-03
     +,   2.8202932E-03,   2.7202975E-03,   2.6245012E-03
     +,   2.5344151E-03,   2.4516741E-03,   2.3780270E-03
     +,   2.3153313E-03,   2.2655511E-03,   2.2307523E-03
     +,   2.2130827E-03,   2.2147540E-03,   2.2380261E-03
     +,   2.2851743E-03,   2.3584571E-03,   2.4600802E-03
     +,   2.5921573E-03,   2.7566408E-03,   2.9552933E-03
     +,   3.1896243E-03,   3.4608096E-03,   3.7696382E-03
     +,   4.1164751E-03,   4.5011924E-03,   4.9230745E-03
     +,   5.3808056E-03,   5.8724503E-03,   6.3954089E-03
     +,   6.9463649E-03,   7.5213136E-03,   8.1156259E-03
     +,   8.7240404E-03,   9.3406616E-03,   9.9591566E-03
     +,   1.0572769E-02,   1.1174402E-02,   1.1756770E-02
     +,   1.2312569E-02,   1.2834572E-02,   1.3315754E-02
     +,   1.3749449E-02,   1.4129552E-02,   1.4450586E-02
     +,   1.4707827E-02,   1.4897425E-02,   1.5016508E-02
     +,   1.5063218E-02,   1.5036770E-02,   1.4937451E-02
     +,   1.4766622E-02,   1.4526684E-02,   1.4221024E-02
     +,   1.3853909E-02,   1.3430390E-02,   1.2956212E-02
     +,   1.2437684E-02,   1.1881480E-02,   1.1294530E-02
     +,   1.0683927E-02,   1.0056742E-02,   9.4198519E-03
     +,   8.7798629E-03,   8.1430543E-03,   7.5151767E-03
     +,   6.9014262E-03,   6.3064420E-03,   5.7342150E-03
     +,   5.1880344E-03,   4.6705296E-03,   4.1837078E-03
     +,   3.7289516E-03,   3.3070205E-03,   2.9181403E-03
     +,   2.5620777E-03,   2.2381709E-03,   1.9453746E-03
     +,   1.6823488E-03,   1.4475430E-03,   1.2392065E-03
     +,   1.0554703E-03,   8.9440978E-04,   7.5407303E-04
     +,   6.3251407E-04,   5.2783720E-04,   4.3822906E-04
     +,   3.6196984E-04,   2.9744511E-04,   2.4316288E-04
     +,   1.9776192E-04,   1.6000803E-04,   1.2879167E-04
     +,   1.0312726E-04,   8.2148777E-05,   6.5097433E-05
     +,   5.1316161E-05,   4.0241281E-05,   3.1391799E-05
     +,   2.4360186E-05,   1.8804307E-05,   1.4439314E-05
     +,   1.1029313E-05,   8.3802297E-06,   6.3337579E-06
     +,   4.7617373E-06,   3.5609764E-06,   2.6488951E-06
     +,   1.9599511E-06,   1.4424998E-06,   1.0560129E-06
     +,   7.6894997E-07,   5.5693386E-07,   4.0122509E-07
     +,   2.8750401E-07,   2.0491028E-07,   1.4526118E-07
     +,   1.0242459E-07,   7.1832417E-08,   5.0106166E-08
     +,   3.4763175E-08,   2.3988823E-08,   1.6464661E-08
     +,   1.1239459E-08,   7.6312636E-09,   5.1534932E-09
     +,   3.4614405E-09,   2.3124349E-09,   1.5365649E-09
     +,   1.0155524E-09,   6.6761974E-10,   4.3656920E-10
     +,   2.8399022E-10,   1.8378404E-10,   1.1833343E-10
     +,   7.5819760E-11,   4.8352433E-11,   3.0701875E-11
     +,   1.9418106E-11,   1.2241538E-11,   7.6989829E-12
     +,   4.8369139E-12,   3.0408792E-12,   1.9177535E-12
     +,   1.2171350E-12,   7.8063299E-13,   5.0849353E-13
     +,   3.3827829E-13,   2.3111325E-13,   1.6288875E-13
     +,   1.1873834E-13,   8.9515885E-14,   6.9618092E-14
     +,   5.5611799E-14,   4.5395165E-14,   3.7674602E-14
     +,   3.1649732E-14,   2.6817624E-14,   2.2857392E-14
     +,   1.9557952E-14,   1.6776612E-14
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_haonly_ttz107_mass = Yx/0.212102
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_haonly_ttz110_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.2452700E-06,   2.7487686E-06
     +,   3.3560159E-06,   4.0862665E-06,   4.9618802E-06
     +,   6.0087309E-06,   7.2566509E-06,   8.7399076E-06
     +,   1.0497667E-05,   1.2574682E-05,   1.5021662E-05
     +,   1.7895976E-05,   2.1262251E-05,   2.5192969E-05
     +,   2.9769059E-05,   3.5080571E-05,   4.1227144E-05
     +,   4.8318645E-05,   5.6475583E-05,   6.5829503E-05
     +,   7.6523356E-05,   8.8711597E-05,   1.0256007E-04
     +,   1.1824694E-04,   1.3595990E-04,   1.5589900E-04
     +,   1.7827310E-04,   2.0330001E-04,   2.3120514E-04
     +,   2.6221975E-04,   2.9657880E-04,   3.3451919E-04
     +,   3.7627673E-04,   4.2208331E-04,   4.7216372E-04
     +,   5.2673224E-04,   5.8598857E-04,   6.5011287E-04
     +,   7.1926665E-04,   7.9357694E-04,   8.7314675E-04
     +,   9.5803873E-04,   1.0482761E-03,   1.1438370E-03
     +,   1.2446512E-03,   1.3505962E-03,   1.4614935E-03
     +,   1.5771071E-03,   1.6971400E-03,   1.8212340E-03
     +,   1.9489697E-03,   2.0798643E-03,   2.2133742E-03
     +,   2.3489068E-03,   2.4857982E-03,   2.6233515E-03
     +,   2.7608161E-03,   2.8974046E-03,   3.0323006E-03
     +,   3.1646634E-03,   3.2936404E-03,   3.4183769E-03
     +,   3.5380160E-03,   3.6517296E-03,   3.7587143E-03
     +,   3.8581959E-03,   3.9494634E-03,   4.0318510E-03
     +,   4.1047726E-03,   4.1677104E-03,   4.2202394E-03
     +,   4.2620176E-03,   4.2928108E-03,   4.3124757E-03
     +,   4.3209796E-03,   4.3183924E-03,   4.3048887E-03
     +,   4.2807464E-03,   4.2463406E-03,   4.2021400E-03
     +,   4.1487059E-03,   4.0866695E-03,   4.0167454E-03
     +,   3.9396966E-03,   3.8563479E-03,   3.7675526E-03
     +,   3.6742028E-03,   3.5771944E-03,   3.4774407E-03
     +,   3.3758362E-03,   3.2732587E-03,   3.1705629E-03
     +,   3.0685645E-03,   2.9680266E-03,   2.8696549E-03
     +,   2.7741052E-03,   2.6819534E-03,   2.5937152E-03
     +,   2.5098228E-03,   2.4306437E-03,   2.3564589E-03
     +,   2.2874856E-03,   2.2238595E-03,   2.1656565E-03
     +,   2.1128803E-03,   2.0654765E-03,   2.0233388E-03
     +,   1.9863127E-03,   1.9541995E-03,   1.9267653E-03
     +,   1.9037513E-03,   1.8848735E-03,   1.8698358E-03
     +,   1.8583313E-03,   1.8500513E-03,   1.8446882E-03
     +,   1.8419425E-03,   1.8415250E-03,   1.8431611E-03
     +,   1.8465931E-03,   1.8515842E-03,   1.8579168E-03
     +,   1.8653959E-03,   1.8738501E-03,   1.8831285E-03
     +,   1.8931039E-03,   1.9036711E-03,   1.9147444E-03
     +,   1.9262604E-03,   1.9381725E-03,   1.9504551E-03
     +,   1.9630967E-03,   1.9761038E-03,   1.9894948E-03
     +,   2.0033042E-03,   2.0175765E-03,   2.0323636E-03
     +,   2.0477260E-03,   2.0637293E-03,   2.0804415E-03
     +,   2.0979277E-03,   2.1162538E-03,   2.1354801E-03
     +,   2.1556658E-03,   2.1768655E-03,   2.1991401E-03
     +,   2.2225620E-03,   2.2472262E-03,   2.2732709E-03
     +,   2.3009025E-03,   2.3304240E-03,   2.3622734E-03
     +,   2.3970669E-03,   2.4356502E-03,   2.4791551E-03
     +,   2.5290500E-03,   2.5871999E-03,   2.6559194E-03
     +,   2.7380148E-03,   2.8368041E-03,   2.9561373E-03
     +,   3.1003763E-03,   3.2743337E-03,   3.4831932E-03
     +,   3.7324042E-03,   4.0275082E-03,   4.3739099E-03
     +,   4.7766548E-03,   5.2401815E-03,   5.7680230E-03
     +,   6.3624564E-03,   7.0242430E-03,   7.7524073E-03
     +,   8.5439701E-03,   9.3937032E-03,   1.0294169E-02
     +,   1.1235669E-02,   1.2206246E-02,   1.3191942E-02
     +,   1.4177160E-02,   1.5144994E-02,   1.6077628E-02
     +,   1.6956946E-02,   1.7765168E-02,   1.8485358E-02
     +,   1.9101990E-02,   1.9601515E-02,   1.9972894E-02
     +,   2.0207886E-02,   2.0301346E-02,   2.0251403E-02
     +,   2.0059451E-02,   1.9730078E-02,   1.9270858E-02
     +,   1.8691972E-02,   1.8005833E-02,   1.7226668E-02
     +,   1.6369974E-02,   1.5451953E-02,   1.4489014E-02
     +,   1.3497382E-02,   1.2492605E-02,   1.1489109E-02
     +,   1.0499967E-02,   9.5367683E-03,   8.6092874E-03
     +,   7.7255182E-03,   6.8917223E-03,   6.1124270E-03
     +,   5.3904904E-03,   4.7273044E-03,   4.1230093E-03
     +,   3.5766307E-03,   3.0862486E-03,   2.6492267E-03
     +,   2.2624282E-03,   1.9223400E-03,   1.6252059E-03
     +,   1.3671854E-03,   1.1444768E-03,   9.5335324E-04
     +,   7.9025701E-04,   6.5185275E-04,   5.3504528E-04
     +,   4.3699145E-04,   3.5511731E-04,   2.8711956E-04
     +,   2.3094899E-04,   1.8479562E-04,   1.4707721E-04
     +,   1.1642216E-04,   9.1647176E-05,   7.1737064E-05
     +,   5.5828372E-05,   4.3192642E-05,   3.3216493E-05
     +,   2.5388224E-05,   1.9284133E-05,   1.4555006E-05
     +,   1.0914878E-05,   8.1315056E-06,   6.0176849E-06
     +,   4.4234257E-06,   3.2293565E-06,   2.3413234E-06
     +,   1.6856395E-06,   1.2050369E-06,   8.5533105E-07
     +,   6.0274687E-07,   4.2168392E-07,   2.9286193E-07
     +,   2.0190029E-07,   1.3816404E-07,   9.3847802E-08
     +,   6.3270996E-08,   4.2336534E-08,   2.8115709E-08
     +,   1.8531040E-08,   1.2121343E-08,   7.8684055E-09
     +,   5.0687916E-09,   3.2404299E-09,   2.0557400E-09
     +,   1.2941603E-09,   8.0848184E-10,   5.0118987E-10
     +,   3.0830025E-10,   1.8818576E-10,   1.1398450E-10
     +,   6.8507811E-11,   4.0856447E-11,   2.4177519E-11
     +,   1.4197094E-11,   8.2721026E-12,   4.7824644E-12
     +,   2.7436118E-12,   1.5617565E-12,   8.8214538E-13
     +,   4.9441153E-13,   2.7496576E-13,   1.5173896E-13
     +,   8.3093329E-14,   4.5152020E-14,   2.4347776E-14
     +,   1.3028909E-14,   6.9192919E-15,   3.6470215E-15
     +,   1.9079407E-15,   9.9085395E-16,   5.1088115E-16
     +,   2.6158183E-16,   1.3303832E-16,   6.7238455E-17
     +,   3.3786321E-17,   1.6892087E-17,   8.4110272E-18
     +,   4.1766901E-18,   2.0718972E-18,   1.0291203E-18
     +,   5.1327172E-19,   2.5795829E-19
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_haonly_ttz110_mass = Yx/0.220866545454545
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_haonly_ttz115_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.6156812E-04,   4.6720883E-04
     +,   4.7349298E-04,   4.8049274E-04,   4.8828177E-04
     +,   4.9693492E-04,   5.0652819E-04,   5.1713822E-04
     +,   5.2884262E-04,   5.4171961E-04,   5.5584795E-04
     +,   5.7130755E-04,   5.8817997E-04,   6.0654868E-04
     +,   6.2650040E-04,   6.4812589E-04,   6.7152124E-04
     +,   6.9679029E-04,   7.2404568E-04,   7.5341068E-04
     +,   7.8502257E-04,   8.1903406E-04,   8.5561501E-04
     +,   8.9495885E-04,   9.3727716E-04,   9.8281051E-04
     +,   1.0318238E-03,   1.0846101E-03,   1.1414910E-03
     +,   1.2028164E-03,   1.2689633E-03,   1.3403348E-03
     +,   1.4173561E-03,   1.5004710E-03,   1.5901364E-03
     +,   1.6868162E-03,   1.7909728E-03,   1.9030564E-03
     +,   2.0235055E-03,   2.1527139E-03,   2.2910456E-03
     +,   2.4388018E-03,   2.5962177E-03,   2.7634471E-03
     +,   2.9405507E-03,   3.1274806E-03,   3.3240728E-03
     +,   3.5300353E-03,   3.7449358E-03,   3.9681992E-03
     +,   4.1990965E-03,   4.4367462E-03,   4.6801060E-03
     +,   4.9279956E-03,   5.1790546E-03,   5.4318099E-03
     +,   5.6846379E-03,   5.9357998E-03,   6.1834520E-03
     +,   6.4256671E-03,   6.6604535E-03,   6.8857889E-03
     +,   7.0996243E-03,   7.2999541E-03,   7.4848207E-03
     +,   7.6523339E-03,   7.8007574E-03,   7.9284869E-03
     +,   8.0341343E-03,   8.1165275E-03,   8.1747677E-03
     +,   8.2082469E-03,   8.2166847E-03,   8.2001435E-03
     +,   8.1590535E-03,   8.0942167E-03,   8.0068167E-03
     +,   7.8984210E-03,   7.7709532E-03,   7.6266821E-03
     +,   7.4682022E-03,   7.2983699E-03,   7.1202945E-03
     +,   6.9372468E-03,   6.7526363E-03,   6.5699136E-03
     +,   6.3925399E-03,   6.2238779E-03,   6.0671614E-03
     +,   5.9253927E-03,   5.8012996E-03,   5.6972732E-03
     +,   5.6153149E-03,   5.5569806E-03,   5.5233566E-03
     +,   5.5150338E-03,   5.5320878E-03,   5.5740797E-03
     +,   5.6400630E-03,   5.7286001E-03,   5.8378023E-03
     +,   5.9653488E-03,   6.1085653E-03,   6.2644454E-03
     +,   6.4297430E-03,   6.6010286E-03,   6.7747468E-03
     +,   6.9472925E-03,   7.1151061E-03,   7.2747194E-03
     +,   7.4228044E-03,   7.5562824E-03,   7.6723294E-03
     +,   7.7684592E-03,   7.8425342E-03,   7.8928256E-03
     +,   7.9180030E-03,   7.9171751E-03,   7.8898696E-03
     +,   7.8360513E-03,   7.7560786E-03,   7.6507023E-03
     +,   7.5210398E-03,   7.3685232E-03,   7.1948604E-03
     +,   7.0020254E-03,   6.7921611E-03,   6.5675871E-03
     +,   6.3307011E-03,   6.0839900E-03,   5.8299266E-03
     +,   5.5709938E-03,   5.3095832E-03,   5.0480268E-03
     +,   4.7885147E-03,   4.5330948E-03,   4.2836722E-03
     +,   4.0419754E-03,   3.8095380E-03,   3.5876986E-03
     +,   3.3776264E-03,   3.1803008E-03,   2.9965001E-03
     +,   2.8268294E-03,   2.6717423E-03,   2.5315185E-03
     +,   2.4062924E-03,   2.2960729E-03,   2.2007462E-03
     +,   2.1200818E-03,   2.0537539E-03,   2.0013554E-03
     +,   1.9624056E-03,   1.9363535E-03,   1.9225986E-03
     +,   1.9204951E-03,   1.9293585E-03,   1.9484749E-03
     +,   1.9771082E-03,   2.0145024E-03,   2.0598907E-03
     +,   2.1124987E-03,   2.1715455E-03,   2.2362466E-03
     +,   2.3058250E-03,   2.3795073E-03,   2.4565228E-03
     +,   2.5361085E-03,   2.6175177E-03,   2.7000159E-03
     +,   2.7828764E-03,   2.8653916E-03,   2.9468737E-03
     +,   3.0266566E-03,   3.1040881E-03,   3.1785471E-03
     +,   3.2494399E-03,   3.3161954E-03,   3.3782755E-03
     +,   3.4351801E-03,   3.4864452E-03,   3.5316411E-03
     +,   3.5703832E-03,   3.6023313E-03,   3.6271939E-03
     +,   3.6447239E-03,   3.6547272E-03,   3.6570632E-03
     +,   3.6516418E-03,   3.6384317E-03,   3.6174501E-03
     +,   3.5887728E-03,   3.5525274E-03,   3.5088949E-03
     +,   3.4581074E-03,   3.4004406E-03,   3.3362198E-03
     +,   3.2658149E-03,   3.1896287E-03,   3.1080968E-03
     +,   3.0216903E-03,   2.9309054E-03,   2.8362523E-03
     +,   2.7382560E-03,   2.6374590E-03,   2.5343995E-03
     +,   2.4296150E-03,   2.3236426E-03,   2.2170092E-03
     +,   2.1102203E-03,   2.0037605E-03,   1.8980992E-03
     +,   1.7936790E-03,   1.6909054E-03,   1.5901536E-03
     +,   1.4917698E-03,   1.3960659E-03,   1.3033109E-03
     +,   1.2137373E-03,   1.1275496E-03,   1.0449073E-03
     +,   9.6593495E-04,   8.9072814E-04,   8.1934902E-04
     +,   7.5182458E-04,   6.8815285E-04,   6.2830979E-04
     +,   5.7224673E-04,   5.1988888E-04,   4.7114337E-04
     +,   4.2590333E-04,   3.8404739E-04,   3.4543939E-04
     +,   3.0993449E-04,   2.7738375E-04,   2.4762983E-04
     +,   2.2051251E-04,   1.9587218E-04,   1.7354923E-04
     +,   1.5338423E-04,   1.3522111E-04,   1.1890915E-04
     +,   1.0430245E-04,   9.1259899E-05,   7.9646983E-05
     +,   6.9336878E-05,   6.0209684E-05,   5.2152285E-05
     +,   4.5059161E-05,   3.8832855E-05,   3.3382581E-05
     +,   2.8624814E-05,   2.4483264E-05,   2.0888256E-05
     +,   1.7776201E-05,   1.5089581E-05,   1.2776712E-05
     +,   1.0791136E-05,   9.0911526E-06,   7.6396263E-06
     +,   6.4036685E-06,   5.3541648E-06,   4.4653825E-06
     +,   3.7147263E-06,   3.0824888E-06,   2.5514103E-06
     +,   2.1064948E-06,   1.7347805E-06,   1.4250684E-06
     +,   1.1677006E-06,   9.5439623E-07,   7.7809119E-07
     +,   6.3276144E-07,   5.1328010E-07,   4.1530828E-07
     +,   3.3519302E-07,   2.6984952E-07,   2.1669898E-07
     +,   1.7357787E-07,   1.3868863E-07,   1.1053248E-07
     +,   8.7871513E-08,   6.9680191E-08,   5.5116299E-08
     +,   4.3486438E-08,   3.4224559E-08,   2.6867575E-08
     +,   2.1038886E-08,   1.6433390E-08,   1.2803712E-08
     +,   9.9507336E-09,   7.7139859E-09,   5.9650391E-09
     +,   4.6010005E-09,   3.5399990E-09,   2.7168030E-09
     +,   2.0798196E-09,   1.5881725E-09,   1.2097136E-09
     +,   9.1911956E-10,   6.9658490E-10
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_haonly_ttz115_mass = Yx/0.211663772727273
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_haonly_ttz120_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.2932053E-03,   3.4456661E-03
     +,   3.5983152E-03,   3.7506078E-03,   3.9019880E-03
     +,   4.0518837E-03,   4.1997205E-03,   4.3449178E-03
     +,   4.4868989E-03,   4.6250988E-03,   4.7589629E-03
     +,   4.8879539E-03,   5.0115618E-03,   5.1293061E-03
     +,   5.2407412E-03,   5.3454647E-03,   5.4431176E-03
     +,   5.5333925E-03,   5.6160372E-03,   5.6908578E-03
     +,   5.7577216E-03,   5.8165579E-03,   5.8673625E-03
     +,   5.9101996E-03,   5.9451913E-03,   5.9725312E-03
     +,   5.9924708E-03,   6.0053184E-03,   6.0114372E-03
     +,   6.0112439E-03,   6.0051922E-03,   5.9937765E-03
     +,   5.9775179E-03,   5.9569594E-03,   5.9326598E-03
     +,   5.9051784E-03,   5.8750734E-03,   5.8428939E-03
     +,   5.8091618E-03,   5.7743797E-03,   5.7390085E-03
     +,   5.7034721E-03,   5.6681484E-03,   5.6333630E-03
     +,   5.5993898E-03,   5.5664447E-03,   5.5346880E-03
     +,   5.5042249E-03,   5.4751066E-03,   5.4473318E-03
     +,   5.4208562E-03,   5.3955899E-03,   5.3714127E-03
     +,   5.3481758E-03,   5.3257113E-03,   5.3038415E-03
     +,   5.2823899E-03,   5.2611874E-03,   5.2400846E-03
     +,   5.2189566E-03,   5.1977192E-03,   5.1763281E-03
     +,   5.1547941E-03,   5.1331837E-03,   5.1116240E-03
     +,   5.0903102E-03,   5.0695026E-03,   5.0495267E-03
     +,   5.0307731E-03,   5.0136955E-03,   4.9987962E-03
     +,   4.9866284E-03,   4.9777795E-03,   4.9728607E-03
     +,   4.9725007E-03,   4.9773203E-03,   4.9879295E-03
     +,   5.0049005E-03,   5.0287610E-03,   5.0599761E-03
     +,   5.0989259E-03,   5.1459023E-03,   5.2010864E-03
     +,   5.2645449E-03,   5.3362083E-03,   5.4158838E-03
     +,   5.5032233E-03,   5.5977521E-03,   5.6988415E-03
     +,   5.8057359E-03,   5.9175477E-03,   6.0332664E-03
     +,   6.1517702E-03,   6.2718587E-03,   6.3922526E-03
     +,   6.5116100E-03,   6.6285683E-03,   6.7417403E-03
     +,   6.8497616E-03,   6.9512855E-03,   7.0450376E-03
     +,   7.1297996E-03,   7.2044604E-03,   7.2680139E-03
     +,   7.3195817E-03,   7.3584216E-03,   7.3839403E-03
     +,   7.3956973E-03,   7.3934095E-03,   7.3769507E-03
     +,   7.3463535E-03,   7.3017920E-03,   7.2435928E-03
     +,   7.1722036E-03,   7.0882002E-03,   6.9922600E-03
     +,   6.8851560E-03,   6.7677270E-03,   6.6408883E-03
     +,   6.5055848E-03,   6.3627926E-03,   6.2135085E-03
     +,   6.0587302E-03,   5.8994358E-03,   5.7365797E-03
     +,   5.5710948E-03,   5.4038581E-03,   5.2357172E-03
     +,   5.0674467E-03,   4.8997882E-03,   4.7334088E-03
     +,   4.5689335E-03,   4.4069150E-03,   4.2478689E-03
     +,   4.0922496E-03,   3.9404575E-03,   3.7928575E-03
     +,   3.6497796E-03,   3.5115040E-03,   3.3782776E-03
     +,   3.2503291E-03,   3.1278611E-03,   3.0110446E-03
     +,   2.9000335E-03,   2.7949749E-03,   2.6959882E-03
     +,   2.6031798E-03,   2.5166490E-03,   2.4364807E-03
     +,   2.3627405E-03,   2.2954806E-03,   2.2347430E-03
     +,   2.1805512E-03,   2.1329098E-03,   2.0918029E-03
     +,   2.0571980E-03,   2.0290397E-03,   2.0072472E-03
     +,   1.9917164E-03,   1.9823185E-03,   1.9788973E-03
     +,   1.9812700E-03,   1.9892270E-03,   2.0025317E-03
     +,   2.0209206E-03,   2.0441050E-03,   2.0717706E-03
     +,   2.1035790E-03,   2.1391716E-03,   2.1781707E-03
     +,   2.2201778E-03,   2.2647802E-03,   2.3115538E-03
     +,   2.3600655E-03,   2.4098705E-03,   2.4605244E-03
     +,   2.5115828E-03,   2.5625990E-03,   2.6131319E-03
     +,   2.6627516E-03,   2.7110402E-03,   2.7575900E-03
     +,   2.8020097E-03,   2.8439313E-03,   2.8830073E-03
     +,   2.9189116E-03,   2.9513447E-03,   2.9800362E-03
     +,   3.0047444E-03,   3.0252556E-03,   3.0413901E-03
     +,   3.0529974E-03,   3.0599602E-03,   3.0621937E-03
     +,   3.0596454E-03,   3.0522931E-03,   3.0401468E-03
     +,   3.0232472E-03,   3.0016631E-03,   2.9754890E-03
     +,   2.9448497E-03,   2.9098927E-03,   2.8707869E-03
     +,   2.8277209E-03,   2.7809066E-03,   2.7305679E-03
     +,   2.6769417E-03,   2.6202807E-03,   2.5608474E-03
     +,   2.4989084E-03,   2.4347343E-03,   2.3686022E-03
     +,   2.3007912E-03,   2.2315751E-03,   2.1612230E-03
     +,   2.0900047E-03,   2.0181830E-03,   1.9460078E-03
     +,   1.8737204E-03,   1.8015573E-03,   1.7297369E-03
     +,   1.6584652E-03,   1.5879389E-03,   1.5183412E-03
     +,   1.4498367E-03,   1.3825742E-03,   1.3166944E-03
     +,   1.2523213E-03,   1.1895611E-03,   1.1285060E-03
     +,   1.0692378E-03,   1.0118252E-03,   9.5631910E-04
     +,   9.0275973E-04,   8.5117953E-04,   8.0159551E-04
     +,   7.5401447E-04,   7.0843648E-04,   6.6485308E-04
     +,   6.2324456E-04,   5.8358436E-04,   5.4584199E-04
     +,   5.0998136E-04,   4.7595846E-04,   4.4372556E-04
     +,   4.1323312E-04,   3.8442877E-04,   3.5725534E-04
     +,   3.3165427E-04,   3.0756780E-04,   2.8493497E-04
     +,   2.6369435E-04,   2.4378591E-04,   2.2514963E-04
     +,   2.0772472E-04,   1.9145136E-04,   1.7627190E-04
     +,   1.6212984E-04,   1.4896900E-04,   1.3673499E-04
     +,   1.2537578E-04,   1.1484115E-04,   1.0508188E-04
     +,   9.6050775E-05,   8.7703411E-05,   7.9996389E-05
     +,   7.2888368E-05,   6.6340326E-05,   6.0315149E-05
     +,   5.4777171E-05,   4.9692586E-05,   4.5029785E-05
     +,   4.0758809E-05,   3.6851121E-05,   3.3279866E-05
     +,   3.0020150E-05,   2.7048103E-05,   2.4341749E-05
     +,   2.1880151E-05,   1.9644038E-05,   1.7615112E-05
     +,   1.5776590E-05,   1.4112562E-05,   1.2608471E-05
     +,   1.1250586E-05,   1.0026357E-05,   8.9240129E-06
     +,   7.9326956E-06,   7.0424517E-06,   6.2439881E-06
     +,   5.5288538E-06,   4.8891729E-06,   4.3178061E-06
     +,   3.8081205E-06,   3.3541185E-06,   2.9502537E-06
     +,   2.5915147E-06,   2.2732897E-06,   1.9914221E-06
     +,   1.7420978E-06,   1.5218906E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_haonly_ttz120_mass = Yx/0.246474260869565
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_haonly_ttz60_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.4541735E-09,   4.2128288E-09
     +,   7.1590316E-09,   1.2043367E-08,   2.0056532E-08
     +,   3.3065827E-08,   5.3965792E-08,   8.7191452E-08
     +,   1.3945728E-07,   2.2081420E-07,   3.4612069E-07
     +,   5.3708311E-07,   8.2502726E-07,   1.2546047E-06
     +,   1.8886698E-06,   2.8145917E-06,   4.1522544E-06
     +,   6.0640364E-06,   8.7669614E-06,   1.2547195E-05
     +,   1.7776887E-05,   2.4933244E-05,   3.4619210E-05
     +,   4.7586283E-05,   6.4754480E-05,   8.7235821E-05
     +,   1.1634937E-04,   1.5363428E-04,   2.0085384E-04
     +,   2.5998952E-04,   3.3322172E-04,   4.2289618E-04
     +,   5.3147384E-04,   6.6146418E-04,   8.1534206E-04
     +,   9.9545124E-04,   1.2038979E-03,   1.4424358E-03
     +,   1.7123780E-03,   2.0144500E-03,   2.3487711E-03
     +,   2.7147455E-03,   3.1110579E-03,   3.5356723E-03
     +,   3.9858697E-03,   4.4583157E-03,   4.9491427E-03
     +,   5.4540592E-03,   5.9684427E-03,   6.4874399E-03
     +,   7.0060450E-03,   7.5191786E-03,   8.0217328E-03
     +,   8.5087009E-03,   8.9751957E-03,   9.4167432E-03
     +,   9.8294606E-03,   1.0210463E-02,   1.0558325E-02
     +,   1.0873638E-02,   1.1159567E-02,   1.1422371E-02
     +,   1.1671687E-02,   1.1920614E-02,   1.2185282E-02
     +,   1.2483979E-02,   1.2835826E-02,   1.3258935E-02
     +,   1.3768489E-02,   1.4374694E-02,   1.5081323E-02
     +,   1.5884768E-02,   1.6774386E-02,   1.7733580E-02
     +,   1.8742228E-02,   1.9779477E-02,   2.0826481E-02
     +,   2.1868646E-02,   2.2896480E-02,   2.3904650E-02
     +,   2.4889320E-02,   2.5844611E-02,   2.6758410E-02
     +,   2.7609522E-02,   2.8366528E-02,   2.8989708E-02
     +,   2.9435581E-02,   2.9663809E-02,   2.9644741E-02
     +,   2.9366251E-02,   2.8837999E-02,   2.8092286E-02
     +,   2.7181048E-02,   2.6169699E-02,   2.5129190E-02
     +,   2.4127929E-02,   2.3224622E-02,   2.2463696E-02
     +,   2.1872664E-02,   2.1462049E-02,   2.1226404E-02
     +,   2.1146405E-02,   2.1191139E-02,   2.1320643E-02
     +,   2.1488804E-02,   2.1646630E-02,   2.1746015E-02
     +,   2.1743776E-02,   2.1605508E-02,   2.1308597E-02
     +,   2.0844035E-02,   2.0216502E-02,   1.9443028E-02
     +,   1.8550055E-02,   1.7570075E-02,   1.6537601E-02
     +,   1.5485988E-02,   1.4444450E-02,   1.3436545E-02
     +,   1.2479094E-02,   1.1582292E-02,   1.0750378E-02
     +,   9.9826101E-03,   9.2744743E-03,   8.6190570E-03
     +,   8.0083339E-03,   7.4341116E-03,   6.8890592E-03
     +,   6.3671721E-03,   5.8642826E-03,   5.3780358E-03
     +,   4.9079177E-03,   4.4548488E-03,   4.0209205E-03
     +,   3.6088394E-03,   3.2215440E-03,   2.8618339E-03
     +,   2.5320372E-03,   2.2337842E-03,   1.9679305E-03
     +,   1.7345549E-03,   1.5329913E-03,   1.3619270E-03
     +,   1.2195539E-03,   1.1037199E-03,   1.0120390E-03
     +,   9.4202999E-04,   8.9121709E-04,   8.5719879E-04
     +,   8.3770085E-04,   8.3061447E-04,   8.3401205E-04
     +,   8.4614969E-04,   8.6546462E-04,   8.9056505E-04
     +,   9.2021434E-04,   9.5331628E-04,   9.8890229E-04
     +,   1.0261142E-03,   1.0641877E-03,   1.1024455E-03
     +,   1.1402851E-03,   1.1771651E-03,   1.2126022E-03
     +,   1.2461662E-03,   1.2774734E-03,   1.3061807E-03
     +,   1.3319855E-03,   1.3546261E-03,   1.3738780E-03
     +,   1.3895517E-03,   1.4014951E-03,   1.4095937E-03
     +,   1.4137685E-03,   1.4139764E-03,   1.4102113E-03
     +,   1.4025007E-03,   1.3909073E-03,   1.3755277E-03
     +,   1.3564880E-03,   1.3339444E-03,   1.3080813E-03
     +,   1.2791079E-03,   1.2472536E-03,   1.2127662E-03
     +,   1.1759108E-03,   1.1369652E-03,   1.0962136E-03
     +,   1.0539441E-03,   1.0104519E-03,   9.6602587E-04
     +,   9.2095049E-04,   8.7550527E-04,   8.2995958E-04
     +,   7.8456727E-04,   7.3956733E-04,   6.9518434E-04
     +,   6.5162568E-04,   6.0907583E-04,   5.6769955E-04
     +,   5.2764337E-04,   4.8903323E-04,   4.5197163E-04
     +,   4.1654086E-04,   3.8280713E-04,   3.5081428E-04
     +,   3.2058856E-04,   2.9214157E-04,   2.6546960E-04
     +,   2.4055302E-04,   2.1736026E-04,   1.9585011E-04
     +,   1.7597206E-04,   1.5766600E-04,   1.4086567E-04
     +,   1.2550085E-04,   1.1149728E-04,   9.8777069E-05
     +,   8.7261076E-05,   7.6870718E-05,   6.7526707E-05
     +,   5.9151047E-05,   5.1668201E-05,   4.5004934E-05
     +,   3.9090468E-05,   3.3857392E-05,   2.9242194E-05
     +,   2.5185014E-05,   2.1629592E-05,   1.8523622E-05
     +,   1.5818925E-05,   1.3471123E-05,   1.1439429E-05
     +,   9.6866961E-06,   8.1794215E-06,   6.8872073E-06
     +,   5.7827478E-06,   4.8417064E-06,   4.0423902E-06
     +,   3.3655126E-06,   2.7940498E-06,   2.3130769E-06
     +,   1.9095075E-06,   1.5719024E-06,   1.2903258E-06
     +,   1.0561988E-06,   8.6211935E-07,   7.0171598E-07
     +,   5.6954087E-07,   4.6096028E-07,   3.7202690E-07
     +,   2.9940145E-07,   2.4027338E-07,   1.9227919E-07
     +,   1.5343730E-07,   1.2209499E-07,   9.6880520E-08
     +,   7.6656647E-08,   6.0483224E-08,   4.7586937E-08
     +,   3.7334651E-08,   2.9208616E-08,   2.2786669E-08
     +,   1.7726309E-08,   1.3750873E-08,   1.0636845E-08
     +,   8.2047054E-09,   6.3107839E-09,   4.8403646E-09
     +,   3.7020600E-09,   2.8234206E-09,   2.1472242E-09
     +,   1.6283731E-09,   1.2314032E-09,   9.2856595E-10
     +,   6.9823103E-10,   5.2354160E-10,   3.9145098E-10
     +,   2.9185596E-10,   2.1698708E-10,   1.6086617E-10
     +,   1.1892384E-10,   8.7667297E-11,   6.4443742E-11
     +,   4.7237592E-11,   3.4527808E-11,   2.5166223E-11
     +,   1.8290794E-11,   1.3256216E-11,   9.5801127E-12
     +,   6.9039175E-12,   4.9611621E-12,   3.5550445E-12
     +,   2.5402100E-12,   1.8099538E-12,   1.2859636E-12
     +,   9.1109282E-13,   6.4366448E-13,   4.5344959E-13
     +,   3.1853825E-13,   2.2313421E-13
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_haonly_ttz60_mass = Yx/0.365987192307692
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_haonly_ttz65_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.5730420E-05,   1.8241739E-05
     +,   2.1091082E-05,   2.4312998E-05,   2.7943781E-05
     +,   3.2021271E-05,   3.6584668E-05,   4.1674135E-05
     +,   4.7330403E-05,   5.3594675E-05,   6.0507646E-05
     +,   6.8109264E-05,   7.6437995E-05,   8.5530337E-05
     +,   9.5419884E-05,   1.0613673E-04,   1.1770678E-04
     +,   1.3015082E-04,   1.4348389E-04,   1.5771454E-04
     +,   1.7284423E-04,   1.8886667E-04,   2.0576733E-04
     +,   2.2352443E-04,   2.4210602E-04,   2.6147423E-04
     +,   2.8158259E-04,   3.0237870E-04,   3.2380552E-04
     +,   3.4580333E-04,   3.6831253E-04,   3.9127673E-04
     +,   4.1464707E-04,   4.3838684E-04,   4.6247686E-04
     +,   4.8692164E-04,   5.1175623E-04,   5.3705304E-04
     +,   5.6293147E-04,   5.8956124E-04,   6.1717659E-04
     +,   6.4607954E-04,   6.7664968E-04,   7.0935162E-04
     +,   7.4474211E-04,   7.8347675E-04,   8.2631584E-04
     +,   8.7413000E-04,   9.2790398E-04,   9.8873943E-04
     +,   1.0578553E-03,   1.1365842E-03,   1.2263646E-03
     +,   1.3287341E-03,   1.4452917E-03,   1.5776901E-03
     +,   1.7275758E-03,   1.8965462E-03,   2.0860822E-03
     +,   2.2974752E-03,   2.5317459E-03,   2.7895663E-03
     +,   3.0711608E-03,   3.3762935E-03,   3.7042273E-03
     +,   4.0537361E-03,   4.4233068E-03,   4.8113060E-03
     +,   5.2164742E-03,   5.6383889E-03,   6.0782903E-03
     +,   6.5397373E-03,   7.0294337E-03,   7.5575183E-03
     +,   8.1375279E-03,   8.7854387E-03,   9.5178904E-03
     +,   1.0349814E-02,   1.1291962E-02,   1.2348964E-02
     +,   1.3518573E-02,   1.4793023E-02,   1.6161259E-02
     +,   1.7612521E-02,   1.9138871E-02,   2.0737482E-02
     +,   2.2411190E-02,   2.4169499E-02,   2.6028167E-02
     +,   2.8007964E-02,   3.0128492E-02,   3.2395706E-02
     +,   3.4784261E-02,   3.7220459E-02,   3.9574802E-02
     +,   4.1673686E-02,   4.3334637E-02,   4.4417311E-02
     +,   4.4876285E-02,   4.4793718E-02,   4.4375740E-02
     +,   4.3906532E-02,   4.3672200E-02,   4.3880317E-02
     +,   4.4605020E-02,   4.5776974E-02,   4.7216907E-02
     +,   4.8693012E-02,   4.9974754E-02,   5.0865721E-02
     +,   5.1214721E-02,   5.0918192E-02,   4.9925424E-02
     +,   4.8249345E-02,   4.5974787E-02,   4.3252092E-02
     +,   4.0273741E-02,   3.7237596E-02,   3.4311756E-02
     +,   3.1610005E-02,   2.9185755E-02,   2.7042028E-02
     +,   2.5150936E-02,   2.3475099E-02,   2.1984305E-02
     +,   2.0663563E-02,   1.9511694E-02,   1.8534159E-02
     +,   1.7732861E-02,   1.7098173E-02,   1.6604735E-02
     +,   1.6212711E-02,   1.5872901E-02,   1.5534178E-02
     +,   1.5150764E-02,   1.4687856E-02,   1.4124683E-02
     +,   1.3454859E-02,   1.2684623E-02,   1.1829895E-02
     +,   1.0912933E-02,   9.9590868E-03,   8.9940242E-03
     +,   8.0417804E-03,   7.1234619E-03,   6.2561915E-03
     +,   5.4527852E-03,   4.7217170E-03,   4.0672743E-03
     +,   3.4899605E-03,   2.9871850E-03,   2.5540211E-03
     +,   2.1839344E-03,   1.8695001E-03,   1.6030732E-03
     +,   1.3773039E-03,   1.1854675E-03,   1.0216655E-03
     +,   8.8092714E-04,   7.5920520E-04,   6.5326993E-04
     +,   5.6060759E-04,   4.7929163E-04,   4.0784429E-04
     +,   3.4511540E-04,   2.9018940E-04,   2.4231058E-04
     +,   2.0082147E-04,   1.6512151E-04,   1.3464723E-04
     +,   1.0886074E-04,   8.7243148E-05,   6.9294394E-05
     +,   5.4539112E-05,   4.2532607E-05,   3.2862536E-05
     +,   2.5154404E-05,   1.9074114E-05,   1.4327858E-05
     +,   1.0661271E-05,   7.8580624E-06,   5.7371767E-06
     +,   4.1491362E-06,   2.9722585E-06,   2.1090059E-06
     +,   1.4822933E-06,   1.0319527E-06,   7.1162225E-07
     +,   4.8606790E-07,   3.2886103E-07,   2.2038931E-07
     +,   1.4629364E-07,   9.6188373E-08,   6.2645228E-08
     +,   4.0412470E-08,   2.5822544E-08,   1.6343487E-08
     +,   1.0246110E-08,   6.3626153E-09,   3.9135135E-09
     +,   2.3842999E-09,   1.4388790E-09,   8.6010060E-10
     +,   5.0924781E-10,   2.9866129E-10,   1.7349666E-10
     +,   9.9829138E-11,   5.6896553E-11,   3.2120594E-11
     +,   1.7961613E-11,   9.9485420E-12,   5.4580307E-12
     +,   2.9660822E-12,   1.5965876E-12,   8.5124708E-13
     +,   4.4955213E-13,   2.3516679E-13,   1.2185244E-13
     +,   6.2538143E-14,   3.1792748E-14,   1.6009314E-14
     +,   7.9849211E-15,   3.9448391E-15,   1.9304575E-15
     +,   9.3573837E-16,   4.4926167E-16,   2.1365191E-16
     +,   1.0064386E-16,   4.6960228E-17,   2.1703163E-17
     +,   9.9352581E-18,   4.5051408E-18,   2.0234813E-18
     +,   9.0020546E-19,   3.9669543E-19,   1.7315474E-19
     +,   7.4862010E-20,   3.2059262E-20,   1.3599368E-20
     +,   5.7140482E-21,   2.3780481E-21,   9.8030021E-22
     +,   4.0028792E-22,   1.6190088E-22,   6.4859620E-23
     +,   2.5737209E-23,   1.0116388E-23,   3.9386890E-24
     +,   1.5188930E-24,   5.8020158E-25,   2.1953109E-25
     +,   8.2274716E-26,   3.0542414E-26,   1.1231154E-26
     +,   4.0908674E-27,   1.4759654E-27,   5.2750321E-28
     +,   1.8676608E-28,   6.5508918E-29,   2.2764674E-29
     +,   7.8389524E-30,   2.6755660E-30,   9.0549477E-31
     +,   3.0404354E-31,   1.0140245E-31,   3.3646815E-32
     +,   1.1137401E-32,   3.6936666E-33,   1.2354656E-33
     +,   4.2073037E-34,   1.4769575E-34,   5.4201574E-35
     +,   2.1047136E-35,   8.6970353E-36,   3.8125262E-36
     +,   1.7551058E-36,   8.3739498E-37,   4.0909566E-37
     +,   2.0269637E-37,   9.9201831E-38,   5.0127114E-38
     +,   2.5254386E-38,   1.2685341E-38,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_haonly_ttz65_mass = Yx/0.491691
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_haonly_ttz70_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.1792739E-07,   1.5940233E-07
     +,   2.1442921E-07,   2.8706637E-07,   3.8246259E-07
     +,   5.0711139E-07,   6.6915248E-07,   8.7872496E-07
     +,   1.1483771E-06,   1.4935616E-06,   1.9331535E-06
     +,   2.4900789E-06,   3.1919988E-06,   4.0720665E-06
     +,   5.1697348E-06,   6.5316499E-06,   8.2125471E-06
     +,   1.0276191E-05,   1.2796335E-05,   1.5857589E-05
     +,   1.9556277E-05,   2.4001163E-05,   2.9313882E-05
     +,   3.5629750E-05,   4.3096759E-05,   5.1876712E-05
     +,   6.2143321E-05,   7.4081559E-05,   8.7885935E-05
     +,   1.0375809E-04,   1.2190401E-04,   1.4253042E-04
     +,   1.6584083E-04,   1.9203059E-04,   2.2128188E-04
     +,   2.5375804E-04,   2.8959749E-04,   3.2890736E-04
     +,   3.7176072E-04,   4.1818377E-04,   4.6816064E-04
     +,   5.2162161E-04,   5.7844433E-04,   6.3845189E-04
     +,   7.0141366E-04,   7.6704921E-04,   8.3503325E-04
     +,   9.0500427E-04,   9.7657624E-04,   1.0493527E-03
     +,   1.1229444E-03,   1.1969892E-03,   1.2711750E-03
     +,   1.3452697E-03,   1.4191368E-03,   1.4927814E-03
     +,   1.5663662E-03,   1.6402459E-03,   1.7149989E-03
     +,   1.7914473E-03,   1.8706830E-03,   1.9540817E-03
     +,   2.0433033E-03,   2.1403013E-03,   2.2472991E-03
     +,   2.3667470E-03,   2.5012961E-03,   2.6536970E-03
     +,   2.8267433E-03,   3.0231166E-03,   3.2452974E-03
     +,   3.4953554E-03,   3.7748362E-03,   4.0845098E-03
     +,   4.4242409E-03,   4.7927895E-03,   5.1876227E-03
     +,   5.6048161E-03,   6.0390369E-03,   6.4835520E-03
     +,   6.9303485E-03,   7.3705423E-03,   7.7947439E-03
     +,   8.1938505E-03,   8.5597904E-03,   8.8866632E-03
     +,   9.1718109E-03,   9.4171409E-03,   9.6302563E-03
     +,   9.8255696E-03,   1.0024939E-02,   1.0257676E-02
     +,   1.0559541E-02,   1.0970376E-02,   1.1530180E-02
     +,   1.2273819E-02,   1.3225532E-02,   1.4394207E-02
     +,   1.5772121E-02,   1.7337875E-02,   1.9065326E-02
     +,   2.0935951E-02,   2.2953032E-02,   2.5150841E-02
     +,   2.7595159E-02,   3.0369641E-02,   3.3549178E-02
     +,   3.7167732E-02,   4.1194472E-02,   4.5533758E-02
     +,   5.0058182E-02,   5.4669332E-02,   5.9353836E-02
     +,   6.4197101E-02,   6.9315895E-02,   7.4718110E-02
     +,   8.0145389E-02,   8.5005544E-02,   8.8475145E-02
     +,   8.9773744E-02,   8.8487886E-02,   8.4772825E-02
     +,   7.9313464E-02,   7.3064983E-02,   6.6921383E-02
     +,   6.1480846E-02,   5.6991324E-02,   5.3448092E-02
     +,   5.0732791E-02,   4.8707988E-02,   4.7237746E-02
     +,   4.6171878E-02,   4.5337986E-02,   4.4560675E-02
     +,   4.3691389E-02,   4.2624522E-02,   4.1290812E-02
     +,   3.9638851E-02,   3.7624460E-02,   3.5218179E-02
     +,   3.2426350E-02,   2.9310515E-02,   2.5991704E-02
     +,   2.2634801E-02,   1.9417906E-02,   1.6496930E-02
     +,   1.3978924E-02,   1.1910118E-02,   1.0279287E-02
     +,   9.0326751E-03,   8.0939475E-03,   7.3826513E-03
     +,   6.8273577E-03,   6.3725044E-03,   5.9797671E-03
     +,   5.6257830E-03,   5.2981847E-03,   4.9915183E-03
     +,   4.7039362E-03,   4.4349148E-03,   4.1838721E-03
     +,   3.9496194E-03,   3.7302894E-03,   3.5234981E-03
     +,   3.3266265E-03,   3.1371335E-03,   2.9528153E-03
     +,   2.7719629E-03,   2.5934381E-03,   2.4167036E-03
     +,   2.2417828E-03,   2.0691603E-03,   1.8996525E-03
     +,   1.7342960E-03,   1.5742402E-03,   1.4206102E-03
     +,   1.2744355E-03,   1.1365978E-03,   1.0077783E-03
     +,   8.8843255E-04,   7.7879813E-04,   6.7891408E-04
     +,   5.8863359E-04,   5.0764787E-04,   4.3552389E-04
     +,   3.7173938E-04,   3.1570616E-04,   2.6679377E-04
     +,   2.2435711E-04,   1.8775849E-04,   1.5637385E-04
     +,   1.2960908E-04,   1.0690883E-04,   8.7759137E-05
     +,   7.1689276E-05,   5.8274098E-05,   4.7133995E-05
     +,   3.7931921E-05,   3.0370522E-05,   2.4190189E-05
     +,   1.9166077E-05,   1.5104332E-05,   1.1838710E-05
     +,   9.2278860E-06,   7.1526551E-06,   5.5126679E-06
     +,   4.2242555E-06,   3.2181424E-06,   2.4372657E-06
     +,   1.8349003E-06,   1.3731106E-06,   1.0213248E-06
     +,   7.5504249E-07,   5.5476039E-07,   4.0508422E-07
     +,   2.9395494E-07,   2.1198363E-07,   1.5191296E-07
     +,   1.0817903E-07,   7.6550343E-08,   5.3826319E-08
     +,   3.7607442E-08,   2.6108573E-08,   1.8010399E-08
     +,   1.2344816E-08,   8.4073308E-09,   5.6891238E-09
     +,   3.8251606E-09,   2.5554214E-09,   1.6961995E-09
     +,   1.1186554E-09,   7.3303685E-10,   4.7726284E-10
     +,   3.0873462E-10,   1.9843595E-10,   1.2672303E-10
     +,   8.0405307E-11,   5.0688780E-11,   3.1750148E-11
     +,   1.9759548E-11,   1.2217982E-11,   7.5062213E-12
     +,   4.5819277E-12,   2.7788969E-12,   1.6745055E-12
     +,   1.0025331E-12,   5.9636942E-13,   3.5247632E-13
     +,   2.0698273E-13,   1.2076569E-13,   7.0008378E-14
     +,   4.0322431E-14,   2.3074929E-14,   1.3120186E-14
     +,   7.4120059E-15,   4.1602637E-15,   2.3200842E-15
     +,   1.2855585E-15,   7.0774632E-16,   3.8712489E-16
     +,   2.1038905E-16,   1.1360574E-16,   6.0950314E-17
     +,   3.2489229E-17,   1.7207081E-17,   9.0547036E-18
     +,   4.7340192E-18,   2.4591265E-18,   1.2692296E-18
     +,   6.5087074E-19,   3.3161914E-19,   1.6787251E-19
     +,   8.4436070E-20,   4.2196196E-20,   2.0951041E-20
     +,   1.0335813E-20,   5.0660628E-21,   2.4672128E-21
     +,   1.1937900E-21,   5.7392627E-22,   2.7413919E-22
     +,   1.3010571E-22,   6.1348659E-23,   2.8742463E-23
     +,   1.3379086E-23,   6.1878636E-24,   2.8434801E-24
     +,   1.2982150E-24,   5.8891336E-25,   2.6542482E-25
     +,   1.1886165E-25,   5.2884157E-26,   2.3378656E-26
     +,   1.0268304E-26,   4.4811352E-27,   1.9429471E-27
     +,   8.3703573E-28,   3.5827155E-28,   1.5236694E-28
     +,   6.4380022E-29,   2.7028684E-29
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_haonly_ttz70_mass = Yx/0.6343778
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_haonly_ttz75_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.0307341E-04,   1.1161172E-04
     +,   1.2065237E-04,   1.3020696E-04,   1.4028599E-04
     +,   1.5089930E-04,   1.6205567E-04,   1.7376315E-04
     +,   1.8602898E-04,   1.9886020E-04,   2.1226295E-04
     +,   2.2624322E-04,   2.4080694E-04,   2.5596010E-04
     +,   2.7170911E-04,   2.8806087E-04,   3.0502322E-04
     +,   3.2260502E-04,   3.4081645E-04,   3.5966927E-04
     +,   3.7917684E-04,   3.9935464E-04,   4.2021959E-04
     +,   4.4179219E-04,   4.6409242E-04,   4.8714507E-04
     +,   5.1097467E-04,   5.3560821E-04,   5.6107377E-04
     +,   5.8740011E-04,   6.1461609E-04,   6.4275047E-04
     +,   6.7183073E-04,   7.0188241E-04,   7.3292834E-04
     +,   7.6498749E-04,   7.9807447E-04,   8.3219726E-04
     +,   8.6735975E-04,   9.0355432E-04,   9.4076886E-04
     +,   9.7897986E-04,   1.0181543E-03,   1.0582493E-03
     +,   1.0992106E-03,   1.1409739E-03,   1.1834636E-03
     +,   1.2265939E-03,   1.2702695E-03,   1.3143867E-03
     +,   1.3588340E-03,   1.4034942E-03,   1.4482454E-03
     +,   1.4929674E-03,   1.5375362E-03,   1.5818361E-03
     +,   1.6257568E-03,   1.6691993E-03,   1.7120790E-03
     +,   1.7543302E-03,   1.7959089E-03,   1.8367986E-03
     +,   1.8770103E-03,   1.9165912E-03,   1.9556242E-03
     +,   1.9942271E-03,   2.0325608E-03,   2.0708209E-03
     +,   2.1092435E-03,   2.1480951E-03,   2.1876737E-03
     +,   2.2282957E-03,   2.2702944E-03,   2.3140016E-03
     +,   2.3597456E-03,   2.4078349E-03,   2.4585477E-03
     +,   2.5121223E-03,   2.5687583E-03,   2.6286144E-03
     +,   2.6918061E-03,   2.7584378E-03,   2.8286111E-03
     +,   2.9024791E-03,   2.9802765E-03,   3.0623937E-03
     +,   3.1494291E-03,   3.2422745E-03,   3.3421621E-03
     +,   3.4507380E-03,   3.5700896E-03,   3.7027362E-03
     +,   3.8515932E-03,   4.0198872E-03,   4.2109983E-03
     +,   4.4282358E-03,   4.6746284E-03,   4.9525807E-03
     +,   5.2636364E-03,   5.6081139E-03,   5.9849150E-03
     +,   6.3912147E-03,   6.8223733E-03,   7.2717033E-03
     +,   7.7304957E-03,   8.1879897E-03,   8.6315116E-03
     +,   9.0469634E-03,   9.4197989E-03,   9.7367326E-03
     +,   9.9885063E-03,   1.0173948E-02,   1.0304897E-02
     +,   1.0411434E-02,   1.0545852E-02,   1.0783672E-02
     +,   1.1220192E-02,   1.1962606E-02,   1.3119565E-02
     +,   1.4792517E-02,   1.7072501E-02,   2.0043403E-02
     +,   2.3788270E-02,   2.8390491E-02,   3.3920210E-02
     +,   4.0401980E-02,   4.7771215E-02,   5.5827390E-02
     +,   6.4209647E-02,   7.2405294E-02,   7.9811528E-02
     +,   8.5837990E-02,   9.0032414E-02,   9.2176676E-02
     +,   9.2314281E-02,   9.0688467E-02,   8.7624498E-02
     +,   8.3418205E-02,   7.8287952E-02,   7.2404541E-02
     +,   6.5962136E-02,   5.9230767E-02,   5.2551601E-02
     +,   4.6277042E-02,   4.0689807E-02,   3.5940129E-02
     +,   3.2030407E-02,   2.8845776E-02,   2.6212189E-02
     +,   2.3958113E-02,   2.1958949E-02,   2.0153893E-02
     +,   1.8536374E-02,   1.7128814E-02,   1.5954657E-02
     +,   1.5018268E-02,   1.4297431E-02,   1.3747672E-02
     +,   1.3313480E-02,   1.2940604E-02,   1.2585046E-02
     +,   1.2217304E-02,   1.1822102E-02,   1.1395168E-02
     +,   1.0939015E-02,   1.0459099E-02,   9.9611757E-03
     +,   9.4498629E-03,   8.9282570E-03,   8.3983205E-03
     +,   7.8615546E-03,   7.3196143E-03,   6.7747328E-03
     +,   6.2299878E-03,   5.6893411E-03,   5.1573440E-03
     +,   4.6388968E-03,   4.1389484E-03,   3.6621499E-03
     +,   3.2125521E-03,   2.7934569E-03,   2.4073273E-03
     +,   2.0557034E-03,   1.7392024E-03,   1.4576054E-03
     +,   1.2099704E-03,   9.9472690E-04,   8.0979447E-04
     +,   6.5273873E-04,   5.2091043E-04,   4.1153489E-04
     +,   3.2183656E-04,   2.4912992E-04,   1.9087983E-04
     +,   1.4474933E-04,   1.0863693E-04,   8.0693047E-05
     +,   5.9318532E-05,   4.3155032E-05,   3.1070838E-05
     +,   2.2139053E-05,   1.5611922E-05,   1.0895396E-05
     +,   7.5251869E-06,   5.1439179E-06,   3.4799425E-06
     +,   2.3299713E-06,   1.5439698E-06,   1.0126201E-06
     +,   6.5731160E-07,   4.2228825E-07,   2.6851396E-07
     +,   1.6898653E-07,   1.0525857E-07,   6.4889477E-08
     +,   3.9591846E-08,   2.3908633E-08,   1.4289262E-08
     +,   8.4519307E-09,   4.9476663E-09,   2.8663443E-09
     +,   1.6433176E-09,   9.3234731E-10,   5.2347371E-10
     +,   2.9083941E-10,   1.5989400E-10,   8.6981901E-11
     +,   4.6820742E-11,   2.4936834E-11,   1.3140586E-11
     +,   6.8510371E-12,   3.5339713E-12,   1.8034900E-12
     +,   9.1051461E-13,   4.5476866E-13,   2.2470150E-13
     +,   1.0982715E-13,   5.3101105E-14,   2.5397314E-14
     +,   1.2015548E-14,   5.6227779E-15,   2.6026415E-15
     +,   1.1916189E-15,   5.3963373E-16,   2.4170525E-16
     +,   1.0707845E-16,   4.6919689E-17,   2.0334401E-17
     +,   8.7159608E-18,   3.6951626E-18,   1.5494499E-18
     +,   6.4261278E-19,   2.6362337E-19,   1.0698857E-19
     +,   4.2960885E-20,   1.7073100E-20,   6.7191049E-21
     +,   2.6212235E-21,   1.0153756E-21,   3.9172200E-22
     +,   1.5129889E-22,   5.9019746E-23,   2.3571359E-23
     +,   9.8241093E-24,   4.3675414E-24,   2.1069100E-24
     +,   1.1070416E-24,   6.2639436E-25,   3.7421190E-25
     +,   2.3147610E-25,   1.4608649E-25,   9.3173939E-26
     +,   5.9718601E-26,   3.8341537E-26,   2.4615879E-26
     +,   1.5789484E-26,   1.0113578E-26,   6.4673875E-27
     +,   4.1283726E-27,   2.6304744E-27,   1.6729030E-27
     +,   1.0619248E-27,   6.7280596E-28,   4.2546835E-28
     +,   2.6854195E-28,   1.6917668E-28,   1.0637527E-28
     +,   6.6758913E-29,   4.1817636E-29,   2.6144361E-29
     +,   1.6314604E-29,   1.0161162E-29,   6.3167222E-30
     +,   3.9192855E-30,   2.4271891E-30,   1.5002673E-30
     +,   9.2557917E-31,   5.6993491E-31,   3.5028253E-31
     +,   2.1487291E-31,   1.3156029E-31
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_haonly_ttz75_mass = Yx/0.551531689655172
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_haonly_ttz80_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.7975516E-07,   2.2673922E-07
     +,   2.8507023E-07,   3.5723750E-07,   4.4621299E-07
     +,   5.5553130E-07,   6.8937527E-07,   8.5267737E-07
     +,   1.0512210E-06,   1.2917772E-06,   1.5822125E-06
     +,   1.9316406E-06,   2.3505706E-06,   2.8510599E-06
     +,   3.4468876E-06,   4.1537223E-06,   4.9892856E-06
     +,   5.9735421E-06,   7.1288723E-06,   8.4802214E-06
     +,   1.0055276E-05,   1.1884600E-05,   1.4001708E-05
     +,   1.6443390E-05,   1.9249323E-05,   2.2462697E-05
     +,   2.6129768E-05,   3.0300011E-05,   3.5026020E-05
     +,   4.0363411E-05,   4.6370609E-05,   5.3108659E-05
     +,   6.0641025E-05,   6.9033224E-05,   7.8352590E-05
     +,   8.8667868E-05,   1.0004892E-04,   1.1256606E-04
     +,   1.2629095E-04,   1.4129361E-04,   1.5764548E-04
     +,   1.7541640E-04,   1.9467568E-04,   2.1549161E-04
     +,   2.3793129E-04,   2.6206049E-04,   2.8794358E-04
     +,   3.1564338E-04,   3.4522105E-04,   3.7673605E-04
     +,   4.1024559E-04,   4.4580470E-04,   4.8346445E-04
     +,   5.2327517E-04,   5.6527776E-04,   6.0951180E-04
     +,   6.5600662E-04,   7.0478290E-04,   7.5584924E-04
     +,   8.0920034E-04,   8.6481299E-04,   9.2264498E-04
     +,   9.8262611E-04,   1.0446639E-03,   1.1086350E-03
     +,   1.1743761E-03,   1.2416954E-03,   1.3103528E-03
     +,   1.3800771E-03,   1.4505452E-03,   1.5214016E-03
     +,   1.5922427E-03,   1.6626355E-03,   1.7321055E-03
     +,   1.8001578E-03,   1.8662780E-03,   1.9299361E-03
     +,   1.9906017E-03,   2.0477599E-03,   2.1009203E-03
     +,   2.1496236E-03,   2.1934686E-03,   2.2321153E-03
     +,   2.2653067E-03,   2.2928740E-03,   2.3147573E-03
     +,   2.3310070E-03,   2.3417971E-03,   2.3474281E-03
     +,   2.3483301E-03,   2.3450607E-03,   2.3382995E-03
     +,   2.3288433E-03,   2.3175883E-03,   2.3055193E-03
     +,   2.2936887E-03,   2.2831953E-03,   2.2751619E-03
     +,   2.2707107E-03,   2.2709358E-03,   2.2768821E-03
     +,   2.2895155E-03,   2.3097044E-03,   2.3381915E-03
     +,   2.3755759E-03,   2.4222899E-03,   2.4785725E-03
     +,   2.5444452E-03,   2.6196896E-03,   2.7038178E-03
     +,   2.7960304E-03,   2.8952069E-03,   2.9998592E-03
     +,   3.1081424E-03,   3.2178371E-03,   3.3264135E-03
     +,   3.4310888E-03,   3.5289978E-03,   3.6173856E-03
     +,   3.6939429E-03,   3.7571965E-03,   3.8070017E-03
     +,   3.8451287E-03,   3.8758868E-03,   3.9068009E-03
     +,   3.9493353E-03,   4.0197205E-03,   4.1399309E-03
     +,   4.3389131E-03,   4.6538813E-03,   5.1315273E-03
     +,   5.8281543E-03,   6.8080625E-03,   8.1384527E-03
     +,   9.8809293E-03,   1.2079583E-02,   1.4748367E-02
     +,   1.7862625E-02,   2.1359663E-02,   2.5150890E-02
     +,   2.9143857E-02,   3.3267412E-02,   3.7487801E-02
     +,   4.1804258E-02,   4.6220727E-02,   5.0701473E-02
     +,   5.5124402E-02,   5.9254609E-02,   6.2757604E-02
     +,   6.5259881E-02,   6.6447102E-02,   6.6171072E-02
     +,   6.4521812E-02,   6.1823912E-02,   5.8546185E-02
     +,   5.5154528E-02,   5.1968701E-02,   4.9085978E-02
     +,   4.6401687E-02,   4.3706235E-02,   4.0804956E-02
     +,   3.7606500E-02,   3.4149557E-02,   3.0572455E-02
     +,   2.7053578E-02,   2.3754533E-02,   2.0785108E-02
     +,   1.8193584E-02,   1.5976336E-02,   1.4096414E-02
     +,   1.2502046E-02,   1.1140218E-02,   9.9645276E-03
     +,   8.9382017E-03,   8.0338689E-03,   7.2314534E-03
     +,   6.5160543E-03,   5.8761393E-03,   5.3022285E-03
     +,   4.7861631E-03,   4.3208008E-03,   3.8998753E-03
     +,   3.5178897E-03,   3.1700470E-03,   2.8522357E-03
     +,   2.5610256E-03,   2.2935974E-03,   2.0476789E-03
     +,   1.8214905E-03,   1.6136778E-03,   1.4231661E-03
     +,   1.2490856E-03,   1.0906921E-03,   9.4728381E-04
     +,   8.1814377E-04,   7.0252357E-04,   5.9964036E-04
     +,   5.0866773E-04,   4.2874285E-04,   3.5898722E-04
     +,   2.9852489E-04,   2.4648930E-04,   2.0203261E-04
     +,   1.6433904E-04,   1.3263494E-04,   1.0618704E-04
     +,   8.4311323E-05,   6.6377346E-05,   5.1808533E-05
     +,   4.0082952E-05,   3.0734995E-05,   2.3354713E-05
     +,   1.7585140E-05,   1.3119188E-05,   9.6967187E-06
     +,   7.1003278E-06,   5.1505467E-06,   3.7010857E-06
     +,   2.6344403E-06,   1.8575115E-06,   1.2973142E-06
     +,   8.9746692E-07,   6.1496735E-07,   4.1739520E-07
     +,   2.8060634E-07,   1.8685039E-07,   1.2323706E-07
     +,   8.0508883E-08,   5.2094954E-08,   3.3387913E-08
     +,   2.1194884E-08,   1.3326847E-08,   8.2998630E-09
     +,   5.1198166E-09,   3.1281859E-09,   1.8931194E-09
     +,   1.1347596E-09,   6.7371414E-10,   3.9618936E-10
     +,   2.3076858E-10,   1.3313423E-10,   7.6076395E-11
     +,   4.3059105E-11,   2.4139460E-11,   1.3403817E-11
     +,   7.3718436E-12,   4.0158679E-12,   2.1668570E-12
     +,   1.1580266E-12,   6.1300433E-13,   3.2140686E-13
     +,   1.6691105E-13,   8.5854067E-14,   4.3741537E-14
     +,   2.2073680E-14,   1.1032940E-14,   5.4620555E-15
     +,   2.6784084E-15,   1.3009053E-15,   6.2582145E-16
     +,   2.9819610E-16,   1.4073808E-16,   6.5791220E-17
     +,   3.0462183E-17,   1.3970511E-17,   6.3461491E-18
     +,   2.8552552E-18,   1.2724026E-18,   5.6164783E-19
     +,   2.4555585E-19,   1.0633345E-19,   4.5607831E-20
     +,   1.9376139E-20,   8.1534547E-21,   3.3982042E-21
     +,   1.4028746E-21,   5.7361658E-22,   2.3231880E-22
     +,   9.3192392E-23,   3.7028528E-23,   1.4572279E-23
     +,   5.6804150E-24,   2.1931301E-24,   8.3870390E-25
     +,   3.1767858E-25,   1.1918652E-25,   4.4290913E-26
     +,   1.6301735E-26,   5.9430993E-27,   2.1459792E-27
     +,   7.6753749E-28,   2.7189867E-28,   9.5406459E-29
     +,   3.3157252E-29,   1.1414079E-29,   3.8916759E-30
     +,   1.3142982E-30,   4.3962388E-31,   1.4565773E-31
     +,   4.7798489E-32,   1.5536734E-32
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_haonly_ttz80_mass = Yx/0.404922
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_haonly_ttz85_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  9.3053423E-09,   1.2262395E-08
     +,   1.6104464E-08,   2.1078749E-08,   2.7496117E-08
     +,   3.5745810E-08,   4.6313378E-08,   5.9802083E-08
     +,   7.6957619E-08,   9.8699893E-08,   1.2615639E-07
     +,   1.6070503E-07,   2.0402233E-07,   2.5813898E-07
     +,   3.2550440E-07,   4.0906090E-07,   5.1232649E-07
     +,   6.3948966E-07,   7.9551438E-07,   9.8625719E-07
     +,   1.2185972E-06,   1.5005749E-06,   1.8415415E-06
     +,   2.2523502E-06,   2.7454614E-06,   3.3352151E-06
     +,   4.0379450E-06,   4.8721945E-06,   5.8589030E-06
     +,   7.0215997E-06,   8.3865598E-06,   9.9829595E-06
     +,   1.1843020E-05,   1.4002127E-05,   1.6498840E-05
     +,   1.9374969E-05,   2.2675493E-05,   2.6448433E-05
     +,   3.0744966E-05,   3.5618428E-05,   4.1124971E-05
     +,   4.7322315E-05,   5.4269585E-05,   6.2026505E-05
     +,   7.0652830E-05,   8.0207297E-05,   9.0746835E-05
     +,   1.0232540E-04,   1.1499300E-04,   1.2879458E-04
     +,   1.4376859E-04,   1.5994610E-04,   1.7734924E-04
     +,   1.9599145E-04,   2.1587350E-04,   2.3698674E-04
     +,   2.5930893E-04,   2.8280579E-04,   3.0743002E-04
     +,   3.3312207E-04,   3.5981034E-04,   3.8741264E-04
     +,   4.1583541E-04,   4.4497973E-04,   4.7474122E-04
     +,   5.0501002E-04,   5.3568033E-04,   5.6664681E-04
     +,   5.9781590E-04,   6.2910205E-04,   6.6043995E-04
     +,   6.9178146E-04,   7.2310708E-04,   7.5442268E-04
     +,   7.8576995E-04,   8.1722642E-04,   8.4890629E-04
     +,   8.8096416E-04,   9.1359642E-04,   9.4704051E-04
     +,   9.8156778E-04,   1.0174890E-03,   1.0551397E-03
     +,   1.0948820E-03,   1.1370889E-03,   1.1821417E-03
     +,   1.2304094E-03,   1.2822476E-03,   1.3379714E-03
     +,   1.3978527E-03,   1.4620995E-03,   1.5308385E-03
     +,   1.6041013E-03,   1.6818178E-03,   1.7637998E-03
     +,   1.8497229E-03,   1.9391375E-03,   2.0314446E-03
     +,   2.1259203E-03,   2.2216933E-03,   2.3177827E-03
     +,   2.4130843E-03,   2.5064154E-03,   2.5965122E-03
     +,   2.6820789E-03,   2.7618045E-03,   2.8343927E-03
     +,   2.8985986E-03,   2.9532658E-03,   2.9973518E-03
     +,   3.0299530E-03,   3.0503408E-03,   3.0579711E-03
     +,   3.0525068E-03,   3.0338250E-03,   3.0020177E-03
     +,   2.9573918E-03,   2.9004551E-03,   2.8319091E-03
     +,   2.7526203E-03,   2.6636021E-03,   2.5659997E-03
     +,   2.4610718E-03,   2.3501741E-03,   2.2347842E-03
     +,   2.1165642E-03,   1.9974441E-03,   1.8798363E-03
     +,   1.7668951E-03,   1.6629476E-03,   1.5739739E-03
     +,   1.5081997E-03,   1.4765961E-03,   1.4932025E-03
     +,   1.5749788E-03,   1.7409768E-03,   2.0105503E-03
     +,   2.4005461E-03,   2.9216893E-03,   3.5746994E-03
     +,   4.3473034E-03,   5.2140378E-03,   6.1408682E-03
     +,   7.0960578E-03,   8.0671273E-03,   9.0808086E-03
     +,   1.0218033E-02,   1.1615051E-02,   1.3444767E-02
     +,   1.5882203E-02,   1.9069942E-02,   2.3103951E-02
     +,   2.8048506E-02,   3.3961631E-02,   4.0889818E-02
     +,   4.8799153E-02,   5.7452422E-02,   6.6293374E-02
     +,   7.4426077E-02,   8.0756500E-02,   8.4292606E-02
     +,   8.4495448E-02,   8.1515029E-02,   7.6158568E-02
     +,   6.9568008E-02,   6.2763058E-02,   5.6299560E-02
     +,   5.0219618E-02,   4.4280294E-02,   3.8276751E-02
     +,   3.2249436E-02,   2.6479362E-02,   2.1327794E-02
     +,   1.7054444E-02,   1.3721597E-02,   1.1210171E-02
     +,   9.3075288E-03,   7.8013130E-03,   6.5366835E-03
     +,   5.4288758E-03,   4.4462257E-03,   3.5842024E-03
     +,   2.8446373E-03,   2.2250910E-03,   1.7166797E-03
     +,   1.3061904E-03,   9.7905460E-04,   7.2149694E-04
     +,   5.2148721E-04,   3.6879253E-04,   2.5461428E-04
     +,   1.7129288E-04,   1.1213306E-04,   7.1353170E-05
     +,   4.4100903E-05,   2.6461135E-05,   1.5408414E-05
     +,   8.7058679E-06,   4.7720609E-06,   2.5374457E-06
     +,   1.3087973E-06,   6.5483482E-07,   3.1780419E-07
     +,   1.4960371E-07,   6.8312474E-08,   3.0256892E-08
     +,   1.2998845E-08,   5.4169984E-09,   2.1898110E-09
     +,   8.5872165E-10,   3.2667113E-10,   1.2057126E-10
     +,   4.3187648E-11,   1.5018238E-11,   5.0738688E-12
     +,   1.6679490E-12,   5.3510955E-13,   1.6850499E-13
     +,   5.2667048E-14,   1.6679568E-14,   5.5339441E-15
     +,   2.0063458E-15,   8.2045882E-16,   3.7794713E-16
     +,   1.9009922E-16,   1.0059497E-16,   5.4510425E-17
     +,   2.9785202E-17,   1.6285226E-17,   8.8780236E-18
     +,   4.8184102E-18,   2.6018840E-18,   1.3975131E-18
     +,   7.4656307E-19,   3.9667002E-19,   2.0963087E-19
     +,   1.1019271E-19,   5.7617498E-20,   2.9971190E-20
     +,   1.5510528E-20,   7.9865056E-21,   4.0921530E-21
     +,   2.0868060E-21,   1.0592736E-21,   5.3530455E-22
     +,   2.6937714E-22,   1.3502348E-22,   6.7431224E-23
     +,   3.3562213E-23,   1.6655731E-23,   8.2446961E-24
     +,   4.0727279E-24,   2.0087960E-24,   9.8989333E-25
     +,   4.8764669E-25,   2.4030328E-25,   1.1853657E-25
     +,   5.8570691E-26,   2.9007549E-26,   1.4407235E-26
     +,   7.1798152E-27,   3.5915597E-27,   1.8037801E-27
     +,   9.0959341E-28,   4.6054416E-28,   2.3408063E-28
     +,   1.1939326E-28,   6.1085870E-29,   3.1336222E-29
     +,   1.6108320E-29,   8.2927429E-30,   4.2732436E-30
     +,   2.2029247E-30,   1.1355212E-30,   5.8496831E-31
     +,   3.0105555E-31,   1.5472335E-31,   7.9385212E-32
     +,   4.0649191E-32,   2.0768928E-32,   1.0585477E-32
     +,   5.3812853E-33,   2.7281060E-33,   1.3791255E-33
     +,   6.9510517E-34,   3.4928722E-34,   1.7497030E-34
     +,   8.7369915E-35,   4.3488309E-35,   2.1575659E-35
     +,   1.0669492E-35,   5.2586573E-36,   2.5810415E-36
     +,   1.2639502E-36,   6.1687957E-37,   3.0004733E-37
     +,   1.4545141E-37,   7.0268128E-38,   3.3833031E-38
     +,   1.6234627E-38,   0.0000000E+00
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_haonly_ttz85_mass = Yx/0.35633136
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_haonly_ttz90_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.3260208E-17,   5.7328024E-17
     +,   9.8336925E-17,   1.6787059E-16,   2.8519282E-16
     +,   4.8218288E-16,   8.1132220E-16,   1.3585718E-15
     +,   2.2639893E-15,   3.7547302E-15,   6.1971429E-15
     +,   1.0179120E-14,   1.6639418E-14,   2.7069042E-14
     +,   4.3824482E-14,   7.0610076E-14,   1.1322047E-13
     +,   1.8067268E-13,   2.8692337E-13,   4.5346924E-13
     +,   7.1324262E-13,   1.1164393E-12,   1.7391510E-12
     +,   2.6962044E-12,   4.1597776E-12,   6.3870333E-12
     +,   9.7596670E-12,   1.4841546E-11,   2.2461099E-11
     +,   3.3829092E-11,   5.0705863E-11,   7.5636726E-11
     +,   1.1228343E-10,   1.6588450E-10,   2.4389582E-10
     +,   3.5687042E-10,   5.1966587E-10,   7.5308337E-10
     +,   1.0861145E-09,   1.5588691E-09,   2.2266633E-09
     +,   3.1652461E-09,   4.4778332E-09,   6.3042931E-09
     +,   8.8330863E-09,   1.2316737E-08,   1.7091782E-08
     +,   2.3604050E-08,   3.2440969E-08,   4.4371962E-08
     +,   6.0399181E-08,   8.1820367E-08,   1.1030556E-07
     +,   1.4799443E-07,   1.9760454E-07,   2.6257811E-07
     +,   3.4723831E-07,   4.5698778E-07,   5.9853471E-07
     +,   7.8015637E-07,   1.0120034E-06,   1.3064468E-06
     +,   1.6784409E-06,   2.1459898E-06,   2.7306171E-06
     +,   3.4577854E-06,   4.3575924E-06,   5.4651186E-06
     +,   6.8212462E-06,   8.4728999E-06,   1.0473976E-05
     +,   1.2885336E-05,   1.5775771E-05,   1.9221636E-05
     +,   2.3307626E-05,   2.8126527E-05,   3.3778619E-05
     +,   4.0371313E-05,   4.8018857E-05,   5.6840876E-05
     +,   6.6959969E-05,   7.8501849E-05,   9.1590438E-05
     +,   1.0634827E-04,   1.2289004E-04,   1.4132312E-04
     +,   1.6173950E-04,   1.8421697E-04,   2.0880974E-04
     +,   2.3554947E-04,   2.6443967E-04,   2.9545030E-04
     +,   3.2851627E-04,   3.6353790E-04,   4.0037805E-04
     +,   4.3885835E-04,   4.7876997E-04,   5.1986740E-04
     +,   5.6188548E-04,   6.0453796E-04,   6.4754096E-04
     +,   6.9061847E-04,   7.3353387E-04,   7.7610323E-04
     +,   8.1823382E-04,   8.5995288E-04,   9.0144027E-04
     +,   9.4306801E-04,   9.8544057E-04,   1.0294244E-03
     +,   1.0761690E-03,   1.1271330E-03,   1.1840684E-03
     +,   1.2490100E-03,   1.3242116E-03,   1.4120823E-03
     +,   1.5150567E-03,   1.6354732E-03,   1.7753786E-03
     +,   1.9363613E-03,   2.1193426E-03,   2.3243658E-03
     +,   2.5504262E-03,   2.7953540E-03,   3.0557169E-03
     +,   3.3267871E-03,   3.6026735E-03,   3.8764155E-03
     +,   4.1403053E-03,   4.3861456E-03,   4.6057068E-03
     +,   4.7910851E-03,   4.9351915E-03,   5.0321096E-03
     +,   5.0774757E-03,   5.0687343E-03,   5.0053066E-03
     +,   4.8886649E-03,   4.7222720E-03,   4.5114583E-03
     +,   4.2632385E-03,   3.9860820E-03,   3.6896633E-03
     +,   3.3846779E-03,   3.0827210E-03,   2.7961114E-03
     +,   2.5378272E-03,   2.3214009E-03,   2.1606919E-03
     +,   2.0695357E-03,   2.0612411E-03,   2.1478934E-03
     +,   2.3396371E-03,   2.6443405E-03,   3.0682159E-03
     +,   3.6181344E-03,   4.3062218E-03,   5.1562949E-03
     +,   6.2097744E-03,   7.5267763E-03,   9.1777444E-03
     +,   1.1222208E-02,   1.3678695E-02,   1.6499486E-02
     +,   1.9570118E-02,   2.2748912E-02,   2.5942769E-02
     +,   2.9185981E-02,   3.2666422E-02,   3.6652964E-02
     +,   4.1327696E-02,   4.6595886E-02,   5.1989302E-02
     +,   5.6751728E-02,   6.0098719E-02,   6.1529115E-02
     +,   6.1011933E-02,   5.8944039E-02,   5.5913150E-02
     +,   5.2418921E-02,   4.8713397E-02,   4.4820599E-02
     +,   4.0673308E-02,   3.6251061E-02,   3.1639080E-02
     +,   2.7002141E-02,   2.2521326E-02,   1.8344801E-02
     +,   1.4573082E-02,   1.1267105E-02,   8.4584374E-03
     +,   6.1536180E-03,   4.3331264E-03,   2.9518625E-03
     +,   1.9453625E-03,   1.2402610E-03,   7.6468341E-04
     +,   4.5549762E-04,   2.6170551E-04,   1.4472310E-04
     +,   7.6852317E-05,   3.9100585E-05,   1.9019852E-05
     +,   8.8299466E-06,   3.9070665E-06,   1.6459331E-06
     +,   6.5961058E-07,   2.5133144E-07,   9.1020055E-08
     +,   3.1320695E-08,   1.0238596E-08,   3.1793037E-09
     +,   9.3777719E-10,   2.6273589E-10,   6.9919341E-11
     +,   1.7677968E-11,   4.2490330E-12,   9.7244825E-13
     +,   2.1294713E-13,   4.5289347E-14,   9.7690470E-15
     +,   2.3764822E-15,   7.6119368E-16,   3.3390552E-16
     +,   1.7684329E-16,   1.0043145E-16,   5.8070190E-17
     +,   3.3624144E-17,   1.9406354E-17,   1.1150767E-17
     +,   6.3769136E-18,   3.6294481E-18,   2.0557957E-18
     +,   1.1588324E-18,   6.5009070E-19,   3.6294281E-19
     +,   2.0165163E-19,   1.1149905E-19,   6.1356387E-20
     +,   3.3601036E-20,   1.8312525E-20,   9.9322581E-21
     +,   5.3612613E-21,   2.8799961E-21,   1.5396291E-21
     +,   8.1912383E-22,   4.3370941E-22,   2.2853661E-22
     +,   1.1984281E-22,   6.2543770E-23,   3.2483692E-23
     +,   1.6789690E-23,   8.6363632E-24,   4.4211473E-24
     +,   2.2523971E-24,   1.1419733E-24,   5.7619939E-25
     +,   2.8933917E-25,   1.4459420E-25,   7.1910471E-26
     +,   3.5590933E-26,   1.7530965E-26,   8.5937259E-27
     +,   4.1922911E-27,   2.0353649E-27,   9.8342008E-28
     +,   4.7286092E-28,   2.2627440E-28,   1.0775975E-28
     +,   5.1072099E-29,   2.4088609E-29,   1.1306956E-29
     +,   5.2819659E-30,   2.4555927E-30,   1.1360909E-30
     +,   5.2310514E-31,   2.3969606E-31,   1.0930843E-31
     +,   4.9606373E-32,   2.2405106E-32,   1.0070459E-32
     +,   4.5047497E-33,   2.0053405E-33,   8.8843982E-34
     +,   3.9170939E-34,   1.7187619E-34,   7.5054499E-35
     +,   3.2616229E-35,   1.4106196E-35,   6.0713056E-36
     +,   2.6005996E-36,   1.1085725E-36,   4.7029532E-37
     +,   1.9855301E-37,   8.3425379E-38,   3.4883434E-38
     +,   1.4516304E-38,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_haonly_ttz90_mass = Yx/0.295255625
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_haonly_ttz95_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  6.7495031E-04,   6.9263880E-04
     +,   7.1051600E-04,   7.2856870E-04,   7.4678252E-04
     +,   7.6514191E-04,   7.8363036E-04,   8.0223003E-04
     +,   8.2092208E-04,   8.3968678E-04,   8.5850293E-04
     +,   8.7734859E-04,   8.9620071E-04,   9.1503537E-04
     +,   9.3382795E-04,   9.5255277E-04,   9.7118370E-04
     +,   9.8969403E-04,   1.0080566E-03,   1.0262436E-03
     +,   1.0442273E-03,   1.0619798E-03,   1.0794726E-03
     +,   1.0966789E-03,   1.1135701E-03,   1.1301195E-03
     +,   1.1463006E-03,   1.1620871E-03,   1.1774541E-03
     +,   1.1923775E-03,   1.2068341E-03,   1.2208020E-03
     +,   1.2342610E-03,   1.2471915E-03,   1.2595765E-03
     +,   1.2713998E-03,   1.2826476E-03,   1.2933069E-03
     +,   1.3033682E-03,   1.3128221E-03,   1.3216628E-03
     +,   1.3298850E-03,   1.3374862E-03,   1.3444660E-03
     +,   1.3508255E-03,   1.3565678E-03,   1.3616981E-03
     +,   1.3662229E-03,   1.3701507E-03,   1.3734919E-03
     +,   1.3762580E-03,   1.3784618E-03,   1.3801178E-03
     +,   1.3812410E-03,   1.3818480E-03,   1.3819558E-03
     +,   1.3815821E-03,   1.3807456E-03,   1.3794642E-03
     +,   1.3777573E-03,   1.3756434E-03,   1.3731414E-03
     +,   1.3702696E-03,   1.3670457E-03,   1.3634870E-03
     +,   1.3596100E-03,   1.3554305E-03,   1.3509631E-03
     +,   1.3462215E-03,   1.3412180E-03,   1.3359637E-03
     +,   1.3304685E-03,   1.3247406E-03,   1.3187873E-03
     +,   1.3126142E-03,   1.3062251E-03,   1.2996228E-03
     +,   1.2928091E-03,   1.2857836E-03,   1.2785448E-03
     +,   1.2710904E-03,   1.2634163E-03,   1.2555178E-03
     +,   1.2473891E-03,   1.2390239E-03,   1.2304143E-03
     +,   1.2215525E-03,   1.2124301E-03,   1.2030381E-03
     +,   1.1933679E-03,   1.1834096E-03,   1.1731549E-03
     +,   1.1625953E-03,   1.1517220E-03,   1.1405270E-03
     +,   1.1290034E-03,   1.1171442E-03,   1.1049447E-03
     +,   1.0923995E-03,   1.0795058E-03,   1.0662605E-03
     +,   1.0526633E-03,   1.0387136E-03,   1.0244141E-03
     +,   1.0097673E-03,   9.9477731E-04,   9.7945065E-04
     +,   9.6379517E-04,   9.4781973E-04,   9.3153404E-04
     +,   9.1495115E-04,   8.9808338E-04,   8.8094646E-04
     +,   8.6355529E-04,   8.4592827E-04,   8.2808279E-04
     +,   8.1003935E-04,   7.9181721E-04,   7.7343895E-04
     +,   7.5492653E-04,   7.3630176E-04,   7.1758940E-04
     +,   6.9881423E-04,   6.8000070E-04,   6.6117442E-04
     +,   6.4236351E-04,   6.2359573E-04,   6.0490333E-04
     +,   5.8632006E-04,   5.6788739E-04,   5.4965215E-04
     +,   5.3167500E-04,   5.1403034E-04,   4.9681705E-04
     +,   4.8016250E-04,   4.6423357E-04,   4.4924996E-04
     +,   4.3549587E-04,   4.2333422E-04,   4.1322425E-04
     +,   4.0573644E-04,   4.0156767E-04,   4.0155087E-04
     +,   4.0666430E-04,   4.1802987E-04,   4.3690673E-04
     +,   4.6467423E-04,   5.0280272E-04,   5.5281556E-04
     +,   6.1624980E-04,   6.9460575E-04,   7.8929495E-04
     +,   9.0160820E-04,   1.0327147E-03,   1.1836885E-03
     +,   1.3555933E-03,   1.5496716E-03,   1.7676585E-03
     +,   2.0122244E-03,   2.2875555E-03,   2.6002035E-03
     +,   2.9600295E-03,   3.3812614E-03,   3.8836482E-03
     +,   4.4935206E-03,   5.2445377E-03,   6.1778734E-03
     +,   7.3417141E-03,   8.7898290E-03,   1.0578790E-02
     +,   1.2763831E-02,   1.5393567E-02,   1.8503930E-02
     +,   2.2111190E-02,   2.6204793E-02,   3.0742202E-02
     +,   3.5644550E-02,   4.0794939E-02,   4.6040673E-02
     +,   5.1199410E-02,   5.6068204E-02,   6.0435850E-02
     +,   6.4098045E-02,   6.6873215E-02,   6.8616822E-02
     +,   6.9233611E-02,   6.8686105E-02,   6.6997819E-02
     +,   6.4251058E-02,   6.0580131E-02,   5.6159534E-02
     +,   5.1189668E-02,   4.5881841E-02,   4.0442996E-02
     +,   3.5062112E-02,   2.9900532E-02,   2.5085855E-02
     +,   2.0708844E-02,   1.6823767E-02,   1.3452197E-02
     +,   1.0588435E-02,   8.2054092E-03,   6.2610367E-03
     +,   4.7044279E-03,   3.4811383E-03,   2.5369092E-03
     +,   1.8207903E-03,   1.2870245E-03,   8.9593744E-04
     +,   6.1419839E-04,   4.1462525E-04,   2.7562206E-04
     +,   1.8042741E-04,   1.1632455E-04,   7.3882838E-05
     +,   4.6257115E-05,   2.8578135E-05,   1.7452987E-05
     +,   1.0566580E-05,   6.3713674E-06,   3.8528387E-06
     +,   2.3598714E-06,   1.4830142E-06,   9.6989925E-07
     +,   6.6810105E-07,   4.8742976E-07,   3.7555506E-07
     +,   3.0266636E-07,   2.5206643E-07,   2.1453587E-07
     +,   1.8502843E-07,   1.6077912E-07,   1.4024751E-07
     +,   1.2254428E-07,   1.0712414E-07,   9.3621566E-08
     +,   8.1769912E-08,   7.1360304E-08,   6.2218938E-08
     +,   5.4195834E-08,   4.7160036E-08,   4.0996131E-08
     +,   3.5601808E-08,   3.0885712E-08,   2.6766816E-08
     +,   2.3173488E-08,   2.0042117E-08,   1.7316097E-08
     +,   1.4945439E-08,   1.2886179E-08,   1.1099245E-08
     +,   9.5502415E-09,   8.2089757E-09,   7.0488602E-09
     +,   6.0464798E-09,   5.1812790E-09,   4.4353099E-09
     +,   3.7928478E-09,   3.2401075E-09,   2.7650553E-09
     +,   2.3572200E-09,   2.0074766E-09,   1.7078605E-09
     +,   1.4514565E-09,   1.2322795E-09,   1.0451193E-09
     +,   8.8546398E-10,   7.4942291E-10,   6.3362998E-10
     +,   5.3517485E-10,   4.5154794E-10,   3.8059386E-10
     +,   3.2045899E-10,   2.6954664E-10,   2.2648641E-10
     +,   1.9010891E-10,   1.5940804E-10,   1.3352745E-10
     +,   1.1173194E-10,   9.3397665E-11,   7.7990503E-11
     +,   6.5057709E-11,   5.4212843E-11,   4.5129196E-11
     +,   3.7528269E-11,   3.1175354E-11,   2.5870967E-11
     +,   2.1446662E-11,   1.7760628E-11,   1.4692702E-11
     +,   1.2142173E-11,   1.0023916E-11,   8.2666200E-12
     +,   6.8102746E-12,   5.6046886E-12,   4.6076927E-12
     +,   3.7841327E-12,   3.1045186E-12,   2.5443213E-12
     +,   2.0830260E-12,   1.7036009E-12
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_haonly_ttz95_mass = Yx/0.3644298
      RETURN
      END
C 
C---- New file --- 
C 
      DOUBLE PRECISION FUNCTION A192_tt_hzonly_hatt100_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  5.1479038E-02,   5.5044957E-02
     +,   5.8572613E-02,   6.2031336E-02,   6.5391913E-02
     +,   6.8627551E-02,   7.1714751E-02,   7.4633792E-02
     +,   7.7369429E-02,   7.9911247E-02,   8.2253598E-02
     +,   8.4395491E-02,   8.6340263E-02,   8.8095233E-02
     +,   8.9670591E-02,   9.1079041E-02,   9.2334695E-02
     +,   9.3452379E-02,   9.4447009E-02,   9.5332779E-02
     +,   9.6122719E-02,   9.6828580E-02,   9.7460389E-02
     +,   9.8026454E-02,   9.8533504E-02,   9.8986760E-02
     +,   9.9389926E-02,   9.9745490E-02,   0.1000552    
     +,   0.1003195    ,   0.1005384    ,   0.1007112    
     +,   0.1008369    ,   0.1009145    ,   0.1009433    
     +,   0.1009227    ,   0.1008537    ,   0.1007381    
     +,   0.1005798    ,   0.1003845    ,   0.1001601    
     +,   9.9916555E-02,   9.9665992E-02,   9.9422231E-02
     +,   9.9199824E-02,   9.9014089E-02,   9.8879807E-02
     +,   9.8810375E-02,   9.8817118E-02,   9.8908521E-02
     +,   9.9089548E-02,   9.9360935E-02,   9.9719770E-02
     +,   0.1001588    ,   0.1006674    ,   0.1012315    
     +,   0.1018345    ,   0.1024591    ,   0.1030865    
     +,   0.1036989    ,   0.1042793    ,   0.1048125    
     +,   0.1052856    ,   0.1056886    ,   0.1060135    
     +,   0.1062547    ,   0.1064088    ,   0.1064738    
     +,   0.1064485    ,   0.1063324    ,   0.1061247    
     +,   0.1058245    ,   0.1054303    ,   0.1049405    
     +,   0.1043529    ,   0.1036657    ,   0.1028777    
     +,   0.1019892    ,   0.1010017    ,   9.9918790E-02
     +,   9.8747052E-02,   9.7495422E-02,   9.6175522E-02
     +,   9.4801471E-02,   9.3389556E-02,   9.1957435E-02
     +,   9.0523876E-02,   8.9107662E-02,   8.7726943E-02
     +,   8.6398803E-02,   8.5138030E-02,   8.3957352E-02
     +,   8.2866617E-02,   8.1872694E-02,   8.0979526E-02
     +,   8.0188662E-02,   7.9499111E-02,   7.8908086E-02
     +,   7.8411393E-02,   7.8004315E-02,   7.7681698E-02
     +,   7.7438846E-02,   7.7271812E-02,   7.7177435E-02
     +,   7.7153817E-02,   7.7200122E-02,   7.7316590E-02
     +,   7.7503987E-02,   7.7763818E-02,   7.8097187E-02
     +,   7.8504845E-02,   7.8986719E-02,   7.9541110E-02
     +,   8.0164880E-02,   8.0852881E-02,   8.1598252E-02
     +,   8.2391851E-02,   8.3223246E-02,   8.4080279E-02
     +,   8.4950104E-02,   8.5819237E-02,   8.6674407E-02
     +,   8.7502681E-02,   8.8292174E-02,   8.9032657E-02
     +,   8.9715078E-02,   9.0332299E-02,   9.0878814E-02
     +,   9.1350816E-02,   9.1745682E-02,   9.2061847E-02
     +,   9.2298582E-02,   9.2455640E-02,   9.2532843E-02
     +,   9.2530370E-02,   9.2448257E-02,   9.2286766E-02
     +,   9.2046455E-02,   9.1728732E-02,   9.1335699E-02
     +,   9.0871073E-02,   9.0340115E-02,   8.9750290E-02
     +,   8.9111410E-02,   8.8435642E-02,   8.7737910E-02
     +,   8.7035537E-02,   8.6348042E-02,   8.5697152E-02
     +,   8.5106231E-02,   8.4599882E-02,   8.4203720E-02
     +,   8.3943367E-02,   8.3844647E-02,   8.3932325E-02
     +,   8.4230199E-02,   8.4760062E-02,   8.5541204E-02
     +,   8.6590111E-02,   8.7919071E-02,   8.9535959E-02
     +,   9.1443427E-02,   9.3638092E-02,   9.6110225E-02
     +,   9.8843098E-02,   0.1018137    ,   0.1049921    
     +,   0.1083425    ,   0.1118250    ,   0.1153965    
     +,   0.1190123    ,   0.1226283    ,   0.1262036    
     +,   0.1297013    ,   0.1330907    ,   0.1363475    
     +,   0.1394550    ,   0.1424024    ,   0.1451841    
     +,   0.1477980    ,   0.1502432    ,   0.1525165    
     +,   0.1546106    ,   0.1565120    ,   0.1581988    
     +,   0.1596406    ,   0.1607979    ,   0.1616247    
     +,   0.1620696    ,   0.1620799    ,   0.1616047    
     +,   0.1605989    ,   0.1590272    ,   0.1568673    
     +,   0.1541117    ,   0.1507702    ,   0.1468694    
     +,   0.1424523    ,   0.1375758    ,   0.1323084    
     +,   0.1267271    ,   0.1209133    ,   0.1149492    
     +,   0.1089142    ,   0.1028834    ,   9.6923240E-02
     +,   9.1091134E-02,   8.5434735E-02,   7.9991363E-02
     +,   7.4787714E-02,   6.9841422E-02,   6.5162003E-02
     +,   6.0752045E-02,   5.6608003E-02,   5.2722186E-02
     +,   4.9083818E-02,   4.5680143E-02,   4.2496987E-02
     +,   3.9519906E-02,   3.6734931E-02,   3.4128457E-02
     +,   3.1687882E-02,   2.9401839E-02,   2.7260209E-02
     +,   2.5253823E-02,   2.3374697E-02,   2.1615917E-02
     +,   1.9971399E-02,   1.8435631E-02,   1.7003600E-02
     +,   1.5670801E-02,   1.4432942E-02,   1.3285754E-02
     +,   1.2225039E-02,   1.1246687E-02,   1.0346417E-02
     +,   9.5198695E-03,   8.7627107E-03,   8.0705350E-03
     +,   7.4388837E-03,   6.8633333E-03,   6.3395677E-03
     +,   5.8633699E-03,   5.4306509E-03,   5.0375024E-03
     +,   4.6802685E-03,   4.3555121E-03,   4.0600235E-03
     +,   3.7908619E-03,   3.5453592E-03,   3.3210746E-03
     +,   3.1158170E-03,   2.9276328E-03,   2.7547802E-03
     +,   2.5957059E-03,   2.4490347E-03,   2.3135617E-03
     +,   2.1882255E-03,   2.0720796E-03,   1.9642909E-03
     +,   1.8641285E-03,   1.7709447E-03,   1.6841574E-03
     +,   1.6032462E-03,   1.5277524E-03,   1.4572556E-03
     +,   1.3913733E-03,   1.3297646E-03,   1.2721148E-03
     +,   1.2181330E-03,   1.1675507E-03,   1.1201230E-03
     +,   1.0756232E-03,   1.0338373E-03,   9.9456729E-04
     +,   9.5763133E-04,   9.2285639E-04,   8.9008512E-04
     +,   8.5916690E-04,   8.2996569E-04,   8.0235052E-04
     +,   7.7620422E-04,   7.5141416E-04,   7.2787888E-04
     +,   7.0550258E-04,   6.8419869E-04,   6.6388585E-04
     +,   6.4448948E-04,   6.2594260E-04,   6.0818205E-04
     +,   5.9115206E-04,   5.7479972E-04,   5.5907911E-04
     +,   5.4394675E-04,   5.2936462E-04,   5.1529729E-04
     +,   5.0171401E-04,   4.8858550E-04,   4.7588727E-04
     +,   4.6359561E-04,   4.5169072E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_hzonly_hatt100_mass = Yx/5.27318877272727
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_hzonly_hatt105_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  5.2452330E-02,   5.6740075E-02
     +,   6.1106820E-02,   6.5524474E-02,   6.9963053E-02
     +,   7.4391067E-02,   7.8775778E-02,   8.3083831E-02
     +,   8.7281592E-02,   9.1336034E-02,   9.5215045E-02
     +,   9.8888360E-02,   0.1023285    ,   0.1055114    
     +,   0.1084172    ,   0.1110310    ,   0.1133434    
     +,   0.1153509    ,   0.1170561    ,   0.1184678    
     +,   0.1195997    ,   0.1204708    ,   0.1211038    
     +,   0.1215240    ,   0.1217580    ,   0.1218320    
     +,   0.1217709    ,   0.1215968    ,   0.1213283    
     +,   0.1209795    ,   0.1205601    ,   0.1200756    
     +,   0.1195279    ,   0.1189161    ,   0.1182378    
     +,   0.1174904    ,   0.1166723    ,   0.1157840    
     +,   0.1148292    ,   0.1138156    ,   0.1127540    
     +,   0.1116594    ,   0.1105493    ,   0.1094437    
     +,   0.1083633    ,   0.1073283    ,   0.1063572    
     +,   0.1054661    ,   0.1046671    ,   0.1039680    
     +,   0.1033723    ,   0.1028785    ,   0.1024811    
     +,   0.1021706    ,   0.1019349    ,   0.1017598    
     +,   0.1016295    ,   0.1015284    ,   0.1014412    
     +,   0.1013538    ,   0.1012535    ,   0.1011297    
     +,   0.1009738    ,   0.1007796    ,   0.1005424    
     +,   0.1002598    ,   9.9931240E-02,   9.9557139E-02
     +,   9.9139482E-02,   9.8681532E-02,   9.8187067E-02
     +,   9.7660728E-02,   9.7107597E-02,   9.6533127E-02
     +,   9.5942706E-02,   9.5341675E-02,   9.4735071E-02
     +,   9.4127171E-02,   9.3521640E-02,   9.2920870E-02
     +,   9.2326224E-02,   9.1737688E-02,   9.1153994E-02
     +,   9.0572245E-02,   8.9988880E-02,   8.9398868E-02
     +,   8.8796824E-02,   8.8176787E-02,   8.7533027E-02
     +,   8.6860150E-02,   8.6153567E-02,   8.5409939E-02
     +,   8.4627271E-02,   8.3805494E-02,   8.2946070E-02
     +,   8.2052752E-02,   8.1130683E-02,   8.0186993E-02
     +,   7.9229936E-02,   7.8269161E-02,   7.7314809E-02
     +,   7.6377355E-02,   7.5467147E-02,   7.4594095E-02
     +,   7.3767096E-02,   7.2993748E-02,   7.2280161E-02
     +,   7.1630642E-02,   7.1047708E-02,   7.0531905E-02
     +,   7.0081912E-02,   6.9694601E-02,   6.9365419E-02
     +,   6.9088355E-02,   6.8856426E-02,   6.8661936E-02
     +,   6.8496697E-02,   6.8352394E-02,   6.8221033E-02
     +,   6.8094961E-02,   6.7967363E-02,   6.7832120E-02
     +,   6.7684308E-02,   6.7519985E-02,   6.7336418E-02
     +,   6.7131989E-02,   6.6906042E-02,   6.6659167E-02
     +,   6.6392496E-02,   6.6108085E-02,   6.5808505E-02
     +,   6.5496825E-02,   6.5176480E-02,   6.4851090E-02
     +,   6.4524457E-02,   6.4200513E-02,   6.3882984E-02
     +,   6.3575864E-02,   6.3283198E-02,   6.3008606E-02
     +,   6.2756225E-02,   6.2529907E-02,   6.2333636E-02
     +,   6.2171355E-02,   6.2047068E-02,   6.1964728E-02
     +,   6.1928295E-02,   6.1941646E-02,   6.2008478E-02
     +,   6.2132470E-02,   6.2316906E-02,   6.2565051E-02
     +,   6.2879793E-02,   6.3263737E-02,   6.3719340E-02
     +,   6.4248458E-02,   6.4853087E-02,   6.5534741E-02
     +,   6.6294827E-02,   6.7134559E-02,   6.8055026E-02
     +,   6.9057435E-02,   7.0142992E-02,   7.1313061E-02
     +,   7.2569817E-02,   7.3915832E-02,   7.5354777E-02
     +,   7.6891534E-02,   7.8532860E-02,   8.0287240E-02
     +,   8.2165249E-02,   8.4179893E-02,   8.6346343E-02
     +,   8.8681653E-02,   9.1204010E-02,   9.3932681E-02
     +,   9.6885853E-02,   0.1000800    ,   0.1035276    
     +,   0.1072365    ,   0.1112076    ,   0.1154332    
     +,   0.1198956    ,   0.1245676    ,   0.1294103    
     +,   0.1343744    ,   0.1394002    ,   0.1444200    
     +,   0.1493592    ,   0.1541381    ,   0.1586756    
     +,   0.1628907    ,   0.1667054    ,   0.1700478    
     +,   0.1728533    ,   0.1750667    ,   0.1766438    
     +,   0.1775517    ,   0.1777704    ,   0.1772917    
     +,   0.1761194    ,   0.1742688    ,   0.1717657    
     +,   0.1686449    ,   0.1649503    ,   0.1607322    
     +,   0.1560462    ,   0.1509528    ,   0.1455149    
     +,   0.1397965    ,   0.1338615    ,   0.1277727    
     +,   0.1215911    ,   0.1153730    ,   0.1091705    
     +,   0.1030316    ,   9.6997976E-02,   9.1105849E-02
     +,   8.5385032E-02,   7.9860307E-02,   7.4550480E-02
     +,   6.9469005E-02,   6.4625323E-02,   6.0024485E-02
     +,   5.5667996E-02,   5.1554456E-02,   4.7680419E-02
     +,   4.4040661E-02,   4.0628396E-02,   3.7435867E-02
     +,   3.4454964E-02,   3.1677172E-02,   2.9093532E-02
     +,   2.6694994E-02,   2.4472745E-02,   2.2417776E-02
     +,   2.0521101E-02,   1.8773954E-02,   1.7167628E-02
     +,   1.5693430E-02,   1.4342785E-02,   1.3107389E-02
     +,   1.1979087E-02,   1.0949920E-02,   1.0012194E-02
     +,   9.1585899E-03,   8.3821304E-03,   7.6761730E-03
     +,   7.0344782E-03,   6.4512845E-03,   5.9211939E-03
     +,   5.4392386E-03,   5.0008879E-03,   4.6020122E-03
     +,   4.2388388E-03,   3.9079445E-03,   3.6062719E-03
     +,   3.3310538E-03,   3.0797911E-03,   2.8502324E-03
     +,   2.6403696E-03,   2.4483898E-03,   2.2726508E-03
     +,   2.1116687E-03,   1.9641188E-03,   1.8287844E-03
     +,   1.7045633E-03,   1.5904631E-03,   1.4855789E-03
     +,   1.3890800E-03,   1.3002106E-03,   1.2182880E-03
     +,   1.1426890E-03,   1.0728419E-03,   1.0082269E-03
     +,   9.4837788E-04,   8.9286425E-04,   8.4130326E-04
     +,   7.9334108E-04,   7.4866565E-04,   7.0698973E-04
     +,   6.6805992E-04,   6.3164323E-04,   5.9753581E-04
     +,   5.6555023E-04,   5.3552247E-04,   5.0730270E-04
     +,   4.8075707E-04,   4.5576738E-04,   4.3222454E-04
     +,   4.1003322E-04,   3.8910471E-04,   3.6936117E-04
     +,   3.5072910E-04,   3.3314404E-04,   3.1654435E-04
     +,   3.0087528E-04,   2.8608413E-04,   2.7212367E-04
     +,   2.5894764E-04,   2.4651430E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_hzonly_hatt105_mass = Yx/5.35141234090909
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_hzonly_hatt107_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  5.6035277E-02,   6.0213301E-02
     +,   6.4407170E-02,   6.8586513E-02,   7.2720863E-02
     +,   7.6780535E-02,   8.0736995E-02,   8.4563345E-02
     +,   8.8235095E-02,   9.1729939E-02,   9.5028460E-02
     +,   9.8113887E-02,   0.1009726    ,   0.1035939    
     +,   0.1059700    ,   0.1080958    ,   0.1099690    
     +,   0.1115896    ,   0.1129600    ,   0.1140849    
     +,   0.1149707    ,   0.1156256    ,   0.1160597    
     +,   0.1162842    ,   0.1163118    ,   0.1161565    
     +,   0.1158334    ,   0.1153584    ,   0.1147483    
     +,   0.1140207    ,   0.1131937    ,   0.1122860    
     +,   0.1113162    ,   0.1103029    ,   0.1092644    
     +,   0.1082181    ,   0.1071807    ,   0.1061672    
     +,   0.1051907    ,   0.1042625    ,   0.1033910    
     +,   0.1025825    ,   0.1018398    ,   0.1011637    
     +,   0.1005519    ,   9.9999741E-02,   9.9500470E-02
     +,   9.9045590E-02,   9.8625332E-02,   9.8229282E-02
     +,   9.7847037E-02,   9.7467914E-02,   9.7082511E-02
     +,   9.6681915E-02,   9.6258759E-02,   9.5806703E-02
     +,   9.5321029E-02,   9.4797872E-02,   9.4235189E-02
     +,   9.3631148E-02,   9.2985041E-02,   9.2296667E-02
     +,   9.1566473E-02,   9.0795010E-02,   8.9983150E-02
     +,   8.9132339E-02,   8.8244066E-02,   8.7320730E-02
     +,   8.6364970E-02,   8.5380509E-02,   8.4371708E-02
     +,   8.3343759E-02,   8.2302652E-02,   8.1255369E-02
     +,   8.0209151E-02,   7.9171620E-02,   7.8150436E-02
     +,   7.7153228E-02,   7.6186635E-02,   7.5256988E-02
     +,   7.4369080E-02,   7.3526852E-02,   7.2732784E-02
     +,   7.1988195E-02,   7.1293145E-02,   7.0646800E-02
     +,   7.0047595E-02,   6.9493592E-02,   6.8982661E-02
     +,   6.8512917E-02,   6.8083018E-02,   6.7692176E-02
     +,   6.7340724E-02,   6.7029700E-02,   6.6761069E-02
     +,   6.6537626E-02,   6.6362672E-02,   6.6240042E-02
     +,   6.6173330E-02,   6.6165902E-02,   6.6220522E-02
     +,   6.6338904E-02,   6.6521540E-02,   6.6767476E-02
     +,   6.7074053E-02,   6.7436926E-02,   6.7849971E-02
     +,   6.8305559E-02,   6.8794243E-02,   6.9305681E-02
     +,   6.9828197E-02,   7.0349507E-02,   7.0856720E-02
     +,   7.1337104E-02,   7.1777813E-02,   7.2166748E-02
     +,   7.2492428E-02,   7.2744399E-02,   7.2913460E-02
     +,   7.2991721E-02,   7.2973005E-02,   7.2852522E-02
     +,   7.2627254E-02,   7.2295904E-02,   7.1858808E-02
     +,   7.1318045E-02,   7.0677213E-02,   6.9941431E-02
     +,   6.9117188E-02,   6.8212382E-02,   6.7235790E-02
     +,   6.6197328E-02,   6.5107532E-02,   6.3977718E-02
     +,   6.2819280E-02,   6.1644036E-02,   6.0463648E-02
     +,   5.9289832E-02,   5.8133703E-02,   5.7005923E-02
     +,   5.5916667E-02,   5.4875392E-02,   5.3890742E-02
     +,   5.2970473E-02,   5.2121785E-02,   5.1350910E-02
     +,   5.0663460E-02,   5.0064456E-02,   4.9558371E-02
     +,   4.9149226E-02,   4.8840828E-02,   4.8636734E-02
     +,   4.8540618E-02,   4.8556093E-02,   4.8687108E-02
     +,   4.8937883E-02,   4.9312979E-02,   4.9817484E-02
     +,   5.0456919E-02,   5.1237214E-02,   5.2164808E-02
     +,   5.3246532E-02,   5.4489248E-02,   5.5899840E-02
     +,   5.7485040E-02,   5.9250850E-02,   6.1202049E-02
     +,   6.3341893E-02,   6.5671727E-02,   6.8190016E-02
     +,   7.0892282E-02,   7.3770083E-02,   7.6811142E-02
     +,   7.9999126E-02,   8.3313428E-02,   8.6729527E-02
     +,   9.0219691E-02,   9.3753614E-02,   9.7299404E-02
     +,   0.1008252    ,   0.1043004    ,   0.1076968    
     +,   0.1109900    ,   0.1141610    ,   0.1171963    
     +,   0.1200885    ,   0.1228367    ,   0.1254456    
     +,   0.1279243    ,   0.1302856    ,   0.1325438    
     +,   0.1347134    ,   0.1368061    ,   0.1388306    
     +,   0.1407897    ,   0.1426796    ,   0.1444892    
     +,   0.1461990    ,   0.1477823    ,   0.1492055    
     +,   0.1504288    ,   0.1514086    ,   0.1520986    
     +,   0.1524529    ,   0.1524268    ,   0.1519808    
     +,   0.1510813    ,   0.1497027    ,   0.1478293    
     +,   0.1454561    ,   0.1425890    ,   0.1392456    
     +,   0.1354543    ,   0.1312533    ,   0.1266891    
     +,   0.1218152    ,   0.1166900    ,   0.1113748    
     +,   0.1059314    ,   0.1004208    ,   9.4900437E-02
     +,   8.9423813E-02,   8.4038623E-02,   7.8786358E-02
     +,   7.3701210E-02,   6.8810433E-02,   6.4134829E-02
     +,   5.9688583E-02,   5.5479974E-02,   5.1512141E-02
     +,   4.7784265E-02,   4.4292033E-02,   4.1028235E-02
     +,   3.7983764E-02,   3.5148513E-02,   3.2511294E-02
     +,   3.0060710E-02,   2.7785441E-02,   2.5674487E-02
     +,   2.3717115E-02,   2.1903154E-02,   2.0223150E-02
     +,   1.8668203E-02,   1.7229894E-02,   1.5900383E-02
     +,   1.4672394E-02,   1.3539123E-02,   1.2494087E-02
     +,   1.1531206E-02,   1.0644842E-02,   9.8295799E-03
     +,   9.0803169E-03,   8.3922902E-03,   7.7609881E-03
     +,   7.1821152E-03,   6.6516572E-03,   6.1658444E-03
     +,   5.7211523E-03,   5.3142463E-03,   4.9420116E-03
     +,   4.6015652E-03,   4.2902203E-03,   4.0054540E-03
     +,   3.7449305E-03,   3.5065033E-03,   3.2881654E-03
     +,   3.0880666E-03,   2.9045125E-03,   2.7359440E-03
     +,   2.5809184E-03,   2.4381194E-03,   2.3063542E-03
     +,   2.1845347E-03,   2.0716700E-03,   1.9668622E-03
     +,   1.8693126E-03,   1.7782940E-03,   1.6931653E-03
     +,   1.6133445E-03,   1.5383268E-03,   1.4676554E-03
     +,   1.4009356E-03,   1.3378114E-03,   1.2779806E-03
     +,   1.2211698E-03,   1.1671466E-03,   1.1157049E-03
     +,   1.0666626E-03,   1.0198668E-03,   9.7517634E-04
     +,   9.3247363E-04,   8.9164835E-04,   8.5260830E-04
     +,   8.1526581E-04,   7.7954534E-04,   7.4537529E-04
     +,   7.1269175E-04,   6.8143272E-04,   6.5154384E-04
     +,   6.2296860E-04,   5.9565750E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_hzonly_hatt107_mass = Yx/5.04772084090909
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_hzonly_hatt110_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.9097273E-02,   5.2997172E-02
     +,   5.6986824E-02,   6.1044894E-02,   6.5148704E-02
     +,   6.9274135E-02,   7.3396601E-02,   7.7490836E-02
     +,   8.1532195E-02,   8.5496806E-02,   8.9361943E-02
     +,   9.3106993E-02,   9.6713811E-02,   0.1001666    
     +,   0.1034526    ,   0.1065620    ,   0.1094879    
     +,   0.1122255    ,   0.1147722    ,   0.1171270    
     +,   0.1192897    ,   0.1212597    ,   0.1230371    
     +,   0.1246211    ,   0.1260099    ,   0.1272015    
     +,   0.1281934    ,   0.1289834    ,   0.1295702    
     +,   0.1299543    ,   0.1301388    ,   0.1301299    
     +,   0.1299373    ,   0.1295746    ,   0.1290594    
     +,   0.1284122    ,   0.1276560    ,   0.1268153    
     +,   0.1259153    ,   0.1249796    ,   0.1240300    
     +,   0.1230850    ,   0.1221586    ,   0.1212601    
     +,   0.1203937    ,   0.1195583    ,   0.1187477    
     +,   0.1179517    ,   0.1171565    ,   0.1163457    
     +,   0.1155011    ,   0.1146048    ,   0.1136388    
     +,   0.1125869    ,   0.1114356    ,   0.1101747    
     +,   0.1087973    ,   0.1073013    ,   0.1056882    
     +,   0.1039641    ,   0.1021389    ,   0.1002261    
     +,   9.8242074E-02,   9.6205354E-02,   9.4136395E-02
     +,   9.2056103E-02,   8.9985274E-02,   8.7944143E-02
     +,   8.5951291E-02,   8.4023751E-02,   8.2176037E-02
     +,   8.0420040E-02,   7.8765072E-02,   7.7217780E-02
     +,   7.5782150E-02,   7.4459799E-02,   7.3250324E-02
     +,   7.2151378E-02,   7.1159229E-02,   7.0268922E-02
     +,   6.9474801E-02,   6.8770580E-02,   6.8149641E-02
     +,   6.7605227E-02,   6.7130856E-02,   6.6720173E-02
     +,   6.6367105E-02,   6.6066131E-02,   6.5811947E-02
     +,   6.5599792E-02,   6.5425433E-02,   6.5284818E-02
     +,   6.5174304E-02,   6.5090537E-02,   6.5030344E-02
     +,   6.4990625E-02,   6.4968348E-02,   6.4960510E-02
     +,   6.4963996E-02,   6.4975403E-02,   6.4991437E-02
     +,   6.5008499E-02,   6.5022923E-02,   6.5030918E-02
     +,   6.5028742E-02,   6.5012522E-02,   6.4978659E-02
     +,   6.4923808E-02,   6.4844809E-02,   6.4739004E-02
     +,   6.4604178E-02,   6.4438604E-02,   6.4241111E-02
     +,   6.4011231E-02,   6.3748978E-02,   6.3455023E-02
     +,   6.3130461E-02,   6.2776946E-02,   6.2396560E-02
     +,   6.1991617E-02,   6.1564766E-02,   6.1118763E-02
     +,   6.0656525E-02,   6.0181048E-02,   5.9695054E-02
     +,   5.9201408E-02,   5.8702596E-02,   5.8201142E-02
     +,   5.7699192E-02,   5.7198700E-02,   5.6701574E-02
     +,   5.6209262E-02,   5.5723101E-02,   5.5244297E-02
     +,   5.4773912E-02,   5.4312773E-02,   5.3861767E-02
     +,   5.3421598E-02,   5.2993122E-02,   5.2577015E-02
     +,   5.2174203E-02,   5.1785730E-02,   5.1412787E-02
     +,   5.1056650E-02,   5.0719019E-02,   5.0401680E-02
     +,   5.0106801E-02,   4.9836773E-02,   4.9594458E-02
     +,   4.9382694E-02,   4.9204830E-02,   4.9064383E-02
     +,   4.8964996E-02,   4.8910491E-02,   4.8904777E-02
     +,   4.8951689E-02,   4.9055129E-02,   4.9218804E-02
     +,   4.9446221E-02,   4.9740851E-02,   5.0105855E-02
     +,   5.0544128E-02,   5.1058471E-02,   5.1651493E-02
     +,   5.2325778E-02,   5.3083766E-02,   5.3928118E-02
     +,   5.4861579E-02,   5.5886988E-02,   5.7007540E-02
     +,   5.8226563E-02,   5.9547603E-02,   6.0974423E-02
     +,   6.2510557E-02,   6.4159386E-02,   6.5923713E-02
     +,   6.7805864E-02,   6.9806837E-02,   7.1926557E-02
     +,   7.4163318E-02,   7.6513730E-02,   7.8972548E-02
     +,   8.1532195E-02,   8.4183902E-02,   8.6916789E-02
     +,   8.9718431E-02,   9.2575423E-02,   9.5473774E-02
     +,   9.8399386E-02,   0.1013377    ,   0.1042756    
     +,   0.1072008    ,   0.1101016    ,   0.1129680    
     +,   0.1157906    ,   0.1185611    ,   0.1212709    
     +,   0.1239108    ,   0.1264705    ,   0.1289375    
     +,   0.1312963    ,   0.1335283    ,   0.1356108    
     +,   0.1375180    ,   0.1392198    ,   0.1406837    
     +,   0.1418754    ,   0.1427596    ,   0.1433023    
     +,   0.1434720    ,   0.1432409    ,   0.1425872    
     +,   0.1414959    ,   0.1399602    ,   0.1379813    
     +,   0.1355700    ,   0.1327449    ,   0.1295333    
     +,   0.1259689    ,   0.1220917    ,   0.1179458    
     +,   0.1135780    ,   0.1090366    ,   0.1043696    
     +,   9.9623680E-02,   9.4842255E-02,   9.0065882E-02
     +,   8.5331008E-02,   8.0668911E-02,   7.6106384E-02
     +,   7.1665794E-02,   6.7364879E-02,   6.3216999E-02
     +,   5.9231769E-02,   5.5415805E-02,   5.1772527E-02
     +,   4.8302945E-02,   4.5006514E-02,   4.1881025E-02
     +,   3.8922921E-02,   3.6127888E-02,   3.3491116E-02
     +,   3.1007396E-02,   2.8671188E-02,   2.6476720E-02
     +,   2.4418410E-02,   2.2490703E-02,   2.0687928E-02
     +,   1.9004539E-02,   1.7435256E-02,   1.5974721E-02
     +,   1.4617710E-02,   1.3359171E-02,   1.2194142E-02
     +,   1.1117700E-02,   1.0125012E-02,   9.2114210E-03
     +,   8.3723562E-03,   7.6033166E-03,   6.8999003E-03
     +,   6.2579061E-03,   5.6732213E-03,   5.1418636E-03
     +,   4.6599731E-03,   4.2239074E-03,   3.8301195E-03
     +,   3.4752367E-03,   3.1560785E-03,   2.8696216E-03
     +,   2.6129985E-03,   2.3835131E-03,   2.1786601E-03
     +,   1.9960983E-03,   1.8336365E-03,   1.6892524E-03
     +,   1.5610945E-03,   1.4474434E-03,   1.3467411E-03
     +,   1.2575550E-03,   1.1785942E-03,   1.1086814E-03
     +,   1.0467634E-03,   9.9188462E-04,   9.4319676E-04
     +,   8.9993572E-04,   8.6142641E-04,   8.2706509E-04
     +,   7.9631765E-04,   7.6871511E-04,   7.4384047E-04
     +,   7.2133000E-04,   7.0086197E-04,   6.8215758E-04
     +,   6.6497020E-04,   6.4908789E-04,   6.3432404E-04
     +,   6.2051869E-04,   6.0753158E-04,   5.9524318E-04
     +,   5.8354979E-04,   5.7236321E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_hzonly_hatt110_mass = Yx/5.02931529545454
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_hzonly_hatt115_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  5.0063506E-02,   5.3578179E-02
     +,   5.7108857E-02,   6.0631990E-02,   6.4123906E-02
     +,   6.7561202E-02,   7.0921257E-02,   7.4182674E-02
     +,   7.7325478E-02,   8.0331914E-02,   8.3186492E-02
     +,   8.5875995E-02,   8.8390253E-02,   9.0721942E-02
     +,   9.2866302E-02,   9.4821788E-02,   9.6589394E-02
     +,   9.8172918E-02,   9.9578120E-02,   0.1008130    
     +,   0.1018867    ,   0.1028100    ,   0.1035939    
     +,   0.1042498    ,   0.1047883    ,   0.1052197    
     +,   0.1055526    ,   0.1057946    ,   0.1059514    
     +,   0.1060271    ,   0.1060244    ,   0.1059449    
     +,   0.1057893    ,   0.1055586    ,   0.1052536    
     +,   0.1048765    ,   0.1044311    ,   0.1039232    
     +,   0.1033605    ,   0.1027540    ,   0.1021160    
     +,   0.1014611    ,   0.1008055    ,   0.1001654    
     +,   9.9557139E-02,   9.8996215E-02,   9.8495238E-02
     +,   9.8064840E-02,   9.7711578E-02,   9.7438343E-02
     +,   9.7243771E-02,   9.7122110E-02,   9.7064376E-02
     +,   9.7057380E-02,   9.7085580E-02,   9.7131416E-02
     +,   9.7175963E-02,   9.7200416E-02,   9.7186126E-02
     +,   9.7116373E-02,   9.6976131E-02,   9.6752770E-02
     +,   9.6437067E-02,   9.6022442E-02,   9.5505692E-02
     +,   9.4886705E-02,   9.4168037E-02,   9.3355171E-02
     +,   9.2455395E-02,   9.1477968E-02,   9.0433605E-02
     +,   8.9333721E-02,   8.8190347E-02,   8.7015860E-02
     +,   8.5821949E-02,   8.4620222E-02,   8.3421260E-02
     +,   8.2234874E-02,   8.1069656E-02,   7.9932980E-02
     +,   7.8831062E-02,   7.7768683E-02,   7.6749593E-02
     +,   7.5776331E-02,   7.4850298E-02,   7.3972136E-02
     +,   7.3141605E-02,   7.2357625E-02,   7.1618721E-02
     +,   7.0923001E-02,   7.0268214E-02,   6.9651857E-02
     +,   6.9071494E-02,   6.8524338E-02,   6.8007782E-02
     +,   6.7519061E-02,   6.7055471E-02,   6.6614144E-02
     +,   6.6192329E-02,   6.5786935E-02,   6.5394789E-02
     +,   6.5012485E-02,   6.4636484E-02,   6.4262912E-02
     +,   6.3887708E-02,   6.3506640E-02,   6.3115217E-02
     +,   6.2708952E-02,   6.2283427E-02,   6.1834250E-02
     +,   6.1357342E-02,   6.0848963E-02,   6.0305942E-02
     +,   5.9725627E-02,   5.9106164E-02,   5.8446467E-02
     +,   5.7746362E-02,   5.7006478E-02,   5.6228515E-02
     +,   5.5414863E-02,   5.4568820E-02,   5.3694513E-02
     +,   5.2796494E-02,   5.1880002E-02,   5.0950505E-02
     +,   5.0013777E-02,   4.9075663E-02,   4.8141863E-02
     +,   4.7217909E-02,   4.6309058E-02,   4.5420028E-02
     +,   4.4555053E-02,   4.3717835E-02,   4.2911325E-02
     +,   4.2137954E-02,   4.1399371E-02,   4.0696759E-02
     +,   4.0030595E-02,   3.9400876E-02,   3.8807102E-02
     +,   3.8248397E-02,   3.7723642E-02,   3.7231412E-02
     +,   3.6770131E-02,   3.6338225E-02,   3.5934124E-02
     +,   3.5556175E-02,   3.5203096E-02,   3.4873601E-02
     +,   3.4566689E-02,   3.4281574E-02,   3.4017723E-02
     +,   3.3774931E-02,   3.3553176E-02,   3.3352759E-02
     +,   3.3174247E-02,   3.3018474E-02,   3.2886487E-02
     +,   3.2779533E-02,   3.2699145E-02,   3.2647043E-02
     +,   3.2625191E-02,   3.2635640E-02,   3.2680776E-02
     +,   3.2763045E-02,   3.2885231E-02,   3.3050165E-02
     +,   3.3260897E-02,   3.3520717E-02,   3.3833016E-02
     +,   3.4201339E-02,   3.4629315E-02,   3.5120845E-02
     +,   3.5679784E-02,   3.6310084E-02,   3.7015848E-02
     +,   3.7801165E-02,   3.8670208E-02,   3.9627086E-02
     +,   4.0676091E-02,   4.1821584E-02,   4.3067865E-02
     +,   4.4419218E-02,   4.5880284E-02,   4.7455482E-02
     +,   4.9149178E-02,   5.0965540E-02,   5.2908640E-02
     +,   5.4981913E-02,   5.7188015E-02,   5.9528608E-02
     +,   6.2003996E-02,   6.4612605E-02,   6.7350551E-02
     +,   7.0211694E-02,   7.3186778E-02,   7.6263309E-02
     +,   7.9425305E-02,   8.2653582E-02,   8.5925490E-02
     +,   8.9215189E-02,   9.2494152E-02,   9.5732026E-02
     +,   9.8897368E-02,   0.1019578    ,   0.1048823    
     +,   0.1076410    ,   0.1102070    ,   0.1125565    
     +,   0.1146703    ,   0.1165339    ,   0.1181377    
     +,   0.1194771    ,   0.1205528    ,   0.1213694    
     +,   0.1219354    ,   0.1222622    ,   0.1223629    
     +,   0.1222517    ,   0.1219427    ,   0.1214491    
     +,   0.1207824    ,   0.1199523    ,   0.1189660    
     +,   0.1178280    ,   0.1165409    ,   0.1151053    
     +,   0.1135206    ,   0.1117845    ,   0.1098953    
     +,   0.1078513    ,   0.1056522    ,   0.1032987    
     +,   0.1007936    ,   9.8142266E-02,   9.5351800E-02
     +,   9.2431962E-02,   8.9394815E-02,   8.6254254E-02
     +,   8.3026186E-02,   7.9727411E-02,   7.6376356E-02
     +,   7.2991721E-02,   6.9592483E-02,   6.6197231E-02
     +,   6.2824436E-02,   5.9491597E-02,   5.6215040E-02
     +,   5.3009480E-02,   4.9888715E-02,   4.6864282E-02
     +,   4.3946128E-02,   4.1142471E-02,   3.8459744E-02
     +,   3.5902381E-02,   3.3473115E-02,   3.1173220E-02
     +,   2.9002490E-02,   2.6959263E-02,   2.5040718E-02
     +,   2.3243219E-02,   2.1562347E-02,   1.9992953E-02
     +,   1.8529473E-02,   1.7166259E-02,   1.5897332E-02
     +,   1.4716788E-02,   1.3618860E-02,   1.2597973E-02
     +,   1.1648726E-02,   1.0766018E-02,   9.9451309E-03
     +,   9.1816494E-03,   8.4714536E-03,   7.8107445E-03
     +,   7.1960967E-03,   6.6242884E-03,   6.0924459E-03
     +,   5.5978564E-03,   5.1381011E-03,   4.7108945E-03
     +,   4.3141786E-03,   3.9460002E-03,   3.6045949E-03
     +,   3.2882718E-03,   2.9954948E-03,   2.7247949E-03
     +,   2.4747886E-03,   2.2442001E-03,   2.0317917E-03
     +,   1.8364212E-03,   1.6569798E-03,   1.4924407E-03
     +,   1.3418044E-03,   1.2041446E-03,   1.0785594E-03
     +,   9.6421072E-04,   8.6028618E-04,   7.6602871E-04
     +,   6.8070804E-04,   6.0364295E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_hzonly_hatt115_mass = Yx/4.62835262790698
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_hzonly_hatt120_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.6271831E-02,   4.9090784E-02
     +,   5.1898234E-02,   5.4678708E-02,   5.7417501E-02
     +,   6.0101144E-02,   6.2717438E-02,   6.5256029E-02
     +,   6.7708358E-02,   7.0067927E-02,   7.2330147E-02
     +,   7.4492432E-02,   7.6553993E-02,   7.8515597E-02
     +,   8.0379322E-02,   8.2148246E-02,   8.3826058E-02
     +,   8.5416466E-02,   8.6923257E-02,   8.8349499E-02
     +,   8.9697450E-02,   9.0968214E-02,   9.2161886E-02
     +,   9.3277223E-02,   9.4311379E-02,   9.5260881E-02
     +,   9.6121259E-02,   9.6887179E-02,   9.7553201E-02
     +,   9.8114267E-02,   9.8565541E-02,   9.8903477E-02
     +,   9.9125497E-02,   9.9231116E-02,   9.9221200E-02
     +,   9.9098973E-02,   9.8869488E-02,   9.8539740E-02
     +,   9.8118417E-02,   9.7615749E-02,   9.7042926E-02
     +,   9.6411712E-02,   9.5734105E-02,   9.5021635E-02
     +,   9.4284929E-02,   9.3533628E-02,   9.2775322E-02
     +,   9.2016026E-02,   9.1259427E-02,   9.0507336E-02
     +,   8.9759283E-02,   8.9013018E-02,   8.8264771E-02
     +,   8.7509491E-02,   8.6741403E-02,   8.5954532E-02
     +,   8.5143030E-02,   8.4301695E-02,   8.3426975E-02
     +,   8.2516134E-02,   8.1568897E-02,   8.0586702E-02
     +,   7.9573348E-02,   7.8534476E-02,   7.7477992E-02
     +,   7.6413542E-02,   7.5352311E-02,   7.4306577E-02
     +,   7.3289342E-02,   7.2313868E-02,   7.1393214E-02
     +,   7.0539586E-02,   6.9764405E-02,   6.9077276E-02
     +,   6.8485938E-02,   6.7995958E-02,   6.7610353E-02
     +,   6.7329869E-02,   6.7152150E-02,   6.7072786E-02
     +,   6.7084350E-02,   6.7177452E-02,   6.7340456E-02
     +,   6.7560025E-02,   6.7821428E-02,   6.8108954E-02
     +,   6.8406381E-02,   6.8697400E-02,   6.8966061E-02
     +,   6.9196984E-02,   6.9376148E-02,   6.9490984E-02
     +,   6.9530614E-02,   6.9486253E-02,   6.9351219E-02
     +,   6.9121331E-02,   6.8794243E-02,   6.8370245E-02
     +,   6.7851640E-02,   6.7242652E-02,   6.6549242E-02
     +,   6.5778919E-02,   6.4940259E-02,   6.4042918E-02
     +,   6.3096926E-02,   6.2112618E-02,   6.1100397E-02
     +,   6.0070369E-02,   5.9031948E-02,   5.7993881E-02
     +,   5.6964055E-02,   5.5949230E-02,   5.4955106E-02
     +,   5.3986169E-02,   5.3045906E-02,   5.2136529E-02
     +,   5.1259287E-02,   5.0414391E-02,   4.9601372E-02
     +,   4.8818897E-02,   4.8065122E-02,   4.7337838E-02
     +,   4.6634413E-02,   4.5952145E-02,   4.5288134E-02
     +,   4.4639729E-02,   4.4004258E-02,   4.3379329E-02
     +,   4.2762738E-02,   4.2152673E-02,   4.1547518E-02
     +,   4.0946152E-02,   4.0347580E-02,   3.9751325E-02
     +,   3.9157063E-02,   3.8564749E-02,   3.7974678E-02
     +,   3.7387319E-02,   3.6803316E-02,   3.6223441E-02
     +,   3.5648718E-02,   3.5080187E-02,   3.4519114E-02
     +,   3.3966679E-02,   3.3424370E-02,   3.2893572E-02
     +,   3.2375790E-02,   3.1872649E-02,   3.1385764E-02
     +,   3.0916855E-02,   3.0467641E-02,   3.0039936E-02
     +,   2.9635597E-02,   2.9256482E-02,   2.8904496E-02
     +,   2.8581573E-02,   2.8289625E-02,   2.8030599E-02
     +,   2.7806353E-02,   2.7618825E-02,   2.7469799E-02
     +,   2.7361033E-02,   2.7294273E-02,   2.7271064E-02
     +,   2.7292967E-02,   2.7361332E-02,   2.7477475E-02
     +,   2.7642541E-02,   2.7857564E-02,   2.8123440E-02
     +,   2.8440919E-02,   2.8810669E-02,   2.9233232E-02
     +,   2.9709050E-02,   3.0238466E-02,   3.0821774E-02
     +,   3.1459231E-02,   3.2151014E-02,   3.2897297E-02
     +,   3.3698227E-02,   3.4554042E-02,   3.5464834E-02
     +,   3.6430754E-02,   3.7451878E-02,   3.8528357E-02
     +,   3.9660044E-02,   4.0846705E-02,   4.2087890E-02
     +,   4.3382999E-02,   4.4730846E-02,   4.6129979E-02
     +,   4.7578327E-02,   4.9073361E-02,   5.0611742E-02
     +,   5.2189462E-02,   5.3801976E-02,   5.5443808E-02
     +,   5.7108656E-02,   5.8789842E-02,   6.0479876E-02
     +,   6.2170632E-02,   6.3853569E-02,   6.5519899E-02
     +,   6.7160659E-02,   6.8766490E-02,   7.0328511E-02
     +,   7.1837865E-02,   7.3285937E-02,   7.4664690E-02
     +,   7.5966462E-02,   7.7184342E-02,   7.8312032E-02
     +,   7.9343982E-02,   8.0275148E-02,   8.1101581E-02
     +,   8.1819735E-02,   8.2426906E-02,   8.2921028E-02
     +,   8.3300747E-02,   8.3565436E-02,   8.3714977E-02
     +,   8.3749980E-02,   8.3671667E-02,   8.3481953E-02
     +,   8.3183222E-02,   8.2778692E-02,   8.2272157E-02
     +,   8.1667930E-02,   8.0970980E-02,   8.0186635E-02
     +,   7.9320893E-02,   7.8380056E-02,   7.7370457E-02
     +,   7.6298952E-02,   7.5172238E-02,   7.3996976E-02
     +,   7.2779499E-02,   7.1526013E-02,   7.0242301E-02
     +,   6.8933517E-02,   6.7604192E-02,   6.6258483E-02
     +,   6.4899728E-02,   6.3530676E-02,   6.2153377E-02
     +,   6.0769416E-02,   5.9380047E-02,   5.7985853E-02
     +,   5.6587201E-02,   5.5184361E-02,   5.3777371E-02
     +,   5.2366268E-02,   5.0951220E-02,   4.9532656E-02
     +,   4.8110958E-02,   4.6686869E-02,   4.5261521E-02
     +,   4.3836329E-02,   4.2412825E-02,   4.0992953E-02
     +,   3.9578814E-02,   3.8172867E-02,   3.6777515E-02
     +,   3.5395324E-02,   3.4028932E-02,   3.2680906E-02
     +,   3.1353693E-02,   3.0049743E-02,   2.8771279E-02
     +,   2.7520331E-02,   2.6298603E-02,   2.5107749E-02
     +,   2.3949062E-02,   2.2823565E-02,   2.1732053E-02
     +,   2.0675130E-02,   1.9653073E-02,   1.8666090E-02
     +,   1.7714059E-02,   1.6796820E-02,   1.5913961E-02
     +,   1.5065081E-02,   1.4249535E-02,   1.3466767E-02
     +,   1.2716006E-02,   1.1996589E-02,   1.1307708E-02
     +,   1.0648596E-02,   1.0018507E-02,   9.4166277E-03
     +,   8.8422261E-03,   8.2945144E-03,   7.7727884E-03
     +,   7.2762696E-03,   6.8042804E-03,   6.3560735E-03
     +,   5.9309718E-03,   5.5282549E-03,   5.1472480E-03
     +,   4.7872351E-03,   4.4475496E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_hzonly_hatt120_mass = Yx/4.12926272093023
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_hzonly_hatt60_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  9.9745635E-03,   1.0753728E-02
     +,   1.1569236E-02,   1.2420155E-02,   1.3305226E-02
     +,   1.4222844E-02,   1.5171066E-02,   1.6147582E-02
     +,   1.7149759E-02,   1.8174689E-02,   1.9219108E-02
     +,   2.0279530E-02,   2.1352250E-02,   2.2433383E-02
     +,   2.3518961E-02,   2.4604915E-02,   2.5687199E-02
     +,   2.6761808E-02,   2.7824802E-02,   2.8872421E-02
     +,   2.9901000E-02,   3.0907054E-02,   3.1887230E-02
     +,   3.2838393E-02,   3.3757400E-02,   3.4641236E-02
     +,   3.5486836E-02,   3.6291115E-02,   3.7050858E-02
     +,   3.7762720E-02,   3.8423125E-02,   3.9028376E-02
     +,   3.9574623E-02,   4.0057953E-02,   4.0474392E-02
     +,   4.0820178E-02,   4.1091882E-02,   4.1286483E-02
     +,   4.1401729E-02,   4.1436184E-02,   4.1389514E-02
     +,   4.1262571E-02,   4.1057553E-02,   4.0778067E-02
     +,   4.0429000E-02,   4.0016755E-02,   3.9548844E-02
     +,   3.9033834E-02,   3.8481098E-02,   3.7900470E-02
     +,   3.7302103E-02,   3.6695872E-02,   3.6091350E-02
     +,   3.5497207E-02,   3.4921221E-02,   3.4369808E-02
     +,   3.3847995E-02,   3.3359267E-02,   3.2905523E-02
     +,   3.2487124E-02,   3.2102980E-02,   3.1750645E-02
     +,   3.1426650E-02,   3.1126497E-02,   3.0845162E-02
     +,   3.0577181E-02,   3.0316973E-02,   3.0059086E-02
     +,   2.9798413E-02,   2.9530356E-02,   2.9250983E-02
     +,   2.8957203E-02,   2.8646698E-02,   2.8318090E-02
     +,   2.7970813E-02,   2.7605118E-02,   2.7221968E-02
     +,   2.6822999E-02,   2.6410252E-02,   2.5986211E-02
     +,   2.5553584E-02,   2.5115136E-02,   2.4673693E-02
     +,   2.4231929E-02,   2.3792323E-02,   2.3357116E-02
     +,   2.2928258E-02,   2.2507284E-02,   2.2095518E-02
     +,   2.1693902E-02,   2.1303067E-02,   2.0923477E-02
     +,   2.0555383E-02,   2.0198848E-02,   1.9853892E-02
     +,   1.9520510E-02,   1.9198677E-02,   1.8888451E-02
     +,   1.8589931E-02,   1.8303357E-02,   1.8029016E-02
     +,   1.7767332E-02,   1.7518781E-02,   1.7283920E-02
     +,   1.7063309E-02,   1.6857520E-02,   1.6667081E-02
     +,   1.6492443E-02,   1.6333953E-02,   1.6191812E-02
     +,   1.6066087E-02,   1.5956651E-02,   1.5863212E-02
     +,   1.5785292E-02,   1.5722247E-02,   1.5673261E-02
     +,   1.5637420E-02,   1.5613660E-02,   1.5600850E-02
     +,   1.5597820E-02,   1.5603348E-02,   1.5616256E-02
     +,   1.5635371E-02,   1.5659604E-02,   1.5687920E-02
     +,   1.5719403E-02,   1.5753215E-02,   1.5788648E-02
     +,   1.5825074E-02,   1.5861994E-02,   1.5898988E-02
     +,   1.5935712E-02,   1.5971901E-02,   1.6007330E-02
     +,   1.6041830E-02,   1.6075244E-02,   1.6107427E-02
     +,   1.6138246E-02,   1.6167542E-02,   1.6195167E-02
     +,   1.6220957E-02,   1.6244728E-02,   1.6266305E-02
     +,   1.6285516E-02,   1.6302211E-02,   1.6316274E-02
     +,   1.6327623E-02,   1.6336247E-02,   1.6342200E-02
     +,   1.6345639E-02,   1.6346810E-02,   1.6346069E-02
     +,   1.6343879E-02,   1.6340833E-02,   1.6337628E-02
     +,   1.6335072E-02,   1.6334068E-02,   1.6335614E-02
     +,   1.6340762E-02,   1.6350606E-02,   1.6366284E-02
     +,   1.6388915E-02,   1.6419584E-02,   1.6459331E-02
     +,   1.6509105E-02,   1.6569741E-02,   1.6641939E-02
     +,   1.6726231E-02,   1.6822983E-02,   1.6932361E-02
     +,   1.7054301E-02,   1.7188536E-02,   1.7334573E-02
     +,   1.7491708E-02,   1.7658979E-02,   1.7835269E-02
     +,   1.8019224E-02,   1.8209338E-02,   1.8403921E-02
     +,   1.8601177E-02,   1.8799214E-02,   1.8996034E-02
     +,   1.9189622E-02,   1.9377921E-02,   1.9558925E-02
     +,   1.9730654E-02,   1.9891186E-02,   2.0038720E-02
     +,   2.0171579E-02,   2.0288205E-02,   2.0387204E-02
     +,   2.0467337E-02,   2.0527540E-02,   2.0566918E-02
     +,   2.0584764E-02,   2.0580515E-02,   2.0553781E-02
     +,   2.0504318E-02,   2.0432016E-02,   2.0336879E-02
     +,   2.0219048E-02,   2.0078741E-02,   1.9916253E-02
     +,   1.9731941E-02,   1.9526273E-02,   1.9299697E-02
     +,   1.9052736E-02,   1.8785963E-02,   1.8499974E-02
     +,   1.8195404E-02,   1.7872898E-02,   1.7533172E-02
     +,   1.7176995E-02,   1.6805142E-02,   1.6418450E-02
     +,   1.6017824E-02,   1.5604246E-02,   1.5178713E-02
     +,   1.4742295E-02,   1.4296164E-02,   1.3841506E-02
     +,   1.3379566E-02,   1.2911668E-02,   1.2439183E-02
     +,   1.1963476E-02,   1.1485951E-02,   1.1008044E-02
     +,   1.0531193E-02,   1.0056805E-02,   9.5862495E-03
     +,   9.1208955E-03,   8.6620599E-03,   8.2109729E-03
     +,   7.7687860E-03,   7.3366170E-03,   6.9154524E-03
     +,   6.5061781E-03,   6.1096088E-03,   5.7264511E-03
     +,   5.3572753E-03,   5.0025485E-03,   4.6626502E-03
     +,   4.3378533E-03,   4.0283059E-03,   3.7340617E-03
     +,   3.4550983E-03,   3.1913077E-03,   2.9424815E-03
     +,   2.7083452E-03,   2.4885789E-03,   2.2827850E-03
     +,   2.0905184E-03,   1.9113058E-03,   1.7446399E-03
     +,   1.5899758E-03,   1.4467511E-03,   1.3144005E-03
     +,   1.1923510E-03,   1.0800204E-03,   9.7683154E-04
     +,   8.8222232E-04,   7.9564098E-04,   7.1654579E-04
     +,   6.4441294E-04,   5.7874550E-04,   5.1906123E-04
     +,   4.6490069E-04,   4.1583215E-04,   3.7144692E-04
     +,   3.3135744E-04,   2.9520050E-04,   2.6263922E-04
     +,   2.3335913E-04,   2.0706613E-04,   1.8348801E-04
     +,   1.6237533E-04,   1.4349552E-04,   1.2663688E-04
     +,   1.1160301E-04,   9.8215984E-05,   8.6311346E-05
     +,   7.5740565E-05,   6.6366934E-05,   5.8067424E-05
     +,   5.0729188E-05,   4.4250904E-05,   3.8540169E-05
     +,   3.3513563E-05,   2.9096271E-05,   2.5220270E-05
     +,   2.1824899E-05,   1.8855197E-05,   1.6262249E-05
     +,   1.4001917E-05,   1.2035013E-05,   1.0326293E-05
     +,   8.8445777E-06,   7.5619050E-06,   6.4536189E-06
     +,   5.4976972E-06,   4.6747718E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_hzonly_hatt60_mass = Yx/1.24453967647059
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_hzonly_hatt65_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  7.4923630E-03,   8.0865761E-03
     +,   8.7084798E-03,   9.3573192E-03,   1.0032154E-02
     +,   1.0731867E-02,   1.1455183E-02,   1.2200718E-02
     +,   1.2966977E-02,   1.3752453E-02,   1.4555596E-02
     +,   1.5374902E-02,   1.6208926E-02,   1.7056340E-02
     +,   1.7915929E-02,   1.8786633E-02,   1.9667532E-02
     +,   2.0557836E-02,   2.1456929E-02,   2.2364227E-02
     +,   2.3279265E-02,   2.4201535E-02,   2.5130514E-02
     +,   2.6065627E-02,   2.7006015E-02,   2.7950786E-02
     +,   2.8898716E-02,   2.9848346E-02,   3.0797934E-02
     +,   3.1745493E-02,   3.2688718E-02,   3.3625163E-02
     +,   3.4552045E-02,   3.5466518E-02,   3.6365569E-02
     +,   3.7246056E-02,   3.8104814E-02,   3.8938589E-02
     +,   3.9744060E-02,   4.0517796E-02,   4.1256335E-02
     +,   4.1955996E-02,   4.2612955E-02,   4.3223098E-02
     +,   4.3782160E-02,   4.4285670E-02,   4.4728853E-02
     +,   4.5106944E-02,   4.5415193E-02,   4.5648977E-02
     +,   4.5804165E-02,   4.5877174E-02,   4.5865387E-02
     +,   4.5767292E-02,   4.5582704E-02,   4.5313012E-02
     +,   4.4961285E-02,   4.4532269E-02,   4.4032399E-02
     +,   4.3469705E-02,   4.2853538E-02,   4.2194340E-02
     +,   4.1503306E-02,   4.0791892E-02,   4.0071491E-02
     +,   3.9353035E-02,   3.8646396E-02,   3.7960373E-02
     +,   3.7301965E-02,   3.6676578E-02,   3.6087453E-02
     +,   3.5535965E-02,   3.5021458E-02,   3.4541525E-02
     +,   3.4092005E-02,   3.3667430E-02,   3.3261269E-02
     +,   3.2866351E-02,   3.2475118E-02,   3.2080080E-02
     +,   3.1674221E-02,   3.1251173E-02,   3.0805713E-02
     +,   3.0333761E-02,   2.9832702E-02,   2.9301371E-02
     +,   2.8740190E-02,   2.8150970E-02,   2.7536962E-02
     +,   2.6902603E-02,   2.6253309E-02,   2.5595337E-02
     +,   2.4935437E-02,   2.4280671E-02,   2.3638085E-02
     +,   2.3014579E-02,   2.2416605E-02,   2.1850120E-02
     +,   2.1320248E-02,   2.0831399E-02,   2.0387016E-02
     +,   1.9989677E-02,   1.9640991E-02,   1.9341698E-02
     +,   1.9091630E-02,   1.8889857E-02,   1.8734703E-02
     +,   1.8623833E-02,   1.8554352E-02,   1.8522847E-02
     +,   1.8525515E-02,   1.8558251E-02,   1.8616678E-02
     +,   1.8696297E-02,   1.8792486E-02,   1.8900685E-02
     +,   1.9016381E-02,   1.9135257E-02,   1.9253220E-02
     +,   1.9366516E-02,   1.9471793E-02,   1.9566135E-02
     +,   1.9647168E-02,   1.9713048E-02,   1.9762535E-02
     +,   1.9794984E-02,   1.9810334E-02,   1.9809121E-02
     +,   1.9792410E-02,   1.9761760E-02,   1.9719142E-02
     +,   1.9666862E-02,   1.9607469E-02,   1.9543672E-02
     +,   1.9478243E-02,   1.9413855E-02,   1.9353097E-02
     +,   1.9298270E-02,   1.9251427E-02,   1.9214200E-02
     +,   1.9187845E-02,   1.9173158E-02,   1.9170506E-02
     +,   1.9179808E-02,   1.9200560E-02,   1.9231899E-02
     +,   1.9272640E-02,   1.9321339E-02,   1.9376388E-02
     +,   1.9436060E-02,   1.9498616E-02,   1.9562364E-02
     +,   1.9625716E-02,   1.9687267E-02,   1.9745860E-02
     +,   1.9800568E-02,   1.9850759E-02,   1.9896111E-02
     +,   1.9936554E-02,   1.9972308E-02,   2.0003796E-02
     +,   2.0031653E-02,   2.0056652E-02,   2.0079611E-02
     +,   2.0101408E-02,   2.0122854E-02,   2.0144671E-02
     +,   2.0167422E-02,   2.0191472E-02,   2.0216951E-02
     +,   2.0243708E-02,   2.0271327E-02,   2.0299090E-02
     +,   2.0325998E-02,   2.0350782E-02,   2.0371960E-02
     +,   2.0387817E-02,   2.0396518E-02,   2.0396104E-02
     +,   2.0384589E-02,   2.0360008E-02,   2.0320449E-02
     +,   2.0264156E-02,   2.0189539E-02,   2.0095255E-02
     +,   1.9980209E-02,   1.9843638E-02,   1.9685065E-02
     +,   1.9504353E-02,   1.9301722E-02,   1.9077672E-02
     +,   1.8832996E-02,   1.8568795E-02,   1.8286396E-02
     +,   1.7987303E-02,   1.7673161E-02,   1.7345767E-02
     +,   1.7006952E-02,   1.6658552E-02,   1.6302368E-02
     +,   1.5940167E-02,   1.5573617E-02,   1.5204235E-02
     +,   1.4833397E-02,   1.4462347E-02,   1.4092143E-02
     +,   1.3723663E-02,   1.3357655E-02,   1.2994699E-02
     +,   1.2635213E-02,   1.2279499E-02,   1.1927764E-02
     +,   1.1580113E-02,   1.1236572E-02,   1.0897106E-02
     +,   1.0561666E-02,   1.0230184E-02,   9.9025629E-03
     +,   9.5787151E-03,   9.2585944E-03,   8.9421561E-03
     +,   8.6293798E-03,   8.3202962E-03,   8.0149742E-03
     +,   7.7134934E-03,   7.4159694E-03,   7.1225674E-03
     +,   6.8334742E-03,   6.5488857E-03,   6.2690140E-03
     +,   5.9941043E-03,   5.7244087E-03,   5.4601678E-03
     +,   5.2016200E-03,   4.9490291E-03,   4.7026211E-03
     +,   4.4626147E-03,   4.2292294E-03,   4.0026638E-03
     +,   3.7830852E-03,   3.5706384E-03,   3.3654599E-03
     +,   3.1676602E-03,   2.9773128E-03,   2.7944632E-03
     +,   2.6191471E-03,   2.4513684E-03,   2.2910982E-03
     +,   2.1382810E-03,   1.9928524E-03,   1.8547100E-03
     +,   1.7237293E-03,   1.5997754E-03,   1.4826928E-03
     +,   1.3723013E-03,   1.2684057E-03,   1.1708050E-03
     +,   1.0792854E-03,   9.9361828E-04,   9.1356679E-04
     +,   8.3889515E-04,   7.6936261E-04,   7.0472149E-04
     +,   6.4472458E-04,   5.8913155E-04,   5.3769862E-04
     +,   4.9018639E-04,   4.4636373E-04,   4.0600507E-04
     +,   3.6888849E-04,   3.3480057E-04,   3.0353805E-04
     +,   2.7490576E-04,   2.4871563E-04,   2.2478899E-04
     +,   2.0295862E-04,   1.8306347E-04,   1.6495462E-04
     +,   1.4848943E-04,   1.3353663E-04,   1.1997132E-04
     +,   1.0767886E-04,   9.6550990E-05,   8.6488508E-05
     +,   7.7398268E-05,   6.9195252E-05,   6.1800143E-05
     +,   5.5139870E-05,   4.9147853E-05,   4.3762098E-05
     +,   3.8926446E-05,   3.4588818E-05,   3.0702126E-05
     +,   2.7222828E-05,   2.4111621E-05,   2.1332324E-05
     +,   1.8852294E-05,   1.6641538E-05,   1.4673098E-05
     +,   1.2922235E-05,   1.1366757E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_hzonly_hatt65_mass = Yx/1.2899658
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_hzonly_hatt70_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  8.0621084E-03,   8.4877014E-03
     +,   8.9240894E-03,   9.3715005E-03,   9.8301852E-03
     +,   1.0300389E-02,   1.0782321E-02,   1.1276155E-02
     +,   1.1781961E-02,   1.2299766E-02,   1.2829449E-02
     +,   1.3370837E-02,   1.3923670E-02,   1.4487687E-02
     +,   1.5062658E-02,   1.5648490E-02,   1.6245320E-02
     +,   1.6853629E-02,   1.7474391E-02,   1.8109167E-02
     +,   1.8760245E-02,   1.9430710E-02,   2.0124521E-02
     +,   2.0846562E-02,   2.1602534E-02,   2.2398943E-02
     +,   2.3242954E-02,   2.4142155E-02,   2.5104329E-02
     +,   2.6137192E-02,   2.7248014E-02,   2.8443333E-02
     +,   2.9728550E-02,   3.1107645E-02,   3.2582790E-02
     +,   3.4154098E-02,   3.5819415E-02,   3.7574053E-02
     +,   3.9410912E-02,   4.1320063E-02,   4.3289378E-02
     +,   4.5304175E-02,   4.7347780E-02,   4.9401689E-02
     +,   5.1445991E-02,   5.3459715E-02,   5.5421304E-02
     +,   5.7309013E-02,   5.9101380E-02,   6.0777634E-02
     +,   6.2318288E-02,   6.3705407E-02,   6.4923495E-02
     +,   6.5959744E-02,   6.6804603E-02,   6.7452624E-02
     +,   6.7902409E-02,   6.8157218E-02,   6.8224870E-02
     +,   6.8117455E-02,   6.7850754E-02,   6.7443438E-02
     +,   6.6915683E-02,   6.6287883E-02,   6.5579139E-02
     +,   6.4805970E-02,   6.3980922E-02,   6.3112043E-02
     +,   6.2202252E-02,   6.1249934E-02,   6.0249470E-02
     +,   5.9192486E-02,   5.8069494E-02,   5.6871474E-02
     +,   5.5591434E-02,   5.4225951E-02,   5.2775990E-02
     +,   5.1247433E-02,   4.9650852E-02,   4.8000991E-02
     +,   4.6315901E-02,   4.4615190E-02,   4.2919349E-02
     +,   4.1247718E-02,   3.9617859E-02,   3.8044427E-02
     +,   3.6539000E-02,   3.5109669E-02,   3.3761479E-02
     +,   3.2496743E-02,   3.1315684E-02,   3.0217178E-02
     +,   2.9199244E-02,   2.8259613E-02,   2.7396105E-02
     +,   2.6606914E-02,   2.5890565E-02,   2.5246004E-02
     +,   2.4672214E-02,   2.4168303E-02,   2.3732975E-02
     +,   2.3364583E-02,   2.3060789E-02,   2.2818524E-02
     +,   2.2633947E-02,   2.2502463E-02,   2.2418788E-02
     +,   2.2377102E-02,   2.2371178E-02,   2.2394611E-02
     +,   2.2440912E-02,   2.2503776E-02,   2.2577189E-02
     +,   2.2655526E-02,   2.2733754E-02,   2.2807417E-02
     +,   2.2872668E-02,   2.2926360E-02,   2.2965936E-02
     +,   2.2989465E-02,   2.2995500E-02,   2.2983106E-02
     +,   2.2951717E-02,   2.2901105E-02,   2.2831295E-02
     +,   2.2742489E-02,   2.2635041E-02,   2.2509443E-02
     +,   2.2366244E-02,   2.2206115E-02,   2.2029748E-02
     +,   2.1838004E-02,   2.1631802E-02,   2.1412237E-02
     +,   2.1180540E-02,   2.0938147E-02,   2.0686664E-02
     +,   2.0427935E-02,   2.0163979E-02,   1.9896990E-02
     +,   1.9629352E-02,   1.9363560E-02,   1.9102169E-02
     +,   1.8847756E-02,   1.8602867E-02,   1.8369900E-02
     +,   1.8151077E-02,   1.7948380E-02,   1.7763488E-02
     +,   1.7597694E-02,   1.7451860E-02,   1.7326443E-02
     +,   1.7221423E-02,   1.7136317E-02,   1.7070187E-02
     +,   1.7021671E-02,   1.6989002E-02,   1.6970089E-02
     +,   1.6962552E-02,   1.6963784E-02,   1.6971057E-02
     +,   1.6981555E-02,   1.6992491E-02,   1.7001119E-02
     +,   1.7004870E-02,   1.7001357E-02,   1.6988467E-02
     +,   1.6964380E-02,   1.6927591E-02,   1.6876956E-02
     +,   1.6811712E-02,   1.6731411E-02,   1.6635980E-02
     +,   1.6525658E-02,   1.6400998E-02,   1.6262792E-02
     +,   1.6112063E-02,   1.5950015E-02,   1.5777981E-02
     +,   1.5597386E-02,   1.5409681E-02,   1.5216338E-02
     +,   1.5018788E-02,   1.4818381E-02,   1.4616358E-02
     +,   1.4413854E-02,   1.4211867E-02,   1.4011204E-02
     +,   1.3812541E-02,   1.3616378E-02,   1.3423061E-02
     +,   1.3232771E-02,   1.3045562E-02,   1.2861355E-02
     +,   1.2679959E-02,   1.2501081E-02,   1.2324368E-02
     +,   1.2149414E-02,   1.1975761E-02,   1.1802941E-02
     +,   1.1630489E-02,   1.1457956E-02,   1.1284906E-02
     +,   1.1110948E-02,   1.0935741E-02,   1.0758996E-02
     +,   1.0580469E-02,   1.0399992E-02,   1.0217458E-02
     +,   1.0032796E-02,   9.8460112E-03,   9.6571464E-03
     +,   9.4663054E-03,   9.2736166E-03,   9.0792403E-03
     +,   8.8833757E-03,   8.6862473E-03,   8.4880702E-03
     +,   8.2890838E-03,   8.0895405E-03,   7.8896759E-03
     +,   7.6897205E-03,   7.4899108E-03,   7.2904760E-03
     +,   7.0916237E-03,   6.8935454E-03,   6.6964417E-03
     +,   6.5004961E-03,   6.3058748E-03,   6.1127343E-03
     +,   5.9212358E-03,   5.7315342E-03,   5.5437698E-03
     +,   5.3580771E-03,   5.1746075E-03,   4.9934941E-03
     +,   4.8148688E-03,   4.6388730E-03,   4.4656489E-03
     +,   4.2953291E-03,   4.1280407E-03,   3.9639208E-03
     +,   3.8031067E-03,   3.6457190E-03,   3.4918708E-03
     +,   3.3416848E-03,   3.1952716E-03,   3.0527243E-03
     +,   2.9141274E-03,   2.7795671E-03,   2.6491045E-03
     +,   2.5227903E-03,   2.4006681E-03,   2.2827676E-03
     +,   2.1690989E-03,   2.0596606E-03,   1.9544393E-03
     +,   1.8534133E-03,   1.7565407E-03,   1.6637666E-03
     +,   1.5750314E-03,   1.4902670E-03,   1.4093878E-03
     +,   1.3323011E-03,   1.2589144E-03,   1.1891210E-03
     +,   1.1228098E-03,   1.0598692E-03,   1.0001834E-03
     +,   9.4363140E-04,   8.9009030E-04,   8.3943945E-04
     +,   7.9155859E-04,   7.4632396E-04,   7.0361455E-04
     +,   6.6331401E-04,   6.2530366E-04,   5.8947201E-04
     +,   5.5570592E-04,   5.2390015E-04,   4.9394829E-04
     +,   4.6575200E-04,   4.3921251E-04,   4.1423872E-04
     +,   3.9073997E-04,   3.6863273E-04,   3.4783475E-04
     +,   3.2826833E-04,   3.0986103E-04,   2.9254192E-04
     +,   2.7624585E-04,   2.6090912E-04,   2.4647353E-04
     +,   2.3288232E-04,   2.2008363E-04,   2.0802704E-04
     +,   1.9666672E-04,   1.8595807E-04,   1.7586072E-04
     +,   1.6633548E-04,   1.5734682E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_hzonly_hatt70_mass = Yx/1.4509705
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_hzonly_hatt75_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  5.8538541E-03,   6.3200532E-03
     +,   6.8119275E-03,   7.3297461E-03,   7.8736404E-03
     +,   8.4436014E-03,   9.0394663E-03,   9.6609183E-03
     +,   1.0307458E-02,   1.0978460E-02,   1.1673106E-02
     +,   1.2390406E-02,   1.3129219E-02,   1.3888218E-02
     +,   1.4665926E-02,   1.5460691E-02,   1.6270693E-02
     +,   1.7093964E-02,   1.7928379E-02,   1.8771695E-02
     +,   1.9621568E-02,   2.0475576E-02,   2.1331280E-02
     +,   2.2186346E-02,   2.3038391E-02,   2.3885325E-02
     +,   2.4725176E-02,   2.5556237E-02,   2.6377060E-02
     +,   2.7186466E-02,   2.7983524E-02,   2.8767565E-02
     +,   2.9538110E-02,   3.0294890E-02,   3.1037791E-02
     +,   3.1766903E-02,   3.2482628E-02,   3.3185698E-02
     +,   3.3877429E-02,   3.4559734E-02,   3.5235446E-02
     +,   3.5908449E-02,   3.6583852E-02,   3.7268125E-02
     +,   3.7969310E-02,   3.8697094E-02,   3.9462965E-02
     +,   4.0280424E-02,   4.1164994E-02,   4.2134453E-02
     +,   4.3208748E-02,   4.4409797E-02,   4.5761086E-02
     +,   4.7286797E-02,   4.9010314E-02,   5.0952885E-02
     +,   5.3131092E-02,   5.5554755E-02,   5.8224559E-02
     +,   6.1130010E-02,   6.4248003E-02,   6.7542195E-02
     +,   7.0963204E-02,   7.4450217E-02,   7.7933297E-02
     +,   8.1335925E-02,   8.4579460E-02,   8.7585583E-02
     +,   9.0281025E-02,   9.2599675E-02,   9.4486430E-02
     +,   9.5898733E-02,   9.6809059E-02,   9.7206034E-02
     +,   9.7096130E-02,   9.6503504E-02,   9.5469959E-02
     +,   9.4053119E-02,   9.2324123E-02,   9.0363003E-02
     +,   8.8253886E-02,   8.6078942E-02,   8.3912782E-02
     +,   8.1816353E-02,   7.9833820E-02,   7.7989906E-02
     +,   7.6289997E-02,   7.4722059E-02,   7.3261008E-02
     +,   7.1873091E-02,   7.0522033E-02,   6.9174081E-02
     +,   6.7802541E-02,   6.6390604E-02,   6.4932764E-02
     +,   6.3435100E-02,   6.1912369E-02,   6.0386494E-02
     +,   5.8881946E-02,   5.7422865E-02,   5.6029208E-02
     +,   5.4714516E-02,   5.3483963E-02,   5.2334141E-02
     +,   5.1253270E-02,   5.0223079E-02,   4.9221013E-02
     +,   4.8222885E-02,   4.7205798E-02,   4.6150554E-02
     +,   4.5043923E-02,   4.3879841E-02,   4.2660128E-02
     +,   4.1394010E-02,   4.0097572E-02,   3.8791742E-02
     +,   3.7500888E-02,   3.6250446E-02,   3.5065226E-02
     +,   3.3967424E-02,   3.2975245E-02,   3.2102093E-02
     +,   3.1355865E-02,   3.0738924E-02,   3.0248288E-02
     +,   2.9876424E-02,   2.9611830E-02,   2.9440204E-02
     +,   2.9345231E-02,   2.9309684E-02,   2.9316250E-02
     +,   2.9348264E-02,   2.9390402E-02,   2.9429045E-02
     +,   2.9452657E-02,   2.9451948E-02,   2.9419886E-02
     +,   2.9351730E-02,   2.9244764E-02,   2.9098228E-02
     +,   2.8912982E-02,   2.8691294E-02,   2.8436489E-02
     +,   2.8152728E-02,   2.7844701E-02,   2.7517350E-02
     +,   2.7175661E-02,   2.6824467E-02,   2.6468271E-02
     +,   2.6111107E-02,   2.5756424E-02,   2.5407085E-02
     +,   2.5065288E-02,   2.4732543E-02,   2.4409750E-02
     +,   2.4097214E-02,   2.3794703E-02,   2.3501502E-02
     +,   2.3216542E-02,   2.2938460E-02,   2.2665689E-02
     +,   2.2396516E-02,   2.2129256E-02,   2.1862231E-02
     +,   2.1593895E-02,   2.1322856E-02,   2.1047983E-02
     +,   2.0768387E-02,   2.0483429E-02,   2.0192811E-02
     +,   1.9896500E-02,   1.9594727E-02,   1.9288016E-02
     +,   1.8977057E-02,   1.8662779E-02,   1.8346211E-02
     +,   1.8028496E-02,   1.7710825E-02,   1.7394422E-02
     +,   1.7080434E-02,   1.6769966E-02,   1.6464010E-02
     +,   1.6163452E-02,   1.5869007E-02,   1.5581223E-02
     +,   1.5300503E-02,   1.5027086E-02,   1.4761030E-02
     +,   1.4502227E-02,   1.4250456E-02,   1.4005361E-02
     +,   1.3766448E-02,   1.3533172E-02,   1.3304910E-02
     +,   1.3080979E-02,   1.2860649E-02,   1.2643211E-02
     +,   1.2427946E-02,   1.2214146E-02,   1.2001134E-02
     +,   1.1788283E-02,   1.1575037E-02,   1.1360867E-02
     +,   1.1145324E-02,   1.0928048E-02,   1.0708732E-02
     +,   1.0487137E-02,   1.0263121E-02,   1.0036613E-02
     +,   9.8076006E-03,   9.5761372E-03,   9.3423501E-03
     +,   9.1064367E-03,   8.8686226E-03,   8.6291935E-03
     +,   8.3884699E-03,   8.1468308E-03,   7.9046618E-03
     +,   7.6623638E-03,   7.4203881E-03,   7.1791648E-03
     +,   6.9391360E-03,   6.7007532E-03,   6.4644655E-03
     +,   6.2306914E-03,   5.9998389E-03,   5.7723136E-03
     +,   5.5484953E-03,   5.3287265E-03,   5.1133265E-03
     +,   4.9025952E-03,   4.6968060E-03,   4.4961893E-03
     +,   4.3009412E-03,   4.1112532E-03,   3.9272606E-03
     +,   3.7490742E-03,   3.5767870E-03,   3.4104604E-03
     +,   3.2501232E-03,   3.0957749E-03,   2.9474061E-03
     +,   2.8049804E-03,   2.6684338E-03,   2.5376845E-03
     +,   2.4126393E-03,   2.2931919E-03,   2.1792115E-03
     +,   2.0705580E-03,   1.9670890E-03,   1.8686448E-03
     +,   1.7750562E-03,   1.6861557E-03,   1.6017705E-03
     +,   1.5217182E-03,   1.4458154E-03,   1.3738822E-03
     +,   1.3057394E-03,   1.2412035E-03,   1.1800950E-03
     +,   1.1222402E-03,   1.0674696E-03,   1.0156140E-03
     +,   9.6651044E-04,   9.2000514E-04,   8.7594683E-04
     +,   8.3418941E-04,   7.9459714E-04,   7.5704040E-04
     +,   7.2139379E-04,   6.8753888E-04,   6.5536628E-04
     +,   6.2477344E-04,   5.9566187E-04,   5.6793995E-04
     +,   5.4152508E-04,   5.1633659E-04,   4.9230328E-04
     +,   4.6935587E-04,   4.4743350E-04,   4.2647703E-04
     +,   4.0643473E-04,   3.8725615E-04,   3.6889769E-04
     +,   3.5131650E-04,   3.3447557E-04,   3.1833915E-04
     +,   3.0287445E-04,   2.8805248E-04,   2.7384452E-04
     +,   2.6022605E-04,   2.4717237E-04,   2.3466224E-04
     +,   2.2267403E-04,   2.1118925E-04,   2.0018891E-04
     +,   1.8965652E-04,   1.7957504E-04,   1.6992961E-04
     +,   1.6070482E-04,   1.5188701E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_hzonly_hatt75_mass = Yx/1.86045243243243
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_hzonly_hatt80_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.4484882E-03,   3.5836170E-03
     +,   3.7185168E-03,   3.8528948E-03,   3.9864923E-03
     +,   4.1190959E-03,   4.2505451E-03,   4.3807453E-03
     +,   4.5096711E-03,   4.6373950E-03,   4.7640679E-03
     +,   4.8899483E-03,   5.0154035E-03,   5.1409123E-03
     +,   5.2670743E-03,   5.3946036E-03,   5.5243350E-03
     +,   5.6572165E-03,   5.7943105E-03,   5.9367851E-03
     +,   6.0859132E-03,   6.2430627E-03,   6.4096982E-03
     +,   6.5874015E-03,   6.7778290E-03,   6.9828029E-03
     +,   7.2042714E-03,   7.4443729E-03,   7.7054664E-03
     +,   7.9902066E-03,   8.3015645E-03,   8.6429119E-03
     +,   9.0180589E-03,   9.4312904E-03,   9.8873908E-03
     +,   1.0391615E-02,   1.0949635E-02,   1.1567427E-02
     +,   1.2251150E-02,   1.3006815E-02,   1.3840176E-02
     +,   1.4756300E-02,   1.5759289E-02,   1.6851975E-02
     +,   1.8035585E-02,   1.9309556E-02,   2.0671392E-02
     +,   2.2116639E-02,   2.3639033E-02,   2.5230784E-02
     +,   2.6882952E-02,   2.8586144E-02,   3.0330969E-02
     +,   3.2109145E-02,   3.3913765E-02,   3.5740472E-02
     +,   3.7587684E-02,   3.9456975E-02,   4.1352987E-02
     +,   4.3283060E-02,   4.5256261E-02,   4.7282211E-02
     +,   4.9369495E-02,   5.1524330E-02,   5.3749122E-02
     +,   5.6041438E-02,   5.8394201E-02,   6.0795460E-02
     +,   6.3230447E-02,   6.5682456E-02,   6.8135992E-02
     +,   7.0578404E-02,   7.3003471E-02,   7.5413369E-02
     +,   7.7821679E-02,   8.0254562E-02,   8.2750641E-02
     +,   8.5358299E-02,   8.8130049E-02,   9.1112837E-02
     +,   9.4336204E-02,   9.7801469E-02,   0.1014729    
     +,   0.1052775    ,   0.1091119    ,   0.1128620    
     +,   0.1164259    ,   0.1197407    ,   0.1228000    
     +,   0.1256599    ,   0.1284275    ,   0.1312329    
     +,   0.1341939    ,   0.1373816    ,   0.1407991    
     +,   0.1443771    ,   0.1479941    ,   0.1515068    
     +,   0.1547886    ,   0.1577579    ,   0.1603968    
     +,   0.1627446    ,   0.1648804    ,   0.1668909    
     +,   0.1688386    ,   0.1707331    ,   0.1725161    
     +,   0.1740631    ,   0.1751982    ,   0.1757224    
     +,   0.1754454    ,   0.1742156    ,   0.1719431    
     +,   0.1686103    ,   0.1642744    ,   0.1590564    
     +,   0.1531269    ,   0.1466821    ,   0.1399241    
     +,   0.1330376    ,   0.1261744    ,   0.1194452    
     +,   0.1129172    ,   0.1066197    ,   0.1005553    
     +,   9.4712891E-02,   8.9077890E-02,   8.3642624E-02
     +,   7.8408822E-02,   7.3389560E-02,   6.8604976E-02
     +,   6.4079612E-02,   5.9836254E-02,   5.5894051E-02
     +,   5.2265462E-02,   4.8956711E-02,   4.5968492E-02
     +,   4.3297425E-02,   4.0937051E-02,   3.8879205E-02
     +,   3.7114397E-02,   3.5631567E-02,   3.4417473E-02
     +,   3.3456326E-02,   3.2729261E-02,   3.2213982E-02
     +,   3.1884901E-02,   3.1713538E-02,   3.1669136E-02
     +,   3.1719513E-02,   3.1832092E-02,   3.1974860E-02
     +,   3.2117378E-02,   3.2231733E-02,   3.2293275E-02
     +,   3.2281250E-02,   3.2179315E-02,   3.1975865E-02
     +,   3.1664010E-02,   3.1241719E-02,   3.0711366E-02
     +,   3.0079441E-02,   2.9356029E-02,   2.8554155E-02
     +,   2.7688978E-02,   2.6777029E-02,   2.5835583E-02
     +,   2.4881750E-02,   2.3931794E-02,   2.3000594E-02
     +,   2.2101188E-02,   2.1244437E-02,   2.0438699E-02
     +,   1.9689875E-02,   1.9001473E-02,   1.8374650E-02
     +,   1.7808514E-02,   1.7300444E-02,   1.6846415E-02
     +,   1.6441278E-02,   1.6079193E-02,   1.5753927E-02
     +,   1.5459148E-02,   1.5188647E-02,   1.4936564E-02
     +,   1.4697558E-02,   1.4466880E-02,   1.4240447E-02
     +,   1.4014874E-02,   1.3787472E-02,   1.3556184E-02
     +,   1.3319584E-02,   1.3076769E-02,   1.2827337E-02
     +,   1.2571249E-02,   1.2308808E-02,   1.2040591E-02
     +,   1.1767366E-02,   1.1490034E-02,   1.1209573E-02
     +,   1.0927046E-02,   1.0643516E-02,   1.0360011E-02
     +,   1.0077529E-02,   9.7970245E-03,   9.5193693E-03
     +,   9.2453426E-03,   8.9756539E-03,   8.7109236E-03
     +,   8.4516592E-03,   8.1982762E-03,   7.9511134E-03
     +,   7.7104205E-03,   7.4763466E-03,   7.2489656E-03
     +,   7.0282859E-03,   6.8142572E-03,   6.6067497E-03
     +,   6.4055845E-03,   6.2105586E-03,   6.0214116E-03
     +,   5.8378614E-03,   5.6596091E-03,   5.4863491E-03
     +,   5.3177513E-03,   5.1534944E-03,   4.9932688E-03
     +,   4.8367777E-03,   4.6837302E-03,   4.5338576E-03
     +,   4.3869209E-03,   4.2427098E-03,   4.1010310E-03
     +,   3.9617205E-03,   3.8246550E-03,   3.6897305E-03
     +,   3.5568660E-03,   3.4260219E-03,   3.2971797E-03
     +,   3.1703357E-03,   3.0455098E-03,   2.9227477E-03
     +,   2.8021093E-03,   2.6836626E-03,   2.5674845E-03
     +,   2.4536676E-03,   2.3423103E-03,   2.2335066E-03
     +,   2.1273496E-03,   2.0239423E-03,   1.9233738E-03
     +,   1.8257271E-03,   1.7310847E-03,   1.6395206E-03
     +,   1.5510933E-03,   1.4658505E-03,   1.3838352E-03
     +,   1.3050784E-03,   1.2295933E-03,   1.1573824E-03
     +,   1.0884411E-03,   1.0227525E-03,   9.6028502E-04
     +,   9.0099609E-04,   8.4483944E-04,   7.9175323E-04
     +,   7.4166805E-04,   6.9450977E-04,   6.5019715E-04
     +,   6.0864002E-04,   5.6974340E-04,   5.3341087E-04
     +,   4.9954193E-04,   4.6803145E-04,   4.3877269E-04
     +,   4.1166093E-04,   3.8658711E-04,   3.6344607E-04
     +,   3.4213037E-04,   3.2253686E-04,   3.0456154E-04
     +,   2.8810540E-04,   2.7306977E-04,   2.5936111E-04
     +,   2.4688727E-04,   2.3556133E-04,   2.2529866E-04
     +,   2.1601886E-04,   2.0764605E-04,   2.0010713E-04
     +,   1.9333405E-04,   1.8726173E-04,   1.8182966E-04
     +,   1.7698045E-04,   1.7266115E-04,   1.6882163E-04
     +,   1.6541588E-04,   1.6240076E-04,   1.5973659E-04
     +,   1.5738654E-04,   1.5531687E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_hzonly_hatt80_mass = Yx/2.62186995
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_hzonly_hatt85_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.8016685E-03,   3.9746929E-03
     +,   4.1462989E-03,   4.3155840E-03,   4.4816285E-03
     +,   4.6435110E-03,   4.8003118E-03,   4.9511348E-03
     +,   5.0951070E-03,   5.2314093E-03,   5.3592646E-03
     +,   5.4779695E-03,   5.5868966E-03,   5.6855055E-03
     +,   5.7733576E-03,   5.8501195E-03,   5.9155761E-03
     +,   5.9696310E-03,   6.0123191E-03,   6.0438043E-03
     +,   6.0643861E-03,   6.0744942E-03,   6.0746931E-03
     +,   6.0656820E-03,   6.0482766E-03,   6.0234223E-03
     +,   5.9921728E-03,   5.9556887E-03,   5.9152264E-03
     +,   5.8721225E-03,   5.8277906E-03,   5.7837046E-03
     +,   5.7413848E-03,   5.7023834E-03,   5.6682774E-03
     +,   5.6406460E-03,   5.6210645E-03,   5.6110891E-03
     +,   5.6122416E-03,   5.6259977E-03,   5.6537795E-03
     +,   5.6969430E-03,   5.7567665E-03,   5.8344426E-03
     +,   5.9310701E-03,   6.0476470E-03,   6.1850622E-03
     +,   6.3440916E-03,   6.5253833E-03,   6.7294678E-03
     +,   6.9567328E-03,   7.2074351E-03,   7.4816789E-03
     +,   7.7794464E-03,   8.1005376E-03,   8.4446371E-03
     +,   8.8112671E-03,   9.1998195E-03,   9.6095512E-03
     +,   1.0039611E-02,   1.0489041E-02,   1.0956819E-02
     +,   1.1441833E-02,   1.1942978E-02,   1.2459170E-02
     +,   1.2989300E-02,   1.3532422E-02,   1.4087662E-02
     +,   1.4654413E-02,   1.5232323E-02,   1.5821522E-02
     +,   1.6422678E-02,   1.7037310E-02,   1.7667938E-02
     +,   1.8318484E-02,   1.8994560E-02,   1.9703772E-02
     +,   2.0456055E-02,   2.1263927E-02,   2.2142563E-02
     +,   2.3109527E-02,   2.4184531E-02,   2.5388433E-02
     +,   2.6742309E-02,   2.8265631E-02,   2.9974787E-02
     +,   3.1880815E-02,   3.3988081E-02,   3.6292970E-02
     +,   3.8784664E-02,   4.1447468E-02,   4.4265483E-02
     +,   4.7230598E-02,   5.0352193E-02,   5.3667381E-02
     +,   5.7248175E-02,   6.1204646E-02,   6.5676890E-02
     +,   7.0818603E-02,   7.6768130E-02,   8.3617315E-02
     +,   9.1380060E-02,   9.9976696E-02,   0.1092345    
     +,   0.1189127    ,   0.1287388    ,   0.1384446    
     +,   0.1477906    ,   0.1565685    ,   0.1645919    
     +,   0.1716913    ,   0.1777353    ,   0.1826771    
     +,   0.1866149    ,   0.1898279    ,   0.1927688    
     +,   0.1960039    ,   0.2001217    ,   0.2056378    
     +,   0.2129082    ,   0.2220451    ,   0.2328489    
     +,   0.2447970    ,   0.2571498    ,   0.2691816    
     +,   0.2804352    ,   0.2908576    ,   0.3006818    
     +,   0.3101100    ,   0.3189770    ,   0.3266042    
     +,   0.3319465    ,   0.3339620    ,   0.3320279    
     +,   0.3262185    ,   0.3173044    ,   0.3064659    
     +,   0.2948457    ,   0.2831494    ,   0.2714960    
     +,   0.2595544    ,   0.2468527    ,   0.2330701    
     +,   0.2181802    ,   0.2024298    ,   0.1862283    
     +,   0.1700426    ,   0.1543390    ,   0.1395568    
     +,   0.1260840    ,   0.1142164    ,   0.1041062    
     +,   9.5726840E-02,   8.8878408E-02,   8.3236434E-02
     +,   7.8428812E-02,   7.4112028E-02,   7.0026904E-02
     +,   6.6022299E-02,   6.2048718E-02,   5.8131017E-02
     +,   5.4334648E-02,   5.0734591E-02,   4.7393009E-02
     +,   4.4347454E-02,   4.1608777E-02,   3.9165605E-02
     +,   3.6991257E-02,   3.5051443E-02,   3.3311032E-02
     +,   3.1738602E-02,   3.0308601E-02,   2.9001888E-02
     +,   2.7805055E-02,   2.6709218E-02,   2.5708251E-02
     +,   2.4797497E-02,   2.3972748E-02,   2.3229506E-02
     +,   2.2562554E-02,   2.1965943E-02,   2.1433173E-02
     +,   2.0957291E-02,   2.0531159E-02,   2.0147687E-02
     +,   1.9800054E-02,   1.9481843E-02,   1.9187076E-02
     +,   1.8910307E-02,   1.8646654E-02,   1.8391734E-02
     +,   1.8141648E-02,   1.7892975E-02,   1.7642710E-02
     +,   1.7388225E-02,   1.7127201E-02,   1.6857682E-02
     +,   1.6578000E-02,   1.6286748E-02,   1.5982790E-02
     +,   1.5665282E-02,   1.5333653E-02,   1.4987567E-02
     +,   1.4626960E-02,   1.4252083E-02,   1.3863398E-02
     +,   1.3461638E-02,   1.3047799E-02,   1.2623103E-02
     +,   1.2188974E-02,   1.1746990E-02,   1.1298923E-02
     +,   1.0846673E-02,   1.0392171E-02,   9.9374093E-03
     +,   9.4844075E-03,   9.0351589E-03,   8.5915597E-03
     +,   8.1554092E-03,   7.7284272E-03,   7.3121381E-03
     +,   6.9079013E-03,   6.5169251E-03,   6.1402246E-03
     +,   5.7785995E-03,   5.4326574E-03,   5.1028468E-03
     +,   4.7894367E-03,   4.4925134E-03,   4.2120116E-03
     +,   3.9477516E-03,   3.6994363E-03,   3.4666497E-03
     +,   3.2488937E-03,   3.0456241E-03,   2.8562234E-03
     +,   2.6800379E-03,   2.5163973E-03,   2.3646185E-03
     +,   2.2240027E-03,   2.0938541E-03,   1.9734984E-03
     +,   1.8622755E-03,   1.7595368E-03,   1.6646605E-03
     +,   1.5770568E-03,   1.4961628E-03,   1.4214406E-03
     +,   1.3523815E-03,   1.2885160E-03,   1.2293946E-03
     +,   1.1746013E-03,   1.1237503E-03,   1.0764846E-03
     +,   1.0324711E-03,   9.9140336E-04,   9.5300173E-04
     +,   9.1701123E-04,   8.8319671E-04,   8.5134461E-04
     +,   8.2126353E-04,   7.9278124E-04,   7.6574029E-04
     +,   7.4000063E-04,   7.1543903E-04,   6.9194456E-04
     +,   6.6941837E-04,   6.4777519E-04,   6.2693964E-04
     +,   6.0684513E-04,   5.8743323E-04,   5.6865474E-04
     +,   5.5046671E-04,   5.3283124E-04,   5.1571586E-04
     +,   4.9909373E-04,   4.8294023E-04,   4.6723601E-04
     +,   4.5196299E-04,   4.3710662E-04,   4.2265304E-04
     +,   4.0859191E-04,   3.9491229E-04,   3.8160614E-04
     +,   3.6866448E-04,   3.5608080E-04,   3.4384770E-04
     +,   3.3195826E-04,   3.2040704E-04,   3.0918716E-04
     +,   2.9829328E-04,   2.8771872E-04,   2.7745814E-04
     +,   2.6750501E-04,   2.5785371E-04,   2.4849767E-04
     +,   2.3943115E-04,   2.3064742E-04,   2.2214081E-04
     +,   2.1390425E-04,   2.0593208E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_hzonly_hatt85_mass = Yx/3.46158929268293
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_hzonly_hatt90_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.6504872E-03,   2.7518214E-03
     +,   2.8533810E-03,   2.9550609E-03,   3.0567758E-03
     +,   3.1584615E-03,   3.2600807E-03,   3.3616181E-03
     +,   3.4630846E-03,   3.5645233E-03,   3.6659993E-03
     +,   3.7676066E-03,   3.8694642E-03,   3.9717169E-03
     +,   4.0745307E-03,   4.1780914E-03,   4.2826035E-03
     +,   4.3882793E-03,   4.4953437E-03,   4.6040216E-03
     +,   4.7145374E-03,   4.8271050E-03,   4.9419240E-03
     +,   5.0591798E-03,   5.1790159E-03,   5.3015570E-03
     +,   5.4268776E-03,   5.5550081E-03,   5.6859278E-03
     +,   5.8195558E-03,   5.9557501E-03,   6.0943025E-03
     +,   6.2349355E-03,   6.3772984E-03,   6.5209740E-03
     +,   6.6654701E-03,   6.8102265E-03,   6.9546141E-03
     +,   7.0979521E-03,   7.2394907E-03,   7.3784450E-03
     +,   7.5139813E-03,   7.6452433E-03,   7.7713509E-03
     +,   7.8914212E-03,   8.0045694E-03,   8.1099365E-03
     +,   8.2066907E-03,   8.2940450E-03,   8.3712703E-03
     +,   8.4377024E-03,   8.4927650E-03,   8.5359709E-03
     +,   8.5669393E-03,   8.5853925E-03,   8.5911779E-03
     +,   8.5842637E-03,   8.5647507E-03,   8.5328631E-03
     +,   8.4889643E-03,   8.4335413E-03,   8.3672125E-03
     +,   8.2907248E-03,   8.2049370E-03,   8.1108194E-03
     +,   8.0094561E-03,   7.9020206E-03,   7.7897757E-03
     +,   7.6740594E-03,   7.5562848E-03,   7.4379086E-03
     +,   7.3204534E-03,   7.2054686E-03,   7.0945420E-03
     +,   6.9892826E-03,   6.8913111E-03,   6.8022795E-03
     +,   6.7238440E-03,   6.6576786E-03,   6.6054789E-03
     +,   6.5689720E-03,   6.5499218E-03,   6.5501551E-03
     +,   6.5715727E-03,   6.6161766E-03,   6.6860919E-03
     +,   6.7835855E-03,   6.9111106E-03,   7.0712934E-03
     +,   7.2669773E-03,   7.5012255E-03,   7.7772760E-03
     +,   8.0985473E-03,   8.4685935E-03,   8.8910386E-03
     +,   9.3694218E-03,   9.9071907E-03,   1.0507402E-02
     +,   1.1172740E-02,   1.1905108E-02,   1.2705664E-02
     +,   1.3574392E-02,   1.4510107E-02,   1.5510048E-02
     +,   1.6569950E-02,   1.7683795E-02,   1.8843723E-02
     +,   2.0040032E-02,   2.1261409E-02,   2.2494990E-02
     +,   2.3726597E-02,   2.4941539E-02,   2.6124893E-02
     +,   2.7262852E-02,   2.8343543E-02,   2.9358758E-02
     +,   3.0305423E-02,   3.1187683E-02,   3.2018576E-02
     +,   3.2822274E-02,   3.3635631E-02,   3.4509555E-02
     +,   3.5509739E-02,   3.6716636E-02,   3.8224105E-02
     +,   4.0136471E-02,   4.2565014E-02,   4.5622300E-02
     +,   4.9418576E-02,   5.4057937E-02,   5.9639402E-02
     +,   6.6257738E-02,   7.4006021E-02,   8.2968518E-02
     +,   9.3205750E-02,   0.1047251    ,   0.1174442    
     +,   0.1311637    ,   0.1455552    ,   0.1601769    
     +,   0.1745141    ,   0.1880556    ,   0.2004066    
     +,   0.2114415    ,   0.2214710    ,   0.2313571    
     +,   0.2424629    ,   0.2563642    ,   0.2743471    
     +,   0.2968616    ,   0.3231625    ,   0.3513493    
     +,   0.3788914    ,   0.4035881    ,   0.4246263    
     +,   0.4430976    ,   0.4612786    ,   0.4806967    
     +,   0.5002065    ,   0.5157476    ,   0.5223535    
     +,   0.5170283    ,   0.5003790    ,   0.4759254    
     +,   0.4479377    ,   0.4195320    ,   0.3921205    
     +,   0.3660010    ,   0.3411601    ,   0.3176354    
     +,   0.2954534    ,   0.2745308    ,   0.2547615    
     +,   0.2361977    ,   0.2191049    ,   0.2038081    
     +,   0.1904487    ,   0.1788315    ,   0.1684632    
     +,   0.1587498    ,   0.1492289    ,   0.1397067    
     +,   0.1302611    ,   0.1211365    ,   0.1126101    
     +,   0.1048842    ,   9.8034292E-02,   9.2011258E-02
     +,   8.6676992E-02,   8.1852883E-02,   7.7362463E-02
     +,   7.3064126E-02,   6.8868369E-02,   6.4739317E-02
     +,   6.0685374E-02,   5.6743484E-02,   5.2961741E-02
     +,   4.9383860E-02,   4.6039272E-02,   4.2938862E-02
     +,   4.0076137E-02,   3.7430990E-02,   3.4975283E-02
     +,   3.2678448E-02,   3.0512214E-02,   2.8453102E-02
     +,   2.6483910E-02,   2.4593931E-02,   2.2777995E-02
     +,   2.1035034E-02,   1.9366816E-02,   1.7776746E-02
     +,   1.6268687E-02,   1.4846072E-02,   1.3511548E-02
     +,   1.2266772E-02,   1.1112204E-02,   1.0047072E-02
     +,   9.0695471E-03,   8.1769647E-03,   7.3657818E-03
     +,   6.6318391E-03,   5.9705544E-03,   5.3770156E-03
     +,   4.8460760E-03,   4.3725292E-03,   3.9512450E-03
     +,   3.5772156E-03,   3.2456147E-03,   2.9518877E-03
     +,   2.6918047E-03,   2.4614646E-03,   2.2572954E-03
     +,   2.0760747E-03,   1.9149343E-03,   1.7713122E-03
     +,   1.6429512E-03,   1.5278836E-03,   1.4243942E-03
     +,   1.3309908E-03,   1.2463864E-03,   1.1694803E-03
     +,   1.0993280E-03,   1.0351171E-03,   9.7615289E-04
     +,   9.2184672E-04,   8.7169383E-04,   8.2525896E-04
     +,   7.8216888E-04,   7.4210536E-04,   7.0479029E-04
     +,   6.6998118E-04,   6.3746865E-04,   6.0706883E-04
     +,   5.7861762E-04,   5.5196899E-04,   5.2699447E-04
     +,   5.0357846E-04,   4.8161543E-04,   4.6100924E-04
     +,   4.4167443E-04,   4.2353178E-04,   4.0650801E-04
     +,   3.9053510E-04,   3.7555178E-04,   3.6149938E-04
     +,   3.4832332E-04,   3.3597328E-04,   3.2440174E-04
     +,   3.1356345E-04,   3.0341547E-04,   2.9391792E-04
     +,   2.8503296E-04,   2.7672376E-04,   2.6895566E-04
     +,   2.6169623E-04,   2.5491364E-04,   2.4857846E-04
     +,   2.4266182E-04,   2.3713698E-04,   2.3197768E-04
     +,   2.2715978E-04,   2.2265945E-04,   2.1845482E-04
     +,   2.1452447E-04,   2.1084862E-04,   2.0740813E-04
     +,   2.0418494E-04,   2.0116220E-04,   1.9832366E-04
     +,   1.9565425E-04,   1.9313958E-04,   1.9076619E-04
     +,   1.8852130E-04,   1.8639299E-04,   1.8436996E-04
     +,   1.8244176E-04,   1.8059835E-04,   1.7883058E-04
     +,   1.7712968E-04,   1.7548754E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_hzonly_hatt90_mass = Yx/4.18105506976744
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_hzonly_hatt95_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  7.2132424E-03,   7.5680609E-03
     +,   7.9280306E-03,   8.2922038E-03,   8.6595742E-03
     +,   9.0290904E-03,   9.3996441E-03,   9.7701009E-03
     +,   1.0139283E-02,   1.0506014E-02,   1.0869100E-02
     +,   1.1227343E-02,   1.1579575E-02,   1.1924637E-02
     +,   1.2261431E-02,   1.2588884E-02,   1.2906002E-02
     +,   1.3211876E-02,   1.3505633E-02,   1.3786539E-02
     +,   1.4053946E-02,   1.4307303E-02,   1.4546171E-02
     +,   1.4770254E-02,   1.4979335E-02,   1.5173358E-02
     +,   1.5352355E-02,   1.5516502E-02,   1.5666060E-02
     +,   1.5801422E-02,   1.5923060E-02,   1.6031561E-02
     +,   1.6127579E-02,   1.6211828E-02,   1.6285110E-02
     +,   1.6348254E-02,   1.6402118E-02,   1.6447591E-02
     +,   1.6485566E-02,   1.6516913E-02,   1.6542505E-02
     +,   1.6563172E-02,   1.6579695E-02,   1.6592816E-02
     +,   1.6603194E-02,   1.6611459E-02,   1.6618114E-02
     +,   1.6623620E-02,   1.6628351E-02,   1.6632590E-02
     +,   1.6636565E-02,   1.6640395E-02,   1.6644159E-02
     +,   1.6647846E-02,   1.6651407E-02,   1.6654737E-02
     +,   1.6657688E-02,   1.6660091E-02,   1.6661743E-02
     +,   1.6662445E-02,   1.6661989E-02,   1.6660182E-02
     +,   1.6656840E-02,   1.6651813E-02,   1.6644977E-02
     +,   1.6636252E-02,   1.6625585E-02,   1.6612967E-02
     +,   1.6598433E-02,   1.6582051E-02,   1.6563928E-02
     +,   1.6544206E-02,   1.6523041E-02,   1.6500615E-02
     +,   1.6477104E-02,   1.6452711E-02,   1.6427608E-02
     +,   1.6401958E-02,   1.6375888E-02,   1.6349502E-02
     +,   1.6322860E-02,   1.6295968E-02,   1.6268775E-02
     +,   1.6241176E-02,   1.6213020E-02,   1.6184071E-02
     +,   1.6154060E-02,   1.6122635E-02,   1.6089432E-02
     +,   1.6054014E-02,   1.6015932E-02,   1.5974697E-02
     +,   1.5929833E-02,   1.5880840E-02,   1.5827255E-02
     +,   1.5768632E-02,   1.5704559E-02,   1.5634719E-02
     +,   1.5558802E-02,   1.5476640E-02,   1.5388126E-02
     +,   1.5293276E-02,   1.5192186E-02,   1.5085120E-02
     +,   1.4972445E-02,   1.4854649E-02,   1.4732389E-02
     +,   1.4606446E-02,   1.4477731E-02,   1.4347296E-02
     +,   1.4216342E-02,   1.4086195E-02,   1.3958306E-02
     +,   1.3834255E-02,   1.3715741E-02,   1.3604575E-02
     +,   1.3502677E-02,   1.3412048E-02,   1.3334811E-02
     +,   1.3273163E-02,   1.3229383E-02,   1.3205824E-02
     +,   1.3204916E-02,   1.3229155E-02,   1.3281085E-02
     +,   1.3363320E-02,   1.3478508E-02,   1.3629328E-02
     +,   1.3818501E-02,   1.4048744E-02,   1.4322782E-02
     +,   1.4643296E-02,   1.5012952E-02,   1.5434274E-02
     +,   1.5909735E-02,   1.6441660E-02,   1.7032130E-02
     +,   1.7683024E-02,   1.8395953E-02,   1.9172225E-02
     +,   2.0012751E-02,   2.0918032E-02,   2.1888196E-02
     +,   2.2922929E-02,   2.4021350E-02,   2.5182232E-02
     +,   2.6403917E-02,   2.7684363E-02,   2.9021233E-02
     +,   3.0412300E-02,   3.1855501E-02,   3.3349369E-02
     +,   3.4893509E-02,   3.6489341E-02,   3.8140707E-02
     +,   3.9854579E-02,   4.1641675E-02,   4.3517508E-02
     +,   4.5502357E-02,   4.7621071E-02,   4.9902994E-02
     +,   5.2380230E-02,   5.5085633E-02,   5.8050245E-02
     +,   6.1300032E-02,   6.4852774E-02,   6.8714626E-02
     +,   7.2879151E-02,   7.7327996E-02,   8.2034670E-02
     +,   8.6970307E-02,   9.2113599E-02,   9.7461194E-02
     +,   0.1030360    ,   0.1088903    ,   0.1151036    
     +,   0.1217709    ,   0.1289839    ,   0.1368114    
     +,   0.1452832    ,   0.1543821    ,   0.1640495    
     +,   0.1742032    ,   0.1847655    ,   0.1956949    
     +,   0.2070254    ,   0.2189148    ,   0.2317068    
     +,   0.2459922    ,   0.2626473    ,   0.2828070    
     +,   0.3077147    ,   0.3384301    ,   0.3754380    
     +,   0.4182588    ,   0.4652200    ,   0.5135199    
     +,   0.5596304    ,   0.5999367    ,   0.6313946    
     +,   0.6520002    ,   0.6609548    ,   0.6585078    
     +,   0.6456295    ,   0.6236537    ,   0.5940070    
     +,   0.5580838    ,   0.5172327    ,   0.4727969    
     +,   0.4261524    ,   0.3787083    ,   0.3318581    
     +,   0.2868918    ,   0.2449007    ,   0.2067059    
     +,   0.1728148    ,   0.1434106    ,   0.1183818    
     +,   9.7389251E-02,   7.9952061E-02,   6.5531783E-02
     +,   5.3607840E-02,   4.3725699E-02,   3.5515890E-02
     +,   2.8691467E-02,   2.3033313E-02,   1.8370835E-02
     +,   1.4563981E-02,   1.1490724E-02,   9.0406258E-03
     +,   7.1123457E-03,   5.6134323E-03,   4.4612857E-03
     +,   3.5842133E-03,   2.9217773E-03,   2.4242091E-03
     +,   2.0515365E-03,   1.7722744E-03,   1.5619765E-03
     +,   1.4018889E-03,   1.2778008E-03,   1.1790679E-03
     +,   1.0978172E-03,   1.0283202E-03,   9.6650783E-04
     +,   9.0958073E-04,   8.5569307E-04,   8.0370012E-04
     +,   7.5296586E-04,   7.0321263E-04,   6.5439369E-04
     +,   6.0660887E-04,   5.6004291E-04,   5.1491614E-04
     +,   4.7144902E-04,   4.2984550E-04,   3.9028237E-04
     +,   3.5289975E-04,   3.1779576E-04,   2.8502964E-04
     +,   2.5462609E-04,   2.2657558E-04,   2.0083704E-04
     +,   1.7734444E-04,   1.5601324E-04,   1.3674029E-04
     +,   1.1941031E-04,   1.0390088E-04,   9.0084264E-05
     +,   7.7829682E-05,   6.7007059E-05,   5.7489600E-05
     +,   4.9154616E-05,   4.1884345E-05,   3.5567671E-05
     +,   3.0101224E-05,   2.5388415E-05,   2.1340999E-05
     +,   1.7877845E-05,   1.4925833E-05,   1.2418665E-05
     +,   1.0297303E-05,   8.5088532E-06,   7.0067154E-06
     +,   5.7496186E-06,   4.7015365E-06,   3.8309204E-06
     +,   3.1103914E-06,   2.5163388E-06,   2.0283746E-06
     +,   1.6290935E-06,   1.3036024E-06,   1.0392986E-06
     +,   8.2549303E-07,   6.5322172E-07,   5.1494874E-07
     +,   4.0440892E-07,   3.1638365E-07,   2.4657109E-07
     +,   1.9142074E-07,   1.4803140E-07
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_hzonly_hatt95_mass = Yx/4.52476793023256
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_hzonly_htt100_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.5101831E-03,   1.5723796E-03
     +,   1.6365811E-03,   1.7027963E-03,   1.7710278E-03
     +,   1.8412749E-03,   1.9135309E-03,   1.9877835E-03
     +,   2.0640136E-03,   2.1422009E-03,   2.2223145E-03
     +,   2.3043179E-03,   2.3881684E-03,   2.4738177E-03
     +,   2.5612086E-03,   2.6502770E-03,   2.7409527E-03
     +,   2.8331550E-03,   2.9267981E-03,   3.0217869E-03
     +,   3.1180168E-03,   3.2153779E-03,   3.3137449E-03
     +,   3.4129948E-03,   3.5129823E-03,   3.6135663E-03
     +,   3.7145885E-03,   3.8158842E-03,   3.9172787E-03
     +,   4.0185917E-03,   4.1196346E-03,   4.2202072E-03
     +,   4.3201074E-03,   4.4191242E-03,   4.5170388E-03
     +,   4.6136328E-03,   4.7086799E-03,   4.8019472E-03
     +,   4.8932144E-03,   4.9822428E-03,   5.0688079E-03
     +,   5.1526814E-03,   5.2336426E-03,   5.3114756E-03
     +,   5.3859726E-03,   5.4569356E-03,   5.5241785E-03
     +,   5.5875280E-03,   5.6468262E-03,   5.7019335E-03
     +,   5.7527334E-03,   5.7991212E-03,   5.8410242E-03
     +,   5.8783884E-03,   5.9111859E-03,   5.9394203E-03
     +,   5.9631173E-03,   5.9823389E-03,   5.9971688E-03
     +,   6.0077258E-03,   6.0141622E-03,   6.0166512E-03
     +,   6.0154065E-03,   6.0106670E-03,   6.0027014E-03
     +,   5.9918114E-03,   5.9783235E-03,   5.9625925E-03
     +,   5.9450031E-03,   5.9259604E-03,   5.9059006E-03
     +,   5.8852797E-03,   5.8645792E-03,   5.8443048E-03
     +,   5.8249789E-03,   5.8071548E-03,   5.7914015E-03
     +,   5.7783085E-03,   5.7684942E-03,   5.7625873E-03
     +,   5.7612448E-03,   5.7651424E-03,   5.7749748E-03
     +,   5.7914527E-03,   5.8153057E-03,   5.8472776E-03
     +,   5.8881184E-03,   5.9385868E-03,   5.9994371E-03
     +,   6.0714162E-03,   6.1552641E-03,   6.2516825E-03
     +,   6.3613332E-03,   6.4848419E-03,   6.6227634E-03
     +,   6.7755645E-03,   6.9436412E-03,   7.1272529E-03
     +,   7.3265680E-03,   7.5415839E-03,   7.7721863E-03
     +,   8.0180643E-03,   8.2787853E-03,   8.5537070E-03
     +,   8.8420548E-03,   9.1428915E-03,   9.4551202E-03
     +,   9.7775087E-03,   1.0108743E-02,   1.0447430E-02
     +,   1.0792117E-02,   1.1141385E-02,   1.1493815E-02
     +,   1.1848141E-02,   1.2203193E-02,   1.2558069E-02
     +,   1.2912065E-02,   1.3264860E-02,   1.3616486E-02
     +,   1.3967442E-02,   1.4318741E-02,   1.4671943E-02
     +,   1.5029226E-02,   1.5393493E-02,   1.5768331E-02
     +,   1.6158111E-02,   1.6568031E-02,   1.7004052E-02
     +,   1.7473051E-02,   1.7982600E-02,   1.8541116E-02
     +,   1.9157561E-02,   1.9841472E-02,   2.0602541E-02
     +,   2.1450518E-02,   2.2394724E-02,   2.3443544E-02
     +,   2.4603873E-02,   2.5880620E-02,   2.7275909E-02
     +,   2.8788259E-02,   3.0412078E-02,   3.2137033E-02
     +,   3.3947755E-02,   3.5823297E-02,   3.7737764E-02
     +,   3.9660688E-02,   4.1557681E-02,   4.3392081E-02
     +,   4.5126688E-02,   4.6725571E-02,   4.8156150E-02
     +,   4.9391259E-02,   5.0411485E-02,   5.1206522E-02
     +,   5.1776428E-02,   5.2132677E-02,   5.2298222E-02
     +,   5.2307446E-02,   5.2205425E-02,   5.2046955E-02
     +,   5.1895194E-02,   5.1820297E-02,   5.1897660E-02
     +,   5.2206106E-02,   5.2825999E-02,   5.3836934E-02
     +,   5.5314790E-02,   5.7328470E-02,   5.9935275E-02
     +,   6.3175231E-02,   6.7065492E-02,   7.1595609E-02
     +,   7.6726384E-02,   8.2393855E-02,   8.8524483E-02
     +,   9.5057204E-02,   0.1019723    ,   0.1093169    
     +,   0.1172177    ,   0.1258643    ,   0.1354624    
     +,   0.1461613    ,   0.1579774    ,   0.1707440    
     +,   0.1841191    ,   0.1976822    ,   0.2111186    
     +,   0.2244554    ,   0.2382628    ,   0.2536903    
     +,   0.2722069    ,   0.2950457    ,   0.3225657    
     +,   0.3538992    ,   0.3871443    ,   0.4199812    
     +,   0.4503385    ,   0.4768670    ,   0.4993815    
     +,   0.5193416    ,   0.5398527    ,   0.5645099    
     +,   0.5953464    ,   0.6313313    ,   0.6687771    
     +,   0.7035904    ,   0.7336546    ,   0.7592775    
     +,   0.7809209    ,   0.7959414    ,   0.7976261    
     +,   0.7782276    ,   0.7339842    ,   0.6679993    
     +,   0.5887560    ,   0.5058699    ,   0.4265440    
     +,   0.3545804    ,   0.2913033    ,   0.2368178    
     +,   0.1907821    ,   0.1526690    ,   0.1217986    
     +,   9.7337976E-02,   7.8335844E-02,   6.3791804E-02
     +,   5.2738845E-02,   4.4315983E-02,   3.7814308E-02
     +,   3.2689594E-02,   2.8549008E-02,   2.5123073E-02
     +,   2.2232933E-02,   1.9760044E-02,   1.7622350E-02
     +,   1.5759496E-02,   1.4124680E-02,   1.2680491E-02
     +,   1.1397010E-02,   1.0250729E-02,   9.2234639E-03
     +,   8.3010485E-03,   7.4721505E-03,   6.7273746E-03
     +,   6.0586450E-03,   5.4587005E-03,   4.9208580E-03
     +,   4.4389488E-03,   4.0073353E-03,   3.6208024E-03
     +,   3.2746107E-03,   2.9644978E-03,   2.6866319E-03
     +,   2.4375687E-03,   2.2142390E-03,   2.0139269E-03
     +,   1.8342170E-03,   1.6729517E-03,   1.5282142E-03
     +,   1.3983075E-03,   1.2817183E-03,   1.1770847E-03
     +,   1.0831885E-03,   9.9894276E-04,   9.2335901E-04
     +,   8.5554586E-04,   7.9470046E-04,   7.4009428E-04
     +,   6.9106359E-04,   6.4700696E-04,   6.0738280E-04
     +,   5.7170069E-04,   5.3951604E-04,   5.1042915E-04
     +,   4.8408422E-04,   4.6015973E-04,   4.3837266E-04
     +,   4.1846849E-04,   4.0022543E-04,   3.8344527E-04
     +,   3.6795612E-04,   3.5360557E-04,   3.4026240E-04
     +,   3.2781038E-04,   3.1615028E-04,   3.0519470E-04
     +,   2.9486764E-04,   2.8510430E-04,   2.7584736E-04
     +,   2.6704787E-04,   2.5866245E-04,   2.5065435E-04
     +,   2.4299035E-04,   2.3564266E-04,   2.2858578E-04
     +,   2.2179833E-04,   2.1526066E-04,   2.0895625E-04
     +,   2.0286968E-04,   1.9698805E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_hzonly_htt100_mass = Yx/5.30999986363636
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_hzonly_htt105_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.7838803E-03,   1.8299690E-03
     +,   1.8769676E-03,   1.9249214E-03,   1.9738777E-03
     +,   2.0238878E-03,   2.0750042E-03,   2.1272802E-03
     +,   2.1807721E-03,   2.2355376E-03,   2.2916321E-03
     +,   2.3491136E-03,   2.4080367E-03,   2.4684560E-03
     +,   2.5304239E-03,   2.5939883E-03,   2.6591949E-03
     +,   2.7260822E-03,   2.7946841E-03,   2.8650269E-03
     +,   2.9371290E-03,   3.0109996E-03,   3.0866375E-03
     +,   3.1640334E-03,   3.2431586E-03,   3.3239785E-03
     +,   3.4064422E-03,   3.4904829E-03,   3.5760175E-03
     +,   3.6629504E-03,   3.7511648E-03,   3.8405324E-03
     +,   3.9309021E-03,   4.0221093E-03,   4.1139750E-03
     +,   4.2062989E-03,   4.2988714E-03,   4.3914630E-03
     +,   4.4838381E-03,   4.5757433E-03,   4.6669240E-03
     +,   4.7571128E-03,   4.8460416E-03,   4.9334373E-03
     +,   5.0190361E-03,   5.1025725E-03,   5.1837959E-03
     +,   5.2624661E-03,   5.3383582E-03,   5.4112747E-03
     +,   5.4810382E-03,   5.5475095E-03,   5.6105754E-03
     +,   5.6701712E-03,   5.7262685E-03,   5.7788892E-03
     +,   5.8281128E-03,   5.8740624E-03,   5.9169289E-03
     +,   5.9569608E-03,   5.9944689E-03,   6.0298280E-03
     +,   6.0634748E-03,   6.0959137E-03,   6.1277095E-03
     +,   6.1594853E-03,   6.1919275E-03,   6.2257713E-03
     +,   6.2618000E-03,   6.3008452E-03,   6.3437638E-03
     +,   6.3914545E-03,   6.4448267E-03,   6.5048044E-03
     +,   6.5723127E-03,   6.6482769E-03,   6.7335982E-03
     +,   6.8291486E-03,   6.9357790E-03,   7.0542879E-03
     +,   7.1854168E-03,   7.3298635E-03,   7.4882419E-03
     +,   7.6611210E-03,   7.8489669E-03,   8.0522057E-03
     +,   8.2711540E-03,   8.5060941E-03,   8.7571964E-03
     +,   9.0246005E-03,   9.3083866E-03,   9.6085640E-03
     +,   9.9251047E-03,   1.0257960E-02,   1.0607061E-02
     +,   1.0972282E-02,   1.1353533E-02,   1.1750670E-02
     +,   1.2163576E-02,   1.2592084E-02,   1.3036044E-02
     +,   1.3495219E-02,   1.3969376E-02,   1.4458138E-02
     +,   1.4961089E-02,   1.5477679E-02,   1.6007157E-02
     +,   1.6548615E-02,   1.7100956E-02,   1.7662909E-02
     +,   1.8232875E-02,   1.8809222E-02,   1.9390021E-02
     +,   1.9973356E-02,   2.0557230E-02,   2.1139801E-02
     +,   2.1719404E-02,   2.2294827E-02,   2.2865415E-02
     +,   2.3431309E-02,   2.3993652E-02,   2.4554776E-02
     +,   2.5118396E-02,   2.5689904E-02,   2.6276384E-02
     +,   2.6886741E-02,   2.7531816E-02,   2.8224198E-02
     +,   2.8978195E-02,   2.9809451E-02,   3.0734640E-02
     +,   3.1770725E-02,   3.2934461E-02,   3.4241252E-02
     +,   3.5704356E-02,   3.7333578E-02,   3.9134074E-02
     +,   4.1105151E-02,   4.3239295E-02,   4.5521162E-02
     +,   4.7927000E-02,   5.0424594E-02,   5.2974042E-02
     +,   5.5528607E-02,   5.8036439E-02,   6.0443427E-02
     +,   6.2695943E-02,   6.4743802E-02,   6.6543773E-02
     +,   6.8062566E-02,   6.9279343E-02,   7.0187092E-02
     +,   7.0793994E-02,   7.1123078E-02,   7.1211755E-02
     +,   7.1110390E-02,   7.0880786E-02,   7.0594564E-02
     +,   7.0331626E-02,   7.0178621E-02,   7.0227921E-02
     +,   7.0576511E-02,   7.1324475E-02,   7.2573110E-02
     +,   7.4422516E-02,   7.6967083E-02,   8.0288842E-02
     +,   8.4448464E-02,   8.9474328E-02,   9.5349669E-02
     +,   0.1020008    ,   0.1092916    ,   0.1170275    
     +,   0.1249715    ,   0.1328732    ,   0.1405090    
     +,   0.1477237    ,   0.1544647    ,   0.1608025    
     +,   0.1669313    ,   0.1731466    ,   0.1798098    
     +,   0.1873008    ,   0.1959767    ,   0.2061440    
     +,   0.2180580    ,   0.2319451    ,   0.2480146    
     +,   0.2664138    ,   0.2870867    ,   0.3095787    
     +,   0.3328922    ,   0.3555403    ,   0.3758817    
     +,   0.3926421    ,   0.4054224    ,   0.4149673    
     +,   0.4230930    ,   0.4322538    ,   0.4448071    
     +,   0.4621175    ,   0.4838034    ,   0.5075611    
     +,   0.5298367    ,   0.5471269    ,   0.5572547    
     +,   0.5599095    ,   0.5562862    ,   0.5482240    
     +,   0.5374010    ,   0.5248696    ,   0.5108821    
     +,   0.4949030    ,   0.4758448    ,   0.4525362    
     +,   0.4242854    ,   0.3912630    ,   0.3545451    
     +,   0.3158671    ,   0.2772357    ,   0.2405244    
     +,   0.2071547    ,   0.1779136    ,   0.1529416    
     +,   0.1318818    ,   0.1141207    ,   9.9015415E-02
     +,   8.6037345E-02,   7.4817702E-02,   6.5121628E-02
     +,   5.6791116E-02,   4.9691085E-02,   4.3678999E-02
     +,   3.8599197E-02,   3.4292523E-02,   3.0609580E-02
     +,   2.7423054E-02,   2.4633192E-02,   2.2166768E-02
     +,   1.9972367E-02,   1.8014301E-02,   1.6266856E-02
     +,   1.4709589E-02,   1.3324410E-02,   1.2094221E-02
     +,   1.1002515E-02,   1.0033390E-02,   9.1717783E-03
     +,   8.4038721E-03,   7.7173999E-03,   7.1015670E-03
     +,   6.5471116E-03,   6.0462155E-03,   5.5922950E-03
     +,   5.1797912E-03,   4.8040245E-03,   4.4610496E-03
     +,   4.1474835E-03,   3.8603870E-03,   3.5971829E-03
     +,   3.3556160E-03,   3.1336767E-03,   2.9295476E-03
     +,   2.7415957E-03,   2.5683674E-03,   2.4085331E-03
     +,   2.2608964E-03,   2.1243882E-03,   1.9980483E-03
     +,   1.8810062E-03,   1.7724836E-03,   1.6717898E-03
     +,   1.5783055E-03,   1.4914690E-03,   1.4107747E-03
     +,   1.3357735E-03,   1.2660467E-03,   1.2012210E-03
     +,   1.1409437E-03,   1.0848962E-03,   1.0327734E-03
     +,   9.8429737E-04,   9.3919935E-04,   8.9723174E-04
     +,   8.5815601E-04,   8.2175055E-04,   7.8780355E-04
     +,   7.5611507E-04,   7.2650018E-04,   6.9878210E-04
     +,   6.7279884E-04,   6.4839679E-04,   6.2543707E-04
     +,   6.0378824E-04,   5.8333291E-04,   5.6396087E-04
     +,   5.4557482E-04,   5.2808376E-04,   5.1140826E-04
     +,   4.9547461E-04,   4.8021899E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_hzonly_htt105_mass = Yx/5.263986
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_hzonly_htt107_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.6781945E-03,   1.7459746E-03
     +,   1.8164917E-03,   1.8898405E-03,   1.9661088E-03
     +,   2.0453802E-03,   2.1277282E-03,   2.2132166E-03
     +,   2.3018953E-03,   2.3938059E-03,   2.4889691E-03
     +,   2.5873918E-03,   2.6890608E-03,   2.7939435E-03
     +,   2.9019862E-03,   3.0131117E-03,   3.1272199E-03
     +,   3.2441863E-03,   3.3638650E-03,   3.4860796E-03
     +,   3.6106349E-03,   3.7373120E-03,   3.8658653E-03
     +,   3.9960402E-03,   4.1275490E-03,   4.2601018E-03
     +,   4.3933890E-03,   4.5270952E-03,   4.6608974E-03
     +,   4.7944766E-03,   4.9275151E-03,   5.0597014E-03
     +,   5.1907459E-03,   5.3203693E-03,   5.4483218E-03
     +,   5.5743828E-03,   5.6983638E-03,   5.8201170E-03
     +,   5.9395419E-03,   6.0565714E-03,   6.1712023E-03
     +,   6.2834774E-03,   6.3934922E-03,   6.5013962E-03
     +,   6.6073905E-03,   6.7117331E-03,   6.8147210E-03
     +,   6.9167032E-03,   7.0180637E-03,   7.1192239E-03
     +,   7.2206277E-03,   7.3227412E-03,   7.4260356E-03
     +,   7.5309868E-03,   7.6380577E-03,   7.7476967E-03
     +,   7.8603178E-03,   7.9763001E-03,   8.0959732E-03
     +,   8.2196137E-03,   8.3474247E-03,   8.4795607E-03
     +,   8.6160740E-03,   8.7569617E-03,   8.9021428E-03
     +,   9.0514468E-03,   9.2046363E-03,   9.3614077E-03
     +,   9.5213996E-03,   9.6841818E-03,   9.8493090E-03
     +,   1.0016283E-02,   1.0184624E-02,   1.0353831E-02
     +,   1.0523433E-02,   1.0693012E-02,   1.0862186E-02
     +,   1.1030660E-02,   1.1198241E-02,   1.1364843E-02
     +,   1.1530491E-02,   1.1695379E-02,   1.1859813E-02
     +,   1.2024298E-02,   1.2189474E-02,   1.2356154E-02
     +,   1.2525316E-02,   1.2698093E-02,   1.2875753E-02
     +,   1.3059690E-02,   1.3251421E-02,   1.3452511E-02
     +,   1.3664583E-02,   1.3889285E-02,   1.4128223E-02
     +,   1.4382923E-02,   1.4654799E-02,   1.4945095E-02
     +,   1.5254846E-02,   1.5584800E-02,   1.5935441E-02
     +,   1.6306855E-02,   1.6698794E-02,   1.7110569E-02
     +,   1.7541111E-02,   1.7988939E-02,   1.8452156E-02
     +,   1.8928496E-02,   1.9415407E-02,   1.9910095E-02
     +,   2.0409547E-02,   2.0910742E-02,   2.1410646E-02
     +,   2.1906411E-02,   2.2395447E-02,   2.2875588E-02
     +,   2.3345113E-02,   2.3802975E-02,   2.4248747E-02
     +,   2.4682812E-02,   2.5106300E-02,   2.5521137E-02
     +,   2.5929967E-02,   2.6336176E-02,   2.6743727E-02
     +,   2.7157078E-02,   2.7581062E-02,   2.8020727E-02
     +,   2.8481206E-02,   2.8967539E-02,   2.9484626E-02
     +,   3.0037021E-02,   3.0628920E-02,   3.1264000E-02
     +,   3.1945501E-02,   3.2676097E-02,   3.3457913E-02
     +,   3.4292519E-02,   3.5180978E-02,   3.6123883E-02
     +,   3.7121255E-02,   3.8172614E-02,   3.9277181E-02
     +,   4.0433720E-02,   4.1640483E-02,   4.2895634E-02
     +,   4.4197127E-02,   4.5542620E-02,   4.6929806E-02
     +,   4.8356645E-02,   4.9821332E-02,   5.1322617E-02
     +,   5.2859951E-02,   5.4434106E-02,   5.6047380E-02
     +,   5.7703920E-02,   5.9410136E-02,   6.1175443E-02
     +,   6.3011721E-02,   6.4933680E-02,   6.6958383E-02
     +,   6.9104552E-02,   7.1391806E-02,   7.3839962E-02
     +,   7.6469012E-02,   7.9299293E-02,   8.2352728E-02
     +,   8.5654438E-02,   8.9234926E-02,   9.3130276E-02
     +,   9.7382344E-02,   0.1020361    ,   0.1071375    
     +,   0.1127298    ,   0.1188532    ,   0.1255471    
     +,   0.1328508    ,   0.1408021    ,   0.1494242    
     +,   0.1587020    ,   0.1685513    ,   0.1787967    
     +,   0.1891815    ,   0.1994258    ,   0.2093221    
     +,   0.2188387    ,   0.2281781    ,   0.2377401    
     +,   0.2479869    ,   0.2592626    ,   0.2716669    
     +,   0.2850600    ,   0.2992160    ,   0.3140396    
     +,   0.3297163    ,   0.3466917    ,   0.3654795    
     +,   0.3863825    ,   0.4092337    ,   0.4332318    
     +,   0.4569268    ,   0.4783973    ,   0.4956612    
     +,   0.5072375    ,   0.5126742    ,   0.5127324    
     +,   0.5090588    ,   0.5034584    ,   0.4971255    
     +,   0.4902330    ,   0.4820519    ,   0.4714575    
     +,   0.4575076    ,   0.4398284    ,   0.4187149    
     +,   0.3949804    ,   0.3696671    ,   0.3437474    
     +,   0.3179306    ,   0.2926198    ,   0.2679933    
     +,   0.2441422    ,   0.2211747    ,   0.1992511    
     +,   0.1785602    ,   0.1592827    ,   0.1415613    
     +,   0.1254871    ,   0.1110994    ,   9.8389655E-02
     +,   8.7301157E-02,   7.7728152E-02,   6.9518879E-02
     +,   6.2486790E-02,   5.6428332E-02,   5.1141437E-02
     +,   4.6445049E-02,   4.2192485E-02,   3.8277134E-02
     +,   3.4631204E-02,   3.1219466E-02,   2.8030109E-02
     +,   2.5064768E-02,   2.2329951E-02,   1.9831317E-02
     +,   1.7570270E-02,   1.5542571E-02,   1.3738405E-02
     +,   1.2143724E-02,   1.0741846E-02,   9.5145302E-03
     +,   8.4433490E-03,   7.5105554E-03,   6.6995085E-03
     +,   5.9949020E-03,   5.3829239E-03,   4.8512616E-03
     +,   4.3889745E-03,   3.9863787E-03,   3.6349711E-03
     +,   3.3273534E-03,   3.0571048E-03,   2.8186776E-03
     +,   2.6073307E-03,   2.4190645E-03,   2.2504919E-03
     +,   2.0987834E-03,   1.9615944E-03,   1.8369849E-03
     +,   1.7233448E-03,   1.6193441E-03,   1.5238890E-03
     +,   1.4360690E-03,   1.3551137E-03,   1.2803714E-03
     +,   1.2112893E-03,   1.1473794E-03,   1.0882190E-03
     +,   1.0334246E-03,   9.8265719E-04,   9.3560183E-04
     +,   8.9197594E-04,   8.5151347E-04,   8.1397308E-04
     +,   7.7912596E-04,   7.4676407E-04,   7.1669056E-04
     +,   6.8872236E-04,   6.6269236E-04,   6.3844200E-04
     +,   6.1582692E-04,   5.9471134E-04,   5.7497172E-04
     +,   5.5649201E-04,   5.3916784E-04,   5.2290049E-04
     +,   5.0760194E-04,   4.9318926E-04,   4.7958858E-04
     +,   4.6673065E-04,   4.5455384E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_hzonly_htt107_mass = Yx/5.13054579545454
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_hzonly_htt110_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.0036765E-03,   2.0662856E-03
     +,   2.1298639E-03,   2.1943888E-03,   2.2598335E-03
     +,   2.3261688E-03,   2.3933626E-03,   2.4613806E-03
     +,   2.5301820E-03,   2.5997257E-03,   2.6699663E-03
     +,   2.7408528E-03,   2.8123304E-03,   2.8843416E-03
     +,   2.9568237E-03,   3.0297083E-03,   3.1029261E-03
     +,   3.1764011E-03,   3.2500541E-03,   3.3238002E-03
     +,   3.3975549E-03,   3.4712255E-03,   3.5447171E-03
     +,   3.6179360E-03,   3.6907801E-03,   3.7631507E-03
     +,   3.8349433E-03,   3.9060563E-03,   3.9763851E-03
     +,   4.0458278E-03,   4.1142823E-03,   4.1816514E-03
     +,   4.2478358E-03,   4.3127467E-03,   4.3762969E-03
     +,   4.4384045E-03,   4.4989944E-03,   4.5580007E-03
     +,   4.6153683E-03,   4.6710451E-03,   4.7249962E-03
     +,   4.7771949E-03,   4.8276265E-03,   4.8762928E-03
     +,   4.9232044E-03,   4.9683899E-03,   5.0118905E-03
     +,   5.0537647E-03,   5.0940830E-03,   5.1329397E-03
     +,   5.1704352E-03,   5.2066967E-03,   5.2418588E-03
     +,   5.2760807E-03,   5.3095357E-03,   5.3424123E-03
     +,   5.3749220E-03,   5.4072877E-03,   5.4397597E-03
     +,   5.4726033E-03,   5.5061025E-03,   5.5405693E-03
     +,   5.5763354E-03,   5.6137606E-03,   5.6532365E-03
     +,   5.6951782E-03,   5.7400479E-03,   5.7883342E-03
     +,   5.8405823E-03,   5.8973674E-03,   5.9593339E-03
     +,   6.0271630E-03,   6.1016120E-03,   6.1834822E-03
     +,   6.2736487E-03,   6.3730516E-03,   6.4826896E-03
     +,   6.6036140E-03,   6.7369421E-03,   6.8838350E-03
     +,   7.0454730E-03,   7.2230767E-03,   7.4178395E-03
     +,   7.6309633E-03,   7.8635626E-03,   8.1167091E-03
     +,   8.3913272E-03,   8.6882180E-03,   9.0079652E-03
     +,   9.3509508E-03,   9.7172931E-03,   1.0106781E-02
     +,   1.0518864E-02,   1.0952655E-02,   1.1406871E-02
     +,   1.1879794E-02,   1.2369351E-02,   1.2873014E-02
     +,   1.3387945E-02,   1.3910886E-02,   1.4438363E-02
     +,   1.4966623E-02,   1.5491785E-02,   1.6009903E-02
     +,   1.6517067E-02,   1.7009549E-02,   1.7483853E-02
     +,   1.7936863E-02,   1.8365990E-02,   1.8769234E-02
     +,   1.9145282E-02,   1.9493636E-02,   1.9814599E-02
     +,   2.0109398E-02,   2.0380108E-02,   2.0629711E-02
     +,   2.0861967E-02,   2.1081433E-02,   2.1293225E-02
     +,   2.1503003E-02,   2.1716714E-02,   2.1940429E-02
     +,   2.2180131E-02,   2.2441516E-02,   2.2729814E-02
     +,   2.3049461E-02,   2.3404043E-02,   2.3796074E-02
     +,   2.4226902E-02,   2.4696585E-02,   2.5204018E-02
     +,   2.5746822E-02,   2.6321663E-02,   2.6924258E-02
     +,   2.7549850E-02,   2.8193492E-02,   2.8850315E-02
     +,   2.9516144E-02,   3.0187868E-02,   3.0863859E-02
     +,   3.1544339E-02,   3.2231607E-02,   3.2930396E-02
     +,   3.3647668E-02,   3.4392554E-02,   3.5175964E-02
     +,   3.6010090E-02,   3.6907583E-02,   3.7880585E-02
     +,   3.8940016E-02,   4.0094342E-02,   4.1348636E-02
     +,   4.2703886E-02,   4.4156663E-02,   4.5699049E-02
     +,   4.7319088E-02,   4.9001962E-02,   5.0731964E-02
     +,   5.2494925E-02,   5.4280505E-02,   5.6085948E-02
     +,   5.7918306E-02,   5.9796590E-02,   6.1752580E-02
     +,   6.3830420E-02,   6.6083670E-02,   6.8571068E-02
     +,   7.1350604E-02,   7.4473366E-02,   7.7977143E-02
     +,   8.1880555E-02,   8.6180195E-02,   9.0849616E-02
     +,   9.5841758E-02,   0.1010935    ,   0.1065360    
     +,   0.1121056    ,   0.1177588    ,   0.1234851    
     +,   0.1293193    ,   0.1353425    ,   0.1416713    
     +,   0.1484342    ,   0.1557365    ,   0.1636246    
     +,   0.1720672    ,   0.1809715    ,   0.1902436    
     +,   0.1998763    ,   0.2100317    ,   0.2210641    
     +,   0.2334376    ,   0.2475398    ,   0.2634536    
     +,   0.2808016    ,   0.2987672    ,   0.3163275    
     +,   0.3326235    ,   0.3472848    ,   0.3605404    
     +,   0.3730786    ,   0.3857733    ,   0.3994974    
     +,   0.4151192    ,   0.4335604    ,   0.4556499    
     +,   0.4815875    ,   0.5102135    ,   0.5385821    
     +,   0.5623769    ,   0.5772647    ,   0.5807104    
     +,   0.5732570    ,   0.5583771    ,   0.5407884    
     +,   0.5241441    ,   0.5094682    ,   0.4951745    
     +,   0.4784373    ,   0.4568997    ,   0.4297697    
     +,   0.3979706    ,   0.3635801    ,   0.3290073    
     +,   0.2962899    ,   0.2667008    ,   0.2406808    
     +,   0.2180199    ,   0.1981576    ,   0.1804712    
     +,   0.1644625    ,   0.1498120    ,   0.1363412    
     +,   0.1239431    ,   0.1125258    ,   0.1019866    
     +,   9.2217296E-02,   8.3121754E-02,   7.4629553E-02
     +,   6.6700689E-02,   5.9323300E-02,   5.2504353E-02
     +,   4.6258502E-02,   4.0597606E-02,   3.5524189E-02
     +,   3.1027885E-02,   2.7084254E-02,   2.3656191E-02
     +,   2.0697506E-02,   1.8157002E-02,   1.5981667E-02
     +,   1.4120263E-02,   1.2525712E-02,   1.1156269E-02
     +,   9.9760592E-03,   8.9549907E-03,   8.0683371E-03
     +,   7.2958404E-03,   6.6209105E-03,   6.0299095E-03
     +,   5.5115432E-03,   5.0562886E-03,   4.6559721E-03
     +,   4.3035084E-03,   3.9927177E-03,   3.7181079E-03
     +,   3.4748127E-03,   3.2585321E-03,   3.0654559E-03
     +,   2.8922216E-03,   2.7358884E-03,   2.5939215E-03
     +,   2.4641417E-03,   2.3446905E-03,   2.2340082E-03
     +,   2.1308067E-03,   2.0340136E-03,   1.9427694E-03
     +,   1.8563682E-03,   1.7742565E-03,   1.6959839E-03
     +,   1.6212037E-03,   1.5496331E-03,   1.4810566E-03
     +,   1.4152939E-03,   1.3522067E-03,   1.2916763E-03
     +,   1.2336012E-03,   1.1778990E-03,   1.1244882E-03
     +,   1.0733004E-03,   1.0242641E-03,   9.7731559E-04
     +,   9.3238661E-04,   8.8941504E-04,   8.4833283E-04
     +,   8.0907729E-04,   7.7158061E-04,   7.3577999E-04
     +,   7.0160790E-04,   6.6900213E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_hzonly_htt110_mass = Yx/5.37441927272727
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_hzonly_htt115_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.3607492E-03,   1.4068858E-03
     +,   1.4533023E-03,   1.4999417E-03,   1.5467486E-03
     +,   1.5936666E-03,   1.6406408E-03,   1.6876165E-03
     +,   1.7345408E-03,   1.7813635E-03,   1.8280343E-03
     +,   1.8745065E-03,   1.9207350E-03,   1.9666788E-03
     +,   2.0122975E-03,   2.0575563E-03,   2.1024225E-03
     +,   2.1468676E-03,   2.1908656E-03,   2.2343956E-03
     +,   2.2774392E-03,   2.3199832E-03,   2.3620168E-03
     +,   2.4035356E-03,   2.4445343E-03,   2.4850152E-03
     +,   2.5249836E-03,   2.5644465E-03,   2.6034147E-03
     +,   2.6419018E-03,   2.6799249E-03,   2.7175017E-03
     +,   2.7546545E-03,   2.7914040E-03,   2.8277754E-03
     +,   2.8637922E-03,   2.8994817E-03,   2.9348671E-03
     +,   2.9699786E-03,   3.0048371E-03,   3.0394702E-03
     +,   3.0739019E-03,   3.1081529E-03,   3.1422460E-03
     +,   3.1761993E-03,   3.2100296E-03,   3.2437525E-03
     +,   3.2773782E-03,   3.3109179E-03,   3.3443770E-03
     +,   3.3777598E-03,   3.4110649E-03,   3.4442917E-03
     +,   3.4774356E-03,   3.5104859E-03,   3.5434323E-03
     +,   3.5762622E-03,   3.6089572E-03,   3.6414990E-03
     +,   3.6738673E-03,   3.7060378E-03,   3.7379868E-03
     +,   3.7696862E-03,   3.8011107E-03,   3.8322334E-03
     +,   3.8630229E-03,   3.8934532E-03,   3.9234953E-03
     +,   3.9531244E-03,   3.9823102E-03,   4.0110336E-03
     +,   4.0392699E-03,   4.0670014E-03,   4.0942095E-03
     +,   4.1208840E-03,   4.1470169E-03,   4.1726041E-03
     +,   4.1976459E-03,   4.2221509E-03,   4.2461357E-03
     +,   4.2696185E-03,   4.2926311E-03,   4.3152091E-03
     +,   4.3374030E-03,   4.3592667E-03,   4.3808725E-03
     +,   4.4022952E-03,   4.4236332E-03,   4.4449894E-03
     +,   4.4664843E-03,   4.4882549E-03,   4.5104483E-03
     +,   4.5332368E-03,   4.5568040E-03,   4.5813522E-03
     +,   4.6071024E-03,   4.6342942E-03,   4.6631834E-03
     +,   4.6940488E-03,   4.7271797E-03,   4.7628898E-03
     +,   4.8015034E-03,   4.8433617E-03,   4.8888144E-03
     +,   4.9382243E-03,   4.9919640E-03,   5.0504045E-03
     +,   5.1139197E-03,   5.1828842E-03,   5.2576652E-03
     +,   5.3386111E-03,   5.4260707E-03,   5.5203601E-03
     +,   5.6217881E-03,   5.7306243E-03,   5.8471286E-03
     +,   5.9715197E-03,   6.1040078E-03,   6.2447637E-03
     +,   6.3939649E-03,   6.5517682E-03,   6.7183431E-03
     +,   6.8938765E-03,   7.0786024E-03,   7.2728456E-03
     +,   7.4769971E-03,   7.6916250E-03,   7.9174535E-03
     +,   8.1554586E-03,   8.4068766E-03,   8.6733019E-03
     +,   8.9566950E-03,   9.2594828E-03,   9.5845554E-03
     +,   9.9353334E-03,   1.0315793E-02,   1.0730399E-02
     +,   1.1184101E-02,   1.1682298E-02,   1.2230676E-02
     +,   1.2835006E-02,   1.3500980E-02,   1.4233996E-02
     +,   1.5038853E-02,   1.5919354E-02,   1.6878182E-02
     +,   1.7916596E-02,   1.9034171E-02,   2.0228760E-02
     +,   2.1496618E-02,   2.2832530E-02,   2.4230039E-02
     +,   2.5681982E-02,   2.7181208E-02,   2.8721081E-02
     +,   3.0296110E-02,   3.1902652E-02,   3.3539530E-02
     +,   3.5208367E-02,   3.6913574E-02,   3.8662724E-02
     +,   4.0466122E-02,   4.2336483E-02,   4.4288166E-02
     +,   4.6336967E-02,   4.8499074E-02,   5.0790355E-02
     +,   5.3225849E-02,   5.5819303E-02,   5.8582906E-02
     +,   6.1526667E-02,   6.4657941E-02,   6.7981362E-02
     +,   7.1497805E-02,   7.5203620E-02,   7.9091482E-02
     +,   8.3150610E-02,   8.7368742E-02,   9.1734983E-02
     +,   9.6242473E-02,   0.1008898    ,   0.1056807    
     +,   0.1106218    ,   0.1157205    ,   0.1209796    
     +,   0.1263936    ,   0.1319465    ,   0.1376152    
     +,   0.1433800    ,   0.1492482    ,   0.1552921    
     +,   0.1616904    ,   0.1687571    ,   0.1769405    
     +,   0.1867733    ,   0.1987697    ,   0.2132865    
     +,   0.2303770    ,   0.2496759    ,   0.2703582    
     +,   0.2912044    ,   0.3107900    ,   0.3277910    
     +,   0.3413344    ,   0.3513119    ,   0.3585343    
     +,   0.3646312    ,   0.3716809    ,   0.3816193    
     +,   0.3955731    ,   0.4133715    ,   0.4334956    
     +,   0.4535778    ,   0.4712228    ,   0.4847312    
     +,   0.4934602    ,   0.4978831    ,   0.4993797    
     +,   0.4996654    ,   0.4998656    ,   0.4996799    
     +,   0.4972986    ,   0.4902771    ,   0.4768404    
     +,   0.4568113    ,   0.4316775    ,   0.4038603    
     +,   0.3756757    ,   0.3485763    ,   0.3230300    
     +,   0.2989372    ,   0.2761658    ,   0.2548198    
     +,   0.2351574    ,   0.2173420    ,   0.2012551    
     +,   0.1865066    ,   0.1725888    ,   0.1590597    
     +,   0.1456627    ,   0.1323517    ,   0.1192454    
     +,   0.1065520    ,   9.4499938E-02,   8.3291456E-02
     +,   7.3077254E-02,   6.3945681E-02,   5.5923086E-02
     +,   4.8981324E-02,   4.3049950E-02,   3.8027845E-02
     +,   3.3797380E-02,   3.0236702E-02,   2.7228773E-02
     +,   2.4667893E-02,   2.2463568E-02,   2.0541660E-02
     +,   1.8843701E-02,   1.7324768E-02,   1.5951278E-02
     +,   1.4698603E-02,   1.3548740E-02,   1.2488369E-02
     +,   1.1507588E-02,   1.0598956E-02,   9.7565772E-03
     +,   8.9757247E-03,   8.2525462E-03,   7.5837476E-03
     +,   6.9663893E-03,   6.3977977E-03,   5.8754981E-03
     +,   5.3970832E-03,   4.9601370E-03,   4.5622289E-03
     +,   4.2009340E-03,   3.8737366E-03,   3.5781350E-03
     +,   3.3115759E-03,   3.0715554E-03,   2.8555791E-03
     +,   2.6612536E-03,   2.4862580E-03,   2.3284205E-03
     +,   2.1856925E-03,   2.0562045E-03,   1.9382412E-03
     +,   1.8302659E-03,   1.7309239E-03,   1.6390188E-03
     +,   1.5535257E-03,   1.4735620E-03,   1.3983925E-03
     +,   1.3273979E-03,   1.2600784E-03,   1.1960216E-03
     +,   1.1349055E-03,   1.0764695E-03,   1.0205178E-03
     +,   9.6689275E-04,   9.1548066E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_hzonly_htt115_mass = Yx/5.03391668181818
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_hzonly_htt120_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  5.2420568E-04,   5.4709992E-04
     +,   5.7120458E-04,   5.9656589E-04,   6.2322890E-04
     +,   6.5123703E-04,   6.8063178E-04,   7.1145192E-04
     +,   7.4373308E-04,   7.7750871E-04,   8.1280730E-04
     +,   8.4965368E-04,   8.8806782E-04,   9.2806463E-04
     +,   9.6965348E-04,   1.0128377E-03,   1.0576145E-03
     +,   1.1039742E-03,   1.1518999E-03,   1.2013675E-03
     +,   1.2523449E-03,   1.3047924E-03,   1.3586615E-03
     +,   1.4138984E-03,   1.4704355E-03,   1.5282028E-03
     +,   1.5871181E-03,   1.6470926E-03,   1.7080300E-03
     +,   1.7698249E-03,   1.8323666E-03,   1.8955356E-03
     +,   1.9592075E-03,   2.0232522E-03,   2.0875332E-03
     +,   2.1519114E-03,   2.2162432E-03,   2.2803810E-03
     +,   2.3441806E-03,   2.4074884E-03,   2.4701590E-03
     +,   2.5320447E-03,   2.5930000E-03,   2.6528833E-03
     +,   2.7115582E-03,   2.7688930E-03,   2.8247628E-03
     +,   2.8790513E-03,   2.9316507E-03,   2.9824637E-03
     +,   3.0314026E-03,   3.0783950E-03,   3.1233768E-03
     +,   3.1663042E-03,   3.2071404E-03,   3.2458715E-03
     +,   3.2824955E-03,   3.3170276E-03,   3.3495012E-03
     +,   3.3799678E-03,   3.4084956E-03,   3.4351733E-03
     +,   3.4601036E-03,   3.4834153E-03,   3.5052497E-03
     +,   3.5257689E-03,   3.5451516E-03,   3.5635969E-03
     +,   3.5813199E-03,   3.5985520E-03,   3.6155432E-03
     +,   3.6325555E-03,   3.6498678E-03,   3.6677725E-03
     +,   3.6865727E-03,   3.7065849E-03,   3.7281341E-03
     +,   3.7515506E-03,   3.7771761E-03,   3.8053540E-03
     +,   3.8364283E-03,   3.8707482E-03,   3.9086565E-03
     +,   3.9504943E-03,   3.9965943E-03,   4.0472830E-03
     +,   4.1028690E-03,   4.1636522E-03,   4.2299088E-03
     +,   4.3018986E-03,   4.3798592E-03,   4.4639977E-03
     +,   4.5544924E-03,   4.6514925E-03,   4.7551133E-03
     +,   4.8654294E-03,   4.9824892E-03,   5.1062806E-03
     +,   5.2367765E-03,   5.3738831E-03,   5.5174879E-03
     +,   5.6674159E-03,   5.8234748E-03,   5.9854104E-03
     +,   6.1529530E-03,   6.3258028E-03,   6.5036197E-03
     +,   6.6860444E-03,   6.8727178E-03,   7.0632719E-03
     +,   7.2573335E-03,   7.4545615E-03,   7.6546175E-03
     +,   7.8572342E-03,   8.0621690E-03,   8.2692709E-03
     +,   8.4784515E-03,   8.6897323E-03,   8.9032371E-03
     +,   9.1192257E-03,   9.3380855E-03,   9.5603522E-03
     +,   9.7866971E-03,   1.0017975E-02,   1.0255194E-02
     +,   1.0499482E-02,   1.0752155E-02,   1.1014611E-02
     +,   1.1288408E-02,   1.1575153E-02,   1.1876551E-02
     +,   1.2194315E-02,   1.2530211E-02,   1.2885930E-02
     +,   1.3263139E-02,   1.3663433E-02,   1.4088290E-02
     +,   1.4539038E-02,   1.5016886E-02,   1.5522907E-02
     +,   1.6057953E-02,   1.6622713E-02,   1.7217729E-02
     +,   1.7843401E-02,   1.8499846E-02,   1.9187123E-02
     +,   1.9905083E-02,   2.0653356E-02,   2.1431344E-02
     +,   2.2238264E-02,   2.3073027E-02,   2.3934167E-02
     +,   2.4819739E-02,   2.5727389E-02,   2.6654204E-02
     +,   2.7596539E-02,   2.8550057E-02,   2.9509814E-02
     +,   3.0470274E-02,   3.1425275E-02,   3.2368511E-02
     +,   3.3293791E-02,   3.4195337E-02,   3.5068553E-02
     +,   3.5910595E-02,   3.6721032E-02,   3.7502460E-02
     +,   3.8261175E-02,   3.9007567E-02,   3.9756205E-02
     +,   4.0525623E-02,   4.1337725E-02,   4.2216729E-02
     +,   4.3187927E-02,   4.4275802E-02,   4.5502823E-02
     +,   4.6887938E-02,   4.8445906E-02,   5.0187595E-02
     +,   5.2121591E-02,   5.4256864E-02,   5.6606412E-02
     +,   5.9191976E-02,   6.2048506E-02,   6.5227382E-02
     +,   6.8797119E-02,   7.2841145E-02,   7.7451892E-02
     +,   8.2720608E-02,   8.8725060E-02,   9.5518500E-02
     +,   0.1031210    ,   0.1115158    ,   0.1206525    
     +,   0.1304550    ,   0.1408278    ,   0.1516587    
     +,   0.1628165    ,   0.1741439    ,   0.1854484    
     +,   0.1964967    ,   0.2070180    ,   0.2167158    
     +,   0.2252985    ,   0.2325375    ,   0.2383661    
     +,   0.2429967    ,   0.2470114    ,   0.2513616    
     +,   0.2572149    ,   0.2656597    ,   0.2773345    
     +,   0.2921326    ,   0.3091214    ,   0.3267672    
     +,   0.3434242    ,   0.3578879    ,   0.3697374    
     +,   0.3792689    ,   0.3870616    ,   0.3934782    
     +,   0.3984186    ,   0.4014857    ,   0.4024069    
     +,   0.4014030    ,   0.3992442    ,   0.3969384    
     +,   0.3952071    ,   0.3940311    ,   0.3924894    
     +,   0.3890184    ,   0.3819750    ,   0.3702701    
     +,   0.3537855    ,   0.3334093    ,   0.3107107    
     +,   0.2874405    ,   0.2650801    ,   0.2445745    
     +,   0.2262839    ,   0.2100988    ,   0.1956271    
     +,   0.1823898    ,   0.1699762    ,   0.1581399    
     +,   0.1468197    ,   0.1360967    ,   0.1261137    
     +,   0.1169931    ,   0.1087802    ,   0.1014238    
     +,   9.4795167E-02,   8.8727176E-02,   8.3055735E-02
     +,   7.7650882E-02,   7.2431497E-02,   6.7364149E-02
     +,   6.2451281E-02,   5.7715338E-02,   5.3185306E-02
     +,   4.8886973E-02,   4.4837795E-02,   4.1045263E-02
     +,   3.7508521E-02,   3.4220982E-02,   3.1171877E-02
     +,   2.8348673E-02,   2.5738658E-02,   2.3329485E-02
     +,   2.1109490E-02,   1.9067975E-02,   1.7195186E-02
     +,   1.5481984E-02,   1.3919488E-02,   1.2499019E-02
     +,   1.1212070E-02,   1.0049907E-02,   9.0038972E-03
     +,   8.0652609E-03,   7.2254203E-03,   6.4758598E-03
     +,   5.8084400E-03,   5.2152942E-03,   4.6890816E-03
     +,   4.2228694E-03,   3.8103072E-03,   3.4455312E-03
     +,   3.1231970E-03,   2.8385071E-03,   2.5870993E-03
     +,   2.3651004E-03,   2.1690230E-03,   1.9957882E-03
     +,   1.8426380E-03,   1.7071503E-03,   1.5871596E-03
     +,   1.4807686E-03,   1.3862838E-03,   1.3022237E-03
     +,   1.2272680E-03,   1.1602605E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_hzonly_htt120_mass = Yx/4.5812686744186
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_hzonly_htt60_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.3272917E-02,   2.6509196E-02
     +,   3.0076720E-02,   3.3992413E-02,   3.8274948E-02
     +,   4.2948920E-02,   4.8051082E-02,   5.3638633E-02
     +,   5.9797782E-02,   6.6651233E-02,   7.4359924E-02
     +,   8.3118603E-02,   9.3142182E-02,   0.1046440    
     +,   0.1178070    ,   0.1327503    ,   0.1494928    
     +,   0.1679192    ,   0.1877616    ,   0.2086271    
     +,   0.2300985    ,   0.2519311    ,   0.2742969    
     +,   0.2979737    ,   0.3243261    ,   0.3550143    
     +,   0.3914656    ,   0.4343397    ,   0.4831944    
     +,   0.5364597    ,   0.5916616    ,   0.6458682    
     +,   0.6964300    ,   0.7419314    ,   0.7828245    
     +,   0.8209908    ,   0.8582103    ,   0.8945047    
     +,   0.9275689    ,   0.9535218    ,   0.9683768    
     +,   0.9694979    ,   0.9566888    ,   0.9326377    
     +,   0.9021913    ,   0.8701445    ,   0.8385683    
     +,   0.8057613    ,   0.7679845    ,   0.7226007    
     +,   0.6699738    ,   0.6130501    ,   0.5556475    
     +,   0.5010210    ,   0.4513327    ,   0.4077042    
     +,   0.3704695    ,   0.3393951    ,   0.3138401    
     +,   0.2928747    ,   0.2754017    ,   0.2602987    
     +,   0.2465730    ,   0.2334756    ,   0.2205510    
     +,   0.2076239    ,   0.1947376    ,   0.1820764    
     +,   0.1698808    ,   0.1583833    ,   0.1477602    
     +,   0.1381161    ,   0.1294818    ,   0.1218287    
     +,   0.1150822    ,   0.1091365    ,   0.1038679    
     +,   9.9144787E-02,   9.4839215E-02,   9.0835698E-02
     +,   8.7039091E-02,   8.3377011E-02,   7.9802357E-02
     +,   7.6289564E-02,   7.2832376E-02,   6.9438048E-02
     +,   6.6123292E-02,   6.2909737E-02,   5.9820611E-02
     +,   5.6877848E-02,   5.4100584E-02,   5.1504415E-02
     +,   4.9100947E-02,   4.6897862E-02,   4.4899266E-02
     +,   4.3106455E-02,   4.1517653E-02,   4.0128838E-02
     +,   3.8933244E-02,   3.7921794E-02,   3.7082881E-02
     +,   3.6402475E-02,   3.5864208E-02,   3.5449836E-02
     +,   3.5139453E-02,   3.4912173E-02,   3.4746733E-02
     +,   3.4622218E-02,   3.4518689E-02,   3.4417834E-02
     +,   3.4303553E-02,   3.4162279E-02,   3.3983376E-02
     +,   3.3759173E-02,   3.3485033E-02,   3.3159241E-02
     +,   3.2782700E-02,   3.2358550E-02,   3.1891957E-02
     +,   3.1389460E-02,   3.0858589E-02,   3.0307405E-02
     +,   2.9744077E-02,   2.9176366E-02,   2.8611420E-02
     +,   2.8055420E-02,   2.7513390E-02,   2.6989127E-02
     +,   2.6485074E-02,   2.6002413E-02,   2.5541110E-02
     +,   2.5100106E-02,   2.4677454E-02,   2.4270572E-02
     +,   2.3876464E-02,   2.3491891E-02,   2.3113655E-02
     +,   2.2738833E-02,   2.2364814E-02,   2.1989506E-02
     +,   2.1611465E-02,   2.1229919E-02,   2.0844752E-02
     +,   2.0456512E-02,   2.0066408E-02,   1.9676140E-02
     +,   1.9287860E-02,   1.8904079E-02,   1.8527530E-02
     +,   1.8161016E-02,   1.7807296E-02,   1.7469067E-02
     +,   1.7148755E-02,   1.6848501E-02,   1.6570061E-02
     +,   1.6314801E-02,   1.6083637E-02,   1.5877035E-02
     +,   1.5695008E-02,   1.5537164E-02,   1.5402710E-02
     +,   1.5290501E-02,   1.5199102E-02,   1.5126828E-02
     +,   1.5071810E-02,   1.5032029E-02,   1.5005407E-02
     +,   1.4989821E-02,   1.4983179E-02,   1.4983444E-02
     +,   1.4988650E-02,   1.4996961E-02,   1.5006673E-02
     +,   1.5016225E-02,   1.5024200E-02,   1.5029333E-02
     +,   1.5030508E-02,   1.5026739E-02,   1.5017158E-02
     +,   1.5001006E-02,   1.4977610E-02,   1.4946384E-02
     +,   1.4906782E-02,   1.4858305E-02,   1.4800490E-02
     +,   1.4732890E-02,   1.4655054E-02,   1.4566570E-02
     +,   1.4466994E-02,   1.4355915E-02,   1.4232910E-02
     +,   1.4097591E-02,   1.3949576E-02,   1.3788529E-02
     +,   1.3614169E-02,   1.3426245E-02,   1.3224612E-02
     +,   1.3009196E-02,   1.2780007E-02,   1.2537170E-02
     +,   1.2280920E-02,   1.2011632E-02,   1.1729762E-02
     +,   1.1435916E-02,   1.1130827E-02,   1.0815332E-02
     +,   1.0490365E-02,   1.0156985E-02,   9.8163458E-03
     +,   9.4696460E-03,   9.1181425E-03,   8.7631680E-03
     +,   8.4060682E-03,   8.0481907E-03,   7.6908623E-03
     +,   7.3354086E-03,   6.9831298E-03,   6.6352310E-03
     +,   6.2928614E-03,   5.9571210E-03,   5.6289886E-03
     +,   5.3093489E-03,   4.9990024E-03,   4.6986528E-03
     +,   4.4088671E-03,   4.1301101E-03,   3.8627638E-03
     +,   3.6071022E-03,   3.3632889E-03,   3.1313933E-03
     +,   2.9114184E-03,   2.7032848E-03,   2.5068307E-03
     +,   2.3218342E-03,   2.1480345E-03,   1.9851059E-03
     +,   1.8326866E-03,   1.6903941E-03,   1.5578195E-03
     +,   1.4345265E-03,   1.3200688E-03,   1.2140014E-03
     +,   1.1158764E-03,   1.0252410E-03,   9.4165129E-04
     +,   8.6467597E-04,   7.9389609E-04,   7.2890066E-04
     +,   6.6929503E-04,   6.1470695E-04,   5.6477520E-04
     +,   5.1915611E-04,   4.7752864E-04,   4.3958789E-04
     +,   4.0504467E-04,   3.7362735E-04,   3.4508400E-04
     +,   3.1917827E-04,   2.9568796E-04,   2.7440654E-04
     +,   2.5514333E-04,   2.3772124E-04,   2.2197502E-04
     +,   2.0775197E-04,   1.9491259E-04,   1.8332663E-04
     +,   1.7287479E-04,   1.6344778E-04,   1.5494540E-04
     +,   1.4727531E-04,   1.4035319E-04,   1.3410252E-04
     +,   1.2845358E-04,   1.2334251E-04,   1.1871143E-04
     +,   1.1450840E-04,   1.1068583E-04,   1.0720130E-04
     +,   1.0401614E-04,   1.0109604E-04,   9.8409815E-05
     +,   9.5929936E-05,   9.3631410E-05,   9.1492351E-05
     +,   8.9493005E-05,   8.7616041E-05,   8.5846063E-05
     +,   8.4169325E-05,   8.2574006E-05,   8.1049460E-05
     +,   7.9586578E-05,   7.8177138E-05,   7.6814271E-05
     +,   7.5491771E-05,   7.4204450E-05,   7.2947681E-05
     +,   7.1717579E-05,   7.0510781E-05,   6.9324466E-05
     +,   6.8156114E-05,   6.7003864E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_hzonly_htt60_mass = Yx/7.81844074468085
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_hzonly_htt65_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  5.5522057E-03,   6.0543092E-03
     +,   6.6078468E-03,   7.2204620E-03,   7.9011275E-03
     +,   8.6602066E-03,   9.5094517E-03,   1.0461896E-02
     +,   1.1531648E-02,   1.2733663E-02,   1.4083231E-02
     +,   1.5595567E-02,   1.7285289E-02,   1.9165907E-02
     +,   2.1249391E-02,   2.3545895E-02,   2.6063707E-02
     +,   2.8809369E-02,   3.1788159E-02,   3.5004865E-02
     +,   3.8464621E-02,   4.2173866E-02,   4.6141319E-02
     +,   5.0378881E-02,   5.4901320E-02,   5.9726920E-02
     +,   6.4876147E-02,   7.0370406E-02,   7.6230392E-02
     +,   8.2473457E-02,   8.9110605E-02,   9.6143126E-02
     +,   0.1035596    ,   0.1113359    ,   0.1194417    
     +,   0.1278577    ,   0.1366072    ,   0.1457994    
     +,   0.1556721    ,   0.1666086    ,   0.1791137    
     +,   0.1937296    ,   0.2109265    ,   0.2310165    
     +,   0.2541451    ,   0.2803619    ,   0.3097112    
     +,   0.3422793    ,   0.3782026    ,   0.4177053    
     +,   0.4611520    ,   0.5089468    ,   0.5610940    
     +,   0.6165519    ,   0.6728724    ,   0.7265998    
     +,   0.7742211    ,   0.8130326    ,   0.8413790    
     +,   0.8583272    ,   0.8632975    ,   0.8561066    
     +,   0.8376153    ,   0.8105260    ,   0.7793326    
     +,   0.7487785    ,   0.7216000    ,   0.6973333    
     +,   0.6731509    ,   0.6460502    ,   0.6146826    
     +,   0.5796890    ,   0.5427148    ,   0.5051847    
     +,   0.4677404    ,   0.4305064    ,   0.3936588    
     +,   0.3577432    ,   0.3235825    ,   0.2919758    
     +,   0.2634570    ,   0.2382339    ,   0.2162793    
     +,   0.1974385    ,   0.1815004    ,   0.1682022    
     +,   0.1572185    ,   0.1481571    ,   0.1405900    
     +,   0.1341009    ,   0.1283340    ,   0.1230247    
     +,   0.1180034    ,   0.1131805    ,   0.1085216    
     +,   0.1040228    ,   9.9690817E-02,   9.5533237E-02
     +,   9.1553211E-02,   8.7751001E-02,   8.4125079E-02
     +,   8.0675483E-02,   7.7404439E-02,   7.4316777E-02
     +,   7.1418233E-02,   6.8713628E-02,   6.6205122E-02
     +,   6.3890286E-02,   6.1761249E-02,   5.9804667E-02
     +,   5.8002912E-02,   5.6334786E-02,   5.4777563E-02
     +,   5.3308226E-02,   5.1905122E-02,   5.0548945E-02
     +,   4.9223680E-02,   4.7916763E-02,   4.6619557E-02
     +,   4.5326784E-02,   4.4036474E-02,   4.2749457E-02
     +,   4.1468862E-02,   4.0199481E-02,   3.8947273E-02
     +,   3.7719119E-02,   3.6522061E-02,   3.5363372E-02
     +,   3.4249883E-02,   3.3188131E-02,   3.2183833E-02
     +,   3.1242119E-02,   3.0367164E-02,   2.9562332E-02
     +,   2.8829945E-02,   2.8171364E-02,   2.7586995E-02
     +,   2.7076297E-02,   2.6637677E-02,   2.6268708E-02
     +,   2.5966071E-02,   2.5725683E-02,   2.5542766E-02
     +,   2.5411909E-02,   2.5327267E-02,   2.5282595E-02
     +,   2.5271436E-02,   2.5287203E-02,   2.5323326E-02
     +,   2.5373349E-02,   2.5431087E-02,   2.5490655E-02
     +,   2.5546605E-02,   2.5594031E-02,   2.5628550E-02
     +,   2.5646437E-02,   2.5644617E-02,   2.5620684E-02
     +,   2.5572922E-02,   2.5500273E-02,   2.5402324E-02
     +,   2.5279308E-02,   2.5131978E-02,   2.4961596E-02
     +,   2.4769852E-02,   2.4558758E-02,   2.4330627E-02
     +,   2.4087925E-02,   2.3833197E-02,   2.3568973E-02
     +,   2.3297744E-02,   2.3021832E-02,   2.2743352E-02
     +,   2.2464106E-02,   2.2185653E-02,   2.1909196E-02
     +,   2.1635549E-02,   2.1365218E-02,   2.1098364E-02
     +,   2.0834789E-02,   2.0574022E-02,   2.0315323E-02
     +,   2.0057756E-02,   1.9800195E-02,   1.9541394E-02
     +,   1.9280054E-02,   1.9014841E-02,   1.8744450E-02
     +,   1.8467631E-02,   1.8183269E-02,   1.7890356E-02
     +,   1.7588051E-02,   1.7275726E-02,   1.6952928E-02
     +,   1.6619446E-02,   1.6275231E-02,   1.5920486E-02
     +,   1.5555611E-02,   1.5181191E-02,   1.4797963E-02
     +,   1.4406856E-02,   1.4008936E-02,   1.3605361E-02
     +,   1.3197367E-02,   1.2786296E-02,   1.2373499E-02
     +,   1.1960330E-02,   1.1548176E-02,   1.1138392E-02
     +,   1.0732252E-02,   1.0330986E-02,   9.9357488E-03
     +,   9.5476126E-03,   9.1675427E-03,   8.7963669E-03
     +,   8.4348470E-03,   8.0836182E-03,   7.7431803E-03
     +,   7.4139256E-03,   7.0961611E-03,   6.7900657E-03
     +,   6.4957179E-03,   6.2131188E-03,   5.9422012E-03
     +,   5.6827907E-03,   5.4346593E-03,   5.1975390E-03
     +,   4.9711145E-03,   4.7550141E-03,   4.5488435E-03
     +,   4.3522017E-03,   4.1646664E-03,   3.9858050E-03
     +,   3.8151771E-03,   3.6523670E-03,   3.4969500E-03
     +,   3.3485135E-03,   3.2066719E-03,   3.0710544E-03
     +,   2.9413006E-03,   2.8170727E-03,   2.6980613E-03
     +,   2.5839782E-03,   2.4745478E-03,   2.3695168E-03
     +,   2.2686594E-03,   2.1717679E-03,   2.0786459E-03
     +,   1.9891143E-03,   1.9030197E-03,   1.8202121E-03
     +,   1.7405570E-03,   1.6639351E-03,   1.5902373E-03
     +,   1.5193593E-03,   1.4512045E-03,   1.3856881E-03
     +,   1.3227300E-03,   1.2622511E-03,   1.2041768E-03
     +,   1.1484394E-03,   1.0949740E-03,   1.0437137E-03
     +,   9.9459314E-04,   9.4755366E-04,   9.0253277E-04
     +,   8.5946848E-04,   8.1830216E-04,   7.7897526E-04
     +,   7.4142707E-04,   7.0559740E-04,   6.7142822E-04
     +,   6.3886220E-04,   6.0783967E-04,   5.7830167E-04
     +,   5.5019255E-04,   5.2345381E-04,   4.9803063E-04
     +,   4.7386633E-04,   4.5090768E-04,   4.2909969E-04
     +,   4.0839153E-04,   3.8873084E-04,   3.7006880E-04
     +,   3.5235609E-04,   3.3554676E-04,   3.1959478E-04
     +,   3.0445581E-04,   2.9008873E-04,   2.7645184E-04
     +,   2.6350722E-04,   2.5121667E-04,   2.3954544E-04
     +,   2.2845884E-04,   2.1792522E-04,   2.0791331E-04
     +,   1.9839460E-04,   1.8934094E-04,   1.8072684E-04
     +,   1.7252719E-04,   1.6471928E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_hzonly_htt65_mass = Yx/7.1169442826087
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_hzonly_htt70_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.3495513E-03,   2.5199442E-03
     +,   2.7021568E-03,   2.8964507E-03,   3.1030113E-03
     +,   3.3219424E-03,   3.5532613E-03,   3.7968988E-03
     +,   4.0526986E-03,   4.3204371E-03,   4.5998115E-03
     +,   4.8904656E-03,   5.1920107E-03,   5.5040475E-03
     +,   5.8261976E-03,   6.1581377E-03,   6.4996504E-03
     +,   6.8506678E-03,   7.2113378E-03,   7.5820913E-03
     +,   7.9637095E-03,   8.3574289E-03,   8.7650092E-03
     +,   9.1888905E-03,   9.6322075E-03,   1.0099016E-02
     +,   1.0594333E-02,   1.1124282E-02,   1.1696192E-02
     +,   1.2318688E-02,   1.3001757E-02,   1.3756764E-02
     +,   1.4596441E-02,   1.5534761E-02,   1.6586801E-02
     +,   1.7768484E-02,   1.9096253E-02,   2.0586720E-02
     +,   2.2256322E-02,   2.4120720E-02,   2.6194874E-02
     +,   2.8492533E-02,   3.1026572E-02,   3.3809498E-02
     +,   3.6854751E-02,   4.0178820E-02,   4.3804497E-02
     +,   4.7764733E-02,   5.2106977E-02,   5.6896091E-02
     +,   6.2214233E-02,   6.8155862E-02,   7.4816555E-02
     +,   8.2277030E-02,   9.0583809E-02,   9.9736057E-02
     +,   0.1096800    ,   0.1203190    ,   0.1315399    
     +,   0.1432476    ,   0.1554030    ,   0.1680482    
     +,   0.1813112    ,   0.1953868    ,   0.2104938    
     +,   0.2268179    ,   0.2444630    ,   0.2634112    
     +,   0.2835138    ,   0.3044936    ,   0.3259810    
     +,   0.3475790    ,   0.3690184    ,   0.3903914    
     +,   0.4124107    ,   0.4364806    ,   0.4643638    
     +,   0.4973948    ,   0.5355237    ,   0.5767108    
     +,   0.6170439    ,   0.6515455    ,   0.6753291    
     +,   0.6849012    ,   0.6793702    ,   0.6610228    
     +,   0.6345475    ,   0.6049215    ,   0.5751408    
     +,   0.5452961    ,   0.5135352    ,   0.4780693    
     +,   0.4388141    ,   0.3977814    ,   0.3582941    
     +,   0.3236581    ,   0.2960066    ,   0.2757661    
     +,   0.2617822    ,   0.2519205    ,   0.2438223    
     +,   0.2355503    ,   0.2259447    ,   0.2146711    
     +,   0.2020361    ,   0.1886925    ,   0.1753547    
     +,   0.1625886    ,   0.1507149    ,   0.1398163    
     +,   0.1298151    ,   0.1205691    ,   0.1119598    
     +,   0.1039365    ,   9.6523948E-02,   8.9795664E-02
     +,   8.3838604E-02,   7.8714795E-02,   7.4439518E-02
     +,   7.0971668E-02,   6.8219416E-02,   6.6054851E-02
     +,   6.4332418E-02,   6.2906533E-02,   6.1646093E-02
     +,   6.0444191E-02,   5.9222002E-02,   5.7929881E-02
     +,   5.6544174E-02,   5.5063672E-02,   5.3503692E-02
     +,   5.1891651E-02,   5.0261393E-02,   4.8649520E-02
     +,   4.7091469E-02,   4.5618795E-02,   4.4257492E-02
     +,   4.3026630E-02,   4.1937836E-02,   4.0995535E-02
     +,   4.0197607E-02,   3.9536167E-02,   3.8998857E-02
     +,   3.8570061E-02,   3.8232259E-02,   3.7967067E-02
     +,   3.7756287E-02,   3.7582688E-02,   3.7430618E-02
     +,   3.7286248E-02,   3.7137840E-02,   3.6975723E-02
     +,   3.6792252E-02,   3.6581501E-02,   3.6339168E-02
     +,   3.6062405E-02,   3.5749484E-02,   3.5399757E-02
     +,   3.5013393E-02,   3.4591429E-02,   3.4135539E-02
     +,   3.3648018E-02,   3.3131730E-02,   3.2590069E-02
     +,   3.2026734E-02,   3.1445786E-02,   3.0851498E-02
     +,   3.0248227E-02,   2.9640255E-02,   2.9031716E-02
     +,   2.8426487E-02,   2.7828112E-02,   2.7239617E-02
     +,   2.6663555E-02,   2.6101993E-02,   2.5556423E-02
     +,   2.5027832E-02,   2.4516784E-02,   2.4023386E-02
     +,   2.3547404E-02,   2.3088291E-02,   2.2645332E-02
     +,   2.2217644E-02,   2.1804208E-02,   2.1403914E-02
     +,   2.1015665E-02,   2.0638304E-02,   2.0270642E-02
     +,   1.9911477E-02,   1.9559581E-02,   1.9213689E-02
     +,   1.8872477E-02,   1.8534601E-02,   1.8198676E-02
     +,   1.7863264E-02,   1.7526915E-02,   1.7188184E-02
     +,   1.6845698E-02,   1.6498104E-02,   1.6144156E-02
     +,   1.5782792E-02,   1.5413110E-02,   1.5034404E-02
     +,   1.4646191E-02,   1.4248297E-02,   1.3840778E-02
     +,   1.3423967E-02,   1.2998487E-02,   1.2565242E-02
     +,   1.2125322E-02,   1.1680048E-02,   1.1230944E-02
     +,   1.0779679E-02,   1.0327987E-02,   9.8776752E-03
     +,   9.4305882E-03,   8.9885583E-03,   8.5533187E-03
     +,   8.1265159E-03,   7.7097062E-03,   7.3042698E-03
     +,   6.9113970E-03,   6.5321429E-03,   6.1673592E-03
     +,   5.8176811E-03,   5.4835621E-03,   5.1652864E-03
     +,   4.8629623E-03,   4.5765201E-03,   4.3057464E-03
     +,   4.0503182E-03,   3.8098036E-03,   3.5836599E-03
     +,   3.3712825E-03,   3.1720260E-03,   2.9851943E-03
     +,   2.8100668E-03,   2.6459314E-03,   2.4920788E-03
     +,   2.3478030E-03,   2.2124229E-03,   2.0853006E-03
     +,   1.9658273E-03,   1.8534292E-03,   1.7475716E-03
     +,   1.6477692E-03,   1.5535778E-03,   1.4645859E-03
     +,   1.3804226E-03,   1.3007611E-03,   1.2252996E-03
     +,   1.1537682E-03,   1.0859292E-03,   1.0215705E-03
     +,   9.6049689E-04,   9.0253353E-04,   8.4752589E-04
     +,   7.9533394E-04,   7.4582588E-04,   6.9888117E-04
     +,   6.5439055E-04,   6.1225216E-04,   5.7236676E-04
     +,   5.3464068E-04,   4.9898773E-04,   4.6532135E-04
     +,   4.3355822E-04,   4.0361931E-04,   3.7542763E-04
     +,   3.4890612E-04,   3.2397959E-04,   3.0057627E-04
     +,   2.7862578E-04,   2.5805799E-04,   2.3880451E-04
     +,   2.2080055E-04,   2.0398073E-04,   1.8828375E-04
     +,   1.7364803E-04,   1.6001606E-04,   1.4733039E-04
     +,   1.3553735E-04,   1.2458384E-04,   1.1442025E-04
     +,   1.0499777E-04,   9.6271004E-05,   8.8195637E-05
     +,   8.0729638E-05,   7.3833718E-05,   6.7469598E-05
     +,   6.1601939E-05,   5.6196470E-05,   5.1221541E-05
     +,   4.6646648E-05,   4.2443633E-05,   3.8585462E-05
     +,   3.5047255E-05,   3.1805161E-05,   2.8837278E-05
     +,   2.6122700E-05,   2.3642238E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_hzonly_htt70_mass = Yx/5.6824054
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_hzonly_htt75_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.0155848E-03,   3.1496689E-03
     +,   3.2895072E-03,   3.4353896E-03,   3.5875940E-03
     +,   3.7463789E-03,   3.9119744E-03,   4.0845824E-03
     +,   4.2643589E-03,   4.4514318E-03,   4.6458663E-03
     +,   4.8476807E-03,   5.0568408E-03,   5.2732509E-03
     +,   5.4967632E-03,   5.7271766E-03,   5.9642284E-03
     +,   6.2076165E-03,   6.4569945E-03,   6.7119771E-03
     +,   6.9721588E-03,   7.2371131E-03,   7.5064078E-03
     +,   7.7796378E-03,   8.0563864E-03,   8.3363056E-03
     +,   8.6190831E-03,   8.9044785E-03,   9.1923326E-03
     +,   9.4825951E-03,   9.7753238E-03,   1.0070726E-02
     +,   1.0369141E-02,   1.0671087E-02,   1.0977256E-02
     +,   1.1288511E-02,   1.1605932E-02,   1.1930763E-02
     +,   1.2264453E-02,   1.2608603E-02,   1.2964997E-02
     +,   1.3335529E-02,   1.3722211E-02,   1.4127136E-02
     +,   1.4552460E-02,   1.5000388E-02,   1.5473159E-02
     +,   1.5973121E-02,   1.6502725E-02,   1.7064665E-02
     +,   1.7661987E-02,   1.8298287E-02,   1.8977895E-02
     +,   1.9706244E-02,   2.0489978E-02,   2.1337466E-02
     +,   2.2258960E-02,   2.3266906E-02,   2.4376156E-02
     +,   2.5603948E-02,   2.6969908E-02,   2.8495533E-02
     +,   3.0203450E-02,   3.2116499E-02,   3.4256302E-02
     +,   3.6641411E-02,   3.9286274E-02,   4.2199709E-02
     +,   4.5385718E-02,   4.8844270E-02,   5.2576352E-02
     +,   5.6588829E-02,   6.0903840E-02,   6.5567039E-02
     +,   7.0657521E-02,   7.6294735E-02,   8.2639940E-02
     +,   8.9892097E-02,   9.8273344E-02,   0.1080022    
     +,   0.1192555    ,   0.1321309    ,   0.1466114    
     +,   0.1625658    ,   0.1797757    ,   0.1980042    
     +,   0.2170563    ,   0.2368087    ,   0.2571641    
     +,   0.2779706    ,   0.2989744    ,   0.3198853    
     +,   0.3405518    ,   0.3611063    ,   0.3818943    
     +,   0.4031143    ,   0.4243702    ,   0.4444898    
     +,   0.4619101    ,   0.4755222    ,   0.4854698    
     +,   0.4932541    ,   0.5008836    ,   0.5094471    
     +,   0.5180251    ,   0.5237014    ,   0.5227864    
     +,   0.5125319    ,   0.4923482    ,   0.4639214    
     +,   0.4303613    ,   0.3950111    ,   0.3605593    
     +,   0.3286999    ,   0.3002462    ,   0.2754006    
     +,   0.2540112    ,   0.2357216    ,   0.2200588    
     +,   0.2064793    ,   0.1944164    ,   0.1833391    
     +,   0.1728135    ,   0.1625565    ,   0.1524598    
     +,   0.1425741    ,   0.1330540    ,   0.1240934    
     +,   0.1158625    ,   0.1084734    ,   0.1019691    
     +,   9.6338935E-02,   9.1540791E-02,   8.7524459E-02
     +,   8.4244534E-02,   8.1664532E-02,   7.9751790E-02
     +,   7.8468218E-02,   7.7761747E-02,   7.7561401E-02
     +,   7.7776395E-02,   7.8299418E-02,   7.9013638E-02
     +,   7.9800718E-02,   8.0548398E-02,   8.1157967E-02
     +,   8.1548661E-02,   8.1660919E-02,   8.1456736E-02
     +,   8.0918819E-02,   8.0048099E-02,   7.8860737E-02
     +,   7.7384613E-02,   7.5655825E-02,   7.3715582E-02
     +,   7.1607850E-02,   6.9377065E-02,   6.7066513E-02
     +,   6.4717256E-02,   6.2367756E-02,   6.0052678E-02
     +,   5.7803009E-02,   5.5645712E-02,   5.3603340E-02
     +,   5.1693615E-02,   4.9929496E-02,   4.8318915E-02
     +,   4.6864919E-02,   4.5565452E-02,   4.4413906E-02
     +,   4.3399744E-02,   4.2508896E-02,   4.1724633E-02
     +,   4.1028429E-02,   4.0400907E-02,   3.9822605E-02
     +,   3.9274767E-02,   3.8740095E-02,   3.8203273E-02
     +,   3.7651267E-02,   3.7073635E-02,   3.6462702E-02
     +,   3.5813406E-02,   3.5123207E-02,   3.4391832E-02
     +,   3.3621088E-02,   3.2814495E-02,   3.1976823E-02
     +,   3.1113906E-02,   3.0232308E-02,   2.9338943E-02
     +,   2.8440846E-02,   2.7544975E-02,   2.6658043E-02
     +,   2.5786255E-02,   2.4935167E-02,   2.4109827E-02
     +,   2.3314433E-02,   2.2552392E-02,   2.1826293E-02
     +,   2.1137910E-02,   2.0488208E-02,   1.9877311E-02
     +,   1.9304596E-02,   1.8768795E-02,   1.8267961E-02
     +,   1.7799620E-02,   1.7360864E-02,   1.6948452E-02
     +,   1.6558846E-02,   1.6188387E-02,   1.5833393E-02
     +,   1.5490218E-02,   1.5155335E-02,   1.4825433E-02
     +,   1.4497504E-02,   1.4168853E-02,   1.3837148E-02
     +,   1.3500446E-02,   1.3157250E-02,   1.2806438E-02
     +,   1.2447287E-02,   1.2079512E-02,   1.1703163E-02
     +,   1.1318616E-02,   1.0926548E-02,   1.0527928E-02
     +,   1.0123923E-02,   9.7158775E-03,   9.3052564E-03
     +,   8.8936472E-03,   8.4826928E-03,   8.0740256E-03
     +,   7.6692612E-03,   7.2700051E-03,   6.8777474E-03
     +,   6.4938827E-03,   6.1197062E-03,   5.7563903E-03
     +,   5.4049343E-03,   5.0661894E-03,   4.7408766E-03
     +,   4.4295671E-03,   4.1326568E-03,   3.8504049E-03
     +,   3.5829523E-03,   3.3303110E-03,   3.0923625E-03
     +,   2.8688868E-03,   2.6595963E-03,   2.4640991E-03
     +,   2.2819433E-03,   2.1126329E-03,   1.9556286E-03
     +,   1.8103491E-03,   1.6761910E-03,   1.5525487E-03
     +,   1.4388097E-03,   1.3343559E-03,   1.2385786E-03
     +,   1.1508882E-03,   1.0707123E-03,   9.9749304E-04
     +,   9.3069661E-04,   8.6982094E-04,   8.1438432E-04
     +,   7.6393213E-04,   7.1804132E-04,   6.7631487E-04
     +,   6.3838041E-04,   6.0389267E-04,   5.7253358E-04
     +,   5.4400921E-04,   5.1804731E-04,   4.9439771E-04
     +,   4.7283364E-04,   4.5314469E-04,   4.3514135E-04
     +,   4.1864885E-04,   4.0351058E-04,   3.8958224E-04
     +,   3.7673520E-04,   3.6485103E-04,   3.5382496E-04
     +,   3.4356088E-04,   3.3397361E-04,   3.2498583E-04
     +,   3.1652823E-04,   3.0853960E-04,   3.0096440E-04
     +,   2.9375395E-04,   2.8686420E-04,   2.8025691E-04
     +,   2.7389740E-04,   2.6775591E-04,   2.6180557E-04
     +,   2.5602357E-04,   2.5038930E-04,   2.4488551E-04
     +,   2.3949669E-04,   2.3421021E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_hzonly_htt75_mass = Yx/5.05692361363636
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_hzonly_htt80_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.2917205E-03,   1.3555984E-03
     +,   1.4210427E-03,   1.4879451E-03,   1.5561871E-03
     +,   1.6256407E-03,   1.6961694E-03,   1.7676292E-03
     +,   1.8398680E-03,   1.9127313E-03,   1.9860575E-03
     +,   2.0596834E-03,   2.1334440E-03,   2.2071749E-03
     +,   2.2807149E-03,   2.3539062E-03,   2.4265968E-03
     +,   2.4986451E-03,   2.5699190E-03,   2.6402990E-03
     +,   2.7096823E-03,   2.7779860E-03,   2.8451448E-03
     +,   2.9111244E-03,   2.9759097E-03,   3.0395247E-03
     +,   3.1020241E-03,   3.1635021E-03,   3.2240970E-03
     +,   3.2839936E-03,   3.3434320E-03,   3.4027067E-03
     +,   3.4621742E-03,   3.5222645E-03,   3.5834736E-03
     +,   3.6463821E-03,   3.7116506E-03,   3.7800265E-03
     +,   3.8523558E-03,   3.9295680E-03,   4.0126974E-03
     +,   4.1028708E-03,   4.2013046E-03,   4.3093120E-03
     +,   4.4282842E-03,   4.5596892E-03,   4.7050575E-03
     +,   4.8659700E-03,   5.0440412E-03,   5.2408986E-03
     +,   5.4581733E-03,   5.6974674E-03,   5.9603392E-03
     +,   6.2483014E-03,   6.5627545E-03,   6.9050435E-03
     +,   7.2763842E-03,   7.6778950E-03,   8.1105800E-03
     +,   8.5753435E-03,   9.0729920E-03,   9.6042762E-03
     +,   1.0169854E-02,   1.0770410E-02,   1.1406632E-02
     +,   1.2079188E-02,   1.2788877E-02,   1.3536512E-02
     +,   1.4323089E-02,   1.5149641E-02,   1.6017461E-02
     +,   1.6927907E-02,   1.7882721E-02,   1.8883873E-02
     +,   1.9933958E-02,   2.1036349E-02,   2.2195436E-02
     +,   2.3417110E-02,   2.4709331E-02,   2.6082525E-02
     +,   2.7549906E-02,   2.9127983E-02,   3.0836171E-02
     +,   3.2696687E-02,   3.4732971E-02,   3.6968451E-02
     +,   3.9423604E-02,   4.2113628E-02,   4.5044683E-02
     +,   4.8211563E-02,   5.1595770E-02,   5.5165395E-02
     +,   5.8878656E-02,   6.2691689E-02,   6.6570379E-02
     +,   7.0506401E-02,   7.4536189E-02,   7.8755982E-02
     +,   8.3330855E-02,   8.8488430E-02,   9.4496541E-02
     +,   0.1016217    ,   0.1100808    ,   0.1199915    
     +,   0.1313444    ,   0.1440044    ,   0.1577499    
     +,   0.1723472    ,   0.1876452    ,   0.2036598    
     +,   0.2206081    ,   0.2388546    ,   0.2587249    
     +,   0.2802397    ,   0.3028570    ,   0.3253970    
     +,   0.3462373    ,   0.3637670    ,   0.3768990    
     +,   0.3854274    ,   0.3900623    ,   0.3921680    
     +,   0.3933094    ,   0.3947646    ,   0.3971173    
     +,   0.4000355    ,   0.4023281    ,   0.4023245    
     +,   0.3984694    ,   0.3899079    ,   0.3768198    
     +,   0.3603520    ,   0.3421829    ,   0.3239329    
     +,   0.3066702    ,   0.2907554    ,   0.2760347    
     +,   0.2621929    ,   0.2490377    ,   0.2365843    
     +,   0.2249815    ,   0.2144043    ,   0.2049910    
     +,   0.1968366    ,   0.1899937    ,   0.1844606    
     +,   0.1801616    ,   0.1769336    ,   0.1745292    
     +,   0.1726379    ,   0.1709200    ,   0.1690447    
     +,   0.1667319    ,   0.1637847    ,   0.1601073    
     +,   0.1557003    ,   0.1506357    ,   0.1450224    
     +,   0.1389744    ,   0.1325934    ,   0.1259666    
     +,   0.1191781    ,   0.1123254    ,   0.1055282    
     +,   9.8927729E-02,   9.2676006E-02,   8.6917229E-02
     +,   8.1768960E-02,   7.7306867E-02,   7.3559001E-02
     +,   7.0507675E-02,   6.8097651E-02,   6.6247687E-02
     +,   6.4863235E-02,   6.3846536E-02,   6.3104019E-02
     +,   6.2550835E-02,   6.2113054E-02,   6.1728049E-02
     +,   6.1343852E-02,   6.0918752E-02,   6.0420442E-02
     +,   5.9825238E-02,   5.9117682E-02,   5.8289487E-02
     +,   5.7339288E-02,   5.6271274E-02,   5.5094387E-02
     +,   5.3821042E-02,   5.2466199E-02,   5.1045958E-02
     +,   4.9576603E-02,   4.8073735E-02,   4.6551492E-02
     +,   4.5021910E-02,   4.3494575E-02,   4.1976716E-02
     +,   4.0473025E-02,   3.8985927E-02,   3.7515968E-02
     +,   3.6062393E-02,   3.4623664E-02,   3.3197649E-02
     +,   3.1782437E-02,   3.0376811E-02,   2.8980155E-02
     +,   2.7592931E-02,   2.6216744E-02,   2.4854274E-02
     +,   2.3509013E-02,   2.2185180E-02,   2.0887585E-02
     +,   1.9621283E-02,   1.8391218E-02,   1.7202115E-02
     +,   1.6058329E-02,   1.4963659E-02,   1.3921109E-02
     +,   1.2932967E-02,   1.2000822E-02,   1.1125405E-02
     +,   1.0306742E-02,   9.5442338E-03,   8.8366829E-03
     +,   8.1823543E-03,   7.5790863E-03,   7.0244274E-03
     +,   6.5156841E-03,   6.0499436E-03,   5.6242184E-03
     +,   5.2355146E-03,   4.8808591E-03,   4.5573278E-03
     +,   4.2621158E-03,   3.9925869E-03,   3.7462369E-03
     +,   3.5207488E-03,   3.3140020E-03,   3.1240641E-03
     +,   2.9491775E-03,   2.7877649E-03,   2.6384301E-03
     +,   2.4999359E-03,   2.3711796E-03,   2.2511946E-03
     +,   2.1391399E-03,   2.0342800E-03,   1.9359645E-03
     +,   1.8436256E-03,   1.7567746E-03,   1.6749752E-03
     +,   1.5978430E-03,   1.5250437E-03,   1.4562808E-03
     +,   1.3912847E-03,   1.3298151E-03,   1.2716588E-03
     +,   1.2166209E-03,   1.1645216E-03,   1.1151945E-03
     +,   1.0684901E-03,   1.0242683E-03,   9.8239502E-04
     +,   9.4274513E-04,   9.0520323E-04,   8.6965674E-04
     +,   8.3599822E-04,   8.0412731E-04,   7.7394809E-04
     +,   7.4536609E-04,   7.1829127E-04,   6.9263822E-04
     +,   6.6832558E-04,   6.4527272E-04,   6.2340329E-04
     +,   6.0264568E-04,   5.8292854E-04,   5.6418683E-04
     +,   5.4635567E-04,   5.2937592E-04,   5.1318906E-04
     +,   4.9774192E-04,   4.8298229E-04,   4.6886294E-04
     +,   4.5533778E-04,   4.4236533E-04,   4.2990534E-04
     +,   4.1792094E-04,   4.0637865E-04,   3.9524611E-04
     +,   3.8449478E-04,   3.7409726E-04,   3.6402949E-04
     +,   3.5426833E-04,   3.4479401E-04,   3.3558707E-04
     +,   3.2663136E-04,   3.1791089E-04,   3.0941251E-04
     +,   3.0112322E-04,   2.9303259E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_hzonly_htt80_mass = Yx/4.64247781395349
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_hzonly_htt85_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.7666208E-03,   1.8393649E-03
     +,   1.9130766E-03,   1.9876126E-03,   2.0628250E-03
     +,   2.1385583E-03,   2.2146534E-03,   2.2909488E-03
     +,   2.3672790E-03,   2.4434805E-03,   2.5193889E-03
     +,   2.5948433E-03,   2.6696862E-03,   2.7437659E-03
     +,   2.8169388E-03,   2.8890704E-03,   2.9600360E-03
     +,   3.0297260E-03,   3.0980427E-03,   3.1649054E-03
     +,   3.2302539E-03,   3.2940449E-03,   3.3562542E-03
     +,   3.4168886E-03,   3.4759685E-03,   3.5335463E-03
     +,   3.5897011E-03,   3.6445360E-03,   3.6981863E-03
     +,   3.7508148E-03,   3.8026157E-03,   3.8538135E-03
     +,   3.9046612E-03,   3.9554453E-03,   4.0064827E-03
     +,   4.0581180E-03,   4.1107275E-03,   4.1647120E-03
     +,   4.2205015E-03,   4.2785462E-03,   4.3393238E-03
     +,   4.4033267E-03,   4.4710627E-03,   4.5430516E-03
     +,   4.6198228E-03,   4.7019063E-03,   4.7898279E-03
     +,   4.8841066E-03,   4.9852463E-03,   5.0937268E-03
     +,   5.2100006E-03,   5.3344849E-03,   5.4675494E-03
     +,   5.6095235E-03,   5.7606590E-03,   5.9211692E-03
     +,   6.0911765E-03,   6.2707383E-03,   6.4598289E-03
     +,   6.6583450E-03,   6.8661030E-03,   7.0828381E-03
     +,   7.3082061E-03,   7.5418041E-03,   7.7831778E-03
     +,   8.0317976E-03,   8.2871420E-03,   8.5486406E-03
     +,   8.8157635E-03,   9.0879789E-03,   9.3648378E-03
     +,   9.6459417E-03,   9.9310242E-03,   1.0219926E-02
     +,   1.0512656E-02,   1.0809422E-02,   1.1110619E-02
     +,   1.1416862E-02,   1.1729084E-02,   1.2048486E-02
     +,   1.2376576E-02,   1.2715242E-02,   1.3066734E-02
     +,   1.3433741E-02,   1.3819360E-02,   1.4227165E-02
     +,   1.4661144E-02,   1.5125769E-02,   1.5625834E-02
     +,   1.6166497E-02,   1.6753124E-02,   1.7391106E-02
     +,   1.8085752E-02,   1.8842127E-02,   1.9664880E-02
     +,   2.0557983E-02,   2.1524804E-02,   2.2567835E-02
     +,   2.3688920E-02,   2.4889043E-02,   2.6168704E-02
     +,   2.7527725E-02,   2.8965708E-02,   3.0481724E-02
     +,   3.2074686E-02,   3.3743363E-02,   3.5486396E-02
     +,   3.7302725E-02,   3.9192427E-02,   4.1157547E-02
     +,   4.3203302E-02,   4.5340165E-02,   4.7585234E-02
     +,   4.9964536E-02,   5.2514389E-02,   5.5284001E-02
     +,   5.8336742E-02,   6.1753836E-02,   6.5636255E-02
     +,   7.0107467E-02,   7.5310677E-02,   8.1397556E-02
     +,   8.8505782E-02,   9.6724235E-02,   0.1060546    
     +,   0.1163871    ,   0.1275210    ,   0.1392381    
     +,   0.1514316    ,   0.1642367    ,   0.1781030    
     +,   0.1937341    ,   0.2118923    ,   0.2331078    
     +,   0.2574216    ,   0.2842637    ,   0.3125404    
     +,   0.3408972    ,   0.3680442    ,   0.3929752    
     +,   0.4149946    ,   0.4335660    ,   0.4481271    
     +,   0.4580838    ,   0.4630910    ,   0.4634522    
     +,   0.4602473    ,   0.4549397    ,   0.4486287    
     +,   0.4415333    ,   0.4331292    ,   0.4228290    
     +,   0.4106071    ,   0.3971010    ,   0.3831922    
     +,   0.3694809    ,   0.3560337    ,   0.3424783    
     +,   0.3283047    ,   0.3131625    ,   0.2970437    
     +,   0.2803152    ,   0.2636014    ,   0.2475659    
     +,   0.2326774    ,   0.2190711    ,   0.2065658    
     +,   0.1948191    ,   0.1835381    ,   0.1726304    
     +,   0.1622336    ,   0.1526247    ,   0.1440775    
     +,   0.1367416    ,   0.1305926    ,   0.1254489    
     +,   0.1210396    ,   0.1170780    ,   0.1133189    
     +,   0.1095885    ,   0.1057922    ,   0.1019072    
     +,   9.7968690E-02,   9.4052739E-02,   9.0260230E-02
     +,   8.6700156E-02,   8.3473369E-02,   8.0658726E-02
     +,   7.8303441E-02,   7.6418467E-02,   7.4978076E-02
     +,   7.3924825E-02,   7.3177546E-02,   7.2640918E-02
     +,   7.2215065E-02,   7.1804620E-02,   7.1325369E-02
     +,   7.0708551E-02,   6.9902867E-02,   6.8874039E-02
     +,   6.7602985E-02,   6.6082940E-02,   6.4316437E-02
     +,   6.2312685E-02,   6.0086038E-02,   5.7654537E-02
     +,   5.5039920E-02,   5.2267708E-02,   4.9367368E-02
     +,   4.6371926E-02,   4.3317571E-02,   4.0242929E-02
     +,   3.7187286E-02,   3.4188751E-02,   3.1282686E-02
     +,   2.8500367E-02,   2.5867468E-02,   2.3403214E-02
     +,   2.1120289E-02,   1.9025210E-02,   1.7118553E-02
     +,   1.5395983E-02,   1.3849434E-02,   1.2468004E-02
     +,   1.1238891E-02,   1.0148425E-02,   9.1828117E-03
     +,   8.3286520E-03,   7.5732647E-03,   6.9050100E-03
     +,   6.3134395E-03,   5.7892674E-03,   5.3242981E-03
     +,   4.9113841E-03,   4.5443457E-03,   4.2177676E-03
     +,   3.9269296E-03,   3.6677069E-03,   3.4364574E-03
     +,   3.2299322E-03,   3.0452227E-03,   2.8797253E-03
     +,   2.7310930E-03,   2.5971900E-03,   2.4760920E-03
     +,   2.3660739E-03,   2.2655865E-03,   2.1732473E-03
     +,   2.0878324E-03,   2.0082812E-03,   1.9336648E-03
     +,   1.8631890E-03,   1.7961869E-03,   1.7321013E-03
     +,   1.6704708E-03,   1.6109233E-03,   1.5531676E-03
     +,   1.4969792E-03,   1.4421861E-03,   1.3886641E-03
     +,   1.3363307E-03,   1.2851347E-03,   1.2350458E-03
     +,   1.1860520E-03,   1.1381600E-03,   1.0913800E-03
     +,   1.0457300E-03,   1.0012317E-03,   9.5790962E-04
     +,   9.1578299E-04,   8.7486970E-04,   8.3518698E-04
     +,   7.9674862E-04,   7.5956096E-04,   7.2362734E-04
     +,   6.8894931E-04,   6.5552030E-04,   6.2333432E-04
     +,   5.9237692E-04,   5.6263484E-04,   5.3408748E-04
     +,   5.0671562E-04,   4.8049376E-04,   4.5539808E-04
     +,   4.3139953E-04,   4.0847095E-04,   3.8658132E-04
     +,   3.6569929E-04,   3.4579454E-04,   3.2683386E-04
     +,   3.0878614E-04,   2.9161791E-04,   2.7529788E-04
     +,   2.5979287E-04,   2.4507201E-04,   2.3110292E-04
     +,   2.1785556E-04,   2.0529873E-04,   1.9340342E-04
     +,   1.8213985E-04,   1.7148029E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_hzonly_htt85_mass = Yx/4.70839534883721
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_hzonly_htt90_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.5071859E-03,   1.5864546E-03
     +,   1.6692735E-03,   1.7556612E-03,   1.8456160E-03
     +,   1.9391150E-03,   2.0361112E-03,   2.1365331E-03
     +,   2.2402802E-03,   2.3472288E-03,   2.4572227E-03
     +,   2.5700752E-03,   2.6855720E-03,   2.8034663E-03
     +,   2.9234814E-03,   3.0453119E-03,   3.1686232E-03
     +,   3.2930535E-03,   3.4182172E-03,   3.5437038E-03
     +,   3.6690859E-03,   3.7939162E-03,   3.9177323E-03
     +,   4.0400722E-03,   4.1604564E-03,   4.2784121E-03
     +,   4.3934700E-03,   4.5051668E-03,   4.6130549E-03
     +,   4.7167027E-03,   4.8157056E-03,   4.9096812E-03
     +,   4.9982849E-03,   5.0812038E-03,   5.1581631E-03
     +,   5.2289362E-03,   5.2933344E-03,   5.3512226E-03
     +,   5.4025119E-03,   5.4471614E-03,   5.4851784E-03
     +,   5.5166297E-03,   5.5416184E-03,   5.5603045E-03
     +,   5.5728871E-03,   5.5796159E-03,   5.5807787E-03
     +,   5.5767042E-03,   5.5677546E-03,   5.5543301E-03
     +,   5.5368622E-03,   5.5158138E-03,   5.4916758E-03
     +,   5.4649687E-03,   5.4362370E-03,   5.4060589E-03
     +,   5.3750374E-03,   5.3438134E-03,   5.3130537E-03
     +,   5.2834689E-03,   5.2558030E-03,   5.2308538E-03
     +,   5.2094604E-03,   5.1925150E-03,   5.1809638E-03
     +,   5.1758117E-03,   5.1781177E-03,   5.1889950E-03
     +,   5.2096150E-03,   5.2411850E-03,   5.2849539E-03
     +,   5.3421902E-03,   5.4141721E-03,   5.5021569E-03
     +,   5.6073787E-03,   5.7310029E-03,   5.8741020E-03
     +,   6.0376222E-03,   6.2223747E-03,   6.4289840E-03
     +,   6.6578444E-03,   6.9091357E-03,   7.1827495E-03
     +,   7.4783308E-03,   7.7951988E-03,   8.1324261E-03
     +,   8.4887575E-03,   8.8627245E-03,   9.2525743E-03
     +,   9.6564004E-03,   1.0072168E-02,   1.0497725E-02
     +,   1.0930938E-02,   1.1369771E-02,   1.1812359E-02
     +,   1.2257069E-02,   1.2702679E-02,   1.3148379E-02
     +,   1.3593937E-02,   1.4039736E-02,   1.4486901E-02
     +,   1.4937277E-02,   1.5393584E-02,   1.5859352E-02
     +,   1.6339025E-02,   1.6837949E-02,   1.7362360E-02
     +,   1.7919431E-02,   1.8517299E-02,   1.9165125E-02
     +,   1.9873068E-02,   2.0652464E-02,   2.1515651E-02
     +,   2.2476150E-02,   2.3548229E-02,   2.4746813E-02
     +,   2.6086593E-02,   2.7581438E-02,   2.9242845E-02
     +,   3.1078747E-02,   3.3091851E-02,   3.5277706E-02
     +,   3.7623495E-02,   4.0107176E-02,   4.2697337E-02
     +,   4.5353625E-02,   4.8029274E-02,   5.0673515E-02
     +,   5.3235941E-02,   5.5670261E-02,   5.7939392E-02
     +,   6.0018998E-02,   6.1901912E-02,   6.3601285E-02
     +,   6.5154485E-02,   6.6627704E-02,   6.8120658E-02
     +,   6.9772437E-02,   7.1764991E-02,   7.4321441E-02
     +,   7.7694930E-02,   8.2144640E-02,   8.7900952E-02
     +,   9.5124260E-02,   0.1038713    ,   0.1140883    
     +,   0.1256392    ,   0.1383667    ,   0.1521714    
     +,   0.1670698    ,   0.1831998    ,   0.2007614    
     +,   0.2199191    ,   0.2407019    ,   0.2629210    
     +,   0.2861139    ,   0.3095180    ,   0.3321514    
     +,   0.3530721    ,   0.3718081    ,   0.3887319    
     +,   0.4050941    ,   0.4225845    ,   0.4426028    
     +,   0.4655463    ,   0.4903669    ,   0.5144981    
     +,   0.5342505    ,   0.5456469    ,   0.5455184    
     +,   0.5324938    ,   0.5074980    ,   0.4736293    
     +,   0.4354668    ,   0.3979580    ,   0.3651542    
     +,   0.3392690    ,   0.3204441    ,   0.3072782    
     +,   0.2977729    ,   0.2901657    ,   0.2833129    
     +,   0.2766150    ,   0.2697366    ,   0.2623888    
     +,   0.2543024    ,   0.2453251    ,   0.2355206    
     +,   0.2251701    ,   0.2146757    ,   0.2044216    
     +,   0.1946698    ,   0.1855222    ,   0.1769418    
     +,   0.1688053    ,   0.1609620    ,   0.1532769    
     +,   0.1456518    ,   0.1380276    ,   0.1303764    
     +,   0.1226901    ,   0.1149734    ,   0.1072429    
     +,   9.9532701E-02,   9.1900885E-02,   8.4428959E-02
     +,   7.7216804E-02,   7.0371009E-02,   6.3988738E-02
     +,   5.8142718E-02,   5.2871805E-02,   4.8178185E-02
     +,   4.4030342E-02,   4.0371265E-02,   3.7129775E-02
     +,   3.4231357E-02,   3.1606782E-02,   2.9197760E-02
     +,   2.6959816E-02,   2.4862504E-02,   2.2887141E-02
     +,   2.1024259E-02,   1.9270629E-02,   1.7626381E-02
     +,   1.6092697E-02,   1.4670391E-02,   1.3359077E-02
     +,   1.2156699E-02,   1.1059413E-02,   1.0061905E-02
     +,   9.1578355E-03,   8.3401185E-03,   7.6012653E-03
     +,   6.9337841E-03,   6.3304971E-03,   5.7845856E-03
     +,   5.2898126E-03,   4.8405929E-03,   4.4319793E-03
     +,   4.0596244E-03,   3.7197634E-03,   3.4091754E-03
     +,   3.1250881E-03,   2.8650914E-03,   2.6270966E-03
     +,   2.4092873E-03,   2.2100513E-03,   2.0279251E-03
     +,   1.8615777E-03,   1.7097953E-03,   1.5714341E-03
     +,   1.4454230E-03,   1.3307611E-03,   1.2265047E-03
     +,   1.1317577E-03,   1.0456789E-03,   9.6748577E-04
     +,   8.9644809E-04,   8.3188288E-04,   7.7316002E-04
     +,   7.1970461E-04,   6.7098945E-04,   6.2653224E-04
     +,   5.8589637E-04,   5.4869085E-04,   5.1456108E-04
     +,   4.8318907E-04,   4.5429301E-04,   4.2762136E-04
     +,   4.0294864E-04,   3.8007490E-04,   3.5882433E-04
     +,   3.3904068E-04,   3.2058469E-04,   3.0333281E-04
     +,   2.8717751E-04,   2.7202099E-04,   2.5777885E-04
     +,   2.4437404E-04,   2.3173977E-04,   2.1981497E-04
     +,   2.0854654E-04,   1.9788581E-04,   1.8779023E-04
     +,   1.7822045E-04,   1.6914216E-04,   1.6052360E-04
     +,   1.5233597E-04,   1.4455385E-04,   1.3715324E-04
     +,   1.3011305E-04,   1.2341305E-04,   1.1703557E-04
     +,   1.1096340E-04,   1.0518153E-04,   9.9675097E-05
     +,   9.4431169E-05,   8.9436806E-05,   8.4680643E-05
     +,   8.0151345E-05,   7.5838849E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_hzonly_htt90_mass = Yx/4.78084043181818
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_hzonly_htt95_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.6344684E-03,   1.6651079E-03
     +,   1.6954403E-03,   1.7254787E-03,   1.7552415E-03
     +,   1.7847520E-03,   1.8140366E-03,   1.8431279E-03
     +,   1.8720599E-03,   1.9008738E-03,   1.9296099E-03
     +,   1.9583148E-03,   1.9870354E-03,   2.0158216E-03
     +,   2.0447252E-03,   2.0737986E-03,   2.1030945E-03
     +,   2.1326658E-03,   2.1625657E-03,   2.1928442E-03
     +,   2.2235524E-03,   2.2547371E-03,   2.2864437E-03
     +,   2.3187164E-03,   2.3515925E-03,   2.3851080E-03
     +,   2.4192960E-03,   2.4541847E-03,   2.4897985E-03
     +,   2.5261568E-03,   2.5632784E-03,   2.6011763E-03
     +,   2.6398613E-03,   2.6793424E-03,   2.7196261E-03
     +,   2.7607176E-03,   2.8026230E-03,   2.8453474E-03
     +,   2.8889023E-03,   2.9332952E-03,   2.9785447E-03
     +,   3.0246740E-03,   3.0717114E-03,   3.1196955E-03
     +,   3.1686774E-03,   3.2187211E-03,   3.2699015E-03
     +,   3.3223121E-03,   3.3760660E-03,   3.4312936E-03
     +,   3.4881453E-03,   3.5467965E-03,   3.6074452E-03
     +,   3.6703157E-03,   3.7356534E-03,   3.8037319E-03
     +,   3.8748509E-03,   3.9493316E-03,   4.0275208E-03
     +,   4.1097826E-03,   4.1965009E-03,   4.2880750E-03
     +,   4.3849098E-03,   4.4874176E-03,   4.5960150E-03
     +,   4.7110911E-03,   4.8330445E-03,   4.9622199E-03
     +,   5.0989524E-03,   5.2435142E-03,   5.3961338E-03
     +,   5.5569680E-03,   5.7261079E-03,   5.9035411E-03
     +,   6.0891784E-03,   6.2828306E-03,   6.4841812E-03
     +,   6.6928035E-03,   6.9081620E-03,   7.1296077E-03
     +,   7.3563429E-03,   7.5874878E-03,   7.8220293E-03
     +,   8.0588777E-03,   8.2968343E-03,   8.5346550E-03
     +,   8.7710144E-03,   9.0045836E-03,   9.2340037E-03
     +,   9.4579412E-03,   9.6751247E-03,   9.8843267E-03
     +,   1.0084430E-02,   1.0274457E-02,   1.0453591E-02
     +,   1.0621185E-02,   1.0776825E-02,   1.0920316E-02
     +,   1.1051724E-02,   1.1171373E-02,   1.1279891E-02
     +,   1.1378174E-02,   1.1467412E-02,   1.1549074E-02
     +,   1.1624893E-02,   1.1696861E-02,   1.1767173E-02
     +,   1.1838220E-02,   1.1912528E-02,   1.1992726E-02
     +,   1.2081462E-02,   1.2181367E-02,   1.2294970E-02
     +,   1.2424659E-02,   1.2572568E-02,   1.2740567E-02
     +,   1.2930147E-02,   1.3142457E-02,   1.3378180E-02
     +,   1.3637619E-02,   1.3920690E-02,   1.4226968E-02
     +,   1.4555792E-02,   1.4906442E-02,   1.5278299E-02
     +,   1.5671043E-02,   1.6084984E-02,   1.6521255E-02
     +,   1.6982207E-02,   1.7471576E-02,   1.7994838E-02
     +,   1.8559244E-02,   1.9174041E-02,   1.9850260E-02
     +,   2.0600647E-02,   2.1439290E-02,   2.2380974E-02
     +,   2.3440612E-02,   2.4632460E-02,   2.5969230E-02
     +,   2.7460948E-02,   2.9114177E-02,   3.0931097E-02
     +,   3.2908697E-02,   3.5037953E-02,   3.7303809E-02
     +,   3.9685063E-02,   4.2154763E-02,   4.4681411E-02
     +,   4.7231171E-02,   4.9770091E-02,   5.2267611E-02
     +,   5.4700416E-02,   5.7056919E-02,   5.9340686E-02
     +,   6.1572798E-02,   6.3792326E-02,   6.6054069E-02
     +,   6.8422273E-02,   7.0961349E-02,   7.3725872E-02
     +,   7.6750934E-02,   8.0048308E-02,   8.3612062E-02
     +,   8.7436303E-02,   9.1541901E-02,   9.6004553E-02
     +,   0.1009716    ,   0.1066507    ,   0.1132624    
     +,   0.1209636    ,   0.1297680    ,   0.1395077    
     +,   0.1498678    ,   0.1605115    ,   0.1712615    
     +,   0.1822627    ,   0.1940326    ,   0.2073610    
     +,   0.2230873    ,   0.2418762    ,   0.2640982    
     +,   0.2897940    ,   0.3185688    ,   0.3493868    
     +,   0.3806241    ,   0.4108827    ,   0.4404626    
     +,   0.4723030    ,   0.5109617    ,   0.5595204    
     +,   0.6160871    ,   0.6723145    ,   0.7155058    
     +,   0.7339717    ,   0.7230037    ,   0.6876965    
     +,   0.6403455    ,   0.5939165    ,   0.5559707    
     +,   0.5267605    ,   0.5018952    ,   0.4767969    
     +,   0.4495589    ,   0.4209292    ,   0.3926059    
     +,   0.3656988    ,   0.3402210    ,   0.3153818    
     +,   0.2901747    ,   0.2639068    ,   0.2365002    
     +,   0.2084970    ,   0.1808369    ,   0.1545513    
     +,   0.1305101    ,   0.1092802    ,   9.1094419E-02
     +,   7.5900353E-02,   6.3443437E-02,   5.3355362E-02
     +,   4.5235671E-02,   3.8708292E-02,   3.3450872E-02
     +,   2.9202783E-02,   2.5759097E-02,   2.2958526E-02
     +,   2.0670868E-02,   1.8788250E-02,   1.7220162E-02
     +,   1.5891135E-02,   1.4739492E-02,   1.3716487E-02
     +,   1.2785227E-02,   1.1919326E-02,   1.1100952E-02
     +,   1.0319154E-02,   9.5681986E-03,   8.8459970E-03
     +,   8.1527913E-03,   7.4901665E-03,   6.8603172E-03
     +,   6.2654330E-03,   5.7073035E-03,   5.1871571E-03
     +,   4.7056014E-03,   4.2625945E-03,   3.8574708E-03
     +,   3.4890652E-03,   3.1558436E-03,   2.8559293E-03
     +,   2.5872362E-03,   2.3475662E-03,   2.1346495E-03
     +,   1.9461960E-03,   1.7799545E-03,   1.6337561E-03
     +,   1.5055295E-03,   1.3933121E-03,   1.2952746E-03
     +,   1.2097331E-03,   1.1351455E-03,   1.0701073E-03
     +,   1.0133537E-03,   9.6375990E-04,   9.2032191E-04
     +,   8.8215555E-04,   8.4848772E-04,   8.1864512E-04
     +,   7.9204264E-04,   7.6817651E-04,   7.4661709E-04
     +,   7.2699797E-04,   7.0900703E-04,   6.9238193E-04
     +,   6.7690376E-04,   6.6238770E-04,   6.4868259E-04
     +,   6.3566142E-04,   6.2322168E-04,   6.1127811E-04
     +,   5.9976231E-04,   5.8861770E-04,   5.7779957E-04
     +,   5.6727102E-04,   5.5700279E-04,   5.4697087E-04
     +,   5.3715549E-04,   5.2754115E-04,   5.1811396E-04
     +,   5.0886348E-04,   4.9977924E-04,   4.9085345E-04
     +,   4.8207780E-04,   4.7344583E-04,   4.6495043E-04
     +,   4.5658590E-04,   4.4834567E-04,   4.4022451E-04
     +,   4.3221633E-04,   4.2431618E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_hzonly_htt95_mass = Yx/4.89587509090909
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_hzonly_ttz100_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.0623615E-03,   4.1766618E-03
     +,   4.2896620E-03,   4.4011637E-03,   4.5109806E-03
     +,   4.6189320E-03,   4.7248602E-03,   4.8286137E-03
     +,   4.9300627E-03,   5.0290972E-03,   5.1256227E-03
     +,   5.2195638E-03,   5.3108670E-03,   5.3995010E-03
     +,   5.4854574E-03,   5.5687432E-03,   5.6493944E-03
     +,   5.7274601E-03,   5.8030151E-03,   5.8761509E-03
     +,   5.9469794E-03,   6.0156262E-03,   6.0822321E-03
     +,   6.1469558E-03,   6.2099560E-03,   6.2714107E-03
     +,   6.3315006E-03,   6.3904063E-03,   6.4483131E-03
     +,   6.5054037E-03,   6.5618539E-03,   6.6178348E-03
     +,   6.6735116E-03,   6.7290263E-03,   6.7845150E-03
     +,   6.8400945E-03,   6.8958607E-03,   6.9518904E-03
     +,   7.0082420E-03,   7.0649413E-03,   7.1220058E-03
     +,   7.1794107E-03,   7.2371205E-03,   7.2950707E-03
     +,   7.3531722E-03,   7.4113193E-03,   7.4693826E-03
     +,   7.5272201E-03,   7.5846594E-03,   7.6415301E-03
     +,   7.6976465E-03,   7.7528111E-03,   7.8068231E-03
     +,   7.8594871E-03,   7.9105990E-03,   7.9599731E-03
     +,   8.0074202E-03,   8.0527738E-03,   8.0958810E-03
     +,   8.1366040E-03,   8.1748385E-03,   8.2104914E-03
     +,   8.2435058E-03,   8.2738586E-03,   8.3015552E-03
     +,   8.3266348E-03,   8.3491746E-03,   8.3692838E-03
     +,   8.3871176E-03,   8.4028644E-03,   8.4167570E-03
     +,   8.4290551E-03,   8.4400633E-03,   8.4501216E-03
     +,   8.4596071E-03,   8.4689306E-03,   8.4785288E-03
     +,   8.4888767E-03,   8.5004689E-03,   8.5138381E-03
     +,   8.5295243E-03,   8.5481014E-03,   8.5701514E-03
     +,   8.5962769E-03,   8.6270906E-03,   8.6632147E-03
     +,   8.7052779E-03,   8.7539162E-03,   8.8097621E-03
     +,   8.8734524E-03,   8.9456225E-03,   9.0269018E-03
     +,   9.1179200E-03,   9.2192963E-03,   9.3316585E-03
     +,   9.4556110E-03,   9.5917732E-03,   9.7407475E-03
     +,   9.9031478E-03,   1.0079576E-02,   1.0270648E-02
     +,   1.0476970E-02,   1.0699167E-02,   1.0937851E-02
     +,   1.1193658E-02,   1.1467226E-02,   1.1759194E-02
     +,   1.2070184E-02,   1.2400846E-02,   1.2751836E-02
     +,   1.3123739E-02,   1.3517205E-02,   1.3932806E-02
     +,   1.4371119E-02,   1.4832679E-02,   1.5317999E-02
     +,   1.5827522E-02,   1.6361710E-02,   1.6920898E-02
     +,   1.7505465E-02,   1.8115735E-02,   1.8751964E-02
     +,   1.9414371E-02,   2.0103211E-02,   2.0818705E-02
     +,   2.1560965E-02,   2.2330198E-02,   2.3126457E-02
     +,   2.3949800E-02,   2.4800101E-02,   2.5677150E-02
     +,   2.6580408E-02,   2.7509181E-02,   2.8462181E-02
     +,   2.9437797E-02,   3.0433822E-02,   3.1447299E-02
     +,   3.2474611E-02,   3.3511464E-02,   3.4552865E-02
     +,   3.5593159E-02,   3.6626264E-02,   3.7645891E-02
     +,   3.8645860E-02,   3.9620269E-02,   4.0564071E-02
     +,   4.1473437E-02,   4.2345896E-02,   4.3180730E-02
     +,   4.3979298E-02,   4.4744890E-02,   4.5482598E-02
     +,   4.6199080E-02,   4.6902128E-02,   4.7599934E-02
     +,   4.8300393E-02,   4.9010370E-02,   4.9735054E-02
     +,   5.0477322E-02,   5.1237524E-02,   5.2013669E-02
     +,   5.2802041E-02,   5.3598482E-02,   5.4400343E-02
     +,   5.5209525E-02,   5.6035753E-02,   5.6901131E-02
     +,   5.7844821E-02,   5.8928255E-02,   6.0239594E-02
     +,   6.1897095E-02,   6.4050630E-02,   6.6880248E-02
     +,   7.0590332E-02,   7.5397737E-02,   8.1514716E-02
     +,   8.9124262E-02,   9.8349802E-02,   0.1092260    
     +,   0.1216807    ,   0.1355373    ,   0.1505513    
     +,   0.1664838    ,   0.1831965    ,   0.2007226    
     +,   0.2192713    ,   0.2391275    ,   0.2604677    
     +,   0.2831773    ,   0.3068061    ,   0.3307615    
     +,   0.3546985    ,   0.3789368    ,   0.4046255    
     +,   0.4334047    ,   0.4665562    ,   0.5041231    
     +,   0.5449123    ,   0.5879300    ,   0.6343057    
     +,   0.6875657    ,   0.7512492    ,   0.8258792    
     +,   0.9082297    ,   0.9930540    ,    1.075348    
     +,    1.153361    ,    1.232509    ,    1.324125    
     +,    1.433683    ,    1.547289    ,    1.633017    
     +,    1.658875    ,    1.609371    ,    1.486957    
     +,    1.305370    ,    1.086543    ,   0.8589213    
     +,   0.6504397    ,   0.4790418    ,   0.3488170    
     +,   0.2539807    ,   0.1855605    ,   0.1357726    
     +,   9.9182650E-02,   7.2213829E-02,   5.2411258E-02
     +,   3.7970375E-02,   2.7517881E-02,   2.0012919E-02
     +,   1.4678068E-02,   1.0934055E-02,   8.3438866E-03
     +,   6.5734750E-03,   5.3676926E-03,   4.5358869E-03
     +,   3.9416193E-03,   3.4924999E-03,   3.1297917E-03
     +,   2.8186820E-03,   2.5401614E-03,   2.2848793E-03
     +,   2.0489036E-03,   1.8310355E-03,   1.6312457E-03
     +,   1.4498109E-03,   1.2868475E-03,   1.1421095E-03
     +,   1.0149530E-03,   9.0438349E-04,   8.0911070E-04
     +,   7.2765932E-04,   6.5846974E-04,   5.9997349E-04
     +,   5.5065687E-04,   5.0911371E-04,   4.7407579E-04
     +,   4.4442358E-04,   4.1918686E-04,   3.9754153E-04
     +,   3.7879890E-04,   3.6238934E-04,   3.4784613E-04
     +,   3.3479187E-04,   3.2292466E-04,   3.1200360E-04
     +,   3.0183847E-04,   2.9228127E-04,   2.8321732E-04
     +,   2.7455832E-04,   2.6623730E-04,   2.5820496E-04
     +,   2.5042531E-04,   2.4287222E-04,   2.3552754E-04
     +,   2.2837985E-04,   2.2142135E-04,   2.1464817E-04
     +,   2.0805786E-04,   2.0165023E-04,   1.9542509E-04
     +,   1.8938340E-04,   1.8352531E-04,   1.7785154E-04
     +,   1.7236169E-04,   1.6705554E-04,   1.6193173E-04
     +,   1.5698846E-04,   1.5222367E-04,   1.4763419E-04
     +,   1.4321686E-04,   1.3896755E-04,   1.3488212E-04
     +,   1.3095561E-04,   1.2718322E-04,   1.2355938E-04
     +,   1.2007880E-04,   1.1673554E-04,   1.1352407E-04
     +,   1.1043829E-04,   1.0747253E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_hzonly_ttz100_mass = Yx/8.09413231914894
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_hzonly_ttz105_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  5.9202099E-03,   6.2226150E-03
     +,   6.5339687E-03,   6.8540769E-03,   7.1827192E-03
     +,   7.5196405E-03,   7.8645702E-03,   8.2172034E-03
     +,   8.5772015E-03,   8.9442320E-03,   9.3179094E-03
     +,   9.6978564E-03,   1.0083648E-02,   1.0474873E-02
     +,   1.0871090E-02,   1.1271852E-02,   1.1676704E-02
     +,   1.2085178E-02,   1.2496809E-02,   1.2911113E-02
     +,   1.3327610E-02,   1.3745807E-02,   1.4165207E-02
     +,   1.4585309E-02,   1.5005581E-02,   1.5425507E-02
     +,   1.5844524E-02,   1.6262056E-02,   1.6677506E-02
     +,   1.7090231E-02,   1.7499566E-02,   1.7904785E-02
     +,   1.8305123E-02,   1.8699771E-02,   1.9087870E-02
     +,   1.9468492E-02,   1.9840674E-02,   2.0203395E-02
     +,   2.0555627E-02,   2.0896252E-02,   2.1224197E-02
     +,   2.1538360E-02,   2.1837657E-02,   2.2121061E-02
     +,   2.2387601E-02,   2.2636412E-02,   2.2866772E-02
     +,   2.3078097E-02,   2.3270022E-02,   2.3442430E-02
     +,   2.3595456E-02,   2.3729546E-02,   2.3845492E-02
     +,   2.3944436E-02,   2.4027927E-02,   2.4097895E-02
     +,   2.4156710E-02,   2.4207130E-02,   2.4252329E-02
     +,   2.4295840E-02,   2.4341591E-02,   2.4393745E-02
     +,   2.4456749E-02,   2.4535220E-02,   2.4633840E-02
     +,   2.4757294E-02,   2.4910133E-02,   2.5096681E-02
     +,   2.5320919E-02,   2.5586318E-02,   2.5895799E-02
     +,   2.6251504E-02,   2.6654782E-02,   2.7106017E-02
     +,   2.7604602E-02,   2.8148901E-02,   2.8736083E-02
     +,   2.9362231E-02,   3.0022370E-02,   3.0710487E-02
     +,   3.1419564E-02,   3.2141872E-02,   3.2868847E-02
     +,   3.3591632E-02,   3.4300826E-02,   3.4987204E-02
     +,   3.5641491E-02,   3.6254860E-02,   3.6819097E-02
     +,   3.7326742E-02,   3.7771329E-02,   3.8147569E-02
     +,   3.8451470E-02,   3.8680360E-02,   3.8832992E-02
     +,   3.8909648E-02,   3.8911901E-02,   3.8842786E-02
     +,   3.8706467E-02,   3.8508352E-02,   3.8254611E-02
     +,   3.7952382E-02,   3.7609309E-02,   3.7233435E-02
     +,   3.6833119E-02,   3.6416609E-02,   3.5992227E-02
     +,   3.5567977E-02,   3.5151508E-02,   3.4750059E-02
     +,   3.4370441E-02,   3.4018807E-02,   3.3700977E-02
     +,   3.3422098E-02,   3.3186920E-02,   3.2999817E-02
     +,   3.2864716E-02,   3.2785244E-02,   3.2764930E-02
     +,   3.2806881E-02,   3.2914277E-02,   3.3089954E-02
     +,   3.3336807E-02,   3.3657469E-02,   3.4054436E-02
     +,   3.4529876E-02,   3.5085626E-02,   3.5722949E-02
     +,   3.6442589E-02,   3.7244428E-02,   3.8127415E-02
     +,   3.9089426E-02,   4.0127248E-02,   4.1236296E-02
     +,   4.2410877E-02,   4.3644145E-02,   4.4928100E-02
     +,   4.6253923E-02,   4.7612403E-02,   4.8994161E-02
     +,   5.0389942E-02,   5.1791258E-02,   5.3190731E-02
     +,   5.4582585E-02,   5.5962641E-02,   5.7328820E-02
     +,   5.8681190E-02,   6.0021669E-02,   6.1353866E-02
     +,   6.2682867E-02,   6.4014614E-02,   6.5355346E-02
     +,   6.6710949E-02,   6.8086773E-02,   6.9487147E-02
     +,   7.0914887E-02,   7.2371833E-02,   7.3858872E-02
     +,   7.5376727E-02,   7.6926216E-02,   7.8509659E-02
     +,   8.0131367E-02,   8.1798621E-02,   8.3522066E-02
     +,   8.5316911E-02,   8.7202877E-02,   8.9205205E-02
     +,   9.1355056E-02,   9.3690760E-02,   9.6258007E-02
     +,   9.9109069E-02,   0.1023016    ,   0.1058948    
     +,   0.1099433    ,   0.1144888    ,   0.1195543    
     +,   0.1251383    ,   0.1312177    ,   0.1377587    
     +,   0.1447399    ,   0.1521843    ,   0.1601931    
     +,   0.1689774    ,   0.1788749    ,   0.1903449    
     +,   0.2039346    ,   0.2202171    ,   0.2397131    
     +,   0.2627904    ,   0.2895694    ,   0.3198533    
     +,   0.3530928    ,   0.3883987    ,   0.4246051    
     +,   0.4603796    ,   0.4943663    ,   0.5253791    
     +,   0.5526244    ,   0.5759007    ,   0.5956634    
     +,   0.6128983    ,   0.6288162    ,   0.6444963    
     +,   0.6606444    ,   0.6775389    ,   0.6951150    
     +,   0.7130123    ,   0.7304745    ,   0.7461919    
     +,   0.7582158    ,   0.7641245    ,   0.7614160    
     +,   0.7479937    ,   0.7225634    ,   0.6848540    
     +,   0.6356871    ,   0.5769352    ,   0.5113585    
     +,   0.4423237    ,   0.3733905    ,   0.3078231    
     +,   0.2481847    ,   0.1961091    ,   0.1522685    
     +,   0.1165240    ,   8.8172875E-02,   6.6204064E-02
     +,   4.9505398E-02,   3.7005346E-02,   2.7753808E-02
     +,   2.0954436E-02,   1.5967008E-02,   1.2295435E-02
     +,   9.5688300E-03,   7.5192153E-03,   5.9582433E-03
     +,   4.7563137E-03,   3.8245842E-03,   3.1008213E-03
     +,   2.5395167E-03,   2.1057012E-03,   1.7713812E-03
     +,   1.5136618E-03,   1.3138464E-03,   1.1569601E-03
     +,   1.0313493E-03,   9.2823157E-04,   8.4121933E-04
     +,   7.6583773E-04,   6.9906894E-04,   6.3893182E-04
     +,   5.8416254E-04,   5.3396338E-04,   4.8781661E-04
     +,   4.4535971E-04,   4.0631022E-04,   3.7042468E-04
     +,   3.3747251E-04,   3.0722652E-04,   2.7946517E-04
     +,   2.5397696E-04,   2.3056228E-04,   2.0903604E-04
     +,   1.8923133E-04,   1.7100216E-04,   1.5421910E-04
     +,   1.3877000E-04,   1.2455885E-04,   1.1150203E-04
     +,   9.9525241E-05,   8.8562185E-05,   7.8552999E-05
     +,   6.9441783E-05,   6.1174695E-05,   5.3699830E-05
     +,   4.6967099E-05,   4.0926312E-05,   3.5528843E-05
     +,   3.0726063E-05,   2.6470976E-05,   2.2717193E-05
     +,   1.9420344E-05,   1.6537326E-05,   1.4027471E-05
     +,   1.1851963E-05,   9.9747094E-06,   8.3618907E-06
     +,   6.9823031E-06,   5.8074743E-06,   4.8113147E-06
     +,   3.9703923E-06,   3.2635442E-06,   2.6720083E-06
     +,   2.1790763E-06,   1.7701049E-06,   1.4322260E-06
     +,   1.1542928E-06,   9.2662901E-07,   7.4094839E-07
     +,   5.9014098E-07,   4.6818300E-07
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_hzonly_ttz105_mass = Yx/6.62839708695652
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_hzonly_ttz107_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  9.4386498E-03,   9.8704500E-03
     +,   1.0306592E-02,   1.0745928E-02,   1.1187255E-02
     +,   1.1629356E-02,   1.2071012E-02,   1.2510994E-02
     +,   1.2948096E-02,   1.3381165E-02,   1.3809084E-02
     +,   1.4230814E-02,   1.4645400E-02,   1.5051984E-02
     +,   1.5449837E-02,   1.5838340E-02,   1.6217029E-02
     +,   1.6585577E-02,   1.6943829E-02,   1.7291786E-02
     +,   1.7629592E-02,   1.7957585E-02,   1.8276233E-02
     +,   1.8586190E-02,   1.8888218E-02,   1.9183220E-02
     +,   1.9472241E-02,   1.9756392E-02,   2.0036904E-02
     +,   2.0315032E-02,   2.0592112E-02,   2.0869475E-02
     +,   2.1148480E-02,   2.1430429E-02,   2.1716621E-02
     +,   2.2008289E-02,   2.2306576E-02,   2.2612540E-02
     +,   2.2927169E-02,   2.3251297E-02,   2.3585698E-02
     +,   2.3930985E-02,   2.4287676E-02,   2.4656169E-02
     +,   2.5036756E-02,   2.5429633E-02,   2.5834905E-02
     +,   2.6252620E-02,   2.6682716E-02,   2.7125081E-02
     +,   2.7579589E-02,   2.8046032E-02,   2.8524170E-02
     +,   2.9013742E-02,   2.9514428E-02,   3.0025860E-02
     +,   3.0547597E-02,   3.1079160E-02,   3.1619970E-02
     +,   3.2169327E-02,   3.2726374E-02,   3.3290181E-02
     +,   3.3859536E-02,   3.4433138E-02,   3.5009425E-02
     +,   3.5586588E-02,   3.6162667E-02,   3.6735382E-02
     +,   3.7302334E-02,   3.7860818E-02,   3.8408082E-02
     +,   3.8941134E-02,   3.9456941E-02,   3.9952472E-02
     +,   4.0424675E-02,   4.0870640E-02,   4.1287698E-02
     +,   4.1673310E-02,   4.2025484E-02,   4.2342573E-02
     +,   4.2623427E-02,   4.2867590E-02,   4.3075200E-02
     +,   4.3247093E-02,   4.3384939E-02,   4.3491080E-02
     +,   4.3568674E-02,   4.3621533E-02,   4.3654203E-02
     +,   4.3671750E-02,   4.3679744E-02,   4.3684173E-02
     +,   4.3691114E-02,   4.3706771E-02,   4.3737251E-02
     +,   4.3788288E-02,   4.3865234E-02,   4.3972727E-02
     +,   4.4114787E-02,   4.4294395E-02,   4.4513669E-02
     +,   4.4773642E-02,   4.5074303E-02,   4.5414660E-02
     +,   4.5792695E-02,   4.6205521E-02,   4.6649527E-02
     +,   4.7120430E-02,   4.7613718E-02,   4.8124410E-02
     +,   4.8647631E-02,   4.9178548E-02,   4.9712665E-02
     +,   5.0245840E-02,   5.0774418E-02,   5.1295333E-02
     +,   5.1806074E-02,   5.2304599E-02,   5.2789442E-02
     +,   5.3259481E-02,   5.3713940E-02,   5.4152168E-02
     +,   5.4573674E-02,   5.4977842E-02,   5.5364050E-02
     +,   5.5731561E-02,   5.6079574E-02,   5.6407023E-02
     +,   5.6713127E-02,   5.6997009E-02,   5.7258058E-02
     +,   5.7496075E-02,   5.7711333E-02,   5.7904657E-02
     +,   5.8077674E-02,   5.8232706E-02,   5.8372855E-02
     +,   5.8501966E-02,   5.8624454E-02,   5.8745641E-02
     +,   5.8870792E-02,   5.9005767E-02,   5.9156321E-02
     +,   5.9328236E-02,   5.9526864E-02,   5.9757229E-02
     +,   6.0023565E-02,   6.0329501E-02,   6.0677629E-02
     +,   6.1069582E-02,   6.1505821E-02,   6.1985761E-02
     +,   6.2507577E-02,   6.3068546E-02,   6.3664861E-02
     +,   6.4292394E-02,   6.4946733E-02,   6.5623946E-02
     +,   6.6321485E-02,   6.7038544E-02,   6.7777321E-02
     +,   6.8543948E-02,   6.9348812E-02,   7.0207424E-02
     +,   7.1140565E-02,   7.2173871E-02,   7.3337279E-02
     +,   7.4663624E-02,   7.6187298E-02,   7.7942520E-02
     +,   7.9961568E-02,   8.2273543E-02,   8.4903926E-02
     +,   8.7875023E-02,   9.1206364E-02,   9.4917506E-02
     +,   9.9030212E-02,   0.1035711    ,   0.1085755    
     +,   0.1140914    ,   0.1201839    ,   0.1269397    
     +,   0.1344726    ,   0.1429264    ,   0.1524739    
     +,   0.1633048    ,   0.1756037    ,   0.1895178    
     +,   0.2051155    ,   0.2223566    ,   0.2410892    
     +,   0.2610856    ,   0.2821100    ,   0.3040076    
     +,   0.3267718    ,   0.3505493    ,   0.3755853    
     +,   0.4021128    ,   0.4302481    ,   0.4599219    
     +,   0.4908842    ,   0.5227775    ,   0.5552415    
     +,   0.5879583    ,   0.6206225    ,   0.6527941    
     +,   0.6836735    ,   0.7118959    ,   0.7354753    
     +,   0.7519748    ,   0.7588834    ,   0.7541261    
     +,   0.7365191    ,   0.7060484    ,   0.6638928    
     +,   0.6122280    ,   0.5538595    ,   0.4918144    
     +,   0.4289768    ,   0.3678254    ,   0.3102724    
     +,   0.2576376    ,   0.2106905    ,   0.1697441    
     +,   0.1347536    ,   0.1054225    ,   8.1288621E-02
     +,   6.1788697E-02,   4.6312336E-02,   3.4245238E-02
     +,   2.5000887E-02,   1.8041667E-02,   1.2892293E-02
     +,   9.1466121E-03,   6.4676306E-03,   4.5824745E-03
     +,   3.2758904E-03,   2.3820263E-03,   1.7759583E-03
     +,   1.3658040E-03,   1.0857616E-03,   8.9002110E-04
     +,   7.4766926E-04,   6.3857960E-04,   5.5019325E-04
     +,   4.7505903E-04,   4.0901569E-04,   3.4990947E-04
     +,   2.9673125E-04,   2.4905941E-04,   2.0670699E-04
     +,   1.6953574E-04,   1.3736318E-04,   1.0992462E-04
     +,   8.6871965E-05,   6.7793881E-05,   5.2241314E-05
     +,   3.9750706E-05,   2.9865801E-05,   2.2156188E-05
     +,   1.6229673E-05,   1.1738768E-05,   8.3835539E-06
     +,   5.9118292E-06,   4.1163635E-06,   2.8300751E-06
     +,   1.9211866E-06,   1.2877564E-06,   8.5230721E-07
     +,   5.5699530E-07,   3.5941267E-07,   2.2899572E-07
     +,   1.4406578E-07,   8.9492580E-08,   5.4890723E-08
     +,   3.3243793E-08,   1.9879607E-08,   1.1738289E-08
     +,   6.8436323E-09,   3.9397547E-09,   2.2394222E-09
     +,   1.2569104E-09,   6.9655626E-10,   3.8116224E-10
     +,   2.0594287E-10,   1.0987160E-10,   5.7878556E-11
     +,   3.0104585E-11,   1.5461412E-11,   7.8405902E-12
     +,   3.9260097E-12,   1.9410485E-12,   9.4759866E-13
     +,   4.5676717E-13,   2.1740442E-13,   1.0217019E-13
     +,   4.7411348E-14,   2.1723148E-14,   9.8280250E-15
     +,   4.3902781E-15,   1.9365191E-15
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_hzonly_ttz107_mass = Yx/6.29428753333333
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_hzonly_ttz110_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  8.9478623E-03,   9.5034717E-03
     +,   1.0080305E-02,   1.0677518E-02,   1.1294049E-02
     +,   1.1928633E-02,   1.2579778E-02,   1.3245806E-02
     +,   1.3924828E-02,   1.4614796E-02,   1.5313477E-02
     +,   1.6018502E-02,   1.6727386E-02,   1.7437546E-02
     +,   1.8146357E-02,   1.8851137E-02,   1.9549225E-02
     +,   2.0238005E-02,   2.0914920E-02,   2.1577504E-02
     +,   2.2223456E-02,   2.2850582E-02,   2.3456885E-02
     +,   2.4040617E-02,   2.4600163E-02,   2.5134200E-02
     +,   2.5641616E-02,   2.6121534E-02,   2.6573310E-02
     +,   2.6996560E-02,   2.7391110E-02,   2.7756976E-02
     +,   2.8094433E-02,   2.8403915E-02,   2.8686022E-02
     +,   2.8941566E-02,   2.9171459E-02,   2.9376762E-02
     +,   2.9558694E-02,   2.9718524E-02,   2.9857710E-02
     +,   2.9977672E-02,   3.0080050E-02,   3.0166456E-02
     +,   3.0238615E-02,   3.0298345E-02,   3.0347418E-02
     +,   3.0387729E-02,   3.0421186E-02,   3.0449742E-02
     +,   3.0475363E-02,   3.0500032E-02,   3.0525744E-02
     +,   3.0554505E-02,   3.0588280E-02,   3.0629043E-02
     +,   3.0678749E-02,   3.0739283E-02,   3.0812554E-02
     +,   3.0900352E-02,   3.1004373E-02,   3.1126318E-02
     +,   3.1267706E-02,   3.1429980E-02,   3.1614453E-02
     +,   3.1822167E-02,   3.2054063E-02,   3.2310784E-02
     +,   3.2592759E-02,   3.2900047E-02,   3.3232376E-02
     +,   3.3589110E-02,   3.3969227E-02,   3.4371234E-02
     +,   3.4793153E-02,   3.5232618E-02,   3.5686783E-02
     +,   3.6152292E-02,   3.6625445E-02,   3.7102208E-02
     +,   3.7578147E-02,   3.8048681E-02,   3.8509063E-02
     +,   3.8954496E-02,   3.9380305E-02,   3.9782010E-02
     +,   4.0155351E-02,   4.0496606E-02,   4.0802471E-02
     +,   4.1070409E-02,   4.1298531E-02,   4.1485764E-02
     +,   4.1631743E-02,   4.1737225E-02,   4.1803624E-02
     +,   4.1833289E-02,   4.1829396E-02,   4.1795824E-02
     +,   4.1737206E-02,   4.1658673E-02,   4.1565824E-02
     +,   4.1464608E-02,   4.1361149E-02,   4.1261677E-02
     +,   4.1172314E-02,   4.1098967E-02,   4.1047145E-02
     +,   4.1021947E-02,   4.1027859E-02,   4.1068662E-02
     +,   4.1147377E-02,   4.1266147E-02,   4.1426264E-02
     +,   4.1628029E-02,   4.1870758E-02,   4.2152971E-02
     +,   4.2472139E-02,   4.2824876E-02,   4.3207075E-02
     +,   4.3613851E-02,   4.4039730E-02,   4.4478718E-02
     +,   4.4924531E-02,   4.5370601E-02,   4.5810357E-02
     +,   4.6237230E-02,   4.6644934E-02,   4.7027547E-02
     +,   4.7379740E-02,   4.7696747E-02,   4.7974601E-02
     +,   4.8210215E-02,   4.8401572E-02,   4.8547525E-02
     +,   4.8648212E-02,   4.8704799E-02,   4.8719637E-02
     +,   4.8696354E-02,   4.8639502E-02,   4.8554949E-02
     +,   4.8449554E-02,   4.8331112E-02,   4.8208300E-02
     +,   4.8090558E-02,   4.7987808E-02,   4.7910396E-02
     +,   4.7868848E-02,   4.7873441E-02,   4.7934040E-02
     +,   4.8059855E-02,   4.8258893E-02,   4.8537891E-02
     +,   4.8901737E-02,   4.9353458E-02,   4.9893882E-02
     +,   5.0521709E-02,   5.1233489E-02,   5.2024063E-02
     +,   5.2886888E-02,   5.3814664E-02,   5.4800235E-02
     +,   5.5837724E-02,   5.6923192E-02,   5.8056038E-02
     +,   5.9239663E-02,   6.0482617E-02,   6.1798718E-02
     +,   6.3207410E-02,   6.4733833E-02,   6.6408232E-02
     +,   6.8265028E-02,   7.0342310E-02,   7.2681010E-02
     +,   7.5323790E-02,   7.8313917E-02,   8.1695490E-02
     +,   8.5511975E-02,   8.9805432E-02,   9.4614990E-02
     +,   9.9975213E-02,   0.1059129    ,   0.1124433    
     +,   0.1195663    ,   0.1272653    ,   0.1355059    
     +,   0.1442397    ,   0.1534122    ,   0.1629728    
     +,   0.1728860    ,   0.1831357    ,   0.1937273    
     +,   0.2046783    ,   0.2160024    ,   0.2276969    
     +,   0.2397354    ,   0.2520772    ,   0.2646883    
     +,   0.2775755    ,   0.2908184    ,   0.3045866    
     +,   0.3191278    ,   0.3347309    ,   0.3516691    
     +,   0.3701237    ,   0.3901140    ,   0.4114399    
     +,   0.4336487    ,   0.4560245    ,   0.4776201    
     +,   0.4973171    ,   0.5139144    ,   0.5262271    
     +,   0.5331869    ,   0.5339276    ,   0.5278449    
     +,   0.5146440    ,   0.4943712    ,   0.4674356    
     +,   0.4346112    ,   0.3970250    ,   0.3560901    
     +,   0.3134074    ,   0.2706303    ,   0.2293115    
     +,   0.1907623    ,   0.1559547    ,   0.1254795    
     +,   9.9552192E-02,   7.8067280E-02,   6.0682360E-02
     +,   4.6908770E-02,   3.6191307E-02,   2.7972572E-02
     +,   2.1737484E-02,   1.7037928E-02,   1.3500910E-02
     +,   1.0828137E-02,   8.7888585E-03,   7.2095105E-03
     +,   5.9628990E-03,   4.9582003E-03,   4.1320478E-03
     +,   3.4410483E-03,   2.8558520E-03,   2.3566899E-03
     +,   1.9300574E-03,   1.5663069E-03,   1.2580220E-03
     +,   9.9903520E-04,   7.8384334E-04,   6.0725282E-04
     +,   4.6429218E-04,   3.5021623E-04,   2.6054369E-04
     +,   1.9112672E-04,   1.3822209E-04,   9.8536075E-05
     +,   6.9237001E-05,   4.7948241E-05,   3.2724671E-05
     +,   2.2011158E-05,   1.4590829E-05,   9.5320593E-06
     +,   6.1371516E-06,   3.8944549E-06,   2.4357757E-06
     +,   1.5015854E-06,   9.1245499E-07,   5.4657443E-07
     +,   3.2275719E-07,   1.8788981E-07,   1.0783400E-07
     +,   6.1018021E-08,   3.4042074E-08,   1.8725503E-08
     +,   1.0156320E-08,   5.4314380E-09,   2.8641218E-09
     +,   1.4891859E-09,   7.6349632E-10,   3.8596035E-10
     +,   1.9238494E-10,   9.4550735E-11,   4.5818037E-11
     +,   2.1890424E-11,   1.0311620E-11,   4.7888421E-12
     +,   2.1925040E-12,   9.8960673E-13,   4.4031074E-13
     +,   1.9312466E-13,   8.3494355E-14,   3.5581486E-14
     +,   1.4945093E-14,   6.1871289E-15,   2.5243746E-15
     +,   1.0150848E-15,   4.0224785E-16,   1.5708615E-16
     +,   6.0449922E-17,   2.2923463E-17
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_hzonly_ttz110_mass = Yx/5.18116104545454
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_hzonly_ttz115_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  9.6676201E-03,   1.0239058E-02
     +,   1.0828617E-02,   1.1435723E-02,   1.2059698E-02
     +,   1.2699784E-02,   1.3355136E-02,   1.4024817E-02
     +,   1.4707770E-02,   1.5402902E-02,   1.6108977E-02
     +,   1.6824665E-02,   1.7548580E-02,   1.8279200E-02
     +,   1.9014958E-02,   1.9754177E-02,   2.0495102E-02
     +,   2.1235963E-02,   2.1974912E-02,   2.2710051E-02
     +,   2.3439528E-02,   2.4161479E-02,   2.4874035E-02
     +,   2.5575504E-02,   2.6264179E-02,   2.6938550E-02
     +,   2.7597204E-02,   2.8238995E-02,   2.8862894E-02
     +,   2.9468173E-02,   3.0054355E-02,   3.0621190E-02
     +,   3.1168761E-02,   3.1697426E-02,   3.2207847E-02
     +,   3.2700948E-02,   3.3177931E-02,   3.3640299E-02
     +,   3.4089752E-02,   3.4528185E-02,   3.4957729E-02
     +,   3.5380617E-02,   3.5799187E-02,   3.6215842E-02
     +,   3.6633030E-02,   3.7053127E-02,   3.7478387E-02
     +,   3.7911013E-02,   3.8352907E-02,   3.8805787E-02
     +,   3.9271027E-02,   3.9749645E-02,   4.0242158E-02
     +,   4.0748689E-02,   4.1268744E-02,   4.1801337E-02
     +,   4.2344883E-02,   4.2897098E-02,   4.3455198E-02
     +,   4.4015683E-02,   4.4574775E-02,   4.5127962E-02
     +,   4.5670480E-02,   4.6197332E-02,   4.6703301E-02
     +,   4.7183197E-02,   4.7632158E-02,   4.8045389E-02
     +,   4.8418783E-02,   4.8748776E-02,   4.9032599E-02
     +,   4.9268384E-02,   4.9455166E-02,   4.9592998E-02
     +,   4.9682911E-02,   4.9727000E-02,   4.9728133E-02
     +,   4.9690001E-02,   4.9616929E-02,   4.9513742E-02
     +,   4.9385481E-02,   4.9237236E-02,   4.9074009E-02
     +,   4.8900496E-02,   4.8720878E-02,   4.8538636E-02
     +,   4.8356593E-02,   4.8176654E-02,   4.7999818E-02
     +,   4.7826372E-02,   4.7655657E-02,   4.7486339E-02
     +,   4.7316480E-02,   4.7143638E-02,   4.6965044E-02
     +,   4.6777818E-02,   4.6579059E-02,   4.6366040E-02
     +,   4.6136308E-02,   4.5887850E-02,   4.5619115E-02
     +,   4.5329135E-02,   4.5017477E-02,   4.4684350E-02
     +,   4.4330429E-02,   4.3956846E-02,   4.3565199E-02
     +,   4.3157380E-02,   4.2735469E-02,   4.2301662E-02
     +,   4.1858282E-02,   4.1407436E-02,   4.0951237E-02
     +,   4.0491581E-02,   4.0030204E-02,   3.9568543E-02
     +,   3.9107945E-02,   3.8649417E-02,   3.8193941E-02
     +,   3.7742268E-02,   3.7295081E-02,   3.6853086E-02
     +,   3.6416903E-02,   3.5987195E-02,   3.5564698E-02
     +,   3.5150286E-02,   3.4744773E-02,   3.4349173E-02
     +,   3.3964485E-02,   3.3591870E-02,   3.3232417E-02
     +,   3.2887299E-02,   3.2557603E-02,   3.2244392E-02
     +,   3.1948678E-02,   3.1671394E-02,   3.1413335E-02
     +,   3.1175261E-02,   3.0957801E-02,   3.0761512E-02
     +,   3.0586837E-02,   3.0434296E-02,   3.0304275E-02
     +,   3.0197209E-02,   3.0113585E-02,   3.0053940E-02
     +,   3.0018907E-02,   3.0009277E-02,   3.0025970E-02
     +,   3.0070130E-02,   3.0143073E-02,   3.0246401E-02
     +,   3.0382007E-02,   3.0552031E-02,   3.0759024E-02
     +,   3.1005813E-02,   3.1295642E-02,   3.1632073E-02
     +,   3.2019045E-02,   3.2460772E-02,   3.2961715E-02
     +,   3.3526540E-02,   3.4159940E-02,   3.4866575E-02
     +,   3.5651021E-02,   3.6517739E-02,   3.7470847E-02
     +,   3.8514417E-02,   3.9652415E-02,   4.0889021E-02
     +,   4.2228613E-02,   4.3676268E-02,   4.5237910E-02
     +,   4.6920534E-02,   4.8731919E-02,   5.0680734E-02
     +,   5.2776035E-02,   5.5026237E-02,   5.7438217E-02
     +,   6.0016613E-02,   6.2762283E-02,   6.5671645E-02
     +,   6.8736114E-02,   7.1943052E-02,   7.5276569E-02
     +,   7.8720123E-02,   8.2259730E-02,   8.5889302E-02
     +,   8.9615762E-02,   9.3463980E-02,   9.7483687E-02
     +,   0.1017529    ,   0.1063803    ,   0.1115041    
     +,   0.1172874    ,   0.1239082    ,   0.1315442    
     +,   0.1403544    ,   0.1504588    ,   0.1619181    
     +,   0.1747154    ,   0.1887475    ,   0.2038244    
     +,   0.2196778    ,   0.2359781    ,   0.2523604    
     +,   0.2684494    ,   0.2838799    ,   0.2983142    
     +,   0.3114470    ,   0.3230039    ,   0.3327308    
     +,   0.3403853    ,   0.3457339    ,   0.3485525    
     +,   0.3486405    ,   0.3458397    ,   0.3400636    
     +,   0.3313164    ,   0.3197164    ,   0.3054976    
     +,   0.2890035    ,   0.2706687    ,   0.2509895    
     +,   0.2304864    ,   0.2096719    ,   0.1890198    
     +,   0.1689425    ,   0.1497735    ,   0.1317639    
     +,   0.1150858    ,   9.9837385E-02,   8.6054109E-02
     +,   7.3721863E-02,   6.2791102E-02,   5.3184975E-02
     +,   4.4810969E-02,   3.7568066E-02,   3.1351782E-02
     +,   2.6057344E-02,   2.1582918E-02,   1.7831361E-02
     +,   1.4710847E-02,   1.2135510E-02,   1.0026281E-02
     +,   8.3113033E-03,   6.9260467E-03,   5.8132997E-03
     +,   4.9232468E-03,   4.2132423E-03,   3.6472052E-03
     +,   3.1951815E-03,   2.8326935E-03,   2.5400028E-03
     +,   2.3013949E-03,   2.1045271E-03,   1.9398195E-03
     +,   1.7998834E-03,   1.6790517E-03,   1.5730042E-03
     +,   1.4784607E-03,   1.3929284E-03,   1.3145098E-03
     +,   1.2417670E-03,   1.1736213E-03,   1.1092597E-03
     +,   1.0480806E-03,   9.8965212E-04,   9.3367067E-04
     +,   8.7992777E-04,   8.2829077E-04,   7.7868463E-04
     +,   7.3107262E-04,   6.8543863E-04,   6.4178067E-04
     +,   6.0010538E-04,   5.6041189E-04,   5.2269897E-04
     +,   4.8695086E-04,   4.5314617E-04,   4.2124855E-04
     +,   3.9121503E-04,   3.6298961E-04,   3.3651202E-04
     +,   3.1171195E-04,   2.8851771E-04,   2.6685200E-04
     +,   2.4663587E-04,   2.2779182E-04,   2.1024050E-04
     +,   1.9390641E-04,   1.7871408E-04,   1.6459290E-04
     +,   1.5147359E-04,   1.3929191E-04,   1.2798562E-04
     +,   1.1749756E-04,   1.0777273E-04,   9.8760844E-05
     +,   9.0413771E-05,   8.2687598E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_hzonly_ttz115_mass = Yx/4.09159555813953
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_hzonly_ttz120_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.0794871E-02,   1.1375395E-02
     +,   1.1966436E-02,   1.2566683E-02,   1.3174761E-02
     +,   1.3789260E-02,   1.4408718E-02,   1.5031667E-02
     +,   1.5656605E-02,   1.6282063E-02,   1.6906556E-02
     +,   1.7528631E-02,   1.8146880E-02,   1.8759908E-02
     +,   1.9366400E-02,   1.9965101E-02,   2.0554779E-02
     +,   2.1134324E-02,   2.1702655E-02,   2.2258768E-02
     +,   2.2801764E-02,   2.3330783E-02,   2.3845047E-02
     +,   2.4343878E-02,   2.4826629E-02,   2.5292758E-02
     +,   2.5741776E-02,   2.6173292E-02,   2.6586961E-02
     +,   2.6982514E-02,   2.7359793E-02,   2.7718652E-02
     +,   2.8059075E-02,   2.8381122E-02,   2.8684936E-02
     +,   2.8970717E-02,   2.9238785E-02,   2.9489558E-02
     +,   2.9723518E-02,   2.9941283E-02,   3.0143498E-02
     +,   3.0330962E-02,   3.0504521E-02,   3.0665133E-02
     +,   3.0813808E-02,   3.0951623E-02,   3.1079736E-02
     +,   3.1199338E-02,   3.1311642E-02,   3.1417903E-02
     +,   3.1519357E-02,   3.1617250E-02,   3.1712789E-02
     +,   3.1807147E-02,   3.1901460E-02,   3.1996768E-02
     +,   3.2094084E-02,   3.2194331E-02,   3.2298289E-02
     +,   3.2406751E-02,   3.2520335E-02,   3.2639615E-02
     +,   3.2765094E-02,   3.2897126E-02,   3.3036098E-02
     +,   3.3182200E-02,   3.3335634E-02,   3.3496480E-02
     +,   3.3664797E-02,   3.3840481E-02,   3.4023378E-02
     +,   3.4213252E-02,   3.4409735E-02,   3.4612294E-02
     +,   3.4820281E-02,   3.5032898E-02,   3.5249133E-02
     +,   3.5467807E-02,   3.5687588E-02,   3.5906915E-02
     +,   3.6124058E-02,   3.6337133E-02,   3.6544118E-02
     +,   3.6742929E-02,   3.6931314E-02,   3.7107140E-02
     +,   3.7268262E-02,   3.7412595E-02,   3.7538197E-02
     +,   3.7643436E-02,   3.7726820E-02,   3.7787199E-02
     +,   3.7823830E-02,   3.7836250E-02,   3.7824411E-02
     +,   3.7788719E-02,   3.7729923E-02,   3.7649181E-02
     +,   3.7547968E-02,   3.7428182E-02,   3.7291896E-02
     +,   3.7141412E-02,   3.6979314E-02,   3.6808159E-02
     +,   3.6630690E-02,   3.6449537E-02,   3.6267269E-02
     +,   3.6086380E-02,   3.5909131E-02,   3.5737574E-02
     +,   3.5573456E-02,   3.5418209E-02,   3.5272915E-02
     +,   3.5138324E-02,   3.5014734E-02,   3.4902118E-02
     +,   3.4800015E-02,   3.4707595E-02,   3.4623738E-02
     +,   3.4546908E-02,   3.4475371E-02,   3.4407109E-02
     +,   3.4339998E-02,   3.4271739E-02,   3.4199964E-02
     +,   3.4122385E-02,   3.4036733E-02,   3.3940934E-02
     +,   3.3833068E-02,   3.3711467E-02,   3.3574741E-02
     +,   3.3421896E-02,   3.3252165E-02,   3.3065271E-02
     +,   3.2861181E-02,   3.2640327E-02,   3.2403406E-02
     +,   3.2151539E-02,   3.1886082E-02,   3.1608660E-02
     +,   3.1321224E-02,   3.1025965E-02,   3.0725243E-02
     +,   3.0421671E-02,   3.0118067E-02,   2.9817417E-02
     +,   2.9522959E-02,   2.9238103E-02,   2.8966501E-02
     +,   2.8712021E-02,   2.8478717E-02,   2.8270897E-02
     +,   2.8093064E-02,   2.7949868E-02,   2.7846126E-02
     +,   2.7786698E-02,   2.7776519E-02,   2.7820403E-02
     +,   2.7923029E-02,   2.8088823E-02,   2.8321832E-02
     +,   2.8625652E-02,   2.9003216E-02,   2.9456770E-02
     +,   2.9987706E-02,   3.0596543E-02,   3.1282667E-02
     +,   3.2044426E-02,   3.2879055E-02,   3.3782717E-02
     +,   3.4750417E-02,   3.5776109E-02,   3.6853038E-02
     +,   3.7973724E-02,   3.9130226E-02,   4.0314592E-02
     +,   4.1519083E-02,   4.2736627E-02,   4.3961301E-02
     +,   4.5188822E-02,   4.6417296E-02,   4.7647428E-02
     +,   4.8883252E-02,   5.0133046E-02,   5.1409353E-02
     +,   5.2729752E-02,   5.4117024E-02,   5.5599462E-02
     +,   5.7210833E-02,   5.8989588E-02,   6.0978819E-02
     +,   6.3224860E-02,   6.5775782E-02,   6.8679802E-02
     +,   7.1983337E-02,   7.5729124E-02,   7.9953618E-02
     +,   8.4685661E-02,   8.9945115E-02,   9.5742345E-02
     +,   0.1020771    ,   0.1089395    ,   0.1163109    
     +,   0.1241643    ,   0.1324636    ,   0.1411635    
     +,   0.1502075    ,   0.1595236    ,   0.1690201    
     +,   0.1785814    ,   0.1880626    ,   0.1972860    
     +,   0.2060418    ,   0.2140917    ,   0.2211760    
     +,   0.2270255    ,   0.2313782    ,   0.2339965    
     +,   0.2346858    ,   0.2333116    ,   0.2298119    
     +,   0.2242052    ,   0.2165929    ,   0.2071533    
     +,   0.1961315    ,   0.1838224    ,   0.1705552    
     +,   0.1566720    ,   0.1425086    ,   0.1283791    
     +,   0.1145647    ,   0.1013027    ,   8.8781789E-02
     +,   7.7141650E-02,   6.6475421E-02,   5.6831952E-02
     +,   4.8222777E-02,   4.0628720E-02,   3.4006000E-02
     +,   2.8292237E-02,   2.3412906E-02,   1.9286528E-02
     +,   1.5828807E-02,   1.2955789E-02,   1.0586951E-02
     +,   8.6472547E-03,   7.0682783E-03,   5.7888427E-03
     +,   4.7555077E-03,   3.9224620E-03,   3.2509726E-03
     +,   2.7088679E-03,   2.2698655E-03,   1.9127289E-03
     +,   1.6204824E-03,   1.3797085E-03,   1.1798930E-03
     +,   1.0128212E-03,   8.7208109E-04,   7.5267628E-04
     +,   6.5071060E-04,   5.6312350E-04,   4.8749306E-04
     +,   4.2189559E-04,   3.6479684E-04,   3.1495484E-04
     +,   2.7136138E-04,   2.3319419E-04,   1.9977333E-04
     +,   1.7052868E-04,   1.4497837E-04,   1.2271045E-04
     +,   1.0336572E-04,   8.6625223E-05,   7.2203431E-05
     +,   5.9843016E-05,   4.9307397E-05,   4.0381183E-05
     +,   3.2865544E-05,   2.6579490E-05,   2.1357146E-05
     +,   1.7048986E-05,   1.3519952E-05,   1.0650144E-05
     +,   8.3332416E-06,   6.4765632E-06,   4.9995974E-06
     +,   3.8333474E-06,   2.9193257E-06,   2.2082486E-06
     +,   1.6591863E-06,   1.2383337E-06,   9.1815593E-07
     +,   6.7634659E-07,   4.9507526E-07,   3.6016928E-07
     +,   2.6050520E-07,   1.8740243E-07,   1.3416886E-07
     +,   9.5675219E-08,   6.8034936E-08
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_hzonly_ttz120_mass = Yx/3.09123380487805
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_hzonly_ttz60_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  6.2781358E-03,   7.0590382E-03
     +,   7.9508061E-03,   8.9713382E-03,   1.0140298E-02
     +,   1.1478687E-02,   1.3008271E-02,   1.4751006E-02
     +,   1.6728440E-02,   1.8961523E-02,   2.1470338E-02
     +,   2.4274589E-02,   2.7394248E-02,   3.0850654E-02
     +,   3.4667742E-02,   3.8873300E-02,   4.3500345E-02
     +,   4.8588280E-02,   5.4184273E-02,   6.0344659E-02
     +,   6.7137033E-02,   7.4641965E-02,   8.2955971E-02
     +,   9.2194416E-02,   0.1024934    ,   0.1140144    
     +,   0.1269450    ,   0.1414990    ,   0.1579056    
     +,   0.1763888    ,   0.1971254    ,   0.2201953    
     +,   0.2455240    ,   0.2728429    ,   0.3016732    
     +,   0.3313507    ,   0.3610790    ,   0.3900040    
     +,   0.4173023    ,   0.4422554    ,   0.4643175    
     +,   0.4831379    ,   0.4985346    ,   0.5104060    
     +,   0.5186089    ,   0.5228660    ,   0.5227472    
     +,   0.5177781    ,   0.5076341    ,   0.4923519    
     +,   0.4724550    ,   0.4489179    ,   0.4229854    
     +,   0.3959182    ,   0.3687756    ,   0.3423037    
     +,   0.3169581    ,   0.2930026    ,   0.2706110    
     +,   0.2499353    ,   0.2311123    ,   0.2142361    
     +,   0.1993249    ,   0.1862971    ,   0.1749744    
     +,   0.1651004    ,   0.1563694    ,   0.1484630    
     +,   0.1410843    ,   0.1339897    ,   0.1270077    
     +,   0.1200469    ,   0.1130887    ,   0.1061725    
     +,   9.9371038E-02,   9.2769787E-02,   8.6449116E-02
     +,   8.0472104E-02,   7.4879400E-02,   6.9690041E-02
     +,   6.4905792E-02,   6.0515344E-02,   5.6500953E-02
     +,   5.2841321E-02,   4.9515512E-02,   4.6503592E-02
     +,   4.3787479E-02,   4.1350413E-02,   3.9176632E-02
     +,   3.7250400E-02,   3.5555873E-02,   3.4076884E-02
     +,   3.2796793E-02,   3.1698607E-02,   3.0765306E-02
     +,   2.9980330E-02,   2.9327653E-02,   2.8792277E-02
     +,   2.8360300E-02,   2.8019186E-02,   2.7757838E-02
     +,   2.7566548E-02,   2.7436974E-02,   2.7362056E-02
     +,   2.7335854E-02,   2.7353445E-02,   2.7410716E-02
     +,   2.7504226E-02,   2.7631041E-02,   2.7788606E-02
     +,   2.7974609E-02,   2.8186912E-02,   2.8423307E-02
     +,   2.8681651E-02,   2.8959593E-02,   2.9254701E-02
     +,   2.9564302E-02,   2.9885549E-02,   3.0215399E-02
     +,   3.0550646E-02,   3.0887963E-02,   3.1223930E-02
     +,   3.1555161E-02,   3.1878319E-02,   3.2190256E-02
     +,   3.2488070E-02,   3.2769226E-02,   3.3031531E-02
     +,   3.3273380E-02,   3.3493616E-02,   3.3691742E-02
     +,   3.3867791E-02,   3.4022417E-02,   3.4156807E-02
     +,   3.4272663E-02,   3.4372117E-02,   3.4457579E-02
     +,   3.4531776E-02,   3.4597408E-02,   3.4657229E-02
     +,   3.4713786E-02,   3.4769390E-02,   3.4825839E-02
     +,   3.4884531E-02,   3.4946229E-02,   3.5011034E-02
     +,   3.5078391E-02,   3.5147071E-02,   3.5215192E-02
     +,   3.5280250E-02,   3.5339277E-02,   3.5388827E-02
     +,   3.5425227E-02,   3.5444625E-02,   3.5443164E-02
     +,   3.5417125E-02,   3.5363071E-02,   3.5278019E-02
     +,   3.5159457E-02,   3.5005558E-02,   3.4815244E-02
     +,   3.4588136E-02,   3.4324702E-02,   3.4026239E-02
     +,   3.3694766E-02,   3.3333022E-02,   3.2944411E-02
     +,   3.2532897E-02,   3.2102797E-02,   3.1658776E-02
     +,   3.1205673E-02,   3.0748298E-02,   3.0291367E-02
     +,   2.9839307E-02,   2.9396219E-02,   2.8965611E-02
     +,   2.8550459E-02,   2.8153049E-02,   2.7774982E-02
     +,   2.7417017E-02,   2.7079176E-02,   2.6760763E-02
     +,   2.6460346E-02,   2.6175804E-02,   2.5904436E-02
     +,   2.5643131E-02,   2.5388325E-02,   2.5136184E-02
     +,   2.4882786E-02,   2.4624120E-02,   2.4356350E-02
     +,   2.4075782E-02,   2.3779066E-02,   2.3463307E-02
     +,   2.3126036E-02,   2.2765299E-02,   2.2379823E-02
     +,   2.1968914E-02,   2.1532441E-02,   2.1070899E-02
     +,   2.0585395E-02,   2.0077543E-02,   1.9549403E-02
     +,   1.9003429E-02,   1.8442459E-02,   1.7869534E-02
     +,   1.7287843E-02,   1.6700713E-02,   1.6111461E-02
     +,   1.5523325E-02,   1.4939373E-02,   1.4362552E-02
     +,   1.3795554E-02,   1.3240756E-02,   1.2700241E-02
     +,   1.2175793E-02,   1.1668869E-02,   1.1180558E-02
     +,   1.0711627E-02,   1.0262583E-02,   9.8336115E-03
     +,   9.4246343E-03,   9.0353675E-03,   8.6653437E-03
     +,   8.3138878E-03,   7.9802116E-03,   7.6634488E-03
     +,   7.3626488E-03,   7.0768129E-03,   6.8049245E-03
     +,   6.5459823E-03,   6.2990170E-03,   6.0630790E-03
     +,   5.8372663E-03,   5.6207660E-03,   5.4128021E-03
     +,   5.2126721E-03,   5.0197588E-03,   4.8335120E-03
     +,   4.6534380E-03,   4.4791093E-03,   4.3101688E-03
     +,   4.1463142E-03,   3.9872816E-03,   3.8328529E-03
     +,   3.6828578E-03,   3.5371564E-03,   3.3956284E-03
     +,   3.2581768E-03,   3.1247332E-03,   2.9952328E-03
     +,   2.8696195E-03,   2.7478545E-03,   2.6298997E-03
     +,   2.5157155E-03,   2.4052602E-03,   2.2984988E-03
     +,   2.1953948E-03,   2.0959012E-03,   1.9999680E-03
     +,   1.9075479E-03,   1.8185875E-03,   1.7330257E-03
     +,   1.6507957E-03,   1.5718376E-03,   1.4960762E-03
     +,   1.4234366E-03,   1.3538444E-03,   1.2872220E-03
     +,   1.2234865E-03,   1.1625529E-03,   1.1043393E-03
     +,   1.0487618E-03,   9.9573331E-04,   9.4516604E-04
     +,   8.9697761E-04,   8.5107912E-04,   8.0738892E-04
     +,   7.6582067E-04,   7.2629377E-04,   6.8872434E-04
     +,   6.5303483E-04,   6.1914488E-04,   5.8697962E-04
     +,   5.5646262E-04,   5.2752311E-04,   5.0008908E-04
     +,   4.7409127E-04,   4.4946483E-04,   4.2614355E-04
     +,   4.0406687E-04,   3.8317329E-04,   3.6340629E-04
     +,   3.4470877E-04,   3.2702819E-04,   3.1031205E-04
     +,   2.9451185E-04,   2.7957908E-04,   2.6546919E-04
     +,   2.5213783E-04,   2.3954411E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_hzonly_ttz60_mass = Yx/4.80727165116279
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_hzonly_ttz65_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.2033944E-03,   3.4036264E-03
     +,   3.6174171E-03,   3.8458770E-03,   4.0901308E-03
     +,   4.3512899E-03,   4.6304162E-03,   4.9285009E-03
     +,   5.2464283E-03,   5.5849878E-03,   5.9448476E-03
     +,   6.3266000E-03,   6.7308238E-03,   7.1581858E-03
     +,   7.6095848E-03,   8.0863526E-03,   8.5905138E-03
     +,   9.1250809E-03,   9.6943676E-03,   1.0304337E-02
     +,   1.0962917E-02,   1.1680217E-02,   1.2468675E-02
     +,   1.3343109E-02,   1.4320415E-02,   1.5419523E-02
     +,   1.6660960E-02,   1.8066797E-02,   1.9660888E-02
     +,   2.1469703E-02,   2.3524074E-02,   2.5861740E-02
     +,   2.8530708E-02,   3.1592764E-02,   3.5126124E-02
     +,   3.9225832E-02,   4.4000544E-02,   4.9564354E-02
     +,   5.6024775E-02,   6.3467123E-02,   7.1943015E-02
     +,   8.1464231E-02,   9.2009850E-02,   0.1035459    
     +,   0.1160514    ,   0.1295427    ,   0.1440813    
     +,   0.1597647    ,   0.1767050    ,   0.1950181    
     +,   0.2148420    ,   0.2363828    ,   0.2599536    
     +,   0.2859411    ,   0.3146423    ,   0.3459955    
     +,   0.3792984    ,   0.4130987    ,   0.4453890    
     +,   0.4741100    ,   0.4977832    ,   0.5160112    
     +,   0.5296066    ,   0.5402768    ,   0.5499511    
     +,   0.5599917    ,   0.5705991    ,   0.5806469    
     +,   0.5880631    ,   0.5905759    ,   0.5865360    
     +,   0.5754000    ,   0.5577469    ,   0.5349155    
     +,   0.5085412    ,   0.4802192    ,   0.4513291    
     +,   0.4229413    ,   0.3957537    ,   0.3700519    
     +,   0.3457390    ,   0.3224361    ,   0.2996691    
     +,   0.2770633    ,   0.2545027    ,   0.2321849    
     +,   0.2105709    ,   0.1902342    ,   0.1716957    
     +,   0.1552861    ,   0.1410941    ,   0.1289935    
     +,   0.1187177    ,   0.1099493    ,   0.1023913    
     +,   9.5804356E-02,   9.0011716E-02,   8.4888399E-02
     +,   8.0340199E-02,   7.6289803E-02,   7.2665878E-02
     +,   6.9401607E-02,   6.6434346E-02,   6.3708983E-02
     +,   6.1178796E-02,   5.8806572E-02,   5.6564551E-02
     +,   5.4433372E-02,   5.2400686E-02,   5.0460082E-02
     +,   4.8609808E-02,   4.6851095E-02,   4.5187399E-02
     +,   4.3622941E-02,   4.2162079E-02,   4.0808495E-02
     +,   3.9565027E-02,   3.8433157E-02,   3.7413377E-02
     +,   3.6504921E-02,   3.5706051E-02,   3.5014234E-02
     +,   3.4426019E-02,   3.3937186E-02,   3.3542670E-02
     +,   3.3236586E-02,   3.3012155E-02,   3.2861736E-02
     +,   3.2776780E-02,   3.2748021E-02,   3.2765638E-02
     +,   3.2819342E-02,   3.2898709E-02,   3.2993414E-02
     +,   3.3093486E-02,   3.3189628E-02,   3.3273324E-02
     +,   3.3337194E-02,   3.3374999E-02,   3.3381809E-02
     +,   3.3354104E-02,   3.3289593E-02,   3.3187363E-02
     +,   3.3047616E-02,   3.2871649E-02,   3.2661676E-02
     +,   3.2420635E-02,   3.2152034E-02,   3.1859800E-02
     +,   3.1548120E-02,   3.1221248E-02,   3.0883433E-02
     +,   3.0538760E-02,   3.0191142E-02,   2.9844109E-02
     +,   2.9500876E-02,   2.9164283E-02,   2.8836697E-02
     +,   2.8520033E-02,   2.8215786E-02,   2.7924960E-02
     +,   2.7648062E-02,   2.7385242E-02,   2.7136169E-02
     +,   2.6900100E-02,   2.6675962E-02,   2.6462335E-02
     +,   2.6257588E-02,   2.6059827E-02,   2.5867095E-02
     +,   2.5677340E-02,   2.5488559E-02,   2.5298873E-02
     +,   2.5106577E-02,   2.4910223E-02,   2.4708673E-02
     +,   2.4501178E-02,   2.4287321E-02,   2.4067160E-02
     +,   2.3841061E-02,   2.3609806E-02,   2.3374481E-02
     +,   2.3136428E-02,   2.2897156E-02,   2.2658283E-02
     +,   2.2421444E-02,   2.2188192E-02,   2.1959899E-02
     +,   2.1737682E-02,   2.1522371E-02,   2.1314379E-02
     +,   2.1113712E-02,   2.0919915E-02,   2.0732151E-02
     +,   2.0549033E-02,   2.0368855E-02,   2.0189509E-02
     +,   2.0008612E-02,   1.9823527E-02,   1.9631475E-02
     +,   1.9429641E-02,   1.9215219E-02,   1.8985525E-02
     +,   1.8738065E-02,   1.8470664E-02,   1.8181454E-02
     +,   1.7868983E-02,   1.7532257E-02,   1.7170779E-02
     +,   1.6784500E-02,   1.6373886E-02,   1.5939888E-02
     +,   1.5483943E-02,   1.5007844E-02,   1.4513788E-02
     +,   1.4004294E-02,   1.3482140E-02,   1.2950270E-02
     +,   1.2411746E-02,   1.1869727E-02,   1.1327314E-02
     +,   1.0787548E-02,   1.0253365E-02,   9.7275386E-03
     +,   9.2125833E-03,   8.7107653E-03,   8.2241176E-03
     +,   7.7543724E-03,   7.3029301E-03,   6.8708933E-03
     +,   6.4590932E-03,   6.0680783E-03,   5.6980988E-03
     +,   5.3491611E-03,   5.0210790E-03,   4.7134385E-03
     +,   4.4256551E-03,   4.1570272E-03,   3.9067287E-03
     +,   3.6738408E-03,   3.4573765E-03,   3.2563293E-03
     +,   3.0696741E-03,   2.8963736E-03,   2.7354120E-03
     +,   2.5858122E-03,   2.4466394E-03,   2.3169983E-03
     +,   2.1960516E-03,   2.0830326E-03,   1.9772244E-03
     +,   1.8779733E-03,   1.7846921E-03,   1.6968552E-03
     +,   1.6139834E-03,   1.5356538E-03,   1.4614959E-03
     +,   1.3911835E-03,   1.3244264E-03,   1.2609699E-03
     +,   1.2005954E-03,   1.1431116E-03,   1.0883469E-03
     +,   1.0361507E-03,   9.8639459E-04,   9.3895872E-04
     +,   8.9373620E-04,   8.5063220E-04,   8.0956018E-04
     +,   7.7043596E-04,   7.3318213E-04,   6.9772662E-04
     +,   6.6400005E-04,   6.3193421E-04,   6.0146232E-04
     +,   5.7252211E-04,   5.4504914E-04,   5.1898358E-04
     +,   4.9426313E-04,   4.7083039E-04,   4.4862527E-04
     +,   4.2759228E-04,   4.0767409E-04,   3.8881754E-04
     +,   3.7096822E-04,   3.5407572E-04,   3.3808933E-04
     +,   3.2296008E-04,   3.0864240E-04,   2.9509046E-04
     +,   2.8226199E-04,   2.7011480E-04,   2.5861038E-04
     +,   2.4771038E-04,   2.3737982E-04,   2.2758404E-04
     +,   2.1829156E-04,   2.0947153E-04,   2.0109583E-04
     +,   1.9313686E-04,   1.8556986E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_hzonly_ttz65_mass = Yx/5.37902065909091
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_hzonly_ttz70_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.5145602E-03,   1.6085857E-03
     +,   1.7082356E-03,   1.8138760E-03,   1.9259015E-03
     +,   2.0447341E-03,   2.1708268E-03,   2.3046655E-03
     +,   2.4467616E-03,   2.5976659E-03,   2.7579479E-03
     +,   2.9282067E-03,   3.1090614E-03,   3.3011467E-03
     +,   3.5051047E-03,   3.7215764E-03,   3.9511938E-03
     +,   4.1945670E-03,   4.4522700E-03,   4.7248285E-03
     +,   5.0127087E-03,   5.3162994E-03,   5.6358976E-03
     +,   5.9717293E-03,   6.3238763E-03,   6.6923653E-03
     +,   7.0770984E-03,   7.4779070E-03,   7.8945719E-03
     +,   8.3268471E-03,   8.7745208E-03,   9.2374645E-03
     +,   9.7157052E-03,   1.0209499E-02,   1.0719408E-02
     +,   1.1246388E-02,   1.1791847E-02,   1.2357697E-02
     +,   1.2946449E-02,   1.3561124E-02,   1.4205394E-02
     +,   1.4883517E-02,   1.5600390E-02,   1.6361715E-02
     +,   1.7174227E-02,   1.8046139E-02,   1.8987849E-02
     +,   2.0012883E-02,   2.1139130E-02,   2.2390194E-02
     +,   2.3796801E-02,   2.5397878E-02,   2.7241023E-02
     +,   2.9382333E-02,   3.1884618E-02,   3.4815438E-02
     +,   3.8243879E-02,   4.2237945E-02,   4.6863280E-02
     +,   5.2184276E-02,   5.8267832E-02,   6.5189995E-02
     +,   7.3044211E-02,   8.1954733E-02,   9.2095308E-02
     +,   0.1037178    ,   0.1171915    ,   0.1330262    
     +,   0.1518533    ,   0.1743158    ,   0.2008765    
     +,   0.2315827    ,   0.2659129    ,   0.3027829    
     +,   0.3407918    ,   0.3786315    ,   0.4155449    
     +,   0.4516159    ,   0.4876576    ,   0.5246229    
     +,   0.5627735    ,   0.6011464    ,   0.6377245    
     +,   0.6703420    ,   0.6976416    ,   0.7193762    
     +,   0.7358472    ,   0.7471550    ,   0.7529709    
     +,   0.7527844    ,   0.7460391    ,   0.7319069    
     +,   0.7092956    ,   0.6775750    ,   0.6375826    
     +,   0.5919237    ,   0.5441656    ,   0.4976675    
     +,   0.4548222    ,   0.4169483    ,   0.3844181    
     +,   0.3568136    ,   0.3330821    ,   0.3118177    
     +,   0.2916230    ,   0.2714630    ,   0.2508890    
     +,   0.2300504    ,   0.2095102    ,   0.1899735    
     +,   0.1720522    ,   0.1561343    ,   0.1423723    
     +,   0.1307210    ,   0.1210024    ,   0.1129560    
     +,   0.1062876    ,   0.1007063    ,   9.5957771E-02
     +,   9.1842592E-02,   8.8222392E-02,   8.5012302E-02
     +,   8.2163997E-02,   7.9646826E-02,   7.7432886E-02
     +,   7.5488202E-02,   7.3771201E-02,   7.2236083E-02
     +,   7.0838876E-02,   6.9543235E-02,   6.8323396E-02
     +,   6.7165270E-02,   6.6064440E-02,   6.5023363E-02
     +,   6.4047061E-02,   6.3140467E-02,   6.2305734E-02
     +,   6.1540689E-02,   6.0838535E-02,   6.0188200E-02
     +,   5.9575155E-02,   5.8982491E-02,   5.8392197E-02
     +,   5.7786282E-02,   5.7148058E-02,   5.6462850E-02
     +,   5.5719014E-02,   5.4908264E-02,   5.4026268E-02
     +,   5.3072263E-02,   5.2049123E-02,   5.0962966E-02
     +,   4.9822357E-02,   4.8637666E-02,   4.7420289E-02
     +,   4.6182062E-02,   4.4934452E-02,   4.3687992E-02
     +,   4.2452067E-02,   4.1234676E-02,   4.0042318E-02
     +,   3.8880024E-02,   3.7751697E-02,   3.6660135E-02
     +,   3.5607439E-02,   3.4595020E-02,   3.3624068E-02
     +,   3.2695614E-02,   3.1810544E-02,   3.0969687E-02
     +,   3.0173941E-02,   2.9424075E-02,   2.8720712E-02
     +,   2.8064227E-02,   2.7454726E-02,   2.6891904E-02
     +,   2.6374962E-02,   2.5902720E-02,   2.5473434E-02
     +,   2.5084889E-02,   2.4734426E-02,   2.4418984E-02
     +,   2.4135189E-02,   2.3879377E-02,   2.3647679E-02
     +,   2.3436110E-02,   2.3240631E-02,   2.3057152E-02
     +,   2.2881655E-02,   2.2710199E-02,   2.2538939E-02
     +,   2.2364242E-02,   2.2182589E-02,   2.1990728E-02
     +,   2.1785641E-02,   2.1564575E-02,   2.1325096E-02
     +,   2.1065112E-02,   2.0782879E-02,   2.0477038E-02
     +,   2.0146625E-02,   1.9791164E-02,   1.9410526E-02
     +,   1.9005027E-02,   1.8575445E-02,   1.8122911E-02
     +,   1.7648928E-02,   1.7155351E-02,   1.6644351E-02
     +,   1.6118303E-02,   1.5579746E-02,   1.5031440E-02
     +,   1.4476179E-02,   1.3916774E-02,   1.3355986E-02
     +,   1.2796550E-02,   1.2241068E-02,   1.1691957E-02
     +,   1.1151426E-02,   1.0621534E-02,   1.0104052E-02
     +,   9.6004903E-03,   9.1121616E-03,   8.6401245E-03
     +,   8.1851650E-03,   7.7478373E-03,   7.3285205E-03
     +,   6.9273929E-03,   6.5444275E-03,   6.1794543E-03
     +,   5.8321897E-03,   5.5022412E-03,   5.1891040E-03
     +,   4.8922035E-03,   4.6109511E-03,   4.3446841E-03
     +,   4.0927292E-03,   3.8544184E-03,   3.6290856E-03
     +,   3.4160616E-03,   3.2146950E-03,   3.0243741E-03
     +,   2.8445090E-03,   2.6745307E-03,   2.5138999E-03
     +,   2.3621197E-03,   2.2187212E-03,   2.0832559E-03
     +,   1.9553059E-03,   1.8344894E-03,   1.7204372E-03
     +,   1.6128033E-03,   1.5112690E-03,   1.4155339E-03
     +,   1.3253065E-03,   1.2403113E-03,   1.1602925E-03
     +,   1.0850044E-03,   1.0142085E-03,   9.4767561E-04
     +,   8.8519044E-04,   8.2654576E-04,   7.7153801E-04
     +,   7.1997166E-04,   6.7166355E-04,   6.2643172E-04
     +,   5.8410241E-04,   5.4451072E-04,   5.0749804E-04
     +,   4.7291059E-04,   4.4060062E-04,   4.1042973E-04
     +,   3.8226563E-04,   3.5598059E-04,   3.3145346E-04
     +,   3.0857197E-04,   2.8722704E-04,   2.6731848E-04
     +,   2.4874925E-04,   2.3143078E-04,   2.1527756E-04
     +,   2.0021200E-04,   1.8615925E-04,   1.7305139E-04
     +,   1.6082345E-04,   1.4941653E-04,   1.3877466E-04
     +,   1.2884592E-04,   1.1958303E-04,   1.1094081E-04
     +,   1.0287864E-04,   9.5357522E-05,   8.8342458E-05
     +,   8.1799873E-05,   7.5699543E-05,   7.0012480E-05
     +,   6.4712563E-05,   5.9774669E-05,   5.5176100E-05
     +,   5.0895051E-05,   4.6911697E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_hzonly_ttz70_mass = Yx/6.15931353333333
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_hzonly_ttz75_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  7.8543951E-04,   8.1077724E-04
     +,   8.3663088E-04,   8.6301571E-04,   8.8995096E-04
     +,   9.1745943E-04,   9.4556884E-04,   9.7431237E-04
     +,   1.0037291E-03,   1.0338668E-03,   1.0647801E-03
     +,   1.0965333E-03,   1.1292023E-03,   1.1628749E-03
     +,   1.1976525E-03,   1.2336532E-03,   1.2710118E-03
     +,   1.3098830E-03,   1.3504432E-03,   1.3928944E-03
     +,   1.4374646E-03,   1.4844117E-03,   1.5340276E-03
     +,   1.5866433E-03,   1.6426268E-03,   1.7023982E-03
     +,   1.7664271E-03,   1.8352452E-03,   1.9094523E-03
     +,   1.9897290E-03,   2.0768461E-03,   2.1716845E-03
     +,   2.2752462E-03,   2.3886787E-03,   2.5132953E-03
     +,   2.6505995E-03,   2.8023126E-03,   2.9703910E-03
     +,   3.1570764E-03,   3.3648729E-03,   3.5966171E-03
     +,   3.8554454E-03,   4.1448134E-03,   4.4684689E-03
     +,   4.8304196E-03,   5.2348715E-03,   5.6861448E-03
     +,   6.1885645E-03,   6.7463177E-03,   7.3633073E-03
     +,   8.0429493E-03,   8.7880036E-03,   9.6003581E-03
     +,   1.0480944E-02,   1.1429425E-02,   1.2444356E-02
     +,   1.3522964E-02,   1.4661380E-02,   1.5854742E-02
     +,   1.7097535E-02,   1.8383972E-02,   1.9708484E-02
     +,   2.1066159E-02,   2.2453425E-02,   2.3868496E-02
     +,   2.5311610E-02,   2.6785694E-02,   2.8296206E-02
     +,   2.9851655E-02,   3.1463310E-02,   3.3146080E-02
     +,   3.4918375E-02,   3.6803924E-02,   3.8832616E-02
     +,   4.1043401E-02,   4.3486975E-02,   4.6228856E-02
     +,   4.9352147E-02,   5.2958980E-02,   5.7167836E-02
     +,   6.2106498E-02,   6.7903109E-02,   7.4675992E-02
     +,   8.2535192E-02,   9.1595411E-02,   0.1020067    
     +,   0.1139757    ,   0.1277604    ,   0.1436068    
     +,   0.1616623    ,   0.1819250    ,   0.2043090    
     +,   0.2288135    ,   0.2556440    ,   0.2851178    
     +,   0.3173894    ,   0.3523032    ,   0.3895795    
     +,   0.4291537    ,   0.4711346    ,   0.5152641    
     +,   0.5603340    ,   0.6044977    ,   0.6469844    
     +,   0.6899561    ,   0.7371141    ,   0.7881035    
     +,   0.8345271    ,   0.8645212    ,   0.8727334    
     +,   0.8642415    ,   0.8476803    ,   0.8262898    
     +,   0.7971562    ,   0.7574875    ,   0.7087685    
     +,   0.6549653    ,   0.5995031    ,   0.5453153    
     +,   0.4959104    ,   0.4543961    ,   0.4214276    
     +,   0.3947749    ,   0.3708877    ,   0.3468038    
     +,   0.3211612    ,   0.2942077    ,   0.2672431    
     +,   0.2418692    ,   0.2193767    ,   0.2004188    
     +,   0.1850056    ,   0.1726811    ,   0.1627704    
     +,   0.1545824    ,   0.1475356    ,   0.1412015    
     +,   0.1352903    ,   0.1296149    ,   0.1240557    
     +,   0.1185412    ,   0.1130389    ,   0.1075529    
     +,   0.1021198    ,   9.6801065E-02,   9.1669604E-02
     +,   8.6798109E-02,   8.2248643E-02,   7.8066416E-02
     +,   7.4277163E-02,   7.0888557E-02,   6.7892507E-02
     +,   6.5268107E-02,   6.2984407E-02,   6.1003052E-02
     +,   5.9280697E-02,   5.7771455E-02,   5.6428764E-02
     +,   5.5208217E-02,   5.4069858E-02,   5.2979976E-02
     +,   5.1912639E-02,   5.0850753E-02,   4.9786013E-02
     +,   4.8718166E-02,   4.7653977E-02,   4.6605583E-02
     +,   4.5588627E-02,   4.4620246E-02,   4.3717463E-02
     +,   4.2895574E-02,   4.2167120E-02,   4.1540824E-02
     +,   4.1021220E-02,   4.0608536E-02,   4.0298481E-02
     +,   4.0082593E-02,   3.9948713E-02,   3.9881255E-02
     +,   3.9861906E-02,   3.9870180E-02,   3.9884251E-02
     +,   3.9881542E-02,   3.9839610E-02,   3.9736915E-02
     +,   3.9553560E-02,   3.9272103E-02,   3.8878243E-02
     +,   3.8361281E-02,   3.7714709E-02,   3.6936305E-02
     +,   3.6028285E-02,   3.4997150E-02,   3.3853415E-02
     +,   3.2610931E-02,   3.1286325E-02,   2.9898295E-02
     +,   2.8466752E-02,   2.7011821E-02,   2.5553141E-02
     +,   2.4109220E-02,   2.2696726E-02,   2.1329947E-02
     +,   2.0020518E-02,   1.8777430E-02,   1.7606724E-02
     +,   1.6511779E-02,   1.5493602E-02,   1.4551031E-02
     +,   1.3681104E-02,   1.2879485E-02,   1.2140900E-02
     +,   1.1459481E-02,   1.0829033E-02,   1.0243395E-02
     +,   9.6966960E-03,   9.1835037E-03,   8.6988918E-03
     +,   8.2385913E-03,   7.7990252E-03,   7.3772506E-03
     +,   6.9709453E-03,   6.5783947E-03,   6.1983969E-03
     +,   5.8301645E-03,   5.4732729E-03,   5.1276106E-03
     +,   4.7932854E-03,   4.4705281E-03,   4.1596759E-03
     +,   3.8611246E-03,   3.5752752E-03,   3.3024834E-03
     +,   3.0430485E-03,   2.7972232E-03,   2.5651457E-03
     +,   2.3468612E-03,   2.1423320E-03,   1.9514265E-03
     +,   1.7739013E-03,   1.6094326E-03,   1.4576298E-03
     +,   1.3180320E-03,   1.1901137E-03,   1.0733020E-03
     +,   9.6699910E-04,   8.7058003E-04,   7.8339892E-04
     +,   7.0480566E-04,   6.3416135E-04,   5.7082920E-04
     +,   5.1419094E-04,   4.6365452E-04,   4.1865354E-04
     +,   3.7864855E-04,   3.4313320E-04,   3.1163773E-04
     +,   2.8372646E-04,   2.5899682E-04,   2.3708105E-04
     +,   2.1764646E-04,   2.0039266E-04,   1.8504840E-04
     +,   1.7137181E-04,   1.5914944E-04,   1.4819122E-04
     +,   1.3833039E-04,   1.2942162E-04,   1.2133828E-04
     +,   1.1397021E-04,   1.0722240E-04,   1.0101370E-04
     +,   9.5274707E-05,   8.9945912E-05,   8.4976884E-05
     +,   8.0325422E-05,   7.5955344E-05,   7.1836854E-05
     +,   6.7944384E-05,   6.4257023E-05,   6.0756847E-05
     +,   5.7429188E-05,   5.4261422E-05,   5.1243256E-05
     +,   4.8365597E-05,   4.5621087E-05,   4.3003081E-05
     +,   4.0505816E-05,   3.8124475E-05,   3.5854380E-05
     +,   3.3691609E-05,   3.1632215E-05,   2.9672821E-05
     +,   2.7809916E-05,   2.6040381E-05,   2.4360967E-05
     +,   2.2768723E-05,   2.1260506E-05,   1.9833453E-05
     +,   1.8484510E-05,   1.7210848E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_hzonly_ttz75_mass = Yx/6.46994934782609
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_hzonly_ttz80_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  7.0893398E-04,   7.3711044E-04
     +,   7.6668127E-04,   7.9772284E-04,   8.3031651E-04
     +,   8.6454762E-04,   9.0050645E-04,   9.3828869E-04
     +,   9.7799511E-04,   1.0197341E-03,   1.0636186E-03
     +,   1.1097685E-03,   1.1583117E-03,   1.2093820E-03
     +,   1.2631216E-03,   1.3196804E-03,   1.3792156E-03
     +,   1.4418917E-03,   1.5078809E-03,   1.5773617E-03
     +,   1.6505184E-03,   1.7275405E-03,   1.8086189E-03
     +,   1.8939507E-03,   1.9837241E-03,   2.0781325E-03
     +,   2.1773584E-03,   2.2815745E-03,   2.3909402E-03
     +,   2.5055967E-03,   2.6256640E-03,   2.7512333E-03
     +,   2.8823640E-03,   3.0190777E-03,   3.1613531E-03
     +,   3.3091248E-03,   3.4622729E-03,   3.6206220E-03
     +,   3.7839494E-03,   3.9519542E-03,   4.1242950E-03
     +,   4.3005613E-03,   4.4802916E-03,   4.6629705E-03
     +,   4.8480434E-03,   5.0349184E-03,   5.2229841E-03
     +,   5.4116179E-03,   5.6002084E-03,   5.7881693E-03
     +,   5.9749633E-03,   6.1601182E-03,   6.3432548E-03
     +,   6.5241195E-03,   6.7025805E-03,   6.8786880E-03
     +,   7.0526567E-03,   7.2249151E-03,   7.3961047E-03
     +,   7.5670960E-03,   7.7389879E-03,   7.9131257E-03
     +,   8.0910679E-03,   8.2746074E-03,   8.4657418E-03
     +,   8.6666336E-03,   8.8796299E-03,   9.1071855E-03
     +,   9.3518849E-03,   9.6163694E-03,   9.9033574E-03
     +,   1.0215580E-02,   1.0555825E-02,   1.0926869E-02
     +,   1.1331530E-02,   1.1772702E-02,   1.2253316E-02
     +,   1.2776441E-02,   1.3345364E-02,   1.3963736E-02
     +,   1.4635586E-02,   1.5365727E-02,   1.6159855E-02
     +,   1.7025085E-02,   1.7970178E-02,   1.9006319E-02
     +,   2.0147299E-02,   2.1410309E-02,   2.2815786E-02
     +,   2.4387656E-02,   2.6152622E-02,   2.8138891E-02
     +,   3.0374659E-02,   3.2886598E-02,   3.5698563E-02
     +,   3.8832065E-02,   4.2310677E-02,   4.6167266E-02
     +,   5.0457496E-02,   5.5274051E-02,   6.0761254E-02
     +,   6.7119189E-02,   7.4596658E-02,   8.3466545E-02
     +,   9.3997344E-02,   0.1064292    ,   0.1209702    
     +,   0.1378097    ,   0.1571276    ,   0.1790568    
     +,   0.2035831    ,   0.2304109    ,   0.2588813    
     +,   0.2881149    ,   0.3174513    ,   0.3470635    
     +,   0.3782708    ,   0.4131319    ,   0.4533898    
     +,   0.4994906    ,   0.5503692    ,   0.6040871    
     +,   0.6586899    ,   0.7125425    ,   0.7643915    
     +,   0.8139933    ,   0.8624439    ,   0.9099205    
     +,   0.9518105    ,   0.9784347    ,   0.9812095    
     +,   0.9601989    ,   0.9260132    ,   0.8943498    
     +,   0.8747736    ,   0.8611363    ,   0.8369735    
     +,   0.7938129    ,   0.7396275    ,   0.6872590    
     +,   0.6404637    ,   0.5947837    ,   0.5477598    
     +,   0.5034267    ,   0.4673961    ,   0.4406729    
     +,   0.4191158    ,   0.3974198    ,   0.3727042    
     +,   0.3450810    ,   0.3161727    ,   0.2876226    
     +,   0.2605581    ,   0.2357062    ,   0.2135698    
     +,   0.1944337    ,   0.1782964    ,   0.1648772    
     +,   0.1537236    ,   0.1443488    ,   0.1363204    
     +,   0.1292877    ,   0.1229667    ,   0.1171207    
     +,   0.1115567    ,   0.1061360    ,   0.1007858    
     +,   9.5501639E-02,   9.0334974E-02,   8.5372224E-02
     +,   8.0709375E-02,   7.6428659E-02,   7.2583258E-02
     +,   6.9191188E-02,   6.6237472E-02,   6.3681409E-02
     +,   6.1467592E-02,   5.9536390E-02,   5.7832517E-02
     +,   5.6310520E-02,   5.4937370E-02,   5.3692348E-02
     +,   5.2564755E-02,   5.1550869E-02,   5.0650470E-02
     +,   4.9863972E-02,   4.9189977E-02,   4.8623454E-02
     +,   4.8154976E-02,   4.7770549E-02,   4.7451701E-02
     +,   4.7176354E-02,   4.6919666E-02,   4.6655219E-02
     +,   4.6356183E-02,   4.5996483E-02,   4.5552056E-02
     +,   4.5001775E-02,   4.4328284E-02,   4.3518648E-02
     +,   4.2564850E-02,   4.1463885E-02,   4.0217638E-02
     +,   3.8832624E-02,   3.7319675E-02,   3.5693046E-02
     +,   3.3969864E-02,   3.2169484E-02,   3.0312510E-02
     +,   2.8420050E-02,   2.6513053E-02,   2.4611872E-02
     +,   2.2735585E-02,   2.0901466E-02,   1.9124815E-02
     +,   1.7418884E-02,   1.5794564E-02,   1.4260316E-02
     +,   1.2822312E-02,   1.1484655E-02,   1.0249263E-02
     +,   9.1162007E-03,   8.0839824E-03,   7.1496968E-03
     +,   6.3092094E-03,   5.5574910E-03,   4.8888722E-03
     +,   4.2972304E-03,   3.7761489E-03,   3.3191477E-03
     +,   2.9198613E-03,   2.5721316E-03,   2.2700790E-03
     +,   2.0082155E-03,   1.7815065E-03,   1.5853464E-03
     +,   1.4155988E-03,   1.2685942E-03,   1.1411001E-03
     +,   1.0302842E-03,   9.3369622E-04,   8.4923347E-04
     +,   7.7509793E-04,   7.0975552E-04,   6.5190764E-04
     +,   6.0046220E-04,   5.5449904E-04,   5.1324215E-04
     +,   4.7604030E-04,   4.4234967E-04,   4.1171012E-04
     +,   3.8373485E-04,   3.5809912E-04,   3.3452839E-04
     +,   3.1278832E-04,   2.9267950E-04,   2.7403288E-04
     +,   2.5670324E-04,   2.4056426E-04,   2.2550681E-04
     +,   2.1143659E-04,   1.9827134E-04,   1.8593772E-04
     +,   1.7437110E-04,   1.6351507E-04,   1.5331828E-04
     +,   1.4373469E-04,   1.3472345E-04,   1.2624740E-04
     +,   1.1827228E-04,   1.1076679E-04,   1.0370262E-04
     +,   9.7053729E-05,   9.0795562E-05,   8.4905332E-05
     +,   7.9362449E-05,   7.4146934E-05,   6.9240807E-05
     +,   6.4626489E-05,   6.0288152E-05,   5.6210294E-05
     +,   5.2378819E-05,   4.8779973E-05,   4.5401201E-05
     +,   4.2230182E-05,   3.9255690E-05,   3.6466790E-05
     +,   3.3853139E-05,   3.1405183E-05,   2.9113511E-05
     +,   2.6969561E-05,   2.4964862E-05,   2.3091679E-05
     +,   2.1342410E-05,   1.9710063E-05,   1.8187789E-05
     +,   1.6769291E-05,   1.5448390E-05,   1.4219405E-05
     +,   1.3076778E-05,   1.2015370E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_hzonly_ttz80_mass = Yx/7.48225434782609
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_hzonly_ttz85_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  9.2050305E-04,   9.5826009E-04
     +,   9.9750131E-04,   1.0382801E-03,   1.0806506E-03
     +,   1.1246685E-03,   1.1703911E-03,   1.2178764E-03
     +,   1.2671838E-03,   1.3183758E-03,   1.3715134E-03
     +,   1.4266595E-03,   1.4838782E-03,   1.5432332E-03
     +,   1.6047885E-03,   1.6686093E-03,   1.7347594E-03
     +,   1.8033019E-03,   1.8742984E-03,   1.9478095E-03
     +,   2.0238936E-03,   2.1026051E-03,   2.1839957E-03
     +,   2.2681162E-03,   2.3550058E-03,   2.4447066E-03
     +,   2.5372494E-03,   2.6326615E-03,   2.7309617E-03
     +,   2.8321620E-03,   2.9362685E-03,   3.0432770E-03
     +,   3.1531765E-03,   3.2659490E-03,   3.3815666E-03
     +,   3.4999985E-03,   3.6212031E-03,   3.7451340E-03
     +,   3.8717473E-03,   4.0009846E-03,   4.1328003E-03
     +,   4.2671398E-03,   4.4039581E-03,   4.5432150E-03
     +,   4.6848799E-03,   4.8289355E-03,   4.9753771E-03
     +,   5.1242206E-03,   5.2755019E-03,   5.4292781E-03
     +,   5.5856383E-03,   5.7446873E-03,   5.9065651E-03
     +,   6.0714409E-03,   6.2394966E-03,   6.4109541E-03
     +,   6.5860422E-03,   6.7650112E-03,   6.9481162E-03
     +,   7.1356185E-03,   7.3277662E-03,   7.5247977E-03
     +,   7.7269133E-03,   7.9342872E-03,   8.1470441E-03
     +,   8.3652362E-03,   8.5888663E-03,   8.8178338E-03
     +,   9.0519749E-03,   9.2910100E-03,   9.5345918E-03
     +,   9.7822417E-03,   1.0033431E-02,   1.0287502E-02
     +,   1.0543744E-02,   1.0801398E-02,   1.1059628E-02
     +,   1.1317585E-02,   1.1574447E-02,   1.1829410E-02
     +,   1.2081721E-02,   1.2330757E-02,   1.2576002E-02
     +,   1.2817144E-02,   1.3054050E-02,   1.3286869E-02
     +,   1.3516000E-02,   1.3742189E-02,   1.3966480E-02
     +,   1.4190314E-02,   1.4415517E-02,   1.4644288E-02
     +,   1.4879242E-02,   1.5123423E-02,   1.5380342E-02
     +,   1.5653955E-02,   1.5948797E-02,   1.6269999E-02
     +,   1.6623460E-02,   1.7015932E-02,   1.7455332E-02
     +,   1.7950868E-02,   1.8513538E-02,   1.9156341E-02
     +,   1.9894984E-02,   2.0748440E-02,   2.1739746E-02
     +,   2.2897005E-02,   2.4254641E-02,   2.5854658E-02
     +,   2.7747439E-02,   2.9992796E-02,   3.2658733E-02
     +,   3.5819393E-02,   3.9548818E-02,   4.3912515E-02
     +,   4.8954185E-02,   5.4682795E-02,   6.1059818E-02
     +,   6.7998484E-02,   7.5378545E-02,   8.3085112E-02
     +,   9.1073640E-02,   9.9452414E-02,   0.1085596    
     +,   0.1190059    ,   0.1316464    ,   0.1474380    
     +,   0.1671784    ,   0.1911453    ,   0.2187735    
     +,   0.2485614    ,   0.2784786    ,   0.3069506    
     +,   0.3341353    ,   0.3626207    ,   0.3966382    
     +,   0.4397886    ,   0.4927981    ,   0.5531313    
     +,   0.6163695    ,   0.6776540    ,   0.7335516    
     +,   0.7858384    ,   0.8430327    ,   0.9126748    
     +,   0.9898623    ,    1.058652    ,    1.108283    
     +,    1.142749    ,    1.170468    ,    1.191128    
     +,    1.197489    ,    1.183047    ,    1.144594    
     +,    1.083030    ,    1.003062    ,   0.9116387    
     +,   0.8183663    ,   0.7339177    ,   0.6637562    
     +,   0.6050141    ,   0.5510603    ,   0.4982624    
     +,   0.4480900    ,   0.4038770    ,   0.3668513    
     +,   0.3353695    ,   0.3068943    ,   0.2799285    
     +,   0.2543364    ,   0.2305912    ,   0.2090740    
     +,   0.1898991    ,   0.1730503    ,   0.1584943    
     +,   0.1461798    ,   0.1359876    ,   0.1277097    
     +,   0.1210772    ,   0.1158068    ,   0.1116401    
     +,   0.1083643    ,   0.1058158    ,   0.1038726    
     +,   0.1024400    ,   0.1014326    ,   0.1007582    
     +,   0.1003065    ,   9.9944226E-02,   9.9518575E-02
     +,   9.8868027E-02,   9.7837858E-02,   9.6298702E-02
     +,   9.4161727E-02,   9.1390118E-02,   8.8002704E-02
     +,   8.4069706E-02,   7.9701886E-02,   7.5035132E-02
     +,   7.0214100E-02,   6.5376043E-02,   6.0638208E-02
     +,   5.6090508E-02,   5.1793132E-02,   4.7777347E-02
     +,   4.4050448E-02,   4.0602297E-02,   3.7411548E-02
     +,   3.4451265E-02,   3.1693812E-02,   2.9114110E-02
     +,   2.6691139E-02,   2.4408503E-02,   2.2254406E-02
     +,   2.0221224E-02,   1.8304506E-02,   1.6502004E-02
     +,   1.4812998E-02,   1.3237695E-02,   1.1776309E-02
     +,   1.0428795E-02,   9.1945250E-03,   8.0719665E-03
     +,   7.0584766E-03,   6.1503556E-03,   5.3429161E-03
     +,   4.6305456E-03,   4.0068012E-03,   3.4646888E-03
     +,   2.9968843E-03,   2.5959106E-03,   2.2543073E-03
     +,   1.9648490E-03,   1.7207037E-03,   1.5154886E-03
     +,   1.3433807E-03,   1.1991634E-03,   1.0782265E-03
     +,   9.7655080E-04,   8.9069223E-04,   8.1773923E-04
     +,   7.5525948E-04,   7.0124026E-04,   6.5403903E-04
     +,   6.1233278E-04,   5.7506328E-04,   5.4139039E-04
     +,   5.1065529E-04,   4.8234727E-04,   4.5606931E-04
     +,   4.3151595E-04,   4.0845483E-04,   3.8670845E-04
     +,   3.6613934E-04,   3.4664173E-04,   3.2813419E-04
     +,   3.1055242E-04,   2.9384295E-04,   2.7796102E-04
     +,   2.6286923E-04,   2.4853367E-04,   2.3492263E-04
     +,   2.2200598E-04,   2.0975604E-04,   1.9814457E-04
     +,   1.8714400E-04,   1.7672771E-04,   1.6686962E-04
     +,   1.5754315E-04,   1.4872239E-04,   1.4038246E-04
     +,   1.3249913E-04,   1.2504826E-04,   1.1800663E-04
     +,   1.1135246E-04,   1.0506401E-04,   9.9121280E-05
     +,   9.3504452E-05,   8.8195433E-05,   8.3176361E-05
     +,   7.8431040E-05,   7.3943549E-05,   6.9699483E-05
     +,   6.5684784E-05,   6.1886749E-05,   5.8293117E-05
     +,   5.4892396E-05,   5.1674207E-05,   4.8628346E-05
     +,   4.5745717E-05,   4.3017400E-05,   4.0435418E-05
     +,   3.7991966E-05,   3.5680019E-05,   3.3492706E-05
     +,   3.1423846E-05,   2.9467359E-05,   2.7617771E-05
     +,   2.5869667E-05,   2.4218170E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_hzonly_ttz85_mass = Yx/8.04674782978723
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_hzonly_ttz90_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.7479653E-03,   2.8341298E-03
     +,   2.9208011E-03,   3.0079156E-03,   3.0954087E-03
     +,   3.1832189E-03,   3.2712838E-03,   3.3595450E-03
     +,   3.4479396E-03,   3.5364146E-03,   3.6249091E-03
     +,   3.7133642E-03,   3.8017218E-03,   3.8899211E-03
     +,   3.9779018E-03,   4.0656016E-03,   4.1529518E-03
     +,   4.2398879E-03,   4.3263379E-03,   4.4122287E-03
     +,   4.4974806E-03,   4.5820172E-03,   4.6657501E-03
     +,   4.7485987E-03,   4.8304684E-03,   4.9112714E-03
     +,   4.9909162E-03,   5.0693071E-03,   5.1463512E-03
     +,   5.2219559E-03,   5.2960352E-03,   5.3684991E-03
     +,   5.4392694E-03,   5.5082710E-03,   5.5754362E-03
     +,   5.6407093E-03,   5.7040411E-03,   5.7653966E-03
     +,   5.8247554E-03,   5.8821039E-03,   5.9374538E-03
     +,   5.9908256E-03,   6.0422551E-03,   6.0917968E-03
     +,   6.1395257E-03,   6.1855279E-03,   6.2299045E-03
     +,   6.2727788E-03,   6.3142846E-03,   6.3545750E-03
     +,   6.3938070E-03,   6.4321635E-03,   6.4698327E-03
     +,   6.5070153E-03,   6.5439218E-03,   6.5807775E-03
     +,   6.6178162E-03,   6.6552870E-03,   6.6934451E-03
     +,   6.7325677E-03,   6.7729391E-03,   6.8148682E-03
     +,   6.8586799E-03,   6.9047231E-03,   6.9533736E-03
     +,   7.0050349E-03,   7.0601450E-03,   7.1191760E-03
     +,   7.1826358E-03,   7.2510685E-03,   7.3250700E-03
     +,   7.4052587E-03,   7.4923011E-03,   7.5868866E-03
     +,   7.6897363E-03,   7.8015947E-03,   7.9231989E-03
     +,   8.0552800E-03,   8.1985565E-03,   8.3537018E-03
     +,   8.5213128E-03,   8.7019308E-03,   8.8959606E-03
     +,   9.1037089E-03,   9.3253069E-03,   9.5607443E-03
     +,   9.8097865E-03,   1.0072052E-02,   1.0346917E-02
     +,   1.0633574E-02,   1.0931038E-02,   1.1238135E-02
     +,   1.1553559E-02,   1.1875927E-02,   1.2203842E-02
     +,   1.2535921E-02,   1.2870970E-02,   1.3207994E-02
     +,   1.3546405E-02,   1.3886094E-02,   1.4227609E-02
     +,   1.4572254E-02,   1.4922301E-02,   1.5281025E-02
     +,   1.5652893E-02,   1.6043624E-02,   1.6460175E-02
     +,   1.6910765E-02,   1.7404830E-02,   1.7952867E-02
     +,   1.8566160E-02,   1.9256664E-02,   2.0036504E-02
     +,   2.0917797E-02,   2.1912048E-02,   2.3029935E-02
     +,   2.4280643E-02,   2.5671715E-02,   2.7208259E-02
     +,   2.8892990E-02,   3.0725541E-02,   3.2702293E-02
     +,   3.4816105E-02,   3.7056610E-02,   3.9410409E-02
     +,   4.1861568E-02,   4.4393621E-02,   4.6990909E-02
     +,   4.9642179E-02,   5.2343726E-02,   5.5104021E-02
     +,   5.7947300E-02,   6.0917191E-02,   6.4076982E-02
     +,   6.7507960E-02,   7.1304254E-02,   7.5565577E-02
     +,   8.0391705E-02,   8.5881770E-02,   9.2139989E-02
     +,   9.9287950E-02,   0.1074815    ,   0.1169239    
     +,   0.1278688    ,   0.1406058    ,   0.1554311    
     +,   0.1725949    ,   0.1922277    ,   0.2142594    
     +,   0.2383546    ,   0.2639099    ,   0.2901646    
     +,   0.3164326    ,   0.3423624    ,   0.3681037    
     +,   0.3943712    ,   0.4225279    ,   0.4546086    
     +,   0.4928490    ,   0.5384727    ,   0.5906903    
     +,   0.6474788    ,   0.7077616    ,   0.7717903    
     +,   0.8382434    ,   0.9020599    ,   0.9566850    
     +,   0.9970047    ,    1.018328    ,    1.014916    
     +,   0.9829440    ,   0.9253226    ,   0.8533745    
     +,   0.7842667    ,   0.7348400    ,   0.7136186    
     +,   0.7163371    ,   0.7294925    ,   0.7395064    
     +,   0.7401572    ,   0.7334414    ,   0.7244735    
     +,   0.7152520    ,   0.7026988    ,   0.6819094    
     +,   0.6505524    ,   0.6102093    ,   0.5645650    
     +,   0.5171930    ,   0.4707353    ,   0.4270951    
     +,   0.3875913    ,   0.3527780    ,   0.3223294    
     +,   0.2953332    ,   0.2708306    ,   0.2482148    
     +,   0.2272833    ,   0.2080198    ,   0.1903537    
     +,   0.1740655    ,   0.1588508    ,   0.1444506    
     +,   0.1307413    ,   0.1177414    ,   0.1055497    
     +,   9.4274007E-02,   8.3978459E-02,   7.4665666E-02
     +,   6.6285007E-02,   5.8755331E-02,   5.1986638E-02
     +,   4.5894396E-02,   4.0406346E-02,   3.5463933E-02
     +,   3.1020414E-02,   2.7036946E-02,   2.3479233E-02
     +,   2.0315645E-02,   1.7516002E-02,   1.5050368E-02
     +,   1.2889341E-02,   1.1004331E-02,   9.3677370E-03
     +,   7.9531679E-03,   6.7358743E-03,   5.6929602E-03
     +,   4.8033739E-03,   4.0478711E-03,   3.4090544E-03
     +,   2.8713085E-03,   2.4206596E-03,   2.0446379E-03
     +,   1.7322139E-03,   1.4737088E-03,   1.2606320E-03
     +,   1.0856120E-03,   9.4230258E-04,   8.2526490E-04
     +,   7.2986551E-04,   6.5219315E-04,   5.8897113E-04
     +,   5.3746591E-04,   4.9540849E-04,   4.6092883E-04
     +,   4.3249709E-04,   4.0886458E-04,   3.8901754E-04
     +,   3.7213863E-04,   3.5757403E-04,   3.4480152E-04
     +,   3.3340856E-04,   3.2307205E-04,   3.1354075E-04
     +,   3.0462103E-04,   2.9616541E-04,   2.8806413E-04
     +,   2.8023610E-04,   2.7262230E-04,   2.6518124E-04
     +,   2.5788505E-04,   2.5071582E-04,   2.4366255E-04
     +,   2.3671941E-04,   2.2988513E-04,   2.2316024E-04
     +,   2.1654685E-04,   2.1004859E-04,   2.0366941E-04
     +,   1.9741303E-04,   1.9128303E-04,   1.8528316E-04
     +,   1.7941657E-04,   1.7368569E-04,   1.6809245E-04
     +,   1.6263868E-04,   1.5732508E-04,   1.5215248E-04
     +,   1.4712061E-04,   1.4222931E-04,   1.3747743E-04
     +,   1.3286406E-04,   1.2838728E-04,   1.2404552E-04
     +,   1.1983626E-04,   1.1575736E-04,   1.1180605E-04
     +,   1.0797939E-04,   1.0427464E-04,   1.0068849E-04
     +,   9.7218006E-05,   9.3859722E-05,   9.0610549E-05
     +,   8.7466993E-05,   8.4425941E-05,   8.1483930E-05
     +,   7.8637888E-05,   7.5884411E-05,   7.3220552E-05
     +,   7.0643058E-05,   6.8149071E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_hzonly_ttz90_mass = Yx/8.15874753191489
      RETURN
      END
      DOUBLE PRECISION FUNCTION A192_tt_hzonly_ttz95_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.3653950E-03,   2.4608374E-03
     +,   2.5580756E-03,   2.6569918E-03,   2.7574578E-03
     +,   2.8593352E-03,   2.9624773E-03,   3.0667274E-03
     +,   3.1719177E-03,   3.2778815E-03,   3.3844353E-03
     +,   3.4913956E-03,   3.5985692E-03,   3.7057609E-03
     +,   3.8127725E-03,   3.9194026E-03,   4.0254481E-03
     +,   4.1307076E-03,   4.2349803E-03,   4.3380680E-03
     +,   4.4397754E-03,   4.5399158E-03,   4.6383035E-03
     +,   4.7347704E-03,   4.8291446E-03,   4.9212775E-03
     +,   5.0110281E-03,   5.0982628E-03,   5.1828702E-03
     +,   5.2647511E-03,   5.3438223E-03,   5.4200217E-03
     +,   5.4932986E-03,   5.5636298E-03,   5.6310049E-03
     +,   5.6954371E-03,   5.7569551E-03,   5.8156177E-03
     +,   5.8714943E-03,   5.9246817E-03,   5.9752935E-03
     +,   6.0234633E-03,   6.0693473E-03,   6.1131166E-03
     +,   6.1549582E-03,   6.1950833E-03,   6.2337113E-03
     +,   6.2710801E-03,   6.3074362E-03,   6.3430425E-03
     +,   6.3781696E-03,   6.4130919E-03,   6.4480947E-03
     +,   6.4834687E-03,   6.5194964E-03,   6.5564741E-03
     +,   6.5946849E-03,   6.6344184E-03,   6.6759447E-03
     +,   6.7195385E-03,   6.7654587E-03,   6.8139546E-03
     +,   6.8652593E-03,   6.9195949E-03,   6.9771698E-03
     +,   7.0381723E-03,   7.1027759E-03,   7.1711303E-03
     +,   7.2433823E-03,   7.3196460E-03,   7.4000256E-03
     +,   7.4846065E-03,   7.5734691E-03,   7.6666628E-03
     +,   7.7642435E-03,   7.8662531E-03,   7.9727229E-03
     +,   8.0836788E-03,   8.1991535E-03,   8.3191851E-03
     +,   8.4437970E-03,   8.5730515E-03,   8.7069971E-03
     +,   8.8457167E-03,   8.9892931E-03,   9.1378596E-03
     +,   9.2915464E-03,   9.4505288E-03,   9.6150087E-03
     +,   9.7852275E-03,   9.9614654E-03,   1.0144027E-02
     +,   1.0333273E-02,   1.0529608E-02,   1.0733487E-02
     +,   1.0945398E-02,   1.1165908E-02,   1.1395593E-02
     +,   1.1635146E-02,   1.1885246E-02,   1.2146675E-02
     +,   1.2420231E-02,   1.2706785E-02,   1.3007215E-02
     +,   1.3322447E-02,   1.3653412E-02,   1.4001024E-02
     +,   1.4366145E-02,   1.4749601E-02,   1.5152137E-02
     +,   1.5574313E-02,   1.6016580E-02,   1.6479142E-02
     +,   1.6962020E-02,   1.7464925E-02,   1.7987359E-02
     +,   1.8528499E-02,   1.9087279E-02,   1.9662384E-02
     +,   2.0252304E-02,   2.0855442E-02,   2.1470096E-02
     +,   2.2094570E-02,   2.2727363E-02,   2.3367243E-02
     +,   2.4013221E-02,   2.4664907E-02,   2.5322428E-02
     +,   2.5986707E-02,   2.6659397E-02,   2.7343279E-02
     +,   2.8042078E-02,   2.8760908E-02,   2.9506106E-02
     +,   3.0285643E-02,   3.1109208E-02,   3.1988278E-02
     +,   3.2936476E-02,   3.3969715E-02,   3.5106692E-02
     +,   3.6368996E-02,   3.7781604E-02,   3.9373275E-02
     +,   4.1176766E-02,   4.3228466E-02,   4.5568299E-02
     +,   4.8238009E-02,   5.1278878E-02,   5.4728128E-02
     +,   5.8614794E-02,   6.2953711E-02,   6.7738995E-02
     +,   7.2938301E-02,   7.8487881E-02,   8.4289961E-02
     +,   9.0212762E-02,   9.6096471E-02,   0.1017645    
     +,   0.1070398    ,   0.1117671    ,   0.1158395    
     +,   0.1192248    ,   0.1219876    ,   0.1243007    
     +,   0.1264417    ,   0.1287705    ,   0.1316929    
     +,   0.1356194    ,   0.1409333    ,   0.1479773    
     +,   0.1570590    ,   0.1684657    ,   0.1824709    
     +,   0.1993113    ,   0.2191435    ,   0.2420025    
     +,   0.2677932    ,   0.2963092    ,   0.3272335    
     +,   0.3601254    ,   0.3946716    ,   0.4315727    
     +,   0.4736822    ,   0.5257885    ,   0.5919459    
     +,   0.6722535    ,   0.7625667    ,   0.8573354    
     +,   0.9521006    ,    1.043674    ,    1.129147    
     +,    1.205589    ,    1.271861    ,    1.330131    
     +,    1.382345    ,    1.424415    ,    1.446461    
     +,    1.439866    ,    1.402443    ,    1.335964    
     +,    1.242601    ,    1.128661    ,    1.007862    
     +,   0.8936197    ,   0.7901037    ,   0.6942548    
     +,   0.6030208    ,   0.5163159    ,   0.4360735    
     +,   0.3648117    ,   0.3044660    ,   0.2554037    
     +,   0.2161598    ,   0.1841586    ,   0.1568600    
     +,   0.1325512    ,   0.1104844    ,   9.0573199E-02
     +,   7.2996266E-02,   5.7917815E-02,   4.5358974E-02
     +,   3.5185374E-02,   2.7146403E-02,   2.0926960E-02
     +,   1.6195243E-02,   1.2638206E-02,   9.9824490E-03
     +,   8.0024088E-03,   6.5200999E-03,   5.4000365E-03
     +,   4.5418763E-03,   3.8728015E-03,   3.3408627E-03
     +,   2.9095397E-03,   2.5534555E-03,   2.2549815E-03
     +,   2.0018606E-03,   1.7854501E-03,   1.5994805E-03
     +,   1.4392174E-03,   1.3009357E-03,   1.1815850E-03
     +,   1.0785689E-03,   9.8961650E-04,   9.1272127E-04
     +,   8.4610441E-04,   7.8818627E-04,   7.3756906E-04
     +,   6.9303281E-04,   6.5352774E-04,   6.1815599E-04
     +,   5.8616401E-04,   5.5693166E-04,   5.2995479E-04
     +,   5.0483021E-04,   4.8124223E-04,   4.5895053E-04
     +,   4.3777510E-04,   4.1758316E-04,   3.9827984E-04
     +,   3.7980088E-04,   3.6210270E-04,   3.4515600E-04
     +,   3.2894142E-04,   3.1344726E-04,   2.9866368E-04
     +,   2.8458182E-04,   2.7119345E-04,   2.5848884E-04
     +,   2.4645549E-04,   2.3507868E-04,   2.2434219E-04
     +,   2.1422737E-04,   2.0471289E-04,   1.9577575E-04
     +,   1.8739213E-04,   1.7953610E-04,   1.7218174E-04
     +,   1.6530159E-04,   1.5886889E-04,   1.5285591E-04
     +,   1.4723599E-04,   1.4198215E-04,   1.3706871E-04
     +,   1.3247014E-04,   1.2816243E-04,   1.2412216E-04
     +,   1.2032707E-04,   1.1675643E-04,   1.1339023E-04
     +,   1.1021023E-04,   1.0719894E-04,   1.0434060E-04
     +,   1.0162024E-04,   9.9024473E-05,   9.6540723E-05
     +,   9.4157898E-05,   9.1865601E-05,   8.9654750E-05
     +,   8.7516943E-05,   8.5444954E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A192_tt_hzonly_ttz95_mass = Yx/8.43874678723404
      RETURN
      END
C 
C---- New file --- 
C 
      DOUBLE PRECISION FUNCTION A196_tt_asha_htt100_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  5.9740319E-07,   7.0613163E-07
     +,   8.3311846E-07,   9.8114106E-07,   1.1533472E-06
     +,   1.3532979E-06,   1.5850085E-06,   1.8530005E-06
     +,   2.1623414E-06,   2.5187253E-06,   2.9284959E-06
     +,   3.3987235E-06,   3.9372699E-06,   4.5528518E-06
     +,   5.2550995E-06,   6.0546404E-06,   6.9631574E-06
     +,   7.9934653E-06,   9.1595839E-06,   1.0476795E-05
     +,   1.1961733E-05,   1.3632432E-05,   1.5508351E-05
     +,   1.7610615E-05,   1.9961673E-05,   2.2585840E-05
     +,   2.5508945E-05,   2.8758483E-05,   3.2363652E-05
     +,   3.6355294E-05,   4.0765943E-05,   4.5629677E-05
     +,   5.0982169E-05,   5.6860528E-05,   6.3303210E-05
     +,   7.0350005E-05,   7.8041674E-05,   8.6419765E-05
     +,   9.5527204E-05,   1.0540622E-04,   1.1610048E-04
     +,   1.2765285E-04,   1.4010606E-04,   1.5350216E-04
     +,   1.6788211E-04,   1.8328555E-04,   1.9975028E-04
     +,   2.1731190E-04,   2.3600360E-04,   2.5585535E-04
     +,   2.7689425E-04,   2.9914326E-04,   3.2262117E-04
     +,   3.4734391E-04,   3.7332030E-04,   4.0055680E-04
     +,   4.2905394E-04,   4.5880725E-04,   4.8980775E-04
     +,   5.2204181E-04,   5.5549131E-04,   5.9013499E-04
     +,   6.2594621E-04,   6.6289847E-04,   7.0096430E-04
     +,   7.4011233E-04,   7.8031735E-04,   8.2155218E-04
     +,   8.6379994E-04,   9.0704550E-04,   9.5128902E-04
     +,   9.9653762E-04,   1.0428198E-03,   1.0901772E-03
     +,   1.1386790E-03,   1.1884207E-03,   1.2395267E-03
     +,   1.2921554E-03,   1.3465094E-03,   1.4028364E-03
     +,   1.4614280E-03,   1.5226379E-03,   1.5868708E-03
     +,   1.6546022E-03,   1.7263662E-03,   1.8027748E-03
     +,   1.8845020E-03,   1.9723030E-03,   2.0669929E-03
     +,   2.1694617E-03,   2.2806630E-03,   2.4015952E-03
     +,   2.5333008E-03,   2.6768565E-03,   2.8333548E-03
     +,   3.0038634E-03,   3.1894378E-03,   3.3910568E-03
     +,   3.6096373E-03,   3.8459545E-03,   4.1006752E-03
     +,   4.3742629E-03,   4.6670232E-03,   4.9790177E-03
     +,   5.3101182E-03,   5.6599844E-03,   6.0280603E-03
     +,   6.4136307E-03,   6.8159122E-03,   7.2341282E-03
     +,   7.6675885E-03,   8.1159575E-03,   8.5793529E-03
     +,   9.0587130E-03,   9.5559889E-03,   1.0074576E-02
     +,   1.0619566E-02,   1.1198206E-02,   1.1820071E-02
     +,   1.2497402E-02,   1.3245122E-02,   1.4080676E-02
     +,   1.5023634E-02,   1.6095046E-02,   1.7316367E-02
     +,   1.8707905E-02,   2.0287471E-02,   2.2068243E-02
     +,   2.4057379E-02,   2.6254103E-02,   2.8649228E-02
     +,   3.1224480E-02,   3.3953901E-02,   3.6805194E-02
     +,   3.9743382E-02,   4.2734545E-02,   4.5750041E-02
     +,   4.8771050E-02,   5.1792327E-02,   5.4824285E-02
     +,   5.7892740E-02,   6.1037272E-02,   6.4307109E-02
     +,   6.7755498E-02,   7.1433321E-02,   7.5384550E-02
     +,   7.9643503E-02,   8.4235124E-02,   8.9180768E-02
     +,   9.4509847E-02,   0.1002769    ,   0.1065852    
     +,   0.1136148    ,   0.1216478    ,   0.1310760    
     +,   0.1423693    ,   0.1559871    ,   0.1722232    
     +,   0.1910052    ,   0.2117176    ,   0.2331456    
     +,   0.2536246    ,   0.2714226    ,   0.2852898    
     +,   0.2949834    ,   0.3015429    ,   0.3071399    
     +,   0.3144895    ,   0.3260407    ,   0.3433613    
     +,   0.3671504    ,   0.3979957    ,   0.4374045    
     +,   0.4880229    ,   0.5520971    ,   0.6286724    
     +,   0.7121713    ,   0.7955602    ,   0.8774916    
     +,   0.9661881    ,    1.072461    ,    1.198718    
     +,    1.342724    ,    1.511346    ,    1.719766    
     +,    1.998131    ,    2.412284    ,    3.027454    
     +,    3.852181    ,    4.769380    ,    5.594551    
     +,    6.597950    ,    8.019627    ,    9.395497    
     +,    11.50294    ,    13.12674    ,    12.76925    
     +,    10.88153    ,    8.769259    ,    6.384477    
     +,    4.455030    ,    3.168451    ,    2.220298    
     +,    1.415049    ,   0.7884309    ,   0.3858221    
     +,   0.1699797    ,   6.8170927E-02,   2.4313012E-02
     +,   7.4277595E-03,   1.8878131E-03,   3.9243710E-04
     +,   6.6147360E-05,   9.0058011E-06,   9.9317560E-07
     +,   9.2843266E-08,   1.0836822E-08,   4.0362407E-09
     +,   2.9259626E-09,   2.2993885E-09,   1.8159245E-09
     +,   1.4340363E-09,   1.1319733E-09,   8.9302293E-10
     +,   7.0400946E-10,   5.5453014E-10,   4.3637013E-10
     +,   3.4302447E-10,   2.6933303E-10,   2.1120648E-10
     +,   1.6540398E-10,   1.2935367E-10,   1.0101243E-10
     +,   7.8760005E-11,   6.1313857E-11,   4.7655220E-11
     +,   3.6977782E-11,   2.8644406E-11,   2.2151298E-11
     +,   1.7100286E-11,   1.3177738E-11,   1.0136943E-11
     +,   7.7839237E-12,   5.9663286E-12,   4.5648056E-12
     +,   3.4861387E-12,   2.6575105E-12,   2.0221168E-12
     +,   1.5357920E-12,   1.1642797E-12,   8.8100328E-13
     +,   6.6540447E-13,   5.0163422E-13,   3.7746935E-13
     +,   2.8350903E-13,   2.1253774E-13,   1.5903527E-13
     +,   1.1877986E-13,   8.8548153E-14,   6.5887020E-14
     +,   4.8933466E-14,   3.6274593E-14,   2.6840163E-14
     +,   1.9822089E-14,   1.4611794E-14,   1.0750817E-14
     +,   7.8951975E-15,   5.7871955E-15,   4.2341127E-15
     +,   3.0920161E-15,   2.2537292E-15,   1.6396321E-15
     +,   1.1906404E-15,   8.6297601E-16,   6.2430542E-16
     +,   4.5079925E-16,   3.2490042E-16,   2.3372532E-16
     +,   1.6781905E-16,   1.2027169E-16,   8.6033388E-17
     +,   6.1426922E-17,   4.3775258E-17,   3.1137828E-17
     +,   2.2106840E-17,   1.5665815E-17,   1.1080592E-17
     +,   7.8226082E-18,   5.5122485E-18,   3.8769149E-18
     +,   2.7216281E-18,   1.9070109E-18,   1.3337134E-18
     +,   9.3100491E-19,   6.4867876E-19,   4.5111334E-19
     +,   3.1313374E-19,   2.1694629E-19,   1.5002412E-19
     +,   1.0354991E-19,   7.1338622E-20
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_asha_htt100_mass = Yx/32.8596744
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_asha_htt105_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  8.4671708E-05,   9.1881317E-05
     +,   9.9583260E-05,   1.0779923E-04,   1.1655077E-04
     +,   1.2585924E-04,   1.3574546E-04,   1.4622981E-04
     +,   1.5733179E-04,   1.6907051E-04,   1.8146372E-04
     +,   1.9452814E-04,   2.0827906E-04,   2.2273044E-04
     +,   2.3789445E-04,   2.5378156E-04,   2.7040017E-04
     +,   2.8775638E-04,   3.0585422E-04,   3.2469496E-04
     +,   3.4427733E-04,   3.6459722E-04,   3.8564729E-04
     +,   4.0741850E-04,   4.2989611E-04,   4.5306474E-04
     +,   4.7690410E-04,   5.0139090E-04,   5.2649871E-04
     +,   5.5219710E-04,   5.7845277E-04,   6.0522900E-04
     +,   6.3248561E-04,   6.6017947E-04,   6.8826444E-04
     +,   7.1669137E-04,   7.4540905E-04,   7.7436329E-04
     +,   8.0349960E-04,   8.3275884E-04,   8.6208421E-04
     +,   8.9141610E-04,   9.2069502E-04,   9.4986224E-04
     +,   9.7885961E-04,   1.0076312E-03,   1.0361235E-03
     +,   1.0642854E-03,   1.0920708E-03,   1.1194383E-03
     +,   1.1463526E-03,   1.1727849E-03,   1.1987153E-03
     +,   1.2241340E-03,   1.2490392E-03,   1.2734436E-03
     +,   1.2973719E-03,   1.3208642E-03,   1.3439757E-03
     +,   1.3667796E-03,   1.3893680E-03,   1.4118541E-03
     +,   1.4343706E-03,   1.4570766E-03,   1.4801543E-03
     +,   1.5038102E-03,   1.5282794E-03,   1.5538216E-03
     +,   1.5807280E-03,   1.6093133E-03,   1.6399248E-03
     +,   1.6729312E-03,   1.7087335E-03,   1.7477513E-03
     +,   1.7904303E-03,   1.8372369E-03,   1.8886508E-03
     +,   1.9451632E-03,   2.0072793E-03,   2.0755075E-03
     +,   2.1503498E-03,   2.2323113E-03,   2.3218784E-03
     +,   2.4195327E-03,   2.5257331E-03,   2.6409281E-03
     +,   2.7655419E-03,   2.9000039E-03,   3.0447284E-03
     +,   3.2001624E-03,   3.3667937E-03,   3.5451844E-03
     +,   3.7360138E-03,   3.9401641E-03,   4.1587832E-03
     +,   4.3933615E-03,   4.6458938E-03,   4.9189581E-03
     +,   5.2159382E-03,   5.5411169E-03,   5.8999266E-03
     +,   6.2990426E-03,   6.7466274E-03,   7.2523416E-03
     +,   7.8274952E-03,   8.4849857E-03,   9.2391102E-03
     +,   1.0105302E-02,   1.1099760E-02,   1.2238797E-02
     +,   1.3537929E-02,   1.5011214E-02,   1.6669845E-02
     +,   1.8521421E-02,   2.0568410E-02,   2.2807630E-02
     +,   2.5228916E-02,   2.7815225E-02,   3.0541932E-02
     +,   3.3377782E-02,   3.6285598E-02,   3.9223522E-02
     +,   4.2147033E-02,   4.5011584E-02,   4.7774717E-02
     +,   5.0398551E-02,   5.2852787E-02,   5.5116188E-02
     +,   5.7178862E-02,   5.9042778E-02,   6.0722619E-02
     +,   6.2245198E-02,   6.3648961E-02,   6.4982690E-02
     +,   6.6304490E-02,   6.7680947E-02,   6.9186501E-02
     +,   7.0903912E-02,   7.2925389E-02,   7.5353868E-02
     +,   7.8304254E-02,   8.1903517E-02,   8.6289339E-02
     +,   9.1605738E-02,   9.7995408E-02,   0.1055918    
     +,   0.1145097    ,   0.1248365    ,   0.1366282    
     +,   0.1499064    ,   0.1646541    ,   0.1808021    
     +,   0.1982054    ,   0.2166072    ,   0.2355950    
     +,   0.2545723    ,   0.2727765    ,   0.2893673    
     +,   0.3035957    ,   0.3150337    ,   0.3238131    
     +,   0.3307750    ,   0.3374533    ,   0.3458370    
     +,   0.3579370    ,   0.3752765    ,   0.3984906    
     +,   0.4272247    ,   0.4604155    ,   0.4968250    
     +,   0.5355455    ,   0.5761943    ,   0.6187353    
     +,   0.6631346    ,   0.7091583    ,   0.7564829    
     +,   0.8051367    ,   0.8562655    ,   0.9129362    
     +,   0.9800664    ,    1.062457    ,    1.161594    
     +,    1.274048    ,    1.393399    ,    1.514156    
     +,    1.635369    ,    1.763945    ,    1.912947    
     +,    2.080957    ,    2.232482    ,    2.352923    
     +,    2.525182    ,    2.841891    ,    3.286089    
     +,    3.811091    ,    4.379003    ,    4.928646    
     +,    5.423217    ,    6.082673    ,    7.251012    
     +,    8.630530    ,    9.843426    ,    10.74071    
     +,    10.08774    ,    6.793687    ,    2.863724    
     +,   0.7052658    ,   0.1048138    ,   1.4550292E-02
     +,   3.7077039E-03,   1.0274713E-03,   2.0403822E-04
     +,   2.7345115E-05,   2.4645572E-06,   1.5345233E-07
     +,   1.0194721E-08,   3.5512340E-09,   2.7384532E-09
     +,   2.2082751E-09,   1.7825569E-09,   1.4388818E-09
     +,   1.1614200E-09,   9.3742758E-10,   7.5660866E-10
     +,   6.1063893E-10,   4.9279825E-10,   3.9766915E-10
     +,   3.2087780E-10,   2.5888683E-10,   2.0884285E-10
     +,   1.6844601E-10,   1.3583899E-10,   1.0951989E-10
     +,   8.8277503E-11,   7.1135424E-11,   5.7303676E-11
     +,   4.6144387E-11,   3.7143445E-11,   2.9885327E-11
     +,   2.4034068E-11,   1.9318257E-11,   1.5519088E-11
     +,   1.2459761E-11,   9.9971507E-12,   8.0158397E-12
     +,   6.4226393E-12,   5.1423180E-12,   4.1140251E-12
     +,   3.2886682E-12,   2.6267020E-12,   2.0961603E-12
     +,   1.6712635E-12,   1.3312638E-12,   1.0594362E-12
     +,   8.4229455E-13,   6.6898619E-13,   5.3080083E-13
     +,   4.2072712E-13,   3.3313022E-13,   2.6348804E-13
     +,   2.0818003E-13,   1.6430298E-13,   1.2953024E-13
     +,   1.0200180E-13,   8.0233861E-14,   6.3039580E-14
     +,   4.9472887E-14,   3.8781088E-14,   3.0364840E-14
     +,   2.3747338E-14,   1.8550011E-14,   1.4473123E-14
     +,   1.1278963E-14,   8.7792780E-15,   6.8254021E-15
     +,   5.3000520E-15,   4.1106289E-15,   3.1843327E-15
     +,   2.4637715E-15,   1.9039812E-15,   1.4695894E-15
     +,   1.1329416E-15,   8.7234526E-16,   6.7088138E-16
     +,   5.1531372E-16,   3.9534257E-16,   3.0293305E-16
     +,   2.3183943E-16,   1.7721537E-16,   1.3529550E-16
     +,   1.0316661E-16,   7.8570684E-17,   5.9766287E-17
     +,   4.5406422E-17,   3.4454994E-17,   2.6112714E-17
     +,   1.9766250E-17,   1.4943893E-17,   1.1284283E-17
     +,   8.5104105E-18,   6.4106196E-18
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_asha_htt105_mass = Yx/29.1850294285714
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_asha_htt107_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.1219036E-04,   3.2783143E-04
     +,   3.4401202E-04,   3.6073645E-04,   3.7800850E-04
     +,   3.9583136E-04,   4.1420729E-04,   4.3313805E-04
     +,   4.5262428E-04,   4.7266707E-04,   4.9326575E-04
     +,   5.1441940E-04,   5.3612667E-04,   5.5838545E-04
     +,   5.8119337E-04,   6.0454739E-04,   6.2844442E-04
     +,   6.5288058E-04,   6.7785231E-04,   7.0335576E-04
     +,   7.2938681E-04,   7.5594144E-04,   7.8301545E-04
     +,   8.1060664E-04,   8.3870982E-04,   8.6732378E-04
     +,   8.9644536E-04,   9.2607317E-04,   9.5620594E-04
     +,   9.8684349E-04,   1.0179866E-03,   1.0496366E-03
     +,   1.0817964E-03,   1.1144690E-03,   1.1476594E-03
     +,   1.1813735E-03,   1.2156176E-03,   1.2503992E-03
     +,   1.2857290E-03,   1.3216143E-03,   1.3580673E-03
     +,   1.3950993E-03,   1.4327221E-03,   1.4709485E-03
     +,   1.5097915E-03,   1.5492638E-03,   1.5893794E-03
     +,   1.6301511E-03,   1.6715920E-03,   1.7137146E-03
     +,   1.7565312E-03,   1.8000527E-03,   1.8442903E-03
     +,   1.8892561E-03,   1.9349584E-03,   1.9814090E-03
     +,   2.0286189E-03,   2.0765995E-03,   2.1253664E-03
     +,   2.1749355E-03,   2.2253292E-03,   2.2765766E-03
     +,   2.3287102E-03,   2.3817788E-03,   2.4358437E-03
     +,   2.4909773E-03,   2.5472778E-03,   2.6048629E-03
     +,   2.6638820E-03,   2.7245120E-03,   2.7869749E-03
     +,   2.8515265E-03,   2.9184802E-03,   2.9881932E-03
     +,   3.0610880E-03,   3.1376511E-03,   3.2184296E-03
     +,   3.3040424E-03,   3.3951858E-03,   3.4926296E-03
     +,   3.5972076E-03,   3.7098371E-03,   3.8314878E-03
     +,   3.9632013E-03,   4.1060550E-03,   4.2611831E-03
     +,   4.4297259E-03,   4.6128551E-03,   4.8117191E-03
     +,   5.0274618E-03,   5.2612005E-03,   5.5139959E-03
     +,   5.7868571E-03,   6.0807709E-03,   6.3967011E-03
     +,   6.7355875E-03,   7.0984727E-03,   7.4864877E-03
     +,   7.9010623E-03,   8.3439713E-03,   8.8176150E-03
     +,   9.3251569E-03,   9.8709082E-03,   1.0460535E-02
     +,   1.1101537E-02,   1.1803614E-02,   1.2578993E-02
     +,   1.3442894E-02,   1.4413892E-02,   1.5514106E-02
     +,   1.6769139E-02,   1.8208133E-02,   1.9862933E-02
     +,   2.1767551E-02,   2.3956362E-02,   2.6462793E-02
     +,   2.9316405E-02,   3.2540873E-02,   3.6150251E-02
     +,   4.0146701E-02,   4.4517606E-02,   4.9233112E-02
     +,   5.4245409E-02,   5.9489552E-02,   6.4885601E-02
     +,   7.0342161E-02,   7.5763986E-02,   8.1058748E-02
     +,   8.6147681E-02,   9.0974063E-02,   9.5513821E-02
     +,   9.9781781E-02,   0.1038379    ,   0.1077873    
     +,   0.1117778    ,   0.1159917    ,   0.1206333    
     +,   0.1259123    ,   0.1320242    ,   0.1391296    
     +,   0.1473314    ,   0.1566578    ,   0.1670490    
     +,   0.1783513    ,   0.1903205    ,   0.2026378    
     +,   0.2149326    ,   0.2268131    ,   0.2379022    
     +,   0.2478749    ,   0.2564929    ,   0.2636383    
     +,   0.2693437    ,   0.2738186    ,   0.2774673    
     +,   0.2808988    ,   0.2849224    ,   0.2905178    
     +,   0.2987629    ,   0.3107060    ,   0.3271706    
     +,   0.3485214    ,   0.3744588    ,   0.4039592    
     +,   0.4354697    ,   0.4673757    ,   0.4986441    
     +,   0.5294136    ,   0.5612571    ,   0.5969054    
     +,   0.6394254    ,   0.6911604    ,   0.7531163    
     +,   0.8254557    ,   0.9088030    ,    1.004720    
     +,    1.113630    ,    1.231592    ,    1.350862    
     +,    1.466853    ,    1.583997    ,    1.707733    
     +,    1.826370    ,    1.910273    ,    1.943166    
     +,    1.952190    ,    1.993305    ,    2.107310    
     +,    2.297418    ,    2.541713    ,    2.819030    
     +,    3.124314    ,    3.444587    ,    3.711814    
     +,    3.861417    ,    3.956990    ,    4.123990    
     +,    4.449745    ,    5.039836    ,    5.837970    
     +,    6.480971    ,    6.631891    ,    6.157948    
     +,    4.973896    ,    3.269563    ,    1.650025    
     +,   0.6155428    ,   0.1659700    ,   3.1844169E-02
     +,   4.2895484E-03,   4.0170617E-04,   2.6845628E-05
     +,   2.1652986E-06,   9.5797475E-07,   8.2002759E-07
     +,   7.2577154E-07,   6.4262582E-07,   5.6880515E-07
     +,   5.0327890E-07,   4.4513934E-07,   3.9357076E-07
     +,   3.4784443E-07,   3.0731422E-07,   2.7140339E-07
     +,   2.3959524E-07,   2.1142995E-07,   1.8649995E-07
     +,   1.6444217E-07,   1.4493187E-07,   1.2768072E-07
     +,   1.1243326E-07,   9.8962389E-08,   8.7065217E-08
     +,   7.6561818E-08,   6.7293243E-08,   5.9117554E-08
     +,   5.1908653E-08,   4.5555328E-08,   3.9958696E-08
     +,   3.5030762E-08,   3.0693560E-08,   2.6878318E-08
     +,   2.3524002E-08,   2.0576321E-08,   1.7987286E-08
     +,   1.5714589E-08,   1.3720704E-08,   1.1972384E-08
     +,   1.0440226E-08,   9.0983692E-09,   7.9238536E-09
     +,   6.8964070E-09,   5.9982050E-09,   5.2135136E-09
     +,   4.5284039E-09,   3.9306114E-09,   3.4093761E-09
     +,   2.9552090E-09,   2.5597395E-09,   2.2156057E-09
     +,   1.9163682E-09,   1.6563558E-09,   1.4305849E-09
     +,   1.2346782E-09,   1.0648210E-09,   9.1765351E-10
     +,   7.9023404E-10,   6.7999834E-10,   5.8470440E-10
     +,   5.0238580E-10,   4.3132772E-10,   3.7003875E-10
     +,   3.1721795E-10,   2.7172908E-10,   2.3258336E-10
     +,   1.9892479E-10,   1.7000504E-10,   1.4517788E-10
     +,   1.2387963E-10,   1.0562424E-10,   8.9988392E-11
     +,   7.6607755E-11,   6.5165297E-11,   5.5388864E-11
     +,   4.7042013E-11,   3.9921753E-11,   3.3852556E-11
     +,   2.8683264E-11,   2.4284335E-11,   2.0543645E-11
     +,   1.7365557E-11,   1.4667396E-11,   1.2378716E-11
     +,   1.0438840E-11,   8.7960325E-12,   7.4058372E-12
     +,   6.2304406E-12,   5.2374008E-12,   4.3991620E-12
     +,   3.6921139E-12,   3.0962617E-12
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_asha_htt107_mass = Yx/26.1256765
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_asha_htt110_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.8637712E-04,   2.9592175E-04
     +,   3.0564502E-04,   3.1554740E-04,   3.2562969E-04
     +,   3.3589292E-04,   3.4633858E-04,   3.5696858E-04
     +,   3.6778545E-04,   3.7879255E-04,   3.8999366E-04
     +,   4.0139339E-04,   4.1299718E-04,   4.2481170E-04
     +,   4.3684483E-04,   4.4910528E-04,   4.6160360E-04
     +,   4.7435192E-04,   4.8736404E-04,   5.0065573E-04
     +,   5.1424513E-04,   5.2815297E-04,   5.4240244E-04
     +,   5.5702083E-04,   5.7203759E-04,   5.8748754E-04
     +,   6.0340919E-04,   6.1984640E-04,   6.3684839E-04
     +,   6.5447111E-04,   6.7277713E-04,   6.9183728E-04
     +,   7.1173115E-04,   7.3254784E-04,   7.5438776E-04
     +,   7.7736308E-04,   8.0159924E-04,   8.2723616E-04
     +,   8.5443107E-04,   8.8335585E-04,   9.1420463E-04
     +,   9.4718975E-04,   9.8254636E-04,   1.0205330E-03
     +,   1.0614328E-03,   1.1055550E-03,   1.1532367E-03
     +,   1.2048427E-03,   1.2607669E-03,   1.3214322E-03
     +,   1.3872912E-03,   1.4588252E-03,   1.5365422E-03
     +,   1.6209809E-03,   1.7126963E-03,   1.8122734E-03
     +,   1.9203110E-03,   2.0374239E-03,   2.1642342E-03
     +,   2.3013712E-03,   2.4494603E-03,   2.6091246E-03
     +,   2.7809599E-03,   2.9655569E-03,   3.1634779E-03
     +,   3.3752357E-03,   3.6013310E-03,   3.8421929E-03
     +,   4.0982380E-03,   4.3698056E-03,   4.6572271E-03
     +,   4.9607614E-03,   5.2806777E-03,   5.6171925E-03
     +,   5.9705586E-03,   6.3410560E-03,   6.7290026E-03
     +,   7.1348036E-03,   7.5590159E-03,   8.0023818E-03
     +,   8.4658153E-03,   8.9505613E-03,   9.4581321E-03
     +,   9.9904668E-03,   1.0549845E-02,   1.1139080E-02
     +,   1.1761355E-02,   1.2420416E-02,   1.3120376E-02
     +,   1.3865814E-02,   1.4661668E-02,   1.5513033E-02
     +,   1.6425146E-02,   1.7403197E-02,   1.8452162E-02
     +,   1.9576423E-02,   2.0779854E-02,   2.2065230E-02
     +,   2.3434401E-02,   2.4887688E-02,   2.6424207E-02
     +,   2.8041244E-02,   2.9734833E-02,   3.1499255E-02
     +,   3.3327635E-02,   3.5212118E-02,   3.7143957E-02
     +,   3.9114211E-02,   4.1114360E-02,   4.3136757E-02
     +,   4.5175064E-02,   4.7225367E-02,   4.9286164E-02
     +,   5.1359423E-02,   5.3450514E-02,   5.5568762E-02
     +,   5.7727009E-02,   5.9941731E-02,   6.2231895E-02
     +,   6.4618409E-02,   6.7122474E-02,   6.9763847E-02
     +,   7.2558835E-02,   7.5518556E-02,   7.8646652E-02
     +,   8.1937246E-02,   8.5374251E-02,   8.8930346E-02
     +,   9.2568010E-02,   9.6240714E-02,   9.9896677E-02
     +,   0.1034823    ,   0.1069487    ,   0.1102569    
     +,   0.1133866    ,   0.1163417    ,   0.1191585    
     +,   0.1219113    ,   0.1247171    ,   0.1277379    
     +,   0.1311781    ,   0.1352780    ,   0.1403027    
     +,   0.1465236    ,   0.1541945    ,   0.1635277    
     +,   0.1746663    ,   0.1876625    ,   0.2024622    
     +,   0.2189030    ,   0.2367205    ,   0.2555703    
     +,   0.2750671    ,   0.2948448    ,   0.3146367    
     +,   0.3343774    ,   0.3542986    ,   0.3749764    
     +,   0.3972590    ,   0.4220486    ,   0.4499922    
     +,   0.4812211    ,   0.5153334    ,   0.5517082    
     +,   0.5900072    ,   0.6304712    ,   0.6736408    
     +,   0.7195233    ,   0.7668633    ,   0.8135101    
     +,   0.8582091    ,   0.9025490    ,   0.9507120    
     +,    1.006039    ,    1.066844    ,    1.125800    
     +,    1.174618    ,    1.211084    ,    1.243459    
     +,    1.289078    ,    1.366425    ,    1.482773    
     +,    1.624449    ,    1.759566    ,    1.857251    
     +,    1.914272    ,    1.964506    ,    2.049806    
     +,    2.176207    ,    2.313322    ,    2.439449    
     +,    2.565968    ,    2.709456    ,    2.867424    
     +,    3.041901    ,    3.236851    ,    3.408666    
     +,    3.509000    ,    3.560631    ,    3.589683    
     +,    3.556831    ,    3.399987    ,    3.064652    
     +,    2.523168    ,    1.831885    ,    1.138834    
     +,   0.5940520    ,   0.2568133    ,   9.1352440E-02
     +,   2.6619060E-02,   6.3333148E-03,   1.2271636E-03
     +,   1.9324348E-04,   2.4726100E-05,   2.6119567E-06
     +,   2.7029193E-07,   6.4897641E-08,   4.5066553E-08
     +,   3.8809102E-08,   3.3935887E-08,   2.9685687E-08
     +,   2.5957306E-08,   2.2687630E-08,   1.9821744E-08
     +,   1.7310889E-08,   1.5112075E-08,   1.3187472E-08
     +,   1.1503697E-08,   1.0031190E-08,   8.7439576E-09
     +,   7.6191906E-09,   6.6368115E-09,   5.7790950E-09
     +,   5.0304916E-09,   4.3773989E-09,   3.8078221E-09
     +,   3.3112473E-09,   2.8784790E-09,   2.5014619E-09
     +,   2.1731137E-09,   1.8872359E-09,   1.6384268E-09
     +,   1.4219587E-09,   1.2336793E-09,   1.0699663E-09
     +,   9.2766561E-10,   8.0401980E-10,   6.9661343E-10
     +,   6.0334232E-10,   5.2237592E-10,   4.5211249E-10
     +,   3.9115455E-10,   3.3829009E-10,   2.9246106E-10
     +,   2.5274335E-10,   2.1833328E-10,   1.8853266E-10
     +,   1.6273433E-10,   1.4040807E-10,   1.2109351E-10
     +,   1.0439106E-10,   8.9953607E-11,   7.7478593E-11
     +,   6.6703233E-11,   5.7400345E-11,   4.9371934E-11
     +,   4.2446140E-11,   3.6474331E-11,   3.1327513E-11
     +,   2.6893666E-11,   2.3075607E-11,   1.9789500E-11
     +,   1.6962686E-11,   1.4532056E-11,   1.2443049E-11
     +,   1.0648689E-11,   9.1081110E-12,   7.7861693E-12
     +,   6.6523662E-12,   5.6805281E-12,   4.8478955E-12
     +,   4.1349632E-12,   3.5248388E-12,   3.0030024E-12
     +,   2.5569150E-12,   2.1758222E-12,   1.8504297E-12
     +,   1.5727528E-12,   1.3359452E-12,   1.1341020E-12
     +,   9.6217207E-13,   8.1580212E-13,   6.9127809E-13
     +,   5.8539561E-13,   4.9542580E-13,   4.1901918E-13
     +,   3.5417616E-13,   2.9917732E-13,   2.5256083E-13
     +,   2.1307190E-13,   1.7964352E-13
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_asha_htt110_mass = Yx/21.2715145106383
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_asha_htt115_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.1071402E-05,   3.3719480E-05
     +,   3.6563113E-05,   3.9613969E-05,   4.2884178E-05
     +,   4.6386387E-05,   5.0133651E-05,   5.4139538E-05
     +,   5.8417969E-05,   6.2983556E-05,   6.7851150E-05
     +,   7.3036092E-05,   7.8554200E-05,   8.4421663E-05
     +,   9.0655107E-05,   9.7271601E-05,   1.0428851E-04
     +,   1.1172361E-04,   1.1959505E-04,   1.2792130E-04
     +,   1.3672117E-04,   1.4601371E-04,   1.5581814E-04
     +,   1.6615466E-04,   1.7704244E-04,   1.8850222E-04
     +,   2.0055422E-04,   2.1321900E-04,   2.2651741E-04
     +,   2.4047050E-04,   2.5509953E-04,   2.7042601E-04
     +,   2.8647168E-04,   3.0325851E-04,   3.2080879E-04
     +,   3.3914522E-04,   3.5829080E-04,   3.7826892E-04
     +,   3.9910452E-04,   4.2082134E-04,   4.4344619E-04
     +,   4.6700559E-04,   4.9152807E-04,   5.1704340E-04
     +,   5.4358388E-04,   5.7118392E-04,   5.9988134E-04
     +,   6.2971754E-04,   6.6073821E-04,   6.9299462E-04
     +,   7.2654465E-04,   7.6145335E-04,   7.9779432E-04
     +,   8.3565444E-04,   8.7512837E-04,   9.1632991E-04
     +,   9.5938670E-04,   1.0044462E-03,   1.0516783E-03
     +,   1.1012771E-03,   1.1534650E-03,   1.2084972E-03
     +,   1.2666592E-03,   1.3282805E-03,   1.3937331E-03
     +,   1.4634277E-03,   1.5378334E-03,   1.6174625E-03
     +,   1.7028918E-03,   1.7947454E-03,   1.8937176E-03
     +,   2.0005498E-03,   2.1160559E-03,   2.2410934E-03
     +,   2.3765860E-03,   2.5235105E-03,   2.6828779E-03
     +,   2.8557365E-03,   3.0431752E-03,   3.2463034E-03
     +,   3.4662159E-03,   3.7040289E-03,   3.9608064E-03
     +,   4.2376108E-03,   4.5354133E-03,   4.8551545E-03
     +,   5.1976470E-03,   5.5636433E-03,   5.9537278E-03
     +,   6.3683870E-03,   6.8079624E-03,   7.2725951E-03
     +,   7.7622612E-03,   8.2767745E-03,   8.8157617E-03
     +,   9.3786046E-03,   9.9645583E-03,   1.0572617E-02
     +,   1.1201672E-02,   1.1850378E-02,   1.2517350E-02
     +,   1.3201039E-02,   1.3899978E-02,   1.4612675E-02
     +,   1.5337907E-02,   1.6074782E-02,   1.6822867E-02
     +,   1.7582431E-02,   1.8354753E-02,   1.9142320E-02
     +,   1.9949015E-02,   2.0780575E-02,   2.1644656E-02
     +,   2.2551196E-02,   2.3512358E-02,   2.4542760E-02
     +,   2.5659066E-02,   2.6879968E-02,   2.8225375E-02
     +,   2.9715940E-02,   3.1372115E-02,   3.3212945E-02
     +,   3.5255030E-02,   3.7511606E-02,   3.9991572E-02
     +,   4.2698685E-02,   4.5632292E-02,   4.8787527E-02
     +,   5.2157946E-02,   5.5737723E-02,   5.9526585E-02
     +,   6.3533343E-02,   6.7781702E-02,   7.2312795E-02
     +,   7.7188067E-02,   8.2487479E-02,   8.8304505E-02
     +,   9.4737448E-02,   0.1018785    ,   0.1098011    
     +,   0.1185470    ,   0.1281190    ,   0.1384758    
     +,   0.1495302    ,   0.1611469    ,   0.1731421    
     +,   0.1852797    ,   0.1972687    ,   0.2087726    
     +,   0.2194364    ,   0.2289382    ,   0.2370636    
     +,   0.2437962    ,   0.2493955    ,   0.2544321    
     +,   0.2597572    ,   0.2663866    ,   0.2753072    
     +,   0.2872410    ,   0.3024220    ,   0.3204679    
     +,   0.3404090    ,   0.3609146    ,   0.3806954    
     +,   0.3989862    ,   0.4159492    ,   0.4328463    
     +,   0.4518779    ,   0.4757186    ,   0.5068930    
     +,   0.5472099    ,   0.5973612    ,   0.6566799    
     +,   0.7230533    ,   0.7931707    ,   0.8631717    
     +,   0.9292500    ,   0.9878209    ,    1.035537    
     +,    1.069986    ,    1.091634    ,    1.106951    
     +,    1.130499    ,    1.180137    ,    1.262120    
     +,    1.357715    ,    1.433177    ,    1.473322    
     +,    1.502107    ,    1.561289    ,    1.670800    
     +,    1.816841    ,    1.978106    ,    2.151504    
     +,    2.336767    ,    2.507671    ,    2.623393    
     +,    2.656091    ,    2.594891    ,    2.441011    
     +,    2.202153    ,    1.891671    ,    1.536217    
     +,    1.171137    ,   0.8282271    ,   0.5339924    
     +,   0.3085877    ,   0.1579287    ,   7.1067922E-02
     +,   2.7990626E-02,   9.6124513E-03,   2.8682156E-03
     +,   7.4122293E-04,   1.6550858E-04,   3.1981181E-05
     +,   5.4711859E-06,   9.5488838E-07,   2.7903869E-07
     +,   1.7499325E-07,   1.4542020E-07,   1.2608756E-07
     +,   1.0974061E-07,   9.5469687E-08,   8.2985537E-08
     +,   7.2071693E-08,   6.2538696E-08,   5.4219857E-08
     +,   4.6967322E-08,   4.0649972E-08,   3.5151977E-08
     +,   3.0371620E-08,   2.6219059E-08,   2.2614962E-08
     +,   1.9489622E-08,   1.6781996E-08,   1.4438303E-08
     +,   1.2411341E-08,   1.0659932E-08,   9.1479997E-09
     +,   7.8438935E-09,   6.7200112E-09,   5.7523226E-09
     +,   4.9198770E-09,   4.2043728E-09,   3.5899024E-09
     +,   3.0626710E-09,   2.6107032E-09,   2.2235742E-09
     +,   1.8922623E-09,   1.6089780E-09,   1.3669638E-09
     +,   1.1603759E-09,   9.8418840E-10,   8.3406065E-10
     +,   7.0624373E-10,   5.9751204E-10,   5.0509852E-10
     +,   4.2662388E-10,   3.6003978E-10,   3.0359207E-10
     +,   2.5577948E-10,   2.1531769E-10,   1.8110487E-10
     +,   1.5219911E-10,   1.2780015E-10,   1.0722227E-10
     +,   8.9881436E-11,   7.5281545E-11,   6.3000147E-11
     +,   5.2677661E-11,   4.4008863E-11,   3.6735490E-11
     +,   3.0638197E-11,   2.5531171E-11,   2.1257112E-11
     +,   1.7683502E-11,   1.4697988E-11,   1.2206088E-11
     +,   1.0127858E-11,   8.3963001E-12,   6.9547406E-12
     +,   5.7557158E-12,   4.7592446E-12,   3.9318982E-12
     +,   3.2455275E-12,   2.6766504E-12,   2.2055626E-12
     +,   1.8157759E-12,   1.4935799E-12,   1.2274624E-12
     +,   1.0078804E-12,   8.2684093E-13,   6.7772659E-13
     +,   5.5500808E-13,   4.5410962E-13,   3.7122280E-13
     +,   3.0319505E-13,   2.4741147E-13,   2.0171222E-13
     +,   1.6430573E-13,   1.3371700E-13
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_asha_htt115_mass = Yx/14.7076000909091
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_asha_htt120_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.9059325E-04,   4.0442328E-04
     +,   4.1833104E-04,   4.3229226E-04,   4.4628177E-04
     +,   4.6027408E-04,   4.7424267E-04,   4.8816076E-04
     +,   5.0200085E-04,   5.1573600E-04,   5.2933843E-04
     +,   5.4278056E-04,   5.5603508E-04,   5.6907494E-04
     +,   5.8187352E-04,   5.9440499E-04,   6.0664414E-04
     +,   6.1856676E-04,   6.3014973E-04,   6.4137107E-04
     +,   6.5221055E-04,   6.6264928E-04,   6.7266985E-04
     +,   6.8225741E-04,   6.9139811E-04,   7.0008117E-04
     +,   7.0829748E-04,   7.1604055E-04,   7.2330609E-04
     +,   7.3009258E-04,   7.3640101E-04,   7.4223499E-04
     +,   7.4760139E-04,   7.5250887E-04,   7.5696979E-04
     +,   7.6099898E-04,   7.6461403E-04,   7.6783577E-04
     +,   7.7068747E-04,   7.7319524E-04,   7.7538838E-04
     +,   7.7729853E-04,   7.7896053E-04,   7.8041182E-04
     +,   7.8169268E-04,   7.8284624E-04,   7.8391901E-04
     +,   7.8495982E-04,   7.8602158E-04,   7.8716030E-04
     +,   7.8843621E-04,   7.8991341E-04,   7.9166068E-04
     +,   7.9375325E-04,   7.9627131E-04,   7.9930353E-04
     +,   8.0294628E-04,   8.0730661E-04,   8.1250269E-04
     +,   8.1866671E-04,   8.2594674E-04,   8.3450990E-04
     +,   8.4454444E-04,   8.5626479E-04,   8.6991483E-04
     +,   8.8577060E-04,   9.0414932E-04,   9.2540873E-04
     +,   9.4995939E-04,   9.7826414E-04,   1.0108503E-03
     +,   1.0483096E-03,   1.0913122E-03,   1.1406026E-03
     +,   1.1970152E-03,   1.2614747E-03,   1.3349953E-03
     +,   1.4186847E-03,   1.5137511E-03,   1.6214963E-03
     +,   1.7432986E-03,   1.8806297E-03,   2.0350108E-03
     +,   2.2080331E-03,   2.4012960E-03,   2.6164285E-03
     +,   2.8550101E-03,   3.1185942E-03,   3.4086055E-03
     +,   3.7263643E-03,   4.0730177E-03,   4.4494709E-03
     +,   4.8563625E-03,   5.2940487E-03,   5.7625449E-03
     +,   6.2614358E-03,   6.7899567E-03,   7.3468443E-03
     +,   7.9304557E-03,   8.5386289E-03,   9.1688428E-03
     +,   9.8180892E-03,   1.0483067E-02,   1.1160078E-02
     +,   1.1845245E-02,   1.2534540E-02,   1.3223837E-02
     +,   1.3909088E-02,   1.4586509E-02,   1.5252682E-02
     +,   1.5904702E-02,   1.6540520E-02,   1.7159011E-02
     +,   1.7760413E-02,   1.8346461E-02,   1.8920878E-02
     +,   1.9489584E-02,   2.0061245E-02,   2.0647535E-02
     +,   2.1263717E-02,   2.1929020E-02,   2.2667022E-02
     +,   2.3506114E-02,   2.4479829E-02,   2.5627058E-02
     +,   2.6991868E-02,   2.8623382E-02,   3.0574573E-02
     +,   3.2901000E-02,   3.5657715E-02,   3.8896170E-02
     +,   4.2658515E-02,   4.6972506E-02,   5.1843859E-02
     +,   5.7250720E-02,   6.3138030E-02,   6.9414377E-02
     +,   7.5953349E-02,   8.2599983E-02,   8.9181550E-02
     +,   9.5522881E-02,   0.1014663    ,   0.1068919    
     +,   0.1117342    ,   0.1159951    ,   0.1197478    
     +,   0.1231315    ,   0.1263353    ,   0.1295751    
     +,   0.1330634    ,   0.1369810    ,   0.1414526    
     +,   0.1465390    ,   0.1522491    ,   0.1585763    
     +,   0.1655492    ,   0.1732868    ,   0.1820302    
     +,   0.1921301    ,   0.2039835    ,   0.2179326    
     +,   0.2341526    ,   0.2525633    ,   0.2727924    
     +,   0.2941974    ,   0.3159365    ,   0.3370705    
     +,   0.3566730    ,   0.3739133    ,   0.3881096    
     +,   0.3988169    ,   0.4060808    ,   0.4109923    
     +,   0.4165130    ,   0.4281809    ,   0.4537900    
     +,   0.5010780    ,   0.5734908    ,   0.6662031    
     +,   0.7657346    ,   0.8548576    ,   0.9208814    
     +,   0.9627908    ,   0.9923574    ,    1.027145    
     +,    1.078942    ,    1.145354    ,    1.210455    
     +,    1.254755    ,    1.268738    ,    1.260035    
     +,    1.248295    ,    1.252573    ,    1.282538    
     +,    1.341724    ,    1.436594    ,    1.570755    
     +,    1.721567    ,    1.833848    ,    1.851442    
     +,    1.751598    ,    1.546335    ,    1.266364    
     +,   0.9525678    ,   0.6504728    ,   0.3986563    
     +,   0.2171181    ,   0.1043045    ,   4.4010345E-02
     +,   1.6286800E-02,   5.2890410E-03,   1.5090025E-03
     +,   3.7843350E-04,   8.3346466E-05,   1.6101309E-05
     +,   2.7437904E-06,   4.3481106E-07,   8.5085418E-08
     +,   3.5371581E-08,   2.5711060E-08,   2.1183736E-08
     +,   1.7707769E-08,   1.4803740E-08,   1.2359480E-08
     +,   1.0303733E-08,   8.5772740E-09,   7.1296067E-09
     +,   5.9176042E-09,   4.9044324E-09,   4.0587351E-09
     +,   3.3539316E-09,   2.7674678E-09,   2.2802005E-09
     +,   1.8759534E-09,   1.5411185E-09,   1.2641888E-09
     +,   1.0354916E-09,   8.4692220E-10,   6.9167949E-10
     +,   5.6406341E-10,   4.5931484E-10,   3.7346856E-10
     +,   3.0322389E-10,   2.4582922E-10,   1.9900492E-10
     +,   1.6086257E-10,   1.2984075E-10,   1.0464762E-10
     +,   8.4218292E-11,   6.7678071E-11,   5.4306507E-11
     +,   4.3512503E-11,   3.4812778E-11,   2.7811742E-11
     +,   2.2186015E-11,   1.7672154E-11,   1.4055985E-11
     +,   1.1163417E-11,   8.8531361E-12,   7.0105896E-12
     +,   5.5433670E-12,   4.3768179E-12,   3.4506759E-12
     +,   2.7165002E-12,   2.1354056E-12,   1.6761492E-12
     +,   1.3137239E-12,   1.0281499E-12,   8.0348060E-13
     +,   6.2698219E-13,   4.8853348E-13,   3.8009762E-13
     +,   2.9529891E-13,   2.2908167E-13,   1.7745050E-13
     +,   1.3725532E-13,   1.0600867E-13,   8.1755668E-14
     +,   6.2958278E-14,   4.8412192E-14,   3.7171861E-14
     +,   2.8499677E-14,   2.1818422E-14,   1.6679141E-14
     +,   1.2731569E-14,   9.7041397E-15,   7.3857444E-15
     +,   5.6129269E-15,   4.2594305E-15,   3.2275407E-15
     +,   2.4420707E-15,   1.8450307E-15,   1.3919236E-15
     +,   1.0485407E-15,   7.8871949E-16,   5.9240516E-16
     +,   4.4430467E-16,   3.3273715E-16,   2.4882225E-16
     +,   1.8579566E-16,   1.3853234E-16
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_asha_htt120_mass = Yx/10.4316426666667
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_asha_htt60_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.3667551E-03,   3.4868449E-03
     +,   3.6123351E-03,   3.7436578E-03,   3.8812838E-03
     +,   4.0257159E-03,   4.1774972E-03,   4.3371990E-03
     +,   4.5054266E-03,   4.6828254E-03,   4.8700618E-03
     +,   5.0678309E-03,   5.2768486E-03,   5.4978523E-03
     +,   5.7315910E-03,   5.9788181E-03,   6.2402948E-03
     +,   6.5167700E-03,   6.8089822E-03,   7.1176579E-03
     +,   7.4434881E-03,   7.7871378E-03,   8.1492271E-03
     +,   8.5303625E-03,   8.9310696E-03,   9.3518700E-03
     +,   9.7932275E-03,   1.0255588E-02,   1.0739379E-02
     +,   1.1245038E-02,   1.1773034E-02,   1.2323900E-02
     +,   1.2898292E-02,   1.3497035E-02,   1.4121190E-02
     +,   1.4772138E-02,   1.5451696E-02,   1.6162189E-02
     +,   1.6906653E-02,   1.7688835E-02,   1.8513538E-02
     +,   1.9386576E-02,   2.0315077E-02,   2.1307550E-02
     +,   2.2374094E-02,   2.3526514E-02,   2.4778513E-02
     +,   2.6145810E-02,   2.7646432E-02,   2.9300876E-02
     +,   3.1132603E-02,   3.3168443E-02,   3.5439245E-02
     +,   3.7980866E-02,   4.0834751E-02,   4.4049453E-02
     +,   4.7681160E-02,   5.1794726E-02,   5.6463789E-02
     +,   6.1770409E-02,   6.7803428E-02,   7.4655809E-02
     +,   8.2419619E-02,   9.1181539E-02,   0.1010154    
     +,   0.1119739    ,   0.1240841    ,   0.1373393    
     +,   0.1516996    ,   0.1670906    ,   0.1834125    
     +,   0.2005456    ,   0.2183665    ,   0.2367537    
     +,   0.2555964    ,   0.2747896    ,   0.2942185    
     +,   0.3137381    ,   0.3331492    ,   0.3521790    
     +,   0.3704782    ,   0.3876492    ,   0.4032886    
     +,   0.4170560    ,   0.4287348    ,   0.4382837    
     +,   0.4458582    ,   0.4518092    ,   0.4566705    
     +,   0.4611529    ,   0.4661569    ,   0.4727980    
     +,   0.4824121    ,   0.4964903    ,   0.5164892    
     +,   0.5434963    ,   0.5778173    ,   0.6185976    
     +,   0.6637040    ,   0.7099845    ,   0.7539812    
     +,   0.7928828    ,   0.8254349    ,   0.8523885    
     +,   0.8762935    ,   0.9005966    ,   0.9283312    
     +,   0.9608307    ,   0.9970632    ,    1.034035    
     +,    1.068285    ,    1.097821    ,    1.123161    
     +,    1.146629    ,    1.170252    ,    1.194132    
     +,    1.217086    ,    1.239329    ,    1.264771    
     +,    1.300592    ,    1.354333    ,    1.430810    
     +,    1.530472    ,    1.649096    ,    1.778606    
     +,    1.909094    ,    2.030653    ,    2.133012    
     +,    2.204900    ,    2.237730    ,    2.232447    
     +,    2.200566    ,    2.155431    ,    2.103404    
     +,    2.045124    ,    1.981785    ,    1.914907    
     +,    1.840844    ,    1.750952    ,    1.639642    
     +,    1.510840    ,    1.375760    ,    1.245763    
     +,    1.127729    ,    1.024208    ,   0.9354252    
     +,   0.8604231    ,   0.7971573    ,   0.7426756    
     +,   0.6938034    ,   0.6479369    ,   0.6034648    
     +,   0.5597603    ,   0.5169566    ,   0.4756952    
     +,   0.4368936    ,   0.4015226    ,   0.3703891    
     +,   0.3439801    ,   0.3223874    ,   0.3053228    
     +,   0.2922169    ,   0.2823428    ,   0.2749361    
     +,   0.2692825    ,   0.2647707    ,   0.2609095    
     +,   0.2573240    ,   0.2537370    ,   0.2499510    
     +,   0.2458302    ,   0.2412872    ,   0.2362722    
     +,   0.2307678    ,   0.2247833    ,   0.2183494    
     +,   0.2115144    ,   0.2043399    ,   0.1968959    
     +,   0.1892558    ,   0.1814927    ,   0.1736763    
     +,   0.1658680    ,   0.1581187    ,   0.1504666    
     +,   0.1429372    ,   0.1355431    ,   0.1282856    
     +,   0.1211575    ,   0.1141481    ,   0.1072453    
     +,   0.1004397    ,   9.3728319E-02,   8.7115690E-02
     +,   8.0614626E-02,   7.4245855E-02,   6.8037264E-02
     +,   6.2021319E-02,   5.6232370E-02,   5.0704278E-02
     +,   4.5468483E-02,   4.0551569E-02,   3.5973534E-02
     +,   3.1747349E-02,   2.7878961E-02,   2.4366712E-02
     +,   2.1202495E-02,   1.8372871E-02,   1.5859893E-02
     +,   1.3642188E-02,   1.1696318E-02,   9.9979518E-03
     +,   8.5225673E-03,   7.2461511E-03,   6.1458573E-03
     +,   5.2004601E-03,   4.3904660E-03,   3.6982105E-03
     +,   3.1079187E-03,   2.6056855E-03,   2.1792483E-03
     +,   1.8179115E-03,   1.5124037E-03,   1.2546891E-03
     +,   1.0378053E-03,   8.5574819E-04,   7.0335332E-04
     +,   5.7616865E-04,   4.7035268E-04,   3.8260501E-04
     +,   3.1009584E-04,   2.5039806E-04,   2.0143023E-04
     +,   1.6141777E-04,   1.2885396E-04,   1.0245787E-04
     +,   8.1148006E-05,   6.4015847E-05,   5.0300165E-05
     +,   3.9365259E-05,   3.0683776E-05,   2.3820683E-05
     +,   1.8418246E-05,   1.4183493E-05,   1.0878020E-05
     +,   8.3089926E-06,   6.3208913E-06,   4.7888557E-06
     +,   3.6132756E-06,   2.7151359E-06,   2.0318771E-06
     +,   1.5143065E-06,   1.1239492E-06,   8.3081738E-07
     +,   6.1163905E-07,   4.4846129E-07,   3.2750884E-07
     +,   2.3824593E-07,   1.7265334E-07,   1.2466101E-07
     +,   8.9698794E-08,   6.4337833E-08,   4.6018020E-08
     +,   3.2838383E-08,   2.3394964E-08,   1.6654008E-08
     +,   1.1859037E-08,   8.4593168E-09,   6.0554828E-09
     +,   4.3593200E-09,   3.1639660E-09,   2.3217255E-09
     +,   1.7275436E-09,   1.3070504E-09,   1.0078663E-09
     +,   7.9328749E-10,   6.3765809E-10,   5.2315147E-10
     +,   4.3739562E-10,   3.7185402E-10,   3.2063302E-10
     +,   2.7967811E-10,   2.4618824E-10,   2.1823382E-10
     +,   1.9447327E-10,   1.7396963E-10,   1.5605603E-10
     +,   1.4025561E-10,   1.2621867E-10,   1.1367993E-10
     +,   1.0243681E-10,   9.2328319E-11,   8.3223435E-11
     +,   7.5011747E-11,   6.7600439E-11,   6.0908813E-11
     +,   5.4866067E-11,   4.9408606E-11,   4.4480607E-11
     +,   4.0031426E-11,   3.6015701E-11
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_asha_htt60_mass = Yx/22.4129708510638
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_asha_htt65_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.8618785E-03,   3.9833570E-03
     +,   4.1092322E-03,   4.2395415E-03,   4.3743108E-03
     +,   4.5135594E-03,   4.6572913E-03,   4.8054997E-03
     +,   4.9581630E-03,   5.1152590E-03,   5.2767429E-03
     +,   5.4425658E-03,   5.6126635E-03,   5.7869679E-03
     +,   5.9654000E-03,   6.1478759E-03,   6.3343043E-03
     +,   6.5245940E-03,   6.7186491E-03,   6.9163800E-03
     +,   7.1176928E-03,   7.3225028E-03,   7.5307330E-03
     +,   7.7423318E-03,   7.9572331E-03,   8.1754168E-03
     +,   8.3968742E-03,   8.6216191E-03,   8.8497009E-03
     +,   9.0812072E-03,   9.3162637E-03,   9.5550511E-03
     +,   9.7978096E-03,   1.0044843E-02,   1.0296556E-02
     +,   1.0553447E-02,   1.0816150E-02,   1.1085448E-02
     +,   1.1362328E-02,   1.1647985E-02,   1.1943917E-02
     +,   1.2251952E-02,   1.2574313E-02,   1.2913702E-02
     +,   1.3273359E-02,   1.3657155E-02,   1.4069652E-02
     +,   1.4516198E-02,   1.5002967E-02,   1.5537002E-02
     +,   1.6126269E-02,   1.6779620E-02,   1.7506743E-02
     +,   1.8318191E-02,   1.9225098E-02,   2.0239247E-02
     +,   2.1372739E-02,   2.2637917E-02,   2.4047155E-02
     +,   2.5612654E-02,   2.7346404E-02,   2.9259985E-02
     +,   3.1364463E-02,   3.3670615E-02,   3.6188845E-02
     +,   3.8929008E-02,   4.1901015E-02,   4.5114182E-02
     +,   4.8577890E-02,   5.2300710E-02,   5.6290898E-02
     +,   6.0555167E-02,   6.5099441E-02,   6.9927499E-02
     +,   7.5042263E-02,   8.0446340E-02,   8.6143531E-02
     +,   9.2142768E-02,   9.8463193E-02,   0.1051408    
     +,   0.1122354    ,   0.1198414    ,   0.1280936    
     +,   0.1371759    ,   0.1473219    ,   0.1588154    
     +,   0.1719804    ,   0.1871688    ,   0.2047356    
     +,   0.2250140    ,   0.2482794    ,   0.2747096    
     +,   0.3043543    ,   0.3371254    ,   0.3728170    
     +,   0.4111713    ,   0.4519906    ,   0.4952202    
     +,   0.5409763    ,   0.5894063    ,   0.6404446    
     +,   0.6934972    ,   0.7472851    ,   0.7999644    
     +,   0.8496349    ,   0.8950888    ,   0.9365608    
     +,   0.9761022    ,    1.017258    ,    1.063895    
     +,    1.118512    ,    1.180861    ,    1.247884    
     +,    1.315398    ,    1.380479    ,    1.442586    
     +,    1.502235    ,    1.558456    ,    1.607713    
     +,    1.645632    ,    1.670205    ,    1.684314    
     +,    1.696402    ,    1.718988    ,    1.765217    
     +,    1.844448    ,    1.958019    ,    2.095986    
     +,    2.237953    ,    2.361816    ,    2.457493    
     +,    2.531772    ,    2.595886    ,    2.649122    
     +,    2.682437    ,    2.699330    ,    2.720523    
     +,    2.759308    ,    2.801567    ,    2.818546    
     +,    2.791069    ,    2.714471    ,    2.588888    
     +,    2.415202    ,    2.200710    ,    1.963786    
     +,    1.730054    ,    1.523011    ,    1.356611    
     +,    1.233331    ,    1.146408    ,    1.083966    
     +,    1.033460    ,   0.9850819    ,   0.9333333    
     +,   0.8769580    ,   0.8178052    ,   0.7592353    
     +,   0.7045372    ,   0.6557664    ,   0.6132756    
     +,   0.5760105    ,   0.5422724    ,   0.5105152    
     +,   0.4798525    ,   0.4501405    ,   0.4217448    
     +,   0.3951918    ,   0.3708775    ,   0.3489339    
     +,   0.3292369    ,   0.3114939    ,   0.2953542    
     +,   0.2804927    ,   0.2666512    ,   0.2536417    
     +,   0.2413274    ,   0.2296014    ,   0.2183682    
     +,   0.2075351    ,   0.1970159    ,   0.1867373    
     +,   0.1766468    ,   0.1667167    ,   0.1569451    
     +,   0.1473537    ,   0.1379792    ,   0.1288658    
     +,   0.1200572    ,   0.1115921    ,   0.1034983    
     +,   9.5792107E-02,   8.8479362E-02,   8.1557028E-02
     +,   7.5015083E-02,   6.8840221E-02,   6.3018277E-02
     +,   5.7536036E-02,   5.2381553E-02,   4.7545351E-02
     +,   4.3020260E-02,   3.8800463E-02,   3.4880627E-02
     +,   3.1255241E-02,   2.7918223E-02,   2.4861725E-02
     +,   2.2076188E-02,   1.9550409E-02,   1.7271413E-02
     +,   1.5224612E-02,   1.3394325E-02,   1.1764299E-02
     +,   1.0317959E-02,   9.0387315E-03,   7.9104835E-03
     +,   6.9178697E-03,   6.0464321E-03,   5.2826847E-03
     +,   4.6142754E-03,   4.0300461E-03,   3.5198920E-03
     +,   3.0747869E-03,   2.6867338E-03,   2.3486479E-03
     +,   2.0542550E-03,   1.7980306E-03,   1.5751325E-03
     +,   1.3813032E-03,   1.2127893E-03,   1.0662979E-03
     +,   9.3894912E-04,   8.2821544E-04,   7.3187629E-04
     +,   6.4799102E-04,   5.7487289E-04,   5.1104528E-04
     +,   4.5522640E-04,   4.0630938E-04,   3.6333795E-04
     +,   3.2548601E-04,   2.9204530E-04,   2.6241210E-04
     +,   2.3607101E-04,   2.1258181E-04,   1.9157089E-04
     +,   1.7272276E-04,   1.5576999E-04,   1.4048477E-04
     +,   1.2667400E-04,   1.1417454E-04,   1.0284606E-04
     +,   9.2568327E-05,   8.3238214E-05,   7.4766162E-05
     +,   6.7073277E-05,   6.0090060E-05,   5.3755146E-05
     +,   4.8013455E-05,   4.2814845E-05,   3.8113823E-05
     +,   3.3869001E-05,   3.0042291E-05,   2.6598253E-05
     +,   2.3504170E-05,   2.0729911E-05,   1.8247239E-05
     +,   1.6029957E-05,   1.4053887E-05,   1.2296571E-05
     +,   1.0737126E-05,   9.3562394E-06,   8.1362004E-06
     +,   7.0607125E-06,   6.1147152E-06,   5.2844689E-06
     +,   4.5574925E-06,   3.9223323E-06,   3.3686765E-06
     +,   2.8871302E-06,   2.4692699E-06,   2.1074682E-06
     +,   1.7949303E-06,   1.5255407E-06,   1.2938779E-06
     +,   1.0950944E-06,   9.2491825E-07,   7.7955269E-07
     +,   6.5565604E-07,   5.5029972E-07,   4.6090452E-07
     +,   3.8522560E-07,   3.2129762E-07,   2.6741930E-07
     +,   2.2210864E-07,   1.8409044E-07,   1.5225973E-07
     +,   1.2566983E-07,   1.0350590E-07,   8.5073104E-08
     +,   6.9776100E-08,   5.7110309E-08
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_asha_htt65_mass = Yx/26.9406485833333
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_asha_htt70_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.8755394E-03,   1.9303509E-03
     +,   1.9864575E-03,   2.0439157E-03,   2.1027906E-03
     +,   2.1631578E-03,   2.2251038E-03,   2.2887283E-03
     +,   2.3541434E-03,   2.4214813E-03,   2.4908883E-03
     +,   2.5625303E-03,   2.6365945E-03,   2.7132896E-03
     +,   2.7928490E-03,   2.8755295E-03,   2.9616151E-03
     +,   3.0514153E-03,   3.1452670E-03,   3.2435348E-03
     +,   3.3466085E-03,   3.4549052E-03,   3.5688633E-03
     +,   3.6889513E-03,   3.8156419E-03,   3.9494387E-03
     +,   4.0908479E-03,   4.2403843E-03,   4.3985620E-03
     +,   4.5658904E-03,   4.7428636E-03,   4.9299612E-03
     +,   5.1276241E-03,   5.3362669E-03,   5.5562533E-03
     +,   5.7878965E-03,   6.0314490E-03,   6.2870923E-03
     +,   6.5549561E-03,   6.8350588E-03,   7.1273758E-03
     +,   7.4317888E-03,   7.7481088E-03,   8.0760838E-03
     +,   8.4154112E-03,   8.7657478E-03,   9.1267424E-03
     +,   9.4980551E-03,   9.8794019E-03,   1.0270589E-02
     +,   1.0671573E-02,   1.1082516E-02,   1.1503844E-02
     +,   1.1936363E-02,   1.2381279E-02,   1.2840371E-02
     +,   1.3316018E-02,   1.3811355E-02,   1.4330367E-02
     +,   1.4877992E-02,   1.5460229E-02,   1.6084228E-02
     +,   1.6758323E-02,   1.7492130E-02,   1.8296530E-02
     +,   1.9183505E-02,   2.0166209E-02,   2.1258501E-02
     +,   2.2474939E-02,   2.3830028E-02,   2.5338085E-02
     +,   2.7012229E-02,   2.8864112E-02,   3.0902671E-02
     +,   3.3133805E-02,   3.5559386E-02,   3.8176473E-02
     +,   4.0976830E-02,   4.3946885E-02,   4.7067463E-02
     +,   5.0313834E-02,   5.3657025E-02,   5.7064183E-02
     +,   6.0500894E-02,   6.3932404E-02,   6.7326896E-02
     +,   7.0657834E-02,   7.3908277E-02,   7.7074476E-02
     +,   8.0171376E-02,   8.3237663E-02,   8.6340949E-02
     +,   8.9583009E-02,   9.3104169E-02,   9.7085692E-02
     +,   0.1017494    ,   0.1073576    ,   0.1142081    
     +,   0.1226337    ,   0.1329987    ,   0.1457047    
     +,   0.1611965    ,   0.1799774    ,   0.2026186    
     +,   0.2297692    ,   0.2621414    ,   0.3004577    
     +,   0.3453390    ,   0.3971220    ,   0.4556037    
     +,   0.5197985    ,   0.5878652    ,   0.6573099    
     +,   0.7255656    ,   0.7907311    ,   0.8522246    
     +,   0.9110690    ,   0.9698167    ,    1.032072    
     +,    1.101426    ,    1.179711    ,    1.265383    
     +,    1.353730    ,    1.439473    ,    1.520066    
     +,    1.597751    ,    1.681133    ,    1.786910    
     +,    1.936858    ,    2.142675    ,    2.386256    
     +,    2.620809    ,    2.803175    ,    2.922252    
     +,    2.988663    ,    3.014464    ,    3.027140    
     +,    3.083525    ,    3.230588    ,    3.455873    
     +,    3.688586    ,    3.850976    ,    3.926900    
     +,    3.964170    ,    3.990027    ,    3.960941    
     +,    3.822052    ,    3.587214    ,    3.323344    
     +,    3.071661    ,    2.818681    ,    2.539825    
     +,    2.241036    ,    1.952348    ,    1.702054    
     +,    1.503642    ,    1.356217    ,    1.250054    
     +,    1.172559    ,    1.111830    ,    1.057865    
     +,    1.003203    ,   0.9436918    ,   0.8788247    
     +,   0.8111719    ,   0.7450400    ,   0.6848245    
     +,   0.6336070    ,   0.5923389    ,   0.5598041    
     +,   0.5332218    ,   0.5092234    ,   0.4848153    
     +,   0.4580381    ,   0.4282169    ,   0.3958350    
     +,   0.3621866    ,   0.3289419    ,   0.2977303    
     +,   0.2698305    ,   0.2460031    ,   0.2264626    
     +,   0.2109512    ,   0.1988758    ,   0.1894633    
     +,   0.1818950    ,   0.1754080    ,   0.1693579    
     +,   0.1632522    ,   0.1567578    ,   0.1496903    
     +,   0.1419942    ,   0.1337170    ,   0.1249793    
     +,   0.1159451    ,   0.1067971    ,   9.7715631E-02
     +,   8.8862412E-02,   8.0370314E-02,   7.2339490E-02
     +,   6.4837560E-02,   5.7902046E-02,   5.1544789E-02
     +,   4.5758069E-02,   4.0520772E-02,   3.5802118E-02
     +,   3.1566322E-02,   2.7775794E-02,   2.4392944E-02
     +,   2.1381207E-02,   1.8706048E-02,   1.6335392E-02
     +,   1.4239460E-02,   1.2390560E-02,   1.0763174E-02
     +,   9.3338992E-03,   8.0812257E-03,   6.9853775E-03
     +,   6.0283565E-03,   5.1939436E-03,   4.4674519E-03
     +,   3.8357379E-03,   3.2871549E-03,   2.8113725E-03
     +,   2.3992590E-03,   2.0427911E-03,   1.7349551E-03
     +,   1.4696006E-03,   1.2413197E-03,   1.0453726E-03
     +,   8.7761116E-04,   7.3438417E-04,   6.1246788E-04
     +,   5.0902378E-04,   4.2155912E-04,   3.4786828E-04
     +,   2.8601172E-04,   2.3429000E-04,   1.9121324E-04
     +,   1.5547810E-04,   1.2595166E-04,   1.0165454E-04
     +,   8.1742095E-05,   6.5488341E-05,   5.2273943E-05
     +,   4.1573850E-05,   3.2944241E-05,   2.6011592E-05
     +,   2.0463718E-05,   1.6041453E-05,   1.2529787E-05
     +,   9.7517486E-06,   7.5624544E-06,   5.8436744E-06
     +,   4.4992876E-06,   3.4516454E-06,   2.6383304E-06
     +,   2.0093100E-06,   1.5246309E-06,   1.1525660E-06
     +,   8.6804152E-07,   6.5129694E-07,   4.8681216E-07
     +,   3.6246638E-07,   2.6883762E-07,   1.9861288E-07
     +,   1.4615016E-07,   1.0711546E-07,   7.8190666E-08
     +,   5.6844275E-08,   4.1155420E-08,   2.9673258E-08
     +,   2.1305453E-08,   1.5233018E-08,   1.0845058E-08
     +,   7.6882429E-09,   5.4268701E-09,   3.8141681E-09
     +,   2.6690652E-09,   1.8596510E-09,   1.2900301E-09
     +,   8.9099206E-10,   6.1269245E-10,   4.1948897E-10
     +,   2.8595995E-10,   1.9409840E-10,   1.3118601E-10
     +,   8.8293428E-11,   5.9183276E-11,   3.9513996E-11
     +,   2.6283279E-11,   1.7421635E-11,   1.1511754E-11
     +,   7.5863361E-12,   4.9893648E-12,   3.2773990E-12
     +,   2.1526051E-12,   1.4156118E-12,   9.3378387E-13
     +,   6.1916130E-13,   4.1376551E-13
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_asha_htt70_mass = Yx/30.1658471428571
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_asha_htt75_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.7370284E-03,   1.8148463E-03
     +,   1.8951842E-03,   1.9780335E-03,   2.0633771E-03
     +,   2.1511889E-03,   2.2414338E-03,   2.3340676E-03
     +,   2.4290346E-03,   2.5262737E-03,   2.6257106E-03
     +,   2.7272610E-03,   2.8308334E-03,   2.9363255E-03
     +,   3.0436278E-03,   3.1526203E-03,   3.2631774E-03
     +,   3.3751666E-03,   3.4884498E-03,   3.6028868E-03
     +,   3.7183329E-03,   3.8346462E-03,   3.9516850E-03
     +,   4.0693195E-03,   4.1874214E-03,   4.3058852E-03
     +,   4.4246200E-03,   4.5435624E-03,   4.6626837E-03
     +,   4.7819959E-03,   4.9015614E-03,   5.0215088E-03
     +,   5.1420415E-03,   5.2634520E-03,   5.3861421E-03
     +,   5.5106380E-03,   5.6376085E-03,   5.7678861E-03
     +,   5.9025004E-03,   6.0426737E-03,   6.1898739E-03
     +,   6.3458113E-03,   6.5124743E-03,   6.6921338E-03
     +,   6.8873637E-03,   7.1010403E-03,   7.3363441E-03
     +,   7.5967456E-03,   7.8859851E-03,   8.2080439E-03
     +,   8.5670929E-03,   8.9674303E-03,   9.4134035E-03
     +,   9.9093597E-03,   1.0459460E-02,   1.1067680E-02
     +,   1.1737587E-02,   1.2472275E-02,   1.3274222E-02
     +,   1.4145159E-02,   1.5085957E-02,   1.6096557E-02
     +,   1.7175771E-02,   1.8321419E-02,   1.9530194E-02
     +,   2.0797566E-02,   2.2118090E-02,   2.3485180E-02
     +,   2.4891602E-02,   2.6329251E-02,   2.7789788E-02
     +,   2.9264448E-02,   3.0744763E-02,   3.2222427E-02
     +,   3.3689972E-02,   3.5140846E-02,   3.6569659E-02
     +,   3.7972476E-02,   3.9347060E-02,   4.0692903E-02
     +,   4.2011093E-02,   4.3304544E-02,   4.4577498E-02
     +,   4.5835581E-02,   4.7085159E-02,   4.8333250E-02
     +,   4.9586821E-02,   5.0852813E-02,   5.2137341E-02
     +,   5.3446017E-02,   5.4783739E-02,   5.6154869E-02
     +,   5.7563987E-02,   5.9016809E-02,   6.0521383E-02
     +,   6.2089615E-02,   6.3739479E-02,   6.5496698E-02
     +,   6.7397520E-02,   6.9490291E-02,   7.1837753E-02
     +,   7.4517794E-02,   7.7624924E-02,   8.1269443E-02
     +,   8.5577518E-02,   9.0690471E-02,   9.6763492E-02
     +,   0.1039662    ,   0.1124848    ,   0.1225265    
     +,   0.1343264    ,   0.1481616    ,   0.1643608    
     +,   0.1833178    ,   0.2054858    ,   0.2313709    
     +,   0.2615148    ,   0.2965282    ,   0.3371866    
     +,   0.3846182    ,   0.4404293    ,   0.5065007    
     +,   0.5841889    ,   0.6730433    ,   0.7698018    
     +,   0.8688414    ,   0.9646319    ,    1.054946    
     +,    1.142406    ,    1.232501    ,    1.329409    
     +,    1.433305    ,    1.541860    ,    1.655257    
     +,    1.783710    ,    1.953161    ,    2.194220    
     +,    2.507648    ,    2.841720    ,    3.124984    
     +,    3.330539    ,    3.500564    ,    3.704308    
     +,    3.969660    ,    4.262912    ,    4.543318    
     +,    4.781771    ,    4.924690    ,    4.943374    
     +,    4.889045    ,    4.837404    ,    4.842454    
     +,    4.842906    ,    4.699200    ,    4.402644    
     +,    4.041380    ,    3.650599    ,    3.242173    
     +,    2.855072    ,    2.513446    ,    2.208385    
     +,    1.934387    ,    1.703460    ,    1.521438    
     +,    1.376610    ,    1.255368    ,    1.154447    
     +,    1.075011    ,    1.013085    ,   0.9591414    
     +,   0.9041656    ,   0.8441641    ,   0.7800663    
     +,   0.7150776    ,   0.6523483    ,   0.5939925    
     +,   0.5410625    ,   0.4938129    ,   0.4519661    
     +,   0.4149490    ,   0.3820972    ,   0.3527910    
     +,   0.3265063    ,   0.3028177    ,   0.2813817    
     +,   0.2619189    ,   0.2441960    ,   0.2280088    
     +,   0.2131713    ,   0.1995050    ,   0.1868325    
     +,   0.1749803    ,   0.1637851    ,   0.1531020    
     +,   0.1428114    ,   0.1328258    ,   0.1230927    
     +,   0.1135931    ,   0.1043365    ,   9.5355615E-02
     +,   8.6698577E-02,   7.8420296E-02,   7.0574246E-02
     +,   6.3206822E-02,   5.6353707E-02,   5.0035991E-02
     +,   4.4260696E-02,   3.9022025E-02,   3.4303028E-02
     +,   3.0077858E-02,   2.6314853E-02,   2.2979164E-02
     +,   2.0034458E-02,   1.7444359E-02,   1.5173811E-02
     +,   1.3189848E-02,   1.1461835E-02,   9.9614803E-03
     +,   8.6629763E-03,   7.5429790E-03,   6.5801991E-03
     +,   5.7553803E-03,   5.0511626E-03,   4.4518709E-03
     +,   3.9433548E-03,   3.5129362E-03,   3.1493255E-03
     +,   2.8424980E-03,   2.5835973E-03,   2.3648783E-03
     +,   2.1796345E-03,   2.0220932E-03,   1.8873240E-03
     +,   1.7711642E-03,   1.6701393E-03,   1.5813638E-03
     +,   1.5024683E-03,   1.4315315E-03,   1.3670069E-03
     +,   1.3076583E-03,   1.2525083E-03,   1.2007974E-03
     +,   1.1519372E-03,   1.1054729E-03,   1.0610608E-03
     +,   1.0184443E-03,   9.7743364E-04,   9.3788607E-04
     +,   8.9969754E-04,   8.6279598E-04,   8.2712632E-04
     +,   7.9264730E-04,   7.5933110E-04,   7.2715536E-04
     +,   6.9609977E-04,   6.6614622E-04,   6.3727901E-04
     +,   6.0948235E-04,   5.8273721E-04,   5.5702374E-04
     +,   5.3232192E-04,   5.0861033E-04,   4.8586426E-04
     +,   4.6405775E-04,   4.4316569E-04,   4.2315977E-04
     +,   4.0401082E-04,   3.8569048E-04,   3.6816963E-04
     +,   3.5141790E-04,   3.3540497E-04,   3.2010168E-04
     +,   3.0547910E-04,   2.9150781E-04,   2.7815887E-04
     +,   2.6540566E-04,   2.5322035E-04,   2.4157777E-04
     +,   2.3045196E-04,   2.1981951E-04,   2.0965653E-04
     +,   1.9994155E-04,   1.9065275E-04,   1.8177064E-04
     +,   1.7327545E-04,   1.6514963E-04,   1.5737563E-04
     +,   1.4993706E-04,   1.4281896E-04,   1.3600635E-04
     +,   1.2948595E-04,   1.2324451E-04,   1.1727019E-04
     +,   1.1155112E-04,   1.0607684E-04,   1.0083675E-04
     +,   9.5821510E-05,   9.1021662E-05,   8.6428881E-05
     +,   8.2034639E-05,   7.7831457E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_asha_htt75_mass = Yx/33.18380044
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_asha_htt80_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.0424753E-03,   3.1425431E-03
     +,   3.2433209E-03,   3.3445407E-03,   3.4459303E-03
     +,   3.5472137E-03,   3.6481204E-03,   3.7483806E-03
     +,   3.8477380E-03,   3.9459555E-03,   4.0428098E-03
     +,   4.1381079E-03,   4.2316844E-03,   4.3234145E-03
     +,   4.4132154E-03,   4.5010517E-03,   4.5869453E-03
     +,   4.6709753E-03,   4.7532897E-03,   4.8341057E-03
     +,   4.9137166E-03,   4.9924958E-03,   5.0708996E-03
     +,   5.1494781E-03,   5.2288566E-03,   5.3097624E-03
     +,   5.3930059E-03,   5.4794848E-03,   5.5701812E-03
     +,   5.6661563E-03,   5.7685412E-03,   5.8785318E-03
     +,   5.9973737E-03,   6.1263498E-03,   6.2667686E-03
     +,   6.4199413E-03,   6.5871654E-03,   6.7696972E-03
     +,   6.9687497E-03,   7.1854219E-03,   7.4207312E-03
     +,   7.6755430E-03,   7.9505537E-03,   8.2462756E-03
     +,   8.5630016E-03,   8.9007830E-03,   9.2594046E-03
     +,   9.6383747E-03,   1.0036903E-02,   1.0453895E-02
     +,   1.0887953E-02,   1.1337371E-02,   1.1800144E-02
     +,   1.2274029E-02,   1.2756484E-02,   1.3244816E-02
     +,   1.3736142E-02,   1.4227484E-02,   1.4715854E-02
     +,   1.5198298E-02,   1.5672017E-02,   1.6134476E-02
     +,   1.6583459E-02,   1.7017301E-02,   1.7434955E-02
     +,   1.7836098E-02,   1.8221403E-02,   1.8592557E-02
     +,   1.8952550E-02,   1.9305699E-02,   1.9657919E-02
     +,   2.0016709E-02,   2.0391367E-02,   2.0792915E-02
     +,   2.1234168E-02,   2.1729629E-02,   2.2295253E-02
     +,   2.2948187E-02,   2.3706369E-02,   2.4588017E-02
     +,   2.5610788E-02,   2.6791265E-02,   2.8143739E-02
     +,   2.9679580E-02,   3.1405900E-02,   3.3325020E-02
     +,   3.5433169E-02,   3.7720304E-02,   4.0169206E-02
     +,   4.2755906E-02,   4.5449752E-02,   4.8214007E-02
     +,   5.1007096E-02,   5.3784430E-02,   5.6500077E-02
     +,   5.9108771E-02,   6.1568756E-02,   6.3843586E-02
     +,   6.5905124E-02,   6.7734770E-02,   6.9326036E-02
     +,   7.0685059E-02,   7.1831994E-02,   7.2800651E-02
     +,   7.3638692E-02,   7.4406832E-02,   7.5177476E-02
     +,   7.6034017E-02,   7.7069752E-02,   7.8387164E-02
     +,   8.0097653E-02,   8.2322568E-02,   8.5193306E-02
     +,   8.8853002E-02,   9.3455121E-02,   9.9162415E-02
     +,   0.1061398    ,   0.1145459    ,   0.1245173    
     +,   0.1361528    ,   0.1494933    ,   0.1645036    
     +,   0.1810595    ,   0.1989488    ,   0.2178870    
     +,   0.2375594    ,   0.2576988    ,   0.2781800    
     +,   0.2991334    ,   0.3210271    ,   0.3447208    
     +,   0.3714773    ,   0.4030007    ,   0.4415497    
     +,   0.4901736    ,   0.5529244    ,   0.6346110    
     +,   0.7394003    ,   0.8679387    ,    1.014671    
     +,    1.169776    ,    1.328507    ,    1.501420    
     +,    1.712546    ,    1.984100    ,    2.322312    
     +,    2.713978    ,    3.135099    ,    3.570111    
     +,    4.022748    ,    4.505681    ,    4.989258    
     +,    5.375244    ,    5.671296    ,    6.017338    
     +,    6.421152    ,    6.753009    ,    6.912570    
     +,    6.820081    ,    6.454400    ,    5.912979    
     +,    5.224340    ,    4.416811    ,    3.670201    
     +,    3.160158    ,    2.876928    ,    2.683699    
     +,    2.473995    ,    2.229913    ,    1.988311    
     +,    1.785860    ,    1.626447    ,    1.489389    
     +,    1.358969    ,    1.237269    ,    1.133062    
     +,    1.048514    ,   0.9774362    ,   0.9109946    
     +,   0.8430344    ,   0.7719347    ,   0.6996981    
     +,   0.6298882    ,   0.5657640    ,   0.5092431    
     +,   0.4607078    ,   0.4193593    ,   0.3837887    
     +,   0.3524926    ,   0.3241972    ,   0.2979718    
     +,   0.2732200    ,   0.2496115    ,   0.2270084    
     +,   0.2053998    ,   0.1848536    ,   0.1654748    
     +,   0.1473685    ,   0.1306145    ,   0.1152541    
     +,   0.1012875    ,   8.8677704E-02,   7.7359334E-02
     +,   6.7250043E-02,   5.8260620E-02,   5.0299466E-02
     +,   4.3277208E-02,   3.7108827E-02,   3.1713329E-02
     +,   2.7013343E-02,   2.2935618E-02,   1.9411346E-02
     +,   1.6376173E-02,   1.3770497E-02,   1.1540071E-02
     +,   9.6363090E-03,   8.0159968E-03,   6.6409842E-03
     +,   5.4778988E-03,   4.4977241E-03,   3.6750338E-03
     +,   2.9876395E-03,   2.4161655E-03,   1.9436178E-03
     +,   1.5550646E-03,   1.2374427E-03,   9.7937312E-04
     +,   7.7096978E-04,   6.0368946E-04,   4.7022058E-04
     +,   3.6436247E-04,   2.8089210E-04,   2.1544487E-04
     +,   1.6441137E-04,   1.2483523E-04,   9.4306393E-05
     +,   7.0879592E-05,   5.2997169E-05,   3.9418632E-05
     +,   2.9161987E-05,   2.1455573E-05,   1.5696967E-05
     +,   1.1417860E-05,   8.2561228E-06,   5.9336016E-06
     +,   4.2378811E-06,   3.0075082E-06,   2.1204323E-06
     +,   1.4850326E-06,   1.0329874E-06,   7.1358079E-07
     +,   4.8947010E-07,   3.3335289E-07,   2.2539402E-07
     +,   1.5128566E-07,   1.0079328E-07,   6.6652994E-08
     +,   4.3746400E-08,   2.8495041E-08,   1.8419367E-08
     +,   1.1815343E-08,   7.5209847E-09,   4.7505107E-09
     +,   2.9773122E-09,   1.8515290E-09,   1.1424657E-09
     +,   6.9943668E-10,   4.2486095E-10,   2.5605965E-10
     +,   1.5311616E-10,   9.0839725E-11,   5.3470284E-11
     +,   3.1227763E-11,   1.8094840E-11,   1.0402919E-11
     +,   5.9342687E-12,   3.3588857E-12,   1.8866222E-12
     +,   1.0516387E-12,   5.8187634E-13,   3.1965075E-13
     +,   1.7442113E-13,   9.4595203E-14,   5.1044435E-14
     +,   2.7448685E-14,   1.4746606E-14,   7.9453080E-15
     +,   4.3174523E-15,   2.3851613E-15,   1.3534568E-15
     +,   7.9818821E-16,   4.9445485E-16,   3.2380500E-16
     +,   2.2408418E-16,   1.6278205E-16,   1.2285316E-16
     +,   9.5302053E-17,   7.5302414E-17,   6.0197394E-17
     +,   4.8461670E-17,   3.9171551E-17
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_asha_htt80_mass = Yx/34.99443556
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_asha_htt85_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.8737970E-04,   4.2477049E-04
     +,   4.6525616E-04,   5.0900452E-04,   5.5617944E-04
     +,   6.0693879E-04,   6.6143204E-04,   7.1979826E-04
     +,   7.8216242E-04,   8.4863650E-04,   9.1931212E-04
     +,   9.9426077E-04,   1.0735309E-03,   1.1571455E-03
     +,   1.2451006E-03,   1.3373614E-03,   1.4338635E-03
     +,   1.5345091E-03,   1.6391673E-03,   1.7476721E-03
     +,   1.8598266E-03,   1.9753983E-03,   2.0941205E-03
     +,   2.2157053E-03,   2.3398218E-03,   2.4661291E-03
     +,   2.5942551E-03,   2.7238126E-03,   2.8544005E-03
     +,   2.9856106E-03,   3.1170319E-03,   3.2482541E-03
     +,   3.3788774E-03,   3.5085152E-03,   3.6368007E-03
     +,   3.7633935E-03,   3.8879847E-03,   4.0102969E-03
     +,   4.1301041E-03,   4.2472077E-03,   4.3614740E-03
     +,   4.4728047E-03,   4.5811594E-03,   4.6865456E-03
     +,   4.7890218E-03,   4.8886957E-03,   4.9857195E-03
     +,   5.0802901E-03,   5.1726424E-03,   5.2630440E-03
     +,   5.3517986E-03,   5.4392242E-03,   5.5256658E-03
     +,   5.6114830E-03,   5.6970394E-03,   5.7827141E-03
     +,   5.8688880E-03,   5.9559490E-03,   6.0442938E-03
     +,   6.1343289E-03,   6.2264833E-03,   6.3212127E-03
     +,   6.4190063E-03,   6.5204212E-03,   6.6260854E-03
     +,   6.7367065E-03,   6.8531241E-03,   6.9763069E-03
     +,   7.1073864E-03,   7.2476757E-03,   7.3987013E-03
     +,   7.5621945E-03,   7.7401404E-03,   7.9347389E-03
     +,   8.1484430E-03,   8.3839307E-03,   8.6440714E-03
     +,   8.9318994E-03,   9.2506018E-03,   9.6034491E-03
     +,   9.9937115E-03,   1.0424684E-02,   1.0899522E-02
     +,   1.1421338E-02,   1.1992996E-02,   1.2617296E-02
     +,   1.3296774E-02,   1.4033928E-02,   1.4831101E-02
     +,   1.5690697E-02,   1.6615272E-02,   1.7607495E-02
     +,   1.8670401E-02,   1.9807469E-02,   2.1022700E-02
     +,   2.2320492E-02,   2.3705879E-02,   2.5184151E-02
     +,   2.6761170E-02,   2.8442811E-02,   3.0235384E-02
     +,   3.2145210E-02,   3.4179140E-02,   3.6344420E-02
     +,   3.8649555E-02,   4.1104645E-02,   4.3721817E-02
     +,   4.6515919E-02,   4.9504820E-02,   5.2709114E-02
     +,   5.6150705E-02,   5.9851799E-02,   6.3831165E-02
     +,   6.8101570E-02,   7.2664566E-02,   7.7507295E-02
     +,   8.2597837E-02,   8.7883897E-02,   9.3291141E-02
     +,   9.8726906E-02,   0.1040846    ,   0.1092520    
     +,   0.1141230    ,   0.1186124    ,   0.1226719    
     +,   0.1263084    ,   0.1296043    ,   0.1327345    
     +,   0.1359815    ,   0.1397372    ,   0.1444921    
     +,   0.1507977    ,   0.1592067    ,   0.1701904    
     +,   0.1840532    ,   0.2008681    ,   0.2204594    
     +,   0.2424662    ,   0.2664933    ,   0.2923291    
     +,   0.3201994    ,   0.3509820    ,   0.3862820    
     +,   0.4282395    ,   0.4790386    ,   0.5403280    
     +,   0.6129760    ,   0.6975224    ,   0.7950823    
     +,   0.9081833    ,    1.041593    ,    1.202720    
     +,    1.399371    ,    1.639082    ,    1.943773    
     +,    2.358424    ,    2.888623    ,    3.455859    
     +,    4.080653    ,    4.944993    ,    5.939893    
     +,    6.812257    ,    7.631245    ,    8.167879    
     +,    8.340421    ,    8.266233    ,    8.017561    
     +,    7.587385    ,    7.029545    ,    6.579274    
     +,    5.825123    ,    4.893847    ,    4.235194    
     +,    3.806016    ,    3.377197    ,    2.938095    
     +,    2.557352    ,    2.231981    ,    1.936953    
     +,    1.662226    ,    1.413601    ,    1.203003    
     +,    1.036593    ,   0.9107754    ,   0.8161146    
     +,   0.7429630    ,   0.6843739    ,   0.6358762    
     +,   0.5941314    ,   0.5562143    ,   0.5197762    
     +,   0.4833668    ,   0.4463834    ,   0.4087165    
     +,   0.3704486    ,   0.3317945    ,   0.2932054    
     +,   0.2554333    ,   0.2194401    ,   0.1861809    
     +,   0.1563739    ,   0.1303605    ,   0.1081010    
     +,   8.9278050E-02,   7.3437631E-02,   6.0107384E-02
     +,   4.8874620E-02,   3.9412774E-02,   3.1473216E-02
     +,   2.4862640E-02,   1.9420329E-02,   1.5001778E-02
     +,   1.1469699E-02,   8.6917747E-03,   6.5426435E-03
     +,   4.9068681E-03,   3.6813568E-03,   2.7769532E-03
     +,   2.1189868E-03,   1.6466886E-03,   1.3117638E-03
     +,   1.0767803E-03,   9.1334525E-04,   8.0032402E-04
     +,   7.2226237E-04,   6.6805753E-04,   6.2986097E-04
     +,   6.0220517E-04,   5.8134017E-04,   5.6473468E-04
     +,   5.5071124E-04,   5.3817616E-04,   5.2643212E-04
     +,   5.1504577E-04,   5.0375867E-04,   4.9242197E-04
     +,   4.8095829E-04,   4.6933425E-04,   4.5754356E-04
     +,   4.4559481E-04,   4.3350572E-04,   4.2129980E-04
     +,   4.0900320E-04,   3.9664231E-04,   3.8424387E-04
     +,   3.7183511E-04,   3.5944258E-04,   3.4709129E-04
     +,   3.3480546E-04,   3.2260935E-04,   3.1052489E-04
     +,   2.9857288E-04,   2.8677372E-04,   2.7514642E-04
     +,   2.6370806E-04,   2.5247445E-04,   2.4146067E-04
     +,   2.3068063E-04,   2.2014600E-04,   2.0986734E-04
     +,   1.9985448E-04,   1.9011603E-04,   1.8065856E-04
     +,   1.7148757E-04,   1.6260819E-04,   1.5402363E-04
     +,   1.4573586E-04,   1.3774654E-04,   1.3005607E-04
     +,   1.2266358E-04,   1.1556727E-04,   1.0876496E-04
     +,   1.0225371E-04,   9.6029406E-05,   9.0087276E-05
     +,   8.4422587E-05,   7.9029269E-05,   7.3901465E-05
     +,   6.9032307E-05,   6.4415100E-05,   6.0042265E-05
     +,   5.5906505E-05,   5.1999799E-05,   4.8314461E-05
     +,   4.4842149E-05,   4.1574971E-05,   3.8504582E-05
     +,   3.5622696E-05,   3.2921325E-05,   3.0392172E-05
     +,   2.8027376E-05,   2.5818852E-05,   2.3758967E-05
     +,   2.1839969E-05,   2.0054540E-05,   1.8395316E-05
     +,   1.6855360E-05,   1.5427750E-05,   1.4105985E-05
     +,   1.2883619E-05,   1.1754629E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_asha_htt85_mass = Yx/36.4921214
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_asha_htt90_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  5.5570150E-04,   5.7649688E-04
     +,   5.9740117E-04,   6.1837834E-04,   6.3939235E-04
     +,   6.6040718E-04,   6.8138662E-04,   7.0229499E-04
     +,   7.2309736E-04,   7.4375974E-04,   7.6424930E-04
     +,   7.8453450E-04,   8.0458552E-04,   8.2437496E-04
     +,   8.4387703E-04,   8.6306932E-04,   8.8193180E-04
     +,   9.0044789E-04,   9.1860420E-04,   9.3639153E-04
     +,   9.5380488E-04,   9.7084319E-04,   9.8751008E-04
     +,   1.0038157E-03,   1.0197731E-03,   1.0354035E-03
     +,   1.0507330E-03,   1.0657943E-03,   1.0806263E-03
     +,   1.0952761E-03,   1.1097974E-03,   1.1242518E-03
     +,   1.1387089E-03,   1.1532474E-03,   1.1679531E-03
     +,   1.1829222E-03,   1.1982594E-03,   1.2140786E-03
     +,   1.2305044E-03,   1.2476686E-03,   1.2657157E-03
     +,   1.2847983E-03,   1.3050789E-03,   1.3267294E-03
     +,   1.3499320E-03,   1.3748775E-03,   1.4017660E-03
     +,   1.4308048E-03,   1.4622111E-03,   1.4962078E-03
     +,   1.5330254E-03,   1.5729006E-03,   1.6160742E-03
     +,   1.6627948E-03,   1.7133093E-03,   1.7678726E-03
     +,   1.8267393E-03,   1.8901647E-03,   1.9584056E-03
     +,   2.0317177E-03,   2.1103551E-03,   2.1945725E-03
     +,   2.2846158E-03,   2.3807362E-03,   2.4831807E-03
     +,   2.5921850E-03,   2.7079931E-03,   2.8308330E-03
     +,   2.9609436E-03,   3.0985454E-03,   3.2438738E-03
     +,   3.3971444E-03,   3.5585908E-03,   3.7284261E-03
     +,   3.9068791E-03,   4.0941825E-03,   4.2905570E-03
     +,   4.4962298E-03,   4.7114412E-03,   4.9364418E-03
     +,   5.1714601E-03,   5.4167658E-03,   5.6725997E-03
     +,   5.9392452E-03,   6.2169521E-03,   6.5060137E-03
     +,   6.8066902E-03,   7.1192854E-03,   7.4440716E-03
     +,   7.7813561E-03,   8.1314640E-03,   8.4947282E-03
     +,   8.8715144E-03,   9.2622675E-03,   9.6675465E-03
     +,   1.0087977E-02,   1.0524450E-02,   1.0978034E-02
     +,   1.1450201E-02,   1.1942793E-02,   1.2458236E-02
     +,   1.2999558E-02,   1.3570625E-02,   1.4176132E-02
     +,   1.4821819E-02,   1.5514538E-02,   1.6262239E-02
     +,   1.7074037E-02,   1.7960208E-02,   1.8932033E-02
     +,   2.0001531E-02,   2.1181408E-02,   2.2484491E-02
     +,   2.3923673E-02,   2.5511205E-02,   2.7258815E-02
     +,   2.9177062E-02,   3.1275745E-02,   3.3563577E-02
     +,   3.6049057E-02,   3.8740966E-02,   4.1649062E-02
     +,   4.4785291E-02,   4.8165306E-02,   5.1809367E-02
     +,   5.5743396E-02,   6.0000699E-02,   6.4621881E-02
     +,   6.9656402E-02,   7.5161487E-02,   8.1202723E-02
     +,   8.7851770E-02,   9.5186077E-02,   0.1032859    
     +,   0.1122334    ,   0.1221100    ,   0.1329905    
     +,   0.1449342    ,   0.1579697    ,   0.1720703    
     +,   0.1871260    ,   0.2029236    ,   0.2191550    
     +,   0.2354678    ,   0.2515731    ,   0.2674062    
     +,   0.2832811    ,   0.2999708    ,   0.3186356    
     +,   0.3405570    ,   0.3667463    ,   0.3976165    
     +,   0.4329723    ,   0.4724652    ,   0.5162652    
     +,   0.5653247    ,   0.6207350    ,   0.6826701    
     +,   0.7504710    ,   0.8249390    ,   0.9119281    
     +,    1.024859    ,    1.183596    ,    1.406774    
     +,    1.701242    ,    2.061917    ,    2.481733    
     +,    2.985255    ,    3.686213    ,    4.690609    
     +,    6.049133    ,    7.434934    ,    8.126315    
     +,    8.259694    ,    8.655286    ,    9.021647    
     +,    8.794909    ,    8.101399    ,    7.266561    
     +,    6.346119    ,    5.243363    ,    4.415294    
     +,    3.951279    ,    3.553807    ,    3.079794    
     +,    2.591318    ,    2.167936    ,    1.838745    
     +,    1.564154    ,    1.312904    ,    1.096260    
     +,   0.9286785    ,   0.8032743    ,   0.7038221    
     +,   0.6195271    ,   0.5465181    ,   0.4834801    
     +,   0.4286807    ,   0.3794605    ,   0.3330615    
     +,   0.2876538    ,   0.2428409    ,   0.1994835    
     +,   0.1590972    ,   0.1231857    ,   9.2759408E-02
     +,   6.8152770E-02,   4.9081545E-02,   3.4835603E-02
     +,   2.4507433E-02,   1.7182499E-02,   1.2057842E-02
     +,   8.4919166E-03,   6.0066688E-03,   4.2637214E-03
     +,   3.0314869E-03,   2.1539633E-03,   1.5260815E-03
     +,   1.0762027E-03,   7.5447542E-04,   5.2538025E-04
     +,   3.6321857E-04,   2.4923281E-04,   1.6970001E-04
     +,   1.1461967E-04,   7.6761986E-05,   5.0945389E-05
     +,   3.3484612E-05,   2.1778518E-05,   1.4005383E-05
     +,   8.8981533E-06,   5.5810192E-06,   3.4531870E-06
     +,   2.1063770E-06,   1.2660086E-06,   7.4939533E-07
     +,   4.3669857E-07,   2.5044864E-07,   1.4132469E-07
     +,   7.8448252E-08,   4.2828965E-08,   2.2995058E-08
     +,   1.2140688E-08,   6.3026819E-09,   3.2170075E-09
     +,   1.6144284E-09,   7.9658541E-10,   3.8644435E-10
     +,   1.8432748E-10,   8.6456328E-11,   3.9880793E-11
     +,   1.8096599E-11,   8.0818841E-12,   3.5554426E-12
     +,   1.5430551E-12,   6.6241733E-13,   2.8263503E-13
     +,   1.2085160E-13,   5.2491164E-14,   2.3632074E-14
     +,   1.1309957E-14,   5.8851176E-15,   3.3581597E-15
     +,   2.0801893E-15,   1.3688495E-15,   9.3582667E-16
     +,   6.5367438E-16,   4.6161797E-16,   3.2761040E-16
     +,   2.3291116E-16,   1.6560222E-16,   1.1766368E-16
     +,   8.3514431E-17,   5.9203957E-17,   4.1916074E-17
     +,   2.9638795E-17,   2.0931005E-17,   1.4763703E-17
     +,   1.0401206E-17,   7.3195426E-18,   5.1452830E-18
     +,   3.6131543E-18,   2.5347343E-18,   1.7765453E-18
     +,   1.2440257E-18,   8.7041683E-19,   6.0853486E-19
     +,   4.2512855E-19,   2.9680194E-19,   2.0707797E-19
     +,   1.4439559E-19,   1.0063243E-19,   7.0099389E-20
     +,   4.8808031E-20,   3.3970114E-20,   2.3633920E-20
     +,   1.6437441E-20,   1.1428607E-20,   7.9439058E-21
     +,   5.5202237E-21,   3.8350925E-21
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_asha_htt90_mass = Yx/34.60324896
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_asha_htt95_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  8.8213081E-04,   8.9146046E-04
     +,   9.0082583E-04,   9.1027049E-04,   9.1984047E-04
     +,   9.2958368E-04,   9.3955087E-04,   9.4979466E-04
     +,   9.6036989E-04,   9.7133493E-04,   9.8274986E-04
     +,   9.9467754E-04,   1.0071852E-03,   1.0203419E-03
     +,   1.0342220E-03,   1.0489029E-03,   1.0644677E-03
     +,   1.0810040E-03,   1.0986055E-03,   1.1173717E-03
     +,   1.1374095E-03,   1.1588326E-03,   1.1817623E-03
     +,   1.2063306E-03,   1.2326741E-03,   1.2609430E-03
     +,   1.2912939E-03,   1.3238938E-03,   1.3589188E-03
     +,   1.3965545E-03,   1.4369941E-03,   1.4804386E-03
     +,   1.5270963E-03,   1.5771796E-03,   1.6309050E-03
     +,   1.6884889E-03,   1.7501479E-03,   1.8160928E-03
     +,   1.8865311E-03,   1.9616529E-03,   2.0416409E-03
     +,   2.1266555E-03,   2.2168353E-03,   2.3122928E-03
     +,   2.4131092E-03,   2.5193312E-03,   2.6309658E-03
     +,   2.7479785E-03,   2.8702887E-03,   2.9977679E-03
     +,   3.1302369E-03,   3.2674677E-03,   3.4091750E-03
     +,   3.5550373E-03,   3.7046655E-03,   3.8576445E-03
     +,   4.0135100E-03,   4.1717673E-03,   4.3318947E-03
     +,   4.4933562E-03,   4.6556070E-03,   4.8181131E-03
     +,   4.9803448E-03,   5.1418194E-03,   5.3021009E-03
     +,   5.4607941E-03,   5.6176083E-03,   5.7723173E-03
     +,   5.9248242E-03,   6.0751345E-03,   6.2234043E-03
     +,   6.3699209E-03,   6.5151453E-03,   6.6596894E-03
     +,   6.8043512E-03,   6.9501023E-03,   7.0980904E-03
     +,   7.2496417E-03,   7.4062604E-03,   7.5696274E-03
     +,   7.7415649E-03,   7.9240613E-03,   8.1192069E-03
     +,   8.3292369E-03,   8.5564451E-03,   8.8032195E-03
     +,   9.0719536E-03,   9.3650836E-03,   9.6849753E-03
     +,   1.0033970E-02,   1.0414309E-02,   1.0828064E-02
     +,   1.1277117E-02,   1.1763137E-02,   1.2287540E-02
     +,   1.2851333E-02,   1.3455231E-02,   1.4099444E-02
     +,   1.4783791E-02,   1.5507500E-02,   1.6269360E-02
     +,   1.7067533E-02,   1.7899746E-02,   1.8763131E-02
     +,   1.9654481E-02,   2.0570312E-02,   2.1506911E-02
     +,   2.2460653E-02,   2.3428306E-02,   2.4407275E-02
     +,   2.5395917E-02,   2.6394103E-02,   2.7403435E-02
     +,   2.8427796E-02,   2.9473539E-02,   3.0549888E-02
     +,   3.1668764E-02,   3.2844972E-02,   3.4095459E-02
     +,   3.5438944E-02,   3.6894824E-02,   3.8481880E-02
     +,   4.0216722E-02,   4.2112425E-02,   4.4176709E-02
     +,   4.6410237E-02,   4.8805926E-02,   5.1347688E-02
     +,   5.4011043E-02,   5.6763213E-02,   5.9565596E-02
     +,   6.2375348E-02,   6.5149285E-02,   6.7846999E-02
     +,   7.0435010E-02,   7.2890595E-02,   7.5204574E-02
     +,   7.7384144E-02,   7.9454295E-02,   8.1458114E-02
     +,   8.3455421E-02,   8.5521020E-02,   8.7741651E-02
     +,   9.0212628E-02,   9.3033932E-02,   9.6308678E-02
     +,   0.1001426    ,   0.1046481    ,   0.1099543    
     +,   0.1162268    ,   0.1236946    ,   0.1326822    
     +,   0.1436346    ,   0.1571186    ,   0.1737735    
     +,   0.1942001    ,   0.2188037    ,   0.2476378    
     +,   0.2803206    ,   0.3160923    ,   0.3540330    
     +,   0.3933623    ,   0.4337320    ,   0.4754575    
     +,   0.5196536    ,   0.5682099    ,   0.6234359    
     +,   0.6872876    ,   0.7605856    ,   0.8433228    
     +,   0.9366491    ,    1.044887    ,    1.176347    
     +,    1.347417    ,    1.591553    ,    1.955759    
     +,    2.463283    ,    3.088725    ,    3.816303    
     +,    4.618169    ,    5.529065    ,    6.694026    
     +,    7.874406    ,    9.060782    ,    9.721285    
     +,    9.854285    ,    9.694461    ,    8.970641    
     +,    7.964854    ,    6.920742    ,    5.865762    
     +,    4.698108    ,    3.863008    ,    3.350791    
     +,    2.805039    ,    2.250744    ,    1.817264    
     +,    1.500270    ,    1.242540    ,    1.007749    
     +,   0.7873158    ,   0.5890924    ,   0.4239056    
     +,   0.2963852    ,   0.2035684    ,   0.1382884    
     +,   9.2963487E-02,   6.1582573E-02,   3.9985370E-02
     +,   2.5362900E-02,   1.5716003E-02,   9.5396377E-03
     +,   5.6953817E-03,   3.3567466E-03,   1.9575178E-03
     +,   1.1300253E-03,   6.4499059E-04,   3.6314287E-04
     +,   2.0108797E-04,   1.0918885E-04,   5.7970377E-05
     +,   3.0017052E-05,   1.5127213E-05,   7.4072973E-06
     +,   3.5198116E-06,   1.6217642E-06,   7.2442913E-07
     +,   3.1396650E-07,   1.3235346E-07,   5.4601436E-08
     +,   2.2346416E-08,   9.3283088E-09,   4.1683026E-09
     +,   2.1178697E-09,   1.2669265E-09,   8.7354629E-10
     +,   6.5844047E-10,   5.1866372E-10,   4.1616663E-10
     +,   3.3611544E-10,   2.7188957E-10,   2.1985828E-10
     +,   1.7759466E-10,   1.4326482E-10,   1.1540655E-10
     +,   9.2830785E-11,   7.4562981E-11,   5.9802441E-11
     +,   4.7893328E-11,   3.8300033E-11,   3.0583307E-11
     +,   2.4385377E-11,   1.9414996E-11,   1.5435113E-11
     +,   1.2253007E-11,   9.7125806E-12,   7.6875329E-12
     +,   6.0757896E-12,   4.7948845E-12,   3.7784090E-12
     +,   2.9730391E-12,   2.3359010E-12,   1.8325961E-12
     +,   1.4356024E-12,   1.1229568E-12,   8.7710264E-13
     +,   6.8405692E-13,   5.3271168E-13,   4.1423985E-13
     +,   3.2163947E-13,   2.4936775E-13,   1.9304908E-13
     +,   1.4922989E-13,   1.1518613E-13,   8.8776344E-14
     +,   6.8320905E-14,   5.2500373E-14,   4.0283857E-14
     +,   3.0863970E-14,   2.3611970E-14,   1.8036938E-14
     +,   1.3757946E-14,   1.0478427E-14,   7.9688877E-15
     +,   6.0513292E-15,   4.5884080E-15,   3.4739849E-15
     +,   2.6263042E-15,   1.9825348E-15,   1.4943312E-15
     +,   1.1246888E-15,   8.4521479E-16,   6.3425086E-16
     +,   4.7523143E-16,   3.5555688E-16,   2.6562032E-16
     +,   1.9814059E-16,   1.4758215E-16,   1.0976247E-16
     +,   8.1512250E-17,   6.0443788E-17
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_asha_htt95_mass = Yx/34.11147152
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_asha_ttz100_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.9739104E-04,   5.4826931E-04
     +,   6.0279696E-04,   6.6103437E-04,   7.2301686E-04
     +,   7.8875112E-04,   8.5821346E-04,   9.3134673E-04
     +,   1.0080568E-03,   1.0882166E-03,   1.1716558E-03
     +,   1.2581663E-03,   1.3475000E-03,   1.4393681E-03
     +,   1.5334430E-03,   1.6293591E-03,   1.7267143E-03
     +,   1.8250740E-03,   1.9239724E-03,   2.0229181E-03
     +,   2.1213980E-03,   2.2188816E-03,   2.3148258E-03
     +,   2.4086877E-03,   2.4999157E-03,   2.5879745E-03
     +,   2.6723363E-03,   2.7524957E-03,   2.8279738E-03
     +,   2.8983227E-03,   2.9631341E-03,   3.0220433E-03
     +,   3.0747338E-03,   3.1209409E-03,   3.1604588E-03
     +,   3.1931365E-03,   3.2188871E-03,   3.2376838E-03
     +,   3.2495612E-03,   3.2546159E-03,   3.2530024E-03
     +,   3.2449341E-03,   3.2306761E-03,   3.2105446E-03
     +,   3.1849022E-03,   3.1541495E-03,   3.1187253E-03
     +,   3.0790954E-03,   3.0357519E-03,   2.9892044E-03
     +,   2.9399747E-03,   2.8885924E-03,   2.8355883E-03
     +,   2.7814878E-03,   2.7268159E-03,   2.6720788E-03
     +,   2.6177720E-03,   2.5643748E-03,   2.5123458E-03
     +,   2.4621258E-03,   2.4141336E-03,   2.3687677E-03
     +,   2.3264110E-03,   2.2874246E-03,   2.2521538E-03
     +,   2.2209354E-03,   2.1940893E-03,   2.1719350E-03
     +,   2.1547819E-03,   2.1429432E-03,   2.1367306E-03
     +,   2.1364635E-03,   2.1424685E-03,   2.1550804E-03
     +,   2.1746466E-03,   2.2015269E-03,   2.2360885E-03
     +,   2.2787105E-03,   2.3297772E-03,   2.3896806E-03
     +,   2.4588034E-03,   2.5375267E-03,   2.6262086E-03
     +,   2.7251926E-03,   2.8347755E-03,   2.9552234E-03
     +,   3.0867306E-03,   3.2294418E-03,   3.3834029E-03
     +,   3.5485839E-03,   3.7248549E-03,   3.9119618E-03
     +,   4.1095330E-03,   4.3170820E-03,   4.5339949E-03
     +,   4.7595087E-03,   4.9927626E-03,   5.2327495E-03
     +,   5.4783896E-03,   5.7284855E-03,   5.9818132E-03
     +,   6.2370896E-03,   6.4930795E-03,   6.7485757E-03
     +,   7.0025180E-03,   7.2540361E-03,   7.5025056E-03
     +,   7.7476483E-03,   7.9896441E-03,   8.2291970E-03
     +,   8.4676193E-03,   8.7069580E-03,   8.9500248E-03
     +,   9.2005087E-03,   9.4629442E-03,   9.7427787E-03
     +,   1.0046233E-02,   1.0380296E-02,   1.0752451E-02
     +,   1.1170520E-02,   1.1642341E-02,   1.2175360E-02
     +,   1.2776218E-02,   1.3450361E-02,   1.4201508E-02
     +,   1.5031107E-02,   1.5938109E-02,   1.6918371E-02
     +,   1.7964706E-02,   1.9066514E-02,   2.0210143E-02
     +,   2.1378897E-02,   2.2553807E-02,   2.3713984E-02
     +,   2.4837743E-02,   2.5903454E-02,   2.6890507E-02
     +,   2.7780514E-02,   2.8558444E-02,   2.9213455E-02
     +,   2.9739711E-02,   3.0137071E-02,   3.0411422E-02
     +,   3.0574780E-02,   3.0645076E-02,   3.0645724E-02
     +,   3.0604959E-02,   3.0554892E-02,   3.0530455E-02
     +,   3.0568194E-02,   3.0705024E-02,   3.0976886E-02
     +,   3.1417470E-02,   3.2057092E-02,   3.2921731E-02
     +,   3.4032386E-02,   3.5405029E-02,   3.7051421E-02
     +,   3.8980782E-02,   4.1202299E-02,   4.3729294E-02
     +,   4.6583541E-02,   4.9799632E-02,   5.3428981E-02
     +,   5.7542369E-02,   6.2229622E-02,   6.7596421E-02
     +,   7.3758930E-02,   8.0836155E-02,   8.8938870E-02
     +,   9.8156095E-02,   0.1085413    ,   0.1201026    
     +,   0.1328034    ,   0.1465852    ,   0.1614238    
     +,   0.1774009    ,   0.1947638    ,   0.2139330    
     +,   0.2354697    ,   0.2601481    ,   0.2893651    
     +,   0.3259115    ,   0.3747061    ,   0.4430214    
     +,   0.5399033    ,   0.6732370    ,   0.8412635    
     +,    1.024868    ,    1.212471    ,    1.463884    
     +,    1.898024    ,    2.521673    ,    3.184766    
     +,    3.781119    ,    4.166619    ,    4.176088    
     +,    3.930226    ,    3.579600    ,    3.055324    
     +,    2.371980    ,    1.692507    ,    1.129618    
     +,   0.7090487    ,   0.4161536    ,   0.2269003    
     +,   0.1154731    ,   5.5717755E-02,   2.6337303E-02
     +,   1.3096950E-02,   7.4685584E-03,   4.9410164E-03
     +,   3.5657936E-03,   2.6846570E-03,   2.1052491E-03
     +,   1.7447994E-03,   1.5358573E-03,   1.4199557E-03
     +,   1.3538643E-03,   1.3104316E-03,   1.2749241E-03
     +,   1.2404008E-03,   1.2040813E-03,   1.1651275E-03
     +,   1.1235030E-03,   1.0794746E-03,   1.0334161E-03
     +,   9.8573416E-04,   9.3683839E-04,   8.8713330E-04
     +,   8.3701470E-04,   7.8686123E-04,   7.3702668E-04
     +,   6.8783993E-04,   6.3960603E-04,   5.9259473E-04
     +,   5.4704363E-04,   5.0315983E-04,   4.6111725E-04
     +,   4.2105297E-04,   3.8307233E-04,   3.4725206E-04
     +,   3.1363915E-04,   2.8225122E-04,   2.5308109E-04
     +,   2.2610165E-04,   2.0126546E-04,   1.7850686E-04
     +,   1.5774617E-04,   1.3889433E-04,   1.2185136E-04
     +,   1.0651093E-04,   9.2763679E-05,   8.0497761E-05
     +,   6.9600072E-05,   5.9958867E-05,   5.1465628E-05
     +,   4.4015258E-05,   3.7506725E-05,   3.1844389E-05
     +,   2.6938696E-05,   2.2706106E-05,   1.9069043E-05
     +,   1.5956311E-05,   1.3303282E-05,   1.1051086E-05
     +,   9.1467873E-06,   7.5431390E-06,   6.1980959E-06
     +,   5.0744034E-06,   4.1393128E-06,   3.3642782E-06
     +,   2.7244466E-06,   2.1982896E-06,   1.7672918E-06
     +,   1.4156464E-06,   1.1298438E-06,   8.9847259E-07
     +,   7.1188254E-07,   5.6199838E-07,   4.4205689E-07
     +,   3.4645367E-07,   2.7053804E-07,   2.1049178E-07
     +,   1.6317686E-07,   1.2603908E-07,   9.7000111E-08
     +,   7.4379869E-08,   5.6827982E-08,   4.3259920E-08
     +,   3.2812007E-08,   2.4796824E-08,   1.8671663E-08
     +,   1.4008323E-08,   1.0471608E-08,   7.7993123E-09
     +,   5.7879306E-09,   4.2796375E-09,   3.1529290E-09
     +,   2.3143918E-09,   1.6927172E-09
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_asha_ttz100_mass = Yx/11.256594
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_asha_ttz105_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.5822530E-05,   5.0282768E-05
     +,   5.5095872E-05,   6.0280759E-05,   6.5856453E-05
     +,   7.1841889E-05,   7.8255893E-05,   8.5117033E-05
     +,   9.2443304E-05,   1.0025253E-04,   1.0856143E-04
     +,   1.1738605E-04,   1.2674127E-04,   1.3664094E-04
     +,   1.4709735E-04,   1.5812137E-04,   1.6972216E-04
     +,   1.8190683E-04,   1.9468063E-04,   2.0804648E-04
     +,   2.2200498E-04,   2.3655423E-04,   2.5168952E-04
     +,   2.6740445E-04,   2.8368793E-04,   3.0052810E-04
     +,   3.1790917E-04,   3.3581269E-04,   3.5421754E-04
     +,   3.7310013E-04,   3.9243425E-04,   4.1219158E-04
     +,   4.3234165E-04,   4.5285243E-04,   4.7369063E-04
     +,   4.9482222E-04,   5.1621260E-04,   5.3782755E-04
     +,   5.5963505E-04,   5.8160210E-04,   6.0370110E-04
     +,   6.2590622E-04,   6.4819632E-04,   6.7055598E-04
     +,   6.9297582E-04,   7.1545428E-04,   7.3799829E-04
     +,   7.6062471E-04,   7.8336184E-04,   8.0624979E-04
     +,   8.2934200E-04,   8.5270678E-04,   8.7642734E-04
     +,   9.0060482E-04,   9.2535501E-04,   9.5081434E-04
     +,   9.7713596E-04,   1.0044920E-03,   1.0330738E-03
     +,   1.0630902E-03,   1.0947686E-03,   1.1283540E-03
     +,   1.1641046E-03,   1.2022958E-03,   1.2432158E-03
     +,   1.2871592E-03,   1.3344330E-03,   1.3853428E-03
     +,   1.4402022E-03,   1.4993146E-03,   1.5629848E-03
     +,   1.6314985E-03,   1.7051350E-03,   1.7841451E-03
     +,   1.8687615E-03,   1.9591893E-03,   2.0555949E-03
     +,   2.1581061E-03,   2.2668149E-03,   2.3817702E-03
     +,   2.5029606E-03,   2.6303381E-03,   2.7637873E-03
     +,   2.9031539E-03,   3.0482120E-03,   3.1987000E-03
     +,   3.3542844E-03,   3.5145991E-03,   3.6792131E-03
     +,   3.8476654E-03,   4.0194597E-03,   4.1940557E-03
     +,   4.3708920E-03,   4.5494013E-03,   4.7290130E-03
     +,   4.9091419E-03,   5.0892462E-03,   5.2687889E-03
     +,   5.4473020E-03,   5.6243483E-03,   5.7995915E-03
     +,   5.9727598E-03,   6.1437138E-03,   6.3124159E-03
     +,   6.4789858E-03,   6.6437069E-03,   6.8070292E-03
     +,   6.9696056E-03,   7.1323081E-03,   7.2962414E-03
     +,   7.4627372E-03,   7.6334034E-03,   7.8100869E-03
     +,   7.9949172E-03,   8.1902649E-03,   8.3987750E-03
     +,   8.6233066E-03,   8.8669611E-03,   9.1329981E-03
     +,   9.4248485E-03,   9.7460700E-03,   1.0100259E-02
     +,   1.0491031E-02,   1.0921991E-02,   1.1396673E-02
     +,   1.1918417E-02,   1.2490457E-02,   1.3115717E-02
     +,   1.3796922E-02,   1.4536393E-02,   1.5336161E-02
     +,   1.6197741E-02,   1.7122302E-02,   1.8110396E-02
     +,   1.9162154E-02,   2.0277228E-02,   2.1454832E-02
     +,   2.2693967E-02,   2.3993846E-02,   2.5354385E-02
     +,   2.6776755E-02,   2.8264396E-02,   2.9824199E-02
     +,   3.1467490E-02,   3.3210829E-02,   3.5076968E-02
     +,   3.7094511E-02,   3.9296772E-02,   4.1719377E-02
     +,   4.4396784E-02,   4.7356997E-02,   5.0615340E-02
     +,   5.4168608E-02,   5.7990003E-02,   6.2025994E-02
     +,   6.6196211E-02,   7.0398517E-02,   7.4518576E-02
     +,   7.8443319E-02,   8.2077339E-02,   8.5361682E-02
     +,   8.8289723E-02,   9.0919271E-02,   9.3378469E-02
     +,   9.5863394E-02,   9.8627485E-02,   0.1019643    
     +,   0.1061882    ,   0.1116191    ,   0.1185734    
     +,   0.1273607    ,   0.1382720    ,   0.1515327    
     +,   0.1671926    ,   0.1849581    ,   0.2040392    
     +,   0.2231526    ,   0.2408437    ,   0.2561719    
     +,   0.2695150    ,   0.2829566    ,   0.2997130    
     +,   0.3225452    ,   0.3519442    ,   0.3854374    
     +,   0.4189596    ,   0.4498344    ,   0.4794818    
     +,   0.5139760    ,   0.5620823    ,   0.6316355    
     +,   0.7255476    ,   0.8391640    ,   0.9585873    
     +,    1.060398    ,    1.127493    ,    1.187218    
     +,    1.321905    ,    1.604683    ,    2.017116    
     +,    2.460333    ,    2.846123    ,    3.069131    
     +,    2.922697    ,    2.290148    ,    1.394801    
     +,   0.6386008    ,   0.2224498    ,   7.0062257E-02
     +,   3.2808561E-02,   2.5852077E-02,   2.2829100E-02
     +,   1.9419661E-02,   1.5955102E-02,   1.3010324E-02
     +,   1.0753296E-02,   9.0638949E-03,   7.7434536E-03
     +,   6.6394769E-03,   5.6738388E-03,   4.8210355E-03
     +,   4.0786061E-03,   3.4474412E-03,   2.9235939E-03
     +,   2.4974027E-03,   2.1556185E-03,   1.8838577E-03
     +,   1.6683440E-03,   1.4968599E-03,   1.3591112E-03
     +,   1.2467143E-03,   1.1530017E-03,   1.0727904E-03
     +,   1.0021568E-03,   9.3822612E-04,   8.7896112E-04
     +,   8.2299026E-04,   7.6945062E-04,   7.1784871E-04
     +,   6.6794368E-04,   6.1966351E-04,   5.7304115E-04
     +,   5.2816287E-04,   4.8513425E-04,   4.4406054E-04
     +,   4.0503766E-04,   3.6814134E-04,   3.3342140E-04
     +,   3.0090410E-04,   2.7059496E-04,   2.4247466E-04
     +,   2.1650389E-04,   1.9262794E-04,   1.7077677E-04
     +,   1.5086640E-04,   1.3280314E-04,   1.1648718E-04
     +,   1.0181317E-04,   8.8671477E-05,   7.6951314E-05
     +,   6.6542925E-05,   5.7338209E-05,   4.9231207E-05
     +,   4.2120013E-05,   3.5908146E-05,   3.0503628E-05
     +,   2.5820331E-05,   2.1778405E-05,   1.8304032E-05
     +,   1.5329271E-05,   1.2792284E-05,   1.0637228E-05
     +,   8.8138468E-06,   7.2770717E-06,   5.9868603E-06
     +,   4.9079308E-06,   4.0091186E-06,   3.2632954E-06
     +,   2.6467631E-06,   2.1390968E-06,   1.7226509E-06
     +,   1.3823599E-06,   1.1053396E-06,   8.8069999E-07
     +,   6.9921470E-07,   5.5315991E-07,   4.3605851E-07
     +,   3.4252295E-07,   2.6809710E-07,   2.0909569E-07
     +,   1.6250090E-07,   1.2583939E-07,   9.7103616E-08
     +,   7.4662815E-08,   5.7204598E-08,   4.3672546E-08
     +,   3.3223372E-08,   2.5184224E-08,   1.9022691E-08
     +,   1.4317431E-08,   1.0737832E-08
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_asha_ttz105_mass = Yx/8.45072097560976
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_asha_ttz107_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.4774986E-03,   1.5091975E-03
     +,   1.5406645E-03,   1.5718648E-03,   1.6027642E-03
     +,   1.6333295E-03,   1.6635276E-03,   1.6933266E-03
     +,   1.7226948E-03,   1.7516031E-03,   1.7800233E-03
     +,   1.8079273E-03,   1.8352905E-03,   1.8620898E-03
     +,   1.8883036E-03,   1.9139127E-03,   1.9389025E-03
     +,   1.9632587E-03,   1.9869728E-03,   2.0100381E-03
     +,   2.0324537E-03,   2.0542212E-03,   2.0753487E-03
     +,   2.0958497E-03,   2.1157425E-03,   2.1350526E-03
     +,   2.1538127E-03,   2.1720622E-03,   2.1898479E-03
     +,   2.2072271E-03,   2.2242658E-03,   2.2410385E-03
     +,   2.2576302E-03,   2.2741384E-03,   2.2906694E-03
     +,   2.3073438E-03,   2.3242915E-03,   2.3416562E-03
     +,   2.3595942E-03,   2.3782719E-03,   2.3978711E-03
     +,   2.4185821E-03,   2.4406090E-03,   2.4641638E-03
     +,   2.4894709E-03,   2.5167600E-03,   2.5462685E-03
     +,   2.5782404E-03,   2.6129184E-03,   2.6505503E-03
     +,   2.6913781E-03,   2.7356406E-03,   2.7835660E-03
     +,   2.8353753E-03,   2.8912672E-03,   2.9514285E-03
     +,   3.0160181E-03,   3.0851706E-03,   3.1589896E-03
     +,   3.2375425E-03,   3.3208597E-03,   3.4089338E-03
     +,   3.5017030E-03,   3.5990681E-03,   3.7008831E-03
     +,   3.8069377E-03,   3.9169872E-03,   4.0307203E-03
     +,   4.1477913E-03,   4.2677894E-03,   4.3902756E-03
     +,   4.5147524E-03,   4.6407022E-03,   4.7675609E-03
     +,   4.8947497E-03,   5.0216778E-03,   5.1477342E-03
     +,   5.2723102E-03,   5.3948192E-03,   5.5146939E-03
     +,   5.6313872E-03,   5.7444139E-03,   5.8533284E-03
     +,   5.9577650E-03,   6.0574198E-03,   6.1520943E-03
     +,   6.2416685E-03,   6.3261450E-03,   6.4056246E-03
     +,   6.4803441E-03,   6.5506594E-03,   6.6170585E-03
     +,   6.6801617E-03,   6.7407303E-03,   6.7996620E-03
     +,   6.8579838E-03,   6.9168666E-03,   6.9775963E-03
     +,   7.0415922E-03,   7.1103834E-03,   7.1856068E-03
     +,   7.2689895E-03,   7.3623508E-03,   7.4675609E-03
     +,   7.5865551E-03,   7.7213021E-03,   7.8737726E-03
     +,   8.0459295E-03,   8.2397163E-03,   8.4570199E-03
     +,   8.6996378E-03,   8.9692874E-03,   9.2675360E-03
     +,   9.5958421E-03,   9.9554649E-03,   1.0347539E-02
     +,   1.0772968E-02,   1.1232536E-02,   1.1726796E-02
     +,   1.2256197E-02,   1.2821056E-02,   1.3421577E-02
     +,   1.4057907E-02,   1.4730231E-02,   1.5438816E-02
     +,   1.6183974E-02,   1.6966291E-02,   1.7786482E-02
     +,   1.8645640E-02,   1.9545034E-02,   2.0486321E-02
     +,   2.1471279E-02,   2.2501985E-02,   2.3580432E-02
     +,   2.4708673E-02,   2.5888531E-02,   2.7121397E-02
     +,   2.8408203E-02,   2.9749440E-02,   3.1145126E-02
     +,   3.2594856E-02,   3.4098182E-02,   3.5655096E-02
     +,   3.7266422E-02,   3.8934182E-02,   4.0662322E-02
     +,   4.2456724E-02,   4.4325072E-02,   4.6276394E-02
     +,   4.8320208E-02,   5.0464936E-02,   5.2715871E-02
     +,   5.5073462E-02,   5.7531673E-02,   6.0076691E-02
     +,   6.2686607E-02,   6.5332688E-02,   6.7982472E-02
     +,   7.0604257E-02,   7.3173888E-02,   7.5684346E-02
     +,   7.8157395E-02,   8.0657415E-02,   8.3307251E-02
     +,   8.6302437E-02,   8.9919724E-02,   9.4513074E-02
     +,   0.1004896    ,   0.1082618    ,   0.1181739    
     +,   0.1304140    ,   0.1449333    ,   0.1613985    
     +,   0.1792038    ,   0.1975582    ,   0.2156587    
     +,   0.2329289    ,   0.2492958    ,   0.2654453    
     +,   0.2829364    ,   0.3040266    ,   0.3311203    
     +,   0.3659346    ,   0.4086572    ,   0.4574219    
     +,   0.5083377    ,   0.5562819    ,   0.5967475    
     +,   0.6288339    ,   0.6585842    ,   0.7002251    
     +,   0.7717742    ,   0.8835958    ,    1.025822    
     +,    1.168038    ,    1.279349    ,    1.356463    
     +,    1.432830    ,    1.555031    ,    1.741379    
     +,    1.950453    ,    2.083683    ,    2.036269    
     +,    1.772159    ,    1.356273    ,   0.9103828    
     +,   0.5387875    ,   0.2862451    ,   0.1430570    
     +,   7.4076355E-02,   4.4887047E-02,   3.3126704E-02
     +,   2.7765559E-02,   2.4374802E-02,   2.1434663E-02
     +,   1.8540286E-02,   1.5697103E-02,   1.3031220E-02
     +,   1.0657405E-02,   8.6322259E-03,   6.9556162E-03
     +,   5.5924365E-03,   4.4937464E-03,   3.6104522E-03
     +,   2.8996230E-03,   2.3261821E-03,   1.8623278E-03
     +,   1.4862402E-03,   1.1808285E-03,   9.3272794E-04
     +,   7.3145959E-04,   5.6872220E-04,   4.3784321E-04
     +,   3.3337303E-04,   2.5078125E-04,   1.8622063E-04
     +,   1.3639888E-04,   9.8491153E-05,   7.0080416E-05
     +,   4.9119786E-05,   3.3904842E-05,   2.3042958E-05
     +,   1.5418320E-05,   1.0155814E-05,   6.5847712E-06
     +,   4.2024794E-06,   2.6400285E-06,   1.6324580E-06
     +,   9.9357817E-07,   5.9526951E-07,   3.5106504E-07
     +,   2.0382052E-07,   1.1650725E-07,   6.5583542E-08
     +,   3.6366743E-08,   1.9874831E-08,   1.0714836E-08
     +,   5.7070433E-09,   3.0106948E-09,   1.5797186E-09
     +,   8.3016499E-10,   4.4171261E-10,   2.4170124E-10
     +,   1.3867808E-10,   8.5003664E-11,   5.6244343E-11
     +,   4.0056371E-11,   3.0280795E-11,   2.3869882E-11
     +,   1.9317546E-11,   1.5872019E-11,   1.3147317E-11
     +,   1.0933941E-11,   9.1085481E-12,   7.5912028E-12
     +,   6.3253209E-12,   5.2676305E-12,   4.3836696E-12
     +,   3.6451185E-12,   3.0284564E-12,   2.5139305E-12
     +,   2.0850153E-12,   1.7277554E-12,   1.4304623E-12
     +,   1.1832743E-12,   9.7794808E-13,   8.0753871E-13
     +,   6.6623291E-13,   5.4917290E-13,   4.5227992E-13
     +,   3.7215521E-13,   3.0595502E-13,   2.5130988E-13
     +,   2.0624180E-13,   1.6910812E-13,   1.3853723E-13
     +,   1.1339377E-13,   9.2731066E-14,   7.5767314E-14
     +,   6.1851837E-14,   5.0447897E-14
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_asha_ttz107_mass = Yx/7.72593535
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_asha_ttz110_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  7.1035890E-04,   7.2533567E-04
     +,   7.4025471E-04,   7.5510319E-04,   7.6986873E-04
     +,   7.8453968E-04,   7.9910486E-04,   8.1355433E-04
     +,   8.2787895E-04,   8.4207155E-04,   8.5612602E-04
     +,   8.7003829E-04,   8.8380656E-04,   8.9743169E-04
     +,   9.1091741E-04,   9.2427083E-04,   9.3750324E-04
     +,   9.5063023E-04,   9.6367230E-04,   9.7665610E-04
     +,   9.8961440E-04,   1.0025870E-03,   1.0156212E-03
     +,   1.0287750E-03,   1.0421134E-03,   1.0557143E-03
     +,   1.0696659E-03,   1.0840689E-03,   1.0990385E-03
     +,   1.1147034E-03,   1.1312084E-03,   1.1487142E-03
     +,   1.1673993E-03,   1.1874596E-03,   1.2091099E-03
     +,   1.2325839E-03,   1.2581351E-03,   1.2860356E-03
     +,   1.3165793E-03,   1.3500749E-03,   1.3868535E-03
     +,   1.4272614E-03,   1.4716609E-03,   1.5204286E-03
     +,   1.5739528E-03,   1.6326312E-03,   1.6968675E-03
     +,   1.7670689E-03,   1.8436401E-03,   1.9269828E-03
     +,   2.0174873E-03,   2.1155300E-03,   2.2214656E-03
     +,   2.3356318E-03,   2.4583219E-03,   2.5898090E-03
     +,   2.7303156E-03,   2.8800226E-03,   3.0390588E-03
     +,   3.2074985E-03,   3.3853594E-03,   3.5725983E-03
     +,   3.7690976E-03,   3.9746887E-03,   4.1891397E-03
     +,   4.4121300E-03,   4.6433075E-03,   4.8822258E-03
     +,   5.1284158E-03,   5.3813192E-03,   5.6403689E-03
     +,   5.9049269E-03,   6.1743525E-03,   6.4479536E-03
     +,   6.7250510E-03,   7.0049684E-03,   7.2870175E-03
     +,   7.5705387E-03,   7.8549245E-03,   8.1396187E-03
     +,   8.4241014E-03,   8.7079694E-03,   8.9908820E-03
     +,   9.2726350E-03,   9.5531316E-03,   9.8324576E-03
     +,   1.0110830E-02,   1.0388708E-02,   1.0666732E-02
     +,   1.0945845E-02,   1.1227278E-02,   1.1512592E-02
     +,   1.1803745E-02,   1.2103169E-02,   1.2413797E-02
     +,   1.2739121E-02,   1.3083317E-02,   1.3451219E-02
     +,   1.3848471E-02,   1.4281464E-02,   1.4757472E-02
     +,   1.5284494E-02,   1.5871370E-02,   1.6527493E-02
     +,   1.7262811E-02,   1.8087542E-02,   1.9011805E-02
     +,   2.0045297E-02,   2.1196928E-02,   2.2474259E-02
     +,   2.3882810E-02,   2.5425782E-02,   2.7103132E-02
     +,   2.8911395E-02,   3.0842779E-02,   3.2885291E-02
     +,   3.5021987E-02,   3.7231516E-02,   3.9487697E-02
     +,   4.1760541E-02,   4.4016711E-02,   4.6220288E-02
     +,   4.8334185E-02,   5.0321653E-02,   5.2147679E-02
     +,   5.3780418E-02,   5.5193193E-02,   5.6365583E-02
     +,   5.7285033E-02,   5.7947621E-02,   5.8358818E-02
     +,   5.8533479E-02,   5.8495730E-02,   5.8277871E-02
     +,   5.7919279E-02,   5.7464477E-02,   5.6961123E-02
     +,   5.6457553E-02,   5.6000337E-02,   5.5631865E-02
     +,   5.5388138E-02,   5.5296943E-02,   5.5376481E-02
     +,   5.5634722E-02,   5.6069296E-02,   5.6668177E-02
     +,   5.7410970E-02,   5.8270488E-02,   5.9215091E-02
     +,   6.0210921E-02,   6.1224278E-02,   6.2223878E-02
     +,   6.3183121E-02,   6.4082362E-02,   6.4911023E-02
     +,   6.5670043E-02,   6.6374622E-02,   6.7057155E-02
     +,   6.7769967E-02,   6.8587229E-02,   6.9605023E-02
     +,   7.0938602E-02,   7.2715580E-02,   7.5064838E-02
     +,   7.8102753E-02,   8.1919409E-02,   8.6570464E-02
     +,   9.2082098E-02,   9.8475620E-02,   0.1058111    
     +,   0.1142432    ,   0.1240705    ,   0.1357476    
     +,   0.1498290    ,   0.1668287    ,   0.1870170    
     +,   0.2102150    ,   0.2356944    ,   0.2622987    
     +,   0.2888181    ,   0.3145155    ,   0.3395561    
     +,   0.3650905    ,   0.3928871    ,   0.4246920    
     +,   0.4616389    ,   0.5039339    ,   0.5507330    
     +,   0.6000992    ,   0.6492774    ,   0.6958520    
     +,   0.7397202    ,   0.7845815    ,   0.8370317    
     +,   0.9027359    ,   0.9816643    ,    1.065736    
     +,    1.140811    ,    1.191726    ,    1.206837    
     +,    1.179673    ,    1.108444    ,   0.9957758    
     +,   0.8495793    ,   0.6835792    ,   0.5155110    
     +,   0.3629203    ,   0.2384699    ,   0.1471905    
     +,   8.6880304E-02,   5.0870162E-02,   3.1306382E-02
     +,   2.1465411E-02,   1.6666275E-02,   1.4146897E-02
     +,   1.2507195E-02,   1.1147332E-02,   9.8690055E-03
     +,   8.6439215E-03,   7.4978992E-03,   6.4606573E-03
     +,   5.5492339E-03,   4.7663194E-03,   4.1040247E-03
     +,   3.5486817E-03,   3.0848302E-03,   2.6977242E-03
     +,   2.3745028E-03,   2.1044952E-03,   1.8790588E-03
     +,   1.6911882E-03,   1.5350716E-03,   1.4057348E-03
     +,   1.2988173E-03,   1.2104394E-03,   1.1371209E-03
     +,   1.0757793E-03,   1.0237377E-03,   9.7872224E-04
     +,   9.3885406E-04,   9.0263109E-04,   8.6889445E-04
     +,   8.3678128E-04,   8.0567430E-04,   7.7515654E-04
     +,   7.4496726E-04,   7.1496289E-04,   6.8508176E-04
     +,   6.5532065E-04,   6.2571798E-04,   5.9633382E-04
     +,   5.6724140E-04,   5.3852197E-04,   5.1025784E-04
     +,   4.8252702E-04,   4.5540289E-04,   4.2895475E-04
     +,   4.0324448E-04,   3.7832541E-04,   3.5424306E-04
     +,   3.3103715E-04,   3.0873978E-04,   2.8737425E-04
     +,   2.6695715E-04,   2.4750023E-04,   2.2900719E-04
     +,   2.1147584E-04,   1.9490004E-04,   1.7926830E-04
     +,   1.6456390E-04,   1.5076608E-04,   1.3785173E-04
     +,   1.2579439E-04,   1.1456442E-04,   1.0413013E-04
     +,   9.4459036E-05,   8.5516273E-05,   7.7267148E-05
     +,   6.9675305E-05,   6.2705200E-05,   5.6320467E-05
     +,   5.0485869E-05,   4.5165943E-05,   4.0326762E-05
     +,   3.5934649E-05,   3.1957628E-05,   2.8364489E-05
     +,   2.5125399E-05,   2.2212236E-05,   1.9597879E-05
     +,   1.7257065E-05,   1.5165696E-05,   1.3301460E-05
     +,   1.1643227E-05,   1.0171590E-05,   8.8683246E-06
     +,   7.7167761E-06,   6.7014312E-06,   5.8081841E-06
     +,   5.0240128E-06,   4.3371301E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_asha_ttz110_mass = Yx/6.19020553846154
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_asha_ttz115_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.1800938E-07,   2.7237448E-07
     +,   3.3944514E-07,   4.2197402E-07,   5.2325686E-07
     +,   6.4722872E-07,   7.9857460E-07,   9.8285273E-07
     +,   1.2066345E-06,   1.4776831E-06,   1.8051139E-06
     +,   2.1996123E-06,   2.6736627E-06,   3.2418122E-06
     +,   3.9209385E-06,   4.7305793E-06,   5.6932699E-06
     +,   6.8349227E-06,   8.1852349E-06,   9.7781140E-06
     +,   1.1652185E-05,   1.3851248E-05,   1.6424801E-05
     +,   1.9428800E-05,   2.2925740E-05,   2.6985954E-05
     +,   3.1687596E-05,   3.7117625E-05,   4.3372274E-05
     +,   5.0557708E-05,   5.8790636E-05,   6.8198773E-05
     +,   7.8921497E-05,   9.1110189E-05,   1.0492867E-04
     +,   1.2055357E-04,   1.3817439E-04,   1.5799352E-04
     +,   1.8022761E-04,   2.0510379E-04,   2.3286443E-04
     +,   2.6376243E-04,   2.9806260E-04,   3.3604042E-04
     +,   3.7798079E-04,   4.2417739E-04,   4.7493077E-04
     +,   5.3054688E-04,   5.9133524E-04,   6.5760768E-04
     +,   7.2967511E-04,   8.0784602E-04,   8.9242269E-04
     +,   9.8370528E-04,   1.0819732E-03,   1.1875051E-03
     +,   1.3005566E-03,   1.4213674E-03,   1.5501569E-03
     +,   1.6871210E-03,   1.8324294E-03,   1.9862277E-03
     +,   2.1486212E-03,   2.3196980E-03,   2.4995124E-03
     +,   2.6880729E-03,   2.8853766E-03,   3.0913642E-03
     +,   3.3059753E-03,   3.5290939E-03,   3.7606107E-03
     +,   4.0003699E-03,   4.2482368E-03,   4.5040422E-03
     +,   4.7676461E-03,   5.0389320E-03,   5.3177956E-03
     +,   5.6041740E-03,   5.8980859E-03,   6.1996267E-03
     +,   6.5089501E-03,   6.8263588E-03,   7.1522356E-03
     +,   7.4871406E-03,   7.8317355E-03,   8.1868777E-03
     +,   8.5535310E-03,   8.9328596E-03,   9.3261180E-03
     +,   9.7347144E-03,   1.0160156E-02,   1.0603978E-02
     +,   1.1067722E-02,   1.1552906E-02,   1.2060937E-02
     +,   1.2592977E-02,   1.3149972E-02,   1.3732430E-02
     +,   1.4340456E-02,   1.4973525E-02,   1.5630530E-02
     +,   1.6309543E-02,   1.7007906E-02,   1.7722026E-02
     +,   1.8447453E-02,   1.9178875E-02,   1.9910045E-02
     +,   2.0633928E-02,   2.1342851E-02,   2.2028578E-02
     +,   2.2682462E-02,   2.3295796E-02,   2.3859922E-02
     +,   2.4366647E-02,   2.4808401E-02,   2.5178704E-02
     +,   2.5472339E-02,   2.5685718E-02,   2.5817120E-02
     +,   2.5866956E-02,   2.5837906E-02,   2.5735060E-02
     +,   2.5565993E-02,   2.5340695E-02,   2.5071498E-02
     +,   2.4772879E-02,   2.4461158E-02,   2.4154184E-02
     +,   2.3870809E-02,   2.3630451E-02,   2.3452427E-02
     +,   2.3355400E-02,   2.3356635E-02,   2.3471398E-02
     +,   2.3712276E-02,   2.4088621E-02,   2.4606010E-02
     +,   2.5265934E-02,   2.6065631E-02,   2.6998140E-02
     +,   2.8052466E-02,   2.9214237E-02,   3.0466558E-02
     +,   3.1791039E-02,   3.3168953E-02,   3.4582864E-02
     +,   3.6018029E-02,   3.7463680E-02,   3.8914483E-02
     +,   4.0371858E-02,   4.1844994E-02,   4.3351877E-02
     +,   4.4920675E-02,   4.6591196E-02,   4.8416410E-02
     +,   5.0463505E-02,   5.2814282E-02,   5.5564005E-02
     +,   5.8816910E-02,   6.2678359E-02,   6.7244507E-02
     +,   7.2588682E-02,   7.8747407E-02,   8.5708946E-02
     +,   9.3407512E-02,   0.1017226    ,   0.1104861    
     +,   0.1194979    ,   0.1285478    ,   0.1374425    
     +,   0.1460322    ,   0.1542331    ,   0.1620291    
     +,   0.1694456    ,   0.1764965    ,   0.1831316    
     +,   0.1892233    ,   0.1946386    ,   0.1994021    
     +,   0.2038928    ,   0.2089644    ,   0.2158864    
     +,   0.2260856    ,   0.2407796    ,   0.2606492    
     +,   0.2856671    ,   0.3151235    ,   0.3478516    
     +,   0.3826315    ,   0.4186396    ,   0.4556565    
     +,   0.4937307    ,   0.5324997    ,   0.5708708    
     +,   0.6075695    ,   0.6420619    ,   0.6745929    
     +,   0.7046738    ,   0.7290248    ,   0.7409219    
     +,   0.7321075    ,   0.6964106    ,   0.6329361    
     +,   0.5470464    ,   0.4488054    ,   0.3498330    
     +,   0.2601307    ,   0.1860258    ,   0.1296654    
     +,   8.9812055E-02,   6.3279144E-02,   4.6321061E-02
     +,   3.5583880E-02,   2.8539419E-02,   2.3526303E-02
     +,   1.9584658E-02,   1.6235128E-02,   1.3284730E-02
     +,   1.0685896E-02,   8.4465714E-03,   6.5794960E-03
     +,   5.0801015E-03,   3.9218445E-03,   3.0608086E-03
     +,   2.4439574E-03,   2.0172016E-03,   1.7312128E-03
     +,   1.5445938E-03,   1.4248870E-03,   1.3481000E-03
     +,   1.2973961E-03,   1.2615119E-03,   1.2332575E-03
     +,   1.2082573E-03,   1.1839867E-03,   1.1590786E-03
     +,   1.1328607E-03,   1.1050649E-03,   1.0756471E-03
     +,   1.0446809E-03,   1.0123029E-03,   9.7868312E-04
     +,   9.4400684E-04,   9.0846379E-04,   8.7224436E-04
     +,   8.3553960E-04,   7.9853664E-04,   7.6141412E-04
     +,   7.2434347E-04,   6.8749097E-04,   6.5101020E-04
     +,   6.1504368E-04,   5.7972537E-04,   5.4517720E-04
     +,   5.1150675E-04,   4.7880897E-04,   4.4716874E-04
     +,   4.1665797E-04,   3.8733458E-04,   3.5924435E-04
     +,   3.3242363E-04,   3.0689727E-04,   2.8267829E-04
     +,   2.5976996E-04,   2.3816878E-04,   2.1786070E-04
     +,   1.9882452E-04,   1.8103363E-04,   1.6445536E-04
     +,   1.4905103E-04,   1.3477793E-04,   1.2159079E-04
     +,   1.0944161E-04,   9.8279350E-05,   8.8051951E-05
     +,   7.8707344E-05,   7.0192109E-05,   6.2454106E-05
     +,   5.5440916E-05,   4.9102044E-05,   4.3387568E-05
     +,   3.8249960E-05,   3.3642878E-05,   2.9522642E-05
     +,   2.5847212E-05,   2.2577311E-05,   1.9675648E-05
     +,   1.7107326E-05,   1.4840051E-05,   1.2843545E-05
     +,   1.1090074E-05,   9.5538926E-06,   8.2115785E-06
     +,   7.0415554E-06,   6.0243665E-06,   5.1422121E-06
     +,   4.3791433E-06,   3.7206955E-06,   3.1539844E-06
     +,   2.6674159E-06,   2.2507268E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_asha_ttz115_mass = Yx/4.26890138888889
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_asha_ttz120_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  6.1655685E-04,   6.2527397E-04
     +,   6.3387572E-04,   6.4237823E-04,   6.5080199E-04
     +,   6.5917266E-04,   6.6752144E-04,   6.7588565E-04
     +,   6.8430963E-04,   6.9284567E-04,   7.0155365E-04
     +,   7.1050238E-04,   7.1977061E-04,   7.2944746E-04
     +,   7.3963305E-04,   7.5043965E-04,   7.6199195E-04
     +,   7.7442802E-04,   7.8789995E-04,   8.0257421E-04
     +,   8.1863283E-04,   8.3627255E-04,   8.5570622E-04
     +,   8.7716331E-04,   9.0088684E-04,   9.2713814E-04
     +,   9.5619180E-04,   9.8833733E-04,   1.0238773E-03
     +,   1.0631270E-03,   1.1064110E-03,   1.1540640E-03
     +,   1.2064251E-03,   1.2638390E-03,   1.3266497E-03
     +,   1.3951987E-03,   1.4698217E-03,   1.5508420E-03
     +,   1.6385739E-03,   1.7333028E-03,   1.8353002E-03
     +,   1.9448015E-03,   2.0620110E-03,   2.1870916E-03
     +,   2.3201637E-03,   2.4612960E-03,   2.6105039E-03
     +,   2.7677433E-03,   2.9329059E-03,   3.1058178E-03
     +,   3.2862322E-03,   3.4738311E-03,   3.6682177E-03
     +,   3.8689314E-03,   4.0754154E-03,   4.2870571E-03
     +,   4.5031589E-03,   4.7229570E-03,   4.9456190E-03
     +,   5.1702531E-03,   5.3959084E-03,   5.6215930E-03
     +,   5.8462564E-03,   6.0688369E-03,   6.2882495E-03
     +,   6.5033762E-03,   6.7131273E-03,   6.9163954E-03
     +,   7.1121226E-03,   7.2992612E-03,   7.4768355E-03
     +,   7.6439069E-03,   7.7996296E-03,   7.9432270E-03
     +,   8.0740303E-03,   8.1914812E-03,   8.2951402E-03
     +,   8.3846971E-03,   8.4600039E-03,   8.5210623E-03
     +,   8.5680429E-03,   8.6013116E-03,   8.6214188E-03
     +,   8.6291274E-03,   8.6254198E-03,   8.6115086E-03
     +,   8.5888477E-03,   8.5591311E-03,   8.5243220E-03
     +,   8.4866267E-03,   8.4485216E-03,   8.4127365E-03
     +,   8.3822506E-03,   8.3602788E-03,   8.3502512E-03
     +,   8.3557917E-03,   8.3806962E-03,   8.4288716E-03
     +,   8.5043320E-03,   8.6111147E-03,   8.7532792E-03
     +,   8.9348136E-03,   9.1596311E-03,   9.4314823E-03
     +,   9.7539565E-03,   1.0130445E-02,   1.0564054E-02
     +,   1.1057628E-02,   1.1613744E-02,   1.2234676E-02
     +,   1.2922297E-02,   1.3678230E-02,   1.4503625E-02
     +,   1.5399323E-02,   1.6365632E-02,   1.7402511E-02
     +,   1.8509272E-02,   1.9684853E-02,   2.0927463E-02
     +,   2.2234883E-02,   2.3604315E-02,   2.5032347E-02
     +,   2.6515085E-02,   2.8048253E-02,   2.9627228E-02
     +,   3.1246882E-02,   3.2901939E-02,   3.4586545E-02
     +,   3.6294606E-02,   3.8019173E-02,   3.9752718E-02
     +,   4.1486356E-02,   4.3210175E-02,   4.4912457E-02
     +,   4.6580087E-02,   4.8198469E-02,   4.9751725E-02
     +,   5.1223561E-02,   5.2598309E-02,   5.3862084E-02
     +,   5.5004314E-02,   5.6019638E-02,   5.6909706E-02
     +,   5.7684720E-02,   5.8364566E-02,   5.8979686E-02
     +,   5.9570752E-02,   6.0187459E-02,   6.0886219E-02
     +,   6.1726805E-02,   6.2767759E-02,   6.4060912E-02
     +,   6.5645613E-02,   6.7543000E-02,   6.9750749E-02
     +,   7.2238848E-02,   7.4947640E-02,   7.7788807E-02
     +,   8.0648430E-02,   8.3393708E-02,   8.5883357E-02
     +,   8.7979920E-02,   8.9564025E-02,   9.0549715E-02
     +,   9.0898387E-02,   9.0629838E-02,   8.9828812E-02
     +,   8.8645011E-02,   8.7285839E-02,   8.6000651E-02
     +,   8.5058741E-02,   8.4721863E-02,   8.5216455E-02
     +,   8.6711675E-02,   8.9308307E-02,   9.3046933E-02
     +,   9.7935840E-02,   0.1039963    ,   0.1113144    
     +,   0.1200817    ,   0.1306058    ,   0.1432801    
     +,   0.1585138    ,   0.1766387    ,   0.1978119    
     +,   0.2219345    ,   0.2486062    ,   0.2771271    
     +,   0.3065550    ,   0.3358276    ,   0.3639522    
     +,   0.3901883    ,   0.4141542    ,   0.4357780    
     +,   0.4550706    ,   0.4717844    ,   0.4851055    
     +,   0.4935335    ,   0.4950445    ,   0.4875259    
     +,   0.4693763    ,   0.4400823    ,   0.4005700    
     +,   0.3532043    ,   0.3014170    ,   0.2490501    
     +,   0.1996452    ,   0.1558735    ,   0.1192412    
     +,   9.0106331E-02,   6.7936100E-02,   5.1665880E-02
     +,   4.0040057E-02,   3.1863064E-02,   2.6137210E-02
     +,   2.2103129E-02,   1.9218568E-02,   1.7111387E-02
     +,   1.5530374E-02,   1.4305097E-02,   1.3317549E-02
     +,   1.2484661E-02,   1.1747704E-02,   1.1065728E-02
     +,   1.0411313E-02,   9.7675547E-03,   9.1256900E-03
     +,   8.4830904E-03,   7.8415284E-03,   7.2057839E-03
     +,   6.5824329E-03,   5.9787543E-03,   5.4018153E-03
     +,   4.8578540E-03,   4.3518795E-03,   3.8873125E-03
     +,   3.4659696E-03,   3.0881693E-03,   2.7528729E-03
     +,   2.4579212E-03,   2.2003385E-03,   1.9766258E-03
     +,   1.7829960E-03,   1.6155865E-03,   1.4706532E-03
     +,   1.3447076E-03,   1.2345921E-03,   1.1375237E-03
     +,   1.0511205E-03,   9.7339967E-04,   9.0273668E-04
     +,   8.3783560E-04,   7.7769090E-04,   7.2153838E-04
     +,   6.6880643E-04,   6.1908137E-04,   5.7207432E-04
     +,   5.2758615E-04,   4.8548036E-04,   4.4566512E-04
     +,   4.0807974E-04,   3.7267955E-04,   3.3942462E-04
     +,   3.0827630E-04,   2.7919540E-04,   2.5213414E-04
     +,   2.2703751E-04,   2.0384479E-04,   1.8248758E-04
     +,   1.6288957E-04,   1.4496878E-04,   1.2864018E-04
     +,   1.1381515E-04,   1.0040190E-04,   8.8307934E-05
     +,   7.7442019E-05,   6.7712470E-05,   5.9030885E-05
     +,   5.1310290E-05,   4.4468048E-05,   3.8424314E-05
     +,   3.3104167E-05,   2.8436310E-05,   2.4354680E-05
     +,   2.0797232E-05,   1.7707094E-05,   1.5031601E-05
     +,   1.2722642E-05,   1.0736628E-05,   9.0338435E-06
     +,   7.5787175E-06,   6.3391740E-06,   5.2867467E-06
     +,   4.3960035E-06,   3.6445711E-06,   3.0126480E-06
     +,   2.4829592E-06,   2.0403472E-06,   1.6716979E-06
     +,   1.3656037E-06,   1.1122717E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_asha_ttz120_mass = Yx/3.40233723529412
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_asha_ttz60_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  7.9942902E-04,   8.3598320E-04
     +,   8.7621273E-04,   9.2044659E-04,   9.6902822E-04
     +,   1.0223137E-03,   1.0806709E-03,   1.1444774E-03
     +,   1.2141174E-03,   1.2899839E-03,   1.3724695E-03
     +,   1.4619685E-03,   1.5588733E-03,   1.6635705E-03
     +,   1.7764403E-03,   1.8978528E-03,   2.0281661E-03
     +,   2.1677269E-03,   2.3168665E-03,   2.4759034E-03
     +,   2.6451452E-03,   2.8248893E-03,   3.0154246E-03
     +,   3.2170559E-03,   3.4300722E-03,   3.6548076E-03
     +,   3.8916145E-03,   4.1408972E-03,   4.4031264E-03
     +,   4.6788636E-03,   4.9687838E-03,   5.2737165E-03
     +,   5.5946750E-03,   5.9329127E-03,   6.2899836E-03
     +,   6.6678175E-03,   7.0688101E-03,   7.4959444E-03
     +,   7.9529779E-03,   8.4445281E-03,   8.9764046E-03
     +,   9.5557775E-03,   1.0191481E-02,   1.0894321E-02
     +,   1.1677372E-02,   1.2556262E-02,   1.3549414E-02
     +,   1.4678191E-02,   1.5966915E-02,   1.7442740E-02
     +,   1.9135294E-02,   2.1076106E-02,   2.3297699E-02
     +,   2.5832763E-02,   2.8712349E-02,   3.1965047E-02
     +,   3.5614938E-02,   3.9680328E-02,   4.4172242E-02
     +,   4.9093533E-02,   5.4438062E-02,   6.0190711E-02
     +,   6.6327177E-02,   7.2815619E-02,   7.9617254E-02
     +,   8.6686626E-02,   9.3973815E-02,   0.1014228    
     +,   0.1089726    ,   0.1165537    ,   0.1240880    
     +,   0.1314844    ,   0.1386392    ,   0.1454339    
     +,   0.1517392    ,   0.1574179    ,   0.1623324    
     +,   0.1663548    ,   0.1693780    ,   0.1713268    
     +,   0.1721689    ,   0.1719233    ,   0.1706655    
     +,   0.1685296    ,   0.1657051    ,   0.1624292    
     +,   0.1589747    ,   0.1556322    ,   0.1526903    
     +,   0.1504104    ,   0.1490039    ,   0.1486112    
     +,   0.1492861    ,   0.1509900    ,   0.1535976    
     +,   0.1569123    ,   0.1606932    ,   0.1646859    
     +,   0.1686546    ,   0.1724095    ,   0.1758249    
     +,   0.1788451    ,   0.1814795    ,   0.1837872    
     +,   0.1858564    ,   0.1877816    ,   0.1896436    
     +,   0.1914954    ,   0.1933515    ,   0.1951877    
     +,   0.1969412    ,   0.1985191    ,   0.1998055    
     +,   0.2006740    ,   0.2009985    ,   0.2006675    
     +,   0.1995939    ,   0.1977260    ,   0.1950536    
     +,   0.1916075    ,   0.1874573    ,   0.1827031    
     +,   0.1774656    ,   0.1718764    ,   0.1660693    
     +,   0.1601766    ,   0.1543243    ,   0.1486315    
     +,   0.1432077    ,   0.1381498    ,   0.1335372    
     +,   0.1294261    ,   0.1258438    ,   0.1227853    
     +,   0.1202135    ,   0.1180627    ,   0.1162460    
     +,   0.1146649    ,   0.1132198    ,   0.1118194    
     +,   0.1103884    ,   0.1088708    ,   0.1072314    
     +,   0.1054537    ,   0.1035370    ,   0.1014911    
     +,   9.9333227E-02,   9.7084463E-02,   9.4768457E-02
     +,   9.2410587E-02,   9.0038605E-02,   8.7683655E-02
     +,   8.5380808E-02,   8.3168775E-02,   8.1089154E-02
     +,   7.9184510E-02,   7.7495195E-02,   7.6055981E-02
     +,   7.4892841E-02,   7.4019790E-02,   7.3436745E-02
     +,   7.3128499E-02,   7.3064908E-02,   7.3202200E-02
     +,   7.3485650E-02,   7.3852830E-02,   7.4237272E-02
     +,   7.4572541E-02,   7.4795894E-02,   7.4851468E-02
     +,   7.4693136E-02,   7.4286051E-02,   7.3607810E-02
     +,   7.2648473E-02,   7.1410142E-02,   6.9905572E-02
     +,   6.8156533E-02,   6.6191941E-02,   6.4045705E-02
     +,   6.1754398E-02,   5.9355386E-02,   5.6885257E-02
     +,   5.4378282E-02,   5.1865011E-02,   4.9371872E-02
     +,   4.6920788E-02,   4.4529006E-02,   4.2209137E-02
     +,   3.9969657E-02,   3.7815630E-02,   3.5748981E-02
     +,   3.3769216E-02,   3.1874295E-02,   3.0060997E-02
     +,   2.8325312E-02,   2.6663031E-02,   2.5070077E-02
     +,   2.3542698E-02,   2.2077467E-02,   2.0671487E-02
     +,   1.9322483E-02,   1.8028691E-02,   1.6788721E-02
     +,   1.5601570E-02,   1.4466663E-02,   1.3383531E-02
     +,   1.2351850E-02,   1.1371437E-02,   1.0442102E-02
     +,   9.5635410E-03,   8.7353578E-03,   7.9570664E-03
     +,   7.2280196E-03,   6.5473290E-03,   5.9139230E-03
     +,   5.3265840E-03,   4.7838935E-03,   4.2842249E-03
     +,   3.8257947E-03,   3.4067344E-03,   3.0250149E-03
     +,   2.6785289E-03,   2.3651384E-03,   2.0826696E-03
     +,   1.8289319E-03,   1.6017589E-03,   1.3990444E-03
     +,   1.2187442E-03,   1.0588813E-03,   9.1757381E-04
     +,   7.9305208E-04,   6.8365323E-04,   5.8781978E-04
     +,   5.0411018E-04,   4.3120453E-04,   3.6788598E-04
     +,   3.1304653E-04,   2.6568529E-04,   2.2489754E-04
     +,   1.8986744E-04,   1.5986525E-04,   1.3424187E-04
     +,   1.1242030E-04,   9.3888317E-05,   7.8194185E-05
     +,   6.4941873E-05,   5.3784122E-05,   4.4416851E-05
     +,   3.6575591E-05,   3.0031637E-05,   2.4586468E-05
     +,   2.0069125E-05,   1.6333053E-05,   1.3252698E-05
     +,   1.0720750E-05,   8.6460168E-06,   6.9513389E-06
     +,   5.5715404E-06,   4.4516628E-06,   3.5456485E-06
     +,   2.8150657E-06,   2.2278882E-06,   1.7575084E-06
     +,   1.3819338E-06,   1.0830784E-06,   8.4606330E-07
     +,   6.5872410E-07,   5.1116024E-07,   3.9532955E-07
     +,   3.0471807E-07,   2.3407991E-07,   1.7920669E-07
     +,   1.3673102E-07,   1.0396692E-07,   7.8782840E-08
     +,   5.9495324E-08,   4.4775597E-08,   3.3582936E-08
     +,   2.5102249E-08,   1.8699939E-08,   1.3883778E-08
     +,   1.0274055E-08,   7.5781070E-09,   5.5719509E-09
     +,   4.0842978E-09,   2.9850982E-09,   2.1757125E-09
     +,   1.5817492E-09,   1.1473572E-09,   8.3067248E-10
     +,   6.0053229E-10,   4.3376222E-10,   3.1324776E-10
     +,   2.2636369E-10,   1.6385751E-10,   1.1895791E-10
     +,   8.6739393E-11,   6.3625057E-11,   4.7032725E-11
     +,   3.5100468E-11,   2.6493608E-11
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_asha_ttz60_mass = Yx/3.98948238888889
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_asha_ttz65_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.1713479E-04,   2.3388978E-04
     +,   2.5181263E-04,   2.7099755E-04,   2.9155012E-04
     +,   3.1358868E-04,   3.3724535E-04,   3.6266772E-04
     +,   3.9001970E-04,   4.1948454E-04,   4.5126362E-04
     +,   4.8557922E-04,   5.2267488E-04,   5.6281645E-04
     +,   6.0629216E-04,   6.5341266E-04,   7.0451072E-04
     +,   7.5993995E-04,   8.2007394E-04,   8.8530331E-04
     +,   9.5603341E-04,   1.0326809E-03,   1.1156680E-03
     +,   1.2054248E-03,   1.3023677E-03,   1.4069150E-03
     +,   1.5194624E-03,   1.6403854E-03,   1.7700298E-03
     +,   1.9087060E-03,   2.0566816E-03,   2.2141763E-03
     +,   2.3813567E-03,   2.5583326E-03,   2.7451550E-03
     +,   2.9418133E-03,   3.1482393E-03,   3.3643020E-03
     +,   3.5898346E-03,   3.8245975E-03,   4.0683416E-03
     +,   4.3207719E-03,   4.5815860E-03,   4.8504774E-03
     +,   5.1271580E-03,   5.4113762E-03,   5.7029426E-03
     +,   6.0017584E-03,   6.3078576E-03,   6.6214497E-03
     +,   6.9429795E-03,   7.2731995E-03,   7.6132356E-03
     +,   7.9647051E-03,   8.3297500E-03,   8.7111806E-03
     +,   9.1124857E-03,   9.5378710E-03,   9.9922167E-03
     +,   1.0480971E-02,   1.1009952E-02,   1.1585105E-02
     +,   1.2212144E-02,   1.2896400E-02,   1.3642698E-02
     +,   1.4455521E-02,   1.5340085E-02,   1.6303789E-02
     +,   1.7359268E-02,   1.8528128E-02,   1.9846419E-02
     +,   2.1370273E-02,   2.3182286E-02,   2.5396073E-02
     +,   2.8159155E-02,   3.1651508E-02,   3.6079109E-02
     +,   4.1662648E-02,   4.8622251E-02,   5.7159219E-02
     +,   6.7437083E-02,   7.9569146E-02,   9.3607046E-02
     +,   0.1095424    ,   0.1273086    ,   0.1467935    
     +,   0.1678423    ,   0.1902586    ,   0.2137794    
     +,   0.2380401    ,   0.2625322    ,   0.2865869    
     +,   0.3094367    ,   0.3303738    ,   0.3489779    
     +,   0.3653283    ,   0.3800648    ,   0.3941943    
     +,   0.4086687    ,   0.4238864    ,   0.4393719    
     +,   0.4538059    ,   0.4654356    ,   0.4726780    
     +,   0.4746553    ,   0.4714291    ,   0.4638801    
     +,   0.4533258    ,   0.4410785    ,   0.4281309    
     +,   0.4150724    ,   0.4022102    ,   0.3897917    
     +,   0.3781503    ,   0.3676897    ,   0.3587082    
     +,   0.3511983    ,   0.3447647    ,   0.3387358    
     +,   0.3324238    ,   0.3254055    ,   0.3176776    
     +,   0.3096238    ,   0.3018147    ,   0.2947558    
     +,   0.2887122    ,   0.2836861    ,   0.2795405    
     +,   0.2761788    ,   0.2736699    ,   0.2722370    
     +,   0.2721115    ,   0.2733123    ,   0.2754627    
     +,   0.2777329    ,   0.2789518    ,   0.2778551    
     +,   0.2733876    ,   0.2649561    ,   0.2525551    
     +,   0.2367436    ,   0.2184923    ,   0.1989661    
     +,   0.1793069    ,   0.1604718    ,   0.1431390    
     +,   0.1276937    ,   0.1142671    ,   0.1028000    
     +,   9.3114913E-02,   8.4978744E-02,   7.8148209E-02
     +,   7.2397150E-02,   6.7529768E-02,   6.3385397E-02
     +,   5.9837244E-02,   5.6787748E-02,   5.4163329E-02
     +,   5.1909115E-02,   4.9983878E-02,   4.8354946E-02
     +,   4.6994328E-02,   4.5876000E-02,   4.4973701E-02
     +,   4.4260036E-02,   4.3706380E-02,   4.3283343E-02
     +,   4.2961482E-02,   4.2712044E-02,   4.2507857E-02
     +,   4.2323787E-02,   4.2137135E-02,   4.1927852E-02
     +,   4.1678537E-02,   4.1374434E-02,   4.1003264E-02
     +,   4.0555120E-02,   4.0022437E-02,   3.9399814E-02
     +,   3.8683951E-02,   3.7873611E-02,   3.6969565E-02
     +,   3.5974566E-02,   3.4893099E-02,   3.3731323E-02
     +,   3.2496989E-02,   3.1199148E-02,   2.9847855E-02
     +,   2.8453913E-02,   2.7028777E-02,   2.5583994E-02
     +,   2.4131030E-02,   2.2681147E-02,   2.1245014E-02
     +,   1.9832481E-02,   1.8452458E-02,   1.7112928E-02
     +,   1.5820729E-02,   1.4581467E-02,   1.3399598E-02
     +,   1.2278517E-02,   1.1220533E-02,   1.0226883E-02
     +,   9.2979018E-03,   8.4332004E-03,   7.6315952E-03
     +,   6.8913167E-03,   6.2101600E-03,   5.5855354E-03
     +,   5.0145169E-03,   4.4939984E-03,   4.0207920E-03
     +,   3.5916569E-03,   3.2033401E-03,   2.8526585E-03
     +,   2.5365565E-03,   2.2521100E-03,   1.9965330E-03
     +,   1.7672146E-03,   1.5617453E-03,   1.3778759E-03
     +,   1.2135389E-03,   1.0668526E-03,   9.3609811E-04
     +,   8.1970380E-04,   7.1624381E-04,   6.2443205E-04
     +,   5.4310163E-04,   4.7118991E-04,   4.0773486E-04
     +,   3.5186810E-04,   3.0280088E-04,   2.5981394E-04
     +,   2.2225454E-04,   1.8953356E-04,   1.6111233E-04
     +,   1.3650276E-04,   1.1526405E-04,   9.6997130E-05
     +,   8.1340499E-05,   6.7968940E-05,   5.6591321E-05
     +,   4.6946949E-05,   3.8802704E-05,   3.1951757E-05
     +,   2.6211579E-05,   2.1421405E-05,   1.7439892E-05
     +,   1.4143857E-05,   1.1426590E-05,   9.1955881E-06
     +,   7.3713304E-06,   5.8858996E-06,   4.6814266E-06
     +,   3.7088041E-06,   2.9266632E-06,   2.3003522E-06
     +,   1.8009397E-06,   1.4043693E-06,   1.0907740E-06
     +,   8.4384266E-07,   6.5022533E-07,   4.9904128E-07
     +,   3.8148295E-07,   2.9046001E-07,   2.2027520E-07
     +,   1.6638295E-07,   1.2517548E-07,   9.3799692E-08
     +,   7.0008518E-08,   5.2043173E-08,   3.8533980E-08
     +,   2.8418178E-08,   2.0874532E-08,   1.5272191E-08
     +,   1.1129083E-08,   8.0775973E-09,   5.8395493E-09
     +,   4.2047725E-09,   3.0156500E-09,   2.1541999E-09
     +,   1.5327400E-09,   1.0862204E-09,   7.6673629E-10
     +,   5.3906690E-10,   3.7750170E-10,   2.6331176E-10
     +,   1.8293302E-10,   1.2658875E-10,   8.7250880E-11
     +,   5.9900168E-11,   4.0959861E-11,   2.7898003E-11
     +,   1.8926130E-11,   1.2788961E-11,   8.6076502E-12
     +,   5.7705806E-12,   3.8532853E-12,   2.5628928E-12
     +,   1.6978800E-12,   1.1203986E-12
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_asha_ttz65_mass = Yx/5.42223897297297
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_asha_ttz70_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  7.7773829E-04,   8.0157421E-04
     +,   8.2559080E-04,   8.4977521E-04,   8.7411731E-04
     +,   8.9860917E-04,   9.2324667E-04,   9.4802893E-04
     +,   9.7295927E-04,   9.9804718E-04,   1.0233069E-03
     +,   1.0487598E-03,   1.0744347E-03,   1.1003691E-03
     +,   1.1266101E-03,   1.1532160E-03,   1.1802578E-03
     +,   1.2078197E-03,   1.2360022E-03,   1.2649231E-03
     +,   1.2947196E-03,   1.3255515E-03,   1.3576013E-03
     +,   1.3910815E-03,   1.4262301E-03,   1.4633212E-03
     +,   1.5026632E-03,   1.5446036E-03,   1.5895315E-03
     +,   1.6378813E-03,   1.6901345E-03,   1.7468233E-03
     +,   1.8085313E-03,   1.8758945E-03,   1.9496030E-03
     +,   2.0303978E-03,   2.1190706E-03,   2.2164555E-03
     +,   2.3234349E-03,   2.4409075E-03,   2.5698079E-03
     +,   2.7110709E-03,   2.8656248E-03,   3.0343728E-03
     +,   3.2181719E-03,   3.4178107E-03,   3.6339827E-03
     +,   3.8672639E-03,   4.1180803E-03,   4.3866867E-03
     +,   4.6731336E-03,   4.9772481E-03,   5.2986043E-03
     +,   5.6365281E-03,   5.9900316E-03,   6.3578789E-03
     +,   6.7385272E-03,   7.1301609E-03,   7.5307111E-03
     +,   7.9378830E-03,   8.3491914E-03,   8.7620271E-03
     +,   9.1736857E-03,   9.5815053E-03,   9.9829221E-03
     +,   1.0375529E-02,   1.0757288E-02,   1.1126542E-02
     +,   1.1482243E-02,   1.1823993E-02,   1.2152268E-02
     +,   1.2468443E-02,   1.2774986E-02,   1.3075448E-02
     +,   1.3374544E-02,   1.3678108E-02,   1.3992958E-02
     +,   1.4326766E-02,   1.4687833E-02,   1.5084879E-02
     +,   1.5526803E-02,   1.6022831E-02,   1.6582735E-02
     +,   1.7217899E-02,   1.7942855E-02,   1.8778117E-02
     +,   1.9753724E-02,   2.0914150E-02,   2.2323290E-02
     +,   2.4069630E-02,   2.6269767E-02,   2.9069155E-02
     +,   3.2639917E-02,   3.7176624E-02,   4.2893104E-02
     +,   5.0026968E-02,   5.8862947E-02,   6.9773495E-02
     +,   8.3274961E-02,   0.1000555    ,   0.1209326    
     +,   0.1466747    ,   0.1777156    ,   0.2138558    
     +,   0.2541835    ,   0.2973725    ,   0.3423263    
     +,   0.3888258    ,   0.4376662    ,   0.4900138    
     +,   0.5462933    ,   0.6053691    ,   0.6645263    
     +,   0.7201993    ,   0.7688329    ,   0.8074958    
     +,   0.8340422    ,   0.8469158    ,   0.8449954    
     +,   0.8282565    ,   0.7992216    ,   0.7637703    
     +,   0.7297040    ,   0.7036659    ,   0.6888613    
     +,   0.6851396    ,   0.6904707    ,   0.7018754    
     +,   0.7152489    ,   0.7253090    ,   0.7270839    
     +,   0.7185467    ,   0.7022584    ,   0.6840662    
     +,   0.6693904    ,   0.6598203    ,   0.6524251    
     +,   0.6418583    ,   0.6235177    ,   0.5958166    
     +,   0.5606136    ,   0.5219846    ,   0.4842840    
     +,   0.4505671    ,   0.4219754    ,   0.3980032    
     +,   0.3772030    ,   0.3578754    ,   0.3385508    
     +,   0.3182515    ,   0.2965915    ,   0.2737386    
     +,   0.2502670    ,   0.2269533    ,   0.2045863    
     +,   0.1838319    ,   0.1651632    ,   0.1488415    
     +,   0.1349307    ,   0.1233291    ,   0.1138079    
     +,   0.1060621    ,   9.9758610E-02,   9.4575085E-02
     +,   9.0223864E-02,   8.6462863E-02,   8.3095364E-02
     +,   7.9964727E-02,   7.6948904E-02,   7.3956981E-02
     +,   7.0928060E-02,   6.7830056E-02,   6.4658731E-02
     +,   6.1434951E-02,   5.8200780E-02,   5.5012483E-02
     +,   5.1933609E-02,   4.9027655E-02,   4.6350896E-02
     +,   4.3946732E-02,   4.1842148E-02,   4.0046331E-02
     +,   3.8550749E-02,   3.7331063E-02,   3.6350429E-02
     +,   3.5563376E-02,   3.4919620E-02,   3.4367941E-02
     +,   3.3859365E-02,   3.3349875E-02,   3.2802068E-02
     +,   3.2186307E-02,   3.1481192E-02,   3.0673431E-02
     +,   2.9757192E-02,   2.8733283E-02,   2.7608246E-02
     +,   2.6393060E-02,   2.5101984E-02,   2.3751430E-02
     +,   2.2359120E-02,   2.0943034E-02,   1.9520614E-02
     +,   1.8108200E-02,   1.6720757E-02,   1.5371254E-02
     +,   1.4070641E-02,   1.2827841E-02,   1.1649703E-02
     +,   1.0541013E-02,   9.5047327E-03,   8.5422825E-03
     +,   7.6536392E-03,   6.8375473E-03,   6.0917954E-03
     +,   5.4134685E-03,   4.7990950E-03,   4.2447830E-03
     +,   3.7464171E-03,   3.2998333E-03,   2.9008226E-03
     +,   2.5452711E-03,   2.2292368E-03,   1.9489726E-03
     +,   1.7009362E-03,   1.4818381E-03,   1.2886563E-03
     +,   1.1186204E-03,   9.6919684E-04,   8.3809358E-04
     +,   7.2325266E-04,   6.2282354E-04,   5.3514284E-04
     +,   4.5872480E-04,   3.9225188E-04,   3.3454309E-04
     +,   2.8454853E-04,   2.4133780E-04,   2.0408332E-04
     +,   1.7204706E-04,   1.4457440E-04,   1.2108572E-04
     +,   1.0106672E-04,   8.4060288E-05,   6.9662303E-05
     +,   5.7516681E-05,   4.7309339E-05,   3.8763505E-05
     +,   3.1636635E-05,   2.5717498E-05,   2.0821517E-05
     +,   1.6788716E-05,   1.3481200E-05,   1.0780359E-05
     +,   8.5844713E-06,   6.8069762E-06,   5.3746189E-06
     +,   4.2255988E-06,   3.3079957E-06,   2.5784998E-06
     +,   2.0012096E-06,   1.5464656E-06,   1.1898785E-06
     +,   9.1153385E-07,   6.9527317E-07,   5.2801317E-07
     +,   3.9924069E-07,   3.0055796E-07,   2.2528305E-07
     +,   1.6812437E-07,   1.2491935E-07,   9.2412378E-08
     +,   6.8066747E-08,   4.9916189E-08,   3.6445559E-08
     +,   2.6494350E-08,   1.9176071E-08,   1.3818863E-08
     +,   9.9147677E-09,   7.0827384E-09,   5.0375371E-09
     +,   3.5673375E-09,   2.5151847E-09,   1.7656575E-09
     +,   1.2340809E-09,   8.5880125E-10,   5.9504407E-10
     +,   4.1049519E-10,   2.8195601E-10,   1.9282258E-10
     +,   1.3129577E-10,   8.9012020E-11,   6.0084639E-11
     +,   4.0381771E-11,   2.7022507E-11,   1.8004221E-11
     +,   1.1943812E-11,   7.8889907E-12,   5.1882656E-12
     +,   3.3973050E-12,   2.2149856E-12
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_asha_ttz70_mass = Yx/7.92152865
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_asha_ttz75_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  6.0756900E-04,   6.2662747E-04
     +,   6.4573938E-04,   6.6487881E-04,   6.8401953E-04
     +,   7.0313516E-04,   7.2219939E-04,   7.4118603E-04
     +,   7.6006865E-04,   7.7882269E-04,   7.9742249E-04
     +,   8.1584399E-04,   8.3406421E-04,   8.5206126E-04
     +,   8.6981460E-04,   8.8730612E-04,   9.0451940E-04
     +,   9.2144078E-04,   9.3806040E-04,   9.5437153E-04
     +,   9.7037212E-04,   9.8606583E-04,   1.0014618E-03
     +,   1.0165779E-03,   1.0314387E-03,   1.0460803E-03
     +,   1.0605498E-03,   1.0749077E-03,   1.0892296E-03
     +,   1.1036093E-03,   1.1181597E-03,   1.1330171E-03
     +,   1.1483426E-03,   1.1643257E-03,   1.1811870E-03
     +,   1.1991820E-03,   1.2186036E-03,   1.2397845E-03
     +,   1.2631034E-03,   1.2889819E-03,   1.3178943E-03
     +,   1.3503622E-03,   1.3869610E-03,   1.4283180E-03
     +,   1.4751137E-03,   1.5280782E-03,   1.5879918E-03
     +,   1.6556794E-03,   1.7320057E-03,   1.8178704E-03
     +,   1.9141977E-03,   2.0219295E-03,   2.1420114E-03
     +,   2.2753903E-03,   2.4229791E-03,   2.5856702E-03
     +,   2.7642965E-03,   2.9596270E-03,   3.1723438E-03
     +,   3.4030264E-03,   3.6521365E-03,   3.9199991E-03
     +,   4.2067678E-03,   4.5124488E-03,   4.8368657E-03
     +,   5.1796120E-03,   5.5401223E-03,   5.9175720E-03
     +,   6.3109715E-03,   6.7190742E-03,   7.1404935E-03
     +,   7.5736064E-03,   8.0167092E-03,   8.4679406E-03
     +,   8.9254454E-03,   9.3874121E-03,   9.8521467E-03
     +,   1.0318214E-02,   1.0784621E-02,   1.1250964E-02
     +,   1.1717568E-02,   1.2185789E-02,   1.2658151E-02
     +,   1.3138664E-02,   1.3632958E-02,   1.4148586E-02
     +,   1.4695127E-02,   1.5284480E-02,   1.5930850E-02
     +,   1.6651027E-02,   1.7464494E-02,   1.8393559E-02
     +,   1.9463772E-02,   2.0704549E-02,   2.2150017E-02
     +,   2.3840077E-02,   2.5822278E-02,   2.8152999E-02
     +,   3.0899238E-02,   3.4138326E-02,   3.7957117E-02
     +,   4.2447086E-02,   4.7698341E-02,   5.3789120E-02
     +,   6.0777139E-02,   6.8692438E-02,   7.7537276E-02
     +,   8.7298319E-02,   9.7972438E-02,   0.1095999    
     +,   0.1222971    ,   0.1362769    ,   0.1518360    
     +,   0.1693133    ,   0.1890113    ,   0.2111134    
     +,   0.2356033    ,   0.2622677    ,   0.2908847    
     +,   0.3217906    ,   0.3568224    ,   0.4001448    
     +,   0.4578249    ,   0.5351352    ,   0.6322178    
     +,   0.7409402    ,   0.8460597    ,   0.9310220    
     +,   0.9862428    ,    1.016137    ,    1.039531    
     +,    1.078834    ,    1.143069    ,    1.219248    
     +,    1.280633    ,    1.305289    ,    1.291148    
     +,    1.256609    ,    1.226898    ,    1.219766    
     +,    1.240201    ,    1.278530    ,    1.309809    
     +,    1.304301    ,    1.247720    ,    1.151847    
     +,    1.043674    ,   0.9456761    ,   0.8665554    
     +,   0.8046409    ,   0.7535987    ,   0.7056104    
     +,   0.6542824    ,   0.5975038    ,   0.5377156    
     +,   0.4793617    ,   0.4260751    ,   0.3794982    
     +,   0.3396333    ,   0.3057204    ,   0.2769132    
     +,   0.2525798    ,   0.2323070    ,   0.2157714    
     +,   0.2026052    ,   0.1923226    ,   0.1843190    
     +,   0.1779321    ,   0.1725308    ,   0.1675953    
     +,   0.1627593    ,   0.1578104    ,   0.1526566    
     +,   0.1472830    ,   0.1417115    ,   0.1359743    
     +,   0.1301059    ,   0.1241436    ,   0.1181324    
     +,   0.1121259    ,   0.1061832    ,   0.1003619    
     +,   9.4708748E-02,   8.9252539E-02,   8.4002137E-02
     +,   7.8948475E-02,   7.4069813E-02,   6.9338657E-02
     +,   6.4729214E-02,   6.0223345E-02,   5.5812892E-02
     +,   5.1500764E-02,   4.7300100E-02,   4.3231264E-02
     +,   3.9318461E-02,   3.5586845E-02,   3.2060023E-02
     +,   2.8757649E-02,   2.5693910E-02,   2.2877103E-02
     +,   2.0309746E-02,   1.7988749E-02,   1.5905989E-02
     +,   1.4049422E-02,   1.2404220E-02,   1.0953406E-02
     +,   9.6789459E-03,   8.5626375E-03,   7.5866263E-03
     +,   6.7338645E-03,   5.9885364E-03,   5.3363037E-03
     +,   4.7643506E-03,   4.2613610E-03,   3.8175161E-03
     +,   3.4244177E-03,   3.0749200E-03,   2.7629735E-03
     +,   2.4835120E-03,   2.2323334E-03,   2.0059177E-03
     +,   1.8013368E-03,   1.6161639E-03,   1.4483654E-03
     +,   1.2962157E-03,   1.1582441E-03,   1.0331904E-03
     +,   9.1995101E-04,   8.1753777E-04,   7.2506152E-04
     +,   6.4171670E-04,   5.6675985E-04,   4.9949402E-04
     +,   4.3926938E-04,   3.8548178E-04,   3.3755868E-04
     +,   2.9496409E-04,   2.5719911E-04,   2.2379824E-04
     +,   1.9432645E-04,   1.6838183E-04,   1.4559564E-04
     +,   1.2562946E-04,   1.0817271E-04,   9.2943243E-05
     +,   7.9686441E-05,   6.8172252E-05,   5.8193109E-05
     +,   4.9563012E-05,   4.2116553E-05,   3.5705536E-05
     +,   3.0198349E-05,   2.5478679E-05,   2.1443611E-05
     +,   1.8002031E-05,   1.5073833E-05,   1.2588822E-05
     +,   1.0485450E-05,   8.7097724E-06,   7.2147513E-06
     +,   5.9595714E-06,   4.9087621E-06,   4.0315554E-06
     +,   3.3014001E-06,   2.6955006E-06,   2.1942155E-06
     +,   1.7807473E-06,   1.4407860E-06,   1.1621521E-06
     +,   9.3450046E-07,   7.4909673E-07,   5.9859349E-07
     +,   4.7682366E-07,   3.7862225E-07,   2.9968641E-07
     +,   2.3645136E-07,   1.8596000E-07,   1.4578137E-07
     +,   1.1391451E-07,   8.8726679E-08,   6.8883857E-08
     +,   5.3305655E-08,   4.1116149E-08,   3.1611084E-08
     +,   2.4224001E-08,   1.8502815E-08,   1.4086714E-08
     +,   1.0689472E-08,   8.0851015E-09,   6.0951901E-09
     +,   4.5800439E-09,   3.4302328E-09,   2.5606874E-09
     +,   1.9052870E-09,   1.4130008E-09,   1.0444667E-09
     +,   7.6952789E-10,   5.6509725E-10,   4.1361822E-10
     +,   3.0174793E-10,   2.1941522E-10
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_asha_ttz75_mass = Yx/10.1655293333333
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_asha_ttz80_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.9342245E-05,   5.5478293E-05
     +,   6.2263403E-05,   6.9750859E-05,   7.7996454E-05
     +,   8.7058361E-05,   9.6996977E-05,   1.0787483E-04
     +,   1.1975601E-04,   1.3270702E-04,   1.4679493E-04
     +,   1.6208831E-04,   1.7865635E-04,   1.9656871E-04
     +,   2.1589496E-04,   2.3670436E-04,   2.5906536E-04
     +,   2.8304514E-04,   3.0870904E-04,   3.3612052E-04
     +,   3.6534024E-04,   3.9642572E-04,   4.2943092E-04
     +,   4.6440770E-04,   5.0140009E-04,   5.4045150E-04
     +,   5.8159861E-04,   6.2487368E-04,   6.7030377E-04
     +,   7.1791123E-04,   7.6771370E-04,   8.1972388E-04
     +,   8.7395008E-04,   9.3039678E-04,   9.8906469E-04
     +,   1.0499523E-03,   1.1130554E-03,   1.1783679E-03
     +,   1.2458873E-03,   1.3156047E-03,   1.3875208E-03
     +,   1.4616348E-03,   1.5379511E-03,   1.6164802E-03
     +,   1.6972392E-03,   1.7802531E-03,   1.8655563E-03
     +,   1.9531937E-03,   2.0432204E-03,   2.1357047E-03
     +,   2.2307266E-03,   2.3283779E-03,   2.4287626E-03
     +,   2.5320027E-03,   2.6382192E-03,   2.7475550E-03
     +,   2.8601545E-03,   2.9761691E-03,   3.0957526E-03
     +,   3.2190590E-03,   3.3462364E-03,   3.4774272E-03
     +,   3.6127495E-03,   3.7523150E-03,   3.8962094E-03
     +,   4.0444736E-03,   4.1971314E-03,   4.3541449E-03
     +,   4.5154495E-03,   4.6809074E-03,   4.8503503E-03
     +,   5.0235302E-03,   5.2001677E-03,   5.3799073E-03
     +,   5.5623651E-03,   5.7471213E-03,   5.9337206E-03
     +,   6.1217039E-03,   6.3106390E-03,   6.5001394E-03
     +,   6.6898805E-03,   6.8796766E-03,   7.0694722E-03
     +,   7.2594457E-03,   7.4500046E-03,   7.6418924E-03
     +,   7.8361882E-03,   8.0344174E-03,   8.2385512E-03
     +,   8.4510986E-03,   8.6751413E-03,   8.9143412E-03
     +,   9.1729797E-03,   9.4559947E-03,   9.7689517E-03
     +,   1.0117997E-02,   1.0509891E-02,   1.0951875E-02
     +,   1.1451707E-02,   1.2017514E-02,   1.2657883E-02
     +,   1.3381729E-02,   1.4198580E-02,   1.5118569E-02
     +,   1.6152987E-02,   1.7314784E-02,   1.8619228E-02
     +,   2.0084882E-02,   2.1734783E-02,   2.3597376E-02
     +,   2.5706919E-02,   2.8104048E-02,   3.0834092E-02
     +,   3.3945460E-02,   3.7485011E-02,   4.1493881E-02
     +,   4.6001095E-02,   5.1019974E-02,   5.6545097E-02
     +,   6.2556013E-02,   6.9025852E-02,   7.5937293E-02
     +,   8.3307452E-02,   9.1221087E-02,   9.9867195E-02
     +,   0.1095695    ,   0.1207926    ,   0.1340850    
     +,   0.1499480    ,   0.1686376    ,   0.1900059    
     +,   0.2134985    ,   0.2384304    ,   0.2644833    
     +,   0.2922975    ,   0.3241245    ,   0.3648280    
     +,   0.4232565    ,   0.5124745    ,   0.6456839    
     +,   0.8255289    ,    1.032116    ,    1.231493    
     +,    1.416725    ,    1.623541    ,    1.864913    
     +,    2.086161    ,    2.237275    ,    2.327646    
     +,    2.334776    ,    2.195191    ,    1.978933    
     +,    1.826921    ,    1.746485    ,    1.671640    
     +,    1.582239    ,    1.476180    ,    1.343457    
     +,    1.195739    ,    1.057698    ,   0.9354454    
     +,   0.8199928    ,   0.7077445    ,   0.6055309    
     +,   0.5210823    ,   0.4550903    ,   0.4022999    
     +,   0.3568087    ,   0.3152693    ,   0.2769074    
     +,   0.2422709    ,   0.2121437    ,   0.1869566    
     +,   0.1666145    ,   0.1505973    ,   0.1381811    
     +,   0.1286417    ,   0.1213665    ,   0.1158819    
     +,   0.1118360    ,   0.1089634    ,   0.1070453    
     +,   0.1058722    ,   0.1052168    ,   0.1048212    
     +,   0.1044021    ,   0.1036709    ,   0.1023634    
     +,   0.1002705    ,   9.7263463E-02,   9.3306147E-02
     +,   8.8454224E-02,   8.2841739E-02,   7.6657861E-02
     +,   7.0119292E-02,   6.3444450E-02,   5.6832582E-02
     +,   5.0448861E-02,   4.4417273E-02,   3.8820732E-02
     +,   3.3705793E-02,   2.9089296E-02,   2.4965758E-02
     +,   2.1314939E-02,   1.8107940E-02,   1.5310683E-02
     +,   1.2887219E-02,   1.0801540E-02,   9.0183923E-03
     +,   7.5037540E-03,   6.2253582E-03,   5.1529892E-03
     +,   4.2585828E-03,   3.5163674E-03,   2.9030731E-03
     +,   2.3980236E-03,   1.9830707E-03,   1.6425094E-03
     +,   1.3629741E-03,   1.1332677E-03,   9.4408216E-04
     +,   7.8779506E-04,   6.5823016E-04,   5.5041391E-04
     +,   4.6035758E-04,   3.8487921E-04,   3.2144453E-04
     +,   2.6802489E-04,   2.2298505E-04,   1.8499931E-04
     +,   1.5298465E-04,   1.2604384E-04,   1.0342382E-04
     +,   8.4487998E-05,   6.8694855E-05,   5.5577064E-05
     +,   4.4731471E-05,   3.5809673E-05,   2.8509718E-05
     +,   2.2570010E-05,   1.7765024E-05,   1.3901386E-05
     +,   1.0813838E-05,   8.3618070E-06,   6.4267638E-06
     +,   4.9095574E-06,   3.7276777E-06,   2.8129673E-06
     +,   2.1096334E-06,   1.5724108E-06,   1.1647455E-06
     +,   8.5741794E-07,   6.2726548E-07,   4.5604560E-07
     +,   3.2950115E-07,   2.3658664E-07,   1.6881536E-07
     +,   1.1970859E-07,   8.4357673E-08,   5.9075163E-08
     +,   4.1112095E-08,   2.8433121E-08,   1.9541773E-08
     +,   1.3346962E-08,   9.0591952E-09,   6.1105689E-09
     +,   4.0959214E-09,   2.7283840E-09,   1.8061289E-09
     +,   1.1881626E-09,   7.7674889E-10,   5.0462562E-10
     +,   3.2579739E-10,   2.0903053E-10,   1.3327513E-10
     +,   8.4446068E-11,   5.3172376E-11,   3.3272329E-11
     +,   2.0689858E-11,   1.2785635E-11,   7.8516967E-12
     +,   4.7917703E-12,   2.9060615E-12,   1.7514759E-12
     +,   1.0490127E-12,   6.2437810E-13,   3.6931629E-13
     +,   2.1708294E-13,   1.2680705E-13,   7.3610253E-14
     +,   4.2464269E-14,   2.4343634E-14,   1.3868785E-14
     +,   7.8517743E-15,   4.4176216E-15,   2.4699309E-15
     +,   1.3723760E-15,   7.5776796E-16,   4.1580747E-16
     +,   2.2673693E-16,   1.2287003E-16
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_asha_ttz80_mass = Yx/11.0703146666667
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_asha_ttz85_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  5.9808764E-05,   6.6405511E-05
     +,   7.3613526E-05,   8.1476326E-05,   9.0039306E-05
     +,   9.9349629E-05,   1.0945632E-04,   1.2041026E-04
     +,   1.3226367E-04,   1.4507122E-04,   1.5888868E-04
     +,   1.7377353E-04,   1.8978497E-04,   2.0698359E-04
     +,   2.2543161E-04,   2.4519238E-04,   2.6633090E-04
     +,   2.8891329E-04,   3.1300698E-04,   3.3868031E-04
     +,   3.6600270E-04,   3.9504457E-04,   4.2587632E-04
     +,   4.5857130E-04,   4.9319933E-04,   5.2983413E-04
     +,   5.6854758E-04,   6.0941110E-04,   6.5249589E-04
     +,   6.9787196E-04,   7.4560777E-04,   7.9576991E-04
     +,   8.4842223E-04,   9.0362568E-04,   9.6143776E-04
     +,   1.0219110E-03,   1.0850936E-03,   1.1510259E-03
     +,   1.2197471E-03,   1.2912805E-03,   1.3656496E-03
     +,   1.4428654E-03,   1.5229292E-03,   1.6058334E-03
     +,   1.6915596E-03,   1.7800791E-03,   1.8713532E-03
     +,   1.9653314E-03,   2.0619542E-03,   2.1611524E-03
     +,   2.2628489E-03,   2.3669589E-03,   2.4733925E-03
     +,   2.5820627E-03,   2.6928713E-03,   2.8057350E-03
     +,   2.9205701E-03,   3.0373065E-03,   3.1558883E-03
     +,   3.2762797E-03,   3.3984678E-03,   3.5224743E-03
     +,   3.6483428E-03,   3.7761673E-03,   3.9060838E-03
     +,   4.0382594E-03,   4.1729272E-03,   4.3103481E-03
     +,   4.4508497E-03,   4.5947856E-03,   4.7425646E-03
     +,   4.8946110E-03,   5.0513907E-03,   5.2133570E-03
     +,   5.3809737E-03,   5.5546849E-03,   5.7348791E-03
     +,   5.9218779E-03,   6.1159288E-03,   6.3171680E-03
     +,   6.5255710E-03,   6.7409864E-03,   6.9630491E-03
     +,   7.1912208E-03,   7.4247201E-03,   7.6625706E-03
     +,   7.9035368E-03,   8.1461910E-03,   8.3888611E-03
     +,   8.6297067E-03,   8.8667320E-03,   9.0977987E-03
     +,   9.3207015E-03,   9.5332321E-03,   9.7332308E-03
     +,   9.9186422E-03,   1.0087633E-02,   1.0238621E-02
     +,   1.0370401E-02,   1.0482186E-02,   1.0573713E-02
     +,   1.0645283E-02,   1.0697846E-02,   1.0733034E-02
     +,   1.0753205E-02,   1.0761457E-02,   1.0761645E-02
     +,   1.0758358E-02,   1.0756897E-02,   1.0763230E-02
     +,   1.0783928E-02,   1.0826092E-02,   1.0897262E-02
     +,   1.1005344E-02,   1.1158494E-02,   1.1365080E-02
     +,   1.1633575E-02,   1.1972583E-02,   1.2390789E-02
     +,   1.2897081E-02,   1.3500644E-02,   1.4211089E-02
     +,   1.5038717E-02,   1.5994977E-02,   1.7093023E-02
     +,   1.8348578E-02,   1.9781841E-02,   2.1419737E-02
     +,   2.3300147E-02,   2.5476851E-02,   2.8026810E-02
     +,   3.1057687E-02,   3.4717243E-02,   3.9201934E-02
     +,   4.4768050E-02,   5.1744454E-02,   6.0547858E-02
     +,   7.1698606E-02,   8.5822508E-02,   0.1036114    
     +,   0.1257149    ,   0.1525774    ,   0.1843148    
     +,   0.2208000    ,   0.2620450    ,   0.3086409    
     +,   0.3616090    ,   0.4212431    ,   0.4856355    
     +,   0.5507999    ,   0.6140955    ,   0.6805075    
     +,   0.7681271    ,   0.9044681    ,    1.106271    
     +,    1.356733    ,    1.611229    ,    1.833346    
     +,    2.036543    ,    2.288352    ,    2.584046    
     +,    2.818339    ,    2.998690    ,    3.113826    
     +,    3.044997    ,    2.825976    ,    2.512650    
     +,    2.140686    ,    1.789548    ,    1.496270    
     +,    1.277261    ,    1.123012    ,    1.002171    
     +,   0.9011793    ,   0.8191345    ,   0.7481532    
     +,   0.6755265    ,   0.5954013    ,   0.5123159    
     +,   0.4353420    ,   0.3714509    ,   0.3231027    
     +,   0.2890244    ,   0.2658953    ,   0.2498461    
     +,   0.2374787    ,   0.2263623    ,   0.2150883    
     +,   0.2030581    ,   0.1901925    ,   0.1766727    
     +,   0.1627621    ,   0.1487084    ,   0.1347065    
     +,   0.1209045    ,   0.1074314    ,   9.4422340E-02
     +,   8.2028769E-02,   7.0411183E-02,   5.9721880E-02
     +,   5.0083831E-02,   4.1572012E-02,   3.4204219E-02
     +,   2.7943391E-02,   2.2708084E-02,   1.8386034E-02
     +,   1.4850833E-02,   1.1975782E-02,   9.6435444E-03
     +,   7.7517796E-03,   6.2153819E-03,   4.9658809E-03
     +,   3.9491295E-03,   3.1224983E-03,   2.4522797E-03
     +,   1.9114257E-03,   1.4777451E-03,   1.1326692E-03
     +,   8.6048403E-04,   6.4782763E-04,   4.8330633E-04
     +,   3.5729489E-04,   2.6175164E-04,   1.9003419E-04
     +,   1.3672945E-04,   9.7494354E-05,   6.8893853E-05
     +,   4.8244576E-05,   3.3476830E-05,   2.3015280E-05
     +,   1.5675199E-05,   1.0574903E-05,   7.0653105E-06
     +,   4.6741097E-06,   3.0613703E-06,   1.9847341E-06
     +,   1.2734388E-06,   8.0849748E-07,   5.0785803E-07
     +,   3.1557201E-07,   1.9394521E-07,   1.1787834E-07
     +,   7.0846575E-08,   4.2099529E-08,   2.4731902E-08
     +,   1.4362350E-08,   8.2442773E-09,   4.6773301E-09
     +,   2.6225386E-09,   1.4531649E-09,   7.9568913E-10
     +,   4.3050422E-10,   2.3014680E-10,   1.2156814E-10
     +,   6.3445041E-11,   3.2712565E-11,   1.6663608E-11
     +,   8.3861217E-12,   4.1693884E-12,   2.0477914E-12
     +,   9.9358618E-13,   4.7625445E-13,   2.2551260E-13
     +,   1.0548498E-13,   4.8743856E-14,   2.2251098E-14
     +,   1.0034182E-14,   4.4702812E-15,   1.9676275E-15
     +,   8.5571413E-16,   3.6773247E-16,   1.5618855E-16
     +,   6.5587654E-17,   2.7242434E-17,   1.1200475E-17
     +,   4.5638900E-18,   1.8464369E-18,   7.4393631E-19
     +,   2.9982873E-19,   1.2169519E-19,   5.0206529E-20
     +,   2.1305371E-20,   9.4187324E-21,   4.3841485E-21
     +,   2.1586247E-21,   1.1209194E-21,   6.0827315E-22
     +,   3.4095134E-22,   1.9527266E-22,   1.1329513E-22
     +,   6.6191230E-23,   3.8786035E-23,   2.2739310E-23
     +,   1.3318070E-23,   7.7857313E-24,   4.5405903E-24
     +,   2.6409870E-24,   1.5317245E-24,   8.8578243E-25
     +,   5.1070993E-25,   2.9357873E-25
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_asha_ttz85_mass = Yx/12.8272815348837
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_asha_ttz90_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.8773697E-09,   4.0361345E-09
     +,   5.6378457E-09,   7.8422069E-09,   1.0862792E-08
     +,   1.4983796E-08,   2.0581652E-08,   2.8152463E-08
     +,   3.8346677E-08,   5.2013863E-08,   7.0256846E-08
     +,   9.4500827E-08,   1.2657873E-07,   1.6883560E-07
     +,   2.2425637E-07,   2.9662249E-07,   3.9069837E-07
     +,   5.1245672E-07,   6.6934768E-07,   8.7061284E-07
     +,   1.1276575E-06,   1.4544828E-06,   1.8681775E-06
     +,   2.3895220E-06,   3.0435535E-06,   3.8604130E-06
     +,   4.8760544E-06,   6.1331821E-06,   7.6822216E-06
     +,   9.5823571E-06,   1.1902660E-05,   1.4723246E-05
     +,   1.8136456E-05,   2.2248098E-05,   2.7178625E-05
     +,   3.3064276E-05,   4.0058156E-05,   4.8331003E-05
     +,   5.8072696E-05,   6.9491121E-05,   8.2814717E-05
     +,   9.8290620E-05,   1.1618517E-04,   1.3678290E-04
     +,   1.6038556E-04,   1.8731051E-04,   2.1788872E-04
     +,   2.5246255E-04,   2.9138301E-04,   3.3500683E-04
     +,   3.8369340E-04,   4.3780121E-04,   4.9768394E-04
     +,   5.6369189E-04,   6.3615787E-04,   7.1540929E-04
     +,   8.0175349E-04,   8.9548179E-04,   9.9686661E-04
     +,   1.1061599E-03,   1.2235924E-03,   1.3493756E-03
     +,   1.4836894E-03,   1.6266998E-03,   1.7785485E-03
     +,   1.9393334E-03,   2.1091409E-03,   2.2879967E-03
     +,   2.4759038E-03,   2.6727878E-03,   2.8785325E-03
     +,   3.0929174E-03,   3.3156583E-03,   3.5463336E-03
     +,   3.7844251E-03,   4.0292810E-03,   4.2800913E-03
     +,   4.5358944E-03,   4.7955997E-03,   5.0579705E-03
     +,   5.3216233E-03,   5.5851033E-03,   5.8468636E-03
     +,   6.1053699E-03,   6.3590962E-03,   6.6066626E-03
     +,   6.8468335E-03,   7.0786760E-03,   7.3015690E-03
     +,   7.5153382E-03,   7.7203088E-03,   7.9173464E-03
     +,   8.1079202E-03,   8.2941297E-03,   8.4786853E-03
     +,   8.6648623E-03,   8.8564623E-03,   9.0576829E-03
     +,   9.2730131E-03,   9.5070582E-03,   9.7643826E-03
     +,   1.0049286E-02,   1.0365658E-02,   1.0716720E-02
     +,   1.1104917E-02,   1.1531737E-02,   1.1997574E-02
     +,   1.2501665E-02,   1.3042104E-02,   1.3615851E-02
     +,   1.4218739E-02,   1.4845761E-02,   1.5491071E-02
     +,   1.6148400E-02,   1.6811138E-02,   1.7472798E-02
     +,   1.8127175E-02,   1.8768821E-02,   1.9393198E-02
     +,   1.9997135E-02,   2.0579029E-02,   2.1139029E-02
     +,   2.1679239E-02,   2.2203837E-02,   2.2718983E-02
     +,   2.3232697E-02,   2.3754716E-02,   2.4296099E-02
     +,   2.4868982E-02,   2.5486136E-02,   2.6160844E-02
     +,   2.6906578E-02,   2.7737284E-02,   2.8667413E-02
     +,   2.9712627E-02,   3.0890413E-02,   3.2220822E-02
     +,   3.3727642E-02,   3.5439782E-02,   3.7393060E-02
     +,   3.9632499E-02,   4.2215399E-02,   4.5214795E-02
     +,   4.8721559E-02,   5.2843839E-02,   5.7703037E-02
     +,   6.3422859E-02,   7.0110947E-02,   7.7834927E-02
     +,   8.6594276E-02,   9.6293300E-02,   0.1067275    
     +,   0.1176066    ,   0.1286447    ,   0.1397492    
     +,   0.1513159    ,   0.1645696    ,   0.1817840    
     +,   0.2061623    ,   0.2412713    ,   0.2902382    
     +,   0.3554551    ,   0.4400506    ,   0.5508536    
     +,   0.6987480    ,   0.8925765    ,    1.126770    
     +,    1.379173    ,    1.640721    ,    1.941394    
     +,    2.366168    ,    2.893363    ,    3.246219    
     +,    3.384884    ,    3.609650    ,    3.809458    
     +,    3.664755    ,    3.083799    ,    2.325482    
     +,    1.812963    ,    1.532621    ,    1.277121    
     +,    1.031041    ,   0.8565571    ,   0.7509686    
     +,   0.6815193    ,   0.6265044    ,   0.5745711    
     +,   0.5187881    ,   0.4571867    ,   0.3931153    
     +,   0.3322845    ,   0.2791857    ,   0.2354950    
     +,   0.2005422    ,   0.1725571    ,   0.1496475    
     +,   0.1302526    ,   0.1132538    ,   9.7948402E-02
     +,   8.3970636E-02,   7.1188502E-02,   5.9598494E-02
     +,   4.9240746E-02,   4.0143911E-02,   3.2296706E-02
     +,   2.5644520E-02,   2.0097665E-02,   1.5543564E-02
     +,   1.1859092E-02,   8.9208651E-03,   6.6118306E-03
     +,   4.8246668E-03,   3.4633779E-03,   2.4439446E-03
     +,   1.6941640E-03,   1.1530477E-03,   7.7010901E-04
     +,   5.0453661E-04,   3.2414685E-04,   2.0416475E-04
     +,   1.2604053E-04,   7.6253498E-05,   4.5203484E-05
     +,   2.6253330E-05,   1.4936240E-05,   8.3235436E-06
     +,   4.5431480E-06,   2.4285450E-06,   1.2712663E-06
     +,   6.5164227E-07,   3.2707584E-07,   1.6073828E-07
     +,   7.7337006E-08,   3.6429142E-08,   1.6798495E-08
     +,   7.5825630E-09,   3.3502108E-09,   1.4488617E-09
     +,   6.1326011E-10,   2.5403260E-10,   1.0297921E-10
     +,   4.0852086E-11,   1.5858053E-11,   6.0230939E-12
     +,   2.2382944E-12,   8.1383500E-13,   2.8949738E-13
     +,   1.0074169E-13,   3.4296025E-14,   1.1421346E-14
     +,   3.7204732E-15,   1.1854694E-15,   3.6948374E-16
     +,   1.1263802E-16,   3.3584023E-17,   9.7936373E-18
     +,   2.7933372E-18,   7.7919819E-19,   2.1256334E-19
     +,   5.6709125E-20,   1.4796292E-20,   3.7754009E-21
     +,   9.4200392E-22,   2.2985675E-22,   5.4846110E-23
     +,   1.2796553E-23,   2.9195198E-24,   6.5134978E-25
     +,   1.4209368E-25,   3.0308520E-26,   6.3211740E-27
     +,   1.2891173E-27,   2.5705110E-28,   5.0112742E-29
     +,   9.5526261E-30,   1.7802785E-30,   3.2440557E-31
     +,   5.7791910E-32,   1.0066286E-32,   1.7141371E-33
     +,   2.8539070E-34,   4.6450615E-35,   7.3218690E-36
     +,   1.1401618E-36,   1.7357087E-37,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_asha_ttz90_mass = Yx/12.4893794883721
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_asha_ttz95_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.5889149E-06,   3.1930633E-06
     +,   3.9254055E-06,   4.8100460E-06,   5.8749174E-06
     +,   7.1522468E-06,   8.6790351E-06,   1.0497565E-05
     +,   1.2655901E-05,   1.5208546E-05,   1.8216764E-05
     +,   2.1749231E-05,   2.5882473E-05,   3.0701343E-05
     +,   3.6299309E-05,   4.2778855E-05,   5.0251616E-05
     +,   5.8838421E-05,   6.8669244E-05,   7.9882921E-05
     +,   9.2626709E-05,   1.0705560E-04,   1.2333106E-04
     +,   1.4162135E-04,   1.6209662E-04,   1.8493188E-04
     +,   2.1030095E-04,   2.3837584E-04,   2.6932397E-04
     +,   3.0330522E-04,   3.4046837E-04,   3.8094824E-04
     +,   4.2486162E-04,   4.7230380E-04,   5.2334496E-04
     +,   5.7802605E-04,   6.3635525E-04,   6.9830357E-04
     +,   7.6380628E-04,   8.3274912E-04,   9.0498041E-04
     +,   9.8029675E-04,   1.0584481E-03,   1.1391352E-03
     +,   1.2220102E-03,   1.3066775E-03,   1.3926954E-03
     +,   1.4795787E-03,   1.5668032E-03,   1.6538097E-03
     +,   1.7400087E-03,   1.8247883E-03,   1.9075178E-03
     +,   1.9875639E-03,   2.0642832E-03,   2.1370489E-03
     +,   2.2052459E-03,   2.2682860E-03,   2.3256142E-03
     +,   2.3767194E-03,   2.4211411E-03,   2.4584767E-03
     +,   2.4883877E-03,   2.5106096E-03,   2.5249519E-03
     +,   2.5313050E-03,   2.5296414E-03,   2.5200199E-03
     +,   2.5025823E-03,   2.4775574E-03,   2.4452542E-03
     +,   2.4060642E-03,   2.3604520E-03,   2.3089580E-03
     +,   2.2521848E-03,   2.1907950E-03,   2.1255089E-03
     +,   2.0570934E-03,   1.9863534E-03,   1.9141259E-03
     +,   1.8412827E-03,   1.7687068E-03,   1.6973055E-03
     +,   1.6279859E-03,   1.5616687E-03,   1.4992645E-03
     +,   1.4416890E-03,   1.3898420E-03,   1.3446196E-03
     +,   1.3068999E-03,   1.2775481E-03,   1.2574145E-03
     +,   1.2473325E-03,   1.2481168E-03,   1.2605669E-03
     +,   1.2854637E-03,   1.3235747E-03,   1.3756476E-03
     +,   1.4424226E-03,   1.5246181E-03,   1.6229502E-03
     +,   1.7381128E-03,   1.8707998E-03,   2.0216790E-03
     +,   2.1914155E-03,   2.3806589E-03,   2.5900237E-03
     +,   2.8200892E-03,   3.0714083E-03,   3.3444772E-03
     +,   3.6396934E-03,   3.9573959E-03,   4.2977636E-03
     +,   4.6608727E-03,   5.0465842E-03,   5.4545985E-03
     +,   5.8843330E-03,   6.3349945E-03,   6.8054525E-03
     +,   7.2943019E-03,   7.7998219E-03,   8.3199311E-03
     +,   8.8522211E-03,   9.3940170E-03,   9.9423686E-03
     +,   1.0494068E-02,   1.1045842E-02,   1.1594309E-02
     +,   1.2136284E-02,   1.2668809E-02,   1.3189510E-02
     +,   1.3696753E-02,   1.4190088E-02,   1.4670503E-02
     +,   1.5140958E-02,   1.5606793E-02,   1.6076202E-02
     +,   1.6560797E-02,   1.7076209E-02,   1.7642677E-02
     +,   1.8285632E-02,   1.9036356E-02,   1.9932577E-02
     +,   2.1018723E-02,   2.2345608E-02,   2.3969648E-02
     +,   2.5950709E-02,   2.8348582E-02,   3.1218333E-02
     +,   3.4605116E-02,   3.8538348E-02,   4.3026749E-02
     +,   4.8055626E-02,   5.3586796E-02,   5.9560191E-02
     +,   6.5896392E-02,   7.2500132E-02,   7.9263508E-02
     +,   8.6069874E-02,   9.2803307E-02,   9.9374279E-02
     +,   0.1057654    ,   0.1121054    ,   0.1187637    
     +,   0.1264392    ,   0.1361746    ,   0.1491954    
     +,   0.1664840    ,   0.1882026    ,   0.2135139    
     +,   0.2416637    ,   0.2744337    ,   0.3182669    
     +,   0.3845187    ,   0.4888732    ,   0.6465235    
     +,   0.8546256    ,    1.086344    ,    1.333639    
     +,    1.619040    ,    1.967720    ,    2.518859    
     +,    3.259820    ,    3.679860    ,    3.730579    
     +,    3.916668    ,    4.116987    ,    3.934191    
     +,    3.345663    ,    2.645225    ,    2.103112    
     +,    1.730138    ,    1.439518    ,    1.156379    
     +,   0.8901900    ,   0.6795980    ,   0.5295315    
     +,   0.4216119    ,   0.3374956    ,   0.2673910    
     +,   0.2085103    ,   0.1605980    ,   0.1229390    
     +,   9.3914844E-02,   7.1643725E-02,   5.4468773E-02
     +,   4.1112375E-02,   3.0660065E-02,   2.2486448E-02
     +,   1.6161708E-02,   1.1364247E-02,   7.8207003E-03
     +,   5.2793850E-03,   3.5087529E-03,   2.3061540E-03
     +,   1.5055393E-03,   9.7952830E-04,   6.3611841E-04
     +,   4.1214837E-04,   2.6584379E-04,   1.7014891E-04
     +,   1.0766447E-04,   6.7121488E-05,   4.1107400E-05
     +,   2.4672889E-05,   1.4487120E-05,   8.3109562E-06
     +,   4.6541059E-06,   2.5424563E-06,   1.3542656E-06
     +,   7.0318293E-07,   3.5585236E-07,   1.7548680E-07
     +,   8.4322686E-08,   3.9478920E-08,   1.8008731E-08
     +,   8.0034255E-09,   3.4653609E-09,   1.4618737E-09
     +,   6.0082278E-10,   2.4057095E-10,   9.3845383E-11
     +,   3.5667094E-11,   1.3206764E-11,   4.7641444E-12
     +,   1.6743538E-12,   5.7333061E-13,   1.9127008E-13
     +,   6.2168898E-14,   1.9689821E-14,   6.0770239E-15
     +,   1.8281881E-15,   5.3641252E-16,   1.5370335E-16
     +,   4.3126951E-17,   1.1921001E-17,   3.2894543E-18
     +,   9.3097027E-19,   2.8341053E-19,   9.8578778E-20
     +,   4.0588421E-20,   1.9356278E-20,   1.0120548E-20
     +,   5.5348351E-21,   3.0818659E-21,   1.7250175E-21
     +,   9.6533997E-22,   5.3891902E-22,   2.9989048E-22
     +,   1.6628019E-22,   9.1853563E-23,   5.0549042E-23
     +,   2.7713555E-23,   1.5136180E-23,   8.2351556E-24
     +,   4.4634783E-24,   2.4099003E-24,   1.2961745E-24
     +,   6.9445965E-25,   3.7064639E-25,   1.9705408E-25
     +,   1.0436087E-25,   5.5054868E-26,   2.8931890E-26
     +,   1.5144512E-26,   7.8968459E-27,   4.1016303E-27
     +,   2.1220399E-27,   1.0936061E-27,   5.6137998E-28
     +,   2.8705362E-28,   1.4620180E-28,   7.4173581E-29
     +,   3.7482307E-29,   1.8867129E-29,   9.4594652E-30
     +,   4.7241707E-30,   2.3499672E-30,   1.1643874E-30
     +,   5.7465649E-31,   2.8249774E-31
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_asha_ttz95_mass = Yx/12.4893794883721
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_asha_hatt100_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.3947948E-03,   1.4433896E-03
     +,   1.4938723E-03,   1.5463666E-03,   1.6010085E-03
     +,   1.6579477E-03,   1.7173480E-03,   1.7793896E-03
     +,   1.8442669E-03,   1.9121963E-03,   1.9834093E-03
     +,   2.0581579E-03,   2.1367145E-03,   2.2193741E-03
     +,   2.3064525E-03,   2.3982883E-03,   2.4952425E-03
     +,   2.5976996E-03,   2.7060674E-03,   2.8207751E-03
     +,   2.9422736E-03,   3.0710357E-03,   3.2075495E-03
     +,   3.3523280E-03,   3.5058863E-03,   3.6687651E-03
     +,   3.8415049E-03,   4.0246523E-03,   4.2187530E-03
     +,   4.4243503E-03,   4.6419767E-03,   4.8721456E-03
     +,   5.1153516E-03,   5.3720558E-03,   5.6426884E-03
     +,   5.9276316E-03,   6.2272223E-03,   6.5417280E-03
     +,   6.8713804E-03,   7.2162962E-03,   7.5765587E-03
     +,   7.9521434E-03,   8.3429450E-03,   8.7487726E-03
     +,   9.1693364E-03,   9.6042585E-03,   1.0053070E-02
     +,   1.0515211E-02,   1.0990036E-02,   1.1476827E-02
     +,   1.1974795E-02,   1.2483090E-02,   1.3000818E-02
     +,   1.3527092E-02,   1.4060955E-02,   1.4601521E-02
     +,   1.5147908E-02,   1.5699310E-02,   1.6254999E-02
     +,   1.6814385E-02,   1.7377011E-02,   1.7942632E-02
     +,   1.8511169E-02,   1.9082848E-02,   1.9658186E-02
     +,   2.0237958E-02,   2.0823371E-02,   2.1415932E-02
     +,   2.2017680E-02,   2.2630963E-02,   2.3258740E-02
     +,   2.3904363E-02,   2.4571802E-02,   2.5265515E-02
     +,   2.5990646E-02,   2.6752936E-02,   2.7558807E-02
     +,   2.8415399E-02,   2.9330749E-02,   3.0313756E-02
     +,   3.1374179E-02,   3.2522991E-02,   3.3772130E-02
     +,   3.5134885E-02,   3.6625724E-02,   3.8260628E-02
     +,   4.0056881E-02,   4.2033438E-02,   4.4210758E-02
     +,   4.6611220E-02,   4.9259149E-02,   5.2180827E-02
     +,   5.5404853E-02,   5.8962386E-02,   6.2887058E-02
     +,   6.7214362E-02,   7.1981706E-02,   7.7226318E-02
     +,   8.2984529E-02,   8.9287795E-02,   9.6160986E-02
     +,   0.1036165    ,   0.1116521    ,   0.1202447    
     +,   0.1293481    ,   0.1388913    ,   0.1487763    
     +,   0.1588826    ,   0.1690728    ,   0.1792008    
     +,   0.1891226    ,   0.1987112    ,   0.2078682    
     +,   0.2165387    ,   0.2247182    ,   0.2324600    
     +,   0.2398721    ,   0.2471135    ,   0.2543794    
     +,   0.2618872    ,   0.2698580    ,   0.2784952    
     +,   0.2879682    ,   0.2983972    ,   0.3098448    
     +,   0.3223090    ,   0.3357357    ,   0.3500301    
     +,   0.3650915    ,   0.3808506    ,   0.3973234    
     +,   0.4146508    ,   0.4331275    ,   0.4531773    
     +,   0.4752801    ,   0.4998381    ,   0.5270181    
     +,   0.5566194    ,   0.5880337    ,   0.6203254    
     +,   0.6524150    ,   0.6833275    ,   0.7123899    
     +,   0.7393224    ,   0.7641823    ,   0.7872086    
     +,   0.8086522    ,   0.8286741    ,   0.8474034    
     +,   0.8651138    ,   0.8824083    ,   0.9001926    
     +,   0.9193574    ,   0.9402764    ,   0.9624739    
     +,   0.9848034    ,    1.006037    ,    1.025373    
     +,    1.042370    ,    1.056495    ,    1.067033    
     +,    1.073955    ,    1.079342    ,    1.087968    
     +,    1.105949    ,    1.137791    ,    1.183684    
     +,    1.238900    ,    1.295810    ,    1.347410    
     +,    1.390590    ,    1.427435    ,    1.463666    
     +,    1.504677    ,    1.551296    ,    1.598044    
     +,    1.635617    ,    1.656661    ,    1.661328    
     +,    1.658521    ,    1.661544    ,    1.680817    
     +,    1.718361    ,    1.767313    ,    1.816094    
     +,    1.853993    ,    1.874472    ,    1.875377    
     +,    1.858127    ,    1.827553    ,    1.790804    
     +,    1.753834    ,    1.717569    ,    1.677538    
     +,    1.627280    ,    1.562071    ,    1.479968    
     +,    1.380582    ,    1.264012    ,    1.131303    
     +,   0.9856550    ,   0.8329235    ,   0.6807744    
     +,   0.5370917    ,   0.4084553    ,   0.2991709    
     +,   0.2110001    ,   0.1433991    ,   9.4084151E-02
     +,   5.9775501E-02,   3.6930945E-02,   2.2300867E-02
     +,   1.3233400E-02,   7.7562085E-03,   4.5084390E-03
     +,   2.6054587E-03,   1.4978147E-03,   8.5535535E-04
     +,   4.8385843E-04,   2.7015692E-04,   1.4831753E-04
     +,   7.9792459E-05,   4.1955995E-05,   2.1531405E-05
     +,   1.0788244E-05,   5.2959208E-06,   2.5710144E-06
     +,   1.2593064E-06,   6.4546623E-07,   3.6456686E-07
     +,   2.3708475E-07,   1.7794463E-07,   1.4834565E-07
     +,   1.3126109E-07,   1.1949480E-07,   1.1010916E-07
     +,   1.0193892E-07,   9.4527273E-08,   8.7689415E-08
     +,   8.1341000E-08,   7.5434706E-08,   6.9937293E-08
     +,   6.4820654E-08,   6.0059548E-08,   5.5630277E-08
     +,   5.1511240E-08,   4.7682022E-08,   4.4123340E-08
     +,   4.0817007E-08,   3.7746279E-08,   3.4895315E-08
     +,   3.2249144E-08,   2.9793927E-08,   2.7516734E-08
     +,   2.5405331E-08,   2.3448218E-08,   2.1634797E-08
     +,   1.9955106E-08,   1.8399806E-08,   1.6960097E-08
     +,   1.5627903E-08,   1.4395669E-08,   1.3256204E-08
     +,   1.2202887E-08,   1.1229581E-08,   1.0330498E-08
     +,   9.5002344E-09,   8.7338012E-09,   8.0265776E-09
     +,   7.3741671E-09,   6.7725368E-09,   6.2179195E-09
     +,   5.7068479E-09,   5.2360507E-09,   4.8024775E-09
     +,   4.4033626E-09,   4.0360617E-09,   3.6981820E-09
     +,   3.3874539E-09,   3.1018121E-09,   2.8393030E-09
     +,   2.5981541E-09,   2.3766904E-09,   2.1733877E-09
     +,   1.9868078E-09,   1.8156453E-09,   1.6586800E-09
     +,   1.5147732E-09,   1.3828978E-09,   1.2620786E-09
     +,   1.1514341E-09,   1.0501373E-09,   9.5743813E-10
     +,   8.7262741E-10,   7.9506712E-10,   7.2415673E-10
     +,   6.5935313E-10,   6.0014738E-10,   5.4607824E-10
     +,   4.9671267E-10,   4.5166126E-10
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_asha_hatt100_mass = Yx/22.3891905106383
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_asha_hatt105_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.2817261E-03,   2.3659365E-03
     +,   2.4538874E-03,   2.5457854E-03,   2.6418462E-03
     +,   2.7422942E-03,   2.8473635E-03,   2.9572970E-03
     +,   3.0723442E-03,   3.1927673E-03,   3.3188290E-03
     +,   3.4507993E-03,   3.5889517E-03,   3.7335637E-03
     +,   3.8849111E-03,   4.0432694E-03,   4.2089131E-03
     +,   4.3821083E-03,   4.5631174E-03,   4.7521894E-03
     +,   4.9495632E-03,   5.1554651E-03,   5.3700996E-03
     +,   5.5936696E-03,   5.8263289E-03,   6.0682385E-03
     +,   6.3195191E-03,   6.5802736E-03,   6.8505802E-03
     +,   7.1304897E-03,   7.4200355E-03,   7.7192211E-03
     +,   8.0280323E-03,   8.3464459E-03,   8.6744158E-03
     +,   9.0118879E-03,   9.3588103E-03,   9.7151203E-03
     +,   1.0080795E-02,   1.0455788E-02,   1.0840116E-02
     +,   1.1233810E-02,   1.1636951E-02,   1.2049673E-02
     +,   1.2472182E-02,   1.2904746E-02,   1.3347721E-02
     +,   1.3801560E-02,   1.4266812E-02,   1.4744129E-02
     +,   1.5234281E-02,   1.5738148E-02,   1.6256711E-02
     +,   1.6791124E-02,   1.7342567E-02,   1.7912399E-02
     +,   1.8502042E-02,   1.9113000E-02,   1.9746860E-02
     +,   2.0405233E-02,   2.1089766E-02,   2.1802107E-02
     +,   2.2543820E-02,   2.3316462E-02,   2.4121469E-02
     +,   2.4960050E-02,   2.5833378E-02,   2.6742209E-02
     +,   2.7687231E-02,   2.8668702E-02,   2.9686712E-02
     +,   3.0740907E-02,   3.1830791E-02,   3.2955442E-02
     +,   3.4113873E-02,   3.5304923E-02,   3.6527343E-02
     +,   3.7779968E-02,   3.9061956E-02,   4.0372863E-02
     +,   4.1712731E-02,   4.3082539E-02,   4.4484105E-02
     +,   4.5920577E-02,   4.7396291E-02,   4.8917178E-02
     +,   5.0490618E-02,   5.2125741E-02,   5.3833045E-02
     +,   5.5624772E-02,   5.7514541E-02,   5.9517112E-02
     +,   6.1648268E-02,   6.3924789E-02,   6.6364065E-02
     +,   6.8983607E-02,   7.1801275E-02,   7.4834339E-02
     +,   7.8099832E-02,   8.1613146E-02,   8.5388541E-02
     +,   8.9437351E-02,   9.3768626E-02,   9.8387435E-02
     +,   0.1032956    ,   0.1084919    ,   0.1139722    
     +,   0.1197321    ,   0.1257693    ,   0.1320863    
     +,   0.1386924    ,   0.1456071    ,   0.1528582    
     +,   0.1604813    ,   0.1685130    ,   0.1769840    
     +,   0.1859075    ,   0.1952708    ,   0.2050252    
     +,   0.2150838    ,   0.2253236    ,   0.2355934    
     +,   0.2457303    ,   0.2555775    ,   0.2650019    
     +,   0.2739045    ,   0.2822309    ,   0.2899669    
     +,   0.2971396    ,   0.3038152    ,   0.3101063    
     +,   0.3161817    ,   0.3222805    ,   0.3287177    
     +,   0.3358748    ,   0.3441665    ,   0.3539865    
     +,   0.3656431    ,   0.3792996    ,   0.3949329    
     +,   0.4123206    ,   0.4310628    ,   0.4506354    
     +,   0.4704695    ,   0.4900480    ,   0.5090190    
     +,   0.5272911    ,   0.5451024    ,   0.5630447    
     +,   0.5820451    ,   0.6033042    ,   0.6281639    
     +,   0.6578697    ,   0.6931719    ,   0.7338344    
     +,   0.7782561    ,   0.8235580    ,   0.8663690    
     +,   0.9041098    ,   0.9361873    ,   0.9642470    
     +,   0.9911485    ,    1.019183    ,    1.048689    
     +,    1.077972    ,    1.104527    ,    1.126612    
     +,    1.144086    ,    1.157993    ,    1.169350    
     +,    1.178073    ,    1.182938    ,    1.182625    
     +,    1.177128    ,    1.168422    ,    1.159853    
     +,    1.154724    ,    1.155027    ,    1.160934    
     +,    1.171060    ,    1.183164    ,    1.194949    
     +,    1.204416    ,    1.209464    ,    1.207075    
     +,    1.193138    ,    1.163755    ,    1.117463    
     +,    1.056802    ,   0.9878109    ,   0.9175329    
     +,   0.8510824    ,   0.7899787    ,   0.7324857    
     +,   0.6753548    ,   0.6158004    ,   0.5527134    
     +,   0.4868461    ,   0.4202622    ,   0.3555236    
     +,   0.2949961    ,   0.2404187    ,   0.1927585    
     +,   0.1522791    ,   0.1187098    ,   9.1431566E-02
     +,   6.9651008E-02,   5.2527729E-02,   3.9253544E-02
     +,   2.9096872E-02,   2.1422911E-02,   1.5696699E-02
     +,   1.1476666E-02,   8.4047019E-03,   6.1954064E-03
     +,   4.6247430E-03,   3.5193027E-03,   2.7468763E-03
     +,   2.2084336E-03,   1.8311656E-03,   1.5625738E-03
     +,   1.3657151E-03,   1.2152686E-03,   1.0943750E-03
     +,   9.9216949E-04,   9.0192579E-04,   8.1967894E-04
     +,   7.4323243E-04,   6.7147281E-04,   6.0392014E-04
     +,   5.4043788E-04,   4.8104642E-04,   4.2581078E-04
     +,   3.7478664E-04,   3.2799304E-04,   2.8539129E-04
     +,   2.4688890E-04,   2.1234628E-04,   1.8158069E-04
     +,   1.5437372E-04,   1.3048261E-04,   1.0965031E-04
     +,   9.1610891E-05,   7.6096032E-05,   6.2842286E-05
     +,   5.1596468E-05,   4.2118088E-05,   3.4181852E-05
     +,   2.7580227E-05,   2.2124930E-05,   1.7645960E-05
     +,   1.3992152E-05,   1.1030716E-05,   8.6458376E-06
     +,   6.7373921E-06,   5.2198207E-06,   4.0207115E-06
     +,   3.0792110E-06,   2.3445718E-06,   1.7748989E-06
     +,   1.3359108E-06,   9.9973136E-07,   7.4386185E-07
     +,   5.5031137E-07,   4.0480828E-07,   2.9608918E-07
     +,   2.1534812E-07,   1.5575078E-07,   1.1202718E-07
     +,   8.0140822E-08,   5.7025154E-08,   4.0367645E-08
     +,   2.8434773E-08,   1.9935689E-08,   1.3916600E-08
     +,   9.6779287E-09,   6.7090005E-09,   4.6404027E-09
     +,   3.2060861E-09,   2.2161122E-09,   1.5355031E-09
     +,   1.0691397E-09,   7.5028744E-10,   5.3251958E-10
     +,   3.8367287E-10,   2.8164063E-10,   2.1129049E-10
     +,   1.6233774E-10,   1.2782750E-10,   1.0307304E-10
     +,   8.4935420E-11,   7.1316050E-11,   6.0816761E-11
     +,   5.2503946E-11,   4.5755490E-11,   4.0153433E-11
     +,   3.5415511E-11,   3.1347237E-11,   2.7813448E-11
     +,   2.4717459E-11,   2.1988212E-11
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_asha_hatt105_mass = Yx/15.3245798222222
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_asha_hatt107_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.5075329E-03,   2.6012780E-03
     +,   2.6985288E-03,   2.7993007E-03,   2.9035974E-03
     +,   3.0114115E-03,   3.1227188E-03,   3.2374843E-03
     +,   3.3556554E-03,   3.4771687E-03,   3.6019415E-03
     +,   3.7298745E-03,   3.8608524E-03,   3.9947424E-03
     +,   4.1313954E-03,   4.2706439E-03,   4.4123027E-03
     +,   4.5561725E-03,   4.7020325E-03,   4.8496528E-03
     +,   4.9987799E-03,   5.1491540E-03,   5.3004948E-03
     +,   5.4525244E-03,   5.6049363E-03,   5.7574343E-03
     +,   5.9097083E-03,   6.0614506E-03,   6.2123518E-03
     +,   6.3621085E-03,   6.5104277E-03,   6.6570281E-03
     +,   6.8016471E-03,   6.9440431E-03,   7.0840055E-03
     +,   7.2213537E-03,   7.3559489E-03,   7.4876957E-03
     +,   7.6165576E-03,   7.7425432E-03,   7.8657409E-03
     +,   7.9862997E-03,   8.1044519E-03,   8.2205096E-03
     +,   8.3348770E-03,   8.4480504E-03,   8.5606286E-03
     +,   8.6733103E-03,   8.7869009E-03,   8.9023095E-03
     +,   9.0205595E-03,   9.1427770E-03,   9.2701865E-03
     +,   9.4041275E-03,   9.5460173E-03,   9.6973665E-03
     +,   9.8597780E-03,   1.0034911E-02,   1.0224486E-02
     +,   1.0430286E-02,   1.0654134E-02,   1.0897878E-02
     +,   1.1163405E-02,   1.1452626E-02,   1.1767503E-02
     +,   1.2109997E-02,   1.2482166E-02,   1.2886108E-02
     +,   1.3324079E-02,   1.3798435E-02,   1.4311791E-02
     +,   1.4866990E-02,   1.5467284E-02,   1.6116273E-02
     +,   1.6818151E-02,   1.7577708E-02,   1.8400399E-02
     +,   1.9292433E-02,   2.0260908E-02,   2.1313788E-02
     +,   2.2459805E-02,   2.3708586E-02,   2.5070313E-02
     +,   2.6555823E-02,   2.8175959E-02,   2.9941650E-02
     +,   3.1862993E-02,   3.3949226E-02,   3.6207531E-02
     +,   3.8642962E-02,   4.1257478E-02,   4.4049144E-02
     +,   4.7011703E-02,   5.0134357E-02,   5.3401411E-02
     +,   5.6791972E-02,   6.0281307E-02,   6.3840821E-02
     +,   6.7440294E-02,   7.1048610E-02,   7.4637137E-02
     +,   7.8180663E-02,   8.1661105E-02,   8.5068516E-02
     +,   8.8403754E-02,   9.1679148E-02,   9.4918698E-02
     +,   9.8157443E-02,   0.1014401    ,   0.1048182    
     +,   0.1083472    ,   0.1120833    ,   0.1160801    
     +,   0.1203871    ,   0.1250474    ,   0.1300984    
     +,   0.1355720    ,   0.1414971    ,   0.1478989    
     +,   0.1548009    ,   0.1622224    ,   0.1701728    
     +,   0.1786464    ,   0.1876141    ,   0.1970156    
     +,   0.2067547    ,   0.2167030    ,   0.2267076    
     +,   0.2366129    ,   0.2462834    ,   0.2556369    
     +,   0.2646646    ,   0.2734486    ,   0.2821544    
     +,   0.2910054    ,   0.3002382    ,   0.3100459    
     +,   0.3205301    ,   0.3316794    ,   0.3433904    
     +,   0.3555420    ,   0.3681150    ,   0.3813249    
     +,   0.3957172    ,   0.4121663    ,   0.4317556    
     +,   0.4555399    ,   0.4842559    ,   0.5180590    
     +,   0.5563502    ,   0.5977188    ,   0.6400072    
     +,   0.6805353    ,   0.7164702    ,   0.7453297    
     +,   0.7655559    ,   0.7770550    ,   0.7815384    
     +,   0.7824651    ,   0.7843813    ,   0.7916242    
     +,   0.8068045    ,   0.8298152    ,   0.8580660    
     +,   0.8879412    ,   0.9165803    ,   0.9428084    
     +,   0.9667223    ,   0.9885691    ,    1.008053    
     +,    1.024743    ,    1.039046    ,    1.052609    
     +,    1.067355    ,    1.083623    ,    1.098922    
     +,    1.108698    ,    1.109069    ,    1.099633    
     +,    1.084038    ,    1.067633    ,    1.053900    
     +,    1.042378    ,    1.029469    ,    1.011170    
     +,   0.9854773    ,   0.9529325    ,   0.9155046    
     +,   0.8750607    ,   0.8324303    ,   0.7873110    
     +,   0.7387603    ,   0.6859081    ,   0.6285744    
     +,   0.5675524    ,   0.5044724    ,   0.4413519    
     +,   0.3801049    ,   0.3222350    ,   0.2687879    
     +,   0.2204461    ,   0.1776340    ,   0.1405645    
     +,   0.1092401    ,   8.3441436E-02,   6.2733404E-02
     +,   4.6517905E-02,   3.4106702E-02,   2.4795236E-02
     +,   1.7924016E-02,   1.2918632E-02,   9.3067447E-03
     +,   6.7168702E-03,   4.8671328E-03,   3.5494312E-03
     +,   2.6129023E-03,   1.9491694E-03,   1.4806201E-03
     +,   1.1516614E-03,   9.2235918E-04,   7.6389225E-04
     +,   6.5546174E-04,   5.8208272E-04,   5.3300010E-04
     +,   5.0055049E-04,   4.7932685E-04,   4.6555902E-04
     +,   4.5664940E-04,   4.5083291E-04,   4.4692942E-04
     +,   4.4416203E-04,   4.4202819E-04,   4.4020856E-04
     +,   4.3850439E-04,   4.3679465E-04,   4.3500762E-04
     +,   4.3310202E-04,   4.3105494E-04,   4.2885507E-04
     +,   4.2649708E-04,   4.2397948E-04,   4.2130344E-04
     +,   4.1847091E-04,   4.1548477E-04,   4.1234810E-04
     +,   4.0906473E-04,   4.0563848E-04,   4.0207326E-04
     +,   3.9837320E-04,   3.9454279E-04,   3.9058630E-04
     +,   3.8650818E-04,   3.8231321E-04,   3.7800628E-04
     +,   3.7359211E-04,   3.6907537E-04,   3.6446130E-04
     +,   3.5975498E-04,   3.5496140E-04,   3.5008555E-04
     +,   3.4513275E-04,   3.4010835E-04,   3.3501736E-04
     +,   3.2986482E-04,   3.2465637E-04,   3.1939690E-04
     +,   3.1409151E-04,   3.0874545E-04,   3.0336404E-04
     +,   2.9795215E-04,   2.9251468E-04,   2.8705673E-04
     +,   2.8158331E-04,   2.7609910E-04,   2.7060873E-04
     +,   2.6511712E-04,   2.5962852E-04,   2.5414769E-04
     +,   2.4867867E-04,   2.4322608E-04,   2.3779373E-04
     +,   2.3238592E-04,   2.2700627E-04,   2.2165889E-04
     +,   2.1634705E-04,   2.1107466E-04,   2.0584490E-04
     +,   2.0066087E-04,   1.9552601E-04,   1.9044298E-04
     +,   1.8541490E-04,   1.8044419E-04,   1.7553364E-04
     +,   1.7068541E-04,   1.6590206E-04,   1.6118534E-04
     +,   1.5653763E-04,   1.5196038E-04,   1.4745566E-04
     +,   1.4302465E-04,   1.3866910E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_asha_hatt107_mass = Yx/13.132693
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_asha_hatt110_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.0812002E-03,   3.1989512E-03
     +,   3.3217084E-03,   3.4496065E-03,   3.5827693E-03
     +,   3.7213152E-03,   3.8653479E-03,   4.0149628E-03
     +,   4.1702394E-03,   4.3312539E-03,   4.4980603E-03
     +,   4.6707015E-03,   4.8492090E-03,   5.0335987E-03
     +,   5.2238735E-03,   5.4200254E-03,   5.6220312E-03
     +,   5.8298544E-03,   6.0434509E-03,   6.2627662E-03
     +,   6.4877337E-03,   6.7182793E-03,   6.9543188E-03
     +,   7.1957810E-03,   7.4425614E-03,   7.6945769E-03
     +,   7.9517299E-03,   8.2139280E-03,   8.4810769E-03
     +,   8.7530911E-03,   9.0298820E-03,   9.3113659E-03
     +,   9.5974607E-03,   9.8880995E-03,   1.0183206E-02
     +,   1.0482723E-02,   1.0786586E-02,   1.1094736E-02
     +,   1.1407138E-02,   1.1723719E-02,   1.2044450E-02
     +,   1.2369283E-02,   1.2698176E-02,   1.3031093E-02
     +,   1.3368002E-02,   1.3708878E-02,   1.4053707E-02
     +,   1.4402496E-02,   1.4755266E-02,   1.5112075E-02
     +,   1.5473031E-02,   1.5838286E-02,   1.6208060E-02
     +,   1.6582688E-02,   1.6962579E-02,   1.7348306E-02
     +,   1.7740594E-02,   1.8140350E-02,   1.8548703E-02
     +,   1.8967029E-02,   1.9396985E-02,   1.9840557E-02
     +,   2.0300036E-02,   2.0778108E-02,   2.1277867E-02
     +,   2.1802763E-02,   2.2356706E-02,   2.2943957E-02
     +,   2.3569228E-02,   2.4237499E-02,   2.4954142E-02
     +,   2.5724629E-02,   2.6554676E-02,   2.7449859E-02
     +,   2.8415691E-02,   2.9457344E-02,   3.0579427E-02
     +,   3.1785764E-02,   3.3079341E-02,   3.4461949E-02
     +,   3.5933893E-02,   3.7494048E-02,   3.9139394E-02
     +,   4.0865287E-02,   4.2664994E-02,   4.4530146E-02
     +,   4.6450440E-02,   4.8414275E-02,   5.0408598E-02
     +,   5.2419666E-02,   5.4433390E-02,   5.6435764E-02
     +,   5.8413472E-02,   6.0354859E-02,   6.2250316E-02
     +,   6.4092778E-02,   6.5878883E-02,   6.7609034E-02
     +,   6.9288284E-02,   7.0926405E-02,   7.2538286E-02
     +,   7.4143708E-02,   7.5767219E-02,   7.7437252E-02
     +,   7.9185292E-02,   8.1044696E-02,   8.3048858E-02
     +,   8.5229822E-02,   8.7616786E-02,   9.0234920E-02
     +,   9.3104303E-02,   9.6240781E-02,   9.9656105E-02
     +,   0.1033607    ,   0.1073647    ,   0.1116814    
     +,   0.1163278    ,   0.1213259    ,   0.1266995    
     +,   0.1324714    ,   0.1386567    ,   0.1452541    
     +,   0.1522391    ,   0.1595582    ,   0.1671264    
     +,   0.1748296    ,   0.1825373    ,   0.1901160    
     +,   0.1974543    ,   0.2044837    ,   0.2112023    
     +,   0.2176884    ,   0.2241081    ,   0.2307065    
     +,   0.2377926    ,   0.2457138    ,   0.2548256    
     +,   0.2654632    ,   0.2779129    ,   0.2923804    
     +,   0.3089540    ,   0.3275624    ,   0.3479381    
     +,   0.3696025    ,   0.3918995    ,   0.4141067    
     +,   0.4356037    ,   0.4560539    ,   0.4755317    
     +,   0.4945061    ,   0.5136467    ,   0.5334933    
     +,   0.5541184    ,   0.5749435    ,   0.5948263    
     +,   0.6124474    ,   0.6268452    ,   0.6378623    
     +,   0.6462538    ,   0.6533921    ,   0.6607146    
     +,   0.6692250    ,   0.6793222    ,   0.6909921    
     +,   0.7041488    ,   0.7188172    ,   0.7350169    
     +,   0.7524741    ,   0.7704238    ,   0.7877121    
     +,   0.8032157    ,   0.8163952    ,   0.8276896    
     +,   0.8384943    ,   0.8506083    ,   0.8653414    
     +,   0.8826362    ,   0.9006978    ,   0.9163666    
     +,   0.9261687    ,   0.9275669    ,   0.9198591    
     +,   0.9042407    ,   0.8829857    ,   0.8581694    
     +,   0.8306797    ,   0.8000339    ,   0.7650190    
     +,   0.7246753    ,   0.6789953    ,   0.6290271    
     +,   0.5764893    ,   0.5232181    ,   0.4707332    
     +,   0.4200666    ,   0.3718223    ,   0.3263407    
     +,   0.2838462    ,   0.2445316    ,   0.2085752    
     +,   0.1761169    ,   0.1472224    ,   0.1218627    
     +,   9.9917985E-02,   8.1193283E-02,   6.5434247E-02
     +,   5.2349448E-02,   4.1628119E-02,   3.2953892E-02
     +,   2.6017129E-02,   2.0526445E-02,   1.6217116E-02
     +,   1.2855947E-02,   1.0243671E-02,   8.2150437E-03
     +,   6.6365767E-03,   5.4026740E-03,   4.4312952E-03
     +,   3.6597433E-03,   3.0406991E-03,   2.5386182E-03
     +,   2.1269980E-03,   1.7861422E-03,   1.5013823E-03
     +,   1.2617416E-03,   1.0589628E-03,   8.8677363E-04
     +,   7.4031501E-04,   6.1573647E-04,   5.0992134E-04
     +,   4.2028833E-04,   3.4464456E-04,   2.8108907E-04
     +,   2.2795853E-04,   1.8379062E-04,   1.4728741E-04
     +,   1.1730311E-04,   9.2831040E-05,   7.2989249E-05
     +,   5.7009158E-05,   4.4227261E-05,   3.4075656E-05
     +,   2.6071086E-05,   1.9805304E-05,   1.4936912E-05
     +,   1.1182990E-05,   8.3106888E-06,   6.1299606E-06
     +,   4.4872804E-06,   3.2598164E-06,   2.3499420E-06
     +,   1.6809242E-06,   1.1930293E-06,   8.4014471E-07
     +,   5.8700022E-07,   4.0689878E-07,   2.7982935E-07
     +,   1.9092207E-07,   1.2922987E-07,   8.6776716E-08
     +,   5.7806819E-08,   3.8202625E-08,   2.5046068E-08
     +,   1.6289684E-08,   1.0510595E-08,   6.7279347E-09
     +,   4.2724544E-09,   2.6917415E-09,   1.6825806E-09
     +,   1.0435776E-09,   6.4226929E-10,   3.9230283E-10
     +,   2.3786875E-10,   1.4321831E-10,   8.5666023E-11
     +,   5.0944565E-11,   3.0152769E-11,   1.7791945E-11
     +,   1.0491193E-11,   6.2041253E-12,   3.6977808E-12
     +,   2.2362737E-12,   1.3836592E-12,   8.8398820E-13
     +,   5.8803022E-13,   4.0947801E-13,   2.9869819E-13
     +,   2.2731507E-13,   1.7916412E-13,   1.4503168E-13
     +,   1.1965614E-13,   9.9995323E-14,   8.4261699E-14
     +,   7.1370312E-14,   6.0637056E-14,   5.1606228E-14
     +,   4.3958591E-14,   3.7456644E-14,   3.1916862E-14
     +,   2.7191055E-14,   2.3157915E-14
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_asha_hatt110_mass = Yx/11.057009
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_asha_hatt115_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.2823217E-03,   2.3170495E-03
     +,   2.3514703E-03,   2.3855972E-03,   2.4194480E-03
     +,   2.4530485E-03,   2.4864306E-03,   2.5196334E-03
     +,   2.5527056E-03,   2.5857042E-03,   2.6186961E-03
     +,   2.6517578E-03,   2.6849781E-03,   2.7184575E-03
     +,   2.7523099E-03,   2.7866629E-03,   2.8216606E-03
     +,   2.8574651E-03,   2.8942558E-03,   2.9322342E-03
     +,   2.9716240E-03,   3.0126756E-03,   3.0556647E-03
     +,   3.1009056E-03,   3.1487376E-03,   3.1995466E-03
     +,   3.2537570E-03,   3.3118424E-03,   3.3743260E-03
     +,   3.4417878E-03,   3.5148687E-03,   3.5942744E-03
     +,   3.6807801E-03,   3.7752362E-03,   3.8785683E-03
     +,   3.9917803E-03,   4.1159568E-03,   4.2522601E-03
     +,   4.4019385E-03,   4.5662932E-03,   4.7467141E-03
     +,   4.9446309E-03,   5.1615238E-03,   5.3988956E-03
     +,   5.6582629E-03,   5.9411228E-03,   6.2489356E-03
     +,   6.5830918E-03,   6.9448841E-03,   7.3354682E-03
     +,   7.7558449E-03,   8.2068006E-03,   8.6888904E-03
     +,   9.2024356E-03,   9.7474167E-03,   1.0323553E-02
     +,   1.0930220E-02,   1.1566480E-02,   1.2231084E-02
     +,   1.2922521E-02,   1.3639029E-02,   1.4378726E-02
     +,   1.5139617E-02,   1.5919819E-02,   1.6717702E-02
     +,   1.7531943E-02,   1.8361954E-02,   1.9207936E-02
     +,   2.0071315E-02,   2.0954862E-02,   2.1863181E-02
     +,   2.2802768E-02,   2.3782508E-02,   2.4813613E-02
     +,   2.5909947E-02,   2.7087975E-02,   2.8366443E-02
     +,   2.9766189E-02,   3.1309616E-02,   3.3019915E-02
     +,   3.4919858E-02,   3.7030935E-02,   3.9371517E-02
     +,   4.1955844E-02,   4.4791784E-02,   4.7880042E-02
     +,   5.1211935E-02,   5.4769106E-02,   5.8522020E-02
     +,   6.2430333E-02,   6.6443190E-02,   7.0499822E-02
     +,   7.4531399E-02,   7.8463830E-02,   8.2220107E-02
     +,   8.5723266E-02,   8.8900633E-02,   9.1686465E-02
     +,   9.4025902E-02,   9.5877253E-02,   9.7214952E-02
     +,   9.8030508E-02,   9.8333627E-02,   9.8151825E-02
     +,   9.7529493E-02,   9.6525736E-02,   9.5212102E-02
     +,   9.3669191E-02,   9.1983169E-02,   9.0242006E-02
     +,   8.8532314E-02,   8.6935759E-02,   8.5526668E-02
     +,   8.4370114E-02,   8.3520882E-02,   8.3023444E-02
     +,   8.2912773E-02,   8.3215803E-02,   8.3954088E-02
     +,   8.5145913E-02,   8.6809330E-02,   8.8963754E-02
     +,   9.1631904E-02,   9.4839804E-02,   9.8615833E-02
     +,   0.1029877    ,   0.1079797    ,   0.1136066    
     +,   0.1198694    ,   0.1267488    ,   0.1342020    
     +,   0.1421566    ,   0.1505125    ,   0.1591385    
     +,   0.1678787    ,   0.1765584    ,   0.1849935    
     +,   0.1930064    ,   0.2004439    ,   0.2071978    
     +,   0.2132254    ,   0.2185682    ,   0.2233642    
     +,   0.2278500    ,   0.2323516    ,   0.2372642    
     +,   0.2430185    ,   0.2500362    ,   0.2586775    
     +,   0.2691818    ,   0.2816075    ,   0.2957871    
     +,   0.3113139    ,   0.3275879    ,   0.3439207    
     +,   0.3596972    ,   0.3745560    ,   0.3885268    
     +,   0.4020672    ,   0.4159712    ,   0.4311651    
     +,   0.4484406    ,   0.4681962    ,   0.4902610    
     +,   0.5138339    ,   0.5375487    ,   0.5596780    
     +,   0.5784553    ,   0.5924845    ,   0.6011312    
     +,   0.6047701    ,   0.6047553    ,   0.6030819    
     +,   0.6018531    ,   0.6027868    ,   0.6069763    
     +,   0.6149539    ,   0.6268966    ,   0.6427224    
     +,   0.6619081    ,   0.6831299    ,   0.7040592    
     +,   0.7216171    ,   0.7327317    ,   0.7352378    
     +,   0.7284261    ,   0.7129174    ,   0.6899785    
     +,   0.6607626    ,   0.6259580    ,   0.5859723    
     +,   0.5414260    ,   0.4935294    ,   0.4440672    
     +,   0.3950171    ,   0.3480731    ,   0.3043204    
     +,   0.2641879    ,   0.2276267    ,   0.1943775    
     +,   0.1641889    ,   0.1369201    ,   0.1125409    
     +,   9.1078885E-02,   7.2550543E-02,   5.6906302E-02
     +,   4.4008773E-02,   3.3635460E-02,   2.5497036E-02
     +,   1.9265223E-02,   1.4602403E-02,   1.1186426E-02
     +,   8.7278206E-03,   6.9800019E-03,   5.7429993E-03
     +,   4.8617595E-03,   4.2209052E-03,   3.7380303E-03
     +,   3.3566658E-03,   3.0397282E-03,   2.7638974E-03
     +,   2.5152590E-03,   2.2860290E-03,   2.0721951E-03
     +,   1.8719160E-03,   1.6845100E-03,   1.5098299E-03
     +,   1.3478744E-03,   1.1985919E-03,   1.0617987E-03
     +,   9.3716837E-04,   8.2422758E-04,   7.2238111E-04
     +,   6.3095265E-04,   5.4922601E-04,   4.7645415E-04
     +,   4.1189365E-04,   3.5482392E-04,   3.0455421E-04
     +,   2.6042835E-04,   2.2183289E-04,   1.8820071E-04
     +,   1.5900694E-04,   1.3376694E-04,   1.1203616E-04
     +,   9.3409675E-05,   7.7517660E-05,   6.4022846E-05
     +,   5.2619696E-05,   4.3033688E-05,   3.5016954E-05
     +,   2.8348197E-05,   2.2831089E-05,   1.8292081E-05
     +,   1.4578510E-05,   1.1557343E-05,   9.1135416E-06
     +,   7.1481495E-06,   5.5765413E-06,   4.3270356E-06
     +,   3.3393947E-06,   2.5632783E-06,   1.9568959E-06
     +,   1.4858548E-06,   1.1220898E-06,   8.4278378E-07
     +,   6.2955934E-07,   4.6772769E-07,   3.4561234E-07
     +,   2.5399228E-07,   1.8564542E-07,   1.3495394E-07
     +,   9.7573206E-08,   7.0164461E-08,   5.0181416E-08
     +,   3.5696207E-08,   2.5255149E-08,   1.7772244E-08
     +,   1.2439395E-08,   8.6604723E-09,   5.9975602E-09
     +,   4.1316999E-09,   2.8315243E-09,   1.9306119E-09
     +,   1.3097547E-09,   8.8425511E-10,   5.9420691E-10
     +,   3.9753573E-10,   2.6488442E-10,   1.7586042E-10
     +,   1.1641100E-10,   7.6892187E-11,   5.0736290E-11
     +,   3.3489943E-11,   2.2155408E-11,   1.4723370E-11
     +,   9.8566511E-12,   6.6688794E-12,   4.5765414E-12
     +,   3.1968497E-12,   2.2802452E-12
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_asha_hatt115_mass = Yx/8.2987443
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_asha_hatt120_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.1171984E-04,   3.3814958E-04
     +,   3.6662188E-04,   3.9727855E-04,   4.3026911E-04
     +,   4.6575099E-04,   5.0388899E-04,   5.4485584E-04
     +,   5.8883021E-04,   6.3600054E-04,   6.8655860E-04
     +,   7.4070325E-04,   7.9863728E-04,   8.6056814E-04
     +,   9.2670525E-04,   9.9725905E-04,   1.0724403E-03
     +,   1.1524564E-03,   1.2375116E-03,   1.3278037E-03
     +,   1.4235213E-03,   1.5248430E-03,   1.6319312E-03
     +,   1.7449396E-03,   1.8639895E-03,   1.9891951E-03
     +,   2.1206383E-03,   2.2583748E-03,   2.4024337E-03
     +,   2.5528101E-03,   2.7094688E-03,   2.8723383E-03
     +,   3.0413135E-03,   3.2162545E-03,   3.3969840E-03
     +,   3.5832960E-03,   3.7749498E-03,   3.9716782E-03
     +,   4.1732010E-03,   4.3792021E-03,   4.5893812E-03
     +,   4.8034228E-03,   5.0210324E-03,   5.2419393E-03
     +,   5.4659178E-03,   5.6928075E-03,   5.9225289E-03
     +,   6.1551114E-03,   6.3907243E-03,   6.6297110E-03
     +,   6.8726167E-03,   7.1202312E-03,   7.3736338E-03
     +,   7.6342537E-03,   7.9038739E-03,   8.1847357E-03
     +,   8.4795561E-03,   8.7915733E-03,   9.1245929E-03
     +,   9.4830198E-03,   9.8718610E-03,   1.0296741E-02
     +,   1.0763831E-02,   1.1279844E-02,   1.1851929E-02
     +,   1.2487464E-02,   1.3194008E-02,   1.3978919E-02
     +,   1.4849269E-02,   1.5811335E-02,   1.6870497E-02
     +,   1.8030593E-02,   1.9293865E-02,   2.0660289E-02
     +,   2.2127518E-02,   2.3690542E-02,   2.5341334E-02
     +,   2.7068917E-02,   2.8859483E-02,   3.0696476E-02
     +,   3.2560755E-02,   3.4431454E-02,   3.6286142E-02
     +,   3.8102068E-02,   3.9856434E-02,   4.1527864E-02
     +,   4.3096811E-02,   4.4546846E-02,   4.5865100E-02
     +,   4.7043212E-02,   4.8077632E-02,   4.8969880E-02
     +,   4.9726591E-02,   5.0359365E-02,   5.0884139E-02
     +,   5.1320449E-02,   5.1690731E-02,   5.2018974E-02
     +,   5.2329842E-02,   5.2647337E-02,   5.2993938E-02
     +,   5.3389423E-02,   5.3850397E-02,   5.4389730E-02
     +,   5.5016492E-02,   5.5736184E-02,   5.6551281E-02
     +,   5.7462133E-02,   5.8468178E-02,   5.9569120E-02
     +,   6.0766358E-02,   6.2064268E-02,   6.3471273E-02
     +,   6.5000564E-02,   6.6670097E-02,   6.8502530E-02
     +,   7.0523605E-02,   7.2760776E-02,   7.5240180E-02
     +,   7.7983759E-02,   8.1005618E-02,   8.4307954E-02
     +,   8.7877616E-02,   9.1683447E-02,   9.5674098E-02
     +,   9.9777199E-02,   0.1039019    ,   0.1079417    
     +,   0.1117817    ,   0.1153064    ,   0.1184110    
     +,   0.1210121    ,   0.1230600    ,   0.1245475    
     +,   0.1255163    ,   0.1260588    ,   0.1263121    
     +,   0.1264485    ,   0.1266594    ,   0.1271368    
     +,   0.1280558    ,   0.1295605    ,   0.1317569    
     +,   0.1347136    ,   0.1384685    ,   0.1430414    
     +,   0.1484455    ,   0.1546947    ,   0.1618039    
     +,   0.1697828    ,   0.1786215    ,   0.1882739    
     +,   0.1986457    ,   0.2095907    ,   0.2209183    
     +,   0.2324145    ,   0.2438719    ,   0.2551180    
     +,   0.2660250    ,   0.2764894    ,   0.2863853    
     +,   0.2954988    ,   0.3034811    ,   0.3098575    
     +,   0.3141176    ,   0.3158761    ,   0.3150615    
     +,   0.3120604    ,   0.3077483    ,   0.3033831    
     +,   0.3003920    ,   0.3001267    ,   0.3036827    
     +,   0.3118307    ,   0.3250413    ,   0.3435224    
     +,   0.3671725    ,   0.3954093    ,   0.4269428    
     +,   0.4596376    ,   0.4906190    ,   0.5166892    
     +,   0.5349818    ,   0.5436264    ,   0.5421713    
     +,   0.5315983    ,   0.5139251    ,   0.4915522    
     +,   0.4666071    ,   0.4405108    ,   0.4138584    
     +,   0.3866045    ,   0.3584143    ,   0.3290167    
     +,   0.2984391    ,   0.2670746    ,   0.2356068    
     +,   0.2048495    ,   0.1755825    ,   0.1484400    
     +,   0.1238601    ,   0.1020837    ,   8.3183147E-02
     +,   6.7101516E-02,   5.3687476E-02,   4.2718612E-02
     +,   3.3925202E-02,   2.7010860E-02,   2.1671340E-02
     +,   1.7612452E-02,   1.4565284E-02,   1.2295967E-02
     +,   1.0609753E-02,   9.3507897E-03,   8.3987880E-03
     +,   7.6637771E-03,   7.0801917E-03,   6.6013648E-03
     +,   6.1948230E-03,   5.8384463E-03,   5.5173896E-03
     +,   5.2218805E-03,   4.9455846E-03,   4.6844184E-03
     +,   4.4357269E-03,   4.1977619E-03,   3.9693490E-03
     +,   3.7496595E-03,   3.5380723E-03,   3.3341250E-03
     +,   3.1374895E-03,   2.9479405E-03,   2.7653323E-03
     +,   2.5895985E-03,   2.4207532E-03,   2.2588423E-03
     +,   2.1039385E-03,   1.9561360E-03,   1.8155202E-03
     +,   1.6821437E-03,   1.5560255E-03,   1.4371491E-03
     +,   1.3254508E-03,   1.2208098E-03,   1.1230590E-03
     +,   1.0319947E-03,   9.4737473E-04,   8.6891965E-04
     +,   7.9632702E-04,   7.2928448E-04,   6.6746224E-04
     +,   6.1052735E-04,   5.5815256E-04,   5.1001651E-04
     +,   4.6580491E-04,   4.2521724E-04,   3.8797132E-04
     +,   3.5380162E-04,   3.2245787E-04,   2.9370841E-04
     +,   2.6734133E-04,   2.4316176E-04,   2.2098968E-04
     +,   2.0066086E-04,   1.8202748E-04,   1.6495287E-04
     +,   1.4931263E-04,   1.3499433E-04,   1.2189511E-04
     +,   1.0992001E-04,   9.8981953E-05,   8.9001660E-05
     +,   7.9905854E-05,   7.1626215E-05,   6.4099462E-05
     +,   5.7267545E-05,   5.1075494E-05,   4.5472931E-05
     +,   4.0412036E-05,   3.5848901E-05,   3.1741856E-05
     +,   2.8052569E-05,   2.4744766E-05,   2.1785108E-05
     +,   1.9142117E-05,   1.6786928E-05,   1.4692509E-05
     +,   1.2833843E-05,   1.1188020E-05,   9.7336888E-06
     +,   8.4514249E-06,   7.3232459E-06,   6.3328721E-06
     +,   5.4652992E-06,   4.7070207E-06,   4.0456821E-06
     +,   3.4701909E-06,   2.9704718E-06,   2.5375339E-06
     +,   2.1632488E-06,   1.8404073E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_asha_hatt120_mass = Yx/5.5736737368421
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_asha_hatt60_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.1139961E-02,   1.2565983E-02
     +,   1.4162473E-02,   1.5935561E-02,   1.7887963E-02
     +,   2.0018637E-02,   2.2322832E-02,   2.4792880E-02
     +,   2.7420077E-02,   3.0198360E-02,   3.3129800E-02
     +,   3.6233202E-02,   3.9555460E-02,   4.3185700E-02
     +,   4.7271606E-02,   5.2036688E-02,   5.7798754E-02
     +,   6.4991720E-02,   7.4198171E-02,   8.6204052E-02
     +,   0.1020856    ,   0.1233229    ,   0.1518958    
     +,   0.1902734    ,   0.2411854    ,   0.3071868    
     +,   0.3901564    ,   0.4910095    ,   0.6096442    
     +,   0.7447923    ,   0.8936487    ,    1.052293    
     +,    1.218514    ,    1.396422    ,    1.598380    
     +,    1.839737    ,    2.128540    ,    2.458462    
     +,    2.809725    ,    3.152097    ,    3.442863    
     +,    3.628191    ,    3.664627    ,    3.550911    
     +,    3.334517    ,    3.080388    ,    2.833403    
     +,    2.608656    ,    2.405020    ,    2.216478    
     +,    2.033533    ,    1.845494    ,    1.648543    
     +,    1.450456    ,    1.265658    ,    1.105833    
     +,   0.9746396    ,   0.8687285    ,   0.7819325    
     +,   0.7087443    ,   0.6454809    ,   0.5898150    
     +,   0.5400514    ,   0.4948609    ,   0.4533778    
     +,   0.4152735    ,   0.3806275    ,   0.3496812    
     +,   0.3225929    ,   0.2993118    ,   0.2795527    
     +,   0.2628631    ,   0.2487020    ,   0.2365182    
     +,   0.2257972    ,   0.2160888    ,   0.2070242    
     +,   0.1983215    ,   0.1897870    ,   0.1813129    
     +,   0.1728663    ,   0.1644722    ,   0.1561960    
     +,   0.1481231    ,   0.1403452    ,   0.1329469    
     +,   0.1260000    ,   0.1195591    ,   0.1136620    
     +,   0.1083295    ,   0.1035671    ,   9.9367455E-02
     +,   9.5711038E-02,   9.2568025E-02,   8.9900054E-02
     +,   8.7662227E-02,   8.5804366E-02,   8.4273785E-02
     +,   8.3016634E-02,   8.1980295E-02,   8.1114665E-02
     +,   8.0373697E-02,   7.9716414E-02,   7.9107873E-02
     +,   7.8519337E-02,   7.7928580E-02,   7.7319868E-02
     +,   7.6683283E-02,   7.6014839E-02,   7.5315356E-02
     +,   7.4590035E-02,   7.3847465E-02,   7.3098898E-02
     +,   7.2357208E-02,   7.1636155E-02,   7.0949368E-02
     +,   7.0309751E-02,   6.9728509E-02,   6.9214925E-02
     +,   6.8775535E-02,   6.8414070E-02,   6.8131231E-02
     +,   6.7924529E-02,   6.7788586E-02,   6.7715287E-02
     +,   6.7694008E-02,   6.7712188E-02,   6.7755811E-02
     +,   6.7809805E-02,   6.7858540E-02,   6.7886576E-02
     +,   6.7878872E-02,   6.7821376E-02,   6.7701414E-02
     +,   6.7507811E-02,   6.7231394E-02,   6.6864878E-02
     +,   6.6403240E-02,   6.5843418E-02,   6.5184355E-02
     +,   6.4427108E-02,   6.3574396E-02,   6.2630549E-02
     +,   6.1601236E-02,   6.0493380E-02,   5.9314758E-02
     +,   5.8073808E-02,   5.6779545E-02,   5.5441339E-02
     +,   5.4068543E-02,   5.2670445E-02,   5.1256329E-02
     +,   4.9835112E-02,   4.8415262E-02,   4.7004797E-02
     +,   4.5611270E-02,   4.4241603E-02,   4.2902030E-02
     +,   4.1598074E-02,   4.0334690E-02,   3.9115895E-02
     +,   3.7945036E-02,   3.6824677E-02,   3.5756633E-02
     +,   3.4741815E-02,   3.3780426E-02,   3.2871947E-02
     +,   3.2015130E-02,   3.1208035E-02,   3.0448090E-02
     +,   2.9732259E-02,   2.9057011E-02,   2.8418398E-02
     +,   2.7812211E-02,   2.7234087E-02,   2.6679497E-02
     +,   2.6143944E-02,   2.5623020E-02,   2.5112504E-02
     +,   2.4608379E-02,   2.4106950E-02,   2.3604905E-02
     +,   2.3099363E-02,   2.2587847E-02,   2.2068338E-02
     +,   2.1539344E-02,   2.0999828E-02,   2.0449173E-02
     +,   1.9887231E-02,   1.9314265E-02,   1.8730905E-02
     +,   1.8138088E-02,   1.7537095E-02,   1.6929427E-02
     +,   1.6316772E-02,   1.5700936E-02,   1.5083887E-02
     +,   1.4467646E-02,   1.3854206E-02,   1.3245546E-02
     +,   1.2643631E-02,   1.2050333E-02,   1.1467388E-02
     +,   1.0896385E-02,   1.0338845E-02,   9.7960541E-03
     +,   9.2691425E-03,   8.7591056E-03,   8.2667591E-03
     +,   7.7927224E-03,   7.3374468E-03,   6.9012619E-03
     +,   6.4843441E-03,   6.0867048E-03,   5.7082311E-03
     +,   5.3487229E-03,   5.0078761E-03,   4.6852753E-03
     +,   4.3804375E-03,   4.0928419E-03,   3.8218873E-03
     +,   3.5669389E-03,   3.3273462E-03,   3.1024390E-03
     +,   2.8915224E-03,   2.6938959E-03,   2.5088810E-03
     +,   2.3358034E-03,   2.1739900E-03,   2.0227907E-03
     +,   1.8815830E-03,   1.7497683E-03,   1.6267628E-03
     +,   1.5120129E-03,   1.4050006E-03,   1.3052246E-03
     +,   1.2122126E-03,   1.1255250E-03,   1.0447475E-03
     +,   9.6948649E-04,   8.9937239E-04,   8.3406462E-04
     +,   7.7324413E-04,   7.1660895E-04,   6.6387741E-04
     +,   6.1479019E-04,   5.6910474E-04,   5.2659231E-04
     +,   4.8703962E-04,   4.5025165E-04,   4.1604278E-04
     +,   3.8424003E-04,   3.5468399E-04,   3.2722592E-04
     +,   3.0172503E-04,   2.7804988E-04,   2.5607939E-04
     +,   2.3570024E-04,   2.1680517E-04,   1.9929382E-04
     +,   1.8307383E-04,   1.6805838E-04,   1.5416533E-04
     +,   1.4131780E-04,   1.2944515E-04,   1.1848003E-04
     +,   1.0835932E-04,   9.9024735E-05,   9.0421541E-05
     +,   8.2497929E-05,   7.5205455E-05,   6.8499248E-05
     +,   6.2337313E-05,   5.6679844E-05,   5.1489747E-05
     +,   4.6732766E-05,   4.2376309E-05,   3.8390441E-05
     +,   3.4746758E-05,   3.1419142E-05,   2.8382861E-05
     +,   2.5615247E-05,   2.3094814E-05,   2.0801908E-05
     +,   1.8717932E-05,   1.6825899E-05,   1.5109824E-05
     +,   1.3554923E-05,   1.2147614E-05,   1.0875160E-05
     +,   9.7259363E-06,   8.6890559E-06,   7.7546238E-06
     +,   6.9133671E-06,   6.1568885E-06,   5.4773482E-06
     +,   4.8676402E-06,   4.3211612E-06,   3.8319399E-06
     +,   3.3944384E-06,   3.0036588E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_asha_hatt60_mass = Yx/18.7453703043478
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_asha_hatt65_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.9698416E-03,   4.0681660E-03
     +,   4.1716625E-03,   4.2810906E-03,   4.3973238E-03
     +,   4.5213620E-03,   4.6543446E-03,   4.7975713E-03
     +,   4.9525094E-03,   5.1208371E-03,   5.3044450E-03
     +,   5.5054892E-03,   5.7264273E-03,   5.9700785E-03
     +,   6.2397006E-03,   6.5390854E-03,   6.8726894E-03
     +,   7.2457851E-03,   7.6646646E-03,   8.1368629E-03
     +,   8.6714514E-03,   9.2793778E-03,   9.9738836E-03
     +,   1.0771151E-02,   1.1690998E-02,   1.2758330E-02
     +,   1.4005017E-02,   1.5473071E-02,   1.7219344E-02
     +,   1.9322291E-02,   2.1890910E-02,   2.5075544E-02
     +,   2.9079169E-02,   3.4166586E-02,   4.0667642E-02
     +,   4.8970249E-02,   5.9499636E-02,   7.2684005E-02
     +,   8.8913694E-02,   0.1085028    ,   0.1316844    
     +,   0.1586508    ,   0.1896731    ,   0.2252943    
     +,   0.2665664    ,   0.3152390    ,   0.3737593    
     +,   0.4449798    ,   0.5316492    ,   0.6360145    
     +,   0.7598721    ,   0.9050676    ,    1.074066    
     +,    1.270305    ,    1.499855    ,    1.779542    
     +,    2.149866    ,    2.663676    ,    3.318299    
     +,    3.994681    ,    4.536592    ,    4.902438    
     +,    5.132248    ,    5.197209    ,    5.065851    
     +,    4.822625    ,    4.531364    ,    4.153665    
     +,    3.690265    ,    3.234185    ,    2.863289    
     +,    2.566035    ,    2.287546    ,    2.006462    
     +,    1.739310    ,    1.503372    ,    1.304670    
     +,    1.144664    ,    1.020641    ,   0.9239137    
     +,   0.8434170    ,   0.7706427    ,   0.7014476    
     +,   0.6352336    ,   0.5732896    ,   0.5171630    
     +,   0.4676434    ,   0.4245411    ,   0.3870884    
     +,   0.3544296    ,   0.3259252    ,   0.3011836    
     +,   0.2799388    ,   0.2619076    ,   0.2467083    
     +,   0.2338579    ,   0.2228185    ,   0.2130744    
     +,   0.2041944    ,   0.1958734    ,   0.1879376    
     +,   0.1803293    ,   0.1730697    ,   0.1662223    
     +,   0.1598546    ,   0.1540149    ,   0.1487171    
     +,   0.1439375    ,   0.1396184    ,   0.1356783    
     +,   0.1320236    ,   0.1285585    ,   0.1251954    
     +,   0.1218605    ,   0.1184983    ,   0.1150726    
     +,   0.1115662    ,   0.1079780    ,   0.1043209    
     +,   0.1006178    ,   9.6897855E-02,   9.3194172E-02
     +,   8.9540586E-02,   8.5969396E-02,   8.2509719E-02
     +,   7.9186998E-02,   7.6021515E-02,   7.3028959E-02
     +,   7.0219733E-02,   6.7599960E-02,   6.5171093E-02
     +,   6.2931240E-02,   6.0874902E-02,   5.8994208E-02
     +,   5.7278927E-02,   5.5717342E-02,   5.4296590E-02
     +,   5.3003218E-02,   5.1823497E-02,   5.0743893E-02
     +,   4.9751483E-02,   4.8834190E-02,   4.7981147E-02
     +,   4.7182698E-02,   4.6430871E-02,   4.5719173E-02
     +,   4.5042701E-02,   4.4398140E-02,   4.3783586E-02
     +,   4.3198396E-02,   4.2642947E-02,   4.2118486E-02
     +,   4.1626804E-02,   4.1169934E-02,   4.0749922E-02
     +,   4.0368635E-02,   4.0027495E-02,   3.9727211E-02
     +,   3.9467763E-02,   3.9248217E-02,   3.9066672E-02
     +,   3.8920235E-02,   3.8805075E-02,   3.8716473E-02
     +,   3.8648859E-02,   3.8596045E-02,   3.8551290E-02
     +,   3.8507480E-02,   3.8457315E-02,   3.8393486E-02
     +,   3.8308833E-02,   3.8196530E-02,   3.8050208E-02
     +,   3.7864137E-02,   3.7633270E-02,   3.7353408E-02
     +,   3.7021182E-02,   3.6634222E-02,   3.6191024E-02
     +,   3.5691034E-02,   3.5134573E-02,   3.4522820E-02
     +,   3.3857767E-02,   3.3142053E-02,   3.2378905E-02
     +,   3.1572130E-02,   3.0725911E-02,   2.9844724E-02
     +,   2.8933235E-02,   2.7996305E-02,   2.7038751E-02
     +,   2.6065312E-02,   2.5080713E-02,   2.4089491E-02
     +,   2.3095896E-02,   2.2103945E-02,   2.1117425E-02
     +,   2.0139840E-02,   1.9174330E-02,   1.8223744E-02
     +,   1.7290672E-02,   1.6377440E-02,   1.5486027E-02
     +,   1.4618162E-02,   1.3775394E-02,   1.2958986E-02
     +,   1.2169964E-02,   1.1409222E-02,   1.0677458E-02
     +,   9.9751530E-03,   9.3026236E-03,   8.6600883E-03
     +,   8.0476142E-03,   7.4650962E-03,   6.9123064E-03
     +,   6.3889464E-03,   5.8945976E-03,   5.4287054E-03
     +,   4.9906322E-03,   4.5796954E-03,   4.1950922E-03
     +,   3.8359559E-03,   3.5013868E-03,   3.1904331E-03
     +,   2.9020775E-03,   2.6352797E-03,   2.3889926E-03
     +,   2.1621541E-03,   1.9536822E-03,   1.7624997E-03
     +,   1.5875536E-03,   1.4278057E-03,   1.2822308E-03
     +,   1.1498338E-03,   1.0296659E-03,   9.2080177E-04
     +,   8.2235865E-04,   7.3350169E-04,   6.5343978E-04
     +,   5.8142160E-04,   5.1674165E-04,   4.5874491E-04
     +,   4.0682044E-04,   3.6039753E-04,   3.1894917E-04
     +,   2.8199216E-04,   2.4908208E-04,   2.1980994E-04
     +,   1.9380249E-04,   1.7072241E-04,   1.5026066E-04
     +,   1.3213778E-04,   1.1610219E-04,   1.0192697E-04
     +,   8.9406865E-05,   7.8357836E-05,   6.8615445E-05
     +,   6.0032464E-05,   5.2476746E-05,   4.5830471E-05
     +,   3.9989071E-05,   3.4859335E-05,   3.0358091E-05
     +,   2.6411515E-05,   2.2954409E-05,   1.9928619E-05
     +,   1.7282642E-05,   1.4971050E-05,   1.2953603E-05
     +,   1.1194570E-05,   9.6624153E-06,   8.3293662E-06
     +,   7.1708901E-06,   6.1652709E-06,   5.2933674E-06
     +,   4.5383986E-06,   3.8854887E-06,   3.3216322E-06
     +,   2.8353259E-06,   2.4165265E-06,   2.0563650E-06
     +,   1.7471189E-06,   1.4819788E-06,   1.2550271E-06
     +,   1.0610618E-06,   8.9557125E-07,   7.5460463E-07
     +,   6.3472902E-07,   5.3297060E-07,   4.4673621E-07
     +,   3.7379246E-07,   3.1219741E-07,   2.6028306E-07
     +,   2.1660566E-07,   1.7992863E-07,   1.4918558E-07
     +,   1.2346683E-07,   1.0199072E-07,   8.4092790E-08
     +,   6.9204759E-08,   5.6845103E-08
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_asha_hatt65_mass = Yx/23.5544271914894
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_asha_hatt70_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.9639991E-03,   2.0365533E-03
     +,   2.1128990E-03,   2.1932358E-03,   2.2777619E-03
     +,   2.3666718E-03,   2.4601531E-03,   2.5583876E-03
     +,   2.6615418E-03,   2.7697764E-03,   2.8832308E-03
     +,   3.0020301E-03,   3.1262778E-03,   3.2560579E-03
     +,   3.3914312E-03,   3.5324369E-03,   3.6790923E-03
     +,   3.8313984E-03,   3.9893403E-03,   4.1528982E-03
     +,   4.3220548E-03,   4.4968142E-03,   4.6772137E-03
     +,   4.8633674E-03,   5.0554606E-03,   5.2538328E-03
     +,   5.4589906E-03,   5.6716688E-03,   5.8928942E-03
     +,   6.1240424E-03,   6.3669081E-03,   6.6237673E-03
     +,   6.8974406E-03,   7.1913418E-03,   7.5095156E-03
     +,   7.8566605E-03,   8.2381172E-03,   8.6598592E-03
     +,   9.1284988E-03,   9.6512102E-03,   1.0235871E-02
     +,   1.0891136E-02,   1.1626770E-02,   1.2454186E-02
     +,   1.3387295E-02,   1.4443721E-02,   1.5646407E-02
     +,   1.7025672E-02,   1.8621568E-02,   2.0486657E-02
     +,   2.2689110E-02,   2.5316384E-02,   2.8479764E-02
     +,   3.2320794E-02,   3.7019014E-02,   4.2803779E-02
     +,   4.9966440E-02,   5.8872528E-02,   6.9966845E-02
     +,   8.3762303E-02,   0.1008048    ,   0.1216196    
     +,   0.1466699    ,   0.1764117    ,   0.2115211    
     +,   0.2533211    ,   0.3042748    ,   0.3681902    
     +,   0.4498233    ,   0.5536666    ,   0.6821461    
     +,   0.8341369    ,    1.007215    ,    1.208024    
     +,    1.466021    ,    1.826668    ,    2.309196    
     +,    2.870599    ,    3.425198    ,    3.903334    
     +,    4.339674    ,    4.889455    ,    5.592791    
     +,    6.247357    ,    6.697735    ,    6.819819    
     +,    6.489201    ,    5.886176    ,    5.300066    
     +,    4.817369    ,    4.379929    ,    3.905613    
     +,    3.375666    ,    2.863983    ,    2.443233    
     +,    2.131286    ,    1.903782    ,    1.725129    
     +,    1.574351    ,    1.443244    ,    1.321783    
     +,    1.197672    ,    1.066068    ,   0.9326101    
     +,   0.8074601    ,   0.6987854    ,   0.6101419    
     +,   0.5409128    ,   0.4879964    ,   0.4475912    
     +,   0.4164216    ,   0.3921610    ,   0.3732918    
     +,   0.3587289    ,   0.3475268    ,   0.3387464    
     +,   0.3314629    ,   0.3248409    ,   0.3182122    
     +,   0.3111250    ,   0.3033427    ,   0.2948062    
     +,   0.2855715    ,   0.2757444    ,   0.2654374    
     +,   0.2547439    ,   0.2437320    ,   0.2324557    
     +,   0.2209651    ,   0.2093209    ,   0.1975981    
     +,   0.1858917    ,   0.1743119    ,   0.1629814    
     +,   0.1520265    ,   0.1415714    ,   0.1317312    
     +,   0.1226044    ,   0.1142672    ,   0.1067703    
     +,   0.1001373    ,   9.4364963E-02,   8.9425109E-02
     +,   8.5269324E-02,   8.1834152E-02,   7.9045847E-02
     +,   7.6825947E-02,   7.5095758E-02,   7.3779486E-02
     +,   7.2806604E-02,   7.2113268E-02,   7.1642525E-02
     +,   7.1344167E-02,   7.1173742E-02,   7.1091861E-02
     +,   7.1063019E-02,   7.1055025E-02,   7.1038254E-02
     +,   7.0985481E-02,   7.0871703E-02,   7.0674509E-02
     +,   7.0374176E-02,   6.9954216E-02,   6.9401741E-02
     +,   6.8707474E-02,   6.7866229E-02,   6.6876680E-02
     +,   6.5741338E-02,   6.4465955E-02,   6.3059174E-02
     +,   6.1532076E-02,   5.9897389E-02,   5.8168709E-02
     +,   5.6360133E-02,   5.4485705E-02,   5.2558765E-02
     +,   5.0591733E-02,   4.8595984E-02,   4.6581708E-02
     +,   4.4557720E-02,   4.2531691E-02,   4.0510420E-02
     +,   3.8499959E-02,   3.6505535E-02,   3.4532048E-02
     +,   3.2584280E-02,   3.0666923E-02,   2.8784579E-02
     +,   2.6941927E-02,   2.5143905E-02,   2.3395335E-02
     +,   2.1701034E-02,   2.0065790E-02,   1.8494207E-02
     +,   1.6990414E-02,   1.5558089E-02,   1.4200431E-02
     +,   1.2919975E-02,   1.1718404E-02,   1.0596667E-02
     +,   9.5549561E-03,   8.5926671E-03,   7.7083567E-03
     +,   6.8999003E-03,   6.1645987E-03,   5.4991296E-03
     +,   4.8997360E-03,   4.3623536E-03,   3.8826668E-03
     +,   3.4561895E-03,   3.0783950E-03,   2.7448242E-03
     +,   2.4511227E-03,   2.1930931E-03,   1.9667682E-03
     +,   1.7684533E-03,   1.5947389E-03,   1.4425016E-03
     +,   1.3089236E-03,   1.1914974E-03,   1.0879929E-03
     +,   9.9645357E-04,   9.1518188E-04,   8.4271171E-04
     +,   7.7778212E-04,   7.1931962E-04,   6.6641840E-04
     +,   6.1831577E-04,   5.7436927E-04,   5.3404138E-04
     +,   4.9688725E-04,   4.6253609E-04,   4.3067656E-04
     +,   4.0104930E-04,   3.7343978E-04,   3.4766475E-04
     +,   3.2356946E-04,   3.0102284E-04,   2.7991200E-04
     +,   2.6013714E-04,   2.4161037E-04,   2.2425436E-04
     +,   2.0799910E-04,   1.9277984E-04,   1.7853698E-04
     +,   1.6521591E-04,   1.5276547E-04,   1.4113678E-04
     +,   1.3028347E-04,   1.2016263E-04,   1.1073246E-04
     +,   1.0195306E-04,   9.3786970E-05,   8.6198386E-05
     +,   7.9152596E-05,   7.2616596E-05,   6.6559289E-05
     +,   6.0951017E-05,   5.5763201E-05,   5.0968720E-05
     +,   4.6542071E-05,   4.2459142E-05,   3.8696744E-05
     +,   3.5232995E-05,   3.2047541E-05,   2.9120833E-05
     +,   2.6434478E-05,   2.3971324E-05,   2.1715232E-05
     +,   1.9650866E-05,   1.7763865E-05,   1.6040889E-05
     +,   1.4469433E-05,   1.3037682E-05,   1.1734618E-05
     +,   1.0550083E-05,   9.4744428E-06,   8.4988706E-06
     +,   7.6150213E-06,   6.8152644E-06,   6.0924049E-06
     +,   5.4398733E-06,   4.8515008E-06,   4.3216619E-06
     +,   3.8450844E-06,   3.4169750E-06,   3.0328697E-06
     +,   2.6886696E-06,   2.3806404E-06,   2.1053118E-06
     +,   1.8595465E-06,   1.6404366E-06,   1.4453577E-06
     +,   1.2718888E-06,   1.1178478E-06,   9.8122905E-07
     +,   8.6023044E-07,   7.5319969E-07,   6.5865743E-07
     +,   5.7525119E-07,   5.0177192E-07
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_asha_hatt70_mass = Yx/29.1508148571429
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_asha_hatt75_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.7139402E-03,   1.7688676E-03
     +,   1.8256682E-03,   1.8844310E-03,   1.9452475E-03
     +,   2.0082120E-03,   2.0734211E-03,   2.1409765E-03
     +,   2.2109807E-03,   2.2835454E-03,   2.3587840E-03
     +,   2.4368172E-03,   2.5177733E-03,   2.6017916E-03
     +,   2.6890205E-03,   2.7796228E-03,   2.8737755E-03
     +,   2.9716734E-03,   3.0735331E-03,   3.1795902E-03
     +,   3.2901089E-03,   3.4053791E-03,   3.5257183E-03
     +,   3.6514844E-03,   3.7830530E-03,   3.9208485E-03
     +,   4.0653204E-03,   4.2169536E-03,   4.3762620E-03
     +,   4.5437883E-03,   4.7200997E-03,   4.9057784E-03
     +,   5.1014158E-03,   5.3076064E-03,   5.5249352E-03
     +,   5.7539656E-03,   5.9952252E-03,   6.2491968E-03
     +,   6.5163164E-03,   6.7969193E-03,   7.0912866E-03
     +,   7.3995865E-03,   7.7218874E-03,   8.0581531E-03
     +,   8.4082419E-03,   8.7719103E-03,   9.1488278E-03
     +,   9.5386030E-03,   9.9408077E-03,   1.0355023E-02
     +,   1.0780894E-02,   1.1218204E-02,   1.1666943E-02
     +,   1.2127455E-02,   1.2600484E-02,   1.3087433E-02
     +,   1.3590461E-02,   1.4112755E-02,   1.4658782E-02
     +,   1.5234627E-02,   1.5848337E-02,   1.6510390E-02
     +,   1.7234083E-02,   1.8036144E-02,   1.8937113E-02
     +,   1.9961648E-02,   2.1138951E-02,   2.2502465E-02
     +,   2.4089800E-02,   2.5941750E-02,   2.8101793E-02
     +,   3.0615095E-02,   3.3529628E-02,   3.6898825E-02
     +,   4.0790640E-02,   4.5303285E-02,   5.0591551E-02
     +,   5.6904670E-02,   6.4633608E-02,   7.4358314E-02
     +,   8.6879574E-02,   0.1032222    ,   0.1245806    
     +,   0.1522149    ,   0.1872848    ,   0.2306735    
     +,   0.2828258    ,   0.3437520    ,   0.4134096    
     +,   0.4929254    ,   0.5868844    ,   0.7059982    
     +,   0.8675043    ,    1.090061    ,    1.385778    
     +,    1.757543    ,    2.191383    ,    2.635738    
     +,    3.051757    ,    3.526806    ,    4.172197    
     +,    4.955605    ,    5.850986    ,    6.844731    
     +,    7.785589    ,    8.373598    ,    8.522787    
     +,    8.389622    ,    7.936969    ,    7.121912    
     +,    6.178606    ,    5.276769    ,    4.436299    
     +,    3.754405    ,    3.279936    ,    2.910288    
     +,    2.542325    ,    2.180392    ,    1.882636    
     +,    1.670481    ,    1.516062    ,    1.383906    
     +,    1.257849    ,    1.137826    ,    1.027083    
     +,   0.9263579    ,   0.8354788    ,   0.7557803    
     +,   0.6895883    ,   0.6380192    ,   0.5996125    
     +,   0.5708179    ,   0.5474068    ,   0.5257047    
     +,   0.5031717    ,   0.4785073    ,   0.4515107    
     +,   0.4228021    ,   0.3934662    ,   0.3646960    
     +,   0.3375234    ,   0.3126843    ,   0.2906025    
     +,   0.2714463    ,   0.2551904    ,   0.2416544    
     +,   0.2305273    ,   0.2213876    ,   0.2137339    
     +,   0.2070319    ,   0.2007722    ,   0.1945225    
     +,   0.1879669    ,   0.1809237    ,   0.1733444    
     +,   0.1652950    ,   0.1569261    ,   0.1484374    
     +,   0.1400444    ,   0.1319501    ,   0.1243211    
     +,   0.1172756    ,   0.1108790    ,   0.1051456    
     +,   0.1000468    ,   9.5521793E-02,   9.1490567E-02
     +,   8.7864421E-02,   8.4555089E-02,   8.1482254E-02
     +,   7.8577466E-02,   7.5786240E-02,   7.3067799E-02
     +,   7.0394374E-02,   6.7749575E-02,   6.5125771E-02
     +,   6.2522233E-02,   5.9943285E-02,   5.7396475E-02
     +,   5.4890905E-02,   5.2436233E-02,   5.0041888E-02
     +,   4.7716182E-02,   4.5465685E-02,   4.3295130E-02
     +,   4.1207355E-02,   3.9203256E-02,   3.7281793E-02
     +,   3.5440382E-02,   3.3675443E-02,   3.1982288E-02
     +,   3.0355850E-02,   2.8790986E-02,   2.7282743E-02
     +,   2.5826506E-02,   2.4418300E-02,   2.3054965E-02
     +,   2.1734199E-02,   2.0454332E-02,   1.9214511E-02
     +,   1.8014580E-02,   1.6854933E-02,   1.5736274E-02
     +,   1.4659595E-02,   1.3626097E-02,   1.2636899E-02
     +,   1.1693008E-02,   1.0795316E-02,   9.9444455E-03
     +,   9.1406712E-03,   8.3839456E-03,   7.6739327E-03
     +,   7.0099696E-03,   6.3910414E-03,   5.8158617E-03
     +,   5.2829487E-03,   4.7906078E-03,   4.3369555E-03
     +,   3.9200000E-03,   3.5377080E-03,   3.1879672E-03
     +,   2.8686624E-03,   2.5777204E-03,   2.3131110E-03
     +,   2.0728491E-03,   1.8550341E-03,   1.6578707E-03
     +,   1.4796604E-03,   1.3187950E-03,   1.1737726E-03
     +,   1.0432070E-03,   9.2581118E-04,   8.2038861E-04
     +,   7.2583894E-04,   6.4115948E-04,   5.6542148E-04
     +,   4.9777562E-04,   4.3744908E-04,   3.8373511E-04
     +,   3.3598475E-04,   2.9360657E-04,   2.5606394E-04
     +,   2.2286749E-04,   1.9356943E-04,   1.6776270E-04
     +,   1.4507893E-04,   1.2518339E-04,   1.0777113E-04
     +,   9.2566195E-05,   7.9320438E-05,   6.7808403E-05
     +,   5.7827150E-05,   4.9194856E-05,   4.1748193E-05
     +,   3.5340519E-05,   2.9840987E-05,   2.5133455E-05
     +,   2.1114687E-05,   1.7692961E-05,   1.4787372E-05
     +,   1.2326877E-05,   1.0249063E-05,   8.4991825E-06
     +,   7.0295232E-06,   5.7987218E-06,   4.7707949E-06
     +,   3.9146785E-06,   3.2036810E-06,   2.6148787E-06
     +,   2.1286246E-06,   1.7281753E-06,   1.3993293E-06
     +,   1.1300521E-06,   9.1016545E-07,   7.3110954E-07
     +,   5.8572186E-07,   4.6799440E-07,   3.7293947E-07
     +,   2.9639955E-07,   2.3494506E-07,   1.8573699E-07
     +,   1.4644729E-07,   1.1516220E-07,   9.0321493E-08
     +,   7.0651147E-08,   5.5119138E-08,   4.2888232E-08
     +,   3.3283047E-08,   2.5761157E-08,   1.9886526E-08
     +,   1.5311299E-08,   1.1757549E-08,   9.0049648E-09
     +,   6.8786168E-09,   5.2405982E-09,   3.9821235E-09
     +,   3.0179421E-09,   2.2811872E-09,   1.7197815E-09
     +,   1.2931241E-09,   9.6977049E-10
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_asha_hatt75_mass = Yx/34.34618348
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_asha_hatt80_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.4089522E-03,   2.4463371E-03
     +,   2.4834673E-03,   2.5203675E-03,   2.5570639E-03
     +,   2.5935860E-03,   2.6299648E-03,   2.6662350E-03
     +,   2.7024332E-03,   2.7385980E-03,   2.7747718E-03
     +,   2.8109984E-03,   2.8473253E-03,   2.8838026E-03
     +,   2.9204842E-03,   2.9574279E-03,   2.9946947E-03
     +,   3.0323516E-03,   3.0704695E-03,   3.1091254E-03
     +,   3.1484030E-03,   3.1883926E-03,   3.2291913E-03
     +,   3.2709057E-03,   3.3136497E-03,   3.3575494E-03
     +,   3.4027381E-03,   3.4493620E-03,   3.4975787E-03
     +,   3.5475583E-03,   3.5994835E-03,   3.6535503E-03
     +,   3.7099710E-03,   3.7689703E-03,   3.8307908E-03
     +,   3.8956895E-03,   3.9639422E-03,   4.0358398E-03
     +,   4.1116970E-03,   4.1918405E-03,   4.2766263E-03
     +,   4.3664267E-03,   4.4616405E-03,   4.5626941E-03
     +,   4.6700407E-03,   4.7841687E-03,   4.9056034E-03
     +,   5.0349096E-03,   5.1727025E-03,   5.3196512E-03
     +,   5.4764845E-03,   5.6440048E-03,   5.8230883E-03
     +,   6.0147145E-03,   6.2199440E-03,   6.4399671E-03
     +,   6.6760867E-03,   6.9297357E-03,   7.2024935E-03
     +,   7.4960846E-03,   7.8123929E-03,   8.1534619E-03
     +,   8.5214777E-03,   8.9188078E-03,   9.3479920E-03
     +,   9.8116677E-03,   1.0312679E-02,   1.0853949E-02
     +,   1.1438584E-02,   1.2069749E-02,   1.2750789E-02
     +,   1.3485072E-02,   1.4276182E-02,   1.5127700E-02
     +,   1.6043430E-02,   1.7027389E-02,   1.8083759E-02
     +,   1.9217057E-02,   2.0432383E-02,   2.1735525E-02
     +,   2.3133125E-02,   2.4633322E-02,   2.6245961E-02
     +,   2.7983669E-02,   2.9862508E-02,   3.1903978E-02
     +,   3.4136746E-02,   3.6600303E-02,   3.9348591E-02
     +,   4.2455807E-02,   4.6021968E-02,   5.0177902E-02
     +,   5.5088129E-02,   6.0948879E-02,   6.7977011E-02
     +,   7.6387316E-02,   8.6360216E-02,   9.7995900E-02
     +,   0.1112717    ,   0.1260056    ,   0.1418581    
     +,   0.1583800    ,   0.1751406    ,   0.1919249    
     +,   0.2089906    ,   0.2273101    ,   0.2487134    
     +,   0.2758982    ,   0.3124067    ,   0.3628768    
     +,   0.4340009    ,   0.5362872    ,   0.6848262    
     +,   0.8946917    ,    1.168974    ,    1.492042    
     +,    1.851838    ,    2.285146    ,    2.864380    
     +,    3.598895    ,    4.490079    ,    5.684217    
     +,    7.189656    ,    8.502592    ,    9.081409    
     +,    9.623647    ,    10.16998    ,    10.59149    
     +,    10.43503    ,    9.552685    ,    8.203316    
     +,    6.742321    ,    5.697417    ,    4.932968    
     +,    4.333580    ,    3.874267    ,    3.411371    
     +,    2.863242    ,    2.375005    ,    2.040226    
     +,    1.792635    ,    1.564447    ,    1.355359    
     +,    1.186022    ,    1.060086    ,   0.9647752    
     +,   0.8840215    ,   0.8070084    ,   0.7300373    
     +,   0.6546750    ,   0.5848910    ,   0.5245424    
     +,   0.4757021    ,   0.4381117    ,   0.4097082    
     +,   0.3877170    ,   0.3696263    ,   0.3536359    
     +,   0.3386151    ,   0.3238461    ,   0.3088078    
     +,   0.2931051    ,   0.2764995    ,   0.2589615    
     +,   0.2406857    ,   0.2220576    ,   0.2035820    
     +,   0.1857914    ,   0.1691616    ,   0.1540515    
     +,   0.1406692    ,   0.1290661    ,   0.1191540    
     +,   0.1107392    ,   0.1035628    ,   9.7338639E-02
     +,   9.1788597E-02,   8.6668074E-02,   8.1782356E-02
     +,   7.6993614E-02,   7.2220862E-02,   6.7433894E-02
     +,   6.2642984E-02,   5.7886608E-02,   5.3219650E-02
     +,   4.8702881E-02,   4.4394068E-02,   4.0341441E-02
     +,   3.6580332E-02,   3.3132244E-02,   3.0004436E-02
     +,   2.7192077E-02,   2.4680855E-02,   2.2449430E-02
     +,   2.0471986E-02,   1.8720755E-02,   1.7167924E-02
     +,   1.5786925E-02,   1.4553222E-02,   1.3444957E-02
     +,   1.2443177E-02,   1.1531716E-02,   1.0696962E-02
     +,   9.9276714E-03,   9.2147309E-03,   8.5507268E-03
     +,   7.9297395E-03,   7.3471204E-03,   6.7992364E-03
     +,   6.2832297E-03,   5.7968968E-03,   5.3385627E-03
     +,   4.9069258E-03,   4.5009204E-03,   4.1196668E-03
     +,   3.7624151E-03,   3.4284678E-03,   3.1171129E-03
     +,   2.8276206E-03,   2.5592498E-03,   2.3111827E-03
     +,   2.0825539E-03,   1.8724654E-03,   1.6799775E-03
     +,   1.5041069E-03,   1.3438551E-03,   1.1982276E-03
     +,   1.0662330E-03,   9.4688754E-04,   8.3923276E-04
     +,   7.4235135E-04,   6.5536267E-04,   5.7742430E-04
     +,   5.0774106E-04,   4.4557324E-04,   3.9022343E-04
     +,   3.4104395E-04,   2.9743859E-04,   2.5885724E-04
     +,   2.2479150E-04,   1.9477608E-04,   1.6838778E-04
     +,   1.4524044E-04,   1.2498132E-04,   1.0729064E-04
     +,   9.1880000E-05,   7.8488636E-05,   6.6880450E-05
     +,   5.6843284E-05,   4.8187627E-05,   4.0742827E-05
     +,   3.4356566E-05,   2.8893546E-05,   2.4233446E-05
     +,   2.0269332E-05,   1.6906790E-05,   1.4062884E-05
     +,   1.1664694E-05,   9.6482572E-06,   7.9577749E-06
     +,   6.5448394E-06,   5.3674576E-06,   4.3892860E-06
     +,   3.5790549E-06,   2.9100099E-06,   2.3592108E-06
     +,   1.9071293E-06,   1.5372188E-06,   1.2354789E-06
     +,   9.9008946E-07,   7.9113221E-07,   6.3032087E-07
     +,   5.0074323E-07,   3.9664855E-07,   3.1327809E-07
     +,   2.4671451E-07,   1.9372820E-07,   1.5168106E-07
     +,   1.1841421E-07,   9.2175810E-08,   7.1542509E-08
     +,   5.5367202E-08,   4.2724377E-08,   3.2873150E-08
     +,   2.5219785E-08,   1.9292312E-08,   1.4715205E-08
     +,   1.1191389E-08,   8.4868264E-09,   6.4171544E-09
     +,   4.8381934E-09,   3.6371441E-09,   2.7263523E-09
     +,   2.0376956E-09,   1.5185926E-09,   1.1284430E-09
     +,   8.3610724E-10,   6.1770500E-10,   4.5503395E-10
     +,   3.3422756E-10,   2.4478516E-10
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_asha_hatt80_mass = Yx/39.436430627451
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_asha_hatt85_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.8742378E-03,   1.9257664E-03
     +,   1.9776863E-03,   2.0300087E-03,   2.0827458E-03
     +,   2.1359120E-03,   2.1895205E-03,   2.2435866E-03
     +,   2.2981241E-03,   2.3531492E-03,   2.4086724E-03
     +,   2.4647061E-03,   2.5212578E-03,   2.5783353E-03
     +,   2.6359416E-03,   2.6940780E-03,   2.7527427E-03
     +,   2.8119308E-03,   2.8716349E-03,   2.9318463E-03
     +,   2.9925539E-03,   3.0537455E-03,   3.1154086E-03
     +,   3.1775357E-03,   3.2401131E-03,   3.3031392E-03
     +,   3.3666117E-03,   3.4305365E-03,   3.4949249E-03
     +,   3.5597999E-03,   3.6251908E-03,   3.6911401E-03
     +,   3.7577020E-03,   3.8249427E-03,   3.8929402E-03
     +,   3.9617866E-03,   4.0315846E-03,   4.1024471E-03
     +,   4.1745026E-03,   4.2478759E-03,   4.3227091E-03
     +,   4.3991352E-03,   4.4772923E-03,   4.5573097E-03
     +,   4.6393066E-03,   4.7233873E-03,   4.8096371E-03
     +,   4.8981141E-03,   4.9888496E-03,   5.0818371E-03
     +,   5.1770350E-03,   5.2743577E-03,   5.3736754E-03
     +,   5.4748179E-03,   5.5775587E-03,   5.6816358E-03
     +,   5.7867430E-03,   5.8925361E-03,   5.9986403E-03
     +,   6.1046644E-03,   6.2102019E-03,   6.3148527E-03
     +,   6.4182291E-03,   6.5199868E-03,   6.6198381E-03
     +,   6.7175594E-03,   6.8130423E-03,   6.9062845E-03
     +,   6.9974479E-03,   7.0868498E-03,   7.1750181E-03
     +,   7.2626872E-03,   7.3508462E-03,   7.4407253E-03
     +,   7.5338469E-03,   7.6320204E-03,   7.7373390E-03
     +,   7.8521967E-03,   7.9792859E-03,   8.1215911E-03
     +,   8.2823504E-03,   8.4650759E-03,   8.6734751E-03
     +,   8.9114811E-03,   9.1831489E-03,   9.4926758E-03
     +,   9.8442771E-03,   1.0242202E-02,   1.0690575E-02
     +,   1.1193382E-02,   1.1754341E-02,   1.2376759E-02
     +,   1.3063394E-02,   1.3816366E-02,   1.4636963E-02
     +,   1.5525405E-02,   1.6480895E-02,   1.7501304E-02
     +,   1.8583415E-02,   1.9722799E-02,   2.0914344E-02
     +,   2.2152537E-02,   2.3432601E-02,   2.4751380E-02
     +,   2.6109306E-02,   2.7512547E-02,   2.8975537E-02
     +,   3.0524334E-02,   3.2200105E-02,   3.4062188E-02
     +,   3.6189992E-02,   3.8683489E-02,   4.1659296E-02
     +,   4.5243956E-02,   4.9561433E-02,   5.4719735E-02
     +,   6.0797080E-02,   6.7839146E-02,   7.5871624E-02
     +,   8.4944405E-02,   9.5207788E-02,   0.1070171    
     +,   0.1210399    ,   0.1383117    ,   0.1601638    
     +,   0.1879639    ,   0.2226894    ,   0.2644608    
     +,   0.3123516    ,   0.3647734    ,   0.4206071    
     +,   0.4807049    ,   0.5491489    ,   0.6341975    
     +,   0.7507439    ,   0.9266116    ,    1.209544    
     +,    1.655291    ,    2.287289    ,    3.111640    
     +,    4.132794    ,    5.256231    ,    6.479627    
     +,    8.050892    ,    9.678038    ,    10.84939    
     +,    11.80053    ,    12.08222    ,    12.61642    
     +,    11.96163    ,    10.35578    ,    8.848500    
     +,    7.493193    ,    6.246990    ,    5.144156    
     +,    4.247880    ,    3.518050    ,    2.832414    
     +,    2.256531    ,    1.859554    ,    1.600099    
     +,    1.415747    ,    1.263504    ,    1.115749    
     +,   0.9671105    ,   0.8317468    ,   0.7237643    
     +,   0.6442554    ,   0.5841062    ,   0.5325741    
     +,   0.4826736    ,   0.4321769    ,   0.3822457    
     +,   0.3354269    ,   0.2939757    ,   0.2589479    
     +,   0.2301242    ,   0.2064607    ,   0.1866745    
     +,   0.1696725    ,   0.1547290    ,   0.1414553    
     +,   0.1296717    ,   0.1192767    ,   0.1101594    
     +,   0.1021609    ,   9.5074363E-02,   8.8666648E-02
     +,   8.2708739E-02,   7.7004142E-02,   7.1406618E-02
     +,   6.5829434E-02,   6.0244452E-02,   5.4672502E-02
     +,   4.9169555E-02,   4.3811847E-02,   3.8681943E-02
     +,   3.3856642E-02,   2.9398244E-02,   2.5350176E-02
     +,   2.1735562E-02,   1.8557847E-02,   1.5803322E-02
     +,   1.3445222E-02,   1.1447951E-02,   9.7705638E-03
     +,   8.3704432E-03,   7.2060511E-03,   6.2386924E-03
     +,   5.4336651E-03,   4.7609233E-03,   4.1951952E-03
     +,   3.7156628E-03,   3.3055092E-03,   2.9513959E-03
     +,   2.6429028E-03,   2.3719457E-03,   2.1322684E-03
     +,   1.9190441E-03,   1.7285446E-03,   1.5578220E-03
     +,   1.4045206E-03,   1.2667223E-03,   1.1428198E-03
     +,   1.0314209E-03,   9.3130430E-04,   8.4138243E-04
     +,   7.6066755E-04,   6.8825029E-04,   6.2329613E-04
     +,   5.6504132E-04,   5.1278406E-04,   4.6587855E-04
     +,   4.2373725E-04,   3.8583193E-04,   3.5168248E-04
     +,   3.2086045E-04,   2.9298561E-04,   2.6772189E-04
     +,   2.4477192E-04,   2.2387548E-04,   2.0480699E-04
     +,   1.8737058E-04,   1.7139518E-04,   1.5673315E-04
     +,   1.4325761E-04,   1.3085868E-04,   1.1944026E-04
     +,   1.0891867E-04,   9.9221696E-05,   9.0284615E-05
     +,   8.2050043E-05,   7.4467112E-05,   6.7489775E-05
     +,   6.1075625E-05,   5.5185712E-05,   4.9784332E-05
     +,   4.4838205E-05,   4.0315754E-05,   3.6187321E-05
     +,   3.2425185E-05,   2.9003091E-05,   2.5895926E-05
     +,   2.3079956E-05,   2.0532989E-05,   1.8233752E-05
     +,   1.6162219E-05,   1.4299629E-05,   1.2628351E-05
     +,   1.1131718E-05,   9.7941765E-06,   8.6012906E-06
     +,   7.5396347E-06,   6.5966715E-06,   5.7608254E-06
     +,   5.0214917E-06,   4.3688256E-06,   3.7938821E-06
     +,   3.2884109E-06,   2.8449529E-06,   2.4566680E-06
     +,   2.1174073E-06,   1.8215638E-06,   1.5641225E-06
     +,   1.3405363E-06,   1.1467606E-06,   9.7915358E-07
     +,   8.3446980E-07,   7.0983327E-07,   6.0267553E-07
     +,   5.1073670E-07,   4.3200794E-07,   3.6473091E-07
     +,   3.0735097E-07,   2.5851338E-07,   2.1702655E-07
     +,   1.8185634E-07,   1.5209872E-07,   1.2697227E-07
     +,   1.0579691E-07,   8.7988106E-08
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_asha_hatt85_mass = Yx/40.9704957254902
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_asha_hatt90_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  8.9786867E-05,   8.5867730E-05
     +,   8.3032028E-05,   8.1336701E-05,   8.0849466E-05
     +,   8.1649872E-05,   8.3830302E-05,   8.7496788E-05
     +,   9.2769638E-05,   9.9784411E-05,   1.0869156E-04
     +,   1.1965684E-04,   1.3286079E-04,   1.4849816E-04
     +,   1.6677660E-04,   1.8791514E-04,   2.1214192E-04
     +,   2.3969181E-04,   2.7080276E-04,   3.0571246E-04
     +,   3.4465350E-04,   3.8784911E-04,   4.3550626E-04
     +,   4.8781469E-04,   5.4493116E-04,   6.0698541E-04
     +,   6.7406404E-04,   7.4620853E-04,   8.2340848E-04
     +,   9.0559572E-04,   9.9263946E-04,   1.0843419E-03
     +,   1.1804352E-03,   1.2805791E-03,   1.3843607E-03
     +,   1.4912948E-03,   1.6008270E-03,   1.7123354E-03
     +,   1.8251461E-03,   1.9385217E-03,   2.0516943E-03
     +,   2.1638593E-03,   2.2741954E-03,   2.3818761E-03
     +,   2.4860885E-03,   2.5860455E-03,   2.6810037E-03
     +,   2.7702805E-03,   2.8532688E-03,   2.9294572E-03
     +,   2.9984380E-03,   3.0599292E-03,   3.1137809E-03
     +,   3.1599889E-03,   3.1987005E-03,   3.2302248E-03
     +,   3.2550332E-03,   3.2737635E-03,   3.2872176E-03
     +,   3.2963573E-03,   3.3023031E-03,   3.3063213E-03
     +,   3.3098171E-03,   3.3143256E-03,   3.3214923E-03
     +,   3.3330643E-03,   3.3508723E-03,   3.3768117E-03
     +,   3.4128274E-03,   3.4608911E-03,   3.5229847E-03
     +,   3.6010696E-03,   3.6970791E-03,   3.8128674E-03
     +,   3.9502112E-03,   4.1107661E-03,   4.2960299E-03
     +,   4.5073074E-03,   4.7457018E-03,   5.0120591E-03
     +,   5.3069075E-03,   5.6304829E-03,   5.9826169E-03
     +,   6.3627926E-03,   6.7700250E-03,   7.2029410E-03
     +,   7.6596728E-03,   8.1379702E-03,   8.6351074E-03
     +,   9.1480184E-03,   9.6733188E-03,   1.0207337E-02
     +,   1.0746251E-02,   1.1286249E-02,   1.1823636E-02
     +,   1.2354942E-02,   1.2877257E-02,   1.3388281E-02
     +,   1.3886731E-02,   1.4372429E-02,   1.4846723E-02
     +,   1.5312641E-02,   1.5775280E-02,   1.6241938E-02
     +,   1.6722444E-02,   1.7229259E-02,   1.7777480E-02
     +,   1.8384770E-02,   1.9071115E-02,   1.9858295E-02
     +,   2.0768985E-02,   2.1825947E-02,   2.3050435E-02
     +,   2.4460899E-02,   2.6070902E-02,   2.7887715E-02
     +,   2.9910097E-02,   3.2127254E-02,   3.4517303E-02
     +,   3.7047219E-02,   3.9673071E-02,   4.2341042E-02
     +,   4.4990037E-02,   4.7555085E-02,   4.9971834E-02
     +,   5.2181501E-02,   5.4137941E-02,   5.5814061E-02
     +,   5.7209969E-02,   5.8360379E-02,   5.9342280E-02
     +,   6.0280636E-02,   6.1351515E-02,   6.2779717E-02
     +,   6.4829864E-02,   6.7788430E-02,   7.1937159E-02
     +,   7.7520259E-02,   8.4712230E-02,   9.3593955E-02
     +,   0.1041483    ,   0.1162855    ,   0.1299007    
     +,   0.1449493    ,   0.1615173    ,   0.1798591    
     +,   0.2003790    ,   0.2235862    ,   0.2500888    
     +,   0.2806641    ,   0.3163078    ,   0.3581005    
     +,   0.4070759    ,   0.4651106    ,   0.5381513    
     +,   0.6406244    ,   0.7952573    ,    1.025159    
     +,    1.342605    ,    1.731607    ,    2.183297    
     +,    2.904875    ,    4.323270    ,    6.382923    
     +,    8.543290    ,    10.70539    ,    12.56042    
     +,    13.95141    ,    14.83426    ,    15.34453    
     +,    13.08885    ,    11.21656    ,    8.848379    
     +,    6.925117    ,    5.530978    ,    4.343683    
     +,    3.413689    ,    2.687753    ,    2.117079    
     +,    1.637860    ,    1.235692    ,   0.9257036    
     +,   0.7194726    ,   0.6024894    ,   0.5412548    
     +,   0.5049151    ,   0.4745130    ,   0.4407716    
     +,   0.4003446    ,   0.3536924    ,   0.3035689    
     +,   0.2535392    ,   0.2067889    ,   0.1654761    
     +,   0.1306073    ,   0.1022403    ,   7.9809435E-02
     +,   6.2435798E-02,   4.9162626E-02,   3.9099503E-02
     +,   3.1487726E-02,   2.5714070E-02,   2.1299539E-02
     +,   1.7879639E-02,   1.5183026E-02,   1.3011527E-02
     +,   1.1223758E-02,   9.7210770E-03,   8.4357839E-03
     +,   7.3218769E-03,   6.3480996E-03,   5.4928949E-03
     +,   4.7407611E-03,   4.0798709E-03,   3.5006441E-03
     +,   2.9948759E-03,   2.5551827E-03,   2.1747022E-03
     +,   1.8470121E-03,   1.5661079E-03,   1.3263389E-03
     +,   1.1224664E-03,   9.4969390E-04,   8.0366660E-04
     +,   6.8047241E-04,   5.7665200E-04,   4.8918754E-04
     +,   4.1546993E-04,   3.5326357E-04,   3.0067767E-04
     +,   2.5612887E-04,   2.1829788E-04,   1.8608969E-04
     +,   1.5860175E-04,   1.3509371E-04,   1.1495398E-04
     +,   9.7678414E-05,   8.2850660E-05,   7.0123810E-05
     +,   5.9205919E-05,   4.9850310E-05,   4.1847154E-05
     +,   3.5015975E-05,   2.9200071E-05,   2.4263099E-05
     +,   2.0086141E-05,   1.6564874E-05,   1.3607466E-05
     +,   1.1133379E-05,   9.0722533E-06,   7.3623528E-06
     +,   5.9499043E-06,   4.7883154E-06,   3.8373105E-06
     +,   3.0621748E-06,   2.4332173E-06,   1.9252057E-06
     +,   1.5167619E-06,   1.1898566E-06,   9.2939956E-07
     +,   7.2284053E-07,   5.5977858E-07,   4.3163735E-07
     +,   3.3139534E-07,   2.5334060E-07,   1.9283675E-07
     +,   1.4614965E-07,   1.1028875E-07,   8.2869391E-08
     +,   6.1998804E-08,   4.6184194E-08,   3.4255372E-08
     +,   2.5298464E-08,   1.8603043E-08,   1.3620566E-08
     +,   9.9297059E-09,   7.2077180E-09,   5.2094071E-09
     +,   3.7488688E-09,   2.6862181E-09,   1.9164736E-09
     +,   1.3614285E-09,   9.6295705E-10,   6.7818545E-10
     +,   4.7556625E-10,   3.3204939E-10,   2.3084509E-10
     +,   1.5979289E-10,   1.1013503E-10,   7.5580930E-11
     +,   5.1645240E-11,   3.5137275E-11,   2.3803244E-11
     +,   1.6055504E-11,   1.0783063E-11,   7.2107420E-12
     +,   4.8011907E-12,   3.1830018E-12,   2.1011409E-12
     +,   1.3810008E-12,   9.0377906E-13
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_asha_hatt90_mass = Yx/39.8528197254902
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_asha_hatt95_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.2835497E-04,   2.4530705E-04
     +,   2.6339106E-04,   2.8267765E-04,   3.0324134E-04
     +,   3.2516057E-04,   3.4851787E-04,   3.7339976E-04
     +,   3.9989606E-04,   4.2810175E-04,   4.5811402E-04
     +,   4.9003394E-04,   5.2396546E-04,   5.6001561E-04
     +,   5.9829355E-04,   6.3891063E-04,   6.8197964E-04
     +,   7.2761514E-04,   7.7593181E-04,   8.2704530E-04
     +,   8.8107155E-04,   9.3812594E-04,   9.9832402E-04
     +,   1.0617843E-03,   1.1286190E-03,   1.1989481E-03
     +,   1.2728900E-03,   1.3505658E-03,   1.4321004E-03
     +,   1.5176253E-03,   1.6072786E-03,   1.7012084E-03
     +,   1.7995753E-03,   1.9025545E-03,   2.0103396E-03
     +,   2.1231435E-03,   2.2412066E-03,   2.3647903E-03
     +,   2.4941964E-03,   2.6297418E-03,   2.7717941E-03
     +,   2.9207466E-03,   3.0770283E-03,   3.2411043E-03
     +,   3.4134693E-03,   3.5946507E-03,   3.7851962E-03
     +,   3.9856732E-03,   4.1966611E-03,   4.4187377E-03
     +,   4.6524755E-03,   4.8984252E-03,   5.1571038E-03
     +,   5.4290020E-03,   5.7145217E-03,   6.0140318E-03
     +,   6.3278060E-03,   6.6560316E-03,   6.9988081E-03
     +,   7.3561356E-03,   7.7279173E-03,   8.1139654E-03
     +,   8.5139824E-03,   8.9276209E-03,   9.3544759E-03
     +,   9.7940462E-03,   1.0245871E-02,   1.0709422E-02
     +,   1.1184247E-02,   1.1669882E-02,   1.2165986E-02
     +,   1.2672217E-02,   1.3188410E-02,   1.3714396E-02
     +,   1.4250171E-02,   1.4795782E-02,   1.5351295E-02
     +,   1.5916778E-02,   1.6492276E-02,   1.7077753E-02
     +,   1.7672941E-02,   1.8277410E-02,   1.8890336E-02
     +,   1.9510586E-02,   2.0136524E-02,   2.0766078E-02
     +,   2.1396589E-02,   2.2024946E-02,   2.2647461E-02
     +,   2.3260048E-02,   2.3858279E-02,   2.4437441E-02
     +,   2.4992768E-02,   2.5519606E-02,   2.6013680E-02
     +,   2.6471175E-02,   2.6889153E-02,   2.7265593E-02
     +,   2.7599774E-02,   2.7892292E-02,   2.8145313E-02
     +,   2.8362570E-02,   2.8549403E-02,   2.8712714E-02
     +,   2.8860835E-02,   2.9003378E-02,   2.9150978E-02
     +,   2.9315058E-02,   2.9507544E-02,   2.9740613E-02
     +,   3.0026412E-02,   3.0376947E-02,   3.0803859E-02
     +,   3.1318516E-02,   3.1931851E-02,   3.2654651E-02
     +,   3.3497516E-02,   3.4471154E-02,   3.5586249E-02
     +,   3.6853667E-02,   3.8284235E-02,   3.9888199E-02
     +,   4.1674811E-02,   4.3651603E-02,   4.5823313E-02
     +,   4.8190556E-02,   5.0749052E-02,   5.3487979E-02
     +,   5.6389749E-02,   5.9428647E-02,   6.2571600E-02
     +,   6.5777697E-02,   6.9000170E-02,   7.2187193E-02
     +,   7.5284787E-02,   7.8239106E-02,   8.0999114E-02
     +,   8.3519630E-02,   8.5764281E-02,   8.7707683E-02
     +,   8.9336790E-02,   9.0652645E-02,   9.1670364E-02
     +,   9.2418939E-02,   9.2940249E-02,   9.3288071E-02
     +,   9.3526617E-02,   9.3729801E-02,   9.3981534E-02
     +,   9.4376899E-02,   9.5025778E-02,   9.6057326E-02
     +,   9.7626723E-02,   9.9920422E-02,   0.1031587    
     +,   0.1075895    ,   0.1134699    ,   0.1210342    
     +,   0.1304471    ,   0.1417516    ,   0.1548331    
     +,   0.1694101    ,   0.1850712    ,   0.2013605    
     +,   0.2178846    ,   0.2343997    ,   0.2508307    
     +,   0.2672088    ,   0.2835569    ,   0.2998069    
     +,   0.3158548    ,   0.3318258    ,   0.3485394    
     +,   0.3681055    ,   0.3945103    ,   0.4341306    
     +,   0.4968649    ,   0.5996469    ,   0.7705355    
     +,    1.042107    ,    1.434145    ,    1.970950    
     +,    2.746102    ,    3.891207    ,    5.478803    
     +,    7.950966    ,    11.87211    ,    16.32709    
     +,    20.58651    ,    21.57562    ,    18.24514    
     +,    13.72167    ,    8.955542    ,    5.601398    
     +,    3.667832    ,    2.419055    ,    1.620902    
     +,    1.085761    ,   0.7144756    ,   0.4652764    
     +,   0.3059030    ,   0.2070535    ,   0.1453149    
     +,   0.1050500    ,   7.7281654E-02,   5.7290599E-02
     +,   4.2565778E-02,   3.1613600E-02,   2.3427580E-02
     +,   1.7287729E-02,   1.2676619E-02,   9.2238570E-03
     +,   6.6599245E-03,   4.7815894E-03,   3.4299195E-03
     +,   2.4777071E-03,   1.8226488E-03,   1.3834551E-03
     +,   1.0970086E-03,   9.1565453E-04,   8.0445927E-04
     +,   7.3865056E-04,   7.0123095E-04,   6.8091357E-04
     +,   6.7044911E-04,   6.6533475E-04,   6.6286302E-04
     +,   6.6145795E-04,   6.6023209E-04,   6.5870269E-04
     +,   6.5661711E-04,   6.5385090E-04,   6.5034785E-04
     +,   6.4608885E-04,   6.4107473E-04,   6.3531677E-04
     +,   6.2883261E-04,   6.2164466E-04,   6.1377825E-04
     +,   6.0526095E-04,   5.9612223E-04,   5.8639422E-04
     +,   5.7611085E-04,   5.6530681E-04,   5.5401790E-04
     +,   5.4228184E-04,   5.3013733E-04,   5.1762286E-04
     +,   5.0477742E-04,   4.9164146E-04,   4.7825419E-04
     +,   4.6465476E-04,   4.5088286E-04,   4.3697766E-04
     +,   4.2297674E-04,   4.0891679E-04,   3.9483455E-04
     +,   3.8076550E-04,   3.6674298E-04,   3.5279884E-04
     +,   3.3896451E-04,   3.2526974E-04,   3.1174166E-04
     +,   2.9840565E-04,   2.8528675E-04,   2.7240688E-04
     +,   2.5978585E-04,   2.4744266E-04,   2.3539437E-04
     +,   2.2365541E-04,   2.1223829E-04,   2.0115447E-04
     +,   1.9041372E-04,   1.8002320E-04,   1.6998856E-04
     +,   1.6031474E-04,   1.5100384E-04,   1.4205783E-04
     +,   1.3347602E-04,   1.2525755E-04,   1.1739928E-04
     +,   1.0989795E-04,   1.0274826E-04,   9.5944946E-05
     +,   8.9480935E-05,   8.3349209E-05,   7.7541525E-05
     +,   7.2048992E-05,   6.6862747E-05,   6.1972823E-05
     +,   5.7369489E-05,   5.3042189E-05,   4.8980659E-05
     +,   4.5173998E-05,   4.1611682E-05,   3.8282698E-05
     +,   3.5176508E-05,   3.2282223E-05,   2.9589464E-05
     +,   2.7087646E-05,   2.4766712E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_asha_hatt95_mass = Yx/38.1543905098039
      RETURN
      END
C 
C---- New file --- 
C 
      DOUBLE PRECISION FUNCTION A196_tt_ashz_htt100_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.0649470E-03,   3.0892899E-03
     +,   3.1106360E-03,   3.1289591E-03,   3.1442493E-03
     +,   3.1565058E-03,   3.1657433E-03,   3.1719874E-03
     +,   3.1752780E-03,   3.1756659E-03,   3.1732155E-03
     +,   3.1680015E-03,   3.1601121E-03,   3.1496426E-03
     +,   3.1367054E-03,   3.1214149E-03,   3.1039009E-03
     +,   3.0843008E-03,   3.0627586E-03,   3.0394278E-03
     +,   3.0144698E-03,   2.9880500E-03,   2.9603445E-03
     +,   2.9315306E-03,   2.9017956E-03,   2.8713292E-03
     +,   2.8403269E-03,   2.8089907E-03,   2.7775245E-03
     +,   2.7461390E-03,   2.7150498E-03,   2.6844761E-03
     +,   2.6546442E-03,   2.6257851E-03,   2.5981341E-03
     +,   2.5719365E-03,   2.5474401E-03,   2.5249037E-03
     +,   2.5045928E-03,   2.4867812E-03,   2.4717529E-03
     +,   2.4598010E-03,   2.4512303E-03,   2.4463569E-03
     +,   2.4455085E-03,   2.4490249E-03,   2.4572604E-03
     +,   2.4705809E-03,   2.4893668E-03,   2.5140129E-03
     +,   2.5449267E-03,   2.5825293E-03,   2.6272549E-03
     +,   2.6795529E-03,   2.7398767E-03,   2.8087001E-03
     +,   2.8864990E-03,   2.9737593E-03,   3.0709708E-03
     +,   3.1786268E-03,   3.2972223E-03,   3.4272501E-03
     +,   3.5691871E-03,   3.7235157E-03,   3.8906990E-03
     +,   4.0711719E-03,   4.2653633E-03,   4.4736541E-03
     +,   4.6964143E-03,   4.9339491E-03,   5.1865466E-03
     +,   5.4544117E-03,   5.7377280E-03,   6.0365787E-03
     +,   6.3510030E-03,   6.6809678E-03,   7.0263408E-03
     +,   7.3869000E-03,   7.7623562E-03,   8.1523266E-03
     +,   8.5562989E-03,   8.9737102E-03,   9.4038472E-03
     +,   9.8459590E-03,   1.0299146E-02,   1.0762482E-02
     +,   1.1234903E-02,   1.1715344E-02,   1.2202626E-02
     +,   1.2695584E-02,   1.3193045E-02,   1.3693819E-02
     +,   1.4196754E-02,   1.4700816E-02,   1.5205072E-02
     +,   1.5708696E-02,   1.6211117E-02,   1.6711945E-02
     +,   1.7211115E-02,   1.7708857E-02,   1.8205794E-02
     +,   1.8702921E-02,   1.9201737E-02,   1.9704120E-02
     +,   2.0212524E-02,   2.0729851E-02,   2.1259475E-02
     +,   2.1805227E-02,   2.2371387E-02,   2.2962593E-02
     +,   2.3583699E-02,   2.4239857E-02,   2.4936209E-02
     +,   2.5677998E-02,   2.6470263E-02,   2.7317945E-02
     +,   2.8225617E-02,   2.9197643E-02,   3.0237997E-02
     +,   3.1350438E-02,   3.2538697E-02,   3.3806432E-02
     +,   3.5157621E-02,   3.6596943E-02,   3.8130097E-02
     +,   3.9763920E-02,   4.1507199E-02,   4.3370437E-02
     +,   4.5366500E-02,   4.7510106E-02,   4.9818136E-02
     +,   5.2308444E-02,   5.4999672E-02,   5.7909429E-02
     +,   6.1053231E-02,   6.4442672E-02,   6.8083137E-02
     +,   7.1972013E-02,   7.6097108E-02,   8.0434881E-02
     +,   8.4949069E-02,   8.9590579E-02,   9.4298422E-02
     +,   9.9000849E-02,   0.1036174    ,   0.1080634    
     +,   0.1122538    ,   0.1161078    ,   0.1195546    
     +,   0.1225386    ,   0.1250234    ,   0.1269959    
     +,   0.1284679    ,   0.1294776    ,   0.1300870    
     +,   0.1303794    ,   0.1304541    ,   0.1304206    
     +,   0.1303908    ,   0.1304729    ,   0.1307641    
     +,   0.1313470    ,   0.1322860    ,   0.1336280    
     +,   0.1354059    ,   0.1376451    ,   0.1403724    
     +,   0.1436270    ,   0.1474720    ,   0.1520034    
     +,   0.1573545    ,   0.1636945    ,   0.1712188    
     +,   0.1801310    ,   0.1906205    ,   0.2028449    
     +,   0.2169211    ,   0.2329337    ,   0.2509631    
     +,   0.2711231    ,   0.2935834    ,   0.3185566    
     +,   0.3462523    ,   0.3768264    ,   0.4103970    
     +,   0.4471952    ,   0.4878540    ,   0.5336609    
     +,   0.5864878    ,   0.6481879    ,   0.7196733    
     +,   0.8002214    ,   0.8876735    ,   0.9796133    
     +,    1.075075    ,    1.176201    ,    1.289138    
     +,    1.422489    ,    1.581662    ,    1.762047    
     +,    1.950877    ,    2.142468    ,    2.350425    
     +,    2.595053    ,    2.877789    ,    3.180456    
     +,    3.490744    ,    3.812742    ,    4.157753    
     +,    4.531880    ,    4.924580    ,    5.331376    
     +,    5.717815    ,    5.983639    ,    6.058985    
     +,    5.935054    ,    5.671611    ,    5.334591    
     +,    4.907952    ,    4.430823    ,    4.026049    
     +,    3.716693    ,    3.425498    ,    3.113548    
     +,    2.803293    ,    2.507941    ,    2.207812    
     +,    1.891947    ,    1.579790    ,    1.296912    
     +,    1.052532    ,   0.8428520    ,   0.6629201    
     +,   0.5111422    ,   0.3873843    ,   0.2904014    
     +,   0.2171029    ,   0.1631845    ,   0.1241308    
     +,   9.5963106E-02,   7.5549707E-02,   6.0587984E-02
     +,   4.9444232E-02,   4.0978901E-02,   3.4405258E-02
     +,   2.9184625E-02,   2.4950478E-02,   2.1453777E-02
     +,   1.8524518E-02,   1.6044730E-02,   1.3929621E-02
     +,   1.2116003E-02,   1.0554934E-02,   9.2070820E-03
     +,   8.0399755E-03,   7.0265257E-03,   6.1440337E-03
     +,   5.3733927E-03,   4.6985075E-03,   4.1058948E-03
     +,   3.5843188E-03,   3.1243942E-03,   2.7182568E-03
     +,   2.3593353E-03,   2.0421424E-03,   1.7620050E-03
     +,   1.5149332E-03,   1.2974921E-03,   1.1066656E-03
     +,   9.3975605E-04,   7.9433341E-04,   6.6819112E-04
     +,   5.5929821E-04,   4.6577171E-04,   3.8587072E-04
     +,   3.1799430E-04,   2.6065865E-04,   2.1251265E-04
     +,   1.7231987E-04,   1.3896919E-04,   1.1146023E-04
     +,   8.8907975E-05,   7.0529524E-05,   5.5643610E-05
     +,   4.3658241E-05,   3.4066725E-05,   2.6436530E-05
     +,   2.0402582E-05,   1.5659576E-05,   1.1953129E-05
     +,   9.0739823E-06,   6.8504714E-06,   5.1434808E-06
     +,   3.8405965E-06,   2.8520203E-06,   2.1062483E-06
     +,   1.5469512E-06,   1.1299110E-06,   8.2076775E-07
     +,   5.9291824E-07,   4.2596824E-07
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_ashz_htt100_mass = Yx/32.8596744
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_ashz_htt105_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  8.3351746E-04,   8.4563409E-04
     +,   8.5774553E-04,   8.6985406E-04,   8.8196312E-04
     +,   8.9407607E-04,   9.0619706E-04,   9.1833080E-04
     +,   9.3048229E-04,   9.4265741E-04,   9.5486274E-04
     +,   9.6710527E-04,   9.7939279E-04,   9.9173363E-04
     +,   1.0041374E-03,   1.0166146E-03,   1.0291768E-03
     +,   1.0418361E-03,   1.0546070E-03,   1.0675046E-03
     +,   1.0805465E-03,   1.0937514E-03,   1.1071406E-03
     +,   1.1207381E-03,   1.1345695E-03,   1.1486659E-03
     +,   1.1630594E-03,   1.1777874E-03,   1.1928919E-03
     +,   1.2084189E-03,   1.2244212E-03,   1.2409571E-03
     +,   1.2580919E-03,   1.2758989E-03,   1.2944599E-03
     +,   1.3138657E-03,   1.3342177E-03,   1.3556285E-03
     +,   1.3782241E-03,   1.4021416E-03,   1.4275359E-03
     +,   1.4545759E-03,   1.4834485E-03,   1.5143595E-03
     +,   1.5475350E-03,   1.5832228E-03,   1.6216947E-03
     +,   1.6632485E-03,   1.7082075E-03,   1.7569266E-03
     +,   1.8097897E-03,   1.8672153E-03,   1.9296557E-03
     +,   1.9976057E-03,   2.0715916E-03,   2.1521905E-03
     +,   2.2400175E-03,   2.3357368E-03,   2.4400600E-03
     +,   2.5537473E-03,   2.6776115E-03,   2.8125197E-03
     +,   2.9593799E-03,   3.1191648E-03,   3.2929005E-03
     +,   3.4816433E-03,   3.6865177E-03,   3.9086659E-03
     +,   4.1492921E-03,   4.4095954E-03,   4.6908315E-03
     +,   4.9942224E-03,   5.3210254E-03,   5.6724381E-03
     +,   6.0496479E-03,   6.4537944E-03,   6.8859123E-03
     +,   7.3469388E-03,   7.8377211E-03,   8.3589666E-03
     +,   8.9111682E-03,   9.4946930E-03,   1.0109642E-02
     +,   1.0755952E-02,   1.1433247E-02,   1.2140970E-02
     +,   1.2878226E-02,   1.3643933E-02,   1.4436665E-02
     +,   1.5254800E-02,   1.6096508E-02,   1.6959677E-02
     +,   1.7842019E-02,   1.8741192E-02,   1.9654712E-02
     +,   2.0580027E-02,   2.1514703E-02,   2.2456275E-02
     +,   2.3402574E-02,   2.4351539E-02,   2.5301538E-02
     +,   2.6251215E-02,   2.7199790E-02,   2.8146891E-02
     +,   2.9092832E-02,   3.0038577E-02,   3.0985748E-02
     +,   3.1936679E-02,   3.2894552E-02,   3.3863239E-02
     +,   3.4847353E-02,   3.5852246E-02,   3.6883775E-02
     +,   3.7948433E-02,   3.9052993E-02,   4.0204469E-02
     +,   4.1409809E-02,   4.2675816E-02,   4.4008583E-02
     +,   4.5413561E-02,   4.6895061E-02,   4.8455860E-02
     +,   5.0097082E-02,   5.1818024E-02,   5.3615890E-02
     +,   5.5485550E-02,   5.7419930E-02,   5.9409656E-02
     +,   6.1443865E-02,   6.3510023E-02,   6.5594941E-02
     +,   6.7684896E-02,   6.9766693E-02,   7.1827978E-02
     +,   7.3858187E-02,   7.5849041E-02,   7.7794693E-02
     +,   7.9692237E-02,   8.1541635E-02,   8.3345488E-02
     +,   8.5108310E-02,   8.6835898E-02,   8.8534378E-02
     +,   9.0209059E-02,   9.1863237E-02,   9.3497239E-02
     +,   9.5107511E-02,   9.6685797E-02,   9.8219082E-02
     +,   9.9689662E-02,   0.1010758    ,   0.1023527    
     +,   0.1034937    ,   0.1044727    ,   0.1052653    
     +,   0.1058515    ,   0.1062170    ,   0.1063558    
     +,   0.1062713    ,   0.1059774    ,   0.1054998    
     +,   0.1048762    ,   0.1041570    ,   0.1034046    
     +,   0.1026935    ,   0.1021096    ,   0.1017498    
     +,   0.1017212    ,   0.1021400    ,   0.1031313    
     +,   0.1048279    ,   0.1073706    ,   0.1109079    
     +,   0.1155971    ,   0.1216042    ,   0.1291049    
     +,   0.1382819    ,   0.1493201    ,   0.1623971    
     +,   0.1776735    ,   0.1952797    ,   0.2153116    
     +,   0.2378374    ,   0.2629209    ,   0.2906468    
     +,   0.3211254    ,   0.3544546    ,   0.3906235    
     +,   0.4293582    ,   0.4699817    ,   0.5113943    
     +,   0.5522312    ,   0.5912504    ,   0.6278907    
     +,   0.6628342    ,   0.6983826    ,   0.7384233    
     +,   0.7878814    ,   0.8516638    ,   0.9333536    
     +,    1.034030    ,    1.151665    ,    1.281174    
     +,    1.414773    ,    1.542421    ,    1.652987    
     +,    1.737476    ,    1.794674    ,    1.836024    
     +,    1.884057    ,    1.962169    ,    2.081141    
     +,    2.231208    ,    2.384650    ,    2.509684    
     +,    2.594443    ,    2.670053    ,    2.801733    
     +,    3.029724    ,    3.319699    ,    3.606230    
     +,    3.872812    ,    4.133860    ,    4.372848    
     +,    4.577901    ,    4.776317    ,    4.945301    
     +,    4.980181    ,    4.828763    ,    4.539233    
     +,    4.146916    ,    3.652931    ,    3.099262    
     +,    2.559204    ,    2.075143    ,    1.651285    
     +,    1.284810    ,   0.9790367    ,   0.7365982    
     +,   0.5530695    ,   0.4177679    ,   0.3182102    
     +,   0.2438565    ,   0.1873588    ,   0.1439859    
     +,   0.1105929    ,   8.4901430E-02,   6.5161809E-02
     +,   5.0015718E-02,   3.8417447E-02,   2.9562822E-02
     +,   2.2831483E-02,   1.7740309E-02,   1.3909157E-02
     +,   1.1037432E-02,   8.8882362E-03,   7.2765788E-03
     +,   6.0600159E-03,   5.1309573E-03,   4.4099498E-03
     +,   3.8395433E-03,   3.3788644E-03,   2.9991332E-03
     +,   2.6801901E-03,   2.4078893E-03,   2.1721600E-03
     +,   1.9657474E-03,   1.7833483E-03,   1.6210036E-03
     +,   1.4756960E-03,   1.3450867E-03,   1.2273317E-03
     +,   1.1209352E-03,   1.0246475E-03,   9.3740626E-04
     +,   8.5829617E-04,   7.8649726E-04,   7.2128535E-04
     +,   6.6199817E-04,   6.0804421E-04,   5.5888045E-04
     +,   5.1402231E-04,   4.7302755E-04,   4.3550422E-04
     +,   4.0109691E-04,   3.6949426E-04,   3.4041647E-04
     +,   3.1361668E-04,   2.8887988E-04,   2.6601364E-04
     +,   2.4485192E-04,   2.2524608E-04,   2.0706808E-04
     +,   1.9020273E-04,   1.7455054E-04,   1.6002129E-04
     +,   1.4653653E-04,   1.3402416E-04,   1.2242077E-04
     +,   1.1166719E-04,   1.0171075E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_ashz_htt105_mass = Yx/29.1850294285714
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_ashz_htt107_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  7.6271506E-04,   7.6926145E-04
     +,   7.7569229E-04,   7.8201038E-04,   7.8821846E-04
     +,   7.9432066E-04,   8.0032111E-04,   8.0622488E-04
     +,   8.1203744E-04,   8.1776513E-04,   8.2341523E-04
     +,   8.2899514E-04,   8.3451357E-04,   8.3997991E-04
     +,   8.4540399E-04,   8.5079722E-04,   8.5617113E-04
     +,   8.6153869E-04,   8.6691353E-04,   8.7231060E-04
     +,   8.7774562E-04,   8.8323565E-04,   8.8879856E-04
     +,   8.9445408E-04,   9.0022292E-04,   9.0612686E-04
     +,   9.1218977E-04,   9.1843726E-04,   9.2489633E-04
     +,   9.3159592E-04,   9.3856809E-04,   9.4584614E-04
     +,   9.5346750E-04,   9.6147187E-04,   9.6990319E-04
     +,   9.7880897E-04,   9.8824257E-04,   9.9826255E-04
     +,   1.0089345E-03,   1.0203311E-03,   1.0325345E-03
     +,   1.0456383E-03,   1.0597482E-03,   1.0749850E-03
     +,   1.0914871E-03,   1.1094133E-03,   1.1289482E-03
     +,   1.1503020E-03,   1.1737210E-03,   1.1994883E-03
     +,   1.2279336E-03,   1.2594364E-03,   1.2944373E-03
     +,   1.3334450E-03,   1.3770422E-03,   1.4259039E-03
     +,   1.4807987E-03,   1.5426045E-03,   1.6123200E-03
     +,   1.6910722E-03,   1.7801310E-03,   1.8809175E-03
     +,   1.9950052E-03,   2.1241407E-03,   2.2702438E-03
     +,   2.4353864E-03,   2.6218302E-03,   2.8319734E-03
     +,   3.0683847E-03,   3.3337318E-03,   3.6308162E-03
     +,   3.9624763E-03,   4.3316199E-03,   4.7410959E-03
     +,   5.1937206E-03,   5.6921928E-03,   6.2389900E-03
     +,   6.8363231E-03,   7.4861180E-03,   8.1899036E-03
     +,   8.9486763E-03,   9.7629884E-03,   1.0632693E-02
     +,   1.1557116E-02,   1.2534780E-02,   1.3563625E-02
     +,   1.4640742E-02,   1.5762663E-02,   1.6925102E-02
     +,   1.8123250E-02,   1.9351773E-02,   2.0604791E-02
     +,   2.1876099E-02,   2.3159355E-02,   2.4448188E-02
     +,   2.5736196E-02,   2.7017413E-02,   2.8286191E-02
     +,   2.9537633E-02,   3.0767493E-02,   3.1972591E-02
     +,   3.3150669E-02,   3.4300815E-02,   3.5423152E-02
     +,   3.6519226E-02,   3.7591834E-02,   3.8644910E-02
     +,   3.9683525E-02,   4.0713798E-02,   4.1742641E-02
     +,   4.2777441E-02,   4.3825969E-02,   4.4895940E-02
     +,   4.5994878E-02,   4.7129527E-02,   4.8305921E-02
     +,   4.9528636E-02,   5.0801050E-02,   5.2124608E-02
     +,   5.3499158E-02,   5.4922651E-02,   5.6391198E-02
     +,   5.7899106E-02,   5.9439417E-02,   6.1003949E-02
     +,   6.2583663E-02,   6.4169474E-02,   6.5752275E-02
     +,   6.7324065E-02,   6.8877980E-02,   7.0409194E-02
     +,   7.1915098E-02,   7.3395923E-02,   7.4854635E-02
     +,   7.6297276E-02,   7.7732630E-02,   7.9171926E-02
     +,   8.0628254E-02,   8.2115911E-02,   8.3649233E-02
     +,   8.5241765E-02,   8.6904787E-02,   8.8646330E-02
     +,   9.0470225E-02,   9.2374384E-02,   9.4350897E-02
     +,   9.6385285E-02,   9.8456100E-02,   0.1005360    
     +,   0.1025922    ,   0.1045885    ,   0.1064860    
     +,   0.1082465    ,   0.1098338    ,   0.1112168    
     +,   0.1123711    ,   0.1132816    ,   0.1139434    
     +,   0.1143632    ,   0.1145594    ,   0.1145621    
     +,   0.1144125    ,   0.1141618    ,   0.1138708    
     +,   0.1136086    ,   0.1134521    ,   0.1134859    
     +,   0.1138025    ,   0.1145011    ,   0.1156879    
     +,   0.1174739    ,   0.1199721    ,   0.1232950    
     +,   0.1275504    ,   0.1328393    ,   0.1392574    
     +,   0.1469002    ,   0.1558721    ,   0.1663023    
     +,   0.1783624    ,   0.1922833    ,   0.2083682    
     +,   0.2269954    ,   0.2486145    ,   0.2737213    
     +,   0.3028143    ,   0.3363352    ,   0.3746028    
     +,   0.4177551    ,   0.4657448    ,   0.5184362    
     +,   0.5757667    ,   0.6378710    ,   0.7049805    
     +,   0.7769555    ,   0.8525332    ,   0.9288215    
     +,    1.001798    ,    1.068249    ,    1.128458    
     +,    1.187623    ,    1.253834    ,    1.333004    
     +,    1.424608    ,    1.522660    ,    1.621345    
     +,    1.719102    ,    1.816519    ,    1.912068    
     +,    2.003352    ,    2.092520    ,    2.185913    
     +,    2.287206    ,    2.396363    ,    2.516770    
     +,    2.655283    ,    2.809663    ,    2.961111    
     +,    3.085402    ,    3.171989    ,    3.234553    
     +,    3.303651    ,    3.401145    ,    3.520693    
     +,    3.636143    ,    3.714827    ,    3.720979    
     +,    3.630036    ,    3.443803    ,    3.182962    
     +,    2.872691    ,    2.537457    ,    2.196662    
     +,    1.861503    ,    1.540524    ,    1.245171    
     +,   0.9864236    ,   0.7691823    ,   0.5923159    
     +,   0.4520099    ,   0.3436576    ,   0.2619879    
     +,   0.2012431    ,   0.1559392    ,   0.1216106    
     +,   9.5063739E-02,   7.4201144E-02,   5.7684619E-02
     +,   4.4631217E-02,   3.4405157E-02,   2.6497597E-02
     +,   2.0472869E-02,   1.5948376E-02,   1.2590143E-02
     +,   1.0114074E-02,   8.2870619E-03,   6.9251605E-03
     +,   5.8888621E-03,   5.0765974E-03,   4.4174884E-03
     +,   3.8641181E-03,   3.3860204E-03,   2.9643457E-03
     +,   2.5878269E-03,   2.2498590E-03,   1.9464245E-03
     +,   1.6748576E-03,   1.4330958E-03,   1.2192455E-03
     +,   1.0313834E-03,   8.6751120E-04,   7.2557427E-04
     +,   6.0348533E-04,   4.9916870E-04,   4.1061497E-04
     +,   3.3592439E-04,   2.7331407E-04,   2.2115419E-04
     +,   1.7796006E-04,   1.4240736E-04,   1.1331765E-04
     +,   8.9660229E-05,   7.0535301E-05,   5.5169272E-05
     +,   4.2898024E-05,   3.3159369E-05,   2.5478525E-05
     +,   1.9458617E-05,   1.4770771E-05,   1.1143400E-05
     +,   8.3549476E-06,   6.2252120E-06,   4.6093660E-06
     +,   3.3914209E-06,   2.4795434E-06,   1.8013232E-06
     +,   1.3002938E-06,   9.3262025E-07,   6.6463934E-07
     +,   4.7062042E-07,   3.3110646E-07
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_ashz_htt107_mass = Yx/26.1256765
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_ashz_htt110_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.4519813E-03,   4.5332904E-03
     +,   4.6137897E-03,   4.6934406E-03,   4.7722072E-03
     +,   4.8500593E-03,   4.9269702E-03,   5.0029191E-03
     +,   5.0778859E-03,   5.1518586E-03,   5.2248291E-03
     +,   5.2967910E-03,   5.3677466E-03,   5.4376987E-03
     +,   5.5066552E-03,   5.5746315E-03,   5.6416430E-03
     +,   5.7077114E-03,   5.7728630E-03,   5.8371257E-03
     +,   5.9005348E-03,   5.9631285E-03,   6.0249460E-03
     +,   6.0860389E-03,   6.1464524E-03,   6.2062433E-03
     +,   6.2654703E-03,   6.3241958E-03,   6.3824868E-03
     +,   6.4404160E-03,   6.4980616E-03,   6.5555042E-03
     +,   6.6128331E-03,   6.6701393E-03,   6.7275236E-03
     +,   6.7850924E-03,   6.8429559E-03,   6.9012353E-03
     +,   6.9600604E-03,   7.0195622E-03,   7.0798900E-03
     +,   7.1411952E-03,   7.2036409E-03,   7.2674016E-03
     +,   7.3326626E-03,   7.3996214E-03,   7.4684815E-03
     +,   7.5394674E-03,   7.6128081E-03,   7.6887542E-03
     +,   7.7675576E-03,   7.8494921E-03,   7.9348413E-03
     +,   8.0239065E-03,   8.1169894E-03,   8.2144151E-03
     +,   8.3165150E-03,   8.4236274E-03,   8.5361050E-03
     +,   8.6543057E-03,   8.7785898E-03,   8.9093288E-03
     +,   9.0468824E-03,   9.1916220E-03,   9.3439193E-03
     +,   9.5041189E-03,   9.6725784E-03,   9.8496219E-03
     +,   1.0035584E-02,   1.0230753E-02,   1.0435404E-02
     +,   1.0649798E-02,   1.0874157E-02,   1.1108655E-02
     +,   1.1353460E-02,   1.1608698E-02,   1.1874443E-02
     +,   1.2150735E-02,   1.2437588E-02,   1.2734978E-02
     +,   1.3042834E-02,   1.3361083E-02,   1.3689608E-02
     +,   1.4028312E-02,   1.4377051E-02,   1.4735757E-02
     +,   1.5104325E-02,   1.5482773E-02,   1.5871098E-02
     +,   1.6269470E-02,   1.6678143E-02,   1.7097516E-02
     +,   1.7528126E-02,   1.7970756E-02,   1.8426420E-02
     +,   1.8896317E-02,   1.9382007E-02,   1.9885270E-02
     +,   2.0408262E-02,   2.0953398E-02,   2.1523500E-02
     +,   2.2121610E-02,   2.2751186E-02,   2.3415867E-02
     +,   2.4119617E-02,   2.4866603E-02,   2.5661087E-02
     +,   2.6507402E-02,   2.7409976E-02,   2.8373094E-02
     +,   2.9400803E-02,   3.0497000E-02,   3.1665035E-02
     +,   3.2907929E-02,   3.4227941E-02,   3.5626814E-02
     +,   3.7105352E-02,   3.8663708E-02,   4.0301073E-02
     +,   4.2015906E-02,   4.3805994E-02,   4.5668393E-02
     +,   4.7599748E-02,   4.9596705E-02,   5.1656213E-02
     +,   5.3775612E-02,   5.5953577E-02,   5.8190238E-02
     +,   6.0487952E-02,   6.2851407E-02,   6.5288454E-02
     +,   6.7809567E-02,   7.0428662E-02,   7.3161848E-02
     +,   7.6027744E-02,   7.9045922E-02,   8.2235701E-02
     +,   8.5614495E-02,   8.9196488E-02,   9.2990361E-02
     +,   9.6997075E-02,   0.1012083    ,   0.1056053    
     +,   0.1101579    ,   0.1148232    ,   0.1195476    
     +,   0.1242668    ,   0.1289084    ,   0.1333937    
     +,   0.1376427    ,   0.1415765    ,   0.1451211    
     +,   0.1482112    ,   0.1507942    ,   0.1528321    
     +,   0.1543037    ,   0.1552055    ,   0.1555528    
     +,   0.1553778    ,   0.1547294    ,   0.1536703    
     +,   0.1522754    ,   0.1506287    ,   0.1488212    
     +,   0.1469479    ,   0.1451066    ,   0.1433968    
     +,   0.1419190    ,   0.1407756    ,   0.1400729    
     +,   0.1399232    ,   0.1404480    ,   0.1417818    
     +,   0.1440725    ,   0.1474830    ,   0.1521881    
     +,   0.1583680    ,   0.1661980    ,   0.1758341    
     +,   0.1873998    ,   0.2009707    ,   0.2165663    
     +,   0.2341526    ,   0.2536577    ,   0.2749978    
     +,   0.2981116    ,   0.3229980    ,   0.3497465    
     +,   0.3785498    ,   0.4096964    ,   0.4435458    
     +,   0.4804721    ,   0.5207790    ,   0.5646043    
     +,   0.6118407    ,   0.6621133    ,   0.7148641    
     +,   0.7695474    ,   0.8258516    ,   0.8837978    
     +,   0.9436167    ,    1.005425    ,    1.068884    
     +,    1.133072    ,    1.196709    ,    1.258696    
     +,    1.318846    ,    1.378683    ,    1.441965    
     +,    1.514054    ,    1.599397    ,    1.698066    
     +,    1.804338    ,    1.909645    ,    2.007878    
     +,    2.097523    ,    2.178060    ,    2.245684    
     +,    2.295581    ,    2.329533    ,    2.358856    
     +,    2.396555    ,    2.445402    ,    2.493767    
     +,    2.522420    ,    2.515534    ,    2.468793    
     +,    2.391870    ,    2.304019    ,    2.222582    
     +,    2.149987    ,    2.069580    ,    1.955647    
     +,    1.790992    ,    1.578598    ,    1.339598    
     +,    1.101399    ,   0.8858438    ,   0.7040312    
     +,   0.5576498    ,   0.4429657    ,   0.3542548    
     +,   0.2857352    ,   0.2323926    ,   0.1902501    
     +,   0.1563605    ,   0.1286535    ,   0.1057293    
     +,   8.6654812E-02,   7.0792928E-02,   5.7670373E-02
     +,   4.6897743E-02,   3.8126569E-02,   3.1034555E-02
     +,   2.5326967E-02,   2.0743866E-02,   1.7064530E-02
     +,   1.4107098E-02,   1.1724808E-02,   9.8008597E-03
     +,   8.2427328E-03,   6.9769300E-03,   5.9448732E-03
     +,   5.0998456E-03,   4.4046124E-03,   3.8293786E-03
     +,   3.3503997E-03,   2.9487889E-03,   2.6095002E-03
     +,   2.3205273E-03,   2.0723022E-03,   1.8572083E-03
     +,   1.6691693E-03,   1.5033337E-03,   1.3558511E-03
     +,   1.2236891E-03,   1.1044474E-03,   9.9626149E-04
     +,   8.9766679E-04,   8.0753607E-04,   7.2498084E-04
     +,   6.4931234E-04,   5.7997112E-04,   5.1650620E-04
     +,   4.5852782E-04,   4.0569936E-04,   3.5770788E-04
     +,   3.1425868E-04,   2.7507127E-04,   2.3986540E-04
     +,   2.0836946E-04,   1.8031093E-04,   1.5542516E-04
     +,   1.3344940E-04,   1.1413113E-04,   9.7223936E-05
     +,   8.2494334E-05,   6.9718655E-05,   5.8688165E-05
     +,   4.9206490E-05,   4.1093084E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_ashz_htt110_mass = Yx/21.2715145106383
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_ashz_htt115_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.0053457E-03,   2.1011811E-03
     +,   2.1981418E-03,   2.2959742E-03,   2.3944143E-03
     +,   2.4931834E-03,   2.5919937E-03,   2.6905474E-03
     +,   2.7885400E-03,   2.8856646E-03,   2.9816076E-03
     +,   3.0760576E-03,   3.1687024E-03,   3.2592358E-03
     +,   3.3473570E-03,   3.4327742E-03,   3.5152074E-03
     +,   3.5943887E-03,   3.6700671E-03,   3.7420108E-03
     +,   3.8100057E-03,   3.8738628E-03,   3.9334125E-03
     +,   3.9885193E-03,   4.0390640E-03,   4.0849647E-03
     +,   4.1261660E-03,   4.1626398E-03,   4.1943942E-03
     +,   4.2214640E-03,   4.2439168E-03,   4.2618508E-03
     +,   4.2753951E-03,   4.2847097E-03,   4.2899791E-03
     +,   4.2914194E-03,   4.2892708E-03,   4.2837984E-03
     +,   4.2752889E-03,   4.2640530E-03,   4.2504161E-03
     +,   4.2347214E-03,   4.2173271E-03,   4.1986015E-03
     +,   4.1789222E-03,   4.1586757E-03,   4.1382508E-03
     +,   4.1180383E-03,   4.0984284E-03,   4.0798094E-03
     +,   4.0625655E-03,   4.0470702E-03,   4.0336912E-03
     +,   4.0227841E-03,   4.0146913E-03,   4.0097423E-03
     +,   4.0082489E-03,   4.0105078E-03,   4.0167961E-03
     +,   4.0273746E-03,   4.0424815E-03,   4.0623369E-03
     +,   4.0871385E-03,   4.1170674E-03,   4.1522817E-03
     +,   4.1929167E-03,   4.2390972E-03,   4.2909165E-03
     +,   4.3484624E-03,   4.4117956E-03,   4.4809692E-03
     +,   4.5560175E-03,   4.6369680E-03,   4.7238292E-03
     +,   4.8166127E-03,   4.9153250E-03,   5.0199642E-03
     +,   5.1305299E-03,   5.2470346E-03,   5.3694998E-03
     +,   5.4979501E-03,   5.6324424E-03,   5.7730391E-03
     +,   5.9198504E-03,   6.0729976E-03,   6.2326584E-03
     +,   6.3990392E-03,   6.5724044E-03,   6.7530582E-03
     +,   6.9413795E-03,   7.1378089E-03,   7.3428415E-03
     +,   7.5570387E-03,   7.7810627E-03,   8.0156447E-03
     +,   8.2615744E-03,   8.5197622E-03,   8.7911654E-03
     +,   9.0768561E-03,   9.3779648E-03,   9.6957348E-03
     +,   1.0031459E-02,   1.0386553E-02,   1.0762461E-02
     +,   1.1160750E-02,   1.1583051E-02,   1.2031063E-02
     +,   1.2506538E-02,   1.3011342E-02,   1.3547414E-02
     +,   1.4116705E-02,   1.4721327E-02,   1.5363383E-02
     +,   1.6045123E-02,   1.6768809E-02,   1.7536847E-02
     +,   1.8351598E-02,   1.9215604E-02,   2.0131296E-02
     +,   2.1101190E-02,   2.2127759E-02,   2.3213308E-02
     +,   2.4359945E-02,   2.5569575E-02,   2.6843732E-02
     +,   2.8183341E-02,   2.9588796E-02,   3.1059591E-02
     +,   3.2594409E-02,   3.4190740E-02,   3.5844997E-02
     +,   3.7552115E-02,   3.9305851E-02,   4.1098326E-02
     +,   4.2920534E-02,   4.4762149E-02,   4.6611637E-02
     +,   4.8456654E-02,   5.0284389E-02,   5.2081753E-02
     +,   5.3835861E-02,   5.5534326E-02,   5.7165924E-02
     +,   5.8720775E-02,   6.0190573E-02,   6.1569098E-02
     +,   6.2852256E-02,   6.4037994E-02,   6.5126486E-02
     +,   6.6119872E-02,   6.7022212E-02,   6.7839161E-02
     +,   6.8577781E-02,   6.9246553E-02,   6.9855236E-02
     +,   7.0414923E-02,   7.0938401E-02,   7.1440309E-02
     +,   7.1937904E-02,   7.2451092E-02,   7.3003292E-02
     +,   7.3621511E-02,   7.4336477E-02,   7.5182490E-02
     +,   7.6196969E-02,   7.7419467E-02,   7.8890525E-02
     +,   8.0650292E-02,   8.2737125E-02,   8.5186206E-02
     +,   8.8027813E-02,   9.1286711E-02,   9.4981492E-02
     +,   9.9123612E-02,   0.1037170    ,   0.1087582    
     +,   0.1142364    ,   0.1201334    ,   0.1264256    
     +,   0.1330872    ,   0.1400949    ,   0.1474336    
     +,   0.1551033    ,   0.1631255    ,   0.1715422    
     +,   0.1804125    ,   0.1898014    ,   0.1997711    
     +,   0.2103777    ,   0.2216843    ,   0.2338014    
     +,   0.2469403    ,   0.2614625    ,   0.2778871    
     +,   0.2968222    ,   0.3188070    ,   0.3441084    
     +,   0.3725591    ,   0.4035416    ,   0.4361543    
     +,   0.4695037    ,   0.5030000    ,   0.5365416    
     +,   0.5705870    ,   0.6062353    ,   0.6453744    
     +,   0.6907172    ,   0.7454200    ,   0.8121321    
     +,   0.8918076    ,   0.9829140    ,    1.081403    
     +,    1.181164    ,    1.274703    ,    1.354497    
     +,    1.415739    ,    1.459735    ,    1.495088    
     +,    1.534002    ,    1.584391    ,    1.643401    
     +,    1.699181    ,    1.741197    ,    1.769525    
     +,    1.792950    ,    1.817791    ,    1.840639    
     +,    1.852683    ,    1.848034    ,    1.824482    
     +,    1.777797    ,    1.700621    ,    1.589570    
     +,    1.451856    ,    1.303008    ,    1.157839    
     +,    1.023612    ,   0.9004348    ,   0.7861501    
     +,   0.6800483    ,   0.5830009    ,   0.4958066    
     +,   0.4182709    ,   0.3496090    ,   0.2892012    
     +,   0.2368309    ,   0.1923938    ,   0.1555313    
     +,   0.1255045    ,   0.1013114    ,   8.1885077E-02
     +,   6.6260122E-02,   5.3645097E-02,   4.3422841E-02
     +,   3.5118952E-02,   2.8366271E-02,   2.2875868E-02
     +,   1.8416163E-02,   1.4799300E-02,   1.1872120E-02
     +,   9.5092813E-03,   7.6075406E-03,   6.0814805E-03
     +,   4.8604053E-03,   3.8858792E-03,   3.1095289E-03
     +,   2.4916262E-03,   1.9998106E-03,   1.6079097E-03
     +,   1.2949386E-03,   1.0442529E-03,   8.4277126E-04
     +,   6.8026007E-04,   5.4874021E-04,   4.4200709E-04
     +,   3.5523315E-04,   2.8462353E-04,   2.2718939E-04
     +,   1.8053764E-04,   1.4274367E-04,   1.1223277E-04
     +,   8.7712921E-05,   6.8109657E-05,   5.2530635E-05
     +,   4.0229042E-05,   3.0583466E-05,   2.3075669E-05
     +,   1.7276536E-05,   1.2833112E-05,   9.4561001E-06
     +,   6.9112061E-06,   5.0096305E-06,   3.6011359E-06
     +,   2.5669435E-06,   1.8143468E-06,   1.2715160E-06
     +,   8.8351601E-07,   6.0866324E-07,   4.1573023E-07
     +,   2.8151689E-07,   1.8900222E-07
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_ashz_htt115_mass = Yx/14.7076000909091
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_ashz_htt120_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  7.3540537E-04,   7.5201021E-04
     +,   7.6872832E-04,   7.8555325E-04,   8.0247835E-04
     +,   8.1949728E-04,   8.3660317E-04,   8.5378933E-04
     +,   8.7104883E-04,   8.8837551E-04,   9.0576243E-04
     +,   9.2320278E-04,   9.4068988E-04,   9.5821678E-04
     +,   9.7577740E-04,   9.9336461E-04,   1.0109720E-03
     +,   1.0285933E-03,   1.0462217E-03,   1.0638514E-03
     +,   1.0814758E-03,   1.0990889E-03,   1.1166846E-03
     +,   1.1342580E-03,   1.1518025E-03,   1.1693132E-03
     +,   1.1867851E-03,   1.2042130E-03,   1.2215928E-03
     +,   1.2389198E-03,   1.2561907E-03,   1.2734018E-03
     +,   1.2905507E-03,   1.3076345E-03,   1.3246525E-03
     +,   1.3416031E-03,   1.3584868E-03,   1.3753040E-03
     +,   1.3920577E-03,   1.4087502E-03,   1.4253868E-03
     +,   1.4419735E-03,   1.4585182E-03,   1.4750309E-03
     +,   1.4915239E-03,   1.5080118E-03,   1.5245121E-03
     +,   1.5410451E-03,   1.5576355E-03,   1.5743111E-03
     +,   1.5911052E-03,   1.6080550E-03,   1.6252032E-03
     +,   1.6426006E-03,   1.6603020E-03,   1.6783727E-03
     +,   1.6968849E-03,   1.7159202E-03,   1.7355720E-03
     +,   1.7559432E-03,   1.7771509E-03,   1.7993258E-03
     +,   1.8226118E-03,   1.8471715E-03,   1.8731849E-03
     +,   1.9008485E-03,   1.9303829E-03,   1.9620259E-03
     +,   1.9960431E-03,   2.0327193E-03,   2.0723701E-03
     +,   2.1153323E-03,   2.1619732E-03,   2.2126851E-03
     +,   2.2678911E-03,   2.3280433E-03,   2.3936185E-03
     +,   2.4651214E-03,   2.5430864E-03,   2.6280740E-03
     +,   2.7206626E-03,   2.8214620E-03,   2.9310910E-03
     +,   3.0501976E-03,   3.1794296E-03,   3.3194644E-03
     +,   3.4709652E-03,   3.6346223E-03,   3.8111070E-03
     +,   4.0011001E-03,   4.2052791E-03,   4.4243028E-03
     +,   4.6588103E-03,   4.9094451E-03,   5.1768296E-03
     +,   5.4615443E-03,   5.7641766E-03,   6.0852538E-03
     +,   6.4253141E-03,   6.7848186E-03,   7.1642417E-03
     +,   7.5639682E-03,   7.9843914E-03,   8.4257964E-03
     +,   8.8884542E-03,   9.3725678E-03,   9.8782415E-03
     +,   1.0405473E-02,   1.0954210E-02,   1.1524273E-02
     +,   1.2115303E-02,   1.2726880E-02,   1.3358342E-02
     +,   1.4008943E-02,   1.4677678E-02,   1.5363446E-02
     +,   1.6064884E-02,   1.6780544E-02,   1.7508727E-02
     +,   1.8247651E-02,   1.8995468E-02,   1.9750182E-02
     +,   2.0509800E-02,   2.1272434E-02,   2.2036295E-02
     +,   2.2799755E-02,   2.3561522E-02,   2.4320604E-02
     +,   2.5076553E-02,   2.5829341E-02,   2.6579652E-02
     +,   2.7328726E-02,   2.8078608E-02,   2.8831918E-02
     +,   2.9592026E-02,   3.0362923E-02,   3.1149065E-02
     +,   3.1955268E-02,   3.2786567E-02,   3.3647947E-02
     +,   3.4543987E-02,   3.5478652E-02,   3.6455058E-02
     +,   3.7474934E-02,   3.8538445E-02,   3.9643921E-02
     +,   4.0787619E-02,   4.1963447E-02,   4.3162972E-02
     +,   4.4375602E-02,   4.5588613E-02,   4.6787344E-02
     +,   4.7955904E-02,   4.9077567E-02,   5.0135549E-02
     +,   5.1113680E-02,   5.1997311E-02,   5.2774325E-02
     +,   5.3435866E-02,   5.3977095E-02,   5.4398123E-02
     +,   5.4704413E-02,   5.4907206E-02,   5.5023771E-02
     +,   5.5077292E-02,   5.5096556E-02,   5.5115525E-02
     +,   5.5172496E-02,   5.5309091E-02,   5.5569310E-02
     +,   5.5998269E-02,   5.6640945E-02,   5.7541259E-02
     +,   5.8741197E-02,   6.0279980E-02,   6.2194068E-02
     +,   6.4517319E-02,   6.7281254E-02,   7.0516035E-02
     +,   7.4251920E-02,   7.8520738E-02,   8.3357364E-02
     +,   8.8802077E-02,   9.4903670E-02,   0.1017216    
     +,   0.1093276    ,   0.1178062    ,   0.1272529    
     +,   0.1377669    ,   0.1494387    ,   0.1623380    
     +,   0.1764981    ,   0.1919045    ,   0.2084910    
     +,   0.2261445    ,   0.2447071    ,   0.2639737    
     +,   0.2836828    ,   0.3035036    ,   0.3230323    
     +,   0.3418239    ,   0.3594679    ,   0.3757000    
     +,   0.3905153    ,   0.4042582    ,   0.4176829    
     +,   0.4319780    ,   0.4487396    ,   0.4698180    
     +,   0.4969471    ,   0.5311588    ,   0.5721877    
     +,   0.6182594    ,   0.6665149    ,   0.7139428    
     +,   0.7582254    ,   0.7979409    ,   0.8321201    
     +,   0.8599173    ,   0.8811659    ,   0.8975848    
     +,   0.9132414    ,   0.9331124    ,   0.9603169    
     +,   0.9941670    ,    1.030728    ,    1.065521    
     +,    1.096120    ,    1.122512    ,    1.144967    
     +,    1.161515    ,    1.167671    ,    1.158929    
     +,    1.133851    ,    1.095039    ,    1.047491    
     +,   0.9960946    ,   0.9439547    ,   0.8921036    
     +,   0.8401650    ,   0.7873368    ,   0.7330962    
     +,   0.6772990    ,   0.6198249    ,   0.5603098    
     +,   0.4983696    ,   0.4342220    ,   0.3692031    
     +,   0.3057554    ,   0.2468245    ,   0.1949916    
     +,   0.1518107    ,   0.1175805    ,   9.1530152E-02
     +,   7.2243862E-02,   5.8110490E-02,   4.7651760E-02
     +,   3.9690390E-02,   3.3386268E-02,   2.8193764E-02
     +,   2.3786757E-02,   1.9983180E-02,   1.6684756E-02
     +,   1.3835669E-02,   1.1397295E-02,   9.3343593E-03
     +,   7.6098973E-03,   6.1845579E-03,   5.0178370E-03
     +,   4.0700473E-03,   3.3042210E-03,   2.6873574E-03
     +,   2.1909438E-03,   1.7910252E-03,   1.4679702E-03
     +,   1.2060055E-03,   9.9257415E-04,   8.1783440E-04
     +,   6.7407475E-04,   5.5530481E-04,   4.5683698E-04
     +,   3.7501118E-04,   3.0692789E-04,   2.5028287E-04
     +,   2.0320804E-04,   1.6418014E-04,   1.3193101E-04
     +,   1.0539636E-04,   8.3675601E-05,   6.5996399E-05
     +,   5.1698578E-05,   4.0213188E-05,   3.1053787E-05
     +,   2.3803559E-05,   1.8109322E-05,   1.3672344E-05
     +,   1.0243198E-05,   7.6145229E-06,   5.6162967E-06
     +,   4.1098997E-06,   2.9838823E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_ashz_htt120_mass = Yx/10.4316426666667
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_ashz_htt60_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.5842806E-02,   2.9145876E-02
     +,   3.2908127E-02,   3.7191808E-02,   4.2063966E-02
     +,   4.7595985E-02,   5.3863265E-02,   6.0945258E-02
     +,   6.8926178E-02,   7.7897437E-02,   8.7959886E-02
     +,   9.9229395E-02,   0.1118442    ,   0.1259759    
     +,   0.1418443    ,   0.1597351    ,   0.1800187    
     +,   0.2031614    ,   0.2297239    ,   0.2603365    
     +,   0.2956509    ,   0.3362858    ,   0.3827989    
     +,   0.4357387    ,   0.4957795    ,   0.5639386    
     +,   0.6417055    ,   0.7309672    ,   0.8335893    
     +,   0.9507754    ,    1.082469    ,    1.227163    
     +,    1.382245    ,    1.544586    ,    1.710814    
     +,    1.876931    ,    2.037598    ,    2.185959    
     +,    2.314749    ,    2.418146    ,    2.493213    
     +,    2.539633    ,    2.558074    ,    2.548405    
     +,    2.509143    ,    2.438621    ,    2.337334    
     +,    2.209963    ,    2.065612    ,    1.915692    
     +,    1.770453    ,    1.636083    ,    1.513996    
     +,    1.402402    ,    1.298996    ,    1.203059    
     +,    1.115960    ,    1.040063    ,   0.9770587    
     +,   0.9268334    ,   0.8874186    ,   0.8557847    
     +,   0.8288554    ,   0.8042367    ,   0.7804840    
     +,   0.7570152    ,   0.7338597    ,   0.7113971    
     +,   0.6901137    ,   0.6704375    ,   0.6526172    
     +,   0.6366763    ,   0.6224192    ,   0.6094867    
     +,   0.5974172    ,   0.5857212    ,   0.5739450    
     +,   0.5617206    ,   0.5488015    ,   0.5350751    
     +,   0.5205677    ,   0.5054188    ,   0.4898453    
     +,   0.4740980    ,   0.4584199    ,   0.4430088    
     +,   0.4279982    ,   0.4134507    ,   0.3993663    
     +,   0.3856975    ,   0.3723721    ,   0.3593152    
     +,   0.3464654    ,   0.3337865    ,   0.3212721    
     +,   0.3089458    ,   0.2968523    ,   0.2850516    
     +,   0.2736061    ,   0.2625762    ,   0.2520114    
     +,   0.2419491    ,   0.2324126    ,   0.2234136    
     +,   0.2149537    ,   0.2070291    ,   0.1996316    
     +,   0.1927522    ,   0.1863809    ,   0.1805081    
     +,   0.1751241    ,   0.1702180    ,   0.1657777    
     +,   0.1617878    ,   0.1582310    ,   0.1550857    
     +,   0.1523282    ,   0.1499309    ,   0.1478646    
     +,   0.1460974    ,   0.1445967    ,   0.1433288    
     +,   0.1422595    ,   0.1413554    ,   0.1405826    
     +,   0.1399093    ,   0.1393044    ,   0.1387388    
     +,   0.1381853    ,   0.1376193    ,   0.1370191    
     +,   0.1363663    ,   0.1356454    ,   0.1348447    
     +,   0.1339558    ,   0.1329740    ,   0.1318968    
     +,   0.1307252    ,   0.1294616    ,   0.1281101    
     +,   0.1266759    ,   0.1251640    ,   0.1235794    
     +,   0.1219261    ,   0.1202072    ,   0.1184241    
     +,   0.1165770    ,   0.1146645    ,   0.1126845    
     +,   0.1106340    ,   0.1085096    ,   0.1063085    
     +,   0.1040287    ,   0.1016694    ,   9.9231794E-02
     +,   9.6719541E-02,   9.4138786E-02,   9.1498107E-02
     +,   8.8809274E-02,   8.6086504E-02,   8.3346494E-02
     +,   8.0607727E-02,   7.7890597E-02,   7.5216547E-02
     +,   7.2607368E-02,   7.0084713E-02,   6.7669772E-02
     +,   6.5382645E-02,   6.3241445E-02,   6.1262347E-02
     +,   5.9459187E-02,   5.7843111E-02,   5.6422312E-02
     +,   5.5202004E-02,   5.4184634E-02,   5.3369597E-02
     +,   5.2753404E-02,   5.2330047E-02,   5.2091077E-02
     +,   5.2025679E-02,   5.2121095E-02,   5.2362818E-02
     +,   5.2734803E-02,   5.3219873E-02,   5.3799734E-02
     +,   5.4455452E-02,   5.5167537E-02,   5.5916328E-02
     +,   5.6682173E-02,   5.7445541E-02,   5.8187444E-02
     +,   5.8889501E-02,   5.9534267E-02,   6.0105171E-02
     +,   6.0587138E-02,   6.0966384E-02,   6.1230645E-02
     +,   6.1369494E-02,   6.1374202E-02,   6.1238013E-02
     +,   6.0956087E-02,   6.0525700E-02,   5.9945930E-02
     +,   5.9217945E-02,   5.8344815E-02,   5.7331335E-02
     +,   5.6184009E-02,   5.4910880E-02,   5.3521447E-02
     +,   5.2026156E-02,   5.0436512E-02,   4.8764788E-02
     +,   4.7023837E-02,   4.5226626E-02,   4.3386240E-02
     +,   4.1515753E-02,   3.9627906E-02,   3.7734840E-02
     +,   3.5848007E-02,   3.3978324E-02,   3.2135617E-02
     +,   3.0328710E-02,   2.8565599E-02,   2.6853139E-02
     +,   2.5197076E-02,   2.3602072E-02,   2.2071896E-02
     +,   2.0609325E-02,   1.9216150E-02,   1.7893307E-02
     +,   1.6641090E-02,   1.5459071E-02,   1.4346198E-02
     +,   1.3300891E-02,   1.2321276E-02,   1.1405037E-02
     +,   1.0549600E-02,   9.7522736E-03,   9.0102218E-03
     +,   8.3204946E-03,   7.6801241E-03,   7.0862104E-03
     +,   6.5358919E-03,   6.0263635E-03,   5.5549126E-03
     +,   5.1189847E-03,   4.7161430E-03,   4.3440573E-03
     +,   4.0005371E-03,   3.6835598E-03,   3.3911981E-03
     +,   3.1216624E-03,   2.8732971E-03,   2.6445636E-03
     +,   2.4340129E-03,   2.2403027E-03,   2.0621971E-03
     +,   1.8985458E-03,   1.7482677E-03,   1.6103579E-03
     +,   1.4838894E-03,   1.3679988E-03,   1.2618718E-03
     +,   1.1647500E-03,   1.0759364E-03,   9.9477021E-04
     +,   9.2063606E-04,   8.5296627E-04,   7.9122931E-04
     +,   7.3492702E-04,   6.8359618E-04,   6.3681032E-04
     +,   5.9417228E-04,   5.5531197E-04,   5.1988685E-04
     +,   4.8758433E-04,   4.5811129E-04,   4.3120276E-04
     +,   4.0661127E-04,   3.8411366E-04,   3.6350259E-04
     +,   3.4459180E-04,   3.2720942E-04,   3.1120132E-04
     +,   2.9642598E-04,   2.8275739E-04,   2.7008029E-04
     +,   2.5829158E-04,   2.4729921E-04,   2.3701979E-04
     +,   2.2737998E-04,   2.1831325E-04,   2.0976155E-04
     +,   2.0167236E-04,   1.9400018E-04,   1.8670403E-04
     +,   1.7974852E-04,   1.7310183E-04,   1.6673683E-04
     +,   1.6062905E-04,   1.5475778E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_ashz_htt60_mass = Yx/22.4129708510638
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_ashz_htt65_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.0861704E-02,   1.1953686E-02
     +,   1.3153557E-02,   1.4469442E-02,   1.5909407E-02
     +,   1.7481280E-02,   1.9192448E-02,   2.1049643E-02
     +,   2.3058573E-02,   2.5223909E-02,   2.7548723E-02
     +,   3.0034464E-02,   3.2680675E-02,   3.5485014E-02
     +,   3.8443197E-02,   4.1549325E-02,   4.4796374E-02
     +,   4.8176929E-02,   5.1684503E-02,   5.5315036E-02
     +,   5.9069268E-02,   6.2955134E-02,   6.6991165E-02
     +,   7.1210340E-02,   7.5663336E-02,   8.0423407E-02
     +,   8.5589387E-02,   9.1289021E-02,   9.7680748E-02
     +,   0.1049556    ,   0.1133378    ,   0.1230871    
     +,   0.1345035    ,   0.1479352    ,   0.1637886    
     +,   0.1825387    ,   0.2047285    ,   0.2309531    
     +,   0.2618180    ,   0.2978627    ,   0.3394739    
     +,   0.3867906    ,   0.4396588    ,   0.4976666    
     +,   0.5602881    ,   0.6271026    ,   0.6980125    
     +,   0.7733964    ,   0.8542581    ,   0.9424954    
     +,    1.041290    ,    1.155290    ,    1.290067    
     +,    1.450839    ,    1.640923    ,    1.860303    
     +,    2.103727    ,    2.358658    ,    2.605585    
     +,    2.823096    ,    2.995056    ,    3.113276    
     +,    3.174215    ,    3.177027    ,    3.127880    
     +,    3.044687    ,    2.952464    ,    2.870606    
     +,    2.803473    ,    2.742769    ,    2.678212    
     +,    2.606025    ,    2.528402    ,    2.446530    
     +,    2.354795    ,    2.242022    ,    2.098878    
     +,    1.925575    ,    1.734006    ,    1.543143    
     +,    1.371135    ,    1.229069    ,    1.119263    
     +,    1.037388    ,   0.9762203    ,   0.9286521    
     +,   0.8892422    ,   0.8544779    ,   0.8224443    
     +,   0.7922956    ,   0.7638038    ,   0.7370137    
     +,   0.7120101    ,   0.6887918    ,   0.6672227    
     +,   0.6470439    ,   0.6279075    ,   0.6094368    
     +,   0.5912746    ,   0.5731131    ,   0.5547076    
     +,   0.5358686    ,   0.5164512    ,   0.4963720    
     +,   0.4756212    ,   0.4543000    ,   0.4326347    
     +,   0.4109763    ,   0.3897617    ,   0.3694619    
     +,   0.3505197    ,   0.3332855    ,   0.3179857    
     +,   0.3047025    ,   0.2933862    ,   0.2838777    
     +,   0.2759438    ,   0.2693124    ,   0.2637035    
     +,   0.2588517    ,   0.2545223    ,   0.2505185    
     +,   0.2466844    ,   0.2429040    ,   0.2390957    
     +,   0.2352104    ,   0.2312238    ,   0.2271314    
     +,   0.2229434    ,   0.2186781    ,   0.2143578    
     +,   0.2100037    ,   0.2056322    ,   0.2012550    
     +,   0.1968754    ,   0.1924908    ,   0.1880945    
     +,   0.1836776    ,   0.1792313    ,   0.1747503    
     +,   0.1702344    ,   0.1656901    ,   0.1611302    
     +,   0.1565737    ,   0.1520445    ,   0.1475693    
     +,   0.1431754    ,   0.1388889    ,   0.1347333    
     +,   0.1307265    ,   0.1268812    ,   0.1232041    
     +,   0.1196964    ,   0.1163539    ,   0.1131679    
     +,   0.1101272    ,   0.1072187    ,   0.1044287    
     +,   0.1017442    ,   9.9154040E-02,   9.6649326E-02
     +,   9.4223969E-02,   9.1875412E-02,   8.9603923E-02
     +,   8.7412655E-02,   8.5307106E-02,   8.3295055E-02
     +,   8.1385083E-02,   7.9586364E-02,   7.7907816E-02
     +,   7.6357506E-02,   7.4941926E-02,   7.3665455E-02
     +,   7.2530083E-02,   7.1535066E-02,   7.0676841E-02
     +,   6.9948964E-02,   6.9342360E-02,   6.8845533E-02
     +,   6.8444729E-02,   6.8124585E-02,   6.7868426E-02
     +,   6.7658946E-02,   6.7478344E-02,   6.7309223E-02
     +,   6.7134760E-02,   6.6939138E-02,   6.6707976E-02
     +,   6.6428617E-02,   6.6090196E-02,   6.5683961E-02
     +,   6.5203160E-02,   6.4643197E-02,   6.4001419E-02
     +,   6.3277148E-02,   6.2471349E-02,   6.1586581E-02
     +,   6.0626745E-02,   5.9596714E-02,   5.8502238E-02
     +,   5.7349663E-02,   5.6145739E-02,   5.4897226E-02
     +,   5.3610951E-02,   5.2293595E-02,   5.0951373E-02
     +,   4.9590129E-02,   4.8215251E-02,   4.6831626E-02
     +,   4.5443464E-02,   4.4054538E-02,   4.2668037E-02
     +,   4.1286826E-02,   3.9913163E-02,   3.8549021E-02
     +,   3.7196107E-02,   3.5855956E-02,   3.4529794E-02
     +,   3.3218786E-02,   3.1924091E-02,   3.0646790E-02
     +,   2.9387912E-02,   2.8148610E-02,   2.6930086E-02
     +,   2.5733482E-02,   2.4559997E-02,   2.3410929E-02
     +,   2.2287585E-02,   2.1191183E-02,   2.0122962E-02
     +,   1.9084124E-02,   1.8075846E-02,   1.7099127E-02
     +,   1.6154870E-02,   1.5243934E-02,   1.4366949E-02
     +,   1.3524403E-02,   1.2716670E-02,   1.1943966E-02
     +,   1.1206289E-02,   1.0503481E-02,   9.8352600E-03
     +,   9.2012119E-03,   8.6007239E-03,   8.0330661E-03
     +,   7.4974336E-03,   6.9929026E-03,   6.5184436E-03
     +,   6.0729473E-03,   5.6552961E-03,   5.2642776E-03
     +,   4.8986552E-03,   4.5571970E-03,   4.2386665E-03
     +,   3.9418018E-03,   3.6653639E-03,   3.4081540E-03
     +,   3.1689999E-03,   2.9467493E-03,   2.7402933E-03
     +,   2.5485819E-03,   2.3706127E-03,   2.2054191E-03
     +,   2.0520890E-03,   1.9097790E-03,   1.7776783E-03
     +,   1.6550315E-03,   1.5411406E-03,   1.4353554E-03
     +,   1.3370650E-03,   1.2457037E-03,   1.1607544E-03
     +,   1.0817387E-03,   1.0082113E-03,   9.3976152E-04
     +,   8.7601860E-04,   8.1663270E-04,   7.6129066E-04
     +,   7.0969644E-04,   6.6158554E-04,   6.1670772E-04
     +,   5.7483901E-04,   5.3576712E-04,   4.9930240E-04
     +,   4.6526414E-04,   4.3349044E-04,   4.0382813E-04
     +,   3.7613561E-04,   3.5028419E-04,   3.2615106E-04
     +,   3.0362501E-04,   2.8259971E-04,   2.6297875E-04
     +,   2.4466985E-04,   2.2758880E-04,   2.1165497E-04
     +,   1.9679496E-04,   1.8293808E-04,   1.7001995E-04
     +,   1.5797863E-04,   1.4675759E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_ashz_htt65_mass = Yx/26.9406485833333
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_ashz_htt70_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.6590832E-03,   4.9342248E-03
     +,   5.2287346E-03,   5.5440925E-03,   5.8819056E-03
     +,   6.2439246E-03,   6.6320514E-03,   7.0483466E-03
     +,   7.4950480E-03,   7.9745976E-03,   8.4896125E-03
     +,   9.0429289E-03,   9.6375952E-03,   1.0276880E-02
     +,   1.0964285E-02,   1.1703532E-02,   1.2498584E-02
     +,   1.3353643E-02,   1.4273141E-02,   1.5261774E-02
     +,   1.6324501E-02,   1.7466558E-02,   1.8693490E-02
     +,   2.0011274E-02,   2.1426158E-02,   2.2945037E-02
     +,   2.4575273E-02,   2.6324937E-02,   2.8202903E-02
     +,   3.0218979E-02,   3.2384042E-02,   3.4710258E-02
     +,   3.7211187E-02,   3.9902080E-02,   4.2799961E-02
     +,   4.5923963E-02,   4.9295481E-02,   5.2938432E-02
     +,   5.6879900E-02,   6.1150081E-02,   6.5783978E-02
     +,   7.0822053E-02,   7.6312497E-02,   8.2313970E-02
     +,   8.8899054E-02,   9.6158728E-02,   0.1042064    
     +,   0.1131829    ,   0.1232591    ,   0.1346381    
     +,   0.1475559    ,   0.1622792    ,   0.1791039    
     +,   0.1983539    ,   0.2203748    ,   0.2455321    
     +,   0.2741931    ,   0.3067025    ,   0.3433399    
     +,   0.3842744    ,   0.4295374    ,   0.4790538    
     +,   0.5327517    ,   0.5907534    ,   0.6535559    
     +,   0.7220852    ,   0.7976187    ,   0.8816311    
     +,   0.9758577    ,    1.082543    ,    1.204678    
     +,    1.345628    ,    1.508048    ,    1.692005    
     +,    1.892923    ,    2.100569    ,    2.301253    
     +,    2.484030    ,    2.647810    ,    2.803438    
     +,    2.967242    ,    3.150160    ,    3.350428    
     +,    3.552892    ,    3.730628    ,    3.849245    
     +,    3.878331    ,    3.806359    ,    3.647043    
     +,    3.433053    ,    3.203416    ,    2.990161    
     +,    2.807488    ,    2.649621    ,    2.500256    
     +,    2.346445    ,    2.186175    ,    2.026822    
     +,    1.878430    ,    1.747803    ,    1.636321    
     +,    1.541138    ,    1.457510    ,    1.380742    
     +,    1.307150    ,    1.234189    ,    1.160300    
     +,    1.084952    ,    1.008914    ,   0.9343514    
     +,   0.8643332    ,   0.8018422    ,   0.7488226    
     +,   0.7056907    ,   0.6714699    ,   0.6443262    
     +,   0.6221992    ,   0.6032669    ,   0.5861698    
     +,   0.5700200    ,   0.5543059    ,   0.5387649    
     +,   0.5232726    ,   0.5077677    ,   0.4922055    
     +,   0.4765465    ,   0.4607581    ,   0.4448386    
     +,   0.4288380    ,   0.4128824    ,   0.3971696    
     +,   0.3819596    ,   0.3675332    ,   0.3541576    
     +,   0.3420384    ,   0.3312943    ,   0.3219392    
     +,   0.3138840    ,   0.3069527    ,   0.3009045    
     +,   0.2954670    ,   0.2903618    ,   0.2853300    
     +,   0.2801515    ,   0.2746583    ,   0.2687374    
     +,   0.2623309    ,   0.2554312    ,   0.2480713    
     +,   0.2403144    ,   0.2322437    ,   0.2239527    
     +,   0.2155371    ,   0.2070882    ,   0.1986880    
     +,   0.1904075    ,   0.1823058    ,   0.1744282    
     +,   0.1668074    ,   0.1594655    ,   0.1524134    
     +,   0.1456531    ,   0.1391808    ,   0.1329867    
     +,   0.1270584    ,   0.1213822    ,   0.1159462    
     +,   0.1107410    ,   0.1057609    ,   0.1010052    
     +,   9.6478850E-02,   9.2191190E-02,   8.8156126E-02
     +,   8.4390484E-02,   8.0913506E-02,   7.7744342E-02
     +,   7.4901193E-02,   7.2399721E-02,   7.0251763E-02
     +,   6.8464018E-02,   6.7037672E-02,   6.5967694E-02
     +,   6.5242834E-02,   6.4845465E-02,   6.4752251E-02
     +,   6.4934433E-02,   6.5358840E-02,   6.5988503E-02
     +,   6.6783838E-02,   6.7703530E-02,   6.8705596E-02
     +,   6.9748424E-02,   7.0791610E-02,   7.1796954E-02
     +,   7.2729245E-02,   7.3556915E-02,   7.4252486E-02
     +,   7.4793123E-02,   7.5160824E-02,   7.5342536E-02
     +,   7.5330123E-02,   7.5120181E-02,   7.4713752E-02
     +,   7.4115992E-02,   7.3335499E-02,   7.2383918E-02
     +,   7.1275182E-02,   7.0025019E-02,   6.8650410E-02
     +,   6.7168497E-02,   6.5596610E-02,   6.3951448E-02
     +,   6.2248841E-02,   6.0503263E-02,   5.8727525E-02
     +,   5.6932982E-02,   5.5129185E-02,   5.3323906E-02
     +,   5.1523224E-02,   4.9731947E-02,   4.7953431E-02
     +,   4.6189923E-02,   4.4442926E-02,   4.2713363E-02
     +,   4.1001655E-02,   3.9307993E-02,   3.7632778E-02
     +,   3.5976462E-02,   3.4339715E-02,   3.2723516E-02
     +,   3.1129330E-02,   2.9559020E-02,   2.8014712E-02
     +,   2.6498852E-02,   2.5014313E-02,   2.3563968E-02
     +,   2.2150820E-02,   2.0777963E-02,   1.9448398E-02
     +,   1.8164856E-02,   1.6929869E-02,   1.5745699E-02
     +,   1.4614289E-02,   1.3537056E-02,   1.2515041E-02
     +,   1.1548880E-02,   1.0638798E-02,   9.7845020E-03
     +,   8.9853201E-03,   8.2402695E-03,   7.5479574E-03
     +,   6.9066803E-03,   6.3145384E-03,   5.7694064E-03
     +,   5.2689514E-03,   4.8107267E-03,   4.3922393E-03
     +,   4.0109414E-03,   3.6642575E-03,   3.3496416E-03
     +,   3.0646203E-03,   2.8067916E-03,   2.5738322E-03
     +,   2.3635288E-03,   2.1738117E-03,   2.0027172E-03
     +,   1.8484152E-03,   1.7092245E-03,   1.5835913E-03
     +,   1.4700869E-03,   1.3674108E-03,   1.2743906E-03
     +,   1.1899688E-03,   1.1131892E-03,   1.0431973E-03
     +,   9.7923924E-04,   9.2063611E-04,   8.6679577E-04
     +,   8.1718859E-04,   7.7135465E-04,   7.2888494E-04
     +,   6.8942615E-04,   6.5266440E-04,   6.1833032E-04
     +,   5.8618456E-04,   5.5602175E-04,   5.2766048E-04
     +,   5.0094171E-04,   4.7572941E-04,   4.5190137E-04
     +,   4.2935257E-04,   4.0798786E-04,   3.8772600E-04
     +,   3.6849230E-04,   3.5022220E-04,   3.3285571E-04
     +,   3.1634085E-04,   3.0062848E-04,   2.8567566E-04
     +,   2.7144115E-04,   2.5788872E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_ashz_htt70_mass = Yx/30.1658471428571
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_ashz_htt75_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  5.0396128E-03,   5.2532824E-03
     +,   5.4742815E-03,   5.7026851E-03,   5.9385626E-03
     +,   6.1819851E-03,   6.4330227E-03,   6.6917525E-03
     +,   6.9582523E-03,   7.2326292E-03,   7.5149871E-03
     +,   7.8054518E-03,   8.1041763E-03,   8.4113376E-03
     +,   8.7271454E-03,   9.0518398E-03,   9.3857087E-03
     +,   9.7290808E-03,   1.0082339E-02,   1.0445909E-02
     +,   1.0820284E-02,   1.1206002E-02,   1.1603675E-02
     +,   1.2014002E-02,   1.2437688E-02,   1.2875567E-02
     +,   1.3328511E-02,   1.3797461E-02,   1.4283438E-02
     +,   1.4787519E-02,   1.5310868E-02,   1.5854709E-02
     +,   1.6420351E-02,   1.7009184E-02,   1.7622698E-02
     +,   1.8262483E-02,   1.8930273E-02,   1.9627962E-02
     +,   2.0357672E-02,   2.1121733E-02,   2.1922892E-02
     +,   2.2764277E-02,   2.3649601E-02,   2.4583295E-02
     +,   2.5570687E-02,   2.6618250E-02,   2.7733890E-02
     +,   2.8927227E-02,   3.0209990E-02,   3.1596366E-02
     +,   3.3103440E-02,   3.4751635E-02,   3.6565069E-02
     +,   3.8572107E-02,   4.0805407E-02,   4.3302603E-02
     +,   4.6106368E-02,   4.9264733E-02,   5.2831486E-02
     +,   5.6866456E-02,   6.1436307E-02,   6.6615514E-02
     +,   7.2487146E-02,   7.9145446E-02,   8.6697429E-02
     +,   9.5263906E-02,   0.1049825    ,   0.1160045    
     +,   0.1284947    ,   0.1426220    ,   0.1585540    
     +,   0.1764441    ,   0.1964296    ,   0.2186270    
     +,   0.2431442    ,   0.2700964    ,   0.2996278    
     +,   0.3319462    ,   0.3673694    ,   0.4063870    
     +,   0.4497119    ,   0.4983136    ,   0.5533163    
     +,   0.6157954    ,   0.6864709    ,   0.7655416    
     +,   0.8528280    ,   0.9483996    ,    1.053405    
     +,    1.170606    ,    1.303848    ,    1.456456    
     +,    1.629693    ,    1.823040    ,    2.036568    
     +,    2.272233    ,    2.529042    ,    2.792127    
     +,    3.028407    ,    3.203232    ,    3.310937    
     +,    3.387723    ,    3.486420    ,    3.632119    
     +,    3.801911    ,    3.949429    ,    4.045624    
     +,    4.091220    ,    4.093914    ,    4.041612    
     +,    3.907624    ,    3.688987    ,    3.429387    
     +,    3.190377    ,    3.005660    ,    2.868303    
     +,    2.750643    ,    2.627675    ,    2.487978    
     +,    2.332271    ,    2.166638    ,    1.997081    
     +,    1.828304    ,    1.665024    ,    1.512718    
     +,    1.376783    ,    1.261165    ,    1.167508    
     +,    1.094817    ,    1.039721    ,   0.9972387    
     +,   0.9619113    ,   0.9289424    ,   0.8950871    
     +,   0.8589914    ,   0.8209491    ,   0.7822234    
     +,   0.7442377    ,   0.7079802    ,   0.6737489    
     +,   0.6412269    ,   0.6097507    ,   0.5786121    
     +,   0.5473027    ,   0.5156428    ,   0.4837940    
     +,   0.4521999    ,   0.4214807    ,   0.3923056    
     +,   0.3652743    ,   0.3408272    ,   0.3191935    
     +,   0.3003808    ,   0.2841981    ,   0.2703129    
     +,   0.2583094    ,   0.2477470    ,   0.2382059    
     +,   0.2293186    ,   0.2207902    ,   0.2124027    
     +,   0.2040149    ,   0.1955577    ,   0.1870237    
     +,   0.1784565    ,   0.1699386    ,   0.1615810    
     +,   0.1535111    ,   0.1458621    ,   0.1387652    
     +,   0.1323431    ,   0.1267040    ,   0.1219375    
     +,   0.1181121    ,   0.1152735    ,   0.1134429    
     +,   0.1126161    ,   0.1127629    ,   0.1138272    
     +,   0.1157275    ,   0.1183577    ,   0.1215895    
     +,   0.1252749    ,   0.1292509    ,   0.1333440    
     +,   0.1373763    ,   0.1411720    ,   0.1445644    
     +,   0.1474029    ,   0.1495588    ,   0.1509312    
     +,   0.1514507    ,   0.1510820    ,   0.1498248    
     +,   0.1477117    ,   0.1448063    ,   0.1411978    
     +,   0.1369959    ,   0.1323237    ,   0.1273111    
     +,   0.1220884    ,   0.1167799    ,   0.1114987    
     +,   0.1063423    ,   0.1013905    ,   9.6703351E-02
     +,   9.2320912E-02,   8.8264681E-02,   8.4538952E-02
     +,   8.1133060E-02,   7.8024760E-02,   7.5182907E-02
     +,   7.2570994E-02,   7.0149153E-02,   6.7877337E-02
     +,   6.5717243E-02,   6.3634075E-02,   6.1597262E-02
     +,   5.9581615E-02,   5.7567641E-02,   5.5541329E-02
     +,   5.3493913E-02,   5.1421545E-02,   4.9324621E-02
     +,   4.7206786E-02,   4.5074470E-02,   4.2936224E-02
     +,   4.0801834E-02,   3.8681660E-02,   3.6586232E-02
     +,   3.4525853E-02,   3.2510128E-02,   3.0547675E-02
     +,   2.8645886E-02,   2.6811220E-02,   2.5048634E-02
     +,   2.3361837E-02,   2.1753501E-02,   2.0225158E-02
     +,   1.8777246E-02,   1.7409367E-02,   1.6120460E-02
     +,   1.4908846E-02,   1.3772278E-02,   1.2708148E-02
     +,   1.1713650E-02,   1.0785771E-02,   9.9213459E-03
     +,   9.1171563E-03,   8.3700642E-03,   7.6769018E-03
     +,   7.0345765E-03,   6.4401259E-03,   5.8906917E-03
     +,   5.3834934E-03,   4.9158689E-03,   4.4853096E-03
     +,   4.0894230E-03,   3.7259029E-03,   3.3925611E-03
     +,   3.0873399E-03,   2.8082842E-03,   2.5535186E-03
     +,   2.3212717E-03,   2.1098859E-03,   1.9177720E-03
     +,   1.7434326E-03,   1.5854652E-03,   1.4425503E-03
     +,   1.3134369E-03,   1.1969536E-03,   1.0920126E-03
     +,   9.9759630E-04,   9.1275113E-04,   8.3659159E-04
     +,   7.6830358E-04,   7.0712523E-04,   6.5236224E-04
     +,   6.0336816E-04,   5.5955612E-04,   5.2038260E-04
     +,   4.8535757E-04,   4.5402968E-04,   4.2599282E-04
     +,   4.0087590E-04,   3.7834674E-04,   3.5810409E-04
     +,   3.3987750E-04,   3.2342595E-04,   3.0853276E-04
     +,   2.9500635E-04,   2.8267506E-04,   2.7138853E-04
     +,   2.6101264E-04,   2.5143067E-04,   2.4253910E-04
     +,   2.3424855E-04,   2.2648026E-04,   2.1916667E-04
     +,   2.1224850E-04,   2.0567568E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_ashz_htt75_mass = Yx/33.18380044
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_ashz_htt80_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  5.2543022E-03,   5.3933724E-03
     +,   5.5342987E-03,   5.6771482E-03,   5.8219931E-03
     +,   5.9689283E-03,   6.1180615E-03,   6.2695201E-03
     +,   6.4234445E-03,   6.5800045E-03,   6.7393826E-03
     +,   6.9017811E-03,   7.0674242E-03,   7.2365599E-03
     +,   7.4094511E-03,   7.5863888E-03,   7.7676796E-03
     +,   7.9536522E-03,   8.1446497E-03,   8.3410377E-03
     +,   8.5432027E-03,   8.7515479E-03,   8.9664878E-03
     +,   9.1884695E-03,   9.4179437E-03,   9.6553955E-03
     +,   9.9013196E-03,   1.0156253E-02,   1.0420745E-02
     +,   1.0695397E-02,   1.0980841E-02,   1.1277764E-02
     +,   1.1586905E-02,   1.1909074E-02,   1.2245158E-02
     +,   1.2596129E-02,   1.2963060E-02,   1.3347116E-02
     +,   1.3749621E-02,   1.4171951E-02,   1.4615679E-02
     +,   1.5082465E-02,   1.5574103E-02,   1.6092492E-02
     +,   1.6639646E-02,   1.7217636E-02,   1.7828582E-02
     +,   1.8474625E-02,   1.9157860E-02,   1.9880289E-02
     +,   2.0643793E-02,   2.1450043E-02,   2.2300448E-02
     +,   2.3196148E-02,   2.4137866E-02,   2.5126012E-02
     +,   2.6160562E-02,   2.7241144E-02,   2.8367048E-02
     +,   2.9537337E-02,   3.0750999E-02,   3.2007176E-02
     +,   3.3305336E-02,   3.4645759E-02,   3.6029983E-02
     +,   3.7461076E-02,   3.8944647E-02,   4.0489230E-02
     +,   4.2107411E-02,   4.3816395E-02,   4.5639392E-02
     +,   4.7606096E-02,   4.9754202E-02,   5.2129619E-02
     +,   5.4787479E-02,   5.7792261E-02,   6.1217092E-02
     +,   6.5142855E-02,   6.9656834E-02,   7.4849531E-02
     +,   8.0810979E-02,   8.7627664E-02,   9.5376678E-02
     +,   0.1041236    ,   0.1139178    ,   0.1247942    
     +,   0.1367732    ,   0.1498696    ,   0.1640997    
     +,   0.1794970    ,   0.1961242    ,   0.2140836    
     +,   0.2335252    ,   0.2546498    ,   0.2777036    
     +,   0.3029734    ,   0.3307931    ,   0.3615492    
     +,   0.3957087    ,   0.4338359    ,   0.4766122    
     +,   0.5248175    ,   0.5792891    ,   0.6408312    
     +,   0.7101203    ,   0.7876291    ,   0.8736337    
     +,   0.9683912    ,    1.072443    ,    1.186923    
     +,    1.313717    ,    1.455471    ,    1.615384    
     +,    1.796758    ,    2.001330    ,    2.226551    
     +,    2.465020    ,    2.709694    ,    2.958285    
     +,    3.207832    ,    3.446574    ,    3.660312    
     +,    3.848990    ,    4.026698    ,    4.193432    
     +,    4.318449    ,    4.375717    ,    4.381964    
     +,    4.368320    ,    4.332433    ,    4.252023    
     +,    4.124274    ,    3.959963    ,    3.759381    
     +,    3.524715    ,    3.285881    ,    3.087923    
     +,    2.951706    ,    2.858470    ,    2.769032    
     +,    2.649816    ,    2.487272    ,    2.289840    
     +,    2.079843    ,    1.880435    ,    1.705460    
     +,    1.556997    ,    1.429652    ,    1.316778    
     +,    1.214078    ,    1.119577    ,    1.032138    
     +,   0.9506406    ,   0.8741211    ,   0.8021408    
     +,   0.7347883    ,   0.6723531    ,   0.6149542    
     +,   0.5623675    ,   0.5140883    ,   0.4695280    
     +,   0.4282216    ,   0.3899263    ,   0.3546035    
     +,   0.3223265    ,   0.2931857    ,   0.2672251    
     +,   0.2444160    ,   0.2246622    ,   0.2078231    
     +,   0.1937338    ,   0.1822161    ,   0.1730853    
     +,   0.1661507    ,   0.1612166    ,   0.1580791    
     +,   0.1565285    ,   0.1563498    ,   0.1573249    
     +,   0.1592347    ,   0.1618614    ,   0.1649907    
     +,   0.1684137    ,   0.1719312    ,   0.1753568    
     +,   0.1785208    ,   0.1812754    ,   0.1834994    
     +,   0.1851018    ,   0.1860238    ,   0.1862415    
     +,   0.1857629    ,   0.1846275    ,   0.1828994    
     +,   0.1806635    ,   0.1780165    ,   0.1750619    
     +,   0.1719006    ,   0.1686260    ,   0.1653182    
     +,   0.1620406    ,   0.1588372    ,   0.1557325    
     +,   0.1527321    ,   0.1498255    ,   0.1469881    
     +,   0.1441855    ,   0.1413772    ,   0.1385206    
     +,   0.1355733    ,   0.1324970    ,   0.1292596    
     +,   0.1258363    ,   0.1222111    ,   0.1183763    
     +,   0.1143336    ,   0.1100928    ,   0.1056708    
     +,   0.1010912    ,   9.6382894E-02,   9.1578633E-02
     +,   8.6713918E-02,   8.1826001E-02,   7.6952666E-02
     +,   7.2130635E-02,   6.7394778E-02,   6.2777676E-02
     +,   5.8308553E-02,   5.4012358E-02,   4.9909614E-02
     +,   4.6016537E-02,   4.2344734E-02,   3.8900897E-02
     +,   3.5687588E-02,   3.2703720E-02,   2.9944580E-02
     +,   2.7402660E-02,   2.5068304E-02,   2.2930218E-02
     +,   2.0975849E-02,   1.9191990E-02,   1.7565407E-02
     +,   1.6082993E-02,   1.4732004E-02,   1.3500372E-02
     +,   1.2376918E-02,   1.1351339E-02,   1.0414163E-02
     +,   9.5568569E-03,   8.7718461E-03,   8.0522746E-03
     +,   7.3920526E-03,   6.7858002E-03,   6.2287366E-03
     +,   5.7165571E-03,   5.2454313E-03,   4.8119542E-03
     +,   4.4130562E-03,   4.0459456E-03,   3.7080862E-03
     +,   3.3971947E-03,   3.1111783E-03,   2.8481008E-03
     +,   2.6061814E-03,   2.3838035E-03,   2.1794492E-03
     +,   1.9917197E-03,   1.8193297E-03,   1.6610896E-03
     +,   1.5158857E-03,   1.3826899E-03,   1.2605577E-03
     +,   1.1486142E-03,   1.0460434E-03,   9.5209177E-04
     +,   8.6607225E-04,   7.8733964E-04,   7.1530900E-04
     +,   6.4943160E-04,   5.8921095E-04,   5.3418177E-04
     +,   4.8392339E-04,   4.3804190E-04,   3.9618104E-04
     +,   3.5800791E-04,   3.2322097E-04,   2.9153962E-04
     +,   2.6270587E-04,   2.3648520E-04,   2.1265814E-04
     +,   1.9102599E-04,   1.7140292E-04,   1.5362028E-04
     +,   1.3752044E-04,   1.2296032E-04,   1.0980617E-04
     +,   9.7936441E-05,   8.7237626E-05,   7.7606586E-05
     +,   6.8947098E-05,   6.1171726E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_ashz_htt80_mass = Yx/34.99443556
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_ashz_htt85_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.4421214E-03,   4.5867441E-03
     +,   4.7334172E-03,   4.8820074E-03,   5.0323769E-03
     +,   5.1843836E-03,   5.3378739E-03,   5.4926919E-03
     +,   5.6486693E-03,   5.8056447E-03,   5.9634396E-03
     +,   6.1218832E-03,   6.2807938E-03,   6.4399936E-03
     +,   6.5993029E-03,   6.7585465E-03,   6.9175456E-03
     +,   7.0761321E-03,   7.2341394E-03,   7.3914113E-03
     +,   7.5478000E-03,   7.7031725E-03,   7.8574037E-03
     +,   8.0103977E-03,   8.1620570E-03,   8.3123362E-03
     +,   8.4611923E-03,   8.6086253E-03,   8.7546613E-03
     +,   8.8993721E-03,   9.0428703E-03,   9.1853170E-03
     +,   9.3269264E-03,   9.4679780E-03,   9.6088098E-03
     +,   9.7498400E-03,   9.8915668E-03,   1.0034565E-02
     +,   1.0179523E-02,   1.0327207E-02,   1.0478502E-02
     +,   1.0634411E-02,   1.0796042E-02,   1.0964630E-02
     +,   1.1141536E-02,   1.1328236E-02,   1.1526347E-02
     +,   1.1737578E-02,   1.1963775E-02,   1.2206873E-02
     +,   1.2468898E-02,   1.2751952E-02,   1.3058201E-02
     +,   1.3389842E-02,   1.3749077E-02,   1.4138112E-02
     +,   1.4559102E-02,   1.5014151E-02,   1.5505268E-02
     +,   1.6034352E-02,   1.6603177E-02,   1.7213393E-02
     +,   1.7866449E-02,   1.8563710E-02,   1.9306388E-02
     +,   2.0095512E-02,   2.0932131E-02,   2.1817114E-02
     +,   2.2751454E-02,   2.3736082E-02,   2.4772186E-02
     +,   2.5860999E-02,   2.7004212E-02,   2.8203726E-02
     +,   2.9461976E-02,   3.0781962E-02,   3.2167200E-02
     +,   3.3621818E-02,   3.5150740E-02,   3.6759645E-02
     +,   3.8454752E-02,   4.0243234E-02,   4.2132784E-02
     +,   4.4132009E-02,   4.6250034E-02,   4.8496950E-02
     +,   5.0883446E-02,   5.3421449E-02,   5.6123894E-02
     +,   5.9005357E-02,   6.2082570E-02,   6.5374486E-02
     +,   6.8903223E-02,   7.2694778E-02,   7.6779634E-02
     +,   8.1192806E-02,   8.5975155E-02,   9.1172807E-02
     +,   9.6838474E-02,   0.1030307    ,   0.1098163    
     +,   0.1172698    ,   0.1254780    ,   0.1345399    
     +,   0.1445712    ,   0.1557037    ,   0.1680822    
     +,   0.1818586    ,   0.1971837    ,   0.2141965    
     +,   0.2330176    ,   0.2537570    ,   0.2765256    
     +,   0.3014645    ,   0.3287659    ,   0.3586960    
     +,   0.3915943    ,   0.4278826    ,   0.4680720    
     +,   0.5128033    ,   0.5628827    ,   0.6192499    
     +,   0.6828431    ,   0.7543346    ,   0.8338396    
     +,   0.9207929    ,    1.014287    ,    1.113916    
     +,    1.220896    ,    1.338405    ,    1.470350    
     +,    1.618929    ,    1.783363    ,    1.961383    
     +,    2.153017    ,    2.364215    ,    2.607086    
     +,    2.890907    ,    3.202627    ,    3.496985    
     +,    3.726364    ,    3.893512    ,    4.051761    
     +,    4.234418    ,    4.420509    ,    4.593821    
     +,    4.774604    ,    4.948453    ,    5.036696    
     +,    4.997991    ,    4.883316    ,    4.743351    
     +,    4.563219    ,    4.314981    ,    4.005657    
     +,    3.665079    ,    3.330123    ,    3.037400    
     +,    2.802252    ,    2.605032    ,    2.411216    
     +,    2.204083    ,    1.992531    ,    1.792915    
     +,    1.611453    ,    1.443027    ,    1.280614    
     +,    1.122637    ,   0.9729325    ,   0.8366815    
     +,   0.7172718    ,   0.6157739    ,   0.5317646    
     +,   0.4640830    ,   0.4111461    ,   0.3710800    
     +,   0.3419016    ,   0.3217148    ,   0.3088468    
     +,   0.3018993    ,   0.2997248    ,   0.3013726    
     +,   0.3060263    ,   0.3129544    ,   0.3214773    
     +,   0.3309477    ,   0.3407435    ,   0.3502728    
     +,   0.3589854    ,   0.3663881    ,   0.3720683    
     +,   0.3757087    ,   0.3771069    ,   0.3761833    
     +,   0.3729860    ,   0.3676828    ,   0.3605475    
     +,   0.3519334    ,   0.3422431    ,   0.3318964    
     +,   0.3212954    ,   0.3107976    ,   0.3006909    
     +,   0.2911814    ,   0.2823883    ,   0.2743430    
     +,   0.2669988    ,   0.2602422    ,   0.2539104    
     +,   0.2478079    ,   0.2417251    ,   0.2354589    
     +,   0.2288285    ,   0.2216885    ,   0.2139413    
     +,   0.2055427    ,   0.1965024    ,   0.1868791    
     +,   0.1767733    ,   0.1663171    ,   0.1556591    
     +,   0.1449534    ,   0.1343493    ,   0.1239809    
     +,   0.1139609    ,   0.1043781    ,   9.5297374E-02
     +,   8.6760849E-02,   7.8789987E-02,   7.1390435E-02
     +,   6.4555675E-02,   5.8270369E-02,   5.2512772E-02
     +,   4.7257438E-02,   4.2477213E-02,   3.8143292E-02
     +,   3.4226388E-02,   3.0697336E-02,   2.7527025E-02
     +,   2.4686387E-02,   2.2146944E-02,   1.9881131E-02
     +,   1.7862361E-02,   1.6065145E-02,   1.4465556E-02
     +,   1.3041459E-02,   1.1772536E-02,   1.0640302E-02
     +,   9.6282111E-03,   8.7216916E-03,   7.9078721E-03
     +,   7.1755382E-03,   6.5150363E-03,   5.9180441E-03
     +,   5.3773751E-03,   4.8868614E-03,   4.4412315E-03
     +,   4.0359288E-03,   3.6669853E-03,   3.3309336E-03
     +,   3.0247523E-03,   2.7457608E-03,   2.4915501E-03
     +,   2.2599525E-03,   2.0490321E-03,   1.8570044E-03
     +,   1.6822427E-03,   1.5232674E-03,   1.3787203E-03
     +,   1.2473434E-03,   1.1279831E-03,   1.0195872E-03
     +,   9.2118909E-04,   8.3189638E-04,   7.5089303E-04
     +,   6.7743979E-04,   6.1085168E-04,   5.5051281E-04
     +,   4.9585319E-04,   4.4636056E-04,   4.0156205E-04
     +,   3.6103252E-04,   3.2438015E-04,   2.9125274E-04
     +,   2.6132536E-04,   2.3430584E-04,   2.0992557E-04
     +,   1.8793991E-04,   1.6812801E-04,   1.5028614E-04
     +,   1.3423091E-04,   1.1979303E-04,   1.0682027E-04
     +,   9.5172145E-05,   8.4722335E-05,   7.5354488E-05
     +,   6.6963898E-05,   5.9454367E-05,   5.2739390E-05
     +,   4.6739606E-05,   4.1383755E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_ashz_htt85_mass = Yx/36.4921214
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_ashz_htt90_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.2427677E-03,   2.3197168E-03
     +,   2.3995969E-03,   2.4825158E-03,   2.5685779E-03
     +,   2.6578868E-03,   2.7505439E-03,   2.8466422E-03
     +,   2.9462711E-03,   3.0495180E-03,   3.1564592E-03
     +,   3.2671627E-03,   3.3816884E-03,   3.5000867E-03
     +,   3.6223968E-03,   3.7486465E-03,   3.8788505E-03
     +,   4.0130117E-03,   4.1511185E-03,   4.2931465E-03
     +,   4.4390559E-03,   4.5887935E-03,   4.7422885E-03
     +,   4.8994659E-03,   5.0602220E-03,   5.2244556E-03
     +,   5.3920420E-03,   5.5628559E-03,   5.7367529E-03
     +,   5.9135915E-03,   6.0932171E-03,   6.2754769E-03
     +,   6.4602150E-03,   6.6472827E-03,   6.8365340E-03
     +,   7.0278370E-03,   7.2210683E-03,   7.4161249E-03
     +,   7.6129353E-03,   7.8114327E-03,   8.0116056E-03
     +,   8.2134670E-03,   8.4170736E-03,   8.6225234E-03
     +,   8.8299671E-03,   9.0396181E-03,   9.2517361E-03
     +,   9.4666453E-03,   9.6847443E-03,   9.9064913E-03
     +,   1.0132410E-02,   1.0363105E-02,   1.0599241E-02
     +,   1.0841571E-02,   1.1090886E-02,   1.1348071E-02
     +,   1.1614062E-02,   1.1889847E-02,   1.2176475E-02
     +,   1.2475037E-02,   1.2786665E-02,   1.3112541E-02
     +,   1.3453837E-02,   1.3811790E-02,   1.4187657E-02
     +,   1.4582671E-02,   1.4998141E-02,   1.5435328E-02
     +,   1.5895579E-02,   1.6380208E-02,   1.6890626E-02
     +,   1.7428214E-02,   1.7994491E-02,   1.8590974E-02
     +,   1.9219304E-02,   1.9881237E-02,   2.0578589E-02
     +,   2.1313302E-02,   2.2087464E-02,   2.2903323E-02
     +,   2.3763165E-02,   2.4669504E-02,   2.5624851E-02
     +,   2.6631951E-02,   2.7693519E-02,   2.8812492E-02
     +,   2.9991774E-02,   3.1234510E-02,   3.2543860E-02
     +,   3.3923231E-02,   3.5376359E-02,   3.6907159E-02
     +,   3.8519982E-02,   4.0219739E-02,   4.2012006E-02
     +,   4.3902762E-02,   4.5898892E-02,   4.8007630E-02
     +,   5.0236896E-02,   5.2594550E-02,   5.5088624E-02
     +,   5.7726134E-02,   6.0513299E-02,   6.3454092E-02
     +,   6.6550374E-02,   6.9800831E-02,   7.3200472E-02
     +,   7.6740481E-02,   8.0408685E-02,   8.4190026E-02
     +,   8.8066980E-02,   9.2022568E-02,   9.6041493E-02
     +,   0.1001146    ,   0.1042411    ,   0.1084346    
     +,   0.1127261    ,   0.1171702    ,   0.1218481    
     +,   0.1268722    ,   0.1323866    ,   0.1385657    
     +,   0.1456088    ,   0.1537313    ,   0.1631520    
     +,   0.1740753    ,   0.1866795    ,   0.2011013    
     +,   0.2174354    ,   0.2357381    ,   0.2560495    
     +,   0.2784228    ,   0.3029693    ,   0.3298877    
     +,   0.3594875    ,   0.3921555    ,   0.4282806    
     +,   0.4681413    ,   0.5118276    ,   0.5592505    
     +,   0.6102957    ,   0.6650885    ,   0.7242155    
     +,   0.7887229    ,   0.8598288    ,   0.9385213    
     +,    1.025350    ,    1.120686    ,    1.225238    
     +,    1.340185    ,    1.466466    ,    1.603835    
     +,    1.751176    ,    1.909279    ,    2.084826    
     +,    2.289990    ,    2.530372    ,    2.785843    
     +,    3.009573    ,    3.164553    ,    3.269624    
     +,    3.398540    ,    3.620762    ,    3.935395    
     +,    4.254799    ,    4.457547    ,    4.474102    
     +,    4.322373    ,    4.060927    ,    3.732310    
     +,    3.362085    ,    2.982144    ,    2.629359    
     +,    2.329500    ,    2.091552    ,    1.910863    
     +,    1.775269    ,    1.674296    ,    1.607092    
     +,    1.581313    ,    1.603125    ,    1.667495    
     +,    1.757304    ,    1.851217    ,    1.932440    
     +,    1.991382    ,    2.022595    ,    2.021621    
     +,    1.985628    ,    1.916736    ,    1.823906    
     +,    1.720567    ,    1.618968    ,    1.525531    
     +,    1.440488    ,    1.361183    ,    1.285455    
     +,    1.212625    ,    1.142614    ,    1.074971    
     +,    1.008773    ,   0.9431468    ,   0.8777332    
     +,   0.8128213    ,   0.7491950    ,   0.6878577    
     +,   0.6298013    ,   0.5758666    ,   0.5266556    
     +,   0.4824979    ,   0.4434430    ,   0.4092721    
     +,   0.3795320    ,   0.3535979    ,   0.3307654    
     +,   0.3103378    ,   0.2916958    ,   0.2743359    
     +,   0.2578812    ,   0.2420701    ,   0.2267302    
     +,   0.2117572    ,   0.1970984    ,   0.1827395    
     +,   0.1686969    ,   0.1550125    ,   0.1417486    
     +,   0.1289799    ,   0.1167846    ,   0.1052378    
     +,   9.4405428E-02,   8.4338419E-02,   7.5068995E-02
     +,   6.6610262E-02,   5.8957674E-02,   5.2089095E-02
     +,   4.5968518E-02,   4.0549465E-02,   3.5777945E-02
     +,   3.1595189E-02,   2.7940935E-02,   2.4755886E-02
     +,   2.1983191E-02,   1.9569632E-02,   1.7466662E-02
     +,   1.5630936E-02,   1.4024207E-02,   1.2613091E-02
     +,   1.1368925E-02,   1.0267416E-02,   9.2879292E-03
     +,   8.4131565E-03,   7.6286942E-03,   6.9225328E-03
     +,   6.2846369E-03,   5.7066530E-03,   5.1816492E-03
     +,   4.7038062E-03,   4.2681927E-03,   3.8706185E-03
     +,   3.5075184E-03,   3.1758023E-03,   2.8727429E-03
     +,   2.5959329E-03,   2.3432442E-03,   2.1127337E-03
     +,   1.9026344E-03,   1.7113428E-03,   1.5373789E-03
     +,   1.3793630E-03,   1.2360150E-03,   1.1061546E-03
     +,   9.8868122E-04,   8.8256120E-04,   7.8683335E-04
     +,   7.0061168E-04,   6.2306062E-04,   5.5341492E-04
     +,   4.9095537E-04,   4.3502499E-04,   3.8500931E-04
     +,   3.4034849E-04,   3.0052188E-04,   2.6505659E-04
     +,   2.3351508E-04,   2.0550154E-04,   1.8065218E-04
     +,   1.5863638E-04,   1.3915602E-04,   1.2193851E-04
     +,   1.0673957E-04,   9.3336981E-05,   8.1532329E-05
     +,   7.1145776E-05,   6.2017360E-05,   5.4002659E-05
     +,   4.6973659E-05,   4.0815099E-05,   3.5425164E-05
     +,   3.0712494E-05,   2.6596568E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_ashz_htt90_mass = Yx/34.60324896
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_ashz_htt95_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.6353953E-03,   3.7493361E-03
     +,   3.8654692E-03,   3.9837267E-03,   4.1040382E-03
     +,   4.2263214E-03,   4.3504895E-03,   4.4764476E-03
     +,   4.6040928E-03,   4.7333245E-03,   4.8640282E-03
     +,   4.9960883E-03,   5.1293843E-03,   5.2637942E-03
     +,   5.3991931E-03,   5.5354545E-03,   5.6724506E-03
     +,   5.8100582E-03,   5.9481515E-03,   6.0866089E-03
     +,   6.2253117E-03,   6.3641486E-03,   6.5030092E-03
     +,   6.6417987E-03,   6.7804153E-03,   6.9187819E-03
     +,   7.0568216E-03,   7.1944674E-03,   7.3316642E-03
     +,   7.4683721E-03,   7.6045562E-03,   7.7402014E-03
     +,   7.8752954E-03,   8.0098473E-03,   8.1438767E-03
     +,   8.2774106E-03,   8.4104957E-03,   8.5431868E-03
     +,   8.6755557E-03,   8.8076768E-03,   8.9396508E-03
     +,   9.0715727E-03,   9.2035607E-03,   9.3357377E-03
     +,   9.4682407E-03,   9.6012112E-03,   9.7348038E-03
     +,   9.8691816E-03,   1.0004527E-02,   1.0141013E-02
     +,   1.0278839E-02,   1.0418209E-02,   1.0559345E-02
     +,   1.0702481E-02,   1.0847854E-02,   1.0995746E-02
     +,   1.1146437E-02,   1.1300234E-02,   1.1457486E-02
     +,   1.1618555E-02,   1.1783855E-02,   1.1953842E-02
     +,   1.2129005E-02,   1.2309913E-02,   1.2497194E-02
     +,   1.2691526E-02,   1.2893701E-02,   1.3104572E-02
     +,   1.3325118E-02,   1.3556394E-02,   1.3799606E-02
     +,   1.4056041E-02,   1.4327168E-02,   1.4614533E-02
     +,   1.4919847E-02,   1.5244963E-02,   1.5591838E-02
     +,   1.5962541E-02,   1.6359279E-02,   1.6784333E-02
     +,   1.7240006E-02,   1.7728698E-02,   1.8252729E-02
     +,   1.8814409E-02,   1.9415919E-02,   2.0059319E-02
     +,   2.0746375E-02,   2.1478651E-02,   2.2257291E-02
     +,   2.3083067E-02,   2.3956275E-02,   2.4876626E-02
     +,   2.5843251E-02,   2.6854688E-02,   2.7908828E-02
     +,   2.9002801E-02,   3.0133195E-02,   3.1295862E-02
     +,   3.2486189E-02,   3.3698954E-02,   3.4928706E-02
     +,   3.6169581E-02,   3.7415799E-02,   3.8661495E-02
     +,   3.9901320E-02,   4.1130345E-02,   4.2344399E-02
     +,   4.3540269E-02,   4.4716079E-02,   4.5871343E-02
     +,   4.7007151E-02,   4.8126481E-02,   4.9234118E-02
     +,   5.0336927E-02,   5.1443625E-02,   5.2565053E-02
     +,   5.3713709E-02,   5.4904036E-02,   5.6151833E-02
     +,   5.7474367E-02,   5.8890175E-02,   6.0418691E-02
     +,   6.2080309E-02,   6.3896522E-02,   6.5889776E-02
     +,   6.8083800E-02,   7.0504062E-02,   7.3177971E-02
     +,   7.6136328E-02,   7.9413049E-02,   8.3047628E-02
     +,   8.7084994E-02,   9.1578297E-02,   9.6589163E-02
     +,   0.1021905    ,   0.1084672    ,   0.1155166    
     +,   0.1234485    ,   0.1323835    ,   0.1424478    
     +,   0.1537648    ,   0.1664428    ,   0.1805604    
     +,   0.1961466    ,   0.2131595    ,   0.2314728    
     +,   0.2508653    ,   0.2710251    ,   0.2915720    
     +,   0.3120989    ,   0.3322250    ,   0.3516515    
     +,   0.3702158    ,   0.3879236    ,   0.4049492    
     +,   0.4216030    ,   0.4382718    ,   0.4553402    
     +,   0.4731015    ,   0.4916864    ,   0.5110104    
     +,   0.5307642    ,   0.5504278    ,   0.5693312    
     +,   0.5867216    ,   0.6018284    ,   0.6139240    
     +,   0.6223823    ,   0.6267725    ,   0.6270202    
     +,   0.6236726    ,   0.6182538    ,   0.6135768    
     +,   0.6138554    ,   0.6243597    ,   0.6505855    
     +,   0.6971905    ,   0.7672626    ,   0.8623003    
     +,   0.9826100    ,    1.127544    ,    1.296442    
     +,    1.492050    ,    1.724331    ,    2.007598    
     +,    2.351145    ,    2.755214    ,    3.211974    
     +,    3.696127    ,    4.157065    ,    4.541373    
     +,    4.832256    ,    5.056920    ,    5.237919    
     +,    5.348112    ,    5.335279    ,    5.176007    
     +,    4.899137    ,    4.569355    ,    4.250159    
     +,    3.975058    ,    3.739269    ,    3.522879    
     +,    3.325452    ,    3.159180    ,    3.020479    
     +,    2.888335    ,    2.734097    ,    2.530278    
     +,    2.271108    ,    1.986145    ,    1.721928    
     +,    1.510005    ,    1.354157    ,    1.240372    
     +,    1.151655    ,    1.075477    ,    1.004219    
     +,   0.9334098    ,   0.8605407    ,   0.7847360    
     +,   0.7065940    ,   0.6277989    ,   0.5505402    
     +,   0.4769762    ,   0.4088840    ,   0.3474844    
     +,   0.2933888    ,   0.2466415    ,   0.2068414    
     +,   0.1733005    ,   0.1451993    ,   0.1217129    
     +,   0.1020925    ,   8.5699528E-02,   7.2002351E-02
     +,   6.0563803E-02,   5.1023301E-02,   4.3079965E-02
     +,   3.6480006E-02,   3.1008262E-02,   2.6481496E-02
     +,   2.2742651E-02,   1.9656653E-02,   1.7107826E-02
     +,   1.4997757E-02,   1.3243377E-02,   1.1775319E-02
     +,   1.0536663E-02,   9.4814990E-03,   8.5731614E-03
     +,   7.7828793E-03,   7.0883716E-03,   6.4725019E-03
     +,   5.9221303E-03,   5.4272171E-03,   4.9800752E-03
     +,   4.5747375E-03,   4.2064567E-03,   3.8713915E-03
     +,   3.5663666E-03,   3.2886541E-03,   3.0358394E-03
     +,   2.8057501E-03,   2.5964200E-03,   2.4060071E-03
     +,   2.2328016E-03,   2.0752198E-03,   1.9317875E-03
     +,   1.8011280E-03,   1.6819725E-03,   1.5731644E-03
     +,   1.4736480E-03,   1.3824600E-03,   1.2987333E-03
     +,   1.2216982E-03,   1.1506593E-03,   1.0850078E-03
     +,   1.0241973E-03,   9.6775399E-04,   9.1525371E-04
     +,   8.6633040E-04,   8.2065578E-04,   7.7794725E-04
     +,   7.3795021E-04,   7.0044439E-04,   6.6523097E-04
     +,   6.3213304E-04,   6.0099480E-04,   5.7167263E-04
     +,   5.4404006E-04,   5.1797862E-04,   4.9338344E-04
     +,   4.7015533E-04,   4.4820562E-04,   4.2744994E-04
     +,   4.0781248E-04,   3.8922066E-04,   3.7160912E-04
     +,   3.5491481E-04,   3.3908131E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_ashz_htt95_mass = Yx/34.11147152
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_ashz_ttz100_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.2756020E-03,   1.3402060E-03
     +,   1.4068884E-03,   1.4756345E-03,   1.5464245E-03
     +,   1.6192310E-03,   1.6940208E-03,   1.7707533E-03
     +,   1.8493810E-03,   1.9298522E-03,   2.0121054E-03
     +,   2.0960730E-03,   2.1816804E-03,   2.2688473E-03
     +,   2.3574857E-03,   2.4475032E-03,   2.5387995E-03
     +,   2.6312701E-03,   2.7248054E-03,   2.8192906E-03
     +,   2.9146075E-03,   3.0106343E-03,   3.1072458E-03
     +,   3.2043210E-03,   3.3017274E-03,   3.3993435E-03
     +,   3.4970436E-03,   3.5947065E-03,   3.6922137E-03
     +,   3.7894540E-03,   3.8863225E-03,   3.9827209E-03
     +,   4.0785642E-03,   4.1737771E-03,   4.2682984E-03
     +,   4.3620830E-03,   4.4551026E-03,   4.5473473E-03
     +,   4.6388335E-03,   4.7295913E-03,   4.8196861E-03
     +,   4.9092029E-03,   4.9982588E-03,   5.0869975E-03
     +,   5.1755989E-03,   5.2642711E-03,   5.3532594E-03
     +,   5.4428405E-03,   5.5333283E-03,   5.6250696E-03
     +,   5.7184435E-03,   5.8138664E-03,   5.9117815E-03
     +,   6.0126670E-03,   6.1170184E-03,   6.2253657E-03
     +,   6.3382485E-03,   6.4562270E-03,   6.5798666E-03
     +,   6.7097340E-03,   6.8463963E-03,   6.9904104E-03
     +,   7.1423016E-03,   7.3025799E-03,   7.4717212E-03
     +,   7.6501356E-03,   7.8382045E-03,   8.0362186E-03
     +,   8.2444185E-03,   8.4629366E-03,   8.6918417E-03
     +,   8.9310780E-03,   9.1805104E-03,   9.4398577E-03
     +,   9.7087594E-03,   9.9867266E-03,   1.0273134E-02
     +,   1.0567239E-02,   1.0868205E-02,   1.1175075E-02
     +,   1.1486761E-02,   1.1802116E-02,   1.2119869E-02
     +,   1.2438714E-02,   1.2757238E-02,   1.3074039E-02
     +,   1.3387629E-02,   1.3696568E-02,   1.3999386E-02
     +,   1.4294668E-02,   1.4581063E-02,   1.4857262E-02
     +,   1.5122063E-02,   1.5374394E-02,   1.5613316E-02
     +,   1.5838014E-02,   1.6047880E-02,   1.6242461E-02
     +,   1.6421529E-02,   1.6585039E-02,   1.6733209E-02
     +,   1.6866442E-02,   1.6985431E-02,   1.7091092E-02
     +,   1.7184611E-02,   1.7267460E-02,   1.7341379E-02
     +,   1.7408412E-02,   1.7470915E-02,   1.7531579E-02
     +,   1.7593445E-02,   1.7659938E-02,   1.7734880E-02
     +,   1.7822538E-02,   1.7927639E-02,   1.8055422E-02
     +,   1.8211639E-02,   1.8402608E-02,   1.8635184E-02
     +,   1.8916801E-02,   1.9255443E-02,   1.9659547E-02
     +,   2.0137945E-02,   2.0699807E-02,   2.1354390E-02
     +,   2.2110837E-02,   2.2978015E-02,   2.3963997E-02
     +,   2.5075993E-02,   2.6319649E-02,   2.7698943E-02
     +,   2.9215464E-02,   3.0868307E-02,   3.2653350E-02
     +,   3.4563325E-02,   3.6587477E-02,   3.8711287E-02
     +,   4.0916674E-02,   4.3182395E-02,   4.5484230E-02
     +,   4.7795419E-02,   5.0087471E-02,   5.2331157E-02
     +,   5.4497343E-02,   5.6557547E-02,   5.8485582E-02
     +,   6.0258012E-02,   6.1855011E-02,   6.3260972E-02
     +,   6.4465232E-02,   6.5461963E-02,   6.6250347E-02
     +,   6.6834226E-02,   6.7221932E-02,   6.7425668E-02
     +,   6.7460582E-02,   6.7344472E-02,   6.7096949E-02
     +,   6.6738755E-02,   6.6291466E-02,   6.5777108E-02
     +,   6.5217867E-02,   6.4636283E-02,   6.4055361E-02
     +,   6.3498706E-02,   6.2991008E-02,   6.2558249E-02
     +,   6.2228229E-02,   6.2030546E-02,   6.1997063E-02
     +,   6.2161975E-02,   6.2561944E-02,   6.3236453E-02
     +,   6.4228393E-02,   6.5584294E-02,   6.7355491E-02
     +,   6.9598742E-02,   7.2376333E-02,   7.5755782E-02
     +,   7.9808585E-02,   8.4608190E-02,   9.0226993E-02
     +,   9.6735492E-02,   0.1042049    ,   0.1127157    
     +,   0.1223756    ,   0.1333496    ,   0.1459004    
     +,   0.1604279    ,   0.1774853    ,   0.1977524    
     +,   0.2219291    ,   0.2505546    ,   0.2837933    
     +,   0.3212679    ,   0.3620352    ,   0.4047788    
     +,   0.4482386    ,   0.4917664    ,   0.5357899    
     +,   0.5818994    ,   0.6323944    ,   0.6893697    
     +,   0.7537752    ,   0.8249971    ,   0.9014008    
     +,   0.9817078    ,    1.066393    ,    1.157767    
     +,    1.258147    ,    1.367350    ,    1.481858    
     +,    1.596299    ,    1.704960    ,    1.801299    
     +,    1.876886    ,    1.922246    ,    1.929154    
     +,    1.892829    ,    1.814388    ,    1.702879    
     +,    1.573748    ,    1.442161    ,    1.315440    
     +,    1.190913    ,    1.061202    ,   0.9223390    
     +,   0.7781641    ,   0.6383374    ,   0.5127900    
     +,   0.4072534    ,   0.3222642    ,   0.2549257    
     +,   0.2013417    ,   0.1581994    ,   0.1232121    
     +,   9.4910063E-02,   7.2279900E-02,   5.4506589E-02
     +,   4.0852536E-02,   3.0618338E-02,   2.3140039E-02
     +,   1.7802944E-02,   1.4062840E-02,   1.1464382E-02
     +,   9.6486611E-03,   8.3489800E-03,   7.3783072E-03
     +,   6.6128178E-03,   5.9751645E-03,   5.4198052E-03
     +,   4.9217180E-03,   4.4681723E-03,   4.0531182E-03
     +,   3.6736652E-03,   3.3280877E-03,   3.0148132E-03
     +,   2.7319796E-03,   2.4773441E-03,   2.2484029E-03
     +,   2.0425518E-03,   1.8572150E-03,   1.6899526E-03
     +,   1.5385526E-03,   1.4010814E-03,   1.2758635E-03
     +,   1.1614840E-03,   1.0567696E-03,   9.6074393E-04
     +,   8.7258889E-04,   7.9161784E-04,   7.1725156E-04
     +,   6.4898690E-04,   5.8637350E-04,   5.2900560E-04
     +,   4.7651542E-04,   4.2855364E-04,   3.8479874E-04
     +,   3.4494099E-04,   3.0869307E-04,   2.7577823E-04
     +,   2.4593974E-04,   2.1893176E-04,   1.9452743E-04
     +,   1.7251086E-04,   1.5268358E-04,   1.3485883E-04
     +,   1.1886306E-04,   1.0453691E-04,   9.1730821E-05
     +,   8.0308018E-05,   7.0140588E-05,   6.1111648E-05
     +,   5.3112097E-05,   4.6042427E-05,   3.9809962E-05
     +,   3.4330336E-05,   2.9525258E-05,   2.5323629E-05
     +,   2.1659833E-05,   1.8474426E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_ashz_ttz100_mass = Yx/11.256594
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_ashz_ttz105_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.3838836E-03,   1.4310317E-03
     +,   1.4801291E-03,   1.5312486E-03,   1.5844669E-03
     +,   1.6398635E-03,   1.6975213E-03,   1.7575287E-03
     +,   1.8199779E-03,   1.8849701E-03,   1.9526094E-03
     +,   2.0230094E-03,   2.0962916E-03,   2.1725872E-03
     +,   2.2520393E-03,   2.3348003E-03,   2.4210380E-03
     +,   2.5109330E-03,   2.6046811E-03,   2.7024949E-03
     +,   2.8046046E-03,   2.9112587E-03,   3.0227241E-03
     +,   3.1392949E-03,   3.2612716E-03,   3.3889909E-03
     +,   3.5227998E-03,   3.6630705E-03,   3.8101964E-03
     +,   3.9645843E-03,   4.1266638E-03,   4.2968760E-03
     +,   4.4756769E-03,   4.6635289E-03,   4.8609036E-03
     +,   5.0682677E-03,   5.2860924E-03,   5.5148299E-03
     +,   5.7549318E-03,   6.0068057E-03,   6.2708519E-03
     +,   6.5474212E-03,   6.8368269E-03,   7.1393228E-03
     +,   7.4551078E-03,   7.7843098E-03,   8.1269834E-03
     +,   8.4830923E-03,   8.8525126E-03,   9.2350198E-03
     +,   9.6302899E-03,   1.0037879E-02,   1.0457232E-02
     +,   1.0887695E-02,   1.1328453E-02,   1.1778618E-02
     +,   1.2237152E-02,   1.2702907E-02,   1.3174633E-02
     +,   1.3650959E-02,   1.4130425E-02,   1.4611489E-02
     +,   1.5092492E-02,   1.5571749E-02,   1.6047526E-02
     +,   1.6518001E-02,   1.6981393E-02,   1.7435858E-02
     +,   1.7879624E-02,   1.8310891E-02,   1.8727973E-02
     +,   1.9129198E-02,   1.9513041E-02,   1.9878047E-02
     +,   2.0222917E-02,   2.0546522E-02,   2.0847885E-02
     +,   2.1126188E-02,   2.1380894E-02,   2.1611672E-02
     +,   2.1818401E-02,   2.2001266E-02,   2.2160709E-02
     +,   2.2297481E-02,   2.2412613E-02,   2.2507494E-02
     +,   2.2583812E-02,   2.2643633E-02,   2.2689367E-02
     +,   2.2723798E-02,   2.2750104E-02,   2.2771847E-02
     +,   2.2792991E-02,   2.2817921E-02,   2.2851462E-02
     +,   2.2898834E-02,   2.2965694E-02,   2.3058107E-02
     +,   2.3182573E-02,   2.3345940E-02,   2.3555435E-02
     +,   2.3818560E-02,   2.4143117E-02,   2.4537019E-02
     +,   2.5008310E-02,   2.5565000E-02,   2.6214924E-02
     +,   2.6965603E-02,   2.7824108E-02,   2.8796908E-02
     +,   2.9889530E-02,   3.1106619E-02,   3.2451455E-02
     +,   3.3926025E-02,   3.5530567E-02,   3.7263744E-02
     +,   3.9122123E-02,   4.1100390E-02,   4.3190986E-02
     +,   4.5384347E-02,   4.7668800E-02,   5.0030429E-02
     +,   5.2453429E-02,   5.4920226E-02,   5.7411704E-02
     +,   5.9907179E-02,   6.2385164E-02,   6.4823203E-02
     +,   6.7198798E-02,   6.9489136E-02,   7.1672283E-02
     +,   7.3726848E-02,   7.5633004E-02,   7.7372514E-02
     +,   7.8929320E-02,   8.0289856E-02,   8.1443258E-02
     +,   8.2381651E-02,   8.3100334E-02,   8.3597824E-02
     +,   8.3875924E-02,   8.3939455E-02,   8.3796278E-02
     +,   8.3456837E-02,   8.2933955E-02,   8.2242385E-02
     +,   8.1398308E-02,   8.0419041E-02,   7.9322346E-02
     +,   7.8126170E-02,   7.6848052E-02,   7.5504929E-02
     +,   7.4112929E-02,   7.2686851E-02,   7.1240291E-02
     +,   6.9785699E-02,   6.8334274E-02,   6.6896215E-02
     +,   6.5480761E-02,   6.4096734E-02,   6.2752612E-02
     +,   6.1456896E-02,   6.0218349E-02,   5.9046455E-02
     +,   5.7951301E-02,   5.6943994E-02,   5.6036796E-02
     +,   5.5243116E-02,   5.4577384E-02,   5.4055221E-02
     +,   5.3693250E-02,   5.3508926E-02,   5.3520560E-02
     +,   5.3747062E-02,   5.4207854E-02,   5.4922823E-02
     +,   5.5912383E-02,   5.7197273E-02,   5.8798794E-02
     +,   6.0739107E-02,   6.3041449E-02,   6.5730236E-02
     +,   6.8831600E-02,   7.2373837E-02,   7.6387241E-02
     +,   8.0903657E-02,   8.5955791E-02,   9.1575831E-02
     +,   9.7793847E-02,   0.1046346    ,   0.1121178    
     +,   0.1202564    ,   0.1290579    ,   0.1385277    
     +,   0.1486747    ,   0.1595152    ,   0.1710755    
     +,   0.1833917    ,   0.1965059    ,   0.2104557    
     +,   0.2252603    ,   0.2409079    ,   0.2573445    
     +,   0.2744663    ,   0.2921169    ,   0.3101023    
     +,   0.3282166    ,   0.3462825    ,   0.3642023    
     +,   0.3820038    ,   0.3998643    ,   0.4181194    
     +,   0.4372789    ,   0.4580815    ,   0.4816015    
     +,   0.5093608    ,   0.5433550    ,   0.5858657    
     +,   0.6390060    ,   0.7040775    ,   0.7809616    
     +,   0.8677430    ,   0.9607110    ,    1.054707    
     +,    1.143688    ,    1.221326    ,    1.281590    
     +,    1.319263    ,    1.330376    ,    1.312529    
     +,    1.265144    ,    1.189694    ,    1.089829    
     +,   0.9712994    ,   0.8414946    ,   0.7085201    
     +,   0.5800640    ,   0.4623566    ,   0.3595048    
     +,   0.2733620    ,   0.2038637    ,   0.1496044    
     +,   0.1084371    ,   7.7969350E-02,   5.5902842E-02
     +,   4.0217128E-02,   2.9239552E-02,   2.1647351E-02
     +,   1.6433556E-02,   1.2855380E-02,   1.0378926E-02
     +,   8.6301649E-03,   7.3530376E-03,   6.3762660E-03
     +,   5.5883233E-03,   4.9191359E-03,   4.3268562E-03
     +,   3.7882833E-03,   3.2920861E-03,   2.8340297E-03
     +,   2.4136682E-03,   2.0320599E-03,   1.6903300E-03
     +,   1.3889170E-03,   1.1272570E-03,   9.0368837E-04
     +,   7.1564229E-04,   5.5989338E-04,   4.3281302E-04
     +,   3.3061515E-04,   2.4957766E-04,   1.8619942E-04
     +,   1.3729636E-04,   1.0005648E-04,   7.2064831E-05
     +,   5.1296171E-05,   3.6082401E-05,   2.5080586E-05
     +,   1.7225617E-05,   1.1689507E-05,   7.8376015E-06
     +,   5.1923234E-06,   3.3991553E-06,   2.1995352E-06
     +,   1.4074365E-06,   8.9128952E-07,   5.5931810E-07
     +,   3.4854082E-07,   2.1640047E-07,   1.3454741E-07
     +,   8.4408768E-08,   5.3986916E-08,   3.5658015E-08
     +,   2.4645423E-08,   1.8004529E-08,   1.3945232E-08
     +,   1.1396420E-08,   9.7257082E-09,   8.5653067E-09
     +,   7.7038012E-09,   7.0212467E-09
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_ashz_ttz105_mass = Yx/8.45072097560976
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_ashz_ttz107_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.9301899E-03,   1.9636960E-03
     +,   1.9974795E-03,   2.0315489E-03,   2.0659196E-03
     +,   2.1006085E-03,   2.1356377E-03,   2.1710345E-03
     +,   2.2068305E-03,   2.2430671E-03,   2.2797910E-03
     +,   2.3170589E-03,   2.3549367E-03,   2.3935023E-03
     +,   2.4328465E-03,   2.4730728E-03,   2.5143032E-03
     +,   2.5566742E-03,   2.6003427E-03,   2.6454877E-03
     +,   2.6923097E-03,   2.7410344E-03,   2.7919125E-03
     +,   2.8452280E-03,   2.9012871E-03,   2.9604356E-03
     +,   3.0230468E-03,   3.0895316E-03,   3.1603335E-03
     +,   3.2359329E-03,   3.3168467E-03,   3.4036264E-03
     +,   3.4968571E-03,   3.5971589E-03,   3.7051816E-03
     +,   3.8216028E-03,   3.9471276E-03,   4.0824749E-03
     +,   4.2283903E-03,   4.3856110E-03,   4.5548966E-03
     +,   4.7369865E-03,   4.9326136E-03,   5.1424881E-03
     +,   5.3672884E-03,   5.6076515E-03,   5.8641653E-03
     +,   6.1373552E-03,   6.4276778E-03,   6.7355102E-03
     +,   7.0611383E-03,   7.4047572E-03,   7.7664410E-03
     +,   8.1461919E-03,   8.5438499E-03,   8.9591807E-03
     +,   9.3918163E-03,   9.8412717E-03,   1.0306964E-02
     +,   1.0788198E-02,   1.1284193E-02,   1.1794082E-02
     +,   1.2316909E-02,   1.2851694E-02,   1.3397434E-02
     +,   1.3953040E-02,   1.4517520E-02,   1.5089810E-02
     +,   1.5668979E-02,   1.6254090E-02,   1.6844356E-02
     +,   1.7439038E-02,   1.8037586E-02,   1.8639520E-02
     +,   1.9244572E-02,   1.9852664E-02,   2.0463843E-02
     +,   2.1078361E-02,   2.1696705E-02,   2.2319585E-02
     +,   2.2947855E-02,   2.3582699E-02,   2.4225460E-02
     +,   2.4877815E-02,   2.5541637E-02,   2.6219176E-02
     +,   2.6912916E-02,   2.7625779E-02,   2.8360980E-02
     +,   2.9122170E-02,   2.9913489E-02,   3.0739438E-02
     +,   3.1605016E-02,   3.2515757E-02,   3.3477675E-02
     +,   3.4497108E-02,   3.5580944E-02,   3.6736228E-02
     +,   3.7970364E-02,   3.9290655E-02,   4.0704455E-02
     +,   4.2218611E-02,   4.3839581E-02,   4.5572795E-02
     +,   4.7422696E-02,   4.9392372E-02,   5.1482972E-02
     +,   5.3693686E-02,   5.6021523E-02,   5.8461014E-02
     +,   6.1003689E-02,   6.3638628E-02,   6.6351697E-02
     +,   6.9126219E-02,   7.1942493E-02,   7.4778579E-02
     +,   7.7610008E-02,   8.0410823E-02,   8.3153352E-02
     +,   8.5809238E-02,   8.8349983E-02,   9.0747103E-02
     +,   9.2973053E-02,   9.5002055E-02,   9.6810333E-02
     +,   9.8376565E-02,   9.9682763E-02,   0.1007142    
     +,   0.1014599    ,   0.1019130    ,   0.1020706    
     +,   0.1019338    ,   0.1015076    ,   0.1008010    
     +,   9.9826433E-02,   9.8599330E-02,   9.7138263E-02
     +,   9.5464118E-02,   9.3599774E-02,   9.1569439E-02
     +,   8.9398593E-02,   8.7113246E-02,   8.4739432E-02
     +,   8.2302786E-02,   7.9828493E-02,   7.7340409E-02
     +,   7.4861005E-02,   7.2411217E-02,   7.0010096E-02
     +,   6.7674518E-02,   6.5419272E-02,   6.3257024E-02
     +,   6.1198402E-02,   5.9251811E-02,   5.7423651E-02
     +,   5.5718787E-02,   5.4140441E-02,   5.2690465E-02
     +,   5.1369589E-02,   5.0177928E-02,   4.9114935E-02
     +,   4.8179839E-02,   4.7371972E-02,   4.6690885E-02
     +,   4.6136625E-02,   4.5710091E-02,   4.5413177E-02
     +,   4.5249052E-02,   4.5222435E-02,   4.5339905E-02
     +,   4.5610238E-02,   4.6044640E-02,   4.6657305E-02
     +,   4.7465436E-02,   4.8489686E-02,   4.9754106E-02
     +,   5.1286142E-02,   5.3116251E-02,   5.5277057E-02
     +,   5.7802923E-02,   6.0728803E-02,   6.4088747E-02
     +,   6.7915171E-02,   7.2238125E-02,   7.7084139E-02
     +,   8.2475334E-02,   8.8428341E-02,   9.4953150E-02
     +,   0.1020500    ,   0.1097046    ,   0.1178846    
     +,   0.1265340    ,   0.1355682    ,   0.1448754    
     +,   0.1543224    ,   0.1637698    ,   0.1730943    
     +,   0.1822224    ,   0.1911685    ,   0.2000706    
     +,   0.2092150    ,   0.2190422    ,   0.2301205    
     +,   0.2430819    ,   0.2585230    ,   0.2768889    
     +,   0.2983621    ,   0.3227947    ,   0.3497176    
     +,   0.3784384    ,   0.4082142    ,   0.4384401    
     +,   0.4688118    ,   0.4993911    ,   0.5305601    
     +,   0.5628826    ,   0.5969376    ,   0.6331724    
     +,   0.6717920    ,   0.7126988    ,   0.7554539    
     +,   0.7992126    ,   0.8426474    ,   0.8839021    
     +,   0.9206115    ,   0.9500439    ,   0.9693722    
     +,   0.9760548    ,   0.9682164    ,   0.9449366    
     +,   0.9063803    ,   0.8537470    ,   0.7890869    
     +,   0.7150783    ,   0.6348135    ,   0.5515915    
     +,   0.4687241    ,   0.3893216    ,   0.3160408    
     +,   0.2508550    ,   0.1949161    ,   0.1485359    
     +,   0.1112895    ,   8.2215771E-02,   6.0060613E-02
     +,   4.3496944E-02,   3.1284533E-02,   2.2362048E-02
     +,   1.5879789E-02,   1.1188833E-02,   7.8073572E-03
     +,   5.3833164E-03,   3.6599571E-03,   2.4485523E-03
     +,   1.6090836E-03,   1.0371269E-03,   6.5484917E-04
     +,   4.0464525E-04,   2.4449179E-04,   1.4434570E-04
     +,   8.3224302E-05,   4.6838075E-05,   2.5719501E-05
     +,   1.3774466E-05,   7.1931563E-06,   3.6616507E-06
     +,   1.8165808E-06,   8.7827067E-07,   4.1387278E-07
     +,   1.9019743E-07,   8.5364533E-08,   3.7550624E-08
     +,   1.6317323E-08,   7.1233801E-09,   3.2292751E-09
     +,   1.6037679E-09,   9.2347635E-10,   6.2786298E-10
     +,   4.8627685E-10,   4.0647849E-10,   3.5247030E-10
     +,   3.1045105E-10,   2.7511085E-10,   2.4431701E-10
     +,   2.1709745E-10,   1.9291231E-10,   1.7138455E-10
     +,   1.5221516E-10,   1.3514823E-10,   1.1995563E-10
     +,   1.0643655E-10,   9.4409987E-11,   8.3715451E-11
     +,   7.4207626E-11,   6.5758281E-11,   5.8251751E-11
     +,   5.1585510E-11,   4.5666831E-11,   4.0414026E-11
     +,   3.5753605E-11,   3.1620314E-11
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_ashz_ttz107_mass = Yx/7.72593535
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_ashz_ttz110_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  8.7113277E-04,   8.9711940E-04
     +,   9.2392578E-04,   9.5158542E-04,   9.8013645E-04
     +,   1.0096247E-03,   1.0401019E-03,   1.0716297E-03
     +,   1.1042784E-03,   1.1381314E-03,   1.1732851E-03
     +,   1.2098502E-03,   1.2479560E-03,   1.2877502E-03
     +,   1.3294038E-03,   1.3731123E-03,   1.4190988E-03
     +,   1.4676178E-03,   1.5189575E-03,   1.5734455E-03
     +,   1.6314503E-03,   1.6933864E-03,   1.7597190E-03
     +,   1.8309720E-03,   1.9077219E-03,   1.9906189E-03
     +,   2.0803793E-03,   2.1777973E-03,   2.2837475E-03
     +,   2.3991959E-03,   2.5251997E-03,   2.6629164E-03
     +,   2.8136105E-03,   2.9786569E-03,   3.1595456E-03
     +,   3.3578882E-03,   3.5754200E-03,   3.8139967E-03
     +,   4.0756180E-03,   4.3623764E-03,   4.6765185E-03
     +,   5.0203861E-03,   5.3964267E-03,   5.8071767E-03
     +,   6.2552467E-03,   6.7432895E-03,   7.2739772E-03
     +,   7.8499699E-03,   8.4738610E-03,   9.1481460E-03
     +,   9.8751634E-03,   1.0657037E-02,   1.1495601E-02
     +,   1.2392397E-02,   1.3348454E-02,   1.4364416E-02
     +,   1.5440308E-02,   1.6575547E-02,   1.7768845E-02
     +,   1.9018175E-02,   2.0320691E-02,   2.1672757E-02
     +,   2.3069762E-02,   2.4506347E-02,   2.5976298E-02
     +,   2.7472440E-02,   2.8987046E-02,   3.0511478E-02
     +,   3.2036729E-02,   3.3553146E-02,   3.5050947E-02
     +,   3.6520015E-02,   3.7950445E-02,   3.9332397E-02
     +,   4.0656548E-02,   4.1914199E-02,   4.3097384E-02
     +,   4.4199117E-02,   4.5213681E-02,   4.6136588E-02
     +,   4.6964776E-02,   4.7696739E-02,   4.8332471E-02
     +,   4.8873600E-02,   4.9323298E-02,   4.9686290E-02
     +,   4.9968597E-02,   5.0177593E-02,   5.0321691E-02
     +,   5.0410252E-02,   5.0453324E-02,   5.0461397E-02
     +,   5.0445173E-02,   5.0415408E-02,   5.0382614E-02
     +,   5.0356898E-02,   5.0347764E-02,   5.0364062E-02
     +,   5.0413843E-02,   5.0504386E-02,   5.0642118E-02
     +,   5.0832793E-02,   5.1081602E-02,   5.1393330E-02
     +,   5.1772587E-02,   5.2224040E-02,   5.2752610E-02
     +,   5.3363830E-02,   5.4063883E-02,   5.4859970E-02
     +,   5.5760153E-02,   5.6773480E-02,   5.7909720E-02
     +,   5.9179232E-02,   6.0592338E-02,   6.2159091E-02
     +,   6.3888155E-02,   6.5786496E-02,   6.7858122E-02
     +,   7.0103511E-02,   7.2518758E-02,   7.5094558E-02
     +,   7.7815749E-02,   8.0661103E-02,   8.3603039E-02
     +,   8.6607464E-02,   8.9634888E-02,   9.2640497E-02
     +,   9.5576003E-02,   9.8390408E-02,   0.1010322    
     +,   0.1034503    ,   0.1055971    ,   0.1074293    
     +,   0.1089097    ,   0.1100092    ,   0.1107073    
     +,   0.1109931    ,   0.1108657    ,   0.1103338    
     +,   0.1094157    ,   0.1081379    ,   0.1065338    
     +,   0.1046426    ,   0.1025079    ,   0.1001753    
     +,   9.7691230E-02,   9.5101401E-02,   9.2449665E-02
     +,   8.9776479E-02,   8.7118417E-02,   8.4507786E-02
     +,   8.1972025E-02,   7.9533719E-02,   7.7210784E-02
     +,   7.5016864E-02,   7.2961681E-02,   7.1051322E-02
     +,   6.9288746E-02,   6.7674533E-02,   6.6206820E-02
     +,   6.4881913E-02,   6.3694693E-02,   6.2638655E-02
     +,   6.1706100E-02,   6.0888410E-02,   6.0176417E-02
     +,   5.9560459E-02,   5.9030756E-02,   5.8577877E-02
     +,   5.8193315E-02,   5.7870064E-02,   5.7603359E-02
     +,   5.7391476E-02,   5.7236694E-02,   5.7145912E-02
     +,   5.7131555E-02,   5.7212058E-02,   5.7412181E-02
     +,   5.7763103E-02,   5.8302347E-02,   5.9073173E-02
     +,   6.0123961E-02,   6.1507355E-02,   6.3279562E-02
     +,   6.5498866E-02,   6.8224832E-02,   7.1517169E-02
     +,   7.5434417E-02,   8.0031805E-02,   8.5360080E-02
     +,   9.1463253E-02,   9.8376021E-02,   0.1061221    
     +,   0.1147135    ,   0.1241497    ,   0.1344167    
     +,   0.1454895    ,   0.1573336    ,   0.1699073    
     +,   0.1831629    ,   0.1970506    ,   0.2115233    
     +,   0.2265422    ,   0.2420798    ,   0.2581300    
     +,   0.2747095    ,   0.2918523    ,   0.3095995    
     +,   0.3279749    ,   0.3469536    ,   0.3664280    
     +,   0.3861858    ,   0.4059112    ,   0.4252119    
     +,   0.4436741    ,   0.4609382    ,   0.4767664    
     +,   0.4910848    ,   0.5039728    ,   0.5156049    
     +,   0.5261460    ,   0.5356295    ,   0.5438597    
     +,   0.5503631    ,   0.5544076    ,   0.5550900    
     +,   0.5514740    ,   0.5427456    ,   0.5283511    
     +,   0.5080960    ,   0.4821920    ,   0.4512421    
     +,   0.4161781    ,   0.3781753    ,   0.3385319    
     +,   0.2985612    ,   0.2594903    ,   0.2223767    
     +,   0.1880467    ,   0.1570710    ,   0.1297631    
     +,   0.1061997    ,   8.6258642E-02,   6.9670148E-02
     +,   5.6070372E-02,   4.5048647E-02,   3.6188100E-02
     +,   2.9096978E-02,   2.3428224E-02,   1.8887350E-02
     +,   1.5234543E-02,   1.2280644E-02,   9.8795826E-03
     +,   7.9199998E-03,   6.3173678E-03,   5.0070919E-03
     +,   3.9387443E-03,   3.0719035E-03,   2.3733540E-03
     +,   1.8151833E-03,   1.3735127E-03,   1.0277428E-03
     +,   7.6013798E-04,   5.5553444E-04,   4.0105206E-04
     +,   2.8591588E-04,   2.0124436E-04,   1.3982203E-04
     +,   9.5878699E-05,   6.4881257E-05,   4.3328553E-05
     +,   2.8559880E-05,   1.8587385E-05,   1.1952488E-05
     +,   7.6037145E-06,   4.7952162E-06,   3.0080248E-06
     +,   1.8868298E-06,   1.1929867E-06,   7.6882668E-07
     +,   5.1215062E-07,   3.5780175E-07,   2.6502076E-07
     +,   2.0872982E-07,   1.7378444E-07,   1.5118781E-07
     +,   1.3568933E-07,   1.2427540E-07,   1.1524114E-07
     +,   1.0763716E-07,   1.0093912E-07,   9.4860368E-08
     +,   8.9241738E-08,   8.3994941E-08,   7.9067490E-08
     +,   7.4427128E-08,   7.0050120E-08,   6.5919401E-08
     +,   6.2020277E-08,   5.8340117E-08
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_ashz_ttz110_mass = Yx/6.19020553846154
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_ashz_ttz115_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.2525145E-03,   1.2921150E-03
     +,   1.3326948E-03,   1.3742801E-03,   1.4168989E-03
     +,   1.4605807E-03,   1.5053581E-03,   1.5512655E-03
     +,   1.5983393E-03,   1.6466214E-03,   1.6961547E-03
     +,   1.7469873E-03,   1.7991718E-03,   1.8527643E-03
     +,   1.9078280E-03,   1.9644322E-03,   2.0226531E-03
     +,   2.0825751E-03,   2.1442906E-03,   2.2079041E-03
     +,   2.2735291E-03,   2.3412933E-03,   2.4113369E-03
     +,   2.4838194E-03,   2.5589105E-03,   2.6368054E-03
     +,   2.7177159E-03,   2.8018777E-03,   2.8895482E-03
     +,   2.9810129E-03,   3.0765824E-03,   3.1765976E-03
     +,   3.2814287E-03,   3.3914770E-03,   3.5071741E-03
     +,   3.6289855E-03,   3.7574079E-03,   3.8929658E-03
     +,   4.0362226E-03,   4.1877548E-03,   4.3481784E-03
     +,   4.5181224E-03,   4.6982327E-03,   4.8891711E-03
     +,   5.0916006E-03,   5.3061885E-03,   5.5335914E-03
     +,   5.7744514E-03,   6.0293884E-03,   6.2989905E-03
     +,   6.5838075E-03,   6.8843425E-03,   7.2010453E-03
     +,   7.5343200E-03,   7.8844810E-03,   8.2518104E-03
     +,   8.6365044E-03,   9.0387072E-03,   9.4584962E-03
     +,   9.8958993E-03,   1.0350908E-02,   1.0823484E-02
     +,   1.1313548E-02,   1.1821059E-02,   1.2345997E-02
     +,   1.2888325E-02,   1.3448152E-02,   1.4025584E-02
     +,   1.4620891E-02,   1.5234409E-02,   1.5866647E-02
     +,   1.6518191E-02,   1.7189851E-02,   1.7882479E-02
     +,   1.8597122E-02,   1.9334929E-02,   2.0097097E-02
     +,   2.0884851E-02,   2.1699458E-02,   2.2542160E-02
     +,   2.3413980E-02,   2.4315892E-02,   2.5248533E-02
     +,   2.6212344E-02,   2.7207272E-02,   2.8232992E-02
     +,   2.9288579E-02,   3.0372771E-02,   3.1483613E-02
     +,   3.2618791E-02,   3.3775490E-02,   3.4950402E-02
     +,   3.6139812E-02,   3.7339836E-02,   3.8546398E-02
     +,   3.9755277E-02,   4.0962484E-02,   4.2164110E-02
     +,   4.3356851E-02,   4.4537719E-02,   4.5704622E-02
     +,   4.6856005E-02,   4.7991484E-02,   4.9111389E-02
     +,   5.0217267E-02,   5.1311631E-02,   5.2397866E-02
     +,   5.3480431E-02,   5.4564573E-02,   5.5656355E-02
     +,   5.6762248E-02,   5.7889286E-02,   5.9044570E-02
     +,   6.0235307E-02,   6.1468348E-02,   6.2750235E-02
     +,   6.4086497E-02,   6.5482013E-02,   6.6940092E-02
     +,   6.8462849E-02,   7.0050597E-02,   7.1701683E-02
     +,   7.3412381E-02,   7.5176843E-02,   7.6986864E-02
     +,   7.8831807E-02,   8.0698855E-02,   8.2572855E-02
     +,   8.4436886E-02,   8.6271882E-02,   8.8057682E-02
     +,   8.9772813E-02,   9.1395535E-02,   9.2903711E-02
     +,   9.4275929E-02,   9.5491871E-02,   9.6532710E-02
     +,   9.7381942E-02,   9.8025866E-02,   9.8453991E-02
     +,   9.8659486E-02,   9.8639309E-02,   9.8394729E-02
     +,   9.7931020E-02,   9.7257569E-02,   9.6387640E-02
     +,   9.5337912E-02,   9.4128020E-02,   9.2780061E-02
     +,   9.1317691E-02,   8.9765571E-02,   8.8148609E-02
     +,   8.6491376E-02,   8.4817111E-02,   8.3147421E-02
     +,   8.1501953E-02,   7.9897910E-02,   7.8349926E-02
     +,   7.6869965E-02,   7.5468011E-02,   7.4151509E-02
     +,   7.2926171E-02,   7.1796335E-02,   7.0765369E-02
     +,   6.9835633E-02,   6.9009319E-02,   6.8288431E-02
     +,   6.7674980E-02,   6.7170911E-02,   6.6778146E-02
     +,   6.6498347E-02,   6.6332713E-02,   6.6281527E-02
     +,   6.6344053E-02,   6.6517957E-02,   6.6799194E-02
     +,   6.7181818E-02,   6.7657784E-02,   6.8216965E-02
     +,   6.8847567E-02,   6.9536313E-02,   7.0269041E-02
     +,   7.1031265E-02,   7.1809225E-02,   7.2590634E-02
     +,   7.3365726E-02,   7.4128367E-02,   7.4876778E-02
     +,   7.5614847E-02,   7.6352283E-02,   7.7105500E-02
     +,   7.7897638E-02,   7.8758404E-02,   7.9723537E-02
     +,   8.0833904E-02,   8.2134418E-02,   8.3672449E-02
     +,   8.5496113E-02,   8.7652631E-02,   9.0186648E-02
     +,   9.3138382E-02,   9.6542589E-02,   0.1004277    
     +,   0.1048154    ,   0.1097196    ,   0.1151481    
     +,   0.1211024    ,   0.1275781    ,   0.1345658    
     +,   0.1420519    ,   0.1500183    ,   0.1584410    
     +,   0.1672898    ,   0.1765271    ,   0.1861051    
     +,   0.1959639    ,   0.2060292    ,   0.2162130    
     +,   0.2264102    ,   0.2364998    ,   0.2463446    
     +,   0.2557935    ,   0.2646798    ,   0.2728253    
     +,   0.2800411    ,   0.2861312    ,   0.2908941    
     +,   0.2941309    ,   0.2956504    ,   0.2952801    
     +,   0.2928761    ,   0.2883356    ,   0.2816094    
     +,   0.2727119    ,   0.2617300    ,   0.2488246    
     +,   0.2342294    ,   0.2182435    ,   0.2012169    
     +,   0.1835317    ,   0.1655820    ,   0.1477536    
     +,   0.1304034    ,   0.1138408    ,   9.8317429E-02
     +,   8.4021270E-02,   7.1073748E-02,   5.9532680E-02
     +,   4.9400076E-02,   4.0632538E-02,   3.3150014E-02
     +,   2.6847670E-02,   2.1606186E-02,   1.7299676E-02
     +,   1.3802430E-02,   1.0994363E-02,   8.7645883E-03
     +,   7.0131570E-03,   5.6519257E-03,   4.6048104E-03
     +,   3.8072830E-03,   3.2053902E-03,   2.7546543E-03
     +,   2.4189777E-03,   2.1694840E-03,   1.9833562E-03
     +,   1.8428549E-03,   1.7344134E-03,   1.6478231E-03
     +,   1.5755496E-03,   1.5121552E-03,   1.4538292E-03
     +,   1.3979863E-03,   1.3429521E-03,   1.2877244E-03
     +,   1.2317855E-03,   1.1749483E-03,   1.1172593E-03
     +,   1.0589084E-03,   1.0001833E-03,   9.4141421E-04
     +,   8.8296010E-04,   8.2517153E-04,   7.6839252E-04
     +,   7.1293494E-04,   6.5908808E-04,   6.0710049E-04
     +,   5.5718410E-04,   5.0951820E-04,   4.6423773E-04
     +,   4.2144739E-04,   3.8121117E-04,   3.4356577E-04
     +,   3.0851283E-04,   2.7603150E-04,   2.4607248E-04
     +,   2.1856955E-04,   1.9343500E-04,   1.7057003E-04
     +,   1.4986115E-04,   1.3118914E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_ashz_ttz115_mass = Yx/4.26890138888889
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_ashz_ttz120_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.5228131E-03,   1.6011558E-03
     +,   1.6845645E-03,   1.7733285E-03,   1.8677464E-03
     +,   1.9681202E-03,   2.0747588E-03,   2.1879715E-03
     +,   2.3080686E-03,   2.4353636E-03,   2.5701628E-03
     +,   2.7127671E-03,   2.8634700E-03,   3.0225536E-03
     +,   3.1902869E-03,   3.3669199E-03,   3.5526843E-03
     +,   3.7477855E-03,   3.9524036E-03,   4.1666864E-03
     +,   4.3907468E-03,   4.6246615E-03,   4.8684608E-03
     +,   5.1221452E-03,   5.3856405E-03,   5.6588487E-03
     +,   5.9416033E-03,   6.2336824E-03,   6.5348120E-03
     +,   6.8446547E-03,   7.1628150E-03,   7.4888361E-03
     +,   7.8221997E-03,   8.1623355E-03,   8.5086059E-03
     +,   8.8603320E-03,   9.2167770E-03,   9.5771523E-03
     +,   9.9406624E-03,   1.0306426E-02,   1.0673591E-02
     +,   1.1041258E-02,   1.1408529E-02,   1.1774519E-02
     +,   1.2138356E-02,   1.2499201E-02,   1.2856258E-02
     +,   1.3208800E-02,   1.3556168E-02,   1.3897801E-02
     +,   1.4233247E-02,   1.4562183E-02,   1.4884413E-02
     +,   1.5199935E-02,   1.5508869E-02,   1.5811570E-02
     +,   1.6108569E-02,   1.6400611E-02,   1.6688671E-02
     +,   1.6973935E-02,   1.7257819E-02,   1.7541977E-02
     +,   1.7828261E-02,   1.8118752E-02,   1.8415740E-02
     +,   1.8721646E-02,   1.9039102E-02,   1.9370822E-02
     +,   1.9719644E-02,   2.0088444E-02,   2.0480148E-02
     +,   2.0897623E-02,   2.1343729E-02,   2.1821190E-02
     +,   2.2332631E-02,   2.2880558E-02,   2.3467226E-02
     +,   2.4094746E-02,   2.4765071E-02,   2.5479997E-02
     +,   2.6241109E-02,   2.7050005E-02,   2.7908161E-02
     +,   2.8817134E-02,   2.9778520E-02,   3.0794200E-02
     +,   3.1866156E-02,   3.2996822E-02,   3.4188885E-02
     +,   3.5445463E-02,   3.6770094E-02,   3.8166542E-02
     +,   3.9638817E-02,   4.1191027E-02,   4.2827297E-02
     +,   4.4551171E-02,   4.6365820E-02,   4.8273269E-02
     +,   5.0274525E-02,   5.2368790E-02,   5.4553632E-02
     +,   5.6824170E-02,   5.9173513E-02,   6.1591897E-02
     +,   6.4067319E-02,   6.6585310E-02,   6.9128893E-02
     +,   7.1679205E-02,   7.4215971E-02,   7.6717794E-02
     +,   7.9162575E-02,   8.1528679E-02,   8.3795033E-02
     +,   8.5942172E-02,   8.7952361E-02,   8.9810789E-02
     +,   9.1505080E-02,   9.3026422E-02,   9.4368957E-02
     +,   9.5530279E-02,   9.6510939E-02,   9.7314209E-02
     +,   9.7945750E-02,   9.8412968E-02,   9.8724633E-02
     +,   9.8890170E-02,   9.8919265E-02,   9.8821275E-02
     +,   9.8604992E-02,   9.8278359E-02,   9.7848155E-02
     +,   9.7320147E-02,   9.6699111E-02,   9.5988937E-02
     +,   9.5192850E-02,   9.4313815E-02,   9.3354605E-02
     +,   9.2318282E-02,   9.1208152E-02,   9.0028062E-02
     +,   8.8782646E-02,   8.7477200E-02,   8.6117543E-02
     +,   8.4710225E-02,   8.3262190E-02,   8.1780776E-02
     +,   8.0273345E-02,   7.8747511E-02,   7.7210709E-02
     +,   7.5670131E-02,   7.4132599E-02,   7.2604850E-02
     +,   7.1093060E-02,   6.9602951E-02,   6.8139769E-02
     +,   6.6708401E-02,   6.5313093E-02,   6.3957520E-02
     +,   6.2644698E-02,   6.1377093E-02,   6.0156342E-02
     +,   5.8983222E-02,   5.7857759E-02,   5.6779187E-02
     +,   5.5745788E-02,   5.4755021E-02,   5.3803582E-02
     +,   5.2887559E-02,   5.2002333E-02,   5.1142804E-02
     +,   5.0303649E-02,   4.9479365E-02,   4.8664439E-02
     +,   4.7853522E-02,   4.7041707E-02,   4.6224598E-02
     +,   4.5398474E-02,   4.4560518E-02,   4.3708939E-02
     +,   4.2843044E-02,   4.1963398E-02,   4.1071989E-02
     +,   4.0172193E-02,   3.9268926E-02,   3.8368627E-02
     +,   3.7479453E-02,   3.6611184E-02,   3.5775207E-02
     +,   3.4984604E-02,   3.4254067E-02,   3.3599790E-02
     +,   3.3039417E-02,   3.2591902E-02,   3.2277301E-02
     +,   3.2116510E-02,   3.2131005E-02,   3.2342568E-02
     +,   3.2772850E-02,   3.3443078E-02,   3.4373723E-02
     +,   3.5584003E-02,   3.7091680E-02,   3.8912825E-02
     +,   4.1061666E-02,   4.3550082E-02,   4.6388015E-02
     +,   4.9583200E-02,   5.3140812E-02,   5.7063617E-02
     +,   6.1351970E-02,   6.6003479E-02,   7.1012087E-02
     +,   7.6367766E-02,   8.2056202E-02,   8.8057682E-02
     +,   9.4345570E-02,   0.1008857    ,   0.1076362    
     +,   0.1145457    ,   0.1215531    ,   0.1285877    
     +,   0.1355698    ,   0.1424104    ,   0.1490129    
     +,   0.1552760    ,   0.1610947    ,   0.1663629    
     +,   0.1709770    ,   0.1748389    ,   0.1778594    
     +,   0.1799606    ,   0.1810794    ,   0.1811702    
     +,   0.1802064    ,   0.1781822    ,   0.1751134    
     +,   0.1710370    ,   0.1660113    ,   0.1601137    
     +,   0.1534384    ,   0.1460937    ,   0.1381993    
     +,   0.1298820    ,   0.1212715    ,   0.1124966    
     +,   0.1036824    ,   9.4946429E-02,   8.6394876E-02
     +,   7.8121193E-02,   7.0205122E-02,   6.2710181E-02
     +,   5.5684362E-02,   4.9160860E-02,   4.3158490E-02
     +,   3.7682701E-02,   3.2727718E-02,   2.8278649E-02
     +,   2.4313042E-02,   2.0802520E-02,   1.7714880E-02
     +,   1.5015882E-02,   1.2670277E-02,   1.0642862E-02
     +,   8.8995472E-03,   7.4080988E-03,   6.1382591E-03
     +,   5.0621964E-03,   4.1546687E-03,   3.3929234E-03
     +,   2.7566007E-03,   2.2276624E-03,   1.7902534E-03
     +,   1.4304749E-03,   1.1361860E-03,   8.9686050E-04
     +,   7.0343062E-04,   5.4807775E-04,   4.2413981E-04
     +,   3.2593720E-04,   2.4868432E-04,   1.8835372E-04
     +,   1.4159697E-04,   1.0563808E-04,   7.8203746E-05
     +,   5.7440444E-05,   4.1855783E-05,   3.0254992E-05
     +,   2.1692127E-05,   1.5425847E-05,   1.0879275E-05
     +,   7.6092283E-06,   5.2776295E-06,   3.6298347E-06
     +,   2.4754686E-06,   1.6739684E-06,   1.1223624E-06
     +,   7.4613382E-07,   4.9178823E-07,   3.2138325E-07
     +,   2.0822637E-07,   1.3375994E-07
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_ashz_ttz120_mass = Yx/3.40233723529412
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_ashz_ttz60_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  5.6162099E-03,   6.0987691E-03
     +,   6.6180481E-03,   7.1793864E-03,   7.7892542E-03
     +,   8.4553156E-03,   9.1865808E-03,   9.9935057E-03
     +,   1.0888125E-02,   1.1884305E-02,   1.2997864E-02
     +,   1.4246953E-02,   1.5652383E-02,   1.7238034E-02
     +,   1.9031350E-02,   2.1063713E-02,   2.3370836E-02
     +,   2.5992915E-02,   2.8974479E-02,   3.2363739E-02
     +,   3.6211457E-02,   4.0569048E-02,   4.5485832E-02
     +,   5.1006142E-02,   5.7164226E-02,   6.3981093E-02
     +,   7.1458846E-02,   7.9576865E-02,   8.8288046E-02
     +,   9.7516581E-02,   0.1071573    ,   0.1170769    
     +,   0.1271179    ,   0.1371042    ,   0.1468486    
     +,   0.1561622    ,   0.1648636    ,   0.1727891    
     +,   0.1798006    ,   0.1857923    ,   0.1906956    
     +,   0.1944805    ,   0.1971534    ,   0.1987543    
     +,   0.1993504    ,   0.1990278    ,   0.1978843    
     +,   0.1960204    ,   0.1935325    ,   0.1905075    
     +,   0.1870186    ,   0.1831239    ,   0.1788672    
     +,   0.1742795    ,   0.1693843    ,   0.1642000    
     +,   0.1587463    ,   0.1530475    ,   0.1471364    
     +,   0.1410562    ,   0.1348609    ,   0.1286149    
     +,   0.1223908    ,   0.1162653    ,   0.1103161    
     +,   0.1046178    ,   9.9237159E-02,   9.4230533E-02
     +,   8.9640148E-02,   8.5494034E-02,   8.1803665E-02
     +,   7.8566283E-02,   7.5764596E-02,   7.3370099E-02
     +,   7.1344607E-02,   6.9643602E-02,   6.8218909E-02
     +,   6.7021251E-02,   6.6002555E-02,   6.5118283E-02
     +,   6.4328849E-02,   6.3601002E-02,   6.2908433E-02
     +,   6.2232450E-02,   6.1561968E-02,   6.0893223E-02
     +,   6.0229357E-02,   5.9579700E-02,   5.8958989E-02
     +,   5.8386184E-02,   5.7883445E-02,   5.7475176E-02
     +,   5.7186492E-02,   5.7042334E-02,   5.7066202E-02
     +,   5.7279136E-02,   5.7698697E-02,   5.8338024E-02
     +,   5.9205268E-02,   6.0302772E-02,   6.1626837E-02
     +,   6.3167393E-02,   6.4908341E-02,   6.6827476E-02
     +,   6.8897560E-02,   7.1087010E-02,   7.3361166E-02
     +,   7.5683489E-02,   7.8017853E-02,   8.0329858E-02
     +,   8.2588412E-02,   8.4768035E-02,   8.6849608E-02
     +,   8.8822156E-02,   9.0682805E-02,   9.2437290E-02
     +,   9.4099052E-02,   9.5688306E-02,   9.7230054E-02
     +,   9.8751917E-02,   0.1002818    ,   0.1018446    
     +,   0.1034602    ,   0.1051407    ,   0.1068890    
     +,   0.1086970    ,   0.1105462    ,   0.1124072    
     +,   0.1142416    ,   0.1160041    ,   0.1176450    
     +,   0.1191127    ,   0.1203577    ,   0.1213349    
     +,   0.1220061    ,   0.1223427    ,   0.1223260    
     +,   0.1219487    ,   0.1212142    ,   0.1201355    
     +,   0.1187347    ,   0.1170400    ,   0.1150849    
     +,   0.1129050    ,   0.1105374    ,   0.1080181    
     +,   0.1053810    ,   0.1026576    ,   9.9875793E-02
     +,   9.7059980E-02,   9.4231129E-02,   9.1407381E-02
     +,   8.8604331E-02,   8.5835047E-02,   8.3111100E-02
     +,   8.0442719E-02,   7.7839151E-02,   7.5308502E-02
     +,   7.2858162E-02,   7.0494741E-02,   6.8223841E-02
     +,   6.6049971E-02,   6.3976653E-02,   6.2006053E-02
     +,   6.0138885E-02,   5.8374401E-02,   5.6710660E-02
     +,   5.5144165E-02,   5.3670198E-02,   5.2282725E-02
     +,   5.0974950E-02,   4.9739275E-02,   4.8567478E-02
     +,   4.7451135E-02,   4.6381824E-02,   4.5351245E-02
     +,   4.4351578E-02,   4.3375645E-02,   4.2417038E-02
     +,   4.1470170E-02,   4.0530421E-02,   3.9594211E-02
     +,   3.8658943E-02,   3.7722878E-02,   3.6785144E-02
     +,   3.5845656E-02,   3.4904927E-02,   3.3964023E-02
     +,   3.3024233E-02,   3.2087307E-02,   3.1154960E-02
     +,   3.0228971E-02,   2.9311122E-02,   2.8403057E-02
     +,   2.7506215E-02,   2.6621819E-02,   2.5750928E-02
     +,   2.4894398E-02,   2.4052804E-02,   2.3226552E-02
     +,   2.2415936E-02,   2.1621102E-02,   2.0842070E-02
     +,   2.0078765E-02,   1.9331176E-02,   1.8599179E-02
     +,   1.7882677E-02,   1.7181635E-02,   1.6496073E-02
     +,   1.5825996E-02,   1.5171486E-02,   1.4532696E-02
     +,   1.3909848E-02,   1.3303158E-02,   1.2712873E-02
     +,   1.2139314E-02,   1.1582811E-02,   1.1043647E-02
     +,   1.0522109E-02,   1.0018501E-02,   9.5330495E-03
     +,   9.0659326E-03,   8.6173089E-03,   8.1872717E-03
     +,   7.7758222E-03,   7.3828935E-03,   7.0083695E-03
     +,   6.6520623E-03,   6.3136863E-03,   5.9928871E-03
     +,   5.6892713E-03,   5.4023731E-03,   5.1316582E-03
     +,   4.8765410E-03,   4.6364209E-03,   4.4106343E-03
     +,   4.1984925E-03,   3.9993012E-03,   3.8123531E-03
     +,   3.6369178E-03,   3.4722723E-03,   3.3177095E-03
     +,   3.1725343E-03,   3.0360620E-03,   2.9076303E-03
     +,   2.7866119E-03,   2.6724096E-03,   2.5644514E-03
     +,   2.4621985E-03,   2.3651586E-03,   2.2728664E-03
     +,   2.1848942E-03,   2.1008535E-03,   2.0203944E-03
     +,   1.9431940E-03,   1.8689644E-03,   1.7974532E-03
     +,   1.7284382E-03,   1.6617196E-03,   1.5971253E-03
     +,   1.5345092E-03,   1.4737487E-03,   1.4147349E-03
     +,   1.3573774E-03,   1.3016070E-03,   1.2473615E-03
     +,   1.1945918E-03,   1.1432607E-03,   1.0933408E-03
     +,   1.0448069E-03,   9.9764054E-04,   9.5183006E-04
     +,   9.0736721E-04,   8.6424273E-04,   8.2244980E-04
     +,   7.8198512E-04,   7.4284116E-04,   7.0501497E-04
     +,   6.6849717E-04,   6.3328282E-04,   5.9936021E-04
     +,   5.6672085E-04,   5.3534994E-04,   5.0523510E-04
     +,   4.7635782E-04,   4.4870161E-04,   4.2224550E-04
     +,   3.9696667E-04,   3.7284303E-04,   3.4984766E-04
     +,   3.2795538E-04,   3.0713668E-04,   2.8736374E-04
     +,   2.6860498E-04,   2.5083052E-04,   2.3400740E-04
     +,   2.1810432E-04,   2.0308742E-04,   1.8892477E-04
     +,   1.7558213E-04,   1.6302733E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_ashz_ttz60_mass = Yx/3.98948238888889
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_ashz_ttz65_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.7505525E-03,   3.0156807E-03
     +,   3.2994086E-03,   3.6023383E-03,   3.9250408E-03
     +,   4.2680521E-03,   4.6318728E-03,   5.0169756E-03
     +,   5.4237959E-03,   5.8527580E-03,   6.3042492E-03
     +,   6.7786435E-03,   7.2763008E-03,   7.7975742E-03
     +,   8.3428090E-03,   8.9123547E-03,   9.5065776E-03
     +,   1.0125850E-02,   1.0770586E-02,   1.1441251E-02
     +,   1.2138373E-02,   1.2862607E-02,   1.3614761E-02
     +,   1.4395932E-02,   1.5207473E-02,   1.6051287E-02
     +,   1.6929856E-02,   1.7846486E-02,   1.8805528E-02
     +,   1.9812649E-02,   2.0875154E-02,   2.2002410E-02
     +,   2.3206264E-02,   2.4501685E-02,   2.5907511E-02
     +,   2.7447393E-02,   2.9150946E-02,   3.1055117E-02
     +,   3.3205837E-02,   3.5659064E-02,   3.8482688E-02
     +,   4.1756783E-02,   4.5573615E-02,   5.0036285E-02
     +,   5.5255681E-02,   6.1346114E-02,   6.8419017E-02
     +,   7.6576233E-02,   8.5902177E-02,   9.6457005E-02
     +,   0.1082710    ,   0.1213407    ,   0.1356271    
     +,   0.1510578    ,   0.1675266    ,   0.1849003    
     +,   0.2030186    ,   0.2216986    ,   0.2407347    
     +,   0.2599003    ,   0.2789460    ,   0.2976009    
     +,   0.3155697    ,   0.3325378    ,   0.3481717    
     +,   0.3621234    ,   0.3740429    ,   0.3835874    
     +,   0.3904407    ,   0.3943340    ,   0.3950714    
     +,   0.3925537    ,   0.3868030    ,   0.3779826    
     +,   0.3664015    ,   0.3525133    ,   0.3368970    
     +,   0.3202207    ,   0.3031922    ,   0.2865022    
     +,   0.2707658    ,   0.2564644    ,   0.2439118    
     +,   0.2332314    ,   0.2243637    ,   0.2170926    
     +,   0.2110922    ,   0.2059815    ,   0.2013805    
     +,   0.1969600    ,   0.1924725    ,   0.1877707    
     +,   0.1828040    ,   0.1776018    ,   0.1722484    
     +,   0.1668555    ,   0.1615362    ,   0.1563879    
     +,   0.1514807    ,   0.1468571    ,   0.1425352    
     +,   0.1385167    ,   0.1347948    ,   0.1313618    
     +,   0.1282135    ,   0.1253510    ,   0.1227807    
     +,   0.1205126    ,   0.1185570    ,   0.1169230    
     +,   0.1156163    ,   0.1146375    ,   0.1139821    
     +,   0.1136399    ,   0.1135952    ,   0.1138274    
     +,   0.1143106    ,   0.1150146    ,   0.1159043    
     +,   0.1169404    ,   0.1180795    ,   0.1192751    
     +,   0.1204777    ,   0.1216366    ,   0.1227017    
     +,   0.1236247    ,   0.1243615    ,   0.1248745    
     +,   0.1251343    ,   0.1251216    ,   0.1248280    
     +,   0.1242568    ,   0.1234223    ,   0.1223491    
     +,   0.1210702    ,   0.1196238    ,   0.1180517    
     +,   0.1163954    ,   0.1146938    ,   0.1129808    
     +,   0.1112828    ,   0.1096188    ,   0.1079988    
     +,   0.1064249    ,   0.1048921    ,   0.1033897    
     +,   0.1019034    ,   0.1004166    ,   9.8912992E-02
     +,   9.7377323E-02,   9.5797323E-02,   9.4164133E-02
     +,   9.2473075E-02,   9.0723544E-02,   8.8918909E-02
     +,   8.7066047E-02,   8.5174665E-02,   8.3256528E-02
     +,   8.1324451E-02,   7.9392135E-02,   7.7472828E-02
     +,   7.5578794E-02,   7.3721163E-02,   7.1909063E-02
     +,   7.0149325E-02,   6.8446524E-02,   6.6802666E-02
     +,   6.5217279E-02,   6.3687578E-02,   6.2208410E-02
     +,   6.0773056E-02,   5.9373345E-02,   5.8000039E-02
     +,   5.6643490E-02,   5.5294205E-02,   5.3943120E-02
     +,   5.2582227E-02,   5.1204942E-02,   4.9806401E-02
     +,   4.8383534E-02,   4.6935294E-02,   4.5462675E-02
     +,   4.3968573E-02,   4.2457480E-02,   4.0935311E-02
     +,   3.9409176E-02,   3.7886988E-02,   3.6376946E-02
     +,   3.4887332E-02,   3.3426303E-02,   3.2001365E-02
     +,   3.0619234E-02,   2.9285781E-02,   2.8005805E-02
     +,   2.6782855E-02,   2.5619358E-02,   2.4516677E-02
     +,   2.3475118E-02,   2.2493966E-02,   2.1571673E-02
     +,   2.0706069E-02,   1.9894406E-02,   1.9133488E-02
     +,   1.8419851E-02,   1.7749928E-02,   1.7120063E-02
     +,   1.6526649E-02,   1.5966250E-02,   1.5435627E-02
     +,   1.4931713E-02,   1.4451745E-02,   1.3993244E-02
     +,   1.3554021E-02,   1.3132127E-02,   1.2725896E-02
     +,   1.2333907E-02,   1.1954989E-02,   1.1588122E-02
     +,   1.1232474E-02,   1.0887384E-02,   1.0552289E-02
     +,   1.0226727E-02,   9.9103358E-03,   9.6028186E-03
     +,   9.3039041E-03,   9.0133641E-03,   8.7310048E-03
     +,   8.4566558E-03,   8.1901317E-03,   7.9312567E-03
     +,   7.6798759E-03,   7.4358271E-03,   7.1989368E-03
     +,   6.9690249E-03,   6.7459350E-03,   6.5294825E-03
     +,   6.3194842E-03,   6.1157765E-03,   5.9181871E-03
     +,   5.7265349E-03,   5.5406475E-03,   5.3603584E-03
     +,   5.1855110E-03,   5.0159376E-03,   4.8514777E-03
     +,   4.6919850E-03,   4.5373156E-03,   4.3873233E-03
     +,   4.2418619E-03,   4.1008070E-03,   3.9640232E-03
     +,   3.8313791E-03,   3.7027530E-03,   3.5780305E-03
     +,   3.4570880E-03,   3.3398087E-03,   3.2260837E-03
     +,   3.1158079E-03,   3.0088711E-03,   2.9051662E-03
     +,   2.8045955E-03,   2.7070639E-03,   2.6124739E-03
     +,   2.5207286E-03,   2.4317442E-03,   2.3454316E-03
     +,   2.2617034E-03,   2.1804827E-03,   2.1016931E-03
     +,   2.0252585E-03,   1.9511046E-03,   1.8791655E-03
     +,   1.8093782E-03,   1.7416775E-03,   1.6760032E-03
     +,   1.6123019E-03,   1.5505163E-03,   1.4905991E-03
     +,   1.4324979E-03,   1.3761701E-03,   1.3215686E-03
     +,   1.2686539E-03,   1.2173832E-03,   1.1677213E-03
     +,   1.1196283E-03,   1.0730717E-03,   1.0280160E-03
     +,   9.8442682E-04,   9.4227481E-04,   9.0152625E-04
     +,   8.6215336E-04,   8.2412385E-04,   7.8741054E-04
     +,   7.5198244E-04,   7.1781344E-04,   6.8487297E-04
     +,   6.5313501E-04,   6.2256970E-04,   5.9315143E-04
     +,   5.6485046E-04,   5.3764123E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_ashz_ttz65_mass = Yx/5.42223897297297
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_ashz_ttz70_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.8419882E-03,   1.9953754E-03
     +,   2.1592630E-03,   2.3340730E-03,   2.5202059E-03
     +,   2.7180295E-03,   2.9278765E-03,   3.1500338E-03
     +,   3.3847343E-03,   3.6321622E-03,   3.8924254E-03
     +,   4.1655619E-03,   4.4515328E-03,   4.7502168E-03
     +,   5.0614066E-03,   5.3848112E-03,   5.7200505E-03
     +,   6.0666697E-03,   6.4241360E-03,   6.7918608E-03
     +,   7.1692020E-03,   7.5554913E-03,   7.9500489E-03
     +,   8.3522405E-03,   8.7614367E-03,   9.1771418E-03
     +,   9.5989555E-03,   1.0026656E-02,   1.0460217E-02
     +,   1.0899877E-02,   1.1346172E-02,   1.1799979E-02
     +,   1.2262567E-02,   1.2735629E-02,   1.3221336E-02
     +,   1.3722338E-02,   1.4241815E-02,   1.4783465E-02
     +,   1.5351555E-02,   1.5950823E-02,   1.6586583E-02
     +,   1.7264623E-02,   1.7991219E-02,   1.8773168E-02
     +,   1.9617811E-02,   2.0533143E-02,   2.1527987E-02
     +,   2.2612324E-02,   2.3797713E-02,   2.5097890E-02
     +,   2.6529528E-02,   2.8113158E-02,   2.9874103E-02
     +,   3.1843543E-02,   3.4058988E-02,   3.6565151E-02
     +,   3.9413664E-02,   4.2662736E-02,   4.6376456E-02
     +,   5.0624091E-02,   5.5480078E-02,   6.1025273E-02
     +,   6.7349523E-02,   7.4557260E-02,   8.2772702E-02
     +,   9.2142969E-02,   0.1028397    ,   0.1150483    
     +,   0.1289514    ,   0.1446959    ,   0.1623612    
     +,   0.1819197    ,   0.2032199    ,   0.2259835    
     +,   0.2498418    ,   0.2743975    ,   0.2993104    
     +,   0.3243930    ,   0.3496916    ,   0.3755180    
     +,   0.4024001    ,   0.4309391    ,   0.4615491    
     +,   0.4941700    ,   0.5280107    ,   0.5614904    
     +,   0.5924228    ,   0.6184751    ,   0.6377339    
     +,   0.6492026    ,   0.6530030    ,   0.6502131    
     +,   0.6424096    ,   0.6311041    ,   0.6173185    
     +,   0.6014393    ,   0.5833648    ,   0.5628532    
     +,   0.5398713    ,   0.5148300    ,   0.4886055    
     +,   0.4623904    ,   0.4374399    ,   0.4148198    
     +,   0.3952155    ,   0.3788533    ,   0.3655235    
     +,   0.3546832    ,   0.3456123    ,   0.3375806    
     +,   0.3299891    ,   0.3224587    ,   0.3148512    
     +,   0.3072210    ,   0.2997321    ,   0.2925585    
     +,   0.2858115    ,   0.2795030    ,   0.2735533    
     +,   0.2678277    ,   0.2621841    ,   0.2565191    
     +,   0.2507938    ,   0.2450427    ,   0.2393662    
     +,   0.2339114    ,   0.2288464    ,   0.2243367    
     +,   0.2205192    ,   0.2174836    ,   0.2152557    
     +,   0.2137908    ,   0.2129733    ,   0.2126282    
     +,   0.2125400    ,   0.2124799    ,   0.2122346    
     +,   0.2116331    ,   0.2105655    ,   0.2089914    
     +,   0.2069358    ,   0.2044743    ,   0.2017120    
     +,   0.1987573    ,   0.1957019    ,   0.1926024    
     +,   0.1894748    ,   0.1862947    ,   0.1830072    
     +,   0.1795390    ,   0.1758159    ,   0.1717757    
     +,   0.1673789    ,   0.1626150    ,   0.1575024    
     +,   0.1520860    ,   0.1464305    ,   0.1406117    
     +,   0.1347097    ,   0.1288021    ,   0.1229580    
     +,   0.1172354    ,   0.1116798    ,   0.1063245    
     +,   0.1011905    ,   9.6289687E-02,   9.1626324E-02
     +,   8.7199271E-02,   8.3003238E-02,   7.9030640E-02
     +,   7.5273156E-02,   7.1722053E-02,   6.8368569E-02
     +,   6.5204464E-02,   6.2222324E-02,   5.9414882E-02
     +,   5.6775387E-02,   5.4297537E-02,   5.1975194E-02
     +,   4.9802087E-02,   4.7772080E-02,   4.5879051E-02
     +,   4.4116862E-02,   4.2479225E-02,   4.0959712E-02
     +,   3.9552070E-02,   3.8249932E-02,   3.7046820E-02
     +,   3.5936277E-02,   3.4912020E-02,   3.3967569E-02
     +,   3.3096634E-02,   3.2293025E-02,   3.1550679E-02
     +,   3.0863654E-02,   3.0226164E-02,   2.9632723E-02
     +,   2.9078063E-02,   2.8557142E-02,   2.8065201E-02
     +,   2.7597796E-02,   2.7150767E-02,   2.6720194E-02
     +,   2.6302470E-02,   2.5894275E-02,   2.5492532E-02
     +,   2.5094427E-02,   2.4697402E-02,   2.4299162E-02
     +,   2.3897601E-02,   2.3490855E-02,   2.3077305E-02
     +,   2.2655554E-02,   2.2224393E-02,   2.1782825E-02
     +,   2.1330105E-02,   2.0865705E-02,   2.0389255E-02
     +,   1.9900631E-02,   1.9399928E-02,   1.8887427E-02
     +,   1.8363575E-02,   1.7829049E-02,   1.7284723E-02
     +,   1.6731571E-02,   1.6170738E-02,   1.5603529E-02
     +,   1.5031380E-02,   1.4455776E-02,   1.3878287E-02
     +,   1.3300570E-02,   1.2724330E-02,   1.2151240E-02
     +,   1.1582961E-02,   1.1021193E-02,   1.0467525E-02
     +,   9.9234758E-03,   9.3905265E-03,   8.8700475E-03
     +,   8.3632702E-03,   7.8713009E-03,   7.3951529E-03
     +,   6.9356929E-03,   6.4936210E-03,   6.0694977E-03
     +,   5.6637656E-03,   5.2767345E-03,   4.9085477E-03
     +,   4.5592235E-03,   4.2286976E-03,   3.9167581E-03
     +,   3.6230923E-03,   3.3473182E-03,   3.0889688E-03
     +,   2.8474920E-03,   2.6222779E-03,   2.4126843E-03
     +,   2.2180297E-03,   2.0375920E-03,   1.8706332E-03
     +,   1.7164155E-03,   1.5741987E-03,   1.4432386E-03
     +,   1.3228034E-03,   1.2121898E-03,   1.1107043E-03
     +,   1.0176793E-03,   9.3248207E-04,   8.5450878E-04
     +,   7.8318274E-04,   7.1796071E-04,   6.5833767E-04
     +,   6.0384133E-04,   5.5402878E-04,   5.0849008E-04
     +,   4.6685114E-04,   4.2876173E-04,   3.9390646E-04
     +,   3.6199170E-04,   3.3275390E-04,   3.0594936E-04
     +,   2.8136020E-04,   2.5878593E-04,   2.3804783E-04
     +,   2.1898159E-04,   2.0144142E-04,   1.8529389E-04
     +,   1.7041879E-04,   1.5670899E-04,   1.4406606E-04
     +,   1.3240275E-04,   1.2163878E-04,   1.1170268E-04
     +,   1.0252866E-04,   9.4057948E-05,   8.6236127E-05
     +,   7.9014615E-05,   7.2348033E-05,   6.6195760E-05
     +,   6.0519673E-05,   5.5285480E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_ashz_ttz70_mass = Yx/7.92152865
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_ashz_ttz75_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.2398541E-03,   2.3876452E-03
     +,   2.5451181E-03,   2.7126344E-03,   2.8905293E-03
     +,   3.0791077E-03,   3.2786368E-03,   3.4893404E-03
     +,   3.7113919E-03,   3.9449227E-03,   4.1899909E-03
     +,   4.4465968E-03,   4.7146673E-03,   4.9940571E-03
     +,   5.2845413E-03,   5.5858078E-03,   5.8974619E-03
     +,   6.2190127E-03,   6.5498836E-03,   6.8893968E-03
     +,   7.2367857E-03,   7.5911828E-03,   7.9516247E-03
     +,   8.3170803E-03,   8.6863926E-03,   9.0583591E-03
     +,   9.4316825E-03,   9.8050013E-03,   1.0176904E-02
     +,   1.0545933E-02,   1.0910592E-02,   1.1269386E-02
     +,   1.1620818E-02,   1.1963423E-02,   1.2295802E-02
     +,   1.2616620E-02,   1.2924680E-02,   1.3218925E-02
     +,   1.3498510E-02,   1.3762807E-02,   1.4011503E-02
     +,   1.4244614E-02,   1.4462563E-02,   1.4666228E-02
     +,   1.4857005E-02,   1.5036891E-02,   1.5208500E-02
     +,   1.5375175E-02,   1.5540993E-02,   1.5710846E-02
     +,   1.5890487E-02,   1.6086539E-02,   1.6306560E-02
     +,   1.6559055E-02,   1.6853470E-02,   1.7200274E-02
     +,   1.7610935E-02,   1.8097917E-02,   1.8674741E-02
     +,   1.9355934E-02,   2.0157026E-02,   2.1094516E-02
     +,   2.2185687E-02,   2.3448626E-02,   2.4901958E-02
     +,   2.6564511E-02,   2.8455405E-02,   3.0593479E-02
     +,   3.2997653E-02,   3.5686545E-02,   3.8679406E-02
     +,   4.1996174E-02,   4.5659378E-02,   4.9694881E-02
     +,   5.4134741E-02,   5.9019629E-02,   6.4401619E-02
     +,   7.0347972E-02,   7.6945446E-02,   8.4303744E-02
     +,   9.2557237E-02,   0.1018672    ,   0.1124160    
     +,   0.1244013    ,   0.1380177    ,   0.1534394    
     +,   0.1707933    ,   0.1901416    ,   0.2114653    
     +,   0.2346698    ,   0.2596006    ,   0.2860700    
     +,   0.3138927    ,   0.3429114    ,   0.3730033    
     +,   0.4040523    ,   0.4359069    ,   0.4683125    
     +,   0.5008963    ,   0.5332403    ,   0.5650967    
     +,   0.5966682    ,   0.6288314    ,   0.6630654    
     +,   0.7009801    ,   0.7435058    ,   0.7900512    
     +,   0.8380593    ,   0.8832648    ,   0.9206554    
     +,   0.9457917    ,   0.9559867    ,   0.9509124    
     +,   0.9325348    ,   0.9045554    ,   0.8715389    
     +,   0.8378601    ,   0.8065696    ,   0.7785036    
     +,   0.7521452    ,   0.7245837    ,   0.6933171    
     +,   0.6579792    ,   0.6210047    ,   0.5868131    
     +,   0.5599610    ,   0.5432440    ,   0.5366870    
     +,   0.5377086    ,   0.5422130    ,   0.5459851    
     +,   0.5458111    ,   0.5400323    ,   0.5284857    
     +,   0.5120440    ,   0.4920167    ,   0.4696557    
     +,   0.4458886    ,   0.4212871    ,   0.3962034    
     +,   0.3709634    ,   0.3460121    ,   0.3219677    
     +,   0.2995747    ,   0.2795837    ,   0.2626006    
     +,   0.2489683    ,   0.2387034    ,   0.2315025    
     +,   0.2268084    ,   0.2239146    ,   0.2220755    
     +,   0.2206019    ,   0.2189245    ,   0.2166262    
     +,   0.2134425    ,   0.2092447    ,   0.2040098    
     +,   0.1977936    ,   0.1907050    ,   0.1828861    
     +,   0.1744978    ,   0.1657114    ,   0.1566991    
     +,   0.1476272    ,   0.1386499    ,   0.1299045    
     +,   0.1215060    ,   0.1135438    ,   0.1060815    
     +,   9.9158391E-02,   9.2791997E-02,   8.6981721E-02
     +,   8.1714354E-02,   7.6968938E-02,   7.2719783E-02
     +,   6.8940036E-02,   6.5603882E-02,   6.2687069E-02
     +,   6.0166858E-02,   5.8021676E-02,   5.6230564E-02
     +,   5.4772139E-02,   5.3623635E-02,   5.2760769E-02
     +,   5.2157301E-02,   5.1785201E-02,   5.1614653E-02
     +,   5.1614653E-02,   5.1753554E-02,   5.1999498E-02
     +,   5.2321177E-02,   5.2688338E-02,   5.3072188E-02
     +,   5.3446013E-02,   5.3785462E-02,   5.4068688E-02
     +,   5.4276731E-02,   5.4393396E-02,   5.4405496E-02
     +,   5.4302644E-02,   5.4077350E-02,   5.3724781E-02
     +,   5.3242624E-02,   5.2631006E-02,   5.1892176E-02
     +,   5.1030394E-02,   5.0051637E-02,   4.8963483E-02
     +,   4.7774665E-02,   4.6495005E-02,   4.5135122E-02
     +,   4.3706276E-02,   4.2219874E-02,   4.0687505E-02
     +,   3.9120711E-02,   3.7530772E-02,   3.5928432E-02
     +,   3.4323826E-02,   3.2726582E-02,   3.1145329E-02
     +,   2.9587895E-02,   2.8061287E-02,   2.6571583E-02
     +,   2.5123874E-02,   2.3722332E-02,   2.2370381E-02
     +,   2.1070614E-02,   1.9824797E-02,   1.8634006E-02
     +,   1.7498773E-02,   1.6419085E-02,   1.5394394E-02
     +,   1.4423740E-02,   1.3505932E-02,   1.2639417E-02
     +,   1.1822430E-02,   1.1053119E-02,   1.0329494E-02
     +,   9.6494732E-03,   9.0109287E-03,   8.4117809E-03
     +,   7.8499671E-03,   7.3234257E-03,   6.8301586E-03
     +,   6.3682678E-03,   5.9359292E-03,   5.5313632E-03
     +,   5.1528867E-03,   4.7989376E-03,   4.4679972E-03
     +,   4.1586333E-03,   3.8695165E-03,   3.5993906E-03
     +,   3.3470576E-03,   3.1113878E-03,   2.8913373E-03
     +,   2.6859229E-03,   2.4942046E-03,   2.3153040E-03
     +,   2.1484040E-03,   1.9927390E-03,   1.8475781E-03
     +,   1.7122374E-03,   1.5860883E-03,   1.4685283E-03
     +,   1.3589943E-03,   1.2569650E-03,   1.1619532E-03
     +,   1.0734964E-03,   9.9116261E-04,   9.1455446E-04
     +,   8.4329938E-04,   7.7704474E-04,   7.1546226E-04
     +,   6.5825076E-04,   6.0512184E-04,   5.5581279E-04
     +,   5.1007158E-04,   4.6766869E-04,   4.2838365E-04
     +,   3.9201538E-04,   3.5837054E-04,   3.2727228E-04
     +,   2.9855082E-04,   2.7205006E-04,   2.4762089E-04
     +,   2.2512319E-04,   2.0442733E-04,   1.8540857E-04
     +,   1.6795185E-04,   1.5194672E-04,   1.3729125E-04
     +,   1.2388745E-04,   1.1164494E-04,   1.0047710E-04
     +,   9.0303947E-05,   8.1049024E-05,   7.2641764E-05
     +,   6.5014923E-05,   5.8106532E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_ashz_ttz75_mass = Yx/10.1655293333333
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_ashz_ttz80_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.7466184E-03,   1.8063391E-03
     +,   1.8676938E-03,   1.9306946E-03,   1.9953512E-03
     +,   2.0616711E-03,   2.1296600E-03,   2.1993211E-03
     +,   2.2706543E-03,   2.3436616E-03,   2.4183400E-03
     +,   2.4946856E-03,   2.5726950E-03,   2.6523643E-03
     +,   2.7336893E-03,   2.8166687E-03,   2.9013015E-03
     +,   2.9875915E-03,   3.0755468E-03,   3.1651796E-03
     +,   3.2565102E-03,   3.3495664E-03,   3.4443841E-03
     +,   3.5410163E-03,   3.6395169E-03,   3.7399656E-03
     +,   3.8424500E-03,   3.9470750E-03,   4.0539633E-03
     +,   4.1632545E-03,   4.2751068E-03,   4.3896954E-03
     +,   4.5072148E-03,   4.6278751E-03,   4.7518997E-03
     +,   4.8795301E-03,   5.0110132E-03,   5.1466040E-03
     +,   5.2865688E-03,   5.4311571E-03,   5.5806260E-03
     +,   5.7352157E-03,   5.8951485E-03,   6.0606212E-03
     +,   6.2318044E-03,   6.4088278E-03,   6.5917824E-03
     +,   6.7807147E-03,   6.9756168E-03,   7.1764342E-03
     +,   7.3830583E-03,   7.5953375E-03,   7.8130728E-03
     +,   8.0360472E-03,   8.2640126E-03,   8.4967446E-03
     +,   8.7340437E-03,   8.9757731E-03,   9.2219077E-03
     +,   9.4725722E-03,   9.7281029E-03,   9.9891080E-03
     +,   1.0256517E-02,   1.0531696E-02,   1.0816500E-02
     +,   1.1113331E-02,   1.1425290E-02,   1.1756157E-02
     +,   1.2110581E-02,   1.2494028E-02,   1.2912937E-02
     +,   1.3374673E-02,   1.3887627E-02,   1.4461108E-02
     +,   1.5105434E-02,   1.5831828E-02,   1.6652294E-02
     +,   1.7579565E-02,   1.8627062E-02,   1.9808726E-02
     +,   2.1138759E-02,   2.2631828E-02,   2.4302607E-02
     +,   2.6166167E-02,   2.8237538E-02,   3.0532366E-02
     +,   3.3066660E-02,   3.5857871E-02,   3.8924925E-02
     +,   4.2290002E-02,   4.5979582E-02,   5.0025981E-02
     +,   5.4469336E-02,   5.9360117E-02,   6.4760365E-02
     +,   7.0744634E-02,   7.7401616E-02,   8.4832057E-02
     +,   9.3149111E-02,   0.1024734    ,   0.1129302    
     +,   0.1246386    ,   0.1377007    ,   0.1521793    
     +,   0.1680773    ,   0.1853178    ,   0.2037407    
     +,   0.2231341    ,   0.2433101    ,   0.2642126    
     +,   0.2860289    ,   0.3092648    ,   0.3347137    
     +,   0.3633308    ,   0.3960128    ,   0.4333980    
     +,   0.4757437    ,   0.5229297    ,   0.5744513    
     +,   0.6292974    ,   0.6857901    ,   0.7419885    
     +,   0.7972912    ,   0.8547270    ,   0.9215992    
     +,    1.005964    ,    1.109775    ,    1.223928    
     +,    1.330587    ,    1.411720    ,    1.456941    
     +,    1.464934    ,    1.440168    ,    1.390262    
     +,    1.325827    ,    1.259281    ,    1.200122    
     +,    1.150124    ,    1.104012    ,    1.055232    
     +,    1.000832    ,   0.9416628    ,   0.8800967    
     +,   0.8186244    ,   0.7596790    ,   0.7052743    
     +,   0.6562592    ,   0.6120574    ,   0.5712925    
     +,   0.5327577    ,   0.4960292    ,   0.4614621    
     +,   0.4297428    ,   0.4013462    ,   0.3761879    
     +,   0.3535807    ,   0.3324667    ,   0.3117663    
     +,   0.2906988    ,   0.2689556    ,   0.2466985    
     +,   0.2244357    ,   0.2028375    ,   0.1825539    
     +,   0.1640866    ,   0.1477281    ,   0.1335625    
     +,   0.1215039    ,   0.1113534    ,   0.1028582    
     +,   9.5758751E-02,   8.9818262E-02,   8.4838450E-02
     +,   8.0663599E-02,   7.7176481E-02,   7.4289732E-02
     +,   7.1937717E-02,   7.0068486E-02,   6.8637721E-02
     +,   6.7604698E-02,   6.6930160E-02,   6.6575587E-02
     +,   6.6502802E-02,   6.6674598E-02,   6.7055233E-02
     +,   6.7610629E-02,   6.8308584E-02,   6.9118515E-02
     +,   7.0011199E-02,   7.0957996E-02,   7.1930453E-02
     +,   7.2899863E-02,   7.3836707E-02,   7.4710831E-02
     +,   7.5491689E-02,   7.6148689E-02,   7.6652095E-02
     +,   7.6973796E-02,   7.7088624E-02,   7.6975219E-02
     +,   7.6617122E-02,   7.6003566E-02,   7.5130202E-02
     +,   7.3999241E-02,   7.2619654E-02,   7.1006551E-02
     +,   6.9180720E-02,   6.7167602E-02,   6.4996280E-02
     +,   6.2697858E-02,   6.0304351E-02,   5.7847500E-02
     +,   5.5357426E-02,   5.2861523E-02,   5.0383747E-02
     +,   4.7944434E-02,   4.5559701E-02,   4.3241419E-02
     +,   4.0997580E-02,   3.8832873E-02,   3.6748845E-02
     +,   3.4744721E-02,   3.2818176E-02,   3.0965766E-02
     +,   2.9183455E-02,   2.7467160E-02,   2.5813231E-02
     +,   2.4218604E-02,   2.2680871E-02,   2.1198416E-02
     +,   1.9770501E-02,   1.8397070E-02,   1.7078502E-02
     +,   1.5815603E-02,   1.4609494E-02,   1.3461249E-02
     +,   1.2371846E-02,   1.1342112E-02,   1.0372557E-02
     +,   9.4632404E-03,   8.6138053E-03,   7.8235092E-03
     +,   7.0911776E-03,   6.4151795E-03,   5.7935319E-03
     +,   5.2239839E-03,   4.7040232E-03,   4.2309100E-03
     +,   3.8017731E-03,   3.4137040E-03,   3.0637216E-03
     +,   2.7488694E-03,   2.4662700E-03,   2.2131302E-03
     +,   1.9867586E-03,   1.7846040E-03,   1.6042809E-03
     +,   1.4435641E-03,   1.3003832E-03,   1.1728386E-03
     +,   1.0592056E-03,   9.5791725E-04,   8.6755509E-04
     +,   7.8684726E-04,   7.1466650E-04,   6.5000274E-04
     +,   5.9196440E-04,   5.3976779E-04,   4.9272500E-04
     +,   4.5022991E-04,   4.1175392E-04,   3.7683803E-04
     +,   3.4508290E-04,   3.1613931E-04,   2.8970404E-04
     +,   2.6551599E-04,   2.4334523E-04,   2.2299457E-04
     +,   2.0428927E-04,   1.8707916E-04,   1.7123019E-04
     +,   1.5662661E-04,   1.4316411E-04,   1.3075175E-04
     +,   1.1930682E-04,   1.0875639E-04,   9.9033670E-05
     +,   9.0078043E-05,   8.1834893E-05,   7.4253119E-05
     +,   6.7286514E-05,   6.0891372E-05,   5.5027787E-05
     +,   4.9657858E-05,   4.4746736E-05,   4.0261144E-05
     +,   3.6170379E-05,   3.2445059E-05,   2.9058014E-05
     +,   2.5983241E-05,   2.3196713E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_ashz_ttz80_mass = Yx/11.0703146666667
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_ashz_ttz85_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.0891256E-03,   2.1635101E-03
     +,   2.2397386E-03,   2.3177722E-03,   2.3975638E-03
     +,   2.4790594E-03,   2.5621958E-03,   2.6469021E-03
     +,   2.7330983E-03,   2.8207011E-03,   2.9096142E-03
     +,   2.9997362E-03,   3.0909581E-03,   3.1831642E-03
     +,   3.2762322E-03,   3.3700338E-03,   3.4644366E-03
     +,   3.5593021E-03,   3.6544888E-03,   3.7498511E-03
     +,   3.8452423E-03,   3.9405143E-03,   4.0355157E-03
     +,   4.1301032E-03,   4.2241230E-03,   4.3174364E-03
     +,   4.4099013E-03,   4.5013805E-03,   4.5917458E-03
     +,   4.6808729E-03,   4.7686473E-03,   4.8549646E-03
     +,   4.9397270E-03,   5.0228522E-03,   5.1042666E-03
     +,   5.1839137E-03,   5.2617476E-03,   5.3377384E-03
     +,   5.4118759E-03,   5.4841614E-03,   5.5546188E-03
     +,   5.6232880E-03,   5.6902305E-03,   5.7555279E-03
     +,   5.8192844E-03,   5.8816262E-03,   5.9427065E-03
     +,   6.0027028E-03,   6.0618175E-03,   6.1202887E-03
     +,   6.1783800E-03,   6.2363902E-03,   6.2946538E-03
     +,   6.3535445E-03,   6.4134710E-03,   6.4748931E-03
     +,   6.5383101E-03,   6.6042729E-03,   6.6733793E-03
     +,   6.7462809E-03,   6.8236901E-03,   6.9063641E-03
     +,   6.9951182E-03,   7.0908307E-03,   7.1944315E-03
     +,   7.3068934E-03,   7.4292533E-03,   7.5625749E-03
     +,   7.7079763E-03,   7.8665921E-03,   8.0395956E-03
     +,   8.2281567E-03,   8.4334612E-03,   8.6566815E-03
     +,   8.8989725E-03,   9.1614760E-03,   9.4452696E-03
     +,   9.7513953E-03,   1.0080829E-02,   1.0434513E-02
     +,   1.0813276E-02,   1.1217937E-02,   1.1649210E-02
     +,   1.2107838E-02,   1.2594501E-02,   1.3109994E-02
     +,   1.3655178E-02,   1.4231207E-02,   1.4839510E-02
     +,   1.5482091E-02,   1.6161688E-02,   1.6881939E-02
     +,   1.7647710E-02,   1.8465456E-02,   1.9343454E-02
     +,   2.0292059E-02,   2.1324154E-02,   2.2455148E-02
     +,   2.3703430E-02,   2.5090080E-02,   2.6639203E-02
     +,   2.8377347E-02,   3.0333653E-02,   3.2539003E-02
     +,   3.5025988E-02,   3.7828322E-02,   4.0980212E-02
     +,   4.4516247E-02,   4.8471723E-02,   5.2883025E-02
     +,   5.7788029E-02,   6.3228808E-02,   6.9252305E-02
     +,   7.5913467E-02,   8.3274931E-02,   9.1408342E-02
     +,   0.1003897    ,   0.1102969    ,   0.1212002    
     +,   0.1331577    ,   0.1462084    ,   0.1603694    
     +,   0.1756436    ,   0.1920392    ,   0.2096030    
     +,   0.2284624    ,   0.2488651    ,   0.2711757    
     +,   0.2958134    ,   0.3231179    ,   0.3532184    
     +,   0.3859819    ,   0.4211527    ,   0.4586405    
     +,   0.4988437    ,   0.5427791    ,   0.5919464    
     +,   0.6480718    ,   0.7130178    ,   0.7889687    
     +,   0.8785161    ,   0.9836890    ,    1.103256    
     +,    1.229578    ,    1.348592    ,    1.445186    
     +,    1.510975    ,    1.548807    ,    1.571269    
     +,    1.593987    ,    1.626469    ,    1.666489    
     +,    1.703346    ,    1.726238    ,    1.728643    
     +,    1.707874    ,    1.664319    ,    1.599842    
     +,    1.513974    ,    1.403392    ,    1.267958    
     +,    1.116425    ,   0.9642926    ,   0.8260140    
     +,   0.7090502    ,   0.6134586    ,   0.5351252    
     +,   0.4692292    ,   0.4121821    ,   0.3620525    
     +,   0.3181949    ,   0.2806536    ,   0.2496312    
     +,   0.2251408    ,   0.2068539    ,   0.1941087    
     +,   0.1860204    ,   0.1816095    ,   0.1799140    
     +,   0.1800697    ,   0.1813620    ,   0.1832441    
     +,   0.1853335    ,   0.1873874    ,   0.1892681    
     +,   0.1909022    ,   0.1922459    ,   0.1932552    
     +,   0.1938690    ,   0.1940008    ,   0.1935451    
     +,   0.1923891    ,   0.1904329    ,   0.1876071    
     +,   0.1838893    ,   0.1793125    ,   0.1739658    
     +,   0.1679861    ,   0.1615429    ,   0.1548200    
     +,   0.1479977    ,   0.1412355    ,   0.1346595    
     +,   0.1283569    ,   0.1223758    ,   0.1167271    
     +,   0.1113923    ,   0.1063328    ,   0.1014983    
     +,   9.6834928E-02,   9.2292272E-02,   8.7828852E-02
     +,   8.3414555E-02,   7.9031810E-02,   7.4675240E-02
     +,   7.0350766E-02,   6.6072859E-02,   6.1861753E-02
     +,   5.7741046E-02,   5.3735543E-02,   4.9868282E-02
     +,   4.6159409E-02,   4.2625323E-02,   3.9277844E-02
     +,   3.6123987E-02,   3.3166427E-02,   3.0404367E-02
     +,   2.7833840E-02,   2.5448434E-02,   2.3240102E-02
     +,   2.1199927E-02,   1.9318424E-02,   1.7585834E-02
     +,   1.5992494E-02,   1.4529167E-02,   1.3186815E-02
     +,   1.1956800E-02,   1.0831004E-02,   9.8016905E-03
     +,   8.8614775E-03,   8.0033960E-03,   7.2209300E-03
     +,   6.5079690E-03,   5.8587422E-03,   5.2678906E-03
     +,   4.7304966E-03,   4.2420160E-03,   3.7982531E-03
     +,   3.3953749E-03,   3.0299230E-03,   2.6987162E-03
     +,   2.3988606E-03,   2.1277436E-03,   1.8829802E-03
     +,   1.6623745E-03,   1.4639151E-03,   1.2857628E-03
     +,   1.1262159E-03,   9.8368619E-04,   8.5669890E-04
     +,   7.4388634E-04,   6.4397068E-04,   5.5575202E-04
     +,   4.7811141E-04,   4.1001299E-04,   3.5048599E-04
     +,   2.9863080E-04,   2.5361963E-04,   2.1468943E-04
     +,   1.8113849E-04,   1.5232683E-04,   1.2767545E-04
     +,   1.0666061E-04,   8.8810040E-05,   7.3701747E-05
     +,   6.0961465E-05,   5.0256000E-05,   4.1293322E-05
     +,   3.3816119E-05,   2.7600918E-05,   2.2452790E-05
     +,   1.8204038E-05,   1.4709781E-05,   1.1846436E-05
     +,   9.5082751E-06,   7.6058859E-06,   6.0634966E-06
     +,   4.8174020E-06,   3.8143414E-06,   3.0097478E-06
     +,   2.3667062E-06,   1.8545937E-06,   1.4482484E-06
     +,   1.1269730E-06,   8.7389537E-07,   6.7525275E-07
     +,   5.1991782E-07,   3.9888701E-07,   3.0493831E-07
     +,   2.3227717E-07,   1.7629291E-07
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_ashz_ttz85_mass = Yx/12.8272815348837
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_ashz_ttz90_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.0763517E-03,   1.1300329E-03
     +,   1.1868707E-03,   1.2469920E-03,   1.3105198E-03
     +,   1.3775711E-03,   1.4482568E-03,   1.5226804E-03
     +,   1.6009331E-03,   1.6831023E-03,   1.7692581E-03
     +,   1.8594606E-03,   1.9537562E-03,   2.0521753E-03
     +,   2.1547351E-03,   2.2614349E-03,   2.3722574E-03
     +,   2.4871677E-03,   2.6061153E-03,   2.7290282E-03
     +,   2.8558210E-03,   2.9863897E-03,   3.1206117E-03
     +,   3.2583575E-03,   3.3994704E-03,   3.5437972E-03
     +,   3.6911622E-03,   3.8413904E-03,   3.9942986E-03
     +,   4.1497038E-03,   4.3074242E-03,   4.4672871E-03
     +,   4.6291277E-03,   4.7927969E-03,   4.9581691E-03
     +,   5.1251380E-03,   5.2936333E-03,   5.4636155E-03
     +,   5.6350962E-03,   5.8081141E-03,   5.9827804E-03
     +,   6.1592464E-03,   6.3377311E-03,   6.5185116E-03
     +,   6.7019346E-03,   6.8884105E-03,   7.0784222E-03
     +,   7.2725131E-03,   7.4712932E-03,   7.6754419E-03
     +,   7.8856815E-03,   8.1027895E-03,   8.3275782E-03
     +,   8.5609006E-03,   8.8035986E-03,   9.0565411E-03
     +,   9.3205618E-03,   9.5964652E-03,   9.8850038E-03
     +,   1.0186844E-02,   1.0502556E-02,   1.0832602E-02
     +,   1.1177271E-02,   1.1536721E-02,   1.1910925E-02
     +,   1.2299610E-02,   1.2702343E-02,   1.3118394E-02
     +,   1.3546852E-02,   1.3986496E-02,   1.4435910E-02
     +,   1.4893381E-02,   1.5356999E-02,   1.5824582E-02
     +,   1.6293786E-02,   1.6762078E-02,   1.7226761E-02
     +,   1.7685007E-02,   1.8133974E-02,   1.8570760E-02
     +,   1.8992480E-02,   1.9396370E-02,   1.9779755E-02
     +,   2.0140208E-02,   2.0475524E-02,   2.0783858E-02
     +,   2.1063717E-02,   2.1314099E-02,   2.1534471E-02
     +,   2.1724917E-02,   2.1886144E-02,   2.2019550E-02
     +,   2.2127252E-02,   2.2212207E-02,   2.2278160E-02
     +,   2.2329738E-02,   2.2372445E-02,   2.2412635E-02
     +,   2.2457559E-02,   2.2515254E-02,   2.2594525E-02
     +,   2.2704817E-02,   2.2856144E-02,   2.3058863E-02
     +,   2.3323607E-02,   2.3661070E-02,   2.4081882E-02
     +,   2.4596490E-02,   2.5215182E-02,   2.5948148E-02
     +,   2.6805554E-02,   2.7798137E-02,   2.8937450E-02
     +,   3.0236786E-02,   3.1711716E-02,   3.3381227E-02
     +,   3.5268176E-02,   3.7400369E-02,   3.9810359E-02
     +,   4.2535786E-02,   4.5618448E-02,   4.9102467E-02
     +,   5.3032190E-02,   5.7449352E-02,   6.2389459E-02
     +,   6.7877397E-02,   7.3925421E-02,   8.0529153E-02
     +,   8.7668635E-02,   9.5308103E-02,   0.1034020    
     +,   0.1118998    ,   0.1207564    ,   0.1299391    
     +,   0.1394390    ,   0.1492763    ,   0.1595060    
     +,   0.1702241    ,   0.1815729    ,   0.1937449    
     +,   0.2069774    ,   0.2215285    ,   0.2376227    
     +,   0.2553626    ,   0.2746367    ,   0.2950935    
     +,   0.3162496    ,   0.3377742    ,   0.3598807    
     +,   0.3836174    ,   0.4108051    ,   0.4435498    
     +,   0.4835761    ,   0.5318815    ,   0.5890540    
     +,   0.6560405    ,   0.7344667    ,   0.8255458    
     +,   0.9276631    ,    1.034542    ,    1.136723    
     +,    1.226863    ,    1.305351    ,    1.380555    
     +,    1.461486    ,    1.547714    ,    1.625250    
     +,    1.672410    ,    1.670928    ,    1.614458    
     +,    1.510684    ,    1.377905    ,    1.238106    
     +,    1.109372    ,    1.001306    ,   0.9154890    
     +,   0.8493813    ,   0.7997825    ,   0.7637215    
     +,   0.7377391    ,   0.7177150    ,   0.6999863    
     +,   0.6827078    ,   0.6661590    ,   0.6517975    
     +,   0.6408966    ,   0.6337020    ,   0.6294144    
     +,   0.6266170    ,   0.6236029    ,   0.6183940    
     +,   0.6087109    ,   0.5922596    ,   0.5674107    
     +,   0.5339455    ,   0.4933839    ,   0.4486602    
     +,   0.4032630    ,   0.3602759    ,   0.3217272    
     +,   0.2884274    ,   0.2602101    ,   0.2363624    
     +,   0.2160299    ,   0.1984742    ,   0.1831586    
     +,   0.1697288    ,   0.1579411    ,   0.1475912    
     +,   0.1384692    ,   0.1303487    ,   0.1229971    
     +,   0.1161964    ,   0.1097630    ,   0.1035620    
     +,   9.7511187E-02,   9.1575444E-02,   8.5755840E-02
     +,   8.0076963E-02,   7.4574709E-02,   6.9285102E-02
     +,   6.4237952E-02,   5.9453629E-02,   5.4941755E-02
     +,   5.0702393E-02,   4.6728320E-02,   4.3008026E-02
     +,   3.9527707E-02,   3.6272921E-02,   3.3230115E-02
     +,   3.0387370E-02,   2.7734308E-02,   2.5261896E-02
     +,   2.2962157E-02,   2.0828096E-02,   1.8852822E-02
     +,   1.7029574E-02,   1.5351593E-02,   1.3811911E-02
     +,   1.2403226E-02,   1.1118042E-02,   9.9488245E-03
     +,   8.8879755E-03,   7.9278583E-03,   7.0609758E-03
     +,   6.2800846E-03,   5.5781952E-03,   4.9485830E-03
     +,   4.3848758E-03,   3.8811341E-03,   3.4317423E-03
     +,   3.0314832E-03,   2.6755515E-03,   2.3595120E-03
     +,   2.0792717E-03,   1.8310862E-03,   1.6115592E-03
     +,   1.4175997E-03,   1.2463920E-03,   1.0953953E-03
     +,   9.6232840E-04,   8.4514124E-04,   7.4198947E-04
     +,   6.5122632E-04,   5.7139382E-04,   5.0118705E-04
     +,   4.3945201E-04,   3.8517109E-04,   3.3744655E-04
     +,   2.9548435E-04,   2.5858707E-04,   2.2614474E-04
     +,   1.9762150E-04,   1.7254593E-04,   1.5050483E-04
     +,   1.3113799E-04,   1.1412684E-04,   9.9193800E-05
     +,   8.6093060E-05,   7.4609918E-05,   6.4553671E-05
     +,   5.5757409E-05,   4.8072448E-05,   4.1368232E-05
     +,   3.5528195E-05,   3.0449812E-05,   2.6041522E-05
     +,   2.2222155E-05,   1.8919933E-05,   1.6070742E-05
     +,   1.3618093E-05,   1.1511530E-05,   9.7066741E-06
     +,   8.1640419E-06,   6.8489644E-06,   5.7307179E-06
     +,   4.7824246E-06,   3.9803781E-06,   3.3039289E-06
     +,   2.7349656E-06,   2.2577879E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_ashz_ttz90_mass = Yx/12.4893794883721
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_ashz_ttz95_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.2105668E-03,   1.2788146E-03
     +,   1.3503088E-03,   1.4250957E-03,   1.5032099E-03
     +,   1.5846728E-03,   1.6694916E-03,   1.7576590E-03
     +,   1.8491491E-03,   1.9439233E-03,   2.0419215E-03
     +,   2.1430657E-03,   2.2472586E-03,   2.3543830E-03
     +,   2.4643014E-03,   2.5768566E-03,   2.6918696E-03
     +,   2.8091427E-03,   2.9284570E-03,   3.0495736E-03
     +,   3.1722370E-03,   3.2961702E-03,   3.4210794E-03
     +,   3.5466633E-03,   3.6725912E-03,   3.7985339E-03
     +,   3.9241440E-03,   4.0490641E-03,   4.1729333E-03
     +,   4.2953836E-03,   4.4160448E-03,   4.5345458E-03
     +,   4.6505188E-03,   4.7635981E-03,   4.8734280E-03
     +,   4.9796584E-03,   5.0819544E-03,   5.1799910E-03
     +,   5.2734665E-03,   5.3620874E-03,   5.4455907E-03
     +,   5.5237301E-03,   5.5962857E-03,   5.6630587E-03
     +,   5.7238853E-03,   5.7786233E-03,   5.8271629E-03
     +,   5.8694216E-03,   5.9053516E-03,   5.9349309E-03
     +,   5.9581725E-03,   5.9751160E-03,   5.9858337E-03
     +,   5.9904289E-03,   5.9890319E-03,   5.9818006E-03
     +,   5.9689190E-03,   5.9506022E-03,   5.9270826E-03
     +,   5.8986200E-03,   5.8654929E-03,   5.8280011E-03
     +,   5.7864622E-03,   5.7412074E-03,   5.6925840E-03
     +,   5.6409552E-03,   5.5866875E-03,   5.5301664E-03
     +,   5.4717762E-03,   5.4119173E-03,   5.3509879E-03
     +,   5.2893991E-03,   5.2275602E-03,   5.1658913E-03
     +,   5.1048161E-03,   5.0447583E-03,   4.9861595E-03
     +,   4.9294694E-03,   4.8751435E-03,   4.8236581E-03
     +,   4.7755130E-03,   4.7312262E-03,   4.6913563E-03
     +,   4.6564913E-03,   4.6272730E-03,   4.6043918E-03
     +,   4.5886068E-03,   4.5807520E-03,   4.5817434E-03
     +,   4.5925993E-03,   4.6144496E-03,   4.6485476E-03
     +,   4.6962872E-03,   4.7592218E-03,   4.8390804E-03
     +,   4.9377792E-03,   5.0574588E-03,   5.2004806E-03
     +,   5.3694905E-03,   5.5674003E-03,   5.7974691E-03
     +,   6.0632797E-03,   6.3688355E-03,   6.7185271E-03
     +,   7.1172300E-03,   7.5703203E-03,   8.0836592E-03
     +,   8.6636301E-03,   9.3171736E-03,   1.0051745E-02
     +,   1.0875166E-02,   1.1795714E-02,   1.2821765E-02
     +,   1.3961840E-02,   1.5224106E-02,   1.6616359E-02
     +,   1.8145349E-02,   1.9816753E-02,   2.1634359E-02
     +,   2.3600016E-02,   2.5713110E-02,   2.7970111E-02
     +,   3.0364489E-02,   3.2886907E-02,   3.5525210E-02
     +,   3.8264655E-02,   4.1089106E-02,   4.3981370E-02
     +,   4.6925008E-02,   4.9904820E-02,   5.2908968E-02
     +,   5.5929478E-02,   5.8963936E-02,   6.2015392E-02
     +,   6.5093324E-02,   6.8212911E-02,   7.1394302E-02
     +,   7.4661352E-02,   7.8040615E-02,   8.1559859E-02
     +,   8.5246794E-02,   8.9128755E-02,   9.3233570E-02
     +,   9.7589962E-02,   0.1022286    ,   0.1071835    
     +,   0.1124919    ,   0.1181909    ,   0.1243137    
     +,   0.1308817    ,   0.1378944    ,   0.1453188    
     +,   0.1530804    ,   0.1610582    ,   0.1690851    
     +,   0.1769551    ,   0.1844388    ,   0.1913048    
     +,   0.1973435    ,   0.2023904    ,   0.2063476    
     +,   0.2091960    ,   0.2110000    ,   0.2119030    
     +,   0.2121169    ,   0.2119054    ,   0.2115695    
     +,   0.2114345    ,   0.2118403    ,   0.2131343    
     +,   0.2156618    ,   0.2197553    ,   0.2257245    
     +,   0.2338514    ,   0.2443999    ,   0.2576640    
     +,   0.2740940    ,   0.2945527    ,   0.3206969    
     +,   0.3552812    ,   0.4019596    ,   0.4642488    
     +,   0.5439788    ,   0.6404303    ,   0.7512392    
     +,   0.8743976    ,    1.008766    ,    1.151407    
     +,    1.294401    ,    1.426742    ,    1.542045    
     +,    1.642905    ,    1.734271    ,    1.814026    
     +,    1.874655    ,    1.913063    ,    1.934240    
     +,    1.943866    ,    1.937311    ,    1.898410    
     +,    1.814628    ,    1.693126    ,    1.555361    
     +,    1.417103    ,    1.280652    ,    1.144440    
     +,    1.011901    ,   0.8895024    ,   0.7810763    
     +,   0.6864762    ,   0.6039879    ,   0.5323049    
     +,   0.4705276    ,   0.4174442    ,   0.3713975    
     +,   0.3307345    ,   0.2942343    ,   0.2612022    
     +,   0.2313252    ,   0.2044801    ,   0.1805787    
     +,   0.1594867    ,   0.1409902    ,   0.1248012    
     +,   0.1105902    ,   9.8030210E-02,   8.6832829E-02
     +,   7.6765783E-02,   6.7657016E-02,   5.9388462E-02
     +,   5.1884059E-02,   4.5095541E-02,   3.8989551E-02
     +,   3.3538409E-02,   2.8713640E-02,   2.4481136E-02
     +,   2.0800350E-02,   1.7625088E-02,   1.4905031E-02
     +,   1.2587931E-02,   1.0622255E-02,   8.9592561E-03
     +,   7.5542824E-03,   6.3675400E-03,   5.3645507E-03
     +,   4.5160661E-03,   3.7975567E-03,   3.1886033E-03
     +,   2.6723181E-03,   2.2347514E-03,   1.8642358E-03
     +,   1.5509791E-03,   1.2867013E-03,   1.0643182E-03
     +,   8.7771897E-04,   7.2162150E-04,   5.9146027E-04
     +,   4.8327999E-04,   3.9365541E-04,   3.1963890E-04
     +,   2.5870814E-04,   2.0870879E-04,   1.6780724E-04
     +,   1.3445321E-04,   1.0734364E-04,   8.5381827E-05
     +,   6.7651003E-05,   5.3387757E-05,   4.1957195E-05
     +,   3.2832242E-05,   2.5577419E-05,   1.9834348E-05
     +,   1.5308366E-05,   1.1757973E-05,   8.9861642E-06
     +,   6.8330983E-06,   5.1690959E-06,   3.8899148E-06
     +,   2.9117853E-06,   2.1680114E-06,   1.6055675E-06
     +,   1.1826846E-06,   8.6653625E-07,   6.3156608E-07
     +,   4.5793391E-07,   3.3038268E-07,   2.3722323E-07
     +,   1.6957260E-07,   1.2072769E-07,   8.5653973E-08
     +,   6.0605288E-08,   4.2805862E-08,   3.0218306E-08
     +,   2.1353499E-08,   1.5133205E-08,   1.0780041E-08
     +,   7.7385769E-09,   5.6137233E-09,   4.1268304E-09
     +,   3.0821925E-09,   2.3434670E-09
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_ashz_ttz95_mass = Yx/12.4893794883721
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_ashz_hatt100_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.3011407E-02,   2.4308758E-02
     +,   2.5652818E-02,   2.7043262E-02,   2.8479688E-02
     +,   2.9961618E-02,   3.1488571E-02,   3.3060025E-02
     +,   3.4675457E-02,   3.6334474E-02,   3.8036615E-02
     +,   3.9781593E-02,   4.1569173E-02,   4.3399271E-02
     +,   4.5271881E-02,   4.7187235E-02,   4.9145617E-02
     +,   5.1147524E-02,   5.3193536E-02,   5.5284414E-02
     +,   5.7421014E-02,   5.9604242E-02,   6.1834995E-02
     +,   6.4114392E-02,   6.6443197E-02,   6.8822272E-02
     +,   7.1252301E-02,   7.3733643E-02,   7.6266475E-02
     +,   7.8850485E-02,   8.1484944E-02,   8.4168665E-02
     +,   8.6899787E-02,   8.9675881E-02,   9.2493862E-02
     +,   9.5349707E-02,   9.8239169E-02,   0.1011568    
     +,   0.1040972    ,   0.1070538    ,   0.1100202    
     +,   0.1129899    ,   0.1159562    ,   0.1189133    
     +,   0.1218559    ,   0.1247799    ,   0.1276830    
     +,   0.1305647    ,   0.1334269    ,   0.1362741    
     +,   0.1391141    ,   0.1419576    ,   0.1448185    
     +,   0.1477143    ,   0.1506648    ,   0.1536923    
     +,   0.1568215    ,   0.1600776    ,   0.1634856    
     +,   0.1670701    ,   0.1708533    ,   0.1748543    
     +,   0.1790875    ,   0.1835625    ,   0.1882828    
     +,   0.1932457    ,   0.1984425    ,   0.2038575    
     +,   0.2094708    ,   0.2152570    ,   0.2211886    
     +,   0.2272356    ,   0.2333690    ,   0.2395601    
     +,   0.2457838    ,   0.2520183    ,   0.2582459    
     +,   0.2644535    ,   0.2706303    ,   0.2767699    
     +,   0.2828648    ,   0.2889076    ,   0.2948878    
     +,   0.3007910    ,   0.3065960    ,   0.3122773    
     +,   0.3178015    ,   0.3231323    ,   0.3282278    
     +,   0.3330458    ,   0.3375460    ,   0.3416901    
     +,   0.3454449    ,   0.3487855    ,   0.3516932    
     +,   0.3541580    ,   0.3561776    ,   0.3577565    
     +,   0.3589086    ,   0.3596525    ,   0.3600170    
     +,   0.3600409    ,   0.3597752    ,   0.3592864    
     +,   0.3586589    ,   0.3579978    ,   0.3574285    
     +,   0.3570943    ,   0.3571555    ,   0.3577769    
     +,   0.3591211    ,   0.3613352    ,   0.3645342    
     +,   0.3687901    ,   0.3741182    ,   0.3804672    
     +,   0.3877155    ,   0.3956769    ,   0.4041019    
     +,   0.4127002    ,   0.4211554    ,   0.4291496    
     +,   0.4363896    ,   0.4426250    ,   0.4476753    
     +,   0.4514358    ,   0.4538942    ,   0.4551271    
     +,   0.4552985    ,   0.4546483    ,   0.4534783    
     +,   0.4521345    ,   0.4509819    ,   0.4503825    
     +,   0.4506724    ,   0.4521314    ,   0.4549635    
     +,   0.4592770    ,   0.4650708    ,   0.4722307    
     +,   0.4805319    ,   0.4896589    ,   0.4992241    
     +,   0.5088072    ,   0.5179827    ,   0.5263656    
     +,   0.5336355    ,   0.5395672    ,   0.5440390    
     +,   0.5470411    ,   0.5486629    ,   0.5490742    
     +,   0.5485018    ,   0.5471974    ,   0.5454049    
     +,   0.5433357    ,   0.5411453    ,   0.5389150    
     +,   0.5366476    ,   0.5342712    ,   0.5316467    
     +,   0.5285884    ,   0.5248849    ,   0.5203304    
     +,   0.5147455    ,   0.5080100    ,   0.5000825    
     +,   0.4910229    ,   0.4810025    ,   0.4703088    
     +,   0.4593459    ,   0.4486181    ,   0.4387086    
     +,   0.4302500    ,   0.4238900    ,   0.4202533    
     +,   0.4199073    ,   0.4233343    ,   0.4309089    
     +,   0.4428918    ,   0.4594225    ,   0.4805274    
     +,   0.5061193    ,   0.5360047    ,   0.5698808    
     +,   0.6073321    ,   0.6478308    ,   0.6907426    
     +,   0.7353464    ,   0.7808529    ,   0.8264549    
     +,   0.8713602    ,   0.9148334    ,   0.9562110    
     +,   0.9949196    ,    1.030446    ,    1.062315    
     +,    1.090071    ,    1.113273    ,    1.131525    
     +,    1.144524    ,    1.152145    ,    1.154504    
     +,    1.151983    ,    1.145199    ,    1.134911    
     +,    1.121884    ,    1.106727    ,    1.089782    
     +,    1.071057    ,    1.050251    ,    1.026865    
     +,    1.000347    ,   0.9702476    ,   0.9363539    
     +,   0.8987507    ,   0.8578151    ,   0.8141553    
     +,   0.7685077    ,   0.7216489    ,   0.6743013    
     +,   0.6270830    ,   0.5804979    ,   0.5349351    
     +,   0.4906911    ,   0.4479964    ,   0.4070439    
     +,   0.3679993    ,   0.3310055    ,   0.2961870    
     +,   0.2636455    ,   0.2334547    ,   0.2056503    
     +,   0.1802326    ,   0.1571674    ,   0.1363851    
     +,   0.1177883    ,   0.1012581    ,   8.6660497E-02
     +,   7.3850349E-02,   6.2678352E-02,   5.2995253E-02
     +,   4.4654328E-02,   3.7512884E-02,   3.1434927E-02
     +,   2.6292499E-02,   2.1966197E-02,   1.8345593E-02
     +,   1.5330144E-02,   1.2829624E-02,   1.0763517E-02
     +,   9.0611409E-03,   7.6612681E-03,   6.5113064E-03
     +,   5.5665392E-03,   4.7893859E-03,   4.1485797E-03
     +,   3.6182688E-03,   3.1772119E-03,   2.8081010E-03
     +,   2.4969485E-03,   2.2324794E-03,   2.0056462E-03
     +,   1.8092422E-03,   1.6375639E-03,   1.4860927E-03
     +,   1.3512719E-03,   1.2303201E-03,   1.1210579E-03
     +,   1.0217744E-03,   9.3112804E-04,   8.4806781E-04
     +,   7.7176082E-04,   7.0153474E-04,   6.3684239E-04
     +,   5.7723705E-04,   5.2233244E-04,   4.7180170E-04
     +,   4.2534855E-04,   3.8271074E-04,   3.4364100E-04
     +,   3.0791320E-04,   2.7530835E-04,   2.4562204E-04
     +,   2.1865418E-04,   1.9421638E-04,   1.7212471E-04
     +,   1.5220312E-04,   1.3428472E-04,   1.1820783E-04
     +,   1.0382066E-04,   9.0977446E-05,   7.9542340E-05
     +,   6.9386027E-05,   6.0388862E-05,   5.2438081E-05
     +,   4.5430075E-05,   3.9268099E-05,   3.3863900E-05
     +,   2.9135803E-05,   2.5009798E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_ashz_hatt100_mass = Yx/22.3891905106383
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_ashz_hatt105_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.6958535E-02,   1.7934704E-02
     +,   1.8959492E-02,   2.0034423E-02,   2.1160882E-02
     +,   2.2340117E-02,   2.3573227E-02,   2.4861086E-02
     +,   2.6204338E-02,   2.7603447E-02,   2.9058531E-02
     +,   3.0569497E-02,   3.2135930E-02,   3.3757150E-02
     +,   3.5432227E-02,   3.7159972E-02,   3.8938962E-02
     +,   4.0767670E-02,   4.2644434E-02,   4.4567566E-02
     +,   4.6535432E-02,   4.8546534E-02,   5.0599586E-02
     +,   5.2693803E-02,   5.4828696E-02,   5.7004478E-02
     +,   5.9222054E-02,   6.1483089E-02,   6.3790157E-02
     +,   6.6146858E-02,   6.8557829E-02,   7.1028642E-02
     +,   7.3566042E-02,   7.6177672E-02,   7.8872077E-02
     +,   8.1658386E-02,   8.4546365E-02,   8.7545671E-02
     +,   9.0666443E-02,   9.3917429E-02,   9.7307160E-02
     +,   0.1008424    ,   0.1045282    ,   0.1083672    
     +,   0.1123598    ,   0.1165027    ,   0.1207900    
     +,   0.1252121    ,   0.1297558    ,   0.1344049    
     +,   0.1391398    ,   0.1439379    ,   0.1487746    
     +,   0.1536231    ,   0.1584549    ,   0.1632416    
     +,   0.1679538    ,   0.1725627    ,   0.1770407    
     +,   0.1813611    ,   0.1854994    ,   0.1894326    
     +,   0.1931406    ,   0.1966059    ,   0.1998138    
     +,   0.2027529    ,   0.2054151    ,   0.2077965    
     +,   0.2098976    ,   0.2117232    ,   0.2132839    
     +,   0.2145951    ,   0.2156795    ,   0.2165652    
     +,   0.2172870    ,   0.2178867    ,   0.2184119    
     +,   0.2189162    ,   0.2194580    ,   0.2201001    
     +,   0.2209077    ,   0.2219470    ,   0.2232839    
     +,   0.2249803    ,   0.2270938    ,   0.2296725    
     +,   0.2327551    ,   0.2363664    ,   0.2405151    
     +,   0.2451932    ,   0.2503732    ,   0.2560088    
     +,   0.2620351    ,   0.2683710    ,   0.2749222    
     +,   0.2815853    ,   0.2882522    ,   0.2948160    
     +,   0.3011766    ,   0.3072443    ,   0.3129458    
     +,   0.3182242    ,   0.3230426    ,   0.3273831    
     +,   0.3312447    ,   0.3346409    ,   0.3375960    
     +,   0.3401403    ,   0.3423058    ,   0.3441226    
     +,   0.3456165    ,   0.3468065    ,   0.3477040    
     +,   0.3483148    ,   0.3486421    ,   0.3486885    
     +,   0.3484622    ,   0.3479788    ,   0.3472663    
     +,   0.3463655    ,   0.3453318    ,   0.3442323    
     +,   0.3431448    ,   0.3421526    ,   0.3413410    
     +,   0.3407942    ,   0.3405923    ,   0.3408079    
     +,   0.3415056    ,   0.3427406    ,   0.3445560    
     +,   0.3469805    ,   0.3500254    ,   0.3536800    
     +,   0.3579090    ,   0.3626474    ,   0.3678012    
     +,   0.3732479    ,   0.3788428    ,   0.3844254    
     +,   0.3898307    ,   0.3948995    ,   0.3994907    
     +,   0.4034880    ,   0.4068054    ,   0.4093902    
     +,   0.4112190    ,   0.4122890    ,   0.4126150    
     +,   0.4122162    ,   0.4111093    ,   0.4093022    
     +,   0.4067901    ,   0.4035569    ,   0.3995755    
     +,   0.3948160    ,   0.3892496    ,   0.3828557    
     +,   0.3756289    ,   0.3675857    ,   0.3587668    
     +,   0.3492392    ,   0.3391009    ,   0.3284771    
     +,   0.3175192    ,   0.3064028    ,   0.2953243    
     +,   0.2844952    ,   0.2741356    ,   0.2644677    
     +,   0.2557117    ,   0.2480747    ,   0.2417459    
     +,   0.2368909    ,   0.2336467    ,   0.2321190    
     +,   0.2323800    ,   0.2344689    ,   0.2383957    
     +,   0.2441434    ,   0.2516750    ,   0.2609384    
     +,   0.2718746    ,   0.2844238    ,   0.2985306    
     +,   0.3141438    ,   0.3312157    ,   0.3496974    
     +,   0.3695261    ,   0.3906086    ,   0.4128098    
     +,   0.4359373    ,   0.4597295    ,   0.4838555    
     +,   0.5079284    ,   0.5315195    ,   0.5541889    
     +,   0.5755153    ,   0.5951319    ,   0.6127476    
     +,   0.6281584    ,   0.6412461    ,   0.6519632    
     +,   0.6603011    ,   0.6662590    ,   0.6698152    
     +,   0.6709008    ,   0.6693937    ,   0.6651278    
     +,   0.6579138    ,   0.6475726    ,   0.6339731    
     +,   0.6170685    ,   0.5969194    ,   0.5737070    
     +,   0.5477367    ,   0.5194205    ,   0.4892496    
     +,   0.4577668    ,   0.4255356    ,   0.3931010    
     +,   0.3609701    ,   0.3295914    ,   0.2993407    
     +,   0.2705148    ,   0.2433324    ,   0.2179411    
     +,   0.1944238    ,   0.1728052    ,   0.1530654    
     +,   0.1351503    ,   0.1189794    ,   0.1044540    
     +,   9.1464415E-02,   7.9897620E-02,   6.9638267E-02
     +,   6.0573626E-02,   5.2595697E-02,   4.5601789E-02
     +,   3.9494574E-02,   3.4182996E-02,   2.9582296E-02
     +,   2.5613401E-02,   2.2202680E-02,   1.9281998E-02
     +,   1.6788842E-02,   1.4666038E-02,   1.2861533E-02
     +,   1.1328582E-02,   1.0025722E-02,   8.9163156E-03
     +,   7.9684714E-03,   7.1548275E-03,   6.4521013E-03
     +,   5.8406834E-03,   5.3043002E-03,   4.8296233E-03
     +,   4.4058370E-03,   4.0242379E-03,   3.6779204E-03
     +,   3.3614768E-03,   3.0706970E-03,   2.8023086E-03
     +,   2.5537915E-03,   2.3232326E-03,   2.1091297E-03
     +,   1.9103062E-03,   1.7258303E-03,   1.5549273E-03
     +,   1.3969194E-03,   1.2511935E-03,   1.1171842E-03
     +,   9.9434238E-04,   8.8211312E-04,   7.7994086E-04
     +,   6.8727351E-04,   6.0354033E-04,   5.2817853E-04
     +,   4.6061337E-04,   4.0028337E-04,   3.4662639E-04
     +,   2.9909989E-04,   2.5717102E-04,   2.2033304E-04
     +,   1.8809691E-04,   1.6000401E-04,   1.3562014E-04
     +,   1.1454047E-04,   9.6391879E-05,   8.0828562E-05
     +,   6.7536559E-05,   5.6228921E-05,   4.6648220E-05
     +,   3.8562277E-05,   3.1765179E-05,   2.6073474E-05
     +,   2.1326276E-05,   1.7381944E-05,   1.4117523E-05
     +,   1.1426002E-05,   9.2154442E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_ashz_hatt105_mass = Yx/15.3245798222222
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_ashz_hatt107_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.1095788E-02,   1.1740801E-02
     +,   1.2412285E-02,   1.3110833E-02,   1.3837094E-02
     +,   1.4591801E-02,   1.5375757E-02,   1.6189899E-02
     +,   1.7035287E-02,   1.7913135E-02,   1.8824873E-02
     +,   1.9772084E-02,   2.0756628E-02,   2.1780608E-02
     +,   2.2846406E-02,   2.3956731E-02,   2.5114616E-02
     +,   2.6323469E-02,   2.7587015E-02,   2.8909430E-02
     +,   3.0295243E-02,   3.1749390E-02,   3.3277154E-02
     +,   3.4884341E-02,   3.6576893E-02,   3.8361315E-02
     +,   4.0244278E-02,   4.2232767E-02,   4.4333890E-02
     +,   4.6554986E-02,   4.8903402E-02,   5.1386435E-02
     +,   5.4011282E-02,   5.6784786E-02,   5.9713427E-02
     +,   6.2802985E-02,   6.6058546E-02,   6.9484033E-02
     +,   7.3082149E-02,   7.6853752E-02,   8.0797970E-02
     +,   8.4911339E-02,   8.9187779E-02,   9.3617916E-02
     +,   9.8188870E-02,   0.1028838    ,   0.1076818    
     +,   0.1125570    ,   0.1174797    ,   0.1224156    
     +,   0.1273260    ,   0.1321690    ,   0.1368999    
     +,   0.1414725    ,   0.1458399    ,   0.1499565    
     +,   0.1537798    ,   0.1572719    ,   0.1604011    
     +,   0.1631446    ,   0.1654890    ,   0.1674324    
     +,   0.1689849    ,   0.1701693    ,   0.1710211    
     +,   0.1715878    ,   0.1719279    ,   0.1721087    
     +,   0.1722047    ,   0.1722949    ,   0.1724588    
     +,   0.1727748    ,   0.1733159    ,   0.1741466    
     +,   0.1753207    ,   0.1768785    ,   0.1788448    
     +,   0.1812288    ,   0.1840228    ,   0.1872040    
     +,   0.1907356    ,   0.1945699    ,   0.1986510    
     +,   0.2029201    ,   0.2073186    ,   0.2117935    
     +,   0.2163005    ,   0.2208083    ,   0.2253003    
     +,   0.2297758    ,   0.2342497    ,   0.2387496    
     +,   0.2433129    ,   0.2479810    ,   0.2527947    
     +,   0.2577856    ,   0.2629719    ,   0.2683514    
     +,   0.2738984    ,   0.2795608    ,   0.2852603    
     +,   0.2908957    ,   0.2963493    ,   0.3014922    
     +,   0.3061987    ,   0.3103541    ,   0.3138684    
     +,   0.3166888    ,   0.3188075    ,   0.3202685    
     +,   0.3211712    ,   0.3216670    ,   0.3219535    
     +,   0.3222603    ,   0.3228341    ,   0.3239160    
     +,   0.3257243    ,   0.3284296    ,   0.3321392    
     +,   0.3368835    ,   0.3426085    ,   0.3491770    
     +,   0.3563768    ,   0.3639368    ,   0.3715484    
     +,   0.3788894    ,   0.3856543    ,   0.3915754    
     +,   0.3964462    ,   0.4001354    ,   0.4025908    
     +,   0.4038377    ,   0.4039672    ,   0.4031176    
     +,   0.4014497    ,   0.3991255    ,   0.3962862    
     +,   0.3930342    ,   0.3894258    ,   0.3854698    
     +,   0.3811354    ,   0.3763652    ,   0.3710908    
     +,   0.3652516    ,   0.3588109    ,   0.3517620    
     +,   0.3441382    ,   0.3360066    ,   0.3274640    
     +,   0.3186255    ,   0.3096103    ,   0.3005341    
     +,   0.2914965    ,   0.2825768    ,   0.2738312    
     +,   0.2652958    ,   0.2569920    ,   0.2489293    
     +,   0.2411163    ,   0.2335644    ,   0.2262929    
     +,   0.2193321    ,   0.2127229    ,   0.2065157    
     +,   0.2007671    ,   0.1955362    ,   0.1908807    
     +,   0.1868535    ,   0.1834979    ,   0.1808466    
     +,   0.1789212    ,   0.1777308    ,   0.1772739    
     +,   0.1775419    ,   0.1785207    ,   0.1801962    
     +,   0.1825579    ,   0.1856033    ,   0.1893411    
     +,   0.1937945    ,   0.1990015    ,   0.2050135    
     +,   0.2118931    ,   0.2197090    ,   0.2285299    
     +,   0.2384167    ,   0.2494153    ,   0.2615520    
     +,   0.2748256    ,   0.2892052    ,   0.3046294    
     +,   0.3210070    ,   0.3382165    ,   0.3561096    
     +,   0.3745151    ,   0.3932383    ,   0.4120607    
     +,   0.4307429    ,   0.4490252    ,   0.4666275    
     +,   0.4832539    ,   0.4985988    ,   0.5123594    
     +,   0.5242473    ,   0.5340005    ,   0.5414008    
     +,   0.5462855    ,   0.5485506    ,   0.5481589    
     +,   0.5451317    ,   0.5395438    ,   0.5315082    
     +,   0.5211664    ,   0.5086707    ,   0.4941767    
     +,   0.4778392    ,   0.4598087    ,   0.4402364    
     +,   0.4192801    ,   0.3971144    ,   0.3739345    
     +,   0.3499636    ,   0.3254531    ,   0.3006811    
     +,   0.2759378    ,   0.2515205    ,   0.2277193    
     +,   0.2048021    ,   0.1830017    ,   0.1625073    
     +,   0.1434605    ,   0.1259510    ,   0.1100179    
     +,   9.5655195E-02,   8.2820609E-02,   7.1440123E-02
     +,   6.1418597E-02,   5.2647941E-02,   4.5013234E-02
     +,   3.8398113E-02,   3.2689571E-02,   2.7781239E-02
     +,   2.3574550E-02,   1.9979520E-02,   1.6915238E-02
     +,   1.4309819E-02,   1.2099562E-02,   1.0228262E-02
     +,   8.6467005E-03,   7.3120808E-03,   6.1870748E-03
     +,   5.2394350E-03,   4.4414704E-03,   3.7694604E-03
     +,   3.2031699E-03,   2.7254666E-03,   2.3219485E-03
     +,   1.9805285E-03,   1.6910871E-03,   1.4452048E-03
     +,   1.2359003E-03,   1.0573776E-03,   9.0481661E-04
     +,   7.7421661E-04,   6.6226081E-04,   5.6617078E-04
     +,   4.8362205E-04,   4.1266831E-04,   3.5166639E-04
     +,   2.9922079E-04,   2.5414643E-04,   2.1543405E-04
     +,   1.8221886E-04,   1.5375525E-04,   1.2940030E-04
     +,   1.0860068E-04,   9.0873633E-05,   7.5802200E-05
     +,   6.3021478E-05,   5.2215215E-05,   4.3106214E-05
     +,   3.5454006E-05,   2.9047897E-05,   2.3705295E-05
     +,   1.9266703E-05,   1.5594325E-05,   1.2568525E-05
     +,   1.0086154E-05,   8.0587515E-06,   6.4103206E-06
     +,   5.0762869E-06,   4.0016703E-06,   3.1401910E-06
     +,   2.4528422E-06,   1.9071171E-06,   1.4759241E-06
     +,   1.1369183E-06,   8.7169019E-07,   6.6522301E-07
     +,   5.0528740E-07,   3.8202040E-07
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_ashz_hatt107_mass = Yx/13.132693
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_ashz_hatt110_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.0989409E-02,   2.2064215E-02
     +,   2.3178259E-02,   2.4333155E-02,   2.5530627E-02
     +,   2.6772531E-02,   2.8060814E-02,   2.9397510E-02
     +,   3.0784687E-02,   3.2224439E-02,   3.3718776E-02
     +,   3.5269592E-02,   3.6878616E-02,   3.8547292E-02
     +,   4.0276866E-02,   4.2068038E-02,   4.3921184E-02
     +,   4.5836024E-02,   4.7811791E-02,   4.9847037E-02
     +,   5.1939610E-02,   5.4086775E-02,   5.6284886E-02
     +,   5.8529913E-02,   6.0816832E-02,   6.3140370E-02
     +,   6.5494545E-02,   6.7872994E-02,   7.0269145E-02
     +,   7.2676130E-02,   7.5087100E-02,   7.7495292E-02
     +,   7.9894021E-02,   8.2277052E-02,   8.4638484E-02
     +,   8.6972758E-02,   8.9274965E-02,   9.1540612E-02
     +,   9.3765922E-02,   9.5947176E-02,   9.8081648E-02
     +,   0.1001668    ,   0.1022006    ,   0.1041813    
     +,   0.1061079    ,   0.1079796    ,   0.1097965    
     +,   0.1115592    ,   0.1132693    ,   0.1149294    
     +,   0.1165437    ,   0.1181175    ,   0.1196579    
     +,   0.1211737    ,   0.1226756    ,   0.1241752    
     +,   0.1256862    ,   0.1272227    ,   0.1287993    
     +,   0.1304302    ,   0.1321286    ,   0.1339058    
     +,   0.1357700    ,   0.1377261    ,   0.1397750    
     +,   0.1419120    ,   0.1441283    ,   0.1464093    
     +,   0.1487365    ,   0.1510869    ,   0.1534348    
     +,   0.1557525    ,   0.1580125    ,   0.1601884    
     +,   0.1622572    ,   0.1642009    ,   0.1660075    
     +,   0.1676729    ,   0.1692020    ,   0.1706086    
     +,   0.1719163    ,   0.1731575    ,   0.1743729    
     +,   0.1756096    ,   0.1769204    ,   0.1783606    
     +,   0.1799853    ,   0.1818483    ,   0.1839975    
     +,   0.1864737    ,   0.1893079    ,   0.1925187    
     +,   0.1961114    ,   0.2000765    ,   0.2043896    
     +,   0.2090107    ,   0.2138855    ,   0.2189459    
     +,   0.2241129    ,   0.2292969    ,   0.2344028    
     +,   0.2393312    ,   0.2439840    ,   0.2482671    
     +,   0.2520968    ,   0.2554027    ,   0.2581336    
     +,   0.2602614    ,   0.2617855    ,   0.2627333    
     +,   0.2631625    ,   0.2631593    ,   0.2628340    
     +,   0.2623169    ,   0.2617492    ,   0.2612747    
     +,   0.2610298    ,   0.2611333    ,   0.2616774    
     +,   0.2627202    ,   0.2642808    ,   0.2663377    
     +,   0.2688298    ,   0.2716609    ,   0.2747067    
     +,   0.2778252    ,   0.2808662    ,   0.2836816    
     +,   0.2861378    ,   0.2881218    ,   0.2895490    
     +,   0.2903657    ,   0.2905493    ,   0.2901079    
     +,   0.2890733    ,   0.2874967    ,   0.2854411    
     +,   0.2829740    ,   0.2801620    ,   0.2770648    
     +,   0.2737331    ,   0.2702073    ,   0.2665169    
     +,   0.2626837    ,   0.2587241    ,   0.2546521    
     +,   0.2504818    ,   0.2462302    ,   0.2419188    
     +,   0.2375711    ,   0.2332149    ,   0.2288774    
     +,   0.2245852    ,   0.2203604    ,   0.2162198    
     +,   0.2121737    ,   0.2082256    ,   0.2043724    
     +,   0.2006077    ,   0.1969233    ,   0.1933127    
     +,   0.1897725    ,   0.1863082    ,   0.1829339    
     +,   0.1796745    ,   0.1765666    ,   0.1736578    
     +,   0.1710059    ,   0.1686765    ,   0.1667403    
     +,   0.1652709    ,   0.1643414    ,   0.1640214    
     +,   0.1643750    ,   0.1654582    ,   0.1673182    
     +,   0.1699923    ,   0.1735075    ,   0.1778804    
     +,   0.1831184    ,   0.1892197    ,   0.1961724    
     +,   0.2039547    ,   0.2125344    ,   0.2218678    
     +,   0.2318964    ,   0.2425464    ,   0.2537276    
     +,   0.2653324    ,   0.2772348    ,   0.2892941    
     +,   0.3013573    ,   0.3132617    ,   0.3248418    
     +,   0.3359353    ,   0.3463906    ,   0.3560693    
     +,   0.3648545    ,   0.3726543    ,   0.3794040    
     +,   0.3850648    ,   0.3896253    ,   0.3930954    
     +,   0.3955032    ,   0.3968879    ,   0.3972929    
     +,   0.3967594    ,   0.3953210    ,   0.3929973    
     +,   0.3897928    ,   0.3856969    ,   0.3806849    
     +,   0.3747229    ,   0.3677745    ,   0.3598075    
     +,   0.3508024    ,   0.3407595    ,   0.3297027    
     +,   0.3176845    ,   0.3047876    ,   0.2911204    
     +,   0.2768156    ,   0.2620236    ,   0.2469066    
     +,   0.2316293    ,   0.2163527    ,   0.2012298    
     +,   0.1863993    ,   0.1719801    ,   0.1580726    
     +,   0.1447569    ,   0.1320937    ,   0.1201242    
     +,   0.1088735    ,   9.8353930E-02,   8.8564701E-02
     +,   7.9495683E-02,   7.1129933E-02,   6.3444555E-02
     +,   5.6411799E-02,   5.0000865E-02,   4.4179011E-02
     +,   3.8912058E-02,   3.4164578E-02,   2.9900966E-02
     +,   2.6086025E-02,   2.2685025E-02,   1.9663889E-02
     +,   1.6989714E-02,   1.4631250E-02,   1.2558530E-02
     +,   1.0743323E-02,   9.1593107E-03,   7.7819820E-03
     +,   6.5885969E-03,   5.5582714E-03,   4.6719853E-03
     +,   3.9124377E-03,   3.2639219E-03,   2.7123094E-03
     +,   2.2449724E-03,   1.8506300E-03,   1.5192331E-03
     +,   1.2418967E-03,   1.0108135E-03,   8.1911095E-04
     +,   6.6079042E-04,   5.3064537E-04,   4.2416746E-04
     +,   3.3746692E-04,   2.6721219E-04,   2.1056757E-04
     +,   1.6512709E-04,   1.2885850E-04,   1.0005850E-04
     +,   7.7309262E-05,   5.9432357E-05,   4.5459328E-05
     +,   3.4594774E-05,   2.6192809E-05,   1.9729649E-05
     +,   1.4784959E-05,   1.1022176E-05,   8.1744838E-06
     +,   6.0309162E-06,   4.4262697E-06,   3.2315784E-06
     +,   2.3469584E-06,   1.6955789E-06,   1.2185612E-06
     +,   8.7118605E-07,   6.1960679E-07,   4.3843181E-07
     +,   3.0867707E-07,   2.1627356E-07,   1.5083214E-07
     +,   1.0474695E-07,   7.2470584E-08,   4.9991133E-08
     +,   3.4418672E-08,   2.3688649E-08
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_ashz_hatt110_mass = Yx/11.057009
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_ashz_hatt115_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.0242328E-02,   2.1243770E-02
     +,   2.2274241E-02,   2.3334559E-02,   2.4425734E-02
     +,   2.5548946E-02,   2.6705584E-02,   2.7897207E-02
     +,   2.9125487E-02,   3.0392284E-02,   3.1699497E-02
     +,   3.3049043E-02,   3.4442786E-02,   3.5882480E-02
     +,   3.7369721E-02,   3.8905747E-02,   4.0491495E-02
     +,   4.2127330E-02,   4.3813188E-02,   4.5548294E-02
     +,   4.7331180E-02,   4.9159646E-02,   5.1030632E-02
     +,   5.2940417E-02,   5.4884262E-02,   5.6856882E-02
     +,   5.8852129E-02,   6.0863324E-02,   6.2883191E-02
     +,   6.4904116E-02,   6.6918194E-02,   6.8917461E-02
     +,   7.0893981E-02,   7.2840005E-02,   7.4748211E-02
     +,   7.6611780E-02,   7.8424424E-02,   8.0180593E-02
     +,   8.1875749E-02,   8.3505809E-02,   8.5067831E-02
     +,   8.6559556E-02,   8.7979488E-02,   8.9326993E-02
     +,   9.0601817E-02,   9.1804482E-02,   9.2935860E-02
     +,   9.3997151E-02,   9.4989955E-02,   9.5916077E-02
     +,   9.6777737E-02,   9.7577341E-02,   9.8317690E-02
     +,   9.9002190E-02,   9.9634841E-02,   0.1002205    
     +,   0.1007650    ,   0.1012754    ,   0.1017603    
     +,   0.1022297    ,   0.1026954    ,   0.1031708    
     +,   0.1036711    ,   0.1042129    ,   0.1048145    
     +,   0.1054949    ,   0.1062741    ,   0.1071722    
     +,   0.1082091    ,   0.1094039    ,   0.1107742    
     +,   0.1123354    ,   0.1141009    ,   0.1160803    
     +,   0.1182799    ,   0.1207019    ,   0.1233443    
     +,   0.1262002    ,   0.1292585    ,   0.1325033    
     +,   0.1359140    ,   0.1394663    ,   0.1431316    
     +,   0.1468789    ,   0.1506740    ,   0.1544817    
     +,   0.1582655    ,   0.1619902    ,   0.1656212    
     +,   0.1691267    ,   0.1724792    ,   0.1756546    
     +,   0.1786352    ,   0.1814087    ,   0.1839699    
     +,   0.1863199    ,   0.1884669    ,   0.1904247    
     +,   0.1922130    ,   0.1938565    ,   0.1953831    
     +,   0.1968237    ,   0.1982099    ,   0.1995730    
     +,   0.2009427    ,   0.2023459    ,   0.2038046    
     +,   0.2053358    ,   0.2069495    ,   0.2086491    
     +,   0.2104290    ,   0.2122757    ,   0.2141669    
     +,   0.2160722    ,   0.2179526    ,   0.2197626    
     +,   0.2214504    ,   0.2229600    ,   0.2242330    
     +,   0.2252114    ,   0.2258391    ,   0.2260653    
     +,   0.2258462    ,   0.2251482    ,   0.2239494    
     +,   0.2222412    ,   0.2200281    ,   0.2173300    
     +,   0.2141788    ,   0.2106195    ,   0.2067069    
     +,   0.2025041    ,   0.1980787    ,   0.1935012    
     +,   0.1888412    ,   0.1841650    ,   0.1795339    
     +,   0.1750014    ,   0.1706122    ,   0.1664008    
     +,   0.1623921    ,   0.1586003    ,   0.1550298    
     +,   0.1516757    ,   0.1485259    ,   0.1455606    
     +,   0.1427554    ,   0.1400820    ,   0.1375101    
     +,   0.1350088    ,   0.1325486    ,   0.1301022    
     +,   0.1276470    ,   0.1251648    ,   0.1226438    
     +,   0.1200788    ,   0.1174717    ,   0.1148313    
     +,   0.1121732    ,   0.1095188    ,   0.1068948    
     +,   0.1043315    ,   0.1018623    ,   9.9521436E-02
     +,   9.7343065E-02,   9.5359735E-02,   9.3601324E-02
     +,   9.2094369E-02,   9.0860784E-02,   8.9917846E-02
     +,   8.9278497E-02,   8.8950895E-02,   8.8939317E-02
     +,   8.9244805E-02,   8.9865863E-02,   9.0799816E-02
     +,   9.2043526E-02,   9.3594246E-02,   9.5450513E-02
     +,   9.7613461E-02,   0.1000867    ,   0.1028769    
     +,   0.1059942    ,   0.1094520    ,   0.1132669    
     +,   0.1174581    ,   0.1220465    ,   0.1270543    
     +,   0.1325043    ,   0.1384168    ,   0.1448102    
     +,   0.1516985    ,   0.1590884    ,   0.1669785    
     +,   0.1753578    ,   0.1842019    ,   0.1934727    
     +,   0.2031152    ,   0.2130594    ,   0.2232169    
     +,   0.2334831    ,   0.2437370    ,   0.2538459    
     +,   0.2636672    ,   0.2730514    ,   0.2818490    
     +,   0.2899150    ,   0.2971127    ,   0.3033203    
     +,   0.3084337    ,   0.3123700    ,   0.3150688    
     +,   0.3164926    ,   0.3166258    ,   0.3154739    
     +,   0.3130586    ,   0.3094171    ,   0.3045974    
     +,   0.2986557    ,   0.2916564    ,   0.2836682    
     +,   0.2747650    ,   0.2650268    ,   0.2545394    
     +,   0.2433951    ,   0.2316925    ,   0.2195387    
     +,   0.2070472    ,   0.1943360    ,   0.1815262    
     +,   0.1687402    ,   0.1560981    ,   0.1437131    
     +,   0.1316903    ,   0.1201240    ,   0.1090942    
     +,   9.8664984E-02,   8.8886067E-02,   7.9790361E-02
     +,   7.1394786E-02,   6.3701890E-02,   5.6701850E-02
     +,   5.0373726E-02,   4.4686995E-02,   3.9604351E-02
     +,   3.5083860E-02,   3.1080388E-02,   2.7547147E-02
     +,   2.4437441E-02,   2.1706006E-02,   1.9309454E-02
     +,   1.7207202E-02,   1.5362090E-02,   1.3740413E-02
     +,   1.2311963E-02,   1.1050108E-02,   9.9317143E-03
     +,   8.9368019E-03,   8.0482420E-03,   7.2515202E-03
     +,   6.5344800E-03,   5.8869487E-03,   5.3004087E-03
     +,   4.7677844E-03,   4.2832401E-03,   3.8418667E-03
     +,   3.4395517E-03,   3.0728383E-03,   2.7387678E-03
     +,   2.4347489E-03,   2.1584986E-03,   1.9079832E-03
     +,   1.6813490E-03,   1.4768635E-03,   1.2929066E-03
     +,   1.1279637E-03,   9.8056998E-04,   8.4934576E-04
     +,   7.3295331E-04,   6.3012936E-04,   5.3965295E-04
     +,   4.6037682E-04,   3.9120333E-04,   3.3110767E-04
     +,   2.7912227E-04,   2.3435277E-04,   1.9596696E-04
     +,   1.6320021E-04,   1.3535713E-04,   1.1180260E-04
     +,   9.1967180E-05,   7.5337986E-05,   6.1460632E-05
     +,   4.9931376E-05,   4.0396786E-05,   3.2546886E-05
     +,   2.6113566E-05,   2.0864611E-05,   1.6601518E-05
     +,   1.3154440E-05,   1.0379847E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_ashz_hatt115_mass = Yx/8.2987443
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_ashz_hatt120_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  9.1959331E-03,   9.6863890E-03
     +,   1.0194343E-02,   1.0719942E-02,   1.1263317E-02
     +,   1.1824599E-02,   1.2403892E-02,   1.3001303E-02
     +,   1.3616944E-02,   1.4250953E-02,   1.4903476E-02
     +,   1.5574706E-02,   1.6264888E-02,   1.6974341E-02
     +,   1.7703498E-02,   1.8452913E-02,   1.9223275E-02
     +,   2.0015489E-02,   2.0830657E-02,   2.1670137E-02
     +,   2.2535579E-02,   2.3428945E-02,   2.4352517E-02
     +,   2.5309021E-02,   2.6301468E-02,   2.7333388E-02
     +,   2.8408647E-02,   2.9531520E-02,   3.0706689E-02
     +,   3.1939141E-02,   3.3234209E-02,   3.4597371E-02
     +,   3.6034301E-02,   3.7550643E-02,   3.9151940E-02
     +,   4.0843405E-02,   4.2629823E-02,   4.4515282E-02
     +,   4.6503022E-02,   4.8595048E-02,   5.0792068E-02
     +,   5.3093120E-02,   5.5495393E-02,   5.7993885E-02
     +,   6.0581408E-02,   6.3248225E-02,   6.5982126E-02
     +,   6.8768226E-02,   7.1589209E-02,   7.4425332E-02
     +,   7.7254787E-02,   8.0054015E-02,   8.2798161E-02
     +,   8.5462011E-02,   8.8019855E-02,   9.0447284E-02
     +,   9.2721209E-02,   9.4821110E-02,   9.6729696E-02
     +,   9.8433599E-02,   9.9924192E-02,   0.1011982    
     +,   0.1022578    ,   0.1031108    ,   0.1037712    
     +,   0.1042580    ,   0.1045957    ,   0.1048124    
     +,   0.1049402    ,   0.1050135    ,   0.1050677    
     +,   0.1051384    ,   0.1052599    ,   0.1054639    
     +,   0.1057786    ,   0.1062277    ,   0.1068290    
     +,   0.1075945    ,   0.1085294    ,   0.1096323    
     +,   0.1108945    ,   0.1123013    ,   0.1138316    
     +,   0.1154594    ,   0.1171540    ,   0.1188815    
     +,   0.1206059    ,   0.1222905    ,   0.1238988    
     +,   0.1253961    ,   0.1267506    ,   0.1279346    
     +,   0.1289249    ,   0.1297038    ,   0.1302598    
     +,   0.1305875    ,   0.1306872    ,   0.1305658    
     +,   0.1302351    ,   0.1297119    ,   0.1290172    
     +,   0.1281750    ,   0.1272120    ,   0.1261562    
     +,   0.1250364    ,   0.1238811    ,   0.1227186    
     +,   0.1215756    ,   0.1204771    ,   0.1194461    
     +,   0.1185039    ,   0.1176689    ,   0.1169579    
     +,   0.1163846    ,   0.1159606    ,   0.1156951    
     +,   0.1155945    ,   0.1156626    ,   0.1158996    
     +,   0.1163028    ,   0.1168652    ,   0.1175757    
     +,   0.1184188    ,   0.1193740    ,   0.1204163    
     +,   0.1215158    ,   0.1226388    ,   0.1237480    
     +,   0.1248040    ,   0.1257658    ,   0.1265932    
     +,   0.1272478    ,   0.1276948    ,   0.1279045    
     +,   0.1278535    ,   0.1275261    ,   0.1269149    
     +,   0.1260209    ,   0.1248535    ,   0.1234298    
     +,   0.1217739    ,   0.1199154    ,   0.1178876    
     +,   0.1157262    ,   0.1134675    ,   0.1111465    
     +,   0.1087954    ,   0.1064430    ,   0.1041134    
     +,   0.1018251    ,   9.9591300E-02,   9.7420327E-02
     +,   9.5315441E-02,   9.3275785E-02,   9.1297433E-02
     +,   8.9374177E-02,   8.7498702E-02,   8.5663475E-02
     +,   8.3861567E-02,   8.2087897E-02,   8.0339320E-02
     +,   7.8615360E-02,   7.6918595E-02,   7.5254567E-02
     +,   7.3631652E-02,   7.2061069E-02,   7.0556395E-02
     +,   6.9133185E-02,   6.7808405E-02,   6.6599779E-02
     +,   6.5525621E-02,   6.4603932E-02,   6.3852012E-02
     +,   6.3286200E-02,   6.2921241E-02,   6.2770396E-02
     +,   6.2844954E-02,   6.3154347E-02,   6.3706122E-02
     +,   6.4505912E-02,   6.5557756E-02,   6.6863969E-02
     +,   6.8425372E-02,   7.0241474E-02,   7.2310410E-02
     +,   7.4628867E-02,   7.7192083E-02,   7.9993807E-02
     +,   8.3025932E-02,   8.6278126E-02,   8.9738011E-02
     +,   9.3390778E-02,   9.7218677E-02,   0.1012013    
     +,   0.1053159    ,   0.1095373    ,   0.1138379    
     +,   0.1181885    ,   0.1225589    ,   0.1269185    
     +,   0.1312365    ,   0.1354828    ,   0.1396283    
     +,   0.1436458    ,   0.1475094    ,   0.1511951    
     +,   0.1546806    ,   0.1579451    ,   0.1609685    
     +,   0.1637318    ,   0.1662163    ,   0.1684028    
     +,   0.1702723    ,   0.1718051    ,   0.1729811    
     +,   0.1737804    ,   0.1741833    ,   0.1741707    
     +,   0.1737255    ,   0.1728328    ,   0.1714810    
     +,   0.1696620    ,   0.1673726    ,   0.1646150    
     +,   0.1613966    ,   0.1577309    ,   0.1536375    
     +,   0.1491419    ,   0.1442750    ,   0.1390728    
     +,   0.1335761    ,   0.1278295    ,   0.1218800    
     +,   0.1157769    ,   0.1095704    ,   0.1033107    
     +,   9.7046487E-02,   9.0825230E-02,   8.4691338E-02
     +,   7.8685485E-02,   7.2844192E-02,   6.7199729E-02
     +,   6.1779615E-02,   5.6605905E-02,   5.1695723E-02
     +,   4.7061589E-02,   4.2711426E-02,   3.8648445E-02
     +,   3.4872107E-02,   3.1378716E-02,   2.8161293E-02
     +,   2.5210390E-02,   2.2514816E-02,   2.0061811E-02
     +,   1.7837418E-02,   1.5826967E-02,   1.4015618E-02
     +,   1.2388489E-02,   1.0930735E-02,   9.6279914E-03
     +,   8.4665390E-03,   7.4333278E-03,   6.5160180E-03
     +,   5.7031005E-03,   4.9839956E-03,   4.3488941E-03
     +,   3.7888309E-03,   3.2956924E-03,   2.8621180E-03
     +,   2.4814412E-03,   2.1476727E-03,   1.8554619E-03
     +,   1.6000244E-03,   1.3770687E-03,   1.1827725E-03
     +,   1.0137509E-03,   8.6697127E-04,   7.3975755E-04
     +,   6.2971545E-04,   5.3473550E-04,   4.5293354E-04
     +,   3.8265073E-04,   3.2240871E-04,   2.7090809E-04
     +,   2.2699432E-04,   1.8965467E-04,   1.5799374E-04
     +,   1.3122524E-04,   1.0866222E-04,   8.9700879E-05
     +,   7.3817093E-05,   6.0552815E-05,   4.9512670E-05
     +,   4.0353363E-05,   3.2780350E-05,   2.6539670E-05
     +,   2.1414908E-05,   1.7220838E-05,   1.3800710E-05
     +,   1.1021398E-05,   8.7710678E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_ashz_hatt120_mass = Yx/5.5736737368421
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_ashz_hatt60_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  0.1534406    ,   0.1786457    
     +,   0.2062311    ,   0.2362245    ,   0.2686396    
     +,   0.3034678    ,   0.3406693    ,   0.3801769    
     +,   0.4219072    ,   0.4657819    ,   0.5117389    
     +,   0.5597190    ,   0.6096182    ,   0.6612031    
     +,   0.7140181    ,   0.7673161    ,   0.8200559    
     +,   0.8709682    ,   0.9186826    ,   0.9619254    
     +,   0.9997653    ,    1.031945    ,    1.059233    
     +,    1.083710    ,    1.108784    ,    1.138793    
     +,    1.178220    ,    1.230733    ,    1.298333    
     +,    1.380758    ,    1.475130    ,    1.575790    
     +,    1.674478    ,    1.761258    ,    1.826402    
     +,    1.862899    ,    1.868648    ,    1.847243    
     +,    1.806739    ,    1.756869    ,    1.705876    
     +,    1.658322    ,    1.614518    ,    1.571469    
     +,    1.524642    ,    1.469826    ,    1.404463    
     +,    1.328223    ,    1.242810    ,    1.151266    
     +,    1.057166    ,   0.9639856    ,   0.8747674    
     +,   0.7919785    ,   0.7174640    ,   0.6523745    
     +,   0.5971350    ,   0.5514625    ,   0.5144619    
     +,   0.4848064    ,   0.4609558    ,   0.4413681    
     +,   0.4246808    ,   0.4098204    ,   0.3960466    
     +,   0.3829246    ,   0.3702528    ,   0.3579758    
     +,   0.3460974    ,   0.3346285    ,   0.3235554    
     +,   0.3128413    ,   0.3024379    ,   0.2923076    
     +,   0.2824330    ,   0.2728269    ,   0.2635296    
     +,   0.2545986    ,   0.2460977    ,   0.2380863    
     +,   0.2306101    ,   0.2236944    ,   0.2173420    
     +,   0.2115337    ,   0.2062305    ,   0.2013771    
     +,   0.1969074    ,   0.1927485    ,   0.1888271    
     +,   0.1850716    ,   0.1814182    ,   0.1778121    
     +,   0.1742104    ,   0.1705823    ,   0.1669100    
     +,   0.1631878    ,   0.1594207    ,   0.1556230    
     +,   0.1518161    ,   0.1480267    ,   0.1442840    
     +,   0.1406181    ,   0.1370579    ,   0.1336291    
     +,   0.1303531    ,   0.1272460    ,   0.1243176    
     +,   0.1215717    ,   0.1190054    ,   0.1166102    
     +,   0.1143726    ,   0.1122746    ,   0.1102956    
     +,   0.1084129    ,   0.1066035    ,   0.1048443    
     +,   0.1031144    ,   0.1013943    ,   9.9668160E-02
     +,   9.7922549E-02,   9.6147880E-02,   9.4337843E-02
     +,   9.2489317E-02,   9.0601839E-02,   8.8677458E-02
     +,   8.6720474E-02,   8.4736414E-02,   8.2732089E-02
     +,   8.0714874E-02,   7.8692503E-02,   7.6672636E-02
     +,   7.4662842E-02,   7.2670005E-02,   7.0700713E-02
     +,   6.8760790E-02,   6.6855296E-02,   6.4988859E-02
     +,   6.3165419E-02,   6.1388239E-02,   5.9660070E-02
     +,   5.7983346E-02,   5.6360088E-02,   5.4791879E-02
     +,   5.3280007E-02,   5.1825754E-02,   5.0429933E-02
     +,   4.9093343E-02,   4.7816638E-02,   4.6600327E-02
     +,   4.5444790E-02,   4.4350252E-02,   4.3316897E-02
     +,   4.2344853E-02,   4.1433971E-02,   4.0584046E-02
     +,   3.9794784E-02,   3.9065782E-02,   3.8396396E-02
     +,   3.7785895E-02,   3.7233464E-02,   3.6738083E-02
     +,   3.6298584E-02,   3.5913736E-02,   3.5582140E-02
     +,   3.5302248E-02,   3.5072457E-02,   3.4891017E-02
     +,   3.4756105E-02,   3.4665782E-02,   3.4618057E-02
     +,   3.4610871E-02,   3.4642115E-02,   3.4709614E-02
     +,   3.4811173E-02,   3.4944568E-02,   3.5107553E-02
     +,   3.5297897E-02,   3.5513364E-02,   3.5751671E-02
     +,   3.6010634E-02,   3.6288016E-02,   3.6581665E-02
     +,   3.6889367E-02,   3.7209000E-02,   3.7538417E-02
     +,   3.7875529E-02,   3.8218208E-02,   3.8564369E-02
     +,   3.8911946E-02,   3.9258774E-02,   3.9602749E-02
     +,   3.9941750E-02,   4.0273558E-02,   4.0595923E-02
     +,   4.0906630E-02,   4.1203320E-02,   4.1483611E-02
     +,   4.1745085E-02,   4.1985240E-02,   4.2201594E-02
     +,   4.2391580E-02,   4.2552613E-02,   4.2682137E-02
     +,   4.2777605E-02,   4.2836513E-02,   4.2856418E-02
     +,   4.2835001E-02,   4.2770058E-02,   4.2659540E-02
     +,   4.2501613E-02,   4.2294655E-02,   4.2037316E-02
     +,   4.1728526E-02,   4.1367535E-02,   4.0953912E-02
     +,   4.0487606E-02,   3.9968967E-02,   3.9398644E-02
     +,   3.8777694E-02,   3.8107671E-02,   3.7390340E-02
     +,   3.6627907E-02,   3.5822935E-02,   3.4978326E-02
     +,   3.4097206E-02,   3.3182960E-02,   3.2239277E-02
     +,   3.1269979E-02,   3.0279022E-02,   2.9270401E-02
     +,   2.8248282E-02,   2.7216800E-02,   2.6180007E-02
     +,   2.5141865E-02,   2.4106346E-02,   2.3077155E-02
     +,   2.2057813E-02,   2.1051716E-02,   2.0061988E-02
     +,   1.9091472E-02,   1.8142730E-02,   1.7218102E-02
     +,   1.6319651E-02,   1.5449071E-02,   1.4607797E-02
     +,   1.3797029E-02,   1.3017690E-02,   1.2270391E-02
     +,   1.1555500E-02,   1.0873225E-02,   1.0223491E-02
     +,   9.6060336E-03,   9.0204477E-03,   8.4661786E-03
     +,   7.9424959E-03,   7.4485498E-03,   6.9834320E-03
     +,   6.5461481E-03,   6.1356141E-03,   5.7507041E-03
     +,   5.3902804E-03,   5.0531840E-03,   4.7382293E-03
     +,   4.4442327E-03,   4.1700522E-03,   3.9145383E-03
     +,   3.6765707E-03,   3.4550717E-03,   3.2490043E-03
     +,   3.0573572E-03,   2.8791586E-03,   2.7134977E-03
     +,   2.5595040E-03,   2.4163441E-03,   2.2832330E-03
     +,   2.1594400E-03,   2.0442654E-03,   1.9370662E-03
     +,   1.8372296E-03,   1.7441930E-03,   1.6574229E-03
     +,   1.5764339E-03,   1.5007642E-03,   1.4299965E-03
     +,   1.3637348E-03,   1.3016236E-03,   1.2433267E-03
     +,   1.1885361E-03,   1.1369741E-03,   1.0883783E-03
     +,   1.0425145E-03,   9.9916337E-04,   9.5812848E-04
     +,   9.1922603E-04,   8.8229351E-04,   8.4717793E-04
     +,   8.1374525E-04,   7.8186794E-04,   7.5143628E-04
     +,   7.2234531E-04,   6.9450436E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_ashz_hatt60_mass = Yx/18.7453703043478
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_ashz_hatt65_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  9.7089820E-02,   0.1087683    
     +,   0.1212950    ,   0.1346237    ,   0.1486809    
     +,   0.1633653    ,   0.1785504    ,   0.1940887    
     +,   0.2098229    ,   0.2256002    ,   0.2412884    
     +,   0.2567998    ,   0.2721144    ,   0.2873024    
     +,   0.3025465    ,   0.3181552    ,   0.3345660    
     +,   0.3523315    ,   0.3720857    ,   0.3944822    
     +,   0.4201085    ,   0.4493852    ,   0.4824605    
     +,   0.5191426    ,   0.5588765    ,   0.6008254    
     +,   0.6440125    ,   0.6875361    ,   0.7307682    
     +,   0.7734755    ,   0.8158103    ,   0.8581704    
     +,   0.9009961    ,   0.9446220    ,   0.9892895    
     +,    1.035350    ,    1.083542    ,    1.135130    
     +,    1.191733    ,    1.254738    ,    1.324614    
     +,    1.400387    ,    1.479699    ,    1.559442    
     +,    1.636788    ,    1.710116    ,    1.779397    
     +,    1.845716    ,    1.910111    ,    1.972283    
     +,    2.030173    ,    2.081018    ,    2.123623    
     +,    2.160313    ,    2.196375    ,    2.236192    
     +,    2.278100    ,    2.312063    ,    2.322890    
     +,    2.297583    ,    2.231693    ,    2.130667    
     +,    2.006128    ,    1.870510    ,    1.733347    
     +,    1.600263    ,    1.473760    ,    1.354627    
     +,    1.243107    ,    1.139610    ,    1.044801    
     +,   0.9593424    ,   0.8835415    ,   0.8172197    
     +,   0.7597758    ,   0.7103652    ,   0.6680300    
     +,   0.6317251    ,   0.6003019    ,   0.5725307    
     +,   0.5471861    ,   0.5231811    ,   0.4996997    
     +,   0.4762609    ,   0.4527151    ,   0.4291579    
     +,   0.4058347    ,   0.3830313    ,   0.3610071    
     +,   0.3399464    ,   0.3199515    ,   0.3010512    
     +,   0.2832212    ,   0.2664084    ,   0.2505541    
     +,   0.2356109    ,   0.2215490    ,   0.2083610    
     +,   0.1960540    ,   0.1846454    ,   0.1741533    
     +,   0.1645901    ,   0.1559559    ,   0.1482369    
     +,   0.1414038    ,   0.1354126    ,   0.1302073    
     +,   0.1257228    ,   0.1218869    ,   0.1186245    
     +,   0.1158605    ,   0.1135211    ,   0.1115368    
     +,   0.1098426    ,   0.1083797    ,   0.1070956    
     +,   0.1059440    ,   0.1048850    ,   0.1038848    
     +,   0.1029152    ,   0.1019533    ,   0.1009812    
     +,   9.9985421E-02,   9.8957114E-02,   9.7890504E-02
     +,   9.6783653E-02,   9.5637396E-02,   9.4455004E-02
     +,   9.3241639E-02,   9.2004053E-02,   9.0749912E-02
     +,   8.9487389E-02,   8.8224851E-02,   8.6970255E-02
     +,   8.5730970E-02,   8.4513441E-02,   8.3323032E-02
     +,   8.2163848E-02,   8.1038751E-02,   7.9949073E-02
     +,   7.8895174E-02,   7.7876031E-02,   7.6889604E-02
     +,   7.5933002E-02,   7.5002626E-02,   7.4094325E-02
     +,   7.3203683E-02,   7.2326161E-02,   7.1457326E-02
     +,   7.0592970E-02,   6.9729336E-02,   6.8863206E-02
     +,   6.7992061E-02,   6.7114137E-02,   6.6228442E-02
     +,   6.5335013E-02,   6.4434588E-02,   6.3528895E-02
     +,   6.2620312E-02,   6.1712179E-02,   6.0808301E-02
     +,   5.9913076E-02,   5.9031438E-02,   5.8168501E-02
     +,   5.7329595E-02,   5.6519926E-02,   5.5744752E-02
     +,   5.5008933E-02,   5.4316964E-02,   5.3672735E-02
     +,   5.3079598E-02,   5.2540127E-02,   5.2056093E-02
     +,   5.1628392E-02,   5.1257178E-02,   5.0941546E-02
     +,   5.0679747E-02,   5.0469324E-02,   5.0306901E-02
     +,   5.0188407E-02,   5.0109118E-02,   5.0063822E-02
     +,   5.0046824E-02,   5.0052039E-02,   5.0073206E-02
     +,   5.0103966E-02,   5.0137877E-02,   5.0168686E-02
     +,   5.0190244E-02,   5.0196778E-02,   5.0182853E-02
     +,   5.0143439E-02,   5.0074063E-02,   4.9970768E-02
     +,   4.9830213E-02,   4.9649596E-02,   4.9426787E-02
     +,   4.9160250E-02,   4.8849057E-02,   4.8492838E-02
     +,   4.8091758E-02,   4.7646560E-02,   4.7158375E-02
     +,   4.6628732E-02,   4.6059635E-02,   4.5453280E-02
     +,   4.4812124E-02,   4.4138882E-02,   4.3436371E-02
     +,   4.2707510E-02,   4.1955203E-02,   4.1182395E-02
     +,   4.0392030E-02,   3.9586883E-02,   3.8769629E-02
     +,   3.7942868E-02,   3.7109062E-02,   3.6270387E-02
     +,   3.5428923E-02,   3.4586594E-02,   3.3745050E-02
     +,   3.2905791E-02,   3.2070212E-02,   3.1239489E-02
     +,   3.0414624E-02,   2.9596452E-02,   2.8785765E-02
     +,   2.7983189E-02,   2.7189234E-02,   2.6404317E-02
     +,   2.5628805E-02,   2.4863053E-02,   2.4107249E-02
     +,   2.3361614E-02,   2.2626365E-02,   2.1901641E-02
     +,   2.1187564E-02,   2.0484321E-02,   1.9792063E-02
     +,   1.9110916E-02,   1.8441003E-02,   1.7782517E-02
     +,   1.7135631E-02,   1.6500507E-02,   1.5877293E-02
     +,   1.5266204E-02,   1.4667445E-02,   1.4081186E-02
     +,   1.3507598E-02,   1.2946904E-02,   1.2399280E-02
     +,   1.1864878E-02,   1.1343878E-02,   1.0836455E-02
     +,   1.0342730E-02,   9.8628122E-03,   9.3968110E-03
     +,   8.9448364E-03,   8.5069248E-03,   8.0830995E-03
     +,   7.6733925E-03,   7.2777998E-03,   6.8962700E-03
     +,   6.5287277E-03,   6.1751036E-03,   5.8352714E-03
     +,   5.5090776E-03,   5.1963669E-03,   4.8969579E-03
     +,   4.6106265E-03,   4.3371273E-03,   4.0762145E-03
     +,   3.8276210E-03,   3.5910469E-03,   3.3661744E-03
     +,   3.1527006E-03,   2.9502721E-03,   2.7585602E-03
     +,   2.5771987E-03,   2.4058381E-03,   2.2441030E-03
     +,   2.0916353E-03,   1.9480536E-03,   1.8129969E-03
     +,   1.6860875E-03,   1.5669673E-03,   1.4552691E-03
     +,   1.3506323E-03,   1.2527135E-03,   1.1611631E-03
     +,   1.0756513E-03,   9.9584751E-04,   9.2144043E-04
     +,   8.5211918E-04,   7.8759308E-04,   7.2757370E-04
     +,   6.7179272E-04,   6.1998505E-04,   5.7190441E-04
     +,   5.2730978E-04,   4.8597765E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_ashz_hatt65_mass = Yx/23.5544271914894
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_ashz_hatt70_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.8878907E-02,   3.1917591E-02
     +,   3.5195973E-02,   3.8721010E-02,   4.2498555E-02
     +,   4.6533402E-02,   5.0829485E-02,   5.5390187E-02
     +,   6.0218696E-02,   6.5319143E-02,   7.0696868E-02
     +,   7.6360084E-02,   8.2321391E-02,   8.8600047E-02
     +,   9.5224530E-02,   0.1022361    ,   0.1096925    
     +,   0.1176725    ,   0.1262795    ,   0.1356456    
     +,   0.1459321    ,   0.1573287    ,   0.1700467    
     +,   0.1843087    ,   0.2003292    ,   0.2182946    
     +,   0.2383341    ,   0.2604924    ,   0.2847027    
     +,   0.3107683    ,   0.3383541    ,   0.3669963    
     +,   0.3961385    ,   0.4251931    ,   0.4536333    
     +,   0.4811076    ,   0.5075514    ,   0.5332781    
     +,   0.5590118    ,   0.5858471    ,   0.6151420    
     +,   0.6483545    ,   0.6868669    ,   0.7318075    
     +,   0.7838963    ,   0.8433164    ,   0.9096177    
     +,   0.9817092    ,    1.057976    ,    1.136549    
     +,    1.215669    ,    1.293992    ,    1.370695    
     +,    1.445352    ,    1.517820    ,    1.588509    
     +,    1.659110    ,    1.733292    ,    1.816202    
     +,    1.911903    ,    2.019768    ,    2.132421    
     +,    2.237311    ,    2.321351    ,    2.376485    
     +,    2.404476    ,    2.418900    ,    2.440846    
     +,    2.487627    ,    2.561975    ,    2.651607    
     +,    2.739240    ,    2.811756    ,    2.859829    
     +,    2.872955    ,    2.840961    ,    2.763571    
     +,    2.656879    ,    2.546891    ,    2.454210    
     +,    2.382746    ,    2.320588    ,    2.250136    
     +,    2.158977    ,    2.044884    ,    1.913781    
     +,    1.774355    ,    1.633710    ,    1.496304    
     +,    1.364927    ,    1.241855    ,    1.129148    
     +,    1.028391    ,   0.9403941    ,   0.8650640    
     +,   0.8013841    ,   0.7475313    ,   0.7012287    
     +,   0.6602225    ,   0.6227412    ,   0.5877059    
     +,   0.5546712    ,   0.5235448    ,   0.4942955    
     +,   0.4667463    ,   0.4405311    ,   0.4151842    
     +,   0.3902722    ,   0.3655123    ,   0.3408340    
     +,   0.3163754    ,   0.2924234    ,   0.2693415    
     +,   0.2474917    ,   0.2271804    ,   0.2086215    
     +,   0.1919314    ,   0.1771318    ,   0.1641717    
     +,   0.1529445    ,   0.1433096    ,   0.1351093    
     +,   0.1281800    ,   0.1223600    ,   0.1174960    
     +,   0.1134466    ,   0.1100833    ,   0.1072924    
     +,   0.1049740    ,   0.1030428    ,   0.1014252    
     +,   0.1000592    ,   9.8892130E-02,   9.7879291E-02
     +,   9.6982352E-02,   9.6168369E-02,   9.5408589E-02
     +,   9.4678231E-02,   9.3955345E-02,   9.3221046E-02
     +,   9.2459060E-02,   9.1655761E-02,   9.0799861E-02
     +,   8.9882500E-02,   8.8897258E-02,   8.7839738E-02
     +,   8.6707905E-02,   8.5501768E-02,   8.4223136E-02
     +,   8.2875587E-02,   8.1464142E-02,   7.9995327E-02
     +,   7.8476772E-02,   7.6916851E-02,   7.5324595E-02
     +,   7.3709711E-02,   7.2081968E-02,   7.0451193E-02
     +,   6.8827003E-02,   6.7218877E-02,   6.5635748E-02
     +,   6.4086102E-02,   6.2577844E-02,   6.1118327E-02
     +,   5.9714060E-02,   5.8370996E-02,   5.7094410E-02
     +,   5.5888928E-02,   5.4758400E-02,   5.3706028E-02
     +,   5.2734338E-02,   5.1845200E-02,   5.1039629E-02
     +,   5.0317988E-02,   4.9679786E-02,   4.9123790E-02
     +,   4.8647795E-02,   4.8248917E-02,   4.7923222E-02
     +,   4.7665983E-02,   4.7471568E-02,   4.7333565E-02
     +,   4.7244851E-02,   4.7197476E-02,   4.7183041E-02
     +,   4.7192611E-02,   4.7216959E-02,   4.7246665E-02
     +,   4.7272217E-02,   4.7284357E-02,   4.7273993E-02
     +,   4.7232512E-02,   4.7151938E-02,   4.7024958E-02
     +,   4.6845108E-02,   4.6606846E-02,   4.6305712E-02
     +,   4.5938205E-02,   4.5502007E-02,   4.4995792E-02
     +,   4.4419408E-02,   4.3773729E-02,   4.3060537E-02
     +,   4.2282548E-02,   4.1443337E-02,   4.0547114E-02
     +,   3.9598659E-02,   3.8603324E-02,   3.7566822E-02
     +,   3.6494996E-02,   3.5393864E-02,   3.4269549E-02
     +,   3.3128098E-02,   3.1975273E-02,   3.0816693E-02
     +,   2.9657688E-02,   2.8503282E-02,   2.7357997E-02
     +,   2.6225964E-02,   2.5110992E-02,   2.4016326E-02
     +,   2.2944789E-02,   2.1898832E-02,   2.0880522E-02
     +,   1.9891432E-02,   1.8932806E-02,   1.8005617E-02
     +,   1.7110519E-02,   1.6247844E-02,   1.5417708E-02
     +,   1.4620043E-02,   1.3854633E-02,   1.3121048E-02
     +,   1.2418734E-02,   1.1747116E-02,   1.1105459E-02
     +,   1.0492987E-02,   9.9089006E-03,   9.3523720E-03
     +,   8.8225165E-03,   8.3184401E-03,   7.8392755E-03
     +,   7.3841494E-03,   6.9521694E-03,   6.5424507E-03
     +,   6.1541446E-03,   5.7864203E-03,   5.4384293E-03
     +,   5.1093451E-03,   4.7983900E-03,   4.5047649E-03
     +,   4.2276965E-03,   3.9664437E-03,   3.7202826E-03
     +,   3.4884908E-03,   3.2703662E-03,   3.0652406E-03
     +,   2.8724622E-03,   2.6913879E-03,   2.5213959E-03
     +,   2.3618960E-03,   2.2123186E-03,   2.0721033E-03
     +,   1.9407141E-03,   1.8176498E-03,   1.7024158E-03
     +,   1.5945429E-03,   1.4935890E-03,   1.3991322E-03
     +,   1.3107678E-03,   1.2281105E-03,   1.1508018E-03
     +,   1.0785020E-03,   1.0108860E-03,   9.4764854E-04
     +,   8.8850758E-04,   8.3319104E-04,   7.8145042E-04
     +,   7.3304644E-04,   6.8776152E-04,   6.4538518E-04
     +,   6.0572760E-04,   5.6860526E-04,   5.3385226E-04
     +,   5.0130917E-04,   4.7083132E-04,   4.4228116E-04
     +,   4.1553023E-04,   3.9046150E-04,   3.6696263E-04
     +,   3.4493199E-04,   3.2427211E-04,   3.0489470E-04
     +,   2.8671484E-04,   2.6965598E-04,   2.5364425E-04
     +,   2.3861311E-04,   2.2449835E-04,   2.1124199E-04
     +,   1.9878811E-04,   1.8708636E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_ashz_hatt70_mass = Yx/29.1508148571429
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_ashz_hatt75_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.0325131E-02,   3.2369524E-02
     +,   3.4482751E-02,   3.6661576E-02,   3.8902633E-02
     +,   4.1202687E-02,   4.3558769E-02,   4.5968499E-02
     +,   4.8430424E-02,   5.0944544E-02,   5.3512659E-02
     +,   5.6138929E-02,   5.8830731E-02,   6.1599042E-02
     +,   6.4459316E-02,   6.7431927E-02,   7.0542596E-02
     +,   7.3822610E-02,   7.7308655E-02,   8.1042215E-02
     +,   8.5068427E-02,   8.9434586E-02,   9.4187647E-02
     +,   9.9372506E-02,   0.1050283    ,   0.1111865    
     +,   0.1178681    ,   0.1250823    ,   0.1328254    
     +,   0.1410815    ,   0.1498238    ,   0.1590175    
     +,   0.1686233    ,   0.1786010    ,   0.1889131    
     +,   0.1995285    ,   0.2104242    ,   0.2215873    
     +,   0.2330161    ,   0.2447210    ,   0.2567270    
     +,   0.2690761    ,   0.2818305    ,   0.2950765    
     +,   0.3089261    ,   0.3235161    ,   0.3390089    
     +,   0.3555895    ,   0.3734638    ,   0.3928590    
     +,   0.4140227    ,   0.4372253    ,   0.4627602    
     +,   0.4909517    ,   0.5221634    ,   0.5568085    
     +,   0.5953288    ,   0.6381190    ,   0.6853682    
     +,   0.7368435    ,   0.7916897    ,   0.8483852    
     +,   0.9049839    ,   0.9597633    ,    1.012156    
     +,    1.063678    ,    1.118276    ,    1.181495    
     +,    1.258459    ,    1.351587    ,    1.459772    
     +,    1.579917    ,    1.709537    ,    1.847164    
     +,    1.989127    ,    2.125968    ,    2.244765    
     +,    2.339259    ,    2.420130    ,    2.512901    
     +,    2.639284    ,    2.795593    ,    2.951797    
     +,    3.078148    ,    3.173541    ,    3.263399    
     +,    3.369819    ,    3.489926    ,    3.602438    
     +,    3.686936    ,    3.734668    ,    3.750116    
     +,    3.745559    ,    3.726928    ,    3.683953    
     +,    3.601149    ,    3.476095    ,    3.319588    
     +,    3.143441    ,    2.955724    ,    2.762234    
     +,    2.565401    ,    2.363594    ,    2.155546    
     +,    1.945248    ,    1.741941    ,    1.555515    
     +,    1.391658    ,    1.250273    ,    1.127576    
     +,    1.019413    ,   0.9231315    ,   0.8374525    
     +,   0.7614006    ,   0.6937021    ,   0.6328677    
     +,   0.5776132    ,   0.5270795    ,   0.4808125    
     +,   0.4385904    ,   0.4002804    ,   0.3657638    
     +,   0.3349088    ,   0.3075572    ,   0.2835201    
     +,   0.2625717    ,   0.2444456    ,   0.2288501    
     +,   0.2154793    ,   0.2040333    ,   0.1942275    
     +,   0.1858035    ,   0.1785315    ,   0.1722133    
     +,   0.1666801    ,   0.1617917    ,   0.1574332    
     +,   0.1535102    ,   0.1499449    ,   0.1466710    
     +,   0.1436304    ,   0.1407696    ,   0.1380374    
     +,   0.1353850    ,   0.1327658    ,   0.1301363    
     +,   0.1274576    ,   0.1246970    ,   0.1218294    
     +,   0.1188381    ,   0.1157154    ,   0.1124627    
     +,   0.1090901    ,   0.1056147    ,   0.1020599    
     +,   9.8453723E-02,   9.4826825E-02,   9.1211028E-02
     +,   8.7637335E-02,   8.4135525E-02,   8.0731936E-02
     +,   7.7449508E-02,   7.4306995E-02,   7.1319021E-02
     +,   6.8495803E-02,   6.5843672E-02,   6.3365728E-02
     +,   6.1062120E-02,   5.8930583E-02,   5.6967132E-02
     +,   5.5166740E-02,   5.3523578E-02,   5.2031375E-02
     +,   5.0683811E-02,   4.9474839E-02,   4.8398379E-02
     +,   4.7448680E-02,   4.6620242E-02,   4.5907587E-02
     +,   4.5305308E-02,   4.4807840E-02,   4.4409435E-02
     +,   4.4104096E-02,   4.3885332E-02,   4.3746274E-02
     +,   4.3679610E-02,   4.3677539E-02,   4.3731861E-02
     +,   4.3833993E-02,   4.3975011E-02,   4.4145882E-02
     +,   4.4337392E-02,   4.4540312E-02,   4.4745587E-02
     +,   4.4944331E-02,   4.5127962E-02,   4.5288309E-02
     +,   4.5417745E-02,   4.5509193E-02,   4.5556147E-02
     +,   4.5552880E-02,   4.5494333E-02,   4.5376282E-02
     +,   4.5195170E-02,   4.4948310E-02,   4.4633795E-02
     +,   4.4250418E-02,   4.3797806E-02,   4.3276276E-02
     +,   4.2686835E-02,   4.2031128E-02,   4.1311450E-02
     +,   4.0530644E-02,   3.9692052E-02,   3.8799435E-02
     +,   3.7857015E-02,   3.6869347E-02,   3.5841219E-02
     +,   3.4777619E-02,   3.3683792E-02,   3.2564998E-02
     +,   3.1426489E-02,   3.0273618E-02,   2.9111639E-02
     +,   2.7945634E-02,   2.6780481E-02,   2.5620954E-02
     +,   2.4471559E-02,   2.3336448E-02,   2.2219472E-02
     +,   2.1124212E-02,   2.0053906E-02,   1.9011339E-02
     +,   1.7998958E-02,   1.7018918E-02,   1.6072918E-02
     +,   1.5162298E-02,   1.4288116E-02,   1.3451093E-02
     +,   1.2651580E-02,   1.1889657E-02,   1.1165168E-02
     +,   1.0477732E-02,   9.8266965E-03,   9.2112292E-03
     +,   8.6303707E-03,   8.0830343E-03,   7.5679854E-03
     +,   7.0838989E-03,   6.6294456E-03,   6.2031983E-03
     +,   5.8037182E-03,   5.4295831E-03,   5.0793812E-03
     +,   4.7516967E-03,   4.4451542E-03,   4.1584410E-03
     +,   3.8902948E-03,   3.6394859E-03,   3.4048527E-03
     +,   3.1853104E-03,   2.9798376E-03,   2.7874617E-03
     +,   2.6072769E-03,   2.4384568E-03,   2.2802169E-03
     +,   2.1318335E-03,   1.9926461E-03,   1.8620450E-03
     +,   1.7394603E-03,   1.6243666E-03,   1.5162887E-03
     +,   1.4147876E-03,   1.3194531E-03,   1.2299069E-03
     +,   1.1458073E-03,   1.0668286E-03,   9.9267776E-04
     +,   9.2307379E-04,   8.5776328E-04,   7.9650182E-04
     +,   7.3906808E-04,   6.8524701E-04,   6.3484325E-04
     +,   5.8766600E-04,   5.4354122E-04,   5.0229940E-04
     +,   4.6378007E-04,   4.2783437E-04,   3.9431619E-04
     +,   3.6309037E-04,   3.3402428E-04,   3.0699515E-04
     +,   2.8188247E-04,   2.5857432E-04,   2.3696107E-04
     +,   2.1694077E-04,   1.9841391E-04,   1.8128792E-04
     +,   1.6547252E-04,   1.5088391E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_ashz_hatt75_mass = Yx/34.34618348
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_ashz_hatt80_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  9.3587283E-03,   9.7634625E-03
     +,   1.0176606E-02,   1.0598793E-02,   1.1030913E-02
     +,   1.1474124E-02,   1.1929884E-02,   1.2399987E-02
     +,   1.2886576E-02,   1.3392184E-02,   1.3919702E-02
     +,   1.4472413E-02,   1.5053990E-02,   1.5668452E-02
     +,   1.6320175E-02,   1.7013818E-02,   1.7754311E-02
     +,   1.8546766E-02,   1.9396471E-02,   2.0308770E-02
     +,   2.1289060E-02,   2.2342719E-02,   2.3475049E-02
     +,   2.4691375E-02,   2.5996823E-02,   2.7396640E-02
     +,   2.8896086E-02,   3.0500555E-02,   3.2215819E-02
     +,   3.4048103E-02,   3.6004454E-02,   3.8092881E-02
     +,   4.0322728E-02,   4.2705055E-02,   4.5252930E-02
     +,   4.7981836E-02,   5.0910100E-02,   5.4059222E-02
     +,   5.7454344E-02,   6.1124150E-02,   6.5101728E-02
     +,   6.9423765E-02,   7.4130803E-02,   7.9266392E-02
     +,   8.4876440E-02,   9.1007747E-02,   9.7706802E-02
     +,   0.1050182    ,   0.1129836    ,   0.1216412    
     +,   0.1310263    ,   0.1411728    ,   0.1521161    
     +,   0.1638971    ,   0.1765624    ,   0.1901672    
     +,   0.2047680    ,   0.2204129    ,   0.2371208    
     +,   0.2548589    ,   0.2735124    ,   0.2928665    
     +,   0.3125969    ,   0.3322968    ,   0.3515306    
     +,   0.3699290    ,   0.3873116    ,   0.4038033    
     +,   0.4199250    ,   0.4366010    ,   0.4550839    
     +,   0.4767796    ,   0.5030434    ,   0.5349808    
     +,   0.5733427    ,   0.6185031    ,   0.6704757    
     +,   0.7288824    ,   0.7928104    ,   0.8605960    
     +,   0.9298060    ,   0.9977559    ,    1.062670    
     +,    1.125086    ,    1.188419    ,    1.257943    
     +,    1.338464    ,    1.432275    ,    1.538701    
     +,    1.654920    ,    1.776857    ,    1.900340    
     +,    2.023448    ,    2.148698    ,    2.281808    
     +,    2.427346    ,    2.586743    ,    2.760889    
     +,    2.951709    ,    3.157923    ,    3.370757    
     +,    3.573372    ,    3.746351    ,    3.892474    
     +,    4.066661    ,    4.345761    ,    4.738750    
     +,    5.151284    ,    5.452985    ,    5.566506    
     +,    5.515403    ,    5.395977    ,    5.279974    
     +,    5.157672    ,    4.964657    ,    4.651299    
     +,    4.256376    ,    3.876390    ,    3.550322    
     +,    3.243451    ,    2.924524    ,    2.594638    
     +,    2.265837    ,    1.952308    ,    1.671852    
     +,    1.438373    ,    1.253565    ,    1.108230    
     +,   0.9895539    ,   0.8871802    ,   0.7952478    
     +,   0.7116322    ,   0.6361448    ,   0.5690337    
     +,   0.5101724    ,   0.4589348    ,   0.4144125    
     +,   0.3756723    ,   0.3419039    ,   0.3124511    
     +,   0.2867737    ,   0.2643937    ,   0.2448641    
     +,   0.2277613    ,   0.2126911    ,   0.1992946    
     +,   0.1872583    ,   0.1763194    ,   0.1662658    
     +,   0.1569337    ,   0.1482040    ,   0.1399976    
     +,   0.1322668    ,   0.1249887    ,   0.1181569    
     +,   0.1117763    ,   0.1058557    ,   0.1004025    
     +,   9.5419869E-02,   9.0904348E-02,   8.6843878E-02
     +,   8.3218336E-02,   8.0000438E-02,   7.7156767E-02
     +,   7.4649543E-02,   7.2438814E-02,   7.0484318E-02
     +,   6.8746872E-02,   6.7189902E-02,   6.5780230E-02
     +,   6.4488977E-02,   6.3291632E-02,   6.2168036E-02
     +,   6.1102182E-02,   6.0081948E-02,   5.9098329E-02
     +,   5.8145035E-02,   5.7217896E-02,   5.6314308E-02
     +,   5.5432655E-02,   5.4571964E-02,   5.3731523E-02
     +,   5.2910738E-02,   5.2108753E-02,   5.1324341E-02
     +,   5.0556097E-02,   4.9802229E-02,   4.9060617E-02
     +,   4.8328906E-02,   4.7604676E-02,   4.6885435E-02
     +,   4.6168711E-02,   4.5452237E-02,   4.4733975E-02
     +,   4.4012129E-02,   4.3285221E-02,   4.2552162E-02
     +,   4.1812211E-02,   4.1064959E-02,   4.0310267E-02
     +,   3.9548349E-02,   3.8779672E-02,   3.8004797E-02
     +,   3.7224464E-02,   3.6439538E-02,   3.5650879E-02
     +,   3.4859303E-02,   3.4065682E-02,   3.3270784E-02
     +,   3.2475267E-02,   3.1679679E-02,   3.0884501E-02
     +,   3.0090170E-02,   2.9296933E-02,   2.8504990E-02
     +,   2.7714537E-02,   2.6925739E-02,   2.6138710E-02
     +,   2.5353571E-02,   2.4570562E-02,   2.3789901E-02
     +,   2.3011886E-02,   2.2236947E-02,   2.1465611E-02
     +,   2.0698464E-02,   1.9936174E-02,   1.9179597E-02
     +,   1.8429637E-02,   1.7687265E-02,   1.6953504E-02
     +,   1.6229490E-02,   1.5516390E-02,   1.4815342E-02
     +,   1.4127488E-02,   1.3454014E-02,   1.2796003E-02
     +,   1.2154495E-02,   1.1530477E-02,   1.0924877E-02
     +,   1.0338470E-02,   9.7719301E-03,   9.2258509E-03
     +,   8.7007163E-03,   8.1968410E-03,   7.7144266E-03
     +,   7.2535821E-03,   6.8143047E-03,   6.3964361E-03
     +,   5.9997290E-03,   5.6238696E-03,   5.2684192E-03
     +,   4.9328613E-03,   4.6166307E-03,   4.3191039E-03
     +,   4.0395875E-03,   3.7773489E-03,   3.5316467E-03
     +,   3.3017164E-03,   3.0867667E-03,   2.8860017E-03
     +,   2.6986462E-03,   2.5239303E-03,   2.3610888E-03
     +,   2.2093777E-03,   2.0680903E-03,   1.9365335E-03
     +,   1.8140444E-03,   1.6999989E-03,   1.5938056E-03
     +,   1.4948985E-03,   1.4027458E-03,   1.3168552E-03
     +,   1.2367658E-03,   1.1620444E-03,   1.0922881E-03
     +,   1.0271297E-03,   9.6622249E-04,   9.0925314E-04
     +,   8.5592625E-04,   8.0597698E-04,   7.5915479E-04
     +,   7.1523630E-04,   6.7401060E-04,   6.3528930E-04
     +,   5.9889478E-04,   5.6466862E-04,   5.3246209E-04
     +,   5.0213857E-04,   4.7357572E-04,   4.4665698E-04
     +,   4.2127864E-04,   3.9734168E-04,   3.7475786E-04
     +,   3.5344274E-04,   3.3332099E-04,   3.1431986E-04
     +,   2.9637455E-04,   2.7942250E-04,   2.6340736E-04
     +,   2.4827480E-04,   2.3397598E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_ashz_hatt80_mass = Yx/39.436430627451
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_ashz_hatt85_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.8900666E-03,   5.0447877E-03
     +,   5.2013868E-03,   5.3597130E-03,   5.5196146E-03
     +,   5.6809373E-03,   5.8435267E-03,   6.0072388E-03
     +,   6.1719231E-03,   6.3374545E-03,   6.5037068E-03
     +,   6.6705770E-03,   6.8379822E-03,   7.0058629E-03
     +,   7.1741878E-03,   7.3429621E-03,   7.5122346E-03
     +,   7.6820855E-03,   7.8526624E-03,   8.0241608E-03
     +,   8.1968457E-03,   8.3710486E-03,   8.5471831E-03
     +,   8.7257577E-03,   8.9073665E-03,   9.0927240E-03
     +,   9.2826588E-03,   9.4781313E-03,   9.6802497E-03
     +,   9.8902769E-03,   1.0109660E-02,   1.0340035E-02
     +,   1.0583250E-02,   1.0841371E-02,   1.1116716E-02
     +,   1.1411868E-02,   1.1729675E-02,   1.2073275E-02
     +,   1.2446109E-02,   1.2851877E-02,   1.3294623E-02
     +,   1.3778614E-02,   1.4308417E-02,   1.4888799E-02
     +,   1.5524725E-02,   1.6221318E-02,   1.6983792E-02
     +,   1.7817413E-02,   1.8727433E-02,   1.9719075E-02
     +,   2.0797446E-02,   2.1967523E-02,   2.3234120E-02
     +,   2.4601955E-02,   2.6075425E-02,   2.7658880E-02
     +,   2.9356407E-02,   3.1171851E-02,   3.3108819E-02
     +,   3.5170510E-02,   3.7359662E-02,   3.9678361E-02
     +,   4.2127650E-02,   4.4707604E-02,   4.7416896E-02
     +,   5.0252363E-02,   5.3209409E-02,   5.6281462E-02
     +,   5.9460916E-02,   6.2739052E-02,   6.6107988E-02
     +,   6.9561385E-02,   7.3097371E-02,   7.6720394E-02
     +,   8.0445021E-02,   8.4298924E-02,   8.8326186E-02
     +,   9.2590906E-02,   9.7180739E-02,   0.1022092    
     +,   0.1078176    ,   0.1141770    ,   0.1214866    
     +,   0.1299726    ,   0.1398797    ,   0.1514624    
     +,   0.1649652    ,   0.1806044    ,   0.1985389    
     +,   0.2188519    ,   0.2415339    ,   0.2664775    
     +,   0.2934924    ,   0.3223286    ,   0.3527092    
     +,   0.3843565    ,   0.4170306    ,   0.4505688    
     +,   0.4849720    ,   0.5205098    ,   0.5578572    
     +,   0.5981439    ,   0.6428654    ,   0.6936009    
     +,   0.7516904    ,   0.8181086    ,   0.8938463    
     +,   0.9808651    ,    1.083077    ,    1.206189    
     +,    1.355367    ,    1.531262    ,    1.726800    
     +,    1.927677    ,    2.116488    ,    2.280230    
     +,    2.423018    ,    2.578384    ,    2.797816    
     +,    3.106507    ,    3.462782    ,    3.772636    
     +,    3.980053    ,    4.150391    ,    4.396260    
     +,    4.737402    ,    5.116126    ,    5.461644    
     +,    5.710151    ,    5.860148    ,    5.963827    
     +,    6.060795    ,    6.145049    ,    6.168015    
     +,    6.124820    ,    6.046587    ,    5.898988    
     +,    5.616830    ,    5.171321    ,    4.601410    
     +,    3.984772    ,    3.393254    ,    2.878006    
     +,    2.449658    ,    2.090418    ,    1.788144    
     +,    1.542438    ,    1.349386    ,    1.194740    
     +,    1.062235    ,   0.9431865    ,   0.8372003    
     +,   0.7467647    ,   0.6724291    ,   0.6115093    
     +,   0.5594553    ,   0.5118789    ,   0.4658689    
     +,   0.4202849    ,   0.3753480    ,   0.3319863    
     +,   0.2912819    ,   0.2541215    ,   0.2210461    
     +,   0.1922446    ,   0.1676278    ,   0.1469257    
     +,   0.1297729    ,   0.1157711    ,   0.1045311    
     +,   9.5691442E-02,   8.8922836E-02,   8.3927371E-02
     +,   8.0435693E-02,   7.8203812E-02,   7.7010266E-02
     +,   7.6654956E-02,   7.6957814E-02,   7.7757992E-02
     +,   7.8912422E-02,   8.0295034E-02,   8.1795096E-02
     +,   8.3316252E-02,   8.4775798E-02,   8.6103611E-02
     +,   8.7241389E-02,   8.8142321E-02,   8.8770434E-02
     +,   8.9100085E-02,   8.9115143E-02,   8.8808574E-02
     +,   8.8181131E-02,   8.7241046E-02,   8.6002603E-02
     +,   8.4485017E-02,   8.2711488E-02,   8.0708183E-02
     +,   7.8503035E-02,   7.6124720E-02,   7.3601887E-02
     +,   7.0962861E-02,   6.8234578E-02,   6.5442398E-02
     +,   6.2609904E-02,   5.9759025E-02,   5.6909516E-02
     +,   5.4079268E-02,   5.1284593E-02,   4.8540007E-02
     +,   4.5858294E-02,   4.3250747E-02,   4.0727247E-02
     +,   3.8296230E-02,   3.5964467E-02,   3.3737373E-02
     +,   3.1618949E-02,   2.9611815E-02,   2.7717005E-02
     +,   2.5934257E-02,   2.4262173E-02,   2.2698104E-02
     +,   2.1238364E-02,   1.9878555E-02,   1.8613603E-02
     +,   1.7437845E-02,   1.6345361E-02,   1.5330132E-02
     +,   1.4386163E-02,   1.3507527E-02,   1.2688578E-02
     +,   1.1924043E-02,   1.1209045E-02,   1.0539079E-02
     +,   9.9101104E-03,   9.3186013E-03,   8.7613836E-03
     +,   8.2356976E-03,   7.7391798E-03,   7.2697992E-03
     +,   6.8257689E-03,   6.4055668E-03,   6.0078874E-03
     +,   5.6316010E-03,   5.2756793E-03,   4.9392050E-03
     +,   4.6213628E-03,   4.3213926E-03,   4.0385593E-03
     +,   3.7721547E-03,   3.5215197E-03,   3.2859754E-03
     +,   3.0648590E-03,   2.8575223E-03,   2.6633211E-03
     +,   2.4816056E-03,   2.3117294E-03,   2.1530665E-03
     +,   2.0049997E-03,   1.8669149E-03,   1.7382121E-03
     +,   1.6183190E-03,   1.5066807E-03,   1.4027558E-03
     +,   1.3060269E-03,   1.2160109E-03,   1.1322387E-03
     +,   1.0542686E-03,   9.8168931E-04,   9.1411511E-04
     +,   8.5118093E-04,   7.9254684E-04,   7.3790137E-04
     +,   6.8695523E-04,   6.3943816E-04,   5.9510110E-04
     +,   5.5371854E-04,   5.1507819E-04,   4.7898979E-04
     +,   4.4527402E-04,   4.1377053E-04,   3.8432807E-04
     +,   3.5681154E-04,   3.3109283E-04,   3.0705766E-04
     +,   2.8459728E-04,   2.6361409E-04,   2.4401573E-04
     +,   2.2571640E-04,   2.0863822E-04,   1.9270618E-04
     +,   1.7785230E-04,   1.6401097E-04,   1.5112234E-04
     +,   1.3912837E-04,   1.2797606E-04,   1.1761381E-04
     +,   1.0799420E-04,   9.9071141E-05,   9.0802067E-05
     +,   8.3145642E-05,   7.6063596E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_ashz_hatt85_mass = Yx/40.9704957254902
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_ashz_hatt90_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  5.2041467E-03,   5.3738235E-03
     +,   5.5450746E-03,   5.7177688E-03,   5.8917780E-03
     +,   6.0669794E-03,   6.2432545E-03,   6.4204941E-03
     +,   6.5985918E-03,   6.7774598E-03,   6.9570104E-03
     +,   7.1371663E-03,   7.3178648E-03,   7.4990490E-03
     +,   7.6806769E-03,   7.8627151E-03,   8.0451425E-03
     +,   8.2279472E-03,   8.4111299E-03,   8.5946983E-03
     +,   8.7786717E-03,   8.9630783E-03,   9.1479495E-03
     +,   9.3333377E-03,   9.5192799E-03,   9.7058350E-03
     +,   9.8930579E-03,   1.0081008E-02,   1.0269745E-02
     +,   1.0459332E-02,   1.0649825E-02,   1.0841285E-02
     +,   1.1033768E-02,   1.1227318E-02,   1.1421993E-02
     +,   1.1617832E-02,   1.1814874E-02,   1.2013152E-02
     +,   1.2212710E-02,   1.2413557E-02,   1.2615737E-02
     +,   1.2819272E-02,   1.3024199E-02,   1.3230538E-02
     +,   1.3438346E-02,   1.3647665E-02,   1.3858563E-02
     +,   1.4071120E-02,   1.4285424E-02,   1.4501601E-02
     +,   1.4719795E-02,   1.4940168E-02,   1.5162916E-02
     +,   1.5388275E-02,   1.5616493E-02,   1.5847864E-02
     +,   1.6082702E-02,   1.6321344E-02,   1.6564161E-02
     +,   1.6811538E-02,   1.7063878E-02,   1.7321590E-02
     +,   1.7585082E-02,   1.7854767E-02,   1.8131051E-02
     +,   1.8414307E-02,   1.8704912E-02,   1.9003181E-02
     +,   1.9309454E-02,   1.9624000E-02,   1.9947104E-02
     +,   2.0279000E-02,   2.0619972E-02,   2.0970259E-02
     +,   2.1330204E-02,   2.1700181E-02,   2.2080658E-02
     +,   2.2472214E-02,   2.2875654E-02,   2.3291990E-02
     +,   2.3722483E-02,   2.4168797E-02,   2.4632992E-02
     +,   2.5117645E-02,   2.5625963E-02,   2.6161904E-02
     +,   2.6730290E-02,   2.7337028E-02,   2.7989166E-02
     +,   2.8695239E-02,   2.9465318E-02,   3.0311184E-02
     +,   3.1246463E-02,   3.2286730E-02,   3.3449426E-02
     +,   3.4753598E-02,   3.6219798E-02,   3.7869308E-02
     +,   3.9723892E-02,   4.1804641E-02,   4.4131547E-02
     +,   4.6722326E-02,   4.9592510E-02,   5.2754276E-02
     +,   5.6217711E-02,   5.9991337E-02,   6.4083673E-02
     +,   6.8506025E-02,   7.3276401E-02,   7.8423604E-02
     +,   8.3992071E-02,   9.0049244E-02,   9.6691169E-02
     +,   0.1040517    ,   0.1123081    ,   0.1216887    
     +,   0.1324697    ,   0.1449689    ,   0.1595169    
     +,   0.1764172    ,   0.1958821    ,   0.2179602    
     +,   0.2424714    ,   0.2689815    ,   0.2968388    
     +,   0.3253046    ,   0.3537901    ,   0.3821403    
     +,   0.4109119    ,   0.4414919    ,   0.4759765    
     +,   0.5167246    ,   0.5656883    ,   0.6236973    
     +,   0.6900330    ,   0.7625626    ,   0.8386489    
     +,   0.9167855    ,   0.9982786    ,    1.087664    
     +,    1.191035    ,    1.313851    ,    1.461711    
     +,    1.644578    ,    1.878125    ,    2.175200    
     +,    2.529645    ,    2.907260    ,    3.263836    
     +,    3.586769    ,    3.909968    ,    4.278051    
     +,    4.709488    ,    5.207706    ,    5.787441    
     +,    6.400764    ,    6.891562    ,    7.093929    
     +,    7.036058    ,    7.046195    ,    7.254000    
     +,    7.401827    ,    7.206175    ,    6.635252    
     +,    5.909229    ,    5.189042    ,    4.487127    
     +,    3.786679    ,    3.109149    ,    2.498788    
     +,    1.986710    ,    1.584367    ,    1.288427    
     +,    1.082082    ,   0.9412195    ,   0.8435517    
     +,   0.7732018    ,   0.7207416    ,   0.6814149    
     +,   0.6528019    ,   0.6327515    ,   0.6183677    
     +,   0.6062196    ,   0.5932251    ,   0.5774542    
     +,   0.5584021    ,   0.5367101    ,   0.5135837    
     +,   0.4902182    ,   0.4674217    ,   0.4454948    
     +,   0.4243084    ,   0.4034882    ,   0.3826072    
     +,   0.3613409    ,   0.3395607    ,   0.3173656    
     +,   0.2950538    ,   0.2730583    ,   0.2518659    
     +,   0.2319344    ,   0.2136234    ,   0.1971511    
     +,   0.1825831    ,   0.1698447    ,   0.1587502    
     +,   0.1490432    ,   0.1404385    ,   0.1326550    
     +,   0.1254418    ,   0.1185939    ,   0.1119594    
     +,   0.1054382    ,   9.8975919E-02,   9.2556611E-02
     +,   8.6193107E-02,   7.9918027E-02,   7.3774651E-02
     +,   6.7810647E-02,   6.2072925E-02,   5.6602541E-02
     +,   5.1432800E-02,   4.6588082E-02,   4.2083230E-02
     +,   3.7923694E-02,   3.4107000E-02,   3.0624242E-02
     +,   2.7461352E-02,   2.4600338E-02,   2.2020971E-02
     +,   1.9702023E-02,   1.7621992E-02,   1.5759716E-02
     +,   1.4094985E-02,   1.2608966E-02,   1.1284073E-02
     +,   1.0104136E-02,   9.0544680E-03,   8.1216814E-03
     +,   7.2935340E-03,   6.5589184E-03,   5.9077828E-03
     +,   5.3309901E-03,   4.8202048E-03,   4.3678698E-03
     +,   3.9671781E-03,   3.6119781E-03,   3.2967154E-03
     +,   3.0164237E-03,   2.7667012E-03,   2.5436231E-03
     +,   2.3437373E-03,   2.1640291E-03,   2.0018730E-03
     +,   1.8549873E-03,   1.7214069E-03,   1.5994554E-03
     +,   1.4877009E-03,   1.3849204E-03,   1.2900750E-03
     +,   1.2022904E-03,   1.1208259E-03,   1.0450467E-03
     +,   9.7441446E-04,   9.0847502E-04,   8.4683183E-04
     +,   7.8914256E-04,   7.3511223E-04,   6.8448205E-04
     +,   6.3701888E-04,   5.9251493E-04,   5.5078533E-04
     +,   5.1166239E-04,   4.7498991E-04,   4.4062408E-04
     +,   4.0843512E-04,   3.7829750E-04,   3.5009824E-04
     +,   3.2372726E-04,   2.9908435E-04,   2.7607166E-04
     +,   2.5459944E-04,   2.3457967E-04,   2.1593152E-04
     +,   1.9857558E-04,   1.8243826E-04,   1.6744807E-04
     +,   1.5353685E-04,   1.4064077E-04,   1.2869743E-04
     +,   1.1764886E-04,   1.0743831E-04,   9.8013094E-05
     +,   8.9321780E-05,   8.1316684E-05,   7.3951393E-05
     +,   6.7182860E-05,   6.0969363E-05,   5.5272267E-05
     +,   5.0054292E-05,   4.5280929E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_ashz_hatt90_mass = Yx/39.8528197254902
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_ashz_hatt95_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  6.1938325E-03,   6.3824621E-03
     +,   6.5729334E-03,   6.7651067E-03,   6.9588348E-03
     +,   7.1539730E-03,   7.3503740E-03,   7.5479001E-03
     +,   7.7464166E-03,   7.9458067E-03,   8.1459628E-03
     +,   8.3468007E-03,   8.5482579E-03,   8.7503036E-03
     +,   8.9529548E-03,   9.1562578E-03,   9.3603283E-03
     +,   9.5653338E-03,   9.7715156E-03,   9.9791922E-03
     +,   1.0188780E-02,   1.0400789E-02,   1.0615832E-02
     +,   1.0834657E-02,   1.1058104E-02,   1.1287184E-02
     +,   1.1523008E-02,   1.1766846E-02,   1.2020096E-02
     +,   1.2284295E-02,   1.2561110E-02,   1.2852319E-02
     +,   1.3159809E-02,   1.3485557E-02,   1.3831591E-02
     +,   1.4199985E-02,   1.4592793E-02,   1.5012046E-02
     +,   1.5459703E-02,   1.5937565E-02,   1.6447291E-02
     +,   1.6990300E-02,   1.7567726E-02,   1.8180376E-02
     +,   1.8828684E-02,   1.9512642E-02,   2.0231774E-02
     +,   2.0985089E-02,   2.1771042E-02,   2.2587553E-02
     +,   2.3431944E-02,   2.4300968E-02,   2.5190795E-02
     +,   2.6097123E-02,   2.7015051E-02,   2.7939305E-02
     +,   2.8864197E-02,   2.9783718E-02,   3.0691663E-02
     +,   3.1581625E-02,   3.2447267E-02,   3.3282235E-02
     +,   3.4080364E-02,   3.4835786E-02,   3.5543073E-02
     +,   3.6197178E-02,   3.6793709E-02,   3.7328877E-02
     +,   3.7799682E-02,   3.8203813E-02,   3.8539886E-02
     +,   3.8807247E-02,   3.9006226E-02,   3.9137919E-02
     +,   3.9204277E-02,   3.9208081E-02,   3.9152782E-02
     +,   3.9042670E-02,   3.8882513E-02,   3.8677707E-02
     +,   3.8434114E-02,   3.8157944E-02,   3.7855741E-02
     +,   3.7534196E-02,   3.7200168E-02,   3.6860459E-02
     +,   3.6521900E-02,   3.6191121E-02,   3.5874564E-02
     +,   3.5578396E-02,   3.5308436E-02,   3.5070129E-02
     +,   3.4868557E-02,   3.4708314E-02,   3.4593564E-02
     +,   3.4528047E-02,   3.4515042E-02,   3.4557454E-02
     +,   3.4657780E-02,   3.4818251E-02,   3.5040785E-02
     +,   3.5327110E-02,   3.5678849E-02,   3.6097527E-02
     +,   3.6584657E-02,   3.7141863E-02,   3.7770823E-02
     +,   3.8473301E-02,   3.9251197E-02,   4.0106580E-02
     +,   4.1041423E-02,   4.2057775E-02,   4.3157410E-02
     +,   4.4341952E-02,   4.5612425E-02,   4.6969432E-02
     +,   4.8412599E-02,   4.9940992E-02,   5.1552333E-02
     +,   5.3243577E-02,   5.5010650E-02,   5.6848451E-02
     +,   5.8751136E-02,   6.0712550E-02,   6.2726431E-02
     +,   6.4786650E-02,   6.6888116E-02,   6.9026895E-02
     +,   7.1201146E-02,   7.3411033E-02,   7.5659886E-02
     +,   7.7953674E-02,   8.0301955E-02,   8.2716979E-02
     +,   8.5214294E-02,   8.7811790E-02,   9.0528898E-02
     +,   9.3386211E-02,   9.6404299E-02,   9.9602669E-02
     +,   0.1029985    ,   0.1066062    ,   0.1104362    
     +,   0.1144950    ,   0.1187846    ,   0.1233033    
     +,   0.1280465    ,   0.1330076    ,   0.1381793    
     +,   0.1435555    ,   0.1491316    ,   0.1549051    
     +,   0.1608744    ,   0.1670382    ,   0.1733910    
     +,   0.1799191    ,   0.1865954    ,   0.1933751    
     +,   0.2001916    ,   0.2069532    ,   0.2135462    
     +,   0.2198402    ,   0.2256982    ,   0.2309934    
     +,   0.2356301    ,   0.2395687    ,   0.2428511    
     +,   0.2456251    ,   0.2481603    ,   0.2508524    
     +,   0.2542090    ,   0.2588158    ,   0.2652880    
     +,   0.2742148    ,   0.2861170    ,   0.3014424    
     +,   0.3206109    ,   0.3441069    ,   0.3726064    
     +,   0.4070857    ,   0.4488966    ,   0.4998331    
     +,   0.5622519    ,   0.6391238    ,   0.7335398    
     +,   0.8472691    ,   0.9794885    ,    1.128817    
     +,    1.300533    ,    1.513999    ,    1.801830    
     +,    2.201429    ,    2.744357    ,    3.436695    
     +,    4.235489    ,    5.064012    ,    5.896248    
     +,    6.798609    ,    7.753582    ,    8.538462    
     +,    8.959419    ,    9.009267    ,    8.739779    
     +,    8.190465    ,    7.476884    ,    6.733456    
     +,    6.025394    ,    5.413548    ,    4.894457    
     +,    4.386285    ,    3.848466    ,    3.307529    
     +,    2.795120    ,    2.322237    ,    1.896968    
     +,    1.532468    ,    1.237474    ,    1.009974    
     +,   0.8388507    ,   0.7087463    ,   0.6050671    
     +,   0.5174196    ,   0.4402713    ,   0.3716037    
     +,   0.3110612    ,   0.2586271    ,   0.2140227    
     +,   0.1766128    ,   0.1455385    ,   0.1198830    
     +,   9.8781392E-02,   8.1467956E-02,   6.7285538E-02
     +,   5.5680513E-02,   4.6191610E-02,   3.8435277E-02
     +,   3.2095362E-02,   2.6912132E-02,   2.2672044E-02
     +,   1.9199090E-02,   1.6348515E-02,   1.4001484E-02
     +,   1.2060673E-02,   1.0446802E-02,   9.0959789E-03
     +,   7.9572499E-03,   6.9902777E-03,   6.1633228E-03
     +,   5.4515875E-03,   4.8357653E-03,   4.3006544E-03
     +,   3.8342190E-03,   3.4268212E-03,   3.0705673E-03
     +,   2.7588441E-03,   2.4860327E-03,   2.2472916E-03
     +,   2.0383815E-03,   1.8555485E-03,   1.6954711E-03
     +,   1.5552153E-03,   1.4321813E-03,   1.3240670E-03
     +,   1.2288511E-03,   1.1447726E-03,   1.0702896E-03
     +,   1.0040659E-03,   9.4495231E-04,   8.9196087E-04
     +,   8.4424077E-04,   8.0106634E-04,   7.6182152E-04
     +,   7.2598225E-04,   6.9310114E-04,   6.6279882E-04
     +,   6.3475646E-04,   6.0869975E-04,   5.8439933E-04
     +,   5.6165713E-04,   5.4030749E-04,   5.2020617E-04
     +,   5.0123263E-04,   4.8328075E-04,   4.6626152E-04
     +,   4.5009601E-04,   4.3471728E-04,   4.2006574E-04
     +,   4.0608886E-04,   3.9274144E-04,   3.7998191E-04
     +,   3.6777440E-04,   3.5608499E-04,   3.4488441E-04
     +,   3.3414445E-04,   3.2384048E-04,   3.1394829E-04
     +,   3.0444682E-04,   2.9531479E-04,   2.8653361E-04
     +,   2.7808434E-04,   2.6995040E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_ashz_hatt95_mass = Yx/38.1543905098039
      RETURN
      END
C 
C---- New file --- 
C 
      DOUBLE PRECISION FUNCTION A196_tt_haonly_htt100_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.5726673E-05,   1.8077844E-05
     +,   2.0736265E-05,   2.3734949E-05,   2.7109469E-05
     +,   3.0897831E-05,   3.5140663E-05,   3.9881095E-05
     +,   4.5164659E-05,   5.1039573E-05,   5.7556121E-05
     +,   6.4766777E-05,   7.2726070E-05,   8.1490143E-05
     +,   9.1116679E-05,   1.0166442E-04,   1.1319287E-04
     +,   1.2576178E-04,   1.3943070E-04,   1.5425851E-04
     +,   1.7030269E-04,   1.8761885E-04,   2.0625969E-04
     +,   2.2627591E-04,   2.4771178E-04,   2.7060925E-04
     +,   2.9500338E-04,   3.2092322E-04,   3.4839075E-04
     +,   3.7742042E-04,   4.0801772E-04,   4.4017954E-04
     +,   4.7389258E-04,   5.0913368E-04,   5.4586853E-04
     +,   5.8405218E-04,   6.2362792E-04,   6.6452724E-04
     +,   7.0667284E-04,   7.4997114E-04,   7.9432281E-04
     +,   8.3961454E-04,   8.8572397E-04,   9.3251956E-04
     +,   9.7986136E-04,   1.0276014E-03,   1.0755863E-03
     +,   1.1236571E-03,   1.1716519E-03,   1.2194057E-03
     +,   1.2667534E-03,   1.3135314E-03,   1.3595774E-03
     +,   1.4047368E-03,   1.4488555E-03,   1.4917926E-03
     +,   1.5334124E-03,   1.5735917E-03,   1.6122183E-03
     +,   1.6491933E-03,   1.6844318E-03,   1.7178641E-03
     +,   1.7494338E-03,   1.7791031E-03,   1.8068500E-03
     +,   1.8326654E-03,   1.8565595E-03,   1.8785544E-03
     +,   1.8986883E-03,   1.9170116E-03,   1.9335875E-03
     +,   1.9484881E-03,   1.9617968E-03,   1.9736018E-03
     +,   1.9839986E-03,   1.9930850E-03,   2.0009605E-03
     +,   2.0077245E-03,   2.0134733E-03,   2.0182994E-03
     +,   2.0222890E-03,   2.0255204E-03,   2.0280622E-03
     +,   2.0299728E-03,   2.0312988E-03,   2.0320741E-03
     +,   2.0323182E-03,   2.0320381E-03,   2.0312262E-03
     +,   2.0298613E-03,   2.0279088E-03,   2.0253218E-03
     +,   2.0220410E-03,   2.0179967E-03,   2.0131103E-03
     +,   2.0072951E-03,   2.0004578E-03,   1.9925029E-03
     +,   1.9833299E-03,   1.9728399E-03,   1.9609346E-03
     +,   1.9475203E-03,   1.9325070E-03,   1.9158145E-03
     +,   1.8973701E-03,   1.8771106E-03,   1.8549875E-03
     +,   1.8309652E-03,   1.8050208E-03,   1.7771480E-03
     +,   1.7473566E-03,   1.7156720E-03,   1.6821390E-03
     +,   1.6468160E-03,   1.6097843E-03,   1.5711380E-03
     +,   1.5309955E-03,   1.4894906E-03,   1.4467844E-03
     +,   1.4030577E-03,   1.3585207E-03,   1.3134194E-03
     +,   1.2680411E-03,   1.2227198E-03,   1.1778519E-03
     +,   1.1339154E-03,   1.0914779E-03,   1.0512313E-03
     +,   1.0140056E-03,   9.8081061E-04,   9.5285889E-04
     +,   9.3161239E-04,   9.1881450E-04,   9.1653701E-04
     +,   9.2721911E-04,   9.5371169E-04,   9.9931401E-04
     +,   1.0678084E-03,   1.1634949E-03,   1.2912131E-03
     +,   1.4563409E-03,   1.6647925E-03,   1.9230096E-03
     +,   2.2379030E-03,   2.6167314E-03,   3.0670324E-03
     +,   3.5964197E-03,   4.2122994E-03,   4.9215774E-03
     +,   5.7303272E-03,   6.6433181E-03,   7.6634418E-03
     +,   8.7912297E-03,   1.0024427E-02,   1.1357460E-02
     +,   1.2780976E-02,   1.4281658E-02,   1.5842250E-02
     +,   1.7441532E-02,   1.9054392E-02,   2.0652493E-02
     +,   2.2204585E-02,   2.3677008E-02,   2.5034530E-02
     +,   2.6241494E-02,   2.7263239E-02,   2.8068447E-02
     +,   2.8632907E-02,   2.8944729E-02,   2.9011192E-02
     +,   2.8866617E-02,   2.8579712E-02,   2.8257310E-02
     +,   2.8040927E-02,   2.8092410E-02,   2.8567009E-02
     +,   2.9576652E-02,   3.1151898E-02,   3.3217784E-02
     +,   3.5602093E-02,   3.8090993E-02,   4.0537667E-02
     +,   4.3015271E-02,   4.5994457E-02,   5.0523404E-02
     +,   5.8379829E-02,   7.2121106E-02,   9.4875336E-02
     +,   0.1296624    ,   0.1781466    ,   0.2391041    
     +,   0.3072987    ,   0.3736513    ,   0.4272007    
     +,   0.4584157    ,   0.4624914    ,   0.4410017    
     +,   0.4009470    ,   0.3516461    ,   0.3011774    
     +,   0.2541977    ,   0.2119165    ,   0.1736259    
     +,   0.1384606    ,   0.1063603    ,   7.8026980E-02
     +,   5.4343667E-02,   3.5804950E-02,   2.2272667E-02
     +,   1.3065995E-02,   7.2225640E-03,   3.7588796E-03
     +,   1.8399570E-03,   8.4605347E-04,   3.6494399E-04
     +,   1.4746712E-04,   5.5748129E-05,   1.9691382E-05
     +,   6.4915062E-06,   1.9957899E-06,   5.7210434E-07
     +,   1.5313614E-07,   3.8563833E-08,   9.3968868E-09
     +,   2.4289628E-09,   8.1800033E-10,   4.1760004E-10
     +,   2.8240502E-10,   2.1090089E-10,   1.6127731E-10
     +,   1.2376229E-10,   9.4878411E-11,   7.2595749E-11
     +,   5.5429404E-11,   4.2232811E-11,   3.2109509E-11
     +,   2.4360507E-11,   1.8442121E-11,   1.3931930E-11
     +,   1.0502313E-11,   7.8999810E-12,   5.9297914E-12
     +,   4.4414867E-12,   3.3196295E-12,   2.4758247E-12
     +,   1.8425524E-12,   1.3683522E-12,   1.0140219E-12
     +,   7.4983216E-13,   5.5329558E-13,   4.0740146E-13
     +,   2.9933345E-13,   2.1946282E-13,   1.6056152E-13
     +,   1.1721818E-13,   8.5391567E-14,   6.2073874E-14
     +,   4.5027465E-14,   3.2592611E-14,   2.3541136E-14
     +,   1.6967107E-14,   1.2202966E-14,   8.7577896E-15
     +,   6.2717792E-15,   4.4819139E-15,   3.1960188E-15
     +,   2.2741625E-15,   1.6147496E-15,   1.1441054E-15
     +,   8.0890805E-16,   5.7068914E-16,   4.0176512E-16
     +,   2.8224120E-16,   1.9785258E-16,   1.3839789E-16
     +,   9.6603843E-17,   6.7286299E-17,   4.6766449E-17
     +,   3.2434791E-17,   2.2447305E-17,   1.5501861E-17
     +,   1.0682708E-17,   7.3458651E-18,   5.0406331E-18
     +,   3.4513797E-18,   2.3581749E-18,   1.6078043E-18
     +,   1.0938455E-18,   7.4260476E-19,   5.0306602E-19
     +,   3.4007093E-19,   2.2939357E-19,   1.5440758E-19
     +,   1.0371102E-19,   6.9511780E-20,   4.6489605E-20
     +,   3.1026456E-20,   2.0662166E-20,   1.3730827E-20
     +,   9.1050662E-21,   6.0248803E-21
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_haonly_htt100_mass = Yx/1.516846
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_haonly_htt105_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.5282772E-03,   3.5621333E-03
     +,   3.5934506E-03,   3.6221428E-03,   3.6481251E-03
     +,   3.6713223E-03,   3.6916635E-03,   3.7090858E-03
     +,   3.7235336E-03,   3.7349577E-03,   3.7433170E-03
     +,   3.7485790E-03,   3.7507196E-03,   3.7497212E-03
     +,   3.7455778E-03,   3.7382899E-03,   3.7278680E-03
     +,   3.7143303E-03,   3.6977045E-03,   3.6780278E-03
     +,   3.6553466E-03,   3.6297149E-03,   3.6011960E-03
     +,   3.5698593E-03,   3.5357887E-03,   3.4990709E-03
     +,   3.4598012E-03,   3.4180859E-03,   3.3740357E-03
     +,   3.3277695E-03,   3.2794138E-03,   3.2291012E-03
     +,   3.1769718E-03,   3.1231707E-03,   3.0678490E-03
     +,   3.0111640E-03,   2.9532777E-03,   2.8943582E-03
     +,   2.8345755E-03,   2.7741084E-03,   2.7131359E-03
     +,   2.6518425E-03,   2.5904179E-03,   2.5290530E-03
     +,   2.4679431E-03,   2.4072863E-03,   2.3472854E-03
     +,   2.2881434E-03,   2.2300668E-03,   2.1732664E-03
     +,   2.1179528E-03,   2.0643412E-03,   2.0126475E-03
     +,   1.9630878E-03,   1.9158856E-03,   1.8712595E-03
     +,   1.8294334E-03,   1.7906310E-03,   1.7550767E-03
     +,   1.7229961E-03,   1.6946138E-03,   1.6701544E-03
     +,   1.6498432E-03,   1.6339011E-03,   1.6225486E-03
     +,   1.6160037E-03,   1.6144795E-03,   1.6181862E-03
     +,   1.6273286E-03,   1.6421035E-03,   1.6627044E-03
     +,   1.6893118E-03,   1.7221017E-03,   1.7612361E-03
     +,   1.8068673E-03,   1.8591378E-03,   1.9181721E-03
     +,   1.9840794E-03,   2.0569575E-03,   2.1368884E-03
     +,   2.2239275E-03,   2.3181229E-03,   2.4194911E-03
     +,   2.5280383E-03,   2.6437386E-03,   2.7665556E-03
     +,   2.8964141E-03,   3.0332315E-03,   3.1768822E-03
     +,   3.3272263E-03,   3.4841017E-03,   3.6473046E-03
     +,   3.8166048E-03,   3.9917538E-03,   4.1724755E-03
     +,   4.3584444E-03,   4.5493310E-03,   4.7447518E-03
     +,   4.9443180E-03,   5.1475870E-03,   5.3541129E-03
     +,   5.5633984E-03,   5.7749464E-03,   5.9882090E-03
     +,   6.2026451E-03,   6.4176912E-03,   6.6327620E-03
     +,   6.8472712E-03,   7.0606498E-03,   7.2723404E-03
     +,   7.4817883E-03,   7.6885102E-03,   7.8920471E-03
     +,   8.0920393E-03,   8.2881935E-03,   8.4803561E-03
     +,   8.6684898E-03,   8.8527463E-03,   9.0334509E-03
     +,   9.2111677E-03,   9.3867145E-03,   9.5611904E-03
     +,   9.7360061E-03,   9.9129286E-03,   1.0094120E-02
     +,   1.0282124E-02,   1.0479967E-02,   1.0691141E-02
     +,   1.0919682E-02,   1.1170176E-02,   1.1447868E-02
     +,   1.1758657E-02,   1.2109210E-02,   1.2506966E-02
     +,   1.2960258E-02,   1.3478335E-02,   1.4071346E-02
     +,   1.4750339E-02,   1.5527260E-02,   1.6414750E-02
     +,   1.7425872E-02,   1.8573780E-02,   1.9871343E-02
     +,   2.1330504E-02,   2.2961365E-02,   2.4771618E-02
     +,   2.6765520E-02,   2.8942714E-02,   3.1297371E-02
     +,   3.3817455E-02,   3.6483798E-02,   3.9269410E-02
     +,   4.2139452E-02,   4.5051523E-02,   4.7956102E-02
     +,   5.0797474E-02,   5.3515319E-02,   5.6046989E-02
     +,   5.8329463E-02,   6.0301796E-02,   6.1908238E-02
     +,   6.3100614E-02,   6.3840792E-02,   6.4102985E-02
     +,   6.3875660E-02,   6.3162446E-02,   6.1983153E-02
     +,   6.0373634E-02,   5.8385331E-02,   5.6084245E-02
     +,   5.3549688E-02,   5.0872575E-02,   4.8153177E-02
     +,   4.5499235E-02,   4.3024126E-02,   4.0844113E-02
     +,   3.9076552E-02,   3.7837669E-02,   3.7240259E-02
     +,   3.7391193E-02,   3.8389277E-02,   4.0322304E-02
     +,   4.3264072E-02,   4.7271084E-02,   5.2378740E-02
     +,   5.8596186E-02,   6.5901525E-02,   7.4236959E-02
     +,   8.3503000E-02,   9.3552612E-02,   0.1041897    
     +,   0.1151673    ,   0.1261892    ,   0.1369170    
     +,   0.1469822    ,   0.1560018    ,   0.1635973    
     +,   0.1694190    ,   0.1731701    ,   0.1746286    
     +,   0.1736656    ,   0.1702599    ,   0.1645011    
     +,   0.1565864    ,   0.1468095    ,   0.1355392    
     +,   0.1231945    ,   0.1102173    ,   9.7043648E-02
     +,   8.4076211E-02,   7.1664602E-02,   6.0090780E-02
     +,   4.9560528E-02,   4.0201407E-02,   3.2068565E-02
     +,   2.5154544E-02,   1.9400928E-02,   1.4711713E-02
     +,   1.0967471E-02,   8.0377609E-03,   5.7905740E-03
     +,   4.1005267E-03,   2.8541321E-03,   1.9525961E-03
     +,   1.3129056E-03,   8.6759229E-04,   5.6344428E-04
     +,   3.5961109E-04,   2.2555074E-04,   1.3901673E-04
     +,   8.4197294E-05,   5.0111412E-05,   2.9306704E-05
     +,   1.6841255E-05,   9.5097394E-06,   5.2763799E-06
     +,   2.8764982E-06,   1.5408392E-06,   8.1100529E-07
     +,   4.1942519E-07,   2.1312964E-07,   1.0641671E-07
     +,   5.2213149E-08,   2.5175378E-08,   1.1930106E-08
     +,   5.5577334E-09,   2.5464215E-09,   1.1483200E-09
     +,   5.1037252E-10,   2.2414388E-10,   9.7716786E-11
     +,   4.2634733E-11,   1.8878950E-11,   8.6692068E-12
     +,   4.2446012E-12,   2.2734087E-12,   1.3454733E-12
     +,   8.6982158E-13,   5.9933915E-13,   4.2947216E-13
     +,   3.1438738E-13,   2.3255649E-13,   1.7278591E-13
     +,   1.2854068E-13,   9.5599276E-14,   7.1025922E-14
     +,   5.2694279E-14,   3.9032481E-14,   2.8865270E-14
     +,   2.1310312E-14,   1.5705800E-14,   1.1555412E-14
     +,   8.4873362E-15,   6.2231794E-15,   4.5551924E-15
     +,   3.3286000E-15,   2.4281347E-15,   1.7682696E-15
     +,   1.2855370E-15,   9.3302543E-16,   6.7603341E-16
     +,   4.8901668E-16,   3.5314651E-16,   2.5461082E-16
     +,   1.8326807E-16,   1.3170488E-16,   9.4498205E-17
     +,   6.7695343E-17,   4.8420129E-17,   3.4580199E-17
     +,   2.4659601E-17,   1.7559223E-17,   1.2485659E-17
     +,   8.8656879E-18,   6.2868895E-18,   4.4524229E-18
     +,   3.1493771E-18,   2.2250414E-18,   1.5702731E-18
     +,   1.1070303E-18,   7.7970499E-19
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_haonly_htt105_mass = Yx/1.48381124137931
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_haonly_htt107_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.0301418E-05,   1.1604253E-05
     +,   1.3052639E-05,   1.4660234E-05,   1.6441616E-05
     +,   1.8412358E-05,   2.0589010E-05,   2.2989138E-05
     +,   2.5631292E-05,   2.8535167E-05,   3.1721323E-05
     +,   3.5211422E-05,   3.9028058E-05,   4.3194814E-05
     +,   4.7736161E-05,   5.2677435E-05,   5.8044752E-05
     +,   6.3864951E-05,   7.0165457E-05,   7.6974226E-05
     +,   8.4319639E-05,   9.2230250E-05,   1.0073461E-04
     +,   1.0986174E-04,   1.1963944E-04,   1.3009610E-04
     +,   1.4125888E-04,   1.5315411E-04,   1.6580707E-04
     +,   1.7924175E-04,   1.9348053E-04,   2.0854380E-04
     +,   2.2445002E-04,   2.4121518E-04,   2.5885270E-04
     +,   2.7737304E-04,   2.9678363E-04,   3.1708833E-04
     +,   3.3828866E-04,   3.6038033E-04,   3.8335772E-04
     +,   4.0720979E-04,   4.3192238E-04,   4.5747738E-04
     +,   4.8385345E-04,   5.1102601E-04,   5.3896761E-04
     +,   5.6764879E-04,   5.9703860E-04,   6.2710565E-04
     +,   6.5781933E-04,   6.8915117E-04,   7.2107563E-04
     +,   7.5357535E-04,   7.8663707E-04,   8.2026224E-04
     +,   8.5446297E-04,   8.8926917E-04,   9.2473056E-04
     +,   9.6092158E-04,   9.9794439E-04,   1.0359345E-03
     +,   1.0750622E-03,   1.1155419E-03,   1.1576347E-03
     +,   1.2016475E-03,   1.2479470E-03,   1.2969509E-03
     +,   1.3491439E-03,   1.4050644E-03,   1.4653198E-03
     +,   1.5305707E-03,   1.6015434E-03,   1.6790075E-03
     +,   1.7637874E-03,   1.8567428E-03,   1.9587562E-03
     +,   2.0707203E-03,   2.1935303E-03,   2.3280638E-03
     +,   2.4751427E-03,   2.6355453E-03,   2.8099483E-03
     +,   2.9989416E-03,   3.2029653E-03,   3.4223350E-03
     +,   3.6571715E-03,   3.9074374E-03,   4.1728704E-03
     +,   4.4530216E-03,   4.7472329E-03,   5.0546201E-03
     +,   5.3740912E-03,   5.7043885E-03,   6.0440823E-03
     +,   6.3915653E-03,   6.7451615E-03,   7.1030622E-03
     +,   7.4634710E-03,   7.8245383E-03,   8.1844991E-03
     +,   8.5416241E-03,   8.8943457E-03,   9.2412047E-03
     +,   9.5809605E-03,   9.9125737E-03,   1.0235213E-02
     +,   1.0548276E-02,   1.0851419E-02,   1.1144530E-02
     +,   1.1427694E-02,   1.1701240E-02,   1.1965650E-02
     +,   1.2221619E-02,   1.2469958E-02,   1.2711644E-02
     +,   1.2947743E-02,   1.3179439E-02,   1.3407977E-02
     +,   1.3634681E-02,   1.3860906E-02,   1.4087987E-02
     +,   1.4317230E-02,   1.4549858E-02,   1.4786937E-02
     +,   1.5029306E-02,   1.5277548E-02,   1.5531912E-02
     +,   1.5792357E-02,   1.6058516E-02,   1.6329886E-02
     +,   1.6605943E-02,   1.6886512E-02,   1.7172063E-02
     +,   1.7464265E-02,   1.7766543E-02,   1.8084625E-02
     +,   1.8427195E-02,   1.8806474E-02,   1.9238675E-02
     +,   1.9744264E-02,   2.0348046E-02,   2.1079015E-02
     +,   2.1969765E-02,   2.3055455E-02,   2.4372539E-02
     +,   2.5956843E-02,   2.7841033E-02,   3.0051773E-02
     +,   3.2606639E-02,   3.5510533E-02,   3.8752064E-02
     +,   4.2300705E-02,   4.6104919E-02,   5.0091192E-02
     +,   5.4164637E-02,   5.8212142E-02,   6.2107373E-02
     +,   6.5717161E-02,   6.8908848E-02,   7.1559317E-02
     +,   7.3562481E-02,   7.4836105E-02,   7.5326979E-02
     +,   7.5013861E-02,   7.3907897E-02,   7.2051361E-02
     +,   6.9514588E-02,   6.6391766E-02,   6.2796324E-02
     +,   5.8856465E-02,   5.4710608E-02,   5.0502833E-02
     +,   4.6379328E-02,   4.2485371E-02,   3.8961083E-02
     +,   3.5938822E-02,   3.3540349E-02,   3.1873625E-02
     +,   3.1030148E-02,   3.1082975E-02,   3.2084722E-02
     +,   3.4066044E-02,   3.7035238E-02,   4.0978074E-02
     +,   4.5858130E-02,   5.1617797E-02,   5.8179770E-02
     +,   6.5447412E-02,   7.3303193E-02,   8.1607841E-02
     +,   9.0195186E-02,   9.8865598E-02,   0.1073804    
     +,   0.1154580    ,   0.1227740    ,   0.1289701    
     +,   0.1336732    ,   0.1365259    ,   0.1372236    
     +,   0.1355552    ,   0.1314410    ,   0.1249564    
     +,   0.1163397    ,   0.1059788    ,   9.4375506E-02
     +,   8.2096323E-02,   6.9716737E-02,   5.7765357E-02
     +,   4.6678390E-02,   3.6771737E-02,   2.8231205E-02
     +,   2.1118037E-02,   1.5388310E-02,   1.0920964E-02
     +,   7.5475555E-03,   5.0790464E-03,   3.3276798E-03
     +,   2.1224797E-03,   1.3178677E-03,   7.9651776E-04
     +,   4.6858197E-04,   2.6830609E-04,   1.4952759E-04
     +,   8.1102677E-05,   4.2810258E-05,   2.1991460E-05
     +,   1.0993866E-05,   5.3482913E-06,   2.5317781E-06
     +,   1.1662271E-06,   5.2274879E-07,   2.2800630E-07
     +,   9.6772268E-08,   3.9974584E-08,   1.6075473E-08
     +,   6.2976242E-09,   2.4072302E-09,   9.0105595E-10
     +,   3.3295033E-10,   1.2363396E-10,   4.7835968E-11
     +,   2.0472938E-11,   1.0318276E-11,   6.2193610E-12
     +,   4.2853312E-12,   3.1786869E-12,   2.4370974E-12
     +,   1.8925144E-12,   1.4755914E-12,   1.1511807E-12
     +,   8.9742661E-13,   6.9875795E-13,   5.4332184E-13
     +,   4.2185412E-13,   3.2706089E-13,   2.5319644E-13
     +,   1.9572737E-13,   1.5108001E-13,   1.1644470E-13
     +,   8.9617861E-14,   6.8870636E-14,   5.2848676E-14
     +,   4.0494141E-14,   3.0982331E-14,   2.3670039E-14
     +,   1.8056777E-14,   1.3754437E-14,   1.0461888E-14
     +,   7.9458340E-15,   6.0259580E-15,   4.5632477E-15
     +,   3.4505306E-15,   2.6053175E-15,   1.9642277E-15
     +,   1.4787285E-15,   1.1115799E-15,   8.3437240E-16
     +,   6.2536924E-16,   4.6803430E-16,   3.4976476E-16
     +,   2.6099965E-16,   1.9447374E-16,   1.4469272E-16
     +,   1.0749533E-16,   7.9744148E-17,   5.9070331E-17
     +,   4.3691438E-17,   3.2269116E-17,   2.3797796E-17
     +,   1.7524751E-17,   1.2886179E-17,   9.4615615E-18
     +,   6.9367374E-18,   5.0782599E-18,   3.7122034E-18
     +,   2.7096555E-18,   1.9749386E-18,   1.4373371E-18
     +,   1.0445257E-18,   7.5795805E-19
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_haonly_htt107_mass = Yx/1.24186222222222
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_haonly_htt110_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.5450725E-03,   2.6885427E-03
     +,   2.8351354E-03,   2.9845024E-03,   3.1362623E-03
     +,   3.2900029E-03,   3.4452830E-03,   3.6016346E-03
     +,   3.7585618E-03,   3.9155530E-03,   4.0720715E-03
     +,   4.2275647E-03,   4.3814667E-03,   4.5332047E-03
     +,   4.6821972E-03,   4.8278654E-03,   4.9696290E-03
     +,   5.1069162E-03,   5.2391691E-03,   5.3658420E-03
     +,   5.4864092E-03,   5.6003723E-03,   5.7072565E-03
     +,   5.8066258E-03,   5.8980701E-03,   5.9812269E-03
     +,   6.0557704E-03,   6.1214222E-03,   6.1779493E-03
     +,   6.2251659E-03,   6.2629413E-03,   6.2911920E-03
     +,   6.3098879E-03,   6.3190502E-03,   6.3187517E-03
     +,   6.3091200E-03,   6.2903292E-03,   6.2626004E-03
     +,   6.2262053E-03,   6.1814589E-03,   6.1287158E-03
     +,   6.0683726E-03,   6.0008601E-03,   5.9266416E-03
     +,   5.8462122E-03,   5.7600890E-03,   5.6688162E-03
     +,   5.5729523E-03,   5.4730740E-03,   5.3697675E-03
     +,   5.2636294E-03,   5.1552607E-03,   5.0452650E-03
     +,   4.9342383E-03,   4.8227855E-03,   4.7114929E-03
     +,   4.6009426E-03,   4.4917073E-03,   4.3843458E-03
     +,   4.2793988E-03,   4.1773948E-03,   4.0788399E-03
     +,   3.9842292E-03,   3.8940290E-03,   3.8086842E-03
     +,   3.7286258E-03,   3.6542513E-03,   3.5859442E-03
     +,   3.5240536E-03,   3.4689126E-03,   3.4208195E-03
     +,   3.3800530E-03,   3.3468583E-03,   3.3214574E-03
     +,   3.3040389E-03,   3.2947643E-03,   3.2937629E-03
     +,   3.3011343E-03,   3.3169438E-03,   3.3412261E-03
     +,   3.3739782E-03,   3.4151673E-03,   3.4647200E-03
     +,   3.5225302E-03,   3.5884483E-03,   3.6622935E-03
     +,   3.7438350E-03,   3.8328120E-03,   3.9289054E-03
     +,   4.0317648E-03,   4.1409899E-03,   4.2561283E-03
     +,   4.3766773E-03,   4.5020888E-03,   4.6317675E-03
     +,   4.7650523E-03,   4.9012494E-03,   5.0396011E-03
     +,   5.1793233E-03,   5.3195772E-03,   5.4595214E-03
     +,   5.5982745E-03,   5.7349922E-03,   5.8688330E-03
     +,   5.9990347E-03,   6.1249346E-03,   6.2460029E-03
     +,   6.3619073E-03,   6.4725853E-03,   6.5783029E-03
     +,   6.6797175E-03,   6.7779920E-03,   6.8748435E-03
     +,   6.9726636E-03,   7.0745545E-03,   7.1844356E-03
     +,   7.3070535E-03,   7.4480334E-03,   7.6138373E-03
     +,   7.8117405E-03,   8.0497181E-03,   8.3362767E-03
     +,   8.6802673E-03,   9.0906397E-03,   9.5761577E-03
     +,   1.0144994E-02,   1.0804504E-02,   1.1560752E-02
     +,   1.2418357E-02,   1.3380029E-02,   1.4446657E-02
     +,   1.5616945E-02,   1.6887778E-02,   1.8254112E-02
     +,   1.9709585E-02,   2.1246908E-02,   2.2858281E-02
     +,   2.4536200E-02,   2.6274217E-02,   2.8067483E-02
     +,   2.9913150E-02,   3.1810883E-02,   3.3763088E-02
     +,   3.5774641E-02,   3.7852228E-02,   4.0003948E-02
     +,   4.2238019E-02,   4.4561304E-02,   4.6977948E-02
     +,   4.9488034E-02,   5.2085988E-02,   5.4759134E-02
     +,   5.7487123E-02,   6.0241655E-02,   6.2986471E-02
     +,   6.5678008E-02,   6.8266831E-02,   7.0699684E-02
     +,   7.2921447E-02,   7.4877523E-02,   7.6516725E-02
     +,   7.7793486E-02,   7.8670152E-02,   7.9118952E-02
     +,   7.9123601E-02,   7.8680083E-02,   7.7797487E-02
     +,   7.6498039E-02,   7.4816741E-02,   7.2800599E-02
     +,   7.0507757E-02,   6.8005882E-02,   6.5370068E-02
     +,   6.2680595E-02,   6.0020596E-02,   5.7472445E-02
     +,   5.5114675E-02,   5.3018652E-02,   5.1244959E-02
     +,   4.9840190E-02,   4.8834227E-02,   4.8238620E-02
     +,   4.8045047E-02,   4.8225649E-02,   4.8733927E-02
     +,   4.9507108E-02,   5.0469179E-02,   5.1534943E-02
     +,   5.2614570E-02,   5.3618055E-02,   5.4460146E-02
     +,   5.5064406E-02,   5.5366680E-02,   5.5317927E-02
     +,   5.4885831E-02,   5.4055393E-02,   5.2828610E-02
     +,   5.1223174E-02,   4.9270339E-02,   4.7012262E-02
     +,   4.4499408E-02,   4.1787338E-02,   3.8933605E-02
     +,   3.5995245E-02,   3.3026829E-02,   3.0078063E-02
     +,   2.7192764E-02,   2.4408296E-02,   2.1754926E-02
     +,   1.9255731E-02,   1.6927091E-02,   1.4779421E-02
     +,   1.2817645E-02,   1.1041926E-02,   9.4485776E-03
     +,   8.0309594E-03,   6.7800661E-03,   5.6851208E-03
     +,   4.7342484E-03,   3.9150482E-03,   3.2148056E-03
     +,   2.6209436E-03,   2.1213067E-03,   1.7043126E-03
     +,   1.3590850E-03,   1.0755921E-03,   8.4471935E-04
     +,   6.5827038E-04,   5.0895783E-04,   3.9039683E-04
     +,   2.9706326E-04,   2.2422556E-04,   1.6787456E-04
     +,   1.2465818E-04,   9.1808157E-05,   6.7056979E-05
     +,   4.8572350E-05,   3.4890538E-05,   2.4853822E-05
     +,   1.7556235E-05,   1.2297273E-05,   8.5412985E-06
     +,   5.8826840E-06,   4.0174837E-06,   2.7205067E-06
     +,   1.8266903E-06,   1.2161922E-06,   8.0288584E-07
     +,   5.2554799E-07,   3.4110536E-07,   2.1952111E-07
     +,   1.4007790E-07,   8.8629200E-08,   5.5604293E-08
     +,   3.4591043E-08,   2.1337595E-08,   1.3051966E-08
     +,   7.9174418E-09,   4.7632058E-09,   2.8422478E-09
     +,   1.6824954E-09,   9.8830755E-10,   5.7627492E-10
     +,   3.3373082E-10,   1.9211122E-10,   1.1005244E-10
     +,   6.2844327E-11,   3.5860440E-11,   2.0518129E-11
     +,   1.1825983E-11,   6.9071862E-12,   4.1174963E-12
     +,   2.5242516E-12,   1.6021569E-12,   1.0572767E-12
     +,   7.2586398E-13,   5.1682942E-13,   3.7947225E-13
     +,   2.8536253E-13,   2.1836549E-13,   1.6910999E-13
     +,   1.3199167E-13,   1.0351344E-13,   8.1400239E-14
     +,   6.4094095E-14,   5.0487775E-14,   3.9762132E-14
     +,   3.1297081E-14,   2.4614561E-14,   1.9340478E-14
     +,   1.5180801E-14,   1.1902732E-14,   9.3221024E-15
     +,   7.2925962E-15,   5.6983790E-15,   4.4474824E-15
     +,   3.4671553E-15,   2.6997447E-15,   2.0997574E-15
     +,   1.6311852E-15,   1.2657068E-15
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_haonly_htt110_mass = Yx/1.117676
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_haonly_htt115_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  6.0036541E-07,   7.5316217E-07
     +,   9.4210037E-07,   1.1750125E-06,   1.4612552E-06
     +,   1.8119623E-06,   2.2403351E-06,   2.7619712E-06
     +,   3.3952163E-06,   4.1616181E-06,   5.0863146E-06
     +,   6.1985738E-06,   7.5323219E-06,   9.1267520E-06
     +,   1.1026940E-05,   1.3284532E-05,   1.5958462E-05
     +,   1.9115734E-05,   2.2832153E-05,   2.7193169E-05
     +,   3.2294687E-05,   3.8243823E-05,   4.5159679E-05
     +,   5.3174543E-05,   6.2433341E-05,   7.3095951E-05
     +,   8.5336345E-05,   9.9343459E-05,   1.1532137E-04
     +,   1.3348935E-04,   1.5408132E-04,   1.7734582E-04
     +,   2.0354477E-04,   2.3295272E-04,   2.6585493E-04
     +,   3.0254622E-04,   3.4332788E-04,   3.8850497E-04
     +,   4.3838669E-04,   4.9327442E-04,   5.5346941E-04
     +,   6.1925856E-04,   6.9091498E-04,   7.6869159E-04
     +,   8.5281604E-04,   9.4348547E-04,   1.0408617E-03
     +,   1.1450634E-03,   1.2561639E-03,   1.3741837E-03
     +,   1.4990866E-03,   1.6307743E-03,   1.7690816E-03
     +,   1.9137834E-03,   2.0645678E-03,   2.2210670E-03
     +,   2.3828303E-03,   2.5493377E-03,   2.7199981E-03
     +,   2.8941536E-03,   3.0710823E-03,   3.2500084E-03
     +,   3.4300929E-03,   3.6104668E-03,   3.7902286E-03
     +,   3.9684321E-03,   4.1441419E-03,   4.3163933E-03
     +,   4.4842553E-03,   4.6467911E-03,   4.8031178E-03
     +,   4.9523725E-03,   5.0937664E-03,   5.2265520E-03
     +,   5.3500701E-03,   5.4637399E-03,   5.5670566E-03
     +,   5.6596119E-03,   5.7411008E-03,   5.8113132E-03
     +,   5.8701350E-03,   5.9175622E-03,   5.9536826E-03
     +,   5.9786881E-03,   5.9928601E-03,   5.9965756E-03
     +,   5.9902966E-03,   5.9745647E-03,   5.9500029E-03
     +,   5.9173037E-03,   5.8772252E-03,   5.8305869E-03
     +,   5.7782684E-03,   5.7211961E-03,   5.6603379E-03
     +,   5.5967071E-03,   5.5313399E-03,   5.4653035E-03
     +,   5.3996700E-03,   5.3355219E-03,   5.2739247E-03
     +,   5.2159247E-03,   5.1625241E-03,   5.1146778E-03
     +,   5.0732601E-03,   5.0390633E-03,   5.0127823E-03
     +,   4.9949968E-03,   4.9861744E-03,   4.9866675E-03
     +,   4.9967282E-03,   5.0165243E-03,   5.0461767E-03
     +,   5.0858003E-03,   5.1355585E-03,   5.1957369E-03
     +,   5.2668098E-03,   5.3495290E-03,   5.4449900E-03
     +,   5.5547189E-03,   5.6807203E-03,   5.8255084E-03
     +,   5.9921057E-03,   6.1840261E-03,   6.4051840E-03
     +,   6.6597462E-03,   6.9520059E-03,   7.2861020E-03
     +,   7.6658512E-03,   8.0943834E-03,   8.5739857E-03
     +,   9.1057457E-03,   9.6894745E-03,   1.0323444E-02
     +,   1.1004508E-02,   1.1728121E-02,   1.2488522E-02
     +,   1.3279110E-02,   1.4093012E-02,   1.4923577E-02
     +,   1.5765030E-02,   1.6613161E-02,   1.7466119E-02
     +,   1.8324897E-02,   1.9193755E-02,   2.0080626E-02
     +,   2.0997087E-02,   2.1958010E-02,   2.2981089E-02
     +,   2.4086015E-02,   2.5293263E-02,   2.6622562E-02
     +,   2.8091272E-02,   2.9712658E-02,   3.1493939E-02
     +,   3.3434223E-02,   3.5522949E-02,   3.7738629E-02
     +,   4.0047813E-02,   4.2404614E-02,   4.4751722E-02
     +,   4.7021680E-02,   4.9139179E-02,   5.1024657E-02
     +,   5.2598614E-02,   5.3786196E-02,   5.4521997E-02
     +,   5.4754991E-02,   5.4452442E-02,   5.3602774E-02
     +,   5.2217118E-02,   5.0329302E-02,   4.7993898E-02
     +,   4.5283008E-02,   4.2282231E-02,   3.9084841E-02
     +,   3.5786517E-02,   3.2480199E-02,   2.9251147E-02
     +,   2.6172807E-02,   2.3304423E-02,   2.0689720E-02
     +,   1.8356407E-02,   1.6316826E-02,   1.4569739E-02
     +,   1.3102614E-02,   1.1893974E-02,   1.0915959E-02
     +,   1.0136939E-02,   9.5238099E-03,   9.0437513E-03
     +,   8.6658010E-03,   8.3619729E-03,   8.1079155E-03
     +,   7.8832516E-03,   7.6716766E-03,   7.4608070E-03
     +,   7.2418437E-03,   7.0091304E-03,   6.7596752E-03
     +,   6.4926711E-03,   6.2089786E-03,   5.9106639E-03
     +,   5.6006033E-03,   5.2821715E-03,   4.9589076E-03
     +,   4.6343147E-03,   4.3117288E-03,   3.9941757E-03
     +,   3.6842893E-03,   3.3842935E-03,   3.0960233E-03
     +,   2.8209088E-03,   2.5599943E-03,   2.3139911E-03
     +,   2.0833339E-03,   1.8682056E-03,   1.6685616E-03
     +,   1.4841841E-03,   1.3147303E-03,   1.1597236E-03
     +,   1.0185986E-03,   8.9072774E-04,   7.7542831E-04
     +,   6.7197002E-04,   5.7959696E-04,   4.9754477E-04
     +,   4.2504151E-04,   3.6131337E-04,   3.0559994E-04
     +,   2.5716302E-04,   2.1528931E-04,   1.7929374E-04
     +,   1.4852820E-04,   1.2238744E-04,   1.0030584E-04
     +,   8.1762963E-05,   6.6284963E-05,   5.3443007E-05
     +,   4.2851836E-05,   3.4169370E-05,   2.7094926E-05
     +,   2.1365742E-05,   1.6753960E-05,   1.3064029E-05
     +,   1.0129689E-05,   7.8104131E-06,   5.9883041E-06
     +,   4.5654060E-06,   3.4610332E-06,   2.6090208E-06
     +,   1.9556412E-06,   1.4576152E-06,   1.0802949E-06
     +,   7.9612801E-07,   5.8338924E-07,   4.2508296E-07
     +,   3.0798697E-07,   2.2188564E-07,   1.5895003E-07
     +,   1.1322171E-07,   8.0193956E-08,   5.6479617E-08
     +,   3.9552518E-08,   2.7542255E-08,   1.9070530E-08
     +,   1.3129789E-08,   8.9885690E-09,   6.1187988E-09
     +,   4.1417092E-09,   2.7875646E-09,   1.8655515E-09
     +,   1.2414587E-09,   8.2147705E-10,   5.4049371E-10
     +,   3.5361353E-10,   2.3003707E-10,   1.4880268E-10
     +,   9.5709343E-11,   6.1212861E-11,   3.8927968E-11
     +,   2.4616361E-11,   1.5478096E-11,   9.6773214E-12
     +,   6.0162058E-12,   3.7190819E-12,   2.2860522E-12
     +,   1.3972224E-12,   8.4916194E-13,   5.1315229E-13
     +,   3.0835081E-13,   1.8423639E-13,   1.0945854E-13
     +,   6.4662820E-14,   3.7984247E-14,   2.2186207E-14
     +,   1.2885657E-14,   7.4415190E-15,   4.2732643E-15
     +,   2.4399883E-15,   1.3853585E-15
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_haonly_htt115_mass = Yx/0.532226666666667
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_haonly_htt120_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.6551938E-06,   3.2234946E-06
     +,   3.9037805E-06,   4.7159815E-06,   5.6831291E-06
     +,   6.8317627E-06,   8.1923436E-06,   9.7997336E-06
     +,   1.1693666E-05,   1.3919388E-05,   1.6528071E-05
     +,   1.9577499E-05,   2.3132687E-05,   2.7266455E-05
     +,   3.2060168E-05,   3.7604321E-05,   4.3999204E-05
     +,   5.1355571E-05,   5.9795184E-05,   6.9451395E-05
     +,   8.0469661E-05,   9.3007897E-05,   1.0723669E-04
     +,   1.2334051E-04,   1.4151516E-04,   1.6197139E-04
     +,   1.8493138E-04,   2.1062973E-04,   2.3931278E-04
     +,   2.7123687E-04,   3.0666767E-04,   3.4587865E-04
     +,   3.8914860E-04,   4.3676014E-04,   4.8899662E-04
     +,   5.4613990E-04,   6.0846616E-04,   6.7624223E-04
     +,   7.4972713E-04,   8.2915497E-04,   9.1474754E-04
     +,   1.0066964E-03,   1.1051642E-03,   1.2102786E-03
     +,   1.3221275E-03,   1.4407544E-03,   1.5661536E-03
     +,   1.6982659E-03,   1.8369736E-03,   1.9820977E-03
     +,   2.1333946E-03,   2.2905522E-03,   2.4531863E-03
     +,   2.6208523E-03,   2.7930150E-03,   2.9690866E-03
     +,   3.1483981E-03,   3.3302167E-03,   3.5137441E-03
     +,   3.6981229E-03,   3.8824414E-03,   4.0657427E-03
     +,   4.2470172E-03,   4.4252411E-03,   4.5993640E-03
     +,   4.7683087E-03,   4.9310182E-03,   5.0864215E-03
     +,   5.2334941E-03,   5.3712218E-03,   5.4986528E-03
     +,   5.6148795E-03,   5.7190740E-03,   5.8104792E-03
     +,   5.8884323E-03,   5.9523764E-03,   6.0018538E-03
     +,   6.0365298E-03,   6.0561965E-03,   6.0607726E-03
     +,   6.0503148E-03,   6.0250163E-03,   5.9852144E-03
     +,   5.9313844E-03,   5.8641485E-03,   5.7842610E-03
     +,   5.6926226E-03,   5.5902586E-03,   5.4783314E-03
     +,   5.3581186E-03,   5.2310107E-03,   5.0985152E-03
     +,   4.9622366E-03,   4.8238612E-03,   4.6851519E-03
     +,   4.5479522E-03,   4.4141398E-03,   4.2856536E-03
     +,   4.1644396E-03,   4.0524728E-03,   3.9517037E-03
     +,   3.8640760E-03,   3.7914808E-03,   3.7357558E-03
     +,   3.6986514E-03,   3.6818187E-03,   3.6867843E-03
     +,   3.7149265E-03,   3.7674566E-03,   3.8453951E-03
     +,   3.9495444E-03,   4.0804851E-03,   4.2385296E-03
     +,   4.4237375E-03,   4.6358658E-03,   4.8743989E-03
     +,   5.1384885E-03,   5.4270108E-03,   5.7385033E-03
     +,   6.0712253E-03,   6.4231539E-03,   6.7919716E-03
     +,   7.1751056E-03,   7.5697927E-03,   7.9730852E-03
     +,   8.3818464E-03,   8.7928921E-03,   9.2029376E-03
     +,   9.6087456E-03,   1.0007082E-02,   1.0394877E-02
     +,   1.0769169E-02,   1.1127274E-02,   1.1466724E-02
     +,   1.1785395E-02,   1.2081519E-02,   1.2353692E-02
     +,   1.2600913E-02,   1.2822615E-02,   1.3018643E-02
     +,   1.3189234E-02,   1.3335011E-02,   1.3456951E-02
     +,   1.3556329E-02,   1.3634670E-02,   1.3693685E-02
     +,   1.3735219E-02,   1.3761163E-02,   1.3773395E-02
     +,   1.3773722E-02,   1.3763809E-02,   1.3745131E-02
     +,   1.3718930E-02,   1.3686189E-02,   1.3647604E-02
     +,   1.3603591E-02,   1.3554296E-02,   1.3499606E-02
     +,   1.3439199E-02,   1.3372583E-02,   1.3299145E-02
     +,   1.3218212E-02,   1.3129113E-02,   1.3031232E-02
     +,   1.2924067E-02,   1.2807262E-02,   1.2680670E-02
     +,   1.2544364E-02,   1.2398646E-02,   1.2244052E-02
     +,   1.2081355E-02,   1.1911532E-02,   1.1735713E-02
     +,   1.1555159E-02,   1.1371224E-02,   1.1185264E-02
     +,   1.0998611E-02,   1.0812519E-02,   1.0628115E-02
     +,   1.0446340E-02,   1.0267922E-02,   1.0093371E-02
     +,   9.9229459E-03,   9.7566452E-03,   9.5942179E-03
     +,   9.4351945E-03,   9.2789037E-03,   9.1244839E-03
     +,   8.9709470E-03,   8.8172238E-03,   8.6621782E-03
     +,   8.5046766E-03,   8.3436240E-03,   8.1780106E-03
     +,   8.0069201E-03,   7.8295823E-03,   7.6453974E-03
     +,   7.4539534E-03,   7.2550089E-03,   7.0485198E-03
     +,   6.8346444E-03,   6.6137272E-03,   6.3862619E-03
     +,   6.1528995E-03,   5.9144464E-03,   5.6717885E-03
     +,   5.4259072E-03,   5.1778550E-03,   4.9287286E-03
     +,   4.6796226E-03,   4.4316254E-03,   4.1858186E-03
     +,   3.9432440E-03,   3.7048685E-03,   3.4715931E-03
     +,   3.2442575E-03,   3.0236142E-03,   2.8103113E-03
     +,   2.6049053E-03,   2.4078772E-03,   2.2195973E-03
     +,   2.0403438E-03,   1.8703192E-03,   1.7096426E-03
     +,   1.5583432E-03,   1.4163792E-03,   1.2836525E-03
     +,   1.1600046E-03,   1.0452148E-03,   9.3901943E-04
     +,   8.4112084E-04,   7.5118890E-04,   6.6886039E-04
     +,   5.9375330E-04,   5.2547763E-04,   4.6362699E-04
     +,   4.0779120E-04,   3.5756404E-04,   3.1254292E-04
     +,   2.7232876E-04,   2.3653488E-04,   2.0478936E-04
     +,   1.7673570E-04,   1.5203217E-04,   1.3035603E-04
     +,   1.1140526E-04,   9.4897448E-05,   8.0569145E-05
     +,   6.8177273E-05,   5.7499667E-05,   4.8332375E-05
     +,   4.0490238E-05,   3.3806413E-05,   2.8130798E-05
     +,   2.3328794E-05,   1.9280717E-05,   1.5880825E-05
     +,   1.3035917E-05,   1.0664055E-05,   8.6938016E-06
     +,   7.0632286E-06,   5.7187822E-06,   4.6142941E-06
     +,   3.7102463E-06,   2.9730388E-06,   2.3740699E-06
     +,   1.8891953E-06,   1.4981371E-06,   1.1839134E-06
     +,   9.3234740E-07,   7.3167723E-07,   5.7220109E-07
     +,   4.4593043E-07,   3.4631415E-07,   2.6801155E-07
     +,   2.0669241E-07,   1.5884513E-07,   1.2164931E-07
     +,   9.2837425E-08,   7.0602745E-08,   5.3505250E-08
     +,   4.0406967E-08,   3.0408241E-08,   2.2803984E-08
     +,   1.7041382E-08,   1.2690616E-08,   9.4175894E-09
     +,   6.9641990E-09,   5.1319811E-09,   3.7685379E-09
     +,   2.7576772E-09,   2.0108912E-09,   1.4612200E-09
     +,   1.0580736E-09,   7.6348200E-10,   5.4897764E-10
     +,   3.9336290E-10,   2.8086983E-10,   1.9984750E-10
     +,   1.4169846E-10,   1.0011848E-10
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_haonly_htt120_mass = Yx/0.314346375
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_haonly_htt60_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.0967618E-03,   1.1586945E-03
     +,   1.2289407E-03,   1.3083651E-03,   1.3978919E-03
     +,   1.4985055E-03,   1.6112521E-03,   1.7372411E-03
     +,   1.8776432E-03,   2.0336995E-03,   2.2067055E-03
     +,   2.3980178E-03,   2.6090445E-03,   2.8412414E-03
     +,   3.0960965E-03,   3.3751188E-03,   3.6798199E-03
     +,   4.0116906E-03,   4.3721753E-03,   4.7626402E-03
     +,   5.1843380E-03,   5.6383698E-03,   6.1256308E-03
     +,   6.6468106E-03,   7.2022560E-03,   7.7920416E-03
     +,   8.4158368E-03,   9.0729073E-03,   9.7620813E-03
     +,   1.0481729E-02,   1.1229738E-02,   1.2003538E-02
     +,   1.2800106E-02,   1.3616005E-02,   1.4447440E-02
     +,   1.5290318E-02,   1.6140353E-02,   1.6993148E-02
     +,   1.7844377E-02,   1.8689783E-02,   1.9525515E-02
     +,   2.0348107E-02,   2.1154700E-02,   2.1943199E-02
     +,   2.2712376E-02,   2.3462012E-02,   2.4192968E-02
     +,   2.4907261E-02,   2.5608068E-02,   2.6299711E-02
     +,   2.6987549E-02,   2.7677858E-02,   2.8377622E-02
     +,   2.9094284E-02,   2.9835369E-02,   3.0608265E-02
     +,   3.1419691E-02,   3.2275397E-02,   3.3179790E-02
     +,   3.4135565E-02,   3.5143424E-02,   3.6201932E-02
     +,   3.7307329E-02,   3.8453646E-02,   3.9632831E-02
     +,   4.0834811E-02,   4.2048141E-02,   4.3260053E-02
     +,   4.4457354E-02,   4.5626529E-02,   4.6754647E-02
     +,   4.7829606E-02,   4.8840895E-02,   4.9779851E-02
     +,   5.0640296E-02,   5.1418863E-02,   5.2115206E-02
     +,   5.2732337E-02,   5.3276811E-02,   5.3758547E-02
     +,   5.4190572E-02,   5.4588791E-02,   5.4970995E-02
     +,   5.5356164E-02,   5.5763129E-02,   5.6209285E-02
     +,   5.6709230E-02,   5.7273347E-02,   5.7906739E-02
     +,   5.8608372E-02,   5.9370901E-02,   6.0180802E-02
     +,   6.1019324E-02,   6.1864115E-02,   6.2691048E-02
     +,   6.3476421E-02,   6.4199440E-02,   6.4844213E-02
     +,   6.5401562E-02,   6.5870032E-02,   6.6256277E-02
     +,   6.6574469E-02,   6.6845022E-02,   6.7092903E-02
     +,   6.7345232E-02,   6.7628928E-02,   6.7968495E-02
     +,   6.8384230E-02,   6.8890899E-02,   6.9497086E-02
     +,   7.0205078E-02,   7.1011394E-02,   7.1907476E-02
     +,   7.2880663E-02,   7.3914818E-02,   7.4991129E-02
     +,   7.6088071E-02,   7.7181831E-02,   7.8245789E-02
     +,   7.9250567E-02,   8.0164067E-02,   8.0951765E-02
     +,   8.1577875E-02,   8.2006626E-02,   8.2204372E-02
     +,   8.2141608E-02,   8.1795402E-02,   8.1151411E-02
     +,   8.0205277E-02,   7.8963749E-02,   7.7444226E-02
     +,   7.5674295E-02,   7.3689662E-02,   7.1532346E-02
     +,   6.9247633E-02,   6.6881515E-02,   6.4478479E-02
     +,   6.2079091E-02,   5.9718437E-02,   5.7425246E-02
     +,   5.5221673E-02,   5.3123433E-02,   5.1140148E-02
     +,   4.9276512E-02,   4.7533467E-02,   4.5908868E-02
     +,   4.4398677E-02,   4.2997856E-02,   4.1700900E-02
     +,   4.0502086E-02,   3.9395850E-02,   3.8376883E-02
     +,   3.7439946E-02,   3.6579654E-02,   3.5790384E-02
     +,   3.5066072E-02,   3.4400035E-02,   3.3784848E-02
     +,   3.3212334E-02,   3.2673761E-02,   3.2159790E-02
     +,   3.1660855E-02,   3.1167390E-02,   3.0670149E-02
     +,   3.0160507E-02,   2.9630752E-02,   2.9074427E-02
     +,   2.8486494E-02,   2.7863447E-02,   2.7203429E-02
     +,   2.6506258E-02,   2.5773317E-02,   2.5007373E-02
     +,   2.4212401E-02,   2.3393467E-02,   2.2556255E-02
     +,   2.1706948E-02,   2.0851962E-02,   1.9997673E-02
     +,   1.9150132E-02,   1.8314963E-02,   1.7497223E-02
     +,   1.6701283E-02,   1.5930697E-02,   1.5188219E-02
     +,   1.4475873E-02,   1.3794929E-02,   1.3145910E-02
     +,   1.2528730E-02,   1.1942822E-02,   1.1387126E-02
     +,   1.0860230E-02,   1.0360519E-02,   9.8861996E-03
     +,   9.4353585E-03,   9.0060756E-03,   8.5964929E-03
     +,   8.2048420E-03,   7.8294575E-03,   7.4688136E-03
     +,   7.1215937E-03,   6.7866351E-03,   6.4629428E-03
     +,   6.1496827E-03,   5.8462191E-03,   5.5520260E-03
     +,   5.2667116E-03,   4.9900129E-03,   4.7217677E-03
     +,   4.4618645E-03,   4.2102584E-03,   3.9669652E-03
     +,   3.7320293E-03,   3.5054947E-03,   3.2874141E-03
     +,   3.0778509E-03,   2.8768552E-03,   2.6844470E-03
     +,   2.5006263E-03,   2.3253828E-03,   2.1586630E-03
     +,   2.0003866E-03,   1.8504527E-03,   1.7087357E-03
     +,   1.5750699E-03,   1.4492683E-03,   1.3311302E-03
     +,   1.2204320E-03,   1.1169270E-03,   1.0203531E-03
     +,   9.3044288E-04,   8.4691908E-04,   7.6949102E-04
     +,   6.9786404E-04,   6.3174887E-04,   5.7084794E-04
     +,   5.1486719E-04,   4.6351852E-04,   4.1651962E-04
     +,   3.7359053E-04,   3.3445968E-04,   2.9886712E-04
     +,   2.6656131E-04,   2.3729930E-04,   2.1084878E-04
     +,   1.8699051E-04,   1.6551610E-04,   1.4622719E-04
     +,   1.2893720E-04,   1.1347247E-04,   9.9668941E-05
     +,   8.7373737E-05,   7.6445569E-05,   6.6753208E-05
     +,   5.8174857E-05,   5.0598337E-05,   4.3921118E-05
     +,   3.8049191E-05,   3.2896289E-05,   2.8383902E-05
     +,   2.4441038E-05,   2.1003345E-05,   1.8012455E-05
     +,   1.5415852E-05,   1.3166585E-05,   1.1222363E-05
     +,   9.5454316E-06,   8.1022517E-06,   6.8629984E-06
     +,   5.8011592E-06,   4.8933061E-06,   4.1188528E-06
     +,   3.4596774E-06,   2.8998468E-06,   2.4254314E-06
     +,   2.0243203E-06,   1.6859236E-06,   1.4010938E-06
     +,   1.1618746E-06,   9.6142651E-07,   7.9383494E-07
     +,   6.5403913E-07,   5.3768559E-07,   4.4107020E-07
     +,   3.6102165E-07,   2.9485463E-07,   2.4028509E-07
     +,   1.9538199E-07,   1.5851988E-07,   1.2832682E-07
     +,   1.0365468E-07,   8.3539021E-08,   6.7177474E-08
     +,   5.3899296E-08,   4.3149072E-08,   3.4465280E-08
     +,   2.7467385E-08,   2.1840863E-08,   1.7327864E-08
     +,   1.3716199E-08,   1.0832829E-08
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_haonly_htt60_mass = Yx/1.76965366666667
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_haonly_htt65_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.6915803E-03,   5.1862276E-03
     +,   5.7221334E-03,   6.2993364E-03,   6.9172946E-03
     +,   7.5748274E-03,   8.2700700E-03,   9.0004262E-03
     +,   9.7625377E-03,   1.0552323E-02,   1.1364919E-02
     +,   1.2194767E-02,   1.3035645E-02,   1.3880770E-02
     +,   1.4722889E-02,   1.5554409E-02,   1.6367571E-02
     +,   1.7154584E-02,   1.7907841E-02,   1.8620105E-02
     +,   1.9284692E-02,   1.9895682E-02,   2.0448085E-02
     +,   2.0938054E-02,   2.1362910E-02,   2.1721384E-02
     +,   2.2013575E-02,   2.2241041E-02,   2.2406738E-02
     +,   2.2515012E-02,   2.2571484E-02,   2.2582954E-02
     +,   2.2557298E-02,   2.2503376E-02,   2.2430919E-02
     +,   2.2350548E-02,   2.2273749E-02,   2.2212971E-02
     +,   2.2181764E-02,   2.2194954E-02,   2.2268847E-02
     +,   2.2421392E-02,   2.2672283E-02,   2.3042912E-02
     +,   2.3556104E-02,   2.4235621E-02,   2.5105314E-02
     +,   2.6187986E-02,   2.7503965E-02,   2.9069357E-02
     +,   3.0894293E-02,   3.2981221E-02,   3.5323281E-02
     +,   3.7903573E-02,   4.0694274E-02,   4.3657806E-02
     +,   4.6747703E-02,   4.9911093E-02,   5.3091787E-02
     +,   5.6233685E-02,   5.9284616E-02,   6.2199641E-02
     +,   6.4943463E-02,   6.7492515E-02,   6.9834895E-02
     +,   7.1968943E-02,   7.3901385E-02,   7.5643346E-02
     +,   7.7207014E-02,   7.8601591E-02,   7.9830594E-02
     +,   8.0889843E-02,   8.1767462E-02,   8.2445040E-02
     +,   8.2900450E-02,   8.3111532E-02,   8.3059907E-02
     +,   8.2734711E-02,   8.2135439E-02,   8.1273109E-02
     +,   8.0170237E-02,   7.8859173E-02,   7.7379435E-02
     +,   7.5774007E-02,   7.4086182E-02,   7.2356015E-02
     +,   7.0618562E-02,   6.8902120E-02,   6.7228511E-02
     +,   6.5613337E-02,   6.4067386E-02,   6.2598310E-02
     +,   6.1211895E-02,   5.9913147E-02,   5.8707256E-02
     +,   5.7600204E-02,   5.6598507E-02,   5.5709600E-02
     +,   5.4941460E-02,   5.4302581E-02,   5.3801626E-02
     +,   5.3447269E-02,   5.3247448E-02,   5.3208862E-02
     +,   5.3335760E-02,   5.3628881E-02,   5.4084051E-02
     +,   5.4690938E-02,   5.5432230E-02,   5.6283023E-02
     +,   5.7210952E-02,   5.8177125E-02,   5.9137337E-02
     +,   6.0044371E-02,   6.0850102E-02,   6.1508212E-02
     +,   6.1976545E-02,   6.2219262E-02,   6.2208474E-02
     +,   6.1925285E-02,   6.1360262E-02,   6.0513239E-02
     +,   5.9392627E-02,   5.8014322E-02,   5.6400232E-02
     +,   5.4577090E-02,   5.2574646E-02,   5.0424635E-02
     +,   4.8159160E-02,   4.5810223E-02,   4.3408282E-02
     +,   4.0982258E-02,   3.8558546E-02,   3.6161218E-02
     +,   3.3811361E-02,   3.1527180E-02,   2.9324144E-02
     +,   2.7214834E-02,   2.5208896E-02,   2.3313370E-02
     +,   2.1532929E-02,   1.9870013E-02,   1.8324956E-02
     +,   1.6896361E-02,   1.5581556E-02,   1.4376543E-02
     +,   1.3276448E-02,   1.2275816E-02,   1.1368745E-02
     +,   1.0549018E-02,   9.8103331E-03,   9.1464687E-03
     +,   8.5513107E-03,   8.0188988E-03,   7.5435205E-03
     +,   7.1197636E-03,   6.7425105E-03,   6.4069140E-03
     +,   6.1084540E-03,   5.8429413E-03,   5.6064739E-03
     +,   5.3954548E-03,   5.2065994E-03,   5.0369115E-03
     +,   4.8836586E-03,   4.7443807E-03,   4.6168822E-03
     +,   4.4992054E-03,   4.3896083E-03,   4.2865677E-03
     +,   4.1887588E-03,   4.0950407E-03,   4.0044310E-03
     +,   3.9161025E-03,   3.8293756E-03,   3.7436902E-03
     +,   3.6585990E-03,   3.5737625E-03,   3.4889341E-03
     +,   3.4039433E-03,   3.3186895E-03,   3.2331371E-03
     +,   3.1473078E-03,   3.0612566E-03,   2.9750776E-03
     +,   2.8888981E-03,   2.8028660E-03,   2.7171394E-03
     +,   2.6318869E-03,   2.5472871E-03,   2.4635140E-03
     +,   2.3807329E-03,   2.2991113E-03,   2.2188050E-03
     +,   2.1399518E-03,   2.0626774E-03,   1.9870964E-03
     +,   1.9133092E-03,   1.8413946E-03,   1.7714163E-03
     +,   1.7034273E-03,   1.6374661E-03,   1.5735523E-03
     +,   1.5116932E-03,   1.4518900E-03,   1.3941266E-03
     +,   1.3383783E-03,   1.2846151E-03,   1.2327998E-03
     +,   1.1828854E-03,   1.1348202E-03,   1.0885517E-03
     +,   1.0440240E-03,   1.0011763E-03,   9.5994648E-04
     +,   9.2027505E-04,   8.8210212E-04,   8.4536581E-04
     +,   8.1000611E-04,   7.7596685E-04,   7.4319175E-04
     +,   7.1162579E-04,   6.8121869E-04,   6.5192283E-04
     +,   6.2369049E-04,   5.9647759E-04,   5.7024375E-04
     +,   5.4495130E-04,   5.2056357E-04,   4.9704598E-04
     +,   4.7436828E-04,   4.5250199E-04,   4.3141918E-04
     +,   4.1109411E-04,   3.9150449E-04,   3.7262769E-04
     +,   3.5444257E-04,   3.3693051E-04,   3.2007377E-04
     +,   3.0385464E-04,   2.8825595E-04,   2.7326282E-04
     +,   2.5886044E-04,   2.4503376E-04,   2.3176811E-04
     +,   2.1905008E-04,   2.0686635E-04,   1.9520304E-04
     +,   1.8404650E-04,   1.7338413E-04,   1.6320244E-04
     +,   1.5348790E-04,   1.4422768E-04,   1.3540889E-04
     +,   1.2701811E-04,   1.1904186E-04,   1.1146723E-04
     +,   1.0428128E-04,   9.7470598E-05,   9.1021859E-05
     +,   8.4922198E-05,   7.9158825E-05,   7.3718606E-05
     +,   6.8588604E-05,   6.3756437E-05,   5.9209455E-05
     +,   5.4935208E-05,   5.0921677E-05,   4.7157100E-05
     +,   4.3629650E-05,   4.0327817E-05,   3.7240570E-05
     +,   3.4357116E-05,   3.1666801E-05,   2.9159290E-05
     +,   2.6824822E-05,   2.4653637E-05,   2.2636603E-05
     +,   2.0764655E-05,   1.9029334E-05,   1.7422275E-05
     +,   1.5935695E-05,   1.4561940E-05,   1.3293872E-05
     +,   1.2124538E-05,   1.1047468E-05,   1.0056406E-05
     +,   9.1454167E-06,   8.3089808E-06,   7.5417547E-06
     +,   6.8388090E-06,   6.1953897E-06,   5.6071194E-06
     +,   5.0698054E-06,   4.5795791E-06,   4.1327544E-06
     +,   3.7259495E-06,   3.3559375E-06,   3.0197664E-06
     +,   2.7146418E-06,   2.4380056E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_haonly_htt65_mass = Yx/1.56089234482759
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_haonly_htt70_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  6.1152657E-03,   6.2935445E-03
     +,   6.4726523E-03,   6.6525238E-03,   6.8331016E-03
     +,   7.0143375E-03,   7.1961884E-03,   7.3786136E-03
     +,   7.5615710E-03,   7.7450201E-03,   7.9289032E-03
     +,   8.1131561E-03,   8.2976967E-03,   8.4824283E-03
     +,   8.6672269E-03,   8.8519519E-03,   9.0364385E-03
     +,   9.2204977E-03,   9.4039217E-03,   9.5864916E-03
     +,   9.7679701E-03,   9.9481214E-03,   1.0126713E-02
     +,   1.0303540E-02,   1.0478402E-02,   1.0651159E-02
     +,   1.0821719E-02,   1.0990051E-02,   1.1156210E-02
     +,   1.1320346E-02,   1.1482712E-02,   1.1643679E-02
     +,   1.1803752E-02,   1.1963568E-02,   1.2123915E-02
     +,   1.2285735E-02,   1.2450124E-02,   1.2618351E-02
     +,   1.2791863E-02,   1.2972267E-02,   1.3161382E-02
     +,   1.3361217E-02,   1.3573982E-02,   1.3802128E-02
     +,   1.4048347E-02,   1.4315588E-02,   1.4607092E-02
     +,   1.4926407E-02,   1.5277413E-02,   1.5664330E-02
     +,   1.6091755E-02,   1.6564630E-02,   1.7088251E-02
     +,   1.7668255E-02,   1.8310474E-02,   1.9020965E-02
     +,   1.9805767E-02,   2.0670788E-02,   2.1621535E-02
     +,   2.2662876E-02,   2.3798706E-02,   2.5031595E-02
     +,   2.6362319E-02,   2.7789637E-02,   2.9309846E-02
     +,   3.0916261E-02,   3.2599349E-02,   3.4346096E-02
     +,   3.6140442E-02,   3.7962981E-02,   3.9791655E-02
     +,   4.1601818E-02,   4.3367304E-02,   4.5060735E-02
     +,   4.6654914E-02,   4.8123583E-02,   4.9442451E-02
     +,   5.0590266E-02,   5.1549878E-02,   5.2309036E-02
     +,   5.2860953E-02,   5.3204898E-02,   5.3346325E-02
     +,   5.3296804E-02,   5.3073693E-02,   5.2699469E-02
     +,   5.2200947E-02,   5.1608015E-02,   5.0952699E-02
     +,   5.0267581E-02,   4.9584623E-02,   4.8933979E-02
     +,   4.8342880E-02,   4.7834817E-02,   4.7429025E-02
     +,   4.7140341E-02,   4.6979237E-02,   4.6952363E-02
     +,   4.7063112E-02,   4.7312573E-02,   4.7700323E-02
     +,   4.8225194E-02,   4.8885960E-02,   4.9681526E-02
     +,   5.0610967E-02,   5.1673174E-02,   5.2865941E-02
     +,   5.4185152E-02,   5.5623867E-02,   5.7171255E-02
     +,   5.8811750E-02,   6.0525201E-02,   6.2286496E-02
     +,   6.4066842E-02,   6.5834448E-02,   6.7556679E-02
     +,   6.9201328E-02,   7.0738986E-02,   7.2144374E-02
     +,   7.3397994E-02,   7.4486807E-02,   7.5404607E-02
     +,   7.6151639E-02,   7.6733902E-02,   7.7161685E-02
     +,   7.7448077E-02,   7.7607185E-02,   7.7652514E-02
     +,   7.7595435E-02,   7.7444077E-02,   7.7202708E-02
     +,   7.6871656E-02,   7.6447465E-02,   7.5923994E-02
     +,   7.5293414E-02,   7.4547760E-02,   7.3680267E-02
     +,   7.2686754E-02,   7.1566410E-02,   7.0322312E-02
     +,   6.8961576E-02,   6.7494579E-02,   6.5933995E-02
     +,   6.4293481E-02,   6.2586568E-02,   6.0824905E-02
     +,   5.9017520E-02,   5.7170250E-02,   5.5285614E-02
     +,   5.3362947E-02,   5.1399514E-02,   4.9391665E-02
     +,   4.7336005E-02,   4.5230597E-02,   4.3076031E-02
     +,   4.0876463E-02,   3.8639713E-02,   3.6377210E-02
     +,   3.4103598E-02,   3.1836297E-02,   2.9594047E-02
     +,   2.7396113E-02,   2.5261346E-02,   2.3207087E-02
     +,   2.1248227E-02,   1.9396834E-02,   1.7661881E-02
     +,   1.6049044E-02,   1.4560690E-02,   1.3196290E-02
     +,   1.1952864E-02,   1.0825346E-02,   9.8070167E-03
     +,   8.8900663E-03,   8.0661336E-03,   7.3265117E-03
     +,   6.6625774E-03,   6.0660853E-03,   5.5292980E-03
     +,   5.0450871E-03,   4.6070376E-03,   4.2095031E-03
     +,   3.8475494E-03,   3.5169027E-03,   3.2139213E-03
     +,   2.9355434E-03,   2.6791953E-03,   2.4427054E-03
     +,   2.2242561E-03,   2.0223400E-03,   1.8356643E-03
     +,   1.6631231E-03,   1.5037685E-03,   1.3567638E-03
     +,   1.2213466E-03,   1.0968205E-03,   9.8254601E-04
     +,   8.7791774E-04,   7.8235130E-04,   6.9528475E-04
     +,   6.1618071E-04,   5.4451707E-04,   4.7978249E-04
     +,   4.2148225E-04,   3.6914321E-04,   3.2230359E-04
     +,   2.8052047E-04,   2.4337275E-04,   2.1045872E-04
     +,   1.8139499E-04,   1.5582010E-04,   1.3339597E-04
     +,   1.1380592E-04,   9.6753822E-05,   8.1965576E-05
     +,   6.9189286E-05,   5.8193669E-05,   4.8766673E-05
     +,   4.0715819E-05,   3.3867753E-05,   2.8065737E-05
     +,   2.3169574E-05,   1.9054703E-05,   1.5610629E-05
     +,   1.2739728E-05,   1.0356410E-05,   8.3861332E-06
     +,   6.7641545E-06,   5.4344332E-06,   4.3488512E-06
     +,   3.4663467E-06,   2.7519766E-06,   2.1761309E-06
     +,   1.7138988E-06,   1.3444622E-06,   1.0504333E-06
     +,   8.1740774E-07,   6.3351939E-07,   4.8902865E-07
     +,   3.7597229E-07,   2.8788494E-07,   2.1954614E-07
     +,   1.6675530E-07,   1.2614655E-07,   9.5040285E-08
     +,   7.1314830E-08,   5.3296102E-08,   3.9668834E-08
     +,   2.9406136E-08,   2.1710413E-08,   1.5963778E-08
     +,   1.1690576E-08,   8.5265439E-09,   6.1937175E-09
     +,   4.4809103E-09,   3.2285838E-09,   2.3168323E-09
     +,   1.6558374E-09,   1.1786283E-09,   8.3553869E-10
     +,   5.8991884E-10,   4.1481898E-10,   2.9050987E-10
     +,   2.0262504E-10,   1.4075595E-10,   9.7381443E-11
     +,   6.7098910E-11,   4.6045851E-11,   3.1470680E-11
     +,   2.1421871E-11,   1.4522433E-11,   9.8051914E-12
     +,   6.5934740E-12,   4.4157867E-12,   2.9453091E-12
     +,   1.9565727E-12,   1.2944641E-12,   8.5295551E-13
     +,   5.5974686E-13,   3.6584535E-13,   2.3814094E-13
     +,   1.5438775E-13,   9.9682490E-14,   6.4101482E-14
     +,   4.1053200E-14,   2.6185846E-14,   1.6634961E-14
     +,   1.0524629E-14,   6.6318271E-15,   4.1618710E-15
     +,   2.6012797E-15,   1.6192493E-15,   1.0038817E-15
     +,   6.1983875E-16,   3.8117012E-16,   2.3344675E-16
     +,   1.4239646E-16,   8.6504325E-17,   5.2338288E-17
     +,   3.1537651E-17,   1.8927057E-17
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_haonly_htt70_mass = Yx/1.56089234482759
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_haonly_htt75_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  7.1254600E-04,   7.6342432E-04
     +,   8.1733824E-04,   8.7445945E-04,   9.3496899E-04
     +,   9.9905604E-04,   1.0669172E-03,   1.1387556E-03
     +,   1.2147765E-03,   1.2951919E-03,   1.3802090E-03
     +,   1.4700331E-03,   1.5648638E-03,   1.6648916E-03
     +,   1.7702936E-03,   1.8812320E-03,   1.9978506E-03
     +,   2.1202723E-03,   2.2485997E-03,   2.3829122E-03
     +,   2.5232686E-03,   2.6697102E-03,   2.8222622E-03
     +,   2.9809542E-03,   3.1458011E-03,   3.3168502E-03
     +,   3.4941682E-03,   3.6778727E-03,   3.8681466E-03
     +,   4.0652580E-03,   4.2695873E-03,   4.4816453E-03
     +,   4.7020940E-03,   4.9317693E-03,   5.1716911E-03
     +,   5.4230774E-03,   5.6873406E-03,   5.9660752E-03
     +,   6.2610605E-03,   6.5741804E-03,   6.9074342E-03
     +,   7.2628357E-03,   7.6423469E-03,   8.0478052E-03
     +,   8.4808143E-03,   8.9426609E-03,   9.4342111E-03
     +,   9.9558262E-03,   1.0507291E-02,   1.1087769E-02
     +,   1.1695784E-02,   1.2329242E-02,   1.2985505E-02
     +,   1.3661525E-02,   1.4353901E-02,   1.5059236E-02
     +,   1.5774233E-02,   1.6496008E-02,   1.7222326E-02
     +,   1.7951870E-02,   1.8684402E-02,   1.9420967E-02
     +,   2.0163871E-02,   2.0916816E-02,   2.1684682E-02
     +,   2.2473283E-02,   2.3289179E-02,   2.4139145E-02
     +,   2.5029877E-02,   2.5967337E-02,   2.6956502E-02
     +,   2.8000729E-02,   2.9101659E-02,   3.0258749E-02
     +,   3.1469397E-02,   3.2728910E-02,   3.4030583E-02
     +,   3.5366006E-02,   3.6725525E-02,   3.8098481E-02
     +,   3.9473359E-02,   4.0838391E-02,   4.2181261E-02
     +,   4.3489546E-02,   4.4750229E-02,   4.5949902E-02
     +,   4.7074333E-02,   4.8108660E-02,   4.9037181E-02
     +,   4.9843866E-02,   5.0512809E-02,   5.1028926E-02
     +,   5.1379133E-02,   5.1553424E-02,   5.1546086E-02
     +,   5.1356852E-02,   5.0991680E-02,   5.0463427E-02
     +,   4.9791690E-02,   4.9002569E-02,   4.8127592E-02
     +,   4.7202539E-02,   4.6265531E-02,   4.5355592E-02
     +,   4.4510596E-02,   4.3765716E-02,   4.3152202E-02
     +,   4.2696290E-02,   4.2418636E-02,   4.2334057E-02
     +,   4.2451695E-02,   4.2775314E-02,   4.3303687E-02
     +,   4.4031154E-02,   4.4948027E-02,   4.6041165E-02
     +,   4.7293972E-02,   4.8687004E-02,   5.0197702E-02
     +,   5.1800728E-02,   5.3468030E-02,   5.5168614E-02
     +,   5.6869000E-02,   5.8533411E-02,   6.0124222E-02
     +,   6.1602302E-02,   6.2928341E-02,   6.4063571E-02
     +,   6.4971462E-02,   6.5619096E-02,   6.5978989E-02
     +,   6.6030733E-02,   6.5762527E-02,   6.5172441E-02
     +,   6.4269133E-02,   6.3071743E-02,   6.1609633E-02
     +,   5.9920873E-02,   5.8050279E-02,   5.6047063E-02
     +,   5.3962246E-02,   5.1845908E-02,   4.9744360E-02
     +,   4.7698211E-02,   4.5740973E-02,   4.3897744E-02
     +,   4.2185172E-02,   4.0612068E-02,   3.9180104E-02
     +,   3.7885133E-02,   3.6718823E-02,   3.5670266E-02
     +,   3.4727346E-02,   3.3877905E-02,   3.3110704E-02
     +,   3.2416087E-02,   3.1786114E-02,   3.1214491E-02
     +,   3.0696366E-02,   3.0227978E-02,   2.9806027E-02
     +,   2.9427234E-02,   2.9087927E-02,   2.8783681E-02
     +,   2.8508997E-02,   2.8257309E-02,   2.8020961E-02
     +,   2.7791377E-02,   2.7559277E-02,   2.7315009E-02
     +,   2.7048953E-02,   2.6751850E-02,   2.6415223E-02
     +,   2.6031662E-02,   2.5595205E-02,   2.5101483E-02
     +,   2.4547849E-02,   2.3933548E-02,   2.3259653E-02
     +,   2.2528896E-02,   2.1745583E-02,   2.0915430E-02
     +,   2.0045273E-02,   1.9142723E-02,   1.8215938E-02
     +,   1.7273407E-02,   1.6323620E-02,   1.5374765E-02
     +,   1.4434582E-02,   1.3510278E-02,   1.2608205E-02
     +,   1.1733883E-02,   1.0891980E-02,   1.0086248E-02
     +,   9.3194749E-03,   8.5935900E-03,   7.9097757E-03
     +,   7.2684786E-03,   6.6694715E-03,   6.1119800E-03
     +,   5.5948263E-03,   5.1164688E-03,   4.6750652E-03
     +,   4.2685904E-03,   3.8949437E-03,   3.5519290E-03
     +,   3.2373525E-03,   2.9490867E-03,   2.6850721E-03
     +,   2.4433311E-03,   2.2220062E-03,   2.0193821E-03
     +,   1.8338721E-03,   1.6640088E-03,   1.5084558E-03
     +,   1.3660087E-03,   1.2355762E-03,   1.1161638E-03
     +,   1.0068729E-03,   9.0690254E-04,   8.1551657E-04
     +,   7.3204754E-04,   6.5589271E-04,   5.8649975E-04
     +,   5.2335678E-04,   4.6599182E-04,   4.1397128E-04
     +,   3.6689072E-04,   3.2436964E-04,   2.8605180E-04
     +,   2.5160550E-04,   2.2071833E-04,   1.9309454E-04
     +,   1.6845616E-04,   1.4654422E-04,   1.2711326E-04
     +,   1.0993366E-04,   9.4791736E-05,   8.1488171E-05
     +,   6.9836773E-05,   5.9665279E-05,   5.0815364E-05
     +,   4.3141325E-05,   3.6509267E-05,   3.0797117E-05
     +,   2.5894466E-05,   2.1701355E-05,   1.8127546E-05
     +,   1.5092227E-05,   1.2523558E-05,   1.0357468E-05
     +,   8.5373404E-06,   7.0134511E-06,   5.7422176E-06
     +,   4.6855380E-06,   3.8103456E-06,   3.0881167E-06
     +,   2.4942970E-06,   2.0078046E-06,   1.6106766E-06
     +,   1.2876860E-06,   1.0259527E-06,   8.1462133E-07
     +,   6.4460068E-07,   5.0832017E-07,   3.9947685E-07
     +,   3.1285921E-07,   2.4418065E-07,   1.8992512E-07
     +,   1.4721674E-07,   1.1371878E-07,   8.7540762E-08
     +,   6.7157522E-08,   5.1343068E-08,   3.9117108E-08
     +,   2.9700074E-08,   2.2472223E-08,   1.6944927E-08
     +,   1.2732998E-08,   9.5351336E-09,   7.1157382E-09
     +,   5.2919744E-09,   3.9220400E-09,   2.8967533E-09
     +,   2.1320992E-09,   1.5638965E-09,   1.1431662E-09
     +,   8.3273483E-10,   6.0451766E-10,   4.3732784E-10
     +,   3.1529027E-10,   2.2652148E-10,   1.6218620E-10
     +,   1.1572143E-10,   8.2284596E-11,   5.8306783E-11
     +,   4.1174127E-11,   2.8975194E-11,   2.0320403E-11
     +,   1.4201518E-11,   9.8910238E-12
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_haonly_htt75_mass = Yx/1.317261
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_haonly_htt80_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.7030724E-04,   2.9272094E-04
     +,   3.1639336E-04,   3.4133653E-04,   3.6755769E-04
     +,   3.9505964E-04,   4.2384060E-04,   4.5389560E-04
     +,   4.8521609E-04,   5.1779434E-04,   5.5162160E-04
     +,   5.8669213E-04,   6.2300666E-04,   6.6057523E-04
     +,   6.9942197E-04,   7.3958992E-04,   7.8114728E-04
     +,   8.2419463E-04,   8.6887256E-04,   9.1536989E-04
     +,   9.6393441E-04,   1.0148825E-03,   1.0686087E-03
     +,   1.1256025E-03,   1.1864494E-03,   1.2518542E-03
     +,   1.3226424E-03,   1.3997732E-03,   1.4843461E-03
     +,   1.5776076E-03,   1.6809519E-03,   1.7959218E-03
     +,   1.9242030E-03,   2.0676155E-03,   2.2281008E-03
     +,   2.4077022E-03,   2.6085428E-03,   2.8327950E-03
     +,   3.0826682E-03,   3.3603294E-03,   3.6679290E-03
     +,   4.0075150E-03,   4.3810196E-03,   4.7902204E-03
     +,   5.2367160E-03,   5.7218960E-03,   6.2469295E-03
     +,   6.8127480E-03,   7.4200509E-03,   8.0692973E-03
     +,   8.7607242E-03,   9.4943419E-03,   1.0269944E-02
     +,   1.1087167E-02,   1.1945347E-02,   1.2843680E-02
     +,   1.3781054E-02,   1.4756060E-02,   1.5766896E-02
     +,   1.6811300E-02,   1.7886423E-02,   1.8988719E-02
     +,   2.0113755E-02,   2.1256240E-02,   2.2409821E-02
     +,   2.3566911E-02,   2.4718912E-02,   2.5855944E-02
     +,   2.6967196E-02,   2.8040843E-02,   2.9064517E-02
     +,   3.0025383E-02,   3.0910723E-02,   3.1708185E-02
     +,   3.2406367E-02,   3.2995261E-02,   3.3466700E-02
     +,   3.3814732E-02,   3.4036141E-02,   3.4130543E-02
     +,   3.4100648E-02,   3.3952262E-02,   3.3694230E-02
     +,   3.3338182E-02,   3.2898296E-02,   3.2390762E-02
     +,   3.1833384E-02,   3.1244965E-02,   3.0644845E-02
     +,   3.0052204E-02,   2.9485678E-02,   2.8962875E-02
     +,   2.8499980E-02,   2.8111426E-02,   2.7809769E-02
     +,   2.7605521E-02,   2.7507102E-02,   2.7520848E-02
     +,   2.7651088E-02,   2.7900157E-02,   2.8268589E-02
     +,   2.8755004E-02,   2.9356342E-02,   3.0067692E-02
     +,   3.0882362E-02,   3.1791836E-02,   3.2785524E-02
     +,   3.3850726E-02,   3.4972604E-02,   3.6134094E-02
     +,   3.7315730E-02,   3.8496085E-02,   3.9651748E-02
     +,   4.0758125E-02,   4.1789860E-02,   4.2722117E-02
     +,   4.3531649E-02,   4.4198465E-02,   4.4707514E-02
     +,   4.5050610E-02,   4.5228306E-02,   4.5251697E-02
     +,   4.5143712E-02,   4.4940174E-02,   4.4689719E-02
     +,   4.4453058E-02,   4.4300959E-02,   4.4311136E-02
     +,   4.4563886E-02,   4.5136858E-02,   4.6099152E-02
     +,   4.7504973E-02,   4.9388081E-02,   5.1756576E-02
     +,   5.4590065E-02,   5.7838533E-02,   6.1423481E-02
     +,   6.5242253E-02,   6.9174707E-02,   7.3091492E-02
     +,   7.6862931E-02,   8.0368958E-02,   8.3507486E-02
     +,   8.6200379E-02,   8.8396907E-02,   9.0074658E-02
     +,   9.1236472E-02,   9.1905519E-02,   9.2118770E-02
     +,   9.1919668E-02,   9.1351390E-02,   9.0451732E-02
     +,   8.9249879E-02,   8.7765552E-02,   8.6010277E-02
     +,   8.3990596E-02,   8.1712000E-02,   7.9182804E-02
     +,   7.6418169E-02,   7.3442593E-02,   7.0290767E-02
     +,   6.7007281E-02,   6.3645013E-02,   6.0262289E-02
     +,   5.6919169E-02,   5.3674102E-02,   5.0580800E-02
     +,   4.7685195E-02,   4.5023199E-02,   4.2619675E-02
     +,   4.0488146E-02,   3.8630869E-02,   3.7039693E-02
     +,   3.5697561E-02,   3.4580350E-02,   3.3658419E-02
     +,   3.2898728E-02,   3.2266632E-02,   3.1727605E-02
     +,   3.1248592E-02,   3.0799311E-02,   3.0353248E-02
     +,   2.9888187E-02,   2.9386578E-02,   2.8835656E-02
     +,   2.8227292E-02,   2.7557692E-02,   2.6826805E-02
     +,   2.6037771E-02,   2.5196394E-02,   2.4310270E-02
     +,   2.3388207E-02,   2.2439718E-02,   2.1474393E-02
     +,   2.0501394E-02,   1.9529156E-02,   1.8565224E-02
     +,   1.7615989E-02,   1.6686570E-02,   1.5780903E-02
     +,   1.4901844E-02,   1.4051243E-02,   1.3230024E-02
     +,   1.2438428E-02,   1.1676255E-02,   1.0942884E-02
     +,   1.0237501E-02,   9.5592756E-03,   8.9074122E-03
     +,   8.2811881E-03,   7.6800422E-03,   7.1036350E-03
     +,   6.5518063E-03,   6.0245181E-03,   5.5218590E-03
     +,   5.0440361E-03,   4.5912904E-03,   4.1638198E-03
     +,   3.7617714E-03,   3.3852377E-03,   3.0341484E-03
     +,   2.7082909E-03,   2.4073145E-03,   2.1307019E-03
     +,   1.8777560E-03,   1.6476321E-03,   1.4393656E-03
     +,   1.2518725E-03,   1.0839634E-03,   9.3438086E-04
     +,   8.0183276E-04,   6.8500149E-04,   5.8256107E-04
     +,   4.9320707E-04,   4.1567910E-04,   3.4875894E-04
     +,   2.9129180E-04,   2.4219745E-04,   2.0047171E-04
     +,   1.6518738E-04,   1.3549990E-04,   1.1064791E-04
     +,   8.9948378E-05,   7.2792616E-05,   5.8643876E-05
     +,   4.7033038E-05,   3.7551858E-05,   2.9847286E-05
     +,   2.3616734E-05,   1.8602967E-05,   1.4587741E-05
     +,   1.1387616E-05,   8.8494926E-06,   6.8461627E-06
     +,   5.2724681E-06,   4.0421533E-06,   3.0849294E-06
     +,   2.3437610E-06,   1.7725989E-06,   1.3345349E-06
     +,   1.0001689E-06,   7.4617674E-07,   5.5415137E-07
     +,   4.0966268E-07,   3.0146785E-07,   2.2083351E-07
     +,   1.6102415E-07,   1.1687469E-07,   8.4441275E-08
     +,   6.0727700E-08,   4.3471925E-08,   3.0975830E-08
     +,   2.1970029E-08,   1.5510462E-08,   1.0899285E-08
     +,   7.6235489E-09,   5.3075020E-09,   3.6779393E-09
     +,   2.5368097E-09,   1.7416004E-09,   1.1900734E-09
     +,   8.0941653E-10,   5.4793714E-10,   3.6919812E-10
     +,   2.4759653E-10,   1.6527124E-10,   1.0980157E-10
     +,   7.2605970E-11,   4.7785807E-11,   3.1302183E-11
     +,   2.0408477E-11,   1.3243241E-11,   8.5533533E-12
     +,   5.4982395E-12,   3.5177733E-12,   2.2400395E-12
     +,   1.4197058E-12,   8.9553793E-13,   5.6224301E-13
     +,   3.5132148E-13,   2.1849392E-13
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_haonly_htt80_mass = Yx/1.50308151724138
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_haonly_htt85_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.0155809E-03,   2.0837842E-03
     +,   2.1547172E-03,   2.2284111E-03,   2.3048867E-03
     +,   2.3841509E-03,   2.4661971E-03,   2.5510034E-03
     +,   2.6385291E-03,   2.7287211E-03,   2.8215041E-03
     +,   2.9167833E-03,   3.0144460E-03,   3.1143564E-03
     +,   3.2163586E-03,   3.3202772E-03,   3.4259118E-03
     +,   3.5330432E-03,   3.6414308E-03,   3.7508134E-03
     +,   3.8609104E-03,   3.9714230E-03,   4.0820334E-03
     +,   4.1924156E-03,   4.3022176E-03,   4.4110883E-03
     +,   4.5186603E-03,   4.6245628E-03,   4.7284188E-03
     +,   4.8298524E-03,   4.9284888E-03,   5.0239596E-03
     +,   5.1159044E-03,   5.2039758E-03,   5.2878405E-03
     +,   5.3671869E-03,   5.4417234E-03,   5.5111870E-03
     +,   5.5753454E-03,   5.6339959E-03,   5.6869751E-03
     +,   5.7341615E-03,   5.7754745E-03,   5.8108820E-03
     +,   5.8404016E-03,   5.8641057E-03,   5.8821240E-03
     +,   5.8946456E-03,   5.9019253E-03,   5.9042820E-03
     +,   5.9021092E-03,   5.8958712E-03,   5.8861123E-03
     +,   5.8734557E-03,   5.8586076E-03,   5.8423607E-03
     +,   5.8255964E-03,   5.8092847E-03,   5.7944860E-03
     +,   5.7823500E-03,   5.7741152E-03,   5.7711042E-03
     +,   5.7747187E-03,   5.7864338E-03,   5.8077872E-03
     +,   5.8403658E-03,   5.8857952E-03,   5.9457151E-03
     +,   6.0217683E-03,   6.1155665E-03,   6.2286803E-03
     +,   6.3625914E-03,   6.5186881E-03,   6.6982070E-03
     +,   6.9022337E-03,   7.1316608E-03,   7.3871501E-03
     +,   7.6691117E-03,   7.9777120E-03,   8.3128409E-03
     +,   8.6740674E-03,   9.0607163E-03,   9.4717834E-03
     +,   9.9060331E-03,   1.0361924E-02,   1.0837745E-02
     +,   1.1331512E-02,   1.1841136E-02,   1.2364324E-02
     +,   1.2898731E-02,   1.3441937E-02,   1.3991443E-02
     +,   1.4544739E-02,   1.5099354E-02,   1.5652850E-02
     +,   1.6202783E-02,   1.6746843E-02,   1.7282765E-02
     +,   1.7808490E-02,   1.8322084E-02,   1.8821958E-02
     +,   1.9306861E-02,   1.9776102E-02,   2.0229612E-02
     +,   2.0668231E-02,   2.1093860E-02,   2.1509612E-02
     +,   2.1920048E-02,   2.2331320E-02,   2.2751179E-02
     +,   2.3188917E-02,   2.3655266E-02,   2.4161963E-02
     +,   2.4721367E-02,   2.5345691E-02,   2.6046341E-02
     +,   2.6832990E-02,   2.7712753E-02,   2.8689345E-02
     +,   2.9762549E-02,   3.0927895E-02,   3.2176562E-02
     +,   3.3495896E-02,   3.4870435E-02,   3.6283161E-02
     +,   3.7717022E-02,   3.9157126E-02,   4.0592253E-02
     +,   4.2016976E-02,   4.3432374E-02,   4.4847108E-02
     +,   4.6276759E-02,   4.7743004E-02,   4.9271278E-02
     +,   5.0888326E-02,   5.2619018E-02,   5.4483082E-02
     +,   5.6492686E-02,   5.8650862E-02,   6.0951326E-02
     +,   6.3379616E-02,   6.5916374E-02,   6.8541914E-02
     +,   7.1241669E-02,   7.4011244E-02,   7.6861612E-02
     +,   7.9821952E-02,   8.2939699E-02,   8.6277455E-02
     +,   8.9906938E-02,   9.3898535E-02,   9.8308563E-02
     +,   0.1031651    ,   0.1084550    ,   0.1141115    
     +,   0.1200072    ,   0.1259532    ,   0.1317058    
     +,   0.1369804    ,   0.1414723    ,   0.1448832    
     +,   0.1469503    ,   0.1474726    ,   0.1463345    
     +,   0.1435202    ,   0.1391184    ,   0.1333165    
     +,   0.1263845    ,   0.1186499    ,   0.1104698    
     +,   0.1022004    ,   9.4168149E-02,   8.6646959E-02
     +,   7.9841971E-02,   7.3882550E-02,   6.8820722E-02
     +,   6.4638436E-02,   6.1259799E-02,   5.8565680E-02
     +,   5.6410156E-02,   5.4637030E-02,   5.3094205E-02
     +,   5.1645480E-02,   5.0178666E-02,   4.8610725E-02
     +,   4.6889417E-02,   4.4991743E-02,   4.2920128E-02
     +,   4.0697239E-02,   3.8360182E-02,   3.5953760E-02
     +,   3.3525199E-02,   3.1119552E-02,   2.8776094E-02
     +,   2.6526047E-02,   2.4391811E-02,   2.2387283E-02
     +,   2.0518620E-02,   1.8785505E-02,   1.7183024E-02
     +,   1.5703348E-02,   1.4337124E-02,   1.3074544E-02
     +,   1.1906346E-02,   1.0824426E-02,   9.8218359E-03
     +,   8.8929283E-03,   8.0332439E-03,   7.2392044E-03
     +,   6.5077841E-03,   5.8362987E-03,   5.2222270E-03
     +,   4.6629831E-03,   4.1557825E-03,   3.6976428E-03
     +,   3.2854129E-03,   2.9157768E-03,   2.5852942E-03
     +,   2.2905124E-03,   2.0280611E-03,   1.7946658E-03
     +,   1.5872348E-03,   1.4029143E-03,   1.2390960E-03
     +,   1.0934224E-03,   9.6379826E-04,   8.4838795E-04
     +,   7.4558635E-04,   6.5399223E-04,   5.7239033E-04
     +,   4.9973134E-04,   4.3510110E-04,   3.7769377E-04
     +,   3.2679882E-04,   2.8178780E-04,   2.4209064E-04
     +,   2.0719049E-04,   1.7661716E-04,   1.4993780E-04
     +,   1.2675102E-04,   1.0668612E-04,   8.9401605E-05
     +,   7.4582123E-05,   6.1936531E-05,   5.1198436E-05
     +,   4.2125754E-05,   3.4499102E-05,   2.8120356E-05
     +,   2.2812523E-05,   1.8418861E-05,   1.4800601E-05
     +,   1.1836232E-05,   9.4202887E-06,   7.4615864E-06
     +,   5.8817650E-06,   4.6141145E-06,   3.6022543E-06
     +,   2.7987749E-06,   2.1640381E-06,   1.6651745E-06
     +,   1.2751351E-06,   9.7175518E-07,   7.3698408E-07
     +,   5.5623099E-07,   4.1778844E-07,   3.1228902E-07
     +,   2.3230183E-07,   1.7196788E-07,   1.2669099E-07
     +,   9.2884498E-08,   6.7769705E-08,   4.9207006E-08
     +,   3.5556731E-08,   2.5569147E-08,   1.8298016E-08
     +,   1.3031562E-08,   9.2359738E-09,   6.5143753E-09
     +,   4.5725370E-09,   3.1940757E-09,   2.2203817E-09
     +,   1.5360807E-09,   1.0575336E-09,   7.2456796E-10
     +,   4.9403520E-10,   3.3522846E-10,   2.2637288E-10
     +,   1.5212520E-10,   1.0173792E-10,   6.7711108E-11
     +,   4.4847851E-11,   2.9560958E-11,   1.9391105E-11
     +,   1.2658519E-11,   8.2237767E-12,   5.3168863E-12
     +,   3.4210161E-12,   2.1905611E-12,   1.3959588E-12
     +,   8.8531363E-13,   5.5879227E-13
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_haonly_htt85_mass = Yx/1.63797344827586
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_haonly_htt90_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.8971571E-06,   4.9468090E-06
     +,   6.2562126E-06,   7.8832218E-06,   9.8968994E-06
     +,   1.2379271E-05,   1.5427282E-05,   1.9154897E-05
     +,   2.3695357E-05,   2.9203889E-05,   3.5859935E-05
     +,   4.3870081E-05,   5.3470714E-05,   6.4930893E-05
     +,   7.8554978E-05,   9.4685289E-05,   1.1370425E-04
     +,   1.3603678E-04,   1.6215142E-04,   1.9256173E-04
     +,   2.2782623E-04,   2.6854809E-04,   3.1537266E-04
     +,   3.6898881E-04,   4.3011594E-04,   4.9951050E-04
     +,   5.7794980E-04,   6.6622766E-04,   7.6514360E-04
     +,   8.7549171E-04,   9.9804671E-04,   1.1335496E-03
     +,   1.2826925E-03,   1.4460995E-03,   1.6243106E-03
     +,   1.8177620E-03,   2.0267675E-03,   2.2514956E-03
     +,   2.4919724E-03,   2.7480186E-03,   3.0192945E-03
     +,   3.3052380E-03,   3.6050819E-03,   3.9178319E-03
     +,   4.2422749E-03,   4.5769727E-03,   4.9202726E-03
     +,   5.2703116E-03,   5.6250356E-03,   5.9822202E-03
     +,   6.3394890E-03,   6.6943504E-03,   7.0442157E-03
     +,   7.3864744E-03,   7.7184597E-03,   8.0375746E-03
     +,   8.3412770E-03,   8.6271418E-03,   8.8928994E-03
     +,   9.1364831E-03,   9.3560610E-03,   9.5500750E-03
     +,   9.7172596E-03,   9.8566916E-03,   9.9677946E-03
     +,   1.0050343E-02,   1.0104494E-02,   1.0130769E-02
     +,   1.0130059E-02,   1.0103611E-02,   1.0053008E-02
     +,   9.9801403E-03,   9.8871840E-03,   9.7765736E-03
     +,   9.6509419E-03,   9.5130987E-03,   9.3659908E-03
     +,   9.2126466E-03,   9.0561369E-03,   8.8995211E-03
     +,   8.7458352E-03,   8.5980091E-03,   8.4588686E-03
     +,   8.3310641E-03,   8.2170712E-03,   8.1191305E-03
     +,   8.0392556E-03,   7.9791816E-03,   7.9403725E-03
     +,   7.9240017E-03,   7.9309400E-03,   7.9617556E-03
     +,   8.0167251E-03,   8.0958288E-03,   8.1987716E-03
     +,   8.3249863E-03,   8.4736729E-03,   8.6438004E-03
     +,   8.8341683E-03,   9.0433937E-03,   9.2700021E-03
     +,   9.5124068E-03,   9.7690076E-03,   1.0038169E-02
     +,   1.0318314E-02,   1.0607931E-02,   1.0905593E-02
     +,   1.1210000E-02,   1.1520004E-02,   1.1834609E-02
     +,   1.2152934E-02,   1.2474269E-02,   1.2797964E-02
     +,   1.3123481E-02,   1.3450258E-02,   1.3777743E-02
     +,   1.4105243E-02,   1.4431964E-02,   1.4756854E-02
     +,   1.5078645E-02,   1.5395800E-02,   1.5706478E-02
     +,   1.6008593E-02,   1.6299902E-02,   1.6578073E-02
     +,   1.6840817E-02,   1.7086124E-02,   1.7312402E-02
     +,   1.7518787E-02,   1.7705290E-02,   1.7873099E-02
     +,   1.8024663E-02,   1.8163878E-02,   1.8296044E-02
     +,   1.8427799E-02,   1.8566959E-02,   1.8722167E-02
     +,   1.8902618E-02,   1.9117786E-02,   1.9377241E-02
     +,   1.9690759E-02,   2.0068893E-02,   2.0524027E-02
     +,   2.1072118E-02,   2.1734769E-02,   2.2541922E-02
     +,   2.3534195E-02,   2.4764437E-02,   2.6297770E-02
     +,   2.8209472E-02,   3.0580148E-02,   3.3488140E-02
     +,   3.7000909E-02,   4.1167084E-02,   4.6011392E-02
     +,   5.1535226E-02,   5.7726115E-02,   6.4575672E-02
     +,   7.2103180E-02,   8.0379441E-02,   8.9546256E-02
     +,   9.9818170E-02,   0.1114620    ,   0.1247529    
     +,   0.1399106    ,   0.1570251    ,   0.1759891    
     +,   0.1964570    ,   0.2178422    ,   0.2393569    
     +,   0.2600939    ,   0.2791397    ,   0.2956955    
     +,   0.3091718    ,   0.3192254    ,   0.3257295    
     +,   0.3286686    ,   0.3280187    ,   0.3236689    
     +,   0.3154380    ,   0.3031953    ,   0.2870315    
     +,   0.2673928    ,   0.2451015    ,   0.2212498    
     +,   0.1970063    ,   0.1734120    ,   0.1512396    
     +,   0.1309548    ,   0.1127597    ,   9.6675329E-02
     +,   8.2628883E-02,   7.0513301E-02,   6.0211085E-02
     +,   5.1595427E-02,   4.4522122E-02,   3.8822595E-02
     +,   3.4303281E-02,   3.0753428E-02,   2.7958753E-02
     +,   2.5716053E-02,   2.3845622E-02,   2.2199826E-02
     +,   2.0667261E-02,   1.9172531E-02,   1.7672321E-02
     +,   1.6149884E-02,   1.4608564E-02,   1.3065181E-02
     +,   1.1544008E-02,   1.0071959E-02,   8.6748842E-03
     +,   7.3747882E-03,   6.1881659E-03,   5.1254174E-03
     +,   4.1909739E-03,   3.3838134E-03,   2.6983758E-03
     +,   2.1257591E-03,   1.6548965E-03,   1.2734949E-03
     +,   9.6898654E-04,   7.2922674E-04,   5.4294599E-04
     +,   4.0004475E-04,   2.9175240E-04,   2.1065223E-04
     +,   1.5060512E-04,   1.0663161E-04,   7.4771524E-05
     +,   5.1929590E-05,   3.5721412E-05,   2.4336481E-05
     +,   1.6419790E-05,   1.0970502E-05,   7.2573202E-06
     +,   4.7528006E-06,   3.0809551E-06,   1.9765960E-06
     +,   1.2547836E-06,   7.8805800E-07,   4.8957605E-07
     +,   3.0081040E-07,   1.8276927E-07,   1.0979493E-07
     +,   6.5204851E-08,   3.8278127E-08,   2.2209553E-08
     +,   1.2734901E-08,   7.2159780E-09,   4.0401380E-09
     +,   2.2349114E-09,   1.2214302E-09,   6.5948758E-10
     +,   3.5175904E-10,   1.8533551E-10,   9.6458119E-11
     +,   4.9588889E-11,   2.5181034E-11,   1.2629554E-11
     +,   6.2564754E-12,   3.0612683E-12,   1.4794099E-12
     +,   7.0611583E-13,   3.3287498E-13,   1.5498610E-13
     +,   7.1268275E-14,   3.2367148E-14,   1.4518773E-14
     +,   6.4323115E-15,   2.8145770E-15,   1.2164520E-15
     +,   5.1934046E-16,   2.1903773E-16,   9.1277303E-17
     +,   3.7596305E-17,   1.5313279E-17,   6.1739115E-18
     +,   2.4676467E-18,   9.8049802E-19,   3.8907942E-19
     +,   1.5538554E-19,   6.3202589E-20,   2.6632298E-20
     +,   1.1863007E-20,   5.6860084E-21,   2.9536966E-21
     +,   1.6513424E-21,   9.7711366E-22,   6.0056539E-22
     +,   3.7764730E-22,   2.4042219E-22,   1.5397559E-22
     +,   9.8829592E-23,   6.3445451E-23,   4.0689890E-23
     +,   2.6055763E-23,   1.6653502E-23,   1.0622635E-23
     +,   6.7614522E-24,   4.2945493E-24
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_haonly_htt90_mass = Yx/2.18127090322581
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_haonly_htt95_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.1134929E-03,   1.1428013E-03
     +,   1.1721211E-03,   1.2014242E-03,   1.2306841E-03
     +,   1.2598743E-03,   1.2889702E-03,   1.3179475E-03
     +,   1.3467838E-03,   1.3754589E-03,   1.4039533E-03
     +,   1.4322494E-03,   1.4603327E-03,   1.4881901E-03
     +,   1.5158115E-03,   1.5431894E-03,   1.5703188E-03
     +,   1.5971988E-03,   1.6238311E-03,   1.6502215E-03
     +,   1.6763795E-03,   1.7023190E-03,   1.7280579E-03
     +,   1.7536210E-03,   1.7790354E-03,   1.8043366E-03
     +,   1.8295647E-03,   1.8547667E-03,   1.8799976E-03
     +,   1.9053192E-03,   1.9308015E-03,   1.9565246E-03
     +,   1.9825771E-03,   2.0090586E-03,   2.0360784E-03
     +,   2.0637582E-03,   2.0922320E-03,   2.1216457E-03
     +,   2.1521607E-03,   2.1839482E-03,   2.2171983E-03
     +,   2.2521124E-03,   2.2889078E-03,   2.3278156E-03
     +,   2.3690825E-03,   2.4129672E-03,   2.4597428E-03
     +,   2.5096948E-03,   2.5631180E-03,   2.6203180E-03
     +,   2.6816053E-03,   2.7472966E-03,   2.8177088E-03
     +,   2.8931631E-03,   2.9739651E-03,   3.0604226E-03
     +,   3.1528247E-03,   3.2514441E-03,   3.3565315E-03
     +,   3.4683100E-03,   3.5869712E-03,   3.7126713E-03
     +,   3.8455145E-03,   3.9855693E-03,   4.1328496E-03
     +,   4.2873020E-03,   4.4488278E-03,   4.6172445E-03
     +,   4.7923247E-03,   4.9737436E-03,   5.1611327E-03
     +,   5.3540235E-03,   5.5519040E-03,   5.7541598E-03
     +,   5.9601353E-03,   6.1691031E-03,   6.3802674E-03
     +,   6.5927752E-03,   6.8057408E-03,   7.0182434E-03
     +,   7.2293049E-03,   7.4379644E-03,   7.6432195E-03
     +,   7.8441054E-03,   8.0396477E-03,   8.2289288E-03
     +,   8.4110554E-03,   8.5852221E-03,   8.7506752E-03
     +,   8.9067742E-03,   9.0529891E-03,   9.1888979E-03
     +,   9.3142260E-03,   9.4288560E-03,   9.5328353E-03
     +,   9.6263792E-03,   9.7099021E-03,   9.7839944E-03
     +,   9.8494580E-03,   9.9072792E-03,   9.9586509E-03
     +,   1.0004943E-02,   1.0047708E-02,   1.0088659E-02
     +,   1.0129652E-02,   1.0172657E-02,   1.0219739E-02
     +,   1.0273020E-02,   1.0334655E-02,   1.0406788E-02
     +,   1.0491528E-02,   1.0590914E-02,   1.0706898E-02
     +,   1.0841332E-02,   1.0995935E-02,   1.1172345E-02
     +,   1.1372089E-02,   1.1596670E-02,   1.1847571E-02
     +,   1.2126345E-02,   1.2434715E-02,   1.2774603E-02
     +,   1.3148239E-02,   1.3558293E-02,   1.4007880E-02
     +,   1.4500585E-02,   1.5040547E-02,   1.5632287E-02
     +,   1.6280754E-02,   1.6990975E-02,   1.7768022E-02
     +,   1.8616483E-02,   1.9540327E-02,   2.0542284E-02
     +,   2.1623585E-02,   2.2783481E-02,   2.4018714E-02
     +,   2.5323261E-02,   2.6688118E-02,   2.8101098E-02
     +,   2.9546725E-02,   3.1006534E-02,   3.2459565E-02
     +,   3.3883028E-02,   3.5253126E-02,   3.6546778E-02
     +,   3.7743188E-02,   3.8825892E-02,   3.9785210E-02
     +,   4.0620774E-02,   4.1343648E-02,   4.1978050E-02
     +,   4.2561926E-02,   4.3146040E-02,   4.3791123E-02
     +,   4.4562861E-02,   4.5525428E-02,   4.6734128E-02
     +,   4.8228521E-02,   5.0027478E-02,   5.2128892E-02
     +,   5.4513894E-02,   5.7156615E-02,   6.0038365E-02
     +,   6.3163713E-02,   6.6573970E-02,   7.0354514E-02
     +,   7.4633263E-02,   7.9569787E-02,   8.5337073E-02
     +,   9.2103563E-02,   0.1000243    ,   0.1092476    
     +,   0.1199379    ,   0.1323057    ,   0.1466341    
     +,   0.1632748    ,   0.1826018    ,   0.2049189    
     +,   0.2303307    ,   0.2585945    ,   0.2889866    
     +,   0.3202213    ,   0.3504554    ,   0.3774030    
     +,   0.3985795    ,   0.4116581    ,   0.4148707    
     +,   0.4073602    ,   0.3893909    ,   0.3623404    
     +,   0.3284700    ,   0.2905341    ,   0.2513193    
     +,   0.2132304    ,   0.1780217    ,   0.1467064    
     +,   0.1196285    ,   9.6643053E-02,   7.7336542E-02
     +,   6.1213095E-02,   4.7811043E-02,   3.6749572E-02
     +,   2.7725739E-02,   2.0487186E-02,   1.4802364E-02
     +,   1.0445353E-02,   7.1931570E-03,   4.8313634E-03
     +,   3.1632741E-03,   2.0177083E-03,   1.2529535E-03
     +,   7.5685524E-04,   4.4430335E-04,   2.5321773E-04
     +,   1.3996752E-04,   7.4966578E-05,   3.8870316E-05
     +,   1.9495012E-05,   9.4516381E-06,   4.4270619E-06
     +,   2.0024086E-06,   8.7440725E-07,   3.6863875E-07
     +,   1.5010036E-07,   5.9105879E-08,   2.2589305E-08
     +,   8.4537852E-09,   3.1642025E-09,   1.2405541E-09
     +,   5.5151261E-10,   3.0035466E-10,   2.0063402E-10
     +,   1.5310091E-10,   1.2443904E-10,   1.0365916E-10
     +,   8.7070871E-11,   7.3305709E-11,   6.1730107E-11
     +,   5.1957490E-11,   4.3701095E-11,   3.6728100E-11
     +,   3.0843182E-11,   2.5880091E-11,   2.1697706E-11
     +,   1.8176129E-11,   1.5213528E-11,   1.2723184E-11
     +,   1.0631490E-11,   8.8762131E-12,   7.4044737E-12
     +,   6.1714908E-12,   5.1394310E-12,   4.2763328E-12
     +,   3.5551406E-12,   2.9530235E-12,   2.4507705E-12
     +,   2.0322054E-12,   1.6836761E-12,   1.3937047E-12
     +,   1.1526758E-12,   9.5251031E-13,   7.8642296E-13
     +,   6.4872858E-13,   5.3468091E-13,   4.4029990E-13
     +,   3.6226103E-13,   2.9779472E-13,   2.4458801E-13
     +,   2.0071287E-13,   1.6456347E-13,   1.3480666E-13
     +,   1.1033513E-13,   9.0226803E-14,   7.3718226E-14
     +,   6.0177815E-14,   4.9081212E-14,   3.9996116E-14
     +,   3.2563850E-14,   2.6489707E-14,   2.1529485E-14
     +,   1.7482901E-14,   1.4184341E-14,   1.1498129E-14
     +,   9.3123997E-15,   7.5355795E-15,   6.0924518E-15
     +,   4.9213360E-15,   3.9718713E-15,   3.2027533E-15
     +,   2.5803256E-15,   2.0770171E-15,   1.6704236E-15
     +,   1.3422394E-15,   1.0775940E-15,   8.6436171E-16
     +,   6.9271842E-16,   5.5466888E-16,   4.4374404E-16
     +,   3.5468854E-16,   2.8325825E-16
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_haonly_htt95_mass = Yx/2.30520675
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_haonly_ttz100_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.3913224E-05,   3.8148362E-05
     +,   4.2840911E-05,   4.8030772E-05,   5.3760214E-05
     +,   6.0073835E-05,   6.7018576E-05,   7.4643736E-05
     +,   8.3000748E-05,   9.2143695E-05,   1.0212844E-04
     +,   1.1301303E-04,   1.2485753E-04,   1.3772387E-04
     +,   1.5167556E-04,   1.6677768E-04,   1.8309687E-04
     +,   2.0070054E-04,   2.1965735E-04,   2.4003642E-04
     +,   2.6190752E-04,   2.8534036E-04,   3.1040431E-04
     +,   3.3717000E-04,   3.6570433E-04,   3.9607621E-04
     +,   4.2835181E-04,   4.6259569E-04,   4.9887097E-04
     +,   5.3723808E-04,   5.7775533E-04,   6.2047777E-04
     +,   6.6545763E-04,   7.1274338E-04,   7.6237990E-04
     +,   8.1440771E-04,   8.6886325E-04,   9.2577667E-04
     +,   9.8517723E-04,   1.0470819E-03,   1.1115087E-03
     +,   1.1784656E-03,   1.2479547E-03,   1.3199719E-03
     +,   1.3945047E-03,   1.4715343E-03,   1.5510321E-03
     +,   1.6329618E-03,   1.7172786E-03,   1.8039268E-03
     +,   1.8928415E-03,   1.9839469E-03,   2.0771553E-03
     +,   2.1723725E-03,   2.2694829E-03,   2.3683687E-03
     +,   2.4688928E-03,   2.5709076E-03,   2.6742516E-03
     +,   2.7787506E-03,   2.8842150E-03,   2.9904456E-03
     +,   3.0972220E-03,   3.2043187E-03,   3.3114993E-03
     +,   3.4185029E-03,   3.5250720E-03,   3.6309261E-03
     +,   3.7357875E-03,   3.8393571E-03,   3.9413432E-03
     +,   4.0414343E-03,   4.1393316E-03,   4.2347205E-03
     +,   4.3272949E-03,   4.4167549E-03,   4.5027980E-03
     +,   4.5851301E-03,   4.6634711E-03,   4.7375550E-03
     +,   4.8071234E-03,   4.8719421E-03,   4.9317912E-03
     +,   4.9864771E-03,   5.0358246E-03,   5.0796913E-03
     +,   5.1179542E-03,   5.1505254E-03,   5.1773447E-03
     +,   5.1983837E-03,   5.2136434E-03,   5.2231601E-03
     +,   5.2270009E-03,   5.2252659E-03,   5.2180840E-03
     +,   5.2056210E-03,   5.1880665E-03,   5.1656445E-03
     +,   5.1386012E-03,   5.1072137E-03,   5.0717783E-03
     +,   5.0326204E-03,   4.9900780E-03,   4.9445154E-03
     +,   4.8963064E-03,   4.8458409E-03,   4.7935233E-03
     +,   4.7397683E-03,   4.6849968E-03,   4.6296329E-03
     +,   4.5741135E-03,   4.5188656E-03,   4.4643269E-03
     +,   4.4109253E-03,   4.3590879E-03,   4.3092309E-03
     +,   4.2617652E-03,   4.2170831E-03,   4.1755666E-03
     +,   4.1375728E-03,   4.1034347E-03,   4.0734620E-03
     +,   4.0479293E-03,   4.0270714E-03,   4.0110825E-03
     +,   4.0001078E-03,   3.9942395E-03,   3.9935103E-03
     +,   3.9978889E-03,   4.0072743E-03,   4.0214946E-03
     +,   4.0402981E-03,   4.0633557E-03,   4.0902579E-03
     +,   4.1205133E-03,   4.1535539E-03,   4.1887313E-03
     +,   4.2253272E-03,   4.2625614E-03,   4.2995983E-03
     +,   4.3355543E-03,   4.3695145E-03,   4.4005518E-03
     +,   4.4277390E-03,   4.4501699E-03,   4.4669830E-03
     +,   4.4773915E-03,   4.4807056E-03,   4.4763722E-03
     +,   4.4640130E-03,   4.4434643E-03,   4.4148308E-03
     +,   4.3785376E-03,   4.3353890E-03,   4.2866291E-03
     +,   4.2340164E-03,   4.1798819E-03,   4.1271881E-03
     +,   4.0795933E-03,   4.0415041E-03,   4.0181093E-03
     +,   4.0154336E-03,   4.0403758E-03,   4.1007628E-03
     +,   4.2054388E-03,   4.3643988E-03,   4.5889546E-03
     +,   4.8919902E-03,   5.2883164E-03,   5.7950546E-03
     +,   6.4320350E-03,   7.2222282E-03,   8.1921620E-03
     +,   9.3720984E-03,   1.0795830E-02,   1.2500492E-02
     +,   1.4525601E-02,   1.6911466E-02,   1.9697230E-02
     +,   2.2918403E-02,   2.6603492E-02,   3.0769967E-02
     +,   3.5420280E-02,   4.0538102E-02,   4.6084061E-02
     +,   5.1992044E-02,   5.8167286E-02,   6.4486124E-02
     +,   7.0796937E-02,   7.6923214E-02,   8.2670957E-02
     +,   8.7836698E-02,   9.2217982E-02,   9.5626019E-02
     +,   9.7898580E-02,   9.8911807E-02,   9.8590337E-02
     +,   9.6915074E-02,   9.3925990E-02,   8.9721270E-02
     +,   8.4451839E-02,   7.8311794E-02,   7.1524836E-02
     +,   6.4330131E-02,   5.6967679E-02,   4.9662851E-02
     +,   4.2615015E-02,   3.5989117E-02,   2.9909840E-02
     +,   2.4459567E-02,   1.9680535E-02,   1.5579410E-02
     +,   1.2133011E-02,   9.2953211E-03,   7.0051239E-03
     +,   5.1929159E-03,   3.7865487E-03,   2.7158090E-03
     +,   1.9158750E-03,   1.3293951E-03,   9.0730883E-04
     +,   6.0907146E-04,   4.0216721E-04,   2.6121034E-04
     +,   1.6689188E-04,   1.0489784E-04,   6.4869258E-05
     +,   3.9475814E-05,   2.3645220E-05,   1.3945346E-05
     +,   8.1028993E-06,   4.6425730E-06,   2.6263328E-06
     +,   1.4698923E-06,   8.1643759E-07,   4.5213233E-07
     +,   2.5131769E-07,   1.4151559E-07,   8.1660460E-08
     +,   4.8887507E-08,   3.0677271E-08,   2.0275923E-08
     +,   1.4083985E-08,   1.0199560E-08,   7.6205762E-09
     +,   5.8156218E-09,   4.4971529E-09,   3.5037895E-09
     +,   2.7400975E-09,   2.1458817E-09,   1.6804957E-09
     +,   1.3148990E-09,   1.0274532E-09,   8.0154666E-10
     +,   6.2419236E-10,   4.8516324E-10,   3.7637060E-10
     +,   2.9140018E-10,   2.2516342E-10,   1.7363146E-10
     +,   1.3362278E-10,   1.0262483E-10,   7.8657157E-11
     +,   6.0163187E-11,   4.5923525E-11,   3.4982038E-11
     +,   2.6592267E-11,   2.0172908E-11,   1.5271669E-11
     +,   1.1537295E-11,   8.6979634E-12,   6.5437686E-12
     +,   4.9129251E-12,   3.6808620E-12,   2.7520130E-12
     +,   2.0532929E-12,   1.5287724E-12,   1.1358851E-12
     +,   8.4220001E-13,   6.2315490E-13,   4.6011507E-13
     +,   3.3902742E-13,   2.4928345E-13,   1.8291548E-13
     +,   1.3393560E-13,   9.7867962E-14,   7.1363739E-14
     +,   5.1928442E-14,   3.7707650E-14,   2.7324000E-14
     +,   1.9758572E-14,   1.4257931E-14,   1.0267281E-14
     +,   7.3780788E-15,   5.2908947E-15,   3.7862021E-15
     +,   2.7038120E-15,   1.9268060E-15,   1.3702400E-15
     +,   9.7239996E-16,   6.8863826E-16
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_haonly_ttz100_mass = Yx/0.635043181818182
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_haonly_ttz105_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.5229844E-03,   1.5805219E-03
     +,   1.6385152E-03,   1.6968609E-03,   1.7554517E-03
     +,   1.8141769E-03,   1.8729223E-03,   1.9315700E-03
     +,   1.9899993E-03,   2.0480903E-03,   2.1057185E-03
     +,   2.1627590E-03,   2.2190867E-03,   2.2745773E-03
     +,   2.3291053E-03,   2.3825485E-03,   2.4347850E-03
     +,   2.4856969E-03,   2.5351674E-03,   2.5830846E-03
     +,   2.6293409E-03,   2.6738327E-03,   2.7164614E-03
     +,   2.7571367E-03,   2.7957703E-03,   2.8322854E-03
     +,   2.8666086E-03,   2.8986759E-03,   2.9284309E-03
     +,   2.9558255E-03,   2.9808194E-03,   3.0033819E-03
     +,   3.0234908E-03,   3.0411321E-03,   3.0563031E-03
     +,   3.0690064E-03,   3.0792567E-03,   3.0870759E-03
     +,   3.0924962E-03,   3.0955570E-03,   3.0963055E-03
     +,   3.0947977E-03,   3.0910976E-03,   3.0852752E-03
     +,   3.0774085E-03,   3.0675805E-03,   3.0558812E-03
     +,   3.0424057E-03,   3.0272529E-03,   3.0105268E-03
     +,   2.9923345E-03,   2.9727863E-03,   2.9519952E-03
     +,   2.9300745E-03,   2.9071406E-03,   2.8833093E-03
     +,   2.8586958E-03,   2.8334160E-03,   2.8075837E-03
     +,   2.7813106E-03,   2.7547069E-03,   2.7278790E-03
     +,   2.7009316E-03,   2.6739640E-03,   2.6470704E-03
     +,   2.6203443E-03,   2.5938696E-03,   2.5677290E-03
     +,   2.5419963E-03,   2.5167426E-03,   2.4920304E-03
     +,   2.4679189E-03,   2.4444584E-03,   2.4216955E-03
     +,   2.3996688E-03,   2.3784102E-03,   2.3579472E-03
     +,   2.3383009E-03,   2.3194852E-03,   2.3015079E-03
     +,   2.2843732E-03,   2.2680766E-03,   2.2526120E-03
     +,   2.2379647E-03,   2.2241171E-03,   2.2110466E-03
     +,   2.1987264E-03,   2.1871249E-03,   2.1762080E-03
     +,   2.1659376E-03,   2.1562721E-03,   2.1471675E-03
     +,   2.1385776E-03,   2.1304542E-03,   2.1227465E-03
     +,   2.1154031E-03,   2.1083707E-03,   2.1015955E-03
     +,   2.0950232E-03,   2.0885994E-03,   2.0822687E-03
     +,   2.0759774E-03,   2.0696712E-03,   2.0632970E-03
     +,   2.0568026E-03,   2.0501367E-03,   2.0432502E-03
     +,   2.0360954E-03,   2.0286255E-03,   2.0207961E-03
     +,   2.0125653E-03,   2.0038930E-03,   1.9947421E-03
     +,   1.9850766E-03,   1.9748646E-03,   1.9640753E-03
     +,   1.9526823E-03,   1.9406601E-03,   1.9279873E-03
     +,   1.9146453E-03,   1.9006171E-03,   1.8858897E-03
     +,   1.8704535E-03,   1.8543001E-03,   1.8374241E-03
     +,   1.8198251E-03,   1.8015022E-03,   1.7824600E-03
     +,   1.7627039E-03,   1.7422430E-03,   1.7210875E-03
     +,   1.6992522E-03,   1.6767516E-03,   1.6536054E-03
     +,   1.6298328E-03,   1.6054556E-03,   1.5804985E-03
     +,   1.5549887E-03,   1.5289534E-03,   1.5024217E-03
     +,   1.4754263E-03,   1.4480022E-03,   1.4201851E-03
     +,   1.3920149E-03,   1.3635380E-03,   1.3348057E-03
     +,   1.3058791E-03,   1.2768354E-03,   1.2477741E-03
     +,   1.2188239E-03,   1.1901588E-03,   1.1620189E-03
     +,   1.1347343E-03,   1.1087578E-03,   1.0847105E-03
     +,   1.0634415E-03,   1.0460975E-03,   1.0342090E-03
     +,   1.0298016E-03,   1.0355196E-03,   1.0547744E-03
     +,   1.0919119E-03,   1.1523947E-03,   1.2429979E-03
     +,   1.3720231E-03,   1.5495069E-03,   1.7874023E-03
     +,   2.0997534E-03,   2.5028556E-03,   3.0153331E-03
     +,   3.6581028E-03,   4.4543082E-03,   5.4291841E-03
     +,   6.6097295E-03,   8.0241244E-03,   9.7013880E-03
     +,   1.1670606E-02,   1.3959961E-02,   1.6595889E-02
     +,   1.9602293E-02,   2.2999365E-02,   2.6802201E-02
     +,   3.1019783E-02,   3.5654034E-02,   4.0698260E-02
     +,   4.6135359E-02,   5.1936429E-02,   5.8059581E-02
     +,   6.4447865E-02,   7.1026988E-02,   7.7705361E-02
     +,   8.4372744E-02,   9.0900108E-02,   9.7141743E-02
     +,   0.1029388    ,   0.1081235    ,   0.1125262    
     +,   0.1159835    ,   0.1183480    ,   0.1194979    
     +,   0.1193464    ,   0.1178497    ,   0.1150126    
     +,   0.1108909    ,   0.1055913    ,   9.9265642E-02
     +,   9.2103392E-02,   8.4321469E-02,   7.6151490E-02
     +,   6.7825876E-02,   5.9565850E-02,   5.1570926E-02
     +,   4.4009693E-02,   3.7013628E-02,   3.0675041E-02
     +,   2.5047945E-02,   2.0150382E-02,   1.5969090E-02
     +,   1.2466115E-02,   9.5856786E-03,   7.2600669E-03
     +,   5.4160198E-03,   3.9797882E-03,   2.8808336E-03
     +,   2.0545267E-03,   1.4438930E-03,   1.0003429E-03
     +,   6.8359397E-04,   4.6114941E-04,   3.0748241E-04
     +,   2.0302902E-04,   1.3312887E-04,   8.7039080E-05
     +,   5.7062411E-05,   3.7799971E-05,   2.5538209E-05
     +,   1.7775908E-05,   1.2861332E-05,   9.7238644E-06
     +,   7.6823771E-06,   6.3114603E-06,   5.3499321E-06
     +,   4.6398713E-06,   4.0870673E-06,   3.6359072E-06
     +,   3.2537537E-06,   2.9213475E-06,   2.6271196E-06
     +,   2.3638868E-06,   2.1269607E-06,   1.9130243E-06
     +,   1.7195645E-06,   1.5445612E-06,   1.3862879E-06
     +,   1.2432178E-06,   1.1139773E-06,   9.9732847E-07
     +,   8.9213768E-07,   7.9736139E-07,   7.1204147E-07
     +,   6.3530683E-07,   5.6635889E-07,   5.0446084E-07
     +,   4.4894128E-07,   3.9919112E-07,   3.5464987E-07
     +,   3.1480707E-07,   2.7920086E-07,   2.4741030E-07
     +,   2.1905156E-07,   1.9377606E-07,   1.7126982E-07
     +,   1.5124841E-07,   1.3345279E-07,   1.1764934E-07
     +,   1.0362880E-07,   9.1200235E-08,   8.0193665E-08
     +,   7.0454604E-08,   6.1845363E-08,   5.4241195E-08
     +,   4.7531351E-08,   4.1615550E-08,   3.6404870E-08
     +,   3.1819063E-08,   2.7787170E-08,   2.4245264E-08
     +,   2.1136538E-08,   1.8410661E-08,   1.6022454E-08
     +,   1.3932095E-08,   1.2103985E-08,   1.0506747E-08
     +,   9.1123882E-09,   7.8963085E-09,   6.8365971E-09
     +,   5.9140315E-09,   5.1115352E-09,   4.4141473E-09
     +,   3.8086063E-09,   3.2833221E-09
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_haonly_ttz105_mass = Yx/0.76840225
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_haonly_ttz107_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.2037264E-03,   1.2131475E-03
     +,   1.2228870E-03,   1.2329515E-03,   1.2433467E-03
     +,   1.2540773E-03,   1.2651470E-03,   1.2765583E-03
     +,   1.2883123E-03,   1.3004094E-03,   1.3128490E-03
     +,   1.3256286E-03,   1.3387448E-03,   1.3521928E-03
     +,   1.3659669E-03,   1.3800595E-03,   1.3944628E-03
     +,   1.4091663E-03,   1.4241592E-03,   1.4394292E-03
     +,   1.4549629E-03,   1.4707452E-03,   1.4867599E-03
     +,   1.5029905E-03,   1.5194175E-03,   1.5360222E-03
     +,   1.5527837E-03,   1.5696797E-03,   1.5866882E-03
     +,   1.6037850E-03,   1.6209454E-03,   1.6381437E-03
     +,   1.6553539E-03,   1.6725485E-03,   1.6896992E-03
     +,   1.7067783E-03,   1.7237561E-03,   1.7406029E-03
     +,   1.7572896E-03,   1.7737844E-03,   1.7900575E-03
     +,   1.8060777E-03,   1.8218139E-03,   1.8372352E-03
     +,   1.8523101E-03,   1.8670079E-03,   1.8812977E-03
     +,   1.8951487E-03,   1.9085308E-03,   1.9214143E-03
     +,   1.9337700E-03,   1.9455685E-03,   1.9567821E-03
     +,   1.9673838E-03,   1.9773459E-03,   1.9866438E-03
     +,   1.9952520E-03,   2.0031466E-03,   2.0103049E-03
     +,   2.0167057E-03,   2.0223279E-03,   2.0271526E-03
     +,   2.0311614E-03,   2.0343382E-03,   2.0366672E-03
     +,   2.0381352E-03,   2.0387289E-03,   2.0384381E-03
     +,   2.0372532E-03,   2.0351664E-03,   2.0321708E-03
     +,   2.0282622E-03,   2.0234375E-03,   2.0176952E-03
     +,   2.0110351E-03,   2.0034590E-03,   1.9949700E-03
     +,   1.9855734E-03,   1.9752756E-03,   1.9640836E-03
     +,   1.9520086E-03,   1.9390604E-03,   1.9252523E-03
     +,   1.9105974E-03,   1.8951125E-03,   1.8788133E-03
     +,   1.8617186E-03,   1.8438471E-03,   1.8252205E-03
     +,   1.8058607E-03,   1.7857889E-03,   1.7650309E-03
     +,   1.7436120E-03,   1.7215577E-03,   1.6988943E-03
     +,   1.6756511E-03,   1.6518545E-03,   1.6275361E-03
     +,   1.6027237E-03,   1.5774494E-03,   1.5517423E-03
     +,   1.5256355E-03,   1.4991583E-03,   1.4723452E-03
     +,   1.4452266E-03,   1.4178336E-03,   1.3901998E-03
     +,   1.3623576E-03,   1.3343383E-03,   1.3061729E-03
     +,   1.2778947E-03,   1.2495333E-03,   1.2211213E-03
     +,   1.1926877E-03,   1.1642640E-03,   1.1358784E-03
     +,   1.1075622E-03,   1.0793421E-03,   1.0512486E-03
     +,   1.0233093E-03,   9.9555135E-04,   9.6800434E-04
     +,   9.4069832E-04,   9.1366266E-04,   8.8692881E-04
     +,   8.6053362E-04,   8.3451462E-04,   8.0891902E-04
     +,   7.8379770E-04,   7.5921643E-04,   7.3525094E-04
     +,   7.1199844E-04,   6.8957591E-04,   6.6813157E-04
     +,   6.4784708E-04,   6.2894699E-04,   6.1170949E-04
     +,   5.9647410E-04,   5.8365171E-04,   5.7373772E-04
     +,   5.6732481E-04,   5.6511391E-04,   5.6792743E-04
     +,   5.7672261E-04,   5.9260253E-04,   6.1682897E-04
     +,   6.5083406E-04,   6.9622771E-04,   7.5480732E-04
     +,   8.2857261E-04,   9.1973547E-04,   1.0307234E-03
     +,   1.1641989E-03,   1.3230881E-03,   1.5106017E-03
     +,   1.7302542E-03,   1.9859094E-03,   2.2818523E-03
     +,   2.6228372E-03,   3.0141186E-03,   3.4615893E-03
     +,   3.9718393E-03,   4.5521851E-03,   5.2107689E-03
     +,   5.9566484E-03,   6.7998003E-03,   7.7510350E-03
     +,   8.8219745E-03,   1.0025010E-02,   1.1373045E-02
     +,   1.2879123E-02,   1.4556118E-02,   1.6416410E-02
     +,   1.8471232E-02,   2.0729838E-02,   2.3199178E-02
     +,   2.5882982E-02,   2.8780794E-02,   3.1887334E-02
     +,   3.5191990E-02,   3.8678020E-02,   4.2321779E-02
     +,   4.6092585E-02,   4.9952913E-02,   5.3858265E-02
     +,   5.7757355E-02,   6.1593127E-02,   6.5304078E-02
     +,   6.8825342E-02,   7.2090089E-02,   7.5032026E-02
     +,   7.7587217E-02,   7.9695962E-02,   8.1305370E-02
     +,   8.2371369E-02,   8.2860410E-02,   8.2751080E-02
     +,   8.2035311E-02,   8.0718897E-02,   7.8821674E-02
     +,   7.6377138E-02,   7.3431462E-02,   7.0041731E-02
     +,   6.6274062E-02,   6.2201846E-02,   5.7902310E-02
     +,   5.3454369E-02,   4.8936278E-02,   4.4422865E-02
     +,   3.9983179E-02,   3.5678897E-02,   3.1563234E-02
     +,   2.7679797E-02,   2.4061823E-02,   2.0732528E-02
     +,   1.7705731E-02,   1.4986311E-02,   1.2571100E-02
     +,   1.0450296E-02,   8.6089270E-03,   7.0277522E-03
     +,   5.6847772E-03,   4.5564827E-03,   3.6187356E-03
     +,   2.8476149E-03,   2.2201904E-03,   1.7150588E-03
     +,   1.3126404E-03,   9.9536486E-04,   7.4779498E-04
     +,   5.5660954E-04,   4.1048243E-04,   2.9992886E-04
     +,   2.1713536E-04,   1.5576194E-04,   1.1072282E-04
     +,   7.8000587E-05,   5.4464341E-05,   3.7703154E-05
     +,   2.5883215E-05,   1.7628379E-05,   1.1918608E-05
     +,   8.0062791E-06,   5.3498270E-06,   3.5617941E-06
     +,   2.3682101E-06,   1.5774158E-06,   1.0568232E-06
     +,   7.1578290E-07,   4.9300331E-07,   3.4744252E-07
     +,   2.5192921E-07,   1.8866086E-07,   1.4608040E-07
     +,   1.1675321E-07,   9.5939619E-08,   8.0639730E-08
     +,   6.8964276E-08,   5.9726176E-08,   5.2178990E-08
     +,   4.5851035E-08,   4.0439549E-08,   3.5745590E-08
     +,   3.1634279E-08,   2.8010763E-08,   2.4804466E-08
     +,   2.1960819E-08,   1.9435861E-08,   1.7192836E-08
     +,   1.5200129E-08,   1.3430189E-08,   1.1858831E-08
     +,   1.0464565E-08,   9.2281578E-09,   8.1323828E-09
     +,   7.1619666E-09,   6.3030945E-09,   5.5435190E-09
     +,   4.8721818E-09,   4.2792800E-09,   3.7559875E-09
     +,   3.2944787E-09,   2.8877190E-09,   2.5294875E-09
     +,   2.2141986E-09,   1.9369064E-09,   1.6932001E-09
     +,   1.4791542E-09,   1.2913042E-09,   1.1265443E-09
     +,   9.8214725E-10,   8.5567869E-10,   7.4499668E-10
     +,   6.4819006E-10,   5.6358546E-10,   4.8969084E-10
     +,   4.2519988E-10,   3.6895159E-10,   3.1993033E-10
     +,   2.7723343E-10,   2.4007374E-10
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_haonly_ttz107_mass = Yx/0.656027217391305
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_haonly_ttz110_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.8129607E-03,   1.8839686E-03
     +,   1.9561171E-03,   2.0293272E-03,   2.1035143E-03
     +,   2.1785877E-03,   2.2544512E-03,   2.3310028E-03
     +,   2.4081348E-03,   2.4857374E-03,   2.5636922E-03
     +,   2.6418781E-03,   2.7201700E-03,   2.7984369E-03
     +,   2.8765467E-03,   2.9543629E-03,   3.0317453E-03
     +,   3.1085548E-03,   3.1846464E-03,   3.2598767E-03
     +,   3.3341006E-03,   3.4071731E-03,   3.4789483E-03
     +,   3.5492864E-03,   3.6180415E-03,   3.6850765E-03
     +,   3.7502544E-03,   3.8134425E-03,   3.8745119E-03
     +,   3.9333384E-03,   3.9898041E-03,   4.0437956E-03
     +,   4.0952093E-03,   4.1439440E-03,   4.1899113E-03
     +,   4.2330269E-03,   4.2732172E-03,   4.3104184E-03
     +,   4.3445742E-03,   4.3756394E-03,   4.4035781E-03
     +,   4.4283662E-03,   4.4499882E-03,   4.4684419E-03
     +,   4.4837324E-03,   4.4958792E-03,   4.5049097E-03
     +,   4.5108646E-03,   4.5137922E-03,   4.5137545E-03
     +,   4.5108213E-03,   4.5050727E-03,   4.4965982E-03
     +,   4.4854982E-03,   4.4718795E-03,   4.4558574E-03
     +,   4.4375565E-03,   4.4171065E-03,   4.3946449E-03
     +,   4.3703145E-03,   4.3442636E-03,   4.3166443E-03
     +,   4.2876145E-03,   4.2573335E-03,   4.2259605E-03
     +,   4.1936627E-03,   4.1606016E-03,   4.1269436E-03
     +,   4.0928498E-03,   4.0584849E-03,   4.0240055E-03
     +,   3.9895717E-03,   3.9553349E-03,   3.9214450E-03
     +,   3.8880450E-03,   3.8552727E-03,   3.8232605E-03
     +,   3.7921367E-03,   3.7620170E-03,   3.7330128E-03
     +,   3.7052291E-03,   3.6787617E-03,   3.6537000E-03
     +,   3.6301240E-03,   3.6081092E-03,   3.5877214E-03
     +,   3.5690230E-03,   3.5520678E-03,   3.5369077E-03
     +,   3.5235900E-03,   3.5121599E-03,   3.5026597E-03
     +,   3.4951360E-03,   3.4896345E-03,   3.4862056E-03
     +,   3.4849057E-03,   3.4857991E-03,   3.4889588E-03
     +,   3.4944711E-03,   3.5024341E-03,   3.5129616E-03
     +,   3.5261835E-03,   3.5422489E-03,   3.5613233E-03
     +,   3.5835952E-03,   3.6092710E-03,   3.6385786E-03
     +,   3.6717607E-03,   3.7090820E-03,   3.7508230E-03
     +,   3.7972729E-03,   3.8487373E-03,   3.9055203E-03
     +,   3.9679357E-03,   4.0362841E-03,   4.1108662E-03
     +,   4.1919565E-03,   4.2798161E-03,   4.3746643E-03
     +,   4.4766897E-03,   4.5860363E-03,   4.7027860E-03
     +,   4.8269555E-03,   4.9584997E-03,   5.0972933E-03
     +,   5.2431147E-03,   5.3956639E-03,   5.5545270E-03
     +,   5.7192058E-03,   5.8890735E-03,   6.0634157E-03
     +,   6.2413909E-03,   6.4220675E-03,   6.6043921E-03
     +,   6.7872265E-03,   6.9693467E-03,   7.1494365E-03
     +,   7.3261196E-03,   7.4979863E-03,   7.6635974E-03
     +,   7.8215059E-03,   7.9702986E-03,   8.1086261E-03
     +,   8.2352413E-03,   8.3490219E-03,   8.4490394E-03
     +,   8.5345889E-03,   8.6052492E-03,   8.6609237E-03
     +,   8.7019075E-03,   8.7289447E-03,   8.7432684E-03
     +,   8.7466659E-03,   8.7415297E-03,   8.7309005E-03
     +,   8.7185027E-03,   8.7087862E-03,   8.7069236E-03
     +,   8.7188324E-03,   8.7511493E-03,   8.8111963E-03
     +,   8.9069363E-03,   9.0468740E-03,   9.2399521E-03
     +,   9.4954288E-03,   9.8227086E-03,   1.0231137E-02
     +,   1.0729773E-02,   1.1327188E-02,   1.2031203E-02
     +,   1.2848544E-02,   1.3784580E-02,   1.4843123E-02
     +,   1.6026100E-02,   1.7333169E-02,   1.8761728E-02
     +,   2.0306617E-02,   2.1959877E-02,   2.3710746E-02
     +,   2.5545802E-02,   2.7448893E-02,   2.9401168E-02
     +,   3.1381428E-02,   3.3366557E-02,   3.5331775E-02
     +,   3.7250958E-02,   3.9097313E-02,   4.0843993E-02
     +,   4.2464625E-02,   4.3933701E-02,   4.5227520E-02
     +,   4.6324570E-02,   4.7205992E-02,   4.7856204E-02
     +,   4.8263222E-02,   4.8418943E-02,   4.8319384E-02
     +,   4.7964755E-02,   4.7359478E-02,   4.6511944E-02
     +,   4.5434486E-02,   4.4142958E-02,   4.2656220E-02
     +,   4.0995736E-02,   3.9185241E-02,   3.7249796E-02
     +,   3.5215396E-02,   3.3108491E-02,   3.0955324E-02
     +,   2.8781237E-02,   2.6610302E-02,   2.4465071E-02
     +,   2.2366073E-02,   2.0331388E-02,   1.8376602E-02
     +,   1.6514819E-02,   1.4756471E-02,   1.3109246E-02
     +,   1.1578315E-02,   1.0166627E-02,   8.8747963E-03
     +,   7.7015013E-03,   6.6438192E-03,   5.6973863E-03
     +,   4.8566298E-03,   4.1151121E-03,   3.4658231E-03
     +,   2.9013499E-03,   2.4140680E-03,   1.9963689E-03
     +,   1.6408388E-03,   1.3403475E-03,   1.0881339E-03
     +,   8.7790622E-04,   7.0390035E-04,   5.6086649E-04
     +,   4.4409995E-04,   3.4943761E-04,   2.7322571E-04
     +,   2.1228789E-04,   1.6389647E-04,   1.2573341E-04
     +,   9.5844131E-05,   7.2594543E-05,   5.4633052E-05
     +,   4.0852428E-05,   3.0352181E-05,   2.2405873E-05
     +,   1.6433274E-05,   1.1975135E-05,   8.6700584E-06
     +,   6.2364802E-06,   4.4569056E-06,   3.1644977E-06
     +,   2.2322595E-06,   1.5643892E-06,   1.0891985E-06
     +,   7.5341359E-07,   5.1774492E-07,   3.5346463E-07
     +,   2.3973274E-07,   1.6153361E-07,   1.0812979E-07
     +,   7.1906349E-08,   4.7504901E-08,   3.1178306E-08
     +,   2.0328358E-08,   1.3167216E-08,   8.4729344E-09
     +,   5.4164779E-09,   3.4398429E-09,   2.1702435E-09
     +,   1.3603083E-09,   8.4708440E-10,   5.2405597E-10
     +,   3.2211941E-10,   1.9672036E-10,   1.1937479E-10
     +,   7.1982392E-11,   4.3137036E-11,   2.5694072E-11
     +,   1.5215119E-11,   8.9594365E-12,   5.2483994E-12
     +,   3.0600110E-12,   1.7770092E-12,   1.0288196E-12
     +,   5.9461024E-13,   3.4367233E-13,   1.9909550E-13
     +,   1.1595252E-13,   6.8133745E-14,   4.0565855E-14
     +,   2.4583361E-14,   1.5230777E-14,   9.6811910E-15
     +,   6.3263997E-15,   4.2505223E-15,   2.9310857E-15
     +,   2.0678143E-15,   1.4865604E-15
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_haonly_ttz110_mass = Yx/0.584239727272727
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_haonly_ttz115_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.6732347E-03,   3.8671533E-03
     +,   4.0725558E-03,   4.2899908E-03,   4.5199762E-03
     +,   4.7629913E-03,   5.0194631E-03,   5.2897600E-03
     +,   5.5741682E-03,   5.8729080E-03,   6.1860774E-03
     +,   6.5136789E-03,   6.8555833E-03,   7.2115306E-03
     +,   7.5811148E-03,   7.9637766E-03,   8.3587952E-03
     +,   8.7652812E-03,   9.1821775E-03,   9.6082557E-03
     +,   1.0042124E-02,   1.0482223E-02,   1.0926840E-02
     +,   1.1374147E-02,   1.1822146E-02,   1.2268788E-02
     +,   1.2711916E-02,   1.3149326E-02,   1.3578794E-02
     +,   1.3998109E-02,   1.4405096E-02,   1.4797670E-02
     +,   1.5173858E-02,   1.5531833E-02,   1.5869964E-02
     +,   1.6186835E-02,   1.6481278E-02,   1.6752403E-02
     +,   1.6999636E-02,   1.7222680E-02,   1.7421605E-02
     +,   1.7596798E-02,   1.7748972E-02,   1.7879179E-02
     +,   1.7988766E-02,   1.8079368E-02,   1.8152887E-02
     +,   1.8211437E-02,   1.8257320E-02,   1.8292982E-02
     +,   1.8320957E-02,   1.8343806E-02,   1.8364098E-02
     +,   1.8384326E-02,   1.8406868E-02,   1.8433940E-02
     +,   1.8467547E-02,   1.8509442E-02,   1.8561086E-02
     +,   1.8623620E-02,   1.8697854E-02,   1.8784229E-02
     +,   1.8882822E-02,   1.8993340E-02,   1.9115139E-02
     +,   1.9247212E-02,   1.9388238E-02,   1.9536586E-02
     +,   1.9690359E-02,   1.9847425E-02,   2.0005470E-02
     +,   2.0162005E-02,   2.0314459E-02,   2.0460177E-02
     +,   2.0596499E-02,   2.0720785E-02,   2.0830464E-02
     +,   2.0923054E-02,   2.0996219E-02,   2.1047803E-02
     +,   2.1075819E-02,   2.1078523E-02,   2.1054396E-02
     +,   2.1002175E-02,   2.0920854E-02,   2.0809686E-02
     +,   2.0668203E-02,   2.0496193E-02,   2.0293716E-02
     +,   2.0061079E-02,   1.9798821E-02,   1.9507732E-02
     +,   1.9188818E-02,   1.8843278E-02,   1.8472480E-02
     +,   1.8078007E-02,   1.7661542E-02,   1.7224954E-02
     +,   1.6770175E-02,   1.6299279E-02,   1.5814379E-02
     +,   1.5317691E-02,   1.4811413E-02,   1.4297839E-02
     +,   1.3779209E-02,   1.3257755E-02,   1.2735720E-02
     +,   1.2215285E-02,   1.1698551E-02,   1.1187531E-02
     +,   1.0684205E-02,   1.0190380E-02,   9.7078076E-03
     +,   9.2380587E-03,   8.7826233E-03,   8.3428025E-03
     +,   7.9197874E-03,   7.5145867E-03,   7.1280929E-03
     +,   6.7610210E-03,   6.4139301E-03,   6.0872664E-03
     +,   5.7813362E-03,   5.4962868E-03,   5.2321604E-03
     +,   4.9889078E-03,   4.7663557E-03,   4.5642732E-03
     +,   4.3823346E-03,   4.2201844E-03,   4.0774010E-03
     +,   3.9535556E-03,   3.8481909E-03,   3.7608608E-03
     +,   3.6911240E-03,   3.6385637E-03,   3.6027951E-03
     +,   3.5834815E-03,   3.5803278E-03,   3.5930951E-03
     +,   3.6216020E-03,   3.6657259E-03,   3.7254042E-03
     +,   3.8006336E-03,   3.8914592E-03,   3.9979802E-03
     +,   4.1203415E-03,   4.2587118E-03,   4.4132853E-03
     +,   4.5842766E-03,   4.7719032E-03,   4.9763606E-03
     +,   5.1978161E-03,   5.4364149E-03,   5.6922445E-03
     +,   5.9653167E-03,   6.2555540E-03,   6.5628020E-03
     +,   6.8868040E-03,   7.2271470E-03,   7.5833211E-03
     +,   7.9546738E-03,   8.3403839E-03,   8.7394714E-03
     +,   9.1508199E-03,   9.5731560E-03,   1.0005015E-02
     +,   1.0444773E-02,   1.0890679E-02,   1.1340835E-02
     +,   1.1793173E-02,   1.2245504E-02,   1.2695556E-02
     +,   1.3140955E-02,   1.3579217E-02,   1.4007839E-02
     +,   1.4424287E-02,   1.4825990E-02,   1.5210387E-02
     +,   1.5574991E-02,   1.5917374E-02,   1.6235173E-02
     +,   1.6526148E-02,   1.6788222E-02,   1.7019471E-02
     +,   1.7218145E-02,   1.7382696E-02,   1.7511828E-02
     +,   1.7604459E-02,   1.7659761E-02,   1.7677171E-02
     +,   1.7656388E-02,   1.7597379E-02,   1.7500391E-02
     +,   1.7365929E-02,   1.7194757E-02,   1.6987894E-02
     +,   1.6746607E-02,   1.6472373E-02,   1.6166875E-02
     +,   1.5831996E-02,   1.5469794E-02,   1.5082448E-02
     +,   1.4672254E-02,   1.4241643E-02,   1.3793086E-02
     +,   1.3329082E-02,   1.2852198E-02,   1.2364992E-02
     +,   1.1869966E-02,   1.1369579E-02,   1.0866250E-02
     +,   1.0362317E-02,   9.8599792E-03,   9.3613192E-03
     +,   8.8683274E-03,   8.3828466E-03,   7.9065403E-03
     +,   7.4409209E-03,   6.9873845E-03,   6.5471195E-03
     +,   6.1211535E-03,   5.7103848E-03,   5.3155511E-03
     +,   4.9372092E-03,   4.5757745E-03,   4.2315461E-03
     +,   3.9046893E-03,   3.5952239E-03,   3.3030615E-03
     +,   3.0280272E-03,   2.7698530E-03,   2.5281701E-03
     +,   2.3025384E-03,   2.0924781E-03,   1.8974352E-03
     +,   1.7168126E-03,   1.5499933E-03,   1.3963310E-03
     +,   1.2551523E-03,   1.1257750E-03,   1.0075222E-03
     +,   8.9971669E-04,   8.0168288E-04,   7.1275793E-04
     +,   6.3230202E-04,   5.5969344E-04,   4.9432908E-04
     +,   4.3563114E-04,   3.8305417E-04,   3.3607535E-04
     +,   2.9420131E-04,   2.5697093E-04,   2.2395200E-04
     +,   1.9473919E-04,   1.6895669E-04,   1.4625835E-04
     +,   1.2632505E-04,   1.0886223E-04,   9.3600880E-05
     +,   8.0296602E-05,   6.8727270E-05,   5.8690952E-05
     +,   5.0005612E-05,   4.2508349E-05,   3.6052290E-05
     +,   3.0506337E-05,   2.5754067E-05,   2.1692027E-05
     +,   1.8228397E-05,   1.5282201E-05,   1.2782401E-05
     +,   1.0666668E-05,   8.8803426E-06,   7.3758283E-06
     +,   6.1118776E-06,   5.0525882E-06,   4.1670833E-06
     +,   3.4286359E-06,   2.8143941E-06,   2.3047069E-06
     +,   1.8828541E-06,   1.5345489E-06,   1.2477022E-06
     +,   1.0120460E-06,   8.1894098E-07,   6.6109379E-07
     +,   5.3238580E-07,   4.2770870E-07,   3.4278270E-07
     +,   2.7405906E-07,   2.1858285E-07,   1.7391577E-07
     +,   1.3804005E-07,   1.0929973E-07,   8.6332342E-08
     +,   6.8025756E-08,   5.3469993E-08,   4.1926636E-08
     +,   3.2794748E-08,   2.5589332E-08
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_haonly_ttz115_mass = Yx/0.680324521739131
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_haonly_ttz120_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.8424274E-03,   1.9636250E-03
     +,   2.0896380E-03,   2.2203876E-03,   2.3557690E-03
     +,   2.4956516E-03,   2.6398788E-03,   2.7882673E-03
     +,   2.9406049E-03,   3.0966606E-03,   3.2561698E-03
     +,   3.4188468E-03,   3.5843824E-03,   3.7524435E-03
     +,   3.9226771E-03,   4.0947115E-03,   4.2681592E-03
     +,   4.4426159E-03,   4.6176668E-03,   4.7928882E-03
     +,   4.9678483E-03,   5.1421137E-03,   5.3152456E-03
     +,   5.4868208E-03,   5.6564007E-03,   5.8235745E-03
     +,   5.9879329E-03,   6.1490829E-03,   6.3066478E-03
     +,   6.4602722E-03,   6.6096215E-03,   6.7543820E-03
     +,   6.8942709E-03,   7.0290291E-03,   7.1584242E-03
     +,   7.2822561E-03,   7.4003502E-03,   7.5125638E-03
     +,   7.6187868E-03,   7.7189286E-03,   7.8129349E-03
     +,   7.9007773E-03,   7.9824477E-03,   8.0579659E-03
     +,   8.1273755E-03,   8.1907362E-03,   8.2481308E-03
     +,   8.2996562E-03,   8.3454233E-03,   8.3855549E-03
     +,   8.4201889E-03,   8.4494669E-03,   8.4735407E-03
     +,   8.4925666E-03,   8.5067060E-03,   8.5161235E-03
     +,   8.5209841E-03,   8.5214563E-03,   8.5177114E-03
     +,   8.5099190E-03,   8.4982533E-03,   8.4828874E-03
     +,   8.4639965E-03,   8.4417593E-03,   8.4163556E-03
     +,   8.3879707E-03,   8.3567956E-03,   8.3230212E-03
     +,   8.2868505E-03,   8.2484866E-03,   8.2081398E-03
     +,   8.1660347E-03,   8.1223929E-03,   8.0774436E-03
     +,   8.0314279E-03,   7.9845870E-03,   7.9371622E-03
     +,   7.8894105E-03,   7.8415731E-03,   7.7938992E-03
     +,   7.7466378E-03,   7.7000228E-03,   7.6542892E-03
     +,   7.6096542E-03,   7.5663286E-03,   7.5244987E-03
     +,   7.4843392E-03,   7.4459990E-03,   7.4096052E-03
     +,   7.3752557E-03,   7.3430198E-03,   7.3129381E-03
     +,   7.2850198E-03,   7.2592339E-03,   7.2355233E-03
     +,   7.2137890E-03,   7.1938988E-03,   7.1756905E-03
     +,   7.1589602E-03,   7.1434770E-03,   7.1289768E-03
     +,   7.1151699E-03,   7.1017374E-03,   7.0883422E-03
     +,   7.0746201E-03,   7.0602023E-03,   7.0446986E-03
     +,   7.0277206E-03,   7.0088715E-03,   6.9877584E-03
     +,   6.9639999E-03,   6.9372193E-03,   6.9070640E-03
     +,   6.8731988E-03,   6.8353200E-03,   6.7931497E-03
     +,   6.7464514E-03,   6.6950223E-03,   6.6387132E-03
     +,   6.5774149E-03,   6.5110684E-03,   6.4396756E-03
     +,   6.3632927E-03,   6.2820339E-03,   6.1960681E-03
     +,   6.1056414E-03,   6.0110460E-03,   5.9126513E-03
     +,   5.8108824E-03,   5.7062320E-03,   5.5992482E-03
     +,   5.4905531E-03,   5.3808126E-03,   5.2707656E-03
     +,   5.1611941E-03,   5.0529316E-03,   4.9468684E-03
     +,   4.8439382E-03,   4.7451062E-03,   4.6513770E-03
     +,   4.5637875E-03,   4.4834008E-03,   4.4112918E-03
     +,   4.3485477E-03,   4.2962688E-03,   4.2555430E-03
     +,   4.2274497E-03,   4.2130537E-03,   4.2133899E-03
     +,   4.2294539E-03,   4.2622020E-03,   4.3125302E-03
     +,   4.3812678E-03,   4.4691726E-03,   4.5769210E-03
     +,   4.7050877E-03,   4.8541385E-03,   5.0244336E-03
     +,   5.2162134E-03,   5.4295645E-03,   5.6644538E-03
     +,   5.9206965E-03,   6.1979401E-03,   6.4956672E-03
     +,   6.8132142E-03,   7.1497490E-03,   7.5042457E-03
     +,   7.8755096E-03,   8.2621938E-03,   8.6627938E-03
     +,   9.0756090E-03,   9.4987871E-03,   9.9303555E-03
     +,   1.0368206E-02,   1.0810070E-02,   1.1253601E-02
     +,   1.1696371E-02,   1.2135846E-02,   1.2569433E-02
     +,   1.2994535E-02,   1.3408545E-02,   1.3808828E-02
     +,   1.4192792E-02,   1.4557927E-02,   1.4901791E-02
     +,   1.5222038E-02,   1.5516440E-02,   1.5782936E-02
     +,   1.6019639E-02,   1.6224818E-02,   1.6396979E-02
     +,   1.6534843E-02,   1.6637351E-02,   1.6703697E-02
     +,   1.6733335E-02,   1.6725961E-02,   1.6681554E-02
     +,   1.6600331E-02,   1.6482783E-02,   1.6329633E-02
     +,   1.6141860E-02,   1.5920674E-02,   1.5667493E-02
     +,   1.5383923E-02,   1.5071783E-02,   1.4733028E-02
     +,   1.4369738E-02,   1.3984146E-02,   1.3578573E-02
     +,   1.3155392E-02,   1.2717011E-02,   1.2265895E-02
     +,   1.1804510E-02,   1.1335263E-02,   1.0860527E-02
     +,   1.0382636E-02,   9.9038482E-03,   9.4262846E-03
     +,   8.9519657E-03,   8.4828241E-03,   8.0206189E-03
     +,   7.5669605E-03,   7.1233436E-03,   6.6911080E-03
     +,   6.2714056E-03,   5.8652377E-03,   5.4734740E-03
     +,   5.0968323E-03,   4.7358572E-03,   4.3909536E-03
     +,   4.0624142E-03,   3.7504029E-03,   3.4549448E-03
     +,   3.1759564E-03,   2.9132823E-03,   2.6666501E-03
     +,   2.4357100E-03,   2.2200588E-03,   2.0192300E-03
     +,   1.8326938E-03,   1.6598818E-03,   1.5002042E-03
     +,   1.3530459E-03,   1.2177650E-03,   1.0937121E-03
     +,   9.8024250E-04,   8.7671349E-04,   7.8248250E-04
     +,   6.9692085E-04,   6.1942392E-04,   5.4939766E-04
     +,   4.8627108E-04,   4.2950132E-04,   3.7857037E-04
     +,   3.3298356E-04,   2.9227434E-04,   2.5600664E-04
     +,   2.2377197E-04,   1.9518711E-04,   1.6989649E-04
     +,   1.4757270E-04,   1.2791355E-04,   1.1064006E-04
     +,   9.5496966E-05,   8.2252722E-05,   7.0695271E-05
     +,   6.0632505E-05,   5.1891373E-05,   4.4315886E-05
     +,   3.7765312E-05,   3.2113796E-05,   2.7249234E-05
     +,   2.3071754E-05,   1.9492385E-05,   1.6432457E-05
     +,   1.3822749E-05,   1.1602000E-05,   9.7167185E-06
     +,   8.1198204E-06,   6.7704045E-06,   5.6326990E-06
     +,   4.6757741E-06,   3.8727294E-06,   3.2004398E-06
     +,   2.6388939E-06,   2.1709809E-06,   1.7819956E-06
     +,   1.4593755E-06,   1.1924482E-06,   9.7211046E-07
     +,   7.9067468E-07,   6.4161873E-07,   5.1946489E-07
     +,   4.1959086E-07,   3.3813495E-07,   2.7185598E-07
     +,   2.1805992E-07,   1.7449855E-07,   1.3931273E-07
     +,   1.1095920E-07,   8.8168420E-08
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_haonly_ttz120_mass = Yx/0.441187894736842
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_haonly_ttz60_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.0390240E-03,   1.1525440E-03
     +,   1.2745361E-03,   1.4050965E-03,   1.5442458E-03
     +,   1.6919204E-03,   1.8479644E-03,   2.0121231E-03
     +,   2.1840339E-03,   2.3632320E-03,   2.5491312E-03
     +,   2.7410334E-03,   2.9381262E-03,   3.1394840E-03
     +,   3.3440734E-03,   3.5507611E-03,   3.7583234E-03
     +,   3.9654574E-03,   4.1708001E-03,   4.3729418E-03
     +,   4.5704558E-03,   4.7619166E-03,   4.9459301E-03
     +,   5.1211817E-03,   5.2864393E-03,   5.4406342E-03
     +,   5.5828737E-03,   5.7125008E-03,   5.8291415E-03
     +,   5.9327497E-03,   6.0236566E-03,   6.1026127E-03
     +,   6.1708265E-03,   6.2299860E-03,   6.2822751E-03
     +,   6.3303621E-03,   6.3773836E-03,   6.4268843E-03
     +,   6.4827595E-03,   6.5491544E-03,   6.6303741E-03
     +,   6.7307670E-03,   6.8546408E-03,   7.0061889E-03
     +,   7.1894764E-03,   7.4084778E-03,   7.6672067E-03
     +,   7.9699205E-03,   8.3214222E-03,   8.7274136E-03
     +,   9.1949021E-03,   9.7325714E-03,   1.0351088E-02
     +,   1.1063306E-02,   1.1884111E-02,   1.2830281E-02
     +,   1.3919799E-02,   1.5171066E-02,   1.6601883E-02
     +,   1.8228304E-02,   2.0063544E-02,   2.2117008E-02
     +,   2.4393430E-02,   2.6892833E-02,   2.9610330E-02
     +,   3.2536186E-02,   3.5656974E-02,   3.8955469E-02
     +,   4.2411957E-02,   4.6003848E-02,   4.9706504E-02
     +,   5.3492103E-02,   5.7329953E-02,   6.1184812E-02
     +,   6.5016933E-02,   6.8781309E-02,   7.2427392E-02
     +,   7.5900055E-02,   7.9141498E-02,   8.2093447E-02
     +,   8.4700152E-02,   8.6912654E-02,   8.8692114E-02
     +,   9.0013400E-02,   9.0866998E-02,   9.1260031E-02
     +,   9.1215149E-02,   9.0767920E-02,   8.9962788E-02
     +,   8.8848203E-02,   8.7471746E-02,   8.5875869E-02
     +,   8.4095150E-02,   8.2154892E-02,   8.0071799E-02
     +,   7.7856623E-02,   7.5516574E-02,   7.3059738E-02
     +,   7.0497312E-02,   6.7846447E-02,   6.5129988E-02
     +,   6.2376361E-02,   5.9616614E-02,   5.6882080E-02
     +,   5.4200616E-02,   5.1594082E-02,   4.9076777E-02
     +,   4.6654671E-02,   4.4326089E-02,   4.2083748E-02
     +,   3.9917532E-02,   3.7816826E-02,   3.5773624E-02
     +,   3.3783928E-02,   3.1849336E-02,   2.9976606E-02
     +,   2.8177442E-02,   2.6466565E-02,   2.4860343E-02
     +,   2.3374511E-02,   2.2022512E-02,   2.0814231E-02
     +,   1.9754833E-02,   1.8844316E-02,   1.8077591E-02
     +,   1.7445039E-02,   1.6933119E-02,   1.6525542E-02
     +,   1.6204206E-02,   1.5950404E-02,   1.5745759E-02
     +,   1.5573113E-02,   1.5417189E-02,   1.5265080E-02
     +,   1.5106513E-02,   1.4933960E-02,   1.4742581E-02
     +,   1.4530027E-02,   1.4296133E-02,   1.4042574E-02
     +,   1.3772482E-02,   1.3490044E-02,   1.3200069E-02
     +,   1.2907660E-02,   1.2617912E-02,   1.2335598E-02
     +,   1.2064981E-02,   1.1809682E-02,   1.1572541E-02
     +,   1.1355578E-02,   1.1159990E-02,   1.0986200E-02
     +,   1.0833896E-02,   1.0702115E-02,   1.0589351E-02
     +,   1.0493660E-02,   1.0412768E-02,   1.0344161E-02
     +,   1.0285204E-02,   1.0233219E-02,   1.0185557E-02
     +,   1.0139670E-02,   1.0093161E-02,   1.0043825E-02
     +,   9.9896649E-03,   9.9289222E-03,   9.8600872E-03
     +,   9.7818961E-03,   9.6933199E-03,   9.5935734E-03
     +,   9.4820913E-03,   9.3585243E-03,   9.2227189E-03
     +,   9.0746917E-03,   8.9146495E-03,   8.7429332E-03
     +,   8.5600186E-03,   8.3665140E-03,   8.1631411E-03
     +,   7.9506990E-03,   7.7300672E-03,   7.5022019E-03
     +,   7.2681149E-03,   7.0288428E-03,   6.7854440E-03
     +,   6.5390025E-03,   6.2906058E-03,   6.0413089E-03
     +,   5.7921419E-03,   5.5441214E-03,   5.2981940E-03
     +,   5.0552483E-03,   4.8161279E-03,   4.5816014E-03
     +,   4.3523498E-03,   4.1289725E-03,   3.9120028E-03
     +,   3.7018901E-03,   3.4989873E-03,   3.3035676E-03
     +,   3.1158405E-03,   2.9359395E-03,   2.7639186E-03
     +,   2.5997681E-03,   2.4434384E-03,   2.2948128E-03
     +,   2.1537310E-03,   2.0200054E-03,   1.8934165E-03
     +,   1.7737120E-03,   1.6606224E-03,   1.5538721E-03
     +,   1.4531791E-03,   1.3582490E-03,   1.2687908E-03
     +,   1.1845230E-03,   1.1051710E-03,   1.0304637E-03
     +,   9.6014194E-04,   8.9396531E-04,   8.3169981E-04
     +,   7.7312469E-04,   7.1803713E-04,   6.6624675E-04
     +,   6.1757234E-04,   5.7184510E-04,   5.2891072E-04
     +,   4.8862456E-04,   4.5084915E-04,   4.1545543E-04
     +,   3.8232477E-04,   3.5134493E-04,   3.2240752E-04
     +,   2.9540985E-04,   2.7025622E-04,   2.4685269E-04
     +,   2.2510892E-04,   2.0493925E-04,   1.8626095E-04
     +,   1.6899241E-04,   1.5305476E-04,   1.3837272E-04
     +,   1.2487301E-04,   1.1248371E-04,   1.0113545E-04
     +,   9.0761736E-05,   8.1298400E-05,   7.2682982E-05
     +,   6.4855572E-05,   5.7759491E-05,   5.1339834E-05
     +,   4.5544315E-05,   4.0323721E-05,   3.5631310E-05
     +,   3.1422653E-05,   2.7655986E-05,   2.4292383E-05
     +,   2.1295376E-05,   1.8630781E-05,   1.6266860E-05
     +,   1.4174360E-05,   1.2326263E-05,   1.0697541E-05
     +,   9.2652763E-06,   8.0086238E-06,   6.9084340E-06
     +,   5.9473118E-06,   5.1095485E-06,   4.3809355E-06
     +,   3.7486209E-06,   3.2010551E-06,   2.7279375E-06
     +,   2.3200457E-06,   1.9691456E-06,   1.6679201E-06
     +,   1.4099159E-06,   1.1893977E-06,   1.0013403E-06
     +,   8.4130119E-07,   7.0541074E-07,   5.9026576E-07
     +,   4.9291674E-07,   4.1078488E-07,   3.4164535E-07
     +,   2.8356462E-07,   2.3488123E-07,   1.9416122E-07
     +,   1.6017371E-07,   1.3186830E-07,   1.0834382E-07
     +,   8.8835847E-08,   7.2692053E-08,   5.9361579E-08
     +,   4.8377004E-08,   3.9345331E-08,   3.1934576E-08
     +,   2.5867246E-08,   2.0909953E-08,   1.6868501E-08
     +,   1.3580459E-08,   1.0911216E-08
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_haonly_ttz60_mass = Yx/1.117676
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_haonly_ttz65_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.6517329E-06,   4.8409793E-06
     +,   6.3828747E-06,   8.3708183E-06,   1.0919640E-05
     +,   1.4169650E-05,   1.8291217E-05,   2.3489963E-05
     +,   3.0012430E-05,   3.8152888E-05,   4.8259688E-05
     +,   6.0743339E-05,   7.6084529E-05,   9.4842726E-05
     +,   1.1766516E-04,   1.4529616E-04,   1.7858636E-04
     +,   2.1850188E-04,   2.6613314E-04,   3.2270225E-04
     +,   3.8957078E-04,   4.6824326E-04,   5.6037016E-04
     +,   6.6775474E-04,   7.9233217E-04,   9.3618716E-04
     +,   1.1015213E-03,   1.2906456E-03,   1.5059570E-03
     +,   1.7499075E-03,   2.0249703E-03,   2.3335954E-03
     +,   2.6781615E-03,   3.0609188E-03,   3.4839259E-03
     +,   3.9489814E-03,   4.4575473E-03,   5.0106626E-03
     +,   5.6089084E-03,   6.2522204E-03,   6.9399439E-03
     +,   7.6706447E-03,   8.4420936E-03,   9.2511913E-03
     +,   1.0093925E-02,   1.0965345E-02,   1.1859567E-02
     +,   1.2769785E-02,   1.3688348E-02,   1.4606843E-02
     +,   1.5516223E-02,   1.6406987E-02,   1.7269336E-02
     +,   1.8093491E-02,   1.8869774E-02,   1.9589081E-02
     +,   2.0242978E-02,   2.0824084E-02,   2.1326333E-02
     +,   2.1745270E-02,   2.2078389E-02,   2.2325456E-02
     +,   2.2488883E-02,   2.2574138E-02,   2.2590160E-02
     +,   2.2549761E-02,   2.2469977E-02,   2.2372371E-02
     +,   2.2283055E-02,   2.2232605E-02,   2.2255581E-02
     +,   2.2389833E-02,   2.2675464E-02,   2.3153579E-02
     +,   2.3864994E-02,   2.4848837E-02,   2.6141116E-02
     +,   2.7773321E-02,   2.9770900E-02,   3.2151066E-02
     +,   3.4919702E-02,   3.8068153E-02,   4.1568395E-02
     +,   4.5370091E-02,   4.9397983E-02,   5.3555153E-02
     +,   5.7729974E-02,   6.1811503E-02,   6.5708771E-02
     +,   6.9373734E-02,   7.2820269E-02,   7.6133870E-02
     +,   7.9466529E-02,   8.3013691E-02,   8.6974241E-02
     +,   9.1500498E-02,   9.6650422E-02,   0.1023508    
     +,   0.1083880    ,   0.1144252    ,   0.1200531    
     +,   0.1248578    ,   0.1284970    ,   0.1307625    
     +,   0.1316166    ,   0.1311915    ,   0.1297536    
     +,   0.1276431    ,   0.1252036    ,   0.1227227    
     +,   0.1203943    ,   0.1183086    ,   0.1164682    
     +,   0.1148171    ,   0.1132759    ,   0.1117694    
     +,   0.1102451    ,   0.1086776    ,   0.1070655    
     +,   0.1054194    ,   0.1037481    ,   0.1020452    
     +,   0.1002788    ,   9.8388001E-02,   9.6287332E-02
     +,   9.3879186E-02,   9.1070347E-02,   8.7791339E-02
     +,   8.4010579E-02,   7.9743601E-02,   7.5051725E-02
     +,   7.0034951E-02,   6.4817078E-02,   5.9531249E-02
     +,   5.4304011E-02,   4.9244393E-02,   4.4437457E-02
     +,   3.9941467E-02,   3.5788987E-02,   3.1991035E-02
     +,   2.8542442E-02,   2.5426736E-02,   2.2620779E-02
     +,   2.0098709E-02,   1.7834840E-02,   1.5804749E-02
     +,   1.3986384E-02,   1.2360395E-02,   1.0909826E-02
     +,   9.6197184E-03,   8.4768431E-03,   7.4693677E-03
     +,   6.5864567E-03,   5.8179442E-03,   5.1542390E-03
     +,   4.5862235E-03,   4.1051237E-03,   3.7024668E-03
     +,   3.3701246E-03,   3.1003649E-03,   2.8858201E-03
     +,   2.7195686E-03,   2.5951713E-03,   2.5066785E-03
     +,   2.4486426E-03,   2.4161285E-03,   2.4047045E-03
     +,   2.4104165E-03,   2.4297689E-03,   2.4596923E-03
     +,   2.4975115E-03,   2.5409064E-03,   2.5878858E-03
     +,   2.6367456E-03,   2.6860328E-03,   2.7345242E-03
     +,   2.7811909E-03,   2.8251705E-03,   2.8657455E-03
     +,   2.9023264E-03,   2.9344312E-03,   2.9616682E-03
     +,   2.9837261E-03,   3.0003660E-03,   3.0114099E-03
     +,   3.0167354E-03,   3.0162702E-03,   3.0099892E-03
     +,   2.9979083E-03,   2.9800865E-03,   2.9566174E-03
     +,   2.9276293E-03,   2.8932858E-03,   2.8537815E-03
     +,   2.8093359E-03,   2.7601959E-03,   2.7066327E-03
     +,   2.6489401E-03,   2.5874255E-03,   2.5224122E-03
     +,   2.4542389E-03,   2.3832547E-03,   2.3098108E-03
     +,   2.2342608E-03,   2.1569682E-03,   2.0782854E-03
     +,   1.9985619E-03,   1.9181431E-03,   1.8373672E-03
     +,   1.7565538E-03,   1.6760101E-03,   1.5960325E-03
     +,   1.5169010E-03,   1.4388717E-03,   1.3621822E-03
     +,   1.2870545E-03,   1.2136899E-03,   1.1422641E-03
     +,   1.0729312E-03,   1.0058315E-03,   9.4107754E-04
     +,   8.7876117E-04,   8.1895915E-04,   7.6172815E-04
     +,   7.0710323E-04,   6.5510225E-04,   6.0573046E-04
     +,   5.5897777E-04,   5.1481696E-04,   4.7320858E-04
     +,   4.3410485E-04,   3.9744726E-04,   3.6316641E-04
     +,   3.3118550E-04,   3.0142447E-04,   2.7379490E-04
     +,   2.4820471E-04,   2.2456056E-04,   2.0276661E-04
     +,   1.8272465E-04,   1.6433626E-04,   1.4750491E-04
     +,   1.3213474E-04,   1.1813080E-04,   1.0540052E-04
     +,   9.3854898E-05,   8.3407787E-05,   7.3975825E-05
     +,   6.5479355E-05,   5.7843288E-05,   5.0995692E-05
     +,   4.4868724E-05,   3.9398947E-05,   3.4526918E-05
     +,   3.0196794E-05,   2.6356702E-05,   2.2958857E-05
     +,   1.9959036E-05,   1.7316363E-05,   1.4993360E-05
     +,   1.2955908E-05,   1.1172887E-05,   9.6158701E-06
     +,   8.2591396E-06,   7.0795900E-06,   6.0562757E-06
     +,   5.1704064E-06,   4.4052167E-06,   3.7457148E-06
     +,   3.1785171E-06,   2.6917476E-06,   2.2749155E-06
     +,   1.9187555E-06,   1.6150823E-06,   1.3567108E-06
     +,   1.1373712E-06,   9.5155502E-07,   7.9448677E-07
     +,   6.6199613E-07,   5.5048383E-07,   4.5682395E-07
     +,   3.7833206E-07,   3.1268794E-07,   2.5791024E-07
     +,   2.1229462E-07,   1.7439251E-07,   1.4296563E-07
     +,   1.1696279E-07,   9.5495068E-08,   7.7808238E-08
     +,   6.3268388E-08,   5.1340276E-08,   4.1576271E-08
     +,   3.3600276E-08,   2.7099121E-08,   2.1811072E-08
     +,   1.7519158E-08,   1.4042931E-08,   1.1233538E-08
     +,   8.9677306E-09,   7.1443411E-09
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_haonly_ttz65_mass = Yx/1.516846
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_haonly_ttz70_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.2111147E-05,   1.4811955E-05
     +,   1.8050067E-05,   2.1917247E-05,   2.6517655E-05
     +,   3.1968895E-05,   3.8402959E-05,   4.5967183E-05
     +,   5.4824828E-05,   6.5156310E-05,   7.7158860E-05
     +,   9.1047179E-05,   1.0705323E-04,   1.2542581E-04
     +,   1.4642975E-04,   1.7034455E-04,   1.9746259E-04
     +,   2.2808694E-04,   2.6252825E-04,   3.0110165E-04
     +,   3.4412218E-04,   3.9190057E-04,   4.4473671E-04
     +,   5.0291873E-04,   5.6670624E-04,   6.3633698E-04
     +,   7.1200915E-04,   7.9387909E-04,   8.8205305E-04
     +,   9.7658031E-04,   1.0774453E-03,   1.1845629E-03
     +,   1.2977716E-03,   1.4168288E-03,   1.5414084E-03
     +,   1.6710971E-03,   1.8053957E-03,   1.9437174E-03
     +,   2.0854012E-03,   2.2296952E-03,   2.3757939E-03
     +,   2.5228248E-03,   2.6698706E-03,   2.8159840E-03
     +,   2.9602030E-03,   3.1015696E-03,   3.2391504E-03
     +,   3.3720590E-03,   3.4994755E-03,   3.6206704E-03
     +,   3.7350229E-03,   3.8420435E-03,   3.9413837E-03
     +,   4.0328614E-03,   4.1164504E-03,   4.1923029E-03
     +,   4.2607365E-03,   4.3222294E-03,   4.3774112E-03
     +,   4.4270456E-03,   4.4720173E-03,   4.5133168E-03
     +,   4.5520342E-03,   4.5893691E-03,   4.6266555E-03
     +,   4.6654125E-03,   4.7074393E-03,   4.7549335E-03
     +,   4.8106685E-03,   4.8781950E-03,   4.9620909E-03
     +,   5.0682006E-03,   5.2039041E-03,   5.3782775E-03
     +,   5.6022294E-03,   5.8884467E-03,   6.2511330E-03
     +,   6.7055281E-03,   7.2671729E-03,   7.9508452E-03
     +,   8.7692095E-03,   9.7316001E-03,   1.0842543E-02
     +,   1.2101150E-02,   1.3500795E-02,   1.5030576E-02
     +,   1.6677633E-02,   1.8431777E-02,   2.0290684E-02
     +,   2.2266444E-02,   2.4391007E-02,   2.6719436E-02
     +,   2.9329518E-02,   3.2316290E-02,   3.5780262E-02
     +,   3.9810158E-02,   4.4463165E-02,   4.9743131E-02
     +,   5.5584546E-02,   6.1842270E-02,   6.8296745E-02
     +,   7.4673079E-02,   8.0683164E-02,   8.6084448E-02
     +,   9.0756916E-02,   9.4778918E-02,   9.8481841E-02
     +,   0.1024515    ,   0.1074465    ,   0.1142254    
     +,   0.1233171    ,   0.1348160    ,   0.1482976    
     +,   0.1629212    ,   0.1776790    ,   0.1916773    
     +,   0.2042807    ,   0.2150477    ,   0.2234994    
     +,   0.2289021    ,   0.2302324    ,   0.2264103    
     +,   0.2167150    ,   0.2011902    ,   0.1808409    
     +,   0.1575276    ,   0.1335840    ,   0.1113143    
     +,   9.2519842E-02,   7.8207210E-02,   6.8518035E-02
     +,   6.2877491E-02,   6.0268410E-02,   5.9538130E-02
     +,   5.9645139E-02,   5.9804313E-02,   5.9528805E-02
     +,   5.8598775E-02,   5.6993768E-02,   5.4818165E-02
     +,   5.2236646E-02,   4.9425144E-02,   4.6537697E-02
     +,   4.3688174E-02,   4.0944163E-02,   3.8329761E-02
     +,   3.5835639E-02,   3.3432458E-02,   3.1084338E-02
     +,   2.8760271E-02,   2.6442150E-02,   2.4128666E-02
     +,   2.1834837E-02,   1.9588571E-02,   1.7425623E-02
     +,   1.5383948E-02,   1.3498213E-02,   1.1795602E-02
     +,   1.0293460E-02,   8.9985942E-03,   7.9075443E-03
     +,   7.0083793E-03,   6.2829135E-03,   5.7089860E-03
     +,   5.2626613E-03,   4.9201255E-03,   4.6590935E-03
     +,   4.4596675E-03,   4.3048225E-03,   4.1805496E-03
     +,   4.0757423E-03,   3.9819046E-03,   3.8927861E-03
     +,   3.8039994E-03,   3.7126539E-03,   3.6170017E-03
     +,   3.5161607E-03,   3.4098816E-03,   3.2983590E-03
     +,   3.1820775E-03,   3.0617099E-03,   2.9380452E-03
     +,   2.8119215E-03,   2.6841776E-03,   2.5556323E-03
     +,   2.4270713E-03,   2.2992268E-03,   2.1727618E-03
     +,   2.0482731E-03,   1.9263013E-03,   1.8073079E-03
     +,   1.6916886E-03,   1.5797829E-03,   1.4718707E-03
     +,   1.3681678E-03,   1.2688395E-03,   1.1740099E-03
     +,   1.0837596E-03,   9.9812413E-04,   9.1710512E-04
     +,   8.4067840E-04,   7.6879235E-04,   7.0136652E-04
     +,   6.3830049E-04,   5.7948189E-04,   5.2477716E-04
     +,   4.7404080E-04,   4.2711996E-04,   3.8385310E-04
     +,   3.4406927E-04,   3.0759335E-04,   2.7424970E-04
     +,   2.4386068E-04,   2.1624658E-04,   1.9122915E-04
     +,   1.6863437E-04,   1.4829113E-04,   1.3003156E-04
     +,   1.1369321E-04,   9.9121171E-05,   8.6165433E-05
     +,   7.4683361E-05,   6.4540560E-05,   5.5610180E-05
     +,   4.7772653E-05,   4.0916617E-05,   3.4939054E-05
     +,   2.9744768E-05,   2.5245927E-05,   2.1362192E-05
     +,   1.8020728E-05,   1.5155493E-05,   1.2706707E-05
     +,   1.0620756E-05,   8.8499264E-06,   7.3515853E-06
     +,   6.0879966E-06,   5.0259741E-06,   4.1363742E-06
     +,   3.3936647E-06,   2.7756398E-06,   2.2631007E-06
     +,   1.8394716E-06,   1.4904832E-06,   1.2039320E-06
     +,   9.6943700E-07,   7.7818527E-07,   6.2271351E-07
     +,   4.9674270E-07,   3.9502024E-07,   3.1314599E-07
     +,   2.4746379E-07,   1.9494692E-07,   1.5309611E-07
     +,   1.1985367E-07,   9.3535064E-08,   7.2767293E-08
     +,   5.6433937E-08,   4.3629885E-08,   3.3625010E-08
     +,   2.5833248E-08,   1.9785105E-08,   1.5105538E-08
     +,   1.1496573E-08,   8.7225436E-09,   6.5971486E-09
     +,   4.9739750E-09,   3.7384305E-09,   2.8010252E-09
     +,   2.0921047E-09,   1.5577004E-09,   1.1561717E-09
     +,   8.5546753E-10,   6.3099070E-10,   4.6395512E-10
     +,   3.4007247E-10,   2.4848545E-10,   1.8099799E-10
     +,   1.3142525E-10,   9.5132111E-11,   6.8645090E-11
     +,   4.9378075E-11,   3.5407243E-11,   2.5310106E-11
     +,   1.8035504E-11,   1.2811694E-11,   9.0724026E-12
     +,   6.4042933E-12,   4.5067478E-12,   3.1614722E-12
     +,   2.2108385E-12,   1.5412015E-12,   1.0710344E-12
     +,   7.4196172E-13,   5.1239248E-13,   3.5274201E-13
     +,   2.4207768E-13,   1.6560965E-13,   1.1294306E-13
     +,   7.6783157E-14,   5.2037584E-14
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_haonly_ttz70_mass = Yx/1.4968875
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_haonly_ttz75_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.1964446E-03,   1.2151070E-03
     +,   1.2352240E-03,   1.2570779E-03,   1.2809762E-03
     +,   1.3072519E-03,   1.3362624E-03,   1.3683911E-03
     +,   1.4040445E-03,   1.4436543E-03,   1.4876724E-03
     +,   1.5365710E-03,   1.5908390E-03,   1.6509790E-03
     +,   1.7175039E-03,   1.7909313E-03,   1.8717784E-03
     +,   1.9605558E-03,   2.0577617E-03,   2.1638721E-03
     +,   2.2793349E-03,   2.4045603E-03,   2.5399087E-03
     +,   2.6856929E-03,   2.8421439E-03,   3.0094332E-03
     +,   3.1876368E-03,   3.3767412E-03,   3.5766277E-03
     +,   3.7870696E-03,   4.0077264E-03,   4.2381366E-03
     +,   4.4777188E-03,   4.7257678E-03,   4.9814605E-03
     +,   5.2438579E-03,   5.5119148E-03,   5.7844813E-03
     +,   6.0603418E-03,   6.3381763E-03,   6.6166469E-03
     +,   6.8943650E-03,   7.1699293E-03,   7.4419556E-03
     +,   7.7090939E-03,   7.9700509E-03,   8.2236221E-03
     +,   8.4687024E-03,   8.7043252E-03,   8.9296652E-03
     +,   9.1440650E-03,   9.3470495E-03,   9.5383245E-03
     +,   9.7178053E-03,   9.8855831E-03,   1.0041954E-02
     +,   1.0187390E-02,   1.0322528E-02,   1.0448150E-02
     +,   1.0565164E-02,   1.0674563E-02,   1.0777406E-02
     +,   1.0874767E-02,   1.0967714E-02,   1.1057253E-02
     +,   1.1144298E-02,   1.1229635E-02,   1.1313867E-02
     +,   1.1397408E-02,   1.1480430E-02,   1.1562852E-02
     +,   1.1644319E-02,   1.1724194E-02,   1.1801546E-02
     +,   1.1875183E-02,   1.1943634E-02,   1.2005189E-02
     +,   1.2057940E-02,   1.2099800E-02,   1.2128570E-02
     +,   1.2141986E-02,   1.2137771E-02,   1.2113715E-02
     +,   1.2067723E-02,   1.1997906E-02,   1.1902630E-02
     +,   1.1780623E-02,   1.1631022E-02,   1.1453501E-02
     +,   1.1248315E-02,   1.1016437E-02,   1.0759679E-02
     +,   1.0480788E-02,   1.0183569E-02,   9.8730149E-03
     +,   9.5554441E-03,   9.2385411E-03,   8.9315353E-03
     +,   8.6452235E-03,   8.3922194E-03,   8.1871878E-03
     +,   8.0473972E-03,   7.9935165E-03,   8.0508413E-03
     +,   8.2508707E-03,   8.6332215E-03,   9.2475479E-03
     +,   1.0155114E-02,   1.1429684E-02,   1.3156999E-02
     +,   1.5432400E-02,   1.8357320E-02,   2.2033224E-02
     +,   2.6555888E-02,   3.2007620E-02,   3.8451914E-02
     +,   4.5925930E-02,   5.4436769E-02,   6.3954473E-02
     +,   7.4409872E-02,   8.5691795E-02,   9.7647958E-02
     +,   0.1100922    ,   0.1228171    ,   0.1356066    
     +,   0.1482437    ,   0.1605137    ,   0.1721883    
     +,   0.1830086    ,   0.1926623    ,   0.2007828    
     +,   0.2069671    ,   0.2108247    ,   0.2120391    
     +,   0.2104300    ,   0.2059925    ,   0.1989056    
     +,   0.1895055    ,   0.1782358    ,   0.1655905    
     +,   0.1520653    ,   0.1381234    ,   0.1241780    
     +,   0.1105885    ,   9.7662508E-02,   8.5651956E-02
     +,   7.4750260E-02,   6.5086044E-02,   5.6716464E-02
     +,   4.9626485E-02,   4.3736517E-02,   3.8917184E-02
     +,   3.5007875E-02,   3.1837251E-02,   2.9241478E-02
     +,   2.7077666E-02,   2.5230473E-02,   2.3613580E-02
     +,   2.2166941E-02,   2.0851629E-02,   1.9643469E-02
     +,   1.8527618E-02,   1.7494271E-02,   1.6535616E-02
     +,   1.5644198E-02,   1.4812411E-02,   1.4032603E-02
     +,   1.3297409E-02,   1.2600138E-02,   1.1935153E-02
     +,   1.1298106E-02,   1.0685867E-02,   1.0096375E-02
     +,   9.5284609E-03,   8.9816535E-03,   8.4558437E-03
     +,   7.9511404E-03,   7.4677593E-03,   7.0058797E-03
     +,   6.5655638E-03,   6.1467746E-03,   5.7493956E-03
     +,   5.3732172E-03,   5.0179320E-03,   4.6831770E-03
     +,   4.3685692E-03,   4.0736827E-03,   3.7980338E-03
     +,   3.5410991E-03,   3.3023297E-03,   3.0810963E-03
     +,   2.8767118E-03,   2.6884363E-03,   2.5154671E-03
     +,   2.3569316E-03,   2.2119067E-03,   2.0794414E-03
     +,   1.9585576E-03,   1.8482573E-03,   1.7475476E-03
     +,   1.6554638E-03,   1.5710712E-03,   1.4934756E-03
     +,   1.4218400E-03,   1.3553972E-03,   1.2934416E-03
     +,   1.2353419E-03,   1.1805422E-03,   1.1285600E-03
     +,   1.0789790E-03,   1.0314487E-03,   9.8568341E-04
     +,   9.4145286E-04,   8.9857361E-04,   8.5690629E-04
     +,   8.1635127E-04,   7.7684096E-04,   7.3833117E-04
     +,   7.0079905E-04,   6.6424179E-04,   6.2866480E-04
     +,   5.9408310E-04,   5.6051899E-04,   5.2799808E-04
     +,   4.9654458E-04,   4.6618172E-04,   4.3693287E-04
     +,   4.0881784E-04,   3.8185043E-04,   3.5604008E-04
     +,   3.3139327E-04,   3.0791108E-04,   2.8558818E-04
     +,   2.6441453E-04,   2.4437727E-04,   2.2545752E-04
     +,   2.0763221E-04,   1.9087593E-04,   1.7515988E-04
     +,   1.6045143E-04,   1.4671558E-04,   1.3391640E-04
     +,   1.2201611E-04,   1.1097498E-04,   1.0075248E-04
     +,   9.1308400E-05,   8.2602113E-05,   7.4592608E-05
     +,   6.7239271E-05,   6.0502840E-05,   5.4344109E-05
     +,   4.8724982E-05,   4.3608867E-05,   3.8960414E-05
     +,   3.4745317E-05,   3.0930809E-05,   2.7485916E-05
     +,   2.4381185E-05,   2.1588545E-05,   1.9081581E-05
     +,   1.6835615E-05,   1.4827553E-05,   1.3035685E-05
     +,   1.1439851E-05,   1.0021503E-05,   8.7633325E-06
     +,   7.6494025E-06,   6.6651519E-06,   5.7971997E-06
     +,   5.0332728E-06,   4.3621912E-06,   3.7738337E-06
     +,   3.2590190E-06,   2.8094084E-06,   2.4174919E-06
     +,   2.0765431E-06,   1.7804875E-06,   1.5239219E-06
     +,   1.3019924E-06,   1.1104022E-06,   9.4530918E-07
     +,   8.0332956E-07,   6.8145198E-07,   5.7703591E-07
     +,   4.8774456E-07,   4.1153621E-07,   3.4661534E-07
     +,   2.9141322E-07,   2.4456608E-07,   2.0488275E-07
     +,   1.7133310E-07,   1.4302043E-07,   1.1917403E-07
     +,   9.9125671E-08,   8.2303394E-08,   6.8213510E-08
     +,   5.6435145E-08,   4.6606910E-08,   3.8421799E-08
     +,   3.1617390E-08,   2.5971744E-08
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_haonly_ttz75_mass = Yx/1.4569705
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_haonly_ttz80_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.3474799E-03,   1.3463473E-03
     +,   1.3441989E-03,   1.3410915E-03,   1.3370868E-03
     +,   1.3322516E-03,   1.3266566E-03,   1.3203761E-03
     +,   1.3134887E-03,   1.3060753E-03,   1.2982190E-03
     +,   1.2900055E-03,   1.2815213E-03,   1.2728533E-03
     +,   1.2640891E-03,   1.2553160E-03,   1.2466194E-03
     +,   1.2380843E-03,   1.2297919E-03,   1.2218219E-03
     +,   1.2142501E-03,   1.2071489E-03,   1.2005860E-03
     +,   1.1946235E-03,   1.1893196E-03,   1.1847258E-03
     +,   1.1808878E-03,   1.1778452E-03,   1.1756303E-03
     +,   1.1742689E-03,   1.1737797E-03,   1.1741748E-03
     +,   1.1754577E-03,   1.1776263E-03,   1.1806705E-03
     +,   1.1845734E-03,   1.1893122E-03,   1.1948571E-03
     +,   1.2011727E-03,   1.2082182E-03,   1.2159484E-03
     +,   1.2243140E-03,   1.2332622E-03,   1.2427382E-03
     +,   1.2526860E-03,   1.2630494E-03,   1.2737735E-03
     +,   1.2848054E-03,   1.2960966E-03,   1.3076039E-03
     +,   1.3192913E-03,   1.3311307E-03,   1.3431055E-03
     +,   1.3552104E-03,   1.3674543E-03,   1.3798621E-03
     +,   1.3924752E-03,   1.4053537E-03,   1.4185779E-03
     +,   1.4322493E-03,   1.4464912E-03,   1.4614498E-03
     +,   1.4772933E-03,   1.4942142E-03,   1.5124279E-03
     +,   1.5321702E-03,   1.5537018E-03,   1.5773008E-03
     +,   1.6032693E-03,   1.6319264E-03,   1.6636141E-03
     +,   1.6986928E-03,   1.7375484E-03,   1.7805881E-03
     +,   1.8282515E-03,   1.8810144E-03,   1.9393893E-03
     +,   2.0039387E-03,   2.0752866E-03,   2.1541265E-03
     +,   2.2412210E-03,   2.3374294E-03,   2.4436894E-03
     +,   2.5610463E-03,   2.6906217E-03,   2.8336367E-03
     +,   2.9913604E-03,   3.1651251E-03,   3.3562514E-03
     +,   3.5660483E-03,   3.7957479E-03,   4.0464364E-03
     +,   4.3190084E-03,   4.6141301E-03,   4.9321642E-03
     +,   5.2730921E-03,   5.6365374E-03,   6.0216496E-03
     +,   6.4271768E-03,   6.8513583E-03,   7.2920420E-03
     +,   7.7465959E-03,   8.2120616E-03,   8.6851045E-03
     +,   9.1622025E-03,   9.6397037E-03,   1.0113939E-02
     +,   1.0581423E-02,   1.1039112E-02,   1.1484616E-02
     +,   1.1916494E-02,   1.2334759E-02,   1.2741299E-02
     +,   1.3140636E-02,   1.3540676E-02,   1.3953831E-02
     +,   1.4398074E-02,   1.4898232E-02,   1.5486897E-02
     +,   1.6205134E-02,   1.7102273E-02,   1.8234678E-02
     +,   1.9663412E-02,   2.1450952E-02,   2.3657100E-02
     +,   2.6334651E-02,   2.9526759E-02,   3.3264380E-02
     +,   3.7567183E-02,   4.2444035E-02,   4.7895905E-02
     +,   5.3915389E-02,   6.0485996E-02,   6.7574531E-02
     +,   7.5122468E-02,   8.3032489E-02,   9.1155268E-02
     +,   9.9281162E-02,   0.1071400    ,   0.1144114    
     +,   0.1207471    ,   0.1258068    ,   0.1292998    
     +,   0.1310267    ,   0.1309139    ,   0.1290332    
     +,   0.1255998    ,   0.1209484    ,   0.1154898    
     +,   0.1096546    ,   0.1038356    ,   9.8340102E-02
     +,   9.3358576E-02,   8.8955328E-02,   8.5082211E-02
     +,   8.1608221E-02,   7.8357562E-02,   7.5147681E-02
     +,   7.1820632E-02,   6.8263598E-02,   6.4416289E-02
     +,   6.0268905E-02,   5.5853870E-02,   5.1233616E-02
     +,   4.6488568E-02,   4.1707449E-02,   3.6980085E-02
     +,   3.2391757E-02,   2.8019175E-02,   2.3928000E-02
     +,   2.0171029E-02,   1.6786266E-02,   1.3795883E-02
     +,   1.1206544E-02,   9.0105841E-03,   7.1874494E-03
     +,   5.7066455E-03,   4.5308494E-03,   3.6189170E-03
     +,   2.9287534E-03,   2.4198324E-03,   2.0550108E-03
     +,   1.8016258E-03,   1.6320406E-03,   1.5237118E-03
     +,   1.4588558E-03,   1.4238710E-03,   1.4086625E-03
     +,   1.4059554E-03,   1.4106468E-03,   1.4192503E-03
     +,   1.4294419E-03,   1.4397079E-03,   1.4490832E-03
     +,   1.4569658E-03,   1.4629865E-03,   1.4669247E-03
     +,   1.4686529E-03,   1.4681027E-03,   1.4652450E-03
     +,   1.4600762E-03,   1.4526127E-03,   1.4428853E-03
     +,   1.4309377E-03,   1.4168259E-03,   1.4006152E-03
     +,   1.3823805E-03,   1.3622059E-03,   1.3401846E-03
     +,   1.3164154E-03,   1.2910034E-03,   1.2640619E-03
     +,   1.2357082E-03,   1.2060629E-03,   1.1752496E-03
     +,   1.1433959E-03,   1.1106316E-03,   1.0770846E-03
     +,   1.0428829E-03,   1.0081572E-03,   9.7303250E-04
     +,   9.3763170E-04,   9.0207712E-04,   8.6648692E-04
     +,   8.3097286E-04,   7.9564139E-04,   7.6059665E-04
     +,   7.2593603E-04,   6.9174950E-04,   6.5811991E-04
     +,   6.2512606E-04,   5.9283979E-04,   5.6132383E-04
     +,   5.3063413E-04,   5.0082296E-04,   4.7193226E-04
     +,   4.4399762E-04,   4.1704986E-04,   3.9111340E-04
     +,   3.6620459E-04,   3.4233424E-04,   3.1950910E-04
     +,   2.9773073E-04,   2.7699408E-04,   2.5728982E-04
     +,   2.3860591E-04,   2.2092617E-04,   2.0423005E-04
     +,   1.8849396E-04,   1.7369317E-04,   1.5979914E-04
     +,   1.4678153E-04,   1.3460920E-04,   1.2324967E-04
     +,   1.1266867E-04,   1.0283139E-04,   9.3703246E-05
     +,   8.5249398E-05,   7.7434495E-05,   7.0223519E-05
     +,   6.3582433E-05,   5.7477722E-05,   5.1876217E-05
     +,   4.6745736E-05,   4.2055584E-05,   3.7775626E-05
     +,   3.3876971E-05,   3.0332209E-05,   2.7115102E-05
     +,   2.4200534E-05,   2.1564705E-05,   1.9185294E-05
     +,   1.7041246E-05,   1.5112654E-05,   1.3380886E-05
     +,   1.1828704E-05,   1.0439850E-05,   9.1993943E-06
     +,   8.0933605E-06,   7.1089721E-06,   6.2343238E-06
     +,   5.4585839E-06,   4.7717253E-06,   4.1646549E-06
     +,   3.6290019E-06,   3.1572104E-06,   2.7423728E-06
     +,   2.3782297E-06,   2.0591572E-06,   1.7800394E-06
     +,   1.5363076E-06,   1.3238263E-06,   1.1389177E-06
     +,   9.7826853E-07,   8.3894275E-07,   7.1830874E-07
     +,   6.1404177E-07,   5.2407000E-07,   4.4656943E-07
     +,   3.7992098E-07,   3.2270518E-07
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_haonly_ttz80_mass = Yx/0.988713384615385
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_haonly_ttz85_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   2.1205278E-38,   1.1389191E-37,   6.0108260E-37
     +,   3.1172235E-36,   1.5885254E-35,   7.9544371E-35
     +,   3.9139972E-34,   1.8924335E-33,   8.9909706E-33
     +,   4.1976686E-32,   1.9256425E-31,   8.6805810E-31
     +,   3.8451598E-30,   1.6736736E-29,   7.1585131E-29
     +,   3.0086088E-28,   1.2425177E-27,   5.0423196E-27
     +,   2.0107226E-26,   7.8788845E-26,   3.0336792E-25
     +,   1.1478024E-24,   4.2673368E-24,   1.5589513E-23
     +,   5.5965301E-23,   1.9741312E-22,   6.8428531E-22
     +,   2.3307326E-21,   7.8007591E-21,   2.5655291E-20
     +,   8.2910187E-20,   2.6328807E-19,   8.2159006E-19
     +,   2.5191562E-18,   7.5901266E-18,   2.2472444E-17
     +,   6.5377623E-17,   1.8690257E-16,   5.2502379E-16
     +,   1.4492751E-15,   3.9309596E-15,   1.0477421E-14
     +,   2.7440340E-14,   7.0620423E-14,   1.7858753E-13
     +,   4.4377501E-13,   1.0836300E-12,   2.6001063E-12
     +,   6.1303180E-12,   1.4202564E-11,   3.2333729E-11
     +,   7.2331280E-11,   1.5900156E-10,   3.4344608E-10
     +,   7.2898870E-10,   1.5204327E-09,   3.1161562E-09
     +,   6.2756400E-09,   1.2419475E-08,   2.4151248E-08
     +,   4.6150660E-08,   8.6662361E-08,   1.5991615E-07
     +,   2.8997468E-07,   5.1671367E-07,   9.0485361E-07
     +,   1.5571886E-06,   2.6337129E-06,   4.3778705E-06
     +,   7.1525651E-06,   1.1486296E-05,   1.8132812E-05
     +,   2.8141465E-05,   4.2942680E-05,   6.4437940E-05
     +,   9.5100833E-05,   1.3807281E-04,   1.9724580E-04
     +,   2.7732790E-04,   3.8388430E-04,   5.2333099E-04
     +,   7.0286175E-04,   9.3037024E-04,   1.2142252E-03
     +,   1.5630805E-03,   1.9854642E-03,   2.4894404E-03
     +,   3.0819452E-03,   3.7682366E-03,   4.5509101E-03
     +,   5.4290891E-03,   6.3973274E-03,   7.4444925E-03
     +,   8.5529201E-03,   9.6979244E-03,   1.0847679E-02
     +,   1.1963777E-02,   1.3002994E-02,   1.3919387E-02
     +,   1.4667685E-02,   1.5206695E-02,   1.5503201E-02
     +,   1.5535235E-02,   1.5294738E-02,   1.4789061E-02
     +,   1.4041369E-02,   1.3090457E-02,   1.1991309E-02
     +,   1.0818113E-02,   9.6722236E-03,   8.6967843E-03
     +,   8.0956481E-03,   8.1473682E-03,   9.1972575E-03
     +,   1.1606920E-02,   1.5650593E-02,   2.1380229E-02
     +,   2.8517913E-02,   3.6453310E-02,   4.4388652E-02
     +,   5.1590707E-02,   5.7661630E-02,   6.2804312E-02
     +,   6.8133987E-02,   7.5933881E-02,   8.9343511E-02
     +,   0.1108540    ,   0.1398844    ,   0.1712646    
     +,   0.1967869    ,   0.2097100    ,   0.2088717    
     +,   0.1988607    ,   0.1864626    ,   0.1767559    
     +,   0.1712776    ,   0.1680950    ,   0.1631171    
     +,   0.1524500    ,   0.1347786    ,   0.1120483    
     +,   8.8024050E-02,   6.6160157E-02,   4.8391838E-02
     +,   3.5170615E-02,   2.6060879E-02,   2.0254837E-02
     +,   1.6850207E-02,   1.4990121E-02,   1.3958401E-02
     +,   1.3239298E-02,   1.2525535E-02,   1.1681079E-02
     +,   1.0683988E-02,   9.5728710E-03,   8.4083891E-03
     +,   7.2504766E-03,   6.1472468E-03,   5.1315022E-03
     +,   4.2217039E-03,   3.4249495E-03,   2.7401855E-03
     +,   2.1613464E-03,   1.6796457E-03,   1.2850066E-03
     +,   9.6691510E-04,   7.1493984E-04,   5.1902811E-04
     +,   3.6969437E-04,   2.5820243E-04,   1.7673805E-04
     +,   1.1852141E-04,   7.7847944E-05,   5.0071238E-05
     +,   3.1532054E-05,   1.9440580E-05,   1.1733408E-05
     +,   6.9321882E-06,   4.0090554E-06,   2.2695504E-06
     +,   1.2576255E-06,   6.8212569E-07,   3.6214809E-07
     +,   1.8820188E-07,   9.5734656E-08,   4.7666273E-08
     +,   2.3230518E-08,   1.1082134E-08,   5.1748184E-09
     +,   2.3651632E-09,   1.0581437E-09,   4.6337795E-10
     +,   1.9861825E-10,   8.3331418E-11,   3.4222965E-11
     +,   1.3757299E-11,   5.4130420E-12,   2.0847573E-12
     +,   7.8593881E-13,   2.9002107E-13,   1.0475199E-13
     +,   3.7033941E-14,   1.2816176E-14,   4.3413395E-15
     +,   1.4393976E-15,   4.6715159E-16,   1.4840293E-16
     +,   4.6144036E-17,   1.4044122E-17,   4.1840748E-18
     +,   1.2201366E-18,   3.4826129E-19,   9.7299246E-20
     +,   2.6609576E-20,   7.1231528E-21,   1.8663549E-21
     +,   4.7865263E-22,   1.2016395E-22,   2.9527982E-23
     +,   7.1019783E-24,   1.6720556E-24,   3.8532719E-25
     +,   8.6914648E-26,   1.9189508E-26,   4.1472529E-27
     +,   8.7733350E-28,   1.8165610E-28,   3.6816525E-29
     +,   7.3040953E-30,   1.4183852E-30,   2.6959161E-31
     +,   5.0155987E-32,   9.1342237E-33,   1.6282575E-33
     +,   2.8409299E-34,   4.8520699E-35,   8.1114068E-36
     +,   1.3272458E-36,   2.1257348E-37,   3.3327485E-38
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_haonly_ttz85_mass = Yx/0.884826833333333
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_haonly_ttz90_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.1394138E-03,   1.1812394E-03
     +,   1.2240921E-03,   1.2680033E-03,   1.3130064E-03
     +,   1.3591357E-03,   1.4064265E-03,   1.4549146E-03
     +,   1.5046344E-03,   1.5556224E-03,   1.6079112E-03
     +,   1.6615314E-03,   1.7165109E-03,   1.7728736E-03
     +,   1.8306385E-03,   1.8898185E-03,   1.9504197E-03
     +,   2.0124405E-03,   2.0758696E-03,   2.1406871E-03
     +,   2.2068603E-03,   2.2743454E-03,   2.3430849E-03
     +,   2.4130107E-03,   2.4840338E-03,   2.5560565E-03
     +,   2.6289618E-03,   2.7026171E-03,   2.7768728E-03
     +,   2.8515633E-03,   2.9265061E-03,   3.0015029E-03
     +,   3.0763389E-03,   3.1507844E-03,   3.2245950E-03
     +,   3.2975124E-03,   3.3692680E-03,   3.4395799E-03
     +,   3.5081618E-03,   3.5747131E-03,   3.6389343E-03
     +,   3.7005206E-03,   3.7591651E-03,   3.8145634E-03
     +,   3.8664162E-03,   3.9144284E-03,   3.9583161E-03
     +,   3.9978055E-03,   4.0326370E-03,   4.0625688E-03
     +,   4.0873759E-03,   4.1068560E-03,   4.1208286E-03
     +,   4.1291406E-03,   4.1316636E-03,   4.1282978E-03
     +,   4.1189739E-03,   4.1036522E-03,   4.0823254E-03
     +,   4.0550176E-03,   4.0217838E-03,   3.9827120E-03
     +,   3.9379238E-03,   3.8875679E-03,   3.8318220E-03
     +,   3.7708990E-03,   3.7050317E-03,   3.6344861E-03
     +,   3.5595431E-03,   3.4805164E-03,   3.3977285E-03
     +,   3.3115295E-03,   3.2222767E-03,   3.1303491E-03
     +,   3.0361307E-03,   2.9400117E-03,   2.8423965E-03
     +,   2.7436928E-03,   2.6443070E-03,   2.5446427E-03
     +,   2.4451145E-03,   2.3461198E-03,   2.2480662E-03
     +,   2.1513419E-03,   2.0563412E-03,   1.9634385E-03
     +,   1.8730122E-03,   1.7854191E-03,   1.7010176E-03
     +,   1.6201466E-03,   1.5431339E-03,   1.4703005E-03
     +,   1.4019536E-03,   1.3383820E-03,   1.2798599E-03
     +,   1.2266507E-03,   1.1789926E-03,   1.1371112E-03
     +,   1.1012042E-03,   1.0714508E-03,   1.0479995E-03
     +,   1.0309741E-03,   1.0204625E-03,   1.0165209E-03
     +,   1.0191652E-03,   1.0283715E-03,   1.0440712E-03
     +,   1.0661473E-03,   1.0944350E-03,   1.1287167E-03
     +,   1.1687187E-03,   1.2141160E-03,   1.2645223E-03
     +,   1.3195021E-03,   1.3785587E-03,   1.4411502E-03
     +,   1.5066778E-03,   1.5745051E-03,   1.6439479E-03
     +,   1.7142941E-03,   1.7848052E-03,   1.8547197E-03
     +,   1.9232674E-03,   1.9896834E-03,   2.0532154E-03
     +,   2.1131299E-03,   2.1687406E-03,   2.2194120E-03
     +,   2.2645928E-03,   2.3038292E-03,   2.3368110E-03
     +,   2.3634047E-03,   2.3837213E-03,   2.3981845E-03
     +,   2.4076349E-03,   2.4134519E-03,   2.4177055E-03
     +,   2.4233430E-03,   2.4343955E-03,   2.4562054E-03
     +,   2.4956609E-03,   2.5614132E-03,   2.6640580E-03
     +,   2.8162522E-03,   3.0327039E-03,   3.3301183E-03
     +,   3.7269795E-03,   4.2432505E-03,   4.9000988E-03
     +,   5.7197921E-03,   6.7258072E-03,   7.9433415E-03
     +,   9.4005475E-03,   1.1130532E-02,   1.3173816E-02
     +,   1.5580993E-02,   1.8415343E-02,   2.1754550E-02
     +,   2.5689986E-02,   3.0322602E-02,   3.5756167E-02
     +,   4.2085309E-02,   4.9379680E-02,   5.7666376E-02
     +,   6.6912659E-02,   7.7010132E-02,   8.7764256E-02
     +,   9.8893508E-02,   0.1100388    ,   0.1207816    
     +,   0.1306714    ,   0.1392605    ,   0.1461407    
     +,   0.1509764    ,   0.1535316    ,   0.1536880    
     +,   0.1514507    ,   0.1469433    ,   0.1403929    
     +,   0.1321075    ,   0.1224502    ,   0.1118128    
     +,   0.1005902    ,   8.9157440E-02,   7.7853583E-02
     +,   6.6969708E-02,   5.6740686E-02,   4.7341362E-02
     +,   3.8887788E-02,   3.1441614E-02,   2.5014555E-02
     +,   1.9577144E-02,   1.5067939E-02,   1.1402207E-02
     +,   8.4807528E-03,   6.1983443E-03,   4.4505517E-03
     +,   3.1387601E-03,   2.1737816E-03,   1.4780883E-03
     +,   9.8660204E-04,   6.4636610E-04,   4.1556859E-04
     +,   2.6216308E-04,   1.6226692E-04,   9.8530843E-05
     +,   5.8689915E-05,   3.4292683E-05,   1.9656725E-05
     +,   1.1054581E-05,   6.1010828E-06,   3.3062272E-06
     +,   1.7607715E-06,   9.2284563E-07,   4.7709381E-07
     +,   2.4418753E-07,   1.2443469E-07,   6.3656991E-08
     +,   3.3064055E-08,   1.7680016E-08,   9.8677626E-09
     +,   5.8047589E-09,   3.6061918E-09,   2.3514510E-09
     +,   1.5914436E-09,   1.1046106E-09,   7.7845597E-10
     +,   5.5299604E-10,   3.9409545E-10,   2.8093070E-10
     +,   1.9997451E-10,   1.4200742E-10,   1.0054742E-10
     +,   7.0962056E-11,   4.9913754E-11,   3.4987742E-11
     +,   2.4439390E-11,   1.7011535E-11,   1.1799794E-11
     +,   8.1560349E-12,   5.6176166E-12,   3.8556593E-12
     +,   2.6371062E-12,   1.7973620E-12,   1.2207255E-12
     +,   8.2619800E-13,   5.5724105E-13,   3.7453620E-13
     +,   2.5086286E-13,   1.6745116E-13,   1.1139124E-13
     +,   7.3846460E-14,   4.8791073E-14,   3.2129495E-14
     +,   2.1087773E-14,   1.3795416E-14,   8.9959956E-15
     +,   5.8480565E-15,   3.7901078E-15,   2.4491244E-15
     +,   1.5781638E-15,   1.0142649E-15,   6.5026036E-16
     +,   4.1596666E-16,   2.6558406E-16,   1.6930313E-16
     +,   1.0780184E-16,   6.8598187E-17,   4.3650943E-17
     +,   2.7795366E-17,   1.7725609E-17,   1.1331667E-17
     +,   7.2696048E-18,   4.6853619E-18,   3.0373971E-18
     +,   1.9829922E-18,   1.3052137E-18,   8.6703066E-19
     +,   5.8171384E-19,   3.9440750E-19,   2.7027710E-19
     +,   1.8717869E-19,   1.3094185E-19,   9.2463916E-20
     +,   6.5846860E-20,   4.7242201E-20,   3.4110570E-20
     +,   2.4759839E-20,   1.8050419E-20,   1.3203961E-20
     +,   9.6841782E-21,   7.1163487E-21,   5.2364842E-21
     +,   3.8564905E-21,   2.8415199E-21,   2.0939294E-21
     +,   1.5428421E-21,   1.1363946E-21,   8.3660145E-22
     +,   6.1549629E-22,   4.5250036E-22
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_haonly_ttz90_mass = Yx/0.838257
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_haonly_ttz95_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.6690904E-06,   2.0475659E-06
     +,   2.5053998E-06,   3.0576914E-06,   3.7220696E-06
     +,   4.5190368E-06,   5.4723628E-06,   6.6094999E-06
     +,   7.9620158E-06,   9.5661781E-06,   1.1463333E-05
     +,   1.3700563E-05,   1.6331223E-05,   1.9415567E-05
     +,   2.3021325E-05,   2.7224380E-05,   3.2109347E-05
     +,   3.7770191E-05,   4.4310818E-05,   5.1845607E-05
     +,   6.0499868E-05,   7.0410308E-05,   8.1725062E-05
     +,   9.4604882E-05,   1.0922101E-04,   1.2575797E-04
     +,   1.4441082E-04,   1.6538583E-04,   1.8889933E-04
     +,   2.1517703E-04,   2.4445233E-04,   2.7696497E-04
     +,   3.1295925E-04,   3.5268159E-04,   3.9637822E-04
     +,   4.4429215E-04,   4.9666030E-04,   5.5370911E-04
     +,   6.1565556E-04,   6.8269239E-04,   7.5499906E-04
     +,   8.3272444E-04,   9.1598969E-04,   1.0048819E-03
     +,   1.0994496E-03,   1.1997001E-03,   1.3055940E-03
     +,   1.4170430E-03,   1.5339063E-03,   1.6559877E-03
     +,   1.7830344E-03,   1.9147346E-03,   2.0507155E-03
     +,   2.1905547E-03,   2.3337556E-03,   2.4797823E-03
     +,   2.6280358E-03,   2.7778710E-03,   2.9285979E-03
     +,   3.0794872E-03,   3.2297766E-03,   3.3786811E-03
     +,   3.5253889E-03,   3.6690899E-03,   3.8089734E-03
     +,   3.9442251E-03,   4.0740645E-03,   4.1977223E-03
     +,   4.3144827E-03,   4.4236588E-03,   4.5246333E-03
     +,   4.6168361E-03,   4.6997797E-03,   4.7730394E-03
     +,   4.8362794E-03,   4.8892465E-03,   4.9317712E-03
     +,   4.9637752E-03,   4.9852720E-03,   4.9963603E-03
     +,   4.9972269E-03,   4.9881414E-03,   4.9694520E-03
     +,   4.9415813E-03,   4.9050180E-03,   4.8603103E-03
     +,   4.8080613E-03,   4.7489125E-03,   4.6835472E-03
     +,   4.6126698E-03,   4.5369994E-03,   4.4572693E-03
     +,   4.3742131E-03,   4.2885491E-03,   4.2009801E-03
     +,   4.1121920E-03,   4.0228302E-03,   3.9335159E-03
     +,   3.8448174E-03,   3.7572687E-03,   3.6713451E-03
     +,   3.5874818E-03,   3.5060511E-03,   3.4273828E-03
     +,   3.3517450E-03,   3.2793551E-03,   3.2103825E-03
     +,   3.1449476E-03,   3.0831194E-03,   3.0249229E-03
     +,   2.9703467E-03,   2.9193354E-03,   2.8718039E-03
     +,   2.8276320E-03,   2.7866757E-03,   2.7487627E-03
     +,   2.7137052E-03,   2.6812935E-03,   2.6513094E-03
     +,   2.6235192E-03,   2.5976833E-03,   2.5735581E-03
     +,   2.5508984E-03,   2.5294560E-03,   2.5089863E-03
     +,   2.4892502E-03,   2.4700118E-03,   2.4510461E-03
     +,   2.4321349E-03,   2.4130745E-03,   2.3936720E-03
     +,   2.3737538E-03,   2.3531651E-03,   2.3317782E-03
     +,   2.3094993E-03,   2.2862793E-03,   2.2621325E-03
     +,   2.2371565E-03,   2.2115633E-03,   2.1857191E-03
     +,   2.1601948E-03,   2.1358258E-03,   2.1137786E-03
     +,   2.0956246E-03,   2.0834105E-03,   2.0797136E-03
     +,   2.0876720E-03,   2.1109709E-03,   2.1537659E-03
     +,   2.2205389E-03,   2.3158649E-03,   2.4440931E-03
     +,   2.6089654E-03,   2.8132279E-03,   3.0582559E-03
     +,   3.3437724E-03,   3.6678065E-03,   4.0269685E-03
     +,   4.4170665E-03,   4.8341518E-03,   5.2761557E-03
     +,   5.7448787E-03,   6.2484210E-03,   6.8040709E-03
     +,   7.4415728E-03,   8.2067093E-03,   9.1651352E-03
     +,   1.0406444E-02,   1.2048137E-02,   1.4238824E-02
     +,   1.7159848E-02,   2.1024732E-02,   2.6075367E-02
     +,   3.2572556E-02,   4.0778358E-02,   5.0930124E-02
     +,   6.3200183E-02,   7.7641286E-02,   9.4123445E-02
     +,   0.1122722    ,   0.1314215    ,   0.1506047    
     +,   0.1686049    ,   0.1840708    ,   0.1956863    
     +,   0.2023686    ,   0.2034560    ,   0.1988333    
     +,   0.1889656    ,   0.1748324    ,   0.1577672    
     +,   0.1392495    ,   0.1206891    ,   0.1032458    
     +,   8.7715894E-02,   7.4498951E-02,   6.3635722E-02
     +,   5.4894011E-02,   4.7879379E-02,   4.2144772E-02
     +,   3.7277747E-02,   3.2954920E-02,   2.8963342E-02
     +,   2.5194973E-02,   2.1623505E-02,   1.8272882E-02
     +,   1.5188424E-02,   1.2414559E-02,   9.9809095E-03
     +,   7.8968145E-03,   6.1522950E-03,   4.7224378E-03
     +,   3.5727844E-03,   2.6645099E-03,   1.9585993E-03
     +,   1.4185578E-03,   1.0118104E-03,   7.1026641E-04
     +,   4.9036474E-04,   3.3276435E-04,   2.2185194E-04
     +,   1.4527391E-04,   9.3446302E-05,   5.9082417E-05
     +,   3.6766269E-05,   2.2571649E-05,   1.3724274E-05
     +,   8.3138984E-06,   5.0603371E-06,   3.1291638E-06
     +,   1.9911397E-06,   1.3193901E-06,   9.1726167E-07
     +,   6.6940964E-07,   5.0972233E-07,   4.0100929E-07
     +,   3.2265081E-07,   2.6326933E-07,   2.1652251E-07
     +,   1.7876627E-07,   1.4779592E-07,   1.2217949E-07
     +,   1.0091006E-07,   8.3227739E-08,   6.8531762E-08
     +,   5.6331633E-08,   4.6219508E-08,   3.7852388E-08
     +,   3.0941933E-08,   2.5245836E-08,   2.0559707E-08
     +,   1.6711827E-08,   1.3558587E-08,   1.0979709E-08
     +,   8.8746361E-09,   7.1596120E-09,   5.7651639E-09
     +,   4.6336148E-09,   3.7171584E-09,   2.9763334E-09
     +,   2.3786761E-09,   1.8974673E-09,   1.5107644E-09
     +,   1.2005997E-09,   9.5232633E-10,   7.5397460E-10
     +,   5.9580790E-10,   4.6993609E-10,   3.6996220E-10
     +,   2.9070873E-10,   2.2800214E-10,   1.7848513E-10
     +,   1.3946028E-10,   1.0876354E-10,   8.4663020E-11
     +,   6.5779542E-11,   5.1011403E-11,   3.9484683E-11
     +,   3.0504991E-11,   2.3523301E-11,   1.8105226E-11
     +,   1.3909015E-11,   1.0665173E-11,   8.1625401E-12
     +,   6.2353660E-12,   4.7542851E-12,   3.6181795E-12
     +,   2.7483643E-12,   2.0837475E-12,   1.5768635E-12
     +,   1.1910498E-12,   8.9793304E-13,   6.7568564E-13
     +,   5.0748555E-13,   3.8044280E-13,   2.8466454E-13
     +,   2.1260034E-13,   1.5847943E-13,   1.1791505E-13
     +,   8.7567520E-14,   6.4908792E-14
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_haonly_ttz95_mass = Yx/0.91649432
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_haonly_hatt100_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  5.1346547E-03,   5.3356048E-03
     +,   5.5425055E-03,   5.7557104E-03,   5.9756050E-03
     +,   6.2026107E-03,   6.4371745E-03,   6.6797724E-03
     +,   6.9308928E-03,   7.1910555E-03,   7.4607716E-03
     +,   7.7405563E-03,   8.0309091E-03,   8.3323093E-03
     +,   8.6451974E-03,   8.9699673E-03,   9.3069496E-03
     +,   9.6563995E-03,   1.0018478E-02,   1.0393253E-02
     +,   1.0780664E-02,   1.1180536E-02,   1.1592539E-02
     +,   1.2016233E-02,   1.2450971E-02,   1.2896004E-02
     +,   1.3350398E-02,   1.3813066E-02,   1.4282786E-02
     +,   1.4758175E-02,   1.5237732E-02,   1.5719835E-02
     +,   1.6202755E-02,   1.6684683E-02,   1.7163746E-02
     +,   1.7638016E-02,   1.8105552E-02,   1.8564397E-02
     +,   1.9012649E-02,   1.9448381E-02,   1.9869780E-02
     +,   2.0275079E-02,   2.0662621E-02,   2.1030830E-02
     +,   2.1378266E-02,   2.1703601E-02,   2.2005659E-02
     +,   2.2283394E-02,   2.2535922E-02,   2.2762503E-02
     +,   2.2962570E-02,   2.3135733E-02,   2.3281764E-02
     +,   2.3400638E-02,   2.3492515E-02,   2.3557782E-02
     +,   2.3597030E-02,   2.3611072E-02,   2.3600981E-02
     +,   2.3568064E-02,   2.3513891E-02,   2.3440268E-02
     +,   2.3349294E-02,   2.3243275E-02,   2.3124769E-02
     +,   2.2996569E-02,   2.2861643E-02,   2.2723144E-02
     +,   2.2584373E-02,   2.2448732E-02,   2.2319708E-02
     +,   2.2200854E-02,   2.2095755E-02,   2.2008007E-02
     +,   2.1941248E-02,   2.1899100E-02,   2.1885267E-02
     +,   2.1903517E-02,   2.1957720E-02,   2.2051960E-02
     +,   2.2190535E-02,   2.2378057E-02,   2.2619493E-02
     +,   2.2920242E-02,   2.3286114E-02,   2.3723440E-02
     +,   2.4238905E-02,   2.4839615E-02,   2.5532870E-02
     +,   2.6326075E-02,   2.7226498E-02,   2.8240964E-02
     +,   2.9375512E-02,   3.0635124E-02,   3.2023277E-02
     +,   3.3541415E-02,   3.5188816E-02,   3.6961857E-02
     +,   3.8854122E-02,   4.0855668E-02,   4.2953361E-02
     +,   4.5130417E-02,   4.7366954E-02,   4.9639739E-02
     +,   5.1923096E-02,   5.4189287E-02,   5.6409001E-02
     +,   5.8552384E-02,   6.0590029E-02,   6.2493771E-02
     +,   6.4237520E-02,   6.5798528E-02,   6.7157879E-02
     +,   6.8301484E-02,   6.9220454E-02,   6.9911659E-02
     +,   7.0377648E-02,   7.0626870E-02,   7.0673130E-02
     +,   7.0535123E-02,   7.0235789E-02,   6.9801234E-02
     +,   6.9259785E-02,   6.8640746E-02,   6.7973040E-02
     +,   6.7284308E-02,   6.6599309E-02,   6.5939300E-02
     +,   6.5320820E-02,   6.4755298E-02,   6.4248495E-02
     +,   6.3800693E-02,   6.3406654E-02,   6.3056402E-02
     +,   6.2736005E-02,   6.2428594E-02,   6.2115721E-02
     +,   6.1778739E-02,   6.1400212E-02,   6.0965195E-02
     +,   6.0462631E-02,   5.9886198E-02,   5.9235107E-02
     +,   5.8514420E-02,   5.7735167E-02,   5.6913808E-02
     +,   5.6071602E-02,   5.5233590E-02,   5.4427221E-02
     +,   5.3680763E-02,   5.3021703E-02,   5.2475307E-02
     +,   5.2062862E-02,   5.1800381E-02,   5.1697668E-02
     +,   5.1757496E-02,   5.1975414E-02,   5.2339830E-02
     +,   5.2832779E-02,   5.3430710E-02,   5.4106239E-02
     +,   5.4829553E-02,   5.5570625E-02,   5.6300923E-02
     +,   5.6995485E-02,   5.7634685E-02,   5.8205418E-02
     +,   5.8702193E-02,   5.9127528E-02,   5.9491798E-02
     +,   5.9812356E-02,   6.0112406E-02,   6.0419220E-02
     +,   6.0761951E-02,   6.1169382E-02,   6.1667524E-02
     +,   6.2277503E-02,   6.3013338E-02,   6.3880570E-02
     +,   6.4875327E-02,   6.5983705E-02,   6.7182019E-02
     +,   6.8437569E-02,   6.9710039E-02,   7.0953235E-02
     +,   7.2117023E-02,   7.3149733E-02,   7.4000522E-02
     +,   7.4621454E-02,   7.4969560E-02,   7.5008661E-02
     +,   7.4710570E-02,   7.4056096E-02,   7.3035628E-02
     +,   7.1649067E-02,   6.9905601E-02,   6.7823075E-02
     +,   6.5427229E-02,   6.2750146E-02,   5.9829261E-02
     +,   5.6706116E-02,   5.3424805E-02,   5.0030433E-02
     +,   4.6567939E-02,   4.3081392E-02,   3.9612159E-02
     +,   3.6198463E-02,   3.2874864E-02,   2.9671548E-02
     +,   2.6613748E-02,   2.3721840E-02,   2.1011502E-02
     +,   1.8493664E-02,   1.6174557E-02,   1.4056333E-02
     +,   1.2137587E-02,   1.0413674E-02,   8.8771563E-03
     +,   7.5184521E-03,   6.3264696E-03,   5.2888328E-03
     +,   4.3924875E-03,   3.6241421E-03,   2.9705502E-03
     +,   2.4187600E-03,   1.9564095E-03,   1.5719220E-03
     +,   1.2545850E-03,   9.9461363E-04,   7.8321522E-04
     +,   6.1259605E-04,   4.7591326E-04,   3.6722247E-04
     +,   2.8142703E-04,   2.1420805E-04,   1.6192970E-04
     +,   1.2156959E-04,   9.0641304E-05,   6.7115929E-05
     +,   4.9352671E-05,   3.6038640E-05,   2.6133304E-05
     +,   1.8818497E-05,   1.3456362E-05,   9.5545320E-06
     +,   6.7363894E-06,   4.7160479E-06,   3.2783121E-06
     +,   2.2627187E-06,   1.5506819E-06,   1.0551498E-06
     +,   7.1284143E-07,   4.7814308E-07,   3.1842578E-07
     +,   2.1053930E-07,   1.3820365E-07,   9.0067651E-08
     +,   5.8274850E-08,   3.7432244E-08,   2.3869934E-08
     +,   1.5111196E-08,   9.4971053E-09,   5.9253966E-09
     +,   3.6700034E-09,   2.2565678E-09,   1.3773775E-09
     +,   8.3458268E-10,   5.0199728E-10,   2.9974631E-10
     +,   1.7767093E-10,   1.0453893E-10,   6.1058360E-11
     +,   3.5401519E-11,   2.0375064E-11,   1.1640366E-11
     +,   6.6014360E-12,   3.7161836E-12,   2.0766160E-12
     +,   1.1518594E-12,   6.3422000E-13,   3.4662510E-13
     +,   1.8805125E-13,   1.0126751E-13,   5.4132337E-14
     +,   2.8722233E-14,   1.5127643E-14,   7.9087204E-15
     +,   4.1040440E-15,   2.1140096E-15,   1.0808662E-15
     +,   5.4855865E-16,   2.7633926E-16,   1.3818075E-16
     +,   6.8583126E-17,   3.3788796E-17,   1.6523027E-17
     +,   8.0203002E-18,   3.8641399E-18,   1.8479697E-18
     +,   8.7719733E-19,   4.1331274E-19
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_haonly_hatt100_mass = Yx/2.05508167741936
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_haonly_hatt105_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.9843580E-03,   3.0489066E-03
     +,   3.1165276E-03,   3.1873798E-03,   3.2616323E-03
     +,   3.3394608E-03,   3.4210528E-03,   3.5066085E-03
     +,   3.5963398E-03,   3.6904798E-03,   3.7892726E-03
     +,   3.8929875E-03,   4.0019136E-03,   4.1163629E-03
     +,   4.2366772E-03,   4.3632225E-03,   4.4963947E-03
     +,   4.6366206E-03,   4.7843577E-03,   4.9400930E-03
     +,   5.1043425E-03,   5.2776528E-03,   5.4605938E-03
     +,   5.6537697E-03,   5.8577829E-03,   6.0732737E-03
     +,   6.3008810E-03,   6.5412493E-03,   6.7950198E-03
     +,   7.0628254E-03,   7.3452825E-03,   7.6429779E-03
     +,   7.9564722E-03,   8.2862796E-03,   8.6328639E-03
     +,   8.9966394E-03,   9.3779517E-03,   9.7770756E-03
     +,   1.0194233E-02,   1.0629526E-02,   1.1083028E-02
     +,   1.1554695E-02,   1.2044412E-02,   1.2551979E-02
     +,   1.3077126E-02,   1.3619495E-02,   1.4178666E-02
     +,   1.4754146E-02,   1.5345386E-02,   1.5951779E-02
     +,   1.6572671E-02,   1.7207365E-02,   1.7855113E-02
     +,   1.8515196E-02,   1.9186784E-02,   1.9869111E-02
     +,   2.0561362E-02,   2.1262722E-02,   2.1972381E-02
     +,   2.2689532E-02,   2.3413386E-02,   2.4143180E-02
     +,   2.4878113E-02,   2.5617478E-02,   2.6360594E-02
     +,   2.7106730E-02,   2.7855288E-02,   2.8605569E-02
     +,   2.9357001E-02,   3.0108908E-02,   3.0860683E-02
     +,   3.1611562E-02,   3.2360803E-02,   3.3107422E-02
     +,   3.3850335E-02,   3.4588195E-02,   3.5319317E-02
     +,   3.6041655E-02,   3.6752764E-02,   3.7449736E-02
     +,   3.8129043E-02,   3.8786720E-02,   3.9418146E-02
     +,   4.0018283E-02,   4.0581524E-02,   4.1101977E-02
     +,   4.1573450E-02,   4.1989733E-02,   4.2344712E-02
     +,   4.2632680E-02,   4.2848539E-02,   4.2988032E-02
     +,   4.3048095E-02,   4.3026984E-02,   4.2924568E-02
     +,   4.2742427E-02,   4.2483978E-02,   4.2154517E-02
     +,   4.1761097E-02,   4.1312516E-02,   4.0818922E-02
     +,   4.0291730E-02,   3.9743021E-02,   3.9185409E-02
     +,   3.8631298E-02,   3.8092639E-02,   3.7580412E-02
     +,   3.7104234E-02,   3.6672026E-02,   3.6289718E-02
     +,   3.5961278E-02,   3.5688452E-02,   3.5471097E-02
     +,   3.5307325E-02,   3.5193894E-02,   3.5126645E-02
     +,   3.5101172E-02,   3.5113238E-02,   3.5159647E-02
     +,   3.5238661E-02,   3.5350621E-02,   3.5498399E-02
     +,   3.5687633E-02,   3.5926949E-02,   3.6227867E-02
     +,   3.6604371E-02,   3.7072673E-02,   3.7650287E-02
     +,   3.8355298E-02,   3.9205249E-02,   4.0216126E-02
     +,   4.1401029E-02,   4.2769279E-02,   4.4325080E-02
     +,   4.6066903E-02,   4.7986761E-02,   5.0069604E-02
     +,   5.2293364E-02,   5.4629479E-02,   5.7043258E-02
     +,   5.9494585E-02,   6.1939631E-02,   6.4332165E-02
     +,   6.6625185E-02,   6.8772599E-02,   7.0731148E-02
     +,   7.2461993E-02,   7.3932052E-02,   7.5115196E-02
     +,   7.5993329E-02,   7.6556563E-02,   7.6803416E-02
     +,   7.6740444E-02,   7.6381586E-02,   7.5747132E-02
     +,   7.4862659E-02,   7.3757634E-02,   7.2463959E-02
     +,   7.1014740E-02,   6.9443211E-02,   6.7781389E-02
     +,   6.6059470E-02,   6.4305335E-02,   6.2544093E-02
     +,   6.0797814E-02,   5.9085827E-02,   5.7424840E-02
     +,   5.5829063E-02,   5.4310501E-02,   5.2879173E-02
     +,   5.1543411E-02,   5.0309841E-02,   4.9183220E-02
     +,   4.8166562E-02,   4.7260921E-02,   4.6465065E-02
     +,   4.5775373E-02,   4.5185681E-02,   4.4687141E-02
     +,   4.4268191E-02,   4.3914717E-02,   4.3610346E-02
     +,   4.3336794E-02,   4.3074429E-02,   4.2802803E-02
     +,   4.2501405E-02,   4.2150427E-02,   4.1731305E-02
     +,   4.1227516E-02,   4.0625207E-02,   3.9913513E-02
     +,   3.9085027E-02,   3.8135931E-02,   3.7066177E-02
     +,   3.5879143E-02,   3.4581594E-02,   3.3183340E-02
     +,   3.1696707E-02,   3.0136019E-02,   2.8517026E-02
     +,   2.6856514E-02,   2.5171638E-02,   2.3479270E-02
     +,   2.1795686E-02,   2.0136287E-02,   1.8514967E-02
     +,   1.6944047E-02,   1.5434165E-02,   1.3994126E-02
     +,   1.2630747E-02,   1.1349026E-02,   1.0152296E-02
     +,   9.0422649E-03,   8.0190962E-03,   7.0816968E-03
     +,   6.2279319E-03,   5.4547708E-03,   4.7584060E-03
     +,   4.1345102E-03,   3.5784438E-03,   3.0852754E-03
     +,   2.6499867E-03,   2.2675975E-03,   1.9332198E-03
     +,   1.6421151E-03,   1.3897741E-03,   1.1719702E-03
     +,   9.8476408E-04,   8.2450808E-04,   6.8786950E-04
     +,   5.7183352E-04,   4.7368268E-04,   3.9097984E-04
     +,   3.2156010E-04,   2.6351766E-04,   2.1517181E-04
     +,   1.7505560E-04,   1.4189693E-04,   1.1459515E-04
     +,   9.2201713E-05,   7.3904899E-05,   5.9014237E-05
     +,   4.6943660E-05,   3.7197515E-05,   2.9359448E-05
     +,   2.3081580E-05,   1.8073975E-05,   1.4095888E-05
     +,   1.0948683E-05,   8.4694102E-06,   6.5244994E-06
     +,   5.0052395E-06,   3.8236212E-06,   2.9086211E-06
     +,   2.2031513E-06,   1.6616068E-06,   1.2477598E-06
     +,   9.3291908E-07,   6.9446770E-07,   5.1468265E-07
     +,   3.7975201E-07,   2.7895138E-07,   2.0399091E-07
     +,   1.4850239E-07,   1.0762128E-07,   7.7641168E-08
     +,   5.5757592E-08,   3.9859543E-08,   2.8364601E-08
     +,   2.0092262E-08,   1.4167079E-08,   9.9433901E-09
     +,   6.9470025E-09,   4.8313420E-09,   3.3446130E-09
     +,   2.3049089E-09,   1.5812365E-09,   1.0799690E-09
     +,   7.3438000E-10,   4.9726467E-10,   3.3532804E-10
     +,   2.2525615E-10,   1.5077545E-10,   1.0060736E-10
     +,   6.6960291E-11,   4.4488857E-11,   2.9539222E-11
     +,   1.9628403E-11,   1.3078341E-11,   8.7590933E-12
     +,   5.9149326E-12,   4.0420267E-12,   2.8066284E-12
     +,   1.9883611E-12,   1.4425813E-12,   1.0746092E-12
     +,   8.2279924E-13,   6.4708080E-13,   5.2152174E-13
     +,   4.2932823E-13,   3.5965019E-13
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_haonly_hatt105_mass = Yx/1.71376986666667
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_haonly_hatt107_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.6583381E-03,   4.7835200E-03
     +,   4.9087824E-03,   5.0339820E-03,   5.1589715E-03
     +,   5.2836002E-03,   5.4077185E-03,   5.5311737E-03
     +,   5.6538153E-03,   5.7755043E-03,   5.8960994E-03
     +,   6.0154740E-03,   6.1335135E-03,   6.2501184E-03
     +,   6.3652140E-03,   6.4787478E-03,   6.5906998E-03
     +,   6.7010829E-03,   6.8099522E-03,   6.9174101E-03
     +,   7.0236074E-03,   7.1287546E-03,   7.2331191E-03
     +,   7.3370454E-03,   7.4409372E-03,   7.5452803E-03
     +,   7.6506366E-03,   7.7576470E-03,   7.8670336E-03
     +,   7.9796016E-03,   8.0962311E-03,   8.2178814E-03
     +,   8.3455844E-03,   8.4804352E-03,   8.6235916E-03
     +,   8.7762624E-03,   8.9396965E-03,   9.1151623E-03
     +,   9.3039647E-03,   9.5073869E-03,   9.7267153E-03
     +,   9.9631986E-03,   1.0218042E-02,   1.0492379E-02
     +,   1.0787263E-02,   1.1103640E-02,   1.1442328E-02
     +,   1.1803996E-02,   1.2189144E-02,   1.2598074E-02
     +,   1.3030865E-02,   1.3487357E-02,   1.3967101E-02
     +,   1.4469392E-02,   1.4993147E-02,   1.5536982E-02
     +,   1.6099136E-02,   1.6677450E-02,   1.7269375E-02
     +,   1.7871955E-02,   1.8481839E-02,   1.9095274E-02
     +,   1.9708093E-02,   2.0315848E-02,   2.0913780E-02
     +,   2.1496836E-02,   2.2059880E-02,   2.2597628E-02
     +,   2.3104900E-02,   2.3576599E-02,   2.4007956E-02
     +,   2.4394574E-02,   2.4732657E-02,   2.5019044E-02
     +,   2.5251467E-02,   2.5428582E-02,   2.5550133E-02
     +,   2.5617003E-02,   2.5631350E-02,   2.5596598E-02
     +,   2.5517451E-02,   2.5399875E-02,   2.5251057E-02
     +,   2.5079263E-02,   2.4893746E-02,   2.4704535E-02
     +,   2.4522280E-02,   2.4357952E-02,   2.4222678E-02
     +,   2.4127390E-02,   2.4082586E-02,   2.4098035E-02
     +,   2.4182487E-02,   2.4343394E-02,   2.4586670E-02
     +,   2.4916409E-02,   2.5334785E-02,   2.5841737E-02
     +,   2.6435040E-02,   2.7110064E-02,   2.7859926E-02
     +,   2.8675420E-02,   2.9545315E-02,   3.0456338E-02
     +,   3.1393670E-02,   3.2341201E-02,   3.3281870E-02
     +,   3.4198221E-02,   3.5072926E-02,   3.5889320E-02
     +,   3.6631823E-02,   3.7286732E-02,   3.7842538E-02
     +,   3.8290534E-02,   3.8625203E-02,   3.8844537E-02
     +,   3.8950253E-02,   3.8947944E-02,   3.8846999E-02
     +,   3.8660545E-02,   3.8404983E-02,   3.8099725E-02
     +,   3.7766553E-02,   3.7428934E-02,   3.7111327E-02
     +,   3.6838256E-02,   3.6633503E-02,   3.6519263E-02
     +,   3.6515199E-02,   3.6637742E-02,   3.6899380E-02
     +,   3.7308153E-02,   3.7867296E-02,   3.8575005E-02
     +,   3.9424647E-02,   4.0404975E-02,   4.1500591E-02
     +,   4.2692713E-02,   4.3960102E-02,   4.5280062E-02
     +,   4.6629332E-02,   4.7985259E-02,   4.9326885E-02
     +,   5.0635606E-02,   5.1895734E-02,   5.3095113E-02
     +,   5.4225054E-02,   5.5280209E-02,   5.6258127E-02
     +,   5.7158805E-02,   5.7983808E-02,   5.8735378E-02
     +,   5.9415769E-02,   6.0026489E-02,   6.0567699E-02
     +,   6.1037827E-02,   6.1433535E-02,   6.1749771E-02
     +,   6.1980106E-02,   6.2117379E-02,   6.2154330E-02
     +,   6.2084295E-02,   6.1902102E-02,   6.1604735E-02
     +,   6.1191846E-02,   6.0666200E-02,   6.0033884E-02
     +,   5.9304241E-02,   5.8489494E-02,   5.7604343E-02
     +,   5.6665253E-02,   5.5689726E-02,   5.4695185E-02
     +,   5.3698223E-02,   5.2713800E-02,   5.1754221E-02
     +,   5.0828733E-02,   4.9943000E-02,   4.9098864E-02
     +,   4.8294310E-02,   4.7523692E-02,   4.6778180E-02
     +,   4.6046309E-02,   4.5314625E-02,   4.4568531E-02
     +,   4.3793127E-02,   4.2974010E-02,   4.2097956E-02
     +,   4.1153610E-02,   4.0132124E-02,   3.9027341E-02
     +,   3.7836097E-02,   3.6558393E-02,   3.5197247E-02
     +,   3.3758380E-02,   3.2250013E-02,   3.0682582E-02
     +,   2.9068131E-02,   2.7419845E-02,   2.5751563E-02
     +,   2.4077501E-02,   2.2411665E-02,   2.0767394E-02
     +,   1.9157130E-02,   1.7592318E-02,   1.6082894E-02
     +,   1.4637309E-02,   1.3262562E-02,   1.1964065E-02
     +,   1.0745599E-02,   9.6094785E-03,   8.5567292E-03
     +,   7.5871325E-03,   6.6993078E-03,   5.8909534E-03
     +,   5.1590432E-03,   4.4999286E-03,   3.9094482E-03
     +,   3.3831291E-03,   2.9163486E-03,   2.5043511E-03
     +,   2.1424023E-03,   1.8258877E-03,   1.5503489E-03
     +,   1.3115202E-03,   1.1053899E-03,   9.2823390E-04
     +,   7.7661243E-04,   6.4736878E-04,   5.3764042E-04
     +,   4.4485531E-04,   3.6671138E-04,   3.0115619E-04
     +,   2.4637810E-04,   2.0079021E-04,   1.6300078E-04
     +,   1.3180096E-04,   1.0614728E-04,   8.5141161E-05
     +,   6.8011555E-05,   5.4101522E-05,   4.2854652E-05
     +,   3.3800738E-05,   2.6543963E-05,   2.0753367E-05
     +,   1.6153803E-05,   1.2517117E-05,   9.6549902E-06
     +,   7.4129739E-06,   5.6651725E-06,   4.3091459E-06
     +,   3.2621519E-06,   2.4577587E-06,   1.8428250E-06
     +,   1.3750534E-06,   1.0210036E-06,   7.5439391E-07
     +,   5.5465625E-07,   4.0577802E-07,   2.9537722E-07
     +,   2.1393566E-07,   1.5417078E-07,   1.1054045E-07
     +,   7.8854491E-08,   5.5965454E-08,   3.9517555E-08
     +,   2.7760290E-08,   1.9400856E-08,   1.3488997E-08
     +,   9.3301651E-09,   6.4200680E-09,   4.3947157E-09
     +,   2.9926990E-09,   2.0273372E-09,   1.3661874E-09
     +,   9.1584834E-10,   6.1073080E-10,   4.0513237E-10
     +,   2.6733135E-10,   1.7547569E-10,   1.1457323E-10
     +,   7.4414586E-11,   4.8075689E-11,   3.0895560E-11
     +,   1.9749397E-11,   1.2557683E-11,   7.9424601E-12
     +,   4.9966611E-12,   3.1267762E-12,   1.9462062E-12
     +,   1.2049504E-12,   7.4203041E-13,   4.5452528E-13
     +,   2.7692573E-13,   1.6782245E-13,   1.0115820E-13
     +,   6.0650120E-14,   3.6168012E-14,   2.1453286E-14
     +,   1.2656799E-14,   7.4272338E-15
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_haonly_hatt107_mass = Yx/1.48381124137931
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_haonly_hatt110_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.7893448E-03,   1.8183378E-03
     +,   1.8470983E-03,   1.8757221E-03,   1.9043321E-03
     +,   1.9330835E-03,   1.9621667E-03,   1.9918110E-03
     +,   2.0222892E-03,   2.0539223E-03,   2.0870811E-03
     +,   2.1221938E-03,   2.1597461E-03,   2.2002875E-03
     +,   2.2444332E-03,   2.2928668E-03,   2.3463410E-03
     +,   2.4056793E-03,   2.4717757E-03,   2.5455926E-03
     +,   2.6281571E-03,   2.7205572E-03,   2.8239316E-03
     +,   2.9394708E-03,   3.0683856E-03,   3.2119197E-03
     +,   3.3713130E-03,   3.5477921E-03,   3.7425493E-03
     +,   3.9567174E-03,   4.1913479E-03,   4.4473801E-03
     +,   4.7256178E-03,   5.0266967E-03,   5.3510568E-03
     +,   5.6989156E-03,   6.0702362E-03,   6.4647016E-03
     +,   6.8817232E-03,   7.3203496E-03,   7.7793528E-03
     +,   8.2571423E-03,   8.7518152E-03,   9.2611406E-03
     +,   9.7825993E-03,   1.0313412E-02,   1.0850575E-02
     +,   1.1390923E-02,   1.1931184E-02,   1.2468072E-02
     +,   1.2998352E-02,   1.3518942E-02,   1.4027001E-02
     +,   1.4520077E-02,   1.4996104E-02,   1.5453612E-02
     +,   1.5891736E-02,   1.6310334E-02,   1.6710004E-02
     +,   1.7092157E-02,   1.7459007E-02,   1.7813563E-02
     +,   1.8159544E-02,   1.8501364E-02,   1.8843958E-02
     +,   1.9192632E-02,   1.9552950E-02,   1.9930428E-02
     +,   2.0330440E-02,   2.0757874E-02,   2.1217022E-02
     +,   2.1711234E-02,   2.2242881E-02,   2.2813028E-02
     +,   2.3421464E-02,   2.4066592E-02,   2.4745366E-02
     +,   2.5453418E-02,   2.6185179E-02,   2.6934084E-02
     +,   2.7692705E-02,   2.8453199E-02,   2.9207444E-02
     +,   2.9947573E-02,   3.0666059E-02,   3.1356275E-02
     +,   3.2012492E-02,   3.2630328E-02,   3.3206660E-02
     +,   3.3739839E-02,   3.4229618E-02,   3.4676939E-02
     +,   3.5083845E-02,   3.5453249E-02,   3.5788611E-02
     +,   3.6093544E-02,   3.6371689E-02,   3.6626242E-02
     +,   3.6859833E-02,   3.7074316E-02,   3.7270695E-02
     +,   3.7449028E-02,   3.7608612E-02,   3.7748016E-02
     +,   3.7865352E-02,   3.7958473E-02,   3.8025290E-02
     +,   3.8063996E-02,   3.8073361E-02,   3.8052905E-02
     +,   3.8003039E-02,   3.7925139E-02,   3.7821598E-02
     +,   3.7695628E-02,   3.7551213E-02,   3.7392873E-02
     +,   3.7225377E-02,   3.7053503E-02,   3.6881790E-02
     +,   3.6714230E-02,   3.6554143E-02,   3.6403969E-02
     +,   3.6265217E-02,   3.6138527E-02,   3.6023639E-02
     +,   3.5919730E-02,   3.5825465E-02,   3.5739444E-02
     +,   3.5660446E-02,   3.5587765E-02,   3.5521526E-02
     +,   3.5462957E-02,   3.5414606E-02,   3.5380386E-02
     +,   3.5365649E-02,   3.5377000E-02,   3.5422109E-02
     +,   3.5509303E-02,   3.5647128E-02,   3.5843838E-02
     +,   3.6106803E-02,   3.6441844E-02,   3.6852840E-02
     +,   3.7341133E-02,   3.7905131E-02,   3.8540177E-02
     +,   3.9238382E-02,   3.9988786E-02,   4.0777534E-02
     +,   4.1588485E-02,   4.2403672E-02,   4.3203924E-02
     +,   4.3969724E-02,   4.4681944E-02,   4.5322690E-02
     +,   4.5875788E-02,   4.6327583E-02,   4.6667378E-02
     +,   4.6887815E-02,   4.6984997E-02,   4.6958655E-02
     +,   4.6812046E-02,   4.6551794E-02,   4.6187568E-02
     +,   4.5731757E-02,   4.5198988E-02,   4.4605691E-02
     +,   4.3969601E-02,   4.3309130E-02,   4.2642836E-02
     +,   4.1988973E-02,   4.1364789E-02,   4.0786013E-02
     +,   4.0266290E-02,   3.9816778E-02,   3.9445590E-02
     +,   3.9157469E-02,   3.8953524E-02,   3.8831044E-02
     +,   3.8783439E-02,   3.8800422E-02,   3.8868267E-02
     +,   3.8970191E-02,   3.9086994E-02,   3.9197709E-02
     +,   3.9280377E-02,   3.9312936E-02,   3.9274022E-02
     +,   3.9143886E-02,   3.8905069E-02,   3.8543098E-02
     +,   3.8047045E-02,   3.7409879E-02,   3.6628664E-02
     +,   3.5704497E-02,   3.4642458E-02,   3.3451296E-02
     +,   3.2142997E-02,   3.0732136E-02,   2.9235337E-02
     +,   2.7670741E-02,   2.6057269E-02,   2.4413910E-02
     +,   2.2759214E-02,   2.1110993E-02,   1.9485570E-02
     +,   1.7897628E-02,   1.6360059E-02,   1.4883763E-02
     +,   1.3477464E-02,   1.2147866E-02,   1.0899806E-02
     +,   9.7362921E-03,   8.6586075E-03,   7.6665990E-03
     +,   6.7589348E-03,   5.9332377E-03,   5.1862430E-03
     +,   4.5140525E-03,   3.9123739E-03,   3.3765298E-03
     +,   2.9016852E-03,   2.4829761E-03,   2.1155681E-03
     +,   1.7947159E-03,   1.5158547E-03,   1.2746586E-03
     +,   1.0670476E-03,   8.8920124E-04,   7.3758815E-04
     +,   6.0897722E-04,   5.0042232E-04,   4.0925175E-04
     +,   3.3306752E-04,   2.6973707E-04,   2.1736335E-04
     +,   1.7427730E-04,   1.3902161E-04,   1.1032927E-04
     +,   8.7104505E-05,   6.8408081E-05,   5.3441010E-05
     +,   4.1526702E-05,   3.2095562E-05,   2.4672203E-05
     +,   1.8862742E-05,   1.4342547E-05,   1.0845658E-05
     +,   8.1560256E-06,   6.0994689E-06,   4.5361012E-06
     +,   3.3545803E-06,   2.4669182E-06,   1.8039742E-06
     +,   1.3117605E-06,   9.4845581E-07,   6.8189496E-07
     +,   4.8748063E-07,   3.4651890E-07,   2.4491703E-07
     +,   1.7212157E-07,   1.2027574E-07,   8.3568125E-08
     +,   5.7731899E-08,   3.9656349E-08,   2.7084745E-08
     +,   1.8392692E-08,   1.2418788E-08,   8.3374090E-09
     +,   5.5653815E-09,   3.6937235E-09,   2.4375078E-09
     +,   1.5993523E-09,   1.0434085E-09,   6.7681316E-10
     +,   4.3651696E-10,   2.7992333E-10,   1.7848208E-10
     +,   1.1315037E-10,   7.1324190E-11,   4.4701635E-11
     +,   2.7856760E-11,   1.7260141E-11,   1.0633591E-11
     +,   6.5136637E-12,   3.9672870E-12,   2.4026009E-12
     +,   1.4467132E-12,   8.6619470E-13,   5.1566650E-13
     +,   3.0525587E-13,   1.7967752E-13,   1.0516848E-13
     +,   6.1212754E-14,   3.5432571E-14,   2.0398054E-14
     +,   1.1680706E-14,   6.6543662E-15,   3.7725230E-15
     +,   2.1291200E-15,   1.1969562E-15
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_haonly_hatt110_mass = Yx/1.3372195
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_haonly_hatt115_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  5.2452134E-03,   5.4443991E-03
     +,   5.6428565E-03,   5.8400701E-03,   6.0355440E-03
     +,   6.2288106E-03,   6.4194356E-03,   6.6070296E-03
     +,   6.7912540E-03,   6.9718393E-03,   7.1485792E-03
     +,   7.3213493E-03,   7.4901078E-03,   7.6549100E-03
     +,   7.8159058E-03,   7.9733515E-03,   8.1276074E-03
     +,   8.2791457E-03,   8.4285382E-03,   8.5764732E-03
     +,   8.7237358E-03,   8.8712098E-03,   9.0198657E-03
     +,   9.1707669E-03,   9.3250275E-03,   9.4838347E-03
     +,   9.6484106E-03,   9.8200049E-03,   9.9998815E-03
     +,   1.0189298E-02,   1.0389484E-02,   1.0601636E-02
     +,   1.0826881E-02,   1.1066280E-02,   1.1320801E-02
     +,   1.1591306E-02,   1.1878530E-02,   1.2183086E-02
     +,   1.2505444E-02,   1.2845902E-02,   1.3204625E-02
     +,   1.3581593E-02,   1.3976621E-02,   1.4389347E-02
     +,   1.4819228E-02,   1.5265558E-02,   1.5727431E-02
     +,   1.6203782E-02,   1.6693369E-02,   1.7194774E-02
     +,   1.7706422E-02,   1.8226575E-02,   1.8753340E-02
     +,   1.9284718E-02,   1.9818524E-02,   2.0352507E-02
     +,   2.0884309E-02,   2.1411473E-02,   2.1931529E-02
     +,   2.2441925E-02,   2.2940146E-02,   2.3423694E-02
     +,   2.3890086E-02,   2.4336969E-02,   2.4762113E-02
     +,   2.5163369E-02,   2.5538845E-02,   2.5886770E-02
     +,   2.6205674E-02,   2.6494263E-02,   2.6751533E-02
     +,   2.6976755E-02,   2.7169464E-02,   2.7329432E-02
     +,   2.7456759E-02,   2.7551755E-02,   2.7614949E-02
     +,   2.7647115E-02,   2.7649216E-02,   2.7622346E-02
     +,   2.7567785E-02,   2.7486878E-02,   2.7381059E-02
     +,   2.7251855E-02,   2.7100803E-02,   2.6929442E-02
     +,   2.6739366E-02,   2.6532115E-02,   2.6309246E-02
     +,   2.6072280E-02,   2.5822714E-02,   2.5562033E-02
     +,   2.5291746E-02,   2.5013313E-02,   2.4728186E-02
     +,   2.4437880E-02,   2.4143877E-02,   2.3847729E-02
     +,   2.3550974E-02,   2.3255233E-02,   2.2962142E-02
     +,   2.2673406E-02,   2.2390766E-02,   2.2116043E-02
     +,   2.1851096E-02,   2.1597834E-02,   2.1358250E-02
     +,   2.1134393E-02,   2.0928338E-02,   2.0742200E-02
     +,   2.0578155E-02,   2.0438386E-02,   2.0325076E-02
     +,   2.0240370E-02,   2.0186381E-02,   2.0165127E-02
     +,   2.0178504E-02,   2.0228244E-02,   2.0315850E-02
     +,   2.0442557E-02,   2.0609284E-02,   2.0816570E-02
     +,   2.1064503E-02,   2.1352733E-02,   2.1680374E-02
     +,   2.2045977E-02,   2.2447594E-02,   2.2882633E-02
     +,   2.3348045E-02,   2.3840213E-02,   2.4355110E-02
     +,   2.4888270E-02,   2.5435016E-02,   2.5990404E-02
     +,   2.6549505E-02,   2.7107410E-02,   2.7659403E-02
     +,   2.8201064E-02,   2.8728476E-02,   2.9238243E-02
     +,   2.9727602E-02,   3.0194484E-02,   3.0637618E-02
     +,   3.1056497E-02,   3.1451292E-02,   3.1822950E-02
     +,   3.2172993E-02,   3.2503448E-02,   3.2816727E-02
     +,   3.3115469E-02,   3.3402406E-02,   3.3680160E-02
     +,   3.3951078E-02,   3.4217138E-02,   3.4479763E-02
     +,   3.4739722E-02,   3.4997057E-02,   3.5251018E-02
     +,   3.5500064E-02,   3.5741821E-02,   3.5973229E-02
     +,   3.6190547E-02,   3.6389489E-02,   3.6565360E-02
     +,   3.6713216E-02,   3.6827996E-02,   3.6904711E-02
     +,   3.6938637E-02,   3.6925405E-02,   3.6861155E-02
     +,   3.6742728E-02,   3.6567677E-02,   3.6334347E-02
     +,   3.6041938E-02,   3.5690516E-02,   3.5280976E-02
     +,   3.4814972E-02,   3.4294914E-02,   3.3723887E-02
     +,   3.3105444E-02,   3.2443576E-02,   3.1742640E-02
     +,   3.1007189E-02,   3.0241841E-02,   2.9451195E-02
     +,   2.8639823E-02,   2.7812097E-02,   2.6972124E-02
     +,   2.6123723E-02,   2.5270471E-02,   2.4415530E-02
     +,   2.3561716E-02,   2.2711555E-02,   2.1867268E-02
     +,   2.1030717E-02,   2.0203475E-02,   1.9386953E-02
     +,   1.8582344E-02,   1.7790630E-02,   1.7012643E-02
     +,   1.6249176E-02,   1.5500940E-02,   1.4768533E-02
     +,   1.4052533E-02,   1.3353562E-02,   1.2672165E-02
     +,   1.2008877E-02,   1.1364275E-02,   1.0738925E-02
     +,   1.0133337E-02,   9.5479963E-03,   8.9833960E-03
     +,   8.4399767E-03,   7.9180878E-03,   7.4180104E-03
     +,   6.9399779E-03,   6.4841309E-03,   6.0504847E-03
     +,   5.6389533E-03,   5.2493876E-03,   4.8814891E-03
     +,   4.5348671E-03,   4.2090490E-03,   3.9034721E-03
     +,   3.6174695E-03,   3.3503063E-03,   3.1012041E-03
     +,   2.8693317E-03,   2.6538088E-03,   2.4537316E-03
     +,   2.2681982E-03,   2.0963051E-03,   1.9371471E-03
     +,   1.7898402E-03,   1.6535427E-03,   1.5274319E-03
     +,   1.4107284E-03,   1.3027024E-03,   1.2026716E-03
     +,   1.1099946E-03,   1.0240802E-03,   9.4439066E-04
     +,   8.7043474E-04,   8.0176094E-04,   7.3796057E-04
     +,   6.7866873E-04,   6.2355580E-04,   5.7232106E-04
     +,   5.2469410E-04,   4.8043448E-04,   4.3932055E-04
     +,   4.0115070E-04,   3.6574324E-04,   3.3293077E-04
     +,   3.0255655E-04,   2.7447453E-04,   2.4855009E-04
     +,   2.2465570E-04,   2.0266918E-04,   1.8247421E-04
     +,   1.6396104E-04,   1.4702437E-04,   1.3156181E-04
     +,   1.1747531E-04,   1.0467180E-04,   9.3060742E-05
     +,   8.2555271E-05,   7.3073083E-05,   6.4535430E-05
     +,   5.6866767E-05,   4.9995433E-05,   4.3854077E-05
     +,   3.8379101E-05,   3.3510310E-05,   2.9191446E-05
     +,   2.5370380E-05,   2.1998141E-05,   1.9029794E-05
     +,   1.6423490E-05,   1.4141071E-05,   1.2147269E-05
     +,   1.0410169E-05,   8.9004934E-06,   7.5919143E-06
     +,   6.4604628E-06,   5.4847342E-06,   4.6454070E-06
     +,   3.9252332E-06,   3.3089084E-06,   2.7827675E-06
     +,   2.3347816E-06,   1.9542847E-06,   1.6319467E-06
     +,   1.3595513E-06,   1.1299578E-06,   9.3691415E-07
     +,   7.7502114E-07,   6.3958470E-07,   5.2657384E-07
     +,   4.3250506E-07,   3.5440448E-07
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_haonly_hatt115_mass = Yx/1.1383737037037
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_haonly_hatt120_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.7784432E-03,   3.9593396E-03
     +,   4.1561681E-03,   4.3696500E-03,   4.6004467E-03
     +,   4.8491550E-03,   5.1162853E-03,   5.4022572E-03
     +,   5.7073738E-03,   6.0318294E-03,   6.3756718E-03
     +,   6.7388047E-03,   7.1209683E-03,   7.5217392E-03
     +,   7.9405094E-03,   8.3764903E-03,   8.8286977E-03
     +,   9.2959590E-03,   9.7769052E-03,   1.0269982E-02
     +,   1.0773445E-02,   1.1285387E-02,   1.1803726E-02
     +,   1.2326268E-02,   1.2850644E-02,   1.3374440E-02
     +,   1.3895137E-02,   1.4410167E-02,   1.4916967E-02
     +,   1.5412973E-02,   1.5895680E-02,   1.6362663E-02
     +,   1.6811622E-02,   1.7240399E-02,   1.7647026E-02
     +,   1.8029738E-02,   1.8387018E-02,   1.8717593E-02
     +,   1.9020503E-02,   1.9295027E-02,   1.9540800E-02
     +,   1.9757736E-02,   1.9946059E-02,   2.0106293E-02
     +,   2.0239251E-02,   2.0346019E-02,   2.0427920E-02
     +,   2.0486511E-02,   2.0523533E-02,   2.0540889E-02
     +,   2.0540610E-02,   2.0524792E-02,   2.0495605E-02
     +,   2.0455206E-02,   2.0405736E-02,   2.0349268E-02
     +,   2.0287773E-02,   2.0223107E-02,   2.0156967E-02
     +,   2.0090887E-02,   2.0026218E-02,   1.9964108E-02
     +,   1.9905524E-02,   1.9851230E-02,   1.9801809E-02
     +,   1.9757669E-02,   1.9719085E-02,   1.9686183E-02
     +,   1.9658994E-02,   1.9637479E-02,   1.9621545E-02
     +,   1.9611089E-02,   1.9606005E-02,   1.9606238E-02
     +,   1.9611785E-02,   1.9622713E-02,   1.9639166E-02
     +,   1.9661399E-02,   1.9689757E-02,   1.9724669E-02
     +,   1.9766642E-02,   1.9816238E-02,   1.9874072E-02
     +,   1.9940767E-02,   2.0016933E-02,   2.0103138E-02
     +,   2.0199856E-02,   2.0307496E-02,   2.0426290E-02
     +,   2.0556331E-02,   2.0697536E-02,   2.0849602E-02
     +,   2.1012016E-02,   2.1184042E-02,   2.1364743E-02
     +,   2.1552911E-02,   2.1747187E-02,   2.1945953E-02
     +,   2.2147447E-02,   2.2349736E-02,   2.2550745E-02
     +,   2.2748282E-02,   2.2940077E-02,   2.3123795E-02
     +,   2.3297068E-02,   2.3457529E-02,   2.3602806E-02
     +,   2.3730583E-02,   2.3838593E-02,   2.3924664E-02
     +,   2.3986695E-02,   2.4022734E-02,   2.4030928E-02
     +,   2.4009587E-02,   2.3957174E-02,   2.3872327E-02
     +,   2.3753891E-02,   2.3600895E-02,   2.3412593E-02
     +,   2.3188481E-02,   2.2928292E-02,   2.2632033E-02
     +,   2.2299992E-02,   2.1932725E-02,   2.1531092E-02
     +,   2.1096267E-02,   2.0629704E-02,   2.0133205E-02
     +,   1.9608811E-02,   1.9058920E-02,   1.8486153E-02
     +,   1.7893439E-02,   1.7283887E-02,   1.6660882E-02
     +,   1.6027935E-02,   1.5388696E-02,   1.4746959E-02
     +,   1.4106589E-02,   1.3471433E-02,   1.2845317E-02
     +,   1.2232055E-02,   1.1635358E-02,   1.1058759E-02
     +,   1.0505619E-02,   9.9791493E-03,   9.4822655E-03
     +,   9.0176268E-03,   8.5876416E-03,   8.1944130E-03
     +,   7.8397049E-03,   7.5249649E-03,   7.2513404E-03
     +,   7.0196455E-03,   6.8303607E-03,   6.6836555E-03
     +,   6.5794070E-03,   6.5171933E-03,   6.4963074E-03
     +,   6.5157870E-03,   6.5744114E-03,   6.6707390E-03
     +,   6.8031130E-03,   6.9696726E-03,   7.1683736E-03
     +,   7.3970202E-03,   7.6532732E-03,   7.9346523E-03
     +,   8.2385484E-03,   8.5622855E-03,   8.9031048E-03
     +,   9.2581483E-03,   9.6245166E-03,   9.9992901E-03
     +,   1.0379531E-02,   1.0762256E-02,   1.1144531E-02
     +,   1.1523452E-02,   1.1896126E-02,   1.2259725E-02
     +,   1.2611524E-02,   1.2948883E-02,   1.3269258E-02
     +,   1.3570230E-02,   1.3849543E-02,   1.4105108E-02
     +,   1.4334978E-02,   1.4537404E-02,   1.4710854E-02
     +,   1.4854004E-02,   1.4965733E-02,   1.5045168E-02
     +,   1.5091666E-02,   1.5104817E-02,   1.5084455E-02
     +,   1.5030650E-02,   1.4943711E-02,   1.4824174E-02
     +,   1.4672805E-02,   1.4490571E-02,   1.4278635E-02
     +,   1.4038365E-02,   1.3771296E-02,   1.3479105E-02
     +,   1.3163596E-02,   1.2826727E-02,   1.2470517E-02
     +,   1.2097056E-02,   1.1708515E-02,   1.1307102E-02
     +,   1.0895004E-02,   1.0474413E-02,   1.0047505E-02
     +,   9.6164308E-03,   9.1832355E-03,   8.7498995E-03
     +,   8.3183348E-03,   7.8903502E-03,   7.4676182E-03
     +,   7.0516826E-03,   6.6440017E-03,   6.2458580E-03
     +,   5.8583980E-03,   5.4826522E-03,   5.1195114E-03
     +,   4.7697006E-03,   4.4338130E-03,   4.1123307E-03
     +,   3.8056097E-03,   3.5138612E-03,   3.2371874E-03
     +,   2.9756022E-03,   2.7290203E-03,   2.4972511E-03
     +,   2.2800248E-03,   2.0770237E-03,   1.8878445E-03
     +,   1.7120339E-03,   1.5491056E-03,   1.3985351E-03
     +,   1.2597605E-03,   1.1321997E-03,   1.0152654E-03
     +,   9.0836280E-04,   8.1088714E-04,   7.2223891E-04
     +,   6.4183318E-04,   5.6909636E-04,   5.0346571E-04
     +,   4.4439832E-04,   3.9137821E-04,   3.4390672E-04
     +,   3.0151044E-04,   2.6374435E-04,   2.3018922E-04
     +,   2.0044974E-04,   1.7415767E-04,   1.5097253E-04
     +,   1.3057898E-04,   1.1268509E-04,   9.7023098E-05
     +,   8.3349099E-05,   7.1440743E-05,   6.1095285E-05
     +,   5.2129519E-05,   4.4379074E-05,   3.7695419E-05
     +,   3.1945696E-05,   2.7011673E-05,   2.2788101E-05
     +,   1.9181369E-05,   1.6108805E-05,   1.3497745E-05
     +,   1.1284326E-05,   9.4124744E-06,   7.8332669E-06
     +,   6.5042573E-06,   5.3884387E-06,   4.4539288E-06
     +,   3.6731035E-06,   3.0223016E-06,   2.4811413E-06
     +,   2.0322607E-06,   1.6607939E-06,   1.3541467E-06
     +,   1.1015985E-06,   8.9411685E-07,   7.2406107E-07
     +,   5.8500933E-07,   4.7158815E-07,   3.7928791E-07
     +,   3.0435976E-07,   2.4367486E-07,   1.9464609E-07
     +,   1.5512632E-07,   1.2334915E-07,   9.7856812E-08
     +,   7.7456221E-08,   6.1168144E-08,   4.8195250E-08
     +,   3.7886604E-08,   2.9715077E-08
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_haonly_hatt120_mass = Yx/0.838257
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_haonly_hatt60_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.9884385E-02,   2.1619646E-02
     +,   2.3655353E-02,   2.6028981E-02,   2.8774409E-02
     +,   3.1919349E-02,   3.5482910E-02,   3.9474178E-02
     +,   4.3893013E-02,   4.8735015E-02,   5.4001406E-02
     +,   5.9715983E-02,   6.5947525E-02,   7.2835319E-02
     +,   8.0614761E-02,   8.9642055E-02,   0.1004237    
     +,   0.1136635    ,   0.1303383    ,   0.1517905    
     +,   0.1797749    ,   0.2163477    ,   0.2634540    
     +,   0.3221576    ,   0.3916950    ,   0.4690393    
     +,   0.5498518    ,   0.6314256    ,   0.7170292    
     +,   0.8189590    ,   0.9551635    ,    1.139311    
     +,    1.381656    ,    1.707683    ,    2.137159    
     +,    2.620059    ,    3.059940    ,    3.392300    
     +,    3.680794    ,    4.086640    ,    4.571724    
     +,    4.882149    ,    4.833452    ,    4.558397    
     +,    4.285841    ,    4.087521    ,    3.867202    
     +,    3.524384    ,    3.128605    ,    2.732232    
     +,    2.331975    ,    1.968317    ,    1.668274    
     +,    1.423988    ,    1.231837    ,    1.088633    
     +,   0.9770281    ,   0.8798313    ,   0.7916201    
     +,   0.7136353    ,   0.6462065    ,   0.5868010    
     +,   0.5320461    ,   0.4799678    ,   0.4304397    
     +,   0.3842251    ,   0.3419739    ,   0.3039130    
     +,   0.2699810    ,   0.2400202    ,   0.2138136    
     +,   0.1910539    ,   0.1713210    ,   0.1541319    
     +,   0.1390178    ,   0.1255999    ,   0.1136250    
     +,   0.1029576    ,   9.3540892E-02,   8.5350178E-02
     +,   7.8352824E-02,   7.2481371E-02,   6.7627355E-02
     +,   6.3645206E-02,   6.0367428E-02,   5.7619818E-02
     +,   5.5237874E-02,   5.3077731E-02,   5.1024098E-02
     +,   4.8992656E-02,   4.6929564E-02,   4.4808418E-02
     +,   4.2625129E-02,   4.0392350E-02,   3.8133942E-02
     +,   3.5880078E-02,   3.3662502E-02,   3.1511627E-02
     +,   2.9453639E-02,   2.7509568E-02,   2.5694055E-02
     +,   2.4015868E-02,   2.2477904E-02,   2.1078413E-02
     +,   1.9811580E-02,   1.8668745E-02,   1.7639432E-02
     +,   1.6712120E-02,   1.5874950E-02,   1.5116343E-02
     +,   1.4425505E-02,   1.3792501E-02,   1.3208611E-02
     +,   1.2666195E-02,   1.2158833E-02,   1.1681102E-02
     +,   1.1228611E-02,   1.0797746E-02,   1.0385680E-02
     +,   9.9901306E-03,   9.6093137E-03,   9.2418585E-03
     +,   8.8867042E-03,   8.5430024E-03,   8.2100844E-03
     +,   7.8874538E-03,   7.5746723E-03,   7.2714197E-03
     +,   6.9773905E-03,   6.6923564E-03,   6.4160861E-03
     +,   6.1484138E-03,   5.8891536E-03,   5.6381687E-03
     +,   5.3953179E-03,   5.1604672E-03,   4.9335114E-03
     +,   4.7143479E-03,   4.5028664E-03,   4.2989575E-03
     +,   4.1025253E-03,   3.9134696E-03,   3.7316710E-03
     +,   3.5570031E-03,   3.3893469E-03,   3.2285536E-03
     +,   3.0744644E-03,   2.9269163E-03,   2.7857360E-03
     +,   2.6507247E-03,   2.5216786E-03,   2.3983882E-03
     +,   2.2806411E-03,   2.1682081E-03,   2.0608578E-03
     +,   1.9583672E-03,   1.8605121E-03,   1.7670642E-03
     +,   1.6778030E-03,   1.5925217E-03,   1.5110149E-03
     +,   1.4330853E-03,   1.3585528E-03,   1.2872473E-03
     +,   1.2190057E-03,   1.1536770E-03,   1.0911261E-03
     +,   1.0312292E-03,   9.7386882E-04,   9.1893901E-04
     +,   8.6634560E-04,   8.1600394E-04,   7.6783361E-04
     +,   7.2176103E-04,   6.7772361E-04,   6.3565886E-04
     +,   5.9550890E-04,   5.5722205E-04,   5.2074919E-04
     +,   4.8604049E-04,   4.5304798E-04,   4.2172661E-04
     +,   3.9203165E-04,   3.6391639E-04,   3.3733435E-04
     +,   3.1224010E-04,   2.8858759E-04,   2.6632860E-04
     +,   2.4541441E-04,   2.2579762E-04,   2.0742830E-04
     +,   1.9025599E-04,   1.7423135E-04,   1.5930449E-04
     +,   1.4542442E-04,   1.3254062E-04,   1.2060362E-04
     +,   1.0956432E-04,   9.9373603E-05,   8.9983238E-05
     +,   8.1346639E-05,   7.3418283E-05,   6.6153341E-05
     +,   5.9508497E-05,   5.3442505E-05,   4.7915095E-05
     +,   4.2887685E-05,   3.8323720E-05,   3.4188353E-05
     +,   3.0448173E-05,   2.7071625E-05,   2.4029148E-05
     +,   2.1292863E-05,   1.8836459E-05,   1.6635327E-05
     +,   1.4666672E-05,   1.2909258E-05,   1.1343262E-05
     +,   9.9503841E-06,   8.7138469E-06,   7.6180854E-06
     +,   6.6488360E-06,   5.7930984E-06,   5.0389881E-06
     +,   4.3756299E-06,   3.7931566E-06,   3.2826572E-06
     +,   2.8360678E-06,   2.4460880E-06,   2.1061510E-06
     +,   1.8103852E-06,   1.5535256E-06,   1.3308518E-06
     +,   1.1381582E-06,   9.7171949E-07,   8.2821481E-07
     +,   7.0470378E-07,   5.9859491E-07,   5.0760428E-07
     +,   4.2971527E-07,   3.6315944E-07,   3.0639171E-07
     +,   2.5806074E-07,   2.1698517E-07,   1.8213720E-07
     +,   1.5262658E-07,   1.2768132E-07,   1.0663192E-07
     +,   8.8901160E-08,   7.3993391E-08,   6.1481074E-08
     +,   5.0997642E-08,   4.2230027E-08,   3.4910652E-08
     +,   2.8810923E-08,   2.3736478E-08,   1.9522627E-08
     +,   1.6029695E-08,   1.3139375E-08,   1.0751878E-08
     +,   8.7832630E-09,   7.1629689E-09,   5.8316645E-09
     +,   4.7397055E-09,   3.8457020E-09,   3.1150298E-09
     +,   2.5188851E-09,   2.0333693E-09,   1.6386638E-09
     +,   1.3183336E-09,   1.0588151E-09,   8.4893936E-10
     +,   6.7951428E-10,   5.4297900E-10,   4.3313758E-10
     +,   3.4493230E-10,   2.7422117E-10,   2.1763731E-10
     +,   1.7243451E-10,   1.3638922E-10,   1.0769474E-10
     +,   8.4893571E-11,   6.6805540E-11,   5.2482754E-11
     +,   4.1160221E-11,   3.2225861E-11,   2.5187978E-11
     +,   1.9653503E-11,   1.5309207E-11,   1.1904806E-11
     +,   9.2418295E-12,   7.1622781E-12,   5.5412649E-12
     +,   4.2798157E-12,   3.2999410E-12,   2.5400691E-12
     +,   1.9518627E-12,   1.4973085E-12,   1.1466695E-12
     +,   8.7664278E-13,   6.6907059E-13
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_haonly_hatt60_mass = Yx/21.235844
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_haonly_hatt65_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  6.9835801E-03,   7.3042852E-03
     +,   7.6423693E-03,   8.0014504E-03,   8.3855987E-03
     +,   8.7992633E-03,   9.2471708E-03,   9.7341891E-03
     +,   1.0265144E-02,   1.0844662E-02,   1.1476900E-02
     +,   1.2165349E-02,   1.2912586E-02,   1.3720081E-02
     +,   1.4588016E-02,   1.5515204E-02,   1.6499091E-02
     +,   1.7535919E-02,   1.8621065E-02,   1.9749651E-02
     +,   2.0917406E-02,   2.2121971E-02,   2.3364490E-02
     +,   2.4651852E-02,   2.5999058E-02,   2.7432511E-02
     +,   2.8993202E-02,   3.0740481E-02,   3.2755680E-02
     +,   3.5145372E-02,   3.8043708E-02,   4.1612685E-02
     +,   4.6038885E-02,   5.1524792E-02,   5.8272805E-02
     +,   6.6461146E-02,   7.6213852E-02,   8.7571107E-02
     +,   0.1004753    ,   0.1147892    ,   0.1303838    
     +,   0.1473106    ,   0.1660614    ,   0.1878373    
     +,   0.2146644    ,   0.2491594    ,   0.2939052    
     +,   0.3508141    ,   0.4216160    ,   0.5115194    
     +,   0.6362683    ,   0.8226510    ,    1.085829    
     +,    1.401051    ,    1.730921    ,    2.082872    
     +,    2.454731    ,    2.756970    ,    2.945386    
     +,    3.134023    ,    3.422108    ,    3.760321    
     +,    4.090774    ,    4.427446    ,    4.609021    
     +,    4.461370    ,    4.083943    ,    3.539184    
     +,    2.912275    ,    2.383727    ,    2.019266    
     +,    1.743859    ,    1.511950    ,    1.326668    
     +,    1.171694    ,    1.029766    ,   0.9017524    
     +,   0.7903283    ,   0.6925447    ,   0.6053291    
     +,   0.5285844    ,   0.4635401    ,   0.4106572    
     +,   0.3688972    ,   0.3361328    ,   0.3099507    
     +,   0.2882848    ,   0.2695730    ,   0.2526439    
     +,   0.2366017    ,   0.2208324    ,   0.2050546    
     +,   0.1893109    ,   0.1738735    ,   0.1591047    
     +,   0.1453281    ,   0.1327458    ,   0.1214198    
     +,   0.1112910    ,   0.1022268    ,   9.4065189E-02
     +,   8.6653307E-02,   7.9866461E-02,   7.3616832E-02
     +,   6.7848392E-02,   6.2528417E-02,   5.7637252E-02
     +,   5.3158782E-02,   4.9073908E-02,   4.5357857E-02
     +,   4.1980151E-02,   3.8905472E-02,   3.6096856E-02
     +,   3.3517744E-02,   3.1134861E-02,   2.8919151E-02
     +,   2.6847243E-02,   2.4900986E-02,   2.3067636E-02
     +,   2.1338675E-02,   1.9709138E-02,   1.8176738E-02
     +,   1.6740825E-02,   1.5401527E-02,   1.4159169E-02
     +,   1.3013880E-02,   1.1964960E-02,   1.1010975E-02
     +,   1.0149371E-02,   9.3767568E-03,   8.6887525E-03
     +,   8.0803204E-03,   7.5457697E-03,   7.0790839E-03
     +,   6.6739642E-03,   6.3240579E-03,   6.0231187E-03
     +,   5.7650902E-03,   5.5441912E-03,   5.3550084E-03
     +,   5.1925518E-03,   5.0522699E-03,   4.9300594E-03
     +,   4.8222686E-03,   4.7257058E-03,   4.6375920E-03
     +,   4.5555546E-03,   4.4775996E-03,   4.4020838E-03
     +,   4.3276697E-03,   4.2533078E-03,   4.1782046E-03
     +,   4.1017942E-03,   4.0237019E-03,   3.9437218E-03
     +,   3.8617980E-03,   3.7779971E-03,   3.6924791E-03
     +,   3.6054864E-03,   3.5173278E-03,   3.4283532E-03
     +,   3.3389393E-03,   3.2494883E-03,   3.1604066E-03
     +,   3.0720884E-03,   2.9849166E-03,   2.8992570E-03
     +,   2.8154468E-03,   2.7337866E-03,   2.6545397E-03
     +,   2.5779365E-03,   2.5041664E-03,   2.4333724E-03
     +,   2.3656569E-03,   2.3010904E-03,   2.2396962E-03
     +,   2.1814636E-03,   2.1263519E-03,   2.0742894E-03
     +,   2.0251730E-03,   1.9788779E-03,   1.9352603E-03
     +,   1.8941602E-03,   1.8554012E-03,   1.8187981E-03
     +,   1.7841607E-03,   1.7512949E-03,   1.7200041E-03
     +,   1.6900934E-03,   1.6613747E-03,   1.6336633E-03
     +,   1.6067820E-03,   1.5805654E-03,   1.5548577E-03
     +,   1.5295134E-03,   1.5043986E-03,   1.4793945E-03
     +,   1.4543943E-03,   1.4293033E-03,   1.4040394E-03
     +,   1.3785346E-03,   1.3527338E-03,   1.3265919E-03
     +,   1.3000747E-03,   1.2731625E-03,   1.2458418E-03
     +,   1.2181097E-03,   1.1899729E-03,   1.1614461E-03
     +,   1.1325503E-03,   1.1033118E-03,   1.0737649E-03
     +,   1.0439488E-03,   1.0139052E-03,   9.8367909E-04
     +,   9.5332036E-04,   9.2288113E-04,   8.9241320E-04
     +,   8.6196978E-04,   8.3160709E-04,   8.0137834E-04
     +,   7.7133701E-04,   7.4153685E-04,   7.1203127E-04
     +,   6.8286934E-04,   6.5409881E-04,   6.2576664E-04
     +,   5.9791765E-04,   5.7059224E-04,   5.4382783E-04
     +,   5.1766058E-04,   4.9212365E-04,   4.6724538E-04
     +,   4.4305064E-04,   4.1956364E-04,   3.9680296E-04
     +,   3.7478367E-04,   3.5351960E-04,   3.3302081E-04
     +,   3.1329333E-04,   2.9434008E-04,   2.7616241E-04
     +,   2.5875890E-04,   2.4212437E-04,   2.2625124E-04
     +,   2.1113083E-04,   1.9675214E-04,   1.8310128E-04
     +,   1.7016276E-04,   1.5792069E-04,   1.4635659E-04
     +,   1.3545070E-04,   1.2518295E-04,   1.1553241E-04
     +,   1.0647665E-04,   9.7992757E-05,   9.0058071E-05
     +,   8.2649392E-05,   7.5743010E-05,   6.9315305E-05
     +,   6.3343017E-05,   5.7803176E-05,   5.2672658E-05
     +,   4.7928857E-05,   4.3550055E-05,   3.9514587E-05
     +,   3.5801477E-05,   3.2390642E-05,   2.9262648E-05
     +,   2.6398589E-05,   2.3780369E-05,   2.1390813E-05
     +,   1.9213569E-05,   1.7232893E-05,   1.5433887E-05
     +,   1.3802627E-05,   1.2325754E-05,   1.0990892E-05
     +,   9.7862558E-06,   8.7009466E-06,   7.7246459E-06
     +,   6.8478803E-06,   6.0617017E-06,   5.3579292E-06
     +,   4.7288900E-06,   4.1675830E-06,   3.6674953E-06
     +,   3.2226505E-06,   2.8275997E-06,   2.4773069E-06
     +,   2.1672154E-06,   1.8931290E-06,   1.6512686E-06
     +,   1.4381719E-06,   1.2507259E-06,   1.0860956E-06
     +,   9.4174084E-07,   8.1535853E-07,   7.0489267E-07
     +,   6.0848538E-07,   5.2448593E-07
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_haonly_hatt65_mass = Yx/18.4173566956522
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_haonly_hatt70_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  5.4124868E-03,   5.6711151E-03
     +,   5.9458986E-03,   6.2370664E-03,   6.5445444E-03
     +,   6.8679051E-03,   7.2063357E-03,   7.5586080E-03
     +,   7.9230601E-03,   8.2976185E-03,   8.6797811E-03
     +,   9.0666814E-03,   9.4551370E-03,   9.8417411E-03
     +,   1.0222953E-02,   1.0595233E-02,   1.0955182E-02
     +,   1.1299698E-02,   1.1626148E-02,   1.1932535E-02
     +,   1.2217670E-02,   1.2481328E-02,   1.2724375E-02
     +,   1.2948887E-02,   1.3158169E-02,   1.3356801E-02
     +,   1.3550562E-02,   1.3746293E-02,   1.3951723E-02
     +,   1.4175178E-02,   1.4425265E-02,   1.4710492E-02
     +,   1.5038856E-02,   1.5417460E-02,   1.5852140E-02
     +,   1.6347235E-02,   1.6905496E-02,   1.7528238E-02
     +,   1.8215863E-02,   1.8968603E-02,   1.9787969E-02
     +,   2.0678395E-02,   2.1649424E-02,   2.2718074E-02
     +,   2.3911221E-02,   2.5267445E-02,   2.6837930E-02
     +,   2.8685734E-02,   3.0882796E-02,   3.3504486E-02
     +,   3.6621779E-02,   4.0291980E-02,   4.4550389E-02
     +,   4.9406435E-02,   5.4847758E-02,   6.0860090E-02
     +,   6.7463249E-02,   7.4765362E-02,   8.3025120E-02
     +,   9.2701115E-02,   0.1044572    ,   0.1190943    
     +,   0.1374029    ,   0.1599856    ,   0.1871406    
     +,   0.2188927    ,   0.2551723    ,   0.2959731    
     +,   0.3414714    ,   0.3926653    ,   0.4539588    
     +,   0.5377536    ,   0.6659082    ,   0.8593042    
     +,    1.116627    ,    1.402061    ,    1.669192    
     +,    1.920415    ,    2.221928    ,    2.604573    
     +,    2.999945    ,    3.293650    ,    3.486843    
     +,    3.714580    ,    3.897511    ,    3.926097    
     +,    3.783730    ,    3.436121    ,    2.932923    
     +,    2.396665    ,    1.961243    ,    1.666254    
     +,    1.437708    ,    1.238570    ,    1.074387    
     +,   0.9310319    ,   0.7939472    ,   0.6682644    
     +,   0.5639939    ,   0.4824471    ,   0.4172551    
     +,   0.3614724    ,   0.3117909    ,   0.2680022    
     +,   0.2306552    ,   0.1996697    ,   0.1742369    
     +,   0.1532414    ,   0.1356299    ,   0.1205805    
     +,   0.1075263    ,   9.6103162E-02,   8.6081021E-02
     +,   7.7295668E-02,   6.9606632E-02,   6.2875032E-02
     +,   5.6964021E-02,   5.1744319E-02,   4.7103696E-02
     +,   4.2950355E-02,   3.9213769E-02,   3.5842020E-02
     +,   3.2797366E-02,   3.0051926E-02,   2.7584260E-02
     +,   2.5376856E-02,   2.3413591E-02,   2.1679020E-02
     +,   2.0157089E-02,   1.8831249E-02,   1.7684041E-02
     +,   1.6697636E-02,   1.5853917E-02,   1.5135082E-02
     +,   1.4523830E-02,   1.4003786E-02,   1.3559782E-02
     +,   1.3177965E-02,   1.2845887E-02,   1.2552589E-02
     +,   1.2288561E-02,   1.2045712E-02,   1.1817235E-02
     +,   1.1597569E-02,   1.1382277E-02,   1.1167902E-02
     +,   1.0951868E-02,   1.0732374E-02,   1.0508272E-02
     +,   1.0278941E-02,   1.0044209E-02,   9.8042730E-03
     +,   9.5596109E-03,   9.3109030E-03,   9.0589728E-03
     +,   8.8047702E-03,   8.5493010E-03,   8.2935803E-03
     +,   8.0386242E-03,   7.7854367E-03,   7.5349570E-03
     +,   7.2880583E-03,   7.0455507E-03,   6.8081599E-03
     +,   6.5765018E-03,   6.3510966E-03,   6.1323792E-03
     +,   5.9206779E-03,   5.7162163E-03,   5.5191149E-03
     +,   5.3294231E-03,   5.1470986E-03,   4.9720150E-03
     +,   4.8039737E-03,   4.6427357E-03,   4.4879941E-03
     +,   4.3394002E-03,   4.1965852E-03,   4.0591597E-03
     +,   3.9267107E-03,   3.7988229E-03,   3.6750934E-03
     +,   3.5551295E-03,   3.4385498E-03,   3.3249939E-03
     +,   3.2141388E-03,   3.1056893E-03,   2.9993793E-03
     +,   2.8949748E-03,   2.7922902E-03,   2.6911651E-03
     +,   2.5914726E-03,   2.4931279E-03,   2.3960774E-03
     +,   2.3002906E-03,   2.2057642E-03,   2.1125260E-03
     +,   2.0206228E-03,   1.9301159E-03,   1.8410787E-03
     +,   1.7536038E-03,   1.6677910E-03,   1.5837401E-03
     +,   1.5015535E-03,   1.4213423E-03,   1.3432055E-03
     +,   1.2672399E-03,   1.1935396E-03,   1.1221907E-03
     +,   1.0532659E-03,   9.8682696E-04,   9.2292996E-04
     +,   8.6161826E-04,   8.0291968E-04,   7.4684975E-04
     +,   6.9341628E-04,   6.4261490E-04,   5.9442635E-04
     +,   5.4882077E-04,   5.0576305E-04,   4.6520380E-04
     +,   4.2708564E-04,   3.9134573E-04,   3.5791442E-04
     +,   3.2671363E-04,   2.9766074E-04,   2.7067089E-04
     +,   2.4565592E-04,   2.2252342E-04,   2.0117979E-04
     +,   1.8153212E-04,   1.6348712E-04,   1.4695086E-04
     +,   1.3183086E-04,   1.1803774E-04,   1.0548270E-04
     +,   9.4079740E-05,   8.3746520E-05,   7.4403695E-05
     +,   6.5974695E-05,   5.8386653E-05,   5.1570903E-05
     +,   4.5462410E-05,   3.9999526E-05,   3.5124536E-05
     +,   3.0783725E-05,   2.6927048E-05,   2.3507784E-05
     +,   2.0482754E-05,   1.7812417E-05,   1.5460146E-05
     +,   1.3392411E-05,   1.1578738E-05,   9.9913268E-06
     +,   8.6048449E-06,   7.3963784E-06,   6.3453349E-06
     +,   5.4331472E-06,   4.6431092E-06,   3.9602719E-06
     +,   3.3713418E-06,   2.8644758E-06,   2.4291298E-06
     +,   2.0559751E-06,   1.7368095E-06,   1.4643751E-06
     +,   1.2323000E-06,   1.0350184E-06,   8.6766198E-07
     +,   7.2597669E-07,   6.0626525E-07,   5.0532901E-07
     +,   4.2039824E-07,   3.4907745E-07,   2.8930415E-07
     +,   2.3931318E-07,   1.9758470E-07,   1.6282506E-07
     +,   1.3392656E-07,   1.0995029E-07,   9.0096059E-08
     +,   7.3688952E-08,   6.0156431E-08,   4.9017565E-08
     +,   3.9866393E-08,   3.2363506E-08,   2.6223859E-08
     +,   2.1209374E-08,   1.7122131E-08,   1.3796902E-08
     +,   1.1097055E-08,   8.9090513E-09,   7.1393900E-09
     +,   5.7107385E-09,   4.5596651E-09,   3.6339518E-09
     +,   2.8909439E-09,   2.2956697E-09,   1.8196892E-09
     +,   1.4397891E-09,   1.1371665E-09
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_haonly_hatt70_mass = Yx/15.3245798222222
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_haonly_hatt75_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.7525909E-03,   3.8556601E-03
     +,   3.9588455E-03,   4.0622125E-03,   4.1658431E-03
     +,   4.2698397E-03,   4.3743225E-03,   4.4794306E-03
     +,   4.5853304E-03,   4.6922197E-03,   4.8003206E-03
     +,   4.9098972E-03,   5.0212499E-03,   5.1347278E-03
     +,   5.2507347E-03,   5.3697317E-03,   5.4922504E-03
     +,   5.6188954E-03,   5.7503581E-03,   5.8874232E-03
     +,   6.0309772E-03,   6.1820177E-03,   6.3416632E-03
     +,   6.5111620E-03,   6.6918796E-03,   6.8853251E-03
     +,   7.0931287E-03,   7.3170271E-03,   7.5588617E-03
     +,   7.8205280E-03,   8.1039527E-03,   8.4110275E-03
     +,   8.7435497E-03,   9.1031399E-03,   9.4911465E-03
     +,   9.9085430E-03,   1.0355825E-02,   1.0832887E-02
     +,   1.1338950E-02,   1.1872378E-02,   1.2430722E-02
     +,   1.3010570E-02,   1.3607577E-02,   1.4216488E-02
     +,   1.4831219E-02,   1.5444983E-02,   1.6050505E-02
     +,   1.6640225E-02,   1.7206650E-02,   1.7742636E-02
     +,   1.8241797E-02,   1.8698851E-02,   1.9110028E-02
     +,   1.9473400E-02,   1.9789169E-02,   2.0059975E-02
     +,   2.0290973E-02,   2.0489985E-02,   2.0667473E-02
     +,   2.0836512E-02,   2.1012720E-02,   2.1214293E-02
     +,   2.1462167E-02,   2.1780506E-02,   2.2197561E-02
     +,   2.2746937E-02,   2.3469467E-02,   2.4415053E-02
     +,   2.5644561E-02,   2.7230412E-02,   2.9255673E-02
     +,   3.1809743E-02,   3.4981299E-02,   3.8847093E-02
     +,   4.3460272E-02,   4.8839688E-02,   5.4964982E-02
     +,   6.1784204E-02,   6.9239028E-02,   7.7311836E-02
     +,   8.6097971E-02,   9.5906608E-02,   0.1073698    
     +,   0.1215316    ,   0.1398312    ,   0.1638907    
     +,   0.1950264    ,   0.2336114    ,   0.2786956    
     +,   0.3285146    ,   0.3818289    ,   0.4389063    
     +,   0.5018259    ,   0.5766363    ,   0.6770658    
     +,   0.8245484    ,    1.049472    ,    1.382488    
     +,    1.789142    ,    2.152967    ,    2.434004    
     +,    2.698192    ,    2.932368    ,    3.079256    
     +,    3.095419    ,    2.867702    ,    2.518842    
     +,    2.288213    ,    2.138350    ,    1.949539    
     +,    1.687165    ,    1.393148    ,    1.112169    
     +,   0.8599780    ,   0.6499752    ,   0.4909669    
     +,   0.3785013    ,   0.3009501    ,   0.2467321    
     +,   0.2070879    ,   0.1764554    ,   0.1519798    
     +,   0.1325155    ,   0.1174891    ,   0.1062004    
     +,   9.7723439E-02,   9.1113128E-02,   8.5600302E-02
     +,   8.0651753E-02,   7.5939186E-02,   7.1277268E-02
     +,   6.6573314E-02,   6.1792452E-02,   5.6939650E-02
     +,   5.2047398E-02,   4.7168959E-02,   4.2371828E-02
     +,   3.7730355E-02,   3.3317722E-02,   2.9199090E-02
     +,   2.5426006E-02,   2.2032345E-02,   1.9032916E-02
     +,   1.6424814E-02,   1.4190315E-02,   1.2300201E-02
     +,   1.0718072E-02,   9.4042560E-03,   8.3188051E-03
     +,   7.4238018E-03,   6.6849850E-03,   6.0725454E-03
     +,   5.5612768E-03,   5.1303515E-03,   4.7629373E-03
     +,   4.4456562E-03,   4.1679833E-03,   3.9216988E-03
     +,   3.7004394E-03,   3.4993163E-03,   3.3145577E-03
     +,   3.1432696E-03,   2.9832462E-03,   2.8328020E-03
     +,   2.6906396E-03,   2.5557645E-03,   2.4274227E-03
     +,   2.3050306E-03,   2.1881263E-03,   2.0763450E-03
     +,   1.9693989E-03,   1.8670496E-03,   1.7690904E-03
     +,   1.6753412E-03,   1.5856489E-03,   1.4998650E-03
     +,   1.4178508E-03,   1.3394785E-03,   1.2646255E-03
     +,   1.1931671E-03,   1.1249807E-03,   1.0599516E-03
     +,   9.9796627E-04,   9.3890820E-04,   8.8266452E-04
     +,   8.2912866E-04,   7.7819551E-04,   7.2976068E-04
     +,   6.8372278E-04,   6.3998892E-04,   5.9846492E-04
     +,   5.5906130E-04,   5.2169448E-04,   4.8628458E-04
     +,   4.5275310E-04,   4.2102515E-04,   3.9103124E-04
     +,   3.6270436E-04,   3.3597869E-04,   3.1079084E-04
     +,   2.8708117E-04,   2.6479180E-04,   2.4386488E-04
     +,   2.2424429E-04,   2.0587683E-04,   1.8870847E-04
     +,   1.7268625E-04,   1.5775918E-04,   1.4387675E-04
     +,   1.3098838E-04,   1.1904437E-04,   1.0799653E-04
     +,   9.7797485E-05,   8.8400033E-05,   7.9757992E-05
     +,   7.1826893E-05,   6.4563312E-05,   5.7924499E-05
     +,   5.1869181E-05,   4.6358000E-05,   4.1352512E-05
     +,   3.6815854E-05,   3.2713051E-05,   2.9010735E-05
     +,   2.5676894E-05,   2.2681294E-05,   1.9995563E-05
     +,   1.7592971E-05,   1.5448293E-05,   1.3537973E-05
     +,   1.1840187E-05,   1.0334642E-05,   9.0024605E-06
     +,   7.8262301E-06,   6.7900332E-06,   5.8791711E-06
     +,   5.0802228E-06,   4.3809923E-06,   3.7703949E-06
     +,   3.2383443E-06,   2.7757360E-06,   2.3744014E-06
     +,   2.0269945E-06,   1.7269134E-06,   1.4682698E-06
     +,   1.2458336E-06,   1.0549583E-06,   8.9151587E-07
     +,   7.5186307E-07,   6.3280373E-07,   5.3151689E-07
     +,   4.4553380E-07,   3.7270200E-07,   3.1114482E-07
     +,   2.5922751E-07,   2.1553303E-07,   1.7883980E-07
     +,   1.4809292E-07,   1.2238310E-07,   1.0093063E-07
     +,   8.3069374E-08,   6.8230570E-08,   5.5928634E-08
     +,   4.5751285E-08,   3.7350127E-08,   3.0429714E-08
     +,   2.4740986E-08,   2.0074912E-08,   1.6255823E-08
     +,   1.3136567E-08,   1.0594206E-08,   8.5265235E-09
     +,   6.8484876E-09,   5.4895195E-09,   4.3912496E-09
     +,   3.5055889E-09,   2.7928548E-09,   2.2205187E-09
     +,   1.7618725E-09,   1.3951308E-09,   1.1024747E-09
     +,   8.6944513E-10,   6.8427231E-10,   5.3744703E-10
     +,   4.2126572E-10,   3.2953140E-10,   2.5724922E-10
     +,   2.0041219E-10,   1.5581703E-10,   1.2089785E-10
     +,   9.3614366E-11,   7.2340259E-11,   5.5787531E-11
     +,   4.2934638E-11,   3.2976000E-11,   2.5275622E-11
     +,   1.9334227E-11,   1.4759234E-11,   1.1244006E-11
     +,   8.5485421E-12,   6.4860942E-12
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_haonly_hatt75_mass = Yx/11.2299826666667
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_haonly_hatt80_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.9154008E-03,   2.8933513E-03
     +,   2.8715825E-03,   2.8506191E-03,   2.8310178E-03
     +,   2.8133702E-03,   2.7982930E-03,   2.7864345E-03
     +,   2.7784707E-03,   2.7750970E-03,   2.7770349E-03
     +,   2.7850224E-03,   2.7998122E-03,   2.8221728E-03
     +,   2.8528776E-03,   2.8927098E-03,   2.9424524E-03
     +,   3.0028883E-03,   3.0747959E-03,   3.1589456E-03
     +,   3.2560956E-03,   3.3669872E-03,   3.4923442E-03
     +,   3.6328700E-03,   3.7892270E-03,   3.9620586E-03
     +,   4.1519580E-03,   4.3594735E-03,   4.5850943E-03
     +,   4.8292452E-03,   5.0922739E-03,   5.3744335E-03
     +,   5.6758742E-03,   5.9966212E-03,   6.3365647E-03
     +,   6.6954354E-03,   7.0727905E-03,   7.4679884E-03
     +,   7.8802072E-03,   8.3083566E-03,   8.7511670E-03
     +,   9.2071025E-03,   9.6744103E-03,   1.0151109E-02
     +,   1.0635011E-02,   1.1123758E-02,   1.1614855E-02
     +,   1.2105708E-02,   1.2593701E-02,   1.3076250E-02
     +,   1.3550888E-02,   1.4015348E-02,   1.4467648E-02
     +,   1.4906214E-02,   1.5329904E-02,   1.5738182E-02
     +,   1.6131131E-02,   1.6509555E-02,   1.6875034E-02
     +,   1.7229946E-02,   1.7577497E-02,   1.7921705E-02
     +,   1.8267360E-02,   1.8620007E-02,   1.8985825E-02
     +,   1.9371515E-02,   1.9784231E-02,   2.0231349E-02
     +,   2.0720420E-02,   2.1258876E-02,   2.1853970E-02
     +,   2.2512481E-02,   2.3240611E-02,   2.4043711E-02
     +,   2.4926154E-02,   2.5891153E-02,   2.6940489E-02
     +,   2.8074436E-02,   2.9291835E-02,   3.0590007E-02
     +,   3.1964906E-02,   3.3411872E-02,   3.4925934E-02
     +,   3.6503218E-02,   3.8141809E-02,   3.9843522E-02
     +,   4.1614890E-02,   4.3468475E-02,   4.5422591E-02
     +,   4.7500622E-02,   4.9728036E-02,   5.2127391E-02
     +,   5.4712098E-02,   5.7478972E-02,   6.0401332E-02
     +,   6.3425250E-02,   6.6473022E-02,   6.9454804E-02
     +,   7.2293177E-02,   7.4956223E-02,   7.7496804E-02
     +,   8.0085024E-02,   8.3024621E-02,   8.6739771E-02
     +,   9.1731593E-02,   9.8508067E-02,   0.1075022    
     +,   0.1189994    ,   0.1330995    ,   0.1497418    
     +,   0.1688300    ,   0.1904744    ,   0.2152886    
     +,   0.2446642    ,   0.2809512    ,   0.3276176    
     +,   0.3892715    ,   0.4709926    ,   0.5760276    
     +,   0.7020091    ,   0.8378990    ,   0.9648949    
     +,    1.062144    ,    1.114074    ,    1.114914    
     +,    1.068662    ,   0.9858607    ,   0.8797610    
     +,   0.7636215    ,   0.6493973    ,   0.5466790    
     +,   0.4613612    ,   0.3946453    ,   0.3436208    
     +,   0.3033212    ,   0.2691192    ,   0.2381756    
     +,   0.2095479    ,   0.1834232    ,   0.1602238    
     +,   0.1400758    ,   0.1227301    ,   0.1077449    
     +,   9.4704047E-02,   8.3329052E-02,   7.3470630E-02
     +,   6.5041304E-02,   5.7946470E-02,   5.2047908E-02
     +,   4.7163926E-02,   4.3092102E-02,   3.9635774E-02
     +,   3.6623787E-02,   3.3920243E-02,   3.1426027E-02
     +,   2.9074810E-02,   2.6826549E-02,   2.4660828E-02
     +,   2.2571266E-02,   2.0560928E-02,   1.8638128E-02
     +,   1.6813640E-02,   1.5098522E-02,   1.3502327E-02
     +,   1.2031940E-02,   1.0691144E-02,   9.4805956E-03
     +,   8.3978958E-03,   7.4379873E-03,   6.5937852E-03
     +,   5.8568190E-03,   5.2177249E-03,   4.6667275E-03
     +,   4.1941116E-03,   3.7905702E-03,   3.4473422E-03
     +,   3.1564005E-03,   2.9105365E-03,   2.7033384E-03
     +,   2.5291594E-03,   2.3830782E-03,   2.2608347E-03
     +,   2.1587419E-03,   2.0736086E-03,   2.0026790E-03
     +,   1.9435756E-03,   1.8942410E-03,   1.8528914E-03
     +,   1.8179861E-03,   1.7881993E-03,   1.7623877E-03
     +,   1.7395746E-03,   1.7189317E-03,   1.6997611E-03
     +,   1.6814806E-03,   1.6636101E-03,   1.6457621E-03
     +,   1.6276275E-03,   1.6089641E-03,   1.5895885E-03
     +,   1.5693679E-03,   1.5482125E-03,   1.5260647E-03
     +,   1.5028969E-03,   1.4787068E-03,   1.4535093E-03
     +,   1.4273340E-03,   1.4002253E-03,   1.3722364E-03
     +,   1.3434270E-03,   1.3138615E-03,   1.2836104E-03
     +,   1.2527481E-03,   1.2213477E-03,   1.1894845E-03
     +,   1.1572352E-03,   1.1246775E-03,   1.0918850E-03
     +,   1.0589315E-03,   1.0258913E-03,   9.9283468E-04
     +,   9.5982925E-04,   9.2694256E-04,   8.9423964E-04
     +,   8.6178066E-04,   8.2962285E-04,   7.9782237E-04
     +,   7.6643244E-04,   7.3550048E-04,   7.0507103E-04
     +,   6.7518710E-04,   6.4588821E-04,   6.1720842E-04
     +,   5.8917853E-04,   5.6182849E-04,   5.3518219E-04
     +,   5.0926034E-04,   4.8408206E-04,   4.5966325E-04
     +,   4.3601493E-04,   4.1314540E-04,   3.9106153E-04
     +,   3.6976743E-04,   3.4926314E-04,   3.2954628E-04
     +,   3.1061354E-04,   2.9245942E-04,   2.7507491E-04
     +,   2.5844941E-04,   2.4257216E-04,   2.2742931E-04
     +,   2.1300546E-04,   1.9928512E-04,   1.8625139E-04
     +,   1.7388567E-04,   1.6216855E-04,   1.5108060E-04
     +,   1.4060190E-04,   1.3071120E-04,   1.2138710E-04
     +,   1.1260851E-04,   1.0435418E-04,   9.6602256E-05
     +,   8.9331021E-05,   8.2519575E-05,   7.6146556E-05
     +,   7.0190887E-05,   6.4632288E-05,   5.9450780E-05
     +,   5.4626529E-05,   5.0140265E-05,   4.5973462E-05
     +,   4.2108222E-05,   3.8526912E-05,   3.5212575E-05
     +,   3.2149190E-05,   2.9320963E-05,   2.6713140E-05
     +,   2.4311254E-05,   2.2101827E-05,   2.0071708E-05
     +,   1.8208690E-05,   1.6500921E-05,   1.4937421E-05
     +,   1.3507595E-05,   1.2201635E-05,   1.1010178E-05
     +,   9.9244198E-06,   8.9362084E-06,   8.0377731E-06
     +,   7.2219677E-06,   6.4820024E-06,   5.8116570E-06
     +,   5.2050450E-06,   4.6567802E-06,   4.1617950E-06
     +,   3.7154555E-06,   3.3134218E-06,   2.9517371E-06
     +,   2.6267076E-06,   2.3349735E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_haonly_hatt80_mass = Yx/4.80298605405405
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_haonly_hatt85_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.3117728E-04,   2.6684446E-04
     +,   3.0699722E-04,   3.5202326E-04,   4.0231508E-04
     +,   4.5826481E-04,   5.2025879E-04,   5.8867066E-04
     +,   6.6385273E-04,   7.4613368E-04,   8.3580217E-04
     +,   9.3310309E-04,   1.0382279E-03,   1.1513041E-03
     +,   1.2723878E-03,   1.4014533E-03,   1.5383863E-03
     +,   1.6829764E-03,   1.8349091E-03,   1.9937635E-03
     +,   2.1590074E-03,   2.3299961E-03,   2.5059709E-03
     +,   2.6860754E-03,   2.8693294E-03,   3.0546798E-03
     +,   3.2409737E-03,   3.4269947E-03,   3.6114668E-03
     +,   3.7930801E-03,   3.9705071E-03,   4.1424287E-03
     +,   4.3075564E-03,   4.4646603E-03,   4.6125972E-03
     +,   4.7503370E-03,   4.8769936E-03,   4.9918499E-03
     +,   5.0943969E-03,   5.1843422E-03,   5.2616582E-03
     +,   5.3265924E-03,   5.3796927E-03,   5.4218322E-03
     +,   5.4542241E-03,   5.4784338E-03,   5.4963878E-03
     +,   5.5103810E-03,   5.5230730E-03,   5.5374787E-03
     +,   5.5569489E-03,   5.5851457E-03,   5.6260051E-03
     +,   5.6836801E-03,   5.7624816E-03,   5.8667948E-03
     +,   6.0009896E-03,   6.1693066E-03,   6.3757300E-03
     +,   6.6238577E-03,   6.9167493E-03,   7.2567849E-03
     +,   7.6454729E-03,   8.0833631E-03,   8.5698832E-03
     +,   9.1031715E-03,   9.6801026E-03,   1.0296093E-02
     +,   1.0945253E-02,   1.1620251E-02,   1.2312587E-02
     +,   1.3012560E-02,   1.3709639E-02,   1.4392547E-02
     +,   1.5049705E-02,   1.5669486E-02,   1.6240524E-02
     +,   1.6752124E-02,   1.7194632E-02,   1.7559716E-02
     +,   1.7840618E-02,   1.8032482E-02,   1.8132418E-02
     +,   1.8139683E-02,   1.8055633E-02,   1.7883707E-02
     +,   1.7629288E-02,   1.7299471E-02,   1.6902873E-02
     +,   1.6449265E-02,   1.5949262E-02,   1.5414040E-02
     +,   1.4854961E-02,   1.4283222E-02,   1.3709583E-02
     +,   1.3144187E-02,   1.2596215E-02,   1.2073887E-02
     +,   1.1584201E-02,   1.1133061E-02,   1.0725157E-02
     +,   1.0364192E-02,   1.0052980E-02,   9.7938543E-03
     +,   9.5890155E-03,   9.4412100E-03,   9.3545429E-03
     +,   9.3355309E-03,   9.3944361E-03,   9.5468648E-03
     +,   9.8155150E-03,   1.0232000E-02,   1.0838225E-02
     +,   1.1687247E-02,   1.2842427E-02,   1.4375100E-02
     +,   1.6359350E-02,   1.8865237E-02,   2.1949569E-02
     +,   2.5647698E-02,   2.9966509E-02,   3.4880962E-02
     +,   4.0335637E-02,   4.6250373E-02,   5.2526951E-02
     +,   5.9055150E-02,   6.5720469E-02,   7.2411455E-02
     +,   7.9041027E-02,   8.5584089E-02,   9.2148021E-02
     +,   9.9067613E-02,   0.1070088    ,   0.1170143    
     +,   0.1304159    ,   0.1485624    ,   0.1724485    
     +,   0.2024955    ,   0.2387745    ,   0.2816962    
     +,   0.3326505    ,   0.3936505    ,   0.4654000    
     +,   0.5446280    ,   0.6228625    ,   0.6883565    
     +,   0.7302876    ,   0.7423655    ,   0.7236357    
     +,   0.6769932    ,   0.6076558    ,   0.5228047    
     +,   0.4314720    ,   0.3433022    ,   0.2662558    
     +,   0.2046753    ,   0.1589143    ,   0.1265073    
     +,   0.1039050    ,   8.7820202E-02,   7.5828455E-02
     +,   6.6394173E-02,   5.8632873E-02,   5.2046213E-02
     +,   4.6329621E-02,   4.1264568E-02,   3.6675200E-02
     +,   3.2422584E-02,   2.8413238E-02,   2.4604848E-02
     +,   2.1001559E-02,   1.7639261E-02,   1.4566989E-02
     +,   1.1830282E-02,   9.4596157E-03,   7.4643069E-03
     +,   5.8327969E-03,   4.5364653E-03,   3.5350835E-03
     +,   2.7826591E-03,   2.2325870E-03,   1.8413623E-03
     +,   1.5707902E-03,   1.3890044E-03,   1.2705780E-03
     +,   1.1959882E-03,   1.1507500E-03,   1.1244593E-03
     +,   1.1098712E-03,   1.1020866E-03,   1.0978846E-03
     +,   1.0952071E-03,   1.0927765E-03,   1.0898247E-03
     +,   1.0859055E-03,   1.0807721E-03,   1.0742994E-03
     +,   1.0664350E-03,   1.0571694E-03,   1.0465188E-03
     +,   1.0345166E-03,   1.0212072E-03,   1.0066421E-03
     +,   9.9087844E-04,   9.7397977E-04,   9.5601240E-04
     +,   9.3704549E-04,   9.1715285E-04,   8.9641049E-04
     +,   8.7489508E-04,   8.5268501E-04,   8.2986051E-04
     +,   8.0650265E-04,   7.8269118E-04,   7.5850502E-04
     +,   7.3402416E-04,   7.0932705E-04,   6.8448932E-04
     +,   6.5958395E-04,   6.3468463E-04,   6.0985947E-04
     +,   5.8517372E-04,   5.6069117E-04,   5.3647195E-04
     +,   5.1257125E-04,   4.8904039E-04,   4.6592831E-04
     +,   4.4327980E-04,   4.2113443E-04,   3.9952743E-04
     +,   3.7849171E-04,   3.5805581E-04,   3.3824312E-04
     +,   3.1907315E-04,   3.0056352E-04,   2.8272628E-04
     +,   2.6557007E-04,   2.4910120E-04,   2.3332293E-04
     +,   2.1823420E-04,   2.0383138E-04,   1.9010928E-04
     +,   1.7705992E-04,   1.6467254E-04,   1.5293433E-04
     +,   1.4183145E-04,   1.3134850E-04,   1.2146789E-04
     +,   1.1217103E-04,   1.0343912E-04,   9.5251744E-05
     +,   8.7587789E-05,   8.0426333E-05,   7.3745905E-05
     +,   6.7524517E-05,   6.1740138E-05,   5.6371246E-05
     +,   5.1396415E-05,   4.6794179E-05,   4.2543532E-05
     +,   3.8624148E-05,   3.5016252E-05,   3.1700361E-05
     +,   2.8657696E-05,   2.5870429E-05,   2.3321143E-05
     +,   2.0993188E-05,   1.8870824E-05,   1.6939033E-05
     +,   1.5183448E-05,   1.3590467E-05,   1.2147368E-05
     +,   1.0842154E-05,   9.6634640E-06,   8.6006685E-06
     +,   7.6439374E-06,   6.7839765E-06,   6.0122534E-06
     +,   5.3207377E-06,   4.7021058E-06,   4.1494914E-06
     +,   3.6566491E-06,   3.2177588E-06,   2.8275449E-06
     +,   2.4811193E-06,   2.1740589E-06,   1.9022992E-06
     +,   1.6621441E-06,   1.4502532E-06,   1.2635758E-06
     +,   1.0993705E-06,   9.5514463E-07,   8.2866723E-07
     +,   7.1791476E-07,   6.2108597E-07,   5.3655197E-07
     +,   4.6286922E-07,   3.9873714E-07,   3.4300510E-07
     +,   2.9464340E-07,   2.5274272E-07
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_haonly_hatt85_mass = Yx/2.92966587878788
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_haonly_hatt90_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.1198841E-03,   2.2129600E-03
     +,   2.3090220E-03,   2.4079804E-03,   2.5097332E-03
     +,   2.6141698E-03,   2.7211700E-03,   2.8306041E-03
     +,   2.9423351E-03,   3.0562247E-03,   3.1721240E-03
     +,   3.2898819E-03,   3.4093447E-03,   3.5303591E-03
     +,   3.6527715E-03,   3.7764304E-03,   3.9011883E-03
     +,   4.0269010E-03,   4.1534337E-03,   4.2806575E-03
     +,   4.4084527E-03,   4.5367116E-03,   4.6653342E-03
     +,   4.7942414E-03,   4.9233534E-03,   5.0526173E-03
     +,   5.1819868E-03,   5.3114286E-03,   5.4409252E-03
     +,   5.5704694E-03,   5.7000672E-03,   5.8297343E-03
     +,   5.9594936E-03,   6.0893735E-03,   6.2194117E-03
     +,   6.3496428E-03,   6.4801006E-03,   6.6108159E-03
     +,   6.7418176E-03,   6.8731089E-03,   7.0046959E-03
     +,   7.1365559E-03,   7.2686481E-03,   7.4009085E-03
     +,   7.5332397E-03,   7.6655201E-03,   7.7975891E-03
     +,   7.9292515E-03,   8.0602737E-03,   8.1903795E-03
     +,   8.3192559E-03,   8.4465472E-03,   8.5718539E-03
     +,   8.6947437E-03,   8.8147344E-03,   8.9313230E-03
     +,   9.0439608E-03,   9.1520809E-03,   9.2550851E-03
     +,   9.3523590E-03,   9.4432821E-03,   9.5272176E-03
     +,   9.6035376E-03,   9.6716220E-03,   9.7308671E-03
     +,   9.7806919E-03,   9.8205507E-03,   9.8499311E-03
     +,   9.8683778E-03,   9.8754857E-03,   9.8709119E-03
     +,   9.8543847E-03,   9.8257009E-03,   9.7847432E-03
     +,   9.7314697E-03,   9.6659306E-03,   9.5882574E-03
     +,   9.4986791E-03,   9.3975049E-03,   9.2851296E-03
     +,   9.1620451E-03,   9.0288091E-03,   8.8860765E-03
     +,   8.7345568E-03,   8.5750390E-03,   8.4083630E-03
     +,   8.2354397E-03,   8.0572059E-03,   7.8746658E-03
     +,   7.6888348E-03,   7.5007579E-03,   7.3115132E-03
     +,   7.1221944E-03,   6.9338926E-03,   6.7477063E-03
     +,   6.5647545E-03,   6.3861324E-03,   6.2129679E-03
     +,   6.0463678E-03,   5.8874716E-03,   5.7374174E-03
     +,   5.5973912E-03,   5.4686032E-03,   5.3523351E-03
     +,   5.2499352E-03,   5.1628468E-03,   5.0926395E-03
     +,   5.0410177E-03,   5.0098402E-03,   5.0011449E-03
     +,   5.0171558E-03,   5.0602797E-03,   5.1330966E-03
     +,   5.2383430E-03,   5.3788451E-03,   5.5574831E-03
     +,   5.7770596E-03,   6.0402378E-03,   6.3493294E-03
     +,   6.7061996E-03,   7.1120430E-03,   7.5671603E-03
     +,   8.0707483E-03,   8.6207325E-03,   9.2135379E-03
     +,   9.8438645E-03,   1.0504729E-02,   1.1187292E-02
     +,   1.1881143E-02,   1.2574442E-02,   1.3254584E-02
     +,   1.3908826E-02,   1.4525490E-02,   1.5095186E-02
     +,   1.5612528E-02,   1.6077831E-02,   1.6498875E-02
     +,   1.6892495E-02,   1.7285854E-02,   1.7717179E-02
     +,   1.8236037E-02,   1.8903537E-02,   1.9792704E-02
     +,   2.0989632E-02,   2.2595521E-02,   2.4730178E-02
     +,   2.7535718E-02,   3.1179110E-02,   3.5852727E-02
     +,   4.1771416E-02,   4.9165506E-02,   5.8270749E-02
     +,   6.9319129E-02,   8.2533650E-02,   9.8125741E-02
     +,   0.1162938    ,   0.1372185    ,   0.1610435    
     +,   0.1878288    ,   0.2174720    ,   0.2496117    
     +,   0.2835200    ,   0.3180178    ,   0.3514605    
     +,   0.3818198    ,   0.4068705    ,   0.4244786    
     +,   0.4329387    ,   0.4312886    ,   0.4195160    
     +,   0.3986048    ,   0.3703945    ,   0.3372792    
     +,   0.3018245    ,   0.2663941    ,   0.2328511    
     +,   0.2024098    ,   0.1756290    ,   0.1525177    
     +,   0.1327085    ,   0.1156465    ,   0.1007509    
     +,   8.7522209E-02,   7.5595528E-02,   6.4749338E-02
     +,   5.4880794E-02,   4.5965027E-02,   3.8012605E-02
     +,   3.1036178E-02,   2.5028696E-02,   1.9952513E-02
     +,   1.5740680E-02,   1.2304135E-02,   9.5411520E-03
     +,   7.3469668E-03,   5.6218221E-03,   4.2761429E-03
     +,   3.2329320E-03,   2.4282269E-03,   1.8103282E-03
     +,   1.3381987E-03,   9.7955018E-04,   7.0905848E-04
     +,   5.0686789E-04,   3.5736899E-04,   2.4821810E-04
     +,   1.6966318E-04,   1.1402401E-04,   7.5290845E-05
     +,   4.8815578E-05,   3.1062806E-05,   1.9393514E-05
     +,   1.1877957E-05,   7.1366080E-06,   4.2072370E-06
     +,   2.4349749E-06,   1.3849028E-06,   7.7534543E-07
     +,   4.2847347E-07,   2.3478611E-07,   1.2846354E-07
     +,   7.0919597E-08,   4.0069271E-08,   2.3560743E-08
     +,   1.4640606E-08,   9.6954693E-09,   6.8289778E-09
     +,   5.0614211E-09,   3.8919339E-09,   3.0648537E-09
     +,   2.4479794E-09,   1.9705615E-09,   1.5924480E-09
     +,   1.2890053E-09,   1.0438108E-09,   8.4502100E-10
     +,   6.8364320E-10,   5.5261601E-10,   4.4627782E-10
     +,   3.6003256E-10,   2.9014147E-10,   2.3355975E-10
     +,   1.8780037E-10,   1.5083156E-10,   1.2099623E-10
     +,   9.6945667E-11,   7.7581164E-11,   6.2007566E-11
     +,   4.9497299E-11,   3.9460810E-11,   3.1418732E-11
     +,   2.4982714E-11,   1.9838797E-11,   1.5733101E-11
     +,   1.2460236E-11,   9.8547325E-12,   7.7833885E-12
     +,   6.1389826E-12,   4.8352706E-12,   3.8030833E-12
     +,   2.9870459E-12,   2.3428137E-12,   1.8349287E-12
     +,   1.4350943E-12,   1.1207932E-12,   8.7407723E-13
     +,   6.8068484E-13,   5.2932252E-13,   4.1102869E-13
     +,   3.1871107E-13,   2.4676978E-13,   1.9079093E-13
     +,   1.4729889E-13,   1.1355649E-13,   8.7415989E-14
     +,   6.7196377E-14,   5.1578238E-14,   3.9533277E-14
     +,   3.0257074E-14,   2.3124169E-14,   1.7647179E-14
     +,   1.3448105E-14,   1.0233379E-14,   7.7759810E-15
     +,   5.9002079E-15,   4.4705611E-15,   3.3825107E-15
     +,   2.5556191E-15,   1.9281682E-15,   1.4527125E-15
     +,   1.0929829E-15,   8.2118341E-16,   6.1613378E-16
     +,   4.6165239E-16,   3.4544119E-16,   2.5813792E-16
     +,   1.9264773E-16,   1.4358599E-16,   1.0688420E-16
     +,   7.9464594E-17,   5.9008464E-17
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_haonly_hatt90_mass = Yx/2.235352
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_haonly_hatt95_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.5452658E-04,   1.6654686E-04
     +,   1.7924495E-04,   1.9263485E-04,   2.0672848E-04
     +,   2.2153553E-04,   2.3706329E-04,   2.5331634E-04
     +,   2.7029612E-04,   2.8800181E-04,   3.0642864E-04
     +,   3.2556857E-04,   3.4540988E-04,   3.6593759E-04
     +,   3.8713243E-04,   4.0897162E-04,   4.3142820E-04
     +,   4.5447156E-04,   4.7806720E-04,   5.0217693E-04
     +,   5.2675890E-04,   5.5176823E-04,   5.7715666E-04
     +,   6.0287514E-04,   6.2886981E-04,   6.5508857E-04
     +,   6.8147772E-04,   7.0798420E-04,   7.3455728E-04
     +,   7.6114968E-04,   7.8771933E-04,   8.1423123E-04
     +,   8.4066024E-04,   8.6699339E-04,   8.9323259E-04
     +,   9.1939885E-04,   9.4553520E-04,   9.7171118E-04
     +,   9.9802914E-04,   1.0246242E-03,   1.0516761E-03
     +,   1.0794095E-03,   1.1081009E-03,   1.1380853E-03
     +,   1.1697598E-03,   1.2035896E-03,   1.2401111E-03
     +,   1.2799362E-03,   1.3237533E-03,   1.3723284E-03
     +,   1.4265027E-03,   1.4871891E-03,   1.5553650E-03
     +,   1.6320682E-03,   1.7183702E-03,   1.8153798E-03
     +,   1.9242062E-03,   2.0459450E-03,   2.1816494E-03
     +,   2.3323002E-03,   2.4987736E-03,   2.6818111E-03
     +,   2.8819654E-03,   3.0995957E-03,   3.3348151E-03
     +,   3.5874373E-03,   3.8569956E-03,   4.1426551E-03
     +,   4.4432627E-03,   4.7572595E-03,   5.0827535E-03
     +,   5.4174480E-03,   5.7587344E-03,   6.1036353E-03
     +,   6.4489162E-03,   6.7910985E-03,   7.1264920E-03
     +,   7.4512833E-03,   7.7616298E-03,   8.0537088E-03
     +,   8.3237719E-03,   8.5682962E-03,   8.7839849E-03
     +,   8.9679146E-03,   9.1175418E-03,   9.2308223E-03
     +,   9.3062045E-03,   9.3427179E-03,   9.3399649E-03
     +,   9.2981439E-03,   9.2180464E-03,   9.1010313E-03
     +,   8.9490041E-03,   8.7643573E-03,   8.5499147E-03
     +,   8.3088940E-03,   8.0447830E-03,   7.7613224E-03
     +,   7.4623609E-03,   7.1518458E-03,   6.8336707E-03
     +,   6.5116794E-03,   6.1895186E-03,   5.8706631E-03
     +,   5.5582905E-03,   5.2552712E-03,   4.9641631E-03
     +,   4.6871630E-03,   4.4260840E-03,   4.1823704E-03
     +,   3.9571319E-03,   3.7510979E-03,   3.5647023E-03
     +,   3.3980513E-03,   3.2510052E-03,   3.1231630E-03
     +,   3.0139382E-03,   2.9225538E-03,   2.8481076E-03
     +,   2.7895791E-03,   2.7458691E-03,   2.7158286E-03
     +,   2.6982767E-03,   2.6920189E-03,   2.6958717E-03
     +,   2.7086693E-03,   2.7292792E-03,   2.7566075E-03
     +,   2.7896087E-03,   2.8272821E-03,   2.8686856E-03
     +,   2.9129218E-03,   2.9591534E-03,   3.0065854E-03
     +,   3.0544784E-03,   3.1021396E-03,   3.1489176E-03
     +,   3.1942031E-03,   3.2374335E-03,   3.2780829E-03
     +,   3.3156613E-03,   3.3497170E-03,   3.3798376E-03
     +,   3.4056460E-03,   3.4268012E-03,   3.4429992E-03
     +,   3.4539769E-03,   3.4595106E-03,   3.4594182E-03
     +,   3.4535702E-03,   3.4419000E-03,   3.4244286E-03
     +,   3.4013158E-03,   3.3729435E-03,   3.3400597E-03
     +,   3.3040179E-03,   3.2671192E-03,   3.2330789E-03
     +,   3.2076328E-03,   3.1992022E-03,   3.2195586E-03
     +,   3.2844150E-03,   3.4138709E-03,   3.6328214E-03
     +,   3.9716368E-03,   4.4675916E-03,   5.1676477E-03
     +,   6.1333589E-03,   7.4484725E-03,   9.2290016E-03
     +,   1.1634042E-02,   1.4872693E-02,   1.9198997E-02
     +,   2.4888329E-02,   3.2203808E-02,   4.1389327E-02
     +,   5.2730750E-02,   6.6692747E-02,   8.4067889E-02
     +,   0.1060705    ,   0.1344683    ,   0.1720335    
     +,   0.2233702    ,   0.2953199    ,   0.3953239    
     +,   0.5266248    ,   0.6816411    ,   0.8378330    
     +,   0.9611700    ,    1.018541    ,   0.9932235    
     +,   0.8929672    ,   0.7449042    ,   0.5817443    
     +,   0.4294268    ,   0.3023760    ,   0.2050352    
     +,   0.1354727    ,   8.8571414E-02,   5.8321118E-02
     +,   3.9277419E-02,   2.7250601E-02,   1.9394377E-02
     +,   1.3968045E-02,   1.0006525E-02,   7.0195901E-03
     +,   4.7662738E-03,   3.1097049E-03,   1.9424335E-03
     +,   1.1610234E-03,   6.6610274E-04,   3.6993175E-04
     +,   2.0230626E-04,   1.1218928E-04,   6.5692955E-05
     +,   4.2166990E-05,   3.0022455E-05,   2.3253659E-05
     +,   1.8975037E-05,   1.5891137E-05,   1.3448867E-05
     +,   1.1415311E-05,   9.6860322E-06,   8.2055567E-06
     +,   6.9370117E-06,   5.8515634E-06,   4.9248270E-06
     +,   4.1355079E-06,   3.4648615E-06,   2.8964250E-06
     +,   2.4158226E-06,   2.0104858E-06,   1.6694454E-06
     +,   1.3831886E-06,   1.1435071E-06,   9.4329573E-07
     +,   7.7644626E-07,   6.3773302E-07,   5.2268467E-07
     +,   4.2748238E-07,   3.4888282E-07,   2.8414107E-07
     +,   2.3093688E-07,   1.8731114E-07,   1.5161814E-07
     +,   1.2248121E-07,   9.8748743E-08,   7.9459468E-08
     +,   6.3814639E-08,   5.1153386E-08,   4.0927716E-08
     +,   3.2685843E-08,   2.6056663E-08,   2.0735435E-08
     +,   1.6472297E-08,   1.3063373E-08,   1.0342779E-08
     +,   8.1756060E-09,   6.4523600E-09,   5.0845066E-09
     +,   4.0006740E-09,   3.1433696E-09,   2.4663391E-09
     +,   1.9325126E-09,   1.5122829E-09,   1.1819614E-09
     +,   9.2268126E-10,   7.1945544E-10,   5.6038507E-10
     +,   4.3603188E-10,   3.3893607E-10,   2.6321523E-10
     +,   2.0423201E-10,   1.5833349E-10,   1.2265260E-10
     +,   9.4942693E-11,   7.3441121E-11,   5.6772153E-11
     +,   4.3859038E-11,   3.3863690E-11,   2.6131597E-11
     +,   2.0154631E-11,   1.5536912E-11,   1.1971610E-11
     +,   9.2201351E-12,   7.0979455E-12,   5.4618437E-12
     +,   4.2010193E-12,   3.2298907E-12,   2.4821575E-12
     +,   1.9067016E-12,   1.4639888E-12,   1.1235558E-12
     +,   8.6186435E-13,   6.6079786E-13,   5.0636974E-13
     +,   3.8782185E-13,   2.9685369E-13,   2.2708818E-13
     +,   1.7360726E-13,   1.3263431E-13
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_haonly_hatt95_mass = Yx/2.5322346875
      RETURN
      END
C 
C---- New file --- 
C 
      DOUBLE PRECISION FUNCTION A196_tt_hzonly_htt100_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.6855951E-03,   2.7581891E-03
     +,   2.8307524E-03,   2.9031928E-03,   2.9754192E-03
     +,   3.0473426E-03,   3.1188775E-03,   3.1899405E-03
     +,   3.2604535E-03,   3.3303455E-03,   3.3995484E-03
     +,   3.4680029E-03,   3.5356574E-03,   3.6024665E-03
     +,   3.6683970E-03,   3.7334249E-03,   3.7975390E-03
     +,   3.8607351E-03,   3.9230287E-03,   3.9844434E-03
     +,   4.0450180E-03,   4.1048070E-03,   4.1638780E-03
     +,   4.2223209E-03,   4.2802319E-03,   4.3377331E-03
     +,   4.3949587E-03,   4.4520604E-03,   4.5092101E-03
     +,   4.5665959E-03,   4.6244203E-03,   4.6829064E-03
     +,   4.7422950E-03,   4.8028398E-03,   4.8648128E-03
     +,   4.9284995E-03,   4.9942019E-03,   5.0622309E-03
     +,   5.1329159E-03,   5.2065905E-03,   5.2836011E-03
     +,   5.3642993E-03,   5.4490450E-03,   5.5381982E-03
     +,   5.6321207E-03,   5.7311752E-03,   5.8357217E-03
     +,   5.9461081E-03,   6.0626813E-03,   6.1857710E-03
     +,   6.3156937E-03,   6.4527490E-03,   6.5972130E-03
     +,   6.7493478E-03,   6.9093737E-03,   7.0774951E-03
     +,   7.2538811E-03,   7.4386606E-03,   7.6319315E-03
     +,   7.8337509E-03,   8.0441348E-03,   8.2630590E-03
     +,   8.4904423E-03,   8.7261768E-03,   8.9701097E-03
     +,   9.2220204E-03,   9.4816741E-03,   9.7487597E-03
     +,   1.0022961E-02,   1.0303878E-02,   1.0591119E-02
     +,   1.0884212E-02,   1.1182694E-02,   1.1486032E-02
     +,   1.1793702E-02,   1.2105153E-02,   1.2419810E-02
     +,   1.2737067E-02,   1.3056353E-02,   1.3377075E-02
     +,   1.3698626E-02,   1.4020442E-02,   1.4341925E-02
     +,   1.4662547E-02,   1.4981747E-02,   1.5299039E-02
     +,   1.5613910E-02,   1.5925938E-02,   1.6234681E-02
     +,   1.6539767E-02,   1.6840877E-02,   1.7137703E-02
     +,   1.7429981E-02,   1.7717535E-02,   1.8000219E-02
     +,   1.8277934E-02,   1.8550660E-02,   1.8818419E-02
     +,   1.9081326E-02,   1.9339547E-02,   1.9593343E-02
     +,   1.9843051E-02,   2.0089120E-02,   2.0332064E-02
     +,   2.0572545E-02,   2.0811342E-02,   2.1049351E-02
     +,   2.1287626E-02,   2.1527380E-02,   2.1770017E-02
     +,   2.2017119E-02,   2.2270501E-02,   2.2532191E-02
     +,   2.2804508E-02,   2.3090016E-02,   2.3391617E-02
     +,   2.3712501E-02,   2.4056243E-02,   2.4426715E-02
     +,   2.4828203E-02,   2.5265351E-02,   2.5743093E-02
     +,   2.6266705E-02,   2.6841728E-02,   2.7473869E-02
     +,   2.8168870E-02,   2.8932478E-02,   2.9770117E-02
     +,   3.0686859E-02,   3.1687055E-02,   3.2774210E-02
     +,   3.3950545E-02,   3.5216950E-02,   3.6572427E-02
     +,   3.8014125E-02,   3.9536905E-02,   4.1133221E-02
     +,   4.2792972E-02,   4.4503678E-02,   4.6250436E-02
     +,   4.8016030E-02,   4.9781363E-02,   5.1526014E-02
     +,   5.3228777E-02,   5.4868076E-02,   5.6423184E-02
     +,   5.7874825E-02,   5.9205949E-02,   6.0402811E-02
     +,   6.1455663E-02,   6.2359512E-02,   6.3114554E-02
     +,   6.3726604E-02,   6.4207323E-02,   6.4573988E-02
     +,   6.4849369E-02,   6.5060988E-02,   6.5240689E-02
     +,   6.5423980E-02,   6.5649018E-02,   6.5956451E-02
     +,   6.6388860E-02,   6.6990905E-02,   6.7809723E-02
     +,   6.8895556E-02,   7.0302822E-02,   7.2090618E-02
     +,   7.4323319E-02,   7.7070542E-02,   8.0405131E-02
     +,   8.4400199E-02,   8.9124560E-02,   9.4636783E-02
     +,   0.1009793    ,   0.1081719    ,   0.1162112    
     +,   0.1250731    ,   0.1347233    ,   0.1451369    
     +,   0.1563239    ,   0.1683540    ,   0.1813726    
     +,   0.1955979    ,   0.2112954    ,   0.2287232    
     +,   0.2480690    ,   0.2693959    ,   0.2926273    
     +,   0.3175916    ,   0.3441371    ,   0.3723287    
     +,   0.4026606    ,   0.4361854    ,   0.4744211    
     +,   0.5189306    ,   0.5706890    ,   0.6296537    
     +,   0.6950688    ,   0.7666339    ,   0.8458094    
     +,   0.9358730    ,    1.039693    ,    1.155928    
     +,    1.276420    ,    1.387793    ,    1.477472    
     +,    1.540355    ,    1.581591    ,    1.614022    
     +,    1.652239    ,    1.705771    ,    1.773897    
     +,    1.845157    ,    1.903248    ,    1.935745    
     +,    1.938757    ,    1.914756    ,    1.868290    
     +,    1.804883    ,    1.731701    ,    1.654969    
     +,    1.574823    ,    1.484325    ,    1.375729    
     +,    1.248481    ,    1.111285    ,   0.9771842    
     +,   0.8566521    ,   0.7538215    ,   0.6670028    
     +,   0.5916461    ,   0.5233075    ,   0.4592387    
     +,   0.3985169    ,   0.3414054    ,   0.2886426    
     +,   0.2410019    ,   0.1990739    ,   0.1631492    
     +,   0.1331607    ,   0.1087009    ,   8.9108706E-02
     +,   7.3595002E-02,   6.1366946E-02,   5.1716041E-02
     +,   4.4057991E-02,   3.7933871E-02,   3.2992344E-02
     +,   2.8966738E-02,   2.5654236E-02,   2.2899287E-02
     +,   2.0582993E-02,   1.8615045E-02,   1.6927315E-02
     +,   1.5468557E-02,   1.4200182E-02,   1.3092682E-02
     +,   1.2122714E-02,   1.1271093E-02,   1.0521506E-02
     +,   9.8597817E-03,   9.2733977E-03,   8.7512378E-03
     +,   8.2835509E-03,   7.8619048E-03,   7.4790306E-03
     +,   7.1287872E-03,   6.8060649E-03,   6.5066521E-03
     +,   6.2270900E-03,   5.9645851E-03,   5.7169129E-03
     +,   5.4823072E-03,   5.2593602E-03,   5.0469707E-03
     +,   4.8442958E-03,   4.6506645E-03,   4.4655725E-03
     +,   4.2886036E-03,   4.1194465E-03,   3.9578243E-03
     +,   3.8035184E-03,   3.6563082E-03,   3.5160035E-03
     +,   3.3823971E-03,   3.2552932E-03,   3.1344760E-03
     +,   3.0197203E-03,   2.9108033E-03,   2.8074780E-03
     +,   2.7095049E-03,   2.6166271E-03,   2.5285971E-03
     +,   2.4451565E-03,   2.3660609E-03,   2.2910589E-03
     +,   2.2199168E-03,   2.1523987E-03,   2.0882874E-03
     +,   2.0273665E-03,   1.9694397E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_hzonly_htt100_mass = Yx/14.3138733181818
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_hzonly_htt105_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  5.5174408E-03,   5.6775906E-03
     +,   5.8402433E-03,   6.0053454E-03,   6.1728363E-03
     +,   6.3426485E-03,   6.5147062E-03,   6.6889250E-03
     +,   6.8652071E-03,   7.0434539E-03,   7.2235465E-03
     +,   7.4053630E-03,   7.5887660E-03,   7.7736084E-03
     +,   7.9597309E-03,   8.1469640E-03,   8.3351228E-03
     +,   8.5240193E-03,   8.7134456E-03,   8.9031868E-03
     +,   9.0930229E-03,   9.2827147E-03,   9.4720162E-03
     +,   9.6606929E-03,   9.8484745E-03,   1.0035117E-02
     +,   1.0220356E-02,   1.0403929E-02,   1.0585586E-02
     +,   1.0765075E-02,   1.0942152E-02,   1.1116594E-02
     +,   1.1288185E-02,   1.1456730E-02,   1.1622056E-02
     +,   1.1784021E-02,   1.1942511E-02,   1.2097437E-02
     +,   1.2248770E-02,   1.2396504E-02,   1.2540688E-02
     +,   1.2681420E-02,   1.2818851E-02,   1.2953191E-02
     +,   1.3084706E-02,   1.3213724E-02,   1.3340638E-02
     +,   1.3465902E-02,   1.3590042E-02,   1.3713637E-02
     +,   1.3837341E-02,   1.3961867E-02,   1.4087978E-02
     +,   1.4216513E-02,   1.4348338E-02,   1.4484380E-02
     +,   1.4625601E-02,   1.4773005E-02,   1.4927614E-02
     +,   1.5090466E-02,   1.5262615E-02,   1.5445119E-02
     +,   1.5639011E-02,   1.5845323E-02,   1.6065061E-02
     +,   1.6299170E-02,   1.6548589E-02,   1.6814148E-02
     +,   1.7096676E-02,   1.7396864E-02,   1.7715376E-02
     +,   1.8052753E-02,   1.8409487E-02,   1.8785909E-02
     +,   1.9182285E-02,   1.9598799E-02,   2.0035466E-02
     +,   2.0492198E-02,   2.0968825E-02,   2.1465041E-02
     +,   2.1980401E-02,   2.2514362E-02,   2.3066226E-02
     +,   2.3635244E-02,   2.4220444E-02,   2.4820851E-02
     +,   2.5435265E-02,   2.6062477E-02,   2.6701091E-02
     +,   2.7349675E-02,   2.8006718E-02,   2.8670603E-02
     +,   2.9339686E-02,   3.0012308E-02,   3.0686831E-02
     +,   3.1361610E-02,   3.2035142E-02,   3.2705940E-02
     +,   3.3372801E-02,   3.4034636E-02,   3.4690708E-02
     +,   3.5340507E-02,   3.5983991E-02,   3.6621481E-02
     +,   3.7253808E-02,   3.7882373E-02,   3.8508989E-02
     +,   3.9136160E-02,   3.9766956E-02,   4.0405001E-02
     +,   4.1054409E-02,   4.1719902E-02,   4.2406451E-02
     +,   4.3119472E-02,   4.3864466E-02,   4.4647060E-02
     +,   4.5472682E-02,   4.6346523E-02,   4.7273193E-02
     +,   4.8256688E-02,   4.9300082E-02,   5.0405353E-02
     +,   5.1573157E-02,   5.2802805E-02,   5.4092102E-02
     +,   5.5437062E-02,   5.6832135E-02,   5.8269959E-02
     +,   5.9741654E-02,   6.1236601E-02,   6.2742874E-02
     +,   6.4247228E-02,   6.5735444E-02,   6.7192458E-02
     +,   6.8602875E-02,   6.9951095E-02,   7.1221747E-02
     +,   7.2399817E-02,   7.3471464E-02,   7.4423917E-02
     +,   7.5245894E-02,   7.5928055E-02,   7.6463148E-02
     +,   7.6846503E-02,   7.7075757E-02,   7.7151760E-02
     +,   7.7078380E-02,   7.6862790E-02,   7.6515846E-02
     +,   7.6052129E-02,   7.5490214E-02,   7.4853227E-02
     +,   7.4168816E-02,   7.3469669E-02,   7.2793789E-02
     +,   7.2184682E-02,   7.1691990E-02,   7.1370997E-02
     +,   7.1282946E-02,   7.1494430E-02,   7.2076395E-02
     +,   7.3103018E-02,   7.4649371E-02,   7.6788843E-02
     +,   7.9590082E-02,   8.3113343E-02,   8.7406330E-02
     +,   9.2500687E-02,   9.8409370E-02,   0.1051243    
     +,   0.1126154    ,   0.1208315    ,   0.1297038    
     +,   0.1391500    ,   0.1490770    ,   0.1593906    
     +,   0.1699985    ,   0.1808145    ,   0.1917631    
     +,   0.2027798    ,   0.2138111    ,   0.2248102    
     +,   0.2357355    ,   0.2465501    ,   0.2572240    
     +,   0.2677414    ,   0.2781139    ,   0.2883992    
     +,   0.2987137    ,   0.3092355    ,   0.3201992    
     +,   0.3318750    ,   0.3445482    ,   0.3585190    
     +,   0.3741342    ,   0.3918481    ,   0.4122837    
     +,   0.4362468    ,   0.4646387    ,   0.4982420    
     +,   0.5374291    ,   0.5818982    ,   0.6305832    
     +,   0.6818187    ,   0.7337760    ,   0.7850671    
     +,   0.8352685    ,   0.8851951    ,   0.9368196    
     +,   0.9928930    ,    1.056315    ,    1.129301    
     +,    1.212301    ,    1.302845    ,    1.394940    
     +,    1.479878    ,    1.548736    ,    1.595584    
     +,    1.619674    ,    1.625508    ,    1.621195    
     +,    1.616342    ,    1.619919    ,    1.637661    
     +,    1.668924    ,    1.704770    ,    1.729722    
     +,    1.727532    ,    1.688002    ,    1.610594    
     +,    1.502957    ,    1.376063    ,    1.239597    
     +,    1.100025    ,   0.9612612    ,   0.8262588    
     +,   0.6980898    ,   0.5800182    ,   0.4749126    
     +,   0.3846148    ,   0.3096388    ,   0.2492408    
     +,   0.2017475    ,   0.1649908    ,   0.1367184    
     +,   0.1148829    ,   9.7792700E-02,   8.4148169E-02
     +,   7.3006168E-02,   6.3709021E-02,   5.5806857E-02
     +,   4.8995063E-02,   4.3066472E-02,   3.7877597E-02
     +,   3.3325963E-02,   2.9335646E-02,   2.5847528E-02
     +,   2.2812298E-02,   2.0185992E-02,   1.7927561E-02
     +,   1.5997695E-02,   1.4358093E-02,   1.2971490E-02
     +,   1.1802274E-02,   1.0817105E-02,   9.9852392E-03
     +,   9.2791077E-03,   8.6746151E-03,   8.1511550E-03
     +,   7.6915147E-03,   7.2816843E-03,   6.9105639E-03
     +,   6.5695425E-03,   6.2520872E-03,   5.9533799E-03
     +,   5.6699887E-03,   5.3994935E-03,   5.1402911E-03
     +,   4.8913169E-03,   4.6519386E-03,   4.4217650E-03
     +,   4.2006052E-03,   3.9883400E-03,   3.7849275E-03
     +,   3.5903093E-03,   3.4044452E-03,   3.2272497E-03
     +,   3.0586063E-03,   2.8983795E-03,   2.7463771E-03
     +,   2.6023944E-03,   2.4661778E-03,   2.3374686E-03
     +,   2.2159712E-03,   2.1013906E-03,   1.9934077E-03
     +,   1.8917108E-03,   1.7959739E-03,   1.7058856E-03
     +,   1.6211272E-03,   1.5413975E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_hzonly_htt105_mass = Yx/14.8473095909091
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_hzonly_htt107_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.5241633E-03,   3.6413297E-03
     +,   3.7614149E-03,   3.8844380E-03,   4.0104091E-03
     +,   4.1393340E-03,   4.2712083E-03,   4.4060247E-03
     +,   4.5437627E-03,   4.6843998E-03,   4.8279003E-03
     +,   4.9742209E-03,   5.1233103E-03,   5.2751089E-03
     +,   5.4295487E-03,   5.5865510E-03,   5.7460321E-03
     +,   5.9078997E-03,   6.0720523E-03,   6.2383818E-03
     +,   6.4067747E-03,   6.5771122E-03,   6.7492649E-03
     +,   6.9231102E-03,   7.0985053E-03,   7.2753183E-03
     +,   7.4534100E-03,   7.6326346E-03,   7.8128558E-03
     +,   7.9939244E-03,   8.1757018E-03,   8.3580445E-03
     +,   8.5408119E-03,   8.7238662E-03,   8.9070732E-03
     +,   9.0902923E-03,   9.2734005E-03,   9.4562611E-03
     +,   9.6387602E-03,   9.8207649E-03,   1.0002162E-02
     +,   1.0182831E-02,   1.0362655E-02,   1.0541526E-02
     +,   1.0719329E-02,   1.0895956E-02,   1.1071295E-02
     +,   1.1245248E-02,   1.1417699E-02,   1.1588548E-02
     +,   1.1757701E-02,   1.1925047E-02,   1.2090501E-02
     +,   1.2253974E-02,   1.2415378E-02,   1.2574643E-02
     +,   1.2731707E-02,   1.2886523E-02,   1.3039063E-02
     +,   1.3189318E-02,   1.3337296E-02,   1.3483056E-02
     +,   1.3626670E-02,   1.3768254E-02,   1.3907987E-02
     +,   1.4046070E-02,   1.4182788E-02,   1.4318466E-02
     +,   1.4453514E-02,   1.4588398E-02,   1.4723687E-02
     +,   1.4860026E-02,   1.4998143E-02,   1.5138868E-02
     +,   1.5283145E-02,   1.5432007E-02,   1.5586597E-02
     +,   1.5748173E-02,   1.5918097E-02,   1.6097864E-02
     +,   1.6289055E-02,   1.6493380E-02,   1.6712628E-02
     +,   1.6948709E-02,   1.7203612E-02,   1.7479397E-02
     +,   1.7778182E-02,   1.8102158E-02,   1.8453496E-02
     +,   1.8834390E-02,   1.9246999E-02,   1.9693427E-02
     +,   2.0175625E-02,   2.0695440E-02,   2.1254566E-02
     +,   2.1854356E-02,   2.2495994E-02,   2.3180213E-02
     +,   2.3907473E-02,   2.4677675E-02,   2.5490351E-02
     +,   2.6344405E-02,   2.7238285E-02,   2.8169757E-02
     +,   2.9136047E-02,   3.0133834E-02,   3.1159112E-02
     +,   3.2207336E-02,   3.3273514E-02,   3.4352235E-02
     +,   3.5437580E-02,   3.6523547E-02,   3.7603810E-02
     +,   3.8672104E-02,   3.9722133E-02,   4.0747982E-02
     +,   4.1743867E-02,   4.2704623E-02,   4.3625552E-02
     +,   4.4502679E-02,   4.5332812E-02,   4.6113521E-02
     +,   4.6843182E-02,   4.7521189E-02,   4.8147678E-02
     +,   4.8723653E-02,   4.9250986E-02,   4.9732160E-02
     +,   5.0170448E-02,   5.0569642E-02,   5.0934199E-02
     +,   5.1268939E-02,   5.1579319E-02,   5.1871158E-02
     +,   5.2150894E-02,   5.2425433E-02,   5.2702412E-02
     +,   5.2990135E-02,   5.3297855E-02,   5.3635739E-02
     +,   5.4015048E-02,   5.4448169E-02,   5.4948781E-02
     +,   5.5531785E-02,   5.6213245E-02,   5.7010438E-02
     +,   5.7941724E-02,   5.9026256E-02,   6.0283888E-02
     +,   6.1735045E-02,   6.3400395E-02,   6.5300353E-02
     +,   6.7454800E-02,   6.9882803E-02,   7.2601870E-02
     +,   7.5626962E-02,   7.8970075E-02,   8.2639471E-02
     +,   8.6638793E-02,   9.0966173E-02,   9.5614761E-02
     +,   0.1005731    ,   0.1058253    ,   0.1113541    
     +,   0.1171434    ,   0.1231817    ,   0.1294653    
     +,   0.1360019    ,   0.1428134    ,   0.1499356    
     +,   0.1574161    ,   0.1653093    ,   0.1736697    
     +,   0.1825421    ,   0.1919512    ,   0.2018956    
     +,   0.2123441    ,   0.2232356    ,   0.2344876    
     +,   0.2460092    ,   0.2577141    ,   0.2695346    
     +,   0.2814326    ,   0.2934044    ,   0.3054810    
     +,   0.3177216    ,   0.3302101    ,   0.3430548    
     +,   0.3563903    ,   0.3703837    ,   0.3852357    
     +,   0.4011633    ,   0.4183527    ,   0.4368967    
     +,   0.4567357    ,   0.4776472    ,   0.4993268    
     +,   0.5215747    ,   0.5445396    ,   0.5689285    
     +,   0.5960730    ,   0.6277689    ,   0.6659011    
     +,   0.7119021    ,   0.7661557    ,   0.8275356    
     +,   0.8932043    ,   0.9588752    ,    1.019639    
     +,    1.071183    ,    1.110962    ,    1.138811    
     +,    1.156824    ,    1.168790    ,    1.179698    
     +,    1.195378    ,    1.221774    ,    1.263476    
     +,    1.321964    ,    1.394660    ,    1.475517    
     +,    1.556682    ,    1.630134    ,    1.688771    
     +,    1.727058    ,    1.741444    ,    1.730439    
     +,    1.694100    ,    1.633300    ,    1.549439    
     +,    1.444879    ,    1.323513    ,    1.190829    
     +,    1.053247    ,   0.9171477    ,   0.7879685    
     +,   0.6696815    ,   0.5646369    ,   0.4736696    
     +,   0.3964171    ,   0.3317398    ,   0.2781124    
     +,   0.2339020    ,   0.1975386    ,   0.1676038    
     +,   0.1428716    ,   0.1223230    ,   0.1051471    
     +,   9.0725377E-02,   7.8598872E-02,   6.8421893E-02
     +,   5.9921093E-02,   5.2863449E-02,   4.7036167E-02
     +,   4.2239383E-02,   3.8287353E-02,   3.5012573E-02
     +,   3.2269329E-02,   2.9935619E-02,   2.7913358E-02
     +,   2.6126638E-02,   2.4518646E-02,   2.3048284E-02
     +,   2.1686926E-02,   2.0415567E-02,   1.9221885E-02
     +,   1.8098282E-02,   1.7040269E-02,   1.6045099E-02
     +,   1.5110831E-02,   1.4235779E-02,   1.3418230E-02
     +,   1.2656174E-02,   1.1947189E-02,   1.1288530E-02
     +,   1.0677248E-02,   1.0110134E-02,   9.5839603E-03
     +,   9.0954369E-03,   8.6414097E-03,   8.2187997E-03
     +,   7.8247748E-03,   7.4566593E-03,   7.1120500E-03
     +,   6.7887451E-03,   6.4848126E-03,   6.1985115E-03
     +,   5.9283152E-03,   5.6729107E-03,   5.4311217E-03
     +,   5.2019539E-03,   4.9845101E-03,   4.7780350E-03
     +,   4.5818374E-03,   4.3953233E-03,   4.2179436E-03
     +,   4.0492169E-03,   3.8886801E-03,   3.7359239E-03
     +,   3.5905447E-03,   3.4521765E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_hzonly_htt107_mass = Yx/14.8346087272727
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_hzonly_htt110_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  5.5109812E-03,   5.6728432E-03
     +,   5.8352239E-03,   5.9979525E-03,   6.1608618E-03
     +,   6.3237860E-03,   6.4865681E-03,   6.6490546E-03
     +,   6.8110954E-03,   6.9725555E-03,   7.1333004E-03
     +,   7.2932066E-03,   7.4521587E-03,   7.6100510E-03
     +,   7.7667898E-03,   7.9222834E-03,   8.0764573E-03
     +,   8.2292454E-03,   8.3805909E-03,   8.5304435E-03
     +,   8.6787669E-03,   8.8255331E-03,   8.9707170E-03
     +,   9.1143129E-03,   9.2563061E-03,   9.3967039E-03
     +,   9.5355101E-03,   9.6727349E-03,   9.8083979E-03
     +,   9.9425148E-03,   1.0075111E-02,   1.0206202E-02
     +,   1.0335812E-02,   1.0463967E-02,   1.0590680E-02
     +,   1.0715971E-02,   1.0839851E-02,   1.0962331E-02
     +,   1.1083416E-02,   1.1203098E-02,   1.1321368E-02
     +,   1.1438211E-02,   1.1553604E-02,   1.1667506E-02
     +,   1.1779879E-02,   1.1890672E-02,   1.1999824E-02
     +,   1.2107265E-02,   1.2212921E-02,   1.2316704E-02
     +,   1.2418522E-02,   1.2518275E-02,   1.2615856E-02
     +,   1.2711152E-02,   1.2804053E-02,   1.2894432E-02
     +,   1.2982177E-02,   1.3067161E-02,   1.3149269E-02
     +,   1.3228387E-02,   1.3304397E-02,   1.3377212E-02
     +,   1.3446725E-02,   1.3512860E-02,   1.3575559E-02
     +,   1.3634758E-02,   1.3690441E-02,   1.3742587E-02
     +,   1.3791219E-02,   1.3836375E-02,   1.3878132E-02
     +,   1.3916590E-02,   1.3951896E-02,   1.3984212E-02
     +,   1.4013764E-02,   1.4040807E-02,   1.4065645E-02
     +,   1.4088621E-02,   1.4110140E-02,   1.4130650E-02
     +,   1.4150657E-02,   1.4170721E-02,   1.4191462E-02
     +,   1.4213567E-02,   1.4237778E-02,   1.4264922E-02
     +,   1.4295884E-02,   1.4331654E-02,   1.4373272E-02
     +,   1.4421894E-02,   1.4478780E-02,   1.4545275E-02
     +,   1.4622858E-02,   1.4713150E-02,   1.4817892E-02
     +,   1.4939002E-02,   1.5078578E-02,   1.5238889E-02
     +,   1.5422440E-02,   1.5631961E-02,   1.5870439E-02
     +,   1.6141128E-02,   1.6447617E-02,   1.6793747E-02
     +,   1.7183762E-02,   1.7622232E-02,   1.8114058E-02
     +,   1.8664498E-02,   1.9279167E-02,   1.9964037E-02
     +,   2.0725263E-02,   2.1569364E-02,   2.2502866E-02
     +,   2.3532519E-02,   2.4664883E-02,   2.5906464E-02
     +,   2.7263308E-02,   2.8741106E-02,   3.0344659E-02
     +,   3.2078031E-02,   3.3944149E-02,   3.5944507E-02
     +,   3.8079046E-02,   4.0346079E-02,   4.2742006E-02
     +,   4.5260977E-02,   4.7895204E-02,   5.0634358E-02
     +,   5.3466190E-02,   5.6375843E-02,   5.9346803E-02
     +,   6.2360171E-02,   6.5395787E-02,   6.8431683E-02
     +,   7.1445286E-02,   7.4413404E-02,   7.7312693E-02
     +,   8.0120355E-02,   8.2814910E-02,   8.5376807E-02
     +,   8.7788709E-02,   9.0036623E-02,   9.2110664E-02
     +,   9.4005525E-02,   9.5720701E-02,   9.7261801E-02
     +,   9.8640308E-02,   9.9873468E-02,   0.1009848    
     +,   0.1020032    ,   0.1029621    ,   0.1038984    
     +,   0.1048512    ,   0.1058594    ,   0.1069604    
     +,   0.1081875    ,   0.1095678    ,   0.1111211    
     +,   0.1128577    ,   0.1147782    ,   0.1168738    
     +,   0.1191270    ,   0.1215140    ,   0.1240072    
     +,   0.1265798    ,   0.1292099    ,   0.1318855    
     +,   0.1346096    ,   0.1374055    ,   0.1403210    
     +,   0.1434308    ,   0.1468397    ,   0.1506806    
     +,   0.1551113    ,   0.1603060    ,   0.1664430    
     +,   0.1736889    ,   0.1821765    ,   0.1919856    
     +,   0.2031266    ,   0.2155321    ,   0.2290610    
     +,   0.2435234    ,   0.2587196    ,   0.2744907    
     +,   0.2907702    ,   0.3076220    ,   0.3252542    
     +,   0.3439888    ,   0.3641968    ,   0.3862080    
     +,   0.4102181    ,   0.4362277    ,   0.4640429    
     +,   0.4933521    ,   0.5238364    ,   0.5552808    
     +,   0.5876261    ,   0.6209245    ,   0.6552225    
     +,   0.6904570    ,   0.7264900    ,   0.7633549    
     +,   0.8016625    ,   0.8429155    ,   0.8893862    
     +,   0.9432555    ,    1.005163    ,    1.072913    
     +,    1.141398    ,    1.204327    ,    1.257163    
     +,    1.299488    ,    1.335146    ,    1.370052    
     +,    1.409215    ,    1.454783    ,    1.505727    
     +,    1.558600    ,    1.608793    ,    1.651897    
     +,    1.684716    ,    1.705437    ,    1.713244    
     +,    1.708221    ,    1.691736    ,    1.666100    
     +,    1.632731    ,    1.590072    ,    1.533671    
     +,    1.459085    ,    1.365475    ,    1.256997    
     +,    1.141154    ,    1.025694    ,   0.9161752    
     +,   0.8153028    ,   0.7236277    ,   0.6406490    
     +,   0.5656449    ,   0.4980264    ,   0.4373520    
     +,   0.3832081    ,   0.3351238    ,   0.2925761    
     +,   0.2550382    ,   0.2220297    ,   0.1931326    
     +,   0.1679823    ,   0.1462397    ,   0.1275588    
     +,   0.1115773    ,   9.7923085E-02,   8.6229779E-02
     +,   7.6157615E-02,   6.7411236E-02,   5.9749395E-02
     +,   5.2984577E-02,   4.6976443E-02,   4.1622326E-02
     +,   3.6847014E-02,   3.2592658E-02,   2.8811553E-02
     +,   2.5461830E-02,   2.2505060E-02,   1.9904457E-02
     +,   1.7624948E-02,   1.5633391E-02,   1.3898606E-02
     +,   1.2391501E-02,   1.1085308E-02,   9.9556968E-03
     +,   8.9806020E-03,   8.1401132E-03,   7.4164211E-03
     +,   6.7937635E-03,   6.2581152E-03,   5.7972083E-03
     +,   5.4002465E-03,   5.0578741E-03,   4.7619292E-03
     +,   4.5053903E-03,   4.2821746E-03,   4.0870840E-03
     +,   3.9156377E-03,   3.7640315E-03,   3.6290023E-03
     +,   3.5077869E-03,   3.3980552E-03,   3.2978291E-03
     +,   3.2054626E-03,   3.1195728E-03,   3.0390203E-03
     +,   2.9628598E-03,   2.8903258E-03,   2.8207893E-03
     +,   2.7537532E-03,   2.6888147E-03,   2.6256638E-03
     +,   2.5640540E-03,   2.5038046E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_hzonly_htt110_mass = Yx/16.1938833777778
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_hzonly_htt115_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  5.1437984E-03,   5.2556028E-03
     +,   5.3656455E-03,   5.4737693E-03,   5.5798311E-03
     +,   5.6836954E-03,   5.7852357E-03,   5.8843410E-03
     +,   5.9809084E-03,   6.0748574E-03,   6.1661135E-03
     +,   6.2546204E-03,   6.3403388E-03,   6.4232447E-03
     +,   6.5033301E-03,   6.5806056E-03,   6.6551003E-03
     +,   6.7268568E-03,   6.7959386E-03,   6.8624262E-03
     +,   6.9264155E-03,   6.9880220E-03,   7.0473733E-03
     +,   7.1046166E-03,   7.1599106E-03,   7.2134295E-03
     +,   7.2653629E-03,   7.3159062E-03,   7.3652687E-03
     +,   7.4136672E-03,   7.4613295E-03,   7.5084809E-03
     +,   7.5553618E-03,   7.6022078E-03,   7.6492582E-03
     +,   7.6967492E-03,   7.7449149E-03,   7.7939839E-03
     +,   7.8441827E-03,   7.8957230E-03,   7.9488084E-03
     +,   8.0036363E-03,   8.0603808E-03,   8.1192059E-03
     +,   8.1802653E-03,   8.2436884E-03,   8.3095878E-03
     +,   8.3780577E-03,   8.4491726E-03,   8.5229930E-03
     +,   8.5995449E-03,   8.6788554E-03,   8.7609133E-03
     +,   8.8457027E-03,   8.9331828E-03,   9.0233004E-03
     +,   9.1159884E-03,   9.2111686E-03,   9.3087517E-03
     +,   9.4086416E-03,   9.5107378E-03,   9.6149389E-03
     +,   9.7211450E-03,   9.8292613E-03,   9.9392133E-03
     +,   1.0050917E-02,   1.0164332E-02,   1.0279412E-02
     +,   1.0396160E-02,   1.0514587E-02,   1.0634748E-02
     +,   1.0756731E-02,   1.0880660E-02,   1.1006703E-02
     +,   1.1135066E-02,   1.1266017E-02,   1.1399852E-02
     +,   1.1536930E-02,   1.1677644E-02,   1.1822456E-02
     +,   1.1971864E-02,   1.2126418E-02,   1.2286708E-02
     +,   1.2453377E-02,   1.2627093E-02,   1.2808580E-02
     +,   1.2998580E-02,   1.3197870E-02,   1.3407234E-02
     +,   1.3627492E-02,   1.3859472E-02,   1.4103997E-02
     +,   1.4361871E-02,   1.4633939E-02,   1.4920997E-02
     +,   1.5223819E-02,   1.5543181E-02,   1.5879793E-02
     +,   1.6234383E-02,   1.6607590E-02,   1.7000081E-02
     +,   1.7412417E-02,   1.7845204E-02,   1.8298952E-02
     +,   1.8774210E-02,   1.9271499E-02,   1.9791340E-02
     +,   2.0334233E-02,   2.0900778E-02,   2.1491596E-02
     +,   2.2107366E-02,   2.2748888E-02,   2.3417035E-02
     +,   2.4112875E-02,   2.4837546E-02,   2.5592456E-02
     +,   2.6379101E-02,   2.7199248E-02,   2.8054757E-02
     +,   2.8947737E-02,   2.9880434E-02,   3.0855183E-02
     +,   3.1874329E-02,   3.2940313E-02,   3.4055471E-02
     +,   3.5221886E-02,   3.6441471E-02,   3.7715632E-02
     +,   3.9045401E-02,   4.0430985E-02,   4.1872062E-02
     +,   4.3367188E-02,   4.4914242E-02,   4.6509791E-02
     +,   4.8149507E-02,   4.9827937E-02,   5.1538464E-02
     +,   5.3273402E-02,   5.5024240E-02,   5.6781758E-02
     +,   5.8535904E-02,   6.0276318E-02,   6.1992630E-02
     +,   6.3674591E-02,   6.5312244E-02,   6.6896580E-02
     +,   6.8419620E-02,   6.9874704E-02,   7.1256779E-02
     +,   7.2562650E-02,   7.3791169E-02,   7.4943110E-02
     +,   7.6021358E-02,   7.7030823E-02,   7.7978358E-02
     +,   7.8872263E-02,   7.9722255E-02,   8.0539055E-02
     +,   8.1334278E-02,   8.2119785E-02,   8.2907863E-02
     +,   8.3710991E-02,   8.4541894E-02,   8.5413910E-02
     +,   8.6341523E-02,   8.7341025E-02,   8.8431641E-02
     +,   8.9636587E-02,   9.0984449E-02,   9.2510380E-02
     +,   9.4256707E-02,   9.6274011E-02,   9.8620884E-02
     +,   0.1013623    ,   0.1045681    ,   0.1083099    
     +,   0.1126576    ,   0.1176748    ,   0.1234155    
     +,   0.1299233    ,   0.1372301    ,   0.1453585    
     +,   0.1543268    ,   0.1641549    ,   0.1748691    
     +,   0.1865040    ,   0.1991009    ,   0.2127017    
     +,   0.2273371    ,   0.2430128    ,   0.2597046    
     +,   0.2773564    ,   0.2958906    ,   0.3152349    
     +,   0.3353611    ,   0.3563336    ,   0.3783618    
     +,   0.4018502    ,   0.4274239    ,   0.4558912    
     +,   0.4881261    ,   0.5248593    ,   0.5664207    
     +,   0.6125026    ,   0.6620308    ,   0.7132202    
     +,   0.7637714    ,   0.8111910    ,   0.8531705    
     +,   0.8879871    ,   0.9148908    ,   0.9344096    
     +,   0.9484627    ,   0.9601821    ,   0.9733939    
     +,   0.9918360    ,    1.018284    ,    1.053950    
     +,    1.098467    ,    1.150528    ,    1.208740    
     +,    1.271871    ,    1.338218    ,    1.404647    
     +,    1.466357    ,    1.517797    ,    1.554278    
     +,    1.573249    ,    1.574702    ,    1.560797    
     +,    1.534899    ,    1.500287    ,    1.459002    
     +,    1.411506    ,    1.357408    ,    1.296589    
     +,    1.229898    ,    1.158970    ,    1.085521    
     +,    1.010724    ,   0.9350908    ,   0.8588311    
     +,   0.7823843    ,   0.7067817    ,   0.6336442    
     +,   0.5648193    ,   0.5018637    ,   0.4456420    
     +,   0.3962176    ,   0.3530149    ,   0.3151151    
     +,   0.2815601    ,   0.2515503    ,   0.2245129    
     +,   0.2000801    ,   0.1780284    ,   0.1582130    
     +,   0.1405145    ,   0.1248078    ,   0.1109499    
     +,   9.8780893E-02,   8.8128895E-02,   7.8818716E-02
     +,   7.0681266E-02,   6.3560449E-02,   5.7315830E-02
     +,   5.1825128E-02,   4.6984613E-02,   4.2707291E-02
     +,   3.8920723E-02,   3.5564985E-02,   3.2590482E-02
     +,   2.9955402E-02,   2.7623605E-02,   2.5563382E-02
     +,   2.3746392E-02,   2.2146510E-02,   2.0739846E-02
     +,   1.9504046E-02,   1.8418618E-02,   1.7464545E-02
     +,   1.6624566E-02,   1.5882952E-02,   1.5225643E-02
     +,   1.4640028E-02,   1.4114996E-02,   1.3640728E-02
     +,   1.3208607E-02,   1.2811180E-02,   1.2441919E-02
     +,   1.2095243E-02,   1.1766311E-02,   1.1451055E-02
     +,   1.1145999E-02,   1.0848287E-02,   1.0555539E-02
     +,   1.0265881E-02,   9.9778185E-03,   9.6902689E-03
     +,   9.4024390E-03,   9.1138603E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_hzonly_htt115_mass = Yx/15.1755563555556
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_hzonly_htt120_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.8256758E-03,   2.9282412E-03
     +,   3.0359034E-03,   3.1489418E-03,   3.2676400E-03
     +,   3.3922896E-03,   3.5231847E-03,   3.6606186E-03
     +,   3.8048828E-03,   3.9562718E-03,   4.1150688E-03
     +,   4.2815488E-03,   4.4559743E-03,   4.6385936E-03
     +,   4.8296363E-03,   5.0293077E-03,   5.2377870E-03
     +,   5.4552229E-03,   5.6817294E-03,   5.9173801E-03
     +,   6.1622052E-03,   6.4161904E-03,   6.6792620E-03
     +,   6.9513102E-03,   7.2321356E-03,   7.5215097E-03
     +,   7.8191208E-03,   8.1245955E-03,   8.4374882E-03
     +,   8.7572895E-03,   9.0834200E-03,   9.4152279E-03
     +,   9.7519951E-03,   1.0092937E-02,   1.0437205E-02
     +,   1.0783897E-02,   1.1132046E-02,   1.1480637E-02
     +,   1.1828636E-02,   1.2174932E-02,   1.2518424E-02
     +,   1.2857970E-02,   1.3192430E-02,   1.3520651E-02
     +,   1.3841504E-02,   1.4153875E-02,   1.4456683E-02
     +,   1.4748883E-02,   1.5029494E-02,   1.5297591E-02
     +,   1.5552320E-02,   1.5792916E-02,   1.6018696E-02
     +,   1.6229099E-02,   1.6423628E-02,   1.6601941E-02
     +,   1.6763790E-02,   1.6909055E-02,   1.7037727E-02
     +,   1.7149929E-02,   1.7245909E-02,   1.7326031E-02
     +,   1.7390775E-02,   1.7440736E-02,   1.7476620E-02
     +,   1.7499214E-02,   1.7509421E-02,   1.7508209E-02
     +,   1.7496621E-02,   1.7475758E-02,   1.7446784E-02
     +,   1.7410891E-02,   1.7369289E-02,   1.7323207E-02
     +,   1.7273882E-02,   1.7222537E-02,   1.7170371E-02
     +,   1.7118545E-02,   1.7068177E-02,   1.7020348E-02
     +,   1.6976055E-02,   1.6936239E-02,   1.6901759E-02
     +,   1.6873406E-02,   1.6851863E-02,   1.6837742E-02
     +,   1.6831553E-02,   1.6833723E-02,   1.6844580E-02
     +,   1.6864365E-02,   1.6893229E-02,   1.6931245E-02
     +,   1.6978383E-02,   1.7034564E-02,   1.7099630E-02
     +,   1.7173335E-02,   1.7255414E-02,   1.7345510E-02
     +,   1.7443243E-02,   1.7548189E-02,   1.7659888E-02
     +,   1.7777866E-02,   1.7901618E-02,   1.8030619E-02
     +,   1.8164363E-02,   1.8302331E-02,   1.8444007E-02
     +,   1.8588886E-02,   1.8736482E-02,   1.8886335E-02
     +,   1.9037981E-02,   1.9191021E-02,   1.9345062E-02
     +,   1.9499751E-02,   1.9654771E-02,   1.9809844E-02
     +,   1.9964734E-02,   2.0119248E-02,   2.0273233E-02
     +,   2.0426577E-02,   2.0579252E-02,   2.0731252E-02
     +,   2.0882618E-02,   2.1033468E-02,   2.1183981E-02
     +,   2.1334404E-02,   2.1485034E-02,   2.1636266E-02
     +,   2.1788582E-02,   2.1942537E-02,   2.2098796E-02
     +,   2.2258151E-02,   2.2421513E-02,   2.2589926E-02
     +,   2.2764640E-02,   2.2947079E-02,   2.3138873E-02
     +,   2.3341905E-02,   2.3558380E-02,   2.3790803E-02
     +,   2.4042085E-02,   2.4315482E-02,   2.4614798E-02
     +,   2.4944320E-02,   2.5308860E-02,   2.5713863E-02
     +,   2.6165329E-02,   2.6669929E-02,   2.7234880E-02
     +,   2.7868012E-02,   2.8577652E-02,   2.9372515E-02
     +,   3.0261509E-02,   3.1253714E-02,   3.2358058E-02
     +,   3.3583026E-02,   3.4936387E-02,   3.6424920E-02
     +,   3.8054224E-02,   3.9827857E-02,   4.1747667E-02
     +,   4.3813150E-02,   4.6021156E-02,   4.8365761E-02
     +,   5.0838422E-02,   5.3427983E-02,   5.6120548E-02
     +,   5.8900282E-02,   6.1750136E-02,   6.4652480E-02
     +,   6.7590378E-02,   7.0549004E-02,   7.3517874E-02
     +,   7.6492399E-02,   7.9475991E-02,   8.2482919E-02
     +,   8.5539900E-02,   8.8687696E-02,   9.1982305E-02
     +,   9.5495105E-02,   9.9311486E-02,   0.1035281    
     +,   0.1082490    ,   0.1135804    ,   0.1196247    
     +,   0.1264727    ,   0.1341974    ,   0.1428497    
     +,   0.1524542    ,   0.1630082    ,   0.1744863    
     +,   0.1868459    ,   0.2000365    ,   0.2140096    
     +,   0.2287316    ,   0.2441934    ,   0.2604179    
     +,   0.2774699    ,   0.2954621    ,   0.3145554    
     +,   0.3349455    ,   0.3568380    ,   0.3804058    
     +,   0.4057432    ,   0.4328335    ,   0.4615699    
     +,   0.4918267    ,   0.5235619    ,   0.5569119    
     +,   0.5922003    ,   0.6298335    ,   0.6700999    
     +,   0.7129717    ,   0.7579992    ,   0.8043298    
     +,   0.8508525    ,   0.8963450    ,   0.9396000    
     +,   0.9795507    ,    1.015515    ,    1.047573    
     +,    1.076833    ,    1.105280    ,    1.135097    
     +,    1.167793    ,    1.203680    ,    1.242008    
     +,    1.281483    ,    1.320585    ,    1.357466    
     +,    1.389674    ,    1.414193    ,    1.428011    
     +,    1.429044    ,    1.417038    ,    1.393908    
     +,    1.363052    ,    1.327763    ,    1.289549    
     +,    1.247547    ,    1.199507    ,    1.143735    
     +,    1.080657    ,    1.013052    ,   0.9449496    
     +,   0.8799904    ,   0.8201911    ,   0.7656033    
     +,   0.7148520    ,   0.6660531    ,   0.6176590    
     +,   0.5689479    ,   0.5200977    ,   0.4719611    
     +,   0.4257193    ,   0.3825518    ,   0.3433890    
     +,   0.3087654    ,   0.2787743    ,   0.2531117    
     +,   0.2311803    ,   0.2122249    ,   0.1954680    
     +,   0.1802244    ,   0.1659736    ,   0.1523813    
     +,   0.1392879    ,   0.1266718    ,   0.1146000    
     +,   0.1031819    ,   9.2531465E-02,   8.2743011E-02
     +,   7.3875830E-02,   6.5949485E-02,   5.8946803E-02
     +,   5.2820832E-02,   4.7501642E-02,   4.2906184E-02
     +,   3.8944419E-02,   3.5526689E-02,   3.2567259E-02
     +,   2.9988328E-02,   2.7721036E-02,   2.5706824E-02
     +,   2.3896817E-02,   2.2251690E-02,   2.0740274E-02
     +,   1.9338559E-02,   1.8028663E-02,   1.6797300E-02
     +,   1.5635133E-02,   1.4535505E-02,   1.3493967E-02
     +,   1.2507393E-02,   1.1573759E-02,   1.0691478E-02
     +,   9.8594157E-03,   9.0764286E-03,   8.3414642E-03
     +,   7.6532695E-03,   7.0105558E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_hzonly_htt120_mass = Yx/14.5170871363636
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_hzonly_htt60_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.4232890E-02,   5.0600093E-02
     +,   5.7802290E-02,   6.5972783E-02,   7.5278535E-02
     +,   8.5929036E-02,   9.8183937E-02,   0.1123586    
     +,   0.1288228    ,   0.1479923    ,   0.1703045    
     +,   0.1961840    ,   0.2259927    ,   0.2599697    
     +,   0.2981705    ,   0.3404242    ,   0.3863367    
     +,   0.4353816    ,   0.4871101    ,   0.5414757    
     +,   0.5992060    ,   0.6620447    ,   0.7326313    
     +,   0.8138314    ,   0.9075409    ,    1.013500    
     +,    1.128898    ,    1.249532    ,    1.372315    
     +,    1.497696    ,    1.629684    ,    1.772393    
     +,    1.924672    ,    2.077264    ,    2.216158    
     +,    2.330718    ,    2.419508    ,    2.488020    
     +,    2.540351    ,    2.573758    ,    2.581620    
     +,    2.560524    ,    2.512983    ,    2.443731    
     +,    2.355560    ,    2.250356    ,    2.133352    
     +,    2.014245    ,    1.902829    ,    1.803326    
     +,    1.712756    ,    1.624362    ,    1.532586    
     +,    1.435977    ,    1.336967    ,    1.239790    
     +,    1.148305    ,    1.064707    ,   0.9893228    
     +,   0.9211710    ,   0.8588046    ,   0.8009884    
     +,   0.7470028    ,   0.6965625    ,   0.6495672    
     +,   0.6058895    ,   0.5652752    ,   0.5273867    
     +,   0.4918675    ,   0.4584287    ,   0.4268774    
     +,   0.3971386    ,   0.3692379    ,   0.3432765    
     +,   0.3193858    ,   0.2976831    ,   0.2782350    
     +,   0.2610308    ,   0.2459760    ,   0.2329060    
     +,   0.2216072    ,   0.2118414    ,   0.2033701    
     +,   0.1959692    ,   0.1894390    ,   0.1836057    
     +,   0.1783212    ,   0.1734574    ,   0.1689048    
     +,   0.1645683    ,   0.1603671    ,   0.1562345    
     +,   0.1521178    ,   0.1479793    ,   0.1437958    
     +,   0.1395592    ,   0.1352732    ,   0.1309528    
     +,   0.1266213    ,   0.1223082    ,   0.1180461    
     +,   0.1138690    ,   0.1098094    ,   0.1058980    
     +,   0.1021610    ,   9.8620132E-02,   9.5291793E-02
     +,   9.2187166E-02,   8.9311764E-02,   8.6666174E-02
     +,   8.4246673E-02,   8.2045406E-02,   8.0051631E-02
     +,   7.8251898E-02,   7.6631285E-02,   7.5173669E-02
     +,   7.3862612E-02,   7.2681576E-02,   7.1614616E-02
     +,   7.0646398E-02,   6.9762498E-02,   6.8949647E-02
     +,   6.8195522E-02,   6.7488909E-02,   6.6819400E-02
     +,   6.6177696E-02,   6.5555148E-02,   6.4943783E-02
     +,   6.4336240E-02,   6.3725829E-02,   6.3106254E-02
     +,   6.2471736E-02,   6.1817046E-02,   6.1137553E-02
     +,   6.0429171E-02,   5.9688523E-02,   5.8913004E-02
     +,   5.8100894E-02,   5.7251301E-02,   5.6364220E-02
     +,   5.5440813E-02,   5.4483101E-02,   5.3494126E-02
     +,   5.2477863E-02,   5.1439218E-02,   5.0383836E-02
     +,   4.9317997E-02,   4.8248652E-02,   4.7183052E-02
     +,   4.6128735E-02,   4.5093223E-02,   4.4084053E-02
     +,   4.3108486E-02,   4.2173326E-02,   4.1284811E-02
     +,   4.0448554E-02,   3.9669424E-02,   3.8951315E-02
     +,   3.8297195E-02,   3.7709154E-02,   3.7188210E-02
     +,   3.6734413E-02,   3.6346857E-02,   3.6023729E-02
     +,   3.5762381E-02,   3.5559341E-02,   3.5410494E-02
     +,   3.5311181E-02,   3.5256185E-02,   3.5239987E-02
     +,   3.5256799E-02,   3.5300676E-02,   3.5365656E-02
     +,   3.5445828E-02,   3.5535444E-02,   3.5628997E-02
     +,   3.5721306E-02,   3.5807539E-02,   3.5883352E-02
     +,   3.5944819E-02,   3.5988558E-02,   3.6011707E-02
     +,   3.6011916E-02,   3.5987373E-02,   3.5936780E-02
     +,   3.5859343E-02,   3.5754710E-02,   3.5622969E-02
     +,   3.5464622E-02,   3.5280436E-02,   3.5071533E-02
     +,   3.4839272E-02,   3.4585167E-02,   3.4310911E-02
     +,   3.4018226E-02,   3.3708926E-02,   3.3384785E-02
     +,   3.3047557E-02,   3.2698907E-02,   3.2340344E-02
     +,   3.1973269E-02,   3.1598959E-02,   3.1218452E-02
     +,   3.0832613E-02,   3.0442139E-02,   3.0047536E-02
     +,   2.9649081E-02,   2.9246936E-02,   2.8841080E-02
     +,   2.8431358E-02,   2.8017459E-02,   2.7599018E-02
     +,   2.7175574E-02,   2.6746614E-02,   2.6311569E-02
     +,   2.5869908E-02,   2.5421124E-02,   2.4964707E-02
     +,   2.4500217E-02,   2.4027333E-02,   2.3545789E-02
     +,   2.3055408E-02,   2.2556173E-02,   2.2048194E-02
     +,   2.1531668E-02,   2.1006912E-02,   2.0474423E-02
     +,   1.9934803E-02,   1.9388743E-02,   1.8837053E-02
     +,   1.8280651E-02,   1.7720573E-02,   1.7157862E-02
     +,   1.6593641E-02,   1.6029127E-02,   1.5465520E-02
     +,   1.4904028E-02,   1.4345895E-02,   1.3792363E-02
     +,   1.3244612E-02,   1.2703779E-02,   1.2170995E-02
     +,   1.1647326E-02,   1.1133741E-02,   1.0631132E-02
     +,   1.0140348E-02,   9.6621513E-03,   9.1971802E-03
     +,   8.7459879E-03,   8.3090812E-03,   7.8868316E-03
     +,   7.4795210E-03,   7.0873708E-03,   6.7105251E-03
     +,   6.3490146E-03,   6.0028010E-03,   5.6717992E-03
     +,   5.3558582E-03,   5.0547482E-03,   4.7681890E-03
     +,   4.4958708E-03,   4.2374418E-03,   3.9925012E-03
     +,   3.7606184E-03,   3.5413627E-03,   3.3342601E-03
     +,   3.1388279E-03,   2.9545845E-03,   2.7810442E-03
     +,   2.6177077E-03,   2.4640774E-03,   2.3196728E-03
     +,   2.1840222E-03,   2.0566499E-03,   1.9370975E-03
     +,   1.8249309E-03,   1.7197129E-03,   1.6210402E-03
     +,   1.5285109E-03,   1.4417530E-03,   1.3604009E-03
     +,   1.2841161E-03,   1.2125687E-03,   1.1454558E-03
     +,   1.0824818E-03,   1.0233772E-03,   9.6788147E-04
     +,   9.1575173E-04,   8.6676423E-04,   8.2070340E-04
     +,   7.7737402E-04,   7.3658809E-04,   6.9817569E-04
     +,   6.6197355E-04,   6.2783487E-04,   5.9561845E-04
     +,   5.6519767E-04,   5.3645106E-04,   5.0926971E-04
     +,   4.8354935E-04,   4.5919672E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_hzonly_htt60_mass = Yx/21.3309653617021
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_hzonly_htt65_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.2596961E-02,   2.3926334E-02
     +,   2.5314579E-02,   2.6762888E-02,   2.8272068E-02
     +,   2.9842444E-02,   3.1473856E-02,   3.3165678E-02
     +,   3.4916870E-02,   3.6726292E-02,   3.8592737E-02
     +,   4.0515557E-02,   4.2495191E-02,   4.4534028E-02
     +,   4.6637420E-02,   4.8815183E-02,   5.1083233E-02
     +,   5.3465661E-02,   5.5996995E-02,   5.8724653E-02
     +,   6.1711509E-02,   6.5038025E-02,   6.8804130E-02
     +,   7.3130511E-02,   7.8158326E-02,   8.4049352E-02
     +,   9.0983883E-02,   9.9158935E-02,   0.1087868    
     +,   0.1200924    ,   0.1333133    ,   0.1486989    
     +,   0.1665119    ,   0.1870314    ,   0.2105596    
     +,   0.2374302    ,   0.2680164    ,   0.3027245    
     +,   0.3419614    ,   0.3860442    ,   0.4350749    
     +,   0.4887883    ,   0.5464776    ,   0.6071067    
     +,   0.6697000    ,   0.7339921    ,   0.8011155    
     +,   0.8739189    ,   0.9565041    ,    1.052822    
     +,    1.164744    ,    1.290530    ,    1.424632    
     +,    1.559193    ,    1.686592    ,    1.801912    
     +,    1.904074    ,    1.995289    ,    2.078919    
     +,    2.156655    ,    2.226333    ,    2.281769    
     +,    2.314877    ,    2.318757    ,    2.289820    
     +,    2.228019    ,    2.136077    ,    2.019068    
     +,    1.884523    ,    1.742152    ,    1.602102    
     +,    1.472404    ,    1.356959    ,    1.255402    
     +,    1.164580    ,    1.080615    ,    1.000444    
     +,   0.9224288    ,   0.8462421    ,   0.7724118    
     +,   0.7018850    ,   0.6356879    ,   0.5747717    
     +,   0.5198848    ,   0.4714860    ,   0.4296486    
     +,   0.3940309    ,   0.3639144    ,   0.3383472    
     +,   0.3163114    ,   0.2968949    ,   0.2794011    
     +,   0.2633793    ,   0.2485944    ,   0.2349625    
     +,   0.2224763    ,   0.2111450    ,   0.2009589    
     +,   0.1918726    ,   0.1838118    ,   0.1766829    
     +,   0.1703885    ,   0.1648373    ,   0.1599518    
     +,   0.1556674    ,   0.1519308    ,   0.1486952    
     +,   0.1459136    ,   0.1435357    ,   0.1415045    
     +,   0.1397564    ,   0.1382220    ,   0.1368292    
     +,   0.1355065    ,   0.1341862    ,   0.1328085    
     +,   0.1313236    ,   0.1296940    ,   0.1278951    
     +,   0.1259152    ,   0.1237548    ,   0.1214252    
     +,   0.1189467    ,   0.1163462    ,   0.1136546    
     +,   0.1109058    ,   0.1081334    ,   0.1053699    
     +,   0.1026445    ,   9.9982820E-02,   9.7405598E-02
     +,   9.4928816E-02,   9.2562869E-02,   9.0313859E-02
     +,   8.8182941E-02,   8.6167581E-02,   8.4261835E-02
     +,   8.2457423E-02,   8.0744013E-02,   7.9110205E-02
     +,   7.7544428E-02,   7.6035045E-02,   7.4571110E-02
     +,   7.3142804E-02,   7.1741685E-02,   7.0360854E-02
     +,   6.8995036E-02,   6.7640774E-02,   6.6296309E-02
     +,   6.4961322E-02,   6.3636929E-02,   6.2325485E-02
     +,   6.1030418E-02,   5.9755739E-02,   5.8506191E-02
     +,   5.7286780E-02,   5.6102686E-02,   5.4958984E-02
     +,   5.3860597E-02,   5.2812099E-02,   5.1817611E-02
     +,   5.0880749E-02,   5.0004594E-02,   4.9191628E-02
     +,   4.8443697E-02,   4.7762062E-02,   4.7147449E-02
     +,   4.6600033E-02,   4.6119459E-02,   4.5704950E-02
     +,   4.5355294E-02,   4.5068979E-02,   4.4844121E-02
     +,   4.4678502E-02,   4.4569779E-02,   4.4515319E-02
     +,   4.4512324E-02,   4.4557787E-02,   4.4648614E-02
     +,   4.4781536E-02,   4.4953130E-02,   4.5159843E-02
     +,   4.5398038E-02,   4.5663882E-02,   4.5953467E-02
     +,   4.6262722E-02,   4.6587456E-02,   4.6923336E-02
     +,   4.7265943E-02,   4.7610708E-02,   4.7952984E-02
     +,   4.8288058E-02,   4.8611108E-02,   4.8917379E-02
     +,   4.9201995E-02,   4.9460243E-02,   4.9687412E-02
     +,   4.9878959E-02,   5.0030481E-02,   5.0137870E-02
     +,   5.0197233E-02,   5.0204948E-02,   5.0157901E-02
     +,   5.0053284E-02,   4.9888771E-02,   4.9662534E-02
     +,   4.9373217E-02,   4.9020030E-02,   4.8602745E-02
     +,   4.8121620E-02,   4.7577500E-02,   4.6971750E-02
     +,   4.6306279E-02,   4.5583416E-02,   4.4805892E-02
     +,   4.3976944E-02,   4.3100152E-02,   4.2179313E-02
     +,   4.1218448E-02,   4.0221937E-02,   3.9194115E-02
     +,   3.8139425E-02,   3.7062384E-02,   3.5967484E-02
     +,   3.4859054E-02,   3.3741333E-02,   3.2618422E-02
     +,   3.1494275E-02,   3.0372513E-02,   2.9256552E-02
     +,   2.8149573E-02,   2.7054550E-02,   2.5974071E-02
     +,   2.4910444E-02,   2.3865864E-02,   2.2842102E-02
     +,   2.1840706E-02,   2.0863069E-02,   1.9910319E-02
     +,   1.8983351E-02,   1.8082852E-02,   1.7209396E-02
     +,   1.6363399E-02,   1.5545079E-02,   1.4754539E-02
     +,   1.3991814E-02,   1.3256838E-02,   1.2549417E-02
     +,   1.1869281E-02,   1.1216161E-02,   1.0589664E-02
     +,   9.9893501E-03,   9.4147883E-03,   8.8654868E-03
     +,   8.3408970E-03,   7.8404406E-03,   7.3635462E-03
     +,   6.9096214E-03,   6.4780223E-03,   6.0680863E-03
     +,   5.6791692E-03,   5.3106090E-03,   4.9617151E-03
     +,   4.6317861E-03,   4.3201493E-03,   4.0260958E-03
     +,   3.7489207E-03,   3.4879395E-03,   3.2424652E-03
     +,   3.0118076E-03,   2.7952818E-03,   2.5922291E-03
     +,   2.4020027E-03,   2.2239538E-03,   2.0574543E-03
     +,   1.9019063E-03,   1.7567103E-03,   1.6213054E-03
     +,   1.4951322E-03,   1.3776683E-03,   1.2683978E-03
     +,   1.1668392E-03,   1.0725198E-03,   9.8500028E-04
     +,   9.0385170E-04,   8.2867593E-04,   7.5908715E-04
     +,   6.9472136E-04,   6.3523935E-04,   5.8031298E-04
     +,   5.2963936E-04,   4.8292673E-04,   4.3990571E-04
     +,   4.0031775E-04,   3.6392425E-04,   3.3049667E-04
     +,   2.9982475E-04,   2.7170702E-04,   2.4595854E-04
     +,   2.2240212E-04,   2.0087555E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_hzonly_htt65_mass = Yx/18.308018826087
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_hzonly_htt70_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.3883666E-02,   1.4522560E-02
     +,   1.5173959E-02,   1.5837615E-02,   1.6513404E-02
     +,   1.7201351E-02,   1.7901676E-02,   1.8614814E-02
     +,   1.9341484E-02,   2.0082738E-02,   2.0839980E-02
     +,   2.1615023E-02,   2.2410139E-02,   2.3228085E-02
     +,   2.4072142E-02,   2.4946116E-02,   2.5854360E-02
     +,   2.6801709E-02,   2.7793484E-02,   2.8835412E-02
     +,   2.9933574E-02,   3.1094300E-02,   3.2324132E-02
     +,   3.3629771E-02,   3.5017971E-02,   3.6495764E-02
     +,   3.8070463E-02,   3.9750028E-02,   4.1543406E-02
     +,   4.3461163E-02,   4.5516271E-02,   4.7724839E-02
     +,   5.0107315E-02,   5.2689351E-02,   5.5502888E-02
     +,   5.8586963E-02,   6.1988264E-02,   6.5761201E-02
     +,   6.9967903E-02,   7.4676439E-02,   7.9960272E-02
     +,   8.5895024E-02,   9.2556082E-02,   0.1000150    
     +,   0.1083354    ,   0.1175688    ,   0.1277498    
     +,   0.1388914    ,   0.1509812    ,   0.1639775    
     +,   0.1778091    ,   0.1923786    ,   0.2075697    
     +,   0.2232657    ,   0.2393707    ,   0.2558482    
     +,   0.2727601    ,   0.2903191    ,   0.3089440    
     +,   0.3293117    ,   0.3523989    ,   0.3794884    
     +,   0.4121126    ,   0.4519057    ,   0.5003336    
     +,   0.5583167    ,   0.6258297    ,   0.7015662    
     +,   0.7828936    ,   0.8661606    ,   0.9474679    
     +,    1.023653    ,    1.093216    ,    1.156657    
     +,    1.216049    ,    1.273859    ,    1.331663    
     +,    1.389486    ,    1.446133    ,    1.500197    
     +,    1.550924    ,    1.598293    ,    1.642214    
     +,    1.681489    ,    1.713157    ,    1.732543    
     +,    1.734063    ,    1.712583    ,    1.665026    
     +,    1.591633    ,    1.496360    ,    1.386125    
     +,    1.269177    ,    1.153273    ,    1.044316    
     +,   0.9457706    ,   0.8588340    ,   0.7831068    
     +,   0.7173603    ,   0.6601974    ,   0.6104026    
     +,   0.5670481    ,   0.5293811    ,   0.4966765    
     +,   0.4681058    ,   0.4427307    ,   0.4195889    
     +,   0.3978319    ,   0.3768485    ,   0.3563328    
     +,   0.3362682    ,   0.3168464    ,   0.2983647    
     +,   0.2811157    ,   0.2653192    ,   0.2510778    
     +,   0.2383766    ,   0.2271018    ,   0.2170762    
     +,   0.2080931    ,   0.1999504    ,   0.1924728    
     +,   0.1855251    ,   0.1790160    ,   0.1728941    
     +,   0.1671405    ,   0.1617572    ,   0.1567585    
     +,   0.1521604    ,   0.1479754    ,   0.1442081    
     +,   0.1408539    ,   0.1378988    ,   0.1353208    
     +,   0.1330913    ,   0.1311778    ,   0.1295451    
     +,   0.1281572    ,   0.1269777    ,   0.1259711    
     +,   0.1251034    ,   0.1243415    ,   0.1236539    
     +,   0.1230104    ,   0.1223823    ,   0.1217425    
     +,   0.1210655    ,   0.1203277    ,   0.1195080    
     +,   0.1185874    ,   0.1175501    ,   0.1163835    
     +,   0.1150786    ,   0.1136301    ,   0.1120365    
     +,   0.1103003    ,   0.1084281    ,   0.1064301    
     +,   0.1043201    ,   0.1021152    ,   9.9835470E-02
     +,   9.7503252E-02,   9.5142879E-02,   9.2780128E-02
     +,   9.0441383E-02,   8.8153183E-02,   8.5941821E-02
     +,   8.3832562E-02,   8.1849031E-02,   8.0012828E-02
     +,   7.8343071E-02,   7.6855987E-02,   7.5564794E-02
     +,   7.4478924E-02,   7.3604710E-02,   7.2944552E-02
     +,   7.2497398E-02,   7.2258696E-02,   7.2220571E-02
     +,   7.2371945E-02,   7.2698966E-02,   7.3185071E-02
     +,   7.3811553E-02,   7.4557841E-02,   7.5401857E-02
     +,   7.6320276E-02,   7.7289157E-02,   7.8284167E-02
     +,   7.9281047E-02,   8.0256000E-02,   8.1185922E-02
     +,   8.2048953E-02,   8.2824677E-02,   8.3494365E-02
     +,   8.4041387E-02,   8.4451318E-02,   8.4712163E-02
     +,   8.4814377E-02,   8.4751040E-02,   8.4517866E-02
     +,   8.4113069E-02,   8.3537318E-02,   8.2793728E-02
     +,   8.1887342E-02,   8.0825329E-02,   7.9616390E-02
     +,   7.8270674E-02,   7.6799504E-02,   7.5215109E-02
     +,   7.3530264E-02,   7.1757883E-02,   6.9911323E-02
     +,   6.8003677E-02,   6.6047668E-02,   6.4055540E-02
     +,   6.2039100E-02,   6.0009390E-02,   5.7976600E-02
     +,   5.5950068E-02,   5.3938456E-02,   5.1949389E-02
     +,   4.9989626E-02,   4.8065133E-02,   4.6181146E-02
     +,   4.4341914E-02,   4.2550921E-02,   4.0811107E-02
     +,   3.9124712E-02,   3.7493262E-02,   3.5917703E-02
     +,   3.4398615E-02,   3.2936044E-02,   3.1529568E-02
     +,   3.0178426E-02,   2.8881636E-02,   2.7637856E-02
     +,   2.6445534E-02,   2.5303019E-02,   2.4208553E-02
     +,   2.3160214E-02,   2.2156013E-02,   2.1194065E-02
     +,   2.0272464E-02,   1.9389274E-02,   1.8542657E-02
     +,   1.7730873E-02,   1.6952291E-02,   1.6205300E-02
     +,   1.5488403E-02,   1.4800278E-02,   1.4139619E-02
     +,   1.3505216E-02,   1.2896007E-02,   1.2310991E-02
     +,   1.1749214E-02,   1.1209789E-02,   1.0691923E-02
     +,   1.0194872E-02,   9.7179031E-03,   9.2603285E-03
     +,   8.8215135E-03,   8.4008547E-03,   7.9977354E-03
     +,   7.6115653E-03,   7.2418014E-03,   6.8878778E-03
     +,   6.5492443E-03,   6.2253773E-03,   5.9157624E-03
     +,   5.6198747E-03,   5.3372006E-03,   5.0672512E-03
     +,   4.8095486E-03,   4.5636063E-03,   4.3289503E-03
     +,   4.1051446E-03,   3.8917277E-03,   3.6882849E-03
     +,   3.4943842E-03,   3.3096345E-03,   3.1336320E-03
     +,   2.9660119E-03,   2.8063983E-03,   2.6544535E-03
     +,   2.5098291E-03,   2.3722132E-03,   2.2412909E-03
     +,   2.1167616E-03,   1.9983484E-03,   1.8857722E-03
     +,   1.7787806E-03,   1.6771166E-03,   1.5805500E-03
     +,   1.4888457E-03,   1.4017927E-03,   1.3191772E-03
     +,   1.2408054E-03,   1.1664815E-03,   1.0960290E-03
     +,   1.0292680E-03,   9.6603623E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_hzonly_htt70_mass = Yx/16.0324412888889
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_hzonly_htt75_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  6.3834805E-03,   6.6963853E-03
     +,   7.0172488E-03,   7.3458049E-03,   7.6817651E-03
     +,   8.0248248E-03,   8.3746556E-03,   8.7309228E-03
     +,   9.0932716E-03,   9.4613619E-03,   9.8348362E-03
     +,   1.0213344E-02,   1.0596549E-02,   1.0984120E-02
     +,   1.1375759E-02,   1.1771179E-02,   1.2170124E-02
     +,   1.2572374E-02,   1.2977738E-02,   1.3386069E-02
     +,   1.3797263E-02,   1.4211247E-02,   1.4627995E-02
     +,   1.5047556E-02,   1.5469976E-02,   1.5895404E-02
     +,   1.6324019E-02,   1.6756063E-02,   1.7191857E-02
     +,   1.7631814E-02,   1.8076448E-02,   1.8526394E-02
     +,   1.8982470E-02,   1.9445680E-02,   1.9917294E-02
     +,   2.0398894E-02,   2.0892467E-02,   2.1400470E-02
     +,   2.1926003E-02,   2.2472830E-02,   2.3045667E-02
     +,   2.3650289E-02,   2.4293743E-02,   2.4984609E-02
     +,   2.5733259E-02,   2.6552109E-02,   2.7455946E-02
     +,   2.8462168E-02,   2.9591002E-02,   3.0865695E-02
     +,   3.2312546E-02,   3.3960868E-02,   3.5842739E-02
     +,   3.7992738E-02,   4.0447082E-02,   4.3243621E-02
     +,   4.6420589E-02,   5.0016433E-02,   5.4069191E-02
     +,   5.8616441E-02,   6.3695356E-02,   6.9343336E-02
     +,   7.5598039E-02,   8.2499020E-02,   9.0087898E-02
     +,   9.8407932E-02,   0.1075049    ,   0.1174244    
     +,   0.1282117    ,   0.1399064    ,   0.1525421    
     +,   0.1661396    ,   0.1807078    ,   0.1962390    
     +,   0.2127129    ,   0.2301013    ,   0.2483751    
     +,   0.2675195    ,   0.2875562    ,   0.3085667    
     +,   0.3307223    ,   0.3543239    ,   0.3798223    
     +,   0.4078277    ,   0.4390604    ,   0.4742477    
     +,   0.5139619    ,   0.5584773    ,   0.6077089    
     +,   0.6613324    ,   0.7190352    ,   0.7807594    
     +,   0.8467299    ,   0.9171359    ,   0.9915418    
     +,    1.068357    ,    1.144796    ,    1.217414    
     +,    1.283083    ,    1.339795    ,    1.386920    
     +,    1.424707    ,    1.453461    ,    1.472813    
     +,    1.481468    ,    1.477535    ,    1.459302    
     +,    1.426156    ,    1.379216    ,    1.321293    
     +,    1.256098    ,    1.187054    ,    1.116436    
     +,    1.045201    ,   0.9735693    ,   0.9018085    
     +,   0.8307357    ,   0.7617190    ,   0.6963311    
     +,   0.6359181    ,   0.5813557    ,   0.5330384    
     +,   0.4909896    ,   0.4550045    ,   0.4247307    
     +,   0.3996785    ,   0.3791922    ,   0.3624646    
     +,   0.3485838    ,   0.3366356    ,   0.3258019    
     +,   0.3154440    ,   0.3051313    ,   0.2946365    
     +,   0.2838970    ,   0.2729655    ,   0.2619665    
     +,   0.2510571    ,   0.2404008    ,   0.2301494    
     +,   0.2204335    ,   0.2113563    ,   0.2029904    
     +,   0.1953803    ,   0.1885465    ,   0.1824864    
     +,   0.1771810    ,   0.1725981    ,   0.1686963    
     +,   0.1654278    ,   0.1627417    ,   0.1605855    
     +,   0.1589073    ,   0.1576564    ,   0.1567833    
     +,   0.1562400    ,   0.1559803    ,   0.1559584    
     +,   0.1561291    ,   0.1564480    ,   0.1568725    
     +,   0.1573603    ,   0.1578727    ,   0.1583731    
     +,   0.1588292    ,   0.1592118    ,   0.1594961    
     +,   0.1596602    ,   0.1596855    ,   0.1595552    
     +,   0.1592540    ,   0.1587671    ,   0.1580796    
     +,   0.1571766    ,   0.1560432    ,   0.1546645    
     +,   0.1530265    ,   0.1511173    ,   0.1489279    
     +,   0.1464528    ,   0.1436912    ,   0.1406480    
     +,   0.1373339    ,   0.1337658    ,   0.1299666    
     +,   0.1259655    ,   0.1217967    ,   0.1174989    
     +,   0.1131142    ,   0.1086876    ,   0.1042649    
     +,   9.9891953E-02,   9.5613636E-02,   9.1472477E-02
     +,   8.7507136E-02,   8.3751962E-02,   8.0236301E-02
     +,   7.6983556E-02,   7.4010715E-02,   7.1328461E-02
     +,   6.8941034E-02,   6.6846624E-02,   6.5037407E-02
     +,   6.3500300E-02,   6.2217850E-02,   6.1168607E-02
     +,   6.0328066E-02,   5.9669562E-02,   5.9165053E-02
     +,   5.8785744E-02,   5.8502857E-02,   5.8288403E-02
     +,   5.8115490E-02,   5.7959009E-02,   5.7795819E-02
     +,   5.7605214E-02,   5.7368968E-02,   5.7071626E-02
     +,   5.6700412E-02,   5.6245331E-02,   5.5699077E-02
     +,   5.5056941E-02,   5.4316636E-02,   5.3478185E-02
     +,   5.2543610E-02,   5.1516779E-02,   5.0403137E-02
     +,   4.9209476E-02,   4.7943614E-02,   4.6614114E-02
     +,   4.5230206E-02,   4.3801431E-02,   4.2337351E-02
     +,   4.0847421E-02,   3.9340954E-02,   3.7826765E-02
     +,   3.6312994E-02,   3.4807365E-02,   3.3316843E-02
     +,   3.1847518E-02,   3.0404748E-02,   2.8993176E-02
     +,   2.7616676E-02,   2.6278324E-02,   2.4980495E-02
     +,   2.3725023E-02,   2.2513179E-02,   2.1345628E-02
     +,   2.0222614E-02,   1.9144112E-02,   1.8109681E-02
     +,   1.7118640E-02,   1.6170163E-02,   1.5263285E-02
     +,   1.4396872E-02,   1.3569729E-02,   1.2780671E-02
     +,   1.2028519E-02,   1.1312029E-02,   1.0629988E-02
     +,   9.9812681E-03,   9.3647605E-03,   8.7793591E-03
     +,   8.2240002E-03,   7.6977098E-03,   7.1994932E-03
     +,   6.7283851E-03,   6.2834783E-03,   5.8638831E-03
     +,   5.4686912E-03,   5.0970144E-03,   4.7479919E-03
     +,   4.4207685E-03,   4.1144667E-03,   3.8282119E-03
     +,   3.5611605E-03,   3.3124327E-03,   3.0811839E-03
     +,   2.8665415E-03,   2.6676655E-03,   2.4836990E-03
     +,   2.3138167E-03,   2.1571852E-03,   2.0130051E-03
     +,   1.8804760E-03,   1.7588374E-03,   1.6473356E-03
     +,   1.5452453E-03,   1.4518773E-03,   1.3665584E-03
     +,   1.2886571E-03,   1.2175629E-03,   1.1527068E-03
     +,   1.0935434E-03,   1.0395678E-03,   9.9030090E-04
     +,   9.4530237E-04,   9.0415688E-04,   8.6648669E-04
     +,   8.3193765E-04,   8.0018985E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_hzonly_htt75_mass = Yx/14.4154802272727
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_hzonly_htt80_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  6.4832852E-03,   6.7513203E-03
     +,   7.0266924E-03,   7.3093250E-03,   7.5991233E-03
     +,   7.8959614E-03,   8.1996890E-03,   8.5101295E-03
     +,   8.8270670E-03,   9.1502694E-03,   9.4794612E-03
     +,   9.8143350E-03,   1.0154549E-02,   1.0499728E-02
     +,   1.0849458E-02,   1.1203289E-02,   1.1560737E-02
     +,   1.1921281E-02,   1.2284360E-02,   1.2649385E-02
     +,   1.3015730E-02,   1.3382734E-02,   1.3749708E-02
     +,   1.4115947E-02,   1.4480706E-02,   1.4843231E-02
     +,   1.5202755E-02,   1.5558485E-02,   1.5909649E-02
     +,   1.6255457E-02,   1.6595144E-02,   1.6927952E-02
     +,   1.7253166E-02,   1.7570099E-02,   1.7878136E-02
     +,   1.8176693E-02,   1.8465290E-02,   1.8743537E-02
     +,   1.9011168E-02,   1.9268015E-02,   1.9514108E-02
     +,   1.9749617E-02,   1.9974928E-02,   2.0190645E-02
     +,   2.0397643E-02,   2.0597065E-02,   2.0790396E-02
     +,   2.0979445E-02,   2.1166425E-02,   2.1353960E-02
     +,   2.1545134E-02,   2.1743497E-02,   2.1953141E-02
     +,   2.2178674E-02,   2.2425264E-02,   2.2698693E-02
     +,   2.3005331E-02,   2.3352167E-02,   2.3746869E-02
     +,   2.4197774E-02,   2.4713971E-02,   2.5305362E-02
     +,   2.5982728E-02,   2.6757922E-02,   2.7644051E-02
     +,   2.8655503E-02,   2.9808443E-02,   3.1120799E-02
     +,   3.2612722E-02,   3.4306508E-02,   3.6226984E-02
     +,   3.8401060E-02,   4.0857989E-02,   4.3628220E-02
     +,   4.6743188E-02,   5.0234180E-02,   5.4130547E-02
     +,   5.8458637E-02,   6.3240416E-02,   6.8491988E-02
     +,   7.4221887E-02,   8.0431782E-02,   8.7115362E-02
     +,   9.4260901E-02,   0.1018521    ,   0.1098729    
     +,   0.1183098    ,   0.1271585    ,   0.1364270    
     +,   0.1461415    ,   0.1563508    ,   0.1671279    
     +,   0.1785738    ,   0.1908174    ,   0.2040122    
     +,   0.2183271    ,   0.2339310    ,   0.2509633    
     +,   0.2694978    ,   0.2894952    ,   0.3107645    
     +,   0.3329412    ,   0.3555134    ,   0.3778978    
     +,   0.3995834    ,   0.4203031    ,   0.4401953    
     +,   0.4598943    ,   0.4804923    ,   0.5033544    
     +,   0.5298204    ,   0.5608892    ,   0.5969730    
     +,   0.6378410    ,   0.6827317    ,   0.7306146    
     +,   0.7804255    ,   0.8311998    ,   0.8819764    
     +,   0.9315832    ,   0.9783935    ,    1.020297    
     +,    1.055031    ,    1.080837    ,    1.097142    
     +,    1.104846    ,    1.105928    ,    1.102433    
     +,    1.095342    ,    1.083995    ,    1.066431    
     +,    1.040501    ,    1.005107    ,   0.9609697    
     +,   0.9105223    ,   0.8571281    ,   0.8040089    
     +,   0.7534022    ,   0.7062161    ,   0.6622464    
     +,   0.6207392    ,   0.5810061    ,   0.5428482    
     +,   0.5066750    ,   0.4733362    ,   0.4437943    
     +,   0.4188099    ,   0.3987289    ,   0.3834177    
     +,   0.3723201    ,   0.3645858    ,   0.3592237    
     +,   0.3552357    ,   0.3517249    ,   0.3479681    
     +,   0.3434547    ,   0.3378956    ,   0.3312061    
     +,   0.3234645    ,   0.3148638    ,   0.3056494    
     +,   0.2960680    ,   0.2863272    ,   0.2765720    
     +,   0.2668785    ,   0.2572651    ,   0.2477144    
     +,   0.2381970    ,   0.2286954    ,   0.2192217    
     +,   0.2098276    ,   0.2006046    ,   0.1916753    
     +,   0.1831803    ,   0.1752645    ,   0.1680575    
     +,   0.1616616    ,   0.1561414    ,   0.1515180    
     +,   0.1477678    ,   0.1448260    ,   0.1425945    
     +,   0.1409503    ,   0.1397558    ,   0.1388696    
     +,   0.1381560    ,   0.1374927    ,   0.1367764    
     +,   0.1359271    ,   0.1348896    ,   0.1336335    
     +,   0.1321505    ,   0.1304525    ,   0.1285673    
     +,   0.1265337    ,   0.1243979    ,   0.1222086    
     +,   0.1200136    ,   0.1178563    ,   0.1157732    
     +,   0.1137929    ,   0.1119350    ,   0.1102094    
     +,   0.1086182    ,   0.1071557    ,   0.1058102    
     +,   0.1045653    ,   0.1034019    ,   0.1022990    
     +,   0.1012355    ,   0.1001903    ,   9.9143736E-02
     +,   9.8078005E-02,   9.6976772E-02,   9.5825620E-02
     +,   9.4612017E-02,   9.3325302E-02,   9.1956146E-02
     +,   9.0496823E-02,   8.8941209E-02,   8.7284662E-02
     +,   8.5523956E-02,   8.3657853E-02,   8.1686765E-02
     +,   7.9613000E-02,   7.7440724E-02,   7.5176232E-02
     +,   7.2827786E-02,   7.0405200E-02,   6.7919873E-02
     +,   6.5384641E-02,   6.2813364E-02,   6.0220379E-02
     +,   5.7620257E-02,   5.5027712E-02,   5.2456729E-02
     +,   4.9920600E-02,   4.7431659E-02,   4.5001037E-02
     +,   4.2638294E-02,   4.0351417E-02,   3.8147110E-02
     +,   3.6030460E-02,   3.4004956E-02,   3.2072768E-02
     +,   3.0234857E-02,   2.8491162E-02,   2.6840487E-02
     +,   2.5280856E-02,   2.3809828E-02,   2.2424255E-02
     +,   2.1120675E-02,   1.9895423E-02,   1.8744681E-02
     +,   1.7664474E-02,   1.6650831E-02,   1.5699882E-02
     +,   1.4807881E-02,   1.3971107E-02,   1.3185997E-02
     +,   1.2449218E-02,   1.1757580E-02,   1.1108031E-02
     +,   1.0497695E-02,   9.9239349E-03,   9.3842158E-03
     +,   8.8761831E-03,   8.3976807E-03,   7.9466887E-03
     +,   7.5213271E-03,   7.1198549E-03,   6.7406846E-03
     +,   6.3823676E-03,   6.0435417E-03,   5.7229619E-03
     +,   5.4195127E-03,   5.1321415E-03,   4.8599131E-03
     +,   4.6019349E-03,   4.3574250E-03,   4.1256268E-03
     +,   3.9058749E-03,   3.6975243E-03,   3.5000038E-03
     +,   3.3127535E-03,   3.1352760E-03,   2.9670845E-03
     +,   2.8077252E-03,   2.6567790E-03,   2.5138343E-03
     +,   2.3785138E-03,   2.2504441E-03,   2.1292835E-03
     +,   2.0146910E-03,   1.9063544E-03,   1.8039611E-03
     +,   1.7072252E-03,   1.6158593E-03,   1.5296013E-03
     +,   1.4481880E-03,   1.3713788E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_hzonly_htt80_mass = Yx/12.853274
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_hzonly_htt85_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.4285020E-03,   3.5608073E-03
     +,   3.6955944E-03,   3.8327910E-03,   3.9723157E-03
     +,   4.1140844E-03,   4.2580068E-03,   4.4039865E-03
     +,   4.5519201E-03,   4.7017047E-03,   4.8532262E-03
     +,   5.0063659E-03,   5.1610013E-03,   5.3170030E-03
     +,   5.4742387E-03,   5.6325682E-03,   5.7918490E-03
     +,   5.9519317E-03,   6.1126649E-03,   6.2738927E-03
     +,   6.4354548E-03,   6.5971883E-03,   6.7589260E-03
     +,   6.9205114E-03,   7.0817652E-03,   7.2425292E-03
     +,   7.4026375E-03,   7.5619309E-03,   7.7202516E-03
     +,   7.8774504E-03,   8.0333874E-03,   8.1879385E-03
     +,   8.3409818E-03,   8.4924251E-03,   8.6421855E-03
     +,   8.7902118E-03,   8.9364713E-03,   9.0809669E-03
     +,   9.2237368E-03,   9.3648480E-03,   9.5044225E-03
     +,   9.6426206E-03,   9.7796516E-03,   9.9157868E-03
     +,   1.0051350E-02,   1.0186732E-02,   1.0322387E-02
     +,   1.0458843E-02,   1.0596706E-02,   1.0736652E-02
     +,   1.0879447E-02,   1.1025945E-02,   1.1177082E-02
     +,   1.1333905E-02,   1.1497555E-02,   1.1669288E-02
     +,   1.1850485E-02,   1.2042645E-02,   1.2247428E-02
     +,   1.2466639E-02,   1.2702273E-02,   1.2956515E-02
     +,   1.3231763E-02,   1.3530668E-02,   1.3856149E-02
     +,   1.4211386E-02,   1.4599896E-02,   1.5025478E-02
     +,   1.5492305E-02,   1.6004821E-02,   1.6567843E-02
     +,   1.7186418E-02,   1.7865922E-02,   1.8611861E-02
     +,   1.9429967E-02,   2.0326061E-02,   2.1305962E-02
     +,   2.2375386E-02,   2.3540083E-02,   2.4805617E-02
     +,   2.6177283E-02,   2.7660368E-02,   2.9259780E-02
     +,   3.0980572E-02,   3.2827456E-02,   3.4805350E-02
     +,   3.6919050E-02,   3.9173648E-02,   4.1574076E-02
     +,   4.4125549E-02,   4.6833232E-02,   4.9701925E-02
     +,   5.2735996E-02,   5.5939265E-02,   5.9314582E-02
     +,   6.2863275E-02,   6.6585571E-02,   7.0479989E-02
     +,   7.4544333E-02,   7.8775242E-02,   8.3170287E-02
     +,   8.7727897E-02,   9.2449941E-02,   9.7342208E-02
     +,   0.1024168    ,   0.1076932    ,   0.1131990    
     +,   0.1189719    ,   0.1250615    ,   0.1315316    
     +,   0.1384636    ,   0.1459621    ,   0.1541586    
     +,   0.1632157    ,   0.1733231    ,   0.1846893    
     +,   0.1975184    ,   0.2119829    ,   0.2281833    
     +,   0.2461191    ,   0.2656662    ,   0.2865787    
     +,   0.3085175    ,   0.3311055    ,   0.3539860    
     +,   0.3768795    ,   0.3996219    ,   0.4221719    
     +,   0.4446167    ,   0.4671791    ,   0.4902707    
     +,   0.5145599    ,   0.5410286    ,   0.5709112    
     +,   0.6054664    ,   0.6455497    ,   0.6910841    
     +,   0.7406253    ,   0.7912456    ,   0.8389292    
     +,   0.8795077    ,   0.9099398    ,   0.9294543    
     +,   0.9400245    ,   0.9458111    ,   0.9516612    
     +,   0.9612589    ,   0.9757221    ,   0.9932554    
     +,    1.009896    ,    1.020896    ,    1.022081    
     +,    1.010731    ,   0.9858931    ,   0.9483504    
     +,   0.9004229    ,   0.8456615    ,   0.7883459    
     +,   0.7327378    ,   0.6822336    ,   0.6386839    
     +,   0.6022035    ,   0.5715185    ,   0.5446759    
     +,   0.5198047    ,   0.4956476    ,   0.4717411    
     +,   0.4482927    ,   0.4259071    ,   0.4053016    
     +,   0.3870923    ,   0.3716710    ,   0.3591595    
     +,   0.3494210    ,   0.3421066    ,   0.3367191    
     +,   0.3326920    ,   0.3294640    ,   0.3265339    
     +,   0.3234945    ,   0.3200420    ,   0.3159679    
     +,   0.3111471    ,   0.3055255    ,   0.2991180    
     +,   0.2920079    ,   0.2843456    ,   0.2763386    
     +,   0.2682334    ,   0.2602870    ,   0.2527345    
     +,   0.2457576    ,   0.2394645    ,   0.2338791    
     +,   0.2289452    ,   0.2245420    ,   0.2205068    
     +,   0.2166617    ,   0.2128369    ,   0.2088902    
     +,   0.2047203    ,   0.2002703    ,   0.1955274    
     +,   0.1905150    ,   0.1852845    ,   0.1799030    
     +,   0.1744442    ,   0.1689795    ,   0.1635725    
     +,   0.1582745    ,   0.1531237    ,   0.1481456    
     +,   0.1433550    ,   0.1387569    ,   0.1343495    
     +,   0.1301263    ,   0.1260775    ,   0.1221903    
     +,   0.1184504    ,   0.1148429    ,   0.1113518    
     +,   0.1079602    ,   0.1046515    ,   0.1014089    
     +,   9.8216042E-02,   9.5057413E-02,   9.1918819E-02
     +,   8.8787772E-02,   8.5653730E-02,   8.2508415E-02
     +,   7.9346173E-02,   7.6164059E-02,   7.2961450E-02
     +,   6.9740430E-02,   6.6505723E-02,   6.3263953E-02
     +,   6.0023759E-02,   5.6795679E-02,   5.3591553E-02
     +,   5.0423976E-02,   4.7306124E-02,   4.4251561E-02
     +,   4.1273650E-02,   3.8384926E-02,   3.5596985E-02
     +,   3.2920450E-02,   3.0364364E-02,   2.7935952E-02
     +,   2.5640676E-02,   2.3482393E-02,   2.1462893E-02
     +,   1.9582264E-02,   1.7839076E-02,   1.6230434E-02
     +,   1.4752103E-02,   1.3398792E-02,   1.2164473E-02
     +,   1.1042492E-02,   1.0025718E-02,   9.1067869E-03
     +,   8.2783448E-03,   7.5330944E-03,   6.8638879E-03
     +,   6.2638628E-03,   5.7265623E-03,   5.2458677E-03
     +,   4.8160921E-03,   4.4320142E-03,   4.0888409E-03
     +,   3.7821892E-03,   3.5080882E-03,   3.2629704E-03
     +,   3.0436346E-03,   2.8471914E-03,   2.6710634E-03
     +,   2.5129677E-03,   2.3708506E-03,   2.2429023E-03
     +,   2.1274968E-03,   2.0232042E-03,   1.9287403E-03
     +,   1.8429762E-03,   1.7648983E-03,   1.6936153E-03
     +,   1.6283286E-03,   1.5683356E-03,   1.5130099E-03
     +,   1.4617953E-03,   1.4142052E-03,   1.3698037E-03
     +,   1.3282122E-03,   1.2890924E-03,   1.2521519E-03
     +,   1.2171315E-03,   1.1838076E-03,   1.1519822E-03
     +,   1.1214877E-03,   1.0921746E-03,   1.0639175E-03
     +,   1.0366057E-03,   1.0101469E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_hzonly_htt85_mass = Yx/12.2424510697674
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_hzonly_htt90_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.2639735E-03,   2.3456072E-03
     +,   2.4301398E-03,   2.5176362E-03,   2.6081582E-03
     +,   2.7017621E-03,   2.7985028E-03,   2.8984288E-03
     +,   3.0015830E-03,   3.1080097E-03,   3.2177411E-03
     +,   3.3308081E-03,   3.4472323E-03,   3.5670330E-03
     +,   3.6902230E-03,   3.8168032E-03,   3.9467765E-03
     +,   4.0801349E-03,   4.2168624E-03,   4.3569379E-03
     +,   4.5003342E-03,   4.6470170E-03,   4.7969432E-03
     +,   4.9500694E-03,   5.1063346E-03,   5.2656853E-03
     +,   5.4280553E-03,   5.5933711E-03,   5.7615601E-03
     +,   5.9325420E-03,   6.1062374E-03,   6.2825629E-03
     +,   6.4614364E-03,   6.6427765E-03,   6.8265041E-03
     +,   7.0125470E-03,   7.2008441E-03,   7.3913392E-03
     +,   7.5840000E-03,   7.7787964E-03,   7.9757432E-03
     +,   8.1748618E-03,   8.3762184E-03,   8.5799154E-03
     +,   8.7860934E-03,   8.9949509E-03,   9.2067411E-03
     +,   9.4217844E-03,   9.6404757E-03,   9.8632835E-03
     +,   1.0090774E-02,   1.0323607E-02,   1.0562537E-02
     +,   1.0808454E-02,   1.1062326E-02,   1.1325283E-02
     +,   1.1598547E-02,   1.1883483E-02,   1.2181574E-02
     +,   1.2494422E-02,   1.2823744E-02,   1.3171365E-02
     +,   1.3539171E-02,   1.3929142E-02,   1.4343319E-02
     +,   1.4783690E-02,   1.5252305E-02,   1.5751071E-02
     +,   1.6281877E-02,   1.6846374E-02,   1.7446086E-02
     +,   1.8082201E-02,   1.8755678E-02,   1.9467009E-02
     +,   2.0216335E-02,   2.1003330E-02,   2.1827098E-02
     +,   2.2686193E-02,   2.3578655E-02,   2.4501974E-02
     +,   2.5452964E-02,   2.6428049E-02,   2.7423067E-02
     +,   2.8433578E-02,   2.9454717E-02,   3.0481588E-02
     +,   3.1509165E-02,   3.2532673E-02,   3.3547536E-02
     +,   3.4549821E-02,   3.5536308E-02,   3.6504619E-02
     +,   3.7453488E-02,   3.8383000E-02,   3.9294541E-02
     +,   4.0191021E-02,   4.1076906E-02,   4.1958127E-02
     +,   4.2842150E-02,   4.3737650E-02,   4.4654571E-02
     +,   4.5603547E-02,   4.6595961E-02,   4.7643222E-02
     +,   4.8756760E-02,   4.9947485E-02,   5.1225498E-02
     +,   5.2599832E-02,   5.4078501E-02,   5.5668321E-02
     +,   5.7375040E-02,   5.9203852E-02,   6.1159566E-02
     +,   6.3247666E-02,   6.5474533E-02,   6.7848802E-02
     +,   7.0381448E-02,   7.3087133E-02,   7.5983934E-02
     +,   7.9094097E-02,   8.2443811E-02,   8.6062580E-02
     +,   8.9982927E-02,   9.4240554E-02,   9.8874062E-02
     +,   0.1039252    ,   0.1094416    ,   0.1154775    
     +,   0.1220975    ,   0.1293768    ,   0.1374017    
     +,   0.1462626    ,   0.1560463    ,   0.1668171    
     +,   0.1785982    ,   0.1913496    ,   0.2049482    
     +,   0.2191845    ,   0.2337746    ,   0.2483996    
     +,   0.2627727    ,   0.2767377    ,   0.2903880    
     +,   0.3041797    ,   0.3190080    ,   0.3361981    
     +,   0.3573607    ,   0.3840930    ,   0.4175685    
     +,   0.4581237    ,   0.5049828    ,   0.5562598    
     +,   0.6092718    ,   0.6610615    ,   0.7089211    
     +,   0.7507797    ,   0.7854062    ,   0.8125152    
     +,   0.8328419    ,   0.8481417    ,   0.8609585    
     +,   0.8740717    ,   0.8897789    ,   0.9092968    
     +,   0.9324854    ,   0.9578234    ,   0.9824844    
     +,    1.002587    ,    1.013899    ,    1.013163    
     +,   0.9996154    ,   0.9758153    ,   0.9470795    
     +,   0.9196380    ,   0.8984137    ,   0.8855319    
     +,   0.8801275    ,   0.8793006    ,   0.8795615    
     +,   0.8780622    ,   0.8731785    ,   0.8643627    
     +,   0.8515770    ,   0.8347312    ,   0.8135409    
     +,   0.7878515    ,   0.7581590    ,   0.7258940    
     +,   0.6932219    ,   0.6624175    ,   0.6351557    
     +,   0.6120904    ,   0.5928774    ,   0.5765200    
     +,   0.5618193    ,   0.5477011    ,   0.5333503    
     +,   0.5181941    ,   0.5018378    ,   0.4840344    
     +,   0.4647033    ,   0.4439622    ,   0.4221360    
     +,   0.3997093    ,   0.3772428    ,   0.3552707    
     +,   0.3342301    ,   0.3144274    ,   0.2960415    
     +,   0.2791457    ,   0.2637396    ,   0.2497663    
     +,   0.2371230    ,   0.2256652    ,   0.2152149    
     +,   0.2055722    ,   0.1965317    ,   0.1878999    
     +,   0.1795108    ,   0.1712369    ,   0.1629912    
     +,   0.1547267    ,   0.1464310    ,   0.1381200    
     +,   0.1298291    ,   0.1216082    ,   0.1135165    
     +,   0.1056171    ,   9.7972289E-02,   9.0640537E-02
     +,   8.3673701E-02,   7.7114023E-02,   7.0991896E-02
     +,   6.5325364E-02,   6.0120963E-02,   5.5372909E-02
     +,   5.1065721E-02,   4.7176030E-02,   4.3674540E-02
     +,   4.0527921E-02,   3.7701134E-02,   3.5159208E-02
     +,   3.2868475E-02,   3.0797318E-02,   2.8917033E-02
     +,   2.7202301E-02,   2.5631016E-02,   2.4184154E-02
     +,   2.2845602E-02,   2.1601956E-02,   2.0441912E-02
     +,   1.9356059E-02,   1.8336603E-02,   1.7376998E-02
     +,   1.6471650E-02,   1.5615824E-02,   1.4805462E-02
     +,   1.4037094E-02,   1.3307629E-02,   1.2614368E-02
     +,   1.1955008E-02,   1.1327498E-02,   1.0730007E-02
     +,   1.0160924E-02,   9.6188560E-03,   9.1025252E-03
     +,   8.6107776E-03,   8.1426017E-03,   7.6970644E-03
     +,   7.2732740E-03,   6.8703941E-03,   6.4876573E-03
     +,   6.1243279E-03,   5.7796724E-03,   5.4529789E-03
     +,   5.1435847E-03,   4.8508053E-03,   4.5740032E-03
     +,   4.3125208E-03,   4.0657464E-03,   3.8330494E-03
     +,   3.6138422E-03,   3.4075184E-03,   3.2135134E-03
     +,   3.0312499E-03,   2.8601845E-03,   2.6997693E-03
     +,   2.5494704E-03,   2.4087806E-03,   2.2771852E-03
     +,   2.1542006E-03,   2.0393394E-03,   1.9321418E-03
     +,   1.8321482E-03,   1.7389246E-03,   1.6520415E-03
     +,   1.5710926E-03,   1.4956781E-03,   1.4254233E-03
     +,   1.3599601E-03,   1.2989454E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_hzonly_htt90_mass = Yx/13.1651835813954
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_hzonly_htt95_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.3096001E-03,   2.3886845E-03
     +,   2.4703639E-03,   2.5546998E-03,   2.6417491E-03
     +,   2.7315654E-03,   2.8241975E-03,   2.9196909E-03
     +,   3.0180826E-03,   3.1194079E-03,   3.2236932E-03
     +,   3.3309574E-03,   3.4412122E-03,   3.5544613E-03
     +,   3.6707018E-03,   3.7899166E-03,   3.9120857E-03
     +,   4.0371739E-03,   4.1651386E-03,   4.2959261E-03
     +,   4.4294740E-03,   4.5657060E-03,   4.7045355E-03
     +,   4.8458739E-03,   4.9896049E-03,   5.1356195E-03
     +,   5.2837906E-03,   5.4339822E-03,   5.5860509E-03
     +,   5.7398486E-03,   5.8952156E-03,   6.0519897E-03
     +,   6.2100082E-03,   6.3690986E-03,   6.5290951E-03
     +,   6.6898325E-03,   6.8511511E-03,   7.0128888E-03
     +,   7.1749189E-03,   7.3370975E-03,   7.4993265E-03
     +,   7.6615126E-03,   7.8236023E-03,   7.9855667E-03
     +,   8.1474213E-03,   8.3092246E-03,   8.4710810E-03
     +,   8.6331582E-03,   8.7956935E-03,   8.9589804E-03
     +,   9.1234054E-03,   9.2894323E-03,   9.4576105E-03
     +,   9.6286051E-03,   9.8031564E-03,   9.9821324E-03
     +,   1.0166500E-02,   1.0357333E-02,   1.0555815E-02
     +,   1.0763234E-02,   1.0980980E-02,   1.1210532E-02
     +,   1.1453440E-02,   1.1711336E-02,   1.1985904E-02
     +,   1.2278832E-02,   1.2591839E-02,   1.2926606E-02
     +,   1.3284788E-02,   1.3667919E-02,   1.4077474E-02
     +,   1.4514730E-02,   1.4980822E-02,   1.5476625E-02
     +,   1.6002804E-02,   1.6559741E-02,   1.7147474E-02
     +,   1.7765701E-02,   1.8413795E-02,   1.9090770E-02
     +,   1.9795179E-02,   2.0525284E-02,   2.1278867E-02
     +,   2.2053452E-02,   2.2846099E-02,   2.3653656E-02
     +,   2.4472591E-02,   2.5299212E-02,   2.6129548E-02
     +,   2.6959557E-02,   2.7785141E-02,   2.8602097E-02
     +,   2.9406305E-02,   3.0193804E-02,   3.0960798E-02
     +,   3.1703718E-02,   3.2419365E-02,   3.3104833E-02
     +,   3.3757742E-02,   3.4376133E-02,   3.4958623E-02
     +,   3.5504308E-02,   3.6012989E-02,   3.6484975E-02
     +,   3.6921274E-02,   3.7323449E-02,   3.7693709E-02
     +,   3.8034838E-02,   3.8350184E-02,   3.8643591E-02
     +,   3.8919393E-02,   3.9182335E-02,   3.9437514E-02
     +,   3.9690308E-02,   3.9946351E-02,   4.0211461E-02
     +,   4.0491603E-02,   4.0792882E-02,   4.1121580E-02
     +,   4.1484125E-02,   4.1887283E-02,   4.2338196E-02
     +,   4.2844545E-02,   4.3414909E-02,   4.4058800E-02
     +,   4.4786990E-02,   4.5611810E-02,   4.6547141E-02
     +,   4.7608741E-02,   4.8813887E-02,   5.0181385E-02
     +,   5.1730789E-02,   5.3482033E-02,   5.5454135E-02
     +,   5.7664331E-02,   6.0127102E-02,   6.2852696E-02
     +,   6.5846749E-02,   6.9110513E-02,   7.2641544E-02
     +,   7.6435469E-02,   8.0489360E-02,   8.4806263E-02
     +,   8.9400373E-02,   9.4301455E-02,   9.9561125E-02
     +,   0.1052547    ,   0.1114812    ,   0.1183596    
     +,   0.1260213    ,   0.1345962    ,   0.1441962    
     +,   0.1548960    ,   0.1667150    ,   0.1795995    
     +,   0.1934071    ,   0.2079025    ,   0.2227581    
     +,   0.2375646    ,   0.2518526    ,   0.2651309    
     +,   0.2769328    ,   0.2868760    ,   0.2947317    
     +,   0.3004903    ,   0.3044185    ,   0.3070911    
     +,   0.3093915    ,   0.3124663    ,   0.3176285    
     +,   0.3262064    ,   0.3393433    ,   0.3577803    
     +,   0.3816655    ,   0.4104623    ,   0.4430278    
     +,   0.4778838    ,   0.5136464    ,   0.5495725    
     +,   0.5860962    ,   0.6252059    ,   0.6703934    
     +,   0.7258768    ,   0.7950535    ,   0.8786954    
     +,   0.9739481    ,    1.074958    ,    1.174871    
     +,    1.267869    ,    1.350158    ,    1.419855    
     +,    1.476325    ,    1.519279    ,    1.547799    
     +,    1.560030    ,    1.554393    ,    1.531610    
     +,    1.495414    ,    1.450757    ,    1.401103    
     +,    1.347492    ,    1.290293    ,    1.231727    
     +,    1.176476    ,    1.129370    ,    1.091849    
     +,    1.060121    ,    1.026698    ,   0.9843100    
     +,   0.9294929    ,   0.8636723    ,   0.7916154    
     +,   0.7188168    ,   0.6494836    ,   0.5858912    
     +,   0.5287796    ,   0.4780737    ,   0.4333926    
     +,   0.3942330    ,   0.3599568    ,   0.3297747    
     +,   0.3028280    ,   0.2783197    ,   0.2556254    
     +,   0.2343409    ,   0.2142656    ,   0.1953502    
     +,   0.1776305    ,   0.1611723    ,   0.1460337    
     +,   0.1322425    ,   0.1197856    ,   0.1086076    
     +,   9.8620296E-02,   8.9714564E-02,   8.1770524E-02
     +,   7.4669376E-02,   6.8301350E-02,   6.2569864E-02
     +,   5.7392977E-02,   5.2703641E-02,   4.8448198E-02
     +,   4.4583865E-02,   4.1075766E-02,   3.7894860E-02
     +,   3.5016041E-02,   3.2416154E-02,   3.0072812E-02
     +,   2.7963940E-02,   2.6067687E-02,   2.4362162E-02
     +,   2.2825859E-02,   2.1438209E-02,   2.0179771E-02
     +,   1.9032538E-02,   1.7980266E-02,   1.7008688E-02
     +,   1.6105449E-02,   1.5260034E-02,   1.4463708E-02
     +,   1.3709401E-02,   1.2991458E-02,   1.2305414E-02
     +,   1.1647830E-02,   1.1016176E-02,   1.0408537E-02
     +,   9.8235412E-03,   9.2602605E-03,   8.7180696E-03
     +,   8.1965262E-03,   7.6953401E-03,   7.2143418E-03
     +,   6.7534177E-03,   6.3124313E-03,   5.8912453E-03
     +,   5.4897335E-03,   5.1076803E-03,   4.7448748E-03
     +,   4.4010021E-03,   4.0757470E-03,   3.7686960E-03
     +,   3.4794305E-03,   3.2074433E-03,   2.9522285E-03
     +,   2.7132046E-03,   2.4897964E-03,   2.2813769E-03
     +,   2.0873034E-03,   1.9069387E-03,   1.7396117E-03
     +,   1.5846706E-03,   1.4414453E-03,   1.3092899E-03
     +,   1.1875505E-03,   1.0756030E-03,   9.7282353E-04
     +,   8.7862212E-04,   7.9241593E-04,   7.1365660E-04
     +,   6.4180919E-04,   5.7637278E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_hzonly_htt95_mass = Yx/13.7296335909091
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_hzonly_ttz100_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  7.5037363E-03,   7.7667334E-03
     +,   8.0343029E-03,   8.3062174E-03,   8.5822251E-03
     +,   8.8620447E-03,   9.1453642E-03,   9.4318436E-03
     +,   9.7211059E-03,   1.0012760E-02,   1.0306368E-02
     +,   1.0601473E-02,   1.0897582E-02,   1.1194177E-02
     +,   1.1490719E-02,   1.1786632E-02,   1.2081327E-02
     +,   1.2374190E-02,   1.2664590E-02,   1.2951881E-02
     +,   1.3235410E-02,   1.3514505E-02,   1.3788498E-02
     +,   1.4056724E-02,   1.4318506E-02,   1.4573201E-02
     +,   1.4820155E-02,   1.5058751E-02,   1.5288388E-02
     +,   1.5508496E-02,   1.5718533E-02,   1.5918000E-02
     +,   1.6106445E-02,   1.6283458E-02,   1.6448693E-02
     +,   1.6601844E-02,   1.6742676E-02,   1.6871011E-02
     +,   1.6986754E-02,   1.7089849E-02,   1.7180348E-02
     +,   1.7258339E-02,   1.7324017E-02,   1.7377615E-02
     +,   1.7419463E-02,   1.7449947E-02,   1.7469531E-02
     +,   1.7478738E-02,   1.7478149E-02,   1.7468430E-02
     +,   1.7450264E-02,   1.7424412E-02,   1.7391657E-02
     +,   1.7352840E-02,   1.7308824E-02,   1.7260505E-02
     +,   1.7208779E-02,   1.7154578E-02,   1.7098829E-02
     +,   1.7042462E-02,   1.6986396E-02,   1.6931539E-02
     +,   1.6878782E-02,   1.6828991E-02,   1.6782993E-02
     +,   1.6741600E-02,   1.6705567E-02,   1.6675621E-02
     +,   1.6652439E-02,   1.6636647E-02,   1.6628837E-02
     +,   1.6629547E-02,   1.6639275E-02,   1.6658455E-02
     +,   1.6687499E-02,   1.6726766E-02,   1.6776593E-02
     +,   1.6837262E-02,   1.6909033E-02,   1.6992165E-02
     +,   1.7086860E-02,   1.7193332E-02,   1.7311782E-02
     +,   1.7442413E-02,   1.7585408E-02,   1.7740998E-02
     +,   1.7909382E-02,   1.8090783E-02,   1.8285459E-02
     +,   1.8493652E-02,   1.8715659E-02,   1.8951751E-02
     +,   1.9202214E-02,   1.9467348E-02,   1.9747451E-02
     +,   2.0042773E-02,   2.0353576E-02,   2.0680057E-02
     +,   2.1022363E-02,   2.1380572E-02,   2.1754678E-02
     +,   2.2144549E-02,   2.2549970E-02,   2.2970524E-02
     +,   2.3405725E-02,   2.3854859E-02,   2.4317045E-02
     +,   2.4791192E-02,   2.5276072E-02,   2.5770241E-02
     +,   2.6272047E-02,   2.6779715E-02,   2.7291238E-02
     +,   2.7804568E-02,   2.8317463E-02,   2.8827664E-02
     +,   2.9332863E-02,   2.9830784E-02,   3.0319188E-02
     +,   3.0795958E-02,   3.1259175E-02,   3.1707119E-02
     +,   3.2138292E-02,   3.2551631E-02,   3.2946348E-02
     +,   3.3322096E-02,   3.3678908E-02,   3.4017339E-02
     +,   3.4338370E-02,   3.4643408E-02,   3.4934361E-02
     +,   3.5213489E-02,   3.5483517E-02,   3.5747405E-02
     +,   3.6008511E-02,   3.6270339E-02,   3.6536645E-02
     +,   3.6811247E-02,   3.7098095E-02,   3.7401181E-02
     +,   3.7724502E-02,   3.8072016E-02,   3.8447779E-02
     +,   3.8855858E-02,   3.9300345E-02,   3.9785486E-02
     +,   4.0315732E-02,   4.0895756E-02,   4.1530509E-02
     +,   4.2225346E-02,   4.2985998E-02,   4.3818567E-02
     +,   4.4729460E-02,   4.5725446E-02,   4.6813473E-02
     +,   4.8000488E-02,   4.9293254E-02,   5.0698448E-02
     +,   5.2222323E-02,   5.3870596E-02,   5.5648815E-02
     +,   5.7562534E-02,   5.9617534E-02,   6.1820701E-02
     +,   6.4181231E-02,   6.6711493E-02,   6.9428310E-02
     +,   7.2354205E-02,   7.5518817E-02,   7.8959614E-02
     +,   8.2721420E-02,   8.6856574E-02,   9.1424346E-02
     +,   9.6489668E-02,   0.1021222    ,   0.1083983    
     +,   0.1154029    ,   0.1232335    ,   0.1320055    
     +,   0.1418568    ,   0.1529455    ,   0.1654396    
     +,   0.1794964    ,   0.1952351    ,   0.2127061    
     +,   0.2318749    ,   0.2526414    ,   0.2749105    
     +,   0.2987157    ,   0.3243864    ,   0.3527187    
     +,   0.3850668    ,   0.4232657    ,   0.4693091    
     +,   0.5247898    ,   0.5902906    ,   0.6652321    
     +,   0.7487891    ,   0.8419791    ,   0.9496142    
     +,    1.079718    ,    1.239103    ,    1.427617    
     +,    1.636258    ,    1.851767    ,    2.064056    
     +,    2.270371    ,    2.475284    ,    2.688631    
     +,    2.920144    ,    3.171722    ,    3.438855    
     +,    3.718801    ,    3.998189    ,    4.231467    
     +,    4.362656    ,    4.371387    ,    4.267524    
     +,    4.053663    ,    3.737427    ,    3.370424    
     +,    3.028584    ,    2.754118    ,    2.539591    
     +,    2.353472    ,    2.161554    ,    1.939282    
     +,    1.683096    ,    1.410682    ,    1.146964    
     +,   0.9098915    ,   0.7067668    ,   0.5382923    
     +,   0.4027676    ,   0.2973937    ,   0.2181261    
     +,   0.1599498    ,   0.1177444    ,   8.7107077E-02
     +,   6.4709276E-02,   4.8221443E-02,   3.6048159E-02
     +,   2.7070997E-02,   2.0473527E-02,   1.5640898E-02
     +,   1.2104055E-02,   9.5061129E-03,   7.5796093E-03
     +,   6.1285812E-03,   5.0130733E-03,   4.1353730E-03
     +,   3.4288811E-03,   2.8489800E-03,   2.3659717E-03
     +,   1.9599167E-03,   1.6170862E-03,   1.3275847E-03
     +,   1.0837988E-03,   8.7948242E-04,   7.0927024E-04
     +,   5.6842359E-04,   4.5269378E-04,   3.5826772E-04
     +,   2.8175814E-04,   2.2019372E-04,   1.7098656E-04
     +,   1.3191669E-04,   1.0110263E-04,   7.6962788E-05
     +,   5.8179314E-05,   4.3664819E-05,   3.2529741E-05
     +,   2.4050561E-05,   1.7642886E-05,   1.2838665E-05
     +,   9.2662003E-06,   6.6317471E-06,   4.7058397E-06
     +,   3.3102062E-06,   2.3079895E-06,   1.5948216E-06
     +,   1.0920833E-06,   7.4099370E-07,   4.9815640E-07
     +,   3.3179379E-07,   2.1893197E-07,   1.4310712E-07
     +,   9.2661679E-08,   5.9432526E-08,   3.7757811E-08
     +,   2.3760311E-08,   1.4809372E-08,   9.1425800E-09
     +,   5.5901954E-09,   3.3854974E-09,   2.0306552E-09
     +,   1.2063712E-09,   7.0980233E-10,   4.1363904E-10
     +,   2.3873384E-10,   1.3646781E-10
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_hzonly_ttz100_mass = Yx/23.0788203829787
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_hzonly_ttz105_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  9.9997595E-03,   1.0330888E-02
     +,   1.0663087E-02,   1.0996022E-02,   1.1329412E-02
     +,   1.1663010E-02,   1.1996641E-02,   1.2330180E-02
     +,   1.2663574E-02,   1.2996864E-02,   1.3330144E-02
     +,   1.3663613E-02,   1.3997543E-02,   1.4332308E-02
     +,   1.4668370E-02,   1.5006279E-02,   1.5346660E-02
     +,   1.5690245E-02,   1.6037820E-02,   1.6390247E-02
     +,   1.6748447E-02,   1.7113380E-02,   1.7486030E-02
     +,   1.7867422E-02,   1.8258533E-02,   1.8660370E-02
     +,   1.9073844E-02,   1.9499825E-02,   1.9939082E-02
     +,   2.0392273E-02,   2.0859921E-02,   2.1342386E-02
     +,   2.1839852E-02,   2.2352302E-02,   2.2879487E-02
     +,   2.3420945E-02,   2.3975974E-02,   2.4543570E-02
     +,   2.5122572E-02,   2.5711460E-02,   2.6308555E-02
     +,   2.6911898E-02,   2.7519330E-02,   2.8128520E-02
     +,   2.8736943E-02,   2.9341979E-02,   2.9940929E-02
     +,   3.0531049E-02,   3.1109579E-02,   3.1673897E-02
     +,   3.2221410E-02,   3.2749776E-02,   3.3256900E-02
     +,   3.3740941E-02,   3.4200408E-02,   3.4634296E-02
     +,   3.5041984E-02,   3.5423368E-02,   3.5778914E-02
     +,   3.6109664E-02,   3.6417220E-02,   3.6703814E-02
     +,   3.6972243E-02,   3.7225947E-02,   3.7468858E-02
     +,   3.7705451E-02,   3.7940688E-02,   3.8179845E-02
     +,   3.8428579E-02,   3.8692690E-02,   3.8978066E-02
     +,   3.9290618E-02,   3.9636083E-02,   4.0019836E-02
     +,   4.0446941E-02,   4.0921770E-02,   4.1448034E-02
     +,   4.2028639E-02,   4.2665467E-02,   4.3359362E-02
     +,   4.4109985E-02,   4.4915896E-02,   4.5774188E-02
     +,   4.6680886E-02,   4.7630608E-02,   4.8616875E-02
     +,   4.9631968E-02,   5.0667260E-02,   5.1713221E-02
     +,   5.2759595E-02,   5.3795651E-02,   5.4810360E-02
     +,   5.5792563E-02,   5.6731462E-02,   5.7616528E-02
     +,   5.8437936E-02,   5.9186831E-02,   5.9855346E-02
     +,   6.0437020E-02,   6.0926732E-02,   6.1321028E-02
     +,   6.1618030E-02,   6.1817650E-02,   6.1921407E-02
     +,   6.1932556E-02,   6.1855871E-02,   6.1697546E-02
     +,   6.1465155E-02,   6.1167322E-02,   6.0813460E-02
     +,   6.0413834E-02,   5.9978928E-02,   5.9519488E-02
     +,   5.9046127E-02,   5.8569241E-02,   5.8098573E-02
     +,   5.7643149E-02,   5.7211142E-02,   5.6809664E-02
     +,   5.6444675E-02,   5.6120839E-02,   5.5841692E-02
     +,   5.5609435E-02,   5.5425011E-02,   5.5288240E-02
     +,   5.5197835E-02,   5.5151604E-02,   5.5146389E-02
     +,   5.5178516E-02,   5.5243723E-02,   5.5337433E-02
     +,   5.5454839E-02,   5.5591162E-02,   5.5741828E-02
     +,   5.5902541E-02,   5.6069449E-02,   5.6239311E-02
     +,   5.6409612E-02,   5.6578577E-02,   5.6745272E-02
     +,   5.6909803E-02,   5.7073094E-02,   5.7237186E-02
     +,   5.7405014E-02,   5.7580568E-02,   5.7768725E-02
     +,   5.7975303E-02,   5.8207087E-02,   5.8471549E-02
     +,   5.8776964E-02,   5.9132334E-02,   5.9547015E-02
     +,   6.0031034E-02,   6.0594603E-02,   6.1248284E-02
     +,   6.2002517E-02,   6.2867880E-02,   6.3854612E-02
     +,   6.4972870E-02,   6.6232279E-02,   6.7642242E-02
     +,   6.9212131E-02,   7.0950963E-02,   7.2868235E-02
     +,   7.4974492E-02,   7.7282034E-02,   7.9805791E-02
     +,   8.2564719E-02,   8.5583724E-02,   8.8894986E-02
     +,   9.2539668E-02,   9.6569002E-02,   0.1010463    
     +,   0.1060465    ,   0.1116549    ,   0.1179661    
     +,   0.1250804    ,   0.1330995    ,   0.1421219    
     +,   0.1522389    ,   0.1635315    ,   0.1760671    
     +,   0.1898992    ,   0.2050698    ,   0.2216083    
     +,   0.2395297    ,   0.2588325    ,   0.2794951    
     +,   0.3014701    ,   0.3246802    ,   0.3490220    
     +,   0.3743713    ,   0.4005855    ,   0.4275086    
     +,   0.4549719    ,   0.4827970    ,   0.5108203    
     +,   0.5389783    ,   0.5674464    ,   0.5968276    
     +,   0.6283204    ,   0.6637946    ,   0.7056841    
     +,   0.7566935    ,   0.8193701    ,   0.8956633    
     +,   0.9865308    ,    1.091574    ,    1.208702    
     +,    1.333876    ,    1.461100    ,    1.583016    
     +,    1.692307    ,    1.783640    ,    1.855531    
     +,    1.911513    ,    1.960078    ,    2.012863    
     +,    2.081198    ,    2.172893    ,    2.292493    
     +,    2.445015    ,    2.637610    ,    2.872789    
     +,    3.136305    ,    3.392242    ,    3.594029    
     +,    3.704414    ,    3.708164    ,    3.609411    
     +,    3.420062    ,    3.151494    ,    2.815422    
     +,    2.430078    ,    2.023093    ,    1.626510    
     +,    1.267715    ,   0.9630167    ,   0.7170305    
     +,   0.5260454    ,   0.3820755    ,   0.2758218    
     +,   0.1984393    ,   0.1424607    ,   0.1021020    
     +,   7.3112570E-02,   5.2416131E-02,   3.7759788E-02
     +,   2.7465494E-02,   2.0277604E-02,   1.5266678E-02
     +,   1.1761017E-02,   9.2866290E-03,   7.5149275E-03
     +,   6.2206462E-03,   5.2503138E-03,   4.4998499E-03
     +,   3.8991491E-03,   3.4016736E-03,   2.9773044E-03
     +,   2.6072147E-03,   2.2800823E-03,   1.9893188E-03
     +,   1.7311269E-03,   1.5031658E-03,   1.3036382E-03
     +,   1.1308298E-03,   9.8288397E-04,   8.5772498E-04
     +,   7.5308903E-04,   6.6661707E-04,   5.9595075E-04
     +,   5.3881016E-04,   4.9305835E-04,   4.5675258E-04
     +,   4.2817177E-04,   4.0581718E-04,   3.8841538E-04
     +,   3.7489878E-04,   3.6439011E-04,   3.5617704E-04
     +,   3.4969131E-04,   3.4448426E-04,   3.4020748E-04
     +,   3.3659316E-04,   3.3343874E-04,   3.3059242E-04
     +,   3.2794219E-04,   3.2540687E-04,   3.2292787E-04
     +,   3.2046431E-04,   3.1798746E-04,   3.1547833E-04
     +,   3.1292418E-04,   3.1031729E-04,   3.0765292E-04
     +,   3.0492895E-04,   3.0214444E-04,   2.9929998E-04
     +,   2.9639638E-04,   2.9343538E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_hzonly_ttz105_mass = Yx/22.2227281276596
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_hzonly_ttz107_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.8590000E-02,   1.9303620E-02
     +,   2.0020235E-02,   2.0738617E-02,   2.1457547E-02
     +,   2.2175832E-02,   2.2892293E-02,   2.3605801E-02
     +,   2.4315245E-02,   2.5019605E-02,   2.5717877E-02
     +,   2.6409106E-02,   2.7092457E-02,   2.7767086E-02
     +,   2.8432259E-02,   2.9087314E-02,   2.9731642E-02
     +,   3.0364720E-02,   3.0986099E-02,   3.1595413E-02
     +,   3.2192338E-02,   3.2776665E-02,   3.3348229E-02
     +,   3.3906993E-02,   3.4452911E-02,   3.4986090E-02
     +,   3.5506658E-02,   3.6014847E-02,   3.6510941E-02
     +,   3.6995310E-02,   3.7468378E-02,   3.7930641E-02
     +,   3.8382638E-02,   3.8824994E-02,   3.9258391E-02
     +,   3.9683528E-02,   4.0101122E-02,   4.0511969E-02
     +,   4.0916856E-02,   4.1316558E-02,   4.1711882E-02
     +,   4.2103570E-02,   4.2492319E-02,   4.2878792E-02
     +,   4.3263566E-02,   4.3647125E-02,   4.4029824E-02
     +,   4.4411879E-02,   4.4793379E-02,   4.5174245E-02
     +,   4.5554213E-02,   4.5932826E-02,   4.6309453E-02
     +,   4.6683237E-02,   4.7053162E-02,   4.7418013E-02
     +,   4.7776353E-02,   4.8126612E-02,   4.8467174E-02
     +,   4.8796128E-02,   4.9111634E-02,   4.9411733E-02
     +,   4.9694475E-02,   4.9957938E-02,   5.0200287E-02
     +,   5.0419878E-02,   5.0615106E-02,   5.0784670E-02
     +,   5.0927505E-02,   5.1042892E-02,   5.1130373E-02
     +,   5.1189896E-02,   5.1221766E-02,   5.1226757E-02
     +,   5.1205948E-02,   5.1160894E-02,   5.1093522E-02
     +,   5.1006217E-02,   5.0901540E-02,   5.0782576E-02
     +,   5.0652530E-02,   5.0514877E-02,   5.0373290E-02
     +,   5.0231509E-02,   5.0093383E-02,   4.9962718E-02
     +,   4.9843229E-02,   4.9738556E-02,   4.9652100E-02
     +,   4.9587086E-02,   4.9546409E-02,   4.9532726E-02
     +,   4.9548313E-02,   4.9595188E-02,   4.9674891E-02
     +,   4.9788784E-02,   4.9937747E-02,   5.0122436E-02
     +,   5.0343387E-02,   5.0600629E-02,   5.0894219E-02
     +,   5.1223990E-02,   5.1589753E-02,   5.1991168E-02
     +,   5.2428067E-02,   5.2900095E-02,   5.3407174E-02
     +,   5.3949129E-02,   5.4526005E-02,   5.5137776E-02
     +,   5.5784650E-02,   5.6466728E-02,   5.7184115E-02
     +,   5.7936896E-02,   5.8724903E-02,   5.9547953E-02
     +,   6.0405292E-02,   6.1296109E-02,   6.2218864E-02
     +,   6.3171655E-02,   6.4152054E-02,   6.5156877E-02
     +,   6.6182330E-02,   6.7223988E-02,   6.8276815E-02
     +,   6.9335029E-02,   7.0392467E-02,   7.1442284E-02
     +,   7.2477587E-02,   7.3490940E-02,   7.4475095E-02
     +,   7.5422771E-02,   7.6327145E-02,   7.7181764E-02
     +,   7.7980958E-02,   7.8720018E-02,   7.9395309E-02
     +,   8.0004483E-02,   8.0546707E-02,   8.1022941E-02
     +,   8.1435665E-02,   8.1789508E-02,   8.2090922E-02
     +,   8.2348481E-02,   8.2572885E-02,   8.2776725E-02
     +,   8.2974754E-02,   8.3183795E-02,   8.3422221E-02
     +,   8.3710477E-02,   8.4070414E-02,   8.4525324E-02
     +,   8.5099794E-02,   8.5819222E-02,   8.6709753E-02
     +,   8.7797940E-02,   8.9110456E-02,   9.0673581E-02
     +,   9.2513271E-02,   9.4654225E-02,   9.7120270E-02
     +,   9.9933758E-02,   0.1031155    ,   0.1066842    
     +,   0.1106580    ,   0.1150534    ,   0.1198855    
     +,   0.1251690    ,   0.1309184    ,   0.1371479    
     +,   0.1438709    ,   0.1511001    ,   0.1588471    
     +,   0.1671218    ,   0.1759311    ,   0.1852797    
     +,   0.1951724    ,   0.2056124    ,   0.2166066    
     +,   0.2281681    ,   0.2403178    ,   0.2530848    
     +,   0.2665053    ,   0.2806190    ,   0.2954632    
     +,   0.3110650    ,   0.3274418    ,   0.3446072    
     +,   0.3625836    ,   0.3814275    ,   0.4012652    
     +,   0.4223252    ,   0.4449584    ,   0.4696457    
     +,   0.4969613    ,   0.5274957    ,   0.5617345    
     +,   0.5999165    ,   0.6419131    ,   0.6871777    
     +,   0.7348233    ,   0.7838347    ,   0.8333687    
     +,   0.8830007    ,   0.9328403    ,   0.9834825    
     +,    1.035864    ,    1.091217    ,    1.151153    
     +,    1.217727    ,    1.293165    ,    1.379063    
     +,    1.475286    ,    1.579235    ,    1.686073    
     +,    1.790038    ,    1.886255    ,    1.972171    
     +,    2.048062    ,    2.116638    ,    2.181940    
     +,    2.247666    ,    2.315178    ,    2.382163    
     +,    2.442930    ,    2.490379    ,    2.518145    
     +,    2.521214    ,    2.494580    ,    2.431884    
     +,    2.326203    ,    2.173203    ,    1.974773    
     +,    1.740540    ,    1.486320    ,    1.230314    
     +,   0.9890929    ,   0.7748027    ,   0.5940480    
     +,   0.4482721    ,   0.3350554    ,   0.2496996    
     +,   0.1866559    ,   0.1405772    ,   0.1069160    
     +,   8.2129955E-02,   6.3626714E-02,   4.9590990E-02
     +,   3.8786471E-02,   3.0379707E-02,   2.3801574E-02
     +,   1.8652426E-02,   1.4638484E-02,   1.1531975E-02
     +,   9.1484450E-03,   7.3349942E-03,   5.9643979E-03
     +,   4.9317963E-03,   4.1525410E-03,   3.5601498E-03
     +,   3.1038737E-03,   2.7459948E-03,   2.4591764E-03
     +,   2.2240544E-03,   2.0271689E-03,   1.8592402E-03
     +,   1.7139170E-03,   1.5868478E-03,   1.4750087E-03
     +,   1.3762434E-03,   1.2889655E-03,   1.2119558E-03
     +,   1.1442186E-03,   1.0848895E-03,   1.0331845E-03
     +,   9.8837086E-04,   9.4973866E-04,   9.1660686E-04
     +,   8.8831404E-04,   8.6423237E-04,   8.4376568E-04
     +,   8.2636328E-04,   8.1151858E-04,   7.9877779E-04
     +,   7.8773755E-04,   7.7804748E-04,   7.6940598E-04
     +,   7.6155848E-04,   7.5429346E-04,   7.4743672E-04
     +,   7.4084825E-04,   7.3441630E-04,   7.2805386E-04
     +,   7.2169339E-04,   7.1528502E-04,   7.0879102E-04
     +,   7.0218550E-04,   6.9544988E-04,   6.8857311E-04
     +,   6.8154791E-04,   6.7437225E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_hzonly_ttz107_mass = Yx/20.1060193478261
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_hzonly_ttz110_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.5811786E-02,   1.6464157E-02
     +,   1.7130239E-02,   1.7809764E-02,   1.8502399E-02
     +,   1.9207826E-02,   1.9925660E-02,   2.0655507E-02
     +,   2.1396929E-02,   2.2149473E-02,   2.2912616E-02
     +,   2.3685798E-02,   2.4468433E-02,   2.5259867E-02
     +,   2.6059380E-02,   2.6866246E-02,   2.7679630E-02
     +,   2.8498681E-02,   2.9322468E-02,   3.0150002E-02
     +,   3.0980265E-02,   3.1812154E-02,   3.2644529E-02
     +,   3.3476245E-02,   3.4306031E-02,   3.5132676E-02
     +,   3.5954919E-02,   3.6771446E-02,   3.7581012E-02
     +,   3.8382303E-02,   3.9174099E-02,   3.9955176E-02
     +,   4.0724449E-02,   4.1480761E-02,   4.2223174E-02
     +,   4.2950783E-02,   4.3662839E-02,   4.4358723E-02
     +,   4.5037966E-02,   4.5700293E-02,   4.6345558E-02
     +,   4.6973929E-02,   4.7585640E-02,   4.8181240E-02
     +,   4.8761461E-02,   4.9327243E-02,   4.9879763E-02
     +,   5.0420411E-02,   5.0950758E-02,   5.1472511E-02
     +,   5.1987559E-02,   5.2497953E-02,   5.3005774E-02
     +,   5.3513154E-02,   5.4022226E-02,   5.4535083E-02
     +,   5.5053752E-02,   5.5580009E-02,   5.6115530E-02
     +,   5.6661688E-02,   5.7219513E-02,   5.7789728E-02
     +,   5.8372546E-02,   5.8967892E-02,   5.9575137E-02
     +,   6.0193140E-02,   6.0820300E-02,   6.1454494E-02
     +,   6.2093150E-02,   6.2733166E-02,   6.3371234E-02
     +,   6.4003445E-02,   6.4625710E-02,   6.5233782E-02
     +,   6.5823190E-02,   6.6389516E-02,   6.6928312E-02
     +,   6.7435309E-02,   6.7906529E-02,   6.8338364E-02
     +,   6.8727501E-02,   6.9071330E-02,   6.9367632E-02
     +,   6.9614984E-02,   6.9812506E-02,   6.9960110E-02
     +,   7.0058472E-02,   7.0108756E-02,   7.0113055E-02
     +,   7.0073955E-02,   6.9994718E-02,   6.9879025E-02
     +,   6.9731131E-02,   6.9555707E-02,   6.9357596E-02
     +,   6.9141984E-02,   6.8914123E-02,   6.8679385E-02
     +,   6.8443112E-02,   6.8210609E-02,   6.7987062E-02
     +,   6.7777514E-02,   6.7586757E-02,   6.7419454E-02
     +,   6.7280062E-02,   6.7172840E-02,   6.7101777E-02
     +,   6.7070752E-02,   6.7083493E-02,   6.7143492E-02
     +,   6.7254253E-02,   6.7419082E-02,   6.7641027E-02
     +,   6.7923330E-02,   6.8268806E-02,   6.8680212E-02
     +,   6.9160089E-02,   6.9710560E-02,   7.0333458E-02
     +,   7.1030162E-02,   7.1801417E-02,   7.2647370E-02
     +,   7.3567286E-02,   7.4559659E-02,   7.5621955E-02
     +,   7.6750569E-02,   7.7940904E-02,   7.9186939E-02
     +,   8.0481969E-02,   8.1817865E-02,   8.3185621E-02
     +,   8.4575400E-02,   8.5976645E-02,   8.7378278E-02
     +,   8.8769048E-02,   9.0137742E-02,   9.1473527E-02
     +,   9.2766106E-02,   9.4006158E-02,   9.5185772E-02
     +,   9.6298233E-02,   9.7338893E-02,   9.8304726E-02
     +,   9.9195041E-02,   0.1000108    ,   0.1007550    
     +,   0.1014329    ,   0.1020513    ,   0.1026178    
     +,   0.1031420    ,   0.1036337    ,   0.1041032    
     +,   0.1045610    ,   0.1050170    ,   0.1054809    
     +,   0.1059613    ,   0.1064661    ,   0.1070026    
     +,   0.1075775    ,   0.1081973    ,   0.1088692    
     +,   0.1096014    ,   0.1104040    ,   0.1112907    
     +,   0.1122788    ,   0.1133910    ,   0.1146563    
     +,   0.1161104    ,   0.1177964    ,   0.1197651    
     +,   0.1220733    ,   0.1247837    ,   0.1279618    
     +,   0.1316736    ,   0.1359808    ,   0.1409378    
     +,   0.1465874    ,   0.1529559    ,   0.1600519    
     +,   0.1678658    ,   0.1763723    ,   0.1855366    
     +,   0.1953231    ,   0.2057104    ,   0.2167039    
     +,   0.2283491    ,   0.2407408    ,   0.2540251    
     +,   0.2683893    ,   0.2840434    ,   0.3011954    
     +,   0.3200280    ,   0.3406799    ,   0.3632501    
     +,   0.3878191    ,   0.4144846    ,   0.4433910    
     +,   0.4747456    ,   0.5087969    ,   0.5457812    
     +,   0.5858465    ,   0.6290009    ,   0.6751117    
     +,   0.7239377    ,   0.7751802    ,   0.8285075    
     +,   0.8834959    ,   0.9395520    ,   0.9959022    
     +,    1.051811    ,    1.107004    ,    1.162171    
     +,    1.219213    ,    1.280921    ,    1.350020    
     +,    1.427897    ,    1.513660    ,    1.604089    
     +,    1.694614    ,    1.780854    ,    1.859911    
     +,    1.930637    ,    1.992833    ,    2.045897    
     +,    2.087824    ,    2.115117    ,    2.123627    
     +,    2.109694    ,    2.070993    ,    2.006695    
     +,    1.917200    ,    1.803788    ,    1.668594    
     +,    1.514923    ,    1.347608    ,    1.172994    
     +,   0.9984118    ,   0.8312256    ,   0.6777192    
     +,   0.5422567    ,   0.4269570    ,   0.3318698    
     +,   0.2554875    ,   0.1953879    ,   0.1488237    
     +,   0.1131373    ,   8.5985392E-02,   6.5421745E-02
     +,   4.9891446E-02,   3.8180057E-02,   2.9348997E-02
     +,   2.2680126E-02,   1.7628817E-02,   1.3785541E-02
     +,   1.0845263E-02,   8.5829748E-03,   6.8334048E-03
     +,   5.4746349E-03,   4.4157552E-03,   3.5880203E-03
     +,   2.9386447E-03,   2.4265756E-03,   2.0197143E-03
     +,   1.6930973E-03,   1.4275423E-03,   1.2084959E-03
     +,   1.0251513E-03,   8.6964801E-04,   7.3635293E-04
     +,   6.2126369E-04,   5.2153587E-04,   4.3511004E-04
     +,   3.6042556E-04,   2.9622018E-04,   2.4140863E-04
     +,   1.9500975E-04,   1.5609441E-04,   1.2378168E-04
     +,   9.7227305E-05,   7.5638251E-05,   5.8273970E-05
     +,   4.4460263E-05,   3.3589957E-05,   2.5129531E-05
     +,   1.8615776E-05,   1.3655374E-05,   9.9184663E-06
     +,   7.1334102E-06,   5.0800768E-06,   3.5822309E-06
     +,   2.5012521E-06,   1.7293074E-06,   1.1838852E-06
     +,   8.0252909E-07,   5.3869269E-07,   3.5804985E-07
     +,   2.3566089E-07,   1.5359393E-07,   9.9136400E-08
     +,   6.3369832E-08,   4.0121808E-08
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_hzonly_ttz110_mass = Yx/17.7613294782609
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_hzonly_ttz115_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.8348342E-02,   2.9799771E-02
     +,   3.1283353E-02,   3.2795869E-02,   3.4333784E-02
     +,   3.5893142E-02,   3.7469689E-02,   3.9058860E-02
     +,   4.0655747E-02,   4.2255331E-02,   4.3852255E-02
     +,   4.5441091E-02,   4.7016203E-02,   4.8572015E-02
     +,   5.0102957E-02,   5.1603466E-02,   5.3068265E-02
     +,   5.4492164E-02,   5.5870380E-02,   5.7198480E-02
     +,   5.8472451E-02,   5.9688821E-02,   6.0844615E-02
     +,   6.1937571E-02,   6.2965952E-02,   6.3928857E-02
     +,   6.4825974E-02,   6.5657705E-02,   6.6425204E-02
     +,   6.7130238E-02,   6.7775317E-02,   6.8363473E-02
     +,   6.8898261E-02,   6.9383815E-02,   6.9824532E-02
     +,   7.0225157E-02,   7.0590727E-02,   7.0926197E-02
     +,   7.1236707E-02,   7.1527183E-02,   7.1802460E-02
     +,   7.2067000E-02,   7.2324894E-02,   7.2579838E-02
     +,   7.2835043E-02,   7.3093101E-02,   7.3356047E-02
     +,   7.3625289E-02,   7.3901631E-02,   7.4185222E-02
     +,   7.4475698E-02,   7.4772105E-02,   7.5072959E-02
     +,   7.5376369E-02,   7.5680040E-02,   7.5981453E-02
     +,   7.6277681E-02,   7.6565810E-02,   7.6842882E-02
     +,   7.7105783E-02,   7.7351652E-02,   7.7577695E-02
     +,   7.7781394E-02,   7.7960521E-02,   7.8113124E-02
     +,   7.8237675E-02,   7.8333102E-02,   7.8398570E-02
     +,   7.8434035E-02,   7.8439616E-02,   7.8416035E-02
     +,   7.8364469E-02,   7.8286573E-02,   7.8184359E-02
     +,   7.8060433E-02,   7.7917576E-02,   7.7759296E-02
     +,   7.7589072E-02,   7.7411093E-02,   7.7229492E-02
     +,   7.7049002E-02,   7.6874517E-02,   7.6710992E-02
     +,   7.6563656E-02,   7.6438040E-02,   7.6339431E-02
     +,   7.6273412E-02,   7.6245390E-02,   7.6260798E-02
     +,   7.6324835E-02,   7.6442607E-02,   7.6618820E-02
     +,   7.6857843E-02,   7.7163570E-02,   7.7539355E-02
     +,   7.7988051E-02,   7.8511640E-02,   7.9111375E-02
     +,   7.9787843E-02,   8.0540292E-02,   8.1367590E-02
     +,   8.2267053E-02,   8.3235390E-02,   8.4267929E-02
     +,   8.5359409E-02,   8.6503431E-02,   8.7692656E-02
     +,   8.8918895E-02,   9.0173595E-02,   9.1447510E-02
     +,   9.2731014E-02,   9.4014153E-02,   9.5287196E-02
     +,   9.6540503E-02,   9.7764567E-02,   9.8950751E-02
     +,   0.1000908    ,   0.1011775    ,   0.1022046    
     +,   0.1031670    ,   0.1040604    ,   0.1048821    
     +,   0.1056303    ,   0.1063044    ,   0.1069047    
     +,   0.1074326    ,   0.1078900    ,   0.1082799    
     +,   0.1086049    ,   0.1088683    ,   0.1090735    
     +,   0.1092232    ,   0.1093200    ,   0.1093661    
     +,   0.1093628    ,   0.1093108    ,   0.1092102    
     +,   0.1090602    ,   0.1088595    ,   0.1086065    
     +,   0.1082989    ,   0.1079348    ,   0.1075123    
     +,   0.1070298    ,   0.1064867    ,   0.1058834    
     +,   0.1052216    ,   0.1045046    ,   0.1037377    
     +,   0.1029279    ,   0.1020846    ,   0.1012191    
     +,   0.1003451    ,   9.9478535E-02,   9.8636791E-02
     +,   9.7839348E-02,   9.7106896E-02,   9.6461013E-02
     +,   9.5924132E-02,   9.5518328E-02,   9.5265500E-02
     +,   9.5186293E-02,   9.5300183E-02,   9.5623791E-02
     +,   9.6171722E-02,   9.6955210E-02,   9.7981960E-02
     +,   9.9255845E-02,   0.1007768    ,   0.1025410    
     +,   0.1045407    ,   0.1067647    ,   0.1091991    
     +,   0.1118282    ,   0.1146350    ,   0.1176031    
     +,   0.1207178    ,   0.1239673    ,   0.1273441    
     +,   0.1308476    ,   0.1344836    ,   0.1382668    
     +,   0.1422204    ,   0.1463778    ,   0.1507816    
     +,   0.1554832    ,   0.1605414    ,   0.1660197    
     +,   0.1719839    ,   0.1784957    ,   0.1856084    
     +,   0.1933620    ,   0.2017788    ,   0.2108635    
     +,   0.2206107    ,   0.2310167    ,   0.2420998    
     +,   0.2539274    ,   0.2666442    ,   0.2804942    
     +,   0.2958268    ,   0.3130907    ,   0.3328001    
     +,   0.3554860    ,   0.3816307    ,   0.4116139    
     +,   0.4456668    ,   0.4838514    ,   0.5260687    
     +,   0.5720869    ,   0.6215760    ,   0.6741214    
     +,   0.7292386    ,   0.7863556    ,   0.8447959    
     +,   0.9037631    ,   0.9623701    ,    1.019706    
     +,    1.074929    ,    1.127362    ,    1.176582    
     +,    1.222424    ,    1.264894    ,    1.304020    
     +,    1.339649    ,    1.371233    ,    1.397696    
     +,    1.417409    ,    1.428297    ,    1.428069    
     +,    1.414526    ,    1.385893    ,    1.341141    
     +,    1.280195    ,    1.204062    ,    1.114792    
     +,    1.015322    ,   0.9092295    ,   0.8003818    
     +,   0.6925723    ,   0.5891995    ,   0.4930268    
     +,   0.4060256    ,   0.3293377    ,   0.2633445    
     +,   0.2078006    ,   0.1619940    ,   0.1249120    
     +,   9.5397733E-02,   7.2269209E-02,   5.4399032E-02
     +,   4.0769342E-02,   3.0497700E-02,   2.2841927E-02
     +,   1.7193489E-02,   1.3064769E-02,   1.0072091E-02
     +,   7.9179425E-03,   6.3747247E-03,   5.2706688E-03
     +,   4.4778041E-03,   3.9020018E-03,   3.4750551E-03
     +,   3.1484903E-03,   2.8886304E-03,   2.6726709E-03
     +,   2.4857072E-03,   2.3184146E-03,   2.1652747E-03
     +,   2.0232396E-03,   1.8907936E-03,   1.7672854E-03
     +,   1.6524725E-03,   1.5462248E-03,   1.4483787E-03
     +,   1.3586616E-03,   1.2766507E-03,   1.2018075E-03
     +,   1.1334860E-03,   1.0709909E-03,   1.0135978E-03
     +,   9.6060231E-04,   9.1133523E-04,   8.6519384E-04
     +,   8.2164397E-04,   7.8023761E-04,   7.4060395E-04
     +,   7.0245081E-04,   6.6556112E-04,   6.2977604E-04
     +,   5.9499545E-04,   5.6115910E-04,   5.2824517E-04
     +,   4.9625424E-04,   4.6520913E-04,   4.3514033E-04
     +,   4.0608886E-04,   3.7809357E-04,   3.5119546E-04
     +,   3.2542806E-04,   3.0082231E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_hzonly_ttz115_mass = Yx/13.9074456818182
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_hzonly_ttz120_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.6643561E-02,   2.8103661E-02
     +,   2.9610921E-02,   3.1164529E-02,   3.2763507E-02
     +,   3.4406681E-02,   3.6092639E-02,   3.7819784E-02
     +,   3.9586261E-02,   4.1390017E-02,   4.3228708E-02
     +,   4.5099769E-02,   4.7000296E-02,   4.8927180E-02
     +,   5.0877050E-02,   5.2846216E-02,   5.4830719E-02
     +,   5.6826387E-02,   5.8828764E-02,   6.0833097E-02
     +,   6.2834531E-02,   6.4827986E-02,   6.6808127E-02
     +,   6.8769664E-02,   7.0707075E-02,   7.2614856E-02
     +,   7.4487559E-02,   7.6319650E-02,   7.8105800E-02
     +,   7.9840809E-02,   8.1519701E-02,   8.3137758E-02
     +,   8.4690563E-02,   8.6174108E-02,   8.7584734E-02
     +,   8.8919342E-02,   9.0175249E-02,   9.1350332E-02
     +,   9.2443101E-02,   9.3452558E-02,   9.4378516E-02
     +,   9.5221072E-02,   9.5981352E-02,   9.6660942E-02
     +,   9.7262003E-02,   9.7787507E-02,   9.8240793E-02
     +,   9.8626100E-02,   9.8948039E-02,   9.9211730E-02
     +,   9.9422857E-02,   9.9587686E-02,   9.9712744E-02
     +,   9.9805064E-02,   9.9871881E-02,   9.9920817E-02
     +,   9.9959768E-02,   9.9996574E-02,   0.1000393    
     +,   0.1000960    ,   0.1001745    ,   0.1002826    
     +,   0.1004276    ,   0.1006164    ,   0.1008555    
     +,   0.1011504    ,   0.1015059    ,   0.1019257    
     +,   0.1024124    ,   0.1029673    ,   0.1035903    
     +,   0.1042797    ,   0.1050324    ,   0.1058435    
     +,   0.1067065    ,   0.1076133    ,   0.1085544    
     +,   0.1095187    ,   0.1104939    ,   0.1114670    
     +,   0.1124238    ,   0.1133500    ,   0.1142310    
     +,   0.1150525    ,   0.1158006    ,   0.1164624    
     +,   0.1170264    ,   0.1174823    ,   0.1178217    
     +,   0.1180382    ,   0.1181274    ,   0.1180875    
     +,   0.1179182    ,   0.1176220    ,   0.1172032    
     +,   0.1166679    ,   0.1160241    ,   0.1152807    
     +,   0.1144481    ,   0.1135373    ,   0.1125594    
     +,   0.1115259    ,   0.1104478    ,   0.1093359    
     +,   0.1081997    ,   0.1070481    ,   0.1058888    
     +,   0.1047284    ,   0.1035720    ,   0.1024238    
     +,   0.1012869    ,   0.1001630    ,   9.9053539E-02
     +,   9.7958870E-02,   9.6879236E-02,   9.5814243E-02
     +,   9.4763912E-02,   9.3728192E-02,   9.2707343E-02
     +,   9.1702282E-02,   9.0714321E-02,   8.9745529E-02
     +,   8.8798948E-02,   8.7877855E-02,   8.6986534E-02
     +,   8.6129785E-02,   8.5312769E-02,   8.4541179E-02
     +,   8.3820753E-02,   8.3157219E-02,   8.2556255E-02
     +,   8.2022943E-02,   8.1561916E-02,   8.1177056E-02
     +,   8.0871299E-02,   8.0646500E-02,   8.0503367E-02
     +,   8.0441296E-02,   8.0458410E-02,   8.0551438E-02
     +,   8.0715880E-02,   8.0945909E-02,   8.1234582E-02
     +,   8.1573874E-02,   8.1955001E-02,   8.2368471E-02
     +,   8.2804501E-02,   8.3253048E-02,   8.3704188E-02
     +,   8.4148645E-02,   8.4577732E-02,   8.4983803E-02
     +,   8.5360549E-02,   8.5703254E-02,   8.6009160E-02
     +,   8.6277254E-02,   8.6508997E-02,   8.6707868E-02
     +,   8.6879812E-02,   8.7032922E-02,   8.7177366E-02
     +,   8.7325379E-02,   8.7490581E-02,   8.7688044E-02
     +,   8.7933578E-02,   8.8243499E-02,   8.8633925E-02
     +,   8.9120254E-02,   8.9716882E-02,   9.0436466E-02
     +,   9.1289707E-02,   9.2284888E-02,   9.3427904E-02
     +,   9.4722115E-02,   9.6168384E-02,   9.7765580E-02
     +,   9.9511251E-02,   0.1014018    ,   0.1034341    
     +,   0.1056056    ,   0.1079164    ,   0.1103692    
     +,   0.1129706    ,   0.1157322    ,   0.1186703    
     +,   0.1218059    ,   0.1251645    ,   0.1287753    
     +,   0.1326690    ,   0.1368766    ,   0.1414273    
     +,   0.1463468    ,   0.1516551    ,   0.1573660    
     +,   0.1634874    ,   0.1700226    ,   0.1769721    
     +,   0.1843387    ,   0.1921325    ,   0.2003768    
     +,   0.2091131    ,   0.2184063    ,   0.2283489    
     +,   0.2390607    ,   0.2506862    ,   0.2633912    
     +,   0.2773570    ,   0.2927699    ,   0.3098160    
     +,   0.3286783    ,   0.3495311    ,   0.3725381    
     +,   0.3978549    ,   0.4256237    ,   0.4559665    
     +,   0.4889641    ,   0.5246354    ,   0.5629052    
     +,   0.6035675    ,   0.6462536    ,   0.6904137    
     +,   0.7353110    ,   0.7800373    ,   0.8235474    
     +,   0.8647136    ,   0.9023831    ,   0.9354374    
     +,   0.9628493    ,   0.9837248    ,   0.9973339    
     +,    1.003128    ,    1.000754    ,   0.9900587    
     +,   0.9710917    ,   0.9441126    ,   0.9095860    
     +,   0.8681778    ,   0.8207498    ,   0.7683271    
     +,   0.7120667    ,   0.6532136    ,   0.5930527    
     +,   0.5328487    ,   0.4737879    ,   0.4169322    
     +,   0.3631807    ,   0.3132388    ,   0.2676020    
     +,   0.2265595    ,   0.1902124    ,   0.1584873    
     +,   0.1311740    ,   0.1079600    ,   8.8462807E-02
     +,   7.2261326E-02,   5.8925007E-02,   4.8036255E-02
     +,   3.9204933E-02,   3.2078113E-02,   2.6346114E-02
     +,   2.1743594E-02,   1.8047510E-02,   1.5073289E-02
     +,   1.2670774E-02,   1.0719401E-02,   9.1230758E-03
     +,   7.8060618E-03,   6.7092697E-03,   5.7868077E-03
     +,   5.0032595E-03,   4.3314858E-03,   3.7508104E-03
     +,   3.2454820E-03,   2.8034505E-03,   2.4154691E-03
     +,   2.0743860E-03,   1.7744952E-03,   1.5111991E-03
     +,   1.2806178E-03,   1.0794358E-03,   9.0468541E-04
     +,   7.5369776E-04,   6.2399165E-04,   5.1327620E-04
     +,   4.1939699E-04,   3.4035716E-04,   2.7429289E-04
     +,   2.1948614E-04,   1.7437039E-04,   1.3752008E-04
     +,   1.0766163E-04,   8.3661194E-05,   6.4527063E-05
     +,   4.9395956E-05,   3.7529331E-05,   2.8298839E-05
     +,   2.1178505E-05,   1.5730891E-05,   1.1597663E-05
     +,   8.4873072E-06,   6.1660762E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_hzonly_ttz120_mass = Yx/11.5406545116279
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_hzonly_ttz60_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.9112030E-02,   2.1837581E-02
     +,   2.4919471E-02,   2.8382212E-02,   3.2246135E-02
     +,   3.6527939E-02,   4.1243114E-02,   4.6410326E-02
     +,   5.2058987E-02,   5.8239654E-02,   6.5036267E-02
     +,   7.2580181E-02,   8.1063658E-02,   9.0749227E-02
     +,   0.1019738    ,   0.1151438    ,   0.1307225    
     +,   0.1492092    ,   0.1711148    ,   0.1969399    
     +,   0.2271542    ,   0.2621819    ,   0.3023846    
     +,   0.3480400    ,   0.3992972    ,   0.4561355    
     +,   0.5183071    ,   0.5853137    ,   0.6564253    
     +,   0.7307616    ,   0.8074305    ,   0.8856686    
     +,   0.9649427    ,    1.044942    ,    1.125433    
     +,    1.206058    ,    1.286161    ,    1.364758    
     +,    1.440654    ,    1.512563    ,    1.579178    
     +,    1.639016    ,    1.690298    ,    1.730906    
     +,    1.758593    ,    1.771327    ,    1.767598    
     +,    1.746621    ,    1.708384    ,    1.653631    
     +,    1.583863    ,    1.501304    ,    1.408863    
     +,    1.310056    ,    1.208870    ,    1.109450    
     +,    1.015645    ,   0.9304495    ,   0.8554980    
     +,   0.7908627    ,   0.7352604    ,   0.6865743    
     +,   0.6425308    ,   0.6012592    ,   0.5616167    
     +,   0.5232141    ,   0.4862186    ,   0.4510776    
     +,   0.4182442    ,   0.3880181    ,   0.3604723    
     +,   0.3354883    ,   0.3128224    ,   0.2921911    
     +,   0.2733284    ,   0.2560235    ,   0.2401254    
     +,   0.2255331    ,   0.2121733    ,   0.1999854    
     +,   0.1889080    ,   0.1788704    ,   0.1697938    
     +,   0.1615917    ,   0.1541752    ,   0.1474554    
     +,   0.1413493    ,   0.1357795    ,   0.1306787    
     +,   0.1259880    ,   0.1216577    ,   0.1176464    
     +,   0.1139196    ,   0.1104478    ,   0.1072052    
     +,   0.1041689    ,   0.1013168    ,   9.8627590E-02
     +,   9.6079923E-02,   9.3652949E-02,   9.1326065E-02
     +,   8.9080058E-02,   8.6897142E-02,   8.4762126E-02
     +,   8.2662448E-02,   8.0588944E-02,   7.8536220E-02
     +,   7.6502405E-02,   7.4489206E-02,   7.2501458E-02
     +,   7.0547290E-02,   6.8636745E-02,   6.6782147E-02
     +,   6.4996712E-02,   6.3294694E-02,   6.1690293E-02
     +,   6.0197510E-02,   5.8829568E-02,   5.7598688E-02
     +,   5.6515727E-02,   5.5589993E-02,   5.4829292E-02
     +,   5.4239616E-02,   5.3825408E-02,   5.3589411E-02
     +,   5.3532857E-02,   5.3655464E-02,   5.3955760E-02
     +,   5.4430801E-02,   5.5076752E-02,   5.5888515E-02
     +,   5.6859978E-02,   5.7984177E-02,   5.9252977E-02
     +,   6.0657427E-02,   6.2187437E-02,   6.3831903E-02
     +,   6.5578423E-02,   6.7413777E-02,   6.9323368E-02
     +,   7.1291424E-02,   7.3301010E-02,   7.5334370E-02
     +,   7.7372566E-02,   7.9396017E-02,   8.1384592E-02
     +,   8.3317988E-02,   8.5175678E-02,   8.6937644E-02
     +,   8.8584617E-02,   9.0098411E-02,   9.1462381E-02
     +,   9.2661560E-02,   9.3683235E-02,   9.4517350E-02
     +,   9.5156208E-02,   9.5595270E-02,   9.5832989E-02
     +,   9.5870703E-02,   9.5712967E-02,   9.5366947E-02
     +,   9.4842762E-02,   9.4152756E-02,   9.3311585E-02
     +,   9.2335425E-02,   9.1241948E-02,   9.0049773E-02
     +,   8.8778093E-02,   8.7446161E-02,   8.6072840E-02
     +,   8.4676608E-02,   8.3274774E-02,   8.1883565E-02
     +,   8.0517486E-02,   7.9189628E-02,   7.7911250E-02
     +,   7.6691628E-02,   7.5538322E-02,   7.4456982E-02
     +,   7.3451355E-02,   7.2523639E-02,   7.1674235E-02
     +,   7.0902310E-02,   7.0205487E-02,   6.9580302E-02
     +,   6.9022320E-02,   6.8526261E-02,   6.8086065E-02
     +,   6.7695171E-02,   6.7346670E-02,   6.7033246E-02
     +,   6.6747516E-02,   6.6482082E-02,   6.6229440E-02
     +,   6.5982431E-02,   6.5733910E-02,   6.5477178E-02
     +,   6.5205790E-02,   6.4913779E-02,   6.4595483E-02
     +,   6.4245850E-02,   6.3860334E-02,   6.3434839E-02
     +,   6.2965877E-02,   6.2450558E-02,   6.1886434E-02
     +,   6.1271679E-02,   6.0605094E-02,   5.9885889E-02
     +,   5.9113909E-02,   5.8289357E-02,   5.7413064E-02
     +,   5.6486171E-02,   5.5510309E-02,   5.4487444E-02
     +,   5.3419869E-02,   5.2310284E-02,   5.1161543E-02
     +,   4.9976744E-02,   4.8759252E-02,   4.7512561E-02
     +,   4.6240240E-02,   4.4946074E-02,   4.3633882E-02
     +,   4.2307481E-02,   4.0970650E-02,   3.9627265E-02
     +,   3.8281180E-02,   3.6936060E-02,   3.5595499E-02
     +,   3.4263074E-02,   3.2942194E-02,   3.1636074E-02
     +,   3.0347759E-02,   2.9080199E-02,   2.7836042E-02
     +,   2.6617741E-02,   2.5427584E-02,   2.4267642E-02
     +,   2.3139657E-02,   2.2045145E-02,   2.0985471E-02
     +,   1.9961717E-02,   1.8974695E-02,   1.8024959E-02
     +,   1.7112933E-02,   1.6238805E-02,   1.5402486E-02
     +,   1.4603734E-02,   1.3842182E-02,   1.3117229E-02
     +,   1.2428131E-02,   1.1774054E-02,   1.1154059E-02
     +,   1.0567055E-02,   1.0011878E-02,   9.4873412E-03
     +,   8.9921886E-03,   8.5251126E-03,   8.0847796E-03
     +,   7.6698740E-03,   7.2790785E-03,   6.9110636E-03
     +,   6.5645268E-03,   6.2382245E-03,   5.9309173E-03
     +,   5.6414092E-03,   5.3685703E-03,   5.1113209E-03
     +,   4.8686122E-03,   4.6394556E-03,   4.4229361E-03
     +,   4.2181876E-03,   4.0243869E-03,   3.8407708E-03
     +,   3.6666463E-03,   3.5013454E-03,   3.3442781E-03
     +,   3.1948746E-03,   3.0526363E-03,   2.9170827E-03
     +,   2.7877963E-03,   2.6643749E-03,   2.5464720E-03
     +,   2.4337540E-03,   2.3259313E-03,   2.2227317E-03
     +,   2.1239077E-03,   2.0292413E-03,   1.9385233E-03
     +,   1.8515745E-03,   1.7682179E-03,   1.6883037E-03
     +,   1.6116807E-03,   1.5382228E-03,   1.4678002E-03
     +,   1.4003019E-03,   1.3356147E-03,   1.2736403E-03
     +,   1.2142772E-03,   1.1574373E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_hzonly_ttz60_mass = Yx/15.647464
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_hzonly_ttz65_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  6.2013087E-03,   6.5250834E-03
     +,   6.8713655E-03,   7.2427243E-03,   7.6421145E-03
     +,   8.0729378E-03,   8.5391337E-03,   9.0452917E-03
     +,   9.5967939E-03,   1.0200004E-02,   1.0862465E-02
     +,   1.1593169E-02,   1.2402879E-02,   1.3304463E-02
     +,   1.4313284E-02,   1.5447607E-02,   1.6728984E-02
     +,   1.8182686E-02,   1.9838050E-02,   2.1728877E-02
     +,   2.3893818E-02,   2.6376817E-02,   2.9227694E-02
     +,   3.2503139E-02,   3.6267191E-02,   4.0593065E-02
     +,   4.5563653E-02,   5.1272437E-02,   5.7823177E-02
     +,   6.5328166E-02,   7.3904991E-02,   8.3671398E-02
     +,   9.4740115E-02,   0.1072139    ,   0.1211849    
     +,   0.1367385    ,   0.1539641    ,   0.1729709    
     +,   0.1939066    ,   0.2169651    ,   0.2423892    
     +,   0.2704495    ,   0.3014106    ,   0.3354895    
     +,   0.3728215    ,   0.4134474    ,   0.4573314    
     +,   0.5044150    ,   0.5546970    ,   0.6083497    
     +,   0.6658527    ,   0.7281323    ,   0.7966412    
     +,   0.8732690    ,   0.9599444    ,    1.057960    
     +,    1.167107    ,    1.285131    ,    1.407970    
     +,    1.530983    ,    1.650560    ,    1.764848    
     +,    1.872595    ,    1.970661    ,    2.052209    
     +,    2.107746    ,    2.129047    ,    2.113386    
     +,    2.065139    ,    1.993758    ,    1.909752    
     +,    1.821158    ,    1.732104    ,    1.643299    
     +,    1.553461    ,    1.460862    ,    1.364501    
     +,    1.264831    ,    1.163886    ,    1.064847    
     +,   0.9711000    ,   0.8852451    ,   0.8084863    
     +,   0.7405936    ,   0.6803986    ,   0.6264424    
     +,   0.5775198    ,   0.5328640    ,   0.4920860    
     +,   0.4549612    ,   0.4212538    ,   0.3906572    
     +,   0.3628131    ,   0.3373806    ,   0.3140939    
     +,   0.2927803    ,   0.2733416    ,   0.2557269    
     +,   0.2398994    ,   0.2258197    ,   0.2134307    
     +,   0.2026583    ,   0.1934076    ,   0.1855666    
     +,   0.1790041    ,   0.1735750    ,   0.1691228    
     +,   0.1654857    ,   0.1625024    ,   0.1600199    
     +,   0.1578997    ,   0.1560212    ,   0.1542856    
     +,   0.1526164    ,   0.1509580    ,   0.1492740    
     +,   0.1475446    ,   0.1457627    ,   0.1439308    
     +,   0.1420582    ,   0.1401583    ,   0.1382459    
     +,   0.1363361    ,   0.1344424    ,   0.1325763    
     +,   0.1307468    ,   0.1289600    ,   0.1272200    
     +,   0.1255283    ,   0.1238850    ,   0.1222888    
     +,   0.1207382    ,   0.1192311    ,   0.1177659    
     +,   0.1163416    ,   0.1149577    ,   0.1136145    
     +,   0.1123130    ,   0.1110549    ,   0.1098419    
     +,   0.1086761    ,   0.1075596    ,   0.1064937    
     +,   0.1054794    ,   0.1045166    ,   0.1036042    
     +,   0.1027399    ,   0.1019205    ,   0.1011409    
     +,   0.1003955    ,   9.9676855E-02,   9.8977238E-02
     +,   9.8287828E-02,   9.7599372E-02,   9.6902370E-02
     +,   9.6187420E-02,   9.5445402E-02,   9.4667956E-02
     +,   9.3847543E-02,   9.2977986E-02,   9.2054263E-02
     +,   9.1072932E-02,   9.0032317E-02,   8.8932350E-02
     +,   8.7774500E-02,   8.6561844E-02,   8.5298717E-02
     +,   8.3990924E-02,   8.2644798E-02,   8.1267722E-02
     +,   7.9867214E-02,   7.8451149E-02,   7.7027090E-02
     +,   7.5602315E-02,   7.4183732E-02,   7.2777338E-02
     +,   7.1388446E-02,   7.0021667E-02,   6.8680599E-02
     +,   6.7368187E-02,   6.6086441E-02,   6.4836971E-02
     +,   6.3620746E-02,   6.2438339E-02,   6.1289996E-02
     +,   6.0175844E-02,   5.9095945E-02,   5.8050293E-02
     +,   5.7038970E-02,   5.6062222E-02,   5.5120274E-02
     +,   5.4213490E-02,   5.3342279E-02,   5.2507173E-02
     +,   5.1708452E-02,   5.0946359E-02,   5.0220974E-02
     +,   4.9532093E-02,   4.8879098E-02,   4.8261009E-02
     +,   4.7676496E-02,   4.7123648E-02,   4.6600159E-02
     +,   4.6103138E-02,   4.5629397E-02,   4.5175202E-02
     +,   4.4736475E-02,   4.4308856E-02,   4.3887787E-02
     +,   4.3468509E-02,   4.3046232E-02,   4.2616185E-02
     +,   4.2173758E-02,   4.1714538E-02,   4.1234337E-02
     +,   4.0729456E-02,   4.0196531E-02,   3.9632741E-02
     +,   3.9035775E-02,   3.8403917E-02,   3.7736010E-02
     +,   3.7031464E-02,   3.6290359E-02,   3.5513282E-02
     +,   3.4701396E-02,   3.3856302E-02,   3.2980170E-02
     +,   3.2075569E-02,   3.1145390E-02,   3.0192764E-02
     +,   2.9221198E-02,   2.8234340E-02,   2.7235912E-02
     +,   2.6229687E-02,   2.5219545E-02,   2.4209218E-02
     +,   2.3202332E-02,   2.2202471E-02,   2.1213023E-02
     +,   2.0237107E-02,   1.9277593E-02,   1.8337207E-02
     +,   1.7418360E-02,   1.6523149E-02,   1.5653387E-02
     +,   1.4810667E-02,   1.3996301E-02,   1.3211289E-02
     +,   1.2456359E-02,   1.1732080E-02,   1.1038720E-02
     +,   1.0376347E-02,   9.7448686E-03,   9.1440193E-03
     +,   8.5733458E-03,   8.0322539E-03,   7.5200778E-03
     +,   7.0360429E-03,   6.5792669E-03,   6.1488021E-03
     +,   5.7436773E-03,   5.3628930E-03,   5.0053820E-03
     +,   4.6700859E-03,   4.3559615E-03,   4.0619476E-03
     +,   3.7869958E-03,   3.5300960E-03,   3.2902616E-03
     +,   3.0665181E-03,   2.8579265E-03,   2.6635982E-03
     +,   2.4826787E-03,   2.3143389E-03,   2.1577931E-03
     +,   2.0123059E-03,   1.8771637E-03,   1.7517089E-03
     +,   1.6353035E-03,   1.5273612E-03,   1.4273169E-03
     +,   1.3346513E-03,   1.2488643E-03,   1.1694989E-03
     +,   1.0961150E-03,   1.0283102E-03,   9.6569932E-04
     +,   9.0792344E-04,   8.5465057E-04,   8.0556347E-04
     +,   7.6037121E-04,   7.1879517E-04,   6.8058050E-04
     +,   6.4548262E-04,   6.1327789E-04,   5.8375247E-04
     +,   5.5670977E-04,   5.3196249E-04,   5.0933886E-04
     +,   4.8867462E-04,   4.6981926E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_hzonly_ttz65_mass = Yx/17.1625359111111
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_hzonly_ttz70_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.7888807E-03,   4.9710087E-03
     +,   5.1588528E-03,   5.3527211E-03,   5.5529568E-03
     +,   5.7599419E-03,   5.9741028E-03,   6.1959024E-03
     +,   6.4258468E-03,   6.6644950E-03,   6.9124424E-03
     +,   7.1703237E-03,   7.4388231E-03,   7.7186627E-03
     +,   8.0105988E-03,   8.3154263E-03,   8.6339694E-03
     +,   8.9670764E-03,   9.3156183E-03,   9.6804705E-03
     +,   1.0062529E-02,   1.0462681E-02,   1.0881800E-02
     +,   1.1320789E-02,   1.1780486E-02,   1.2261787E-02
     +,   1.2765572E-02,   1.3292793E-02,   1.3844504E-02
     +,   1.4421953E-02,   1.5026701E-02,   1.5660778E-02
     +,   1.6326934E-02,   1.7028879E-02,   1.7771667E-02
     +,   1.8562084E-02,   1.9409109E-02,   2.0324429E-02
     +,   2.1322969E-02,   2.2423262E-02,   2.3648040E-02
     +,   2.5024462E-02,   2.6584474E-02,   2.8365107E-02
     +,   3.0408904E-02,   3.2764751E-02,   3.5489138E-02
     +,   3.8648464E-02,   4.2322144E-02,   4.6606805E-02
     +,   5.1620845E-02,   5.7508644E-02,   6.4443037E-02
     +,   7.2625250E-02,   8.2279325E-02,   9.3645915E-02
     +,   0.1069717    ,   0.1225029    ,   0.1404837    
     +,   0.1611637    ,   0.1848082    ,   0.2117062    
     +,   0.2421539    ,   0.2764180    ,   0.3146610    
     +,   0.3568684    ,   0.4028382    ,   0.4522599    
     +,   0.5049447    ,   0.5610944    ,   0.6215070    
     +,   0.6874727    ,   0.7603323    ,   0.8407673    
     +,   0.9282562    ,    1.021025    ,    1.116662    
     +,    1.213098    ,    1.309507    ,    1.406717    
     +,    1.506941    ,    1.612661    ,    1.724555    
     +,    1.839432    ,    1.949704    ,    2.045592    
     +,    2.118835    ,    2.165414    ,    2.185542    
     +,    2.181954    ,    2.158248    ,    2.117730    
     +,    2.062159    ,    1.990635    ,    1.900121    
     +,    1.788220    ,    1.656711    ,    1.513357    
     +,    1.370362    ,    1.240098    ,    1.130348    
     +,    1.041857    ,   0.9693270    ,   0.9049828    
     +,   0.8423217    ,   0.7782390    ,   0.7130406    
     +,   0.6490735    ,   0.5890900    ,   0.5350891    
     +,   0.4878615    ,   0.4470912    ,   0.4117792    
     +,   0.3807094    ,   0.3528200    ,   0.3273787    
     +,   0.3040059    ,   0.2825804    ,   0.2631249    
     +,   0.2456960    ,   0.2303216    ,   0.2169730    
     +,   0.2055601    ,   0.1959424    ,   0.1879451    
     +,   0.1813753    ,   0.1760335    ,   0.1717253    
     +,   0.1682675    ,   0.1654934    ,   0.1632533    
     +,   0.1614166    ,   0.1598692    ,   0.1585139    
     +,   0.1572671    ,   0.1560591    ,   0.1548325    
     +,   0.1535414    ,   0.1521510    ,   0.1506371    
     +,   0.1489850    ,   0.1471890    ,   0.1452501    
     +,   0.1431756    ,   0.1409771    ,   0.1386690    
     +,   0.1362674    ,   0.1337885    ,   0.1312490    
     +,   0.1286639    ,   0.1260476    ,   0.1234132    
     +,   0.1207730    ,   0.1181379    ,   0.1155180    
     +,   0.1129232    ,   0.1103621    ,   0.1078427    
     +,   0.1053721    ,   0.1029564    ,   0.1006004    
     +,   9.8307878E-02,   9.6081190E-02,   9.3921676E-02
     +,   9.1829397E-02,   8.9803584E-02,   8.7843090E-02
     +,   8.5946366E-02,   8.4111899E-02,   8.2338631E-02
     +,   8.0626100E-02,   7.8974850E-02,   7.7386208E-02
     +,   7.5862534E-02,   7.4407414E-02,   7.3025011E-02
     +,   7.1720295E-02,   7.0498794E-02,   6.9366127E-02
     +,   6.8327732E-02,   6.7388795E-02,   6.6553652E-02
     +,   6.5825857E-02,   6.5207705E-02,   6.4700067E-02
     +,   6.4302415E-02,   6.4012587E-02,   6.3826717E-02
     +,   6.3739404E-02,   6.3743599E-02,   6.3830718E-02
     +,   6.3990876E-02,   6.4212911E-02,   6.4484574E-02
     +,   6.4792804E-02,   6.5123893E-02,   6.5463684E-02
     +,   6.5797791E-02,   6.6111863E-02,   6.6391818E-02
     +,   6.6623881E-02,   6.6795036E-02,   6.6893056E-02
     +,   6.6906661E-02,   6.6825755E-02,   6.6641465E-02
     +,   6.6346429E-02,   6.5934673E-02,   6.5401822E-02
     +,   6.4745069E-02,   6.3963287E-02,   6.3056916E-02
     +,   6.2028106E-02,   6.0880430E-02,   5.9618913E-02
     +,   5.8250014E-02,   5.6781486E-02,   5.5221990E-02
     +,   5.3581197E-02,   5.1869657E-02,   5.0098300E-02
     +,   4.8278492E-02,   4.6421871E-02,   4.4540100E-02
     +,   4.2644534E-02,   4.0746227E-02,   3.8855843E-02
     +,   3.6983404E-02,   3.5138100E-02,   3.3328276E-02
     +,   3.1561513E-02,   2.9844405E-02,   2.8182482E-02
     +,   2.6580296E-02,   2.5041571E-02,   2.3568973E-02
     +,   2.2164263E-02,   2.0828491E-02,   1.9561939E-02
     +,   1.8364126E-02,   1.7233986E-02,   1.6170025E-02
     +,   1.5170301E-02,   1.4232481E-02,   1.3353952E-02
     +,   1.2531965E-02,   1.1763646E-02,   1.1045991E-02
     +,   1.0375980E-02,   9.7506847E-03,   9.1671729E-03
     +,   8.6226016E-03,   8.1142848E-03,   7.6396605E-03
     +,   7.1962755E-03,   6.7818286E-03,   6.3942010E-03
     +,   6.0314219E-03,   5.6916429E-03,   5.3731618E-03
     +,   5.0744358E-03,   4.7940477E-03,   4.5306780E-03
     +,   4.2831236E-03,   4.0503084E-03,   3.8312222E-03
     +,   3.6249401E-03,   3.4306308E-03,   3.2475283E-03
     +,   3.0749151E-03,   2.9121351E-03,   2.7585872E-03
     +,   2.6137168E-03,   2.4770012E-03,   2.3479527E-03
     +,   2.2261287E-03,   2.1111015E-03,   2.0024853E-03
     +,   1.8999025E-03,   1.8030131E-03,   1.7114858E-03
     +,   1.6250196E-03,   1.5433194E-03,   1.4661180E-03
     +,   1.3931551E-03,   1.3241918E-03,   1.2589983E-03
     +,   1.1973572E-03,   1.1390692E-03,   1.0839391E-03
     +,   1.0317907E-03,   9.8244951E-04,   9.3575910E-04
     +,   8.9156546E-04,   8.4972876E-04,   8.1011269E-04
     +,   7.7259389E-04,   7.3705078E-04,   7.0337445E-04
     +,   6.7145703E-04,   6.4120151E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_hzonly_ttz70_mass = Yx/17.5475132
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_hzonly_ttz75_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.7118841E-03,   4.7954787E-03
     +,   4.8769200E-03,   4.9561574E-03,   5.0331652E-03
     +,   5.1079467E-03,   5.1805293E-03,   5.2509746E-03
     +,   5.3193704E-03,   5.3858515E-03,   5.4505765E-03
     +,   5.5137519E-03,   5.5756210E-03,   5.6364709E-03
     +,   5.6966315E-03,   5.7564797E-03,   5.8164392E-03
     +,   5.8769742E-03,   5.9386012E-03,   6.0018799E-03
     +,   6.0674138E-03,   6.1358521E-03,   6.2078787E-03
     +,   6.2842285E-03,   6.3656508E-03,   6.4529451E-03
     +,   6.5469216E-03,   6.6484194E-03,   6.7582880E-03
     +,   6.8773837E-03,   7.0065637E-03,   7.1466821E-03
     +,   7.2985832E-03,   7.4630873E-03,   7.6409923E-03
     +,   7.8330757E-03,   8.0400798E-03,   8.2627172E-03
     +,   8.5016871E-03,   8.7576453E-03,   9.0312678E-03
     +,   9.3232244E-03,   9.6342126E-03,   9.9650109E-03
     +,   1.0316482E-02,   1.0689662E-02,   1.1085790E-02
     +,   1.1506402E-02,   1.1953407E-02,   1.2429194E-02
     +,   1.2936740E-02,   1.3479739E-02,   1.4062713E-02
     +,   1.4691207E-02,   1.5371780E-02,   1.6112309E-02
     +,   1.6921895E-02,   1.7811030E-02,   1.8791517E-02
     +,   1.9876469E-02,   2.1080146E-02,   2.2417821E-02
     +,   2.3905553E-02,   2.5560258E-02,   2.7399762E-02
     +,   2.9443083E-02,   3.1711873E-02,   3.4231752E-02
     +,   3.7035525E-02,   4.0166203E-02,   4.3682016E-02
     +,   4.7660112E-02,   5.2201215E-02,   5.7430629E-02
     +,   6.3498840E-02,   7.0578165E-02,   7.8858532E-02
     +,   8.8546075E-02,   9.9869870E-02,   0.1130992    
     +,   0.1285738    ,   0.1467528    ,   0.1682609    
     +,   0.1939442    ,   0.2249008    ,   0.2624917    
     +,   0.3082631    ,   0.3637559    ,   0.4301082    
     +,   0.5075244    ,   0.5947468    ,   0.6888610    
     +,   0.7857918    ,   0.8815601    ,   0.9738767    
     +,    1.063230    ,    1.152882    ,    1.247875    
     +,    1.353925    ,    1.476261    ,    1.618016    
     +,    1.778311    ,    1.951670    ,    2.128779    
     +,    2.297401    ,    2.443862    ,    2.557408    
     +,    2.634638    ,    2.677015    ,    2.683108    
     +,    2.647444    ,    2.568914    ,    2.457398    
     +,    2.330640    ,    2.206278    ,    2.094819    
     +,    1.995079    ,    1.895396    ,    1.782769    
     +,    1.653070    ,    1.513070    ,    1.374237    
     +,    1.245671    ,    1.131491    ,    1.031925    
     +,   0.9450313    ,   0.8678493    ,   0.7973863    
     +,   0.7315669    ,   0.6698021    ,   0.6127118    
     +,   0.5613388    ,   0.5163563    ,   0.4777336    
     +,   0.4448107    ,   0.4166012    ,   0.3920969    
     +,   0.3704657    ,   0.3511260    ,   0.3337258    
     +,   0.3180624    ,   0.3039838    ,   0.2913114    
     +,   0.2798058    ,   0.2691737    ,   0.2591058    
     +,   0.2493264    ,   0.2396363    ,   0.2299360    
     +,   0.2202269    ,   0.2105929    ,   0.2011714    
     +,   0.1921186    ,   0.1835782    ,   0.1756598    
     +,   0.1684286    ,   0.1619030    ,   0.1560608    
     +,   0.1508511    ,   0.1462073    ,   0.1420584    
     +,   0.1383398    ,   0.1349989    ,   0.1319992    
     +,   0.1293193    ,   0.1269516    ,   0.1248992    
     +,   0.1231705    ,   0.1217753    ,   0.1207202    
     +,   0.1200050    ,   0.1196200    ,   0.1195439    
     +,   0.1197435    ,   0.1201741    ,   0.1207804    
     +,   0.1214994    ,   0.1222627    ,   0.1229997    
     +,   0.1236414    ,   0.1241235    ,   0.1243887    
     +,   0.1243901    ,   0.1240921    ,   0.1234719    
     +,   0.1225195    ,   0.1212372    ,   0.1196382    
     +,   0.1177454    ,   0.1155891    ,   0.1132044    
     +,   0.1106295    ,   0.1079034    ,   0.1050642    
     +,   0.1021473    ,   9.9184602E-02,   9.6203968E-02
     +,   9.3229122E-02,   9.0279140E-02,   8.7369367E-02
     +,   8.4511995E-02,   8.1716418E-02,   7.8989975E-02
     +,   7.6338239E-02,   7.3766157E-02,   7.1277581E-02
     +,   6.8875745E-02,   6.6563599E-02,   6.4343452E-02
     +,   6.2216733E-02,   6.0183994E-02,   5.8244865E-02
     +,   5.6397773E-02,   5.4639727E-02,   5.2966483E-02
     +,   5.1372673E-02,   4.9851779E-02,   4.8396338E-02
     +,   4.6998136E-02,   4.5648810E-02,   4.4339750E-02
     +,   4.3062437E-02,   4.1809045E-02,   4.0572420E-02
     +,   3.9346159E-02,   3.8124993E-02,   3.6904853E-02
     +,   3.5682838E-02,   3.4457155E-02,   3.3227190E-02
     +,   3.1993419E-02,   3.0757278E-02,   2.9520923E-02
     +,   2.8287182E-02,   2.7059510E-02,   2.5841577E-02
     +,   2.4637271E-02,   2.3450624E-02,   2.2285596E-02
     +,   2.1145925E-02,   2.0035058E-02,   1.8956214E-02
     +,   1.7912202E-02,   1.6905328E-02,   1.5937470E-02
     +,   1.5010109E-02,   1.4124262E-02,   1.3280459E-02
     +,   1.2478840E-02,   1.1719225E-02,   1.1001037E-02
     +,   1.0323407E-02,   9.6852640E-03,   9.0853097E-03
     +,   8.5220588E-03,   7.9938946E-03,   7.4991500E-03
     +,   7.0361062E-03,   6.6029821E-03,   6.1980090E-03
     +,   5.8194711E-03,   5.4656905E-03,   5.1350282E-03
     +,   4.8259129E-03,   4.5368872E-03,   4.2665419E-03
     +,   4.0135584E-03,   3.7767203E-03,   3.5548960E-03
     +,   3.3470213E-03,   3.1521141E-03,   2.9692815E-03
     +,   2.7977000E-03,   2.6366005E-03,   2.4852783E-03
     +,   2.3430958E-03,   2.2094515E-03,   2.0838059E-03
     +,   1.9656459E-03,   1.8545118E-03,   1.7499648E-03
     +,   1.6516095E-03,   1.5590666E-03,   1.4719929E-03
     +,   1.3900575E-03,   1.3129612E-03,   1.2404153E-03
     +,   1.1721483E-03,   1.1079118E-03,   1.0474633E-03
     +,   9.9058170E-04,   9.3705032E-04,   8.8667253E-04
     +,   8.3925523E-04,   7.9462200E-04,   7.5260078E-04
     +,   7.1303424E-04,   6.7576877E-04,   6.4066408E-04
     +,   6.0758361E-04,   5.7640293E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_hzonly_ttz75_mass = Yx/19.8751949565217
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_hzonly_ttz80_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.5024616E-03,   3.6237070E-03
     +,   3.7484327E-03,   3.8766891E-03,   4.0085167E-03
     +,   4.1439477E-03,   4.2830054E-03,   4.4256998E-03
     +,   4.5720297E-03,   4.7219889E-03,   4.8755514E-03
     +,   5.0326833E-03,   5.1933355E-03,   5.3574541E-03
     +,   5.5249692E-03,   5.6958068E-03,   5.8698840E-03
     +,   6.0471180E-03,   6.2274258E-03,   6.4107249E-03
     +,   6.5969452E-03,   6.7860298E-03,   6.9779386E-03
     +,   7.1726739E-03,   7.3702508E-03,   7.5707501E-03
     +,   7.7742976E-03,   7.9810824E-03,   8.1913751E-03
     +,   8.4055290E-03,   8.6239940E-03,   8.8473335E-03
     +,   9.0762284E-03,   9.3114953E-03,   9.5540881E-03
     +,   9.8051056E-03,   1.0065807E-02,   1.0337593E-02
     +,   1.0622040E-02,   1.0920847E-02,   1.1235878E-02
     +,   1.1569100E-02,   1.1922597E-02,   1.2298518E-02
     +,   1.2699062E-02,   1.3126420E-02,   1.3582750E-02
     +,   1.4070104E-02,   1.4590375E-02,   1.5145248E-02
     +,   1.5736116E-02,   1.6364031E-02,   1.7029619E-02
     +,   1.7733078E-02,   1.8474001E-02,   1.9251492E-02
     +,   2.0064002E-02,   2.0909386E-02,   2.1784877E-02
     +,   2.2687126E-02,   2.3612238E-02,   2.4555903E-02
     +,   2.5513377E-02,   2.6479820E-02,   2.7450308E-02
     +,   2.8420040E-02,   2.9384686E-02,   3.0340454E-02
     +,   3.1284578E-02,   3.2215316E-02,   3.3132471E-02
     +,   3.4037422E-02,   3.4933574E-02,   3.5826284E-02
     +,   3.6723230E-02,   3.7634414E-02,   3.8572118E-02
     +,   3.9551053E-02,   4.0588353E-02,   4.1703567E-02
     +,   4.2918645E-02,   4.4258345E-02,   4.5750190E-02
     +,   4.7425278E-02,   4.9318504E-02,   5.1469855E-02
     +,   5.3925022E-02,   5.6737281E-02,   5.9968963E-02
     +,   6.3694678E-02,   6.8004675E-02,   7.3009603E-02
     +,   7.8846835E-02,   8.5688241E-02,   9.3747586E-02
     +,   0.1032853    ,   0.1146120    ,   0.1280780    
     +,   0.1440578    ,   0.1629120    ,   0.1849454    
     +,   0.2103529    ,   0.2391843    ,   0.2713284    
     +,   0.3065515    ,   0.3445789    ,   0.3852107    
     +,   0.4284338    ,   0.4744529    ,   0.5235679    
     +,   0.5759379    ,   0.6314758    ,   0.6901881    
     +,   0.7531973    ,   0.8239168    ,   0.9082741    
     +,    1.012833    ,    1.141398    ,    1.292541    
     +,    1.460507    ,    1.638045    ,    1.816436    
     +,    1.981912    ,    2.116076    ,    2.207046    
     +,    2.261813    ,    2.301528    ,    2.341307    
     +,    2.379899    ,    2.411418    ,    2.438410    
     +,    2.465963    ,    2.487419    ,    2.482877    
     +,    2.433104    ,    2.334826    ,    2.203706    
     +,    2.061862    ,    1.921780    ,    1.782977    
     +,    1.642292    ,    1.503211    ,    1.374719    
     +,    1.264556    ,    1.175128    ,    1.103977    
     +,    1.046081    ,   0.9957030    ,   0.9476052    
     +,   0.8980502    ,   0.8455697    ,   0.7910298    
     +,   0.7368294    ,   0.6855950    ,   0.6390975    
     +,   0.5978644    ,   0.5614461    ,   0.5289614    
     +,   0.4995331    ,   0.4724531    ,   0.4471560    
     +,   0.4231551    ,   0.4000366    ,   0.3775086    
     +,   0.3554586    ,   0.3339725    ,   0.3132957    
     +,   0.2937485    ,   0.2756336    ,   0.2591646    
     +,   0.2444312    ,   0.2313968    ,   0.2199254    
     +,   0.2098205    ,   0.2008657    ,   0.1928541    
     +,   0.1856092    ,   0.1789967    ,   0.1729242    
     +,   0.1673368    ,   0.1622090    ,   0.1575349    
     +,   0.1533174    ,   0.1495589    ,   0.1462545    
     +,   0.1433866    ,   0.1409233    ,   0.1388170    
     +,   0.1370075    ,   0.1354247    ,   0.1339924    
     +,   0.1326331    ,   0.1312722    ,   0.1298412    
     +,   0.1282809    ,   0.1265432    ,   0.1245924    
     +,   0.1224054    ,   0.1199708    ,   0.1172881    
     +,   0.1143664    ,   0.1112223    ,   0.1078782    
     +,   0.1043605    ,   0.1006989    ,   9.6923873E-02
     +,   9.3066551E-02,   8.9157782E-02,   8.5227534E-02
     +,   8.1304133E-02,   7.7414170E-02,   7.3582545E-02
     +,   6.9831870E-02,   6.6182032E-02,   6.2650271E-02
     +,   5.9251186E-02,   5.5996366E-02,   5.2894071E-02
     +,   4.9949434E-02,   4.7164965E-02,   4.4539899E-02
     +,   4.2070985E-02,   3.9752860E-02,   3.7578184E-02
     +,   3.5538130E-02,   3.3622779E-02,   3.1821806E-02
     +,   3.0124700E-02,   2.8521027E-02,   2.7000900E-02
     +,   2.5555270E-02,   2.4176050E-02,   2.2856103E-02
     +,   2.1589475E-02,   2.0371391E-02,   1.9198101E-02
     +,   1.8066814E-02,   1.6975697E-02,   1.5923683E-02
     +,   1.4910235E-02,   1.3935309E-02,   1.2999231E-02
     +,   1.2102550E-02,   1.1245841E-02,   1.0429672E-02
     +,   9.6545788E-03,   8.9209350E-03,   8.2288729E-03
     +,   7.5782901E-03,   6.9689038E-03,   6.4001158E-03
     +,   5.8710896E-03,   5.3807935E-03,   4.9279840E-03
     +,   4.5112087E-03,   4.1288664E-03,   3.7792614E-03
     +,   3.4606075E-03,   3.1710353E-03,   2.9086496E-03
     +,   2.6715675E-03,   2.4579219E-03,   2.2658710E-03
     +,   2.0936283E-03,   1.9394949E-03,   1.8018354E-03
     +,   1.6791039E-03,   1.5698561E-03,   1.4727431E-03
     +,   1.3865078E-03,   1.3099896E-03,   1.2421301E-03
     +,   1.1819614E-03,   1.1285987E-03,   1.0812422E-03
     +,   1.0391746E-03,   1.0017460E-03,   9.6837920E-04
     +,   9.3855400E-04,   9.1181236E-04,   8.8774343E-04
     +,   8.6598709E-04,   8.4622245E-04,   8.2816993E-04
     +,   8.1158098E-04,   7.9624075E-04,   7.8195910E-04
     +,   7.6857110E-04,   7.5593422E-04,   7.4392353E-04
     +,   7.3243212E-04,   7.2136713E-04,   7.1064965E-04
     +,   7.0021133E-04,   6.8999507E-04,   6.7995134E-04
     +,   6.7003997E-04,   6.6022587E-04,   6.5048150E-04
     +,   6.4078323E-04,   6.3111301E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_hzonly_ttz80_mass = Yx/20.6527086956522
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_hzonly_ttz85_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.8570378E-03,   2.9235408E-03
     +,   2.9901760E-03,   3.0569031E-03,   3.1236846E-03
     +,   3.1904827E-03,   3.2572642E-03,   3.3239953E-03
     +,   3.3906456E-03,   3.4571921E-03,   3.5236094E-03
     +,   3.5898802E-03,   3.6559894E-03,   3.7219287E-03
     +,   3.7876926E-03,   3.8532852E-03,   3.9187162E-03
     +,   3.9840015E-03,   4.0491656E-03,   4.1142404E-03
     +,   4.1792700E-03,   4.2443052E-03,   4.3094079E-03
     +,   4.3746540E-03,   4.4401269E-03,   4.5059258E-03
     +,   4.5721605E-03,   4.6389564E-03,   4.7064517E-03
     +,   4.7748005E-03,   4.8441715E-03,   4.9147485E-03
     +,   4.9867337E-03,   5.0603440E-03,   5.1358133E-03
     +,   5.2133952E-03,   5.2933567E-03,   5.3759865E-03
     +,   5.4615946E-03,   5.5504986E-03,   5.6430502E-03
     +,   5.7396097E-03,   5.8405632E-03,   5.9463168E-03
     +,   6.0572987E-03,   6.1739609E-03,   6.2967800E-03
     +,   6.4262636E-03,   6.5629426E-03,   6.7073838E-03
     +,   6.8601919E-03,   7.0220088E-03,   7.1935137E-03
     +,   7.3754559E-03,   7.5686104E-03,   7.7738399E-03
     +,   7.9920609E-03,   8.2242629E-03,   8.4715243E-03
     +,   8.7350048E-03,   9.0159616E-03,   9.3157580E-03
     +,   9.6358368E-03,   9.9777738E-03,   1.0343260E-02
     +,   1.0734051E-02,   1.1152066E-02,   1.1599259E-02
     +,   1.2077743E-02,   1.2589654E-02,   1.3137267E-02
     +,   1.3722849E-02,   1.4348814E-02,   1.5017545E-02
     +,   1.5731543E-02,   1.6493386E-02,   1.7305674E-02
     +,   1.8171115E-02,   1.9092582E-02,   2.0073134E-02
     +,   2.1115929E-02,   2.2224490E-02,   2.3402441E-02
     +,   2.4653828E-02,   2.5982734E-02,   2.7393596E-02
     +,   2.8890660E-02,   3.0478202E-02,   3.2159872E-02
     +,   3.3938698E-02,   3.5816591E-02,   3.7793715E-02
     +,   3.9868150E-02,   4.2035658E-02,   4.4289116E-02
     +,   4.6618059E-02,   4.9009185E-02,   5.1445972E-02
     +,   5.3909834E-02,   5.6380413E-02,   5.8837671E-02
     +,   6.1262920E-02,   6.3641787E-02,   6.5966152E-02
     +,   6.8237551E-02,   7.0470005E-02,   7.2692804E-02
     +,   7.4953549E-02,   7.7320367E-02,   7.9882979E-02
     +,   8.2752228E-02,   8.6058401E-02,   8.9946076E-02
     +,   9.4567977E-02,   0.1000757    ,   0.1066131    
     +,   0.1143102    ,   0.1232888    ,   0.1336773    
     +,   0.1456432    ,   0.1594397    ,   0.1754553    
     +,   0.1942568    ,   0.2165970    ,   0.2433629    
     +,   0.2754467    ,   0.3135653    ,   0.3580497    
     +,   0.4087140    ,   0.4648392    ,   0.5253486    
     +,   0.5891262    ,   0.6555194    ,   0.7250099    
     +,   0.8000707    ,   0.8856939    ,   0.9884210    
     +,    1.112747    ,    1.255988    ,    1.406311    
     +,    1.548776    ,    1.677298    ,    1.801460    
     +,    1.938177    ,    2.093163    ,    2.252736    
     +,    2.399673    ,    2.534270    ,    2.667346    
     +,    2.791850    ,    2.876152    ,    2.892624    
     +,    2.847667    ,    2.776749    ,    2.705736    
     +,    2.622286    ,    2.495315    ,    2.316373    
     +,    2.109070    ,    1.903951    ,    1.717877    
     +,    1.555611    ,    1.418740    ,    1.307144    
     +,    1.215414    ,    1.133087    ,    1.050265    
     +,   0.9628646    ,   0.8731061    ,   0.7863830    
     +,   0.7078814    ,   0.6407974    ,   0.5860361    
     +,   0.5427040    ,   0.5088846    ,   0.4823938    
     +,   0.4613093    ,   0.4441769    ,   0.4299683    
     +,   0.4179460    ,   0.4075321    ,   0.3982255    
     +,   0.3895580    ,   0.3810878    ,   0.3724234    
     +,   0.3632683    ,   0.3534710    ,   0.3430582    
     +,   0.3322306    ,   0.3213196    ,   0.3107103    
     +,   0.3007593    ,   0.2917280    ,   0.2837425    
     +,   0.2767896    ,   0.2707387    ,   0.2653795    
     +,   0.2604637    ,   0.2557375    ,   0.2509687    
     +,   0.2459601    ,   0.2405575    ,   0.2346513    
     +,   0.2281771    ,   0.2211166    ,   0.2134940    
     +,   0.2053718    ,   0.1968450    ,   0.1880318    
     +,   0.1790608    ,   0.1700602    ,   0.1611485    
     +,   0.1524254    ,   0.1439663    ,   0.1358216    
     +,   0.1280185    ,   0.1205637    ,   0.1134480    
     +,   0.1066522    ,   0.1001526    ,   9.3924135E-02
     +,   8.7943822E-02,   8.2193583E-02,   7.6660641E-02
     +,   7.1337231E-02,   6.6220544E-02,   6.1311919E-02
     +,   5.6615304E-02,   5.2135650E-02,   4.7878247E-02
     +,   4.3847904E-02,   4.0048033E-02,   3.6479972E-02
     +,   3.3143084E-02,   3.0035017E-02,   2.7151231E-02
     +,   2.4485556E-02,   2.2030668E-02,   1.9778138E-02
     +,   1.7718557E-02,   1.5841968E-02,   1.4138176E-02
     +,   1.2596718E-02,   1.1206945E-02,   9.9582179E-03
     +,   8.8400738E-03,   7.8421989E-03,   6.9544469E-03
     +,   6.1669801E-03,   5.4704095E-03,   4.8556873E-03
     +,   4.3142629E-03,   3.8381475E-03,   3.4199071E-03
     +,   3.0526686E-03,   2.7301686E-03,   2.4467623E-03
     +,   2.1973921E-03,   1.9775499E-03,   1.7832696E-03
     +,   1.6110990E-03,   1.4580425E-03,   1.3215099E-03
     +,   1.1992832E-03,   1.0894858E-03,   9.9051208E-04
     +,   9.0100459E-04,   8.1982248E-04,   7.4600079E-04
     +,   6.7871943E-04,   6.1728264E-04,   5.6110276E-04
     +,   5.0967577E-04,   4.6256400E-04,   4.1938742E-04
     +,   3.7981718E-04,   3.4355739E-04,   3.1034841E-04
     +,   2.7995280E-04,   2.5215858E-04,   2.2676858E-04
     +,   2.0360465E-04,   1.8249884E-04,   1.6329803E-04
     +,   1.4585680E-04,   1.3004149E-04,   1.1572534E-04
     +,   1.0278961E-04,   9.1124217E-05,   8.0624333E-05
     +,   7.1193157E-05,   6.2738764E-05,   5.5176453E-05
     +,   4.8426053E-05,   4.2413885E-05,   3.7070615E-05
     +,   3.2332700E-05,   2.8140705E-05,   2.4440365E-05
     +,   2.1181255E-05,   1.8317538E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_hzonly_ttz85_mass = Yx/21.1050521276596
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_hzonly_ttz90_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  5.5103307E-03,   5.7391399E-03
     +,   5.9766034E-03,   6.2227766E-03,   6.4776512E-03
     +,   6.7411615E-03,   7.0131756E-03,   7.2934884E-03
     +,   7.5818142E-03,   7.8778146E-03,   8.1810467E-03
     +,   8.4910132E-03,   8.8071302E-03,   9.1287429E-03
     +,   9.4551370E-03,   9.7855255E-03,   1.0119073E-02
     +,   1.0454890E-02,   1.0792064E-02,   1.1129634E-02
     +,   1.1466630E-02,   1.1802080E-02,   1.2135011E-02
     +,   1.2464485E-02,   1.2789568E-02,   1.3109399E-02
     +,   1.3423149E-02,   1.3730071E-02,   1.4029486E-02
     +,   1.4320807E-02,   1.4603535E-02,   1.4877271E-02
     +,   1.5141721E-02,   1.5396697E-02,   1.5642110E-02
     +,   1.5877984E-02,   1.6104436E-02,   1.6321674E-02
     +,   1.6530016E-02,   1.6729822E-02,   1.6921548E-02
     +,   1.7105693E-02,   1.7282812E-02,   1.7453475E-02
     +,   1.7618280E-02,   1.7777821E-02,   1.7932704E-02
     +,   1.8083489E-02,   1.8230733E-02,   1.8374940E-02
     +,   1.8516578E-02,   1.8656064E-02,   1.8793764E-02
     +,   1.8929994E-02,   1.9065021E-02,   1.9199070E-02
     +,   1.9332327E-02,   1.9464957E-02,   1.9597098E-02
     +,   1.9728890E-02,   1.9860480E-02,   1.9992048E-02
     +,   2.0123776E-02,   2.0255942E-02,   2.0388862E-02
     +,   2.0522930E-02,   2.0658622E-02,   2.0796502E-02
     +,   2.0937230E-02,   2.1081544E-02,   2.1230295E-02
     +,   2.1384373E-02,   2.1544777E-02,   2.1712501E-02
     +,   2.1888610E-02,   2.2074150E-02,   2.2270141E-02
     +,   2.2477536E-02,   2.2697205E-02,   2.2929909E-02
     +,   2.3176204E-02,   2.3436518E-02,   2.3711016E-02
     +,   2.3999659E-02,   2.4302112E-02,   2.4617827E-02
     +,   2.4945932E-02,   2.5285380E-02,   2.5634810E-02
     +,   2.5992734E-02,   2.6357500E-02,   2.6727341E-02
     +,   2.7100509E-02,   2.7475363E-02,   2.7850416E-02
     +,   2.8224474E-02,   2.8596776E-02,   2.8967069E-02
     +,   2.9335788E-02,   2.9704137E-02,   3.0074237E-02
     +,   3.0449158E-02,   3.0833172E-02,   3.1231642E-02
     +,   3.1651199E-02,   3.2099754E-02,   3.2586459E-02
     +,   3.3121776E-02,   3.3717379E-02,   3.4386177E-02
     +,   3.5142213E-02,   3.6000758E-02,   3.6978137E-02
     +,   3.8092118E-02,   3.9361797E-02,   4.0808350E-02
     +,   4.2455114E-02,   4.4328935E-02,   4.6460714E-02
     +,   4.8887245E-02,   5.1652610E-02,   5.4809790E-02
     +,   5.8422510E-02,   6.2567078E-02,   6.7333013E-02
     +,   7.2822370E-02,   7.9148963E-02,   8.6432919E-02
     +,   9.4795525E-02,   0.1043477    ,   0.1151797    
     +,   0.1273447    ,   0.1408473    ,   0.1556298    
     +,   0.1715705    ,   0.1884895    ,   0.2061683    
     +,   0.2243898    ,   0.2429920    ,   0.2619311    
     +,   0.2813370    ,   0.3015476    ,   0.3230980    
     +,   0.3466422    ,   0.3728180    ,   0.4021021    
     +,   0.4347284    ,   0.4707802    ,   0.5105342    
     +,   0.5549895    ,   0.6062764    ,   0.6674643    
     +,   0.7413864    ,   0.8287659    ,   0.9268661    
     +,    1.030224    ,    1.133859    ,    1.237006    
     +,    1.344469    ,    1.464619    ,    1.605791    
     +,    1.772804    ,    1.963448    ,    2.165035    
     +,    2.354313    ,    2.504581    ,    2.597663    
     +,    2.631030    ,    2.613504    ,    2.556704    
     +,    2.473704    ,    2.381700    ,    2.296708    
     +,    2.223768    ,    2.157549    ,    2.093231    
     +,    2.033187    ,    1.982977    ,    1.944456    
     +,    1.914336    ,    1.888389    ,    1.865028    
     +,    1.843080    ,    1.816854    ,    1.776725    
     +,    1.716720    ,    1.640473    ,    1.558430    
     +,    1.479333    ,    1.404553    ,    1.329305    
     +,    1.247901    ,    1.158083    ,    1.062067    
     +,   0.9650068    ,   0.8727022    ,   0.7898005    
     +,   0.7188829    ,   0.6603684    ,   0.6130199    
     +,   0.5747499    ,   0.5433668    ,   0.5170251    
     +,   0.4943222    ,   0.4741647    ,   0.4555914    
     +,   0.4376979    ,   0.4196733    ,   0.4008985    
     +,   0.3810353    ,   0.3600528    ,   0.3381875    
     +,   0.3158491    ,   0.2935124    ,   0.2716279    
     +,   0.2505629    ,   0.2305750    ,   0.2118135    
     +,   0.1943391    ,   0.1781515    ,   0.1632079    
     +,   0.1494437    ,   0.1367858    ,   0.1251579    
     +,   0.1144836    ,   0.1046882    ,   9.5700420E-02
     +,   8.7451071E-02,   7.9873674E-02,   7.2905764E-02
     +,   6.6489831E-02,   6.0574111E-02,   5.5112526E-02
     +,   5.0065637E-02,   4.5400802E-02,   4.1090727E-02
     +,   3.7113111E-02,   3.3449765E-02,   3.0085154E-02
     +,   2.7005106E-02,   2.4196194E-02,   2.1645132E-02
     +,   1.9338161E-02,   1.7260682E-02,   1.5397446E-02
     +,   1.3732795E-02,   1.2250738E-02,   1.0935196E-02
     +,   9.7703850E-03,   8.7412065E-03,   7.8332163E-03
     +,   7.0329509E-03,   6.3280440E-03,   5.7072402E-03
     +,   5.1603494E-03,   4.6782824E-03,   4.2530103E-03
     +,   3.8774454E-03,   3.5453399E-03,   3.2512285E-03
     +,   2.9903548E-03,   2.7585600E-03,   2.5522015E-03
     +,   2.3681025E-03,   2.2035048E-03,   2.0559824E-03
     +,   1.9234167E-03,   1.8039646E-03,   1.6960145E-03
     +,   1.5981531E-03,   1.5091465E-03,   1.4279247E-03
     +,   1.3535552E-03,   1.2852213E-03,   1.2222135E-03
     +,   1.1639207E-03,   1.1098047E-03,   1.0594050E-03
     +,   1.0123147E-03,   9.6818624E-04,   9.2671096E-04
     +,   8.8762498E-04,   8.5069326E-04,   8.1571384E-04
     +,   7.8250549E-04,   7.5091311E-04,   7.2079670E-04
     +,   6.9203274E-04,   6.6451472E-04,   6.3814479E-04
     +,   6.1283947E-04,   5.8852159E-04,   5.6512590E-04
     +,   5.4259121E-04,   5.2086642E-04,   4.9990334E-04
     +,   4.7966215E-04,   4.6010478E-04,   4.4120042E-04
     +,   4.2291885E-04,   4.0523623E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_hzonly_ttz90_mass = Yx/23.1026007234043
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_hzonly_ttz95_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  7.0422357E-03,   7.2747585E-03
     +,   7.5038797E-03,   7.7289506E-03,   7.9493327E-03
     +,   8.1644328E-03,   8.3736908E-03,   8.5765971E-03
     +,   8.7726833E-03,   8.9615565E-03,   9.1428682E-03
     +,   9.3163466E-03,   9.4817840E-03,   9.6390443E-03
     +,   9.7880755E-03,   9.9288924E-03,   1.0061590E-02
     +,   1.0186343E-02,   1.0303399E-02,   1.0413077E-02
     +,   1.0515776E-02,   1.0611953E-02,   1.0702134E-02
     +,   1.0786910E-02,   1.0866906E-02,   1.0942819E-02
     +,   1.1015370E-02,   1.1085321E-02,   1.1153463E-02
     +,   1.1220596E-02,   1.1287545E-02,   1.1355135E-02
     +,   1.1424184E-02,   1.1495508E-02,   1.1569903E-02
     +,   1.1648138E-02,   1.1730958E-02,   1.1819072E-02
     +,   1.1913151E-02,   1.2013824E-02,   1.2121672E-02
     +,   1.2237222E-02,   1.2360961E-02,   1.2493323E-02
     +,   1.2634681E-02,   1.2785375E-02,   1.2945686E-02
     +,   1.3115859E-02,   1.3296088E-02,   1.3486544E-02
     +,   1.3687352E-02,   1.3898625E-02,   1.4120441E-02
     +,   1.4352886E-02,   1.4596004E-02,   1.4849864E-02
     +,   1.5114525E-02,   1.5390058E-02,   1.5676547E-02
     +,   1.5974090E-02,   1.6282799E-02,   1.6602825E-02
     +,   1.6934309E-02,   1.7277453E-02,   1.7632473E-02
     +,   1.7999586E-02,   1.8379044E-02,   1.8771101E-02
     +,   1.9176042E-02,   1.9594133E-02,   2.0025671E-02
     +,   2.0470899E-02,   2.0930098E-02,   2.1403480E-02
     +,   2.1891272E-02,   2.2393648E-02,   2.2910737E-02
     +,   2.3442579E-02,   2.3989210E-02,   2.4550615E-02
     +,   2.5126599E-02,   2.5716981E-02,   2.6321400E-02
     +,   2.6939480E-02,   2.7570613E-02,   2.8214149E-02
     +,   2.8869221E-02,   2.9534860E-02,   3.0209849E-02
     +,   3.0892869E-02,   3.1582385E-02,   3.2276623E-02
     +,   3.2973591E-02,   3.3671152E-02,   3.4366950E-02
     +,   3.5058372E-02,   3.5742711E-02,   3.6417030E-02
     +,   3.7078340E-02,   3.7723485E-02,   3.8349364E-02
     +,   3.8952798E-02,   3.9530795E-02,   4.0080439E-02
     +,   4.0599063E-02,   4.1084349E-02,   4.1534297E-02
     +,   4.1947421E-02,   4.2322762E-02,   4.2660043E-02
     +,   4.2959642E-02,   4.3222733E-02,   4.3451339E-02
     +,   4.3648355E-02,   4.3817628E-02,   4.3964010E-02
     +,   4.4093266E-02,   4.4212278E-02,   4.4328872E-02
     +,   4.4451967E-02,   4.4591412E-02,   4.4758026E-02
     +,   4.4963568E-02,   4.5220636E-02,   4.5542605E-02
     +,   4.5943502E-02,   4.6437949E-02,   4.7040991E-02
     +,   4.7767986E-02,   4.8634369E-02,   4.9655627E-02
     +,   5.0846908E-02,   5.2223165E-02,   5.3798668E-02
     +,   5.5587143E-02,   5.7601620E-02,   5.9854187E-02
     +,   6.2356181E-02,   6.5118484E-02,   6.8151437E-02
     +,   7.1465231E-02,   7.5070120E-02,   7.8977562E-02
     +,   8.3200261E-02,   8.7752521E-02,   9.2651315E-02
     +,   9.7916193E-02,   0.1035689    ,   0.1096330    
     +,   0.1161327    ,   0.1230917    ,   0.1305296    
     +,   0.1384602    ,   0.1468909    ,   0.1558206    
     +,   0.1652411    ,   0.1751410    ,   0.1855141    
     +,   0.1963664    ,   0.2077261    ,   0.2196513    
     +,   0.2322306    ,   0.2455735    ,   0.2597889    
     +,   0.2749555    ,   0.2910831    ,   0.3080847    
     +,   0.3257793    ,   0.3439498    ,   0.3624685    
     +,   0.3814797    ,   0.4015953    ,   0.4240158    
     +,   0.4504985    ,   0.4831475    ,   0.5240803    
     +,   0.5750329    ,   0.6368954    ,   0.7091869    
     +,   0.7896350    ,   0.8744286    ,   0.9599086    
     +,    1.045953    ,    1.139996    ,    1.259171    
     +,    1.427261    ,    1.664245    ,    1.970921    
     +,    2.318308    ,    2.654057    ,    2.928933    
     +,    3.129672    ,    3.289824    ,    3.454766    
     +,    3.624511    ,    3.740195    ,    3.737779    
     +,    3.610817    ,    3.414279    ,    3.212139    
     +,    3.031080    ,    2.859125    ,    2.672793    
     +,    2.464118    ,    2.248585    ,    2.049833    
     +,    1.880494    ,    1.738302    ,    1.613787    
     +,    1.497761    ,    1.384642    ,    1.272858    
     +,    1.163417    ,    1.058010    ,   0.9579445    
     +,   0.8639796    ,   0.7764210    ,   0.6952305    
     +,   0.6201612    ,   0.5509611    ,   0.4875294    
     +,   0.4299535    ,   0.3783855    ,   0.3328338    
     +,   0.2930129    ,   0.2583354    ,   0.2280272    
     +,   0.2012921    ,   0.1774459    ,   0.1559838    
     +,   0.1365760    ,   0.1190217    ,   0.1031943    
     +,   8.8998526E-02,   7.6346405E-02,   6.5142602E-02
     +,   5.5284504E-02,   4.6665162E-02,   3.9176136E-02
     +,   3.2710191E-02,   2.7163990E-02,   2.2439430E-02
     +,   1.8443670E-02,   1.5089261E-02,   1.2294672E-02
     +,   9.9845817E-03,   8.0898162E-03,   6.5474445E-03
     +,   5.3010504E-03,   4.3008020E-03,   3.5030723E-03
     +,   2.8703085E-03,   2.3706628E-03,   1.9774416E-03
     +,   1.6685438E-03,   1.4259267E-03,   1.2350376E-03
     +,   1.0842462E-03,   9.6434448E-04,   8.6811592E-04
     +,   7.8995532E-04,   7.2553632E-04,   6.7153905E-04
     +,   6.2543678E-04,   5.8532244E-04,   5.4975873E-04
     +,   5.1767280E-04,   4.8827162E-04,   4.6097202E-04
     +,   4.3534813E-04,   4.1109338E-04,   3.8799172E-04
     +,   3.6589245E-04,   3.4469162E-04,   3.2432002E-04
     +,   3.0473506E-04,   2.8590855E-04,   2.6782611E-04
     +,   2.5047807E-04,   2.3386111E-04,   2.1797151E-04
     +,   2.0280774E-04,   1.8836548E-04,   1.7464063E-04
     +,   1.6162533E-04,   1.4931109E-04,   1.3768596E-04
     +,   1.2673569E-04,   1.1644503E-04,   1.0679533E-04
     +,   9.7767523E-05,   8.9339803E-05,   8.1490252E-05
     +,   7.4194868E-05,   6.7429806E-05,   6.1169805E-05
     +,   5.5390105E-05,   5.0064966E-05,   4.5169545E-05
     +,   4.0678446E-05,   3.6567282E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_hzonly_ttz95_mass = Yx/23.1501614042553
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_hzonly_hatt100_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  0.1080913    ,   0.1167399    
     +,   0.1256197    ,   0.1346804    ,   0.1438661    
     +,   0.1531155    ,   0.1623630    ,   0.1715391    
     +,   0.1805727    ,   0.1893922    ,   0.1979263    
     +,   0.2061067    ,   0.2138695    ,   0.2211565    
     +,   0.2279173    ,   0.2341102    ,   0.2397036    
     +,   0.2446762    ,   0.2490178    ,   0.2527294    
     +,   0.2558217    ,   0.2583157    ,   0.2602403    
     +,   0.2616316    ,   0.2625313    ,   0.2629839    
     +,   0.2630371    ,   0.2627373    ,   0.2621307    
     +,   0.2612606    ,   0.2601667    ,   0.2588841    
     +,   0.2574428    ,   0.2558681    ,   0.2541793    
     +,   0.2523913    ,   0.2505134    ,   0.2485516    
     +,   0.2465082    ,   0.2443828    ,   0.2421727    
     +,   0.2398751    ,   0.2374872    ,   0.2350060    
     +,   0.2324318    ,   0.2297668    ,   0.2270169    
     +,   0.2241921    ,   0.2213071    ,   0.2183812    
     +,   0.2154383    ,   0.2125078    ,   0.2096221    
     +,   0.2068174    ,   0.2041325    ,   0.2016068    
     +,   0.1992799    ,   0.1971893    ,   0.1953707    
     +,   0.1938544    ,   0.1926652    ,   0.1918218    
     +,   0.1913356    ,   0.1912096    ,   0.1914393    
     +,   0.1920120    ,   0.1929080    ,   0.1941006    
     +,   0.1955585    ,   0.1972447    ,   0.1991201    
     +,   0.2011437    ,   0.2032745    ,   0.2054725    
     +,   0.2077005    ,   0.2099243    ,   0.2121141    
     +,   0.2142446    ,   0.2162954    ,   0.2182515    
     +,   0.2201011    ,   0.2218377    ,   0.2234572    
     +,   0.2249581    ,   0.2263409    ,   0.2276065    
     +,   0.2287557    ,   0.2297891    ,   0.2307058    
     +,   0.2315037    ,   0.2321791    ,   0.2327269    
     +,   0.2331412    ,   0.2334147    ,   0.2335409    
     +,   0.2335130    ,   0.2333259    ,   0.2329759    
     +,   0.2324620    ,   0.2317865    ,   0.2309547    
     +,   0.2299768    ,   0.2288669    ,   0.2276437    
     +,   0.2263311    ,   0.2249571    ,   0.2235542    
     +,   0.2221592    ,   0.2208116    ,   0.2195532    
     +,   0.2184268    ,   0.2174748    ,   0.2167380    
     +,   0.2162530    ,   0.2160512    ,   0.2161565    
     +,   0.2165842    ,   0.2173399    ,   0.2184173    
     +,   0.2197987    ,   0.2214548    ,   0.2233452    
     +,   0.2254192    ,   0.2276184    ,   0.2298774    
     +,   0.2321273    ,   0.2342988    ,   0.2363237    
     +,   0.2381389    ,   0.2396881    ,   0.2409251    
     +,   0.2418144    ,   0.2423330    ,   0.2424711    
     +,   0.2422315    ,   0.2416304    ,   0.2406940    
     +,   0.2394601    ,   0.2379731    ,   0.2362843    
     +,   0.2344485    ,   0.2325224    ,   0.2305622    
     +,   0.2286215    ,   0.2267510    ,   0.2249944    
     +,   0.2233908    ,   0.2219710    ,   0.2207590    
     +,   0.2197713    ,   0.2190173    ,   0.2184999    
     +,   0.2182167    ,   0.2181612    ,   0.2183243    
     +,   0.2186961    ,   0.2192676    ,   0.2200322    
     +,   0.2209886    ,   0.2221399    ,   0.2234973    
     +,   0.2250791    ,   0.2269107    ,   0.2290239    
     +,   0.2314571    ,   0.2342515    ,   0.2374502    
     +,   0.2410954    ,   0.2452267    ,   0.2498786    
     +,   0.2550791    ,   0.2608493    ,   0.2672032    
     +,   0.2741483    ,   0.2816863    ,   0.2898133    
     +,   0.2985243    ,   0.3078085    ,   0.3176504    
     +,   0.3280300    ,   0.3389157    ,   0.3502637    
     +,   0.3620104    ,   0.3740712    ,   0.3863359    
     +,   0.3986670    ,   0.4109011    ,   0.4228533    
     +,   0.4343230    ,   0.4451023    ,   0.4549873    
     +,   0.4637878    ,   0.4713373    ,   0.4775025    
     +,   0.4821862    ,   0.4853344    ,   0.4869299    
     +,   0.4869927    ,   0.4855726    ,   0.4827413    
     +,   0.4785856    ,   0.4732009    ,   0.4666822    
     +,   0.4591253    ,   0.4506196    ,   0.4412523    
     +,   0.4311048    ,   0.4202570    ,   0.4087894    
     +,   0.3967806    ,   0.3843116    ,   0.3714627    
     +,   0.3583152    ,   0.3449456    ,   0.3314260    
     +,   0.3178239    ,   0.3041987    ,   0.2906008    
     +,   0.2770736    ,   0.2636546    ,   0.2503738    
     +,   0.2372580    ,   0.2243338    ,   0.2116257    
     +,   0.1991592    ,   0.1869615    ,   0.1750618    
     +,   0.1634903    ,   0.1522776    ,   0.1414534    
     +,   0.1310465    ,   0.1210829    ,   0.1115839    
     +,   0.1025668    ,   9.4044387E-02,   8.6023383E-02
     +,   7.8505248E-02,   7.1487345E-02,   6.4962037E-02
     +,   5.8917638E-02,   5.3338856E-02,   4.8208207E-02
     +,   4.3505862E-02,   3.9210115E-02,   3.5298146E-02
     +,   3.1746734E-02,   2.8532265E-02,   2.5630891E-02
     +,   2.3019087E-02,   2.0674042E-02,   1.8573429E-02
     +,   1.6695715E-02,   1.5020546E-02,   1.3528544E-02
     +,   1.2201427E-02,   1.1022121E-02,   9.9748820E-03
     +,   9.0451865E-03,   8.2196975E-03,   7.4863071E-03
     +,   6.8341210E-03,   6.2533743E-03,   5.7352968E-03
     +,   5.2721328E-03,   4.8570726E-03,   4.4841054E-03
     +,   4.1479766E-03,   3.8441399E-03,   3.5686519E-03
     +,   3.3180893E-03,   3.0895057E-03,   2.8803810E-03
     +,   2.6885504E-03,   2.5121460E-03,   2.3495615E-03
     +,   2.1994335E-03,   2.0605652E-03,   1.9319390E-03
     +,   1.8126536E-03,   1.7019353E-03,   1.5990882E-03
     +,   1.5035091E-03,   1.4146456E-03,   1.3320121E-03
     +,   1.2551567E-03,   1.1836769E-03,   1.1171951E-03
     +,   1.0553634E-03,   9.9786406E-04,   9.4439345E-04
     +,   8.9467550E-04,   8.4844464E-04,   8.0545788E-04
     +,   7.6548272E-04,   7.2830555E-04,   6.9372111E-04
     +,   6.6154217E-04,   6.3158869E-04,   6.0369639E-04
     +,   5.7770812E-04,   5.5348052E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_hzonly_hatt100_mass = Yx/14.3900785
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_hzonly_hatt105_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  0.1206643    ,   0.1291464    
     +,   0.1377177    ,   0.1463349    ,   0.1549554    
     +,   0.1635386    ,   0.1720464    ,   0.1804448    
     +,   0.1887041    ,   0.1967992    ,   0.2047096    
     +,   0.2124204    ,   0.2199211    ,   0.2272056    
     +,   0.2342707    ,   0.2411166    ,   0.2477448    
     +,   0.2541575    ,   0.2603556    ,   0.2663391    
     +,   0.2721045    ,   0.2776456    ,   0.2829504    
     +,   0.2880034    ,   0.2927836    ,   0.2972662    
     +,   0.3014215    ,   0.3052177    ,   0.3086208    
     +,   0.3115970    ,   0.3141139    ,   0.3161424    
     +,   0.3176590    ,   0.3186471    ,   0.3190983    
     +,   0.3190144    ,   0.3184071    ,   0.3172992    
     +,   0.3157236    ,   0.3137235    ,   0.3113499    
     +,   0.3086602    ,   0.3057180    ,   0.3025879    
     +,   0.2993355    ,   0.2960232    ,   0.2927100    
     +,   0.2894477    ,   0.2862812    ,   0.2832455    
     +,   0.2803666    ,   0.2776608    ,   0.2751347    
     +,   0.2727860    ,   0.2706055    ,   0.2685780    
     +,   0.2666826    ,   0.2648965    ,   0.2631950    
     +,   0.2615536    ,   0.2599501    ,   0.2583644    
     +,   0.2567799    ,   0.2551849    ,   0.2535716    
     +,   0.2519370    ,   0.2502823    ,   0.2486127    
     +,   0.2469369    ,   0.2452660    ,   0.2436129    
     +,   0.2419915    ,   0.2404165    ,   0.2389016    
     +,   0.2374597    ,   0.2361022    ,   0.2348384    
     +,   0.2336751    ,   0.2326164    ,   0.2316632    
     +,   0.2308139    ,   0.2300638    ,   0.2294053    
     +,   0.2288286    ,   0.2283211    ,   0.2278688    
     +,   0.2274564    ,   0.2270675    ,   0.2266858    
     +,   0.2262953    ,   0.2258809    ,   0.2254290    
     +,   0.2249283    ,   0.2243699    ,   0.2237480    
     +,   0.2230592    ,   0.2223035    ,   0.2214840    
     +,   0.2206066    ,   0.2196793    ,   0.2187127    
     +,   0.2177182    ,   0.2167088    ,   0.2156970    
     +,   0.2146955    ,   0.2137158    ,   0.2127676    
     +,   0.2118588    ,   0.2109950    ,   0.2101788    
     +,   0.2094104    ,   0.2086870    ,   0.2080033    
     +,   0.2073519    ,   0.2067240    ,   0.2061086    
     +,   0.2054948    ,   0.2048712    ,   0.2042269    
     +,   0.2035526    ,   0.2028399    ,   0.2020833    
     +,   0.2012794    ,   0.2004271    ,   0.1995284    
     +,   0.1985881    ,   0.1976127    ,   0.1966115    
     +,   0.1955948    ,   0.1945740    ,   0.1935612    
     +,   0.1925674    ,   0.1916033    ,   0.1906773    
     +,   0.1897962    ,   0.1889637    ,   0.1881806    
     +,   0.1874445    ,   0.1867500    ,   0.1860886    
     +,   0.1854492    ,   0.1848187    ,   0.1841825    
     +,   0.1835257    ,   0.1828330    ,   0.1820910    
     +,   0.1812882    ,   0.1804162    ,   0.1794703    
     +,   0.1784509    ,   0.1773625    ,   0.1762157    
     +,   0.1750263    ,   0.1738152    ,   0.1726085    
     +,   0.1714362    ,   0.1703323    ,   0.1693327    
     +,   0.1684750    ,   0.1677972    ,   0.1673363    
     +,   0.1671275    ,   0.1672036    ,   0.1675939    
     +,   0.1683242    ,   0.1694173    ,   0.1708916    
     +,   0.1727638    ,   0.1750482    ,   0.1777588    
     +,   0.1809102    ,   0.1845176    ,   0.1886004    
     +,   0.1931811    ,   0.1982859    ,   0.2039460    
     +,   0.2101965    ,   0.2170746    ,   0.2246191    
     +,   0.2328678    ,   0.2418557    ,   0.2516093    
     +,   0.2621462    ,   0.2734711    ,   0.2855715    
     +,   0.2984173    ,   0.3119566    ,   0.3261173    
     +,   0.3408062    ,   0.3559084    ,   0.3712932    
     +,   0.3868145    ,   0.4023139    ,   0.4176264    
     +,   0.4325846    ,   0.4470214    ,   0.4607725    
     +,   0.4736802    ,   0.4855961    ,   0.4963798    
     +,   0.5059002    ,   0.5140361    ,   0.5206780    
     +,   0.5257258    ,   0.5290906    ,   0.5306980    
     +,   0.5304881    ,   0.5284198    ,   0.5244731    
     +,   0.5186506    ,   0.5109830    ,   0.5015282    
     +,   0.4903730    ,   0.4776326    ,   0.4634458    
     +,   0.4479777    ,   0.4314087    ,   0.4139335    
     +,   0.3957531    ,   0.3770705    ,   0.3580843    
     +,   0.3389825    ,   0.3199421    ,   0.3011216    
     +,   0.2826617    ,   0.2646810    ,   0.2472811    
     +,   0.2305428    ,   0.2145277    ,   0.1992806    
     +,   0.1848323    ,   0.1712003    ,   0.1583897    
     +,   0.1463958    ,   0.1352073    ,   0.1248043    
     +,   0.1151621    ,   0.1062514    ,   9.8039471E-02
     +,   9.0490073E-02,   8.3564997E-02,   7.7225260E-02
     +,   7.1430869E-02,   6.6141523E-02,   6.1317362E-02
     +,   5.6919828E-02,   5.2911736E-02,   4.9257331E-02
     +,   4.5923032E-02,   4.2877737E-02,   4.0092401E-02
     +,   3.7540469E-02,   3.5197902E-02,   3.3043005E-02
     +,   3.1056203E-02,   2.9219992E-02,   2.7519004E-02
     +,   2.5939599E-02,   2.4469633E-02,   2.3098428E-02
     +,   2.1816680E-02,   2.0616202E-02,   1.9489719E-02
     +,   1.8430794E-02,   1.7433867E-02,   1.6493890E-02
     +,   1.5606440E-02,   1.4767585E-02,   1.3973838E-02
     +,   1.3222022E-02,   1.2509296E-02,   1.1833149E-02
     +,   1.1191320E-02,   1.0581726E-02,   1.0002495E-02
     +,   9.4519891E-03,   8.9286519E-03,   8.4311431E-03
     +,   7.9581840E-03,   7.5086728E-03,   7.0815305E-03
     +,   6.6758394E-03,   6.2906900E-03,   5.9252898E-03
     +,   5.5788523E-03,   5.2506742E-03,   4.9400614E-03
     +,   4.6463432E-03,   4.3689031E-03,   4.1071055E-03
     +,   3.8603642E-03,   3.6280644E-03,   3.4096392E-03
     +,   3.2044903E-03,   3.0120604E-03,   2.8317652E-03
     +,   2.6630552E-03,   2.5053606E-03,   2.3581432E-03
     +,   2.2208514E-03,   2.0929605E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_hzonly_hatt105_mass = Yx/15.0632242727273
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_hzonly_hatt107_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  0.1363668    ,   0.1464367    
     +,   0.1566111    ,   0.1668246    ,   0.1770113    
     +,   0.1871062    ,   0.1970468    ,   0.2067742    
     +,   0.2162359    ,   0.2253861    ,   0.2341866    
     +,   0.2426078    ,   0.2506284    ,   0.2582357    
     +,   0.2654239    ,   0.2721939    ,   0.2785513    
     +,   0.2845044    ,   0.2900638    ,   0.2952389    
     +,   0.3000378    ,   0.3044659    ,   0.3085251    
     +,   0.3122137    ,   0.3155265    ,   0.3184555    
     +,   0.3209928    ,   0.3231277    ,   0.3248521    
     +,   0.3261601    ,   0.3270483    ,   0.3275186    
     +,   0.3275761    ,   0.3272308    ,   0.3264976    
     +,   0.3253937    ,   0.3239411    ,   0.3221628    
     +,   0.3200842    ,   0.3177319    ,   0.3151340    
     +,   0.3123188    ,   0.3093162    ,   0.3061568    
     +,   0.3028729    ,   0.2994975    ,   0.2960650    
     +,   0.2926109    ,   0.2891713    ,   0.2857809    
     +,   0.2824748    ,   0.2792854    ,   0.2762418    
     +,   0.2733707    ,   0.2706936    ,   0.2682284    
     +,   0.2659878    ,   0.2639799    ,   0.2622101    
     +,   0.2606786    ,   0.2593832    ,   0.2583196    
     +,   0.2574806    ,   0.2568570    ,   0.2564380    
     +,   0.2562108    ,   0.2561603    ,   0.2562696    
     +,   0.2565191    ,   0.2568858    ,   0.2573453    
     +,   0.2578706    ,   0.2584334    ,   0.2590044    
     +,   0.2595547    ,   0.2600569    ,   0.2604859    
     +,   0.2608203    ,   0.2610441    ,   0.2611450    
     +,   0.2611179    ,   0.2609622    ,   0.2606832    
     +,   0.2602903    ,   0.2597965    ,   0.2592165    
     +,   0.2585664    ,   0.2578605    ,   0.2571117    
     +,   0.2563297    ,   0.2555191    ,   0.2546796    
     +,   0.2538069    ,   0.2528901    ,   0.2519149    
     +,   0.2508623    ,   0.2497110    ,   0.2484381    
     +,   0.2470208    ,   0.2454376    ,   0.2436698    
     +,   0.2417024    ,   0.2395265    ,   0.2371380    
     +,   0.2345404    ,   0.2317433    ,   0.2287635    
     +,   0.2256239    ,   0.2223531    ,   0.2189843    
     +,   0.2155544    ,   0.2121022    ,   0.2086674    
     +,   0.2052885    ,   0.2020021    ,   0.1988411    
     +,   0.1958339    ,   0.1930027    ,   0.1903639    
     +,   0.1879268    ,   0.1856939    ,   0.1836611    
     +,   0.1818181    ,   0.1801490    ,   0.1786334    
     +,   0.1772474    ,   0.1759644    ,   0.1747570    
     +,   0.1735977    ,   0.1724600    ,   0.1713195    
     +,   0.1701546    ,   0.1689475    ,   0.1676845    
     +,   0.1663553    ,   0.1649549    ,   0.1634818    
     +,   0.1619384    ,   0.1603308    ,   0.1586675    
     +,   0.1569594    ,   0.1552194    ,   0.1534615    
     +,   0.1516995    ,   0.1499484    ,   0.1482221    
     +,   0.1465345    ,   0.1448985    ,   0.1433266    
     +,   0.1418304    ,   0.1404211    ,   0.1391094    
     +,   0.1379065    ,   0.1368230    ,   0.1358704    
     +,   0.1350610    ,   0.1344078    ,   0.1339253    
     +,   0.1336288    ,   0.1335354    ,   0.1336632    
     +,   0.1340317    ,   0.1346617    ,   0.1355754    
     +,   0.1367959    ,   0.1383474    ,   0.1402552    
     +,   0.1425451    ,   0.1452445    ,   0.1483808    
     +,   0.1519819    ,   0.1560759    ,   0.1606915    
     +,   0.1658557    ,   0.1715944    ,   0.1779314    
     +,   0.1848879    ,   0.1924796    ,   0.2007176    
     +,   0.2096063    ,   0.2191436    ,   0.2293183    
     +,   0.2401105    ,   0.2514922    ,   0.2634268    
     +,   0.2758688    ,   0.2887657    ,   0.3020586    
     +,   0.3156837    ,   0.3295721    ,   0.3436520    
     +,   0.3578498    ,   0.3720885    ,   0.3862896    
     +,   0.4003739    ,   0.4142591    ,   0.4278600    
     +,   0.4410879    ,   0.4538513    ,   0.4660552    
     +,   0.4775975    ,   0.4883734    ,   0.4982738    
     +,   0.5071853    ,   0.5149915    ,   0.5215755    
     +,   0.5268194    ,   0.5306098    ,   0.5328389    
     +,   0.5334082    ,   0.5322336    ,   0.5292476    
     +,   0.5244071    ,   0.5176942    ,   0.5091218    
     +,   0.4987345    ,   0.4866118    ,   0.4728650    
     +,   0.4576368    ,   0.4410990    ,   0.4234443    
     +,   0.4048822    ,   0.3856327    ,   0.3659186    
     +,   0.3459571    ,   0.3259548    ,   0.3061042    
     +,   0.2865784    ,   0.2675273    ,   0.2490766    
     +,   0.2313303    ,   0.2143694    ,   0.1982522    
     +,   0.1830181    ,   0.1686908    ,   0.1552776    
     +,   0.1427736    ,   0.1311644    ,   0.1204269    
     +,   0.1105302    ,   0.1014380    ,   9.3110740E-02
     +,   8.5505165E-02,   7.8575559E-02,   7.2274975E-02
     +,   6.6556536E-02,   6.1373521E-02,   5.6679774E-02
     +,   5.2430734E-02,   4.8584208E-02,   4.5099944E-02
     +,   4.1940369E-02,   3.9070893E-02,   3.6459882E-02
     +,   3.4078382E-02,   3.1900436E-02,   2.9902989E-02
     +,   2.8065572E-02,   2.6370091E-02,   2.4800757E-02
     +,   2.3343937E-02,   2.1987816E-02,   2.0722175E-02
     +,   1.9538248E-02,   1.8428629E-02,   1.7386887E-02
     +,   1.6407527E-02,   1.5485884E-02,   1.4617964E-02
     +,   1.3800206E-02,   1.3029516E-02,   1.2303184E-02
     +,   1.1618774E-02,   1.0974020E-02,   1.0366825E-02
     +,   9.7952783E-03,   9.2574935E-03,   8.7517248E-03
     +,   8.2762400E-03,   7.8294072E-03,   7.4095889E-03
     +,   7.0152534E-03,   6.6448557E-03,   6.2969630E-03
     +,   5.9701377E-03,   5.6630457E-03,   5.3743855E-03
     +,   5.1029162E-03,   4.8474935E-03,   4.6070055E-03
     +,   4.3804413E-03,   4.1668294E-03,   3.9652963E-03
     +,   3.7750059E-03,   3.5952132E-03,   3.4252102E-03
     +,   3.2643699E-03,   3.1120977E-03,   2.9678696E-03
     +,   2.8311876E-03,   2.7016152E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_hzonly_hatt107_mass = Yx/15.2791389545455
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_hzonly_hatt110_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  0.1112353    ,   0.1200509    
     +,   0.1291033    ,   0.1383433    ,   0.1477161    
     +,   0.1571625    ,   0.1666190    ,   0.1760196    
     +,   0.1852959    ,   0.1943794    ,   0.2032013    
     +,   0.2116945    ,   0.2197948    ,   0.2274420    
     +,   0.2345809    ,   0.2411623    ,   0.2471443    
     +,   0.2524929    ,   0.2571824    ,   0.2611969    
     +,   0.2645296    ,   0.2671843    ,   0.2691747    
     +,   0.2705253    ,   0.2712696    ,   0.2714529    
     +,   0.2711278    ,   0.2703568    ,   0.2692092    
     +,   0.2677608    ,   0.2660921    ,   0.2642855    
     +,   0.2624252    ,   0.2605929    ,   0.2588667    
     +,   0.2573181    ,   0.2560101    ,   0.2549953    
     +,   0.2543138    ,   0.2539919    ,   0.2540419    
     +,   0.2544615    ,   0.2552348    ,   0.2563334    
     +,   0.2577170    ,   0.2593373    ,   0.2611392    
     +,   0.2630649    ,   0.2650543    ,   0.2670507    
     +,   0.2690006    ,   0.2708570    ,   0.2725807    
     +,   0.2741403    ,   0.2755129    ,   0.2766842    
     +,   0.2776463    ,   0.2783984    ,   0.2789425    
     +,   0.2792844    ,   0.2794303    ,   0.2793860    
     +,   0.2791556    ,   0.2787411    ,   0.2781409    
     +,   0.2773505    ,   0.2763632    ,   0.2751711    
     +,   0.2737636    ,   0.2721324    ,   0.2702686    
     +,   0.2681672    ,   0.2658252    ,   0.2632439    
     +,   0.2604294    ,   0.2573911    ,   0.2541439    
     +,   0.2507055    ,   0.2470983    ,   0.2433465    
     +,   0.2394771    ,   0.2355174    ,   0.2314970    
     +,   0.2274443    ,   0.2233876    ,   0.2193541    
     +,   0.2153696    ,   0.2114580    ,   0.2076410    
     +,   0.2039381    ,   0.2003663    ,   0.1969400    
     +,   0.1936705    ,   0.1905664    ,   0.1876334    
     +,   0.1848740    ,   0.1822879    ,   0.1798721    
     +,   0.1776208    ,   0.1755263    ,   0.1735780    
     +,   0.1717645    ,   0.1700729    ,   0.1684889    
     +,   0.1669987    ,   0.1655879    ,   0.1642430    
     +,   0.1629509    ,   0.1617002    ,   0.1604802    
     +,   0.1592827    ,   0.1581002    ,   0.1569280    
     +,   0.1557625    ,   0.1546019    ,   0.1534468    
     +,   0.1522982    ,   0.1511593    ,   0.1500342    
     +,   0.1489281    ,   0.1478463    ,   0.1467956    
     +,   0.1457820    ,   0.1448124    ,   0.1438926    
     +,   0.1430287    ,   0.1422253    ,   0.1414868    
     +,   0.1408163    ,   0.1402153    ,   0.1396845    
     +,   0.1392230    ,   0.1388286    ,   0.1384978    
     +,   0.1382259    ,   0.1380069    ,   0.1378346    
     +,   0.1377015    ,   0.1376000    ,   0.1375225    
     +,   0.1374618    ,   0.1374111    ,   0.1373647    
     +,   0.1373178    ,   0.1372674    ,   0.1372119    
     +,   0.1371516    ,   0.1370886    ,   0.1370269    
     +,   0.1369727    ,   0.1369333    ,   0.1369185    
     +,   0.1369389    ,   0.1370065    ,   0.1371343    
     +,   0.1373355    ,   0.1376245    ,   0.1380150    
     +,   0.1385210    ,   0.1391562    ,   0.1399335    
     +,   0.1408653    ,   0.1419637    ,   0.1432392    
     +,   0.1447027    ,   0.1463638    ,   0.1482318    
     +,   0.1503157    ,   0.1526246    ,   0.1551674    
     +,   0.1579535    ,   0.1609929    ,   0.1642960    
     +,   0.1678751    ,   0.1717428    ,   0.1759134    
     +,   0.1804029    ,   0.1852283    ,   0.1904079    
     +,   0.1959611    ,   0.2019084    ,   0.2082695    
     +,   0.2150641    ,   0.2223103    ,   0.2300247    
     +,   0.2382192    ,   0.2469012    ,   0.2560730    
     +,   0.2657297    ,   0.2758576    ,   0.2864336    
     +,   0.2974248    ,   0.3087855    ,   0.3204581    
     +,   0.3323734    ,   0.3444513    ,   0.3565969    
     +,   0.3687076    ,   0.3806704    ,   0.3923678    
     +,   0.4036747    ,   0.4144671    ,   0.4246219    
     +,   0.4340210    ,   0.4425535    ,   0.4501199    
     +,   0.4566325    ,   0.4620187    ,   0.4662208    
     +,   0.4691987    ,   0.4709275    ,   0.4713979    
     +,   0.4706146    ,   0.4685967    ,   0.4653738    
     +,   0.4609882    ,   0.4554888    ,   0.4489338    
     +,   0.4413864    ,   0.4329178    ,   0.4236021    
     +,   0.4135166    ,   0.4027416    ,   0.3913604    
     +,   0.3794550    ,   0.3671073    ,   0.3543989    
     +,   0.3414083    ,   0.3282106    ,   0.3148773    
     +,   0.3014757    ,   0.2880692    ,   0.2747158    
     +,   0.2614690    ,   0.2483794    ,   0.2354916    
     +,   0.2228470    ,   0.2104840    ,   0.1984371    
     +,   0.1867369    ,   0.1754100    ,   0.1644804    
     +,   0.1539681    ,   0.1438885    ,   0.1342531    
     +,   0.1250700    ,   0.1163435    ,   0.1080736    
     +,   0.1002565    ,   9.2886545E-02,   8.5954130E-02
     +,   7.9447709E-02,   7.3354028E-02,   6.7658454E-02
     +,   6.2344786E-02,   5.7396349E-02,   5.2796233E-02
     +,   4.8527390E-02,   4.4572577E-02,   4.0914737E-02
     +,   3.7537429E-02,   3.4424547E-02,   3.1560209E-02
     +,   2.8929016E-02,   2.6516361E-02,   2.4307769E-02
     +,   2.2289380E-02,   2.0447910E-02,   1.8770561E-02
     +,   1.7244948E-02,   1.5859244E-02,   1.4602200E-02
     +,   1.3463154E-02,   1.2431884E-02,   1.1498760E-02
     +,   1.0654814E-02,   9.8915361E-03,   9.2010899E-03
     +,   8.5761193E-03,   8.0099190E-03,   7.4962405E-03
     +,   7.0294421E-03,   6.6043390E-03,   6.2162834E-03
     +,   5.8610463E-03,   5.5348780E-03,   5.2344142E-03
     +,   4.9566696E-03,   4.6990379E-03,   4.4592018E-03
     +,   4.2351712E-03,   4.0251906E-03,   3.8277716E-03
     +,   3.6416098E-03,   3.4656129E-03,   3.2988335E-03
     +,   3.1404844E-03,   2.9898859E-03,   2.8464776E-03
     +,   2.7097736E-03,   2.5793812E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_hzonly_hatt110_mass = Yx/14.1868646818182
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_hzonly_hatt115_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  0.1393450    ,   0.1488035    
     +,   0.1583307    ,   0.1678781    ,   0.1773975    
     +,   0.1868424    ,   0.1961676    ,   0.2053305    
     +,   0.2142905    ,   0.2230105    ,   0.2314554    
     +,   0.2395927    ,   0.2473929    ,   0.2548279    
     +,   0.2618719    ,   0.2685007    ,   0.2746918    
     +,   0.2804236    ,   0.2856764    ,   0.2904323    
     +,   0.2946753    ,   0.2983919    ,   0.3015727    
     +,   0.3042111    ,   0.3063053    ,   0.3078588    
     +,   0.3088802    ,   0.3093835    ,   0.3093885    
     +,   0.3089205    ,   0.3080089    ,   0.3066881    
     +,   0.3049944    ,   0.3029669    ,   0.3006454    
     +,   0.2980691    ,   0.2952770    ,   0.2923049    
     +,   0.2891861    ,   0.2859513    ,   0.2826276    
     +,   0.2792377    ,   0.2758026    ,   0.2723394    
     +,   0.2688637    ,   0.2653883    ,   0.2619250    
     +,   0.2584846    ,   0.2550778    ,   0.2517143    
     +,   0.2484041    ,   0.2451569    ,   0.2419824    
     +,   0.2388903    ,   0.2358894    ,   0.2329886    
     +,   0.2301955    ,   0.2275172    ,   0.2249595    
     +,   0.2225264    ,   0.2202206    ,   0.2180429    
     +,   0.2159921    ,   0.2140646    ,   0.2122550    
     +,   0.2105550    ,   0.2089545    ,   0.2074404    
     +,   0.2059984    ,   0.2046118    ,   0.2032622    
     +,   0.2019307    ,   0.2005977    ,   0.1992438    
     +,   0.1978509    ,   0.1964020    ,   0.1948826    
     +,   0.1932816    ,   0.1915913    ,   0.1898075    
     +,   0.1879308    ,   0.1859662    ,   0.1839224    
     +,   0.1818126    ,   0.1796537    ,   0.1774650    
     +,   0.1752687    ,   0.1730878    ,   0.1709463    
     +,   0.1688677    ,   0.1668742    ,   0.1649861    
     +,   0.1632209    ,   0.1615932    ,   0.1601135    
     +,   0.1587885    ,   0.1576209    ,   0.1566094    
     +,   0.1557489    ,   0.1550310    ,   0.1544438    
     +,   0.1539735    ,   0.1536038    ,   0.1533174    
     +,   0.1530962    ,   0.1529217    ,   0.1527761    
     +,   0.1526417    ,   0.1525029    ,   0.1523450    
     +,   0.1521552    ,   0.1519225    ,   0.1516382    
     +,   0.1512950    ,   0.1508882    ,   0.1504143    
     +,   0.1498716    ,   0.1492598    ,   0.1485801    
     +,   0.1478343    ,   0.1470251    ,   0.1461560    
     +,   0.1452304    ,   0.1442525    ,   0.1432260    
     +,   0.1421549    ,   0.1410426    ,   0.1398928    
     +,   0.1387086    ,   0.1374929    ,   0.1362482    
     +,   0.1349768    ,   0.1336813    ,   0.1323633    
     +,   0.1310250    ,   0.1296682    ,   0.1282951    
     +,   0.1269077    ,   0.1255086    ,   0.1241003    
     +,   0.1226858    ,   0.1212686    ,   0.1198522    
     +,   0.1184409    ,   0.1170392    ,   0.1156521    
     +,   0.1142849    ,   0.1129434    ,   0.1116339    
     +,   0.1103630    ,   0.1091374    ,   0.1079645    
     +,   0.1068517    ,   0.1058070    ,   0.1048384    
     +,   0.1039542    ,   0.1031633    ,   0.1024743    
     +,   0.1018965    ,   0.1014392    ,   0.1011119    
     +,   0.1009246    ,   0.1008870    ,   0.1010096    
     +,   0.1013026    ,   0.1017765    ,   0.1024419    
     +,   0.1033094    ,   0.1043897    ,   0.1056935    
     +,   0.1072314    ,   0.1090134    ,   0.1110497    
     +,   0.1133500    ,   0.1159231    ,   0.1187774    
     +,   0.1219202    ,   0.1253577    ,   0.1290948    
     +,   0.1331350    ,   0.1374802    ,   0.1421302    
     +,   0.1470823    ,   0.1523320    ,   0.1578729    
     +,   0.1636950    ,   0.1697864    ,   0.1761325    
     +,   0.1827164    ,   0.1895182    ,   0.1965158    
     +,   0.2036849    ,   0.2109993    ,   0.2184298    
     +,   0.2259472    ,   0.2335203    ,   0.2411176    
     +,   0.2487068    ,   0.2562566    ,   0.2637371    
     +,   0.2711199    ,   0.2783788    ,   0.2854919    
     +,   0.2924406    ,   0.2992105    ,   0.3057917    
     +,   0.3121795    ,   0.3183718    ,   0.3243702    
     +,   0.3301791    ,   0.3358036    ,   0.3412476    
     +,   0.3465128    ,   0.3515971    ,   0.3564931    
     +,   0.3611853    ,   0.3656510    ,   0.3698595    
     +,   0.3737713    ,   0.3773386    ,   0.3805081    
     +,   0.3832208    ,   0.3854146    ,   0.3870278    
     +,   0.3880001    ,   0.3882768    ,   0.3878096    
     +,   0.3865609    ,   0.3845037    ,   0.3816245    
     +,   0.3779229    ,   0.3734131    ,   0.3681222    
     +,   0.3620902    ,   0.3553680    ,   0.3480163    
     +,   0.3401019    ,   0.3316982    ,   0.3228807    
     +,   0.3137246    ,   0.3043042    ,   0.2946904    
     +,   0.2849495    ,   0.2751417    ,   0.2653203    
     +,   0.2555321    ,   0.2458174    ,   0.2362087    
     +,   0.2267326    ,   0.2174111    ,   0.2082602    
     +,   0.1992923    ,   0.1905170    ,   0.1819412    
     +,   0.1735699    ,   0.1654069    ,   0.1574552    
     +,   0.1497181    ,   0.1421975    ,   0.1348955    
     +,   0.1278149    ,   0.1209578    ,   0.1143263    
     +,   0.1079220    ,   0.1017469    ,   9.5802017E-02
     +,   9.0087786E-02,   8.4604740E-02,   7.9352565E-02
     +,   7.4330039E-02,   6.9535352E-02,   6.4966403E-02
     +,   6.0620502E-02,   5.6493912E-02,   5.2582525E-02
     +,   4.8882119E-02,   4.5387372E-02,   4.2093068E-02
     +,   3.8993180E-02,   3.6081683E-02,   3.3351962E-02
     +,   3.0797411E-02,   2.8410947E-02,   2.6185609E-02
     +,   2.4114000E-02,   2.2188954E-02,   2.0403061E-02
     +,   1.8748930E-02,   1.7219359E-02,   1.5807033E-02
     +,   1.4504952E-02,   1.3306090E-02,   1.2203750E-02
     +,   1.1191302E-02,   1.0262474E-02,   9.4111366E-03
     +,   8.6315088E-03,   7.9180123E-03,   7.2654369E-03
     +,   6.6687828E-03,   6.1234324E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_hzonly_hatt115_mass = Yx/13.7169327272727
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_hzonly_hatt120_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  0.1363933    ,   0.1465380    
     +,   0.1568307    ,   0.1672060    ,   0.1775953    
     +,   0.1879281    ,   0.1981330    ,   0.2081397    
     +,   0.2178798    ,   0.2272887    ,   0.2363066    
     +,   0.2448784    ,   0.2529564    ,   0.2604994    
     +,   0.2674740    ,   0.2738545    ,   0.2796226    
     +,   0.2847666    ,   0.2892826    ,   0.2931729    
     +,   0.2964451    ,   0.2991123    ,   0.3011917    
     +,   0.3027057    ,   0.3036791    ,   0.3041410    
     +,   0.3041225    ,   0.3036578    ,   0.3027832    
     +,   0.3015366    ,   0.2999577    ,   0.2980866    
     +,   0.2959639    ,   0.2936296    ,   0.2911215    
     +,   0.2884763    ,   0.2857262    ,   0.2829007    
     +,   0.2800233    ,   0.2771131    ,   0.2741840    
     +,   0.2712440    ,   0.2682967    ,   0.2653410    
     +,   0.2623731    ,   0.2593858    ,   0.2563727    
     +,   0.2533263    ,   0.2502414    ,   0.2471157    
     +,   0.2439502    ,   0.2407505    ,   0.2375266    
     +,   0.2342928    ,   0.2310676    ,   0.2278723    
     +,   0.2247307    ,   0.2216669    ,   0.2187053    
     +,   0.2158674    ,   0.2131719    ,   0.2106333    
     +,   0.2082617    ,   0.2060601    ,   0.2040266    
     +,   0.2021533    ,   0.2004269    ,   0.1988295    
     +,   0.1973390    ,   0.1959311    ,   0.1945797    
     +,   0.1932581    ,   0.1919406    ,   0.1906031    
     +,   0.1892239    ,   0.1877846    ,   0.1862707    
     +,   0.1846716    ,   0.1829804    ,   0.1811948    
     +,   0.1793158    ,   0.1773476    ,   0.1752977    
     +,   0.1731756    ,   0.1709924    ,   0.1687607    
     +,   0.1664940    ,   0.1642054    ,   0.1619087    
     +,   0.1596165    ,   0.1573408    ,   0.1550930    
     +,   0.1528831    ,   0.1507200    ,   0.1486113    
     +,   0.1465640    ,   0.1445830    ,   0.1426730    
     +,   0.1408371    ,   0.1390779    ,   0.1373964    
     +,   0.1357931    ,   0.1342679    ,   0.1328195    
     +,   0.1314458    ,   0.1301440    ,   0.1289107    
     +,   0.1277416    ,   0.1266316    ,   0.1255748    
     +,   0.1245651    ,   0.1235952    ,   0.1226578    
     +,   0.1217447    ,   0.1208475    ,   0.1199579    
     +,   0.1190670    ,   0.1181663    ,   0.1172472    
     +,   0.1163017    ,   0.1153221    ,   0.1143014    
     +,   0.1132334    ,   0.1121126    ,   0.1109345    
     +,   0.1096959    ,   0.1083941    ,   0.1070282    
     +,   0.1055980    ,   0.1041044    ,   0.1025495    
     +,   0.1009363    ,   9.9268913E-02,   9.7552106E-02
     +,   9.5791228E-02,   9.3992464E-02,   9.2162505E-02
     +,   9.0308242E-02,   8.8436946E-02,   8.6555876E-02
     +,   8.4672481E-02,   8.2794249E-02,   8.0928251E-02
     +,   7.9081401E-02,   7.7260703E-02,   7.5472452E-02
     +,   7.3722795E-02,   7.2017610E-02,   7.0362404E-02
     +,   6.8762362E-02,   6.7222312E-02,   6.5746970E-02
     +,   6.4340696E-02,   6.3007727E-02,   6.1751995E-02
     +,   6.0577516E-02,   5.9488051E-02,   5.8487367E-02
     +,   5.7579253E-02,   5.6767281E-02,   5.6055274E-02
     +,   5.5446796E-02,   5.4945633E-02,   5.4555383E-02
     +,   5.4279760E-02,   5.4122288E-02,   5.4086644E-02
     +,   5.4176264E-02,   5.4394614E-02,   5.4744970E-02
     +,   5.5230629E-02,   5.5854734E-02,   5.6620363E-02
     +,   5.7530623E-02,   5.8588572E-02,   5.9797339E-02
     +,   6.1160296E-02,   6.2680915E-02,   6.4362943E-02
     +,   6.6210814E-02,   6.8229370E-02,   7.0424154E-02
     +,   7.2801344E-02,   7.5368203E-02,   7.8132950E-02
     +,   8.1104688E-02,   8.4293470E-02,   8.7710641E-02
     +,   9.1368310E-02,   9.5278941E-02,   9.9455863E-02
     +,   0.1039124    ,   0.1086615    ,   0.1137150    
     +,   0.1190839    ,   0.1247772    ,   0.1308008    
     +,   0.1371574    ,   0.1438462    ,   0.1508620    
     +,   0.1581943    ,   0.1658271    ,   0.1737398    
     +,   0.1819061    ,   0.1902942    ,   0.1988681    
     +,   0.2075875    ,   0.2164083    ,   0.2252837    
     +,   0.2341665    ,   0.2430086    ,   0.2517615    
     +,   0.2603785    ,   0.2688157    ,   0.2770315    
     +,   0.2849880    ,   0.2926488    ,   0.2999834    
     +,   0.3069630    ,   0.3135608    ,   0.3197533    
     +,   0.3255183    ,   0.3308332    ,   0.3356762    
     +,   0.3400257    ,   0.3438587    ,   0.3471513    
     +,   0.3498789    ,   0.3520165    ,   0.3535395    
     +,   0.3544237    ,   0.3546465    ,   0.3541883    
     +,   0.3530329    ,   0.3511689    ,   0.3485909    
     +,   0.3452994    ,   0.3413020    ,   0.3366137    
     +,   0.3312571    ,   0.3252614    ,   0.3186635    
     +,   0.3115063    ,   0.3038372    ,   0.2957087    
     +,   0.2871765    ,   0.2782986    ,   0.2691333    
     +,   0.2597390    ,   0.2501732    ,   0.2404913    
     +,   0.2307457    ,   0.2209860    ,   0.2112580    
     +,   0.2016037    ,   0.1920602    ,   0.1826615    
     +,   0.1734378    ,   0.1644149    ,   0.1556149    
     +,   0.1470577    ,   0.1387595    ,   0.1307336    
     +,   0.1229908    ,   0.1155405    ,   0.1083887    
     +,   0.1015400    ,   9.4997235E-02,   8.8761911E-02
     +,   8.2833216E-02,   7.7208973E-02,   7.1886078E-02
     +,   6.6859886E-02,   6.2124386E-02,   5.7672359E-02
     +,   5.3496130E-02,   4.9586486E-02,   4.5934062E-02
     +,   4.2528275E-02,   3.9358545E-02,   3.6413442E-02
     +,   3.3681694E-02,   3.1151440E-02,   2.8811241E-02
     +,   2.6649291E-02,   2.4654251E-02,   2.2814831E-02
     +,   2.1120077E-02,   1.9559557E-02,   1.8123060E-02
     +,   1.6801002E-02,   1.5584167E-02,   1.4464012E-02
     +,   1.3432362E-02,   1.2481724E-02,   1.1605024E-02
     +,   1.0795835E-02,   1.0048140E-02,   9.3565239E-03
     +,   8.7159518E-03,   8.1219422E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_hzonly_hatt120_mass = Yx/12.0994925116279
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_hzonly_hatt60_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.4505486E-02,   3.6834672E-02
     +,   3.9226394E-02,   4.1673101E-02,   4.4166494E-02
     +,   4.6697684E-02,   4.9257249E-02,   5.1835518E-02
     +,   5.4422580E-02,   5.7008862E-02,   5.9584882E-02
     +,   6.2141776E-02,   6.4671464E-02,   6.7166701E-02
     +,   6.9621362E-02,   7.2030537E-02,   7.4390516E-02
     +,   7.6698788E-02,   7.8954019E-02,   8.1156015E-02
     +,   8.3305240E-02,   8.5403077E-02,   8.7450907E-02
     +,   8.9450635E-02,   9.1403484E-02,   9.3310483E-02
     +,   9.5171705E-02,   9.6986249E-02,   9.8751977E-02
     +,   0.1004655    ,   0.1021219    ,   0.1037153    
     +,   0.1052381    ,   0.1066820    ,   0.1080378    
     +,   0.1092956    ,   0.1104455    ,   0.1114775    
     +,   0.1123823    ,   0.1131512    ,   0.1137767    
     +,   0.1142526    ,   0.1145747    ,   0.1147401    
     +,   0.1147483    ,   0.1146006    ,   0.1143006    
     +,   0.1138537    ,   0.1132675    ,   0.1125510    
     +,   0.1117152    ,   0.1107723    ,   0.1097354    
     +,   0.1086185    ,   0.1074357    ,   0.1062014    
     +,   0.1049293    ,   0.1036323    ,   0.1023222    
     +,   0.1010093    ,   9.9702008E-02,   9.8406605E-02
     +,   9.7127296E-02,   9.5865943E-02,   9.4621889E-02
     +,   9.3392625E-02,   9.2173502E-02,   9.0958133E-02
     +,   8.9738868E-02,   8.8507183E-02,   8.7253854E-02
     +,   8.5970007E-02,   8.4647104E-02,   8.3277762E-02
     +,   8.1855848E-02,   8.0377072E-02,   7.8839295E-02
     +,   7.7242583E-02,   7.5589381E-02,   7.3884375E-02
     +,   7.2134681E-02,   7.0349269E-02,   6.8539128E-02
     +,   6.6716410E-02,   6.4894632E-02,   6.3087635E-02
     +,   6.1309680E-02,   5.9574630E-02,   5.7895906E-02
     +,   5.6285776E-02,   5.4755125E-02,   5.3313393E-02
     +,   5.1968165E-02,   5.0725032E-02,   4.9587570E-02
     +,   4.8557449E-02,   4.7634229E-02,   4.6815835E-02
     +,   4.6098333E-02,   4.5476500E-02,   4.4943754E-02
     +,   4.4492688E-02,   4.4115096E-02,   4.3802440E-02
     +,   4.3545984E-02,   4.3337066E-02,   4.3167442E-02
     +,   4.3029282E-02,   4.2915527E-02,   4.2819928E-02
     +,   4.2737078E-02,   4.2662669E-02,   4.2593304E-02
     +,   4.2526614E-02,   4.2461146E-02,   4.2396378E-02
     +,   4.2332541E-02,   4.2270582E-02,   4.2212009E-02
     +,   4.2158809E-02,   4.2113215E-02,   4.2077675E-02
     +,   4.2054791E-02,   4.2046998E-02,   4.2056587E-02
     +,   4.2085651E-02,   4.2135943E-02,   4.2208798E-02
     +,   4.2305179E-02,   4.2425498E-02,   4.2569790E-02
     +,   4.2737495E-02,   4.2927694E-02,   4.3139026E-02
     +,   4.3369699E-02,   4.3617547E-02,   4.3880239E-02
     +,   4.4155095E-02,   4.4439331E-02,   4.4730082E-02
     +,   4.5024421E-02,   4.5319494E-02,   4.5612615E-02
     +,   4.5901187E-02,   4.6182849E-02,   4.6455536E-02
     +,   4.6717532E-02,   4.6967443E-02,   4.7204219E-02
     +,   4.7427289E-02,   4.7636401E-02,   4.7831740E-02
     +,   4.8013855E-02,   4.8183754E-02,   4.8342705E-02
     +,   4.8492361E-02,   4.8634611E-02,   4.8771672E-02
     +,   4.8905887E-02,   4.9039830E-02,   4.9176168E-02
     +,   4.9317606E-02,   4.9466874E-02,   4.9626701E-02
     +,   4.9799666E-02,   4.9988262E-02,   5.0194778E-02
     +,   5.0421238E-02,   5.0669450E-02,   5.0940875E-02
     +,   5.1236629E-02,   5.1557403E-02,   5.1903538E-02
     +,   5.2274909E-02,   5.2670889E-02,   5.3090449E-02
     +,   5.3532045E-02,   5.3993661E-02,   5.4472789E-02
     +,   5.4966521E-02,   5.5471469E-02,   5.5983867E-02
     +,   5.6499623E-02,   5.7014205E-02,   5.7523012E-02
     +,   5.8021106E-02,   5.8503393E-02,   5.8964808E-02
     +,   5.9400275E-02,   5.9804689E-02,   6.0173217E-02
     +,   6.0501169E-02,   6.0784131E-02,   6.1018031E-02
     +,   6.1199222E-02,   6.1324462E-02,   6.1390992E-02
     +,   6.1396532E-02,   6.1339367E-02,   6.1218198E-02
     +,   6.1032359E-02,   6.0781613E-02,   6.0466241E-02
     +,   6.0086947E-02,   5.9644852E-02,   5.9141446E-02
     +,   5.8578514E-02,   5.7958234E-02,   5.7282917E-02
     +,   5.6555048E-02,   5.5777270E-02,   5.4952361E-02
     +,   5.4083146E-02,   5.3172398E-02,   5.2222993E-02
     +,   5.1237691E-02,   5.0219301E-02,   4.9170524E-02
     +,   4.8093937E-02,   4.6992201E-02,   4.5867804E-02
     +,   4.4723198E-02,   4.3560822E-02,   4.2383116E-02
     +,   4.1192394E-02,   3.9990947E-02,   3.8781166E-02
     +,   3.7565444E-02,   3.6346056E-02,   3.5125311E-02
     +,   3.3905640E-02,   3.2689411E-02,   3.1478990E-02
     +,   3.0276701E-02,   2.9084943E-02,   2.7906032E-02
     +,   2.6742186E-02,   2.5595669E-02,   2.4468662E-02
     +,   2.3363192E-02,   2.2281151E-02,   2.1224415E-02
     +,   2.0194681E-02,   1.9193444E-02,   1.8222047E-02
     +,   1.7281711E-02,   1.6373463E-02,   1.5498118E-02
     +,   1.4656273E-02,   1.3848443E-02,   1.3074864E-02
     +,   1.2335612E-02,   1.1630631E-02,   1.0959703E-02
     +,   1.0322407E-02,   9.7181955E-03,   9.1464259E-03
     +,   8.6063426E-03,   8.0970498E-03,   7.6175663E-03
     +,   7.1668713E-03,   6.7438842E-03,   6.3474420E-03
     +,   5.9763575E-03,   5.6294478E-03,   5.3054886E-03
     +,   5.0032493E-03,   4.7215326E-03,   4.4591487E-03
     +,   4.2149150E-03,   3.9876779E-03,   3.7763317E-03
     +,   3.5798082E-03,   3.3970673E-03,   3.2271156E-03
     +,   3.0690222E-03,   2.9218830E-03,   2.7848631E-03
     +,   2.6571583E-03,   2.5380324E-03,   2.4267805E-03
     +,   2.3227609E-03,   2.2253653E-03,   2.1340435E-03
     +,   2.0482761E-03,   1.9675964E-03,   1.8915702E-03
     +,   1.8197995E-03,   1.7519298E-03,   1.6876291E-03
     +,   1.6266054E-03,   1.5685870E-03,   1.5133354E-03
     +,   1.4606294E-03,   1.4102765E-03,   1.3620980E-03
     +,   1.3159388E-03,   1.2716549E-03,   1.2291230E-03
     +,   1.1882263E-03,   1.1488664E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_hzonly_hatt60_mass = Yx/3.672364
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_hzonly_hatt65_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.7084636E-02,   1.8645348E-02
     +,   2.0313568E-02,   2.2090081E-02,   2.3974808E-02
     +,   2.5966847E-02,   2.8064499E-02,   3.0265339E-02
     +,   3.2566357E-02,   3.4964174E-02,   3.7454985E-02
     +,   4.0034913E-02,   4.2700041E-02,   4.5446590E-02
     +,   4.8270956E-02,   5.1169764E-02,   5.4139830E-02
     +,   5.7178013E-02,   6.0281049E-02,   6.3445300E-02
     +,   6.6666313E-02,   6.9938563E-02,   7.3254898E-02
     +,   7.6606318E-02,   7.9981200E-02,   8.3365455E-02
     +,   8.6742066E-02,   9.0091005E-02,   9.3389474E-02
     +,   9.6612193E-02,   9.9732012E-02,   0.1027207    
     +,   0.1055495    ,   0.1081908    ,   0.1106186    
     +,   0.1128102    ,   0.1147467    ,   0.1164146    
     +,   0.1178060    ,   0.1189193    ,   0.1197593    
     +,   0.1203369    ,   0.1206689    ,   0.1207770    
     +,   0.1206869    ,   0.1204273    ,   0.1200283    
     +,   0.1195205    ,   0.1189335    ,   0.1182953    
     +,   0.1176309    ,   0.1169618    ,   0.1163060    
     +,   0.1156768    ,   0.1150838    ,   0.1145326    
     +,   0.1140247    ,   0.1135584    ,   0.1131288    
     +,   0.1127288    ,   0.1123486    ,   0.1119771    
     +,   0.1116019    ,   0.1112098    ,   0.1107875    
     +,   0.1103222    ,   0.1098018    ,   0.1092161    
     +,   0.1085568    ,   0.1078183    ,   0.1069979    
     +,   0.1060969    ,   0.1051198    ,   0.1040748    
     +,   0.1029740    ,   0.1018325    ,   0.1006679    
     +,   9.9500246E-02,   9.8350219E-02,   9.7238816E-02
     +,   9.6186452E-02,   9.5211349E-02,   9.4329223E-02
     +,   9.3552262E-02,   9.2888363E-02,   9.2340730E-02
     +,   9.1907851E-02,   9.1583095E-02,   9.1355279E-02
     +,   9.1208972E-02,   9.1125026E-02,   9.1081500E-02
     +,   9.1054626E-02,   9.1019593E-02,   9.0951607E-02
     +,   9.0827227E-02,   9.0624645E-02,   9.0325184E-02
     +,   8.9913413E-02,   8.9378074E-02,   8.8712201E-02
     +,   8.7913312E-02,   8.6983308E-02,   8.5928500E-02
     +,   8.4758691E-02,   8.3487116E-02,   8.2129665E-02
     +,   8.0704078E-02,   7.9229131E-02,   7.7724077E-02
     +,   7.6208018E-02,   7.4698664E-02,   7.3212601E-02
     +,   7.1764097E-02,   7.0365451E-02,   6.9026172E-02
     +,   6.7753583E-02,   6.6552229E-02,   6.5424606E-02
     +,   6.4371198E-02,   6.3390739E-02,   6.2480826E-02
     +,   6.1638221E-02,   6.0859226E-02,   6.0139976E-02
     +,   5.9477113E-02,   5.8867708E-02,   5.8309656E-02
     +,   5.7801813E-02,   5.7343934E-02,   5.6936737E-02
     +,   5.6581777E-02,   5.6281295E-02,   5.6038018E-02
     +,   5.5854827E-02,   5.5734552E-02,   5.5679619E-02
     +,   5.5691842E-02,   5.5772133E-02,   5.5920169E-02
     +,   5.6134429E-02,   5.6411825E-02,   5.6747843E-02
     +,   5.7136465E-02,   5.7570163E-02,   5.8040135E-02
     +,   5.8536500E-02,   5.9048448E-02,   5.9564557E-02
     +,   6.0073137E-02,   6.0562510E-02,   6.1021280E-02
     +,   6.1438780E-02,   6.1805241E-02,   6.2112119E-02
     +,   6.2352259E-02,   6.2520057E-02,   6.2611662E-02
     +,   6.2624924E-02,   6.2559478E-02,   6.2416602E-02
     +,   6.2199119E-02,   6.1911386E-02,   6.1558921E-02
     +,   6.1148267E-02,   6.0686775E-02,   6.0182270E-02
     +,   5.9642978E-02,   5.9077017E-02,   5.8492366E-02
     +,   5.7896640E-02,   5.7296846E-02,   5.6699235E-02
     +,   5.6109224E-02,   5.5531312E-02,   5.4969020E-02
     +,   5.4424871E-02,   5.3900458E-02,   5.3396463E-02
     +,   5.2912716E-02,   5.2448284E-02,   5.2001629E-02
     +,   5.1570676E-02,   5.1152993E-02,   5.0745726E-02
     +,   5.0346069E-02,   4.9951017E-02,   4.9557589E-02
     +,   4.9163006E-02,   4.8764706E-02,   4.8360262E-02
     +,   4.7947600E-02,   4.7525022E-02,   4.7091048E-02
     +,   4.6644587E-02,   4.6184812E-02,   4.5711230E-02
     +,   4.5223586E-02,   4.4721846E-02,   4.4206128E-02
     +,   4.3676723E-02,   4.3134023E-02,   4.2578496E-02
     +,   4.2010549E-02,   4.1430734E-02,   4.0839475E-02
     +,   4.0237136E-02,   3.9624088E-02,   3.9000656E-02
     +,   3.8366985E-02,   3.7723232E-02,   3.7069488E-02
     +,   3.6405828E-02,   3.5732277E-02,   3.5048809E-02
     +,   3.4355473E-02,   3.3652365E-02,   3.2939564E-02
     +,   3.2217257E-02,   3.1485744E-02,   3.0745398E-02
     +,   2.9996678E-02,   2.9240211E-02,   2.8476773E-02
     +,   2.7707171E-02,   2.6932381E-02,   2.6153492E-02
     +,   2.5371732E-02,   2.4588341E-02,   2.3804644E-02
     +,   2.3022067E-02,   2.2242077E-02,   2.1466102E-02
     +,   2.0695578E-02,   1.9931998E-02,   1.9176740E-02
     +,   1.8431135E-02,   1.7696492E-02,   1.6974064E-02
     +,   1.6264934E-02,   1.5570129E-02,   1.4890596E-02
     +,   1.4227178E-02,   1.3580586E-02,   1.2951399E-02
     +,   1.2340160E-02,   1.1747291E-02,   1.1173081E-02
     +,   1.0617726E-02,   1.0081396E-02,   9.5641194E-03
     +,   9.0658534E-03,   8.5865259E-03,   8.1259962E-03
     +,   7.6840408E-03,   7.2603901E-03,   6.8547619E-03
     +,   6.4668353E-03,   6.0962299E-03,   5.7425434E-03
     +,   5.4053748E-03,   5.0842981E-03,   4.7788550E-03
     +,   4.4885757E-03,   4.2130104E-03,   3.9516687E-03
     +,   3.7040608E-03,   3.4697102E-03,   3.2481363E-03
     +,   3.0388439E-03,   2.8413406E-03,   2.6551499E-03
     +,   2.4797991E-03,   2.3148065E-03,   2.1597000E-03
     +,   2.0140291E-03,   1.8773323E-03,   1.7491749E-03
     +,   1.6291153E-03,   1.5167391E-03,   1.4116282E-03
     +,   1.3133904E-03,   1.2216329E-03,   1.1359901E-03
     +,   1.0560963E-03,   9.8161190E-04,   9.1220374E-04
     +,   8.4755296E-04,   7.8736211E-04,   7.3133985E-04
     +,   6.7921693E-04,   6.3073175E-04,   5.8564276E-04
     +,   5.4371625E-04,   5.0473813E-04,   4.6850144E-04
     +,   4.3481746E-04,   4.0350470E-04,   3.7439782E-04
     +,   3.4733870E-04,   3.2218345E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_hzonly_hatt65_mass = Yx/3.8958992
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_hzonly_hatt70_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.4930236E-02,   1.5957847E-02
     +,   1.7040944E-02,   1.8181663E-02,   1.9382147E-02
     +,   2.0644443E-02,   2.1970510E-02,   2.3362165E-02
     +,   2.4821008E-02,   2.6348442E-02,   2.7945492E-02
     +,   2.9612860E-02,   3.1350788E-02,   3.3159047E-02
     +,   3.5036922E-02,   3.6983140E-02,   3.8995836E-02
     +,   4.1072659E-02,   4.3210678E-02,   4.5406558E-02
     +,   4.7656536E-02,   4.9956590E-02,   5.2302480E-02
     +,   5.4690130E-02,   5.7115272E-02,   5.9574161E-02
     +,   6.2063392E-02,   6.4580068E-02,   6.7122027E-02
     +,   6.9687866E-02,   7.2277062E-02,   7.4890047E-02
     +,   7.7528201E-02,   8.0193967E-02,   8.2890667E-02
     +,   8.5622557E-02,   8.8394828E-02,   9.1213167E-02
     +,   9.4084285E-02,   9.7014576E-02,   0.1000112    
     +,   0.1030808    ,   0.1062296    ,   0.1094634    
     +,   0.1127864    ,   0.1162018    ,   0.1197106    
     +,   0.1233120    ,   0.1270030    ,   0.1307776    
     +,   0.1346273    ,   0.1385408    ,   0.1425035    
     +,   0.1464981    ,   0.1505037    ,   0.1544966    
     +,   0.1584496    ,   0.1623323    ,   0.1661115    
     +,   0.1697507    ,   0.1732111    ,   0.1764515    
     +,   0.1794289    ,   0.1820999    ,   0.1844211    
     +,   0.1863505    ,   0.1878487    ,   0.1888798    
     +,   0.1894138    ,   0.1894264    ,   0.1889008    
     +,   0.1878281    ,   0.1862080    ,   0.1840485    
     +,   0.1813659    ,   0.1781837    ,   0.1745331    
     +,   0.1704510    ,   0.1659794    ,   0.1611646    
     +,   0.1560563    ,   0.1507068    ,   0.1451707    
     +,   0.1395032    ,   0.1337616    ,   0.1280023    
     +,   0.1222825    ,   0.1166575    ,   0.1111817    
     +,   0.1059063    ,   0.1008785    ,   9.6141353E-02
     +,   9.1731966E-02,   8.7680295E-02,   8.4008880E-02
     +,   8.0732547E-02,   7.7857204E-02,   7.5380921E-02
     +,   7.3293306E-02,   7.1577013E-02,   7.0207760E-02
     +,   6.9156200E-02,   6.8388328E-02,   6.7867428E-02
     +,   6.7554913E-02,   6.7411803E-02,   6.7399733E-02
     +,   6.7482032E-02,   6.7624435E-02,   6.7795895E-02
     +,   6.7969099E-02,   6.8120591E-02,   6.8231091E-02
     +,   6.8285383E-02,   6.8272315E-02,   6.8184473E-02
     +,   6.8017796E-02,   6.7771368E-02,   6.7446843E-02
     +,   6.7048058E-02,   6.6580571E-02,   6.6051252E-02
     +,   6.5467864E-02,   6.4838670E-02,   6.4172126E-02
     +,   6.3476659E-02,   6.2760301E-02,   6.2030699E-02
     +,   6.1294816E-02,   6.0559023E-02,   5.9828803E-02
     +,   5.9109088E-02,   5.8403812E-02,   5.7716440E-02
     +,   5.7049554E-02,   5.6405254E-02,   5.5784985E-02
     +,   5.5189788E-02,   5.4620184E-02,   5.4076355E-02
     +,   5.3558193E-02,   5.3065386E-02,   5.2597415E-02
     +,   5.2153658E-02,   5.1733512E-02,   5.1336329E-02
     +,   5.0961595E-02,   5.0608963E-02,   5.0278146E-02
     +,   4.9969159E-02,   4.9682196E-02,   4.9417753E-02
     +,   4.9176440E-02,   4.8959248E-02,   4.8767183E-02
     +,   4.8601516E-02,   4.8463617E-02,   4.8354756E-02
     +,   4.8276316E-02,   4.8229426E-02,   4.8215110E-02
     +,   4.8234079E-02,   4.8286684E-02,   4.8372850E-02
     +,   4.8492126E-02,   4.8643462E-02,   4.8825245E-02
     +,   4.9035404E-02,   4.9271293E-02,   4.9529716E-02
     +,   4.9807038E-02,   5.0099220E-02,   5.0401825E-02
     +,   5.0710272E-02,   5.1019695E-02,   5.1325321E-02
     +,   5.1622409E-02,   5.1906392E-02,   5.2173018E-02
     +,   5.2418537E-02,   5.2639652E-02,   5.2833710E-02
     +,   5.2998718E-02,   5.3133532E-02,   5.3237647E-02
     +,   5.3311441E-02,   5.3356063E-02,   5.3373374E-02
     +,   5.3365927E-02,   5.3336855E-02,   5.3289749E-02
     +,   5.3228609E-02,   5.3157598E-02,   5.3081006E-02
     +,   5.3002939E-02,   5.2927356E-02,   5.2857738E-02
     +,   5.2797046E-02,   5.2747607E-02,   5.2710876E-02
     +,   5.2687481E-02,   5.2677125E-02,   5.2678436E-02
     +,   5.2689139E-02,   5.2705944E-02,   5.2724656E-02
     +,   5.2740220E-02,   5.2746855E-02,   5.2738126E-02
     +,   5.2707177E-02,   5.2646793E-02,   5.2549705E-02
     +,   5.2408550E-02,   5.2216269E-02,   5.1966157E-02
     +,   5.1652037E-02,   5.1268458E-02,   5.0810762E-02
     +,   5.0275199E-02,   4.9659129E-02,   4.8960857E-02
     +,   4.8179898E-02,   4.7316827E-02,   4.6373468E-02
     +,   4.5352548E-02,   4.4257857E-02,   4.3094154E-02
     +,   4.1867055E-02,   4.0582817E-02,   3.9248250E-02
     +,   3.7870783E-02,   3.6458135E-02,   3.5018135E-02
     +,   3.3558704E-02,   3.2087848E-02,   3.0613258E-02
     +,   2.9142352E-02,   2.7682254E-02,   2.6239693E-02
     +,   2.4820739E-02,   2.3430940E-02,   2.2075307E-02
     +,   2.0758240E-02,   1.9483417E-02,   1.8253881E-02
     +,   1.7072164E-02,   1.5940165E-02,   1.4859166E-02
     +,   1.3829925E-02,   1.2852816E-02,   1.1927669E-02
     +,   1.1053932E-02,   1.0230770E-02,   9.4570555E-03
     +,   8.7313484E-03,   8.0520213E-03,   7.4173436E-03
     +,   6.8254401E-03,   6.2743281E-03,   5.7619703E-03
     +,   5.2863471E-03,   4.8454320E-03,   4.4371914E-03
     +,   4.0596379E-03,   3.7108711E-03,   3.3890209E-03
     +,   3.0922934E-03,   2.8189919E-03,   2.5675024E-03
     +,   2.3362786E-03,   2.1238606E-03,   1.9288907E-03
     +,   1.7500910E-03,   1.5862528E-03,   1.4362477E-03
     +,   1.2990360E-03,   1.1736304E-03,   1.0591282E-03
     +,   9.5467432E-04,   8.5948763E-04,   7.7282923E-04
     +,   6.9402455E-04,   6.2243722E-04,   5.5748550E-04
     +,   4.9862161E-04,   4.4534501E-04,   3.9718626E-04
     +,   3.5371064E-04,   3.1451989E-04,   2.7923984E-04
     +,   2.4752930E-04,   2.1906836E-04,   1.9356553E-04
     +,   1.7074826E-04,   1.5036858E-04,   1.3219517E-04
     +,   1.1601798E-04,   1.0164181E-04,   8.8889603E-05
     +,   7.7597535E-05,   6.7617395E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_hzonly_hatt70_mass = Yx/4.28442466666667
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_hzonly_hatt75_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  8.9965044E-03,   9.6366070E-03
     +,   1.0305843E-02,   1.1003821E-02,   1.1730087E-02
     +,   1.2484191E-02,   1.3265749E-02,   1.4074480E-02
     +,   1.4910292E-02,   1.5773393E-02,   1.6664283E-02
     +,   1.7583877E-02,   1.8533578E-02,   1.9515313E-02
     +,   2.0531612E-02,   2.1585654E-02,   2.2681300E-02
     +,   2.3823189E-02,   2.5016736E-02,   2.6268244E-02
     +,   2.7584950E-02,   2.8975116E-02,   3.0448098E-02
     +,   3.2014575E-02,   3.3686321E-02,   3.5476573E-02
     +,   3.7399750E-02,   3.9471298E-02,   4.1707527E-02
     +,   4.4124871E-02,   4.6739388E-02,   4.9565703E-02
     +,   5.2615989E-02,   5.5898663E-02,   5.9417251E-02
     +,   6.3169107E-02,   6.7144625E-02,   7.1326531E-02
     +,   7.5690217E-02,   8.0203906E-02,   8.4830746E-02
     +,   8.9530289E-02,   9.4261400E-02,   9.8985642E-02
     +,   0.1036701    ,   0.1082912    ,   0.1128368    
     +,   0.1173084    ,   0.1217218    ,   0.1261062    
     +,   0.1305020    ,   0.1349565    ,   0.1395186    
     +,   0.1442325    ,   0.1491300    ,   0.1542252    
     +,   0.1595087    ,   0.1649463    ,   0.1704801    
     +,   0.1760348    ,   0.1815284    ,   0.1868862    
     +,   0.1920560    ,   0.1970254    ,   0.2018343    
     +,   0.2065808    ,   0.2114221    ,   0.2165620    
     +,   0.2222313    ,   0.2286561    ,   0.2360242    
     +,   0.2444451    ,   0.2539185    ,   0.2643088    
     +,   0.2753390    ,   0.2866025    ,   0.2975938    
     +,   0.3077614    ,   0.3165715    ,   0.3235714    
     +,   0.3284473    ,   0.3310637    ,   0.3314738    
     +,   0.3299026    ,   0.3267059    ,   0.3223080    
     +,   0.3171375    ,   0.3115642    ,   0.3058572    
     +,   0.3001604    ,   0.2944946    ,   0.2887802    
     +,   0.2828709    ,   0.2765958    ,   0.2697983    
     +,   0.2623658    ,   0.2542482    ,   0.2454633    
     +,   0.2360916    ,   0.2262631    ,   0.2161385    
     +,   0.2058927    ,   0.1956954    ,   0.1857028    
     +,   0.1760450    ,   0.1668265    ,   0.1581241    
     +,   0.1499909    ,   0.1424591    ,   0.1355456    
     +,   0.1292565    ,   0.1235890    ,   0.1185364    
     +,   0.1140879    ,   0.1102308    ,   0.1069501    
     +,   0.1042287    ,   0.1020463    ,   0.1003786    
     +,   9.9195942E-02,   9.8462105E-02,   9.8133281E-02
     +,   9.8157138E-02,   9.8473050E-02,   9.9012733E-02
     +,   9.9701352E-02,   0.1004601    ,   0.1012087    
     +,   0.1018685    ,   0.1023657    ,   0.1026353    
     +,   0.1026222    ,   0.1022846    ,   0.1015947    
     +,   0.1005393    ,   9.9118985E-02,   9.7347520E-02
     +,   9.5249750E-02,   9.2859484E-02,   9.0216920E-02
     +,   8.7366641E-02,   8.4354982E-02,   8.1227556E-02
     +,   7.8027964E-02,   7.4796505E-02,   7.1568668E-02
     +,   6.8374716E-02,   6.5239884E-02,   6.2184073E-02
     +,   5.9222091E-02,   5.6364227E-02,   5.3617354E-02
     +,   5.0985005E-02,   4.8468314E-02,   4.6066634E-02
     +,   4.3778323E-02,   4.1601181E-02,   3.9532676E-02
     +,   3.7570413E-02,   3.5712603E-02,   3.3957716E-02
     +,   3.2304805E-02,   3.0753579E-02,   2.9304132E-02
     +,   2.7956823E-02,   2.6712188E-02,   2.5570879E-02
     +,   2.4533436E-02,   2.3600010E-02,   2.2770435E-02
     +,   2.2044070E-02,   2.1419726E-02,   2.0895546E-02
     +,   2.0469086E-02,   2.0137308E-02,   1.9896567E-02
     +,   1.9742709E-02,   1.9671109E-02,   1.9676760E-02
     +,   1.9754378E-02,   1.9898426E-02,   2.0103224E-02
     +,   2.0363037E-02,   2.0672141E-02,   2.1024870E-02
     +,   2.1415656E-02,   2.1839069E-02,   2.2289878E-02
     +,   2.2763057E-02,   2.3253741E-02,   2.3757329E-02
     +,   2.4269432E-02,   2.4785805E-02,   2.5302444E-02
     +,   2.5815532E-02,   2.6321441E-02,   2.6816683E-02
     +,   2.7297912E-02,   2.7761977E-02,   2.8205847E-02
     +,   2.8626643E-02,   2.9021598E-02,   2.9388135E-02
     +,   2.9723814E-02,   3.0026317E-02,   3.0293539E-02
     +,   3.0523546E-02,   3.0714545E-02,   3.0864997E-02
     +,   3.0973531E-02,   3.1039055E-02,   3.1060647E-02
     +,   3.1037655E-02,   3.0969679E-02,   3.0856565E-02
     +,   3.0698413E-02,   3.0495606E-02,   3.0248731E-02
     +,   2.9958658E-02,   2.9626522E-02,   2.9253647E-02
     +,   2.8841570E-02,   2.8392097E-02,   2.7907180E-02
     +,   2.7388953E-02,   2.6839675E-02,   2.6261749E-02
     +,   2.5657738E-02,   2.5030222E-02,   2.4381839E-02
     +,   2.3715317E-02,   2.3033392E-02,   2.2338765E-02
     +,   2.1634098E-02,   2.0922082E-02,   2.0205272E-02
     +,   1.9486137E-02,   1.8767109E-02,   1.8050494E-02
     +,   1.7338444E-02,   1.6632969E-02,   1.5936000E-02
     +,   1.5249309E-02,   1.4574477E-02,   1.3912942E-02
     +,   1.3266025E-02,   1.2634891E-02,   1.2020526E-02
     +,   1.1423757E-02,   1.0845344E-02,   1.0285825E-02
     +,   9.7456416E-03,   9.2251161E-03,   8.7244743E-03
     +,   8.2437852E-03,   7.7830292E-03,   7.3421183E-03
     +,   6.9208774E-03,   6.5190308E-03,   6.1362325E-03
     +,   5.7721040E-03,   5.4262122E-03,   5.0980560E-03
     +,   4.7870986E-03,   4.4928007E-03,   4.2145709E-03
     +,   3.9517987E-03,   3.7038790E-03,   3.4701971E-03
     +,   3.2501207E-03,   3.0430164E-03,   2.8482755E-03
     +,   2.6652892E-03,   2.4934525E-03,   2.3321740E-03
     +,   2.1808918E-03,   2.0390432E-03,   1.9061033E-03
     +,   1.7815500E-03,   1.6648965E-03,   1.5556647E-03
     +,   1.4534115E-03,   1.3577020E-03,   1.2681365E-03
     +,   1.1843253E-03,   1.1059102E-03,   1.0325458E-03
     +,   9.6390804E-04,   8.9969812E-04,   8.3962723E-04
     +,   7.8343297E-04,   7.3086185E-04,   6.8168400E-04
     +,   6.3567696E-04,   5.9264025E-04,   5.5238005E-04
     +,   5.1472138E-04,   4.7949509E-04,   4.4654874E-04
     +,   4.1573503E-04,   3.8692087E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_hzonly_hatt75_mass = Yx/5.37692778378378
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_hzonly_hatt80_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  5.3400607E-03,   5.5885543E-03
     +,   5.8499482E-03,   6.1250511E-03,   6.4147259E-03
     +,   6.7198933E-03,   7.0415274E-03,   7.3806704E-03
     +,   7.7384198E-03,   8.1159445E-03,   8.5144630E-03
     +,   8.9352597E-03,   9.3796644E-03,   9.8490724E-03
     +,   1.0344915E-02,   1.0868673E-02,   1.1421856E-02
     +,   1.2006028E-02,   1.2622762E-02,   1.3273683E-02
     +,   1.3960453E-02,   1.4684784E-02,   1.5448430E-02
     +,   1.6253285E-02,   1.7101249E-02,   1.7994449E-02
     +,   1.8935103E-02,   1.9925624E-02,   2.0968648E-02
     +,   2.2067025E-02,   2.3223860E-02,   2.4442500E-02
     +,   2.5726534E-02,   2.7079770E-02,   2.8506216E-02
     +,   3.0010007E-02,   3.1595383E-02,   3.3266559E-02
     +,   3.5027795E-02,   3.6883045E-02,   3.8836244E-02
     +,   4.0890913E-02,   4.3050218E-02,   4.5316957E-02
     +,   4.7693286E-02,   5.0180845E-02,   5.2780442E-02
     +,   5.5492129E-02,   5.8314875E-02,   6.1246507E-02
     +,   6.4283602E-02,   6.7421190E-02,   7.0652917E-02
     +,   7.3971212E-02,   7.7366926E-02,   8.0830790E-02
     +,   8.4353499E-02,   8.7927289E-02,   9.1547154E-02
     +,   9.5213003E-02,   9.8931052E-02,   0.1027159    
     +,   0.1065910    ,   0.1105899    ,   0.1147541    
     +,   0.1191308    ,   0.1237686    ,   0.1287110    
     +,   0.1339914    ,   0.1396250    ,   0.1456057    
     +,   0.1519025    ,   0.1584623    ,   0.1652138    
     +,   0.1720789    ,   0.1789828    ,   0.1858665    
     +,   0.1926976    ,   0.1994779    ,   0.2062451    
     +,   0.2130698    ,   0.2200503    ,   0.2273020    
     +,   0.2349514    ,   0.2431257    ,   0.2519492    
     +,   0.2615339    ,   0.2719727    ,   0.2833260    
     +,   0.2956079    ,   0.3087729    ,   0.3227048    
     +,   0.3372214    ,   0.3520961    ,   0.3671011    
     +,   0.3820658    ,   0.3969511    ,   0.4119054    
     +,   0.4272899    ,   0.4436376    ,   0.4615503    
     +,   0.4815237    ,   0.5037693    ,   0.5280471    
     +,   0.5535926    ,   0.5791448    ,   0.6030781    
     +,   0.6236108    ,   0.6390500    ,   0.6480207    
     +,   0.6496466    ,   0.6436697    ,   0.6304756    
     +,   0.6110301    ,   0.5867247    ,   0.5591603    
     +,   0.5299110    ,   0.5003069    ,   0.4713042    
     +,   0.4434333    ,   0.4168476    ,   0.3914327    
     +,   0.3669376    ,   0.3430935    ,   0.3197049    
     +,   0.2966973    ,   0.2741194    ,   0.2521276    
     +,   0.2309428    ,   0.2108135    ,   0.1919715    
     +,   0.1746065    ,   0.1588443    ,   0.1447439    
     +,   0.1322965    ,   0.1214365    ,   0.1120547    
     +,   0.1040112    ,   9.7148091E-02,   9.1301285E-02
     +,   8.6310521E-02,   8.2025781E-02,   7.8312136E-02
     +,   7.5053304E-02,   7.2153069E-02,   6.9534563E-02
     +,   6.7139208E-02,   6.4924628E-02,   6.2862083E-02
     +,   6.0933530E-02,   5.9129253E-02,   5.7445586E-02
     +,   5.5882957E-02,   5.4443773E-02,   5.3131692E-02
     +,   5.1950403E-02,   5.0902847E-02,   4.9990740E-02
     +,   4.9214259E-02,   4.8572004E-02,   4.8060820E-02
     +,   4.7675896E-02,   4.7410924E-02,   4.7258284E-02
     +,   4.7209140E-02,   4.7253840E-02,   4.7382046E-02
     +,   4.7582932E-02,   4.7845550E-02,   4.8158858E-02
     +,   4.8511982E-02,   4.8894357E-02,   4.9295954E-02
     +,   4.9707226E-02,   5.0119214E-02,   5.0523747E-02
     +,   5.0913308E-02,   5.1281132E-02,   5.1621158E-02
     +,   5.1927999E-02,   5.2197009E-02,   5.2424088E-02
     +,   5.2605722E-02,   5.2738979E-02,   5.2821450E-02
     +,   5.2851111E-02,   5.2826460E-02,   5.2746441E-02
     +,   5.2610360E-02,   5.2417967E-02,   5.2169502E-02
     +,   5.1865529E-02,   5.1507138E-02,   5.1095825E-02
     +,   5.0633572E-02,   5.0122723E-02,   4.9566112E-02
     +,   4.8966970E-02,   4.8328806E-02,   4.7655441E-02
     +,   4.6950977E-02,   4.6219684E-02,   4.5465838E-02
     +,   4.4693731E-02,   4.3907594E-02,   4.3111466E-02
     +,   4.2309064E-02,   4.1503858E-02,   4.0698934E-02
     +,   3.9896861E-02,   3.9099723E-02,   3.8309179E-02
     +,   3.7526403E-02,   3.6752004E-02,   3.5986155E-02
     +,   3.5228673E-02,   3.4478955E-02,   3.3736128E-02
     +,   3.2999013E-02,   3.2266360E-02,   3.1536780E-02
     +,   3.0808842E-02,   3.0081177E-02,   2.9352576E-02
     +,   2.8621882E-02,   2.7888186E-02,   2.7150847E-02
     +,   2.6409475E-02,   2.5663927E-02,   2.4914334E-02
     +,   2.4161156E-02,   2.3405125E-02,   2.2647165E-02
     +,   2.1888418E-02,   2.1130299E-02,   2.0374300E-02
     +,   1.9622043E-02,   1.8875280E-02,   1.8135812E-02
     +,   1.7405398E-02,   1.6685775E-02,   1.5978692E-02
     +,   1.5285788E-02,   1.4608574E-02,   1.3948426E-02
     +,   1.3306624E-02,   1.2684290E-02,   1.2082351E-02
     +,   1.1501563E-02,   1.0942562E-02,   1.0405774E-02
     +,   9.8914569E-03,   9.3997512E-03,   8.9306450E-03
     +,   8.4839640E-03,   8.0594020E-03,   7.6565826E-03
     +,   7.2750142E-03,   6.9141001E-03,   6.5731728E-03
     +,   6.2515284E-03,   5.9484076E-03,   5.6629996E-03
     +,   5.3944681E-03,   5.1419879E-03,   4.9047060E-03
     +,   4.6817674E-03,   4.4723446E-03,   4.2756270E-03
     +,   4.0908107E-03,   3.9171181E-03,   3.7538169E-03
     +,   3.6002041E-03,   3.4556016E-03,   3.3193706E-03
     +,   3.1909195E-03,   3.0696790E-03,   2.9551340E-03
     +,   2.8467905E-03,   2.7442048E-03,   2.6469519E-03
     +,   2.5546562E-03,   2.4669576E-03,   2.3835402E-03
     +,   2.3041035E-03,   2.2283839E-03,   2.1561324E-03
     +,   2.0871256E-03,   2.0211639E-03,   1.9580589E-03
     +,   1.8976462E-03,   1.8397701E-03,   1.7842946E-03
     +,   1.7310894E-03,   1.6800415E-03,   1.6310407E-03
     +,   1.5839926E-03,   1.5388032E-03,   1.4953910E-03
     +,   1.4536757E-03,   1.4135857E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_hzonly_hatt80_mass = Yx/7.4325454
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_hzonly_hatt85_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  7.1118902E-03,   7.4798344E-03
     +,   7.8544859E-03,   8.2348436E-03,   8.6198421E-03
     +,   9.0083517E-03,   9.3991924E-03,   9.7911386E-03
     +,   1.0182926E-02,   1.0573292E-02,   1.0960939E-02
     +,   1.1344579E-02,   1.1722938E-02,   1.2094768E-02
     +,   1.2458861E-02,   1.2814058E-02,   1.3159266E-02
     +,   1.3493458E-02,   1.3815698E-02,   1.4125139E-02
     +,   1.4421034E-02,   1.4702749E-02,   1.4969749E-02
     +,   1.5221652E-02,   1.5458146E-02,   1.5679087E-02
     +,   1.5884424E-02,   1.6074244E-02,   1.6248744E-02
     +,   1.6408240E-02,   1.6553162E-02,   1.6684044E-02
     +,   1.6801525E-02,   1.6906347E-02,   1.6999329E-02
     +,   1.7081397E-02,   1.7153544E-02,   1.7216865E-02
     +,   1.7272513E-02,   1.7321743E-02,   1.7365864E-02
     +,   1.7406289E-02,   1.7444486E-02,   1.7482031E-02
     +,   1.7520571E-02,   1.7561845E-02,   1.7607678E-02
     +,   1.7659990E-02,   1.7720772E-02,   1.7792121E-02
     +,   1.7876197E-02,   1.7975235E-02,   1.8091541E-02
     +,   1.8227488E-02,   1.8385487E-02,   1.8568011E-02
     +,   1.8777596E-02,   1.9016830E-02,   1.9288380E-02
     +,   1.9595020E-02,   1.9939654E-02,   2.0325387E-02
     +,   2.0755533E-02,   2.1233778E-02,   2.1764211E-02
     +,   2.2351360E-02,   2.3000471E-02,   2.3717433E-02
     +,   2.4509121E-02,   2.5383260E-02,   2.6348883E-02
     +,   2.7416099E-02,   2.8596511E-02,   2.9903030E-02
     +,   3.1350080E-02,   3.2953676E-02,   3.4731142E-02
     +,   3.6701273E-02,   3.8884431E-02,   4.1302409E-02
     +,   4.3978188E-02,   4.6936423E-02,   5.0202645E-02
     +,   5.3803843E-02,   5.7766911E-02,   6.2118936E-02
     +,   6.6884764E-02,   7.2086811E-02,   7.7742316E-02
     +,   8.3863512E-02,   9.0457097E-02,   9.7525224E-02
     +,   0.1050690    ,   0.1130939    ,   0.1216158    
     +,   0.1306655    ,   0.1402952    ,   0.1505773    
     +,   0.1616047    ,   0.1734804    ,   0.1863119    
     +,   0.2001963    ,   0.2152117    ,   0.2314032    
     +,   0.2487737    ,   0.2672700    ,   0.2867693    
     +,   0.3070733    ,   0.3279127    ,   0.3489672    
     +,   0.3699055    ,   0.3904448    ,   0.4104014    
     +,   0.4297334    ,   0.4485441    ,   0.4670613    
     +,   0.4855808    ,   0.5044299    ,   0.5239540    
     +,   0.5445790    ,   0.5669363    ,   0.5919812    
     +,   0.6209685    ,   0.6551167    ,   0.6948919    
     +,   0.7391176    ,   0.7843917    ,   0.8253376    
     +,   0.8559328    ,   0.8715099    ,   0.8705530    
     +,   0.8553621    ,   0.8312390    ,   0.8046141    
     +,   0.7809594    ,   0.7633525    ,   0.7520339    
     +,   0.7448544    ,   0.7382729    ,   0.7285181    
     +,   0.7126286    ,   0.6891390    ,   0.6582892    
     +,   0.6217265    ,   0.5818662    ,   0.5411399    
     +,   0.5014237    ,   0.4637812    ,   0.4285260    
     +,   0.3954871    ,   0.3643245    ,   0.3347652    
     +,   0.3067068    ,   0.2802083    ,   0.2554226    
     +,   0.2325133    ,   0.2115915    ,   0.1926836    
     +,   0.1757338    ,   0.1606274    ,   0.1472143    
     +,   0.1353401    ,   0.1248667    ,   0.1156817    
     +,   0.1076987    ,   0.1008521    ,   9.5087692E-02
     +,   9.0352044E-02,   8.6584777E-02,   8.3714552E-02
     +,   8.1658177E-02,   8.0321319E-02,   7.9602130E-02
     +,   7.9394467E-02,   7.9591915E-02,   8.0090836E-02
     +,   8.0793262E-02,   8.1609219E-02,   8.2458325E-02
     +,   8.3271176E-02,   8.3990358E-02,   8.4570393E-02
     +,   8.4977835E-02,   8.5190773E-02,   8.5197590E-02
     +,   8.4995724E-02,   8.4590293E-02,   8.3992183E-02
     +,   8.3216399E-02,   8.2280584E-02,   8.1203453E-02
     +,   8.0003448E-02,   7.8698151E-02,   7.7303149E-02
     +,   7.5831927E-02,   7.4295513E-02,   7.2702661E-02
     +,   7.1060278E-02,   6.9373265E-02,   6.7645371E-02
     +,   6.5879554E-02,   6.4078562E-02,   6.2244918E-02
     +,   6.0381543E-02,   5.8492154E-02,   5.6581087E-02
     +,   5.4653265E-02,   5.2714631E-02,   5.0771698E-02
     +,   4.8831332E-02,   4.6900697E-02,   4.4987090E-02
     +,   4.3097738E-02,   4.1239407E-02,   3.9418295E-02
     +,   3.7640151E-02,   3.5909928E-02,   3.4231674E-02
     +,   3.2608621E-02,   3.1043308E-02,   2.9537311E-02
     +,   2.8091481E-02,   2.6706073E-02,   2.5380755E-02
     +,   2.4114594E-02,   2.2906255E-02,   2.1754129E-02
     +,   2.0656388E-02,   1.9610943E-02,   1.8615583E-02
     +,   1.7668154E-02,   1.6766464E-02,   1.5908321E-02
     +,   1.5091585E-02,   1.4314309E-02,   1.3574556E-02
     +,   1.2870523E-02,   1.2200559E-02,   1.1563142E-02
     +,   1.0956819E-02,   1.0380251E-02,   9.8322434E-03
     +,   9.3116788E-03,   8.8174930E-03,   8.3486950E-03
     +,   7.9043806E-03,   7.4836961E-03,   7.0857988E-03
     +,   6.7098700E-03,   6.3551608E-03,   6.0209008E-03
     +,   5.7063289E-03,   5.4107206E-03,   5.1333481E-03
     +,   4.8734699E-03,   4.6303528E-03,   4.4032778E-03
     +,   4.1915285E-03,   3.9943769E-03,   3.8111028E-03
     +,   3.6410051E-03,   3.4833869E-03,   3.3375528E-03
     +,   3.2028202E-03,   3.0785338E-03,   2.9640384E-03
     +,   2.8587005E-03,   2.7619095E-03,   2.6730739E-03
     +,   2.5916181E-03,   2.5169898E-03,   2.4486629E-03
     +,   2.3861360E-03,   2.3289251E-03,   2.2765729E-03
     +,   2.2286507E-03,   2.1847461E-03,   2.1444787E-03
     +,   2.1074854E-03,   2.0734309E-03,   2.0419990E-03
     +,   2.0128987E-03,   1.9858568E-03,   1.9606252E-03
     +,   1.9369713E-03,   1.9146848E-03,   1.8935713E-03
     +,   1.8734536E-03,   1.8541723E-03,   1.8355811E-03
     +,   1.8175507E-03,   1.7999623E-03,   1.7827124E-03
     +,   1.7657058E-03,   1.7488614E-03,   1.7321068E-03
     +,   1.7153783E-03,   1.6986204E-03,   1.6817874E-03
     +,   1.6648378E-03,   1.6477389E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_hzonly_hatt85_mass = Yx/9.09134014634146
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_hzonly_hatt90_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  9.2718750E-03,   9.5558157E-03
     +,   9.8307086E-03,   1.0095410E-02,   1.0348836E-02
     +,   1.0589972E-02,   1.0817887E-02,   1.1031751E-02
     +,   1.1230833E-02,   1.1414522E-02,   1.1582328E-02
     +,   1.1733885E-02,   1.1868960E-02,   1.1987465E-02
     +,   1.2089440E-02,   1.2175068E-02,   1.2244665E-02
     +,   1.2298678E-02,   1.2337679E-02,   1.2362362E-02
     +,   1.2373536E-02,   1.2372094E-02,   1.2359039E-02
     +,   1.2335439E-02,   1.2302429E-02,   1.2261200E-02
     +,   1.2212975E-02,   1.2158998E-02,   1.2100528E-02
     +,   1.2038809E-02,   1.1975079E-02,   1.1910531E-02
     +,   1.1846321E-02,   1.1783542E-02,   1.1723226E-02
     +,   1.1666329E-02,   1.1613712E-02,   1.1566163E-02
     +,   1.1524359E-02,   1.1488888E-02,   1.1460229E-02
     +,   1.1438762E-02,   1.1424765E-02,   1.1418414E-02
     +,   1.1419792E-02,   1.1428890E-02,   1.1445608E-02
     +,   1.1469780E-02,   1.1501158E-02,   1.1539435E-02
     +,   1.1584260E-02,   1.1635231E-02,   1.1691927E-02
     +,   1.1753904E-02,   1.1820709E-02,   1.1891909E-02
     +,   1.1967078E-02,   1.2045836E-02,   1.2127841E-02
     +,   1.2212819E-02,   1.2300566E-02,   1.2390972E-02
     +,   1.2484020E-02,   1.2579823E-02,   1.2678603E-02
     +,   1.2780741E-02,   1.2886763E-02,   1.2997353E-02
     +,   1.3113377E-02,   1.3235864E-02,   1.3366056E-02
     +,   1.3505345E-02,   1.3655353E-02,   1.3817848E-02
     +,   1.3994792E-02,   1.4188309E-02,   1.4400668E-02
     +,   1.4634242E-02,   1.4891518E-02,   1.5175052E-02
     +,   1.5487382E-02,   1.5831070E-02,   1.6208548E-02
     +,   1.6622206E-02,   1.7074179E-02,   1.7566444E-02
     +,   1.8100660E-02,   1.8678222E-02,   1.9300098E-02
     +,   1.9966919E-02,   2.0678937E-02,   2.1435941E-02
     +,   2.2237312E-02,   2.3082092E-02,   2.3969030E-02
     +,   2.4896508E-02,   2.5862850E-02,   2.6866226E-02
     +,   2.7904991E-02,   2.8977674E-02,   3.0083375E-02
     +,   3.1221770E-02,   3.2393608E-02,   3.3600714E-02
     +,   3.4846541E-02,   3.6136325E-02,   3.7477251E-02
     +,   3.8878873E-02,   4.0353332E-02,   4.1915592E-02
     +,   4.3583352E-02,   4.5377616E-02,   4.7322240E-02
     +,   4.9444396E-02,   5.1773954E-02,   5.4343421E-02
     +,   5.7186652E-02,   6.0338270E-02,   6.3831121E-02
     +,   6.7694858E-02,   7.1953073E-02,   7.6620579E-02
     +,   8.1701547E-02,   8.7189190E-02,   9.3066163E-02
     +,   9.9307247E-02,   0.1058865    ,   0.1127849    
     +,   0.1200045    ,   0.1275827    ,   0.1356145    
     +,   0.1442742    ,   0.1538447    ,   0.1647415    
     +,   0.1775320    ,   0.1929311    ,   0.2117563    
     +,   0.2348296    ,   0.2628234    ,   0.2960722    
     +,   0.3343996    ,   0.3770448    ,   0.4227460    
     +,   0.4699878    ,   0.5173411    ,   0.5637830    
     +,   0.6088238    ,   0.6524014    ,   0.6946404    
     +,   0.7356485    ,   0.7755083    ,   0.8144524    
     +,   0.8530272    ,   0.8920403    ,   0.9322427    
     +,   0.9739305    ,    1.016640    ,    1.058960    
     +,    1.098357    ,    1.131028    ,    1.152089    
     +,    1.156432    ,    1.140275    ,    1.102855    
     +,    1.047379    ,   0.9805412    ,   0.9106476    
     +,   0.8451290    ,   0.7885375    ,   0.7417907    
     +,   0.7027556    ,   0.6677103    ,   0.6330363    
     +,   0.5965153    ,   0.5578493    ,   0.5183475    
     +,   0.4800896    ,   0.4449976    ,   0.4142154    
     +,   0.3879417    ,   0.3656391    ,   0.3464025    
     +,   0.3292919    ,   0.3135449    ,   0.2986547    
     +,   0.2843499    ,   0.2705267    ,   0.2571741    
     +,   0.2443167    ,   0.2319839    ,   0.2201987    
     +,   0.2089808    ,   0.1983522    ,   0.1883378    
     +,   0.1789588    ,   0.1702256    ,   0.1621304    
     +,   0.1546423    ,   0.1477082    ,   0.1412593    
     +,   0.1352193    ,   0.1295120    ,   0.1240691    
     +,   0.1188349    ,   0.1137691    ,   0.1088460    
     +,   0.1040537    ,   9.9391416E-02,   9.4865546E-02
     +,   9.0486556E-02,   8.6265668E-02,   8.2212724E-02
     +,   7.8334101E-02,   7.4631318E-02,   7.1101248E-02
     +,   6.7736499E-02,   6.4526416E-02,   6.1457675E-02
     +,   5.8515988E-02,   5.5687528E-02,   5.2959237E-02
     +,   5.0320044E-02,   4.7761366E-02,   4.5277152E-02
     +,   4.2863671E-02,   4.0519454E-02,   3.8245048E-02
     +,   3.6042411E-02,   3.3914320E-02,   3.1863991E-02
     +,   2.9894887E-02,   2.8010136E-02,   2.6212206E-02
     +,   2.4502818E-02,   2.2883000E-02,   2.1352727E-02
     +,   1.9911118E-02,   1.8556558E-02,   1.7286744E-02
     +,   1.6098654E-02,   1.4988830E-02,   1.3953539E-02
     +,   1.2988819E-02,   1.2090535E-02,   1.1254539E-02
     +,   1.0476803E-02,   9.7534191E-03,   9.0806037E-03
     +,   8.4547866E-03,   7.8726858E-03,   7.3311925E-03
     +,   6.8274350E-03,   6.3588149E-03,   5.9229424E-03
     +,   5.5176006E-03,   5.1407614E-03,   4.7905911E-03
     +,   4.4653998E-03,   4.1636061E-03,   3.8837446E-03
     +,   3.6244697E-03,   3.3845180E-03,   3.1626849E-03
     +,   2.9578323E-03,   2.7689019E-03,   2.5948635E-03
     +,   2.4347398E-03,   2.2876062E-03,   2.1525784E-03
     +,   2.0288024E-03,   1.9154643E-03,   1.8117974E-03
     +,   1.7170714E-03,   1.6305862E-03,   1.5516827E-03
     +,   1.4797454E-03,   1.4141862E-03,   1.3544641E-03
     +,   1.3000646E-03,   1.2505176E-03,   1.2053794E-03
     +,   1.1642465E-03,   1.1267425E-03,   1.0925248E-03
     +,   1.0612771E-03,   1.0327140E-03,   1.0065727E-03
     +,   9.8261528E-04,   9.6062786E-04,   9.4041473E-04
     +,   9.2180155E-04,   9.0462901E-04,   8.8875613E-04
     +,   8.7405392E-04,   8.6040830E-04,   8.4771542E-04
     +,   8.3588297E-04,   8.2482700E-04,   8.1447331E-04
     +,   8.0475351E-04,   7.9560722E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_hzonly_hatt90_mass = Yx/10.0457783333333
      RETURN
      END
      DOUBLE PRECISION FUNCTION A196_tt_hzonly_hatt95_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  8.2556056E-03,   8.5299434E-03
     +,   8.8069728E-03,   9.0865241E-03,   9.3684075E-03
     +,   9.6524460E-03,   9.9384496E-03,   1.0226218E-02
     +,   1.0515542E-02,   1.0806214E-02,   1.1097988E-02
     +,   1.1390612E-02,   1.1683810E-02,   1.1977276E-02
     +,   1.2270676E-02,   1.2563643E-02,   1.2855777E-02
     +,   1.3146630E-02,   1.3435722E-02,   1.3722525E-02
     +,   1.4006454E-02,   1.4286900E-02,   1.4563178E-02
     +,   1.4834590E-02,   1.5100359E-02,   1.5359689E-02
     +,   1.5611736E-02,   1.5855625E-02,   1.6090440E-02
     +,   1.6315255E-02,   1.6529122E-02,   1.6731085E-02
     +,   1.6920196E-02,   1.7095506E-02,   1.7256096E-02
     +,   1.7401071E-02,   1.7529586E-02,   1.7640844E-02
     +,   1.7734108E-02,   1.7808715E-02,   1.7864097E-02
     +,   1.7899767E-02,   1.7915336E-02,   1.7910540E-02
     +,   1.7885214E-02,   1.7839324E-02,   1.7772948E-02
     +,   1.7686306E-02,   1.7579731E-02,   1.7453691E-02
     +,   1.7308787E-02,   1.7145710E-02,   1.6965328E-02
     +,   1.6768547E-02,   1.6556451E-02,   1.6330158E-02
     +,   1.6090918E-02,   1.5840037E-02,   1.5578903E-02
     +,   1.5308948E-02,   1.5031678E-02,   1.4748610E-02
     +,   1.4461323E-02,   1.4171388E-02,   1.3880403E-02
     +,   1.3589979E-02,   1.3301709E-02,   1.3017205E-02
     +,   1.2738042E-02,   1.2465822E-02,   1.2202088E-02
     +,   1.1948416E-02,   1.1706335E-02,   1.1477393E-02
     +,   1.1263113E-02,   1.1065021E-02,   1.0884645E-02
     +,   1.0723536E-02,   1.0583232E-02,   1.0465287E-02
     +,   1.0371296E-02,   1.0302849E-02,   1.0261574E-02
     +,   1.0249099E-02,   1.0267071E-02,   1.0317157E-02
     +,   1.0400992E-02,   1.0520210E-02,   1.0676401E-02
     +,   1.0871088E-02,   1.1105730E-02,   1.1381654E-02
     +,   1.1700018E-02,   1.2061837E-02,   1.2467884E-02
     +,   1.2918650E-02,   1.3414352E-02,   1.3954810E-02
     +,   1.4539512E-02,   1.5167450E-02,   1.5837224E-02
     +,   1.6546873E-02,   1.7293993E-02,   1.8075563E-02
     +,   1.8888110E-02,   1.9727642E-02,   2.0589592E-02
     +,   2.1468941E-02,   2.2360303E-02,   2.3257934E-02
     +,   2.4155710E-02,   2.5047459E-02,   2.5926789E-02
     +,   2.6787464E-02,   2.7623300E-02,   2.8428532E-02
     +,   2.9197698E-02,   2.9926082E-02,   3.0609574E-02
     +,   3.1245047E-02,   3.1830367E-02,   3.2364547E-02
     +,   3.2847863E-02,   3.3281989E-02,   3.3670042E-02
     +,   3.4016568E-02,   3.4327667E-02,   3.4610841E-02
     +,   3.4874987E-02,   3.5130337E-02,   3.5388198E-02
     +,   3.5660792E-02,   3.5961073E-02,   3.6302306E-02
     +,   3.6697954E-02,   3.7161198E-02,   3.7704721E-02
     +,   3.8340352E-02,   3.9078858E-02,   3.9929792E-02
     +,   4.0901266E-02,   4.1999981E-02,   4.3231372E-02
     +,   4.4599786E-02,   4.6108644E-02,   4.7761057E-02
     +,   4.9560130E-02,   5.1509444E-02,   5.3613599E-02
     +,   5.5878874E-02,   5.8313806E-02,   6.0929406E-02
     +,   6.3740008E-02,   6.6764086E-02,   7.0024773E-02
     +,   7.3550470E-02,   7.7375576E-02,   8.1541337E-02
     +,   8.6095765E-02,   9.1091916E-02,   9.6587144E-02
     +,   0.1026388    ,   0.1092980    ,   0.1166029    
     +,   0.1245695    ,   0.1331818    ,   0.1423827    
     +,   0.1520696    ,   0.1620981    ,   0.1722944    
     +,   0.1824817    ,   0.1925227    ,   0.2023739    
     +,   0.2121431    ,   0.2221389    ,   0.2328984    
     +,   0.2451740    ,   0.2598729    ,   0.2779522    
     +,   0.3002820    ,   0.3275032    ,   0.3599148    
     +,   0.3974492    ,   0.4397969    ,   0.4866960    
     +,   0.5383256    ,   0.5955814    ,   0.6598719    
     +,   0.7322341    ,   0.8121428    ,   0.8971710    
     +,   0.9845770    ,    1.074479    ,    1.171979    
     +,    1.285078    ,    1.418245    ,    1.566041    
     +,    1.712406    ,    1.836803    ,    1.922575    
     +,    1.961938    ,    1.956102    ,    1.913003    
     +,    1.844655    ,    1.763952    ,    1.680256    
     +,    1.595721    ,    1.505283    ,    1.401227    
     +,    1.279477    ,    1.143276    ,    1.002106    
     +,   0.8672035    ,   0.7470998    ,   0.6456443    
     +,   0.5625715    ,   0.4952331    ,   0.4401571    
     +,   0.3939649    ,   0.3538087    ,   0.3175819    
     +,   0.2840092    ,   0.2525760    ,   0.2233006    
     +,   0.1964406    ,   0.1722461    ,   0.1508179    
     +,   0.1320737    ,   0.1157878    ,   0.1016593    
     +,   8.9373261E-02,   7.8639567E-02,   6.9211654E-02
     +,   6.0891427E-02,   5.3525086E-02,   4.6993256E-02
     +,   4.1202907E-02,   3.6079701E-02,   3.1560957E-02
     +,   2.7590899E-02,   2.4118084E-02,   2.1093976E-02
     +,   1.8472053E-02,   1.6207721E-02,   1.4258943E-02
     +,   1.2586695E-02,   1.1155188E-02,   9.9319676E-03
     +,   8.8880900E-03,   7.9980837E-03,   7.2395038E-03
     +,   6.5928288E-03,   6.0411547E-03,   5.5698683E-03
     +,   5.1663518E-03,   4.8197769E-03,   4.5208978E-03
     +,   4.2618322E-03,   4.0358785E-03,   3.8373857E-03
     +,   3.6616265E-03,   3.5046614E-03,   3.3632170E-03
     +,   3.2346060E-03,   3.1166435E-03,   3.0075456E-03
     +,   2.9058733E-03,   2.8104775E-03,   2.7204398E-03
     +,   2.6350219E-03,   2.5536360E-03,   2.4758198E-03
     +,   2.4012029E-03,   2.3294848E-03,   2.2604237E-03
     +,   2.1938281E-03,   2.1295340E-03,   2.0674118E-03
     +,   2.0073454E-03,   1.9492425E-03,   1.8930157E-03
     +,   1.8385948E-03,   1.7859096E-03,   1.7349027E-03
     +,   1.6855135E-03,   1.6376926E-03,   1.5913863E-03
     +,   1.5465457E-03,   1.5031254E-03,   1.4610766E-03
     +,   1.4203571E-03,   1.3809206E-03,   1.3427269E-03
     +,   1.3057310E-03,   1.2698945E-03,   1.2351755E-03
     +,   1.2015373E-03,   1.1689398E-03,   1.1373491E-03
     +,   1.1067276E-03,   1.0770437E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A196_tt_hzonly_hatt95_mass = Yx/12.3984058604651
      RETURN
      END
C 
C---- New file --- 
C 
      DOUBLE PRECISION FUNCTION A200_tt_asha_htt100_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.2999727E-06,   4.9575997E-06
     +,   5.7060188E-06,   6.5561762E-06,   7.5201115E-06
     +,   8.6110049E-06,   9.8432783E-06,   1.1232644E-05
     +,   1.2796152E-05,   1.4552393E-05,   1.6521370E-05
     +,   1.8724675E-05,   2.1185542E-05,   2.3928860E-05
     +,   2.6981212E-05,   3.0370964E-05,   3.4128199E-05
     +,   3.8284761E-05,   4.2874286E-05,   4.7932110E-05
     +,   5.3495216E-05,   5.9602269E-05,   6.6293323E-05
     +,   7.3610288E-05,   8.1595630E-05,   9.0293710E-05
     +,   9.9749457E-05,   1.1000867E-04,   1.2111767E-04
     +,   1.3312309E-04,   1.4607166E-04,   1.6000975E-04
     +,   1.7498324E-04,   1.9103715E-04,   2.0821528E-04
     +,   2.2655987E-04,   2.4611136E-04,   2.6690756E-04
     +,   2.8898526E-04,   3.1237581E-04,   3.3711022E-04
     +,   3.6321455E-04,   3.9071197E-04,   4.1962173E-04
     +,   4.4995986E-04,   4.8173833E-04,   5.1496591E-04
     +,   5.4964790E-04,   5.8578677E-04,   6.2338240E-04
     +,   6.6243252E-04,   7.0293405E-04,   7.4488251E-04
     +,   7.8827649E-04,   8.3311141E-04,   8.7939081E-04
     +,   9.2711922E-04,   9.7630732E-04,   1.0269729E-03
     +,   1.0791426E-03,   1.1328524E-03,   1.1881519E-03
     +,   1.2450987E-03,   1.3037706E-03,   1.3642611E-03
     +,   1.4266736E-03,   1.4911379E-03,   1.5577921E-03
     +,   1.6268012E-03,   1.6983396E-03,   1.7726059E-03
     +,   1.8498061E-03,   1.9301685E-03,   2.0139234E-03
     +,   2.1013168E-03,   2.1926025E-03,   2.2880300E-03
     +,   2.3878473E-03,   2.4923051E-03,   2.6016471E-03
     +,   2.7160947E-03,   2.8358749E-03,   2.9611816E-03
     +,   3.0922145E-03,   3.2291424E-03,   3.3721456E-03
     +,   3.5213816E-03,   3.6770352E-03,   3.8392874E-03
     +,   4.0083672E-03,   4.1845520E-03,   4.3681771E-03
     +,   4.5596696E-03,   4.7595887E-03,   4.9686343E-03
     +,   5.1876614E-03,   5.4177525E-03,   5.6601879E-03
     +,   5.9165247E-03,   6.1885561E-03,   6.4783827E-03
     +,   6.7883418E-03,   7.1210754E-03,   7.4794148E-03
     +,   7.8664180E-03,   8.2852757E-03,   8.7392069E-03
     +,   9.2313830E-03,   9.7648380E-03,   1.0342331E-02
     +,   1.0966119E-02,   1.1637975E-02,   1.2358841E-02
     +,   1.3128889E-02,   1.3947206E-02,   1.4811871E-02
     +,   1.5719697E-02,   1.6666427E-02,   1.7646536E-02
     +,   1.8653521E-02,   1.9680025E-02,   2.0717999E-02
     +,   2.1759152E-02,   2.2795467E-02,   2.3819778E-02
     +,   2.4826350E-02,   2.5811963E-02,   2.6776662E-02
     +,   2.7725000E-02,   2.8666850E-02,   2.9618615E-02
     +,   3.0603727E-02,   3.1653233E-02,   3.2805298E-02
     +,   3.4104407E-02,   3.5599370E-02,   3.7340268E-02
     +,   3.9374623E-02,   4.1743036E-02,   4.4474274E-02
     +,   4.7580481E-02,   5.1053964E-02,   5.4865710E-02
     +,   5.8966145E-02,   6.3288480E-02,   6.7756563E-02
     +,   7.2293840E-02,   7.6834500E-02,   8.1335276E-02
     +,   8.5785598E-02,   9.0213545E-02,   9.4686151E-02
     +,   9.9303499E-02,   0.1041859    ,   0.1094553    
     +,   0.1152144    ,   0.1215282    ,   0.1284144    
     +,   0.1358429    ,   0.1437492    ,   0.1520609    
     +,   0.1607309    ,   0.1697727    ,   0.1792984    
     +,   0.1895571    ,   0.2009736    ,   0.2141878    
     +,   0.2300786    ,   0.2497507    ,   0.2744404    
     +,   0.3053166    ,   0.3431948    ,   0.3882479    
     +,   0.4398413    ,   0.4965993    ,   0.5568112    
     +,   0.6193632    ,   0.6853970    ,   0.7600617    
     +,   0.8525336    ,   0.9732201    ,    1.129651    
     +,    1.324524    ,    1.560554    ,    1.848552    
     +,    2.207271    ,    2.670311    ,    3.280053    
     +,    4.030006    ,    4.921712    ,    5.961142    
     +,    6.978714    ,    8.386249    ,    9.779651    
     +,    10.42364    ,    10.89793    ,    10.10892    
     +,    9.340548    ,    8.596327    ,    7.510134    
     +,    6.207045    ,    4.865308    ,    4.040878    
     +,    3.578862    ,    3.126450    ,    2.631530    
     +,    2.184042    ,    1.788992    ,    1.423100    
     +,    1.094270    ,   0.8166685    ,   0.5919702    
     +,   0.4153027    ,   0.2812800    ,   0.1839507    
     +,   0.1163192    ,   7.1212590E-02,   4.2275596E-02
     +,   2.4415938E-02,   1.3820040E-02,   7.7801221E-03
     +,   4.4717211E-03,   2.7280932E-03,   1.8408772E-03
     +,   1.4013929E-03,   1.1852402E-03,   1.0749970E-03
     +,   1.0121166E-03,   9.6884422E-04,   9.3272410E-04
     +,   8.9852070E-04,   8.6423219E-04,   8.2922966E-04
     +,   7.9343654E-04,   7.5698952E-04,   7.2009274E-04
     +,   6.8296865E-04,   6.4584130E-04,   6.0892507E-04
     +,   5.7241856E-04,   5.3650612E-04,   5.0135743E-04
     +,   4.6712506E-04,   4.3394105E-04,   4.0191950E-04
     +,   3.7115847E-04,   3.4173753E-04,   3.1371688E-04
     +,   2.8714008E-04,   2.6203712E-04,   2.3842060E-04
     +,   2.1628945E-04,   1.9563142E-04,   1.7642304E-04
     +,   1.5862951E-04,   1.4220765E-04,   1.2710823E-04
     +,   1.1327602E-04,   1.0065011E-04,   8.9166293E-05
     +,   7.8758763E-05,   6.9360300E-05,   6.0902454E-05
     +,   5.3317355E-05,   4.6538931E-05,   4.0501956E-05
     +,   3.5143534E-05,   3.0403728E-05,   2.6225396E-05
     +,   2.2554301E-05,   1.9339548E-05,   1.6533892E-05
     +,   1.4093482E-05,   1.1977689E-05,   1.0149330E-05
     +,   8.5746478E-06,   7.2227785E-06,   6.0660623E-06
     +,   5.0794747E-06,   4.2407751E-06,   3.5300482E-06
     +,   2.9297523E-06,   2.4243222E-06,   2.0001573E-06
     +,   1.6453081E-06,   1.3494138E-06,   1.1034558E-06
     +,   8.9964993E-07,   7.3131918E-07,   5.9271974E-07
     +,   4.7896845E-07,   3.8589852E-07,   3.0999479E-07
     +,   2.4828145E-07,   1.9826633E-07,   1.5785660E-07
     +,   1.2531159E-07,   9.9181158E-08,   7.8267512E-08
     +,   6.1580458E-08,   4.8308003E-08
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_asha_htt100_mass = Yx/36.32973204
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_asha_htt105_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.8739382E-06,   3.2943781E-06
     +,   3.7708824E-06,   4.3100949E-06,   4.9193291E-06
     +,   5.6066156E-06,   6.3807665E-06,   7.2514181E-06
     +,   8.2290708E-06,   9.3252311E-06,   1.0552351E-05
     +,   1.1923983E-05,   1.3454766E-05,   1.5160576E-05
     +,   1.7058497E-05,   1.9166931E-05,   2.1505648E-05
     +,   2.4095829E-05,   2.6960144E-05,   3.0122776E-05
     +,   3.3609460E-05,   3.7447586E-05,   4.1666066E-05
     +,   4.6295816E-05,   5.1368927E-05,   5.6919747E-05
     +,   6.2984043E-05,   6.9599395E-05,   7.6805132E-05
     +,   8.4642299E-05,   9.3153663E-05,   1.0238366E-04
     +,   1.1237838E-04,   1.2318561E-04,   1.3485461E-04
     +,   1.4743632E-04,   1.6098315E-04,   1.7554879E-04
     +,   1.9118936E-04,   2.0796074E-04,   2.2592208E-04
     +,   2.4513298E-04,   2.6565482E-04,   2.8755068E-04
     +,   3.1088534E-04,   3.3572569E-04,   3.6214042E-04
     +,   3.9020067E-04,   4.1998061E-04,   4.5155705E-04
     +,   4.8501062E-04,   5.2042585E-04,   5.5789121E-04
     +,   5.9750292E-04,   6.3935883E-04,   6.8356813E-04
     +,   7.3024456E-04,   7.7951170E-04,   8.3150173E-04
     +,   8.8635739E-04,   9.4423280E-04,   1.0052946E-03
     +,   1.0697189E-03,   1.1376997E-03,   1.2094453E-03
     +,   1.2851726E-03,   1.3651217E-03,   1.4495376E-03
     +,   1.5386903E-03,   1.6328513E-03,   1.7323180E-03
     +,   1.8373851E-03,   1.9483700E-03,   2.0655836E-03
     +,   2.1893498E-03,   2.3199958E-03,   2.4578364E-03
     +,   2.6031795E-03,   2.7563293E-03,   2.9175752E-03
     +,   3.0871688E-03,   3.2653578E-03,   3.4523336E-03
     +,   3.6482764E-03,   3.8532990E-03,   4.0674950E-03
     +,   4.2908834E-03,   4.5234608E-03,   4.7651408E-03
     +,   5.0158114E-03,   5.2753105E-03,   5.5434196E-03
     +,   5.8198818E-03,   6.1044283E-03,   6.3967831E-03
     +,   6.6966368E-03,   7.0037441E-03,   7.3178527E-03
     +,   7.6388204E-03,   7.9665454E-03,   8.3010811E-03
     +,   8.6425794E-03,   8.9913970E-03,   9.3480321E-03
     +,   9.7132185E-03,   1.0087915E-02,   1.0473285E-02
     +,   1.0870715E-02,   1.1281846E-02,   1.1708527E-02
     +,   1.2152747E-02,   1.2616702E-02,   1.3102639E-02
     +,   1.3612927E-02,   1.4149854E-02,   1.4715742E-02
     +,   1.5312695E-02,   1.5942721E-02,   1.6607491E-02
     +,   1.7308429E-02,   1.8046578E-02,   1.8822530E-02
     +,   1.9636376E-02,   2.0487756E-02,   2.1375759E-02
     +,   2.2298805E-02,   2.3254836E-02,   2.4241103E-02
     +,   2.5254406E-02,   2.6290970E-02,   2.7346777E-02
     +,   2.8417511E-02,   2.9499117E-02,   3.0587867E-02
     +,   3.1681072E-02,   3.2777589E-02,   3.3878338E-02
     +,   3.4987185E-02,   3.6111735E-02,   3.7263945E-02
     +,   3.8460713E-02,   3.9724264E-02,   4.1082401E-02
     +,   4.2568095E-02,   4.4218667E-02,   4.6074860E-02
     +,   4.8179094E-02,   5.0573282E-02,   5.3296633E-02
     +,   5.6383211E-02,   5.9859443E-02,   6.3741259E-02
     +,   6.8032354E-02,   7.2722748E-02,   7.7787846E-02
     +,   8.3188161E-02,   8.8870808E-02,   9.4772987E-02
     +,   0.1008261    ,   0.1069620    ,   0.1131231    
     +,   0.1192733    ,   0.1254113    ,   0.1315860    
     +,   0.1379114    ,   0.1445784    ,   0.1518593    
     +,   0.1601011    ,   0.1697088    ,   0.1811102    
     +,   0.1947141    ,   0.2108630    ,   0.2297937    
     +,   0.2516004    ,   0.2762004    ,   0.3033122    
     +,   0.3324468    ,   0.3629657    ,   0.3942629    
     +,   0.4260892    ,   0.4589670    ,   0.4946096    
     +,   0.5362551    ,   0.5886465    ,   0.6570005    
     +,   0.7443337    ,   0.8479672    ,   0.9584354    
     +,    1.063982    ,    1.158991    ,    1.249044    
     +,    1.348698    ,    1.479151    ,    1.666058    
     +,    1.913943    ,    2.176758    ,    2.422917    
     +,    2.745156    ,    3.307133    ,    4.221024    
     +,    5.520540    ,    6.919722    ,    8.368620    
     +,    10.15385    ,    12.05797    ,    13.07315    
     +,    12.63688    ,    11.96288    ,    10.50618    
     +,    8.341758    ,    6.140394    ,    4.013546    
     +,    2.283032    ,    1.084590    ,   0.4122396    
     +,   0.1259558    ,   3.1276725E-02,   6.1877947E-03
     +,   9.4458833E-04,   1.0874827E-04,   9.3383551E-06
     +,   6.0399361E-07,   3.7647577E-08,   8.9730534E-09
     +,   6.4612595E-09,   5.1650866E-09,   4.1442529E-09
     +,   3.3257814E-09,   2.6689151E-09,   2.1415052E-09
     +,   1.7179206E-09,   1.3776741E-09,   1.1043414E-09
     +,   8.8477126E-10,   7.0843104E-10,   5.6684751E-10
     +,   4.5321116E-10,   3.6205536E-10,   2.8897815E-10
     +,   2.3043167E-10,   1.8356158E-10,   1.4607200E-10
     +,   1.1611349E-10,   9.2195161E-11,   7.3118553E-11
     +,   5.7920242E-11,   4.5825465E-11,   3.6211447E-11
     +,   2.8578135E-11,   2.2525225E-11,   1.7731323E-11
     +,   1.3939274E-11,   1.0943688E-11,   8.5804515E-12
     +,   6.7184877E-12,   5.2534032E-12,   4.1021964E-12
     +,   3.1988958E-12,   2.4910568E-12,   1.9371464E-12
     +,   1.5043079E-12,   1.1665614E-12,   9.0337926E-13
     +,   6.9858231E-13,   5.3945574E-13,   4.1598658E-13
     +,   3.2032008E-13,   2.4630341E-13,   1.8912213E-13
     +,   1.4500816E-13,   1.1102423E-13,   8.4882859E-14
     +,   6.4804017E-14,   4.9403400E-14,   3.7608236E-14
     +,   2.8588050E-14,   2.1699664E-14,   1.6447338E-14
     +,   1.2448094E-14,   9.4076705E-15,   7.0994418E-15
     +,   5.3497923E-15,   4.0254072E-15,   3.0244866E-15
     +,   2.2690943E-15,   1.6998855E-15,   1.2715935E-15
     +,   9.4980250E-16,   7.0840579E-16,   5.2757685E-16
     +,   3.9233079E-16,   2.9132081E-16,   2.1599917E-16
     +,   1.5991300E-16,   1.1821581E-16,   8.7260467E-17
     +,   6.4315893E-17,   4.7333369E-17,   3.4783415E-17
     +,   2.5522645E-17,   1.8699731E-17
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_asha_htt105_mass = Yx/35.07323316
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_asha_htt107_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.2359755E-09,   4.1598547E-09
     +,   5.3347762E-09,   6.8252626E-09,   8.7113969E-09
     +,   1.1092287E-08,   1.4090290E-08,   1.7855987E-08
     +,   2.2574133E-08,   2.8471169E-08,   3.5823234E-08
     +,   4.4966562E-08,   5.6309283E-08,   7.0345322E-08
     +,   8.7670990E-08,   1.0900394E-07,   1.3520524E-07
     +,   1.6730569E-07,   2.0653482E-07,   2.5435560E-07
     +,   3.1250340E-07,   3.8303097E-07,   4.6835740E-07
     +,   5.7133320E-07,   6.9528761E-07,   8.4412551E-07
     +,   1.0223876E-06,   1.2353507E-06,   1.4891249E-06
     +,   1.7907646E-06,   2.1483859E-06,   2.5713000E-06
     +,   3.0701542E-06,   3.6570823E-06,   4.3458676E-06
     +,   5.1521165E-06,   6.0934453E-06,   7.1896402E-06
     +,   8.4629582E-06,   9.9381077E-06,   1.1642755E-05
     +,   1.3607475E-05,   1.5866082E-05,   1.8455790E-05
     +,   2.1417431E-05,   2.4795581E-05,   2.8638766E-05
     +,   3.2999575E-05,   3.7934773E-05,   4.3505359E-05
     +,   4.9776627E-05,   5.6818149E-05,   6.4703585E-05
     +,   7.3511197E-05,   8.3322288E-05,   9.4222836E-05
     +,   1.0630169E-04,   1.1965088E-04,   1.3436514E-04
     +,   1.5054141E-04,   1.6827823E-04,   1.8767570E-04
     +,   2.0883309E-04,   2.3185123E-04,   2.5683068E-04
     +,   2.8386831E-04,   3.1306304E-04,   3.4450836E-04
     +,   3.7830014E-04,   4.1452874E-04,   4.5328855E-04
     +,   4.9466983E-04,   5.3877127E-04,   5.8569195E-04
     +,   6.3554518E-04,   6.8846083E-04,   7.4458786E-04
     +,   8.0410694E-04,   8.6724560E-04,   9.3428895E-04
     +,   1.0055886E-03,   1.0815973E-03,   1.1628724E-03
     +,   1.2501199E-03,   1.3442000E-03,   1.4461775E-03
     +,   1.5573263E-03,   1.6791829E-03,   1.8135426E-03
     +,   1.9625069E-03,   2.1284835E-03,   2.3141787E-03
     +,   2.5225929E-03,   2.7570056E-03,   3.0209208E-03
     +,   3.3179654E-03,   3.6518637E-03,   4.0262374E-03
     +,   4.4445614E-03,   4.9098991E-03,   5.4248460E-03
     +,   5.9912191E-03,   6.6100154E-03,   7.2810822E-03
     +,   8.0031129E-03,   8.7734684E-03,   9.5880479E-03
     +,   1.0441319E-02,   1.1326418E-02,   1.2235210E-02
     +,   1.3158398E-02,   1.4085970E-02,   1.5007286E-02
     +,   1.5911700E-02,   1.6788706E-02,   1.7628616E-02
     +,   1.8422741E-02,   1.9163994E-02,   1.9847024E-02
     +,   2.0468650E-02,   2.1027954E-02,   2.1526307E-02
     +,   2.1967387E-02,   2.2357017E-02,   2.2702934E-02
     +,   2.3014357E-02,   2.3301715E-02,   2.3576105E-02
     +,   2.3848973E-02,   2.4131650E-02,   2.4435179E-02
     +,   2.4770066E-02,   2.5146469E-02,   2.5574302E-02
     +,   2.6063848E-02,   2.6626408E-02,   2.7275136E-02
     +,   2.8026022E-02,   2.8898904E-02,   2.9918073E-02
     +,   3.1112598E-02,   3.2515917E-02,   3.4164801E-02
     +,   3.6097176E-02,   3.8348626E-02,   4.0948831E-02
     +,   4.3916777E-02,   4.7256000E-02,   5.0950788E-02
     +,   5.4964155E-02,   5.9237614E-02,   6.3693836E-02
     +,   6.8243533E-02,   7.2795436E-02,   7.7268958E-02
     +,   8.1607863E-02,   8.5795410E-02,   8.9866340E-02
     +,   9.3914688E-02,   9.8094054E-02,   0.1026104    
     +,   0.1077039    ,   0.1136205    ,   0.1205748    
     +,   0.1287095    ,   0.1380538    ,   0.1484935    
     +,   0.1597614    ,   0.1714618    ,   0.1831323    
     +,   0.1943485    ,   0.2048653    ,   0.2147715    
     +,   0.2246239    ,   0.2355103    ,   0.2489819    
     +,   0.2668014    ,   0.2904875    ,   0.3207371    
     +,   0.3569069    ,   0.3968320    ,   0.4372599    
     +,   0.4749887    ,   0.5084167    ,   0.5387951    
     +,   0.5704101    ,   0.6093934    ,   0.6616933    
     +,   0.7310836    ,   0.8178139    ,   0.9183707    
     +,    1.026890    ,    1.137785    ,    1.248197    
     +,    1.361341    ,    1.491450    ,    1.659797    
     +,    1.872601    ,    2.108594    ,    2.356873    
     +,    2.657803    ,    3.047928    ,    3.529279    
     +,    4.163321    ,    5.169103    ,    6.631042    
     +,    8.262588    ,    10.37634    ,    12.35480    
     +,    14.82066    ,    16.52082    ,    14.11133    
     +,    8.384302    ,    3.453940    ,   0.8591760    
     +,   0.1187740    ,   1.4944770E-02,   3.8603481E-03
     +,   1.3871716E-03,   8.2560931E-04,   7.5653032E-04
     +,   7.6140545E-04,   7.7187450E-04,   7.8165770E-04
     +,   7.9038210E-04,   7.9799903E-04,   8.0447417E-04
     +,   8.0977858E-04,   8.1388844E-04,   8.1678579E-04
     +,   8.1845716E-04,   8.1889477E-04,   8.1809697E-04
     +,   8.1606733E-04,   8.1281492E-04,   8.0835458E-04
     +,   8.0270600E-04,   7.9589471E-04,   7.8795123E-04
     +,   7.7891035E-04,   7.6881173E-04,   7.5769948E-04
     +,   7.4562186E-04,   7.3263026E-04,   7.1877870E-04
     +,   7.0412550E-04,   6.8873115E-04,   6.7265739E-04
     +,   6.5596728E-04,   6.3872710E-04,   6.2100199E-04
     +,   6.0285750E-04,   5.8436056E-04,   5.6557736E-04
     +,   5.4657232E-04,   5.2740867E-04,   5.0814933E-04
     +,   4.8885541E-04,   4.6958480E-04,   4.5039292E-04
     +,   4.3133384E-04,   4.1245884E-04,   3.9381493E-04
     +,   3.7544614E-04,   3.5739475E-04,   3.3969822E-04
     +,   3.2239038E-04,   3.0550294E-04,   2.8906396E-04
     +,   2.7309704E-04,   2.5762248E-04,   2.4265815E-04
     +,   2.2821881E-04,   2.1431495E-04,   2.0095422E-04
     +,   1.8814257E-04,   1.7588172E-04,   1.6417225E-04
     +,   1.5301084E-04,   1.4239352E-04,   1.3231277E-04
     +,   1.2276051E-04,   1.1372584E-04,   1.0519742E-04
     +,   9.7161545E-05,   8.9604400E-05,   8.2510451E-05
     +,   7.5863296E-05,   6.9646638E-05,   6.3842803E-05
     +,   5.8434493E-05,   5.3403528E-05,   4.8732240E-05
     +,   4.4402364E-05,   4.0396299E-05,   3.6696118E-05
     +,   3.3284694E-05,   3.0144773E-05,   2.7259974E-05
     +,   2.4613981E-05,   2.2191382E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_asha_htt107_mass = Yx/32.9904925714286
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_asha_htt110_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.8684268E-04,   1.9638997E-04
     +,   2.0628443E-04,   2.1653116E-04,   2.2713504E-04
     +,   2.3810087E-04,   2.4943316E-04,   2.6113639E-04
     +,   2.7321471E-04,   2.8567269E-04,   2.9851438E-04
     +,   3.1174390E-04,   3.2536543E-04,   3.3938326E-04
     +,   3.5380170E-04,   3.6862536E-04,   3.8385906E-04
     +,   3.9950782E-04,   4.1557712E-04,   4.3207293E-04
     +,   4.4900159E-04,   4.6637034E-04,   4.8418646E-04
     +,   5.0245930E-04,   5.2119716E-04,   5.4041116E-04
     +,   5.6011241E-04,   5.8031327E-04,   6.0102739E-04
     +,   6.2226981E-04,   6.4405682E-04,   6.6640601E-04
     +,   6.8933668E-04,   7.1286957E-04,   7.3702697E-04
     +,   7.6183293E-04,   7.8731315E-04,   8.1349426E-04
     +,   8.4040681E-04,   8.6807949E-04,   8.9654600E-04
     +,   9.2583976E-04,   9.5599599E-04,   9.8705152E-04
     +,   1.0190445E-03,   1.0520142E-03,   1.0860011E-03
     +,   1.1210465E-03,   1.1571924E-03,   1.1944815E-03
     +,   1.2329570E-03,   1.2726618E-03,   1.3136390E-03
     +,   1.3559335E-03,   1.3995850E-03,   1.4446379E-03
     +,   1.4911322E-03,   1.5391087E-03,   1.5886060E-03
     +,   1.6396622E-03,   1.6923135E-03,   1.7465957E-03
     +,   1.8025392E-03,   1.8601783E-03,   1.9195452E-03
     +,   1.9806654E-03,   2.0435702E-03,   2.1082826E-03
     +,   2.1748345E-03,   2.2432460E-03,   2.3135487E-03
     +,   2.3857646E-03,   2.4599263E-03,   2.5360601E-03
     +,   2.6142013E-03,   2.6943900E-03,   2.7766672E-03
     +,   2.8610823E-03,   2.9476995E-03,   3.0365970E-03
     +,   3.1278608E-03,   3.2216136E-03,   3.3179943E-03
     +,   3.4171906E-03,   3.5194268E-03,   3.6249990E-03
     +,   3.7342657E-03,   3.8476943E-03,   3.9658519E-03
     +,   4.0894607E-03,   4.2194151E-03,   4.3568099E-03
     +,   4.5029838E-03,   4.6595754E-03,   4.8285639E-03
     +,   5.0122980E-03,   5.2135992E-03,   5.4357513E-03
     +,   5.6826216E-03,   5.9586423E-03,   6.2689194E-03
     +,   6.6191880E-03,   7.0159114E-03,   7.4661770E-03
     +,   7.9777557E-03,   8.5589970E-03,   9.2187012E-03
     +,   9.9659711E-03,   1.0810110E-02,   1.1760322E-02
     +,   1.2825345E-02,   1.4013337E-02,   1.5331249E-02
     +,   1.6784765E-02,   1.8377561E-02,   2.0111352E-02
     +,   2.1985158E-02,   2.3995504E-02,   2.6135834E-02
     +,   2.8396957E-02,   3.0767012E-02,   3.3231713E-02
     +,   3.5774954E-02,   3.8379729E-02,   4.1028906E-02
     +,   4.3705881E-02,   4.6396393E-02,   4.9088940E-02
     +,   5.1776536E-02,   5.4457005E-02,   5.7134602E-02
     +,   5.9819739E-02,   6.2530063E-02,   6.5289639E-02
     +,   6.8129189E-02,   7.1085058E-02,   7.4197836E-02
     +,   7.7511236E-02,   8.1070587E-02,   8.4920876E-02
     +,   8.9104839E-02,   9.3661107E-02,   9.8622814E-02
     +,   0.1040159    ,   0.1098565    ,   0.1161510    
     +,   0.1228940    ,   0.1300672    ,   0.1376397    
     +,   0.1455704    ,   0.1538109    ,   0.1623105    
     +,   0.1710243    ,   0.1799215    ,   0.1889922    
     +,   0.1982494    ,   0.2077284    ,   0.2174789    
     +,   0.2275518    ,   0.2379837    ,   0.2487858    
     +,   0.2599388    ,   0.2713992    ,   0.2831136    
     +,   0.2950409    ,   0.3071668    ,   0.3195129    
     +,   0.3321432    ,   0.3451868    ,   0.3588923    
     +,   0.3737339    ,   0.3905347    ,   0.4105339    
     +,   0.4352851    ,   0.4663120    ,   0.5045488    
     +,   0.5497268    ,   0.6000013    ,   0.6521255    
     +,   0.7023161    ,   0.7476164    ,   0.7872182    
     +,   0.8230080    ,   0.8587484    ,   0.8981935    
     +,   0.9436311    ,   0.9966837    ,    1.061050    
     +,    1.143018    ,    1.245525    ,    1.359809    
     +,    1.467279    ,    1.557266    ,    1.644578    
     +,    1.762090    ,    1.928817    ,    2.128706    
     +,    2.330470    ,    2.528499    ,    2.752527    
     +,    3.035212    ,    3.410250    ,    3.935441    
     +,    4.547253    ,    5.010758    ,    5.359409    
     +,    5.925385    ,    6.742550    ,    7.512977    
     +,    8.005505    ,    8.103365    ,    7.480051    
     +,    5.774769    ,    3.437951    ,    1.494537    
     +,   0.4600333    ,   0.1012720    ,   1.8136978E-02
     +,   3.6229533E-03,   8.8790205E-04,   2.0157194E-04
     +,   3.5890847E-05,   5.0986537E-06,   8.6042132E-07
     +,   3.9459010E-07,   3.2032469E-07,   2.8000215E-07
     +,   2.4587675E-07,   2.1590132E-07,   1.8952821E-07
     +,   1.6632814E-07,   1.4592324E-07,   1.2797990E-07
     +,   1.1220391E-07,   9.8337260E-08,   8.6151445E-08
     +,   7.5445243E-08,   6.6041707E-08,   5.7785190E-08
     +,   5.0537796E-08,   4.4178162E-08,   3.8599744E-08
     +,   3.3708577E-08,   2.9421592E-08,   2.5665633E-08
     +,   2.2376531E-08,   1.9497703E-08,   1.6979117E-08
     +,   1.4776747E-08,   1.2852055E-08,   1.1170902E-08
     +,   9.7032489E-09,   8.4228065E-09,   7.3063990E-09
     +,   6.3335910E-09,   5.4864251E-09,   4.7491833E-09
     +,   4.1080579E-09,   3.5508849E-09,   3.0669887E-09
     +,   2.6470528E-09,   2.2828941E-09,   1.9673274E-09
     +,   1.6940654E-09,   1.4576330E-09,   1.2532132E-09
     +,   1.0766050E-09,   9.2414970E-10,   7.9265261E-10
     +,   6.7931794E-10,   5.8171440E-10,   4.9772886E-10
     +,   4.2552373E-10,   3.6349448E-10,   3.1024969E-10
     +,   2.6458688E-10,   2.2545625E-10,   1.9195426E-10
     +,   1.6329306E-10,   1.3879593E-10,   1.1787425E-10
     +,   1.0002268E-10,   8.4802679E-11,   7.1838341E-11
     +,   6.0804153E-11,   5.1421672E-11,   4.3449935E-11
     +,   3.6682723E-11,   3.0943349E-11,   2.6079552E-11
     +,   2.1961712E-11,   1.8478188E-11,   1.5534008E-11
     +,   1.3047757E-11,   1.0950092E-11,   9.1817569E-12
     +,   7.6924760E-12,   6.4391782E-12,   5.3854898E-12
     +,   4.5003385E-12,   3.7574813E-12
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_asha_htt110_mass = Yx/28.492723
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_asha_htt115_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  5.9615693E-05,   6.5608830E-05
     +,   7.2127375E-05,   7.9208316E-05,   8.6890279E-05
     +,   9.5213385E-05,   1.0421934E-04,   1.1395124E-04
     +,   1.2445342E-04,   1.3577202E-04,   1.4795379E-04
     +,   1.6104667E-04,   1.7509946E-04,   1.9016179E-04
     +,   2.0628367E-04,   2.2351545E-04,   2.4190758E-04
     +,   2.6151034E-04,   2.8237354E-04,   3.0454650E-04
     +,   3.2807721E-04,   3.5301261E-04,   3.7939750E-04
     +,   4.0727650E-04,   4.3668872E-04,   4.6767393E-04
     +,   5.0026720E-04,   5.3450023E-04,   5.7040161E-04
     +,   6.0799567E-04,   6.4730231E-04,   6.8833685E-04
     +,   7.3110970E-04,   7.7562610E-04,   8.2188571E-04
     +,   8.6988247E-04,   9.1960473E-04,   9.7103376E-04
     +,   1.0241483E-03,   1.0789149E-03,   1.1353001E-03
     +,   1.1932609E-03,   1.2527496E-03,   1.3137121E-03
     +,   1.3760895E-03,   1.4398174E-03,   1.5048268E-03
     +,   1.5710444E-03,   1.6383933E-03,   1.7067926E-03
     +,   1.7761600E-03,   1.8464109E-03,   1.9174583E-03
     +,   1.9892196E-03,   2.0616052E-03,   2.1345350E-03
     +,   2.2079269E-03,   2.2817026E-03,   2.3557898E-03
     +,   2.4301203E-03,   2.5046337E-03,   2.5792764E-03
     +,   2.6540007E-03,   2.7287723E-03,   2.8035680E-03
     +,   2.8783679E-03,   2.9531741E-03,   3.0279898E-03
     +,   3.1028416E-03,   3.1777602E-03,   3.2527966E-03
     +,   3.3280079E-03,   3.4034741E-03,   3.4792775E-03
     +,   3.5555223E-03,   3.6323243E-03,   3.7098059E-03
     +,   3.7881027E-03,   3.8673661E-03,   3.9477567E-03
     +,   4.0294398E-03,   4.1125971E-03,   4.1974126E-03
     +,   4.2840876E-03,   4.3728217E-03,   4.4638370E-03
     +,   4.5573525E-03,   4.6536103E-03,   4.7528557E-03
     +,   4.8553590E-03,   4.9614091E-03,   5.0713145E-03
     +,   5.1854127E-03,   5.3040888E-03,   5.4277768E-03
     +,   5.5569666E-03,   5.6922408E-03,   5.8342735E-03
     +,   5.9838928E-03,   6.1420780E-03,   6.3100541E-03
     +,   6.4893081E-03,   6.6817096E-03,   6.8895682E-03
     +,   7.1157771E-03,   7.3639499E-03,   7.6385578E-03
     +,   7.9451166E-03,   8.2904194E-03,   8.6827306E-03
     +,   9.1319345E-03,   9.6498244E-03,   1.0250111E-02
     +,   1.0948630E-02,   1.1763148E-02,   1.2713352E-02
     +,   1.3820325E-02,   1.5106213E-02,   1.6593279E-02
     +,   1.8303199E-02,   2.0255944E-02,   2.2468435E-02
     +,   2.4953479E-02,   2.7718831E-02,   3.0766172E-02
     +,   3.4090187E-02,   3.7679110E-02,   4.1514158E-02
     +,   4.5571301E-02,   4.9821563E-02,   5.4233693E-02
     +,   5.8775157E-02,   6.3415207E-02,   6.8125628E-02
     +,   7.2883531E-02,   7.7671774E-02,   8.2479477E-02
     +,   8.7301910E-02,   9.2140354E-02,   9.7000323E-02
     +,   0.1018896    ,   0.1068166    ,   0.1117888    
     +,   0.1168109    ,   0.1218837    ,   0.1270047    
     +,   0.1321687    ,   0.1373706    ,   0.1426088    
     +,   0.1478905    ,   0.1532373    ,   0.1586917    
     +,   0.1643259    ,   0.1702532    ,   0.1766396    
     +,   0.1837159    ,   0.1917877    ,   0.2012370    
     +,   0.2125086    ,   0.2260757    ,   0.2423854    
     +,   0.2617790    ,   0.2843929    ,   0.3100628    
     +,   0.3382491    ,   0.3680142    ,   0.3980841    
     +,   0.4270287    ,   0.4535516    ,   0.4768590    
     +,   0.4970271    ,   0.5152552    ,   0.5338605    
     +,   0.5559295    ,   0.5846197    ,   0.6222281    
     +,   0.6692482    ,   0.7237986    ,   0.7818020    
     +,   0.8380361    ,   0.8876178    ,   0.9272294    
     +,   0.9557102    ,   0.9742373    ,   0.9865552    
     +,   0.9993572    ,    1.022379    ,    1.067274    
     +,    1.143460    ,    1.250324    ,    1.371915    
     +,    1.485375    ,    1.583322    ,    1.687671    
     +,    1.831689    ,    2.022478    ,    2.231325    
     +,    2.432398    ,    2.629615    ,    2.833365    
     +,    3.046919    ,    3.259708    ,    3.426076    
     +,    3.517298    ,    3.573601    ,    3.627468    
     +,    3.659615    ,    3.648856    ,    3.569113    
     +,    3.378014    ,    3.055930    ,    2.599841    
     +,    2.014624    ,    1.368214    ,   0.7908617    
     +,   0.3826870    ,   0.1536795    ,   5.0915897E-02
     +,   1.3840982E-02,   3.0713533E-03,   5.5426097E-04
     +,   8.1605867E-05,   1.0321560E-05,   1.6262778E-06
     +,   7.0725144E-07,   5.6664288E-07,   4.9550954E-07
     +,   4.3593263E-07,   3.8340286E-07,   3.3697160E-07
     +,   2.9595404E-07,   2.5974529E-07,   2.2780286E-07
     +,   1.9964297E-07,   1.7483727E-07,   1.5300117E-07
     +,   1.3379257E-07,   1.1690858E-07,   1.0207914E-07
     +,   8.9063668E-08,   7.7648536E-08,   6.7644933E-08
     +,   5.8885238E-08,   5.1220439E-08,   4.4518664E-08
     +,   3.8663671E-08,   3.3552663E-08,   2.9094435E-08
     +,   2.5208584E-08,   2.1824512E-08,   1.8879712E-08
     +,   1.6319142E-08,   1.4094513E-08,   1.2163403E-08
     +,   1.0488370E-08,   9.0366301E-09,   7.7794731E-09
     +,   6.6917565E-09,   5.7513825E-09,   4.9390603E-09
     +,   4.2379535E-09,   3.6333656E-09,   3.1124281E-09
     +,   2.6639355E-09,   2.2781654E-09,   1.9466153E-09
     +,   1.6619023E-09,   1.4176283E-09,   1.2082355E-09
     +,   1.0288925E-09,   8.7541524E-10,   7.4419237E-10
     +,   6.3209871E-10,   5.3642518E-10,   4.5483664E-10
     +,   3.8532497E-10,   3.2615094E-10,   2.7582522E-10
     +,   2.3305963E-10,   1.9675364E-10,   1.6595668E-10
     +,   1.3985800E-10,   1.1775919E-10,   9.9065381E-11
     +,   8.3264923E-11,   6.9923102E-11,   5.8667078E-11
     +,   4.9178925E-11,   4.1188893E-11,   3.4466114E-11
     +,   2.8815002E-11,   2.4068830E-11,   2.0086571E-11
     +,   1.6748084E-11,   1.3952048E-11,   1.1612308E-11
     +,   9.6563105E-12,   8.0225210E-12,   6.6592140E-12
     +,   5.5225620E-12,   4.5758310E-12
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_asha_htt115_mass = Yx/20.9854223478261
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_asha_htt120_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  5.4380311E-05,   5.8618323E-05
     +,   6.3135296E-05,   6.7945155E-05,   7.3062249E-05
     +,   7.8501231E-05,   8.4277090E-05,   9.0405061E-05
     +,   9.6900592E-05,   1.0377962E-04,   1.1105810E-04
     +,   1.1875215E-04,   1.2687813E-04,   1.3545247E-04
     +,   1.4449180E-04,   1.5401273E-04,   1.6403190E-04
     +,   1.7456611E-04,   1.8563200E-04,   1.9724634E-04
     +,   2.0942587E-04,   2.2218730E-04,   2.3554712E-04
     +,   2.4952283E-04,   2.6413030E-04,   2.7938749E-04
     +,   2.9531130E-04,   3.1191943E-04,   3.2923004E-04
     +,   3.4726204E-04,   3.6603518E-04,   3.8557037E-04
     +,   4.0588985E-04,   4.2701798E-04,   4.4898095E-04
     +,   4.7180793E-04,   4.9553101E-04,   5.2018568E-04
     +,   5.4581382E-04,   5.7245913E-04,   6.0017454E-04
     +,   6.2901800E-04,   6.5905537E-04,   6.9036183E-04
     +,   7.2302204E-04,   7.5713138E-04,   7.9279795E-04
     +,   8.3014241E-04,   8.6930074E-04,   9.1042375E-04
     +,   9.5367967E-04,   9.9925452E-04,   1.0473519E-03
     +,   1.0981997E-03,   1.1520393E-03,   1.2091402E-03
     +,   1.2697892E-03,   1.3342955E-03,   1.4029902E-03
     +,   1.4762240E-03,   1.5543678E-03,   1.6378121E-03
     +,   1.7269577E-03,   1.8222261E-03,   1.9240505E-03
     +,   2.0328625E-03,   2.1491095E-03,   2.2732255E-03
     +,   2.4056537E-03,   2.5468110E-03,   2.6971146E-03
     +,   2.8569412E-03,   3.0266615E-03,   3.2065883E-03
     +,   3.3970133E-03,   3.5981806E-03,   3.8102728E-03
     +,   4.0334119E-03,   4.2676721E-03,   4.5130663E-03
     +,   4.7695087E-03,   5.0368779E-03,   5.3149443E-03
     +,   5.6034378E-03,   5.9019797E-03,   6.2101572E-03
     +,   6.5274471E-03,   6.8533057E-03,   7.1870857E-03
     +,   7.5281160E-03,   7.8756856E-03,   8.2290191E-03
     +,   8.5873157E-03,   8.9497752E-03,   9.3155941E-03
     +,   9.6839387E-03,   1.0054032E-02,   1.0425083E-02
     +,   1.0796387E-02,   1.1167243E-02,   1.1537062E-02
     +,   1.1905285E-02,   1.2271485E-02,   1.2635293E-02
     +,   1.2996486E-02,   1.3354964E-02,   1.3710737E-02
     +,   1.4063977E-02,   1.4415034E-02,   1.4764450E-02
     +,   1.5112927E-02,   1.5461473E-02,   1.5811298E-02
     +,   1.6163997E-02,   1.6521497E-02,   1.6886231E-02
     +,   1.7261134E-02,   1.7649867E-02,   1.8056827E-02
     +,   1.8487422E-02,   1.8948175E-02,   1.9446896E-02
     +,   1.9992840E-02,   2.0596940E-02,   2.1271912E-02
     +,   2.2032188E-02,   2.2894120E-02,   2.3875605E-02
     +,   2.4996078E-02,   2.6275812E-02,   2.7735677E-02
     +,   2.9396029E-02,   3.1276383E-02,   3.3394042E-02
     +,   3.5763722E-02,   3.8396690E-02,   4.1300196E-02
     +,   4.4477500E-02,   4.7928486E-02,   5.1650338E-02
     +,   5.5638645E-02,   5.9889223E-02,   6.4400427E-02
     +,   6.9174550E-02,   7.4218720E-02,   7.9546139E-02
     +,   8.5174359E-02,   9.1121674E-02,   9.7401857E-02
     +,   0.1040165    ,   0.1109453    ,   0.1181358    
     +,   0.1254954    ,   0.1328892    ,   0.1401434    
     +,   0.1470596    ,   0.1534408    ,   0.1591278    
     +,   0.1640422    ,   0.1682287    ,   0.1718922    
     +,   0.1754129    ,   0.1793339    ,   0.1843160    
     +,   0.1910609    ,   0.2002162    ,   0.2122804    
     +,   0.2275301    ,   0.2459795    ,   0.2673692    
     +,   0.2911740    ,   0.3166424    ,   0.3428850    
     +,   0.3690466    ,   0.3945628    ,   0.4194193    
     +,   0.4442227    ,   0.4699424    ,   0.4974088    
     +,   0.5269806    ,   0.5588238    ,   0.5937268    
     +,   0.6336730    ,   0.6814724    ,   0.7397798    
     +,   0.8104527    ,   0.8942829    ,   0.9901669    
     +,    1.093611    ,    1.195618    ,    1.283154    
     +,    1.342801    ,    1.368190    ,    1.365344    
     +,    1.348491    ,    1.332042    ,    1.331065    
     +,    1.365195    ,    1.451030    ,    1.586081    
     +,    1.741909    ,    1.878942    ,    1.978861    
     +,    2.062911    ,    2.166501    ,    2.298705    
     +,    2.431418    ,    2.508874    ,    2.467006    
     +,    2.271330    ,    1.940764    ,    1.529825    
     +,    1.101584    ,   0.7152238    ,   0.4138936    
     +,   0.2117780    ,   9.5265999E-02,   3.7475988E-02
     +,   1.2820384E-02,   3.7931229E-03,   9.6558785E-04
     +,   2.1054385E-04,   3.9200109E-05,   6.2403433E-06
     +,   8.7424172E-07,   1.3260355E-07,   4.2261266E-08
     +,   2.9399898E-08,   2.4749284E-08,   2.1261672E-08
     +,   1.8281685E-08,   1.5707922E-08,   1.3485091E-08
     +,   1.1566947E-08,   9.9132835E-09,   8.4888709E-09
     +,   7.2629667E-09,   6.2088739E-09,   5.3033582E-09
     +,   4.5261128E-09,   3.8595451E-09,   3.2884073E-09
     +,   2.7994784E-09,   2.3812778E-09,   2.0238671E-09
     +,   1.7186855E-09,   1.4583316E-09,   1.2364021E-09
     +,   1.0473835E-09,   8.8654079E-10,   7.4978596E-10
     +,   6.3360611E-10,   5.3499311E-10,   4.5136311E-10
     +,   3.8049652E-10,   3.2049424E-10,   2.6973510E-10
     +,   2.2683247E-10,   1.9059869E-10,   1.6002215E-10
     +,   1.3424194E-10,   1.1252425E-10,   9.4243488E-11
     +,   7.8868176E-11,   6.5948053E-11,   5.5099758E-11
     +,   4.5998157E-11,   3.8368735E-11,   3.1978895E-11
     +,   2.6631411E-11,   2.2159941E-11,   1.8424116E-11
     +,   1.5305628E-11,   1.2704539E-11,   1.0536773E-11
     +,   8.7317271E-12,   7.2299137E-12,   5.9814801E-12
     +,   4.9444927E-12,   4.0839151E-12,   3.3702943E-12
     +,   2.7790741E-12,   2.2896353E-12,   1.8848295E-12
     +,   1.5502828E-12,   1.2740518E-12,   1.0461596E-12
     +,   8.5829900E-13,   7.0358378E-13,   5.7626348E-13
     +,   4.7158458E-13,   3.8558973E-13,   3.1500890E-13
     +,   2.5712638E-13,   2.0970054E-13,   1.7087418E-13
     +,   1.3911798E-13,   1.1316463E-13,   9.1974131E-14
     +,   7.4686513E-14,   6.0595856E-14
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_asha_htt120_mass = Yx/13.8377839534884
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_asha_htt60_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  5.5033336E-03,   5.7716472E-03
     +,   6.0516545E-03,   6.3435733E-03,   6.6475947E-03
     +,   6.9638863E-03,   7.2925841E-03,   7.6337927E-03
     +,   7.9875859E-03,   8.3540222E-03,   8.7331235E-03
     +,   9.1248881E-03,   9.5293000E-03,   9.9463249E-03
     +,   1.0375924E-02,   1.0818051E-02,   1.1272671E-02
     +,   1.1739748E-02,   1.2219283E-02,   1.2711283E-02
     +,   1.3215804E-02,   1.3732937E-02,   1.4262797E-02
     +,   1.4805602E-02,   1.5361532E-02,   1.5930902E-02
     +,   1.6514016E-02,   1.7111238E-02,   1.7722975E-02
     +,   1.8349629E-02,   1.8991645E-02,   1.9649448E-02
     +,   2.0323485E-02,   2.1014171E-02,   2.1721933E-02
     +,   2.2447171E-02,   2.3190346E-02,   2.3951927E-02
     +,   2.4732567E-02,   2.5533024E-02,   2.6354428E-02
     +,   2.7198277E-02,   2.8066665E-02,   2.8962465E-02
     +,   2.9889558E-02,   3.0853080E-02,   3.1859752E-02
     +,   3.2918163E-02,   3.4039196E-02,   3.5236418E-02
     +,   3.6526576E-02,   3.7930060E-02,   3.9471615E-02
     +,   4.1180965E-02,   4.3093510E-02,   4.5251418E-02
     +,   4.7704402E-02,   5.0510932E-02,   5.3739361E-02
     +,   5.7469215E-02,   6.1792273E-02,   6.6813879E-02
     +,   7.2653018E-02,   7.9443052E-02,   8.7330334E-02
     +,   9.6469998E-02,   0.1070232    ,   0.1191462    
     +,   0.1329822    ,   0.1486447    ,   0.1662039    
     +,   0.1856664    ,   0.2069619    ,   0.2299246    
     +,   0.2542867    ,   0.2796727    ,   0.3056018    
     +,   0.3315018    ,   0.3567384    ,   0.3806543    
     +,   0.4026189    ,   0.4221058    ,   0.4387598    
     +,   0.4524780    ,   0.4634650    ,   0.4722668    
     +,   0.4797615    ,   0.4871066    ,   0.4956332    
     +,   0.5067120    ,   0.5215782    ,   0.5411569    
     +,   0.5658951    ,   0.5956452    ,   0.6296270    
     +,   0.6664964    ,   0.7045568    ,   0.7420645    
     +,   0.7775984    ,   0.8103576    ,   0.8403038    
     +,   0.8680469    ,   0.8945331    ,   0.9206715    
     +,   0.9470675    ,   0.9739363    ,    1.001111    
     +,    1.028032    ,    1.053777    ,    1.077251    
     +,    1.097695    ,    1.115273    ,    1.131333    
     +,    1.148060    ,    1.167704    ,    1.191908    
     +,    1.221480    ,    1.256527    ,    1.296645    
     +,    1.341057    ,    1.388831    ,    1.439300    
     +,    1.492494    ,    1.549277    ,    1.611039    
     +,    1.679257    ,    1.755362    ,    1.840711    
     +,    1.935659    ,    2.036861    ,    2.134262    
     +,    2.211375    ,    2.251362    ,    2.245986    
     +,    2.200560    ,    2.130340    ,    2.050905    
     +,    1.970005    ,    1.886230    ,    1.793638    
     +,    1.687666    ,    1.568470    ,    1.440922    
     +,    1.312481    ,    1.190392    ,    1.079530    
     +,   0.9816658    ,   0.8961277    ,   0.8210582    
     +,   0.7545192    ,   0.6950424    ,   0.6416917    
     +,   0.5939322    ,   0.5515012    ,   0.5143202    
     +,   0.4824007    ,   0.4557195    ,   0.4341028    
     +,   0.4171549    ,   0.4042454    ,   0.3945507    
     +,   0.3871333    ,   0.3810293    ,   0.3753332    
     +,   0.3692664    ,   0.3622214    ,   0.3537868    
     +,   0.3437470    ,   0.3320711    ,   0.3188866    
     +,   0.3044515    ,   0.2891184    ,   0.2732973    
     +,   0.2574214    ,   0.2419131    ,   0.2271536    
     +,   0.2134591    ,   0.2010669    ,   0.1901255    
     +,   0.1806931    ,   0.1727452    ,   0.1661860    
     +,   0.1608624    ,   0.1565810    ,   0.1531240    
     +,   0.1502655    ,   0.1477841    ,   0.1454736    
     +,   0.1431508    ,   0.1406619    ,   0.1378843    
     +,   0.1347288    ,   0.1311383    ,   0.1270867    
     +,   0.1225753    ,   0.1176297    ,   0.1122952    
     +,   0.1066326    ,   0.1007129    ,   9.4613597E-02
     +,   8.8414364E-02,   8.2193613E-02,   7.6024771E-02
     +,   6.9974542E-02,   6.4101689E-02,   5.8455084E-02
     +,   5.3073905E-02,   4.7987923E-02,   4.3217871E-02
     +,   3.8775828E-02,   3.4666538E-02,   3.0888731E-02
     +,   2.7435973E-02,   2.4297375E-02,   2.1458913E-02
     +,   1.8904410E-02,   1.6616080E-02,   1.4575032E-02
     +,   1.2761962E-02,   1.1157770E-02,   9.7435415E-03
     +,   8.5010147E-03,   7.4128537E-03,   6.4626937E-03
     +,   5.6351977E-03,   4.9162051E-03,   4.2927829E-03
     +,   3.7531652E-03,   3.2867093E-03,   2.8838827E-03
     +,   2.5362400E-03,   2.2363041E-03,   1.9774854E-03
     +,   1.7540251E-03,   1.5609303E-03,   1.3938536E-03
     +,   1.2490443E-03,   1.1232836E-03,   1.0138057E-03
     +,   9.1823697E-04,   8.3454943E-04,   7.6101895E-04
     +,   6.9617480E-04,   6.3876261E-04,   5.8771577E-04
     +,   5.4213207E-04,   5.0124532E-04,   4.6440278E-04
     +,   4.3105200E-04,   4.0072776E-04,   3.7303343E-04
     +,   3.4763356E-04,   3.2424601E-04,   3.0263214E-04
     +,   2.8258888E-04,   2.6394456E-04,   2.4655514E-04
     +,   2.3029848E-04,   2.1506999E-04,   2.0078065E-04
     +,   1.8735544E-04,   1.7472994E-04,   1.6284778E-04
     +,   1.5166009E-04,   1.4112503E-04,   1.3120468E-04
     +,   1.2186515E-04,   1.1307651E-04,   1.0481136E-04
     +,   9.7043892E-05,   8.9750138E-05,   8.2907944E-05
     +,   7.6496304E-05,   7.0494651E-05,   6.4883330E-05
     +,   5.9643844E-05,   5.4757627E-05,   5.0207262E-05
     +,   4.5975226E-05,   4.2045038E-05,   3.8400154E-05
     +,   3.5024965E-05,   3.1903928E-05,   2.9022320E-05
     +,   2.6365582E-05,   2.3919974E-05,   2.1672042E-05
     +,   1.9608829E-05,   1.7718156E-05,   1.5988078E-05
     +,   1.4407468E-05,   1.2965479E-05,   1.1652045E-05
     +,   1.0457419E-05,   9.3725712E-06,   8.3888290E-06
     +,   7.4981695E-06,   6.6929415E-06,   5.9660929E-06
     +,   5.3109293E-06,   4.7213057E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_asha_htt60_mass = Yx/23.8035589787234
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_asha_htt65_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.5877742E-03,   3.7693251E-03
     +,   3.9598048E-03,   4.1595781E-03,   4.3690018E-03
     +,   4.5884373E-03,   4.8182351E-03,   5.0587440E-03
     +,   5.3102961E-03,   5.5732196E-03,   5.8478247E-03
     +,   6.1344081E-03,   6.4332420E-03,   6.7445841E-03
     +,   7.0686718E-03,   7.4057141E-03,   7.7559086E-03
     +,   8.1194239E-03,   8.4964093E-03,   8.8869901E-03
     +,   9.2912884E-03,   9.7093992E-03,   1.0141409E-02
     +,   1.0587430E-02,   1.1047527E-02,   1.1521821E-02
     +,   1.2010436E-02,   1.2513517E-02,   1.3031268E-02
     +,   1.3563937E-02,   1.4111836E-02,   1.4675365E-02
     +,   1.5255013E-02,   1.5851388E-02,   1.6465211E-02
     +,   1.7097365E-02,   1.7748868E-02,   1.8420920E-02
     +,   1.9114945E-02,   1.9832488E-02,   2.0575378E-02
     +,   2.1345640E-02,   2.2145525E-02,   2.2977522E-02
     +,   2.3844363E-02,   2.4749035E-02,   2.5694750E-02
     +,   2.6685016E-02,   2.7723566E-02,   2.8814439E-02
     +,   2.9961988E-02,   3.1170851E-02,   3.2446075E-02
     +,   3.3793189E-02,   3.5218019E-02,   3.6727149E-02
     +,   3.8327631E-02,   4.0027205E-02,   4.1834265E-02
     +,   4.3757979E-02,   4.5808207E-02,   4.7995545E-02
     +,   5.0331153E-02,   5.2827075E-02,   5.5496253E-02
     +,   5.8352329E-02,   6.1410714E-02,   6.4688385E-02
     +,   6.8205580E-02,   7.1985744E-02,   7.6057807E-02
     +,   8.0456108E-02,   8.5222498E-02,   9.0405673E-02
     +,   9.6062273E-02,   0.1022557    ,   0.1090542    
     +,   0.1165285    ,   0.1247499    ,   0.1337859    
     +,   0.1436953    ,   0.1545264    ,   0.1663110    
     +,   0.1790639    ,   0.1927789    ,   0.2074342    
     +,   0.2229947    ,   0.2394291    ,   0.2567255    
     +,   0.2749248    ,   0.2941589    ,   0.3146929    
     +,   0.3369685    ,   0.3616318    ,   0.3895147    
     +,   0.4215472    ,   0.4585952    ,   0.5012056    
     +,   0.5493482    ,   0.6021964    ,   0.6581074    
     +,   0.7148021    ,   0.7697889    ,   0.8208399    
     +,   0.8664215    ,   0.9058895    ,   0.9394972    
     +,   0.9683213    ,   0.9942563    ,    1.020069    
     +,    1.049352    ,    1.086118    ,    1.133886    
     +,    1.194382    ,    1.266349    ,    1.345362    
     +,    1.425244    ,    1.500605    ,    1.568489    
     +,    1.627675    ,    1.676607    ,    1.713065    
     +,    1.736933    ,    1.753235    ,    1.771368    
     +,    1.800456    ,    1.845271    ,    1.906645    
     +,    1.985251    ,    2.084009    ,    2.205032    
     +,    2.341995    ,    2.476039    ,    2.584525    
     +,    2.658671    ,    2.710770    ,    2.760243    
     +,    2.814126    ,    2.863204    ,    2.890820    
     +,    2.879189    ,    2.813143    ,    2.689003    
     +,    2.521677    ,    2.338005    ,    2.160922    
     +,    1.999611    ,    1.851923    ,    1.712757    
     +,    1.579839    ,    1.453776    ,    1.335268    
     +,    1.223562    ,    1.117287    ,    1.016062    
     +,   0.9210339    ,   0.8341739    ,   0.7572057    
     +,   0.6909325    ,   0.6351676    ,   0.5890244    
     +,   0.5512912    ,   0.5207055    ,   0.4960929    
     +,   0.4764093    ,   0.4607280    ,   0.4481989    
     +,   0.4379995    ,   0.4293107    ,   0.4213228    
     +,   0.4132837    ,   0.4045587    ,   0.3946942    
     +,   0.3834563    ,   0.3708413    ,   0.3570495    
     +,   0.3424343    ,   0.3274363    ,   0.3125120    
     +,   0.2980667    ,   0.2844090    ,   0.2717239    
     +,   0.2600685    ,   0.2493839    ,   0.2395255    
     +,   0.2302954    ,   0.2214767    ,   0.2128612    
     +,   0.2042708    ,   0.1955710    ,   0.1866747    
     +,   0.1775412    ,   0.1681726    ,   0.1586049    
     +,   0.1488994    ,   0.1391342    ,   0.1293979    
     +,   0.1197817    ,   0.1103734    ,   0.1012537    
     +,   9.2494294E-02,   8.4154695E-02,   7.6281190E-02
     +,   6.8906873E-02,   6.2053170E-02,   5.5729058E-02
     +,   4.9933054E-02,   4.4655006E-02,   3.9877154E-02
     +,   3.5575360E-02,   3.1721011E-02,   2.8282598E-02
     +,   2.5226686E-02,   2.2518875E-02,   2.0125020E-02
     +,   1.8012149E-02,   1.6148834E-02,   1.4505628E-02
     +,   1.3055451E-02,   1.1773891E-02,   1.0638986E-02
     +,   9.6313246E-03,   8.7340027E-03,   7.9323556E-03
     +,   7.2137387E-03,   6.5673678E-03,   5.9841340E-03
     +,   5.4563400E-03,   4.9774568E-03,   4.5419931E-03
     +,   4.1453363E-03,   3.7835722E-03,   3.4533453E-03
     +,   3.1517663E-03,   2.8763583E-03,   2.6249164E-03
     +,   2.3954844E-03,   2.1863228E-03,   1.9958459E-03
     +,   1.8225928E-03,   1.6652142E-03,   1.5224678E-03
     +,   1.3931927E-03,   1.2762954E-03,   1.1707513E-03
     +,   1.0756078E-03,   9.8997098E-04,   9.1299874E-04
     +,   8.4390544E-04,   7.8196509E-04,   7.2649639E-04
     +,   6.7686802E-04,   6.3249964E-04,   5.9285591E-04
     +,   5.5744173E-04,   5.2580453E-04,   4.9753260E-04
     +,   4.7225101E-04,   4.4961754E-04,   4.2932303E-04
     +,   4.1108992E-04,   3.9466849E-04,   3.7983395E-04
     +,   3.6638556E-04,   3.5414580E-04,   3.4295616E-04
     +,   3.3267619E-04,   3.2318305E-04,   3.1436875E-04
     +,   3.0613816E-04,   2.9840847E-04,   2.9110821E-04
     +,   2.8417562E-04,   2.7755715E-04,   2.7120672E-04
     +,   2.6508584E-04,   2.5916094E-04,   2.5340452E-04
     +,   2.4779289E-04,   2.4230691E-04,   2.3692999E-04
     +,   2.3164954E-04,   2.2645431E-04,   2.2133632E-04
     +,   2.1628845E-04,   2.1130581E-04,   2.0638436E-04
     +,   2.0152108E-04,   1.9671439E-04,   1.9196272E-04
     +,   1.8726574E-04,   1.8262299E-04,   1.7803497E-04
     +,   1.7350189E-04,   1.6902480E-04,   1.6460429E-04
     +,   1.6024160E-04,   1.5593752E-04,   1.5169353E-04
     +,   1.4751036E-04,   1.4338948E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_asha_htt65_mass = Yx/28.253605625
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_asha_htt70_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.0673817E-03,   3.1917922E-03
     +,   3.3205973E-03,   3.4537942E-03,   3.5913626E-03
     +,   3.7332666E-03,   3.8794556E-03,   4.0298617E-03
     +,   4.1844016E-03,   4.3429853E-03,   4.5055044E-03
     +,   4.6718423E-03,   4.8418753E-03,   5.0154724E-03
     +,   5.1925029E-03,   5.3728363E-03,   5.5563445E-03
     +,   5.7429094E-03,   5.9324233E-03,   6.1247968E-03
     +,   6.3199596E-03,   6.5178666E-03,   6.7184959E-03
     +,   6.9218772E-03,   7.1280501E-03,   7.3371190E-03
     +,   7.5492193E-03,   7.7645369E-03,   7.9833046E-03
     +,   8.2058059E-03,   8.4323771E-03,   8.6634019E-03
     +,   8.8993125E-03,   9.1405874E-03,   9.3877520E-03
     +,   9.6413679E-03,   9.9020274E-03,   1.0170344E-02
     +,   1.0446981E-02,   1.0732561E-02,   1.1027760E-02
     +,   1.1333215E-02,   1.1649564E-02,   1.1977412E-02
     +,   1.2317335E-02,   1.2669876E-02,   1.3035521E-02
     +,   1.3414722E-02,   1.3807887E-02,   1.4215389E-02
     +,   1.4637570E-02,   1.5074790E-02,   1.5527420E-02
     +,   1.5995966E-02,   1.6481007E-02,   1.6983401E-02
     +,   1.7504320E-02,   1.8045368E-02,   1.8608734E-02
     +,   1.9197380E-02,   1.9815158E-02,   2.0467049E-02
     +,   2.1159299E-02,   2.1899646E-02,   2.2697462E-02
     +,   2.3563754E-02,   2.4511369E-02,   2.5554763E-02
     +,   2.6710117E-02,   2.7994866E-02,   2.9427657E-02
     +,   3.1027712E-02,   3.2814790E-02,   3.4808315E-02
     +,   3.7027564E-02,   3.9491162E-02,   4.2216830E-02
     +,   4.5221582E-02,   4.8522037E-02,   5.2134559E-02
     +,   5.6075033E-02,   6.0359873E-02,   6.5004826E-02
     +,   7.0025571E-02,   7.5435936E-02,   8.1247836E-02
     +,   8.7469555E-02,   9.4105959E-02,   0.1011576    
     +,   0.1086232    ,   0.1165021    ,   0.1247985    
     +,   0.1335267    ,   0.1427185    ,   0.1524287    
     +,   0.1627370    ,   0.1737521    ,   0.1856070    
     +,   0.1984573    ,   0.2124736    ,   0.2278450    
     +,   0.2447852    ,   0.2635601    ,   0.2845242    
     +,   0.3081740    ,   0.3351863    ,   0.3664179    
     +,   0.4028388    ,   0.4453863    ,   0.4947604    
     +,   0.5512136    ,   0.6144373    ,   0.6835365    
     +,   0.7571220    ,   0.8334024    ,   0.9103127    
     +,   0.9856950    ,    1.057736    ,    1.125536    
     +,    1.189569    ,    1.251646    ,    1.314413    
     +,    1.380810    ,    1.453645    ,    1.534807    
     +,    1.623888    ,    1.717595    ,    1.813158    
     +,    1.916497    ,    2.046490    ,    2.222288    
     +,    2.437462    ,    2.652321    ,    2.825107    
     +,    2.949911    ,    3.050626    ,    3.141420    
     +,    3.214854    ,    3.278495    ,    3.382848    
     +,    3.578641    ,    3.843587    ,    4.086698    
     +,    4.234200    ,    4.282862    ,    4.267669    
     +,    4.199893    ,    4.052621    ,    3.813510    
     +,    3.520389    ,    3.221273    ,    2.933075    
     +,    2.652434    ,    2.379407    ,    2.122342    
     +,    1.890180    ,    1.685702    ,    1.506163    
     +,    1.348254    ,    1.210888    ,    1.094398    
     +,   0.9986536    ,   0.9219009    ,   0.8606320    
     +,   0.8102843    ,   0.7663553    ,   0.7254702    
     +,   0.6859480    ,   0.6477208    ,   0.6117174    
     +,   0.5790702    ,   0.5504836    ,   0.5259752    
     +,   0.5049742    ,   0.4866136    ,   0.4700239    
     +,   0.4545312    ,   0.4397098    ,   0.4253316    
     +,   0.4112644    ,   0.3973807    ,   0.3835016    
     +,   0.3693878    ,   0.3547685    ,   0.3393958    
     +,   0.3231032    ,   0.3058463    ,   0.2877211    
     +,   0.2689551    ,   0.2498773    ,   0.2308687    
     +,   0.2123123    ,   0.1945504    ,   0.1778501    
     +,   0.1623868    ,   0.1482425    ,   0.1354187    
     +,   0.1238523    ,   0.1134379    ,   0.1040483    
     +,   9.5552854E-02,   8.7828383E-02,   8.0766387E-02
     +,   7.4276306E-02,   6.8285994E-02,   6.2738150E-02
     +,   5.7588212E-02,   5.2801456E-02,   4.8349947E-02
     +,   4.4210281E-02,   4.0362269E-02,   3.6788478E-02
     +,   3.3473082E-02,   3.0401444E-02,   2.7560096E-02
     +,   2.4936670E-02,   2.2519518E-02,   2.0297399E-02
     +,   1.8259501E-02,   1.6395472E-02,   1.4694915E-02
     +,   1.3147576E-02,   1.1743414E-02,   1.0472480E-02
     +,   9.3249045E-03,   8.2910759E-03,   7.3617571E-03
     +,   6.5280679E-03,   5.7814992E-03,   5.1140422E-03
     +,   4.5182318E-03,   3.9871368E-03,   3.5143108E-03
     +,   3.0938517E-03,   2.7203984E-03,   2.3890447E-03
     +,   2.0953419E-03,   1.8352927E-03,   1.6052923E-03
     +,   1.4020817E-03,   1.2227381E-03,   1.0646506E-03
     +,   9.2547934E-04,   8.0311927E-04,   6.9568801E-04
     +,   6.0150918E-04,   5.1908160E-04,   4.4705832E-04
     +,   3.8423622E-04,   3.2954593E-04,   2.8202691E-04
     +,   2.4082234E-04,   2.0517067E-04,   1.7439296E-04
     +,   1.4788273E-04,   1.2510143E-04,   1.0557257E-04
     +,   8.8873720E-05,   7.4630327E-05,   6.2512103E-05
     +,   5.2229214E-05,   4.3526965E-05,   3.6181737E-05
     +,   2.9998413E-05,   2.4807616E-05,   2.0461761E-05
     +,   1.6833141E-05,   1.3811813E-05,   1.1303156E-05
     +,   9.2258488E-06,   7.5104326E-06,   6.0978341E-06
     +,   4.9378573E-06,   3.9879378E-06,   3.2121748E-06
     +,   2.5804416E-06,   2.0673961E-06,   1.6519278E-06
     +,   1.3163947E-06,   1.0461936E-06,   8.2919752E-07
     +,   6.5543031E-07,   5.1666228E-07,   4.0616339E-07
     +,   3.1841699E-07,   2.4894084E-07,   1.9408478E-07
     +,   1.5089441E-07,   1.1698842E-07,   9.0445674E-08
     +,   6.9728365E-08,   5.3603660E-08,   4.1090846E-08
     +,   3.1408497E-08,   2.3938828E-08,   1.8192734E-08
     +,   1.3785887E-08,   1.0415961E-08,   7.8468094E-09
     +,   5.8939080E-09,   4.4139918E-09
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_asha_htt70_mass = Yx/32.8302248571429
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_asha_htt75_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.7314672E-03,   1.7721152E-03
     +,   1.8151979E-03,   1.8608975E-03,   1.9094031E-03
     +,   1.9609067E-03,   2.0156039E-03,   2.0736926E-03
     +,   2.1353699E-03,   2.2008352E-03,   2.2702841E-03
     +,   2.3439082E-03,   2.4218950E-03,   2.5044242E-03
     +,   2.5916670E-03,   2.6837850E-03,   2.7809278E-03
     +,   2.8832299E-03,   2.9908130E-03,   3.1037808E-03
     +,   3.2222187E-03,   3.3461950E-03,   3.4757541E-03
     +,   3.6109313E-03,   3.7517252E-03,   3.8981298E-03
     +,   4.0501114E-03,   4.2076195E-03,   4.3705897E-03
     +,   4.5389393E-03,   4.7125793E-03,   4.8914081E-03
     +,   5.0753229E-03,   5.2642208E-03,   5.4580034E-03
     +,   5.6565856E-03,   5.8598984E-03,   6.0678958E-03
     +,   6.2805745E-03,   6.4979466E-03,   6.7200977E-03
     +,   6.9471519E-03,   7.1793017E-03,   7.4168048E-03
     +,   7.6600043E-03,   7.9093203E-03,   8.1652720E-03
     +,   8.4284712E-03,   8.6996295E-03,   8.9795748E-03
     +,   9.2692301E-03,   9.5696375E-03,   9.8819407E-03
     +,   1.0207416E-02,   1.0547406E-02,   1.0903399E-02
     +,   1.1276952E-02,   1.1669735E-02,   1.2083502E-02
     +,   1.2520077E-02,   1.2981375E-02,   1.3469387E-02
     +,   1.3986128E-02,   1.4533726E-02,   1.5114364E-02
     +,   1.5730221E-02,   1.6383598E-02,   1.7076744E-02
     +,   1.7812047E-02,   1.8591795E-02,   1.9418385E-02
     +,   2.0294080E-02,   2.1221157E-02,   2.2201674E-02
     +,   2.3237575E-02,   2.4330556E-02,   2.5481835E-02
     +,   2.6692199E-02,   2.7961833E-02,   2.9290248E-02
     +,   3.0675896E-02,   3.2116443E-02,   3.3608265E-02
     +,   3.5146758E-02,   3.6726005E-02,   3.8339261E-02
     +,   3.9978772E-02,   4.1636571E-02,   4.3304760E-02
     +,   4.4976603E-02,   4.6647593E-02,   4.8316743E-02
     +,   4.9988352E-02,   5.1674325E-02,   5.3396109E-02
     +,   5.5186976E-02,   5.7094678E-02,   5.9182886E-02
     +,   6.1533067E-02,   6.4244650E-02,   6.7435034E-02
     +,   7.1237162E-02,   7.5797521E-02,   8.1271134E-02
     +,   8.7817259E-02,   9.5593393E-02,   0.1047472    
     +,   0.1154085    ,   0.1276800    ,   0.1416245    
     +,   0.1572518    ,   0.1745116    ,   0.1932871    
     +,   0.2134104    ,   0.2346865    ,   0.2569475    
     +,   0.2801116    ,   0.3042617    ,   0.3297079    
     +,   0.3570542    ,   0.3872455    ,   0.4216202    
     +,   0.4619899    ,   0.5107398    ,   0.5708394    
     +,   0.6454759    ,   0.7370097    ,   0.8453685    
     +,   0.9672034    ,    1.097704    ,    1.235664    
     +,    1.387910    ,    1.566165    ,    1.774044    
     +,    1.995570    ,    2.201649    ,    2.371385    
     +,    2.503621    ,    2.611828    ,    2.724966    
     +,    2.892956    ,    3.163886    ,    3.535669    
     +,    3.932318    ,    4.258772    ,    4.505141    
     +,    4.748999    ,    5.022712    ,    5.240117    
     +,    5.329710    ,    5.366469    ,    5.385316    
     +,    5.254681    ,    4.919161    ,    4.499244    
     +,    4.109429    ,    3.755167    ,    3.397619    
     +,    3.036861    ,    2.724002    ,    2.498696    
     +,    2.338144    ,    2.187426    ,    2.013603    
     +,    1.819425    ,    1.625448    ,    1.448794    
     +,    1.294220    ,    1.159075    ,    1.041698    
     +,   0.9437655    ,   0.8670014    ,   0.8098291    
     +,   0.7671869    ,   0.7328160    ,   0.7017213    
     +,   0.6712541    ,   0.6406896    ,   0.6101512    
     +,   0.5797234    ,   0.5491440    ,   0.5179611    
     +,   0.4858606    ,   0.4529336    ,   0.4197508    
     +,   0.3872465    ,   0.3564771    ,   0.3283600    
     +,   0.3034854    ,   0.2820445    ,   0.2638614    
     +,   0.2485074    ,   0.2354345    ,   0.2240879    
     +,   0.2139775    ,   0.2047083    ,   0.1959787    
     +,   0.1875618    ,   0.1792833    ,   0.1710064    
     +,   0.1626241    ,   0.1540572    ,   0.1452568    
     +,   0.1362076    ,   0.1269309    ,   0.1174813    
     +,   0.1079424    ,   9.8420456E-02,   8.9034103E-02
     +,   7.9904176E-02,   7.1145371E-02,   6.2859200E-02
     +,   5.5127956E-02,   4.8010837E-02,   4.1543655E-02
     +,   3.5739940E-02,   3.0592551E-02,   2.6076905E-02
     +,   2.2155112E-02,   1.8780233E-02,   1.5899273E-02
     +,   1.3456971E-02,   1.1398574E-02,   9.6716713E-03
     +,   8.2276370E-03,   7.0225671E-03,   6.0177916E-03
     +,   5.1797559E-03,   4.4797696E-03,   3.8936792E-03
     +,   3.4014012E-03,   2.9863445E-03,   2.6348713E-03
     +,   2.3358620E-03,   2.0802980E-03,   1.8608336E-03
     +,   1.6715082E-03,   1.5074917E-03,   1.3648446E-03
     +,   1.2403375E-03,   1.1313132E-03,   1.0355806E-03
     +,   9.5131126E-04,   8.7696314E-04,   8.1123121E-04
     +,   7.5300457E-04,   7.0132851E-04,   6.5537210E-04
     +,   6.1441358E-04,   5.7782547E-04,   5.4505374E-04
     +,   5.1561266E-04,   4.8907613E-04,   4.6506984E-04
     +,   4.4326298E-04,   4.2336559E-04,   4.0512497E-04
     +,   3.8832019E-04,   3.7275755E-04,   3.5826926E-04
     +,   3.4471077E-04,   3.3195777E-04,   3.1990232E-04
     +,   3.0845276E-04,   2.9753192E-04,   2.8707349E-04
     +,   2.7702193E-04,   2.6733126E-04,   2.5796337E-04
     +,   2.4888630E-04,   2.4007396E-04,   2.3150558E-04
     +,   2.2316464E-04,   2.1503748E-04,   2.0711328E-04
     +,   1.9938452E-04,   1.9184440E-04,   1.8448883E-04
     +,   1.7731391E-04,   1.7031758E-04,   1.6349767E-04
     +,   1.5685338E-04,   1.5038339E-04,   1.4408756E-04
     +,   1.3796490E-04,   1.3201531E-04,   1.2623814E-04
     +,   1.2063257E-04,   1.1519822E-04,   1.0993388E-04
     +,   1.0483879E-04,   9.9911347E-05,   9.5150397E-05
     +,   9.0553920E-05,   8.6120337E-05,   8.1847269E-05
     +,   7.7732686E-05,   7.3773888E-05,   6.9968439E-05
     +,   6.6313303E-05,   6.2805782E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_asha_htt75_mass = Yx/35.00074284
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_asha_htt80_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.2030352E-03,   1.2494730E-03
     +,   1.2964492E-03,   1.3439116E-03,   1.3918080E-03
     +,   1.4400874E-03,   1.4887018E-03,   1.5376057E-03
     +,   1.5867573E-03,   1.6361225E-03,   1.6856709E-03
     +,   1.7353818E-03,   1.7852421E-03,   1.8352502E-03
     +,   1.8854163E-03,   1.9357650E-03,   1.9863367E-03
     +,   2.0371904E-03,   2.0884047E-03,   2.1400827E-03
     +,   2.1923508E-03,   2.2453668E-03,   2.2993162E-03
     +,   2.3544244E-03,   2.4109492E-03,   2.4691939E-03
     +,   2.5295056E-03,   2.5922789E-03,   2.6579632E-03
     +,   2.7270615E-03,   2.8001370E-03,   2.8778145E-03
     +,   2.9607846E-03,   3.0498060E-03,   3.1457033E-03
     +,   3.2493745E-03,   3.3617839E-03,   3.4839660E-03
     +,   3.6170289E-03,   3.7621260E-03,   3.9204881E-03
     +,   4.0933862E-03,   4.2821355E-03,   4.4880835E-03
     +,   4.7125993E-03,   4.9570561E-03,   5.2228170E-03
     +,   5.5112159E-03,   5.8235372E-03,   6.1609969E-03
     +,   6.5247118E-03,   6.9156894E-03,   7.3347744E-03
     +,   7.7826781E-03,   8.2598664E-03,   8.7666269E-03
     +,   9.3029840E-03,   9.8686907E-03,   1.0463222E-02
     +,   1.1085738E-02,   1.1735099E-02,   1.2409844E-02
     +,   1.3108162E-02,   1.3827959E-02,   1.4566884E-02
     +,   1.5322220E-02,   1.6091121E-02,   1.6870469E-02
     +,   1.7657124E-02,   1.8447798E-02,   1.9239362E-02
     +,   2.0028751E-02,   2.0813292E-02,   2.1590633E-02
     +,   2.2359116E-02,   2.3117866E-02,   2.3866968E-02
     +,   2.4607699E-02,   2.5342885E-02,   2.6077049E-02
     +,   2.6816621E-02,   2.7570369E-02,   2.8349400E-02
     +,   2.9167637E-02,   3.0041711E-02,   3.0991247E-02
     +,   3.2038584E-02,   3.3208944E-02,   3.4529600E-02
     +,   3.6029786E-02,   3.7739627E-02,   3.9689068E-02
     +,   4.1906502E-02,   4.4417419E-02,   4.7242600E-02
     +,   5.0395772E-02,   5.3882480E-02,   5.7697602E-02
     +,   6.1824735E-02,   6.6234529E-02,   7.0885636E-02
     +,   7.5724415E-02,   8.0688067E-02,   8.5706547E-02
     +,   9.0707533E-02,   9.5621139E-02,   0.1003850    
     +,   0.1049508    ,   0.1092897    ,   0.1133974    
     +,   0.1172976    ,   0.1210447    ,   0.1247235    
     +,   0.1284484    ,   0.1323586    ,   0.1366144    
     +,   0.1413894    ,   0.1468671    ,   0.1532353    
     +,   0.1606884    ,   0.1694345    ,   0.1797094    
     +,   0.1918000    ,   0.2060714    ,   0.2229892    
     +,   0.2431220    ,   0.2671132    ,   0.2955884    
     +,   0.3290074    ,   0.3674523    ,   0.4104488    
     +,   0.4569049    ,   0.5053469    ,   0.5544580    
     +,   0.6038826    ,   0.6550618    ,   0.7119153    
     +,   0.7810649    ,   0.8710178    ,   0.9899929    
     +,    1.143559    ,    1.334216    ,    1.562323    
     +,    1.825005    ,    2.114129    ,    2.419795    
     +,    2.740391    ,    3.091856    ,    3.498740    
     +,    3.959551    ,    4.455431    ,    5.015411    
     +,    5.611220    ,    6.063141    ,    6.386448    
     +,    6.759596    ,    6.973855    ,    6.883677    
     +,    6.820210    ,    6.799464    ,    6.538951    
     +,    6.062592    ,    5.472715    ,    4.805614    
     +,    4.128331    ,    3.535574    ,    3.091372    
     +,    2.781204    ,    2.549859    ,    2.352513    
     +,    2.170561    ,    1.999228    ,    1.835691    
     +,    1.678412    ,    1.525683    ,    1.374908    
     +,    1.227788    ,    1.093270    ,   0.9822283    
     +,   0.8993094    ,   0.8396835    ,   0.7923003    
     +,   0.7459764    ,   0.6939790    ,   0.6352335    
     +,   0.5727893    ,   0.5113068    ,   0.4549857    
     +,   0.4065189    ,   0.3669306    ,   0.3358842    
     +,   0.3121592    ,   0.2940873    ,   0.2798957    
     +,   0.2679438    ,   0.2568707    ,   0.2456636    
     +,   0.2336686    ,   0.2205630    ,   0.2063046    
     +,   0.1910661    ,   0.1751640    ,   0.1589875    
     +,   0.1429398    ,   0.1273913    ,   0.1126458    
     +,   9.8925970E-02,   8.6371385E-02,   7.5045437E-02
     +,   6.4948119E-02,   5.6032967E-02,   4.8223209E-02
     +,   4.1424442E-02,   3.5534892E-02,   3.0453041E-02
     +,   2.6082641E-02,   2.2334583E-02,   1.9127743E-02
     +,   1.6389394E-02,   1.4055024E-02,   1.2067235E-02
     +,   1.0375509E-02,   8.9357104E-03,   7.7093975E-03
     +,   6.6633145E-03,   5.7690251E-03,   5.0024455E-03
     +,   4.3433071E-03,   3.7746406E-03,   3.2823756E-03
     +,   2.8549097E-03,   2.4826855E-03,   2.1577873E-03
     +,   1.8736814E-03,   1.6249623E-03,   1.4070797E-03
     +,   1.2161959E-03,   1.0490500E-03,   9.0283481E-04
     +,   7.7509979E-04,   6.6369976E-04,   5.6674972E-04
     +,   4.8257425E-04,   4.0967576E-04,   3.4671617E-04
     +,   2.9250261E-04,   2.4596625E-04,   2.0614742E-04
     +,   1.7218929E-04,   1.4333085E-04,   1.1889203E-04
     +,   9.8269949E-05,   8.0933161E-05,   6.6413180E-05
     +,   5.4297947E-05,   4.4227723E-05,   3.5890138E-05
     +,   2.9014325E-05,   2.3366283E-05,   1.8745164E-05
     +,   1.4979615E-05,   1.1923778E-05,   9.4539428E-06
     +,   7.4658960E-06,   5.8723936E-06,   4.6004220E-06
     +,   3.5893343E-06,   2.7890521E-06,   2.1583323E-06
     +,   1.6633554E-06,   1.2765666E-06,   9.7563452E-07
     +,   7.4252517E-07,   5.6273393E-07,   4.2466920E-07
     +,   3.1912023E-07,   2.3878027E-07,   1.7790364E-07
     +,   1.3197722E-07,   9.7486172E-08,   7.1697393E-08
     +,   5.2502969E-08,   3.8279918E-08,   2.7788737E-08
     +,   2.0084741E-08,   1.4453323E-08,   1.0355379E-08
     +,   7.3867459E-09,   5.2461013E-09,   3.7094101E-09
     +,   2.6113542E-09,   1.8302366E-09,   1.2771406E-09
     +,   8.8725399E-10,   6.1368471E-10,   4.2258932E-10
     +,   2.8972008E-10,   1.9774866E-10,   1.3437994E-10
     +,   9.0913901E-11,   6.1236877E-11
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_asha_htt80_mass = Yx/38.40778788
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_asha_htt85_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  6.4608546E-05,   7.0344722E-05
     +,   7.6559394E-05,   8.3291452E-05,   9.0582871E-05
     +,   9.8478988E-05,   1.0702866E-04,   1.1628443E-04
     +,   1.2630269E-04,   1.3714453E-04,   1.4887481E-04
     +,   1.6156308E-04,   1.7528376E-04,   1.9011588E-04
     +,   2.0614370E-04,   2.2345636E-04,   2.4214826E-04
     +,   2.6231896E-04,   2.8407329E-04,   3.0752106E-04
     +,   3.3277748E-04,   3.5996237E-04,   3.8920023E-04
     +,   4.2062212E-04,   4.5436004E-04,   4.9055397E-04
     +,   5.2934606E-04,   5.7088281E-04,   6.1531464E-04
     +,   6.6279550E-04,   7.1348331E-04,   7.6753978E-04
     +,   8.2513090E-04,   8.8642642E-04,   9.5160218E-04
     +,   1.0208390E-03,   1.0943254E-03,   1.1722567E-03
     +,   1.2548428E-03,   1.3422979E-03,   1.4348590E-03
     +,   1.5327759E-03,   1.6363194E-03,   1.7457851E-03
     +,   1.8614955E-03,   1.9838081E-03,   2.1131132E-03
     +,   2.2498448E-03,   2.3944832E-03,   2.5475568E-03
     +,   2.7096514E-03,   2.8814101E-03,   3.0635360E-03
     +,   3.2568085E-03,   3.4620499E-03,   3.6801752E-03
     +,   3.9121448E-03,   4.1589863E-03,   4.4217822E-03
     +,   4.7016600E-03,   4.9997796E-03,   5.3173350E-03
     +,   5.6554992E-03,   6.0154521E-03,   6.3983453E-03
     +,   6.8052262E-03,   7.2371070E-03,   7.6948269E-03
     +,   8.1791384E-03,   8.6905630E-03,   9.2294840E-03
     +,   9.7960085E-03,   1.0390073E-02,   1.1011302E-02
     +,   1.1659141E-02,   1.2332806E-02,   1.3031282E-02
     +,   1.3753395E-02,   1.4497916E-02,   1.5263605E-02
     +,   1.6049204E-02,   1.6853755E-02,   1.7676469E-02
     +,   1.8517081E-02,   1.9375758E-02,   2.0253427E-02
     +,   2.1151653E-02,   2.2072921E-02,   2.3020469E-02
     +,   2.3998437E-02,   2.5011754E-02,   2.6065901E-02
     +,   2.7166793E-02,   2.8320631E-02,   2.9533466E-02
     +,   3.0810816E-02,   3.2157529E-02,   3.3577178E-02
     +,   3.5072085E-02,   3.6642749E-02,   3.8288169E-02
     +,   4.0005483E-02,   4.1790657E-02,   4.3638520E-02
     +,   4.5543771E-02,   4.7501948E-02,   4.9510468E-02
     +,   5.1570419E-02,   5.3688783E-02,   5.5880710E-02
     +,   5.8172144E-02,   6.0603499E-02,   6.3232198E-02
     +,   6.6136047E-02,   6.9414303E-02,   7.3187858E-02
     +,   7.7595159E-02,   8.2785681E-02,   8.8906571E-02
     +,   9.6087210E-02,   0.1044190    ,   0.1139338    
     +,   0.1245870    ,   0.1362479    ,   0.1487022    
     +,   0.1616695    ,   0.1748423    ,   0.1879340    
     +,   0.2007435    ,   0.2132093    ,   0.2254552    
     +,   0.2377971    ,   0.2507122    ,   0.2647505    
     +,   0.2804142    ,   0.2980160    ,   0.3175658    
     +,   0.3387417    ,   0.3609896    ,   0.3837680    
     +,   0.4069026    ,   0.4309441    ,   0.4573688    
     +,   0.4884950    ,   0.5271319    ,   0.5761428    
     +,   0.6381626    ,   0.7156273    ,   0.8110885    
     +,   0.9276578    ,    1.069812    ,    1.245577    
     +,    1.468265    ,    1.748778    ,    2.078477    
     +,    2.432417    ,    2.810291    ,    3.265022    
     +,    3.875189    ,    4.694040    ,    5.665423    
     +,    6.626206    ,    7.394374    ,    7.873370    
     +,    8.009027    ,    7.787822    ,    7.530575    
     +,    7.424036    ,    7.543915    ,    7.443725    
     +,    6.731381    ,    5.773930    ,    4.882723    
     +,    4.234195    ,    3.812934    ,    3.378520    
     +,    2.867244    ,    2.402757    ,    2.049320    
     +,    1.775037    ,    1.536482    ,    1.323250    
     +,    1.147638    ,    1.018096    ,   0.9277790    
     +,   0.8610024    ,   0.8037119    ,   0.7484720    
     +,   0.6938519    ,   0.6417097    ,   0.5947303    
     +,   0.5548589    ,   0.5225012    ,   0.4963491    
     +,   0.4738036    ,   0.4518077    ,   0.4277687    
     +,   0.4002163    ,   0.3690084    ,   0.3351040    
     +,   0.3000813    ,   0.2656119    ,   0.2330671    
     +,   0.2033293    ,   0.1767880    ,   0.1534429    
     +,   0.1330579    ,   0.1152961    ,   9.9810705E-02
     +,   8.6292297E-02,   7.4483931E-02,   6.4177275E-02
     +,   5.5200052E-02,   4.7404263E-02,   4.0658463E-02
     +,   3.4843318E-02,   2.9848544E-02,   2.5571927E-02
     +,   2.1919750E-02,   1.8807258E-02,   1.6158132E-02
     +,   1.3904863E-02,   1.1988685E-02,   1.0358830E-02
     +,   8.9718131E-03,   7.7907746E-03,   6.7846766E-03
     +,   5.9273425E-03,   5.1966356E-03,   4.5738369E-03
     +,   4.0430753E-03,   3.5907927E-03,   3.2053269E-03
     +,   2.8766550E-03,   2.5961665E-03,   2.3564093E-03
     +,   2.1509705E-03,   1.9743543E-03,   1.8218512E-03
     +,   1.6894377E-03,   1.5736986E-03,   1.4717591E-03
     +,   1.3812043E-03,   1.3000147E-03,   1.2265167E-03
     +,   1.1593393E-03,   1.0973634E-03,   1.0396806E-03
     +,   9.8556362E-04,   9.3444233E-04,   8.8586594E-04
     +,   8.3948695E-04,   7.9504517E-04,   7.5234630E-04
     +,   7.1124756E-04,   6.7164662E-04,   6.3347601E-04
     +,   5.9669133E-04,   5.6126266E-04,   5.2717183E-04
     +,   4.9441023E-04,   4.6297305E-04,   4.3285530E-04
     +,   4.0405148E-04,   3.7655741E-04,   3.5036317E-04
     +,   3.2545609E-04,   3.0182133E-04,   2.7944034E-04
     +,   2.5828934E-04,   2.3834115E-04,   2.1956681E-04
     +,   2.0193396E-04,   1.8540661E-04,   1.6994659E-04
     +,   1.5551530E-04,   1.4207064E-04,   1.2957120E-04
     +,   1.1797307E-04,   1.0723335E-04,   9.7307624E-05
     +,   8.8152854E-05,   7.9725236E-05,   7.1982671E-05
     +,   6.4882828E-05,   5.8385405E-05,   5.2450556E-05
     +,   4.7039812E-05,   4.2116670E-05,   3.7645419E-05
     +,   3.3592558E-05,   2.9925666E-05,   2.6614462E-05
     +,   2.3629857E-05,   2.0944881E-05,   1.8533787E-05
     +,   1.6372827E-05,   1.4439528E-05,   1.2713223E-05
     +,   1.1174502E-05,   9.8055989E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_asha_htt85_mass = Yx/38.50444164
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_asha_htt90_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.2181494E-03,   1.2507956E-03
     +,   1.2834932E-03,   1.3162323E-03,   1.3490063E-03
     +,   1.3818129E-03,   1.4146531E-03,   1.4475342E-03
     +,   1.4804666E-03,   1.5134683E-03,   1.5465604E-03
     +,   1.5797707E-03,   1.6131327E-03,   1.6466851E-03
     +,   1.6804726E-03,   1.7145465E-03,   1.7489636E-03
     +,   1.7837855E-03,   1.8190804E-03,   1.8549212E-03
     +,   1.8913844E-03,   1.9285530E-03,   1.9665121E-03
     +,   2.0053519E-03,   2.0451620E-03,   2.0860361E-03
     +,   2.1280688E-03,   2.1713532E-03,   2.2159819E-03
     +,   2.2620456E-03,   2.3096316E-03,   2.3588226E-03
     +,   2.4096959E-03,   2.4623226E-03,   2.5167647E-03
     +,   2.5730778E-03,   2.6313048E-03,   2.6914799E-03
     +,   2.7536291E-03,   2.8177581E-03,   2.8838713E-03
     +,   2.9519540E-03,   3.0219820E-03,   3.0939211E-03
     +,   3.1677266E-03,   3.2433472E-03,   3.3207210E-03
     +,   3.3997872E-03,   3.4804805E-03,   3.5627389E-03
     +,   3.6465062E-03,   3.7317353E-03,   3.8183932E-03
     +,   3.9064721E-03,   3.9959783E-03,   4.0869568E-03
     +,   4.1794861E-03,   4.2736810E-03,   4.3697064E-03
     +,   4.4677733E-03,   4.5681489E-03,   4.6711606E-03
     +,   4.7771842E-03,   4.8866649E-03,   5.0001130E-03
     +,   5.1180758E-03,   5.2411780E-03,   5.3700693E-03
     +,   5.5054631E-03,   5.6480812E-03,   5.7986877E-03
     +,   5.9580351E-03,   6.1268876E-03,   6.3059679E-03
     +,   6.4959810E-03,   6.6975830E-03,   6.9113504E-03
     +,   7.1377880E-03,   7.3773190E-03,   7.6302881E-03
     +,   7.8969225E-03,   8.1773875E-03,   8.4717451E-03
     +,   8.7800343E-03,   9.1022262E-03,   9.4383359E-03
     +,   9.7883819E-03,   1.0152525E-02,   1.0531032E-02
     +,   1.0924424E-02,   1.1333501E-02,   1.1759382E-02
     +,   1.2203589E-02,   1.2668126E-02,   1.3155500E-02
     +,   1.3668702E-02,   1.4211308E-02,   1.4787335E-02
     +,   1.5401356E-02,   1.6058296E-02,   1.6763492E-02
     +,   1.7522467E-02,   1.8341037E-02,   1.9225065E-02
     +,   2.0180658E-02,   2.1214129E-02,   2.2332132E-02
     +,   2.3541920E-02,   2.4851833E-02,   2.6271641E-02
     +,   2.7812935E-02,   2.9489879E-02,   3.1319190E-02
     +,   3.3320639E-02,   3.5516363E-02,   3.7930433E-02
     +,   4.0586945E-02,   4.3508451E-02,   4.6712399E-02
     +,   5.0208595E-02,   5.3995281E-02,   5.8055792E-02
     +,   6.2356044E-02,   6.6843927E-02,   7.1449690E-02
     +,   7.6088861E-02,   8.0669113E-02,   8.5097335E-02
     +,   8.9291096E-02,   9.3189098E-02,   9.6762910E-02
     +,   0.1000256    ,   0.1030389    ,   0.1059140    
     +,   0.1088092    ,   0.1119223    ,   0.1154800    
     +,   0.1197261    ,   0.1249105    ,   0.1312829    
     +,   0.1390881    ,   0.1485673    ,   0.1599629    
     +,   0.1735230    ,   0.1895063    ,   0.2081934    
     +,   0.2299031    ,   0.2550198    ,   0.2840342    
     +,   0.3175874    ,   0.3564982    ,   0.4017618    
     +,   0.4545542    ,   0.5162595    ,   0.5884448    
     +,   0.6724250    ,   0.7680407    ,   0.8722788    
     +,   0.9803863    ,    1.091792    ,    1.217772    
     +,    1.382675    ,    1.613273    ,    1.917504    
     +,    2.268295    ,    2.630779    ,    3.019938    
     +,    3.493730    ,    4.129481    ,    4.987147    
     +,    5.968226    ,    6.934318    ,    7.907137    
     +,    8.759533    ,    9.239861    ,    9.483953    
     +,    9.497398    ,    8.941156    ,    7.811266    
     +,    6.671158    ,    5.874101    ,    5.064448    
     +,    4.280148    ,    3.697839    ,    3.255786    
     +,    2.908147    ,    2.633257    ,    2.383162    
     +,    2.114391    ,    1.826854    ,    1.559440    
     +,    1.350164    ,    1.208150    ,    1.115479    
     +,    1.044508    ,   0.9742305    ,   0.8973750    
     +,   0.8175492    ,   0.7417443    ,   0.6744753    
     +,   0.6161753    ,   0.5646076    ,   0.5169406    
     +,   0.4710426    ,   0.4257866    ,   0.3808160    
     +,   0.3362421    ,   0.2924728    ,   0.2501444    
     +,   0.2100647    ,   0.1731014    ,   0.1400230    
     +,   0.1113421    ,   8.7229662E-02,   6.7522958E-02
     +,   5.1803540E-02,   3.9506026E-02,   3.0022599E-02
     +,   2.2780832E-02,   1.7285636E-02,   1.3131283E-02
     +,   9.9977301E-03,   7.6379431E-03,   5.8631403E-03
     +,   4.5297975E-03,   3.5292504E-03,   2.7794617E-03
     +,   2.2185438E-03,   1.7998409E-03,   1.4882057E-03
     +,   1.2571194E-03,   1.0864912E-03,   9.6104888E-04
     +,   8.6917460E-04,   8.0203393E-04,   7.5291388E-04
     +,   7.1674795E-04,   6.8974344E-04,   6.6908909E-04
     +,   6.5272558E-04,   6.3916703E-04,   6.2735903E-04
     +,   6.1656628E-04,   6.0628611E-04,   5.9618359E-04
     +,   5.8604323E-04,   5.7573244E-04,   5.6517433E-04
     +,   5.5433041E-04,   5.4318859E-04,   5.3175230E-04
     +,   5.2003545E-04,   5.0805951E-04,   4.9584993E-04
     +,   4.8343398E-04,   4.7083996E-04,   4.5809796E-04
     +,   4.4523788E-04,   4.3228874E-04,   4.1927909E-04
     +,   4.0623778E-04,   3.9319284E-04,   3.8017076E-04
     +,   3.6719686E-04,   3.5429696E-04,   3.4149448E-04
     +,   3.2881164E-04,   3.1627025E-04,   3.0389093E-04
     +,   2.9169227E-04,   2.7969145E-04,   2.6790521E-04
     +,   2.5634893E-04,   2.4503583E-04,   2.3397781E-04
     +,   2.2318664E-04,   2.1267126E-04,   2.0244066E-04
     +,   1.9250131E-04,   1.8285975E-04,   1.7351998E-04
     +,   1.6448612E-04,   1.5576003E-04,   1.4734361E-04
     +,   1.3923667E-04,   1.3143904E-04,   1.2394894E-04
     +,   1.1676380E-04,   1.0988088E-04,   1.0329586E-04
     +,   9.7004588E-05,   9.1001471E-05,   8.5281208E-05
     +,   7.9837111E-05,   7.4662945E-05,   6.9751281E-05
     +,   6.5095039E-05,   6.0686256E-05,   5.6517321E-05
     +,   5.2579864E-05,   4.8865910E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_asha_htt90_mass = Yx/39.42265236
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_asha_htt95_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  5.2997074E-04,   5.5869855E-04
     +,   5.8921904E-04,   6.2166894E-04,   6.5619225E-04
     +,   6.9293968E-04,   7.3206850E-04,   7.7374111E-04
     +,   8.1812375E-04,   8.6538855E-04,   9.1570761E-04
     +,   9.6925430E-04,   1.0262018E-03,   1.0867203E-03
     +,   1.1509765E-03,   1.2191302E-03,   1.2913339E-03
     +,   1.3677292E-03,   1.4484463E-03,   1.5336010E-03
     +,   1.6232922E-03,   1.7176016E-03,   1.8165889E-03
     +,   1.9202997E-03,   2.0287449E-03,   2.1419234E-03
     +,   2.2598030E-03,   2.3823269E-03,   2.5094156E-03
     +,   2.6409638E-03,   2.7768402E-03,   2.9168937E-03
     +,   3.0609495E-03,   3.2088130E-03,   3.3602740E-03
     +,   3.5151050E-03,   3.6730664E-03,   3.8339067E-03
     +,   3.9973794E-03,   4.1632140E-03,   4.3311608E-03
     +,   4.5009605E-03,   4.6723620E-03,   4.8451228E-03
     +,   5.0190124E-03,   5.1938109E-03,   5.3693135E-03
     +,   5.5453321E-03,   5.7216948E-03,   5.8982433E-03
     +,   6.0748416E-03,   6.2513687E-03,   6.4277165E-03
     +,   6.6038053E-03,   6.7795487E-03,   6.9548972E-03
     +,   7.1298038E-03,   7.3042372E-03,   7.4781803E-03
     +,   7.6516303E-03,   7.8245997E-03,   7.9971226E-03
     +,   8.1692385E-03,   8.3410265E-03,   8.5125882E-03
     +,   8.6840419E-03,   8.8555608E-03,   9.0273321E-03
     +,   9.1996193E-03,   9.3727037E-03,   9.5469486E-03
     +,   9.7227478E-03,   9.9005848E-03,   1.0080977E-02
     +,   1.0264538E-02,   1.0451925E-02,   1.0643865E-02
     +,   1.0841131E-02,   1.1044568E-02,   1.1255067E-02
     +,   1.1473531E-02,   1.1700922E-02,   1.1938183E-02
     +,   1.2186293E-02,   1.2446195E-02,   1.2718833E-02
     +,   1.3005097E-02,   1.3305860E-02,   1.3621919E-02
     +,   1.3954049E-02,   1.4302986E-02,   1.4669392E-02
     +,   1.5053916E-02,   1.5457211E-02,   1.5879955E-02
     +,   1.6322827E-02,   1.6786639E-02,   1.7272262E-02
     +,   1.7780790E-02,   1.8313440E-02,   1.8871717E-02
     +,   1.9457318E-02,   2.0072253E-02,   2.0718737E-02
     +,   2.1399280E-02,   2.2116575E-02,   2.2873407E-02
     +,   2.3672603E-02,   2.4516957E-02,   2.5409102E-02
     +,   2.6351208E-02,   2.7345179E-02,   2.8392257E-02
     +,   2.9493246E-02,   3.0648341E-02,   3.1857524E-02
     +,   3.3120617E-02,   3.4438092E-02,   3.5811365E-02
     +,   3.7244063E-02,   3.8742889E-02,   4.0318746E-02
     +,   4.1987970E-02,   4.3773573E-02,   4.5705874E-02
     +,   4.7822591E-02,   5.0168701E-02,   5.2794430E-02
     +,   5.5753190E-02,   5.9097167E-02,   6.2873296E-02
     +,   6.7116871E-02,   7.1847036E-02,   7.7060491E-02
     +,   8.2729004E-02,   8.8797480E-02,   9.5184743E-02
     +,   0.1017883    ,   0.1084921    ,   0.1151767    
     +,   0.1217304    ,   0.1280628    ,   0.1341182    
     +,   0.1398866    ,   0.1454127    ,   0.1508035    
     +,   0.1562298    ,   0.1619210    ,   0.1681521    
     +,   0.1752208    ,   0.1834129    ,   0.1929613    
     +,   0.2040089    ,   0.2165884    ,   0.2306378    
     +,   0.2460641    ,   0.2628559    ,   0.2812269    
     +,   0.3017280    ,   0.3252718    ,   0.3530455    
     +,   0.3863517    ,   0.4265475    ,   0.4752748    
     +,   0.5349693    ,   0.6092903    ,   0.7028540    
     +,   0.8197031    ,   0.9603218    ,    1.118257    
     +,    1.280576    ,    1.439120    ,    1.611740    
     +,    1.847530    ,    2.185352    ,    2.602323    
     +,    3.037491    ,    3.501568    ,    4.129485    
     +,    4.991058    ,    6.033501    ,    7.229201    
     +,    8.267790    ,    8.961082    ,    9.621724    
     +,    9.888517    ,    9.521099    ,    8.835548    
     +,    7.868779    ,    6.848377    ,    6.094872    
     +,    5.424716    ,    4.588979    ,    3.670614    
     +,    2.920147    ,    2.463534    ,    2.215145    
     +,    2.030627    ,    1.830355    ,    1.605617    
     +,    1.377177    ,    1.164228    ,   0.9767838    
     +,   0.8175142    ,   0.6842884    ,   0.5730231    
     +,   0.4798720    ,   0.4017410    ,   0.3360112    
     +,   0.2804131    ,   0.2331015    ,   0.1926769    
     +,   0.1581035    ,   0.1286008    ,   0.1035584    
     +,   8.2476310E-02,   6.4917684E-02,   5.0476808E-02
     +,   3.8763415E-02,   2.9398907E-02,   2.2019250E-02
     +,   1.6285354E-02,   1.1891559E-02,   8.5703610E-03
     +,   6.0938508E-03,   4.2726351E-03,   2.9524453E-03
     +,   2.0096565E-03,   1.3467647E-03,   8.8815845E-04
     +,   5.7618099E-04,   3.6759529E-04,   2.3057552E-04
     +,   1.4216853E-04,   8.6158158E-05,   5.1314706E-05
     +,   3.0032908E-05,   1.7271890E-05,   9.7599159E-06
     +,   5.4184334E-06,   2.9551113E-06,   1.5830980E-06
     +,   8.3297601E-07,   4.3041132E-07,   2.1837160E-07
     +,   1.0877564E-07,   5.3195162E-08,   2.5539991E-08
     +,   1.2040883E-08,   5.5776672E-09,   2.5417510E-09
     +,   1.1423332E-09,   5.0888627E-10,   2.2686640E-10
     +,   1.0295611E-10,   4.8880174E-11,   2.5148300E-11
     +,   1.4440987E-11,   9.3037565E-12,   6.5796917E-12
     +,   4.9453878E-12,   3.8452757E-12,   3.0405385E-12
     +,   2.4222169E-12,   1.9350493E-12,   1.5467434E-12
     +,   1.2357961E-12,   9.8646698E-13,   7.8657914E-13
     +,   6.2644996E-13,   4.9830555E-13,   3.9588347E-13
     +,   3.1412484E-13,   2.4894084E-13,   1.9703581E-13
     +,   1.5576029E-13,   1.2297639E-13,   9.6972797E-14
     +,   7.6371675E-14,   6.0072593E-14,   4.7192854E-14
     +,   3.7028560E-14,   2.9017052E-14,   2.2710656E-14
     +,   1.7752628E-14,   1.3859786E-14,   1.0807106E-14
     +,   8.4162091E-15,   6.5461518E-15,   5.0852296E-15
     +,   3.9454511E-15,   3.0572983E-15,   2.3661355E-15
     +,   1.8289309E-15,   1.4119383E-15,   1.0886524E-15
     +,   8.3835097E-16,   6.4478636E-16,   4.9530093E-16
     +,   3.7999312E-16,   2.9116924E-16
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_asha_htt95_mass = Yx/38.19031692
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_asha_ttz100_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.4889241E-05,   2.8641149E-05
     +,   3.2884898E-05,   3.7672962E-05,   4.3061682E-05
     +,   4.9111179E-05,   5.5885408E-05,   6.3452026E-05
     +,   7.1882190E-05,   8.1250844E-05,   9.1635724E-05
     +,   1.0311753E-04,   1.1577942E-04,   1.2970653E-04
     +,   1.4498546E-04,   1.6170346E-04,   1.7994801E-04
     +,   1.9980583E-04,   2.2136184E-04,   2.4469855E-04
     +,   2.6989481E-04,   2.9702467E-04,   3.2615577E-04
     +,   3.5735060E-04,   3.9065981E-04,   4.2612787E-04
     +,   4.6378624E-04,   5.0365471E-04,   5.4573960E-04
     +,   5.9003237E-04,   6.3650875E-04,   6.8512763E-04
     +,   7.3582993E-04,   7.8853808E-04,   8.4315502E-04
     +,   8.9956413E-04,   9.5762836E-04,   1.0171899E-03
     +,   1.0780746E-03,   1.1400817E-03,   1.2029983E-03
     +,   1.2665897E-03,   1.3306051E-03,   1.3947774E-03
     +,   1.4588265E-03,   1.5224593E-03,   1.5853730E-03
     +,   1.6472570E-03,   1.7077960E-03,   1.7666720E-03
     +,   1.8235669E-03,   1.8781659E-03,   1.9301609E-03
     +,   1.9792547E-03,   2.0251584E-03,   2.0676034E-03
     +,   2.1063362E-03,   2.1411260E-03,   2.1717660E-03
     +,   2.1980763E-03,   2.2199049E-03,   2.2371325E-03
     +,   2.2496716E-03,   2.2574700E-03,   2.2605113E-03
     +,   2.2588151E-03,   2.2524404E-03,   2.2414832E-03
     +,   2.2260766E-03,   2.2063942E-03,   2.1826448E-03
     +,   2.1550760E-03,   2.1239691E-03,   2.0896452E-03
     +,   2.0524552E-03,   2.0127853E-03,   1.9710555E-03
     +,   1.9277197E-03,   1.8832600E-03,   1.8381918E-03
     +,   1.7930684E-03,   1.7484715E-03,   1.7050247E-03
     +,   1.6633871E-03,   1.6242653E-03,   1.5884091E-03
     +,   1.5566255E-03,   1.5297756E-03,   1.5087889E-03
     +,   1.4946619E-03,   1.4884674E-03,   1.4913593E-03
     +,   1.5045722E-03,   1.5294240E-03,   1.5673137E-03
     +,   1.6197090E-03,   1.6881441E-03,   1.7741882E-03
     +,   1.8794399E-03,   2.0054730E-03,   2.1538271E-03
     +,   2.3259297E-03,   2.5230846E-03,   2.7463702E-03
     +,   2.9966224E-03,   3.2743588E-03,   3.5796950E-03
     +,   3.9123008E-03,   4.2713741E-03,   4.6555791E-03
     +,   5.0629764E-03,   5.4910993E-03,   5.9368471E-03
     +,   6.3966285E-03,   6.8662814E-03,   7.3412643E-03
     +,   7.8166174E-03,   8.2871951E-03,   8.7476512E-03
     +,   9.1926930E-03,   9.6171685E-03,   1.0016173E-02
     +,   1.0385233E-02,   1.0720449E-02,   1.1018593E-02
     +,   1.1277200E-02,   1.1494705E-02,   1.1670469E-02
     +,   1.1804886E-02,   1.1899403E-02,   1.1956602E-02
     +,   1.1980217E-02,   1.1975251E-02,   1.1948023E-02
     +,   1.1906326E-02,   1.1859563E-02,   1.1818962E-02
     +,   1.1797780E-02,   1.1811519E-02,   1.1878135E-02
     +,   1.2018128E-02,   1.2254498E-02,   1.2612515E-02
     +,   1.3119163E-02,   1.3802163E-02,   1.4688765E-02
     +,   1.5804024E-02,   1.7168708E-02,   1.8797094E-02
     +,   2.0694956E-02,   2.2857623E-02,   2.5268644E-02
     +,   2.7899703E-02,   3.0711906E-02,   3.3658251E-02
     +,   3.6687493E-02,   3.9749760E-02,   4.2802893E-02
     +,   4.5818523E-02,   4.8786953E-02,   5.1720858E-02
     +,   5.4654900E-02,   5.7641711E-02,   6.0744140E-02
     +,   6.4025082E-02,   6.7535877E-02,   7.1307369E-02
     +,   7.5346604E-02,   7.9642124E-02,   8.4176563E-02
     +,   8.8945411E-02,   9.3977220E-02,   9.9350072E-02
     +,   0.1051997    ,   0.1117227    ,   0.1191866    
     +,   0.1279640    ,   0.1386002    ,   0.1518863    
     +,   0.1688587    ,   0.1907378    ,   0.2192503    
     +,   0.2581252    ,   0.3152561    ,   0.4017107    
     +,   0.5242159    ,   0.6779793    ,   0.8525048    
     +,    1.045782    ,    1.269593    ,    1.541794    
     +,    1.872746    ,    2.252837    ,    2.645367    
     +,    3.114149    ,    3.719754    ,    4.194065    
     +,    4.319171    ,    3.958498    ,    3.286987    
     +,    2.697931    ,    2.277749    ,    1.917567    
     +,    1.583534    ,    1.286572    ,   0.9972621    
     +,   0.7322876    ,   0.5257055    ,   0.3782414    
     +,   0.2731318    ,   0.1972200    ,   0.1430359    
     +,   0.1049119    ,   7.7900305E-02,   5.8325324E-02
     +,   4.3841753E-02,   3.2981187E-02,   2.4757437E-02
     +,   1.8484261E-02,   1.3692621E-02,   1.0060907E-02
     +,   7.3532462E-03,   5.3773364E-03,   3.9657247E-03
     +,   2.9729430E-03,   2.2783207E-03,   1.7877995E-03
     +,   1.4326619E-03,   1.1657954E-03,   9.5678971E-04
     +,   7.8704394E-04,   6.4563978E-04,   5.2627467E-04
     +,   4.2521380E-04,   3.4002584E-04,   2.6885472E-04
     +,   2.1007992E-04,   1.6217411E-04,   1.2366302E-04
     +,   9.3135801E-05,   6.9276786E-05,   5.0891671E-05
     +,   3.6922705E-05,   2.6455820E-05,   1.8720795E-05
     +,   1.3082969E-05,   9.0296817E-06,   6.1548581E-06
     +,   4.1432118E-06,   2.7544872E-06,   1.8085219E-06
     +,   1.1726806E-06,   7.5095591E-07,   4.7493597E-07
     +,   2.9664335E-07,   1.8298130E-07,   1.1146985E-07
     +,   6.7064903E-08,   3.9848505E-08,   2.3383047E-08
     +,   1.3550939E-08,   7.7557845E-09,   4.3839199E-09
     +,   2.4472100E-09,   1.3491788E-09,   7.3459894E-10
     +,   3.9500614E-10,   2.0976963E-10,   1.1002110E-10
     +,   5.6989830E-11,   2.9154325E-11,   1.4730068E-11
     +,   7.3505663E-12,   3.6228776E-12,   1.7636296E-12
     +,   8.4805757E-13,   4.0282884E-13,   1.8904461E-13
     +,   8.7661242E-14,   4.0177798E-14,   1.8207276E-14
     +,   8.1632216E-15,   3.6241067E-15,   1.5954165E-15
     +,   6.9782169E-16,   3.0419960E-16,   1.3275068E-16
     +,   5.8354628E-17,   2.6053453E-17,   1.1930467E-17
     +,   5.6603022E-18,   2.8044181E-18,   1.4559404E-18
     +,   7.9017720E-19,   4.4525793E-19,   2.5815348E-19
     +,   1.5265402E-19,   9.1394049E-20,   5.5102507E-20
     +,   3.3329524E-20,   2.0175927E-20
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_asha_ttz100_mass = Yx/12.3486417209302
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_asha_ttz105_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  9.4013411E-04,   9.7726786E-04
     +,   1.0149851E-03,   1.0532507E-03,   1.0920275E-03
     +,   1.1312769E-03,   1.1709589E-03,   1.2110316E-03
     +,   1.2514512E-03,   1.2921744E-03,   1.3331552E-03
     +,   1.3743463E-03,   1.4157002E-03,   1.4571680E-03
     +,   1.4987000E-03,   1.5402456E-03,   1.5817540E-03
     +,   1.6231734E-03,   1.6644519E-03,   1.7055367E-03
     +,   1.7463752E-03,   1.7869142E-03,   1.8271002E-03
     +,   1.8668816E-03,   1.9062030E-03,   1.9450128E-03
     +,   1.9832577E-03,   2.0208855E-03,   2.0578431E-03
     +,   2.0940793E-03,   2.1295429E-03,   2.1641830E-03
     +,   2.1979497E-03,   2.2307937E-03,   2.2626673E-03
     +,   2.2935236E-03,   2.3233169E-03,   2.3520021E-03
     +,   2.3795383E-03,   2.4058826E-03,   2.4309976E-03
     +,   2.4548476E-03,   2.4773981E-03,   2.4986195E-03
     +,   2.5184846E-03,   2.5369711E-03,   2.5540611E-03
     +,   2.5697425E-03,   2.5840085E-03,   2.5968603E-03
     +,   2.6083062E-03,   2.6183650E-03,   2.6270654E-03
     +,   2.6344485E-03,   2.6405682E-03,   2.6454951E-03
     +,   2.6493163E-03,   2.6521403E-03,   2.6540970E-03
     +,   2.6553408E-03,   2.6560556E-03,   2.6564545E-03
     +,   2.6567862E-03,   2.6573362E-03,   2.6584319E-03
     +,   2.6604438E-03,   2.6637912E-03,   2.6689433E-03
     +,   2.6764241E-03,   2.6868135E-03,   2.7007491E-03
     +,   2.7189285E-03,   2.7421094E-03,   2.7711063E-03
     +,   2.8067934E-03,   2.8500983E-03,   2.9019956E-03
     +,   2.9635001E-03,   3.0356632E-03,   3.1195607E-03
     +,   3.2162692E-03,   3.3268724E-03,   3.4524165E-03
     +,   3.5939242E-03,   3.7523392E-03,   3.9285389E-03
     +,   4.1232747E-03,   4.3371902E-03,   4.5707459E-03
     +,   4.8242467E-03,   5.0977953E-03,   5.3912560E-03
     +,   5.7042469E-03,   6.0361470E-03,   6.3860696E-03
     +,   6.7528118E-03,   7.1349354E-03,   7.5306739E-03
     +,   7.9380386E-03,   8.3547328E-03,   8.7782703E-03
     +,   9.2059011E-03,   9.6347462E-03,   1.0061729E-02
     +,   1.0483706E-02,   1.0897485E-02,   1.1299822E-02
     +,   1.1687524E-02,   1.2057510E-02,   1.2406833E-02
     +,   1.2732709E-02,   1.3032621E-02,   1.3304292E-02
     +,   1.3545793E-02,   1.3755508E-02,   1.3932204E-02
     +,   1.4075021E-02,   1.4183504E-02,   1.4257581E-02
     +,   1.4297587E-02,   1.4304227E-02,   1.4278569E-02
     +,   1.4222027E-02,   1.4136327E-02,   1.4023464E-02
     +,   1.3885710E-02,   1.3725532E-02,   1.3545594E-02
     +,   1.3348705E-02,   1.3137821E-02,   1.2915975E-02
     +,   1.2686314E-02,   1.2452035E-02,   1.2216426E-02
     +,   1.1982837E-02,   1.1754679E-02,   1.1535486E-02
     +,   1.1328893E-02,   1.1138660E-02,   1.0968708E-02
     +,   1.0823156E-02,   1.0706329E-02,   1.0622764E-02
     +,   1.0577245E-02,   1.0574778E-02,   1.0620593E-02
     +,   1.0720080E-02,   1.0878759E-02,   1.1102170E-02
     +,   1.1395800E-02,   1.1764946E-02,   1.2214552E-02
     +,   1.2749040E-02,   1.3372202E-02,   1.4087008E-02
     +,   1.4895452E-02,   1.5798483E-02,   1.6796080E-02
     +,   1.7887391E-02,   1.9070853E-02,   2.0344952E-02
     +,   2.1708881E-02,   2.3163501E-02,   2.4712771E-02
     +,   2.6365565E-02,   2.8137559E-02,   3.0053139E-02
     +,   3.2147709E-02,   3.4469508E-02,   3.7080795E-02
     +,   4.0057775E-02,   4.3489639E-02,   4.7476508E-02
     +,   5.2125666E-02,   5.7546601E-02,   6.3847281E-02
     +,   7.1129128E-02,   7.9481922E-02,   8.8978641E-02
     +,   9.9668510E-02,   0.1115651    ,   0.1246312    
     +,   0.1387681    ,   0.1538262    ,   0.1696525    
     +,   0.1861958    ,   0.2036528    ,   0.2225929    
     +,   0.2439773    ,   0.2690031    ,   0.2987652    
     +,   0.3338059    ,   0.3738945    ,   0.4187018    
     +,   0.4694543    ,   0.5297655    ,   0.6042194    
     +,   0.6996351    ,   0.8342015    ,    1.039256    
     +,    1.339591    ,    1.746810    ,    2.262801    
     +,    2.848878    ,    3.440454    ,    3.969999    
     +,    4.298532    ,    4.260579    ,    3.848509    
     +,    3.218660    ,    2.515608    ,    1.796666    
     +,    1.119459    ,   0.5874370    ,   0.2601439    
     +,   0.1030262    ,   4.1983418E-02,   2.1105073E-02
     +,   1.3565531E-02,   9.9355020E-03,   7.5917672E-03
     +,   5.8793980E-03,   4.6114717E-03,   3.7055463E-03
     +,   3.0907025E-03,   2.6875176E-03,   2.4180755E-03
     +,   2.2202688E-03,   2.0535684E-03,   1.8963394E-03
     +,   1.7396975E-03,   1.5817940E-03,   1.4239821E-03
     +,   1.2687265E-03,   1.1186275E-03,   9.7597088E-04
     +,   8.4258657E-04,   7.1981177E-04,   6.0848799E-04
     +,   5.0899305E-04,   4.2130437E-04,   3.4507012E-04
     +,   2.7967244E-04,   2.2429586E-04,   1.7799993E-04
     +,   1.3978159E-04,   1.0862193E-04,   8.3526007E-05
     +,   6.3556727E-05,   4.7857397E-05,   3.5660363E-05
     +,   2.6295043E-05,   1.9187861E-05,   1.3856687E-05
     +,   9.9033732E-06,   7.0050551E-06,   4.9042737E-06
     +,   3.3986917E-06,   2.3316395E-06,   1.5837199E-06
     +,   1.0652382E-06,   7.0970958E-07,   4.6851054E-07
     +,   3.0658722E-07,   1.9900520E-07,   1.2823523E-07
     +,   8.2123236E-08,   5.2348742E-08,   3.3281722E-08
     +,   2.1158773E-08,   1.3495340E-08,   8.6700283E-09
     +,   5.6360325E-09,   3.7246854E-09,   2.5133560E-09
     +,   1.7373984E-09,   1.2322581E-09,   8.9639973E-10
     +,   6.6733957E-10,   5.0672683E-10,   3.9090714E-10
     +,   3.0519887E-10,   2.4033750E-10,   1.9036600E-10
     +,   1.5133737E-10,   1.2056037E-10,   9.6130610E-11
     +,   7.6658832E-11,   6.1104448E-11,   4.8665707E-11
     +,   3.8717706E-11,   3.0764790E-11,   2.4412696E-11
     +,   1.9344536E-11,   1.5306286E-11,   1.2092907E-11
     +,   9.5398160E-12,   7.5142496E-12,   5.9098126E-12
     +,   4.6408086E-12,   3.6387521E-12
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_asha_ttz105_mass = Yx/11.002995
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_asha_ttz107_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  6.2843114E-06,   7.1571922E-06
     +,   8.1379158E-06,   9.2378523E-06,   1.0469320E-05
     +,   1.1845635E-05,   1.3381142E-05,   1.5091306E-05
     +,   1.6992684E-05,   1.9103145E-05,   2.1441698E-05
     +,   2.4028710E-05,   2.6885926E-05,   3.0036501E-05
     +,   3.3505123E-05,   3.7318066E-05,   4.1503274E-05
     +,   4.6090507E-05,   5.1111372E-05,   5.6599587E-05
     +,   6.2591062E-05,   6.9124137E-05,   7.6239652E-05
     +,   8.3981824E-05,   9.2397306E-05,   1.0153717E-04
     +,   1.1145599E-04,   1.2221289E-04,   1.3387205E-04
     +,   1.4650321E-04,   1.6018236E-04,   1.7499254E-04
     +,   1.9102443E-04,   2.0837746E-04,   2.2716034E-04
     +,   2.4749237E-04,   2.6950400E-04,   2.9333780E-04
     +,   3.1915089E-04,   3.4711169E-04,   3.7740631E-04
     +,   4.1023473E-04,   4.4581314E-04,   4.8437438E-04
     +,   5.2616693E-04,   5.7145598E-04,   6.2052178E-04
     +,   6.7365909E-04,   7.3117617E-04,   7.9339190E-04
     +,   8.6063467E-04,   9.3323848E-04,   1.0115391E-03
     +,   1.0958767E-03,   1.1865762E-03,   1.2839626E-03
     +,   1.3883403E-03,   1.4999942E-03,   1.6191840E-03
     +,   1.7461365E-03,   1.8810425E-03,   2.0240520E-03
     +,   2.1752566E-03,   2.3347083E-03,   2.5024030E-03
     +,   2.6782593E-03,   2.8621554E-03,   3.0538817E-03
     +,   3.2531880E-03,   3.4597316E-03,   3.6731346E-03
     +,   3.8929279E-03,   4.1186130E-03,   4.3496075E-03
     +,   4.5852992E-03,   4.8250337E-03,   5.0680973E-03
     +,   5.3137452E-03,   5.5612144E-03,   5.8097197E-03
     +,   6.0584284E-03,   6.3065235E-03,   6.5531419E-03
     +,   6.7974376E-03,   7.0385202E-03,   7.2755194E-03
     +,   7.5075226E-03,   7.7336328E-03,   7.9529108E-03
     +,   8.1644254E-03,   8.3672367E-03,   8.5603781E-03
     +,   8.7428801E-03,   8.9137936E-03,   9.0721780E-03
     +,   9.2171067E-03,   9.3477210E-03,   9.4632171E-03
     +,   9.5629022E-03,   9.6461959E-03,   9.7126998E-03
     +,   9.7622061E-03,   9.7947633E-03,   9.8107010E-03
     +,   9.8106861E-03,   9.7957626E-03,   9.7673899E-03
     +,   9.7274799E-03,   9.6784206E-03,   9.6230935E-03
     +,   9.5648933E-03,   9.5076934E-03,   9.4558448E-03
     +,   9.4141150E-03,   9.3876338E-03,   9.3818093E-03
     +,   9.4022099E-03,   9.4544617E-03,   9.5440811E-03
     +,   9.6763289E-03,   9.8560574E-03,   1.0087498E-02
     +,   1.0374106E-02,   1.0718407E-02,   1.1121827E-02
     +,   1.1584519E-02,   1.2105343E-02,   1.2681676E-02
     +,   1.3309506E-02,   1.3983289E-02,   1.4696173E-02
     +,   1.5439914E-02,   1.6205212E-02,   1.6981687E-02
     +,   1.7758317E-02,   1.8523566E-02,   1.9265678E-02
     +,   1.9972958E-02,   2.0634184E-02,   2.1238800E-02
     +,   2.1777220E-02,   2.2241116E-02,   2.2623688E-02
     +,   2.2919850E-02,   2.3126390E-02,   2.3242144E-02
     +,   2.3268100E-02,   2.3207443E-02,   2.3065591E-02
     +,   2.2850255E-02,   2.2571374E-02,   2.2241190E-02
     +,   2.1874230E-02,   2.1487312E-02,   2.1099670E-02
     +,   2.0733105E-02,   2.0412140E-02,   2.0164238E-02
     +,   2.0020118E-02,   2.0013964E-02,   2.0183630E-02
     +,   2.0570623E-02,   2.1219822E-02,   2.2178708E-02
     +,   2.3496119E-02,   2.5220279E-02,   2.7395748E-02
     +,   3.0059891E-02,   3.3238944E-02,   3.6943484E-02
     +,   4.1164264E-02,   4.5869455E-02,   5.1004261E-02
     +,   5.6492683E-02,   6.2242098E-02,   6.8153001E-02
     +,   7.4130416E-02,   8.0097929E-02,   8.6015232E-02
     +,   9.1897279E-02,   9.7834498E-02,   0.1040139    
     +,   0.1107389    ,   0.1184453    ,   0.1277047    
     +,   0.1392090    ,   0.1537181    ,   0.1719508    
     +,   0.1943896    ,   0.2209973    ,   0.2509347    
     +,   0.2824795    ,   0.3134818    ,   0.3425442    
     +,   0.3705562    ,   0.4016054    ,   0.4423644    
     +,   0.4995841    ,   0.5753943    ,   0.6621000    
     +,   0.7455839    ,   0.8264331    ,   0.9396538    
     +,    1.135690    ,    1.453615    ,    1.957797    
     +,    2.697782    ,    3.506225    ,    4.159816    
     +,    4.673790    ,    4.890309    ,    4.378160    
     +,    3.144036    ,    1.768991    ,   0.7844287    
     +,   0.2943343    ,   0.1169461    ,   6.3569181E-02
     +,   4.5105066E-02,   3.5407066E-02,   2.8171321E-02
     +,   2.2059545E-02,   1.7116893E-02,   1.3477256E-02
     +,   1.0991125E-02,   9.3390010E-03,   8.2123121E-03
     +,   7.3940908E-03,   6.7573464E-03,   6.2361294E-03
     +,   5.7985834E-03,   5.4287845E-03,   5.1164273E-03
     +,   4.8520984E-03,   4.6259845E-03,   4.4281930E-03
     +,   4.2496291E-03,   4.0827040E-03,   3.9216555E-03
     +,   3.7625297E-03,   3.6029599E-03,   3.4418418E-03
     +,   3.2789735E-03,   3.1147352E-03,   2.9498632E-03
     +,   2.7852792E-03,   2.6219620E-03,   2.4608616E-03
     +,   2.3028618E-03,   2.1487712E-03,   1.9992799E-03
     +,   1.8549700E-03,   1.7163283E-03,   1.5837359E-03
     +,   1.4574698E-03,   1.3377171E-03,   1.2245919E-03
     +,   1.1181337E-03,   1.0183100E-03,   9.2503295E-04
     +,   8.3817227E-04,   7.5755641E-04,   6.8297476E-04
     +,   6.1419036E-04,   5.5095268E-04,   4.9298879E-04
     +,   4.4001610E-04,   3.9174961E-04,   3.4790128E-04
     +,   3.0818113E-04,   2.7230338E-04,   2.3999077E-04
     +,   2.1097355E-04,   1.8498943E-04,   1.6178744E-04
     +,   1.4113040E-04,   1.2279078E-04,   1.0655650E-04
     +,   9.2226241E-05,   7.9614038E-05,   6.8545189E-05
     +,   5.8859630E-05,   5.0408438E-05,   4.3056185E-05
     +,   3.6678124E-05,   3.1161624E-05,   2.6403986E-05
     +,   2.2312661E-05,   1.8804772E-05,   1.5805686E-05
     +,   1.3249228E-05,   1.1076262E-05,   9.2347500E-06
     +,   7.6785645E-06,   6.3673942E-06,   5.2658011E-06
     +,   4.3430205E-06,   3.5722173E-06,   2.9302655E-06
     +,   2.3971329E-06,   1.9556821E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_asha_ttz107_mass = Yx/10.6230733170732
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_asha_ttz110_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.4313304E-04,   2.5826189E-04
     +,   2.7415575E-04,   2.9084610E-04,   3.0836617E-04
     +,   3.2675028E-04,   3.4603439E-04,   3.6625599E-04
     +,   3.8745353E-04,   4.0966817E-04,   4.3294148E-04
     +,   4.5731672E-04,   4.8283875E-04,   5.0955324E-04
     +,   5.3750753E-04,   5.6674954E-04,   5.9732795E-04
     +,   6.2929216E-04,   6.6269143E-04,   6.9757504E-04
     +,   7.3399174E-04,   7.7198911E-04,   8.1161252E-04
     +,   8.5290818E-04,   8.9591451E-04,   9.4067195E-04
     +,   9.8721392E-04,   1.0355697E-03,   1.0857637E-03
     +,   1.1378134E-03,   1.1917299E-03,   1.2475161E-03
     +,   1.3051667E-03,   1.3646667E-03,   1.4259915E-03
     +,   1.4891051E-03,   1.5539605E-03,   1.6204971E-03
     +,   1.6886463E-03,   1.7583186E-03,   1.8294191E-03
     +,   1.9018343E-03,   1.9754383E-03,   2.0500917E-03
     +,   2.1256413E-03,   2.2019204E-03,   2.2787501E-03
     +,   2.3559385E-03,   2.4332840E-03,   2.5105728E-03
     +,   2.5875829E-03,   2.6640852E-03,   2.7398420E-03
     +,   2.8146161E-03,   2.8881591E-03,   2.9602291E-03
     +,   3.0305821E-03,   3.0989777E-03,   3.1651796E-03
     +,   3.2289608E-03,   3.2901037E-03,   3.3484031E-03
     +,   3.4036655E-03,   3.4557183E-03,   3.5044074E-03
     +,   3.5495954E-03,   3.5911747E-03,   3.6290565E-03
     +,   3.6631832E-03,   3.6935229E-03,   3.7200772E-03
     +,   3.7428753E-03,   3.7619828E-03,   3.7774937E-03
     +,   3.7895408E-03,   3.7982892E-03,   3.8039379E-03
     +,   3.8067226E-03,   3.8069123E-03,   3.8048106E-03
     +,   3.8007558E-03,   3.7951178E-03,   3.7883003E-03
     +,   3.7807387E-03,   3.7729004E-03,   3.7652841E-03
     +,   3.7584202E-03,   3.7528705E-03,   3.7492330E-03
     +,   3.7481382E-03,   3.7502560E-03,   3.7563008E-03
     +,   3.7670326E-03,   3.7832663E-03,   3.8058818E-03
     +,   3.8358273E-03,   3.8741347E-03,   3.9219246E-03
     +,   3.9804270E-03,   4.0509794E-03,   4.1350494E-03
     +,   4.2342287E-03,   4.3502557E-03,   4.4849906E-03
     +,   4.6404363E-03,   4.8187156E-03,   5.0220420E-03
     +,   5.2526915E-03,   5.5129891E-03,   5.8052423E-03
     +,   6.1316588E-03,   6.4943391E-03,   6.8951310E-03
     +,   7.3356330E-03,   7.8170188E-03,   8.3400719E-03
     +,   8.9049898E-03,   9.5114633E-03,   1.0158480E-02
     +,   1.0844442E-02,   1.1567102E-02,   1.2323554E-02
     +,   1.3110316E-02,   1.3923474E-02,   1.4758741E-02
     +,   1.5611504E-02,   1.6477160E-02,   1.7351048E-02
     +,   1.8228838E-02,   1.9106440E-02,   1.9980356E-02
     +,   2.0847566E-02,   2.1705803E-02,   2.2553373E-02
     +,   2.3389315E-02,   2.4213279E-02,   2.5025396E-02
     +,   2.5826225E-02,   2.6616709E-02,   2.7398048E-02
     +,   2.8171534E-02,   2.8938655E-02,   2.9701155E-02
     +,   3.0461069E-02,   3.1220913E-02,   3.1984005E-02
     +,   3.2754693E-02,   3.3538636E-02,   3.4343127E-02
     +,   3.5177406E-02,   3.6052793E-02,   3.6982581E-02
     +,   3.7982035E-02,   3.9068036E-02,   4.0258508E-02
     +,   4.1571498E-02,   4.3024164E-02,   4.4631593E-02
     +,   4.6405222E-02,   4.8351020E-02,   5.0468270E-02
     +,   5.2748118E-02,   5.5172611E-02,   5.7715096E-02
     +,   6.0342114E-02,   6.3016817E-02,   6.5704435E-02
     +,   6.8380088E-02,   7.1037456E-02,   7.3697262E-02
     +,   7.6413296E-02,   7.9275191E-02,   8.2406759E-02
     +,   8.5960448E-02,   9.0111084E-02,   9.5054470E-02
     +,   0.1010116    ,   0.1082359    ,   0.1170149    
     +,   0.1276486    ,   0.1403912    ,   0.1553611    
     +,   0.1724607    ,   0.1913707    ,   0.2116834    
     +,   0.2331800    ,   0.2561440    ,   0.2814765    
     +,   0.3103512    ,   0.3433876    ,   0.3797969    
     +,   0.4173807    ,   0.4540537    ,   0.4902990    
     +,   0.5303623    ,   0.5800698    ,   0.6421052    
     +,   0.7129832    ,   0.7855554    ,   0.8564358    
     +,   0.9335670    ,    1.037072    ,    1.186801    
     +,    1.377943    ,    1.567531    ,    1.706031    
     +,    1.796565    ,    1.898078    ,    2.048185    
     +,    2.199406    ,    2.240509    ,    2.074899    
     +,    1.694131    ,    1.194575    ,   0.7193950    
     +,   0.3714689    ,   0.1707168    ,   7.7857330E-02
     +,   4.2323306E-02,   3.0118261E-02,   2.5686458E-02
     +,   2.3737172E-02,   2.2733189E-02,   2.2117786E-02
     +,   2.1572983E-02,   2.0903526E-02,   2.0020144E-02
     +,   1.8914238E-02,   1.7625578E-02,   1.6215181E-02
     +,   1.4747459E-02,   1.3280177E-02,   1.1859734E-02
     +,   1.0519907E-02,   9.2826160E-03,   8.1593692E-03
     +,   7.1535823E-03,   6.2628519E-03,   5.4808329E-03
     +,   4.7987956E-03,   4.2069019E-03,   3.6950668E-03
     +,   3.2534674E-03,   2.8728636E-03,   2.5448212E-03
     +,   2.2618112E-03,   2.0171897E-03,   1.8051595E-03
     +,   1.6207311E-03,   1.4596623E-03,   1.3183426E-03
     +,   1.1937321E-03,   1.0832909E-03,   9.8489737E-04
     +,   8.9677848E-04,   8.1746193E-04,   7.4573199E-04
     +,   6.8058091E-04,   6.2117056E-04,   5.6680833E-04
     +,   5.1692344E-04,   4.7104331E-04,   4.2877227E-04
     +,   3.8977989E-04,   3.5379271E-04,   3.2057497E-04
     +,   2.8992465E-04,   2.6166780E-04,   2.3565025E-04
     +,   2.1173134E-04,   1.8978251E-04,   1.6968507E-04
     +,   1.5132705E-04,   1.3460008E-04,   1.1939998E-04
     +,   1.0562750E-04,   9.3184492E-05,   8.1977305E-05
     +,   7.1913782E-05,   6.2906212E-05,   5.4868931E-05
     +,   4.7720896E-05,   4.1383882E-05,   3.5784444E-05
     +,   3.0852527E-05,   2.6522959E-05,   2.2734437E-05
     +,   1.9430043E-05,   1.6557464E-05,   1.4068212E-05
     +,   1.1918266E-05,   1.0067251E-05,   8.4788517E-06
     +,   7.1200989E-06,   5.9615982E-06,   4.9769337E-06
     +,   4.1427506E-06,   3.4382535E-06,   2.8452100E-06
     +,   2.3475384E-06,   1.9312508E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_asha_ttz110_mass = Yx/8.38169325
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_asha_ttz115_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  6.2778010E-04,   6.5271102E-04
     +,   6.7888194E-04,   7.0637133E-04,   7.3526119E-04
     +,   7.6563586E-04,   7.9758296E-04,   8.3119178E-04
     +,   8.6655334E-04,   9.0376148E-04,   9.4290980E-04
     +,   9.8409224E-04,   1.0274033E-03,   1.0729361E-03
     +,   1.1207825E-03,   1.1710319E-03,   1.2237710E-03
     +,   1.2790821E-03,   1.3370431E-03,   1.3977259E-03
     +,   1.4611965E-03,   1.5275124E-03,   1.5967222E-03
     +,   1.6688695E-03,   1.7439796E-03,   1.8220752E-03
     +,   1.9031613E-03,   1.9872324E-03,   2.0742682E-03
     +,   2.1642365E-03,   2.2570877E-03,   2.3527597E-03
     +,   2.4511728E-03,   2.5522325E-03,   2.6558293E-03
     +,   2.7618366E-03,   2.8701134E-03,   2.9805019E-03
     +,   3.0928359E-03,   3.2069241E-03,   3.3225738E-03
     +,   3.4395743E-03,   3.5577046E-03,   3.6767365E-03
     +,   3.7964305E-03,   3.9165444E-03,   4.0368293E-03
     +,   4.1570347E-03,   4.2769094E-03,   4.3962034E-03
     +,   4.5146714E-03,   4.6320725E-03,   4.7481712E-03
     +,   4.8627523E-03,   4.9755997E-03,   5.0865225E-03
     +,   5.1953411E-03,   5.3018969E-03,   5.4060509E-03
     +,   5.5076890E-03,   5.6067212E-03,   5.7030851E-03
     +,   5.7967412E-03,   5.8876900E-03,   5.9759584E-03
     +,   6.0616047E-03,   6.1447285E-03,   6.2254542E-03
     +,   6.3039586E-03,   6.3804435E-03,   6.4551625E-03
     +,   6.5283985E-03,   6.6004866E-03,   6.6717970E-03
     +,   6.7427503E-03,   6.8138116E-03,   6.8854899E-03
     +,   6.9583301E-03,   7.0329411E-03,   7.1099713E-03
     +,   7.1901069E-03,   7.2740917E-03,   7.3627047E-03
     +,   7.4567823E-03,   7.5571872E-03,   7.6648411E-03
     +,   7.7806935E-03,   7.9057477E-03,   8.0410335E-03
     +,   8.1876218E-03,   8.3466414E-03,   8.5192285E-03
     +,   8.7065715E-03,   8.9099007E-03,   9.1304937E-03
     +,   9.3696434E-03,   9.6287159E-03,   9.9090841E-03
     +,   1.0212200E-02,   1.0539509E-02,   1.0892530E-02
     +,   1.1272762E-02,   1.1681757E-02,   1.2120997E-02
     +,   1.2591975E-02,   1.3096118E-02,   1.3634705E-02
     +,   1.4208861E-02,   1.4819533E-02,   1.5467403E-02
     +,   1.6152756E-02,   1.6875541E-02,   1.7635154E-02
     +,   1.8430537E-02,   1.9259915E-02,   2.0120973E-02
     +,   2.1010580E-02,   2.1925015E-02,   2.2859739E-02
     +,   2.3809632E-02,   2.4768990E-02,   2.5731564E-02
     +,   2.6690783E-02,   2.7639981E-02,   2.8572597E-02
     +,   2.9482281E-02,   3.0363481E-02,   3.1211423E-02
     +,   3.2022703E-02,   3.2795370E-02,   3.3529382E-02
     +,   3.4226667E-02,   3.4891486E-02,   3.5530306E-02
     +,   3.6151949E-02,   3.6767393E-02,   3.7389431E-02
     +,   3.8032331E-02,   3.8711317E-02,   3.9441872E-02
     +,   4.0239014E-02,   4.1116506E-02,   4.2086214E-02
     +,   4.3157391E-02,   4.4336092E-02,   4.5625128E-02
     +,   4.7024027E-02,   4.8529182E-02,   5.0134800E-02
     +,   5.1833827E-02,   5.3619161E-02,   5.5484690E-02
     +,   5.7426620E-02,   5.9444286E-02,   6.1540417E-02
     +,   6.3720435E-02,   6.5991387E-02,   6.8360187E-02
     +,   7.0830926E-02,   7.3402338E-02,   7.6066054E-02
     +,   7.8805596E-02,   8.1596822E-02,   8.4410705E-02
     +,   8.7217845E-02,   8.9994043E-02,   9.2725836E-02
     +,   9.5415957E-02,   9.8086685E-02,   0.1007802    
     +,   0.1035574    ,   0.1064954    ,   0.1096866    
     +,   0.1132397    ,   0.1172840    ,   0.1219762    
     +,   0.1275081    ,   0.1341091    ,   0.1420453    
     +,   0.1516127    ,   0.1631227    ,   0.1768790    
     +,   0.1931375    ,   0.2120371    ,   0.2334905    
     +,   0.2570580    ,   0.2818706    ,   0.3066902    
     +,   0.3301720    ,   0.3513153    ,   0.3699638    
     +,   0.3871575    ,   0.4051754    ,   0.4271931    
     +,   0.4565347    ,   0.4956007    ,   0.5447990    
     +,   0.6021511    ,   0.6642067    ,   0.7280985    
     +,   0.7933864    ,   0.8618904    ,   0.9348968    
     +,    1.009485    ,    1.077106    ,    1.126217    
     +,    1.147321    ,    1.136567    ,    1.095380    
     +,    1.027211    ,   0.9350285    ,   0.8218503    
     +,   0.6932364    ,   0.5587097    ,   0.4302140    
     +,   0.3184460    ,   0.2295606    ,   0.1641940    
     +,   0.1188584    ,   8.8349335E-02,   6.7744665E-02
     +,   5.3381588E-02,   4.2933583E-02,   3.5055503E-02
     +,   2.8982388E-02,   2.4249274E-02,   2.0541079E-02
     +,   1.7624961E-02,   1.5321312E-02,   1.3489177E-02
     +,   1.2016458E-02,   1.0813089E-02,   9.8069292E-03
     +,   8.9416541E-03,   8.1753489E-03,   7.4788020E-03
     +,   6.8335873E-03,   6.2296712E-03,   5.6628347E-03
     +,   5.1323292E-03,   4.6390588E-03,   4.1842968E-03
     +,   3.7688508E-03,   3.3926517E-03,   3.0547085E-03
     +,   2.7532214E-03,   2.4857474E-03,   2.2494092E-03
     +,   2.0411194E-03,   1.8577796E-03,   1.6963655E-03
     +,   1.5540464E-03,   1.4282473E-03,   1.3166615E-03
     +,   1.2172504E-03,   1.1282430E-03,   1.0481206E-03
     +,   9.7558548E-04,   9.0953219E-04,   8.4902823E-04
     +,   7.9329504E-04,   7.4168161E-04,   6.9364387E-04
     +,   6.4873241E-04,   6.0658215E-04,   5.6689163E-04
     +,   5.2941614E-04,   4.9396150E-04,   4.6037251E-04
     +,   4.2852305E-04,   3.9831304E-04,   3.6966414E-04
     +,   3.4251300E-04,   3.1680564E-04,   2.9249609E-04
     +,   2.6954562E-04,   2.4791536E-04,   2.2757082E-04
     +,   2.0847452E-04,   1.9059094E-04,   1.7388054E-04
     +,   1.5830458E-04,   1.4382026E-04,   1.3038520E-04
     +,   1.1795357E-04,   1.0648005E-04,   9.5916941E-05
     +,   8.6216292E-05,   7.7330638E-05,   6.9211419E-05
     +,   6.1811632E-05,   5.5083980E-05,   4.8983045E-05
     +,   4.3463784E-05,   3.8483457E-05,   3.4000226E-05
     +,   2.9974632E-05,   2.6368589E-05,   2.3146431E-05
     +,   2.0274114E-05,   1.7720015E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_asha_ttz115_mass = Yx/6.3588
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_asha_ttz120_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.5319888E-03,   1.5743775E-03
     +,   1.6178724E-03,   1.6625057E-03,   1.7083099E-03
     +,   1.7553151E-03,   1.8035511E-03,   1.8530454E-03
     +,   1.9038223E-03,   1.9559066E-03,   2.0093177E-03
     +,   2.0640732E-03,   2.1201870E-03,   2.1776683E-03
     +,   2.2365234E-03,   2.2967532E-03,   2.3583553E-03
     +,   2.4213200E-03,   2.4856348E-03,   2.5512802E-03
     +,   2.6182306E-03,   2.6864556E-03,   2.7559178E-03
     +,   2.8265768E-03,   2.8983797E-03,   2.9712748E-03
     +,   3.0451994E-03,   3.1200871E-03,   3.1958653E-03
     +,   3.2724557E-03,   3.3497759E-03,   3.4277386E-03
     +,   3.5062511E-03,   3.5852189E-03,   3.6645441E-03
     +,   3.7441256E-03,   3.8238624E-03,   3.9036500E-03
     +,   3.9833905E-03,   4.0629767E-03,   4.1423147E-03
     +,   4.2213076E-03,   4.2998646E-03,   4.3779011E-03
     +,   4.4553378E-03,   4.5321067E-03,   4.6081468E-03
     +,   4.6834094E-03,   4.7578583E-03,   4.8314715E-03
     +,   4.9042422E-03,   4.9761808E-03,   5.0473134E-03
     +,   5.1176939E-03,   5.1873871E-03,   5.2564894E-03
     +,   5.3251195E-03,   5.3934180E-03,   5.4615592E-03
     +,   5.5297418E-03,   5.5981949E-03,   5.6671831E-03
     +,   5.7369960E-03,   5.8079641E-03,   5.8804504E-03
     +,   5.9548491E-03,   6.0315980E-03,   6.1111585E-03
     +,   6.1940444E-03,   6.2807864E-03,   6.3719656E-03
     +,   6.4681885E-03,   6.5700966E-03,   6.6783559E-03
     +,   6.7936643E-03,   6.9167428E-03,   7.0483238E-03
     +,   7.1891500E-03,   7.3399777E-03,   7.5015570E-03
     +,   7.6746205E-03,   7.8598913E-03,   8.0580385E-03
     +,   8.2697123E-03,   8.4954752E-03,   8.7358421E-03
     +,   8.9912172E-03,   9.2619229E-03,   9.5481370E-03
     +,   9.8499227E-03,   1.0167198E-02,   1.0499701E-02
     +,   1.0846986E-02,   1.1208457E-02,   1.1583315E-02
     +,   1.1970545E-02,   1.2368985E-02,   1.2777229E-02
     +,   1.3193759E-02,   1.3616834E-02,   1.4044635E-02
     +,   1.4475175E-02,   1.4906443E-02,   1.5336332E-02
     +,   1.5762784E-02,   1.6183786E-02,   1.6597390E-02
     +,   1.7001808E-02,   1.7395467E-02,   1.7777048E-02
     +,   1.8145487E-02,   1.8500101E-02,   1.8840540E-02
     +,   1.9166874E-02,   1.9479550E-02,   1.9779481E-02
     +,   2.0067908E-02,   2.0346506E-02,   2.0617256E-02
     +,   2.0882435E-02,   2.1144552E-02,   2.1406250E-02
     +,   2.1670224E-02,   2.1939186E-02,   2.2215754E-02
     +,   2.2502335E-02,   2.2801176E-02,   2.3114188E-02
     +,   2.3443097E-02,   2.3789303E-02,   2.4154104E-02
     +,   2.4538664E-02,   2.4944291E-02,   2.5372472E-02
     +,   2.5825242E-02,   2.6305340E-02,   2.6816461E-02
     +,   2.7363438E-02,   2.7952576E-02,   2.8591674E-02
     +,   2.9290128E-02,   3.0058801E-02,   3.0910041E-02
     +,   3.1857342E-02,   3.2914743E-02,   3.4096614E-02
     +,   3.5416845E-02,   3.6888059E-02,   3.8520958E-02
     +,   4.0323682E-02,   4.2300999E-02,   4.4453721E-02
     +,   4.6778288E-02,   4.9266867E-02,   5.1907346E-02
     +,   5.4683436E-02,   5.7575431E-02,   6.0561132E-02
     +,   6.3616492E-02,   6.6715859E-02,   6.9833197E-02
     +,   7.2941884E-02,   7.6014213E-02,   7.9021245E-02
     +,   8.1932388E-02,   8.4714897E-02,   8.7333903E-02
     +,   8.9754090E-02,   9.1942579E-02,   9.3872957E-02
     +,   9.5530905E-02,   9.6920632E-02,   9.8071143E-02
     +,   9.9040717E-02,   9.9918693E-02,   0.1008232    
     +,   0.1018949    ,   0.1032854    ,   0.1051440    
     +,   0.1076039    ,   0.1107706    ,   0.1147159    
     +,   0.1194804    ,   0.1250857    ,   0.1315544    
     +,   0.1389367    ,   0.1473399    ,   0.1569539    
     +,   0.1680642    ,   0.1810413    ,   0.1963074    
     +,   0.2142717    ,   0.2352549    ,   0.2594248    
     +,   0.2867757    ,   0.3171586    ,   0.3503556    
     +,   0.3861547    ,   0.4243636    ,   0.4646958    
     +,   0.5065202    ,   0.5485526    ,   0.5886073    
     +,   0.6235646    ,   0.6496729    ,   0.6631804    
     +,   0.6611238    ,   0.6420397    ,   0.6063713    
     +,   0.5564288    ,   0.4959602    ,   0.4294894    
     +,   0.3616005    ,   0.2963358    ,   0.2368097    
     +,   0.1850365    ,   0.1419411    ,   0.1075109    
     +,   8.1038058E-02,   6.1386954E-02,   4.7238834E-02
     +,   3.7294511E-02,   3.0407382E-02,   2.5648318E-02
     +,   2.2317206E-02,   1.9918708E-02,   1.8119995E-02
     +,   1.6705712E-02,   1.5539421E-02,   1.4535049E-02
     +,   1.3637822E-02,   1.2812488E-02,   1.2036475E-02
     +,   1.1295890E-02,   1.0582932E-02,   9.8938253E-03
     +,   9.2273941E-03,   8.5839722E-03,   7.9645654E-03
     +,   7.3703113E-03,   6.8022613E-03,   6.2613022E-03
     +,   5.7480875E-03,   5.2630198E-03,   4.8063044E-03
     +,   4.3779863E-03,   3.9779223E-03,   3.6057546E-03
     +,   3.2609424E-03,   2.9427938E-03,   2.6504081E-03
     +,   2.3827278E-03,   2.1385760E-03,   1.9166570E-03
     +,   1.7155765E-03,   1.5338861E-03,   1.3701246E-03
     +,   1.2228306E-03,   1.0905613E-03,   9.7192742E-04
     +,   8.6561777E-04,   7.7040336E-04,   6.8514189E-04
     +,   6.0879090E-04,   5.4041483E-04,   4.7916782E-04
     +,   4.2429770E-04,   3.7514162E-04,   3.3111381E-04
     +,   2.9169497E-04,   2.5642695E-04,   2.2490635E-04
     +,   1.9677437E-04,   1.7170818E-04,   1.4941770E-04
     +,   1.2964242E-04,   1.1214248E-04,   9.6700569E-05
     +,   8.3115025E-05,   7.1201859E-05,   6.0789716E-05
     +,   5.1722011E-05,   4.3853201E-05,   3.7050562E-05
     +,   3.1191488E-05,   2.6164844E-05,   2.1868984E-05
     +,   1.8211958E-05,   1.5111263E-05,   1.2492529E-05
     +,   1.0289798E-05,   8.4442518E-06,   6.9042480E-06
     +,   5.6242452E-06,   4.5646743E-06,   3.6910085E-06
     +,   2.9735500E-06,   2.3866785E-06,   1.9085612E-06
     +,   1.5205663E-06,   1.2069746E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_asha_ttz120_mass = Yx/4.0905252
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_asha_ttz60_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  7.4875075E-04,   7.7258627E-04
     +,   7.9807197E-04,   8.2533655E-04,   8.5452263E-04
     +,   8.8579161E-04,   9.1932720E-04,   9.5534266E-04
     +,   9.9408755E-04,   1.0358577E-03,   1.0810025E-03
     +,   1.1299384E-03,   1.1831610E-03,   1.2412601E-03
     +,   1.3049338E-03,   1.3750056E-03,   1.4524413E-03
     +,   1.5383663E-03,   1.6340818E-03,   1.7410818E-03
     +,   1.8610674E-03,   1.9959572E-03,   2.1478967E-03
     +,   2.3192735E-03,   2.5126922E-03,   2.7310108E-03
     +,   2.9772955E-03,   3.2548311E-03,   3.5671000E-03
     +,   3.9177667E-03,   4.3106582E-03,   4.7497568E-03
     +,   5.2391863E-03,   5.7832152E-03,   6.3862638E-03
     +,   7.0529296E-03,   7.7880253E-03,   8.5966168E-03
     +,   9.4841560E-03,   1.0456408E-02,   1.1519729E-02
     +,   1.2680979E-02,   1.3947691E-02,   1.5328112E-02
     +,   1.6831242E-02,   1.8466901E-02,   2.0245692E-02
     +,   2.2179062E-02,   2.4279201E-02,   2.6559073E-02
     +,   2.9032294E-02,   3.1713028E-02,   3.4615804E-02
     +,   3.7755456E-02,   4.1146263E-02,   4.4802129E-02
     +,   4.8735242E-02,   5.2955668E-02,   5.7470001E-02
     +,   6.2280409E-02,   6.7383282E-02,   7.2768323E-02
     +,   7.8417040E-02,   8.4302902E-02,   9.0390727E-02
     +,   9.6636273E-02,   0.1029887    ,   0.1093898    
     +,   0.1157781    ,   0.1220888    ,   0.1282585    
     +,   0.1342259    ,   0.1399367    ,   0.1453451    
     +,   0.1504175    ,   0.1551359    ,   0.1594990    
     +,   0.1635250    ,   0.1672520    ,   0.1707364    
     +,   0.1740492    ,   0.1772717    ,   0.1804874    
     +,   0.1837752    ,   0.1872012    ,   0.1908135    
     +,   0.1946374    ,   0.1986753    ,   0.2029073    
     +,   0.2072945    ,   0.2117817    ,   0.2162991    
     +,   0.2207652    ,   0.2250879    ,   0.2291666    
     +,   0.2328953    ,   0.2361686    ,   0.2388893    
     +,   0.2409762    ,   0.2423723    ,   0.2430479    
     +,   0.2430002    ,   0.2422477    ,   0.2408210    
     +,   0.2387498    ,   0.2360551    ,   0.2327419    
     +,   0.2288026    ,   0.2242252    ,   0.2190078    
     +,   0.2131765    ,   0.2067987    ,   0.1999937    
     +,   0.1929297    ,   0.1858161    ,   0.1788823    
     +,   0.1723571    ,   0.1664414    ,   0.1612904    
     +,   0.1569970    ,   0.1535866    ,   0.1510180    
     +,   0.1491918    ,   0.1479625    ,   0.1471537    
     +,   0.1465739    ,   0.1460302    ,   0.1453420    
     +,   0.1443509    ,   0.1429294    ,   0.1409864    
     +,   0.1384714    ,   0.1353747    ,   0.1317278    
     +,   0.1275981    ,   0.1230841    ,   0.1183082    
     +,   0.1134074    ,   0.1085241    ,   0.1037967    
     +,   9.9352010E-02,   9.5297530E-02,   9.1715917E-02
     +,   8.8662386E-02,   8.6163811E-02,   8.4219202E-02
     +,   8.2803048E-02,   8.1869557E-02,   8.1357919E-02
     +,   8.1197925E-02,   8.1315830E-02,   8.1639409E-02
     +,   8.2102194E-02,   8.2646720E-02,   8.3226316E-02
     +,   8.3805665E-02,   8.4360667E-02,   8.4876753E-02
     +,   8.5347258E-02,   8.5770957E-02,   8.6149849E-02
     +,   8.6486891E-02,   8.6784184E-02,   8.7041691E-02
     +,   8.7256163E-02,   8.7420903E-02,   8.7525874E-02
     +,   8.7558053E-02,   8.7502338E-02,   8.7342478E-02
     +,   8.7062120E-02,   8.6645767E-02,   8.6079925E-02
     +,   8.5353568E-02,   8.4459014E-02,   8.3392002E-02
     +,   8.2151823E-02,   8.0741435E-02,   7.9166904E-02
     +,   7.7437043E-02,   7.5562887E-02,   7.3557369E-02
     +,   7.1434557E-02,   6.9209099E-02,   6.6895865E-02
     +,   6.4509772E-02,   6.2065292E-02,   5.9576243E-02
     +,   5.7055689E-02,   5.4516230E-02,   5.1969461E-02
     +,   4.9426328E-02,   4.6897247E-02,   4.4392038E-02
     +,   4.1919865E-02,   3.9489366E-02,   3.7108887E-02
     +,   3.4786273E-02,   3.2528728E-02,   3.0342916E-02
     +,   2.8235035E-02,   2.6210610E-02,   2.4274269E-02
     +,   2.2429818E-02,   2.0680364E-02,   1.9027906E-02
     +,   1.7473482E-02,   1.6017284E-02,   1.4658557E-02
     +,   1.3395579E-02,   1.2225822E-02,   1.1146133E-02
     +,   1.0152748E-02,   9.2413425E-03,   8.4072556E-03
     +,   7.6456359E-03,   6.9515104E-03,   6.3198367E-03
     +,   5.7456568E-03,   5.2242260E-03,   4.7509493E-03
     +,   4.3215021E-03,   3.9318730E-03,   3.5783506E-03
     +,   3.2575065E-03,   2.9662200E-03,   2.7016790E-03
     +,   2.4613433E-03,   2.2429037E-03,   2.0442882E-03
     +,   1.8636407E-03,   1.6992908E-03,   1.5497195E-03
     +,   1.4135572E-03,   1.2895763E-03,   1.1766515E-03
     +,   1.0737616E-03,   9.7998604E-04,   8.9448597E-04
     +,   8.1649388E-04,   7.4531208E-04,   6.8031263E-04
     +,   6.2092493E-04,   5.6662923E-04,   5.1695568E-04
     +,   4.7148459E-04,   4.2983703E-04,   3.9166972E-04
     +,   3.5667498E-04,   3.2457933E-04,   2.9513470E-04
     +,   2.6811796E-04,   2.4333068E-04,   2.2059371E-04
     +,   1.9974379E-04,   1.8063351E-04,   1.6312966E-04
     +,   1.4711091E-04,   1.3246495E-04,   1.1908857E-04
     +,   1.0688749E-04,   9.5773990E-05,   8.5665888E-05
     +,   7.6486598E-05,   6.8165471E-05,   6.0635470E-05
     +,   5.3833784E-05,   4.7702095E-05,   4.2185537E-05
     +,   3.7232388E-05,   3.2794262E-05,   2.8826220E-05
     +,   2.5286283E-05,   2.2135073E-05,   1.9336068E-05
     +,   1.6855634E-05,   1.4662363E-05,   1.2727534E-05
     +,   1.1024493E-05,   9.5290325E-06,   8.2187780E-06
     +,   7.0735391E-06,   6.0747834E-06,   5.2058526E-06
     +,   4.4515837E-06,   3.7984132E-06,   3.2340824E-06
     +,   2.7476315E-06,   2.3293123E-06,   1.9703996E-06
     +,   1.6631889E-06,   1.4008284E-06,   1.1773041E-06
     +,   9.8729595E-07,   8.2616282E-07,   6.8982467E-07
     +,   5.7473949E-07,   4.7781248E-07,   3.9637254E-07
     +,   3.2809766E-07,   2.7099540E-07
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_asha_ttz60_mass = Yx/4.46352433333333
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_asha_ttz65_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.9433801E-04,   4.0368197E-04
     +,   4.1303659E-04,   4.2239774E-04,   4.3176333E-04
     +,   4.4113278E-04,   4.5050864E-04,   4.5989608E-04
     +,   4.6930413E-04,   4.7874698E-04,   4.8824414E-04
     +,   4.9782189E-04,   5.0751481E-04,   5.1736704E-04
     +,   5.2743417E-04,   5.3778500E-04,   5.4850394E-04
     +,   5.5969355E-04,   5.7147659E-04,   5.8399950E-04
     +,   5.9743552E-04,   6.1198708E-04,   6.2789023E-04
     +,   6.4541836E-04,   6.6488289E-04,   6.8664004E-04
     +,   7.1109098E-04,   7.3868531E-04,   7.6992175E-04
     +,   8.0534961E-04,   8.4556732E-04,   8.9122093E-04
     +,   9.4299979E-04,   1.0016303E-03,   1.0678689E-03
     +,   1.1424902E-03,   1.2262756E-03,   1.3199963E-03
     +,   1.4244040E-03,   1.5401957E-03,   1.6680210E-03
     +,   1.8084446E-03,   1.9619460E-03,   2.1289110E-03
     +,   2.3096385E-03,   2.5043620E-03,   2.7132907E-03
     +,   2.9366759E-03,   3.1749108E-03,   3.4286631E-03
     +,   3.6990438E-03,   3.9878213E-03,   4.2976527E-03
     +,   4.6323882E-03,   4.9972907E-03,   5.3993952E-03
     +,   5.8477214E-03,   6.3535171E-03,   6.9304556E-03
     +,   7.5947405E-03,   8.3652157E-03,   9.2634363E-03
     +,   1.0313665E-02,   1.1543159E-02,   1.2982355E-02
     +,   1.4665123E-02,   1.6629701E-02,   1.8919112E-02
     +,   2.1582730E-02,   2.4677118E-02,   2.8268324E-02
     +,   3.2433130E-02,   3.7262324E-02,   4.2862114E-02
     +,   4.9357727E-02,   5.6894928E-02,   6.5640219E-02
     +,   7.5779229E-02,   8.7512471E-02,   0.1010452    
     +,   0.1165705    ,   0.1342513    ,   0.1541866    
     +,   0.1763808    ,   0.2006954    ,   0.2268122    
     +,   0.2541929    ,   0.2820747    ,   0.3094916    
     +,   0.3353598    ,   0.3586063    ,   0.3783307    
     +,   0.3939664    ,   0.4053904    ,   0.4129348    
     +,   0.4172923    ,   0.4193405    ,   0.4199298    
     +,   0.4197173    ,   0.4190845    ,   0.4181525    
     +,   0.4168589    ,   0.4150588    ,   0.4126091    
     +,   0.4094295    ,   0.4055459    ,   0.4011042    
     +,   0.3963416    ,   0.3915038    ,   0.3867215    
     +,   0.3818975    ,   0.3766690    ,   0.3704938    
     +,   0.3628418    ,   0.3534321    ,   0.3424072    
     +,   0.3303863    ,   0.3183591    ,   0.3074732    
     +,   0.2987740    ,   0.2929839    ,   0.2903639    
     +,   0.2906824    ,   0.2932856    ,   0.2972403    
     +,   0.3015207    ,   0.3051917    ,   0.3075509    
     +,   0.3082020    ,   0.3070481    ,   0.3042237    
     +,   0.2999971    ,   0.2946739    ,   0.2885315    
     +,   0.2817889    ,   0.2746072    ,   0.2671094    
     +,   0.2593998    ,   0.2515788    ,   0.2437461    
     +,   0.2359965    ,   0.2284092    ,   0.2210371    
     +,   0.2138991    ,   0.2069787    ,   0.2002241    
     +,   0.1935562    ,   0.1868792    ,   0.1800927    
     +,   0.1731056    ,   0.1658508    ,   0.1582983    
     +,   0.1504641    ,   0.1424132    ,   0.1342565    
     +,   0.1261411    ,   0.1182337    ,   0.1107010    
     +,   0.1036913    ,   9.7319454E-02,   9.1655441E-02
     +,   8.6722076E-02,   8.2498483E-02,   7.8928031E-02
     +,   7.5929530E-02,   7.3409542E-02,   7.1273841E-02
     +,   6.9435582E-02,   6.7820840E-02,   6.6371270E-02
     +,   6.5043882E-02,   6.3809216E-02,   6.2648237E-02
     +,   6.1549086E-02,   6.0504328E-02,   5.9508204E-02
     +,   5.8554869E-02,   5.7637461E-02,   5.6747604E-02
     +,   5.5875324E-02,   5.5009373E-02,   5.4137874E-02
     +,   5.3248860E-02,   5.2330773E-02,   5.1373053E-02
     +,   5.0366707E-02,   4.9304567E-02,   4.8181493E-02
     +,   4.6994515E-02,   4.5743078E-02,   4.4428654E-02
     +,   4.3054804E-02,   4.1626979E-02,   4.0152233E-02
     +,   3.8638778E-02,   3.7095748E-02,   3.5532936E-02
     +,   3.3960383E-02,   3.2387935E-02,   3.0825047E-02
     +,   2.9280649E-02,   2.7762843E-02,   2.6278635E-02
     +,   2.4833981E-02,   2.3433851E-02,   2.2081977E-02
     +,   2.0781044E-02,   1.9532828E-02,   1.8338265E-02
     +,   1.7197426E-02,   1.6109804E-02,   1.5074454E-02
     +,   1.4090069E-02,   1.3155024E-02,   1.2267548E-02
     +,   1.1425868E-02,   1.0628180E-02,   9.8726908E-03
     +,   9.1576753E-03,   8.4815798E-03,   7.8428788E-03
     +,   7.2401511E-03,   6.6721085E-03,   6.1375382E-03
     +,   5.6352490E-03,   5.1641022E-03,   4.7230241E-03
     +,   4.3109483E-03,   3.9267852E-03,   3.5694442E-03
     +,   3.2378465E-03,   2.9308964E-03,   2.6474583E-03
     +,   2.3863888E-03,   2.1465530E-03,   1.9267866E-03
     +,   1.7259255E-03,   1.5428237E-03,   1.3763469E-03
     +,   1.2253656E-03,   1.0887786E-03,   9.6552499E-04
     +,   8.5457839E-04,   7.5494609E-04,   6.6568155E-04
     +,   5.8589247E-04,   5.1473529E-04,   4.5141266E-04
     +,   3.9518063E-04,   3.4535240E-04,   3.0128655E-04
     +,   2.6239271E-04,   2.2813135E-04,   1.9800867E-04
     +,   1.7157286E-04,   1.4841417E-04,   1.2816340E-04
     +,   1.1048734E-04,   9.5085139E-05,   8.1687402E-05
     +,   7.0053946E-05,   5.9970429E-05,   5.1245384E-05
     +,   4.3708947E-05,   3.7211295E-05,   3.1619216E-05
     +,   2.6815271E-05,   2.2696255E-05,   1.9171395E-05
     +,   1.6160780E-05,   1.3594435E-05,   1.1411330E-05
     +,   9.5581672E-06,   7.9883539E-06,   6.6614198E-06
     +,   5.5423343E-06,   4.6006144E-06,   3.8100156E-06
     +,   3.1477991E-06,   2.5944714E-06,   2.1332141E-06
     +,   1.7496770E-06,   1.4315349E-06,   1.1683208E-06
     +,   9.5109107E-07,   7.7228771E-07,   6.2549168E-07
     +,   5.0528593E-07,   4.0712209E-07,   3.2716827E-07
     +,   2.6222611E-07,   2.0961674E-07,   1.6711763E-07
     +,   1.3287784E-07,   1.0537051E-07,   8.3331727E-08
     +,   6.5724628E-08,   5.1696667E-08,   4.0552393E-08
     +,   3.1723378E-08,   2.4748903E-08
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_asha_ttz65_mass = Yx/6.152139
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_asha_ttz70_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  9.8928949E-04,   1.0325767E-03
     +,   1.0771967E-03,   1.1231515E-03,   1.1704410E-03
     +,   1.2190613E-03,   1.2690051E-03,   1.3202624E-03
     +,   1.3728183E-03,   1.4266568E-03,   1.4817560E-03
     +,   1.5380903E-03,   1.5956302E-03,   1.6543425E-03
     +,   1.7141892E-03,   1.7751278E-03,   1.8371119E-03
     +,   1.9000896E-03,   1.9640052E-03,   2.0287975E-03
     +,   2.0944013E-03,   2.1607457E-03,   2.2277539E-03
     +,   2.2953486E-03,   2.3634401E-03,   2.4319417E-03
     +,   2.5007564E-03,   2.5697851E-03,   2.6389232E-03
     +,   2.7080628E-03,   2.7770917E-03,   2.8458955E-03
     +,   2.9143579E-03,   2.9823608E-03,   3.0497883E-03
     +,   3.1165266E-03,   3.1824668E-03,   3.2475085E-03
     +,   3.3115686E-03,   3.3745740E-03,   3.4364816E-03
     +,   3.4972790E-03,   3.5569931E-03,   3.6157027E-03
     +,   3.6735507E-03,   3.7307567E-03,   3.7876361E-03
     +,   3.8446134E-03,   3.9022453E-03,   3.9612362E-03
     +,   4.0224656E-03,   4.0869992E-03,   4.1561178E-03
     +,   4.2313300E-03,   4.3143835E-03,   4.4072829E-03
     +,   4.5122877E-03,   4.6319137E-03,   4.7689234E-03
     +,   4.9263085E-03,   5.1072706E-03,   5.3151920E-03
     +,   5.5535873E-03,   5.8260974E-03,   6.1364449E-03
     +,   6.4883768E-03,   6.8857265E-03,   7.3323245E-03
     +,   7.8321528E-03,   8.3893035E-03,   9.0082483E-03
     +,   9.6938899E-03,   1.0452003E-02,   1.1289435E-02
     +,   1.2214742E-02,   1.3238674E-02,   1.4374738E-02
     +,   1.5639871E-02,   1.7055135E-02,   1.8646002E-02
     +,   2.0442318E-02,   2.2478266E-02,   2.4790958E-02
     +,   2.7419521E-02,   3.0402396E-02,   3.3775825E-02
     +,   3.7570719E-02,   4.1811641E-02,   4.6514306E-02
     +,   5.1685572E-02,   5.7322446E-02,   6.3411921E-02
     +,   6.9933213E-02,   7.6865256E-02,   8.4202483E-02
     +,   9.1984734E-02,   0.1003463    ,   0.1095746    
     +,   0.1201743    ,   0.1329073    ,   0.1487994    
     +,   0.1690887    ,   0.1951380    ,   0.2283049    
     +,   0.2697921    ,   0.3204265    ,   0.3803074    
     +,   0.4483155    ,   0.5215939    ,   0.5952986    
     +,   0.6630103    ,   0.7180260    ,   0.7552032    
     +,   0.7726654    ,   0.7724602    ,   0.7598118    
     +,   0.7412969    ,   0.7228246    ,   0.7082544    
     +,   0.6989881    ,   0.6943936    ,   0.6926144    
     +,   0.6914193    ,   0.6888825    ,   0.6837907    
     +,   0.6756998    ,   0.6647155    ,   0.6512362    
     +,   0.6359466    ,   0.6200887    ,   0.6056315    
     +,   0.5949348    ,   0.5898132    ,   0.5904721    
     +,   0.5949640    ,   0.5995844    ,   0.6000938    
     +,   0.5932367    ,   0.5778487    ,   0.5550813    
     +,   0.5276804    ,   0.4987097    ,   0.4703613    
     +,   0.4433949    ,   0.4173692    ,   0.3913879    
     +,   0.3648906    ,   0.3380728    ,   0.3118032    
     +,   0.2871996    ,   0.2651501    ,   0.2460179    
     +,   0.2296122    ,   0.2153711    ,   0.2026284    
     +,   0.1908337    ,   0.1796646    ,   0.1690305    
     +,   0.1590083    ,   0.1497559    ,   0.1414362    
     +,   0.1341687    ,   0.1280084    ,   0.1229405    
     +,   0.1188870    ,   0.1157178    ,   0.1132640    
     +,   0.1113328    ,   0.1097232    ,   0.1082426    
     +,   0.1067221    ,   0.1050282    ,   0.1030706    
     +,   0.1008041    ,   9.8227009E-02,   9.5373616E-02
     +,   9.2304766E-02,   8.9098006E-02,   8.5836455E-02
     +,   8.2600281E-02,   7.9459399E-02,   7.6469265E-02
     +,   7.3668577E-02,   7.1078539E-02,   6.8704441E-02
     +,   6.6538259E-02,   6.4561278E-02,   6.2747367E-02
     +,   6.1066125E-02,   5.9485916E-02,   5.7975721E-02
     +,   5.6507129E-02,   5.5055756E-02,   5.3601664E-02
     +,   5.2129742E-02,   5.0629526E-02,   4.9095057E-02
     +,   4.7524139E-02,   4.5917623E-02,   4.4278782E-02
     +,   4.2612765E-02,   4.0925801E-02,   3.9224677E-02
     +,   3.7516259E-02,   3.5807502E-02,   3.4104779E-02
     +,   3.2413945E-02,   3.0740427E-02,   2.9089103E-02
     +,   2.7464207E-02,   2.5869567E-02,   2.4308756E-02
     +,   2.2785041E-02,   2.1301394E-02,   1.9860594E-02
     +,   1.8465392E-02,   1.7118368E-02,   1.5821867E-02
     +,   1.4578051E-02,   1.3388977E-02,   1.2256326E-02
     +,   1.1181468E-02,   1.0165503E-02,   9.2091402E-03
     +,   8.3126212E-03,   7.4757780E-03,   6.6980897E-03
     +,   5.9786108E-03,   5.3159683E-03,   4.7084396E-03
     +,   4.1540246E-03,   3.6504401E-03,   3.1951442E-03
     +,   2.7854179E-03,   2.4184554E-03,   2.0913268E-03
     +,   1.8010709E-03,   1.5447534E-03,   1.3194783E-03
     +,   1.1224101E-03,   9.5082255E-04,   8.0212718E-04
     +,   6.7387777E-04,   5.6377670E-04,   4.6969406E-04
     +,   3.8967683E-04,   3.2194052E-04,   2.6486427E-04
     +,   2.1699135E-04,   1.7702572E-04,   1.4381371E-04
     +,   1.1633994E-04,   9.3717936E-05,   7.5176591E-05
     +,   6.0048591E-05,   4.7761416E-05,   3.7827311E-05
     +,   2.9832379E-05,   2.3427016E-05,   1.8318302E-05
     +,   1.4262356E-05,   1.1056905E-05,   8.5350066E-06
     +,   6.5598233E-06,   5.0199565E-06,   3.8248718E-06
     +,   2.9015710E-06,   2.1915171E-06,   1.6479693E-06
     +,   1.2337709E-06,   9.1958003E-07,   6.8235505E-07
     +,   5.0407328E-07,   3.7070393E-07,   2.7139302E-07
     +,   1.9779235E-07,   1.4349678E-07,   1.0363315E-07
     +,   7.4500967E-08,   5.3313077E-08,   3.7974957E-08
     +,   2.6924953E-08,   1.9001604E-08,   1.3347687E-08
     +,   9.3322363E-09,   6.4943131E-09,   4.4981832E-09
     +,   3.1008907E-09,   2.1275810E-09,   1.4528472E-09
     +,   9.8740149E-10,   6.6786932E-10,   4.4959281E-10
     +,   3.0120578E-10,   2.0082992E-10,   1.3326019E-10
     +,   8.8001023E-11,   5.7832787E-11,   3.7824185E-11
     +,   2.4618304E-11,   1.5945965E-11
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_asha_ttz70_mass = Yx/8.14005885
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_asha_ttz75_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.0224857E-03,   1.0538875E-03
     +,   1.0879202E-03,   1.1246863E-03,   1.1642837E-03
     +,   1.2068029E-03,   1.2523265E-03,   1.3009282E-03
     +,   1.3526704E-03,   1.4076056E-03,   1.4657726E-03
     +,   1.5271972E-03,   1.5918894E-03,   1.6598433E-03
     +,   1.7310368E-03,   1.8054295E-03,   1.8829615E-03
     +,   1.9635537E-03,   2.0471076E-03,   2.1335026E-03
     +,   2.2225981E-03,   2.3142314E-03,   2.4082181E-03
     +,   2.5043574E-03,   2.6024180E-03,   2.7021596E-03
     +,   2.8033161E-03,   2.9056049E-03,   3.0087258E-03
     +,   3.1123643E-03,   3.2161917E-03,   3.3198660E-03
     +,   3.4230386E-03,   3.5253498E-03,   3.6264362E-03
     +,   3.7259320E-03,   3.8234706E-03,   3.9186864E-03
     +,   4.0112240E-03,   4.1007278E-03,   4.1868608E-03
     +,   4.2692944E-03,   4.3477169E-03,   4.4218348E-03
     +,   4.4913748E-03,   4.5560864E-03,   4.6157441E-03
     +,   4.6701478E-03,   4.7191242E-03,   4.7625313E-03
     +,   4.8002531E-03,   4.8322091E-03,   4.8583434E-03
     +,   4.8786364E-03,   4.8930962E-03,   4.9017635E-03
     +,   4.9047107E-03,   4.9020383E-03,   4.8938813E-03
     +,   4.8804055E-03,   4.8618116E-03,   4.8383344E-03
     +,   4.8102541E-03,   4.7778934E-03,   4.7416338E-03
     +,   4.7019282E-03,   4.6593081E-03,   4.6144244E-03
     +,   4.5680511E-03,   4.5211450E-03,   4.4748727E-03
     +,   4.4306782E-03,   4.3903389E-03,   4.3560457E-03
     +,   4.3304968E-03,   4.3169898E-03,   4.3195440E-03
     +,   4.3430151E-03,   4.3932237E-03,   4.4770865E-03
     +,   4.6027279E-03,   4.7796085E-03,   5.0185695E-03
     +,   5.3319344E-03,   5.7334318E-03,   6.2382291E-03
     +,   6.8626837E-03,   7.6242876E-03,   8.5412301E-03
     +,   9.6322373E-03,   1.0916189E-02,   1.2411653E-02
     +,   1.4136630E-02,   1.6108423E-02,   1.8343398E-02
     +,   2.0856675E-02,   2.3662651E-02,   2.6774507E-02
     +,   3.0205110E-02,   3.3966526E-02,   3.8071305E-02
     +,   4.2531904E-02,   4.7362112E-02,   5.2576151E-02
     +,   5.8189988E-02,   6.4221881E-02,   7.0695147E-02
     +,   7.7645898E-02,   8.5138172E-02,   9.3286119E-02
     +,   0.1022840    ,   0.1124431    ,   0.1242228    
     +,   0.1382578    ,   0.1553605    ,   0.1765051    
     +,   0.2027818    ,   0.2353487    ,   0.2753422    
     +,   0.3236892    ,   0.3807081    ,   0.4456313    
     +,   0.5165707    ,   0.5914440    ,   0.6694854    
     +,   0.7519701    ,   0.8411797    ,   0.9381609    
     +,    1.040400    ,    1.139670    ,    1.222283    
     +,    1.276051    ,    1.302336    ,    1.320123    
     +,    1.352575    ,    1.406975    ,    1.467884    
     +,    1.508145    ,    1.506892    ,    1.462198    
     +,    1.390686    ,    1.315576    ,    1.253487    
     +,    1.207790    ,    1.169120    ,    1.122003    
     +,    1.054720    ,   0.9662890    ,   0.8660949    
     +,   0.7674445    ,   0.6803468    ,   0.6080205    
     +,   0.5480146    ,   0.4957545    ,   0.4477513    
     +,   0.4029265    ,   0.3620783    ,   0.3265113    
     +,   0.2969279    ,   0.2730769    ,   0.2540091    
     +,   0.2385360    ,   0.2255747    ,   0.2142937    
     +,   0.2041236    ,   0.1947133    ,   0.1858821    
     +,   0.1775798    ,   0.1698503    ,   0.1627931    
     +,   0.1565224    ,   0.1511260    ,   0.1466336    
     +,   0.1429979    ,   0.1400915    ,   0.1377169    
     +,   0.1356291    ,   0.1335644    ,   0.1312705    
     +,   0.1285337    ,   0.1251991    ,   0.1211824    
     +,   0.1164724    ,   0.1111243    ,   0.1052478    
     +,   9.8991461E-02,   9.2524238E-02,   8.6018078E-02
     +,   7.9633377E-02,   7.3508583E-02,   6.7751855E-02
     +,   6.2438712E-02,   5.7612654E-02,   5.3287949E-02
     +,   4.9454249E-02,   4.6082560E-02,   4.3131240E-02
     +,   4.0550876E-02,   3.8288672E-02,   3.6292024E-02
     +,   3.4511130E-02,   3.2900453E-02,   3.1419590E-02
     +,   3.0033858E-02,   2.8714450E-02,   2.7438078E-02
     +,   2.6186766E-02,   2.4947543E-02,   2.3711860E-02
     +,   2.2475021E-02,   2.1235725E-02,   1.9995531E-02
     +,   1.8758262E-02,   1.7529298E-02,   1.6315153E-02
     +,   1.5123026E-02,   1.3960262E-02,   1.2833901E-02
     +,   1.1750408E-02,   1.0715554E-02,   9.7340085E-03
     +,   8.8093653E-03,   7.9441397E-03,   7.1397284E-03
     +,   6.3964212E-03,   5.7135550E-03,   5.0896835E-03
     +,   4.5226468E-03,   4.0096948E-03,   3.5476689E-03
     +,   3.1331629E-03,   2.7626052E-03,   2.4323454E-03
     +,   2.1387786E-03,   1.8784356E-03,   1.6479843E-03
     +,   1.4443004E-03,   1.2645037E-03,   1.1059522E-03
     +,   9.6623867E-04,   8.4319874E-04,   7.3490530E-04
     +,   6.3964387E-04,   5.5588968E-04,   4.8229835E-04
     +,   4.1768904E-04,   3.6102135E-04,   3.1137423E-04
     +,   2.6793612E-04,   2.2999384E-04,   1.9691163E-04
     +,   1.6812586E-04,   1.4313687E-04,   1.2149903E-04
     +,   1.0281311E-04,   8.6722757E-05,   7.2910450E-05
     +,   6.1092243E-05,   5.1013889E-05,   4.2448890E-05
     +,   3.5196386E-05,   2.9078015E-05,   2.3935625E-05
     +,   1.9629959E-05,   1.6039088E-05,   1.3056017E-05
     +,   1.0587623E-05,   8.5533684E-06,   6.8836985E-06
     +,   5.5187807E-06,   4.4074959E-06,   3.5064415E-06
     +,   2.7788583E-06,   2.1937369E-06,   1.7251031E-06
     +,   1.3513325E-06,   1.0544278E-06,   8.1956779E-07
     +,   6.3453729E-07,   4.8937324E-07,   3.7594617E-07
     +,   2.8768690E-07,   2.1928845E-07,   1.6650201E-07
     +,   1.2592824E-07,   9.4871218E-08,   7.1195018E-08
     +,   5.3218585E-08,   3.9626414E-08,   2.9390366E-08
     +,   2.1713632E-08,   1.5979339E-08,   1.1713655E-08
     +,   8.5531191E-09,   6.2210588E-09,   4.5071573E-09
     +,   3.2527407E-09,   2.3382676E-09,   1.6743558E-09
     +,   1.1942614E-09,   8.4851548E-10
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_asha_ttz75_mass = Yx/10.557122
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_asha_ttz80_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.6544363E-06,   1.9158874E-06
     +,   2.2149309E-06,   2.5563575E-06,   2.9454775E-06
     +,   3.3881624E-06,   3.8908865E-06,   4.4607837E-06
     +,   5.1056709E-06,   5.8341561E-06,   6.6556190E-06
     +,   7.5803159E-06,   8.6194113E-06,   9.7850543E-06
     +,   1.1090433E-05,   1.2549824E-05,   1.4178673E-05
     +,   1.5993654E-05,   1.8012759E-05,   2.0255333E-05
     +,   2.2742184E-05,   2.5495659E-05,   2.8539675E-05
     +,   3.1900068E-05,   3.5604153E-05,   3.9681516E-05
     +,   4.4163637E-05,   4.9084170E-05,   5.4479144E-05
     +,   6.0387076E-05,   6.6849170E-05,   7.3909447E-05
     +,   8.1615028E-05,   9.0016358E-05,   9.9167322E-05
     +,   1.0912569E-04,   1.1995324E-04,   1.3171586E-04
     +,   1.4448486E-04,   1.5833507E-04,   1.7334787E-04
     +,   1.8960923E-04,   2.0721098E-04,   2.2625085E-04
     +,   2.4683229E-04,   2.6906517E-04,   2.9306512E-04
     +,   3.1895371E-04,   3.4685823E-04,   3.7691137E-04
     +,   4.0925047E-04,   4.4401712E-04,   4.8135547E-04
     +,   5.2141451E-04,   5.6433951E-04,   6.1028014E-04
     +,   6.5938121E-04,   7.1178388E-04,   7.6762366E-04
     +,   8.2702789E-04,   8.9011306E-04,   9.5698430E-04
     +,   1.0277262E-03,   1.1024115E-03,   1.1810928E-03
     +,   1.2637922E-03,   1.3505169E-03,   1.4412367E-03
     +,   1.5359037E-03,   1.6344276E-03,   1.7366989E-03
     +,   1.8425647E-03,   1.9518526E-03,   2.0643449E-03
     +,   2.1798054E-03,   2.2979707E-03,   2.4185465E-03
     +,   2.5412189E-03,   2.6656718E-03,   2.7915873E-03
     +,   2.9186460E-03,   3.0465764E-03,   3.1751408E-03
     +,   3.3042026E-03,   3.4337305E-03,   3.5638844E-03
     +,   3.6950430E-03,   3.8279211E-03,   3.9636265E-03
     +,   4.1038077E-03,   4.2507746E-03,   4.4076336E-03
     +,   4.5784623E-03,   4.7684908E-03,   4.9842708E-03
     +,   5.2338126E-03,   5.5268030E-03,   5.8746627E-03
     +,   6.2907380E-03,   6.7902738E-03,   7.3905722E-03
     +,   8.1108445E-03,   8.9723319E-03,   9.9979835E-03
     +,   1.1212399E-02,   1.2641360E-02,   1.4311058E-02
     +,   1.6247166E-02,   1.8473653E-02,   2.1011150E-02
     +,   2.3875026E-02,   2.7074812E-02,   3.0613232E-02
     +,   3.4488358E-02,   3.8695972E-02,   4.3235481E-02
     +,   4.8114318E-02,   5.3353284E-02,   5.8986325E-02
     +,   6.5058723E-02,   7.1622439E-02,   7.8736171E-02
     +,   8.6480476E-02,   9.4995283E-02,   0.1045385    
     +,   0.1155534    ,   0.1287253    ,   0.1449910    
     +,   0.1654887    ,   0.1914064    ,   0.2237318    
     +,   0.2629255    ,   0.3087603    ,   0.3606858    
     +,   0.4190450    ,   0.4867215    ,   0.5696889    
     +,   0.6742681    ,   0.8008154    ,   0.9388371    
     +,    1.071920    ,    1.195547    ,    1.336165    
     +,    1.540691    ,    1.818010    ,    2.090669    
     +,    2.241126    ,    2.225366    ,    2.118295    
     +,    2.013029    ,    1.935088    ,    1.903250    
     +,    1.935479    ,    1.966330    ,    1.921657    
     +,    1.816734    ,    1.681288    ,    1.510817    
     +,    1.319100    ,    1.149326    ,    1.026822    
     +,   0.9387619    ,   0.8594481    ,   0.7753507    
     +,   0.6868164    ,   0.5997545    ,   0.5205134    
     +,   0.4539545    ,   0.4019420    ,   0.3627491    
     +,   0.3323532    ,   0.3066874    ,   0.2831863    
     +,   0.2609730    ,   0.2401896    ,   0.2212461    
     +,   0.2043950    ,   0.1896079    ,   0.1766080    
     +,   0.1649651    ,   0.1542167    ,   0.1439850    
     +,   0.1340599    ,   0.1244239    ,   0.1152187    
     +,   0.1066739    ,   9.9023528E-02,   9.2439540E-02
     +,   8.6995535E-02,   8.2659453E-02,   7.9307683E-02
     +,   7.6753139E-02,   7.4776419E-02,   7.3153682E-02
     +,   7.1678445E-02,   7.0176169E-02,   6.8511769E-02
     +,   6.6591524E-02,   6.4360917E-02,   6.1800271E-02
     +,   5.8919180E-02,   5.5750351E-02,   5.2343290E-02
     +,   4.8758890E-02,   4.5064569E-02,   4.1329034E-02
     +,   3.7618607E-02,   3.3994254E-02,   3.0508772E-02
     +,   2.7204867E-02,   2.4114642E-02,   2.1259589E-02
     +,   1.8651061E-02,   1.6291231E-02,   1.4174813E-02
     +,   1.2290893E-02,   1.0624440E-02,   9.1578094E-03
     +,   7.8722443E-03,   6.7490498E-03,   5.7701464E-03
     +,   4.9187243E-03,   4.1795638E-03,   3.5390691E-03
     +,   2.9851897E-03,   2.5073609E-03,   2.0963559E-03
     +,   1.7440664E-03,   1.4433165E-03,   1.1877459E-03
     +,   9.7169768E-04,   7.9009891E-04,   6.3838135E-04
     +,   5.1244395E-04,   4.0862200E-04,   3.2363049E-04
     +,   2.5455581E-04,   1.9883449E-04,   1.5422422E-04
     +,   1.1877972E-04,   9.0832807E-05,   6.8968060E-05
     +,   5.1994299E-05,   3.8918781E-05,   2.8923658E-05
     +,   2.1342397E-05,   1.5636366E-05,   1.1374442E-05
     +,   8.2153419E-06,   5.8916289E-06,   4.1952671E-06
     +,   2.9661808E-06,   2.0823702E-06,   1.4516086E-06
     +,   1.0047801E-06,   6.9058893E-07,   4.7130584E-07
     +,   3.1939456E-07,   2.1492639E-07,   1.4360960E-07
     +,   9.5282871E-08,   6.2775243E-08,   4.1067334E-08
     +,   2.6676657E-08,   1.7206885E-08,   1.1020445E-08
     +,   7.0082922E-09,   4.4253006E-09,   2.7745510E-09
     +,   1.7272280E-09,   1.0675816E-09,   6.5515954E-10
     +,   3.9919795E-10,   2.4149677E-10,   1.4504421E-10
     +,   8.6489468E-11,   5.1200905E-11,   3.0092016E-11
     +,   1.7557405E-11,   1.0169791E-11,   5.8476769E-12
     +,   3.3379770E-12,   1.8914102E-12,   1.0639033E-12
     +,   5.9402662E-13,   3.2923658E-13,   1.8113115E-13
     +,   9.8911120E-14,   5.3613476E-14,   2.8844125E-14
     +,   1.5402999E-14,   8.1638416E-15,   4.2947764E-15
     +,   2.2424158E-15,   1.1620846E-15,   5.9769938E-16
     +,   3.0511863E-16,   1.5458711E-16,   7.7735033E-17
     +,   3.8795538E-17,   1.9217422E-17
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_asha_ttz80_mass = Yx/12.4048357674419
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_asha_ttz85_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  6.1081402E-04,   6.3862425E-04
     +,   6.6643837E-04,   6.9415034E-04,   7.2165055E-04
     +,   7.4882625E-04,   7.7556272E-04,   8.0174429E-04
     +,   8.2725438E-04,   8.5197797E-04,   8.7580096E-04
     +,   8.9861202E-04,   9.2030357E-04,   9.4077253E-04
     +,   9.5992140E-04,   9.7765971E-04,   9.9390396E-04
     +,   1.0085793E-03,   1.0216204E-03,   1.0329715E-03
     +,   1.0425880E-03,   1.0504361E-03,   1.0564942E-03
     +,   1.0607529E-03,   1.0632148E-03,   1.0638958E-03
     +,   1.0628238E-03,   1.0600402E-03,   1.0555977E-03
     +,   1.0495622E-03,   1.0420108E-03,   1.0330322E-03
     +,   1.0227254E-03,   1.0111990E-03,   9.9857093E-04
     +,   9.8496745E-04,   9.7052107E-04,   9.5537171E-04
     +,   9.3966210E-04,   9.2354108E-04,   9.0715842E-04
     +,   8.9066540E-04,   8.7421422E-04,   8.5795496E-04
     +,   8.4203633E-04,   8.2660286E-04,   8.1179489E-04
     +,   7.9774694E-04,   7.8458694E-04,   7.7243551E-04
     +,   7.6140463E-04,   7.5159763E-04,   7.4310851E-04
     +,   7.3602062E-04,   7.3040870E-04,   7.2633621E-04
     +,   7.2385761E-04,   7.2301767E-04,   7.2385295E-04
     +,   7.2639203E-04,   7.3065748E-04,   7.3666719E-04
     +,   7.4443582E-04,   7.5397844E-04,   7.6531229E-04
     +,   7.7845890E-04,   7.9345028E-04,   8.1032922E-04
     +,   8.2915730E-04,   8.5001491E-04,   8.7301084E-04
     +,   8.9828239E-04,   9.2600542E-04,   9.5639360E-04
     +,   9.8970905E-04,   1.0262653E-03,   1.0664281E-03
     +,   1.1106215E-03,   1.1593328E-03,   1.2131135E-03
     +,   1.2725734E-03,   1.3383912E-03,   1.4112974E-03
     +,   1.4920855E-03,   1.5815874E-03,   1.6806845E-03
     +,   1.7902732E-03,   1.9112763E-03,   2.0445997E-03
     +,   2.1911412E-03,   2.3517581E-03,   2.5272381E-03
     +,   2.7182838E-03,   2.9255045E-03,   3.1493851E-03
     +,   3.3902428E-03,   3.6482608E-03,   3.9234138E-03
     +,   4.2155250E-03,   4.5241918E-03,   4.8488663E-03
     +,   5.1887878E-03,   5.5430876E-03,   5.9107346E-03
     +,   6.2906542E-03,   6.6817538E-03,   7.0829540E-03
     +,   7.4932883E-03,   7.9120127E-03,   8.3386628E-03
     +,   8.7731043E-03,   9.2157163E-03,   9.6673574E-03
     +,   1.0129550E-02,   1.0604423E-02,   1.1094877E-02
     +,   1.1604479E-02,   1.2137631E-02,   1.2699451E-02
     +,   1.3295952E-02,   1.3934089E-02,   1.4621911E-02
     +,   1.5368943E-02,   1.6186835E-02,   1.7090324E-02
     +,   1.8098788E-02,   1.9239107E-02,   2.0549508E-02
     +,   2.2085968E-02,   2.3930276E-02,   2.6201040E-02
     +,   2.9064849E-02,   3.2747205E-02,   3.7537221E-02
     +,   4.3785933E-02,   5.1894668E-02,   6.2297892E-02
     +,   7.5450376E-02,   9.1826543E-02,   0.1119237    
     +,   0.1362358    ,   0.1651532    ,   0.1987793    
     +,   0.2367673    ,   0.2784011    ,   0.3231049    
     +,   0.3712385    ,   0.4246784    ,   0.4866566    
     +,   0.5609577    ,   0.6513243    ,   0.7613971    
     +,   0.8942895    ,    1.053039    ,    1.246370    
     +,    1.491958    ,    1.799862    ,    2.160975    
     +,    2.561980    ,    2.937317    ,    3.138062    
     +,    3.132069    ,    3.067615    ,    3.034524    
     +,    2.955415    ,    2.815304    ,    2.668984    
     +,    2.447598    ,    2.150905    ,    1.867434    
     +,    1.614616    ,    1.394619    ,    1.226609    
     +,    1.095112    ,   0.9656599    ,   0.8306246    
     +,   0.7050320    ,   0.6014112    ,   0.5215153    
     +,   0.4604261    ,   0.4116310    ,   0.3700813    
     +,   0.3332724    ,   0.3007910    ,   0.2731652    
     +,   0.2508868    ,   0.2339499    ,   0.2217966    
     +,   0.2134269    ,   0.2075448    ,   0.2027233    
     +,   0.1976000    ,   0.1910750    ,   0.1824615    
     +,   0.1715528    ,   0.1585909    ,   0.1441562    
     +,   0.1290114    ,   0.1139417    ,   9.9626750E-02
     +,   8.6561076E-02,   7.5024895E-02,   6.5098867E-02
     +,   5.6709498E-02,   4.9685076E-02,   4.3807048E-02
     +,   3.8852334E-02,   3.4620281E-02,   3.0945392E-02
     +,   2.7700171E-02,   2.4791999E-02,   2.2156952E-02
     +,   1.9752517E-02,   1.7551027E-02,   1.5534611E-02
     +,   1.3691394E-02,   1.2012524E-02,   1.0490278E-02
     +,   9.1171218E-03,   7.8852801E-03,   6.7862892E-03
     +,   5.8112033E-03,   4.9508130E-03,   4.1957702E-03
     +,   3.5367489E-03,   2.9646787E-03,   2.4708908E-03
     +,   2.0471544E-03,   1.6857040E-03,   1.3793025E-03
     +,   1.1212663E-03,   9.0543745E-04,   7.2616950E-04
     +,   5.7834078E-04,   4.5734970E-04,   3.5907238E-04
     +,   2.7985967E-04,   2.1651700E-04,   1.6626889E-04
     +,   1.2672691E-04,   9.5860632E-05,   7.1963368E-05
     +,   5.3613221E-05,   3.9637405E-05,   2.9080185E-05
     +,   2.1171094E-05,   1.5294725E-05,   1.0964342E-05
     +,   7.7993145E-06,   5.5051560E-06,   3.8558019E-06
     +,   2.6796868E-06,   1.8479120E-06,   1.2644754E-06
     +,   8.5854884E-07,   5.7841424E-07,   3.8666639E-07
     +,   2.5648501E-07,   1.6881455E-07,   1.1024830E-07
     +,   7.1441939E-08,   4.5936559E-08,   2.9307513E-08
     +,   1.8552644E-08,   1.1653336E-08,   7.2627540E-09
     +,   4.4910689E-09,   2.7554798E-09,   1.6774437E-09
     +,   1.0131862E-09,   6.0716887E-10,   3.6100209E-10
     +,   2.1295719E-10,   1.2463600E-10,   7.2368722E-11
     +,   4.1689097E-11,   2.3825161E-11,   1.3508287E-11
     +,   7.5978911E-12,   4.2396013E-12,   2.3467769E-12
     +,   1.2886700E-12,   7.0196100E-13,   3.7931225E-13
     +,   2.0331394E-13,   1.0810265E-13,   5.7014967E-14
     +,   2.9826934E-14,   1.5477777E-14,   7.9664601E-15
     +,   4.0671490E-15,   2.0594901E-15,   1.0343975E-15
     +,   5.1528805E-16,   2.5460116E-16,   1.2476634E-16
     +,   6.0642100E-17,   2.9232768E-17,   1.3976588E-17
     +,   6.6274211E-18,   3.1169024E-18
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_asha_ttz85_mass = Yx/14.3716273953488
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_asha_ttz90_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.1621150E-16,   3.5781276E-16
     +,   5.8982446E-16,   9.6847206E-16,   1.5839900E-15
     +,   2.5806322E-15,   4.1880659E-15,   6.7704923E-15
     +,   1.0903109E-14,   1.7490958E-14,   2.7952038E-14
     +,   4.4499462E-14,   7.0573647E-14,   1.1150155E-13
     +,   1.7549914E-13,   2.7518667E-13,   4.2987483E-13
     +,   6.6899345E-13,   1.0372190E-12,   1.6020974E-12
     +,   2.4653433E-12,   3.7795409E-12,   5.7725682E-12
     +,   8.7837116E-12,   1.3315350E-11,   2.0109385E-11
     +,   3.0255996E-11,   4.5351240E-11,   6.7721648E-11
     +,   1.0074451E-10,   1.4930251E-10,   2.2042386E-10
     +,   3.2418232E-10,   4.7495508E-10,   6.9317296E-10
     +,   1.0077390E-09,   1.4593644E-09,   2.1051176E-09
     +,   3.0247223E-09,   4.3288253E-09,   6.1706094E-09
     +,   8.7608454E-09,   1.2388365E-08,   1.7446974E-08
     +,   2.4471072E-08,   3.4182339E-08,   4.7550380E-08
     +,   6.5871681E-08,   9.0870643E-08,   1.2482955E-07
     +,   1.7075263E-07,   2.3257454E-07,   3.1541879E-07
     +,   4.2593027E-07,   5.7265771E-07,   7.6656977E-07
     +,   1.0216345E-06,   1.3555485E-06,   1.7906046E-06
     +,   2.3547173E-06,   3.0826347E-06,   4.0173672E-06
     +,   5.2117284E-06,   6.7303508E-06,   8.6517412E-06
     +,   1.1070424E-05,   1.4099979E-05,   1.7875253E-05
     +,   2.2556178E-05,   2.8329929E-05,   3.5415473E-05
     +,   4.4065342E-05,   5.4570781E-05,   6.7262525E-05
     +,   8.2515806E-05,   1.0075217E-04,   1.2243970E-04
     +,   1.4809490E-04,   1.7828478E-04,   2.1362536E-04
     +,   2.5477572E-04,   3.0244383E-04,   3.5737193E-04
     +,   4.2034421E-04,   4.9216748E-04,   5.7368138E-04
     +,   6.6573377E-04,   7.6919707E-04,   8.8494015E-04
     +,   1.0138479E-03,   1.1568142E-03,   1.3147334E-03
     +,   1.4885154E-03,   1.6791082E-03,   1.8875058E-03
     +,   2.1147428E-03,   2.3619670E-03,   2.6304040E-03
     +,   2.9214439E-03,   3.2365932E-03,   3.5775627E-03
     +,   3.9461907E-03,   4.3445206E-03,   4.7746734E-03
     +,   5.2388827E-03,   5.7393839E-03,   6.2782676E-03
     +,   6.8573714E-03,   7.4781631E-03,   8.1415251E-03
     +,   8.8474862E-03,   9.5951911E-03,   1.0382523E-02
     +,   1.1206158E-02,   1.2061242E-02,   1.2941573E-02
     +,   1.3839426E-02,   1.4745920E-02,   1.5651038E-02
     +,   1.6544217E-02,   1.7414743E-02,   1.8252304E-02
     +,   1.9047791E-02,   1.9794144E-02,   2.0487169E-02
     +,   2.1126401E-02,   2.1716146E-02,   2.2266151E-02
     +,   2.2792500E-02,   2.3317955E-02,   2.3872295E-02
     +,   2.4491977E-02,   2.5219472E-02,   2.6101682E-02
     +,   2.7187744E-02,   2.8525908E-02,   3.0159375E-02
     +,   3.2121889E-02,   3.4433167E-02,   3.7095029E-02
     +,   4.0089186E-02,   4.3378320E-02,   4.6911657E-02
     +,   5.0634690E-02,   5.4502994E-02,   5.8499947E-02
     +,   6.2654182E-02,   6.7056522E-02,   7.1878903E-02
     +,   7.7402107E-02,   8.4060945E-02,   9.2510752E-02
     +,   0.1036943    ,   0.1188466    ,   0.1393352    
     +,   0.1662349    ,   0.1996506    ,   0.2381386    
     +,   0.2791322    ,   0.3214177    ,   0.3690525    
     +,   0.4333522    ,   0.5308337    ,   0.6794873    
     +,   0.8917682    ,    1.161516    ,    1.459141    
     +,    1.748139    ,    2.023064    ,    2.359226    
     +,    2.830782    ,    3.302437    ,    3.580504    
     +,    3.586763    ,    3.456239    ,    3.352705    
     +,    3.348581    ,    3.282188    ,    2.972458    
     +,    2.488284    ,    2.023871    ,    1.622621    
     +,    1.285406    ,    1.043755    ,   0.8861226    
     +,   0.7729285    ,   0.6799366    ,   0.5966890    
     +,   0.5200096    ,   0.4537717    ,   0.4033760    
     +,   0.3694805    ,   0.3473869    ,   0.3302713    
     +,   0.3123381    ,   0.2903211    ,   0.2635674    
     +,   0.2333630    ,   0.2019963    ,   0.1718799    
     +,   0.1449107    ,   0.1221496    ,   0.1038176    
     +,   8.9508533E-02,   7.8478284E-02,   6.9893382E-02
     +,   6.2995076E-02,   5.7174031E-02,   5.1985081E-02
     +,   4.7132429E-02,   4.2444870E-02,   3.7848607E-02
     +,   3.3340361E-02,   2.8962495E-02,   2.4781186E-02
     +,   2.0868566E-02,   1.7288571E-02,   1.4087878E-02
     +,   1.1291959E-02,   8.9049488E-03,   6.9116685E-03
     +,   5.2822423E-03,   3.9771465E-03,   2.9518653E-03
     +,   2.1609550E-03,   1.5612263E-03,   1.1137718E-03
     +,   7.8496442E-04,   5.4675795E-04,   3.7649384E-04
     +,   2.5634802E-04,   1.7260695E-04,   1.1493075E-04
     +,   7.5669021E-05,   4.9254293E-05,   3.1689251E-05
     +,   2.0146572E-05,   1.2652984E-05,   7.8481035E-06
     +,   4.8059519E-06,   2.9047194E-06,   1.7323073E-06
     +,   1.0191452E-06,   5.9132481E-07,   3.3829050E-07
     +,   1.9078632E-07,   1.0605380E-07,   5.8095857E-08
     +,   3.1356585E-08,   1.6673761E-08,   8.7336476E-09
     +,   4.5056230E-09,   2.2891482E-09,   1.1453029E-09
     +,   5.6421695E-10,   2.7365610E-10,   1.3066986E-10
     +,   6.1424137E-11,   2.8422150E-11,   1.2944775E-11
     +,   5.8028387E-12,   2.5602788E-12,   1.1117412E-12
     +,   4.7507544E-13,   1.9978991E-13,   8.2682213E-14
     +,   3.3670725E-14,   1.3492663E-14,   5.3204854E-15
     +,   2.0644025E-15,   7.8814018E-16,   2.9606631E-16
     +,   1.0943526E-16,   3.9800685E-17,   1.4242015E-17
     +,   5.0144475E-18,   1.7370582E-18,   5.9207158E-19
     +,   1.9854887E-19,   6.5512911E-20,   2.1267335E-20
     +,   6.7930431E-21,   2.1347233E-21,   6.6005292E-22
     +,   2.0079066E-22,   6.0098705E-23,   1.7698229E-23
     +,   5.1276377E-24,   1.4617247E-24,   4.0995363E-25
     +,   1.1312570E-25,   3.0712435E-26,   8.2040409E-27
     +,   2.1560772E-27,   5.5753611E-28,   1.4184609E-28
     +,   3.5510266E-29,   8.7474753E-30,   2.1208079E-30
     +,   5.0618291E-31,   1.1901894E-31
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_asha_ttz90_mass = Yx/14.1822917727273
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_asha_ttz95_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.8777029E-04,   3.1606448E-04
     +,   3.4656399E-04,   3.7937341E-04,   4.1459463E-04
     +,   4.5232530E-04,   4.9265812E-04,   5.3567905E-04
     +,   5.8146595E-04,   6.3008891E-04,   6.8160554E-04
     +,   7.3606207E-04,   7.9349056E-04,   8.5390772E-04
     +,   9.1731368E-04,   9.8369038E-04,   1.0529994E-03
     +,   1.1251817E-03,   1.2001562E-03,   1.2778182E-03
     +,   1.3580390E-03,   1.4406650E-03,   1.5255163E-03
     +,   1.6123925E-03,   1.7010588E-03,   1.7912651E-03
     +,   1.8827311E-03,   1.9751547E-03,   2.0682132E-03
     +,   2.1615622E-03,   2.2548405E-03,   2.3476710E-03
     +,   2.4396633E-03,   2.5304183E-03,   2.6195305E-03
     +,   2.7065903E-03,   2.7911898E-03,   2.8729257E-03
     +,   2.9514078E-03,   3.0262503E-03,   3.0970941E-03
     +,   3.1635968E-03,   3.2254423E-03,   3.2823440E-03
     +,   3.3340489E-03,   3.3803405E-03,   3.4210412E-03
     +,   3.4560163E-03,   3.4851737E-03,   3.5084700E-03
     +,   3.5259060E-03,   3.5375324E-03,   3.5434468E-03
     +,   3.5437930E-03,   3.5387638E-03,   3.5285926E-03
     +,   3.5135576E-03,   3.4939749E-03,   3.4701971E-03
     +,   3.4426104E-03,   3.4116276E-03,   3.3776853E-03
     +,   3.3412422E-03,   3.3027667E-03,   3.2627387E-03
     +,   3.2216443E-03,   3.1799634E-03,   3.1381766E-03
     +,   3.0967477E-03,   3.0561304E-03,   3.0167536E-03
     +,   2.9790287E-03,   2.9433346E-03,   2.9100254E-03
     +,   2.8794187E-03,   2.8517984E-03,   2.8274148E-03
     +,   2.8064807E-03,   2.7891707E-03,   2.7756228E-03
     +,   2.7659419E-03,   2.7601959E-03,   2.7584212E-03
     +,   2.7606245E-03,   2.7667866E-03,   2.7768640E-03
     +,   2.7907933E-03,   2.8084961E-03,   2.8298816E-03
     +,   2.8548522E-03,   2.8833097E-03,   2.9151556E-03
     +,   2.9502960E-03,   2.9886512E-03,   3.0301553E-03
     +,   3.0747557E-03,   3.1224273E-03,   3.1731594E-03
     +,   3.2269764E-03,   3.2839170E-03,   3.3440574E-03
     +,   3.4074890E-03,   3.4743361E-03,   3.5447381E-03
     +,   3.6188599E-03,   3.6968868E-03,   3.7790136E-03
     +,   3.8654490E-03,   3.9564194E-03,   4.0521668E-03
     +,   4.1529378E-03,   4.2590122E-03,   4.3706871E-03
     +,   4.4883131E-03,   4.6122801E-03,   4.7430713E-03
     +,   4.8812530E-03,   5.0275344E-03,   5.1827696E-03
     +,   5.3480202E-03,   5.5245794E-03,   5.7140081E-03
     +,   5.9181838E-03,   6.1393706E-03,   6.3802828E-03
     +,   6.6441521E-03,   6.9349357E-03,   7.2574713E-03
     +,   7.6178852E-03,   8.0239968E-03,   8.4860623E-03
     +,   9.0175504E-03,   9.6362913E-03,   1.0365513E-02
     +,   1.1235066E-02,   1.2282205E-02,   1.3551708E-02
     +,   1.5095058E-02,   1.6968273E-02,   1.9227792E-02
     +,   2.1924384E-02,   2.5095582E-02,   2.8757285E-02
     +,   3.2894935E-02,   3.7455861E-02,   4.2345807E-02
     +,   4.7428999E-02,   5.2533560E-02,   5.7463840E-02
     +,   6.2017921E-02,   6.6008456E-02,   6.9285497E-02
     +,   7.1759202E-02,   7.3419534E-02,   7.4350476E-02
     +,   7.4738868E-02,   7.4876048E-02,   7.5151429E-02
     +,   7.6036334E-02,   7.8056462E-02,   8.1751063E-02
     +,   8.7619506E-02,   9.6059635E-02,   0.1073105    
     +,   0.1214186    ,   0.1382454    ,   0.1575236    
     +,   0.1789690    ,   0.2024736    ,   0.2284560    
     +,   0.2584020    ,   0.2953079    ,   0.3434586    
     +,   0.4078149    ,   0.4949447    ,   0.6160547    
     +,   0.7892497    ,    1.038849    ,    1.378413    
     +,    1.773425    ,    2.145619    ,    2.446713    
     +,    2.779971    ,    3.291518    ,    3.855078    
     +,    4.294168    ,    4.454058    ,    4.315268    
     +,    3.981622    ,    3.377271    ,    2.652666    
     +,    2.021378    ,    1.585530    ,    1.319102    
     +,    1.146188    ,    1.017495    ,   0.9082752    
     +,   0.8022125    ,   0.6890084    ,   0.5709639    
     +,   0.4603265    ,   0.3678894    ,   0.2964299    
     +,   0.2427136    ,   0.2019667    ,   0.1702155    
     +,   0.1446487    ,   0.1233796    ,   0.1051938    
     +,   8.9333855E-02,   7.5332433E-02,   6.2907852E-02
     +,   5.1901300E-02,   4.2229302E-02,   3.3842560E-02
     +,   2.6693199E-02,   2.0714426E-02,   1.5814252E-02
     +,   1.1879420E-02,   8.7836450E-03,   6.3961037E-03
     +,   4.5900648E-03,   3.2491060E-03,   2.2708387E-03
     +,   1.5687182E-03,   1.0722589E-03,   7.2591478E-04
     +,   4.8714894E-04,   3.2423722E-04,   2.1408458E-04
     +,   1.4021281E-04,   9.1051348E-05,   5.8582147E-05
     +,   3.7309455E-05,   2.3496799E-05,   1.4617043E-05
     +,   8.9723781E-06,   5.4291859E-06,   3.2357200E-06
     +,   1.8979492E-06,   1.0949609E-06,   6.2102026E-07
     +,   3.4614212E-07,   1.8955187E-07,   1.0196867E-07
     +,   5.3888328E-08,   2.7984932E-08,   1.4288331E-08
     +,   7.1794704E-09,   3.5566958E-09,   1.7424152E-09
     +,   8.4840068E-10,   4.1397794E-10,   2.0500023E-10
     +,   1.0482494E-10,   5.6469458E-11,   3.2592203E-11
     +,   2.0278742E-11,   1.3502713E-11,   9.4683194E-12
     +,   6.8714587E-12,   5.0895976E-12,   3.8111489E-12
     +,   2.8684804E-12,   2.1629469E-12,   1.6309840E-12
     +,   1.2286983E-12,   9.2431705E-13,   6.9418315E-13
     +,   5.2040929E-13,   3.8940644E-13,   2.9083192E-13
     +,   2.1679902E-13,   1.6130288E-13,   1.1978154E-13
     +,   8.8778865E-14,   6.5673785E-14,   4.8488953E-14
     +,   3.5731834E-14,   2.6280702E-14,   1.9292036E-14
     +,   1.4134756E-14,   1.0336119E-14,   7.5438906E-15
     +,   5.4953024E-15,   3.9953612E-15,   2.8992350E-15
     +,   2.0997551E-15,   1.5178243E-15,   1.0950444E-15
     +,   7.8851382E-16,   5.6668691E-16,   4.0648537E-16
     +,   2.9100704E-16,   2.0793523E-16,   1.4828941E-16
     +,   1.0555010E-16,   7.4983029E-17,   5.3165945E-17
     +,   3.7623678E-17,   2.6573789E-17
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_asha_ttz95_mass = Yx/14.1608997209302
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_asha_hatt100_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.0015955E-03,   1.0256738E-03
     +,   1.0500738E-03,   1.0748045E-03,   1.0998751E-03
     +,   1.1252979E-03,   1.1510857E-03,   1.1772546E-03
     +,   1.2038212E-03,   1.2308061E-03,   1.2582310E-03
     +,   1.2861203E-03,   1.3145012E-03,   1.3434034E-03
     +,   1.3728591E-03,   1.4029047E-03,   1.4335780E-03
     +,   1.4649210E-03,   1.4969787E-03,   1.5297991E-03
     +,   1.5634341E-03,   1.5979382E-03,   1.6333698E-03
     +,   1.6697927E-03,   1.7072702E-03,   1.7458730E-03
     +,   1.7856737E-03,   1.8267479E-03,   1.8691766E-03
     +,   1.9130426E-03,   1.9584338E-03,   2.0054409E-03
     +,   2.0541577E-03,   2.1046828E-03,   2.1571170E-03
     +,   2.2115665E-03,   2.2681390E-03,   2.3269469E-03
     +,   2.3881092E-03,   2.4517423E-03,   2.5179747E-03
     +,   2.5869331E-03,   2.6587523E-03,   2.7335712E-03
     +,   2.8115346E-03,   2.8927920E-03,   2.9775025E-03
     +,   3.0658320E-03,   3.1579526E-03,   3.2540483E-03
     +,   3.3543126E-03,   3.4589516E-03,   3.5681829E-03
     +,   3.6822446E-03,   3.8013814E-03,   3.9258678E-03
     +,   4.0559908E-03,   4.1920645E-03,   4.3344251E-03
     +,   4.4834409E-03,   4.6395068E-03,   4.8030596E-03
     +,   4.9745576E-03,   5.1545193E-03,   5.3435056E-03
     +,   5.5421116E-03,   5.7510086E-03,   5.9709060E-03
     +,   6.2026056E-03,   6.4469464E-03,   6.7048860E-03
     +,   6.9774338E-03,   7.2657266E-03,   7.5709769E-03
     +,   7.8945393E-03,   8.2379095E-03,   8.6027058E-03
     +,   8.9907125E-03,   9.4039245E-03,   9.8445565E-03
     +,   1.0315014E-02,   1.0818022E-02,   1.1356545E-02
     +,   1.1933930E-02,   1.2553805E-02,   1.3220244E-02
     +,   1.3937623E-02,   1.4710793E-02,   1.5544889E-02
     +,   1.6445434E-02,   1.7418250E-02,   1.8469259E-02
     +,   1.9604420E-02,   2.0829622E-02,   2.2150416E-02
     +,   2.3571609E-02,   2.5097307E-02,   2.6730176E-02
     +,   2.8471550E-02,   3.0320685E-02,   3.2274876E-02
     +,   3.4328792E-02,   3.6474776E-02,   3.8702365E-02
     +,   4.0998749E-02,   4.3349084E-02,   4.5736607E-02
     +,   4.8143663E-02,   5.0552737E-02,   5.2947503E-02
     +,   5.5313829E-02,   5.7641957E-02,   5.9927136E-02
     +,   6.2171999E-02,   6.4387053E-02,   6.6592447E-02
     +,   6.8817861E-02,   7.1103185E-02,   7.3497064E-02
     +,   7.6055832E-02,   7.8840725E-02,   8.1914343E-02
     +,   8.5336454E-02,   8.9159407E-02,   9.3423270E-02
     +,   9.8150313E-02,   0.1033425    ,   0.1089776    
     +,   0.1150099    ,   0.1213706    ,   0.1279732    
     +,   0.1347179    ,   0.1415015    ,   0.1482236    
     +,   0.1547975    ,   0.1611562    ,   0.1672572    
     +,   0.1730855    ,   0.1786530    ,   0.1839939    
     +,   0.1891594    ,   0.1942107    ,   0.1992131    
     +,   0.2042314    ,   0.2093276    ,   0.2145642    
     +,   0.2200091    ,   0.2257436    ,   0.2318733    
     +,   0.2385378    ,   0.2459158    ,   0.2542224    
     +,   0.2636975    ,   0.2745793    ,   0.2870640    
     +,   0.3012569    ,   0.3171211    ,   0.3344439    
     +,   0.3528284    ,   0.3717273    ,   0.3905306    
     +,   0.4086899    ,   0.4258606    ,   0.4420208    
     +,   0.4575248    ,   0.4730468    ,   0.4894076    
     +,   0.5073107    ,   0.5270535    ,   0.5483049    
     +,   0.5700383    ,   0.5906765    ,   0.6084137    
     +,   0.6216306    ,   0.6292796    ,   0.6311220    
     +,   0.6277590    ,   0.6205014    ,   0.6111521    
     +,   0.6017976    ,   0.5946697    ,   0.5920504    
     +,   0.5961584    ,   0.6089292    ,   0.6316683    
     +,   0.6646229    ,   0.7066354    ,   0.7551142    
     +,   0.8064710    ,   0.8570523    ,   0.9042362    
     +,   0.9471213    ,   0.9863196    ,    1.022976    
     +,    1.057846    ,    1.091722    ,    1.128099    
     +,    1.178120    ,    1.265667    ,    1.426159    
     +,    1.688696    ,    2.042126    ,    2.430069    
     +,    2.863490    ,    3.594412    ,    5.107344    
     +,    8.026353    ,    12.80083    ,    18.44035    
     +,    21.36173    ,    18.17490    ,    10.86631    
     +,    4.547068    ,    1.375775    ,   0.3237463    
     +,   7.2284497E-02,   2.5966519E-02,   1.6421128E-02
     +,   1.1558693E-02,   7.8818211E-03,   5.2175950E-03
     +,   3.4391501E-03,   2.3889684E-03,   1.8621731E-03
     +,   1.6419742E-03,   1.5655815E-03,   1.5429939E-03
     +,   1.5358495E-03,   1.5311486E-03,   1.5253297E-03
     +,   1.5176089E-03,   1.5078674E-03,   1.4961215E-03
     +,   1.4824154E-03,   1.4668063E-03,   1.4493564E-03
     +,   1.4301359E-03,   1.4092220E-03,   1.3866985E-03
     +,   1.3626529E-03,   1.3371775E-03,   1.3103702E-03
     +,   1.2823339E-03,   1.2531703E-03,   1.2229853E-03
     +,   1.1918878E-03,   1.1599879E-03,   1.1273935E-03
     +,   1.0942129E-03,   1.0605564E-03,   1.0265301E-03
     +,   9.9223736E-04,   9.5778203E-04,   9.2326466E-04
     +,   8.8878046E-04,   8.5442059E-04,   8.2027435E-04
     +,   7.8642659E-04,   7.5295538E-04,   7.1993377E-04
     +,   6.8743160E-04,   6.5551378E-04,   6.2423741E-04
     +,   5.9365429E-04,   5.6381396E-04,   5.3475722E-04
     +,   5.0651975E-04,   4.7913395E-04,   4.5262655E-04
     +,   4.2701807E-04,   4.0232370E-04,   3.7855623E-04
     +,   3.5572343E-04,   3.3382757E-04,   3.1286714E-04
     +,   2.9283890E-04,   2.7373355E-04,   2.5554121E-04
     +,   2.3824668E-04,   2.2183447E-04,   2.0628462E-04
     +,   1.9157707E-04,   1.7768821E-04,   1.6459450E-04
     +,   1.5226954E-04,   1.4068742E-04,   1.2982021E-04
     +,   1.1963947E-04,   1.1011730E-04,   1.0122421E-04
     +,   9.2931929E-05,   8.5211104E-05,   7.8033678E-05
     +,   7.1370952E-05,   6.5195592E-05,   5.9480073E-05
     +,   5.4198219E-05,   4.9323935E-05,   4.4832588E-05
     +,   4.0699746E-05,   3.6902489E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_asha_hatt100_mass = Yx/35.43568476
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_asha_hatt105_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.2548092E-03,   3.3341115E-03
     +,   3.4143217E-03,   3.4954273E-03,   3.5774193E-03
     +,   3.6602933E-03,   3.7440478E-03,   3.8286885E-03
     +,   3.9142244E-03,   4.0006777E-03,   4.0880721E-03
     +,   4.1764430E-03,   4.2658369E-03,   4.3563088E-03
     +,   4.4479263E-03,   4.5407712E-03,   4.6349401E-03
     +,   4.7305431E-03,   4.8277094E-03,   4.9265833E-03
     +,   5.0273286E-03,   5.1301285E-03,   5.2351849E-03
     +,   5.3427271E-03,   5.4529933E-03,   5.5662575E-03
     +,   5.6828032E-03,   5.8029410E-03,   5.9270044E-03
     +,   6.0553383E-03,   6.1883153E-03,   6.3263201E-03
     +,   6.4697531E-03,   6.6190315E-03,   6.7745810E-03
     +,   6.9368347E-03,   7.1062343E-03,   7.2832201E-03
     +,   7.4682464E-03,   7.6617431E-03,   7.8641539E-03
     +,   8.0759106E-03,   8.2974359E-03,   8.5291462E-03
     +,   8.7714493E-03,   9.0247476E-03,   9.2894481E-03
     +,   9.5659578E-03,   9.8546902E-03,   1.0156089E-02
     +,   1.0470632E-02,   1.0798843E-02,   1.1141305E-02
     +,   1.1498719E-02,   1.1871860E-02,   1.2261683E-02
     +,   1.2669305E-02,   1.3096055E-02,   1.3543501E-02
     +,   1.4013520E-02,   1.4508319E-02,   1.5030496E-02
     +,   1.5583050E-02,   1.6169496E-02,   1.6793914E-02
     +,   1.7460858E-02,   1.8175637E-02,   1.8944098E-02
     +,   1.9772906E-02,   2.0669328E-02,   2.1641469E-02
     +,   2.2698019E-02,   2.3848511E-02,   2.5102938E-02
     +,   2.6471999E-02,   2.7966782E-02,   2.9598655E-02
     +,   3.1379025E-02,   3.3319354E-02,   3.5430789E-02
     +,   3.7723571E-02,   4.0207330E-02,   4.2890057E-02
     +,   4.5778375E-02,   4.8876446E-02,   5.2186228E-02
     +,   5.5706378E-02,   5.9432399E-02,   6.3355543E-02
     +,   6.7463130E-02,   7.1737893E-02,   7.6157533E-02
     +,   8.0694869E-02,   8.5318260E-02,   8.9991979E-02
     +,   9.4676398E-02,   9.9330217E-02,   0.1039108    
     +,   0.1083777    ,   0.1126935    ,   0.1168281    
     +,   0.1207605    ,   0.1244830    ,   0.1280028    
     +,   0.1313462    ,   0.1345591    ,   0.1377081    
     +,   0.1408800    ,   0.1441794    ,   0.1477242    
     +,   0.1516389    ,   0.1560475    ,   0.1610621    
     +,   0.1667734    ,   0.1732389    ,   0.1804742    
     +,   0.1884450    ,   0.1970649    ,   0.2061942    
     +,   0.2156499    ,   0.2252160    ,   0.2346616    
     +,   0.2437613    ,   0.2523191    ,   0.2601894    
     +,   0.2672939    ,   0.2736363    ,   0.2793033    
     +,   0.2844640    ,   0.2893534    ,   0.2942541    
     +,   0.2994677    ,   0.3052839    ,   0.3119470    
     +,   0.3196264    ,   0.3283956    ,   0.3382237    
     +,   0.3489893    ,   0.3605176    ,   0.3726367    
     +,   0.3852410    ,   0.3983540    ,   0.4121562    
     +,   0.4269749    ,   0.4432179    ,   0.4612914    
     +,   0.4815165    ,   0.5040893    ,   0.5291077    
     +,   0.5566261    ,   0.5866946    ,   0.6192994    
     +,   0.6542071    ,   0.6907555    ,   0.7277399    
     +,   0.7634984    ,   0.7962953    ,   0.8248606    
     +,   0.8488976    ,   0.8693333    ,   0.8882304    
     +,   0.9083647    ,   0.9326349    ,   0.9634408    
     +,    1.002181    ,    1.049009    ,    1.102904    
     +,    1.161911    ,    1.223285    ,    1.283384    
     +,    1.337697    ,    1.381545    ,    1.411491    
     +,    1.426620    ,    1.428720    ,    1.421370    
     +,    1.408890    ,    1.395885    ,    1.387033    
     +,    1.386267    ,    1.395466    ,    1.413657    
     +,    1.437252    ,    1.460831    ,    1.477913    
     +,    1.482016    ,    1.468637    ,    1.437638    
     +,    1.394365    ,    1.348091    ,    1.308108    
     +,    1.279773    ,    1.262851    ,    1.253006    
     +,    1.244992    ,    1.235108    ,    1.221471    
     +,    1.202646    ,    1.176323    ,    1.139306    
     +,    1.088695    ,    1.023241    ,   0.9440065    
     +,   0.8540870    ,   0.7577972    ,   0.6597401    
     +,   0.5641200    ,   0.4743361    ,   0.3927845    
     +,   0.3208337    ,   0.2589308    ,   0.2067953    
     +,   0.1636471    ,   0.1284315    ,   0.1000062    
     +,   7.7266507E-02,   5.9211921E-02,   4.4974227E-02
     +,   3.3823092E-02,   2.5155742E-02,   1.8477870E-02
     +,   1.3386410E-02,   9.5525021E-03,   6.7067491E-03
     +,   4.6282355E-03,   3.1367424E-03,   2.0866548E-03
     +,   1.3619608E-03,   8.7200629E-04,   5.4762390E-04
     +,   3.3735906E-04,   2.0390989E-04,   1.2095716E-04
     +,   7.0438131E-05,   4.0284329E-05,   2.2634085E-05
     +,   1.2497440E-05,   6.7833116E-06,   3.6202453E-06
     +,   1.9001877E-06,   9.8112343E-07,   4.9857209E-07
     +,   2.4959058E-07,   1.2333392E-07,   6.0406528E-08
     +,   2.9570314E-08,   1.4697600E-08,   7.6188016E-09
     +,   4.2754493E-09,   2.6904787E-09,   1.9194459E-09
     +,   1.5203508E-09,   1.2904373E-09,   1.1384406E-09
     +,   1.0239524E-09,   9.2928648E-10,   8.4668395E-10
     +,   7.7264517E-10,   7.0545170E-10,   6.4414629E-10
     +,   5.8809813E-10,   5.3681914E-10,   4.8989451E-10
     +,   4.4695658E-10,   4.0767623E-10,   3.7174899E-10
     +,   3.3889516E-10,   3.0885997E-10,   2.8141009E-10
     +,   2.5632838E-10,   2.3341620E-10,   2.1249183E-10
     +,   1.9338893E-10,   1.7595300E-10,   1.6004263E-10
     +,   1.4552928E-10,   1.3229323E-10,   1.2022632E-10
     +,   1.0922778E-10,   9.9206532E-11,   9.0077987E-11
     +,   8.1765449E-11,   7.4197821E-11,   6.7310824E-11
     +,   6.1044669E-11,   5.5345534E-11,   5.0163471E-11
     +,   4.5452763E-11,   4.1172274E-11,   3.7283645E-11
     +,   3.3752133E-11,   3.0545927E-11,   2.7635939E-11
     +,   2.4995580E-11,   2.2600739E-11,   2.0429131E-11
     +,   1.8460622E-11,   1.6676681E-11,   1.5060651E-11
     +,   1.3597038E-11,   1.2271961E-11
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_asha_hatt105_mass = Yx/19.3176196956522
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_asha_hatt107_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.3979230E-03,   3.5156778E-03
     +,   3.6371637E-03,   3.7625057E-03,   3.8918331E-03
     +,   4.0252800E-03,   4.1629840E-03,   4.3050875E-03
     +,   4.4517340E-03,   4.6030749E-03,   4.7592581E-03
     +,   4.9204361E-03,   5.0867596E-03,   5.2583804E-03
     +,   5.4354505E-03,   5.6181187E-03,   5.8065294E-03
     +,   6.0008229E-03,   6.2011383E-03,   6.4076059E-03
     +,   6.6203470E-03,   6.8394789E-03,   7.0651011E-03
     +,   7.2973240E-03,   7.5362166E-03,   7.7818711E-03
     +,   8.0343420E-03,   8.2936874E-03,   8.5599506E-03
     +,   8.8331625E-03,   9.1133509E-03,   9.4005307E-03
     +,   9.6947076E-03,   9.9958880E-03,   1.0304072E-02
     +,   1.0619259E-02,   1.0941447E-02,   1.1270639E-02
     +,   1.1606855E-02,   1.1950092E-02,   1.2300400E-02
     +,   1.2657819E-02,   1.3022400E-02,   1.3394224E-02
     +,   1.3773390E-02,   1.4160020E-02,   1.4554252E-02
     +,   1.4956265E-02,   1.5366257E-02,   1.5784459E-02
     +,   1.6211135E-02,   1.6646601E-02,   1.7091202E-02
     +,   1.7545363E-02,   1.8009538E-02,   1.8484304E-02
     +,   1.8970300E-02,   1.9468293E-02,   1.9979188E-02
     +,   2.0504061E-02,   2.1044180E-02,   2.1601068E-02
     +,   2.2176482E-02,   2.2772532E-02,   2.3391716E-02
     +,   2.4036838E-02,   2.4711264E-02,   2.5418762E-02
     +,   2.6163705E-02,   2.6950920E-02,   2.7785946E-02
     +,   2.8674750E-02,   2.9624036E-02,   3.0640922E-02
     +,   3.1733174E-02,   3.2908991E-02,   3.4176897E-02
     +,   3.5545733E-02,   3.7024539E-02,   3.8622461E-02
     +,   4.0348385E-02,   4.2211138E-02,   4.4218916E-02
     +,   4.6379633E-02,   4.8700225E-02,   5.1187102E-02
     +,   5.3845439E-02,   5.6679811E-02,   5.9693418E-02
     +,   6.2888578E-02,   6.6266723E-02,   6.9827907E-02
     +,   7.3571093E-02,   7.7494301E-02,   8.1594259E-02
     +,   8.5865922E-02,   9.0302780E-02,   9.4896019E-02
     +,   9.9634960E-02,   0.1045057    ,   0.1094925    
     +,   0.1145764    ,   0.1197371    ,   0.1249527    
     +,   0.1302019    ,   0.1354652    ,   0.1407263    
     +,   0.1459748    ,   0.1512075    ,   0.1564300    
     +,   0.1616562    ,   0.1669088    ,   0.1722175    
     +,   0.1776171    ,   0.1831439    ,   0.1888331    
     +,   0.1947142    ,   0.2008085    ,   0.2071235    
     +,   0.2136525    ,   0.2203694    ,   0.2272292    
     +,   0.2341706    ,   0.2411220    ,   0.2480160    
     +,   0.2548068    ,   0.2614997    ,   0.2681771    
     +,   0.2750274    ,   0.2823578    ,   0.2905928    
     +,   0.3002401    ,   0.3118327    ,   0.3258404    
     +,   0.3425729    ,   0.3620831    ,   0.3840933    
     +,   0.4079751    ,   0.4327818    ,   0.4573473    
     +,   0.4804334    ,   0.5009080    ,   0.5179205    
     +,   0.5310275    ,   0.5402588    ,   0.5460973    
     +,   0.5493992    ,   0.5512574    ,   0.5528713    
     +,   0.5554314    ,   0.5600354    ,   0.5676385    
     +,   0.5790055    ,   0.5946575    ,   0.6147768    
     +,   0.6390955    ,   0.6667854    ,   0.6964329    
     +,   0.7261569    ,   0.7539375    ,   0.7781252    
     +,   0.7980161    ,   0.8142987    ,   0.8292158    
     +,   0.8463417    ,   0.8699788    ,   0.9042503    
     +,   0.9519793    ,    1.013529    ,    1.085915    
     +,    1.162742    ,    1.235371    ,    1.295206    
     +,    1.336218    ,    1.356538    ,    1.358423    
     +,    1.346907    ,    1.328049    ,    1.307459    
     +,    1.289328    ,    1.275848    ,    1.267235    
     +,    1.262453    ,    1.260324    ,    1.260297    
     +,    1.262580    ,    1.267883    ,    1.277193    
     +,    1.291373    ,    1.310159    ,    1.330838    
     +,    1.347739    ,    1.353630    ,    1.342735    
     +,    1.313526    ,    1.269342    ,    1.216418    
     +,    1.160593    ,    1.104735    ,    1.048188    
     +,   0.9880902    ,   0.9215008    ,   0.8470916    
     +,   0.7657629    ,   0.6801938    ,   0.5938222    
     +,   0.5098866    ,   0.4308631    ,   0.3583454    
     +,   0.2932084    ,   0.2358511    ,   0.1863680    
     +,   0.1446135    ,   0.1102113    ,   8.2566880E-02
     +,   6.0906272E-02,   4.4342108E-02,   3.1956211E-02
     +,   2.2877144E-02,   1.6334413E-02,   1.1684068E-02
     +,   8.4142741E-03,   6.1338567E-03,   4.5526656E-03
     +,   3.4603830E-03,   2.7072041E-03,   2.1877212E-03
     +,   1.8283395E-03,   1.5779949E-03,   1.4014676E-03
     +,   1.2745843E-03,   1.1808133E-03,   1.1088959E-03
     +,   1.0512032E-03,   1.0026031E-03,   9.5966348E-04
     +,   9.2012301E-04,   8.8252645E-04,   8.4596698E-04
     +,   8.0991117E-04,   7.7407656E-04,   7.3835131E-04
     +,   7.0273125E-04,   6.6727668E-04,   6.3208689E-04
     +,   5.9728348E-04,   5.6299451E-04,   5.2934512E-04
     +,   4.9645419E-04,   4.6443386E-04,   4.3338165E-04
     +,   4.0338284E-04,   3.7451126E-04,   3.4682784E-04
     +,   3.2037837E-04,   2.9519678E-04,   2.7130658E-04
     +,   2.4871973E-04,   2.2743664E-04,   2.0744816E-04
     +,   1.8873776E-04,   1.7128114E-04,   1.5504601E-04
     +,   1.3999427E-04,   1.2608450E-04,   1.1326956E-04
     +,   1.0149939E-04,   9.0722257E-05,   8.0884623E-05
     +,   7.1931368E-05,   6.3807121E-05,   5.6457302E-05
     +,   4.9827955E-05,   4.3865821E-05,   3.8519247E-05
     +,   3.3738932E-05,   2.9476998E-05,   2.5688410E-05
     +,   2.2330032E-05,   1.9361709E-05,   1.6745433E-05
     +,   1.4446120E-05,   1.2430947E-05,   1.0669882E-05
     +,   9.1350948E-06,   7.8013327E-06,   6.6454600E-06
     +,   5.6464987E-06,   4.7855956E-06,   4.0456707E-06
     +,   3.4115185E-06,   2.8694781E-06,   2.4074709E-06
     +,   2.0147295E-06,   1.6818043E-06,   1.4003352E-06
     +,   1.1630316E-06,   9.6349424E-07,   7.9617740E-07
     +,   6.5624835E-07,   5.3954818E-07
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_asha_hatt107_mass = Yx/18.2433972
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_asha_hatt110_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.2655301E-03,   3.3568460E-03
     +,   3.4505131E-03,   3.5465781E-03,   3.6450871E-03
     +,   3.7460905E-03,   3.8496405E-03,   3.9557922E-03
     +,   4.0646009E-03,   4.1761296E-03,   4.2904406E-03
     +,   4.4076000E-03,   4.5276769E-03,   4.6507409E-03
     +,   4.7768690E-03,   4.9061370E-03,   5.0386256E-03
     +,   5.1744170E-03,   5.3135972E-03,   5.4562534E-03
     +,   5.6024771E-03,   5.7523604E-03,   5.9059975E-03
     +,   6.0634934E-03,   6.2249401E-03,   6.3904491E-03
     +,   6.5601282E-03,   6.7340871E-03,   6.9124452E-03
     +,   7.0953211E-03,   7.2828471E-03,   7.4751605E-03
     +,   7.6724011E-03,   7.8747272E-03,   8.0823041E-03
     +,   8.2953079E-03,   8.5139312E-03,   8.7383781E-03
     +,   8.9688879E-03,   9.2056841E-03,   9.4490452E-03
     +,   9.6992515E-03,   9.9566113E-03,   1.0221454E-02
     +,   1.0494131E-02,   1.0775018E-02,   1.1064505E-02
     +,   1.1363014E-02,   1.1670968E-02,   1.1988808E-02
     +,   1.2316988E-02,   1.2655956E-02,   1.3006139E-02
     +,   1.3367987E-02,   1.3741877E-02,   1.4128183E-02
     +,   1.4527218E-02,   1.4939230E-02,   1.5364386E-02
     +,   1.5802765E-02,   1.6254339E-02,   1.6718961E-02
     +,   1.7196322E-02,   1.7685993E-02,   1.8187391E-02
     +,   1.8699721E-02,   1.9222070E-02,   1.9753296E-02
     +,   2.0292168E-02,   2.0837236E-02,   2.1386994E-02
     +,   2.1939781E-02,   2.2493955E-02,   2.3047823E-02
     +,   2.3599813E-02,   2.4148533E-02,   2.4692798E-02
     +,   2.5231780E-02,   2.5765181E-02,   2.6293302E-02
     +,   2.6817150E-02,   2.7338648E-02,   2.7860703E-02
     +,   2.8387403E-02,   2.8924055E-02,   2.9477386E-02
     +,   3.0055482E-02,   3.0667977E-02,   3.1325918E-02
     +,   3.2041788E-02,   3.2829463E-02,   3.3703938E-02
     +,   3.4681190E-02,   3.5778057E-02,   3.7011832E-02
     +,   3.8399987E-02,   3.9959978E-02,   4.1708782E-02
     +,   4.3663006E-02,   4.5838233E-02,   4.8249371E-02
     +,   5.0910223E-02,   5.3833913E-02,   5.7032418E-02
     +,   6.0517270E-02,   6.4299241E-02,   6.8388037E-02
     +,   7.2792262E-02,   7.7519156E-02,   8.2573868E-02
     +,   8.7957978E-02,   9.3670383E-02,   9.9705055E-02
     +,   0.1060532    ,   0.1127026    ,   0.1196418    
     +,   0.1268613    ,   0.1343601    ,   0.1421478    
     +,   0.1502504    ,   0.1587104    ,   0.1675855    
     +,   0.1769418    ,   0.1868424    ,   0.1973312    
     +,   0.2084106    ,   0.2200240    ,   0.2320361    
     +,   0.2442268    ,   0.2562934    ,   0.2678750    
     +,   0.2785859    ,   0.2880722    ,   0.2960683    
     +,   0.3024549    ,   0.3073019    ,   0.3108832    
     +,   0.3136629    ,   0.3162461    ,   0.3193045    
     +,   0.3234848    ,   0.3293223    ,   0.3371700    
     +,   0.3471557    ,   0.3591716    ,   0.3728995    
     +,   0.3878587    ,   0.4034695    ,   0.4191182    
     +,   0.4342194    ,   0.4482605    ,   0.4608364    
     +,   0.4716878    ,   0.4807468    ,   0.4881967    
     +,   0.4945309    ,   0.5005898    ,   0.5075420    
     +,   0.5167897    ,   0.5298112    ,   0.5479541    
     +,   0.5722361    ,   0.6031737    ,   0.6406745    
     +,   0.6840029    ,   0.7318664    ,   0.7826757    
     +,   0.8349838    ,   0.8879322    ,   0.9413833    
     +,   0.9955595    ,    1.050341    ,    1.104703    
     +,    1.156707    ,    1.203979    ,    1.244141    
     +,    1.274853    ,    1.293693    ,    1.298516    
     +,    1.288441    ,    1.264917    ,    1.232002    
     +,    1.195451    ,    1.160924    ,    1.132241    
     +,    1.110401    ,    1.093788    ,    1.079298    
     +,    1.063709    ,    1.044654    ,    1.020966    
     +,   0.9926246    ,   0.9605176    ,   0.9260597    
     +,   0.8906347    ,   0.8550046    ,   0.8189989    
     +,   0.7816483    ,   0.7417024    ,   0.6982314    
     +,   0.6510088    ,   0.6005474    ,   0.5478733    
     +,   0.4942318    ,   0.4408588    ,   0.3888559    
     +,   0.3391586    ,   0.2925281    ,   0.2495345    
     +,   0.2105436    ,   0.1757269    ,   0.1450897    
     +,   0.1185065    ,   9.5756121E-02,   7.6553196E-02
     +,   6.0569756E-02,   4.7450282E-02,   3.6827013E-02
     +,   2.8337011E-02,   2.1637054E-02,   1.6412864E-02
     +,   1.2386793E-02,   9.3201706E-03,   7.0118960E-03
     +,   5.2953186E-03,   4.0344913E-03,   3.1199832E-03
     +,   2.4647536E-03,   2.0005323E-03,   1.6746499E-03
     +,   1.4471628E-03,   1.2883076E-03,   1.1763244E-03
     +,   1.0956385E-03,   1.0353350E-03,   9.8792056E-04
     +,   9.4837381E-04,   9.1341714E-04,   8.8097010E-04
     +,   8.4975874E-04,   8.1904116E-04,   7.8842102E-04
     +,   7.5771817E-04,   7.2688237E-04,   6.9594214E-04
     +,   6.6497177E-04,   6.3406926E-04,   6.0334016E-04
     +,   5.7289249E-04,   5.4283487E-04,   5.1326689E-04
     +,   4.8428174E-04,   4.5596584E-04,   4.2839738E-04
     +,   4.0164319E-04,   3.7576139E-04,   3.5080273E-04
     +,   3.2680886E-04,   3.0381113E-04,   2.8183282E-04
     +,   2.6089058E-04,   2.4099353E-04,   2.2214238E-04
     +,   2.0433150E-04,   1.8755099E-04,   1.7178392E-04
     +,   1.5700859E-04,   1.4320010E-04,   1.3032975E-04
     +,   1.1836488E-04,   1.0727038E-04,   9.7009819E-05
     +,   8.7545144E-05,   7.8836529E-05,   7.0843569E-05
     +,   6.3526357E-05,   5.6844030E-05,   5.0757062E-05
     +,   4.5225708E-05,   4.0211951E-05,   3.5678131E-05
     +,   3.1588559E-05,   2.7908392E-05,   2.4604842E-05
     +,   2.1646296E-05,   1.9003226E-05,   1.6647544E-05
     +,   1.4552928E-05,   1.2694961E-05,   1.1050689E-05
     +,   9.5990490E-06,   8.3204031E-06,   7.1968361E-06
     +,   6.2117756E-06,   5.3502122E-06,   4.5983584E-06
     +,   3.9438100E-06,   3.3752503E-06,   2.8825532E-06
     +,   2.4565493E-06,   2.0890798E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_asha_hatt110_mass = Yx/14.343530372093
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_asha_hatt115_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.2449186E-03,   2.3158798E-03
     +,   2.3907898E-03,   2.4698135E-03,   2.5531116E-03
     +,   2.6408408E-03,   2.7331486E-03,   2.8301782E-03
     +,   2.9320596E-03,   3.0389160E-03,   3.1508545E-03
     +,   3.2679688E-03,   3.3903369E-03,   3.5180212E-03
     +,   3.6510648E-03,   3.7894920E-03,   3.9333077E-03
     +,   4.0824981E-03,   4.2370283E-03,   4.3968465E-03
     +,   4.5618806E-03,   4.7320491E-03,   4.9072476E-03
     +,   5.0873798E-03,   5.2723233E-03,   5.4619787E-03
     +,   5.6562414E-03,   5.8550285E-03,   6.0582818E-03
     +,   6.2659793E-03,   6.4781443E-03,   6.6948659E-03
     +,   6.9162981E-03,   7.1426905E-03,   7.3743924E-03
     +,   7.6118773E-03,   7.8557413E-03,   8.1067421E-03
     +,   8.3658053E-03,   8.6340150E-03,   8.9126667E-03
     +,   9.2032487E-03,   9.5074493E-03,   9.8271752E-03
     +,   1.0164537E-02,   1.0521849E-02,   1.0901611E-02
     +,   1.1306503E-02,   1.1739353E-02,   1.2203104E-02
     +,   1.2700778E-02,   1.3235436E-02,   1.3810109E-02
     +,   1.4427795E-02,   1.5091276E-02,   1.5803201E-02
     +,   1.6565887E-02,   1.7381307E-02,   1.8250996E-02
     +,   1.9175982E-02,   2.0156702E-02,   2.1192953E-02
     +,   2.2283778E-02,   2.3427505E-02,   2.4621705E-02
     +,   2.5863009E-02,   2.7147362E-02,   2.8469758E-02
     +,   2.9824568E-02,   3.1205282E-02,   3.2604892E-02
     +,   3.4015667E-02,   3.5429608E-02,   3.6838222E-02
     +,   3.8232967E-02,   3.9605308E-02,   4.0946763E-02
     +,   4.2249151E-02,   4.3504879E-02,   4.4707026E-02
     +,   4.5849301E-02,   4.6926588E-02,   4.7934651E-02
     +,   4.8870556E-02,   4.9732532E-02,   5.0520204E-02
     +,   5.1234383E-02,   5.1877342E-02,   5.2452456E-02
     +,   5.2964389E-02,   5.3418871E-02,   5.3822529E-02
     +,   5.4182768E-02,   5.4507710E-02,   5.4805860E-02
     +,   5.5085924E-02,   5.5356719E-02,   5.5626985E-02
     +,   5.5905275E-02,   5.6199878E-02,   5.6518696E-02
     +,   5.6869432E-02,   5.7259738E-02,   5.7697218E-02
     +,   5.8189992E-02,   5.8746893E-02,   5.9377912E-02
     +,   6.0094707E-02,   6.0911171E-02,   6.1843783E-02
     +,   6.2912002E-02,   6.4138837E-02,   6.5550677E-02
     +,   6.7177877E-02,   6.9054030E-02,   7.1216412E-02
     +,   7.3704541E-02,   7.6560549E-02,   7.9826728E-02
     +,   8.3545461E-02,   8.7756872E-02,   9.2496477E-02
     +,   9.7792923E-02,   0.1036656    ,   0.1101217    
     +,   0.1171521    ,   0.1247311    ,   0.1328122    
     +,   0.1413292    ,   0.1501953    ,   0.1593072    
     +,   0.1685484    ,   0.1777972    ,   0.1869338    
     +,   0.1958517    ,   0.2044672    ,   0.2127258    
     +,   0.2206081    ,   0.2281280    ,   0.2353256    
     +,   0.2422503    ,   0.2489411    ,   0.2554042    
     +,   0.2615913    ,   0.2673869    ,   0.2726100    
     +,   0.2770336    ,   0.2804232    ,   0.2825954    
     +,   0.2834887    ,   0.2832321    ,   0.2822010    
     +,   0.2810365    ,   0.2806179    ,   0.2819753    
     +,   0.2861512    ,   0.2940315    ,   0.3061820    
     +,   0.3227298    ,   0.3433221    ,   0.3671816    
     +,   0.3932375    ,   0.4203089    ,   0.4472910    
     +,   0.4733137    ,   0.4978359    ,   0.5206758    
     +,   0.5419943    ,   0.5622345    ,   0.5820250    
     +,   0.6020463    ,   0.6228696    ,   0.6447893    
     +,   0.6677081    ,   0.6911175    ,   0.7142071    
     +,   0.7360367    ,   0.7556849    ,   0.7723297    
     +,   0.7852666    ,   0.7939382    ,   0.7980382    
     +,   0.7976601    ,   0.7933812    ,   0.7861614    
     +,   0.7770591    ,   0.7668859    ,   0.7559802    
     +,   0.7442195    ,   0.7312464    ,   0.7167259    
     +,   0.7005041    ,   0.6826131    ,   0.6631742    
     +,   0.6423265    ,   0.6202214    ,   0.5970568    
     +,   0.5730833    ,   0.5485401    ,   0.5235534    
     +,   0.4980528    ,   0.4717668    ,   0.4443111    
     +,   0.4153402    ,   0.3847009    ,   0.3525162    
     +,   0.3191982    ,   0.2853830    ,   0.2518239    
     +,   0.2192780    ,   0.1884215    ,   0.1597984    
     +,   0.1337958    ,   0.1106411    ,   9.0416595E-02
     +,   7.3078766E-02,   5.8479313E-02,   4.6390455E-02
     +,   3.6533192E-02,   2.8604731E-02,   2.2299921E-02
     +,   1.7331069E-02,   1.3440493E-02,   1.0406562E-02
     +,   8.0450987E-03,   6.2076212E-03,   4.7771274E-03
     +,   3.6627334E-03,   2.7944683E-03,   2.1186862E-03
     +,   1.5941553E-03,   1.1888830E-03,   8.7775954E-04
     +,   6.4088049E-04,   4.6232983E-04,   3.2927087E-04
     +,   2.3135982E-04,   1.6029587E-04,   1.0946301E-04
     +,   7.3648080E-05,   4.8806181E-05,   3.1850534E-05
     +,   2.0465446E-05,   1.2945829E-05,   8.0612544E-06
     +,   4.9411710E-06,   2.9814232E-06,   1.7709481E-06
     +,   1.0357001E-06,   5.9654741E-07,   3.3856776E-07
     +,   1.8949694E-07,   1.0475489E-07,   5.7346504E-08
     +,   3.1228751E-08,   1.7046441E-08,   9.4433528E-09
     +,   5.4071769E-09,   3.2740817E-09,   2.1414965E-09
     +,   1.5282373E-09,   1.1820244E-09,   9.7272135E-10
     +,   8.3420998E-10,   7.3332374E-10,   6.5354666E-10
     +,   5.8665783E-10,   5.2850901E-10,   4.7692233E-10
     +,   4.3066486E-10,   3.8896450E-10,   3.5128073E-10
     +,   3.1719127E-10,   2.8634142E-10,   2.5842242E-10
     +,   2.3316091E-10,   2.1030744E-10,   1.8963933E-10
     +,   1.7095113E-10,   1.5405963E-10,   1.3879528E-10
     +,   1.2500623E-10,   1.1255277E-10,   1.0130961E-10
     +,   9.1161328E-11,   8.2004924E-11,   7.3745524E-11
     +,   6.6297370E-11,   5.9583137E-11,   5.3532085E-11
     +,   4.8080658E-11,   4.3170700E-11,   3.8750097E-11
     +,   3.4771058E-11,   3.1190796E-11,   2.7970190E-11
     +,   2.5074194E-11,   2.2470805E-11,   2.0131348E-11
     +,   1.8029555E-11,   1.6142048E-11
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_asha_hatt115_mass = Yx/9.98951970731707
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_asha_hatt120_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  5.9284517E-03,   6.1117741E-03
     +,   6.2954272E-03,   6.4791506E-03,   6.6626845E-03
     +,   6.8457695E-03,   7.0281574E-03,   7.2096065E-03
     +,   7.3898835E-03,   7.5687775E-03,   7.7460888E-03
     +,   7.9216361E-03,   8.0952682E-03,   8.2668532E-03
     +,   8.4362971E-03,   8.6035309E-03,   8.7685278E-03
     +,   8.9313043E-03,   9.0919146E-03,   9.2504621E-03
     +,   9.4071003E-03,   9.5620351E-03,   9.7155301E-03
     +,   9.8679131E-03,   1.0019556E-02,   1.0170909E-02
     +,   1.0322480E-02,   1.0474842E-02,   1.0628632E-02
     +,   1.0784553E-02,   1.0943367E-02,   1.1105897E-02
     +,   1.1273035E-02,   1.1445704E-02,   1.1624895E-02
     +,   1.1811625E-02,   1.2006954E-02,   1.2211955E-02
     +,   1.2427734E-02,   1.2655366E-02,   1.2895947E-02
     +,   1.3150522E-02,   1.3420101E-02,   1.3705636E-02
     +,   1.4008004E-02,   1.4327985E-02,   1.4666242E-02
     +,   1.5023327E-02,   1.5399623E-02,   1.5795374E-02
     +,   1.6210642E-02,   1.6645307E-02,   1.7099058E-02
     +,   1.7571416E-02,   1.8061666E-02,   1.8568963E-02
     +,   1.9092260E-02,   1.9630374E-02,   2.0181999E-02
     +,   2.0745752E-02,   2.1320187E-02,   2.1903893E-02
     +,   2.2495475E-02,   2.3093719E-02,   2.3697570E-02
     +,   2.4306243E-02,   2.4919331E-02,   2.5536764E-02
     +,   2.6159074E-02,   2.6787236E-02,   2.7422959E-02
     +,   2.8068509E-02,   2.8726948E-02,   2.9401939E-02
     +,   3.0097922E-02,   3.0819943E-02,   3.1573601E-02
     +,   3.2364927E-02,   3.3200346E-02,   3.4086380E-02
     +,   3.5029460E-02,   3.6035847E-02,   3.7111122E-02
     +,   3.8260244E-02,   3.9487042E-02,   4.0794246E-02
     +,   4.2183001E-02,   4.3653000E-02,   4.5202039E-02
     +,   4.6826344E-02,   4.8520334E-02,   5.0276697E-02
     +,   5.2086540E-02,   5.3939782E-02,   5.5825353E-02
     +,   5.7731137E-02,   5.9644964E-02,   6.1554402E-02
     +,   6.3447587E-02,   6.5313146E-02,   6.7141071E-02
     +,   6.8922438E-02,   7.0650227E-02,   7.2319083E-02
     +,   7.3925793E-02,   7.5469293E-02,   7.6950423E-02
     +,   7.8372166E-02,   7.9739459E-02,   8.1059046E-02
     +,   8.2339138E-02,   8.3589338E-02,   8.4820233E-02
     +,   8.6043246E-02,   8.7270305E-02,   8.8513494E-02
     +,   8.9784846E-02,   9.1096207E-02,   9.2458844E-02
     +,   9.3883358E-02,   9.5379606E-02,   9.6956417E-02
     +,   9.8621801E-02,   0.1003831    ,   0.1022469    
     +,   0.1042197    ,   0.1063080    ,   0.1085188    
     +,   0.1108606    ,   0.1133430    ,   0.1159782    
     +,   0.1187801    ,   0.1217656    ,   0.1249531    
     +,   0.1283634    ,   0.1320181    ,   0.1359391    
     +,   0.1401471    ,   0.1446614    ,   0.1494984    
     +,   0.1546696    ,   0.1601809    ,   0.1660309    
     +,   0.1722084    ,   0.1786888    ,   0.1854334    
     +,   0.1923863    ,   0.1994750    ,   0.2066135    
     +,   0.2137113    ,   0.2206843    ,   0.2274692    
     +,   0.2340382    ,   0.2404101    ,   0.2466516    
     +,   0.2528676    ,   0.2591823    ,   0.2657153    
     +,   0.2725557    ,   0.2797495    ,   0.2873033    
     +,   0.2952027    ,   0.3034445    ,   0.3120699    
     +,   0.3211836    ,   0.3309556    ,   0.3415921    
     +,   0.3532947    ,   0.3662122    ,   0.3804083    
     +,   0.3958522    ,   0.4124442    ,   0.4300540    
     +,   0.4485546    ,   0.4678240    ,   0.4877087    
     +,   0.5079510    ,   0.5281215    ,   0.5476028    
     +,   0.5656503    ,   0.5815336    ,   0.5947139    
     +,   0.6049920    ,   0.6125690    ,   0.6179788    
     +,   0.6219114    ,   0.6249868    ,   0.6275376    
     +,   0.6294805    ,   0.6303051    ,   0.6291858    
     +,   0.6251770    ,   0.6174404    ,   0.6054359    
     +,   0.5890284    ,   0.5684938    ,   0.5444326    
     +,   0.5176246    ,   0.4888801    ,   0.4589245    
     +,   0.4283420    ,   0.3975673    ,   0.3669113    
     +,   0.3366042    ,   0.3068334    ,   0.2777650    
     +,   0.2495612    ,   0.2223905    ,   0.1964319    
     +,   0.1718700    ,   0.1488901    ,   0.1276660    
     +,   0.1083396    ,   9.1003262E-02,   7.5689636E-02
     +,   6.2368628E-02,   5.0950706E-02,   4.1297570E-02
     +,   3.3238456E-02,   2.6586184E-02,   2.1149777E-02
     +,   1.6746152E-02,   1.3207441E-02,   1.0384517E-02
     +,   8.1480565E-03,   6.3883192E-03,   5.0135134E-03
     +,   3.9475141E-03,   3.1276036E-03,   2.5024661E-03
     +,   2.0303382E-03,   1.6773558E-03,   1.4162038E-03
     +,   1.2250454E-03,   1.0865870E-03,   9.8725047E-04
     +,   9.1652357E-04,   8.6637773E-04,   8.3076867E-04
     +,   8.0521480E-04,   7.8644819E-04,   7.7212916E-04
     +,   7.6060795E-04,   7.5074285E-04,   7.4175937E-04
     +,   7.3314266E-04,   7.2455977E-04,   7.1580021E-04
     +,   7.0673769E-04,   6.9730147E-04,   6.8745663E-04
     +,   6.7719165E-04,   6.6651031E-04,   6.5542659E-04
     +,   6.4395886E-04,   6.3212984E-04,   6.1996520E-04
     +,   6.0749211E-04,   5.9473753E-04,   5.8172946E-04
     +,   5.6849653E-04,   5.5506773E-04,   5.4147077E-04
     +,   5.2773353E-04,   5.1388465E-04,   4.9995107E-04
     +,   4.8595938E-04,   4.7193622E-04,   4.5790771E-04
     +,   4.4389840E-04,   4.2993194E-04,   4.1603189E-04
     +,   4.0222134E-04,   3.8852089E-04,   3.7495064E-04
     +,   3.6153078E-04,   3.4827864E-04,   3.3521224E-04
     +,   3.2234672E-04,   3.0969782E-04,   2.9727840E-04
     +,   2.8510188E-04,   2.7317891E-04,   2.6152047E-04
     +,   2.5013511E-04,   2.3903146E-04,   2.2821614E-04
     +,   2.1769479E-04,   2.0747283E-04,   1.9755351E-04
     +,   1.8794027E-04,   1.7863439E-04,   1.6963757E-04
     +,   1.6094930E-04,   1.5256956E-04,   1.4449634E-04
     +,   1.3672801E-04,   1.2926120E-04,   1.2209297E-04
     +,   1.1521880E-04,   1.0863446E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_asha_hatt120_mass = Yx/8.01924165
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_asha_hatt60_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.3812162E-02,   1.5053711E-02
     +,   1.6457669E-02,   1.8050149E-02,   1.9860582E-02
     +,   2.1921886E-02,   2.4270924E-02,   2.6949411E-02
     +,   3.0005632E-02,   3.3497859E-02,   3.7499424E-02
     +,   4.2107120E-02,   4.7453184E-02,   5.3721607E-02
     +,   6.1168101E-02,   7.0142657E-02,   8.1110686E-02
     +,   9.4667763E-02,   0.1115396    ,   0.1325583    
     +,   0.1586040    ,   0.1905057    ,   0.2289196    
     +,   0.2742492    ,   0.3267085    ,   0.3866878    
     +,   0.4553900    ,   0.5355142    ,   0.6314636    
     +,   0.7486575    ,   0.8921003    ,    1.065097    
     +,    1.269102    ,    1.504805    ,    1.773366    
     +,    2.076707    ,    2.417214    ,    2.795779    
     +,    3.202487    ,    3.600806    ,    3.929640    
     +,    4.140091    ,    4.227136    ,    4.208793    
     +,    4.089306    ,    3.866011    ,    3.556102    
     +,    3.194279    ,    2.815795    ,    2.454168    
     +,    2.141297    ,    1.895581    ,    1.713639    
     +,    1.578282    ,    1.470937    ,    1.376450    
     +,    1.283588    ,    1.186463    ,    1.085500    
     +,   0.9854750    ,   0.8917035    ,   0.8071188    
     +,   0.7317545    ,   0.6640524    ,   0.6024689    
     +,   0.5463001    ,   0.4955728    ,   0.4505511    
     +,   0.4112742    ,   0.3773907    ,   0.3482081    
     +,   0.3228651    ,   0.3004906    ,   0.2803292    
     +,   0.2618056    ,   0.2445540    ,   0.2284086    
     +,   0.2133650    ,   0.1995183    ,   0.1870029    
     +,   0.1759362    ,   0.1663801    ,   0.1583286    
     +,   0.1517084    ,   0.1463960    ,   0.1422363    
     +,   0.1390625    ,   0.1367101    ,   0.1350270    
     +,   0.1338776    ,   0.1331444    ,   0.1327257    
     +,   0.1325335    ,   0.1324894    ,   0.1325222    
     +,   0.1325645    ,   0.1325520    ,   0.1324221    
     +,   0.1321146    ,   0.1315726    ,   0.1307447    
     +,   0.1295870    ,   0.1280650    ,   0.1261567    
     +,   0.1238533    ,   0.1211601    ,   0.1180968    
     +,   0.1146969    ,   0.1110050    ,   0.1070753    
     +,   0.1029684    ,   9.8747939E-02,   9.4478115E-02
     +,   9.0219773E-02,   8.6029001E-02,   8.1954174E-02
     +,   7.8035608E-02,   7.4303828E-02,   7.0780672E-02
     +,   6.7478769E-02,   6.4402930E-02,   6.1551467E-02
     +,   5.8917385E-02,   5.6489702E-02,   5.4254882E-02
     +,   5.2198492E-02,   5.0305519E-02,   4.8562001E-02
     +,   4.6954900E-02,   4.5473080E-02,   4.4106971E-02
     +,   4.2848974E-02,   4.1693117E-02,   4.0634912E-02
     +,   3.9670985E-02,   3.8798772E-02,   3.8016301E-02
     +,   3.7321813E-02,   3.6713444E-02,   3.6189020E-02
     +,   3.5745945E-02,   3.5381004E-02,   3.5090268E-02
     +,   3.4869090E-02,   3.4712110E-02,   3.4613237E-02
     +,   3.4565818E-02,   3.4562629E-02,   3.4596037E-02
     +,   3.4658186E-02,   3.4740958E-02,   3.4836296E-02
     +,   3.4936212E-02,   3.5032995E-02,   3.5119276E-02
     +,   3.5188168E-02,   3.5233364E-02,   3.5249192E-02
     +,   3.5230707E-02,   3.5173744E-02,   3.5074919E-02
     +,   3.4931675E-02,   3.4742255E-02,   3.4505703E-02
     +,   3.4221813E-02,   3.3891104E-02,   3.3514753E-02
     +,   3.3094574E-02,   3.2632839E-02,   3.2132287E-02
     +,   3.1596072E-02,   3.1027593E-02,   3.0430486E-02
     +,   2.9808450E-02,   2.9165346E-02,   2.8504949E-02
     +,   2.7830955E-02,   2.7146975E-02,   2.6456458E-02
     +,   2.5762580E-02,   2.5068281E-02,   2.4376251E-02
     +,   2.3688925E-02,   2.3008386E-02,   2.2336414E-02
     +,   2.1674559E-02,   2.1024078E-02,   2.0385927E-02
     +,   1.9760810E-02,   1.9149272E-02,   1.8551601E-02
     +,   1.7967889E-02,   1.7398143E-02,   1.6842213E-02
     +,   1.6299833E-02,   1.5770644E-02,   1.5254281E-02
     +,   1.4750329E-02,   1.4258321E-02,   1.3777802E-02
     +,   1.3308338E-02,   1.2849532E-02,   1.2400982E-02
     +,   1.1962321E-02,   1.1533266E-02,   1.1113540E-02
     +,   1.0702901E-02,   1.0301189E-02,   9.9082775E-03
     +,   9.5240539E-03,   9.1484422E-03,   8.7814229E-03
     +,   8.4230015E-03,   8.0731828E-03,   7.7319876E-03
     +,   7.3994664E-03,   7.0756823E-03,   6.7606755E-03
     +,   6.4544883E-03,   6.1571836E-03,   5.8687888E-03
     +,   5.5893189E-03,   5.3187977E-03,   5.0572292E-03
     +,   4.8045842E-03,   4.5608194E-03,   4.3258881E-03
     +,   4.0997248E-03,   3.8822333E-03,   3.6732985E-03
     +,   3.4728050E-03,   3.2806208E-03,   3.0965882E-03
     +,   2.9205356E-03,   2.7522990E-03,   2.5916840E-03
     +,   2.4384912E-03,   2.2925232E-03,   2.1535757E-03
     +,   2.0214303E-03,   1.8958657E-03,   1.7766659E-03
     +,   1.6636155E-03,   1.5564887E-03,   1.4550617E-03
     +,   1.3591197E-03,   1.2684482E-03,   1.1828300E-03
     +,   1.1020523E-03,   1.0259131E-03,   9.5420709E-04
     +,   8.8673382E-04,   8.2330243E-04,   7.6372636E-04
     +,   7.0782035E-04,   6.5540493E-04,   6.0630922E-04
     +,   5.6036783E-04,   5.1741768E-04,   4.7730125E-04
     +,   4.3986971E-04,   4.0497869E-04,   3.7248756E-04
     +,   3.4226105E-04,   3.1417183E-04,   2.8809538E-04
     +,   2.6391205E-04,   2.4150917E-04,   2.2077869E-04
     +,   2.0161606E-04,   1.8392173E-04,   1.6760184E-04
     +,   1.5256708E-04,   1.3873146E-04,   1.2601350E-04
     +,   1.1433718E-04,   1.0362893E-04,   9.3820556E-05
     +,   8.4846433E-05,   7.6645869E-05,   6.9160553E-05
     +,   6.2336767E-05,   5.6123074E-05,   5.0472114E-05
     +,   4.5338787E-05,   4.0681673E-05,   3.6461548E-05
     +,   3.2641979E-05,   2.9189381E-05,   2.6072123E-05
     +,   2.3261258E-05,   2.0729642E-05,   1.8452458E-05
     +,   1.6406537E-05,   1.4570775E-05,   1.2925506E-05
     +,   1.1452880E-05,   1.0136313E-05,   8.9608002E-06
     +,   7.9124566E-06,   6.9787357E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_asha_hatt60_mass = Yx/21.7602283043478
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_asha_hatt65_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.3405495E-03,   3.4269660E-03
     +,   3.5176987E-03,   3.6139088E-03,   3.7169647E-03
     +,   3.8284620E-03,   3.9502545E-03,   4.0844833E-03
     +,   4.2336043E-03,   4.4004349E-03,   4.5881784E-03
     +,   4.8004650E-03,   5.0413930E-03,   5.3155618E-03
     +,   5.6281015E-03,   5.9846919E-03,   6.3915816E-03
     +,   6.8555782E-03,   7.3840413E-03,   7.9848366E-03
     +,   8.6663133E-03,   9.4372509E-03,   1.0306824E-02
     +,   1.1284725E-02,   1.2381146E-02,   1.3607440E-02
     +,   1.4976801E-02,   1.6506070E-02,   1.8218687E-02
     +,   2.0149635E-02,   2.2353167E-02,   2.4914021E-02
     +,   2.7962951E-02,   3.1696476E-02,   3.6400426E-02
     +,   4.2475391E-02,   5.0460804E-02,   6.1052665E-02
     +,   7.5110659E-02,   9.3644634E-02,   0.1177856    
     +,   0.1487290    ,   0.1876577    ,   0.2356359    
     +,   0.2934738    ,   0.3615754    ,   0.4398616    
     +,   0.5279688    ,   0.6259535    ,   0.7353145    
     +,   0.8594812    ,    1.003300    ,    1.173121    
     +,    1.379237    ,    1.636705    ,    1.956707    
     +,    2.331885    ,    2.737839    ,    3.158903    
     +,    3.601644    ,    4.068896    ,    4.529892    
     +,    4.916012    ,    5.142205    ,    5.145129    
     +,    4.915007    ,    4.535888    ,    4.180903    
     +,    3.965932    ,    3.823491    ,    3.614125    
     +,    3.299501    ,    2.925610    ,    2.535343    
     +,    2.165030    ,    1.856930    ,    1.632722    
     +,    1.474743    ,    1.344079    ,    1.211854    
     +,    1.073921    ,   0.9435109    ,   0.8353207    
     +,   0.7550546    ,   0.6989310    ,   0.6587936    
     +,   0.6270461    ,   0.5986629    ,   0.5709235    
     +,   0.5424252    ,   0.5124074    ,   0.4805539    
     +,   0.4470331    ,   0.4125311    ,   0.3781644    
     +,   0.3452907    ,   0.3152539    ,   0.2891705    
     +,   0.2677571    ,   0.2512616    ,   0.2394676    
     +,   0.2317778    ,   0.2273324    ,   0.2251479    
     +,   0.2242432    ,   0.2237379    ,   0.2229175    
     +,   0.2212631    ,   0.2184546    ,   0.2143515    
     +,   0.2089620    ,   0.2024044    ,   0.1948716    
     +,   0.1865936    ,   0.1778108    ,   0.1687504    
     +,   0.1596147    ,   0.1505712    ,   0.1417540    
     +,   0.1332642    ,   0.1251762    ,   0.1175431    
     +,   0.1104024    ,   0.1037787    ,   9.7688615E-02
     +,   9.2141919E-02,   8.7141924E-02,   8.2686834E-02
     +,   7.8768663E-02,   7.5374275E-02,   7.2484247E-02
     +,   7.0074260E-02,   6.8114214E-02,   6.6569492E-02
     +,   6.5400913E-02,   6.4565927E-02,   6.4019114E-02
     +,   6.3713215E-02,   6.3599929E-02,   6.3631311E-02
     +,   6.3760638E-02,   6.3943535E-02,   6.4139158E-02
     +,   6.4310841E-02,   6.4426973E-02,   6.4461745E-02
     +,   6.4395092E-02,   6.4213052E-02,   6.3907519E-02
     +,   6.3475877E-02,   6.2920421E-02,   6.2247552E-02
     +,   6.1467208E-02,   6.0591560E-02,   5.9634451E-02
     +,   5.8610350E-02,   5.7533793E-02,   5.6418277E-02
     +,   5.5276170E-02,   5.4118078E-02,   5.2952658E-02
     +,   5.1786471E-02,   5.0624177E-02,   4.9468607E-02
     +,   4.8320893E-02,   4.7180880E-02,   4.6047509E-02
     +,   4.4919118E-02,   4.3793637E-02,   4.2669065E-02
     +,   4.1543625E-02,   4.0416040E-02,   3.9285511E-02
     +,   3.8151875E-02,   3.7015695E-02,   3.5878122E-02
     +,   3.4740794E-02,   3.3605926E-02,   3.2476086E-02
     +,   3.1353988E-02,   3.0242482E-02,   2.9144455E-02
     +,   2.8062759E-02,   2.6999976E-02,   2.5958462E-02
     +,   2.4940353E-02,   2.3947511E-02,   2.2981396E-02
     +,   2.2043165E-02,   2.1133779E-02,   2.0253828E-02
     +,   1.9403640E-02,   1.8583402E-02,   1.7793085E-02
     +,   1.7032446E-02,   1.6301101E-02,   1.5598603E-02
     +,   1.4924383E-02,   1.4277755E-02,   1.3657968E-02
     +,   1.3064245E-02,   1.2495760E-02,   1.1951596E-02
     +,   1.1430821E-02,   1.0932524E-02,   1.0455704E-02
     +,   9.9993804E-03,   9.5625706E-03,   9.1443127E-03
     +,   8.7436121E-03,   8.3595058E-03,   7.9910792E-03
     +,   7.6374486E-03,   7.2977464E-03,   6.9711576E-03
     +,   6.6569354E-03,   6.3543925E-03,   6.0628671E-03
     +,   5.7817698E-03,   5.5105919E-03,   5.2488586E-03
     +,   4.9961451E-03,   4.7521037E-03,   4.5164339E-03
     +,   4.2888597E-03,   4.0691523E-03,   3.8571283E-03
     +,   3.6526369E-03,   3.4555336E-03,   3.2656975E-03
     +,   3.0830344E-03,   2.9074578E-03,   2.7388751E-03
     +,   2.5771987E-03,   2.4223521E-03,   2.2742408E-03
     +,   2.1327650E-03,   1.9978243E-03,   1.8693112E-03
     +,   1.7470968E-03,   1.6310452E-03,   1.5210153E-03
     +,   1.4168571E-03,   1.3184032E-03,   1.2254779E-03
     +,   1.1379048E-03,   1.0555001E-03,   9.7806833E-04
     +,   9.0541109E-04,   8.3733327E-04,   7.7363168E-04
     +,   7.1410235E-04,   6.5854646E-04,   6.0676591E-04
     +,   5.5856205E-04,   5.1373994E-04,   4.7211215E-04
     +,   4.3349562E-04,   3.9771025E-04,   3.6458243E-04
     +,   3.3394728E-04,   3.0564604E-04,   2.7952524E-04
     +,   2.5543853E-04,   2.3324911E-04,   2.1282487E-04
     +,   1.9404090E-04,   1.7678060E-04,   1.6093391E-04
     +,   1.4639634E-04,   1.3306993E-04,   1.2086374E-04
     +,   1.0969272E-04,   9.9476609E-05,   9.0140638E-05
     +,   8.1616148E-05,   7.3838106E-05,   6.6747074E-05
     +,   6.0287006E-05,   5.4406817E-05,   4.9058312E-05
     +,   4.4197674E-05,   3.9783736E-05,   3.5779023E-05
     +,   3.2148408E-05,   2.8860004E-05,   2.5884052E-05
     +,   2.3193155E-05,   2.0762371E-05,   1.8568433E-05
     +,   1.6590247E-05,   1.4808159E-05,   1.3204403E-05
     +,   1.1762444E-05,   1.0467342E-05,   9.3052377E-06
     +,   8.2636088E-06,   7.3308811E-06,   6.4965966E-06
     +,   5.7511156E-06,   5.0857443E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_asha_hatt65_mass = Yx/25.887602125
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_asha_hatt70_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.5819812E-03,   1.7008178E-03
     +,   1.8252071E-03,   1.9550931E-03,   2.0903877E-03
     +,   2.2309709E-03,   2.3766898E-03,   2.5273592E-03
     +,   2.6827573E-03,   2.8426412E-03,   3.0067270E-03
     +,   3.1747078E-03,   3.3462502E-03,   3.5209986E-03
     +,   3.6985804E-03,   3.8786109E-03,   4.0606991E-03
     +,   4.2444570E-03,   4.4295071E-03,   4.6154954E-03
     +,   4.8021036E-03,   4.9890671E-03,   5.1761870E-03
     +,   5.3633722E-03,   5.5506327E-03,   5.7381527E-03
     +,   5.9262924E-03,   6.1156591E-03,   6.3071358E-03
     +,   6.5019629E-03,   6.7017884E-03,   6.9087562E-03
     +,   7.1255895E-03,   7.3556788E-03,   7.6032020E-03
     +,   7.8732250E-03,   8.1718387E-03,   8.5062878E-03
     +,   8.8851573E-03,   9.3184914E-03,   9.8180864E-03
     +,   1.0397723E-02,   1.1073515E-02,   1.1864420E-02
     +,   1.2792850E-02,   1.3885503E-02,   1.5174459E-02
     +,   1.6698530E-02,   1.8504944E-02,   2.0651393E-02
     +,   2.3208516E-02,   2.6262943E-02,   2.9920928E-02
     +,   3.4313280E-02,   3.9600071E-02,   4.5978006E-02
     +,   5.3686529E-02,   6.3014999E-02,   7.4309535E-02
     +,   8.7980010E-02,   0.1045105    ,   0.1244795    
     +,   0.1485964    ,   0.1777587    ,   0.2131018    
     +,   0.2559840    ,   0.3078794    ,   0.3702282    
     +,   0.4445920    ,   0.5334409    ,   0.6417251    
     +,   0.7787958    ,   0.9599858    ,    1.205108    
     +,    1.528407    ,    1.921964    ,    2.359450    
     +,    2.841329    ,    3.423236    ,    4.137051    
     +,    4.882794    ,    5.501243    ,    5.939032    
     +,    6.205740    ,    6.283715    ,    6.235013    
     +,    6.168896    ,    6.015835    ,    5.678856    
     +,    5.240656    ,    4.778636    ,    4.282126    
     +,    3.761173    ,    3.272714    ,    2.861993    
     +,    2.520207    ,    2.211933    ,    1.925114    
     +,    1.674031    ,    1.467900    ,    1.297527    
     +,    1.149202    ,    1.018271    ,   0.9080565    
     +,   0.8214192    ,   0.7558506    ,   0.7046406    
     +,   0.6606015    ,   0.6187262    ,   0.5768083    
     +,   0.5347760    ,   0.4937125    ,   0.4550931    
     +,   0.4202883    ,   0.3903181    ,   0.3657246    
     +,   0.3465477    ,   0.3323514    ,   0.3223169    
     +,   0.3153734    ,   0.3103571    ,   0.3061618    
     +,   0.3018569    ,   0.2967631    ,   0.2904721    
     +,   0.2828283    ,   0.2738788    ,   0.2638149    
     +,   0.2529061    ,   0.2414528    ,   0.2297429    
     +,   0.2180320    ,   0.2065302    ,   0.1954070    
     +,   0.1847958    ,   0.1748054    ,   0.1655295    
     +,   0.1570517    ,   0.1494456    ,   0.1427728    
     +,   0.1370776    ,   0.1323803    ,   0.1286714    
     +,   0.1259089    ,   0.1240183    ,   0.1228946    
     +,   0.1224079    ,   0.1224103    ,   0.1227437    
     +,   0.1232479    ,   0.1237682    ,   0.1241620    
     +,   0.1243042    ,   0.1240914    ,   0.1234443    
     +,   0.1223092    ,   0.1206583    ,   0.1184882    
     +,   0.1158184    ,   0.1126884    ,   0.1091540    
     +,   0.1052837    ,   0.1011546    ,   9.6848302E-02
     +,   9.2446655E-02,   8.8028014E-02,   8.3664805E-02
     +,   7.9420500E-02,   7.5347587E-02,   7.1486808E-02
     +,   6.7866884E-02,   6.4504668E-02,   6.1405711E-02
     +,   5.8565877E-02,   5.5973150E-02,   5.3608865E-02
     +,   5.1449973E-02,   4.9470868E-02,   4.7644876E-02
     +,   4.5945689E-02,   4.4348497E-02,   4.2831115E-02
     +,   4.1374389E-02,   3.9962508E-02,   3.8583104E-02
     +,   3.7227333E-02,   3.5889443E-02,   3.4566384E-02
     +,   3.3257443E-02,   3.1963840E-02,   3.0688118E-02
     +,   2.9433666E-02,   2.8204475E-02,   2.7004715E-02
     +,   2.5838261E-02,   2.4708623E-02,   2.3618804E-02
     +,   2.2571126E-02,   2.1567091E-02,   2.0607477E-02
     +,   1.9692371E-02,   1.8821202E-02,   1.7992765E-02
     +,   1.7205374E-02,   1.6457014E-02,   1.5745342E-02
     +,   1.5067819E-02,   1.4421878E-02,   1.3804952E-02
     +,   1.3214501E-02,   1.2648118E-02,   1.2103613E-02
     +,   1.1579000E-02,   1.1072486E-02,   1.0582517E-02
     +,   1.0107810E-02,   9.6473033E-03,   9.2001250E-03
     +,   8.7656016E-03,   8.3432691E-03,   7.9327766E-03
     +,   7.5339028E-03,   7.1465522E-03,   6.7707072E-03
     +,   6.4063901E-03,   6.0536545E-03,   5.7126093E-03
     +,   5.3833635E-03,   5.0660009E-03,   4.7605899E-03
     +,   4.4671982E-03,   4.1858605E-03,   3.9165625E-03
     +,   3.6592518E-03,   3.4138637E-03,   3.1802708E-03
     +,   2.9583129E-03,   2.7478056E-03,   2.5485321E-03
     +,   2.3602322E-03,   2.1826192E-03,   2.0153937E-03
     +,   1.8582359E-03,   1.7107968E-03,   1.5727152E-03
     +,   1.4436278E-03,   1.3231620E-03,   1.2109339E-03
     +,   1.1065557E-03,   1.0096511E-03,   9.1983576E-04
     +,   8.3673024E-04,   7.5996661E-04,   6.8918359E-04
     +,   6.2402396E-04,   5.6414108E-04,   5.0920330E-04
     +,   4.5889002E-04,   4.1288935E-04,   3.7090277E-04
     +,   3.3264738E-04,   2.9785340E-04,   2.6626172E-04
     +,   2.3762707E-04,   2.1172018E-04,   1.8832211E-04
     +,   1.6722687E-04,   1.4824275E-04,   1.3118991E-04
     +,   1.1589919E-04,   1.0221322E-04,   8.9986541E-05
     +,   7.9084151E-05,   6.9380359E-05,   6.0759328E-05
     +,   5.3115149E-05,   4.6349534E-05,   4.0373281E-05
     +,   3.5104022E-05,   3.0467356E-05,   2.6394910E-05
     +,   2.2825185E-05,   1.9701998E-05,   1.6974982E-05
     +,   1.4598383E-05,   1.2531364E-05,   1.0737066E-05
     +,   9.1825250E-06,   7.8384555E-06,   6.6785774E-06
     +,   5.6797039E-06,   4.8211332E-06,   4.0846712E-06
     +,   3.4541720E-06,   2.9154983E-06,   2.4561641E-06
     +,   2.0652917E-06,   1.7333214E-06,   1.4519578E-06
     +,   1.2139486E-06,   1.0130296E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_asha_hatt70_mass = Yx/30.8700274285714
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_asha_hatt75_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  9.8782312E-04,   1.0531032E-03
     +,   1.1217240E-03,   1.1937533E-03,   1.2692494E-03
     +,   1.3482602E-03,   1.4308222E-03,   1.5169592E-03
     +,   1.6066806E-03,   1.6999845E-03,   1.7968507E-03
     +,   1.8972426E-03,   2.0011074E-03,   2.1083746E-03
     +,   2.2189547E-03,   2.3327400E-03,   2.4496040E-03
     +,   2.5694016E-03,   2.6919693E-03,   2.8171253E-03
     +,   2.9446722E-03,   3.0743966E-03,   3.2060689E-03
     +,   3.3394587E-03,   3.4743091E-03,   3.6103746E-03
     +,   3.7474001E-03,   3.8851360E-03,   4.0233387E-03
     +,   4.1617821E-03,   4.3002586E-03,   4.4385889E-03
     +,   4.5766300E-03,   4.7142846E-03,   4.8515066E-03
     +,   4.9883155E-03,   5.1248041E-03,   5.2611497E-03
     +,   5.3976323E-03,   5.5346303E-03,   5.6726532E-03
     +,   5.8123446E-03,   5.9545008E-03,   6.1000888E-03
     +,   6.2502697E-03,   6.4064218E-03,   6.5701734E-03
     +,   6.7434455E-03,   6.9284984E-03,   7.1279998E-03
     +,   7.3451013E-03,   7.5835539E-03,   7.8478279E-03
     +,   8.1433021E-03,   8.4764259E-03,   8.8550439E-03
     +,   9.2886258E-03,   9.7886799E-03,   1.0369139E-02
     +,   1.1046845E-02,   1.1842035E-02,   1.2778884E-02
     +,   1.3885967E-02,   1.5196876E-02,   1.6750634E-02
     +,   1.8591879E-02,   2.0771550E-02,   2.3346528E-02
     +,   2.6380386E-02,   2.9942654E-02,   3.4109566E-02
     +,   3.8963076E-02,   4.4592097E-02,   5.1092252E-02
     +,   5.8570147E-02,   6.7150429E-02,   7.6990627E-02
     +,   8.8308074E-02,   0.1014206    ,   0.1167944    
     +,   0.1350853    ,   0.1571548    ,   0.1840202    
     +,   0.2167450    ,   0.2562713    ,   0.3032918    
     +,   0.3582046    ,   0.4212153    ,   0.4924651    
     +,   0.5721720    ,   0.6608372    ,   0.7599419    
     +,   0.8739243    ,    1.014597    ,    1.209255    
     +,    1.511422    ,    2.001465    ,    2.742409    
     +,    3.684030    ,    4.648614    ,    5.506980    
     +,    6.253500    ,    6.896261    ,    7.540978    
     +,    8.329573    ,    8.977189    ,    9.150277    
     +,    8.966114    ,    8.234396    ,    7.212310    
     +,    6.484094    ,    5.801210    ,    5.022616    
     +,    4.363259    ,    3.906197    ,    3.556093    
     +,    3.220989    ,    2.875513    ,    2.517623    
     +,    2.152599    ,    1.812977    ,    1.537596    
     +,    1.334810    ,    1.185624    ,    1.069441    
     +,   0.9765454    ,   0.9041386    ,   0.8494307    
     +,   0.8072837    ,   0.7716238    ,   0.7373123    
     +,   0.7010982    ,   0.6617230    ,   0.6196529    
     +,   0.5764912    ,   0.5342239    ,   0.4944898    
     +,   0.4581482    ,   0.4252686    ,   0.3954561    
     +,   0.3682644    ,   0.3434739    ,   0.3211489    
     +,   0.3015147    ,   0.2847666    ,   0.2709120    
     +,   0.2597125    ,   0.2507141    ,   0.2433364    
     +,   0.2369768    ,   0.2311040    ,   0.2253179    
     +,   0.2193734    ,   0.2131730    ,   0.2067347    
     +,   0.2001476    ,   0.1935255    ,   0.1869662    
     +,   0.1805262    ,   0.1742111    ,   0.1679783    
     +,   0.1617521    ,   0.1554448    ,   0.1489760    
     +,   0.1422886    ,   0.1353596    ,   0.1282041    
     +,   0.1208717    ,   0.1134398    ,   0.1060038    
     +,   9.8667406E-02,   9.1533266E-02,   8.4693871E-02
     +,   7.8227125E-02,   7.2193459E-02,   6.6633448E-02
     +,   6.1568908E-02,   5.7004943E-02,   5.2931990E-02
     +,   4.9328431E-02,   4.6163745E-02,   4.3401416E-02
     +,   4.1001070E-02,   3.8920406E-02,   3.7117030E-02
     +,   3.5549879E-02,   3.4180012E-02,   3.2971252E-02
     +,   3.1890724E-02,   3.0909237E-02,   3.0001177E-02
     +,   2.9144622E-02,   2.8321313E-02,   2.7516380E-02
     +,   2.6718056E-02,   2.5917539E-02,   2.5108637E-02
     +,   2.4287490E-02,   2.3452103E-02,   2.2602195E-02
     +,   2.1738814E-02,   2.0864118E-02,   1.9980971E-02
     +,   1.9092791E-02,   1.8203437E-02,   1.7316837E-02
     +,   1.6436948E-02,   1.5567663E-02,   1.4712692E-02
     +,   1.3875398E-02,   1.3058831E-02,   1.2265722E-02
     +,   1.1498433E-02,   1.0758884E-02,   1.0048613E-02
     +,   9.3688350E-03,   8.7204156E-03,   8.1038363E-03
     +,   7.5192936E-03,   6.9667613E-03,   6.4459094E-03
     +,   5.9562009E-03,   5.4969508E-03,   5.0673112E-03
     +,   4.6662777E-03,   4.2927479E-03,   3.9455704E-03
     +,   3.6235263E-03,   3.3253429E-03,   3.0497289E-03
     +,   2.7954069E-03,   2.5611043E-03,   2.3455529E-03
     +,   2.1475151E-03,   1.9658096E-03,   1.7992766E-03
     +,   1.6468063E-03,   1.5073488E-03,   1.3799060E-03
     +,   1.2635250E-03,   1.1573102E-03,   1.0604269E-03
     +,   9.7209384E-04,   8.9157687E-04,   8.1819453E-04
     +,   7.5131998E-04,   6.9037336E-04,   6.3481601E-04
     +,   5.8415375E-04,   5.3793762E-04,   4.9575244E-04
     +,   4.5721955E-04,   4.2199646E-04,   3.8977174E-04
     +,   3.6026063E-04,   3.3320545E-04,   3.0837543E-04
     +,   2.8556157E-04,   2.6457460E-04,   2.4524401E-04
     +,   2.2741799E-04,   2.1095999E-04,   1.9574646E-04
     +,   1.8166676E-04,   1.6862294E-04,   1.5652594E-04
     +,   1.4529594E-04,   1.3486207E-04,   1.2516066E-04
     +,   1.1613378E-04,   1.0772934E-04,   9.9900972E-05
     +,   9.2606635E-05,   8.5807769E-05,   7.9469442E-05
     +,   7.3560397E-05,   6.8051289E-05,   6.2915969E-05
     +,   5.8129728E-05,   5.3670385E-05,   4.9516842E-05
     +,   4.5650038E-05,   4.2051779E-05,   3.8705526E-05
     +,   3.5595374E-05,   3.2706808E-05,   3.0025927E-05
     +,   2.7539638E-05,   2.5235851E-05,   2.3102886E-05
     +,   2.1129945E-05,   1.9306610E-05,   1.7623242E-05
     +,   1.6070520E-05,   1.4639847E-05,   1.3322883E-05
     +,   1.2111955E-05,   1.0999619E-05,   9.9790250E-06
     +,   9.0435715E-06,   8.1871567E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_asha_hatt75_mass = Yx/38.5406868
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_asha_hatt80_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.6769825E-03,   1.7629751E-03
     +,   1.8515561E-03,   1.9426859E-03,   2.0363168E-03
     +,   2.1323939E-03,   2.2308556E-03,   2.3316329E-03
     +,   2.4346507E-03,   2.5398310E-03,   2.6470872E-03
     +,   2.7563288E-03,   2.8674612E-03,   2.9803871E-03
     +,   3.0950063E-03,   3.2112179E-03,   3.3289182E-03
     +,   3.4480065E-03,   3.5683808E-03,   3.6899426E-03
     +,   3.8125974E-03,   3.9362526E-03,   4.0608230E-03
     +,   4.1862354E-03,   4.3124096E-03,   4.4392906E-03
     +,   4.5668241E-03,   4.6949689E-03,   4.8236954E-03
     +,   4.9529886E-03,   5.0828443E-03,   5.2132760E-03
     +,   5.3443103E-03,   5.4759891E-03,   5.6083715E-03
     +,   5.7415324E-03,   5.8755632E-03,   6.0105701E-03
     +,   6.1466824E-03,   6.2840348E-03,   6.4227870E-03
     +,   6.5631131E-03,   6.7051998E-03,   6.8492568E-03
     +,   6.9955071E-03,   7.1441969E-03,   7.2955918E-03
     +,   7.4499869E-03,   7.6077092E-03,   7.7691157E-03
     +,   7.9346225E-03,   8.1046931E-03,   8.2798637E-03
     +,   8.4607620E-03,   8.6480966E-03,   8.8427272E-03
     +,   9.0456279E-03,   9.2579573E-03,   9.4810408E-03
     +,   9.7164279E-03,   9.9658854E-03,   1.0231446E-02
     +,   1.0515371E-02,   1.0820234E-02,   1.1148879E-02
     +,   1.1504404E-02,   1.1890217E-02,   1.2309932E-02
     +,   1.2767465E-02,   1.3266875E-02,   1.3812470E-02
     +,   1.4408639E-02,   1.5059969E-02,   1.5771072E-02
     +,   1.6546695E-02,   1.7391680E-02,   1.8310906E-02
     +,   1.9309340E-02,   2.0392193E-02,   2.1564897E-02
     +,   2.2833111E-02,   2.4203073E-02,   2.5681453E-02
     +,   2.7275909E-02,   2.8995039E-02,   3.0849265E-02
     +,   3.2851178E-02,   3.5017237E-02,   3.7369106E-02
     +,   3.9936863E-02,   4.2762652E-02,   4.5905441E-02
     +,   4.9447242E-02,   5.3500049E-02,   5.8212418E-02
     +,   6.3773923E-02,   7.0417970E-02,   7.8415737E-02
     +,   8.8064149E-02,   9.9657997E-02,   0.1134550    
     +,   0.1296282    ,   0.1482369    ,   0.1692383    
     +,   0.1926155    ,   0.2186856    ,   0.2486681    
     +,   0.2855358    ,   0.3350071    ,   0.4061831    
     +,   0.5108986    ,   0.6610190    ,   0.8644513    
     +,    1.123441    ,    1.439426    ,    1.827418    
     +,    2.332168    ,    3.003737    ,    3.808414    
     +,    4.637990    ,    5.497421    ,    6.511582    
     +,    7.682279    ,    8.853123    ,    9.577624    
     +,    10.10229    ,    10.85546    ,    10.94719    
     +,    10.33069    ,    9.345692    ,    8.307539    
     +,    7.500928    ,    6.702248    ,    5.715856    
     +,    4.657316    ,    3.805494    ,    3.227355    
     +,    2.816591    ,    2.471432    ,    2.156363    
     +,    1.886184    ,    1.678564    ,    1.522136    
     +,    1.389377    ,    1.263649    ,    1.144382    
     +,    1.035159    ,   0.9359140    ,   0.8444074    
     +,   0.7599053    ,   0.6840330    ,   0.6191857    
     +,   0.5666144    ,   0.5256212    ,   0.4939323    
     +,   0.4686230    ,   0.4469493    ,   0.4268438    
     +,   0.4070809    ,   0.3872262    ,   0.3674437    
     +,   0.3482438    ,   0.3302184    ,   0.3138246    
     +,   0.2992518    ,   0.2863916    ,   0.2748903    
     +,   0.2642523    ,   0.2539588    ,   0.2435731    
     +,   0.2328108    ,   0.2215640    ,   0.2098865    
     +,   0.1979517    ,   0.1859972    ,   0.1742664    
     +,   0.1629665    ,   0.1522424    ,   0.1421691    
     +,   0.1327580    ,   0.1239738    ,   0.1157551    
     +,   0.1080321    ,   0.1007400    ,   9.3829624E-02
     +,   8.7270305E-02,   8.1049815E-02,   7.5170130E-02
     +,   6.9643050E-02,   6.4485200E-02,   5.9711710E-02
     +,   5.5332620E-02,   5.1350228E-02,   4.7757268E-02
     +,   4.4536415E-02,   4.1661575E-02,   3.9099775E-02
     +,   3.6813255E-02,   3.4761742E-02,   3.2904975E-02
     +,   3.1204918E-02,   2.9627049E-02,   2.8141510E-02
     +,   2.6723634E-02,   2.5354328E-02,   2.4019513E-02
     +,   2.2709794E-02,   2.1419911E-02,   2.0147910E-02
     +,   1.8894356E-02,   1.7661713E-02,   1.6453806E-02
     +,   1.5275195E-02,   1.4130658E-02,   1.3024935E-02
     +,   1.1962497E-02,   1.0947321E-02,   9.9826464E-03
     +,   9.0710092E-03,   8.2142763E-03,   7.4134669E-03
     +,   6.6688862E-03,   5.9802122E-03,   5.3465073E-03
     +,   4.7662542E-03,   4.2374823E-03,   3.7578852E-03
     +,   3.3248591E-03,   2.9355544E-03,   2.5869876E-03
     +,   2.2761277E-03,   1.9999228E-03,   1.7553461E-03
     +,   1.5394541E-03,   1.3494429E-03,   1.1826328E-03
     +,   1.0365132E-03,   9.0876204E-04,   7.9724082E-04
     +,   6.9999148E-04,   6.1524444E-04,   5.4141594E-04
     +,   4.7709269E-04,   4.2101849E-04,   3.7208860E-04
     +,   3.2933900E-04,   2.9192932E-04,   2.5912913E-04
     +,   2.3030843E-04,   2.0492794E-04,   1.8252306E-04
     +,   1.6269661E-04,   1.4511099E-04,   1.2947813E-04
     +,   1.1555154E-04,   1.0312115E-04,   9.2008457E-05
     +,   8.2060462E-05,   7.3145224E-05,   6.5149019E-05
     +,   5.7973983E-05,   5.1534797E-05,   4.5756278E-05
     +,   4.0572329E-05,   3.5924888E-05,   3.1761687E-05
     +,   2.8035951E-05,   2.4705863E-05,   2.1733556E-05
     +,   1.9084488E-05,   1.6727281E-05,   1.4633498E-05
     +,   1.2777170E-05,   1.1134444E-05,   9.6835684E-06
     +,   8.4048397E-06,   7.2800954E-06,   6.2929644E-06
     +,   5.4284155E-06,   4.6729374E-06,   4.0141781E-06
     +,   3.4410705E-06,   2.9435651E-06,   2.5126858E-06
     +,   2.1403298E-06,   1.8192984E-06,   1.5431350E-06
     +,   1.3061033E-06,   1.1031334E-06,   9.2971459E-07
     +,   7.8189277E-07,   6.5616734E-07,   5.4948578E-07
     +,   4.5916397E-07,   3.8287160E-07,   3.1857149E-07
     +,   2.6450556E-07,   2.1914448E-07,   1.8117548E-07
     +,   1.4946403E-07,   1.2304028E-07
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_asha_hatt80_mass = Yx/43.2099162352941
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_asha_hatt85_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  8.8718737E-04,   9.1294188E-04
     +,   9.3920878E-04,   9.6607348E-04,   9.9363585E-04
     +,   1.0220123E-03,   1.0513366E-03,   1.0817603E-03
     +,   1.1134545E-03,   1.1466123E-03,   1.1814469E-03
     +,   1.2181940E-03,   1.2571129E-03,   1.2984860E-03
     +,   1.3426199E-03,   1.3898452E-03,   1.4405153E-03
     +,   1.4950078E-03,   1.5537210E-03,   1.6170748E-03
     +,   1.6855081E-03,   1.7594765E-03,   1.8394475E-03
     +,   1.9259067E-03,   2.0193371E-03,   2.1202341E-03
     +,   2.2290878E-03,   2.3463846E-03,   2.4726002E-03
     +,   2.6081938E-03,   2.7536047E-03,   2.9092452E-03
     +,   3.0754951E-03,   3.2526986E-03,   3.4411545E-03
     +,   3.6411181E-03,   3.8527912E-03,   4.0763165E-03
     +,   4.3117963E-03,   4.5592454E-03,   4.8186462E-03
     +,   5.0899019E-03,   5.3728651E-03,   5.6673270E-03
     +,   5.9730238E-03,   6.2896465E-03,   6.6168392E-03
     +,   6.9542048E-03,   7.3013143E-03,   7.6577179E-03
     +,   8.0229416E-03,   8.3965054E-03,   8.7779164E-03
     +,   9.1667119E-03,   9.5623871E-03,   9.9644978E-03
     +,   1.0372586E-02,   1.0786218E-02,   1.1204963E-02
     +,   1.1628411E-02,   1.2056152E-02,   1.2487781E-02
     +,   1.2922854E-02,   1.3360940E-02,   1.3801572E-02
     +,   1.4244208E-02,   1.4688304E-02,   1.5133199E-02
     +,   1.5578231E-02,   1.6022617E-02,   1.6465567E-02
     +,   1.6906206E-02,   1.7343676E-02,   1.7777065E-02
     +,   1.8205576E-02,   1.8628472E-02,   1.9045150E-02
     +,   1.9455208E-02,   1.9858567E-02,   2.0255465E-02
     +,   2.0646537E-02,   2.1032924E-02,   2.1416245E-02
     +,   2.1798722E-02,   2.2183072E-02,   2.2572605E-02
     +,   2.2971049E-02,   2.3382580E-02,   2.3811579E-02
     +,   2.4262551E-02,   2.4739943E-02,   2.5247868E-02
     +,   2.5789943E-02,   2.6369132E-02,   2.6987582E-02
     +,   2.7646482E-02,   2.8346216E-02,   2.9086379E-02
     +,   2.9866273E-02,   3.0685205E-02,   3.1543516E-02
     +,   3.2443263E-02,   3.3389721E-02,   3.4392510E-02
     +,   3.5467375E-02,   3.6637768E-02,   3.7936199E-02
     +,   3.9405782E-02,   4.1101187E-02,   4.3089271E-02
     +,   4.5448951E-02,   4.8271321E-02,   5.1658496E-02
     +,   5.5723317E-02,   6.0587019E-02,   6.6378564E-02
     +,   7.3231965E-02,   8.1289828E-02,   9.0712845E-02
     +,   0.1017109    ,   0.1145983    ,   0.1298740    
     +,   0.1483046    ,   0.1709626    ,   0.1991573    
     +,   0.2342335    ,   0.2773153    ,   0.3291190    
     +,   0.3899917    ,   0.4600973    ,   0.5397274    
     +,   0.6301307    ,   0.7362793    ,   0.8723848    
     +,    1.067317    ,    1.361161    ,    1.789076    
     +,    2.369328    ,    3.094354    ,    3.916547    
     +,    4.869238    ,    6.102278    ,    7.549123    
     +,    8.843268    ,    10.07309    ,    11.71265    
     +,    12.87281    ,    13.29286    ,    12.66469    
     +,    11.92759    ,    10.92838    ,    9.436507    
     +,    8.031866    ,    6.774229    ,    5.749508    
     +,    4.969774    ,    4.233749    ,    3.426936    
     +,    2.731161    ,    2.260457    ,    1.945523    
     +,    1.694849    ,    1.480487    ,    1.309983    
     +,    1.187168    ,    1.096948    ,    1.014790    
     +,   0.9235129    ,   0.8205984    ,   0.7139670    
     +,   0.6137068    ,   0.5264808    ,   0.4543637    
     +,   0.3963022    ,   0.3499667    ,   0.3129498    
     +,   0.2832838    ,   0.2595281    ,   0.2406480    
     +,   0.2258369    ,   0.2143577    ,   0.2054475    
     +,   0.1982953    ,   0.1920841    ,   0.1860687    
     +,   0.1796558    ,   0.1724595    ,   0.1643192    
     +,   0.1552790    ,   0.1455409    ,   0.1353971    
     +,   0.1251677    ,   0.1151479    ,   0.1055722    
     +,   9.6597888E-02,   8.8305973E-02,   8.0713086E-02
     +,   7.3789038E-02,   6.7474693E-02,   6.1699282E-02
     +,   5.6392901E-02,   5.1493797E-02,   4.6951741E-02
     +,   4.2728815E-02,   3.8798369E-02,   3.5141688E-02
     +,   3.1745840E-02,   2.8601443E-02,   2.5700584E-02
     +,   2.3035316E-02,   2.0597089E-02,   1.8376501E-02
     +,   1.6363034E-02,   1.4544997E-02,   1.2909928E-02
     +,   1.1444932E-02,   1.0136837E-02,   8.9723524E-03
     +,   7.9384604E-03,   7.0226775E-03,   6.2130163E-03
     +,   5.4982370E-03,   4.8679616E-03,   4.3126624E-03
     +,   3.8236547E-03,   3.3931248E-03,   3.0141238E-03
     +,   2.6804726E-03,   2.3866906E-03,   2.1279533E-03
     +,   1.9000372E-03,   1.6992327E-03,   1.5222668E-03
     +,   1.3662671E-03,   1.2287209E-03,   1.1073987E-03
     +,   1.0003357E-03,   9.0580102E-04,   8.2226424E-04
     +,   7.4836408E-04,   6.8289798E-04,   6.2480627E-04
     +,   5.7315273E-04,   5.2710896E-04,   4.8594698E-04
     +,   4.4903121E-04,   4.1580590E-04,   3.8578486E-04
     +,   3.5854708E-04,   3.3373098E-04,   3.1102356E-04
     +,   2.9015646E-04,   2.7090259E-04,   2.5306872E-04
     +,   2.3649044E-04,   2.2102895E-04,   2.0656880E-04
     +,   1.9301282E-04,   1.8027876E-04,   1.6829759E-04
     +,   1.5701195E-04,   1.4637335E-04,   1.3633979E-04
     +,   1.2687525E-04,   1.1794930E-04,   1.0953414E-04
     +,   1.0160501E-04,   9.4139818E-05,   8.7118147E-05
     +,   8.0520418E-05,   7.4328003E-05,   6.8523448E-05
     +,   6.3089843E-05,   5.8010326E-05,   5.3268443E-05
     +,   4.8848546E-05,   4.4734647E-05,   4.0911611E-05
     +,   3.7364094E-05,   3.4077555E-05,   3.1037318E-05
     +,   2.8229497E-05,   2.5640216E-05,   2.3256358E-05
     +,   2.1064925E-05,   1.9053668E-05,   1.7210601E-05
     +,   1.5524243E-05,   1.3983774E-05,   1.2578672E-05
     +,   1.1299125E-05,   1.0135637E-05,   9.0793874E-06
     +,   8.1219023E-06,   7.2553503E-06,   6.4722485E-06
     +,   5.7656848E-06,   5.1291145E-06,   4.5565189E-06
     +,   4.0422178E-06,   3.5810083E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_asha_hatt85_mass = Yx/46.3369496470588
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_asha_hatt90_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  7.3827850E-04,   7.5398880E-04
     +,   7.6881703E-04,   7.8271731E-04,   7.9565152E-04
     +,   8.0759235E-04,   8.1852294E-04,   8.2843861E-04
     +,   8.3734933E-04,   8.4528094E-04,   8.5227616E-04
     +,   8.5839781E-04,   8.6373003E-04,   8.6838042E-04
     +,   8.7248400E-04,   8.7620202E-04,   8.7972853E-04
     +,   8.8328891E-04,   8.8714529E-04,   8.9159666E-04
     +,   8.9698209E-04,   9.0368092E-04,   9.1211544E-04
     +,   9.2275132E-04,   9.3609479E-04,   9.5269678E-04
     +,   9.7314583E-04,   9.9806883E-04,   1.0281233E-03
     +,   1.0639946E-03,   1.1063878E-03,   1.1560185E-03
     +,   1.2136039E-03,   1.2798504E-03,   1.3554419E-03
     +,   1.4410266E-03,   1.5372012E-03,   1.6444952E-03
     +,   1.7633665E-03,   1.8941641E-03,   2.0371445E-03
     +,   2.1924360E-03,   2.3600406E-03,   2.5398242E-03
     +,   2.7315109E-03,   2.9346861E-03,   3.1487965E-03
     +,   3.3731577E-03,   3.6069669E-03,   3.8493180E-03
     +,   4.0992163E-03,   4.3556052E-03,   4.6173851E-03
     +,   4.8834584E-03,   5.1527126E-03,   5.4241070E-03
     +,   5.6966469E-03,   5.9694308E-03,   6.2416652E-03
     +,   6.5126810E-03,   6.7819371E-03,   7.0490376E-03
     +,   7.3136971E-03,   7.5757788E-03,   7.8352522E-03
     +,   8.0921538E-03,   8.3466098E-03,   8.5987486E-03
     +,   8.8487389E-03,   9.0966830E-03,   9.3426611E-03
     +,   9.5866369E-03,   9.8284930E-03,   1.0067965E-02
     +,   1.0304682E-02,   1.0538139E-02,   1.0767703E-02
     +,   1.0992635E-02,   1.1212152E-02,   1.1425425E-02
     +,   1.1631630E-02,   1.1830023E-02,   1.2019954E-02
     +,   1.2200974E-02,   1.2372833E-02,   1.2535583E-02
     +,   1.2689576E-02,   1.2835544E-02,   1.2974576E-02
     +,   1.3108188E-02,   1.3238292E-02,   1.3367182E-02
     +,   1.3497525E-02,   1.3632348E-02,   1.3774983E-02
     +,   1.3929019E-02,   1.4098288E-02,   1.4286821E-02
     +,   1.4498848E-02,   1.4738767E-02,   1.5011223E-02
     +,   1.5321062E-02,   1.5673531E-02,   1.6074222E-02
     +,   1.6529312E-02,   1.7045580E-02,   1.7630495E-02
     +,   1.8292252E-02,   1.9039789E-02,   1.9882679E-02
     +,   2.0830801E-02,   2.1894256E-02,   2.3082737E-02
     +,   2.4405414E-02,   2.5870200E-02,   2.7483892E-02
     +,   2.9251656E-02,   3.1177804E-02,   3.3265892E-02
     +,   3.5520289E-02,   3.7947394E-02,   4.0557213E-02
     +,   4.3364994E-02,   4.6392918E-02,   4.9670339E-02
     +,   5.3232852E-02,   5.7120886E-02,   6.1374810E-02
     +,   6.6030316E-02,   7.1110412E-02,   7.6618984E-02
     +,   8.2532533E-02,   8.8796690E-02,   9.5323555E-02
     +,   0.1019983    ,   0.1086917    ,   0.1152832    
     +,   0.1216962    ,   0.1279418    ,   0.1341682    
     +,   0.1407016    ,   0.1480654    ,   0.1569543    
     +,   0.1681444    ,   0.1823367    ,   0.1999694    
     +,   0.2210675    ,   0.2452480    ,   0.2719866    
     +,   0.3011617    ,   0.3337644    ,   0.3726805    
     +,   0.4236127    ,   0.4960123    ,   0.6031594    
     +,   0.7611773    ,   0.9898520    ,    1.318199    
     +,    1.787317    ,    2.432632    ,    3.264654    
     +,    4.293544    ,    5.652881    ,    7.336296    
     +,    9.138975    ,    11.39930    ,    12.99579    
     +,    14.21090    ,    15.18458    ,    14.38344    
     +,    13.09243    ,    11.69094    ,    9.766733    
     +,    7.998837    ,    6.401991    ,    5.097904    
     +,    3.959743    ,    3.080107    ,    2.587384    
     +,    2.327733    ,    2.104715    ,    1.842721    
     +,    1.557280    ,    1.290616    ,    1.072138    
     +,   0.9042953    ,   0.7726078    ,   0.6625578    
     +,   0.5666267    ,   0.4828243    ,   0.4114743    
     +,   0.3530211    ,   0.3069243    ,   0.2714684    
     +,   0.2442124    ,   0.2226356    ,   0.2045970    
     +,   0.1885121    ,   0.1733323    ,   0.1584456    
     +,   0.1435739    ,   0.1286836    ,   0.1139079    
     +,   9.9480264E-02,   8.5674688E-02,   7.2754383E-02
     +,   6.0937420E-02,   5.0376236E-02,   4.1148592E-02
     +,   3.3259418E-02,   2.6652152E-02,   2.1224027E-02
     +,   1.6842071E-02,   1.3358745E-02,   1.0625654E-02
     +,   8.5034175E-03,   6.8676434E-03,   5.6119207E-03
     +,   4.6485234E-03,   3.9072935E-03,   3.3333160E-03
     +,   2.8845312E-03,   2.5292314E-03,   2.2437596E-03
     +,   2.0105923E-03,   1.8168280E-03,   1.6529980E-03
     +,   1.5121407E-03,   1.3891218E-03,   1.2801504E-03
     +,   1.1824208E-03,   1.0938424E-03,   1.0128450E-03
     +,   9.3824719E-04,   8.6916174E-04,   8.0490712E-04
     +,   7.4496068E-04,   6.8892079E-04,   6.3647173E-04
     +,   5.8735767E-04,   5.4136867E-04,   4.9833045E-04
     +,   4.5809074E-04,   4.2051059E-04,   3.8546097E-04
     +,   3.5282239E-04,   3.2247897E-04,   2.9431572E-04
     +,   2.6822003E-04,   2.4408319E-04,   2.2179591E-04
     +,   2.0125082E-04,   1.8234424E-04,   1.6497495E-04
     +,   1.4904344E-04,   1.3445370E-04,   1.2111447E-04
     +,   1.0893805E-04,   9.7840049E-05,   8.7740300E-05
     +,   7.8563542E-05,   7.0238661E-05,   6.2698040E-05
     +,   5.5878336E-05,   4.9720795E-05,   4.4169861E-05
     +,   3.9173756E-05,   3.4684599E-05,   3.0657851E-05
     +,   2.7051934E-05,   2.3828352E-05,   2.0951777E-05
     +,   1.8389532E-05,   1.6111355E-05,   1.4089451E-05
     +,   1.2298490E-05,   1.0715022E-05,   9.3178069E-06
     +,   8.0872842E-06,   7.0057813E-06,   6.0571037E-06
     +,   5.2266787E-06,   4.5012107E-06,   3.8687854E-06
     +,   3.3185815E-06,   2.8409427E-06,   2.4271610E-06
     +,   2.0694495E-06,   1.7608903E-06,   1.4952832E-06
     +,   1.2671554E-06,   1.0716290E-06,   9.0441847E-07
     +,   7.6172540E-07,   6.4022697E-07,   5.3699443E-07
     +,   4.4947876E-07,   3.7544442E-07,   3.1295627E-07
     +,   2.6032552E-07,   2.1609699E-07
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_asha_hatt90_mass = Yx/44.9866397647059
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_asha_hatt95_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.6471974E-05,   5.3739339E-05
     +,   6.1977313E-05,   7.1287330E-05,   8.1777020E-05
     +,   9.3559895E-05,   1.0675500E-04,   1.2148629E-04
     +,   1.3788173E-04,   1.5607353E-04,   1.7619561E-04
     +,   1.9838345E-04,   2.2277265E-04,   2.4949736E-04
     +,   2.7868885E-04,   3.1047378E-04,   3.4497239E-04
     +,   3.8229665E-04,   4.2254853E-04,   4.6581725E-04
     +,   5.1217875E-04,   5.6169211E-04,   6.1439828E-04
     +,   6.7032187E-04,   7.2946073E-04,   7.9179608E-04
     +,   8.5728313E-04,   9.2585274E-04,   9.9741318E-04
     +,   1.0718479E-03,   1.1490171E-03,   1.2287587E-03
     +,   1.3108900E-03,   1.3952106E-03,   1.4815037E-03
     +,   1.5695404E-03,   1.6590847E-03,   1.7498937E-03
     +,   1.8417323E-03,   1.9343615E-03,   2.0275661E-03
     +,   2.1211428E-03,   2.2149142E-03,   2.3087356E-03
     +,   2.4025012E-03,   2.4961508E-03,   2.5896756E-03
     +,   2.6831254E-03,   2.7766151E-03,   2.8703304E-03
     +,   2.9645308E-03,   3.0595583E-03,   3.1558350E-03
     +,   3.2538753E-03,   3.3542700E-03,   3.4577106E-03
     +,   3.5649678E-03,   3.6768981E-03,   3.7944403E-03
     +,   3.9186068E-03,   4.0504783E-03,   4.1911970E-03
     +,   4.3419427E-03,   4.5039435E-03,   4.6784477E-03
     +,   4.8666876E-03,   5.0699054E-03,   5.2892836E-03
     +,   5.5259718E-03,   5.7810075E-03,   6.0553569E-03
     +,   6.3498188E-03,   6.6650761E-03,   7.0015872E-03
     +,   7.3596411E-03,   7.7393032E-03,   8.1403702E-03
     +,   8.5623823E-03,   9.0046385E-03,   9.4661647E-03
     +,   9.9456813E-03,   1.0441707E-02,   1.0952462E-02
     +,   1.1476016E-02,   1.2010204E-02,   1.2552799E-02
     +,   1.3101428E-02,   1.3653788E-02,   1.4207557E-02
     +,   1.4760613E-02,   1.5311038E-02,   1.5857199E-02
     +,   1.6397815E-02,   1.6932109E-02,   1.7459802E-02
     +,   1.7981127E-02,   1.8496981E-02,   1.9008785E-02
     +,   1.9518612E-02,   2.0029005E-02,   2.0543028E-02
     +,   2.1064034E-02,   2.1595657E-02,   2.2141520E-02
     +,   2.2705169E-02,   2.3289828E-02,   2.3898149E-02
     +,   2.4532082E-02,   2.5192708E-02,   2.5880078E-02
     +,   2.6593000E-02,   2.7329238E-02,   2.8085236E-02
     +,   2.8856494E-02,   2.9637516E-02,   3.0422354E-02
     +,   3.1204857E-02,   3.1979371E-02,   3.2741450E-02
     +,   3.3488926E-02,   3.4223150E-02,   3.4950420E-02
     +,   3.5683792E-02,   3.6445070E-02,   3.7266787E-02
     +,   3.8193807E-02,   3.9284732E-02,   4.0611766E-02
     +,   4.2259563E-02,   4.4321164E-02,   4.6892434E-02
     +,   5.0062753E-02,   5.3904682E-02,   5.8460735E-02
     +,   6.3731529E-02,   6.9664881E-02,   7.6148085E-02
     +,   8.3006904E-02,   9.0011470E-02,   9.6889183E-02
     +,   0.1033438    ,   0.1090817    ,   0.1138396    
     +,   0.1174117    ,   0.1196724    ,   0.1205943    
     +,   0.1202549    ,   0.1188354    ,   0.1166095    
     +,   0.1139224    ,   0.1111642    ,   0.1087389    
     +,   0.1070319    ,   0.1063783    ,   0.1070388    
     +,   0.1091833    ,   0.1128861    ,   0.1181348    
     +,   0.1248518    ,   0.1329246    ,   0.1422426    
     +,   0.1527299    ,   0.1643687    ,   0.1772120    
     +,   0.1913943    ,   0.2071635    ,   0.2249620    
     +,   0.2455791    ,   0.2703079    ,   0.3009610    
     +,   0.3395644    ,   0.3877153    ,   0.4459342    
     +,   0.5136089    ,   0.5900722    ,   0.6770234    
     +,   0.7819392    ,   0.9205461    ,    1.115247    
     +,    1.398283    ,    1.828455    ,    2.458358    
     +,    3.315670    ,    4.638670    ,    6.656940    
     +,    9.836679    ,    13.32588    ,    15.05566    
     +,    18.18810    ,    19.75991    ,    17.08717    
     +,    13.82147    ,    11.16706    ,    8.490920    
     +,    5.908090    ,    4.295278    ,    3.424862    
     +,    2.619195    ,    1.877037    ,    1.327104    
     +,   0.9600770    ,   0.7112062    ,   0.5323445    
     +,   0.3979623    ,   0.2948217    ,   0.2161684    
     +,   0.1578854    ,   0.1161336    ,   8.6894706E-02
     +,   6.6458225E-02,   5.1877599E-02,   4.1093331E-02
     +,   3.2806199E-02,   2.6254870E-02,   2.1003820E-02
     +,   1.6788749E-02,   1.3424598E-02,   1.0761475E-02
     +,   8.6689433E-03,   7.0328601E-03,   5.7555037E-03
     +,   4.7561871E-03,   3.9703907E-03,   3.3477501E-03
     +,   2.8496441E-03,   2.4468428E-03,   2.1173866E-03
     +,   1.8447837E-03,   1.6166250E-03,   1.4235611E-03
     +,   1.2585290E-03,   1.1161525E-03,   9.9230732E-04
     +,   8.8381249E-04,   7.8820076E-04,   7.0352154E-04
     +,   6.2822085E-04,   5.6104932E-04,   5.0098321E-04
     +,   4.4716845E-04,   3.9888805E-04,   3.5553411E-04
     +,   3.1658311E-04,   2.8157799E-04,   2.5011873E-04
     +,   2.2185493E-04,   1.9647543E-04,   1.7370163E-04
     +,   1.5328427E-04,   1.3500154E-04,   1.1865155E-04
     +,   1.0405188E-04,   9.1038026E-05,   7.9460253E-05
     +,   6.9181158E-05,   6.0075312E-05,   5.2028507E-05
     +,   4.4935943E-05,   3.8701015E-05,   3.3235239E-05
     +,   2.8457840E-05,   2.4294828E-05,   2.0678259E-05
     +,   1.7546266E-05,   1.4842838E-05,   1.2516901E-05
     +,   1.0522323E-05,   8.8177139E-06,   7.3658798E-06
     +,   6.1335136E-06,   5.0909953E-06,   4.2121387E-06
     +,   3.4738346E-06,   2.8557229E-06,   2.3400141E-06
     +,   1.9112624E-06,   1.5560172E-06,   1.2627140E-06
     +,   1.0213757E-06,   8.2349493E-07,   6.6179717E-07
     +,   5.3013071E-07,   4.2328077E-07,   3.3687363E-07
     +,   2.6723481E-07,   2.1130603E-07,   1.6654073E-07
     +,   1.3083240E-07,   1.0244801E-07,   7.9960778E-08
     +,   6.2207711E-08,   4.8238846E-08,   3.7285719E-08
     +,   2.8725925E-08,   2.2059655E-08,   1.6885291E-08
     +,   1.2882849E-08,   9.7971737E-09,   7.4264692E-09
     +,   5.6111258E-09,   4.2258166E-09
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_asha_hatt95_mass = Yx/42.5939854117647
      RETURN
      END
C 
C---- New file --- 
C 
      DOUBLE PRECISION FUNCTION A200_tt_ashz_htt100_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  8.6547353E-04,   8.8117301E-04
     +,   8.9692511E-04,   9.1273483E-04,   9.2860870E-04
     +,   9.4455486E-04,   9.6058333E-04,   9.7670557E-04
     +,   9.9293515E-04,   1.0092885E-03,   1.0257836E-03
     +,   1.0424408E-03,   1.0592836E-03,   1.0763378E-03
     +,   1.0936324E-03,   1.1111994E-03,   1.1290744E-03
     +,   1.1472958E-03,   1.1659064E-03,   1.1849523E-03
     +,   1.2044844E-03,   1.2245565E-03,   1.2452278E-03
     +,   1.2665627E-03,   1.2886287E-03,   1.3114995E-03
     +,   1.3352538E-03,   1.3599753E-03,   1.3857525E-03
     +,   1.4126812E-03,   1.4408608E-03,   1.4703982E-03
     +,   1.5014044E-03,   1.5339976E-03,   1.5683008E-03
     +,   1.6044428E-03,   1.6425583E-03,   1.6827862E-03
     +,   1.7252733E-03,   1.7701661E-03,   1.8176207E-03
     +,   1.8677940E-03,   1.9208469E-03,   1.9769422E-03
     +,   2.0362462E-03,   2.0989247E-03,   2.1651443E-03
     +,   2.2350692E-03,   2.3088637E-03,   2.3866876E-03
     +,   2.4686949E-03,   2.5550355E-03,   2.6458495E-03
     +,   2.7412733E-03,   2.8414235E-03,   2.9464138E-03
     +,   3.0563402E-03,   3.1712833E-03,   3.2913079E-03
     +,   3.4164626E-03,   3.5467772E-03,   3.6822627E-03
     +,   3.8229038E-03,   3.9686742E-03,   4.1195308E-03
     +,   4.2753965E-03,   4.4361968E-03,   4.6018218E-03
     +,   4.7721700E-03,   4.9471119E-03,   5.1265340E-03
     +,   5.3103026E-03,   5.4983166E-03,   5.6904694E-03
     +,   5.8866888E-03,   6.0869488E-03,   6.2912521E-03
     +,   6.4996593E-03,   6.7123193E-03,   6.9294572E-03
     +,   7.1513872E-03,   7.3785614E-03,   7.6115336E-03
     +,   7.8510260E-03,   8.0978880E-03,   8.3531719E-03
     +,   8.6180707E-03,   8.8939937E-03,   9.1825062E-03
     +,   9.4853863E-03,   9.8045915E-03,   1.0142235E-02
     +,   1.0500590E-02,   1.0882072E-02,   1.1289225E-02
     +,   1.1724620E-02,   1.2190916E-02,   1.2690716E-02
     +,   1.3226639E-02,   1.3801115E-02,   1.4416518E-02
     +,   1.5074934E-02,   1.5778285E-02,   1.6528118E-02
     +,   1.7325729E-02,   1.8172065E-02,   1.9067688E-02
     +,   2.0012759E-02,   2.1007190E-02,   2.2050574E-02
     +,   2.3142152E-02,   2.4281105E-02,   2.5466373E-02
     +,   2.6696987E-02,   2.7971925E-02,   2.9290510E-02
     +,   3.0652158E-02,   3.2056849E-02,   3.3504821E-02
     +,   3.4996986E-02,   3.6534775E-02,   3.8120057E-02
     +,   3.9755207E-02,   4.1443076E-02,   4.3186791E-02
     +,   4.4989310E-02,   4.6853773E-02,   4.8782539E-02
     +,   5.0777461E-02,   5.2839153E-02,   5.4967001E-02
     +,   5.7158478E-02,   5.9409358E-02,   6.1713051E-02
     +,   6.4060934E-02,   6.6442080E-02,   6.8843469E-02
     +,   7.1250156E-02,   7.3646061E-02,   7.6014280E-02
     +,   7.8337647E-02,   8.0599532E-02,   8.2784861E-02
     +,   8.4880590E-02,   8.6876266E-02,   8.8764809E-02
     +,   9.0542585E-02,   9.2209294E-02,   9.3767926E-02
     +,   9.5224120E-02,   9.6585535E-02,   9.7860582E-02
     +,   9.9057823E-02,   0.1001849    ,   0.1012479    
     +,   0.1022511    ,   0.1031972    ,   0.1040881    
     +,   0.1049258    ,   0.1057150    ,   0.1064643    
     +,   0.1071895    ,   0.1079148    ,   0.1086750    
     +,   0.1095158    ,   0.1104937    ,   0.1116736    
     +,   0.1131262    ,   0.1149236    ,   0.1171348    
     +,   0.1198220    ,   0.1230380    ,   0.1268298    
     +,   0.1312454    ,   0.1363494    ,   0.1422472    
     +,   0.1491141    ,   0.1572281    ,   0.1669969    
     +,   0.1789711    ,   0.1938281    ,   0.2123194    
     +,   0.2351764    ,   0.2629801    ,   0.2960082    
     +,   0.3340926    ,   0.3765467    ,   0.4222298    
     +,   0.4698153    ,   0.5182972    ,   0.5676966    
     +,   0.6197073    ,   0.6778845    ,   0.7470672    
     +,   0.8322772    ,   0.9382017    ,    1.070212    
     +,    1.235440    ,    1.439550    ,    1.677841    
     +,    1.929796    ,    2.170662    ,    2.397873    
     +,    2.648642    ,    2.980277    ,    3.416253    
     +,    3.917949    ,    4.398636    ,    4.736887    
     +,    4.882885    ,    4.989534    ,    5.240034    
     +,    5.568463    ,    5.764628    ,    5.789770    
     +,    5.734002    ,    5.582082    ,    5.285411    
     +,    4.920802    ,    4.612705    ,    4.390926    
     +,    4.208025    ,    4.014565    ,    3.770822    
     +,    3.469481    ,    3.153313    ,    2.861185    
     +,    2.588492    ,    2.322229    ,    2.071465    
     +,    1.851300    ,    1.664599    ,    1.504451    
     +,    1.362374    ,    1.231990    ,    1.109473    
     +,   0.9933460    ,   0.8840867    ,   0.7832093    
     +,   0.6919085    ,   0.6101495    ,   0.5367842    
     +,   0.4703327    ,   0.4096684    ,   0.3542270    
     +,   0.3038553    ,   0.2585707    ,   0.2183922    
     +,   0.1832583    ,   0.1529913    ,   0.1272806    
     +,   0.1057003    ,   8.7747015E-02,   7.2886273E-02
     +,   6.0599141E-02,   5.0419591E-02,   4.1953962E-02
     +,   3.4884270E-02,   2.8961202E-02,   2.3992218E-02
     +,   1.9827856E-02,   1.6348863E-02,   1.3456367E-02
     +,   1.1065697E-02,   9.1025149E-03,   7.5003044E-03
     +,   6.1997501E-03,   5.1484853E-03,   4.3008476E-03
     +,   3.6176881E-03,   3.0661218E-03,   2.6190574E-03
     +,   2.2545212E-03,   1.9549539E-03,   1.7065329E-03
     +,   1.4985141E-03,   1.3225675E-03,   1.1723064E-03
     +,   1.0428041E-03,   9.3028106E-04,   8.3179487E-04
     +,   7.4505905E-04,   6.6825759E-04,   5.9994916E-04
     +,   5.3896074E-04,   4.8433981E-04,   4.3529342E-04
     +,   3.9115918E-04,   3.5138166E-04,   3.1548322E-04
     +,   2.8305771E-04,   2.5375010E-04,   2.2725406E-04
     +,   2.0329720E-04,   1.8164203E-04,   1.6207424E-04
     +,   1.4440482E-04,   1.2846148E-04,   1.1409070E-04
     +,   1.0115142E-04,   8.9516921E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_ashz_htt100_mass = Yx/36.32973204
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_ashz_htt105_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  8.2109199E-04,   8.3058124E-04
     +,   8.4000768E-04,   8.4938982E-04,   8.5874862E-04
     +,   8.6810900E-04,   8.7749929E-04,   8.8695169E-04
     +,   8.9650252E-04,   9.0619270E-04,   9.1606786E-04
     +,   9.2617836E-04,   9.3658036E-04,   9.4733539E-04
     +,   9.5851079E-04,   9.7018084E-04,   9.8242611E-04
     +,   9.9533354E-04,   1.0089978E-03,   1.0235211E-03
     +,   1.0390127E-03,   1.0555902E-03,   1.0733790E-03
     +,   1.0925133E-03,   1.1131341E-03,   1.1353928E-03
     +,   1.1594476E-03,   1.1854655E-03,   1.2136216E-03
     +,   1.2440986E-03,   1.2770876E-03,   1.3127866E-03
     +,   1.3514004E-03,   1.3931403E-03,   1.4382239E-03
     +,   1.4868726E-03,   1.5393135E-03,   1.5957759E-03
     +,   1.6564954E-03,   1.7217019E-03,   1.7916339E-03
     +,   1.8665242E-03,   1.9466054E-03,   2.0321065E-03
     +,   2.1232520E-03,   2.2202611E-03,   2.3233457E-03
     +,   2.4327079E-03,   2.5485421E-03,   2.6710278E-03
     +,   2.8003354E-03,   2.9366177E-03,   3.0800104E-03
     +,   3.2306425E-03,   3.3886065E-03,   3.5539917E-03
     +,   3.7268579E-03,   3.9072423E-03,   4.0951623E-03
     +,   4.2906064E-03,   4.4935402E-03,   4.7039036E-03
     +,   4.9215974E-03,   5.1465095E-03,   5.3785010E-03
     +,   5.6173760E-03,   5.8629452E-03,   6.1149523E-03
     +,   6.3731447E-03,   6.6372063E-03,   6.9068242E-03
     +,   7.1816226E-03,   7.4612298E-03,   7.7452143E-03
     +,   8.0331489E-03,   8.3245775E-03,   8.6190142E-03
     +,   8.9159487E-03,   9.2148865E-03,   9.5153237E-03
     +,   9.8167267E-03,   1.0118606E-02,   1.0420442E-02
     +,   1.0721784E-02,   1.1022168E-02,   1.1321203E-02
     +,   1.1618509E-02,   1.1913801E-02,   1.2206822E-02
     +,   1.2497426E-02,   1.2785545E-02,   1.3071187E-02
     +,   1.3354466E-02,   1.3635619E-02,   1.3915000E-02
     +,   1.4193056E-02,   1.4470384E-02,   1.4747656E-02
     +,   1.5025707E-02,   1.5305438E-02,   1.5587881E-02
     +,   1.5874118E-02,   1.6165333E-02,   1.6462738E-02
     +,   1.6767589E-02,   1.7081145E-02,   1.7404648E-02
     +,   1.7739268E-02,   1.8086122E-02,   1.8446237E-02
     +,   1.8820463E-02,   1.9209540E-02,   1.9613964E-02
     +,   2.0034084E-02,   2.0469962E-02,   2.0921482E-02
     +,   2.1388199E-02,   2.1869494E-02,   2.2364412E-02
     +,   2.2871817E-02,   2.3390325E-02,   2.3918314E-02
     +,   2.4453981E-02,   2.4995375E-02,   2.5540439E-02
     +,   2.6086975E-02,   2.6632808E-02,   2.7175702E-02
     +,   2.7713489E-02,   2.8244058E-02,   2.8765433E-02
     +,   2.9275738E-02,   2.9773338E-02,   3.0256715E-02
     +,   3.0724630E-02,   3.1176044E-02,   3.1610131E-02
     +,   3.2026295E-02,   3.2424178E-02,   3.2803625E-02
     +,   3.3164643E-02,   3.3507448E-02,   3.3832420E-02
     +,   3.4140091E-02,   3.4431100E-02,   3.4706246E-02
     +,   3.4966473E-02,   3.5212837E-02,   3.5446558E-02
     +,   3.5669122E-02,   3.5882171E-02,   3.6087684E-02
     +,   3.6287989E-02,   3.6485881E-02,   3.6684655E-02
     +,   3.6888231E-02,   3.7101232E-02,   3.7329137E-02
     +,   3.7578333E-02,   3.7856180E-02,   3.8171150E-02
     +,   3.8532794E-02,   3.8951881E-02,   3.9440207E-02
     +,   4.0010810E-02,   4.0677745E-02,   4.1456025E-02
     +,   4.2361464E-02,   4.3410797E-02,   4.4621442E-02
     +,   4.6011515E-02,   4.7599789E-02,   4.9406238E-02
     +,   5.1452126E-02,   5.3760242E-02,   5.6356169E-02
     +,   5.9268907E-02,   6.2531896E-02,   6.6184416E-02
     +,   7.0273548E-02,   7.4855685E-02,   7.9997651E-02
     +,   8.5778236E-02,   9.2288531E-02,   9.9630713E-02
     +,   0.1079146    ,   0.1172532    ,   0.1277578    
     +,   0.1395328    ,   0.1526717    ,   0.1672628    
     +,   0.1833965    ,   0.2011771    ,   0.2207393    
     +,   0.2422585    ,   0.2659526    ,   0.2920722    
     +,   0.3208907    ,   0.3527013    ,   0.3878217    
     +,   0.4266065    ,   0.4694556    ,   0.5167922    
     +,   0.5689744    ,   0.6261225    ,   0.6878768    
     +,   0.7531075    ,   0.8197439    ,   0.8850222    
     +,   0.9464051    ,    1.003161    ,    1.057958    
     +,    1.117203    ,    1.189035    ,    1.279466    
     +,    1.389400    ,    1.514883    ,    1.649709    
     +,    1.788239    ,    1.929335    ,    2.082142    
     +,    2.268848    ,    2.517327    ,    2.837979    
     +,    3.203974    ,    3.587050    ,    4.007792    
     +,    4.475536    ,    4.927892    ,    5.322930    
     +,    5.694773    ,    6.087243    ,    6.411814    
     +,    6.453823    ,    6.234670    ,    6.021419    
     +,    5.873267    ,    5.643732    ,    5.306359    
     +,    4.941759    ,    4.570250    ,    4.163911    
     +,    3.709463    ,    3.208233    ,    2.689164    
     +,    2.203176    ,    1.780091    ,    1.419977    
     +,    1.117492    ,   0.8713331    ,   0.6783354    
     +,   0.5307307    ,   0.4185561    ,   0.3324749    
     +,   0.2651468    ,   0.2114280    ,   0.1679814    
     +,   0.1326814    ,   0.1040844    ,   8.1087284E-02
     +,   6.2762864E-02,   4.8300691E-02,   3.6992401E-02
     +,   2.8228769E-02,   2.1494459E-02,   1.6358675E-02
     +,   1.2467329E-02,   9.5339539E-03,   7.3301499E-03
     +,   5.6767478E-03,   4.4355802E-03,   3.5016835E-03
     +,   2.7961726E-03,   2.2602424E-03,   1.8503155E-03
     +,   1.5341736E-03,   1.2879154E-03,   1.0938430E-03
     +,   9.3878718E-04,   8.1298902E-04,   7.0920499E-04
     +,   6.2210910E-04,   5.4779067E-04,   4.8341838E-04
     +,   4.2694356E-04,   3.7690467E-04,   3.3225119E-04
     +,   2.9222711E-04,   2.5628178E-04,   2.2399513E-04
     +,   1.9503944E-04,   1.6913818E-04,   1.4605249E-04
     +,   1.2556057E-04,   1.0745599E-04,   9.1538073E-05
     +,   7.7615230E-05,   6.5500455E-05,   5.5015727E-05
     +,   4.5989778E-05,   3.8261966E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_ashz_htt105_mass = Yx/35.07323316
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_ashz_htt107_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.8936921E-03,   2.9802411E-03
     +,   3.0671917E-03,   3.1544100E-03,   3.2417593E-03
     +,   3.3290996E-03,   3.4162886E-03,   3.5031845E-03
     +,   3.5896427E-03,   3.6755230E-03,   3.7606829E-03
     +,   3.8449834E-03,   3.9282907E-03,   4.0104729E-03
     +,   4.0914039E-03,   4.1709673E-03,   4.2490503E-03
     +,   4.3255491E-03,   4.4003725E-03,   4.4734376E-03
     +,   4.5446744E-03,   4.6140235E-03,   4.6814415E-03
     +,   4.7469041E-03,   4.8103919E-03,   4.8719160E-03
     +,   4.9314955E-03,   4.9891737E-03,   5.0450102E-03
     +,   5.0990889E-03,   5.1515135E-03,   5.2024107E-03
     +,   5.2519310E-03,   5.3002504E-03,   5.3475648E-03
     +,   5.3940993E-03,   5.4401048E-03,   5.4858583E-03
     +,   5.5316617E-03,   5.5778455E-03,   5.6247665E-03
     +,   5.6728055E-03,   5.7223747E-03,   5.7739080E-03
     +,   5.8278646E-03,   5.8847293E-03,   5.9450059E-03
     +,   6.0092211E-03,   6.0779201E-03,   6.1516636E-03
     +,   6.2310230E-03,   6.3165831E-03,   6.4089280E-03
     +,   6.5086517E-03,   6.6163340E-03,   6.7325546E-03
     +,   6.8578711E-03,   6.9928248E-03,   7.1379244E-03
     +,   7.2936448E-03,   7.4604214E-03,   7.6386379E-03
     +,   7.8286091E-03,   8.0305971E-03,   8.2447948E-03
     +,   8.4712934E-03,   8.7101180E-03,   8.9611765E-03
     +,   9.2242984E-03,   9.4991848E-03,   9.7854594E-03
     +,   1.0082586E-02,   1.0389962E-02,   1.0706825E-02
     +,   1.1032332E-02,   1.1365532E-02,   1.1705337E-02
     +,   1.2050571E-02,   1.2399977E-02,   1.2752224E-02
     +,   1.3105880E-02,   1.3459493E-02,   1.3811535E-02
     +,   1.4160481E-02,   1.4504774E-02,   1.4842895E-02
     +,   1.5173325E-02,   1.5494631E-02,   1.5805405E-02
     +,   1.6104365E-02,   1.6390339E-02,   1.6662253E-02
     +,   1.6919198E-02,   1.7160442E-02,   1.7385406E-02
     +,   1.7593719E-02,   1.7785223E-02,   1.7959950E-02
     +,   1.8118182E-02,   1.8260425E-02,   1.8387401E-02
     +,   1.8500099E-02,   1.8599726E-02,   1.8687721E-02
     +,   1.8765761E-02,   1.8835757E-02,   1.8899800E-02
     +,   1.8960215E-02,   1.9019507E-02,   1.9080354E-02
     +,   1.9145589E-02,   1.9218177E-02,   1.9301197E-02
     +,   1.9397814E-02,   1.9511221E-02,   1.9644653E-02
     +,   1.9801307E-02,   1.9984329E-02,   2.0196723E-02
     +,   2.0441361E-02,   2.0720894E-02,   2.1037677E-02
     +,   2.1393716E-02,   2.1790659E-02,   2.2229688E-02
     +,   2.2711433E-02,   2.3235977E-02,   2.3802735E-02
     +,   2.4410497E-02,   2.5057269E-02,   2.5740379E-02
     +,   2.6456339E-02,   2.7200958E-02,   2.7969252E-02
     +,   2.8755574E-02,   2.9553639E-02,   3.0356549E-02
     +,   3.1156875E-02,   3.1946916E-02,   3.2718670E-02
     +,   3.3464003E-02,   3.4174770E-02,   3.4843083E-02
     +,   3.5461396E-02,   3.6022577E-02,   3.6520224E-02
     +,   3.6948729E-02,   3.7303347E-02,   3.7580416E-02
     +,   3.7777439E-02,   3.7893105E-02,   3.7927411E-02
     +,   3.7881650E-02,   3.7758507E-02,   3.7561987E-02
     +,   3.7297398E-02,   3.6971450E-02,   3.6592070E-02
     +,   3.6168452E-02,   3.5711069E-02,   3.5231512E-02
     +,   3.4742609E-02,   3.4258302E-02,   3.3793729E-02
     +,   3.3365063E-02,   3.2989621E-02,   3.2685798E-02
     +,   3.2472976E-02,   3.2371480E-02,   3.2402400E-02
     +,   3.2587513E-02,   3.2948982E-02,   3.3509154E-02
     +,   3.4290310E-02,   3.5314247E-02,   3.6602259E-02
     +,   3.8174909E-02,   4.0051963E-02,   4.2252831E-02
     +,   4.4797361E-02,   4.7706969E-02,   5.1006172E-02
     +,   5.4725002E-02,   5.8902130E-02,   6.3587822E-02
     +,   6.8846785E-02,   7.4760914E-02,   8.1431225E-02
     +,   8.8976711E-02,   9.7530313E-02,   0.1072331    
     +,   0.1182238    ,   0.1306246    ,   0.1445278    
     +,   0.1599840    ,   0.1769928    ,   0.1954992    
     +,   0.2153988    ,   0.2365501    ,   0.2587855    
     +,   0.2819206    ,   0.3057638    ,   0.3301236    
     +,   0.3548168    ,   0.3796886    ,   0.4046595    
     +,   0.4297810    ,   0.4553102    ,   0.4817792    
     +,   0.5100602    ,   0.5414127    ,   0.5774937    
     +,   0.6203036    ,   0.6719768    ,   0.7343495    
     +,   0.8083014    ,   0.8931193    ,   0.9862826    
     +,    1.084027    ,    1.182576    ,    1.279374    
     +,    1.373577    ,    1.465937    ,    1.559017    
     +,    1.658243    ,    1.773190    ,    1.918027    
     +,    2.109046    ,    2.355450    ,    2.645135    
     +,    2.944046    ,    3.228352    ,    3.524588    
     +,    3.891161    ,    4.345845    ,    4.857024    
     +,    5.406321    ,    5.953398    ,    6.362552    
     +,    6.541058    ,    6.565952    ,    6.511746    
     +,    6.335615    ,    6.028346    ,    5.647453    
     +,    5.183473    ,    4.586654    ,    3.887543    
     +,    3.182853    ,    2.540028    ,    1.974408    
     +,    1.490609    ,    1.099571    ,   0.8050861    
     +,   0.5954428    ,   0.4493050    ,   0.3456365    
     +,   0.2691244    ,   0.2103894    ,   0.1641190    
     +,   0.1273224    ,   9.8199241E-02,   7.5483233E-02
     +,   5.8102850E-02,   4.5052990E-02,   3.5386954E-02
     +,   2.8262500E-02,   2.2982623E-02,   1.9009601E-02
     +,   1.5953146E-02,   1.3543104E-02,   1.1597711E-02
     +,   9.9954559E-03,   8.6540915E-03,   7.5166579E-03
     +,   6.5426389E-03,   5.7022595E-03,   4.9733212E-03
     +,   4.3387357E-03,   3.7851844E-03,   3.3018512E-03
     +,   2.8798168E-03,   2.5114052E-03,   2.1899813E-03
     +,   1.9096496E-03,   1.6652236E-03,   1.4520902E-03
     +,   1.2661888E-03,   1.1039810E-03,   9.6236437E-04
     +,   8.3866878E-04,   7.3056936E-04,   6.3607260E-04
     +,   5.5344438E-04,   4.8119467E-04,   4.1802181E-04
     +,   3.6280209E-04,   3.1454882E-04,   2.7240583E-04
     +,   2.3561831E-04,   2.0352943E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_ashz_htt107_mass = Yx/32.9904925714286
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_ashz_htt110_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  6.4762612E-04,   6.7551143E-04
     +,   7.0447352E-04,   7.3453301E-04,   7.6570816E-04
     +,   7.9801516E-04,   8.3146757E-04,   8.6607679E-04
     +,   9.0185046E-04,   9.3879492E-04,   9.7691140E-04
     +,   1.0161988E-03,   1.0566515E-03,   1.0982612E-03
     +,   1.1410152E-03,   1.1848964E-03,   1.2298843E-03
     +,   1.2759540E-03,   1.3230762E-03,   1.3712179E-03
     +,   1.4203413E-03,   1.4704055E-03,   1.5213642E-03
     +,   1.5731708E-03,   1.6257697E-03,   1.6791078E-03
     +,   1.7331257E-03,   1.7877623E-03,   1.8429542E-03
     +,   1.8986374E-03,   1.9547467E-03,   2.0112148E-03
     +,   2.0679766E-03,   2.1249685E-03,   2.1821265E-03
     +,   2.2393905E-03,   2.2967046E-03,   2.3540154E-03
     +,   2.4112784E-03,   2.4684516E-03,   2.5255040E-03
     +,   2.5824122E-03,   2.6391631E-03,   2.6957532E-03
     +,   2.7521937E-03,   2.8085099E-03,   2.8647403E-03
     +,   2.9209403E-03,   2.9771852E-03,   3.0335688E-03
     +,   3.0902035E-03,   3.1472268E-03,   3.2047969E-03
     +,   3.2631007E-03,   3.3223471E-03,   3.3827766E-03
     +,   3.4446558E-03,   3.5082840E-03,   3.5739890E-03
     +,   3.6421334E-03,   3.7131133E-03,   3.7873578E-03
     +,   3.8653298E-03,   3.9475304E-03,   4.0345001E-03
     +,   4.1268049E-03,   4.2250575E-03,   4.3298961E-03
     +,   4.4420036E-03,   4.5620850E-03,   4.6908879E-03
     +,   4.8291758E-03,   4.9777576E-03,   5.1374440E-03
     +,   5.3090826E-03,   5.4935380E-03,   5.6916797E-03
     +,   5.9043719E-03,   6.1325035E-03,   6.3769603E-03
     +,   6.6385833E-03,   6.9182375E-03,   7.2167292E-03
     +,   7.5348634E-03,   7.8733675E-03,   8.2329642E-03
     +,   8.6142737E-03,   9.0179006E-03,   9.4443252E-03
     +,   9.8939892E-03,   1.0367253E-02,   1.0864330E-02
     +,   1.1385347E-02,   1.1930353E-02,   1.2499266E-02
     +,   1.3091834E-02,   1.3707745E-02,   1.4346465E-02
     +,   1.5007406E-02,   1.5689736E-02,   1.6392564E-02
     +,   1.7114732E-02,   1.7855039E-02,   1.8612010E-02
     +,   1.9384060E-02,   2.0169487E-02,   2.0966336E-02
     +,   2.1772522E-02,   2.2585871E-02,   2.3404047E-02
     +,   2.4224561E-02,   2.5044886E-02,   2.5862357E-02
     +,   2.6674351E-02,   2.7478134E-02,   2.8271077E-02
     +,   2.9050542E-02,   2.9814070E-02,   3.0559286E-02
     +,   3.1284045E-02,   3.1986468E-02,   3.2664921E-02
     +,   3.3318106E-02,   3.3945106E-02,   3.4545455E-02
     +,   3.5119012E-02,   3.5666171E-02,   3.6187708E-02
     +,   3.6684901E-02,   3.7159376E-02,   3.7613202E-02
     +,   3.8048748E-02,   3.8468666E-02,   3.8875796E-02
     +,   3.9273113E-02,   3.9663598E-02,   4.0050171E-02
     +,   4.0435486E-02,   4.0822007E-02,   4.1211776E-02
     +,   4.1606292E-02,   4.2006575E-02,   4.2412933E-02
     +,   4.2825073E-02,   4.3241903E-02,   4.3661688E-02
     +,   4.4082019E-02,   4.4499788E-02,   4.4911355E-02
     +,   4.5312673E-02,   4.5699380E-02,   4.6066906E-02
     +,   4.6410732E-02,   4.6726588E-02,   4.7010645E-02
     +,   4.7259700E-02,   4.7471482E-02,   4.7644820E-02
     +,   4.7779903E-02,   4.7878552E-02,   4.7944203E-02
     +,   4.7982313E-02,   4.8000339E-02,   4.8007857E-02
     +,   4.8016608E-02,   4.8040535E-02,   4.8095636E-02
     +,   4.8200034E-02,   4.8373830E-02,   4.8639171E-02
     +,   4.9020372E-02,   4.9543899E-02,   5.0239071E-02
     +,   5.1138561E-02,   5.2279297E-02,   5.3703874E-02
     +,   5.5462148E-02,   5.7613235E-02,   6.0227986E-02
     +,   6.3391931E-02,   6.7208350E-02,   7.1801089E-02
     +,   7.7317312E-02,   8.3929665E-02,   9.1835544E-02
     +,   0.1012531    ,   0.1124121    ,   0.1255404    
     +,   0.1408417    ,   0.1584653    ,   0.1784786    
     +,   0.2008373    ,   0.2253628    ,   0.2517393    
     +,   0.2795300    ,   0.3082125    ,   0.3372312    
     +,   0.3660706    ,   0.3943365    ,   0.4218367    
     +,   0.4486504    ,   0.4751785    ,   0.5021409    
     +,   0.5305126    ,   0.5614046    ,   0.5959185    
     +,   0.6349901    ,   0.6792243    ,   0.7287190    
     +,   0.7828712    ,   0.8402849    ,   0.8989850    
     +,   0.9570730    ,    1.013607    ,    1.069032    
     +,    1.124502    ,    1.180160    ,    1.233607    
     +,    1.280382    ,    1.317115    ,    1.345777    
     +,    1.375791    ,    1.422019    ,    1.499217    
     +,    1.615375    ,    1.766660    ,    1.937331    
     +,    2.108270    ,    2.273197    ,    2.449622    
     +,    2.663003    ,    2.904188    ,    3.114405    
     +,    3.252118    ,    3.375304    ,    3.599238    
     +,    3.949019    ,    4.295526    ,    4.463120    
     +,    4.393569    ,    4.187383    ,    3.976873    
     +,    3.805841    ,    3.655964    ,    3.514036    
     +,    3.373646    ,    3.217785    ,    3.020441    
     +,    2.756369    ,    2.419646    ,    2.038452    
     +,    1.661707    ,    1.329007    ,    1.054709    
     +,   0.8340033    ,   0.6564376    ,   0.5137229    
     +,   0.4002789    ,   0.3113717    ,   0.2423044    
     +,   0.1887500    ,   0.1471757    ,   0.1148868    
     +,   8.9832664E-02,   7.0404425E-02,   5.5313330E-02
     +,   4.3539971E-02,   3.4300137E-02,   2.7006567E-02
     +,   2.1226818E-02,   1.6642988E-02,   1.3017477E-02
     +,   1.0166923E-02,   7.9447841E-03,   6.2307031E-03
     +,   4.9241399E-03,   3.9402531E-03,   3.2080470E-03
     +,   2.6685880E-03,   2.2739680E-03,   1.9859360E-03
     +,   1.7747439E-03,   1.6177656E-03,   1.4982716E-03
     +,   1.4041836E-03,   1.3270370E-03,   1.2610471E-03
     +,   1.2023814E-03,   1.1485862E-03,   1.0981392E-03
     +,   1.0501486E-03,   1.0041165E-03,   9.5979881E-04
     +,   9.1709144E-04,   8.7597681E-04,   8.3647016E-04
     +,   7.9860596E-04,   7.6241215E-04,   7.2791259E-04
     +,   6.9511286E-04,   6.6400872E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_ashz_htt110_mass = Yx/28.492723
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_ashz_htt115_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.0537402E-03,   1.0832151E-03
     +,   1.1134727E-03,   1.1445223E-03,   1.1763721E-03
     +,   1.2090286E-03,   1.2424979E-03,   1.2767839E-03
     +,   1.3118887E-03,   1.3478150E-03,   1.3845618E-03
     +,   1.4221271E-03,   1.4605072E-03,   1.4996968E-03
     +,   1.5396883E-03,   1.5804723E-03,   1.6220382E-03
     +,   1.6643725E-03,   1.7074596E-03,   1.7512825E-03
     +,   1.7958218E-03,   1.8410555E-03,   1.8869591E-03
     +,   1.9335096E-03,   1.9806756E-03,   2.0284289E-03
     +,   2.0767371E-03,   2.1255659E-03,   2.1748790E-03
     +,   2.2246374E-03,   2.2748022E-03,   2.3253311E-03
     +,   2.3761808E-03,   2.4273060E-03,   2.4786608E-03
     +,   2.5301971E-03,   2.5818667E-03,   2.6336187E-03
     +,   2.6854060E-03,   2.7371738E-03,   2.7888743E-03
     +,   2.8404559E-03,   2.8918684E-03,   2.9430615E-03
     +,   2.9939869E-03,   3.0445966E-03,   3.0948468E-03
     +,   3.1446929E-03,   3.1940944E-03,   3.2430147E-03
     +,   3.2914192E-03,   3.3392794E-03,   3.3865687E-03
     +,   3.4332708E-03,   3.4793701E-03,   3.5248601E-03
     +,   3.5697424E-03,   3.6140271E-03,   3.6577322E-03
     +,   3.7008862E-03,   3.7435270E-03,   3.7857087E-03
     +,   3.8274934E-03,   3.8689608E-03,   3.9102039E-03
     +,   3.9513321E-03,   3.9924742E-03,   4.0337737E-03
     +,   4.0753996E-03,   4.1175368E-03,   4.1603972E-03
     +,   4.2042141E-03,   4.2492491E-03,   4.2957845E-03
     +,   4.3441365E-03,   4.3946491E-03,   4.4476930E-03
     +,   4.5036715E-03,   4.5630224E-03,   4.6262164E-03
     +,   4.6937512E-03,   4.7661667E-03,   4.8440276E-03
     +,   4.9279444E-03,   5.0185481E-03,   5.1165177E-03
     +,   5.2225492E-03,   5.3373873E-03,   5.4617901E-03
     +,   5.5965642E-03,   5.7425359E-03,   5.9005548E-03
     +,   6.0715033E-03,   6.2562828E-03,   6.4558289E-03
     +,   6.6710757E-03,   6.9030048E-03,   7.1525848E-03
     +,   7.4208230E-03,   7.7087143E-03,   8.0172913E-03
     +,   8.3475560E-03,   8.7005505E-03,   9.0772687E-03
     +,   9.4787320E-03,   9.9059409E-03,   1.0359855E-02
     +,   1.0841390E-02,   1.1351453E-02,   1.1890895E-02
     +,   1.2460450E-02,   1.3060829E-02,   1.3692576E-02
     +,   1.4356195E-02,   1.5051961E-02,   1.5780089E-02
     +,   1.6540518E-02,   1.7333077E-02,   1.8157290E-02
     +,   1.9012524E-02,   1.9897874E-02,   2.0812130E-02
     +,   2.1753795E-02,   2.2721129E-02,   2.3712117E-02
     +,   2.4724353E-02,   2.5755245E-02,   2.6801817E-02
     +,   2.7860949E-02,   2.8929101E-02,   3.0002696E-02
     +,   3.1077754E-02,   3.2150295E-02,   3.3216063E-02
     +,   3.4270775E-02,   3.5310101E-02,   3.6329616E-02
     +,   3.7324913E-02,   3.8291723E-02,   3.9225880E-02
     +,   4.0123317E-02,   4.0980201E-02,   4.1793030E-02
     +,   4.2558588E-02,   4.3274015E-02,   4.3936972E-02
     +,   4.4545643E-02,   4.5098748E-02,   4.5595739E-02
     +,   4.6036817E-02,   4.6423066E-02,   4.6756502E-02
     +,   4.7040112E-02,   4.7278091E-02,   4.7475796E-02
     +,   4.7639791E-02,   4.7778063E-02,   4.7899839E-02
     +,   4.8015729E-02,   4.8137609E-02,   4.8278581E-02
     +,   4.8452932E-02,   4.8675809E-02,   4.8963208E-02
     +,   4.9331661E-02,   4.9798101E-02,   5.0379574E-02
     +,   5.1093038E-02,   5.1955245E-02,   5.2982599E-02
     +,   5.4191016E-02,   5.5595938E-02,   5.7212364E-02
     +,   5.9055045E-02,   6.1138164E-02,   6.3475780E-02
     +,   6.6081822E-02,   6.8969741E-02,   7.2152734E-02
     +,   7.5643688E-02,   7.9455189E-02,   8.3598897E-02
     +,   8.8086039E-02,   9.2927508E-02,   9.8134354E-02
     +,   0.1037177    ,   0.1096903    ,   0.1160689    
     +,   0.1228772    ,   0.1301494    ,   0.1379379    
     +,   0.1463190    ,   0.1553977    ,   0.1653105    
     +,   0.1762220    ,   0.1883108    ,   0.2017493    
     +,   0.2166793    ,   0.2331939    ,   0.2513353    
     +,   0.2711196    ,   0.2925965    ,   0.3159353    
     +,   0.3415085    ,   0.3699329    ,   0.4020364    
     +,   0.4387017    ,   0.4805931    ,   0.5278195    
     +,   0.5796185    ,   0.6341736    ,   0.6886720    
     +,   0.7396829    ,   0.7838496    ,   0.8188043    
     +,   0.8441435    ,   0.8621767    ,   0.8781162    
     +,   0.8993509    ,   0.9337557    ,   0.9873843    
     +,    1.062325    ,    1.155528    ,    1.259256    
     +,    1.363737    ,    1.461944    ,    1.554296    
     +,    1.648960    ,    1.755518    ,    1.876338    
     +,    2.003919    ,    2.126441    ,    2.233603    
     +,    2.316181    ,    2.365396    ,    2.382037    
     +,    2.389446    ,    2.428026    ,    2.519597    
     +,    2.633523    ,    2.706735    ,    2.708846    
     +,    2.671248    ,    2.640662    ,    2.621116    
     +,    2.573989    ,    2.461213    ,    2.276537    
     +,    2.044100    ,    1.799499    ,    1.571195    
     +,    1.371135    ,    1.196299    ,    1.037214    
     +,   0.8863288    ,   0.7416716    ,   0.6059822    
     +,   0.4838777    ,   0.3792274    ,   0.2936661    
     +,   0.2263661    ,   0.1747387    ,   0.1355051    
     +,   0.1055932    ,   8.2587034E-02,   6.4766698E-02
     +,   5.0947756E-02,   4.0282100E-02,   3.2112196E-02
     +,   2.5894955E-02,   2.1174176E-02,   1.7573591E-02
     +,   1.4793900E-02,   1.2607134E-02,   1.0847092E-02
     +,   9.3971388E-03,   8.1773065E-03,   7.1337419E-03
     +,   6.2297899E-03,   5.4401183E-03,   4.7463677E-03
     +,   4.1348110E-03,   3.5946113E-03,   3.1170691E-03
     +,   2.6949197E-03,   2.3220901E-03,   1.9933407E-03
     +,   1.7041230E-03,   1.4504530E-03,   1.2287364E-03
     +,   1.0357499E-03,   8.6852396E-04,   7.2434888E-04
     +,   6.0070271E-04,   4.9527094E-04,   4.0590097E-04
     +,   3.3062231E-04,   2.6761828E-04,   2.1524176E-04
     +,   1.7199418E-04,   1.3653560E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_ashz_htt115_mass = Yx/20.9854223478261
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_ashz_htt120_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.0690344E-03,   1.1286701E-03
     +,   1.1906797E-03,   1.2550993E-03,   1.3219623E-03
     +,   1.3912986E-03,   1.4631345E-03,   1.5374934E-03
     +,   1.6143924E-03,   1.6938486E-03,   1.7758708E-03
     +,   1.8604632E-03,   1.9476255E-03,   2.0373513E-03
     +,   2.1296276E-03,   2.2244356E-03,   2.3217483E-03
     +,   2.4215318E-03,   2.5237452E-03,   2.6283376E-03
     +,   2.7352490E-03,   2.8444119E-03,   2.9557464E-03
     +,   3.0691684E-03,   3.1845728E-03,   3.3018542E-03
     +,   3.4208901E-03,   3.5415469E-03,   3.6636798E-03
     +,   3.7871317E-03,   3.9117346E-03,   4.0373066E-03
     +,   4.1636536E-03,   4.2905710E-03,   4.4178427E-03
     +,   4.5452383E-03,   4.6725189E-03,   4.7994331E-03
     +,   4.9257269E-03,   5.0511248E-03,   5.1753549E-03
     +,   5.2981349E-03,   5.4191751E-03,   5.5381837E-03
     +,   5.6548668E-03,   5.7689291E-03,   5.8800741E-03
     +,   5.9880139E-03,   6.0924604E-03,   6.1931340E-03
     +,   6.2897671E-03,   6.3820998E-03,   6.4698891E-03
     +,   6.5529123E-03,   6.6309539E-03,   6.7038354E-03
     +,   6.7713913E-03,   6.8334886E-03,   6.8900227E-03
     +,   6.9409185E-03,   6.9861375E-03,   7.0256777E-03
     +,   7.0595755E-03,   7.0879078E-03,   7.1107983E-03
     +,   7.1284072E-03,   7.1409494E-03,   7.1486817E-03
     +,   7.1519124E-03,   7.1509983E-03,   7.1463459E-03
     +,   7.1384138E-03,   7.1277097E-03,   7.1147918E-03
     +,   7.1002650E-03,   7.0847883E-03,   7.0690592E-03
     +,   7.0538246E-03,   7.0398725E-03,   7.0280270E-03
     +,   7.0191547E-03,   7.0141442E-03,   7.0139160E-03
     +,   7.0194127E-03,   7.0315921E-03,   7.0514218E-03
     +,   7.0798732E-03,   7.1179154E-03,   7.1665035E-03
     +,   7.2265728E-03,   7.2990363E-03,   7.3847678E-03
     +,   7.4845874E-03,   7.5992695E-03,   7.7295299E-03
     +,   7.8759911E-03,   8.0392137E-03,   8.2196454E-03
     +,   8.4176585E-03,   8.6334841E-03,   8.8672740E-03
     +,   9.1190245E-03,   9.3886312E-03,   9.6758259E-03
     +,   9.9802325E-03,   1.0301337E-02,   1.0638468E-02
     +,   1.0990821E-02,   1.1357471E-02,   1.1737382E-02
     +,   1.2129349E-02,   1.2532116E-02,   1.2944272E-02
     +,   1.3364371E-02,   1.3790849E-02,   1.4222135E-02
     +,   1.4656580E-02,   1.5092555E-02,   1.5528394E-02
     +,   1.5962496E-02,   1.6393306E-02,   1.6819308E-02
     +,   1.7239081E-02,   1.7651347E-02,   1.8054955E-02
     +,   1.8448859E-02,   1.8832264E-02,   1.9204471E-02
     +,   1.9565050E-02,   1.9913722E-02,   2.0250458E-02
     +,   2.0575427E-02,   2.0889014E-02,   2.1191796E-02
     +,   2.1484585E-02,   2.1768352E-02,   2.2044232E-02
     +,   2.2313507E-02,   2.2577584E-02,   2.2837970E-02
     +,   2.3096208E-02,   2.3353860E-02,   2.3612496E-02
     +,   2.3873622E-02,   2.4138631E-02,   2.4408812E-02
     +,   2.4685308E-02,   2.4969026E-02,   2.5260642E-02
     +,   2.5560612E-02,   2.5869161E-02,   2.6186192E-02
     +,   2.6511373E-02,   2.6844146E-02,   2.7183749E-02
     +,   2.7529245E-02,   2.7879603E-02,   2.8233794E-02
     +,   2.8590912E-02,   2.8950218E-02,   2.9311359E-02
     +,   2.9674569E-02,   3.0040748E-02,   3.0411776E-02
     +,   3.0790741E-02,   3.1182170E-02,   3.1592324E-02
     +,   3.2029394E-02,   3.2503881E-02,   3.3028767E-02
     +,   3.3619635E-02,   3.4294818E-02,   3.5075400E-02
     +,   3.5985075E-02,   3.7049633E-02,   3.8296685E-02
     +,   3.9754692E-02,   4.1451987E-02,   4.3415423E-02
     +,   4.5669224E-02,   4.8233215E-02,   5.1121078E-02
     +,   5.4338783E-02,   5.7883494E-02,   6.1742302E-02
     +,   6.5891355E-02,   7.0295900E-02,   7.4911550E-02
     +,   7.9685554E-02,   8.4559120E-02,   8.9472204E-02
     +,   9.4368570E-02,   9.9202186E-02,   0.1039461    
     +,   0.1086023    ,   0.1132111    ,   0.1178603    
     +,   0.1226930    ,   0.1279097    ,   0.1337661    
     +,   0.1405607    ,   0.1486187    ,   0.1582657    
     +,   0.1697971    ,   0.1834415    ,   0.1993273    
     +,   0.2174496    ,   0.2376469    ,   0.2596038    
     +,   0.2828867    ,   0.3070244    ,   0.3316250    
     +,   0.3565093    ,   0.3818074    ,   0.4079589    
     +,   0.4355881    ,   0.4652876    ,   0.4973933    
     +,   0.5318589    ,   0.5683018    ,   0.6062092    
     +,   0.6451571    ,   0.6849309    ,   0.7254588    
     +,   0.7665700    ,   0.8077054    ,   0.8477810    
     +,   0.8854157    ,   0.9195034    ,   0.9499154    
     +,   0.9779928    ,    1.006614    ,    1.039716    
     +,    1.081427    ,    1.135617    ,    1.206875    
     +,    1.301875    ,    1.427183    ,    1.581225    
     +,    1.746164    ,    1.890226    ,    1.982759    
     +,    2.010174    ,    1.979349    ,    1.908644    
     +,    1.817270    ,    1.719827    ,    1.624480    
     +,    1.532303    ,    1.438799    ,    1.338183    
     +,    1.227787    ,    1.109519    ,   0.9883522    
     +,   0.8698949    ,   0.7586849    ,   0.6575003    
     +,   0.5673648    ,   0.4879598    ,   0.4182462    
     +,   0.3570595    ,   0.3034537    ,   0.2567387    
     +,   0.2163417    ,   0.1816680    ,   0.1520523    
     +,   0.1268151    ,   0.1053398    ,   8.7113768E-02
     +,   7.1728274E-02,   5.8849987E-02,   4.8184697E-02
     +,   3.9449971E-02,   3.2364592E-02,   2.6653094E-02
     +,   2.2057174E-02,   1.8346246E-02,   1.5326860E-02
     +,   1.2844283E-02,   1.0780893E-02,   9.0498496E-03
     +,   7.5885672E-03,   6.3514109E-03,   5.3043659E-03
     +,   4.4205273E-03,   3.6776019E-03,   3.0560787E-03
     +,   2.5385383E-03,   2.1093434E-03,   1.7544494E-03
     +,   1.4615075E-03,   1.2197588E-03,   1.0200574E-03
     +,   8.5470319E-04,   7.1735447E-04,   6.0281728E-04
     +,   5.0691271E-04,   4.2627871E-04,   3.5824263E-04
     +,   3.0066460E-04,   2.5184159E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_ashz_htt120_mass = Yx/13.8377839534884
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_ashz_htt60_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.6176153E-02,   3.9990500E-02
     +,   4.4128448E-02,   4.8623238E-02,   5.3518903E-02
     +,   5.8874480E-02,   6.4769208E-02,   7.1308710E-02
     +,   7.8631096E-02,   8.6913198E-02,   9.6373931E-02
     +,   0.1072755    ,   0.1199198    ,   0.1346409    
     +,   0.1517950    ,   0.1717518    ,   0.1948931    
     +,   0.2216232    ,   0.2523916    ,   0.2877208    
     +,   0.3282236    ,   0.3745920    ,   0.4275489    
     +,   0.4877835    ,   0.5558847    ,   0.6323750    
     +,   0.7177886    ,   0.8127905    ,   0.9181754    
     +,    1.034616    ,    1.162151    ,    1.299590    
     +,    1.444145    ,    1.591514    ,    1.736470    
     +,    1.873791    ,    1.999323    ,    2.111050    
     +,    2.209762    ,    2.298583    ,    2.380900    
     +,    2.457143    ,    2.522413    ,    2.567061    
     +,    2.580600    ,    2.556937    ,    2.497518    
     +,    2.410607    ,    2.307265    ,    2.196854    
     +,    2.084524    ,    1.971666    ,    1.858212    
     +,    1.744896    ,    1.634099    ,    1.529038    
     +,    1.432322    ,    1.344854    ,    1.265759    
     +,    1.193074    ,    1.124711    ,    1.059163    
     +,   0.9957911    ,   0.9347471    ,   0.8767197    
     +,   0.8226277    ,   0.7732936    ,   0.7292110    
     +,   0.6903723    ,   0.6562647    ,   0.6259822    
     +,   0.5984434    ,   0.5726182    ,   0.5477127    
     +,   0.5232528    ,   0.4990912    ,   0.4753495    
     +,   0.4523270    ,   0.4304067    ,   0.4099788    
     +,   0.3913789    ,   0.3748435    ,   0.3604951    
     +,   0.3483318    ,   0.3382445    ,   0.3300357    
     +,   0.3234496    ,   0.3181981    ,   0.3139879    
     +,   0.3105383    ,   0.3075950    ,   0.3049385    
     +,   0.3023862    ,   0.2997927    ,   0.2970495    
     +,   0.2940826    ,   0.2908482    ,   0.2873321    
     +,   0.2835433    ,   0.2795113    ,   0.2752805    
     +,   0.2709055    ,   0.2664436    ,   0.2619523    
     +,   0.2574828    ,   0.2530773    ,   0.2487664    
     +,   0.2445695    ,   0.2404944    ,   0.2365395    
     +,   0.2326978    ,   0.2289589    ,   0.2253125    
     +,   0.2217508    ,   0.2182713    ,   0.2148753    
     +,   0.2115701    ,   0.2083655    ,   0.2052735    
     +,   0.2023047    ,   0.1994668    ,   0.1967615    
     +,   0.1941843    ,   0.1917221    ,   0.1893547    
     +,   0.1870548    ,   0.1847893    ,   0.1825221    
     +,   0.1802153    ,   0.1778330    ,   0.1753416    
     +,   0.1727138    ,   0.1699281    ,   0.1669715    
     +,   0.1638385    ,   0.1605317    ,   0.1570613    
     +,   0.1534441    ,   0.1497019    ,   0.1458605    
     +,   0.1419484    ,   0.1379953    ,   0.1340305    
     +,   0.1300818    ,   0.1261755    ,   0.1223342    
     +,   0.1185773    ,   0.1149205    ,   0.1113761    
     +,   0.1079520    ,   0.1046531    ,   0.1014813    
     +,   9.8435998E-02,   9.5514238E-02,   9.2711419E-02
     +,   9.0022221E-02,   8.7440543E-02,   8.4959902E-02
     +,   8.2573980E-02,   8.0277026E-02,   7.8063771E-02
     +,   7.5929619E-02,   7.3870972E-02,   7.1885191E-02
     +,   6.9970250E-02,   6.8125069E-02,   6.6349216E-02
     +,   6.4643189E-02,   6.3007660E-02,   6.1443921E-02
     +,   5.9953544E-02,   5.8538407E-02,   5.7200443E-02
     +,   5.5941436E-02,   5.4763459E-02,   5.3668089E-02
     +,   5.2656837E-02,   5.1731013E-02,   5.0891452E-02
     +,   5.0138701E-02,   4.9472850E-02,   4.8893500E-02
     +,   4.8399873E-02,   4.7990628E-02,   4.7663897E-02
     +,   4.7417331E-02,   4.7248092E-02,   4.7152754E-02
     +,   4.7127429E-02,   4.7167782E-02,   4.7268957E-02
     +,   4.7425672E-02,   4.7632303E-02,   4.7882762E-02
     +,   4.8170667E-02,   4.8489399E-02,   4.8832029E-02
     +,   4.9191415E-02,   4.9560338E-02,   4.9931433E-02
     +,   5.0297331E-02,   5.0650623E-02,   5.0984036E-02
     +,   5.1290426E-02,   5.1562808E-02,   5.1794492E-02
     +,   5.1979091E-02,   5.2110597E-02,   5.2183423E-02
     +,   5.2192528E-02,   5.2133370E-02,   5.2002020E-02
     +,   5.1795192E-02,   5.1510286E-02,   5.1145341E-02
     +,   5.0699238E-02,   5.0171539E-02,   4.9562532E-02
     +,   4.8873268E-02,   4.8105568E-02,   4.7261894E-02
     +,   4.6345379E-02,   4.5359865E-02,   4.4309698E-02
     +,   4.3199781E-02,   4.2035401E-02,   4.0822323E-02
     +,   3.9566610E-02,   3.8274508E-02,   3.6952399E-02
     +,   3.5606828E-02,   3.4244355E-02,   3.2871366E-02
     +,   3.1494092E-02,   3.0118736E-02,   2.8751055E-02
     +,   2.7396511E-02,   2.6060292E-02,   2.4747180E-02
     +,   2.3461437E-02,   2.2206893E-02,   2.0986978E-02
     +,   1.9804677E-02,   1.8662399E-02,   1.7562129E-02
     +,   1.6505461E-02,   1.5493552E-02,   1.4527108E-02
     +,   1.3606437E-02,   1.2731620E-02,   1.1902313E-02
     +,   1.1117895E-02,   1.0377565E-02,   9.6802730E-03
     +,   9.0247719E-03,   8.4096417E-03,   7.8333952E-03
     +,   7.2944406E-03,   6.7910920E-03,   6.3216160E-03
     +,   5.8842925E-03,   5.4773889E-03,   5.0991671E-03
     +,   4.7479095E-03,   4.4219815E-03,   4.1197552E-03
     +,   3.8396693E-03,   3.5802356E-03,   3.3400401E-03
     +,   3.1177124E-03,   2.9119670E-03,   2.7215956E-03
     +,   2.5454650E-03,   2.3825001E-03,   2.2316950E-03
     +,   2.0921279E-03,   1.9629211E-03,   1.8432763E-03
     +,   1.7324383E-03,   1.6297229E-03,   1.5344820E-03
     +,   1.4461332E-03,   1.3641258E-03,   1.2879637E-03
     +,   1.2171813E-03,   1.1513594E-03,   1.0901061E-03
     +,   1.0330630E-03,   9.7990537E-04,   9.3032967E-04
     +,   8.8406383E-04,   8.4085204E-04,   8.0046640E-04
     +,   7.6269230E-04,   7.2733819E-04,   6.9422356E-04
     +,   6.6318811E-04,   6.3407997E-04,   6.0676411E-04
     +,   5.8111263E-04,   5.5701198E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_ashz_htt60_mass = Yx/23.8035589787234
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_ashz_htt65_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.3516050E-02,   1.4513270E-02
     +,   1.5605018E-02,   1.6802000E-02,   1.8115869E-02
     +,   1.9559205E-02,   2.1145429E-02,   2.2888768E-02
     +,   2.4804071E-02,   2.6906796E-02,   2.9212700E-02
     +,   3.1737670E-02,   3.4497652E-02,   3.7508391E-02
     +,   4.0785406E-02,   4.4344019E-02,   4.8199575E-02
     +,   5.2367803E-02,   5.6865633E-02,   6.1712198E-02
     +,   6.6930287E-02,   7.2548330E-02,   7.8602143E-02
     +,   8.5137926E-02,   9.2212863E-02,   9.9897854E-02
     +,   0.1082763    ,   0.1174429    ,   0.1275000    
     +,   0.1385525    ,   0.1507025    ,   0.1640456    
     +,   0.1786720    ,   0.1946749    ,   0.2121719    
     +,   0.2313401    ,   0.2524673    ,   0.2760155    
     +,   0.3026915    ,   0.3335036    ,   0.3697951    
     +,   0.4132166    ,   0.4656226    ,   0.5288764    
     +,   0.6045679    ,   0.6937014    ,   0.7964559    
     +,   0.9121575    ,    1.039536    ,    1.177216    
     +,    1.324220    ,    1.480213    ,    1.645345    
     +,    1.819786    ,    2.003255    ,    2.194883    
     +,    2.392963    ,    2.593723    ,    2.788793    
     +,    2.963388    ,    3.098417    ,    3.177874    
     +,    3.197669    ,    3.169364    ,    3.115034    
     +,    3.055533    ,    2.999098    ,    2.937734    
     +,    2.854393    ,    2.736376    ,    2.585384    
     +,    2.417266    ,    2.252600    ,    2.106126    
     +,    1.981779    ,    1.874836    ,    1.777601    
     +,    1.684406    ,    1.593781    ,    1.507726    
     +,    1.429472    ,    1.361191    ,    1.302848    
     +,    1.252293    ,    1.206123    ,    1.160672    
     +,    1.112795    ,    1.060342    ,    1.002458    
     +,   0.9396324    ,   0.8735494    ,   0.8067143    
     +,   0.7419457    ,   0.6818523    ,   0.6284272    
     +,   0.5828389    ,   0.5453912    ,   0.5156705    
     +,   0.4927521    ,   0.4754317    ,   0.4624094    
     +,   0.4524261    ,   0.4443375    ,   0.4371571    
     +,   0.4300786    ,   0.4224898    ,   0.4139742    
     +,   0.4043078    ,   0.3934432    ,   0.3814820    
     +,   0.3686422    ,   0.3552160    ,   0.3415337    
     +,   0.3279273    ,   0.3147049    ,   0.3021272    
     +,   0.2903990    ,   0.2796605    ,   0.2699896    
     +,   0.2614050    ,   0.2538750    ,   0.2473276    
     +,   0.2416619    ,   0.2367583    ,   0.2324900    
     +,   0.2287321    ,   0.2253676    ,   0.2222933    
     +,   0.2194217    ,   0.2166818    ,   0.2140180    
     +,   0.2113888    ,   0.2087630    ,   0.2061187    
     +,   0.2034394    ,   0.2007129    ,   0.1979299    
     +,   0.1950821    ,   0.1921632    ,   0.1891671    
     +,   0.1860893    ,   0.1829263    ,   0.1796763    
     +,   0.1763383    ,   0.1729142    ,   0.1694068    
     +,   0.1658210    ,   0.1621636    ,   0.1584427    
     +,   0.1546683    ,   0.1508515    ,   0.1470047    
     +,   0.1431416    ,   0.1392767    ,   0.1354253    
     +,   0.1316035    ,   0.1278283    ,   0.1241165    
     +,   0.1204852    ,   0.1169516    ,   0.1135325    
     +,   0.1102441    ,   0.1071015    ,   0.1041194    
     +,   0.1013100    ,   9.8684579E-02,   9.6252128E-02
     +,   9.4019622E-02,   9.1991603E-02,   9.0170041E-02
     +,   8.8554457E-02,   8.7141909E-02,   8.5926607E-02
     +,   8.4900469E-02,   8.4053107E-02,   8.3371915E-02
     +,   8.2842425E-02,   8.2448676E-02,   8.2173117E-02
     +,   8.1997491E-02,   8.1902876E-02,   8.1869870E-02
     +,   8.1879422E-02,   8.1912659E-02,   8.1951603E-02
     +,   8.1979267E-02,   8.1979975E-02,   8.1939533E-02
     +,   8.1845395E-02,   8.1686959E-02,   8.1455372E-02
     +,   8.1143856E-02,   8.0747478E-02,   8.0263138E-02
     +,   7.9689547E-02,   7.9026967E-02,   7.8277156E-02
     +,   7.7443235E-02,   7.6529182E-02,   7.5539976E-02
     +,   7.4481256E-02,   7.3359095E-02,   7.2179832E-02
     +,   7.0949793E-02,   6.9675528E-02,   6.8363026E-02
     +,   6.7018263E-02,   6.5646671E-02,   6.4253345E-02
     +,   6.2842861E-02,   6.1419200E-02,   5.9986018E-02
     +,   5.8546495E-02,   5.7103168E-02,   5.5658307E-02
     +,   5.4213848E-02,   5.2771419E-02,   5.1332332E-02
     +,   4.9897648E-02,   4.8468448E-02,   4.7045551E-02
     +,   4.5629688E-02,   4.4221699E-02,   4.2822365E-02
     +,   4.1432455E-02,   4.0052716E-02,   3.8684089E-02
     +,   3.7327547E-02,   3.5984050E-02,   3.4654640E-02
     +,   3.3340476E-02,   3.2042775E-02,   3.0762762E-02
     +,   2.9501639E-02,   2.8260780E-02,   2.7041446E-02
     +,   2.5844898E-02,   2.4672475E-02,   2.3525426E-02
     +,   2.2404939E-02,   2.1312116E-02,   2.0248068E-02
     +,   1.9213811E-02,   1.8210227E-02,   1.7238047E-02
     +,   1.6298020E-02,   1.5390732E-02,   1.4516604E-02
     +,   1.3675930E-02,   1.2868964E-02,   1.2095749E-02
     +,   1.1356211E-02,   1.0650196E-02,   9.9774366E-03
     +,   9.3375007E-03,   8.7298527E-03,   8.1539080E-03
     +,   7.6089757E-03,   7.0942473E-03,   6.6088480E-03
     +,   6.1518750E-03,   5.7223551E-03,   5.3192559E-03
     +,   4.9415035E-03,   4.5880377E-03,   4.2577451E-03
     +,   3.9495048E-03,   3.6622155E-03,   3.3947807E-03
     +,   3.1460994E-03,   2.9150906E-03,   2.7007137E-03
     +,   2.5019548E-03,   2.3178186E-03,   2.1473481E-03
     +,   1.9896396E-03,   1.8438103E-03,   1.7090352E-03
     +,   1.5845165E-03,   1.4695127E-03,   1.3633113E-03
     +,   1.2652563E-03,   1.1747178E-03,   1.0911205E-03
     +,   1.0139156E-03,   9.4260223E-04,   8.7670929E-04
     +,   8.1579946E-04,   7.5947453E-04,   7.0735964E-04
     +,   6.5911579E-04,   6.1442499E-04,   5.7300128E-04
     +,   5.3457636E-04,   4.9890968E-04,   4.6577642E-04
     +,   4.3497520E-04,   4.0631814E-04,   3.7963744E-04
     +,   3.5477630E-04,   3.3159525E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_ashz_htt65_mass = Yx/28.253605625
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_ashz_htt70_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.9981093E-03,   5.3442414E-03
     +,   5.7135699E-03,   6.1072232E-03,   6.5263356E-03
     +,   6.9720396E-03,   7.4454779E-03,   7.9477774E-03
     +,   8.4800543E-03,   9.0434402E-03,   9.6390098E-03
     +,   1.0267840E-02,   1.0930958E-02,   1.1629382E-02
     +,   1.2364074E-02,   1.3135981E-02,   1.3946014E-02
     +,   1.4795062E-02,   1.5684033E-02,   1.6613869E-02
     +,   1.7585594E-02,   1.8600419E-02,   1.9659774E-02
     +,   2.0765532E-02,   2.1919990E-02,   2.3126286E-02
     +,   2.4388425E-02,   2.5711602E-02,   2.7102480E-02
     +,   2.8569454E-02,   3.0122936E-02,   3.1775586E-02
     +,   3.3542514E-02,   3.5441432E-02,   3.7492599E-02
     +,   3.9718810E-02,   4.2145111E-02,   4.4798512E-02
     +,   4.7707990E-02,   5.0903972E-02,   5.4419421E-02
     +,   5.8290631E-02,   6.2559992E-02,   6.7280106E-02
     +,   7.2519541E-02,   7.8370370E-02,   8.4956758E-02
     +,   9.2442900E-02,   0.1010401    ,   0.1110097    
     +,   0.1226640    ,   0.1363617    ,   0.1525051    
     +,   0.1715391    ,   0.1939503    ,   0.2202761    
     +,   0.2511009    ,   0.2870368    ,   0.3286705    
     +,   0.3764733    ,   0.4306896    ,   0.4912642    
     +,   0.5578718    ,   0.6301600    ,   0.7081926    
     +,   0.7929826    ,   0.8868204    ,   0.9928871    
     +,    1.113984    ,    1.250725    ,    1.400576    
     +,    1.558933    ,    1.722349    ,    1.891587    
     +,    2.072078    ,    2.270986    ,    2.492760    
     +,    2.735281    ,    2.987544    ,    3.230388    
     +,    3.442261    ,    3.607813    ,    3.722450    
     +,    3.789771    ,    3.815778    ,    3.804883    
     +,    3.758017    ,    3.673294    ,    3.551952    
     +,    3.406532    ,    3.261449    ,    3.139998    
     +,    3.047267    ,    2.965411    ,    2.866165    
     +,    2.729254    ,    2.552933    ,    2.351859    
     +,    2.146789    ,    1.953947    ,    1.779948    
     +,    1.623700    ,    1.481968    ,    1.353992    
     +,    1.242229    ,    1.150045    ,    1.078915    
     +,    1.027208    ,   0.9907601    ,   0.9643117    
     +,   0.9428135    ,   0.9222112    ,   0.8997733    
     +,   0.8741218    ,   0.8450726    ,   0.8132975    
     +,   0.7799242    ,   0.7461406    ,   0.7129435    
     +,   0.6810495    ,   0.6509395    ,   0.6229515    
     +,   0.5973502    ,   0.5743318    ,   0.5539931    
     +,   0.5362799    ,   0.5209603    ,   0.5076376    
     +,   0.4957937    ,   0.4848580    ,   0.4742759    
     +,   0.4635659    ,   0.4523546    ,   0.4403951    
     +,   0.4275669    ,   0.4138645    ,   0.3993788    
     +,   0.3842784    ,   0.3687819    ,   0.3531363    
     +,   0.3375965    ,   0.3224044    ,   0.3077724    
     +,   0.2938704    ,   0.2808218    ,   0.2686974    
     +,   0.2575175    ,   0.2472590    ,   0.2378621    
     +,   0.2292383    ,   0.2212819    ,   0.2138797    
     +,   0.2069184    ,   0.2002912    ,   0.1939026    
     +,   0.1876727    ,   0.1815391    ,   0.1754559    
     +,   0.1693955    ,   0.1633473    ,   0.1573161    
     +,   0.1513196    ,   0.1453879    ,   0.1395600    
     +,   0.1338806    ,   0.1283982    ,   0.1231629    
     +,   0.1182227    ,   0.1136219    ,   0.1093988    
     +,   0.1055855    ,   0.1022053    ,   9.9272855E-02
     +,   9.6793920E-02,   9.4765633E-02,   9.3176991E-02
     +,   9.2009276E-02,   9.1237716E-02,   9.0831712E-02
     +,   9.0756655E-02,   9.0974696E-02,   9.1445886E-02
     +,   9.2129461E-02,   9.2984758E-02,   9.3971997E-02
     +,   9.5053345E-02,   9.6193142E-02,   9.7358778E-02
     +,   9.8521069E-02,   9.9654205E-02,   0.1007361    
     +,   0.1017483    ,   0.1026754    ,   0.1035055    
     +,   0.1042291    ,   0.1048393    ,   0.1053307    
     +,   0.1056993    ,   0.1059420    ,   0.1060562    
     +,   0.1060392    ,   0.1058883    ,   0.1056004    
     +,   0.1051719    ,   0.1045991    ,   0.1038780    
     +,   0.1030044    ,   0.1019746    ,   0.1007854    
     +,   9.9434666E-02,   9.7921208E-02,   9.6245736E-02
     +,   9.4410717E-02,   9.2420414E-02,   9.0281308E-02
     +,   8.8001981E-02,   8.5593328E-02,   8.3067767E-02
     +,   8.0439568E-02,   7.7724576E-02,   7.4939542E-02
     +,   7.2101966E-02,   6.9229759E-02,   6.6340908E-02
     +,   6.3452773E-02,   6.0582019E-02,   5.7744436E-02
     +,   5.4954488E-02,   5.2225105E-02,   4.9567498E-02
     +,   4.6991382E-02,   4.4504758E-02,   4.2113695E-02
     +,   3.9822660E-02,   3.7634730E-02,   3.5551332E-02
     +,   3.3572588E-02,   3.1697631E-02,   2.9924540E-02
     +,   2.8250512E-02,   2.6672032E-02,   2.5185250E-02
     +,   2.3785869E-02,   2.2469275E-02,   2.1230761E-02
     +,   2.0065621E-02,   1.8969245E-02,   1.7937005E-02
     +,   1.6964495E-02,   1.6047608E-02,   1.5182343E-02
     +,   1.4364999E-02,   1.3592184E-02,   1.2860764E-02
     +,   1.2167814E-02,   1.1510693E-02,   1.0887023E-02
     +,   1.0294667E-02,   9.7316504E-03,   9.1961976E-03
     +,   8.6867493E-03,   8.2018999E-03,   7.7403449E-03
     +,   7.3009133E-03,   6.8825823E-03,   6.4843791E-03
     +,   6.1054104E-03,   5.7448759E-03,   5.4020351E-03
     +,   5.0761634E-03,   4.7665825E-03,   4.4726715E-03
     +,   4.1938275E-03,   3.9294590E-03,   3.6789898E-03
     +,   3.4418874E-03,   3.2176035E-03,   3.0056273E-03
     +,   2.8054379E-03,   2.6165505E-03,   2.4384623E-03
     +,   2.2707100E-03,   2.1128168E-03,   1.9643388E-03
     +,   1.8248238E-03,   1.6938507E-03,   1.5709961E-03
     +,   1.4558514E-03,   1.3480304E-03,   1.2471471E-03
     +,   1.1528422E-03,   1.0647556E-03,   9.8255347E-04
     +,   9.0590480E-04,   8.3450106E-04,   7.6803775E-04
     +,   7.0623175E-04,   6.4880506E-04,   5.9549941E-04
     +,   5.4606143E-04,   5.0025631E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_ashz_htt70_mass = Yx/32.8302248571429
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_ashz_htt75_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  6.9738110E-03,   7.1974196E-03
     +,   7.4249934E-03,   7.6564024E-03,   7.8915022E-03
     +,   8.1301378E-03,   8.3721392E-03,   8.6173266E-03
     +,   8.8655101E-03,   9.1165025E-03,   9.3701025E-03
     +,   9.6261073E-03,   9.8843202E-03,   1.0144557E-02
     +,   1.0406636E-02,   1.0670398E-02,   1.0935705E-02
     +,   1.1202453E-02,   1.1470561E-02,   1.1740015E-02
     +,   1.2010843E-02,   1.2283134E-02,   1.2557067E-02
     +,   1.2832904E-02,   1.3110992E-02,   1.3391830E-02
     +,   1.3676027E-02,   1.3964348E-02,   1.4257737E-02
     +,   1.4557338E-02,   1.4864501E-02,   1.5180838E-02
     +,   1.5508235E-02,   1.5848875E-02,   1.6205296E-02
     +,   1.6580395E-02,   1.6977502E-02,   1.7400371E-02
     +,   1.7853305E-02,   1.8341057E-02,   1.8869046E-02
     +,   1.9443281E-02,   2.0070449E-02,   2.0758038E-02
     +,   2.1514321E-02,   2.2348551E-02,   2.3271015E-02
     +,   2.4293251E-02,   2.5428250E-02,   2.6690690E-02
     +,   2.8097279E-02,   2.9667025E-02,   3.1421646E-02
     +,   3.3386018E-02,   3.5588142E-02,   3.8059887E-02
     +,   4.0836778E-02,   4.3958437E-02,   4.7468815E-02
     +,   5.1417079E-02,   5.5858944E-02,   6.0859572E-02
     +,   6.6497430E-02,   7.2871372E-02,   8.0108941E-02
     +,   8.8375367E-02,   9.7885773E-02,   0.1089111    
     +,   0.1217839    ,   0.1368894    ,   0.1546510    
     +,   0.1754969    ,   0.1998249    ,   0.2279565    
     +,   0.2601130    ,   0.2964051    ,   0.3368476    
     +,   0.3813924    ,   0.4299574    ,   0.4824174    
     +,   0.5385715    ,   0.5981430    ,   0.6608575    
     +,   0.7266995    ,   0.7962341    ,   0.8708464    
     +,   0.9525990    ,    1.043664    ,    1.145522    
     +,    1.258502    ,    1.382156    ,    1.516553    
     +,    1.663763    ,    1.828097    ,    2.013941    
     +,    2.221949    ,    2.446298    ,    2.675083    
     +,    2.894958    ,    3.098900    ,    3.292747    
     +,    3.491650    ,    3.703593    ,    3.914811    
     +,    4.096669    ,    4.226541    ,    4.296328    
     +,    4.305088    ,    4.255470    ,    4.157276    
     +,    4.025420    ,    3.872947    ,    3.707741    
     +,    3.532462    ,    3.346134    ,    3.148338    
     +,    2.942691    ,    2.735571    ,    2.533243    
     +,    2.340830    ,    2.161722    ,    1.996149    
     +,    1.841338    ,    1.694323    ,    1.554599    
     +,    1.424200    ,    1.306154    ,    1.203189    
     +,    1.116973    ,    1.047583    ,   0.9931382    
     +,   0.9500629    ,   0.9139504    ,   0.8806934    
     +,   0.8473482    ,   0.8125194    ,   0.7762540    
     +,   0.7395976    ,   0.7040196    ,   0.6708771    
     +,   0.6410487    ,   0.6147702    ,   0.5916776    
     +,   0.5709870    ,   0.5517354    ,   0.5329952    
     +,   0.5140398    ,   0.4944222    ,   0.4739789    
     +,   0.4527818    ,   0.4310634    ,   0.4091406    
     +,   0.3873462    ,   0.3659808    ,   0.3452900    
     +,   0.3254564    ,   0.3066016    ,   0.2887939    
     +,   0.2720608    ,   0.2564028    ,   0.2417971    
     +,   0.2282085    ,   0.2155960    ,   0.2039152    
     +,   0.1931218    ,   0.1831740    ,   0.1740347    
     +,   0.1656706    ,   0.1580532    ,   0.1511574    
     +,   0.1449623    ,   0.1394500    ,   0.1346031    
     +,   0.1304055    ,   0.1268405    ,   0.1238893    
     +,   0.1215301    ,   0.1197375    ,   0.1184819    
     +,   0.1177281    ,   0.1174365    ,   0.1175627    
     +,   0.1180576    ,   0.1188689    ,   0.1199412    
     +,   0.1212174    ,   0.1226397    ,   0.1241503    
     +,   0.1256931    ,   0.1272139    ,   0.1286616    
     +,   0.1299891    ,   0.1311539    ,   0.1321185    
     +,   0.1328512    ,   0.1333264    ,   0.1335246    
     +,   0.1334330    ,   0.1330448    ,   0.1323604    
     +,   0.1313855    ,   0.1301326    ,   0.1286187    
     +,   0.1268661    ,   0.1249009    ,   0.1227524    
     +,   0.1204521    ,   0.1180329    ,   0.1155280    
     +,   0.1129696    ,   0.1103887    ,   0.1078137    
     +,   0.1052701    ,   0.1027795    ,   0.1003593    
     +,   9.8023035E-02,   9.5779650E-02,   9.3633860E-02
     +,   9.1586217E-02,   8.9633770E-02,   8.7770224E-02
     +,   8.5986450E-02,   8.4271401E-02,   8.2612336E-02
     +,   8.0995366E-02,   7.9406202E-02,   7.7830628E-02
     +,   7.6254867E-02,   7.4665964E-02,   7.3052078E-02
     +,   7.1403004E-02,   6.9710203E-02,   6.7966752E-02
     +,   6.6167645E-02,   6.4309984E-02,   6.2392622E-02
     +,   6.0416214E-02,   5.8383293E-02,   5.6298092E-02
     +,   5.4166101E-02,   5.1994186E-02,   4.9790412E-02
     +,   4.7563750E-02,   4.5323674E-02,   4.3080140E-02
     +,   4.0843450E-02,   3.8623940E-02,   3.6431596E-02
     +,   3.4275994E-02,   3.2166418E-02,   3.0111231E-02
     +,   2.8117962E-02,   2.6193365E-02,   2.4343248E-02
     +,   2.2572223E-02,   2.0883910E-02,   1.9281020E-02
     +,   1.7765244E-02,   1.6337262E-02,   1.4996871E-02
     +,   1.3743174E-02,   1.2574565E-02,   1.1488729E-02
     +,   1.0482872E-02,   9.5538506E-03,   8.6981151E-03
     +,   7.9118675E-03,   7.1912147E-03,   6.5321592E-03
     +,   5.9306473E-03,   5.3826515E-03,   4.8842756E-03
     +,   4.4317273E-03,   4.0213396E-03,   3.6496224E-03
     +,   3.3133072E-03,   3.0092816E-03,   2.7346804E-03
     +,   2.4868022E-03,   2.2631858E-03,   2.0615333E-03
     +,   1.8797654E-03,   1.7159550E-03,   1.5683691E-03
     +,   1.4354117E-03,   1.3156509E-03,   1.2077787E-03
     +,   1.1106116E-03,   1.0230903E-03,   9.4424601E-04
     +,   8.7321614E-04,   8.0921286E-04,   7.5153407E-04
     +,   6.9954031E-04,   6.5266073E-04,   6.1037601E-04
     +,   5.7222252E-04,   5.3777755E-04,   5.0666463E-04
     +,   4.7854011E-04,   4.5309763E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_ashz_htt75_mass = Yx/35.00074284
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_ashz_htt80_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  6.0673533E-03,   6.4087459E-03
     +,   6.7624054E-03,   7.1279281E-03,   7.5048245E-03
     +,   7.8925304E-03,   8.2903970E-03,   8.6977044E-03
     +,   9.1136517E-03,   9.5373914E-03,   9.9679930E-03
     +,   1.0404477E-02,   1.0845814E-02,   1.1290930E-02
     +,   1.1738728E-02,   1.2188078E-02,   1.2637842E-02
     +,   1.3086879E-02,   1.3534065E-02,   1.3978284E-02
     +,   1.4418459E-02,   1.4853557E-02,   1.5282596E-02
     +,   1.5704688E-02,   1.6118973E-02,   1.6524747E-02
     +,   1.6921367E-02,   1.7308330E-02,   1.7685244E-02
     +,   1.8051857E-02,   1.8408099E-02,   1.8754015E-02
     +,   1.9089853E-02,   1.9416040E-02,   1.9733172E-02
     +,   2.0042080E-02,   2.0343762E-02,   2.0639466E-02
     +,   2.0930635E-02,   2.1218944E-02,   2.1506293E-02
     +,   2.1794813E-02,   2.2086857E-02,   2.2385029E-02
     +,   2.2692131E-02,   2.3011224E-02,   2.3345586E-02
     +,   2.3698730E-02,   2.4074411E-02,   2.4476659E-02
     +,   2.4909763E-02,   2.5378343E-02,   2.5887404E-02
     +,   2.6442358E-02,   2.7049130E-02,   2.7714271E-02
     +,   2.8445065E-02,   2.9249717E-02,   3.0137403E-02
     +,   3.1118598E-02,   3.2205131E-02,   3.3410516E-02
     +,   3.4749988E-02,   3.6240913E-02,   3.7902903E-02
     +,   3.9757866E-02,   4.1830517E-02,   4.4148143E-02
     +,   4.6741173E-02,   4.9642589E-02,   5.2888721E-02
     +,   5.6517918E-02,   6.0571134E-02,   6.5090060E-02
     +,   7.0116848E-02,   7.5692013E-02,   8.1852578E-02
     +,   8.8629581E-02,   9.6047066E-02,   0.1041196    
     +,   0.1128511    ,   0.1222367    ,   0.1322633    
     +,   0.1429168    ,   0.1541869    ,   0.1660801    
     +,   0.1786298    ,   0.1919145    ,   0.2060720    
     +,   0.2213171    ,   0.2379533    ,   0.2563750    
     +,   0.2770584    ,   0.3005357    ,   0.3273535    
     +,   0.3580226    ,   0.3929915    ,   0.4326368    
     +,   0.4773151    ,   0.5274200    ,   0.5834590    
     +,   0.6460366    ,   0.7157510    ,   0.7929294    
     +,   0.8773216    ,   0.9678473    ,    1.062643    
     +,    1.159633    ,    1.257621    ,    1.357411    
     +,    1.462104    ,    1.576004    ,    1.702565    
     +,    1.843561    ,    2.001028    ,    2.181054    
     +,    2.394902    ,    2.652874    ,    2.950623    
     +,    3.258356    ,    3.532190    ,    3.752344    
     +,    3.949816    ,    4.173583    ,    4.423100    
     +,    4.637855    ,    4.768587    ,    4.829373    
     +,    4.854783    ,    4.838152    ,    4.752804    
     +,    4.608875    ,    4.440576    ,    4.252243    
     +,    4.021713    ,    3.749197    ,    3.469371    
     +,    3.218853    ,    3.009706    ,    2.828995    
     +,    2.652831    ,    2.463995    ,    2.263560    
     +,    2.067769    ,    1.893479    ,    1.746110    
     +,    1.619692    ,    1.505164    ,    1.397205    
     +,    1.294962    ,    1.199285    ,    1.110635    
     +,    1.028870    ,   0.9538550    ,   0.8857408    
     +,   0.8247274    ,   0.7706472    ,   0.7227423    
     +,   0.6797310    ,   0.6400750    ,   0.6023068    
     +,   0.5653158    ,   0.5284995    ,   0.4917750    
     +,   0.4554720    ,   0.4201671    ,   0.3865043    
     +,   0.3550502    ,   0.3262061    ,   0.3001878    
     +,   0.2770501    ,   0.2567317    ,   0.2391043    
     +,   0.2240110    ,   0.2112887    ,   0.2007729    
     +,   0.1922957    ,   0.1856827    ,   0.1807481    
     +,   0.1772915    ,   0.1751034    ,   0.1739689    
     +,   0.1736724    ,   0.1740052    ,   0.1747716    
     +,   0.1757933    ,   0.1769140    ,   0.1780018    
     +,   0.1789511    ,   0.1796825    ,   0.1801425    
     +,   0.1803008    ,   0.1801494    ,   0.1796981    
     +,   0.1789724    ,   0.1780093    ,   0.1768541    
     +,   0.1755571    ,   0.1741701    ,   0.1727435    
     +,   0.1713236    ,   0.1699501    ,   0.1686540    
     +,   0.1674553    ,   0.1663635    ,   0.1653751    
     +,   0.1644749    ,   0.1636365    ,   0.1628229    
     +,   0.1619896    ,   0.1610856    ,   0.1600570    
     +,   0.1588497    ,   0.1574120    ,   0.1556971    
     +,   0.1536659    ,   0.1512884    ,   0.1485453    
     +,   0.1454276    ,   0.1419386    ,   0.1380914    
     +,   0.1339089    ,   0.1294226    ,   0.1246708    
     +,   0.1196967    ,   0.1145468    ,   0.1092694    
     +,   0.1039136    ,   9.8526552E-02,   9.3153633E-02
     +,   8.7837376E-02,   8.2616389E-02,   7.7524908E-02
     +,   7.2592340E-02,   6.7843981E-02,   6.3299648E-02
     +,   5.8974478E-02,   5.4879270E-02,   5.1020440E-02
     +,   4.7400173E-02,   4.4017039E-02,   4.0866699E-02
     +,   3.7942063E-02,   3.5233706E-02,   3.2730564E-02
     +,   3.0420529E-02,   2.8290756E-02,   2.6327923E-02
     +,   2.4518784E-02,   2.2850582E-02,   2.1310974E-02
     +,   1.9888358E-02,   1.8572114E-02,   1.7352510E-02
     +,   1.6220680E-02,   1.5168700E-02,   1.4189577E-02
     +,   1.3277147E-02,   1.2425886E-02,   1.1630947E-02
     +,   1.0888078E-02,   1.0193520E-02,   9.5438464E-03
     +,   8.9360001E-03,   8.3672432E-03,   7.8350380E-03
     +,   7.3370165E-03,   6.8710246E-03,   6.4350427E-03
     +,   6.0271383E-03,   5.6454954E-03,   5.2884272E-03
     +,   4.9543306E-03,   4.6416754E-03,   4.3490171E-03
     +,   4.0750299E-03,   3.8184249E-03,   3.5780338E-03
     +,   3.3527303E-03,   3.1414991E-03,   2.9433626E-03
     +,   2.7574431E-03,   2.5829049E-03,   2.4189942E-03
     +,   2.2649972E-03,   2.1202753E-03,   1.9842237E-03
     +,   1.8562874E-03,   1.7359660E-03,   1.6227840E-03
     +,   1.5163149E-03,   1.4161516E-03,   1.3219318E-03
     +,   1.2333050E-03,   1.1499592E-03,   1.0715913E-03
     +,   9.9793018E-04,   9.2871214E-04,   8.6369878E-04
     +,   8.0265844E-04,   7.4538065E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_ashz_htt80_mass = Yx/38.40778788
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_ashz_htt85_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.7170143E-03,   3.8210312E-03
     +,   3.9275670E-03,   4.0368158E-03,   4.1489895E-03
     +,   4.2643244E-03,   4.3830816E-03,   4.5055454E-03
     +,   4.6320241E-03,   4.7628586E-03,   4.8984066E-03
     +,   5.0390568E-03,   5.1852199E-03,   5.3373361E-03
     +,   5.4958672E-03,   5.6612939E-03,   5.8341245E-03
     +,   6.0148835E-03,   6.2041101E-03,   6.4023552E-03
     +,   6.6101858E-03,   6.8281703E-03,   7.0568710E-03
     +,   7.2968695E-03,   7.5487075E-03,   7.8129396E-03
     +,   8.0900844E-03,   8.3806356E-03,   8.6850543E-03
     +,   9.0037584E-03,   9.3371207E-03,   9.6854568E-03
     +,   1.0049021E-02,   1.0427994E-02,   1.0822485E-02
     +,   1.1232529E-02,   1.1658063E-02,   1.2098930E-02
     +,   1.2554913E-02,   1.3025642E-02,   1.3510711E-02
     +,   1.4009583E-02,   1.4521637E-02,   1.5046177E-02
     +,   1.5582412E-02,   1.6129494E-02,   1.6686503E-02
     +,   1.7252496E-02,   1.7826488E-02,   1.8407486E-02
     +,   1.8994519E-02,   1.9586638E-02,   2.0182962E-02
     +,   2.0782705E-02,   2.1385156E-02,   2.1989785E-02
     +,   2.2596205E-02,   2.3204194E-02,   2.3813777E-02
     +,   2.4425171E-02,   2.5038866E-02,   2.5655581E-02
     +,   2.6276283E-02,   2.6902253E-02,   2.7534997E-02
     +,   2.8176267E-02,   2.8828122E-02,   2.9492807E-02
     +,   3.0172912E-02,   3.0871201E-02,   3.1590853E-02
     +,   3.2335300E-02,   3.3108510E-02,   3.3914924E-02
     +,   3.4759738E-02,   3.5649151E-02,   3.6590397E-02
     +,   3.7592288E-02,   3.8665507E-02,   3.9823078E-02
     +,   4.1080605E-02,   4.2457111E-02,   4.3975074E-02
     +,   4.5661289E-02,   4.7546845E-02,   4.9667623E-02
     +,   5.2064035E-02,   5.4781329E-02,   5.7868384E-02
     +,   6.1377533E-02,   6.5363191E-02,   6.9879904E-02
     +,   7.4980617E-02,   8.0714889E-02,   8.7126210E-02
     +,   9.4248839E-02,   0.1021076    ,   0.1107142    
     +,   0.1200689    ,   0.1301593    ,   0.1409643    
     +,   0.1524567    ,   0.1646101    ,   0.1774036    
     +,   0.1908315    ,   0.2049092    ,   0.2196787    
     +,   0.2352146    ,   0.2516280    ,   0.2690682    
     +,   0.2877205    ,   0.3078098    ,   0.3295929    
     +,   0.3533617    ,   0.3794328    ,   0.4081565    
     +,   0.4399107    ,   0.4751103    ,   0.5141752    
     +,   0.5574689    ,   0.6051588    ,   0.6570501    
     +,   0.7125203    ,   0.7707313    ,   0.8312202    
     +,   0.8947777    ,   0.9641889    ,    1.044244    
     +,    1.140834    ,    1.259287    ,    1.402726    
     +,    1.570929    ,    1.760307    ,    1.965595    
     +,    2.183706    ,    2.417538    ,    2.674372    
     +,    2.954434    ,    3.236286    ,    3.480812    
     +,    3.666547    ,    3.824874    ,    4.018540    
     +,    4.268081    ,    4.518940    ,    4.707873    
     +,    4.839264    ,    4.955314    ,    5.053011    
     +,    5.091120    ,    5.068538    ,    5.020340    
     +,    4.934175    ,    4.749712    ,    4.447193    
     +,    4.076009    ,    3.700389    ,    3.356665    
     +,    3.053409    ,    2.783892    ,    2.536124    
     +,    2.300891    ,    2.075109    ,    1.859440    
     +,    1.654305    ,    1.458665    ,    1.271948    
     +,    1.096043    ,   0.9350072    ,   0.7930147    
     +,   0.6724669    ,   0.5734301    ,   0.4941863    
     +,   0.4321649    ,   0.3846852    ,   0.3493453    
     +,   0.3241444    ,   0.3074301    ,   0.2977874    
     +,   0.2939576    ,   0.2947961    ,   0.2992725    
     +,   0.3064771    ,   0.3156244    ,   0.3260419    
     +,   0.3371527    ,   0.3484530    ,   0.3595007    
     +,   0.3699053    ,   0.3793285    ,   0.3874928    
     +,   0.3941885    ,   0.3992859    ,   0.4027413    
     +,   0.4045979    ,   0.4049775    ,   0.4040596    
     +,   0.4020563    ,   0.3991784    ,   0.3956023    
     +,   0.3914457    ,   0.3867502    ,   0.3814827    
     +,   0.3755495    ,   0.3688231    ,   0.3611749    
     +,   0.3525089    ,   0.3427906    ,   0.3320614    
     +,   0.3204453    ,   0.3081370    ,   0.2953871    
     +,   0.2824742    ,   0.2696785    ,   0.2572567    
     +,   0.2454239    ,   0.2343399    ,   0.2241014    
     +,   0.2147449    ,   0.2062527    ,   0.1985600    
     +,   0.1915675    ,   0.1851538    ,   0.1791860    
     +,   0.1735297    ,   0.1680588    ,   0.1626617    
     +,   0.1572468    ,   0.1517445    ,   0.1461084    
     +,   0.1403159    ,   0.1343650    ,   0.1282713    
     +,   0.1220646    ,   0.1157856    ,   0.1094808    
     +,   0.1031992    ,   9.6990295E-02,   9.0900220E-02
     +,   8.4970258E-02,   7.9235643E-02,   7.3725469E-02
     +,   6.8461984E-02,   6.3460685E-02,   5.8730979E-02
     +,   5.4277223E-02,   5.0099205E-02,   4.6192564E-02
     +,   4.2550065E-02,   3.9162457E-02,   3.6018506E-02
     +,   3.3105914E-02,   3.0412020E-02,   2.7923852E-02
     +,   2.5628336E-02,   2.3512742E-02,   2.1564888E-02
     +,   1.9773137E-02,   1.8126324E-02,   1.6613917E-02
     +,   1.5226133E-02,   1.3953771E-02,   1.2788134E-02
     +,   1.1721089E-02,   1.0745127E-02,   9.8531302E-03
     +,   9.0384474E-03,   8.2949009E-03,   7.6167267E-03
     +,   6.9984882E-03,   6.4351289E-03,   5.9219664E-03
     +,   5.4546567E-03,   5.0291307E-03,   4.6416279E-03
     +,   4.2887144E-03,   3.9671799E-03,   3.6741195E-03
     +,   3.4068332E-03,   3.1628835E-03,   2.9400247E-03
     +,   2.7362406E-03,   2.5496795E-03,   2.3786880E-03
     +,   2.2217555E-03,   2.0775392E-03,   1.9448206E-03
     +,   1.8225068E-03,   1.7096298E-03,   1.6053102E-03
     +,   1.5087748E-03,   1.4193199E-03,   1.3363295E-03
     +,   1.2592413E-03,   1.1875620E-03,   1.1208419E-03
     +,   1.0586850E-03,   1.0007273E-03,   9.4664830E-04
     +,   8.9615164E-04,   8.4897521E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_ashz_htt85_mass = Yx/38.50444164
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_ashz_htt90_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.0856781E-03,   4.2214342E-03
     +,   4.3600923E-03,   4.5016138E-03,   4.6459525E-03
     +,   4.7930549E-03,   4.9428581E-03,   5.0952970E-03
     +,   5.2502900E-03,   5.4077609E-03,   5.5676172E-03
     +,   5.7297642E-03,   5.8940980E-03,   6.0605109E-03
     +,   6.2288921E-03,   6.3991216E-03,   6.5710805E-03
     +,   6.7446427E-03,   6.9196825E-03,   7.0960717E-03
     +,   7.2736824E-03,   7.4523878E-03,   7.6320572E-03
     +,   7.8125717E-03,   7.9938062E-03,   8.1756432E-03
     +,   8.3579794E-03,   8.5407048E-03,   8.7237256E-03
     +,   8.9069493E-03,   9.0903053E-03,   9.2737228E-03
     +,   9.4571458E-03,   9.6405353E-03,   9.8238578E-03
     +,   1.0007099E-02,   1.0190260E-02,   1.0373355E-02
     +,   1.0556421E-02,   1.0739495E-02,   1.0922653E-02
     +,   1.1105970E-02,   1.1289547E-02,   1.1473502E-02
     +,   1.1657971E-02,   1.1843108E-02,   1.2029088E-02
     +,   1.2216100E-02,   1.2404365E-02,   1.2594111E-02
     +,   1.2785607E-02,   1.2979133E-02,   1.3174988E-02
     +,   1.3373545E-02,   1.3575157E-02,   1.3780257E-02
     +,   1.3989300E-02,   1.4202806E-02,   1.4421340E-02
     +,   1.4645549E-02,   1.4876137E-02,   1.5113919E-02
     +,   1.5359766E-02,   1.5614700E-02,   1.5879847E-02
     +,   1.6156452E-02,   1.6445909E-02,   1.6749764E-02
     +,   1.7069735E-02,   1.7407678E-02,   1.7765665E-02
     +,   1.8145900E-02,   1.8550793E-02,   1.8982869E-02
     +,   1.9444861E-02,   1.9939616E-02,   2.0470059E-02
     +,   2.1039195E-02,   2.1650087E-02,   2.2305802E-02
     +,   2.3009269E-02,   2.3763396E-02,   2.4570795E-02
     +,   2.5433943E-02,   2.6354905E-02,   2.7335448E-02
     +,   2.8376795E-02,   2.9479818E-02,   3.0644713E-02
     +,   3.1871192E-02,   3.3158474E-02,   3.4505107E-02
     +,   3.5909154E-02,   3.7368380E-02,   3.8880248E-02
     +,   4.0442020E-02,   4.2051222E-02,   4.3705594E-02
     +,   4.5403745E-02,   4.7145244E-02,   4.8931312E-02
     +,   5.0764978E-02,   5.2652095E-02,   5.4601420E-02
     +,   5.6625713E-02,   5.8742344E-02,   6.0973816E-02
     +,   6.3348740E-02,   6.5902986E-02,   6.8680078E-02
     +,   7.1732186E-02,   7.5121090E-02,   7.8918487E-02
     +,   8.3207130E-02,   8.8080458E-02,   9.3643695E-02
     +,   0.1000124    ,   0.1073132    ,   0.1156804    
     +,   0.1252545    ,   0.1361771    ,   0.1485830    
     +,   0.1625915    ,   0.1782962    ,   0.1957537    
     +,   0.2149733    ,   0.2359208    ,   0.2585239    
     +,   0.2827049    ,   0.3084217    ,   0.3357338    
     +,   0.3648658    ,   0.3962758    ,   0.4306832    
     +,   0.4690599    ,   0.5125341    ,   0.5622118    
     +,   0.6189091    ,   0.6828358    ,   0.7532998    
     +,   0.8285562    ,   0.9059538    ,   0.9824448    
     +,    1.055402    ,    1.123519    ,    1.187468    
     +,    1.250039    ,    1.315791    ,    1.390523    
     +,    1.480793    ,    1.593297    ,    1.733506    
     +,    1.903551    ,    2.100530    ,    2.316754    
     +,    2.542112    ,    2.767862    ,    2.991087    
     +,    3.216532    ,    3.449404    ,    3.680121    
     +,    3.879617    ,    4.021671    ,    4.111338    
     +,    4.179009    ,    4.242615    ,    4.285132    
     +,    4.269328    ,    4.164163    ,    3.960274    
     +,    3.673485    ,    3.335171    ,    2.974604    
     +,    2.612713    ,    2.271190    ,    1.977413    
     +,    1.754930    ,    1.611388    ,    1.537607    
     +,    1.517124    ,    1.536145    ,    1.586597    
     +,    1.662776    ,    1.756915    ,    1.857940    
     +,    1.953498    ,    2.032671    ,    2.087289    
     +,    2.112305    ,    2.106443    ,    2.072932    
     +,    2.018811    ,    1.952059    ,    1.878199    
     +,    1.798903    ,    1.713595    ,    1.622313    
     +,    1.527270    ,    1.432093    ,    1.339963    
     +,    1.252425    ,    1.169598    ,    1.091199    
     +,    1.017397    ,   0.9490245    ,   0.8872470    
     +,   0.8330801    ,   0.7870137    ,   0.7488277    
     +,   0.7176028    ,   0.6918653    ,   0.6698195    
     +,   0.6496053    ,   0.6295487    ,   0.6083607    
     +,   0.5852557    ,   0.5599810    ,   0.5327596    
     +,   0.5041813    ,   0.4750580    ,   0.4462703    
     +,   0.4186360    ,   0.3928100    ,   0.3692215    
     +,   0.3480496    ,   0.3292385    ,   0.3125431    
     +,   0.2975860    ,   0.2839223    ,   0.2711032    
     +,   0.2587260    ,   0.2464687    ,   0.2341062    
     +,   0.2215152    ,   0.2086662    ,   0.1956050    
     +,   0.1824335    ,   0.1692901    ,   0.1563287    
     +,   0.1437012    ,   0.1315462    ,   0.1199806    
     +,   0.1090937    ,   9.8945051E-02,   8.9566410E-02
     +,   8.0964990E-02,   7.3126957E-02,   6.6021726E-02
     +,   5.9607185E-02,   5.3834483E-02,   4.8650440E-02
     +,   4.4001047E-02,   3.9833892E-02,   3.6099281E-02
     +,   3.2750711E-02,   2.9745772E-02,   2.7046371E-02
     +,   2.4618315E-02,   2.2431016E-02,   2.0457342E-02
     +,   1.8673435E-02,   1.7058244E-02,   1.5593124E-02
     +,   1.4261696E-02,   1.3049707E-02,   1.1944541E-02
     +,   1.0935179E-02,   1.0012001E-02,   9.1666058E-03
     +,   8.3915619E-03,   7.6803542E-03,   7.0272824E-03
     +,   6.4273141E-03,   5.8759409E-03,   5.3691491E-03
     +,   4.9033887E-03,   4.4754031E-03,   4.0822993E-03
     +,   3.7213911E-03,   3.3902694E-03,   3.0866773E-03
     +,   2.8085737E-03,   2.5540285E-03,   2.3212854E-03
     +,   2.1086780E-03,   1.9146784E-03,   1.7378409E-03
     +,   1.5768138E-03,   1.4303493E-03,   1.2972594E-03
     +,   1.1764524E-03,   1.0668914E-03,   9.6762419E-04
     +,   8.7775086E-04,   7.9644570E-04,   7.2293240E-04
     +,   6.5650151E-04,   5.9648900E-04,   5.4229121E-04
     +,   4.9334590E-04,   4.4914457E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_ashz_htt90_mass = Yx/39.42265236
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_ashz_htt95_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.1065562E-03,   2.1778787E-03
     +,   2.2509410E-03,   2.3257802E-03,   2.4024358E-03
     +,   2.4809481E-03,   2.5613615E-03,   2.6437219E-03
     +,   2.7280780E-03,   2.8144829E-03,   2.9029911E-03
     +,   2.9936607E-03,   3.0865539E-03,   3.1817355E-03
     +,   3.2792762E-03,   3.3792492E-03,   3.4817336E-03
     +,   3.5868131E-03,   3.6945776E-03,   3.8051207E-03
     +,   3.9185439E-03,   4.0349518E-03,   4.1544582E-03
     +,   4.2771874E-03,   4.4032582E-03,   4.5328136E-03
     +,   4.6659908E-03,   4.8029409E-03,   4.9438206E-03
     +,   5.0887973E-03,   5.2380404E-03,   5.3917356E-03
     +,   5.5500669E-03,   5.7132323E-03,   5.8814334E-03
     +,   6.0548787E-03,   6.2337816E-03,   6.4183581E-03
     +,   6.6088359E-03,   6.8054292E-03,   7.0083709E-03
     +,   7.2178827E-03,   7.4341879E-03,   7.6575023E-03
     +,   7.8880349E-03,   8.1259925E-03,   8.3715627E-03
     +,   8.6249281E-03,   8.8862488E-03,   9.1556758E-03
     +,   9.4333356E-03,   9.7193280E-03,   1.0013731E-02
     +,   1.0316612E-02,   1.0627973E-02,   1.0947823E-02
     +,   1.1276125E-02,   1.1612803E-02,   1.1957764E-02
     +,   1.2310865E-02,   1.2671952E-02,   1.3040827E-02
     +,   1.3417250E-02,   1.3800978E-02,   1.4191755E-02
     +,   1.4589264E-02,   1.4993219E-02,   1.5403279E-02
     +,   1.5819157E-02,   1.6240498E-02,   1.6667033E-02
     +,   1.7098458E-02,   1.7534534E-02,   1.7975030E-02
     +,   1.8419797E-02,   1.8868754E-02,   1.9321874E-02
     +,   1.9779231E-02,   2.0241022E-02,   2.0707613E-02
     +,   2.1179469E-02,   2.1657299E-02,   2.2141974E-02
     +,   2.2634704E-02,   2.3136890E-02,   2.3650359E-02
     +,   2.4177251E-02,   2.4720222E-02,   2.5282320E-02
     +,   2.5867196E-02,   2.6479114E-02,   2.7122933E-02
     +,   2.7804196E-02,   2.8529191E-02,   2.9304985E-02
     +,   3.0139230E-02,   3.1040421E-02,   3.2017503E-02
     +,   3.3080086E-02,   3.4237977E-02,   3.5501260E-02
     +,   3.6879744E-02,   3.8382970E-02,   4.0019512E-02
     +,   4.1796915E-02,   4.3721087E-02,   4.5795824E-02
     +,   4.8022334E-02,   5.0399151E-02,   5.2921582E-02
     +,   5.5581264E-02,   5.8366653E-02,   6.1262414E-02
     +,   6.4250425E-02,   6.7309737E-02,   7.0418045E-02
     +,   7.3552303E-02,   7.6691017E-02,   7.9815336E-02
     +,   8.2911983E-02,   8.5975491E-02,   8.9010559E-02
     +,   9.2035152E-02,   9.5082976E-02,   9.8205447E-02
     +,   0.1014729    ,   0.1049759    ,   0.1088234    
     +,   0.1131415    ,   0.1180682    ,   0.1237484    
     +,   0.1303239    ,   0.1379242    ,   0.1466529    
     +,   0.1565755    ,   0.1677063    ,   0.1799959    
     +,   0.1933264    ,   0.2075121    ,   0.2223086    
     +,   0.2374334    ,   0.2525961    ,   0.2675408    
     +,   0.2820857    ,   0.2961614    ,   0.3098384    
     +,   0.3233311    ,   0.3369762    ,   0.3511848    
     +,   0.3663801    ,   0.3829267    ,   0.4010729    
     +,   0.4209276    ,   0.4424840    ,   0.4656743    
     +,   0.4904430    ,   0.5168034    ,   0.5448332    
     +,   0.5745860    ,   0.6059126    ,   0.6382520    
     +,   0.6704555    ,   0.7007313    ,   0.7267844    
     +,   0.7461556    ,   0.7566990    ,   0.7570801    
     +,   0.7471721    ,   0.7282137    ,   0.7027279    
     +,   0.6742401    ,   0.6468970    ,   0.6251031    
     +,   0.6132352    ,   0.6154460    ,   0.6355883    
     +,   0.6773553    ,   0.7445830    ,   0.8414811    
     +,   0.9722621    ,    1.139828    ,    1.343906    
     +,    1.579729    ,    1.838700    ,    2.112335    
     +,    2.399627    ,    2.712422    ,    3.068119    
     +,    3.471043    ,    3.905137    ,    4.343736    
     +,    4.749176    ,    5.066353    ,    5.246921    
     +,    5.291416    ,    5.258285    ,    5.212033    
     +,    5.145261    ,    4.986847    ,    4.718359    
     +,    4.423355    ,    4.185960    ,    4.004107    
     +,    3.826699    ,    3.622426    ,    3.395399    
     +,    3.162858    ,    2.932801    ,    2.701630    
     +,    2.467205    ,    2.236295    ,    2.020233    
     +,    1.829075    ,    1.668745    ,    1.539077    
     +,    1.433783    ,    1.343934    ,    1.262491    
     +,    1.186196    ,    1.114379    ,    1.046773    
     +,   0.9823326    ,   0.9193759    ,   0.8563744    
     +,   0.7926223    ,   0.7284453    ,   0.6649684    
     +,   0.6036528    ,   0.5458655    ,   0.4925961    
     +,   0.4443686    ,   0.4012749    ,   0.3630916    
     +,   0.3294104    ,   0.2997446    ,   0.2735869    
     +,   0.2504467    ,   0.2298664    ,   0.2114264    
     +,   0.1947522    ,   0.1795221    ,   0.1654745    
     +,   0.1524080    ,   0.1401774    ,   0.1286864    
     +,   0.1178771    ,   0.1077176    ,   9.8190099E-02
     +,   8.9283049E-02,   8.0985904E-02,   7.3284000E-02
     +,   6.6158570E-02,   5.9587233E-02,   5.3544644E-02
     +,   4.8003402E-02,   4.2935707E-02,   3.8314525E-02
     +,   3.4113429E-02,   3.0306602E-02,   2.6869033E-02
     +,   2.3776468E-02,   2.1004997E-02,   1.8530760E-02
     +,   1.6330168E-02,   1.4380170E-02,   1.2657971E-02
     +,   1.1141521E-02,   9.8097920E-03,   8.6428877E-03
     +,   7.6221293E-03,   6.7303153E-03,   5.9517999E-03
     +,   5.2724523E-03,   4.6795914E-03,   4.1619721E-03
     +,   3.7097330E-03,   3.3141722E-03,   2.9677546E-03
     +,   2.6638780E-03,   2.3968627E-03,   2.1617552E-03
     +,   1.9543080E-03,   1.7708247E-03,   1.6081419E-03
     +,   1.4635116E-03,   1.3345847E-03,   1.2193252E-03
     +,   1.1159830E-03,   1.0230616E-03,   9.3926257E-04
     +,   8.6348044E-04,   7.9475535E-04,   7.3226995E-04
     +,   6.7531323E-04,   6.2327855E-04,   5.7563593E-04
     +,   5.3193251E-04,   4.9176929E-04,   4.5480378E-04
     +,   4.2073129E-04,   3.8928888E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_ashz_htt95_mass = Yx/38.19031692
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_ashz_ttz100_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.6951166E-04,   3.9833153E-04
     +,   4.2883301E-04,   4.6106425E-04,   4.9507071E-04
     +,   5.3089537E-04,   5.6857755E-04,   6.0815376E-04
     +,   6.4965599E-04,   6.9311430E-04,   7.3855318E-04
     +,   7.8599341E-04,   8.3545217E-04,   8.8694156E-04
     +,   9.4047049E-04,   9.9604321E-04,   1.0536602E-03
     +,   1.1133184E-03,   1.1750107E-03,   1.2387282E-03
     +,   1.3044568E-03,   1.3721823E-03,   1.4418861E-03
     +,   1.5135537E-03,   1.5871598E-03,   1.6626901E-03
     +,   1.7401230E-03,   1.8194404E-03,   1.9006260E-03
     +,   1.9836654E-03,   2.0685475E-03,   2.1552644E-03
     +,   2.2438124E-03,   2.3341933E-03,   2.4264127E-03
     +,   2.5204828E-03,   2.6164220E-03,   2.7142514E-03
     +,   2.8140061E-03,   2.9157163E-03,   3.0194283E-03
     +,   3.1251889E-03,   3.2330507E-03,   3.3430718E-03
     +,   3.4553134E-03,   3.5698405E-03,   3.6867200E-03
     +,   3.8060197E-03,   3.9278073E-03,   4.0521487E-03
     +,   4.1791084E-03,   4.3087429E-03,   4.4411039E-03
     +,   4.5762439E-03,   4.7141891E-03,   4.8549734E-03
     +,   4.9986085E-03,   5.1450944E-03,   5.2944180E-03
     +,   5.4465523E-03,   5.6014508E-03,   5.7590543E-03
     +,   5.9192763E-03,   6.0820244E-03,   6.2471908E-03
     +,   6.4146342E-03,   6.5842140E-03,   6.7557581E-03
     +,   6.9290996E-03,   7.1040322E-03,   7.2803660E-03
     +,   7.4578742E-03,   7.6363459E-03,   7.8155417E-03
     +,   7.9952329E-03,   8.1751952E-03,   8.3551835E-03
     +,   8.5349651E-03,   8.7143211E-03,   8.8930335E-03
     +,   9.0708891E-03,   9.2477025E-03,   9.4232801E-03
     +,   9.5974691E-03,   9.7701093E-03,   9.9410908E-03
     +,   1.0110305E-02,   1.0277680E-02,   1.0443175E-02
     +,   1.0606783E-02,   1.0768550E-02,   1.0928550E-02
     +,   1.1086922E-02,   1.1243887E-02,   1.1399738E-02
     +,   1.1554860E-02,   1.1709775E-02,   1.1865134E-02
     +,   1.2021772E-02,   1.2180714E-02,   1.2343240E-02
     +,   1.2510908E-02,   1.2685613E-02,   1.2869602E-02
     +,   1.3065581E-02,   1.3276731E-02,   1.3506742E-02
     +,   1.3759885E-02,   1.4041044E-02,   1.4355771E-02
     +,   1.4710203E-02,   1.5111195E-02,   1.5566139E-02
     +,   1.6083030E-02,   1.6670255E-02,   1.7336585E-02
     +,   1.8090844E-02,   1.8941870E-02,   1.9898046E-02
     +,   2.0967189E-02,   2.2156134E-02,   2.3470305E-02
     +,   2.4913339E-02,   2.6486853E-02,   2.8189966E-02
     +,   3.0018758E-02,   3.1966429E-02,   3.4022573E-02
     +,   3.6173549E-02,   3.8402025E-02,   4.0687609E-02
     +,   4.3006562E-02,   4.5332856E-02,   4.7638085E-02
     +,   4.9892779E-02,   5.2066863E-02,   5.4130573E-02
     +,   5.6055322E-02,   5.7815079E-02,   5.9386715E-02
     +,   6.0751017E-02,   6.1893351E-02,   6.2804222E-02
     +,   6.3479461E-02,   6.3920230E-02,   6.4133108E-02
     +,   6.4129502E-02,   6.3925177E-02,   6.3539609E-02
     +,   6.2995017E-02,   6.2315624E-02,   6.1526604E-02
     +,   6.0653407E-02,   5.9720773E-02,   5.8752149E-02
     +,   5.7769425E-02,   5.6792393E-02,   5.5838797E-02
     +,   5.4924380E-02,   5.4063305E-02,   5.3268407E-02
     +,   5.2551858E-02,   5.1925726E-02,   5.1402446E-02
     +,   5.0995298E-02,   5.0718777E-02,   5.0588604E-02
     +,   5.0621726E-02,   5.0835840E-02,   5.1249087E-02
     +,   5.1879570E-02,   5.2745126E-02,   5.3863753E-02
     +,   5.5254597E-02,   5.6939848E-02,   5.8948010E-02
     +,   6.1317552E-02,   6.4100400E-02,   6.7365348E-02
     +,   7.1199812E-02,   7.5708993E-02,   8.1013098E-02
     +,   8.7243475E-02,   9.4539143E-02,   0.1030439    
     +,   0.1129031    ,   0.1242611    ,   0.1372550    
     +,   0.1520039    ,   0.1685994    ,   0.1871186    
     +,   0.2076658    ,   0.2304544    ,   0.2559082    
     +,   0.2847283    ,   0.3178605    ,   0.3563585    
     +,   0.4012444    ,   0.4534942    ,   0.5141422    
     +,   0.5842288    ,   0.6642316    ,   0.7530605    
     +,   0.8473757    ,   0.9423040    ,    1.033773    
     +,    1.121163    ,    1.208205    ,    1.300612    
     +,    1.400875    ,    1.503459    ,    1.595294    
     +,    1.663311    ,    1.703316    ,    1.721428    
     +,    1.726534    ,    1.722355    ,    1.707732    
     +,    1.683359    ,    1.654947    ,    1.627753    
     +,    1.599629    ,    1.562065    ,    1.507711    
     +,    1.434619    ,    1.343409    ,    1.233617    
     +,    1.105180    ,   0.9629306    ,   0.8179924    
     +,   0.6838351    ,   0.5703316    ,   0.4804622    
     +,   0.4112660    ,   0.3571860    ,   0.3130857    
     +,   0.2755717    ,   0.2428334    ,   0.2139337    
     +,   0.1882527    ,   0.1652746    ,   0.1445850    
     +,   0.1259046    ,   0.1090791    ,   9.4029084E-02
     +,   8.0692321E-02,   6.8985619E-02,   5.8793303E-02
     +,   4.9976099E-02,   4.2385910E-02,   3.5876881E-02
     +,   3.0314222E-02,   2.5577310E-02,   2.1559106E-02
     +,   1.8164305E-02,   1.5307932E-02,   1.2913988E-02
     +,   1.0914279E-02,   9.2477808E-03,   7.8605711E-03
     +,   6.7056357E-03,   5.7424787E-03,   4.9367179E-03
     +,   4.2596683E-03,   3.6878111E-03,   3.2019964E-03
     +,   2.7868596E-03,   2.4301785E-03,   2.1222369E-03
     +,   1.8552841E-03,   1.6231135E-03,   1.4207124E-03
     +,   1.2439613E-03,   1.0894153E-03,   9.5416041E-04
     +,   8.3571504E-04,   7.3191914E-04,   6.4091053E-04
     +,   5.6105526E-04,   4.9094047E-04,   4.2932847E-04
     +,   3.7515259E-04,   3.2748180E-04,   2.8551748E-04
     +,   2.4856415E-04,   2.1602555E-04,   1.8738239E-04
     +,   1.6218412E-04,   1.4004075E-04,   1.2060763E-04
     +,   1.0358396E-04,   8.8701185E-05,   7.5722251E-05
     +,   6.4433421E-05,   5.4644261E-05,   4.6182100E-05
     +,   3.8892282E-05,   3.2634354E-05,   2.7282524E-05
     +,   2.2722825E-05,   1.8853525E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_ashz_ttz100_mass = Yx/12.3486417209302
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_ashz_ttz105_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.6437619E-03,   1.6761943E-03
     +,   1.7085231E-03,   1.7407286E-03,   1.7727917E-03
     +,   1.8046979E-03,   1.8364332E-03,   1.8679874E-03
     +,   1.8993540E-03,   1.9305306E-03,   1.9615178E-03
     +,   1.9923209E-03,   2.0229493E-03,   2.0534180E-03
     +,   2.0837467E-03,   2.1139609E-03,   2.1440911E-03
     +,   2.1741744E-03,   2.2042543E-03,   2.2343798E-03
     +,   2.2646065E-03,   2.2949972E-03,   2.3256203E-03
     +,   2.3565535E-03,   2.3878762E-03,   2.4196801E-03
     +,   2.4520594E-03,   2.4851162E-03,   2.5189589E-03
     +,   2.5537007E-03,   2.5894614E-03,   2.6263646E-03
     +,   2.6645395E-03,   2.7041195E-03,   2.7452405E-03
     +,   2.7880426E-03,   2.8326663E-03,   2.8792552E-03
     +,   2.9279541E-03,   2.9789042E-03,   3.0322499E-03
     +,   3.0881304E-03,   3.1466840E-03,   3.2080445E-03
     +,   3.2723404E-03,   3.3396962E-03,   3.4102264E-03
     +,   3.4840414E-03,   3.5612409E-03,   3.6419155E-03
     +,   3.7261466E-03,   3.8140039E-03,   3.9055408E-03
     +,   4.0008100E-03,   4.0998342E-03,   4.2026374E-03
     +,   4.3092202E-03,   4.4195717E-03,   4.5336662E-03
     +,   4.6514599E-03,   4.7728973E-03,   4.8979060E-03
     +,   5.0263931E-03,   5.1582577E-03,   5.2933879E-03
     +,   5.4316409E-03,   5.5728788E-03,   5.7169329E-03
     +,   5.8636409E-03,   6.0128104E-03,   6.1642569E-03
     +,   6.3177710E-03,   6.4731492E-03,   6.6301711E-03
     +,   6.7886212E-03,   6.9482876E-03,   7.1089459E-03
     +,   7.2703813E-03,   7.4323853E-03,   7.5947735E-03
     +,   7.7573489E-03,   7.9199560E-03,   8.0824485E-03
     +,   8.2447138E-03,   8.4066549E-03,   8.5682319E-03
     +,   8.7294290E-03,   8.8902870E-03,   9.0508871E-03
     +,   9.2113726E-03,   9.3719568E-03,   9.5329052E-03
     +,   9.6945539E-03,   9.8573267E-03,   1.0021726E-02
     +,   1.0188318E-02,   1.0357777E-02,   1.0530846E-02
     +,   1.0708355E-02,   1.0891223E-02,   1.1080457E-02
     +,   1.1277117E-02,   1.1482358E-02,   1.1697376E-02
     +,   1.1923438E-02,   1.2161844E-02,   1.2413919E-02
     +,   1.2680981E-02,   1.2964372E-02,   1.3265393E-02
     +,   1.3585275E-02,   1.3925214E-02,   1.4286277E-02
     +,   1.4669436E-02,   1.5075489E-02,   1.5505089E-02
     +,   1.5958661E-02,   1.6436454E-02,   1.6938400E-02
     +,   1.7464226E-02,   1.8013373E-02,   1.8584935E-02
     +,   1.9177699E-02,   1.9790163E-02,   2.0420497E-02
     +,   2.1066494E-02,   2.1725710E-02,   2.2395309E-02
     +,   2.3072261E-02,   2.3753187E-02,   2.4434581E-02
     +,   2.5112661E-02,   2.5783584E-02,   2.6443332E-02
     +,   2.7087916E-02,   2.7713383E-02,   2.8315803E-02
     +,   2.8891409E-02,   2.9436698E-02,   2.9948417E-02
     +,   3.0423639E-02,   3.0859817E-02,   3.1254917E-02
     +,   3.1607345E-02,   3.1916067E-02,   3.2180596E-02
     +,   3.2401059E-02,   3.2578126E-02,   3.2713071E-02
     +,   3.2807771E-02,   3.2864619E-02,   3.2886539E-02
     +,   3.2876942E-02,   3.2839641E-02,   3.2778822E-02
     +,   3.2699019E-02,   3.2604974E-02,   3.2501623E-02
     +,   3.2394029E-02,   3.2287341E-02,   3.2186721E-02
     +,   3.2097269E-02,   3.2024041E-02,   3.1972002E-02
     +,   3.1945981E-02,   3.1950653E-02,   3.1990565E-02
     +,   3.2070093E-02,   3.2193478E-02,   3.2364782E-02
     +,   3.2587927E-02,   3.2866709E-02,   3.3204801E-02
     +,   3.3605769E-02,   3.4073055E-02,   3.4610085E-02
     +,   3.5220355E-02,   3.5907511E-02,   3.6675569E-02
     +,   3.7529368E-02,   3.8474996E-02,   3.9520402E-02
     +,   4.0676422E-02,   4.1957907E-02,   4.3385100E-02
     +,   4.4984907E-02,   4.6792436E-02,   4.8852295E-02
     +,   5.1219277E-02,   5.3958077E-02,   5.7142708E-02
     +,   6.0854267E-02,   6.5177441E-02,   7.0196569E-02
     +,   7.5991645E-02,   8.2634300E-02,   9.0183906E-02
     +,   9.8686539E-02,   0.1081754    ,   0.1186704    
     +,   0.1301786    ,   0.1426929    ,   0.1561910    
     +,   0.1706323    ,   0.1859571    ,   0.2020967    
     +,   0.2189889    ,   0.2365986    ,   0.2549399    
     +,   0.2740815    ,   0.2941214    ,   0.3151319    
     +,   0.3370947    ,   0.3598573    ,   0.3831492    
     +,   0.4066681    ,   0.4302170    ,   0.4538222    
     +,   0.4777974    ,   0.5027803    ,   0.5298611    
     +,   0.5608156    ,   0.5983194    ,   0.6458671    
     +,   0.7073073    ,   0.7861668    ,   0.8848704    
     +,    1.003521    ,    1.138044    ,    1.278824    
     +,    1.412267    ,    1.526435    ,    1.617767    
     +,    1.692828    ,    1.761479    ,    1.825604    
     +,    1.873673    ,    1.887561    ,    1.855987    
     +,    1.781719    ,    1.677035    ,    1.554113    
     +,    1.419859    ,    1.277165    ,    1.128255    
     +,   0.9765646    ,   0.8268568    ,   0.6845035    
     +,   0.5544825    ,   0.4404307    ,   0.3440869    
     +,   0.2653622    ,   0.2027821    ,   0.1540498    
     +,   0.1165795    ,   8.7922841E-02,   6.6020988E-02
     +,   4.9276792E-02,   3.6501043E-02,   2.6811235E-02
     +,   1.9536119E-02,   1.4148400E-02,   1.0224317E-02
     +,   7.4203205E-03,   5.4580919E-03,   4.1137915E-03
     +,   3.2108179E-03,   2.6133431E-03,   2.2200681E-03
     +,   1.9581120E-03,   1.7770765E-03,   1.6435386E-03
     +,   1.5363001E-03,   1.4425867E-03,   1.3551767E-03
     +,   1.2703515E-03,   1.1864813E-03,   1.1031413E-03
     +,   1.0205288E-03,   9.3915052E-04,   8.5961219E-04
     +,   7.8253140E-04,   7.0846168E-04,   6.3788629E-04
     +,   5.7118456E-04,   5.0864852E-04,   4.5046950E-04
     +,   3.9675011E-04,   3.4751720E-04,   3.0271875E-04
     +,   2.6224676E-04,   2.2593566E-04,   1.9358295E-04
     +,   1.6495031E-04,   1.3978066E-04,   1.1779978E-04
     +,   9.8730248E-05,   8.2292281E-05,   6.8214467E-05
     +,   5.6233755E-05,   4.6102701E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_ashz_ttz105_mass = Yx/11.002995
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_ashz_ttz107_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.5613035E-03,   3.6721395E-03
     +,   3.7841799E-03,   3.8972765E-03,   4.0112729E-03
     +,   4.1260058E-03,   4.2413054E-03,   4.3569976E-03
     +,   4.4728993E-03,   4.5888312E-03,   4.7046049E-03
     +,   4.8200306E-03,   4.9349191E-03,   5.0490783E-03
     +,   5.1623192E-03,   5.2744541E-03,   5.3853001E-03
     +,   5.4946728E-03,   5.6023998E-03,   5.7083112E-03
     +,   5.8122454E-03,   5.9140478E-03,   6.0135741E-03
     +,   6.1106957E-03,   6.2052831E-03,   6.2972321E-03
     +,   6.3864430E-03,   6.4728339E-03,   6.5563335E-03
     +,   6.6368901E-03,   6.7144637E-03,   6.7890328E-03
     +,   6.8605915E-03,   6.9291480E-03,   6.9947303E-03
     +,   7.0573809E-03,   7.1171625E-03,   7.1741459E-03
     +,   7.2284294E-03,   7.2801178E-03,   7.3293359E-03
     +,   7.3762238E-03,   7.4209375E-03,   7.4636391E-03
     +,   7.5045149E-03,   7.5437562E-03,   7.5815716E-03
     +,   7.6181749E-03,   7.6537984E-03,   7.6886774E-03
     +,   7.7230590E-03,   7.7571995E-03,   7.7913627E-03
     +,   7.8258161E-03,   7.8608412E-03,   7.8967167E-03
     +,   7.9337303E-03,   7.9721753E-03,   8.0123451E-03
     +,   8.0545442E-03,   8.0990717E-03,   8.1462376E-03
     +,   8.1963474E-03,   8.2497122E-03,   8.3066523E-03
     +,   8.3674770E-03,   8.4325094E-03,   8.5020699E-03
     +,   8.5764835E-03,   8.6560696E-03,   8.7411664E-03
     +,   8.8320933E-03,   8.9291884E-03,   9.0327784E-03
     +,   9.1431970E-03,   9.2607895E-03,   9.3858810E-03
     +,   9.5188012E-03,   9.6598817E-03,   9.8094577E-03
     +,   9.9678347E-03,   1.0135338E-02,   1.0312252E-02
     +,   1.0498878E-02,   1.0695473E-02,   1.0902296E-02
     +,   1.1119560E-02,   1.1347472E-02,   1.1586173E-02
     +,   1.1835792E-02,   1.2096409E-02,   1.2368047E-02
     +,   1.2650661E-02,   1.2944163E-02,   1.3248405E-02
     +,   1.3563140E-02,   1.3888070E-02,   1.4222795E-02
     +,   1.4566846E-02,   1.4919652E-02,   1.5280573E-02
     +,   1.5648847E-02,   1.6023675E-02,   1.6404102E-02
     +,   1.6789144E-02,   1.7177733E-02,   1.7568696E-02
     +,   1.7960804E-02,   1.8352797E-02,   1.8743360E-02
     +,   1.9131126E-02,   1.9514738E-02,   1.9892802E-02
     +,   2.0263968E-02,   2.0626882E-02,   2.0980267E-02
     +,   2.1322865E-02,   2.1653533E-02,   2.1971181E-02
     +,   2.2274846E-02,   2.2563694E-02,   2.2836979E-02
     +,   2.3094129E-02,   2.3334702E-02,   2.3558412E-02
     +,   2.3765145E-02,   2.3954896E-02,   2.4127873E-02
     +,   2.4284383E-02,   2.4424883E-02,   2.4549996E-02
     +,   2.4660423E-02,   2.4757020E-02,   2.4840677E-02
     +,   2.4912432E-02,   2.4973337E-02,   2.5024517E-02
     +,   2.5067130E-02,   2.5102351E-02,   2.5131373E-02
     +,   2.5155388E-02,   2.5175573E-02,   2.5193093E-02
     +,   2.5209105E-02,   2.5224727E-02,   2.5241097E-02
     +,   2.5259329E-02,   2.5280504E-02,   2.5305768E-02
     +,   2.5336256E-02,   2.5373129E-02,   2.5417602E-02
     +,   2.5470955E-02,   2.5534529E-02,   2.5609754E-02
     +,   2.5698109E-02,   2.5801226E-02,   2.5920779E-02
     +,   2.6058538E-02,   2.6216375E-02,   2.6396196E-02
     +,   2.6600013E-02,   2.6829794E-02,   2.7087575E-02
     +,   2.7375329E-02,   2.7695047E-02,   2.8048581E-02
     +,   2.8437715E-02,   2.8864156E-02,   2.9329516E-02
     +,   2.9835338E-02,   3.0383080E-02,   3.0974323E-02
     +,   3.1610787E-02,   3.2294460E-02,   3.3027921E-02
     +,   3.3814501E-02,   3.4658603E-02,   3.5566047E-02
     +,   3.6544595E-02,   3.7604239E-02,   3.8757708E-02
     +,   4.0020775E-02,   4.1412827E-02,   4.2956926E-02
     +,   4.4679876E-02,   4.6612062E-02,   4.8787165E-02
     +,   5.1241312E-02,   5.4011770E-02,   5.7135727E-02
     +,   6.0648423E-02,   6.4580709E-02,   6.8956800E-02
     +,   7.3792301E-02,   7.9091996E-02,   8.4847644E-02
     +,   9.1037497E-02,   9.7626857E-02,   0.1045693    
     +,   0.1118091    ,   0.1192854    ,   0.1269391    
     +,   0.1347178    ,   0.1425826    ,   0.1505163    
     +,   0.1585280    ,   0.1666566    ,   0.1749721    
     +,   0.1835714    ,   0.1925679    ,   0.2020756    
     +,   0.2121910    ,   0.2229786    ,   0.2344622    
     +,   0.2466304    ,   0.2594603    ,   0.2729498    
     +,   0.2871543    ,   0.3022216    ,   0.3184292    
     +,   0.3362218    ,   0.3562454    ,   0.3793604    
     +,   0.4066122    ,   0.4391554    ,   0.4781964    
     +,   0.5250140    ,   0.5810540    ,   0.6479421    
     +,   0.7272204    ,   0.8198426    ,   0.9257224    
     +,    1.043715    ,    1.171999    ,    1.308174    
     +,    1.448290    ,    1.585203    ,    1.708093    
     +,    1.804656    ,    1.865242    ,    1.885966    
     +,    1.868618    ,    1.817974    ,    1.739319    
     +,    1.637674    ,    1.517983    ,    1.384897    
     +,    1.242201    ,    1.092855    ,   0.9399920    
     +,   0.7880806    ,   0.6430438    ,   0.5110264    
     +,   0.3966839    ,   0.3020869    ,   0.2267333    
     +,   0.1683768    ,   0.1240628    ,   9.0889491E-02
     +,   6.6353850E-02,   4.8408937E-02,   3.5411395E-02
     +,   2.6060356E-02,   1.9350637E-02,   1.4529588E-02
     +,   1.1052741E-02,   8.5351029E-03,   6.7056888E-03
     +,   5.3717284E-03,   4.3938877E-03,   3.6702151E-03
     +,   3.1259458E-03,   2.7067605E-03,   2.3739054E-03
     +,   2.1003354E-03,   1.8675699E-03,   1.6633681E-03
     +,   1.4798555E-03,   1.3122335E-03,   1.1577416E-03
     +,   1.0149777E-03,   8.8332628E-04,   7.6261436E-04
     +,   6.5281300E-04,   5.5389653E-04,   4.6571757E-04
     +,   3.8797382E-04,   3.2020727E-04,   2.6180464E-04
     +,   2.1204619E-04,   1.7012772E-04,   1.3521092E-04
     +,   1.0644638E-04,   8.3011371E-05,   6.4124448E-05
     +,   4.9067738E-05,   3.7191774E-05,   2.7924392E-05
     +,   2.0768195E-05,   1.5300295E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_ashz_ttz107_mass = Yx/10.6230733170732
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_ashz_ttz110_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.3168340E-03,   1.3622878E-03
     +,   1.4095227E-03,   1.4586103E-03,   1.5096248E-03
     +,   1.5626450E-03,   1.6177533E-03,   1.6750372E-03
     +,   1.7345870E-03,   1.7965003E-03,   1.8608770E-03
     +,   1.9278236E-03,   1.9974504E-03,   2.0698726E-03
     +,   2.1452114E-03,   2.2235916E-03,   2.3051444E-03
     +,   2.3900040E-03,   2.4783111E-03,   2.5702077E-03
     +,   2.6658415E-03,   2.7653619E-03,   2.8689206E-03
     +,   2.9766769E-03,   3.0887793E-03,   3.2053876E-03
     +,   3.3266554E-03,   3.4527348E-03,   3.5837735E-03
     +,   3.7199166E-03,   3.8612997E-03,   4.0080552E-03
     +,   4.1602999E-03,   4.3181437E-03,   4.4816821E-03
     +,   4.6509933E-03,   4.8261420E-03,   5.0071659E-03
     +,   5.1940964E-03,   5.3869225E-03,   5.5856225E-03
     +,   5.7901423E-03,   6.0003963E-03,   6.2162713E-03
     +,   6.4376206E-03,   6.6642622E-03,   6.8959813E-03
     +,   7.1325246E-03,   7.3736040E-03,   7.6188929E-03
     +,   7.8680273E-03,   8.1206057E-03,   8.3761849E-03
     +,   8.6343065E-03,   8.8944444E-03,   9.1560716E-03
     +,   9.4186142E-03,   9.6814781E-03,   9.9440413E-03
     +,   1.0205662E-02,   1.0465689E-02,   1.0723458E-02
     +,   1.0978283E-02,   1.1229506E-02,   1.1476470E-02
     +,   1.1718504E-02,   1.1955001E-02,   1.2185342E-02
     +,   1.2408976E-02,   1.2625371E-02,   1.2834080E-02
     +,   1.3034682E-02,   1.3226861E-02,   1.3410362E-02
     +,   1.3585044E-02,   1.3750846E-02,   1.3907833E-02
     +,   1.4056184E-02,   1.4196222E-02,   1.4328406E-02
     +,   1.4453340E-02,   1.4571802E-02,   1.4684723E-02
     +,   1.4793219E-02,   1.4898582E-02,   1.5002293E-02
     +,   1.5106008E-02,   1.5211593E-02,   1.5321080E-02
     +,   1.5436701E-02,   1.5560869E-02,   1.5696159E-02
     +,   1.5845323E-02,   1.6011253E-02,   1.6197002E-02
     +,   1.6405720E-02,   1.6640697E-02,   1.6905287E-02
     +,   1.7202945E-02,   1.7537145E-02,   1.7911430E-02
     +,   1.8329328E-02,   1.8794378E-02,   1.9310080E-02
     +,   1.9879881E-02,   2.0507194E-02,   2.1195261E-02
     +,   2.1947218E-02,   2.2766054E-02,   2.3654560E-02
     +,   2.4615200E-02,   2.5650233E-02,   2.6761416E-02
     +,   2.7950183E-02,   2.9217271E-02,   3.0562967E-02
     +,   3.1986594E-02,   3.3486847E-02,   3.5061210E-02
     +,   3.6706287E-02,   3.8417447E-02,   4.0188719E-02
     +,   4.2012699E-02,   4.3880727E-02,   4.5782711E-02
     +,   4.7706973E-02,   4.9640685E-02,   5.1569562E-02
     +,   5.3478479E-02,   5.5351201E-02,   5.7171110E-02
     +,   5.8920994E-02,   6.0583934E-02,   6.2143192E-02
     +,   6.3582890E-02,   6.4888351E-02,   6.6046298E-02
     +,   6.7045420E-02,   6.7876555E-02,   6.8533078E-02
     +,   6.9010958E-02,   6.9308914E-02,   6.9428556E-02
     +,   6.9374301E-02,   6.9153219E-02,   6.8774782E-02
     +,   6.8250813E-02,   6.7594953E-02,   6.6822313E-02
     +,   6.5949194E-02,   6.4992391E-02,   6.3969076E-02
     +,   6.2896177E-02,   6.1789978E-02,   6.0665723E-02
     +,   5.9537552E-02,   5.8418084E-02,   5.7318099E-02
     +,   5.6246668E-02,   5.5211134E-02,   5.4216854E-02
     +,   5.3267553E-02,   5.2365385E-02,   5.1511150E-02
     +,   5.0704356E-02,   4.9943656E-02,   4.9227037E-02
     +,   4.8552088E-02,   4.7916345E-02,   4.7317382E-02
     +,   4.6753306E-02,   4.6222884E-02,   4.5725804E-02
     +,   4.5262888E-02,   4.4836327E-02,   4.4449847E-02
     +,   4.4108853E-02,   4.3820560E-02,   4.3594092E-02
     +,   4.3440394E-02,   4.3372333E-02,   4.3404453E-02
     +,   4.3552961E-02,   4.3835305E-02,   4.4270046E-02
     +,   4.4876520E-02,   4.5674477E-02,   4.6684068E-02
     +,   4.7925651E-02,   4.9420025E-02,   5.1188737E-02
     +,   5.3254988E-02,   5.5644557E-02,   5.8387168E-02
     +,   6.1518621E-02,   6.5082498E-02,   6.9132112E-02
     +,   7.3732279E-02,   7.8960977E-02,   8.4909007E-02
     +,   9.1677703E-02,   9.9374443E-02,   0.1081052    
     +,   0.1179624    ,   0.1290077    ,   0.1412564    
     +,   0.1546589    ,   0.1690874    ,   0.1843337    
     +,   0.2001253    ,   0.2161570    ,   0.2321434    
     +,   0.2478845    ,   0.2633298    ,   0.2786175    
     +,   0.2940718    ,   0.3101494    ,   0.3273335    
     +,   0.3460006    ,   0.3662975    ,   0.3880881    
     +,   0.4109865    ,   0.4344933    ,   0.4582066    
     +,   0.4820411    ,   0.5063751    ,   0.5320549    
     +,   0.5602237    ,   0.5919867    ,   0.6279804    
     +,   0.6679851    ,   0.7107344    ,   0.7540454    
     +,   0.7952690    ,   0.8319542    ,   0.8625109    
     +,   0.8865920    ,   0.9050656    ,   0.9195819    
     +,   0.9318715    ,   0.9430211    ,   0.9529264    
     +,   0.9600742    ,   0.9617100    ,   0.9543688    
     +,   0.9346790    ,   0.9002368    ,   0.8503211    
     +,   0.7862127    ,   0.7110379    ,   0.6291404    
     +,   0.5452440    ,   0.4636525    ,   0.3876848    
     +,   0.3194476    ,   0.2599202    ,   0.2092080    
     +,   0.1668392    ,   0.1320204    ,   0.1038215    
     +,   8.1286192E-02,   6.3489601E-02,   4.9573272E-02
     +,   3.8769167E-02,   3.0414091E-02,   2.3953514E-02
     +,   1.8940482E-02,   1.5026167E-02,   1.1945159E-02
     +,   9.4994353E-03,   7.5432891E-03,   5.9699393E-03
     +,   4.7006025E-03,   3.6762217E-03,   2.8515868E-03
     +,   2.1911983E-03,   1.6662207E-03,   1.2528020E-03
     +,   9.3074352E-04,   6.8289385E-04,   4.9460895E-04
     +,   3.5352723E-04,   2.4929395E-04,   1.7339749E-04
     +,   1.1893849E-04,   8.0442180E-05,   5.3635024E-05
     +,   3.5248362E-05,   2.2829658E-05,   1.4569880E-05
     +,   9.1616212E-06,   5.6755543E-06,   3.4641009E-06
     +,   2.0834527E-06,   1.2353673E-06,   7.2277157E-07
     +,   4.1796164E-07,   2.3959365E-07,   1.3685678E-07
     +,   7.8561790E-08,   4.5934925E-08
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_ashz_ttz110_mass = Yx/8.38169325
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_ashz_ttz115_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.8663845E-03,   3.9738645E-03
     +,   4.0832991E-03,   4.1947104E-03,   4.3081301E-03
     +,   4.4235853E-03,   4.5411116E-03,   4.6607452E-03
     +,   4.7825221E-03,   4.9064904E-03,   5.0326949E-03
     +,   5.1611885E-03,   5.2920259E-03,   5.4252679E-03
     +,   5.5609811E-03,   5.6992369E-03,   5.8401120E-03
     +,   5.9836907E-03,   6.1300630E-03,   6.2793251E-03
     +,   6.4315796E-03,   6.5869386E-03,   6.7455154E-03
     +,   6.9074431E-03,   7.0728427E-03,   7.2418600E-03
     +,   7.4146371E-03,   7.5913281E-03,   7.7720867E-03
     +,   7.9570757E-03,   8.1464639E-03,   8.3404183E-03
     +,   8.5391141E-03,   8.7427218E-03,   8.9514200E-03
     +,   9.1653708E-03,   9.3847523E-03,   9.6097160E-03
     +,   9.8404279E-03,   1.0077016E-02,   1.0319629E-02
     +,   1.0568377E-02,   1.0823358E-02,   1.1084653E-02
     +,   1.1352318E-02,   1.1626391E-02,   1.1906871E-02
     +,   1.2193737E-02,   1.2486929E-02,   1.2786355E-02
     +,   1.3091896E-02,   1.3403390E-02,   1.3720625E-02
     +,   1.4043399E-02,   1.4371412E-02,   1.4704388E-02
     +,   1.5041984E-02,   1.5383847E-02,   1.5729606E-02
     +,   1.6078865E-02,   1.6431252E-02,   1.6786374E-02
     +,   1.7143846E-02,   1.7503375E-02,   1.7864671E-02
     +,   1.8227519E-02,   1.8591834E-02,   1.8957602E-02
     +,   1.9324994E-02,   1.9694330E-02,   2.0066174E-02
     +,   2.0441290E-02,   2.0820776E-02,   2.1205982E-02
     +,   2.1598680E-02,   2.2001015E-02,   2.2415522E-02
     +,   2.2845233E-02,   2.3293659E-02,   2.3764815E-02
     +,   2.4263218E-02,   2.4793914E-02,   2.5362406E-02
     +,   2.5974710E-02,   2.6637176E-02,   2.7356584E-02
     +,   2.8139874E-02,   2.8994184E-02,   2.9926559E-02
     +,   3.0943956E-02,   3.2052994E-02,   3.3259686E-02
     +,   3.4569286E-02,   3.5986174E-02,   3.7513569E-02
     +,   3.9153170E-02,   4.0905353E-02,   4.2768478E-02
     +,   4.4739354E-02,   4.6812512E-02,   4.8980825E-02
     +,   5.1234853E-02,   5.3563457E-02,   5.5953443E-02
     +,   5.8390204E-02,   6.0857616E-02,   6.3338317E-02
     +,   6.5814063E-02,   6.8266250E-02,   7.0676170E-02
     +,   7.3025070E-02,   7.5295016E-02,   7.7468835E-02
     +,   7.9530723E-02,   8.1466198E-02,   8.3262771E-02
     +,   8.4909514E-02,   8.6397886E-02,   8.7721139E-02
     +,   8.8874869E-02,   8.9856602E-02,   9.0665810E-02
     +,   9.1303922E-02,   9.1774017E-02,   9.2080742E-02
     +,   9.2230104E-02,   9.2229165E-02,   9.2086017E-02
     +,   9.1809496E-02,   9.1409013E-02,   9.0894319E-02
     +,   9.0275496E-02,   8.9562573E-02,   8.8765599E-02
     +,   8.7894425E-02,   8.6958542E-02,   8.5967124E-02
     +,   8.4928997E-02,   8.3852232E-02,   8.2744464E-02
     +,   8.1612781E-02,   8.0463670E-02,   7.9302974E-02
     +,   7.8135967E-02,   7.6967426E-02,   7.5801589E-02
     +,   7.4642248E-02,   7.3492818E-02,   7.2356321E-02
     +,   7.1235493E-02,   7.0132703E-02,   6.9050238E-02
     +,   6.7990102E-02,   6.6954084E-02,   6.5943852E-02
     +,   6.4960867E-02,   6.4006537E-02,   6.3081987E-02
     +,   6.2188264E-02,   6.1326385E-02,   6.0497168E-02
     +,   5.9701368E-02,   5.8939792E-02,   5.8213353E-02
     +,   5.7522986E-02,   5.6869850E-02,   5.6255426E-02
     +,   5.5681605E-02,   5.5150636E-02,   5.4665275E-02
     +,   5.4228786E-02,   5.3845022E-02,   5.3518265E-02
     +,   5.3253286E-02,   5.3055126E-02,   5.2929033E-02
     +,   5.2880161E-02,   5.2913543E-02,   5.3033631E-02
     +,   5.3244226E-02,   5.3548135E-02,   5.3947002E-02
     +,   5.4441128E-02,   5.5029523E-02,   5.5709783E-02
     +,   5.6478277E-02,   5.7330381E-02,   5.8260940E-02
     +,   5.9264887E-02,   6.0337633E-02,   6.1476015E-02
     +,   6.2679142E-02,   6.3948974E-02,   6.5291137E-02
     +,   6.6715665E-02,   6.8237282E-02,   6.9875374E-02
     +,   7.1653798E-02,   7.3600397E-02,   7.5745568E-02
     +,   7.8120671E-02,   8.0756143E-02,   8.3679341E-02
     +,   8.6912245E-02,   9.0468854E-02,   9.4354540E-02
     +,   9.8565124E-02,   0.1030874    ,   0.1079022    
     +,   0.1129885    ,   0.1183298    ,   0.1239212    
     +,   0.1297774    ,   0.1359413    ,   0.1424888    
     +,   0.1495319    ,   0.1572163    ,   0.1657162    
     +,   0.1752216    ,   0.1859210    ,   0.1979846    
     +,   0.2115445    ,   0.2266759    ,   0.2433857    
     +,   0.2616067    ,   0.2811980    ,   0.3019514    
     +,   0.3236072    ,   0.3458725    ,   0.3684399    
     +,   0.3910006    ,   0.4132577    ,   0.4349302    
     +,   0.4557467    ,   0.4754314    ,   0.4936942    
     +,   0.5102144    ,   0.5246345    ,   0.5365671    
     +,   0.5456150    ,   0.5513972    ,   0.5535880    
     +,   0.5519512    ,   0.5463650    ,   0.5368363    
     +,   0.5234964    ,   0.5065860    ,   0.4864270    
     +,   0.4633974    ,   0.4379112    ,   0.4104009    
     +,   0.3813125    ,   0.3511081    ,   0.3202659    
     +,   0.2892734    ,   0.2586241    ,   0.2288018    
     +,   0.2002593    ,   0.1733939    ,   0.1485285    
     +,   0.1258987    ,   0.1056434    ,   8.7804437E-02
     +,   7.2337337E-02,   5.9126891E-02,   4.8001911E-02
     +,   3.8755450E-02,   3.1163024E-02,   2.4996500E-02
     +,   2.0035591E-02,   1.6076650E-02,   1.2937821E-02
     +,   1.0460857E-02,   8.5113226E-03,   6.9775311E-03
     +,   5.7685398E-03,   4.8111924E-03,   4.0477775E-03
     +,   3.4331519E-03,   2.9325956E-03,   2.5195712E-03
     +,   2.1741039E-03,   1.8812208E-03,   1.6298589E-03
     +,   1.4118409E-03,   1.2211998E-03,   1.0535365E-03
     +,   9.0560195E-04,   7.7496719E-04,   6.5973401E-04
     +,   5.5838883E-04,   4.6963966E-04,   3.9235473E-04
     +,   3.2548213E-04,   2.6803708E-04,   2.1906858E-04
     +,   1.7766793E-04,   1.4295954E-04,   1.1411621E-04
     +,   9.0357578E-05,   7.0964219E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_ashz_ttz115_mass = Yx/6.3588
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_ashz_ttz120_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.6671998E-03,   3.7753808E-03
     +,   3.8859381E-03,   3.9988994E-03,   4.1142893E-03
     +,   4.2321286E-03,   4.3524341E-03,   4.4752168E-03
     +,   4.6004788E-03,   4.7282241E-03,   4.8584407E-03
     +,   4.9911113E-03,   5.1262127E-03,   5.2637090E-03
     +,   5.4035550E-03,   5.5456976E-03,   5.6900713E-03
     +,   5.8365995E-03,   5.9851976E-03,   6.1357636E-03
     +,   6.2881922E-03,   6.4423624E-03,   6.5981415E-03
     +,   6.7553986E-03,   6.9139726E-03,   7.0737177E-03
     +,   7.2344667E-03,   7.3960507E-03,   7.5583016E-03
     +,   7.7210381E-03,   7.8840898E-03,   8.0472864E-03
     +,   8.2104560E-03,   8.3734402E-03,   8.5360864E-03
     +,   8.6982548E-03,   8.8598225E-03,   9.0206815E-03
     +,   9.1807498E-03,   9.3399612E-03,   9.4982870E-03
     +,   9.6557215E-03,   9.8122945E-03,   9.9680750E-03
     +,   1.0123166E-02,   1.0277721E-02,   1.0431932E-02
     +,   1.0586042E-02,   1.0740349E-02,   1.0895202E-02
     +,   1.1051007E-02,   1.1208230E-02,   1.1367399E-02
     +,   1.1529108E-02,   1.1694004E-02,   1.1862818E-02
     +,   1.2036337E-02,   1.2215426E-02,   1.2400998E-02
     +,   1.2594054E-02,   1.2795649E-02,   1.3006908E-02
     +,   1.3228994E-02,   1.3463141E-02,   1.3710644E-02
     +,   1.3972799E-02,   1.4250964E-02,   1.4546489E-02
     +,   1.4860765E-02,   1.5195139E-02,   1.5550964E-02
     +,   1.5929528E-02,   1.6332110E-02,   1.6759854E-02
     +,   1.7213868E-02,   1.7695159E-02,   1.8204555E-02
     +,   1.8742777E-02,   1.9310430E-02,   1.9907948E-02
     +,   2.0535566E-02,   2.1193421E-02,   2.1881426E-02
     +,   2.2599420E-02,   2.3347035E-02,   2.4123857E-02
     +,   2.4929335E-02,   2.5762931E-02,   2.6623989E-02
     +,   2.7511993E-02,   2.8426498E-02,   2.9367076E-02
     +,   3.0333528E-02,   3.1325892E-02,   3.2344475E-02
     +,   3.3389799E-02,   3.4462798E-02,   3.5564627E-02
     +,   3.6696941E-02,   3.7861530E-02,   3.9060656E-02
     +,   4.0296655E-02,   4.1572217E-02,   4.2889927E-02
     +,   4.4252463E-02,   4.5662366E-02,   4.7121804E-02
     +,   4.8632424E-02,   5.0195396E-02,   5.1811129E-02
     +,   5.3478796E-02,   5.5196822E-02,   5.6962047E-02
     +,   5.8770176E-02,   6.0615242E-02,   6.2489975E-02
     +,   6.4385258E-02,   6.6290781E-02,   6.8194486E-02
     +,   7.0083141E-02,   7.1942411E-02,   7.3756881E-02
     +,   7.5510405E-02,   7.7186480E-02,   7.8768656E-02
     +,   8.0240421E-02,   8.1586100E-02,   8.2790732E-02
     +,   8.3840884E-02,   8.4724277E-02,   8.5430905E-02
     +,   8.5952483E-02,   8.6283244E-02,   8.6419642E-02
     +,   8.6360745E-02,   8.6108029E-02,   8.5665390E-02
     +,   8.5039176E-02,   8.4237806E-02,   8.3271787E-02
     +,   8.2153253E-02,   8.0895923E-02,   7.9514526E-02
     +,   7.8024641E-02,   7.6442458E-02,   7.4784189E-02
     +,   7.3066004E-02,   7.1303710E-02,   6.9512494E-02
     +,   6.7706607E-02,   6.5899216E-02,   6.4102545E-02
     +,   6.2327608E-02,   6.0584012E-02,   5.8880158E-02
     +,   5.7223439E-02,   5.5620033E-02,   5.4075111E-02
     +,   5.2592926E-02,   5.1177107E-02,   4.9830519E-02
     +,   4.8555560E-02,   4.7354292E-02,   4.6228476E-02
     +,   4.5179531E-02,   4.4208683E-02,   4.3317053E-02
     +,   4.2505536E-02,   4.1774794E-02,   4.1125152E-02
     +,   4.0556662E-02,   4.0068891E-02,   3.9660886E-02
     +,   3.9331056E-02,   3.9077260E-02,   3.8896538E-02
     +,   3.8785171E-02,   3.8738769E-02,   3.8752198E-02
     +,   3.8819633E-02,   3.8934760E-02,   3.9090857E-02
     +,   3.9280929E-02,   3.9497938E-02,   3.9735083E-02
     +,   3.9985813E-02,   4.0244326E-02,   4.0505521E-02
     +,   4.0765416E-02,   4.1021105E-02,   4.1271131E-02
     +,   4.1515414E-02,   4.1755412E-02,   4.1994128E-02
     +,   4.2236157E-02,   4.2487696E-02,   4.2756584E-02
     +,   4.3052122E-02,   4.3385338E-02,   4.3768890E-02
     +,   4.4217035E-02,   4.4745829E-02,   4.5373093E-02
     +,   4.6118457E-02,   4.7003146E-02,   4.8050169E-02
     +,   4.9283799E-02,   5.0729245E-02,   5.2412141E-02
     +,   5.4358058E-02,   5.6591462E-02,   5.9135154E-02
     +,   6.2009297E-02,   6.5231070E-02,   6.8814084E-02
     +,   7.2767973E-02,   7.7098697E-02,   8.1809558E-02
     +,   8.6901717E-02,   9.2374913E-02,   9.8229922E-02
     +,   0.1044692    ,   0.1110978    ,   0.1181243    
     +,   0.1255616    ,   0.1334257    ,   0.1417332    
     +,   0.1505001    ,   0.1597384    ,   0.1694514    
     +,   0.1796292    ,   0.1902438    ,   0.2012450    
     +,   0.2125561    ,   0.2240686    ,   0.2356430    
     +,   0.2471060    ,   0.2582518    ,   0.2688465    
     +,   0.2786334    ,   0.2873413    ,   0.2946942    
     +,   0.3004235    ,   0.3042819    ,   0.3060562    
     +,   0.3055807    ,   0.3027492    ,   0.2975225    
     +,   0.2899356    ,   0.2800979    ,   0.2681909    
     +,   0.2544596    ,   0.2392038    ,   0.2227624    
     +,   0.2054965    ,   0.1877741    ,   0.1699537    
     +,   0.1523704    ,   0.1353211    ,   0.1190574    
     +,   0.1037813    ,   8.9641631E-02,   7.6733895E-02
     +,   6.5105587E-02,   5.4762300E-02,   4.5672365E-02
     +,   3.7775576E-02,   3.0991238E-02,   2.5224404E-02
     +,   2.0371955E-02,   1.6328506E-02,   1.2990765E-02
     +,   1.0260405E-02,   8.0461577E-03,   6.2654261E-03
     +,   4.8450269E-03,   3.7208891E-03,   2.8381047E-03
     +,   2.1500185E-03,   1.6176888E-03,   1.2088367E-03
     +,   8.9711667E-04,   6.6115265E-04,   4.8383613E-04
     +,   3.5154913E-04,   2.5358511E-04,   1.8157293E-04
     +,   1.2903333E-04,   9.0995607E-05,   6.3668980E-05
     +,   4.4193963E-05,   3.0425777E-05,   2.0773008E-05
     +,   1.4062082E-05,   9.4368634E-06,   6.2769313E-06
     +,   4.1375765E-06,   2.7023352E-06,   1.7485122E-06
     +,   1.1206092E-06,   7.1128341E-07
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_ashz_ttz120_mass = Yx/4.0905252
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_ashz_ttz60_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.8467540E-03,   5.2633584E-03
     +,   5.7152021E-03,   6.2072161E-03,   6.7456472E-03
     +,   7.3383097E-03,   7.9948558E-03,   8.7270597E-03
     +,   9.5490394E-03,   1.0477575E-02,   1.1532194E-02
     +,   1.2735375E-02,   1.4112552E-02,   1.5692050E-02
     +,   1.7504826E-02,   1.9584043E-02,   2.1964429E-02
     +,   2.4681451E-02,   2.7770132E-02,   3.1263884E-02
     +,   3.5192940E-02,   3.9582964E-02,   4.4453595E-02
     +,   4.9817633E-02,   5.5679500E-02,   6.2036179E-02
     +,   6.8876900E-02,   7.6184742E-02,   8.3938345E-02
     +,   9.2114381E-02,   0.1006897    ,   0.1096433    
     +,   0.1189571    ,   0.1286159    ,   0.1386042    
     +,   0.1489026    ,   0.1594811    ,   0.1702918    
     +,   0.1812623    ,   0.1922872    ,   0.2032261    
     +,   0.2139010    ,   0.2241019    ,   0.2335939    
     +,   0.2421324    ,   0.2494785    ,   0.2554184    
     +,   0.2597813    ,   0.2624554    ,   0.2633984    
     +,   0.2626422    ,   0.2602899    ,   0.2565078    
     +,   0.2515089    ,   0.2455368    ,   0.2388441    
     +,   0.2316741    ,   0.2242463    ,   0.2167438    
     +,   0.2093093    ,   0.2020429    ,   0.1950065    
     +,   0.1882309    ,   0.1817226    ,   0.1754732    
     +,   0.1694670    ,   0.1636851    ,   0.1581106    
     +,   0.1527294    ,   0.1475304    ,   0.1425050    
     +,   0.1376461    ,   0.1329460    ,   0.1283963    
     +,   0.1239868    ,   0.1197055    ,   0.1155402    
     +,   0.1114779    ,   0.1075067    ,   0.1036168    
     +,   9.9802271E-02,   9.6061237E-02,   9.2398003E-02
     +,   8.8822395E-02,   8.5351169E-02,   8.2007006E-02
     +,   7.8818396E-02,   7.5818293E-02,   7.3042847E-02
     +,   7.0529312E-02,   6.8314128E-02,   6.6431217E-02
     +,   6.4909436E-02,   6.3770898E-02,   6.3029662E-02
     +,   6.2690645E-02,   6.2749125E-02,   6.3190751E-02
     +,   6.3992321E-02,   6.5122612E-02,   6.6544078E-02
     +,   6.8214454E-02,   7.0088945E-02,   7.2121918E-02
     +,   7.4268900E-02,   7.6488465E-02,   7.8743115E-02
     +,   8.1000574E-02,   8.3234340E-02,   8.5423887E-02
     +,   8.7554045E-02,   8.9614943E-02,   9.1600589E-02
     +,   9.3508318E-02,   9.5337182E-02,   9.7087309E-02
     +,   9.8758340E-02,   0.1003491    ,   0.1018564    
     +,   0.1032751    ,   0.1045975    ,   0.1058137    
     +,   0.1069120    ,   0.1078789    ,   0.1087001    
     +,   0.1093608    ,   0.1098466    ,   0.1101440    
     +,   0.1102410    ,   0.1101275    ,   0.1097959    
     +,   0.1092410    ,   0.1084609    ,   0.1074561    
     +,   0.1062307    ,   0.1047913    ,   0.1031475    
     +,   0.1013118    ,   9.9298917E-02,   9.7125962E-02
     +,   9.4811998E-02,   9.2377864E-02,   8.9845456E-02
     +,   8.7237589E-02,   8.4577739E-02,   8.1889227E-02
     +,   7.9194851E-02,   7.6516747E-02,   7.3875777E-02
     +,   7.1290962E-02,   6.8779238E-02,   6.6355519E-02
     +,   6.4032122E-02,   6.1818685E-02,   5.9722111E-02
     +,   5.7746876E-02,   5.5894919E-02,   5.4165743E-02
     +,   5.2556764E-02,   5.1063776E-02,   4.9680971E-02
     +,   4.8401356E-02,   4.7217295E-02,   4.6120636E-02
     +,   4.5102939E-02,   4.4155896E-02,   4.3271627E-02
     +,   4.2442672E-02,   4.1662209E-02,   4.0924162E-02
     +,   4.0223237E-02,   3.9555009E-02,   3.8915735E-02
     +,   3.8302388E-02,   3.7712637E-02,   3.7144665E-02
     +,   3.6597066E-02,   3.6068801E-02,   3.5559081E-02
     +,   3.5067216E-02,   3.4592528E-02,   3.4134407E-02
     +,   3.3692077E-02,   3.3264644E-02,   3.2851066E-02
     +,   3.2450125E-02,   3.2060422E-02,   3.1680424E-02
     +,   3.1308405E-02,   3.0942589E-02,   3.0581089E-02
     +,   3.0221991E-02,   2.9863397E-02,   2.9503467E-02
     +,   2.9140409E-02,   2.8772552E-02,   2.8398387E-02
     +,   2.8016575E-02,   2.7625944E-02,   2.7225498E-02
     +,   2.6814498E-02,   2.6392382E-02,   2.5958780E-02
     +,   2.5513506E-02,   2.5056595E-02,   2.4588233E-02
     +,   2.4108725E-02,   2.3618558E-02,   2.3118358E-02
     +,   2.2608787E-02,   2.2090608E-02,   2.1564694E-02
     +,   2.1031963E-02,   2.0493338E-02,   1.9949781E-02
     +,   1.9402290E-02,   1.8851880E-02,   1.8299533E-02
     +,   1.7746214E-02,   1.7192937E-02,   1.6640643E-02
     +,   1.6090246E-02,   1.5542682E-02,   1.4998853E-02
     +,   1.4459595E-02,   1.3925713E-02,   1.3398021E-02
     +,   1.2877282E-02,   1.2364203E-02,   1.1859446E-02
     +,   1.1363669E-02,   1.0877484E-02,   1.0401430E-02
     +,   9.9359965E-03,   9.4816815E-03,   9.0388842E-03
     +,   8.6079547E-03,   8.1892312E-03,   7.7829915E-03
     +,   7.3894444E-03,   7.0087477E-03,   6.6410373E-03
     +,   6.2864004E-03,   5.9448555E-03,   5.6163748E-03
     +,   5.3009158E-03,   4.9983887E-03,   4.7086510E-03
     +,   4.4315229E-03,   4.1668219E-03,   3.9143087E-03
     +,   3.6737181E-03,   3.4447792E-03,   3.2271992E-03
     +,   3.0206519E-03,   2.8248008E-03,   2.6393086E-03
     +,   2.4638299E-03,   2.2979991E-03,   2.1414484E-03
     +,   1.9938194E-03,   1.8547516E-03,   1.7238766E-03
     +,   1.6008313E-03,   1.4852691E-03,   1.3768367E-03
     +,   1.2751895E-03,   1.1799975E-03,   1.0909376E-03
     +,   1.0076916E-03,   9.2995109E-04,   8.5742242E-04
     +,   7.8982278E-04,   7.2687474E-04,   6.6831236E-04
     +,   6.1388576E-04,   5.6334835E-04,   5.1647122E-04
     +,   4.7302915E-04,   4.3281305E-04,   3.9561829E-04
     +,   3.6125517E-04,   3.2953869E-04,   3.0029731E-04
     +,   2.7336465E-04,   2.4858632E-04,   2.2581403E-04
     +,   2.0490738E-04,   1.8573609E-04,   1.6817455E-04
     +,   1.5210682E-04,   1.3742164E-04,   1.2401637E-04
     +,   1.1179291E-04,   1.0066087E-04,   9.0534115E-05
     +,   8.1333463E-05,   7.2983719E-05,   6.5415828E-05
     +,   5.8564521E-05,   5.2369902E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_ashz_ttz60_mass = Yx/4.46352433333333
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_ashz_ttz65_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.0823525E-03,   2.1727174E-03
     +,   2.2724997E-03,   2.3830005E-03,   2.5056642E-03
     +,   2.6420841E-03,   2.7940045E-03,   2.9633211E-03
     +,   3.1520794E-03,   3.3624873E-03,   3.5968996E-03
     +,   3.8578336E-03,   4.1479878E-03,   4.4702599E-03
     +,   4.8277914E-03,   5.2240188E-03,   5.6627598E-03
     +,   6.1483043E-03,   6.6855475E-03,   7.2801290E-03
     +,   7.9385852E-03,   8.6685335E-03,   9.4787898E-03
     +,   1.0379576E-02,   1.1382457E-02,   1.2500559E-02
     +,   1.3748351E-02,   1.5141533E-02,   1.6696809E-02
     +,   1.8431524E-02,   2.0363281E-02,   2.2509614E-02
     +,   2.4887647E-02,   2.7514128E-02,   3.0405585E-02
     +,   3.3579100E-02,   3.7053466E-02,   4.0850952E-02
     +,   4.4999953E-02,   4.9536880E-02,   5.4509956E-02
     +,   5.9980866E-02,   6.6026896E-02,   7.2741359E-02
     +,   8.0231987E-02,   8.8617750E-02,   9.8022915E-02
     +,   0.1085694    ,   0.1203669    ,   0.1335033    
     +,   0.1480340    ,   0.1639733    ,   0.1812872    
     +,   0.1998920    ,   0.2196498    ,   0.2403761    
     +,   0.2618401    ,   0.2837741    ,   0.3058773    
     +,   0.3278215    ,   0.3492549    ,   0.3698043    
     +,   0.3890762    ,   0.4066668    ,   0.4221680    
     +,   0.4351833    ,   0.4453564    ,   0.4523955    
     +,   0.4561050    ,   0.4564136    ,   0.4533861    
     +,   0.4472280    ,   0.4382642    ,   0.4269073    
     +,   0.4136133    ,   0.3988352    ,   0.3829888    
     +,   0.3664284    ,   0.3494438    ,   0.3322729    
     +,   0.3151276    ,   0.2982113    ,   0.2817431    
     +,   0.2659550    ,   0.2510865    ,   0.2373587    
     +,   0.2249514    ,   0.2139749    ,   0.2044546    
     +,   0.1963243    ,   0.1894340    ,   0.1835689    
     +,   0.1784745    ,   0.1738845    ,   0.1695490    
     +,   0.1652562    ,   0.1608476    ,   0.1562262    
     +,   0.1513564    ,   0.1462594    ,   0.1410021    
     +,   0.1356863    ,   0.1304339    ,   0.1253751    
     +,   0.1206363    ,   0.1163309    ,   0.1125532    
     +,   0.1093735    ,   0.1068359    ,   0.1049592    
     +,   0.1037383    ,   0.1031471    ,   0.1031422    
     +,   0.1036670    ,   0.1046556    ,   0.1060363    
     +,   0.1077350    ,   0.1096777    ,   0.1117917    
     +,   0.1140077    ,   0.1162597    ,   0.1184854    
     +,   0.1206265    ,   0.1226289    ,   0.1244427    
     +,   0.1260229    ,   0.1273305    ,   0.1283332    
     +,   0.1290072    ,   0.1293381    ,   0.1293223    
     +,   0.1289672    ,   0.1282924    ,   0.1273285    
     +,   0.1261157    ,   0.1247029    ,   0.1231444    
     +,   0.1214974    ,   0.1198188    ,   0.1181618    
     +,   0.1165736    ,   0.1150922    ,   0.1137452    
     +,   0.1125479    ,   0.1115038    ,   0.1106042    
     +,   0.1098297    ,   0.1091518    ,   0.1085350    
     +,   0.1079390    ,   0.1073215    ,   0.1066401    
     +,   0.1058550    ,   0.1049304    ,   0.1038364    
     +,   0.1025501    ,   0.1010557    ,   9.9345572E-02
     +,   9.7419262E-02,   9.5283829E-02,   9.2952475E-02
     +,   9.0444036E-02,   8.7781824E-02,   8.4992558E-02
     +,   8.2105033E-02,   7.9149045E-02,   7.6154865E-02
     +,   7.3151939E-02,   7.0167854E-02,   6.7228109E-02
     +,   6.4355679E-02,   6.1570615E-02,   5.8889441E-02
     +,   5.6325536E-02,   5.3889282E-02,   5.1587708E-02
     +,   4.9424965E-02,   4.7402788E-02,   4.5520589E-02
     +,   4.3775585E-02,   4.2163402E-02,   4.0678382E-02
     +,   3.9313857E-02,   3.8062263E-02,   3.6915511E-02
     +,   3.5865352E-02,   3.4903374E-02,   3.4021232E-02
     +,   3.3210751E-02,   3.2464169E-02,   3.1774092E-02
     +,   3.1133564E-02,   3.0536244E-02,   2.9976290E-02
     +,   2.9448437E-02,   2.8948002E-02,   2.8470887E-02
     +,   2.8013548E-02,   2.7572943E-02,   2.7146522E-02
     +,   2.6732242E-02,   2.6328446E-02,   2.5933890E-02
     +,   2.5547624E-02,   2.5169078E-02,   2.4797874E-02
     +,   2.4433868E-02,   2.4077106E-02,   2.3727795E-02
     +,   2.3386193E-02,   2.3052650E-02,   2.2727545E-02
     +,   2.2411300E-02,   2.2104265E-02,   2.1806752E-02
     +,   2.1519043E-02,   2.1241313E-02,   2.0973636E-02
     +,   2.0715967E-02,   2.0468190E-02,   2.0230021E-02
     +,   2.0001078E-02,   1.9780865E-02,   1.9568773E-02
     +,   1.9364078E-02,   1.9165957E-02,   1.8973511E-02
     +,   1.8785786E-02,   1.8601730E-02,   1.8420279E-02
     +,   1.8240340E-02,   1.8060798E-02,   1.7880548E-02
     +,   1.7698495E-02,   1.7513603E-02,   1.7324854E-02
     +,   1.7131291E-02,   1.6932050E-02,   1.6726343E-02
     +,   1.6513441E-02,   1.6292736E-02,   1.6063718E-02
     +,   1.5825981E-02,   1.5579225E-02,   1.5323237E-02
     +,   1.5057935E-02,   1.4783352E-02,   1.4499590E-02
     +,   1.4206855E-02,   1.3905479E-02,   1.3595841E-02
     +,   1.3278405E-02,   1.2953732E-02,   1.2622442E-02
     +,   1.2285199E-02,   1.1942706E-02,   1.1595736E-02
     +,   1.1245091E-02,   1.0891577E-02,   1.0536013E-02
     +,   1.0179251E-02,   9.8221442E-03,   9.4655147E-03
     +,   9.1101732E-03,   8.7569421E-03,   8.4065888E-03
     +,   8.0598518E-03,   7.7174497E-03,   7.3800716E-03
     +,   7.0483359E-03,   6.7228219E-03,   6.4040781E-03
     +,   6.0926117E-03,   5.7888497E-03,   5.4931780E-03
     +,   5.2059582E-03,   4.9274643E-03,   4.6579540E-03
     +,   4.3976079E-03,   4.1465899E-03,   3.9049867E-03
     +,   3.6728720E-03,   3.4502510E-03,   3.2371173E-03
     +,   3.0334012E-03,   2.8390274E-03,   2.6538677E-03
     +,   2.4777695E-03,   2.3105694E-03,   2.1520602E-03
     +,   2.0020376E-03,   1.8602570E-03,   1.7264804E-03
     +,   1.6004380E-03,   1.4818688E-03,   1.3704860E-03
     +,   1.2660138E-03,   1.1681581E-03,   1.0766364E-03
     +,   9.9115330E-04,   9.1142632E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_ashz_ttz65_mass = Yx/6.152139
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_ashz_ttz70_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.1351015E-03,   2.2097458E-03
     +,   2.2853708E-03,   2.3618457E-03,   2.4390349E-03
     +,   2.5167968E-03,   2.5949904E-03,   2.6734720E-03
     +,   2.7521022E-03,   2.8307477E-03,   2.9092820E-03
     +,   2.9875929E-03,   3.0655859E-03,   3.1431881E-03
     +,   3.2203558E-03,   3.2970805E-03,   3.3733947E-03
     +,   3.4493827E-03,   3.5251859E-03,   3.6010153E-03
     +,   3.6771630E-03,   3.7540130E-03,   3.8320555E-03
     +,   3.9119101E-03,   3.9943345E-03,   4.0802611E-03
     +,   4.1708169E-03,   4.2673619E-03,   4.3715327E-03
     +,   4.4852914E-03,   4.6109888E-03,   4.7514322E-03
     +,   4.9099782E-03,   5.0906171E-03,   5.2980864E-03
     +,   5.5379779E-03,   5.8168541E-03,   6.1423532E-03
     +,   6.5233200E-03,   6.9698077E-03,   7.4932254E-03
     +,   8.1062568E-03,   8.8228732E-03,   9.6582426E-03
     +,   1.0628628E-02,   1.1751284E-02,   1.3044377E-02
     +,   1.4526986E-02,   1.6219223E-02,   1.8142475E-02
     +,   2.0319834E-02,   2.2776624E-02,   2.5540879E-02
     +,   2.8644079E-02,   3.2120772E-02,   3.6009181E-02
     +,   4.0350005E-02,   4.5185857E-02,   5.0560348E-02
     +,   5.6517575E-02,   6.3103020E-02,   7.0365950E-02
     +,   7.8363650E-02,   8.7169364E-02,   9.6880317E-02
     +,   0.1076259    ,   0.1195776    ,   0.1329500    
     +,   0.1480016    ,   0.1650207    ,   0.1843090    
     +,   0.2061492    ,   0.2307742    ,   0.2583237    
     +,   0.2888133    ,   0.3221018    ,   0.3578675    
     +,   0.3956009    ,   0.4346117    ,   0.4740548    
     +,   0.5129746    ,   0.5503861    ,   0.5853532    
     +,   0.6170807    ,   0.6449557    ,   0.6685592    
     +,   0.6876081    ,   0.7018716    ,   0.7110888    
     +,   0.7149335    ,   0.7130468    ,   0.7051270    
     +,   0.6910563    ,   0.6710050    ,   0.6455015    
     +,   0.6154471    ,   0.5820671    ,   0.5468276    
     +,   0.5113007    ,   0.4770164    ,   0.4452988    
     +,   0.4171378    ,   0.3931077    ,   0.3733647    
     +,   0.3577027    ,   0.3456633    ,   0.3366491    
     +,   0.3300198    ,   0.3251551    ,   0.3214811    
     +,   0.3184755    ,   0.3156657    ,   0.3126337    
     +,   0.3090312    ,   0.3046023    ,   0.2992061    
     +,   0.2928290    ,   0.2855794    ,   0.2776653    
     +,   0.2693583    ,   0.2609499    ,   0.2527117    
     +,   0.2448643    ,   0.2375583    ,   0.2308693    
     +,   0.2248069    ,   0.2193267    ,   0.2143512    
     +,   0.2097844    ,   0.2055309    ,   0.2015049    
     +,   0.1976408    ,   0.1938941    ,   0.1902423    
     +,   0.1866807    ,   0.1832157    ,   0.1798586    
     +,   0.1766182    ,   0.1734944    ,   0.1704768    
     +,   0.1675434    ,   0.1646634    ,   0.1618013    
     +,   0.1589217    ,   0.1559948    ,   0.1529991    
     +,   0.1499235    ,   0.1467670    ,   0.1435371    
     +,   0.1402465    ,   0.1369090    ,   0.1335382    
     +,   0.1301433    ,   0.1267283    ,   0.1232926    
     +,   0.1198317    ,   0.1163391    ,   0.1128078    
     +,   0.1092335    ,   0.1056157    ,   0.1019587    
     +,   9.8272532E-02,   9.4572417E-02,   9.0878174E-02
     +,   8.7212488E-02,   8.3599687E-02,   8.0064394E-02
     +,   7.6630078E-02,   7.3317632E-02,   7.0144840E-02
     +,   6.7126267E-02,   6.4272866E-02,   6.1592042E-02
     +,   5.9088293E-02,   5.6763772E-02,   5.4618467E-02
     +,   5.2650936E-02,   5.0858695E-02,   4.9238510E-02
     +,   4.7786489E-02,   4.6498135E-02,   4.5368645E-02
     +,   4.4392653E-02,   4.3564100E-02,   4.2876247E-02
     +,   4.2321522E-02,   4.1891638E-02,   4.1577261E-02
     +,   4.1368313E-02,   4.1253954E-02,   4.1222569E-02
     +,   4.1262057E-02,   4.1359860E-02,   4.1503202E-02
     +,   4.1679278E-02,   4.1875340E-02,   4.2079002E-02
     +,   4.2278294E-02,   4.2461924E-02,   4.2619355E-02
     +,   4.2740937E-02,   4.2818025E-02,   4.2843036E-02
     +,   4.2809602E-02,   4.2712476E-02,   4.2547699E-02
     +,   4.2312469E-02,   4.2005192E-02,   4.1625481E-02
     +,   4.1173995E-02,   4.0652424E-02,   4.0063415E-02
     +,   3.9410461E-02,   3.8697738E-02,   3.7930053E-02
     +,   3.7112705E-02,   3.6251396E-02,   3.5351980E-02
     +,   3.4420487E-02,   3.3463020E-02,   3.2485530E-02
     +,   3.1493783E-02,   3.0493358E-02,   2.9489521E-02
     +,   2.8487109E-02,   2.7490538E-02,   2.6503857E-02
     +,   2.5530649E-02,   2.4573989E-02,   2.3636479E-02
     +,   2.2720348E-02,   2.1827413E-02,   2.0959014E-02
     +,   2.0116147E-02,   1.9299548E-02,   1.8509584E-02
     +,   1.7746370E-02,   1.7009841E-02,   1.6299745E-02
     +,   1.5615634E-02,   1.4956939E-02,   1.4323042E-02
     +,   1.3713257E-02,   1.3126811E-02,   1.2562910E-02
     +,   1.2020782E-02,   1.1499668E-02,   1.0998776E-02
     +,   1.0517357E-02,   1.0054723E-02,   9.6101770E-03
     +,   9.1830604E-03,   8.7727783E-03,   8.3787702E-03
     +,   8.0004800E-03,   7.6373923E-03,   7.2890343E-03
     +,   6.9549689E-03,   6.6347523E-03,   6.3279648E-03
     +,   6.0342229E-03,   5.7531549E-03,   5.4843808E-03
     +,   5.2275294E-03,   4.9822610E-03,   4.7482178E-03
     +,   4.5250389E-03,   4.3123858E-03,   4.1099149E-03
     +,   3.9172722E-03,   3.7341039E-03,   3.5600665E-03
     +,   3.3948163E-03,   3.2380007E-03,   3.0892685E-03
     +,   2.9482828E-03,   2.8146938E-03,   2.6881711E-03
     +,   2.5683730E-03,   2.4549786E-03,   2.3476584E-03
     +,   2.2461044E-03,   2.1500033E-03,   2.0590625E-03
     +,   1.9729875E-03,   1.8915043E-03,   1.8143414E-03
     +,   1.7412382E-03,   1.6719520E-03,   1.6062417E-03
     +,   1.5438871E-03,   1.4846703E-03,   1.4283924E-03
     +,   1.3748583E-03,   1.3238911E-03,   1.2753176E-03
     +,   1.2289813E-03,   1.1847306E-03,   1.1424287E-03
     +,   1.1019430E-03,   1.0631548E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_ashz_ttz70_mass = Yx/8.14005885
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_ashz_ttz75_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.3692867E-03,   2.4635596E-03
     +,   2.5595555E-03,   2.6571888E-03,   2.7563733E-03
     +,   2.8570218E-03,   2.9590509E-03,   3.0623823E-03
     +,   3.1669438E-03,   3.2726796E-03,   3.3795424E-03
     +,   3.4875050E-03,   3.5965622E-03,   3.7067356E-03
     +,   3.8180759E-03,   3.9306716E-03,   4.0446515E-03
     +,   4.1601891E-03,   4.2775110E-03,   4.3968977E-03
     +,   4.5186952E-03,   4.6433141E-03,   4.7712368E-03
     +,   4.9030320E-03,   5.0393348E-03,   5.1808828E-03
     +,   5.3284969E-03,   5.4830927E-03,   5.6456877E-03
     +,   5.8173942E-03,   5.9994329E-03,   6.1931205E-03
     +,   6.3998844E-03,   6.6212546E-03,   6.8588564E-03
     +,   7.1144216E-03,   7.3897657E-03,   7.6867915E-03
     +,   8.0074919E-03,   8.3538899E-03,   8.7280851E-03
     +,   9.1321869E-03,   9.5682973E-03,   1.0038493E-02
     +,   1.0544780E-02,   1.1089052E-02,   1.1673048E-02
     +,   1.2298306E-02,   1.2966099E-02,   1.3677416E-02
     +,   1.4432881E-02,   1.5232734E-02,   1.6076801E-02
     +,   1.6964551E-02,   1.7894942E-02,   1.8866729E-02
     +,   1.9878346E-02,   2.0928171E-02,   2.2014694E-02
     +,   2.3136804E-02,   2.4294112E-02,   2.5487442E-02
     +,   2.6719183E-02,   2.7994076E-02,   2.9319748E-02
     +,   3.0707346E-02,   3.2172561E-02,   3.3736143E-02
     +,   3.5425112E-02,   3.7273142E-02,   3.9321732E-02
     +,   4.1620214E-02,   4.4226293E-02,   4.7204774E-02
     +,   5.0626561E-02,   5.4565784E-02,   5.9095431E-02
     +,   6.4282775E-02,   7.0184998E-02,   7.6845437E-02
     +,   8.4291726E-02,   9.2541091E-02,   0.1016066    
     +,   0.1115130    ,   0.1223112    ,   0.1340975    
     +,   0.1470262    ,   0.1613212    ,   0.1772779    
     +,   0.1952664    ,   0.2157355    ,   0.2392173    
     +,   0.2663320    ,   0.2977665    ,   0.3341851    
     +,   0.3760458    ,   0.4233519    ,   0.4753959    
     +,   0.5306928    ,   0.5872092    ,   0.6429611    
     +,   0.6967399    ,   0.7486453    ,   0.7999871    
     +,   0.8525067    ,   0.9071662    ,   0.9631361    
     +,    1.017522    ,    1.065952    ,    1.103714    
     +,    1.126968    ,    1.133682    ,    1.124079    
     +,    1.100487    ,    1.066554    ,    1.026043    
     +,   0.9818013    ,   0.9354054    ,   0.8876490    
     +,   0.8393499    ,   0.7918898    ,   0.7471092    
     +,   0.7067349    ,   0.6717862    ,   0.6423265    
     +,   0.6175937    ,   0.5963578    ,   0.5773140    
     +,   0.5593584    ,   0.5417206    ,   0.5239518    
     +,   0.5058443    ,   0.4873274    ,   0.4683959    
     +,   0.4490752    ,   0.4294285    ,   0.4095826    
     +,   0.3897422    ,   0.3701816    ,   0.3512096    
     +,   0.3331154    ,   0.3161161    ,   0.3003221    
     +,   0.2857387    ,   0.2722928    ,   0.2598666    
     +,   0.2483327    ,   0.2375735    ,   0.2274844    
     +,   0.2179666    ,   0.2089196    ,   0.2002378    
     +,   0.1918103    ,   0.1835293    ,   0.1752994    
     +,   0.1670491    ,   0.1587362    ,   0.1503508    
     +,   0.1419142    ,   0.1334762    ,   0.1251071    
     +,   0.1168915    ,   0.1089225    ,   0.1012936    
     +,   9.4093017E-02,   8.7398902E-02,   8.1275739E-02
     +,   7.5771347E-02,   7.0915043E-02,   6.6717759E-02
     +,   6.3173525E-02,   6.0260721E-02,   5.7944752E-02
     +,   5.6181129E-02,   5.4918606E-02,   5.4101452E-02
     +,   5.3672325E-02,   5.3574041E-02,   5.3750973E-02
     +,   5.4150116E-02,   5.4721724E-02,   5.5419631E-02
     +,   5.6201283E-02,   5.7027820E-02,   5.7864137E-02
     +,   5.8678530E-02,   5.9442941E-02,   6.0132794E-02
     +,   6.0727164E-02,   6.1208580E-02,   6.1563388E-02
     +,   6.1781492E-02,   6.1856516E-02,   6.1785597E-02
     +,   6.1569475E-02,   6.1212022E-02,   6.0720183E-02
     +,   6.0103584E-02,   5.9374012E-02,   5.8545068E-02
     +,   5.7631698E-02,   5.6649625E-02,   5.5614877E-02
     +,   5.4543193E-02,   5.3449787E-02,   5.2348677E-02
     +,   5.1252469E-02,   5.0172105E-02,   4.9116634E-02
     +,   4.8092928E-02,   4.7105782E-02,   4.6157937E-02
     +,   4.5250133E-02,   4.4381164E-02,   4.3548208E-02
     +,   4.2747039E-02,   4.1972261E-02,   4.1217588E-02
     +,   4.0476147E-02,   3.9740849E-02,   3.9004527E-02
     +,   3.8260277E-02,   3.7501700E-02,   3.6723103E-02
     +,   3.5919566E-02,   3.5087146E-02,   3.4222972E-02
     +,   3.3325274E-02,   3.2393340E-02,   3.1427480E-02
     +,   3.0429116E-02,   2.9400561E-02,   2.8344931E-02
     +,   2.7266003E-02,   2.6168264E-02,   2.5056520E-02
     +,   2.3935873E-02,   2.2811679E-02,   2.1689335E-02
     +,   2.0574084E-02,   1.9470995E-02,   1.8384950E-02
     +,   1.7320480E-02,   1.6281646E-02,   1.5272067E-02
     +,   1.4294951E-02,   1.3353013E-02,   1.2448428E-02
     +,   1.1582867E-02,   1.0757642E-02,   9.9735223E-03
     +,   9.2308829E-03,   8.5297683E-03,   7.8698797E-03
     +,   7.2505786E-03,   6.6709723E-03,   6.1299880E-03
     +,   5.6263627E-03,   5.1586567E-03,   4.7253165E-03
     +,   4.3247370E-03,   3.9552501E-03,   3.6151297E-03
     +,   3.3026405E-03,   3.0160875E-03,   2.7537637E-03
     +,   2.5140007E-03,   2.2951963E-03,   2.0957978E-03
     +,   1.9143035E-03,   1.7492813E-03,   1.5993826E-03
     +,   1.4633319E-03,   1.3399201E-03,   1.2280166E-03
     +,   1.1265784E-03,   1.0346232E-03,   9.5125457E-04
     +,   8.7563629E-04,   8.0701080E-04,   7.4467674E-04
     +,   6.8800309E-04,   6.3641003E-04,   5.8937928E-04
     +,   5.4643769E-04,   5.0716574E-04,   4.7118292E-04
     +,   4.3814999E-04,   4.0776722E-04,   3.7976453E-04
     +,   3.5390549E-04,   3.2997760E-04,   3.0779597E-04
     +,   2.8719439E-04,   2.6802873E-04,   2.5016951E-04
     +,   2.3350475E-04,   2.1793330E-04,   2.0336788E-04
     +,   1.8972940E-04,   1.7694916E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_ashz_ttz75_mass = Yx/10.557122
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_ashz_ttz80_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.7100157E-03,   2.7607330E-03
     +,   2.8096102E-03,   2.8565349E-03,   2.9014014E-03
     +,   2.9441116E-03,   2.9845752E-03,   3.0227127E-03
     +,   3.0584536E-03,   3.0917404E-03,   3.1225265E-03
     +,   3.1507784E-03,   3.1764759E-03,   3.1996146E-03
     +,   3.2202066E-03,   3.2382782E-03,   3.2538760E-03
     +,   3.2670635E-03,   3.2779274E-03,   3.2865717E-03
     +,   3.2931264E-03,   3.2977425E-03,   3.3006007E-03
     +,   3.3019050E-03,   3.3018920E-03,   3.3008270E-03
     +,   3.2990118E-03,   3.2967820E-03,   3.2945138E-03
     +,   3.2926248E-03,   3.2915778E-03,   3.2918847E-03
     +,   3.2941094E-03,   3.2988712E-03,   3.3068508E-03
     +,   3.3187915E-03,   3.3355041E-03,   3.3578705E-03
     +,   3.3868470E-03,   3.4234640E-03,   3.4688336E-03
     +,   3.5241432E-03,   3.5906576E-03,   3.6697180E-03
     +,   3.7627360E-03,   3.8711841E-03,   3.9965911E-03
     +,   4.1405298E-03,   4.3045958E-03,   4.4903955E-03
     +,   4.6995217E-03,   4.9335286E-03,   5.1939050E-03
     +,   5.4820534E-03,   5.7992218E-03,   6.1465264E-03
     +,   6.5248641E-03,   6.9349078E-03,   7.3770587E-03
     +,   7.8514293E-03,   8.3578052E-03,   8.8956458E-03
     +,   9.4640292E-03,   1.0061719E-02,   1.0687155E-02
     +,   1.1338406E-02,   1.2013350E-02,   1.2709580E-02
     +,   1.3424653E-02,   1.4155990E-02,   1.4901223E-02
     +,   1.5658082E-02,   1.6424788E-02,   1.7200023E-02
     +,   1.7983263E-02,   1.8774908E-02,   1.9576425E-02
     +,   2.0390606E-02,   2.1221776E-02,   2.2075964E-02
     +,   2.2960963E-02,   2.3886684E-02,   2.4865074E-02
     +,   2.5910506E-02,   2.7039643E-02,   2.8271871E-02
     +,   2.9629208E-02,   3.1136915E-02,   3.2823551E-02
     +,   3.4721904E-02,   3.6869831E-02,   3.9311454E-02
     +,   4.2098816E-02,   4.5294028E-02,   4.8971009E-02
     +,   5.3216361E-02,   5.8130559E-02,   6.3825928E-02
     +,   7.0425704E-02,   7.8060254E-02,   8.6867608E-02
     +,   9.6993625E-02,   0.1086005    ,   0.1218744    
     +,   0.1370390    ,   0.1543641    ,   0.1741650    
     +,   0.1967900    ,   0.2225853    ,   0.2518203    
     +,   0.2845649    ,   0.3205447    ,   0.3589988    
     +,   0.3986828    ,   0.4380987    ,   0.4760542    
     +,   0.5124163    ,   0.5487906    ,   0.5886430    
     +,   0.6365045    ,   0.6962312    ,   0.7689485    
     +,   0.8518620    ,   0.9390977    ,    1.024674    
     +,    1.106045    ,    1.185548    ,    1.267860    
     +,    1.354642    ,    1.440335    ,    1.513028    
     +,    1.560234    ,    1.575555    ,    1.561686    
     +,    1.528094    ,    1.484939    ,    1.437351    
     +,    1.384479    ,    1.324123    ,    1.258504    
     +,    1.195149    ,    1.141522    ,    1.098281    
     +,    1.057483    ,    1.007643    ,   0.9416039    
     +,   0.8612461    ,   0.7761885    ,   0.6983374    
     +,   0.6363316    ,   0.5927770    ,   0.5646579    
     +,   0.5456473    ,   0.5288178    ,   0.5086932    
     +,   0.4822682    ,   0.4490711    ,   0.4105753    
     +,   0.3693113    ,   0.3279984    ,   0.2888925    
     +,   0.2534621    ,   0.2223634    ,   0.1956083    
     +,   0.1728169    ,   0.1534534    ,   0.1369874    
     +,   0.1229714    ,   0.1110573    ,   0.1009807    
     +,   9.2536479E-02,   8.5556760E-02,   7.9897113E-02
     +,   7.5430013E-02,   7.2041608E-02,   6.9627486E-02
     +,   6.8090320E-02,   6.7336395E-02,   6.7272350E-02
     +,   6.7802981E-02,   6.8830118E-02,   7.0252284E-02
     +,   7.1965657E-02,   7.3865943E-02,   7.5850517E-02
     +,   7.7821009E-02,   7.9686157E-02,   8.1364572E-02
     +,   8.2786858E-02,   8.3897449E-02,   8.4656037E-02
     +,   8.5038096E-02,   8.5034683E-02,   8.4651910E-02
     +,   8.3909273E-02,   8.2837828E-02,   8.1478022E-02
     +,   7.9876788E-02,   7.8085050E-02,   7.6154903E-02
     +,   7.4137472E-02,   7.2080567E-02,   7.0026897E-02
     +,   6.8012767E-02,   6.6067599E-02,   6.4212933E-02
     +,   6.2463041E-02,   6.0825117E-02,   5.9299961E-02
     +,   5.7882715E-02,   5.6564108E-02,   5.5331547E-02
     +,   5.4169964E-02,   5.3062983E-02,   5.1993806E-02
     +,   5.0946027E-02,   4.9904350E-02,   4.8854928E-02
     +,   4.7785975E-02,   4.6687927E-02,   4.5553494E-02
     +,   4.4377852E-02,   4.3158479E-02,   4.1895095E-02
     +,   4.0589288E-02,   3.9244406E-02,   3.7865300E-02
     +,   3.6457978E-02,   3.5029255E-02,   3.3586383E-02
     +,   3.2137066E-02,   3.0688971E-02,   2.9249439E-02
     +,   2.7825456E-02,   2.6423542E-02,   2.5049409E-02
     +,   2.3708086E-02,   2.2403868E-02,   2.1140290E-02
     +,   1.9920064E-02,   1.8745184E-02,   1.7617086E-02
     +,   1.6536614E-02,   1.5504058E-02,   1.4519284E-02
     +,   1.3581871E-02,   1.2691123E-02,   1.1846050E-02
     +,   1.1045516E-02,   1.0288347E-02,   9.5731821E-03
     +,   8.8986289E-03,   8.2632890E-03,   7.6657445E-03
     +,   7.1045100E-03,   6.5781213E-03,   6.0851285E-03
     +,   5.6240843E-03,   5.1935199E-03,   4.7919699E-03
     +,   4.4180071E-03,   4.0702159E-03,   3.7471717E-03
     +,   3.4474698E-03,   3.1697683E-03,   2.9127190E-03
     +,   2.6750164E-03,   2.4554112E-03,   2.2526961E-03
     +,   2.0656986E-03,   1.8933043E-03,   1.7344618E-03
     +,   1.5881783E-03,   1.4535079E-03,   1.3295652E-03
     +,   1.2155343E-03,   1.1106411E-03,   1.0141808E-03
     +,   9.2548860E-04,   8.4396271E-04,   7.6903671E-04
     +,   7.0020056E-04,   6.3697540E-04,   5.7892955E-04
     +,   5.2565930E-04,   4.7680014E-04,   4.3201220E-04
     +,   3.9098252E-04,   3.5342737E-04,   3.1907929E-04
     +,   2.8769588E-04,   2.5904871E-04,   2.3292977E-04
     +,   2.0914261E-04,   1.8750773E-04,   1.6785529E-04
     +,   1.5002979E-04,   1.3388407E-04,   1.1928299E-04
     +,   1.0609881E-04,   9.4214156E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_ashz_ttz80_mass = Yx/12.4048357674419
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_ashz_ttz85_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.4907749E-03,   1.5272491E-03
     +,   1.5635063E-03,   1.5995112E-03,   1.6352314E-03
     +,   1.6706383E-03,   1.7057073E-03,   1.7404180E-03
     +,   1.7747552E-03,   1.8087099E-03,   1.8422785E-03
     +,   1.8754636E-03,   1.9082746E-03,   1.9407280E-03
     +,   1.9728483E-03,   2.0046672E-03,   2.0362257E-03
     +,   2.0675722E-03,   2.0987645E-03,   2.1298684E-03
     +,   2.1609601E-03,   2.1921236E-03,   2.2234516E-03
     +,   2.2550481E-03,   2.2870218E-03,   2.3194940E-03
     +,   2.3525907E-03,   2.3864470E-03,   2.4212054E-03
     +,   2.4570131E-03,   2.4940246E-03,   2.5323986E-03
     +,   2.5722971E-03,   2.6138851E-03,   2.6573301E-03
     +,   2.7027989E-03,   2.7504577E-03,   2.8004716E-03
     +,   2.8530033E-03,   2.9082068E-03,   2.9662349E-03
     +,   3.0272310E-03,   3.0913311E-03,   3.1586608E-03
     +,   3.2293375E-03,   3.3034661E-03,   3.3811424E-03
     +,   3.4624494E-03,   3.5474612E-03,   3.6362428E-03
     +,   3.7288477E-03,   3.8253265E-03,   3.9257240E-03
     +,   4.0300912E-03,   4.1384734E-03,   4.2509348E-03
     +,   4.3675532E-03,   4.4884277E-03,   4.6136933E-03
     +,   4.7435234E-03,   4.8781484E-03,   5.0178617E-03
     +,   5.1630288E-03,   5.3141178E-03,   5.4717064E-03
     +,   5.6364844E-03,   5.8093015E-03,   5.9911483E-03
     +,   6.1832224E-03,   6.3868994E-03,   6.6037979E-03
     +,   6.8357652E-03,   7.0849378E-03,   7.3537175E-03
     +,   7.6448424E-03,   7.9613915E-03,   8.3067818E-03
     +,   8.6848056E-03,   9.0996716E-03,   9.5559899E-03
     +,   1.0058732E-02,   1.0613319E-02,   1.1225470E-02
     +,   1.1901291E-02,   1.2647036E-02,   1.3469202E-02
     +,   1.4374171E-02,   1.5368258E-02,   1.6457262E-02
     +,   1.7646438E-02,   1.8940145E-02,   2.0341462E-02
     +,   2.1851987E-02,   2.3471754E-02,   2.5198983E-02
     +,   2.7029952E-02,   2.8959556E-02,   3.0981380E-02
     +,   3.3088889E-02,   3.5276093E-02,   3.7539460E-02
     +,   3.9879132E-02,   4.2301521E-02,   4.4820607E-02
     +,   4.7460470E-02,   5.0256636E-02,   5.3257089E-02
     +,   5.6522846E-02,   6.0128305E-02,   6.4160466E-02
     +,   6.8717450E-02,   7.3908009E-02,   7.9848319E-02
     +,   8.6659797E-02,   9.4461910E-02,   0.1033652    
     +,   0.1134562    ,   0.1247830    ,   0.1373339    
     +,   0.1510232    ,   0.1656815    ,   0.1810614    
     +,   0.1968693    ,   0.2128311    ,   0.2287946    
     +,   0.2448668    ,   0.2615699    ,   0.2799506    
     +,   0.3015806    ,   0.3283465    ,   0.3620167    
     +,   0.4036362    ,   0.4529872    ,   0.5083844    
     +,   0.5671260    ,   0.6266230    ,   0.6858819    
     +,   0.7465631    ,   0.8127355    ,   0.8891799    
     +,   0.9793096    ,    1.084186    ,    1.202641    
     +,    1.330672    ,    1.459668    ,    1.576953    
     +,    1.671811    ,    1.742812    ,    1.798254    
     +,    1.849931    ,    1.908098    ,    1.978043    
     +,    2.052486    ,    2.105317    ,    2.101382    
     +,    2.021106    ,    1.876642    ,    1.702081    
     +,    1.528647    ,    1.369873    ,    1.225578    
     +,    1.092969    ,   0.9719838    ,   0.8638978    
     +,   0.7687839    ,   0.6851426    ,   0.6110685    
     +,   0.5453011    ,   0.4874244    ,   0.4374309    
     +,   0.3951403    ,   0.3598597    ,   0.3304289    
     +,   0.3055256    ,   0.2840044    ,   0.2650838    
     +,   0.2483578    ,   0.2336917    ,   0.2210829    
     +,   0.2105471    ,   0.2020451    ,   0.1954462    
     +,   0.1905213    ,   0.1869611    ,   0.1844117    
     +,   0.1825153    ,   0.1809470    ,   0.1794414    
     +,   0.1778055    ,   0.1759187    ,   0.1737256    
     +,   0.1712224    ,   0.1684431    ,   0.1654476    
     +,   0.1623102    ,   0.1591120    ,   0.1559349    
     +,   0.1528548    ,   0.1499367    ,   0.1472299    
     +,   0.1447629    ,   0.1425406    ,   0.1405418    
     +,   0.1387195    ,   0.1370043    ,   0.1353085    
     +,   0.1335336    ,   0.1315780    ,   0.1293462    
     +,   0.1267558    ,   0.1237446    ,   0.1202756    
     +,   0.1163390    ,   0.1119525    ,   0.1071586    
     +,   0.1020220    ,   9.6622959E-02,   9.1052055E-02
     +,   8.5403576E-02,   7.9770759E-02,   7.4239738E-02
     +,   6.8886198E-02,   6.3773125E-02,   5.8949005E-02
     +,   5.4447234E-02,   5.0287139E-02,   4.6475586E-02
     +,   4.3008573E-02,   3.9873045E-02,   3.7049487E-02
     +,   3.4514055E-02,   3.2240290E-02,   3.0200515E-02
     +,   2.8367376E-02,   2.6714863E-02,   2.5218656E-02
     +,   2.3856714E-02,   2.2609554E-02,   2.1460142E-02
     +,   2.0393780E-02,   1.9397993E-02,   1.8462379E-02
     +,   1.7578317E-02,   1.6738646E-02,   1.5937544E-02
     +,   1.5170340E-02,   1.4433309E-02,   1.3723432E-02
     +,   1.3038364E-02,   1.2376343E-02,   1.1735980E-02
     +,   1.1116253E-02,   1.0516478E-02,   9.9361921E-03
     +,   9.3750879E-03,   8.8330023E-03,   8.3099119E-03
     +,   7.8058662E-03,   7.3209247E-03,   6.8551679E-03
     +,   6.4087063E-03,   5.9816260E-03,   5.5739512E-03
     +,   5.1856614E-03,   4.8167165E-03,   4.4669774E-03
     +,   4.1362382E-03,   3.8242498E-03,   3.5306879E-03
     +,   3.2551440E-03,   2.9971479E-03,   2.7561877E-03
     +,   2.5316963E-03,   2.3230433E-03,   2.1295624E-03
     +,   1.9505718E-03,   1.7853420E-03,   1.6331481E-03
     +,   1.4932351E-03,   1.3648648E-03,   1.2472852E-03
     +,   1.1397708E-03,   1.0415980E-03,   9.5207605E-04
     +,   8.7052822E-04,   7.9631648E-04,   7.2882621E-04
     +,   6.6747668E-04,   6.1172782E-04,   5.6106725E-04
     +,   5.1502517E-04,   4.7316085E-04,   4.3507435E-04
     +,   4.0039397E-04,   3.6878540E-04,   3.3994086E-04
     +,   3.1358571E-04,   2.8946911E-04,   2.6736883E-04
     +,   2.4708323E-04,   2.2843483E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_ashz_ttz85_mass = Yx/14.3716273953488
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_ashz_ttz90_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  7.2390994E-04,   7.4685452E-04
     +,   7.7055633E-04,   7.9504307E-04,   8.2034298E-04
     +,   8.4648514E-04,   8.7349908E-04,   9.0141501E-04
     +,   9.3026360E-04,   9.6007751E-04,   9.9088904E-04
     +,   1.0227318E-03,   1.0556411E-03,   1.0896531E-03
     +,   1.1248061E-03,   1.1611399E-03,   1.1986969E-03
     +,   1.2375216E-03,   1.2776622E-03,   1.3191700E-03
     +,   1.3621005E-03,   1.4065135E-03,   1.4524738E-03
     +,   1.5000548E-03,   1.5493317E-03,   1.6003919E-03
     +,   1.6533290E-03,   1.7082456E-03,   1.7652550E-03
     +,   1.8244813E-03,   1.8860608E-03,   1.9501419E-03
     +,   2.0168878E-03,   2.0864748E-03,   2.1590951E-03
     +,   2.2349567E-03,   2.3142835E-03,   2.3973142E-03
     +,   2.4843100E-03,   2.5755391E-03,   2.6712941E-03
     +,   2.7718798E-03,   2.8776128E-03,   2.9888265E-03
     +,   3.1058628E-03,   3.2290719E-03,   3.3588121E-03
     +,   3.4954427E-03,   3.6393232E-03,   3.7908077E-03
     +,   3.9502420E-03,   4.1179564E-03,   4.2942604E-03
     +,   4.4794478E-03,   4.6737632E-03,   4.8774318E-03
     +,   5.0906269E-03,   5.3134700E-03,   5.5460334E-03
     +,   5.7883202E-03,   6.0402704E-03,   6.3017565E-03
     +,   6.5725516E-03,   6.8523749E-03,   7.1408614E-03
     +,   7.4375356E-03,   7.7418708E-03,   8.0532236E-03
     +,   8.3709108E-03,   8.6941309E-03,   9.0220599E-03
     +,   9.3537690E-03,   9.6883290E-03,   1.0024733E-02
     +,   1.0361979E-02,   1.0699077E-02,   1.1035020E-02
     +,   1.1368847E-02,   1.1699676E-02,   1.2026720E-02
     +,   1.2349255E-02,   1.2666761E-02,   1.2978832E-02
     +,   1.3285306E-02,   1.3586211E-02,   1.3881873E-02
     +,   1.4172878E-02,   1.4460165E-02,   1.4744997E-02
     +,   1.5029048E-02,   1.5314405E-02,   1.5603574E-02
     +,   1.5899528E-02,   1.6205749E-02,   1.6526204E-02
     +,   1.6865350E-02,   1.7228184E-02,   1.7620167E-02
     +,   1.8047269E-02,   1.8515863E-02,   1.9032763E-02
     +,   1.9605028E-02,   2.0240054E-02,   2.0945273E-02
     +,   2.1728208E-02,   2.2596247E-02,   2.3556488E-02
     +,   2.4615541E-02,   2.5779506E-02,   2.7053662E-02
     +,   2.8442184E-02,   2.9948236E-02,   3.1573437E-02
     +,   3.3318073E-02,   3.5180572E-02,   3.7157901E-02
     +,   3.9245155E-02,   4.1436240E-02,   4.3723870E-02
     +,   4.6100717E-02,   4.8560385E-02,   5.1098928E-02
     +,   5.3717226E-02,   5.6423854E-02,   5.9238516E-02
     +,   6.2195592E-02,   6.5349095E-02,   6.8776004E-02
     +,   7.2581261E-02,   7.6899916E-02,   8.1900515E-02
     +,   8.7783732E-02,   9.4780751E-02,   0.1031427    
     +,   0.1131253    ,   0.1249616    ,   0.1388248    
     +,   0.1547902    ,   0.1728078    ,   0.1927011    
     +,   0.2142116    ,   0.2370974    ,   0.2612718    
     +,   0.2869387    ,   0.3146637    ,   0.3453368    
     +,   0.3799791    ,   0.4194305    ,   0.4640071    
     +,   0.5132383    ,   0.5657690    ,   0.6194708    
     +,   0.6718138    ,   0.7206123    ,   0.7653167    
     +,   0.8087208    ,   0.8580519    ,   0.9237196    
     +,    1.014887    ,    1.133957    ,    1.273983    
     +,    1.420742    ,    1.556808    ,    1.664395    
     +,    1.727859    ,    1.738357    ,    1.698982    
     +,    1.625263    ,    1.539175    ,    1.460036    
     +,    1.396930    ,    1.345852    ,    1.293175    
     +,    1.224695    ,    1.135895    ,    1.036850    
     +,   0.9477772    ,   0.8878057    ,   0.8646632    
     +,   0.8720312    ,   0.8950089    ,   0.9184424    
     +,   0.9323459    ,   0.9324029    ,   0.9176016    
     +,   0.8882191    ,   0.8455161    ,   0.7923328    
     +,   0.7331709    ,   0.6732880    ,   0.6173055    
     +,   0.5681665    ,   0.5268225    ,   0.4925723    
     +,   0.4637485    ,   0.4384525    ,   0.4151278    
     +,   0.3928597    ,   0.3714002    ,   0.3509937    
     +,   0.3321076    ,   0.3151777    ,   0.3004376    
     +,   0.2878582    ,   0.2771740    ,   0.2679611    
     +,   0.2597349    ,   0.2520327    ,   0.2444678    
     +,   0.2367499    ,   0.2286837    ,   0.2201532    
     +,   0.2111032    ,   0.2015268    ,   0.1914586    
     +,   0.1809717    ,   0.1701737    ,   0.1591992    
     +,   0.1481998    ,   0.1373326    ,   0.1267455    
     +,   0.1165675    ,   0.1069028    ,   9.7827695E-02
     +,   8.9390606E-02,   8.1615604E-02,   7.4507266E-02
     +,   6.8054073E-02,   6.2231936E-02,   5.7007708E-02
     +,   5.2341953E-02,   4.8190381E-02,   4.4505425E-02
     +,   4.1237883E-02,   3.8338833E-02,   3.5760153E-02
     +,   3.3456244E-02,   3.1385072E-02,   2.9508773E-02
     +,   2.7794011E-02,   2.6212361E-02,   2.4740281E-02
     +,   2.3358701E-02,   2.2052528E-02,   2.0810219E-02
     +,   1.9623255E-02,   1.8485541E-02,   1.7392796E-02
     +,   1.6342213E-02,   1.5332148E-02,   1.4361622E-02
     +,   1.3430168E-02,   1.2537729E-02,   1.1684374E-02
     +,   1.0870210E-02,   1.0095306E-02,   9.3596959E-03
     +,   8.6632743E-03,   8.0057299E-03,   7.3865713E-03
     +,   6.8051587E-03,   6.2606670E-03,   5.7520494E-03
     +,   5.2781058E-03,   4.8375423E-03,   4.4288971E-03
     +,   4.0506246E-03,   3.7011378E-03,   3.3788048E-03
     +,   3.0819597E-03,   2.8089483E-03,   2.5581608E-03
     +,   2.3280326E-03,   2.1170406E-03,   1.9237329E-03
     +,   1.7467551E-03,   1.5848100E-03,   1.4367064E-03
     +,   1.3013168E-03,   1.1776169E-03,   1.0646435E-03
     +,   9.6152659E-04,   8.6745218E-04,   7.8168703E-04
     +,   7.0354698E-04,   6.3241459E-04,   5.6771631E-04
     +,   5.0892547E-04,   4.5556389E-04,   4.0718354E-04
     +,   3.6337777E-04,   3.2376530E-04,   2.8799879E-04
     +,   2.5575186E-04,   2.2672667E-04,   2.0064310E-04
     +,   1.7724517E-04,   1.5629244E-04,   1.3756513E-04
     +,   1.2085720E-04,   1.0598054E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_ashz_ttz90_mass = Yx/14.1822917727273
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_ashz_ttz95_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.3686242E-03,   1.4134758E-03
     +,   1.4590151E-03,   1.5052636E-03,   1.5522498E-03
     +,   1.6000088E-03,   1.6485826E-03,   1.6980206E-03
     +,   1.7483792E-03,   1.7997252E-03,   1.8521309E-03
     +,   1.9056773E-03,   1.9604531E-03,   2.0165548E-03
     +,   2.0740868E-03,   2.1331597E-03,   2.1938912E-03
     +,   2.2564046E-03,   2.3208281E-03,   2.3872943E-03
     +,   2.4559386E-03,   2.5268970E-03,   2.6003087E-03
     +,   2.6763126E-03,   2.7550396E-03,   2.8366237E-03
     +,   2.9211894E-03,   3.0088555E-03,   3.0997314E-03
     +,   3.1939149E-03,   3.2914949E-03,   3.3925420E-03
     +,   3.4971144E-03,   3.6052526E-03,   3.7169782E-03
     +,   3.8322932E-03,   3.9511812E-03,   4.0735984E-03
     +,   4.1994946E-03,   4.3287771E-03,   4.4613499E-03
     +,   4.5970869E-03,   4.7358433E-03,   4.8774593E-03
     +,   5.0217537E-03,   5.1685357E-03,   5.3176004E-03
     +,   5.4687355E-03,   5.6217238E-03,   5.7763476E-03
     +,   5.9323939E-03,   6.0896557E-03,   6.2479428E-03
     +,   6.4070877E-03,   6.5669366E-03,   6.7273788E-03
     +,   6.8883342E-03,   7.0497636E-03,   7.2116773E-03
     +,   7.3741390E-03,   7.5372648E-03,   7.7012400E-03
     +,   7.8662978E-03,   8.0327578E-03,   8.2009966E-03
     +,   8.3714528E-03,   8.5446453E-03,   8.7211346E-03
     +,   8.9015635E-03,   9.0866052E-03,   9.2769954E-03
     +,   9.4734896E-03,   9.6768839E-03,   9.8879701E-03
     +,   1.0107555E-02,   1.0336434E-02,   1.0575358E-02
     +,   1.0825030E-02,   1.1086113E-02,   1.1359193E-02
     +,   1.1644738E-02,   1.1943156E-02,   1.2254694E-02
     +,   1.2579517E-02,   1.2917620E-02,   1.3268887E-02
     +,   1.3633036E-02,   1.4009680E-02,   1.4398239E-02
     +,   1.4798057E-02,   1.5208355E-02,   1.5628217E-02
     +,   1.6056642E-02,   1.6492588E-02,   1.6934976E-02
     +,   1.7382672E-02,   1.7834594E-02,   1.8289659E-02
     +,   1.8746922E-02,   1.9205485E-02,   1.9664660E-02
     +,   2.0123873E-02,   2.0582855E-02,   2.1041514E-02
     +,   2.1500124E-02,   2.1959264E-02,   2.2419866E-02
     +,   2.2883257E-02,   2.3351220E-02,   2.3825996E-02
     +,   2.4310242E-02,   2.4807146E-02,   2.5320353E-02
     +,   2.5854036E-02,   2.6412774E-02,   2.7001671E-02
     +,   2.7626203E-02,   2.8292280E-02,   2.9006068E-02
     +,   2.9774072E-02,   3.0603040E-02,   3.1499803E-02
     +,   3.2471232E-02,   3.3524301E-02,   3.4665894E-02
     +,   3.5902619E-02,   3.7241079E-02,   3.8687356E-02
     +,   4.0247481E-02,   4.1926883E-02,   4.3730903E-02
     +,   4.5664344E-02,   4.7732048E-02,   4.9938664E-02
     +,   5.2289225E-02,   5.4789398E-02,   5.7445791E-02
     +,   6.0266584E-02,   6.3262209E-02,   6.6445753E-02
     +,   6.9833159E-02,   7.3443435E-02,   7.7298731E-02
     +,   8.1423298E-02,   8.5841879E-02,   9.0578564E-02
     +,   9.5653594E-02,   0.1010804    ,   0.1068621    
     +,   0.1129899    ,   0.1194391    ,   0.1261688    
     +,   0.1331223    ,   0.1402299    ,   0.1474131    
     +,   0.1545897    ,   0.1616805    ,   0.1686157    
     +,   0.1753384    ,   0.1818066    ,   0.1879931    
     +,   0.1938829    ,   0.1994689    ,   0.2047478    
     +,   0.2097191    ,   0.2143845    ,   0.2187535    
     +,   0.2228557    ,   0.2267610    ,   0.2306082    
     +,   0.2346418    ,   0.2392559    ,   0.2450421    
     +,   0.2528272    ,   0.2636718    ,   0.2787873    
     +,   0.2993469    ,   0.3262656    ,   0.3601559    
     +,   0.4016603    ,   0.4520829    ,   0.5138022    
     +,   0.5898238    ,   0.6824494    ,   0.7919745    
     +,   0.9163929    ,    1.051826    ,    1.192661    
     +,    1.331808    ,    1.463069    ,    1.585232    
     +,    1.703404    ,    1.824386    ,    1.948669    
     +,    2.064475    ,    2.149467    ,    2.183138    
     +,    2.161359    ,    2.096572    ,    2.003223    
     +,    1.888041    ,    1.754877    ,    1.612028    
     +,    1.471148    ,    1.341657    ,    1.227609    
     +,    1.127926    ,    1.038647    ,   0.9561770    
     +,   0.8795868    ,   0.8101314    ,   0.7489392    
     +,   0.6954658    ,   0.6478222    ,   0.6040044    
     +,   0.5626248    ,   0.5228069    ,   0.4837750    
     +,   0.4447339    ,   0.4051321    ,   0.3649971    
     +,   0.3250363    ,   0.2864162    ,   0.2503650    
     +,   0.2178251    ,   0.1892836    ,   0.1647838    
     +,   0.1440426    ,   0.1265981    ,   0.1119359    
     +,   9.9566624E-02,   8.9062594E-02,   8.0066308E-02
     +,   7.2286829E-02,   6.5491170E-02,   5.9493154E-02
     +,   5.4146420E-02,   4.9337748E-02,   4.4980709E-02
     +,   4.1009836E-02,   3.7376016E-02,   3.4042221E-02
     +,   3.0979663E-02,   2.8164970E-02,   2.5578501E-02
     +,   2.3203358E-02,   2.1024419E-02,   1.9027822E-02
     +,   1.7200857E-02,   1.5531940E-02,   1.4010072E-02
     +,   1.2624914E-02,   1.1366711E-02,   1.0226107E-02
     +,   9.1940127E-03,   8.2616825E-03,   7.4207713E-03
     +,   6.6632852E-03,   5.9815869E-03,   5.3684935E-03
     +,   4.8173415E-03,   4.3219691E-03,   3.8766905E-03
     +,   3.4763403E-03,   3.1162889E-03,   2.7923381E-03
     +,   2.5007394E-03,   2.2381698E-03,   2.0016725E-03
     +,   1.7886058E-03,   1.5966268E-03,   1.4236658E-03
     +,   1.2678793E-03,   1.1276139E-03,   1.0013930E-03
     +,   8.8790414E-04,   7.8595255E-04,   6.9447310E-04
     +,   6.1249064E-04,   5.3913012E-04,   4.7358597E-04
     +,   4.1513162E-04,   3.6309529E-04,   3.1686871E-04
     +,   2.7588810E-04,   2.3964203E-04,   2.0765737E-04
     +,   1.7950074E-04,   1.5477762E-04,   1.3312370E-04
     +,   1.1420908E-04,   9.7730350E-05,   8.3413848E-05
     +,   7.1009257E-05,   6.0291892E-05,   5.1057599E-05
     +,   4.3124113E-05,   3.6327077E-05,   3.0520616E-05
     +,   2.5574167E-05,   2.1372638E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_ashz_ttz95_mass = Yx/14.1608997209302
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_ashz_hatt100_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  8.3248205E-03,   8.6651305E-03
     +,   9.0211760E-03,   9.3937144E-03,   9.7835166E-03
     +,   1.0191370E-02,   1.0618075E-02,   1.1064439E-02
     +,   1.1531260E-02,   1.2019351E-02,   1.2529504E-02
     +,   1.3062484E-02,   1.3619048E-02,   1.4199902E-02
     +,   1.4805710E-02,   1.5437089E-02,   1.6094578E-02
     +,   1.6778652E-02,   1.7489681E-02,   1.8227955E-02
     +,   1.8993640E-02,   1.9786783E-02,   2.0607289E-02
     +,   2.1454958E-02,   2.2329368E-02,   2.3230013E-02
     +,   2.4156177E-02,   2.5106985E-02,   2.6081383E-02
     +,   2.7078157E-02,   2.8095920E-02,   2.9133113E-02
     +,   3.0188020E-02,   3.1258803E-02,   3.2343440E-02
     +,   3.3439845E-02,   3.4545790E-02,   3.5658993E-02
     +,   3.6777191E-02,   3.7897922E-02,   3.9018884E-02
     +,   4.0137786E-02,   4.1252315E-02,   4.2360350E-02
     +,   4.3459848E-02,   4.4548910E-02,   4.5625862E-02
     +,   4.6689276E-02,   4.7737833E-02,   4.8770651E-02
     +,   4.9786974E-02,   5.0786484E-02,   5.1769078E-02
     +,   5.2735016E-02,   5.3684842E-02,   5.4619502E-02
     +,   5.5540178E-02,   5.6448363E-02,   5.7345919E-02
     +,   5.8234878E-02,   5.9117597E-02,   5.9996635E-02
     +,   6.0874727E-02,   6.1754789E-02,   6.2639982E-02
     +,   6.3533373E-02,   6.4438254E-02,   6.5357916E-02
     +,   6.6295706E-02,   6.7254834E-02,   6.8238594E-02
     +,   6.9250070E-02,   7.0292376E-02,   7.1368240E-02
     +,   7.2480485E-02,   7.3631540E-02,   7.4823566E-02
     +,   7.6058418E-02,   7.7337660E-02,   7.8662589E-02
     +,   8.0033712E-02,   8.1451431E-02,   8.2915284E-02
     +,   8.4424451E-02,   8.5977376E-02,   8.7571844E-02
     +,   8.9204952E-02,   9.0873010E-02,   9.2571624E-02
     +,   9.4295792E-02,   9.6039720E-02,   9.7796999E-02
     +,   9.9560529E-02,   0.1013231    ,   0.1030769    
     +,   0.1048139    ,   0.1065265    ,   0.1082069    
     +,   0.1098479    ,   0.1114428    ,   0.1129860    
     +,   0.1144726    ,   0.1158993    ,   0.1172639    
     +,   0.1185659    ,   0.1198065    ,   0.1209882    
     +,   0.1221159    ,   0.1231953    ,   0.1242344    
     +,   0.1252421    ,   0.1262290    ,   0.1272063    
     +,   0.1281863    ,   0.1291819    ,   0.1302062    
     +,   0.1312722    ,   0.1323928    ,   0.1335805    
     +,   0.1348470    ,   0.1362032    ,   0.1376587    
     +,   0.1392219    ,   0.1408998    ,   0.1426985    
     +,   0.1446211    ,   0.1466704    ,   0.1488468    
     +,   0.1511491    ,   0.1535739    ,   0.1561163    
     +,   0.1587694    ,   0.1615244    ,   0.1643706    
     +,   0.1672953    ,   0.1702843    ,   0.1733210    
     +,   0.1763874    ,   0.1794637    ,   0.1825285    
     +,   0.1855587    ,   0.1885295    ,   0.1914146    
     +,   0.1941871    ,   0.1968181    ,   0.1992781    
     +,   0.2015374    ,   0.2035648    ,   0.2053303    
     +,   0.2068044    ,   0.2079580    ,   0.2087647    
     +,   0.2092007    ,   0.2092452    ,   0.2088822    
     +,   0.2081003    ,   0.2068946    ,   0.2052663    
     +,   0.2032243    ,   0.2007851    ,   0.1979727    
     +,   0.1948191    ,   0.1913648    ,   0.1876573    
     +,   0.1837517    ,   0.1797090    ,   0.1755969    
     +,   0.1714877    ,   0.1674578    ,   0.1635869    
     +,   0.1599583    ,   0.1566570    ,   0.1537691    
     +,   0.1513830    ,   0.1495876    ,   0.1484736    
     +,   0.1481324    ,   0.1486567    ,   0.1501401    
     +,   0.1526771    ,   0.1563613    ,   0.1612855    
     +,   0.1675378    ,   0.1752007    ,   0.1843469    
     +,   0.1950347    ,   0.2073037    ,   0.2211720    
     +,   0.2366299    ,   0.2536356    ,   0.2721158    
     +,   0.2919647    ,   0.3130455    ,   0.3351995    
     +,   0.3582591    ,   0.3820625    ,   0.4064706    
     +,   0.4313861    ,   0.4567688    ,   0.4826350    
     +,   0.5090463    ,   0.5360816    ,   0.5638019    
     +,   0.5922108    ,   0.6212296    ,   0.6507033    
     +,   0.6804494    ,   0.7103222    ,   0.7403066    
     +,   0.7705758    ,   0.8014916    ,   0.8335176    
     +,   0.8670726    ,   0.9023529    ,   0.9391876    
     +,   0.9770111    ,    1.014987    ,    1.052288    
     +,    1.088493    ,    1.124009    ,    1.160450    
     +,    1.200815    ,    1.249445    ,    1.311662    
     +,    1.393253    ,    1.500037    ,    1.638225    
     +,    1.816313    ,    2.047916    ,    2.352331    
     +,    2.748823    ,    3.244907    ,    3.826142    
     +,    4.456378    ,    5.088733    ,    5.676517    
     +,    6.174489    ,    6.535649    ,    6.717779    
     +,    6.699825    ,    6.491080    ,    6.121520    
     +,    5.625534    ,    5.036366    ,    4.390660    
     +,    3.729695    ,    3.092520    ,    2.507844    
     +,    1.991558    ,    1.549636    ,    1.182135    
     +,   0.8856848    ,   0.6541449    ,   0.4788230    
     +,   0.3493926    ,   0.2554014    ,   0.1876035    
     +,   0.1386255    ,   0.1030065    ,   7.6885559E-02
     +,   5.7593469E-02,   4.3285985E-02,   3.2667622E-02
     +,   2.4803763E-02,   1.9000154E-02,   1.4728561E-02
     +,   1.1583863E-02,   9.2563517E-03,   7.5121424E-03
     +,   6.1784964E-03,   5.1316521E-03,   4.2860685E-03
     +,   3.5848094E-03,   2.9913483E-03,   2.4829505E-03
     +,   2.0455713E-03,   1.6700773E-03,   1.3499369E-03
     +,   1.0796740E-03,   8.5420534E-04,   6.6847436E-04
     +,   5.1747804E-04,   3.9630948E-04,   3.0032676E-04
     +,   2.2523825E-04,   1.6721014E-04,   1.2289081E-04
     +,   8.9425848E-05,   6.4438347E-05,   4.5981236E-05
     +,   3.2493255E-05,   2.2738910E-05,   1.5758120E-05
     +,   1.0813328E-05,   7.3469732E-06,   4.9419168E-06
     +,   3.2906464E-06,   2.1686992E-06,   1.4145052E-06
     +,   9.1290815E-07,   5.8293847E-07
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_ashz_hatt100_mass = Yx/35.43568476
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_ashz_hatt105_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.8337008E-02,   1.9296737E-02
     +,   2.0292351E-02,   2.1324469E-02,   2.2393692E-02
     +,   2.3500647E-02,   2.4645988E-02,   2.5830381E-02
     +,   2.7054520E-02,   2.8319223E-02,   2.9625297E-02
     +,   3.0973664E-02,   3.2365385E-02,   3.3801612E-02
     +,   3.5283688E-02,   3.6813106E-02,   3.8391676E-02
     +,   4.0021349E-02,   4.1704491E-02,   4.3443717E-02
     +,   4.5242064E-02,   4.7102988E-02,   4.9030378E-02
     +,   5.1028647E-02,   5.3102549E-02,   5.5257540E-02
     +,   5.7499386E-02,   5.9834410E-02,   6.2269248E-02
     +,   6.4810880E-02,   6.7466497E-02,   7.0243210E-02
     +,   7.3148243E-02,   7.6188080E-02,   7.9369143E-02
     +,   8.2696483E-02,   8.6174421E-02,   8.9805610E-02
     +,   9.3591318E-02,   9.7530425E-02,   0.1016201    
     +,   0.1058548    ,   0.1102265    ,   0.1147247    
     +,   0.1193363    ,   0.1240455    ,   0.1288345    
     +,   0.1336832    ,   0.1385700    ,   0.1434717    
     +,   0.1483645    ,   0.1532243    ,   0.1580269    
     +,   0.1627493    ,   0.1673691    ,   0.1718662    
     +,   0.1762219    ,   0.1804204    ,   0.1844484    
     +,   0.1882956    ,   0.1919552    ,   0.1954231    
     +,   0.1986990    ,   0.2017865    ,   0.2046927    
     +,   0.2074284    ,   0.2100087    ,   0.2124527    
     +,   0.2147838    ,   0.2170294    ,   0.2192205    
     +,   0.2213921    ,   0.2235824    ,   0.2258309    
     +,   0.2281787    ,   0.2306663    ,   0.2333322    
     +,   0.2362109    ,   0.2393313    ,   0.2427144    
     +,   0.2463705    ,   0.2502999    ,   0.2544883    
     +,   0.2589096    ,   0.2635223    ,   0.2682734    
     +,   0.2730969    ,   0.2779182    ,   0.2826565    
     +,   0.2872281    ,   0.2915517    ,   0.2955528    
     +,   0.2991681    ,   0.3023518    ,   0.3050782    
     +,   0.3073460    ,   0.3091803    ,   0.3106340    
     +,   0.3117856    ,   0.3127368    ,   0.3136086    
     +,   0.3145338    ,   0.3156486    ,   0.3170835    
     +,   0.3189543    ,   0.3213519    ,   0.3243340    
     +,   0.3279187    ,   0.3320807    ,   0.3367503    
     +,   0.3418152    ,   0.3471296    ,   0.3525191    
     +,   0.3577958    ,   0.3627709    ,   0.3672694    
     +,   0.3711447    ,   0.3742896    ,   0.3766465    
     +,   0.3782145    ,   0.3790490    ,   0.3792605    
     +,   0.3790056    ,   0.3784754    ,   0.3778812    
     +,   0.3774382    ,   0.3773452    ,   0.3777717    
     +,   0.3788403    ,   0.3806170    ,   0.3831057    
     +,   0.3862451    ,   0.3899161    ,   0.3939474    
     +,   0.3981325    ,   0.4022413    ,   0.4060409    
     +,   0.4093101    ,   0.4118563    ,   0.4135266    
     +,   0.4142149    ,   0.4138674    ,   0.4124813    
     +,   0.4100995    ,   0.4068028    ,   0.4027001    
     +,   0.3979171    ,   0.3925841    ,   0.3868261    
     +,   0.3807529    ,   0.3744531    ,   0.3679909    
     +,   0.3614042    ,   0.3547049    ,   0.3478834    
     +,   0.3409153    ,   0.3337661    ,   0.3263988    
     +,   0.3187799    ,   0.3108889    ,   0.3027186    
     +,   0.2942826    ,   0.2856164    ,   0.2767770    
     +,   0.2678435    ,   0.2589139    ,   0.2501036    
     +,   0.2415421    ,   0.2333688    ,   0.2257314    
     +,   0.2187837    ,   0.2126830    ,   0.2075895    
     +,   0.2036664    ,   0.2010801    ,   0.1999999    
     +,   0.2005991    ,   0.2030538    ,   0.2075412    
     +,   0.2142374    ,   0.2233105    ,   0.2349127    
     +,   0.2491698    ,   0.2661710    ,   0.2859558    
     +,   0.3085034    ,   0.3337265    ,   0.3614730    
     +,   0.3915332    ,   0.4236521    ,   0.4575543    
     +,   0.4929664    ,   0.5296326    ,   0.5673268    
     +,   0.6058457    ,   0.6449847    ,   0.6844901    
     +,   0.7240133    ,   0.7630643    ,   0.8009873    
     +,   0.8369545    ,   0.8700319    ,   0.8992645    
     +,   0.9237995    ,   0.9430082    ,   0.9566032    
     +,   0.9646909    ,   0.9677618    ,   0.9666213    
     +,   0.9622533    ,   0.9556614    ,   0.9477059    
     +,   0.9389954    ,   0.9298143    ,   0.9201317    
     +,   0.9096640    ,   0.8979661    ,   0.8845447    
     +,   0.8689517    ,   0.8508556    ,   0.8300733    
     +,   0.8065783    ,   0.7804881    ,   0.7520333    
     +,   0.7215310    ,   0.6893639    ,   0.6559564    
     +,   0.6217566    ,   0.5872107    ,   0.5527485    
     +,   0.5187569    ,   0.4855630    ,   0.4534128    
     +,   0.4224714    ,   0.3928255    ,   0.3644915    
     +,   0.3374359    ,   0.3116003    ,   0.2869185    
     +,   0.2633333    ,   0.2408091    ,   0.2193368    
     +,   0.1989304    ,   0.1796205    ,   0.1614462    
     +,   0.1444472    ,   0.1286549    ,   0.1140852    
     +,   0.1007368    ,   8.8591054E-02,   7.7610917E-02
     +,   6.7744985E-02,   5.8931116E-02,   5.1099416E-02
     +,   4.4174936E-02,   3.8081326E-02,   3.2743234E-02
     +,   2.8087469E-02,   2.4043927E-02,   2.0546628E-02
     +,   1.7534265E-02,   1.4950053E-02,   1.2741624E-02
     +,   1.0861206E-02,   9.2655988E-03,   7.9157036E-03
     +,   6.7765340E-03,   5.8170832E-03,   5.0100149E-03
     +,   4.3313764E-03,   3.7604298E-03,   3.2793898E-03
     +,   2.8731064E-03,   2.5287527E-03,   2.2355877E-03
     +,   1.9847066E-03,   1.7687235E-03,   1.5816068E-03
     +,   1.4184103E-03,   1.2751390E-03,   1.1485410E-03
     +,   1.0360075E-03,   9.3542080E-04,   8.4508467E-04
     +,   7.6361618E-04,   6.8990275E-04,   6.2302803E-04
     +,   5.6223781E-04,   5.0690956E-04,   4.5651174E-04
     +,   4.1059733E-04,   3.6877277E-04,   3.3069809E-04
     +,   2.9606550E-04,   2.6460207E-04,   2.3605509E-04
     +,   2.1019590E-04,   1.8680969E-04,   1.6569982E-04
     +,   1.4667987E-04,   1.2957821E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_ashz_hatt105_mass = Yx/19.3176196956522
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_ashz_hatt107_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.3139941E-02,   2.4278110E-02
     +,   2.5446419E-02,   2.6643828E-02,   2.7869225E-02
     +,   2.9121382E-02,   3.0399049E-02,   3.1700920E-02
     +,   3.3025660E-02,   3.4372032E-02,   3.5738785E-02
     +,   3.7124798E-02,   3.8529098E-02,   3.9950892E-02
     +,   4.1389659E-02,   4.2845063E-02,   4.4317186E-02
     +,   4.5806367E-02,   4.7313441E-02,   4.8839532E-02
     +,   5.0386250E-02,   5.1955611E-02,   5.3549979E-02
     +,   5.5172279E-02,   5.6825478E-02,   5.8513187E-02
     +,   6.0238983E-02,   6.2006652E-02,   6.3820153E-02
     +,   6.5683253E-02,   6.7599773E-02,   6.9573276E-02
     +,   7.1607068E-02,   7.3704198E-02,   7.5867340E-02
     +,   7.8098916E-02,   8.0400996E-02,   8.2775563E-02
     +,   8.5224479E-02,   8.7749451E-02,   9.0352818E-02
     +,   9.3037032E-02,   9.5805287E-02,   9.8661661E-02
     +,   0.1016110    ,   0.1046596    ,   0.1078146    
     +,   0.1110845    ,   0.1144787    ,   0.1180075    
     +,   0.1216816    ,   0.1255115    ,   0.1295073    
     +,   0.1336778    ,   0.1380295    ,   0.1425664    
     +,   0.1472891    ,   0.1521939    ,   0.1572724    
     +,   0.1625112    ,   0.1678917    ,   0.1733899    
     +,   0.1789769    ,   0.1846194    ,   0.1902808    
     +,   0.1959207    ,   0.2014982    ,   0.2069711    
     +,   0.2122986    ,   0.2174413    ,   0.2223634    
     +,   0.2270328    ,   0.2314228    ,   0.2355121    
     +,   0.2392850    ,   0.2427328    ,   0.2458525    
     +,   0.2486467    ,   0.2511250    ,   0.2533017    
     +,   0.2551962    ,   0.2568342    ,   0.2582443    
     +,   0.2594603    ,   0.2605197    ,   0.2614641    
     +,   0.2623383    ,   0.2631897    ,   0.2640679    
     +,   0.2650241    ,   0.2661095    ,   0.2673740    
     +,   0.2688652    ,   0.2706273    ,   0.2726987    
     +,   0.2751112    ,   0.2778890    ,   0.2810478    
     +,   0.2845946    ,   0.2885282    ,   0.2928394    
     +,   0.2975115    ,   0.3025234    ,   0.3078486    
     +,   0.3134595    ,   0.3193260    ,   0.3254178    
     +,   0.3317046    ,   0.3381555    ,   0.3447389    
     +,   0.3514204    ,   0.3581618    ,   0.3649184    
     +,   0.3716393    ,   0.3782633    ,   0.3847214    
     +,   0.3909353    ,   0.3968198    ,   0.4022861    
     +,   0.4072438    ,   0.4116076    ,   0.4153005    
     +,   0.4182590    ,   0.4204393    ,   0.4218191    
     +,   0.4224009    ,   0.4222121    ,   0.4213066    
     +,   0.4197598    ,   0.4176675    ,   0.4151396    
     +,   0.4122959    ,   0.4092577    ,   0.4061449    
     +,   0.4030659    ,   0.4001130    ,   0.3973583    
     +,   0.3948468    ,   0.3925942    ,   0.3905838    
     +,   0.3887674    ,   0.3870654    ,   0.3853714    
     +,   0.3835559    ,   0.3814749    ,   0.3789778    
     +,   0.3759153    ,   0.3721501    ,   0.3675660    
     +,   0.3620729    ,   0.3556136    ,   0.3481702    
     +,   0.3397611    ,   0.3304420    ,   0.3203031    
     +,   0.3094648    ,   0.2980722    ,   0.2862861    
     +,   0.2742787    ,   0.2622283    ,   0.2503094    
     +,   0.2386910    ,   0.2275310    ,   0.2169739    
     +,   0.2071472    ,   0.1981608    ,   0.1901085    
     +,   0.1830660    ,   0.1770931    ,   0.1722353    
     +,   0.1685255    ,   0.1659862    ,   0.1646302    
     +,   0.1644632    ,   0.1654853    ,   0.1676909    
     +,   0.1710712    ,   0.1756144    ,   0.1813062    
     +,   0.1881329    ,   0.1960827    ,   0.2051472    
     +,   0.2153259    ,   0.2266286    ,   0.2390803    
     +,   0.2527216    ,   0.2676116    ,   0.2838309    
     +,   0.3014792    ,   0.3206700    ,   0.3415306    
     +,   0.3641909    ,   0.3887716    ,   0.4153725    
     +,   0.4440562    ,   0.4748311    ,   0.5076264    
     +,   0.5422786    ,   0.5785143    ,   0.6159427    
     +,   0.6540478    ,   0.6922013    ,   0.7296832    
     +,   0.7657123    ,   0.7994806    ,   0.8302117    
     +,   0.8572024    ,   0.8798701    ,   0.8977995    
     +,   0.9107637    ,   0.9187382    ,   0.9218925    
     +,   0.9205673    ,   0.9152381    ,   0.9064597    
     +,   0.8948168    ,   0.8808734    ,   0.8651292    
     +,   0.8479924    ,   0.8297638    ,   0.8106337    
     +,   0.7906945    ,   0.7699577    ,   0.7483776    
     +,   0.7258710    ,   0.7023454    ,   0.6777167    
     +,   0.6519296    ,   0.6249672    ,   0.5968640    
     +,   0.5677097    ,   0.5376517    ,   0.5068800    
     +,   0.4756283    ,   0.4441588    ,   0.4127457    
     +,   0.3816636    ,   0.3511799    ,   0.3215424    
     +,   0.2929684    ,   0.2656453    ,   0.2397259    
     +,   0.2153282    ,   0.1925323    ,   0.1713847    
     +,   0.1519015    ,   0.1340703    ,   0.1178530    
     +,   0.1031909    ,   9.0010703E-02,   7.8225836E-02
     +,   6.7741856E-02,   5.8460459E-02,   5.0281756E-02
     +,   4.3106135E-02,   3.6837019E-02,   3.1382367E-02
     +,   2.6655218E-02,   2.2574158E-02,   1.9063920E-02
     +,   1.6055778E-02,   1.3487165E-02,   1.1301387E-02
     +,   9.4476100E-03,   7.8806533E-03,   6.5602795E-03
     +,   5.4510357E-03,   4.5218752E-03,   3.7457016E-03
     +,   3.0989330E-03,   2.5612148E-03,   2.1150876E-03
     +,   1.7456101E-03,   1.4400453E-03,   1.1876140E-03
     +,   9.7925775E-04,   8.0735196E-04,   6.6555350E-04
     +,   5.4857257E-04,   4.5204296E-04,   3.7234934E-04
     +,   3.0652608E-04,   2.5212925E-04,   2.0716061E-04
     +,   1.6997611E-04,   1.3923179E-04,   1.1382066E-04
     +,   9.2832110E-05,   7.5516917E-05,   6.1253100E-05
     +,   4.9526443E-05,   3.9907565E-05,   3.2039636E-05
     +,   2.5623394E-05,   2.0409234E-05,   1.6187472E-05
     +,   1.2783119E-05,   1.0049366E-05,   7.8640478E-06
     +,   6.1251189E-06,   4.7481326E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_ashz_hatt107_mass = Yx/18.2433972
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_ashz_hatt110_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.6249748E-02,   1.7131988E-02
     +,   1.8049302E-02,   1.9002313E-02,   1.9991657E-02
     +,   2.1017984E-02,   2.2081979E-02,   2.3184314E-02
     +,   2.4325689E-02,   2.5506888E-02,   2.6728638E-02
     +,   2.7991695E-02,   2.9296815E-02,   3.0644720E-02
     +,   3.2036088E-02,   3.3471547E-02,   3.4951571E-02
     +,   3.6476545E-02,   3.8046688E-02,   3.9661929E-02
     +,   4.1322034E-02,   4.3026425E-02,   4.4774171E-02
     +,   4.6564106E-02,   4.8394475E-02,   5.0263286E-02
     +,   5.2168071E-02,   5.4105856E-02,   5.6073394E-02
     +,   5.8066923E-02,   6.0082398E-02,   6.2115427E-02
     +,   6.4161427E-02,   6.6215552E-02,   6.8272926E-02
     +,   7.0328727E-02,   7.2378047E-02,   7.4416414E-02
     +,   7.6439649E-02,   7.8443862E-02,   8.0425948E-02
     +,   8.2383469E-02,   8.4314741E-02,   8.6219087E-02
     +,   8.8096850E-02,   8.9949585E-02,   9.1780216E-02
     +,   9.3592852E-02,   9.5393211E-02,   9.7188346E-02
     +,   9.8987035E-02,   0.1007993    ,   0.1026370    
     +,   0.1045130    ,   0.1064420    ,   0.1084393    
     +,   0.1105215    ,   0.1127059    ,   0.1150101    
     +,   0.1174515    ,   0.1200473    ,   0.1228140    
     +,   0.1257662    ,   0.1289171    ,   0.1322771    
     +,   0.1358534    ,   0.1396500    ,   0.1436659    
     +,   0.1478962    ,   0.1523301    ,   0.1569520    
     +,   0.1617397    ,   0.1666660    ,   0.1716975    
     +,   0.1767961    ,   0.1819192    ,   0.1870199    
     +,   0.1920498    ,   0.1969593    ,   0.2017004    
     +,   0.2062277    ,   0.2105013    ,   0.2144891    
     +,   0.2181690    ,   0.2215302    ,   0.2245760    
     +,   0.2273240    ,   0.2298071    ,   0.2320722    
     +,   0.2341810    ,   0.2362047    ,   0.2382239    
     +,   0.2403223    ,   0.2425840    ,   0.2450880    
     +,   0.2479035    ,   0.2510855    ,   0.2546716    
     +,   0.2586791    ,   0.2631044    ,   0.2679226    
     +,   0.2730904    ,   0.2785489    ,   0.2842264    
     +,   0.2900454    ,   0.2959248    ,   0.3017857    
     +,   0.3075528    ,   0.3131589    ,   0.3185427    
     +,   0.3236493    ,   0.3284287    ,   0.3328313    
     +,   0.3368082    ,   0.3403077    ,   0.3432729    
     +,   0.3456440    ,   0.3473588    ,   0.3483559    
     +,   0.3485787    ,   0.3479801    ,   0.3465280    
     +,   0.3442079    ,   0.3410299    ,   0.3370262    
     +,   0.3322559    ,   0.3268001    ,   0.3207622    
     +,   0.3142600    ,   0.3074235    ,   0.3003863    
     +,   0.2932825    ,   0.2862362    ,   0.2793608    
     +,   0.2727527    ,   0.2664874    ,   0.2606200    
     +,   0.2551825    ,   0.2501861    ,   0.2456216    
     +,   0.2414637    ,   0.2376737    ,   0.2342033    
     +,   0.2309984    ,   0.2280036    ,   0.2251640    
     +,   0.2224294    ,   0.2197553    ,   0.2171040    
     +,   0.2144450    ,   0.2117547    ,   0.2090154    
     +,   0.2062146    ,   0.2033430    ,   0.2003942    
     +,   0.1973633    ,   0.1942471    ,   0.1910440    
     +,   0.1877543    ,   0.1843821    ,   0.1809354    
     +,   0.1774287    ,   0.1738836    ,   0.1703302    
     +,   0.1668077    ,   0.1633640    ,   0.1600570    
     +,   0.1569514    ,   0.1541185    ,   0.1516335    
     +,   0.1495736    ,   0.1480159    ,   0.1470337    
     +,   0.1466963    ,   0.1470659    ,   0.1481977    
     +,   0.1501387    ,   0.1529286    ,   0.1566001    
     +,   0.1611802    ,   0.1666916    ,   0.1731540    
     +,   0.1805851    ,   0.1890032    ,   0.1984267    
     +,   0.2088744    ,   0.2203667    ,   0.2329248    
     +,   0.2465709    ,   0.2613243    ,   0.2772019    
     +,   0.2942145    ,   0.3123600    ,   0.3316196    
     +,   0.3519515    ,   0.3732818    ,   0.3954967    
     +,   0.4184346    ,   0.4418843    ,   0.4655836    
     +,   0.4892164    ,   0.5124291    ,   0.5348430    
     +,   0.5560745    ,   0.5757585    ,   0.5935780    
     +,   0.6092902    ,   0.6227464    ,   0.6339079    
     +,   0.6428529    ,   0.6497639    ,   0.6549091    
     +,   0.6586059    ,   0.6611823    ,   0.6629261    
     +,   0.6640460    ,   0.6646338    ,   0.6646433    
     +,   0.6638943    ,   0.6620825    ,   0.6588192    
     +,   0.6536778    ,   0.6462479    ,   0.6361892    
     +,   0.6232739    ,   0.6074146    ,   0.5886793    
     +,   0.5672829    ,   0.5435623    ,   0.5179452    
     +,   0.4909114    ,   0.4629530    ,   0.4345383    
     +,   0.4060881    ,   0.3779633    ,   0.3504522    
     +,   0.3237768    ,   0.2980999    ,   0.2735360    
     +,   0.2501591    ,   0.2280159    ,   0.2071346    
     +,   0.1875299    ,   0.1692041    ,   0.1521509    
     +,   0.1363564    ,   0.1217977    ,   0.1084416    
     +,   9.6246548E-02,   8.5163742E-02,   7.5136267E-02
     +,   6.6101834E-02,   5.7995245E-02,   5.0749291E-02
     +,   4.4296227E-02,   3.8569633E-02,   3.3505835E-02
     +,   2.9044164E-02,   2.5127105E-02,   2.1700935E-02
     +,   1.8715786E-02,   1.6125364E-02,   1.3886589E-02
     +,   1.1959672E-02,   1.0308123E-02,   8.8982126E-03
     +,   7.6990915E-03,   6.6827713E-03,   5.8239019E-03
     +,   5.0996561E-03,   4.4897124E-03,   3.9761579E-03
     +,   3.5432945E-03,   3.1774850E-03,   2.8670244E-03
     +,   2.6019872E-03,   2.3739878E-03,   2.1760724E-03
     +,   2.0024909E-03,   1.8485796E-03,   1.7105647E-03
     +,   1.5854632E-03,   1.4709157E-03,   1.3651085E-03
     +,   1.2666427E-03,   1.1744755E-03,   1.0878263E-03
     +,   1.0061243E-03,   9.2896400E-04,   8.5604726E-04
     +,   7.8716816E-04,   7.2216947E-04,   6.6093914E-04
     +,   6.0337776E-04,   5.4940343E-04,   4.9892900E-04
     +,   4.5187015E-04,   4.0812872E-04,   3.6760382E-04
     +,   3.3017943E-04,   2.9573537E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_ashz_hatt110_mass = Yx/14.343530372093
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_ashz_hatt115_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.4496075E-02,   1.5227790E-02
     +,   1.5988950E-02,   1.6780542E-02,   1.7603612E-02
     +,   1.8459216E-02,   1.9348435E-02,   2.0272369E-02
     +,   2.1232100E-02,   2.2228766E-02,   2.3263453E-02
     +,   2.4337219E-02,   2.5451111E-02,   2.6606139E-02
     +,   2.7803225E-02,   2.9043263E-02,   3.0327054E-02
     +,   3.1655308E-02,   3.3028621E-02,   3.4447528E-02
     +,   3.5912395E-02,   3.7423499E-02,   3.8980957E-02
     +,   4.0584881E-02,   4.2235073E-02,   4.3931399E-02
     +,   4.5673542E-02,   4.7461126E-02,   4.9293648E-02
     +,   5.1170647E-02,   5.3091578E-02,   5.5055942E-02
     +,   5.7063196E-02,   5.9112892E-02,   6.1204612E-02
     +,   6.3338123E-02,   6.5513052E-02,   6.7729294E-02
     +,   6.9986761E-02,   7.2285108E-02,   7.4624263E-02
     +,   7.7003770E-02,   7.9423003E-02,   8.1880942E-02
     +,   8.4376022E-02,   8.6905986E-02,   8.9467794E-02
     +,   9.2057392E-02,   9.4669513E-02,   9.7297743E-02
     +,   9.9934235E-02,   0.1025698    ,   0.1051938    
     +,   0.1077943    ,   0.1103582    ,   0.1128715    
     +,   0.1153196    ,   0.1176877    ,   0.1199611    
     +,   0.1221260    ,   0.1241702    ,   0.1260830    
     +,   0.1278567    ,   0.1294864    ,   0.1309714    
     +,   0.1323145    ,   0.1335233    ,   0.1346099    
     +,   0.1355907    ,   0.1364869    ,   0.1373232    
     +,   0.1381276    ,   0.1389310    ,   0.1397653    
     +,   0.1406633    ,   0.1416568    ,   0.1427752    
     +,   0.1440451    ,   0.1454882    ,   0.1471205    
     +,   0.1489518    ,   0.1509842    ,   0.1532126    
     +,   0.1556239    ,   0.1581979    ,   0.1609075    
     +,   0.1637193    ,   0.1665962    ,   0.1694967    
     +,   0.1723789    ,   0.1752003    ,   0.1779206    
     +,   0.1805030    ,   0.1829157    ,   0.1851333    
     +,   0.1871365    ,   0.1889144    ,   0.1904631    
     +,   0.1917855    ,   0.1928910    ,   0.1937943    
     +,   0.1945133    ,   0.1950695    ,   0.1954837    
     +,   0.1957776    ,   0.1959704    ,   0.1960791    
     +,   0.1961176    ,   0.1960960    ,   0.1960218    
     +,   0.1958993    ,   0.1957314    ,   0.1955196    
     +,   0.1952659    ,   0.1949731    ,   0.1946463    
     +,   0.1942927    ,   0.1939225    ,   0.1935488    
     +,   0.1931863    ,   0.1928518    ,   0.1925621    
     +,   0.1923326    ,   0.1921763    ,   0.1921020    
     +,   0.1921134    ,   0.1922074    ,   0.1923738    
     +,   0.1925950    ,   0.1928461    ,   0.1930959    
     +,   0.1933073    ,   0.1934394    ,   0.1934495    
     +,   0.1932944    ,   0.1929332    ,   0.1923286    
     +,   0.1914491    ,   0.1902706    ,   0.1887765    
     +,   0.1869595    ,   0.1848212    ,   0.1823721    
     +,   0.1796302    ,   0.1766210    ,   0.1733755    
     +,   0.1699288    ,   0.1663190    ,   0.1625853    
     +,   0.1587668    ,   0.1549007    ,   0.1510223    
     +,   0.1471629    ,   0.1433505    ,   0.1396086    
     +,   0.1359567    ,   0.1324105    ,   0.1289816    
     +,   0.1256790    ,   0.1225092    ,   0.1194766    
     +,   0.1165848    ,   0.1138371    ,   0.1112370    
     +,   0.1087886    ,   0.1064974    ,   0.1043706    
     +,   0.1024175    ,   0.1006489    ,   9.9077858E-02
     +,   9.7719505E-02,   9.6590661E-02,   9.5709652E-02
     +,   9.5095612E-02,   9.4768912E-02,   9.4749957E-02
     +,   9.5059037E-02,   9.5715813E-02,   9.6739136E-02
     +,   9.8145902E-02,   9.9951230E-02,   0.1021678    
     +,   0.1048053    ,   0.1078701    ,   0.1113652    
     +,   0.1152895    ,   0.1196374    ,   0.1243996    
     +,   0.1295620    ,   0.1351067    ,   0.1410112    
     +,   0.1472504    ,   0.1537955    ,   0.1606158    
     +,   0.1676799    ,   0.1749566    ,   0.1824157    
     +,   0.1900299    ,   0.1977777    ,   0.2056429    
     +,   0.2136173    ,   0.2217019    ,   0.2299085    
     +,   0.2382592    ,   0.2467860    ,   0.2555304    
     +,   0.2645400    ,   0.2738643    ,   0.2835499    
     +,   0.2936360    ,   0.3041457    ,   0.3150804    
     +,   0.3264124    ,   0.3380825    ,   0.3499953    
     +,   0.3620167    ,   0.3739789    ,   0.3856834    
     +,   0.3969098    ,   0.4074208    ,   0.4169782    
     +,   0.4253507    ,   0.4323227    ,   0.4377081    
     +,   0.4413538    ,   0.4431453    ,   0.4430104    
     +,   0.4409170    ,   0.4368737    ,   0.4309239    
     +,   0.4231428    ,   0.4136333    ,   0.4025194    
     +,   0.3899442    ,   0.3760654    ,   0.3610509    
     +,   0.3450783    ,   0.3283316    ,   0.3109977    
     +,   0.2932636    ,   0.2753130    ,   0.2573249    
     +,   0.2394689    ,   0.2219014    ,   0.2047621    
     +,   0.1881752    ,   0.1722451    ,   0.1570545    
     +,   0.1426669    ,   0.1291274    ,   0.1164618    
     +,   0.1046799    ,   9.3778558E-02,   8.3742678E-02
     +,   7.4547015E-02,   6.6159129E-02,   5.8541421E-02
     +,   5.1652446E-02,   4.5447610E-02,   3.9880995E-02
     +,   3.4906499E-02,   3.0478118E-02,   2.6550325E-02
     +,   2.3078917E-02,   2.0021614E-02,   1.7337773E-02
     +,   1.4988941E-02,   1.2939247E-02,   1.1155273E-02
     +,   9.6060745E-03,   8.2633942E-03,   7.1016788E-03
     +,   6.0979268E-03,   5.2315290E-03,   4.4842400E-03
     +,   3.8400749E-03,   3.2849680E-03,   2.8067576E-03
     +,   2.3948553E-03,   2.0401813E-03,   1.7348813E-03
     +,   1.4722461E-03,   1.2464821E-03,   1.0526400E-03
     +,   8.8643463E-04,   7.4419077E-04,   6.2271178E-04
     +,   5.1922526E-04,   4.3132569E-04,   3.5690077E-04
     +,   2.9411147E-04,   2.4133755E-04,   1.9716582E-04
     +,   1.6035125E-04,   1.2980933E-04,   1.0458877E-04
     +,   8.3865052E-05,   6.6920227E-05,   5.3136788E-05
     +,   4.1982388E-05,   3.3003693E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_ashz_hatt115_mass = Yx/9.98951970731707
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_ashz_hatt120_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.7875073E-02,   1.8709373E-02
     +,   1.9557951E-02,   2.0419199E-02,   2.1291448E-02
     +,   2.2172900E-02,   2.3061737E-02,   2.3956101E-02
     +,   2.4854092E-02,   2.5753915E-02,   2.6653759E-02
     +,   2.7551962E-02,   2.8446972E-02,   2.9337475E-02
     +,   3.0222360E-02,   3.1100836E-02,   3.1972419E-02
     +,   3.2837071E-02,   3.3695113E-02,   3.4547444E-02
     +,   3.5395429E-02,   3.6240995E-02,   3.7086669E-02
     +,   3.7935607E-02,   3.8791474E-02,   3.9658651E-02
     +,   4.0542036E-02,   4.1447073E-02,   4.2379692E-02
     +,   4.3346304E-02,   4.4353593E-02,   4.5408607E-02
     +,   4.6518438E-02,   4.7690302E-02,   4.8931286E-02
     +,   5.0248329E-02,   5.1647983E-02,   5.3136304E-02
     +,   5.4718841E-02,   5.6400340E-02,   5.8184814E-02
     +,   6.0075302E-02,   6.2073909E-02,   6.4181648E-02
     +,   6.6398464E-02,   6.8723239E-02,   7.1153745E-02
     +,   7.3686749E-02,   7.6317966E-02,   7.9042122E-02
     +,   8.1853136E-02,   8.4744096E-02,   8.7707199E-02
     +,   9.0734266E-02,   9.3816124E-02,   9.6943326E-02
     +,   0.1001056    ,   0.1032923    ,   0.1064921    
     +,   0.1096929    ,   0.1128820    ,   0.1160462    
     +,   0.1191710    ,   0.1222417    ,   0.1252425    
     +,   0.1281569    ,   0.1309679    ,   0.1336581    
     +,   0.1362102    ,   0.1386069    ,   0.1408314    
     +,   0.1428684    ,   0.1447038    ,   0.1463259    
     +,   0.1477254    ,   0.1488962    ,   0.1498356    
     +,   0.1505448    ,   0.1510291    ,   0.1512979    
     +,   0.1513655    ,   0.1512496    ,   0.1509730    
     +,   0.1505616    ,   0.1500449    ,   0.1494557    
     +,   0.1488291    ,   0.1482019    ,   0.1476122    
     +,   0.1470985    ,   0.1466987    ,   0.1464497    
     +,   0.1463856    ,   0.1465380    ,   0.1469345    
     +,   0.1475973    ,   0.1485435    ,   0.1497841    
     +,   0.1513234    ,   0.1531592    ,   0.1552824    
     +,   0.1576770    ,   0.1603213    ,   0.1631879    
     +,   0.1662441    ,   0.1694537    ,   0.1727770    
     +,   0.1761713    ,   0.1795930    ,   0.1829974    
     +,   0.1863391    ,   0.1895737    ,   0.1926571    
     +,   0.1955469    ,   0.1982028    ,   0.2005866    
     +,   0.2026633    ,   0.2044020    ,   0.2057756    
     +,   0.2067626    ,   0.2073471    ,   0.2075193    
     +,   0.2072764    ,   0.2066224    ,   0.2055686    
     +,   0.2041329    ,   0.2023394    ,   0.2002178    
     +,   0.1978022    ,   0.1951304    ,   0.1922417    
     +,   0.1891765    ,   0.1859740    ,   0.1826720    
     +,   0.1793050    ,   0.1759031    ,   0.1724918    
     +,   0.1690915    ,   0.1657167    ,   0.1623763    
     +,   0.1590746    ,   0.1558106    ,   0.1525793    
     +,   0.1493723    ,   0.1461794    ,   0.1429887    
     +,   0.1397876    ,   0.1365649    ,   0.1333103    
     +,   0.1300157    ,   0.1266761    ,   0.1232898    
     +,   0.1198584    ,   0.1163874    ,   0.1128854    
     +,   0.1093647    ,   0.1058404    ,   0.1023298    
     +,   9.8851815E-02,   9.5426932E-02,   9.2075832E-02
     +,   8.8819101E-02,   8.5676901E-02,   8.2668260E-02
     +,   7.9810411E-02,   7.7118926E-02,   7.4607439E-02
     +,   7.2287522E-02,   7.0168324E-02,   6.8257086E-02
     +,   6.6559136E-02,   6.5078095E-02,   6.3815929E-02
     +,   6.2773377E-02,   6.1950304E-02,   6.1345939E-02
     +,   6.0959201E-02,   6.0789026E-02,   6.0834736E-02
     +,   6.1096244E-02,   6.1574511E-02,   6.2271558E-02
     +,   6.3190706E-02,   6.4336807E-02,   6.5716192E-02
     +,   6.7336544E-02,   6.9206700E-02,   7.1336754E-02
     +,   7.3737480E-02,   7.6419599E-02,   7.9394095E-02
     +,   8.2671218E-02,   8.6259857E-02,   9.0167165E-02
     +,   9.4398521E-02,   9.8956652E-02,   0.1038417    
     +,   0.1090502    ,   0.1145766    ,   0.1204120    
     +,   0.1265442    ,   0.1329582    ,   0.1396365    
     +,   0.1465590    ,   0.1537019    ,   0.1610394    
     +,   0.1685424    ,   0.1761777    ,   0.1839081    
     +,   0.1916928    ,   0.1994862    ,   0.2072376    
     +,   0.2148917    ,   0.2223894    ,   0.2296688    
     +,   0.2366652    ,   0.2433131    ,   0.2495494    
     +,   0.2553135    ,   0.2605491    ,   0.2652067    
     +,   0.2692451    ,   0.2726305    ,   0.2753383    
     +,   0.2773521    ,   0.2786630    ,   0.2792686    
     +,   0.2791708    ,   0.2783756    ,   0.2768902    
     +,   0.2747231    ,   0.2718829    ,   0.2683784    
     +,   0.2642183    ,   0.2594131    ,   0.2539752    
     +,   0.2479206    ,   0.2412707    ,   0.2340537    
     +,   0.2263043    ,   0.2180655    ,   0.2093893    
     +,   0.2003345    ,   0.1909672    ,   0.1813586    
     +,   0.1715843    ,   0.1617220    ,   0.1518486    
     +,   0.1420391    ,   0.1323656    ,   0.1228938    
     +,   0.1136829    ,   0.1047852    ,   9.6244343E-02
     +,   8.8095613E-02,   8.0365710E-02,   7.3073722E-02
     +,   6.6231512E-02,   5.9843265E-02,   5.3907454E-02
     +,   4.8417538E-02,   4.3362446E-02,   3.8727179E-02
     +,   3.4493841E-02,   3.0642733E-02,   2.7152229E-02
     +,   2.3999656E-02,   2.1162111E-02,   1.8616468E-02
     +,   1.6339781E-02,   1.4309594E-02,   1.2504442E-02
     +,   1.0903771E-02,   9.4880480E-03,   8.2389526E-03
     +,   7.1395398E-03,   6.1740051E-03,   5.3279507E-03
     +,   4.5881141E-03,   3.9425413E-03,   3.3803408E-03
     +,   2.8917762E-03,   2.4680481E-03,   2.1013469E-03
     +,   1.7846575E-03,   1.5117838E-03,   1.2771989E-03
     +,   1.0760078E-03,   9.0390391E-04,   7.5705932E-04
     +,   6.3212018E-04,   5.2611856E-04,   4.3646040E-04
     +,   3.6085903E-04,   2.9732237E-04,   2.4410205E-04
     +,   1.9968192E-04,   1.6273801E-04,   1.3212826E-04
     +,   1.0686157E-04,   8.6088097E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_ashz_hatt120_mass = Yx/8.01924165
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_ashz_hatt60_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  0.1834539    ,   0.2120157    
     +,   0.2421510    ,   0.2734912    ,   0.3056985    
     +,   0.3385247    ,   0.3718718    ,   0.4058373    
     +,   0.4407358    ,   0.4770896    ,   0.5155725    
     +,   0.5569235    ,   0.6018342    ,   0.6508352    
     +,   0.7042073    ,   0.7619493    ,   0.8238049    
     +,   0.8893368    ,   0.9579929    ,    1.029128    
     +,    1.101964    ,    1.175562    ,    1.248944    
     +,    1.321450    ,    1.393213    ,    1.465438    
     +,    1.540071    ,    1.618706    ,    1.701135    
     +,    1.784435    ,    1.863386    ,    1.932419    
     +,    1.988154    ,    2.031109    ,    2.065338    
     +,    2.095958    ,    2.125872    ,    2.153382    
     +,    2.172169    ,    2.173697    ,    2.150852    
     +,    2.100925    ,    2.026421    ,    1.933478    
     +,    1.829098    ,    1.718817    ,    1.605969    
     +,    1.492467    ,    1.380066    ,    1.271104    
     +,    1.168361    ,    1.074340    ,   0.9906042    
     +,   0.9175159    ,   0.8544364    ,   0.8000776    
     +,   0.7528582    ,   0.7111227    ,   0.6733072    
     +,   0.6380740    ,   0.6044491    ,   0.5719047    
     +,   0.5403550    ,   0.5100533    ,   0.4814376    
     +,   0.4549680    ,   0.4309936    ,   0.4096916    
     +,   0.3910423    ,   0.3748580    ,   0.3608248    
     +,   0.3485609    ,   0.3376629    ,   0.3277546    
     +,   0.3185147    ,   0.3096987    ,   0.3011437    
     +,   0.2927631    ,   0.2845334    ,   0.2764754    
     +,   0.2686365    ,   0.2610708    ,   0.2538261    
     +,   0.2469330    ,   0.2404016    ,   0.2342192    
     +,   0.2283548    ,   0.2227627    ,   0.2173894    
     +,   0.2121779    ,   0.2070746    ,   0.2020322    
     +,   0.1970124    ,   0.1919877    ,   0.1869407    
     +,   0.1818651    ,   0.1767622    ,   0.1716419    
     +,   0.1665182    ,   0.1614099    ,   0.1563366    
     +,   0.1513196    ,   0.1463782    ,   0.1415316    
     +,   0.1367952    ,   0.1321826    ,   0.1277045    
     +,   0.1233688    ,   0.1191807    ,   0.1151429    
     +,   0.1112568    ,   0.1075215    ,   0.1039357    
     +,   0.1004964    ,   9.7200930E-02,   9.4045646E-02
     +,   9.1027327E-02,   8.8142313E-02,   8.5387483E-02
     +,   8.2759507E-02,   8.0255203E-02,   7.7871524E-02
     +,   7.5605556E-02,   7.3454045E-02,   7.1413890E-02
     +,   6.9481820E-02,   6.7654274E-02,   6.5927751E-02
     +,   6.4298287E-02,   6.2762119E-02,   6.1314970E-02
     +,   5.9952833E-02,   5.8671385E-02,   5.7466473E-02
     +,   5.6333810E-02,   5.5269286E-02,   5.4268911E-02
     +,   5.3328779E-02,   5.2445207E-02,   5.1614545E-02
     +,   5.0833482E-02,   5.0098851E-02,   4.9407613E-02
     +,   4.8757013E-02,   4.8144415E-02,   4.7567360E-02
     +,   4.7023606E-02,   4.6511088E-02,   4.6027850E-02
     +,   4.5572169E-02,   4.5142408E-02,   4.4737071E-02
     +,   4.4354916E-02,   4.3994725E-02,   4.3655463E-02
     +,   4.3336265E-02,   4.3036342E-02,   4.2755064E-02
     +,   4.2491861E-02,   4.2246286E-02,   4.2018022E-02
     +,   4.1806743E-02,   4.1612253E-02,   4.1434392E-02
     +,   4.1272983E-02,   4.1127913E-02,   4.0999051E-02
     +,   4.0886238E-02,   4.0789291E-02,   4.0707961E-02
     +,   4.0641982E-02,   4.0590994E-02,   4.0554583E-02
     +,   4.0532209E-02,   4.0523250E-02,   4.0527046E-02
     +,   4.0542770E-02,   4.0569592E-02,   4.0606506E-02
     +,   4.0652480E-02,   4.0706389E-02,   4.0766973E-02
     +,   4.0833026E-02,   4.0903211E-02,   4.0976159E-02
     +,   4.1050479E-02,   4.1124761E-02,   4.1197553E-02
     +,   4.1267466E-02,   4.1333076E-02,   4.1393008E-02
     +,   4.1445903E-02,   4.1490473E-02,   4.1525476E-02
     +,   4.1549735E-02,   4.1562129E-02,   4.1561674E-02
     +,   4.1547418E-02,   4.1518513E-02,   4.1474264E-02
     +,   4.1413989E-02,   4.1337170E-02,   4.1243404E-02
     +,   4.1132338E-02,   4.1003771E-02,   4.0857587E-02
     +,   4.0693749E-02,   4.0512327E-02,   4.0313505E-02
     +,   4.0097486E-02,   3.9864600E-02,   3.9615225E-02
     +,   3.9349783E-02,   3.9068781E-02,   3.8772702E-02
     +,   3.8462125E-02,   3.8137626E-02,   3.7799798E-02
     +,   3.7449215E-02,   3.7086498E-02,   3.6712181E-02
     +,   3.6326878E-02,   3.5931107E-02,   3.5525411E-02
     +,   3.5110269E-02,   3.4686130E-02,   3.4253426E-02
     +,   3.3812556E-02,   3.3363890E-02,   3.2907702E-02
     +,   3.2444309E-02,   3.1973988E-02,   3.1496972E-02
     +,   3.1013452E-02,   3.0523663E-02,   3.0027775E-02
     +,   2.9525967E-02,   2.9018432E-02,   2.8505355E-02
     +,   2.7986940E-02,   2.7463375E-02,   2.6934898E-02
     +,   2.6401779E-02,   2.5864275E-02,   2.5322681E-02
     +,   2.4777347E-02,   2.4228672E-02,   2.3677038E-02
     +,   2.3122858E-02,   2.2566659E-02,   2.2008916E-02
     +,   2.1450153E-02,   2.0890962E-02,   2.0331947E-02
     +,   1.9773699E-02,   1.9216850E-02,   1.8662056E-02
     +,   1.8109996E-02,   1.7561318E-02,   1.7016679E-02
     +,   1.6476747E-02,   1.5942199E-02,   1.5413662E-02
     +,   1.4891746E-02,   1.4377080E-02,   1.3870225E-02
     +,   1.3371721E-02,   1.2882101E-02,   1.2401857E-02
     +,   1.1931421E-02,   1.1471187E-02,   1.1021531E-02
     +,   1.0582792E-02,   1.0155234E-02,   9.7390823E-03
     +,   9.3345623E-03,   8.9417985E-03,   8.5609220E-03
     +,   8.1919879E-03,   7.8350464E-03,   7.4900715E-03
     +,   7.1570422E-03,   6.8358649E-03,   6.5264530E-03
     +,   6.2286528E-03,   5.9423209E-03,   5.6672650E-03
     +,   5.4032686E-03,   5.1501235E-03,   4.9075671E-03
     +,   4.6753590E-03,   4.4532130E-03,   4.2408626E-03
     +,   4.0380042E-03,   3.8443578E-03,   3.6596076E-03
     +,   3.4834668E-03,   3.3156185E-03,   3.1557702E-03
     +,   3.0036094E-03,   2.8588462E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_ashz_hatt60_mass = Yx/21.7602283043478
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_ashz_hatt65_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  7.8046806E-02,   8.7375969E-02
     +,   9.7439386E-02,   0.1082357    ,   0.1197524    
     +,   0.1319648    ,   0.1448344    ,   0.1583077    
     +,   0.1723166    ,   0.1867803    ,   0.2016083    
     +,   0.2167076    ,   0.2319933    ,   0.2474030    
     +,   0.2629144    ,   0.2785661    ,   0.2944784    
     +,   0.3108745    ,   0.3280931    ,   0.3465926    
     +,   0.3669442    ,   0.3898052    ,   0.4158802    
     +,   0.4458694    ,   0.4804025    ,   0.5199801    
     +,   0.5649031    ,   0.6152114    ,   0.6706436    
     +,   0.7306241    ,   0.7943142    ,   0.8607180    
     +,   0.9288286    ,   0.9977332    ,    1.066644    
     +,    1.134846    ,    1.201663    ,    1.266548    
     +,    1.329394    ,    1.390907    ,    1.452851    
     +,    1.517891    ,    1.588943    ,    1.668123    
     +,    1.755547    ,    1.848484    ,    1.941477    
     +,    2.027735    ,    2.101474    ,    2.160316    
     +,    2.206430    ,    2.245819    ,    2.285889    
     +,    2.332245    ,    2.385925    ,    2.442087    
     +,    2.490581    ,    2.518444    ,    2.513768    
     +,    2.469825    ,    2.387670    ,    2.275789    
     +,    2.146860    ,    2.013349    ,    1.884258    
     +,    1.764272    ,    1.654682    ,    1.554990    
     +,    1.463994    ,    1.380304    ,    1.302464    
     +,    1.229096    ,    1.159050    ,    1.091549    
     +,    1.026189    ,   0.9628707    ,   0.9016912    
     +,   0.8428450    ,   0.7865607    ,   0.7330898    
     +,   0.6827047    ,   0.6356745    ,   0.5922530    
     +,   0.5526213    ,   0.5168573    ,   0.4848969    
     +,   0.4565419    ,   0.4314778    ,   0.4093266    
     +,   0.3896889    ,   0.3721869    ,   0.3564906    
     +,   0.3423212    ,   0.3294463    ,   0.3176681    
     +,   0.3068105    ,   0.2967104    ,   0.2872149    
     +,   0.2781799    ,   0.2694753    ,   0.2609868    
     +,   0.2526203    ,   0.2443019    ,   0.2359801    
     +,   0.2276239    ,   0.2192217    ,   0.2107813    
     +,   0.2023268    ,   0.1938961    ,   0.1855394    
     +,   0.1773163    ,   0.1692909    ,   0.1615307    
     +,   0.1540998    ,   0.1470592    ,   0.1404601    
     +,   0.1343445    ,   0.1287411    ,   0.1236666    
     +,   0.1191240    ,   0.1151037    ,   0.1115845    
     +,   0.1085360    ,   0.1059188    ,   0.1036877    
     +,   0.1017940    ,   0.1001861    ,   9.8812535E-02
     +,   9.7622789E-02,   9.6568853E-02,   9.5606267E-02
     +,   9.4694905E-02,   9.3799382E-02,   9.2889428E-02
     +,   9.1940135E-02,   9.0931706E-02,   8.9849502E-02
     +,   8.8683620E-02,   8.7428577E-02,   8.6082920E-02
     +,   8.4648699E-02,   8.3131060E-02,   8.1537612E-02
     +,   7.9878040E-02,   7.8163765E-02,   7.6407067E-02
     +,   7.4621059E-02,   7.2819121E-02,   7.1014702E-02
     +,   6.9220670E-02,   6.7449383E-02,   6.5712437E-02
     +,   6.4020380E-02,   6.2382627E-02,   6.0807366E-02
     +,   5.9301727E-02,   5.7871442E-02,   5.6521088E-02
     +,   5.5254087E-02,   5.4072745E-02,   5.2978378E-02
     +,   5.1971193E-02,   5.1050771E-02,   5.0215833E-02
     +,   4.9464416E-02,   4.8794009E-02,   4.8201576E-02
     +,   4.7683697E-02,   4.7236577E-02,   4.6856090E-02
     +,   4.6537925E-02,   4.6277583E-02,   4.6070397E-02
     +,   4.5911569E-02,   4.5796219E-02,   4.5719504E-02
     +,   4.5676470E-02,   4.5662194E-02,   4.5671802E-02
     +,   4.5700449E-02,   4.5743413E-02,   4.5796040E-02
     +,   4.5853887E-02,   4.5912564E-02,   4.5967992E-02
     +,   4.6016239E-02,   4.6053674E-02,   4.6076905E-02
     +,   4.6082914E-02,   4.6068933E-02,   4.6032649E-02
     +,   4.5972075E-02,   4.5885649E-02,   4.5772199E-02
     +,   4.5630977E-02,   4.5461681E-02,   4.5264486E-02
     +,   4.5039926E-02,   4.4788964E-02,   4.4512972E-02
     +,   4.4213712E-02,   4.3893300E-02,   4.3554116E-02
     +,   4.3198891E-02,   4.2830542E-02,   4.2452190E-02
     +,   4.2067066E-02,   4.1678552E-02,   4.1290030E-02
     +,   4.0904805E-02,   4.0526137E-02,   4.0157184E-02
     +,   3.9800849E-02,   3.9459806E-02,   3.9136454E-02
     +,   3.8832832E-02,   3.8550593E-02,   3.8291004E-02
     +,   3.8054861E-02,   3.7842546E-02,   3.7653904E-02
     +,   3.7488356E-02,   3.7344806E-02,   3.7221715E-02
     +,   3.7117120E-02,   3.7028562E-02,   3.6953256E-02
     +,   3.6888074E-02,   3.6829513E-02,   3.6773864E-02
     +,   3.6717247E-02,   3.6655579E-02,   3.6584727E-02
     +,   3.6500532E-02,   3.6398895E-02,   3.6275811E-02
     +,   3.6127426E-02,   3.5950132E-02,   3.5740618E-02
     +,   3.5495870E-02,   3.5213232E-02,   3.4890499E-02
     +,   3.4525897E-02,   3.4118082E-02,   3.3666208E-02
     +,   3.3169966E-02,   3.2629471E-02,   3.2045357E-02
     +,   3.1418689E-02,   3.0751070E-02,   3.0044436E-02
     +,   2.9301146E-02,   2.8523915E-02,   2.7715834E-02
     +,   2.6880167E-02,   2.6020421E-02,   2.5140304E-02
     +,   2.4243686E-02,   2.3334442E-02,   2.2416469E-02
     +,   2.1493688E-02,   2.0570004E-02,   1.9649111E-02
     +,   1.8734587E-02,   1.7829914E-02,   1.6938288E-02
     +,   1.6062666E-02,   1.5205824E-02,   1.4370272E-02
     +,   1.3558179E-02,   1.2771437E-02,   1.2011713E-02
     +,   1.1280380E-02,   1.0578484E-02,   9.9068126E-03
     +,   9.2659537E-03,   8.6561628E-03,   8.0775609E-03
     +,   7.5299637E-03,   7.0130830E-03,   6.5263798E-03
     +,   6.0692290E-03,   5.6408108E-03,   5.2402504E-03
     +,   4.8665223E-03,   4.5185750E-03,   4.1952622E-03
     +,   3.8954029E-03,   3.6178064E-03,   3.3612403E-03
     +,   3.1245016E-03,   2.9063660E-03,   2.7056560E-03
     +,   2.5211987E-03,   2.3518743E-03,   2.1965872E-03
     +,   2.0543013E-03,   1.9240138E-03,   1.8047884E-03
     +,   1.6957247E-03,   1.5959892E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_ashz_hatt65_mass = Yx/25.887602125
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_ashz_hatt70_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  5.2987844E-02,   5.6489427E-02
     +,   6.0101252E-02,   6.3826680E-02,   6.7671478E-02
     +,   7.1644165E-02,   7.5756207E-02,   8.0022544E-02
     +,   8.4461473E-02,   8.9095376E-02,   9.3950480E-02
     +,   9.9056952E-02,   0.1044493    ,   0.1101659    
     +,   0.1162486    ,   0.1227423    ,   0.1296940    
     +,   0.1371517    ,   0.1451634    ,   0.1537755    
     +,   0.1630331    ,   0.1729798    ,   0.1836591    
     +,   0.1951189    ,   0.2074151    ,   0.2206201    
     +,   0.2348305    ,   0.2501736    ,   0.2668129    
     +,   0.2849481    ,   0.3048055    ,   0.3266208    
     +,   0.3506108    ,   0.3769387    ,   0.4056804    
     +,   0.4367972    ,   0.4701267    ,   0.5054009    
     +,   0.5422916    ,   0.5804737    ,   0.6197037    
     +,   0.6598719    ,   0.7010247    ,   0.7433389    
     +,   0.7870738    ,   0.8325120    ,   0.8799373    
     +,   0.9296361    ,   0.9819139    ,    1.037100    
     +,    1.095560    ,    1.157726    ,    1.224178    
     +,    1.295605    ,    1.372521    ,    1.454615    
     +,    1.540029    ,    1.625213    ,    1.705920    
     +,    1.779219    ,    1.845456    ,    1.908664    
     +,    1.974958    ,    2.049923    ,    2.136705    
     +,    2.235554    ,    2.344249    ,    2.458537    
     +,    2.572731    ,    2.680881    ,    2.778206    
     +,    2.861740    ,    2.929862    ,    2.981341    
     +,    3.014741    ,    3.028305    ,    3.020087    
     +,    2.987975    ,    2.929984    ,    2.845138    
     +,    2.735243    ,    2.606172    ,    2.467090    
     +,    2.327187    ,    2.192218    ,    2.063348    
     +,    1.938890    ,    1.816969    ,    1.697173    
     +,    1.580409    ,    1.467857    ,    1.360071    
     +,    1.256757    ,    1.157170    ,    1.060747    
     +,   0.9675920    ,   0.8785853    ,   0.7951907    
     +,   0.7190132    ,   0.6513788    ,   0.5929898    
     +,   0.5438306    ,   0.5032135    ,   0.4699779    
     +,   0.4427163    ,   0.4200020    ,   0.4005553    
     +,   0.3833387    ,   0.3675841    ,   0.3527715    
     +,   0.3385800    ,   0.3248284    ,   0.3114286    
     +,   0.2983470    ,   0.2855846    ,   0.2731603    
     +,   0.2611086    ,   0.2494708    ,   0.2382938    
     +,   0.2276225    ,   0.2174950    ,   0.2079392    
     +,   0.1989692    ,   0.1905825    ,   0.1827621    
     +,   0.1754792    ,   0.1686943    ,   0.1623638    
     +,   0.1564408    ,   0.1508812    ,   0.1456435    
     +,   0.1406935    ,   0.1360020    ,   0.1315478    
     +,   0.1273152    ,   0.1232940    ,   0.1194786    
     +,   0.1158662    ,   0.1124556    ,   0.1092464    
     +,   0.1062380    ,   0.1034286    ,   0.1008146    
     +,   9.8390386E-02,   9.6148044E-02,   9.4077349E-02
     +,   9.2165716E-02,   9.0398930E-02,   8.8760883E-02
     +,   8.7234266E-02,   8.5801117E-02,   8.4443368E-02
     +,   8.3143070E-02,   8.1882998E-02,   8.0647223E-02
     +,   7.9421513E-02,   7.8193411E-02,   7.6952659E-02
     +,   7.5691395E-02,   7.4404120E-02,   7.3087983E-02
     +,   7.1742229E-02,   7.0368521E-02,   6.8970770E-02
     +,   6.7554392E-02,   6.6126511E-02,   6.4695530E-02
     +,   6.3270874E-02,   6.1862454E-02,   6.0480572E-02
     +,   5.9135608E-02,   5.7837706E-02,   5.6596473E-02
     +,   5.5420931E-02,   5.4319151E-02,   5.3298339E-02
     +,   5.2364495E-02,   5.1522538E-02,   5.0776199E-02
     +,   5.0128050E-02,   4.9579456E-02,   4.9130704E-02
     +,   4.8781104E-02,   4.8528988E-02,   4.8371799E-02
     +,   4.8306383E-02,   4.8328832E-02,   4.8434813E-02
     +,   4.8619539E-02,   4.8877966E-02,   4.9204797E-02
     +,   4.9594648E-02,   5.0042067E-02,   5.0541602E-02
     +,   5.1087845E-02,   5.1675521E-02,   5.2299406E-02
     +,   5.2954443E-02,   5.3635608E-02,   5.4338146E-02
     +,   5.5057194E-02,   5.5788044E-02,   5.6526028E-02
     +,   5.7266448E-02,   5.8004521E-02,   5.8735467E-02
     +,   5.9454374E-02,   6.0156107E-02,   6.0835455E-02
     +,   6.1487123E-02,   6.2105514E-02,   6.2684938E-02
     +,   6.3219555E-02,   6.3703418E-02,   6.4130642E-02
     +,   6.4495191E-02,   6.4791158E-02,   6.5012835E-02
     +,   6.5154716E-02,   6.5211594E-02,   6.5178700E-02
     +,   6.5051749E-02,   6.4827085E-02,   6.4501755E-02
     +,   6.4073443E-02,   6.3540809E-02,   6.2903345E-02
     +,   6.2161475E-02,   6.1316542E-02,   6.0370829E-02
     +,   5.9327662E-02,   5.8191206E-02,   5.6966562E-02
     +,   5.5659521E-02,   5.4276776E-02,   5.2825563E-02
     +,   5.1313631E-02,   4.9749244E-02,   4.8141021E-02
     +,   4.6497639E-02,   4.4827871E-02,   4.3140508E-02
     +,   4.1444235E-02,   3.9747350E-02,   3.8057730E-02
     +,   3.6382988E-02,   3.4730136E-02,   3.3105548E-02
     +,   3.1514943E-02,   2.9963531E-02,   2.8455665E-02
     +,   2.6995009E-02,   2.5584681E-02,   2.4227083E-02
     +,   2.2923898E-02,   2.1676196E-02,   2.0484606E-02
     +,   1.9349204E-02,   1.8269533E-02,   1.7244758E-02
     +,   1.6273728E-02,   1.5355034E-02,   1.4486927E-02
     +,   1.3667482E-02,   1.2894719E-02,   1.2166458E-02
     +,   1.1480496E-02,   1.0834615E-02,   1.0226627E-02
     +,   9.6543152E-03,   9.1155330E-03,   8.6082360E-03
     +,   8.1304545E-03,   7.6802913E-03,   7.2559393E-03
     +,   6.8557537E-03,   6.4781271E-03,   6.1216131E-03
     +,   5.7848231E-03,   5.4665105E-03,   5.1654810E-03
     +,   4.8806719E-03,   4.6110596E-03,   4.3557431E-03
     +,   4.1138581E-03,   3.8846370E-03,   3.6673485E-03
     +,   3.4613195E-03,   3.2659478E-03,   3.0806481E-03
     +,   2.9049041E-03,   2.7382071E-03,   2.5801125E-03
     +,   2.4301771E-03,   2.2880088E-03,   2.1532194E-03
     +,   2.0254618E-03,   1.9043916E-03,   1.7896992E-03
     +,   1.6810752E-03,   1.5782425E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_ashz_hatt70_mass = Yx/30.8700274285714
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_ashz_hatt75_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.1952163E-02,   2.3672704E-02
     +,   2.5518555E-02,   2.7501157E-02,   2.9633421E-02
     +,   3.1929743E-02,   3.4405820E-02,   3.7078515E-02
     +,   3.9965384E-02,   4.3084469E-02,   4.6453264E-02
     +,   5.0088327E-02,   5.4004237E-02,   5.8212947E-02
     +,   6.2722705E-02,   6.7537516E-02,   7.2656438E-02
     +,   7.8073107E-02,   8.3775967E-02,   8.9748278E-02
     +,   9.5968813E-02,   0.1024133    ,   0.1090553    
     +,   0.1158696    ,   0.1228331    ,   0.1299291    
     +,   0.1371501    ,   0.1445012    ,   0.1520038    
     +,   0.1596984    ,   0.1676467    ,   0.1759325    
     +,   0.1846604    ,   0.1939522    ,   0.2039418    
     +,   0.2147665    ,   0.2265584    ,   0.2394332    
     +,   0.2534817    ,   0.2687578    ,   0.2852750    
     +,   0.3029989    ,   0.3218450    ,   0.3416786    
     +,   0.3623161    ,   0.3835275    ,   0.4050423    
     +,   0.4265672    ,   0.4478038    ,   0.4684897    
     +,   0.4884456    ,   0.5076370    ,   0.5262398    
     +,   0.5446851    ,   0.5636752    ,   0.5841566    
     +,   0.6072260    ,   0.6339958    ,   0.6654330    
     +,   0.7022244    ,   0.7447205    ,   0.7930363    
     +,   0.8473277    ,   0.9082450    ,   0.9773774    
     +,    1.057398    ,    1.151574    ,    1.262409    
     +,    1.389945    ,    1.530616    ,    1.677900    
     +,    1.824809    ,    1.967204    ,    2.105786    
     +,    2.245365    ,    2.391244    ,    2.544122    
     +,    2.696603    ,    2.835145    ,    2.948941    
     +,    3.040395    ,    3.126205    ,    3.223294    
     +,    3.331404    ,    3.432176    ,    3.507799    
     +,    3.558933    ,    3.605485    ,    3.674194    
     +,    3.783774    ,    3.932558    ,    4.095035    
     +,    4.231779    ,    4.306556    ,    4.300657    
     +,    4.218087    ,    4.078408    ,    3.900181    
     +,    3.688923    ,    3.442253    ,    3.165448    
     +,    2.877403    ,    2.600416    ,    2.348120    
     +,    2.123116    ,    1.921619    ,    1.738039    
     +,    1.567775    ,    1.408851    ,    1.262058    
     +,    1.129607    ,    1.013362    ,   0.9139272    
     +,   0.8305408    ,   0.7614599    ,   0.7043108    
     +,   0.6564360    ,   0.6151898    ,   0.5782650    
     +,   0.5439175    ,   0.5110790    ,   0.4793099    
     +,   0.4486337    ,   0.4193295    ,   0.3917415    
     +,   0.3661498    ,   0.3426968    ,   0.3213847    
     +,   0.3020935    ,   0.2846304    ,   0.2687680    
     +,   0.2542867    ,   0.2409920    ,   0.2287328    
     +,   0.2173973    ,   0.2069080    ,   0.1972132    
     +,   0.1882750    ,   0.1800592    ,   0.1725296    
     +,   0.1656447    ,   0.1593555    ,   0.1536064    
     +,   0.1483373    ,   0.1434871    ,   0.1389945    
     +,   0.1348016    ,   0.1308551    ,   0.1271082    
     +,   0.1235206    ,   0.1200594    ,   0.1166993    
     +,   0.1134220    ,   0.1102158    ,   0.1070746    
     +,   0.1039976    ,   0.1009879    ,   9.8051406E-02
     +,   9.5195942E-02,   9.2430666E-02,   8.9764565E-02
     +,   8.7206222E-02,   8.4763229E-02,   8.2441740E-02
     +,   8.0246136E-02,   7.8179024E-02,   7.6241493E-02
     +,   7.4433029E-02,   7.2751708E-02,   7.1194485E-02
     +,   6.9757625E-02,   6.8436854E-02,   6.7227468E-02
     +,   6.6124693E-02,   6.5123953E-02,   6.4220667E-02
     +,   6.3410632E-02,   6.2689878E-02,   6.2054779E-02
     +,   6.1501801E-02,   6.1027680E-02,   6.0629204E-02
     +,   6.0303152E-02,   6.0046252E-02,   5.9855022E-02
     +,   5.9725817E-02,   5.9654705E-02,   5.9637442E-02
     +,   5.9669457E-02,   5.9745859E-02,   5.9861470E-02
     +,   6.0010854E-02,   6.0188301E-02,   6.0387935E-02
     +,   6.0603745E-02,   6.0829684E-02,   6.1059624E-02
     +,   6.1287530E-02,   6.1507426E-02,   6.1713550E-02
     +,   6.1900191E-02,   6.2062014E-02,   6.2193818E-02
     +,   6.2290706E-02,   6.2348172E-02,   6.2361859E-02
     +,   6.2327910E-02,   6.2242631E-02,   6.2102821E-02
     +,   6.1905537E-02,   6.1648235E-02,   6.1328769E-02
     +,   6.0945306E-02,   6.0496476E-02,   5.9981190E-02
     +,   5.9398942E-02,   5.8749527E-02,   5.8033220E-02
     +,   5.7250679E-02,   5.6403097E-02,   5.5492077E-02
     +,   5.4519642E-02,   5.3488337E-02,   5.2401133E-02
     +,   5.1261358E-02,   5.0072722E-02,   4.8839360E-02
     +,   4.7565799E-02,   4.6256702E-02,   4.4917028E-02
     +,   4.3551929E-02,   4.2166781E-02,   4.0766865E-02
     +,   3.9357524E-02,   3.7944153E-02,   3.6531951E-02
     +,   3.5125908E-02,   3.3730946E-02,   3.2351684E-02
     +,   3.0992348E-02,   2.9656859E-02,   2.8348843E-02
     +,   2.7071528E-02,   2.5827657E-02,   2.4619557E-02
     +,   2.3449237E-02,   2.2318291E-02,   2.1227831E-02
     +,   2.0178605E-02,   1.9171111E-02,   1.8205395E-02
     +,   1.7281221E-02,   1.6398145E-02,   1.5555477E-02
     +,   1.4752255E-02,   1.3987363E-02,   1.3259592E-02
     +,   1.2567621E-02,   1.1909998E-02,   1.1285230E-02
     +,   1.0691840E-02,   1.0128330E-02,   9.5931869E-03
     +,   9.0849251E-03,   8.6021516E-03,   8.1434865E-03
     +,   7.7076065E-03,   7.2932811E-03,   6.8993610E-03
     +,   6.5247342E-03,   6.1683692E-03,   5.8293277E-03
     +,   5.5067427E-03,   5.1997853E-03,   4.9076984E-03
     +,   4.6298103E-03,   4.3654582E-03,   4.1140676E-03
     +,   3.8750751E-03,   3.6479812E-03,   3.4322932E-03
     +,   3.2275761E-03,   3.0333889E-03,   2.8493411E-03
     +,   2.6750339E-03,   2.5101060E-03,   2.3541909E-03
     +,   2.2069365E-03,   2.0680102E-03,   1.9370696E-03
     +,   1.8137963E-03,   1.6978607E-03,   1.5889535E-03
     +,   1.4867567E-03,   1.3909694E-03,   1.3012846E-03
     +,   1.2174116E-03,   1.1390542E-03,   1.0659324E-03
     +,   9.9776289E-04,   9.3427865E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_ashz_hatt75_mass = Yx/38.5406868
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_ashz_hatt80_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.7486891E-02,   1.8340886E-02
     +,   1.9216521E-02,   2.0113492E-02,   2.1031512E-02
     +,   2.1970306E-02,   2.2929646E-02,   2.3909330E-02
     +,   2.4909183E-02,   2.5929153E-02,   2.6969135E-02
     +,   2.8029155E-02,   2.9109281E-02,   3.0209662E-02
     +,   3.1330533E-02,   3.2472230E-02,   3.3635195E-02
     +,   3.4820046E-02,   3.6027580E-02,   3.7258860E-02
     +,   3.8515259E-02,   3.9798588E-02,   4.1111130E-02
     +,   4.2456027E-02,   4.3837041E-02,   4.5259271E-02
     +,   4.6729021E-02,   4.8254248E-02,   4.9844854E-02
     +,   5.1512983E-02,   5.3273372E-02,   5.5143602E-02
     +,   5.7144415E-02,   5.9299778E-02,   6.1637025E-02
     +,   6.4186715E-02,   6.6982277E-02,   7.0059568E-02
     +,   7.3456131E-02,   7.7209778E-02,   8.1357814E-02
     +,   8.5934915E-02,   9.0971597E-02,   9.6491866E-02
     +,   0.1025113    ,   0.1090345    ,   0.1160541    
     +,   0.1235480    ,   0.1314795    ,   0.1397975    
     +,   0.1484383    ,   0.1573293    ,   0.1663953    
     +,   0.1755674    ,   0.1847921    ,   0.1940454    
     +,   0.2033446    ,   0.2127585    ,   0.2224147    
     +,   0.2324982    ,   0.2432437    ,   0.2549169    
     +,   0.2677881    ,   0.2821047    ,   0.2980660    
     +,   0.3158041    ,   0.3353878    ,   0.3568331    
     +,   0.3801402    ,   0.4053234    ,   0.4324610    
     +,   0.4617196    ,   0.4933868    ,   0.5278584    
     +,   0.5656111    ,   0.6071084    ,   0.6526598    
     +,   0.7022816    ,   0.7556179    ,   0.8120240    
     +,   0.8708407    ,   0.9318236    ,   0.9954986    
     +,    1.063249    ,    1.136960    ,    1.218408    
     +,    1.308763    ,    1.408603    ,    1.518327    
     +,    1.638311    ,    1.767950    ,    1.903908    
     +,    2.039539    ,    2.168249    ,    2.290777    
     +,    2.420616    ,    2.579427    ,    2.781853    
     +,    3.022463    ,    3.277808    ,    3.521273    
     +,    3.738497    ,    3.937927    ,    4.153067    
     +,    4.424957    ,    4.759082    ,    5.091016    
     +,    5.324968    ,    5.436529    ,    5.505312    
     +,    5.602601    ,    5.687085    ,    5.667953    
     +,    5.530366    ,    5.332363    ,    5.109038    
     +,    4.848490    ,    4.545309    ,    4.219654    
     +,    3.885883    ,    3.538192    ,    3.172549    
     +,    2.803792    ,    2.453789    ,    2.134477    
     +,    1.848811    ,    1.600096    ,    1.393610    
     +,    1.230996    ,    1.106837    ,    1.010720    
     +,   0.9318175    ,   0.8620462    ,   0.7967985    
     +,   0.7340739    ,   0.6733748    ,   0.6149570    
     +,   0.5594199    ,   0.5074687    ,   0.4597264    
     +,   0.4166089    ,   0.3782611    ,   0.3445694    
     +,   0.3152296    ,   0.2898237    ,   0.2678838    
     +,   0.2489410    ,   0.2325582    ,   0.2183425    
     +,   0.2059496    ,   0.1950848    ,   0.1854982    
     +,   0.1769789    ,   0.1693476    ,   0.1624529    
     +,   0.1561660    ,   0.1503775    ,   0.1449942    
     +,   0.1399374    ,   0.1351418    ,   0.1305542    
     +,   0.1261320    ,   0.1218434    ,   0.1176662    
     +,   0.1135859    ,   0.1095963    ,   0.1056974    
     +,   0.1018949    ,   9.8198563E-02,   9.4621219E-02
     +,   9.1178134E-02,   8.7885432E-02,   8.4759012E-02
     +,   8.1813671E-02,   7.9062834E-02,   7.6517090E-02
     +,   7.4183986E-02,   7.2067983E-02,   7.0169866E-02
     +,   6.8486698E-02,   6.7012258E-02,   6.5737151E-02
     +,   6.4649157E-02,   6.3733757E-02,   6.2974513E-02
     +,   6.2353887E-02,   6.1853487E-02,   6.1454777E-02
     +,   6.1139371E-02,   6.0889769E-02,   6.0689352E-02
     +,   6.0522895E-02,   6.0376737E-02,   6.0238823E-02
     +,   6.0098886E-02,   5.9948299E-02,   5.9780184E-02
     +,   5.9589308E-02,   5.9371699E-02,   5.9124824E-02
     +,   5.8847148E-02,   5.8538117E-02,   5.8197811E-02
     +,   5.7826947E-02,   5.7426590E-02,   5.6998000E-02
     +,   5.6542475E-02,   5.6061331E-02,   5.5555765E-02
     +,   5.5026773E-02,   5.4475065E-02,   5.3901199E-02
     +,   5.3305335E-02,   5.2687492E-02,   5.2047368E-02
     +,   5.1384535E-02,   5.0698448E-02,   4.9988378E-02
     +,   4.9253561E-02,   4.8493378E-02,   4.7707107E-02
     +,   4.6894263E-02,   4.6054445E-02,   4.5187559E-02
     +,   4.4293649E-02,   4.3373041E-02,   4.2426333E-02
     +,   4.1454520E-02,   4.0458739E-02,   3.9440438E-02
     +,   3.8401414E-02,   3.7343752E-02,   3.6269661E-02
     +,   3.5181604E-02,   3.4082312E-02,   3.2974578E-02
     +,   3.1861309E-02,   3.0745558E-02,   2.9630477E-02
     +,   2.8519075E-02,   2.7414424E-02,   2.6319563E-02
     +,   2.5237434E-02,   2.4170790E-02,   2.3122283E-02
     +,   2.2094397E-02,   2.1089453E-02,   2.0109495E-02
     +,   1.9156322E-02,   1.8231601E-02,   1.7336646E-02
     +,   1.6472546E-02,   1.5640182E-02,   1.4840194E-02
     +,   1.4072921E-02,   1.3338508E-02,   1.2636886E-02
     +,   1.1967829E-02,   1.1330851E-02,   1.0725318E-02
     +,   1.0150492E-02,   9.6054971E-03,   9.0893218E-03
     +,   8.6008580E-03,   8.1389965E-03,   7.7025136E-03
     +,   7.2901668E-03,   6.9007226E-03,   6.5329392E-03
     +,   6.1855721E-03,   5.8573964E-03,   5.5472497E-03
     +,   5.2540009E-03,   4.9765548E-03,   4.7138738E-03
     +,   4.4650016E-03,   4.2290078E-03,   4.0050610E-03
     +,   3.7923576E-03,   3.5901850E-03,   3.3978613E-03
     +,   3.2147928E-03,   3.0404092E-03,   2.8742191E-03
     +,   2.7157550E-03,   2.5646128E-03,   2.4204154E-03
     +,   2.2828202E-03,   2.1515314E-03,   2.0262636E-03
     +,   1.9067734E-03,   1.7928224E-03,   1.6842074E-03
     +,   1.5807245E-03,   1.4821993E-03,   1.3884532E-03
     +,   1.2993305E-03,   1.2146703E-03,   1.1343291E-03
     +,   1.0581565E-03,   9.8601740E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_ashz_hatt80_mass = Yx/43.2099162352941
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_ashz_hatt85_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  5.6329211E-03,   5.7725511E-03
     +,   5.9156707E-03,   6.0626525E-03,   6.2138806E-03
     +,   6.3697458E-03,   6.5306406E-03,   6.6969586E-03
     +,   6.8690833E-03,   7.0473985E-03,   7.2322590E-03
     +,   7.4240076E-03,   7.6229689E-03,   7.8294352E-03
     +,   8.0436748E-03,   8.2659330E-03,   8.4964233E-03
     +,   8.7353401E-03,   8.9828586E-03,   9.2391288E-03
     +,   9.5043108E-03,   9.7785546E-03,   1.0062027E-02
     +,   1.0354942E-02,   1.0657530E-02,   1.0970114E-02
     +,   1.1293082E-02,   1.1626933E-02,   1.1972287E-02
     +,   1.2329915E-02,   1.2700753E-02,   1.3085928E-02
     +,   1.3486760E-02,   1.3904794E-02,   1.4341797E-02
     +,   1.4799767E-02,   1.5280914E-02,   1.5787665E-02
     +,   1.6322654E-02,   1.6888628E-02,   1.7488502E-02
     +,   1.8125229E-02,   1.8801773E-02,   1.9521026E-02
     +,   2.0285754E-02,   2.1098509E-02,   2.1961540E-02
     +,   2.2876736E-02,   2.3845553E-02,   2.4868997E-02
     +,   2.5947565E-02,   2.7081318E-02,   2.8269894E-02
     +,   2.9512711E-02,   3.0809032E-02,   3.2158393E-02
     +,   3.3560839E-02,   3.5017435E-02,   3.6530726E-02
     +,   3.8105540E-02,   3.9749481E-02,   4.1473959E-02
     +,   4.3294542E-02,   4.5232270E-02,   4.7313932E-02
     +,   4.9572453E-02,   5.2047588E-02,   5.4785054E-02
     +,   5.7836737E-02,   6.1258785E-02,   6.5110840E-02
     +,   6.9452889E-02,   7.4343815E-02,   7.9837464E-02
     +,   8.5981056E-02,   9.2812262E-02,   0.1003576    
     +,   0.1086320    ,   0.1176408    ,   0.1273818    
     +,   0.1378480    ,   0.1490356    ,   0.1609455    
     +,   0.1735919    ,   0.1870031    ,   0.2012259    
     +,   0.2163239    ,   0.2323797    ,   0.2494920    
     +,   0.2677797    ,   0.2873854    ,   0.3084806    
     +,   0.3312781    ,   0.3560424    ,   0.3830977    
     +,   0.4128261    ,   0.4456674    ,   0.4820926    
     +,   0.5225841    ,   0.5675956    ,   0.6175681    
     +,   0.6729630    ,   0.7343637    ,   0.8024955    
     +,   0.8780774    ,   0.9613370    ,    1.051321    
     +,    1.145510    ,    1.240549    ,    1.334671    
     +,    1.431082    ,    1.539543    ,    1.672831    
     +,    1.838863    ,    2.034752    ,    2.248555    
     +,    2.466156    ,    2.679168    ,    2.894593    
     +,    3.138690    ,    3.432917    ,    3.753146    
     +,    4.036946    ,    4.257439    ,    4.458374    
     +,    4.676357    ,    4.879467    ,    5.045998    
     +,    5.248981    ,    5.615665    ,    6.187417    
     +,    6.829859    ,    7.394572    ,    7.787951    
     +,    7.860019    ,    7.592134    ,    7.163532    
     +,    6.691566    ,    6.193857    ,    5.693357    
     +,    5.177235    ,    4.584378    ,    3.917158    
     +,    3.270276    ,    2.733170    ,    2.316125    
     +,    1.977128    ,    1.683643    ,    1.430560    
     +,    1.221901    ,    1.056299    ,   0.9266210    
     +,   0.8243309    ,   0.7421270    ,   0.6745322    
     +,   0.6176518    ,   0.5687561    ,   0.5258951    
     +,   0.4876058    ,   0.4527347    ,   0.4203657    
     +,   0.3898175    ,   0.3606576    ,   0.3326849    
     +,   0.3058797    ,   0.2803437    ,   0.2562351    
     +,   0.2337189    ,   0.2129324    ,   0.1939699    
     +,   0.1768803    ,   0.1616676    ,   0.1482969    
     +,   0.1367032    ,   0.1267976    ,   0.1184719    
     +,   0.1116040    ,   0.1060614    ,   0.1017050    
     +,   9.8391883E-02,   9.5979363E-02,   9.4328396E-02
     +,   9.3305781E-02,   9.2786856E-02,   9.2657007E-02
     +,   9.2812806E-02,   9.3162388E-02,   9.3625277E-02
     +,   9.4132267E-02,   9.4624512E-02,   9.5052592E-02
     +,   9.5376022E-02,   9.5561951E-02,   9.5584966E-02
     +,   9.5425665E-02,   9.5070615E-02,   9.4511338E-02
     +,   9.3744382E-02,   9.2770427E-02,   9.1594182E-02
     +,   9.0223983E-02,   8.8671423E-02,   8.6950988E-02
     +,   8.5079536E-02,   8.3076149E-02,   8.0961332E-02
     +,   7.8756623E-02,   7.6484226E-02,   7.4166290E-02
     +,   7.1824417E-02,   6.9479167E-02,   6.7149676E-02
     +,   6.4853333E-02,   6.2605195E-02,   6.0417756E-02
     +,   5.8301285E-02,   5.6263167E-02,   5.4308146E-02
     +,   5.2438412E-02,   5.0653946E-02,   4.8952434E-02
     +,   4.7329772E-02,   4.5780417E-02,   4.4297658E-02
     +,   4.2873893E-02,   4.1501079E-02,   4.0171113E-02
     +,   3.8876072E-02,   3.7608366E-02,   3.6361095E-02
     +,   3.5128295E-02,   3.3904936E-02,   3.2687005E-02
     +,   3.1471554E-02,   3.0256877E-02,   2.9042227E-02
     +,   2.7827814E-02,   2.6614867E-02,   2.5405390E-02
     +,   2.4201984E-02,   2.3007760E-02,   2.1826304E-02
     +,   2.0661471E-02,   1.9517131E-02,   1.8397162E-02
     +,   1.7305393E-02,   1.6245445E-02,   1.5220569E-02
     +,   1.4233631E-02,   1.3287201E-02,   1.2383274E-02
     +,   1.1523392E-02,   1.0708660E-02,   9.9397087E-03
     +,   9.2166588E-03,   8.5392073E-03,   7.9066996E-03
     +,   7.3181218E-03,   6.7721074E-03,   6.2670377E-03
     +,   5.8011110E-03,   5.3723576E-03,   4.9786521E-03
     +,   4.6177972E-03,   4.2875935E-03,   3.9858022E-03
     +,   3.7102157E-03,   3.4587001E-03,   3.2291973E-03
     +,   3.0197261E-03,   2.8284159E-03,   2.6535280E-03
     +,   2.4934430E-03,   2.3466577E-03,   2.2117968E-03
     +,   2.0876213E-03,   1.9729966E-03,   1.8669157E-03
     +,   1.7684663E-03,   1.6768494E-03,   1.5913468E-03
     +,   1.5113357E-03,   1.4362604E-03,   1.3656436E-03
     +,   1.2990598E-03,   1.2361482E-03,   1.1765881E-03
     +,   1.1201025E-03,   1.0664547E-03,   1.0154338E-03
     +,   9.6686155E-04,   9.2057692E-04,   8.7644451E-04
     +,   8.3433912E-04,   7.9415546E-04,   7.5579411E-04
     +,   7.1917073E-04,   6.8420410E-04,   6.5082405E-04
     +,   6.1896158E-04,   5.8855652E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_ashz_hatt85_mass = Yx/46.3369496470588
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_ashz_hatt90_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  5.1112305E-03,   5.2305046E-03
     +,   5.3502982E-03,   5.4706032E-03,   5.5914093E-03
     +,   5.7127238E-03,   5.8345553E-03,   5.9569255E-03
     +,   6.0798614E-03,   6.2034070E-03,   6.3276063E-03
     +,   6.4525241E-03,   6.5782261E-03,   6.7047966E-03
     +,   6.8323254E-03,   6.9609205E-03,   7.0906971E-03
     +,   7.2217816E-03,   7.3543177E-03,   7.4884584E-03
     +,   7.6243738E-03,   7.7622421E-03,   7.9022618E-03
     +,   8.0446554E-03,   8.1896354E-03,   8.3374660E-03
     +,   8.4884102E-03,   8.6427554E-03,   8.8008204E-03
     +,   8.9629423E-03,   9.1294888E-03,   9.3008587E-03
     +,   9.4774812E-03,   9.6598258E-03,   9.8483944E-03
     +,   1.0043734E-02,   1.0246429E-02,   1.0457108E-02
     +,   1.0676457E-02,   1.0905185E-02,   1.1144060E-02
     +,   1.1393896E-02,   1.1655528E-02,   1.1929840E-02
     +,   1.2217750E-02,   1.2520183E-02,   1.2838081E-02
     +,   1.3172385E-02,   1.3524037E-02,   1.3893928E-02
     +,   1.4282917E-02,   1.4691819E-02,   1.5121329E-02
     +,   1.5572092E-02,   1.6044587E-02,   1.6539190E-02
     +,   1.7056102E-02,   1.7595330E-02,   1.8156728E-02
     +,   1.8739922E-02,   1.9344326E-02,   1.9969137E-02
     +,   2.0613296E-02,   2.1275571E-02,   2.1954542E-02
     +,   2.2648489E-02,   2.3355661E-02,   2.4074033E-02
     +,   2.4801584E-02,   2.5536131E-02,   2.6275577E-02
     +,   2.7017750E-02,   2.7760677E-02,   2.8502446E-02
     +,   2.9241422E-02,   2.9976266E-02,   3.0705936E-02
     +,   3.1429816E-02,   3.2147799E-02,   3.2860342E-02
     +,   3.3568416E-02,   3.4273777E-02,   3.4978818E-02
     +,   3.5686847E-02,   3.6401939E-02,   3.7129220E-02
     +,   3.7874807E-02,   3.8646042E-02,   3.9451499E-02
     +,   4.0301211E-02,   4.1206777E-02,   4.2181499E-02
     +,   4.3240443E-02,   4.4400748E-02,   4.5681614E-02
     +,   4.7104068E-02,   4.8691370E-02,   5.0468262E-02
     +,   5.2461311E-02,   5.4697998E-02,   5.7206843E-02
     +,   6.0016476E-02,   6.3155904E-02,   6.6653669E-02
     +,   7.0539013E-02,   7.4842162E-02,   7.9595312E-02
     +,   8.4835321E-02,   9.0606250E-02,   9.6962459E-02
     +,   0.1039709    ,   0.1117141    ,   0.1202891    
     +,   0.1298063    ,   0.1403810    ,   0.1521260    
     +,   0.1651345    ,   0.1794681    ,   0.1951370    
     +,   0.2120907    ,   0.2302094    ,   0.2493043    
     +,   0.2691336    ,   0.2894332    ,   0.3099652    
     +,   0.3305909    ,   0.3513722    ,   0.3726766    
     +,   0.3952831    ,   0.4204184    ,   0.4497111    
     +,   0.4850098    ,   0.5281515    ,   0.5807927    
     +,   0.6445324    ,   0.7214166    ,   0.8146256    
     +,   0.9288159    ,    1.069463    ,    1.240977    
     +,    1.444093    ,    1.673516    ,    1.917127    
     +,    2.158498    ,    2.383753    ,    2.589993    
     +,    2.790196    ,    3.015721    ,    3.317816    
     +,    3.742976    ,    4.263523    ,    4.761678    
     +,    5.162574    ,    5.528547    ,    5.958506    
     +,    6.498709    ,    7.114625    ,    7.649027    
     +,    7.969813    ,    8.114797    ,    8.082717    
     +,    7.770854    ,    7.213618    ,    6.613895    
     +,    6.078742    ,    5.517704    ,    4.859328    
     +,    4.155839    ,    3.483717    ,    2.881127    
     +,    2.360814    ,    1.921588    ,    1.556128    
     +,    1.260586    ,    1.033643    ,   0.8700125    
     +,   0.7595824    ,   0.6915399    ,   0.6574283    
     +,   0.6509750    ,   0.6665434    ,   0.6981608    
     +,   0.7395187    ,   0.7844518    ,   0.8273989    
     +,   0.8636665    ,   0.8895496    ,   0.9024007    
     +,   0.9007327    ,   0.8843594    ,   0.8544811    
     +,   0.8135899    ,   0.7651496    ,   0.7130337    
     +,   0.6608819    ,   0.6115491    ,   0.5667923    
     +,   0.5272413    ,   0.4926221    ,   0.4621166    
     +,   0.4347304    ,   0.4095676    ,   0.3859777    
     +,   0.3635889    ,   0.3422551    ,   0.3219641    
     +,   0.3027527    ,   0.2846477    ,   0.2676348    
     +,   0.2516539    ,   0.2366144    ,   0.2224124    
     +,   0.2089476    ,   0.1961318    ,   0.1838948    
     +,   0.1721856    ,   0.1609695    ,   0.1502241    
     +,   0.1399384    ,   0.1301099    ,   0.1207421    
     +,   0.1118420    ,   0.1034193    ,   9.5483162E-02
     +,   8.8039137E-02,   8.1088461E-02,   7.4626699E-02
     +,   6.8642862E-02,   6.3119099E-02,   5.8031946E-02
     +,   5.3354122E-02,   4.9055409E-02,   4.5104180E-02
     +,   4.1469228E-02,   3.8121220E-02,   3.5032801E-02
     +,   3.2179672E-02,   2.9540634E-02,   2.7097628E-02
     +,   2.4835002E-02,   2.2739528E-02,   2.0799968E-02
     +,   1.9006496E-02,   1.7350242E-02,   1.5823068E-02
     +,   1.4417413E-02,   1.3126018E-02,   1.1941739E-02
     +,   1.0857597E-02,   9.8668430E-03,   8.9628007E-03
     +,   8.1389742E-03,   7.3891748E-03,   6.7074611E-03
     +,   6.0881693E-03,   5.5259643E-03,   5.0159027E-03
     +,   4.5533949E-03,   4.1341735E-03,   3.7543208E-03
     +,   3.4102774E-03,   3.0987882E-03,   2.8168703E-03
     +,   2.5618072E-03,   2.3311549E-03,   2.1226625E-03
     +,   1.9342845E-03,   1.7641719E-03,   1.6106352E-03
     +,   1.4721252E-03,   1.3472304E-03,   1.2346702E-03
     +,   1.1332746E-03,   1.0419700E-03,   9.5977786E-04
     +,   8.8581356E-04,   8.1926136E-04,   7.5938756E-04
     +,   7.0551742E-04,   6.5704435E-04,   6.1341183E-04
     +,   5.7412079E-04,   5.3871435E-04,   5.0678354E-04
     +,   4.7795495E-04,   4.5189488E-04,   4.2830044E-04
     +,   4.0689850E-04,   3.8744611E-04,   3.6972208E-04
     +,   3.5353078E-04,   3.3869484E-04,   3.2505763E-04
     +,   3.1247805E-04,   3.0083180E-04,   2.9000716E-04
     +,   2.7990664E-04,   2.7044269E-04,   2.6153945E-04
     +,   2.5312905E-04,   2.4515318E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_ashz_hatt90_mass = Yx/44.9866397647059
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_ashz_hatt95_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.8967194E-03,   3.0485168E-03
     +,   3.2060381E-03,   3.3693288E-03,   3.5384174E-03
     +,   3.7133172E-03,   3.8940241E-03,   4.0805172E-03
     +,   4.2727543E-03,   4.4706832E-03,   4.6742298E-03
     +,   4.8832940E-03,   5.0977697E-03,   5.3175297E-03
     +,   5.5424278E-03,   5.7723089E-03,   6.0070017E-03
     +,   6.2463270E-03,   6.4900904E-03,   6.7380979E-03
     +,   6.9901398E-03,   7.2460189E-03,   7.5055198E-03
     +,   7.7684522E-03,   8.0345981E-03,   8.3037801E-03
     +,   8.5758083E-03,   8.8505074E-03,   9.1277165E-03
     +,   9.4072828E-03,   9.6890656E-03,   9.9729449E-03
     +,   1.0258806E-02,   1.0546554E-02,   1.0836092E-02
     +,   1.1127342E-02,   1.1420231E-02,   1.1714683E-02
     +,   1.2010636E-02,   1.2307997E-02,   1.2606699E-02
     +,   1.2906646E-02,   1.3207722E-02,   1.3509801E-02
     +,   1.3812726E-02,   1.4116317E-02,   1.4420371E-02
     +,   1.4724636E-02,   1.5028845E-02,   1.5332682E-02
     +,   1.5635807E-02,   1.5937844E-02,   1.6238388E-02
     +,   1.6537018E-02,   1.6833277E-02,   1.7126713E-02
     +,   1.7416857E-02,   1.7703261E-02,   1.7985480E-02
     +,   1.8263103E-02,   1.8535761E-02,   1.8803142E-02
     +,   1.9065000E-02,   1.9321168E-02,   1.9571600E-02
     +,   1.9816326E-02,   2.0055527E-02,   2.0289497E-02
     +,   2.0518702E-02,   2.0743720E-02,   2.0965334E-02
     +,   2.1184467E-02,   2.1402208E-02,   2.1619819E-02
     +,   2.1838725E-02,   2.2060515E-02,   2.2286939E-02
     +,   2.2519870E-02,   2.2761377E-02,   2.3013629E-02
     +,   2.3278937E-02,   2.3559773E-02,   2.3858717E-02
     +,   2.4178486E-02,   2.4521943E-02,   2.4892118E-02
     +,   2.5292164E-02,   2.5725482E-02,   2.6195573E-02
     +,   2.6706195E-02,   2.7261324E-02,   2.7865099E-02
     +,   2.8521856E-02,   2.9236142E-02,   3.0012611E-02
     +,   3.0855926E-02,   3.1770792E-02,   3.2761633E-02
     +,   3.3832651E-02,   3.4987472E-02,   3.6229070E-02
     +,   3.7559334E-02,   3.8979176E-02,   4.0487748E-02
     +,   4.2082723E-02,   4.3759763E-02,   4.5512352E-02
     +,   4.7331620E-02,   4.9206495E-02,   5.1123559E-02
     +,   5.3067029E-02,   5.5019278E-02,   5.6960892E-02
     +,   5.8871403E-02,   6.0729492E-02,   6.2514171E-02
     +,   6.4204909E-02,   6.5783054E-02,   6.7232080E-02
     +,   6.8538889E-02,   6.9694333E-02,   7.0693776E-02
     +,   7.1537971E-02,   7.2233230E-02,   7.2791725E-02
     +,   7.3231533E-02,   7.3576413E-02,   7.3855221E-02
     +,   7.4101366E-02,   7.4351892E-02,   7.4646458E-02
     +,   7.5025871E-02,   7.5531095E-02,   7.6201722E-02
     +,   7.7074707E-02,   7.8183413E-02,   7.9556592E-02
     +,   8.1217892E-02,   8.3186023E-02,   8.5475042E-02
     +,   8.8095121E-02,   9.1054015E-02,   9.4359040E-02
     +,   9.8018751E-02,   0.1020445    ,   0.1064527    
     +,   0.1112657    ,   0.1165109    ,   0.1222210    
     +,   0.1284314    ,   0.1351770    ,   0.1424871    
     +,   0.1503802    ,   0.1588591    ,   0.1679049    
     +,   0.1774716    ,   0.1874835    ,   0.1978357    
     +,   0.2083962    ,   0.2190110    ,   0.2295183    
     +,   0.2397614    ,   0.2496065    ,   0.2589628    
     +,   0.2678010    ,   0.2761655    ,   0.2841823    
     +,   0.2920566    ,   0.3000656    ,   0.3085424    
     +,   0.3178627    ,   0.3284378    ,   0.3407184    
     +,   0.3552077    ,   0.3724838    ,   0.3932157    
     +,   0.4181526    ,   0.4480911    ,   0.4838369    
     +,   0.5262327    ,   0.5763116    ,   0.6355588    
     +,   0.7061735    ,   0.7913221    ,   0.8958573    
     +,    1.028525    ,    1.205777    ,    1.453282    
     +,    1.796464    ,    2.238075    ,    2.747611    
     +,    3.294430    ,    3.884837    ,    4.515796    
     +,    5.124514    ,    5.683560    ,    6.248763    
     +,    6.816921    ,    7.328226    ,    7.790733    
     +,    8.219176    ,    8.501992    ,    8.452633    
     +,    8.056389    ,    7.455307    ,    6.827338    
     +,    6.269243    ,    5.736130    ,    5.218296    
     +,    4.754490    ,    4.322870    ,    3.885754    
     +,    3.444952    ,    3.030119    ,    2.669292    
     +,    2.362062    ,    2.083866    ,    1.817326    
     +,    1.566121    ,    1.341568    ,    1.148176    
     +,   0.9828897    ,   0.8410618    ,   0.7198242    
     +,   0.6174043    ,   0.5315679    ,   0.4592905    
     +,   0.3974257    ,   0.3434144    ,   0.2955521    
     +,   0.2528763    ,   0.2149120    ,   0.1814347    
     +,   0.1523009    ,   0.1273413    ,   0.1063024    
     +,   8.8836245E-02,   7.4521765E-02,   6.2898494E-02
     +,   5.3505808E-02,   4.5916479E-02,   3.9757837E-02
     +,   3.4719881E-02,   3.0554285E-02,   2.7068010E-02
     +,   2.4113938E-02,   2.1580739E-02,   1.9384257E-02
     +,   1.7460678E-02,   1.5761450E-02,   1.4249026E-02
     +,   1.2894297E-02,   1.1674684E-02,   1.0572483E-02
     +,   9.5736915E-03,   8.6671831E-03,   7.8440486E-03
     +,   7.0969518E-03,   6.4196382E-03,   5.8066556E-03
     +,   5.2531385E-03,   4.7545806E-03,   4.3067005E-03
     +,   3.9054130E-03,   3.5468326E-03,   3.2271883E-03
     +,   2.9428699E-03,   2.6904633E-03,   2.4667392E-03
     +,   2.2686550E-03,   2.0933887E-03,   1.9383508E-03
     +,   1.8011726E-03,   1.6796977E-03,   1.5719848E-03
     +,   1.4763080E-03,   1.3911203E-03,   1.3150646E-03
     +,   1.2469371E-03,   1.1856923E-03,   1.1304097E-03
     +,   1.0802953E-03,   1.0346550E-03,   9.9289371E-04
     +,   9.5449231E-04,   9.1900787E-04,   8.8605605E-04
     +,   8.5530611E-04,   8.2647690E-04,   7.9932314E-04
     +,   7.7363744E-04,   7.4923894E-04,   7.2597509E-04
     +,   7.0371240E-04,   6.8233913E-04,   6.6175679E-04
     +,   6.4188364E-04,   6.2264729E-04,   6.0398818E-04
     +,   5.8585353E-04,   5.6820031E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_ashz_hatt95_mass = Yx/42.5939854117647
      RETURN
      END
C 
C---- New file --- 
C 
      DOUBLE PRECISION FUNCTION A200_tt_haonly_htt100_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.2535534E-03,   1.2600783E-03
     +,   1.2664929E-03,   1.2728159E-03,   1.2790653E-03
     +,   1.2852601E-03,   1.2914183E-03,   1.2975591E-03
     +,   1.3037003E-03,   1.3098597E-03,   1.3160553E-03
     +,   1.3223035E-03,   1.3286216E-03,   1.3350248E-03
     +,   1.3415290E-03,   1.3481476E-03,   1.3548951E-03
     +,   1.3617834E-03,   1.3688242E-03,   1.3760281E-03
     +,   1.3834042E-03,   1.3909612E-03,   1.3987053E-03
     +,   1.4066431E-03,   1.4147778E-03,   1.4231133E-03
     +,   1.4316508E-03,   1.4403907E-03,   1.4493318E-03
     +,   1.4584708E-03,   1.4678043E-03,   1.4773266E-03
     +,   1.4870304E-03,   1.4969076E-03,   1.5069477E-03
     +,   1.5171400E-03,   1.5274715E-03,   1.5379278E-03
     +,   1.5484942E-03,   1.5591534E-03,   1.5698877E-03
     +,   1.5806783E-03,   1.5915046E-03,   1.6023454E-03
     +,   1.6131782E-03,   1.6239800E-03,   1.6347269E-03
     +,   1.6453941E-03,   1.6559559E-03,   1.6663871E-03
     +,   1.6766607E-03,   1.6867507E-03,   1.6966308E-03
     +,   1.7062745E-03,   1.7156560E-03,   1.7247505E-03
     +,   1.7335333E-03,   1.7419816E-03,   1.7500743E-03
     +,   1.7577927E-03,   1.7651197E-03,   1.7720428E-03
     +,   1.7785525E-03,   1.7846442E-03,   1.7903202E-03
     +,   1.7955864E-03,   1.8004598E-03,   1.8049637E-03
     +,   1.8091331E-03,   1.8130146E-03,   1.8166674E-03
     +,   1.8201672E-03,   1.8236055E-03,   1.8270937E-03
     +,   1.8307642E-03,   1.8347735E-03,   1.8393027E-03
     +,   1.8445617E-03,   1.8507914E-03,   1.8582651E-03
     +,   1.8672906E-03,   1.8782138E-03,   1.8914188E-03
     +,   1.9073322E-03,   1.9264219E-03,   1.9492017E-03
     +,   1.9762276E-03,   2.0081061E-03,   2.0454857E-03
     +,   2.0890648E-03,   2.1395902E-03,   2.1978528E-03
     +,   2.2646880E-03,   2.3409817E-03,   2.4276648E-03
     +,   2.5257054E-03,   2.6361244E-03,   2.7599714E-03
     +,   2.8983483E-03,   3.0523774E-03,   3.2232320E-03
     +,   3.4120947E-03,   3.6201898E-03,   3.8487345E-03
     +,   4.0989672E-03,   4.3721232E-03,   4.6693976E-03
     +,   4.9919374E-03,   5.3408472E-03,   5.7171369E-03
     +,   6.1216629E-03,   6.5551661E-03,   7.0181368E-03
     +,   7.5108884E-03,   8.0333818E-03,   8.5853245E-03
     +,   9.1659790E-03,   9.7742723E-03,   1.0408618E-02
     +,   1.1067006E-02,   1.1746954E-02,   1.2445429E-02
     +,   1.3158917E-02,   1.3883493E-02,   1.4614798E-02
     +,   1.5348053E-02,   1.6078264E-02,   1.6800150E-02
     +,   1.7508410E-02,   1.8197665E-02,   1.8862741E-02
     +,   1.9498622E-02,   2.0100743E-02,   2.0664925E-02
     +,   2.1187622E-02,   2.1665957E-02,   2.2097765E-02
     +,   2.2481667E-02,   2.2817163E-02,   2.3104602E-02
     +,   2.3345185E-02,   2.3540970E-02,   2.3694854E-02
     +,   2.3810549E-02,   2.3892475E-02,   2.3945747E-02
     +,   2.3976078E-02,   2.3989610E-02,   2.3992805E-02
     +,   2.3992216E-02,   2.3994215E-02,   2.4004681E-02
     +,   2.4028607E-02,   2.4069685E-02,   2.4129843E-02
     +,   2.4208806E-02,   2.4303760E-02,   2.4409113E-02
     +,   2.4516532E-02,   2.4615265E-02,   2.4692934E-02
     +,   2.4736809E-02,   2.4735648E-02,   2.4682099E-02
     +,   2.4575528E-02,   2.4425212E-02,   2.4253510E-02
     +,   2.4098771E-02,   2.4017651E-02,   2.4086639E-02
     +,   2.4402840E-02,   2.5083849E-02,   2.6267298E-02
     +,   2.8109815E-02,   3.0784575E-02,   3.4477286E-02
     +,   3.9377853E-02,   4.5665860E-02,   5.3490538E-02
     +,   6.2946960E-02,   7.4052535E-02,   8.6732186E-02
     +,   0.1008234    ,   0.1161061    ,   0.1323530    
     +,   0.1493898    ,   0.1671442    ,   0.1856596    
     +,   0.2050449    ,   0.2253660    ,   0.2464979    
     +,   0.2679751    ,   0.2888955    ,   0.3079302    
     +,   0.3234555    ,   0.3337927    ,   0.3375058    
     +,   0.3336857    ,   0.3221433    ,   0.3034642    
     +,   0.2789168    ,   0.2502392    ,   0.2193617    
     +,   0.1881385    ,   0.1581392    ,   0.1305202    
     +,   0.1059959    ,   8.4880918E-02,   6.7170955E-02
     +,   5.2640241E-02,   4.0934362E-02,   3.1643845E-02
     +,   2.4355443E-02,   1.8684763E-02,   1.4295194E-02
     +,   1.0905159E-02,   8.2874764E-03,   6.2643094E-03
     +,   4.6998258E-03,   3.4917092E-03,   2.5626963E-03
     +,   1.8538226E-03,   1.3190863E-03,   9.2164706E-04
     +,   6.3141697E-04,   4.2366705E-04,   2.7816746E-04
     +,   1.7859774E-04,   1.1207824E-04,   6.8725487E-05
     +,   4.1177096E-05,   2.4113886E-05,   1.3813001E-05
     +,   7.7520372E-06,   4.2755878E-06,   2.3303203E-06
     +,   1.2670953E-06,   6.9809823E-07,   3.9857193E-07
     +,   2.4216698E-07,   1.5996957E-07,   1.1547878E-07
     +,   8.9896986E-08,   7.3798859E-08,   6.2569207E-08
     +,   5.3987208E-08,   4.6989111E-08,   4.1056548E-08
     +,   3.5922973E-08,   3.1437313E-08,   2.7501290E-08
     +,   2.4042562E-08,   2.1002949E-08,   1.8332965E-08
     +,   1.5989189E-08,   1.3933365E-08,   1.2131704E-08
     +,   1.0554196E-08,   9.1741077E-09,   7.9677553E-09
     +,   6.9142274E-09,   5.9949898E-09,   5.1935971E-09
     +,   4.4955311E-09,   3.8880437E-09,   3.3598235E-09
     +,   2.9009131E-09,   2.5025788E-09,   2.1571369E-09
     +,   1.8578162E-09,   1.5986762E-09,   1.3745260E-09
     +,   1.1808180E-09,   1.0135546E-09,   8.6924851E-10
     +,   7.4486606E-10,   6.3774186E-10,   5.4556720E-10
     +,   4.6631948E-10,   3.9825049E-10,   3.3983011E-10
     +,   2.8973690E-10,   2.4681857E-10,   2.1008188E-10
     +,   1.7866181E-10,   1.5181408E-10,   1.2889211E-10
     +,   1.0933842E-10,   9.2673688E-11,   7.8482318E-11
     +,   6.6408552E-11,   5.6144697E-11,   4.7427395E-11
     +,   4.0029705E-11,   3.3757646E-11,   2.8444243E-11
     +,   2.3947075E-11,   2.0143873E-11,   1.6930478E-11
     +,   1.4217655E-11,   1.1929528E-11
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_haonly_htt100_mass = Yx/1.87474965517241
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_haonly_htt105_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.0304988E-03,   1.0550008E-03
     +,   1.0794713E-03,   1.1038854E-03,   1.1282178E-03
     +,   1.1524430E-03,   1.1765356E-03,   1.2004701E-03
     +,   1.2242203E-03,   1.2477618E-03,   1.2710688E-03
     +,   1.2941158E-03,   1.3168780E-03,   1.3393305E-03
     +,   1.3614488E-03,   1.3832086E-03,   1.4045861E-03
     +,   1.4255581E-03,   1.4461012E-03,   1.4661931E-03
     +,   1.4858120E-03,   1.5049360E-03,   1.5235445E-03
     +,   1.5416177E-03,   1.5591347E-03,   1.5760778E-03
     +,   1.5924277E-03,   1.6081677E-03,   1.6232800E-03
     +,   1.6377488E-03,   1.6515587E-03,   1.6646946E-03
     +,   1.6771428E-03,   1.6888903E-03,   1.6999245E-03
     +,   1.7102336E-03,   1.7198072E-03,   1.7286347E-03
     +,   1.7367074E-03,   1.7440167E-03,   1.7505549E-03
     +,   1.7563152E-03,   1.7612920E-03,   1.7654797E-03
     +,   1.7688740E-03,   1.7714716E-03,   1.7732695E-03
     +,   1.7742661E-03,   1.7744600E-03,   1.7738511E-03
     +,   1.7724400E-03,   1.7702278E-03,   1.7672171E-03
     +,   1.7634105E-03,   1.7588123E-03,   1.7534269E-03
     +,   1.7472594E-03,   1.7403167E-03,   1.7326057E-03
     +,   1.7241342E-03,   1.7149113E-03,   1.7049462E-03
     +,   1.6942497E-03,   1.6828332E-03,   1.6707079E-03
     +,   1.6578881E-03,   1.6443862E-03,   1.6302185E-03
     +,   1.6153989E-03,   1.5999461E-03,   1.5838756E-03
     +,   1.5672080E-03,   1.5499622E-03,   1.5321603E-03
     +,   1.5138250E-03,   1.4949810E-03,   1.4756552E-03
     +,   1.4558781E-03,   1.4356831E-03,   1.4151048E-03
     +,   1.3941877E-03,   1.3729770E-03,   1.3515302E-03
     +,   1.3299095E-03,   1.3081916E-03,   1.2864638E-03
     +,   1.2648338E-03,   1.2434254E-03,   1.2223911E-03
     +,   1.2019108E-03,   1.1821993E-03,   1.1635163E-03
     +,   1.1461718E-03,   1.1305335E-03,   1.1170398E-03
     +,   1.1062120E-03,   1.0986634E-03,   1.0951173E-03
     +,   1.0964198E-03,   1.1035562E-03,   1.1176696E-03
     +,   1.1400749E-03,   1.1722815E-03,   1.2160020E-03
     +,   1.2731759E-03,   1.3459807E-03,   1.4368343E-03
     +,   1.5484053E-03,   1.6836179E-03,   1.8456418E-03
     +,   2.0378572E-03,   2.2638657E-03,   2.5274020E-03
     +,   2.8323436E-03,   3.1825742E-03,   3.5819849E-03
     +,   4.0342910E-03,   4.5430255E-03,   5.1113032E-03
     +,   5.7417993E-03,   6.4365715E-03,   7.1968641E-03
     +,   8.0230013E-03,   8.9143096E-03,   9.8689497E-03
     +,   1.0883706E-02,   1.1954125E-02,   1.3074200E-02
     +,   1.4236627E-02,   1.5432555E-02,   1.6651938E-02
     +,   1.7883353E-02,   1.9114479E-02,   2.0332003E-02
     +,   2.1522144E-02,   2.2670820E-02,   2.3763912E-02
     +,   2.4787676E-02,   2.5729172E-02,   2.6576485E-02
     +,   2.7319076E-02,   2.7948065E-02,   2.8456572E-02
     +,   2.8839806E-02,   2.9095216E-02,   2.9222563E-02
     +,   2.9223897E-02,   2.9103437E-02,   2.8867438E-02
     +,   2.8523952E-02,   2.8082496E-02,   2.7553808E-02
     +,   2.6949471E-02,   2.6281504E-02,   2.5562057E-02
     +,   2.4803134E-02,   2.4016269E-02,   2.3212254E-02
     +,   2.2400990E-02,   2.1591494E-02,   2.0791648E-02
     +,   2.0008320E-02,   1.9247450E-02,   1.8514095E-02
     +,   1.7812504E-02,   1.7146299E-02,   1.6518675E-02
     +,   1.5932484E-02,   1.5390335E-02,   1.4894796E-02
     +,   1.4448565E-02,   1.4054606E-02,   1.3716312E-02
     +,   1.3437800E-02,   1.3224194E-02,   1.3081946E-02
     +,   1.3019254E-02,   1.3046524E-02,   1.3176830E-02
     +,   1.3426437E-02,   1.3815300E-02,   1.4367606E-02
     +,   1.5112297E-02,   1.6083850E-02,   1.7323131E-02
     +,   1.8878508E-02,   2.0807343E-02,   2.3177881E-02
     +,   2.6070936E-02,   2.9580835E-02,   3.3815909E-02
     +,   3.8896188E-02,   4.4947498E-02,   5.2092116E-02
     +,   6.0435191E-02,   7.0045978E-02,   8.0935672E-02
     +,   9.3035303E-02,   0.1061768    ,   0.1200783    
     +,   0.1343391    ,   0.1484486    ,   0.1618109    
     +,   0.1737802    ,   0.1837077    ,   0.1909992    
     +,   0.1951686    ,   0.1958868    ,   0.1930181    
     +,   0.1866376    ,   0.1770281    ,   0.1646570    
     +,   0.1501347    ,   0.1341599    ,   0.1174597    
     +,   0.1007338    ,   8.4602557E-02,   6.9568895E-02
     +,   5.5998351E-02,   4.4114560E-02,   3.4005426E-02
     +,   2.5644226E-02,   1.8916154E-02,   1.3646149E-02
     +,   9.6260533E-03,   6.6386047E-03,   4.4754799E-03
     +,   2.9490769E-03,   1.8991425E-03,   1.1950856E-03
     +,   7.3480513E-04,   4.4141343E-04,   2.5904740E-04
     +,   1.4850461E-04,   8.3162842E-05,   4.5493020E-05
     +,   2.4311541E-05,   1.2695025E-05,   6.4806222E-06
     +,   3.2371067E-06,   1.5850725E-06,   7.6365086E-07
     +,   3.6460023E-07,   1.7486452E-07,   8.6280998E-08
     +,   4.5401467E-08,   2.6506610E-08,   1.7542446E-08
     +,   1.3003345E-08,   1.0434779E-08,   8.7652179E-09
     +,   7.5341893E-09,   6.5444055E-09,   5.7092602E-09
     +,   4.9879403E-09,   4.3585620E-09,   3.8072545E-09
     +,   3.3237719E-09,   2.8997429E-09,   2.5280111E-09
     +,   2.2023461E-09,   1.9172510E-09,   1.6678484E-09
     +,   1.4498255E-09,   1.2593908E-09,   1.0931741E-09
     +,   9.4819730E-10,   8.2184970E-10,   7.1182171E-10
     +,   6.1607563E-10,   5.3281601E-10,   4.6047377E-10
     +,   3.9766521E-10,   3.4317346E-10,   2.9593181E-10
     +,   2.5500849E-10,   2.1958331E-10,   1.8894226E-10
     +,   1.6245769E-10,   1.3958465E-10,   1.1984379E-10
     +,   1.0282040E-10,   8.8150404E-11,   7.5518591E-11
     +,   6.4649695E-11,   5.5304903E-11,   4.7276329E-11
     +,   4.0383676E-11,   3.4470902E-11,   2.9402255E-11
     +,   2.5060794E-11,   2.1344669E-11,   1.8166456E-11
     +,   1.5450106E-11,   1.3130427E-11,   1.1150838E-11
     +,   9.4628229E-12,   8.0244457E-12,   6.7998046E-12
     +,   5.7578105E-12,   4.8719687E-12
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_haonly_htt105_mass = Yx/1.23140607692308
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_haonly_htt107_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.7161128E-07,   2.1402809E-07
     +,   2.6627902E-07,   3.3047863E-07,   4.0915762E-07
     +,   5.0533419E-07,   6.2259778E-07,   7.6520388E-07
     +,   9.3817999E-07,   1.1474601E-06,   1.4000076E-06
     +,   1.7039805E-06,   2.0689033E-06,   2.5058650E-06
     +,   3.0277276E-06,   3.6493720E-06,   4.3879563E-06
     +,   5.2631926E-06,   6.2976619E-06,   7.5171474E-06
     +,   8.9509886E-06,   1.0632447E-05,   1.2599102E-05
     +,   1.4893415E-05,   1.7562767E-05,   2.0660451E-05
     +,   2.4245697E-05,   2.8384298E-05,   3.3149070E-05
     +,   3.8620281E-05,   4.4886005E-05,   5.2042651E-05
     +,   6.0195205E-05,   6.9457601E-05,   7.9952981E-05
     +,   9.1813767E-05,   1.0518188E-04,   1.2020843E-04
     +,   1.3705486E-04,   1.5588978E-04,   1.7689256E-04
     +,   2.0024956E-04,   2.2615484E-04,   2.5480927E-04
     +,   2.8641929E-04,   3.2119587E-04,   3.5935288E-04
     +,   4.0110620E-04,   4.4667113E-04,   4.9626111E-04
     +,   5.5008574E-04,   6.0834817E-04,   6.7124254E-04
     +,   7.3895568E-04,   8.1165420E-04,   8.8949647E-04
     +,   9.7261858E-04,   1.0611365E-03,   1.1551436E-03
     +,   1.2547070E-03,   1.3598674E-03,   1.4706369E-03
     +,   1.5869886E-03,   1.7088717E-03,   1.8362019E-03
     +,   1.9688464E-03,   2.1066528E-03,   2.2494146E-03
     +,   2.3969063E-03,   2.5488469E-03,   2.7049379E-03
     +,   2.8648267E-03,   3.0281462E-03,   3.1944755E-03
     +,   3.3633797E-03,   3.5343948E-03,   3.7070198E-03
     +,   3.8807313E-03,   4.0549943E-03,   4.2292587E-03
     +,   4.4029420E-03,   4.5754751E-03,   4.7462578E-03
     +,   4.9147112E-03,   5.0802357E-03,   5.2422583E-03
     +,   5.4001939E-03,   5.5534947E-03,   5.7016108E-03
     +,   5.8440324E-03,   5.9802788E-03,   6.1098961E-03
     +,   6.2324712E-03,   6.3476460E-03,   6.4551146E-03
     +,   6.5546175E-03,   6.6459770E-03,   6.7290687E-03
     +,   6.8038590E-03,   6.8703811E-03,   6.9287647E-03
     +,   6.9792201E-03,   7.0220553E-03,   7.0576640E-03
     +,   7.0865368E-03,   7.1092551E-03,   7.1264831E-03
     +,   7.1389680E-03,   7.1475306E-03,   7.1530566E-03
     +,   7.1564806E-03,   7.1587814E-03,   7.1609570E-03
     +,   7.1640220E-03,   7.1689817E-03,   7.1768258E-03
     +,   7.1885106E-03,   7.2049564E-03,   7.2270301E-03
     +,   7.2555598E-03,   7.2913282E-03,   7.3350854E-03
     +,   7.3875729E-03,   7.4495468E-03,   7.5218203E-03
     +,   7.6052835E-03,   7.7009806E-03,   7.8101293E-03
     +,   7.9342015E-03,   8.0749467E-03,   8.2344618E-03
     +,   8.4151952E-03,   8.6200004E-03,   8.8521019E-03
     +,   9.1151046E-03,   9.4129369E-03,   9.7497432E-03
     +,   1.0129797E-02,   1.0557384E-02,   1.1036607E-02
     +,   1.1571169E-02,   1.2164167E-02,   1.2817919E-02
     +,   1.3533697E-02,   1.4311426E-02,   1.5149625E-02
     +,   1.6045161E-02,   1.6993066E-02,   1.7986502E-02
     +,   1.9016813E-02,   2.0073511E-02,   2.1144353E-02
     +,   2.2215560E-02,   2.3272194E-02,   2.4298390E-02
     +,   2.5277674E-02,   2.6193457E-02,   2.7029537E-02
     +,   2.7770467E-02,   2.8401958E-02,   2.8911389E-02
     +,   2.9288108E-02,   2.9523715E-02,   2.9612349E-02
     +,   2.9550852E-02,   2.9338796E-02,   2.8978588E-02
     +,   2.8475435E-02,   2.7837252E-02,   2.7074648E-02
     +,   2.6200924E-02,   2.5232054E-02,   2.4186656E-02
     +,   2.3086149E-02,   2.1954989E-02,   2.0820571E-02
     +,   1.9713409E-02,   1.8667074E-02,   1.7717803E-02
     +,   1.6903726E-02,   1.6263917E-02,   1.5836928E-02
     +,   1.5658978E-02,   1.5762087E-02,   1.6172566E-02
     +,   1.6910089E-02,   1.7988088E-02,   1.9416025E-02
     +,   2.1203697E-02,   2.3367554E-02,   2.5939424E-02
     +,   2.8975679E-02,   3.2565787E-02,   3.6838733E-02
     +,   4.1964721E-02,   4.8149299E-02,   5.5617951E-02
     +,   6.4590834E-02,   7.5247601E-02,   8.7682933E-02
     +,   0.1018576    ,   0.1175538    ,   0.1343431    
     +,   0.1515732    ,   0.1683851    ,   0.1837684    
     +,   0.1966475    ,   0.2059936    ,   0.2109509    
     +,   0.2109523    ,   0.2058043    ,   0.1957270    
     +,   0.1813380    ,   0.1635789    ,   0.1436024    
     +,   0.1226372    ,   0.1018515    ,   8.2238257E-02
     +,   6.4540967E-02,   4.9223598E-02,   3.6476489E-02
     +,   2.6259784E-02,   1.8363863E-02,   1.2473811E-02
     +,   8.2292911E-03,   5.2726059E-03,   3.2807898E-03
     +,   1.9825299E-03,   1.1634261E-03,   6.6302193E-04
     +,   3.6694319E-04,   1.9722799E-04,   1.0295304E-04
     +,   5.2193162E-05,   2.5699554E-05,   1.2290817E-05
     +,   5.7093180E-06,   2.5760976E-06,   1.1291252E-06
     +,   4.8075896E-07,   1.9884699E-07,   7.9898847E-08
     +,   3.1190044E-08,   1.1828807E-08,   4.3582209E-09
     +,   1.5600696E-09,   5.4259425E-10,   1.8336729E-10
     +,   6.0220447E-11,   1.9228806E-11,   5.9753903E-12
     +,   1.8114090E-12,   5.3884718E-13,   1.5952806E-13
     +,   4.8521205E-14,   1.6119723E-14,   6.3415832E-15
     +,   3.0750178E-15,   1.7611591E-15,   1.1055938E-15
     +,   7.2182231E-16,   4.7780975E-16,   3.1736620E-16
     +,   2.1069554E-16,   1.3961795E-16,   9.2299585E-17
     +,   6.0862275E-17,   4.0027664E-17,   2.6255839E-17
     +,   1.7176419E-17,   1.1206497E-17,   7.2918279E-18
     +,   4.7319103E-18,   3.0623769E-18,   1.9764906E-18
     +,   1.2721958E-18,   8.1662481E-19,   5.2277168E-19
     +,   3.3373698E-19,   2.1247901E-19,   1.3490553E-19
     +,   8.5419943E-20,   5.3937233E-20,   3.3965060E-20
     +,   2.1329212E-20,   1.3357657E-20,   8.3423806E-21
     +,   5.1957731E-21,   3.2271492E-21,   1.9988836E-21
     +,   1.2347118E-21,   7.6057091E-22,   4.6722320E-22
     +,   2.8622315E-22,   1.7486263E-22,   1.0653267E-22
     +,   6.4725955E-23,   3.9216674E-23,   2.3695865E-23
     +,   1.4278001E-23,   8.5797238E-24
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_haonly_htt107_mass = Yx/1.208172
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_haonly_htt110_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.6146556E-04,   4.7983401E-04
     +,   4.9851113E-04,   5.1747664E-04,   5.3670898E-04
     +,   5.5618474E-04,   5.7587930E-04,   5.9576659E-04
     +,   6.1581854E-04,   6.3600723E-04,   6.5630191E-04
     +,   6.7667133E-04,   6.9708319E-04,   7.1750360E-04
     +,   7.3789811E-04,   7.5823144E-04,   7.7846739E-04
     +,   7.9856935E-04,   8.1849977E-04,   8.3822123E-04
     +,   8.5769594E-04,   8.7688601E-04,   8.9575315E-04
     +,   9.1426115E-04,   9.3237165E-04,   9.5004903E-04
     +,   9.6725783E-04,   9.8396337E-04,   1.0001328E-03
     +,   1.0157344E-03,   1.0307383E-03,   1.0451170E-03
     +,   1.0588450E-03,   1.0718991E-03,   1.0842594E-03
     +,   1.0959093E-03,   1.1068345E-03,   1.1170256E-03
     +,   1.1264775E-03,   1.1351880E-03,   1.1431611E-03
     +,   1.1504049E-03,   1.1569337E-03,   1.1627672E-03
     +,   1.1679308E-03,   1.1724570E-03,   1.1763854E-03
     +,   1.1797623E-03,   1.1826416E-03,   1.1850855E-03
     +,   1.1871641E-03,   1.1889567E-03,   1.1905512E-03
     +,   1.1920448E-03,   1.1935444E-03,   1.1951668E-03
     +,   1.1970387E-03,   1.1992975E-03,   1.2020909E-03
     +,   1.2055774E-03,   1.2099263E-03,   1.2153183E-03
     +,   1.2219447E-03,   1.2300075E-03,   1.2397212E-03
     +,   1.2513098E-03,   1.2650093E-03,   1.2810652E-03
     +,   1.2997350E-03,   1.3212847E-03,   1.3459922E-03
     +,   1.3741422E-03,   1.4060312E-03,   1.4419599E-03
     +,   1.4822391E-03,   1.5271868E-03,   1.5771227E-03
     +,   1.6323697E-03,   1.6932563E-03,   1.7601113E-03
     +,   1.8332553E-03,   1.9130132E-03,   1.9996930E-03
     +,   2.0936024E-03,   2.1950242E-03,   2.3042352E-03
     +,   2.4214764E-03,   2.5469775E-03,   2.6809198E-03
     +,   2.8234606E-03,   2.9747146E-03,   3.1347396E-03
     +,   3.3035378E-03,   3.4810614E-03,   3.6671995E-03
     +,   3.8617505E-03,   4.0644612E-03,   4.2749727E-03
     +,   4.4928677E-03,   4.7176117E-03,   4.9486095E-03
     +,   5.1851477E-03,   5.4264483E-03,   5.6716176E-03
     +,   5.9196968E-03,   6.1696498E-03,   6.4203460E-03
     +,   6.6705928E-03,   6.9191568E-03,   7.1647605E-03
     +,   7.4060704E-03,   7.6417695E-03,   7.8705102E-03
     +,   8.0909897E-03,   8.3019175E-03,   8.5020782E-03
     +,   8.6903134E-03,   8.8655846E-03,   9.0269465E-03
     +,   9.1736168E-03,   9.3049761E-03,   9.4205756E-03
     +,   9.5201889E-03,   9.6038245E-03,   9.6717486E-03
     +,   9.7244922E-03,   9.7629009E-03,   9.7881285E-03
     +,   9.8016653E-03,   9.8053571E-03,   9.8014111E-03
     +,   9.7924070E-03,   9.7813066E-03,   9.7714476E-03
     +,   9.7665424E-03,   9.7706756E-03,   9.7882720E-03
     +,   9.8240832E-03,   9.8831495E-03,   9.9707656E-03
     +,   1.0092407E-02,   1.0253673E-02,   1.0460203E-02
     +,   1.0717577E-02,   1.1031156E-02,   1.1405990E-02
     +,   1.1846626E-02,   1.2356879E-02,   1.2939644E-02
     +,   1.3596693E-02,   1.4328416E-02,   1.5133510E-02
     +,   1.6008789E-02,   1.6949022E-02,   1.7946742E-02
     +,   1.8992051E-02,   2.0072669E-02,   2.1174083E-02
     +,   2.2279682E-02,   2.3370944E-02,   2.4428101E-02
     +,   2.5430547E-02,   2.6357487E-02,   2.7188653E-02
     +,   2.7905174E-02,   2.8490230E-02,   2.8929763E-02
     +,   2.9213192E-02,   2.9333949E-02,   2.9289873E-02
     +,   2.9083487E-02,   2.8722193E-02,   2.8218212E-02
     +,   2.7588438E-02,   2.6854286E-02,   2.6041219E-02
     +,   2.5178229E-02,   2.4297338E-02,   2.3432747E-02
     +,   2.2619830E-02,   2.1894274E-02,   2.1291053E-02
     +,   2.0843517E-02,   2.0582823E-02,   2.0537980E-02
     +,   2.0736724E-02,   2.1207299E-02,   2.1981524E-02
     +,   2.3098864E-02,   2.4610957E-02,   2.6586605E-02
     +,   2.9115511E-02,   3.2309618E-02,   3.6301136E-02
     +,   4.1236009E-02,   4.7261100E-02,   5.4505069E-02
     +,   6.3054740E-02,   7.2928727E-02,   8.4050089E-02
     +,   9.6222684E-02,   0.1091181    ,   0.1222761    
     +,   0.1351203    ,   0.1469910    ,   0.1571974    
     +,   0.1650782    ,   0.1700672    ,   0.1717549    
     +,   0.1699368    ,   0.1646396    ,   0.1561224    
     +,   0.1448532    ,   0.1314593    ,   0.1166652    
     +,   0.1012237    ,   8.5848384E-02,   7.1156435E-02
     +,   5.7631306E-02,   4.5604821E-02,   3.5254408E-02
     +,   2.6620284E-02,   1.9632081E-02,   1.4139588E-02
     +,   9.9444538E-03,   6.8289940E-03,   4.5786272E-03
     +,   2.9970307E-03,   1.9150919E-03,   1.1945270E-03
     +,   7.2726165E-04,   4.3217276E-04,   2.5064941E-04
     +,   1.4186962E-04,   7.8365047E-05,   4.2241536E-05
     +,   2.2218517E-05,   1.1403617E-05,   5.7110815E-06
     +,   2.7907572E-06,   1.3305614E-06,   6.1896299E-07
     +,   2.8095070E-07,   1.2443672E-07,   5.3787087E-08
     +,   2.2698215E-08,   9.3597547E-09,   3.7783092E-09
     +,   1.4993637E-09,   5.9048283E-10,   2.3550500E-10
     +,   9.8955108E-11,   4.6545524E-11,   2.5900875E-11
     +,   1.7104122E-11,   1.2755803E-11,   1.0156946E-11
     +,   8.3294387E-12,   6.9113517E-12,   5.7581700E-12
     +,   4.8023183E-12,   4.0045319E-12,   3.3372766E-12
     +,   2.7790860E-12,   2.3123816E-12,   1.9224448E-12
     +,   1.5969124E-12,   1.3253815E-12,   1.0990975E-12
     +,   9.1067692E-13,   7.5391391E-13,   6.2360815E-13
     +,   5.1539182E-13,   4.2559264E-13,   3.5114091E-13
     +,   2.8946946E-13,   2.3842622E-13,   1.9621856E-13
     +,   1.6134481E-13,   1.3255762E-13,   1.0881388E-13
     +,   8.9248020E-14,   7.3137920E-14,   5.9885345E-14
     +,   4.8992345E-14,   4.0047060E-14,   3.2707283E-14
     +,   2.6689964E-14,   2.1761413E-14,   1.7727773E-14
     +,   1.4429687E-14,   1.1735146E-14,   9.5357487E-15
     +,   7.7419430E-15,   6.2803160E-15,   5.0902640E-15
     +,   4.1222523E-15,   3.3354821E-15,   2.6966054E-15
     +,   2.1782323E-15,   1.7580377E-15
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_haonly_htt110_mass = Yx/1.09200161538462
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_haonly_htt115_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.3297411E-03,   1.3509288E-03
     +,   1.3722181E-03,   1.3936104E-03,   1.4151061E-03
     +,   1.4367070E-03,   1.4584142E-03,   1.4802294E-03
     +,   1.5021547E-03,   1.5241933E-03,   1.5463475E-03
     +,   1.5686215E-03,   1.5910193E-03,   1.6135465E-03
     +,   1.6362091E-03,   1.6590140E-03,   1.6819702E-03
     +,   1.7050873E-03,   1.7283765E-03,   1.7518512E-03
     +,   1.7755259E-03,   1.7994173E-03,   1.8235443E-03
     +,   1.8479287E-03,   1.8725933E-03,   1.8975643E-03
     +,   1.9228715E-03,   1.9485463E-03,   1.9746237E-03
     +,   2.0011417E-03,   2.0281414E-03,   2.0556680E-03
     +,   2.0837693E-03,   2.1124980E-03,   2.1419099E-03
     +,   2.1720636E-03,   2.2030240E-03,   2.2348580E-03
     +,   2.2676382E-03,   2.3014389E-03,   2.3363428E-03
     +,   2.3724334E-03,   2.4098000E-03,   2.4485365E-03
     +,   2.4887412E-03,   2.5305168E-03,   2.5739707E-03
     +,   2.6192148E-03,   2.6663670E-03,   2.7155464E-03
     +,   2.7668793E-03,   2.8204955E-03,   2.8765274E-03
     +,   2.9351143E-03,   2.9963930E-03,   3.0605099E-03
     +,   3.1276077E-03,   3.1978339E-03,   3.2713346E-03
     +,   3.3482558E-03,   3.4287418E-03,   3.5129352E-03
     +,   3.6009687E-03,   3.6929750E-03,   3.7890794E-03
     +,   3.8893868E-03,   3.9940034E-03,   4.1030082E-03
     +,   4.2164763E-03,   4.3344488E-03,   4.4569601E-03
     +,   4.5840056E-03,   4.7155698E-03,   4.8515913E-03
     +,   4.9919919E-03,   5.1366589E-03,   5.2854405E-03
     +,   5.4381471E-03,   5.5945627E-03,   5.7544378E-03
     +,   5.9174746E-03,   6.0833599E-03,   6.2517305E-03
     +,   6.4222179E-03,   6.5944046E-03,   6.7678806E-03
     +,   6.9421949E-03,   7.1169129E-03,   7.2915773E-03
     +,   7.4657528E-03,   7.6390202E-03,   7.8109698E-03
     +,   7.9812203E-03,   8.1494451E-03,   8.3153592E-03
     +,   8.4787197E-03,   8.6393673E-03,   8.7971846E-03
     +,   8.9521557E-03,   9.1043161E-03,   9.2538102E-03
     +,   9.4008390E-03,   9.5457137E-03,   9.6888114E-03
     +,   9.8306024E-03,   9.9716447E-03,   1.0112557E-02
     +,   1.0254038E-02,   1.0396860E-02,   1.0541858E-02
     +,   1.0689899E-02,   1.0841920E-02,   1.0998870E-02
     +,   1.1161744E-02,   1.1331529E-02,   1.1509228E-02
     +,   1.1695809E-02,   1.1892233E-02,   1.2099388E-02
     +,   1.2318107E-02,   1.2549152E-02,   1.2793151E-02
     +,   1.3050620E-02,   1.3321933E-02,   1.3607323E-02
     +,   1.3906810E-02,   1.4220290E-02,   1.4547422E-02
     +,   1.4887756E-02,   1.5240621E-02,   1.5605271E-02
     +,   1.5980819E-02,   1.6366372E-02,   1.6761003E-02
     +,   1.7163888E-02,   1.7574349E-02,   1.7991912E-02
     +,   1.8416367E-02,   1.8847916E-02,   1.9287158E-02
     +,   1.9735105E-02,   2.0193247E-02,   2.0663528E-02
     +,   2.1148296E-02,   2.1650143E-02,   2.2171896E-02
     +,   2.2716355E-02,   2.3286125E-02,   2.3883324E-02
     +,   2.4509421E-02,   2.5164934E-02,   2.5849078E-02
     +,   2.6559604E-02,   2.7292611E-02,   2.8042369E-02
     +,   2.8801220E-02,   2.9559599E-02,   3.0306235E-02
     +,   3.1028355E-02,   3.1711921E-02,   3.2342255E-02
     +,   3.2904506E-02,   3.3384237E-02,   3.3768203E-02
     +,   3.4044970E-02,   3.4205686E-02,   3.4244601E-02
     +,   3.4159720E-02,   3.3953141E-02,   3.3631340E-02
     +,   3.3205293E-02,   3.2690313E-02,   3.2105722E-02
     +,   3.1474397E-02,   3.0822080E-02,   3.0176505E-02
     +,   2.9566456E-02,   2.9020786E-02,   2.8567329E-02
     +,   2.8231842E-02,   2.8037032E-02,   2.8001746E-02
     +,   2.8140180E-02,   2.8461326E-02,   2.8968690E-02
     +,   2.9660016E-02,   3.0527385E-02,   3.1557482E-02
     +,   3.2732032E-02,   3.4028210E-02,   3.5419546E-02
     +,   3.6876664E-02,   3.8367972E-02,   3.9860670E-02
     +,   4.1321676E-02,   4.2718414E-02,   4.4019450E-02
     +,   4.5195308E-02,   4.6219196E-02,   4.7067344E-02
     +,   4.7719426E-02,   4.8158962E-02,   4.8373505E-02
     +,   4.8354719E-02,   4.8098464E-02,   4.7604725E-02
     +,   4.6877462E-02,   4.5924507E-02,   4.4757288E-02
     +,   4.3390438E-02,   4.1841473E-02,   4.0130492E-02
     +,   3.8279686E-02,   3.6312666E-02,   3.4254093E-02
     +,   3.2129291E-02,   2.9963577E-02,   2.7781634E-02
     +,   2.5607137E-02,   2.3462506E-02,   2.1368122E-02
     +,   1.9342180E-02,   1.7400587E-02,   1.5556625E-02
     +,   1.3820743E-02,   1.2200691E-02,   1.0701668E-02
     +,   9.3263453E-03,   8.0749663E-03,   6.9457078E-03
     +,   5.9350096E-03,   5.0377878E-03,   4.2476915E-03
     +,   3.5574804E-03,   2.9593685E-03,   2.4451579E-03
     +,   2.0065538E-03,   1.6353920E-03,   1.3237703E-03
     +,   1.0641695E-03,   8.4957934E-04,   6.7357661E-04
     +,   5.3034199E-04,   4.1466803E-04,   3.2196657E-04
     +,   2.4824715E-04,   1.9007258E-04,   1.4451331E-04
     +,   1.0910406E-04,   8.1794176E-05,   6.0889815E-05
     +,   4.5009045E-05,   3.3036111E-05,   2.4077633E-05
     +,   1.7424782E-05,   1.2521100E-05,   8.9339110E-06
     +,   6.3294788E-06,   4.4526132E-06,   3.1101126E-06
     +,   2.1570236E-06,   1.4854418E-06,   1.0157162E-06
     +,   6.8960242E-07,   4.6488461E-07,   3.1117600E-07
     +,   2.0681155E-07,   1.3647640E-07,   8.9425292E-08
     +,   5.8180557E-08,   3.7584140E-08,   2.4107234E-08
     +,   1.5353768E-08,   9.7096251E-09,   6.0968715E-09
     +,   3.8014245E-09,   2.3534925E-09,   1.4468698E-09
     +,   8.8327318E-10,   5.3547988E-10,   3.2239383E-10
     +,   1.9278869E-10,   1.1451791E-10,   6.7587977E-11
     +,   3.9645384E-11,   2.3124147E-11,   1.3421381E-11
     +,   7.7598952E-12,   4.4768811E-12,   2.5834979E-12
     +,   1.4966903E-12,   8.7486631E-13,   5.1954686E-13
     +,   3.1612207E-13,   1.9892528E-13,   1.3054451E-13
     +,   8.9809135E-14,   6.4787538E-14,   4.8786977E-14
     +,   3.8054619E-14,   3.0484241E-14
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_haonly_htt115_mass = Yx/0.88095875
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_haonly_htt120_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.1279146E-03,   1.1831491E-03
     +,   1.2399140E-03,   1.2981814E-03,   1.3579184E-03
     +,   1.4190867E-03,   1.4816433E-03,   1.5455384E-03
     +,   1.6107161E-03,   1.6771177E-03,   1.7446746E-03
     +,   1.8133135E-03,   1.8829533E-03,   1.9535075E-03
     +,   2.0248813E-03,   2.0969743E-03,   2.1696771E-03
     +,   2.2428748E-03,   2.3164439E-03,   2.3902543E-03
     +,   2.4641692E-03,   2.5380428E-03,   2.6117244E-03
     +,   2.6850596E-03,   2.7578799E-03,   2.8300199E-03
     +,   2.9013045E-03,   2.9715565E-03,   3.0405938E-03
     +,   3.1082346E-03,   3.1742926E-03,   3.2385853E-03
     +,   3.3009290E-03,   3.3611462E-03,   3.4190605E-03
     +,   3.4745063E-03,   3.5273237E-03,   3.5773653E-03
     +,   3.6244979E-03,   3.6685988E-03,   3.7095689E-03
     +,   3.7473259E-03,   3.7818111E-03,   3.8129908E-03
     +,   3.8408574E-03,   3.8654367E-03,   3.8867828E-03
     +,   3.9049874E-03,   3.9201756E-03,   3.9325156E-03
     +,   3.9422107E-03,   3.9495104E-03,   3.9547049E-03
     +,   3.9581289E-03,   3.9601610E-03,   3.9612264E-03
     +,   3.9617964E-03,   3.9623850E-03,   3.9635519E-03
     +,   3.9659003E-03,   3.9700759E-03,   3.9767656E-03
     +,   3.9866930E-03,   4.0006177E-03,   4.0193349E-03
     +,   4.0436662E-03,   4.0744622E-03,   4.1125901E-03
     +,   4.1589374E-03,   4.2143962E-03,   4.2798668E-03
     +,   4.3562367E-03,   4.4443915E-03,   4.5451773E-03
     +,   4.6594185E-03,   4.7878916E-03,   4.9313079E-03
     +,   5.0902981E-03,   5.2654170E-03,   5.4571116E-03
     +,   5.6656888E-03,   5.8913385E-03,   6.1340672E-03
     +,   6.3937348E-03,   6.6699758E-03,   6.9622574E-03
     +,   7.2697885E-03,   7.5915898E-03,   7.9264091E-03
     +,   8.2727857E-03,   8.6290324E-03,   8.9932121E-03
     +,   9.3631735E-03,   9.7366031E-03,   1.0111023E-02
     +,   1.0483782E-02,   1.0852192E-02,   1.1213466E-02
     +,   1.1564864E-02,   1.1903654E-02,   1.2227255E-02
     +,   1.2533215E-02,   1.2819342E-02,   1.3083680E-02
     +,   1.3324632E-02,   1.3540974E-02,   1.3731874E-02
     +,   1.3896951E-02,   1.4036291E-02,   1.4150453E-02
     +,   1.4240449E-02,   1.4307754E-02,   1.4354259E-02
     +,   1.4382237E-02,   1.4394297E-02,   1.4393310E-02
     +,   1.4382335E-02,   1.4364567E-02,   1.4343217E-02
     +,   1.4321456E-02,   1.4302315E-02,   1.4288614E-02
     +,   1.4282870E-02,   1.4287240E-02,   1.4303454E-02
     +,   1.4332784E-02,   1.4375979E-02,   1.4433273E-02
     +,   1.4504367E-02,   1.4588440E-02,   1.4684171E-02
     +,   1.4789782E-02,   1.4903098E-02,   1.5021579E-02
     +,   1.5142431E-02,   1.5262661E-02,   1.5379160E-02
     +,   1.5488797E-02,   1.5588509E-02,   1.5675377E-02
     +,   1.5746696E-02,   1.5800064E-02,   1.5833445E-02
     +,   1.5845206E-02,   1.5834156E-02,   1.5799616E-02
     +,   1.5741365E-02,   1.5659712E-02,   1.5555449E-02
     +,   1.5429839E-02,   1.5284570E-02,   1.5121742E-02
     +,   1.4943799E-02,   1.4753462E-02,   1.4553668E-02
     +,   1.4347530E-02,   1.4138249E-02,   1.3929031E-02
     +,   1.3723030E-02,   1.3523315E-02,   1.3332759E-02
     +,   1.3154015E-02,   1.2989464E-02,   1.2841178E-02
     +,   1.2710867E-02,   1.2599868E-02,   1.2509136E-02
     +,   1.2439216E-02,   1.2390250E-02,   1.2361978E-02
     +,   1.2353760E-02,   1.2364583E-02,   1.2393088E-02
     +,   1.2437602E-02,   1.2496168E-02,   1.2566579E-02
     +,   1.2646426E-02,   1.2733132E-02,   1.2823987E-02
     +,   1.2916209E-02,   1.3006987E-02,   1.3093499E-02
     +,   1.3172978E-02,   1.3242746E-02,   1.3300257E-02
     +,   1.3343113E-02,   1.3369118E-02,   1.3376297E-02
     +,   1.3362920E-02,   1.3327525E-02,   1.3268923E-02
     +,   1.3186226E-02,   1.3078840E-02,   1.2946469E-02
     +,   1.2789113E-02,   1.2607050E-02,   1.2400845E-02
     +,   1.2171321E-02,   1.1919524E-02,   1.1646715E-02
     +,   1.1354361E-02,   1.1044091E-02,   1.0717656E-02
     +,   1.0376905E-02,   1.0023803E-02,   9.6603334E-03
     +,   9.2884926E-03,   8.9103086E-03,   8.5277800E-03
     +,   8.1428289E-03,   7.7573182E-03,   7.3730447E-03
     +,   6.9917105E-03,   6.6148802E-03,   6.2439982E-03
     +,   5.8804112E-03,   5.5253292E-03,   5.1798057E-03
     +,   4.8447629E-03,   4.5210193E-03,   4.2092325E-03
     +,   3.9099338E-03,   3.6235522E-03,   3.3503992E-03
     +,   3.0906601E-03,   2.8444179E-03,   2.6116814E-03
     +,   2.3923679E-03,   2.1863044E-03,   1.9932478E-03
     +,   1.8129067E-03,   1.6449338E-03,   1.4889246E-03
     +,   1.3444364E-03,   1.2110090E-03,   1.0881425E-03
     +,   9.7532012E-04,   8.7201945E-04,   7.7770959E-04
     +,   6.9185102E-04,   6.1390753E-04,   5.4335489E-04
     +,   4.7967784E-04,   4.2236966E-04,   3.7094086E-04
     +,   3.2492328E-04,   2.8386843E-04,   2.4734644E-04
     +,   2.1495056E-04,   1.8630071E-04,   1.6103701E-04
     +,   1.3882408E-04,   1.1935175E-04,   1.0233282E-04
     +,   8.7501641E-05,   7.4614945E-05,   6.3451407E-05
     +,   5.3809763E-05,   4.5506993E-05,   3.8378359E-05
     +,   3.2276330E-05,   2.7068876E-05,   2.2638023E-05
     +,   1.8879155E-05,   1.5700178E-05,   1.3019618E-05
     +,   1.0766082E-05,   8.8773368E-06,   7.2991561E-06
     +,   5.9844201E-06,   4.8924344E-06,   3.9882420E-06
     +,   3.2418443E-06,   2.6275509E-06,   2.1235007E-06
     +,   1.7111984E-06,   1.3749467E-06,   1.1015721E-06
     +,   8.7997927E-07,   7.0092142E-07,   5.5666516E-07
     +,   4.4081077E-07,   3.4804373E-07,   2.7399588E-07
     +,   2.1506719E-07,   1.6831756E-07,   1.3134215E-07
     +,   1.0218641E-07,   7.9268716E-08,   6.1308477E-08
     +,   4.7277656E-08,   3.6349547E-08,   2.7864708E-08
     +,   2.1296827E-08,   1.6228768E-08,   1.2329830E-08
     +,   9.3397867E-09,   7.0536696E-09,   5.3112674E-09
     +,   3.9872865E-09,   2.9844185E-09
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_haonly_htt120_mass = Yx/0.47691
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_haonly_htt60_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  8.7473961E-03,   9.0514403E-03
     +,   9.3642548E-03,   9.6854661E-03,   1.0014676E-02
     +,   1.0351459E-02,   1.0695417E-02,   1.1046192E-02
     +,   1.1403499E-02,   1.1767208E-02,   1.2137333E-02
     +,   1.2514140E-02,   1.2898170E-02,   1.3290309E-02
     +,   1.3691869E-02,   1.4104608E-02,   1.4530816E-02
     +,   1.4973361E-02,   1.5435724E-02,   1.5922016E-02
     +,   1.6437000E-02,   1.6986053E-02,   1.7575141E-02
     +,   1.8210765E-02,   1.8899750E-02,   1.9649237E-02
     +,   2.0466372E-02,   2.1358151E-02,   2.2331083E-02
     +,   2.3390945E-02,   2.4542432E-02,   2.5788801E-02
     +,   2.7131522E-02,   2.8569952E-02,   3.0101029E-02
     +,   3.1719007E-02,   3.3415303E-02,   3.5178382E-02
     +,   3.6993917E-02,   3.8844682E-02,   4.0711224E-02
     +,   4.2572014E-02,   4.4404197E-02,   4.6184320E-02
     +,   4.7889020E-02,   4.9496114E-02,   5.0985295E-02
     +,   5.2339219E-02,   5.3544089E-02,   5.4590553E-02
     +,   5.5473942E-02,   5.6194797E-02,   5.6758590E-02
     +,   5.7175737E-02,   5.7460889E-02,   5.7632327E-02
     +,   5.7710968E-02,   5.7719339E-02,   5.7680465E-02
     +,   5.7616789E-02,   5.7549130E-02,   5.7495885E-02
     +,   5.7472382E-02,   5.7490438E-02,   5.7558283E-02
     +,   5.7680719E-02,   5.7859413E-02,   5.8093511E-02
     +,   5.8380291E-02,   5.8715969E-02,   5.9096441E-02
     +,   5.9518028E-02,   5.9978079E-02,   6.0475312E-02
     +,   6.1010290E-02,   6.1585326E-02,   6.2204383E-02
     +,   6.2872753E-02,   6.3596658E-02,   6.4382665E-02
     +,   6.5236986E-02,   6.6164933E-02,   6.7170337E-02
     +,   6.8255022E-02,   6.9418497E-02,   7.0657879E-02
     +,   7.1967669E-02,   7.3340222E-02,   7.4765772E-02
     +,   7.6233044E-02,   7.7729531E-02,   7.9241857E-02
     +,   8.0755971E-02,   8.2257234E-02,   8.3730347E-02
     +,   8.5158855E-02,   8.6525097E-02,   8.7809458E-02
     +,   8.8990465E-02,   9.0044491E-02,   9.0946257E-02
     +,   9.1669515E-02,   9.2188209E-02,   9.2477962E-02
     +,   9.2517801E-02,   9.2292055E-02,   9.1792047E-02
     +,   9.1017395E-02,   8.9976922E-02,   8.8688806E-02
     +,   8.7180294E-02,   8.5486174E-02,   8.3647504E-02
     +,   8.1708916E-02,   7.9716697E-02,   7.7715717E-02
     +,   7.5747766E-02,   7.3848829E-02,   7.2048105E-02
     +,   7.0366465E-02,   6.8816081E-02,   6.7400441E-02
     +,   6.6114731E-02,   6.4946547E-02,   6.3877091E-02
     +,   6.2882654E-02,   6.1935969E-02,   6.1007950E-02
     +,   6.0069114E-02,   5.9091352E-02,   5.8049023E-02
     +,   5.6920383E-02,   5.5688344E-02,   5.4341339E-02
     +,   5.2873407E-02,   5.1284418E-02,   4.9579803E-02
     +,   4.7769979E-02,   4.5869488E-02,   4.3896139E-02
     +,   4.1870147E-02,   3.9813012E-02,   3.7746303E-02
     +,   3.5690960E-02,   3.3666711E-02,   3.1691041E-02
     +,   2.9779030E-02,   2.7943179E-02,   2.6193233E-02
     +,   2.4536109E-02,   2.2976203E-02,   2.1515770E-02
     +,   2.0155054E-02,   1.8892637E-02,   1.7725790E-02
     +,   1.6650915E-02,   1.5663728E-02,   1.4759454E-02
     +,   1.3933118E-02,   1.3179767E-02,   1.2494438E-02
     +,   1.1872321E-02,   1.1308860E-02,   1.0799722E-02
     +,   1.0340777E-02,   9.9281380E-03,   9.5581692E-03
     +,   9.2274221E-03,   8.9326231E-03,   8.6706597E-03
     +,   8.4385807E-03,   8.2335789E-03,   8.0529405E-03
     +,   7.8940839E-03,   7.7545606E-03,   7.6320157E-03
     +,   7.5242124E-03,   7.4290368E-03,   7.3445020E-03
     +,   7.2687329E-03,   7.1999845E-03,   7.1366383E-03
     +,   7.0772171E-03,   7.0203585E-03,   6.9648344E-03
     +,   6.9095488E-03,   6.8535260E-03,   6.7959162E-03
     +,   6.7359810E-03,   6.6731046E-03,   6.6067707E-03
     +,   6.5365657E-03,   6.4621787E-03,   6.3833841E-03
     +,   6.3000396E-03,   6.2120766E-03,   6.1194994E-03
     +,   6.0223793E-03,   5.9208358E-03,   5.8150399E-03
     +,   5.7052067E-03,   5.5915951E-03,   5.4744827E-03
     +,   5.3541735E-03,   5.2310023E-03,   5.1053059E-03
     +,   4.9774321E-03,   4.8477394E-03,   4.7165886E-03
     +,   4.5843292E-03,   4.4513056E-03,   4.3178583E-03
     +,   4.1843224E-03,   4.0510055E-03,   3.9182035E-03
     +,   3.7862030E-03,   3.6552739E-03,   3.5256585E-03
     +,   3.3975814E-03,   3.2712598E-03,   3.1468808E-03
     +,   3.0246114E-03,   2.9046102E-03,   2.7870163E-03
     +,   2.6719447E-03,   2.5594938E-03,   2.4497546E-03
     +,   2.3428029E-03,   2.2386929E-03,   2.1374673E-03
     +,   2.0391622E-03,   1.9438039E-03,   1.8514008E-03
     +,   1.7619540E-03,   1.6754635E-03,   1.5919131E-03
     +,   1.5112807E-03,   1.4335428E-03,   1.3586704E-03
     +,   1.2866241E-03,   1.2173608E-03,   1.1508381E-03
     +,   1.0870100E-03,   1.0258228E-03,   9.6722087E-04
     +,   9.1114995E-04,   8.5755414E-04,   8.0637133E-04
     +,   7.5753895E-04,   7.1099791E-04,   6.6668319E-04
     +,   6.2452920E-04,   5.8447279E-04,   5.4644985E-04
     +,   5.1039358E-04,   4.7623730E-04,   4.4391651E-04
     +,   4.1336656E-04,   3.8452123E-04,   3.5731474E-04
     +,   3.3168361E-04,   3.0756477E-04,   2.8489428E-04
     +,   2.6360934E-04,   2.4364985E-04,   2.2495480E-04
     +,   2.0746446E-04,   1.9112143E-04,   1.7586953E-04
     +,   1.6165274E-04,   1.4841676E-04,   1.3610962E-04
     +,   1.2468078E-04,   1.1408050E-04,   1.0426077E-04
     +,   9.5176285E-05,   8.6782100E-05,   7.9036196E-05
     +,   7.1897215E-05,   6.5326480E-05,   5.9286176E-05
     +,   5.3741031E-05,   4.8656711E-05,   4.4001299E-05
     +,   3.9743893E-05,   3.5855770E-05,   3.2309414E-05
     +,   2.9078934E-05,   2.6140220E-05,   2.3470246E-05
     +,   2.1047777E-05,   1.8852599E-05,   1.6866121E-05
     +,   1.5070750E-05,   1.3450323E-05,   1.1989615E-05
     +,   1.0674695E-05,   9.4924835E-06,   8.4310441E-06
     +,   7.4792270E-06,   6.6268794E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_haonly_htt60_mass = Yx/2.01362
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_haonly_htt65_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  7.1611414E-03,   7.7142762E-03
     +,   8.3012730E-03,   8.9225899E-03,   9.5785027E-03
     +,   1.0269105E-02,   1.0994302E-02,   1.1753804E-02
     +,   1.2547125E-02,   1.3373625E-02,   1.4232441E-02
     +,   1.5122553E-02,   1.6042748E-02,   1.6991640E-02
     +,   1.7967649E-02,   1.8968981E-02,   1.9993622E-02
     +,   2.1039290E-02,   2.2103388E-02,   2.3182973E-02
     +,   2.4274716E-02,   2.5374781E-02,   2.6478844E-02
     +,   2.7582102E-02,   2.8679026E-02,   2.9763645E-02
     +,   3.0829366E-02,   3.1869102E-02,   3.2875370E-02
     +,   3.3840425E-02,   3.4756426E-02,   3.5615660E-02
     +,   3.6410823E-02,   3.7135217E-02,   3.7783153E-02
     +,   3.8350157E-02,   3.8833257E-02,   3.9231226E-02
     +,   3.9544817E-02,   3.9776806E-02,   3.9932054E-02
     +,   4.0017504E-02,   4.0041976E-02,   4.0015940E-02
     +,   3.9951202E-02,   3.9860491E-02,   3.9756913E-02
     +,   3.9653618E-02,   3.9563093E-02,   3.9496776E-02
     +,   3.9464571E-02,   3.9474487E-02,   3.9532267E-02
     +,   3.9641347E-02,   3.9802678E-02,   4.0014822E-02
     +,   4.0274147E-02,   4.0575072E-02,   4.0910471E-02
     +,   4.1272070E-02,   4.1650839E-02,   4.2037576E-02
     +,   4.2423144E-02,   4.2798989E-02,   4.3157332E-02
     +,   4.3491341E-02,   4.3795355E-02,   4.4064745E-02
     +,   4.4295955E-02,   4.4486292E-02,   4.4633821E-02
     +,   4.4737119E-02,   4.4795170E-02,   4.4807140E-02
     +,   4.4772461E-02,   4.4690683E-02,   4.4561744E-02
     +,   4.4386029E-02,   4.4164766E-02,   4.3900382E-02
     +,   4.3596882E-02,   4.3260336E-02,   4.2899348E-02
     +,   4.2525314E-02,   4.2152848E-02,   4.1799840E-02
     +,   4.1487474E-02,   4.1239884E-02,   4.1083764E-02
     +,   4.1047599E-02,   4.1160606E-02,   4.1451477E-02
     +,   4.1947037E-02,   4.2670593E-02,   4.3640293E-02
     +,   4.4867553E-02,   4.6355691E-02,   4.8098631E-02
     +,   5.0080501E-02,   5.2274894E-02,   5.4645903E-02
     +,   5.7148386E-02,   5.9730299E-02,   6.2334143E-02
     +,   6.4900227E-02,   6.7369223E-02,   6.9685094E-02
     +,   7.1797989E-02,   7.3666841E-02,   7.5261243E-02
     +,   7.6562263E-02,   7.7563316E-02,   7.8269213E-02
     +,   7.8695208E-02,   7.8864679E-02,   7.8807130E-02
     +,   7.8555077E-02,   7.8141734E-02,   7.7598475E-02
     +,   7.6952800E-02,   7.6227061E-02,   7.5437807E-02
     +,   7.4595511E-02,   7.3705353E-02,   7.2767965E-02
     +,   7.1781091E-02,   7.0740536E-02,   6.9642037E-02
     +,   6.8481974E-02,   6.7258820E-02,   6.5973110E-02
     +,   6.4628184E-02,   6.3229673E-02,   6.1785381E-02
     +,   6.0304623E-02,   5.8797576E-02,   5.7274818E-02
     +,   5.5746596E-02,   5.4222364E-02,   5.2710466E-02
     +,   5.1218040E-02,   4.9750924E-02,   4.8313472E-02
     +,   4.6908878E-02,   4.5539279E-02,   4.4205818E-02
     +,   4.2908795E-02,   4.1647948E-02,   4.0422421E-02
     +,   3.9230879E-02,   3.8071588E-02,   3.6942631E-02
     +,   3.5841838E-02,   3.4766838E-02,   3.3715226E-02
     +,   3.2684676E-02,   3.1672969E-02,   3.0677974E-02
     +,   2.9697848E-02,   2.8731115E-02,   2.7776567E-02
     +,   2.6833322E-02,   2.5900945E-02,   2.4979318E-02
     +,   2.4068566E-02,   2.3169093E-02,   2.2281550E-02
     +,   2.1406751E-02,   2.0545548E-02,   1.9698828E-02
     +,   1.8867550E-02,   1.8052623E-02,   1.7254841E-02
     +,   1.6474921E-02,   1.5713569E-02,   1.4971313E-02
     +,   1.4248609E-02,   1.3545878E-02,   1.2863480E-02
     +,   1.2201667E-02,   1.1560673E-02,   1.0940731E-02
     +,   1.0342060E-02,   9.7648166E-03,   9.2091504E-03
     +,   8.6752279E-03,   8.1631942E-03,   7.6731225E-03
     +,   7.2050570E-03,   6.7590349E-03,   6.3349912E-03
     +,   5.9327967E-03,   5.5522770E-03,   5.1931720E-03
     +,   4.8551187E-03,   4.5376751E-03,   4.2403364E-03
     +,   3.9625205E-03,   3.7035523E-03,   3.4626978E-03
     +,   3.2391846E-03,   3.0321912E-03,   2.8408498E-03
     +,   2.6642678E-03,   2.5015592E-03,   2.3518144E-03
     +,   2.2141326E-03,   2.0876359E-03,   1.9714672E-03
     +,   1.8647888E-03,   1.7667980E-03,   1.6767363E-03
     +,   1.5938849E-03,   1.5175623E-03,   1.4471323E-03
     +,   1.3820089E-03,   1.3216495E-03,   1.2655514E-03
     +,   1.2132569E-03,   1.1643530E-03,   1.1184625E-03
     +,   1.0752456E-03,   1.0344005E-03,   9.9565962E-04
     +,   9.5878146E-04,   9.2355494E-04,   8.8979636E-04
     +,   8.5734692E-04,   8.2606648E-04,   7.9583476E-04
     +,   7.6655170E-04,   7.3813304E-04,   7.1050605E-04
     +,   6.8361120E-04,   6.5740250E-04,   6.3184061E-04
     +,   6.0689484E-04,   5.8254309E-04,   5.5876916E-04
     +,   5.3556036E-04,   5.1290833E-04,   4.9080915E-04
     +,   4.6926178E-04,   4.4826575E-04,   4.2782188E-04
     +,   4.0793337E-04,   3.8860386E-04,   3.6983585E-04
     +,   3.5163172E-04,   3.3399527E-04,   3.1692782E-04
     +,   3.0043008E-04,   2.8450272E-04,   2.6914559E-04
     +,   2.5435616E-04,   2.4013105E-04,   2.2646660E-04
     +,   2.1335803E-04,   2.0079844E-04,   1.8878009E-04
     +,   1.7729483E-04,   1.6633366E-04,   1.5588581E-04
     +,   1.4593986E-04,   1.3648448E-04,   1.2750678E-04
     +,   1.1899334E-04,   1.1093073E-04,   1.0330505E-04
     +,   9.6101619E-05,   8.9305453E-05,   8.2901854E-05
     +,   7.6875906E-05,   7.1212307E-05,   6.5895758E-05
     +,   6.0911523E-05,   5.6244346E-05,   5.1879721E-05
     +,   4.7802852E-05,   4.3999684E-05,   4.0455936E-05
     +,   3.7158188E-05,   3.4092885E-05,   3.1247288E-05
     +,   2.8608696E-05,   2.6165149E-05,   2.3904884E-05
     +,   2.1816595E-05,   1.9889638E-05,   1.8113546E-05
     +,   1.6478578E-05,   1.4975203E-05,   1.3594567E-05
     +,   1.2328059E-05,   1.1167700E-05,   1.0105773E-05
     +,   9.1351303E-06,   8.2489169E-06,   7.4407817E-06
     +,   6.7046658E-06,   6.0349698E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_haonly_htt65_mass = Yx/1.812258
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_haonly_htt70_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.2439949E-03,   1.2982468E-03
     +,   1.3559543E-03,   1.4175556E-03,   1.4835431E-03
     +,   1.5544699E-03,   1.6309544E-03,   1.7136858E-03
     +,   1.8034287E-03,   1.9010328E-03,   2.0074295E-03
     +,   2.1236425E-03,   2.2507883E-03,   2.3900778E-03
     +,   2.5428187E-03,   2.7104109E-03,   2.8943438E-03
     +,   3.0961903E-03,   3.3175950E-03,   3.5602627E-03
     +,   3.8259416E-03,   4.1164006E-03,   4.4334000E-03
     +,   4.7786916E-03,   5.1539247E-03,   5.5606863E-03
     +,   6.0004052E-03,   6.4743282E-03,   6.9834809E-03
     +,   7.5286147E-03,   8.1101684E-03,   8.7282145E-03
     +,   9.3824267E-03,   1.0072032E-02,   1.0795782E-02
     +,   1.1551931E-02,   1.2338200E-02,   1.3151767E-02
     +,   1.3989339E-02,   1.4846993E-02,   1.5720429E-02
     +,   1.6604830E-02,   1.7495012E-02,   1.8385459E-02
     +,   1.9270446E-02,   2.0144124E-02,   2.1000657E-02
     +,   2.1834351E-02,   2.2639817E-02,   2.3412125E-02
     +,   2.4146972E-02,   2.4840882E-02,   2.5491288E-02
     +,   2.6096813E-02,   2.6657235E-02,   2.7173754E-02
     +,   2.7648935E-02,   2.8086795E-02,   2.8492711E-02
     +,   2.8873377E-02,   2.9236598E-02,   2.9591091E-02
     +,   2.9946145E-02,   3.0311337E-02,   3.0696126E-02
     +,   3.1109352E-02,   3.1558935E-02,   3.2051321E-02
     +,   3.2591294E-02,   3.3181470E-02,   3.3822283E-02
     +,   3.4511738E-02,   3.5245597E-02,   3.6017433E-02
     +,   3.6819037E-02,   3.7640851E-02,   3.8472421E-02
     +,   3.9303064E-02,   4.0122509E-02,   4.0921476E-02
     +,   4.1692112E-02,   4.2428587E-02,   4.3127172E-02
     +,   4.3786567E-02,   4.4407643E-02,   4.4993397E-02
     +,   4.5548495E-02,   4.6078958E-02,   4.6591569E-02
     +,   4.7093492E-02,   4.7591846E-02,   4.8093308E-02
     +,   4.8603948E-02,   4.9129132E-02,   4.9673613E-02
     +,   5.0241534E-02,   5.0836757E-02,   5.1462952E-02
     +,   5.2124020E-02,   5.2824106E-02,   5.3567894E-02
     +,   5.4360524E-02,   5.5207741E-02,   5.6115549E-02
     +,   5.7090204E-02,   5.8137793E-02,   5.9263691E-02
     +,   6.0472090E-02,   6.1765317E-02,   6.3143022E-02
     +,   6.4600989E-02,   6.6130534E-02,   6.7717195E-02
     +,   6.9340311E-02,   7.0971966E-02,   7.2577231E-02
     +,   7.4114166E-02,   7.5535141E-02,   7.6788127E-02
     +,   7.7819109E-02,   7.8574993E-02,   7.9006590E-02
     +,   7.9072118E-02,   7.8740418E-02,   7.7993646E-02
     +,   7.6829463E-02,   7.5262055E-02,   7.3322453E-02
     +,   7.1057178E-02,   6.8526678E-02,   6.5801725E-02
     +,   6.2960520E-02,   6.0083985E-02,   5.7252448E-02
     +,   5.4541197E-02,   5.2017335E-02,   4.9737517E-02
     +,   4.7745667E-02,   4.6071939E-02,   4.4732697E-02
     +,   4.3731023E-02,   4.3057676E-02,   4.2692628E-02
     +,   4.2606939E-02,   4.2764716E-02,   4.3125074E-02
     +,   4.3644086E-02,   4.4276532E-02,   4.4977482E-02
     +,   4.5703750E-02,   4.6415020E-02,   4.7074720E-02
     +,   4.7650762E-02,   4.8116140E-02,   4.8449136E-02
     +,   4.8633479E-02,   4.8658326E-02,   4.8518147E-02
     +,   4.8212312E-02,   4.7744848E-02,   4.7123831E-02
     +,   4.6360888E-02,   4.5470681E-02,   4.4470292E-02
     +,   4.3378484E-02,   4.2215236E-02,   4.1001137E-02
     +,   3.9756816E-02,   3.8502298E-02,   3.7256557E-02
     +,   3.6037184E-02,   3.4859866E-02,   3.3737943E-02
     +,   3.2682274E-02,   3.1701051E-02,   3.0799538E-02
     +,   2.9980099E-02,   2.9242322E-02,   2.8583080E-02
     +,   2.7996751E-02,   2.7475538E-02,   2.7009891E-02
     +,   2.6588866E-02,   2.6200566E-02,   2.5832618E-02
     +,   2.5472667E-02,   2.5108768E-02,   2.4729770E-02
     +,   2.4325676E-02,   2.3887960E-02,   2.3409694E-02
     +,   2.2885723E-02,   2.2312773E-02,   2.1689385E-02
     +,   2.1015838E-02,   2.0294048E-02,   1.9527424E-02
     +,   1.8720658E-02,   1.7879428E-02,   1.7010197E-02
     +,   1.6120041E-02,   1.5216361E-02,   1.4306569E-02
     +,   1.3397989E-02,   1.2497723E-02,   1.1612340E-02
     +,   1.0747844E-02,   9.9096261E-03,   9.1023510E-03
     +,   8.3298497E-03,   7.5951857E-03,   6.9007045E-03
     +,   6.2480010E-03,   5.6379363E-03,   5.0707418E-03
     +,   4.5461189E-03,   4.0632663E-03,   3.6209335E-03
     +,   3.2175279E-03,   2.8512275E-03,   2.5199680E-03
     +,   2.2215524E-03,   1.9537243E-03,   1.7141940E-03
     +,   1.5006701E-03,   1.3109134E-03,   1.1427756E-03
     +,   9.9420722E-04,   8.6326327E-04,   7.4812956E-04
     +,   6.4713130E-04,   5.5872672E-04,   4.8150157E-04
     +,   4.1417262E-04,   3.5558661E-04,   3.0470098E-04
     +,   2.6058266E-04,   2.2240264E-04,   1.8942308E-04
     +,   1.6098772E-04,   1.3651657E-04,   1.1549921E-04
     +,   9.7485827E-05,   8.2079416E-05,   6.8931688E-05
     +,   5.7738005E-05,   4.8231424E-05,   4.0177860E-05
     +,   3.3373035E-05,   2.7639489E-05,   2.2822145E-05
     +,   1.8786381E-05,   1.5415795E-05,   1.2609610E-05
     +,   1.0280725E-05,   8.3542491E-06,   6.7660490E-06
     +,   5.4612397E-06,   4.3929381E-06,   3.5213445E-06
     +,   2.8128065E-06,   2.2389254E-06,   1.7757952E-06
     +,   1.4034138E-06,   1.1051349E-06,   8.6710060E-07
     +,   6.7785589E-07,   5.2797765E-07,   4.0973342E-07
     +,   3.1680048E-07,   2.4403982E-07,   1.8729469E-07
     +,   1.4321189E-07,   1.0909766E-07,   8.2799367E-08
     +,   6.2606546E-08,   4.7160977E-08,   3.5393406E-08
     +,   2.6462374E-08,   1.9710996E-08,   1.4626900E-08
     +,   1.0813509E-08,   7.9641955E-09,   5.8436855E-09
     +,   4.2716044E-09,   3.1107379E-09,   2.2568272E-09
     +,   1.6311367E-09,   1.1744903E-09,   8.4249163E-10
     +,   6.0206923E-10,   4.2863169E-10,   3.0400932E-10
     +,   2.1480523E-10,   1.5120576E-10,   1.0603438E-10
     +,   7.4078216E-11,   5.1557071E-11,   3.5747957E-11
     +,   2.4692668E-11,   1.6992211E-11
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_haonly_htt70_mass = Yx/1.68727468965517
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_haonly_htt75_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.9431385E-03,   5.1356726E-03
     +,   5.3333426E-03,   5.5359160E-03,   5.7431194E-03
     +,   5.9546353E-03,   6.1701066E-03,   6.3891313E-03
     +,   6.6112662E-03,   6.8360344E-03,   7.0629115E-03
     +,   7.2913389E-03,   7.5207264E-03,   7.7504539E-03
     +,   7.9798736E-03,   8.2083214E-03,   8.4351236E-03
     +,   8.6595919E-03,   8.8810492E-03,   9.0988269E-03
     +,   9.3122786E-03,   9.5207924E-03,   9.7237946E-03
     +,   9.9207880E-03,   1.0111324E-02,   1.0295056E-02
     +,   1.0471730E-02,   1.0641210E-02,   1.0803490E-02
     +,   1.0958706E-02,   1.1107152E-02,   1.1249291E-02
     +,   1.1385767E-02,   1.1517411E-02,   1.1645249E-02
     +,   1.1770503E-02,   1.1894588E-02,   1.2019109E-02
     +,   1.2145858E-02,   1.2276782E-02,   1.2413989E-02
     +,   1.2559696E-02,   1.2716238E-02,   1.2886003E-02
     +,   1.3071427E-02,   1.3274937E-02,   1.3498951E-02
     +,   1.3745808E-02,   1.4017771E-02,   1.4316984E-02
     +,   1.4645458E-02,   1.5005063E-02,   1.5397515E-02
     +,   1.5824405E-02,   1.6287137E-02,   1.6787043E-02
     +,   1.7325306E-02,   1.7903028E-02,   1.8521218E-02
     +,   1.9180821E-02,   1.9882688E-02,   2.0627581E-02
     +,   2.1416066E-02,   2.2248570E-02,   2.3125233E-02
     +,   2.4045710E-02,   2.5009241E-02,   2.6014270E-02
     +,   2.7058514E-02,   2.8138567E-02,   2.9249996E-02
     +,   3.0386889E-02,   3.1542074E-02,   3.2706734E-02
     +,   3.3870645E-02,   3.5022125E-02,   3.6148086E-02
     +,   3.7234303E-02,   3.8265809E-02,   3.9227150E-02
     +,   4.0102765E-02,   4.0877622E-02,   4.1537654E-02
     +,   4.2070366E-02,   4.2465281E-02,   4.2714573E-02
     +,   4.2813402E-02,   4.2760327E-02,   4.2557564E-02
     +,   4.2211153E-02,   4.1730862E-02,   4.1130316E-02
     +,   4.0426571E-02,   3.9639816E-02,   3.8793016E-02
     +,   3.7911389E-02,   3.7021797E-02,   3.6152218E-02
     +,   3.5331089E-02,   3.4586743E-02,   3.3946741E-02
     +,   3.3437405E-02,   3.3083148E-02,   3.2905996E-02
     +,   3.2925051E-02,   3.3156045E-02,   3.3610851E-02
     +,   3.4297042E-02,   3.5217587E-02,   3.6370572E-02
     +,   3.7748870E-02,   3.9340317E-02,   4.1127540E-02
     +,   4.3088533E-02,   4.5196764E-02,   4.7422215E-02
     +,   4.9731862E-02,   5.2091070E-02,   5.4464221E-02
     +,   5.6816451E-02,   5.9114631E-02,   6.1328184E-02
     +,   6.3430518E-02,   6.5399788E-02,   6.7219414E-02
     +,   6.8878144E-02,   7.0370629E-02,   7.1696520E-02
     +,   7.2860524E-02,   7.3871054E-02,   7.4739657E-02
     +,   7.5479619E-02,   7.6104924E-02,   7.6628849E-02
     +,   7.7063076E-02,   7.7416480E-02,   7.7694461E-02
     +,   7.7898368E-02,   7.8025527E-02,   7.8069344E-02
     +,   7.8019895E-02,   7.7864945E-02,   7.7591114E-02
     +,   7.7185377E-02,   7.6636523E-02,   7.5936683E-02
     +,   7.5082362E-02,   7.4075706E-02,   7.2924763E-02
     +,   7.1643367E-02,   7.0250802E-02,   6.8770520E-02
     +,   6.7228861E-02,   6.5653093E-02,   6.4069562E-02
     +,   6.2502094E-02,   6.0970139E-02,   5.9487559E-02
     +,   5.8061987E-02,   5.6694683E-02,   5.5380620E-02
     +,   5.4109417E-02,   5.2866682E-02,   5.1635344E-02
     +,   5.0397199E-02,   4.9134567E-02,   4.7831837E-02
     +,   4.6476558E-02,   4.5060173E-02,   4.3578643E-02
     +,   4.2032618E-02,   4.0427193E-02,   3.8771205E-02
     +,   3.7076693E-02,   3.5358138E-02,   3.3631336E-02
     +,   3.1912494E-02,   3.0217620E-02,   2.8561663E-02
     +,   2.6957832E-02,   2.5417311E-02,   2.3949081E-02
     +,   2.2559756E-02,   2.1253493E-02,   2.0032255E-02
     +,   1.8896127E-02,   1.7843449E-02,   1.6871111E-02
     +,   1.5974918E-02,   1.5149990E-02,   1.4390843E-02
     +,   1.3691748E-02,   1.3046971E-02,   1.2450891E-02
     +,   1.1898098E-02,   1.1383524E-02,   1.0902539E-02
     +,   1.0450942E-02,   1.0024952E-02,   9.6212309E-03
     +,   9.2368927E-03,   8.8694422E-03,   8.5167326E-03
     +,   8.1769424E-03,   7.8485841E-03,   7.5304001E-03
     +,   7.2213602E-03,   6.9206590E-03,   6.6276640E-03
     +,   6.3418699E-03,   6.0629020E-03,   5.7905135E-03
     +,   5.5245422E-03,   5.2648867E-03,   5.0115078E-03
     +,   4.7644288E-03,   4.5237117E-03,   4.2894292E-03
     +,   4.0616710E-03,   3.8405638E-03,   3.6262108E-03
     +,   3.4187187E-03,   3.2181968E-03,   3.0247441E-03
     +,   2.8384307E-03,   2.6593106E-03,   2.4874299E-03
     +,   2.3228123E-03,   2.1654489E-03,   2.0153087E-03
     +,   1.8723487E-03,   1.7365024E-03,   1.6076730E-03
     +,   1.4857445E-03,   1.3705927E-03,   1.2620641E-03
     +,   1.1599888E-03,   1.0641897E-03,   9.7447523E-04
     +,   8.9063635E-04,   8.1245514E-04,   7.3971064E-04
     +,   6.7217508E-04,   6.0961128E-04,   5.5177975E-04
     +,   4.9844367E-04,   4.4936489E-04,   4.0430372E-04
     +,   3.6302363E-04,   3.2529572E-04,   2.9089171E-04
     +,   2.5958961E-04,   2.3117632E-04,   2.0544550E-04
     +,   1.8219701E-04,   1.6123956E-04,   1.4239200E-04
     +,   1.2548197E-04,   1.1034535E-04,   9.6827454E-05
     +,   8.4783962E-05,   7.4079646E-05,   6.4587686E-05
     +,   5.6190358E-05,   4.8779457E-05,   4.2254323E-05
     +,   3.6522542E-05,   3.1499683E-05,   2.7108654E-05
     +,   2.3278906E-05,   1.9946505E-05,   1.7053821E-05
     +,   1.4548845E-05,   1.2384667E-05,   1.0519286E-05
     +,   8.9153391E-06,   7.5393573E-06,   6.3617967E-06
     +,   5.3563540E-06,   4.4999460E-06,   3.7721456E-06
     +,   3.1551365E-06,   2.6332405E-06,   2.1928595E-06
     +,   1.8221089E-06,   1.5107256E-06,   1.2498060E-06
     +,   1.0316728E-06,   8.4974766E-07,   6.9836187E-07
     +,   5.7269023E-07,   4.6859964E-07,   3.8258929E-07
     +,   3.1167821E-07,   2.5335459E-07,   2.0549156E-07
     +,   1.6630614E-07,   1.3429685E-07,   1.0821111E-07
     +,   8.7000338E-08,   6.9794119E-08
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_haonly_htt75_mass = Yx/1.66644413793103
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_haonly_htt80_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  8.0561545E-04,   8.2113536E-04
     +,   8.3656062E-04,   8.5191429E-04,   8.6722744E-04
     +,   8.8254100E-04,   8.9790759E-04,   9.1339136E-04
     +,   9.2907040E-04,   9.4503909E-04,   9.6140738E-04
     +,   9.7830489E-04,   9.9588057E-04,   1.0143050E-03
     +,   1.0337734E-03,   1.0545045E-03,   1.0767443E-03
     +,   1.1007664E-03,   1.1268726E-03,   1.1553952E-03
     +,   1.1866960E-03,   1.2211680E-03,   1.2592333E-03
     +,   1.3013467E-03,   1.3479871E-03,   1.3996655E-03
     +,   1.4569148E-03,   1.5202917E-03,   1.5903707E-03
     +,   1.6677431E-03,   1.7530102E-03,   1.8467789E-03
     +,   1.9496571E-03,   2.0622467E-03,   2.1851379E-03
     +,   2.3189012E-03,   2.4640821E-03,   2.6211897E-03
     +,   2.7907032E-03,   2.9730352E-03,   3.1685606E-03
     +,   3.3775824E-03,   3.6003324E-03,   3.8369657E-03
     +,   4.0875520E-03,   4.3520671E-03,   4.6303873E-03
     +,   4.9222801E-03,   5.2274000E-03,   5.5452809E-03
     +,   5.8753267E-03,   6.2168082E-03,   6.5688523E-03
     +,   6.9304616E-03,   7.3004505E-03,   7.6775281E-03
     +,   8.0602216E-03,   8.4469281E-03,   8.8358894E-03
     +,   9.2252279E-03,   9.6129421E-03,   9.9969469E-03
     +,   1.0375057E-02,   1.0745093E-02,   1.1104871E-02
     +,   1.1452235E-02,   1.1785185E-02,   1.2101847E-02
     +,   1.2400643E-02,   1.2680272E-02,   1.2939870E-02
     +,   1.3179027E-02,   1.3397921E-02,   1.3597338E-02
     +,   1.3778792E-02,   1.3944559E-02,   1.4097705E-02
     +,   1.4242116E-02,   1.4382520E-02,   1.4524410E-02
     +,   1.4674002E-02,   1.4838156E-02,   1.5024198E-02
     +,   1.5239825E-02,   1.5492829E-02,   1.5790956E-02
     +,   1.6141595E-02,   1.6551616E-02,   1.7027011E-02
     +,   1.7572768E-02,   1.8192641E-02,   1.8888941E-02
     +,   1.9662457E-02,   2.0512508E-02,   2.1436932E-02
     +,   2.2432134E-02,   2.3493541E-02,   2.4615629E-02
     +,   2.5792604E-02,   2.7018489E-02,   2.8287916E-02
     +,   2.9596183E-02,   3.0939946E-02,   3.2317106E-02
     +,   3.3727188E-02,   3.5171118E-02,   3.6650781E-02
     +,   3.8168579E-02,   3.9726790E-02,   4.1326556E-02
     +,   4.2966787E-02,   4.4643510E-02,   4.6348646E-02
     +,   4.8069824E-02,   4.9789649E-02,   5.1486377E-02
     +,   5.3134017E-02,   5.4704007E-02,   5.6166239E-02
     +,   5.7491444E-02,   5.8652997E-02,   5.9628952E-02
     +,   6.0404077E-02,   6.0971405E-02,   6.1332975E-02
     +,   6.1500300E-02,   6.1493963E-02,   6.1342582E-02
     +,   6.1081272E-02,   6.0749762E-02,   6.0390282E-02
     +,   6.0045566E-02,   5.9756994E-02,   5.9563093E-02
     +,   5.9498269E-02,   5.9592057E-02,   5.9868440E-02
     +,   6.0345344E-02,   6.1034195E-02,   6.1939437E-02
     +,   6.3057780E-02,   6.4377680E-02,   6.5878794E-02
     +,   6.7531772E-02,   6.9298141E-02,   7.1131349E-02
     +,   7.2977975E-02,   7.4779816E-02,   7.6476701E-02
     +,   7.8009836E-02,   7.9325214E-02,   8.0377087E-02
     +,   8.1131160E-02,   8.1567138E-02,   8.1680268E-02
     +,   8.1481688E-02,   8.0997705E-02,   8.0267705E-02
     +,   7.9340957E-02,   7.8272887E-02,   7.7120580E-02
     +,   7.5938322E-02,   7.4773833E-02,   7.3664822E-02
     +,   7.2636932E-02,   7.1702793E-02,   7.0862561E-02
     +,   7.0105091E-02,   6.9410428E-02,   6.8752661E-02
     +,   6.8102852E-02,   6.7431949E-02,   6.6712856E-02
     +,   6.5922171E-02,   6.5041065E-02,   6.4055242E-02
     +,   6.2954605E-02,   6.1732598E-02,   6.0385123E-02
     +,   5.8909934E-02,   5.7306081E-02,   5.5573951E-02
     +,   5.3715404E-02,   5.1734213E-02,   4.9636822E-02
     +,   4.7433075E-02,   4.5136616E-02,   4.2764835E-02
     +,   4.0338725E-02,   3.7882555E-02,   3.5422318E-02
     +,   3.2984808E-02,   3.0596379E-02,   2.8281463E-02
     +,   2.6061270E-02,   2.3953049E-02,   2.1969656E-02
     +,   2.0119194E-02,   1.8405039E-02,   1.6826395E-02
     +,   1.5379039E-02,   1.4055977E-02,   1.2848191E-02
     +,   1.1745580E-02,   1.0737740E-02,   9.8143714E-03
     +,   8.9658601E-03,   8.1836283E-03,   7.4602491E-03
     +,   6.7894440E-03,   6.1661000E-03,   5.5861967E-03
     +,   5.0465916E-03,   4.5448272E-03,   4.0789843E-03
     +,   3.6475514E-03,   3.2492420E-03,   2.8828583E-03
     +,   2.5472303E-03,   2.2411835E-03,   1.9634373E-03
     +,   1.7126207E-03,   1.4872871E-03,   1.2859044E-03
     +,   1.1068615E-03,   9.4850967E-04,   8.0919534E-04
     +,   6.8727194E-04,   5.8111729E-04,   4.8916385E-04
     +,   4.0992111E-04,   3.4197964E-04,   2.8401887E-04
     +,   2.3481817E-04,   1.9326439E-04,   1.5834172E-04
     +,   1.2913640E-04,   1.0483415E-04,   8.4712505E-05
     +,   6.8134264E-05,   5.4542990E-05,   4.3456464E-05
     +,   3.4458724E-05,   2.7192755E-05,   2.1354821E-05
     +,   1.6688375E-05,   1.2977572E-05,   1.0041869E-05
     +,   7.7313716E-06,   5.9225790E-06,   4.5139655E-06
     +,   3.4227855E-06,   2.5820486E-06,   1.9377712E-06
     +,   1.4466940E-06,   1.0744100E-06,   7.9373439E-07
     +,   5.8329061E-07,   4.2636748E-07,   3.0999848E-07
     +,   2.2418401E-07,   1.6125644E-07,   1.1536745E-07
     +,   8.2090139E-08,   5.8095587E-08,   4.0891152E-08
     +,   2.8624477E-08,   1.9928185E-08,   1.3798141E-08
     +,   9.5013677E-09,   6.5066175E-09,   4.4312847E-09
     +,   3.0013116E-09,   2.0215851E-09,   1.3541414E-09
     +,   9.0206087E-10,   5.9757910E-10,   3.9368767E-10
     +,   2.5792501E-10,   1.6804735E-10,   1.0888150E-10
     +,   7.0157678E-11,   4.4955633E-11,   2.8648278E-11
     +,   1.8155576E-11,   1.1442998E-11,   7.1728660E-12
     +,   4.4717576E-12,   2.7728876E-12,   1.7103067E-12
     +,   1.0494444E-12,   6.4067572E-13,   3.8923560E-13
     +,   2.3539002E-13,   1.4175979E-13,   8.5061502E-14
     +,   5.0895598E-14,   3.0398342E-14,   1.8151205E-14
     +,   1.0857115E-14,   6.5233497E-15
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_haonly_htt80_mass = Yx/1.553364
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_haonly_htt85_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.2472441E-03,   1.2872990E-03
     +,   1.3274287E-03,   1.3675629E-03,   1.4076282E-03
     +,   1.4475505E-03,   1.4872539E-03,   1.5266619E-03
     +,   1.5656966E-03,   1.6042822E-03,   1.6423408E-03
     +,   1.6797968E-03,   1.7165749E-03,   1.7526026E-03
     +,   1.7878095E-03,   1.8221287E-03,   1.8554964E-03
     +,   1.8878547E-03,   1.9191498E-03,   1.9493347E-03
     +,   1.9783699E-03,   2.0062237E-03,   2.0328725E-03
     +,   2.0583055E-03,   2.0825190E-03,   2.1055252E-03
     +,   2.1273482E-03,   2.1480278E-03,   2.1676186E-03
     +,   2.1861945E-03,   2.2038466E-03,   2.2206886E-03
     +,   2.2368557E-03,   2.2525073E-03,   2.2678287E-03
     +,   2.2830330E-03,   2.2983649E-03,   2.3140998E-03
     +,   2.3305495E-03,   2.3480600E-03,   2.3670201E-03
     +,   2.3878578E-03,   2.4110465E-03,   2.4371047E-03
     +,   2.4666006E-03,   2.5001508E-03,   2.5384233E-03
     +,   2.5821365E-03,   2.6320615E-03,   2.6890163E-03
     +,   2.7538694E-03,   2.8275307E-03,   2.9109488E-03
     +,   3.0051090E-03,   3.1110127E-03,   3.2296856E-03
     +,   3.3621518E-03,   3.5094288E-03,   3.6725127E-03
     +,   3.8523646E-03,   4.0498939E-03,   4.2659505E-03
     +,   4.5012911E-03,   4.7566011E-03,   5.0324607E-03
     +,   5.3293165E-03,   5.6475331E-03,   5.9873117E-03
     +,   6.3487785E-03,   6.7318906E-03,   7.1365424E-03
     +,   7.5624664E-03,   8.0093583E-03,   8.4767612E-03
     +,   8.9641847E-03,   9.4710682E-03,   9.9967523E-03
     +,   1.0540499E-02,   1.1101536E-02,   1.1678989E-02
     +,   1.2271833E-02,   1.2878968E-02,   1.3499058E-02
     +,   1.4130637E-02,   1.4771914E-02,   1.5420912E-02
     +,   1.6075250E-02,   1.6732316E-02,   1.7389085E-02
     +,   1.8042257E-02,   1.8688260E-02,   1.9323252E-02
     +,   1.9943254E-02,   2.0544294E-02,   2.1122504E-02
     +,   2.1674236E-02,   2.2196338E-02,   2.2686204E-02
     +,   2.3142079E-02,   2.3563070E-02,   2.3949414E-02
     +,   2.4302443E-02,   2.4624713E-02,   2.4919886E-02
     +,   2.5192732E-02,   2.5448905E-02,   2.5694707E-02
     +,   2.5936801E-02,   2.6181879E-02,   2.6436256E-02
     +,   2.6705444E-02,   2.6993787E-02,   2.7304048E-02
     +,   2.7637137E-02,   2.7991835E-02,   2.8364737E-02
     +,   2.8750187E-02,   2.9140547E-02,   2.9526431E-02
     +,   2.9897269E-02,   3.0241922E-02,   3.0549439E-02
     +,   3.0809950E-02,   3.1015672E-02,   3.1161727E-02
     +,   3.1247098E-02,   3.1275351E-02,   3.1255223E-02
     +,   3.1200835E-02,   3.1131683E-02,   3.1072225E-02
     +,   3.1051008E-02,   3.1099502E-02,   3.1250618E-02
     +,   3.1536996E-02,   3.1989411E-02,   3.2635290E-02
     +,   3.3497687E-02,   3.4595266E-02,   3.5942897E-02
     +,   3.7553210E-02,   3.9439157E-02,   4.1617200E-02
     +,   4.4110280E-02,   4.6949938E-02,   5.0177895E-02
     +,   5.3844880E-02,   5.8006961E-02,   6.2719487E-02
     +,   6.8029046E-02,   7.3962845E-02,   8.0517516E-02
     +,   8.7648883E-02,   9.5264807E-02,   0.1032203    
     +,   0.1113181    ,   0.1193155    ,   0.1269380    
     +,   0.1338971    ,   0.1399115    ,   0.1447323    
     +,   0.1481653    ,   0.1500893    ,   0.1504691    
     +,   0.1493595    ,   0.1469008    ,   0.1433055    
     +,   0.1388400    ,   0.1337999    ,   0.1284853    
     +,   0.1231775    ,   0.1181179    ,   0.1134919    
     +,   0.1094195    ,   0.1059517    ,   0.1030713    
     +,   0.1007013    ,   9.8717123E-02,   9.6962258E-02
     +,   9.5266052E-02,   9.3462683E-02,   9.1408551E-02
     +,   8.8996060E-02,   8.6163074E-02,   8.2896188E-02
     +,   7.9228520E-02,   7.5231679E-02,   7.1003698E-02
     +,   6.6655278E-02,   6.2296644E-02,   5.8024809E-02
     +,   5.3915493E-02,   5.0018914E-02,   4.6359085E-02
     +,   4.2936400E-02,   3.9733477E-02,   3.6721796E-02
     +,   3.3868339E-02,   3.1141263E-02,   2.8514648E-02
     +,   2.5971310E-02,   2.3503704E-02,   2.1113150E-02
     +,   1.8808471E-02,   1.6603820E-02,   1.4515726E-02
     +,   1.2560858E-02,   1.0754087E-02,   9.1068046E-03
     +,   7.6258732E-03,   6.3134087E-03,   5.1669669E-03
     +,   4.1799392E-03,   3.3422525E-03,   2.6413538E-03
     +,   2.0631445E-03,   1.5927720E-03,   1.2153497E-03
     +,   9.1659790E-04,   6.8329443E-04,   5.0350116E-04
     +,   3.6674942E-04,   2.6408190E-04,   1.8798947E-04
     +,   1.3230335E-04,   9.2059236E-05,   6.3335945E-05
     +,   4.3087173E-05,   2.8985274E-05,   1.9282124E-05
     +,   1.2685497E-05,   8.2539591E-06,   5.3116978E-06
     +,   3.3808990E-06,   2.1285775E-06,   1.3256056E-06
     +,   8.1660778E-07,   4.9762906E-07,   2.9999114E-07
     +,   1.7890491E-07,   1.0554694E-07,   6.1601312E-08
     +,   3.5568402E-08,   2.0317064E-08,   1.1480736E-08
     +,   6.4179400E-09,   3.5492891E-09,   1.9417565E-09
     +,   1.0508548E-09,   5.6259986E-10,   2.9796018E-10
     +,   1.5610624E-10,   8.0912714E-11,   4.1495900E-11
     +,   2.1060329E-11,   1.0581428E-11,   5.2665533E-12
     +,   2.5995380E-12,   1.2748320E-12,   6.2308849E-13
     +,   3.0510449E-13,   1.5091903E-13,   7.6343872E-14
     +,   4.0147220E-14,   2.2348246E-14,   1.3353773E-14
     +,   8.5966543E-15,   5.9135563E-15,   4.2797233E-15
     +,   3.2056820E-15,   2.4526817E-15,   1.8995146E-15
     +,   1.4806754E-15,   1.1577975E-15,   9.0642023E-16
     +,   7.0974156E-16,   5.5550660E-16,   4.3448129E-16
     +,   3.3952101E-16,   2.6506316E-16,   2.0672456E-16
     +,   1.6106104E-16,   1.2535340E-16,   9.7460842E-17
     +,   7.5695119E-17,   5.8729049E-17,   4.5517939E-17
     +,   3.5241411E-17,   2.7256549E-17,   2.1058672E-17
     +,   1.6253133E-17,   1.2530975E-17,   9.6511579E-18
     +,   7.4253406E-18,   5.7068878E-18,   4.3815025E-18
     +,   3.3604376E-18,   2.5745889E-18,   1.9704658E-18
     +,   1.5065001E-18,   1.1505799E-18
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_haonly_htt85_mass = Yx/1.70810524137931
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_haonly_htt90_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.8221814E-04,   5.2299327E-04
     +,   5.6616723E-04,   6.1177218E-04,   6.5982906E-04
     +,   7.1034604E-04,   7.6331856E-04,   8.1872725E-04
     +,   8.7653683E-04,   9.3669881E-04,   9.9914544E-04
     +,   1.0637922E-03,   1.1305368E-03,   1.1992593E-03
     +,   1.2698220E-03,   1.3420677E-03,   1.4158227E-03
     +,   1.4908946E-03,   1.5670748E-03,   1.6441380E-03
     +,   1.7218442E-03,   1.7999393E-03,   1.8781553E-03
     +,   1.9562184E-03,   2.0338362E-03,   2.1107192E-03
     +,   2.1865666E-03,   2.2610768E-03,   2.3339475E-03
     +,   2.4048786E-03,   2.4735746E-03,   2.5397472E-03
     +,   2.6031181E-03,   2.6634212E-03,   2.7204074E-03
     +,   2.7738430E-03,   2.8235158E-03,   2.8692351E-03
     +,   2.9108382E-03,   2.9481836E-03,   2.9811633E-03
     +,   3.0096972E-03,   3.0337367E-03,   3.0532661E-03
     +,   3.0683030E-03,   3.0788984E-03,   3.0851376E-03
     +,   3.0871392E-03,   3.0850561E-03,   3.0790730E-03
     +,   3.0694071E-03,   3.0563043E-03,   3.0400408E-03
     +,   3.0209182E-03,   2.9992638E-03,   2.9754259E-03
     +,   2.9497731E-03,   2.9226909E-03,   2.8945785E-03
     +,   2.8658458E-03,   2.8369098E-03,   2.8081927E-03
     +,   2.7801204E-03,   2.7531125E-03,   2.7275858E-03
     +,   2.7039519E-03,   2.6826079E-03,   2.6639430E-03
     +,   2.6483270E-03,   2.6361176E-03,   2.6276524E-03
     +,   2.6232526E-03,   2.6232207E-03,   2.6278412E-03
     +,   2.6373835E-03,   2.6521031E-03,   2.6722418E-03
     +,   2.6980336E-03,   2.7297083E-03,   2.7674974E-03
     +,   2.8116314E-03,   2.8623561E-03,   2.9199265E-03
     +,   2.9846237E-03,   3.0567453E-03,   3.1366271E-03
     +,   3.2246299E-03,   3.3211603E-03,   3.4266543E-03
     +,   3.5415986E-03,   3.6665264E-03,   3.8020071E-03
     +,   3.9486578E-03,   4.1071507E-03,   4.2782119E-03
     +,   4.4626053E-03,   4.6611778E-03,   4.8748110E-03
     +,   5.1044929E-03,   5.3512650E-03,   5.6162900E-03
     +,   5.9008100E-03,   6.2062163E-03,   6.5339915E-03
     +,   6.8857763E-03,   7.2633489E-03,   7.6685837E-03
     +,   8.1034442E-03,   8.5699791E-03,   9.0702428E-03
     +,   9.6061677E-03,   1.0179576E-02,   1.0791932E-02
     +,   1.1444347E-02,   1.2137284E-02,   1.2870552E-02
     +,   1.3642994E-02,   1.4452501E-02,   1.5295719E-02
     +,   1.6168119E-02,   1.7063875E-02,   1.7975828E-02
     +,   1.8895583E-02,   1.9813731E-02,   2.0719940E-02
     +,   2.1603147E-02,   2.2452036E-02,   2.3255156E-02
     +,   2.4001474E-02,   2.4680594E-02,   2.5283370E-02
     +,   2.5802206E-02,   2.6231771E-02,   2.6569556E-02
     +,   2.6816733E-02,   2.6979029E-02,   2.7067721E-02
     +,   2.7100701E-02,   2.7103400E-02,   2.7109519E-02
     +,   2.7161365E-02,   2.7309807E-02,   2.7613685E-02
     +,   2.8138954E-02,   2.8957495E-02,   3.0146202E-02
     +,   3.1786114E-02,   3.3961687E-02,   3.6760043E-02
     +,   4.0269874E-02,   4.4578649E-02,   4.9767785E-02
     +,   5.5905923E-02,   6.3041046E-02,   7.1191065E-02
     +,   8.0335513E-02,   9.0411223E-02,   0.1013132    
     +,   0.1128983    ,   0.1249900    ,   0.1373829    
     +,   0.1498343    ,   0.1620441    ,   0.1736284    
     +,   0.1840976    ,   0.1928590    ,   0.1992643    
     +,   0.2027123    ,   0.2027947    ,   0.1994469    
     +,   0.1930633    ,   0.1845281    ,   0.1751335    
     +,   0.1663954    ,   0.1597957    ,   0.1565094    
     +,   0.1571796    ,   0.1617906    ,   0.1696664    
     +,   0.1795951    ,   0.1900444    ,   0.1994198    
     +,   0.2063100    ,   0.2096737    ,   0.2089415    
     +,   0.2040319    ,   0.1952978    ,   0.1834225    
     +,   0.1692951    ,   0.1538841    ,   0.1381189    
     +,   0.1227997    ,   0.1085358    ,   9.5716946E-02
     +,   8.4516026E-02,   7.4921221E-02,   6.6784605E-02
     +,   5.9876364E-02,   5.3936835E-02,   4.8719056E-02
     +,   4.4017281E-02,   3.9680701E-02,   3.5615090E-02
     +,   3.1776257E-02,   2.8158413E-02,   2.4779329E-02
     +,   2.1667518E-02,   1.8851329E-02,   1.6350798E-02
     +,   1.4173061E-02,   1.2311202E-02,   1.0745451E-02
     +,   9.4458451E-03,   8.3758477E-03,   7.4962690E-03
     +,   6.7686974E-03,   6.1579989E-03,   5.6339945E-03
     +,   5.1723109E-03,   4.7544721E-03,   4.3673199E-03
     +,   4.0022600E-03,   3.6543303E-03,   3.3212164E-03
     +,   3.0023840E-03,   2.6983847E-03,   2.4103296E-03
     +,   2.1394650E-03,   1.8868904E-03,   1.6534250E-03
     +,   1.4395391E-03,   1.2453175E-03,   1.0704687E-03
     +,   9.1438211E-04,   7.7619794E-04,   6.5483595E-04
     +,   5.4907397E-04,   4.5760800E-04,   3.7909250E-04
     +,   3.1217770E-04,   2.5555064E-04,   2.0796330E-04
     +,   1.6824569E-04,   1.3531728E-04,   1.0819709E-04
     +,   8.6007312E-05,   6.7969580E-05,   5.3400589E-05
     +,   4.1708070E-05,   3.2384345E-05,   2.4996425E-05
     +,   1.9179291E-05,   1.4628170E-05,   1.1090208E-05
     +,   8.3572477E-06,   6.2595241E-06,   4.6597424E-06
     +,   3.4475770E-06,   2.5349948E-06,   1.8523873E-06
     +,   1.3451395E-06,   9.7067471E-07,   6.9603743E-07
     +,   4.9593621E-07,   3.5111577E-07,   2.4699588E-07
     +,   1.7263471E-07,   1.1988361E-07,   8.2714401E-08
     +,   5.6699285E-08,   3.8613244E-08,   2.6124914E-08
     +,   1.7560343E-08,   1.1726235E-08,   7.7789464E-09
     +,   5.1265610E-09,   3.3562897E-09,   2.1828708E-09
     +,   1.4103158E-09,   9.0517793E-10,   5.7711930E-10
     +,   3.6552886E-10,   2.2997858E-10,   1.4373915E-10
     +,   8.9241614E-11,   5.5040059E-11,   3.3720967E-11
     +,   2.0522205E-11,   1.2406925E-11,   7.4508177E-12
     +,   4.4448729E-12,   2.6339796E-12,   1.5505329E-12
     +,   9.0666401E-13,   5.2665538E-13,   3.0388002E-13
     +,   1.7417750E-13,   9.9169432E-14,   5.6088967E-14
     +,   3.1511767E-14,   1.7586588E-14
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_haonly_htt90_mass = Yx/2.0337562
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_haonly_htt95_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  7.3633884E-05,   8.1869846E-05
     +,   9.0882262E-05,   1.0072658E-04,   1.1146011E-04
     +,   1.2314189E-04,   1.3583261E-04,   1.4959427E-04
     +,   1.6448963E-04,   1.8058303E-04,   1.9793863E-04
     +,   2.1662077E-04,   2.3669371E-04,   2.5822085E-04
     +,   2.8126457E-04,   3.0588536E-04,   3.3214202E-04
     +,   3.6009034E-04,   3.8978312E-04,   4.2126924E-04
     +,   4.5459357E-04,   4.8979576E-04,   5.2690966E-04
     +,   5.6596554E-04,   6.0698250E-04,   6.4997753E-04
     +,   6.9495715E-04,   7.4192055E-04,   7.9085858E-04
     +,   8.4175332E-04,   8.9457753E-04,   9.4929495E-04
     +,   1.0058595E-03,   1.0642156E-03,   1.1242981E-03
     +,   1.1860320E-03,   1.2493330E-03,   1.3141069E-03
     +,   1.3802542E-03,   1.4476605E-03,   1.5162103E-03
     +,   1.5857766E-03,   1.6562277E-03,   1.7274262E-03
     +,   1.7992295E-03,   1.8714913E-03,   1.9440644E-03
     +,   2.0167988E-03,   2.0895454E-03,   2.1621566E-03
     +,   2.2344873E-03,   2.3063973E-03,   2.3777517E-03
     +,   2.4484282E-03,   2.5183058E-03,   2.5872821E-03
     +,   2.6552642E-03,   2.7221763E-03,   2.7879574E-03
     +,   2.8525672E-03,   2.9159850E-03,   2.9782152E-03
     +,   3.0392809E-03,   3.0992385E-03,   3.1581710E-03
     +,   3.2161861E-03,   3.2734312E-03,   3.3300782E-03
     +,   3.3863408E-03,   3.4424604E-03,   3.4987228E-03
     +,   3.5554420E-03,   3.6129754E-03,   3.6717106E-03
     +,   3.7320761E-03,   3.7945353E-03,   3.8595791E-03
     +,   3.9277296E-03,   3.9995406E-03,   4.0755901E-03
     +,   4.1564680E-03,   4.2427899E-03,   4.3351692E-03
     +,   4.4342359E-03,   4.5405999E-03,   4.6548801E-03
     +,   4.7776569E-03,   4.9095033E-03,   5.0509395E-03
     +,   5.2024578E-03,   5.3644977E-03,   5.5374308E-03
     +,   5.7215574E-03,   5.9171137E-03,   6.1242539E-03
     +,   6.3430192E-03,   6.5733814E-03,   6.8151751E-03
     +,   7.0681572E-03,   7.3319357E-03,   7.6060286E-03
     +,   7.8897942E-03,   8.1825014E-03,   8.4832525E-03
     +,   8.7910388E-03,   9.1047334E-03,   9.4230566E-03
     +,   9.7446060E-03,   1.0067889E-02,   1.0391308E-02
     +,   1.0713147E-02,   1.1031661E-02,   1.1345009E-02
     +,   1.1651380E-02,   1.1948923E-02,   1.2235878E-02
     +,   1.2510526E-02,   1.2771323E-02,   1.3016854E-02
     +,   1.3245972E-02,   1.3457797E-02,   1.3651779E-02
     +,   1.3827763E-02,   1.3986045E-02,   1.4127434E-02
     +,   1.4253274E-02,   1.4365531E-02,   1.4466798E-02
     +,   1.4560364E-02,   1.4650206E-02,   1.4741004E-02
     +,   1.4838113E-02,   1.4947547E-02,   1.5075848E-02
     +,   1.5230028E-02,   1.5417363E-02,   1.5645200E-02
     +,   1.5920674E-02,   1.6250432E-02,   1.6640266E-02
     +,   1.7094711E-02,   1.7616674E-02,   1.8207094E-02
     +,   1.8864634E-02,   1.9585362E-02,   2.0362852E-02
     +,   2.1188261E-02,   2.2050694E-02,   2.2938047E-02
     +,   2.3838274E-02,   2.4741050E-02,   2.5639979E-02
     +,   2.6535463E-02,   2.7437977E-02,   2.8371328E-02
     +,   2.9375559E-02,   3.0508900E-02,   3.1847771E-02
     +,   3.3484060E-02,   3.5518717E-02,   3.8052458E-02
     +,   4.1172788E-02,   4.4938926E-02,   4.9366467E-02
     +,   5.4414399E-02,   5.9976242E-02,   6.5879576E-02
     +,   7.1899615E-02,   7.7790700E-02,   8.3338127E-02
     +,   8.8429578E-02,   9.3138151E-02,   9.7797737E-02
     +,   0.1030454    ,   0.1098048    ,   0.1191958    
     +,   0.1323645    ,   0.1502525    ,   0.1733405    
     +,   0.2014161    ,   0.2334189    ,   0.2674282    
     +,   0.3008524    ,   0.3308212    ,   0.3546998    
     +,   0.3705784    ,   0.3775659    ,   0.3757761    
     +,   0.3660493    ,   0.3495787    ,   0.3276208    
     +,   0.3014060    ,   0.2722056    ,   0.2414225    
     +,   0.2105755    ,   0.1811502    ,   0.1543700    
     +,   0.1309968    ,   0.1112575    ,   9.4917826E-02
     +,   8.1456684E-02,   7.0261002E-02,   6.0779531E-02
     +,   5.2601885E-02,   4.5465853E-02,   3.9217900E-02
     +,   3.3763397E-02,   2.9026115E-02,   2.4926716E-02
     +,   2.1379232E-02,   1.8298149E-02,   1.5607427E-02
     +,   1.3246029E-02,   1.1168952E-02,   9.3447817E-03
     +,   7.7513265E-03,   6.3710483E-03,   5.1876837E-03
     +,   4.1845459E-03,   3.3440297E-03,   2.6476895E-03
     +,   2.0770244E-03,   1.6142100E-03,   1.2426251E-03
     +,   9.4720483E-04,   7.1464904E-04,   5.3344062E-04
     +,   3.9373609E-04,   2.8722105E-04,   2.0696002E-04
     +,   1.4723178E-04,   1.0336248E-04,   7.1577939E-05
     +,   4.8873986E-05,   3.2894412E-05,   2.1816171E-05
     +,   1.4253797E-05,   9.1725415E-06,   5.8127766E-06
     +,   3.6269362E-06,   2.2279087E-06,   1.3471549E-06
     +,   8.0181059E-07,   4.6970302E-07,   2.7079523E-07
     +,   1.5364350E-07,   8.5789928E-08,   4.7139764E-08
     +,   2.5488875E-08,   1.3562381E-08,   7.1011810E-09
     +,   3.6586425E-09,   1.8548583E-09,   9.2536057E-10
     +,   4.5426557E-10,   2.1942984E-10,   1.0429829E-10
     +,   4.8782575E-11,   2.2451695E-11,   1.0167627E-11
     +,   4.5309282E-12,   1.9868527E-12,   8.5733471E-13
     +,   3.6402711E-13,   1.5210889E-13,   6.2549724E-14
     +,   2.5314811E-14,   1.0085528E-14,   3.9569059E-15
     +,   1.5297434E-15,   5.8345429E-16,   2.2006721E-16
     +,   8.2456394E-17,   3.0947960E-17,   1.1810308E-17
     +,   4.6953650E-18,   2.0088954E-18,   9.5345821E-19
     +,   5.0726039E-19,   2.9765009E-19,   1.8686354E-19
     +,   1.2204511E-19,   8.1363288E-20,   5.4769451E-20
     +,   3.7014933E-20,   2.5046205E-20,   1.6945355E-20
     +,   1.1455935E-20,   7.7370403E-21,   5.2193731E-21
     +,   3.5168262E-21,   2.3667501E-21,   1.5908556E-21
     +,   1.0680068E-21,   7.1613288E-22,   4.7959880E-22
     +,   3.2080244E-22,   2.1431808E-22,   1.4300579E-22
     +,   9.5303258E-23,   6.3435126E-23
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_haonly_htt95_mass = Yx/2.10455767741936
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_haonly_ttz100_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.4802749E-19,   2.7602583E-19
     +,   5.1203028E-19,   9.4489493E-19,   1.7346492E-18
     +,   3.1679626E-18,   5.7555756E-18,   1.0402538E-17
     +,   1.8703525E-17,   3.3454499E-17,   5.9528629E-17
     +,   1.0537477E-16,   1.8556213E-16,   3.2507404E-16
     +,   5.6651925E-16,   9.8217525E-16,   1.6939613E-15
     +,   2.9064140E-15,   4.9608187E-15,   8.4234250E-15
     +,   1.4228668E-14,   2.3910121E-14,   3.9970038E-14
     +,   6.6471561E-14,   1.0996914E-13,   1.8098782E-13
     +,   2.9632549E-13,   4.8264528E-13,   7.8204012E-13
     +,   1.2605770E-12,   2.0213935E-12,   3.2245760E-12
     +,   5.1172361E-12,   8.0786289E-12,   1.2687647E-11
     +,   1.9822784E-11,   3.0809771E-11,   4.7637724E-11
     +,   7.3275476E-11,   1.1212480E-10,   1.7068218E-10
     +,   2.5847291E-10,   3.8938833E-10,   5.8356686E-10
     +,   8.7003960E-10,   1.2904112E-09,   1.9039565E-09
     +,   2.7946478E-09,   4.0807251E-09,   5.9277285E-09
     +,   8.5660368E-09,   1.2314347E-08,   1.7610912E-08
     +,   2.5055158E-08,   3.5460769E-08,   4.9927742E-08
     +,   6.9932064E-08,   9.7443163E-08,   1.3507258E-07
     +,   1.8626154E-07,   2.5551702E-07,   3.4870556E-07
     +,   4.7340632E-07,   6.3936710E-07,   8.5903514E-07
     +,   1.1481749E-06,   1.5266855E-06,   2.0194248E-06
     +,   2.6573598E-06,   3.4786392E-06,   4.5301522E-06
     +,   5.8688524E-06,   7.5637563E-06,   9.6974827E-06
     +,   1.2368607E-05,   1.5693749E-05,   1.9809473E-05
     +,   2.4874636E-05,   3.1072828E-05,   3.8614333E-05
     +,   4.7736823E-05,   5.8708676E-05,   7.1827148E-05
     +,   8.7421482E-05,   1.0584875E-04,   1.2749592E-04
     +,   1.5277229E-04,   1.8211099E-04,   2.1595618E-04
     +,   2.5476274E-04,   2.9898458E-04,   3.4906171E-04
     +,   4.0540946E-04,   4.6841006E-04,   5.3839508E-04
     +,   6.1562250E-04,   7.0027751E-04,   7.9243683E-04
     +,   8.9207507E-04,   9.9902635E-04,   1.1129986E-03
     +,   1.2335345E-03,   1.3600342E-03,   1.4917209E-03
     +,   1.6276685E-03,   1.7667941E-03,   1.9078596E-03
     +,   2.0494924E-03,   2.1902150E-03,   2.3284596E-03
     +,   2.4625796E-03,   2.5909150E-03,   2.7117885E-03
     +,   2.8235768E-03,   2.9247138E-03,   3.0137561E-03
     +,   3.0893912E-03,   3.1504938E-03,   3.1961307E-03
     +,   3.2256036E-03,   3.2384570E-03,   3.2344891E-03
     +,   3.2137625E-03,   3.1765997E-03,   3.1235716E-03
     +,   3.0554926E-03,   2.9733852E-03,   2.8784720E-03
     +,   2.7721254E-03,   2.6558577E-03,   2.5312593E-03
     +,   2.3999913E-03,   2.2637183E-03,   2.1241077E-03
     +,   1.9827653E-03,   1.8412191E-03,   1.7009057E-03
     +,   1.5631362E-03,   1.4290733E-03,   1.2997272E-03
     +,   1.1759596E-03,   1.0584709E-03,   9.4779732E-04
     +,   8.4432698E-04,   7.4832293E-04,   6.5992062E-04
     +,   5.7916390E-04,   5.0604052E-04,   4.4051552E-04
     +,   3.8257797E-04,   3.3230998E-04,   2.8996600E-04
     +,   2.5606231E-04,   2.3148318E-04,   2.1760547E-04
     +,   2.1642396E-04,   2.3066840E-04,   2.6390480E-04
     +,   3.2060055E-04,   4.0612638E-04,   5.2671385E-04
     +,   6.8933808E-04,   9.0153469E-04,   1.1712055E-03
     +,   1.5064403E-03,   1.9153252E-03,   2.4057210E-03
     +,   2.9850113E-03,   3.6596784E-03,   4.4344529E-03
     +,   5.3109513E-03,   6.2859789E-03,   7.3497924E-03
     +,   8.4849400E-03,   9.6668964E-03,   1.0868316E-02
     +,   1.2067308E-02,   1.3260289E-02,   1.4478123E-02
     +,   1.5802482E-02,   1.7377965E-02,   1.9415146E-02
     +,   2.2178860E-02,   2.5954382E-02,   3.0985007E-02
     +,   3.7386447E-02,   4.5073330E-02,   5.3766988E-02
     +,   6.3151382E-02,   7.3164850E-02,   8.4269457E-02
     +,   9.7432666E-02,   0.1136649    ,   0.1332651    
     +,   0.1552118    ,   0.1771119    ,   0.1957724    
     +,   0.2080898    ,   0.2118631    ,   0.2063045    
     +,   0.1921931    ,   0.1716373    ,   0.1474656    
     +,   0.1224536    ,   9.8722510E-02,   7.7535979E-02
     +,   5.9468489E-02,   4.4685937E-02,   3.3121709E-02
     +,   2.4516985E-02,   1.8422460E-02,   1.4250556E-02
     +,   1.1386422E-02,   9.3054203E-03,   7.6428223E-03
     +,   6.1992859E-03,   4.9010487E-03,   3.7452308E-03
     +,   2.7533812E-03,   1.9426743E-03,   1.3138867E-03
     +,   8.5132336E-04,   5.2833586E-04,   3.1402818E-04
     +,   1.7874992E-04,   9.7437565E-05,   5.0864586E-05
     +,   2.5428610E-05,   1.2174133E-05,   5.5815008E-06
     +,   2.4505912E-06,   1.0304125E-06,   4.1491558E-07
     +,   1.5999352E-07,   5.9083671E-08,   2.0894916E-08
     +,   7.0763111E-09,   2.2949900E-09,   7.1281703E-10
     +,   2.1202376E-10,   6.0392316E-11,   1.6473505E-11
     +,   4.3034487E-12,   1.0766022E-12,   2.5791823E-13
     +,   5.9172204E-14,   1.3001138E-14,   2.7356034E-15
     +,   5.5120224E-16,   1.0636555E-16,   1.9656344E-17
     +,   3.4785331E-18,   5.8955225E-19,   9.5712287E-20
     +,   1.4890274E-20,   2.2232539E-21,   3.2042361E-22
     +,   4.5505754E-23,   6.8259046E-24,   1.2875705E-24
     +,   3.6694654E-25,   1.4587839E-25,   6.6378738E-26
     +,   3.1273161E-26,   1.4801544E-26,   6.9847547E-27
     +,   3.2804396E-27,   1.5328346E-27,   7.1256442E-28
     +,   3.2952750E-28,   1.5159671E-28,   6.9378503E-29
     +,   3.1587616E-29,   1.4306962E-29,   6.4462673E-30
     +,   2.8894783E-30,   1.2884250E-30,   5.7154980E-31
     +,   2.5221698E-31,   1.1072562E-31,   4.8356202E-32
     +,   2.1009055E-32,   9.0800407E-33,   3.9041147E-33
     +,   1.6699021E-33,   7.1056916E-34,   3.0079130E-34
     +,   1.2666244E-34,   5.3062446E-35,   2.2113477E-35
     +,   9.1680488E-36,   3.7811497E-36,   1.5514018E-36
     +,   6.3321584E-37,   2.5712008E-37,   1.0385896E-37
     +,   4.1735489E-38,   1.6683889E-38,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_haonly_ttz100_mass = Yx/0.761673652173913
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_haonly_ttz105_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.3231735E-03,   2.3898052E-03
     +,   2.4558865E-03,   2.5212748E-03,   2.5858274E-03
     +,   2.6494011E-03,   2.7118525E-03,   2.7730402E-03
     +,   2.8328225E-03,   2.8910637E-03,   2.9476266E-03
     +,   3.0023803E-03,   3.0551967E-03,   3.1059524E-03
     +,   3.1545300E-03,   3.2008167E-03,   3.2447078E-03
     +,   3.2861033E-03,   3.3249117E-03,   3.3610489E-03
     +,   3.3944391E-03,   3.4250149E-03,   3.4527162E-03
     +,   3.4774942E-03,   3.4993070E-03,   3.5181243E-03
     +,   3.5339228E-03,   3.5466894E-03,   3.5564220E-03
     +,   3.5631256E-03,   3.5668151E-03,   3.5675156E-03
     +,   3.5652597E-03,   3.5600881E-03,   3.5520534E-03
     +,   3.5412107E-03,   3.5276271E-03,   3.5113755E-03
     +,   3.4925342E-03,   3.4711894E-03,   3.4474323E-03
     +,   3.4213595E-03,   3.3930719E-03,   3.3626747E-03
     +,   3.3302766E-03,   3.2959890E-03,   3.2599261E-03
     +,   3.2222038E-03,   3.1829383E-03,   3.1422472E-03
     +,   3.1002483E-03,   3.0570587E-03,   3.0127957E-03
     +,   2.9675711E-03,   2.9215012E-03,   2.8746936E-03
     +,   2.8272576E-03,   2.7792973E-03,   2.7309142E-03
     +,   2.6822051E-03,   2.6332648E-03,   2.5841801E-03
     +,   2.5350391E-03,   2.4859197E-03,   2.4368963E-03
     +,   2.3880422E-03,   2.3394199E-03,   2.2910940E-03
     +,   2.2431163E-03,   2.1955417E-03,   2.1484131E-03
     +,   2.1017753E-03,   2.0556620E-03,   2.0101091E-03
     +,   1.9651430E-03,   1.9207868E-03,   1.8770621E-03
     +,   1.8339872E-03,   1.7915735E-03,   1.7498293E-03
     +,   1.7087645E-03,   1.6683805E-03,   1.6286812E-03
     +,   1.5896632E-03,   1.5513260E-03,   1.5136627E-03
     +,   1.4766693E-03,   1.4403354E-03,   1.4046545E-03
     +,   1.3696154E-03,   1.3352066E-03,   1.3014172E-03
     +,   1.2682371E-03,   1.2356531E-03,   1.2036515E-03
     +,   1.1722228E-03,   1.1413527E-03,   1.1110314E-03
     +,   1.0812455E-03,   1.0519858E-03,   1.0232400E-03
     +,   9.9499978E-04,   9.6725399E-04,   9.3999581E-04
     +,   9.1321603E-04,   8.8690652E-04,   8.6106121E-04
     +,   8.3567528E-04,   8.1074244E-04,   7.8625733E-04
     +,   7.6221791E-04,   7.3861959E-04,   7.1546203E-04
     +,   6.9274259E-04,   6.7046279E-04,   6.4862228E-04
     +,   6.2722526E-04,   6.0627511E-04,   5.8577966E-04
     +,   5.6574808E-04,   5.4619275E-04,   5.2713190E-04
     +,   5.0858920E-04,   4.9059401E-04,   4.7318437E-04
     +,   4.5641037E-04,   4.4033301E-04,   4.2503097E-04
     +,   4.1059937E-04,   3.9715727E-04,   3.8484798E-04
     +,   3.7384598E-04,   3.6435816E-04,   3.5663112E-04
     +,   3.5095250E-04,   3.4765591E-04,   3.4712453E-04
     +,   3.4979175E-04,   3.5614287E-04,   3.6671478E-04
     +,   3.8209162E-04,   4.0289969E-04,   4.2980086E-04
     +,   4.6348144E-04,   5.0463376E-04,   5.5394473E-04
     +,   6.1207364E-04,   6.7962415E-04,   7.5712084E-04
     +,   8.4498880E-04,   9.4352243E-04,   1.0528526E-03
     +,   1.1729277E-03,   1.3035046E-03,   1.4441323E-03
     +,   1.5941360E-03,   1.7526381E-03,   1.9185891E-03
     +,   2.0908022E-03,   2.2679875E-03,   2.4488664E-03
     +,   2.6322531E-03,   2.8171581E-03,   3.0029444E-03
     +,   3.1894986E-03,   3.3773929E-03,   3.5680812E-03
     +,   3.7641088E-03,   3.9693518E-03,   4.1892407E-03
     +,   4.4309753E-03,   4.7037853E-03,   5.0191805E-03
     +,   5.3911866E-03,   5.8365334E-03,   6.3749379E-03
     +,   7.0292684E-03,   7.8256298E-03,   8.7934481E-03
     +,   9.9654803E-03,   1.1377578E-02,   1.3068143E-02
     +,   1.5077462E-02,   1.7446810E-02,   2.0216946E-02
     +,   2.3426007E-02,   2.7107336E-02,   3.1287022E-02
     +,   3.5980735E-02,   4.1189924E-02,   4.6899546E-02
     +,   5.3074744E-02,   5.9657928E-02,   6.6567570E-02
     +,   7.3698312E-02,   8.0921426E-02,   8.8086940E-02
     +,   9.5028229E-02,   0.1015681    ,   0.1075258    
     +,   0.1127238    ,   0.1169981    ,   0.1202056    
     +,   0.1222328    ,   0.1230012    ,   0.1224730    
     +,   0.1206532    ,   0.1175899    ,   0.1133719    
     +,   0.1081239    ,   0.1020001    ,   9.5176242E-02
     +,   8.7841228E-02,   8.0186941E-02,   7.2400413E-02
     +,   6.4656600E-02,   5.7111681E-02,   4.9897823E-02
     +,   4.3120988E-02,   3.6860380E-02,   3.1167608E-02
     +,   2.6069246E-02,   2.1569928E-02,   1.7655460E-02
     +,   1.4296446E-02,   1.1452580E-02,   9.0764835E-03
     +,   7.1167662E-03,   5.5208039E-03,   4.2371843E-03
     +,   3.2174687E-03,   2.4172319E-03,   1.7967336E-03
     +,   1.3213013E-03,   9.6133671E-04,   6.9197663E-04
     +,   4.9275841E-04,   3.4713247E-04,   2.4191667E-04
     +,   1.6677298E-04,   1.1372433E-04,   7.6707649E-05
     +,   5.1176878E-05,   3.3770906E-05,   2.2041195E-05
     +,   1.4228605E-05,   9.0855538E-06,   5.7390721E-06
     +,   3.5868093E-06,   2.2187337E-06,   1.3591140E-06
     +,   8.2513162E-07,   4.9716294E-07,   2.9792164E-07
     +,   1.7812485E-07,   1.0677021E-07,   6.4607477E-08
     +,   3.9833850E-08,   2.5304884E-08,   1.6752677E-08
     +,   1.1659226E-08,   8.5562215E-09,   6.5971344E-09
     +,   5.2990314E-09,   4.3887356E-09,   3.7123773E-09
     +,   3.1833465E-09,   2.7525289E-09,   2.3914983E-09
     +,   2.0832067E-09,   1.8168739E-09,   1.5852490E-09
     +,   1.3830758E-09,   1.2062831E-09,   1.0515704E-09
     +,   9.1617841E-10,   7.9771745E-10,   6.9412615E-10
     +,   6.0358468E-10,   5.2450333E-10,   4.5547471E-10
     +,   3.9526582E-10,   3.4278202E-10,   2.9706715E-10
     +,   2.5727334E-10,   2.2266000E-10,   1.9257307E-10
     +,   1.6643828E-10,   1.4375337E-10,   1.2407558E-10
     +,   1.0701943E-10,   9.2244899E-11,   7.9456546E-11
     +,   6.8394387E-11,   5.8832710E-11,   5.0573323E-11
     +,   4.3444196E-11,   3.7294483E-11,   3.1993807E-11
     +,   2.7427781E-11,   2.3497617E-11
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_haonly_ttz105_mass = Yx/0.814202869565217
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_haonly_ttz107_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.6456974E-30,   6.5414414E-30
     +,   1.6068229E-29,   3.9212159E-29,   9.5068332E-29
     +,   2.2898797E-28,   5.4796121E-28,   1.3027098E-27
     +,   3.0768223E-27,   7.2197914E-27,   1.6830911E-26
     +,   3.8981001E-26,   8.9693201E-26,   2.0503601E-25
     +,   4.6565079E-25,   1.0506389E-24,   2.3551001E-24
     +,   5.2447756E-24,   1.1603959E-23,   2.5506372E-23
     +,   5.5700068E-23,   1.2084357E-22,   2.6046423E-22
     +,   5.5776081E-22,   1.1865876E-21,   2.5079516E-21
     +,   5.2662599E-21,   1.0986218E-20,   2.2769757E-20
     +,   4.6884823E-20,   9.5911256E-20,   1.9492661E-19
     +,   3.9358094E-19,   7.8951980E-19,   1.5734655E-18
     +,   3.1153944E-18,   6.1282329E-18,   1.1976118E-17
     +,   2.3252540E-17,   4.4851831E-17,   8.5952880E-17
     +,   1.6364556E-16,   3.0953739E-16,   5.8168463E-16
     +,   1.0859899E-15,   2.0143295E-15,   3.7119343E-15
     +,   6.7957225E-15,   1.2360487E-14,   2.2335805E-14
     +,   4.0098990E-14,   7.1520562E-14,   1.2673322E-13
     +,   2.2311239E-13,   3.9022488E-13,   6.7807332E-13
     +,   1.1705902E-12,   2.0077013E-12,   3.4210510E-12
     +,   5.7914567E-12,   9.7405053E-12,   1.6275932E-11
     +,   2.7019033E-11,   4.4561639E-11,   7.3017391E-11
     +,   1.1886442E-10,   1.9224329E-10,   3.0889527E-10
     +,   4.9311211E-10,   7.8206008E-10,   1.2322808E-09
     +,   1.9290352E-09,   3.0001626E-09,   4.6356541E-09
     +,   7.1161512E-09,   1.0853092E-08,   1.6444835E-08
     +,   2.4755314E-08,   3.7023312E-08,   5.5011849E-08
     +,   8.1208270E-08,   1.1910176E-07,   1.7353992E-07
     +,   2.5122006E-07,   3.6130425E-07,   5.1625676E-07
     +,   7.3286174E-07,   1.0335993E-06,   1.4482606E-06
     +,   2.0160930E-06,   2.7883548E-06,   3.8313760E-06
     +,   5.2302935E-06,   7.0936071E-06,   9.5583255E-06
     +,   1.2795633E-05,   1.7018268E-05,   2.2487164E-05
     +,   2.9520757E-05,   3.8502254E-05,   4.9890547E-05
     +,   6.4226864E-05,   8.2146413E-05,   1.0438228E-04
     +,   1.3177564E-04,   1.6527863E-04,   2.0595310E-04
     +,   2.5496876E-04,   3.1359986E-04,   3.8321083E-04
     +,   4.6522944E-04,   5.6113786E-04,   6.7241845E-04
     +,   8.0053927E-04,   9.4687706E-04,   1.1126979E-03
     +,   1.2990602E-03,   1.5067942E-03,   1.7363898E-03
     +,   1.9879767E-03,   2.2612475E-03,   2.5553813E-03
     +,   2.8690149E-03,   3.2002295E-03,   3.5465215E-03
     +,   3.9047617E-03,   4.2713000E-03,   4.6419166E-03
     +,   5.0119800E-03,   5.3764414E-03,   5.7300376E-03
     +,   6.0673184E-03,   6.3828817E-03,   6.6714305E-03
     +,   6.9280025E-03,   7.1480824E-03,   7.3277331E-03
     +,   7.4637453E-03,   7.5537609E-03,   7.5963344E-03
     +,   7.5909998E-03,   7.5383121E-03,   7.4398401E-03
     +,   7.2981291E-03,   7.1166619E-03,   6.8997489E-03
     +,   6.6524185E-03,   6.3803205E-03,   6.0895672E-03
     +,   5.7865605E-03,   5.4778703E-03,   5.1701046E-03
     +,   4.8697498E-03,   4.5830337E-03,   4.3158317E-03
     +,   4.0735989E-03,   3.8612697E-03,   3.6831917E-03
     +,   3.5431068E-03,   3.4441310E-03,   3.3887068E-03
     +,   3.3786113E-03,   3.4149394E-03,   3.4980748E-03
     +,   3.6276779E-03,   3.8026571E-03,   4.0211058E-03
     +,   4.2802650E-03,   4.5764898E-03,   4.9051968E-03
     +,   5.2608098E-03,   5.6367684E-03,   6.0255909E-03
     +,   6.4189243E-03,   6.8076393E-03,   7.1820882E-03
     +,   7.5323214E-03,   7.8483615E-03,   8.1205741E-03
     +,   8.3400626E-03,   8.4990114E-03,   8.5910466E-03
     +,   8.6115794E-03,   8.5580824E-03,   8.4303003E-03
     +,   8.2305027E-03,   7.9637980E-03,   7.6387576E-03
     +,   7.2687268E-03,   6.8744072E-03,   6.4883516E-03
     +,   6.1624791E-03,   5.9793931E-03,   6.0677864E-03
     +,   6.6212690E-03,   7.9179313E-03,   1.0334842E-02
     +,   1.4349187E-02,   2.0515935E-02,   2.9411370E-02
     +,   4.1536245E-02,   5.7183832E-02,   7.6289684E-02
     +,   9.8290078E-02,   0.1220299    ,   0.1457736    
     +,   0.1673411    ,   0.1843853    ,   0.1947829    
     +,   0.1970552    ,   0.1907070    ,   0.1763804    
     +,   0.1557584    ,   0.1312297    ,   0.1054154    
     +,   8.0691703E-02,   5.8830976E-02,   4.0836271E-02
     +,   2.6975058E-02,   1.6950384E-02,   1.0127194E-02
     +,   5.7498990E-03,   3.1006974E-03,   1.5872542E-03
     +,   7.7085174E-04,   3.5499004E-04,   1.5498116E-04
     +,   6.4158470E-05,   2.5212845E-05,   9.4347170E-06
     +,   3.3869230E-06,   1.1856625E-06,   4.1835966E-07
     +,   1.5737663E-07,   6.7363025E-08,   3.3761676E-08
     +,   1.9195571E-08,   1.1712657E-08,   7.3600370E-09
     +,   4.6624620E-09,   2.9504781E-09,   1.8585974E-09
     +,   1.1639503E-09,   7.2430317E-10,   4.4775966E-10
     +,   2.7495603E-10,   1.6770536E-10,   1.0159188E-10
     +,   6.1117729E-11,   3.6514337E-11,   2.1663112E-11
     +,   1.2761900E-11,   7.4651899E-12,   4.3360246E-12
     +,   2.5006399E-12,   1.4318617E-12,   8.1403433E-13
     +,   4.5949301E-13,   2.5751046E-13,   1.4327810E-13
     +,   7.9147761E-14,   4.3408623E-14,   2.3636366E-14
     +,   1.2777449E-14,   6.8577507E-15,   3.6541281E-15
     +,   1.9330270E-15,   1.0152100E-15,   5.2935186E-16
     +,   2.7402755E-16,   1.4083044E-16,   7.1855254E-17
     +,   3.6399110E-17,   1.8305638E-17,   9.1395889E-18
     +,   4.5304451E-18,   2.2294829E-18,   1.0892765E-18
     +,   5.2835128E-19,   2.5443471E-19,   1.2164116E-19
     +,   5.7736922E-20,   2.7206801E-20,   1.2728338E-20
     +,   5.9117120E-21,   2.7260177E-21,   1.2479665E-21
     +,   5.6718695E-22,   2.5592829E-22,   1.1464699E-22
     +,   5.0989113E-23,   2.2513235E-23,   9.8690167E-24
     +,   4.2949236E-24,   1.8557061E-24,   7.9599778E-25
     +,   3.3898724E-25,   1.4331956E-25,   6.0158884E-26
     +,   2.5069346E-26,   1.0371862E-26
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_haonly_ttz107_mass = Yx/0.659002909090909
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_haonly_ttz110_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.6690813E-03,   1.7489668E-03
     +,   1.8309877E-03,   1.9150891E-03,   2.0012073E-03
     +,   2.0892699E-03,   2.1791954E-03,   2.2708934E-03
     +,   2.3642634E-03,   2.4591992E-03,   2.5555820E-03
     +,   2.6532852E-03,   2.7521725E-03,   2.8521009E-03
     +,   2.9529175E-03,   3.0544610E-03,   3.1565635E-03
     +,   3.2590488E-03,   3.3617339E-03,   3.4644299E-03
     +,   3.5669417E-03,   3.6690685E-03,   3.7706043E-03
     +,   3.8713454E-03,   3.9710733E-03,   4.0695793E-03
     +,   4.1666455E-03,   4.2620562E-03,   4.3555959E-03
     +,   4.4470504E-03,   4.5362082E-03,   4.6228594E-03
     +,   4.7068000E-03,   4.7878302E-03,   4.8657572E-03
     +,   4.9403938E-03,   5.0115623E-03,   5.0790929E-03
     +,   5.1428280E-03,   5.2026147E-03,   5.2583190E-03
     +,   5.3098141E-03,   5.3569870E-03,   5.3997394E-03
     +,   5.4379865E-03,   5.4716556E-03,   5.5006929E-03
     +,   5.5250567E-03,   5.5447216E-03,   5.5596801E-03
     +,   5.5699362E-03,   5.5755116E-03,   5.5764457E-03
     +,   5.5727893E-03,   5.5646105E-03,   5.5519934E-03
     +,   5.5350331E-03,   5.5138418E-03,   5.4885424E-03
     +,   5.4592723E-03,   5.4261792E-03,   5.3894231E-03
     +,   5.3491760E-03,   5.3056143E-03,   5.2589267E-03
     +,   5.2093090E-03,   5.1569617E-03,   5.1020947E-03
     +,   5.0449185E-03,   4.9856501E-03,   4.9245059E-03
     +,   4.8617087E-03,   4.7974745E-03,   4.7320272E-03
     +,   4.6655843E-03,   4.5983577E-03,   4.5305640E-03
     +,   4.4624140E-03,   4.3941066E-03,   4.3258397E-03
     +,   4.2578066E-03,   4.1901884E-03,   4.1231643E-03
     +,   4.0568975E-03,   3.9915494E-03,   3.9272653E-03
     +,   3.8641868E-03,   3.8024373E-03,   3.7421384E-03
     +,   3.6833936E-03,   3.6262954E-03,   3.5709285E-03
     +,   3.5173653E-03,   3.4656639E-03,   3.4158700E-03
     +,   3.3680226E-03,   3.3221429E-03,   3.2782459E-03
     +,   3.2363303E-03,   3.1963883E-03,   3.1583963E-03
     +,   3.1223255E-03,   3.0881318E-03,   3.0557644E-03
     +,   3.0251625E-03,   2.9962533E-03,   2.9689604E-03
     +,   2.9431970E-03,   2.9188686E-03,   2.8958735E-03
     +,   2.8741069E-03,   2.8534548E-03,   2.8338009E-03
     +,   2.8150231E-03,   2.7969996E-03,   2.7796002E-03
     +,   2.7626981E-03,   2.7461632E-03,   2.7298660E-03
     +,   2.7136772E-03,   2.6974671E-03,   2.6811121E-03
     +,   2.6644876E-03,   2.6474751E-03,   2.6299572E-03
     +,   2.6118264E-03,   2.5929764E-03,   2.5733113E-03
     +,   2.5527382E-03,   2.5311757E-03,   2.5085483E-03
     +,   2.4847924E-03,   2.4598499E-03,   2.4336791E-03
     +,   2.4062456E-03,   2.3775292E-03,   2.3475252E-03
     +,   2.3162432E-03,   2.2837115E-03,   2.2499766E-03
     +,   2.2151105E-03,   2.1792133E-03,   2.1424147E-03
     +,   2.1048819E-03,   2.0668313E-03,   2.0285302E-03
     +,   1.9903095E-03,   1.9525817E-03,   1.9158492E-03
     +,   1.8807244E-03,   1.8479478E-03,   1.8184154E-03
     +,   1.7932011E-03,   1.7735824E-03,   1.7610756E-03
     +,   1.7574669E-03,   1.7648462E-03,   1.7856410E-03
     +,   1.8226547E-03,   1.8790931E-03,   1.9586000E-03
     +,   2.0652832E-03,   2.2037223E-03,   2.3789792E-03
     +,   2.5966067E-03,   2.8626288E-03,   3.1834845E-03
     +,   3.5659822E-03,   4.0172576E-03,   4.5446632E-03
     +,   5.1556057E-03,   5.8574309E-03,   6.6573033E-03
     +,   7.5619905E-03,   8.5775573E-03,   9.7093154E-03
     +,   1.0961523E-02,   1.2337046E-02,   1.3837192E-02
     +,   1.5461587E-02,   1.7207881E-02,   1.9071449E-02
     +,   2.1045327E-02,   2.3120241E-02,   2.5284451E-02
     +,   2.7523573E-02,   2.9820800E-02,   3.2157168E-02
     +,   3.4511607E-02,   3.6860969E-02,   3.9180845E-02
     +,   4.1445673E-02,   4.3629050E-02,   4.5704402E-02
     +,   4.7645576E-02,   4.9427252E-02,   5.1025368E-02
     +,   5.2417759E-02,   5.3584769E-02,   5.4509550E-02
     +,   5.5178400E-02,   5.5581238E-02,   5.5711813E-02
     +,   5.5567797E-02,   5.5150911E-02,   5.4466844E-02
     +,   5.3525124E-02,   5.2338969E-02,   5.0924990E-02
     +,   4.9302604E-02,   4.7493771E-02,   4.5522556E-02
     +,   4.3414548E-02,   4.1196115E-02,   3.8894061E-02
     +,   3.6535155E-02,   3.4145564E-02,   3.1750172E-02
     +,   2.9372366E-02,   2.7033890E-02,   2.4754107E-02
     +,   2.2550032E-02,   2.0436319E-02,   1.8425042E-02
     +,   1.6525574E-02,   1.4744779E-02,   1.3087255E-02
     +,   1.1555325E-02,   1.0149176E-02,   8.8671818E-03
     +,   7.7062263E-03,   6.6618458E-03,   5.7284278E-03
     +,   4.8995432E-03,   4.1682413E-03,   3.5271070E-03
     +,   2.9685472E-03,   2.4849919E-03,   2.0689878E-03
     +,   1.7133037E-03,   1.4110591E-03,   1.1558125E-03
     +,   9.4158138E-04,   7.6286582E-04,   6.1468058E-04
     +,   4.9256039E-04,   3.9253282E-04,   3.1109323E-04
     +,   2.4518563E-04,   1.9217237E-04,   1.4978586E-04
     +,   1.1609848E-04,   8.9486428E-05,   6.8590401E-05
     +,   5.2280255E-05,   3.9625400E-05,   2.9865691E-05
     +,   2.2383969E-05,   1.6682539E-05,   1.2363575E-05
     +,   9.1114598E-06,   6.6773077E-06,   4.8661391E-06
     +,   3.5264675E-06,   2.5414777E-06,   1.8215122E-06
     +,   1.2983462E-06,   9.2042666E-07,   6.4902730E-07
     +,   4.5524527E-07,   3.1767351E-07,   2.2056555E-07
     +,   1.5240578E-07,   1.0482594E-07,   7.1789891E-08
     +,   4.8973241E-08,   3.3292661E-08,   2.2568265E-08
     +,   1.5265561E-08,   1.0313146E-08,   6.9661237E-09
     +,   4.7106647E-09,   3.1937675E-09,   2.1746969E-09
     +,   1.4898957E-09,   1.0289918E-09,   7.1773409E-10
     +,   5.0642873E-10,   3.6194053E-10,   2.6220692E-10
     +,   1.9258728E-10,   1.4335148E-10,   1.0803731E-10
     +,   8.2331454E-11,   6.3345933E-11,   4.9127306E-11
     +,   3.8344380E-11,   3.0076126E-11,   2.3677643E-11
     +,   1.8688672E-11,   1.4776189E-11
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_haonly_ttz110_mass = Yx/0.604086
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_haonly_ttz115_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.8526125E-04,   3.0271421E-04
     +,   3.2090076E-04,   3.3982628E-04,   3.5949398E-04
     +,   3.7990513E-04,   4.0105876E-04,   4.2295139E-04
     +,   4.4557708E-04,   4.6892816E-04,   4.9299380E-04
     +,   5.1776058E-04,   5.4321240E-04,   5.6933105E-04
     +,   5.9609534E-04,   6.2348152E-04,   6.5146363E-04
     +,   6.8001333E-04,   7.0909981E-04,   7.3869049E-04
     +,   7.6875096E-04,   7.9924508E-04,   8.3013496E-04
     +,   8.6138403E-04,   8.9295139E-04,   9.2479965E-04
     +,   9.5688982E-04,   9.8918425E-04,   1.0216470E-03
     +,   1.0542438E-03,   1.0869437E-03,   1.1197190E-03
     +,   1.1525464E-03,   1.1854079E-03,   1.2182909E-03
     +,   1.2511903E-03,   1.2841088E-03,   1.3170567E-03
     +,   1.3500570E-03,   1.3831385E-03,   1.4163459E-03
     +,   1.4497343E-03,   1.4833721E-03,   1.5173418E-03
     +,   1.5517409E-03,   1.5866823E-03,   1.6222941E-03
     +,   1.6587215E-03,   1.6961250E-03,   1.7346824E-03
     +,   1.7745869E-03,   1.8160482E-03,   1.8592896E-03
     +,   1.9045515E-03,   1.9520826E-03,   2.0021473E-03
     +,   2.0550170E-03,   2.1109714E-03,   2.1702938E-03
     +,   2.2332713E-03,   2.3001889E-03,   2.3713280E-03
     +,   2.4469576E-03,   2.5273405E-03,   2.6127230E-03
     +,   2.7033226E-03,   2.7993433E-03,   2.9009469E-03
     +,   3.0082732E-03,   3.1214093E-03,   3.2404140E-03
     +,   3.3652820E-03,   3.4959717E-03,   3.6323699E-03
     +,   3.7743170E-03,   3.9215907E-03,   4.0738969E-03
     +,   4.2308732E-03,   4.3921019E-03,   4.5570973E-03
     +,   4.7252919E-03,   4.8960755E-03,   5.0687524E-03
     +,   5.2425885E-03,   5.4167756E-03,   5.5904738E-03
     +,   5.7627796E-03,   5.9327721E-03,   6.0994793E-03
     +,   6.2619234E-03,   6.4191134E-03,   6.5700435E-03
     +,   6.7137149E-03,   6.8491530E-03,   6.9754091E-03
     +,   7.0915557E-03,   7.1967291E-03,   7.2901053E-03
     +,   7.3709376E-03,   7.4385386E-03,   7.4923141E-03
     +,   7.5317482E-03,   7.5564240E-03,   7.5660204E-03
     +,   7.5603202E-03,   7.5392113E-03,   7.5026890E-03
     +,   7.4508581E-03,   7.3839249E-03,   7.3021995E-03
     +,   7.2061024E-03,   7.0961365E-03,   6.9729094E-03
     +,   6.8371003E-03,   6.6894786E-03,   6.5308665E-03
     +,   6.3621644E-03,   6.1843023E-03,   5.9982743E-03
     +,   5.8050863E-03,   5.6057661E-03,   5.4013645E-03
     +,   5.1929341E-03,   4.9815052E-03,   4.7680913E-03
     +,   4.5536994E-03,   4.3392763E-03,   4.1257557E-03
     +,   3.9139967E-03,   3.7048317E-03,   3.4990094E-03
     +,   3.2972440E-03,   3.1001586E-03,   2.9083372E-03
     +,   2.7222752E-03,   2.5424028E-03,   2.3690930E-03
     +,   2.2026533E-03,   2.0433154E-03,   1.8912496E-03
     +,   1.7465786E-03,   1.6093689E-03,   1.4796288E-03
     +,   1.3573202E-03,   1.2423801E-03,   1.1346994E-03
     +,   1.0341461E-03,   9.4057911E-04,   8.5385365E-04
     +,   7.7382865E-04,   7.0039189E-04,   6.3348468E-04
     +,   5.7312421E-04,   5.1943219E-04,   4.7268340E-04
     +,   4.3335799E-04,   4.0219972E-04,   3.8028831E-04
     +,   3.6912959E-04,   3.7075390E-04,   3.8782414E-04
     +,   4.2375861E-04,   4.8285190E-04,   5.7039672E-04
     +,   6.9280731E-04,   8.5771532E-04,   1.0740254E-03
     +,   1.3519408E-03,   1.7029551E-03,   2.1397478E-03
     +,   2.6759680E-03,   3.3259788E-03,   4.1045463E-03
     +,   5.0263656E-03,   6.1054206E-03,   7.3545636E-03
     +,   8.7847961E-03,   1.0404515E-02,   1.2218947E-02
     +,   1.4229679E-02,   1.6434142E-02,   1.8825071E-02
     +,   2.1390455E-02,   2.4113722E-02,   2.6973803E-02
     +,   2.9945269E-02,   3.2999057E-02,   3.6103353E-02
     +,   3.9224152E-02,   4.2325735E-02,   4.5372073E-02
     +,   4.8327323E-02,   5.1156182E-02,   5.3824771E-02
     +,   5.6301113E-02,   5.8555357E-02,   6.0559712E-02
     +,   6.2288918E-02,   6.3720308E-02,   6.4833835E-02
     +,   6.5612197E-02,   6.6041112E-02,   6.6109717E-02
     +,   6.5810874E-02,   6.5141708E-02,   6.4104103E-02
     +,   6.2705167E-02,   6.0957808E-02,   5.8881011E-02
     +,   5.6499712E-02,   5.3844843E-02,   5.0953023E-02
     +,   4.7865722E-02,   4.4628117E-02,   4.1287977E-02
     +,   3.7894510E-02,   3.4496702E-02,   3.1141493E-02
     +,   2.7872633E-02,   2.4729710E-02,   2.1746434E-02
     +,   1.8950259E-02,   1.6362092E-02,   1.3995963E-02
     +,   1.1859076E-02,   9.9524632E-03,   8.2717706E-03
     +,   6.8079359E-03,   5.5480502E-03,   4.4764644E-03
     +,   3.5757774E-03,   2.8276185E-03,   2.2133819E-03
     +,   1.7149416E-03,   1.3151799E-03,   9.9825230E-04
     +,   7.4988161E-04,   5.5748073E-04,   4.1014864E-04
     +,   2.9861345E-04,   2.1513808E-04,   1.5337631E-04
     +,   1.0820003E-04,   7.5528485E-05,   5.2166866E-05
     +,   3.5651436E-05,   2.4107710E-05,   1.6129477E-05
     +,   1.0677223E-05,   6.9932094E-06,   4.5317338E-06
     +,   2.9054340E-06,   1.8429714E-06,   1.1566182E-06
     +,   7.1815066E-07,   4.4114884E-07,   2.6810352E-07
     +,   1.6120275E-07,   9.5892716E-08,   5.6432832E-08
     +,   3.2856160E-08,   1.8925480E-08,   1.0784819E-08
     +,   6.0800263E-09,   3.3911047E-09,   1.8711643E-09
     +,   1.0214372E-09,   5.5163474E-10,   2.9474642E-10
     +,   1.5581403E-10,   8.1495845E-11,   4.2177487E-11
     +,   2.1602668E-11,   1.0952230E-11,   5.4981119E-12
     +,   2.7348059E-12,   1.3491695E-12,   6.6130462E-13
     +,   3.2296640E-13,   1.5790757E-13,   7.7871296E-14
     +,   3.9174345E-14,   2.0413443E-14,   1.1214126E-14
     +,   6.5914342E-15,   4.1699733E-15,   2.8228921E-15
     +,   2.0161483E-15,   1.4948389E-15,   1.1348554E-15
     +,   8.7361596E-16,   6.7763695E-16,   5.2763525E-16
     +,   4.1150571E-16,   3.2106903E-16,   2.5043837E-16
     +,   1.9522370E-16,   1.5205487E-16,   1.1832210E-16
     +,   9.1981525E-17,   7.1432770E-17
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_haonly_ttz115_mass = Yx/0.604086
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_haonly_ttz120_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.7774323E-03,   2.8551896E-03
     +,   2.9347506E-03,   3.0160942E-03,   3.0991910E-03
     +,   3.1840056E-03,   3.2704929E-03,   3.3586009E-03
     +,   3.4482668E-03,   3.5394244E-03,   3.6319930E-03
     +,   3.7258861E-03,   3.8210065E-03,   3.9172489E-03
     +,   4.0144986E-03,   4.1126315E-03,   4.2115157E-03
     +,   4.3110079E-03,   4.4109598E-03,   4.5112120E-03
     +,   4.6115983E-03,   4.7119441E-03,   4.8120678E-03
     +,   4.9117873E-03,   5.0109001E-03,   5.1092142E-03
     +,   5.2065235E-03,   5.3026197E-03,   5.3972928E-03
     +,   5.4903296E-03,   5.5815144E-03,   5.6706332E-03
     +,   5.7574697E-03,   5.8418103E-03,   5.9234435E-03
     +,   6.0021621E-03,   6.0777594E-03,   6.1500371E-03
     +,   6.2188050E-03,   6.2838723E-03,   6.3450658E-03
     +,   6.4022150E-03,   6.4551607E-03,   6.5037534E-03
     +,   6.5478580E-03,   6.5873484E-03,   6.6221128E-03
     +,   6.6520539E-03,   6.6770851E-03,   6.6971397E-03
     +,   6.7121591E-03,   6.7221061E-03,   6.7269551E-03
     +,   6.7266989E-03,   6.7213438E-03,   6.7109130E-03
     +,   6.6954461E-03,   6.6749956E-03,   6.6496325E-03
     +,   6.6194413E-03,   6.5845209E-03,   6.5449849E-03
     +,   6.5009622E-03,   6.4525935E-03,   6.4000282E-03
     +,   6.3434364E-03,   6.2829908E-03,   6.2188795E-03
     +,   6.1512971E-03,   6.0804524E-03,   6.0065533E-03
     +,   5.9298254E-03,   5.8504888E-03,   5.7687815E-03
     +,   5.6849364E-03,   5.5991895E-03,   5.5117849E-03
     +,   5.4229707E-03,   5.3329864E-03,   5.2420748E-03
     +,   5.1504821E-03,   5.0584469E-03,   4.9662101E-03
     +,   4.8740013E-03,   4.7820564E-03,   4.6905940E-03
     +,   4.5998394E-03,   4.5099990E-03,   4.4212807E-03
     +,   4.3338798E-03,   4.2479793E-03,   4.1637593E-03
     +,   4.0813899E-03,   4.0010242E-03,   3.9228047E-03
     +,   3.8468689E-03,   3.7733314E-03,   3.7023046E-03
     +,   3.6338766E-03,   3.5681317E-03,   3.5051305E-03
     +,   3.4449287E-03,   3.3875580E-03,   3.3330424E-03
     +,   3.2813870E-03,   3.2325799E-03,   3.1865982E-03
     +,   3.1434041E-03,   3.1029424E-03,   3.0651414E-03
     +,   3.0299223E-03,   2.9971842E-03,   2.9668203E-03
     +,   2.9387055E-03,   2.9127060E-03,   2.8886755E-03
     +,   2.8664581E-03,   2.8458880E-03,   2.8267934E-03
     +,   2.8089944E-03,   2.7923041E-03,   2.7765343E-03
     +,   2.7614932E-03,   2.7469876E-03,   2.7328259E-03
     +,   2.7188198E-03,   2.7047838E-03,   2.6905432E-03
     +,   2.6759286E-03,   2.6607865E-03,   2.6449752E-03
     +,   2.6283755E-03,   2.6108865E-03,   2.5924358E-03
     +,   2.5729812E-03,   2.5525149E-03,   2.5310752E-03
     +,   2.5087469E-03,   2.4856722E-03,   2.4620558E-03
     +,   2.4381834E-03,   2.4144237E-03,   2.3912434E-03
     +,   2.3692236E-03,   2.3490733E-03,   2.3316427E-03
     +,   2.3179445E-03,   2.3091715E-03,   2.3067142E-03
     +,   2.3121808E-03,   2.3274175E-03,   2.3545276E-03
     +,   2.3958851E-03,   2.4541547E-03,   2.5323040E-03
     +,   2.6336114E-03,   2.7616601E-03,   2.9203545E-03
     +,   3.1139045E-03,   3.3467826E-03,   3.6237384E-03
     +,   3.9497428E-03,   4.3299193E-03,   4.7694943E-03
     +,   5.2737584E-03,   5.8479672E-03,   6.4972010E-03
     +,   7.2262837E-03,   8.0397287E-03,   8.9415805E-03
     +,   9.9352226E-03,   1.1023295E-02,   1.2207647E-02
     +,   1.3489160E-02,   1.4867489E-02,   1.6341213E-02
     +,   1.7907642E-02,   1.9562621E-02,   2.1300578E-02
     +,   2.3114612E-02,   2.4996413E-02,   2.6936138E-02
     +,   2.8922584E-02,   3.0943403E-02,   3.2985121E-02
     +,   3.5033099E-02,   3.7071846E-02,   3.9085321E-02
     +,   4.1057006E-02,   4.2969916E-02,   4.4807222E-02
     +,   4.6552278E-02,   4.8188701E-02,   4.9700759E-02
     +,   5.1073708E-02,   5.2293792E-02,   5.3348504E-02
     +,   5.4226741E-02,   5.4919086E-02,   5.5417862E-02
     +,   5.5717211E-02,   5.5813268E-02,   5.5704214E-02
     +,   5.5390295E-02,   5.4873876E-02,   5.4159399E-02
     +,   5.3253282E-02,   5.2163985E-02,   5.0901819E-02
     +,   4.9478766E-02,   4.7908302E-02,   4.6205413E-02
     +,   4.4386186E-02,   4.2467523E-02,   4.0466987E-02
     +,   3.8402628E-02,   3.6292646E-02,   3.4154963E-02
     +,   3.2007065E-02,   2.9865999E-02,   2.7747715E-02
     +,   2.5667064E-02,   2.3637749E-02,   2.1672050E-02
     +,   1.9780571E-02,   1.7972309E-02,   1.6254723E-02
     +,   1.4633600E-02,   1.3112996E-02,   1.1695396E-02
     +,   1.0381919E-02,   9.1722962E-03,   8.0649536E-03
     +,   7.0572370E-03,   6.1456622E-03,   5.3258780E-03
     +,   4.5929276E-03,   3.9414521E-03,   3.3657693E-03
     +,   2.8599824E-03,   2.4181481E-03,   2.0344062E-03
     +,   1.7030358E-03,   1.4185088E-03,   1.1755854E-03
     +,   9.6936477E-04,   7.9529674E-04,   6.4919138E-04
     +,   5.2724290E-04,   4.2603508E-04,   3.4250764E-04
     +,   2.7395485E-04,   2.1800782E-04,   1.7260374E-04
     +,   1.3595904E-04,   1.0654679E-04,   8.3070780E-05
     +,   6.4436877E-05,   4.9727190E-05,   3.8178761E-05
     +,   2.9162249E-05,   2.2161275E-05,   1.6754773E-05
     +,   1.2602253E-05,   9.4304232E-06,   7.0207552E-06
     +,   5.1999800E-06,   3.8316784E-06,   2.8089942E-06
     +,   2.0487228E-06,   1.4865575E-06,   1.0731292E-06
     +,   7.7072542E-07,   5.5070780E-07,   3.9148264E-07
     +,   2.7687605E-07,   1.9481918E-07,   1.3638399E-07
     +,   9.4988891E-08,   6.5822370E-08,   4.5379391E-08
     +,   3.1127431E-08,   2.1243308E-08,   1.4424899E-08
     +,   9.7456887E-09,   6.5515180E-09,   4.3823731E-09
     +,   2.9169183E-09,   1.9320496E-09,   1.2735154E-09
     +,   8.3545998E-10,   5.4552141E-10,   3.5458866E-10
     +,   2.2946538E-10,   1.4787173E-10,   9.4912134E-11
     +,   6.0698099E-11,   3.8690485E-11,   2.4594724E-11
     +,   1.5601019E-11,   9.8833094E-12
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_haonly_ttz120_mass = Yx/0.709144434782609
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_haonly_ttz60_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.8872119E-03,   1.9359092E-03
     +,   1.9865495E-03,   2.0393373E-03,   2.0945244E-03
     +,   2.1524222E-03,   2.2134050E-03,   2.2779193E-03
     +,   2.3464884E-03,   2.4197216E-03,   2.4983138E-03
     +,   2.5830502E-03,   2.6748085E-03,   2.7745550E-03
     +,   2.8833442E-03,   3.0023097E-03,   3.1326551E-03
     +,   3.2756422E-03,   3.4325751E-03,   3.6047795E-03
     +,   3.7935844E-03,   4.0002945E-03,   4.2261630E-03
     +,   4.4723810E-03,   4.7400096E-03,   5.0300029E-03
     +,   5.3431438E-03,   5.6800395E-03,   6.0411016E-03
     +,   6.4265304E-03,   6.8363240E-03,   7.2702817E-03
     +,   7.7280314E-03,   8.2090739E-03,   8.7128412E-03
     +,   9.2387944E-03,   9.7865183E-03,   1.0355868E-02
     +,   1.0947173E-02,   1.1561328E-02,   1.2200134E-02
     +,   1.2866425E-02,   1.3564326E-02,   1.4299450E-02
     +,   1.5079063E-02,   1.5912145E-02,   1.6809393E-02
     +,   1.7783051E-02,   1.8846592E-02,   2.0014195E-02
     +,   2.1300046E-02,   2.2717433E-02,   2.4277646E-02
     +,   2.5988942E-02,   2.7855055E-02,   2.9874468E-02
     +,   3.2039169E-02,   3.4334186E-02,   3.6737360E-02
     +,   3.9219689E-02,   4.1746233E-02,   4.4277519E-02
     +,   4.6771307E-02,   4.9185116E-02,   5.1478509E-02
     +,   5.3615142E-02,   5.5565350E-02,   5.7307214E-02
     +,   5.8827963E-02,   6.0123760E-02,   6.1199531E-02
     +,   6.2067527E-02,   6.2745877E-02,   6.3256413E-02
     +,   6.3622773E-02,   6.3868381E-02,   6.4014830E-02
     +,   6.4080663E-02,   6.4080648E-02,   6.4025447E-02
     +,   6.3921541E-02,   6.3771650E-02,   6.3575186E-02
     +,   6.3328788E-02,   6.3026987E-02,   6.2662810E-02
     +,   6.2228441E-02,   6.1716005E-02,   6.1118305E-02
     +,   6.0429741E-02,   5.9647113E-02,   5.8770604E-02
     +,   5.7804432E-02,   5.6757215E-02,   5.5642150E-02
     +,   5.4476880E-02,   5.3282335E-02,   5.2081995E-02
     +,   5.0900042E-02,   4.9759928E-02,   4.8682403E-02
     +,   4.7684226E-02,   4.6776682E-02,   4.5965090E-02
     +,   4.5248400E-02,   4.4619571E-02,   4.4066545E-02
     +,   4.3573484E-02,   4.3122198E-02,   4.2693947E-02
     +,   4.2270906E-02,   4.1837551E-02,   4.1381638E-02
     +,   4.0894810E-02,   4.0372822E-02,   3.9815232E-02
     +,   3.9224979E-02,   3.8607445E-02,   3.7969716E-02
     +,   3.7319586E-02,   3.6664609E-02,   3.6011573E-02
     +,   3.5365876E-02,   3.4731179E-02,   3.4109376E-02
     +,   3.3500701E-02,   3.2903809E-02,   3.2316279E-02
     +,   3.1734802E-02,   3.1155745E-02,   3.0575309E-02
     +,   2.9990029E-02,   2.9396838E-02,   2.8793408E-02
     +,   2.8178085E-02,   2.7550008E-02,   2.6909111E-02
     +,   2.6256010E-02,   2.5591912E-02,   2.4918478E-02
     +,   2.4237787E-02,   2.3552168E-02,   2.2864014E-02
     +,   2.2175739E-02,   2.1489754E-02,   2.0808248E-02
     +,   2.0133212E-02,   1.9466443E-02,   1.8809475E-02
     +,   1.8163539E-02,   1.7529622E-02,   1.6908523E-02
     +,   1.6300840E-02,   1.5706979E-02,   1.5127216E-02
     +,   1.4561782E-02,   1.4010853E-02,   1.3474549E-02
     +,   1.2952978E-02,   1.2446311E-02,   1.1954692E-02
     +,   1.1478273E-02,   1.1017263E-02,   1.0571857E-02
     +,   1.0142216E-02,   9.7284708E-03,   9.3307411E-03
     +,   8.9490851E-03,   8.5834656E-03,   8.2337689E-03
     +,   7.8998189E-03,   7.5813499E-03,   7.2779888E-03
     +,   6.9892788E-03,   6.7147245E-03,   6.4537316E-03
     +,   6.2056524E-03,   5.9698252E-03,   5.7455548E-03
     +,   5.5321190E-03,   5.3287996E-03,   5.1349015E-03
     +,   4.9497499E-03,   4.7726939E-03,   4.6031172E-03
     +,   4.4404590E-03,   4.2842054E-03,   4.1338797E-03
     +,   3.9890548E-03,   3.8493646E-03,   3.7144753E-03
     +,   3.5840950E-03,   3.4579779E-03,   3.3359167E-03
     +,   3.2177214E-03,   3.1032320E-03,   2.9923164E-03
     +,   2.8848595E-03,   2.7807557E-03,   2.6799075E-03
     +,   2.5822353E-03,   2.4876636E-03,   2.3961132E-03
     +,   2.3075093E-03,   2.2217853E-03,   2.1388661E-03
     +,   2.0586762E-03,   1.9811448E-03,   1.9061991E-03
     +,   1.8337606E-03,   1.7637502E-03,   1.6960928E-03
     +,   1.6307132E-03,   1.5675308E-03,   1.5064671E-03
     +,   1.4474487E-03,   1.3904019E-03,   1.3352524E-03
     +,   1.2819278E-03,   1.2303629E-03,   1.1804905E-03
     +,   1.1322460E-03,   1.0855710E-03,   1.0404099E-03
     +,   9.9670771E-04,   9.5441239E-04,   9.1347808E-04
     +,   8.7386114E-04,   8.3551963E-04,   7.9841336E-04
     +,   7.6250837E-04,   7.2777248E-04,   6.9417380E-04
     +,   6.6168321E-04,   6.3027634E-04,   5.9992762E-04
     +,   5.7061337E-04,   5.4231333E-04,   5.1500805E-04
     +,   4.8867759E-04,   4.6330292E-04,   4.3886734E-04
     +,   4.1535444E-04,   3.9274665E-04,   3.7102681E-04
     +,   3.5017903E-04,   3.3018750E-04,   3.1103473E-04
     +,   2.9270331E-04,   2.7517698E-04,   2.5843777E-04
     +,   2.4246698E-04,   2.2724688E-04,   2.1275907E-04
     +,   1.9898376E-04,   1.8590095E-04,   1.7349103E-04
     +,   1.6173403E-04,   1.5060886E-04,   1.4009424E-04
     +,   1.3016940E-04,   1.2081335E-04,   1.1200432E-04
     +,   1.0372071E-04,   9.5941665E-05,   8.8645553E-05
     +,   8.1811057E-05,   7.5417498E-05,   6.9444337E-05
     +,   6.3871055E-05,   5.8677469E-05,   5.3844178E-05
     +,   4.9352264E-05,   4.5182856E-05,   4.1317795E-05
     +,   3.7739734E-05,   3.4431509E-05,   3.1376923E-05
     +,   2.8560060E-05,   2.5965959E-05,   2.3579963E-05
     +,   2.1388369E-05,   1.9377825E-05,   1.7535880E-05
     +,   1.5850484E-05,   1.4310421E-05,   1.2904925E-05
     +,   1.1623858E-05,   1.0457779E-05,   9.3976732E-06
     +,   8.4351941E-06,   7.5624293E-06,   6.7720707E-06
     +,   6.0572083E-06,   5.4114994E-06,   4.8289630E-06
     +,   4.3041150E-06,   3.8318126E-06,   3.4073660E-06
     +,   3.0263827E-06,   2.6848668E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_haonly_ttz60_mass = Yx/1.208172
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_haonly_ttz65_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  5.8708048E-07,   7.9113408E-07
     +,   1.0604019E-06,   1.4137040E-06,   1.8746235E-06
     +,   2.4725061E-06,   3.2436076E-06,   4.2324032E-06
     +,   5.4930251E-06,   7.0909700E-06,   9.1047377E-06
     +,   1.1627782E-05,   1.4770460E-05,   1.8662025E-05
     +,   2.3452627E-05,   2.9315113E-05,   3.6446792E-05
     +,   4.5070774E-05,   5.5436838E-05,   6.7821820E-05
     +,   8.2529361E-05,   9.9888457E-05,   1.2025108E-04
     +,   1.4399043E-04,   1.7149218E-04,   2.0315421E-04
     +,   2.3937435E-04,   2.8054416E-04,   3.2703849E-04
     +,   3.7920481E-04,   4.3735220E-04,   5.0173962E-04
     +,   5.7256635E-04,   6.4996333E-04,   7.3398830E-04
     +,   8.2462677E-04,   9.2179899E-04,   1.0253767E-03
     +,   1.1352232E-03,   1.2512213E-03,   1.3733658E-03
     +,   1.5018355E-03,   1.6371190E-03,   1.7801549E-03
     +,   1.9325056E-03,   2.0965436E-03,   2.2756546E-03
     +,   2.4744372E-03,   2.6988785E-03,   2.9564863E-03
     +,   3.2563412E-03,   3.6090584E-03,   4.0266188E-03
     +,   4.5221285E-03,   5.1093469E-03,   5.8023618E-03
     +,   6.6150678E-03,   7.5608804E-03,   8.6526228E-03
     +,   9.9027054E-03,   1.1323631E-02,   1.2928785E-02
     +,   1.4733195E-02,   1.6754422E-02,   1.9012602E-02
     +,   2.1529326E-02,   2.4326103E-02,   2.7420318E-02
     +,   3.0821498E-02,   3.4525551E-02,   3.8511183E-02
     +,   4.2735778E-02,   4.7135580E-02,   5.1626410E-02
     +,   5.6109097E-02,   6.0475331E-02,   6.4614601E-02
     +,   6.8421409E-02,   7.1801394E-02,   7.4675113E-02
     +,   7.6981060E-02,   7.8678906E-02,   7.9752609E-02
     +,   8.0216587E-02,   8.0124736E-02,   7.9582639E-02
     +,   7.8761831E-02,   7.7911407E-02,   7.7361576E-02
     +,   7.7510640E-02,   7.8789167E-02,   8.1599362E-02
     +,   8.6234719E-02,   9.2797011E-02,   0.1011307    
     +,   0.1107975    ,   0.1211103    ,   0.1312216    
     +,   0.1402572    ,   0.1474569    ,   0.1522946    
     +,   0.1545402    ,   0.1542550    ,   0.1517261    
     +,   0.1473634    ,   0.1415966    ,   0.1348020    
     +,   0.1272744    ,   0.1192417    ,   0.1109053    
     +,   0.1024807    ,   9.4215453E-02,   8.6382933E-02
     +,   7.9249002E-02,   7.3033497E-02,   6.7873999E-02
     +,   6.3809738E-02,   6.0782045E-02,   5.8654156E-02
     +,   5.7238448E-02,   5.6327350E-02,   5.5720232E-02
     +,   5.5243291E-02,   5.4761577E-02,   5.4183114E-02
     +,   5.3456854E-02,   5.2565727E-02,   5.1517751E-02
     +,   5.0335959E-02,   4.9049985E-02,   4.7689032E-02
     +,   4.6278108E-02,   4.4835769E-02,   4.3374669E-02
     +,   4.1902456E-02,   4.0423814E-02,   3.8942117E-02
     +,   3.7460689E-02,   3.5983294E-02,   3.4514304E-02
     +,   3.3058446E-02,   3.1620122E-02,   3.0202756E-02
     +,   2.8808549E-02,   2.7438454E-02,   2.6092056E-02
     +,   2.4768107E-02,   2.3465138E-02,   2.2181874E-02
     +,   2.0917661E-02,   1.9672891E-02,   1.8449232E-02
     +,   1.7249526E-02,   1.6077563E-02,   1.4937857E-02
     +,   1.3835385E-02,   1.2775157E-02,   1.1761816E-02
     +,   1.0799459E-02,   9.8915128E-03,   9.0404367E-03
     +,   8.2477694E-03,   7.5141839E-03,   6.8394705E-03
     +,   6.2225861E-03,   5.6618154E-03,   5.1548984E-03
     +,   4.6991073E-03,   4.2913286E-03,   3.9282041E-03
     +,   3.6062407E-03,   3.3218700E-03,   3.0715009E-03
     +,   2.8516124E-03,   2.6588207E-03,   2.4898776E-03
     +,   2.3417328E-03,   2.2115621E-03,   2.0967694E-03
     +,   1.9949931E-03,   1.9041162E-03,   1.8222670E-03
     +,   1.7478047E-03,   1.6793042E-03,   1.6155494E-03
     +,   1.5555188E-03,   1.4983673E-03,   1.4434024E-03
     +,   1.3900739E-03,   1.3379609E-03,   1.2867451E-03
     +,   1.2361995E-03,   1.1861802E-03,   1.1366068E-03
     +,   1.0874491E-03,   1.0387187E-03,   9.9046296E-04
     +,   9.4275316E-04,   8.9567434E-04,   8.4932236E-04
     +,   8.0380129E-04,   7.5921690E-04,   7.1566942E-04
     +,   6.7325414E-04,   6.3206337E-04,   5.9217686E-04
     +,   5.5366370E-04,   5.1658624E-04,   4.8099461E-04
     +,   4.4692575E-04,   4.1440607E-04,   3.8345307E-04
     +,   3.5407423E-04,   3.2626517E-04,   3.0001270E-04
     +,   2.7529750E-04,   2.5209211E-04,   2.3036127E-04
     +,   2.1006397E-04,   1.9115597E-04,   1.7358697E-04
     +,   1.5730337E-04,   1.4224980E-04,   1.2836882E-04
     +,   1.1560063E-04,   1.0388491E-04,   9.3161660E-05
     +,   8.3371284E-05,   7.4454103E-05,   6.6351677E-05
     +,   5.9007587E-05,   5.2367079E-05,   4.6376917E-05
     +,   4.0986073E-05,   3.6146419E-05,   3.1811716E-05
     +,   2.7938302E-05,   2.4485298E-05,   2.1414389E-05
     +,   1.8689552E-05,   1.6277318E-05,   1.4146846E-05
     +,   1.2269621E-05,   1.0619292E-05,   9.1717129E-06
     +,   7.9049387E-06,   6.7989426E-06,   5.8354858E-06
     +,   4.9980790E-06,   4.2719316E-06,   3.6436659E-06
     +,   3.1012949E-06,   2.6341504E-06,   2.2327129E-06
     +,   1.8885061E-06,   1.5940221E-06,   1.3426501E-06
     +,   1.1285649E-06,   9.4663659E-07,   7.9237395E-07
     +,   6.6186573E-07,   5.5170267E-07,   4.5891548E-07
     +,   3.8093501E-07,   3.1554731E-07,   2.6083811E-07
     +,   2.1516283E-07,   1.7711542E-07,   1.4549276E-07
     +,   1.1926663E-07,   9.7563309E-08,   7.9642895E-08
     +,   6.4878840E-08,   5.2741441E-08,   4.2784905E-08
     +,   3.4635821E-08,   2.7980121E-08,   2.2556408E-08
     +,   1.8145959E-08,   1.4567511E-08,   1.1670281E-08
     +,   9.3297983E-09,   7.4430968E-09,   5.9255747E-09
     +,   4.7075721E-09,   3.7321595E-09,   2.9526765E-09
     +,   2.3310998E-09,   1.8365451E-09,   1.4438832E-09
     +,   1.1328155E-09,   8.8690100E-10,   6.9292744E-10
     +,   5.4024307E-10,   4.2032750E-10,   3.2634331E-10
     +,   2.5284752E-10,   1.9549298E-10,   1.5083451E-10
     +,   1.1613402E-10,   8.9230734E-11
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_haonly_ttz65_mass = Yx/1.4886405
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_haonly_ttz70_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.6021121E-03,   1.6730223E-03
     +,   1.7471709E-03,   1.8247325E-03,   1.9058823E-03
     +,   1.9907930E-03,   2.0796326E-03,   2.1725609E-03
     +,   2.2697258E-03,   2.3712653E-03,   2.4772948E-03
     +,   2.5879091E-03,   2.7031801E-03,   2.8231472E-03
     +,   2.9478199E-03,   3.0771692E-03,   3.2111285E-03
     +,   3.3495869E-03,   3.4923896E-03,   3.6393350E-03
     +,   3.7901734E-03,   3.9446075E-03,   4.1022883E-03
     +,   4.2628334E-03,   4.4257971E-03,   4.5907125E-03
     +,   4.7570681E-03,   4.9243253E-03,   5.0919228E-03
     +,   5.2592875E-03,   5.4258378E-03,   5.5909990E-03
     +,   5.7542128E-03,   5.9149456E-03,   6.0727061E-03
     +,   6.2270528E-03,   6.3776113E-03,   6.5240893E-03
     +,   6.6662938E-03,   6.8041333E-03,   6.9376640E-03
     +,   7.0670806E-03,   7.1927593E-03,   7.3152711E-03
     +,   7.4354210E-03,   7.5542689E-03,   7.6731807E-03
     +,   7.7938624E-03,   7.9184100E-03,   8.0493595E-03
     +,   8.1897415E-03,   8.3431304E-03,   8.5136918E-03
     +,   8.7062316E-03,   8.9261923E-03,   9.1796843E-03
     +,   9.4734346E-03,   9.8147094E-03,   1.0211210E-02
     +,   1.0670891E-02,   1.1201721E-02,   1.1811404E-02
     +,   1.2506959E-02,   1.3294410E-02,   1.4178277E-02
     +,   1.5160999E-02,   1.6242644E-02,   1.7420167E-02
     +,   1.8687276E-02,   2.0033756E-02,   2.1445580E-02
     +,   2.2904461E-02,   2.4388354E-02,   2.5871424E-02
     +,   2.7325042E-02,   2.8718583E-02,   3.0020712E-02
     +,   3.1201141E-02,   3.2232825E-02,   3.3094205E-02
     +,   3.3771731E-02,   3.4262594E-02,   3.4576863E-02
     +,   3.4739375E-02,   3.4790669E-02,   3.4787040E-02
     +,   3.4799598E-02,   3.4912705E-02,   3.5221819E-02
     +,   3.5831623E-02,   3.6854099E-02,   3.8406610E-02
     +,   4.0608793E-02,   4.3577727E-02,   4.7419172E-02
     +,   5.2214678E-02,   5.8007568E-02,   6.4787298E-02
     +,   7.2482139E-02,   8.0958538E-02,   9.0037078E-02
     +,   9.9515520E-02,   0.1092016    ,   0.1189362    
     +,   0.1286080    ,   0.1381452    ,   0.1474909    
     +,   0.1565726    ,   0.1652775    ,   0.1734424    
     +,   0.1808639    ,   0.1873219    ,   0.1925998    
     +,   0.1964945    ,   0.1988072    ,   0.1993296    
     +,   0.1978373    ,   0.1941104    ,   0.1879862    
     +,   0.1794318    ,   0.1686139    ,   0.1559354    
     +,   0.1420184    ,   0.1276282    ,   0.1135633    
     +,   0.1005369    ,   8.9079015E-02,   7.9492077E-02
     +,   7.1850173E-02,   6.6045463E-02,   6.1851237E-02
     +,   5.8989394E-02,   5.7181206E-02,   5.6179602E-02
     +,   5.5780511E-02,   5.5820685E-02,   5.6168281E-02
     +,   5.6711752E-02,   5.7351261E-02,   5.7993583E-02
     +,   5.8550540E-02,   5.8940142E-02,   5.9089158E-02
     +,   5.8935992E-02,   5.8433533E-02,   5.7550844E-02
     +,   5.6274366E-02,   5.4607850E-02,   5.2571367E-02
     +,   5.0199319E-02,   4.7537964E-02,   4.4642724E-02
     +,   4.1574877E-02,   3.8398135E-02,   3.5175830E-02
     +,   3.1968415E-02,   2.8830983E-02,   2.5811274E-02
     +,   2.2948718E-02,   2.0273985E-02,   1.7808335E-02
     +,   1.5564287E-02,   1.3546469E-02,   1.1752512E-02
     +,   1.0174191E-02,   8.7988870E-03,   7.6109837E-03
     +,   6.5929717E-03,   5.7264538E-03,   4.9931337E-03
     +,   4.3755174E-03,   3.8573295E-03,   3.4237832E-03
     +,   3.0617712E-03,   2.7599034E-03,   2.5083628E-03
     +,   2.2988142E-03,   2.1242471E-03,   1.9787767E-03
     +,   1.8574676E-03,   1.7561846E-03,   1.6714607E-03
     +,   1.6003702E-03,   1.5404320E-03,   1.4895389E-03
     +,   1.4459037E-03,   1.4080047E-03,   1.3745518E-03
     +,   1.3444573E-03,   1.3168150E-03,   1.2908739E-03
     +,   1.2660206E-03,   1.2417660E-03,   1.2177258E-03
     +,   1.1936056E-03,   1.1691881E-03,   1.1443223E-03
     +,   1.1189120E-03,   1.0929030E-03,   1.0662765E-03
     +,   1.0390435E-03,   1.0112376E-03,   9.8290644E-04
     +,   9.5411029E-04,   9.2492095E-04,   8.9541345E-04
     +,   8.6566608E-04,   8.3576120E-04,   8.0578128E-04
     +,   7.7580614E-04,   7.4591365E-04,   7.1618112E-04
     +,   6.8668311E-04,   6.5748824E-04,   6.2866142E-04
     +,   6.0026540E-04,   5.7235855E-04,   5.4499245E-04
     +,   5.1821460E-04,   4.9207004E-04,   4.6659674E-04
     +,   4.4182784E-04,   4.1779364E-04,   3.9451983E-04
     +,   3.7202591E-04,   3.5032741E-04,   3.2943705E-04
     +,   3.0936350E-04,   2.9011027E-04,   2.7167742E-04
     +,   2.5406299E-04,   2.3726170E-04,   2.2126426E-04
     +,   2.0605883E-04,   1.9163272E-04,   1.7796946E-04
     +,   1.6505085E-04,   1.5285768E-04,   1.4136934E-04
     +,   1.3056316E-04,   1.2041551E-04,   1.1090256E-04
     +,   1.0199976E-04,   9.3681600E-05,   8.5922205E-05
     +,   7.8696256E-05,   7.1978277E-05,   6.5742475E-05
     +,   5.9963480E-05,   5.4616801E-05,   4.9677903E-05
     +,   4.5122812E-05,   4.0928553E-05,   3.7072808E-05
     +,   3.3533739E-05,   3.0290365E-05,   2.7322751E-05
     +,   2.4611783E-05,   2.2139060E-05,   1.9887089E-05
     +,   1.7839409E-05,   1.5980442E-05,   1.4295346E-05
     +,   1.2770151E-05,   1.1391913E-05,   1.0148332E-05
     +,   9.0279345E-06,   8.0200944E-06,   7.1149125E-06
     +,   6.3031416E-06,   5.5762257E-06,   4.9263008E-06
     +,   4.3461100E-06,   3.8289340E-06,   3.3686092E-06
     +,   2.9595290E-06,   2.5965101E-06,   2.2748718E-06
     +,   1.9903027E-06,   1.7389239E-06,   1.5171823E-06
     +,   1.3218864E-06,   1.1501271E-06,   9.9930298E-07
     +,   8.6704949E-07,   7.5125956E-07,   6.5002979E-07
     +,   5.6165783E-07,   4.8462977E-07,   4.1758418E-07
     +,   3.5931637E-07,   3.0874853E-07,   2.6493117E-07
     +,   2.2701579E-07,   1.9425784E-07,   1.6599552E-07
     +,   1.4164917E-07,   1.2070534E-07,   1.0271611E-07
     +,   8.7286246E-08,   7.4071806E-08
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_haonly_ttz70_mass = Yx/1.79142744827586
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_haonly_ttz75_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  8.7711611E-04,   9.1690337E-04
     +,   9.5764769E-04,   9.9935988E-04,   1.0420564E-03
     +,   1.0857589E-03,   1.1304963E-03,   1.1763040E-03
     +,   1.2232253E-03,   1.2713133E-03,   1.3206290E-03
     +,   1.3712427E-03,   1.4232353E-03,   1.4766982E-03
     +,   1.5317339E-03,   1.5884553E-03,   1.6469883E-03
     +,   1.7074695E-03,   1.7700479E-03,   1.8348852E-03
     +,   1.9021535E-03,   1.9720383E-03,   2.0447345E-03
     +,   2.1204534E-03,   2.1994070E-03,   2.2818272E-03
     +,   2.3679463E-03,   2.4580068E-03,   2.5522553E-03
     +,   2.6509389E-03,   2.7543074E-03,   2.8626034E-03
     +,   2.9760660E-03,   3.0949216E-03,   3.2193819E-03
     +,   3.3496406E-03,   3.4858661E-03,   3.6281971E-03
     +,   3.7767526E-03,   3.9315969E-03,   4.0927762E-03
     +,   4.2602890E-03,   4.4340994E-03,   4.6141362E-03
     +,   4.8002996E-03,   4.9924660E-03,   5.1905024E-03
     +,   5.3942748E-03,   5.6036664E-03,   5.8185942E-03
     +,   6.0390299E-03,   6.2650163E-03,   6.4966911E-03
     +,   6.7343176E-03,   6.9782641E-03,   7.2290669E-03
     +,   7.4873948E-03,   7.7540679E-03,   8.0300346E-03
     +,   8.3163595E-03,   8.6141769E-03,   8.9246528E-03
     +,   9.2489021E-03,   9.5879538E-03,   9.9426489E-03
     +,   1.0313520E-02,   1.0700776E-02,   1.1104121E-02
     +,   1.1522781E-02,   1.1955331E-02,   1.2399779E-02
     +,   1.2853443E-02,   1.3313098E-02,   1.3774958E-02
     +,   1.4234887E-02,   1.4688549E-02,   1.5131596E-02
     +,   1.5559954E-02,   1.5970178E-02,   1.6359687E-02
     +,   1.6727073E-02,   1.7072456E-02,   1.7397661E-02
     +,   1.7706487E-02,   1.8004771E-02,   1.8300500E-02
     +,   1.8603722E-02,   1.8926486E-02,   1.9282565E-02
     +,   1.9687247E-02,   2.0156967E-02,   2.0708825E-02
     +,   2.1360107E-02,   2.2127738E-02,   2.3027591E-02
     +,   2.4073565E-02,   2.5276940E-02,   2.6645079E-02
     +,   2.8180767E-02,   2.9880863E-02,   3.1735949E-02
     +,   3.3729468E-02,   3.5838433E-02,   3.8033821E-02
     +,   4.0282868E-02,   4.2551436E-02,   4.4807192E-02
     +,   4.7023226E-02,   4.9181409E-02,   5.1274672E-02
     +,   5.3307600E-02,   5.5296194E-02,   5.7264589E-02
     +,   5.9241269E-02,   6.1252959E-02,   6.3319497E-02
     +,   6.5448217E-02,   6.7632087E-02,   6.9850422E-02
     +,   7.2076276E-02,   7.4289523E-02,   7.6495066E-02
     +,   7.8743644E-02,   8.1148610E-02,   8.3890684E-02
     +,   8.7203361E-02,   9.1336824E-02,   9.6499242E-02
     +,   0.1027912    ,   0.1101446    ,   0.1182914    
     +,   0.1267697    ,   0.1349810    ,   0.1422792    
     +,   0.1480791    ,   0.1519516    ,   0.1536830    
     +,   0.1532850    ,   0.1509576    ,   0.1470179    
     +,   0.1418204    ,   0.1356908    ,   0.1288867    
     +,   0.1215909    ,   0.1139304    ,   0.1060046    
     +,   9.7913377E-02,   8.9774042E-02,   8.1721611E-02
     +,   7.3897697E-02,   6.6433839E-02,   5.9436169E-02
     +,   5.2974664E-02,   4.7080606E-02,   4.1751925E-02
     +,   3.6962781E-02,   3.2673474E-02,   2.8839227E-02
     +,   2.5416553E-02,   2.2366628E-02,   1.9655075E-02
     +,   1.7251538E-02,   1.5128490E-02,   1.3259917E-02
     +,   1.1620701E-02,   1.0186707E-02,   8.9351824E-03
     +,   7.8450395E-03,   6.8971342E-03,   6.0745343E-03
     +,   5.3625088E-03,   4.7482606E-03,   4.2206063E-03
     +,   3.7697034E-03,   3.3867888E-03,   3.0638529E-03
     +,   2.7935230E-03,   2.5689728E-03,   2.3838514E-03
     +,   2.2322631E-03,   2.1087958E-03,   2.0085431E-03
     +,   1.9271049E-03,   1.8605940E-03,   1.8056353E-03
     +,   1.7593532E-03,   1.7193350E-03,   1.6835969E-03
     +,   1.6505409E-03,   1.6189143E-03,   1.5877548E-03
     +,   1.5563506E-03,   1.5241980E-03,   1.4909623E-03
     +,   1.4564422E-03,   1.4205407E-03,   1.3832464E-03
     +,   1.3446081E-03,   1.3047180E-03,   1.2637004E-03
     +,   1.2217051E-03,   1.1788959E-03,   1.1354428E-03
     +,   1.0915194E-03,   1.0473036E-03,   1.0029668E-03
     +,   9.5867558E-04,   9.1459294E-04,   8.7087415E-04
     +,   8.2766276E-04,   7.8509282E-04,   7.4329070E-04
     +,   7.0237229E-04,   6.6243944E-04,   6.2358292E-04
     +,   5.8588485E-04,   5.4941600E-04,   5.1423360E-04
     +,   4.8038422E-04,   4.4790714E-04,   4.1682841E-04
     +,   3.8716476E-04,   3.5892540E-04,   3.3211135E-04
     +,   3.0671386E-04,   2.8271702E-04,   2.6010021E-04
     +,   2.3883635E-04,   2.1889230E-04,   2.0023000E-04
     +,   1.8280918E-04,   1.6658589E-04,   1.5151247E-04
     +,   1.3753943E-04,   1.2461712E-04,   1.1269334E-04
     +,   1.0171554E-04,   9.1631860E-05,   8.2390514E-05
     +,   7.3939736E-05,   6.6228844E-05,   5.9208822E-05
     +,   5.2832042E-05,   4.7052043E-05,   4.1824227E-05
     +,   3.7106282E-05,   3.2857821E-05,   2.9040233E-05
     +,   2.5617081E-05,   2.2554394E-05,   1.9819958E-05
     +,   1.7383716E-05,   1.5217823E-05,   1.3296406E-05
     +,   1.1595407E-05,   1.0092671E-05,   8.7679109E-06
     +,   7.6025276E-06,   6.5794611E-06,   5.6831695E-06
     +,   4.8996003E-06,   4.2160250E-06,   3.6208910E-06
     +,   3.1038153E-06,   2.6555126E-06,   2.2676252E-06
     +,   1.9326876E-06,   1.6440765E-06,   1.3959026E-06
     +,   1.1829271E-06,   1.0005268E-06,   8.4463591E-07
     +,   7.1167648E-07,   5.9850260E-07,   5.0236179E-07
     +,   4.2086253E-07,   3.5190951E-07,   2.9369369E-07
     +,   2.4463904E-07,   2.0338987E-07,   1.6877202E-07
     +,   1.3977983E-07,   1.1554618E-07,   9.5332190E-08
     +,   7.8503881E-08,   6.4523071E-08,   5.2930872E-08
     +,   4.3338162E-08,   3.5416473E-08,   2.8887289E-08
     +,   2.3516957E-08,   1.9108342E-08,   1.5496633E-08
     +,   1.2543524E-08,   1.0133848E-08,   8.1713871E-09
     +,   6.5764407E-09,   5.2826654E-09,   4.2353396E-09
     +,   3.3891443E-09,   2.7068590E-09
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_haonly_ttz75_mass = Yx/1.38716044444444
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_haonly_ttz80_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  6.6344079E-04,   7.0123933E-04
     +,   7.3999952E-04,   7.7965134E-04,   8.2011760E-04
     +,   8.6131465E-04,   9.0315245E-04,   9.4553572E-04
     +,   9.8836271E-04,   1.0315295E-03,   1.0749268E-03
     +,   1.1184429E-03,   1.1619640E-03,   1.2053757E-03
     +,   1.2485632E-03,   1.2914134E-03,   1.3338150E-03
     +,   1.3756604E-03,   1.4168459E-03,   1.4572750E-03
     +,   1.4968567E-03,   1.5355079E-03,   1.5731547E-03
     +,   1.6097355E-03,   1.6451948E-03,   1.6794937E-03
     +,   1.7126028E-03,   1.7445071E-03,   1.7752044E-03
     +,   1.8047072E-03,   1.8330418E-03,   1.8602489E-03
     +,   1.8863833E-03,   1.9115135E-03,   1.9357227E-03
     +,   1.9591057E-03,   1.9817711E-03,   2.0038383E-03
     +,   2.0254385E-03,   2.0467110E-03,   2.0678062E-03
     +,   2.0888804E-03,   2.1100966E-03,   2.1316232E-03
     +,   2.1536320E-03,   2.1762974E-03,   2.1997946E-03
     +,   2.2242987E-03,   2.2499834E-03,   2.2770185E-03
     +,   2.3055710E-03,   2.3358006E-03,   2.3678613E-03
     +,   2.4019014E-03,   2.4380558E-03,   2.4764533E-03
     +,   2.5172113E-03,   2.5604349E-03,   2.6062180E-03
     +,   2.6546414E-03,   2.7057733E-03,   2.7596694E-03
     +,   2.8163679E-03,   2.8758994E-03,   2.9382806E-03
     +,   3.0035099E-03,   3.0715810E-03,   3.1424691E-03
     +,   3.2161453E-03,   3.2925629E-03,   3.3716748E-03
     +,   3.4534161E-03,   3.5377233E-03,   3.6245156E-03
     +,   3.7137130E-03,   3.8052297E-03,   3.8989659E-03
     +,   3.9948141E-03,   4.0926677E-03,   4.1924091E-03
     +,   4.2939056E-03,   4.3970314E-03,   4.5016385E-03
     +,   4.6075918E-03,   4.7147451E-03,   4.8229750E-03
     +,   4.9321637E-03,   5.0422437E-03,   5.1531801E-03
     +,   5.2650236E-03,   5.3779203E-03,   5.4921350E-03
     +,   5.6080860E-03,   5.7263831E-03,   5.8478527E-03
     +,   5.9735412E-03,   6.1047655E-03,   6.2430785E-03
     +,   6.3902857E-03,   6.5483805E-03,   6.7195124E-03
     +,   6.9058584E-03,   7.1095452E-03,   7.3324461E-03
     +,   7.5760526E-03,   7.8412537E-03,   8.1281075E-03
     +,   8.4356554E-03,   8.7617533E-03,   9.1029266E-03
     +,   9.4542522E-03,   9.8094819E-03,   1.0161098E-02
     +,   1.0500717E-02,   1.0819515E-02,   1.1109031E-02
     +,   1.1362053E-02,   1.1573918E-02,   1.1743921E-02
     +,   1.1877042E-02,   1.1985741E-02,   1.2091740E-02
     +,   1.2227619E-02,   1.2437855E-02,   1.2779070E-02
     +,   1.3319003E-02,   1.4134182E-02,   1.5305801E-02
     +,   1.6914615E-02,   1.9034525E-02,   2.1727150E-02
     +,   2.5036890E-02,   2.8989989E-02,   3.3595517E-02
     +,   3.8851250E-02,   4.4750188E-02,   5.1285878E-02
     +,   5.8454145E-02,   6.6248037E-02,   7.4643970E-02
     +,   8.3581805E-02,   9.2945054E-02,   0.1025475    
     +,   0.1121308    ,   0.1213773    ,   0.1299403    
     +,   0.1374781    ,   0.1436865    ,   0.1483206    
     +,   0.1511984    ,   0.1521912    ,   0.1512078    
     +,   0.1481867    ,   0.1431043    ,   0.1359998    
     +,   0.1270126    ,   0.1164140    ,   0.1046180    
     +,   9.2161477E-02,   7.9654165E-02,   6.7702673E-02
     +,   5.6833811E-02,   4.7431704E-02,   3.9700981E-02
     +,   3.3663720E-02,   2.9186772E-02,   2.6027927E-02
     +,   2.3888368E-02,   2.2461576E-02,   2.1470970E-02
     +,   2.0692786E-02,   1.9965008E-02,   1.9185508E-02
     +,   1.8303201E-02,   1.7305925E-02,   1.6207529E-02
     +,   1.5036597E-02,   1.3827502E-02,   1.2613954E-02
     +,   1.1424958E-02,   1.0283016E-02,   9.2038261E-03
     +,   8.1968252E-03,   7.2663007E-03,   6.4128106E-03
     +,   5.6344955E-03,   4.9280506E-03,   4.2894445E-03
     +,   3.7144618E-03,   3.1990057E-03,   2.7390877E-03
     +,   2.3308913E-03,   1.9707531E-03,   1.6550787E-03
     +,   1.3802930E-03,   1.1428535E-03,   9.3927135E-04
     +,   7.6611590E-04,   6.2004232E-04,   4.9784611E-04
     +,   3.9650398E-04,   3.1319362E-04,   2.4531307E-04
     +,   1.9050307E-04,   1.4665646E-04,   1.1190643E-04
     +,   8.4625935E-05,   6.3415850E-05,   4.7086221E-05
     +,   3.4637284E-05,   2.5240826E-05,   1.8219729E-05
     +,   1.3026637E-05,   9.2245036E-06,   6.4691230E-06
     +,   4.4928702E-06,   3.0900540E-06,   2.1045169E-06
     +,   1.4192692E-06,   9.4777261E-07,   6.2669449E-07
     +,   4.1030646E-07,   2.6598642E-07,   1.7073120E-07
     +,   1.0850691E-07,   6.8278531E-08,   4.2539913E-08
     +,   2.6242198E-08,   1.6028263E-08,   9.6927533E-09
     +,   5.8034741E-09,   3.4404615E-09,   2.0194109E-09
     +,   1.1735534E-09,   6.7525646E-10,   3.8469150E-10
     +,   2.1698335E-10,   1.2117646E-10,   6.7003326E-11
     +,   3.6681949E-11,   1.9882826E-11,   1.0670424E-11
     +,   5.6698491E-12,   2.9829093E-12,   1.5537370E-12
     +,   8.0129317E-13,   4.0916123E-13,   2.0685977E-13
     +,   1.0354440E-13,   5.1317623E-14,   2.5181739E-14
     +,   1.2234241E-14,   5.8850634E-15,   2.8029870E-15
     +,   1.3218373E-15,   6.1719072E-16,   2.8533917E-16
     +,   1.3062531E-16,   5.9214088E-17,   2.6580890E-17
     +,   1.1817178E-17,   5.2040013E-18,   2.2705332E-18
     +,   9.8182854E-19,   4.2105414E-19,   1.7923285E-19
     +,   7.5838704E-20,   3.1970401E-20,   1.3474426E-20
     +,   5.7073867E-21,   2.4477763E-21,   1.0737005E-21
     +,   4.8746702E-22,   2.3173820E-22,   1.1627984E-22
     +,   6.1673972E-23,   3.4383790E-23,   1.9947642E-23
     +,   1.1908378E-23,   7.2446090E-24,   4.4581839E-24
     +,   2.7610708E-24,   1.7152191E-24,   1.0665921E-24
     +,   6.6305776E-25,   4.1178411E-25,   2.5536374E-25
     +,   1.5809140E-25,   9.7695240E-26,   6.0257190E-26
     +,   3.7095907E-26,   2.2793150E-26,   1.3978549E-26
     +,   8.5565293E-27,   5.2279418E-27,   3.1883504E-27
     +,   1.9410177E-27,   1.1795658E-27,   7.1561066E-28
     +,   4.3340535E-28,   2.6206603E-28
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_haonly_ttz80_mass = Yx/0.9665376
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_haonly_ttz85_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.6592599E-19,   3.2183915E-19
     +,   6.2058129E-19,   1.1895671E-18,   2.2667904E-18
     +,   4.2940381E-18,   8.0863498E-18,   1.5138151E-17
     +,   2.8172180E-17,   5.2119979E-17,   9.5856369E-17
     +,   1.7525474E-16,   3.1852970E-16,   5.7552458E-16
     +,   1.0337365E-15,   1.8458144E-15,   3.2764166E-15
     +,   5.7815136E-15,   1.0141841E-14,   1.7685784E-14
     +,   3.0659418E-14,   5.2836797E-14,   9.0518427E-14
     +,   1.5416223E-13,   2.6100191E-13,   4.3928427E-13
     +,   7.3498580E-13,   1.2224923E-12,   2.0213644E-12
     +,   3.3225848E-12,   5.4292508E-12,   8.8193350E-12
     +,   1.4241800E-11,   2.2862632E-11,   3.6485471E-11
     +,   5.7882324E-11,   9.1286236E-11,   1.4311781E-10
     +,   2.2305975E-10,   3.4560180E-10,   5.3231108E-10
     +,   8.1505896E-10,   1.2406377E-09,   1.8773034E-09
     +,   2.8239535E-09,   4.2229340E-09,   6.2777534E-09
     +,   9.2774544E-09,   1.3629736E-08,   1.9905817E-08
     +,   2.8900718E-08,   4.1713051E-08,   5.9850592E-08
     +,   8.5370331E-08,   1.2105347E-07,   1.7064266E-07
     +,   2.3913168E-07,   3.3313898E-07,   4.6137555E-07
     +,   6.3522202E-07,   8.6943976E-07,   1.1830423E-06
     +,   1.6003066E-06,   2.1520602E-06,   2.8771335E-06
     +,   3.8239714E-06,   5.0527628E-06,   6.6373987E-06
     +,   8.6682894E-06,   1.1254622E-05,   1.4527885E-05
     +,   1.8644281E-05,   2.3788800E-05,   3.0177458E-05
     +,   3.8061444E-05,   4.7729947E-05,   5.9511967E-05
     +,   7.3778654E-05,   9.0945854E-05,   1.1147404E-04
     +,   1.3586537E-04,   1.6466656E-04,   1.9845933E-04
     +,   2.3786265E-04,   2.8351744E-04,   3.3608801E-04
     +,   3.9624027E-04,   4.6464294E-04,   5.4193835E-04
     +,   6.2874303E-04,   7.2562537E-04,   8.3308143E-04
     +,   9.5152343E-04,   1.0812698E-03,   1.2225234E-03
     +,   1.3753393E-03,   1.5396440E-03,   1.7151828E-03
     +,   1.9015531E-03,   2.0981506E-03,   2.3042145E-03
     +,   2.5187784E-03,   2.7407284E-03,   2.9687611E-03
     +,   3.2014528E-03,   3.4372641E-03,   3.6745663E-03
     +,   3.9117006E-03,   4.1470570E-03,   4.3791318E-03
     +,   4.6065878E-03,   4.8284056E-03,   5.0439253E-03
     +,   5.2530076E-03,   5.4560835E-03,   5.6542889E-03
     +,   5.8494704E-03,   6.0442602E-03,   6.2419814E-03
     +,   6.4465944E-03,   6.6625024E-03,   6.8942648E-03
     +,   7.1462700E-03,   7.4223420E-03,   7.7252565E-03
     +,   8.0562318E-03,   8.4145376E-03,   8.7970197E-03
     +,   9.1979271E-03,   9.6087176E-03,   1.0018310E-02
     +,   1.0413391E-02,   1.0779294E-02,   1.1101085E-02
     +,   1.1365330E-02,   1.1562296E-02,   1.1688713E-02
     +,   1.1750826E-02,   1.1767031E-02,   1.1768996E-02
     +,   1.1799843E-02,   1.1908195E-02,   1.2138433E-02
     +,   1.2520738E-02,   1.3069835E-02,   1.3807628E-02
     +,   1.4827048E-02,   1.6404653E-02,   1.9138211E-02
     +,   2.4036007E-02,   3.2447413E-02,   4.5747325E-02
     +,   6.4800173E-02,   8.9388885E-02,   0.1179065    
     +,   0.1476014    ,   0.1754735    ,   0.1995166    
     +,   0.2195877    ,   0.2371522    ,   0.2537536    
     +,   0.2690111    ,   0.2795720    ,   0.2800974    
     +,   0.2660740    ,   0.2367973    ,   0.1964592    
     +,   0.1525032    ,   0.1123964    ,   8.0942415E-02
     +,   5.9459746E-02,   4.6641376E-02,   4.0041786E-02
     +,   3.7249949E-02,   3.6422350E-02,   3.6337383E-02
     +,   3.6258783E-02,   3.5793301E-02,   3.4793068E-02
     +,   3.3283606E-02,   3.1395312E-02,   2.9297009E-02
     +,   2.7142229E-02,   2.5038172E-02,   2.3038790E-02
     +,   2.1155028E-02,   1.9372618E-02,   1.7669555E-02
     +,   1.6028784E-02,   1.4444416E-02,   1.2921957E-02
     +,   1.1475514E-02,   1.0123439E-02,   8.8838739E-03
     +,   7.7713225E-03,   6.7947498E-03,   5.9569213E-03
     +,   5.2545988E-03,   4.6794587E-03,   4.2194463E-03
     +,   3.8601584E-03,   3.5860590E-03,   3.3815338E-03
     +,   3.2317333E-03,   3.1231381E-03,   3.0438725E-03
     +,   2.9838718E-03,   2.9348922E-03,   2.8904076E-03
     +,   2.8454489E-03,   2.7964124E-03,   2.7408535E-03
     +,   2.6772858E-03,   2.6049903E-03,   2.5238551E-03
     +,   2.4342374E-03,   2.3368467E-03,   2.2326335E-03
     +,   2.1227181E-03,   2.0083329E-03,   1.8907487E-03
     +,   1.7712401E-03,   1.6510579E-03,   1.5313920E-03
     +,   1.4133406E-03,   1.2979001E-03,   1.1859606E-03
     +,   1.0782875E-03,   9.7551249E-04,   8.7813946E-04
     +,   7.8655267E-04,   7.0101517E-04,   6.2167109E-04
     +,   5.4856221E-04,   4.8164453E-04,   4.2078568E-04
     +,   3.6578599E-04,   3.1639292E-04,   2.7230909E-04
     +,   2.3320147E-04,   1.9871550E-04,   1.6848679E-04
     +,   1.4214645E-04,   1.1932732E-04,   9.9672383E-05
     +,   8.2840597E-05,   6.8509064E-05,   5.6375011E-05
     +,   4.6158955E-05,   3.7606413E-05,   3.0486071E-05
     +,   2.4590739E-05,   1.9736746E-05,   1.5762171E-05
     +,   1.2525361E-05,   9.9036433E-06,   7.7917166E-06
     +,   6.0997008E-06,   4.7513549E-06,   3.6826179E-06
     +,   2.8400714E-06,   2.1794124E-06,   1.6641130E-06
     +,   1.2643181E-06,   9.5580117E-07,   7.1897296E-07
     +,   5.3812954E-07,   4.0076944E-07,   2.9698933E-07
     +,   2.1898785E-07,   1.6066767E-07,   1.1729279E-07
     +,   8.5202380E-08,   6.1583727E-08,   4.4290346E-08
     +,   3.1694995E-08,   2.2568416E-08,   1.5990041E-08
     +,   1.1272695E-08,   7.9075937E-09,   5.5193636E-09
     +,   3.8332932E-09,   2.6490150E-09,   1.8215272E-09
     +,   1.2462769E-09,   8.4846330E-10,   5.7475796E-10
     +,   3.8740519E-10,   2.5982702E-10,   1.7339304E-10
     +,   1.1513800E-10,   7.6073411E-11,   5.0013545E-11
     +,   3.2716645E-11,   2.1295668E-11,   1.3792408E-11
     +,   8.8885036E-12,   5.6996001E-12,   3.6366429E-12
     +,   2.3087881E-12,   1.4585056E-12
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_haonly_ttz85_mass = Yx/1.09200161538462
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_haonly_ttz90_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.3545451E-03,   1.3895556E-03
     +,   1.4232659E-03,   1.4555384E-03,   1.4862397E-03
     +,   1.5152409E-03,   1.5424179E-03,   1.5676535E-03
     +,   1.5908363E-03,   1.6118650E-03,   1.6306449E-03
     +,   1.6470914E-03,   1.6611300E-03,   1.6726963E-03
     +,   1.6817374E-03,   1.6882115E-03,   1.6920887E-03
     +,   1.6933508E-03,   1.6919922E-03,   1.6880190E-03
     +,   1.6814498E-03,   1.6723151E-03,   1.6606569E-03
     +,   1.6465281E-03,   1.6299947E-03,   1.6111305E-03
     +,   1.5900207E-03,   1.5667600E-03,   1.5414511E-03
     +,   1.5142047E-03,   1.4851389E-03,   1.4543771E-03
     +,   1.4220494E-03,   1.3882889E-03,   1.3532332E-03
     +,   1.3170219E-03,   1.2797966E-03,   1.2417000E-03
     +,   1.2028726E-03,   1.1634575E-03,   1.1235925E-03
     +,   1.0834147E-03,   1.0430574E-03,   1.0026498E-03
     +,   9.6231635E-04,   9.2217652E-04,   8.8234380E-04
     +,   8.4292563E-04,   8.0402248E-04,   7.6572841E-04
     +,   7.2812993E-04,   6.9130649E-04,   6.5533043E-04
     +,   6.2026439E-04,   5.8616744E-04,   5.5308739E-04
     +,   5.2106683E-04,   4.9014058E-04,   4.6033654E-04
     +,   4.3167602E-04,   4.0417354E-04,   3.7783742E-04
     +,   3.5267172E-04,   3.2867290E-04,   3.0583254E-04
     +,   2.8413988E-04,   2.6357680E-04,   2.4412418E-04
     +,   2.2575683E-04,   2.0844894E-04,   1.9216971E-04
     +,   1.7688825E-04,   1.6256962E-04,   1.4917931E-04
     +,   1.3668013E-04,   1.2503413E-04,   1.1420347E-04
     +,   1.0414990E-04,   9.4834424E-05,   8.6218315E-05
     +,   7.8263969E-05,   7.0933347E-05,   6.4190113E-05
     +,   5.7997837E-05,   5.2322022E-05,   4.7128484E-05
     +,   4.2384931E-05,   3.8059712E-05,   3.4123110E-05
     +,   3.0546347E-05,   2.7302105E-05,   2.4364659E-05
     +,   2.1709699E-05,   1.9314126E-05,   1.7156239E-05
     +,   1.5215923E-05,   1.3474128E-05,   1.1913299E-05
     +,   1.0516945E-05,   9.2699229E-06,   8.1580920E-06
     +,   7.1685376E-06,   6.2892404E-06,   5.5092864E-06
     +,   4.8185912E-06,   4.2079491E-06,   3.6690046E-06
     +,   3.1941531E-06,   2.7764572E-06,   2.4096369E-06
     +,   2.0880543E-06,   1.8065831E-06,   1.5606440E-06
     +,   1.3460970E-06,   1.1592614E-06,   9.9682836E-07
     +,   8.5587772E-07,   7.3382165E-07,   6.2843890E-07
     +,   5.3788489E-07,   4.6080964E-07,   3.9659736E-07
     +,   3.4583775E-07,   3.1123295E-07,   2.9928327E-07
     +,   3.2327733E-07,   4.0846231E-07,   6.0071659E-07
     +,   9.8074270E-07,   1.6864344E-06,   2.9474702E-06
     +,   5.1364264E-06,   8.8431943E-06,   1.4977406E-05
     +,   2.4907438E-05,   4.0638726E-05,   6.5031294E-05
     +,   1.0205299E-04,   1.5705574E-04,   2.3704111E-04
     +,   3.5086606E-04,   5.0933973E-04,   7.2514242E-04
     +,   1.0124560E-03,   1.3861991E-03,   1.8609398E-03
     +,   2.4493104E-03,   3.1600259E-03,   3.9957836E-03
     +,   4.9513327E-03,   6.0120216E-03,   7.1534943E-03
     +,   8.3434982E-03,   9.5465388E-03,   1.0732070E-02
     +,   1.1886992E-02,   1.3032930E-02,   1.4247052E-02
     +,   1.5684135E-02,   1.7595176E-02,   2.0336416E-02
     +,   2.4359887E-02,   3.0177845E-02,   3.8297396E-02
     +,   4.9129024E-02,   6.2879518E-02,   7.9450808E-02
     +,   9.8373495E-02,   0.1187987    ,   0.1395573    
     +,   0.1592852    ,   0.1765942    ,   0.1902541    
     +,   0.1993449    ,   0.2033576    ,   0.2022333    
     +,   0.1963366    ,   0.1863841    ,   0.1733424    
     +,   0.1583080    ,   0.1423887    ,   0.1265953    
     +,   0.1117500    ,   9.8427370E-02,   8.6931966E-02
     +,   7.7314928E-02,   6.9419824E-02,   6.2950283E-02
     +,   5.7544891E-02,   5.2844901E-02,   4.8543893E-02
     +,   4.4417929E-02,   4.0334553E-02,   3.6244612E-02
     +,   3.2163292E-02,   2.8147338E-02,   2.4272960E-02
     +,   2.0617325E-02,   1.7245730E-02,   1.4205036E-02
     +,   1.1521629E-02,   9.2022903E-03,   7.2371652E-03
     +,   5.6039002E-03,   4.2717927E-03,   3.2051252E-03
     +,   2.3664215E-03,   1.7188611E-03,   1.2279106E-03
     +,   8.6242997E-04,   5.9532566E-04,   4.0374143E-04
     +,   2.6891122E-04,   1.7583146E-04,   1.1282088E-04
     +,   7.1011083E-05,   4.3827913E-05,   2.6515709E-05
     +,   1.5719237E-05,   9.1288666E-06,   5.1919642E-06
     +,   2.8910695E-06,   1.5758302E-06,   8.4063834E-07
     +,   4.3881028E-07,   2.2409920E-07,   1.1195825E-07
     +,   5.4712892E-08,   2.6151387E-08,   1.2224440E-08
     +,   5.5882783E-09,   2.4982325E-09,   1.0921081E-09
     +,   4.6682180E-10,   1.9511975E-10,   7.9743871E-11
     +,   3.1865337E-11,   1.2450079E-11,   4.7562939E-12
     +,   1.7766054E-12,   6.4881612E-13,   2.3167202E-13
     +,   8.0883440E-14,   2.7609871E-14,   9.2145106E-15
     +,   3.0067463E-15,   9.5929647E-16,   2.9924644E-16
     +,   9.1265398E-17,   2.7215920E-17,   7.9355125E-18
     +,   2.2623979E-18,   6.3079858E-19,   1.7208535E-19
     +,   4.5983852E-20,   1.2072814E-20,   3.1410310E-21
     +,   8.2850312E-22,   2.3401648E-22,   7.8179883E-23
     +,   3.3804274E-23,   1.8512502E-23,   1.1605165E-23
     +,   7.6944925E-24,   5.2003719E-24,   3.5335703E-24
     +,   2.4025674E-24,   1.6321582E-24,   1.1073264E-24
     +,   7.5014208E-25,   5.0738597E-25,   3.4266224E-25
     +,   2.3106120E-25,   1.5556625E-25,   1.0457458E-25
     +,   7.0189041E-26,   4.7036491E-26,   3.1472734E-26
     +,   2.1025832E-26,   1.4025206E-26,   9.3408041E-27
     +,   6.2114553E-27,   4.1240589E-27,   2.7339384E-27
     +,   1.8095683E-27,   1.1959011E-27,   7.8911970E-28
     +,   5.1988981E-28,   3.4198895E-28,   2.2461490E-28
     +,   1.4729761E-28,   9.6443632E-29,   6.3050065E-29
     +,   4.1154740E-29,   2.6821818E-29,   1.7453289E-29
     +,   1.1339757E-29,   7.3560992E-30,   4.7645886E-30
     +,   3.0812410E-30,   1.9895656E-30
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_haonly_ttz90_mass = Yx/0.93129925
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_haonly_ttz95_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  5.6619919E-04,   5.9685315E-04
     +,   6.2858965E-04,   6.6141854E-04,   6.9534982E-04
     +,   7.3039340E-04,   7.6655910E-04,   8.0385711E-04
     +,   8.4229704E-04,   8.8189106E-04,   9.2264981E-04
     +,   9.6458534E-04,   1.0077102E-03,   1.0520378E-03
     +,   1.0975818E-03,   1.1443576E-03,   1.1923796E-03
     +,   1.2416642E-03,   1.2922272E-03,   1.3440839E-03
     +,   1.3972509E-03,   1.4517431E-03,   1.5075731E-03
     +,   1.5647564E-03,   1.6232997E-03,   1.6832136E-03
     +,   1.7445014E-03,   1.8071636E-03,   1.8711956E-03
     +,   1.9365875E-03,   2.0033226E-03,   2.0713776E-03
     +,   2.1407201E-03,   2.2113090E-03,   2.2830949E-03
     +,   2.3560154E-03,   2.4299982E-03,   2.5049571E-03
     +,   2.5807982E-03,   2.6574060E-03,   2.7346583E-03
     +,   2.8124165E-03,   2.8905263E-03,   2.9688205E-03
     +,   3.0471168E-03,   3.1252194E-03,   3.2029185E-03
     +,   3.2799907E-03,   3.3562011E-03,   3.4313027E-03
     +,   3.5050390E-03,   3.5771437E-03,   3.6473419E-03
     +,   3.7153582E-03,   3.7809049E-03,   3.8436987E-03
     +,   3.9034525E-03,   3.9598830E-03,   4.0127095E-03
     +,   4.0616584E-03,   4.1064648E-03,   4.1468744E-03
     +,   4.1826451E-03,   4.2135511E-03,   4.2393855E-03
     +,   4.2599556E-03,   4.2750975E-03,   4.2846617E-03
     +,   4.2885304E-03,   4.2866073E-03,   4.2788251E-03
     +,   4.2651435E-03,   4.2455513E-03,   4.2200661E-03
     +,   4.1887346E-03,   4.1516307E-03,   4.1088597E-03
     +,   4.0605552E-03,   4.0068757E-03,   3.9480049E-03
     +,   3.8841567E-03,   3.8155592E-03,   3.7424737E-03
     +,   3.6651683E-03,   3.5839400E-03,   3.4990914E-03
     +,   3.4109477E-03,   3.3198341E-03,   3.2260963E-03
     +,   3.1300755E-03,   3.0321172E-03,   2.9325734E-03
     +,   2.8317964E-03,   2.7301270E-03,   2.6279003E-03
     +,   2.5254539E-03,   2.4231032E-03,   2.3211634E-03
     +,   2.2199247E-03,   2.1196757E-03,   2.0206755E-03
     +,   1.9231800E-03,   1.8274140E-03,   1.7335960E-03
     +,   1.6419168E-03,   1.5525476E-03,   1.4656462E-03
     +,   1.3813495E-03,   1.2997710E-03,   1.2210042E-03
     +,   1.1451319E-03,   1.0722089E-03,   1.0022823E-03
     +,   9.3537290E-04,   8.7149517E-04,   8.1063999E-04
     +,   7.5279252E-04,   6.9791748E-04,   6.4597541E-04
     +,   5.9691089E-04,   5.5065891E-04,   5.0714967E-04
     +,   4.6630559E-04,   4.2803987E-04,   3.9226122E-04
     +,   3.5887721E-04,   3.2778792E-04,   2.9889497E-04
     +,   2.7209491E-04,   2.4728745E-04,   2.2436937E-04
     +,   2.0324258E-04,   1.8380994E-04,   1.6598363E-04
     +,   1.4968512E-04,   1.3485526E-04,   1.2146746E-04
     +,   1.0954707E-04,   9.9203404E-05,   9.0681075E-05
     +,   8.4436011E-05,   8.1244558E-05,   8.2358165E-05
     +,   8.9714005E-05,   1.0620626E-04,   1.3602630E-04
     +,   1.8506279E-04,   2.6133700E-04,   3.7544387E-04
     +,   5.4095028E-04,   7.7465700E-04,   1.0966235E-03
     +,   1.5299078E-03,   2.0999608E-03,   2.8335834E-03
     +,   3.7574593E-03,   4.8965318E-03,   6.2724426E-03
     +,   7.9021882E-03,   9.7973179E-03,   1.1964827E-02
     +,   1.4409051E-02,   1.7135276E-02,   2.0155160E-02
     +,   2.3493487E-02,   2.7194805E-02,   3.1328950E-02
     +,   3.5994384E-02,   4.1317340E-02,   4.7444839E-02
     +,   5.4530486E-02,   6.2714800E-02,   7.2100185E-02
     +,   8.2722485E-02,   9.4522543E-02,   0.1073265    
     +,   0.1208331    ,   0.1346147    ,   0.1481362    
     +,   0.1607908    ,   0.1719463    ,   0.1810007    
     +,   0.1874405    ,   0.1908917    ,   0.1911553    
     +,   0.1882258    ,   0.1822891    ,   0.1736998    
     +,   0.1629445    ,   0.1505965    ,   0.1372636    
     +,   0.1235411    ,   0.1099710    ,   9.7009175E-02
     +,   8.5003071E-02,   7.4184485E-02,   6.4672515E-02
     +,   5.6485184E-02,   4.9558900E-02,   4.3772500E-02
     +,   3.8971618E-02,   3.4989458E-02,   3.1663436E-02
     +,   2.8846864E-02,   2.6415125E-02,   2.4266906E-02
     +,   2.2323417E-02,   2.0525847E-02,   1.8832076E-02
     +,   1.7213635E-02,   1.5653277E-02,   1.4142912E-02
     +,   1.2681619E-02,   1.1273796E-02,   9.9275196E-03
     +,   8.6529329E-03,   7.4605485E-03,   6.3597960E-03
     +,   5.3580427E-03,   4.4599758E-03,   3.6670831E-03
     +,   2.9777980E-03,   2.3878480E-03,   1.8906955E-03
     +,   1.4781234E-03,   1.1409088E-03,   8.6942222E-04
     +,   6.5409561E-04,   4.8581022E-04,   3.5619727E-04
     +,   2.5781267E-04,   1.8420425E-04,   1.2991467E-04
     +,   9.0439949E-05,   6.2144383E-05,   4.2146636E-05
     +,   2.8211307E-05,   1.8636883E-05,   1.2150825E-05
     +,   7.8180938E-06,   4.9640757E-06,   3.1103684E-06
     +,   1.9231593E-06,   1.1733561E-06,   7.0637589E-07
     +,   4.1959299E-07,   2.4592464E-07,   1.4221287E-07
     +,   8.1136832E-08,   4.5671349E-08,   2.5362713E-08
     +,   1.3894849E-08,   7.5095512E-09,   4.0038071E-09
     +,   2.1057678E-09,   1.0924610E-09,   5.5905680E-10
     +,   2.8220110E-10,   1.4050630E-10,   6.8999154E-11
     +,   3.3419725E-11,   1.5965224E-11,   7.5221279E-12
     +,   3.4952638E-12,   1.6018042E-12,   7.2395714E-13
     +,   3.2268226E-13,   1.4184502E-13,   6.1496815E-14
     +,   2.6297225E-14,   1.1092543E-14,   4.6168374E-15
     +,   1.8970675E-15,   7.7028567E-16,   3.0962699E-16
     +,   1.2364718E-16,   4.9374278E-17,   1.9950336E-17
     +,   8.3201325E-18,   3.6861430E-18,   1.7906299E-18
     +,   9.7234171E-19,   5.8679913E-19,   3.8359532E-19
     +,   2.6376112E-19,   1.8655428E-19,   1.3386823E-19
     +,   9.6727935E-20,   7.0107169E-20,   5.0871401E-20
     +,   3.6923145E-20,   2.6793740E-20,   1.9435528E-20
     +,   1.4090674E-20,   1.0209849E-20,   7.3932313E-21
     +,   5.3502474E-21,   3.8691583E-21,   2.7961516E-21
     +,   2.0192369E-21,   1.4571240E-21
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_haonly_ttz95_mass = Yx/1.0873548
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_haonly_hatt100_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.1616241E-03,   2.2235592E-03
     +,   2.2854107E-03,   2.3471056E-03,   2.4085746E-03
     +,   2.4697534E-03,   2.5305832E-03,   2.5910120E-03
     +,   2.6509948E-03,   2.7104968E-03,   2.7694916E-03
     +,   2.8279617E-03,   2.8859039E-03,   2.9433239E-03
     +,   3.0002426E-03,   3.0566950E-03,   3.1127289E-03
     +,   3.1684106E-03,   3.2238220E-03,   3.2790601E-03
     +,   3.3342440E-03,   3.3895096E-03,   3.4450092E-03
     +,   3.5009244E-03,   3.5574466E-03,   3.6147973E-03
     +,   3.6732173E-03,   3.7329691E-03,   3.7943383E-03
     +,   3.8576385E-03,   3.9232019E-03,   3.9913892E-03
     +,   4.0625846E-03,   4.1371994E-03,   4.2156656E-03
     +,   4.2984458E-03,   4.3860236E-03,   4.4789067E-03
     +,   4.5776344E-03,   4.6827542E-03,   4.7948482E-03
     +,   4.9145105E-03,   5.0423546E-03,   5.1790052E-03
     +,   5.3251046E-03,   5.4812920E-03,   5.6482134E-03
     +,   5.8265151E-03,   6.0168272E-03,   6.2197656E-03
     +,   6.4359242E-03,   6.6658617E-03,   6.9100955E-03
     +,   7.1691046E-03,   7.4432809E-03,   7.7329786E-03
     +,   8.0384482E-03,   8.3598569E-03,   8.6972658E-03
     +,   9.0506291E-03,   9.4197728E-03,   9.8044006E-03
     +,   1.0204052E-02,   1.0618147E-02,   1.1045955E-02
     +,   1.1486549E-02,   1.1938893E-02,   1.2401731E-02
     +,   1.2873713E-02,   1.3353260E-02,   1.3838710E-02
     +,   1.4328190E-02,   1.4819758E-02,   1.5311280E-02
     +,   1.5800567E-02,   1.6285341E-02,   1.6763212E-02
     +,   1.7231740E-02,   1.7688487E-02,   1.8131001E-02
     +,   1.8556805E-02,   1.8963521E-02,   1.9348776E-02
     +,   1.9710345E-02,   2.0046065E-02,   2.0353954E-02
     +,   2.0632157E-02,   2.0879023E-02,   2.1093080E-02
     +,   2.1273088E-02,   2.1418041E-02,   2.1527162E-02
     +,   2.1599924E-02,   2.1636074E-02,   2.1635603E-02
     +,   2.1598767E-02,   2.1526070E-02,   2.1418288E-02
     +,   2.1276407E-02,   2.1101670E-02,   2.0895496E-02
     +,   2.0659549E-02,   2.0395629E-02,   2.0105725E-02
     +,   1.9791933E-02,   1.9456482E-02,   1.9101704E-02
     +,   1.8730002E-02,   1.8343819E-02,   1.7945612E-02
     +,   1.7537909E-02,   1.7123191E-02,   1.6703943E-02
     +,   1.6282599E-02,   1.5861606E-02,   1.5443311E-02
     +,   1.5030077E-02,   1.4624156E-02,   1.4227823E-02
     +,   1.3843277E-02,   1.3472666E-02,   1.3118169E-02
     +,   1.2781931E-02,   1.2466070E-02,   1.2172730E-02
     +,   1.1904087E-02,   1.1662319E-02,   1.1449659E-02
     +,   1.1268357E-02,   1.1120732E-02,   1.1009119E-02
     +,   1.0935904E-02,   1.0903490E-02,   1.0914292E-02
     +,   1.0970709E-02,   1.1075122E-02,   1.1229830E-02
     +,   1.1437029E-02,   1.1698770E-02,   1.2016944E-02
     +,   1.2393154E-02,   1.2828690E-02,   1.3324511E-02
     +,   1.3881123E-02,   1.4498483E-02,   1.5175989E-02
     +,   1.5912384E-02,   1.6705608E-02,   1.7552765E-02
     +,   1.8450124E-02,   1.9392986E-02,   2.0375581E-02
     +,   2.1391112E-02,   2.2431808E-02,   2.3488915E-02
     +,   2.4552656E-02,   2.5612462E-02,   2.6657186E-02
     +,   2.7675215E-02,   2.8654713E-02,   2.9584065E-02
     +,   3.0452151E-02,   3.1248670E-02,   3.1964589E-02
     +,   3.2592554E-02,   3.3127151E-02,   3.3565175E-02
     +,   3.3905800E-02,   3.4150701E-02,   3.4303911E-02
     +,   3.4371641E-02,   3.4362011E-02,   3.4284700E-02
     +,   3.4150492E-02,   3.3971079E-02,   3.3758797E-02
     +,   3.3526696E-02,   3.3288952E-02,   3.3061489E-02
     +,   3.2863118E-02,   3.2717045E-02,   3.2652739E-02
     +,   3.2708172E-02,   3.2932345E-02,   3.3388082E-02
     +,   3.4154814E-02,   3.5331551E-02,   3.7039589E-02
     +,   3.9424725E-02,   4.2658053E-02,   4.6935707E-02
     +,   5.2475311E-02,   5.9508402E-02,   6.8268172E-02
     +,   7.8972436E-02,   9.1799125E-02,   0.1068563    
     +,   0.1241495    ,   0.1435497    ,   0.1647641    
     +,   0.1873142    ,   0.2105327    ,   0.2335799    
     +,   0.2554788    ,   0.2751722    ,   0.2916040    
     +,   0.3038041    ,   0.3109775    ,   0.3125858    
     +,   0.3084044    ,   0.2985511    ,   0.2834814    
     +,   0.2639502    ,   0.2409407    ,   0.2155770    
     +,   0.1890284    ,   0.1624144    ,   0.1367225    
     +,   0.1127523    ,   9.1085233E-02,   7.2072878E-02
     +,   5.5855416E-02,   4.2394347E-02,   3.1512570E-02
     +,   2.2938890E-02,   1.6351389E-02,   1.1413606E-02
     +,   7.8014154E-03,   5.2214749E-03,   3.4219213E-03
     +,   2.1958598E-03,   1.3797482E-03,   8.4888237E-04
     +,   5.1137339E-04,   3.0163763E-04,   1.7421367E-04
     +,   9.8519238E-05,   5.4551929E-05,   2.9577430E-05
     +,   1.5702391E-05,   8.1624476E-06,   4.1546728E-06
     +,   2.0707669E-06,   1.0106540E-06,   4.8300626E-07
     +,   2.2605387E-07,   1.0361531E-07,   4.6519364E-08
     +,   2.0460970E-08,   8.8205585E-09,   3.7294390E-09
     +,   1.5485576E-09,   6.3302180E-10,   2.5591321E-10
     +,   1.0316126E-10,   4.2066857E-11,   1.7756885E-11
     +,   8.0007953E-12,   3.9615091E-12,   2.1807491E-12
     +,   1.3173758E-12,   8.4965845E-13,   5.6965278E-13
     +,   3.8964128E-13,   2.6892841E-13,   1.8619920E-13
     +,   1.2894873E-13,   8.9197672E-14,   6.1590659E-14
     +,   4.2440203E-14,   2.9180593E-14,   2.0020039E-14
     +,   1.3705962E-14,   9.3637570E-15,   6.3843588E-15
     +,   4.3447776E-15,   2.9515155E-15,   2.0018199E-15
     +,   1.3557251E-15,   9.1703651E-16,   6.1967199E-16
     +,   4.1843335E-16,   2.8242863E-16,   1.9062259E-16
     +,   1.2870261E-16,   8.6967606E-17,   5.8842876E-17
     +,   3.9886662E-17,   2.7103221E-17,   1.8472548E-17
     +,   1.2636352E-17,   8.6808254E-18,   5.9924951E-18
     +,   4.1588941E-18,   2.9031932E-18,   2.0391168E-18
     +,   1.4413943E-18,   1.0254770E-18,   7.3427996E-19
     +,   5.2905934E-19,   3.8347385E-19
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_haonly_hatt100_mass = Yx/2.0740286
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_haonly_hatt105_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  7.0483573E-03,   7.3928381E-03
     +,   7.7427612E-03,   8.0972631E-03,   8.4554302E-03
     +,   8.8163028E-03,   9.1788787E-03,   9.5421309E-03
     +,   9.9049946E-03,   1.0266421E-02,   1.0625332E-02
     +,   1.0980665E-02,   1.1331376E-02,   1.1676451E-02
     +,   1.2014912E-02,   1.2345830E-02,   1.2668341E-02
     +,   1.2981638E-02,   1.3285001E-02,   1.3577784E-02
     +,   1.3859445E-02,   1.4129528E-02,   1.4387674E-02
     +,   1.4633650E-02,   1.4867298E-02,   1.5088598E-02
     +,   1.5297613E-02,   1.5494529E-02,   1.5679622E-02
     +,   1.5853269E-02,   1.6015941E-02,   1.6168201E-02
     +,   1.6310677E-02,   1.6444080E-02,   1.6569179E-02
     +,   1.6686797E-02,   1.6797800E-02,   1.6903080E-02
     +,   1.7003553E-02,   1.7100140E-02,   1.7193768E-02
     +,   1.7285332E-02,   1.7375711E-02,   1.7465746E-02
     +,   1.7556209E-02,   1.7647825E-02,   1.7741231E-02
     +,   1.7836984E-02,   1.7935541E-02,   1.8037248E-02
     +,   1.8142344E-02,   1.8250948E-02,   1.8363032E-02
     +,   1.8478464E-02,   1.8596960E-02,   1.8718129E-02
     +,   1.8841423E-02,   1.8966205E-02,   1.9091723E-02
     +,   1.9217117E-02,   1.9341452E-02,   1.9463753E-02
     +,   1.9582979E-02,   1.9698108E-02,   1.9808119E-02
     +,   1.9912040E-02,   2.0008994E-02,   2.0098198E-02
     +,   2.0179018E-02,   2.0251008E-02,   2.0313935E-02
     +,   2.0367781E-02,   2.0412814E-02,   2.0449564E-02
     +,   2.0478882E-02,   2.0501904E-02,   2.0520087E-02
     +,   2.0535180E-02,   2.0549241E-02,   2.0564573E-02
     +,   2.0583732E-02,   2.0609459E-02,   2.0644654E-02
     +,   2.0692304E-02,   2.0755434E-02,   2.0837035E-02
     +,   2.0939969E-02,   2.1066941E-02,   2.1220351E-02
     +,   2.1402275E-02,   2.1614386E-02,   2.1857811E-02
     +,   2.2133136E-02,   2.2440312E-02,   2.2778636E-02
     +,   2.3146641E-02,   2.3542158E-02,   2.3962237E-02
     +,   2.4403218E-02,   2.4860665E-02,   2.5329536E-02
     +,   2.5804127E-02,   2.6278254E-02,   2.6745269E-02
     +,   2.7198259E-02,   2.7630169E-02,   2.8033881E-02
     +,   2.8402470E-02,   2.8729349E-02,   2.9008461E-02
     +,   2.9234411E-02,   2.9402679E-02,   2.9509813E-02
     +,   2.9553575E-02,   2.9533071E-02,   2.9448910E-02
     +,   2.9303290E-02,   2.9100075E-02,   2.8844878E-02
     +,   2.8545072E-02,   2.8209725E-02,   2.7849615E-02
     +,   2.7477164E-02,   2.7106198E-02,   2.6751872E-02
     +,   2.6430482E-02,   2.6159108E-02,   2.5955480E-02
     +,   2.5837520E-02,   2.5823090E-02,   2.5929553E-02
     +,   2.6173368E-02,   2.6569726E-02,   2.7131991E-02
     +,   2.7871393E-02,   2.8796570E-02,   2.9913053E-02
     +,   3.1222977E-02,   3.2724787E-02,   3.4413051E-02
     +,   3.6278021E-02,   3.8305704E-02,   4.0478040E-02
     +,   4.2772930E-02,   4.5164242E-02,   4.7622737E-02
     +,   5.0116301E-02,   5.2610487E-02,   5.5069409E-02
     +,   5.7456791E-02,   5.9736736E-02,   6.1874438E-02
     +,   6.3837461E-02,   6.5596618E-02,   6.7126818E-02
     +,   6.8407610E-02,   6.9424026E-02,   7.0167020E-02
     +,   7.0633575E-02,   7.0826843E-02,   7.0756137E-02
     +,   7.0436351E-02,   6.9887601E-02,   6.9134578E-02
     +,   6.8205684E-02,   6.7131996E-02,   6.5946557E-02
     +,   6.4683139E-02,   6.3375294E-02,   6.2055372E-02
     +,   6.0753703E-02,   5.9497725E-02,   5.8311190E-02
     +,   5.7213724E-02,   5.6220528E-02,   5.5341832E-02
     +,   5.4583054E-02,   5.3944811E-02,   5.3423159E-02
     +,   5.3009842E-02,   5.2692909E-02,   5.2457295E-02
     +,   5.2285381E-02,   5.2157823E-02,   5.2054204E-02
     +,   5.1953819E-02,   5.1836353E-02,   5.1682480E-02
     +,   5.1474482E-02,   5.1196653E-02,   5.0835669E-02
     +,   5.0380848E-02,   4.9824249E-02,   4.9160719E-02
     +,   4.8387799E-02,   4.7505524E-02,   4.6516318E-02
     +,   4.5424670E-02,   4.4236757E-02,   4.2960137E-02
     +,   4.1603599E-02,   4.0176716E-02,   3.8689516E-02
     +,   3.7152298E-02,   3.5575535E-02,   3.3969458E-02
     +,   3.2343991E-02,   3.0708792E-02,   2.9073017E-02
     +,   2.7445205E-02,   2.5833292E-02,   2.4244731E-02
     +,   2.2686342E-02,   2.1164209E-02,   1.9683817E-02
     +,   1.8250113E-02,   1.6867427E-02,   1.5539377E-02
     +,   1.4269008E-02,   1.3058880E-02,   1.1910850E-02
     +,   1.0826216E-02,   9.8057967E-03,   8.8498751E-03
     +,   7.9581682E-03,   7.1299141E-03,   6.3639777E-03
     +,   5.6588058E-03,   5.0124414E-03,   4.4226176E-03
     +,   3.8868431E-03,   3.4023980E-03,   2.9663611E-03
     +,   2.5757002E-03,   2.2273420E-03,   1.9181491E-03
     +,   1.6449993E-03,   1.4048381E-03,   1.1946877E-03
     +,   1.0116657E-03,   8.5302390E-04,   7.1617635E-04
     +,   5.9869688E-04,   4.9832393E-04,   4.1297518E-04
     +,   3.4075274E-04,   2.7993310E-04,   2.2896026E-04
     +,   1.8644406E-04,   1.5115421E-04,   1.2200224E-04
     +,   9.8035540E-05,   7.8427227E-05,   6.2462197E-05
     +,   4.9525406E-05,   3.9092436E-05,   3.0719337E-05
     +,   2.4031780E-05,   1.8715835E-05,   1.4510278E-05
     +,   1.1199192E-05,   8.6048603E-06,   6.5817535E-06
     +,   5.0115768E-06,   3.7988129E-06,   2.8665318E-06
     +,   2.1532542E-06,   1.6101491E-06,   1.1985928E-06
     +,   8.8819138E-07,   6.5518657E-07,   4.8111627E-07
     +,   3.5169367E-07,   2.5591925E-07,   1.8537857E-07
     +,   1.3367246E-07,   9.5948785E-08,   6.8558364E-08
     +,   4.8763340E-08,   3.4526103E-08,   2.4333875E-08
     +,   1.7072329E-08,   1.1922880E-08,   8.2886666E-09
     +,   5.7357767E-09,   3.9510493E-09,   2.7091838E-09
     +,   1.8491118E-09,   1.2563092E-09,   8.4962087E-10
     +,   5.7195221E-10,   3.8325335E-10,   2.5563152E-10
     +,   1.6971920E-10,   1.1216243E-10,   7.3781752E-11
     +,   4.8310869E-11,   3.1486400E-11,   2.0426471E-11
     +,   1.3189876E-11,   8.4776769E-12
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_haonly_hatt105_mass = Yx/1.62478303448276
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_haonly_hatt107_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.8640505E-03,   4.9559069E-03
     +,   5.0469204E-03,   5.1371795E-03,   5.2268002E-03
     +,   5.3159120E-03,   5.4046689E-03,   5.4932460E-03
     +,   5.5818344E-03,   5.6706541E-03,   5.7599419E-03
     +,   5.8499570E-03,   5.9409793E-03,   6.0333107E-03
     +,   6.1272727E-03,   6.2232069E-03,   6.3214763E-03
     +,   6.4224596E-03,   6.5265512E-03,   6.6341627E-03
     +,   6.7457147E-03,   6.8616392E-03,   6.9823693E-03
     +,   7.1083489E-03,   7.2400020E-03,   7.3777582E-03
     +,   7.5220205E-03,   7.6731746E-03,   7.8315716E-03
     +,   7.9975203E-03,   8.1712846E-03,   8.3530676E-03
     +,   8.5430043E-03,   8.7411553E-03,   8.9474907E-03
     +,   9.1618886E-03,   9.3841236E-03,   9.6138623E-03
     +,   9.8506697E-03,   1.0093971E-02,   1.0343111E-02
     +,   1.0597304E-02,   1.0855664E-02,   1.1117219E-02
     +,   1.1380918E-02,   1.1645650E-02,   1.1910263E-02
     +,   1.2173598E-02,   1.2434511E-02,   1.2691912E-02
     +,   1.2944789E-02,   1.3192255E-02,   1.3433572E-02
     +,   1.3668216E-02,   1.3895863E-02,   1.4116473E-02
     +,   1.4330287E-02,   1.4537863E-02,   1.4740082E-02
     +,   1.4938178E-02,   1.5133716E-02,   1.5328590E-02
     +,   1.5525016E-02,   1.5725484E-02,   1.5932750E-02
     +,   1.6149733E-02,   1.6379511E-02,   1.6625211E-02
     +,   1.6889973E-02,   1.7176818E-02,   1.7488636E-02
     +,   1.7828006E-02,   1.8197214E-02,   1.8598074E-02
     +,   1.9031936E-02,   1.9499587E-02,   2.0001160E-02
     +,   2.0536115E-02,   2.1103254E-02,   2.1700669E-02
     +,   2.2325689E-02,   2.2975035E-02,   2.3644704E-02
     +,   2.4330193E-02,   2.5026405E-02,   2.5727887E-02
     +,   2.6428780E-02,   2.7123131E-02,   2.7804779E-02
     +,   2.8467698E-02,   2.9106036E-02,   2.9714175E-02
     +,   3.0286957E-02,   3.0819785E-02,   3.1308725E-02
     +,   3.1750496E-02,   3.2142740E-02,   3.2483816E-02
     +,   3.2773070E-02,   3.3010669E-02,   3.3197667E-02
     +,   3.3335913E-02,   3.3428021E-02,   3.3477250E-02
     +,   3.3487450E-02,   3.3462904E-02,   3.3408247E-02
     +,   3.3328354E-02,   3.3228178E-02,   3.3112697E-02
     +,   3.2986820E-02,   3.2855272E-02,   3.2722581E-02
     +,   3.2592978E-02,   3.2470442E-02,   3.2358635E-02
     +,   3.2260921E-02,   3.2180406E-02,   3.2119919E-02
     +,   3.2082010E-02,   3.2069009E-02,   3.2083001E-02
     +,   3.2125801E-02,   3.2198939E-02,   3.2303598E-02
     +,   3.2440621E-02,   3.2610361E-02,   3.2812666E-02
     +,   3.3046838E-02,   3.3311445E-02,   3.3604439E-02
     +,   3.3922981E-02,   3.4263514E-02,   3.4621686E-02
     +,   3.4992523E-02,   3.5370361E-02,   3.5749018E-02
     +,   3.6121842E-02,   3.6481980E-02,   3.6822394E-02
     +,   3.7136085E-02,   3.7416216E-02,   3.7656371E-02
     +,   3.7850559E-02,   3.7993502E-02,   3.8080670E-02
     +,   3.8108427E-02,   3.8074110E-02,   3.7976105E-02
     +,   3.7813950E-02,   3.7588291E-02,   3.7301023E-02
     +,   3.6955211E-02,   3.6555167E-02,   3.6106370E-02
     +,   3.5615515E-02,   3.5090424E-02,   3.4539953E-02
     +,   3.3973929E-02,   3.3403046E-02,   3.2838672E-02
     +,   3.2292642E-02,   3.1777099E-02,   3.1304218E-02
     +,   3.0885840E-02,   3.0533267E-02,   3.0256886E-02
     +,   3.0065876E-02,   2.9967818E-02,   2.9968506E-02
     +,   3.0071540E-02,   3.0278239E-02,   3.0587381E-02
     +,   3.0995172E-02,   3.1495124E-02,   3.2078233E-02
     +,   3.2733049E-02,   3.3445880E-02,   3.4201059E-02
     +,   3.4981426E-02,   3.5768636E-02,   3.6543563E-02
     +,   3.7286855E-02,   3.7979446E-02,   3.8602982E-02
     +,   3.9140239E-02,   3.9575566E-02,   3.9895311E-02
     +,   4.0088024E-02,   4.0144719E-02,   4.0059064E-02
     +,   3.9827354E-02,   3.9448619E-02,   3.8924519E-02
     +,   3.8259137E-02,   3.7458804E-02,   3.6531933E-02
     +,   3.5488684E-02,   3.4340587E-02,   3.3100259E-02
     +,   3.1781182E-02,   3.0397281E-02,   2.8962614E-02
     +,   2.7491054E-02,   2.5996275E-02,   2.4491230E-02
     +,   2.2988083E-02,   2.1498192E-02,   2.0031897E-02
     +,   1.8598326E-02,   1.7205479E-02,   1.5860284E-02
     +,   1.4568515E-02,   1.3334739E-02,   1.2162473E-02
     +,   1.1054293E-02,   1.0011843E-02,   9.0358499E-03
     +,   8.1262756E-03,   7.2825020E-03,   6.5032267E-03
     +,   5.7866550E-03,   5.1306188E-03,   4.5326026E-03
     +,   3.9897766E-03,   3.4991228E-03,   3.0575173E-03
     +,   2.6617451E-03,   2.3085345E-03,   1.9946313E-03
     +,   1.7168525E-03,   1.4720928E-03,   1.2573402E-03
     +,   1.0697173E-03,   9.0651325E-04,   7.6515961E-04
     +,   6.4325985E-04,   5.3859979E-04,   4.4913930E-04
     +,   3.7300595E-04,   3.0850028E-04,   2.5409216E-04
     +,   2.0840811E-04,   1.7022068E-04,   1.3844299E-04
     +,   1.1212018E-04,   9.0415924E-05,   7.2600960E-05
     +,   5.8045018E-05,   4.6207351E-05,   3.6624409E-05
     +,   2.8902326E-05,   2.2708829E-05,   1.7764536E-05
     +,   1.3835691E-05,   1.0728200E-05,   8.2819060E-06
     +,   6.3651710E-06,   4.8703282E-06,   3.7099389E-06
     +,   2.8134252E-06,   2.1240478E-06,   1.5964163E-06
     +,   1.1944662E-06,   8.8971757E-07,   6.5974172E-07
     +,   4.8700383E-07,   3.5787301E-07,   2.6179751E-07
     +,   1.9064935E-07,   1.3820745E-07,   9.9736994E-08
     +,   7.1649367E-08,   5.1238096E-08,   3.6474692E-08
     +,   2.5847315E-08,   1.8232809E-08,   1.2803059E-08
     +,   8.9491907E-09,   6.2269137E-09,   4.3128972E-09
     +,   2.9735898E-09,   2.0407802E-09,   1.3941988E-09
     +,   9.4809904E-10,   6.4178940E-10,   4.3244852E-10
     +,   2.9004998E-10,   1.9364993E-10,   1.2869304E-10
     +,   8.5132713E-11,   5.6056784E-11,   3.6741915E-11
     +,   2.3970836E-11,   1.5566959E-11,   1.0062583E-11
     +,   6.4745939E-12,   4.1466635E-12,   2.6435043E-12
     +,   1.6774231E-12,   1.0594931E-12
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_haonly_hatt107_mass = Yx/1.27529266666667
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_haonly_hatt110_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  6.1920877E-03,   6.3276333E-03
     +,   6.4598578E-03,   6.5885093E-03,   6.7133810E-03
     +,   6.8343035E-03,   6.9511686E-03,   7.0639295E-03
     +,   7.1726087E-03,   7.2773159E-03,   7.3782443E-03
     +,   7.4756900E-03,   7.5700558E-03,   7.6618581E-03
     +,   7.7517377E-03,   7.8404611E-03,   7.9289246E-03
     +,   8.0181640E-03,   8.1093451E-03,   8.2037719E-03
     +,   8.3028805E-03,   8.4082317E-03,   8.5215084E-03
     +,   8.6445054E-03,   8.7791057E-03,   8.9272885E-03
     +,   9.0910941E-03,   9.2726061E-03,   9.4739348E-03
     +,   9.6971942E-03,   9.9444678E-03,   1.0217792E-02
     +,   1.0519109E-02,   1.0850253E-02,   1.1212895E-02
     +,   1.1608534E-02,   1.2038432E-02,   1.2503590E-02
     +,   1.3004731E-02,   1.3542197E-02,   1.4115999E-02
     +,   1.4725712E-02,   1.5370470E-02,   1.6048942E-02
     +,   1.6759276E-02,   1.7499121E-02,   1.8265581E-02
     +,   1.9055232E-02,   1.9864107E-02,   2.0687738E-02
     +,   2.1521162E-02,   2.2358986E-02,   2.3195406E-02
     +,   2.4024367E-02,   2.4839485E-02,   2.5634345E-02
     +,   2.6402431E-02,   2.7137369E-02,   2.7832983E-02
     +,   2.8483452E-02,   2.9083440E-02,   2.9628215E-02
     +,   3.0113770E-02,   3.0536951E-02,   3.0895557E-02
     +,   3.1188345E-02,   3.1415194E-02,   3.1577006E-02
     +,   3.1675853E-02,   3.1714793E-02,   3.1697936E-02
     +,   3.1630274E-02,   3.1517625E-02,   3.1366453E-02
     +,   3.1183723E-02,   3.0976741E-02,   3.0752940E-02
     +,   3.0519731E-02,   3.0284245E-02,   3.0053204E-02
     +,   2.9832745E-02,   2.9628213E-02,   2.9444104E-02
     +,   2.9283881E-02,   2.9149961E-02,   2.9043613E-02
     +,   2.8964991E-02,   2.8913114E-02,   2.8885942E-02
     +,   2.8880466E-02,   2.8892770E-02,   2.8918210E-02
     +,   2.8951539E-02,   2.8987082E-02,   2.9018890E-02
     +,   2.9040949E-02,   2.9047323E-02,   2.9032331E-02
     +,   2.8990686E-02,   2.8917698E-02,   2.8809318E-02
     +,   2.8662300E-02,   2.8474238E-02,   2.8243631E-02
     +,   2.7969956E-02,   2.7653579E-02,   2.7295848E-02
     +,   2.6899030E-02,   2.6466165E-02,   2.6001101E-02
     +,   2.5508398E-02,   2.4993185E-02,   2.4461128E-02
     +,   2.3918243E-02,   2.3370899E-02,   2.2825612E-02
     +,   2.2289015E-02,   2.1767726E-02,   2.1268304E-02
     +,   2.0797096E-02,   2.0360198E-02,   1.9963408E-02
     +,   1.9612156E-02,   1.9311389E-02,   1.9065579E-02
     +,   1.8878669E-02,   1.8754048E-02,   1.8694475E-02
     +,   1.8702108E-02,   1.8778449E-02,   1.8924335E-02
     +,   1.9139931E-02,   1.9424738E-02,   1.9777564E-02
     +,   2.0196568E-02,   2.0679260E-02,   2.1222491E-02
     +,   2.1822480E-02,   2.2474889E-02,   2.3174828E-02
     +,   2.3916837E-02,   2.4694948E-02,   2.5502827E-02
     +,   2.6333759E-02,   2.7180588E-02,   2.8036021E-02
     +,   2.8892564E-02,   2.9742589E-02,   3.0578440E-02
     +,   3.1392671E-02,   3.2178037E-02,   3.2927591E-02
     +,   3.3634875E-02,   3.4294110E-02,   3.4900218E-02
     +,   3.5448980E-02,   3.5937142E-02,   3.6362577E-02
     +,   3.6724269E-02,   3.7022378E-02,   3.7258286E-02
     +,   3.7434515E-02,   3.7554696E-02,   3.7623443E-02
     +,   3.7646215E-02,   3.7629131E-02,   3.7578739E-02
     +,   3.7501823E-02,   3.7405089E-02,   3.7294954E-02
     +,   3.7177291E-02,   3.7057176E-02,   3.6938693E-02
     +,   3.6824778E-02,   3.6717031E-02,   3.6615726E-02
     +,   3.6519725E-02,   3.6426544E-02,   3.6332432E-02
     +,   3.6232483E-02,   3.6120899E-02,   3.5991121E-02
     +,   3.5836127E-02,   3.5648715E-02,   3.5421707E-02
     +,   3.5148315E-02,   3.4822304E-02,   3.4438260E-02
     +,   3.3991754E-02,   3.3479568E-02,   3.2899700E-02
     +,   3.2251451E-02,   3.1535510E-02,   3.0753877E-02
     +,   2.9909747E-02,   2.9007420E-02,   2.8052248E-02
     +,   2.7050406E-02,   2.6008677E-02,   2.4934277E-02
     +,   2.3834813E-02,   2.2717968E-02,   2.1591313E-02
     +,   2.0462196E-02,   1.9337729E-02,   1.8224472E-02
     +,   1.7128434E-02,   1.6055103E-02,   1.5009315E-02
     +,   1.3995168E-02,   1.3016107E-02,   1.2074980E-02
     +,   1.1174018E-02,   1.0314792E-02,   9.4983447E-03
     +,   8.7252855E-03,   7.9957759E-03,   7.3095514E-03
     +,   6.6660242E-03,   6.0643875E-03,   5.5035399E-03
     +,   4.9821972E-03,   4.4989614E-03,   4.0523126E-03
     +,   3.6406191E-03,   3.2621888E-03,   2.9153232E-03
     +,   2.5982980E-03,   2.3093671E-03,   2.0467977E-03
     +,   1.8088984E-03,   1.5940077E-03,   1.4004885E-03
     +,   1.2267552E-03,   1.0712919E-03,   9.3262456E-04
     +,   8.0934301E-04,   7.0011319E-04,   6.0366653E-04
     +,   5.1879988E-04,   4.4438327E-04,   3.7936491E-04
     +,   3.2276480E-04,   2.7367088E-04,   2.3124331E-04
     +,   1.9471454E-04,   1.6338337E-04,   1.3661067E-04
     +,   1.1381950E-04,   9.4493225E-05,   7.8167410E-05
     +,   6.4429034E-05,   5.2913227E-05,   4.3298223E-05
     +,   3.5301287E-05,   2.8675913E-05,   2.3208573E-05
     +,   1.8714674E-05,   1.5035291E-05,   1.2034556E-05
     +,   9.5970208E-06,   7.6248434E-06,   6.0354155E-06
     +,   4.7594763E-06,   3.7393061E-06,   2.9268251E-06
     +,   2.2822896E-06,   1.7730225E-06,   1.3722364E-06
     +,   1.0580563E-06,   8.1273583E-07,   6.2194482E-07
     +,   4.7415332E-07,   3.6011795E-07,   2.7247393E-07
     +,   2.0538333E-07,   1.5422550E-07,   1.1537318E-07
     +,   8.5980936E-08,   6.3834499E-08,   4.7212243E-08
     +,   3.4786233E-08,   2.5533122E-08,   1.8670345E-08
     +,   1.3600121E-08,   9.8692237E-09,   7.1345707E-09
     +,   5.1379740E-09,   3.6860681E-09,   2.6343432E-09
     +,   1.8755444E-09,   1.3302026E-09,   9.3983876E-10
     +,   6.6148975E-10,   4.6380530E-10,   3.2395295E-10
     +,   2.2540822E-10,   1.5623880E-10,   1.0788210E-10
     +,   7.4206169E-11,   5.0847604E-11
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_haonly_hatt110_mass = Yx/1.25291911111111
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_haonly_hatt115_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  9.2155836E-04,   9.5360912E-04
     +,   9.8573335E-04,   1.0178835E-03,   1.0500150E-03
     +,   1.0820882E-03,   1.1140691E-03,   1.1459307E-03
     +,   1.1776540E-03,   1.2092324E-03,   1.2406692E-03
     +,   1.2719827E-03,   1.3032071E-03,   1.3343946E-03
     +,   1.3656181E-03,   1.3969727E-03,   1.4285790E-03
     +,   1.4605846E-03,   1.4931671E-03,   1.5265355E-03
     +,   1.5609338E-03,   1.5966418E-03,   1.6339760E-03
     +,   1.6732963E-03,   1.7149966E-03,   1.7595190E-03
     +,   1.8073415E-03,   1.8589858E-03,   1.9150121E-03
     +,   1.9760188E-03,   2.0426391E-03,   2.1155365E-03
     +,   2.1954023E-03,   2.2829487E-03,   2.3789024E-03
     +,   2.4839977E-03,   2.5989681E-03,   2.7245355E-03
     +,   2.8614115E-03,   3.0102641E-03,   3.1717387E-03
     +,   3.3464225E-03,   3.5348462E-03,   3.7374755E-03
     +,   3.9546983E-03,   4.1868240E-03,   4.4340682E-03
     +,   4.6965596E-03,   4.9743289E-03,   5.2673123E-03
     +,   5.5753519E-03,   5.8981986E-03,   6.2355078E-03
     +,   6.5868823E-03,   6.9518038E-03,   7.3297336E-03
     +,   7.7200504E-03,   8.1220828E-03,   8.5351234E-03
     +,   8.9584244E-03,   9.3912026E-03,   9.8326625E-03
     +,   1.0281937E-02,   1.0738182E-02,   1.1200516E-02
     +,   1.1667981E-02,   1.2139639E-02,   1.2614459E-02
     +,   1.3091414E-02,   1.3569374E-02,   1.4047221E-02
     +,   1.4523725E-02,   1.4997678E-02,   1.5467777E-02
     +,   1.5932748E-02,   1.6391303E-02,   1.6842155E-02
     +,   1.7284051E-02,   1.7715834E-02,   1.8136449E-02
     +,   1.8544914E-02,   1.8940447E-02,   1.9322386E-02
     +,   1.9690311E-02,   2.0043936E-02,   2.0383231E-02
     +,   2.0708313E-02,   2.1019515E-02,   2.1317290E-02
     +,   2.1602236E-02,   2.1875035E-02,   2.2136383E-02
     +,   2.2386948E-02,   2.2627356E-02,   2.2858085E-02
     +,   2.3079416E-02,   2.3291420E-02,   2.3493873E-02
     +,   2.3686264E-02,   2.3867736E-02,   2.4037132E-02
     +,   2.4192961E-02,   2.4333427E-02,   2.4456484E-02
     +,   2.4559896E-02,   2.4641277E-02,   2.4698175E-02
     +,   2.4728166E-02,   2.4728926E-02,   2.4698328E-02
     +,   2.4634534E-02,   2.4536053E-02,   2.4401840E-02
     +,   2.4231311E-02,   2.4024449E-02,   2.3781773E-02
     +,   2.3504388E-02,   2.3193939E-02,   2.2852631E-02
     +,   2.2483150E-02,   2.2088593E-02,   2.1672450E-02
     +,   2.1238502E-02,   2.0790681E-02,   2.0333022E-02
     +,   1.9869605E-02,   1.9404365E-02,   1.8941121E-02
     +,   1.8483374E-02,   1.8034378E-02,   1.7596936E-02
     +,   1.7173510E-02,   1.6766049E-02,   1.6376108E-02
     +,   1.6004743E-02,   1.5652578E-02,   1.5319867E-02
     +,   1.5006462E-02,   1.4711913E-02,   1.4435494E-02
     +,   1.4176306E-02,   1.3933329E-02,   1.3705464E-02
     +,   1.3491642E-02,   1.3290884E-02,   1.3102347E-02
     +,   1.2925408E-02,   1.2759706E-02,   1.2605201E-02
     +,   1.2462188E-02,   1.2331345E-02,   1.2213756E-02
     +,   1.2110916E-02,   1.2024714E-02,   1.1957427E-02
     +,   1.1911717E-02,   1.1890570E-02,   1.1897243E-02
     +,   1.1935231E-02,   1.2008174E-02,   1.2119791E-02
     +,   1.2273786E-02,   1.2473724E-02,   1.2722956E-02
     +,   1.3024488E-02,   1.3380880E-02,   1.3794095E-02
     +,   1.4265374E-02,   1.4795177E-02,   1.5383051E-02
     +,   1.6027464E-02,   1.6725780E-02,   1.7474247E-02
     +,   1.8267887E-02,   1.9100437E-02,   1.9964496E-02
     +,   2.0851506E-02,   2.1751769E-02,   2.2654628E-02
     +,   2.3548681E-02,   2.4421878E-02,   2.5261706E-02
     +,   2.6055465E-02,   2.6790576E-02,   2.7454801E-02
     +,   2.8036445E-02,   2.8524704E-02,   2.8909937E-02
     +,   2.9183840E-02,   2.9339671E-02,   2.9372441E-02
     +,   2.9279016E-02,   2.9058216E-02,   2.8710874E-02
     +,   2.8239766E-02,   2.7649568E-02,   2.6946781E-02
     +,   2.6139559E-02,   2.5237452E-02,   2.4251202E-02
     +,   2.3192586E-02,   2.2074081E-02,   2.0908512E-02
     +,   1.9708840E-02,   1.8488027E-02,   1.7258547E-02
     +,   1.6032280E-02,   1.4820393E-02,   1.3633100E-02
     +,   1.2479447E-02,   1.1367304E-02,   1.0303381E-02
     +,   9.2931231E-03,   8.3406605E-03,   7.4489140E-03
     +,   6.6197254E-03,   5.8538634E-03,   5.1510874E-03
     +,   4.5103156E-03,   3.9298018E-03,   3.4071275E-03
     +,   2.9393991E-03,   2.5233871E-03,   2.1555959E-03
     +,   1.8323472E-03,   1.5498999E-03,   1.3045430E-03
     +,   1.0926360E-03,   9.1065519E-04,   7.5525249E-04
     +,   6.2329537E-04,   5.1187415E-04,   4.1831052E-04
     +,   3.4017209E-04,   2.7527713E-04,   2.2167218E-04
     +,   1.7763159E-04,   1.4164492E-04,   1.1239785E-04
     +,   8.8754226E-05,   6.9741538E-05,   5.4534292E-05
     +,   4.2435346E-05,   3.2859662E-05,   2.5320520E-05
     +,   1.9416018E-05,   1.4815973E-05,   1.1250692E-05
     +,   8.5016554E-06,   6.3930956E-06,   4.7840772E-06
     +,   3.5625430E-06,   2.6399832E-06,   1.9468164E-06
     +,   1.4286551E-06,   1.0432857E-06,   7.5815188E-07
     +,   5.4826472E-07,   3.9454847E-07,   2.8254027E-07
     +,   2.0134205E-07,   1.4277963E-07,   1.0075577E-07
     +,   7.0752051E-08,   4.9440480E-08,   3.4379106E-08
     +,   2.3788537E-08,   1.6379685E-08,   1.1223095E-08
     +,   7.6521243E-09,   5.1916555E-09,   3.5050030E-09
     +,   2.3546900E-09,   1.5741070E-09,   1.0470859E-09
     +,   6.9308814E-10,   4.5649706E-10,   2.9918640E-10
     +,   1.9511272E-10,   1.2661347E-10,   8.1754305E-11
     +,   5.2527684E-11,   3.3581318E-11,   2.1362450E-11
     +,   1.3521741E-11,   8.5163465E-12,   5.3371105E-12
     +,   3.3279861E-12,   2.0648633E-12,   1.2747368E-12
     +,   7.8303293E-13,   4.7858093E-13,   2.9104383E-13
     +,   1.7610558E-13,   1.0602597E-13,   6.3512706E-14
     +,   3.7855549E-14,   2.2449370E-14,   1.3246364E-14
     +,   7.7766290E-15,   4.5425644E-15
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_haonly_hatt115_mass = Yx/0.735409043478261
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_haonly_hatt120_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.6363543E-03,   4.8070294E-03
     +,   4.9785222E-03,   5.1504080E-03,   5.3222515E-03
     +,   5.4936060E-03,   5.6640217E-03,   5.8330502E-03
     +,   6.0002496E-03,   6.1651999E-03,   6.3274940E-03
     +,   6.4867577E-03,   6.6426564E-03,   6.7948988E-03
     +,   6.9432459E-03,   7.0875208E-03,   7.2276187E-03
     +,   7.3635080E-03,   7.4952417E-03,   7.6229568E-03
     +,   7.7468893E-03,   7.8673633E-03,   7.9848077E-03
     +,   8.0997515E-03,   8.2128095E-03,   8.3247041E-03
     +,   8.4362337E-03,   8.5482858E-03,   8.6618206E-03
     +,   8.7778540E-03,   8.8974601E-03,   9.0217376E-03
     +,   9.1518126E-03,   9.2888074E-03,   9.4338302E-03
     +,   9.5879585E-03,   9.7522102E-03,   9.9275345E-03
     +,   1.0114797E-02,   1.0314744E-02,   1.0528014E-02
     +,   1.0755099E-02,   1.0996358E-02,   1.1251981E-02
     +,   1.1522012E-02,   1.1806328E-02,   1.2104639E-02
     +,   1.2416512E-02,   1.2741363E-02,   1.3078468E-02
     +,   1.3426994E-02,   1.3786006E-02,   1.4154482E-02
     +,   1.4531367E-02,   1.4915540E-02,   1.5305914E-02
     +,   1.5701395E-02,   1.6100945E-02,   1.6503599E-02
     +,   1.6908476E-02,   1.7314807E-02,   1.7721947E-02
     +,   1.8129356E-02,   1.8536670E-02,   1.8943651E-02
     +,   1.9350136E-02,   1.9756155E-02,   2.0161742E-02
     +,   2.0567084E-02,   2.0972343E-02,   2.1377742E-02
     +,   2.1783417E-02,   2.2189513E-02,   2.2595996E-02
     +,   2.3002757E-02,   2.3409504E-02,   2.3815727E-02
     +,   2.4220685E-02,   2.4623428E-02,   2.5022734E-02
     +,   2.5417101E-02,   2.5804810E-02,   2.6183838E-02
     +,   2.6551999E-02,   2.6906841E-02,   2.7245786E-02
     +,   2.7566092E-02,   2.7864942E-02,   2.8139446E-02
     +,   2.8386727E-02,   2.8603949E-02,   2.8788351E-02
     +,   2.8937293E-02,   2.9048329E-02,   2.9119216E-02
     +,   2.9147930E-02,   2.9132728E-02,   2.9072152E-02
     +,   2.8965052E-02,   2.8810620E-02,   2.8608346E-02
     +,   2.8358106E-02,   2.8060058E-02,   2.7714767E-02
     +,   2.7323104E-02,   2.6886258E-02,   2.6405795E-02
     +,   2.5883567E-02,   2.5321744E-02,   2.4722749E-02
     +,   2.4089357E-02,   2.3424504E-02,   2.2731457E-02
     +,   2.2013593E-02,   2.1274559E-02,   2.0518057E-02
     +,   1.9747999E-02,   1.8968262E-02,   1.8182885E-02
     +,   1.7395802E-02,   1.6610919E-02,   1.5832108E-02
     +,   1.5063114E-02,   1.4307474E-02,   1.3568545E-02
     +,   1.2849513E-02,   1.2153247E-02,   1.1482427E-02
     +,   1.0839365E-02,   1.0226169E-02,   9.6445661E-03
     +,   9.0960823E-03,   8.5818758E-03,   8.1029078E-03
     +,   7.6598343E-03,   7.2530843E-03,   6.8828962E-03
     +,   6.5493295E-03,   6.2522492E-03,   5.9913956E-03
     +,   5.7664164E-03,   5.5768648E-03,   5.4222229E-03
     +,   5.3019240E-03,   5.2153845E-03,   5.1619937E-03
     +,   5.1411376E-03,   5.1521990E-03,   5.1945616E-03
     +,   5.2676108E-03,   5.3707324E-03,   5.5033020E-03
     +,   5.6646708E-03,   5.8541745E-03,   6.0711186E-03
     +,   6.3147419E-03,   6.5842178E-03,   6.8786587E-03
     +,   7.1970993E-03,   7.5384341E-03,   7.9014795E-03
     +,   8.2849329E-03,   8.6873425E-03,   9.1071138E-03
     +,   9.5425425E-03,   9.9917836E-03,   1.0452822E-02
     +,   1.0923507E-02,   1.1401583E-02,   1.1884679E-02
     +,   1.2370272E-02,   1.2855752E-02,   1.3338447E-02
     +,   1.3815627E-02,   1.4284477E-02,   1.4742188E-02
     +,   1.5185974E-02,   1.5613018E-02,   1.6020590E-02
     +,   1.6406035E-02,   1.6766805E-02,   1.7100463E-02
     +,   1.7404715E-02,   1.7677469E-02,   1.7916828E-02
     +,   1.8121084E-02,   1.8288780E-02,   1.8418709E-02
     +,   1.8509928E-02,   1.8561751E-02,   1.8573768E-02
     +,   1.8545868E-02,   1.8478192E-02,   1.8371183E-02
     +,   1.8225525E-02,   1.8042171E-02,   1.7822325E-02
     +,   1.7567424E-02,   1.7279109E-02,   1.6959200E-02
     +,   1.6609717E-02,   1.6232833E-02,   1.5830817E-02
     +,   1.5406042E-02,   1.4961003E-02,   1.4498195E-02
     +,   1.4020151E-02,   1.3529438E-02,   1.3028605E-02
     +,   1.2520131E-02,   1.2006438E-02,   1.1489906E-02
     +,   1.0972821E-02,   1.0457335E-02,   9.9454699E-03
     +,   9.4391638E-03,   8.9402106E-03,   8.4502287E-03
     +,   7.9706861E-03,   7.5029470E-03,   7.0481752E-03
     +,   6.6073844E-03,   6.1814645E-03,   5.7711592E-03
     +,   5.3770402E-03,   4.9995435E-03,   4.6390006E-03
     +,   4.2956173E-03,   3.9694603E-03,   3.6604914E-03
     +,   3.3685949E-03,   3.0935626E-03,   2.8350882E-03
     +,   2.5927944E-03,   2.3662660E-03,   2.1550090E-03
     +,   1.9584864E-03,   1.7761362E-03,   1.6073651E-03
     +,   1.4515467E-03,   1.3080389E-03,   1.1762013E-03
     +,   1.0553878E-03,   9.4494555E-04,   8.4422989E-04
     +,   7.5261277E-04,   6.6947989E-04,   5.9422810E-04
     +,   5.2627537E-04,   4.6506844E-04,   4.1007114E-04
     +,   3.6077327E-04,   3.1669458E-04,   2.7738063E-04
     +,   2.4240155E-04,   2.1135517E-04,   1.8386831E-04
     +,   1.5959376E-04,   1.3820847E-04,   1.1941468E-04
     +,   1.0293987E-04,   8.8534274E-05,   7.5968863E-05
     +,   6.5035594E-05,   5.5546829E-05,   4.7332007E-05
     +,   4.0237672E-05,   3.4126555E-05,   2.8875760E-05
     +,   2.4375346E-05,   2.0527666E-05,   1.7246448E-05
     +,   1.4455429E-05,   1.2087295E-05,   1.0082977E-05
     +,   8.3909908E-06,   6.9661869E-06,   5.7694906E-06
     +,   4.7668691E-06,   3.9290298E-06,   3.2306277E-06
     +,   2.6499747E-06,   2.1684134E-06,   1.7700776E-06
     +,   1.4414015E-06,   1.1709121E-06,   9.4886826E-07
     +,   7.6705254E-07,   6.1856724E-07,   4.9760325E-07
     +,   3.9931851E-07,   3.1965976E-07,   2.5526631E-07
     +,   2.0334284E-07,   1.6158421E-07,   1.2808457E-07
     +,   1.0128080E-07,   7.9888252E-08,   6.2859222E-08
     +,   4.9337650E-08,   3.8629285E-08
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_haonly_hatt120_mass = Yx/0.787938260869565
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_haonly_hatt60_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.8218450E-02,   1.9556535E-02
     +,   2.1070307E-02,   2.2790622E-02,   2.4752764E-02
     +,   2.6996421E-02,   2.9565785E-02,   3.2510120E-02
     +,   3.5885476E-02,   3.9758928E-02,   4.4215646E-02
     +,   4.9371291E-02,   5.5389781E-02,   6.2508158E-02
     +,   7.1068652E-02,   8.1557661E-02,   9.4646081E-02
     +,   0.1112174    ,   0.1323676    ,   0.1593755    
     +,   0.1936838    ,   0.2369405    ,   0.2910209    
     +,   0.3576784    ,   0.4373749    ,   0.5276496    
     +,   0.6228523    ,   0.7181615    ,   0.8185656    
     +,   0.9465610    ,    1.135278    ,    1.400690    
     +,    1.715382    ,    2.020225    ,    2.268670    
     +,    2.479834    ,    2.779746    ,    3.283157    
     +,    3.859449    ,    4.333850    ,    4.729699    
     +,    4.974558    ,    5.019075    ,    4.943498    
     +,    4.694214    ,    4.237079    ,    3.677425    
     +,    3.188402    ,    2.851362    ,    2.608828    
     +,    2.397938    ,    2.201906    ,    1.992228    
     +,    1.768341    ,    1.558120    ,    1.369087    
     +,    1.198476    ,    1.049018    ,   0.9210835    
     +,   0.8094772    ,   0.7083070    ,   0.6148150    
     +,   0.5300698    ,   0.4570455    ,   0.3977159    
     +,   0.3514956    ,   0.3158689    ,   0.2880324    
     +,   0.2659600    ,   0.2484713    ,   0.2347406    
     +,   0.2238779    ,   0.2148159    ,   0.2064472    
     +,   0.1978294    ,   0.1883420    ,   0.1777469    
     +,   0.1661588    ,   0.1539525    ,   0.1416394    
     +,   0.1297435    ,   0.1186983    ,   0.1087878    
     +,   0.1001259    ,   9.2675224E-02,   8.6284995E-02
     +,   8.0740407E-02,   7.5806372E-02,   7.1264446E-02
     +,   6.6934846E-02,   6.2688433E-02,   5.8448892E-02
     +,   5.4187581E-02,   4.9914226E-02,   4.5666501E-02
     +,   4.1499265E-02,   3.7473507E-02,   3.3649035E-02
     +,   3.0077029E-02,   2.6796868E-02,   2.3833176E-02
     +,   2.1196412E-02,   1.8883230E-02,   1.6879408E-02
     +,   1.5161890E-02,   1.3701974E-02,   1.2468020E-02
     +,   1.1427638E-02,   1.0549497E-02,   9.8046977E-03
     +,   9.1676386E-03,   8.6162379E-03,   8.1321439E-03
     +,   7.7004018E-03,   7.3092333E-03,   6.9494974E-03
     +,   6.6143586E-03,   6.2987595E-03,   5.9991200E-03
     +,   5.7129464E-03,   5.4385667E-03,   5.1749446E-03
     +,   4.9214712E-03,   4.6778168E-03,   4.4438494E-03
     +,   4.2195790E-03,   4.0050447E-03,   3.8003374E-03
     +,   3.6055108E-03,   3.4206174E-03,   3.2456436E-03
     +,   3.0805480E-03,   2.9252151E-03,   2.7794938E-03
     +,   2.6431635E-03,   2.5159537E-03,   2.3975566E-03
     +,   2.2876200E-03,   2.1857491E-03,   2.0915202E-03
     +,   2.0044944E-03,   1.9242140E-03,   1.8502056E-03
     +,   1.7819940E-03,   1.7191103E-03,   1.6610865E-03
     +,   1.6074661E-03,   1.5578110E-03,   1.5117010E-03
     +,   1.4687337E-03,   1.4285310E-03,   1.3907412E-03
     +,   1.3550394E-03,   1.3211237E-03,   1.2887197E-03
     +,   1.2575813E-03,   1.2274882E-03,   1.1982432E-03
     +,   1.1696732E-03,   1.1416312E-03,   1.1139886E-03
     +,   1.0866371E-03,   1.0594893E-03,   1.0324750E-03
     +,   1.0055377E-03,   9.7863574E-04,   9.5174194E-04
     +,   9.2484074E-04,   8.9792500E-04,   8.7099674E-04
     +,   8.4406754E-04,   8.1715564E-04,   7.9028303E-04
     +,   7.6347665E-04,   7.3676964E-04,   7.1019563E-04
     +,   6.8379042E-04,   6.5759307E-04,   6.3164328E-04
     +,   6.0597976E-04,   5.8064074E-04,   5.5566552E-04
     +,   5.3109217E-04,   5.0695601E-04,   4.8329023E-04
     +,   4.6012786E-04,   4.3749969E-04,   4.1543224E-04
     +,   3.9394974E-04,   3.7307592E-04,   3.5282920E-04
     +,   3.3322579E-04,   3.1428010E-04,   2.9600353E-04
     +,   2.7840360E-04,   2.6148517E-04,   2.4525152E-04
     +,   2.2970323E-04,   2.1483748E-04,   2.0064908E-04
     +,   1.8713172E-04,   1.7427685E-04,   1.6207312E-04
     +,   1.5050761E-04,   1.3956691E-04,   1.2923504E-04
     +,   1.1949484E-04,   1.1032881E-04,   1.0171829E-04
     +,   9.3643393E-05,   8.6083681E-05,   7.9018726E-05
     +,   7.2427691E-05,   6.6289191E-05,   6.0581729E-05
     +,   5.5284298E-05,   5.0375995E-05,   4.5835797E-05
     +,   4.1643118E-05,   3.7778162E-05,   3.4221226E-05
     +,   3.0953172E-05,   2.7955704E-05,   2.5211113E-05
     +,   2.2702214E-05,   2.0412521E-05,   1.8326444E-05
     +,   1.6429118E-05,   1.4706270E-05,   1.3144410E-05
     +,   1.1730891E-05,   1.0453784E-05,   9.3017879E-06
     +,   8.2643346E-06,   7.3316401E-06,   6.4944697E-06
     +,   5.7442548E-06,   5.0730891E-06,   4.4736489E-06
     +,   3.9391211E-06,   3.4632462E-06,   3.0402905E-06
     +,   2.6649930E-06,   2.3325158E-06,   2.0384421E-06
     +,   1.7787672E-06,   1.5498458E-06,   1.3483568E-06
     +,   1.1712930E-06,   1.0159546E-06,   8.7989213E-07
     +,   7.6090146E-07,   6.5701232E-07,   5.6645644E-07
     +,   4.8764605E-07,   4.1916672E-07,   3.5976109E-07
     +,   3.0831077E-07,   2.6382068E-07,   2.2540928E-07
     +,   1.9230022E-07,   1.6380801E-07,   1.3932701E-07
     +,   1.1832537E-07,   1.0033850E-07,   8.4957641E-08
     +,   7.1825603E-08,   6.0631834E-08,   5.1105619E-08
     +,   4.3011191E-08,   3.6143991E-08,   3.0327428E-08
     +,   2.5408635E-08,   2.1255524E-08,   1.7754298E-08
     +,   1.4807521E-08,   1.2331129E-08,   1.0253446E-08
     +,   8.5129193E-09,   7.0572272E-09,   5.8415863E-09
     +,   4.8280788E-09,   3.9843644E-09,   3.2831489E-09
     +,   2.7012415E-09,   2.2191322E-09,   1.8203139E-09
     +,   1.4909082E-09,   1.2192765E-09,   9.9562181E-10
     +,   8.1177054E-10,   6.6086620E-10,   5.3720545E-10
     +,   4.3602180E-10,   3.5336392E-10,   2.8594166E-10
     +,   2.3103583E-10,   1.8638995E-10,   1.5014517E-10
     +,   1.2076522E-10,   9.6988230E-11
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_haonly_hatt60_mass = Yx/22.3774466086957
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_haonly_hatt65_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.3237328E-02,   1.3593620E-02
     +,   1.3909861E-02,   1.4184726E-02,   1.4417919E-02
     +,   1.4610250E-02,   1.4763710E-02,   1.4881548E-02
     +,   1.4968316E-02,   1.5029925E-02,   1.5073707E-02
     +,   1.5108513E-02,   1.5144825E-02,   1.5194966E-02
     +,   1.5273341E-02,   1.5396824E-02,   1.5585202E-02
     +,   1.5861709E-02,   1.6253607E-02,   1.6792707E-02
     +,   1.7515691E-02,   1.8464068E-02,   1.9683553E-02
     +,   2.1222791E-02,   2.3130924E-02,   2.5454890E-02
     +,   2.8235679E-02,   3.1504948E-02,   3.5282250E-02
     +,   3.9573789E-02,   4.4373415E-02,   4.9666613E-02
     +,   5.5438388E-02,   6.1686207E-02,   6.8441726E-02
     +,   7.5805619E-02,   8.4000938E-02,   9.3447171E-02
     +,   0.1048482    ,   0.1192739    ,   0.1382204    
     +,   0.1636161    ,   0.1977337    ,   0.2429155    
     +,   0.3010908    ,   0.3733287    ,   0.4598545    
     +,   0.5603576    ,   0.6732411    ,   0.7935652    
     +,   0.9144585    ,    1.036544    ,    1.176082    
     +,    1.357663    ,    1.600132    ,    1.921828    
     +,    2.354460    ,    2.896643    ,    3.447852    
     +,    3.904964    ,    4.202074    ,    4.312686    
     +,    4.417387    ,    4.533777    ,    4.576039    
     +,    4.464036    ,    4.086257    ,    3.628442    
     +,    3.259572    ,    2.851806    ,    2.349960    
     +,    1.911173    ,    1.625894    ,    1.441034    
     +,    1.295130    ,    1.153557    ,    1.002421    
     +,   0.8470063    ,   0.7036799    ,   0.5885109    
     +,   0.5073681    ,   0.4547900    ,   0.4201462    
     +,   0.3934311    ,   0.3677951    ,   0.3398713    
     +,   0.3091762    ,   0.2770598    ,   0.2455514    
     +,   0.2164103    ,   0.1906445    ,   0.1684908    
     +,   0.1496671    ,   0.1336775    ,   0.1200277    
     +,   0.1083169    ,   9.8239057E-02,   8.9555718E-02
     +,   8.2063012E-02,   7.5576253E-02,   6.9923081E-02
     +,   6.4946823E-02,   6.0508545E-02,   5.6491457E-02
     +,   5.2801121E-02,   4.9365483E-02,   4.6133090E-02
     +,   4.3070253E-02,   4.0157426E-02,   3.7385873E-02
     +,   3.4754518E-02,   3.2265939E-02,   2.9924411E-02
     +,   2.7733047E-02,   2.5692923E-02,   2.3801787E-02
     +,   2.2054413E-02,   2.0442532E-02,   1.8955976E-02
     +,   1.7583229E-02,   1.6312480E-02,   1.5132536E-02
     +,   1.4033322E-02,   1.3006219E-02,   1.2044304E-02
     +,   1.1142412E-02,   1.0296736E-02,   9.5047960E-03
     +,   8.7648900E-03,   8.0759833E-03,   7.4372250E-03
     +,   6.8478766E-03,   6.3069775E-03,   5.8133625E-03
     +,   5.3654863E-03,   4.9614552E-03,   4.5990772E-03
     +,   4.2758733E-03,   3.9891298E-03,   3.7359891E-03
     +,   3.5135422E-03,   3.3188702E-03,   3.1490950E-03
     +,   3.0014473E-03,   2.8733150E-03,   2.7622413E-03
     +,   2.6659605E-03,   2.5824129E-03,   2.5097386E-03
     +,   2.4462664E-03,   2.3905176E-03,   2.3411938E-03
     +,   2.2971600E-03,   2.2574272E-03,   2.2211419E-03
     +,   2.1875738E-03,   2.1560986E-03,   2.1261843E-03
     +,   2.0973796E-03,   2.0693096E-03,   2.0416565E-03
     +,   2.0141576E-03,   1.9865972E-03,   1.9587998E-03
     +,   1.9306235E-03,   1.9019548E-03,   1.8727075E-03
     +,   1.8428192E-03,   1.8122421E-03,   1.7809467E-03
     +,   1.7489191E-03,   1.7161579E-03,   1.6826690E-03
     +,   1.6484695E-03,   1.6135866E-03,   1.5780509E-03
     +,   1.5419000E-03,   1.5051777E-03,   1.4679335E-03
     +,   1.4302188E-03,   1.3920870E-03,   1.3535975E-03
     +,   1.3148125E-03,   1.2757930E-03,   1.2366024E-03
     +,   1.1973069E-03,   1.1579740E-03,   1.1186693E-03
     +,   1.0794582E-03,   1.0404097E-03,   1.0015885E-03
     +,   9.6305832E-04,   9.2488411E-04,   8.8712916E-04
     +,   8.4985263E-04,   8.1311131E-04,   7.7696220E-04
     +,   7.4145908E-04,   7.0665067E-04,   6.7258271E-04
     +,   6.3929951E-04,   6.0684193E-04,   5.7524483E-04
     +,   5.4453954E-04,   5.1475631E-04,   4.8591848E-04
     +,   4.5804548E-04,   4.3115462E-04,   4.0525908E-04
     +,   3.8036643E-04,   3.5648068E-04,   3.3360359E-04
     +,   3.1173317E-04,   2.9086269E-04,   2.7098213E-04
     +,   2.5207998E-04,   2.3414145E-04,   2.1714822E-04
     +,   2.0107946E-04,   1.8591377E-04,   1.7162623E-04
     +,   1.5819032E-04,   1.4557898E-04,   1.3376372E-04
     +,   1.2271429E-04,   1.1239974E-04,   1.0278926E-04
     +,   9.3851522E-05,   8.5554464E-05,   7.7866098E-05
     +,   7.0755086E-05,   6.4190375E-05,   5.8140955E-05
     +,   5.2576394E-05,   4.7467620E-05,   4.2785716E-05
     +,   3.8502752E-05,   3.4592071E-05,   3.1027954E-05
     +,   2.7785529E-05,   2.4841067E-05,   2.2172166E-05
     +,   1.9757545E-05,   1.7576884E-05,   1.5611055E-05
     +,   1.3842177E-05,   1.2253478E-05,   1.0829152E-05
     +,   9.5544738E-06,   8.4158755E-06,   7.4006398E-06
     +,   6.4970159E-06,   5.6942254E-06,   4.9823316E-06
     +,   4.3521609E-06,   3.7953273E-06,   3.3042022E-06
     +,   2.8718312E-06,   2.4918588E-06,   2.1585249E-06
     +,   1.8666454E-06,   1.6115335E-06,   1.3889507E-06
     +,   1.1950935E-06,   1.0265692E-06,   8.8032562E-07
     +,   7.5364130E-07,   6.4410057E-07,   5.4955729E-07
     +,   4.6810058E-07,   3.9804337E-07,   3.3789985E-07
     +,   2.8636143E-07,   2.4227401E-07,   2.0462689E-07
     +,   1.7253871E-07,   1.4523559E-07,   1.2204708E-07
     +,   1.0238681E-07,   8.5748709E-08,   7.1692376E-08
     +,   5.9839088E-08,   4.9860752E-08,   4.1476188E-08
     +,   3.4442916E-08,   2.8554000E-08,   2.3631840E-08
     +,   1.9524881E-08,   1.6104433E-08,   1.3260565E-08
     +,   1.0900452E-08,   8.9451317E-09,   7.3281559E-09
     +,   5.9932441E-09,   4.8932169E-09,   3.9882844E-09
     +,   3.2452094E-09,   2.6360780E-09,   2.1376616E-09
     +,   1.7305274E-09,   1.3985646E-09
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_haonly_hatt65_mass = Yx/19.856044173913
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_haonly_hatt70_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  5.6112427E-03,   5.8520981E-03
     +,   6.1118123E-03,   6.3908854E-03,   6.6896868E-03
     +,   7.0084431E-03,   7.3472313E-03,   7.7059683E-03
     +,   8.0844117E-03,   8.4821796E-03,   8.8987118E-03
     +,   9.3333144E-03,   9.7851576E-03,   1.0253293E-02
     +,   1.0736676E-02,   1.1234175E-02,   1.1744613E-02
     +,   1.2266765E-02,   1.2799412E-02,   1.3341327E-02
     +,   1.3891333E-02,   1.4448301E-02,   1.5011149E-02
     +,   1.5578912E-02,   1.6150646E-02,   1.6725566E-02
     +,   1.7302962E-02,   1.7882243E-02,   1.8462963E-02
     +,   1.9044874E-02,   1.9627951E-02,   2.0212529E-02
     +,   2.0799395E-02,   2.1389998E-02,   2.1986688E-02
     +,   2.2593055E-02,   2.3214355E-02,   2.3858104E-02
     +,   2.4534848E-02,   2.5258956E-02,   2.6049927E-02
     +,   2.6933616E-02,   2.7943909E-02,   2.9124396E-02
     +,   3.0530395E-02,   3.2230683E-02,   3.4309205E-02
     +,   3.6865734E-02,   4.0014986E-02,   4.3882586E-02
     +,   4.8596665E-02,   5.4273203E-02,   6.0995173E-02
     +,   6.8787634E-02,   7.7591971E-02,   8.7253384E-02
     +,   9.7528860E-02,   0.1081344    ,   0.1188404    
     +,   0.1296175    ,   0.1408207    ,   0.1533776    
     +,   0.1689038    ,   0.1896396    ,   0.2180889    
     +,   0.2564161    ,   0.3060531    ,   0.3682010    
     +,   0.4453307    ,   0.5421047    ,   0.6638559    
     +,   0.8131356    ,   0.9875368    ,    1.181814    
     +,    1.395931    ,    1.642365    ,    1.937003    
     +,    2.257204    ,    2.534106    ,    2.796315    
     +,    3.213689    ,    3.771254    ,    4.194443    
     +,    4.329021    ,    4.217905    ,    4.087806    
     +,    3.922758    ,    3.561494    ,    3.301705    
     +,    3.193365    ,    2.825626    ,    2.220986    
     +,    1.692845    ,    1.329375    ,    1.069975    
     +,   0.8672097    ,   0.7062901    ,   0.5853943    
     +,   0.5009646    ,   0.4438697    ,   0.4035861    
     +,   0.3723532    ,   0.3456433    ,   0.3209193    
     +,   0.2966430    ,   0.2719060    ,   0.2463590    
     +,   0.2201545    ,   0.1938134    ,   0.1680441    
     +,   0.1435809    ,   0.1210557    ,   0.1009301    
     +,   8.3455451E-02,   6.8679504E-02,   5.6472871E-02
     +,   4.6582457E-02,   3.8683556E-02,   3.2432575E-02
     +,   2.7502391E-02,   2.3606131E-02,   2.0507017E-02
     +,   1.8018054E-02,   1.5996577E-02,   1.4336540E-02
     +,   1.2960413E-02,   1.1811513E-02,   1.0848393E-02
     +,   1.0039950E-02,   9.3622822E-03,   8.7961219E-03
     +,   8.3254492E-03,   7.9363137E-03,   7.6164161E-03
     +,   7.3546739E-03,   7.1411366E-03,   6.9669127E-03
     +,   6.8241223E-03,   6.7058662E-03,   6.6061821E-03
     +,   6.5199998E-03,   6.4430553E-03,   6.3718096E-03
     +,   6.3033719E-03,   6.2354263E-03,   6.1661364E-03
     +,   6.0940860E-03,   6.0182186E-03,   5.9377789E-03
     +,   5.8522657E-03,   5.7613817E-03,   5.6650182E-03
     +,   5.5632116E-03,   5.4561165E-03,   5.3439848E-03
     +,   5.2271551E-03,   5.1060342E-03,   4.9810656E-03
     +,   4.8527317E-03,   4.7215559E-03,   4.5880587E-03
     +,   4.4527710E-03,   4.3162317E-03,   4.1789715E-03
     +,   4.0414971E-03,   3.9042970E-03,   3.7678471E-03
     +,   3.6325937E-03,   3.4989452E-03,   3.3672764E-03
     +,   3.2379364E-03,   3.1112384E-03,   2.9874495E-03
     +,   2.8667997E-03,   2.7494943E-03,   2.6356902E-03
     +,   2.5255077E-03,   2.4190426E-03,   2.3163552E-03
     +,   2.2174702E-03,   2.1223831E-03,   2.0310706E-03
     +,   1.9434853E-03,   1.8595521E-03,   1.7791794E-03
     +,   1.7022649E-03,   1.6286927E-03,   1.5583322E-03
     +,   1.4910453E-03,   1.4266950E-03,   1.3651351E-03
     +,   1.3062180E-03,   1.2498006E-03,   1.1957434E-03
     +,   1.1439056E-03,   1.0941533E-03,   1.0463609E-03
     +,   1.0004112E-03,   9.5619017E-04,   9.1359345E-04
     +,   8.7252707E-04,   8.3290634E-04,   7.9465151E-04
     +,   7.5769197E-04,   7.2196854E-04,   6.8742613E-04
     +,   6.5401691E-04,   6.2170177E-04,   5.9044763E-04
     +,   5.6022435E-04,   5.3100701E-04,   5.0277665E-04
     +,   4.7551712E-04,   4.4921378E-04,   4.2385393E-04
     +,   3.9942839E-04,   3.7592874E-04,   3.5334562E-04
     +,   3.3167002E-04,   3.1089495E-04,   2.9101039E-04
     +,   2.7200591E-04,   2.5387132E-04,   2.3659489E-04
     +,   2.2016274E-04,   2.0455944E-04,   1.8976926E-04
     +,   1.7577496E-04,   1.6255700E-04,   1.5009452E-04
     +,   1.3836629E-04,   1.2734983E-04,   1.1702096E-04
     +,   1.0735467E-04,   9.8326142E-05,   8.9909052E-05
     +,   8.2076709E-05,   7.4802658E-05,   6.8060312E-05
     +,   6.1822531E-05,   5.6062505E-05,   5.0754039E-05
     +,   4.5871297E-05,   4.1388616E-05,   3.7280974E-05
     +,   3.3524382E-05,   3.0095503E-05,   2.6971662E-05
     +,   2.4131057E-05,   2.1553129E-05,   1.9217945E-05
     +,   1.7106628E-05,   1.5201391E-05,   1.3485453E-05
     +,   1.1942871E-05,   1.0558702E-05,   9.3190692E-06
     +,   8.2110037E-06,   7.2223706E-06,   6.3419247E-06
     +,   5.5593150E-06,   4.8650013E-06,   4.2501397E-06
     +,   3.7066393E-06,   3.2271441E-06,   2.8048842E-06
     +,   2.4337048E-06,   2.1080432E-06,   1.8228505E-06
     +,   1.5735523E-06,   1.3560249E-06,   1.1665734E-06
     +,   1.0018822E-06,   8.5897295E-07,   7.3518765E-07
     +,   6.2816997E-07,   5.3581147E-07,   4.5625424E-07
     +,   3.8784449E-07,   3.2913081E-07,   2.7882743E-07
     +,   2.3581003E-07,   1.9908775E-07,   1.6779842E-07
     +,   1.4118413E-07,   1.1858903E-07,   9.9439987E-08
     +,   8.3240238E-08,   6.9560933E-08,   5.8030103E-08
     +,   4.8328300E-08,   4.0179547E-08,   3.3347963E-08
     +,   2.7630479E-08,   2.2854296E-08,   1.8871354E-08
     +,   1.5556036E-08,   1.2801170E-08,   1.0516247E-08
     +,   8.6243643E-09,   7.0608057E-09
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_haonly_hatt70_mass = Yx/17.4916457333333
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_haonly_hatt75_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.8128754E-03,   3.9351536E-03
     +,   4.0598861E-03,   4.1868463E-03,   4.3158000E-03
     +,   4.4465009E-03,   4.5787017E-03,   4.7121583E-03
     +,   4.8466385E-03,   4.9819336E-03,   5.1178597E-03
     +,   5.2542752E-03,   5.3910920E-03,   5.5282875E-03
     +,   5.6659244E-03,   5.8041527E-03,   5.9432434E-03
     +,   6.0835904E-03,   6.2257289E-03,   6.3703526E-03
     +,   6.5183300E-03,   6.6707027E-03,   6.8287104E-03
     +,   6.9937971E-03,   7.1675973E-03,   7.3519745E-03
     +,   7.5489981E-03,   7.7609723E-03,   7.9904320E-03
     +,   8.2401754E-03,   8.5132932E-03,   8.8132089E-03
     +,   9.1437455E-03,   9.5091863E-03,   9.9143786E-03
     +,   1.0364821E-02,   1.0866763E-02,   1.1427258E-02
     +,   1.2054265E-02,   1.2756505E-02,   1.3543481E-02
     +,   1.4425139E-02,   1.5411500E-02,   1.6512137E-02
     +,   1.7735420E-02,   1.9087657E-02,   2.0572064E-02
     +,   2.2187721E-02,   2.3928523E-02,   2.5782270E-02
     +,   2.7730040E-02,   2.9745854E-02,   3.1796928E-02
     +,   3.3844590E-02,   3.5845321E-02,   3.7753269E-02
     +,   3.9522454E-02,   4.1109946E-02,   4.2479031E-02
     +,   4.3602515E-02,   4.4465728E-02,   4.5069139E-02
     +,   4.5430217E-02,   4.5584474E-02,   4.5585565E-02
     +,   4.5504205E-02,   4.5426078E-02,   4.5448560E-02
     +,   4.5676395E-02,   4.6216361E-02,   4.7171410E-02
     +,   4.8634395E-02,   5.0683171E-02,   5.3377222E-02
     +,   5.6759279E-02,   6.0862321E-02,   6.5724090E-02
     +,   7.1411148E-02,   7.8051656E-02,   8.5874386E-02
     +,   9.5248416E-02,   0.1067154    ,   0.1209918    
     +,   0.1389288    ,   0.1614034    ,   0.1891569    
     +,   0.2225796    ,   0.2615180    ,   0.3051746    
     +,   0.3523917    ,   0.4026794    ,   0.4580212    
     +,   0.5243940    ,   0.6120185    ,   0.7360821    
     +,   0.9174893    ,    1.174343    ,    1.508829    
     +,    1.910876    ,    2.340226    ,    2.681849    
     +,    2.839217    ,    2.916883    ,    3.098271    
     +,    3.309664    ,    3.299217    ,    3.016042    
     +,    2.662673    ,    2.366532    ,    2.039203    
     +,    1.625898    ,    1.220598    ,   0.9185076    
     +,   0.7282729    ,   0.6124536    ,   0.5328634    
     +,   0.4652286    ,   0.4006393    ,   0.3405241    
     +,   0.2888247    ,   0.2470319    ,   0.2138179    
     +,   0.1868327    ,   0.1641168    ,   0.1444733    
     +,   0.1272600    ,   0.1121037    ,   9.8746449E-02
     +,   8.6988181E-02,   7.6675326E-02,   6.7686230E-02
     +,   5.9918620E-02,   5.3274345E-02,   4.7653809E-02
     +,   4.2952497E-02,   3.9063208E-02,   3.5879236E-02
     +,   3.3297170E-02,   3.1219319E-02,   2.9555840E-02
     +,   2.8225772E-02,   2.7157331E-02,   2.6287880E-02
     +,   2.5563749E-02,   2.4939917E-02,   2.4379326E-02
     +,   2.3852360E-02,   2.3336161E-02,   2.2813855E-02
     +,   2.2273710E-02,   2.1708356E-02,   2.1114044E-02
     +,   2.0489858E-02,   1.9837059E-02,   1.9158503E-02
     +,   1.8458232E-02,   1.7741028E-02,   1.7012004E-02
     +,   1.6276417E-02,   1.5539497E-02,   1.4806162E-02
     +,   1.4080966E-02,   1.3368028E-02,   1.2670978E-02
     +,   1.1992849E-02,   1.1336130E-02,   1.0702821E-02
     +,   1.0094415E-02,   9.5118973E-03,   8.9558344E-03
     +,   8.4264642E-03,   7.9236981E-03,   7.4471501E-03
     +,   6.9962172E-03,   6.5701758E-03,   6.1681215E-03
     +,   5.7890653E-03,   5.4319846E-03,   5.0958223E-03
     +,   4.7794920E-03,   4.4819210E-03,   4.2020804E-03
     +,   3.9389781E-03,   3.6916453E-03,   3.4591672E-03
     +,   3.2406931E-03,   3.0354238E-03,   2.8425974E-03
     +,   2.6615011E-03,   2.4914849E-03,   2.3319237E-03
     +,   2.1822306E-03,   2.0418640E-03,   1.9103114E-03
     +,   1.7870778E-03,   1.6716941E-03,   1.5637195E-03
     +,   1.4627333E-03,   1.3683226E-03,   1.2800947E-03
     +,   1.1976756E-03,   1.1207071E-03,   1.0488399E-03
     +,   9.8173879E-04,   9.1909157E-04,   8.6059206E-04
     +,   8.0595160E-04,   7.5489871E-04,   7.0717797E-04
     +,   6.6254562E-04,   6.2077394E-04,   5.8165356E-04
     +,   5.4498937E-04,   5.1059917E-04,   4.7831461E-04
     +,   4.4798406E-04,   4.1946815E-04,   3.9263815E-04
     +,   3.6737695E-04,   3.4358076E-04,   3.2115311E-04
     +,   3.0000680E-04,   2.8006418E-04,   2.6125478E-04
     +,   2.4351351E-04,   2.2678112E-04,   2.1100478E-04
     +,   1.9613582E-04,   1.8212845E-04,   1.6894040E-04
     +,   1.5653310E-04,   1.4487024E-04,   1.3391691E-04
     +,   1.2363995E-04,   1.1400868E-04,   1.0499284E-04
     +,   9.6563141E-05,   8.8691901E-05,   8.1352242E-05
     +,   7.4517600E-05,   6.8162160E-05,   6.2261170E-05
     +,   5.6790603E-05,   5.1726642E-05,   4.7046229E-05
     +,   4.2727268E-05,   3.8748345E-05,   3.5088466E-05
     +,   3.1727403E-05,   2.8646004E-05,   2.5825537E-05
     +,   2.3248091E-05,   2.0896685E-05,   1.8755127E-05
     +,   1.6807866E-05,   1.5040143E-05,   1.3438145E-05
     +,   1.1988785E-05,   1.0679664E-05,   9.4991346E-06
     +,   8.4363710E-06,   7.4812465E-06,   6.6242551E-06
     +,   5.8565574E-06,   5.1700354E-06,   4.5570982E-06
     +,   4.0107466E-06,   3.5245641E-06,   3.0926494E-06
     +,   2.7095625E-06,   2.3703319E-06,   2.0704365E-06
     +,   1.8057581E-06,   1.5725344E-06,   1.3673567E-06
     +,   1.1871572E-06,   1.0291426E-06,   8.9081510E-07
     +,   7.6991097E-07,   6.6441265E-07,   5.7250116E-07
     +,   4.9256010E-07,   4.2313917E-07,   3.6295401E-07
     +,   3.1085725E-07,   2.6583675E-07,   2.2699261E-07
     +,   1.9353040E-07,   1.6475208E-07,   1.4004051E-07
     +,   1.1885604E-07,   1.0072321E-07,   8.5228045E-08
     +,   7.2007175E-08,   6.0745506E-08,   5.1167337E-08
     +,   4.3034486E-08,   3.6139415E-08,   3.0303301E-08
     +,   2.5371129E-08,   2.1209697E-08
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_haonly_hatt75_mass = Yx/12.2503021395349
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_haonly_hatt80_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.3231304E-03,   2.2664629E-03
     +,   2.2062722E-03,   2.1429174E-03,   2.0767697E-03
     +,   2.0082081E-03,   1.9376173E-03,   1.8653835E-03
     +,   1.7918928E-03,   1.7175254E-03,   1.6426581E-03
     +,   1.5676601E-03,   1.4928901E-03,   1.4186975E-03
     +,   1.3454214E-03,   1.2733901E-03,   1.2029227E-03
     +,   1.1343304E-03,   1.0679190E-03,   1.0039909E-03
     +,   9.4285037E-04,   8.8480703E-04,   8.3018141E-04
     +,   7.7930780E-04,   7.3254935E-04,   6.9029228E-04
     +,   6.5296370E-04,   6.2103377E-04,   5.9502391E-04
     +,   5.7551364E-04,   5.6314678E-04,   5.5863650E-04
     +,   5.6276959E-04,   5.7640806E-04,   6.0048973E-04
     +,   6.3602545E-04,   6.8409409E-04,   7.4583385E-04
     +,   8.2243525E-04,   9.1511401E-04,   1.0251105E-03
     +,   1.1536528E-03,   1.3019377E-03,   1.4711039E-03
     +,   1.6621992E-03,   1.8761506E-03,   2.1137299E-03
     +,   2.3755240E-03,   2.6619004E-03,   2.9729810E-03
     +,   3.3086184E-03,   3.6683744E-03,   4.0515075E-03
     +,   4.4569974E-03,   4.8834919E-03,   5.3294166E-03
     +,   5.7929442E-03,   6.2720859E-03,   6.7647626E-03
     +,   7.2689001E-03,   7.7825533E-03,   8.3040511E-03
     +,   8.8321082E-03,   9.3660811E-03,   9.9060992E-03
     +,   1.0453185E-02,   1.1009566E-02,   1.1578644E-02
     +,   1.2165278E-02,   1.2775665E-02,   1.3417506E-02
     +,   1.4099742E-02,   1.4832592E-02,   1.5627090E-02
     +,   1.6494960E-02,   1.7448153E-02,   1.8498339E-02
     +,   1.9656505E-02,   2.0932512E-02,   2.2334611E-02
     +,   2.3868836E-02,   2.5538983E-02,   2.7345914E-02
     +,   2.9287923E-02,   3.1360317E-02,   3.3556264E-02
     +,   3.5866901E-02,   3.8282916E-02,   4.0795207E-02
     +,   4.3396875E-02,   4.6084307E-02,   4.8857797E-02
     +,   5.1721435E-02,   5.4681506E-02,   5.7742774E-02
     +,   6.0903251E-02,   6.4150035E-02,   6.7456014E-02
     +,   7.0784546E-02,   7.4102581E-02,   7.7407755E-02
     +,   8.0764957E-02,   8.4347419E-02,   8.8467136E-02
     +,   9.3583718E-02,   0.1002816    ,   0.1092176    
     +,   0.1210479    ,   0.1363505    ,   0.1555790    
     +,   0.1791155    ,   0.2074727    ,   0.2414842    
     +,   0.2822418    ,   0.3309236    ,   0.3897311    
     +,   0.4646437    ,   0.5667731    ,   0.7054763    
     +,   0.8733613    ,    1.038286    ,    1.159300    
     +,    1.220034    ,    1.246978    ,    1.285910    
     +,    1.350921    ,    1.397841    ,    1.359929    
     +,    1.214092    ,    1.000856    ,   0.7820618    
     +,   0.5976825    ,   0.4589268    ,   0.3602019    
     +,   0.2901212    ,   0.2383509    ,   0.1982216    
     +,   0.1660205    ,   0.1395523    ,   0.1174160    
     +,   9.8766923E-02,   8.3126105E-02,   7.0174433E-02
     +,   5.9609469E-02,   5.1089328E-02,   4.4241544E-02
     +,   3.8705938E-02,   3.4174595E-02,   3.0411923E-02
     +,   2.7253890E-02,   2.4593407E-02,   2.2360565E-02
     +,   2.0504666E-02,   1.8981943E-02,   1.7749514E-02
     +,   1.6763700E-02,   1.5980780E-02,   1.5358807E-02
     +,   1.4859364E-02,   1.4448741E-02,   1.4098298E-02
     +,   1.3784534E-02,   1.3488756E-02,   1.3196580E-02
     +,   1.2897380E-02,   1.2583777E-02,   1.2251179E-02
     +,   1.1897299E-02,   1.1521722E-02,   1.1125561E-02
     +,   1.0711128E-02,   1.0281619E-02,   9.8407948E-03
     +,   9.3927812E-03,   8.9418897E-03,   8.4923413E-03
     +,   8.0481749E-03,   7.6131355E-03,   7.1905502E-03
     +,   6.7832354E-03,   6.3934792E-03,   6.0230475E-03
     +,   5.6731617E-03,   5.3444933E-03,   5.0372314E-03
     +,   4.7511533E-03,   4.4856584E-03,   4.2398158E-03
     +,   4.0124543E-03,   3.8022497E-03,   3.6077367E-03
     +,   3.4273958E-03,   3.2597161E-03,   3.1032201E-03
     +,   2.9564935E-03,   2.8182245E-03,   2.6872305E-03
     +,   2.5624617E-03,   2.4429990E-03,   2.3280652E-03
     +,   2.2170260E-03,   2.1093765E-03,   2.0047245E-03
     +,   1.9027835E-03,   1.8033719E-03,   1.7063782E-03
     +,   1.6117566E-03,   1.5195216E-03,   1.4297272E-03
     +,   1.3424517E-03,   1.2577912E-03,   1.1758588E-03
     +,   1.0967687E-03,   1.0206256E-03,   9.4752572E-04
     +,   8.7755674E-04,   8.1078894E-04,   7.4727030E-04
     +,   6.8702910E-04,   6.3007989E-04,   5.7641091E-04
     +,   5.2599161E-04,   4.7877652E-04,   4.3470299E-04
     +,   3.9368984E-04,   3.5564278E-04,   3.2045844E-04
     +,   2.8802326E-04,   2.5821346E-04,   2.3089962E-04
     +,   2.0594975E-04,   1.8322899E-04,   1.6259980E-04
     +,   1.4392505E-04,   1.2707103E-04,   1.1190475E-04
     +,   9.8297001E-05,   8.6123851E-05,   7.5266136E-05
     +,   6.5609514E-05,   5.7045720E-05,   4.9473216E-05
     +,   4.2796673E-05,   3.6926696E-05,   3.1780415E-05
     +,   2.7281540E-05,   2.3359889E-05,   1.9950930E-05
     +,   1.6995875E-05,   1.4441629E-05,   1.2239931E-05
     +,   1.0347356E-05,   8.7250874E-06,   7.3384117E-06
     +,   6.1563660E-06,   5.1515017E-06,   4.2996476E-06
     +,   3.5795135E-06,   2.9723783E-06,   2.4619055E-06
     +,   2.0338896E-06,   1.6760060E-06,   1.3775666E-06
     +,   1.1293683E-06,   9.2352872E-07,   7.5327574E-07
     +,   6.1283413E-07,   4.9730272E-07,   4.0252215E-07
     +,   3.2497286E-07,   2.6169170E-07,   2.1019400E-07
     +,   1.6839994E-07,   1.3457107E-07,   1.0726190E-07
     +,   8.5276795E-08,   6.7623887E-08,   5.3488492E-08
     +,   4.2199186E-08,   3.3207691E-08,   2.6064951E-08
     +,   2.0406372E-08,   1.5935207E-08,   1.2411950E-08
     +,   9.6428510E-09,   7.4724111E-09,   5.7756799E-09
     +,   4.4527426E-09,   3.4240637E-09,   2.6262661E-09
     +,   2.0092095E-09,   1.5331807E-09,   1.1669479E-09
     +,   8.8591279E-10,   6.7084233E-10,   5.0667631E-10
     +,   3.8170717E-10,   2.8682098E-10,   2.1497119E-10
     +,   1.6070556E-10,   1.1983126E-10
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_haonly_hatt80_mass = Yx/5.45310064864865
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_haonly_hatt85_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.0311305E-03,   2.1758173E-03
     +,   2.3261663E-03,   2.4819868E-03,   2.6430511E-03
     +,   2.8090915E-03,   2.9798043E-03,   3.1548492E-03
     +,   3.3338501E-03,   3.5164026E-03,   3.7020671E-03
     +,   3.8903751E-03,   4.0808357E-03,   4.2729340E-03
     +,   4.4661365E-03,   4.6598958E-03,   4.8536528E-03
     +,   5.0468426E-03,   5.2388958E-03,   5.4292460E-03
     +,   5.6173345E-03,   5.8026104E-03,   5.9845350E-03
     +,   6.1626020E-03,   6.3363034E-03,   6.5051834E-03
     +,   6.6687982E-03,   6.8267439E-03,   6.9786524E-03
     +,   7.1241935E-03,   7.2630760E-03,   7.3950537E-03
     +,   7.5199245E-03,   7.6375310E-03,   7.7477628E-03
     +,   7.8505566E-03,   7.9458980E-03,   8.0338158E-03
     +,   8.1143957E-03,   8.1877606E-03,   8.2540838E-03
     +,   8.3135841E-03,   8.3665261E-03,   8.4132124E-03
     +,   8.4539913E-03,   8.4892474E-03,   8.5194046E-03
     +,   8.5449172E-03,   8.5662734E-03,   8.5839918E-03
     +,   8.5986098E-03,   8.6106928E-03,   8.6208191E-03
     +,   8.6295810E-03,   8.6375792E-03,   8.6454172E-03
     +,   8.6536994E-03,   8.6630210E-03,   8.6739715E-03
     +,   8.6871227E-03,   8.7030306E-03,   8.7222299E-03
     +,   8.7452363E-03,   8.7725362E-03,   8.8045942E-03
     +,   8.8418564E-03,   8.8847503E-03,   8.9336792E-03
     +,   8.9890454E-03,   9.0512382E-03,   9.1206562E-03
     +,   9.1976961E-03,   9.2827799E-03,   9.3763396E-03
     +,   9.4788345E-03,   9.5907561E-03,   9.7126141E-03
     +,   9.8449402E-03,   9.9882912E-03,   1.0143235E-02
     +,   1.0310319E-02,   1.0490089E-02,   1.0683031E-02
     +,   1.0889595E-02,   1.1110120E-02,   1.1344868E-02
     +,   1.1593942E-02,   1.1857325E-02,   1.2134794E-02
     +,   1.2425964E-02,   1.2730244E-02,   1.3046802E-02
     +,   1.3374587E-02,   1.3712316E-02,   1.4058478E-02
     +,   1.4411283E-02,   1.4768749E-02,   1.5128633E-02
     +,   1.5488538E-02,   1.5845867E-02,   1.6197974E-02
     +,   1.6542166E-02,   1.6875904E-02,   1.7196892E-02
     +,   1.7503349E-02,   1.7794270E-02,   1.8069720E-02
     +,   1.8331306E-02,   1.8582664E-02,   1.8830024E-02
     +,   1.9082785E-02,   1.9354207E-02,   1.9661892E-02
     +,   2.0028273E-02,   2.0480627E-02,   2.1050969E-02
     +,   2.1775125E-02,   2.2691552E-02,   2.3839122E-02
     +,   2.5254659E-02,   2.6969573E-02,   2.9005939E-02
     +,   3.1372428E-02,   3.4060765E-02,   3.7043452E-02
     +,   4.0275823E-02,   4.3708205E-02,   4.7313493E-02
     +,   5.1141873E-02,   5.5405684E-02,   6.0595181E-02
     +,   6.7596957E-02,   7.7770144E-02,   9.2902549E-02
     +,   0.1149880    ,   0.1458019    ,   0.1863493    
     +,   0.2363505    ,   0.2939633    ,   0.3558606    
     +,   0.4176717    ,   0.4746801    ,   0.5225860    
     +,   0.5581278    ,   0.5794160    ,   0.5858930    
     +,   0.5779713    ,   0.5566193    ,   0.5231791    
     +,   0.4795137    ,   0.4282817    ,   0.3729769    
     +,   0.3175208    ,   0.2655518    ,   0.2197684    
     +,   0.1816060    ,   0.1512922    ,   0.1281482    
     +,   0.1109560    ,   9.8274618E-02,   8.8676333E-02
     +,   8.0918580E-02,   7.4049659E-02,   6.7448005E-02
     +,   6.0802054E-02,   5.4047614E-02,   4.7285657E-02
     +,   4.0701028E-02,   3.4496326E-02,   2.8846899E-02
     +,   2.3875650E-02,   1.9643404E-02,   1.6151743E-02
     +,   1.3354195E-02,   1.1170996E-02,   9.5036915E-03
     +,   8.2488582E-03,   7.3083718E-03,   6.5959655E-03
     +,   6.0406048E-03,   5.5872891E-03,   5.1959548E-03
     +,   4.8392829E-03,   4.5001102E-03,   4.1689090E-03
     +,   3.8415578E-03,   3.5174745E-03,   3.1981841E-03
     +,   2.8863091E-03,   2.5848944E-03,   2.2968738E-03
     +,   2.0248219E-03,   1.7708133E-03,   1.5363349E-03
     +,   1.3222651E-03,   1.1289269E-03,   9.5615588E-04
     +,   8.0335856E-04,   6.6958572E-04,   5.5362593E-04
     +,   4.5409164E-04,   3.6948017E-04,   2.9823411E-04
     +,   2.3880281E-04,   1.8969014E-04,   1.4947585E-04
     +,   1.1684644E-04,   9.0611298E-05,   6.9707006E-05
     +,   5.3197946E-05,   4.0274921E-05,   3.0248282E-05
     +,   2.2537108E-05,   1.6658050E-05,   1.2214477E-05
     +,   8.8849683E-06,   6.4116953E-06,   4.5901020E-06
     +,   3.2598725E-06,   2.2967754E-06,   1.6053588E-06
     +,   1.1131604E-06,   7.6574048E-07,   5.2257627E-07
     +,   3.5380049E-07,   2.3763104E-07,   1.5834014E-07
     +,   1.0467150E-07,   6.8645420E-08,   4.4661650E-08
     +,   2.8827454E-08,   1.8460037E-08,   1.1727618E-08
     +,   7.3914950E-09,   4.6218296E-09,   2.8671487E-09
     +,   1.7645535E-09,   1.0773993E-09,   6.5265421E-10
     +,   3.9223766E-10,   2.3386712E-10,   1.3834085E-10
     +,   8.1189985E-11,   4.7273675E-11,   2.7308279E-11
     +,   1.5650805E-11,   8.8992737E-12,   5.0204424E-12
     +,   2.8099170E-12,   1.5603576E-12,   8.5966336E-13
     +,   4.6989300E-13,   2.5482684E-13,   1.3711231E-13
     +,   7.3195796E-14,   3.8767316E-14,   2.0371627E-14
     +,   1.0621275E-14,   5.4942597E-15,   2.8197875E-15
     +,   1.4358478E-15,   7.2542935E-16,   3.6363715E-16
     +,   1.8085018E-16,   8.9241684E-17,   4.3692464E-17
     +,   2.1223876E-17,   1.0229000E-17,   4.8915230E-18
     +,   2.3208465E-18,   1.0925291E-18,   5.1028472E-19
     +,   2.3648109E-19,   1.0873722E-19,   4.9606926E-20
     +,   2.2455033E-20,   1.0084871E-20,   4.4940375E-21
     +,   1.9869642E-21,   8.7166924E-22,   3.7940186E-22
     +,   1.6385479E-22,   7.0210823E-23,   2.9851175E-23
     +,   1.2592296E-23,   5.2706286E-24,   2.1888673E-24
     +,   9.0191335E-25,   3.6874135E-25,   1.4957744E-25
     +,   6.0203960E-26,   2.4042034E-26,   9.5264985E-27
     +,   3.7452589E-27,   1.4609840E-27,   5.6545756E-28
     +,   2.1715618E-28,   8.2743891E-29,   3.1284267E-29
     +,   1.1735890E-29,   4.3686181E-30
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_haonly_hatt85_mass = Yx/2.6995093125
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_haonly_hatt90_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  9.8343364E-05,   1.1013012E-04
     +,   1.2310754E-04,   1.3736628E-04,   1.5300002E-04
     +,   1.7010518E-04,   1.8878053E-04,   2.0912671E-04
     +,   2.3124515E-04,   2.5523896E-04,   2.8120997E-04
     +,   3.0925943E-04,   3.3948678E-04,   3.7198866E-04
     +,   4.0685816E-04,   4.4418365E-04,   4.8404769E-04
     +,   5.2652671E-04,   5.7168870E-04,   6.1959418E-04
     +,   6.7029393E-04,   7.2382856E-04,   7.8022754E-04
     +,   8.3951332E-04,   9.0169034E-04,   9.6675940E-04
     +,   1.0347068E-03,   1.1055102E-03,   1.1791387E-03
     +,   1.2555546E-03,   1.3347155E-03,   1.4165755E-03
     +,   1.5010897E-03,   1.5882171E-03,   1.6779227E-03
     +,   1.7701836E-03,   1.8649914E-03,   1.9623570E-03
     +,   2.0623228E-03,   2.1649480E-03,   2.2703377E-03
     +,   2.3786295E-03,   2.4900036E-03,   2.6046853E-03
     +,   2.7229500E-03,   2.8451199E-03,   2.9715688E-03
     +,   3.1027191E-03,   3.2390424E-03,   3.3810521E-03
     +,   3.5293035E-03,   3.6843873E-03,   3.8469180E-03
     +,   4.0175421E-03,   4.1969037E-03,   4.3856706E-03
     +,   4.5845015E-03,   4.7940556E-03,   5.0149797E-03
     +,   5.2479156E-03,   5.4934979E-03,   5.7523614E-03
     +,   6.0251285E-03,   6.3124634E-03,   6.6150595E-03
     +,   6.9336267E-03,   7.2689815E-03,   7.6219742E-03
     +,   7.9935966E-03,   8.3848927E-03,   8.7970681E-03
     +,   9.2313699E-03,   9.6891792E-03,   1.0171872E-02
     +,   1.0680864E-02,   1.1217505E-02,   1.1782958E-02
     +,   1.2378133E-02,   1.3003606E-02,   1.3659465E-02
     +,   1.4345091E-02,   1.5059200E-02,   1.5799506E-02
     +,   1.6562814E-02,   1.7344715E-02,   1.8139739E-02
     +,   1.8941104E-02,   1.9740971E-02,   2.0530276E-02
     +,   2.1299053E-02,   2.2036534E-02,   2.2731306E-02
     +,   2.3371663E-02,   2.3945950E-02,   2.4442827E-02
     +,   2.4851598E-02,   2.5162660E-02,   2.5367707E-02
     +,   2.5460145E-02,   2.5435248E-02,   2.5290398E-02
     +,   2.5025209E-02,   2.4641538E-02,   2.4143510E-02
     +,   2.3537368E-02,   2.2831284E-02,   2.2035200E-02
     +,   2.1160491E-02,   2.0219570E-02,   1.9225592E-02
     +,   1.8192180E-02,   1.7132839E-02,   1.6060894E-02
     +,   1.4988901E-02,   1.3928661E-02,   1.2890721E-02
     +,   1.1884484E-02,   1.0917839E-02,   9.9973520E-03
     +,   9.1280565E-03,   8.3136009E-03,   7.5563970E-03
     +,   6.8576951E-03,   6.2177437E-03,   5.6360732E-03
     +,   5.1118275E-03,   4.6439711E-03,   4.2318176E-03
     +,   3.8753422E-03,   3.5757730E-03,   3.3360010E-03
     +,   3.1611410E-03,   3.0588841E-03,   3.0398285E-03
     +,   3.1175495E-03,   3.3085102E-03,   3.6317329E-03
     +,   4.1083773E-03,   4.7614127E-03,   5.6154802E-03
     +,   6.6971239E-03,   8.0356505E-03,   9.6648382E-03
     +,   1.1625421E-02,   1.3969008E-02,   1.6765419E-02
     +,   2.0114226E-02,   2.4162671E-02,   2.9130960E-02
     +,   3.5341665E-02,   4.3244056E-02,   5.3419441E-02
     +,   6.6552587E-02,   8.3358519E-02,   0.1044622    
     +,   0.1302473    ,   0.1607040    ,   0.1953067    
     +,   0.2329389    ,   0.2718874    ,   0.3099361    
     +,   0.3445532    ,   0.3731905    ,   0.3936673    
     +,   0.4045464    ,   0.4053873    ,   0.3967851    
     +,   0.3801650    ,   0.3574075    ,   0.3304511    
     +,   0.3010142    ,   0.2704920    ,   0.2400029    
     +,   0.2104948    ,   0.1828138    ,   0.1576842    
     +,   0.1356366    ,   0.1169259    ,   0.1014947    
     +,   8.9008451E-02,   7.8950830E-02,   7.0741870E-02
     +,   6.3842900E-02,   5.7825182E-02,   5.2396283E-02
     +,   4.7390420E-02,   4.2736955E-02,   3.8422823E-02
     +,   3.4459852E-02,   3.0862162E-02,   2.7633118E-02
     +,   2.4762217E-02,   2.2227285E-02,   1.9998685E-02
     +,   1.8043756E-02,   1.6330544E-02,   1.4829839E-02
     +,   1.3515695E-02,   1.2365149E-02,   1.1357686E-02
     +,   1.0474660E-02,   9.6987458E-03,   9.0137497E-03
     +,   8.4047113E-03,   7.8581357E-03,   7.3620910E-03
     +,   6.9064391E-03,   6.4829015E-03,   6.0849818E-03
     +,   5.7077887E-03,   5.3478465E-03,   5.0028600E-03
     +,   4.6714330E-03,   4.3528043E-03,   4.0466655E-03
     +,   3.7530067E-03,   3.4719643E-03,   3.2037117E-03
     +,   2.9484145E-03,   2.7062157E-03,   2.4771639E-03
     +,   2.2612335E-03,   2.0583358E-03,   1.8683083E-03
     +,   1.6909095E-03,   1.5258412E-03,   1.3727651E-03
     +,   1.2312965E-03,   1.1010021E-03,   9.8141748E-04
     +,   8.7205804E-04,   7.7241519E-04,   6.8195601E-04
     +,   6.0013676E-04,   5.2641379E-04,   4.6023415E-04
     +,   4.0104875E-04,   3.4832064E-04,   3.0152482E-04
     +,   2.6014954E-04,   2.2370384E-04,   1.9172244E-04
     +,   1.6376458E-04,   1.3941462E-04,   1.1828540E-04
     +,   1.0001971E-04,   8.4288477E-05,   7.0789683E-05
     +,   5.9249127E-05,   4.9419777E-05,   4.1078656E-05
     +,   3.4026445E-05,   2.8086344E-05,   2.3101789E-05
     +,   1.8934548E-05,   1.5463615E-05,   1.2583616E-05
     +,   1.0203100E-05,   8.2428578E-06,   6.6348207E-06
     +,   5.3208341E-06,   4.2513193E-06,   3.3841357E-06
     +,   2.6837424E-06,   2.1203148E-06,   1.6688408E-06
     +,   1.3085004E-06,   1.0220515E-06,   7.9525944E-07
     +,   6.1641276E-07,   4.7593974E-07,   3.6605596E-07
     +,   2.8045085E-07,   2.1402853E-07,   1.6269853E-07
     +,   1.2319582E-07,   9.2917404E-08,   6.9805999E-08
     +,   5.2236039E-08,   3.8934612E-08,   2.8905363E-08
     +,   2.1374884E-08,   1.5743526E-08,   1.1549925E-08
     +,   8.4396579E-09,   6.1425309E-09,   4.4528665E-09
     +,   3.2151173E-09,   2.3122033E-09,   1.6562219E-09
     +,   1.1816293E-09,   8.3966345E-10,   5.9429073E-10
     +,   4.1894002E-10,   2.9415304E-10,   2.0570913E-10
     +,   1.4328513E-10,   9.9404575E-11,   6.8687792E-11
     +,   4.7272526E-11,   3.2404586E-11
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_haonly_hatt90_mass = Yx/2.10455767741936
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_haonly_hatt95_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.5589184E-04,   1.7675894E-04
     +,   1.9998824E-04,   2.2578328E-04,   2.5435630E-04
     +,   2.8592735E-04,   3.2072340E-04,   3.5897683E-04
     +,   4.0092357E-04,   4.4680375E-04,   4.9685611E-04
     +,   5.5131828E-04,   6.1042374E-04,   6.7439966E-04
     +,   7.4346311E-04,   8.1781938E-04,   8.9765794E-04
     +,   9.8314986E-04,   1.0744437E-03,   1.1716631E-03
     +,   1.2749031E-03,   1.3842261E-03,   1.4996582E-03
     +,   1.6211945E-03,   1.7487750E-03,   1.8823112E-03
     +,   2.0216596E-03,   2.1666316E-03,   2.3169899E-03
     +,   2.4724461E-03,   2.6326629E-03,   2.7972525E-03
     +,   2.9657776E-03,   3.1377543E-03,   3.3126522E-03
     +,   3.4898988E-03,   3.6688820E-03,   3.8489529E-03
     +,   4.0294426E-03,   4.2096372E-03,   4.3888232E-03
     +,   4.5662648E-03,   4.7412184E-03,   4.9129450E-03
     +,   5.0807092E-03,   5.2437931E-03,   5.4014982E-03
     +,   5.5531547E-03,   5.6981286E-03,   5.8358265E-03
     +,   5.9657050E-03,   6.0872710E-03,   6.2000882E-03
     +,   6.3037896E-03,   6.3980650E-03,   6.4826803E-03
     +,   6.5574669E-03,   6.6223289E-03,   6.6772439E-03
     +,   6.7222607E-03,   6.7574973E-03,   6.7831445E-03
     +,   6.7994534E-03,   6.8067433E-03,   6.8053934E-03
     +,   6.7958343E-03,   6.7785541E-03,   6.7540840E-03
     +,   6.7229997E-03,   6.6859173E-03,   6.6434806E-03
     +,   6.5963706E-03,   6.5452876E-03,   6.4909570E-03
     +,   6.4341179E-03,   6.3755224E-03,   6.3159368E-03
     +,   6.2561375E-03,   6.1968951E-03,   6.1389883E-03
     +,   6.0831970E-03,   6.0302881E-03,   5.9810318E-03
     +,   5.9361788E-03,   5.8964747E-03,   5.8626388E-03
     +,   5.8353767E-03,   5.8153607E-03,   5.8032353E-03
     +,   5.7996055E-03,   5.8050323E-03,   5.8200224E-03
     +,   5.8450275E-03,   5.8804275E-03,   5.9265317E-03
     +,   5.9835603E-03,   6.0516456E-03,   6.1308146E-03
     +,   6.2209941E-03,   6.3219867E-03,   6.4334855E-03
     +,   6.5550478E-03,   6.6861175E-03,   6.8259910E-03
     +,   6.9738529E-03,   7.1287663E-03,   7.2896560E-03
     +,   7.4553438E-03,   7.6245526E-03,   7.7959215E-03
     +,   7.9679955E-03,   8.1392825E-03,   8.3082318E-03
     +,   8.4732939E-03,   8.6328993E-03,   8.7855337E-03
     +,   8.9297099E-03,   9.0640336E-03,   9.1871992E-03
     +,   9.2980415E-03,   9.3955463E-03,   9.4788726E-03
     +,   9.5473751E-03,   9.6006393E-03,   9.6384957E-03
     +,   9.6610244E-03,   9.6685868E-03,   9.6618319E-03
     +,   9.6416930E-03,   9.6094077E-03,   9.5665045E-03
     +,   9.5147919E-03,   9.4563458E-03,   9.3934853E-03
     +,   9.3287397E-03,   9.2648175E-03,   9.2045581E-03
     +,   9.1508795E-03,   9.1067348E-03,   9.0750502E-03
     +,   9.0586999E-03,   9.0604350E-03,   9.0828789E-03
     +,   9.1285035E-03,   9.1996305E-03,   9.2984689E-03
     +,   9.4271712E-03,   9.5879063E-03,   9.7829765E-03
     +,   1.0014990E-02,   1.0287028E-02,   1.0602850E-02
     +,   1.0967114E-02,   1.1385656E-02,   1.1865673E-02
     +,   1.2415822E-02,   1.3046287E-02,   1.3768674E-02
     +,   1.4595671E-02,   1.5540407E-02,   1.6615817E-02
     +,   1.7833585E-02,   1.9202838E-02,   2.0728761E-02
     +,   2.2411086E-02,   2.4242507E-02,   2.6207646E-02
     +,   2.8283935E-02,   3.0445900E-02,   3.2674145E-02
     +,   3.4970392E-02,   3.7378523E-02,   4.0009141E-02
     +,   4.3064136E-02,   4.6860076E-02,   5.1855776E-02
     +,   5.8695447E-02,   6.8283319E-02,   8.1895515E-02
     +,   0.1012936    ,   0.1287418    ,   0.1667743    
     +,   0.2175831    ,   0.2820246    ,   0.3584835    
     +,   0.4420837    ,   0.5248039    ,   0.5967653    
     +,   0.6484107    ,   0.6728437    ,   0.6674359    
     +,   0.6341230    ,   0.5784702    ,   0.5080358    
     +,   0.4306891    ,   0.3533559    ,   0.2813224    
     +,   0.2180062    ,   0.1650695    ,   0.1227433    
     +,   9.0241872E-02,   6.6171721E-02,   4.8884653E-02
     +,   3.6743432E-02,   2.8294399E-02,   2.2359041E-02
     +,   1.8063959E-02,   1.4818489E-02,   1.2258081E-02
     +,   1.0174771E-02,   8.4532574E-03,   7.0237601E-03
     +,   5.8347075E-03,   4.8415824E-03,   4.0053371E-03
     +,   3.2940467E-03,   2.6840621E-03,   2.1595098E-03
     +,   1.7104512E-03,   1.3304844E-03,   1.0145020E-03
     +,   7.5730082E-04,   5.5293535E-04,   3.9466098E-04
     +,   2.7526804E-04,   1.8757190E-04,   1.2485600E-04
     +,   8.1181322E-05,   5.1556970E-05,   3.1980897E-05
     +,   1.9376401E-05,   1.1466985E-05,   6.6286511E-06
     +,   3.7429386E-06,   2.0647233E-06,   1.1127943E-06
     +,   5.8606184E-07,   3.0170855E-07,   1.5190335E-07
     +,   7.4855393E-08,   3.6151302E-08,   1.7149501E-08
     +,   8.0213329E-09,   3.7221621E-09,   1.7306647E-09
     +,   8.1848978E-10,   4.0166739E-10,   2.0896973E-10
     +,   1.1704952E-10,   7.0742537E-11,   4.5612691E-11
     +,   3.0820339E-11,   2.1460321E-11,   1.5210274E-11
     +,   1.0888537E-11,   7.8381728E-12,   5.6606738E-12
     +,   4.0966865E-12,   2.9694277E-12,   2.1551957E-12
     +,   1.5661721E-12,   1.1395135E-12,   8.3006052E-13
     +,   6.0532547E-13,   4.4191438E-13,   3.2293878E-13
     +,   2.3620382E-13,   1.7289836E-13,   1.2664330E-13
     +,   9.2809468E-14,   6.8038193E-14,   4.9888990E-14
     +,   3.6583322E-14,   2.6823785E-14,   1.9662825E-14
     +,   1.4408166E-14,   1.0552162E-14,   7.7232083E-15
     +,   5.6482973E-15,   4.1272540E-15,   3.0128473E-15
     +,   2.1970201E-15,   1.6002471E-15,   1.1641584E-15
     +,   8.4580697E-16,   6.1368543E-16,   4.4464200E-16
     +,   3.2168906E-16,   2.3238979E-16,   1.6761939E-16
     +,   1.2071354E-16,   8.6793984E-17,   6.2304825E-17
     +,   4.4651415E-17,   3.1947062E-17,   2.2818690E-17
     +,   1.6271184E-17,   1.1582435E-17,   8.2307738E-18
     +,   5.8388074E-18,   4.1348381E-18
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_haonly_hatt95_mass = Yx/2.37737070967742
      RETURN
      END
C 
C---- New file --- 
C 
      DOUBLE PRECISION FUNCTION A200_tt_hzonly_htt100_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.2486728E-03,   2.3019190E-03
     +,   2.3562892E-03,   2.4118284E-03,   2.4685827E-03
     +,   2.5266001E-03,   2.5859296E-03,   2.6466206E-03
     +,   2.7087231E-03,   2.7722882E-03,   2.8373667E-03
     +,   2.9040077E-03,   2.9722617E-03,   3.0421764E-03
     +,   3.1137983E-03,   3.1871735E-03,   3.2623438E-03
     +,   3.3393505E-03,   3.4182307E-03,   3.4990178E-03
     +,   3.5817442E-03,   3.6664354E-03,   3.7531133E-03
     +,   3.8418013E-03,   3.9325082E-03,   4.0252460E-03
     +,   4.1200221E-03,   4.2168335E-03,   4.3156776E-03
     +,   4.4165449E-03,   4.5194230E-03,   4.6242913E-03
     +,   4.7311299E-03,   4.8399116E-03,   4.9506067E-03
     +,   5.0631813E-03,   5.1775980E-03,   5.2938163E-03
     +,   5.4118014E-03,   5.5315001E-03,   5.6528738E-03
     +,   5.7758731E-03,   5.9004533E-03,   6.0265660E-03
     +,   6.1541679E-03,   6.2832092E-03,   6.4136502E-03
     +,   6.5454473E-03,   6.6785640E-03,   6.8129636E-03
     +,   6.9486140E-03,   7.0854882E-03,   7.2235642E-03
     +,   7.3628309E-03,   7.5032692E-03,   7.6448820E-03
     +,   7.7876733E-03,   7.9316571E-03,   8.0768568E-03
     +,   8.2233027E-03,   8.3710402E-03,   8.5201263E-03
     +,   8.6706169E-03,   8.8225994E-03,   8.9761745E-03
     +,   9.1314344E-03,   9.2885140E-03,   9.4475364E-03
     +,   9.6086636E-03,   9.7720474E-03,   9.9378768E-03
     +,   1.0106338E-02,   1.0277641E-02,   1.0451992E-02
     +,   1.0629619E-02,   1.0810762E-02,   1.0995649E-02
     +,   1.1184510E-02,   1.1377584E-02,   1.1575108E-02
     +,   1.1777285E-02,   1.1984329E-02,   1.2196408E-02
     +,   1.2413687E-02,   1.2636280E-02,   1.2864277E-02
     +,   1.3097702E-02,   1.3336571E-02,   1.3580792E-02
     +,   1.3830252E-02,   1.4084771E-02,   1.4344083E-02
     +,   1.4607851E-02,   1.4875687E-02,   1.5147130E-02
     +,   1.5421624E-02,   1.5698573E-02,   1.5977306E-02
     +,   1.6257115E-02,   1.6537230E-02,   1.6816873E-02
     +,   1.7095223E-02,   1.7371496E-02,   1.7644893E-02
     +,   1.7914684E-02,   1.8180201E-02,   1.8440861E-02
     +,   1.8696180E-02,   1.8945850E-02,   1.9189730E-02
     +,   1.9427847E-02,   1.9660478E-02,   1.9888140E-02
     +,   2.0111615E-02,   2.0331960E-02,   2.0550551E-02
     +,   2.0769026E-02,   2.0989373E-02,   2.1213831E-02
     +,   2.1444954E-02,   2.1685528E-02,   2.1938577E-02
     +,   2.2207301E-02,   2.2495043E-02,   2.2805229E-02
     +,   2.3141276E-02,   2.3506595E-02,   2.3904433E-02
     +,   2.4337856E-02,   2.4809670E-02,   2.5322346E-02
     +,   2.5877941E-02,   2.6478106E-02,   2.7123936E-02
     +,   2.7816070E-02,   2.8554628E-02,   2.9339163E-02
     +,   3.0168714E-02,   3.1041926E-02,   3.1957053E-02
     +,   3.2911919E-02,   3.3904128E-02,   3.4931127E-02
     +,   3.5990287E-02,   3.7078809E-02,   3.8194057E-02
     +,   3.9333399E-02,   4.0494237E-02,   4.1674044E-02
     +,   4.2870291E-02,   4.4080444E-02,   4.5301735E-02
     +,   4.6531118E-02,   4.7765285E-02,   4.9000543E-02
     +,   5.0232649E-02,   5.1457144E-02,   5.2669372E-02
     +,   5.3865012E-02,   5.5040263E-02,   5.6192845E-02
     +,   5.7322666E-02,   5.8432747E-02,   5.9530426E-02
     +,   6.0628269E-02,   6.1745275E-02,   6.2907353E-02
     +,   6.4148359E-02,   6.5510482E-02,   6.7044817E-02
     +,   6.8811715E-02,   7.0881866E-02,   7.3338330E-02
     +,   7.6279297E-02,   7.9821832E-02,   8.4108606E-02
     +,   8.9313522E-02,   9.5648013E-02,   0.1033642    
     +,   0.1127536    ,   0.1241360    ,   0.1378364    
     +,   0.1541500    ,   0.1732997    ,   0.1953867    
     +,   0.2203483    ,   0.2479371    ,   0.2777313    
     +,   0.3091713    ,   0.3416180    ,   0.3744259    
     +,   0.4070107    ,   0.4389386    ,   0.4700899    
     +,   0.5009185    ,   0.5327356    ,   0.5678162    
     +,   0.6090631    ,   0.6590962    ,   0.7190120    
     +,   0.7874448    ,   0.8606265    ,   0.9336612    
     +,    1.002446    ,    1.065212    ,    1.122852    
     +,    1.178014    ,    1.233749    ,    1.292518    
     +,    1.355577    ,    1.422285    ,    1.489400    
     +,    1.551497    ,    1.603259    ,    1.642500    
     +,    1.671503    ,    1.695634    ,    1.720410    
     +,    1.748267    ,    1.775496    ,    1.790720    
     +,    1.777848    ,    1.724171    ,    1.629052    
     +,    1.505819    ,    1.374399    ,    1.250382    
     +,    1.139157    ,    1.038394    ,   0.9446788    
     +,   0.8579317    ,   0.7810512    ,   0.7167762    
     +,   0.6651556    ,   0.6233231    ,   0.5870305    
     +,   0.5524629    ,   0.5172495    ,   0.4805244    
     +,   0.4424762    ,   0.4038343    ,   0.3655045    
     +,   0.3283578    ,   0.2931156    ,   0.2602941    
     +,   0.2301898    ,   0.2028972    ,   0.1783553    
     +,   0.1564088    ,   0.1368640    ,   0.1195199    
     +,   0.1041885    ,   9.0697423E-02,   7.8884661E-02
     +,   6.8592161E-02,   5.9663393E-02,   5.1944025E-02
     +,   4.5284059E-02,   3.9541308E-02,   3.4585562E-02
     +,   3.0301495E-02,   2.6589165E-02,   2.3363790E-02
     +,   2.0554699E-02,   1.8103827E-02,   1.5963044E-02
     +,   1.4092501E-02,   1.2458876E-02,   1.1033754E-02
     +,   9.7923931E-03,   8.7129995E-03,   7.7762022E-03
     +,   6.9645685E-03,   6.2623452E-03,   5.6553548E-03
     +,   5.1309457E-03,   4.6777870E-03,   4.2859125E-03
     +,   3.9465204E-03,   3.6519850E-03,   3.3956666E-03
     +,   3.1718821E-03,   2.9757346E-03,   2.8030705E-03
     +,   2.6503359E-03,   2.5145342E-03,   2.3931104E-03
     +,   2.2839052E-03,   2.1850960E-03,   2.0951328E-03
     +,   2.0127124E-03,   1.9367207E-03,   1.8662260E-03
     +,   1.8004302E-03,   1.7386669E-03,   1.6803662E-03
     +,   1.6250557E-03,   1.5723311E-03,   1.5218606E-03
     +,   1.4733623E-03,   1.4266085E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_hzonly_htt100_mass = Yx/14.6216270454545
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_hzonly_htt105_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.1453123E-03,   2.1805244E-03
     +,   2.2155056E-03,   2.2502355E-03,   2.2846966E-03
     +,   2.3188700E-03,   2.3527418E-03,   2.3862985E-03
     +,   2.4195292E-03,   2.4524257E-03,   2.4849824E-03
     +,   2.5171952E-03,   2.5490662E-03,   2.5805966E-03
     +,   2.6117943E-03,   2.6426692E-03,   2.6732367E-03
     +,   2.7035144E-03,   2.7335258E-03,   2.7632981E-03
     +,   2.7928632E-03,   2.8222571E-03,   2.8515230E-03
     +,   2.8807090E-03,   2.9098645E-03,   2.9390508E-03
     +,   2.9683306E-03,   2.9977735E-03,   3.0274545E-03
     +,   3.0574568E-03,   3.0878671E-03,   3.1187795E-03
     +,   3.1502945E-03,   3.1825188E-03,   3.2155665E-03
     +,   3.2495568E-03,   3.2846166E-03,   3.3208807E-03
     +,   3.3584894E-03,   3.3975900E-03,   3.4383393E-03
     +,   3.4809008E-03,   3.5254469E-03,   3.5721567E-03
     +,   3.6212220E-03,   3.6728387E-03,   3.7272202E-03
     +,   3.7845869E-03,   3.8451704E-03,   3.9092195E-03
     +,   3.9769947E-03,   4.0487712E-03,   4.1248435E-03
     +,   4.2055272E-03,   4.2911470E-03,   4.3820622E-03
     +,   4.4786488E-03,   4.5813047E-03,   4.6904585E-03
     +,   4.8065656E-03,   4.9301055E-03,   5.0615952E-03
     +,   5.2015656E-03,   5.3505935E-03,   5.5092829E-03
     +,   5.6782495E-03,   5.8581559E-03,   6.0496666E-03
     +,   6.2534851E-03,   6.4703040E-03,   6.7008524E-03
     +,   6.9458289E-03,   7.2059557E-03,   7.4818986E-03
     +,   7.7743251E-03,   8.0838595E-03,   8.4110480E-03
     +,   8.7563712E-03,   9.1202352E-03,   9.5029511E-03
     +,   9.9046705E-03,   1.0325461E-02,   1.0765177E-02
     +,   1.1223567E-02,   1.1700122E-02,   1.2194202E-02
     +,   1.2704890E-02,   1.3231097E-02,   1.3771446E-02
     +,   1.4324372E-02,   1.4888069E-02,   1.5460455E-02
     +,   1.6039221E-02,   1.6621862E-02,   1.7205691E-02
     +,   1.7787745E-02,   1.8364998E-02,   1.8934203E-02
     +,   1.9492093E-02,   2.0035243E-02,   2.0560285E-02
     +,   2.1063780E-02,   2.1542436E-02,   2.1992957E-02
     +,   2.2412295E-02,   2.2797542E-02,   2.3146009E-02
     +,   2.3455298E-02,   2.3723340E-02,   2.3948420E-02
     +,   2.4129163E-02,   2.4264649E-02,   2.4354348E-02
     +,   2.4398198E-02,   2.4396576E-02,   2.4350308E-02
     +,   2.4260690E-02,   2.4129417E-02,   2.3958683E-02
     +,   2.3750996E-02,   2.3509301E-02,   2.3236876E-02
     +,   2.2937346E-02,   2.2614557E-02,   2.2272637E-02
     +,   2.1915926E-02,   2.1548895E-02,   2.1176189E-02
     +,   2.0802492E-02,   2.0432563E-02,   2.0071179E-02
     +,   1.9723078E-02,   1.9392952E-02,   1.9085422E-02
     +,   1.8804980E-02,   1.8555954E-02,   1.8342543E-02
     +,   1.8168740E-02,   1.8038295E-02,   1.7954729E-02
     +,   1.7921278E-02,   1.7940899E-02,   1.8016186E-02
     +,   1.8149426E-02,   1.8342488E-02,   1.8596867E-02
     +,   1.8913640E-02,   1.9293431E-02,   1.9736381E-02
     +,   2.0242248E-02,   2.0810334E-02,   2.1439482E-02
     +,   2.2128154E-02,   2.2874543E-02,   2.3676623E-02
     +,   2.4532178E-02,   2.5439033E-02,   2.6395241E-02
     +,   2.7399268E-02,   2.8450115E-02,   2.9547751E-02
     +,   3.0693315E-02,   3.1889278E-02,   3.3139795E-02
     +,   3.4451026E-02,   3.5831232E-02,   3.7290756E-02
     +,   3.8842157E-02,   4.0500179E-02,   4.2281404E-02
     +,   4.4203777E-02,   4.6286132E-02,   4.8547551E-02
     +,   5.1006578E-02,   5.3679943E-02,   5.6582075E-02
     +,   5.9723705E-02,   6.3110724E-02,   6.6743284E-02
     +,   7.0615143E-02,   7.4712910E-02,   7.9015106E-02
     +,   8.3492808E-02,   8.8110439E-02,   9.2827342E-02
     +,   9.7600035E-02,   0.1023868    ,   0.1071538    
     +,   0.1118823    ,   0.1165774    ,   0.1212796    
     +,   0.1260753    ,   0.1311078    ,   0.1365862    
     +,   0.1427921    ,   0.1500785    ,   0.1588624    
     +,   0.1696037    ,   0.1827724    ,   0.1987973    
     +,   0.2180008    ,   0.2405319    ,   0.2663144    
     +,   0.2950280    ,   0.3261369    ,   0.3589776    
     +,   0.3928637    ,   0.4271879    ,   0.4614981    
     +,   0.4955688    ,   0.5294991    ,   0.5638497    
     +,   0.5997473    ,   0.6387590    ,   0.6823883    
     +,   0.7312559    ,   0.7843971    ,   0.8393487    
     +,   0.8934942    ,   0.9464817    ,    1.002394    
     +,    1.069661    ,    1.157502    ,    1.270273    
     +,    1.403571    ,    1.545651    ,    1.684008    
     +,    1.812443    ,    1.932306    ,    2.045841    
     +,    2.147952    ,    2.226467    ,    2.272047    
     +,    2.286563    ,    2.280696    ,    2.264535    
     +,    2.240075    ,    2.200602    ,    2.137136    
     +,    2.046770    ,    1.934421    ,    1.806213    
     +,    1.663417    ,    1.504411    ,    1.331066    
     +,    1.151430    ,   0.9766688    ,   0.8164769    
     +,   0.6767381    ,   0.5595521    ,   0.4641361    
     +,   0.3877996    ,   0.3268543    ,   0.2774889    
     +,   0.2364681    ,   0.2014949    ,   0.1712027    
     +,   0.1449079    ,   0.1222967    ,   0.1031706    
     +,   8.7296247E-02,   7.4352078E-02,   6.3941687E-02
     +,   5.5637345E-02,   4.9024630E-02,   4.3732889E-02
     +,   3.9452296E-02,   3.5936527E-02,   3.2996200E-02
     +,   3.0488802E-02,   2.8308662E-02,   2.6377961E-02
     +,   2.4639526E-02,   2.3051515E-02,   2.1583641E-02
     +,   2.0214407E-02,   1.8928561E-02,   1.7715683E-02
     +,   1.6568525E-02,   1.5482297E-02,   1.4453581E-02
     +,   1.3480065E-02,   1.2559879E-02,   1.1691598E-02
     +,   1.0873813E-02,   1.0105255E-02,   9.3845250E-03
     +,   8.7101432E-03,   8.0805905E-03,   7.4941474E-03
     +,   6.9490569E-03,   6.4433939E-03,   5.9752101E-03
     +,   5.5424329E-03,   5.1430073E-03,   4.7748061E-03
     +,   4.4357530E-03,   4.1237599E-03,   3.8368220E-03
     +,   3.5729646E-03,   3.3303250E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_hzonly_htt105_mass = Yx/16.0769251363636
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_hzonly_htt107_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.1300892E-03,   4.2552371E-03
     +,   4.3807817E-03,   4.5065018E-03,   4.6321712E-03
     +,   4.7575580E-03,   4.8824283E-03,   5.0065420E-03
     +,   5.1296568E-03,   5.2515389E-03,   5.3719440E-03
     +,   5.4906374E-03,   5.6073852E-03,   5.7219593E-03
     +,   5.8341399E-03,   5.9437118E-03,   6.0504708E-03
     +,   6.1542257E-03,   6.2547936E-03,   6.3520102E-03
     +,   6.4457217E-03,   6.5357904E-03,   6.6220989E-03
     +,   6.7045507E-03,   6.7830603E-03,   6.8575745E-03
     +,   6.9280514E-03,   6.9944812E-03,   7.0568714E-03
     +,   7.1152556E-03,   7.1696928E-03,   7.2202687E-03
     +,   7.2670942E-03,   7.3103053E-03,   7.3500671E-03
     +,   7.3865708E-03,   7.4200351E-03,   7.4507031E-03
     +,   7.4788500E-03,   7.5047696E-03,   7.5287907E-03
     +,   7.5512617E-03,   7.5725606E-03,   7.5930813E-03
     +,   7.6132519E-03,   7.6335156E-03,   7.6543391E-03
     +,   7.6762065E-03,   7.6996228E-03,   7.7251093E-03
     +,   7.7531990E-03,   7.7844388E-03,   7.8193890E-03
     +,   7.8586126E-03,   7.9026762E-03,   7.9521555E-03
     +,   8.0076233E-03,   8.0696438E-03,   8.1387796E-03
     +,   8.2155792E-03,   8.3005764E-03,   8.3942935E-03
     +,   8.4972205E-03,   8.6098313E-03,   8.7325741E-03
     +,   8.8658500E-03,   9.0100430E-03,   9.1654798E-03
     +,   9.3324687E-03,   9.5112408E-03,   9.7020166E-03
     +,   9.9049415E-03,   1.0120125E-02,   1.0347620E-02
     +,   1.0587424E-02,   1.0839506E-02,   1.1103760E-02
     +,   1.1380031E-02,   1.1668133E-02,   1.1967842E-02
     +,   1.2278873E-02,   1.2600924E-02,   1.2933641E-02
     +,   1.3276677E-02,   1.3629623E-02,   1.3992101E-02
     +,   1.4363674E-02,   1.4743956E-02,   1.5132503E-02
     +,   1.5528927E-02,   1.5932849E-02,   1.6343880E-02
     +,   1.6761640E-02,   1.7185817E-02,   1.7616123E-02
     +,   1.8052228E-02,   1.8493909E-02,   1.8940901E-02
     +,   1.9393016E-02,   1.9850016E-02,   2.0311760E-02
     +,   2.0778021E-02,   2.1248640E-02,   2.1723416E-02
     +,   2.2202151E-02,   2.2684636E-02,   2.3170594E-02
     +,   2.3659736E-02,   2.4151728E-02,   2.4646226E-02
     +,   2.5142757E-02,   2.5640864E-02,   2.6140004E-02
     +,   2.6639607E-02,   2.7138999E-02,   2.7637532E-02
     +,   2.8134456E-02,   2.8629027E-02,   2.9120455E-02
     +,   2.9607940E-02,   3.0090721E-02,   3.0568007E-02
     +,   3.1039026E-02,   3.1503074E-02,   3.1959556E-02
     +,   3.2407816E-02,   3.2847431E-02,   3.3277959E-02
     +,   3.3699177E-02,   3.4110885E-02,   3.4513142E-02
     +,   3.4906060E-02,   3.5289999E-02,   3.5665438E-02
     +,   3.6033083E-02,   3.6393866E-02,   3.6748894E-02
     +,   3.7099525E-02,   3.7447356E-02,   3.7794258E-02
     +,   3.8142357E-02,   3.8494047E-02,   3.8852081E-02
     +,   3.9219461E-02,   3.9599530E-02,   3.9995920E-02
     +,   4.0412638E-02,   4.0853966E-02,   4.1324440E-02
     +,   4.1828938E-02,   4.2372569E-02,   4.2960536E-02
     +,   4.3598175E-02,   4.4290934E-02,   4.5044076E-02
     +,   4.5862630E-02,   4.6751298E-02,   4.7714252E-02
     +,   4.8754986E-02,   4.9875971E-02,   5.1078580E-02
     +,   5.2362904E-02,   5.3727422E-02,   5.5168781E-02
     +,   5.6681845E-02,   5.8259547E-02,   5.9892546E-02
     +,   6.1569620E-02,   6.3277796E-02,   6.5002620E-02
     +,   6.6728495E-02,   6.8439484E-02,   7.0120156E-02
     +,   7.1756594E-02,   7.3337488E-02,   7.4855402E-02
     +,   7.6308288E-02,   7.7700667E-02,   7.9044901E-02
     +,   8.0362260E-02,   8.1683673E-02,   8.3050117E-02
     +,   8.4512532E-02,   8.6131461E-02,   8.7976374E-02
     +,   9.0124451E-02,   9.2659198E-02,   9.5669419E-02
     +,   9.9247664E-02,   0.1034880    ,   0.1084853    
     +,   0.1143323    ,   0.1211157    ,   0.1289125    
     +,   0.1377843    ,   0.1477689    ,   0.1588719    
     +,   0.1710578    ,   0.1842439    ,   0.1982969    
     +,   0.2130342    ,   0.2282375    ,   0.2436743    
     +,   0.2591281    ,   0.2744293    ,   0.2894914    
     +,   0.3043271    ,   0.3190493    ,   0.3338533    
     +,   0.3489850    ,   0.3647085    ,   0.3812931    
     +,   0.3990324    ,   0.4182894    ,   0.4395441    
     +,   0.4634198    ,   0.4906645    ,   0.5221002    
     +,   0.5585501    ,   0.6007605    ,   0.6492969    
     +,   0.7043296    ,   0.7653283    ,   0.8308774    
     +,   0.8989398    ,   0.9678034    ,    1.037413    
     +,    1.110182    ,    1.190296    ,    1.281449    
     +,    1.384415    ,    1.496579    ,    1.614011    
     +,    1.734132    ,    1.855987    ,    1.977557    
     +,    2.093277    ,    2.195735    ,    2.281266    
     +,    2.353535    ,    2.419327    ,    2.478165    
     +,    2.515329    ,    2.506813    ,    2.433973    
     +,    2.296042    ,    2.110331    ,    1.901497    
     +,    1.689777    ,    1.486037    ,    1.293697    
     +,    1.113141    ,   0.9448623    ,   0.7903607    
     +,   0.6516191    ,   0.5302324    ,   0.4268471    
     +,   0.3410346    ,   0.2714715    ,   0.2162165    
     +,   0.1729901    ,   0.1394399    ,   0.1133859    
     +,   9.2996612E-02,   7.6856762E-02,   6.3935548E-02
     +,   5.3506196E-02,   4.5052335E-02,   3.8190328E-02
     +,   3.2618113E-02,   2.8087821E-02,   2.4392644E-02
     +,   2.1360585E-02,   1.8851183E-02,   1.6752733E-02
     +,   1.4978725E-02,   1.3463130E-02,   1.2156469E-02
     +,   1.1021301E-02,   1.0029107E-02,   9.1573019E-03
     +,   8.3875889E-03,   7.7044768E-03,   7.0947609E-03
     +,   6.5469444E-03,   6.0511874E-03,   5.5990797E-03
     +,   5.1835985E-03,   4.7990554E-03,   4.4408771E-03
     +,   4.1055637E-03,   3.7904417E-03,   3.4935910E-03
     +,   3.2136110E-03,   2.9495608E-03,   2.7007624E-03
     +,   2.4667669E-03,   2.2472099E-03,   2.0418083E-03
     +,   1.8502559E-03,   1.6722482E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_hzonly_htt107_mass = Yx/16.8338632
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_hzonly_htt110_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.5685234E-03,   2.6271495E-03
     +,   2.6863716E-03,   2.7461769E-03,   2.8065529E-03
     +,   2.8674861E-03,   2.9289643E-03,   2.9909718E-03
     +,   3.0534931E-03,   3.1165152E-03,   3.1800224E-03
     +,   3.2439979E-03,   3.3084247E-03,   3.3732867E-03
     +,   3.4385649E-03,   3.5042423E-03,   3.5702989E-03
     +,   3.6367171E-03,   3.7034757E-03,   3.7705575E-03
     +,   3.8379407E-03,   3.9056053E-03,   3.9735306E-03
     +,   4.0416997E-03,   4.1100890E-03,   4.1786809E-03
     +,   4.2474568E-03,   4.3164007E-03,   4.3854932E-03
     +,   4.4547212E-03,   4.5240726E-03,   4.5935339E-03
     +,   4.6631009E-03,   4.7327671E-03,   4.8025330E-03
     +,   4.8724026E-03,   4.9423873E-03,   5.0125006E-03
     +,   5.0827684E-03,   5.1532174E-03,   5.2238908E-03
     +,   5.2948380E-03,   5.3661200E-03,   5.4378118E-03
     +,   5.5100005E-03,   5.5827890E-03,   5.6562964E-03
     +,   5.7306630E-03,   5.8060437E-03,   5.8826176E-03
     +,   5.9605855E-03,   6.0401754E-03,   6.1216350E-03
     +,   6.2052449E-03,   6.2913047E-03,   6.3801538E-03
     +,   6.4721536E-03,   6.5676966E-03,   6.6672051E-03
     +,   6.7711361E-03,   6.8799639E-03,   6.9942074E-03
     +,   7.1143894E-03,   7.2410768E-03,   7.3748520E-03
     +,   7.5163045E-03,   7.6660533E-03,   7.8247050E-03
     +,   7.9928916E-03,   8.1712157E-03,   8.3602928E-03
     +,   8.5606985E-03,   8.7730009E-03,   8.9977048E-03
     +,   9.2352899E-03,   9.4861798E-03,   9.7507201E-03
     +,   1.0029169E-02,   1.0321723E-02,   1.0628480E-02
     +,   1.0949394E-02,   1.1284353E-02,   1.1633072E-02
     +,   1.1995180E-02,   1.2370111E-02,   1.2757224E-02
     +,   1.3155668E-02,   1.3564496E-02,   1.3982554E-02
     +,   1.4408601E-02,   1.4841249E-02,   1.5278941E-02
     +,   1.5720006E-02,   1.6162686E-02,   1.6605126E-02
     +,   1.7045345E-02,   1.7481355E-02,   1.7911073E-02
     +,   1.8332448E-02,   1.8743364E-02,   1.9141801E-02
     +,   1.9525724E-02,   1.9893235E-02,   2.0242468E-02
     +,   2.0571750E-02,   2.0879516E-02,   2.1164393E-02
     +,   2.1425191E-02,   2.1660939E-02,   2.1870939E-02
     +,   2.2054669E-02,   2.2211935E-02,   2.2342816E-02
     +,   2.2447648E-02,   2.2527091E-02,   2.2582088E-02
     +,   2.2613890E-02,   2.2624061E-02,   2.2614416E-02
     +,   2.2587126E-02,   2.2544593E-02,   2.2489533E-02
     +,   2.2424892E-02,   2.2353923E-02,   2.2280067E-02
     +,   2.2207007E-02,   2.2138633E-02,   2.2079058E-02
     +,   2.2032516E-02,   2.2003457E-02,   2.1996407E-02
     +,   2.2016050E-02,   2.2067139E-02,   2.2154525E-02
     +,   2.2283096E-02,   2.2457808E-02,   2.2683609E-02
     +,   2.2965467E-02,   2.3308378E-02,   2.3717346E-02
     +,   2.4197377E-02,   2.4753479E-02,   2.5390713E-02
     +,   2.6114216E-02,   2.6929138E-02,   2.7840730E-02
     +,   2.8854346E-02,   2.9975366E-02,   3.1209109E-02
     +,   3.2560978E-02,   3.4036186E-02,   3.5639502E-02
     +,   3.7375208E-02,   3.9246809E-02,   4.1256733E-02
     +,   4.3405794E-02,   4.5692872E-02,   4.8114710E-02
     +,   5.0665330E-02,   5.3335354E-02,   5.6112289E-02
     +,   5.8979999E-02,   6.1918452E-02,   6.4904027E-02
     +,   6.7910068E-02,   7.0907310E-02,   7.3864438E-02
     +,   7.6749548E-02,   7.9531759E-02,   8.2182683E-02
     +,   8.4678210E-02,   8.7000802E-02,   8.9141577E-02
     +,   9.1102324E-02,   9.2897221E-02,   9.4554521E-02
     +,   9.6117608E-02,   9.7645171E-02,   9.9211566E-02
     +,   0.1009061    ,   0.1028316    ,   0.1051038    
     +,   0.1078484    ,   0.1112005    ,   0.1153011    
     +,   0.1202935    ,   0.1263174    ,   0.1335021    
     +,   0.1419543    ,   0.1517432    ,   0.1628851    
     +,   0.1753255    ,   0.1889242    ,   0.2034501    
     +,   0.2185883    ,   0.2339617    ,   0.2491721    
     +,   0.2638584    ,   0.2777642    ,   0.2908023    
     +,   0.3031027    ,   0.3150314    ,   0.3271737    
     +,   0.3402779    ,   0.3551715    ,   0.3726777    
     +,   0.3935333    ,   0.4183175    ,   0.4473839    
     +,   0.4807784    ,   0.5181533    ,   0.5587190    
     +,   0.6013284    ,   0.6447472    ,   0.6880663    
     +,   0.7310869    ,   0.7744232    ,   0.8191383    
     +,   0.8659744    ,   0.9145434    ,   0.9630117    
     +,    1.008735    ,    1.049934    ,    1.087867    
     +,    1.128160    ,    1.179659    ,    1.250238    
     +,    1.341303    ,    1.444797    ,    1.545654    
     +,    1.629168    ,    1.688918    ,    1.729904    
     +,    1.764288    ,    1.802191    ,    1.843957    
     +,    1.880263    ,    1.900450    ,    1.902110    
     +,    1.893377    ,    1.885949    ,    1.885252    
     +,    1.886130    ,    1.877032    ,    1.848300    
     +,    1.797438    ,    1.727721    ,    1.642872    
     +,    1.543502    ,    1.428059    ,    1.296309    
     +,    1.151741    ,    1.001302    ,   0.8534241    
     +,   0.7158627    ,   0.5942588    ,   0.4914982    
     +,   0.4077617    ,   0.3411542    ,   0.2886508    
     +,   0.2470000    ,   0.2133360    ,   0.1854435    
     +,   0.1617619    ,   0.1412598    ,   0.1232774    
     +,   0.1074014    ,   9.3373522E-02,   8.1025027E-02
     +,   7.0231803E-02,   6.0884576E-02,   5.2870329E-02
     +,   4.6062876E-02,   4.0322937E-02,   3.5504714E-02
     +,   3.1464722E-02,   2.8068792E-02,   2.5198815E-02
     +,   2.2754772E-02,   2.0655721E-02,   1.8837551E-02
     +,   1.7250847E-02,   1.5857417E-02,   1.4627863E-02
     +,   1.3538850E-02,   1.2571588E-02,   1.1710248E-02
     +,   1.0941229E-02,   1.0252652E-02,   9.6338969E-03
     +,   9.0755858E-03,   8.5693430E-03,   8.1078531E-03
     +,   7.6846979E-03,   7.2944071E-03,   6.9322665E-03
     +,   6.5943738E-03,   6.2774327E-03,   5.9787775E-03
     +,   5.6961975E-03,   5.4279468E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_hzonly_htt110_mass = Yx/17.5453422666667
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_hzonly_htt115_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.8997062E-03,   5.0190771E-03
     +,   5.1383087E-03,   5.2572624E-03,   5.3758025E-03
     +,   5.4937890E-03,   5.6110835E-03,   5.7275519E-03
     +,   5.8430573E-03,   5.9574707E-03,   6.0706600E-03
     +,   6.1824974E-03,   6.2928614E-03,   6.4016334E-03
     +,   6.5086978E-03,   6.6139461E-03,   6.7172744E-03
     +,   6.8185842E-03,   6.9177854E-03,   7.0147901E-03
     +,   7.1095238E-03,   7.2019077E-03,   7.2918837E-03
     +,   7.3793982E-03,   7.4643954E-03,   7.5468426E-03
     +,   7.6267030E-03,   7.7039539E-03,   7.7785817E-03
     +,   7.8505753E-03,   7.9199411E-03,   7.9866825E-03
     +,   8.0508217E-03,   8.1123821E-03,   8.1713991E-03
     +,   8.2279118E-03,   8.2819723E-03,   8.3336346E-03
     +,   8.3829639E-03,   8.4300302E-03,   8.4749116E-03
     +,   8.5176909E-03,   8.5584577E-03,   8.5973078E-03
     +,   8.6343419E-03,   8.6696660E-03,   8.7033939E-03
     +,   8.7356335E-03,   8.7665124E-03,   8.7961508E-03
     +,   8.8246744E-03,   8.8522164E-03,   8.8789063E-03
     +,   8.9048836E-03,   8.9302845E-03,   8.9552552E-03
     +,   8.9799315E-03,   9.0044672E-03,   9.0290019E-03
     +,   9.0536866E-03,   9.0786722E-03,   9.1041150E-03
     +,   9.1301603E-03,   9.1569694E-03,   9.1846967E-03
     +,   9.2135007E-03,   9.2435470E-03,   9.2749894E-03
     +,   9.3080001E-03,   9.3427449E-03,   9.3793944E-03
     +,   9.4181206E-03,   9.4591128E-03,   9.5025450E-03
     +,   9.5486166E-03,   9.5975213E-03,   9.6494667E-03
     +,   9.7046699E-03,   9.7633610E-03,   9.8257838E-03
     +,   9.8921889E-03,   9.9628670E-03,   1.0038103E-02
     +,   1.0118232E-02,   1.0203597E-02,   1.0294588E-02
     +,   1.0391622E-02,   1.0495164E-02,   1.0605716E-02
     +,   1.0723840E-02,   1.0850159E-02,   1.0985347E-02
     +,   1.1130150E-02,   1.1285392E-02,   1.1451980E-02
     +,   1.1630899E-02,   1.1823230E-02,   1.2030145E-02
     +,   1.2252929E-02,   1.2492935E-02,   1.2751657E-02
     +,   1.3030662E-02,   1.3331631E-02,   1.3656323E-02
     +,   1.4006594E-02,   1.4384395E-02,   1.4791701E-02
     +,   1.5230544E-02,   1.5703004E-02,   1.6211165E-02
     +,   1.6757051E-02,   1.7342700E-02,   1.7969990E-02
     +,   1.8640760E-02,   1.9356608E-02,   2.0119036E-02
     +,   2.0929210E-02,   2.1788107E-02,   2.2696309E-02
     +,   2.3654090E-02,   2.4661366E-02,   2.5717556E-02
     +,   2.6821634E-02,   2.7972158E-02,   2.9167216E-02
     +,   3.0404320E-02,   3.1680670E-02,   3.2992840E-02
     +,   3.4337159E-02,   3.5709474E-02,   3.7105463E-02
     +,   3.8520440E-02,   3.9949767E-02,   4.1388582E-02
     +,   4.2832296E-02,   4.4276439E-02,   4.5716912E-02
     +,   4.7149904E-02,   4.8572339E-02,   4.9981754E-02
     +,   5.1376387E-02,   5.2755199E-02,   5.4118060E-02
     +,   5.5465762E-02,   5.6799747E-02,   5.8122307E-02
     +,   5.9436418E-02,   6.0745534E-02,   6.2053509E-02
     +,   6.3364498E-02,   6.4682744E-02,   6.6012219E-02
     +,   6.7356631E-02,   6.8719305E-02,   7.0102960E-02
     +,   7.1509562E-02,   7.2940275E-02,   7.4395619E-02
     +,   7.5875469E-02,   7.7378936E-02,   7.8904845E-02
     +,   8.0451816E-02,   8.2018539E-02,   8.3603948E-02
     +,   8.5208043E-02,   8.6831838E-02,   8.8478029E-02
     +,   9.0151228E-02,   9.1859087E-02,   9.3612276E-02
     +,   9.5425233E-02,   9.7316571E-02,   9.9310018E-02
     +,   0.1014342    ,   0.1037229    ,   0.1062149    
     +,   0.1089538    ,   0.1119862    ,   0.1153604    
     +,   0.1191248    ,   0.1233253    ,   0.1280027    
     +,   0.1331898    ,   0.1389109    ,   0.1451792    
     +,   0.1519966    ,   0.1593549    ,   0.1672372    
     +,   0.1756210    ,   0.1844801    ,   0.1937914    
     +,   0.2035394    ,   0.2137246    ,   0.2243733    
     +,   0.2355523    ,   0.2473806    ,   0.2600399    
     +,   0.2737791    ,   0.2889082    ,   0.3057786    
     +,   0.3247512    ,   0.3461623    ,   0.3702872    
     +,   0.3973069    ,   0.4272704    ,   0.4600616    
     +,   0.4953580    ,   0.5325919    ,   0.5709577    
     +,   0.6094783    ,   0.6471450    ,   0.6830979    
     +,   0.7167962    ,   0.7481084    ,   0.7772884    
     +,   0.8049023    ,   0.8317724    ,   0.8589923    
     +,   0.8879493    ,   0.9202247    ,   0.9572831    
     +,    1.000045    ,    1.048672    ,    1.102843    
     +,    1.162414    ,    1.227770    ,    1.299233    
     +,    1.375568    ,    1.452690    ,    1.523927    
     +,    1.582248    ,    1.623290    ,    1.647356    
     +,    1.659367    ,    1.667279    ,    1.679906    
     +,    1.704700    ,    1.745464    ,    1.800274    
     +,    1.860714    ,    1.913434    ,    1.943929    
     +,    1.940934    ,    1.899313    ,    1.820481    
     +,    1.710976    ,    1.580677    ,    1.441326    
     +,    1.305059    ,    1.182406    ,    1.080048    
     +,   0.9994450    ,   0.9371387    ,   0.8865910    
     +,   0.8406574    ,   0.7936006    ,   0.7420868    
     +,   0.6851758    ,   0.6237451    ,   0.5597453    
     +,   0.4955551    ,   0.4334936    ,   0.3755037    
     +,   0.3229706    ,   0.2766611    ,   0.2367456    
     +,   0.2029140    ,   0.1745337    ,   0.1508093    
     +,   0.1309208    ,   0.1141229    ,   9.9796228E-02
     +,   8.7458953E-02,   7.6753110E-02,   6.7419678E-02
     +,   5.9270781E-02,   5.2162718E-02,   4.5978844E-02
     +,   4.0615838E-02,   3.5978597E-02,   3.1976372E-02
     +,   2.8523803E-02,   2.5541041E-02,   2.2955872E-02
     +,   2.0704063E-02,   1.8730476E-02,   1.6988607E-02
     +,   1.5440249E-02,   1.4054823E-02,   1.2807988E-02
     +,   1.1680892E-02,   1.0658747E-02,   9.7301649E-03
     +,   8.8860150E-03,   8.1189731E-03,   7.4227653E-03
     +,   6.7919618E-03,   6.2215184E-03,   5.7067680E-03
     +,   5.2431724E-03,   4.8264093E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_hzonly_htt115_mass = Yx/18.5521522666667
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_hzonly_htt120_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.0074159E-03,   3.1309351E-03
     +,   3.2590353E-03,   3.3917583E-03,   3.5291328E-03
     +,   3.6711737E-03,   3.8178780E-03,   3.9692260E-03
     +,   4.1251793E-03,   4.2856866E-03,   4.4506686E-03
     +,   4.6200305E-03,   4.7936533E-03,   4.9713985E-03
     +,   5.1531047E-03,   5.3385901E-03,   5.5276463E-03
     +,   5.7200477E-03,   5.9155459E-03,   6.1138654E-03
     +,   6.3147177E-03,   6.5177907E-03,   6.7227492E-03
     +,   6.9292570E-03,   7.1369354E-03,   7.3454170E-03
     +,   7.5543062E-03,   7.7632042E-03,   7.9716984E-03
     +,   8.1793750E-03,   8.3858166E-03,   8.5906005E-03
     +,   8.7933140E-03,   8.9935400E-03,   9.1908751E-03
     +,   9.3849264E-03,   9.5753120E-03,   9.7616669E-03
     +,   9.9436510E-03,   1.0120938E-02,   1.0293227E-02
     +,   1.0460253E-02,   1.0621773E-02,   1.0777575E-02
     +,   1.0927485E-02,   1.1071359E-02,   1.1209099E-02
     +,   1.1340634E-02,   1.1465942E-02,   1.1585027E-02
     +,   1.1697947E-02,   1.1804793E-02,   1.1905693E-02
     +,   1.2000818E-02,   1.2090377E-02,   1.2174611E-02
     +,   1.2253799E-02,   1.2328252E-02,   1.2398315E-02
     +,   1.2464354E-02,   1.2526768E-02,   1.2585985E-02
     +,   1.2642436E-02,   1.2696583E-02,   1.2748905E-02
     +,   1.2799880E-02,   1.2850011E-02,   1.2899791E-02
     +,   1.2949727E-02,   1.3000318E-02,   1.3052058E-02
     +,   1.3105442E-02,   1.3160953E-02,   1.3219051E-02
     +,   1.3280195E-02,   1.3344823E-02,   1.3413349E-02
     +,   1.3486160E-02,   1.3563638E-02,   1.3646124E-02
     +,   1.3733939E-02,   1.3827375E-02,   1.3926681E-02
     +,   1.4032102E-02,   1.4143831E-02,   1.4262031E-02
     +,   1.4386834E-02,   1.4518356E-02,   1.4656643E-02
     +,   1.4801743E-02,   1.4953664E-02,   1.5112363E-02
     +,   1.5277772E-02,   1.5449815E-02,   1.5628355E-02
     +,   1.5813231E-02,   1.6004270E-02,   1.6201245E-02
     +,   1.6403936E-02,   1.6612051E-02,   1.6825324E-02
     +,   1.7043427E-02,   1.7266037E-02,   1.7492797E-02
     +,   1.7723337E-02,   1.7957278E-02,   1.8194223E-02
     +,   1.8433744E-02,   1.8675443E-02,   1.8918905E-02
     +,   1.9163677E-02,   1.9409357E-02,   1.9655515E-02
     +,   1.9901736E-02,   2.0147622E-02,   2.0392779E-02
     +,   2.0636832E-02,   2.0879464E-02,   2.1120355E-02
     +,   2.1359252E-02,   2.1595940E-02,   2.1830263E-02
     +,   2.2062130E-02,   2.2291541E-02,   2.2518611E-02
     +,   2.2743490E-02,   2.2966512E-02,   2.3188107E-02
     +,   2.3408873E-02,   2.3629524E-02,   2.3851037E-02
     +,   2.4074480E-02,   2.4301199E-02,   2.4532666E-02
     +,   2.4770686E-02,   2.5017222E-02,   2.5274513E-02
     +,   2.5545007E-02,   2.5831440E-02,   2.6136797E-02
     +,   2.6464274E-02,   2.6817331E-02,   2.7199626E-02
     +,   2.7615093E-02,   2.8067771E-02,   2.8561927E-02
     +,   2.9101968E-02,   2.9692374E-02,   3.0337689E-02
     +,   3.1042490E-02,   3.1811323E-02,   3.2648634E-02
     +,   3.3558637E-02,   3.4545381E-02,   3.5612632E-02
     +,   3.6763664E-02,   3.8001314E-02,   3.9327938E-02
     +,   4.0745337E-02,   4.2254593E-02,   4.3856211E-02
     +,   4.5550164E-02,   4.7335681E-02,   4.9211562E-02
     +,   5.1176369E-02,   5.3228363E-02,   5.5365741E-02
     +,   5.7586849E-02,   5.9890613E-02,   6.2276594E-02
     +,   6.4745173E-02,   6.7297786E-02,   6.9937482E-02
     +,   7.2668813E-02,   7.5497799E-02,   7.8432404E-02
     +,   8.1482552E-02,   8.4659636E-02,   8.7976895E-02
     +,   9.1449156E-02,   9.5092908E-02,   9.8925583E-02
     +,   0.1029657    ,   0.1072334    ,   0.1117493    
     +,   0.1165353    ,   0.1216142    ,   0.1270106    
     +,   0.1327503    ,   0.1388598    ,   0.1453672    
     +,   0.1523008    ,   0.1596876    ,   0.1675528    
     +,   0.1759186    ,   0.1848029    ,   0.1942182    
     +,   0.2041712    ,   0.2146639    ,   0.2256949    
     +,   0.2372586    ,   0.2493488    ,   0.2619585    
     +,   0.2750795    ,   0.2886983    ,   0.3027927    
     +,   0.3173242    ,   0.3322277    ,   0.3474065    
     +,   0.3627295    ,   0.3780397    ,   0.3931752    
     +,   0.4080081    ,   0.4225000    ,   0.4367580    
     +,   0.4510893    ,   0.4660261    ,   0.4823247    
     +,   0.5009148    ,   0.5228283    ,   0.5491260    
     +,   0.5808282    ,   0.6188519    ,   0.6639061    
     +,   0.7163264    ,   0.7758141    ,   0.8411998    
     +,   0.9103690    ,   0.9804556    ,    1.048262    
     +,    1.110742    ,    1.165398    ,    1.210632    
     +,    1.246201    ,    1.273878    ,    1.297967    
     +,    1.324913    ,    1.361524    ,    1.412326    
     +,    1.477505    ,    1.552818    ,    1.631490    
     +,    1.706632    ,    1.772666    ,    1.825336    
     +,    1.861143    ,    1.877229    ,    1.872045    
     +,    1.846501    ,    1.804584    ,    1.752353    
     +,    1.695267    ,    1.635490    ,    1.571141    
     +,    1.498158    ,    1.413278    ,    1.316175    
     +,    1.209765    ,    1.099149    ,   0.9901207    
     +,   0.8878390    ,   0.7959139    ,   0.7159794    
     +,   0.6477772    ,   0.5896464    ,   0.5392027    
     +,   0.4940151    ,   0.4520942    ,   0.4121263    
     +,   0.3734921    ,   0.3361375    ,   0.3003752    
     +,   0.2666723    ,   0.2354831    ,   0.2071427    
     +,   0.1818223    ,   0.1595206    ,   0.1400980    
     +,   0.1233118    ,   0.1088629    ,   9.6429475E-02
     +,   8.5699342E-02,   7.6386221E-02,   6.8243727E-02
     +,   6.1067116E-02,   5.4694697E-02,   4.9001437E-02
     +,   4.3893617E-02,   3.9302126E-02,   3.5174552E-02
     +,   3.1470548E-02,   2.8156094E-02,   2.5201190E-02
     +,   2.2577055E-02,   2.0255780E-02,   1.8209424E-02
     +,   1.6410811E-02,   1.4833366E-02,   1.3452059E-02
     +,   1.2243346E-02,   1.1185789E-02
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_hzonly_htt120_mass = Yx/17.6930077333333
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_hzonly_htt60_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  6.8979599E-02,   7.9453990E-02
     +,   9.1153845E-02,   0.1041490    ,   0.1184955    
     +,   0.1342310    ,   0.1513720    ,   0.1699141    
     +,   0.1898380    ,   0.2111264    ,   0.2337884    
     +,   0.2578959    ,   0.2836255    ,   0.3112949    
     +,   0.3413792    ,   0.3744932    ,   0.4113256    
     +,   0.4525367    ,   0.4986395    ,   0.5499284    
     +,   0.6065022    ,   0.6684122    ,   0.7358972    
     +,   0.8096125    ,   0.8907152    ,   0.9807813    
     +,    1.081475    ,    1.194071    ,    1.318853    
     +,    1.454616    ,    1.598629    ,    1.747454    
     +,    1.898376    ,    2.050526    ,    2.204467    
     +,    2.359966    ,    2.513356    ,    2.656525    
     +,    2.778136    ,    2.866019    ,    2.909173    
     +,    2.899696    ,    2.835600    ,    2.723817    
     +,    2.580273    ,    2.424987    ,    2.274448    
     +,    2.136106    ,    2.008302    ,    1.884690    
     +,    1.759568    ,    1.631036    ,    1.501150    
     +,    1.374114    ,    1.254213    ,    1.144428    
     +,    1.046141    ,   0.9594001    ,   0.8834267    
     +,   0.8170444    ,   0.7589784    ,   0.7080339    
     +,   0.6631649    ,   0.6234513    ,   0.5880430    
     +,   0.5561212    ,   0.5268740    ,   0.4995484    
     +,   0.4735055    ,   0.4482953    ,   0.4236796    
     +,   0.3996328    ,   0.3762916    ,   0.3538907    
     +,   0.3326887    ,   0.3129097    ,   0.2947052    
     +,   0.2781372    ,   0.2631780    ,   0.2497284    
     +,   0.2376407    ,   0.2267373    ,   0.2168353    
     +,   0.2077570    ,   0.1993437    ,   0.1914591    
     +,   0.1839929    ,   0.1768594    ,   0.1699981    
     +,   0.1633689    ,   0.1569502    ,   0.1507365    
     +,   0.1447341    ,   0.1389570    ,   0.1334248    
     +,   0.1281596    ,   0.1231822    ,   0.1185119    
     +,   0.1141626    ,   0.1101442    ,   0.1064599    
     +,   0.1031081    ,   0.1000814    ,   9.7368002E-02
     +,   9.4952144E-02,   9.2815116E-02,   9.0936229E-02
     +,   8.9293636E-02,   8.7864824E-02,   8.6627506E-02
     +,   8.5560143E-02,   8.4642239E-02,   8.3854690E-02
     +,   8.3179906E-02,   8.2602143E-02,   8.2107268E-02
     +,   8.1682838E-02,   8.1318140E-02,   8.1003763E-02
     +,   8.0731757E-02,   8.0495290E-02,   8.0288514E-02
     +,   8.0106266E-02,   7.9943962E-02,   7.9797544E-02
     +,   7.9662837E-02,   7.9536073E-02,   7.9413295E-02
     +,   7.9290368E-02,   7.9162925E-02,   7.9026505E-02
     +,   7.8876242E-02,   7.8707099E-02,   7.8513965E-02
     +,   7.8291461E-02,   7.8034364E-02,   7.7737428E-02
     +,   7.7395588E-02,   7.7004306E-02,   7.6559216E-02
     +,   7.6056547E-02,   7.5493366E-02,   7.4867226E-02
     +,   7.4176602E-02,   7.3420830E-02,   7.2600089E-02
     +,   7.1715541E-02,   7.0769146E-02,   6.9763973E-02
     +,   6.8703681E-02,   6.7592859E-02,   6.6436812E-02
     +,   6.5241478E-02,   6.4013205E-02,   6.2758878E-02
     +,   6.1485648E-02,   6.0200963E-02,   5.8912206E-02
     +,   5.7626724E-02,   5.6351826E-02,   5.5094603E-02
     +,   5.3861640E-02,   5.2659269E-02,   5.1493321E-02
     +,   5.0369024E-02,   4.9291000E-02,   4.8263356E-02
     +,   4.7289498E-02,   4.6372131E-02,   4.5513313E-02
     +,   4.4714570E-02,   4.3976679E-02,   4.3299891E-02
     +,   4.2683885E-02,   4.2127840E-02,   4.1630451E-02
     +,   4.1190032E-02,   4.0804476E-02,   4.0471476E-02
     +,   4.0188383E-02,   3.9952341E-02,   3.9760403E-02
     +,   3.9609499E-02,   3.9496459E-02,   3.9418127E-02
     +,   3.9371330E-02,   3.9352961E-02,   3.9359961E-02
     +,   3.9389361E-02,   3.9438251E-02,   3.9503884E-02
     +,   3.9583560E-02,   3.9674725E-02,   3.9774887E-02
     +,   3.9881695E-02,   3.9992850E-02,   4.0106166E-02
     +,   4.0219449E-02,   4.0330637E-02,   4.0437639E-02
     +,   4.0538456E-02,   4.0631019E-02,   4.0713329E-02
     +,   4.0783376E-02,   4.0839128E-02,   4.0878549E-02
     +,   4.0899612E-02,   4.0900260E-02,   4.0878478E-02
     +,   4.0832248E-02,   4.0759597E-02,   4.0658623E-02
     +,   4.0527422E-02,   4.0364258E-02,   4.0167496E-02
     +,   3.9935544E-02,   3.9667118E-02,   3.9361015E-02
     +,   3.9016236E-02,   3.8632091E-02,   3.8208023E-02
     +,   3.7743807E-02,   3.7239451E-02,   3.6695324E-02
     +,   3.6111984E-02,   3.5490334E-02,   3.4831565E-02
     +,   3.4137167E-02,   3.3408869E-02,   3.2648660E-02
     +,   3.1858813E-02,   3.1041842E-02,   3.0200377E-02
     +,   2.9337246E-02,   2.8455490E-02,   2.7558204E-02
     +,   2.6648512E-02,   2.5729699E-02,   2.4805026E-02
     +,   2.3877714E-02,   2.2950903E-02,   2.2027740E-02
     +,   2.1111261E-02,   2.0204296E-02,   1.9309560E-02
     +,   1.8429613E-02,   1.7566847E-02,   1.6723383E-02
     +,   1.5901139E-02,   1.5101884E-02,   1.4327068E-02
     +,   1.3577939E-02,   1.2855542E-02,   1.2160722E-02
     +,   1.1494037E-02,   1.0855853E-02,   1.0246380E-02
     +,   9.6656289E-03,   9.1134170E-03,   8.5893972E-03
     +,   8.0931103E-03,   7.6239812E-03,   7.1812817E-03
     +,   6.7641921E-03,   6.3718599E-03,   6.0033230E-03
     +,   5.6575667E-03,   5.3335717E-03,   5.0302842E-03
     +,   4.7466191E-03,   4.4814926E-03,   4.2338446E-03
     +,   4.0026288E-03,   3.7868025E-03,   3.5853584E-03
     +,   3.3973402E-03,   3.2218036E-03,   3.0578694E-03
     +,   2.9046827E-03,   2.7614520E-03,   2.6274126E-03
     +,   2.5018663E-03,   2.3841416E-03,   2.2736327E-03
     +,   2.1697592E-03,   2.0720004E-03,   1.9798663E-03
     +,   1.8929079E-03,   1.8107197E-03,   1.7329224E-03
     +,   1.6591806E-03,   1.5891790E-03,   1.5226416E-03
     +,   1.4593072E-03,   1.3989513E-03,   1.3413597E-03
     +,   1.2863488E-03,   1.2337457E-03,   1.1834006E-03
     +,   1.1351719E-03,   1.0889391E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_hzonly_htt60_mass = Yx/22.3126233191489
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_hzonly_htt65_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.0969093E-02,   2.3022525E-02
     +,   2.5237091E-02,   2.7622553E-02,   3.0189794E-02
     +,   3.2951225E-02,   3.5921257E-02,   3.9116766E-02
     +,   4.2557478E-02,   4.6266574E-02,   5.0270543E-02
     +,   5.4599285E-02,   5.9285469E-02,   6.4363517E-02
     +,   6.9868058E-02,   7.5831689E-02,   8.2282558E-02
     +,   8.9241914E-02,   9.6721955E-02,   0.1047251    
     +,   0.1132446    ,   0.1222679    ,   0.1317829    
     +,   0.1417875    ,   0.1522977    ,   0.1633626    
     +,   0.1750703    ,   0.1875542    ,   0.2009901    
     +,   0.2155879    ,   0.2315749    ,   0.2491802    
     +,   0.2686232    ,   0.2901154    ,   0.3138835    
     +,   0.3402039    ,   0.3694420    ,   0.4020689    
     +,   0.4386284    ,   0.4796337    ,   0.5254231    
     +,   0.5759994    ,   0.6309655    ,   0.6896010    
     +,   0.7511283    ,   0.8150798    ,   0.8816661    
     +,   0.9519904    ,    1.028059    ,    1.112576    
     +,    1.208491    ,    1.318234    ,    1.442606    
     +,    1.579606    ,    1.723773    ,    1.866729    
     +,    1.998915    ,    2.111971    ,    2.200644    
     +,    2.263572    ,    2.302711    ,    2.321639    
     +,    2.323019    ,    2.306263    ,    2.266802    
     +,    2.198255    ,    2.096834    ,    1.965568    
     +,    1.815303    ,    1.661776    ,    1.520332    
     +,    1.401281    ,    1.307773    ,    1.236517    
     +,    1.180172    ,    1.130237    ,    1.079431    
     +,    1.023159    ,   0.9599183    ,   0.8908379    
     +,   0.8187031    ,   0.7468421    ,   0.6782696    
     +,   0.6151659    ,   0.5587589    ,   0.5094220    
     +,   0.4669253    ,   0.4306624    ,   0.3998635    
     +,   0.3737117    ,   0.3514330    ,   0.3323310    
     +,   0.3158052    ,   0.3013523    ,   0.2885607    
     +,   0.2771008    ,   0.2667060    ,   0.2571612    
     +,   0.2482865    ,   0.2399294    ,   0.2319588    
     +,   0.2242641    ,   0.2167532    ,   0.2093578    
     +,   0.2020316    ,   0.1947521    ,   0.1875189    
     +,   0.1803507    ,   0.1732794    ,   0.1663467    
     +,   0.1595987    ,   0.1530802    ,   0.1468332    
     +,   0.1408921    ,   0.1352845    ,   0.1300287    
     +,   0.1251360    ,   0.1206094    ,   0.1164467    
     +,   0.1126404    ,   0.1091796    ,   0.1060510    
     +,   0.1032396    ,   0.1007299    ,   9.8506011E-02
     +,   9.6552655E-02,   9.4854519E-02,   9.3397059E-02
     +,   9.2165716E-02,   9.1145910E-02,   9.0322874E-02
     +,   8.9681044E-02,   8.9203879E-02,   8.8873759E-02
     +,   8.8671446E-02,   8.8576451E-02,   8.8566698E-02
     +,   8.8619076E-02,   8.8709429E-02,   8.8813044E-02
     +,   8.8905305E-02,   8.8961832E-02,   8.8959478E-02
     +,   8.8876568E-02,   8.8693410E-02,   8.8393070E-02
     +,   8.7961406E-02,   8.7387659E-02,   8.6664476E-02
     +,   8.5788071E-02,   8.4758237E-02,   8.3578214E-02
     +,   8.2254574E-02,   8.0796905E-02,   7.9217210E-02
     +,   7.7529974E-02,   7.5751454E-02,   7.3899187E-02
     +,   7.1991533E-02,   7.0047520E-02,   6.8086073E-02
     +,   6.6125803E-02,   6.4184770E-02,   6.2280033E-02
     +,   6.0427472E-02,   5.8641702E-02,   5.6935932E-02
     +,   5.5321984E-02,   5.3810019E-02,   5.2408699E-02
     +,   5.1125508E-02,   4.9966481E-02,   4.8936363E-02
     +,   4.8038859E-02,   4.7276534E-02,   4.6651155E-02
     +,   4.6163540E-02,   4.5813777E-02,   4.5601230E-02
     +,   4.5524586E-02,   4.5581844E-02,   4.5770377E-02
     +,   4.6086885E-02,   4.6527304E-02,   4.7086902E-02
     +,   4.7760099E-02,   4.8540533E-02,   4.9420904E-02
     +,   5.0393108E-02,   5.1447947E-02,   5.2575447E-02
     +,   5.3764652E-02,   5.5003643E-02,   5.6279704E-02
     +,   5.7579342E-02,   5.8888510E-02,   6.0192470E-02
     +,   6.1476190E-02,   6.2724456E-02,   6.3922137E-02
     +,   6.5054141E-02,   6.6105790E-02,   6.7063227E-02
     +,   6.7913301E-02,   6.8643950E-02,   6.9244348E-02
     +,   6.9705211E-02,   7.0018686E-02,   7.0178770E-02
     +,   7.0181146E-02,   7.0023462E-02,   6.9705203E-02
     +,   6.9227770E-02,   6.8594351E-02,   6.7809828E-02
     +,   6.6880822E-02,   6.5815367E-02,   6.4622752E-02
     +,   6.3313395E-02,   6.1898708E-02,   6.0390651E-02
     +,   5.8801666E-02,   5.7144485E-02,   5.5431940E-02
     +,   5.3676575E-02,   5.1890537E-02,   5.0085604E-02
     +,   4.8272893E-02,   4.6462648E-02,   4.4664219E-02
     +,   4.2886160E-02,   4.1136034E-02,   3.9420314E-02
     +,   3.7744485E-02,   3.6113244E-02,   3.4530159E-02
     +,   3.2997981E-02,   3.1518716E-02,   3.0093696E-02
     +,   2.8723454E-02,   2.7407976E-02,   2.6146859E-02
     +,   2.4939284E-02,   2.3784043E-02,   2.2679636E-02
     +,   2.1624457E-02,   2.0616818E-02,   1.9654807E-02
     +,   1.8736521E-02,   1.7860128E-02,   1.7023740E-02
     +,   1.6225522E-02,   1.5463754E-02,   1.4736794E-02
     +,   1.4043013E-02,   1.3380897E-02,   1.2749044E-02
     +,   1.2146135E-02,   1.1570884E-02,   1.1022083E-02
     +,   1.0498624E-02,   9.9994550E-03,   9.5235379E-03
     +,   9.0698889E-03,   8.6376006E-03,   8.2257669E-03
     +,   7.8335125E-03,   7.4600098E-03,   7.1044597E-03
     +,   6.7660646E-03,   6.4440453E-03,   6.1376709E-03
     +,   5.8462252E-03,   5.5690035E-03,   5.3053121E-03
     +,   5.0545116E-03,   4.8159519E-03,   4.5890315E-03
     +,   4.3731541E-03,   4.1677649E-03,   3.9723120E-03
     +,   3.7862940E-03,   3.6092035E-03,   3.4405901E-03
     +,   3.2800010E-03,   3.1270278E-03,   2.9812704E-03
     +,   2.8423527E-03,   2.7099364E-03,   2.5836802E-03
     +,   2.4632858E-03,   2.3484575E-03,   2.2389279E-03
     +,   2.1344372E-03,   2.0347543E-03,   1.9396461E-03
     +,   1.8489101E-03,   1.7623428E-03,   1.6797640E-03
     +,   1.6009924E-03,   1.5258685E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_hzonly_htt65_mass = Yx/19.8823087826087
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_hzonly_htt70_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  6.1864457E-03,   6.4929514E-03
     +,   6.8127639E-03,   7.1467594E-03,   7.4959351E-03
     +,   7.8614261E-03,   8.2445107E-03,   8.6466465E-03
     +,   9.0694707E-03,   9.5148571E-03,   9.9848984E-03
     +,   1.0481969E-02,   1.1008739E-02,   1.1568238E-02
     +,   1.2163864E-02,   1.2799455E-02,   1.3479313E-02
     +,   1.4208270E-02,   1.4991723E-02,   1.5835663E-02
     +,   1.6746733E-02,   1.7732212E-02,   1.8800037E-02
     +,   1.9958844E-02,   2.1217747E-02,   2.2586528E-02
     +,   2.4075354E-02,   2.5694758E-02,   2.7455533E-02
     +,   2.9368628E-02,   3.1445082E-02,   3.3696014E-02
     +,   3.6132660E-02,   3.8766470E-02,   4.1609384E-02
     +,   4.4674028E-02,   4.7974158E-02,   5.1524810E-02
     +,   5.5343125E-02,   5.9448011E-02,   6.3861467E-02
     +,   6.8608604E-02,   7.3719203E-02,   7.9229504E-02
     +,   8.5185856E-02,   9.1649443E-02,   9.8703459E-02
     +,   0.1064615    ,   0.1150769    ,   0.1247505    
     +,   0.1357346    ,   0.1483293    ,   0.1628693    
     +,   0.1797014    ,   0.1991493    ,   0.2214870    
     +,   0.2469104    ,   0.2755364    ,   0.3074227    
     +,   0.3426084    ,   0.3811606    ,   0.4232043    
     +,   0.4689079    ,   0.5184412    ,   0.5719087    
     +,   0.6293179    ,   0.6906486    ,   0.7559913    
     +,   0.8257583    ,   0.9007829    ,   0.9822080    
     +,    1.071018    ,    1.167336    ,    1.269640    
     +,    1.374339    ,    1.475990    ,    1.568230    
     +,    1.645255    ,    1.703257    ,    1.741209    
     +,    1.760701    ,    1.764913    ,    1.757278    
     +,    1.740471    ,    1.716018    ,    1.684358    
     +,    1.645030    ,    1.596846    ,    1.538213    
     +,    1.467832    ,    1.385630    ,    1.293500    
     +,    1.195377    ,    1.096520    ,    1.002290    
     +,   0.9169238    ,   0.8427036    ,   0.7798625    
     +,   0.7270654    ,   0.6822336    ,   0.6432891    
     +,   0.6086256    ,   0.5771887    ,   0.5483391    
     +,   0.5216204    ,   0.4966156    ,   0.4729094    
     +,   0.4501358    ,   0.4280441    ,   0.4065374    
     +,   0.3856586    ,   0.3655278    ,   0.3462840    
     +,   0.3280263    ,   0.3107964    ,   0.2945772    
     +,   0.2793178    ,   0.2649554    ,   0.2514389    
     +,   0.2387361    ,   0.2268374    ,   0.2157495    
     +,   0.2054856    ,   0.1960555    ,   0.1874591    
     +,   0.1796831    ,   0.1726981    ,   0.1664622    
     +,   0.1609222    ,   0.1560199    ,   0.1516938    
     +,   0.1478847    ,   0.1445363    ,   0.1415988    
     +,   0.1390279    ,   0.1367850    ,   0.1348364    
     +,   0.1331519    ,   0.1317032    ,   0.1304627    
     +,   0.1294030    ,   0.1284960    ,   0.1277131    
     +,   0.1270257    ,   0.1264053    ,   0.1258248    
     +,   0.1252592    ,   0.1246858    ,   0.1240855    
     +,   0.1234422    ,   0.1227435    ,   0.1219802    
     +,   0.1211461    ,   0.1202371    ,   0.1192511    
     +,   0.1181872    ,   0.1170453    ,   0.1158256    
     +,   0.1145281    ,   0.1131532    ,   0.1117008    
     +,   0.1101709    ,   0.1085640    ,   0.1068809    
     +,   0.1051234    ,   0.1032940    ,   0.1013969    
     +,   9.9437870E-02,   9.7424090E-02,   9.5364377E-02
     +,   9.3269356E-02,   9.1150969E-02,   8.9022316E-02
     +,   8.6897157E-02,   8.4790245E-02,   8.2716204E-02
     +,   8.0689445E-02,   7.8724056E-02,   7.6833293E-02
     +,   7.5029172E-02,   7.3322304E-02,   7.1722075E-02
     +,   7.0236079E-02,   6.8870351E-02,   6.7629129E-02
     +,   6.6515192E-02,   6.5529816E-02,   6.4672664E-02
     +,   6.3942261E-02,   6.3335970E-02,   6.2850021E-02
     +,   6.2479936E-02,   6.2220417E-02,   6.2065549E-02
     +,   6.2008914E-02,   6.2043723E-02,   6.2162764E-02
     +,   6.2358618E-02,   6.2623486E-02,   6.2949546E-02
     +,   6.3328534E-02,   6.3752122E-02,   6.4211756E-02
     +,   6.4698659E-02,   6.5203771E-02,   6.5717965E-02
     +,   6.6231854E-02,   6.6735871E-02,   6.7220263E-02
     +,   6.7675374E-02,   6.8091288E-02,   6.8458356E-02
     +,   6.8766922E-02,   6.9007747E-02,   6.9171898E-02
     +,   6.9250934E-02,   6.9237113E-02,   6.9123454E-02
     +,   6.8903863E-02,   6.8573341E-02,   6.8127930E-02
     +,   6.7564964E-02,   6.6883050E-02,   6.6082157E-02
     +,   6.5163597E-02,   6.4129964E-02,   6.2985249E-02
     +,   6.1734717E-02,   6.0384735E-02,   5.8942623E-02
     +,   5.7416786E-02,   5.5816334E-02,   5.4150950E-02
     +,   5.2430674E-02,   5.0665993E-02,   4.8867323E-02
     +,   4.7045030E-02,   4.5209333E-02,   4.3370139E-02
     +,   4.1536652E-02,   3.9717585E-02,   3.7921067E-02
     +,   3.6154445E-02,   3.4424189E-02,   3.2735959E-02
     +,   3.1094680E-02,   2.9504487E-02,   2.7968599E-02
     +,   2.6489483E-02,   2.5069049E-02,   2.3708424E-02
     +,   2.2408085E-02,   2.1168130E-02,   1.9988144E-02
     +,   1.8867239E-02,   1.7804174E-02,   1.6797515E-02
     +,   1.5845587E-02,   1.4946477E-02,   1.4098137E-02
     +,   1.3298494E-02,   1.2545419E-02,   1.1836698E-02
     +,   1.1170140E-02,   1.0543627E-02,   9.9550262E-03
     +,   9.4022620E-03,   8.8833515E-03,   8.3963955E-03
     +,   7.9395222E-03,   7.5109471E-03,   7.1090003E-03
     +,   6.7320801E-03,   6.3786432E-03,   6.0472260E-03
     +,   5.7364735E-03,   5.4450585E-03,   5.1717637E-03
     +,   4.9154023E-03,   4.6748864E-03,   4.4491570E-03
     +,   4.2372439E-03,   4.0382049E-03,   3.8511776E-03
     +,   3.6753260E-03,   3.5098868E-03,   3.3541280E-03
     +,   3.2073599E-03,   3.0689551E-03,   2.9383057E-03
     +,   2.8148612E-03,   2.6980932E-03,   2.5875245E-03
     +,   2.4826978E-03,   2.3832014E-03,   2.2886428E-03
     +,   2.1986717E-03,   2.1129521E-03,   2.0311866E-03
     +,   1.9530935E-03,   1.8784207E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_hzonly_htt70_mass = Yx/16.6190770666667
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_hzonly_htt75_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  7.7696191E-03,   8.0613736E-03
     +,   8.3606271E-03,   8.6677857E-03,   8.9833187E-03
     +,   9.3077458E-03,   9.6416567E-03,   9.9856881E-03
     +,   1.0340534E-02,   1.0706952E-02,   1.1085733E-02
     +,   1.1477700E-02,   1.1883725E-02,   1.2304688E-02
     +,   1.2741478E-02,   1.3194995E-02,   1.3666121E-02
     +,   1.4155711E-02,   1.4664594E-02,   1.5193552E-02
     +,   1.5743336E-02,   1.6314631E-02,   1.6908078E-02
     +,   1.7524321E-02,   1.8163923E-02,   1.8827522E-02
     +,   1.9515762E-02,   2.0229377E-02,   2.0969277E-02
     +,   2.1736564E-02,   2.2532670E-02,   2.3359396E-02
     +,   2.4219060E-02,   2.5114568E-02,   2.6049543E-02
     +,   2.7028410E-02,   2.8056540E-02,   2.9140227E-02
     +,   3.0286919E-02,   3.1505011E-02,   3.2804053E-02
     +,   3.4194574E-02,   3.5687964E-02,   3.7296399E-02
     +,   3.9032586E-02,   4.0909491E-02,   4.2940103E-02
     +,   4.5137119E-02,   4.7512565E-02,   5.0077606E-02
     +,   5.2842274E-02,   5.5815358E-02,   5.9004277E-02
     +,   6.2415794E-02,   6.6055797E-02,   6.9931105E-02
     +,   7.4050091E-02,   7.8424722E-02,   8.3072841E-02
     +,   8.8020474E-02,   9.3304731E-02,   9.8976031E-02
     +,   0.1050996    ,   0.1117567    ,   0.1190436    
     +,   0.1270667    ,   0.1359390    ,   0.1457687    
     +,   0.1566508    ,   0.1686512    ,   0.1817963    
     +,   0.1960574    ,   0.2113459    ,   0.2275088    
     +,   0.2443419    ,   0.2616130    ,   0.2791007    
     +,   0.2966486    ,   0.3142259    ,   0.3319781    
     +,   0.3502548    ,   0.3696111    ,   0.3907631    
     +,   0.4145341    ,   0.4417899    ,   0.4734204    
     +,   0.5103421    ,   0.5535271    ,   0.6039617    
     +,   0.6625001    ,   0.7295433    ,   0.8046285    
     +,   0.8860802    ,   0.9709197    ,    1.055160    
     +,    1.134498    ,    1.205241    ,    1.265102    
     +,    1.313653    ,    1.352126    ,    1.382669    
     +,    1.407205    ,    1.426379    ,    1.439003    
     +,    1.442279    ,    1.432748    ,    1.407644    
     +,    1.366100    ,    1.309739    ,    1.242458    
     +,    1.169523    ,    1.096282    ,    1.027027    
     +,   0.9642351    ,   0.9084768    ,   0.8588054    
     +,   0.8134759    ,   0.7706424    ,   0.7288733    
     +,   0.6873538    ,   0.6458725    ,   0.6046925    
     +,   0.5643920    ,   0.5257408    ,   0.4895924    
     +,   0.4567805    ,   0.4279882    ,   0.4036428    
     +,   0.3838280    ,   0.3682683    ,   0.3563692    
     +,   0.3473171    ,   0.3402002    ,   0.3341318    
     +,   0.3283437    ,   0.3222464    ,   0.3154513    
     +,   0.3077598    ,   0.2991331    ,   0.2896534    
     +,   0.2794838    ,   0.2688332    ,   0.2579283    
     +,   0.2469940    ,   0.2362411    ,   0.2258564    
     +,   0.2159998    ,   0.2068030    ,   0.1983685    
     +,   0.1907704    ,   0.1840568    ,   0.1782509    
     +,   0.1733531    ,   0.1693431    ,   0.1661813    
     +,   0.1638114    ,   0.1621620    ,   0.1611476    
     +,   0.1606719    ,   0.1606296    ,   0.1609084    
     +,   0.1613930    ,   0.1619675    ,   0.1625196    
     +,   0.1629436    ,   0.1631444    ,   0.1630396    
     +,   0.1625631    ,   0.1616661    ,   0.1603177    
     +,   0.1585060    ,   0.1562366    ,   0.1535310    
     +,   0.1504251    ,   0.1469668    ,   0.1432129    
     +,   0.1392263    ,   0.1350740    ,   0.1308246    
     +,   0.1265451    ,   0.1222999    ,   0.1181493    
     +,   0.1141481    ,   0.1103446    ,   0.1067800    
     +,   0.1034890    ,   0.1004981    ,   9.7826980E-02
     +,   9.5487863E-02,   9.3486249E-02,   9.1821000E-02
     +,   9.0484709E-02,   8.9464612E-02,   8.8742718E-02
     +,   8.8296399E-02,   8.8099457E-02,   8.8122271E-02
     +,   8.8332981E-02,   8.8698104E-02,   8.9183144E-02
     +,   8.9753613E-02,   9.0375423E-02,   9.1016039E-02
     +,   9.1644637E-02,   9.2233077E-02,   9.2755958E-02
     +,   9.3191460E-02,   9.3521059E-02,   9.3730129E-02
     +,   9.3807608E-02,   9.3746148E-02,   9.3541749E-02
     +,   9.3193501E-02,   9.2703335E-02,   9.2075273E-02
     +,   9.1315515E-02,   9.0431280E-02,   8.9430973E-02
     +,   8.8323265E-02,   8.7116987E-02,   8.5820705E-02
     +,   8.4442325E-02,   8.2989164E-02,   8.1467703E-02
     +,   7.9883404E-02,   7.8240842E-02,   7.6543927E-02
     +,   7.4795932E-02,   7.2999485E-02,   7.1156934E-02
     +,   6.9270566E-02,   6.7342818E-02,   6.5376155E-02
     +,   6.3373491E-02,   6.1338373E-02,   5.9274692E-02
     +,   5.7186946E-02,   5.5080358E-02,   5.2960716E-02
     +,   5.0834104E-02,   4.8707042E-02,   4.6586402E-02
     +,   4.4479270E-02,   4.2392522E-02,   4.0333010E-02
     +,   3.8307432E-02,   3.6322158E-02,   3.4382924E-02
     +,   3.2495018E-02,   3.0663271E-02,   2.8891686E-02
     +,   2.7183626E-02,   2.5541877E-02,   2.3968553E-02
     +,   2.2465024E-02,   2.1032043E-02,   1.9669859E-02
     +,   1.8378222E-02,   1.7156286E-02,   1.6002791E-02
     +,   1.4916208E-02,   1.3894661E-02,   1.2935961E-02
     +,   1.2037710E-02,   1.1197450E-02,   1.0412505E-02
     +,   9.6801389E-03,   8.9976238E-03,   8.3622262E-03
     +,   7.7711781E-03,   7.2217844E-03,   6.7114327E-03
     +,   6.2376014E-03,   5.7978341E-03,   5.3897807E-03
     +,   5.0112489E-03,   4.6601146E-03,   4.3344232E-03
     +,   4.0322980E-03,   3.7520311E-03,   3.4919877E-03
     +,   3.2506932E-03,   3.0267448E-03,   2.8188813E-03
     +,   2.6259080E-03,   2.4467555E-03,   2.2804195E-03
     +,   2.1259771E-03,   1.9825967E-03,   1.8494930E-03
     +,   1.7259632E-03,   1.6113402E-03,   1.5050252E-03
     +,   1.4064502E-03,   1.3151034E-03,   1.2304946E-03
     +,   1.1521804E-03,   1.0797371E-03,   1.0127781E-03
     +,   9.5093180E-04,   8.9385849E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_hzonly_htt75_mass = Yx/15.2394422727273
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_hzonly_htt80_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.3231985E-03,   3.4280904E-03
     +,   3.5354791E-03,   3.6453626E-03,   3.7577420E-03
     +,   3.8726158E-03,   3.9899782E-03,   4.1098269E-03
     +,   4.2321589E-03,   4.3569766E-03,   4.4842809E-03
     +,   4.6140817E-03,   4.7463910E-03,   4.8812358E-03
     +,   5.0186468E-03,   5.1586716E-03,   5.3013731E-03
     +,   5.4468289E-03,   5.5951406E-03,   5.7464316E-03
     +,   5.9008468E-03,   6.0585658E-03,   6.2197945E-03
     +,   6.3847820E-03,   6.5537929E-03,   6.7271506E-03
     +,   6.9052060E-03,   7.0883492E-03,   7.2770179E-03
     +,   7.4716778E-03,   7.6728449E-03,   7.8810602E-03
     +,   8.0969101E-03,   8.3210031E-03,   8.5539743E-03
     +,   8.7964870E-03,   9.0492116E-03,   9.3128337E-03
     +,   9.5880572E-03,   9.8755565E-03,   1.0176040E-02
     +,   1.0490198E-02,   1.0818718E-02,   1.1162302E-02
     +,   1.1521657E-02,   1.1897535E-02,   1.2290735E-02
     +,   1.2702138E-02,   1.3132758E-02,   1.3583773E-02
     +,   1.4056599E-02,   1.4552937E-02,   1.5074874E-02
     +,   1.5624977E-02,   1.6206300E-02,   1.6822606E-02
     +,   1.7478334E-02,   1.8178763E-02,   1.8930024E-02
     +,   1.9739194E-02,   2.0614248E-02,   2.1564117E-02
     +,   2.2598507E-02,   2.3727939E-02,   2.4963493E-02
     +,   2.6316473E-02,   2.7798397E-02,   2.9420333E-02
     +,   3.1192960E-02,   3.3125702E-02,   3.5227012E-02
     +,   3.7503451E-02,   3.9960235E-02,   4.2600650E-02
     +,   4.5426954E-02,   4.8440784E-02,   5.1644024E-02
     +,   5.5040345E-02,   5.8637328E-02,   6.2448550E-02
     +,   6.6495389E-02,   7.0810542E-02,   7.5438835E-02
     +,   8.0439806E-02,   8.5886955E-02,   9.1868117E-02
     +,   9.8481685E-02,   0.1058352    ,   0.1140397    
     +,   0.1232089    ,   0.1334568    ,   0.1449002    
     +,   0.1576619    ,   0.1718793    ,   0.1877057    
     +,   0.2053051    ,   0.2248391    ,   0.2464291    
     +,   0.2701131    ,   0.2957882    ,   0.3231714    
     +,   0.3517797    ,   0.3809744    ,   0.4100513    
     +,   0.4384024    ,   0.4657018    ,   0.4920798    
     +,   0.5182335    ,   0.5454039    ,   0.5751693    
     +,   0.6090570    ,   0.6480405    ,   0.6920643    
     +,   0.7398154    ,   0.7889109    ,   0.8365781    
     +,   0.8805938    ,   0.9201246    ,   0.9559719    
     +,   0.9900102    ,    1.023961    ,    1.058124    
     +,    1.090710    ,    1.118243    ,    1.136814    
     +,    1.143561    ,    1.137621    ,    1.120153    
     +,    1.093601    ,    1.060712    ,    1.023825    
     +,   0.9846601    ,   0.9444548    ,   0.9041882    
     +,   0.8646740    ,   0.8264973    ,   0.7898955    
     +,   0.7546984    ,   0.7204061    ,   0.6864043    
     +,   0.6522257    ,   0.6177675    ,   0.5833894    
     +,   0.5498815    ,   0.5182998    ,   0.4897287    
     +,   0.4650459    ,   0.4447384    ,   0.4288032    
     +,   0.4167630    ,   0.4077661    ,   0.4007463    
     +,   0.3946043    ,   0.3883711    ,   0.3813281    
     +,   0.3730691    ,   0.3634991    ,   0.3527852    
     +,   0.3412727    ,   0.3293954    ,   0.3175864    
     +,   0.3062117    ,   0.2955309    ,   0.2856811    
     +,   0.2766805    ,   0.2684513    ,   0.2608465    
     +,   0.2536820    ,   0.2467657    ,   0.2399223    
     +,   0.2330133    ,   0.2259475    ,   0.2186860    
     +,   0.2112406    ,   0.2036679    ,   0.1960595    
     +,   0.1885287    ,   0.1812008    ,   0.1742004    
     +,   0.1676414    ,   0.1616203    ,   0.1562123    
     +,   0.1514678    ,   0.1474133    ,   0.1440523    
     +,   0.1413703    ,   0.1393358    ,   0.1379056    
     +,   0.1370281    ,   0.1366450    ,   0.1366949    
     +,   0.1371131    ,   0.1378336    ,   0.1387885    
     +,   0.1399089    ,   0.1411244    ,   0.1423641    
     +,   0.1435574    ,   0.1446344    ,   0.1455282    
     +,   0.1461766    ,   0.1465238    ,   0.1465227    
     +,   0.1461365    ,   0.1453404    ,   0.1441225    
     +,   0.1424840    ,   0.1404389    ,   0.1380133    
     +,   0.1352440    ,   0.1321757    ,   0.1288596    
     +,   0.1253504    ,   0.1217039    ,   0.1179744    
     +,   0.1142132    ,   0.1104663    ,   0.1067735    
     +,   0.1031675    ,   9.9673934E-02,   9.6311063E-02
     +,   9.3090415E-02,   9.0017758E-02,   8.7093905E-02
     +,   8.4315300E-02,   8.1675433E-02,   7.9165645E-02
     +,   7.6776065E-02,   7.4495830E-02,   7.2314017E-02
     +,   7.0219964E-02,   6.8203509E-02,   6.6254959E-02
     +,   6.4365253E-02,   6.2526368E-02,   6.0730636E-02
     +,   5.8971219E-02,   5.7241965E-02,   5.5537455E-02
     +,   5.3852804E-02,   5.2183796E-02,   5.0527073E-02
     +,   4.8880007E-02,   4.7240552E-02,   4.5607500E-02
     +,   4.3980431E-02,   4.2359687E-02,   4.0746223E-02
     +,   3.9141528E-02,   3.7547860E-02,   3.5967812E-02
     +,   3.4404304E-02,   3.2860633E-02,   3.1340279E-02
     +,   2.9846698E-02,   2.8383315E-02,   2.6953559E-02
     +,   2.5560657E-02,   2.4207518E-02,   2.2896744E-02
     +,   2.1630695E-02,   2.0411365E-02,   1.9240268E-02
     +,   1.8118560E-02,   1.7047090E-02,   1.6026245E-02
     +,   1.5056057E-02,   1.4136264E-02,   1.3266301E-02
     +,   1.2445264E-02,   1.1671995E-02,   1.0945172E-02
     +,   1.0263287E-02,   9.6246265E-03,   9.0273665E-03
     +,   8.4696375E-03,   7.9494491E-03,   7.4648308E-03
     +,   7.0137451E-03,   6.5942118E-03,   6.2042275E-03
     +,   5.8418876E-03,   5.5052922E-03,   5.1926551E-03
     +,   4.9022241E-03,   4.6323701E-03,   4.3815263E-03
     +,   4.1482127E-03,   3.9310711E-03,   3.7287988E-03
     +,   3.5402169E-03,   3.3642082E-03,   3.1997594E-03
     +,   3.0459233E-03,   2.9018482E-03,   2.7667326E-03
     +,   2.6398676E-03,   2.5205873E-03,   2.4083003E-03
     +,   2.3024553E-03,   2.2025651E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_hzonly_htt80_mass = Yx/13.5427652093023
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_hzonly_htt85_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.9110226E-03,   4.0361192E-03
     +,   4.1661421E-03,   4.3013417E-03,   4.4419668E-03
     +,   4.5882761E-03,   4.7405325E-03,   4.8989956E-03
     +,   5.0639296E-03,   5.2356040E-03,   5.4142792E-03
     +,   5.6002131E-03,   5.7936613E-03,   5.9948689E-03
     +,   6.2040747E-03,   6.4215069E-03,   6.6473754E-03
     +,   6.8818787E-03,   7.1251965E-03,   7.3774843E-03
     +,   7.6388819E-03,   7.9094954E-03,   8.1894035E-03
     +,   8.4786713E-03,   8.7773046E-03,   9.0853041E-03
     +,   9.4026169E-03,   9.7291563E-03,   1.0064806E-02
     +,   1.0409409E-02,   1.0762770E-02,   1.1124658E-02
     +,   1.1494806E-02,   1.1872932E-02,   1.2258695E-02
     +,   1.2651750E-02,   1.3051730E-02,   1.3458245E-02
     +,   1.3870918E-02,   1.4289332E-02,   1.4713117E-02
     +,   1.5141910E-02,   1.5575360E-02,   1.6013164E-02
     +,   1.6455064E-02,   1.6900869E-02,   1.7350439E-02
     +,   1.7803729E-02,   1.8260775E-02,   1.8721716E-02
     +,   1.9186804E-02,   1.9656390E-02,   2.0130940E-02
     +,   2.0611074E-02,   2.1097478E-02,   2.1591017E-02
     +,   2.2092624E-02,   2.2603365E-02,   2.3124397E-02
     +,   2.3656964E-02,   2.4202378E-02,   2.4762020E-02
     +,   2.5337271E-02,   2.5929591E-02,   2.6540425E-02
     +,   2.7171146E-02,   2.7823176E-02,   2.8497813E-02
     +,   2.9196352E-02,   2.9919943E-02,   3.0669708E-02
     +,   3.1446610E-02,   3.2251578E-02,   3.3085339E-02
     +,   3.3948574E-02,   3.4841821E-02,   3.5765458E-02
     +,   3.6719706E-02,   3.7704602E-02,   3.8720120E-02
     +,   3.9765805E-02,   4.0841103E-02,   4.1945014E-02
     +,   4.3076336E-02,   4.4233304E-02,   4.5413908E-02
     +,   4.6615534E-02,   4.7835294E-02,   4.9069826E-02
     +,   5.0315745E-02,   5.1569659E-02,   5.2828662E-02
     +,   5.4090802E-02,   5.5356003E-02,   5.6627087E-02
     +,   5.7910785E-02,   5.9219610E-02,   6.0573254E-02
     +,   6.2000923E-02,   6.3542597E-02,   6.5251186E-02
     +,   6.7192987E-02,   6.9448307E-02,   7.2109640E-02
     +,   7.5279437E-02,   7.9065472E-02,   8.3574511E-02
     +,   8.8905126E-02,   9.5140643E-02,   0.1023415    
     +,   0.1105396    ,   0.1197365    ,   0.1299021    
     +,   0.1409810    ,   0.1528959    ,   0.1655586    
     +,   0.1788772    ,   0.1927715    ,   0.2071839    
     +,   0.2221042    ,   0.2375933    ,   0.2538133    
     +,   0.2710520    ,   0.2897291    ,   0.3103648    
     +,   0.3334942    ,   0.3595409    ,   0.3886483    
     +,   0.4205452    ,   0.4544719    ,   0.4892649    
     +,   0.5235810    ,   0.5562841    ,   0.5868540    
     +,   0.6157297    ,   0.6444147    ,   0.6752636    
     +,   0.7109462    ,   0.7536904    ,   0.8045063    
     +,   0.8626200    ,   0.9253479    ,   0.9884667    
     +,    1.047023    ,    1.096313    ,    1.132747    
     +,    1.154286    ,    1.160408    ,    1.151768    
     +,    1.129804    ,    1.096535    ,    1.054513    
     +,    1.006740    ,   0.9563881    ,   0.9062711    
     +,   0.8583302    ,   0.8133518    ,   0.7710876    
     +,   0.7307351    ,   0.6915179    ,   0.6531396    
     +,   0.6159601    ,   0.5808679    ,   0.5489479    
     +,   0.5210770    ,   0.4976230    ,   0.4783179    
     +,   0.4623366    ,   0.4485197    ,   0.4356626    
     +,   0.4227634    ,   0.4091762    ,   0.3946512    
     +,   0.3792873    ,   0.3634296    ,   0.3475500    
     +,   0.3321439    ,   0.3176545    ,   0.3044285    
     +,   0.2926917    ,   0.2825524    ,   0.2740115    
     +,   0.2669801    ,   0.2613000    ,   0.2567647    
     +,   0.2531417    ,   0.2501907    ,   0.2476806    
     +,   0.2454042    ,   0.2431863    ,   0.2408903    
     +,   0.2384185    ,   0.2357107    ,   0.2327393    
     +,   0.2295028    ,   0.2260210    ,   0.2223290    
     +,   0.2184725    ,   0.2145051    ,   0.2104856    
     +,   0.2064780    ,   0.2025484    ,   0.1987637    
     +,   0.1951889    ,   0.1918831    ,   0.1888949    
     +,   0.1862569    ,   0.1839820    ,   0.1820585    
     +,   0.1804492    ,   0.1790907    ,   0.1778971    
     +,   0.1767645    ,   0.1755780    ,   0.1742203    
     +,   0.1725801    ,   0.1705600    ,   0.1680840    
     +,   0.1651015    ,   0.1615914    ,   0.1575606    
     +,   0.1530436    ,   0.1480981    ,   0.1428002    
     +,   0.1372380    ,   0.1315059    ,   0.1256990    
     +,   0.1199081    ,   0.1142144    ,   0.1086878    
     +,   0.1033844    ,   9.8346159E-02,   9.3600146E-02
     +,   8.9159988E-02,   8.5027844E-02,   8.1195258E-02
     +,   7.7645838E-02,   7.4357495E-02,   7.1304217E-02
     +,   6.8457745E-02,   6.5789297E-02,   6.3271150E-02
     +,   6.0877338E-02,   5.8584318E-02,   5.6371469E-02
     +,   5.4221559E-02,   5.2120663E-02,   5.0057780E-02
     +,   4.8024923E-02,   4.6016902E-02,   4.4030715E-02
     +,   4.2065315E-02,   4.0121406E-02,   3.8200997E-02
     +,   3.6306944E-02,   3.4442797E-02,   3.2612689E-02
     +,   3.0820968E-02,   2.9071877E-02,   2.7369551E-02
     +,   2.5717985E-02,   2.4120817E-02,   2.2581143E-02
     +,   2.1101566E-02,   1.9684361E-02,   1.8331099E-02
     +,   1.7042829E-02,   1.5820187E-02,   1.4663309E-02
     +,   1.3571797E-02,   1.2544852E-02,   1.1581366E-02
     +,   1.0679907E-02,   9.8386975E-03,   9.0557430E-03
     +,   8.3289249E-03,   7.6558865E-03,   7.0342505E-03
     +,   6.4614802E-03,   5.9350682E-03,   5.4524201E-03
     +,   5.0110118E-03,   4.6082861E-03,   4.2417748E-03
     +,   3.9090239E-03,   3.6076901E-03,   3.3354713E-03
     +,   3.0901572E-03,   2.8696524E-03,   2.6719260E-03
     +,   2.4950735E-03,   2.3372669E-03,   2.1968030E-03
     +,   2.0720637E-03,   1.9615486E-03,   1.8638439E-03
     +,   1.7776504E-03,   1.7017536E-03,   1.6350414E-03
     +,   1.5764869E-03,   1.5251549E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_hzonly_htt85_mass = Yx/12.8122426046512
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_hzonly_htt90_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  6.6816723E-03,   6.9781980E-03
     +,   7.2804834E-03,   7.5879218E-03,   7.8998553E-03
     +,   8.2155615E-03,   8.5342769E-03,   8.8551817E-03
     +,   9.1774138E-03,   9.5000686E-03,   9.8222159E-03
     +,   1.0142876E-02,   1.0461062E-02,   1.0775759E-02
     +,   1.1085941E-02,   1.1390593E-02,   1.1688681E-02
     +,   1.1979204E-02,   1.2261171E-02,   1.2533627E-02
     +,   1.2795645E-02,   1.3046363E-02,   1.3284954E-02
     +,   1.3510680E-02,   1.3722844E-02,   1.3920855E-02
     +,   1.4104202E-02,   1.4272464E-02,   1.4425335E-02
     +,   1.4562594E-02,   1.4684150E-02,   1.4790031E-02
     +,   1.4880368E-02,   1.4955434E-02,   1.5015624E-02
     +,   1.5061436E-02,   1.5093531E-02,   1.5112672E-02
     +,   1.5119753E-02,   1.5115790E-02,   1.5101904E-02
     +,   1.5079353E-02,   1.5049481E-02,   1.5013749E-02
     +,   1.4973706E-02,   1.4930983E-02,   1.4887305E-02
     +,   1.4844459E-02,   1.4804289E-02,   1.4768698E-02
     +,   1.4739622E-02,   1.4719033E-02,   1.4708917E-02
     +,   1.4711264E-02,   1.4728061E-02,   1.4761278E-02
     +,   1.4812837E-02,   1.4884637E-02,   1.4978494E-02
     +,   1.5096168E-02,   1.5239313E-02,   1.5409497E-02
     +,   1.5608151E-02,   1.5836574E-02,   1.6095944E-02
     +,   1.6387222E-02,   1.6711242E-02,   1.7068595E-02
     +,   1.7459707E-02,   1.7884739E-02,   1.8343667E-02
     +,   1.8836170E-02,   1.9361727E-02,   1.9919498E-02
     +,   2.0508438E-02,   2.1127248E-02,   2.1774307E-02
     +,   2.2447782E-02,   2.3145597E-02,   2.3865514E-02
     +,   2.4604982E-02,   2.5361395E-02,   2.6131911E-02
     +,   2.6913684E-02,   2.7703704E-02,   2.8499052E-02
     +,   2.9296741E-02,   3.0093975E-02,   3.0887997E-02
     +,   3.1676345E-02,   3.2456789E-02,   3.3227384E-02
     +,   3.3986576E-02,   3.4733243E-02,   3.5466801E-02
     +,   3.6187090E-02,   3.6894672E-02,   3.7590604E-02
     +,   3.8276743E-02,   3.8955525E-02,   3.9630264E-02
     +,   4.0304933E-02,   4.0984366E-02,   4.1674126E-02
     +,   4.2380661E-02,   4.3111157E-02,   4.3873552E-02
     +,   4.4676527E-02,   4.5529444E-02,   4.6442285E-02
     +,   4.7425505E-02,   4.8490118E-02,   4.9647473E-02
     +,   5.0909366E-02,   5.2287888E-02,   5.3795714E-02
     +,   5.5445839E-02,   5.7252154E-02,   5.9229147E-02
     +,   6.1392587E-02,   6.3759461E-02,   6.6347986E-02
     +,   6.9178045E-02,   7.2271191E-02,   7.5651065E-02
     +,   7.9343110E-02,   8.3376050E-02,   8.7781876E-02
     +,   9.2598304E-02,   9.7869553E-02,   0.1036497    
     +,   0.1100037    ,   0.1170105    ,   0.1247624    
     +,   0.1333657    ,   0.1429376    ,   0.1536018    
     +,   0.1654833    ,   0.1787050    ,   0.1933825    
     +,   0.2096210    ,   0.2275168    ,   0.2471592    
     +,   0.2686278    ,   0.2919881    ,   0.3172869    
     +,   0.3445414    ,   0.3737334    ,   0.4048142    
     +,   0.4377297    ,   0.4724466    ,   0.5089714    
     +,   0.5473401    ,   0.5875449    ,   0.6294037    
     +,   0.6724056    ,   0.7156204    ,   0.7577506    
     +,   0.7973527    ,   0.8331643    ,   0.8644037    
     +,   0.8908514    ,   0.9126444    ,   0.9298806    
     +,   0.9422537    ,   0.9489601    ,   0.9489856    
     +,   0.9416854    ,   0.9273632    ,   0.9075705    
     +,   0.8849304    ,   0.8625268    ,   0.8430882    
     +,   0.8283178    ,   0.8186192    ,   0.8133359    
     +,   0.8113294    ,   0.8115626    ,   0.8133854    
     +,   0.8164030    ,   0.8200830    ,   0.8234112    
     +,   0.8248658    ,   0.8227674    ,   0.8158082    
     +,   0.8034942    ,   0.7862602    ,   0.7652324    
     +,   0.7417917    ,   0.7171504    ,   0.6921219    
     +,   0.6671239    ,   0.6423343    ,   0.6178765    
     +,   0.5939155    ,   0.5706605    ,   0.5482935    
     +,   0.5268932    ,   0.5064058    ,   0.4866796    
     +,   0.4675368    ,   0.4488389    ,   0.4305284    
     +,   0.4126277    ,   0.3952196    ,   0.3784064    
     +,   0.3622791    ,   0.3468992    ,   0.3322876    
     +,   0.3184226    ,   0.3052458    ,   0.2926701    
     +,   0.2805897    ,   0.2688934    ,   0.2574823    
     +,   0.2462841    ,   0.2352635    ,   0.2244244    
     +,   0.2138088    ,   0.2034867    ,   0.1935419    
     +,   0.1840591    ,   0.1751126    ,   0.1667582    
     +,   0.1590284    ,   0.1519338    ,   0.1454659    
     +,   0.1396007    ,   0.1343035    ,   0.1295325    
     +,   0.1252427    ,   0.1213870    ,   0.1179169    
     +,   0.1147827    ,   0.1119342    ,   0.1093198    
     +,   0.1068869    ,   0.1045830    ,   0.1023565    
     +,   0.1001582    ,   9.7942501E-02,   9.5669612E-02
     +,   9.3306422E-02,   9.0827301E-02,   8.8215023E-02
     +,   8.5460760E-02,   8.2564130E-02,   7.9531677E-02
     +,   7.6376498E-02,   7.3117353E-02,   6.9776624E-02
     +,   6.6379383E-02,   6.2952429E-02,   5.9522841E-02
     +,   5.6116816E-02,   5.2759096E-02,   4.9472526E-02
     +,   4.6277341E-02,   4.3190747E-02,   4.0226940E-02
     +,   3.7397306E-02,   3.4710310E-02,   3.2171465E-02
     +,   2.9783780E-02,   2.7548257E-02,   2.5463643E-02
     +,   2.3527071E-02,   2.1734368E-02,   2.0080242E-02
     +,   1.8558426E-02,   1.7162014E-02,   1.5883783E-02
     +,   1.4716238E-02,   1.3651698E-02,   1.2682539E-02
     +,   1.1801363E-02,   1.1000861E-02,   1.0274138E-02
     +,   9.6145310E-03,   9.0158256E-03,   8.4721316E-03
     +,   7.9780370E-03,   7.5284606E-03,   7.1188007E-03
     +,   6.7447773E-03,   6.4025549E-03,   6.0886159E-03
     +,   5.7997936E-03,   5.5332668E-03,   5.2864840E-03
     +,   5.0571971E-03,   4.8433840E-03,   4.6432875E-03
     +,   4.4553312E-03,   4.2781564E-03,   4.1105566E-03
     +,   3.9514969E-03,   3.8000618E-03,   3.6554767E-03
     +,   3.5170584E-03,   3.3842344E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_hzonly_htt90_mass = Yx/13.3320375348837
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_hzonly_htt95_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  5.8863685E-03,   5.9545869E-03
     +,   6.0175690E-03,   6.0752667E-03,   6.1276620E-03
     +,   6.1747711E-03,   6.2166317E-03,   6.2533217E-03
     +,   6.2849405E-03,   6.3116285E-03,   6.3335444E-03
     +,   6.3508847E-03,   6.3638715E-03,   6.3727512E-03
     +,   6.3777999E-03,   6.3793189E-03,   6.3776295E-03
     +,   6.3730762E-03,   6.3660229E-03,   6.3568507E-03
     +,   6.3459561E-03,   6.3337497E-03,   6.3206498E-03
     +,   6.3070850E-03,   6.2934887E-03,   6.2802983E-03
     +,   6.2679541E-03,   6.2568858E-03,   6.2475288E-03
     +,   6.2403041E-03,   6.2356279E-03,   6.2339013E-03
     +,   6.2355124E-03,   6.2408326E-03,   6.2502148E-03
     +,   6.2639914E-03,   6.2824707E-03,   6.3059414E-03
     +,   6.3346624E-03,   6.3688694E-03,   6.4087720E-03
     +,   6.4545455E-03,   6.5063434E-03,   6.5642870E-03
     +,   6.6284724E-03,   6.6989637E-03,   6.7758029E-03
     +,   6.8589998E-03,   6.9485460E-03,   7.0444047E-03
     +,   7.1465238E-03,   7.2548301E-03,   7.3692328E-03
     +,   7.4896431E-03,   7.6159416E-03,   7.7480292E-03
     +,   7.8857923E-03,   8.0291322E-03,   8.1779603E-03
     +,   8.3322031E-03,   8.4918188E-03,   8.6567905E-03
     +,   8.8271396E-03,   9.0029407E-03,   9.1843214E-03
     +,   9.3714586E-03,   9.5646158E-03,   9.7641144E-03
     +,   9.9703725E-03,   1.0183888E-02,   1.0405256E-02
     +,   1.0635168E-02,   1.0874419E-02,   1.1123891E-02
     +,   1.1384580E-02,   1.1657584E-02,   1.1944066E-02
     +,   1.2245281E-02,   1.2562547E-02,   1.2897251E-02
     +,   1.3250774E-02,   1.3624542E-02,   1.4019921E-02
     +,   1.4438281E-02,   1.4880844E-02,   1.5348781E-02
     +,   1.5843028E-02,   1.6364420E-02,   1.6913448E-02
     +,   1.7490409E-02,   1.8095274E-02,   1.8727630E-02
     +,   1.9386683E-02,   2.0071251E-02,   2.0779753E-02
     +,   2.1510102E-02,   2.2259830E-02,   2.3025952E-02
     +,   2.3805171E-02,   2.4593689E-02,   2.5387473E-02
     +,   2.6182096E-02,   2.6973011E-02,   2.7755423E-02
     +,   2.8524583E-02,   2.9275781E-02,   3.0004453E-02
     +,   3.0706327E-02,   3.1377602E-02,   3.2015014E-02
     +,   3.2615982E-02,   3.3178754E-02,   3.3702523E-02
     +,   3.4187555E-02,   3.4635268E-02,   3.5048328E-02
     +,   3.5430707E-02,   3.5787802E-02,   3.6126342E-02
     +,   3.6454495E-02,   3.6781840E-02,   3.7119288E-02
     +,   3.7479132E-02,   3.7874930E-02,   3.8321555E-02
     +,   3.8835015E-02,   3.9432593E-02,   4.0132716E-02
     +,   4.0954910E-02,   4.1919854E-02,   4.3049306E-02
     +,   4.4365901E-02,   4.5893241E-02,   4.7655337E-02
     +,   4.9676567E-02,   5.1981144E-02,   5.4592203E-02
     +,   5.7531219E-02,   6.0817283E-02,   6.4465813E-02
     +,   6.8487160E-02,   7.2885439E-02,   7.7657707E-02
     +,   8.2792357E-02,   8.8267557E-02,   9.4051212E-02
     +,   0.1000999    ,   0.1063580    ,   0.1127582    
     +,   0.1192230    ,   0.1256649    ,   0.1319895    
     +,   0.1380987    ,   0.1438967    ,   0.1492957    
     +,   0.1542244    ,   0.1586371    ,   0.1625250    
     +,   0.1659257    ,   0.1689323    ,   0.1717019    
     +,   0.1744615    ,   0.1775116    ,   0.1812300    
     +,   0.1860725    ,   0.1925733    ,   0.2013361    
     +,   0.2130179    ,   0.2282923    ,   0.2477871    
     +,   0.2719852    ,   0.3010963    ,   0.3349078    
     +,   0.3726460    ,   0.4129086    ,   0.4537564    
     +,   0.4930157    ,   0.5288066    ,   0.5602252    
     +,   0.5879632    ,   0.6145682    ,   0.6441018    
     +,   0.6811391    ,   0.7293510    ,   0.7901735    
     +,   0.8621236    ,   0.9410613    ,    1.021281    
     +,    1.097028    ,    1.163947    ,    1.220031    
     +,    1.265676    ,    1.302696    ,    1.332711    
     +,    1.355905    ,    1.371149    ,    1.377581    
     +,    1.376262    ,    1.370128    ,    1.361896    
     +,    1.351513    ,    1.335410    ,    1.308401    
     +,    1.266800    ,    1.210498    ,    1.142816    
     +,    1.068863    ,   0.9938579    ,   0.9222691    
     +,   0.8575606    ,   0.8019949    ,   0.7563424    
     +,   0.7197905    ,   0.6903330    ,   0.6655184    
     +,   0.6431717    ,   0.6217841    ,   0.6005221    
     +,   0.5789925    ,   0.5569883    ,   0.5343310    
     +,   0.5108735    ,   0.4865908    ,   0.4616721    
     +,   0.4365373    ,   0.4117645    ,   0.3879549    
     +,   0.3655932    ,   0.3449527    ,   0.3260706    
     +,   0.3087818    ,   0.2927829    ,   0.2777095    
     +,   0.2632038    ,   0.2489685    ,   0.2347954    
     +,   0.2205809    ,   0.2063240    ,   0.1921092    
     +,   0.1780806    ,   0.1644124    ,   0.1512811    
     +,   0.1388413    ,   0.1272095    ,   0.1164580    
     +,   0.1066168    ,   9.7677961E-02,   8.9604840E-02
     +,   8.2341485E-02,   7.5821824E-02,   6.9974951E-02
     +,   6.4730279E-02,   6.0020801E-02,   5.5783991E-02
     +,   5.1962178E-02,   4.8502874E-02,   4.5358986E-02
     +,   4.2488173E-02,   3.9852761E-02,   3.7419647E-02
     +,   3.5160448E-02,   3.3051010E-02,   3.1071104E-02
     +,   2.9204272E-02,   2.7437499E-02,   2.5760503E-02
     +,   2.4165398E-02,   2.2646405E-02,   2.1199243E-02
     +,   1.9820699E-02,   1.8508395E-02,   1.7260596E-02
     +,   1.6075904E-02,   1.4953014E-02,   1.3890672E-02
     +,   1.2887703E-02,   1.1942695E-02,   1.1054245E-02
     +,   1.0220679E-02,   9.4403066E-03,   8.7111965E-03
     +,   8.0313915E-03,   7.3987548E-03,   6.8111597E-03
     +,   6.2663457E-03,   5.7621025E-03,   5.2961591E-03
     +,   4.8662652E-03,   4.4702445E-03,   4.1059162E-03
     +,   3.7712092E-03,   3.4640797E-03,   3.1826079E-03
     +,   2.9249196E-03,   2.6892670E-03,   2.4739648E-03
     +,   2.2774495E-03,   2.0982251E-03,   1.9349108E-03
     +,   1.7861958E-03,   1.6508757E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_hzonly_htt95_mass = Yx/14.0587287272727
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_hzonly_ttz100_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  7.3398454E-03,   7.4987225E-03
     +,   7.6548853E-03,   7.8081624E-03,   7.9584094E-03
     +,   8.1055081E-03,   8.2493732E-03,   8.3899479E-03
     +,   8.5272109E-03,   8.6611798E-03,   8.7919077E-03
     +,   8.9194840E-03,   9.0440428E-03,   9.1657583E-03
     +,   9.2848493E-03,   9.4015794E-03,   9.5162494E-03
     +,   9.6292105E-03,   9.7408481E-03,   9.8515972E-03
     +,   9.9619292E-03,   1.0072357E-02,   1.0183421E-02
     +,   1.0295710E-02,   1.0409820E-02,   1.0526394E-02
     +,   1.0646086E-02,   1.0769568E-02,   1.0897520E-02
     +,   1.1030632E-02,   1.1169586E-02,   1.1315062E-02
     +,   1.1467727E-02,   1.1628214E-02,   1.1797138E-02
     +,   1.1975072E-02,   1.2162537E-02,   1.2360005E-02
     +,   1.2567898E-02,   1.2786545E-02,   1.3016220E-02
     +,   1.3257110E-02,   1.3509310E-02,   1.3772816E-02
     +,   1.4047536E-02,   1.4333268E-02,   1.4629711E-02
     +,   1.4936456E-02,   1.5252981E-02,   1.5578672E-02
     +,   1.5912807E-02,   1.6254548E-02,   1.6602989E-02
     +,   1.6957141E-02,   1.7315889E-02,   1.7678108E-02
     +,   1.8042579E-02,   1.8408056E-02,   1.8773237E-02
     +,   1.9136811E-02,   1.9497477E-02,   1.9853918E-02
     +,   2.0204855E-02,   2.0549053E-02,   2.0885346E-02
     +,   2.1212604E-02,   2.1529822E-02,   2.1836050E-02
     +,   2.2130504E-02,   2.2412498E-02,   2.2681477E-02
     +,   2.2937037E-02,   2.3178926E-02,   2.3407027E-02
     +,   2.3621412E-02,   2.3822298E-02,   2.4010058E-02
     +,   2.4185196E-02,   2.4348406E-02,   2.4500508E-02
     +,   2.4642425E-02,   2.4775231E-02,   2.4900103E-02
     +,   2.5018286E-02,   2.5131121E-02,   2.5240006E-02
     +,   2.5346376E-02,   2.5451697E-02,   2.5557410E-02
     +,   2.5664970E-02,   2.5775826E-02,   2.5891311E-02
     +,   2.6012719E-02,   2.6141291E-02,   2.6278134E-02
     +,   2.6424253E-02,   2.6580542E-02,   2.6747771E-02
     +,   2.6926531E-02,   2.7117305E-02,   2.7320430E-02
     +,   2.7536070E-02,   2.7764251E-02,   2.8004836E-02
     +,   2.8257567E-02,   2.8522054E-02,   2.8797744E-02
     +,   2.9083978E-02,   2.9380027E-02,   2.9685011E-02
     +,   2.9997991E-02,   3.0317983E-02,   3.0643914E-02
     +,   3.0974692E-02,   3.1309236E-02,   3.1646427E-02
     +,   3.1985197E-02,   3.2324523E-02,   3.2663446E-02
     +,   3.3001062E-02,   3.3336654E-02,   3.3669595E-02
     +,   3.3999428E-02,   3.4325901E-02,   3.4649014E-02
     +,   3.4968976E-02,   3.5286330E-02,   3.5601914E-02
     +,   3.5916928E-02,   3.6232919E-02,   3.6551893E-02
     +,   3.6876243E-02,   3.7208822E-02,   3.7552901E-02
     +,   3.7912209E-02,   3.8290959E-02,   3.8693693E-02
     +,   3.9125293E-02,   3.9591067E-02,   4.0096477E-02
     +,   4.0647119E-02,   4.1248631E-02,   4.1906599E-02
     +,   4.2626444E-02,   4.3413118E-02,   4.4271216E-02
     +,   4.5204695E-02,   4.6216693E-02,   4.7309492E-02
     +,   4.8484430E-02,   4.9741924E-02,   5.1081087E-02
     +,   5.2500084E-02,   5.3996056E-02,   5.5565350E-02
     +,   5.7203412E-02,   5.8905166E-02,   6.0665496E-02
     +,   6.2479440E-02,   6.4342454E-02,   6.6251278E-02
     +,   6.8204343E-02,   7.0202149E-02,   7.2247960E-02
     +,   7.4348852E-02,   7.6515868E-02,   7.8764781E-02
     +,   8.1116863E-02,   8.3599642E-02,   8.6247943E-02
     +,   8.9104354E-02,   9.2220560E-02,   9.5659062E-02
     +,   9.9494278E-02,   0.1038141    ,   0.1087232    
     +,   0.1143447    ,   0.1208236    ,   0.1283307    
     +,   0.1370673    ,   0.1472694    ,   0.1592107    
     +,   0.1732062    ,   0.1896126    ,   0.2088237    
     +,   0.2312555    ,   0.2573213    ,   0.2873893    
     +,   0.3217221    ,   0.3604099    ,   0.4033416    
     +,   0.4502312    ,   0.5007297    ,   0.5546188    
     +,   0.6120436    ,   0.6737899    ,   0.7416335    
     +,   0.8187332    ,   0.9096835    ,    1.019587    
     +,    1.151855    ,    1.305712    ,    1.475440    
     +,    1.652634    ,    1.830162    ,    2.005346    
     +,    2.181742    ,    2.369824    ,    2.583351    
     +,    2.828747    ,    3.095314    ,    3.356958    
     +,    3.582942    ,    3.748235    ,    3.840394    
     +,    3.862117    ,    3.827763    ,    3.756514    
     +,    3.665582    ,    3.564883    ,    3.453099    
     +,    3.319678    ,    3.156408    ,    2.968433    
     +,    2.770112    ,    2.571192    ,    2.371181    
     +,    2.165714    ,    1.954881    ,    1.745470    
     +,    1.547392    ,    1.368387    ,    1.210742    
     +,    1.071760    ,   0.9469341    ,   0.8331057    
     +,   0.7296882    ,   0.6377895    ,   0.5585333    
     +,   0.4919124    ,   0.4366262    ,   0.3905612    
     +,   0.3514000    ,   0.3170684    ,   0.2859713    
     +,   0.2570580    ,   0.2297765    ,   0.2039589    
     +,   0.1796788    ,   0.1571157    ,   0.1364434    
     +,   0.1177725    ,   0.1011309    ,   8.6469635E-02
     +,   7.3681302E-02,   6.2622942E-02,   5.3133667E-02
     +,   4.5046106E-02,   3.8193807E-02,   3.2416888E-02
     +,   2.7565608E-02,   2.3502171E-02,   2.0102205E-02
     +,   1.7255988E-02,   1.4868865E-02,   1.2860227E-02
     +,   1.1162831E-02,   9.7214608E-03,   8.4912106E-03
     +,   7.4357362E-03,   6.5258443E-03,   5.7381112E-03
     +,   5.0536147E-03,   4.4569243E-03,   3.9353827E-03
     +,   3.4785373E-03,   3.0775729E-03,   2.7250927E-03
     +,   2.4147436E-03,   2.1411262E-03,   1.8995565E-03
     +,   1.6860248E-03,   1.4970356E-03,   1.3295870E-03
     +,   1.1810551E-03,   1.0491831E-03,   9.3199674E-04
     +,   8.2777964E-04,   7.3504640E-04,   6.5248652E-04
     +,   5.7896483E-04,   5.1347440E-04,   4.5513824E-04
     +,   4.0317420E-04,   3.5689719E-04,   3.1569312E-04
     +,   2.7902148E-04,   2.4639579E-04,   2.1738638E-04
     +,   1.9160521E-04,   1.6870901E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_hzonly_ttz100_mass = Yx/25.7571988085106
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_hzonly_ttz105_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.9484069E-03,   5.0420039E-03
     +,   5.1361793E-03,   5.2311569E-03,   5.3271898E-03
     +,   5.4245582E-03,   5.5235657E-03,   5.6245397E-03
     +,   5.7278322E-03,   5.8338186E-03,   5.9428927E-03
     +,   6.0554659E-03,   6.1719650E-03,   6.2928284E-03
     +,   6.4185024E-03,   6.5494375E-03,   6.6860844E-03
     +,   6.8288930E-03,   6.9783013E-03,   7.1347272E-03
     +,   7.2985818E-03,   7.4702296E-03,   7.6500252E-03
     +,   7.8382809E-03,   8.0352509E-03,   8.2411580E-03
     +,   8.4561640E-03,   8.6803744E-03,   8.9138225E-03
     +,   9.1564758E-03,   9.4082402E-03,   9.6689267E-03
     +,   9.9382838E-03,   1.0215981E-02,   1.0501598E-02
     +,   1.0794641E-02,   1.1094539E-02,   1.1400646E-02
     +,   1.1712252E-02,   1.2028564E-02,   1.2348746E-02
     +,   1.2671907E-02,   1.2997102E-02,   1.3323369E-02
     +,   1.3649700E-02,   1.3975092E-02,   1.4298540E-02
     +,   1.4619038E-02,   1.4935613E-02,   1.5247322E-02
     +,   1.5553276E-02,   1.5852658E-02,   1.6144691E-02
     +,   1.6428744E-02,   1.6704204E-02,   1.6970631E-02
     +,   1.7227657E-02,   1.7475061E-02,   1.7712746E-02
     +,   1.7940730E-02,   1.8159168E-02,   1.8368373E-02
     +,   1.8568745E-02,   1.8760875E-02,   1.8945424E-02
     +,   1.9123174E-02,   1.9295054E-02,   1.9462042E-02
     +,   1.9625241E-02,   1.9785788E-02,   1.9944916E-02
     +,   2.0103863E-02,   2.0263903E-02,   2.0426324E-02
     +,   2.0592399E-02,   2.0763384E-02,   2.0940466E-02
     +,   2.1124776E-02,   2.1317385E-02,   2.1519272E-02
     +,   2.1731270E-02,   2.1954149E-02,   2.2188488E-02
     +,   2.2434777E-02,   2.2693330E-02,   2.2964297E-02
     +,   2.3247678E-02,   2.3543319E-02,   2.3850882E-02
     +,   2.4169866E-02,   2.4499642E-02,   2.4839379E-02
     +,   2.5188083E-02,   2.5544673E-02,   2.5907904E-02
     +,   2.6276365E-02,   2.6648609E-02,   2.7023012E-02
     +,   2.7397908E-02,   2.7771529E-02,   2.8142059E-02
     +,   2.8507637E-02,   2.8866384E-02,   2.9216386E-02
     +,   2.9555777E-02,   2.9882675E-02,   3.0195281E-02
     +,   3.0491814E-02,   3.0770600E-02,   3.1030083E-02
     +,   3.1268783E-02,   3.1485364E-02,   3.1678639E-02
     +,   3.1847615E-02,   3.1991415E-02,   3.2109402E-02
     +,   3.2201119E-02,   3.2266330E-02,   3.2305006E-02
     +,   3.2317352E-02,   3.2303810E-02,   3.2265019E-02
     +,   3.2201879E-02,   3.2115519E-02,   3.2007258E-02
     +,   3.1878665E-02,   3.1731516E-02,   3.1567749E-02
     +,   3.1389531E-02,   3.1199202E-02,   3.0999199E-02
     +,   3.0792180E-02,   3.0580880E-02,   3.0368177E-02
     +,   3.0157017E-02,   2.9950442E-02,   2.9751522E-02
     +,   2.9563436E-02,   2.9389322E-02,   2.9232334E-02
     +,   2.9095672E-02,   2.8982483E-02,   2.8895866E-02
     +,   2.8838867E-02,   2.8814493E-02,   2.8825644E-02
     +,   2.8875114E-02,   2.8965620E-02,   2.9099751E-02
     +,   2.9279901E-02,   2.9508432E-02,   2.9787434E-02
     +,   3.0118912E-02,   3.0504687E-02,   3.0946434E-02
     +,   3.1445656E-02,   3.2003678E-02,   3.2621771E-02
     +,   3.3301067E-02,   3.4042571E-02,   3.4847308E-02
     +,   3.5716277E-02,   3.6650501E-02,   3.7651088E-02
     +,   3.8719308E-02,   3.9856657E-02,   4.1064832E-02
     +,   4.2345822E-02,   4.3702003E-02,   4.5136176E-02
     +,   4.6651565E-02,   4.8251841E-02,   4.9941443E-02
     +,   5.1725421E-02,   5.3609673E-02,   5.5601317E-02
     +,   5.7708964E-02,   5.9942961E-02,   6.2316146E-02
     +,   6.4844459E-02,   6.7547821E-02,   7.0450567E-02
     +,   7.3582515E-02,   7.6979972E-02,   8.0686070E-02
     +,   8.4750868E-02,   8.9231908E-02,   9.4194531E-02
     +,   9.9711083E-02,   0.1058606    ,   0.1127295    
     +,   0.1204117    ,   0.1290093    ,   0.1386336    
     +,   0.1494085    ,   0.1614733    ,   0.1749841    
     +,   0.1901197    ,   0.2070870    ,   0.2261242    
     +,   0.2475000    ,   0.2715076    ,   0.2984494    
     +,   0.3286040    ,   0.3621804    ,   0.3992745    
     +,   0.4398195    ,   0.4835432    ,   0.5299443    
     +,   0.5782940    ,   0.6276787    ,   0.6771441    
     +,   0.7259676    ,   0.7740134    ,   0.8220345    
     +,   0.8718181    ,   0.9261621    ,   0.9888048    
     +,    1.064229    ,    1.157117    ,    1.271314    
     +,    1.408623    ,    1.568087    ,    1.746117    
     +,    1.937531    ,    2.138265    ,    2.350362    
     +,    2.585309    ,    2.857635    ,    3.169335    
     +,    3.503656    ,    3.840439    ,    4.170628    
     +,    4.479735    ,    4.716664    ,    4.807423    
     +,    4.729328    ,    4.555542    ,    4.389104    
     +,    4.259956    ,    4.110991    ,    3.870651    
     +,    3.517664    ,    3.087506    ,    2.639761    
     +,    2.222965    ,    1.857635    ,    1.540674    
     +,    1.261073    ,    1.012516    ,   0.7955859    
     +,   0.6131091    ,   0.4655386    ,   0.3497942    
     +,   0.2606924    ,   0.1927867    ,   0.1413946    
     +,   0.1028022    ,   7.4097030E-02,   5.2968405E-02
     +,   3.7575398E-02,   2.6468923E-02,   1.8532062E-02
     +,   1.2920168E-02,   9.0007661E-03,   6.3007469E-03
     +,   4.4675888E-03,   3.2406470E-03,   2.4299347E-03
     +,   1.8998669E-03,   1.5560437E-03,   1.3342903E-03
     +,   1.1918264E-03,   1.1005535E-03,   1.0421851E-03
     +,   1.0048581E-03,   9.8086544E-04,   9.6520380E-04
     +,   9.5462229E-04,   9.4702427E-04,   9.4106985E-04
     +,   9.3591766E-04,   9.3104952E-04,   9.2615589E-04
     +,   9.2105719E-04,   9.1565424E-04,   9.0989599E-04
     +,   9.0375898E-04,   8.9723646E-04,   8.9032977E-04
     +,   8.8304601E-04,   8.7539433E-04,   8.6738606E-04
     +,   8.5903268E-04,   8.5034757E-04,   8.4134319E-04
     +,   8.3203352E-04,   8.2243182E-04,   8.1255293E-04
     +,   8.0241013E-04,   7.9201878E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_hzonly_ttz105_mass = Yx/26.20223025
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_hzonly_ttz107_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  9.1086971E-03,   9.3319714E-03
     +,   9.5534408E-03,   9.7728614E-03,   9.9900039E-03
     +,   1.0204644E-02,   1.0416583E-02,   1.0625616E-02
     +,   1.0831561E-02,   1.1034253E-02,   1.1233537E-02
     +,   1.1429263E-02,   1.1621303E-02,   1.1809547E-02
     +,   1.1993892E-02,   1.2174248E-02,   1.2350549E-02
     +,   1.2522738E-02,   1.2690767E-02,   1.2854613E-02
     +,   1.3014263E-02,   1.3169720E-02,   1.3320995E-02
     +,   1.3468129E-02,   1.3611168E-02,   1.3750175E-02
     +,   1.3885232E-02,   1.4016436E-02,   1.4143904E-02
     +,   1.4267756E-02,   1.4388153E-02,   1.4505259E-02
     +,   1.4619259E-02,   1.4730361E-02,   1.4838789E-02
     +,   1.4944789E-02,   1.5048631E-02,   1.5150595E-02
     +,   1.5251007E-02,   1.5350184E-02,   1.5448489E-02
     +,   1.5546296E-02,   1.5644003E-02,   1.5742026E-02
     +,   1.5840814E-02,   1.5940821E-02,   1.6042529E-02
     +,   1.6146431E-02,   1.6253047E-02,   1.6362900E-02
     +,   1.6476519E-02,   1.6594457E-02,   1.6717264E-02
     +,   1.6845509E-02,   1.6979719E-02,   1.7120462E-02
     +,   1.7268268E-02,   1.7423665E-02,   1.7587146E-02
     +,   1.7759209E-02,   1.7940298E-02,   1.8130831E-02
     +,   1.8331181E-02,   1.8541690E-02,   1.8762654E-02
     +,   1.8994285E-02,   1.9236768E-02,   1.9490208E-02
     +,   1.9754654E-02,   2.0030068E-02,   2.0316368E-02
     +,   2.0613356E-02,   2.0920809E-02,   2.1238379E-02
     +,   2.1565655E-02,   2.1902185E-02,   2.2247382E-02
     +,   2.2600615E-02,   2.2961199E-02,   2.3328353E-02
     +,   2.3701256E-02,   2.4079023E-02,   2.4460703E-02
     +,   2.4845336E-02,   2.5231870E-02,   2.5619291E-02
     +,   2.6006496E-02,   2.6392419E-02,   2.6775928E-02
     +,   2.7155956E-02,   2.7531411E-02,   2.7901206E-02
     +,   2.8264277E-02,   2.8619610E-02,   2.8966226E-02
     +,   2.9303147E-02,   2.9629504E-02,   2.9944394E-02
     +,   3.0247062E-02,   3.0536732E-02,   3.0812752E-02
     +,   3.1074475E-02,   3.1321384E-02,   3.1552985E-02
     +,   3.1768851E-02,   3.1968664E-02,   3.2152127E-02
     +,   3.2319028E-02,   3.2469258E-02,   3.2602746E-02
     +,   3.2719463E-02,   3.2819506E-02,   3.2903019E-02
     +,   3.2970160E-02,   3.3021223E-02,   3.3056531E-02
     +,   3.3076469E-02,   3.3081505E-02,   3.3072095E-02
     +,   3.3048835E-02,   3.3012338E-02,   3.2963239E-02
     +,   3.2902259E-02,   3.2830164E-02,   3.2747753E-02
     +,   3.2655846E-02,   3.2555316E-02,   3.2447059E-02
     +,   3.2331999E-02,   3.2211103E-02,   3.2085307E-02
     +,   3.1955630E-02,   3.1823065E-02,   3.1688605E-02
     +,   3.1553332E-02,   3.1418238E-02,   3.1284396E-02
     +,   3.1152900E-02,   3.1024838E-02,   3.0901337E-02
     +,   3.0783582E-02,   3.0672822E-02,   3.0570352E-02
     +,   3.0477582E-02,   3.0396005E-02,   3.0327270E-02
     +,   3.0273169E-02,   3.0235710E-02,   3.0217107E-02
     +,   3.0219790E-02,   3.0246504E-02,   3.0300274E-02
     +,   3.0384451E-02,   3.0502705E-02,   3.0659115E-02
     +,   3.0858021E-02,   3.1104170E-02,   3.1402566E-02
     +,   3.1758569E-02,   3.2177635E-02,   3.2665491E-02
     +,   3.3227880E-02,   3.3870541E-02,   3.4599040E-02
     +,   3.5418760E-02,   3.6334805E-02,   3.7351761E-02
     +,   3.8473744E-02,   3.9704438E-02,   4.1046973E-02
     +,   4.2503979E-02,   4.4077706E-02,   4.5770276E-02
     +,   4.7583960E-02,   4.9520984E-02,   5.1584594E-02
     +,   5.3778935E-02,   5.6109436E-02,   5.8583368E-02
     +,   6.1210383E-02,   6.4002827E-02,   6.6975936E-02
     +,   7.0148274E-02,   7.3542409E-02,   7.7185065E-02
     +,   8.1106871E-02,   8.5343026E-02,   8.9933246E-02
     +,   9.4921716E-02,   0.1003559    ,   0.1062869    
     +,   0.1127678    ,   0.1198524    ,   0.1275929    
     +,   0.1360394    ,   0.1452374    ,   0.1552252    
     +,   0.1660338    ,   0.1776864    ,   0.1901986    
     +,   0.2035767    ,   0.2178200    ,   0.2329210    
     +,   0.2488658    ,   0.2656365    ,   0.2832209    
     +,   0.3016267    ,   0.3209025    ,   0.3411666    
     +,   0.3626372    ,   0.3856456    ,   0.4106239    
     +,   0.4380651    ,   0.4684559    ,   0.5022080    
     +,   0.5396301    ,   0.5810040    ,   0.6267636    
     +,   0.6777246    ,   0.7351866    ,   0.8006971    
     +,   0.8752661    ,   0.9582265    ,    1.046425    
     +,    1.134748    ,    1.218501    ,    1.296819    
     +,    1.374806    ,    1.462209    ,    1.568873    
     +,    1.699981    ,    1.854341    ,    2.026283    
     +,    2.210018    ,    2.405742    ,    2.625138    
     +,    2.888964    ,    3.211322    ,    3.580436    
     +,    3.957916    ,    4.303368    ,    4.600259    
     +,    4.853185    ,    5.056808    ,    5.169036    
     +,    5.120552    ,    4.859296    ,    4.391352    
     +,    3.780971    ,    3.115719    ,    2.471848    
     +,    1.900234    ,    1.426309    ,    1.053979    
     +,   0.7720578    ,   0.5627125    ,   0.4084809    
     +,   0.2953665    ,   0.2128739    ,   0.1530861    
     +,   0.1099550    ,   7.8915447E-02,   5.6615349E-02
     +,   4.0644016E-02,   2.9267687E-02,   2.1215307E-02
     +,   1.5539294E-02,   1.1531528E-02,   8.6720539E-03
     +,   6.5925582E-03,   5.0439639E-03,   3.8653386E-03
     +,   2.9557771E-03,   2.2517398E-03,   1.7109076E-03
     +,   1.3020737E-03,   9.9966140E-04,   7.8157883E-04
     +,   6.2853185E-04,   5.2411639E-04,   4.5486892E-04
     +,   4.1022102E-04,   3.8220940E-04,   3.6508418E-04
     +,   3.5484869E-04,   3.4882993E-04,   3.4530103E-04
     +,   3.4318442E-04,   3.4182984E-04,   3.4085682E-04
     +,   3.4004971E-04,   3.3928998E-04,   3.3851460E-04
     +,   3.3769096E-04,   3.3680312E-04,   3.3584333E-04
     +,   3.3480846E-04,   3.3369745E-04,   3.3251019E-04
     +,   3.3124720E-04,   3.2990924E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_hzonly_ttz107_mass = Yx/25.2687888510638
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_hzonly_ttz110_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.2846348E-02,   1.3392745E-02
     +,   1.3955032E-02,   1.4533108E-02,   1.5126785E-02
     +,   1.5735798E-02,   1.6359778E-02,   1.6998272E-02
     +,   1.7650690E-02,   1.8316360E-02,   1.8994464E-02
     +,   1.9684069E-02,   2.0384092E-02,   2.1093329E-02
     +,   2.1810438E-02,   2.2533933E-02,   2.3262197E-02
     +,   2.3993474E-02,   2.4725892E-02,   2.5457453E-02
     +,   2.6186042E-02,   2.6909471E-02,   2.7625399E-02
     +,   2.8331522E-02,   2.9025393E-02,   2.9704602E-02
     +,   3.0366667E-02,   3.1009190E-02,   3.1629730E-02
     +,   3.2225974E-02,   3.2795679E-02,   3.3336699E-02
     +,   3.3847060E-02,   3.4324922E-02,   3.4768663E-02
     +,   3.5176843E-02,   3.5548300E-02,   3.5882052E-02
     +,   3.6177471E-02,   3.6434166E-02,   3.6652043E-02
     +,   3.6831293E-02,   3.6972445E-02,   3.7076309E-02
     +,   3.7144009E-02,   3.7176941E-02,   3.7176803E-02
     +,   3.7145529E-02,   3.7085366E-02,   3.6998704E-02
     +,   3.6888208E-02,   3.6756646E-02,   3.6607016E-02
     +,   3.6442339E-02,   3.6265813E-02,   3.6080617E-02
     +,   3.5889976E-02,   3.5697047E-02,   3.5505041E-02
     +,   3.5316985E-02,   3.5135813E-02,   3.4964386E-02
     +,   3.4805331E-02,   3.4661073E-02,   3.4533922E-02
     +,   3.4425840E-02,   3.4338616E-02,   3.4273803E-02
     +,   3.4232646E-02,   3.4216188E-02,   3.4225173E-02
     +,   3.4260083E-02,   3.4321245E-02,   3.4408621E-02
     +,   3.4522090E-02,   3.4661226E-02,   3.4825467E-02
     +,   3.5014108E-02,   3.5226256E-02,   3.5460949E-02
     +,   3.5717115E-02,   3.5993606E-02,   3.6289249E-02
     +,   3.6602832E-02,   3.6933132E-02,   3.7278995E-02
     +,   3.7639197E-02,   3.8012676E-02,   3.8398329E-02
     +,   3.8795173E-02,   3.9202299E-02,   3.9618827E-02
     +,   4.0043961E-02,   4.0476985E-02,   4.0917210E-02
     +,   4.1364018E-02,   4.1816801E-02,   4.2274956E-02
     +,   4.2737931E-02,   4.3205082E-02,   4.3675791E-02
     +,   4.4149335E-02,   4.4624984E-02,   4.5101836E-02
     +,   4.5578990E-02,   4.6055347E-02,   4.6529744E-02
     +,   4.7000811E-02,   4.7467176E-02,   4.7927279E-02
     +,   4.8379436E-02,   4.8821907E-02,   4.9252842E-02
     +,   4.9670331E-02,   5.0072443E-02,   5.0457262E-02
     +,   5.0822802E-02,   5.1167347E-02,   5.1488996E-02
     +,   5.1786259E-02,   5.2057680E-02,   5.2302048E-02
     +,   5.2518453E-02,   5.2706253E-02,   5.2865136E-02
     +,   5.2995093E-02,   5.3096633E-02,   5.3170603E-02
     +,   5.3218257E-02,   5.3241313E-02,   5.3241950E-02
     +,   5.3222772E-02,   5.3186823E-02,   5.3137526E-02
     +,   5.3078808E-02,   5.3014867E-02,   5.2950349E-02
     +,   5.2890107E-02,   5.2839320E-02,   5.2803382E-02
     +,   5.2787900E-02,   5.2798565E-02,   5.2841190E-02
     +,   5.2921589E-02,   5.3045571E-02,   5.3218838E-02
     +,   5.3447124E-02,   5.3735826E-02,   5.4090213E-02
     +,   5.4515373E-02,   5.5016119E-02,   5.5597033E-02
     +,   5.6262363E-02,   5.7016164E-02,   5.7862267E-02
     +,   5.8804359E-02,   5.9845783E-02,   6.0990062E-02
     +,   6.2240575E-02,   6.3600659E-02,   6.5073945E-02
     +,   6.6664167E-02,   6.8375364E-02,   7.0211515E-02
     +,   7.2177202E-02,   7.4276961E-02,   7.6515310E-02
     +,   7.8896508E-02,   8.1424668E-02,   8.4103025E-02
     +,   8.6933769E-02,   8.9917630E-02,   9.3053691E-02
     +,   9.6339159E-02,   9.9768437E-02,   0.1033342    
     +,   0.1070267    ,   0.1108343    ,   0.1147444    
     +,   0.1187443    ,   0.1228229    ,   0.1269719    
     +,   0.1311885    ,   0.1354773    ,   0.1398534    
     +,   0.1443435    ,   0.1489883    ,   0.1538443    
     +,   0.1589839    ,   0.1644936    ,   0.1704741    
     +,   0.1770356    ,   0.1842941    ,   0.1923656    
     +,   0.2013609    ,   0.2113796    ,   0.2225047    
     +,   0.2347987    ,   0.2483054    ,   0.2630506    
     +,   0.2790493    ,   0.2963152    ,   0.3148750    
     +,   0.3347790    ,   0.3561061    ,   0.3789681    
     +,   0.4034957    ,   0.4298068    ,   0.4579700    
     +,   0.4879567    ,   0.5196047    ,   0.5526117    
     +,   0.5865821    ,   0.6211420    ,   0.6561031    
     +,   0.6916495    ,   0.7284997    ,   0.7679819    
     +,   0.8119520    ,   0.8625280    ,   0.9216831    
     +,   0.9907209    ,    1.069831    ,    1.157914    
     +,    1.252870    ,    1.352309    ,    1.454396    
     +,    1.558350    ,    1.664238    ,    1.772187    
     +,    1.881649    ,    1.991297    ,    2.099484    
     +,    2.204664    ,    2.305519    ,    2.401319    
     +,    2.493066    ,    2.584840    ,    2.683343    
     +,    2.794481    ,    2.918423    ,    3.046812    
     +,    3.164534    ,    3.254482    ,    3.301599    
     +,    3.294068    ,    3.222994    ,    3.083141    
     +,    2.875341    ,    2.608602    ,    2.299595    
     +,    1.969462    ,    1.639511    ,    1.327824    
     +,    1.047595    ,   0.8068838    ,   0.6089488    
     +,   0.4528190    ,   0.3342038    ,   0.2467762    
     +,   0.1835684    ,   0.1381201    ,   0.1051602    
     +,   8.0800094E-02,   6.2386815E-02,   4.8201755E-02
     +,   3.7158277E-02,   2.8556274E-02,   2.1911632E-02
     +,   1.6854124E-02,   1.3075241E-02,   1.0306358E-02
     +,   8.3128819E-03,   6.8951347E-03,   5.8898996E-03
     +,   5.1696892E-03,   4.6393797E-03,   4.2315149E-03
     +,   3.9005107E-03,   3.6172410E-03,   3.3641055E-03
     +,   3.1312096E-03,   2.9133901E-03,   2.7082507E-03
     +,   2.5147893E-03,   2.3326515E-03,   2.1616449E-03
     +,   2.0015496E-03,   1.8520512E-03,   1.7126993E-03
     +,   1.5829739E-03,   1.4622845E-03,   1.3500382E-03
     +,   1.2456382E-03,   1.1485311E-03,   1.0581912E-03
     +,   9.7415125E-04,   8.9597801E-04,   8.2329090E-04
     +,   7.5573567E-04,   6.9299887E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_hzonly_ttz110_mass = Yx/23.6621771489362
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_hzonly_ttz115_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.5910311E-02,   1.6549777E-02
     +,   1.7211199E-02,   1.7895279E-02,   1.8602693E-02
     +,   1.9334108E-02,   2.0090127E-02,   2.0871287E-02
     +,   2.1678098E-02,   2.2511024E-02,   2.3370370E-02
     +,   2.4256404E-02,   2.5169289E-02,   2.6109073E-02
     +,   2.7075687E-02,   2.8068939E-02,   2.9088525E-02
     +,   3.0133970E-02,   3.1204669E-02,   3.2299887E-02
     +,   3.3418730E-02,   3.4560144E-02,   3.5722904E-02
     +,   3.6905717E-02,   3.8106985E-02,   3.9325114E-02
     +,   4.0558286E-02,   4.1804541E-02,   4.3061759E-02
     +,   4.4327736E-02,   4.5600098E-02,   4.6876375E-02
     +,   4.8153941E-02,   4.9430087E-02,   5.0702039E-02
     +,   5.1966831E-02,   5.3221501E-02,   5.4462936E-02
     +,   5.5688109E-02,   5.6893703E-02,   5.8076493E-02
     +,   5.9233308E-02,   6.0360722E-02,   6.1455496E-02
     +,   6.2514268E-02,   6.3533783E-02,   6.4510770E-02
     +,   6.5442041E-02,   6.6324428E-02,   6.7154869E-02
     +,   6.7930520E-02,   6.8648480E-02,   6.9306165E-02
     +,   6.9901116E-02,   7.0431083E-02,   7.0894122E-02
     +,   7.1288481E-02,   7.1612716E-02,   7.1865760E-02
     +,   7.2046824E-02,   7.2155595E-02,   7.2192043E-02
     +,   7.2156630E-02,   7.2050273E-02,   7.1874283E-02
     +,   7.1630426E-02,   7.1321011E-02,   7.0948675E-02
     +,   7.0516735E-02,   7.0028745E-02,   6.9488786E-02
     +,   6.8901435E-02,   6.8271510E-02,   6.7604326E-02
     +,   6.6905558E-02,   6.6181056E-02,   6.5436982E-02
     +,   6.4679891E-02,   6.3916281E-02,   6.3152887E-02
     +,   6.2396627E-02,   6.1654329E-02,   6.0932927E-02
     +,   6.0239203E-02,   5.9579972E-02,   5.8961786E-02
     +,   5.8391042E-02,   5.7873979E-02,   5.7416469E-02
     +,   5.7024062E-02,   5.6701936E-02,   5.6454860E-02
     +,   5.6287140E-02,   5.6202509E-02,   5.6204218E-02
     +,   5.6294791E-02,   5.6476194E-02,   5.6749642E-02
     +,   5.7115640E-02,   5.7573862E-02,   5.8123156E-02
     +,   5.8761567E-02,   5.9486300E-02,   6.0293552E-02
     +,   6.1178643E-02,   6.2136166E-02,   6.3159674E-02
     +,   6.4241856E-02,   6.5374680E-02,   6.6549398E-02
     +,   6.7756429E-02,   6.8985768E-02,   7.0226796E-02
     +,   7.1468621E-02,   7.2699986E-02,   7.3909603E-02
     +,   7.5086080E-02,   7.6218441E-02,   7.7295773E-02
     +,   7.8307755E-02,   7.9244815E-02,   8.0097951E-02
     +,   8.0859162E-02,   8.1521451E-02,   8.2079083E-02
     +,   8.2527280E-02,   8.2862861E-02,   8.3083846E-02
     +,   8.3189622E-02,   8.3181024E-02,   8.3060168E-02
     +,   8.2830630E-02,   8.2497142E-02,   8.2065687E-02
     +,   8.1543431E-02,   8.0938421E-02,   8.0259785E-02
     +,   7.9517275E-02,   7.8721419E-02,   7.7883169E-02
     +,   7.7014022E-02,   7.6125748E-02,   7.5230204E-02
     +,   7.4339367E-02,   7.3465250E-02,   7.2619714E-02
     +,   7.1814306E-02,   7.1060389E-02,   7.0368916E-02
     +,   6.9750391E-02,   6.9214746E-02,   6.8771340E-02
     +,   6.8428919E-02,   6.8195343E-02,   6.8077780E-02
     +,   6.8082459E-02,   6.8214543E-02,   6.8478346E-02
     +,   6.8876967E-02,   6.9412380E-02,   7.0085451E-02
     +,   7.0895925E-02,   7.1842343E-02,   7.2922170E-02
     +,   7.4132122E-02,   7.5467989E-02,   7.6925047E-02
     +,   7.8498162E-02,   8.0182247E-02,   8.1972517E-02
     +,   8.3864726E-02,   8.5855767E-02,   8.7944016E-02
     +,   9.0129599E-02,   9.2414759E-02,   9.4804607E-02
     +,   9.7306840E-02,   9.9932373E-02,   0.1026951    
     +,   0.1056127    ,   0.1087059    ,   0.1119985    
     +,   0.1155173    ,   0.1192919    ,   0.1233537    
     +,   0.1277356    ,   0.1324709    ,   0.1375927    
     +,   0.1431328    ,   0.1491198    ,   0.1555794    
     +,   0.1625329    ,   0.1699971    ,   0.1779854    
     +,   0.1865099    ,   0.1955839    ,   0.2052252    
     +,   0.2154599    ,   0.2263282    ,   0.2378842    
     +,   0.2501968    ,   0.2633458    ,   0.2774170    
     +,   0.2924922    ,   0.3086370    ,   0.3258955    
     +,   0.3442864    ,   0.3638064    ,   0.3844478    
     +,   0.4062246    ,   0.4292031    ,   0.4535229    
     +,   0.4794106    ,   0.5071619    ,   0.5370899    
     +,   0.5694452    ,   0.6043283    ,   0.6416201    
     +,   0.6809561    ,   0.7217655    ,   0.7633851    
     +,   0.8052130    ,   0.8468485    ,   0.8881964    
     +,   0.9295143    ,   0.9713788    ,    1.014651    
     +,    1.060430    ,    1.110018    ,    1.164805    
     +,    1.226076    ,    1.294711    ,    1.370912    
     +,    1.453984    ,    1.542375    ,    1.633933    
     +,    1.726238    ,    1.816873    ,    1.903487    
     +,    1.983714    ,    2.054975    ,    2.114357    
     +,    2.158597    ,    2.184167    ,    2.187415    
     +,    2.164818    ,    2.113453    ,    2.031663    
     +,    1.919807    ,    1.780811    ,    1.620193    
     +,    1.445496    ,    1.265239    ,    1.087670    
     +,   0.9196967    ,   0.7662724    ,   0.6302589    
     +,   0.5126664    ,   0.4130947    ,   0.3302448    
     +,   0.2623428    ,   0.2074328    ,   0.1635596    
     +,   0.1288789    ,   0.1017094    ,   8.0555037E-02
     +,   6.4124972E-02,   5.1340751E-02,   4.1331105E-02
     +,   3.3417094E-02,   2.7088493E-02,   2.1973349E-02
     +,   1.7805234E-02,   1.4393715E-02,   1.1600390E-02
     +,   9.3208766E-03,   7.4719824E-03,   5.9846882E-03
     +,   4.7994088E-03,   3.8642616E-03,   3.1337773E-03
     +,   2.5686894E-03,   2.1354198E-03,   1.8058716E-03
     +,   1.5568611E-03,   1.3696585E-03,   1.2293266E-03
     +,   1.1241533E-03,   1.0450748E-03,   9.8514080E-04
     +,   9.3908887E-04,   9.0295600E-04,   8.7379111E-04
     +,   8.4940612E-04,   8.2819886E-04,   8.0900470E-04
     +,   7.9099124E-04,   7.7357178E-04,   7.5634604E-04
     +,   7.3904730E-04,   7.2151108E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_hzonly_ttz115_mass = Yx/18.7132418666667
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_hzonly_ttz120_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.7202476E-02,   2.8365603E-02
     +,   2.9541019E-02,   3.0726442E-02,   3.1919517E-02
     +,   3.3117820E-02,   3.4318913E-02,   3.5520341E-02
     +,   3.6719598E-02,   3.7914287E-02,   3.9101932E-02
     +,   4.0280171E-02,   4.1446634E-02,   4.2599145E-02
     +,   4.3735482E-02,   4.4853643E-02,   4.5951694E-02
     +,   4.7027864E-02,   4.8080541E-02,   4.9108285E-02
     +,   5.0109860E-02,   5.1084157E-02,   5.2030299E-02
     +,   5.2947767E-02,   5.3836055E-02,   5.4695055E-02
     +,   5.5524785E-02,   5.6325596E-02,   5.7098065E-02
     +,   5.7842974E-02,   5.8561347E-02,   5.9254494E-02
     +,   5.9923887E-02,   6.0571231E-02,   6.1198376E-02
     +,   6.1807420E-02,   6.2400468E-02,   6.2979884E-02
     +,   6.3548043E-02,   6.4107329E-02,   6.4660147E-02
     +,   6.5208919E-02,   6.5755956E-02,   6.6303469E-02
     +,   6.6853531E-02,   6.7407951E-02,   6.7968383E-02
     +,   6.8536162E-02,   6.9112360E-02,   6.9697730E-02
     +,   7.0292614E-02,   7.0897013E-02,   7.1510598E-02
     +,   7.2132491E-02,   7.2761595E-02,   7.3396385E-02
     +,   7.4034847E-02,   7.4674807E-02,   7.5313680E-02
     +,   7.5948544E-02,   7.6576263E-02,   7.7193618E-02
     +,   7.7797085E-02,   7.8383081E-02,   7.8948051E-02
     +,   7.9488389E-02,   8.0000706E-02,   8.0481559E-02
     +,   8.0927826E-02,   8.1336670E-02,   8.1705548E-02
     +,   8.2032263E-02,   8.2315087E-02,   8.2552627E-02
     +,   8.2744226E-02,   8.2889557E-02,   8.2988799E-02
     +,   8.3042905E-02,   8.3053209E-02,   8.3021730E-02
     +,   8.2950920E-02,   8.2843862E-02,   8.2703970E-02
     +,   8.2535312E-02,   8.2342148E-02,   8.2129285E-02
     +,   8.1901692E-02,   8.1664369E-02,   8.1422880E-02
     +,   8.1182353E-02,   8.0948174E-02,   8.0725409E-02
     +,   8.0519065E-02,   8.0333583E-02,   8.0173366E-02
     +,   8.0041967E-02,   7.9942606E-02,   7.9877675E-02
     +,   7.9849131E-02,   7.9858035E-02,   7.9904556E-02
     +,   7.9988278E-02,   8.0108039E-02,   8.0261521E-02
     +,   8.0445990E-02,   8.0657683E-02,   8.0892399E-02
     +,   8.1145108E-02,   8.1410334E-02,   8.1682064E-02
     +,   8.1954010E-02,   8.2219556E-02,   8.2471907E-02
     +,   8.2704298E-02,   8.2910083E-02,   8.3082765E-02
     +,   8.3216280E-02,   8.3304800E-02,   8.3343290E-02
     +,   8.3327085E-02,   8.3252475E-02,   8.3116330E-02
     +,   8.2916468E-02,   8.2651407E-02,   8.2320765E-02
     +,   8.1924789E-02,   8.1464700E-02,   8.0942541E-02
     +,   8.0361024E-02,   7.9723693E-02,   7.9034619E-02
     +,   7.8298464E-02,   7.7520296E-02,   7.6705560E-02
     +,   7.5859949E-02,   7.4989341E-02,   7.4099511E-02
     +,   7.3196426E-02,   7.2285719E-02,   7.1372837E-02
     +,   7.0462964E-02,   6.9561049E-02,   6.8671413E-02
     +,   6.7798153E-02,   6.6944830E-02,   6.6114560E-02
     +,   6.5309994E-02,   6.4533383E-02,   6.3786663E-02
     +,   6.3071333E-02,   6.2388651E-02,   6.1739616E-02
     +,   6.1125241E-02,   6.0546245E-02,   6.0003549E-02
     +,   5.9498131E-02,   5.9031192E-02,   5.8604117E-02
     +,   5.8218826E-02,   5.7877574E-02,   5.7583235E-02
     +,   5.7339236E-02,   5.7149772E-02,   5.7019763E-02
     +,   5.6954898E-02,   5.6961894E-02,   5.7048302E-02
     +,   5.7222705E-02,   5.7494719E-02,   5.7875007E-02
     +,   5.8375366E-02,   5.9008550E-02,   5.9788369E-02
     +,   6.0729556E-02,   6.1847512E-02,   6.3158162E-02
     +,   6.4677849E-02,   6.6422425E-02,   6.8407297E-02
     +,   7.0646696E-02,   7.3153026E-02,   7.5936377E-02
     +,   7.9003476E-02,   8.2357854E-02,   8.5998766E-02
     +,   8.9921169E-02,   9.4115682E-02,   9.8569416E-02
     +,   0.1032664    ,   0.1081885    ,   0.1133180    
     +,   0.1186395    ,   0.1241415    ,   0.1298202    
     +,   0.1356815    ,   0.1417439    ,   0.1480390    
     +,   0.1546132    ,   0.1615277    ,   0.1688558    
     +,   0.1766803    ,   0.1850884    ,   0.1941677    
     +,   0.2039986    ,   0.2146486    ,   0.2261696    
     +,   0.2385938    ,   0.2519341    ,   0.2661881    
     +,   0.2813452    ,   0.2973959    ,   0.3143390    
     +,   0.3321917    ,   0.3509986    ,   0.3708273    
     +,   0.3917641    ,   0.4139002    ,   0.4373140    
     +,   0.4620495    ,   0.4880903    ,   0.5153542    
     +,   0.5436884    ,   0.5728830    ,   0.6027023    
     +,   0.6329321    ,   0.6634228    ,   0.6941301    
     +,   0.7251313    ,   0.7566165    ,   0.7888466    
     +,   0.8220840    ,   0.8565224    ,   0.8922288    
     +,   0.9291193    ,   0.9669684    ,    1.005478    
     +,    1.044336    ,    1.083288    ,    1.122153    
     +,    1.160803    ,    1.199062    ,    1.236580    
     +,    1.272704    ,    1.306379    ,    1.336112    
     +,    1.360019    ,    1.375959    ,    1.381735    
     +,    1.375327    ,    1.355142    ,    1.320240    
     +,    1.270469    ,    1.206559    ,    1.130088    
     +,    1.043361    ,   0.9492146    ,   0.8507892    
     +,   0.7512583    ,   0.6535856    ,   0.5603375    
     +,   0.4735584    ,   0.3946990    ,   0.3246151    
     +,   0.2636197    ,   0.2115770    ,   0.1679909    
     +,   0.1321215    ,   0.1030864    ,   7.9943284E-02
     +,   6.1756875E-02,   4.7649324E-02,   3.6831599E-02
     +,   2.8617227E-02,   2.2426318E-02,   1.7782191E-02
     +,   1.4302380E-02,   1.1685714E-02,   9.7006792E-03
     +,   8.1723193E-03,   6.9714892E-03,   6.0045510E-03
     +,   5.2053207E-03,   4.5278990E-03,   3.9413352E-03
     +,   3.4251462E-03,   2.9661334E-03,   2.5558178E-03
     +,   2.1887382E-03,   1.8612318E-03,   1.5705354E-03
     +,   1.3143482E-03,   1.0904446E-03,   8.9657935E-04
     +,   7.3037372E-04,   5.8936334E-04,   4.7099678E-04
     +,   3.7272551E-04,   2.9203450E-04,   2.2652301E-04
     +,   1.7393084E-04,   1.3219065E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_hzonly_ttz120_mass = Yx/14.6765439545455
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_hzonly_ttz60_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.6867488E-02,   4.0446360E-02
     +,   4.4352368E-02,   4.8618030E-02,   5.3280771E-02
     +,   5.8385029E-02,   6.3984670E-02,   7.0146330E-02
     +,   7.6952621E-02,   8.4506579E-02,   9.2935354E-02
     +,   0.1023960    ,   0.1130822    ,   0.1252316    
     +,   0.1391321    ,   0.1551225    ,   0.1735804    
     +,   0.1948928    ,   0.2194058    ,   0.2473634    
     +,   0.2788593    ,   0.3138298    ,   0.3521286    
     +,   0.3936914    ,   0.4387630    ,   0.4881344    
     +,   0.5432631    ,   0.6061916    ,   0.6792073    
     +,   0.7642939    ,   0.8625271    ,   0.9736596    
     +,    1.096128    ,    1.227552    ,    1.365582    
     +,    1.508639    ,    1.656004    ,    1.806944    
     +,    1.959050    ,    2.106739    ,    2.241068    
     +,    2.351539    ,    2.429376    ,    2.470582    
     +,    2.476943    ,    2.454348    ,    2.409535    
     +,    2.347259    ,    2.269431    ,    2.176423    
     +,    2.069172    ,    1.950725    ,    1.826261    
     +,    1.701801    ,    1.582572    ,    1.471806    
     +,    1.370553    ,    1.278168    ,    1.193095    
     +,    1.113549    ,    1.037889    ,   0.9648111    
     +,   0.8934439    ,   0.8234212    ,   0.7549157    
     +,   0.6885824    ,   0.6253526    ,   0.5662029    
     +,   0.5119005    ,   0.4628755    ,   0.4191699    
     +,   0.3805155    ,   0.3464341    ,   0.3163637    
     +,   0.2897455    ,   0.2660848    ,   0.2449771    
     +,   0.2261079    ,   0.2092366    ,   0.1941805    
     +,   0.1807941    ,   0.1689507    ,   0.1585312    
     +,   0.1494149    ,   0.1414776    ,   0.1345912    
     +,   0.1286275    ,   0.1234610    ,   0.1189737    
     +,   0.1150569    ,   0.1116142    ,   0.1085622    
     +,   0.1058302    ,   0.1033594    ,   0.1011020    
     +,   9.9020056E-02,   9.7083375E-02,   9.5269084E-02
     +,   9.3559332E-02,   9.1941178E-02,   9.0405002E-02
     +,   8.8943988E-02,   8.7553434E-02,   8.6230345E-02
     +,   8.4972747E-02,   8.3779611E-02,   8.2650408E-02
     +,   8.1585050E-02,   8.0583714E-02,   7.9646334E-02
     +,   7.8773089E-02,   7.7963859E-02,   7.7218324E-02
     +,   7.6535814E-02,   7.5915523E-02,   7.5356111E-02
     +,   7.4856065E-02,   7.4413426E-02,   7.4025899E-02
     +,   7.3690824E-02,   7.3405214E-02,   7.3165707E-02
     +,   7.2968766E-02,   7.2810389E-02,   7.2686382E-02
     +,   7.2592288E-02,   7.2523497E-02,   7.2475217E-02
     +,   7.2442539E-02,   7.2420456E-02,   7.2404027E-02
     +,   7.2388358E-02,   7.2368652E-02,   7.2340302E-02
     +,   7.2298914E-02,   7.2240539E-02,   7.2161406E-02
     +,   7.2058298E-02,   7.1928404E-02,   7.1769424E-02
     +,   7.1579628E-02,   7.1357690E-02,   7.1102902E-02
     +,   7.0815139E-02,   7.0494704E-02,   7.0142388E-02
     +,   6.9759481E-02,   6.9347456E-02,   6.8908453E-02
     +,   6.8444669E-02,   6.7958511E-02,   6.7452572E-02
     +,   6.6929556E-02,   6.6392176E-02,   6.5843031E-02
     +,   6.5284781E-02,   6.4719856E-02,   6.4150572E-02
     +,   6.3578971E-02,   6.3007027E-02,   6.2436350E-02
     +,   6.1868370E-02,   6.1304357E-02,   6.0745280E-02
     +,   6.0191970E-02,   5.9644990E-02,   5.9104804E-02
     +,   5.8571763E-02,   5.8046009E-02,   5.7527620E-02
     +,   5.7016715E-02,   5.6513209E-02,   5.6017093E-02
     +,   5.5528175E-02,   5.5046443E-02,   5.4571804E-02
     +,   5.4104175E-02,   5.3643469E-02,   5.3189714E-02
     +,   5.2742835E-02,   5.2302785E-02,   5.1869627E-02
     +,   5.1443368E-02,   5.1024072E-02,   5.0611734E-02
     +,   5.0206475E-02,   4.9808327E-02,   4.9417436E-02
     +,   4.9033839E-02,   4.8657715E-02,   4.8289146E-02
     +,   4.7928274E-02,   4.7575299E-02,   4.7230378E-02
     +,   4.6893746E-02,   4.6565548E-02,   4.6246026E-02
     +,   4.5935437E-02,   4.5633972E-02,   4.5341849E-02
     +,   4.5059234E-02,   4.4786334E-02,   4.4523209E-02
     +,   4.4269927E-02,   4.4026483E-02,   4.3792754E-02
     +,   4.3568503E-02,   4.3353431E-02,   4.3147098E-02
     +,   4.2948864E-02,   4.2758029E-02,   4.2573694E-02
     +,   4.2394802E-02,   4.2220172E-02,   4.2048413E-02
     +,   4.1878063E-02,   4.1707460E-02,   4.1534849E-02
     +,   4.1358370E-02,   4.1176073E-02,   4.0985957E-02
     +,   4.0785950E-02,   4.0573988E-02,   4.0348027E-02
     +,   4.0106062E-02,   3.9846160E-02,   3.9566457E-02
     +,   3.9265309E-02,   3.8941123E-02,   3.8592517E-02
     +,   3.8218327E-02,   3.7817635E-02,   3.7389692E-02
     +,   3.6934007E-02,   3.6450427E-02,   3.5938971E-02
     +,   3.5399921E-02,   3.4833860E-02,   3.4241650E-02
     +,   3.3624314E-02,   3.2983124E-02,   3.2319628E-02
     +,   3.1635512E-02,   3.0932629E-02,   3.0212969E-02
     +,   2.9478682E-02,   2.8732009E-02,   2.7975244E-02
     +,   2.7210692E-02,   2.6440738E-02,   2.5667720E-02
     +,   2.4893910E-02,   2.4121590E-02,   2.3352960E-02
     +,   2.2590075E-02,   2.1834860E-02,   2.1089191E-02
     +,   2.0354778E-02,   1.9633142E-02,   1.8925661E-02
     +,   1.8233581E-02,   1.7557997E-02,   1.6899785E-02
     +,   1.6259670E-02,   1.5638286E-02,   1.5036050E-02
     +,   1.4453246E-02,   1.3890047E-02,   1.3346512E-02
     +,   1.2822543E-02,   1.2317943E-02,   1.1832454E-02
     +,   1.1365736E-02,   1.0917349E-02,   1.0486790E-02
     +,   1.0073553E-02,   9.6770423E-03,   9.2966743E-03
     +,   8.9318100E-03,   8.5818330E-03,   8.2460847E-03
     +,   7.9239495E-03,   7.6147751E-03,   7.3179691E-03
     +,   7.0329099E-03,   6.7590391E-03,   6.4957882E-03
     +,   6.2426259E-03,   5.9990543E-03,   5.7645869E-03
     +,   5.5387919E-03,   5.3212298E-03,   5.1115258E-03
     +,   4.9092993E-03,   4.7142217E-03,   4.5259683E-03
     +,   4.3442589E-03,   4.1688108E-03,   3.9993906E-03
     +,   3.8357535E-03,   3.6776997E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_hzonly_ttz60_mass = Yx/19.330752
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_hzonly_ttz65_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  5.6579397E-03,   5.9600868E-03
     +,   6.2887082E-03,   6.6468143E-03,   7.0377011E-03
     +,   7.4649532E-03,   7.9324478E-03,   8.4443390E-03
     +,   9.0050604E-03,   9.6193645E-03,   1.0292299E-02
     +,   1.1029279E-02,   1.1836187E-02,   1.2719476E-02
     +,   1.3686422E-02,   1.4745384E-02,   1.5906211E-02
     +,   1.7180758E-02,   1.8583544E-02,   2.0132508E-02
     +,   2.1850027E-02,   2.3763977E-02,   2.5909005E-02
     +,   2.8328169E-02,   3.1074170E-02,   3.4211628E-02
     +,   3.7818413E-02,   4.1987639E-02,   4.6829011E-02
     +,   5.2469991E-02,   5.9056044E-02,   6.6750348E-02
     +,   7.5732447E-02,   8.6195908E-02,   9.8345131E-02
     +,   0.1123913    ,   0.1285474    ,   0.1470233    
     +,   0.1680247    ,   0.1917529    ,   0.2184260    
     +,   0.2483096    ,   0.2817755    ,   0.3193721    
     +,   0.3618859    ,   0.4103604    ,   0.4660437    
     +,   0.5302649    ,   0.6042671    ,   0.6890458    
     +,   0.7852021    ,   0.8927649    ,    1.010937    
     +,    1.137828    ,    1.270395    ,    1.405021    
     +,    1.538766    ,    1.670956    ,    1.804115    
     +,    1.943235    ,    2.093074    ,    2.254450    
     +,    2.421427    ,    2.581150    ,    2.716545    
     +,    2.810407    ,    2.849157    ,    2.825515    
     +,    2.740491    ,    2.604361    ,    2.435192    
     +,    2.254137    ,    2.079094    ,    1.920116    
     +,    1.778835    ,    1.651391    ,    1.532534    
     +,    1.418586    ,    1.308403    ,    1.202808    
     +,    1.103479    ,    1.011991    ,   0.9293612    
     +,   0.8558642    ,   0.7910559    ,   0.7338685    
     +,   0.6828614    ,   0.6365131    ,   0.5935218    
     +,   0.5529869    ,   0.5144528    ,   0.4778350    
     +,   0.4432669    ,   0.4109417    ,   0.3809972    
     +,   0.3534590    ,   0.3282326    ,   0.3051458    
     +,   0.2839939    ,   0.2645893    ,   0.2467813    
     +,   0.2304681    ,   0.2155816    ,   0.2020743    
     +,   0.1898999    ,   0.1790027    ,   0.1693126    
     +,   0.1607459    ,   0.1532084    ,   0.1466036    
     +,   0.1408371    ,   0.1358202    ,   0.1314728    
     +,   0.1277232    ,   0.1245083    ,   0.1217712    
     +,   0.1194606    ,   0.1175290    ,   0.1159316    
     +,   0.1146256    ,   0.1135693    ,   0.1127224    
     +,   0.1120458    ,   0.1115017    ,   0.1110536    
     +,   0.1106671    ,   0.1103100    ,   0.1099524    
     +,   0.1095672    ,   0.1091307    ,   0.1086222    
     +,   0.1080248    ,   0.1073252    ,   0.1065139    
     +,   0.1055854    ,   0.1045378    ,   0.1033729    
     +,   0.1020962    ,   0.1007163    ,   9.9244386E-02
     +,   9.7694442E-02,   9.6082270E-02,   9.4425142E-02
     +,   9.2741184E-02,   9.1049321E-02,   8.9368120E-02
     +,   8.7715648E-02,   8.6109437E-02,   8.4565453E-02
     +,   8.3098322E-02,   8.1720829E-02,   8.0443993E-02
     +,   7.9276748E-02,   7.8226000E-02,   7.7296518E-02
     +,   7.6491289E-02,   7.5811163E-02,   7.5255230E-02
     +,   7.4820697E-02,   7.4503355E-02,   7.4297205E-02
     +,   7.4195027E-02,   7.4188225E-02,   7.4267134E-02
     +,   7.4421056E-02,   7.4638486E-02,   7.4907161E-02
     +,   7.5214408E-02,   7.5547196E-02,   7.5892299E-02
     +,   7.6236658E-02,   7.6567508E-02,   7.6872535E-02
     +,   7.7140152E-02,   7.7359676E-02,   7.7521525E-02
     +,   7.7617399E-02,   7.7640362E-02,   7.7584915E-02
     +,   7.7447206E-02,   7.7224925E-02,   7.6917350E-02
     +,   7.6525331E-02,   7.6051056E-02,   7.5498156E-02
     +,   7.4871361E-02,   7.4176505E-02,   7.3420100E-02
     +,   7.2609395E-02,   7.1752019E-02,   7.0855796E-02
     +,   6.9928534E-02,   6.8977937E-02,   6.8011433E-02
     +,   6.7035876E-02,   6.6057593E-02,   6.5082237E-02
     +,   6.4114772E-02,   6.3159332E-02,   6.2219247E-02
     +,   6.1297126E-02,   6.0394891E-02,   5.9513658E-02
     +,   5.8653854E-02,   5.7815522E-02,   5.6998041E-02
     +,   5.6200437E-02,   5.5421345E-02,   5.4659225E-02
     +,   5.3912263E-02,   5.3178478E-02,   5.2455895E-02
     +,   5.1742550E-02,   5.1036440E-02,   5.0335605E-02
     +,   4.9638234E-02,   4.8942618E-02,   4.8247151E-02
     +,   4.7550380E-02,   4.6850998E-02,   4.6147827E-02
     +,   4.5439806E-02,   4.4726066E-02,   4.4005845E-02
     +,   4.3278489E-02,   4.2543460E-02,   4.1800354E-02
     +,   4.1048896E-02,   4.0288869E-02,   3.9520159E-02
     +,   3.8742792E-02,   3.7956905E-02,   3.7162635E-02
     +,   3.6360312E-02,   3.5550382E-02,   3.4733269E-02
     +,   3.3909544E-02,   3.3079948E-02,   3.2245230E-02
     +,   3.1406265E-02,   3.0563924E-02,   2.9719269E-02
     +,   2.8873390E-02,   2.8027417E-02,   2.7182475E-02
     +,   2.6339849E-02,   2.5500823E-02,   2.4666609E-02
     +,   2.3838496E-02,   2.3017772E-02,   2.2205692E-02
     +,   2.1403441E-02,   2.0612219E-02,   1.9833187E-02
     +,   1.9067403E-02,   1.8315835E-02,   1.7579446E-02
     +,   1.6859118E-02,   1.6155591E-02,   1.5469525E-02
     +,   1.4801537E-02,   1.4152148E-02,   1.3521754E-02
     +,   1.2910652E-02,   1.2319127E-02,   1.1747305E-02
     +,   1.1195246E-02,   1.0662965E-02,   1.0150402E-02
     +,   9.6574016E-03,   9.1837421E-03,   8.7291822E-03
     +,   8.2934285E-03,   7.8761093E-03,   7.4768178E-03
     +,   7.0951544E-03,   6.7306329E-03,   6.3827946E-03
     +,   6.0511180E-03,   5.7351044E-03,   5.4342081E-03
     +,   5.1479083E-03,   4.8756469E-03,   4.6168994E-03
     +,   4.3711099E-03,   4.1377591E-03,   3.9163069E-03
     +,   3.7062310E-03,   3.5070307E-03,   3.3181959E-03
     +,   3.1392539E-03,   2.9697211E-03,   2.8091515E-03
     +,   2.6570931E-03,   2.5131309E-03,   2.3768458E-03
     +,   2.2478539E-03,   2.1257703E-03,   2.0102425E-03
     +,   1.9009185E-03,   1.7974783E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_hzonly_ttz65_mass = Yx/20.315674826087
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_hzonly_ttz70_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  7.4507562E-03,   7.7688871E-03
     +,   8.1038671E-03,   8.4569100E-03,   8.8292975E-03
     +,   9.2223696E-03,   9.6375253E-03,   1.0076214E-02
     +,   1.0539914E-02,   1.1030158E-02,   1.1548466E-02
     +,   1.2096355E-02,   1.2675306E-02,   1.3286742E-02
     +,   1.3932006E-02,   1.4612302E-02,   1.5328683E-02
     +,   1.6081996E-02,   1.6872838E-02,   1.7701522E-02
     +,   1.8568031E-02,   1.9471992E-02,   2.0412590E-02
     +,   2.1388672E-02,   2.2398543E-02,   2.3440192E-02
     +,   2.4511138E-02,   2.5608642E-02,   2.6729714E-02
     +,   2.7871318E-02,   2.9030576E-02,   3.0205064E-02
     +,   3.1393178E-02,   3.2594580E-02,   3.3810765E-02
     +,   3.5045706E-02,   3.6306623E-02,   3.7604719E-02
     +,   3.8956236E-02,   4.0383019E-02,   4.1913603E-02
     +,   4.3583766E-02,   4.5436881E-02,   4.7524180E-02
     +,   4.9904309E-02,   5.2642703E-02,   5.5810265E-02
     +,   5.9481535E-02,   6.3732862E-02,   6.8640128E-02
     +,   7.4277073E-02,   8.0714345E-02,   8.8020086E-02
     +,   9.6263751E-02,   0.1055217    ,   0.1158905    
     +,   0.1275028    ,   0.1405520    ,   0.1553211    
     +,   0.1722175    ,   0.1918076    ,   0.2148498    
     +,   0.2423138    ,   0.2753839    ,   0.3154182    
     +,   0.3638411    ,   0.4219672    ,   0.4907250    
     +,   0.5703925    ,   0.6604134    ,   0.7595276    
     +,   0.8662492    ,   0.9796852    ,    1.100275    
     +,    1.230000    ,    1.371601    ,    1.526999    
     +,    1.695809    ,    1.874832    ,    2.058485    
     +,    2.239078    ,    2.406527    ,    2.548866    
     +,    2.655639    ,    2.722920    ,    2.755713    
     +,    2.764012    ,    2.754936    ,    2.728002    
     +,    2.678260    ,    2.603993    ,    2.510420    
     +,    2.406098    ,    2.296912    ,    2.184285    
     +,    2.067643    ,    1.946774    ,    1.821938    
     +,    1.693318    ,    1.561807    ,    1.430383    
     +,    1.304223    ,    1.188800    ,    1.087371    
     +,   0.9996135    ,   0.9223118    ,   0.8514287    
     +,   0.7840992    ,   0.7195193    ,   0.6585755    
     +,   0.6027952    ,   0.5533579    ,   0.5106217    
     +,   0.4741275    ,   0.4429061    ,   0.4158097    
     +,   0.3917646    ,   0.3698936    ,   0.3495570    
     +,   0.3303331    ,   0.3119839    ,   0.2944103    
     +,   0.2776080    ,   0.2616258    ,   0.2465304    
     +,   0.2323850    ,   0.2192279    ,   0.2070721    
     +,   0.1959033    ,   0.1856905    ,   0.1763920    
     +,   0.1679664    ,   0.1603758    ,   0.1535905    
     +,   0.1475871    ,   0.1423460    ,   0.1378483    
     +,   0.1340703    ,   0.1309797    ,   0.1285338    
     +,   0.1266772    ,   0.1253426    ,   0.1244515    
     +,   0.1239165    ,   0.1236452    ,   0.1235421    
     +,   0.1235130    ,   0.1234680    ,   0.1233241    
     +,   0.1230081    ,   0.1224583    ,   0.1216263    
     +,   0.1204773    ,   0.1189908    ,   0.1171599    
     +,   0.1149914    ,   0.1125042    ,   0.1097274    
     +,   0.1066994    ,   0.1034655    ,   0.1000762    
     +,   9.6584737E-02,   9.3045950E-02,   8.9513898E-02
     +,   8.6040460E-02,   8.2673937E-02,   7.9458259E-02
     +,   7.6432012E-02,   7.3627844E-02,   7.1072176E-02
     +,   6.8785734E-02,   6.6783190E-02,   6.5073796E-02
     +,   6.3661791E-02,   6.2547311E-02,   6.1726622E-02
     +,   6.1193060E-02,   6.0937624E-02,   6.0949422E-02
     +,   6.1216183E-02,   6.1724871E-02,   6.2461611E-02
     +,   6.3412026E-02,   6.4561479E-02,   6.5894864E-02
     +,   6.7396477E-02,   6.9049917E-02,   7.0838101E-02
     +,   7.2742857E-02,   7.4744657E-02,   7.6822750E-02
     +,   7.8954957E-02,   8.1117474E-02,   8.3285086E-02
     +,   8.5431300E-02,   8.7528728E-02,   8.9549012E-02
     +,   9.1463625E-02,   9.3244150E-02,   9.4863094E-02
     +,   9.6293926E-02,   9.7512186E-02,   9.8495670E-02
     +,   9.9225320E-02,   9.9685311E-02,   9.9863619E-02
     +,   9.9752411E-02,   9.9347889E-02,   9.8650753E-02
     +,   9.7665943E-02,   9.6402347E-02,   9.4872825E-02
     +,   9.3093663E-02,   9.1084093E-02,   8.8865705E-02
     +,   8.6462341E-02,   8.3899155E-02,   8.1202060E-02
     +,   7.8397125E-02,   7.5510532E-02,   7.2567537E-02
     +,   6.9592267E-02,   6.6607609E-02,   6.3634694E-02
     +,   6.0692620E-02,   5.7798397E-02,   5.4967023E-02
     +,   5.2211415E-02,   4.9542107E-02,   4.6967618E-02
     +,   4.4494618E-02,   4.2127982E-02,   3.9870732E-02
     +,   3.7724327E-02,   3.5689175E-02,   3.3764239E-02
     +,   3.1947449E-02,   3.0236090E-02,   2.8626692E-02
     +,   2.7115148E-02,   2.5696918E-02,   2.4367316E-02
     +,   2.3121446E-02,   2.1954222E-02,   2.0860568E-02
     +,   1.9835550E-02,   1.8874353E-02,   1.7972263E-02
     +,   1.7124759E-02,   1.6327670E-02,   1.5576981E-02
     +,   1.4868931E-02,   1.4200089E-02,   1.3567295E-02
     +,   1.2967596E-02,   1.2398318E-02,   1.1857050E-02
     +,   1.1341636E-02,   1.0850075E-02,   1.0380605E-02
     +,   9.9316407E-03,   9.5018074E-03,   9.0898219E-03
     +,   8.6945659E-03,   8.3150808E-03,   7.9504726E-03
     +,   7.5999540E-03,   7.2628511E-03,   6.9385604E-03
     +,   6.6265296E-03,   6.3262614E-03,   6.0373312E-03
     +,   5.7593565E-03,   5.4919720E-03,   5.2348454E-03
     +,   4.9876915E-03,   4.7502210E-03,   4.5221862E-03
     +,   4.3033245E-03,   4.0934146E-03,   3.8922133E-03
     +,   3.6995111E-03,   3.5150750E-03,   3.3387002E-03
     +,   3.1701585E-03,   3.0092450E-03,   2.8557365E-03
     +,   2.7094106E-03,   2.5700575E-03,   2.4374467E-03
     +,   2.3113645E-03,   2.1915799E-03,   2.0778757E-03
     +,   1.9700197E-03,   1.8677944E-03,   1.7709695E-03
     +,   1.6793280E-03,   1.5926432E-03,   1.5107013E-03
     +,   1.4332817E-03,   1.3601765E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_hzonly_ttz70_mass = Yx/21.9966097826087
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_hzonly_ttz75_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  5.8119269E-03,   5.8996710E-03
     +,   5.9847198E-03,   6.0670176E-03,   6.1465343E-03
     +,   6.2232604E-03,   6.2972154E-03,   6.3684420E-03
     +,   6.4370185E-03,   6.5030609E-03,   6.5667187E-03
     +,   6.6281892E-03,   6.6877129E-03,   6.7455857E-03
     +,   6.8021570E-03,   6.8578389E-03,   6.9131078E-03
     +,   6.9685159E-03,   7.0246877E-03,   7.0823296E-03
     +,   7.1422351E-03,   7.2052884E-03,   7.2724670E-03
     +,   7.3448545E-03,   7.4236277E-03,   7.5100786E-03
     +,   7.6056090E-03,   7.7117314E-03,   7.8300806E-03
     +,   7.9624038E-03,   8.1105847E-03,   8.2766274E-03
     +,   8.4626852E-03,   8.6710500E-03,   8.9041805E-03
     +,   9.1647068E-03,   9.4554592E-03,   9.7794747E-03
     +,   1.0140073E-02,   1.0540819E-02,   1.0985641E-02
     +,   1.1478825E-02,   1.2025095E-02,   1.2629657E-02
     +,   1.3298251E-02,   1.4037222E-02,   1.4853556E-02
     +,   1.5754918E-02,   1.6749684E-02,   1.7846962E-02
     +,   1.9056559E-02,   2.0388948E-02,   2.1855244E-02
     +,   2.3467287E-02,   2.5237342E-02,   2.7178599E-02
     +,   2.9304933E-02,   3.1631507E-02,   3.4175172E-02
     +,   3.6955282E-02,   3.9994698E-02,   4.3321162E-02
     +,   4.6968371E-02,   5.0978050E-02,   5.5401117E-02
     +,   6.0298387E-02,   6.5741979E-02,   7.1814083E-02
     +,   7.8606881E-02,   8.6219311E-02,   9.4755255E-02
     +,   0.1043180    ,   0.1150072    ,   0.1269112    
     +,   0.1401020    ,   0.1546271    ,   0.1704996    
     +,   0.1876932    ,   0.2061470    ,   0.2257872    
     +,   0.2465813    ,   0.2686434    ,   0.2923776    
     +,   0.3186520    ,   0.3489312    ,   0.3852891    
     +,   0.4301735    ,   0.4858882    ,   0.5538338    
     +,   0.6338266    ,   0.7238804    ,   0.8207904    
     +,   0.9213736    ,    1.023689    ,    1.127441    
     +,    1.233549    ,    1.343805    ,    1.461260    
     +,    1.590589    ,    1.736635    ,    1.901019    
     +,    2.079051    ,    2.259768    ,    2.428904    
     +,    2.573240    ,    2.683973    ,    2.757097    
     +,    2.790158    ,    2.779550    ,    2.723824    
     +,    2.630523    ,    2.516980    ,    2.402012    
     +,    2.296872    ,    2.203625    ,    2.118896    
     +,    2.037027    ,    1.951550    ,    1.857323    
     +,    1.752994    ,    1.641462    ,    1.527973    
     +,    1.417764    ,    1.314759    ,    1.221194    
     +,    1.137575    ,    1.062829    ,   0.9948390    
     +,   0.9311922    ,   0.8699301    ,   0.8099792    
     +,   0.7512448    ,   0.6943541    ,   0.6402958    
     +,   0.5900194    ,   0.5441692    ,   0.5029731    
     +,   0.4662603    ,   0.4335835    ,   0.4043682    
     +,   0.3780497    ,   0.3541436    ,   0.3322698    
     +,   0.3121396    ,   0.2935349    ,   0.2762813    
     +,   0.2602413    ,   0.2453114    ,   0.2314198    
     +,   0.2185222    ,   0.2065958    ,   0.1956292    
     +,   0.1856114    ,   0.1765231    ,   0.1683317    
     +,   0.1609924    ,   0.1544483    ,   0.1486350    
     +,   0.1434856    ,   0.1389359    ,   0.1349255    
     +,   0.1314007    ,   0.1283145    ,   0.1256257    
     +,   0.1232970    ,   0.1212939    ,   0.1195841    
     +,   0.1181350    ,   0.1169145    ,   0.1158906    
     +,   0.1150312    ,   0.1143054    ,   0.1136829    
     +,   0.1131359    ,   0.1126382    ,   0.1121667    
     +,   0.1117009    ,   0.1112235    ,   0.1107202    
     +,   0.1101803    ,   0.1095956    ,   0.1089619    
     +,   0.1082776    ,   0.1075445    ,   0.1067675    
     +,   0.1059541    ,   0.1051149    ,   0.1042627    
     +,   0.1034123    ,   0.1025802    ,   0.1017833    
     +,   0.1010392    ,   0.1003648    ,   9.9775299E-02
     +,   9.9284165E-02,   9.8901600E-02,   9.8634496E-02
     +,   9.8485641E-02,   9.8453321E-02,   9.8531276E-02
     +,   9.8708682E-02,   9.8970555E-02,   9.9297896E-02
     +,   9.9668570E-02,   0.1000579    ,   0.1004396    
     +,   0.1007868    ,   0.1010730    ,   0.1012726    
     +,   0.1013624    ,   0.1013220    ,   0.1011341    
     +,   0.1007859    ,   0.1002685    ,   9.9576935E-02
     +,   9.8711237E-02,   9.7674951E-02,   9.6475340E-02
     +,   9.5122710E-02,   9.3630202E-02,   9.2012510E-02
     +,   9.0285748E-02,   8.8466682E-02,   8.6572066E-02
     +,   8.4617890E-02,   8.2619280E-02,   8.0589876E-02
     +,   7.8541689E-02,   7.6484762E-02,   7.4427232E-02
     +,   7.2375342E-02,   7.0333607E-02,   6.8304785E-02
     +,   6.6290215E-02,   6.4290367E-02,   6.2304601E-02
     +,   6.0331710E-02,   5.8370415E-02,   5.6419343E-02
     +,   5.4477170E-02,   5.2542984E-02,   5.0616439E-02
     +,   4.8697848E-02,   4.6787970E-02,   4.4888258E-02
     +,   4.3000903E-02,   4.1128658E-02,   3.9274633E-02
     +,   3.7442315E-02,   3.5635691E-02,   3.3858698E-02
     +,   3.2115355E-02,   3.0409712E-02,   2.8745698E-02
     +,   2.7126873E-02,   2.5556490E-02,   2.4037575E-02
     +,   2.2572679E-02,   2.1163851E-02,   1.9812677E-02
     +,   1.8520379E-02,   1.7287724E-02,   1.6114950E-02
     +,   1.5001902E-02,   1.3948150E-02,   1.2952822E-02
     +,   1.2014724E-02,   1.1132491E-02,   1.0304498E-02
     +,   9.5288856E-03,   8.8036470E-03,   8.1267152E-03
     +,   7.4959248E-03,   6.9090230E-03,   6.3637239E-03
     +,   5.8578099E-03,   5.3889956E-03,   4.9551032E-03
     +,   4.5539457E-03,   4.1834549E-03,   3.8415815E-03
     +,   3.5264089E-03,   3.2360577E-03,   2.9687840E-03
     +,   2.7228962E-03,   2.4968295E-03,   2.2890896E-03
     +,   2.0982742E-03,   1.9230910E-03,   1.7623081E-03
     +,   1.6148008E-03,   1.4795044E-03,   1.3554478E-03
     +,   1.2417160E-03,   1.1374769E-03,   1.0419484E-03
     +,   9.5442130E-04,   8.7423017E-04,   8.0077263E-04
     +,   7.3348498E-04,   6.7185675E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_hzonly_ttz75_mass = Yx/22.6467985531915
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_hzonly_ttz80_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  5.6709466E-03,   5.7871575E-03
     +,   5.9029730E-03,   6.0184472E-03,   6.1336639E-03
     +,   6.2487265E-03,   6.3637695E-03,   6.4789541E-03
     +,   6.5944721E-03,   6.7105512E-03,   6.8274508E-03
     +,   6.9454685E-03,   7.0649320E-03,   7.1862172E-03
     +,   7.3097367E-03,   7.4359407E-03,   7.5653228E-03
     +,   7.6984246E-03,   7.8358194E-03,   7.9781320E-03
     +,   8.1260223E-03,   8.2801981E-03,   8.4413998E-03
     +,   8.6104171E-03,   8.7880529E-03,   8.9751678E-03
     +,   9.1726352E-03,   9.3813622E-03,   9.6022757E-03
     +,   9.8363124E-03,   1.0084431E-02,   1.0347587E-02
     +,   1.0626739E-02,   1.0922839E-02,   1.1236819E-02
     +,   1.1569596E-02,   1.1922054E-02,   1.2295039E-02
     +,   1.2689371E-02,   1.3105771E-02,   1.3544961E-02
     +,   1.4007557E-02,   1.4494107E-02,   1.5005081E-02
     +,   1.5540857E-02,   1.6101712E-02,   1.6687842E-02
     +,   1.7299313E-02,   1.7936088E-02,   1.8598020E-02
     +,   1.9284833E-02,   1.9996131E-02,   2.0731388E-02
     +,   2.1490004E-02,   2.2271173E-02,   2.3074050E-02
     +,   2.3897640E-02,   2.4740832E-02,   2.5602443E-02
     +,   2.6481172E-02,   2.7375670E-02,   2.8284518E-02
     +,   2.9206196E-02,   3.0139256E-02,   3.1082250E-02
     +,   3.2033678E-02,   3.2992281E-02,   3.3956818E-02
     +,   3.4926463E-02,   3.5900552E-02,   3.6879119E-02
     +,   3.7862673E-02,   3.8852818E-02,   3.9852157E-02
     +,   4.0864926E-02,   4.1897237E-02,   4.2957511E-02
     +,   4.4056930E-02,   4.5210168E-02,   4.6435744E-02
     +,   4.7756493E-02,   4.9200103E-02,   5.0799232E-02
     +,   5.2591767E-02,   5.4620426E-02,   5.6932554E-02
     +,   5.9578989E-02,   6.2613733E-02,   6.6092640E-02
     +,   7.0073642E-02,   7.4617662E-02,   7.9790607E-02
     +,   8.5668854E-02,   9.2347436E-02,   9.9949934E-02
     +,   0.1086397    ,   0.1186327    ,   0.1302027    
     +,   0.1436831    ,   0.1594532    ,   0.1779173    
     +,   0.1994678    ,   0.2244546    ,   0.2531590    
     +,   0.2858067    ,   0.3226243    ,   0.3639411    
     +,   0.4103257    ,   0.4626887    ,   0.5222532    
     +,   0.5903255    ,   0.6679384    ,   0.7555180    
     +,   0.8529252    ,   0.9598837    ,    1.076556    
     +,    1.203497    ,    1.340579    ,    1.484991    
     +,    1.629952    ,    1.766185    ,    1.887075    
     +,    1.994929    ,    2.102875    ,    2.228545    
     +,    2.381604    ,    2.552837    ,    2.713828    
     +,    2.830975    ,    2.884896    ,    2.878868    
     +,    2.829602    ,    2.752686    ,    2.657780    
     +,    2.553069    ,    2.447623    ,    2.347032    
     +,    2.248844    ,    2.144781    ,    2.027777    
     +,    1.896523    ,    1.754567    ,    1.607608    
     +,    1.462539    ,    1.327561    ,    1.210970    
     +,    1.118364    ,    1.050162    ,    1.001289    
     +,   0.9632386    ,   0.9272954    ,   0.8872206    
     +,   0.8404301    ,   0.7875485    ,   0.7310514    
     +,   0.6738444    ,   0.6182863    ,   0.5658230    
     +,   0.5170659    ,   0.4720813    ,   0.4306853    
     +,   0.3926677    ,   0.3578909    ,   0.3262891    
     +,   0.2978142    ,   0.2723824    ,   0.2498424    
     +,   0.2299779    ,   0.2125335    ,   0.1972550    
     +,   0.1839204    ,   0.1723540    ,   0.1624240    
     +,   0.1540300    ,   0.1470869    ,   0.1415070    
     +,   0.1371912    ,   0.1340250    ,   0.1318809    
     +,   0.1306223    ,   0.1301111    ,   0.1302128    
     +,   0.1308019    ,   0.1317646    ,   0.1330004    
     +,   0.1344218    ,   0.1359541    ,   0.1375333    
     +,   0.1391051    ,   0.1406228    ,   0.1420460    
     +,   0.1433397    ,   0.1444730    ,   0.1454195    
     +,   0.1461565    ,   0.1466653    ,   0.1469315    
     +,   0.1469452    ,   0.1467014    ,   0.1461995    
     +,   0.1454436    ,   0.1444424    ,   0.1432076    
     +,   0.1417540    ,   0.1400985    ,   0.1382588    
     +,   0.1362530    ,   0.1340986    ,   0.1318120    
     +,   0.1294087    ,   0.1269019    ,   0.1243042    
     +,   0.1216268    ,   0.1188805    ,   0.1160753    
     +,   0.1132215    ,   0.1103299    ,   0.1074116    
     +,   0.1044780    ,   0.1015413    ,   9.8613247E-02
     +,   9.5705479E-02,   9.2828982E-02,   8.9993685E-02
     +,   8.7207757E-02,   8.4477618E-02,   8.1807904E-02
     +,   7.9201140E-02,   7.6657727E-02,   7.4176259E-02
     +,   7.1753807E-02,   6.9386281E-02,   6.7068487E-02
     +,   6.4794622E-02,   6.2559061E-02,   6.0355995E-02
     +,   5.8180131E-02,   5.6027003E-02,   5.3893015E-02
     +,   5.1775340E-02,   4.9672287E-02,   4.7583342E-02
     +,   4.5509014E-02,   4.3450631E-02,   4.1410401E-02
     +,   3.9391376E-02,   3.7397310E-02,   3.5432179E-02
     +,   3.3500377E-02,   3.1606644E-02,   2.9755579E-02
     +,   2.7951729E-02,   2.6199592E-02,   2.4503326E-02
     +,   2.2866668E-02,   2.1292856E-02,   1.9784784E-02
     +,   1.8344799E-02,   1.6974572E-02,   1.5675224E-02
     +,   1.4447399E-02,   1.3291185E-02,   1.2206057E-02
     +,   1.1191010E-02,   1.0244698E-02,   9.3652569E-03
     +,   8.5504884E-03,   7.7979462E-03,   7.1049305E-03
     +,   6.4685014E-03,   5.8855820E-03,   5.3530508E-03
     +,   4.8677209E-03,   4.4263788E-03,   4.0258379E-03
     +,   3.6630202E-03,   3.3348848E-03,   3.0385540E-03
     +,   2.7712369E-03,   2.5303271E-03,   2.3133405E-03
     +,   2.1179849E-03,   1.9421027E-03,   1.7837276E-03
     +,   1.6410316E-03,   1.5123636E-03,   1.3962094E-03
     +,   1.2912006E-03,   1.1961142E-03,   1.1098403E-03
     +,   1.0313989E-03,   9.5990690E-04,   8.9459051E-04
     +,   8.3475735E-04,   7.7980396E-04,   7.2919269E-04
     +,   6.8245892E-04,   6.3918944E-04,   5.9902866E-04
     +,   5.6166120E-04,   5.2681693E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_hzonly_ttz80_mass = Yx/22.8138861702128
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_hzonly_ttz85_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.4928762E-03,   3.5787369E-03
     +,   3.6654959E-03,   3.7531208E-03,   3.8415773E-03
     +,   3.9308262E-03,   4.0208274E-03,   4.1115349E-03
     +,   4.2028991E-03,   4.2948704E-03,   4.3873931E-03
     +,   4.4804043E-03,   4.5738397E-03,   4.6676314E-03
     +,   4.7617042E-03,   4.8559783E-03,   4.9503716E-03
     +,   5.0447932E-03,   5.1391521E-03,   5.2333479E-03
     +,   5.3272769E-03,   5.4208306E-03,   5.5138962E-03
     +,   5.6063593E-03,   5.6980918E-03,   5.7889749E-03
     +,   5.8788750E-03,   5.9676641E-03,   6.0552028E-03
     +,   6.1413571E-03,   6.2259901E-03,   6.3089603E-03
     +,   6.3901301E-03,   6.4693633E-03,   6.5465225E-03
     +,   6.6214744E-03,   6.6940892E-03,   6.7642438E-03
     +,   6.8318197E-03,   6.8967054E-03,   6.9588027E-03
     +,   7.0180153E-03,   7.0742718E-03,   7.1275034E-03
     +,   7.1776644E-03,   7.2247270E-03,   7.2686868E-03
     +,   7.3095663E-03,   7.3474110E-03,   7.3823095E-03
     +,   7.4143852E-03,   7.4438122E-03,   7.4708159E-03
     +,   7.4956887E-03,   7.5187976E-03,   7.5405990E-03
     +,   7.5616543E-03,   7.5826454E-03,   7.6044002E-03
     +,   7.6279105E-03,   7.6543600E-03,   7.6851598E-03
     +,   7.7219727E-03,   7.7667497E-03,   7.8217741E-03
     +,   7.8896824E-03,   7.9735229E-03,   8.0767768E-03
     +,   8.2034003E-03,   8.3578359E-03,   8.5450653E-03
     +,   8.7705757E-03,   9.0404106E-03,   9.3610827E-03
     +,   9.7396178E-03,   1.0183459E-02,   1.0700372E-02
     +,   1.1298354E-02,   1.1985586E-02,   1.2770232E-02
     +,   1.3660241E-02,   1.4663344E-02,   1.5786678E-02
     +,   1.7036848E-02,   1.8419545E-02,   1.9939687E-02
     +,   2.1600977E-02,   2.3406222E-02,   2.5356896E-02
     +,   2.7453514E-02,   2.9695552E-02,   3.2081347E-02
     +,   3.4608431E-02,   3.7273746E-02,   4.0073741E-02
     +,   4.3004327E-02,   4.6061665E-02,   4.9241740E-02
     +,   5.2541502E-02,   5.5958353E-02,   5.9491582E-02
     +,   6.3142203E-02,   6.6914298E-02,   7.0815340E-02
     +,   7.4857898E-02,   7.9060428E-02,   8.3448276E-02
     +,   8.8055067E-02,   9.2924416E-02,   9.8110504E-02
     +,   0.1036791    ,   0.1097096    ,   0.1162963    
     +,   0.1235526    ,   0.1316146    ,   0.1406507    
     +,   0.1508674    ,   0.1625184    ,   0.1759015    
     +,   0.1913470    ,   0.2091846    ,   0.2296920    
     +,   0.2530434    ,   0.2792776    ,   0.3083149    
     +,   0.3400479    ,   0.3745197    ,   0.4121314    
     +,   0.4538382    ,   0.5011915    ,   0.5561713    
     +,   0.6207548    ,   0.6964253    ,   0.7838469    
     +,   0.8829998    ,   0.9936262    ,    1.115586    
     +,    1.248868    ,    1.393256    ,    1.547670    
     +,    1.708965    ,    1.870631    ,    2.023279    
     +,    2.158327    ,    2.273094    ,    2.372992    
     +,    2.469009    ,    2.572851    ,    2.691381    
     +,    2.819939    ,    2.939007    ,    3.021755    
     +,    3.050182    ,    3.026965    ,    2.972533    
     +,    2.909191    ,    2.844070    ,    2.763596    
     +,    2.643976    ,    2.472076    ,    2.259886    
     +,    2.037514    ,    1.832118    ,    1.654995    
     +,    1.504950    ,    1.376839    ,    1.265177    
     +,    1.163938    ,    1.067210    ,   0.9713965    
     +,   0.8767503    ,   0.7868177    ,   0.7063674    
     +,   0.6391947    ,   0.5868598    ,   0.5485833    
     +,   0.5219787    ,   0.5040098    ,   0.4917420    
     +,   0.4827386    ,   0.4751637    ,   0.4677457    
     +,   0.4596953    ,   0.4506251    ,   0.4404625    
     +,   0.4293581    ,   0.4175786    ,   0.4054164    
     +,   0.3931168    ,   0.3808436    ,   0.3686682    
     +,   0.3565891    ,   0.3445584    ,   0.3325146    
     +,   0.3204081    ,   0.3082224    ,   0.2959836    
     +,   0.2837624    ,   0.2716669    ,   0.2598366    
     +,   0.2484301    ,   0.2376116    ,   0.2275391    
     +,   0.2183509    ,   0.2101553    ,   0.2030177    
     +,   0.1969556    ,   0.1919351    ,   0.1878710    
     +,   0.1846331    ,   0.1820559    ,   0.1799500    
     +,   0.1781165    ,   0.1763588    ,   0.1744955    
     +,   0.1723696    ,   0.1698554    ,   0.1668629    
     +,   0.1633382    ,   0.1592640    ,   0.1546545    
     +,   0.1495518    ,   0.1440197    ,   0.1381377    
     +,   0.1319937    ,   0.1256788    ,   0.1192827    
     +,   0.1128886    ,   0.1065702    ,   0.1003899    
     +,   9.4398580E-02,   8.8634841E-02,   8.3125614E-02
     +,   7.7887535E-02,   7.2928950E-02,   6.8250522E-02
     +,   6.3847356E-02,   5.9710883E-02,   5.5829577E-02
     +,   5.2189972E-02,   4.8777916E-02,   4.5579214E-02
     +,   4.2580031E-02,   3.9766930E-02,   3.7127364E-02
     +,   3.4649931E-02,   3.2324117E-02,   3.0140225E-02
     +,   2.8089460E-02,   2.6164001E-02,   2.4356544E-02
     +,   2.2660432E-02,   2.1069625E-02,   1.9578539E-02
     +,   1.8181834E-02,   1.6874507E-02,   1.5651885E-02
     +,   1.4509495E-02,   1.3442975E-02,   1.2448112E-02
     +,   1.1520910E-02,   1.0657500E-02,   9.8540718E-03
     +,   9.1069685E-03,   8.4127262E-03,   7.7679548E-03
     +,   7.1694050E-03,   6.6140294E-03,   6.0989186E-03
     +,   5.6212898E-03,   5.1785205E-03,   4.7681713E-03
     +,   4.3879626E-03,   4.0357327E-03,   3.7094797E-03
     +,   3.4073645E-03,   3.1276483E-03,   2.8687548E-03
     +,   2.6291893E-03,   2.4076060E-03,   2.2027260E-03
     +,   2.0133962E-03,   1.8385223E-03,   1.6771136E-03
     +,   1.5282300E-03,   1.3910177E-03,   1.2646662E-03
     +,   1.1484220E-03,   1.0415917E-03,   9.4351353E-04
     +,   8.5357879E-04,   7.7120570E-04,   6.9585867E-04
     +,   6.2702445E-04,   5.6422927E-04,   5.0702004E-04
     +,   4.5497780E-04,   4.0770209E-04,   3.6482338E-04
     +,   3.2598892E-04,   2.9087355E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_hzonly_ttz85_mass = Yx/24.150587106383
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_hzonly_ttz90_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.8165899E-03,   3.9203516E-03
     +,   4.0234956E-03,   4.1258396E-03,   4.2272019E-03
     +,   4.3274104E-03,   4.4262954E-03,   4.5237015E-03
     +,   4.6194741E-03,   4.7134813E-03,   4.8055965E-03
     +,   4.8957090E-03,   4.9837255E-03,   5.0695674E-03
     +,   5.1531773E-03,   5.2345162E-03,   5.3135678E-03
     +,   5.3903363E-03,   5.4648472E-03,   5.5371565E-03
     +,   5.6073419E-03,   5.6755040E-03,   5.7417741E-03
     +,   5.8063096E-03,   5.8692922E-03,   5.9309332E-03
     +,   5.9914729E-03,   6.0511706E-03,   6.1103199E-03
     +,   6.1692381E-03,   6.2282654E-03,   6.2877629E-03
     +,   6.3481214E-03,   6.4097429E-03,   6.4730537E-03
     +,   6.5384964E-03,   6.6065248E-03,   6.6776029E-03
     +,   6.7522111E-03,   6.8308259E-03,   6.9139330E-03
     +,   7.0020123E-03,   7.0955404E-03,   7.1949884E-03
     +,   7.3008179E-03,   7.4134679E-03,   7.5333673E-03
     +,   7.6609184E-03,   7.7965087E-03,   7.9404879E-03
     +,   8.0931867E-03,   8.2549034E-03,   8.4259007E-03
     +,   8.6064283E-03,   8.7966826E-03,   8.9968536E-03
     +,   9.2070969E-03,   9.4275484E-03,   9.6583264E-03
     +,   9.8995380E-03,   1.0151288E-02,   1.0413687E-02
     +,   1.0686838E-02,   1.0970881E-02,   1.1265993E-02
     +,   1.1572348E-02,   1.1890215E-02,   1.2219868E-02
     +,   1.2561688E-02,   1.2916080E-02,   1.3283563E-02
     +,   1.3664684E-02,   1.4060120E-02,   1.4470566E-02
     +,   1.4896828E-02,   1.5339773E-02,   1.5800294E-02
     +,   1.6279314E-02,   1.6777812E-02,   1.7296752E-02
     +,   1.7837044E-02,   1.8399606E-02,   1.8985195E-02
     +,   1.9594541E-02,   2.0228155E-02,   2.0886440E-02
     +,   2.1569533E-02,   2.2277405E-02,   2.3009686E-02
     +,   2.3765776E-02,   2.4544785E-02,   2.5345435E-02
     +,   2.6166158E-02,   2.7005054E-02,   2.7859952E-02
     +,   2.8728269E-02,   2.9607259E-02,   3.0493820E-02
     +,   3.1384785E-02,   3.2276720E-02,   3.3166274E-02
     +,   3.4049995E-02,   3.4924682E-02,   3.5787333E-02
     +,   3.6635384E-02,   3.7466880E-02,   3.8280576E-02
     +,   3.9076194E-02,   3.9854731E-02,   4.0618613E-02
     +,   4.1371949E-02,   4.2120945E-02,   4.2873949E-02
     +,   4.3642040E-02,   4.4439074E-02,   4.5282092E-02
     +,   4.6191458E-02,   4.7191281E-02,   4.8309438E-02
     +,   4.9577918E-02,   5.1033136E-02,   5.2715812E-02
     +,   5.4671373E-02,   5.6950357E-02,   5.9608437E-02
     +,   6.2706642E-02,   6.6312045E-02,   7.0497528E-02
     +,   7.5342782E-02,   8.0933630E-02,   8.7363318E-02
     +,   9.4731070E-02,   0.1031434    ,   0.1127120    
     +,   0.1235556    ,   0.1358000    ,   0.1495814    
     +,   0.1650545    ,   0.1824096    ,   0.2018966    
     +,   0.2238522    ,   0.2487265    ,   0.2770830    
     +,   0.3095472    ,   0.3466800    ,   0.3888008    
     +,   0.4357841    ,   0.4869199    ,   0.5409256    
     +,   0.5961596    ,   0.6510341    ,   0.7046359    
     +,   0.7575200    ,   0.8124560    ,   0.8746578    
     +,   0.9509273    ,    1.047682    ,    1.168720    
     +,    1.313901    ,    1.479057    ,    1.656547    
     +,    1.836273    ,    2.008017    ,    2.165182    
     +,    2.307473    ,    2.438620    ,    2.557528    
     +,    2.649450    ,    2.689831    ,    2.663352    
     +,    2.579598    ,    2.466367    ,    2.348910    
     +,    2.239403    ,    2.143685    ,    2.069075    
     +,    2.020694    ,    1.993374    ,    1.971814    
     +,    1.939718    ,    1.889054    ,    1.823414    
     +,    1.755023    ,    1.697136    ,    1.655354    
     +,    1.623731    ,    1.589358    ,    1.541841    
     +,    1.479747    ,    1.409524    ,    1.339480    
     +,    1.274538    ,    1.214858    ,    1.157729    
     +,    1.100372    ,    1.041760    ,   0.9828144    
     +,   0.9253793    ,   0.8709651    ,   0.8200874    
     +,   0.7724150    ,   0.7273500    ,   0.6845052    
     +,   0.6438090    ,   0.6053147    ,   0.5689589    
     +,   0.5344844    ,   0.5015268    ,   0.4697692    
     +,   0.4390716    ,   0.4095119    ,   0.3813548    
     +,   0.3549664    ,   0.3307225    ,   0.3089351    
     +,   0.2898034    ,   0.2733836    ,   0.2595839    
     +,   0.2481776    ,   0.2388284    ,   0.2311215    
     +,   0.2246030    ,   0.2188173    ,   0.2133413    
     +,   0.2078113    ,   0.2019428    ,   0.1955405    
     +,   0.1884996    ,   0.1807982    ,   0.1724855    
     +,   0.1636666    ,   0.1544840    ,   0.1450994    
     +,   0.1356788    ,   0.1263804    ,   0.1173433    
     +,   0.1086822    ,   0.1004847    ,   9.2810892E-02
     +,   8.5694134E-02,   7.9144783E-02,   7.3154673E-02
     +,   6.7700446E-02,   6.2747680E-02,   5.8254842E-02
     +,   5.4176938E-02,   5.0467797E-02,   4.7081959E-02
     +,   4.3976668E-02,   4.1113053E-02,   3.8456317E-02
     +,   3.5976313E-02,   3.3647764E-02,   3.1449825E-02
     +,   2.9365750E-02,   2.7382486E-02,   2.5490442E-02
     +,   2.3682697E-02,   2.1954516E-02,   2.0302905E-02
     +,   1.8726323E-02,   1.7224154E-02,   1.5796248E-02
     +,   1.4442805E-02,   1.3164209E-02,   1.1960596E-02
     +,   1.0831860E-02,   9.7776111E-03,   8.7970383E-03
     +,   7.8888163E-03,   7.0511843E-03,   6.2820106E-03
     +,   5.5787624E-03,   4.9385205E-03,   4.3580867E-03
     +,   3.8341074E-03,   3.3629925E-03,   2.9411337E-03
     +,   2.5648300E-03,   2.2304566E-03,   1.9344146E-03
     +,   1.6732588E-03,   1.4436533E-03,   1.2424678E-03
     +,   1.0667333E-03,   9.1371010E-04,   7.8084972E-04
     +,   6.6581753E-04,   5.6649791E-04,   4.8096274E-04
     +,   4.0748907E-04,   3.4452495E-04,   2.9069753E-04
     +,   2.4478300E-04,   2.0570768E-04,   1.7252302E-04
     +,   1.4440301E-04,   1.2062329E-04,   1.0055715E-04
     +,   8.3658662E-05,   6.9458067E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_hzonly_ttz90_mass = Yx/24.0220581702128
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_hzonly_ttz95_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  5.0693257E-03,   5.2622380E-03
     +,   5.4592043E-03,   5.6600613E-03,   5.8646430E-03
     +,   6.0727629E-03,   6.2842248E-03,   6.4988099E-03
     +,   6.7162951E-03,   6.9364458E-03,   7.1590128E-03
     +,   7.3837340E-03,   7.6103392E-03,   7.8385547E-03
     +,   8.0680987E-03,   8.2986727E-03,   8.5299872E-03
     +,   8.7617533E-03,   8.9936648E-03,   9.2254281E-03
     +,   9.4567509E-03,   9.6873483E-03,   9.9169333E-03
     +,   1.0145252E-02,   1.0372022E-02,   1.0597015E-02
     +,   1.0820000E-02,   1.1040770E-02,   1.1259140E-02
     +,   1.1474947E-02,   1.1688066E-02,   1.1898391E-02
     +,   1.2105857E-02,   1.2310429E-02,   1.2512118E-02
     +,   1.2710972E-02,   1.2907074E-02,   1.3100572E-02
     +,   1.3291644E-02,   1.3480510E-02,   1.3667461E-02
     +,   1.3852818E-02,   1.4036946E-02,   1.4220274E-02
     +,   1.4403262E-02,   1.4586410E-02,   1.4770266E-02
     +,   1.4955404E-02,   1.5142433E-02,   1.5331968E-02
     +,   1.5524669E-02,   1.5721180E-02,   1.5922129E-02
     +,   1.6128192E-02,   1.6339954E-02,   1.6558018E-02
     +,   1.6782932E-02,   1.7015176E-02,   1.7255180E-02
     +,   1.7503303E-02,   1.7759809E-02,   1.8024869E-02
     +,   1.8298546E-02,   1.8580804E-02,   1.8871490E-02
     +,   1.9170301E-02,   1.9476866E-02,   1.9790638E-02
     +,   2.0110987E-02,   2.0437162E-02,   2.0768322E-02
     +,   2.1103512E-02,   2.1441769E-02,   2.1782028E-02
     +,   2.2123236E-02,   2.2464374E-02,   2.2804420E-02
     +,   2.3142463E-02,   2.3477731E-02,   2.3809608E-02
     +,   2.4137694E-02,   2.4461843E-02,   2.4782199E-02
     +,   2.5099279E-02,   2.5413958E-02,   2.5727544E-02
     +,   2.6041748E-02,   2.6358798E-02,   2.6681338E-02
     +,   2.7012480E-02,   2.7355809E-02,   2.7715255E-02
     +,   2.8095121E-02,   2.8499976E-02,   2.8934607E-02
     +,   2.9403813E-02,   2.9912407E-02,   3.0464971E-02
     +,   3.1065783E-02,   3.1718578E-02,   3.2426514E-02
     +,   3.3191826E-02,   3.4015868E-02,   3.4898788E-02
     +,   3.5839587E-02,   3.6835890E-02,   3.7883922E-02
     +,   3.8978469E-02,   4.0112935E-02,   4.1279450E-02
     +,   4.2468816E-02,   4.3670960E-02,   4.4874836E-02
     +,   4.6069041E-02,   4.7241859E-02,   4.8381936E-02
     +,   4.9478438E-02,   5.0521802E-02,   5.1503871E-02
     +,   5.2418787E-02,   5.3263381E-02,   5.4037422E-02
     +,   5.4744426E-02,   5.5391952E-02,   5.5991951E-02
     +,   5.6560922E-02,   5.7120129E-02,   5.7695456E-02
     +,   5.8317304E-02,   5.9019912E-02,   5.9840824E-02
     +,   6.0819823E-02,   6.1997853E-02,   6.3415237E-02
     +,   6.5110557E-02,   6.7118570E-02,   6.9468111E-02
     +,   7.2180800E-02,   7.5269461E-02,   7.8736730E-02
     +,   8.2574338E-02,   8.6763591E-02,   9.1276154E-02
     +,   9.6076734E-02,   0.1011258    ,   0.1063854    
     +,   0.1118255    ,   0.1174306    ,   0.1232092    
     +,   0.1292018    ,   0.1354881    ,   0.1421907    
     +,   0.1494758    ,   0.1575472    ,   0.1666326    
     +,   0.1769626    ,   0.1887435    ,   0.2021279    
     +,   0.2171849    ,   0.2338737    ,   0.2520367    
     +,   0.2714031    ,   0.2916111    ,   0.3122507    
     +,   0.3329202    ,   0.3532844    ,   0.3731386    
     +,   0.3924640    ,   0.4114861    ,   0.4307133    
     +,   0.4509611    ,   0.4733310    ,   0.4991168    
     +,   0.5296292    ,   0.5659978    ,   0.6091294    
     +,   0.6599952    ,   0.7202404    ,   0.7926665    
     +,   0.8807609    ,   0.9869023    ,    1.110433    
     +,    1.248018    ,    1.397133    ,    1.559250    
     +,    1.737718    ,    1.931537    ,    2.133794    
     +,    2.340035    ,    2.557026    ,    2.797142    
     +,    3.059731    ,    3.319952    ,    3.540146    
     +,    3.692291    ,    3.765868    ,    3.757814    
     +,    3.667606    ,    3.506880    ,    3.305874    
     +,    3.101950    ,    2.917467    ,    2.748821    
     +,    2.580066    ,    2.406558    ,    2.241429    
     +,    2.099821    ,    1.982025    ,    1.873316    
     +,    1.756814    ,    1.625283    ,    1.483795    
     +,    1.344341    ,    1.218289    ,    1.111554    
     +,    1.023897    ,   0.9509516    ,   0.8869295    
     +,   0.8267580    ,   0.7672499    ,   0.7073782    
     +,   0.6479034    ,   0.5906093    ,   0.5374553    
     +,   0.4899237    ,   0.4486965    ,   0.4136425    
     +,   0.3840040    ,   0.3586653    ,   0.3364154    
     +,   0.3161492    ,   0.2969919    ,   0.2783495    
     +,   0.2599037    ,   0.2415639    ,   0.2233956    
     +,   0.2055520    ,   0.1882175    ,   0.1715663    
     +,   0.1557383    ,   0.1408329    ,   0.1269114    
     +,   0.1140016    ,   0.1021058    ,   9.1207862E-02
     +,   8.1279725E-02,   7.2283700E-02,   6.4174369E-02
     +,   5.6900781E-02,   5.0407741E-02,   4.4635814E-02
     +,   3.9523069E-02,   3.5006978E-02,   3.1025374E-02
     +,   2.7517896E-02,   2.4427565E-02,   2.1702107E-02
     +,   1.9294368E-02,   1.7162552E-02,   1.5270474E-02
     +,   1.3587352E-02,   1.2087204E-02,   1.0748156E-02
     +,   9.5519302E-03,   8.4832869E-03,   7.5291973E-03
     +,   6.6784741E-03,   5.9213890E-03,   5.2492684E-03
     +,   4.6542264E-03,   4.1290317E-03,   3.6670298E-03
     +,   3.2620216E-03,   2.9081972E-03,   2.6001567E-03
     +,   2.3329128E-03,   2.1018221E-03,   1.9026472E-03
     +,   1.7314930E-03,   1.5848458E-03,   1.4595177E-03
     +,   1.3526683E-03,   1.2617523E-03,   1.1845288E-03
     +,   1.1190136E-03,   1.0634769E-03,   1.0164056E-03
     +,   9.7648770E-04,   9.4259385E-04,   9.1374817E-04
     +,   8.8911899E-04,   8.6799328E-04,   8.4976770E-04
     +,   8.3392806E-04,   8.2004286E-04,   8.0774649E-04
     +,   7.9673389E-04,   7.8674825E-04,   7.7757676E-04
     +,   7.6904107E-04,   7.6099474E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_hzonly_ttz95_mass = Yx/25.949992212766
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_hzonly_hatt100_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.4346893E-02,   3.5887122E-02
     +,   3.7449103E-02,   3.9030921E-02,   4.0630683E-02
     +,   4.2246465E-02,   4.3876383E-02,   4.5518551E-02
     +,   4.7171038E-02,   4.8832018E-02,   5.0499532E-02
     +,   5.2171614E-02,   5.3846307E-02,   5.5521511E-02
     +,   5.7195127E-02,   5.8864910E-02,   6.0528491E-02
     +,   6.2183391E-02,   6.3826911E-02,   6.5456294E-02
     +,   6.7068487E-02,   6.8660341E-02,   7.0228502E-02
     +,   7.1769431E-02,   7.3279366E-02,   7.4754447E-02
     +,   7.6190792E-02,   7.7584252E-02,   7.8930736E-02
     +,   8.0226108E-02,   8.1466317E-02,   8.2647309E-02
     +,   8.3765313E-02,   8.4816709E-02,   8.5798085E-02
     +,   8.6706579E-02,   8.7539390E-02,   8.8294469E-02
     +,   8.8970184E-02,   8.9565277E-02,   9.0079375E-02
     +,   9.0512395E-02,   9.0865090E-02,   9.1138914E-02
     +,   9.1335744E-02,   9.1458276E-02,   9.1509819E-02
     +,   9.1494232E-02,   9.1415949E-02,   9.1280080E-02
     +,   9.1092072E-02,   9.0857752E-02,   9.0583563E-02
     +,   9.0276062E-02,   8.9942098E-02,   8.9588732E-02
     +,   8.9223206E-02,   8.8852622E-02,   8.8484272E-02
     +,   8.8125169E-02,   8.7782294E-02,   8.7462306E-02
     +,   8.7171689E-02,   8.6916566E-02,   8.6702578E-02
     +,   8.6535066E-02,   8.6418815E-02,   8.6357966E-02
     +,   8.6356290E-02,   8.6416818E-02,   8.6542025E-02
     +,   8.6733580E-02,   8.6992666E-02,   8.7319449E-02
     +,   8.7713577E-02,   8.8174000E-02,   8.8698640E-02
     +,   8.9284934E-02,   8.9929231E-02,   9.0627566E-02
     +,   9.1374740E-02,   9.2165180E-02,   9.2992261E-02
     +,   9.3849197E-02,   9.4728105E-02,   9.5620841E-02
     +,   9.6518606E-02,   9.7412363E-02,   9.8292604E-02
     +,   9.9149756E-02,   9.9974021E-02,   0.1007556    
     +,   0.1014850    ,   0.1021528    ,   0.1027500    
     +,   0.1032682    ,   0.1036995    ,   0.1040370    
     +,   0.1042743    ,   0.1044062    ,   0.1044285    
     +,   0.1043381    ,   0.1041331    ,   0.1038129    
     +,   0.1033777    ,   0.1028293    ,   0.1021705    
     +,   0.1014054    ,   0.1005390    ,   9.9577241E-02
     +,   9.8527074E-02,   9.7396061E-02,   9.6192643E-02
     +,   9.4925642E-02,   9.3604304E-02,   9.2238106E-02
     +,   9.0836711E-02,   8.9409769E-02,   8.7966882E-02
     +,   8.6517379E-02,   8.5070267E-02,   8.3634160E-02
     +,   8.2217313E-02,   8.0827333E-02,   7.9471178E-02
     +,   7.8155421E-02,   7.6885760E-02,   7.5667463E-02
     +,   7.4505009E-02,   7.3402382E-02,   7.2362840E-02
     +,   7.1389094E-02,   7.0483446E-02,   6.9647595E-02
     +,   6.8882823E-02,   6.8190031E-02,   6.7569807E-02
     +,   6.7022443E-02,   6.6547982E-02,   6.6146322E-02
     +,   6.5817229E-02,   6.5560468E-02,   6.5375745E-02
     +,   6.5262720E-02,   6.5221429E-02,   6.5251693E-02
     +,   6.5353744E-02,   6.5527879E-02,   6.5774806E-02
     +,   6.6095345E-02,   6.6490673E-02,   6.6962235E-02
     +,   6.7511775E-02,   6.8141334E-02,   6.8853311E-02
     +,   6.9650225E-02,   7.0534855E-02,   7.1510307E-02
     +,   7.2579809E-02,   7.3746562E-02,   7.5014085E-02
     +,   7.6385796E-02,   7.7865206E-02,   7.9455681E-02
     +,   8.1160761E-02,   8.2983769E-02,   8.4928021E-02
     +,   8.6996727E-02,   8.9193180E-02,   9.1520742E-02
     +,   9.3982756E-02,   9.6582435E-02,   9.9323601E-02
     +,   0.1022103    ,   0.1052464    ,   0.1084366    
     +,   0.1117858    ,   0.1152989    ,   0.1189805    
     +,   0.1228353    ,   0.1268669    ,   0.1310774    
     +,   0.1354665    ,   0.1400310    ,   0.1447644    
     +,   0.1496546    ,   0.1546852    ,   0.1598348    
     +,   0.1650782    ,   0.1703862    ,   0.1757299    
     +,   0.1810822    ,   0.1864231    ,   0.1917424    
     +,   0.1970470    ,   0.2023633    ,   0.2077428    
     +,   0.2132640    ,   0.2190341    ,   0.2251883    
     +,   0.2318855    ,   0.2393032    ,   0.2476300    
     +,   0.2570546    ,   0.2677542    ,   0.2798846    
     +,   0.2935663    ,   0.3088755    ,   0.3258356    
     +,   0.3444141    ,   0.3645229    ,   0.3860212    
     +,   0.4087312    ,   0.4324571    ,   0.4570093    
     +,   0.4822340    ,   0.5080454    ,   0.5344621    
     +,   0.5616239    ,   0.5898030    ,   0.6194060    
     +,   0.6509364    ,   0.6849508    ,   0.7219899    
     +,   0.7624981    ,   0.8067495    ,   0.8547657    
     +,   0.9062669    ,   0.9606473    ,    1.016972    
     +,    1.074000    ,    1.130239    ,    1.184014    
     +,    1.233538    ,    1.276994    ,    1.312614    
     +,    1.338771    ,    1.354032    ,    1.357264    
     +,    1.347688    ,    1.324953    ,    1.289199    
     +,    1.241081    ,    1.181765    ,    1.112890    
     +,    1.036475    ,   0.9547895    ,   0.8701923    
     +,   0.7849755    ,   0.7012267    ,   0.6207036    
     +,   0.5447782    ,   0.4744189    ,   0.4102084    
     +,   0.3523901    ,   0.3009397    ,   0.2556337    
     +,   0.2161109    ,   0.1819208    ,   0.1525669    
     +,   0.1275391    ,   0.1063306    ,   8.8452630E-02
     +,   7.3446997E-02,   6.0894586E-02,   5.0417241E-02
     +,   4.1682187E-02,   3.4402516E-02,   2.8334776E-02
     +,   2.3275135E-02,   1.9055415E-02,   1.5537995E-02
     +,   1.2610220E-02,   1.0179290E-02,   8.1683304E-03
     +,   6.5129898E-03,   5.1583247E-03,   4.0572616E-03
     +,   3.1688807E-03,   2.4577393E-03,   1.8930173E-03
     +,   1.4482182E-03,   1.1006439E-03,   8.3116232E-04
     +,   6.2376721E-04,   4.6529522E-04,   3.4501692E-04
     +,   2.5431041E-04,   1.8633145E-04,   1.3568818E-04
     +,   9.8186691E-05,   7.0581802E-05,   5.0388677E-05
     +,   3.5711480E-05,   2.5116658E-05,   1.7523240E-05
     +,   1.2122931E-05,   8.3131772E-06,   5.6487170E-06
     +,   3.8019091E-06,   2.5339868E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_hzonly_hatt100_mass = Yx/14.4156886363636
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_hzonly_hatt105_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  0.1226180    ,   0.1308715    
     +,   0.1391591    ,   0.1474269    ,   0.1556204    
     +,   0.1636850    ,   0.1715678    ,   0.1792180    
     +,   0.1865884    ,   0.1936364    ,   0.2003248    
     +,   0.2066229    ,   0.2125072    ,   0.2179617    
     +,   0.2229795    ,   0.2275612    ,   0.2317170    
     +,   0.2354653    ,   0.2388327    ,   0.2418529    
     +,   0.2445674    ,   0.2470227    ,   0.2492698    
     +,   0.2513628    ,   0.2533572    ,   0.2553077    
     +,   0.2572670    ,   0.2592843    ,   0.2614022    
     +,   0.2636563    ,   0.2660732    ,   0.2686694    
     +,   0.2714505    ,   0.2744099    ,   0.2775302    
     +,   0.2807820    ,   0.2841251    ,   0.2875103    
     +,   0.2908799    ,   0.2941699    ,   0.2973125    
     +,   0.3002379    ,   0.3028770    ,   0.3051648    
     +,   0.3070413    ,   0.3084540    ,   0.3093613    
     +,   0.3097325    ,   0.3095504    ,   0.3088107    
     +,   0.3075230    ,   0.3057110    ,   0.3034103    
     +,   0.3006692    ,   0.2975444    ,   0.2941012    
     +,   0.2904099    ,   0.2865444    ,   0.2825786    
     +,   0.2785840    ,   0.2746283    ,   0.2707730    
     +,   0.2670714    ,   0.2635676    ,   0.2602956    
     +,   0.2572801    ,   0.2545341    ,   0.2520622    
     +,   0.2498593    ,   0.2479139    ,   0.2462067    
     +,   0.2447147    ,   0.2434117    ,   0.2422686    
     +,   0.2412570    ,   0.2403486    ,   0.2395168    
     +,   0.2387376    ,   0.2379900    ,   0.2372566    
     +,   0.2365241    ,   0.2357824    ,   0.2350261    
     +,   0.2342537    ,   0.2334677    ,   0.2326740    
     +,   0.2318827    ,   0.2311070    ,   0.2303637    
     +,   0.2296718    ,   0.2290531    ,   0.2285315    
     +,   0.2281308    ,   0.2278759    ,   0.2277904    
     +,   0.2278961    ,   0.2282117    ,   0.2287510    
     +,   0.2295233    ,   0.2305309    ,   0.2317689    
     +,   0.2332246    ,   0.2348777    ,   0.2366989    
     +,   0.2386521    ,   0.2406941    ,   0.2427761    
     +,   0.2448449    ,   0.2468453    ,   0.2487206    
     +,   0.2504166    ,   0.2518818    ,   0.2530700    
     +,   0.2539425    ,   0.2544681    ,   0.2546254    
     +,   0.2544031    ,   0.2538002    ,   0.2528256    
     +,   0.2514979    ,   0.2498435    ,   0.2478969    
     +,   0.2456978    ,   0.2432898    ,   0.2407184    
     +,   0.2380307    ,   0.2352715    ,   0.2324834    
     +,   0.2297055    ,   0.2269714    ,   0.2243090    
     +,   0.2217404    ,   0.2192809    ,   0.2169392    
     +,   0.2147184    ,   0.2126148    ,   0.2106204    
     +,   0.2087217    ,   0.2069020    ,   0.2051413    
     +,   0.2034176    ,   0.2017070    ,   0.1999861    
     +,   0.1982314    ,   0.1964209    ,   0.1945346    
     +,   0.1925554    ,   0.1904703    ,   0.1882700    
     +,   0.1859507    ,   0.1835136    ,   0.1809664    
     +,   0.1783223    ,   0.1756019    ,   0.1728320    
     +,   0.1700458    ,   0.1672836    ,   0.1645916    
     +,   0.1620214    ,   0.1596307    ,   0.1574804    
     +,   0.1556357    ,   0.1541645    ,   0.1531350    
     +,   0.1526161    ,   0.1526745    ,   0.1533741    
     +,   0.1547734    ,   0.1569244    ,   0.1598707    
     +,   0.1636454    ,   0.1682697    ,   0.1737520    
     +,   0.1800869    ,   0.1872532    ,   0.1952166    
     +,   0.2039282    ,   0.2133270    ,   0.2233417    
     +,   0.2338942    ,   0.2449038    ,   0.2562887    
     +,   0.2679727    ,   0.2798887    ,   0.2919818    
     +,   0.3042102    ,   0.3165494    ,   0.3289911    
     +,   0.3415398    ,   0.3542113    ,   0.3670274    
     +,   0.3800086    ,   0.3931693    ,   0.4065099    
     +,   0.4200116    ,   0.4336331    ,   0.4473037    
     +,   0.4609271    ,   0.4743817    ,   0.4875242    
     +,   0.5001945    ,   0.5122252    ,   0.5234492    
     +,   0.5337079    ,   0.5428542    ,   0.5507653    
     +,   0.5573398    ,   0.5625023    ,   0.5662022    
     +,   0.5684118    ,   0.5691220    ,   0.5683383    
     +,   0.5660788    ,   0.5623674    ,   0.5572348    
     +,   0.5507165    ,   0.5428532    ,   0.5336918    
     +,   0.5232884    ,   0.5117105    ,   0.4990380    
     +,   0.4853657    ,   0.4708023    ,   0.4554712    
     +,   0.4395047    ,   0.4230428    ,   0.4062296    
     +,   0.3892083    ,   0.3721145    ,   0.3550748    
     +,   0.3382025    ,   0.3215966    ,   0.3053375    
     +,   0.2894889    ,   0.2740996    ,   0.2592033    
     +,   0.2448198    ,   0.2309609    ,   0.2176306    
     +,   0.2048264    ,   0.1925429    ,   0.1807742    
     +,   0.1695137    ,   0.1587546    ,   0.1484906    
     +,   0.1387171    ,   0.1294300    ,   0.1206242    
     +,   0.1122944    ,   0.1044350    ,   9.7038306E-02
     +,   9.0095006E-02,   8.3593994E-02,   7.7522524E-02
     +,   7.1865194E-02,   6.6605188E-02,   6.1724395E-02
     +,   5.7203636E-02,   5.3022590E-02,   4.9160484E-02
     +,   4.5596857E-02,   4.2311303E-02,   3.9283734E-02
     +,   3.6494769E-02,   3.3926163E-02,   3.1560350E-02
     +,   2.9380858E-02,   2.7372433E-02,   2.5520917E-02
     +,   2.3813019E-02,   2.2236608E-02,   2.0780539E-02
     +,   1.9434648E-02,   1.8189499E-02,   1.7036509E-02
     +,   1.5967928E-02,   1.4976549E-02,   1.4055932E-02
     +,   1.3200087E-02,   1.2403689E-02,   1.1661771E-02
     +,   1.0969924E-02,   1.0324046E-02,   9.7205127E-03
     +,   9.1559440E-03,   8.6273486E-03,   8.1319623E-03
     +,   7.6672807E-03,   7.2310753E-03,   6.8212673E-03
     +,   6.4360178E-03,   6.0736057E-03,   5.7325098E-03
     +,   5.4112952E-03,   5.1086927E-03,   4.8234970E-03
     +,   4.5546386E-03,   4.3010972E-03,   4.0619592E-03
     +,   3.8363521E-03,   3.6234907E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_hzonly_hatt105_mass = Yx/16.5574480909091
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_hzonly_hatt107_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  0.1450837    ,   0.1547959    
     +,   0.1645301    ,   0.1742292    ,   0.1838378    
     +,   0.1933030    ,   0.2025753    ,   0.2116094    
     +,   0.2203648    ,   0.2288067    ,   0.2369049    
     +,   0.2446353    ,   0.2519779    ,   0.2589187    
     +,   0.2654474    ,   0.2715570    ,   0.2772446    
     +,   0.2825097    ,   0.2873539    ,   0.2917811    
     +,   0.2957967    ,   0.2994087    ,   0.3026254    
     +,   0.3054583    ,   0.3079197    ,   0.3100240    
     +,   0.3117881    ,   0.3132293    ,   0.3143668    
     +,   0.3152210    ,   0.3158118    ,   0.3161592    
     +,   0.3162816    ,   0.3161955    ,   0.3159151    
     +,   0.3154515    ,   0.3148118    ,   0.3140005    
     +,   0.3130187    ,   0.3118654    ,   0.3105370    
     +,   0.3090299    ,   0.3073408    ,   0.3054686    
     +,   0.3034142    ,   0.3011832    ,   0.2987851    
     +,   0.2962352    ,   0.2935517    ,   0.2907597    
     +,   0.2878872    ,   0.2849644    ,   0.2820232    
     +,   0.2790952    ,   0.2762103    ,   0.2733952    
     +,   0.2706719    ,   0.2680562    ,   0.2655587    
     +,   0.2631818    ,   0.2609216    ,   0.2587682    
     +,   0.2567055    ,   0.2547131    ,   0.2527669    
     +,   0.2508412    ,   0.2489105    ,   0.2469491    
     +,   0.2449345    ,   0.2428477    ,   0.2406741    
     +,   0.2384047    ,   0.2360359    ,   0.2335700    
     +,   0.2310147    ,   0.2283836    ,   0.2256950    
     +,   0.2229712    ,   0.2202370    ,   0.2175209    
     +,   0.2148512    ,   0.2122568    ,   0.2097658    
     +,   0.2074044    ,   0.2051961    ,   0.2031610    
     +,   0.2013155    ,   0.1996715    ,   0.1982357    
     +,   0.1970106    ,   0.1959936    ,   0.1951777    
     +,   0.1945508    ,   0.1940976    ,   0.1937990    
     +,   0.1936333    ,   0.1935762    ,   0.1936018    
     +,   0.1936839    ,   0.1937954    ,   0.1939105    
     +,   0.1940039    ,   0.1940523    ,   0.1940346    
     +,   0.1939329    ,   0.1937313    ,   0.1934183    
     +,   0.1929852    ,   0.1924271    ,   0.1917424    
     +,   0.1909328    ,   0.1900032    ,   0.1889619    
     +,   0.1878188    ,   0.1865868    ,   0.1852798    
     +,   0.1839132    ,   0.1825034    ,   0.1810672    
     +,   0.1796204    ,   0.1781795    ,   0.1767591    
     +,   0.1753732    ,   0.1740340    ,   0.1727515    
     +,   0.1715348    ,   0.1703899    ,   0.1693210    
     +,   0.1683304    ,   0.1674179    ,   0.1665815    
     +,   0.1658171    ,   0.1651191    ,   0.1644802    
     +,   0.1638921    ,   0.1633449    ,   0.1628285    
     +,   0.1623322    ,   0.1618452    ,   0.1613564    
     +,   0.1608558    ,   0.1603338    ,   0.1597819    
     +,   0.1591931    ,   0.1585612    ,   0.1578824    
     +,   0.1571547    ,   0.1563780    ,   0.1555546    
     +,   0.1546888    ,   0.1537877    ,   0.1528610    
     +,   0.1519201    ,   0.1509800    ,   0.1500575    
     +,   0.1491726    ,   0.1483474    ,   0.1476067    
     +,   0.1469780    ,   0.1464906    ,   0.1461764    
     +,   0.1460691    ,   0.1462037    ,   0.1466166    
     +,   0.1473449    ,   0.1484251    ,   0.1498935    
     +,   0.1517837    ,   0.1541270    ,   0.1569504    
     +,   0.1602757    ,   0.1641181    ,   0.1684853    
     +,   0.1733772    ,   0.1787839    ,   0.1846871    
     +,   0.1910591    ,   0.1978638    ,   0.2050585    
     +,   0.2125956    ,   0.2204252    ,   0.2284968    
     +,   0.2367647    ,   0.2451895    ,   0.2537422    
     +,   0.2624066    ,   0.2711811    ,   0.2800814    
     +,   0.2891397    ,   0.2984022    ,   0.3079300    
     +,   0.3177912    ,   0.3280592    ,   0.3388048    
     +,   0.3500907    ,   0.3619650    ,   0.3744548    
     +,   0.3875605    ,   0.4012534    ,   0.4154732    
     +,   0.4301271    ,   0.4450920    ,   0.4602199    
     +,   0.4753429    ,   0.4902773    ,   0.5048361    
     +,   0.5188314    ,   0.5320847    ,   0.5444318    
     +,   0.5557280    ,   0.5658519    ,   0.5747036    
     +,   0.5822088    ,   0.5883150    ,   0.5929890    
     +,   0.5962134    ,   0.5979838    ,   0.5983056    
     +,   0.5971907    ,   0.5946514    ,   0.5907035    
     +,   0.5853632    ,   0.5786455    ,   0.5705687    
     +,   0.5611516    ,   0.5504172    ,   0.5383985    
     +,   0.5251352    ,   0.5106823    ,   0.4951059    
     +,   0.4784911    ,   0.4609387    ,   0.4425668    
     +,   0.4235066    ,   0.4039051    ,   0.3839180    
     +,   0.3637068    ,   0.3434362    ,   0.3232690    
     +,   0.3033603    ,   0.2838535    ,   0.2648818    
     +,   0.2465589    ,   0.2289806    ,   0.2122221    
     +,   0.1963402    ,   0.1813714    ,   0.1673338    
     +,   0.1542278    ,   0.1420412    ,   0.1307478    
     +,   0.1203117    ,   0.1106903    ,   0.1018358    
     +,   9.3696423E-02,   8.6219840E-02,   7.9354189E-02
     +,   7.3049173E-02,   6.7256741E-02,   6.1931923E-02
     +,   5.7033636E-02,   5.2524451E-02,   4.8370250E-02
     +,   4.4540498E-02,   4.1008230E-02,   3.7749175E-02
     +,   3.4741592E-02,   3.1966325E-02,   2.9406132E-02
     +,   2.7045272E-02,   2.4869470E-02,   2.2865774E-02
     +,   2.1022223E-02,   1.9327613E-02,   1.7771460E-02
     +,   1.6344083E-02,   1.5036172E-02,   1.3839102E-02
     +,   1.2744539E-02,   1.1744757E-02,   1.0832302E-02
     +,   1.0000240E-02,   9.2419274E-03,   8.5511971E-03
     +,   7.9221595E-03,   7.3493938E-03,   6.8277735E-03
     +,   6.3525354E-03,   5.9193140E-03,   5.5240272E-03
     +,   5.1629785E-03,   4.8327376E-03,   4.5302301E-03
     +,   4.2526252E-03,   3.9974120E-03,   3.7622990E-03
     +,   3.5452696E-03,   3.3444967E-03,   3.1583875E-03
     +,   2.9855070E-03,   2.8246106E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_hzonly_hatt107_mass = Yx/16.5025311818182
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_hzonly_hatt110_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  9.8885491E-02,   0.1069449    
     +,   0.1152770    ,   0.1238458    ,   0.1326106    
     +,   0.1415261    ,   0.1505431    ,   0.1596087    
     +,   0.1686677    ,   0.1776633    ,   0.1865378    
     +,   0.1952339    ,   0.2036962    ,   0.2118713    
     +,   0.2197105    ,   0.2271697    ,   0.2342103    
     +,   0.2408011    ,   0.2469171    ,   0.2525415    
     +,   0.2576648    ,   0.2622852    ,   0.2664080    
     +,   0.2700449    ,   0.2732132    ,   0.2759356    
     +,   0.2782387    ,   0.2801512    ,   0.2817052    
     +,   0.2829331    ,   0.2838681    ,   0.2845429    
     +,   0.2849897    ,   0.2852396    ,   0.2853231    
     +,   0.2852687    ,   0.2851044    ,   0.2848563    
     +,   0.2845494    ,   0.2842073    ,   0.2838521    
     +,   0.2835035    ,   0.2831796    ,   0.2828952    
     +,   0.2826618    ,   0.2824872    ,   0.2823752    
     +,   0.2823245    ,   0.2823299    ,   0.2823816    
     +,   0.2824650    ,   0.2825622    ,   0.2826529    
     +,   0.2827141    ,   0.2827226    ,   0.2826552    
     +,   0.2824905    ,   0.2822087    ,   0.2817946    
     +,   0.2812372    ,   0.2805288    ,   0.2796682    
     +,   0.2786579    ,   0.2775061    ,   0.2762246    
     +,   0.2748295    ,   0.2733391    ,   0.2717746    
     +,   0.2701590    ,   0.2685150    ,   0.2668658    
     +,   0.2652341    ,   0.2636398    ,   0.2621022    
     +,   0.2606364    ,   0.2592555    ,   0.2579678    
     +,   0.2567785    ,   0.2556882    ,   0.2546927    
     +,   0.2537839    ,   0.2529501    ,   0.2521749    
     +,   0.2514392    ,   0.2507215    ,   0.2499984    
     +,   0.2492462    ,   0.2484405    ,   0.2475598    
     +,   0.2465828    ,   0.2454930    ,   0.2442766    
     +,   0.2429247    ,   0.2414324    ,   0.2397996    
     +,   0.2380310    ,   0.2361340    ,   0.2341206    
     +,   0.2320042    ,   0.2298003    ,   0.2275251    
     +,   0.2251946    ,   0.2228235    ,   0.2204254    
     +,   0.2180115    ,   0.2155907    ,   0.2131692    
     +,   0.2107509    ,   0.2083376    ,   0.2059290    
     +,   0.2035240    ,   0.2011199    ,   0.1987147    
     +,   0.1963064    ,   0.1938939    ,   0.1914771    
     +,   0.1890580    ,   0.1866404    ,   0.1842293    
     +,   0.1818322    ,   0.1794577    ,   0.1771165    
     +,   0.1748193    ,   0.1725787    ,   0.1704064    
     +,   0.1683146    ,   0.1663147    ,   0.1644170    
     +,   0.1626307    ,   0.1609632    ,   0.1594200    
     +,   0.1580046    ,   0.1567182    ,   0.1555604    
     +,   0.1545275    ,   0.1536145    ,   0.1528145    
     +,   0.1521183    ,   0.1515154    ,   0.1509939    
     +,   0.1505412    ,   0.1501437    ,   0.1497878    
     +,   0.1494600    ,   0.1491473    ,   0.1488376    
     +,   0.1485202    ,   0.1481865    ,   0.1478296    
     +,   0.1474449    ,   0.1470314    ,   0.1465904    
     +,   0.1461265    ,   0.1456476    ,   0.1451647    
     +,   0.1446922    ,   0.1442472    ,   0.1438493    
     +,   0.1435204    ,   0.1432843    ,   0.1431658    
     +,   0.1431902    ,   0.1433827    ,   0.1437678    
     +,   0.1443687    ,   0.1452063    ,   0.1462993    
     +,   0.1476634    ,   0.1493109    ,   0.1512514    
     +,   0.1534908    ,   0.1560324    ,   0.1588778    
     +,   0.1620264    ,   0.1654763    ,   0.1692266    
     +,   0.1732776    ,   0.1776305    ,   0.1822902    
     +,   0.1872648    ,   0.1925661    ,   0.1982094    
     +,   0.2042140    ,   0.2106014    ,   0.2173958    
     +,   0.2246206    ,   0.2322986    ,   0.2404500    
     +,   0.2490901    ,   0.2582276    ,   0.2678646    
     +,   0.2779945    ,   0.2886009    ,   0.2996596    
     +,   0.3111373    ,   0.3229946    ,   0.3351858    
     +,   0.3476613    ,   0.3603708    ,   0.3732643    
     +,   0.3862928    ,   0.3994115    ,   0.4125781    
     +,   0.4257553    ,   0.4389047    ,   0.4519906    
     +,   0.4649731    ,   0.4778076    ,   0.4904410    
     +,   0.5028088    ,   0.5148342    ,   0.5264264    
     +,   0.5374804    ,   0.5478801    ,   0.5574985    
     +,   0.5662037    ,   0.5738609    ,   0.5803400    
     +,   0.5855184    ,   0.5892866    ,   0.5915532    
     +,   0.5922483    ,   0.5913231    ,   0.5887540    
     +,   0.5845436    ,   0.5787148    ,   0.5713152    
     +,   0.5624084    ,   0.5520768    ,   0.5404145    
     +,   0.5275253    ,   0.5135232    ,   0.4985248    
     +,   0.4826513    ,   0.4660268    ,   0.4487752    
     +,   0.4310203    ,   0.4128872    ,   0.3944982    
     +,   0.3759729    ,   0.3574264    ,   0.3389720    
     +,   0.3207137    ,   0.3027499    ,   0.2851677    
     +,   0.2680464    ,   0.2514542    ,   0.2354457    
     +,   0.2200650    ,   0.2053452    ,   0.1913077    
     +,   0.1779628    ,   0.1653131    ,   0.1533537    
     +,   0.1420720    ,   0.1314509    ,   0.1214700    
     +,   0.1121064    ,   0.1033350    ,   9.5130257E-02
     +,   8.7466978E-02,   8.0320366E-02,   7.3665768E-02
     +,   6.7479290E-02,   6.1738621E-02,   5.6421373E-02
     +,   5.1506009E-02,   4.6971753E-02,   4.2798180E-02
     +,   3.8964953E-02,   3.5452012E-02,   3.2239683E-02
     +,   2.9308587E-02,   2.6639339E-02,   2.4213005E-02
     +,   2.2011327E-02,   2.0016242E-02,   1.8210681E-02
     +,   1.6578026E-02,   1.5102759E-02,   1.3770052E-02
     +,   1.2566241E-02,   1.1478487E-02,   1.0495127E-02
     +,   9.6053546E-03,   8.7994821E-03,   8.0686957E-03
     +,   7.4050808E-03,   6.8016271E-03,   6.2520425E-03
     +,   5.7508070E-03,   5.2929935E-03,   4.8743053E-03
     +,   4.4909148E-03,   4.1394937E-03,   3.8170689E-03
     +,   3.5210527E-03,   3.2491188E-03,   2.9992333E-03
     +,   2.7695503E-03,   2.5584460E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_hzonly_hatt110_mass = Yx/16.4613435
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_hzonly_hatt115_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  0.1427621    ,   0.1517357    
     +,   0.1607590    ,   0.1697853    ,   0.1787668    
     +,   0.1876557    ,   0.1964047    ,   0.2049676    
     +,   0.2133002    ,   0.2213607    ,   0.2291105    
     +,   0.2365140    ,   0.2435398    ,   0.2501601    
     +,   0.2563517    ,   0.2620955    ,   0.2673762    
     +,   0.2721825    ,   0.2765070    ,   0.2803451    
     +,   0.2836955    ,   0.2865596    ,   0.2889409    
     +,   0.2908452    ,   0.2922801    ,   0.2932552    
     +,   0.2937813    ,   0.2938710    ,   0.2935391    
     +,   0.2928013    ,   0.2916757    ,   0.2901827    
     +,   0.2883431    ,   0.2861813    ,   0.2837212    
     +,   0.2809905    ,   0.2780161    ,   0.2748272    
     +,   0.2714525    ,   0.2679214    ,   0.2642632    
     +,   0.2605061    ,   0.2566783    ,   0.2528066    
     +,   0.2489172    ,   0.2450349    ,   0.2411839    
     +,   0.2373876    ,   0.2336686    ,   0.2300499    
     +,   0.2265539    ,   0.2232024    ,   0.2200181    
     +,   0.2170230    ,   0.2142395    ,   0.2116886    
     +,   0.2093914    ,   0.2073666    ,   0.2056317    
     +,   0.2042014    ,   0.2030868    ,   0.2022960    
     +,   0.2018319    ,   0.2016934    ,   0.2018742    
     +,   0.2023625    ,   0.2031416    ,   0.2041896    
     +,   0.2054803    ,   0.2069834    ,   0.2086647    
     +,   0.2104864    ,   0.2124104    ,   0.2143959    
     +,   0.2164023    ,   0.2183890    ,   0.2203170    
     +,   0.2221486    ,   0.2238491    ,   0.2253866    
     +,   0.2267322    ,   0.2278613    ,   0.2287524    
     +,   0.2293885    ,   0.2297561    ,   0.2298456    
     +,   0.2296509    ,   0.2291696    ,   0.2284020    
     +,   0.2273516    ,   0.2260241    ,   0.2244276    
     +,   0.2225727    ,   0.2204712    ,   0.2181366    
     +,   0.2155840    ,   0.2128292    ,   0.2098899    
     +,   0.2067840    ,   0.2035305    ,   0.2001492    
     +,   0.1966606    ,   0.1930856    ,   0.1894456    
     +,   0.1857622    ,   0.1820572    ,   0.1783525    
     +,   0.1746697    ,   0.1710299    ,   0.1674536    
     +,   0.1639606    ,   0.1605692    ,   0.1572971    
     +,   0.1541594    ,   0.1511704    ,   0.1483418    
     +,   0.1456836    ,   0.1432031    ,   0.1409057    
     +,   0.1387944    ,   0.1368695    ,   0.1351292    
     +,   0.1335695    ,   0.1321842    ,   0.1309653    
     +,   0.1299025    ,   0.1289846    ,   0.1281988    
     +,   0.1275313    ,   0.1269676    ,   0.1264926    
     +,   0.1260910    ,   0.1257476    ,   0.1254475    
     +,   0.1251764    ,   0.1249208    ,   0.1246678    
     +,   0.1244063    ,   0.1241258    ,   0.1238177    
     +,   0.1234744    ,   0.1230903    ,   0.1226610    
     +,   0.1221837    ,   0.1216571    ,   0.1210815    
     +,   0.1204585    ,   0.1197907    ,   0.1190826    
     +,   0.1183391    ,   0.1175665    ,   0.1167719    
     +,   0.1159631    ,   0.1151488    ,   0.1143380    
     +,   0.1135405    ,   0.1127662    ,   0.1120260    
     +,   0.1113305    ,   0.1106909    ,   0.1101188    
     +,   0.1096259    ,   0.1092241    ,   0.1089255    
     +,   0.1087428    ,   0.1086887    ,   0.1087759    
     +,   0.1090176    ,   0.1094269    ,   0.1100170    
     +,   0.1108014    ,   0.1117934    ,   0.1130058    
     +,   0.1144518    ,   0.1161439    ,   0.1180938    
     +,   0.1203134    ,   0.1228130    ,   0.1256024    
     +,   0.1286906    ,   0.1320854    ,   0.1357929    
     +,   0.1398185    ,   0.1441659    ,   0.1488378    
     +,   0.1538350    ,   0.1591568    ,   0.1648015    
     +,   0.1707657    ,   0.1770440    ,   0.1836305    
     +,   0.1905169    ,   0.1976939    ,   0.2051504    
     +,   0.2128734    ,   0.2208496    ,   0.2290622    
     +,   0.2374941    ,   0.2461265    ,   0.2549400    
     +,   0.2639133    ,   0.2730249    ,   0.2822535    
     +,   0.2915787    ,   0.3009800    ,   0.3104405    
     +,   0.3199441    ,   0.3294791    ,   0.3390356    
     +,   0.3486079    ,   0.3581945    ,   0.3677947    
     +,   0.3774107    ,   0.3870461    ,   0.3967040    
     +,   0.4063852    ,   0.4160878    ,   0.4258046    
     +,   0.4355242    ,   0.4452259    ,   0.4548815    
     +,   0.4644549    ,   0.4738996    ,   0.4831603    
     +,   0.4921713    ,   0.5008591    ,   0.5091389    
     +,   0.5169178    ,   0.5240963    ,   0.5305678    
     +,   0.5362197    ,   0.5409378    ,   0.5446076    
     +,   0.5471158    ,   0.5483586    ,   0.5482392    
     +,   0.5466774    ,   0.5436102    ,   0.5389951    
     +,   0.5328155    ,   0.5250792    ,   0.5158223    
     +,   0.5051075    ,   0.4930210    ,   0.4796746    
     +,   0.4651987    ,   0.4497404    ,   0.4334590    
     +,   0.4165183    ,   0.3990882    ,   0.3813347    
     +,   0.3634167    ,   0.3454869    ,   0.3276849    
     +,   0.3101351    ,   0.2929465    ,   0.2762130    
     +,   0.2600110    ,   0.2444007    ,   0.2294258    
     +,   0.2151173    ,   0.2014927    ,   0.1885578    
     +,   0.1763084    ,   0.1647334    ,   0.1538144    
     +,   0.1435280    ,   0.1338489    ,   0.1247486    
     +,   0.1161979    ,   0.1081667    ,   0.1006267    
     +,   9.3550093E-02,   8.6910009E-02,   8.0681361E-02
     +,   7.4841082E-02,   6.9367222E-02,   6.4239845E-02
     +,   5.9439931E-02,   5.4950349E-02,   5.0754584E-02
     +,   4.6837609E-02,   4.3184791E-02,   3.9782669E-02
     +,   3.6618013E-02,   3.3678513E-02,   3.0951999E-02
     +,   2.8426804E-02,   2.6091814E-02,   2.3935948E-02
     +,   2.1948762E-02,   2.0119842E-02,   1.8439319E-02
     +,   1.6897433E-02,   1.5484944E-02,   1.4192755E-02
     +,   1.3012282E-02,   1.1935147E-02,   1.0953476E-02
     +,   1.0059645E-02,   9.2465403E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_hzonly_hatt115_mass = Yx/15.7748821363636
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_hzonly_hatt120_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  9.3300149E-02,   9.9207260E-02
     +,   0.1052417    ,   0.1113853    ,   0.1176190    
     +,   0.1239230    ,   0.1302770    ,   0.1366605    
     +,   0.1430529    ,   0.1494342    ,   0.1557846    
     +,   0.1620856    ,   0.1683192    ,   0.1744689    
     +,   0.1805193    ,   0.1864564    ,   0.1922673    
     +,   0.1979406    ,   0.2034654    ,   0.2088319    
     +,   0.2140311    ,   0.2190541    ,   0.2238921    
     +,   0.2285369    ,   0.2329788    ,   0.2372088    
     +,   0.2412173    ,   0.2449941    ,   0.2485288    
     +,   0.2518113    ,   0.2548314    ,   0.2575803    
     +,   0.2600494    ,   0.2622324    ,   0.2641244    
     +,   0.2657233    ,   0.2670296    ,   0.2680464    
     +,   0.2687805    ,   0.2692421    ,   0.2694442    
     +,   0.2694028    ,   0.2691374    ,   0.2686693    
     +,   0.2680226    ,   0.2672223    ,   0.2662942    
     +,   0.2652655    ,   0.2641620    ,   0.2630085    
     +,   0.2618288    ,   0.2606434    ,   0.2594713    
     +,   0.2583268    ,   0.2572209    ,   0.2561608    
     +,   0.2551490    ,   0.2541838    ,   0.2532596    
     +,   0.2523659    ,   0.2514900    ,   0.2506154    
     +,   0.2497237    ,   0.2487945    ,   0.2478076    
     +,   0.2467424    ,   0.2455797    ,   0.2443023    
     +,   0.2428954    ,   0.2413482    ,   0.2396531    
     +,   0.2378077    ,   0.2358125    ,   0.2336744    
     +,   0.2314027    ,   0.2290113    ,   0.2265179    
     +,   0.2239423    ,   0.2213071    ,   0.2186356    
     +,   0.2159525    ,   0.2132818    ,   0.2106473    
     +,   0.2080709    ,   0.2055728    ,   0.2031706    
     +,   0.2008788    ,   0.1987090    ,   0.1966693    
     +,   0.1947648    ,   0.1929964    ,   0.1913624    
     +,   0.1898581    ,   0.1884754    ,   0.1872042    
     +,   0.1860322    ,   0.1849452    ,   0.1839279    
     +,   0.1829645    ,   0.1820382    ,   0.1811331    
     +,   0.1802334    ,   0.1793240    ,   0.1783915    
     +,   0.1774239    ,   0.1764107    ,   0.1753441    
     +,   0.1742178    ,   0.1730276    ,   0.1717718    
     +,   0.1704504    ,   0.1690655    ,   0.1676209    
     +,   0.1661214    ,   0.1645734    ,   0.1629843    
     +,   0.1613611    ,   0.1597118    ,   0.1580442    
     +,   0.1563652    ,   0.1546816    ,   0.1529987    
     +,   0.1513211    ,   0.1496520    ,   0.1479931    
     +,   0.1463454    ,   0.1447077    ,   0.1430783    
     +,   0.1414541    ,   0.1398311    ,   0.1382046    
     +,   0.1365693    ,   0.1349196    ,   0.1332499    
     +,   0.1315546    ,   0.1298287    ,   0.1280676    
     +,   0.1262676    ,   0.1244257    ,   0.1225400    
     +,   0.1206097    ,   0.1186354    ,   0.1166184    
     +,   0.1145613    ,   0.1124682    ,   0.1103440    
     +,   0.1081945    ,   0.1060265    ,   0.1038480    
     +,   0.1016672    ,   9.9492878E-02,   9.7334586E-02
     +,   9.5202237E-02,   9.3105830E-02,   9.1055438E-02
     +,   8.9061514E-02,   8.7134339E-02,   8.5284106E-02
     +,   8.3520822E-02,   8.1854627E-02,   8.0295183E-02
     +,   7.8851916E-02,   7.7534214E-02,   7.6351084E-02
     +,   7.5311348E-02,   7.4423492E-02,   7.3695861E-02
     +,   7.3136419E-02,   7.2752886E-02,   7.2552584E-02
     +,   7.2542697E-02,   7.2729826E-02,   7.3120147E-02
     +,   7.3719420E-02,   7.4532703E-02,   7.5564474E-02
     +,   7.6818481E-02,   7.8297310E-02,   8.0002792E-02
     +,   8.1935734E-02,   8.4095798E-02,   8.6481400E-02
     +,   8.9089543E-02,   9.1916442E-02,   9.4956942E-02
     +,   9.8204866E-02,   0.1016529    ,   0.1052934    
     +,   0.1091181    ,   0.1131182    ,   0.1172854    
     +,   0.1216113    ,   0.1260884    ,   0.1307097    
     +,   0.1354694    ,   0.1403632    ,   0.1453876    
     +,   0.1505405    ,   0.1558209    ,   0.1612290    
     +,   0.1667654    ,   0.1724310    ,   0.1782270    
     +,   0.1841550    ,   0.1902149    ,   0.1964063    
     +,   0.2027287    ,   0.2091797    ,   0.2157561    
     +,   0.2224548    ,   0.2292722    ,   0.2362047    
     +,   0.2432488    ,   0.2504031    ,   0.2576674    
     +,   0.2650425    ,   0.2725316    ,   0.2801402    
     +,   0.2878747    ,   0.2957428    ,   0.3037522    
     +,   0.3119102    ,   0.3202220    ,   0.3286879    
     +,   0.3373042    ,   0.3460601    ,   0.3549358    
     +,   0.3639006    ,   0.3729146    ,   0.3819238    
     +,   0.3908632    ,   0.3996538    ,   0.4082066    
     +,   0.4164223    ,   0.4241939    ,   0.4314092    
     +,   0.4379550    ,   0.4437201    ,   0.4485990    
     +,   0.4524964    ,   0.4553310    ,   0.4570368    
     +,   0.4575676    ,   0.4568980    ,   0.4550230    
     +,   0.4519575    ,   0.4477366    ,   0.4424117    
     +,   0.4360487    ,   0.4287235    ,   0.4205196    
     +,   0.4115251    ,   0.4018273    ,   0.3915135    
     +,   0.3806655    ,   0.3693597    ,   0.3576673    
     +,   0.3456535    ,   0.3333761    ,   0.3208889    
     +,   0.3082422    ,   0.2954834    ,   0.2826577    
     +,   0.2698083    ,   0.2569812    ,   0.2442203    
     +,   0.2315702    ,   0.2190764    ,   0.2067837    
     +,   0.1947358    ,   0.1829741    ,   0.1715388    
     +,   0.1604659    ,   0.1497875    ,   0.1395304    
     +,   0.1297178    ,   0.1203660    ,   0.1114871    
     +,   0.1030868    ,   9.5166802E-02,   8.7723069E-02
     +,   8.0748320E-02,   7.4230887E-02,   6.8156593E-02
     +,   6.2508389E-02,   5.7267845E-02,   5.2414950E-02
     +,   4.7928810E-02,   4.3788824E-02,   3.9973736E-02
     +,   3.6463294E-02,   3.3237327E-02,   3.0276870E-02
     +,   2.7563473E-02,   2.5079984E-02,   2.2809826E-02
     +,   2.0737756E-02,   1.8849134E-02,   1.7130457E-02
     +,   1.5568819E-02,   1.4152279E-02
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_hzonly_hatt120_mass = Yx/14.1411040909091
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_hzonly_hatt60_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.7681157E-02,   3.0059457E-02
     +,   3.2568511E-02,   3.5208296E-02,   3.7978128E-02
     +,   4.0876530E-02,   4.3901198E-02,   4.7048874E-02
     +,   5.0315309E-02,   5.3695358E-02,   5.7182435E-02
     +,   6.0768835E-02,   6.4445436E-02,   6.8201683E-02
     +,   7.2025456E-02,   7.5903162E-02,   7.9819560E-02
     +,   8.3757922E-02,   8.7700009E-02,   9.1626376E-02
     +,   9.5516317E-02,   9.9348277E-02,   0.1031001    
     +,   0.1067496    ,   0.1102742    ,   0.1136524    
     +,   0.1168635    ,   0.1198879    ,   0.1227078    
     +,   0.1253075    ,   0.1276736    ,   0.1297948    
     +,   0.1316627    ,   0.1332712    ,   0.1346167    
     +,   0.1356977    ,   0.1365151    ,   0.1370713    
     +,   0.1373702    ,   0.1374169    ,   0.1372173    
     +,   0.1367781    ,   0.1361063    ,   0.1352092    
     +,   0.1340944    ,   0.1327700    ,   0.1312442    
     +,   0.1295260    ,   0.1276251    ,   0.1255522    
     +,   0.1233195    ,   0.1209402    ,   0.1184297    
     +,   0.1158046    ,   0.1130838    ,   0.1102874    
     +,   0.1074373    ,   0.1045565    ,   0.1016689    
     +,   9.8798819E-02,   9.5970772E-02,   9.3208529E-02
     +,   9.0535007E-02,   8.7971389E-02,   8.5536949E-02
     +,   8.3248734E-02,   8.1120774E-02,   7.9164580E-02
     +,   7.7388145E-02,   7.5796686E-02,   7.4392088E-02
     +,   7.3173538E-02,   7.2137244E-02,   7.1277179E-02
     +,   7.0585005E-02,   7.0050597E-02,   6.9662362E-02
     +,   6.9407627E-02,   6.9272876E-02,   6.9244072E-02
     +,   6.9307022E-02,   6.9447547E-02,   6.9651559E-02
     +,   6.9905564E-02,   7.0196338E-02,   7.0511416E-02
     +,   7.0838921E-02,   7.1167700E-02,   7.1487360E-02
     +,   7.1788274E-02,   7.2061740E-02,   7.2299674E-02
     +,   7.2494954E-02,   7.2641388E-02,   7.2733633E-02
     +,   7.2767220E-02,   7.2738715E-02,   7.2645552E-02
     +,   7.2486185E-02,   7.2259963E-02,   7.1967155E-02
     +,   7.1609080E-02,   7.1187697E-02,   7.0705891E-02
     +,   7.0167221E-02,   6.9575876E-02,   6.8936594E-02
     +,   6.8254612E-02,   6.7535445E-02,   6.6784851E-02
     +,   6.6008806E-02,   6.5213248E-02,   6.4404160E-02
     +,   6.3587382E-02,   6.2768690E-02,   6.1953444E-02
     +,   6.1146937E-02,   6.0354024E-02,   5.9579320E-02
     +,   5.8827091E-02,   5.8101188E-02,   5.7405252E-02
     +,   5.6742463E-02,   5.6115791E-02,   5.5527691E-02
     +,   5.4980449E-02,   5.4475963E-02,   5.4015890E-02
     +,   5.3601451E-02,   5.3233732E-02,   5.2913371E-02
     +,   5.2640807E-02,   5.2416090E-02,   5.2239105E-02
     +,   5.2109245E-02,   5.2025724E-02,   5.1987395E-02
     +,   5.1992804E-02,   5.2040126E-02,   5.2127294E-02
     +,   5.2251793E-02,   5.2410886E-02,   5.2601438E-02
     +,   5.2820064E-02,   5.3062987E-02,   5.3326171E-02
     +,   5.3605381E-02,   5.3895965E-02,   5.4193232E-02
     +,   5.4492202E-02,   5.4787800E-02,   5.5074923E-02
     +,   5.5348333E-02,   5.5603024E-02,   5.5833887E-02
     +,   5.6036163E-02,   5.6205351E-02,   5.6337226E-02
     +,   5.6428079E-02,   5.6474660E-02,   5.6474280E-02
     +,   5.6424983E-02,   5.6325417E-02,   5.6175068E-02
     +,   5.5974141E-02,   5.5723734E-02,   5.5425704E-02
     +,   5.5082753E-02,   5.4698367E-02,   5.4276787E-02
     +,   5.3822953E-02,   5.3342465E-02,   5.2841421E-02
     +,   5.2326396E-02,   5.1804386E-02,   5.1282473E-02
     +,   5.0768003E-02,   5.0268255E-02,   4.9790483E-02
     +,   4.9341612E-02,   4.8928294E-02,   4.8556719E-02
     +,   4.8232596E-02,   4.7961026E-02,   4.7746412E-02
     +,   4.7592431E-02,   4.7502097E-02,   4.7477543E-02
     +,   4.7520243E-02,   4.7630779E-02,   4.7809064E-02
     +,   4.8054285E-02,   4.8364952E-02,   4.8738945E-02
     +,   4.9173646E-02,   4.9665857E-02,   5.0211992E-02
     +,   5.0808083E-02,   5.1449880E-02,   5.2132890E-02
     +,   5.2852415E-02,   5.3603593E-02,   5.4381501E-02
     +,   5.5181194E-02,   5.5997569E-02,   5.6825664E-02
     +,   5.7660371E-02,   5.8496665E-02,   5.9329484E-02
     +,   6.0153749E-02,   6.0964417E-02,   6.1756350E-02
     +,   6.2524401E-02,   6.3263342E-02,   6.3967951E-02
     +,   6.4632930E-02,   6.5252855E-02,   6.5822318E-02
     +,   6.6335924E-02,   6.6788249E-02,   6.7173854E-02
     +,   6.7487568E-02,   6.7724168E-02,   6.7878775E-02
     +,   6.7946687E-02,   6.7923680E-02,   6.7805827E-02
     +,   6.7589775E-02,   6.7272723E-02,   6.6852450E-02
     +,   6.6327520E-02,   6.5697238E-02,   6.4961687E-02
     +,   6.4121708E-02,   6.3179128E-02,   6.2136509E-02
     +,   6.0997281E-02,   5.9765726E-02,   5.8446985E-02
     +,   5.7046730E-02,   5.5571388E-02,   5.4027990E-02
     +,   5.2424155E-02,   5.0767723E-02,   4.9066912E-02
     +,   4.7330216E-02,   4.5566265E-02,   4.3783523E-02
     +,   4.1990418E-02,   4.0195342E-02,   3.8406231E-02
     +,   3.6630649E-02,   3.4875866E-02,   3.3148654E-02
     +,   3.1455137E-02,   2.9800821E-02,   2.8190775E-02
     +,   2.6629373E-02,   2.5120290E-02,   2.3666555E-02
     +,   2.2270666E-02,   2.0934531E-02,   1.9659352E-02
     +,   1.8445835E-02,   1.7294256E-02,   1.6204327E-02
     +,   1.5175328E-02,   1.4206233E-02,   1.3295682E-02
     +,   1.2441955E-02,   1.1643104E-02,   1.0897023E-02
     +,   1.0201461E-02,   9.5539996E-03,   8.9521352E-03
     +,   8.3933910E-03,   7.8751901E-03,   7.3950374E-03
     +,   6.9504133E-03,   6.5389085E-03,   6.1581349E-03
     +,   5.8058365E-03,   5.4798150E-03,   5.1780180E-03
     +,   4.8984652E-03,   4.6393317E-03,   4.3988843E-03
     +,   4.1755065E-03,   3.9677224E-03,   3.7741447E-03
     +,   3.5935189E-03,   3.4246752E-03,   3.2665674E-03
     +,   3.1182200E-03,   2.9787733E-03,   2.8474280E-03
     +,   2.7234810E-03,   2.6062839E-03,   2.4952705E-03
     +,   2.3899185E-03,   2.2897730E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_hzonly_hatt60_mass = Yx/4.3149
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_hzonly_hatt65_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.1718001E-02,   3.3593826E-02
     +,   3.5506446E-02,   3.7454356E-02,   3.9436687E-02
     +,   4.1453220E-02,   4.3504413E-02,   4.5591455E-02
     +,   4.7716189E-02,   4.9881220E-02,   5.2089754E-02
     +,   5.4345645E-02,   5.6653518E-02,   5.9018590E-02
     +,   6.1446860E-02,   6.3945152E-02,   6.6521116E-02
     +,   6.9183484E-02,   7.1941853E-02,   7.4806988E-02
     +,   7.7790454E-02,   8.0904700E-02,   8.4162585E-02
     +,   8.7577038E-02,   9.1159984E-02,   9.4922282E-02
     +,   9.8871991E-02,   0.1030137    ,   0.1073470    
     +,   0.1118659    ,   0.1165572    ,   0.1214000    
     +,   0.1263651    ,   0.1314149    ,   0.1365036    
     +,   0.1415784    ,   0.1465807    ,   0.1514478    
     +,   0.1561157    ,   0.1605209    ,   0.1646040    
     +,   0.1683117    ,   0.1715993    ,   0.1744332    
     +,   0.1767917    ,   0.1786663    ,   0.1800620    
     +,   0.1809956    ,   0.1814958    ,   0.1816002    
     +,   0.1813532    ,   0.1808036    ,   0.1800013    
     +,   0.1789954    ,   0.1778305    ,   0.1765464    
     +,   0.1751749    ,   0.1737400    ,   0.1722565    
     +,   0.1707316    ,   0.1691640    ,   0.1675460    
     +,   0.1658649    ,   0.1641042    ,   0.1622457    
     +,   0.1602712    ,   0.1581640    ,   0.1559108    
     +,   0.1535022    ,   0.1509344    ,   0.1482091    
     +,   0.1453342    ,   0.1423233    ,   0.1391961    
     +,   0.1359764    ,   0.1326925    ,   0.1293755    
     +,   0.1260585    ,   0.1227750    ,   0.1195573    
     +,   0.1164372    ,   0.1134424    ,   0.1105977    
     +,   0.1079231    ,   0.1054336    ,   0.1031388    
     +,   0.1010429    ,   9.9144243E-02,   9.7436324E-02
     +,   9.5907457E-02,   9.4541833E-02,   9.3319923E-02
     +,   9.2219524E-02,   9.1216587E-02,   9.0286002E-02
     +,   8.9402795E-02,   8.8542819E-02,   8.7683745E-02
     +,   8.6805552E-02,   8.5891359E-02,   8.4927604E-02
     +,   8.3904564E-02,   8.2816027E-02,   8.1659630E-02
     +,   8.0436334E-02,   7.9150066E-02,   7.7807292E-02
     +,   7.6416686E-02,   7.4988097E-02,   7.3532261E-02
     +,   7.2060354E-02,   7.0583232E-02,   6.9111258E-02
     +,   6.7653723E-02,   6.6218913E-02,   6.4813651E-02
     +,   6.3443609E-02,   6.2112857E-02,   6.0824487E-02
     +,   5.9580322E-02,   5.8381271E-02,   5.7227675E-02
     +,   5.6119256E-02,   5.5055305E-02,   5.4035109E-02
     +,   5.3057875E-02,   5.2122898E-02,   5.1229693E-02
     +,   5.0377980E-02,   4.9567785E-02,   4.8799314E-02
     +,   4.8073076E-02,   4.7389667E-02,   4.6749864E-02
     +,   4.6154447E-02,   4.5604166E-02,   4.5099791E-02
     +,   4.4641845E-02,   4.4230685E-02,   4.3866407E-02
     +,   4.3548942E-02,   4.3277882E-02,   4.3052483E-02
     +,   4.2871833E-02,   4.2734709E-02,   4.2639554E-02
     +,   4.2584714E-02,   4.2568237E-02,   4.2588063E-02
     +,   4.2641949E-02,   4.2727601E-02,   4.2842563E-02
     +,   4.2984378E-02,   4.3150567E-02,   4.3338582E-02
     +,   4.3545961E-02,   4.3770235E-02,   4.4008952E-02
     +,   4.4259802E-02,   4.4520468E-02,   4.4788782E-02
     +,   4.5062661E-02,   4.5340110E-02,   4.5619268E-02
     +,   4.5898452E-02,   4.6176065E-02,   4.6450689E-02
     +,   4.6720996E-02,   4.6985913E-02,   4.7244430E-02
     +,   4.7495719E-02,   4.7739096E-02,   4.7974005E-02
     +,   4.8200056E-02,   4.8416886E-02,   4.8624244E-02
     +,   4.8822012E-02,   4.9010091E-02,   4.9188405E-02
     +,   4.9356937E-02,   4.9515642E-02,   4.9664471E-02
     +,   4.9803372E-02,   4.9932212E-02,   5.0050877E-02
     +,   5.0159149E-02,   5.0256811E-02,   5.0343510E-02
     +,   5.0418939E-02,   5.0482709E-02,   5.0534356E-02
     +,   5.0573427E-02,   5.0599471E-02,   5.0611969E-02
     +,   5.0610419E-02,   5.0594337E-02,   5.0563235E-02
     +,   5.0516639E-02,   5.0454065E-02,   5.0375089E-02
     +,   5.0279286E-02,   5.0166257E-02,   5.0035559E-02
     +,   4.9886819E-02,   4.9719650E-02,   4.9533609E-02
     +,   4.9328294E-02,   4.9103275E-02,   4.8858106E-02
     +,   4.8592295E-02,   4.8305362E-02,   4.7996797E-02
     +,   4.7666144E-02,   4.7312841E-02,   4.6936385E-02
     +,   4.6536334E-02,   4.6112243E-02,   4.5663748E-02
     +,   4.5190509E-02,   4.4692323E-02,   4.4169068E-02
     +,   4.3620743E-02,   4.3047484E-02,   4.2449594E-02
     +,   4.1827504E-02,   4.1181780E-02,   4.0513195E-02
     +,   3.9822724E-02,   3.9111421E-02,   3.8380519E-02
     +,   3.7631441E-02,   3.6865737E-02,   3.6085047E-02
     +,   3.5291083E-02,   3.4485761E-02,   3.3670947E-02
     +,   3.2848574E-02,   3.2020651E-02,   3.1189157E-02
     +,   3.0356046E-02,   2.9523209E-02,   2.8692530E-02
     +,   2.7865838E-02,   2.7044807E-02,   2.6231017E-02
     +,   2.5425995E-02,   2.4631169E-02,   2.3847740E-02
     +,   2.3076836E-02,   2.2319498E-02,   2.1576583E-02
     +,   2.0848816E-02,   2.0136850E-02,   1.9441221E-02
     +,   1.8762300E-02,   1.8100359E-02,   1.7455617E-02
     +,   1.6828202E-02,   1.6218128E-02,   1.5625313E-02
     +,   1.5049674E-02,   1.4491065E-02,   1.3949246E-02
     +,   1.3423945E-02,   1.2914905E-02,   1.2421788E-02
     +,   1.1944242E-02,   1.1481919E-02,   1.1034473E-02
     +,   1.0601504E-02,   1.0182621E-02,   9.7774575E-03
     +,   9.3856519E-03,   9.0068113E-03,   8.6405668E-03
     +,   8.2865758E-03,   7.9444721E-03,   7.6139318E-03
     +,   7.2946101E-03,   6.9862097E-03,   6.6884034E-03
     +,   6.4009177E-03,   6.1234459E-03,   5.8557363E-03
     +,   5.5975020E-03,   5.3485096E-03,   5.1085032E-03
     +,   4.8772376E-03,   4.6544946E-03,   4.4400413E-03
     +,   4.2336700E-03,   4.0351581E-03,   3.8443101E-03
     +,   3.6609105E-03,   3.4847734E-03,   3.3156900E-03
     +,   3.1534794E-03,   2.9979397E-03,   2.8488943E-03
     +,   2.7061447E-03,   2.5695169E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_hzonly_hatt65_mass = Yx/4.64810616666667
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_hzonly_hatt70_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.0219477E-02,   2.1147305E-02
     +,   2.2075938E-02,   2.3001673E-02,   2.3920676E-02
     +,   2.4829092E-02,   2.5723120E-02,   2.6599085E-02
     +,   2.7453553E-02,   2.8283508E-02,   2.9086420E-02
     +,   2.9860467E-02,   3.0604713E-02,   3.1319302E-02
     +,   3.2005683E-02,   3.2666780E-02,   3.3307273E-02
     +,   3.3933681E-02,   3.4554683E-02,   3.5181113E-02
     +,   3.5826109E-02,   3.6505155E-02,   3.7236013E-02
     +,   3.8038623E-02,   3.8934849E-02,   3.9948352E-02
     +,   4.1104037E-02,   4.2427775E-02,   4.3945890E-02
     +,   4.5684591E-02,   4.7669500E-02,   4.9925130E-02
     +,   5.2474294E-02,   5.5337775E-02,   5.8533862E-02
     +,   6.2078055E-02,   6.5982841E-02,   7.0257455E-02
     +,   7.4908115E-02,   7.9937011E-02,   8.5343316E-02
     +,   9.1121972E-02,   9.7263522E-02,   0.1037537    
     +,   0.1105725    ,   0.1176931    ,   0.1250809    
     +,   0.1326927    ,   0.1404753    ,   0.1483654    
     +,   0.1562894    ,   0.1641641    ,   0.1718980    
     +,   0.1793942    ,   0.1865519    ,   0.1932727    
     +,   0.1994625    ,   0.2050373    ,   0.2099269    
     +,   0.2140784    ,   0.2174592    ,   0.2200584    
     +,   0.2218872    ,   0.2229786    ,   0.2233839    
     +,   0.2231713    ,   0.2224212    ,   0.2212227    
     +,   0.2196683    ,   0.2178509    ,   0.2158592    
     +,   0.2137753    ,   0.2116700    ,   0.2096033    
     +,   0.2076206    ,   0.2057532    ,   0.2040170    
     +,   0.2024147    ,   0.2009349    ,   0.1995546    
     +,   0.1982412    ,   0.1969544    ,   0.1956498    
     +,   0.1942803    ,   0.1928000    ,   0.1911652    
     +,   0.1893379    ,   0.1872865    ,   0.1849875    
     +,   0.1824257    ,   0.1795951    ,   0.1764981    
     +,   0.1731446    ,   0.1695522    ,   0.1657440    
     +,   0.1617486    ,   0.1575972    ,   0.1533246    
     +,   0.1489659    ,   0.1445571    ,   0.1401327    
     +,   0.1357259    ,   0.1313671    ,   0.1270837    
     +,   0.1228988    ,   0.1188311    ,   0.1148954    
     +,   0.1111014    ,   0.1074543    ,   0.1039551    
     +,   0.1006013    ,   9.7386979E-02,   9.4304040E-02
     +,   9.1342472E-02,   8.8491790E-02,   8.5741051E-02
     +,   8.3080254E-02,   8.0500357E-02,   7.7994250E-02
     +,   7.5556546E-02,   7.3184095E-02,   7.0875965E-02
     +,   6.8633109E-02,   6.6458240E-02,   6.4355165E-02
     +,   6.2328976E-02,   6.0384851E-02,   5.8528204E-02
     +,   5.6763705E-02,   5.5095404E-02,   5.3525984E-02
     +,   5.2056983E-02,   5.0688103E-02,   4.9417872E-02
     +,   4.8243079E-02,   4.7159199E-02,   4.6160709E-02
     +,   4.5241099E-02,   4.4393219E-02,   4.3609548E-02
     +,   4.2882603E-02,   4.2205039E-02,   4.1569866E-02
     +,   4.0970758E-02,   4.0402096E-02,   3.9859105E-02
     +,   3.9337877E-02,   3.8835414E-02,   3.8349599E-02
     +,   3.7879132E-02,   3.7423410E-02,   3.6982518E-02
     +,   3.6557101E-02,   3.6148198E-02,   3.5757139E-02
     +,   3.5385523E-02,   3.5035096E-02,   3.4707591E-02
     +,   3.4404710E-02,   3.4128070E-02,   3.3879172E-02
     +,   3.3659332E-02,   3.3469681E-02,   3.3311147E-02
     +,   3.3184502E-02,   3.3090241E-02,   3.3028811E-02
     +,   3.3000417E-02,   3.3005182E-02,   3.3043131E-02
     +,   3.3114180E-02,   3.3218224E-02,   3.3355132E-02
     +,   3.3524740E-02,   3.3726878E-02,   3.3961400E-02
     +,   3.4228165E-02,   3.4527019E-02,   3.4857783E-02
     +,   3.5220291E-02,   3.5614286E-02,   3.6039520E-02
     +,   3.6495518E-02,   3.6981773E-02,   3.7497580E-02
     +,   3.8041990E-02,   3.8613848E-02,   3.9211731E-02
     +,   3.9833967E-02,   4.0478479E-02,   4.1142896E-02
     +,   4.1824549E-02,   4.2520359E-02,   4.3226913E-02
     +,   4.3940540E-02,   4.4657268E-02,   4.5372840E-02
     +,   4.6082743E-02,   4.6782348E-02,   4.7466949E-02
     +,   4.8131723E-02,   4.8771851E-02,   4.9382649E-02
     +,   4.9959566E-02,   5.0498195E-02,   5.0994407E-02
     +,   5.1444426E-02,   5.1844835E-02,   5.2192494E-02
     +,   5.2484825E-02,   5.2719694E-02,   5.2895300E-02
     +,   5.3010393E-02,   5.3064164E-02,   5.3056214E-02
     +,   5.2986514E-02,   5.2855499E-02,   5.2663900E-02
     +,   5.2412685E-02,   5.2103218E-02,   5.1736977E-02
     +,   5.1315632E-02,   5.0841007E-02,   5.0315082E-02
     +,   4.9739838E-02,   4.9117312E-02,   4.8449602E-02
     +,   4.7738846E-02,   4.6987109E-02,   4.6196450E-02
     +,   4.5368999E-02,   4.4506866E-02,   4.3612100E-02
     +,   4.2686760E-02,   4.1733049E-02,   4.0753052E-02
     +,   3.9748922E-02,   3.8722921E-02,   3.7677351E-02
     +,   3.6614511E-02,   3.5536755E-02,   3.4446549E-02
     +,   3.3346433E-02,   3.2238927E-02,   3.1126555E-02
     +,   3.0011961E-02,   2.8897816E-02,   2.7786676E-02
     +,   2.6681108E-02,   2.5583744E-02,   2.4497040E-02
     +,   2.3423396E-02,   2.2365179E-02,   2.1324651E-02
     +,   2.0303885E-02,   1.9304812E-02,   1.8329293E-02
     +,   1.7379016E-02,   1.6455431E-02,   1.5559833E-02
     +,   1.4693385E-02,   1.3857060E-02,   1.3051608E-02
     +,   1.2277585E-02,   1.1535453E-02,   1.0825428E-02
     +,   1.0147557E-02,   9.5017711E-03,   8.8878553E-03
     +,   8.3054090E-03,   7.7539072E-03,   7.2327484E-03
     +,   6.7412131E-03,   6.2784632E-03,   5.8435793E-03
     +,   5.4356167E-03,   5.0535188E-03,   4.6962355E-03
     +,   4.3626362E-03,   4.0516118E-03,   3.7619972E-03
     +,   3.4926659E-03,   3.2424605E-03,   3.0102709E-03
     +,   2.7949759E-03,   2.5955103E-03,   2.4108214E-03
     +,   2.2398944E-03,   2.0817721E-03,   1.9355190E-03
     +,   1.8002662E-03,   1.6751728E-03,   1.5594632E-03
     +,   1.4523948E-03,   1.3532876E-03,   1.2614946E-03
     +,   1.1764287E-03,   1.0975351E-03,   1.0243127E-03
     +,   9.5629162E-04,   8.9305016E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_hzonly_hatt70_mass = Yx/4.86624833333333
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_hzonly_hatt75_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.1585661E-02,   1.2339215E-02
     +,   1.3137208E-02,   1.3980933E-02,   1.4871429E-02
     +,   1.5809432E-02,   1.6795361E-02,   1.7829286E-02
     +,   1.8910898E-02,   2.0039553E-02,   2.1214189E-02
     +,   2.2433383E-02,   2.3695396E-02,   2.4998149E-02
     +,   2.6339311E-02,   2.7716309E-02,   2.9126415E-02
     +,   3.0566752E-02,   3.2034408E-02,   3.3526387E-02
     +,   3.5039783E-02,   3.6571667E-02,   3.8119182E-02
     +,   3.9679661E-02,   4.1250315E-02,   4.2828687E-02
     +,   4.4412255E-02,   4.5998715E-02,   4.7585886E-02
     +,   4.9171917E-02,   5.0755206E-02,   5.2334826E-02
     +,   5.3910512E-02,   5.5483114E-02,   5.7054710E-02
     +,   5.8629256E-02,   6.0212858E-02,   6.1814141E-02
     +,   6.3444965E-02,   6.5120429E-02,   6.6859715E-02
     +,   6.8685934E-02,   7.0626438E-02,   7.2712623E-02
     +,   7.4979566E-02,   7.7465191E-02,   8.0209248E-02
     +,   8.3251625E-02,   8.6630382E-02,   9.0379424E-02
     +,   9.4525695E-02,   9.9086754E-02,   0.1040679    
     +,   0.1094605    ,   0.1152404    ,   0.1213684    
     +,   0.1277913    ,   0.1344444    ,   0.1412565    
     +,   0.1481548    ,   0.1550707    ,   0.1619468    
     +,   0.1687413    ,   0.1754333    ,   0.1820239    
     +,   0.1885362    ,   0.1950135    ,   0.2015128    
     +,   0.2081002    ,   0.2148405    ,   0.2217912    
     +,   0.2289918    ,   0.2364588    ,   0.2441779    
     +,   0.2521006    ,   0.2601420    ,   0.2681806    
     +,   0.2760609    ,   0.2836012    ,   0.2906007    
     +,   0.2968526    ,   0.3021571    ,   0.3063398    
     +,   0.3092650    ,   0.3108517    ,   0.3110822    
     +,   0.3100082    ,   0.3077474    ,   0.3044738    
     +,   0.3004031    ,   0.2957709    ,   0.2908094    
     +,   0.2857260    ,   0.2806830    ,   0.2757859    
     +,   0.2710770    ,   0.2665375    ,   0.2620984    
     +,   0.2576552    ,   0.2530862    ,   0.2482722    
     +,   0.2431145    ,   0.2375479    ,   0.2315496    
     +,   0.2251409    ,   0.2183837    ,   0.2113736    
     +,   0.2042272    ,   0.1970689    ,   0.1900188    
     +,   0.1831820    ,   0.1766388    ,   0.1704412    
     +,   0.1646101    ,   0.1591393    ,   0.1539971    
     +,   0.1491353    ,   0.1444940    ,   0.1400101    
     +,   0.1356230    ,   0.1312799    ,   0.1269396    
     +,   0.1225750    ,   0.1181733    ,   0.1137356    
     +,   0.1092760    ,   0.1048184    ,   0.1003952    
     +,   9.6042819E-02,   9.1801062E-02,   8.7708734E-02
     +,   8.3803162E-02,   8.0117248E-02,   7.6679088E-02
     +,   7.3510453E-02,   7.0626587E-02,   6.8036310E-02
     +,   6.5741971E-02,   6.3739523E-02,   6.2019721E-02
     +,   6.0568571E-02,   5.9368204E-02,   5.8397777E-02
     +,   5.7634246E-02,   5.7053361E-02,   5.6630280E-02
     +,   5.6340277E-02,   5.6159336E-02,   5.6064598E-02
     +,   5.6034580E-02,   5.6049500E-02,   5.6091424E-02
     +,   5.6144234E-02,   5.6193590E-02,   5.6227084E-02
     +,   5.6233827E-02,   5.6204665E-02,   5.6131802E-02
     +,   5.6008913E-02,   5.5830918E-02,   5.5594049E-02
     +,   5.5295713E-02,   5.4934409E-02,   5.4509930E-02
     +,   5.4023072E-02,   5.3475820E-02,   5.2871194E-02
     +,   5.2213356E-02,   5.1507477E-02,   5.0759587E-02
     +,   4.9976707E-02,   4.9166564E-02,   4.8337556E-02
     +,   4.7498491E-02,   4.6658657E-02,   4.5827355E-02
     +,   4.5013964E-02,   4.4227693E-02,   4.3477394E-02
     +,   4.2771373E-02,   4.2117234E-02,   4.1521844E-02
     +,   4.0991101E-02,   4.0529884E-02,   4.0141914E-02
     +,   3.9829813E-02,   3.9595004E-02,   3.9437663E-02
     +,   3.9356820E-02,   3.9350338E-02,   3.9414994E-02
     +,   3.9546542E-02,   3.9739817E-02,   3.9988771E-02
     +,   4.0286705E-02,   4.0626276E-02,   4.0999681E-02
     +,   4.1398752E-02,   4.1815147E-02,   4.2240422E-02
     +,   4.2666137E-02,   4.3084040E-02,   4.3486159E-02
     +,   4.3864921E-02,   4.4213161E-02,   4.4524327E-02
     +,   4.4792470E-02,   4.5012336E-02,   4.5179382E-02
     +,   4.5289852E-02,   4.5340762E-02,   4.5329936E-02
     +,   4.5255944E-02,   4.5118157E-02,   4.4916637E-02
     +,   4.4652145E-02,   4.4326127E-02,   4.3940607E-02
     +,   4.3498043E-02,   4.3001484E-02,   4.2454273E-02
     +,   4.1860092E-02,   4.1222923E-02,   4.0546890E-02
     +,   3.9836247E-02,   3.9095245E-02,   3.8328223E-02
     +,   3.7539419E-02,   3.6732946E-02,   3.5912789E-02
     +,   3.5082772E-02,   3.4246530E-02,   3.3407439E-02
     +,   3.2568555E-02,   3.1732827E-02,   3.0902851E-02
     +,   3.0080931E-02,   2.9269164E-02,   2.8469404E-02
     +,   2.7683184E-02,   2.6911803E-02,   2.6156383E-02
     +,   2.5417807E-02,   2.4696726E-02,   2.3993606E-02
     +,   2.3308750E-02,   2.2642335E-02,   2.1994330E-02
     +,   2.1364575E-02,   2.0752857E-02,   2.0158801E-02
     +,   1.9581944E-02,   1.9021776E-02,   1.8477740E-02
     +,   1.7949173E-02,   1.7435392E-02,   1.6935712E-02
     +,   1.6449431E-02,   1.5975811E-02,   1.5514120E-02
     +,   1.5063666E-02,   1.4623778E-02,   1.4193787E-02
     +,   1.3773060E-02,   1.3361040E-02,   1.2957178E-02
     +,   1.2560979E-02,   1.2172021E-02,   1.1789931E-02
     +,   1.1414378E-02,   1.1045075E-02,   1.0681817E-02
     +,   1.0324455E-02,   9.9728601E-03,   9.6269529E-03
     +,   9.2867399E-03,   8.9522051E-03,   8.6234296E-03
     +,   8.3004721E-03,   7.9834592E-03,   7.6725082E-03
     +,   7.3677739E-03,   7.0693986E-03,   6.7775641E-03
     +,   6.4924150E-03,   6.2141367E-03,   5.9428723E-03
     +,   5.6787631E-03,   5.4219640E-03,   5.1725740E-03
     +,   4.9307137E-03,   4.6964525E-03,   4.4698664E-03
     +,   4.2509804E-03,   4.0398301E-03,   3.8363957E-03
     +,   3.6406654E-03,   3.4525795E-03,   3.2720782E-03
     +,   3.0990602E-03,   2.9334293E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_hzonly_hatt75_mass = Yx/5.770611
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_hzonly_hatt80_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.3431966E-02,   1.3869950E-02
     +,   1.4311147E-02,   1.4755890E-02,   1.5204645E-02
     +,   1.5658014E-02,   1.6116733E-02,   1.6581688E-02
     +,   1.7053884E-02,   1.7534481E-02,   1.8024744E-02
     +,   1.8526062E-02,   1.9039933E-02,   1.9567924E-02
     +,   2.0111701E-02,   2.0672968E-02,   2.1253480E-02
     +,   2.1854991E-02,   2.2479281E-02,   2.3128077E-02
     +,   2.3803104E-02,   2.4506008E-02,   2.5238363E-02
     +,   2.6001731E-02,   2.6797494E-02,   2.7627051E-02
     +,   2.8491650E-02,   2.9392509E-02,   3.0330757E-02
     +,   3.1307507E-02,   3.2323822E-02,   3.3380773E-02
     +,   3.4479406E-02,   3.5620809E-02,   3.6806054E-02
     +,   3.8036257E-02,   3.9312504E-02,   4.0635832E-02
     +,   4.2007234E-02,   4.3427445E-02,   4.4897046E-02
     +,   4.6416275E-02,   4.7984980E-02,   4.9602553E-02
     +,   5.1267914E-02,   5.2979529E-02,   5.4735541E-02
     +,   5.6533810E-02,   5.8372345E-02,   6.0249560E-02
     +,   6.2164642E-02,   6.4118177E-02,   6.6112548E-02
     +,   6.8152711E-02,   7.0246309E-02,   7.2404295E-02
     +,   7.4640989E-02,   7.6974064E-02,   7.9424337E-02
     +,   8.2015149E-02,   8.4771678E-02,   8.7720178E-02
     +,   9.0886809E-02,   9.4297148E-02,   9.7975656E-02
     +,   0.1019446    ,   0.1062252    ,   0.1108371    
     +,   0.1157999    ,   0.1211330    ,   0.1268579    
     +,   0.1329977    ,   0.1395789    ,   0.1466303    
     +,   0.1541851    ,   0.1622791    ,   0.1709518    
     +,   0.1802455    ,   0.1902063    ,   0.2008828    
     +,   0.2123236    ,   0.2245760    ,   0.2376778    
     +,   0.2516529    ,   0.2664969    ,   0.2821707    
     +,   0.2985849    ,   0.3155968    ,   0.3330016    
     +,   0.3505423    ,   0.3679194    ,   0.3848100    
     +,   0.4008940    ,   0.4158855    ,   0.4295534    
     +,   0.4417407    ,   0.4523755    ,   0.4614642    
     +,   0.4690825    ,   0.4753557    ,   0.4804375    
     +,   0.4844952    ,   0.4876939    ,   0.4901859    
     +,   0.4921054    ,   0.4935615    ,   0.4946261    
     +,   0.4953246    ,   0.4956264    ,   0.4954385    
     +,   0.4946111    ,   0.4929500    ,   0.4902426    
     +,   0.4862851    ,   0.4809075    ,   0.4739912    
     +,   0.4654755    ,   0.4553516    ,   0.4436516    
     +,   0.4304335    ,   0.4157739    ,   0.3997674    
     +,   0.3825336    ,   0.3642241    ,   0.3450328    
     +,   0.3252014    ,   0.3050084    ,   0.2847618    
     +,   0.2647741    ,   0.2453485    ,   0.2267538    
     +,   0.2092159    ,   0.1929050    ,   0.1779373    
     +,   0.1643739    ,   0.1522268    ,   0.1414670    
     +,   0.1320306    ,   0.1238255    ,   0.1167398    
     +,   0.1106489    ,   0.1054213    ,   0.1009244    
     +,   9.7030468E-02,   9.3621589E-02,   9.0592407E-02
     +,   8.7853037E-02,   8.5330322E-02,   8.2967997E-02
     +,   8.0725096E-02,   7.8574970E-02,   7.6502606E-02
     +,   7.4502520E-02,   7.2575927E-02,   7.0728570E-02
     +,   6.8969063E-02,   6.7307137E-02,   6.5752372E-02
     +,   6.4313591E-02,   6.2998272E-02,   6.1812341E-02
     +,   6.0759824E-02,   5.9843175E-02,   5.9063207E-02
     +,   5.8419079E-02,   5.7908542E-02,   5.7528142E-02
     +,   5.7273243E-02,   5.7138249E-02,   5.7116713E-02
     +,   5.7201482E-02,   5.7384986E-02,   5.7659145E-02
     +,   5.8015823E-02,   5.8446635E-02,   5.8943372E-02
     +,   5.9497911E-02,   6.0102373E-02,   6.0749192E-02
     +,   6.1431263E-02,   6.2141772E-02,   6.2874451E-02
     +,   6.3623309E-02,   6.4382926E-02,   6.5148257E-02
     +,   6.5914512E-02,   6.6677324E-02,   6.7432590E-02
     +,   6.8176433E-02,   6.8905078E-02,   6.9615036E-02
     +,   7.0302710E-02,   7.0964582E-02,   7.1597084E-02
     +,   7.2196595E-02,   7.2759479E-02,   7.3281750E-02
     +,   7.3759377E-02,   7.4188277E-02,   7.4564107E-02
     +,   7.4882448E-02,   7.5138777E-02,   7.5328596E-02
     +,   7.5447381E-02,   7.5490765E-02,   7.5454585E-02
     +,   7.5334944E-02,   7.5128429E-02,   7.4832037E-02
     +,   7.4443460E-02,   7.3961064E-02,   7.3384032E-02
     +,   7.2712407E-02,   7.1947202E-02,   7.1090348E-02
     +,   7.0144825E-02,   6.9114596E-02,   6.8004534E-02
     +,   6.6820309E-02,   6.5568604E-02,   6.4256586E-02
     +,   6.2892057E-02,   6.1483234E-02,   6.0038678E-02
     +,   5.8566958E-02,   5.7076458E-02,   5.5575587E-02
     +,   5.4072253E-02,   5.2573826E-02,   5.1087029E-02
     +,   4.9617935E-02,   4.8171774E-02,   4.6752870E-02
     +,   4.5364648E-02,   4.4009738E-02,   4.2689819E-02
     +,   4.1405693E-02,   4.0157512E-02,   3.8944714E-02
     +,   3.7766110E-02,   3.6619965E-02,   3.5504267E-02
     +,   3.4416717E-02,   3.3354726E-02,   3.2315705E-02
     +,   3.1297110E-02,   3.0296493E-02,   2.9311543E-02
     +,   2.8340178E-02,   2.7380701E-02,   2.6431644E-02
     +,   2.5491875E-02,   2.4560686E-02,   2.3637712E-02
     +,   2.2722885E-02,   2.1816425E-02,   2.0918934E-02
     +,   2.0031257E-02,   1.9154396E-02,   1.8289536E-02
     +,   1.7438060E-02,   1.6601430E-02,   1.5781118E-02
     +,   1.4978607E-02,   1.4195431E-02,   1.3432990E-02
     +,   1.2692601E-02,   1.1975526E-02,   1.1282880E-02
     +,   1.0615597E-02,   9.9744471E-03,   9.3600834E-03
     +,   8.7729786E-03,   8.2134027E-03,   7.6814583E-03
     +,   7.1771350E-03,   6.7002070E-03,   6.2503642E-03
     +,   5.8271075E-03,   5.4298704E-03,   5.0579323E-03
     +,   4.7105257E-03,   4.3867594E-03,   4.0857205E-03
     +,   3.8064024E-03,   3.5477991E-03,   3.3088485E-03
     +,   3.0884771E-03,   2.8856257E-03,   2.6992115E-03
     +,   2.5281901E-03,   2.3715135E-03,   2.2281799E-03
     +,   2.0972004E-03,   1.9776388E-03,   1.8685827E-03
     +,   1.7691763E-03,   1.6785949E-03,   1.5960701E-03
     +,   1.5208696E-03,   1.4523176E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_hzonly_hatt80_mass = Yx/8.0041395
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_hzonly_hatt85_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  9.1323303E-03,   9.4935801E-03
     +,   9.8594651E-03,   1.0229445E-02,   1.0602955E-02
     +,   1.0979403E-02,   1.1358188E-02,   1.1738689E-02
     +,   1.2120271E-02,   1.2502319E-02,   1.2884193E-02
     +,   1.3265265E-02,   1.3644913E-02,   1.4022546E-02
     +,   1.4397562E-02,   1.4769419E-02,   1.5137579E-02
     +,   1.5501544E-02,   1.5860861E-02,   1.6215108E-02
     +,   1.6563911E-02,   1.6906947E-02,   1.7243933E-02
     +,   1.7574660E-02,   1.7898928E-02,   1.8216634E-02
     +,   1.8527690E-02,   1.8832071E-02,   1.9129796E-02
     +,   1.9420922E-02,   1.9705540E-02,   1.9983778E-02
     +,   2.0255784E-02,   2.0521726E-02,   2.0781793E-02
     +,   2.1036165E-02,   2.1285040E-02,   2.1528581E-02
     +,   2.1766977E-02,   2.2000367E-02,   2.2228902E-02
     +,   2.2452697E-02,   2.2671858E-02,   2.2886503E-02
     +,   2.3096746E-02,   2.3302728E-02,   2.3504656E-02
     +,   2.3702817E-02,   2.3897624E-02,   2.4089659E-02
     +,   2.4279751E-02,   2.4469027E-02,   2.4658974E-02
     +,   2.4851562E-02,   2.5049277E-02,   2.5255281E-02
     +,   2.5473446E-02,   2.5708497E-02,   2.5966056E-02
     +,   2.6252763E-02,   2.6576316E-02,   2.6945516E-02
     +,   2.7370222E-02,   2.7861407E-02,   2.8431050E-02
     +,   2.9091915E-02,   2.9857516E-02,   3.0741705E-02
     +,   3.1758502E-02,   3.2921582E-02,   3.4244042E-02
     +,   3.5737742E-02,   3.7413146E-02,   3.9278544E-02
     +,   4.1340142E-02,   4.3601595E-02,   4.6063863E-02
     +,   4.8725422E-02,   5.1582720E-02,   5.4630630E-02
     +,   5.7862822E-02,   6.1273381E-02,   6.4856954E-02
     +,   6.8610616E-02,   7.2533920E-02,   7.6630853E-02
     +,   8.0909319E-02,   8.5383415E-02,   9.0072729E-02
     +,   9.5004670E-02,   0.1002145    ,   0.1057466    
     +,   0.1116552    ,   0.1180039    ,   0.1248637    
     +,   0.1323070    ,   0.1404019    ,   0.1492003    
     +,   0.1587301    ,   0.1689847    ,   0.1799236    
     +,   0.1914779    ,   0.2035726    ,   0.2161535    
     +,   0.2292271    ,   0.2428938    ,   0.2573694    
     +,   0.2729890    ,   0.2901839    ,   0.3094358    
     +,   0.3312125    ,   0.3559057    ,   0.3837580    
     +,   0.4148010    ,   0.4487751    ,   0.4850603    
     +,   0.5226102    ,   0.5599729    ,   0.5954202    
     +,   0.6272460    ,   0.6541606    ,   0.6756549    
     +,   0.6921797    ,   0.7050185    ,   0.7159107    
     +,   0.7265947    ,   0.7384721    ,   0.7524879    
     +,   0.7691386    ,   0.7884402    ,   0.8098149    
     +,   0.8319511    ,   0.8528932    ,   0.8704050    
     +,   0.8825319    ,   0.8880008    ,   0.8862339    
     +,   0.8769871    ,   0.8599160    ,   0.8344392    
     +,   0.8000559    ,   0.7569396    ,   0.7064224    
     +,   0.6510342    ,   0.5940639    ,   0.5388108    
     +,   0.4878991    ,   0.4428769    ,   0.4041729    
     +,   0.3713237    ,   0.3433284    ,   0.3189882    
     +,   0.2971667    ,   0.2769496    ,   0.2577230    
     +,   0.2391772    ,   0.2212610    ,   0.2041039    
     +,   0.1879319    ,   0.1729910    ,   0.1594884    
     +,   0.1475608    ,   0.1372675    ,   0.1285949    
     +,   0.1214717    ,   0.1157866    ,   0.1114033    
     +,   0.1081716    ,   0.1059350    ,   0.1045364    
     +,   0.1038218    ,   0.1036430    ,   0.1038589    
     +,   0.1043381    ,   0.1049599    ,   0.1056152    
     +,   0.1062077    ,   0.1066543    ,   0.1068856    
     +,   0.1068464    ,   0.1064954    ,   0.1058054    
     +,   0.1047625    ,   0.1033661    ,   0.1016269    
     +,   9.9566527E-02,   9.7215302E-02,   9.4610512E-02
     +,   9.1794506E-02,   8.8812903E-02,   8.5712172E-02
     +,   8.2538195E-02,   7.9334810E-02,   7.6142319E-02
     +,   7.2996542E-02,   6.9928087E-02,   6.6962533E-02
     +,   6.4119965E-02,   6.1415154E-02,   5.8858041E-02
     +,   5.6454428E-02,   5.4206457E-02,   5.2112881E-02
     +,   5.0169982E-02,   4.8372265E-02,   4.6712551E-02
     +,   4.5182597E-02,   4.3773551E-02,   4.2476155E-02
     +,   4.1280817E-02,   4.0178012E-02,   3.9158408E-02
     +,   3.8212907E-02,   3.7332695E-02,   3.6509398E-02
     +,   3.5735171E-02,   3.5002705E-02,   3.4305207E-02
     +,   3.3636510E-02,   3.2991137E-02,   3.2364175E-02
     +,   3.1751338E-02,   3.1149061E-02,   3.0554317E-02
     +,   2.9964658E-02,   2.9378155E-02,   2.8793408E-02
     +,   2.8209427E-02,   2.7625594E-02,   2.7041592E-02
     +,   2.6457399E-02,   2.5873195E-02,   2.5289310E-02
     +,   2.4706142E-02,   2.4124244E-02,   2.3544146E-02
     +,   2.2966370E-02,   2.2391468E-02,   2.1819983E-02
     +,   2.1252345E-02,   2.0688968E-02,   2.0130236E-02
     +,   1.9576520E-02,   1.9028082E-02,   1.8485175E-02
     +,   1.7948046E-02,   1.7416937E-02,   1.6892038E-02
     +,   1.6373543E-02,   1.5861686E-02,   1.5356671E-02
     +,   1.4858706E-02,   1.4368042E-02,   1.3884950E-02
     +,   1.3409677E-02,   1.2942477E-02,   1.2483650E-02
     +,   1.2033497E-02,   1.1592287E-02,   1.1160289E-02
     +,   1.0737790E-02,   1.0325073E-02,   9.9223638E-03
     +,   9.5298728E-03,   9.1478257E-03,   8.7763835E-03
     +,   8.4156757E-03,   8.0658207E-03,   7.7269110E-03
     +,   7.3989737E-03,   7.0820092E-03,   6.7759980E-03
     +,   6.4808950E-03,   6.1965953E-03,   5.9229713E-03
     +,   5.6598908E-03,   5.4071597E-03,   5.1645981E-03
     +,   4.9319724E-03,   4.7090566E-03,   4.4955853E-03
     +,   4.2913053E-03,   4.0959287E-03,   3.9091827E-03
     +,   3.7307648E-03,   3.5603957E-03,   3.3977728E-03
     +,   3.2425995E-03,   3.0945905E-03,   2.9534488E-03
     +,   2.8189002E-03,   2.6906568E-03,   2.5684549E-03
     +,   2.4520219E-03,   2.3411089E-03,   2.2354601E-03
     +,   2.1348423E-03,   2.0390174E-03,   1.9477695E-03
     +,   1.8608789E-03,   1.7781468E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_hzonly_hatt85_mass = Yx/9.62117458536585
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_hzonly_hatt90_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  6.6860863E-03,   6.8679759E-03
     +,   7.0455540E-03,   7.2182394E-03,   7.3854686E-03
     +,   7.5466968E-03,   7.7014039E-03,   7.8490973E-03
     +,   7.9893218E-03,   8.1216618E-03,   8.2457401E-03
     +,   8.3612306E-03,   8.4678587E-03,   8.5653979E-03
     +,   8.6536873E-03,   8.7326216E-03,   8.8021597E-03
     +,   8.8623259E-03,   8.9132031E-03,   8.9549515E-03
     +,   8.9877853E-03,   9.0119913E-03,   9.0279151E-03
     +,   9.0359682E-03,   9.0366229E-03,   9.0304008E-03
     +,   9.0178875E-03,   8.9997062E-03,   8.9765349E-03
     +,   8.9490833E-03,   8.9180972E-03,   8.8843554E-03
     +,   8.8486541E-03,   8.8118054E-03,   8.7746363E-03
     +,   8.7379692E-03,   8.7026274E-03,   8.6694239E-03
     +,   8.6391540E-03,   8.6125936E-03,   8.5904840E-03
     +,   8.5735386E-03,   8.5624261E-03,   8.5577788E-03
     +,   8.5601723E-03,   8.5701421E-03,   8.5881585E-03
     +,   8.6146500E-03,   8.6499806E-03,   8.6944643E-03
     +,   8.7483590E-03,   8.8118771E-03,   8.8851834E-03
     +,   8.9684008E-03,   9.0616187E-03,   9.1649033E-03
     +,   9.2782928E-03,   9.4018355E-03,   9.5355697E-03
     +,   9.6795568E-03,   9.8338882E-03,   9.9987034E-03
     +,   1.0174183E-02,   1.0360600E-02,   1.0558322E-02
     +,   1.0767789E-02,   1.0989579E-02,   1.1224383E-02
     +,   1.1473050E-02,   1.1736549E-02,   1.2016029E-02
     +,   1.2312775E-02,   1.2628254E-02,   1.2964074E-02
     +,   1.3322024E-02,   1.3704054E-02,   1.4112249E-02
     +,   1.4548842E-02,   1.5016236E-02,   1.5516975E-02
     +,   1.6053695E-02,   1.6629236E-02,   1.7246507E-02
     +,   1.7908612E-02,   1.8618744E-02,   1.9380294E-02
     +,   2.0196712E-02,   2.1071710E-02,   2.2009004E-02
     +,   2.3012506E-02,   2.4086256E-02,   2.5234245E-02
     +,   2.6460461E-02,   2.7768845E-02,   2.9163191E-02
     +,   3.0646803E-02,   3.2222670E-02,   3.3892993E-02
     +,   3.5659298E-02,   3.7521902E-02,   3.9480209E-02
     +,   4.1532077E-02,   4.3674331E-02,   4.5902260E-02
     +,   4.8210405E-02,   5.0592631E-02,   5.3042870E-02
     +,   5.5555817E-02,   5.8128431E-02,   6.0760982E-02
     +,   6.3458286E-02,   6.6231646E-02,   6.9099762E-02
     +,   7.2090618E-02,   7.5241752E-02,   7.8601845E-02
     +,   8.2229994E-02,   8.6196519E-02,   9.0580910E-02
     +,   9.5471032E-02,   0.1009597    ,   0.1071401    
     +,   0.1141007    ,   0.1219183    ,   0.1306522    
     +,   0.1403366    ,   0.1509818    ,   0.1625732    
     +,   0.1750836    ,   0.1884851    ,   0.2027705    
     +,   0.2179712    ,   0.2341786    ,   0.2515499    
     +,   0.2703103    ,   0.2907319    ,   0.3130911    
     +,   0.3376109    ,   0.3644015    ,   0.3934181    
     +,   0.4244751    ,   0.4573330    ,   0.4918437    
     +,   0.5280861    ,   0.5664020    ,   0.6072704    
     +,   0.6509904    ,   0.6972833    ,   0.7450028    
     +,   0.7921467    ,   0.8362400    ,   0.8750052    
     +,   0.9071162    ,   0.9327419    ,   0.9537446    
     +,   0.9734030    ,   0.9956020    ,    1.023456    
     +,    1.057672    ,    1.095326    ,    1.129926    
     +,    1.153183    ,    1.157954    ,    1.140970    
     +,    1.103965    ,    1.052633    ,   0.9941344    
     +,   0.9344233    ,   0.8766692    ,   0.8212390    
     +,   0.7669108    ,   0.7124598    ,   0.6577776    
     +,   0.6041025    ,   0.5534728    ,   0.5078428    
     +,   0.4684176    ,   0.4354313    ,   0.4083300    
     +,   0.3861418    ,   0.3678319    ,   0.3525072    
     +,   0.3394892    ,   0.3282988    ,   0.3186176    
     +,   0.3102425    ,   0.3030489    ,   0.2969500    
     +,   0.2918554    ,   0.2876402    ,   0.2841171    
     +,   0.2810310    ,   0.2780728    ,   0.2749076    
     +,   0.2712111    ,   0.2667108    ,   0.2612164    
     +,   0.2546392    ,   0.2469973    ,   0.2384054    
     +,   0.2290534    ,   0.2191792    ,   0.2090373    
     +,   0.1988748    ,   0.1889115    ,   0.1793266    
     +,   0.1702553    ,   0.1617909    ,   0.1539890    
     +,   0.1468752    ,   0.1404516    ,   0.1347039    
     +,   0.1296048    ,   0.1251164    ,   0.1211921    
     +,   0.1177773    ,   0.1148100    ,   0.1122207    
     +,   0.1099347    ,   0.1078735    ,   0.1059576    
     +,   0.1041092    ,   0.1022554    ,   0.1003312    
     +,   9.8281845E-02,   9.6065030E-02,   9.3651928E-02
     +,   9.1027670E-02,   8.8190734E-02,   8.5151784E-02
     +,   8.1932284E-02,   7.8562252E-02,   7.5077631E-02
     +,   7.1518295E-02,   6.7926019E-02,   6.4341925E-02
     +,   6.0805012E-02,   5.7351179E-02,   5.4011893E-02
     +,   5.0813358E-02,   4.7776483E-02,   4.4916995E-02
     +,   4.2245280E-02,   3.9766721E-02,   3.7482198E-02
     +,   3.5388865E-02,   3.3480436E-02,   3.1747796E-02
     +,   3.0179610E-02,   2.8763149E-02,   2.7484395E-02
     +,   2.6328761E-02,   2.5281593E-02,   2.4328426E-02
     +,   2.3455305E-02,   2.2649085E-02,   2.1897679E-02
     +,   2.1190183E-02,   2.0516926E-02,   1.9869545E-02
     +,   1.9241050E-02,   1.8625753E-02,   1.8019157E-02
     +,   1.7417913E-02,   1.6819771E-02,   1.6223351E-02
     +,   1.5628051E-02,   1.5034008E-02,   1.4441874E-02
     +,   1.3852701E-02,   1.3267849E-02,   1.2688926E-02
     +,   1.2117662E-02,   1.1555782E-02,   1.1004987E-02
     +,   1.0466957E-02,   9.9431640E-03,   9.4350036E-03
     +,   8.9436173E-03,   8.4700137E-03,   8.0149379E-03
     +,   7.5789928E-03,   7.1625235E-03,   6.7657400E-03
     +,   6.3886251E-03,   6.0310499E-03,   5.6926990E-03
     +,   5.3731352E-03,   5.0718416E-03,   4.7881724E-03
     +,   4.5214449E-03,   4.2708870E-03,   4.0357159E-03
     +,   3.8150966E-03,   3.6082088E-03,   3.4142060E-03
     +,   3.2322744E-03,   3.0615984E-03,   2.9014086E-03
     +,   2.7509450E-03,   2.6095065E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_hzonly_hatt90_mass = Yx/11.664613
      RETURN
      END
      DOUBLE PRECISION FUNCTION A200_tt_hzonly_hatt95_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  6.4921798E-03,   6.9506848E-03
     +,   7.4279844E-03,   7.9231542E-03,   8.4350752E-03
     +,   8.9624273E-03,   9.5036915E-03,   1.0057159E-02
     +,   1.0620927E-02,   1.1192942E-02,   1.1770967E-02
     +,   1.2352629E-02,   1.2935423E-02,   1.3516751E-02
     +,   1.4093931E-02,   1.4664230E-02,   1.5224889E-02
     +,   1.5773166E-02,   1.6306352E-02,   1.6821783E-02
     +,   1.7316939E-02,   1.7789382E-02,   1.8236855E-02
     +,   1.8657312E-02,   1.9048847E-02,   1.9409843E-02
     +,   1.9738922E-02,   2.0034947E-02,   2.0297090E-02
     +,   2.0524774E-02,   2.0717736E-02,   2.0875985E-02
     +,   2.0999817E-02,   2.1089792E-02,   2.1146744E-02
     +,   2.1171752E-02,   2.1166099E-02,   2.1131296E-02
     +,   2.1069018E-02,   2.0981103E-02,   2.0869518E-02
     +,   2.0736320E-02,   2.0583652E-02,   2.0413699E-02
     +,   2.0228658E-02,   2.0030731E-02,   1.9822095E-02
     +,   1.9604858E-02,   1.9381087E-02,   1.9152744E-02
     +,   1.8921709E-02,   1.8689740E-02,   1.8458493E-02
     +,   1.8229481E-02,   1.8004108E-02,   1.7783647E-02
     +,   1.7569253E-02,   1.7361945E-02,   1.7162645E-02
     +,   1.6972153E-02,   1.6791167E-02,   1.6620288E-02
     +,   1.6460054E-02,   1.6310900E-02,   1.6173203E-02
     +,   1.6047297E-02,   1.5933428E-02,   1.5831864E-02
     +,   1.5742773E-02,   1.5666340E-02,   1.5602710E-02
     +,   1.5552024E-02,   1.5514425E-02,   1.5490040E-02
     +,   1.5479001E-02,   1.5481465E-02,   1.5497605E-02
     +,   1.5527591E-02,   1.5571667E-02,   1.5630087E-02
     +,   1.5703171E-02,   1.5791293E-02,   1.5894875E-02
     +,   1.6014466E-02,   1.6150651E-02,   1.6304171E-02
     +,   1.6475836E-02,   1.6666617E-02,   1.6877595E-02
     +,   1.7109994E-02,   1.7365195E-02,   1.7644722E-02
     +,   1.7950201E-02,   1.8283430E-02,   1.8646328E-02
     +,   1.9040842E-02,   1.9469054E-02,   1.9933002E-02
     +,   2.0434758E-02,   2.0976270E-02,   2.1559382E-02
     +,   2.2185694E-02,   2.2856588E-02,   2.3573019E-02
     +,   2.4335561E-02,   2.5144309E-02,   2.5998706E-02
     +,   2.6897553E-02,   2.7839022E-02,   2.8820513E-02
     +,   2.9838575E-02,   3.0889088E-02,   3.1967048E-02
     +,   3.3066820E-02,   3.4181964E-02,   3.5305601E-02
     +,   3.6430180E-02,   3.7547991E-02,   3.8650945E-02
     +,   3.9731015E-02,   4.0780418E-02,   4.1791558E-02
     +,   4.2757437E-02,   4.3671895E-02,   4.4529695E-02
     +,   4.5326646E-02,   4.6059918E-02,   4.6728041E-02
     +,   4.7331132E-02,   4.7870826E-02,   4.8350435E-02
     +,   4.8774876E-02,   4.9150765E-02,   4.9486142E-02
     +,   4.9790636E-02,   5.0075162E-02,   5.0351821E-02
     +,   5.0633807E-02,   5.0935108E-02,   5.1270425E-02
     +,   5.1654845E-02,   5.2103702E-02,   5.2632354E-02
     +,   5.3255990E-02,   5.3989369E-02,   5.4846786E-02
     +,   5.5841941E-02,   5.6987796E-02,   5.8296725E-02
     +,   5.9780497E-02,   6.1450567E-02,   6.3318059E-02
     +,   6.5393873E-02,   6.7689158E-02,   7.0215300E-02
     +,   7.2983518E-02,   7.6004907E-02,   7.9290353E-02
     +,   8.2849480E-02,   8.6689718E-02,   9.0815961E-02
     +,   9.5229238E-02,   9.9926099E-02,   0.1048985    
     +,   0.1101360    ,   0.1156290    ,   0.1213748    
     +,   0.1273877    ,   0.1337124    ,   0.1404387    
     +,   0.1477155    ,   0.1557623    ,   0.1648748    
     +,   0.1754206    ,   0.1878239    ,   0.2025460    
     +,   0.2200545    ,   0.2407871    ,   0.2651097    
     +,   0.2932734    ,   0.3253785    ,   0.3613590    
     +,   0.4010228    ,   0.4441454    ,   0.4905819    
     +,   0.5403425    ,   0.5935810    ,   0.6504794    
     +,   0.7111148    ,   0.7754539    ,   0.8436118    
     +,   0.9162233    ,   0.9945711    ,    1.080051    
     +,    1.172876    ,    1.270714    ,    1.368410    
     +,    1.459592    ,    1.539474    ,    1.606848    
     +,    1.663393    ,    1.710349    ,    1.744866    
     +,    1.759145    ,    1.743628    ,    1.692574    
     +,    1.608361    ,    1.501568    ,    1.386726    
     +,    1.276379    ,    1.177095    ,    1.089191    
     +,    1.009450    ,   0.9344165    ,   0.8623263    
     +,   0.7931389    ,   0.7275431    ,   0.6660250    
     +,   0.6085808    ,   0.5549242    ,   0.5047754    
     +,   0.4580016    ,   0.4145612    ,   0.3743936    
     +,   0.3373626    ,   0.3032846    ,   0.2719855    
     +,   0.2433353    ,   0.2172529    ,   0.1936833    
     +,   0.1725681    ,   0.1538177    ,   0.1372983    
     +,   0.1228349    ,   0.1102231    ,   9.9240027E-02
     +,   8.9662082E-02,   8.1277415E-02,   7.3893838E-02
     +,   6.7343608E-02,   6.1485913E-02,   5.6206543E-02
     +,   5.1415328E-02,   4.7042761E-02,   4.3036874E-02
     +,   3.9359670E-02,   3.5983190E-02,   3.2886289E-02
     +,   3.0052155E-02,   2.7466491E-02,   2.5115555E-02
     +,   2.2985527E-02,   2.1062136E-02,   1.9330397E-02
     +,   1.7774595E-02,   1.6378747E-02,   1.5126992E-02
     +,   1.4003803E-02,   1.2994293E-02,   1.2084563E-02
     +,   1.1261925E-02,   1.0514974E-02,   9.8335901E-03
     +,   9.2089847E-03,   8.6337077E-03,   8.1014233E-03
     +,   7.6068561E-03,   7.1456968E-03,   6.7144250E-03
     +,   6.3101519E-03,   5.9305415E-03,   5.5737076E-03
     +,   5.2381051E-03,   4.9224207E-03,   4.6255398E-03
     +,   4.3465109E-03,   4.0844479E-03,   3.8385666E-03
     +,   3.6080976E-03,   3.3923322E-03,   3.1905572E-03
     +,   3.0021020E-03,   2.8262851E-03,   2.6624606E-03
     +,   2.5099756E-03,   2.3682115E-03,   2.2365530E-03
     +,   2.1144026E-03,   2.0011950E-03,   1.8963708E-03
     +,   1.7994049E-03,   1.7097821E-03,   1.6270212E-03
     +,   1.5506528E-03,   1.4802393E-03,   1.4153555E-03
     +,   1.3556057E-03,   1.3006073E-03,   1.2500056E-03
     +,   1.2034574E-03,   1.1606457E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A200_tt_hzonly_hatt95_mass = Yx/12.8543881395349
      RETURN
      END
C 
C---- New file --- 
C 
      DOUBLE PRECISION FUNCTION A202_tt_asha_htt100_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.2525017E-04,   1.3310846E-04
     +,   1.4127443E-04,   1.4974596E-04,   1.5851986E-04
     +,   1.6759177E-04,   1.7695612E-04,   1.8660628E-04
     +,   1.9653424E-04,   2.0673135E-04,   2.1718735E-04
     +,   2.2789111E-04,   2.3883034E-04,   2.4999183E-04
     +,   2.6136154E-04,   2.7292437E-04,   2.8466459E-04
     +,   2.9656567E-04,   3.0861076E-04,   3.2078230E-04
     +,   3.3306234E-04,   3.4543296E-04,   3.5787569E-04
     +,   3.7037322E-04,   3.8290664E-04,   3.9545912E-04
     +,   4.0801347E-04,   4.2055338E-04,   4.3306328E-04
     +,   4.4552883E-04,   4.5793678E-04,   4.7027532E-04
     +,   4.8253420E-04,   4.9470493E-04,   5.0678104E-04
     +,   5.1875832E-04,   5.3063466E-04,   5.4241077E-04
     +,   5.5409066E-04,   5.6568015E-04,   5.7718955E-04
     +,   5.8863236E-04,   6.0002547E-04,   6.1139010E-04
     +,   6.2275189E-04,   6.3414057E-04,   6.4559130E-04
     +,   6.5714389E-04,   6.6884368E-04,   6.8074150E-04
     +,   6.9289422E-04,   7.0536498E-04,   7.1822287E-04
     +,   7.3154463E-04,   7.4541196E-04,   7.5991586E-04
     +,   7.7515270E-04,   7.9122721E-04,   8.0825045E-04
     +,   8.2634122E-04,   8.4562571E-04,   8.6623710E-04
     +,   8.8831410E-04,   9.1200374E-04,   9.3745906E-04
     +,   9.6483616E-04,   9.9429965E-04,   1.0260148E-03
     +,   1.0601535E-03,   1.0968868E-03,   1.1363911E-03
     +,   1.1788382E-03,   1.2244047E-03,   1.2732587E-03
     +,   1.3255693E-03,   1.3815006E-03,   1.4412066E-03
     +,   1.5048326E-03,   1.5725184E-03,   1.6443915E-03
     +,   1.7205604E-03,   1.8011275E-03,   1.8861693E-03
     +,   1.9757550E-03,   2.0699217E-03,   2.1686996E-03
     +,   2.2720837E-03,   2.3800572E-03,   2.4925687E-03
     +,   2.6095498E-03,   2.7309083E-03,   2.8565216E-03
     +,   2.9862404E-03,   3.1198999E-03,   3.2573156E-03
     +,   3.3982720E-03,   3.5425548E-03,   3.6899226E-03
     +,   3.8401478E-03,   3.9929873E-03,   4.1482328E-03
     +,   4.3056761E-03,   4.4651683E-03,   4.6265898E-03
     +,   4.7899038E-03,   4.9551553E-03,   5.1224814E-03
     +,   5.2921409E-03,   5.4645399E-03,   5.6402390E-03
     +,   5.8199544E-03,   6.0046073E-03,   6.1952858E-03
     +,   6.3932985E-03,   6.6001206E-03,   6.8174521E-03
     +,   7.0471447E-03,   7.2912592E-03,   7.5520012E-03
     +,   7.8317635E-03,   8.1331227E-03,   8.4588369E-03
     +,   8.8118892E-03,   9.1955746E-03,   9.6135326E-03
     +,   1.0069785E-02,   1.0568916E-02,   1.1115999E-02
     +,   1.1716776E-02,   1.2377479E-02,   1.3104913E-02
     +,   1.3906095E-02,   1.4788176E-02,   1.5757866E-02
     +,   1.6821200E-02,   1.7982984E-02,   1.9246243E-02
     +,   2.0611960E-02,   2.2078915E-02,   2.3643684E-02
     +,   2.5300791E-02,   2.7043426E-02,   2.8864348E-02
     +,   3.0756842E-02,   3.2715596E-02,   3.4738049E-02
     +,   3.6824983E-02,   3.8980827E-02,   4.1213732E-02
     +,   4.3535441E-02,   4.5960456E-02,   4.8504829E-02
     +,   5.1185403E-02,   5.4018956E-02,   5.7021245E-02
     +,   6.0206547E-02,   6.3588530E-02,   6.7182280E-02
     +,   7.1007900E-02,   7.5095929E-02,   7.9495616E-02
     +,   8.4282450E-02,   8.9563601E-02,   9.5478609E-02
     +,   0.1021910    ,   0.1098713    ,   0.1186748    
     +,   0.1287275    ,   0.1401250    ,   0.1529505    
     +,   0.1673002    ,   0.1833109    ,   0.2011830    
     +,   0.2211968    ,   0.2436982    ,   0.2689971    
     +,   0.2971494    ,   0.3278284    ,   0.3608100    
     +,   0.3976333    ,   0.4442891    ,   0.5128154    
     +,   0.6178210    ,   0.7674752    ,   0.9568227    
     +,    1.174355    ,    1.419622    ,    1.700936    
     +,    2.020205    ,    2.411144    ,    2.904538    
     +,    3.503994    ,    4.137619    ,    4.422559    
     +,    4.665199    ,    5.133838    ,    5.134309    
     +,    4.727587    ,    4.280673    ,    3.617412    
     +,    2.941380    ,    2.406315    ,    1.990038    
     +,    1.666565    ,    1.387892    ,    1.141230    
     +,   0.9356055    ,   0.7727241    ,   0.6424699    
     +,   0.5354929    ,   0.4479617    ,   0.3778881    
     +,   0.3221161    ,   0.2756903    ,   0.2336108    
     +,   0.1930325    ,   0.1538293    ,   0.1175889    
     +,   8.6191215E-02,   6.0807917E-02,   4.1564103E-02
     +,   2.7744042E-02,   1.8218765E-02,   1.1829497E-02
     +,   7.6077008E-03,   4.8387060E-03,   3.0325919E-03
     +,   1.8644644E-03,   1.1195681E-03,   6.5418408E-04
     +,   3.7090926E-04,   2.0362732E-04,   1.0807283E-04
     +,   5.5385746E-05,   2.7385962E-05,   1.3056368E-05
     +,   5.9988756E-06,   2.6554701E-06,   1.1322976E-06
     +,   4.6501754E-07,   1.8392596E-07,   7.0067792E-08
     +,   2.5714543E-08,   9.0941317E-09,   3.1016112E-09
     +,   1.0220805E-09,   3.2699496E-10,   1.0282956E-10
     +,   3.2793507E-11,   1.1365115E-11,   4.7576587E-12
     +,   2.5623707E-12,   1.6834181E-12,   1.2242145E-12
     +,   9.2585152E-13,   7.0900317E-13,   5.4456141E-13
     +,   4.1820554E-13,   3.2081366E-13,   2.4575570E-13
     +,   1.8797817E-13,   1.4356745E-13,   1.0948070E-13
     +,   8.3357813E-14,   6.3370228E-14,   4.8100348E-14
     +,   3.6452652E-14,   2.7582261E-14,   2.0837741E-14
     +,   1.5717621E-14,   1.1836722E-14,   8.8999200E-15
     +,   6.6812197E-15,   5.0076355E-15,   3.7472407E-15
     +,   2.7996199E-15,   2.0882642E-15,   1.5551736E-15
     +,   1.1562951E-15,   8.5834613E-16,   6.3613662E-16
     +,   4.7069647E-16,   3.4771542E-16,   2.5645243E-16
     +,   1.8883448E-16,   1.3882038E-16,   1.0188736E-16
     +,   7.4657782E-17,   5.4616794E-17,   3.9890216E-17
     +,   2.9087075E-17,   2.1174871E-17,   1.5389924E-17
     +,   1.1167028E-17,   8.0896924E-18,   5.8507535E-18
     +,   4.2245863E-18,   3.0453556E-18,   2.1917381E-18
     +,   1.5747780E-18,   1.1296475E-18
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_asha_htt100_mass = Yx/17.86549086
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_asha_htt105_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.6244150E-04,   4.6654444E-04
     +,   4.7034488E-04,   4.7385349E-04,   4.7708218E-04
     +,   4.8004446E-04,   4.8275510E-04,   4.8522980E-04
     +,   4.8748538E-04,   4.8953935E-04,   4.9140974E-04
     +,   4.9311481E-04,   4.9467327E-04,   4.9610378E-04
     +,   4.9742457E-04,   4.9865374E-04,   4.9980881E-04
     +,   5.0090661E-04,   5.0196290E-04,   5.0299295E-04
     +,   5.0401042E-04,   5.0502806E-04,   5.0605729E-04
     +,   5.0710811E-04,   5.0818914E-04,   5.0930772E-04
     +,   5.1046960E-04,   5.1167910E-04,   5.1293930E-04
     +,   5.1425176E-04,   5.1561708E-04,   5.1703444E-04
     +,   5.1850191E-04,   5.2001694E-04,   5.2157568E-04
     +,   5.2317412E-04,   5.2480720E-04,   5.2646990E-04
     +,   5.2815670E-04,   5.2986218E-04,   5.3158082E-04
     +,   5.3330750E-04,   5.3503743E-04,   5.3676637E-04
     +,   5.3849071E-04,   5.4020784E-04,   5.4191577E-04
     +,   5.4361369E-04,   5.4530200E-04,   5.4698199E-04
     +,   5.4865680E-04,   5.5033027E-04,   5.5200810E-04
     +,   5.5369723E-04,   5.5540598E-04,   5.5714446E-04
     +,   5.5892381E-04,   5.6075759E-04,   5.6265993E-04
     +,   5.6464720E-04,   5.6673744E-04,   5.6895020E-04
     +,   5.7130709E-04,   5.7383167E-04,   5.7654968E-04
     +,   5.7948875E-04,   5.8267952E-04,   5.8615510E-04
     +,   5.8995193E-04,   5.9410936E-04,   5.9867126E-04
     +,   6.0368492E-04,   6.0920342E-04,   6.1528379E-04
     +,   6.2198995E-04,   6.2939245E-04,   6.3756801E-04
     +,   6.4660143E-04,   6.5658678E-04,   6.6762703E-04
     +,   6.7983451E-04,   6.9333351E-04,   7.0825842E-04
     +,   7.2475756E-04,   7.4299070E-04,   7.6313305E-04
     +,   7.8537222E-04,   8.0991455E-04,   8.3697907E-04
     +,   8.6680485E-04,   8.9964969E-04,   9.3578926E-04
     +,   9.7552000E-04,   1.0191643E-03,   1.0670701E-03
     +,   1.1196096E-03,   1.1771920E-03,   1.2402559E-03
     +,   1.3092883E-03,   1.3848128E-03,   1.4674163E-03
     +,   1.5577357E-03,   1.6564884E-03,   1.7644576E-03
     +,   1.8825253E-03,   2.0116731E-03,   2.1529833E-03
     +,   2.3076546E-03,   2.4770182E-03,   2.6625353E-03
     +,   2.8657753E-03,   3.0884512E-03,   3.3323495E-03
     +,   3.5993687E-03,   3.8914138E-03,   4.2104227E-03
     +,   4.5582242E-03,   4.9365475E-03,   5.3468524E-03
     +,   5.7903100E-03,   6.2676654E-03,   6.7791161E-03
     +,   7.3242155E-03,   7.9018408E-03,   8.5100960E-03
     +,   9.1461930E-03,   9.8066116E-03,   1.0486968E-02
     +,   1.1182290E-02,   1.1886977E-02,   1.2595224E-02
     +,   1.3301060E-02,   1.3998884E-02,   1.4683588E-02
     +,   1.5351088E-02,   1.5998622E-02,   1.6625002E-02
     +,   1.7230963E-02,   1.7819377E-02,   1.8395333E-02
     +,   1.8966094E-02,   1.9541034E-02,   2.0131476E-02
     +,   2.0750353E-02,   2.1411762E-02,   2.2130657E-02
     +,   2.2922240E-02,   2.3801321E-02,   2.4781622E-02
     +,   2.5875043E-02,   2.7090522E-02,   2.8432924E-02
     +,   2.9901743E-02,   3.1490080E-02,   3.3183705E-02
     +,   3.4960531E-02,   3.6791489E-02,   3.8642693E-02
     +,   4.0479213E-02,   4.2270798E-02,   4.4000704E-02
     +,   4.5675620E-02,   4.7337238E-02,   4.9073793E-02
     +,   5.1028550E-02,   5.3401068E-02,   5.6436811E-02
     +,   6.0400885E-02,   6.5535396E-02,   7.2005004E-02
     +,   7.9842776E-02,   8.8917315E-02,   9.8940343E-02
     +,   0.1095242    ,   0.1202824    ,   0.1309484    
     +,   0.1414602    ,   0.1519769    ,   0.1628114    
     +,   0.1743126    ,   0.1867632    ,   0.2003732    
     +,   0.2153988    ,   0.2323200    ,   0.2519251    
     +,   0.2751827    ,   0.3030149    ,   0.3363079    
     +,   0.3763961    ,   0.4258113    ,   0.4886650    
     +,   0.5693918    ,   0.6688793    ,   0.7815933    
     +,   0.9023586    ,    1.040921    ,    1.225054    
     +,    1.491773    ,    1.861677    ,    2.241823    
     +,    2.580048    ,    3.086127    ,    3.685877    
     +,    4.454151    ,    5.313842    ,    5.629102    
     +,    5.819154    ,    5.434427    ,    4.669882    
     +,    3.963722    ,    3.394031    ,    2.782055    
     +,    2.169905    ,    1.597966    ,    1.115069    
     +,   0.7403191    ,   0.4669774    ,   0.2822102    
     +,   0.1655289    ,   9.4883412E-02,   5.3007010E-02
     +,   2.8720560E-02,   1.5208992E-02,   8.1371348E-03
     +,   4.6478156E-03,   2.9649395E-03,   2.1155181E-03
     +,   1.6349050E-03,   1.3240218E-03,   1.1017044E-03
     +,   9.3367673E-04,   8.0355728E-04,   7.0203125E-04
     +,   6.2282645E-04,   5.6113087E-04,   5.1295420E-04
     +,   4.7492771E-04,   4.4425865E-04,   4.1871535E-04
     +,   3.9659705E-04,   3.7667458E-04,   3.5811009E-04
     +,   3.4036682E-04,   3.2312685E-04,   3.0622302E-04
     +,   2.8958777E-04,   2.7321308E-04,   2.5712376E-04
     +,   2.4136149E-04,   2.2597582E-04,   2.1101499E-04
     +,   1.9652418E-04,   1.8254432E-04,   1.6911028E-04
     +,   1.5624982E-04,   1.4398439E-04,   1.3233014E-04
     +,   1.2129713E-04,   1.1088932E-04,   1.0110552E-04
     +,   9.1940572E-05,   8.3385072E-05,   7.5425240E-05
     +,   6.8044159E-05,   6.1222898E-05,   5.4939428E-05
     +,   4.9170001E-05,   4.3889795E-05,   3.9072911E-05
     +,   3.4692479E-05,   3.0721360E-05,   2.7132684E-05
     +,   2.3899798E-05,   2.0996307E-05,   1.8396584E-05
     +,   1.6076097E-05,   1.4011003E-05,   1.2178879E-05
     +,   1.0558218E-05,   9.1289994E-06,   7.8722906E-06
     +,   6.7706164E-06,   5.8076530E-06,   4.9684677E-06
     +,   4.2392517E-06,   3.6074948E-06,   3.0617491E-06
     +,   2.5916609E-06,   2.1879457E-06,   1.8422127E-06
     +,   1.5470083E-06,   1.2956588E-06,   1.0822763E-06
     +,   9.0163417E-07,   7.4915670E-07,   6.2081131E-07
     +,   5.1309331E-07,   4.2293883E-07,   3.4770346E-07
     +,   2.8509191E-07,   2.3313693E-07
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_asha_htt105_mass = Yx/17.3602791428571
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_asha_htt107_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.9196551E-05,   5.3575426E-05
     +,   5.8243830E-05,   6.3210282E-05,   6.8482412E-05
     +,   7.4066847E-05,   7.9969104E-05,   8.6193446E-05
     +,   9.2742644E-05,   9.9618286E-05,   1.0681998E-04
     +,   1.1434571E-04,   1.2219162E-04,   1.3035187E-04
     +,   1.3881856E-04,   1.4758165E-04,   1.5662900E-04
     +,   1.6594616E-04,   1.7551641E-04,   1.8532079E-04
     +,   1.9533813E-04,   2.0554496E-04,   2.1591550E-04
     +,   2.2642269E-04,   2.3703613E-04,   2.4772497E-04
     +,   2.5845590E-04,   2.6919442E-04,   2.7990466E-04
     +,   2.9054994E-04,   3.0109260E-04,   3.1149483E-04
     +,   3.2171860E-04,   3.3172604E-04,   3.4148007E-04
     +,   3.5094455E-04,   3.6008478E-04,   3.6886774E-04
     +,   3.7726344E-04,   3.8524350E-04,   3.9278393E-04
     +,   3.9986396E-04,   4.0646706E-04,   4.1258178E-04
     +,   4.1820161E-04,   4.2332633E-04,   4.2796176E-04
     +,   4.3212093E-04,   4.3582416E-04,   4.3909988E-04
     +,   4.4198515E-04,   4.4452606E-04,   4.4677849E-04
     +,   4.4880837E-04,   4.5069202E-04,   4.5251747E-04
     +,   4.5438364E-04,   4.5640144E-04,   4.5869400E-04
     +,   4.6139664E-04,   4.6465712E-04,   4.6863535E-04
     +,   4.7350343E-04,   4.7944521E-04,   4.8665609E-04
     +,   4.9534097E-04,   5.0571514E-04,   5.1800074E-04
     +,   5.3242786E-04,   5.4922933E-04,   5.6864216E-04
     +,   5.9090112E-04,   6.1623997E-04,   6.4488372E-04
     +,   6.7704922E-04,   7.1294099E-04,   7.5274322E-04
     +,   7.9661811E-04,   8.4470469E-04,   8.9711224E-04
     +,   9.5391064E-04,   1.0151385E-03,   1.0807846E-03
     +,   1.1508007E-03,   1.2250816E-03,   1.3034812E-03
     +,   1.3857913E-03,   1.4717629E-03,   1.5610829E-03
     +,   1.6533972E-03,   1.7483035E-03,   1.8453505E-03
     +,   1.9440455E-03,   2.0438707E-03,   2.1442815E-03
     +,   2.2447065E-03,   2.3445780E-03,   2.4433164E-03
     +,   2.5403674E-03,   2.6351875E-03,   2.7272792E-03
     +,   2.8161805E-03,   2.9014964E-03,   2.9828919E-03
     +,   3.0601171E-03,   3.1330136E-03,   3.2015131E-03
     +,   3.2656556E-03,   3.3255946E-03,   3.3816064E-03
     +,   3.4340792E-03,   3.4835336E-03,   3.5306115E-03
     +,   3.5760868E-03,   3.6208581E-03,   3.6659555E-03
     +,   3.7125365E-03,   3.7618913E-03,   3.8154428E-03
     +,   3.8747564E-03,   3.9415504E-03,   4.0176972E-03
     +,   4.1052462E-03,   4.2064423E-03,   4.3237465E-03
     +,   4.4598440E-03,   4.6176855E-03,   4.8004710E-03
     +,   5.0117006E-03,   5.2551152E-03,   5.5347439E-03
     +,   5.8547943E-03,   6.2196790E-03,   6.6338438E-03
     +,   7.1017491E-03,   7.6277177E-03,   8.2157524E-03
     +,   8.8694040E-03,   9.5916428E-03,   1.0384664E-02
     +,   1.1249638E-02,   1.2186605E-02,   1.3194364E-02
     +,   1.4270324E-02,   1.5410312E-02,   1.6608754E-02
     +,   1.7858706E-02,   1.9151984E-02,   2.0479694E-02
     +,   2.1832967E-02,   2.3203889E-02,   2.4586568E-02
     +,   2.5978845E-02,   2.7384084E-02,   2.8812906E-02
     +,   3.0284928E-02,   3.1830058E-02,   3.3489224E-02
     +,   3.5313811E-02,   3.7363395E-02,   3.9702218E-02
     +,   4.2393252E-02,   4.5490313E-02,   4.9029060E-02
     +,   5.3017091E-02,   5.7424739E-02,   6.2177170E-02
     +,   6.7151614E-02,   7.2180271E-02,   7.7060014E-02
     +,   8.1569225E-02,   8.5492253E-02,   8.8646509E-02
     +,   9.0909645E-02,   9.2241712E-02,   9.2701301E-02
     +,   9.2451967E-02,   9.1763191E-02,   9.1007873E-02
     +,   9.0663448E-02,   9.1324024E-02,   9.3734033E-02
     +,   9.8849528E-02,   0.1079098    ,   0.1224450    
     +,   0.1440767    ,   0.1739883    ,   0.2121293    
     +,   0.2565578    ,   0.3035574    ,   0.3489393    
     +,   0.3901188    ,   0.4276960    ,   0.4649523    
     +,   0.5049744    ,   0.5486847    ,   0.5989786    
     +,   0.6684895    ,   0.7771405    ,   0.9383348    
     +,    1.156814    ,    1.429536    ,    1.739921    
     +,    2.059434    ,    2.337124    ,    2.769589    
     +,    3.510980    ,    4.304765    ,    5.487887    
     +,    6.335662    ,    6.869747    ,    6.713804    
     +,    5.579168    ,    4.479090    ,    3.254930    
     +,    2.095737    ,    1.265759    ,   0.6900977    
     +,   0.3095966    ,   0.1117485    ,   3.4660988E-02
     +,   1.1264683E-02,   5.4597096E-03,   4.1921488E-03
     +,   3.8267046E-03,   3.5617244E-03,   3.2715600E-03
     +,   2.9550670E-03,   2.6271420E-03,   2.3022438E-03
     +,   1.9919770E-03,   1.7045827E-03,   1.4450102E-03
     +,   1.2153811E-03,   1.0156374E-03,   8.4417115E-04
     +,   6.9846789E-04,   5.7560671E-04,   4.7260016E-04
     +,   3.8661118E-04,   3.1507824E-04,   2.5575954E-04
     +,   2.0672365E-04,   1.6632029E-04,   1.3315013E-04
     +,   1.0602961E-04,   8.3955878E-05,   6.6078232E-05
     +,   5.1676958E-05,   4.0144863E-05,   3.0968244E-05
     +,   2.3715002E-05,   1.8023236E-05,   1.3590639E-05
     +,   1.0165793E-05,   7.5413027E-06,   5.5473170E-06
     +,   4.0456753E-06,   2.9249134E-06,   2.0960324E-06
     +,   1.4887260E-06,   1.0479446E-06,   7.3103888E-07
     +,   5.0535624E-07,   3.4618330E-07,   2.3499049E-07
     +,   1.5805757E-07,   1.0534225E-07,   6.9568429E-08
     +,   4.5523706E-08,   2.9516844E-08,   1.8963359E-08
     +,   1.2072083E-08,   7.6149043E-09,   4.7594777E-09
     +,   2.9477127E-09,   1.8089830E-09,   1.1000958E-09
     +,   6.6293643E-10,   3.9590442E-10,   2.3431260E-10
     +,   1.3744759E-10,   7.9918315E-11,   4.6068777E-11
     +,   2.6332686E-11,   1.4930059E-11,   8.4001616E-12
     +,   4.6928282E-12,   2.6055497E-12,   1.4394914E-12
     +,   7.9275367E-13,   4.3623763E-13,   2.4066106E-13
     +,   1.3366898E-13,   7.5149996E-14,   4.3026905E-14
     +,   2.5246937E-14,   1.5263911E-14,   9.5407767E-15
     +,   6.1682350E-15,   4.1149415E-15
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_asha_htt107_mass = Yx/16.8083974285714
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_asha_htt110_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.0921816E-04,   4.2306774E-04
     +,   4.3709279E-04,   4.5128464E-04,   4.6563457E-04
     +,   4.8013387E-04,   4.9477373E-04,   5.0954550E-04
     +,   5.2444031E-04,   5.3945009E-04,   5.5456639E-04
     +,   5.6978100E-04,   5.8508624E-04,   6.0047460E-04
     +,   6.1593874E-04,   6.3147192E-04,   6.4706785E-04
     +,   6.6272053E-04,   6.7842443E-04,   6.9417461E-04
     +,   7.0996681E-04,   7.2579709E-04,   7.4166217E-04
     +,   7.5756008E-04,   7.7348796E-04,   7.8944553E-04
     +,   8.0543204E-04,   8.2144793E-04,   8.3749433E-04
     +,   8.5357338E-04,   8.6968782E-04,   8.8584173E-04
     +,   9.0203970E-04,   9.1828761E-04,   9.3459233E-04
     +,   9.5096172E-04,   9.6740486E-04,   9.8393171E-04
     +,   1.0005542E-03,   1.0172842E-03,   1.0341362E-03
     +,   1.0511255E-03,   1.0682677E-03,   1.0855810E-03
     +,   1.1030845E-03,   1.1207988E-03,   1.1387448E-03
     +,   1.1569459E-03,   1.1754261E-03,   1.1942101E-03
     +,   1.2133241E-03,   1.2327948E-03,   1.2526498E-03
     +,   1.2729178E-03,   1.2936261E-03,   1.3148037E-03
     +,   1.3364784E-03,   1.3586781E-03,   1.3814295E-03
     +,   1.4047575E-03,   1.4286870E-03,   1.4532398E-03
     +,   1.4784342E-03,   1.5042879E-03,   1.5308156E-03
     +,   1.5580247E-03,   1.5859235E-03,   1.6145115E-03
     +,   1.6437877E-03,   1.6737415E-03,   1.7043625E-03
     +,   1.7356289E-03,   1.7675202E-03,   1.8000051E-03
     +,   1.8330506E-03,   1.8666197E-03,   1.9006690E-03
     +,   1.9351523E-03,   1.9700234E-03,   2.0052334E-03
     +,   2.0407329E-03,   2.0764780E-03,   2.1124228E-03
     +,   2.1485339E-03,   2.1847792E-03,   2.2211429E-03
     +,   2.2576186E-03,   2.2942193E-03,   2.3309740E-03
     +,   2.3679356E-03,   2.4051834E-03,   2.4428230E-03
     +,   2.4809905E-03,   2.5198581E-03,   2.5596351E-03
     +,   2.6005674E-03,   2.6429433E-03,   2.6870882E-03
     +,   2.7333754E-03,   2.7822133E-03,   2.8340560E-03
     +,   2.8893882E-03,   2.9487368E-03,   3.0126486E-03
     +,   3.0817003E-03,   3.1564869E-03,   3.2376037E-03
     +,   3.3256472E-03,   3.4212042E-03,   3.5248392E-03
     +,   3.6370738E-03,   3.7583939E-03,   3.8892117E-03
     +,   4.0298831E-03,   4.1806633E-03,   4.3417411E-03
     +,   4.5131869E-03,   4.6949936E-03,   4.8870384E-03
     +,   5.0891261E-03,   5.3009917E-03,   5.5223019E-03
     +,   5.7527036E-03,   5.9918766E-03,   6.2395642E-03
     +,   6.4956127E-03,   6.7600855E-03,   7.0332801E-03
     +,   7.3158774E-03,   7.6089473E-03,   7.9141306E-03
     +,   8.2336375E-03,   8.5704364E-03,   8.9282608E-03
     +,   9.3117813E-03,   9.7266678E-03,   1.0179679E-02
     +,   1.0678794E-02,   1.1233351E-02,   1.1854175E-02
     +,   1.2553660E-02,   1.3345926E-02,   1.4247022E-02
     +,   1.5274933E-02,   1.6449530E-02,   1.7792586E-02
     +,   1.9327460E-02,   2.1078356E-02,   2.3069451E-02
     +,   2.5323683E-02,   2.7860694E-02,   3.0694274E-02
     +,   3.3829670E-02,   3.7260782E-02,   4.0967330E-02
     +,   4.4912390E-02,   4.9042154E-02,   5.3287275E-02
     +,   5.7566531E-02,   6.1792627E-02,   6.5881610E-02
     +,   6.9762647E-02,   7.3387854E-02,   7.6741047E-02
     +,   7.9843134E-02,   8.2751527E-02,   8.5555047E-02
     +,   8.8364914E-02,   9.1304407E-02,   9.4501913E-02
     +,   9.8091528E-02,   0.1022231    ,   0.1070787    
     +,   0.1128855    ,   0.1199090    ,   0.1284157    
     +,   0.1385943    ,   0.1504513    ,   0.1637155    
     +,   0.1778012    ,   0.1918669    ,   0.2049810    
     +,   0.2163578    ,   0.2256017    ,   0.2328908    
     +,   0.2390830    ,   0.2457374    ,   0.2550447    
     +,   0.2696277    ,   0.2921587    ,   0.3247516    
     +,   0.3681364    ,   0.4208025    ,   0.4785740    
     +,   0.5351790    ,   0.5840862    ,   0.6212088    
     +,   0.6473511    ,   0.6691046    ,   0.6980211    
     +,   0.7480289    ,   0.8289675    ,   0.9386637    
     +,    1.065861    ,    1.205555    ,    1.369682    
     +,    1.582929    ,    1.861495    ,    2.187055    
     +,    2.535393    ,    2.914665    ,    3.439336    
     +,    4.236203    ,    5.257822    ,    6.410158    
     +,    7.054326    ,    6.474832    ,    4.403445    
     +,    1.821478    ,   0.3895200    ,   3.9650261E-02
     +,   1.8370479E-03,   3.9408151E-05,   2.1520564E-06
     +,   1.6400886E-06,   1.4712774E-06,   1.3196685E-06
     +,   1.1826322E-06,   1.0588665E-06,   9.4718007E-07
     +,   8.4648866E-07,   7.5579663E-07,   6.7418495E-07
     +,   6.0081283E-07,   5.3491681E-07,   4.7579152E-07
     +,   4.2279214E-07,   3.7533295E-07,   3.3287921E-07
     +,   2.9493998E-07,   2.6106878E-07,   2.3086098E-07
     +,   2.0394916E-07,   1.7999737E-07,   1.5870117E-07
     +,   1.3978651E-07,   1.2300497E-07,   1.0813074E-07
     +,   9.4960548E-08,   8.3311889E-08,   7.3019400E-08
     +,   6.3934380E-08,   5.5923859E-08,   4.8868340E-08
     +,   4.2660211E-08,   3.7203307E-08,   3.2411897E-08
     +,   2.8209305E-08,   2.4527015E-08,   2.1303823E-08
     +,   1.8485579E-08,   1.6024073E-08,   1.3876333E-08
     +,   1.2004265E-08,   1.0374345E-08,   8.9566550E-09
     +,   7.7248412E-09,   6.6557000E-09,   5.7287628E-09
     +,   4.9259112E-09,   4.2312660E-09,   3.6308925E-09
     +,   3.1125598E-09,   2.6655163E-09,   2.2803464E-09
     +,   1.9488635E-09,   1.6638638E-09,   1.4191059E-09
     +,   1.2091145E-09,   1.0291532E-09,   8.7508090E-10
     +,   7.4332035E-10,   6.3075284E-10,   5.3468957E-10
     +,   4.5279258E-10,   3.8305054E-10,   3.2371983E-10
     +,   2.7329883E-10,   2.3049683E-10,   1.9419850E-10
     +,   1.6345031E-10,   1.3742964E-10,   1.1543382E-10
     +,   9.6858882E-11,   8.1190450E-11,   6.7986644E-11
     +,   5.6872295E-11,   4.7526014E-11,   3.9675273E-11
     +,   3.3087338E-11,   2.7565325E-11
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_asha_htt110_mass = Yx/15.7706198571429
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_asha_htt115_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  9.4719253E-05,   9.9620265E-05
     +,   1.0469898E-04,   1.0995731E-04,   1.1539694E-04
     +,   1.2101942E-04,   1.2682599E-04,   1.3281778E-04
     +,   1.3899549E-04,   1.4536011E-04,   1.5191197E-04
     +,   1.5865146E-04,   1.6557872E-04,   1.7269389E-04
     +,   1.7999690E-04,   1.8748763E-04,   1.9516607E-04
     +,   2.0303206E-04,   2.1108551E-04,   2.1932668E-04
     +,   2.2775578E-04,   2.3637328E-04,   2.4517984E-04
     +,   2.5417720E-04,   2.6336632E-04,   2.7275004E-04
     +,   2.8233093E-04,   2.9211261E-04,   3.0209962E-04
     +,   3.1229723E-04,   3.2271189E-04,   3.3335097E-04
     +,   3.4422352E-04,   3.5533938E-04,   3.6671045E-04
     +,   3.7834953E-04,   3.9027157E-04,   4.0249282E-04
     +,   4.1503223E-04,   4.2790914E-04,   4.4114640E-04
     +,   4.5476778E-04,   4.6879973E-04,   4.8327012E-04
     +,   4.9820950E-04,   5.1365001E-04,   5.2962609E-04
     +,   5.4617395E-04,   5.6333136E-04,   5.8113848E-04
     +,   5.9963658E-04,   6.1886857E-04,   6.3887815E-04
     +,   6.5971143E-04,   6.8141322E-04,   7.0403109E-04
     +,   7.2761183E-04,   7.5220206E-04,   7.7784888E-04
     +,   8.0459827E-04,   8.3249557E-04,   8.6158584E-04
     +,   8.9191023E-04,   9.2351111E-04,   9.5642882E-04
     +,   9.9069858E-04,   1.0263583E-03,   1.0634389E-03
     +,   1.1019742E-03,   1.1419911E-03,   1.1835207E-03
     +,   1.2265876E-03,   1.2712224E-03,   1.3174504E-03
     +,   1.3653043E-03,   1.4148203E-03,   1.4660378E-03
     +,   1.5190037E-03,   1.5737794E-03,   1.6304405E-03
     +,   1.6890753E-03,   1.7498002E-03,   1.8127500E-03
     +,   1.8780991E-03,   1.9460471E-03,   2.0168442E-03
     +,   2.0907773E-03,   2.1681932E-03,   2.2494833E-03
     +,   2.3351084E-03,   2.4255891E-03,   2.5215067E-03
     +,   2.6235080E-03,   2.7323090E-03,   2.8486871E-03
     +,   2.9734669E-03,   3.1075338E-03,   3.2517954E-03
     +,   3.4072036E-03,   3.5747008E-03,   3.7552428E-03
     +,   3.9497358E-03,   4.1590715E-03,   4.3840441E-03
     +,   4.6253894E-03,   4.8837471E-03,   5.1596239E-03
     +,   5.4534096E-03,   5.7653822E-03,   6.0957065E-03
     +,   6.4444053E-03,   6.8114479E-03,   7.1967049E-03
     +,   7.6000490E-03,   8.0213211E-03,   8.4604574E-03
     +,   8.9174313E-03,   9.3924077E-03,   9.8856688E-03
     +,   1.0397729E-02,   1.0929329E-02,   1.1481397E-02
     +,   1.2055069E-02,   1.2651690E-02,   1.3272760E-02
     +,   1.3919800E-02,   1.4594443E-02,   1.5298212E-02
     +,   1.6032645E-02,   1.6799102E-02,   1.7598949E-02
     +,   1.8433457E-02,   1.9304086E-02,   2.0212531E-02
     +,   2.1161141E-02,   2.2153223E-02,   2.3193354E-02
     +,   2.4287943E-02,   2.5445683E-02,   2.6677882E-02
     +,   2.7998608E-02,   2.9424747E-02,   3.0975819E-02
     +,   3.2673243E-02,   3.4539167E-02,   3.6595333E-02
     +,   3.8861424E-02,   4.1353170E-02,   4.4081241E-02
     +,   4.7050748E-02,   5.0261725E-02,   5.3710949E-02
     +,   5.7395890E-02,   6.1320160E-02,   6.5499082E-02
     +,   6.9963962E-02,   7.4764006E-02,   7.9962723E-02
     +,   8.5626699E-02,   9.1807052E-02,   9.8517157E-02
     +,   0.1057087    ,   0.1132547    ,   0.1209474    
     +,   0.1285178    ,   0.1356777    ,   0.1421825    
     +,   0.1479057    ,   0.1529124    ,   0.1575105    
     +,   0.1622638    ,   0.1679517    ,   0.1754648    
     +,   0.1856463    ,   0.1991038    ,   0.2160431    
     +,   0.2361582    ,   0.2586089    ,   0.2820935    
     +,   0.3050048    ,   0.3256732    ,   0.3427077    
     +,   0.3554260    ,   0.3642921    ,   0.3711820    
     +,   0.3792538    ,   0.3922304    ,   0.4132038    
     +,   0.4435946    ,   0.4832752    ,   0.5323051    
     +,   0.5926251    ,   0.6664330    ,   0.7502559    
     +,   0.8304801    ,   0.8889757    ,   0.9182256    
     +,   0.9334193    ,   0.9694428    ,    1.058787    
     +,    1.199691    ,    1.346320    ,    1.441834    
     +,    1.457674    ,    1.405887    ,    1.351019    
     +,    1.391423    ,    1.560088    ,    1.773489    
     +,    1.929969    ,    2.004523    ,    2.026423    
     +,    2.034113    ,    2.028726    ,    1.950493    
     +,    1.736854    ,    1.379294    ,   0.9425961    
     +,   0.5399750    ,   0.2559684    ,   9.9893153E-02
     +,   3.1971309E-02,   8.3518894E-03,   1.7711720E-03
     +,   3.0321837E-04,   4.1717572E-05,   4.6563064E-06
     +,   4.8919628E-07,   1.1124122E-07,   7.6081058E-08
     +,   6.6054248E-08,   5.8320214E-08,   5.1510597E-08
     +,   4.5474671E-08,   4.0125464E-08,   3.5386474E-08
     +,   3.1189778E-08,   2.7475018E-08,   2.4188584E-08
     +,   2.1282359E-08,   1.8713651E-08,   1.6444559E-08
     +,   1.4441308E-08,   1.2673739E-08,   1.1115017E-08
     +,   9.7413535E-09,   8.5315852E-09,   7.4668227E-09
     +,   6.5302732E-09,   5.7071166E-09,   4.9841034E-09
     +,   4.3494710E-09,   3.7928349E-09,   3.3049878E-09
     +,   2.8777196E-09,   2.5037781E-09,   2.1767708E-09
     +,   1.8910280E-09,   1.6415270E-09,   1.4238337E-09
     +,   1.2340503E-09,   1.0687299E-09,   9.2483043E-10
     +,   7.9967227E-10,   6.9090811E-10,   5.9646449E-10
     +,   5.1451871E-10,   4.4347714E-10,   3.8194106E-10
     +,   3.2868042E-10,   2.8261851E-10,   2.4281682E-10
     +,   2.0845330E-10,   1.7880886E-10,   1.5325566E-10
     +,   1.3124872E-10,   1.1231039E-10,   9.6027436E-11
     +,   8.2038210E-11,   7.0030592E-11,   5.9731511E-11
     +,   5.0906057E-11,   4.3348995E-11,   3.6884037E-11
     +,   3.1357542E-11,   2.6637489E-11,   2.2609579E-11
     +,   1.9174932E-11,   1.6248889E-11,   1.3758079E-11
     +,   1.1639636E-11,   9.8393012E-12,   8.3106777E-12
     +,   7.0137850E-12,   5.9144668E-12,   4.9833631E-12
     +,   4.1954296E-12,   3.5291748E-12,   2.9663114E-12
     +,   2.4911776E-12,   2.0904437E-12
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_asha_htt115_mass = Yx/10.9757326595745
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_asha_htt120_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.0360847E-06,   2.2525292E-06
     +,   2.4895019E-06,   2.7486669E-06,   3.0317929E-06
     +,   3.3407548E-06,   3.6775368E-06,   4.0442437E-06
     +,   4.4430822E-06,   4.8764055E-06,   5.3466638E-06
     +,   5.8564374E-06,   6.4084325E-06,   7.0054766E-06
     +,   7.6505257E-06,   8.3466530E-06,   9.0970598E-06
     +,   9.9050694E-06,   1.0774116E-05,   1.1707744E-05
     +,   1.2709625E-05,   1.3783506E-05,   1.4933232E-05
     +,   1.6162809E-05,   1.7476184E-05,   1.8877501E-05
     +,   2.0370899E-05,   2.1960588E-05,   2.3650784E-05
     +,   2.5445746E-05,   2.7349723E-05,   2.9366964E-05
     +,   3.1501680E-05,   3.3758028E-05,   3.6140100E-05
     +,   3.8651913E-05,   4.1297390E-05,   4.4080229E-05
     +,   4.7004243E-05,   5.0072726E-05,   5.3289114E-05
     +,   5.6656510E-05,   6.0177841E-05,   6.3855841E-05
     +,   6.7693014E-05,   7.1691727E-05,   7.5854150E-05
     +,   8.0182253E-05,   8.4677966E-05,   8.9343055E-05
     +,   9.4179384E-05,   9.9188830E-05,   1.0437342E-04
     +,   1.0973580E-04,   1.1527853E-04,   1.2100551E-04
     +,   1.2692111E-04,   1.3303095E-04,   1.3934227E-04
     +,   1.4586406E-04,   1.5260759E-04,   1.5958697E-04
     +,   1.6681907E-04,   1.7432516E-04,   1.8213097E-04
     +,   1.9026655E-04,   1.9876874E-04,   2.0768007E-04
     +,   2.1705145E-04,   2.2694070E-04,   2.3741605E-04
     +,   2.4855416E-04,   2.6044372E-04,   2.7318319E-04
     +,   2.8688391E-04,   3.0167020E-04,   3.1767794E-04
     +,   3.3505590E-04,   3.5396696E-04,   3.7458687E-04
     +,   3.9710174E-04,   4.2171180E-04,   4.4862437E-04
     +,   4.7805934E-04,   5.1024038E-04,   5.4540019E-04
     +,   5.8377057E-04,   6.2558928E-04,   6.7108753E-04
     +,   7.2049745E-04,   7.7404600E-04,   8.3195022E-04
     +,   8.9441880E-04,   9.6165593E-04,   1.0338599E-03
     +,   1.1112159E-03,   1.1939185E-03,   1.2821546E-03
     +,   1.3761336E-03,   1.4760734E-03,   1.5822364E-03
     +,   1.6949172E-03,   1.8144880E-03,   1.9413878E-03
     +,   2.0761711E-03,   2.2195233E-03,   2.3722765E-03
     +,   2.5354510E-03,   2.7102965E-03,   2.8983208E-03
     +,   3.1013046E-03,   3.3213818E-03,   3.5610243E-03
     +,   3.8231267E-03,   4.1109715E-03,   4.4283052E-03
     +,   4.7792592E-03,   5.1684128E-03,   5.6006354E-03
     +,   6.0810777E-03,   6.6150222E-03,   7.2076474E-03
     +,   7.8638438E-03,   8.5879825E-03,   9.3835881E-03
     +,   1.0252931E-02,   1.1196873E-02,   1.2214376E-02
     +,   1.3302465E-02,   1.4455836E-02,   1.5667088E-02
     +,   1.6926521E-02,   1.8222734E-02,   1.9542722E-02
     +,   2.0872720E-02,   2.2198822E-02,   2.3507655E-02
     +,   2.4787271E-02,   2.6028052E-02,   2.7223246E-02
     +,   2.8369473E-02,   2.9467197E-02,   3.0520996E-02
     +,   3.1539459E-02,   3.2535020E-02,   3.3523865E-02
     +,   3.4525506E-02,   3.5562351E-02,   3.6659405E-02
     +,   3.7844233E-02,   3.9146937E-02,   4.0600620E-02
     +,   4.2242631E-02,   4.4116285E-02,   4.6273135E-02
     +,   4.8774730E-02,   5.1693827E-02,   5.5113416E-02
     +,   5.9122026E-02,   6.3804284E-02,   6.9228232E-02
     +,   7.5428784E-02,   8.2390532E-02,   9.0036020E-02
     +,   9.8223515E-02,   0.1067594    ,   0.1154307    
     +,   0.1240619    ,   0.1325887    ,   0.1411310    
     +,   0.1500318    ,   0.1598231    ,   0.1710910    
     +,   0.1842575    ,   0.1993529    ,   0.2158966    
     +,   0.2329669    ,   0.2494683    ,   0.2644833    
     +,   0.2775267    ,   0.2885586    ,   0.2978100    
     +,   0.3056752    ,   0.3129476    ,   0.3212639    
     +,   0.3330854    ,   0.3506857    ,   0.3748930    
     +,   0.4053153    ,   0.4422537    ,   0.4873652    
     +,   0.5402468    ,   0.5937411    ,   0.6348627    
     +,   0.6529639    ,   0.6475236    ,   0.6280346    
     +,   0.6080836    ,   0.6004679    ,   0.6144785    
     +,   0.6527618    ,   0.7101235    ,   0.7782735    
     +,   0.8538303    ,   0.9404091    ,    1.039358    
     +,    1.141791    ,    1.231879    ,    1.290256    
     +,    1.303249    ,    1.278206    ,    1.231807    
     +,    1.165637    ,    1.070341    ,   0.9417561    
     +,   0.7844817    ,   0.6105327    ,   0.4377654    
     +,   0.2849659    ,   0.1658376    ,   8.5056774E-02
     +,   3.8036607E-02,   1.4735634E-02,   4.9298708E-03
     +,   1.4220889E-03,   3.5335775E-04,   7.5614444E-05
     +,   1.3991819E-05,   2.3100858E-06,   4.1020965E-07
     +,   1.3680568E-07,   9.3994807E-08,   7.9985419E-08
     +,   7.0013670E-08,   6.1404137E-08,   5.3812965E-08
     +,   4.7113918E-08,   4.1207830E-08,   3.6006426E-08
     +,   3.1430218E-08,   2.7408246E-08,   2.3877142E-08
     +,   2.0780361E-08,   1.8067222E-08,   1.5692628E-08
     +,   1.3616539E-08,   1.1803421E-08,   1.0221558E-08
     +,   8.8428331E-09,   7.6425062E-09,   6.5985266E-09
     +,   5.6914713E-09,   4.9042121E-09,   4.2216675E-09
     +,   3.6304966E-09,   3.1189871E-09,   2.6768812E-09
     +,   2.2951672E-09,   1.9659236E-09,   1.6822287E-09
     +,   1.4380400E-09,   1.2280786E-09,   1.0477310E-09
     +,   8.9297258E-10,   7.6032025E-10,   6.4672934E-10
     +,   5.4955873E-10,   4.6652282E-10,   3.9564171E-10
     +,   3.3519576E-10,   2.8370073E-10,   2.3987753E-10
     +,   2.0262304E-10,   1.7098439E-10,   1.4414128E-10
     +,   1.2139223E-10,   1.0213120E-10,   8.5841168E-11
     +,   7.2077275E-11,   6.0460428E-11,   5.0665128E-11
     +,   4.2414742E-11,   3.5472351E-11,   2.9636960E-11
     +,   2.4736688E-11,   2.0626258E-11,   1.7181697E-11
     +,   1.4298077E-11,   1.1886647E-11,   9.8720017E-12
     +,   8.1907207E-12,   6.7889730E-12,   5.6215406E-12
     +,   4.6502095E-12,   3.8429060E-12,   3.1725709E-12
     +,   2.6165788E-12,   2.1558642E-12,   1.7745091E-12
     +,   1.4591535E-12,   1.1986541E-12
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_asha_htt120_mass = Yx/7.43527002272727
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_asha_htt60_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.1805902E-03,   4.3153376E-03
     +,   4.4526774E-03,   4.5927730E-03,   4.7358167E-03
     +,   4.8820227E-03,   5.0316323E-03,   5.1849145E-03
     +,   5.3421534E-03,   5.5036680E-03,   5.6697866E-03
     +,   5.8408598E-03,   6.0172495E-03,   6.1993310E-03
     +,   6.3874861E-03,   6.5821041E-03,   6.7835641E-03
     +,   6.9922544E-03,   7.2085527E-03,   7.4328221E-03
     +,   7.6654241E-03,   7.9067014E-03,   8.1569925E-03
     +,   8.4166350E-03,   8.6859446E-03,   8.9652538E-03
     +,   9.2549035E-03,   9.5552597E-03,   9.8667024E-03
     +,   1.0189671E-02,   1.0524665E-02,   1.0872243E-02
     +,   1.1233066E-02,   1.1607897E-02,   1.1997615E-02
     +,   1.2403246E-02,   1.2825958E-02,   1.3267096E-02
     +,   1.3728214E-02,   1.4211054E-02,   1.4717622E-02
     +,   1.5250213E-02,   1.5811456E-02,   1.6404385E-02
     +,   1.7032523E-02,   1.7700016E-02,   1.8411726E-02
     +,   1.9173441E-02,   1.9992029E-02,   2.0875657E-02
     +,   2.1834029E-02,   2.2878602E-02,   2.4022784E-02
     +,   2.5282241E-02,   2.6674794E-02,   2.8220830E-02
     +,   2.9943012E-02,   3.1866290E-02,   3.4017682E-02
     +,   3.6425948E-02,   3.9120946E-02,   4.2133264E-02
     +,   4.5493029E-02,   4.9229369E-02,   5.3369176E-02
     +,   5.7935573E-02,   6.2947884E-02,   6.8420015E-02
     +,   7.4361995E-02,   8.0780223E-02,   8.7681390E-02
     +,   9.5074899E-02,   0.1029785    ,   0.1114189    
     +,   0.1204333    ,   0.1300630    ,   0.1403413    
     +,   0.1512757    ,   0.1628307    ,   0.1749088    
     +,   0.1873439    ,   0.1999133    ,   0.2123630    
     +,   0.2244563    ,   0.2360200    ,   0.2469875    
     +,   0.2574103    ,   0.2674392    ,   0.2772628    
     +,   0.2870369    ,   0.2968122    ,   0.3065031    
     +,   0.3159136    ,   0.3248149    ,   0.3330573    
     +,   0.3406683    ,   0.3479056    ,   0.3552250    
     +,   0.3631825    ,   0.3722896    ,   0.3828793    
     +,   0.3950208    ,   0.4085163    ,   0.4229647    
     +,   0.4378747    ,   0.4527737    ,   0.4672776    
     +,   0.4811211    ,   0.4941642    ,   0.5063884    
     +,   0.5178593    ,   0.5286545    ,   0.5387313    
     +,   0.5478429    ,   0.5556043    ,   0.5617616    
     +,   0.5665515    ,   0.5709869    ,   0.5769264    
     +,   0.5869063    ,   0.6037384    ,   0.6298138    
     +,   0.6661428    ,   0.7114547    ,   0.7619432    
     +,   0.8121827    ,   0.8572150    ,   0.8947994    
     +,   0.9264166    ,   0.9559691    ,   0.9867434    
     +,    1.018616    ,    1.047550    ,    1.067697    
     +,    1.074559    ,    1.067000    ,    1.047023    
     +,    1.017761    ,   0.9811538    ,   0.9370749    
     +,   0.8845941    ,   0.8242913    ,   0.7594642    
     +,   0.6950698    ,   0.6353620    ,   0.5822473    
     +,   0.5354131    ,   0.4935728    ,   0.4555679    
     +,   0.4207188    ,   0.3886777    ,   0.3592370    
     +,   0.3323060    ,   0.3079683    ,   0.2864722    
     +,   0.2681064    ,   0.2530290    ,   0.2411492    
     +,   0.2321078    ,   0.2253369    ,   0.2201588    
     +,   0.2158843    ,   0.2118876    ,   0.2076539    
     +,   0.2028056    ,   0.1971141    ,   0.1904971    
     +,   0.1830049    ,   0.1747939    ,   0.1660922    
     +,   0.1571641    ,   0.1482740    ,   0.1396586    
     +,   0.1315089    ,   0.1239630    ,   0.1171034    
     +,   0.1109641    ,   0.1055404    ,   0.1007977    
     +,   9.6681885E-02,   9.3127079E-02,   9.0062678E-02
     +,   8.7417163E-02,   8.5120521E-02,   8.3106004E-02
     +,   8.1310697E-02,   7.9675540E-02,   7.8145258E-02
     +,   7.6668419E-02,   7.5198106E-02,   7.3692106E-02
     +,   7.2113417E-02,   7.0431694E-02,   6.8623327E-02
     +,   6.6672362E-02,   6.4570524E-02,   6.2317576E-02
     +,   5.9920747E-02,   5.7393864E-02,   5.4756537E-02
     +,   5.2033003E-02,   4.9250700E-02,   4.6438519E-02
     +,   4.3625765E-02,   4.0840928E-02,   3.8110252E-02
     +,   3.5457019E-02,   3.2901146E-02,   3.0458666E-02
     +,   2.8141411E-02,   2.5957325E-02,   2.3910811E-02
     +,   2.2003008E-02,   2.0232117E-02,   1.8594136E-02
     +,   1.7083377E-02,   1.5692923E-02,   1.4414990E-02
     +,   1.3241404E-02,   1.2164033E-02,   1.1174813E-02
     +,   1.0266068E-02,   9.4306758E-03,   8.6620664E-03
     +,   7.9542100E-03,   7.3016961E-03,   6.6997022E-03
     +,   6.1439499E-03,   5.6305858E-03,   5.1561920E-03
     +,   4.7177533E-03,   4.3125693E-03,   3.9381855E-03
     +,   3.5923852E-03,   3.2731849E-03,   2.9787330E-03
     +,   2.7073277E-03,   2.4574099E-03,   2.2275238E-03
     +,   2.0162950E-03,   1.8224374E-03,   1.6447541E-03
     +,   1.4821176E-03,   1.3334546E-03,   1.1977562E-03
     +,   1.0740798E-03,   9.6153701E-04,   8.5928431E-04
     +,   7.6652993E-04,   6.8253826E-04,   6.0661067E-04
     +,   5.3809327E-04,   4.7637857E-04,   4.2089800E-04
     +,   3.7111726E-04,   3.2653878E-04,   2.8670242E-04
     +,   2.5118006E-04,   2.1957212E-04,   1.9150885E-04
     +,   1.6665029E-04,   1.4468239E-04,   1.2531439E-04
     +,   1.0827946E-04,   9.3334449E-05,   8.0255442E-05
     +,   6.8838192E-05,   5.8897727E-05,   5.0265939E-05
     +,   4.2790129E-05,   3.6332640E-05,   3.0770050E-05
     +,   2.5991567E-05,   2.1897809E-05,   1.8400269E-05
     +,   1.5420634E-05,   1.2889172E-05,   1.0744666E-05
     +,   8.9329833E-06,   7.4069203E-06,   6.1250194E-06
     +,   5.0513604E-06,   4.1546314E-06,   3.4078698E-06
     +,   2.7877397E-06,   2.2742806E-06,   1.8503505E-06
     +,   1.5013368E-06,   1.2148445E-06,   9.8033593E-07
     +,   7.8894374E-07,   6.3317998E-07,   5.0678523E-07
     +,   4.0451033E-07,   3.2199591E-07,   2.5561053E-07
     +,   2.0235851E-07,   1.5976130E-07,   1.2578700E-07
     +,   9.8765874E-08,   7.7337830E-08
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_asha_htt60_mass = Yx/11.9263374255319
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_asha_htt65_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.8268178E-03,   2.9246951E-03
     +,   3.0240295E-03,   3.1246804E-03,   3.2265056E-03
     +,   3.3293623E-03,   3.4331107E-03,   3.5376130E-03
     +,   3.6427365E-03,   3.7483613E-03,   3.8543704E-03
     +,   3.9606644E-03,   4.0671551E-03,   4.1737729E-03
     +,   4.2804638E-03,   4.3871985E-03,   4.4939709E-03
     +,   4.6007964E-03,   4.7077225E-03,   4.8148213E-03
     +,   4.9221972E-03,   5.0299880E-03,   5.1383562E-03
     +,   5.2475133E-03,   5.3576841E-03,   5.4691429E-03
     +,   5.5821855E-03,   5.6971433E-03,   5.8143730E-03
     +,   5.9342575E-03,   6.0572047E-03,   6.1836378E-03
     +,   6.3139950E-03,   6.4487197E-03,   6.5882620E-03
     +,   6.7330697E-03,   6.8835798E-03,   7.0402147E-03
     +,   7.2033852E-03,   7.3734657E-03,   7.5508216E-03
     +,   7.7357772E-03,   7.9286387E-03,   8.1296870E-03
     +,   8.3391899E-03,   8.5574081E-03,   8.7846145E-03
     +,   9.0211043E-03,   9.2672408E-03,   9.5234634E-03
     +,   9.7903479E-03,   1.0068625E-02,   1.0359265E-02
     +,   1.0663547E-02,   1.0983079E-02,   1.1319975E-02
     +,   1.1676889E-02,   1.2057153E-02,   1.2464950E-02
     +,   1.2905422E-02,   1.3384905E-02,   1.3911144E-02
     +,   1.4493489E-02,   1.5143279E-02,   1.5874172E-02
     +,   1.6702417E-02,   1.7647468E-02,   1.8732280E-02
     +,   1.9983938E-02,   2.1433910E-02,   2.3118643E-02
     +,   2.5079360E-02,   2.7362300E-02,   3.0017635E-02
     +,   3.3098739E-02,   3.6660030E-02,   4.0754061E-02
     +,   4.5427971E-02,   5.0719861E-02,   5.6654263E-02
     +,   6.3237786E-02,   7.0458606E-02,   7.8285694E-02
     +,   8.6676195E-02,   9.5583424E-02,   0.1049739    
     +,   0.1148421    ,   0.1252286    ,   0.1362238    
     +,   0.1479655    ,   0.1606126    ,   0.1743048    
     +,   0.1891121    ,   0.2049898    ,   0.2217485    
     +,   0.2390511    ,   0.2564510    ,   0.2734530    
     +,   0.2896027    ,   0.3045748    ,   0.3182632    
     +,   0.3308376    ,   0.3427649    ,   0.3547715    
     +,   0.3677527    ,   0.3826170    ,   0.4000858    
     +,   0.4204652    ,   0.4434681    ,   0.4681752    
     +,   0.4932245    ,   0.5172476    ,   0.5393766    
     +,   0.5596276    ,   0.5789589    ,   0.5990134    
     +,   0.6216871    ,   0.6487123    ,   0.6813198    
     +,   0.7199690    ,   0.7640614    ,   0.8117530    
     +,   0.8599619    ,   0.9046165    ,   0.9412280    
     +,   0.9661792    ,   0.9789770    ,   0.9844477    
     +,   0.9926772    ,    1.015057    ,    1.057658    
     +,    1.116475    ,    1.179897    ,    1.238684    
     +,    1.295234    ,    1.361506    ,    1.445359    
     +,    1.537800    ,    1.613601    ,    1.645176    
     +,    1.618312    ,    1.538327    ,    1.424579    
     +,    1.299848    ,    1.181891    ,    1.080326    
     +,   0.9977223    ,   0.9318799    ,   0.8777580    
     +,   0.8293982    ,   0.7818999    ,   0.7326001    
     +,   0.6811116    ,   0.6287392    ,   0.5777518    
     +,   0.5305922    ,   0.4890315    ,   0.4535608    
     +,   0.4233494    ,   0.3967823    ,   0.3722253    
     +,   0.3485960    ,   0.3255338    ,   0.3032298    
     +,   0.2821356    ,   0.2627042    ,   0.2452390    
     +,   0.2298410    ,   0.2164257    ,   0.2047807    
     +,   0.1946269    ,   0.1856737    ,   0.1776549    
     +,   0.1703485    ,   0.1635833    ,   0.1572348    
     +,   0.1512194    ,   0.1454865    ,   0.1400098    
     +,   0.1347812    ,   0.1298026    ,   0.1250819    
     +,   0.1206273    ,   0.1164432    ,   0.1125275    
     +,   0.1088697    ,   0.1054490    ,   0.1022348    
     +,   9.9186957E-02,   9.6258946E-02,   9.3399972E-02
     +,   9.0558663E-02,   8.7687291E-02,   8.4744647E-02
     +,   8.1698664E-02,   7.8528129E-02,   7.5223729E-02
     +,   7.1787372E-02,   6.8230949E-02,   6.4574935E-02
     +,   6.0846459E-02,   5.7076994E-02,   5.3300176E-02
     +,   4.9550213E-02,   4.5860410E-02,   4.2261478E-02
     +,   3.8780805E-02,   3.5441983E-02,   3.2264296E-02
     +,   2.9262278E-02,   2.6446065E-02,   2.3821795E-02
     +,   2.1391742E-02,   1.9154608E-02,   1.7106270E-02
     +,   1.5240398E-02,   1.3548743E-02,   1.2021625E-02
     +,   1.0648453E-02,   9.4182538E-03,   8.3196992E-03
     +,   7.3415604E-03,   6.4729466E-03,   5.7034036E-03
     +,   5.0229724E-03,   4.4223494E-03,   3.8929470E-03
     +,   3.4268724E-03,   3.0169007E-03,   2.6564989E-03
     +,   2.3398150E-03,   2.0616136E-03,   1.8172181E-03
     +,   1.6024864E-03,   1.4137868E-03,   1.2479026E-03
     +,   1.1020137E-03,   9.7365997E-04,   8.6068746E-04
     +,   7.6120539E-04,   6.7356194E-04,   5.9631927E-04
     +,   5.2821799E-04,   4.6815010E-04,   4.1514571E-04
     +,   3.6835612E-04,   3.2703581E-04,   2.9052634E-04
     +,   2.5824935E-04,   2.2969842E-04,   2.0442541E-04
     +,   1.8203621E-04,   1.6218585E-04,   1.4457104E-04
     +,   1.2892431E-04,   1.1501121E-04,   1.0262731E-04
     +,   9.1593327E-05,   8.1751648E-05,   7.2964511E-05
     +,   6.5112035E-05,   5.8089143E-05,   5.1803479E-05
     +,   4.6174177E-05,   4.1130759E-05,   3.6610785E-05
     +,   3.2559310E-05,   2.8928089E-05,   2.5674290E-05
     +,   2.2759759E-05,   2.0150472E-05,   1.7816223E-05
     +,   1.5729907E-05,   1.3867011E-05,   1.2205488E-05
     +,   1.0725559E-05,   9.4091183E-06,   8.2399483E-06
     +,   7.2031621E-06,   6.2853696E-06,   5.4742950E-06
     +,   4.7588824E-06,   4.1289973E-06,   3.5755302E-06
     +,   3.0901442E-06,   2.6653533E-06,   2.2943491E-06
     +,   1.9709857E-06,   1.6897642E-06,   1.4456995E-06
     +,   1.2343523E-06,   1.0517225E-06,   8.9426447E-07
     +,   7.5879711E-07,   6.4251486E-07,   5.4291399E-07
     +,   4.5779714E-07,   3.8521449E-07,   3.2346213E-07
     +,   2.7103783E-07,   2.2663417E-07
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_asha_htt65_mass = Yx/14.3110576875
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_asha_htt70_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.0658378E-03,   2.1420664E-03
     +,   2.2203205E-03,   2.3006639E-03,   2.3831616E-03
     +,   2.4678865E-03,   2.5549135E-03,   2.6443191E-03
     +,   2.7361868E-03,   2.8306055E-03,   2.9276644E-03
     +,   3.0274547E-03,   3.1300730E-03,   3.2356190E-03
     +,   3.3441931E-03,   3.4558985E-03,   3.5708402E-03
     +,   3.6891256E-03,   3.8108611E-03,   3.9361580E-03
     +,   4.0651220E-03,   4.1978634E-03,   4.3344912E-03
     +,   4.4751167E-03,   4.6198415E-03,   4.7687767E-03
     +,   4.9220212E-03,   5.0796764E-03,   5.2418397E-03
     +,   5.4085962E-03,   5.5800388E-03,   5.7562422E-03
     +,   5.9372741E-03,   6.1232019E-03,   6.3140723E-03
     +,   6.5099285E-03,   6.7107999E-03,   6.9166953E-03
     +,   7.1276305E-03,   7.3435814E-03,   7.5645423E-03
     +,   7.7904779E-03,   8.0213612E-03,   8.2571562E-03
     +,   8.4978417E-03,   8.7434128E-03,   8.9938929E-03
     +,   9.2493575E-03,   9.5099434E-03,   9.7758761E-03
     +,   1.0047498E-02,   1.0325311E-02,   1.0609974E-02
     +,   1.0902416E-02,   1.1203775E-02,   1.1515548E-02
     +,   1.1839554E-02,   1.2178023E-02,   1.2533605E-02
     +,   1.2909395E-02,   1.3308973E-02,   1.3736366E-02
     +,   1.4196031E-02,   1.4692803E-02,   1.5231864E-02
     +,   1.5818510E-02,   1.6458174E-02,   1.7156078E-02
     +,   1.7917227E-02,   1.8746002E-02,   1.9646142E-02
     +,   2.0620286E-02,   2.1670042E-02,   2.2795521E-02
     +,   2.3995453E-02,   2.5267098E-02,   2.6606131E-02
     +,   2.8006908E-02,   2.9462866E-02,   3.0966828E-02
     +,   3.2511555E-02,   3.4090836E-02,   3.5700016E-02
     +,   3.7337523E-02,   3.9005656E-02,   4.0712226E-02
     +,   4.2471159E-02,   4.4304010E-02,   4.6240114E-02
     +,   4.8317455E-02,   5.0582588E-02,   5.3090390E-02
     +,   5.5904109E-02,   5.9096035E-02,   6.2748440E-02
     +,   6.6955842E-02,   7.1829997E-02,   7.7504158E-02
     +,   8.4140204E-02,   9.1930896E-02,   0.1010998    
     +,   0.1118883    ,   0.1245329    ,   0.1392260    
     +,   0.1560710    ,   0.1750363    ,   0.1959233    
     +,   0.2183686    ,   0.2418872    ,   0.2659552    
     +,   0.2901280    ,   0.3141781    ,   0.3382028    
     +,   0.3626671    ,   0.3883063    ,   0.4158763    
     +,   0.4458116    ,   0.4780000    ,   0.5118768    
     +,   0.5468818    ,   0.5829572    ,   0.6205978    
     +,   0.6603209    ,   0.7020538    ,   0.7452635    
     +,   0.7901320    ,   0.8389717    ,   0.8963444    
     +,   0.9669815    ,    1.052348    ,    1.148322    
     +,    1.245485    ,    1.330987    ,    1.390940    
     +,    1.416763    ,    1.416781    ,    1.420629    
     +,    1.460342    ,    1.539539    ,    1.628743    
     +,    1.700667    ,    1.763309    ,    1.842633    
     +,    1.937492    ,    2.015024    ,    2.053045    
     +,    2.063463    ,    2.064574    ,    2.045768    
     +,    1.971585    ,    1.819139    ,    1.607571    
     +,    1.388765    ,    1.208554    ,    1.078039    
     +,   0.9800329    ,   0.8940275    ,   0.8106658    
     +,   0.7300570    ,   0.6553443    ,   0.5892255    
     +,   0.5332441    ,   0.4878381    ,   0.4524856    
     +,   0.4259869    ,   0.4067633    ,   0.3930441    
     +,   0.3829683    ,   0.3746892    ,   0.3665134    
     +,   0.3570533    ,   0.3453519    ,   0.3309554    
     +,   0.3139146    ,   0.2947147    ,   0.2741475    
     +,   0.2531478    ,   0.2326350    ,   0.2133792    
     +,   0.1959124    ,   0.1805026    ,   0.1671736    
     +,   0.1557601    ,   0.1459796    ,   0.1375053    
     +,   0.1300237    ,   0.1232713    ,   0.1170498    
     +,   0.1112254    ,   0.1057166    ,   0.1004775    
     +,   9.5482051E-02,   9.0712205E-02,   8.6150751E-02
     +,   8.1777595E-02,   7.7570930E-02,   7.3508814E-02
     +,   6.9571681E-02,   6.5744251E-02,   6.2016577E-02
     +,   5.8384884E-02,   5.4850556E-02,   5.1418621E-02
     +,   4.8096843E-02,   4.4894304E-02,   4.1819815E-02
     +,   3.8880933E-02,   3.6083784E-02,   3.3432268E-02
     +,   3.0927926E-02,   2.8570183E-02,   2.6356747E-02
     +,   2.4283689E-02,   2.2345785E-02,   2.0536961E-02
     +,   1.8850759E-02,   1.7280467E-02,   1.5819298E-02
     +,   1.4460676E-02,   1.3198463E-02,   1.2026795E-02
     +,   1.0940229E-02,   9.9338265E-03,   9.0030255E-03
     +,   8.1435349E-03,   7.3513701E-03,   6.6228369E-03
     +,   5.9544109E-03,   5.3426712E-03,   4.7843065E-03
     +,   4.2761266E-03,   3.8149997E-03,   3.3978203E-03
     +,   3.0215548E-03,   2.6832616E-03,   2.3800421E-03
     +,   2.1090861E-03,   1.8676987E-03,   1.6532944E-03
     +,   1.4633939E-03,   1.2956518E-03,   1.1478751E-03
     +,   1.0180112E-03,   9.0414536E-04,   8.0451311E-04
     +,   7.1750191E-04,   6.4164028E-04,   5.7558797E-04
     +,   5.1813712E-04,   4.6820845E-04,   4.2483263E-04
     +,   3.8714797E-04,   3.5439382E-04,   3.2589916E-04
     +,   3.0107229E-04,   2.7939607E-04,   2.6042064E-04
     +,   2.4375507E-04,   2.2905966E-04,   2.1604120E-04
     +,   2.0444856E-04,   1.9406607E-04,   1.8470884E-04
     +,   1.7621942E-04,   1.6846490E-04,   1.6133224E-04
     +,   1.5472612E-04,   1.4856686E-04,   1.4278805E-04
     +,   1.3733369E-04,   1.3215769E-04,   1.2722221E-04
     +,   1.2249622E-04,   1.1795402E-04,   1.1357491E-04
     +,   1.0934246E-04,   1.0524306E-04,   1.0126633E-04
     +,   9.7403652E-05,   9.3648698E-05,   8.9996065E-05
     +,   8.6442116E-05,   8.2983541E-05,   7.9618287E-05
     +,   7.6344368E-05,   7.3160663E-05,   7.0065973E-05
     +,   6.7059402E-05,   6.4140397E-05,   6.1308107E-05
     +,   5.8562124E-05,   5.5901637E-05,   5.3326145E-05
     +,   5.0834769E-05,   4.8426878E-05,   4.6101457E-05
     +,   4.3857683E-05,   4.1694399E-05,   3.9610593E-05
     +,   3.7604943E-05,   3.5676258E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_asha_htt70_mass = Yx/16.418481
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_asha_htt75_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  9.6384599E-04,   1.0065319E-03
     +,   1.0510151E-03,   1.0973228E-03,   1.1454758E-03
     +,   1.1954908E-03,   1.2473763E-03,   1.3011356E-03
     +,   1.3567636E-03,   1.4142509E-03,   1.4735771E-03
     +,   1.5347156E-03,   1.5976311E-03,   1.6622803E-03
     +,   1.7286114E-03,   1.7965643E-03,   1.8660714E-03
     +,   1.9370557E-03,   2.0094337E-03,   2.0831127E-03
     +,   2.1579948E-03,   2.2339749E-03,   2.3109417E-03
     +,   2.3887835E-03,   2.4673766E-03,   2.5466036E-03
     +,   2.6263411E-03,   2.7064676E-03,   2.7868652E-03
     +,   2.8674167E-03,   2.9480162E-03,   3.0285637E-03
     +,   3.1089715E-03,   3.1891677E-03,   3.2690966E-03
     +,   3.3487249E-03,   3.4280426E-03,   3.5070686E-03
     +,   3.5858580E-03,   3.6644945E-03,   3.7431130E-03
     +,   3.8218871E-03,   3.9010439E-03,   3.9808676E-03
     +,   4.0616975E-03,   4.1439445E-03,   4.2280839E-03
     +,   4.3146699E-03,   4.4043320E-03,   4.4977823E-03
     +,   4.5958199E-03,   4.6993298E-03,   4.8092869E-03
     +,   4.9267593E-03,   5.0528920E-03,   5.1889257E-03
     +,   5.3361724E-03,   5.4960195E-03,   5.6699105E-03
     +,   5.8593391E-03,   6.0658283E-03,   6.2909168E-03
     +,   6.5361168E-03,   6.8029175E-03,   7.0927506E-03
     +,   7.4069244E-03,   7.7466583E-03,   8.1129801E-03
     +,   8.5067758E-03,   8.9286901E-03,   9.3791857E-03
     +,   9.8584555E-03,   1.0366534E-02,   1.0903178E-02
     +,   1.1468057E-02,   1.2060726E-02,   1.2680705E-02
     +,   1.3327602E-02,   1.4001306E-02,   1.4702100E-02
     +,   1.5430803E-02,   1.6189113E-02,   1.6979616E-02
     +,   1.7806243E-02,   1.8674247E-02,   1.9590570E-02
     +,   2.0563772E-02,   2.1604337E-02,   2.2724438E-02
     +,   2.3938062E-02,   2.5260827E-02,   2.6709633E-02
     +,   2.8302524E-02,   3.0058382E-02,   3.1996604E-02
     +,   3.4136374E-02,   3.6496706E-02,   3.9095297E-02
     +,   4.1948464E-02,   4.5069784E-02,   4.8469890E-02
     +,   5.2154914E-02,   5.6126706E-02,   6.0381260E-02
     +,   6.4909205E-02,   6.9695212E-02,   7.4717440E-02
     +,   7.9948291E-02,   8.5355729E-02,   9.0907738E-02
     +,   9.6580602E-02,   0.1023771    ,   0.1083511    
     +,   0.1146437    ,   0.1215223    ,   0.1294225    
     +,   0.1389732    ,   0.1509982    ,   0.1664605    
     +,   0.1863409    ,   0.2114470    ,   0.2422003    
     +,   0.2785032    ,   0.3197545    ,   0.3650017    
     +,   0.4131133    ,   0.4629578    ,   0.5137326    
     +,   0.5657230    ,   0.6210676    ,   0.6833414    
     +,   0.7547717    ,   0.8322561    ,   0.9062707    
     +,   0.9671216    ,    1.016414    ,    1.071627    
     +,    1.153103    ,    1.264816    ,    1.394509    
     +,    1.532005    ,    1.674249    ,    1.813928    
     +,    1.940972    ,    2.051054    ,    2.143553    
     +,    2.223652    ,    2.313386    ,    2.444997    
     +,    2.602381    ,    2.694427    ,    2.659264    
     +,    2.549035    ,    2.431285    ,    2.298840    
     +,    2.141961    ,    1.999518    ,    1.890278    
     +,    1.776943    ,    1.619703    ,    1.417032    
     +,    1.199340    ,    1.006540    ,   0.8645961    
     +,   0.7727456    ,   0.7119300    ,   0.6626779    
     +,   0.6144620    ,   0.5648688    ,   0.5159512    
     +,   0.4712801    ,   0.4336305    ,   0.4035424    
     +,   0.3793377    ,   0.3583107    ,   0.3381063    
     +,   0.3175108    ,   0.2964644    ,   0.2755848    
     +,   0.2556081    ,   0.2370345    ,   0.2200438    
     +,   0.2045912    ,   0.1905492    ,   0.1778067    
     +,   0.1662963    ,   0.1559734    ,   0.1467826    
     +,   0.1386383    ,   0.1314203    ,   0.1249832    
     +,   0.1191732    ,   0.1138439    ,   0.1088672    
     +,   0.1041386    ,   9.9578910E-02,   9.5131904E-02
     +,   9.0760455E-02,   8.6442284E-02,   8.2165979E-02
     +,   7.7928454E-02,   7.3732436E-02,   6.9584191E-02
     +,   6.5492727E-02,   6.1469436E-02,   5.7526469E-02
     +,   5.3676739E-02,   4.9933471E-02,   4.6309676E-02
     +,   4.2817168E-02,   3.9466728E-02,   3.6267553E-02
     +,   3.3227012E-02,   3.0350203E-02,   2.7640088E-02
     +,   2.5097817E-02,   2.2722604E-02,   2.0511914E-02
     +,   1.8461838E-02,   1.6567584E-02,   1.4823306E-02
     +,   1.3222575E-02,   1.1758663E-02,   1.0424531E-02
     +,   9.2129195E-03,   8.1164995E-03,   7.1280221E-03
     +,   6.2402594E-03,   5.4460065E-03,   4.7381930E-03
     +,   4.1099419E-03,   3.5545561E-03,   3.0655181E-03
     +,   2.6365789E-03,   2.2618177E-03,   1.9355947E-03
     +,   1.6526225E-03,   1.4079997E-03,   1.1972029E-03
     +,   1.0160777E-03,   8.6085853E-04,   7.2816800E-04
     +,   6.1498734E-04,   5.1863235E-04,   4.3674192E-04
     +,   3.6725512E-04,   3.0837764E-04,   2.5855220E-04
     +,   2.1643710E-04,   1.8088384E-04,   1.5090495E-04
     +,   1.2565737E-04,   1.0442365E-04,   8.6592278E-05
     +,   7.1641509E-05,   5.9127695E-05,   4.8674265E-05
     +,   3.9960745E-05,   3.2713975E-05,   2.6701853E-05
     +,   2.1727470E-05,   1.7623481E-05,   1.4247576E-05
     +,   1.1479237E-05,   9.2167029E-06,   7.3737947E-06
     +,   5.8779228E-06,   4.6681876E-06,   3.6935260E-06
     +,   2.9112202E-06,   2.2857296E-06,   1.7876157E-06
     +,   1.3925428E-06,   1.0804596E-06,   8.3494126E-07
     +,   6.4260655E-07,   4.9255709E-07,   3.7600000E-07
     +,   2.8583912E-07,   2.1640021E-07,   1.6314745E-07
     +,   1.2248735E-07,   9.1574961E-08,   6.8177350E-08
     +,   5.0543889E-08,   3.7313612E-08,   2.7430184E-08
     +,   2.0079160E-08,   1.4636067E-08,   1.0623196E-08
     +,   7.6779560E-09,   5.5256675E-09,   3.9598755E-09
     +,   2.8257026E-09,   2.0078372E-09,   1.4206206E-09
     +,   1.0008879E-09,   7.0216927E-10,   4.9052062E-10
     +,   3.4121100E-10,   2.3634750E-10
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_asha_htt75_mass = Yx/17.59506882
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_asha_htt80_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  6.0377695E-04,   6.2898837E-04
     +,   6.5480464E-04,   6.8121153E-04,   7.0819218E-04
     +,   7.3572894E-04,   7.6380296E-04,   7.9239387E-04
     +,   8.2147971E-04,   8.5104007E-04,   8.8105188E-04
     +,   9.1149309E-04,   9.4234105E-04,   9.7357488E-04
     +,   1.0051748E-03,   1.0371216E-03,   1.0693999E-03
     +,   1.1019957E-03,   1.1349003E-03,   1.1681074E-03
     +,   1.2016168E-03,   1.2354341E-03,   1.2695707E-03
     +,   1.3040478E-03,   1.3388918E-03,   1.3741415E-03
     +,   1.4098440E-03,   1.4460596E-03,   1.4828590E-03
     +,   1.5203272E-03,   1.5585639E-03,   1.5976824E-03
     +,   1.6378135E-03,   1.6791038E-03,   1.7217177E-03
     +,   1.7658363E-03,   1.8116598E-03,   1.8594072E-03
     +,   1.9093181E-03,   1.9616459E-03,   2.0166680E-03
     +,   2.0746768E-03,   2.1359855E-03,   2.2009220E-03
     +,   2.2698322E-03,   2.3430767E-03,   2.4210333E-03
     +,   2.5040898E-03,   2.5926491E-03,   2.6871241E-03
     +,   2.7879362E-03,   2.8955191E-03,   3.0103058E-03
     +,   3.1327466E-03,   3.2632796E-03,   3.4023612E-03
     +,   3.5504394E-03,   3.7079658E-03,   3.8753883E-03
     +,   4.0531526E-03,   4.2417035E-03,   4.4414806E-03
     +,   4.6529043E-03,   4.8764064E-03,   5.1124096E-03
     +,   5.3613042E-03,   5.6235045E-03,   5.8993739E-03
     +,   6.1893030E-03,   6.4936238E-03,   6.8126922E-03
     +,   7.1468065E-03,   7.4962783E-03,   7.8613553E-03
     +,   8.2422858E-03,   8.6392965E-03,   9.0525541E-03
     +,   9.4821909E-03,   9.9283336E-03,   1.0391083E-02
     +,   1.0870472E-02,   1.1366582E-02,   1.1879423E-02
     +,   1.2409081E-02,   1.2955603E-02,   1.3519160E-02
     +,   1.4099917E-02,   1.4698219E-02,   1.5314461E-02
     +,   1.5949242E-02,   1.6603339E-02,   1.7277710E-02
     +,   1.7973499E-02,   1.8692156E-02,   1.9435380E-02
     +,   2.0205097E-02,   2.1003611E-02,   2.1833470E-02
     +,   2.2697672E-02,   2.3599580E-02,   2.4543177E-02
     +,   2.5532907E-02,   2.6574144E-02,   2.7673116E-02
     +,   2.8837414E-02,   3.0076373E-02,   3.1401642E-02
     +,   3.2828137E-02,   3.4375444E-02,   3.6069248E-02
     +,   3.7943128E-02,   4.0040825E-02,   4.2417366E-02
     +,   4.5140203E-02,   4.8287544E-02,   5.1945437E-02
     +,   5.6200013E-02,   6.1128806E-02,   6.6787146E-02
     +,   7.3196895E-02,   8.0336496E-02,   8.8137366E-02
     +,   9.6491784E-02,   0.1052735    ,   0.1143688    
     +,   0.1237152    ,   0.1333412    ,   0.1433896    
     +,   0.1541239    ,   0.1659048    ,   0.1791636    
     +,   0.1943876    ,   0.2121682    ,   0.2333036    
     +,   0.2589442    ,   0.2906808    ,   0.3304941    
     +,   0.3804677    ,   0.4421887    ,   0.5158943    
     +,   0.6000364    ,   0.6928329    ,   0.7966347    
     +,   0.9209226    ,    1.074885    ,    1.252376    
     +,    1.436019    ,    1.626575    ,    1.837876    
     +,    2.039325    ,    2.163588    ,    2.218369    
     +,    2.305194    ,    2.468830    ,    2.662249    
     +,    2.880363    ,    3.114402    ,    3.232253    
     +,    3.193869    ,    3.145238    ,    3.080740    
     +,    2.952798    ,    2.827185    ,    2.650388    
     +,    2.354727    ,    2.025278    ,    1.766309    
     +,    1.591880    ,    1.460836    ,    1.334412    
     +,    1.198958    ,    1.059278    ,   0.9252051    
     +,   0.8034981    ,   0.6968534    ,   0.6062419    
     +,   0.5319406    ,   0.4732003    ,   0.4282364    
     +,   0.3946440    ,   0.3697421    ,   0.3508084    
     +,   0.3353646    ,   0.3214572    ,   0.3078085    
     +,   0.2937948    ,   0.2793081    ,   0.2645571    
     +,   0.2498800    ,   0.2356094    ,   0.2220089    
     +,   0.2092661    ,   0.1975059    ,   0.1867961    
     +,   0.1771385    ,   0.1684548    ,   0.1605835    
     +,   0.1532928    ,   0.1463127    ,   0.1393759    
     +,   0.1322583    ,   0.1248036    ,   0.1169365    
     +,   0.1086602    ,   0.1000468    ,   9.1218889E-02
     +,   8.2331166E-02,   7.3553286E-02,   6.5052263E-02
     +,   5.6978110E-02,   4.9453709E-02,   4.2568788E-02
     +,   3.6376674E-02,   3.0895146E-02,   2.6111308E-02
     +,   2.1988105E-02,   1.8471204E-02,   1.5495967E-02
     +,   1.2994085E-02,   1.0898652E-02,   9.1471691E-03
     +,   7.6838615E-03,   6.4605768E-03,   5.4366351E-03
     +,   4.5781960E-03,   3.8574685E-03,   3.2517659E-03
     +,   2.7425017E-03,   2.3143501E-03,   1.9546140E-03
     +,   1.6526985E-03,   1.3996682E-03,   1.1879221E-03
     +,   1.0109829E-03,   8.6332741E-04,   7.4021565E-04
     +,   6.3759938E-04,   5.5203604E-04,   4.8060229E-04
     +,   4.2082445E-04,   3.7062634E-04,   3.2827837E-04
     +,   2.9234550E-04,   2.6164384E-04,   2.3520573E-04
     +,   2.1224709E-04,   1.9213551E-04,   1.7436314E-04
     +,   1.5852581E-04,   1.4430510E-04,   1.3144859E-04
     +,   1.1975793E-04,   1.0907813E-04,   9.9287121E-05
     +,   9.0287584E-05,   8.2001941E-05,   7.4367672E-05
     +,   6.7333109E-05,   6.0854116E-05,   5.4892462E-05
     +,   4.9414572E-05,   4.4389846E-05,   3.9789604E-05
     +,   3.5586807E-05,   3.1756164E-05,   2.8272972E-05
     +,   2.5113486E-05,   2.2255013E-05,   1.9675668E-05
     +,   1.7354238E-05,   1.5270385E-05,   1.3404851E-05
     +,   1.1739277E-05,   1.0256149E-05,   8.9389796E-06
     +,   7.7723971E-06,   6.7418746E-06,   5.8340320E-06
     +,   5.0363356E-06,   4.3373279E-06,   3.7263808E-06
     +,   3.1938421E-06,   2.7308440E-06,   2.3293853E-06
     +,   1.9821784E-06,   1.6826941E-06,   1.4250401E-06
     +,   1.2039401E-06,   1.0147154E-06,   8.5317919E-07
     +,   7.1564483E-07,   5.9884007E-07,   4.9990314E-07
     +,   4.1631029E-07,   3.4586782E-07,   2.8665480E-07
     +,   2.3701166E-07,   1.9549529E-07,   1.6086609E-07
     +,   1.3205329E-07,   1.0814220E-07
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_asha_htt80_mass = Yx/18.78845304
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_asha_htt85_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.6983130E-04,   2.8089335E-04
     +,   2.9215936E-04,   3.0361928E-04,   3.1526235E-04
     +,   3.2707723E-04,   3.3905194E-04,   3.5117389E-04
     +,   3.6342995E-04,   3.7580717E-04,   3.8829161E-04
     +,   4.0086923E-04,   4.1352602E-04,   4.2624783E-04
     +,   4.3902051E-04,   4.5183004E-04,   4.6466285E-04
     +,   4.7750588E-04,   4.9034640E-04,   5.0317263E-04
     +,   5.1597384E-04,   5.2874017E-04,   5.4146320E-04
     +,   5.5413664E-04,   5.6675484E-04,   5.7931518E-04
     +,   5.9181696E-04,   6.0426205E-04,   6.1665534E-04
     +,   6.2900461E-04,   6.4132147E-04,   6.5362127E-04
     +,   6.6592358E-04,   6.7825231E-04,   6.9063669E-04
     +,   7.0311152E-04,   7.1571686E-04,   7.2849909E-04
     +,   7.4151240E-04,   7.5481622E-04,   7.6847983E-04
     +,   7.8257930E-04,   7.9719961E-04,   8.1243558E-04
     +,   8.2839106E-04,   8.4518088E-04,   8.6293003E-04
     +,   8.8177534E-04,   9.0186548E-04,   9.2336151E-04
     +,   9.4643689E-04,   9.7127928E-04,   9.9808886E-04
     +,   1.0270824E-03,   1.0584876E-03,   1.0925505E-03
     +,   1.1295299E-03,   1.1697001E-03,   1.2133510E-03
     +,   1.2607878E-03,   1.3123292E-03,   1.3683105E-03
     +,   1.4290761E-03,   1.4949884E-03,   1.5664235E-03
     +,   1.6437585E-03,   1.7273929E-03,   1.8177206E-03
     +,   1.9151537E-03,   2.0200950E-03,   2.1329590E-03
     +,   2.2541459E-03,   2.3840629E-03,   2.5230902E-03
     +,   2.6716085E-03,   2.8299803E-03,   2.9985362E-03
     +,   3.1775790E-03,   3.3673958E-03,   3.5682404E-03
     +,   3.7803161E-03,   4.0038163E-03,   4.2388816E-03
     +,   4.4856556E-03,   4.7442382E-03,   5.0147651E-03
     +,   5.2973572E-03,   5.5922237E-03,   5.8996272E-03
     +,   6.2199775E-03,   6.5538799E-03,   6.9021462E-03
     +,   7.2659040E-03,   7.6466748E-03,   8.0464296E-03
     +,   8.4676128E-03,   8.9132888E-03,   9.3870750E-03
     +,   9.8932525E-03,   1.0436629E-02,   1.1022594E-02
     +,   1.1656856E-02,   1.2345402E-02,   1.3094092E-02
     +,   1.3908521E-02,   1.4793600E-02,   1.5753131E-02
     +,   1.6789481E-02,   1.7903332E-02,   1.9093385E-02
     +,   2.0356126E-02,   2.1686284E-02,   2.3076871E-02
     +,   2.4520351E-02,   2.6009446E-02,   2.7539199E-02
     +,   2.9108508E-02,   3.0722927E-02,   3.2396417E-02
     +,   3.4153719E-02,   3.6031216E-02,   3.8076505E-02
     +,   4.0346347E-02,   4.2902339E-02,   4.5804773E-02
     +,   4.9104482E-02,   5.2836165E-02,   5.7011750E-02
     +,   6.1619934E-02,   6.6629723E-02,   7.2004154E-02
     +,   7.7719904E-02,   8.3796345E-02,   9.0325154E-02
     +,   9.7499087E-02,   0.1056250    ,   0.1151105    
     +,   0.1264146    ,   0.1399614    ,   0.1560389    
     +,   0.1747374    ,   0.1960093    ,   0.2198950    
     +,   0.2468227    ,   0.2777270    ,   0.3137241    
     +,   0.3554089    ,   0.4025185    ,   0.4550227    
     +,   0.5156465    ,   0.5912142    ,   0.6891291    
     +,   0.8111701    ,   0.9547983    ,    1.123457    
     +,    1.325639    ,    1.556755    ,    1.805620    
     +,    2.088046    ,    2.405300    ,    2.713070    
     +,    3.034604    ,    3.414952    ,    3.828106    
     +,    4.113844    ,    4.013148    ,    3.752458    
     +,    3.691540    ,    3.612632    ,    3.424674    
     +,    3.307118    ,    3.132198    ,    2.773900    
     +,    2.310661    ,    1.888553    ,    1.590701    
     +,    1.405915    ,    1.264339    ,    1.121434    
     +,   0.9804262    ,   0.8557521    ,   0.7529082    
     +,   0.6678258    ,   0.5928715    ,   0.5240787    
     +,   0.4628269    ,   0.4122766    ,   0.3737986    
     +,   0.3461426    ,   0.3266691    ,   0.3128186    
     +,   0.3027009    ,   0.2948406    ,   0.2877442    
     +,   0.2798115    ,   0.2696509    ,   0.2565128    
     +,   0.2405222    ,   0.2225727    ,   0.2039670    
     +,   0.1859875    ,   0.1695623    ,   0.1551117    
     +,   0.1425740    ,   0.1315508    ,   0.1214977    
     +,   0.1119022    ,   0.1024026    ,   9.2836685E-02
     +,   8.3227232E-02,   7.3729739E-02,   6.4564653E-02
     +,   5.5953674E-02,   4.8073854E-02,   4.1034643E-02
     +,   3.4874346E-02,   2.9569697E-02,   2.5053129E-02
     +,   2.1232421E-02,   1.8007601E-02,   1.5282399E-02
     +,   1.2971868E-02,   1.1005325E-02,   9.3260538E-03
     +,   7.8892894E-03,   6.6598090E-03,   5.6094807E-03
     +,   4.7150315E-03,   3.9565181E-03,   3.3164045E-03
     +,   2.7790142E-03,   2.3301721E-03,   1.9570608E-03
     +,   1.6482048E-03,   1.3934525E-03,   1.1838805E-03
     +,   1.0117668E-03,   8.7051577E-04,   7.5454242E-04
     +,   6.5916235E-04,   5.8048859E-04,   5.1532773E-04
     +,   4.6106838E-04,   4.1558681E-04,   3.7716836E-04
     +,   3.4443673E-04,   3.1628922E-04,   2.9184317E-04
     +,   2.7039560E-04,   2.5138911E-04,   2.3437904E-04
     +,   2.1901235E-04,   2.0500968E-04,   1.9214940E-04
     +,   1.8025481E-04,   1.6918572E-04,   1.5883148E-04
     +,   1.4910432E-04,   1.3993392E-04,   1.3126447E-04
     +,   1.2305209E-04,   1.1526168E-04,   1.0786467E-04
     +,   1.0083800E-04,   9.4163370E-05,   8.7824919E-05
     +,   8.1809208E-05,   7.6104880E-05,   7.0701710E-05
     +,   6.5589877E-05,   6.0760085E-05,   5.6203658E-05
     +,   5.1911931E-05,   4.7876005E-05,   4.4086864E-05
     +,   4.0535811E-05,   3.7213485E-05,   3.4110901E-05
     +,   3.1218515E-05,   2.8527149E-05,   2.6027183E-05
     +,   2.3709397E-05,   2.1564258E-05,   1.9582638E-05
     +,   1.7755279E-05,   1.6073320E-05,   1.4527935E-05
     +,   1.3110543E-05,   1.1812956E-05,   1.0627097E-05
     +,   9.5453497E-06,   8.5602605E-06,   7.6648384E-06
     +,   6.8523077E-06,   6.1163396E-06,   5.4508482E-06
     +,   4.8501761E-06,   4.3089203E-06,   3.8220887E-06
     +,   3.3849346E-06,   2.9930989E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_asha_htt85_mass = Yx/19.57032546
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_asha_htt90_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  5.9530470E-05,   6.5640750E-05
     +,   7.2294577E-05,   7.9529636E-05,   8.7384993E-05
     +,   9.5900970E-05,   1.0511900E-04,   1.1508156E-04
     +,   1.2583175E-04,   1.3741387E-04,   1.4987220E-04
     +,   1.6325142E-04,   1.7759619E-04,   1.9295097E-04
     +,   2.0935977E-04,   2.2686577E-04,   2.4551104E-04
     +,   2.6533651E-04,   2.8638120E-04,   3.0868247E-04
     +,   3.3227543E-04,   3.5719262E-04,   3.8346369E-04
     +,   4.1111701E-04,   4.4017503E-04,   4.7066016E-04
     +,   5.0258962E-04,   5.3597824E-04,   5.7083793E-04
     +,   6.0717721E-04,   6.4500229E-04,   6.8431726E-04
     +,   7.2512415E-04,   7.6742435E-04,   8.1121793E-04
     +,   8.5650594E-04,   9.0329093E-04,   9.5157605E-04
     +,   1.0013721E-03,   1.0526880E-03,   1.1055454E-03
     +,   1.1599690E-03,   1.2159944E-03,   1.2736665E-03
     +,   1.3330425E-03,   1.3941921E-03,   1.4572003E-03
     +,   1.5221677E-03,   1.5892094E-03,   1.6584608E-03
     +,   1.7300744E-03,   1.8042204E-03,   1.8810860E-03
     +,   1.9608827E-03,   2.0438288E-03,   2.1301697E-03
     +,   2.2201575E-03,   2.3140623E-03,   2.4121620E-03
     +,   2.5147444E-03,   2.6221024E-03,   2.7345337E-03
     +,   2.8523288E-03,   2.9757821E-03,   3.1051834E-03
     +,   3.2407998E-03,   3.3828989E-03,   3.5317186E-03
     +,   3.6874923E-03,   3.8504126E-03,   4.0206653E-03
     +,   4.1983877E-03,   4.3837079E-03,   4.5766984E-03
     +,   4.7774091E-03,   4.9858536E-03,   5.2019884E-03
     +,   5.4257261E-03,   5.6569418E-03,   5.8954633E-03
     +,   6.1410405E-03,   6.3934014E-03,   6.6521880E-03
     +,   6.9170194E-03,   7.1874377E-03,   7.4629742E-03
     +,   7.7430955E-03,   8.0272900E-03,   8.3150156E-03
     +,   8.6057940E-03,   8.8992175E-03,   9.1949739E-03
     +,   9.4929133E-03,   9.7931409E-03,   1.0096055E-02
     +,   1.0402399E-02,   1.0713430E-02,   1.1030899E-02
     +,   1.1357248E-02,   1.1695601E-02,   1.2049925E-02
     +,   1.2425005E-02,   1.2826564E-02,   1.3261174E-02
     +,   1.3736303E-02,   1.4260211E-02,   1.4841760E-02
     +,   1.5490271E-02,   1.6215339E-02,   1.7026531E-02
     +,   1.7933004E-02,   1.8943407E-02,   2.0065306E-02
     +,   2.1305226E-02,   2.2668084E-02,   2.4157370E-02
     +,   2.5774581E-02,   2.7519649E-02,   2.9390311E-02
     +,   3.1382550E-02,   3.3490375E-02,   3.5705619E-02
     +,   3.8017981E-02,   4.0415153E-02,   4.2882688E-02
     +,   4.5403719E-02,   4.7959737E-02,   5.0530102E-02
     +,   5.3093284E-02,   5.5626795E-02,   5.8108699E-02
     +,   6.0518581E-02,   6.2839948E-02,   6.5062389E-02
     +,   6.7185454E-02,   6.9222823E-02,   7.1206510E-02
     +,   7.3191717E-02,   7.5259909E-02,   7.7520542E-02
     +,   8.0109246E-02,   8.3184011E-02,   8.6918309E-02
     +,   9.1492102E-02,   9.7081795E-02,   0.1038541    
     +,   0.1119652    ,   0.1215695    ,   0.1328408    
     +,   0.1459975    ,   0.1613158    ,   0.1791173    
     +,   0.1997479    ,   0.2235892    ,   0.2511450    
     +,   0.2831363    ,   0.3204281    ,   0.3636713    
     +,   0.4129243    ,   0.4678447    ,   0.5289034    
     +,   0.5995697    ,   0.6883198    ,   0.8080367    
     +,   0.9715447    ,    1.182976    ,    1.431621    
     +,    1.714004    ,    2.055231    ,    2.457814    
     +,    2.889060    ,    3.341521    ,    3.778537    
     +,    4.081887    ,    4.158543    ,    4.145978    
     +,    4.155413    ,    4.052079    ,    3.826373    
     +,    3.481780    ,    2.996930    ,    2.477425    
     +,    2.060478    ,    1.732472    ,    1.455387    
     +,    1.234006    ,    1.076078    ,   0.9698570    
     +,   0.8976325    ,   0.8419096    ,   0.7866968    
     +,   0.7240546    ,   0.6566539    ,   0.5925741    
     +,   0.5383277    ,   0.4955491    ,   0.4618563    
     +,   0.4333291    ,   0.4063635    ,   0.3784234    
     +,   0.3481958    ,   0.3155619    ,   0.2814207    
     +,   0.2472980    ,   0.2148046    ,   0.1851391    
     +,   0.1588544    ,   0.1359238    ,   0.1159853    
     +,   9.8596610E-02,   8.3393283E-02,   7.0126295E-02
     +,   5.8626641E-02,   4.8754942E-02,   4.0369205E-02
     +,   3.3315070E-02,   2.7429929E-02,   2.2552753E-02
     +,   1.8532967E-02,   1.5235350E-02,   1.2540606E-02
     +,   1.0345239E-02,   8.5603232E-03,   7.1098856E-03
     +,   5.9296638E-03,   4.9661524E-03,   4.1755540E-03
     +,   3.5225896E-03,   2.9792618E-03,   2.5237196E-03
     +,   2.1391057E-03,   1.8124565E-03,   1.5337794E-03
     +,   1.2953285E-03,   1.0910309E-03,   9.1599568E-04
     +,   7.6621579E-04,   6.3834089E-04,   5.2950566E-04
     +,   4.3721573E-04,   3.5928332E-04,   2.9378053E-04
     +,   2.3899785E-04,   1.9341650E-04,   1.5569419E-04
     +,   1.2465045E-04,   9.9249184E-05,   7.8584912E-05
     +,   6.1873208E-05,   4.8439910E-05,   3.7706897E-05
     +,   2.9183540E-05,   2.2456770E-05,   1.7180846E-05
     +,   1.3068342E-05,   9.8824949E-06,   7.4299264E-06
     +,   5.5536320E-06,   4.1270528E-06,   3.0490855E-06
     +,   2.2396027E-06,   1.6354967E-06,   1.1874140E-06
     +,   8.5708911E-07,   6.1507802E-07,   4.3884518E-07
     +,   3.1128931E-07,   2.1952962E-07,   1.5392251E-07
     +,   1.0729603E-07,   7.4358432E-08,   5.1232245E-08
     +,   3.5093297E-08,   2.3898044E-08,   1.6178820E-08
     +,   1.0888841E-08,   7.2853181E-09,   4.8456359E-09
     +,   3.2038232E-09,   2.1057414E-09,   1.3757447E-09
     +,   8.9345070E-10,   5.7673955E-10,   3.7005637E-10
     +,   2.3600008E-10,   1.4959417E-10,   9.4244904E-11
     +,   5.9009873E-11,   3.6721376E-11,   2.2709919E-11
     +,   1.3957881E-11,   8.5252239E-12,   5.1746385E-12
     +,   3.1211741E-12,   1.8707932E-12,   1.1142412E-12
     +,   6.5945757E-13,   3.8781489E-13,   2.2662174E-13
     +,   1.3158150E-13,   7.5912624E-14
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_asha_htt90_mass = Yx/18.64148454
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_asha_htt95_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.7794096E-04,   1.9129219E-04
     +,   2.0540568E-04,   2.2030521E-04,   2.3601382E-04
     +,   2.5255358E-04,   2.6994577E-04,   2.8821049E-04
     +,   3.0736631E-04,   3.2743133E-04,   3.4842151E-04
     +,   3.7035134E-04,   3.9323367E-04,   4.1707946E-04
     +,   4.4189807E-04,   4.6769661E-04,   4.9448013E-04
     +,   5.2225130E-04,   5.5101083E-04,   5.8075698E-04
     +,   6.1148516E-04,   6.4318901E-04,   6.7585811E-04
     +,   7.0948235E-04,   7.4404455E-04,   7.7952899E-04
     +,   8.1591489E-04,   8.5317914E-04,   8.9129584E-04
     +,   9.3023654E-04,   9.6996961E-04,   1.0104607E-03
     +,   1.0516731E-03,   1.0935671E-03,   1.1361003E-03
     +,   1.1792285E-03,   1.2229036E-03,   1.2670761E-03
     +,   1.3116963E-03,   1.3567075E-03,   1.4020571E-03
     +,   1.4476873E-03,   1.4935400E-03,   1.5395570E-03
     +,   1.5856780E-03,   1.6318443E-03,   1.6779973E-03
     +,   1.7240799E-03,   1.7700365E-03,   1.8158146E-03
     +,   1.8613657E-03,   1.9066470E-03,   1.9516208E-03
     +,   1.9962608E-03,   2.0405462E-03,   2.0844724E-03
     +,   2.1280479E-03,   2.1712976E-03,   2.2142681E-03
     +,   2.2570291E-03,   2.2996764E-03,   2.3423387E-03
     +,   2.3851765E-03,   2.4283906E-03,   2.4722277E-03
     +,   2.5169745E-03,   2.5629743E-03,   2.6106182E-03
     +,   2.6603586E-03,   2.7126980E-03,   2.7682027E-03
     +,   2.8274874E-03,   2.8912278E-03,   2.9601364E-03
     +,   3.0349726E-03,   3.1165252E-03,   3.2055962E-03
     +,   3.3029877E-03,   3.4094907E-03,   3.5258636E-03
     +,   3.6527924E-03,   3.7908987E-03,   3.9406805E-03
     +,   4.1025216E-03,   4.2766295E-03,   4.4630542E-03
     +,   4.6616229E-03,   4.8719677E-03,   5.0934660E-03
     +,   5.3252759E-03,   5.5663157E-03,   5.8152536E-03
     +,   6.0705361E-03,   6.3304156E-03,   6.5929759E-03
     +,   6.8561304E-03,   7.1177203E-03,   7.3755071E-03
     +,   7.6272707E-03,   7.8708204E-03,   8.1041027E-03
     +,   8.3251996E-03,   8.5324589E-03,   8.7244883E-03
     +,   8.9002615E-03,   9.0591535E-03,   9.2009855E-03
     +,   9.3260929E-03,   9.4353734E-03,   9.5303217E-03
     +,   9.6130706E-03,   9.6864440E-03,   9.7539742E-03
     +,   9.8199453E-03,   9.8893940E-03,   9.9681439E-03
     +,   1.0062763E-02,   1.0180586E-02,   1.0329609E-02
     +,   1.0518456E-02,   1.0756265E-02,   1.1052509E-02
     +,   1.1416825E-02,   1.1858843E-02,   1.2387912E-02
     +,   1.3012789E-02,   1.3741507E-02,   1.4580945E-02
     +,   1.5536781E-02,   1.6613115E-02,   1.7812548E-02
     +,   1.9135885E-02,   2.0582438E-02,   2.2149846E-02
     +,   2.3834601E-02,   2.5632240E-02,   2.7537707E-02
     +,   2.9546021E-02,   3.1653073E-02,   3.3856455E-02
     +,   3.6156107E-02,   3.8555536E-02,   4.1062955E-02
     +,   4.3691974E-02,   4.6462197E-02,   4.9400419E-02
     +,   5.2541010E-02,   5.5926926E-02,   5.9611447E-02
     +,   6.3660540E-02,   6.8155445E-02,   7.3192976E-02
     +,   7.8883469E-02,   8.5341372E-02,   9.2666857E-02
     +,   0.1009173    ,   0.1100754    ,   0.1200232    
     +,   0.1305425    ,   0.1413720    ,   0.1523579    
     +,   0.1637096    ,   0.1763197    ,   0.1920158    
     +,   0.2135369    ,   0.2440643    ,   0.2862856    
     +,   0.3411718    ,   0.4069319    ,   0.4793218    
     +,   0.5551686    ,   0.6384614    ,   0.7413158    
     +,   0.8745403    ,    1.045414    ,    1.272986    
     +,    1.574596    ,    1.935047    ,    2.321324    
     +,    2.712526    ,    3.188465    ,    3.724451    
     +,    4.171715    ,    4.466032    ,    4.551336    
     +,    4.483518    ,    4.283154    ,    3.985264    
     +,    3.706073    ,    3.315092    ,    2.776666    
     +,    2.361241    ,    2.038857    ,    1.730446    
     +,    1.492838    ,    1.333218    ,    1.205414    
     +,    1.076584    ,   0.9375240    ,   0.7981936    
     +,   0.6749527    ,   0.5769535    ,   0.5045361    
     +,   0.4524484    ,   0.4125420    ,   0.3769229    
     +,   0.3407020    ,   0.3026587    ,   0.2640570    
     +,   0.2269862    ,   0.1931830    ,   0.1635298    
     +,   0.1380599    ,   0.1162512    ,   9.7399928E-02
     +,   8.0904417E-02,   6.6384308E-02,   5.3659812E-02
     +,   4.2664960E-02,   3.3359207E-02,   2.5668574E-02
     +,   1.9467436E-02,   1.4584771E-02,   1.0822359E-02
     +,   7.9759303E-03,   5.8534299E-03,   4.2867758E-03
     +,   3.1370798E-03,   2.2949462E-03,   1.6775173E-03
     +,   1.2238025E-03,   8.8964868E-04,   6.4330391E-04
     +,   4.6189604E-04,   3.2879593E-04,   2.3172314E-04
     +,   1.6150324E-04,   1.1121809E-04,   7.5621967E-05
     +,   5.0740127E-05,   3.3580789E-05,   2.1914111E-05
     +,   1.4097399E-05,   8.9379264E-06,   5.5838291E-06
     +,   3.4368857E-06,   2.0839375E-06,   1.2446043E-06
     +,   7.3206411E-07,   4.2403983E-07,   2.4185414E-07
     +,   1.3581294E-07,   7.5082689E-08,   4.0862460E-08
     +,   2.1890646E-08,   1.1542810E-08,   5.9907443E-09
     +,   3.0604144E-09,   1.5389603E-09,   7.6186207E-10
     +,   3.7141612E-10,   1.7840869E-10,   8.4513459E-11
     +,   3.9542175E-11,   1.8323596E-11,   8.4477095E-12
     +,   3.9038130E-12,   1.8296551E-12,   8.8445381E-13
     +,   4.5004305E-13,   2.4557664E-13,   1.4499028E-13
     +,   9.2139607E-14,   6.2041389E-14,   4.3459790E-14
     +,   3.1192920E-14,   2.2699585E-14,   1.6641262E-14
     +,   1.2244987E-14,   9.0257383E-15,   6.6574820E-15
     +,   4.9117382E-15,   3.6237116E-15,   2.6732711E-15
     +,   1.9719262E-15,   1.4545090E-15,   1.0728354E-15
     +,   7.9132407E-16,   5.8371984E-16,   4.3061779E-16
     +,   3.1771428E-16,   2.3444413E-16,   1.7302781E-16
     +,   1.2771997E-16,   9.4292892E-17,   6.9624626E-17
     +,   5.1417908E-17,   3.7976451E-17,   2.8051835E-17
     +,   2.0721968E-17,   1.5307968E-17
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_asha_htt95_mass = Yx/18.54154596
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_asha_ttz100_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.3007735E-04,   2.4389489E-04
     +,   2.5806885E-04,   2.7256942E-04,   2.8736412E-04
     +,   3.0241758E-04,   3.1769223E-04,   3.3314805E-04
     +,   3.4874293E-04,   3.6443386E-04,   3.8017574E-04
     +,   3.9592272E-04,   4.1162851E-04,   4.2724630E-04
     +,   4.4273006E-04,   4.5803376E-04,   4.7311289E-04
     +,   4.8792400E-04,   5.0242583E-04,   5.1657914E-04
     +,   5.3034700E-04,   5.4369605E-04,   5.5659510E-04
     +,   5.6901795E-04,   5.8093976E-04,   5.9234159E-04
     +,   6.0320750E-04,   6.1352528E-04,   6.2328740E-04
     +,   6.3248968E-04,   6.4113189E-04,   6.4921792E-04
     +,   6.5675471E-04,   6.6375290E-04,   6.7022600E-04
     +,   6.7619066E-04,   6.8166567E-04,   6.8667228E-04
     +,   6.9123390E-04,   6.9537491E-04,   6.9912185E-04
     +,   7.0250186E-04,   7.0554280E-04,   7.0827367E-04
     +,   7.1072357E-04,   7.1292219E-04,   7.1489962E-04
     +,   7.1668625E-04,   7.1831298E-04,   7.1981124E-04
     +,   7.2121352E-04,   7.2255329E-04,   7.2386523E-04
     +,   7.2518608E-04,   7.2655489E-04,   7.2801305E-04
     +,   7.2960556E-04,   7.3138054E-04,   7.3339057E-04
     +,   7.3569239E-04,   7.3834806E-04,   7.4142497E-04
     +,   7.4499543E-04,   7.4913807E-04,   7.5393729E-04
     +,   7.5948238E-04,   7.6586945E-04,   7.7319855E-04
     +,   7.8157516E-04,   7.9110794E-04,   8.0191018E-04
     +,   8.1409520E-04,   8.2777906E-04,   8.4307563E-04
     +,   8.6009892E-04,   8.7895850E-04,   8.9975866E-04
     +,   9.2259614E-04,   9.4756030E-04,   9.7473082E-04
     +,   1.0041717E-03,   1.0359379E-03,   1.0700637E-03
     +,   1.1065712E-03,   1.1454605E-03,   1.1867168E-03
     +,   1.2303013E-03,   1.2761598E-03,   1.3242135E-03
     +,   1.3743669E-03,   1.4265083E-03,   1.4805034E-03
     +,   1.5362033E-03,   1.5934487E-03,   1.6520695E-03
     +,   1.7118823E-03,   1.7727064E-03,   1.8343527E-03
     +,   1.8966425E-03,   1.9593963E-03,   2.0224543E-03
     +,   2.0856634E-03,   2.1488979E-03,   2.2120469E-03
     +,   2.2750327E-03,   2.3378069E-03,   2.4003480E-03
     +,   2.4626683E-03,   2.5248171E-03,   2.5868777E-03
     +,   2.6489589E-03,   2.7112062E-03,   2.7737820E-03
     +,   2.8368770E-03,   2.9006843E-03,   2.9654163E-03
     +,   3.0312694E-03,   3.0984376E-03,   3.1670853E-03
     +,   3.2373506E-03,   3.3093293E-03,   3.3830639E-03
     +,   3.4585360E-03,   3.5356681E-03,   3.6143167E-03
     +,   3.6942612E-03,   3.7752297E-03,   3.8568855E-03
     +,   3.9388672E-03,   4.0207887E-03,   4.1022925E-03
     +,   4.1830726E-03,   4.2629433E-03,   4.3418906E-03
     +,   4.4201622E-03,   4.4983560E-03,   4.5775217E-03
     +,   4.6592900E-03,   4.7460180E-03,   4.8409333E-03
     +,   4.9482901E-03,   5.0735329E-03,   5.2234675E-03
     +,   5.4063681E-03,   5.6320457E-03,   5.9118769E-03
     +,   6.2586800E-03,   6.6864104E-03,   7.2097145E-03
     +,   7.8432802E-03,   8.6009055E-03,   9.4942944E-03
     +,   1.0531784E-02,   1.1717056E-02,   1.3047787E-02
     +,   1.4514524E-02,   1.6100155E-02,   1.7780086E-02
     +,   1.9523010E-02,   2.1292442E-02,   2.3049600E-02
     +,   2.4756512E-02,   2.6379699E-02,   2.7894525E-02
     +,   2.9289691E-02,   3.0571979E-02,   3.1771485E-02
     +,   3.2947872E-02,   3.4197070E-02,   3.5657708E-02
     +,   3.7515596E-02,   4.0004324E-02,   4.3401062E-02
     +,   4.8018791E-02,   5.4201644E-02,   6.2333483E-02
     +,   7.2855823E-02,   8.6260475E-02,   0.1029781    
     +,   0.1230981    ,   0.1460587    ,   0.1708249    
     +,   0.1970606    ,   0.2265640    ,   0.2626477    
     +,   0.3069287    ,   0.3587510    ,   0.4220477    
     +,   0.5095329    ,   0.6269170    ,   0.7556798    
     +,   0.8880562    ,    1.062844    ,    1.286416    
     +,    1.522645    ,    1.758304    ,    1.925322    
     +,    1.937054    ,    1.823782    ,    1.640518    
     +,    1.392470    ,    1.123459    ,   0.9032913    
     +,   0.7417011    ,   0.6219859    ,   0.5306361    
     +,   0.4533355    ,   0.3827537    ,   0.3183600    
     +,   0.2610109    ,   0.2118445    ,   0.1714873    
     +,   0.1391376    ,   0.1131533    ,   9.2038132E-02
     +,   7.4717373E-02,   6.0388193E-02,   4.8431545E-02
     +,   3.8417131E-02,   3.0073810E-02,   2.3213301E-02
     +,   1.7668096E-02,   1.3266345E-02,   9.8328423E-03
     +,   7.1984893E-03,   5.2085272E-03,   3.7270538E-03
     +,   2.6387430E-03,   1.8488475E-03,   1.2819079E-03
     +,   8.7933865E-04,   5.9651985E-04,   3.9998180E-04
     +,   2.6494832E-04,   1.7328173E-04,   1.1182783E-04
     +,   7.1165276E-05,   4.4628840E-05,   2.7560247E-05
     +,   1.6746975E-05,   1.0005520E-05,   5.8732790E-06
     +,   3.3850640E-06,   1.9143333E-06,   1.0616516E-06
     +,   5.7711287E-07,   3.0739355E-07,   1.6037939E-07
     +,   8.1947647E-08,   4.1007720E-08,   2.0100366E-08
     +,   9.6551185E-09,   4.5495949E-09,   2.1070057E-09
     +,   9.6215347E-10,   4.3563475E-10,   1.9738317E-10
     +,   9.0779904E-11,   4.3217121E-11,   2.1771654E-11
     +,   1.1808006E-11,   6.9229579E-12,   4.3414517E-12
     +,   2.8587087E-12,   1.9409728E-12,   1.3404921E-12
     +,   9.3349970E-13,   6.5219818E-13,   4.5590067E-13
     +,   3.1839391E-13,   2.2199931E-13,   1.5448734E-13
     +,   1.0728336E-13,   7.4343797E-14,   5.1406951E-14
     +,   3.5471609E-14,   2.4424371E-14,   1.6783045E-14
     +,   1.1508681E-14,   7.8760918E-15,   5.3793127E-15
     +,   3.6668874E-15,   2.4947149E-15,   1.6940263E-15
     +,   1.1481341E-15,   7.7670841E-16,   5.2446676E-16
     +,   3.5348705E-16,   2.3781681E-16,   1.5970506E-16
     +,   1.0705710E-16,   7.1634992E-17,   4.7847776E-17
     +,   3.1901663E-17,   2.1232084E-17,   1.4105426E-17
     +,   9.3541389E-18,   6.1920118E-18,   4.0914479E-18
     +,   2.6985109E-18,   1.7765633E-18
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_asha_ttz100_mass = Yx/6.30255613953488
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_asha_ttz105_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  6.6956896E-12,   9.4259392E-12
     +,   1.3227352E-11,   1.8502963E-11,   2.5800560E-11
     +,   3.5862122E-11,   4.9689312E-11,   6.8629435E-11
     +,   9.4487820E-11,   1.2967764E-10,   1.7740914E-10
     +,   2.4194055E-10,   3.2889988E-10,   4.4569862E-10
     +,   6.0206207E-10,   8.1070994E-10,   1.0882106E-09
     +,   1.4560803E-09,   1.9421496E-09,   2.5822930E-09
     +,   3.4225829E-09,   4.5219841E-09,   5.9556506E-09
     +,   7.8191817E-09,   1.0233348E-08,   1.3350737E-08
     +,   1.7362911E-08,   2.2509733E-08,   2.9090319E-08
     +,   3.7476539E-08,   4.8128506E-08,   6.1614024E-08
     +,   7.8630400E-08,   1.0003159E-07,   1.2685864E-07
     +,   1.6037615E-07,   2.0211461E-07,   2.5391807E-07
     +,   3.1800397E-07,   3.9701757E-07,   4.9411841E-07
     +,   6.1305019E-07,   7.5823880E-07,   9.3489376E-07
     +,   1.1491214E-06,   1.4080517E-06,   1.7199732E-06
     +,   2.0944819E-06,   2.5426395E-06,   3.0771444E-06
     +,   3.7125105E-06,   4.4652520E-06,   5.3540539E-06
     +,   6.4000628E-06,   7.6268834E-06,   9.0610220E-06
     +,   1.0731861E-05,   1.2671939E-05,   1.4917065E-05
     +,   1.7506463E-05,   2.0482858E-05,   2.3892600E-05
     +,   2.7785400E-05,   3.2214772E-05,   3.7237784E-05
     +,   4.2914278E-05,   4.9307899E-05,   5.6484274E-05
     +,   6.4512256E-05,   7.3461735E-05,   8.3404993E-05
     +,   9.4413896E-05,   1.0656169E-04,   1.1991948E-04
     +,   1.3455786E-04,   1.5054519E-04,   1.6794549E-04
     +,   1.8681823E-04,   2.0721885E-04,   2.2919668E-04
     +,   2.5279200E-04,   2.7804004E-04,   3.0496443E-04
     +,   3.3358310E-04,   3.6390088E-04,   3.9591669E-04
     +,   4.2961596E-04,   4.6497877E-04,   5.0197204E-04
     +,   5.4055802E-04,   5.8069202E-04,   6.2232133E-04
     +,   6.6538900E-04,   7.0983864E-04,   7.5561448E-04
     +,   8.0265821E-04,   8.5092301E-04,   9.0036349E-04
     +,   9.5095159E-04,   1.0026665E-03,   1.0555112E-03
     +,   1.1095017E-03,   1.1646852E-03,   1.2211284E-03
     +,   1.2789335E-03,   1.3382367E-03,   1.3992069E-03
     +,   1.4620533E-03,   1.5270319E-03,   1.5944432E-03
     +,   1.6646300E-03,   1.7379917E-03,   1.8149668E-03
     +,   1.8960508E-03,   1.9817720E-03,   2.0727080E-03
     +,   2.1694533E-03,   2.2726322E-03,   2.3828580E-03
     +,   2.5007357E-03,   2.6268314E-03,   2.7616362E-03
     +,   2.9055437E-03,   3.0588291E-03,   3.2216113E-03
     +,   3.3938035E-03,   3.5751280E-03,   3.7650506E-03
     +,   3.9628167E-03,   4.1674064E-03,   4.3775975E-03
     +,   4.5919470E-03,   4.8088883E-03,   5.0267456E-03
     +,   5.2438560E-03,   5.4586446E-03,   5.6696991E-03
     +,   5.8758934E-03,   6.0764882E-03,   6.2711989E-03
     +,   6.4602476E-03,   6.6444143E-03,   6.8250461E-03
     +,   7.0040231E-03,   7.1836757E-03,   7.3667220E-03
     +,   7.5561334E-03,   7.7549703E-03,   7.9662567E-03
     +,   8.1928242E-03,   8.4371651E-03,   8.7012714E-03
     +,   8.9865476E-03,   9.2937341E-03,   9.6228281E-03
     +,   9.9730100E-03,   1.0342631E-02,   1.0729225E-02
     +,   1.1129483E-02,   1.1539219E-02,   1.1953502E-02
     +,   1.2366663E-02,   1.2772412E-02,   1.3164037E-02
     +,   1.3534716E-02,   1.3877892E-02,   1.4187776E-02
     +,   1.4460145E-02,   1.4693286E-02,   1.4889224E-02
     +,   1.5055215E-02,   1.5205503E-02,   1.5363222E-02
     +,   1.5562201E-02,   1.5848439E-02,   1.6281059E-02
     +,   1.6932596E-02,   1.7888820E-02,   1.9248663E-02
     +,   2.1124873E-02,   2.3644652E-02,   2.6948100E-02
     +,   3.1180011E-02,   3.6469691E-02,   4.2894669E-02
     +,   5.0434213E-02,   5.8930956E-02,   6.8084829E-02
     +,   7.7498361E-02,   8.6780749E-02,   9.5723428E-02
     +,   0.1045593    ,   0.1142553    ,   0.1265734    
     +,   0.1436514    ,   0.1678417    ,   0.2037016    
     +,   0.2612208    ,   0.3512042    ,   0.4683234    
     +,   0.5954077    ,   0.7457741    ,   0.9345057    
     +,    1.190984    ,    1.626610    ,    2.092205    
     +,    2.295042    ,    2.287014    ,    2.146867    
     +,    1.860507    ,    1.582285    ,    1.303676    
     +,   0.9627976    ,   0.6184150    ,   0.3789474    
     +,   0.2353369    ,   0.1439411    ,   8.4875613E-02
     +,   4.8819263E-02,   2.8083947E-02,   1.6450105E-02
     +,   9.8618101E-03,   6.0765664E-03,   3.9128051E-03
     +,   2.7112905E-03,   2.0744191E-03,   1.7545460E-03
     +,   1.6005203E-03,   1.5252456E-03,   1.4824619E-03
     +,   1.4498987E-03,   1.4180086E-03,   1.3832862E-03
     +,   1.3447888E-03,   1.3025551E-03,   1.2569595E-03
     +,   1.2084853E-03,   1.1576508E-03,   1.1049783E-03
     +,   1.0509770E-03,   9.9613843E-04,   9.4093278E-04
     +,   8.8580005E-04,   8.3114178E-04,   7.7732134E-04
     +,   7.2466541E-04,   6.7345856E-04,   6.2394020E-04
     +,   5.7630893E-04,   5.3072773E-04,   4.8731713E-04
     +,   4.4616236E-04,   4.0731896E-04,   3.7081252E-04
     +,   3.3663987E-04,   3.0477520E-04,   2.7517506E-04
     +,   2.4777910E-04,   2.2251134E-04,   1.9928551E-04
     +,   1.7800830E-04,   1.5858035E-04,   1.4089690E-04
     +,   1.2485131E-04,   1.1033790E-04,   9.7250049E-05
     +,   8.5483181E-05,   7.4936259E-05,   6.5511515E-05
     +,   5.7114517E-05,   4.9655468E-05,   4.3049757E-05
     +,   3.7217640E-05,   3.2083979E-05,   2.7578813E-05
     +,   2.3637609E-05,   2.0200237E-05,   1.7211854E-05
     +,   1.4621817E-05,   1.2384304E-05,   1.0457382E-05
     +,   8.8034003E-06,   7.3882147E-06,   6.1813844E-06
     +,   5.1555517E-06,   4.2865231E-06,   3.5527560E-06
     +,   2.9352509E-06,   2.4173753E-06,   1.9844929E-06
     +,   1.6239089E-06,   1.3245533E-06,   1.0768953E-06
     +,   8.7269694E-07,   7.0492257E-07,   5.6754061E-07
     +,   4.5544218E-07,   3.6428463E-07,   2.9041772E-07
     +,   2.3076566E-07,   1.8276332E-07
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_asha_ttz105_mass = Yx/5.6897805
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_asha_ttz107_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.3550369E-09,   4.5385233E-09
     +,   6.1205041E-09,   8.2281604E-09,   1.1026785E-08
     +,   1.4730363E-08,   1.9614893E-08,   2.6034844E-08
     +,   3.4443566E-08,   4.5419323E-08,   5.9695324E-08
     +,   7.8198561E-08,   1.0209580E-07,   1.3284929E-07
     +,   1.7228449E-07,   2.2266971E-07,   2.8681208E-07
     +,   3.6817084E-07,   4.7098902E-07,   6.0044925E-07
     +,   7.6285244E-07,   9.6582653E-07,   1.2185569E-06
     +,   1.5320783E-06,   1.9195295E-06,   2.3965595E-06
     +,   2.9816497E-06,   3.6965512E-06,   4.5667366E-06
     +,   5.6218832E-06,   6.8963886E-06,   8.4299363E-06
     +,   1.0268033E-05,   1.2462615E-05,   1.5072619E-05
     +,   1.8164563E-05,   2.1813066E-05,   2.6101312E-05
     +,   3.1121821E-05,   3.6975965E-05,   4.3775355E-05
     +,   5.1640956E-05,   6.0703507E-05,   7.1103161E-05
     +,   8.2988947E-05,   9.6518219E-05,   1.1185540E-04
     +,   1.2917104E-04,   1.4863990E-04,   1.7043939E-04
     +,   1.9474712E-04,   2.2173862E-04,   2.5158393E-04
     +,   2.8444704E-04,   3.2047721E-04,   3.5981249E-04
     +,   4.0257088E-04,   4.4884870E-04,   4.9871707E-04
     +,   5.5221759E-04,   6.0936040E-04,   6.7012070E-04
     +,   7.3443219E-04,   8.0219330E-04,   8.7326131E-04
     +,   9.4744429E-04,   1.0245166E-03,   1.1042014E-03
     +,   1.1861913E-03,   1.2701297E-03,   1.3556360E-03
     +,   1.4422878E-03,   1.5296477E-03,   1.6172462E-03
     +,   1.7046081E-03,   1.7912509E-03,   1.8766868E-03
     +,   1.9604350E-03,   2.0420363E-03,   2.1210529E-03
     +,   2.1970724E-03,   2.2697281E-03,   2.3386900E-03
     +,   2.4036875E-03,   2.4644979E-03,   2.5209677E-03
     +,   2.5729991E-03,   2.6205685E-03,   2.6637120E-03
     +,   2.7025400E-03,   2.7372264E-03,   2.7680087E-03
     +,   2.7951817E-03,   2.8190985E-03,   2.8401616E-03
     +,   2.8588125E-03,   2.8755285E-03,   2.8908148E-03
     +,   2.9051905E-03,   2.9191833E-03,   2.9333208E-03
     +,   2.9481163E-03,   2.9640642E-03,   2.9816257E-03
     +,   3.0012249E-03,   3.0232377E-03,   3.0479834E-03
     +,   3.0757207E-03,   3.1066414E-03,   3.1408658E-03
     +,   3.1784375E-03,   3.2193284E-03,   3.2634281E-03
     +,   3.3105579E-03,   3.3604603E-03,   3.4128169E-03
     +,   3.4672415E-03,   3.5232985E-03,   3.5805001E-03
     +,   3.6383276E-03,   3.6962372E-03,   3.7536661E-03
     +,   3.8100493E-03,   3.8648373E-03,   3.9175032E-03
     +,   3.9675501E-03,   4.0145395E-03,   4.0580868E-03
     +,   4.0978882E-03,   4.1337241E-03,   4.1654832E-03
     +,   4.1931649E-03,   4.2169061E-03,   4.2369943E-03
     +,   4.2538960E-03,   4.2682793E-03,   4.2810445E-03
     +,   4.2933677E-03,   4.3067401E-03,   4.3230173E-03
     +,   4.3444689E-03,   4.3738261E-03,   4.4143312E-03
     +,   4.4697654E-03,   4.5444560E-03,   4.6432698E-03
     +,   4.7715576E-03,   4.9350471E-03,   5.1396945E-03
     +,   5.3915088E-03,   5.6962939E-03,   6.0593439E-03
     +,   6.4851544E-03,   6.9771484E-03,   7.5374069E-03
     +,   8.1664128E-03,   8.8629862E-03,   9.6243462E-03
     +,   1.0446228E-02,   1.1323128E-02,   1.2248826E-02
     +,   1.3216883E-02,   1.4221046E-02,   1.5255840E-02
     +,   1.6317017E-02,   1.7401671E-02,   1.8508200E-02
     +,   1.9636072E-02,   2.0785445E-02,   2.1956481E-02
     +,   2.3148522E-02,   2.4359530E-02,   2.5585582E-02
     +,   2.6820548E-02,   2.8055869E-02,   2.9281039E-02
     +,   3.0483946E-02,   3.1651430E-02,   3.2770038E-02
     +,   3.3826891E-02,   3.4810305E-02,   3.5710480E-02
     +,   3.6520455E-02,   3.7237287E-02,   3.7864391E-02
     +,   3.8416583E-02,   3.8931224E-02,   3.9489023E-02
     +,   4.0248845E-02,   4.1496612E-02,   4.3701310E-02
     +,   4.7559235E-02,   5.3996123E-02,   6.4085707E-02
     +,   7.8824341E-02,   9.8696873E-02,   0.1231117    
     +,   0.1502349    ,   0.1781284    ,   0.2071898    
     +,   0.2417597    ,   0.2893846    ,   0.3605931    
     +,   0.4702616    ,   0.6329717    ,   0.8504981    
     +,    1.094727    ,    1.302426    ,    1.482394    
     +,    1.783478    ,    2.151184    ,    2.277947    
     +,    2.092563    ,    1.680075    ,    1.201450    
     +,   0.8274797    ,   0.5453101    ,   0.3168165    
     +,   0.1564614    ,   6.6677645E-02,   2.5616815E-02
     +,   9.4243092E-03,   3.4416837E-03,   1.2127880E-03
     +,   3.8757685E-04,   1.0709913E-04,   2.5024981E-05
     +,   4.9475439E-06,   8.7279926E-07,   1.7825954E-07
     +,   6.9454721E-08,   4.6002963E-08,   3.4812519E-08
     +,   2.6770943E-08,   2.0578874E-08,   1.5785856E-08
     +,   1.2081981E-08,   9.2263814E-09,   7.0299127E-09
     +,   5.3442650E-09,   4.0535721E-09,   3.0676115E-09
     +,   2.3161868E-09,   1.7448122E-09,   1.3113409E-09
     +,   9.8326558E-10,   7.3554984E-10,   5.4894245E-10
     +,   4.0869966E-10,   3.0355926E-10,   2.2492209E-10
     +,   1.6624858E-10,   1.2257921E-10,   9.0157985E-11
     +,   6.6146769E-11,   4.8407924E-11,   3.5336609E-11
     +,   2.5729464E-11,   1.8686249E-11,   1.3535928E-11
     +,   9.7796727E-12,   7.0474356E-12,   5.0652052E-12
     +,   3.6308766E-12,   2.5958458E-12,   1.8509235E-12
     +,   1.3162257E-12,   9.3348365E-13,   6.6026253E-13
     +,   4.6574929E-13,   3.2764535E-13,   2.2986601E-13
     +,   1.6082974E-13,   1.1222024E-13,   7.8087391E-14
     +,   5.4188140E-14,   3.7499812E-14,   2.5879972E-14
     +,   1.7811321E-14,   1.2224620E-14,   8.3669982E-15
     +,   5.7109680E-15,   3.8872506E-15,   2.6386313E-15
     +,   1.7861125E-15,   1.2057046E-15,   8.1165397E-16
     +,   5.4487067E-16,   3.6476915E-16,   2.4351996E-16
     +,   1.6212728E-16,   1.0763935E-16,   7.1267546E-17
     +,   4.7055010E-17,   3.0983353E-17,   2.0344550E-17
     +,   1.3322263E-17,   8.6997381E-18,   5.6656185E-18
     +,   3.6795268E-18,   2.3831605E-18
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_asha_ttz107_mass = Yx/5.1578945
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_asha_ttz110_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.9106729E-07,   4.6830510E-07
     +,   5.5964000E-07,   6.6740836E-07,   7.9428662E-07
     +,   9.4333552E-07,   1.1180434E-06,   1.3223754E-06
     +,   1.5608233E-06,   1.8384751E-06,   2.1610581E-06
     +,   2.5350105E-06,   2.9675489E-06,   3.4667394E-06
     +,   4.0415707E-06,   4.7020244E-06,   5.4591605E-06
     +,   6.3251832E-06,   7.3135338E-06,   8.4389567E-06
     +,   9.7175680E-06,   1.1166950E-05,   1.2806157E-05
     +,   1.4655946E-05,   1.6738486E-05,   1.9077843E-05
     +,   2.1699647E-05,   2.4631272E-05,   2.7901804E-05
     +,   3.1542029E-05,   3.5584399E-05,   4.0062940E-05
     +,   4.5013174E-05,   5.0472099E-05,   5.6477857E-05
     +,   6.3069761E-05,   7.0288021E-05,   7.8173289E-05
     +,   8.6767235E-05,   9.6110663E-05,   1.0624509E-04
     +,   1.1721091E-04,   1.2904774E-04,   1.4179377E-04
     +,   1.5548535E-04,   1.7015665E-04,   1.8583899E-04
     +,   2.0256059E-04,   2.2034576E-04,   2.3921483E-04
     +,   2.5918320E-04,   2.8026127E-04,   3.0245338E-04
     +,   3.2575926E-04,   3.5016963E-04,   3.7567117E-04
     +,   4.0224171E-04,   4.2985257E-04,   4.5846743E-04
     +,   4.8804245E-04,   5.1852642E-04,   5.4986146E-04
     +,   5.8198033E-04,   6.1481178E-04,   6.4827857E-04
     +,   6.8229402E-04,   7.1677170E-04,   7.5161614E-04
     +,   7.8673405E-04,   8.2202523E-04,   8.5739436E-04
     +,   8.9274161E-04,   9.2797534E-04,   9.6300326E-04
     +,   9.9774334E-04,   1.0321211E-03,   1.0660706E-03
     +,   1.0995389E-03,   1.1324893E-03,   1.1649025E-03
     +,   1.1967752E-03,   1.2281290E-03,   1.2590062E-03
     +,   1.2894771E-03,   1.3196354E-03,   1.3496069E-03
     +,   1.3795428E-03,   1.4096285E-03,   1.4400745E-03
     +,   1.4711254E-03,   1.5030543E-03,   1.5361590E-03
     +,   1.5707621E-03,   1.6072127E-03,   1.6458774E-03
     +,   1.6871353E-03,   1.7313819E-03,   1.7790131E-03
     +,   1.8304319E-03,   1.8860322E-03,   1.9462055E-03
     +,   2.0113224E-03,   2.0817434E-03,   2.1577999E-03
     +,   2.2398040E-03,   2.3280426E-03,   2.4227684E-03
     +,   2.5242036E-03,   2.6325511E-03,   2.7479855E-03
     +,   2.8706463E-03,   3.0006662E-03,   3.1381396E-03
     +,   3.2831628E-03,   3.4357908E-03,   3.5960868E-03
     +,   3.7640699E-03,   3.9397567E-03,   4.1231131E-03
     +,   4.3140817E-03,   4.5125559E-03,   4.7183507E-03
     +,   4.9311989E-03,   5.1507512E-03,   5.3765392E-03
     +,   5.6079389E-03,   5.8442028E-03,   6.0843932E-03
     +,   6.3274228E-03,   6.5719960E-03,   6.8166689E-03
     +,   7.0597976E-03,   7.2996221E-03,   7.5342176E-03
     +,   7.7615958E-03,   7.9797115E-03,   8.1865098E-03
     +,   8.3799884E-03,   8.5582705E-03,   8.7196603E-03
     +,   8.8626919E-03,   8.9862095E-03,   9.0894382E-03
     +,   9.1720326E-03,   9.2341248E-03,   9.2763891E-03
     +,   9.3000811E-03,   9.3070753E-03,   9.2998995E-03
     +,   9.2817601E-03,   9.2565678E-03,   9.2289513E-03
     +,   9.2042703E-03,   9.1886101E-03,   9.1887871E-03
     +,   9.2123207E-03,   9.2674140E-03,   9.3629025E-03
     +,   9.5081972E-03,   9.7131692E-03,   9.9880593E-03
     +,   1.0343304E-02,   1.0789289E-02,   1.1336047E-02
     +,   1.1992930E-02,   1.2768068E-02,   1.3667716E-02
     +,   1.4695511E-02,   1.5851783E-02,   1.7132659E-02
     +,   1.8529348E-02,   2.0027872E-02,   2.1609414E-02
     +,   2.3251321E-02,   2.4929019E-02,   2.6619498E-02
     +,   2.8305262E-02,   2.9978907E-02,   3.1647969E-02
     +,   3.3339497E-02,   3.5103653E-02,   3.7017498E-02
     +,   3.9189078E-02,   4.1762345E-02,   4.4920243E-02
     +,   4.8881426E-02,   5.3882729E-02,   6.0140084E-02
     +,   6.7785852E-02,   7.6793142E-02,   8.6916648E-02
     +,   9.7679116E-02,   0.1084334    ,   0.1185064    
     +,   0.1273982    ,   0.1349785    ,   0.1416253    
     +,   0.1482628    ,   0.1562997    ,   0.1674628    
     +,   0.1834711    ,   0.2055007    ,   0.2336237    
     +,   0.2666803    ,   0.3029059    ,   0.3414055    
     +,   0.3852987    ,   0.4465149    ,   0.5442998    
     +,   0.6927987    ,   0.8931030    ,    1.122190    
     +,    1.343962    ,    1.588294    ,    1.891404    
     +,    2.111461    ,    1.987564    ,    1.451317    
     +,   0.7862036    ,   0.3193187    ,   0.1099265    
     +,   4.2897973E-02,   2.2447340E-02,   1.3598063E-02
     +,   8.7002888E-03,   5.9723528E-03,   4.4992194E-03
     +,   3.7278277E-03,   3.3421277E-03,   3.1486803E-03
     +,   3.0294671E-03,   2.9233685E-03,   2.8065885E-03
     +,   2.6742630E-03,   2.5289424E-03,   2.3752921E-03
     +,   2.2181415E-03,   2.0618129E-03,   1.9098561E-03
     +,   1.7649439E-03,   1.6288887E-03,   1.5027201E-03
     +,   1.3867958E-03,   1.2809364E-03,   1.1845876E-03
     +,   1.0969669E-03,   1.0171771E-03,   9.4429834E-04
     +,   8.7746134E-04,   8.1589515E-04,   7.5893337E-04
     +,   7.0602458E-04,   6.5672671E-04,   6.1068800E-04
     +,   5.6762696E-04,   5.2731769E-04,   4.8957736E-04
     +,   4.5425000E-04,   4.2119491E-04,   3.9028295E-04
     +,   3.6139388E-04,   3.3441160E-04,   3.0922212E-04
     +,   2.8571513E-04,   2.6378667E-04,   2.4333506E-04
     +,   2.2426408E-04,   2.0648458E-04,   1.8991313E-04
     +,   1.7447134E-04,   1.6008689E-04,   1.4669410E-04
     +,   1.3423272E-04,   1.2264619E-04,   1.1188267E-04
     +,   1.0189501E-04,   9.2638184E-05,   8.4071151E-05
     +,   7.6154167E-05,   6.8850633E-05,   6.2124716E-05
     +,   5.5943030E-05,   5.0272622E-05,   4.5082528E-05
     +,   4.0342165E-05,   3.6022597E-05,   3.2095490E-05
     +,   2.8533508E-05,   2.5310694E-05,   2.2401686E-05
     +,   1.9782576E-05,   1.7430195E-05,   1.5322817E-05
     +,   1.3439549E-05,   1.1760926E-05,   1.0268413E-05
     +,   8.9448204E-06,   7.7739405E-06,   6.7408514E-06
     +,   5.8315918E-06,   5.0334038E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_asha_ttz110_mass = Yx/4.65997682926829
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_asha_ttz115_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.8503125E-04,   1.9397735E-04
     +,   2.0319154E-04,   2.1267170E-04,   2.2241496E-04
     +,   2.3241789E-04,   2.4267625E-04,   2.5318519E-04
     +,   2.6393906E-04,   2.7493195E-04,   2.8615692E-04
     +,   2.9760643E-04,   3.0927267E-04,   3.2114692E-04
     +,   3.3322020E-04,   3.4548319E-04,   3.5792592E-04
     +,   3.7053844E-04,   3.8331049E-04,   3.9623168E-04
     +,   4.0929182E-04,   4.2248066E-04,   4.3578824E-04
     +,   4.4920584E-04,   4.6272369E-04,   4.7633454E-04
     +,   4.9003121E-04,   5.0380779E-04,   5.1766017E-04
     +,   5.3158536E-04,   5.4558262E-04,   5.5965333E-04
     +,   5.7380134E-04,   5.8803306E-04,   6.0235802E-04
     +,   6.1678927E-04,   6.3134311E-04,   6.4603996E-04
     +,   6.6090521E-04,   6.7596708E-04,   6.9126062E-04
     +,   7.0682477E-04,   7.2270399E-04,   7.3894893E-04
     +,   7.5561553E-04,   7.7276590E-04,   7.9046836E-04
     +,   8.0879708E-04,   8.2783273E-04,   8.4766158E-04
     +,   8.6837611E-04,   8.9007441E-04,   9.1285910E-04
     +,   9.3683938E-04,   9.6212589E-04,   9.8883524E-04
     +,   1.0170857E-03,   1.0469971E-03,   1.0786904E-03
     +,   1.1122858E-03,   1.1479023E-03,   1.1856561E-03
     +,   1.2256561E-03,   1.2680098E-03,   1.3128160E-03
     +,   1.3601617E-03,   1.4101289E-03,   1.4627816E-03
     +,   1.5181778E-03,   1.5763545E-03,   1.6373415E-03
     +,   1.7011446E-03,   1.7677627E-03,   1.8371693E-03
     +,   1.9093279E-03,   1.9841888E-03,   2.0616818E-03
     +,   2.1417253E-03,   2.2242295E-03,   2.3090988E-03
     +,   2.3962227E-03,   2.4854988E-03,   2.5768147E-03
     +,   2.6700746E-03,   2.7651796E-03,   2.8620567E-03
     +,   2.9606372E-03,   3.0608887E-03,   3.1627920E-03
     +,   3.2663671E-03,   3.3716713E-03,   3.4787920E-03
     +,   3.5878569E-03,   3.6990459E-03,   3.8125825E-03
     +,   3.9287261E-03,   4.0477952E-03,   4.1701393E-03
     +,   4.2961622E-03,   4.4262917E-03,   4.5610061E-03
     +,   4.7007925E-03,   4.8461766E-03,   4.9976767E-03
     +,   5.1558274E-03,   5.3211572E-03,   5.4941615E-03
     +,   5.6753019E-03,   5.8650081E-03,   6.0636485E-03
     +,   6.2715020E-03,   6.4887833E-03,   6.7155813E-03
     +,   6.9518997E-03,   7.1975873E-03,   7.4523883E-03
     +,   7.7158739E-03,   7.9874983E-03,   8.2665216E-03
     +,   8.5520903E-03,   8.8431938E-03,   9.1386633E-03
     +,   9.4372081E-03,   9.7374488E-03,   1.0037915E-02
     +,   1.0337062E-02,   1.0633374E-02,   1.0925316E-02
     +,   1.1211487E-02,   1.1490575E-02,   1.1761514E-02
     +,   1.2023464E-02,   1.2275951E-02,   1.2518850E-02
     +,   1.2752526E-02,   1.2977825E-02,   1.3196114E-02
     +,   1.3409304E-02,   1.3619850E-02,   1.3830720E-02
     +,   1.4045297E-02,   1.4267358E-02,   1.4500939E-02
     +,   1.4750231E-02,   1.5019421E-02,   1.5312603E-02
     +,   1.5633663E-02,   1.5986126E-02,   1.6373105E-02
     +,   1.6797271E-02,   1.7260779E-02,   1.7765235E-02
     +,   1.8311664E-02,   1.8900517E-02,   1.9531596E-02
     +,   2.0203842E-02,   2.0915287E-02,   2.1662924E-02
     +,   2.2442564E-02,   2.3248672E-02,   2.4074670E-02
     +,   2.4913171E-02,   2.5756586E-02,   2.6598185E-02
     +,   2.7433475E-02,   2.8261783E-02,   2.9087923E-02
     +,   2.9923860E-02,   3.0789921E-02,   3.1715114E-02
     +,   3.2736402E-02,   3.3896778E-02,   3.5242163E-02
     +,   3.6817305E-02,   3.8661126E-02,   4.0802915E-02
     +,   4.3259412E-02,   4.6033595E-02,   4.9116377E-02
     +,   5.2491214E-02,   5.6140974E-02,   6.0057126E-02
     +,   6.4250201E-02,   6.8759009E-02,   7.3654570E-02
     +,   7.9035021E-02,   8.5011266E-02,   9.1684073E-02
     +,   9.9120125E-02,   0.1073375    ,   0.1163147    
     +,   0.1260255    ,   0.1364945    ,   0.1478588    
     +,   0.1603992    ,   0.1745060    ,   0.1905537    
     +,   0.2087077    ,   0.2287583    ,   0.2501474    
     +,   0.2723013    ,   0.2951133    ,   0.3191711    
     +,   0.3454706    ,   0.3748814    ,   0.4078535    
     +,   0.4444314    ,   0.4844536    ,   0.5280851    
     +,   0.5763417    ,   0.6298143    ,   0.6845569    
     +,   0.7285331    ,   0.7442139    ,   0.7175450    
     +,   0.6463752    ,   0.5418452    ,   0.4229811    
     +,   0.3091317    ,   0.2141500    ,   0.1438817    
     +,   9.7048454E-02,   6.8265252E-02,   5.1298335E-02
     +,   4.1117132E-02,   3.4461681E-02,   2.9518854E-02
     +,   2.5388654E-02,   2.1678351E-02,   1.8262515E-02
     +,   1.5145332E-02,   1.2375777E-02,   9.9967290E-03
     +,   8.0217896E-03,   6.4323675E-03,   5.1857424E-03
     +,   4.2272126E-03,   3.5003647E-03,   2.9535450E-03
     +,   2.5428908E-03,   2.2329788E-03,   1.9961186E-03
     +,   1.8111538E-03,   1.6622568E-03,   1.5378831E-03
     +,   1.4298742E-03,   1.3326817E-03,   1.2427176E-03
     +,   1.1578205E-03,   1.0768226E-03,   9.9918945E-04
     +,   9.2477229E-04,   8.5363118E-04,   7.8590895E-04
     +,   7.2175340E-04,   6.6127937E-04,   6.0455303E-04
     +,   5.5158278E-04,   5.0231832E-04,   4.5666267E-04
     +,   4.1448401E-04,   3.7562251E-04,   3.3989677E-04
     +,   3.0711526E-04,   2.7708581E-04,   2.4961476E-04
     +,   2.2451412E-04,   2.0160616E-04,   1.8072309E-04
     +,   1.6170666E-04,   1.4441028E-04,   1.2869952E-04
     +,   1.1445029E-04,   1.0154714E-04,   8.9883593E-05
     +,   7.9362180E-05,   6.9891081E-05,   6.1386039E-05
     +,   5.3767290E-05,   4.6961177E-05,   4.0897732E-05
     +,   3.5512217E-05,   3.0743140E-05,   2.6533547E-05
     +,   2.2829581E-05,   1.9581506E-05,   1.6742701E-05
     +,   1.4269990E-05,   1.2123723E-05,   1.0267176E-05
     +,   8.6669679E-06,   7.2924809E-06,   6.1161159E-06
     +,   5.1128131E-06,   4.2602105E-06,   3.5381927E-06
     +,   2.9289679E-06,   2.4167059E-06,   1.9875299E-06
     +,   1.6292107E-06,   1.3311287E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_asha_ttz115_mass = Yx/3.35389653846154
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_asha_ttz120_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.7865701E-04,   1.9033860E-04
     +,   2.0264060E-04,   2.1558625E-04,   2.2919882E-04
     +,   2.4350201E-04,   2.5851966E-04,   2.7427578E-04
     +,   2.9079453E-04,   3.0810072E-04,   3.2621875E-04
     +,   3.4517329E-04,   3.6498913E-04,   3.8569109E-04
     +,   4.0730412E-04,   4.2985310E-04,   4.5336285E-04
     +,   4.7785850E-04,   5.0336466E-04,   5.2990613E-04
     +,   5.5750774E-04,   5.8619387E-04,   6.1598839E-04
     +,   6.4691721E-04,   6.7900226E-04,   7.1226875E-04
     +,   7.4674009E-04,   7.8243925E-04,   8.1938930E-04
     +,   8.5761276E-04,   8.9713215E-04,   9.3796890E-04
     +,   9.8014472E-04,   1.0236804E-03,   1.0685964E-03
     +,   1.1149124E-03,   1.1626479E-03,   1.2118205E-03
     +,   1.2624513E-03,   1.3145540E-03,   1.3681481E-03
     +,   1.4232496E-03,   1.4798741E-03,   1.5380376E-03
     +,   1.5977550E-03,   1.6590421E-03,   1.7219144E-03
     +,   1.7863881E-03,   1.8524799E-03,   1.9202091E-03
     +,   1.9895961E-03,   2.0606634E-03,   2.1334377E-03
     +,   2.2079537E-03,   2.2842439E-03,   2.3623556E-03
     +,   2.4423411E-03,   2.5242625E-03,   2.6081949E-03
     +,   2.6942263E-03,   2.7824608E-03,   2.8730221E-03
     +,   2.9660473E-03,   3.0617043E-03,   3.1601845E-03
     +,   3.2616949E-03,   3.3664855E-03,   3.4748197E-03
     +,   3.5870054E-03,   3.7033651E-03,   3.8242657E-03
     +,   3.9500860E-03,   4.0812455E-03,   4.2181676E-03
     +,   4.3613045E-03,   4.5111179E-03,   4.6680635E-03
     +,   4.8325858E-03,   5.0051212E-03,   5.1860786E-03
     +,   5.3758044E-03,   5.5746096E-03,   5.7827081E-03
     +,   6.0002506E-03,   6.2272605E-03,   6.4636678E-03
     +,   6.7092418E-03,   6.9636432E-03,   7.2263437E-03
     +,   7.4966848E-03,   7.7738483E-03,   8.0568334E-03
     +,   8.3444957E-03,   8.6355628E-03,   8.9286463E-03
     +,   9.2222309E-03,   9.5147807E-03,   9.8046828E-03
     +,   1.0090388E-02,   1.0370380E-02,   1.0643288E-02
     +,   1.0907886E-02,   1.1163212E-02,   1.1408579E-02
     +,   1.1643653E-02,   1.1868523E-02,   1.2083688E-02
     +,   1.2290137E-02,   1.2489376E-02,   1.2683424E-02
     +,   1.2874766E-02,   1.3066385E-02,   1.3261680E-02
     +,   1.3464408E-02,   1.3678581E-02,   1.3908412E-02
     +,   1.4158122E-02,   1.4431903E-02,   1.4733694E-02
     +,   1.5067142E-02,   1.5435414E-02,   1.5841076E-02
     +,   1.6286012E-02,   1.6771354E-02,   1.7297409E-02
     +,   1.7863542E-02,   1.8468296E-02,   1.9109240E-02
     +,   1.9783113E-02,   2.0485763E-02,   2.1212269E-02
     +,   2.1956900E-02,   2.2713298E-02,   2.3474382E-02
     +,   2.4232615E-02,   2.4979932E-02,   2.5707893E-02
     +,   2.6407711E-02,   2.7070560E-02,   2.7687568E-02
     +,   2.8250005E-02,   2.8749552E-02,   2.9178541E-02
     +,   2.9530171E-02,   2.9798768E-02,   2.9980110E-02
     +,   3.0071620E-02,   3.0072618E-02,   2.9984489E-02
     +,   2.9810788E-02,   2.9557254E-02,   2.9231798E-02
     +,   2.8844386E-02,   2.8406810E-02,   2.7932433E-02
     +,   2.7435971E-02,   2.6933167E-02,   2.6440458E-02
     +,   2.5974786E-02,   2.5553454E-02,   2.5193885E-02
     +,   2.4913650E-02,   2.4730554E-02,   2.4662688E-02
     +,   2.4728559E-02,   2.4947392E-02,   2.5339145E-02
     +,   2.5924664E-02,   2.6725478E-02,   2.7763415E-02
     +,   2.9059730E-02,   3.0634025E-02,   3.2503001E-02
     +,   3.4679059E-02,   3.7168887E-02,   3.9973449E-02
     +,   4.3087859E-02,   4.6502031E-02,   5.0201595E-02
     +,   5.4168388E-02,   5.8378946E-02,   6.2801085E-02
     +,   6.7389637E-02,   7.2083279E-02,   7.6804675E-02
     +,   8.1468105E-02,   8.5997507E-02,   9.0353668E-02
     +,   9.4564267E-02,   9.8748475E-02,   0.1031254    
     +,   0.1079940    ,   0.1136816    ,   0.1204668    
     +,   0.1284925    ,   0.1376929    ,   0.1477647    
     +,   0.1582093    ,   0.1684559    ,   0.1780521    
     +,   0.1868805    ,   0.1953295    ,   0.2043328    
     +,   0.2152068    ,   0.2292810    ,   0.2474055    
     +,   0.2694978    ,   0.2943082    ,   0.3195308    
     +,   0.3422333    ,   0.3594483    ,   0.3687271    
     +,   0.3685110    ,   0.3582776    ,   0.3385208    
     +,   0.3106364    ,   0.2767396    ,   0.2393956    
     +,   0.2012760    ,   0.1647837    ,   0.1317331    
     +,   0.1031910    ,   7.9498395E-02,   6.0433611E-02
     +,   4.5440450E-02,   3.3841066E-02,   2.4981366E-02
     +,   1.8299358E-02,   1.3337987E-02,   9.7297849E-03
     +,   7.1745147E-03,   5.4218182E-03,   4.2622862E-03
     +,   3.5241146E-03,   3.0712914E-03,   2.8009168E-03
     +,   2.6391451E-03,   2.5358298E-03,   2.4588434E-03
     +,   2.3889043E-03,   2.3153657E-03,   2.2330803E-03
     +,   2.1402452E-03,   2.0369983E-03,   1.9245625E-03
     +,   1.8047402E-03,   1.6795988E-03,   1.5512736E-03
     +,   1.4218553E-03,   1.2933214E-03,   1.1674529E-03
     +,   1.0458095E-03,   9.2971028E-04,   8.2021300E-04
     +,   7.1810564E-04,   6.2392338E-04,   5.3796940E-04
     +,   4.6033072E-04,   3.9090117E-04,   3.2941738E-04
     +,   2.7549360E-04,   2.2864676E-04,   1.8832380E-04
     +,   1.5393234E-04,   1.2486626E-04,   1.0051918E-04
     +,   8.0304228E-05,   6.3667459E-05,   5.0094517E-05
     +,   3.9115967E-05,   3.0311390E-05,   2.3310422E-05
     +,   1.7790620E-05,   1.3474915E-05,   1.0128654E-05
     +,   7.5557350E-06,   5.5936334E-06,   4.1097210E-06
     +,   2.9965684E-06,   2.1683998E-06,   1.5572161E-06
     +,   1.1098494E-06,   7.8501063E-07,   5.5105414E-07
     +,   3.8389348E-07,   2.6542185E-07,   1.8212397E-07
     +,   1.2402199E-07,   8.3818961E-08,   5.6219651E-08
     +,   3.7423856E-08,   2.4723660E-08,   1.6210416E-08
     +,   1.0548259E-08,   6.8121855E-09,   4.3661665E-09
     +,   2.7773781E-09,   1.7533909E-09,   1.0986176E-09
     +,   6.8316541E-10,   4.2162934E-10
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_asha_ttz120_mass = Yx/2.43314516666667
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_asha_ttz60_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.2078646E-04,   3.3994811E-04
     +,   3.6006476E-04,   3.8117031E-04,   4.0329774E-04
     +,   4.2647999E-04,   4.5075009E-04,   4.7614184E-04
     +,   5.0269120E-04,   5.3044001E-04,   5.5943592E-04
     +,   5.8973941E-04,   6.2142726E-04,   6.5460161E-04
     +,   6.8939757E-04,   7.2599604E-04,   7.6463690E-04
     +,   8.0563733E-04,   8.4941066E-04,   8.9649105E-04
     +,   9.4755896E-04,   1.0034713E-03,   1.0652908E-03
     +,   1.1343244E-03,   1.2121423E-03,   1.3006235E-03
     +,   1.4019666E-03,   1.5187135E-03,   1.6537529E-03
     +,   1.8103117E-03,   1.9919304E-03,   2.2024154E-03
     +,   2.4457744E-03,   2.7261265E-03,   3.0475934E-03
     +,   3.4141797E-03,   3.8296375E-03,   4.2973286E-03
     +,   4.8201494E-03,   5.4003559E-03,   6.0396250E-03
     +,   6.7389999E-03,   7.4989917E-03,   8.3197718E-03
     +,   9.2014065E-03,   1.0144206E-02,   1.1149133E-02
     +,   1.2218209E-02,   1.3354992E-02,   1.4564935E-02
     +,   1.5855676E-02,   1.7237188E-02,   1.8721716E-02
     +,   2.0323660E-02,   2.2058861E-02,   2.3944458E-02
     +,   2.5997888E-02,   2.8236520E-02,   3.0677173E-02
     +,   3.3335947E-02,   3.6228299E-02,   3.9369393E-02
     +,   4.2774182E-02,   4.6458006E-02,   5.0435804E-02
     +,   5.4720148E-02,   5.9319425E-02,   6.4232320E-02
     +,   6.9443725E-02,   7.4917331E-02,   8.0591343E-02
     +,   8.6373314E-02,   9.2140630E-02,   9.7742565E-02
     +,   0.1030094    ,   0.1077645    ,   0.1118391    
     +,   0.1150901    ,   0.1174145    ,   0.1187610    
     +,   0.1191345    ,   0.1185947    ,   0.1172488    
     +,   0.1152366    ,   0.1127181    ,   0.1098568    
     +,   0.1068100    ,   0.1037208    ,   0.1007167    
     +,   9.7910747E-02,   9.5404722E-02,   9.3292341E-02
     +,   9.1659039E-02,   9.0579316E-02,   9.0109669E-02
     +,   9.0279914E-02,   9.1083512E-02,   9.2470199E-02
     +,   9.4343305E-02,   9.6562058E-02,   9.8951198E-02
     +,   0.1013148    ,   0.1034550    ,   0.1051900    
     +,   0.1063716    ,   0.1068970    ,   0.1067154    
     +,   0.1058278    ,   0.1042818    ,   0.1021608    
     +,   9.9572182E-02,   9.6633770E-02,   9.3463644E-02
     +,   9.0171263E-02,   8.6853251E-02,   8.3590835E-02
     +,   8.0452144E-02,   7.7493683E-02,   7.4764192E-02
     +,   7.2306506E-02,   7.0159040E-02,   6.8355441E-02
     +,   6.6922404E-02,   6.5876611E-02,   6.5221310E-02
     +,   6.4943291E-02,   6.5010779E-02,   6.5372825E-02
     +,   6.5961018E-02,   6.6692658E-02,   6.7475781E-02
     +,   6.8215102E-02,   6.8818785E-02,   6.9204636E-02
     +,   6.9305860E-02,   6.9075130E-02,   6.8487212E-02
     +,   6.7539804E-02,   6.6252217E-02,   6.4663053E-02
     +,   6.2826119E-02,   6.0805980E-02,   5.8672592E-02
     +,   5.6496557E-02,   5.4344941E-02,   5.2277125E-02
     +,   5.0342254E-02,   4.8577771E-02,   4.7008533E-02
     +,   4.5646925E-02,   4.4494003E-02,   4.3541055E-02
     +,   4.2771455E-02,   4.2162526E-02,   4.1687869E-02
     +,   4.1319076E-02,   4.1027647E-02,   4.0786251E-02
     +,   4.0569913E-02,   4.0356781E-02,   4.0128712E-02
     +,   3.9871342E-02,   3.9574184E-02,   3.9230350E-02
     +,   3.8836125E-02,   3.8390607E-02,   3.7895087E-02
     +,   3.7352618E-02,   3.6767337E-02,   3.6144108E-02
     +,   3.5488199E-02,   3.4804896E-02,   3.4099203E-02
     +,   3.3375777E-02,   3.2638922E-02,   3.1892359E-02
     +,   3.1139385E-02,   3.0382924E-02,   2.9625513E-02
     +,   2.8869368E-02,   2.8116489E-02,   2.7368698E-02
     +,   2.6627718E-02,   2.5895042E-02,   2.5172107E-02
     +,   2.4460239E-02,   2.3760634E-02,   2.3074264E-02
     +,   2.2401931E-02,   2.1744275E-02,   2.1101633E-02
     +,   2.0474089E-02,   1.9861508E-02,   1.9263493E-02
     +,   1.8679393E-02,   1.8108333E-02,   1.7549315E-02
     +,   1.7001234E-02,   1.6462861E-02,   1.5932955E-02
     +,   1.5410354E-02,   1.4893975E-02,   1.4382823E-02
     +,   1.3876074E-02,   1.3373137E-02,   1.2873578E-02
     +,   1.2377176E-02,   1.1883958E-02,   1.1394149E-02
     +,   1.0908135E-02,   1.0426460E-02,   9.9498508E-03
     +,   9.4791381E-03,   9.0152025E-03,   8.5589858E-03
     +,   8.1114732E-03,   7.6736454E-03,   7.2464310E-03
     +,   6.8307039E-03,   6.4273058E-03,   6.0369563E-03
     +,   5.6602769E-03,   5.2978103E-03,   4.9499846E-03
     +,   4.6170955E-03,   4.2993273E-03,   3.9967783E-03
     +,   3.7094455E-03,   3.4372071E-03,   3.1798619E-03
     +,   2.9371453E-03,   2.7087252E-03,   2.4941952E-03
     +,   2.2931071E-03,   2.1049909E-03,   1.9293292E-03
     +,   1.7655867E-03,   1.6132252E-03,   1.4716999E-03
     +,   1.3404542E-03,   1.2189397E-03,   1.1066225E-03
     +,   1.0029802E-03,   9.0749713E-04,   8.1967487E-04
     +,   7.3903822E-04,   6.6512922E-04,   5.9750420E-04
     +,   5.3573825E-04,   4.7943235E-04,   4.2819974E-04
     +,   3.8167316E-04,   3.3950675E-04,   3.0137174E-04
     +,   2.6695448E-04,   2.3595897E-04,   2.0810761E-04
     +,   1.8313889E-04,   1.6080531E-04,   1.4087492E-04
     +,   1.2313225E-04,   1.0737574E-04,   9.3417002E-05
     +,   8.1081213E-05,   7.0207716E-05,   6.0647129E-05
     +,   5.2262167E-05,   4.4927452E-05,   3.8528273E-05
     +,   3.2959670E-05,   2.8126417E-05,   2.3942579E-05
     +,   2.0330615E-05,   1.7220525E-05,   1.4549630E-05
     +,   1.2262187E-05,   1.0308267E-05,   8.6438367E-06
     +,   7.2297257E-06,   6.0316120E-06,   5.0191761E-06
     +,   4.1660196E-06,   3.4489851E-06,   2.8480308E-06
     +,   2.3457042E-06,   1.9269885E-06,   1.5789084E-06
     +,   1.2903305E-06,   1.0517538E-06,   8.5504206E-07
     +,   6.9330537E-07,   5.6068183E-07,   4.5223774E-07
     +,   3.6380371E-07,   2.9189073E-07,   2.3357043E-07
     +,   1.8640782E-07,   1.4837136E-07,   1.1778229E-07
     +,   9.3249113E-08,   7.3629032E-08
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_asha_ttz60_mass = Yx/2.24535208333333
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_asha_ttz65_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  5.0613441E-04,   5.1570300E-04
     +,   5.2547437E-04,   5.3549750E-04,   5.4583029E-04
     +,   5.5654033E-04,   5.6770729E-04,   5.7942251E-04
     +,   5.9179228E-04,   6.0493842E-04,   6.1899994E-04
     +,   6.3413492E-04,   6.5052253E-04,   6.6836458E-04
     +,   6.8788743E-04,   7.0934388E-04,   7.3301489E-04
     +,   7.5921137E-04,   7.8827521E-04,   8.2058104E-04
     +,   8.5653696E-04,   8.9658494E-04,   9.4120082E-04
     +,   9.9089660E-04,   1.0462123E-03,   1.1077247E-03
     +,   1.1760369E-03,   1.2517776E-03,   1.3355982E-03
     +,   1.4281673E-03,   1.5301642E-03,   1.6422721E-03
     +,   1.7651708E-03,   1.8995272E-03,   2.0459834E-03
     +,   2.2051462E-03,   2.3775746E-03,   2.5637611E-03
     +,   2.7641340E-03,   2.9790043E-03,   3.2086000E-03
     +,   3.4530070E-03,   3.7121805E-03,   3.9859251E-03
     +,   4.2738863E-03,   4.5755566E-03,   4.8902766E-03
     +,   5.2172546E-03,   5.5555981E-03,   5.9043556E-03
     +,   6.2625827E-03,   6.6294130E-03,   7.0041553E-03
     +,   7.3864255E-03,   7.7762068E-03,   8.1740571E-03
     +,   8.5811689E-03,   8.9995191E-03,   9.4319554E-03
     +,   9.8822704E-03,   1.0355233E-02,   1.0856581E-02
     +,   1.1392931E-02,   1.1971734E-02,   1.2601133E-02
     +,   1.3289713E-02,   1.4046580E-02,   1.4881086E-02
     +,   1.5803197E-02,   1.6823577E-02,   1.7954515E-02
     +,   1.9210700E-02,   2.0611007E-02,   2.2180025E-02
     +,   2.3950623E-02,   2.5966203E-02,   2.8283017E-02
     +,   3.0972537E-02,   3.4123849E-02,   3.7845444E-02
     +,   4.2266965E-02,   4.7541790E-02,   5.3847007E-02
     +,   6.1382629E-02,   7.0361093E-02,   8.0987923E-02
     +,   9.3421519E-02,   0.1077193    ,   0.1237662    
     +,   0.1412156    ,   0.1594543    ,   0.1776230    
     +,   0.1947076    ,   0.2096895    ,   0.2217200    
     +,   0.2302738    ,   0.2352379    ,   0.2369063    
     +,   0.2358922    ,   0.2329861    ,   0.2290034    
     +,   0.2246573    ,   0.2204806    ,   0.2168002    
     +,   0.2137568    ,   0.2113530    ,   0.2095035    
     +,   0.2080722    ,   0.2068829    ,   0.2057112    
     +,   0.2042810    ,   0.2022837    ,   0.1994377    
     +,   0.1955700    ,   0.1906963    ,   0.1850572    
     +,   0.1790959    ,   0.1733704    ,   0.1684334    
     +,   0.1647100    ,   0.1624135    ,   0.1615168    
     +,   0.1617802    ,   0.1628217    ,   0.1642073    
     +,   0.1655365    ,   0.1665063    ,   0.1669463    
     +,   0.1668183    ,   0.1661925    ,   0.1652013    
     +,   0.1639871    ,   0.1626552    ,   0.1612411    
     +,   0.1597004    ,   0.1579203    ,   0.1557500    
     +,   0.1530376    ,   0.1496650    ,   0.1455729    
     +,   0.1407697    ,   0.1353271    ,   0.1293635    
     +,   0.1230243    ,   0.1164633    ,   0.1098276    
     +,   0.1032489    ,   9.6842073E-02,   9.0703875E-02
     +,   8.4913529E-02,   7.9533182E-02,   7.4606977E-02
     +,   7.0160165E-02,   6.6197671E-02,   6.2706158E-02
     +,   5.9656605E-02,   5.7008475E-02,   5.4714493E-02
     +,   5.2725814E-02,   5.0996181E-02,   4.9484327E-02
     +,   4.8155498E-02,   4.6981495E-02,   4.5939531E-02
     +,   4.5010738E-02,   4.4178426E-02,   4.3426961E-02
     +,   4.2740401E-02,   4.2102266E-02,   4.1495480E-02
     +,   4.0902894E-02,   4.0307865E-02,   3.9695032E-02
     +,   3.9051130E-02,   3.8365625E-02,   3.7631035E-02
     +,   3.6843222E-02,   3.6001429E-02,   3.5108089E-02
     +,   3.4168348E-02,   3.3189673E-02,   3.2181289E-02
     +,   3.1153606E-02,   3.0117363E-02,   2.9083207E-02
     +,   2.8061185E-02,   2.7060129E-02,   2.6087338E-02
     +,   2.5148321E-02,   2.4246786E-02,   2.3384491E-02
     +,   2.2561394E-02,   2.1775957E-02,   2.1025341E-02
     +,   2.0305702E-02,   1.9612595E-02,   1.8941335E-02
     +,   1.8287294E-02,   1.7646115E-02,   1.7013978E-02
     +,   1.6387781E-02,   1.5765199E-02,   1.5144665E-02
     +,   1.4525387E-02,   1.3907346E-02,   1.3291082E-02
     +,   1.2677639E-02,   1.2068472E-02,   1.1465315E-02
     +,   1.0869992E-02,   1.0284388E-02,   9.7103845E-03
     +,   9.1497619E-03,   8.6041167E-03,   8.0748526E-03
     +,   7.5632147E-03,   7.0702336E-03,   6.5966938E-03
     +,   6.1431839E-03,   5.7101524E-03,   5.2978243E-03
     +,   4.9062744E-03,   4.5354660E-03,   4.1852295E-03
     +,   3.8552699E-03,   3.5451937E-03,   3.2545472E-03
     +,   2.9828015E-03,   2.7293463E-03,   2.4935200E-03
     +,   2.2746336E-03,   2.0719590E-03,   1.8847247E-03
     +,   1.7121431E-03,   1.5534280E-03,   1.4077706E-03
     +,   1.2743651E-03,   1.1524211E-03,   1.0411616E-03
     +,   9.3981961E-04,   8.4765395E-04,   7.6395809E-04
     +,   6.8805483E-04,   6.1929738E-04,   5.5707514E-04
     +,   5.0081959E-04,   4.4999967E-04,   4.0411891E-04
     +,   3.6271909E-04,   3.2538248E-04,   2.9172248E-04
     +,   2.6138642E-04,   2.3405551E-04,   2.0943975E-04
     +,   1.8727500E-04,   1.6732269E-04,   1.4936877E-04
     +,   1.3321979E-04,   1.1870033E-04,   1.0565237E-04
     +,   9.3934192E-05,   8.3417894E-05,   7.3987176E-05
     +,   6.5537097E-05,   5.7973488E-05,   5.1210252E-05
     +,   4.5169443E-05,   3.9780716E-05,   3.4980192E-05
     +,   3.0709463E-05,   2.6915530E-05,   2.3550450E-05
     +,   2.0570620E-05,   1.7936225E-05,   1.5611136E-05
     +,   1.3562801E-05,   1.1761415E-05,   1.0180253E-05
     +,   8.7949111E-06,   7.5835583E-06,   6.5263475E-06
     +,   5.6055505E-06,   4.8051311E-06,   4.1108119E-06
     +,   3.5097337E-06,   2.9904886E-06,   2.5428621E-06
     +,   2.1577839E-06,   1.8272401E-06,   1.5441024E-06
     +,   1.3021115E-06,   1.0957278E-06,   9.2010822E-07
     +,   7.7098684E-07,   6.4465593E-07,   5.3786329E-07
     +,   4.4779657E-07,   3.7200121E-07,   3.0836458E-07
     +,   2.5505437E-07,   2.1049919E-07
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_asha_ttz65_mass = Yx/3.29360176923077
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_asha_ttz70_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  6.5270154E-04,   6.8031932E-04
     +,   7.0857356E-04,   7.3743495E-04,   7.6687016E-04
     +,   7.9684251E-04,   8.2731160E-04,   8.5823401E-04
     +,   8.8956195E-04,   9.2124625E-04,   9.5323386E-04
     +,   9.8546874E-04,   1.0178933E-03,   1.0504477E-03
     +,   1.0830704E-03,   1.1156989E-03,   1.1482702E-03
     +,   1.1807210E-03,   1.2129882E-03,   1.2450098E-03
     +,   1.2767258E-03,   1.3080778E-03,   1.3390103E-03
     +,   1.3694729E-03,   1.3994171E-03,   1.4288013E-03
     +,   1.4575896E-03,   1.4857518E-03,   1.5132657E-03
     +,   1.5401167E-03,   1.5662998E-03,   1.5918192E-03
     +,   1.6166886E-03,   1.6409346E-03,   1.6645927E-03
     +,   1.6877126E-03,   1.7103554E-03,   1.7325950E-03
     +,   1.7545202E-03,   1.7762301E-03,   1.7978408E-03
     +,   1.8194792E-03,   1.8412874E-03,   1.8634199E-03
     +,   1.8860451E-03,   1.9093449E-03,   1.9335138E-03
     +,   1.9587604E-03,   1.9853080E-03,   2.0133939E-03
     +,   2.0432738E-03,   2.0752214E-03,   2.1095320E-03
     +,   2.1465309E-03,   2.1865694E-03,   2.2300428E-03
     +,   2.2773889E-03,   2.3291013E-03,   2.3857360E-03
     +,   2.4479248E-03,   2.5163826E-03,   2.5919182E-03
     +,   2.6754353E-03,   2.7679505E-03,   2.8705881E-03
     +,   2.9845661E-03,   3.1112148E-03,   3.2519354E-03
     +,   3.4082178E-03,   3.5815851E-03,   3.7736213E-03
     +,   3.9859097E-03,   4.2200829E-03,   4.4777803E-03
     +,   4.7607338E-03,   5.0708177E-03,   5.4101306E-03
     +,   5.7811770E-03,   6.1871419E-03,   6.6322093E-03
     +,   7.1220244E-03,   7.6644574E-03,   8.2703698E-03
     +,   8.9548137E-03,   9.7380336E-03,   1.0646733E-02
     +,   1.1714544E-02,   1.2982303E-02,   1.4496929E-02
     +,   1.6310137E-02,   1.8476581E-02,   2.1052886E-02
     +,   2.4098990E-02,   2.7682962E-02,   3.1888869E-02
     +,   3.6827214E-02,   4.2649034E-02,   4.9559541E-02
     +,   5.7837833E-02,   6.7857519E-02,   8.0111369E-02
     +,   9.5216386E-02,   0.1138791    ,   0.1367657    
     +,   0.1642621    ,   0.1961363    ,   0.2312308    
     +,   0.2674003    ,   0.3018694    ,   0.3319713    
     +,   0.3559585    ,   0.3734587    ,   0.3852827    
     +,   0.3927202    ,   0.3967451    ,   0.3977042    
     +,   0.3957775    ,   0.3919486    ,   0.3885972    
     +,   0.3888027    ,   0.3944179    ,   0.4042611    
     +,   0.4140898    ,   0.4186520    ,   0.4143083    
     +,   0.4003932    ,   0.3788774    ,   0.3532696    
     +,   0.3276255    ,   0.3056988    ,   0.2899348    
     +,   0.2806531    ,   0.2760800    ,   0.2734598    
     +,   0.2705881    ,   0.2667826    ,   0.2627625    
     +,   0.2596999    ,   0.2581860    ,   0.2577247    
     +,   0.2568997    ,   0.2539702    ,   0.2475350    
     +,   0.2369962    ,   0.2227099    ,   0.2058285    
     +,   0.1879377    ,   0.1706236    ,   0.1551092    
     +,   0.1420511    ,   0.1315264    ,   0.1231687    
     +,   0.1163766    ,   0.1105193    ,   0.1050802    
     +,   9.9721268E-02,   9.4280563E-02,   8.8733256E-02
     +,   8.3142094E-02,   7.7614598E-02,   7.2268881E-02
     +,   6.7212135E-02,   6.2527247E-02,   5.8265697E-02
     +,   5.4446135E-02,   5.1058702E-02,   4.8071932E-02
     +,   4.5440711E-02,   4.3114085E-02,   4.1041777E-02
     +,   3.9178532E-02,   3.7486043E-02,   3.5933290E-02
     +,   3.4495868E-02,   3.3154935E-02,   3.1895563E-02
     +,   3.0705813E-02,   2.9575961E-02,   2.8497869E-02
     +,   2.7464690E-02,   2.6470721E-02,   2.5511408E-02
     +,   2.4583198E-02,   2.3683351E-02,   2.2809904E-02
     +,   2.1961596E-02,   2.1137638E-02,   2.0337524E-02
     +,   1.9560982E-02,   1.8807897E-02,   1.8078100E-02
     +,   1.7371355E-02,   1.6687365E-02,   1.6025694E-02
     +,   1.5385694E-02,   1.4766562E-02,   1.4167394E-02
     +,   1.3587154E-02,   1.3024671E-02,   1.2478717E-02
     +,   1.1948078E-02,   1.1431570E-02,   1.0928029E-02
     +,   1.0436402E-02,   9.9558141E-03,   9.4855074E-03
     +,   9.0248864E-03,   8.5735871E-03,   8.1314184E-03
     +,   7.6983371E-03,   7.2744670E-03,   6.8601030E-03
     +,   6.4556506E-03,   6.0615898E-03,   5.6784614E-03
     +,   5.3068721E-03,   4.9474365E-03,   4.6007298E-03
     +,   4.2672930E-03,   3.9476445E-03,   3.6421982E-03
     +,   3.3512865E-03,   3.0751664E-03,   2.8139988E-03
     +,   2.5678268E-03,   2.3365938E-03,   2.1201647E-03
     +,   1.9183130E-03,   1.7307126E-03,   1.5569648E-03
     +,   1.3966174E-03,   1.2491583E-03,   1.1140197E-03
     +,   9.9059811E-04,   8.7827467E-04,   7.7640038E-04
     +,   6.8431738E-04,   6.0137222E-04,   5.2691548E-04
     +,   4.6030380E-04,   4.0091091E-04,   3.4813603E-04
     +,   3.0140200E-04,   2.6015574E-04,   2.2387452E-04
     +,   1.9206962E-04,   1.6428353E-04,   1.4008935E-04
     +,   1.1909310E-04,   1.0093460E-04,   8.5282554E-05
     +,   7.1835973E-05,   6.0323298E-05,   5.0499824E-05
     +,   4.2145512E-05,   3.5064299E-05,   2.9082496E-05
     +,   2.4046498E-05,   1.9820796E-05,   1.6286785E-05
     +,   1.3341220E-05,   1.0894392E-05,   8.8685683E-06
     +,   7.1968507E-06,   5.8220348E-06,   4.6951081E-06
     +,   3.7744230E-06,   3.0247625E-06,   2.4164015E-06
     +,   1.9243298E-06,   1.5276273E-06,   1.2088841E-06
     +,   9.5363515E-07,   7.4990322E-07,   5.8782484E-07
     +,   4.5931975E-07,   3.5776478E-07,   2.7777935E-07
     +,   2.1498727E-07,   1.6585939E-07,   1.2754762E-07
     +,   9.7771888E-08,   7.4705845E-08,   5.6898202E-08
     +,   4.3195104E-08,   3.2686462E-08,   2.4654202E-08
     +,   1.8535131E-08,   1.3889530E-08,   1.0374184E-08
     +,   7.7232514E-09,   5.7307759E-09,   4.2383657E-09
     +,   3.1242329E-09,   2.2953686E-09,   1.6807878E-09
     +,   1.2266786E-09,   8.9226160E-10,   6.4684863E-10
     +,   4.6735760E-10,   3.3654018E-10
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_asha_ttz70_mass = Yx/4.0857243
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_asha_ttz75_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  6.8698682E-05,   6.7781992E-05
     +,   6.7081040E-05,   6.6597080E-05,   6.6331289E-05
     +,   6.6284745E-05,   6.6458437E-05,   6.6853296E-05
     +,   6.7470188E-05,   6.8309942E-05,   6.9373396E-05
     +,   7.0661270E-05,   7.2174378E-05,   7.3913492E-05
     +,   7.5879441E-05,   7.8073099E-05,   8.0495425E-05
     +,   8.3147483E-05,   8.6030501E-05,   8.9145826E-05
     +,   9.2495102E-05,   9.6080119E-05,   9.9903016E-05
     +,   1.0396650E-04,   1.0827329E-04,   1.1282692E-04
     +,   1.1763137E-04,   1.2269118E-04,   1.2801173E-04
     +,   1.3359905E-04,   1.3946026E-04,   1.4560328E-04
     +,   1.5203725E-04,   1.5877254E-04,   1.6582099E-04
     +,   1.7319595E-04,   1.8091245E-04,   1.8898750E-04
     +,   1.9744068E-04,   2.0629338E-04,   2.1557068E-04
     +,   2.2530039E-04,   2.3551434E-04,   2.4624873E-04
     +,   2.5754471E-04,   2.6944937E-04,   2.8201676E-04
     +,   2.9530859E-04,   3.0939607E-04,   3.2436076E-04
     +,   3.4029645E-04,   3.5731110E-04,   3.7552795E-04
     +,   3.9508971E-04,   4.1615689E-04,   4.3891463E-04
     +,   4.6357143E-04,   4.9036276E-04,   5.1955279E-04
     +,   5.5143662E-04,   5.8634084E-04,   6.2462565E-04
     +,   6.6668214E-04,   7.1293744E-04,   7.6385133E-04
     +,   8.1990910E-04,   8.8163093E-04,   9.4955479E-04
     +,   1.0242481E-03,   1.1062868E-03,   1.1962706E-03
     +,   1.2947982E-03,   1.4024869E-03,   1.5199453E-03
     +,   1.6477959E-03,   1.7866674E-03,   1.9371879E-03
     +,   2.0999964E-03,   2.2757656E-03,   2.4652032E-03
     +,   2.6690473E-03,   2.8881314E-03,   3.1233535E-03
     +,   3.3757661E-03,   3.6465421E-03,   3.9370884E-03
     +,   4.2490130E-03,   4.5842542E-03,   4.9450435E-03
     +,   5.3340383E-03,   5.7543442E-03,   6.2095551E-03
     +,   6.7038625E-03,   7.2422349E-03,   7.8306161E-03
     +,   8.4762517E-03,   9.1884322E-03,   9.9792480E-03
     +,   1.0865144E-02,   1.1868653E-02,   1.3021295E-02
     +,   1.4366815E-02,   1.5965886E-02,   1.7900657E-02
     +,   2.0279819E-02,   2.3241473E-02,   2.6952060E-02
     +,   3.1599294E-02,   3.7377395E-02,   4.4464007E-02
     +,   5.2990537E-02,   6.3014105E-02,   7.4489556E-02
     +,   8.7256104E-02,   0.1010351    ,   0.1154635    
     +,   0.1301755    ,   0.1449740    ,   0.1600932    
     +,   0.1765188    ,   0.1961872    ,   0.2217724    
     +,   0.2557453    ,   0.2987385    ,   0.3480576    
     +,   0.3979833    ,   0.4429619    ,   0.4819311    
     +,   0.5193431    ,   0.5601791    ,   0.6030176    
     +,   0.6389278    ,   0.6584185    ,   0.6595832    
     +,   0.6498486    ,   0.6405744    ,   0.6390452    
     +,   0.6434492    ,   0.6452157    ,   0.6370192    
     +,   0.6178941    ,   0.5903790    ,   0.5556525    
     +,   0.5143582    ,   0.4708717    ,   0.4334002    
     +,   0.4085986    ,   0.3966825    ,   0.3918811    
     +,   0.3869510    ,   0.3772266    ,   0.3615370    
     +,   0.3407304    ,   0.3160177    ,   0.2884178    
     +,   0.2590685    ,   0.2295307    ,   0.2016123    
     +,   0.1768680    ,   0.1561673    ,   0.1395811    
     +,   0.1265872    ,   0.1164043    ,   0.1082791    
     +,   0.1016381    ,   9.6113540E-02,   9.1495559E-02
     +,   8.7666333E-02,   8.4547825E-02,   8.2071297E-02
     +,   8.0163158E-02,   7.8739516E-02,   7.7705584E-02
     +,   7.6957293E-02,   7.6384000E-02,   7.5872779E-02
     +,   7.5313896E-02,   7.4606977E-02,   7.3666632E-02
     +,   7.2427563E-02,   7.0847705E-02,   6.8909839E-02
     +,   6.6621028E-02,   6.4009801E-02,   6.1122295E-02
     +,   5.8017131E-02,   5.4760113E-02,   5.1418226E-02
     +,   4.8055556E-02,   4.4729888E-02,   4.1489892E-02
     +,   3.8374275E-02,   3.5411965E-02,   3.2622643E-02
     +,   3.0017748E-02,   2.7602134E-02,   2.5375674E-02
     +,   2.3334332E-02,   2.1471130E-02,   1.9777128E-02
     +,   1.8242124E-02,   1.6854944E-02,   1.5603678E-02
     +,   1.4476070E-02,   1.3459789E-02,   1.2542417E-02
     +,   1.1711828E-02,   1.0956394E-02,   1.0265158E-02
     +,   9.6279876E-03,   9.0357903E-03,   8.4806569E-03
     +,   7.9559144E-03,   7.4560917E-03,   6.9769532E-03
     +,   6.5154335E-03,   6.0695065E-03,   5.6380043E-03
     +,   5.2204989E-03,   4.8171682E-03,   4.4285627E-03
     +,   4.0554875E-03,   3.6988931E-03,   3.3597392E-03
     +,   3.0388748E-03,   2.7369990E-03,   2.4546315E-03
     +,   2.1920626E-03,   1.9493276E-03,   1.7262314E-03
     +,   1.5223763E-03,   1.3371669E-03,   1.1698296E-03
     +,   1.0194570E-03,   8.8505383E-04,   7.6553872E-04
     +,   6.5978826E-04,   5.6667189E-04,   4.8506400E-04
     +,   4.1385987E-04,   3.5199887E-04,   2.9847861E-04
     +,   2.5235891E-04,   2.1276524E-04,   1.7889561E-04
     +,   1.5002307E-04,   1.2549164E-04,   1.0471278E-04
     +,   8.7164211E-05,   7.2386603E-05,   5.9975675E-05
     +,   4.9579092E-05,   4.0891930E-05,   3.3650907E-05
     +,   2.7629245E-05,   2.2633016E-05,   1.8497185E-05
     +,   1.5081453E-05,   1.2266762E-05,   9.9526051E-06
     +,   8.0544987E-06,   6.5014019E-06,   5.2336777E-06
     +,   4.2014672E-06,   3.3632662E-06,   2.6844129E-06
     +,   2.1361316E-06,   1.6945964E-06,   1.3400924E-06
     +,   1.0563251E-06,   8.2989180E-07,   6.4980037E-07
     +,   5.0704858E-07,   3.9427641E-07,   3.0549629E-07
     +,   2.3585739E-07,   1.8142779E-07,   1.3904555E-07
     +,   1.0616561E-07,   8.0756294E-08,   6.1194442E-08
     +,   4.6193961E-08,   3.4735759E-08,   2.6018592E-08
     +,   1.9412788E-08,   1.4427445E-08,   1.0680126E-08
     +,   7.8747711E-09,   5.7833063E-09,   4.2303645E-09
     +,   3.0820937E-09,   2.2364974E-09,   1.6164057E-09
     +,   1.1635388E-09,   8.3418955E-10,   5.9565070E-10
     +,   4.2361309E-10,   3.0004521E-10,   2.1166653E-10
     +,   1.4871532E-10,   1.0406558E-10
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_asha_ttz75_mass = Yx/5.150896
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_asha_ttz80_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.7668471E-04,   3.7234978E-04
     +,   3.6792728E-04,   3.6345396E-04,   3.5896775E-04
     +,   3.5450747E-04,   3.5011291E-04,   3.4582458E-04
     +,   3.4168354E-04,   3.3773115E-04,   3.3400930E-04
     +,   3.3055982E-04,   3.2742470E-04,   3.2464563E-04
     +,   3.2226430E-04,   3.2032173E-04,   3.1885851E-04
     +,   3.1791462E-04,   3.1752916E-04,   3.1774046E-04
     +,   3.1858592E-04,   3.2010171E-04,   3.2232286E-04
     +,   3.2528338E-04,   3.2901563E-04,   3.3355114E-04
     +,   3.3891946E-04,   3.4514905E-04,   3.5226688E-04
     +,   3.6029835E-04,   3.6926745E-04,   3.7919663E-04
     +,   3.9010687E-04,   4.0201767E-04,   4.1494716E-04
     +,   4.2891179E-04,   4.4392695E-04,   4.6000606E-04
     +,   4.7716254E-04,   4.9540610E-04,   5.1474769E-04
     +,   5.3519523E-04,   5.5675622E-04,   5.7943619E-04
     +,   6.0323998E-04,   6.2817091E-04,   6.5423094E-04
     +,   6.8142108E-04,   7.0974045E-04,   7.3918735E-04
     +,   7.6975889E-04,   8.0145057E-04,   8.3425653E-04
     +,   8.6817163E-04,   9.0318650E-04,   9.3929423E-04
     +,   9.7648526E-04,   1.0147505E-03,   1.0540806E-03
     +,   1.0944668E-03,   1.1359008E-03,   1.1783772E-03
     +,   1.2218893E-03,   1.2664371E-03,   1.3120242E-03
     +,   1.3586535E-03,   1.4063403E-03,   1.4550991E-03
     +,   1.5049581E-03,   1.5559465E-03,   1.6081096E-03
     +,   1.6614936E-03,   1.7161625E-03,   1.7721819E-03
     +,   1.8296337E-03,   1.8886080E-03,   1.9492012E-03
     +,   2.0115161E-03,   2.0756666E-03,   2.1417714E-03
     +,   2.2099460E-03,   2.2803158E-03,   2.3529974E-03
     +,   2.4281128E-03,   2.5057718E-03,   2.5860923E-03
     +,   2.6691773E-03,   2.7551414E-03,   2.8440938E-03
     +,   2.9361628E-03,   3.0315025E-03,   3.1302969E-03
     +,   3.2327876E-03,   3.3393027E-03,   3.4502773E-03
     +,   3.5662791E-03,   3.6880709E-03,   3.8166186E-03
     +,   3.9531691E-03,   4.0992699E-03,   4.2568501E-03
     +,   4.4282367E-03,   4.6162643E-03,   4.8242994E-03
     +,   5.0563775E-03,   5.3173280E-03,   5.6129531E-03
     +,   5.9503242E-03,   6.3382117E-03,   6.7876312E-03
     +,   7.3125064E-03,   7.9306206E-03,   8.6644199E-03
     +,   9.5420638E-03,   1.0597930E-02,   1.1873213E-02
     +,   1.3415539E-02,   1.5278722E-02,   1.7521486E-02
     +,   2.0207003E-02,   2.3402493E-02,   2.7179917E-02
     +,   3.1618338E-02,   3.6807757E-02,   4.2851105E-02
     +,   4.9860787E-02,   5.7947956E-02,   6.7201108E-02
     +,   7.7679344E-02,   8.9450791E-02,   0.1027346    
     +,   0.1181415    ,   0.1369359    ,   0.1611161    
     +,   0.1931134    ,   0.2349658    ,   0.2871021    
     +,   0.3475546    ,   0.4130553    ,   0.4820896    
     +,   0.5563709    ,   0.6378682    ,   0.7262340    
     +,   0.8213539    ,   0.9240125    ,    1.030981    
     +,    1.133196    ,    1.215109    ,    1.252282    
     +,    1.231714    ,    1.177731    ,    1.122865    
     +,    1.069486    ,    1.009866    ,   0.9505107    
     +,   0.8979021    ,   0.8452069    ,   0.7836387    
     +,   0.7132483    ,   0.6406087    ,   0.5744817    
     +,   0.5205023    ,   0.4759320    ,   0.4326697    
     +,   0.3856730    ,   0.3365910    ,   0.2906791    
     +,   0.2522053    ,   0.2223255    ,   0.1996357    
     +,   0.1817741    ,   0.1666695    ,   0.1530216    
     +,   0.1402574    ,   0.1282952    ,   0.1172909    
     +,   0.1074397    ,   9.8857731E-02,   9.1540702E-02
     +,   8.5383244E-02,   8.0221839E-02,   7.5874805E-02
     +,   7.2165079E-02,   6.8930507E-02,   6.6026941E-02
     +,   6.3330598E-02,   6.0740482E-02,   5.8181275E-02
     +,   5.5604890E-02,   5.2990213E-02,   5.0339308E-02
     +,   4.7673099E-02,   4.5025595E-02,   4.2437781E-02
     +,   3.9951645E-02,   3.7605684E-02,   3.5431180E-02
     +,   3.3449735E-02,   3.1671982E-02,   3.0097773E-02
     +,   2.8717186E-02,   2.7511943E-02,   2.6457332E-02
     +,   2.5524372E-02,   2.4681995E-02,   2.3898736E-02
     +,   2.3144558E-02,   2.2392299E-02,   2.1618767E-02
     +,   2.0805508E-02,   1.9939404E-02,   1.9012937E-02
     +,   1.8024102E-02,   1.6975943E-02,   1.5876055E-02
     +,   1.4735841E-02,   1.3569524E-02,   1.2393028E-02
     +,   1.1223019E-02,   1.0076071E-02,   8.9675458E-03
     +,   7.9110246E-03,   6.9178483E-03,   5.9967195E-03
     +,   5.1535196E-03,   4.3914267E-03,   3.7111498E-03
     +,   3.1111755E-03,   2.5881063E-03,   2.1371299E-03
     +,   1.7524526E-03,   1.4276591E-03,   1.1560426E-03
     +,   9.3093090E-04,   7.4593106E-04,   5.9505570E-04
     +,   4.7286064E-04,   3.7450876E-04,   2.9577679E-04
     +,   2.3303817E-04,   1.8323347E-04,   1.4381968E-04
     +,   1.1270503E-04,   8.8186549E-05,   6.8892426E-05
     +,   5.3726817E-05,   4.1818173E-05,   3.2475789E-05
     +,   2.5154694E-05,   1.9426056E-05,   1.4951351E-05
     +,   1.1463832E-05,   8.7532471E-06,   6.6534144E-06
     +,   5.0327567E-06,   3.7871805E-06,   2.8343945E-06
     +,   2.1092990E-06,   1.5604651E-06,   1.1474269E-06
     +,   8.3847073E-07,   6.0882218E-07,   4.3921804E-07
     +,   3.1478396E-07,   2.2411126E-07,   1.5848970E-07
     +,   1.1132622E-07,   7.7667551E-08,   5.3816752E-08
     +,   3.7035150E-08,   2.5311257E-08,   1.7179651E-08
     +,   1.1580163E-08,   7.7518552E-09,   5.1531801E-09
     +,   3.4019989E-09,   2.2303199E-09,   1.4520567E-09
     +,   9.3879560E-10,   6.0275346E-10,   3.8430564E-10
     +,   2.4332883E-10,   1.5299503E-10,   9.5530091E-11
     +,   5.9233736E-11,   3.6473456E-11,   2.2302675E-11
     +,   1.3542582E-11,   8.1662836E-12,   4.8900441E-12
     +,   2.9078992E-12,   1.7171584E-12,   1.0069790E-12
     +,   5.8640115E-13,   3.3911613E-13,   1.9474462E-13
     +,   1.1106129E-13,   6.2896079E-14,   3.5372347E-14
     +,   1.9754594E-14,   1.0956047E-14
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_asha_ttz80_mass = Yx/6.65117909302326
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_asha_ttz85_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.2458244E-06,   2.6255193E-06
     +,   3.0632182E-06,   3.5666835E-06,   4.1445246E-06
     +,   4.8062830E-06,   5.5624760E-06,   6.4246806E-06
     +,   7.4055793E-06,   8.5190868E-06,   9.7803104E-06
     +,   1.1205692E-05,   1.2813018E-05,   1.4621497E-05
     +,   1.6651762E-05,   1.8925941E-05,   2.1467649E-05
     +,   2.4302015E-05,   2.7455657E-05,   3.0956689E-05
     +,   3.4834658E-05,   3.9120510E-05,   4.3846459E-05
     +,   4.9046255E-05,   5.4754200E-05,   6.1006231E-05
     +,   6.7838817E-05,   7.5289157E-05,   8.3395047E-05
     +,   9.2194634E-05,   1.0172617E-04,   1.1202794E-04
     +,   1.2313788E-04,   1.3509353E-04,   1.4793174E-04
     +,   1.6168857E-04,   1.7639894E-04,   1.9209644E-04
     +,   2.0881440E-04,   2.2658306E-04,   2.4543289E-04
     +,   2.6539233E-04,   2.8648844E-04,   3.0874743E-04
     +,   3.3219456E-04,   3.5685452E-04,   3.8275178E-04
     +,   4.0991139E-04,   4.3835919E-04,   4.6812260E-04
     +,   4.9923174E-04,   5.3172023E-04,   5.6562544E-04
     +,   6.0099328E-04,   6.3787273E-04,   6.7632552E-04
     +,   7.1642210E-04,   7.5824599E-04,   8.0189522E-04
     +,   8.4748573E-04,   8.9515245E-04,   9.4505370E-04
     +,   9.9737011E-04,   1.0523137E-03,   1.1101279E-03
     +,   1.1710837E-03,   1.2354950E-03,   1.3037043E-03
     +,   1.3761014E-03,   1.4531028E-03,   1.5351721E-03
     +,   1.6227934E-03,   1.7164896E-03,   1.8167911E-03
     +,   1.9242468E-03,   2.0394037E-03,   2.1627822E-03
     +,   2.2948673E-03,   2.4360945E-03,   2.5868244E-03
     +,   2.7473026E-03,   2.9176706E-03,   3.0979051E-03
     +,   3.2878399E-03,   3.4871032E-03,   3.6951564E-03
     +,   3.9112368E-03,   4.1344143E-03,   4.3635452E-03
     +,   4.5973435E-03,   4.8343930E-03,   5.0731665E-03
     +,   5.3120931E-03,   5.5496302E-03,   5.7843081E-03
     +,   6.0147760E-03,   6.2399139E-03,   6.4588394E-03
     +,   6.6710180E-03,   6.8762484E-03,   7.0747435E-03
     +,   7.2670886E-03,   7.4542868E-03,   7.6376726E-03
     +,   7.8189019E-03,   7.9998691E-03,   8.1825890E-03
     +,   8.3691394E-03,   8.5615311E-03,   8.7616118E-03
     +,   8.9709414E-03,   9.1907624E-03,   9.4218971E-03
     +,   9.6647684E-03,   9.9193761E-03,   1.0185421E-02
     +,   1.0462359E-02,   1.0749622E-02,   1.1046781E-02
     +,   1.1353842E-02,   1.1671539E-02,   1.2001657E-02
     +,   1.2347442E-02,   1.2714138E-02,   1.3109624E-02
     +,   1.3545329E-02,   1.4037752E-02,   1.4610474E-02
     +,   1.5297286E-02,   1.6145956E-02,   1.7223008E-02
     +,   1.8618032E-02,   2.0447124E-02,   2.2852447E-02
     +,   2.5997413E-02,   3.0054731E-02,   3.5187554E-02
     +,   4.1527417E-02,   4.9155284E-02,   5.8093298E-02
     +,   6.8313703E-02,   7.9766370E-02,   9.2418209E-02
     +,   0.1063036    ,   0.1216153    ,   0.1389392    
     +,   0.1597994    ,   0.1874807    ,   0.2271462    
     +,   0.2835095    ,   0.3565218    ,   0.4397167    
     +,   0.5247107    ,   0.6094827    ,   0.7065703    
     +,   0.8399982    ,    1.014879    ,    1.195195    
     +,    1.341139    ,    1.453109    ,    1.572110    
     +,    1.705454    ,    1.788755    ,    1.805931    
     +,    1.735166    ,    1.566862    ,    1.422456    
     +,    1.336026    ,    1.241659    ,    1.109431    
     +,   0.9467019    ,   0.7735615    ,   0.6079131    
     +,   0.4696411    ,   0.3747716    ,   0.3191219    
     +,   0.2841648    ,   0.2556995    ,   0.2299658    
     +,   0.2082157    ,   0.1915261    ,   0.1793870    
     +,   0.1701741    ,   0.1619668    ,   0.1532264    
     +,   0.1431743    ,   0.1318249    ,   0.1197468    
     +,   0.1077157    ,   9.6420437E-02,   8.6306989E-02
     +,   7.7563293E-02,   7.0183888E-02,   6.4051181E-02
     +,   5.8997605E-02,   5.4840244E-02,   5.1395476E-02
     +,   4.8484966E-02,   4.5942474E-02,   4.3622881E-02
     +,   4.1411322E-02,   3.9228696E-02,   3.7032336E-02
     +,   3.4811631E-02,   3.2579999E-02,   3.0364724E-02
     +,   2.8197756E-02,   2.6108557E-02,   2.4119245E-02
     +,   2.2242457E-02,   2.0481754E-02,   1.8833488E-02
     +,   1.7289169E-02,   1.5837980E-02,   1.4469091E-02
     +,   1.3173376E-02,   1.1944163E-02,   1.0777442E-02
     +,   9.6717170E-03,   8.6275591E-03,   7.6466920E-03
     +,   6.7314059E-03,   5.8839759E-03,   5.1061125E-03
     +,   4.3985723E-03,   3.7610426E-03,   3.1921268E-03
     +,   2.6893509E-03,   2.2492772E-03,   1.8677287E-03
     +,   1.5400166E-03,   1.2611169E-03,   1.0258539E-03
     +,   8.2909741E-04,   6.6591817E-04,   5.3165812E-04
     +,   4.2202952E-04,   3.3316636E-04,   2.6163383E-04
     +,   2.0442545E-04,   1.5895332E-04,   1.2302090E-04
     +,   9.4783107E-05,   7.2706040E-05,   5.5529712E-05
     +,   4.2229247E-05,   3.1976720E-05,   2.4108036E-05
     +,   1.8094868E-05,   1.3519822E-05,   1.0054029E-05
     +,   7.4401992E-06,   5.4780699E-06,   4.0122472E-06
     +,   2.9226185E-06,   2.1168403E-06,   1.5242380E-06
     +,   1.0909047E-06,   7.7590016E-07,   5.4831474E-07
     +,   3.8494076E-07,   2.6843503E-07,   1.8591025E-07
     +,   1.2785810E-07,   8.7312849E-08,   5.9197877E-08
     +,   3.9844632E-08,   2.6622150E-08,   1.7656454E-08
     +,   1.1623094E-08,   7.5939992E-09,   4.9242224E-09
     +,   3.1689464E-09,   2.0238702E-09,   1.2826928E-09
     +,   8.0675250E-10,   5.0351540E-10,   3.1185149E-10
     +,   1.9165744E-10,   1.1688439E-10,   7.0733003E-11
     +,   4.2474965E-11,   2.5308880E-11,   1.4964209E-11
     +,   8.7792820E-12,   5.1109733E-12,   2.9524148E-12
     +,   1.6922758E-12,   9.6249994E-13,   5.4318838E-13
     +,   3.0418289E-13,   1.6901956E-13,   9.3190958E-14
     +,   5.0983177E-14,   2.7676808E-14,   1.4908029E-14
     +,   7.9681668E-15,   4.2258491E-15,   2.2238352E-15
     +,   1.1612038E-15,   6.0165460E-16
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_asha_ttz85_mass = Yx/7.70916586363636
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_asha_ttz90_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.3704456E-04,   3.4845970E-04
     +,   3.5981811E-04,   3.7109872E-04,   3.8228167E-04
     +,   3.9334869E-04,   4.0428338E-04,   4.1507135E-04
     +,   4.2570059E-04,   4.3616229E-04,   4.4645014E-04
     +,   4.5656119E-04,   4.6649596E-04,   4.7625919E-04
     +,   4.8585897E-04,   4.9530831E-04,   5.0462404E-04
     +,   5.1382813E-04,   5.2294688E-04,   5.3201162E-04
     +,   5.4105878E-04,   5.5012957E-04,   5.5927003E-04
     +,   5.6853215E-04,   5.7797140E-04,   5.8764918E-04
     +,   5.9763103E-04,   6.0798734E-04,   6.1879214E-04
     +,   6.3012383E-04,   6.4206420E-04,   6.5469823E-04
     +,   6.6811359E-04,   6.8240019E-04,   6.9764943E-04
     +,   7.1395410E-04,   7.3140697E-04,   7.5010088E-04
     +,   7.7012816E-04,   7.9157780E-04,   8.1453822E-04
     +,   8.3909329E-04,   8.6532295E-04,   8.9330232E-04
     +,   9.2310057E-04,   9.5478049E-04,   9.8839682E-04
     +,   1.0239970E-03,   1.0616183E-03,   1.1012902E-03
     +,   1.1430299E-03,   1.1868452E-03,   1.2327310E-03
     +,   1.2806747E-03,   1.3306452E-03,   1.3826056E-03
     +,   1.4365031E-03,   1.4922745E-03,   1.5498430E-03
     +,   1.6091223E-03,   1.6700131E-03,   1.7324078E-03
     +,   1.7961839E-03,   1.8612146E-03,   1.9273654E-03
     +,   1.9944888E-03,   2.0624378E-03,   2.1310535E-03
     +,   2.2001816E-03,   2.2696562E-03,   2.3393207E-03
     +,   2.4090095E-03,   2.4785683E-03,   2.5478387E-03
     +,   2.6166744E-03,   2.6849364E-03,   2.7524913E-03
     +,   2.8192170E-03,   2.8850085E-03,   2.9497761E-03
     +,   3.0134397E-03,   3.0759454E-03,   3.1372525E-03
     +,   3.1973487E-03,   3.2562357E-03,   3.3139472E-03
     +,   3.3705323E-03,   3.4260741E-03,   3.4806714E-03
     +,   3.5344528E-03,   3.5875710E-03,   3.6401970E-03
     +,   3.6925222E-03,   3.7447608E-03,   3.7971416E-03
     +,   3.8499015E-03,   3.9032931E-03,   3.9575696E-03
     +,   4.0129917E-03,   4.0698135E-03,   4.1282899E-03
     +,   4.1886629E-03,   4.2511718E-03,   4.3160385E-03
     +,   4.3834811E-03,   4.4537093E-03,   4.5269276E-03
     +,   4.6033375E-03,   4.6831626E-03,   4.7666477E-03
     +,   4.8540677E-03,   4.9457648E-03,   5.0421474E-03
     +,   5.1437370E-03,   5.2511701E-03,   5.3652613E-03
     +,   5.4869978E-03,   5.6176218E-03,   5.7586408E-03
     +,   5.9119062E-03,   6.0796775E-03,   6.2646954E-03
     +,   6.4702975E-03,   6.7005567E-03,   6.9604544E-03
     +,   7.2560152E-03,   7.5945752E-03,   7.9848748E-03
     +,   8.4372871E-03,   8.9637106E-03,   9.5775528E-03
     +,   1.0293186E-02,   1.1125394E-02,   1.2088175E-02
     +,   1.3193546E-02,   1.4449965E-02,   1.5860636E-02
     +,   1.7422304E-02,   1.9124733E-02,   2.0951124E-02
     +,   2.2879897E-02,   2.4888482E-02,   2.6958823E-02
     +,   2.9083928E-02,   3.1274896E-02,   3.3568006E-02
     +,   3.6029682E-02,   3.8758889E-02,   4.1886777E-02
     +,   4.5572825E-02,   4.9997784E-02,   5.5354748E-02
     +,   6.1845120E-02,   6.9689728E-02,   7.9168096E-02
     +,   9.0689197E-02,   0.1048684    ,   0.1225365    
     +,   0.1445906    ,   0.1716912    ,   0.2040522    
     +,   0.2418229    ,   0.2863983    ,   0.3416634    
     +,   0.4129119    ,   0.5039085    ,   0.6161556    
     +,   0.7506866    ,   0.9103017    ,    1.094254    
     +,    1.279280    ,    1.437899    ,    1.580605    
     +,    1.709251    ,    1.760262    ,    1.680181    
     +,    1.549067    ,    1.474688    ,    1.407689    
     +,    1.267326    ,    1.091464    ,   0.9356201    
     +,   0.7909109    ,   0.6468896    ,   0.5284351    
     +,   0.4564465    ,   0.4233747    ,   0.4074386    
     +,   0.3904401    ,   0.3639964    ,   0.3285733    
     +,   0.2892869    ,   0.2512835    ,   0.2174237    
     +,   0.1885415    ,   0.1645410    ,   0.1450067    
     +,   0.1292957    ,   0.1165790    ,   0.1060156    
     +,   9.6934289E-02,   8.8892758E-02,   8.1623137E-02
     +,   7.4949242E-02,   6.8735056E-02,   6.2870607E-02
     +,   5.7278115E-02,   5.1915940E-02,   4.6774704E-02
     +,   4.1867770E-02,   3.7221458E-02,   3.2866620E-02
     +,   2.8831245E-02,   2.5135476E-02,   2.1789096E-02
     +,   1.8790802E-02,   1.6128941E-02,   1.3783520E-02
     +,   1.1729280E-02,   9.9386862E-03,   8.3838375E-03
     +,   7.0383116E-03,   5.8780806E-03,   4.8816553E-03
     +,   4.0299054E-03,   3.3058024E-03,   2.6940859E-03
     +,   2.1808846E-03,   1.7534803E-03,   1.4002371E-03
     +,   1.1105653E-03,   8.7487849E-04,   6.8458595E-04
     +,   5.3210364E-04,   4.1083575E-04,   3.1509349E-04
     +,   2.4004643E-04,   1.8164315E-04,   1.3651686E-04
     +,   1.0189619E-04,   7.5524746E-05,   5.5582892E-05
     +,   4.0613693E-05,   2.9460014E-05,   2.1211508E-05
     +,   1.5158168E-05,   1.0750236E-05,   7.5654716E-06
     +,   5.2826385E-06,   3.6595543E-06,   2.5148922E-06
     +,   1.7142503E-06,   1.1589194E-06,   7.7699445E-07
     +,   5.1655582E-07,   3.4048736E-07,   2.2249975E-07
     +,   1.4413372E-07,   9.2546344E-08,   5.8892670E-08
     +,   3.7139625E-08,   2.3208878E-08,   1.4370336E-08
     +,   8.8152170E-09,   5.3571294E-09,   3.2249674E-09
     +,   1.9229840E-09,   1.1356974E-09,   6.6430816E-10
     +,   3.8482673E-10,   2.2076074E-10,   1.2540893E-10
     +,   7.0546451E-11,   3.9295303E-11,   2.1672180E-11
     +,   1.1834920E-11,   6.3988641E-12,   3.4255016E-12
     +,   1.8155307E-12,   9.5269420E-13,   4.9493737E-13
     +,   2.5457194E-13,   1.2963248E-13,   6.5354995E-14
     +,   3.2620414E-14,   1.6120241E-14,   7.8873184E-15
     +,   3.8209275E-15,   1.8329211E-15,   8.7072239E-16
     +,   4.0970494E-16,   1.9099266E-16,   8.8250417E-17
     +,   4.0442124E-17,   1.8400821E-17,   8.3251518E-18
     +,   3.7548660E-18,   1.6945225E-18,   7.6945442E-19
     +,   3.5429327E-19,   1.6710994E-19
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_asha_ttz90_mass = Yx/7.27494075
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_asha_ttz95_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  7.2940416E-04,   7.4645958E-04
     +,   7.6281122E-04,   7.7840016E-04,   7.9316972E-04
     +,   8.0706651E-04,   8.2004053E-04,   8.3204621E-04
     +,   8.4304187E-04,   8.5299119E-04,   8.6186244E-04
     +,   8.6962985E-04,   8.7627280E-04,   8.8177726E-04
     +,   8.8613515E-04,   8.8934490E-04,   8.9141156E-04
     +,   8.9234678E-04,   8.9216902E-04,   8.9090335E-04
     +,   8.8858174E-04,   8.8524283E-04,   8.8093209E-04
     +,   8.7570038E-04,   8.6960604E-04,   8.6271262E-04
     +,   8.5508957E-04,   8.4681174E-04,   8.3795900E-04
     +,   8.2861603E-04,   8.1887154E-04,   8.0881856E-04
     +,   7.9855300E-04,   7.8817422E-04,   7.7778409E-04
     +,   7.6748623E-04,   7.5738638E-04,   7.4759102E-04
     +,   7.3820725E-04,   7.2934316E-04,   7.2110590E-04
     +,   7.1360241E-04,   7.0693874E-04,   7.0121972E-04
     +,   6.9654844E-04,   6.9302623E-04,   6.9075241E-04
     +,   6.8982400E-04,   6.9033558E-04,   6.9237920E-04
     +,   6.9604418E-04,   7.0141751E-04,   7.0858322E-04
     +,   7.1762328E-04,   7.2861608E-04,   7.4163877E-04
     +,   7.5676560E-04,   7.7406835E-04,   7.9361675E-04
     +,   8.1547891E-04,   8.3971967E-04,   8.6640310E-04
     +,   8.9558901E-04,   9.2733657E-04,   9.6170255E-04
     +,   9.9873799E-04,   1.0384937E-03,   1.0810114E-03
     +,   1.1263337E-03,   1.1744909E-03,   1.2255121E-03
     +,   1.2794113E-03,   1.3361995E-03,   1.3958697E-03
     +,   1.4584063E-03,   1.5237804E-03,   1.5919415E-03
     +,   1.6628208E-03,   1.7363343E-03,   1.8123762E-03
     +,   1.8908107E-03,   1.9714867E-03,   2.0542180E-03
     +,   2.1388019E-03,   2.2249992E-03,   2.3125540E-03
     +,   2.4011740E-03,   2.4905524E-03,   2.5803486E-03
     +,   2.6702089E-03,   2.7597612E-03,   2.8486131E-03
     +,   2.9363609E-03,   3.0226023E-03,   3.1069322E-03
     +,   3.1889433E-03,   3.2682493E-03,   3.3444732E-03
     +,   3.4172693E-03,   3.4863150E-03,   3.5513353E-03
     +,   3.6120908E-03,   3.6684000E-03,   3.7201308E-03
     +,   3.7672208E-03,   3.8096700E-03,   3.8475480E-03
     +,   3.8809986E-03,   3.9102389E-03,   3.9355615E-03
     +,   3.9573302E-03,   3.9759791E-03,   3.9920099E-03
     +,   4.0059839E-03,   4.0185163E-03,   4.0302696E-03
     +,   4.0419376E-03,   4.0542479E-03,   4.0679392E-03
     +,   4.0837559E-03,   4.1024392E-03,   4.1247131E-03
     +,   4.1512758E-03,   4.1827983E-03,   4.2199157E-03
     +,   4.2632255E-03,   4.3132957E-03,   4.3706652E-03
     +,   4.4358675E-03,   4.5094336E-03,   4.5919348E-03
     +,   4.6839896E-03,   4.7863182E-03,   4.8997542E-03
     +,   5.0252974E-03,   5.1641334E-03,   5.3176489E-03
     +,   5.4874453E-03,   5.6753517E-03,   5.8834073E-03
     +,   6.1138291E-03,   6.3690096E-03,   6.6515645E-03
     +,   6.9643888E-03,   7.3107914E-03,   7.6948465E-03
     +,   8.1218202E-03,   8.5987598E-03,   9.1353105E-03
     +,   9.7446414E-03,   1.0444337E-02,   1.1257089E-02
     +,   1.2211068E-02,   1.3339738E-02,   1.4680706E-02
     +,   1.6273709E-02,   1.8158335E-02,   2.0372707E-02
     +,   2.2955103E-02,   2.5952021E-02,   2.9437516E-02
     +,   3.3544090E-02,   3.8501460E-02,   4.4670694E-02
     +,   5.2553333E-02,   6.2758133E-02,   7.5922765E-02
     +,   9.2597574E-02,   0.1130762    ,   0.1371345    
     +,   0.1637330    ,   0.1910395    ,   0.2174695    
     +,   0.2441666    ,   0.2776704    ,   0.3292555    
     +,   0.4081450    ,   0.5117350    ,   0.6237713    
     +,   0.7326984    ,   0.8593268    ,    1.047899    
     +,    1.306594    ,    1.585045    ,    1.843595    
     +,    2.049292    ,    2.128050    ,    2.059586    
     +,    1.889743    ,    1.656788    ,    1.373474    
     +,    1.097544    ,   0.8904446    ,   0.7433323    
     +,   0.6230595    ,   0.5225350    ,   0.4460856    
     +,   0.3870871    ,   0.3373097    ,   0.2960867    
     +,   0.2651008    ,   0.2431207    ,   0.2264477    
     +,   0.2112495    ,   0.1949971    ,   0.1767785    
     +,   0.1569576    ,   0.1365821    ,   0.1168224    
     +,   9.8601088E-02,   8.2445592E-02,   6.8511583E-02
     +,   5.6691274E-02,   4.6739481E-02,   3.8375959E-02
     +,   3.1345848E-02,   2.5441740E-02,   2.0501103E-02
     +,   1.6393507E-02,   1.3007523E-02,   1.0241724E-02
     +,   8.0024078E-03,   6.2042139E-03,   4.7712470E-03
     +,   3.6377998E-03,   2.7482610E-03,   2.0561591E-03
     +,   1.5228010E-03,   1.1160236E-03,   8.0920488E-04
     +,   5.8044837E-04,   4.1188829E-04,   2.8912953E-04
     +,   2.0075854E-04,   1.3787458E-04,   9.3633789E-05
     +,   6.2862659E-05,   4.1707888E-05,   2.7336351E-05
     +,   1.7691582E-05,   1.1300557E-05,   7.1213449E-06
     +,   4.4257758E-06,   2.7115789E-06,   1.6372793E-06
     +,   9.7406939E-07,   5.7088488E-07,   3.2956055E-07
     +,   1.8737668E-07,   1.0493324E-07,   5.7885948E-08
     +,   3.1463404E-08,   1.6858911E-08,   8.9127843E-09
     +,   4.6551603E-09,   2.4072995E-09,   1.2368333E-09
     +,   6.3476713E-10,   3.2801473E-10,   1.7256536E-10
     +,   9.3709832E-11,   5.3279554E-11,   3.2049668E-11
     +,   2.0453238E-11,   1.3767236E-11,   9.6630134E-12
     +,   6.9837014E-12,   5.1417746E-12,   3.8264756E-12
     +,   2.8634454E-12,   2.1477477E-12,   1.6115974E-12
     +,   1.2084777E-12,   9.0501483E-13,   6.7664277E-13
     +,   5.0498418E-13,   3.7614890E-13,   2.7963601E-13
     +,   2.0747118E-13,   1.5362246E-13,   1.1352087E-13
     +,   8.3719293E-14,   6.1616097E-14,   4.5257699E-14
     +,   3.3174831E-14,   2.4269107E-14,   1.7718293E-14
     +,   1.2909459E-14,   9.3868954E-15,   6.8116814E-15
     +,   4.9330271E-15,   3.5652540E-15,   2.5715539E-15
     +,   1.8510505E-15,   1.3297442E-15,   9.5331367E-16
     +,   6.8207190E-16,   4.8701594E-16,   3.4704165E-16
     +,   2.4679599E-16,   1.7515461E-16
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_asha_ttz95_mass = Yx/7.08120954545454
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_asha_hatt100_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.5552082E-05,   4.8355876E-05
     +,   5.1284078E-05,   5.4338609E-05,   5.7521178E-05
     +,   6.0833230E-05,   6.4275941E-05,   6.7850255E-05
     +,   7.1556722E-05,   7.5395787E-05,   7.9367419E-05
     +,   8.3471372E-05,   8.7707027E-05,   9.2073489E-05
     +,   9.6569580E-05,   1.0119386E-04,   1.0594453E-04
     +,   1.1081965E-04,   1.1581703E-04,   1.2093432E-04
     +,   1.2616903E-04,   1.3151868E-04,   1.3698064E-04
     +,   1.4255282E-04,   1.4823259E-04,   1.5401843E-04
     +,   1.5990877E-04,   1.6590285E-04,   1.7200057E-04
     +,   1.7820296E-04,   1.8451210E-04,   1.9093174E-04
     +,   1.9746702E-04,   2.0412551E-04,   2.1091694E-04
     +,   2.1785380E-04,   2.2495199E-04,   2.3223065E-04
     +,   2.3971377E-04,   2.4742904E-04,   2.5541030E-04
     +,   2.6369677E-04,   2.7233429E-04,   2.8137583E-04
     +,   2.9088242E-04,   3.0092348E-04,   3.1157801E-04
     +,   3.2293511E-04,   3.3509472E-04,   3.4816840E-04
     +,   3.6228023E-04,   3.7756731E-04,   3.9418010E-04
     +,   4.1228466E-04,   4.3205978E-04,   4.5370174E-04
     +,   4.7742118E-04,   5.0344510E-04,   5.3201633E-04
     +,   5.6339393E-04,   5.9785275E-04,   6.3568441E-04
     +,   6.7719264E-04,   7.2269957E-04,   7.7254203E-04
     +,   8.2706509E-04,   8.8663294E-04,   9.5161435E-04
     +,   1.0223952E-03,   1.0993620E-03,   1.1829174E-03
     +,   1.2734584E-03,   1.3713964E-03,   1.4771303E-03
     +,   1.5910661E-03,   1.7136042E-03,   1.8451273E-03
     +,   1.9860035E-03,   2.1365902E-03,   2.2972208E-03
     +,   2.4681848E-03,   2.6497557E-03,   2.8421436E-03
     +,   3.0455329E-03,   3.2600295E-03,   3.4857064E-03
     +,   3.7225476E-03,   3.9704982E-03,   4.2294078E-03
     +,   4.4990829E-03,   4.7792681E-03,   5.0696419E-03
     +,   5.3698323E-03,   5.6794551E-03,   5.9981127E-03
     +,   6.3253776E-03,   6.6608866E-03,   7.0042755E-03
     +,   7.3552867E-03,   7.7136932E-03,   8.0794124E-03
     +,   8.4524099E-03,   8.8328067E-03,   9.2207696E-03
     +,   9.6165836E-03,   1.0020587E-02,   1.0433114E-02
     +,   1.0854472E-02,   1.1284922E-02,   1.1724597E-02
     +,   1.2173397E-02,   1.2631056E-02,   1.3096975E-02
     +,   1.3570305E-02,   1.4049837E-02,   1.4534138E-02
     +,   1.5021476E-02,   1.5510028E-02,   1.5997861E-02
     +,   1.6483212E-02,   1.6964626E-02,   1.7441142E-02
     +,   1.7912593E-02,   1.8379945E-02,   1.8845573E-02
     +,   1.9313661E-02,   1.9790731E-02,   2.0286079E-02
     +,   2.0812539E-02,   2.1387072E-02,   2.2031695E-02
     +,   2.2774020E-02,   2.3648083E-02,   2.4694309E-02
     +,   2.5959160E-02,   2.7493613E-02,   2.9350163E-02
     +,   3.1578407E-02,   3.4219261E-02,   3.7297565E-02
     +,   4.0814210E-02,   4.4738978E-02,   4.9005795E-02
     +,   5.3511016E-02,   5.8116209E-02,   6.2657908E-02
     +,   6.6961557E-02,   7.0859663E-02,   7.4212462E-02
     +,   7.6927431E-02,   7.8973673E-02,   8.0389075E-02
     +,   8.1278458E-02,   8.1801794E-02,   8.2153514E-02
     +,   8.2536787E-02,   8.3136082E-02,   8.4093690E-02
     +,   8.5493475E-02,   8.7355748E-02,   8.9643843E-02
     +,   9.2281692E-02,   9.5178194E-02,   9.8254137E-02
     +,   0.1014660    ,   0.1048210    ,   0.1083805    
     +,   0.1122507    ,   0.1165634    ,   0.1214466    
     +,   0.1269970    ,   0.1332513    ,   0.1401718    
     +,   0.1476392    ,   0.1554622    ,   0.1633982    
     +,   0.1711834    ,   0.1785612    ,   0.1853097    
     +,   0.1912590    ,   0.1962965    ,   0.2003638    
     +,   0.2034486    ,   0.2055755    ,   0.2068049    
     +,   0.2072441    ,   0.2070739    ,   0.2065904    
     +,   0.2062506    ,   0.2067145    ,   0.2088731    
     +,   0.2138557    ,   0.2229894    ,   0.2376591    
     +,   0.2590501    ,   0.2879439    ,   0.3250512    
     +,   0.3724171    ,   0.4353139    ,   0.5223407    
     +,   0.6442953    ,   0.8177748    ,    1.071454    
     +,    1.447201    ,    2.007526    ,    2.953329    
     +,    4.779529    ,    7.464594    ,    10.29478    
     +,    12.56201    ,    11.81796    ,    8.193260    
     +,    4.826072    ,    2.479291    ,    1.182439    
     +,   0.5628107    ,   0.2473251    ,   9.8511912E-02
     +,   3.9413054E-02,   1.8705243E-02,   1.1419968E-02
     +,   8.5005155E-03,   6.9520730E-03,   5.8372431E-03
     +,   4.9134344E-03,   4.1243029E-03,   3.4493287E-03
     +,   2.8767185E-03,   2.3988497E-03,   2.0086905E-03
     +,   1.6974413E-03,   1.4542530E-03,   1.2672656E-03
     +,   1.1248963E-03,   1.0167473E-03,   9.3402853E-04
     +,   8.6966774E-04,   8.1819639E-04,   7.7552575E-04
     +,   7.3869905E-04,   7.0565270E-04,   6.7500304E-04
     +,   6.4586237E-04,   6.1769172E-04,   5.9019111E-04
     +,   5.6321890E-04,   5.3673057E-04,   5.1073730E-04
     +,   4.8528032E-04,   4.6041698E-04,   4.3620475E-04
     +,   4.1269790E-04,   3.8994549E-04,   3.6798842E-04
     +,   3.4685706E-04,   3.2657283E-04,   3.0715056E-04
     +,   2.8859678E-04,   2.7090995E-04,   2.5408226E-04
     +,   2.3810167E-04,   2.2295132E-04,   2.0860948E-04
     +,   1.9505134E-04,   1.8225099E-04,   1.7017932E-04
     +,   1.5880600E-04,   1.4810075E-04,   1.3803277E-04
     +,   1.2857074E-04,   1.1968371E-04,   1.1134192E-04
     +,   1.0351642E-04,   9.6178679E-05,   8.9301364E-05
     +,   8.2858947E-05,   7.6826269E-05,   7.1180228E-05
     +,   6.5898210E-05,   6.0959490E-05,   5.6343870E-05
     +,   5.2032912E-05,   4.8008664E-05,   4.4254699E-05
     +,   4.0755072E-05,   3.7495174E-05,   3.4460889E-05
     +,   3.1638883E-05,   2.9016830E-05,   2.6582708E-05
     +,   2.4325422E-05,   2.2234170E-05,   2.0298963E-05
     +,   1.8510056E-05,   1.6858421E-05,   1.5335258E-05
     +,   1.3932398E-05,   1.2641896E-05,   1.1456366E-05
     +,   1.0368639E-05,   9.3720519E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_asha_hatt100_mass = Yx/19.51153806
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_asha_hatt105_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  7.7881350E-04,   8.2258444E-04
     +,   8.6836575E-04,   9.1618055E-04,   9.6604589E-04
     +,   1.0179724E-03,   1.0719643E-03,   1.1280173E-03
     +,   1.1861203E-03,   1.2462557E-03,   1.3083960E-03
     +,   1.3725060E-03,   1.4385427E-03,   1.5064537E-03
     +,   1.5761805E-03,   1.6476536E-03,   1.7207984E-03
     +,   1.7955313E-03,   1.8717616E-03,   1.9493934E-03
     +,   2.0283237E-03,   2.1084454E-03,   2.1896462E-03
     +,   2.2718154E-03,   2.3548319E-03,   2.4385850E-03
     +,   2.5229575E-03,   2.6078396E-03,   2.6931253E-03
     +,   2.7787150E-03,   2.8645191E-03,   2.9504602E-03
     +,   3.0364750E-03,   3.1225164E-03,   3.2085581E-03
     +,   3.2945969E-03,   3.3806544E-03,   3.4667812E-03
     +,   3.5530631E-03,   3.6396142E-03,   3.7265962E-03
     +,   3.8142100E-03,   3.9026989E-03,   3.9923564E-03
     +,   4.0835291E-03,   4.1766162E-03,   4.2720744E-03
     +,   4.3704212E-03,   4.4722310E-03,   4.5781480E-03
     +,   4.6888725E-03,   4.8051761E-03,   4.9278890E-03
     +,   5.0579184E-03,   5.1962179E-03,   5.3438134E-03
     +,   5.5017979E-03,   5.6713102E-03,   5.8535463E-03
     +,   6.0497606E-03,   6.2612495E-03,   6.4893612E-03
     +,   6.7354683E-03,   7.0009949E-03,   7.2874073E-03
     +,   7.5961626E-03,   7.9287942E-03,   8.2868012E-03
     +,   8.6717578E-03,   9.0851998E-03,   9.5287217E-03
     +,   1.0003872E-02,   1.0512261E-02,   1.1055420E-02
     +,   1.1634927E-02,   1.2252323E-02,   1.2909084E-02
     +,   1.3606625E-02,   1.4346331E-02,   1.5129524E-02
     +,   1.5957337E-02,   1.6830916E-02,   1.7751170E-02
     +,   1.8719012E-02,   1.9735122E-02,   2.0800211E-02
     +,   2.1914769E-02,   2.3079379E-02,   2.4294443E-02
     +,   2.5560470E-02,   2.6878051E-02,   2.8247666E-02
     +,   2.9669888E-02,   3.1145437E-02,   3.2675091E-02
     +,   3.4259599E-02,   3.5900023E-02,   3.7597422E-02
     +,   3.9353479E-02,   4.1170206E-02,   4.3050706E-02
     +,   4.4999111E-02,   4.7021322E-02,   4.9124997E-02
     +,   5.1319964E-02,   5.3618275E-02,   5.6033522E-02
     +,   5.8580287E-02,   6.1273005E-02,   6.4124197E-02
     +,   6.7142107E-02,   7.0328943E-02,   7.3677957E-02
     +,   7.7172466E-02,   8.0783866E-02,   8.4472656E-02
     +,   8.8189229E-02,   9.1877490E-02,   9.5479116E-02
     +,   9.8939948E-02,   0.1022164    ,   0.1052829    
     +,   0.1081379    ,   0.1108089    ,   0.1133557    
     +,   0.1158685    ,   0.1184645    ,   0.1212792    
     +,   0.1244550    ,   0.1281264    ,   0.1324069    
     +,   0.1373740    ,   0.1430633    ,   0.1494637    
     +,   0.1565245    ,   0.1641657    ,   0.1722932    
     +,   0.1808146    ,   0.1896505    ,   0.1987400    
     +,   0.2080363    ,   0.2175011    ,   0.2270985    
     +,   0.2367941    ,   0.2465611    ,   0.2563952    
     +,   0.2663217    ,   0.2763855    ,   0.2866232    
     +,   0.2970154    ,   0.3074506    ,   0.3177346    
     +,   0.3276760    ,   0.3372429    ,   0.3467370    
     +,   0.3568895    ,   0.3687838    ,   0.3835618    
     +,   0.4019884    ,   0.4240606    ,   0.4488966    
     +,   0.4750073    ,   0.5008347    ,   0.5252327    
     +,   0.5475643    ,   0.5673741    ,   0.5839720    
     +,   0.5963948    ,   0.6039333    ,   0.6068763    
     +,   0.6068665    ,   0.6064524    ,   0.6080156    
     +,   0.6127316    ,   0.6202223    ,   0.6291113    
     +,   0.6381336    ,   0.6470777    ,   0.6569081    
     +,   0.6689793    ,   0.6839166    ,   0.7010087    
     +,   0.7185132    ,   0.7345021    ,   0.7476302    
     +,   0.7574912    ,   0.7645971    ,   0.7700175    
     +,   0.7747042    ,   0.7788187    ,   0.7815636    
     +,   0.7816596    ,   0.7780852    ,   0.7706724    
     +,   0.7604465    ,   0.7495660    ,   0.7405760    
     +,   0.7350645    ,   0.7327015    ,   0.7315739    
     +,   0.7295409    ,   0.7252739    ,   0.7180595    
     +,   0.7067965    ,   0.6894138    ,   0.6633947    
     +,   0.6270305    ,   0.5804270    ,   0.5256366    
     +,   0.4659679    ,   0.4049884    ,   0.3457361    
     +,   0.2903401    ,   0.2400254    ,   0.1953280    
     +,   0.1563491    ,   0.1229466    ,   9.4841078E-02
     +,   7.1664169E-02,   5.2974060E-02,   3.8262103E-02
     +,   2.6976131E-02,   1.8549236E-02,   1.2430511E-02
     +,   8.1128441E-03,   5.1535051E-03,   3.1843928E-03
     +,   1.9129246E-03,   1.1164936E-03,   6.3276239E-04
     +,   3.4802750E-04,   1.8567759E-04,   9.6047843E-05
     +,   4.8160382E-05,   2.3412751E-05,   1.1045295E-05
     +,   5.0699859E-06,   2.2789741E-06,   1.0179019E-06
     +,   4.6573339E-07,   2.3041922E-07,   1.3177541E-07
     +,   9.0081578E-08,   7.1384079E-08,   6.1757135E-08
     +,   5.5694603E-08,   5.1092560E-08,   4.7169539E-08
     +,   4.3639051E-08,   4.0393370E-08,   3.7386922E-08
     +,   3.4595296E-08,   3.2001999E-08,   2.9593135E-08
     +,   2.7356162E-08,   2.5279471E-08,   2.3352287E-08
     +,   2.1564631E-08,   1.9906885E-08,   1.8370134E-08
     +,   1.6946121E-08,   1.5627119E-08,   1.4405757E-08
     +,   1.3275208E-08,   1.2229163E-08,   1.1261625E-08
     +,   1.0366999E-08,   9.5401305E-09,   8.7761753E-09
     +,   8.0705878E-09,   7.4191382E-09,   6.8178938E-09
     +,   6.2632113E-09,   5.7516552E-09,   5.2800275E-09
     +,   4.8454036E-09,   4.4449968E-09,   4.0762660E-09
     +,   3.7368189E-09,   3.4244534E-09,   3.1370977E-09
     +,   2.8728628E-09,   2.6299638E-09,   2.4067706E-09
     +,   2.2017459E-09,   2.0134918E-09,   1.8406928E-09
     +,   1.6821345E-09,   1.5367028E-09,   1.4033530E-09
     +,   1.2811315E-09,   1.1691462E-09,   1.0665806E-09
     +,   9.7267139E-10,   8.8672508E-10,   8.0808876E-10
     +,   7.3617251E-10,   6.7042061E-10,   6.1033179E-10
     +,   5.5543314E-10,   5.0529808E-10
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_asha_hatt105_mass = Yx/10.8309394565217
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_asha_hatt107_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.9220474E-04,   5.1416468E-04
     +,   5.3719553E-04,   5.6133169E-04,   5.8660726E-04
     +,   6.1305548E-04,   6.4070959E-04,   6.6960126E-04
     +,   6.9976191E-04,   7.3122268E-04,   7.6401408E-04
     +,   7.9816504E-04,   8.3370536E-04,   8.7066385E-04
     +,   9.0906961E-04,   9.4895222E-04,   9.9034188E-04
     +,   1.0332698E-03,   1.0777694E-03,   1.1238765E-03
     +,   1.1716295E-03,   1.2210724E-03,   1.2722521E-03
     +,   1.3252266E-03,   1.3800547E-03,   1.4368125E-03
     +,   1.4955828E-03,   1.5564621E-03,   1.6195627E-03
     +,   1.6850164E-03,   1.7529725E-03,   1.8236070E-03
     +,   1.8971195E-03,   1.9737412E-03,   2.0537348E-03
     +,   2.1374002E-03,   2.2250765E-03,   2.3171457E-03
     +,   2.4140400E-03,   2.5162362E-03,   2.6242693E-03
     +,   2.7387268E-03,   2.8602555E-03,   2.9895601E-03
     +,   3.1274059E-03,   3.2746184E-03,   3.4320806E-03
     +,   3.6007329E-03,   3.7815645E-03,   3.9756144E-03
     +,   4.1839560E-03,   4.4076983E-03,   4.6479595E-03
     +,   4.9058856E-03,   5.1825847E-03,   5.4791654E-03
     +,   5.7966891E-03,   6.1361496E-03,   6.4984714E-03
     +,   6.8844673E-03,   7.2948406E-03,   7.7301557E-03
     +,   8.1907986E-03,   8.6770076E-03,   9.1888430E-03
     +,   9.7261127E-03,   1.0288497E-02,   1.0875395E-02
     +,   1.1486091E-02,   1.2119603E-02,   1.2774853E-02
     +,   1.3450557E-02,   1.4145393E-02,   1.4857876E-02
     +,   1.5586577E-02,   1.6330084E-02,   1.7087009E-02
     +,   1.7856099E-02,   1.8636327E-02,   1.9426914E-02
     +,   2.0227296E-02,   2.1037316E-02,   2.1857094E-02
     +,   2.2687197E-02,   2.3528485E-02,   2.4382263E-02
     +,   2.5249999E-02,   2.6133589E-02,   2.7034923E-02
     +,   2.7956061E-02,   2.8899077E-02,   2.9865772E-02
     +,   3.0857718E-02,   3.1876221E-02,   3.2922186E-02
     +,   3.3996072E-02,   3.5098072E-02,   3.6228094E-02
     +,   3.7386142E-02,   3.8572341E-02,   3.9787535E-02
     +,   4.1033331E-02,   4.2312674E-02,   4.3629870E-02
     +,   4.4990882E-02,   4.6403244E-02,   4.7875732E-02
     +,   4.9417995E-02,   5.1039927E-02,   5.2750766E-02
     +,   5.4558188E-02,   5.6467652E-02,   5.8481399E-02
     +,   6.0598478E-02,   6.2814124E-02,   6.5120801E-02
     +,   6.7508288E-02,   6.9965467E-02,   7.2481148E-02
     +,   7.5046420E-02,   7.7656239E-02,   8.0311865E-02
     +,   8.3023332E-02,   8.5812964E-02,   8.8718235E-02
     +,   9.1794848E-02,   9.5119044E-02,   9.8787472E-02
     +,   0.1029143    ,   0.1076229    ,   0.1130350    
     +,   0.1192521    ,   0.1263392    ,   0.1343046    
     +,   0.1430880    ,   0.1525544    ,   0.1624968    
     +,   0.1726528    ,   0.1827271    ,   0.1924206    
     +,   0.2014601    ,   0.2096280    ,   0.2167837    
     +,   0.2228775    ,   0.2279506    ,   0.2321261    
     +,   0.2355863    ,   0.2385425    ,   0.2412069    
     +,   0.2437719    ,   0.2464119    ,   0.2493096    
     +,   0.2527055    ,   0.2569579    ,   0.2625798    
     +,   0.2702246    ,   0.2805911    ,   0.2942526    
     +,   0.3114567    ,   0.3319754    ,   0.3550947    
     +,   0.3797632    ,   0.4048503    ,   0.4293902    
     +,   0.4526732    ,   0.4741536    ,   0.4932707    
     +,   0.5093682    ,   0.5218388    ,   0.5304685    
     +,   0.5358198    ,   0.5394241    ,   0.5436154    
     +,   0.5509719    ,   0.5634875    ,   0.5818161    
     +,   0.6049181    ,   0.6302980    ,   0.6546806    
     +,   0.6748533    ,   0.6884745    ,   0.6947883    
     +,   0.6951187    ,   0.6928423    ,   0.6925557    
     +,   0.6985042    ,   0.7128198    ,   0.7342804    
     +,   0.7581440    ,   0.7772433    ,   0.7841733    
     +,   0.7739140    ,   0.7459067    ,   0.7045498    
     +,   0.6578038    ,   0.6144932    ,   0.5814389    
     +,   0.5615362    ,   0.5533647    ,   0.5522578    
     +,   0.5522121    ,   0.5478070    ,   0.5355034    
     +,   0.5140905    ,   0.4844071    ,   0.4486213    
     +,   0.4093882    ,   0.3691432    ,   0.3296744    
     +,   0.2920217    ,   0.2566236    ,   0.2235740    
     +,   0.1928542    ,   0.1644743    ,   0.1385169    
     +,   0.1151095    ,   9.4366148E-02,   7.6335646E-02
     +,   6.0975805E-02,   4.8149731E-02,   3.7638385E-02
     +,   2.9168295E-02,   2.2441808E-02,   1.7163251E-02
     +,   1.3059050E-02,   9.8904222E-03,   7.4578305E-03
     +,   5.5994634E-03,   4.1866247E-03,   3.1181334E-03
     +,   2.3147338E-03,   1.7142647E-03,   1.2679858E-03
     +,   9.3786063E-04,   6.9445802E-04,   5.1521551E-04
     +,   3.8310356E-04,   2.8546114E-04,   2.1299228E-04
     +,   1.5894494E-04,   1.1845238E-04,   8.8013643E-05
     +,   6.5097047E-05,   4.7853362E-05,   3.4915145E-05
     +,   2.5256542E-05,   1.8096458E-05,   1.2833698E-05
     +,   9.0033982E-06,   6.2460258E-06,   4.2839333E-06
     +,   2.9046178E-06,   1.9471224E-06,   1.2909120E-06
     +,   8.4692823E-07,   5.5037333E-07,   3.5481173E-07
     +,   2.2745390E-07,   1.4550018E-07,   9.3352106E-08
     +,   6.0502714E-08,   3.9978552E-08,   2.7221391E-08
     +,   1.9297776E-08,   1.4347789E-08,   1.1208323E-08
     +,   9.1628056E-09,   7.7757756E-09,   6.7859145E-09
     +,   6.0381753E-09,   5.4415144E-09,   4.9428310E-09
     +,   4.5111737E-09,   4.1283519E-09,   3.7834891E-09
     +,   3.4698546E-09,   3.1830134E-09,   2.9198741E-09
     +,   2.6780749E-09,   2.4557296E-09,   2.2512114E-09
     +,   2.0631024E-09,   1.8901063E-09,   1.7310583E-09
     +,   1.5848693E-09,   1.4505529E-09,   1.3271791E-09
     +,   1.2138927E-09,   1.1099103E-09,   1.0144956E-09
     +,   9.2697833E-10,   8.4672730E-10,   7.7316881E-10
     +,   7.0576489E-10,   6.4402467E-10,   5.8748828E-10
     +,   5.3573918E-10,   4.8838444E-10,   4.4506898E-10
     +,   4.0545950E-10,   3.6925360E-10
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_asha_hatt107_mass = Yx/9.2492176
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_asha_hatt110_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.5308057E-04,   4.7090295E-04
     +,   4.8951618E-04,   5.0896825E-04,   5.2931189E-04
     +,   5.5060582E-04,   5.7291461E-04,   5.9631042E-04
     +,   6.2087266E-04,   6.4669090E-04,   6.7386316E-04
     +,   7.0249889E-04,   7.3271891E-04,   7.6465693E-04
     +,   7.9846114E-04,   8.3429448E-04,   8.7233610E-04
     +,   9.1278285E-04,   9.5584942E-04,   1.0017704E-03
     +,   1.0508007E-03,   1.1032165E-03,   1.1593144E-03
     +,   1.2194174E-03,   1.2838639E-03,   1.3530215E-03
     +,   1.4272759E-03,   1.5070351E-03,   1.5927256E-03
     +,   1.6847940E-03,   1.7837014E-03,   1.8899224E-03
     +,   2.0039417E-03,   2.1262490E-03,   2.2573371E-03
     +,   2.3976935E-03,   2.5477959E-03,   2.7081042E-03
     +,   2.8790652E-03,   3.0610769E-03,   3.2545165E-03
     +,   3.4597048E-03,   3.6769090E-03,   3.9063329E-03
     +,   4.1481061E-03,   4.4022799E-03,   4.6688132E-03
     +,   4.9475697E-03,   5.2383104E-03,   5.5406867E-03
     +,   5.8542378E-03,   6.1783874E-03,   6.5124356E-03
     +,   6.8555935E-03,   7.2069154E-03,   7.5653950E-03
     +,   7.9299035E-03,   8.2992315E-03,   8.6721014E-03
     +,   9.0471786E-03,   9.4230939E-03,   9.7984830E-03
     +,   1.0171961E-02,   1.0542225E-02,   1.0908046E-02
     +,   1.1268263E-02,   1.1621906E-02,   1.1968134E-02
     +,   1.2306350E-02,   1.2636161E-02,   1.2957478E-02
     +,   1.3270468E-02,   1.3575664E-02,   1.3873878E-02
     +,   1.4166308E-02,   1.4454502E-02,   1.4740335E-02
     +,   1.5026029E-02,   1.5314140E-02,   1.5607527E-02
     +,   1.5909318E-02,   1.6222889E-02,   1.6551811E-02
     +,   1.6899876E-02,   1.7270984E-02,   1.7669184E-02
     +,   1.8098600E-02,   1.8563513E-02,   1.9068195E-02
     +,   1.9617066E-02,   2.0214627E-02,   2.0865446E-02
     +,   2.1574153E-02,   2.2345489E-02,   2.3184257E-02
     +,   2.4095137E-02,   2.5082892E-02,   2.6151955E-02
     +,   2.7306644E-02,   2.8550697E-02,   2.9887572E-02
     +,   3.1319935E-02,   3.2850016E-02,   3.4479141E-02
     +,   3.6208235E-02,   3.8037699E-02,   3.9967503E-02
     +,   4.1997489E-02,   4.4127706E-02,   4.6358675E-02
     +,   4.8691221E-02,   5.1127329E-02,   5.3669605E-02
     +,   5.6321960E-02,   5.9088852E-02,   6.1975688E-02
     +,   6.4987645E-02,   6.8129674E-02,   7.1404561E-02
     +,   7.4812837E-02,   7.8350827E-02,   8.2009755E-02
     +,   8.5775301E-02,   8.9628391E-02,   9.3546420E-02
     +,   9.7505614E-02,   0.1014860    ,   0.1054742    
     +,   0.1094685    ,   0.1134801    ,   0.1175336    
     +,   0.1216622    ,   0.1259024    ,   0.1302835    
     +,   0.1348196    ,   0.1395008    ,   0.1442893    
     +,   0.1491206    ,   0.1539125    ,   0.1585766    
     +,   0.1630357    ,   0.1672403    ,   0.1711827    
     +,   0.1749027    ,   0.1784821    ,   0.1820297    
     +,   0.1856542    ,   0.1894361    ,   0.1934025    
     +,   0.1975173    ,   0.2016910    ,   0.2058153    
     +,   0.2098159    ,   0.2137109    ,   0.2176593    
     +,   0.2219757    ,   0.2271028    ,   0.2335332    
     +,   0.2417026    ,   0.2518790    ,   0.2640911    
     +,   0.2781243    ,   0.2936053    ,   0.3101613    
     +,   0.3276113    ,   0.3460930    ,   0.3660377    
     +,   0.3879317    ,   0.4119286    ,   0.4374605    
     +,   0.4630706    ,   0.4866256    ,   0.5059187    
     +,   0.5194578    ,   0.5270909    ,   0.5300714    
     +,   0.5304185    ,   0.5298690    ,   0.5290619    
     +,   0.5275037    ,   0.5242997    ,   0.5190571    
     +,   0.5122783    ,   0.5050386    ,   0.4983236    
     +,   0.4925700    ,   0.4876924    ,   0.4835048    
     +,   0.4801640    ,   0.4783185    ,   0.4788224    
     +,   0.4821796    ,   0.4880832    ,   0.4953777    
     +,   0.5024726    ,   0.5079309    ,   0.5108454    
     +,   0.5108328    ,   0.5077417    ,   0.5013480    
     +,   0.4912502    ,   0.4770021    ,   0.4583465    
     +,   0.4353943    ,   0.4086368    ,   0.3788116    
     +,   0.3467305    ,   0.3131776    ,   0.2788951    
     +,   0.2446290    ,   0.2111647    ,   0.1793071    
     +,   0.1498009    ,   0.1232324    ,   9.9960588E-02
     +,   8.0094405E-02,   6.3516930E-02,   4.9944475E-02
     +,   3.8999643E-02,   3.0275779E-02,   2.3381900E-02
     +,   1.7970607E-02,   1.3748382E-02,   1.0474046E-02
     +,   7.9520438E-03,   6.0245460E-03,   4.5638536E-03
     +,   3.4662420E-03,   2.6475573E-03,   2.0401422E-03
     +,   1.5903778E-03,   1.2565199E-03,   1.0067647E-03
     +,   8.1745785E-04,   6.7142001E-04,   5.5641244E-04
     +,   4.6389317E-04,   3.8799268E-04,   3.2470917E-04
     +,   2.7131333E-04,   2.2592703E-04,   1.8722624E-04
     +,   1.5423681E-04,   1.2620082E-04,   1.0249660E-04
     +,   8.2589853E-05,   6.6003377E-05,   5.2301522E-05
     +,   4.1085561E-05,   3.1992113E-05,   2.4690769E-05
     +,   1.8885881E-05,   1.4316666E-05,   1.0755959E-05
     +,   8.0086484E-06,   5.9099157E-06,   4.3225587E-06
     +,   3.1338336E-06,   2.2523170E-06,   1.6049604E-06
     +,   1.1341743E-06,   7.9508681E-07,   5.5316036E-07
     +,   3.8216197E-07,   2.6241335E-07,   1.7930113E-07
     +,   1.2211193E-07,   8.3083911E-08,   5.6651622E-08
     +,   3.8868588E-08,   2.6968783E-08,   1.9034800E-08
     +,   1.3750648E-08,   1.0222499E-08,   7.8498621E-09
     +,   6.2334276E-09,   5.1098485E-09,   4.3073394E-09
     +,   3.7145855E-09,   3.2601251E-09,   2.8982459E-09
     +,   2.5998990E-09,   2.3465547E-09,   2.1263977E-09
     +,   1.9317608E-09,   1.7576155E-09,   1.6005262E-09
     +,   1.4580670E-09,   1.3284541E-09,   1.2102893E-09
     +,   1.1024459E-09,   1.0039649E-09,   9.1401736E-10
     +,   8.3186258E-10,   7.5684320E-10,   6.8835060E-10
     +,   6.2584055E-10,   5.6880473E-10,   5.1678584E-10
     +,   4.6935617E-10,   4.2612860E-10
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_asha_hatt110_mass = Yx/7.39518770454545
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_asha_hatt115_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.5747735E-03,   2.6692839E-03
     +,   2.7686988E-03,   2.8733036E-03,   2.9833843E-03
     +,   3.0992248E-03,   3.2211021E-03,   3.3492825E-03
     +,   3.4840177E-03,   3.6255487E-03,   3.7740865E-03
     +,   3.9298204E-03,   4.0929071E-03,   4.2634695E-03
     +,   4.4415896E-03,   4.6273051E-03,   4.8206048E-03
     +,   5.0214222E-03,   5.2296384E-03,   5.4450664E-03
     +,   5.6674606E-03,   5.8965064E-03,   6.1318167E-03
     +,   6.3729505E-03,   6.6193673E-03,   6.8704914E-03
     +,   7.1256533E-03,   7.3841284E-03,   7.6451330E-03
     +,   7.9078218E-03,   8.1712985E-03,   8.4346319E-03
     +,   8.6968457E-03,   8.9569436E-03,   9.2139104E-03
     +,   9.4667384E-03,   9.7144116E-03,   9.9559482E-03
     +,   1.0190405E-02,   1.0416876E-02,   1.0634533E-02
     +,   1.0842619E-02,   1.1040480E-02,   1.1227569E-02
     +,   1.1403464E-02,   1.1567892E-02,   1.1720727E-02
     +,   1.1862014E-02,   1.1991992E-02,   1.2111074E-02
     +,   1.2219912E-02,   1.2319345E-02,   1.2410454E-02
     +,   1.2494547E-02,   1.2573172E-02,   1.2648110E-02
     +,   1.2721386E-02,   1.2795256E-02,   1.2872192E-02
     +,   1.2954895E-02,   1.3046253E-02,   1.3149315E-02
     +,   1.3267281E-02,   1.3403466E-02,   1.3561229E-02
     +,   1.3743952E-02,   1.3954986E-02,   1.4197544E-02
     +,   1.4474705E-02,   1.4789258E-02,   1.5143706E-02
     +,   1.5540086E-02,   1.5980005E-02,   1.6464435E-02
     +,   1.6993763E-02,   1.7567646E-02,   1.8184943E-02
     +,   1.8843699E-02,   1.9541159E-02,   2.0273766E-02
     +,   2.1037025E-02,   2.1825794E-02,   2.2634124E-02
     +,   2.3455560E-02,   2.4283076E-02,   2.5109444E-02
     +,   2.5927177E-02,   2.6728934E-02,   2.7507588E-02
     +,   2.8256560E-02,   2.8969990E-02,   2.9642968E-02
     +,   3.0271700E-02,   3.0853854E-02,   3.1388588E-02
     +,   3.1876672E-02,   3.2320719E-02,   3.2725044E-02
     +,   3.3095714E-02,   3.3440463E-02,   3.3768535E-02
     +,   3.4090374E-02,   3.4417473E-02,   3.4761831E-02
     +,   3.5135701E-02,   3.5551079E-02,   3.6019180E-02
     +,   3.6550045E-02,   3.7152119E-02,   3.7831813E-02
     +,   3.8593173E-02,   3.9437830E-02,   4.0364739E-02
     +,   4.1370589E-02,   4.2449702E-02,   4.3594930E-02
     +,   4.4797890E-02,   4.6050202E-02,   4.7344085E-02
     +,   4.8673656E-02,   5.0036170E-02,   5.1432908E-02
     +,   5.2870501E-02,   5.4362036E-02,   5.5927537E-02
     +,   5.7594456E-02,   5.9397731E-02,   6.1378639E-02
     +,   6.3583858E-02,   6.6062264E-02,   6.8862341E-02
     +,   7.2026908E-02,   7.5589046E-02,   7.9565763E-02
     +,   8.3953954E-02,   8.8726141E-02,   9.3828611E-02
     +,   9.9182978E-02,   0.1046916    ,   0.1102454    
     +,   0.1157357    ,   0.1210668    ,   0.1261689    
     +,   0.1310077    ,   0.1355884    ,   0.1399555    
     +,   0.1441845    ,   0.1483696    ,   0.1526088    
     +,   0.1569890    ,   0.1615721    ,   0.1663854    
     +,   0.1714153    ,   0.1766061    ,   0.1818622    
     +,   0.1870541    ,   0.1920357    ,   0.1966669    
     +,   0.2008445    ,   0.2045366    ,   0.2078134    
     +,   0.2108629    ,   0.2139847    ,   0.2175559    
     +,   0.2219733    ,   0.2275802    ,   0.2345908    
     +,   0.2430337    ,   0.2527268    ,   0.2632965    
     +,   0.2742370    ,   0.2850125    ,   0.2951804    
     +,   0.3045113    ,   0.3130804    ,   0.3212957    
     +,   0.3298258    ,   0.3394217    ,   0.3506603    
     +,   0.3636828    ,   0.3780338    ,   0.3926863    
     +,   0.4062841    ,   0.4175261    ,   0.4255477    
     +,   0.4301454    ,   0.4317561    ,   0.4312046    
     +,   0.4293558    ,   0.4268225    ,   0.4238579    
     +,   0.4204350    ,   0.4164286    ,   0.4117659    
     +,   0.4064528    ,   0.4004808    ,   0.3937006    
     +,   0.3857660    ,   0.3761906    ,   0.3645048    
     +,   0.3504164    ,   0.3339090    ,   0.3152322    
     +,   0.2948177    ,   0.2731663    ,   0.2507517    
     +,   0.2279806    ,   0.2051967    ,   0.1827098    
     +,   0.1608230    ,   0.1398480    ,   0.1200960    
     +,   0.1018501    ,   8.5333124E-02,   7.0684545E-02
     +,   5.7950370E-02,   4.7086079E-02,   3.7971899E-02
     +,   3.0436689E-02,   2.4282074E-02,   1.9301871E-02
     +,   1.5298885E-02,   1.2095220E-02,   9.5371567E-03
     +,   7.4963174E-03,   5.8684880E-03,   4.5706849E-03
     +,   3.5373918E-03,   2.7169301E-03,   2.0683808E-03
     +,   1.5590123E-03,   1.1622437E-03,   8.5621333E-04
     +,   6.2282383E-04,   4.4706382E-04,   3.1648064E-04
     +,   2.2084356E-04,   1.5184811E-04,   1.0284295E-04
     +,   6.8587397E-05,   4.5029716E-05,   2.9096958E-05
     +,   1.8501702E-05,   1.1574773E-05,   7.1232821E-06
     +,   4.3118803E-06,   2.5670429E-06,   1.5029060E-06
     +,   8.6520777E-07,   4.8976165E-07,   2.7257852E-07
     +,   1.4914568E-07,   8.0229007E-08,   4.2427420E-08
     +,   2.2056351E-08,   1.1271241E-08,   5.6618568E-09
     +,   2.7957388E-09,   1.3569624E-09,   6.4737288E-10
     +,   3.0357175E-10,   1.3992471E-10,   6.3392687E-11
     +,   2.8228071E-11,   1.2355033E-11,   5.3151927E-12
     +,   2.2475407E-12,   9.3422243E-13,   3.8179215E-13
     +,   1.5345109E-13,   6.0698517E-14,   2.3667181E-14
     +,   9.1280328E-15,   3.5082195E-15,   1.3647505E-15
     +,   5.5392794E-16,   2.4625593E-16,   1.2640134E-16
     +,   7.6391076E-17,   5.2715301E-17,   3.9455417E-17
     +,   3.0765984E-17,   2.4432478E-17,   1.9547634E-17
     +,   1.5681174E-17,   1.2588156E-17,   1.0103581E-17
     +,   8.1055933E-18,   6.4988884E-18,   5.2071925E-18
     +,   4.1694514E-18,   3.3362392E-18,   2.6677481E-18
     +,   2.1317104E-18,   1.7022094E-18,   1.3583073E-18
     +,   1.0831471E-18,   8.6312290E-19,   6.8731094E-19
     +,   5.4693136E-19,   4.3492614E-19
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_asha_hatt115_mass = Yx/5.5778045
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_asha_hatt120_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.2887268E-03,   1.3177169E-03
     +,   1.3471707E-03,   1.3771212E-03,   1.4076063E-03
     +,   1.4386675E-03,   1.4703511E-03,   1.5027079E-03
     +,   1.5357941E-03,   1.5696725E-03,   1.6044109E-03
     +,   1.6400844E-03,   1.6767746E-03,   1.7145710E-03
     +,   1.7535720E-03,   1.7938836E-03,   1.8356219E-03
     +,   1.8789128E-03,   1.9238923E-03,   1.9707088E-03
     +,   2.0195208E-03,   2.0705003E-03,   2.1238308E-03
     +,   2.1797123E-03,   2.2383521E-03,   2.2999784E-03
     +,   2.3648292E-03,   2.4331554E-03,   2.5052244E-03
     +,   2.5813144E-03,   2.6617155E-03,   2.7467313E-03
     +,   2.8366721E-03,   2.9318579E-03,   3.0326138E-03
     +,   3.1392684E-03,   3.2521510E-03,   3.3715856E-03
     +,   3.4978972E-03,   3.6313864E-03,   3.7723510E-03
     +,   3.9210618E-03,   4.0777642E-03,   4.2426735E-03
     +,   4.4159661E-03,   4.5977747E-03,   4.7881827E-03
     +,   4.9872175E-03,   5.1948451E-03,   5.4109609E-03
     +,   5.6353887E-03,   5.8678724E-03,   6.1080707E-03
     +,   6.3555716E-03,   6.6098394E-03,   6.8702837E-03
     +,   7.1362015E-03,   7.4068010E-03,   7.6812007E-03
     +,   7.9584373E-03,   8.2374662E-03,   8.5171666E-03
     +,   8.7963436E-03,   9.0737538E-03,   9.3481326E-03
     +,   9.6181314E-03,   9.8824473E-03,   1.0139731E-02
     +,   1.0388681E-02,   1.0628019E-02,   1.0856546E-02
     +,   1.1073124E-02,   1.1276737E-02,   1.1466491E-02
     +,   1.1641650E-02,   1.1801663E-02,   1.1946174E-02
     +,   1.2075059E-02,   1.2188447E-02,   1.2286770E-02
     +,   1.2370722E-02,   1.2441355E-02,   1.2500032E-02
     +,   1.2548500E-02,   1.2588838E-02,   1.2623533E-02
     +,   1.2655408E-02,   1.2687665E-02,   1.2723841E-02
     +,   1.2767793E-02,   1.2823644E-02,   1.2895757E-02
     +,   1.2988653E-02,   1.3106933E-02,   1.3255208E-02
     +,   1.3437986E-02,   1.3659572E-02,   1.3923928E-02
     +,   1.4234606E-02,   1.4594546E-02,   1.5006046E-02
     +,   1.5470553E-02,   1.5988689E-02,   1.6560026E-02
     +,   1.7183172E-02,   1.7855687E-02,   1.8574059E-02
     +,   1.9333785E-02,   2.0129530E-02,   2.0955196E-02
     +,   2.1804063E-02,   2.2669181E-02,   2.3543440E-02
     +,   2.4420144E-02,   2.5293121E-02,   2.6157400E-02
     +,   2.7009377E-02,   2.7847633E-02,   2.8673118E-02
     +,   2.9489996E-02,   3.0306049E-02,   3.1133294E-02
     +,   3.1988576E-02,   3.2894168E-02,   3.3878114E-02
     +,   3.4974314E-02,   3.6222626E-02,   3.7667941E-02
     +,   3.9359260E-02,   4.1347221E-02,   4.3681655E-02
     +,   4.6407357E-02,   4.9560275E-02,   5.3161945E-02
     +,   5.7215486E-02,   6.1700985E-02,   6.6572070E-02
     +,   7.1754418E-02,   7.7146143E-02,   8.2619958E-02
     +,   8.8026419E-02,   9.3200706E-02,   9.7970240E-02
     +,   0.1021637    ,   0.1056208    ,   0.1082047    
     +,   0.1098131    ,   0.1103908    ,   0.1099400    
     +,   0.1085285    ,   0.1062929    ,   0.1034371    
     +,   0.1002237    ,   9.6959129E-02,   9.3974560E-02
     +,   9.1604993E-02,   9.0168521E-02,   8.9950487E-02
     +,   9.1193214E-02,   9.4089910E-02,   9.8781586E-02
     +,   0.1053509    ,   0.1138105    ,   0.1240874    
     +,   0.1360086    ,   0.1492958    ,   0.1635787    
     +,   0.1784333    ,   0.1934353    ,   0.2082140    
     +,   0.2224862    ,   0.2360648    ,   0.2488369    
     +,   0.2607198    ,   0.2716213    ,   0.2814187    
     +,   0.2899645    ,   0.2971224    ,   0.3028224    
     +,   0.3071181    ,   0.3102337    ,   0.3125797    
     +,   0.3147380    ,   0.3173848    ,   0.3211370    
     +,   0.3263255    ,   0.3327572    ,   0.3395988    
     +,   0.3455012    ,   0.3489996    ,   0.3490503    
     +,   0.3454445    ,   0.3388910    ,   0.3307068    
     +,   0.3222907    ,   0.3146311    ,   0.3080525    
     +,   0.3022418    ,   0.2964640    ,   0.2898357    
     +,   0.2815571    ,   0.2710703    ,   0.2581460    
     +,   0.2429109    ,   0.2258180    ,   0.2075505    
     +,   0.1888846    ,   0.1705431    ,   0.1530746    
     +,   0.1367959    ,   0.1218025    ,   0.1080317    
     +,   9.5344007E-02,   8.3596110E-02,   7.2689734E-02
     +,   6.2587947E-02,   5.3304713E-02,   4.4881169E-02
     +,   3.7360702E-02,   3.0769039E-02,   2.5101097E-02
     +,   2.0318994E-02,   1.6356196E-02,   1.3125230E-02
     +,   1.0526961E-02,   8.4598921E-03,   6.8273810E-03
     +,   5.5423360E-03,   4.5298650E-03,   3.7281616E-03
     +,   3.0879674E-03,   2.5710938E-03,   2.1486073E-03
     +,   1.7990300E-03,   1.5066487E-03,   1.2599824E-03
     +,   1.0506460E-03,   8.7244762E-04,   7.2069454E-04
     +,   5.9170387E-04,   4.8248106E-04,   3.9050373E-04
     +,   3.1356985E-04,   2.4971011E-04,   1.9714714E-04
     +,   1.5427259E-04,   1.1963085E-04,   9.1912465E-05
     +,   6.9954600E-05,   5.2738033E-05,   3.9377708E-05
     +,   2.9117566E-05,   2.1321219E-05,   1.5459722E-05
     +,   1.1099401E-05,   7.8901412E-06,   5.5532887E-06
     +,   3.8698286E-06,   2.6699165E-06,   1.8237225E-06
     +,   1.2333254E-06,   8.2577134E-07,   5.4739439E-07
     +,   3.5924828E-07,   2.3343094E-07,   1.5017193E-07
     +,   9.5649462E-08,   6.0318655E-08,   3.7662321E-08
     +,   2.3283482E-08,   1.4251913E-08,   8.6376577E-09
     +,   5.1836011E-09,   3.0802236E-09,   1.8123899E-09
     +,   1.0560186E-09,   6.0932426E-10,   3.4820238E-10
     +,   1.9708574E-10,   1.1051314E-10,   6.1406338E-11
     +,   3.3827306E-11,   1.8487333E-11,   1.0036052E-11
     +,   5.4217390E-12,   2.9237259E-12,   1.5813242E-12
     +,   8.6402646E-13,   4.8190949E-13,   2.7803852E-13
     +,   1.6836463E-13,   1.0826081E-13,   7.4250434E-14
     +,   5.4062711E-14,   4.1320978E-14,   3.2712206E-14
     +,   2.6508745E-14,   2.1794907E-14,   1.8072358E-14
     +,   1.5056495E-14,   1.2574649E-14
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_asha_hatt120_mass = Yx/4.137163275
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_asha_hatt60_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  6.2841894E-03,   6.6366112E-03
     +,   7.0224721E-03,   7.4479505E-03,   7.9202326E-03
     +,   8.4479339E-03,   9.0419371E-03,   9.7168665E-03
     +,   1.0493407E-02,   1.1401814E-02,   1.2486538E-02
     +,   1.3812217E-02,   1.5470493E-02,   1.7586898E-02
     +,   2.0326374E-02,   2.3895646E-02,   2.8540166E-02
     +,   3.4534916E-02,   4.2170376E-02,   5.1739879E-02
     +,   6.3537806E-02,   7.7876978E-02,   9.5121510E-02
     +,   0.1157160    ,   0.1401771    ,   0.1690702    
     +,   0.2030538    ,   0.2431713    ,   0.2914419    
     +,   0.3514317    ,   0.4280402    ,   0.5258442    
     +,   0.6465275    ,   0.7874437    ,   0.9432179    
     +,    1.109073    ,    1.281195    ,    1.452099    
     +,    1.607460    ,    1.732216    ,    1.821234    
     +,    1.881001    ,    1.919995    ,    1.938325    
     +,    1.924443    ,    1.860811    ,    1.738904    
     +,    1.572984    ,    1.395234    ,    1.234070    
     +,    1.099092    ,   0.9855810    ,   0.8868529    
     +,   0.7995788    ,   0.7217517    ,   0.6506833    
     +,   0.5839590    ,   0.5208634    ,   0.4622728    
     +,   0.4095598    ,   0.3637576    ,   0.3253079    
     +,   0.2940650    ,   0.2693154    ,   0.2498675    
     +,   0.2342594    ,   0.2210329    ,   0.2089764    
     +,   0.1972550    ,   0.1854326    ,   0.1734046    
     +,   0.1612992    ,   0.1493627    ,   0.1378725    
     +,   0.1270708    ,   0.1171324    ,   0.1081559    
     +,   0.1001697    ,   9.3146384E-02,   8.7020725E-02
     +,   8.1706442E-02,   7.7107131E-02,   7.3126644E-02
     +,   6.9673404E-02,   6.6664025E-02,   6.4023562E-02
     +,   6.1686352E-02,   5.9594661E-02,   5.7698745E-02
     +,   5.5956058E-02,   5.4330785E-02,   5.2793752E-02
     +,   5.1321860E-02,   4.9897630E-02,   4.8508950E-02
     +,   4.7148552E-02,   4.5812994E-02,   4.4502422E-02
     +,   4.3219328E-02,   4.1968159E-02,   4.0754158E-02
     +,   3.9583206E-02,   3.8460780E-02,   3.7391901E-02
     +,   3.6380515E-02,   3.5429478E-02,   3.4540500E-02
     +,   3.3714134E-02,   3.2949876E-02,   3.2246284E-02
     +,   3.1601369E-02,   3.1012608E-02,   3.0477345E-02
     +,   2.9992795E-02,   2.9556479E-02,   2.9166104E-02
     +,   2.8819820E-02,   2.8516190E-02,   2.8254239E-02
     +,   2.8033402E-02,   2.7853452E-02,   2.7714392E-02
     +,   2.7616378E-02,   2.7559521E-02,   2.7543787E-02
     +,   2.7568879E-02,   2.7634034E-02,   2.7737945E-02
     +,   2.7878683E-02,   2.8053571E-02,   2.8259197E-02
     +,   2.8491292E-02,   2.8744867E-02,   2.9014215E-02
     +,   2.9292917E-02,   2.9574139E-02,   2.9850503E-02
     +,   3.0114474E-02,   3.0358436E-02,   3.0574886E-02
     +,   3.0756639E-02,   3.0896988E-02,   3.0989913E-02
     +,   3.1030228E-02,   3.1013750E-02,   3.0937381E-02
     +,   3.0799137E-02,   3.0598328E-02,   3.0335449E-02
     +,   3.0012226E-02,   2.9631475E-02,   2.9197112E-02
     +,   2.8713990E-02,   2.8187670E-02,   2.7624356E-02
     +,   2.7030710E-02,   2.6413679E-02,   2.5780221E-02
     +,   2.5137203E-02,   2.4491319E-02,   2.3848806E-02
     +,   2.3215383E-02,   2.2596184E-02,   2.1995693E-02
     +,   2.1417608E-02,   2.0864880E-02,   2.0339778E-02
     +,   1.9843819E-02,   1.9377830E-02,   1.8942021E-02
     +,   1.8536080E-02,   1.8159216E-02,   1.7810218E-02
     +,   1.7487574E-02,   1.7189560E-02,   1.6914263E-02
     +,   1.6659686E-02,   1.6423794E-02,   1.6204597E-02
     +,   1.6000109E-02,   1.5808458E-02,   1.5627867E-02
     +,   1.5456697E-02,   1.5293408E-02,   1.5136580E-02
     +,   1.4984923E-02,   1.4837247E-02,   1.4692432E-02
     +,   1.4549452E-02,   1.4407344E-02,   1.4265180E-02
     +,   1.4122071E-02,   1.3977152E-02,   1.3829597E-02
     +,   1.3678567E-02,   1.3523235E-02,   1.3362814E-02
     +,   1.3196521E-02,   1.3023601E-02,   1.2843332E-02
     +,   1.2655043E-02,   1.2458143E-02,   1.2252085E-02
     +,   1.2036408E-02,   1.1810773E-02,   1.1574933E-02
     +,   1.1328749E-02,   1.1072227E-02,   1.0805503E-02
     +,   1.0528831E-02,   1.0242595E-02,   9.9473251E-03
     +,   9.6436888E-03,   9.3324399E-03,   9.0144482E-03
     +,   8.6906953E-03,   8.3622476E-03,   8.0302181E-03
     +,   7.6957694E-03,   7.3601329E-03,   7.0245261E-03
     +,   6.6901594E-03,   6.3582589E-03,   6.0300156E-03
     +,   5.7065496E-03,   5.3889258E-03,   5.0781593E-03
     +,   4.7751809E-03,   4.4808146E-03,   4.1957898E-03
     +,   3.9207567E-03,   3.6562602E-03,   3.4027263E-03
     +,   3.1604788E-03,   2.9297690E-03,   2.7107245E-03
     +,   2.5033862E-03,   2.3077244E-03,   2.1236280E-03
     +,   1.9509040E-03,   1.7892974E-03,   1.6385086E-03
     +,   1.4981891E-03,   1.3679423E-03,   1.2473402E-03
     +,   1.1359395E-03,   1.0332778E-03,   9.3887496E-04
     +,   8.5224648E-04,   7.7291654E-04,   7.0040562E-04
     +,   6.3424406E-04,   5.7397870E-04,   5.1917153E-04
     +,   4.6939784E-04,   4.2425332E-04,   3.8335708E-04
     +,   3.4634981E-04,   3.1289112E-04,   2.8266391E-04
     +,   2.5537479E-04,   2.3075189E-04,   2.0854270E-04
     +,   1.8851519E-04,   1.7045881E-04,   1.5417929E-04
     +,   1.3950000E-04,   1.2626140E-04,   1.1431894E-04
     +,   1.0354137E-04,   9.3810209E-05,   8.5019565E-05
     +,   7.7074365E-05,   6.9888549E-05,   6.3385312E-05
     +,   5.7496331E-05,   5.2159834E-05,   4.7321257E-05
     +,   4.2931209E-05,   3.8946098E-05,   3.5326473E-05
     +,   3.2037486E-05,   2.9047522E-05,   2.6328686E-05
     +,   2.3855579E-05,   2.1605725E-05,   1.9558693E-05
     +,   1.7696115E-05,   1.6001566E-05,   1.4460034E-05
     +,   1.3058097E-05,   1.1783422E-05,   1.0624974E-05
     +,   9.5725654E-06,   8.6170603E-06,   7.7499972E-06
     +,   6.9637531E-06,   6.2512690E-06,   5.6061645E-06
     +,   5.0225167E-06,   4.4949697E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_asha_hatt60_mass = Yx/10.466713173913
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_asha_hatt65_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.6449493E-03,   1.7871673E-03
     +,   1.9464368E-03,   2.1246215E-03,   2.3237013E-03
     +,   2.5457656E-03,   2.7929954E-03,   3.0676478E-03
     +,   3.3720289E-03,   3.7084913E-03,   4.0793777E-03
     +,   4.4870223E-03,   4.9337237E-03,   5.4217279E-03
     +,   5.9532369E-03,   6.5304097E-03,   7.1553905E-03
     +,   7.8303572E-03,   8.5575748E-03,   9.3394779E-03
     +,   1.0178762E-02,   1.1078476E-02,   1.2042104E-02
     +,   1.3073728E-02,   1.4177944E-02,   1.5360137E-02
     +,   1.6626419E-02,   1.7983841E-02,   1.9440612E-02
     +,   2.1006623E-02,   2.2694273E-02,   2.4519937E-02
     +,   2.6506474E-02,   2.8687082E-02,   3.1110981E-02
     +,   3.3851106E-02,   3.7013412E-02,   4.0746734E-02
     +,   4.5252781E-02,   5.0796401E-02,   5.7725355E-02
     +,   6.6508994E-02,   7.7809893E-02,   9.2580542E-02
     +,   0.1121428    ,   0.1381761    ,   0.1725475    
     +,   0.2169825    ,   0.2726480    ,   0.3397489    
     +,   0.4172204    ,   0.5027401    ,   0.5937428    
     +,   0.6903458    ,   0.7994065    ,   0.9355634    
     +,    1.114389    ,    1.338960    ,    1.590780    
     +,    1.839676    ,    2.067147    ,    2.270954    
     +,    2.443468    ,    2.564013    ,    2.619132    
     +,    2.606462    ,    2.519760    ,    2.362226    
     +,    2.158582    ,    1.936389    ,    1.717465    
     +,    1.516830    ,    1.339547    ,    1.185878    
     +,    1.052471    ,   0.9332453    ,   0.8262960    
     +,   0.7340269    ,   0.6564931    ,   0.5897636    
     +,   0.5297212    ,   0.4745219    ,   0.4239737    
     +,   0.3781809    ,   0.3370654    ,   0.3005103    
     +,   0.2685425    ,   0.2412533    ,   0.2186041    
     +,   0.2002787    ,   0.1856907    ,   0.1740945    
     +,   0.1647174    ,   0.1568612    ,   0.1499599    
     +,   0.1435991    ,   0.1375092    ,   0.1315454    
     +,   0.1256558    ,   0.1198511    ,   0.1141744    
     +,   0.1086804    ,   0.1034211    ,   9.8439254E-02
     +,   9.3766958E-02,   8.9426436E-02,   8.5432783E-02
     +,   8.1794970E-02,   7.8516118E-02,   7.5593680E-02
     +,   7.3018938E-02,   7.0775427E-02,   6.8839818E-02
     +,   6.7181766E-02,   6.5765694E-02,   6.4552382E-02
     +,   6.3501820E-02,   6.2575154E-02,   6.1737124E-02
     +,   6.0957689E-02,   6.0212813E-02,   5.9485141E-02
     +,   5.8763139E-02,   5.8040213E-02,   5.7313051E-02
     +,   5.6580212E-02,   5.5840213E-02,   5.5090241E-02
     +,   5.4325204E-02,   5.3537291E-02,   5.2715935E-02
     +,   5.1848561E-02,   5.0921552E-02,   4.9921624E-02
     +,   4.8837014E-02,   4.7658984E-02,   4.6382900E-02
     +,   4.5009028E-02,   4.3542728E-02,   4.1994430E-02
     +,   4.0379349E-02,   3.8716387E-02,   3.7027068E-02
     +,   3.5334241E-02,   3.3661049E-02,   3.2029286E-02
     +,   3.0458584E-02,   2.8965613E-02,   2.7563415E-02
     +,   2.6261041E-02,   2.5063591E-02,   2.3972530E-02
     +,   2.2985971E-02,   2.2099163E-02,   2.1305140E-02
     +,   2.0595431E-02,   1.9960627E-02,   1.9390859E-02
     +,   1.8876391E-02,   1.8408008E-02,   1.7977269E-02
     +,   1.7576708E-02,   1.7200001E-02,   1.6841989E-02
     +,   1.6498612E-02,   1.6166881E-02,   1.5844792E-02
     +,   1.5531167E-02,   1.5225540E-02,   1.4927985E-02
     +,   1.4639043E-02,   1.4359561E-02,   1.4090560E-02
     +,   1.3833135E-02,   1.3588414E-02,   1.3357416E-02
     +,   1.3141031E-02,   1.2939965E-02,   1.2754710E-02
     +,   1.2585467E-02,   1.2432207E-02,   1.2294615E-02
     +,   1.2172111E-02,   1.2063842E-02,   1.1968710E-02
     +,   1.1885406E-02,   1.1812397E-02,   1.1747997E-02
     +,   1.1690367E-02,   1.1637564E-02,   1.1587568E-02
     +,   1.1538318E-02,   1.1487766E-02,   1.1433873E-02
     +,   1.1374682E-02,   1.1308323E-02,   1.1233046E-02
     +,   1.1147264E-02,   1.1049558E-02,   1.0938691E-02
     +,   1.0813653E-02,   1.0673654E-02,   1.0518122E-02
     +,   1.0346711E-02,   1.0159332E-02,   9.9561121E-03
     +,   9.7373836E-03,   9.5037157E-03,   9.2558665E-03
     +,   8.9947609E-03,   8.7214820E-03,   8.4372647E-03
     +,   8.1434660E-03,   7.8415172E-03,   7.5329132E-03
     +,   7.2192145E-03,   6.9020088E-03,   6.5828525E-03
     +,   6.2632891E-03,   5.9448499E-03,   5.6289667E-03
     +,   5.3170053E-03,   5.0102575E-03,   4.7099153E-03
     +,   4.4170399E-03,   4.1325777E-03,   3.8573712E-03
     +,   3.5921382E-03,   3.3374580E-03,   3.0937877E-03
     +,   2.8614823E-03,   2.6407831E-03,   2.4318090E-03
     +,   2.2345800E-03,   2.0490449E-03,   1.8750506E-03
     +,   1.7123709E-03,   1.5607261E-03,   1.4197804E-03
     +,   1.2891421E-03,   1.1683840E-03,   1.0570586E-03
     +,   9.5469505E-04,   8.6080306E-04,   7.7488535E-04
     +,   6.9645012E-04,   6.2500790E-04,   5.6007341E-04
     +,   5.0117401E-04,   4.4785877E-04,   3.9968846E-04
     +,   3.5624462E-04,   3.1713335E-04,   2.8198233E-04
     +,   2.5043965E-04,   2.2217692E-04,   1.9689064E-04
     +,   1.7429916E-04,   1.5414112E-04,   1.3617646E-04
     +,   1.2018624E-04,   1.0597026E-04,   9.3345232E-05
     +,   8.2144688E-05,   7.2218812E-05,   6.3431056E-05
     +,   5.5658373E-05,   4.8790356E-05,   4.2727694E-05
     +,   3.7380880E-05,   3.2669705E-05,   2.8522714E-05
     +,   2.4875962E-05,   2.1672138E-05,   1.8860141E-05
     +,   1.6394719E-05,   1.4235246E-05,   1.2345877E-05
     +,   1.0694523E-05,   9.2528926E-06,   7.9957035E-06
     +,   6.9007151E-06,   5.9480740E-06,   5.1203538E-06
     +,   4.4020226E-06,   3.7794634E-06,   3.2405965E-06
     +,   2.7747772E-06,   2.3726755E-06,   2.0260316E-06
     +,   1.7276337E-06,   1.4711144E-06,   1.2509262E-06
     +,   1.0621859E-06,   9.0064918E-07,   7.6258920E-07
     +,   6.4477780E-07,   5.4438794E-07,   4.5897784E-07
     +,   3.8641639E-07,   3.2486747E-07
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_asha_hatt65_mass = Yx/12.81075425
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_asha_hatt70_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.4224461E-03,   1.4816748E-03
     +,   1.5440852E-03,   1.6097840E-03,   1.6788676E-03
     +,   1.7514217E-03,   1.8275172E-03,   1.9072095E-03
     +,   1.9905353E-03,   2.0775162E-03,   2.1681460E-03
     +,   2.2624000E-03,   2.3602287E-03,   2.4615552E-03
     +,   2.5662801E-03,   2.6742746E-03,   2.7853868E-03
     +,   2.8994412E-03,   3.0162407E-03,   3.1355692E-03
     +,   3.2572036E-03,   3.3809149E-03,   3.5064842E-03
     +,   3.6337213E-03,   3.7624720E-03,   3.8926606E-03
     +,   4.0243124E-03,   4.1575977E-03,   4.2928811E-03
     +,   4.4307858E-03,   4.5722662E-03,   4.7186813E-03
     +,   4.8719035E-03,   5.0344151E-03,   5.2094129E-03
     +,   5.4009440E-03,   5.6140111E-03,   5.8546984E-03
     +,   6.1303275E-03,   6.4495420E-03,   6.8225176E-03
     +,   7.2611053E-03,   7.7790841E-03,   8.3924532E-03
     +,   9.1198506E-03,   9.9831121E-03,   1.1007938E-02
     +,   1.2224797E-02,   1.3669949E-02,   1.5386556E-02
     +,   1.7425824E-02,   1.9848000E-02,   2.2722956E-02
     +,   2.6130404E-02,   3.0158278E-02,   3.4900773E-02
     +,   4.0452659E-02,   4.6901755E-02,   5.4318696E-02
     +,   6.2747888E-02,   7.2208680E-02,   8.2722574E-02
     +,   9.4386734E-02,   0.1075071    ,   0.1227607    
     +,   0.1413039    ,   0.1647200    ,   0.1947916    
     +,   0.2333748    ,   0.2827398    ,   0.3462487    
     +,   0.4281807    ,   0.5318741    ,   0.6577961    
     +,   0.8050756    ,   0.9769682    ,    1.184724    
     +,    1.439918    ,    1.735866    ,    2.045104    
     +,    2.344171    ,    2.626121    ,    2.874557    
     +,    3.034080    ,    3.069469    ,    3.060557    
     +,    3.101054    ,    3.135067    ,    3.032683    
     +,    2.765721    ,    2.428933    ,    2.120884    
     +,    1.869444    ,    1.658052    ,    1.468631    
     +,    1.295319    ,    1.141800    ,    1.014213    
     +,   0.9112158    ,   0.8237230    ,   0.7439382    
     +,   0.6696642    ,   0.6015531    ,   0.5402175    
     +,   0.4857227    ,   0.4379815    ,   0.3969259    
     +,   0.3624068    ,   0.3339921    ,   0.3108738    
     +,   0.2919877    ,   0.2762717    ,   0.2628726    
     +,   0.2511725    ,   0.2407039    ,   0.2310582    
     +,   0.2218708    ,   0.2128620    ,   0.2038886    
     +,   0.1949527    ,   0.1861667    ,   0.1776862    
     +,   0.1696440    ,   0.1621069    ,   0.1550639    
     +,   0.1484430    ,   0.1421389    ,   0.1360471    
     +,   0.1300870    ,   0.1242170    ,   0.1184347    
     +,   0.1127705    ,   0.1072749    ,   0.1020060    
     +,   9.7016312E-02,   9.2345081E-02,   8.8013925E-02
     +,   8.4025420E-02,   8.0364533E-02,   7.7002749E-02
     +,   7.3901989E-02,   7.1019590E-02,   6.8312004E-02
     +,   6.5738775E-02,   6.3265689E-02,   6.0865991E-02
     +,   5.8522027E-02,   5.6225527E-02,   5.3976979E-02
     +,   5.1784128E-02,   4.9660556E-02,   4.7623690E-02
     +,   4.5692444E-02,   4.3885034E-02,   4.2217217E-02
     +,   4.0700998E-02,   3.9343379E-02,   3.8145766E-02
     +,   3.7104070E-02,   3.6209077E-02,   3.5446882E-02
     +,   3.4800023E-02,   3.4248501E-02,   3.3770859E-02
     +,   3.3345278E-02,   3.2950617E-02,   3.2567319E-02
     +,   3.2178085E-02,   3.1768445E-02,   3.1327017E-02
     +,   3.0845797E-02,   3.0320033E-02,   2.9748160E-02
     +,   2.9131394E-02,   2.8473530E-02,   2.7780365E-02
     +,   2.7059250E-02,   2.6318628E-02,   2.5567593E-02
     +,   2.4815265E-02,   2.4070501E-02,   2.3341581E-02
     +,   2.2635808E-02,   2.1959310E-02,   2.1316906E-02
     +,   2.0712046E-02,   2.0146735E-02,   1.9621609E-02
     +,   1.9135959E-02,   1.8687984E-02,   1.8274775E-02
     +,   1.7892627E-02,   1.7537186E-02,   1.7203644E-02
     +,   1.6886894E-02,   1.6581764E-02,   1.6283166E-02
     +,   1.5986251E-02,   1.5686506E-02,   1.5379896E-02
     +,   1.5062939E-02,   1.4732778E-02,   1.4387175E-02
     +,   1.4024553E-02,   1.3644036E-02,   1.3245347E-02
     +,   1.2828809E-02,   1.2395334E-02,   1.1946321E-02
     +,   1.1483563E-02,   1.1009217E-02,   1.0525748E-02
     +,   1.0035811E-02,   9.5421718E-03,   9.0476302E-03
     +,   8.5550211E-03,   8.0670994E-03,   7.5864573E-03
     +,   7.1155136E-03,   6.6565182E-03,   6.2114322E-03
     +,   5.7819597E-03,   5.3695510E-03,   4.9753790E-03
     +,   4.6003074E-03,   4.2449338E-03,   3.9096228E-03
     +,   3.5944975E-03,   3.2994426E-03,   3.0241502E-03
     +,   2.7681636E-03,   2.5308791E-03,   2.3115629E-03
     +,   2.1093879E-03,   1.9234811E-03,   1.7529007E-03
     +,   1.5966820E-03,   1.4538622E-03,   1.3234823E-03
     +,   1.2045954E-03,   1.0962862E-03,   9.9768420E-04
     +,   9.0796431E-04,   8.2634320E-04,   7.5209158E-04
     +,   6.8453792E-04,   6.2306365E-04,   5.6709751E-04
     +,   5.1612040E-04,   4.6966510E-04,   4.2730517E-04
     +,   3.8865634E-04,   3.5337562E-04,   3.2115486E-04
     +,   2.9171558E-04,   2.6480833E-04,   2.4021121E-04
     +,   2.1772480E-04,   1.9716841E-04,   1.7837937E-04
     +,   1.6121201E-04,   1.4553418E-04,   1.3122472E-04
     +,   1.1817348E-04,   1.0628080E-04,   9.5454117E-05
     +,   8.5608262E-05,   7.6665347E-05,   6.8553272E-05
     +,   6.1204657E-05,   5.4557117E-05,   4.8553062E-05
     +,   4.3138974E-05,   3.8264694E-05,   3.3883673E-05
     +,   2.9953051E-05,   2.6432539E-05,   2.3285245E-05
     +,   2.0476562E-05,   1.7974877E-05,   1.5750680E-05
     +,   1.3777068E-05,   1.2029041E-05,   1.0483904E-05
     +,   9.1206566E-06,   7.9203119E-06,   6.8654272E-06
     +,   5.9401623E-06,   5.1302372E-06,   4.4226222E-06
     +,   3.8056482E-06,   3.2687308E-06,   2.8024338E-06
     +,   2.3982379E-06,   2.0485863E-06,   1.7466933E-06
     +,   1.4865664E-06,   1.2628522E-06,   1.0708437E-06
     +,   9.0635979E-07,   7.6573986E-07
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_asha_hatt70_mass = Yx/15.9025915714286
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_asha_hatt75_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  7.2921393E-04,   7.6036691E-04
     +,   7.9240632E-04,   8.2533184E-04,   8.5914263E-04
     +,   8.9383777E-04,   9.2941633E-04,   9.6587813E-04
     +,   1.0032230E-03,   1.0414539E-03,   1.0805740E-03
     +,   1.1205891E-03,   1.1615079E-03,   1.2033421E-03
     +,   1.2461077E-03,   1.2898244E-03,   1.3345171E-03
     +,   1.3802159E-03,   1.4269565E-03,   1.4747807E-03
     +,   1.5237379E-03,   1.5738840E-03,   1.6252815E-03
     +,   1.6780054E-03,   1.7321340E-03,   1.7877599E-03
     +,   1.8449851E-03,   1.9039233E-03,   1.9647016E-03
     +,   2.0274643E-03,   2.0923729E-03,   2.1596104E-03
     +,   2.2293853E-03,   2.3019353E-03,   2.3775350E-03
     +,   2.4564993E-03,   2.5391914E-03,   2.6260358E-03
     +,   2.7175271E-03,   2.8142303E-03,   2.9168122E-03
     +,   3.0260400E-03,   3.1428011E-03,   3.2681171E-03
     +,   3.4031621E-03,   3.5492759E-03,   3.7079854E-03
     +,   3.8810140E-03,   4.0703020E-03,   4.2780205E-03
     +,   4.5065833E-03,   4.7586593E-03,   5.0371797E-03
     +,   5.3453716E-03,   5.6867222E-03,   6.0650576E-03
     +,   6.4845118E-03,   6.9495980E-03,   7.4652373E-03
     +,   8.0368482E-03,   8.6704437E-03,   9.3727764E-03
     +,   1.0151479E-02,   1.1015409E-02,   1.1974918E-02
     +,   1.3042192E-02,   1.4232002E-02,   1.5562194E-02
     +,   1.7054912E-02,   1.8737493E-02,   2.0644395E-02
     +,   2.2818523E-02,   2.5313918E-02,   2.8197452E-02
     +,   3.1551752E-02,   3.5477415E-02,   4.0095337E-02
     +,   4.5550056E-02,   5.2015088E-02,   5.9700269E-02
     +,   6.8860769E-02,   7.9808757E-02,   9.2911191E-02
     +,   0.1085710    ,   0.1271617    ,   0.1489257    
     +,   0.1738478    ,   0.2016324    ,   0.2319751    
     +,   0.2654338    ,   0.3049506    ,   0.3573911    
     +,   0.4334995    ,   0.5449818    ,   0.6999545    
     +,   0.8996811    ,    1.139510    ,    1.418621    
     +,    1.751244    ,    2.148555    ,    2.597456    
     +,    3.092324    ,    3.605882    ,    4.027773    
     +,    4.195239    ,    4.117505    ,    4.035779    
     +,    3.984275    ,    3.862862    ,    3.554083    
     +,    3.141764    ,    2.852541    ,    2.651384    
     +,    2.375416    ,    2.027390    ,    1.692158    
     +,    1.420853    ,    1.223507    ,    1.082884    
     +,   0.9746652    ,   0.8790815    ,   0.7884356    
     +,   0.7067485    ,   0.6396532    ,   0.5872356    
     +,   0.5453318    ,   0.5098141    ,   0.4786571    
     +,   0.4511437    ,   0.4262259    ,   0.4019323    
     +,   0.3761925    ,   0.3480425    ,   0.3181296    
     +,   0.2882273    ,   0.2602954    ,   0.2357276    
     +,   0.2150879    ,   0.1982452    ,   0.1846679    
     +,   0.1736766    ,   0.1645964    ,   0.1568255    
     +,   0.1498654    ,   0.1433338    ,   0.1369686    
     +,   0.1306244    ,   0.1242567    ,   0.1178986    
     +,   0.1116305    ,   0.1055525    ,   9.9762432E-02
     +,   9.4339885E-02,   8.9338534E-02,   8.4784932E-02
     +,   8.0681168E-02,   7.7009022E-02,   7.3734276E-02
     +,   7.0811518E-02,   6.8188585E-02,   6.5809354E-02
     +,   6.3617878E-02,   6.1561335E-02,   5.9592888E-02
     +,   5.7673488E-02,   5.5773444E-02,   5.3872999E-02
     +,   5.1961437E-02,   5.0036207E-02,   4.8100933E-02
     +,   4.6164025E-02,   4.4236541E-02,   4.2330459E-02
     +,   4.0457573E-02,   3.8628869E-02,   3.6853492E-02
     +,   3.5138920E-02,   3.3491038E-02,   3.1914320E-02
     +,   3.0411903E-02,   2.8986091E-02,   2.7638577E-02
     +,   2.6370537E-02,   2.5182599E-02,   2.4074906E-02
     +,   2.3047134E-02,   2.2098303E-02,   2.1226574E-02
     +,   2.0429263E-02,   1.9702829E-02,   1.9042740E-02
     +,   1.8443545E-02,   1.7899057E-02,   1.7402418E-02
     +,   1.6946265E-02,   1.6522972E-02,   1.6124897E-02
     +,   1.5744576E-02,   1.5374904E-02,   1.5009348E-02
     +,   1.4642141E-02,   1.4268374E-02,   1.3884068E-02
     +,   1.3486227E-02,   1.3072912E-02,   1.2643117E-02
     +,   1.2196767E-02,   1.1734649E-02,   1.1258301E-02
     +,   1.0769854E-02,   1.0271924E-02,   9.7675305E-03
     +,   9.2599308E-03,   8.7524615E-03,   8.2484568E-03
     +,   7.7511817E-03,   7.2637121E-03,   6.7888270E-03
     +,   6.3289893E-03,   5.8863549E-03,   5.4626563E-03
     +,   5.0592348E-03,   4.6770852E-03,   4.3168277E-03
     +,   3.9787129E-03,   3.6626912E-03,   3.3684510E-03
     +,   3.0954499E-03,   2.8429271E-03,   2.6099745E-03
     +,   2.3955817E-03,   2.1986593E-03,   2.0180540E-03
     +,   1.8526020E-03,   1.7011581E-03,   1.5625886E-03
     +,   1.4358048E-03,   1.3197813E-03,   1.2135548E-03
     +,   1.1162235E-03,   1.0269588E-03,   9.4500906E-04
     +,   8.6969289E-04,   8.0038991E-04,   7.3654542E-04
     +,   6.7766657E-04,   6.2331429E-04,   5.7309406E-04
     +,   5.2665611E-04,   4.8369280E-04,   4.4392640E-04
     +,   4.0710907E-04,   3.7302074E-04,   3.4146366E-04
     +,   3.1225692E-04,   2.8523614E-04,   2.6025323E-04
     +,   2.3717176E-04,   2.1586425E-04,   1.9621264E-04
     +,   1.7810817E-04,   1.6144897E-04,   1.4613816E-04
     +,   1.3208477E-04,   1.1920438E-04,   1.0741573E-04
     +,   9.6642245E-05,   8.6812179E-05,   7.7857549E-05
     +,   6.9713431E-05,   6.2318708E-05,   5.5616056E-05
     +,   4.9551461E-05,   4.4073651E-05,   3.9134542E-05
     +,   3.4689449E-05,   3.0696025E-05,   2.7115202E-05
     +,   2.3910097E-05,   2.1046848E-05,   1.8493633E-05
     +,   1.6221355E-05,   1.4202815E-05,   1.2413228E-05
     +,   1.0829574E-05,   9.4309471E-06,   8.1980779E-06
     +,   7.1134041E-06,   6.1610290E-06,   5.3263948E-06
     +,   4.5964202E-06,   3.9591982E-06,   3.4040656E-06
     +,   2.9213668E-06,   2.5025056E-06,   2.1397300E-06
     +,   1.8261703E-06,   1.5556653E-06,   1.3227799E-06
     +,   1.1226640E-06,   9.5105776E-07
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_asha_hatt75_mass = Yx/18.92366406
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_asha_hatt80_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  5.1996286E-04,   5.3163944E-04
     +,   5.4341200E-04,   5.5529346E-04,   5.6729832E-04
     +,   5.7944388E-04,   5.9174979E-04,   6.0423871E-04
     +,   6.1693601E-04,   6.2987034E-04,   6.4307346E-04
     +,   6.5658067E-04,   6.7043037E-04,   6.8466517E-04
     +,   6.9933117E-04,   7.1447896E-04,   7.3016313E-04
     +,   7.4644235E-04,   7.6338067E-04,   7.8104652E-04
     +,   7.9951377E-04,   8.1886147E-04,   8.3917478E-04
     +,   8.6054642E-04,   8.8307355E-04,   9.0686372E-04
     +,   9.3203166E-04,   9.5870165E-04,   9.8700903E-04
     +,   1.0171008E-03,   1.0491376E-03,   1.0832950E-03
     +,   1.1197657E-03,   1.1587617E-03,   1.2005154E-03
     +,   1.2452835E-03,   1.2933476E-03,   1.3450171E-03
     +,   1.4006341E-03,   1.4605665E-03,   1.5252228E-03
     +,   1.5950404E-03,   1.6704922E-03,   1.7520851E-03
     +,   1.8403564E-03,   1.9358729E-03,   2.0392230E-03
     +,   2.1510141E-03,   2.2718613E-03,   2.4023796E-03
     +,   2.5431709E-03,   2.6948121E-03,   2.8578355E-03
     +,   3.0327286E-03,   3.2198855E-03,   3.4196302E-03
     +,   3.6321669E-03,   3.8575819E-03,   4.0958254E-03
     +,   4.3467036E-03,   4.6098744E-03,   4.8848498E-03
     +,   5.1709842E-03,   5.4675299E-03,   5.7736444E-03
     +,   6.0883900E-03,   6.4108581E-03,   6.7401375E-03
     +,   7.0754718E-03,   7.4162516E-03,   7.7621834E-03
     +,   8.1132948E-03,   8.4701180E-03,   8.8336905E-03
     +,   9.2057129E-03,   9.5886113E-03,   9.9855764E-03
     +,   1.0400639E-02,   1.0838774E-02,   1.1305936E-02
     +,   1.1809101E-02,   1.2356506E-02,   1.2957742E-02
     +,   1.3624209E-02,   1.4369500E-02,   1.5210227E-02
     +,   1.6166808E-02,   1.7264793E-02,   1.8535893E-02
     +,   2.0019425E-02,   2.1763016E-02,   2.3822535E-02
     +,   2.6260966E-02,   2.9145811E-02,   3.2544844E-02
     +,   3.6520593E-02,   4.1127570E-02,   4.6411246E-02
     +,   5.2417744E-02,   5.9213206E-02,   6.6922657E-02
     +,   7.5784795E-02,   8.6227246E-02,   9.8946162E-02
     +,   0.1149707    ,   0.1356552    ,   0.1625321    
     +,   0.1970046    ,   0.2400478    ,   0.2923562    
     +,   0.3553004    ,   0.4320113    ,   0.5265438    
     +,   0.6402654    ,   0.7686949    ,   0.9057242    
     +,    1.061079    ,    1.284196    ,    1.648935    
     +,    2.158730    ,    2.689263    ,    3.149006    
     +,    3.676276    ,    4.346709    ,    5.048120    
     +,    5.520190    ,    5.611829    ,    5.501542    
     +,    5.194401    ,    4.792773    ,    4.136450    
     +,    3.430568    ,    3.035423    ,    2.719422    
     +,    2.366884    ,    1.999958    ,    1.631024    
     +,    1.323347    ,    1.111037    ,   0.9722784    
     +,   0.8776725    ,   0.8077784    ,   0.7486218    
     +,   0.6911526    ,   0.6323600    ,   0.5736865    
     +,   0.5181972    ,   0.4684014    ,   0.4251878    
     +,   0.3877458    ,   0.3542655    ,   0.3230202    
     +,   0.2931647    ,   0.2648601    ,   0.2388647    
     +,   0.2159970    ,   0.1967788    ,   0.1813166    
     +,   0.1693397    ,   0.1603071    ,   0.1535348    
     +,   0.1483217    ,   0.1440478    ,   0.1402296    
     +,   0.1365324    ,   0.1327517    ,   0.1287815    
     +,   0.1245802    ,   0.1201472    ,   0.1155050    
     +,   0.1106903    ,   0.1057473    ,   0.1007222    
     +,   9.5659621E-02,   9.0599850E-02,   8.5577078E-02
     +,   8.0618963E-02,   7.5748757E-02,   7.0986666E-02
     +,   6.6350840E-02,   6.1858755E-02,   5.7527632E-02
     +,   5.3373441E-02,   4.9410235E-02,   4.5649450E-02
     +,   4.2100001E-02,   3.8767878E-02,   3.5656162E-02
     +,   3.2765638E-02,   3.0095343E-02,   2.7642265E-02
     +,   2.5401631E-02,   2.3367072E-02,   2.1530339E-02
     +,   1.9881176E-02,   1.8407568E-02,   1.7096015E-02
     +,   1.5931802E-02,   1.4899330E-02,   1.3982768E-02
     +,   1.3166605E-02,   1.2435981E-02,   1.1777091E-02
     +,   1.1177492E-02,   1.0626322E-02,   1.0114221E-02
     +,   9.6334200E-03,   9.1776550E-03,   8.7419879E-03
     +,   8.3226329E-03,   7.9168258E-03,   7.5226617E-03
     +,   7.1389186E-03,   6.7648827E-03,   6.4002532E-03
     +,   6.0450523E-03,   5.6995144E-03,   5.3639850E-03
     +,   5.0388854E-03,   4.7246940E-03,   4.4218483E-03
     +,   4.1307458E-03,   3.8517474E-03,   3.5851367E-03
     +,   3.3310957E-03,   3.0897241E-03,   2.8610514E-03
     +,   2.6450197E-03,   2.4414787E-03,   2.2502064E-03
     +,   2.0709289E-03,   1.9033145E-03,   1.7469709E-03
     +,   1.6014697E-03,   1.4663640E-03,   1.3411706E-03
     +,   1.2253920E-03,   1.1185292E-03,   1.0200802E-03
     +,   9.2953822E-04,   8.4640394E-04,   7.7019498E-04
     +,   7.0044131E-04,   6.3668453E-04,   5.7848496E-04
     +,   5.2542624E-04,   4.7711187E-04,   4.3316282E-04
     +,   3.9322214E-04,   3.5695831E-04,   3.2405672E-04
     +,   2.9422413E-04,   2.6718964E-04,   2.4270179E-04
     +,   2.2052633E-04,   2.0044760E-04,   1.8226860E-04
     +,   1.6580865E-04,   1.5090143E-04,   1.3739544E-04
     +,   1.2515389E-04,   1.1405251E-04,   1.0397823E-04
     +,   9.4828982E-05,   8.6513719E-05,   7.8949721E-05
     +,   7.2062830E-05,   6.5787062E-05,   6.0063245E-05
     +,   5.4838158E-05,   5.0064293E-05,   4.5699479E-05
     +,   4.1706058E-05,   3.8050101E-05,   3.4701312E-05
     +,   3.1632855E-05,   2.8820274E-05,   2.6241963E-05
     +,   2.3878138E-05,   2.1711261E-05,   1.9725154E-05
     +,   1.7905404E-05,   1.6238640E-05,   1.4712906E-05
     +,   1.3317034E-05,   1.2040954E-05,   1.0875281E-05
     +,   9.8113660E-06,   8.8413044E-06,   7.9576639E-06
     +,   7.1536688E-06,   6.4229157E-06,   5.7595689E-06
     +,   5.1581133E-06,   4.6134978E-06,   4.1209605E-06
     +,   3.6761471E-06,   3.2749535E-06,   2.9136272E-06
     +,   2.5886418E-06,   2.2967781E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_asha_hatt80_mass = Yx/21.4458740588235
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_asha_hatt85_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  7.1417307E-04,   7.3250307E-04
     +,   7.5126352E-04,   7.7044335E-04,   7.9002714E-04
     +,   8.0999424E-04,   8.3031994E-04,   8.5097441E-04
     +,   8.7192253E-04,   8.9312595E-04,   9.1454026E-04
     +,   9.3611697E-04,   9.5780363E-04,   9.7954355E-04
     +,   1.0012765E-03,   1.0229391E-03,   1.0444650E-03
     +,   1.0657855E-03,   1.0868306E-03,   1.1075280E-03
     +,   1.1278056E-03,   1.1475907E-03,   1.1668114E-03
     +,   1.1853977E-03,   1.2032796E-03,   1.2203917E-03
     +,   1.2366704E-03,   1.2520567E-03,   1.2664954E-03
     +,   1.2799376E-03,   1.2923385E-03,   1.3036610E-03
     +,   1.3138747E-03,   1.3229562E-03,   1.3308902E-03
     +,   1.3376706E-03,   1.3432993E-03,   1.3477881E-03
     +,   1.3511593E-03,   1.3534437E-03,   1.3546845E-03
     +,   1.3549346E-03,   1.3542587E-03,   1.3527325E-03
     +,   1.3504443E-03,   1.3474929E-03,   1.3439901E-03
     +,   1.3400597E-03,   1.3358376E-03,   1.3314721E-03
     +,   1.3271247E-03,   1.3229679E-03,   1.3191887E-03
     +,   1.3159865E-03,   1.3135747E-03,   1.3121807E-03
     +,   1.3120475E-03,   1.3134360E-03,   1.3166249E-03
     +,   1.3219167E-03,   1.3296389E-03,   1.3401498E-03
     +,   1.3538445E-03,   1.3711625E-03,   1.3925966E-03
     +,   1.4186997E-03,   1.4501021E-03,   1.4875166E-03
     +,   1.5317592E-03,   1.5837523E-03,   1.6445505E-03
     +,   1.7153366E-03,   1.7974462E-03,   1.8923569E-03
     +,   2.0017058E-03,   2.1272777E-03,   2.2709863E-03
     +,   2.4348593E-03,   2.6210235E-03,   2.8316614E-03
     +,   3.0689449E-03,   3.3350324E-03,   3.6319485E-03
     +,   3.9615962E-03,   4.3256124E-03,   4.7253924E-03
     +,   5.1619345E-03,   5.6358925E-03,   6.1474172E-03
     +,   6.6962289E-03,   7.2815558E-03,   7.9020821E-03
     +,   8.5559990E-03,   9.2410678E-03,   9.9546481E-03
     +,   1.0693666E-02,   1.1454888E-02,   1.2234856E-02
     +,   1.3030244E-02,   1.3837871E-02,   1.4655171E-02
     +,   1.5480346E-02,   1.6312988E-02,   1.7154420E-02
     +,   1.8008504E-02,   1.8882347E-02,   1.9787075E-02
     +,   2.0738842E-02,   2.1759931E-02,   2.2879655E-02
     +,   2.4135189E-02,   2.5572689E-02,   2.7247658E-02
     +,   2.9226106E-02,   3.1585101E-02,   3.4414839E-02
     +,   3.7820224E-02,   4.1924875E-02,   4.6874087E-02
     +,   5.2839674E-02,   6.0022444E-02,   6.8650499E-02
     +,   7.8969590E-02,   9.1222361E-02,   0.1056156    
     +,   0.1222918    ,   0.1413503    ,   0.1629751    
     +,   0.1877766    ,   0.2173529    ,   0.2548570    
     +,   0.3048843    ,   0.3721525    ,   0.4596957    
     +,   0.5684499    ,   0.6993726    ,   0.8604953    
     +,    1.074003    ,    1.365569    ,    1.766098    
     +,    2.323445    ,    2.993846    ,    3.696171    
     +,    4.436234    ,    4.972780    ,    5.446003    
     +,    6.107556    ,    6.405907    ,    6.114511    
     +,    5.713522    ,    5.079639    ,    4.543085    
     +,    4.075619    ,    3.266961    ,    2.587595    
     +,    2.243847    ,    1.998486    ,    1.728021    
     +,    1.442600    ,    1.190827    ,   0.9943548    
     +,   0.8448879    ,   0.7331470    ,   0.6502850    
     +,   0.5856822    ,   0.5307757    ,   0.4808597    
     +,   0.4343874    ,   0.3914931    ,   0.3527211    
     +,   0.3184144    ,   0.2885534    ,   0.2627383    
     +,   0.2402509    ,   0.2202320    ,   0.2019123    
     +,   0.1847857    ,   0.1686499    ,   0.1535304    
     +,   0.1395650    ,   0.1269064    ,   0.1156604    
     +,   0.1058543    ,   9.7427785E-02,   9.0239368E-02
     +,   8.4085807E-02,   7.8729488E-02,   7.3931083E-02
     +,   6.9479883E-02,   6.5215111E-02,   6.1034583E-02
     +,   5.6893557E-02,   5.2794553E-02,   4.8772320E-02
     +,   4.4877686E-02,   4.1163564E-02,   3.7674744E-02
     +,   3.4441236E-02,   3.1475883E-02,   2.8775524E-02
     +,   2.6324442E-02,   2.4098359E-02,   2.2068821E-02
     +,   2.0207154E-02,   1.8487548E-02,   1.6888455E-02
     +,   1.5393462E-02,   1.3991314E-02,   1.2675080E-02
     +,   1.1441080E-02,   1.0287883E-02,   9.2153279E-03
     +,   8.2236007E-03,   7.3125176E-03,   6.4811856E-03
     +,   5.7278317E-03,   5.0496995E-03,   4.4430811E-03
     +,   3.9035336E-03,   3.4261267E-03,   3.0055435E-03
     +,   2.6363544E-03,   2.3132104E-03,   2.0309573E-03
     +,   1.7847295E-03,   1.5700489E-03,   1.3828722E-03
     +,   1.2195862E-03,   1.0769945E-03,   9.5230533E-04
     +,   8.4310683E-04,   7.4731832E-04,   6.6314609E-04
     +,   5.8905402E-04,   5.2373164E-04,   4.6604846E-04
     +,   4.1503392E-04,   3.6985509E-04,   3.2979250E-04
     +,   2.9422055E-04,   2.6259656E-04,   2.3445062E-04
     +,   2.0937296E-04,   1.8700433E-04,   1.6703126E-04
     +,   1.4918095E-04,   1.3321433E-04,   1.1892126E-04
     +,   1.0611746E-04,   9.4642455E-05,   8.4354018E-05
     +,   7.5126940E-05,   6.6851382E-05,   5.9430051E-05
     +,   5.2776166E-05,   4.6812620E-05,   4.1470979E-05
     +,   3.6689955E-05,   3.2414246E-05,   2.8594141E-05
     +,   2.5185027E-05,   2.2146573E-05,   1.9442045E-05
     +,   1.7038166E-05,   1.4904970E-05,   1.3014995E-05
     +,   1.1343337E-05,   9.8674636E-06,   8.5669044E-06
     +,   7.4229793E-06,   6.4187820E-06,   5.5390537E-06
     +,   4.7699891E-06,   4.0990572E-06,   3.5149824E-06
     +,   3.0076612E-06,   2.5679612E-06,   2.1877509E-06
     +,   1.8597079E-06,   1.5773456E-06,   1.3348513E-06
     +,   1.1270996E-06,   9.4951940E-07,   7.9810223E-07
     +,   6.6929374E-07,   5.5998896E-07,   4.6745561E-07
     +,   3.8930852E-07,   3.2347589E-07,   2.6814939E-07
     +,   2.2176947E-07,   1.8298236E-07,   1.5062686E-07
     +,   1.2370134E-07,   1.0135131E-07,   8.2843940E-08
     +,   6.7557302E-08,   5.4961340E-08,   4.4608900E-08
     +,   3.6120809E-08,   2.9179054E-08
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_asha_hatt85_mass = Yx/22.3853197647059
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_asha_hatt90_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.4762333E-04,   1.6007719E-04
     +,   1.7331605E-04,   1.8736250E-04,   2.0223719E-04
     +,   2.1795835E-04,   2.3454163E-04,   2.5199959E-04
     +,   2.7034123E-04,   2.8957287E-04,   3.0969596E-04
     +,   3.3070816E-04,   3.5260234E-04,   3.7536692E-04
     +,   3.9898502E-04,   4.2343463E-04,   4.4868834E-04
     +,   4.7471310E-04,   5.0147012E-04,   5.2891462E-04
     +,   5.5699644E-04,   5.8565923E-04,   6.1484042E-04
     +,   6.4447412E-04,   6.7448529E-04,   7.0479728E-04
     +,   7.3532650E-04,   7.6598552E-04,   7.9668290E-04
     +,   8.2732365E-04,   8.5780967E-04,   8.8804058E-04
     +,   9.1791456E-04,   9.4732887E-04,   9.7618083E-04
     +,   1.0043681E-03,   1.0317903E-03,   1.0583493E-03
     +,   1.0839530E-03,   1.1085100E-03,   1.1319383E-03
     +,   1.1541613E-03,   1.1751103E-03,   1.1947273E-03
     +,   1.2129635E-03,   1.2297831E-03,   1.2451634E-03
     +,   1.2590965E-03,   1.2715912E-03,   1.2826733E-03
     +,   1.2923902E-03,   1.3008086E-03,   1.3080202E-03
     +,   1.3141416E-03,   1.3193161E-03,   1.3237178E-03
     +,   1.3275528E-03,   1.3310604E-03,   1.3345174E-03
     +,   1.3382396E-03,   1.3425843E-03,   1.3479516E-03
     +,   1.3547863E-03,   1.3635812E-03,   1.3748759E-03
     +,   1.3892564E-03,   1.4073588E-03,   1.4298612E-03
     +,   1.4574879E-03,   1.4909996E-03,   1.5311930E-03
     +,   1.5788882E-03,   1.6349277E-03,   1.7001559E-03
     +,   1.7754182E-03,   1.8615434E-03,   1.9593230E-03
     +,   2.0694972E-03,   2.1927503E-03,   2.3296836E-03
     +,   2.4807863E-03,   2.6464504E-03,   2.8269156E-03
     +,   3.0223012E-03,   3.2325471E-03,   3.4574587E-03
     +,   3.6966491E-03,   3.9495998E-03,   4.2156074E-03
     +,   4.4938484E-03,   4.7833836E-03,   5.0831535E-03
     +,   5.3920378E-03,   5.7089077E-03,   6.0326550E-03
     +,   6.3622049E-03,   6.6966573E-03,   7.0352494E-03
     +,   7.3775197E-03,   7.7232844E-03,   8.0728093E-03
     +,   8.4267920E-03,   8.7865526E-03,   9.1540124E-03
     +,   9.5318807E-03,   9.9236984E-03,   1.0333890E-02
     +,   1.0767873E-02,   1.1232082E-02,   1.1733983E-02
     +,   1.2281928E-02,   1.2885123E-02,   1.3553252E-02
     +,   1.4296228E-02,   1.5123533E-02,   1.6043764E-02
     +,   1.7063662E-02,   1.8187515E-02,   1.9416068E-02
     +,   2.0746036E-02,   2.2169434E-02,   2.3673275E-02
     +,   2.5239863E-02,   2.6847661E-02,   2.8472492E-02
     +,   3.0089341E-02,   3.1675059E-02,   3.3210728E-02
     +,   3.4684934E-02,   3.6096212E-02,   3.7456069E-02
     +,   3.8791247E-02,   4.0146500E-02,   4.1587234E-02
     +,   4.3203373E-02,   4.5113128E-02,   4.7465988E-02
     +,   5.0441790E-02,   5.4241769E-02,   5.9066705E-02
     +,   6.5080434E-02,   7.2365880E-02,   8.0888510E-02
     +,   9.0490587E-02,   0.1009395    ,   0.1120483    
     +,   0.1238519    ,   0.1368000    ,   0.1519005    
     +,   0.1707342    ,   0.1952807    ,   0.2275370    
     +,   0.2690209    ,   0.3204637    ,   0.3822988    
     +,   0.4570623    ,   0.5557917    ,   0.7052615    
     +,   0.9370492    ,    1.260543    ,    1.669680    
     +,    2.148964    ,    2.723412    ,    3.627994    
     +,    4.710855    ,    5.704793    ,    6.537896    
     +,    7.321033    ,    7.181213    ,    6.835293    
     +,    6.256271    ,    5.600356    ,    4.677462    
     +,    3.738696    ,    3.070529    ,    2.467019    
     +,    1.907635    ,    1.506083    ,    1.267613    
     +,    1.115761    ,   0.9974540    ,   0.8923773    
     +,   0.7893665    ,   0.6807151    ,   0.5697431    
     +,   0.4684963    ,   0.3865282    ,   0.3255433    
     +,   0.2818401    ,   0.2504481    ,   0.2272624    
     +,   0.2092920    ,   0.1943551    ,   0.1809025    
     +,   0.1679586    ,   0.1550326    ,   0.1419859    
     +,   0.1288962    ,   0.1159536    ,   0.1033893    
     +,   9.1427997E-02,   8.0254771E-02,   6.9997594E-02
     +,   6.0724478E-02,   5.2450992E-02,   4.5150738E-02
     +,   3.8769569E-02,   3.3237085E-02,   2.8474124E-02
     +,   2.4397912E-02,   2.0925982E-02,   1.7978923E-02
     +,   1.5482028E-02,   1.3366729E-02,   1.1571852E-02
     +,   1.0044203E-02,   8.7383883E-03,   7.6163253E-03
     +,   6.6466527E-03,   5.8039366E-03,   5.0675832E-03
     +,   4.4210982E-03,   3.8513436E-03,   3.3478106E-03
     +,   2.9020396E-03,   2.5071872E-03,   2.1576688E-03
     +,   1.8488179E-03,   1.5766347E-03,   1.3376230E-03
     +,   1.1286691E-03,   9.4692339E-04,   7.8972639E-04
     +,   6.5458537E-04,   5.3916377E-04,   4.4124664E-04
     +,   3.5875695E-04,   2.8976388E-04,   2.3248128E-04
     +,   1.8527076E-04,   1.4664978E-04,   1.1529289E-04
     +,   9.0025547E-05,   6.9817215E-05,   5.3775791E-05
     +,   4.1137831E-05,   3.1255873E-05,   2.3586119E-05
     +,   1.7677285E-05,   1.3158958E-05,   9.7291704E-06
     +,   7.1446329E-06,   5.2112723E-06,   3.7755358E-06
     +,   2.7169785E-06,   1.9420825E-06,   1.3789025E-06
     +,   9.7251143E-07,   6.8131965E-07,   4.7413494E-07
     +,   3.2776080E-07,   2.2507352E-07,   1.5353318E-07
     +,   1.0403682E-07,   7.0031106E-08,   4.6828401E-08
     +,   3.1105429E-08,   2.0524702E-08,   1.3453517E-08
     +,   8.7600291E-09,   5.6660028E-09,   3.6404304E-09
     +,   2.3234661E-09,   1.4730468E-09,   9.2764713E-10
     +,   5.8028776E-10,   3.6056164E-10,   2.2253552E-10
     +,   1.3642168E-10,   8.3069142E-11,   5.0239830E-11
     +,   3.0179845E-11,   1.8006334E-11,   1.0670441E-11
     +,   6.2800967E-12,   3.6710223E-12,   2.1312340E-12
     +,   1.2288079E-12,   7.0364927E-13,   4.0015219E-13
     +,   2.2599694E-13,   1.2675580E-13,   7.0603916E-14
     +,   3.9054192E-14,   2.1453313E-14,   1.1702730E-14
     +,   6.3395567E-15,   3.4102673E-15,   1.8217544E-15
     +,   9.6635882E-16,   5.0903816E-16
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_asha_hatt90_mass = Yx/22.3103946470588
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_asha_hatt95_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  7.6140190E-05,   8.5524567E-05
     +,   9.5856645E-05,   1.0720262E-04,   1.1962942E-04
     +,   1.3320432E-04,   1.4799440E-04,   1.6406574E-04
     +,   1.8148287E-04,   2.0030892E-04,   2.2060322E-04
     +,   2.4242203E-04,   2.6581710E-04,   2.9083528E-04
     +,   3.1751752E-04,   3.4589856E-04,   3.7600577E-04
     +,   4.0785925E-04,   4.4147039E-04,   4.7684251E-04
     +,   5.1396957E-04,   5.5283640E-04,   5.9341791E-04
     +,   6.3568266E-04,   6.7958486E-04,   7.2507490E-04
     +,   7.7209243E-04,   8.2056923E-04,   8.7043061E-04
     +,   9.2159602E-04,   9.7397919E-04,   1.0274901E-03
     +,   1.0820369E-03,   1.1375260E-03,   1.1938645E-03
     +,   1.2509616E-03,   1.3087305E-03,   1.3670886E-03
     +,   1.4259663E-03,   1.4852941E-03,   1.5450225E-03
     +,   1.6051111E-03,   1.6655348E-03,   1.7262864E-03
     +,   1.7873765E-03,   1.8488362E-03,   1.9107179E-03
     +,   1.9730979E-03,   2.0360763E-03,   2.0997776E-03
     +,   2.1643520E-03,   2.2299762E-03,   2.2968501E-03
     +,   2.3652036E-03,   2.4352828E-03,   2.5073623E-03
     +,   2.5817314E-03,   2.6586985E-03,   2.7385817E-03
     +,   2.8217088E-03,   2.9084084E-03,   2.9990056E-03
     +,   3.0938091E-03,   3.1931133E-03,   3.2971881E-03
     +,   3.4062534E-03,   3.5204962E-03,   3.6400317E-03
     +,   3.7649246E-03,   3.8951484E-03,   4.0306086E-03
     +,   4.1710995E-03,   4.3163369E-03,   4.4659157E-03
     +,   4.6193395E-03,   4.7760089E-03,   4.9352162E-03
     +,   5.0961548E-03,   5.2579483E-03,   5.4196576E-03
     +,   5.5802665E-03,   5.7387585E-03,   5.8940914E-03
     +,   6.0452665E-03,   6.1913216E-03,   6.3314047E-03
     +,   6.4647617E-03,   6.5908181E-03,   6.7091668E-03
     +,   6.8196310E-03,   6.9222739E-03,   7.0174173E-03
     +,   7.1056532E-03,   7.1878596E-03,   7.2651855E-03
     +,   7.3390217E-03,   7.4110054E-03,   7.4829427E-03
     +,   7.5567891E-03,   7.6345629E-03,   7.7183060E-03
     +,   7.8099770E-03,   7.9114083E-03,   8.0242008E-03
     +,   8.1496798E-03,   8.2888259E-03,   8.4422249E-03
     +,   8.6100502E-03,   8.7920716E-03,   8.9876791E-03
     +,   9.1959145E-03,   9.4156014E-03,   9.6454015E-03
     +,   9.8840101E-03,   1.0130242E-02,   1.0383260E-02
     +,   1.0642655E-02,   1.0908660E-02,   1.1182176E-02
     +,   1.1464902E-02,   1.1759318E-02,   1.2068571E-02
     +,   1.2396364E-02,   1.2746766E-02,   1.3123893E-02
     +,   1.3531510E-02,   1.3972802E-02,   1.4449839E-02
     +,   1.4963419E-02,   1.5512666E-02,   1.6095076E-02
     +,   1.6706383E-02,   1.7340932E-02,   1.7991895E-02
     +,   1.8651992E-02,   1.9314108E-02,   1.9972077E-02
     +,   2.0621523E-02,   2.1260791E-02,   2.1891586E-02
     +,   2.2519613E-02,   2.3155069E-02,   2.3812979E-02
     +,   2.4513256E-02,   2.5280487E-02,   2.6143683E-02
     +,   2.7135460E-02,   2.8290836E-02,   2.9645585E-02
     +,   3.1234056E-02,   3.3086225E-02,   3.5224367E-02
     +,   3.7659697E-02,   4.0389717E-02,   4.3396499E-02
     +,   4.6646535E-02,   5.0093513E-02,   5.3683680E-02
     +,   5.7362948E-02,   6.1085738E-02,   6.4826146E-02
     +,   6.8590023E-02,   7.2432205E-02,   7.6482251E-02
     +,   8.0984287E-02,   8.6347893E-02,   9.3195930E-02
     +,   0.1023716    ,   0.1148449    ,   0.1314665    
     +,   0.1525823    ,   0.1776617    ,   0.2052114    
     +,   0.2332615    ,   0.2606430    ,   0.2892079    
     +,   0.3265767    ,   0.3867745    ,   0.4846703    
     +,   0.6306261    ,   0.8422980    ,    1.165599    
     +,    1.678351    ,    2.422326    ,    3.421770    
     +,    4.512430    ,    5.750323    ,    7.544188    
     +,    8.695991    ,    9.354228    ,    8.834910    
     +,    7.370932    ,    5.784106    ,    4.631908    
     +,    3.544703    ,    2.525820    ,    1.821343    
     +,    1.315361    ,   0.9234840    ,   0.6659166    
     +,   0.5121458    ,   0.4178195    ,   0.3522594    
     +,   0.2996679    ,   0.2543539    ,   0.2145976    
     +,   0.1796349    ,   0.1489671    ,   0.1222335    
     +,   9.9140368E-02,   7.9429209E-02,   6.2857598E-02
     +,   4.9172428E-02,   3.8086310E-02,   2.9273942E-02
     +,   2.2387560E-02,   1.7081602E-02,   1.3036365E-02
     +,   9.9739889E-03,   7.6645846E-03,   5.9243529E-03
     +,   4.6106325E-03,   3.6149700E-03,   2.8560348E-03
     +,   2.2734285E-03,   1.8226372E-03,   1.4709722E-03
     +,   1.1943959E-03,   9.7516162E-04,   8.0010394E-04
     +,   6.5938092E-04,   5.4555078E-04,   4.5292490E-04
     +,   3.7712211E-04,   3.1474835E-04,   2.6314930E-04
     +,   2.2024690E-04,   1.8441261E-04,   1.5436333E-04
     +,   1.2908348E-04,   1.0776639E-04,   8.9767702E-05
     +,   7.4566175E-05,   6.1734681E-05,   5.0919996E-05
     +,   4.1826803E-05,   3.4204757E-05,   2.7839207E-05
     +,   2.2545342E-05,   1.8163637E-05,   1.4555123E-05
     +,   1.1599224E-05,   9.1916318E-06,   7.2421230E-06
     +,   5.6729555E-06,   4.4176350E-06,   3.4196846E-06
     +,   2.6313735E-06,   2.0126101E-06,   1.5300354E-06
     +,   1.1561152E-06,   8.6827094E-07,   6.4811803E-07
     +,   4.8082632E-07,   3.5453797E-07,   2.5981902E-07
     +,   1.8923681E-07,   1.3698408E-07,   9.8552540E-08
     +,   7.0468239E-08,   5.0077301E-08,   3.5368409E-08
     +,   2.4826797E-08,   1.7320186E-08,   1.2008949E-08
     +,   8.2753893E-09,   5.6675149E-09,   3.8576937E-09
     +,   2.6096527E-09,   1.7545624E-09,   1.1723972E-09
     +,   7.7859630E-10,   5.1388943E-10,   3.3709951E-10
     +,   2.1976901E-10,   1.4239863E-10,   9.1700487E-11
     +,   5.8688984E-11,   3.7331253E-11,   2.3599830E-11
     +,   1.4827781E-11,   9.2589755E-12,   5.7462112E-12
     +,   3.5442120E-12,   2.1726494E-12,   1.3236630E-12
     +,   8.0149272E-13,   4.8232382E-13,   2.8847657E-13
     +,   1.7147510E-13,   1.0130364E-13
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_asha_hatt95_mass = Yx/21.3075507647059
      RETURN
      END
C 
C---- New file --- 
C 
      DOUBLE PRECISION FUNCTION A202_tt_ashz_htt100_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.0260579E-03,   1.0408012E-03
     +,   1.0552504E-03,   1.0694063E-03,   1.0832718E-03
     +,   1.0968528E-03,   1.1101577E-03,   1.1231983E-03
     +,   1.1359887E-03,   1.1485470E-03,   1.1608937E-03
     +,   1.1730535E-03,   1.1850544E-03,   1.1969272E-03
     +,   1.2087077E-03,   1.2204347E-03,   1.2321507E-03
     +,   1.2439024E-03,   1.2557398E-03,   1.2677182E-03
     +,   1.2798950E-03,   1.2923321E-03,   1.3050957E-03
     +,   1.3182553E-03,   1.3318838E-03,   1.3460576E-03
     +,   1.3608572E-03,   1.3763641E-03,   1.3926643E-03
     +,   1.4098465E-03,   1.4279999E-03,   1.4472179E-03
     +,   1.4675928E-03,   1.4892204E-03,   1.5121959E-03
     +,   1.5366145E-03,   1.5625714E-03,   1.5901605E-03
     +,   1.6194759E-03,   1.6506073E-03,   1.6836439E-03
     +,   1.7186711E-03,   1.7557695E-03,   1.7950174E-03
     +,   1.8364865E-03,   1.8802447E-03,   1.9263519E-03
     +,   1.9748637E-03,   2.0258278E-03,   2.0792850E-03
     +,   2.1352686E-03,   2.1938046E-03,   2.2549084E-03
     +,   2.3185944E-03,   2.3848584E-03,   2.4536978E-03
     +,   2.5250982E-03,   2.5990375E-03,   2.6754879E-03
     +,   2.7544142E-03,   2.8357764E-03,   2.9195303E-03
     +,   3.0056217E-03,   3.0940014E-03,   3.1846175E-03
     +,   3.2774084E-03,   3.3723256E-03,   3.4693116E-03
     +,   3.5683226E-03,   3.6693090E-03,   3.7722406E-03
     +,   3.8770831E-03,   3.9838268E-03,   4.0924577E-03
     +,   4.2029927E-03,   4.3154578E-03,   4.4298950E-03
     +,   4.5463638E-03,   4.6649552E-03,   4.7857794E-03
     +,   4.9089612E-03,   5.0346684E-03,   5.1630763E-03
     +,   5.2944077E-03,   5.4288935E-03,   5.5668093E-03
     +,   5.7084425E-03,   5.8541228E-03,   6.0041901E-03
     +,   6.1590192E-03,   6.3190069E-03,   6.4845639E-03
     +,   6.6561089E-03,   6.8340939E-03,   7.0189722E-03
     +,   7.2111902E-03,   7.4112192E-03,   7.6194969E-03
     +,   7.8364853E-03,   8.0626039E-03,   8.2982760E-03
     +,   8.5438853E-03,   8.7998081E-03,   9.0663591E-03
     +,   9.3438411E-03,   9.6325176E-03,   9.9325832E-03
     +,   1.0244192E-02,   1.0567454E-02,   1.0902427E-02
     +,   1.1249095E-02,   1.1607416E-02,   1.1977243E-02
     +,   1.2358442E-02,   1.2750771E-02,   1.3154015E-02
     +,   1.3567871E-02,   1.3992107E-02,   1.4426447E-02
     +,   1.4870723E-02,   1.5324863E-02,   1.5788918E-02
     +,   1.6263146E-02,   1.6748140E-02,   1.7244831E-02
     +,   1.7754573E-02,   1.8279351E-02,   1.8821692E-02
     +,   1.9384980E-02,   1.9973319E-02,   2.0591794E-02
     +,   2.1246316E-02,   2.1943748E-02,   2.2691693E-02
     +,   2.3498453E-02,   2.4372758E-02,   2.5323333E-02
     +,   2.6358519E-02,   2.7485849E-02,   2.8711377E-02
     +,   3.0038917E-02,   3.1469483E-02,   3.3000711E-02
     +,   3.4626253E-02,   3.6335148E-02,   3.8111977E-02
     +,   3.9936669E-02,   4.1784678E-02,   4.3627724E-02
     +,   4.5434747E-02,   4.7173068E-02,   4.8809662E-02
     +,   5.0312761E-02,   5.1653687E-02,   5.2808411E-02
     +,   5.3758878E-02,   5.4494437E-02,   5.5012845E-02
     +,   5.5320777E-02,   5.5433877E-02,   5.5376779E-02
     +,   5.5182144E-02,   5.4889895E-02,   5.4545850E-02
     +,   5.4200292E-02,   5.3906374E-02,   5.3718649E-02
     +,   5.3691588E-02,   5.3877890E-02,   5.4327104E-02
     +,   5.5084243E-02,   5.6187861E-02,   5.7668597E-02
     +,   5.9547808E-02,   6.1836518E-02,   6.4536855E-02
     +,   6.7646138E-02,   7.1165711E-02,   7.5116381E-02
     +,   7.9560786E-02,   8.4630869E-02,   9.0555660E-02
     +,   9.7681016E-02,   0.1064699    ,   0.1174683    
     +,   0.1312328    ,   0.1482327    ,   0.1687649    
     +,   0.1929347    ,   0.2207528    ,   0.2523535    
     +,   0.2882378    ,   0.3293926    ,   0.3771376    
     +,   0.4326604    ,   0.4964089    ,   0.5678115    
     +,   0.6458914    ,   0.7308462    ,   0.8255969    
     +,   0.9359454    ,    1.068667    ,    1.226959    
     +,    1.404561    ,    1.586643    ,    1.760735    
     +,    1.920949    ,    2.061644    ,    2.187513    
     +,    2.317475    ,    2.440873    ,    2.510135    
     +,    2.517349    ,    2.528099    ,    2.604571    
     +,    2.705567    ,    2.725273    ,    2.640087    
     +,    2.511171    ,    2.370439    ,    2.201502    
     +,    2.002816    ,    1.806392    ,    1.642592    
     +,    1.521463    ,    1.434403    ,    1.356750    
     +,    1.263178    ,    1.147750    ,    1.024332    
     +,   0.9100446    ,   0.8129624    ,   0.7325987    
     +,   0.6654288    ,   0.6079923    ,   0.5574040    
     +,   0.5114934    ,   0.4690772    ,   0.4298229    
     +,   0.3937207    ,   0.3606451    ,   0.3302822    
     +,   0.3022918    ,   0.2764550    ,   0.2526841    
     +,   0.2309324    ,   0.2110939    ,   0.1929608    
     +,   0.1762490    ,   0.1606565    ,   0.1459208    
     +,   0.1318594    ,   0.1183836    ,   0.1054882    
     +,   9.3227565E-02,   8.1689082E-02,   7.0967905E-02
     +,   6.1146244E-02,   5.2279603E-02,   4.4391979E-02
     +,   3.7475549E-02,   3.1493545E-02,   2.6385499E-02
     +,   2.2074483E-02,   1.8474095E-02,   1.5493705E-02
     +,   1.3044065E-02,   1.1041267E-02,   9.4091445E-03
     +,   8.0806566E-03,   6.9984836E-03,   6.1147818E-03
     +,   5.3902841E-03,   4.7931890E-03,   4.2980509E-03
     +,   3.8846734E-03,   3.5369624E-03,   3.2421718E-03
     +,   2.9900917E-03,   2.7725725E-03,   2.5830232E-03
     +,   2.4161413E-03,   2.2676208E-03,   2.1340009E-03
     +,   2.0124789E-03,   1.9008336E-03,   1.7972935E-03
     +,   1.7004728E-03,   1.6093072E-03,   1.5229781E-03
     +,   1.4408807E-03,   1.3625617E-03,   1.2877013E-03
     +,   1.2160647E-03,   1.1474951E-03,   1.0818749E-03
     +,   1.0191281E-03,   9.5919037E-04,   9.0201630E-04
     +,   8.4755657E-04,   7.9576892E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_ashz_htt100_mass = Yx/17.86549086
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_ashz_htt105_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  7.5886090E-04,   7.7386585E-04
     +,   7.8873488E-04,   8.0346467E-04,   8.1805402E-04
     +,   8.3250256E-04,   8.4681192E-04,   8.6098531E-04
     +,   8.7502738E-04,   8.8894449E-04,   9.0274453E-04
     +,   9.1643684E-04,   9.3003211E-04,   9.4354240E-04
     +,   9.5698133E-04,   9.7036338E-04,   9.8370423E-04
     +,   9.9702075E-04,   1.0103304E-03,   1.0236514E-03
     +,   1.0370027E-03,   1.0504038E-03,   1.0638738E-03
     +,   1.0774336E-03,   1.0911014E-03,   1.1048985E-03
     +,   1.1188431E-03,   1.1329545E-03,   1.1472511E-03
     +,   1.1617503E-03,   1.1764686E-03,   1.1914219E-03
     +,   1.2066248E-03,   1.2220914E-03,   1.2378332E-03
     +,   1.2538624E-03,   1.2701885E-03,   1.2868198E-03
     +,   1.3037660E-03,   1.3210317E-03,   1.3386242E-03
     +,   1.3565484E-03,   1.3748090E-03,   1.3934110E-03
     +,   1.4123592E-03,   1.4316586E-03,   1.4513156E-03
     +,   1.4713384E-03,   1.4917364E-03,   1.5125222E-03
     +,   1.5337112E-03,   1.5553235E-03,   1.5773823E-03
     +,   1.5999188E-03,   1.6229680E-03,   1.6465746E-03
     +,   1.6707894E-03,   1.6956733E-03,   1.7212979E-03
     +,   1.7477451E-03,   1.7751078E-03,   1.8034948E-03
     +,   1.8330243E-03,   1.8638327E-03,   1.8960715E-03
     +,   1.9299042E-03,   1.9655155E-03,   2.0031016E-03
     +,   2.0428796E-03,   2.0850780E-03,   2.1299475E-03
     +,   2.1777472E-03,   2.2287553E-03,   2.2832588E-03
     +,   2.3415601E-03,   2.4039715E-03,   2.4708088E-03
     +,   2.5423924E-03,   2.6190476E-03,   2.7011053E-03
     +,   2.7888760E-03,   2.8826806E-03,   2.9828153E-03
     +,   3.0895751E-03,   3.2032251E-03,   3.3240214E-03
     +,   3.4521823E-03,   3.5879170E-03,   3.7313879E-03
     +,   3.8827388E-03,   4.0420815E-03,   4.2094844E-03
     +,   4.3849833E-03,   4.5685885E-03,   4.7602798E-03
     +,   4.9599898E-03,   5.1676421E-03,   5.3831167E-03
     +,   5.6062909E-03,   5.8369967E-03,   6.0750814E-03
     +,   6.3203485E-03,   6.5726275E-03,   6.8317060E-03
     +,   7.0973989E-03,   7.3695136E-03,   7.6478417E-03
     +,   7.9321750E-03,   8.2223173E-03,   8.5180653E-03
     +,   8.8191759E-03,   9.1254236E-03,   9.4365142E-03
     +,   9.7521637E-03,   1.0071993E-02,   1.0395608E-02
     +,   1.0722499E-02,   1.1052129E-02,   1.1383810E-02
     +,   1.1716806E-02,   1.2050255E-02,   1.2383168E-02
     +,   1.2714437E-02,   1.3042878E-02,   1.3367179E-02
     +,   1.3685914E-02,   1.3997623E-02,   1.4300741E-02
     +,   1.4593691E-02,   1.4874890E-02,   1.5142784E-02
     +,   1.5395871E-02,   1.5632790E-02,   1.5852293E-02
     +,   1.6053366E-02,   1.6235197E-02,   1.6397277E-02
     +,   1.6539413E-02,   1.6661774E-02,   1.6764916E-02
     +,   1.6849816E-02,   1.6917892E-02,   1.6971018E-02
     +,   1.7011525E-02,   1.7042195E-02,   1.7066281E-02
     +,   1.7087460E-02,   1.7109809E-02,   1.7137812E-02
     +,   1.7176297E-02,   1.7230412E-02,   1.7305577E-02
     +,   1.7407436E-02,   1.7541841E-02,   1.7714769E-02
     +,   1.7932290E-02,   1.8200496E-02,   1.8525429E-02
     +,   1.8913057E-02,   1.9369064E-02,   1.9898854E-02
     +,   2.0507371E-02,   2.1198884E-02,   2.1976827E-02
     +,   2.2843694E-02,   2.3800701E-02,   2.4847578E-02
     +,   2.5982350E-02,   2.7201295E-02,   2.8498759E-02
     +,   2.9867062E-02,   3.1296652E-02,   3.2776497E-02
     +,   3.4294382E-02,   3.5837404E-02,   3.7393037E-02
     +,   3.8949974E-02,   4.0499128E-02,   4.2035010E-02
     +,   4.3557066E-02,   4.5070805E-02,   4.6589106E-02
     +,   4.8133370E-02,   4.9734659E-02,   5.1434912E-02
     +,   5.3287849E-02,   5.5360537E-02,   5.7735108E-02
     +,   6.0509991E-02,   6.3800514E-02,   6.7738734E-02
     +,   7.2469905E-02,   7.8144133E-02,   8.4903717E-02
     +,   9.2865296E-02,   0.1020966    ,   0.1125924    
     +,   0.1242534    ,   0.1368769    ,   0.1501591    
     +,   0.1637202    ,   0.1771606    ,   0.1901473    
     +,   0.2025302    ,   0.2144710    ,   0.2265594    
     +,   0.2398591    ,   0.2558267    ,   0.2760668    
     +,   0.3019384    ,   0.3341199    ,   0.3723705    
     +,   0.4157664    ,   0.4634910    ,   0.5158030    
     +,   0.5743860    ,   0.6413917    ,   0.7174640    
     +,   0.8004820    ,   0.8874836    ,   0.9799030    
     +,    1.086271    ,    1.216924    ,    1.378060    
     +,    1.574005    ,    1.804113    ,    2.044243    
     +,    2.242737    ,    2.362716    ,    2.440992    
     +,    2.556068    ,    2.707361    ,    2.814492    
     +,    2.827261    ,    2.766593    ,    2.708526    
     +,    2.677613    ,    2.607695    ,    2.477746    
     +,    2.327197    ,    2.181605    ,    2.051834    
     +,    1.928800    ,    1.788972    ,    1.628598    
     +,    1.462657    ,    1.303923    ,    1.156867    
     +,    1.019533    ,   0.8874470    ,   0.7590620    
     +,   0.6378011    ,   0.5290916    ,   0.4363981    
     +,   0.3597001    ,   0.2965172    ,   0.2437401    
     +,   0.1988567    ,   0.1603118    ,   0.1273476    
     +,   9.9649385E-02,   7.6991655E-02,   5.9007376E-02
     +,   4.5128133E-02,   3.4649983E-02,   2.6842771E-02
     +,   2.1045772E-02,   1.6717646E-02,   1.3445916E-02
     +,   1.0932500E-02,   8.9696888E-03,   7.4152583E-03
     +,   6.1714095E-03,   5.1692426E-03,   4.3583848E-03
     +,   3.7004538E-03,   3.1650139E-03,   2.7275730E-03
     +,   2.3681873E-03,   2.0708025E-03,   1.8225727E-03
     +,   1.6134266E-03,   1.4355301E-03,   1.2828961E-03
     +,   1.1509375E-03,   1.0361659E-03,   9.3587913E-04
     +,   8.4795762E-04,   7.7070814E-04,   7.0272683E-04
     +,   6.4283895E-04,   5.9002661E-04,   5.4340909E-04
     +,   5.0220569E-04,   4.6573285E-04,   4.3338255E-04
     +,   4.0462357E-04,   3.7898603E-04,   3.5606307E-04
     +,   3.3549781E-04,   3.1698385E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_ashz_htt105_mass = Yx/17.3602791428571
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_ashz_htt107_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.9764704E-04,   5.1822717E-04
     +,   5.3913612E-04,   5.6035130E-04,   5.8184849E-04
     +,   6.0360308E-04,   6.2558975E-04,   6.4778188E-04
     +,   6.7015283E-04,   6.9267623E-04,   7.1532431E-04
     +,   7.3807023E-04,   7.6088676E-04,   7.8374718E-04
     +,   8.0662535E-04,   8.2949531E-04,   8.5233251E-04
     +,   8.7511307E-04,   8.9781411E-04,   9.2041440E-04
     +,   9.4289373E-04,   9.6523389E-04,   9.8741776E-04
     +,   1.0094320E-03,   1.0312622E-03,   1.0528989E-03
     +,   1.0743331E-03,   1.0955591E-03,   1.1165736E-03
     +,   1.1373750E-03,   1.1579650E-03,   1.1783482E-03
     +,   1.1985315E-03,   1.2185244E-03,   1.2383390E-03
     +,   1.2579913E-03,   1.2774995E-03,   1.2968841E-03
     +,   1.3161709E-03,   1.3353842E-03,   1.3545570E-03
     +,   1.3737199E-03,   1.3929100E-03,   1.4121659E-03
     +,   1.4315294E-03,   1.4510457E-03,   1.4707631E-03
     +,   1.4907322E-03,   1.5110074E-03,   1.5316458E-03
     +,   1.5527077E-03,   1.5742568E-03,   1.5963591E-03
     +,   1.6190859E-03,   1.6425076E-03,   1.6667009E-03
     +,   1.6917451E-03,   1.7177209E-03,   1.7447124E-03
     +,   1.7728070E-03,   1.8020924E-03,   1.8326623E-03
     +,   1.8646074E-03,   1.8980228E-03,   1.9330066E-03
     +,   1.9696523E-03,   2.0080602E-03,   2.0483225E-03
     +,   2.0905402E-03,   2.1348034E-03,   2.1812082E-03
     +,   2.2298417E-03,   2.2807925E-03,   2.3341407E-03
     +,   2.3899649E-03,   2.4483395E-03,   2.5093276E-03
     +,   2.5729872E-03,   2.6393707E-03,   2.7085259E-03
     +,   2.7804819E-03,   2.8552704E-03,   2.9329038E-03
     +,   3.0133948E-03,   3.0967379E-03,   3.1829292E-03
     +,   3.2719420E-03,   3.3637560E-03,   3.4583299E-03
     +,   3.5556222E-03,   3.6555892E-03,   3.7581702E-03
     +,   3.8633044E-03,   3.9709304E-03,   4.0809861E-03
     +,   4.1933963E-03,   4.3081027E-03,   4.4250293E-03
     +,   4.5441203E-03,   4.6653058E-03,   4.7885347E-03
     +,   4.9137459E-03,   5.0408971E-03,   5.1699383E-03
     +,   5.3008310E-03,   5.4335482E-03,   5.5680498E-03
     +,   5.7043065E-03,   5.8422941E-03,   5.9819897E-03
     +,   6.1233533E-03,   6.2663583E-03,   6.4109508E-03
     +,   6.5570856E-03,   6.7046811E-03,   6.8536615E-03
     +,   7.0038983E-03,   7.1552638E-03,   7.3075807E-03
     +,   7.4606463E-03,   7.6142177E-03,   7.7680037E-03
     +,   7.9216640E-03,   8.0748191E-03,   8.2270373E-03
     +,   8.3778193E-03,   8.5266354E-03,   8.6728791E-03
     +,   8.8159163E-03,   8.9550428E-03,   9.0895332E-03
     +,   9.2186080E-03,   9.3414681E-03,   9.4572837E-03
     +,   9.5652249E-03,   9.6644601E-03,   9.7541660E-03
     +,   9.8335510E-03,   9.9018682E-03,   9.9584274E-03
     +,   1.0002616E-02,   1.0033905E-02,   1.0051885E-02
     +,   1.0056259E-02,   1.0046874E-02,   1.0023730E-02
     +,   9.9869790E-03,   9.9369660E-03,   9.8742144E-03
     +,   9.7994301E-03,   9.7135194E-03,   9.6175876E-03
     +,   9.5129311E-03,   9.4010383E-03,   9.2835659E-03
     +,   9.1623534E-03,   9.0393927E-03,   8.9168092E-03
     +,   8.7968297E-03,   8.6817909E-03,   8.5740769E-03
     +,   8.4761074E-03,   8.3903130E-03,   8.3190994E-03
     +,   8.2648154E-03,   8.2297502E-03,   8.2161026E-03
     +,   8.2260035E-03,   8.2615046E-03,   8.3246455E-03
     +,   8.4174844E-03,   8.5422359E-03,   8.7013943E-03
     +,   8.8979490E-03,   9.1356412E-03,   9.4193304E-03
     +,   9.7554652E-03,   1.0152603E-02,   1.0622129E-02
     +,   1.1179063E-02,   1.1842973E-02,   1.2638817E-02
     +,   1.3597845E-02,   1.4758327E-02,   1.6165756E-02
     +,   1.7872315E-02,   1.9935571E-02,   2.2416135E-02
     +,   2.5373749E-02,   2.8861823E-02,   3.2921821E-02
     +,   3.7576303E-02,   4.2822052E-02,   4.8625126E-02
     +,   5.4918505E-02,   6.1602712E-02,   6.8550535E-02
     +,   7.5617835E-02,   8.2659326E-02,   8.9547344E-02
     +,   9.6193627E-02,   0.1025718    ,   0.1087358    
     +,   0.1148304    ,   0.1210873    ,   0.1278104    
     +,   0.1353454    ,   0.1440524    ,   0.1542973    
     +,   0.1664864    ,   0.1811417    ,   0.1989876    
     +,   0.2209741    ,   0.2481422    ,   0.2812896    
     +,   0.3205113    ,   0.3648503    ,   0.4123431    
     +,   0.4606383    ,   0.5080582    ,   0.5544360    
     +,   0.6007383    ,   0.6473235    ,   0.6926476    
     +,   0.7349476    ,   0.7763030    ,   0.8242590    
     +,   0.8877648    ,   0.9711681    ,    1.072131    
     +,    1.184870    ,    1.307299    ,    1.444248    
     +,    1.599560    ,    1.776472    ,    1.983756    
     +,    2.213832    ,    2.452722    ,    2.709700    
     +,    2.945847    ,    3.053746    ,    3.022414    
     +,    2.962362    ,    2.931939    ,    2.917024    
     +,    2.859931    ,    2.702599    ,    2.491442    
     +,    2.301242    ,    2.119162    ,    1.912050    
     +,    1.689233    ,    1.467701    ,    1.250944    
     +,    1.040309    ,   0.8419567    ,   0.6651272    
     +,   0.5170698    ,   0.3994675    ,   0.3087972    
     +,   0.2391374    ,   0.1849687    ,   0.1424448    
     +,   0.1091654    ,   8.3442308E-02,   6.3830093E-02
     +,   4.9029797E-02,   3.7931178E-02,   2.9637070E-02
     +,   2.3445224E-02,   1.8813020E-02,   1.5324100E-02
     +,   1.2662967E-02,   1.0595848E-02,   8.9546330E-03
     +,   7.6220143E-03,   6.5177968E-03,   5.5880710E-03
     +,   4.7962442E-03,   4.1170795E-03,   3.5323079E-03
     +,   3.0281779E-03,   2.5937071E-03,   2.2198746E-03
     +,   1.8989560E-03,   1.6242969E-03,   1.3900263E-03
     +,   1.1909601E-03,   1.0225188E-03,   8.8060967E-04
     +,   7.6161441E-04,   6.6230365E-04,   5.7982851E-04
     +,   5.1165989E-04,   4.5558019E-04,   4.0963892E-04
     +,   3.7214337E-04,   3.4162399E-04,   3.1682267E-04
     +,   2.9666483E-04,   2.8024599E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_ashz_htt107_mass = Yx/16.8083974285714
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_ashz_htt110_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  9.1280224E-04,   9.4554492E-04
     +,   9.7868522E-04,   1.0121827E-03,   1.0459947E-03
     +,   1.0800762E-03,   1.1143814E-03,   1.1488621E-03
     +,   1.1834678E-03,   1.2181490E-03,   1.2528526E-03
     +,   1.2875253E-03,   1.3221132E-03,   1.3565619E-03
     +,   1.3908155E-03,   1.4248193E-03,   1.4585182E-03
     +,   1.4918562E-03,   1.5247792E-03,   1.5572329E-03
     +,   1.5891648E-03,   1.6205230E-03,   1.6512562E-03
     +,   1.6813165E-03,   1.7106556E-03,   1.7392297E-03
     +,   1.7669951E-03,   1.7939111E-03,   1.8199397E-03
     +,   1.8450459E-03,   1.8691971E-03,   1.8923635E-03
     +,   1.9145195E-03,   1.9356416E-03,   1.9557106E-03
     +,   1.9747098E-03,   1.9926270E-03,   2.0094528E-03
     +,   2.0251824E-03,   2.0398130E-03,   2.0533476E-03
     +,   2.0657922E-03,   2.0771564E-03,   2.0874534E-03
     +,   2.0967005E-03,   2.1049196E-03,   2.1121348E-03
     +,   2.1183761E-03,   2.1236762E-03,   2.1280721E-03
     +,   2.1316046E-03,   2.1343196E-03,   2.1362656E-03
     +,   2.1374973E-03,   2.1380722E-03,   2.1380540E-03
     +,   2.1375092E-03,   2.1365103E-03,   2.1351348E-03
     +,   2.1334668E-03,   2.1315934E-03,   2.1296099E-03
     +,   2.1276153E-03,   2.1257168E-03,   2.1240285E-03
     +,   2.1226702E-03,   2.1217684E-03,   2.1214588E-03
     +,   2.1218827E-03,   2.1231903E-03,   2.1255396E-03
     +,   2.1290951E-03,   2.1340309E-03,   2.1405267E-03
     +,   2.1487726E-03,   2.1589631E-03,   2.1713011E-03
     +,   2.1859922E-03,   2.2032531E-03,   2.2233024E-03
     +,   2.2463591E-03,   2.2726501E-03,   2.3023998E-03
     +,   2.3358348E-03,   2.3731776E-03,   2.4146507E-03
     +,   2.4604676E-03,   2.5108410E-03,   2.5659681E-03
     +,   2.6260419E-03,   2.6912449E-03,   2.7617398E-03
     +,   2.8376756E-03,   2.9191913E-03,   3.0064057E-03
     +,   3.0994150E-03,   3.1983068E-03,   3.3031381E-03
     +,   3.4139596E-03,   3.5307910E-03,   3.6536492E-03
     +,   3.7825189E-03,   3.9173882E-03,   4.0582153E-03
     +,   4.2049601E-03,   4.3575759E-03,   4.5160041E-03
     +,   4.6801749E-03,   4.8500332E-03,   5.0255293E-03
     +,   5.2065938E-03,   5.3931898E-03,   5.5852612E-03
     +,   5.7827807E-03,   5.9857038E-03,   6.1940160E-03
     +,   6.4076758E-03,   6.6266712E-03,   6.8509500E-03
     +,   7.0804777E-03,   7.3151966E-03,   7.5550191E-03
     +,   7.7998159E-03,   8.0494415E-03,   8.3037037E-03
     +,   8.5623357E-03,   8.8250404E-03,   9.0914275E-03
     +,   9.3610687E-03,   9.6334293E-03,   9.9079367E-03
     +,   1.0183911E-02,   1.0460635E-02,   1.0737299E-02
     +,   1.1013054E-02,   1.1287016E-02,   1.1558236E-02
     +,   1.1825741E-02,   1.2088582E-02,   1.2345809E-02
     +,   1.2596477E-02,   1.2839683E-02,   1.3074616E-02
     +,   1.3300504E-02,   1.3516669E-02,   1.3722542E-02
     +,   1.3917660E-02,   1.4101667E-02,   1.4274337E-02
     +,   1.4435574E-02,   1.4585414E-02,   1.4724008E-02
     +,   1.4851644E-02,   1.4968734E-02,   1.5075827E-02
     +,   1.5173581E-02,   1.5262798E-02,   1.5344413E-02
     +,   1.5419517E-02,   1.5489350E-02,   1.5555356E-02
     +,   1.5619188E-02,   1.5682740E-02,   1.5748192E-02
     +,   1.5818076E-02,   1.5895277E-02,   1.5983127E-02
     +,   1.6085435E-02,   1.6206546E-02,   1.6351398E-02
     +,   1.6525507E-02,   1.6735058E-02,   1.6986912E-02
     +,   1.7288592E-02,   1.7648261E-02,   1.8074766E-02
     +,   1.8577611E-02,   1.9166909E-02,   1.9853458E-02
     +,   2.0648861E-02,   2.1565650E-02,   2.2617454E-02
     +,   2.3819372E-02,   2.5188489E-02,   2.6744310E-02
     +,   2.8509142E-02,   3.0508615E-02,   3.2772094E-02
     +,   3.5332602E-02,   3.8226075E-02,   4.1490875E-02
     +,   4.5165896E-02,   4.9287654E-02,   5.3887349E-02
     +,   5.8986895E-02,   6.4594150E-02,   7.0698202E-02
     +,   7.7266105E-02,   8.4242456E-02,   9.1552086E-02
     +,   9.9108271E-02,   0.1068276    ,   0.1146500    
     +,   0.1225599    ,   0.1306021    ,   0.1388892    
     +,   0.1475894    ,   0.1568959    ,   0.1669844    
     +,   0.1779743    ,   0.1899062    ,   0.2027568    
     +,   0.2164820    ,   0.2310715    ,   0.2465672    
     +,   0.2630278    ,   0.2804421    ,   0.2986500    
     +,   0.3173369    ,   0.3361304    ,   0.3547670    
     +,   0.3732110    ,   0.3916460    ,   0.4103744    
     +,   0.4297523    ,   0.4503280    ,   0.4732269    
     +,   0.5005944    ,   0.5357478    ,   0.5827534    
     +,   0.6454222    ,   0.7258664    ,   0.8227833    
     +,   0.9298384    ,    1.034681    ,    1.119720    
     +,    1.168496    ,    1.181272    ,    1.188982    
     +,    1.241720    ,    1.371068    ,    1.564634    
     +,    1.781888    ,    1.990700    ,    2.181581    
     +,    2.349578    ,    2.485207    ,    2.591569    
     +,    2.677133    ,    2.737911    ,    2.787393    
     +,    2.853472    ,    2.896095    ,    2.801894    
     +,    2.533913    ,    2.191473    ,    1.870705    
     +,    1.579113    ,    1.296990    ,    1.031022    
     +,   0.8006433    ,   0.6147676    ,   0.4702254    
     +,   0.3595531    ,   0.2753762    ,   0.2112551    
     +,   0.1619536    ,   0.1236807    ,   9.3954369E-02
     +,   7.1126223E-02,   5.3908408E-02,   4.1128315E-02
     +,   3.1706676E-02,   2.4730179E-02,   1.9501479E-02
     +,   1.5529025E-02,   1.2477065E-02,   1.0113232E-02
     +,   8.2684569E-03,   6.8152980E-03,   5.6563020E-03
     +,   4.7183544E-03,   3.9477972E-03,   3.3063681E-03
     +,   2.7669885E-03,   2.3105219E-03,   1.9230347E-03
     +,   1.5940175E-03,   1.3151985E-03,   1.0797206E-03
     +,   8.8176073E-04,   7.1620842E-04,   5.7856389E-04
     +,   4.6480793E-04,   3.7138505E-04,   2.9513665E-04
     +,   2.3329814E-04,   1.8345194E-04,   1.4351757E-04
     +,   1.1171024E-04,   8.6522508E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_ashz_htt110_mass = Yx/15.7706198571429
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_ashz_htt115_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.5885052E-04,   2.6785184E-04
     +,   2.7710354E-04,   2.8661234E-04,   2.9638523E-04
     +,   3.0642925E-04,   3.1675203E-04,   3.2736140E-04
     +,   3.3826538E-04,   3.4947289E-04,   3.6099280E-04
     +,   3.7283445E-04,   3.8500750E-04,   3.9752221E-04
     +,   4.1038921E-04,   4.2361947E-04,   4.3722469E-04
     +,   4.5121677E-04,   4.6560829E-04,   4.8041210E-04
     +,   4.9564184E-04,   5.1131152E-04,   5.2743539E-04
     +,   5.4402940E-04,   5.6110817E-04,   5.7868852E-04
     +,   5.9678708E-04,   6.1542116E-04,   6.3460844E-04
     +,   6.5436767E-04,   6.7471765E-04,   6.9567811E-04
     +,   7.1726937E-04,   7.3951192E-04,   7.6242728E-04
     +,   7.8603718E-04,   8.1036438E-04,   8.3543110E-04
     +,   8.6126267E-04,   8.8788127E-04,   9.1531296E-04
     +,   9.4358250E-04,   9.7271573E-04,   1.0027390E-03
     +,   1.0336790E-03,   1.0655632E-03,   1.0984191E-03
     +,   1.1322752E-03,   1.1671599E-03,   1.2031024E-03
     +,   1.2401317E-03,   1.2782780E-03,   1.3175707E-03
     +,   1.3580417E-03,   1.3997196E-03,   1.4426362E-03
     +,   1.4868220E-03,   1.5323091E-03,   1.5791275E-03
     +,   1.6273087E-03,   1.6768832E-03,   1.7278836E-03
     +,   1.7803381E-03,   1.8342793E-03,   1.8897394E-03
     +,   1.9467463E-03,   2.0053342E-03,   2.0655289E-03
     +,   2.1273675E-03,   2.1908775E-03,   2.2560949E-03
     +,   2.3230484E-03,   2.3917798E-03,   2.4623200E-03
     +,   2.5347134E-03,   2.6090043E-03,   2.6852423E-03
     +,   2.7634792E-03,   2.8437795E-03,   2.9262179E-03
     +,   3.0108707E-03,   3.0978392E-03,   3.1872301E-03
     +,   3.2791747E-03,   3.3738173E-03,   3.4713354E-03
     +,   3.5719187E-03,   3.6758010E-03,   3.7832335E-03
     +,   3.8945116E-03,   4.0099691E-03,   4.1299709E-03
     +,   4.2549223E-03,   4.3852841E-03,   4.5215515E-03
     +,   4.6642553E-03,   4.8139831E-03,   4.9713394E-03
     +,   5.1369849E-03,   5.3115836E-03,   5.4958430E-03
     +,   5.6904559E-03,   5.8961385E-03,   6.1135660E-03
     +,   6.3434034E-03,   6.5862737E-03,   6.8427147E-03
     +,   7.1131820E-03,   7.3980419E-03,   7.6975413E-03
     +,   8.0117490E-03,   8.3406074E-03,   8.6838342E-03
     +,   9.0409918E-03,   9.4113750E-03,   9.7941021E-03
     +,   1.0188006E-02,   1.0591733E-02,   1.1003640E-02
     +,   1.1421887E-02,   1.1844417E-02,   1.2268949E-02
     +,   1.2693007E-02,   1.3114007E-02,   1.3529244E-02
     +,   1.3935876E-02,   1.4331101E-02,   1.4712038E-02
     +,   1.5075935E-02,   1.5420073E-02,   1.5741937E-02
     +,   1.6039141E-02,   1.6309598E-02,   1.6551450E-02
     +,   1.6763158E-02,   1.6943544E-02,   1.7091777E-02
     +,   1.7207397E-02,   1.7290361E-02,   1.7341018E-02
     +,   1.7360084E-02,   1.7348683E-02,   1.7308285E-02
     +,   1.7240716E-02,   1.7148104E-02,   1.7032865E-02
     +,   1.6897663E-02,   1.6745377E-02,   1.6579088E-02
     +,   1.6401974E-02,   1.6217370E-02,   1.6028682E-02
     +,   1.5839381E-02,   1.5652968E-02,   1.5472974E-02
     +,   1.5302950E-02,   1.5146476E-02,   1.5007116E-02
     +,   1.4888490E-02,   1.4794259E-02,   1.4728153E-02
     +,   1.4693975E-02,   1.4695668E-02,   1.4737312E-02
     +,   1.4823168E-02,   1.4957698E-02,   1.5145594E-02
     +,   1.5391782E-02,   1.5701458E-02,   1.6080059E-02
     +,   1.6533224E-02,   1.7066795E-02,   1.7686749E-02
     +,   1.8399164E-02,   1.9209996E-02,   2.0125154E-02
     +,   2.1150338E-02,   2.2290854E-02,   2.3551587E-02
     +,   2.4937121E-02,   2.6451679E-02,   2.8099222E-02
     +,   2.9883856E-02,   3.1810418E-02,   3.3885121E-02
     +,   3.6116343E-02,   3.8515721E-02,   4.1099660E-02
     +,   4.3890309E-02,   4.6916224E-02,   5.0213475E-02
     +,   5.3824697E-02,   5.7797350E-02,   6.2180355E-02
     +,   6.7019559E-02,   7.2351210E-02,   7.8194894E-02
     +,   8.4547997E-02,   9.1383323E-02,   9.8650835E-02
     +,   0.1062847    ,   0.1142177    ,   0.1223987    
     +,   0.1308082    ,   0.1394686    ,   0.1484449    
     +,   0.1578319    ,   0.1677335    ,   0.1782454    
     +,   0.1894498    ,   0.2014299    ,   0.2142954    
     +,   0.2282016    ,   0.2433316    ,   0.2598319    
     +,   0.2777140    ,   0.2967869    ,   0.3166764    
     +,   0.3369598    ,   0.3573881    ,   0.3781236    
     +,   0.3998683    ,   0.4237591    ,   0.4509556    
     +,   0.4819765    ,   0.5161514    ,   0.5517207    
     +,   0.5868639    ,   0.6211593    ,   0.6562706    
     +,   0.6949684    ,   0.7390559    ,   0.7881671    
     +,   0.8409027    ,   0.8971068    ,   0.9580416    
     +,    1.023019    ,    1.085684    ,    1.134962    
     +,    1.162030    ,    1.168616    ,    1.168741    
     +,    1.180523    ,    1.214432    ,    1.266951    
     +,    1.322702    ,    1.363347    ,    1.377366    
     +,    1.363466    ,    1.327880    ,    1.279985    
     +,    1.228043    ,    1.176880    ,    1.127987    
     +,    1.079363    ,    1.025415    ,   0.9600467    
     +,   0.8814070    ,   0.7929125    ,   0.6996531    
     +,   0.6051530    ,   0.5117451    ,   0.4223800    
     +,   0.3407831    ,   0.2700052    ,   0.2112296    
     +,   0.1638529    ,   0.1263125    ,   9.6859418E-02
     +,   7.3937707E-02,   5.6257531E-02,   4.2750489E-02
     +,   3.2520156E-02,   2.4817169E-02,   1.9028472E-02
     +,   1.4667273E-02,   1.1358947E-02,   8.8257473E-03
     +,   6.8669938E-03,   5.3406921E-03,   4.1459599E-03
     +,   3.2099730E-03,   2.4780906E-03,   1.9079939E-03
     +,   1.4658390E-03,   1.1243406E-03,   8.6141226E-04
     +,   6.5937219E-04,   5.0425559E-04,   3.8514586E-04
     +,   2.9363862E-04,   2.2329381E-04,   1.6921674E-04
     +,   1.2767474E-04,   9.5823831E-05,   7.1477036E-05
     +,   5.2947988E-05,   3.8923135E-05,   2.8377946E-05
     +,   2.0508123E-05,   1.4684189E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_ashz_htt115_mass = Yx/10.9757326595745
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_ashz_htt120_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.8124886E-04,   3.8880817E-04
     +,   3.9641885E-04,   4.0407875E-04,   4.1178588E-04
     +,   4.1953806E-04,   4.2733303E-04,   4.3516865E-04
     +,   4.4304255E-04,   4.5095274E-04,   4.5889677E-04
     +,   4.6687239E-04,   4.7487728E-04,   4.8290926E-04
     +,   4.9096602E-04,   4.9904530E-04,   5.0714501E-04
     +,   5.1526300E-04,   5.2339718E-04,   5.3154561E-04
     +,   5.3970650E-04,   5.4787804E-04,   5.5605866E-04
     +,   5.6424731E-04,   5.7244219E-04,   5.8064278E-04
     +,   5.8884831E-04,   5.9705862E-04,   6.0527324E-04
     +,   6.1349262E-04,   6.2171783E-04,   6.2994979E-04
     +,   6.3819042E-04,   6.4644200E-04,   6.5470755E-04
     +,   6.6299067E-04,   6.7129580E-04,   6.7962805E-04
     +,   6.8799418E-04,   6.9640036E-04,   7.0485554E-04
     +,   7.1336899E-04,   7.2195113E-04,   7.3061400E-04
     +,   7.3937082E-04,   7.4823672E-04,   7.5722841E-04
     +,   7.6636398E-04,   7.7566394E-04,   7.8515027E-04
     +,   7.9484779E-04,   8.0478302E-04,   8.1498479E-04
     +,   8.2548574E-04,   8.3631941E-04,   8.4752357E-04
     +,   8.5913861E-04,   8.7120809E-04,   8.8377867E-04
     +,   8.9690107E-04,   9.1062917E-04,   9.2502084E-04
     +,   9.4013795E-04,   9.5604645E-04,   9.7281771E-04
     +,   9.9052500E-04,   1.0092501E-03,   1.0290750E-03
     +,   1.0500911E-03,   1.0723916E-03,   1.0960775E-03
     +,   1.1212535E-03,   1.1480316E-03,   1.1765278E-03
     +,   1.2068661E-03,   1.2391771E-03,   1.2735958E-03
     +,   1.3102649E-03,   1.3493353E-03,   1.3909659E-03
     +,   1.4353201E-03,   1.4825745E-03,   1.5329083E-03
     +,   1.5865165E-03,   1.6435959E-03,   1.7043614E-03
     +,   1.7690301E-03,   1.8378387E-03,   1.9110239E-03
     +,   1.9888433E-03,   2.0715664E-03,   2.1594658E-03
     +,   2.2528288E-03,   2.3519583E-03,   2.4571677E-03
     +,   2.5687711E-03,   2.6871038E-03,   2.8124941E-03
     +,   2.9452890E-03,   3.0858221E-03,   3.2344433E-03
     +,   3.3914775E-03,   3.5572592E-03,   3.7320929E-03
     +,   3.9162724E-03,   4.1100709E-03,   4.3137181E-03
     +,   4.5273993E-03,   4.7512697E-03,   4.9854335E-03
     +,   5.2299085E-03,   5.4846783E-03,   5.7496168E-03
     +,   6.0245534E-03,   6.3091940E-03,   6.6031897E-03
     +,   6.9060600E-03,   7.2172643E-03,   7.5361230E-03
     +,   7.8618964E-03,   8.1937350E-03,   8.5306894E-03
     +,   8.8717183E-03,   9.2157153E-03,   9.5615126E-03
     +,   9.9078408E-03,   1.0253419E-02,   1.0596890E-02
     +,   1.0936909E-02,   1.1272063E-02,   1.1600992E-02
     +,   1.1922288E-02,   1.2234612E-02,   1.2536616E-02
     +,   1.2827018E-02,   1.3104584E-02,   1.3368116E-02
     +,   1.3616483E-02,   1.3848646E-02,   1.4063621E-02
     +,   1.4260495E-02,   1.4438424E-02,   1.4596671E-02
     +,   1.4734566E-02,   1.4851513E-02,   1.4947020E-02
     +,   1.5020682E-02,   1.5072189E-02,   1.5101337E-02
     +,   1.5108041E-02,   1.5092351E-02,   1.5054445E-02
     +,   1.4994688E-02,   1.4913610E-02,   1.4811951E-02
     +,   1.4690706E-02,   1.4551109E-02,   1.4394715E-02
     +,   1.4223385E-02,   1.4039368E-02,   1.3845311E-02
     +,   1.3644261E-02,   1.3439762E-02,   1.3235854E-02
     +,   1.3037064E-02,   1.2848462E-02,   1.2675681E-02
     +,   1.2524873E-02,   1.2402729E-02,   1.2316452E-02
     +,   1.2273725E-02,   1.2282635E-02,   1.2351651E-02
     +,   1.2489490E-02,   1.2705022E-02,   1.3007168E-02
     +,   1.3404741E-02,   1.3906238E-02,   1.4519656E-02
     +,   1.5252345E-02,   1.6110770E-02,   1.7100217E-02
     +,   1.8224664E-02,   1.9486714E-02,   2.0887518E-02
     +,   2.2426687E-02,   2.4102578E-02,   2.5912784E-02
     +,   2.7854647E-02,   2.9925823E-02,   3.2125715E-02
     +,   3.4456480E-02,   3.6924213E-02,   3.9540410E-02
     +,   4.2323265E-02,   4.5298234E-02,   4.8497900E-02
     +,   5.1961072E-02,   5.5730686E-02,   5.9849735E-02
     +,   6.4355470E-02,   6.9272883E-02,   7.4607313E-02
     +,   8.0337025E-02,   8.6406879E-02,   9.2727423E-02
     +,   9.9178135E-02,   0.1056181    ,   0.1119064    
     +,   0.1179302    ,   0.1236361    ,   0.1290590    
     +,   0.1343390    ,   0.1397168    ,   0.1455003    
     +,   0.1520057    ,   0.1594861    ,   0.1680728    
     +,   0.1777515    ,   0.1883921    ,   0.1998355    
     +,   0.2120090    ,   0.2250267    ,   0.2392296    
     +,   0.2551303    ,   0.2732665    ,   0.2940167    
     +,   0.3174503    ,   0.3432572    ,   0.3707238    
     +,   0.3987289    ,   0.4258333    ,   0.4506461    
     +,   0.4725285    ,   0.4922491    ,   0.5118693    
     +,   0.5335298    ,   0.5580140    ,   0.5845183    
     +,   0.6119790    ,   0.6405216    ,   0.6714599    
     +,   0.7060307    ,   0.7442247    ,   0.7844885    
     +,   0.8241173    ,   0.8599275    ,   0.8886237    
     +,   0.9068936    ,   0.9125274    ,   0.9067046    
     +,   0.8941432    ,   0.8790222    ,   0.8610011    
     +,   0.8366745    ,   0.8044223    ,   0.7661566    
     +,   0.7244789    ,   0.6797344    ,   0.6304550    
     +,   0.5759218    ,   0.5177324    ,   0.4591061    
     +,   0.4030901    ,   0.3513535    ,   0.3041836    
     +,   0.2612072    ,   0.2220551    ,   0.1866195    
     +,   0.1549890    ,   0.1272788    ,   0.1034992    
     +,   8.3498359E-02,   6.6972502E-02,   5.3513266E-02
     +,   4.2666230E-02,   3.3980049E-02,   2.7046200E-02
     +,   2.1515172E-02,   1.7101927E-02,   1.3578797E-02
     +,   1.0767043E-02,   8.5258167E-03,   6.7440309E-03
     +,   5.3326162E-03,   4.2196373E-03,   3.3460734E-03
     +,   2.6633469E-03,   2.1315131E-03,   1.7178069E-03
     +,   1.3957504E-03,   1.1441485E-03,   9.4635249E-04
     +,   7.8943156E-04,   6.6352752E-04,   5.6119368E-04
     +,   4.7689531E-04,   4.0653613E-04,   3.4712028E-04
     +,   2.9644734E-04,   2.5290763E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_ashz_htt120_mass = Yx/7.43527002272727
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_ashz_htt60_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.6184935E-02,   1.7850144E-02
     +,   1.9696984E-02,   2.1753134E-02,   2.4052054E-02
     +,   2.6634263E-02,   2.9548530E-02,   3.2853380E-02
     +,   3.6618195E-02,   4.0924277E-02,   4.5864508E-02
     +,   5.1542122E-02,   5.8067914E-02,   6.5555751E-02
     +,   7.4117877E-02,   8.3860986E-02,   9.4884627E-02
     +,   0.1072852    ,   0.1211646    ,   0.1366470    
     +,   0.1538983    ,   0.1731497    ,   0.1947194    
     +,   0.2190300    ,   0.2466092    ,   0.2780817    
     +,   0.3141306    ,   0.3554428    ,   0.4026398    
     +,   0.4562044    ,   0.5164118    ,   0.5832641    
     +,   0.6564121    ,   0.7350585    ,   0.8178020    
     +,   0.9025015    ,   0.9862084    ,    1.065345    
     +,    1.136196    ,    1.195602    ,    1.241598    
     +,    1.273575    ,    1.291880    ,    1.297157    
     +,    1.289859    ,    1.270258    ,    1.238814    
     +,    1.196494    ,    1.144831    ,    1.085777    
     +,    1.021587    ,   0.9548023    ,   0.8882078    
     +,   0.8245620    ,   0.7661243    ,   0.7141389    
     +,   0.6686211    ,   0.6285316    ,   0.5922896    
     +,   0.5583967    ,   0.5259118    ,   0.4946446    
     +,   0.4650303    ,   0.4378040    ,   0.4136229    
     +,   0.3927868    ,   0.3751205    ,   0.3600414    
     +,   0.3467343    ,   0.3343676    ,   0.3222603    
     +,   0.3099847    ,   0.2973817    ,   0.2845220    
     +,   0.2716281    ,   0.2589981    ,   0.2469337    
     +,   0.2356915    ,   0.2254524    ,   0.2163130    
     +,   0.2082893    ,   0.2013272    ,   0.1953211    
     +,   0.1901285    ,   0.1855874    ,   0.1815301    
     +,   0.1777951    ,   0.1742368    ,   0.1707326    
     +,   0.1671875    ,   0.1635362    ,   0.1597436    
     +,   0.1558016    ,   0.1517249    ,   0.1475459    
     +,   0.1433103    ,   0.1390693    ,   0.1348763    
     +,   0.1307828    ,   0.1268354    ,   0.1230735    
     +,   0.1195303    ,   0.1162311    ,   0.1131954    
     +,   0.1104372    ,   0.1079663    ,   0.1057893    
     +,   0.1039099    ,   0.1023290    ,   0.1010447    
     +,   0.1000515    ,   9.9339887E-02,   9.8895587E-02
     +,   9.8699041E-02,   9.8725148E-02,   9.8943591E-02
     +,   9.9319316E-02,   9.9813767E-02,   0.1003858    
     +,   0.1009936    ,   0.1015963    ,   0.1021554    
     +,   0.1026364    ,   0.1030100    ,   0.1032529    
     +,   0.1033480    ,   0.1032849    ,   0.1030592    
     +,   0.1026725    ,   0.1021304    ,   0.1014428    
     +,   0.1006220    ,   9.9681936E-02,   9.8636895E-02
     +,   9.7501256E-02,   9.6288055E-02,   9.5009275E-02
     +,   9.3674779E-02,   9.2292696E-02,   9.0869047E-02
     +,   8.9408368E-02,   8.7913439E-02,   8.6385764E-02
     +,   8.4825881E-02,   8.3233804E-02,   8.1609137E-02
     +,   7.9951242E-02,   7.8259908E-02,   7.6535098E-02
     +,   7.4777313E-02,   7.2987542E-02,   7.1167447E-02
     +,   6.9319569E-02,   6.7446925E-02,   6.5553248E-02
     +,   6.3643031E-02,   6.1721578E-02,   5.9794474E-02
     +,   5.7868022E-02,   5.5949114E-02,   5.4044846E-02
     +,   5.2162763E-02,   5.0310567E-02,   4.8496183E-02
     +,   4.6727385E-02,   4.5011677E-02,   4.3356568E-02
     +,   4.1768998E-02,   4.0255312E-02,   3.8821250E-02
     +,   3.7471820E-02,   3.6211282E-02,   3.5042852E-02
     +,   3.3968907E-02,   3.2990955E-02,   3.2109458E-02
     +,   3.1324003E-02,   3.0633366E-02,   3.0035505E-02
     +,   2.9527601E-02,   2.9106166E-02,   2.8767169E-02
     +,   2.8506087E-02,   2.8317975E-02,   2.8197514E-02
     +,   2.8139189E-02,   2.8137304E-02,   2.8186047E-02
     +,   2.8279603E-02,   2.8412098E-02,   2.8577788E-02
     +,   2.8770996E-02,   2.8986227E-02,   2.9218107E-02
     +,   2.9461514E-02,   2.9711509E-02,   2.9963417E-02
     +,   3.0212786E-02,   3.0455451E-02,   3.0687524E-02
     +,   3.0905344E-02,   3.1105576E-02,   3.1285129E-02
     +,   3.1441279E-02,   3.1571455E-02,   3.1673487E-02
     +,   3.1745419E-02,   3.1785578E-02,   3.1792577E-02
     +,   3.1765338E-02,   3.1702977E-02,   3.1604875E-02
     +,   3.1470705E-02,   3.1300370E-02,   3.1093948E-02
     +,   3.0851817E-02,   3.0574521E-02,   3.0262807E-02
     +,   2.9917583E-02,   2.9539982E-02,   2.9131247E-02
     +,   2.8692760E-02,   2.8226092E-02,   2.7732870E-02
     +,   2.7214823E-02,   2.6673781E-02,   2.6111620E-02
     +,   2.5530353E-02,   2.4931902E-02,   2.4318282E-02
     +,   2.3691535E-02,   2.3053695E-02,   2.2406759E-02
     +,   2.1752691E-02,   2.1093467E-02,   2.0430995E-02
     +,   1.9767083E-02,   1.9103529E-02,   1.8442083E-02
     +,   1.7784346E-02,   1.7131856E-02,   1.6486079E-02
     +,   1.5848419E-02,   1.5220116E-02,   1.4602318E-02
     +,   1.3996131E-02,   1.3402522E-02,   1.2822355E-02
     +,   1.2256362E-02,   1.1705250E-02,   1.1169570E-02
     +,   1.0649775E-02,   1.0146257E-02,   9.6593229E-03
     +,   9.1891605E-03,   8.7358803E-03,   8.2995445E-03
     +,   7.8801429E-03,   7.4775685E-03,   7.0916619E-03
     +,   6.7222286E-03,   6.3690240E-03,   6.0317381E-03
     +,   5.7100151E-03,   5.4035038E-03,   5.1117856E-03
     +,   4.8344256E-03,   4.5709810E-03,   4.3209950E-03
     +,   4.0839780E-03,   3.8594387E-03,   3.6468918E-03
     +,   3.4458512E-03,   3.2558183E-03,   3.0762968E-03
     +,   2.9068165E-03,   2.7468919E-03,   2.5960680E-03
     +,   2.4538797E-03,   2.3198957E-03,   2.1936791E-03
     +,   2.0748228E-03,   1.9629200E-03,   1.8575934E-03
     +,   1.7584673E-03,   1.6651952E-03,   1.5774370E-03
     +,   1.4948674E-03,   1.4171861E-03,   1.3440965E-03
     +,   1.2753285E-03,   1.2106148E-03,   1.1497128E-03
     +,   1.0923849E-03,   1.0384145E-03,   9.8759052E-04
     +,   9.3972095E-04,   8.9461781E-04,   8.5211289E-04
     +,   8.1204053E-04,   7.7425182E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_ashz_htt60_mass = Yx/11.9263374255319
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_ashz_htt65_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.5882720E-03,   5.0133094E-03
     +,   5.4783970E-03,   5.9863697E-03,   6.5401578E-03
     +,   7.1428115E-03,   7.7975034E-03,   8.5075693E-03
     +,   9.2765447E-03,   1.0108236E-02,   1.1006720E-02
     +,   1.1976448E-02,   1.3022312E-02,   1.4149725E-02
     +,   1.5364724E-02,   1.6674103E-02,   1.8085591E-02
     +,   1.9608036E-02,   2.1251682E-02,   2.3028471E-02
     +,   2.4952333E-02,   2.7039496E-02,   2.9308580E-02
     +,   3.1780776E-02,   3.4479085E-02,   3.7428282E-02
     +,   4.0653665E-02,   4.4180606E-02,   4.8034638E-02
     +,   5.2243508E-02,   5.6841902E-02,   6.1880786E-02
     +,   6.7441814E-02,   7.3656306E-02,   8.0726802E-02
     +,   8.8945992E-02,   9.8705575E-02,   0.1104860    
     +,   0.1248240    ,   0.1422510    ,   0.1632260    
     +,   0.1880682    ,   0.2169306    ,   0.2498324    
     +,   0.2867638    ,   0.3278432    ,   0.3734713    
     +,   0.4244084    ,   0.4817016    ,   0.5464529    
     +,   0.6194690    ,   0.7008609    ,   0.7896383    
     +,   0.8834165    ,   0.9784897    ,    1.070655    
     +,    1.156577    ,    1.234925    ,    1.306177    
     +,    1.371028    ,    1.428762    ,    1.477218    
     +,    1.514546    ,    1.540883    ,    1.557855    
     +,    1.565789    ,    1.561440    ,    1.539042    
     +,    1.494549    ,    1.429526    ,    1.351187    
     +,    1.268821    ,    1.189647    ,    1.117064    
     +,    1.051302    ,   0.9909223    ,   0.9339013    
     +,   0.8783256    ,   0.8230404    ,   0.7681811    
     +,   0.7151874    ,   0.6661673    ,   0.6229773    
     +,   0.5864928    ,   0.5564093    ,   0.5315151    
     +,   0.5102127    ,   0.4909863    ,   0.4726709    
     +,   0.4545068    ,   0.4360757    ,   0.4172122    
     +,   0.3979263    ,   0.3783541    ,   0.3587202    
     +,   0.3393031    ,   0.3203983    ,   0.3022881    
     +,   0.2852127    ,   0.2693593    ,   0.2548467    
     +,   0.2417333    ,   0.2300177    ,   0.2196548    
     +,   0.2105662    ,   0.2026530    ,   0.1958072    
     +,   0.1899178    ,   0.1848768    ,   0.1805797    
     +,   0.1769293    ,   0.1738317    ,   0.1711971    
     +,   0.1689367    ,   0.1669627    ,   0.1651881    
     +,   0.1635292    ,   0.1619069    ,   0.1602522    
     +,   0.1585087    ,   0.1566369    ,   0.1546150    
     +,   0.1524404    ,   0.1501271    ,   0.1477033    
     +,   0.1452080    ,   0.1426860    ,   0.1401833    
     +,   0.1377438    ,   0.1354054    ,   0.1331976    
     +,   0.1311403    ,   0.1292427    ,   0.1275039    
     +,   0.1259126    ,   0.1244492    ,   0.1230870    
     +,   0.1217940    ,   0.1205346    ,   0.1192720    
     +,   0.1179699    ,   0.1165948    ,   0.1151167    
     +,   0.1135114    ,   0.1117604    ,   0.1098522    
     +,   0.1077817    ,   0.1055503    ,   0.1031651    
     +,   0.1006380    ,   9.7984515E-02,   9.5223010E-02
     +,   9.2373617E-02,   8.9457020E-02,   8.6493798E-02
     +,   8.3504014E-02,   8.0506735E-02,   7.7519372E-02
     +,   7.4557938E-02,   7.1637131E-02,   6.8769962E-02
     +,   6.5968342E-02,   6.3243024E-02,   6.0604002E-02
     +,   5.8060121E-02,   5.5619560E-02,   5.3290125E-02
     +,   5.1079057E-02,   4.8992760E-02,   4.7037270E-02
     +,   4.5218118E-02,   4.3540318E-02,   4.2007964E-02
     +,   4.0624574E-02,   3.9393060E-02,   3.8315315E-02
     +,   3.7392378E-02,   3.6624376E-02,   3.6010396E-02
     +,   3.5548460E-02,   3.5235405E-02,   3.5066999E-02
     +,   3.5037696E-02,   3.5140730E-02,   3.5368208E-02
     +,   3.5710879E-02,   3.6158398E-02,   3.6699232E-02
     +,   3.7320890E-02,   3.8009822E-02,   3.8751766E-02
     +,   3.9531801E-02,   4.0334459E-02,   4.1144077E-02
     +,   4.1944902E-02,   4.2721380E-02,   4.3458391E-02
     +,   4.4141371E-02,   4.4756729E-02,   4.5291968E-02
     +,   4.5735881E-02,   4.6078779E-02,   4.6312548E-02
     +,   4.6430979E-02,   4.6429615E-02,   4.6305943E-02
     +,   4.6059299E-02,   4.5690928E-02,   4.5203879E-02
     +,   4.4602748E-02,   4.3893721E-02,   4.3084387E-02
     +,   4.2183354E-02,   4.1200131E-02,   4.0144943E-02
     +,   3.9028533E-02,   3.7861813E-02,   3.6655676E-02
     +,   3.5420768E-02,   3.4167536E-02,   3.2905694E-02
     +,   3.1644341E-02,   3.0391851E-02,   2.9155705E-02
     +,   2.7942436E-02,   2.6757581E-02,   2.5605870E-02
     +,   2.4491062E-02,   2.3415992E-02,   2.2382641E-02
     +,   2.1392303E-02,   2.0445585E-02,   1.9542409E-02
     +,   1.8682210E-02,   1.7864028E-02,   1.7086474E-02
     +,   1.6347906E-02,   1.5646495E-02,   1.4980276E-02
     +,   1.4347165E-02,   1.3745044E-02,   1.3171846E-02
     +,   1.2625559E-02,   1.2104205E-02,   1.1605917E-02
     +,   1.1128972E-02,   1.0671767E-02,   1.0232821E-02
     +,   9.8107681E-03,   9.4044395E-03,   9.0127336E-03
     +,   8.6347051E-03,   8.2695214E-03,   7.9164729E-03
     +,   7.5749233E-03,   7.2443276E-03,   6.9242395E-03
     +,   6.6142860E-03,   6.3141328E-03,   6.0234996E-03
     +,   5.7421657E-03,   5.4699508E-03,   5.2066837E-03
     +,   4.9522179E-03,   4.7064475E-03,   4.4692545E-03
     +,   4.2405352E-03,   4.0201973E-03,   3.8081536E-03
     +,   3.6042994E-03,   3.4085272E-03,   3.2207363E-03
     +,   3.0408197E-03,   2.8686493E-03,   2.7040893E-03
     +,   2.5470096E-03,   2.3972506E-03,   2.2546626E-03
     +,   2.1190695E-03,   1.9903034E-03,   1.8681702E-03
     +,   1.7524859E-03,   1.6430444E-03,   1.5396480E-03
     +,   1.4420800E-03,   1.3501338E-03,   1.2635891E-03
     +,   1.1822250E-03,   1.1058279E-03,   1.0341724E-03
     +,   9.6704502E-04,   9.0422400E-04,   8.4549934E-04
     +,   7.9065544E-04,   7.3948887E-04,   6.9179339E-04
     +,   6.4737495E-04,   6.0603872E-04,   5.6760164E-04
     +,   5.3188199E-04,   4.9870979E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_ashz_htt65_mass = Yx/14.3110576875
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_ashz_htt70_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.1656563E-03,   2.2825063E-03
     +,   2.4049699E-03,   2.5333557E-03,   2.6680040E-03
     +,   2.8092940E-03,   2.9576486E-03,   3.1135371E-03
     +,   3.2774813E-03,   3.4500731E-03,   3.6319657E-03
     +,   3.8238908E-03,   4.0266709E-03,   4.2412281E-03
     +,   4.4685965E-03,   4.7099404E-03,   4.9665691E-03
     +,   5.2399579E-03,   5.5317688E-03,   5.8438783E-03
     +,   6.1783968E-03,   6.5377066E-03,   6.9244732E-03
     +,   7.3417178E-03,   7.7927597E-03,   8.2813548E-03
     +,   8.8116350E-03,   9.3881572E-03,   1.0015925E-02
     +,   1.0700395E-02,   1.1447499E-02,   1.2263673E-02
     +,   1.3155882E-02,   1.4131729E-02,   1.5199561E-02
     +,   1.6368704E-02,   1.7649800E-02,   1.9055253E-02
     +,   2.0600064E-02,   2.2302452E-02,   2.4185399E-02
     +,   2.6277812E-02,   2.8616363E-02,   3.1247329E-02
     +,   3.4228597E-02,   3.7631530E-02,   4.1542351E-02
     +,   4.6062928E-02,   5.1310219E-02,   5.7413917E-02
     +,   6.4512305E-02,   7.2745509E-02,   8.2246684E-02
     +,   9.3133561E-02,   0.1054973    ,   0.1193995    
     +,   0.1348715    ,   0.1519263    ,   0.1705839    
     +,   0.1909101    ,   0.2130726    ,   0.2373993    
     +,   0.2644262    ,   0.2949022    ,   0.3297106    
     +,   0.3697009    ,   0.4155134    ,   0.4674961    
     +,   0.5258554    ,   0.5908790    ,   0.6629725    
     +,   0.7422123    ,   0.8277477    ,   0.9176778    
     +,    1.009908    ,    1.103435    ,    1.198932    
     +,    1.297978    ,    1.401408    ,    1.507880    
     +,    1.613188    ,    1.710624    ,    1.793192    
     +,    1.857619    ,    1.906025    ,    1.940922    
     +,    1.957587    ,    1.944014    ,    1.891428    
     +,    1.805250    ,    1.705123    ,    1.613415    
     +,    1.541500    ,    1.484136    ,    1.425905    
     +,    1.354249    ,    1.268489    ,    1.178349    
     +,    1.095146    ,    1.024193    ,   0.9636001    
     +,   0.9080366    ,   0.8530437    ,   0.7970918    
     +,   0.7412393    ,   0.6876487    ,   0.6381370    
     +,   0.5934007    ,   0.5530420    ,   0.5161309    
     +,   0.4818657    ,   0.4499815    ,   0.4207821    
     +,   0.3948534    ,   0.3727037    ,   0.3544862    
     +,   0.3399253    ,   0.3284128    ,   0.3191990    
     +,   0.3115645    ,   0.3049298    ,   0.2988754    
     +,   0.2931124    ,   0.2874314    ,   0.2816667    
     +,   0.2756831    ,   0.2693797    ,   0.2627047    
     +,   0.2556645    ,   0.2483230    ,   0.2407895    
     +,   0.2331999    ,   0.2256931    ,   0.2183914    
     +,   0.2113837    ,   0.2047141    ,   0.1983827    
     +,   0.1923465    ,   0.1865308    ,   0.1808430    
     +,   0.1751875    ,   0.1694812    ,   0.1636644    
     +,   0.1577073    ,   0.1516135    ,   0.1454159    
     +,   0.1391709    ,   0.1329500    ,   0.1268293    
     +,   0.1208809    ,   0.1151659    ,   0.1097297    
     +,   0.1046002    ,   9.9787660E-02,   9.5286809E-02
     +,   9.1081515E-02,   8.7147795E-02,   8.3457805E-02
     +,   7.9983585E-02,   7.6699704E-02,   7.3584706E-02
     +,   7.0621751E-02,   6.7799389E-02,   6.5110773E-02
     +,   6.2552720E-02,   6.0125113E-02,   5.7830241E-02
     +,   5.5671647E-02,   5.3653445E-02,   5.1779818E-02
     +,   5.0054826E-02,   4.8481636E-02,   4.7062576E-02
     +,   4.5798682E-02,   4.4690166E-02,   4.3735601E-02
     +,   4.2932495E-02,   4.2276938E-02,   4.1763928E-02
     +,   4.1387122E-02,   4.1139144E-02,   4.1011650E-02
     +,   4.0995233E-02,   4.1079767E-02,   4.1254405E-02
     +,   4.1507598E-02,   4.1827414E-02,   4.2201348E-02
     +,   4.2616818E-02,   4.3060854E-02,   4.3520577E-02
     +,   4.3983057E-02,   4.4435691E-02,   4.4866107E-02
     +,   4.5262493E-02,   4.5613717E-02,   4.5909401E-02
     +,   4.6140168E-02,   4.6297818E-02,   4.6375304E-02
     +,   4.6367038E-02,   4.6268839E-02,   4.6078112E-02
     +,   4.5793813E-02,   4.5416482E-02,   4.4948179E-02
     +,   4.4392444E-02,   4.3754183E-02,   4.3039553E-02
     +,   4.2255752E-02,   4.1410808E-02,   4.0513471E-02
     +,   3.9572991E-02,   3.8598750E-02,   3.7600137E-02
     +,   3.6586456E-02,   3.5566580E-02,   3.4548774E-02
     +,   3.3540618E-02,   3.2548901E-02,   3.1579450E-02
     +,   3.0637095E-02,   2.9725702E-02,   2.8848149E-02
     +,   2.8006228E-02,   2.7200807E-02,   2.6431926E-02
     +,   2.5698859E-02,   2.5000069E-02,   2.4333524E-02
     +,   2.3696708E-02,   2.3086730E-02,   2.2500435E-02
     +,   2.1934532E-02,   2.1385707E-02,   2.0850684E-02
     +,   2.0326270E-02,   1.9809520E-02,   1.9297734E-02
     +,   1.8788539E-02,   1.8279810E-02,   1.7769869E-02
     +,   1.7257387E-02,   1.6741388E-02,   1.6221251E-02
     +,   1.5696732E-02,   1.5167935E-02,   1.4635220E-02
     +,   1.4099211E-02,   1.3560847E-02,   1.3021185E-02
     +,   1.2481476E-02,   1.1943098E-02,   1.1407538E-02
     +,   1.0876302E-02,   1.0350915E-02,   9.8329093E-03
     +,   9.3237981E-03,   8.8249808E-03,   8.3377864E-03
     +,   7.8634517E-03,   7.4031143E-03,   6.9577373E-03
     +,   6.5281526E-03,   6.1151008E-03,   5.7191197E-03
     +,   5.3406246E-03,   4.9799047E-03,   4.6371184E-03
     +,   4.3122731E-03,   4.0052631E-03,   3.7158928E-03
     +,   3.4438665E-03,   3.1887831E-03,   2.9501677E-03
     +,   2.7275041E-03,   2.5201908E-03,   2.3276114E-03
     +,   2.1490899E-03,   1.9839497E-03,   1.8314769E-03
     +,   1.6909715E-03,   1.5617142E-03,   1.4430087E-03
     +,   1.3341547E-03,   1.2344837E-03,   1.1433369E-03
     +,   1.0600801E-03,   9.8411308E-04,   9.1485464E-04
     +,   8.5176172E-04,   7.9431402E-04,   7.4202922E-04
     +,   6.9444970E-04,   6.5115391E-04,   6.1174540E-04
     +,   5.7586178E-04,   5.4316432E-04,   5.1334494E-04
     +,   4.8611802E-04,   4.6122554E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_ashz_htt70_mass = Yx/16.418481
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_ashz_htt75_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.5506611E-03,   2.6499911E-03
     +,   2.7508864E-03,   2.8532336E-03,   2.9569173E-03
     +,   3.0618242E-03,   3.1678432E-03,   3.2748680E-03
     +,   3.3828041E-03,   3.4915691E-03,   3.6010942E-03
     +,   3.7113319E-03,   3.8222596E-03,   3.9338809E-03
     +,   4.0462376E-03,   4.1594063E-03,   4.2735091E-03
     +,   4.3887161E-03,   4.5052539E-03,   4.6234056E-03
     +,   4.7435160E-03,   4.8659979E-03,   4.9913321E-03
     +,   5.1200804E-03,   5.2528605E-03,   5.3903847E-03
     +,   5.5334298E-03,   5.6828544E-03,   5.8395909E-03
     +,   6.0046534E-03,   6.1791386E-03,   6.3642259E-03
     +,   6.5612067E-03,   6.7714672E-03,   6.9965390E-03
     +,   7.2381091E-03,   7.4980734E-03,   7.7785733E-03
     +,   8.0820890E-03,   8.4114643E-03,   8.7700728E-03
     +,   9.1618802E-03,   9.5915999E-03,   1.0064849E-02
     +,   1.0588296E-02,   1.1169882E-02,   1.1818978E-02
     +,   1.2546632E-02,   1.3365717E-02,   1.4291150E-02
     +,   1.5340034E-02,   1.6531723E-02,   1.7887851E-02
     +,   1.9432325E-02,   2.1190902E-02,   2.3191132E-02
     +,   2.5461698E-02,   2.8031878E-02,   3.0930825E-02
     +,   3.4186870E-02,   3.7826706E-02,   4.1874841E-02
     +,   4.6352740E-02,   5.1279087E-02,   5.6669731E-02
     +,   6.2537402E-02,   6.8893842E-02,   7.5749382E-02
     +,   8.3116204E-02,   9.1008030E-02,   9.9444479E-02
     +,   0.1084523    ,   0.1180735    ,   0.1283722    
     +,   0.1394530    ,   0.1514806    ,   0.1647047    
     +,   0.1794822    ,   0.1962854    ,   0.2156826    
     +,   0.2382830    ,   0.2646663    ,   0.2952921    
     +,   0.3304415    ,   0.3701608    ,   0.4142256    
     +,   0.4620825    ,   0.5128611    ,   0.5655179    
     +,   0.6192791    ,   0.6742910    ,   0.7323059    
     +,   0.7970169    ,   0.8735487    ,   0.9665380    
     +,    1.076953    ,    1.199680    ,    1.325198    
     +,    1.445747    ,    1.559966    ,    1.669967    
     +,    1.774986    ,    1.871836    ,    1.960422    
     +,    2.042310    ,    2.112946    ,    2.161974    
     +,    2.183117    ,    2.179161    ,    2.155969    
     +,    2.113827    ,    2.044905    ,    1.940130    
     +,    1.801576    ,    1.647260    ,    1.500344    
     +,    1.374100    ,    1.268302    ,    1.176921    
     +,    1.095714    ,    1.023652    ,   0.9608333    
     +,   0.9070109    ,   0.8615770    ,   0.8236764    
     +,   0.7917638    ,   0.7632926    ,   0.7351525    
     +,   0.7046112    ,   0.6700938    ,   0.6313957    
     +,   0.5894521    ,   0.5458739    ,   0.5024996    
     +,   0.4610336    ,   0.4228218    ,   0.3887527    
     +,   0.3592301    ,   0.3342256    ,   0.3133761    
     +,   0.2961073    ,   0.2817518    ,   0.2696362    
     +,   0.2591318    ,   0.2496812    ,   0.2408073    
     +,   0.2321265    ,   0.2233616    ,   0.2143494    
     +,   0.2050381    ,   0.1954711    ,   0.1857616    
     +,   0.1760600    ,   0.1665228    ,   0.1572905    
     +,   0.1484713    ,   0.1401353    ,   0.1323139    
     +,   0.1250068    ,   0.1181917    ,   0.1118305    
     +,   0.1058800    ,   0.1002984    ,   9.5049486E-02
     +,   9.0105191E-02,   8.5446723E-02,   8.1064574E-02
     +,   7.6957002E-02,   7.3127873E-02,   6.9584884E-02
     +,   6.6338353E-02,   6.3398749E-02,   6.0775150E-02
     +,   5.8474399E-02,   5.6500029E-02,   5.4851335E-02
     +,   5.3523023E-02,   5.2505180E-02,   5.1783107E-02
     +,   5.1337600E-02,   5.1145393E-02,   5.1179860E-02
     +,   5.1411528E-02,   5.1809166E-02,   5.2340377E-02
     +,   5.2972686E-02,   5.3674269E-02,   5.4414816E-02
     +,   5.5166330E-02,   5.5903632E-02,   5.6605037E-02
     +,   5.7252690E-02,   5.7832640E-02,   5.8335163E-02
     +,   5.8754567E-02,   5.9088890E-02,   5.9339572E-02
     +,   5.9510950E-02,   5.9609611E-02,   5.9643798E-02
     +,   5.9622578E-02,   5.9555251E-02,   5.9450623E-02
     +,   5.9316408E-02,   5.9158783E-02,   5.8981963E-02
     +,   5.8787968E-02,   5.8576565E-02,   5.8345292E-02
     +,   5.8089688E-02,   5.7803575E-02,   5.7479516E-02
     +,   5.7109267E-02,   5.6684338E-02,   5.6196436E-02
     +,   5.5638190E-02,   5.5003360E-02,   5.4287408E-02
     +,   5.3487737E-02,   5.2603871E-02,   5.1637597E-02
     +,   5.0592687E-02,   4.9475148E-02,   4.8292667E-02
     +,   4.7054444E-02,   4.5770723E-02,   4.4452518E-02
     +,   4.3111224E-02,   4.1758012E-02,   4.0403545E-02
     +,   3.9057914E-02,   3.7730061E-02,   3.6427654E-02
     +,   3.5156950E-02,   3.3922955E-02,   3.2729045E-02
     +,   3.1577300E-02,   3.0468537E-02,   2.9402498E-02
     +,   2.8377863E-02,   2.7392527E-02,   2.6443901E-02
     +,   2.5528984E-02,   2.4644453E-02,   2.3786945E-02
     +,   2.2953240E-02,   2.2140242E-02,   2.1345122E-02
     +,   2.0565368E-02,   1.9798940E-02,   1.9044103E-02
     +,   1.8299565E-02,   1.7564455E-02,   1.6838303E-02
     +,   1.6120922E-02,   1.5412454E-02,   1.4713343E-02
     +,   1.4024268E-02,   1.3346030E-02,   1.2679569E-02
     +,   1.2025979E-02,   1.1386380E-02,   1.0761881E-02
     +,   1.0153575E-02,   9.5625697E-03,   8.9898370E-03
     +,   8.4362729E-03,   7.9026986E-03,   7.3898132E-03
     +,   6.8981545E-03,   6.4281318E-03,   5.9800548E-03
     +,   5.5540828E-03,   5.1502255E-03,   4.7683665E-03
     +,   4.4082971E-03,   4.0696608E-03,   3.7520346E-03
     +,   3.4548654E-03,   3.1775548E-03,   2.9193987E-03
     +,   2.6796702E-03,   2.4575598E-03,   2.2522549E-03
     +,   2.0628860E-03,   1.8885953E-03,   1.7284993E-03
     +,   1.5817179E-03,   1.4473933E-03,   1.3246652E-03
     +,   1.2127145E-03,   1.1107298E-03,   1.0179464E-03
     +,   9.3362090E-04,   8.5705699E-04,   7.8758656E-04
     +,   7.2459009E-04,   6.6747953E-04,   6.1571418E-04
     +,   5.6878559E-04,   5.2623032E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_ashz_htt75_mass = Yx/17.59506882
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_ashz_htt80_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.1290743E-03,   3.2473225E-03
     +,   3.3701903E-03,   3.4979426E-03,   3.6308484E-03
     +,   3.7691842E-03,   3.9132312E-03,   4.0632673E-03
     +,   4.2195679E-03,   4.3824068E-03,   4.5520370E-03
     +,   4.7287052E-03,   4.9126283E-03,   5.1040044E-03
     +,   5.3030010E-03,   5.5097491E-03,   5.7243425E-03
     +,   5.9468294E-03,   6.1772135E-03,   6.4154486E-03
     +,   6.6614314E-03,   6.9150073E-03,   7.1759606E-03
     +,   7.4440385E-03,   7.7189002E-03,   8.0001913E-03
     +,   8.2874810E-03,   8.5803075E-03,   8.8781705E-03
     +,   9.1805439E-03,   9.4868764E-03,   9.7966110E-03
     +,   1.0109197E-02,   1.0424095E-02,   1.0740794E-02
     +,   1.1058826E-02,   1.1377797E-02,   1.1697358E-02
     +,   1.2017284E-02,   1.2337434E-02,   1.2657796E-02
     +,   1.2978509E-02,   1.3299850E-02,   1.3622286E-02
     +,   1.3946472E-02,   1.4273274E-02,   1.4603808E-02
     +,   1.4939441E-02,   1.5281826E-02,   1.5632957E-02
     +,   1.5995190E-02,   1.6371286E-02,   1.6764477E-02
     +,   1.7178541E-02,   1.7617812E-02,   1.8087309E-02
     +,   1.8592756E-02,   1.9140678E-02,   1.9738404E-02
     +,   2.0394130E-02,   2.1116897E-02,   2.1916538E-02
     +,   2.2803523E-02,   2.3788922E-02,   2.4884079E-02
     +,   2.6100202E-02,   2.7448276E-02,   2.8938238E-02
     +,   3.0578887E-02,   3.2377038E-02,   3.4337491E-02
     +,   3.6462221E-02,   3.8750682E-02,   4.1199349E-02
     +,   4.3802470E-02,   4.6552591E-02,   4.9441390E-02
     +,   5.2461158E-02,   5.5606920E-02,   5.8878127E-02
     +,   6.2280383E-02,   6.5828279E-02,   6.9546126E-02
     +,   7.3469959E-02,   7.7646829E-02,   8.2135417E-02
     +,   8.7003648E-02,   9.2328392E-02,   9.8192669E-02
     +,   0.1046854    ,   0.1119008    ,   0.1199366    
     +,   0.1288944    ,   0.1388770    ,   0.1499853    
     +,   0.1623138    ,   0.1759551    ,   0.1910095    
     +,   0.2076149    ,   0.2259800    ,   0.2464186    
     +,   0.2693428    ,   0.2952071    ,   0.3243804    
     +,   0.3570132    ,   0.3929644    ,   0.4318996    
     +,   0.4736188    ,   0.5185297    ,   0.5680087    
     +,   0.6243107    ,   0.6898580    ,   0.7661711    
     +,   0.8532624    ,   0.9499795    ,    1.054952    
     +,    1.166938    ,    1.284623    ,    1.406954    
     +,    1.534077    ,    1.666502    ,    1.802653    
     +,    1.939345    ,    2.074174    ,    2.200593    
     +,    2.299743    ,    2.349295    ,    2.347893    
     +,    2.322490    ,    2.304830    ,    2.303998    
     +,    2.301994    ,    2.270047    ,    2.189333    
     +,    2.062685    ,    1.910833    ,    1.757106    
     +,    1.613959    ,    1.481988    ,    1.359362    
     +,    1.249591    ,    1.158964    ,    1.088386    
     +,    1.030585    ,   0.9752994    ,   0.9158342    
     +,   0.8510432    ,   0.7832597    ,   0.7156702    
     +,   0.6510815    ,   0.5917251    ,   0.5391890    
     +,   0.4942047    ,   0.4565103    ,   0.4250036    
     +,   0.3981246    ,   0.3742752    ,   0.3521239    
     +,   0.3307395    ,   0.3095963    ,   0.2884910    
     +,   0.2674511    ,   0.2466447    ,   0.2263066    
     +,   0.2066856    ,   0.1880119    ,   0.1704802    
     +,   0.1542401    ,   0.1393956    ,   0.1260097    
     +,   0.1141107    ,   0.1036956    ,   9.4735026E-02
     +,   8.7176561E-02,   8.0949180E-02,   7.5964265E-02
     +,   7.2120629E-02,   6.9308221E-02,   6.7412764E-02
     +,   6.6319942E-02,   6.5920204E-02,   6.6111609E-02
     +,   6.6802360E-02,   6.7911655E-02,   6.9369778E-02
     +,   7.1116872E-02,   7.3101260E-02,   7.5277500E-02
     +,   7.7604294E-02,   8.0041744E-02,   8.2550190E-02
     +,   8.5088521E-02,   8.7613054E-02,   9.0077251E-02
     +,   9.2432320E-02,   9.4627716E-02,   9.6612655E-02
     +,   9.8337896E-02,   9.9758260E-02,   0.1008344    
     +,   0.1015353    ,   0.1018400    ,   0.1017395    
     +,   0.1012367    ,   0.1003484    ,   9.9102877E-02
     +,   9.7539678E-02,   9.5708065E-02,   9.3663968E-02
     +,   9.1468096E-02,   8.9182116E-02,   8.6867012E-02
     +,   8.4580012E-02,   8.2371816E-02,   8.0285229E-02
     +,   7.8353956E-02,   7.6601394E-02,   7.5040355E-02
     +,   7.3673412E-02,   7.2493546E-02,   7.1485132E-02
     +,   7.0625134E-02,   6.9884814E-02,   6.9231339E-02
     +,   6.8629451E-02,   6.8042941E-02,   6.7436635E-02
     +,   6.6777453E-02,   6.6035680E-02,   6.5186061E-02
     +,   6.4208448E-02,   6.3088290E-02,   6.1816704E-02
     +,   6.0390599E-02,   5.8812309E-02,   5.7089061E-02
     +,   5.5232365E-02,   5.3257383E-02,   5.1182114E-02
     +,   4.9026292E-02,   4.6810739E-02,   4.4556752E-02
     +,   4.2285271E-02,   4.0016070E-02,   3.7767421E-02
     +,   3.5556030E-02,   3.3396456E-02,   3.1300869E-02
     +,   2.9279232E-02,   2.7339524E-02,   2.5487401E-02
     +,   2.3726648E-02,   2.2059446E-02,   2.0486461E-02
     +,   1.9007003E-02,   1.7619373E-02,   1.6321117E-02
     +,   1.5109149E-02,   1.3979831E-02,   1.2929227E-02
     +,   1.1953275E-02,   1.1047818E-02,   1.0208630E-02
     +,   9.4315344E-03,   8.7125460E-03,   8.0477362E-03
     +,   7.4333395E-03,   6.8658064E-03,   6.3417847E-03
     +,   5.8580609E-03,   5.4116291E-03,   4.9996981E-03
     +,   4.6196626E-03,   4.2690733E-03,   3.9456510E-03
     +,   3.6473190E-03,   3.3721130E-03,   3.1182556E-03
     +,   2.8840720E-03,   2.6680480E-03,   2.4687618E-03
     +,   2.2849282E-03,   2.1153411E-03,   1.9589108E-03
     +,   1.8146142E-03,   1.6815265E-03,   1.5587826E-03
     +,   1.4455848E-03,   1.3412077E-03,   1.2449671E-03
     +,   1.1562427E-03,   1.0744509E-03,   9.9906069E-04
     +,   9.2957122E-04,   8.6552784E-04,   8.0650119E-04
     +,   7.5210084E-04,   7.0195855E-04,   6.5573957E-04
     +,   6.1312824E-04,   5.7383796E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_ashz_htt80_mass = Yx/18.78845304
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_ashz_htt85_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.2223007E-03,   1.2509250E-03
     +,   1.2798278E-03,   1.3090064E-03,   1.3384602E-03
     +,   1.3681898E-03,   1.3981973E-03,   1.4284879E-03
     +,   1.4590682E-03,   1.4899496E-03,   1.5211448E-03
     +,   1.5526701E-03,   1.5845463E-03,   1.6167985E-03
     +,   1.6494555E-03,   1.6825539E-03,   1.7161329E-03
     +,   1.7502408E-03,   1.7849315E-03,   1.8202682E-03
     +,   1.8563214E-03,   1.8931729E-03,   1.9309126E-03
     +,   1.9696457E-03,   2.0094858E-03,   2.0505646E-03
     +,   2.0930262E-03,   2.1370326E-03,   2.1827638E-03
     +,   2.2304186E-03,   2.2802176E-03,   2.3324043E-03
     +,   2.3872466E-03,   2.4450389E-03,   2.5061022E-03
     +,   2.5707886E-03,   2.6394809E-03,   2.7125932E-03
     +,   2.7905782E-03,   2.8739157E-03,   2.9631318E-03
     +,   3.0587832E-03,   3.1614651E-03,   3.2718112E-03
     +,   3.3904945E-03,   3.5182235E-03,   3.6557398E-03
     +,   3.8038234E-03,   3.9632828E-03,   4.1349554E-03
     +,   4.3197079E-03,   4.5184209E-03,   4.7319974E-03
     +,   4.9613584E-03,   5.2074087E-03,   5.4710754E-03
     +,   5.7532652E-03,   6.0548708E-03,   6.3767573E-03
     +,   6.7197625E-03,   7.0846812E-03,   7.4722553E-03
     +,   7.8831520E-03,   8.3179800E-03,   8.7772859E-03
     +,   9.2614619E-03,   9.7708674E-03,   1.0305667E-02
     +,   1.0865984E-02,   1.1451725E-02,   1.2062730E-02
     +,   1.2698617E-02,   1.3358944E-02,   1.4043058E-02
     +,   1.4750230E-02,   1.5479688E-02,   1.6230537E-02
     +,   1.7001932E-02,   1.7793177E-02,   1.8603794E-02
     +,   1.9433584E-02,   2.0282984E-02,   2.1152979E-02
     +,   2.2045610E-02,   2.2963913E-02,   2.3912355E-02
     +,   2.4896881E-02,   2.5925338E-02,   2.7007453E-02
     +,   2.8155219E-02,   2.9383082E-02,   3.0708058E-02
     +,   3.2150086E-02,   3.3732623E-02,   3.5483174E-02
     +,   3.7433870E-02,   3.9623030E-02,   4.2095777E-02
     +,   4.4905882E-02,   4.8116107E-02,   5.1799156E-02
     +,   5.6036431E-02,   6.0916353E-02,   6.6529579E-02
     +,   7.2963580E-02,   8.0295473E-02,   8.8583171E-02
     +,   9.7859353E-02,   0.1081291    ,   0.1193714    
     +,   0.1315463    ,   0.1446125    ,   0.1585406    
     +,   0.1733318    ,   0.1890179    ,   0.2056553    
     +,   0.2232969    ,   0.2419696    ,   0.2616597    
     +,   0.2823538    ,   0.3041287    ,   0.3272970    
     +,   0.3525515    ,   0.3810165    ,   0.4140959    
     +,   0.4530854    ,   0.4986919    ,   0.5507736    
     +,   0.6087468    ,   0.6726567    ,   0.7443059    
     +,   0.8272049    ,   0.9247537    ,    1.037403    
     +,    1.161150    ,    1.289187    ,    1.415967    
     +,    1.539626    ,    1.659288    ,    1.770319    
     +,    1.865102    ,    1.940765    ,    2.004368    
     +,    2.066789    ,    2.131264    ,    2.191926    
     +,    2.245013    ,    2.295152    ,    2.346941    
     +,    2.395376    ,    2.427118    ,    2.430325    
     +,    2.403136    ,    2.348808    ,    2.263640    
     +,    2.138624    ,    1.974014    ,    1.785978    
     +,    1.598207    ,    1.429319    ,    1.285875    
     +,    1.163984    ,    1.056378    ,   0.9582212    
     +,   0.8675759    ,   0.7829212    ,   0.7020243    
     +,   0.6230617    ,   0.5459915    ,   0.4725590    
     +,   0.4051661    ,   0.3457436    ,   0.2953085    
     +,   0.2540825    ,   0.2217509    ,   0.1976314    
     +,   0.1807793    ,   0.1700953    ,   0.1644558    
     +,   0.1628332    ,   0.1643654    ,   0.1683606    
     +,   0.1742555    ,   0.1815566    ,   0.1897877    
     +,   0.1984567    ,   0.2070490    ,   0.2150409    
     +,   0.2219294    ,   0.2272692    ,   0.2307145    
     +,   0.2320503    ,   0.2312169    ,   0.2283157    
     +,   0.2236010    ,   0.2174526    ,   0.2103377    
     +,   0.2027651    ,   0.1952327    ,   0.1881866    
     +,   0.1819851    ,   0.1768758    ,   0.1729882    
     +,   0.1703374    ,   0.1688395    ,   0.1683322    
     +,   0.1685985    ,   0.1693898    ,   0.1704457    
     +,   0.1715105    ,   0.1723442    ,   0.1727316    
     +,   0.1724881    ,   0.1714650    ,   0.1695544    
     +,   0.1666929    ,   0.1628650    ,   0.1581049    
     +,   0.1524943    ,   0.1461595    ,   0.1392606    
     +,   0.1319821    ,   0.1245195    ,   0.1170649    
     +,   0.1097934    ,   0.1028535    ,   9.6359529E-02
     +,   9.0388291E-02,   8.4977970E-02,   8.0132261E-02
     +,   7.5825892E-02,   7.2011136E-02,   6.8624891E-02
     +,   6.5595970E-02,   6.2851541E-02,   6.0321297E-02
     +,   5.7941806E-02,   5.5658687E-02,   5.3427957E-02
     +,   5.1216107E-02,   4.9000058E-02,   4.6766337E-02
     +,   4.4509724E-02,   4.2231847E-02,   3.9939843E-02
     +,   3.7645023E-02,   3.5361461E-02,   3.3104591E-02
     +,   3.0890217E-02,   2.8733995E-02,   2.6650084E-02
     +,   2.4650998E-02,   2.2747211E-02,   2.0946940E-02
     +,   1.9255860E-02,   1.7677344E-02,   1.6212642E-02
     +,   1.4861044E-02,   1.3619999E-02,   1.2485544E-02
     +,   1.1452665E-02,   1.0515487E-02,   9.6674925E-03
     +,   8.9018568E-03,   8.2117114E-03,   7.5901747E-03
     +,   7.0305765E-03,   6.5266108E-03,   6.0723466E-03
     +,   5.6622648E-03,   5.2913330E-03,   4.9550054E-03
     +,   4.6492154E-03,   4.3703192E-03,   4.1151061E-03
     +,   3.8807776E-03,   3.6648661E-03,   3.4652525E-03
     +,   3.2800762E-03,   3.1077550E-03,   2.9469007E-03
     +,   2.7963391E-03,   2.6550400E-03,   2.5221317E-03
     +,   2.3968415E-03,   2.2785198E-03,   2.1665869E-03
     +,   2.0605377E-03,   1.9599400E-03,   1.8643993E-03
     +,   1.7735782E-03,   1.6871655E-03,   1.6048932E-03
     +,   1.5265105E-03,   1.4518006E-03,   1.3805575E-03
     +,   1.3126023E-03,   1.2477631E-03,   1.1858895E-03
     +,   1.1268354E-03,   1.0704722E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_ashz_htt85_mass = Yx/19.57032546
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_ashz_htt90_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  8.7721716E-04,   9.0992206E-04
     +,   9.4387820E-04,   9.7912119E-04,   1.0156874E-03
     +,   1.0536123E-03,   1.0929315E-03,   1.1336802E-03
     +,   1.1758929E-03,   1.2196058E-03,   1.2648526E-03
     +,   1.3116669E-03,   1.3600828E-03,   1.4101336E-03
     +,   1.4618520E-03,   1.5152710E-03,   1.5704223E-03
     +,   1.6273388E-03,   1.6860516E-03,   1.7465928E-03
     +,   1.8089944E-03,   1.8732883E-03,   1.9395056E-03
     +,   2.0076833E-03,   2.0778489E-03,   2.1500411E-03
     +,   2.2242942E-03,   2.3006441E-03,   2.3791306E-03
     +,   2.4597931E-03,   2.5426745E-03,   2.6278209E-03
     +,   2.7152803E-03,   2.8051054E-03,   2.8973506E-03
     +,   2.9920784E-03,   3.0893532E-03,   3.1892450E-03
     +,   3.2918365E-03,   3.3972047E-03,   3.5054479E-03
     +,   3.6166639E-03,   3.7309648E-03,   3.8484698E-03
     +,   3.9693126E-03,   4.0936363E-03,   4.2216014E-03
     +,   4.3533808E-03,   4.4891662E-03,   4.6291663E-03
     +,   4.7736098E-03,   4.9227499E-03,   5.0768582E-03
     +,   5.2362438E-03,   5.4012258E-03,   5.5721737E-03
     +,   5.7494757E-03,   5.9335604E-03,   6.1248951E-03
     +,   6.3239811E-03,   6.5313680E-03,   6.7476486E-03
     +,   6.9734487E-03,   7.2094565E-03,   7.4564074E-03
     +,   7.7150636E-03,   7.9862634E-03,   8.2708606E-03
     +,   8.5697807E-03,   8.8839624E-03,   9.2144106E-03
     +,   9.5621301E-03,   9.9281874E-03,   1.0313625E-02
     +,   1.0719542E-02,   1.1147032E-02,   1.1597163E-02
     +,   1.2071007E-02,   1.2569618E-02,   1.3094062E-02
     +,   1.3645316E-02,   1.4224415E-02,   1.4832285E-02
     +,   1.5469928E-02,   1.6138289E-02,   1.6838415E-02
     +,   1.7571317E-02,   1.8338203E-02,   1.9140318E-02
     +,   1.9979157E-02,   2.0856436E-02,   2.1774093E-02
     +,   2.2734353E-02,   2.3739811E-02,   2.4793394E-02
     +,   2.5898216E-02,   2.7057769E-02,   2.8275490E-02
     +,   2.9554995E-02,   3.0899536E-02,   3.2312177E-02
     +,   3.3795156E-02,   3.5350073E-02,   3.6977276E-02
     +,   3.8676105E-02,   4.0444594E-02,   4.2279493E-02
     +,   4.4176586E-02,   4.6131156E-02,   4.8138548E-02
     +,   5.0194848E-02,   5.2298266E-02,   5.4449994E-02
     +,   5.6655947E-02,   5.8927666E-02,   6.1284017E-02
     +,   6.3751847E-02,   6.6367090E-02,   6.9174312E-02
     +,   7.2227083E-02,   7.5586684E-02,   7.9320930E-02
     +,   8.3503030E-02,   8.8211372E-02,   9.3529351E-02
     +,   9.9545583E-02,   0.1063560    ,   0.1140628    
     +,   0.1227713    ,   0.1325809    ,   0.1435716    
     +,   0.1557827    ,   0.1691991    ,   0.1837366    
     +,   0.1992533    ,   0.2155752    ,   0.2325416    
     +,   0.2500675    ,   0.2682095    ,   0.2872259    
     +,   0.3076226    ,   0.3301685    ,   0.3558499    
     +,   0.3857414    ,   0.4208000    ,   0.4616748    
     +,   0.5086397    ,   0.5617689    ,   0.6213524    
     +,   0.6883020    ,   0.7641733    ,   0.8507156    
     +,   0.9492612    ,    1.060301    ,    1.182691    
     +,    1.311908    ,    1.438611    ,    1.550767    
     +,    1.640251    ,    1.709097    ,    1.768767    
     +,    1.831668    ,    1.901214    ,    1.967824    
     +,    2.013704    ,    2.022569    ,    1.987680    
     +,    1.913579    ,    1.810909    ,    1.688312    
     +,    1.549342    ,    1.397709    ,    1.243798    
     +,    1.103362    ,   0.9896743    ,   0.9081185    
     +,   0.8573264    ,   0.8332158    ,   0.8315377    
     +,   0.8481930    ,   0.8784840    ,   0.9164043    
     +,   0.9546427    ,   0.9856694    ,    1.003587    
     +,    1.005887    ,   0.9940940    ,   0.9727311    
     +,   0.9470221    ,   0.9205959    ,   0.8944342    
     +,   0.8674666    ,   0.8381137    ,   0.8056784    
     +,   0.7708762    ,   0.7355047    ,   0.7015842    
     +,   0.6704744    ,   0.6423855    ,   0.6164566    
     +,   0.5913024    ,   0.5656879    ,   0.5390196    
     +,   0.5115007    ,   0.4839802    ,   0.4575990    
     +,   0.4333968    ,   0.4119911    ,   0.3934051    
     +,   0.3770969    ,   0.3621629    ,   0.3476356    
     +,   0.3327624    ,   0.3171777    ,   0.3009303    
     +,   0.2843866    ,   0.2680642    ,   0.2524636    
     +,   0.2379525    ,   0.2247163    ,   0.2127615    
     +,   0.2019640    ,   0.1921270    ,   0.1830323    
     +,   0.1744783    ,   0.1663013    ,   0.1583831    
     +,   0.1506486    ,   0.1430578    ,   0.1355967    
     +,   0.1282697    ,   0.1210920    ,   0.1140836    
     +,   0.1072661    ,   0.1006618    ,   9.4291158E-02
     +,   8.8172600E-02,   8.2322814E-02,   7.6755658E-02
     +,   7.1481586E-02,   6.6507399E-02,   6.1836429E-02
     +,   5.7467539E-02,   5.3395148E-02,   4.9609490E-02
     +,   4.6097424E-02,   4.2842649E-02,   3.9826479E-02
     +,   3.7028778E-02,   3.4429405E-02,   3.2008257E-02
     +,   2.9746495E-02,   2.7627224E-02,   2.5635723E-02
     +,   2.3759523E-02,   2.1988615E-02,   2.0315373E-02
     +,   1.8734263E-02,   1.7241281E-02,   1.5833780E-02
     +,   1.4510123E-02,   1.3269203E-02,   1.2110040E-02
     +,   1.1031587E-02,   1.0032635E-02,   9.1114519E-03
     +,   8.2657989E-03,   7.4929884E-03,   6.7898165E-03
     +,   6.1525996E-03,   5.5772951E-03,   5.0596562E-03
     +,   4.5952615E-03,   4.1796146E-03,   3.8082569E-03
     +,   3.4768884E-03,   3.1813544E-03,   2.9177724E-03
     +,   2.6825056E-03,   2.4722437E-03,   2.2839573E-03
     +,   2.1149507E-03,   1.9628061E-03,   1.8254085E-03
     +,   1.7008916E-03,   1.5876492E-03,   1.4842799E-03
     +,   1.3895805E-03,   1.3025282E-03,   1.2222364E-03
     +,   1.1479601E-03,   1.0790525E-03,   1.0149704E-03
     +,   9.5524057E-04,   8.9946395E-04,   8.4728847E-04
     +,   7.9841563E-04,   7.5257866E-04,   7.0954801E-04
     +,   6.6911546E-04,   6.3109992E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_ashz_htt90_mass = Yx/18.64148454
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_ashz_htt95_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.4511275E-03,   1.4818197E-03
     +,   1.5132180E-03,   1.5453885E-03,   1.5784024E-03
     +,   1.6123372E-03,   1.6472755E-03,   1.6833062E-03
     +,   1.7205223E-03,   1.7590252E-03,   1.7989191E-03
     +,   1.8403144E-03,   1.8833266E-03,   1.9280751E-03
     +,   1.9746840E-03,   2.0232806E-03,   2.0739955E-03
     +,   2.1269615E-03,   2.1823130E-03,   2.2401847E-03
     +,   2.3007123E-03,   2.3640282E-03,   2.4302630E-03
     +,   2.4995473E-03,   2.5719986E-03,   2.6477375E-03
     +,   2.7268725E-03,   2.8095022E-03,   2.8957161E-03
     +,   2.9855934E-03,   3.0791981E-03,   3.1765811E-03
     +,   3.2777747E-03,   3.3827987E-03,   3.4916503E-03
     +,   3.6043075E-03,   3.7207324E-03,   3.8408595E-03
     +,   3.9646081E-03,   4.0918682E-03,   4.2225141E-03
     +,   4.3563941E-03,   4.4933339E-03,   4.6331384E-03
     +,   4.7755926E-03,   4.9204607E-03,   5.0674882E-03
     +,   5.2164062E-03,   5.3669265E-03,   5.5187508E-03
     +,   5.6715691E-03,   5.8250683E-03,   5.9789228E-03
     +,   6.1328150E-03,   6.2864204E-03,   6.4394232E-03
     +,   6.5915221E-03,   6.7424118E-03,   6.8918271E-03
     +,   7.0394990E-03,   7.1852007E-03,   7.3287217E-03
     +,   7.4698832E-03,   7.6085478E-03,   7.7446150E-03
     +,   7.8780157E-03,   8.0087371E-03,   8.1368042E-03
     +,   8.2622925E-03,   8.3853286E-03,   8.5060932E-03
     +,   8.6248135E-03,   8.7417793E-03,   8.8573322E-03
     +,   8.9718672E-03,   9.0858387E-03,   9.1997497E-03
     +,   9.3141533E-03,   9.4296662E-03,   9.5469570E-03
     +,   9.6667288E-03,   9.7897500E-03,   9.9168150E-03
     +,   1.0048785E-02,   1.0186547E-02,   1.0331047E-02
     +,   1.0483245E-02,   1.0644170E-02,   1.0814870E-02
     +,   1.0996444E-02,   1.1190036E-02,   1.1396823E-02
     +,   1.1618036E-02,   1.1854969E-02,   1.2108980E-02
     +,   1.2381461E-02,   1.2673919E-02,   1.2987921E-02
     +,   1.3325145E-02,   1.3687363E-02,   1.4076483E-02
     +,   1.4494481E-02,   1.4943550E-02,   1.5425940E-02
     +,   1.5944086E-02,   1.6500568E-02,   1.7098056E-02
     +,   1.7739337E-02,   1.8427324E-02,   1.9164998E-02
     +,   1.9955302E-02,   2.0801220E-02,   2.1705583E-02
     +,   2.2671107E-02,   2.3700170E-02,   2.4794906E-02
     +,   2.5956843E-02,   2.7187075E-02,   2.8485885E-02
     +,   2.9852865E-02,   3.1286828E-02,   3.2785662E-02
     +,   3.4346417E-02,   3.5965689E-02,   3.7639603E-02
     +,   3.9364222E-02,   4.1136313E-02,   4.2953681E-02
     +,   4.4816371E-02,   4.6727177E-02,   4.8693016E-02
     +,   5.0725464E-02,   5.2842107E-02,   5.5066705E-02
     +,   5.7429925E-02,   5.9969254E-02,   6.2728472E-02
     +,   6.5756813E-02,   6.9108009E-02,   7.2838277E-02
     +,   7.7004023E-02,   8.1659496E-02,   8.6853988E-02
     +,   9.2628449E-02,   9.9011503E-02,   0.1060169    
     +,   0.1136412    ,   0.1218620    ,   0.1306405    
     +,   0.1399276    ,   0.1496730    ,   0.1598386    
     +,   0.1704157    ,   0.1814429    ,   0.1930192    
     +,   0.2053057    ,   0.2185112    ,   0.2328533    
     +,   0.2484904    ,   0.2654315    ,   0.2834487    
     +,   0.3020114    ,   0.3202797    ,   0.3371875    
     +,   0.3516057    ,   0.3625591    ,   0.3694334    
     +,   0.3721195    ,   0.3710410    ,   0.3670805    
     +,   0.3614370    ,   0.3554942    ,   0.3507161    
     +,   0.3485994    ,   0.3506379    ,   0.3582996    
     +,   0.3730610    ,   0.3965521    ,   0.4307990    
     +,   0.4784231    ,   0.5426362    ,   0.6270408    
     +,   0.7354411    ,   0.8716784    ,    1.039015    
     +,    1.238190    ,    1.463431    ,    1.697999    
     +,    1.916656    ,    2.102967    ,    2.267587    
     +,    2.432233    ,    2.581806    ,    2.656972    
     +,    2.621052    ,    2.506397    ,    2.372849    
     +,    2.256336    ,    2.165502    ,    2.092915    
     +,    2.024952    ,    1.949190    ,    1.854229    
     +,    1.735868    ,    1.606222    ,    1.484697    
     +,    1.379194    ,    1.283512    ,    1.191526    
     +,    1.106786    ,    1.037224    ,   0.9850039    
     +,   0.9432765    ,   0.9010963    ,   0.8504172    
     +,   0.7897307    ,   0.7230671    ,   0.6565540    
     +,   0.5953671    ,   0.5423599    ,   0.4981061    
     +,   0.4616034    ,   0.4310546    ,   0.4044986    
     +,   0.3802301    ,   0.3570103    ,   0.3341172    
     +,   0.3112890    ,   0.2886256    ,   0.2664680    
     +,   0.2452824    ,   0.2255451    ,   0.2076499    
     +,   0.1918493    ,   0.1782283    ,   0.1667062    
     +,   0.1570679    ,   0.1490092    ,   0.1421821    
     +,   0.1362352    ,   0.1308455    ,   0.1257367    
     +,   0.1206892    ,   0.1155419    ,   0.1101904    
     +,   0.1045824    ,   9.8710798E-02,   9.2604794E-02
     +,   8.6321540E-02,   7.9937749E-02,   7.3539667E-02
     +,   6.7215823E-02,   6.1050765E-02,   5.5119731E-02
     +,   4.9484827E-02,   4.4193771E-02,   3.9279804E-02
     +,   3.4761924E-02,   3.0646192E-02,   2.6927913E-02
     +,   2.3594033E-02,   2.0624956E-02,   1.7996365E-02
     +,   1.5681250E-02,   1.3651545E-02,   1.1878858E-02
     +,   1.0335593E-02,   8.9957034E-03,   7.8349290E-03
     +,   6.8309871E-03,   5.9637702E-03,   5.2153631E-03
     +,   4.5698774E-03,   4.0132939E-03,   3.5333557E-03
     +,   3.1194263E-03,   2.7622192E-03,   2.4537365E-03
     +,   2.1870271E-03,   1.9561285E-03,   1.7558781E-03
     +,   1.5818576E-03,   1.4302547E-03,   1.2978194E-03
     +,   1.1817544E-03,   1.0796868E-03,   9.8958274E-04
     +,   9.0971496E-04,   8.3862367E-04,   7.7506283E-04
     +,   7.1798620E-04,   6.6650059E-04,   6.1985938E-04
     +,   5.7742390E-04,   5.3866027E-04,   5.0311128E-04
     +,   4.7039374E-04,   4.4017777E-04,   4.1218620E-04
     +,   3.8617887E-04,   3.6195316E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_ashz_htt95_mass = Yx/18.54154596
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_ashz_ttz100_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.8750990E-04,   1.9629594E-04
     +,   2.0540024E-04,   2.1483231E-04,   2.2460250E-04
     +,   2.3472153E-04,   2.4520111E-04,   2.5605358E-04
     +,   2.6729208E-04,   2.7893123E-04,   2.9098615E-04
     +,   3.0347341E-04,   3.1641056E-04,   3.2981668E-04
     +,   3.4371225E-04,   3.5811891E-04,   3.7306035E-04
     +,   3.8856140E-04,   4.0464886E-04,   4.2135129E-04
     +,   4.3869874E-04,   4.5672330E-04,   4.7545848E-04
     +,   4.9494085E-04,   5.1520648E-04,   5.3629541E-04
     +,   5.5824808E-04,   5.8110669E-04,   6.0491491E-04
     +,   6.2971725E-04,   6.5556006E-04,   6.8248960E-04
     +,   7.1055332E-04,   7.3979824E-04,   7.7027193E-04
     +,   8.0202101E-04,   8.3509175E-04,   8.6952775E-04
     +,   9.0537401E-04,   9.4266928E-04,   9.8145311E-04
     +,   1.0217603E-03,   1.0636222E-03,   1.1070665E-03
     +,   1.1521166E-03,   1.1987907E-03,   1.2471016E-03
     +,   1.2970576E-03,   1.3486602E-03,   1.4019060E-03
     +,   1.4567847E-03,   1.5132807E-03,   1.5713716E-03
     +,   1.6310333E-03,   1.6922295E-03,   1.7549268E-03
     +,   1.8190830E-03,   1.8846543E-03,   1.9515951E-03
     +,   2.0198578E-03,   2.0893940E-03,   2.1601601E-03
     +,   2.2321097E-03,   2.3052036E-03,   2.3794125E-03
     +,   2.4547046E-03,   2.5310675E-03,   2.6084874E-03
     +,   2.6869744E-03,   2.7665389E-03,   2.8472161E-03
     +,   2.9290465E-03,   3.0120949E-03,   3.0964308E-03
     +,   3.1821481E-03,   3.2693548E-03,   3.3581683E-03
     +,   3.4487171E-03,   3.5411464E-03,   3.6356130E-03
     +,   3.7322678E-03,   3.8312797E-03,   3.9328039E-03
     +,   4.0370072E-03,   4.1440339E-03,   4.2540319E-03
     +,   4.3671262E-03,   4.4834302E-03,   4.6030288E-03
     +,   4.7259913E-03,   4.8523657E-03,   4.9821618E-03
     +,   5.1153633E-03,   5.2519366E-03,   5.3918241E-03
     +,   5.5349316E-03,   5.6811646E-03,   5.8303983E-03
     +,   5.9825196E-03,   6.1373971E-03,   6.2949271E-03
     +,   6.4550061E-03,   6.6175694E-03,   6.7825778E-03
     +,   6.9500413E-03,   7.1200295E-03,   7.2926618E-03
     +,   7.4681118E-03,   7.6466426E-03,   7.8285858E-03
     +,   8.0143167E-03,   8.2043046E-03,   8.3990609E-03
     +,   8.5991602E-03,   8.8052005E-03,   9.0178307E-03
     +,   9.2376927E-03,   9.4654486E-03,   9.7017325E-03
     +,   9.9471696E-03,   1.0202354E-02,   1.0467823E-02
     +,   1.0744070E-02,   1.1031573E-02,   1.1330760E-02
     +,   1.1642020E-02,   1.1965776E-02,   1.2302415E-02
     +,   1.2652405E-02,   1.3016245E-02,   1.3394568E-02
     +,   1.3788075E-02,   1.4197672E-02,   1.4624379E-02
     +,   1.5069435E-02,   1.5534270E-02,   1.6020477E-02
     +,   1.6529815E-02,   1.7064217E-02,   1.7625734E-02
     +,   1.8216427E-02,   1.8838329E-02,   1.9493392E-02
     +,   2.0183414E-02,   2.0909747E-02,   2.1673428E-02
     +,   2.2474917E-02,   2.3313908E-02,   2.4189316E-02
     +,   2.5099142E-02,   2.6040368E-02,   2.7008796E-02
     +,   2.7999079E-02,   2.9004728E-02,   3.0018166E-02
     +,   3.1030688E-02,   3.2032702E-02,   3.3013999E-02
     +,   3.3963952E-02,   3.4871768E-02,   3.5727020E-02
     +,   3.6520019E-02,   3.7242122E-02,   3.7886295E-02
     +,   3.8447563E-02,   3.8923208E-02,   3.9313078E-02
     +,   3.9619759E-02,   3.9848488E-02,   4.0006977E-02
     +,   4.0105172E-02,   4.0154852E-02,   4.0169384E-02
     +,   4.0163800E-02,   4.0155161E-02,   4.0163741E-02
     +,   4.0215079E-02,   4.0342931E-02,   4.0593162E-02
     +,   4.1027952E-02,   4.1730367E-02,   4.2807572E-02
     +,   4.4392727E-02,   4.6643890E-02,   4.9739577E-02
     +,   5.3870093E-02,   5.9225280E-02,   6.5980144E-02
     +,   7.4278720E-02,   8.4216975E-02,   9.5830344E-02
     +,   0.1090816    ,   0.1238562    ,   0.1399727    
     +,   0.1572218    ,   0.1754399    ,   0.1946162    
     +,   0.2150055    ,   0.2371960    ,   0.2620730    
     +,   0.2906458    ,   0.3237416    ,   0.3616272    
     +,   0.4037452    ,   0.4488399    ,   0.4955905    
     +,   0.5433074    ,   0.5919474    ,   0.6413801    
     +,   0.6909013    ,   0.7396758    ,   0.7870410    
     +,   0.8312513    ,   0.8680555    ,   0.8923879    
     +,   0.9026660    ,   0.9017910    ,   0.8919320    
     +,   0.8697656    ,   0.8299575    ,   0.7737185    
     +,   0.7118787    ,   0.6582928    ,   0.6201628    
     +,   0.5940793    ,   0.5701398    ,   0.5395074    
     +,   0.4992000    ,   0.4516908    ,   0.4016218    
     +,   0.3531285    ,   0.3091054    ,   0.2714827    
     +,   0.2413563    ,   0.2187573    ,   0.2025252    
     +,   0.1906248    ,   0.1807916    ,   0.1711714    
     +,   0.1606849    ,   0.1490489    ,   0.1365577    
     +,   0.1237802    ,   0.1113004    ,   9.9562064E-02
     +,   8.8817813E-02,   7.9147413E-02,   7.0512444E-02
     +,   6.2815085E-02,   5.5943128E-02,   4.9793448E-02
     +,   4.4281073E-02,   3.9337814E-02,   3.4906015E-02
     +,   3.0933198E-02,   2.7369728E-02,   2.4168596E-02
     +,   2.1286452E-02,   1.8685048E-02,   1.6332678E-02
     +,   1.4204469E-02,   1.2281568E-02,   1.0549737E-02
     +,   8.9978985E-03,   7.6167681E-03,   6.3973172E-03
     +,   5.3301351E-03,   4.4050571E-03,   3.6110003E-03
     +,   2.9361038E-03,   2.3680963E-03,   1.8946972E-03
     +,   1.5039081E-03,   1.1843030E-03,   9.2528609E-04
     +,   7.1725971E-04,   5.5164169E-04,   4.2093787E-04
     +,   3.1866721E-04,   2.3933359E-04,   1.7831408E-04
     +,   1.3178475E-04,   9.6606520E-05,   7.0241040E-05
     +,   5.0650451E-05,   3.6221620E-05,   2.5687234E-05
     +,   1.8063702E-05,   1.2595862E-05,   8.7087456E-06
     +,   5.9701765E-06,   4.0578930E-06,   2.7346223E-06
     +,   1.8270815E-06,   1.2102821E-06,   7.9481288E-07
     +,   5.1748555E-07,   3.3401636E-07,   2.1373668E-07
     +,   1.3558527E-07,   8.5265448E-08
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_ashz_ttz100_mass = Yx/6.30255613953488
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_ashz_ttz105_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.2646966E-03,   1.2812708E-03
     +,   1.2968951E-03,   1.3115451E-03,   1.3252003E-03
     +,   1.3378434E-03,   1.3494622E-03,   1.3600487E-03
     +,   1.3695991E-03,   1.3781149E-03,   1.3856014E-03
     +,   1.3920682E-03,   1.3975302E-03,   1.4020064E-03
     +,   1.4055201E-03,   1.4080990E-03,   1.4097751E-03
     +,   1.4105844E-03,   1.4105660E-03,   1.4097642E-03
     +,   1.4082245E-03,   1.4059971E-03,   1.4031349E-03
     +,   1.3996931E-03,   1.3957289E-03,   1.3913019E-03
     +,   1.3864730E-03,   1.3813055E-03,   1.3758620E-03
     +,   1.3702069E-03,   1.3644047E-03,   1.3585199E-03
     +,   1.3526168E-03,   1.3467588E-03,   1.3410092E-03
     +,   1.3354291E-03,   1.3300793E-03,   1.3250184E-03
     +,   1.3203031E-03,   1.3159894E-03,   1.3121298E-03
     +,   1.3087754E-03,   1.3059754E-03,   1.3037770E-03
     +,   1.3022249E-03,   1.3013625E-03,   1.3012311E-03
     +,   1.3018710E-03,   1.3033208E-03,   1.3056191E-03
     +,   1.3088036E-03,   1.3129126E-03,   1.3179850E-03
     +,   1.3240612E-03,   1.3311829E-03,   1.3393961E-03
     +,   1.3487492E-03,   1.3592956E-03,   1.3710938E-03
     +,   1.3842084E-03,   1.3987118E-03,   1.4146840E-03
     +,   1.4322137E-03,   1.4513999E-03,   1.4723539E-03
     +,   1.4951952E-03,   1.5200581E-03,   1.5470881E-03
     +,   1.5764458E-03,   1.6083018E-03,   1.6428436E-03
     +,   1.6802677E-03,   1.7207880E-03,   1.7646236E-03
     +,   1.8120089E-03,   1.8631874E-03,   1.9184049E-03
     +,   1.9779128E-03,   2.0419669E-03,   2.1108210E-03
     +,   2.1847186E-03,   2.2639029E-03,   2.3485920E-03
     +,   2.4389988E-03,   2.5353003E-03,   2.6376571E-03
     +,   2.7461844E-03,   2.8609713E-03,   2.9820497E-03
     +,   3.1094116E-03,   3.2429977E-03,   3.3826809E-03
     +,   3.5282709E-03,   3.6795225E-03,   3.8361237E-03
     +,   3.9976765E-03,   4.1637332E-03,   4.3337573E-03
     +,   4.5071654E-03,   4.6832883E-03,   4.8614163E-03
     +,   5.0407634E-03,   5.2205184E-03,   5.3998050E-03
     +,   5.5777314E-03,   5.7533849E-03,   5.9258314E-03
     +,   6.0941326E-03,   6.2573771E-03,   6.4146766E-03
     +,   6.5651592E-03,   6.7080292E-03,   6.8425243E-03
     +,   6.9679758E-03,   7.0837759E-03,   7.1894270E-03
     +,   7.2845113E-03,   7.3687327E-03,   7.4418886E-03
     +,   7.5038970E-03,   7.5547900E-03,   7.5947102E-03
     +,   7.6239067E-03,   7.6427427E-03,   7.6516741E-03
     +,   7.6512522E-03,   7.6421127E-03,   7.6249605E-03
     +,   7.6005631E-03,   7.5697405E-03,   7.5333444E-03
     +,   7.4922489E-03,   7.4473410E-03,   7.3995041E-03
     +,   7.3496047E-03,   7.2984719E-03,   7.2469069E-03
     +,   7.1956613E-03,   7.1454155E-03,   7.0967921E-03
     +,   7.0503410E-03,   7.0065320E-03,   6.9657560E-03
     +,   6.9283191E-03,   6.8944539E-03,   6.8643051E-03
     +,   6.8379482E-03,   6.8153860E-03,   6.7965626E-03
     +,   6.7813559E-03,   6.7696129E-03,   6.7611332E-03
     +,   6.7557022E-03,   6.7530945E-03,   6.7530880E-03
     +,   6.7554908E-03,   6.7601488E-03,   6.7669768E-03
     +,   6.7759803E-03,   6.7872866E-03,   6.8011805E-03
     +,   6.8181478E-03,   6.8389173E-03,   6.8645268E-03
     +,   6.8963859E-03,   6.9363466E-03,   6.9867978E-03
     +,   7.0507391E-03,   7.1318969E-03,   7.2348174E-03
     +,   7.3649269E-03,   7.5286333E-03,   7.7333781E-03
     +,   7.9876473E-03,   8.3009051E-03,   8.6835558E-03
     +,   9.1467565E-03,   9.7021274E-03,   1.0361465E-02
     +,   1.1136319E-02,   1.2037540E-02,   1.3074589E-02
     +,   1.4255026E-02,   1.5583985E-02,   1.7063549E-02
     +,   1.8692205E-02,   2.0464512E-02,   2.2371162E-02
     +,   2.4398945E-02,   2.6530914E-02,   2.8747534E-02
     +,   3.1027602E-02,   3.3349529E-02,   3.5693370E-02
     +,   3.8043119E-02,   4.0388890E-02,   4.2729165E-02
     +,   4.5073051E-02,   4.7441736E-02,   4.9869027E-02
     +,   5.2399859E-02,   5.5087999E-02,   5.7991985E-02
     +,   6.1171331E-02,   6.4684153E-02,   6.8591259E-02
     +,   7.2967105E-02,   7.7918246E-02,   8.3604917E-02
     +,   9.0255357E-02,   9.8157503E-02,   0.1076172    
     +,   0.1188862    ,   0.1320799    ,   0.1471266    
     +,   0.1637851    ,   0.1817504    ,   0.2007956    
     +,   0.2208652    ,   0.2420761    ,   0.2647293    
     +,   0.2894835    ,   0.3176702    ,   0.3513074    
     +,   0.3922500    ,   0.4406635    ,   0.4942032    
     +,   0.5494358    ,   0.6050788    ,   0.6641074    
     +,   0.7317463    ,   0.8097423    ,   0.8910706    
     +,   0.9597436    ,   0.9973603    ,   0.9934943    
     +,   0.9532397    ,   0.8953423    ,   0.8405883    
     +,   0.7989304    ,   0.7661150    ,   0.7319189    
     +,   0.6910191    ,   0.6461976    ,   0.6029050    
     +,   0.5626435    ,   0.5218280    ,   0.4758151    
     +,   0.4231686    ,   0.3665302    ,   0.3104659    
     +,   0.2588752    ,   0.2137618    ,   0.1754291    
     +,   0.1432642    ,   0.1164083    ,   9.4082661E-02
     +,   7.5654052E-02,   6.0589757E-02,   4.8405848E-02
     +,   3.8642947E-02,   3.0869620E-02,   2.4698608E-02
     +,   1.9800941E-02,   1.5909189E-02,   1.2810921E-02
     +,   1.0339413E-02,   8.3637340E-03,   6.7804335E-03
     +,   5.5075567E-03,   4.4804784E-03,   3.6485987E-03
     +,   2.9724506E-03,   2.4212929E-03,   1.9711442E-03
     +,   1.6031695E-03,   1.3023185E-03,   1.0564897E-03
     +,   8.5578265E-04,   6.9209264E-04,   5.5871776E-04
     +,   4.5015154E-04,   3.6184955E-04,   2.9009732E-04
     +,   2.3184913E-04,   1.8462923E-04,   1.4641622E-04
     +,   1.1556421E-04,   9.0732872E-05,   7.0821945E-05
     +,   5.4930581E-05,   4.2314397E-05,   3.2359942E-05
     +,   2.4558231E-05,   1.8489147E-05,   1.3804863E-05
     +,   1.0219826E-05,   7.4998443E-06,   5.4549687E-06
     +,   3.9318179E-06,   2.8081165E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_ashz_ttz105_mass = Yx/5.6897805
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_ashz_ttz107_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  5.4191804E-04,   5.7229778E-04
     +,   6.0384133E-04,   6.3655368E-04,   6.7043689E-04
     +,   7.0549059E-04,   7.4171112E-04,   7.7909179E-04
     +,   8.1762258E-04,   8.5729262E-04,   8.9808571E-04
     +,   9.3998382E-04,   9.8296639E-04,   1.0270096E-03
     +,   1.0720878E-03,   1.1181728E-03,   1.1652343E-03
     +,   1.2132404E-03,   1.2621577E-03,   1.3119510E-03
     +,   1.3625843E-03,   1.4140214E-03,   1.4662241E-03
     +,   1.5191579E-03,   1.5727825E-03,   1.6270650E-03
     +,   1.6819685E-03,   1.7374593E-03,   1.7935042E-03
     +,   1.8500731E-03,   1.9071364E-03,   1.9646673E-03
     +,   2.0226419E-03,   2.0810373E-03,   2.1398342E-03
     +,   2.1990149E-03,   2.2585643E-03,   2.3184700E-03
     +,   2.3787227E-03,   2.4393110E-03,   2.5002295E-03
     +,   2.5614719E-03,   2.6230330E-03,   2.6849078E-03
     +,   2.7470915E-03,   2.8095774E-03,   2.8723609E-03
     +,   2.9354321E-03,   2.9987805E-03,   3.0623926E-03
     +,   3.1262517E-03,   3.1903379E-03,   3.2546250E-03
     +,   3.3190881E-03,   3.3836893E-03,   3.4483934E-03
     +,   3.5131571E-03,   3.5779318E-03,   3.6426657E-03
     +,   3.7073039E-03,   3.7717882E-03,   3.8360558E-03
     +,   3.9000434E-03,   3.9636889E-03,   4.0269312E-03
     +,   4.0897070E-03,   4.1519636E-03,   4.2136479E-03
     +,   4.2747203E-03,   4.3351427E-03,   4.3948977E-03
     +,   4.4539734E-03,   4.5123771E-03,   4.5701317E-03
     +,   4.6272790E-03,   4.6838853E-03,   4.7400324E-03
     +,   4.7958270E-03,   4.8514009E-03,   4.9069114E-03
     +,   4.9625346E-03,   5.0184764E-03,   5.0749602E-03
     +,   5.1322347E-03,   5.1905639E-03,   5.2502332E-03
     +,   5.3115371E-03,   5.3747832E-03,   5.4402831E-03
     +,   5.5083497E-03,   5.5792988E-03,   5.6534284E-03
     +,   5.7310201E-03,   5.8123441E-03,   5.8976440E-03
     +,   5.9871217E-03,   6.0809525E-03,   6.1792554E-03
     +,   6.2821177E-03,   6.3895537E-03,   6.5015410E-03
     +,   6.6179782E-03,   6.7387186E-03,   6.8635391E-03
     +,   6.9921534E-03,   7.1242228E-03,   7.2593330E-03
     +,   7.3970100E-03,   7.5367321E-03,   7.6779299E-03
     +,   7.8199720E-03,   7.9622101E-03,   8.1039397E-03
     +,   8.2444623E-03,   8.3830385E-03,   8.5189398E-03
     +,   8.6514307E-03,   8.7798005E-03,   8.9033395E-03
     +,   9.0213884E-03,   9.1333166E-03,   9.2385318E-03
     +,   9.3364920E-03,   9.4267214E-03,   9.5087998E-03
     +,   9.5823612E-03,   9.6471207E-03,   9.7028455E-03
     +,   9.7493771E-03,   9.7866207E-03,   9.8145464E-03
     +,   9.8331822E-03,   9.8426184E-03,   9.8429937E-03
     +,   9.8345000E-03,   9.8173739E-03,   9.7918920E-03
     +,   9.7583700E-03,   9.7171459E-03,   9.6685980E-03
     +,   9.6131200E-03,   9.5511377E-03,   9.4830906E-03
     +,   9.4094444E-03,   9.3306750E-03,   9.2472918E-03
     +,   9.1598118E-03,   9.0687973E-03,   8.9748297E-03
     +,   8.8785198E-03,   8.7805232E-03,   8.6815394E-03
     +,   8.5823284E-03,   8.4836977E-03,   8.3865179E-03
     +,   8.2917418E-03,   8.2004042E-03,   8.1136152E-03
     +,   8.0325799E-03,   7.9586059E-03,   7.8931013E-03
     +,   7.8375721E-03,   7.7936375E-03,   7.7630198E-03
     +,   7.7475356E-03,   7.7491095E-03,   7.7697434E-03
     +,   7.8115263E-03,   7.8766122E-03,   7.9671973E-03
     +,   8.0855126E-03,   8.2337847E-03,   8.4142312E-03
     +,   8.6290240E-03,   8.8802259E-03,   9.1697956E-03
     +,   9.4995443E-03,   9.8710489E-03,   1.0285638E-02
     +,   1.0744359E-02,   1.1247927E-02,   1.1796635E-02
     +,   1.2390332E-02,   1.3028456E-02,   1.3709946E-02
     +,   1.4433226E-02,   1.5196225E-02,   1.5996529E-02
     +,   1.6831372E-02,   1.7697750E-02,   1.8592769E-02
     +,   1.9513864E-02,   2.0459108E-02,   2.1427762E-02
     +,   2.2420904E-02,   2.3442039E-02,   2.4497747E-02
     +,   2.5598459E-02,   2.6759176E-02,   2.7999984E-02
     +,   2.9346153E-02,   3.0828265E-02,   3.2481715E-02
     +,   3.4345936E-02,   3.6462735E-02,   3.8874939E-02
     +,   4.1624211E-02,   4.4748235E-02,   4.8278362E-02
     +,   5.2236602E-02,   5.6632917E-02,   6.1461821E-02
     +,   6.6700585E-02,   7.2308458E-02,   7.8227118E-02
     +,   8.4383585E-02,   9.0699367E-02,   9.7107179E-02
     +,   0.1035790    ,   0.1101690    ,   0.1170713    
     +,   0.1246793    ,   0.1336252    ,   0.1447683    
     +,   0.1590991    ,   0.1775379    ,   0.2006525    
     +,   0.2283827    ,   0.2599134    ,   0.2938345    
     +,   0.3286104    ,   0.3632000    ,   0.3975040    
     +,   0.4324036    ,   0.4694016    ,   0.5100676    
     +,   0.5553872    ,   0.6050778    ,   0.6571295    
     +,   0.7080497    ,   0.7540210    ,   0.7924625    
     +,   0.8230037    ,   0.8470570    ,   0.8659644    
     +,   0.8787543    ,   0.8812371    ,   0.8676322    
     +,   0.8339422    ,   0.7805834    ,   0.7122581    
     +,   0.6355057    ,   0.5561358    ,   0.4781391    
     +,   0.4040063    ,   0.3354033    ,   0.2735181    
     +,   0.2190918    ,   0.1724104    ,   0.1333635    
     +,   0.1015285    ,   7.6234370E-02,   5.6628205E-02
     +,   4.1762356E-02,   3.0690234E-02,   2.2544602E-02
     +,   1.6590176E-02,   1.2241195E-02,   9.0535572E-03
     +,   6.7031286E-03,   4.9593477E-03,   3.6597410E-03
     +,   2.6890105E-03,   1.9639628E-03,   1.4235207E-03
     +,   1.0222405E-03,   7.2593486E-04,   5.0883787E-04
     +,   3.5137511E-04,   2.3862949E-04,   1.5913500E-04
     +,   1.0407851E-04,   6.6691311E-05,   4.1838794E-05
     +,   2.5682786E-05,   1.5420634E-05,   9.0538042E-06
     +,   5.1967545E-06,   2.9157907E-06,   1.5989740E-06
     +,   8.5699730E-07,   4.4891107E-07,   2.2985820E-07
     +,   1.1508335E-07,   5.6383897E-08,   2.7069696E-08
     +,   1.2769386E-08,   5.9469731E-09,   2.7580864E-09
     +,   1.2922453E-09,   6.2525957E-10
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_ashz_ttz107_mass = Yx/5.1578945
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_ashz_ttz110_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  8.4166822E-04,   8.6784939E-04
     +,   8.9462503E-04,   9.2200562E-04,   9.5000205E-04
     +,   9.7862619E-04,   1.0078903E-03,   1.0378076E-03
     +,   1.0683920E-03,   1.0996595E-03,   1.1316257E-03
     +,   1.1643075E-03,   1.1977233E-03,   1.2318916E-03
     +,   1.2668316E-03,   1.3025646E-03,   1.3391130E-03
     +,   1.3764978E-03,   1.4147422E-03,   1.4538699E-03
     +,   1.4939053E-03,   1.5348730E-03,   1.5767961E-03
     +,   1.6197024E-03,   1.6636130E-03,   1.7085540E-03
     +,   1.7545501E-03,   1.8016228E-03,   1.8497952E-03
     +,   1.8990882E-03,   1.9495214E-03,   2.0011126E-03
     +,   2.0538792E-03,   2.1078349E-03,   2.1629913E-03
     +,   2.2193603E-03,   2.2769475E-03,   2.3357577E-03
     +,   2.3957938E-03,   2.4570532E-03,   2.5195349E-03
     +,   2.5832320E-03,   2.6481352E-03,   2.7142332E-03
     +,   2.7815122E-03,   2.8499579E-03,   2.9195526E-03
     +,   2.9902782E-03,   3.0621155E-03,   3.1350467E-03
     +,   3.2090517E-03,   3.2841146E-03,   3.3602186E-03
     +,   3.4373545E-03,   3.5155090E-03,   3.5946823E-03
     +,   3.6748734E-03,   3.7560896E-03,   3.8383454E-03
     +,   3.9216657E-03,   4.0060808E-03,   4.0916330E-03
     +,   4.1783708E-03,   4.2663589E-03,   4.3556755E-03
     +,   4.4463994E-03,   4.5386315E-03,   4.6324772E-03
     +,   4.7280607E-03,   4.8255059E-03,   4.9249562E-03
     +,   5.0265547E-03,   5.1304614E-03,   5.2368278E-03
     +,   5.3458186E-03,   5.4576024E-03,   5.5723325E-03
     +,   5.6901616E-03,   5.8112396E-03,   5.9357081E-03
     +,   6.0636783E-03,   6.1952597E-03,   6.3305236E-03
     +,   6.4695342E-03,   6.6123065E-03,   6.7588440E-03
     +,   6.9090906E-03,   7.0629753E-03,   7.2203632E-03
     +,   7.3810923E-03,   7.5449552E-03,   7.7116839E-03
     +,   7.8809671E-03,   8.0524608E-03,   8.2257632E-03
     +,   8.4004207E-03,   8.5759545E-03,   8.7518236E-03
     +,   8.9274738E-03,   9.1022933E-03,   9.2756674E-03
     +,   9.4469320E-03,   9.6154306E-03,   9.7804731E-03
     +,   9.9413805E-03,   1.0097478E-02,   1.0248081E-02
     +,   1.0392529E-02,   1.0530187E-02,   1.0660456E-02
     +,   1.0782746E-02,   1.0896529E-02,   1.1001315E-02
     +,   1.1096664E-02,   1.1182182E-02,   1.1257549E-02
     +,   1.1322483E-02,   1.1376782E-02,   1.1420290E-02
     +,   1.1452923E-02,   1.1474656E-02,   1.1485518E-02
     +,   1.1485608E-02,   1.1475068E-02,   1.1454097E-02
     +,   1.1422946E-02,   1.1381904E-02,   1.1331312E-02
     +,   1.1271533E-02,   1.1202982E-02,   1.1126079E-02
     +,   1.1041291E-02,   1.0949091E-02,   1.0849976E-02
     +,   1.0744451E-02,   1.0633036E-02,   1.0516258E-02
     +,   1.0394657E-02,   1.0268766E-02,   1.0139123E-02
     +,   1.0006269E-02,   9.8707611E-03,   9.7331386E-03
     +,   9.5939431E-03,   9.4537362E-03,   9.3130572E-03
     +,   9.1724629E-03,   9.0325074E-03,   8.8937590E-03
     +,   8.7567763E-03,   8.6221239E-03,   8.4903836E-03
     +,   8.3621321E-03,   8.2379617E-03,   8.1184534E-03
     +,   8.0042128E-03,   7.8958487E-03,   7.7939690E-03
     +,   7.6991916E-03,   7.6121511E-03,   7.5334786E-03
     +,   7.4638221E-03,   7.4038394E-03,   7.3542115E-03
     +,   7.3156250E-03,   7.2888047E-03,   7.2744903E-03
     +,   7.2734710E-03,   7.2865803E-03,   7.3147053E-03
     +,   7.3588011E-03,   7.4199070E-03,   7.4991579E-03
     +,   7.5978055E-03,   7.7172145E-03,   7.8589106E-03
     +,   8.0245649E-03,   8.2160188E-03,   8.4352763E-03
     +,   8.6845383E-03,   8.9661907E-03,   9.2827734E-03
     +,   9.6369805E-03,   1.0031679E-02,   1.0469845E-02
     +,   1.0954545E-02,   1.1488887E-02,   1.2076064E-02
     +,   1.2719288E-02,   1.3421745E-02,   1.4186652E-02
     +,   1.5017325E-02,   1.5917042E-02,   1.6889239E-02
     +,   1.7937617E-02,   1.9066190E-02,   2.0279352E-02
     +,   2.1582050E-02,   2.2980042E-02,   2.4479927E-02
     +,   2.6089171E-02,   2.7816253E-02,   2.9670697E-02
     +,   3.1662829E-02,   3.3803090E-02,   3.6101799E-02
     +,   3.8567841E-02,   4.1207045E-02,   4.4020556E-02
     +,   4.7003001E-02,   5.0140597E-02,   5.3409580E-02
     +,   5.6776389E-02,   6.0199935E-02,   6.3636012E-02
     +,   6.7044698E-02,   7.0401937E-02,   7.3713318E-02
     +,   7.7028938E-02,   8.0456592E-02,   8.4170699E-02
     +,   8.8411614E-02,   9.3471490E-02,   9.9665359E-02
     +,   0.1072876    ,   0.1165568    ,   0.1275593    
     +,   0.1402015    ,   0.1541881    ,   0.1690296    
     +,   0.1840894    ,   0.1986668    ,   0.2121098    
     +,   0.2239463    ,   0.2340230    ,   0.2426386    
     +,   0.2506196    ,   0.2592743    ,   0.2701621    
     +,   0.2846742    ,   0.3035666    ,   0.3266911    
     +,   0.3531816    ,   0.3821203    ,   0.4133782    
     +,   0.4480973    ,   0.4883874    ,   0.5362206    
     +,   0.5920073    ,   0.6535658    ,   0.7160395    
     +,   0.7727574    ,   0.8166500    ,   0.8416383    
     +,   0.8435857    ,   0.8207673    ,   0.7740559    
     +,   0.7069051    ,   0.6250324    ,   0.5356071    
     +,   0.4459904    ,   0.3623561    ,   0.2887369    
     +,   0.2268092    ,   0.1763526    ,   0.1360160    
     +,   0.1040597    ,   7.8833669E-02,   5.8976810E-02
     +,   4.3434367E-02,   3.1395566E-02,   2.2217203E-02
     +,   1.5362812E-02,   1.0367466E-02,   6.8238736E-03
     +,   4.3803956E-03,   2.7427268E-03,   1.6754715E-03
     +,   9.9852798E-04,   5.8037421E-04,   3.2872200E-04
     +,   1.8123549E-04,   9.7125216E-05,   5.0521121E-05
     +,   2.5470834E-05,   1.2432958E-05,   5.8720434E-06
     +,   2.6841317E-06,   1.1899126E-06,   5.1435762E-07
     +,   2.1950271E-07,   9.4841262E-08,   4.3380354E-08
     +,   2.2257272E-08,   1.3316353E-08,   9.1716945E-09
     +,   6.9305384E-09,   5.4923439E-09,   4.4429931E-09
     +,   3.6213781E-09,   2.9577474E-09
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_ashz_ttz110_mass = Yx/4.65997682926829
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_ashz_ttz115_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.2573426E-03,   1.2748066E-03
     +,   1.2926522E-03,   1.3109271E-03,   1.3296823E-03
     +,   1.3489726E-03,   1.3688554E-03,   1.3893934E-03
     +,   1.4106515E-03,   1.4327001E-03,   1.4556115E-03
     +,   1.4794641E-03,   1.5043380E-03,   1.5303190E-03
     +,   1.5574953E-03,   1.5859598E-03,   1.6158085E-03
     +,   1.6471416E-03,   1.6800622E-03,   1.7146765E-03
     +,   1.7510942E-03,   1.7894278E-03,   1.8297908E-03
     +,   1.8723025E-03,   1.9170783E-03,   1.9642410E-03
     +,   2.0139115E-03,   2.0662101E-03,   2.1212595E-03
     +,   2.1791812E-03,   2.2400948E-03,   2.3041200E-03
     +,   2.3713717E-03,   2.4419646E-03,   2.5160082E-03
     +,   2.5936086E-03,   2.6748662E-03,   2.7598753E-03
     +,   2.8487290E-03,   2.9415023E-03,   3.0382751E-03
     +,   3.1391096E-03,   3.2440636E-03,   3.3531846E-03
     +,   3.4665065E-03,   3.5840578E-03,   3.7058501E-03
     +,   3.8318869E-03,   3.9621610E-03,   4.0966491E-03
     +,   4.2353184E-03,   4.3781288E-03,   4.5250175E-03
     +,   4.6759304E-03,   4.8307814E-03,   4.9894950E-03
     +,   5.1519806E-03,   5.3181429E-03,   5.4878867E-03
     +,   5.6611174E-03,   5.8377422E-03,   6.0176775E-03
     +,   6.2008398E-03,   6.3871769E-03,   6.5766508E-03
     +,   6.7692334E-03,   6.9649462E-03,   7.1638231E-03
     +,   7.3659588E-03,   7.5714686E-03,   7.7805370E-03
     +,   7.9933824E-03,   8.2102949E-03,   8.4316079E-03
     +,   8.6577218E-03,   8.8891126E-03,   9.1262888E-03
     +,   9.3698232E-03,   9.6203545E-03,   9.8785674E-03
     +,   1.0145161E-02,   1.0420891E-02,   1.0706495E-02
     +,   1.1002749E-02,   1.1310367E-02,   1.1630061E-02
     +,   1.1962455E-02,   1.2308121E-02,   1.2667493E-02
     +,   1.3040909E-02,   1.3428550E-02,   1.3830418E-02
     +,   1.4246299E-02,   1.4675804E-02,   1.5118316E-02
     +,   1.5572947E-02,   1.6038602E-02,   1.6513895E-02
     +,   1.6997261E-02,   1.7486813E-02,   1.7980536E-02
     +,   1.8476123E-02,   1.8971192E-02,   1.9463144E-02
     +,   1.9949306E-02,   2.0426972E-02,   2.0893382E-02
     +,   2.1345811E-02,   2.1781618E-02,   2.2198334E-02
     +,   2.2593573E-02,   2.2965264E-02,   2.3311520E-02
     +,   2.3630794E-02,   2.3921812E-02,   2.4183702E-02
     +,   2.4415888E-02,   2.4618180E-02,   2.4790717E-02
     +,   2.4934001E-02,   2.5048876E-02,   2.5136430E-02
     +,   2.5198037E-02,   2.5235299E-02,   2.5249977E-02
     +,   2.5243986E-02,   2.5219310E-02,   2.5177989E-02
     +,   2.5122019E-02,   2.5053361E-02,   2.4973907E-02
     +,   2.4885383E-02,   2.4789384E-02,   2.4687313E-02
     +,   2.4580376E-02,   2.4469571E-02,   2.4355683E-02
     +,   2.4239300E-02,   2.4120785E-02,   2.4000330E-02
     +,   2.3877954E-02,   2.3753541E-02,   2.3626830E-02
     +,   2.3497464E-02,   2.3365052E-02,   2.3229115E-02
     +,   2.3089197E-02,   2.2944855E-02,   2.2795675E-02
     +,   2.2641318E-02,   2.2481503E-02,   2.2316108E-02
     +,   2.2145091E-02,   2.1968564E-02,   2.1786779E-02
     +,   2.1600151E-02,   2.1409262E-02,   2.1214865E-02
     +,   2.1017864E-02,   2.0819370E-02,   2.0620631E-02
     +,   2.0423090E-02,   2.0228343E-02,   2.0038156E-02
     +,   1.9854417E-02,   1.9679161E-02,   1.9514546E-02
     +,   1.9362839E-02,   1.9226376E-02,   1.9107522E-02
     +,   1.9008718E-02,   1.8932346E-02,   1.8880764E-02
     +,   1.8856231E-02,   1.8860895E-02,   1.8896693E-02
     +,   1.8965404E-02,   1.9068489E-02,   1.9207180E-02
     +,   1.9382333E-02,   1.9594552E-02,   1.9844033E-02
     +,   2.0130698E-02,   2.0454183E-02,   2.0813914E-02
     +,   2.1209147E-02,   2.1639073E-02,   2.2103025E-02
     +,   2.2600548E-02,   2.3131570E-02,   2.3696642E-02
     +,   2.4297116E-02,   2.4935285E-02,   2.5614675E-02
     +,   2.6340198E-02,   2.7118307E-02,   2.7957074E-02
     +,   2.8866282E-02,   2.9857434E-02,   3.0943662E-02
     +,   3.2139335E-02,   3.3459798E-02,   3.4920912E-02
     +,   3.6538254E-02,   3.8326077E-02,   4.0296607E-02
     +,   4.2458694E-02,   4.4816580E-02,   4.7368824E-02
     +,   5.0107576E-02,   5.3018071E-02,   5.6078371E-02
     +,   5.9260387E-02,   6.2531859E-02,   6.5858699E-02
     +,   6.9207914E-02,   7.2552122E-02,   7.5873353E-02
     +,   7.9166733E-02,   8.2442738E-02,   8.5729018E-02
     +,   8.9069679E-02,   9.2522539E-02,   9.6155867E-02
     +,   0.1000443    ,   0.1042648    ,   0.1088932    
     +,   0.1140027    ,   0.1196646    ,   0.1259473    
     +,   0.1329156    ,   0.1406278    ,   0.1491315    
     +,   0.1584550    ,   0.1685996    ,   0.1795334    
     +,   0.1911901    ,   0.2034694    ,   0.2162460    
     +,   0.2293815    ,   0.2427346    ,   0.2561643    
     +,   0.2695327    ,   0.2826937    ,   0.2954788    
     +,   0.3076749    ,   0.3190117    ,   0.3291562    
     +,   0.3377205    ,   0.3442827    ,   0.3484252    
     +,   0.3497715    ,   0.3480257    ,   0.3430015    
     +,   0.3346386    ,   0.3230074    ,   0.3083047    
     +,   0.2908428    ,   0.2710337    ,   0.2493733    
     +,   0.2264224    ,   0.2027811    ,   0.1790574    
     +,   0.1558348    ,   0.1336417    ,   0.1129170    
     +,   9.3992189E-02,   7.7081814E-02,   6.2284205E-02
     +,   4.9592134E-02,   3.8913339E-02,   3.0093307E-02
     +,   2.2937259E-02,   1.7230241E-02,   1.2754587E-02
     +,   9.3024531E-03,   6.6830106E-03,   4.7280192E-03
     +,   3.2928789E-03,   2.2570239E-03,   1.5220064E-03
     +,   1.0094942E-03,   6.5837562E-04,   4.2212385E-04
     +,   2.6601486E-04,   1.6474538E-04,   1.0025254E-04
     +,   5.9936723E-05,   3.5202538E-05,   2.0308496E-05
     +,   1.1507334E-05,   6.4032383E-06,   3.4987845E-06
     +,   1.8769595E-06,   9.8849750E-07,   5.1099170E-07
     +,   2.5927841E-07,   1.2913536E-07,   6.3157081E-08
     +,   3.0358155E-08,   1.4372530E-08
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_ashz_ttz115_mass = Yx/3.35389653846154
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_ashz_ttz120_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.5824158E-03,   1.6211001E-03
     +,   1.6608823E-03,   1.7018287E-03,   1.7440075E-03
     +,   1.7874903E-03,   1.8323516E-03,   1.8786670E-03
     +,   1.9265142E-03,   1.9759741E-03,   2.0271279E-03
     +,   2.0800584E-03,   2.1348498E-03,   2.1915871E-03
     +,   2.2503559E-03,   2.3112430E-03,   2.3743354E-03
     +,   2.4397213E-03,   2.5074871E-03,   2.5777223E-03
     +,   2.6505156E-03,   2.7259560E-03,   2.8041338E-03
     +,   2.8851419E-03,   2.9690694E-03,   3.0560147E-03
     +,   3.1460719E-03,   3.2393413E-03,   3.3359253E-03
     +,   3.4359295E-03,   3.5394661E-03,   3.6466511E-03
     +,   3.7576058E-03,   3.8724579E-03,   3.9913440E-03
     +,   4.1144048E-03,   4.2417902E-03,   4.3736566E-03
     +,   4.5101754E-03,   4.6515097E-03,   4.7978465E-03
     +,   4.9493685E-03,   5.1062680E-03,   5.2687381E-03
     +,   5.4369750E-03,   5.6111785E-03,   5.7915370E-03
     +,   5.9782420E-03,   6.1714728E-03,   6.3713989E-03
     +,   6.5781670E-03,   6.7919120E-03,   7.0127393E-03
     +,   7.2407424E-03,   7.4759568E-03,   7.7184029E-03
     +,   7.9680560E-03,   8.2248431E-03,   8.4886532E-03
     +,   8.7593310E-03,   9.0366621E-03,   9.3203923E-03
     +,   9.6102031E-03,   9.9057565E-03,   1.0206657E-02
     +,   1.0512456E-02,   1.0822710E-02,   1.1136899E-02
     +,   1.1454528E-02,   1.1775063E-02,   1.2098013E-02
     +,   1.2422839E-02,   1.2749108E-02,   1.3076340E-02
     +,   1.3404181E-02,   1.3732324E-02,   1.4060517E-02
     +,   1.4388612E-02,   1.4716572E-02,   1.5044477E-02
     +,   1.5372494E-02,   1.5700953E-02,   1.6030256E-02
     +,   1.6360980E-02,   1.6693758E-02,   1.7029395E-02
     +,   1.7368719E-02,   1.7712699E-02,   1.8062308E-02
     +,   1.8418584E-02,   1.8782586E-02,   1.9155303E-02
     +,   1.9537695E-02,   1.9930653E-02,   2.0334963E-02
     +,   2.0751208E-02,   2.1179896E-02,   2.1621222E-02
     +,   2.2075249E-02,   2.2541735E-02,   2.3020223E-02
     +,   2.3509927E-02,   2.4009855E-02,   2.4518669E-02
     +,   2.5034796E-02,   2.5556412E-02,   2.6081406E-02
     +,   2.6607446E-02,   2.7132029E-02,   2.7652470E-02
     +,   2.8165888E-02,   2.8669380E-02,   2.9159868E-02
     +,   2.9634316E-02,   3.0089611E-02,   3.0522725E-02
     +,   3.0930659E-02,   3.1310529E-02,   3.1659517E-02
     +,   3.1975061E-02,   3.2254696E-02,   3.2496195E-02
     +,   3.2697536E-02,   3.2856986E-02,   3.2973062E-02
     +,   3.3044573E-02,   3.3070620E-02,   3.3050630E-02
     +,   3.2984391E-02,   3.2871958E-02,   3.2713812E-02
     +,   3.2510739E-02,   3.2263871E-02,   3.1974725E-02
     +,   3.1645115E-02,   3.1277183E-02,   3.0873416E-02
     +,   3.0436585E-02,   2.9969707E-02,   2.9476000E-02
     +,   2.8958946E-02,   2.8422181E-02,   2.7869407E-02
     +,   2.7304437E-02,   2.6731133E-02,   2.6153339E-02
     +,   2.5574766E-02,   2.4999121E-02,   2.4429932E-02
     +,   2.3870509E-02,   2.3323961E-02,   2.2793133E-02
     +,   2.2280635E-02,   2.1788703E-02,   2.1319296E-02
     +,   2.0874048E-02,   2.0454261E-02,   2.0060910E-02
     +,   1.9694583E-02,   1.9355679E-02,   1.9044202E-02
     +,   1.8759921E-02,   1.8502364E-02,   1.8270828E-02
     +,   1.8064423E-02,   1.7882094E-02,   1.7722679E-02
     +,   1.7584924E-02,   1.7467536E-02,   1.7369179E-02
     +,   1.7288569E-02,   1.7224466E-02,   1.7175725E-02
     +,   1.7141307E-02,   1.7120354E-02,   1.7112128E-02
     +,   1.7116139E-02,   1.7132055E-02,   1.7159782E-02
     +,   1.7199438E-02,   1.7251354E-02,   1.7316068E-02
     +,   1.7394323E-02,   1.7487040E-02,   1.7595315E-02
     +,   1.7720388E-02,   1.7863642E-02,   1.8026607E-02
     +,   1.8210961E-02,   1.8418502E-02,   1.8651251E-02
     +,   1.8911432E-02,   1.9201579E-02,   1.9524595E-02
     +,   1.9883856E-02,   2.0283358E-02,   2.0727819E-02
     +,   2.1222787E-02,   2.1774812E-02,   2.2391595E-02
     +,   2.3081943E-02,   2.3855818E-02,   2.4724379E-02
     +,   2.5699755E-02,   2.6794657E-02,   2.8022155E-02
     +,   2.9395062E-02,   3.0925104E-02,   3.2622203E-02
     +,   3.4493592E-02,   3.6542926E-02,   3.8769182E-02
     +,   4.1165911E-02,   4.3721013E-02,   4.6416454E-02
     +,   4.9228214E-02,   5.2127346E-02,   5.5081513E-02
     +,   5.8056414E-02,   6.1018042E-02,   6.3935533E-02
     +,   6.6783376E-02,   6.9543965E-02,   7.2209328E-02
     +,   7.4782819E-02,   7.7279411E-02,   7.9725057E-02
     +,   8.2155466E-02,   8.4613942E-02,   8.7148644E-02
     +,   8.9809097E-02,   9.2643037E-02,   9.5693678E-02
     +,   9.8996751E-02,   0.1025784    ,   0.1064545    
     +,   0.1106291    ,   0.1150946    ,   0.1198317    
     +,   0.1248092    ,   0.1299853    ,   0.1353059    
     +,   0.1407057    ,   0.1461084    ,   0.1514266    
     +,   0.1565614    ,   0.1614050    ,   0.1658414    
     +,   0.1697496    ,   0.1730065    ,   0.1754914    
     +,   0.1770903    ,   0.1777015    ,   0.1772403    
     +,   0.1756450    ,   0.1728798    ,   0.1689402    
     +,   0.1638542    ,   0.1576831    ,   0.1505210    
     +,   0.1424918    ,   0.1337448    ,   0.1244481    
     +,   0.1147812    ,   0.1049291    ,   9.5071673E-02
     +,   8.5377492E-02,   7.5998396E-02,   6.7063421E-02
     +,   5.8675330E-02,   5.0909560E-02,   4.3814998E-02
     +,   3.7415031E-02,   3.1709895E-02,   2.6680937E-02
     +,   2.2294909E-02,   1.8507048E-02,   1.5265998E-02
     +,   1.2516269E-02,   1.0201976E-02,   8.2682762E-03
     +,   6.6636815E-03,   5.3405697E-03,   4.2562080E-03
     +,   3.3726050E-03,   2.6567229E-03,   2.0799947E-03
     +,   1.6180411E-03,   1.2502559E-03,   9.5925923E-04
     +,   7.3055731E-04,   5.5206497E-04,   4.1380565E-04
     +,   3.0754873E-04,   2.2657230E-04,   1.6539781E-04
     +,   1.1960914E-04,   8.5661130E-05,   6.0742146E-05
     +,   4.2635864E-05,   2.9618321E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_ashz_ttz120_mass = Yx/2.43314516666667
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_ashz_ttz60_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.1725420E-03,   2.4568343E-03
     +,   2.7834505E-03,   3.1588485E-03,   3.5900928E-03
     +,   4.0847827E-03,   4.6509500E-03,   5.2969200E-03
     +,   6.0311402E-03,   6.8620518E-03,   7.7978461E-03
     +,   8.8463360E-03,   1.0014826E-02,   1.1310015E-02
     +,   1.2737984E-02,   1.4304249E-02,   1.6013870E-02
     +,   1.7871641E-02,   1.9882338E-02,   2.2050949E-02
     +,   2.4382873E-02,   2.6884133E-02,   2.9561289E-02
     +,   3.2421671E-02,   3.5472542E-02,   3.8721256E-02
     +,   4.2174235E-02,   4.5836471E-02,   4.9710568E-02
     +,   5.3795859E-02,   5.8087815E-02,   6.2577151E-02
     +,   6.7249231E-02,   7.2083823E-02,   7.7054717E-02
     +,   8.2129732E-02,   8.7270759E-02,   9.2433803E-02
     +,   9.7569622E-02,   0.1026231    ,   0.1075350    
     +,   0.1122414    ,   0.1166753    ,   0.1207674    
     +,   0.1244477    ,   0.1276479    ,   0.1303037    
     +,   0.1323579    ,   0.1337631    ,   0.1344853    
     +,   0.1345064    ,   0.1338267    ,   0.1324656    
     +,   0.1304622    ,   0.1278744    ,   0.1247753    
     +,   0.1212505    ,   0.1173932    ,   0.1132990    
     +,   0.1090607    ,   0.1047637    ,   0.1004818    
     +,   9.6274517E-02,   9.2185475E-02,   8.8242367E-02
     +,   8.4458634E-02,   8.0834910E-02,   7.7362858E-02
     +,   7.4027628E-02,   7.0812099E-02,   6.7698926E-02
     +,   6.4673610E-02,   6.1725527E-02,   5.8849551E-02
     +,   5.6045424E-02,   5.3317774E-02,   5.0675176E-02
     +,   4.8129153E-02,   4.5692332E-02,   4.3377738E-02
     +,   4.1197632E-02,   3.9162353E-02,   3.7280105E-02
     +,   3.5556071E-02,   3.3992816E-02,   3.2589946E-02
     +,   3.1344645E-02,   3.0251797E-02,   2.9304640E-02
     +,   2.8495070E-02,   2.7814206E-02,   2.7252849E-02
     +,   2.6801836E-02,   2.6452372E-02,   2.6196301E-02
     +,   2.6026316E-02,   2.5935985E-02,   2.5919840E-02
     +,   2.5973301E-02,   2.6092600E-02,   2.6274603E-02
     +,   2.6516674E-02,   2.6816485E-02,   2.7171765E-02
     +,   2.7580248E-02,   2.8039414E-02,   2.8546367E-02
     +,   2.9097728E-02,   2.9689660E-02,   3.0317796E-02
     +,   3.0977136E-02,   3.1662308E-02,   3.2367438E-02
     +,   3.3086423E-02,   3.3812851E-02,   3.4540329E-02
     +,   3.5262465E-02,   3.5973027E-02,   3.6666088E-02
     +,   3.7336133E-02,   3.7978154E-02,   3.8587712E-02
     +,   3.9160978E-02,   3.9694887E-02,   4.0187046E-02
     +,   4.0635783E-02,   4.1040167E-02,   4.1399844E-02
     +,   4.1715201E-02,   4.1987110E-02,   4.2216972E-02
     +,   4.2406537E-02,   4.2557906E-02,   4.2673361E-02
     +,   4.2755269E-02,   4.2805996E-02,   4.2827833E-02
     +,   4.2822868E-02,   4.2792920E-02,   4.2739462E-02
     +,   4.2663638E-02,   4.2566132E-02,   4.2447224E-02
     +,   4.2306799E-02,   4.2144343E-02,   4.1959036E-02
     +,   4.1749716E-02,   4.1515123E-02,   4.1253880E-02
     +,   4.0964559E-02,   4.0645894E-02,   4.0296730E-02
     +,   3.9916292E-02,   3.9504111E-02,   3.9060075E-02
     +,   3.8584653E-02,   3.8078718E-02,   3.7543636E-02
     +,   3.6981165E-02,   3.6393575E-02,   3.5783425E-02
     +,   3.5153508E-02,   3.4506861E-02,   3.3846624E-02
     +,   3.3175897E-02,   3.2497667E-02,   3.1814847E-02
     +,   3.1130087E-02,   3.0445721E-02,   2.9763797E-02
     +,   2.9086040E-02,   2.8413886E-02,   2.7748365E-02
     +,   2.7090240E-02,   2.6440097E-02,   2.5798228E-02
     +,   2.5164779E-02,   2.4539836E-02,   2.3923405E-02
     +,   2.3315446E-02,   2.2715967E-02,   2.2125030E-02
     +,   2.1542821E-02,   2.0969545E-02,   2.0405544E-02
     +,   1.9851280E-02,   1.9307330E-02,   1.8774303E-02
     +,   1.8252892E-02,   1.7743880E-02,   1.7248036E-02
     +,   1.6766123E-02,   1.6298918E-02,   1.5847147E-02
     +,   1.5411450E-02,   1.4992371E-02,   1.4590384E-02
     +,   1.4205857E-02,   1.3838984E-02,   1.3489860E-02
     +,   1.3158428E-02,   1.2844510E-02,   1.2547772E-02
     +,   1.2267751E-02,   1.2003877E-02,   1.1755448E-02
     +,   1.1521650E-02,   1.1301605E-02,   1.1094351E-02
     +,   1.0898845E-02,   1.0714005E-02,   1.0538724E-02
     +,   1.0371882E-02,   1.0212346E-02,   1.0058992E-02
     +,   9.9107297E-03,   9.7665116E-03,   9.6253278E-03
     +,   9.4862189E-03,   9.3483087E-03,   9.2107868E-03
     +,   9.0729035E-03,   8.9340182E-03,   8.7935636E-03
     +,   8.6510526E-03,   8.5060801E-03,   8.3583407E-03
     +,   8.2076108E-03,   8.0537321E-03,   7.8966264E-03
     +,   7.7362945E-03,   7.5728116E-03,   7.4062948E-03
     +,   7.2369180E-03,   7.0649283E-03,   6.8905898E-03
     +,   6.7142099E-03,   6.5361368E-03,   6.3567404E-03
     +,   6.1764019E-03,   5.9955083E-03,   5.8144755E-03
     +,   5.6337141E-03,   5.4536215E-03,   5.2745896E-03
     +,   5.0970088E-03,   4.9212570E-03,   4.7476813E-03
     +,   4.5766095E-03,   4.4083623E-03,   4.2432225E-03
     +,   4.0814434E-03,   3.9232657E-03,   3.7689018E-03
     +,   3.6185256E-03,   3.4722846E-03,   3.3303106E-03
     +,   3.1927072E-03,   3.0595437E-03,   2.9308668E-03
     +,   2.8067073E-03,   2.6870754E-03,   2.5719537E-03
     +,   2.4613047E-03,   2.3550862E-03,   2.2532309E-03
     +,   2.1556558E-03,   2.0622753E-03,   1.9729910E-03
     +,   1.8876911E-03,   1.8062561E-03,   1.7285659E-03
     +,   1.6544957E-03,   1.5839131E-03,   1.5166827E-03
     +,   1.4526753E-03,   1.3917526E-03,   1.3337855E-03
     +,   1.2786379E-03,   1.2261836E-03,   1.1762921E-03
     +,   1.1288424E-03,   1.0837107E-03,   1.0407835E-03
     +,   9.9994510E-04,   9.6108980E-04,   9.2411251E-04
     +,   8.8891236E-04,   8.5539703E-04,   8.2347385E-04
     +,   7.9305895E-04,   7.6406880E-04,   7.3642813E-04
     +,   7.1006181E-04,   6.8490265E-04,   6.6088390E-04
     +,   6.3794537E-04,   6.1602780E-04,   5.9507770E-04
     +,   5.7504262E-04,   5.5587519E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_ashz_ttz60_mass = Yx/2.24535208333333
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_ashz_ttz65_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.8668616E-03,   3.9996235E-03
     +,   4.1349404E-03,   4.2730607E-03,   4.4142604E-03
     +,   4.5588496E-03,   4.7071651E-03,   4.8595788E-03
     +,   5.0164899E-03,   5.1783505E-03,   5.3456537E-03
     +,   5.5189598E-03,   5.6989091E-03,   5.8862474E-03
     +,   6.0818512E-03,   6.2867654E-03,   6.5022381E-03
     +,   6.7297677E-03,   6.9711511E-03,   7.2285393E-03
     +,   7.5044944E-03,   7.8020589E-03,   8.1247985E-03
     +,   8.4769102E-03,   8.8632079E-03,   9.2892749E-03
     +,   9.7614313E-03,   1.0286811E-02,   1.0873367E-02
     +,   1.1529879E-02,   1.2265937E-02,   1.3091902E-02
     +,   1.4018910E-02,   1.5058830E-02,   1.6224300E-02
     +,   1.7528806E-02,   1.8986883E-02,   2.0614238E-02
     +,   2.2428334E-02,   2.4448320E-02,   2.6695812E-02
     +,   2.9194819E-02,   3.1971887E-02,   3.5055973E-02
     +,   3.8478136E-02,   4.2271249E-02,   4.6469897E-02
     +,   5.1110841E-02,   5.6234319E-02,   6.1886184E-02
     +,   6.8120576E-02,   7.5002551E-02,   8.2608558E-02
     +,   9.1024980E-02,   0.1003391    ,   0.1106274    
     +,   0.1219351    ,   0.1342528    ,   0.1474934    
     +,   0.1614717    ,   0.1758964    ,   0.1903753    
     +,   0.2044353    ,   0.2175641    ,   0.2292561    
     +,   0.2390662    ,   0.2466593    ,   0.2518430    
     +,   0.2545829    ,   0.2549919    ,   0.2532974    
     +,   0.2497967    ,   0.2448016    ,   0.2385950    
     +,   0.2313966    ,   0.2233570    ,   0.2145678    
     +,   0.2050930    ,   0.1950003    ,   0.1843941    
     +,   0.1734347    ,   0.1623362    ,   0.1513549    
     +,   0.1407597    ,   0.1308040    ,   0.1216961    
     +,   0.1135813    ,   0.1065324    ,   0.1005522    
     +,   9.5582195E-02,   9.1517419E-02,   8.8223055E-02
     +,   8.5549608E-02,   8.3346084E-02,   8.1471570E-02
     +,   7.9803452E-02,   7.8242749E-02,   7.6717757E-02
     +,   7.5185090E-02,   7.3628485E-02,   7.2055608E-02
     +,   7.0493758E-02,   6.8983346E-02,   6.7572258E-02
     +,   6.6308737E-02,   6.5236270E-02,   6.4389125E-02
     +,   6.3789427E-02,   6.3445926E-02,   6.3354082E-02
     +,   6.3497536E-02,   6.3850410E-02,   6.4379953E-02
     +,   6.5049596E-02,   6.5821163E-02,   6.6657722E-02
     +,   6.7525104E-02,   6.8393022E-02,   6.9235951E-02
     +,   7.0033468E-02,   7.0769690E-02,   7.1433246E-02
     +,   7.2016247E-02,   7.2513796E-02,   7.2923072E-02
     +,   7.3242642E-02,   7.3471799E-02,   7.3610052E-02
     +,   7.3656946E-02,   7.3611848E-02,   7.3473819E-02
     +,   7.3242366E-02,   7.2917148E-02,   7.2499029E-02
     +,   7.1990088E-02,   7.1394511E-02,   7.0718654E-02
     +,   6.9971316E-02,   6.9163829E-02,   6.8309449E-02
     +,   6.7423217E-02,   6.6520870E-02,   6.5617993E-02
     +,   6.4728886E-02,   6.3865639E-02,   6.3036971E-02
     +,   6.2247533E-02,   6.1497390E-02,   6.0781967E-02
     +,   6.0092084E-02,   5.9414502E-02,   5.8733046E-02
     +,   5.8029510E-02,   5.7284955E-02,   5.6480974E-02
     +,   5.5601157E-02,   5.4632016E-02,   5.3563818E-02
     +,   5.2391265E-02,   5.1113952E-02,   4.9735956E-02
     +,   4.8265815E-02,   4.6715982E-02,   4.5102011E-02
     +,   4.3441627E-02,   4.1753855E-02,   4.0058266E-02
     +,   3.8373958E-02,   3.6718771E-02,   3.5108689E-02
     +,   3.3557549E-02,   3.2076579E-02,   3.0674148E-02
     +,   2.9355891E-02,   2.8124942E-02,   2.6981860E-02
     +,   2.5925145E-02,   2.4951529E-02,   2.4056369E-02
     +,   2.3233965E-02,   2.2477938E-02,   2.1781648E-02
     +,   2.1138450E-02,   2.0541856E-02,   1.9985775E-02
     +,   1.9464752E-02,   1.8973939E-02,   1.8509153E-02
     +,   1.8066885E-02,   1.7644333E-02,   1.7239239E-02
     +,   1.6849892E-02,   1.6475013E-02,   1.6113704E-02
     +,   1.5765296E-02,   1.5429286E-02,   1.5105324E-02
     +,   1.4793089E-02,   1.4492234E-02,   1.4202366E-02
     +,   1.3923053E-02,   1.3653766E-02,   1.3393870E-02
     +,   1.3142635E-02,   1.2899294E-02,   1.2662978E-02
     +,   1.2432787E-02,   1.2207795E-02,   1.1987082E-02
     +,   1.1769724E-02,   1.1554836E-02,   1.1341587E-02
     +,   1.1129218E-02,   1.0917027E-02,   1.0704405E-02
     +,   1.0490837E-02,   1.0275907E-02,   1.0059289E-02
     +,   9.8407390E-03,   9.6201394E-03,   9.3974331E-03
     +,   9.1726501E-03,   8.9459205E-03,   8.7174308E-03
     +,   8.4874323E-03,   8.2562277E-03,   8.0241784E-03
     +,   7.7916943E-03,   7.5591989E-03,   7.3271412E-03
     +,   7.0960028E-03,   6.8662772E-03,   6.6384380E-03
     +,   6.4129657E-03,   6.1903452E-03,   5.9710280E-03
     +,   5.7554399E-03,   5.5440050E-03,   5.3371075E-03
     +,   5.1350920E-03,   4.9382639E-03,   4.7469079E-03
     +,   4.5612683E-03,   4.3815346E-03,   4.2078611E-03
     +,   4.0403693E-03,   3.8791436E-03,   3.7242169E-03
     +,   3.5755909E-03,   3.4332431E-03,   3.2971057E-03
     +,   3.1670819E-03,   3.0430576E-03,   2.9248907E-03
     +,   2.8124133E-03,   2.7054369E-03,   2.6037677E-03
     +,   2.5071965E-03,   2.4154990E-03,   2.3284447E-03
     +,   2.2458038E-03,   2.1673453E-03,   2.0928311E-03
     +,   2.0220275E-03,   1.9547110E-03,   1.8906558E-03
     +,   1.8296445E-03,   1.7714715E-03,   1.7159391E-03
     +,   1.6628560E-03,   1.6120411E-03,   1.5633273E-03
     +,   1.5165586E-03,   1.4715852E-03,   1.4282701E-03
     +,   1.3864901E-03,   1.3461267E-03,   1.3070776E-03
     +,   1.2692444E-03,   1.2325427E-03,   1.1968929E-03
     +,   1.1622274E-03,   1.1284815E-03,   1.0956030E-03
     +,   1.0635408E-03,   1.0322548E-03,   1.0017067E-03
     +,   9.7186322E-04,   9.4269851E-04,   9.1418688E-04
     +,   8.8630954E-04,   8.5904682E-04,   8.3238614E-04
     +,   8.0631283E-04,   7.8081765E-04,   7.5589010E-04
     +,   7.3152379E-04,   7.0771045E-04,   6.8444572E-04
     +,   6.6172268E-04,   6.3953805E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_ashz_ttz65_mass = Yx/3.29360176923077
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_ashz_ttz70_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  8.0495601E-04,   8.3305297E-04
     +,   8.6224638E-04,   8.9261407E-04,   9.2424522E-04
     +,   9.5724140E-04,   9.9171780E-04,   1.0278050E-03
     +,   1.0656500E-03,   1.1054208E-03,   1.1473023E-03
     +,   1.1915036E-03,   1.2382558E-03,   1.2878136E-03
     +,   1.3404590E-03,   1.3964990E-03,   1.4562679E-03
     +,   1.5201274E-03,   1.5884674E-03,   1.6617039E-03
     +,   1.7402823E-03,   1.8246736E-03,   1.9153752E-03
     +,   2.0129180E-03,   2.1178476E-03,   2.2307502E-03
     +,   2.3522330E-03,   2.4829370E-03,   2.6235341E-03
     +,   2.7747341E-03,   2.9372876E-03,   3.1119944E-03
     +,   3.2997085E-03,   3.5013554E-03,   3.7179473E-03
     +,   3.9506047E-03,   4.2005940E-03,   4.4693705E-03
     +,   4.7586616E-03,   5.0705140E-03,   5.4074707E-03
     +,   5.7726824E-03,   6.1701140E-03,   6.6047912E-03
     +,   7.0830691E-03,   7.6129530E-03,   8.2044173E-03
     +,   8.8697355E-03,   9.6237417E-03,   1.0484026E-02
     +,   1.1470952E-02,   1.2607540E-02,   1.3919051E-02
     +,   1.5432522E-02,   1.7175747E-02,   1.9176848E-02
     +,   2.1463202E-02,   2.4061194E-02,   2.6996210E-02
     +,   3.0293217E-02,   3.3977821E-02,   3.8077604E-02
     +,   4.2622801E-02,   4.7647171E-02,   5.3186871E-02
     +,   5.9277620E-02,   6.5953366E-02,   7.3242344E-02
     +,   8.1168510E-02,   8.9752674E-02,   9.9022098E-02
     +,   0.1090182    ,   0.1198098    ,   0.1314979    
     +,   0.1442162    ,   0.1581141    ,   0.1733229    
     +,   0.1899062    ,   0.2078030    ,   0.2267692    
     +,   0.2463457    ,   0.2658750    ,   0.2845632    
     +,   0.3016032    ,   0.3163075    ,   0.3282276    
     +,   0.3372013    ,   0.3433211    ,   0.3468307    
     +,   0.3479946    ,   0.3469979    ,   0.3439154    
     +,   0.3387579    ,   0.3315667    ,   0.3225076    
     +,   0.3119179    ,   0.3002751    ,   0.2881083    
     +,   0.2758821    ,   0.2639119    ,   0.2523392    
     +,   0.2411790    ,   0.2303977    ,   0.2199961    
     +,   0.2100438    ,   0.2006722    ,   0.1920295    
     +,   0.1842290    ,   0.1773137    ,   0.1712489    
     +,   0.1659373    ,   0.1612433    ,   0.1570190    
     +,   0.1531188    ,   0.1494104    ,   0.1457779    
     +,   0.1421266    ,   0.1383857    ,   0.1345134    
     +,   0.1304987    ,   0.1263599    ,   0.1221404    
     +,   0.1179019    ,   0.1137162    ,   0.1096585    
     +,   0.1058019    ,   0.1022119    ,   9.8943383E-02
     +,   9.6036665E-02,   9.3516447E-02,   9.1388866E-02
     +,   8.9642487E-02,   8.8248953E-02,   8.7166309E-02
     +,   8.6341843E-02,   8.5717447E-02,   8.5233442E-02
     +,   8.4833637E-02,   8.4468171E-02,   8.4096484E-02
     +,   8.3688505E-02,   8.3225004E-02,   8.2696445E-02
     +,   8.2100883E-02,   8.1441902E-02,   8.0725297E-02
     +,   7.9956360E-02,   7.9137690E-02,   7.8267246E-02
     +,   7.7337734E-02,   7.6336436E-02,   7.5246572E-02
     +,   7.4048527E-02,   7.2722159E-02,   7.1248889E-02
     +,   6.9613904E-02,   6.7807853E-02,   6.5827928E-02
     +,   6.3678600E-02,   6.1371725E-02,   5.8925778E-02
     +,   5.6364890E-02,   5.3717770E-02,   5.1015954E-02
     +,   4.8292197E-02,   4.5579050E-02,   4.2907719E-02
     +,   4.0306885E-02,   3.7801601E-02,   3.5413072E-02
     +,   3.3158492E-02,   3.1050837E-02,   2.9098956E-02
     +,   2.7308052E-02,   2.5680268E-02,   2.4214797E-02
     +,   2.2908514E-02,   2.1756561E-02,   2.0752596E-02
     +,   1.9889064E-02,   1.9157585E-02,   1.8549241E-02
     +,   1.8054636E-02,   1.7664036E-02,   1.7367531E-02
     +,   1.7155161E-02,   1.7016934E-02,   1.6942922E-02
     +,   1.6923366E-02,   1.6948728E-02,   1.7009770E-02
     +,   1.7097630E-02,   1.7203886E-02,   1.7320627E-02
     +,   1.7440485E-02,   1.7556733E-02,   1.7663268E-02
     +,   1.7754665E-02,   1.7826226E-02,   1.7873935E-02
     +,   1.7894493E-02,   1.7885290E-02,   1.7844416E-02
     +,   1.7770603E-02,   1.7663203E-02,   1.7522128E-02
     +,   1.7347839E-02,   1.7141262E-02,   1.6903779E-02
     +,   1.6637083E-02,   1.6343212E-02,   1.6024448E-02
     +,   1.5683280E-02,   1.5322296E-02,   1.4944192E-02
     +,   1.4551697E-02,   1.4147550E-02,   1.3734407E-02
     +,   1.3314839E-02,   1.2891342E-02,   1.2466235E-02
     +,   1.2041669E-02,   1.1619649E-02,   1.1202002E-02
     +,   1.0790332E-02,   1.0386048E-02,   9.9903950E-03
     +,   9.6044363E-03,   9.2290277E-03,   8.8648563E-03
     +,   8.5124718E-03,   8.1722811E-03,   7.8445328E-03
     +,   7.5293537E-03,   7.2267954E-03,   6.9367872E-03
     +,   6.6591697E-03,   6.3937423E-03,   6.1402363E-03
     +,   5.8983210E-03,   5.6676250E-03,   5.4477672E-03
     +,   5.2383384E-03,   5.0388998E-03,   4.8490046E-03
     +,   4.6682148E-03,   4.4960883E-03,   4.3321755E-03
     +,   4.1760369E-03,   4.0272526E-03,   3.8854023E-03
     +,   3.7500772E-03,   3.6208916E-03,   3.4974760E-03
     +,   3.3794646E-03,   3.2665126E-03,   3.1582969E-03
     +,   3.0545113E-03,   2.9548602E-03,   2.8590646E-03
     +,   2.7668690E-03,   2.6780339E-03,   2.5923289E-03
     +,   2.5095406E-03,   2.4294811E-03,   2.3519658E-03
     +,   2.2768273E-03,   2.2039162E-03,   2.1330970E-03
     +,   2.0642411E-03,   1.9972341E-03,   1.9319762E-03
     +,   1.8683787E-03,   1.8063594E-03,   1.7458453E-03
     +,   1.6867791E-03,   1.6291031E-03,   1.5727743E-03
     +,   1.5177502E-03,   1.4640018E-03,   1.4114971E-03
     +,   1.3602170E-03,   1.3101390E-03,   1.2612521E-03
     +,   1.2135402E-03,   1.1669976E-03,   1.1216146E-03
     +,   1.0773839E-03,   1.0343032E-03,   9.9236507E-04
     +,   9.5156906E-04,   9.1190758E-04,   8.7337941E-04
     +,   8.3597732E-04,   7.9969806E-04,   7.6453306E-04
     +,   7.3047739E-04,   6.9751992E-04,   6.6565361E-04
     +,   6.3486537E-04,   6.0514506E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_ashz_ttz70_mass = Yx/4.0857243
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_ashz_ttz75_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  8.6331979E-04,   8.9574937E-04
     +,   9.2966337E-04,   9.6515764E-04,   1.0023346E-03
     +,   1.0413030E-03,   1.0821780E-03,   1.1250805E-03
     +,   1.1701363E-03,   1.2174797E-03,   1.2672471E-03
     +,   1.3195807E-03,   1.3746262E-03,   1.4325326E-03
     +,   1.4934504E-03,   1.5575334E-03,   1.6249334E-03
     +,   1.6958030E-03,   1.7702924E-03,   1.8485491E-03
     +,   1.9307164E-03,   2.0169318E-03,   2.1073273E-03
     +,   2.2020312E-03,   2.3011551E-03,   2.4048123E-03
     +,   2.5131027E-03,   2.6261169E-03,   2.7439382E-03
     +,   2.8666419E-03,   2.9942940E-03,   3.1269577E-03
     +,   3.2646875E-03,   3.4075349E-03,   3.5555500E-03
     +,   3.7087814E-03,   3.8672767E-03,   4.0310849E-03
     +,   4.2002685E-03,   4.3748724E-03,   4.5549632E-03
     +,   4.7406009E-03,   4.9318504E-03,   5.1287697E-03
     +,   5.3314185E-03,   5.5398494E-03,   5.7541081E-03
     +,   5.9742280E-03,   6.2002330E-03,   6.4321388E-03
     +,   6.6699637E-03,   6.9137337E-03,   7.1634986E-03
     +,   7.4193808E-03,   7.6815719E-03,   7.9504382E-03
     +,   8.2265502E-03,   8.5107936E-03,   8.8044712E-03
     +,   9.1094589E-03,   9.4283614E-03,   9.7647235E-03
     +,   1.0123231E-02,   1.0510012E-02,   1.0932911E-02
     +,   1.1401712E-02,   1.1928535E-02,   1.2527963E-02
     +,   1.3217369E-02,   1.4016876E-02,   1.4949512E-02
     +,   1.6040865E-02,   1.7319039E-02,   1.8813981E-02
     +,   2.0557346E-02,   2.2582049E-02,   2.4921946E-02
     +,   2.7612105E-02,   3.0689675E-02,   3.4194857E-02
     +,   3.8172070E-02,   4.2672444E-02,   4.7754060E-02
     +,   5.3483605E-02,   5.9934087E-02,   6.7184091E-02
     +,   7.5312845E-02,   8.4399074E-02,   9.4517849E-02
     +,   0.1057437    ,   0.1181530    ,   0.1318232    
     +,   0.1468242    ,   0.1631929    ,   0.1808904    
     +,   0.1997518    ,   0.2194690    ,   0.2396248    
     +,   0.2598241    ,   0.2798799    ,   0.3000046    
     +,   0.3208712    ,   0.3434841    ,   0.3688279    
     +,   0.3974235    ,   0.4289196    ,   0.4618944    
     +,   0.4939372    ,   0.5220305    ,   0.5431572    
     +,   0.5550094    ,   0.5565916    ,   0.5484998    
     +,   0.5327671    ,   0.5123202    ,   0.4902286    
     +,   0.4689877    ,   0.4499912    ,   0.4333409    
     +,   0.4180129    ,   0.4023708    ,   0.3848814    
     +,   0.3647650    ,   0.3423452    ,   0.3189583    
     +,   0.2964983    ,   0.2768071    ,   0.2611681    
     +,   0.2500358    ,   0.2430453    ,   0.2392140    
     +,   0.2372416    ,   0.2358021    ,   0.2337695    
     +,   0.2303460    ,   0.2251018    ,   0.2179438    
     +,   0.2090428    ,   0.1987425    ,   0.1874767    
     +,   0.1756991    ,   0.1638342    ,   0.1522465    
     +,   0.1412236    ,   0.1309721    ,   0.1216146    
     +,   0.1131975    ,   0.1057011    ,   9.9053048E-02
     +,   9.3145959E-02,   8.7855347E-02,   8.3056986E-02
     +,   7.8639910E-02,   7.4514911E-02,   7.0618540E-02
     +,   6.6912428E-02,   6.3379079E-02,   6.0015820E-02
     +,   5.6829009E-02,   5.3829104E-02,   5.1026035E-02
     +,   4.8426893E-02,   4.6035048E-02,   4.3849401E-02
     +,   4.1864939E-02,   4.0073458E-02,   3.8464405E-02
     +,   3.7025567E-02,   3.5743486E-02,   3.4604136E-02
     +,   3.3593260E-02,   3.2696690E-02,   3.1900402E-02
     +,   3.1190958E-02,   3.0555671E-02,   2.9982598E-02
     +,   2.9460959E-02,   2.8981093E-02,   2.8534655E-02
     +,   2.8114613E-02,   2.7715296E-02,   2.7332395E-02
     +,   2.6962902E-02,   2.6604937E-02,   2.6257727E-02
     +,   2.5921404E-02,   2.5596865E-02,   2.5285536E-02
     +,   2.4989245E-02,   2.4710052E-02,   2.4450025E-02
     +,   2.4211125E-02,   2.3995081E-02,   2.3803262E-02
     +,   2.3636559E-02,   2.3495382E-02,   2.3379572E-02
     +,   2.3288425E-02,   2.3220681E-02,   2.3174589E-02
     +,   2.3147950E-02,   2.3138154E-02,   2.3142321E-02
     +,   2.3157312E-02,   2.3179892E-02,   2.3206769E-02
     +,   2.3234712E-02,   2.3260562E-02,   2.3281386E-02
     +,   2.3294484E-02,   2.3297412E-02,   2.3288067E-02
     +,   2.3264637E-02,   2.3225682E-02,   2.3170054E-02
     +,   2.3096938E-02,   2.3005787E-02,   2.2896323E-02
     +,   2.2768458E-02,   2.2622317E-02,   2.2458144E-02
     +,   2.2276269E-02,   2.2077106E-02,   2.1861110E-02
     +,   2.1628704E-02,   2.1380302E-02,   2.1116290E-02
     +,   2.0837007E-02,   2.0542728E-02,   2.0233665E-02
     +,   1.9910010E-02,   1.9571921E-02,   1.9219521E-02
     +,   1.8852932E-02,   1.8472314E-02,   1.8077852E-02
     +,   1.7669786E-02,   1.7248461E-02,   1.6814305E-02
     +,   1.6367862E-02,   1.5909774E-02,   1.5440842E-02
     +,   1.4962010E-02,   1.4474325E-02,   1.3978950E-02
     +,   1.3477209E-02,   1.2970523E-02,   1.2460375E-02
     +,   1.1948314E-02,   1.1436001E-02,   1.0925060E-02
     +,   1.0417131E-02,   9.9138720E-03,   9.4168996E-03
     +,   8.9277457E-03,   8.4478557E-03,   7.9786219E-03
     +,   7.5213178E-03,   7.0770704E-03,   6.6468786E-03
     +,   6.2316279E-03,   5.8320602E-03,   5.4487512E-03
     +,   5.0821323E-03,   4.7325348E-03,   4.4001159E-03
     +,   4.0849126E-03,   3.7868631E-03,   3.5057929E-03
     +,   3.2414114E-03,   2.9933441E-03,   2.7611526E-03
     +,   2.5443351E-03,   2.3423198E-03,   2.1544916E-03
     +,   1.9802237E-03,   1.8188395E-03,   1.6696691E-03
     +,   1.5320175E-03,   1.4052072E-03,   1.2885507E-03
     +,   1.1813889E-03,   1.0830651E-03,   9.9295645E-04
     +,   9.1045193E-04,   8.3497918E-04,   7.6598470E-04
     +,   7.0294656E-04,   6.4537808E-04,   5.9281668E-04
     +,   5.4483581E-04,   5.0103373E-04,   4.6104312E-04
     +,   4.2451979E-04,   3.9115158E-04,   3.6064777E-04
     +,   3.3274622E-04,   3.0720409E-04,   2.8380362E-04
     +,   2.6234391E-04,   2.4264584E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_ashz_ttz75_mass = Yx/5.150896
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_ashz_ttz80_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.5583276E-03,   1.5888312E-03
     +,   1.6175797E-03,   1.6444591E-03,   1.6693629E-03
     +,   1.6921918E-03,   1.7128555E-03,   1.7312737E-03
     +,   1.7473757E-03,   1.7611026E-03,   1.7724069E-03
     +,   1.7812530E-03,   1.7876187E-03,   1.7914952E-03
     +,   1.7928870E-03,   1.7918135E-03,   1.7883077E-03
     +,   1.7824178E-03,   1.7742057E-03,   1.7637500E-03
     +,   1.7511416E-03,   1.7364875E-03,   1.7199091E-03
     +,   1.7015401E-03,   1.6815304E-03,   1.6600413E-03
     +,   1.6372476E-03,   1.6133360E-03,   1.5885053E-03
     +,   1.5629653E-03,   1.5369359E-03,   1.5106464E-03
     +,   1.4843359E-03,   1.4582515E-03,   1.4326487E-03
     +,   1.4077899E-03,   1.3839448E-03,   1.3613917E-03
     +,   1.3404129E-03,   1.3213019E-03,   1.3043579E-03
     +,   1.2898904E-03,   1.2782194E-03,   1.2696767E-03
     +,   1.2646095E-03,   1.2633812E-03,   1.2663772E-03
     +,   1.2740049E-03,   1.2867013E-03,   1.3049345E-03
     +,   1.3292101E-03,   1.3600743E-03,   1.3981194E-03
     +,   1.4439913E-03,   1.4983864E-03,   1.5620650E-03
     +,   1.6358480E-03,   1.7206211E-03,   1.8173398E-03
     +,   1.9270264E-03,   2.0507728E-03,   2.1897389E-03
     +,   2.3451417E-03,   2.5182702E-03,   2.7104730E-03
     +,   2.9231289E-03,   3.1576899E-03,   3.4156146E-03
     +,   3.6984226E-03,   4.0076249E-03,   4.3447851E-03
     +,   4.7114417E-03,   5.1091891E-03,   5.5395951E-03
     +,   6.0042934E-03,   6.5049697E-03,   7.0433537E-03
     +,   7.6212846E-03,   8.2407854E-03,   8.9040846E-03
     +,   9.6135875E-03,   1.0372066E-02,   1.1182475E-02
     +,   1.2048161E-02,   1.2972551E-02,   1.3959303E-02
     +,   1.5011895E-02,   1.6133716E-02,   1.7327642E-02
     +,   1.8596144E-02,   1.9941278E-02,   2.1364853E-02
     +,   2.2869114E-02,   2.4457840E-02,   2.6137704E-02
     +,   2.7919931E-02,   2.9822869E-02,   3.1874035E-02
     +,   3.4113377E-02,   3.6595952E-02,   3.9396130E-02
     +,   4.2611446E-02,   4.6367861E-02,   5.0822809E-02
     +,   5.6166492E-02,   6.2615775E-02,   7.0397578E-02
     +,   7.9724014E-02,   9.0767242E-02,   0.1036541    
     +,   0.1185079    ,   0.1355590    ,   0.1552827    
     +,   0.1784864    ,   0.2062042    ,   0.2393548    
     +,   0.2782329    ,   0.3221068    ,   0.3691394    
     +,   0.4167833    ,   0.4625441    ,   0.5049326    
     +,   0.5441802    ,   0.5821055    ,   0.6208081    
     +,   0.6608391    ,   0.7001916    ,   0.7349252    
     +,   0.7609518    ,   0.7757990    ,   0.7795591    
     +,   0.7747144    ,   0.7649694    ,   0.7537469    
     +,   0.7432448    ,   0.7342162    ,   0.7258658    
     +,   0.7156749    ,   0.6999032    ,   0.6753152    
     +,   0.6412316    ,   0.6002740    ,   0.5571675    
     +,   0.5166001    ,   0.4815249    ,   0.4525711    
     +,   0.4284226    ,   0.4067600    ,   0.3853385    
     +,   0.3627990    ,   0.3389236    ,   0.3143593    
     +,   0.2900900    ,   0.2669734    ,   0.2455098    
     +,   0.2258260    ,   0.2077900    ,   0.1911661    
     +,   0.1757438    ,   0.1614049    ,   0.1481209    
     +,   0.1359160    ,   0.1248205    ,   0.1148349    
     +,   0.1059173    ,   9.7988345E-02,   9.0945207E-02
     +,   8.4677100E-02,   7.9078667E-02,   7.4060164E-02
     +,   6.9553211E-02,   6.5511212E-02,   6.1907485E-02
     +,   5.8730971E-02,   5.5980790E-02,   5.3659566E-02
     +,   5.1768139E-02,   5.0301373E-02,   4.9245100E-02
     +,   4.8574943E-02,   4.8256699E-02,   4.8247680E-02
     +,   4.8498612E-02,   4.8955970E-02,   4.9564105E-02
     +,   5.0267182E-02,   5.1010955E-02,   5.1744208E-02
     +,   5.2419979E-02,   5.2996356E-02,   5.3437576E-02
     +,   5.3714417E-02,   5.3804673E-02,   5.3693391E-02
     +,   5.3372789E-02,   5.2841935E-02,   5.2106369E-02
     +,   5.1177267E-02,   5.0070565E-02,   4.8806086E-02
     +,   4.7406416E-02,   4.5895975E-02,   4.4299863E-02
     +,   4.2643014E-02,   4.0949620E-02,   3.9242208E-02
     +,   3.7541188E-02,   3.5864729E-02,   3.4228340E-02
     +,   3.2644730E-02,   3.1123925E-02,   2.9673442E-02
     +,   2.8298389E-02,   2.7001578E-02,   2.5783928E-02
     +,   2.4644746E-02,   2.3582028E-02,   2.2592589E-02
     +,   2.1672446E-02,   2.0817164E-02,   2.0021908E-02
     +,   1.9281695E-02,   1.8591626E-02,   1.7946994E-02
     +,   1.7343277E-02,   1.6776327E-02,   1.6242398E-02
     +,   1.5738131E-02,   1.5260528E-02,   1.4806956E-02
     +,   1.4375151E-02,   1.3963129E-02,   1.3569139E-02
     +,   1.3191614E-02,   1.2829187E-02,   1.2480581E-02
     +,   1.2144577E-02,   1.1820053E-02,   1.1505907E-02
     +,   1.1201045E-02,   1.0904381E-02,   1.0614869E-02
     +,   1.0331469E-02,   1.0053157E-02,   9.7789420E-03
     +,   9.5079076E-03,   9.2391949E-03,   8.9720041E-03
     +,   8.7056281E-03,   8.4394962E-03,   8.1731128E-03
     +,   7.9061082E-03,   7.6382500E-03,   7.3694321E-03
     +,   7.0996555E-03,   6.8290378E-03,   6.5578269E-03
     +,   6.2863794E-03,   6.0151201E-03,   5.7445550E-03
     +,   5.4752789E-03,   5.2079330E-03,   4.9431808E-03
     +,   4.6817078E-03,   4.4242362E-03,   4.1714530E-03
     +,   3.9240289E-03,   3.6826232E-03,   3.4478509E-03
     +,   3.2202653E-03,   3.0003623E-03,   2.7885931E-03
     +,   2.5853380E-03,   2.3908971E-03,   2.2055008E-03
     +,   2.0293277E-03,   1.8624626E-03,   1.7049476E-03
     +,   1.5567379E-03,   1.4177512E-03,   1.2878306E-03
     +,   1.1667877E-03,   1.0543726E-03,   9.5031335E-04
     +,   8.5429038E-04,   7.6597079E-04,   6.8499078E-04
     +,   6.1097124E-04,   5.4352998E-04,   4.8226904E-04
     +,   4.2679781E-04,   3.7672004E-04,   3.3165226E-04
     +,   2.9121395E-04,   2.5504135E-04,   2.2277966E-04
     +,   1.9409384E-04,   1.6866167E-04,   1.4618222E-04
     +,   1.2636984E-04,   1.0896030E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_ashz_ttz80_mass = Yx/6.65117909302326
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_ashz_ttz85_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.9319135E-04,   4.0939735E-04
     +,   4.2607088E-04,   4.4321772E-04,   4.6084335E-04
     +,   4.7895388E-04,   4.9755472E-04,   5.1665225E-04
     +,   5.3625205E-04,   5.5636110E-04,   5.7698600E-04
     +,   5.9813319E-04,   6.1981037E-04,   6.4202468E-04
     +,   6.6478492E-04,   6.8809919E-04,   7.1197719E-04
     +,   7.3642842E-04,   7.6146360E-04,   7.8709418E-04
     +,   8.1333250E-04,   8.4019150E-04,   8.6768495E-04
     +,   8.9582964E-04,   9.2464010E-04,   9.5413561E-04
     +,   9.8433509E-04,   1.0152591E-03,   1.0469304E-03
     +,   1.0793739E-03,   1.1126160E-03,   1.1466866E-03
     +,   1.1816177E-03,   1.2174444E-03,   1.2542066E-03
     +,   1.2919478E-03,   1.3307164E-03,   1.3705664E-03
     +,   1.4115613E-03,   1.4537672E-03,   1.4972650E-03
     +,   1.5421427E-03,   1.5885014E-03,   1.6364562E-03
     +,   1.6861382E-03,   1.7376968E-03,   1.7913015E-03
     +,   1.8471451E-03,   1.9054452E-03,   1.9664478E-03
     +,   2.0304290E-03,   2.0976982E-03,   2.1685986E-03
     +,   2.2435142E-03,   2.3228584E-03,   2.4070947E-03
     +,   2.4967182E-03,   2.5922628E-03,   2.6943001E-03
     +,   2.8034344E-03,   2.9202981E-03,   3.0455480E-03
     +,   3.1798484E-03,   3.3238812E-03,   3.4783247E-03
     +,   3.6438289E-03,   3.8210356E-03,   4.0105232E-03
     +,   4.2128372E-03,   4.4284277E-03,   4.6576876E-03
     +,   4.9008755E-03,   5.1581734E-03,   5.4295999E-03
     +,   5.7150642E-03,   6.0143317E-03,   6.3270056E-03
     +,   6.6525321E-03,   6.9902423E-03,   7.3393276E-03
     +,   7.6988293E-03,   8.0677383E-03,   8.4449342E-03
     +,   8.8293292E-03,   9.2198141E-03,   9.6154362E-03
     +,   1.0015377E-02,   1.0419158E-02,   1.0826670E-02
     +,   1.1238380E-02,   1.1655496E-02,   1.2080096E-02
     +,   1.2515360E-02,   1.2965827E-02,   1.3437570E-02
     +,   1.3938379E-02,   1.4478057E-02,   1.5068467E-02
     +,   1.5723826E-02,   1.6460573E-02,   1.7297596E-02
     +,   1.8255889E-02,   1.9358631E-02,   2.0630572E-02
     +,   2.2097792E-02,   2.3787025E-02,   2.5724778E-02
     +,   2.7936440E-02,   3.0445486E-02,   3.3272363E-02
     +,   3.6433209E-02,   3.9939977E-02,   4.3799158E-02
     +,   4.8013125E-02,   5.2579783E-02,   5.7494838E-02
     +,   6.2751651E-02,   6.8343304E-02,   7.4261278E-02
     +,   8.0496326E-02,   8.7038659E-02,   9.3879558E-02
     +,   0.1010175    ,   0.1084666    ,   0.1162647    
     +,   0.1244822    ,   0.1332358    ,   0.1427100    
     +,   0.1532035    ,   0.1651837    ,   0.1793249    
     +,   0.1964566    ,   0.2173927    ,   0.2426558    
     +,   0.2722464    ,   0.3056308    ,   0.3420392    
     +,   0.3809772    ,   0.4226767    ,   0.4682593    
     +,   0.5194874    ,   0.5779030    ,   0.6431861    
     +,   0.7116254    ,   0.7768514    ,   0.8334982    
     +,   0.8803986    ,   0.9198220    ,   0.9549719    
     +,   0.9896769    ,    1.027590    ,    1.066823    
     +,    1.096251    ,    1.102477    ,    1.081782    
     +,    1.042536    ,   0.9958412    ,   0.9469267    
     +,   0.8957707    ,   0.8416430    ,   0.7839501    
     +,   0.7207584    ,   0.6499240    ,   0.5722567    
     +,   0.4924269    ,   0.4164720    ,   0.3488009    
     +,   0.2912348    ,   0.2438156    ,   0.2058131    
     +,   0.1761384    ,   0.1534177    ,   0.1361313    
     +,   0.1228713    ,   0.1125439    ,   0.1044061    
     +,   9.7984470E-02,   9.2963211E-02,   8.9110397E-02
     +,   8.6251937E-02,   8.4270954E-02,   8.3106883E-02
     +,   8.2743913E-02,   8.3189651E-02,   8.4450096E-02
     +,   8.6507045E-02,   8.9301519E-02,   9.2723668E-02
     +,   9.6610203E-02,   0.1007474    ,   0.1048819    
     +,   0.1087370    ,   0.1120329    ,   0.1145111    
     +,   0.1159580    ,   0.1162249    ,   0.1152411    
     +,   0.1130195    ,   0.1096523    ,   0.1052976    
     +,   0.1001623    ,   9.4479419E-02,   8.8485979E-02
     +,   8.2404383E-02,   7.6428443E-02,   7.0713542E-02
     +,   6.5373212E-02,   6.0480665E-02,   5.6072358E-02
     +,   5.2153684E-02,   4.8706323E-02,   4.5695081E-02
     +,   4.3073721E-02,   4.0789958E-02,   3.8789999E-02
     +,   3.7021752E-02,   3.5437066E-02,   3.3993166E-02
     +,   3.2653581E-02,   3.1388711E-02,   3.0175325E-02
     +,   2.8996302E-02,   2.7840020E-02,   2.6699476E-02
     +,   2.5571374E-02,   2.4455408E-02,   2.3353489E-02
     +,   2.2269078E-02,   2.1206459E-02,   2.0170311E-02
     +,   1.9165419E-02,   1.8196223E-02,   1.7266536E-02
     +,   1.6379485E-02,   1.5537408E-02,   1.4741728E-02
     +,   1.3992988E-02,   1.3290968E-02,   1.2634699E-02
     +,   1.2022530E-02,   1.1452294E-02,   1.0921451E-02
     +,   1.0427190E-02,   9.9664787E-03,   9.5362449E-03
     +,   9.1334619E-03,   8.7552033E-03,   8.3986642E-03
     +,   8.0612525E-03,   7.7406317E-03,   7.4346727E-03
     +,   7.1414975E-03,   6.8594888E-03,   6.5872581E-03
     +,   6.3236249E-03,   6.0675982E-03,   5.8183931E-03
     +,   5.5753812E-03,   5.3380625E-03,   5.1060561E-03
     +,   4.8791058E-03,   4.6570450E-03,   4.4397647E-03
     +,   4.2272201E-03,   4.0194420E-03,   3.8164777E-03
     +,   3.6184061E-03,   3.4253467E-03,   3.2374319E-03
     +,   3.0547932E-03,   2.8775653E-03,   2.7058960E-03
     +,   2.5399260E-03,   2.3797753E-03,   2.2255518E-03
     +,   2.0773625E-03,   1.9352755E-03,   1.7993578E-03
     +,   1.6696354E-03,   1.5461287E-03,   1.4288172E-03
     +,   1.3176725E-03,   1.2126265E-03,   1.1136022E-03
     +,   1.0204874E-03,   9.3316031E-04,   8.5147092E-04
     +,   7.7525206E-04,   7.0432830E-04,   6.3850050E-04
     +,   5.7756691E-04,   5.2130845E-04,   4.6950602E-04
     +,   4.2192868E-04,   3.7834901E-04,   3.3853253E-04
     +,   3.0225114E-04,   2.6927426E-04,   2.3937992E-04
     +,   2.1234744E-04,   1.8796658E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_ashz_ttz85_mass = Yx/7.70916586363636
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_ashz_ttz90_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.4529023E-04,   3.5126830E-04
     +,   3.5731640E-04,   3.6344177E-04,   3.6965264E-04
     +,   3.7595836E-04,   3.8236889E-04,   3.8889516E-04
     +,   3.9554934E-04,   4.0234468E-04,   4.0929523E-04
     +,   4.1641653E-04,   4.2372514E-04,   4.3123873E-04
     +,   4.3897654E-04,   4.4695864E-04,   4.5520707E-04
     +,   4.6374460E-04,   4.7259545E-04,   4.8178557E-04
     +,   4.9134204E-04,   5.0129322E-04,   5.1166891E-04
     +,   5.2250089E-04,   5.3382124E-04,   5.4566434E-04
     +,   5.5806577E-04,   5.7106197E-04,   5.8469130E-04
     +,   5.9899304E-04,   6.1400828E-04,   6.2977895E-04
     +,   6.4634834E-04,   6.6376140E-04,   6.8206398E-04
     +,   7.0130371E-04,   7.2152924E-04,   7.4279052E-04
     +,   7.6514028E-04,   7.8863051E-04,   8.1331760E-04
     +,   8.3925808E-04,   8.6651114E-04,   8.9513831E-04
     +,   9.2520367E-04,   9.5677446E-04,   9.8992081E-04
     +,   1.0247165E-03,   1.0612403E-03,   1.0995744E-03
     +,   1.1398076E-03,   1.1820336E-03,   1.2263528E-03
     +,   1.2728757E-03,   1.3217166E-03,   1.3730046E-03
     +,   1.4268771E-03,   1.4834841E-03,   1.5429906E-03
     +,   1.6055770E-03,   1.6714436E-03,   1.7408120E-03
     +,   1.8139242E-03,   1.8910553E-03,   1.9725140E-03
     +,   2.0586373E-03,   2.1498159E-03,   2.2464760E-03
     +,   2.3491120E-03,   2.4582653E-03,   2.5745623E-03
     +,   2.6986881E-03,   2.8314290E-03,   2.9736459E-03
     +,   3.1263081E-03,   3.2904898E-03,   3.4673598E-03
     +,   3.6581922E-03,   3.8643782E-03,   4.0874076E-03
     +,   4.3288381E-03,   4.5903311E-03,   4.8735677E-03
     +,   5.1802904E-03,   5.5121970E-03,   5.8709863E-03
     +,   6.2582190E-03,   6.6753714E-03,   7.1236789E-03
     +,   7.6041785E-03,   8.1176171E-03,   8.6643631E-03
     +,   9.2443926E-03,   9.8572941E-03,   1.0502208E-02
     +,   1.1177738E-02,   1.1882118E-02,   1.2613043E-02
     +,   1.3367902E-02,   1.4143630E-02,   1.4937000E-02
     +,   1.5744485E-02,   1.6562605E-02,   1.7387791E-02
     +,   1.8216733E-02,   1.9046377E-02,   1.9874061E-02
     +,   2.0697601E-02,   2.1515535E-02,   2.2327121E-02
     +,   2.3132358E-02,   2.3932239E-02,   2.4728613E-02
     +,   2.5524400E-02,   2.6323447E-02,   2.7130699E-02
     +,   2.7951946E-02,   2.8794073E-02,   2.9664664E-02
     +,   3.0572319E-02,   3.1526454E-02,   3.2537494E-02
     +,   3.3617165E-02,   3.4779057E-02,   3.6039341E-02
     +,   3.7417479E-02,   3.8937565E-02,   4.0628839E-02
     +,   4.2526763E-02,   4.4672702E-02,   4.7114193E-02
     +,   4.9903493E-02,   5.3097542E-02,   5.6756850E-02
     +,   6.0946617E-02,   6.5738112E-02,   7.1210034E-02
     +,   7.7450626E-02,   8.4558070E-02,   9.2640057E-02
     +,   0.1018140    ,   0.1122117    ,   0.1239887    
     +,   0.1373291    ,   0.1524318    ,   0.1694622    
     +,   0.1884632    ,   0.2092494    ,   0.2313595    
     +,   0.2541404    ,   0.2769895    ,   0.2996771    
     +,   0.3225809    ,   0.3466787    ,   0.3733131    
     +,   0.4038813    ,   0.4395237    ,   0.4806871    
     +,   0.5265087    ,   0.5744058    ,   0.6204920    
     +,   0.6609157    ,   0.6934784    ,   0.7185407    
     +,   0.7385100    ,   0.7557461    ,   0.7698222    
     +,   0.7761969    ,   0.7680384    ,   0.7403955    
     +,   0.6936044    ,   0.6335118    ,   0.5689626    
     +,   0.5087429    ,   0.4594611    ,   0.4244923    
     +,   0.4038334    ,   0.3948642    ,   0.3938584    
     +,   0.3975438    ,   0.4039318    ,   0.4121659    
     +,   0.4217880    ,   0.4320255    ,   0.4414632    
     +,   0.4481900    ,   0.4502706    ,   0.4463364    
     +,   0.4360539    ,   0.4202753    ,   0.4007837    
     +,   0.3797350    ,   0.3590286    ,   0.3398671    
     +,   0.3226445    ,   0.3071343    ,   0.2928154    
     +,   0.2791621    ,   0.2658132    ,   0.2526100    
     +,   0.2395452    ,   0.2266850    ,   0.2141026    
     +,   0.2018511    ,   0.1899658    ,   0.1784790    
     +,   0.1674358    ,   0.1568962    ,   0.1469218    
     +,   0.1375570    ,   0.1288145    ,   0.1206707    
     +,   0.1130711    ,   0.1059447    ,   9.9222742E-02
     +,   9.2854358E-02,   8.6814679E-02,   8.1104711E-02
     +,   7.5744987E-02,   7.0765167E-02,   6.6191360E-02
     +,   6.2037125E-02,   5.8298431E-02,   5.4951996E-02
     +,   5.1957995E-02,   4.9265396E-02,   4.6818588E-02
     +,   4.4563185E-02,   4.2450987E-02,   4.0443420E-02
     +,   3.8513236E-02,   3.6644265E-02,   3.4829982E-02
     +,   3.3071529E-02,   3.1375293E-02,   2.9750179E-02
     +,   2.8205523E-02,   2.6749481E-02,   2.5387727E-02
     +,   2.4122670E-02,   2.2953391E-02,   2.1875905E-02
     +,   2.0883556E-02,   1.9967545E-02,   1.9117743E-02
     +,   1.8323436E-02,   1.7573919E-02,   1.6858952E-02
     +,   1.6169271E-02,   1.5496938E-02,   1.4835400E-02
     +,   1.4179613E-02,   1.3526089E-02,   1.2872770E-02
     +,   1.2218856E-02,   1.1564673E-02,   1.0911519E-02
     +,   1.0261456E-02,   9.6170316E-03,   8.9811608E-03
     +,   8.3569856E-03,   7.7476748E-03,   7.1562557E-03
     +,   6.5855482E-03,   6.0381233E-03,   5.5161295E-03
     +,   5.0213160E-03,   4.5550247E-03,   4.1181636E-03
     +,   3.7111763E-03,   3.3341090E-03,   2.9866609E-03
     +,   2.6681907E-03,   2.3777520E-03,   2.1141618E-03
     +,   1.8760732E-03,   1.6619617E-03,   1.4702362E-03
     +,   1.2992236E-03,   1.1472545E-03,   1.0126526E-03
     +,   8.9380087E-04,   7.8912760E-04,   6.9715607E-04
     +,   6.1648816E-04,   5.4583844E-04,   4.8401667E-04
     +,   4.2994163E-04,   3.8264148E-04,   3.4124023E-04
     +,   3.0496460E-04,   2.7312723E-04,   2.4512975E-04
     +,   2.2044667E-04,   1.9862592E-04,   1.7927474E-04
     +,   1.6205858E-04,   1.4668910E-04,   1.3292255E-04
     +,   1.2055023E-04,   1.0939668E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_ashz_ttz90_mass = Yx/7.27494075
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_ashz_ttz95_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  6.2249333E-04,   6.4140192E-04
     +,   6.6064287E-04,   6.8024202E-04,   7.0022972E-04
     +,   7.2063960E-04,   7.4150972E-04,   7.6288235E-04
     +,   7.8480307E-04,   8.0732332E-04,   8.3049684E-04
     +,   8.5438165E-04,   8.7903987E-04,   9.0453582E-04
     +,   9.3093823E-04,   9.5831743E-04,   9.8674593E-04
     +,   1.0162990E-03,   1.0470510E-03,   1.0790785E-03
     +,   1.1124569E-03,   1.1472609E-03,   1.1835626E-03
     +,   1.2214336E-03,   1.2609382E-03,   1.3021411E-03
     +,   1.3450977E-03,   1.3898588E-03,   1.4364681E-03
     +,   1.4849614E-03,   1.5353652E-03,   1.5876964E-03
     +,   1.6419616E-03,   1.6981566E-03,   1.7562645E-03
     +,   1.8162569E-03,   1.8780929E-03,   1.9417165E-03
     +,   2.0070642E-03,   2.0740503E-03,   2.1425844E-03
     +,   2.2125591E-03,   2.2838549E-03,   2.3563411E-03
     +,   2.4298741E-03,   2.5043031E-03,   2.5794655E-03
     +,   2.6551902E-03,   2.7313016E-03,   2.8076184E-03
     +,   2.8839530E-03,   2.9601182E-03,   3.0359246E-03
     +,   3.1111890E-03,   3.1857232E-03,   3.2593526E-03
     +,   3.3319071E-03,   3.4032241E-03,   3.4731529E-03
     +,   3.5415576E-03,   3.6083164E-03,   3.6733234E-03
     +,   3.7364885E-03,   3.7977446E-03,   3.8570473E-03
     +,   3.9143628E-03,   3.9696931E-03,   4.0230523E-03
     +,   4.0744855E-03,   4.1240538E-03,   4.1718488E-03
     +,   4.2179758E-03,   4.2625694E-03,   4.3057790E-03
     +,   4.3477737E-03,   4.3887449E-03,   4.4288943E-03
     +,   4.4684382E-03,   4.5076036E-03,   4.5466302E-03
     +,   4.5857588E-03,   4.6252385E-03,   4.6653152E-03
     +,   4.7062389E-03,   4.7482508E-03,   4.7915932E-03
     +,   4.8364946E-03,   4.8831822E-03,   4.9318662E-03
     +,   4.9827546E-03,   5.0360444E-03,   5.0919247E-03
     +,   5.1505766E-03,   5.2121822E-03,   5.2769273E-03
     +,   5.3449962E-03,   5.4165907E-03,   5.4919273E-03
     +,   5.5712499E-03,   5.6548333E-03,   5.7429993E-03
     +,   5.8361106E-03,   5.9346021E-03,   6.0389666E-03
     +,   6.1497837E-03,   6.2677241E-03,   6.3935458E-03
     +,   6.5281140E-03,   6.6724159E-03,   6.8275593E-03
     +,   6.9947699E-03,   7.1754255E-03,   7.3710252E-03
     +,   7.5832303E-03,   7.8138458E-03,   8.0648400E-03
     +,   8.3383275E-03,   8.6366162E-03,   8.9621618E-03
     +,   9.3176309E-03,   9.7059011E-03,   1.0130057E-02
     +,   1.0593426E-02,   1.1099661E-02,   1.1652774E-02
     +,   1.2257119E-02,   1.2917613E-02,   1.3639604E-02
     +,   1.4429144E-02,   1.5292810E-02,   1.6237920E-02
     +,   1.7272212E-02,   1.8403964E-02,   1.9641459E-02
     +,   2.0992856E-02,   2.2465590E-02,   2.4065677E-02
     +,   2.5797090E-02,   2.7661236E-02,   2.9656256E-02
     +,   3.1776510E-02,   3.4012664E-02,   3.6352307E-02
     +,   3.8780950E-02,   4.1283485E-02,   4.3847360E-02
     +,   4.6465311E-02,   4.9138848E-02,   5.1881716E-02
     +,   5.4722920E-02,   5.7707969E-02,   6.0897786E-02
     +,   6.4365186E-02,   6.8188027E-02,   7.2438292E-02
     +,   7.7168405E-02,   8.2396135E-02,   8.8089772E-02
     +,   9.4156168E-02,   0.1004332    ,   0.1066933    
     +,   0.1126549    ,   0.1180050    ,   0.1224315    
     +,   0.1256600    ,   0.1274909    ,   0.1278294    
     +,   0.1267056    ,   0.1242799    ,   0.1208354    
     +,   0.1167644    ,   0.1125536    ,   0.1087751    
     +,   0.1060867    ,   0.1052341    ,   0.1070439    
     +,   0.1124030    ,   0.1222298    ,   0.1374547    
     +,   0.1590249    ,   0.1878900    ,   0.2248785    
     +,   0.2704047    ,   0.3241038    ,   0.3846557    
     +,   0.4499734    ,   0.5175632    ,   0.5847301    
     +,   0.6487719    ,   0.7078655    ,   0.7627640    
     +,   0.8175057    ,   0.8764622    ,   0.9380341    
     +,   0.9911588    ,    1.021283    ,    1.022388    
     +,    1.002138    ,   0.9736779    ,   0.9436014    
     +,   0.9091367    ,   0.8652200    ,   0.8118520    
     +,   0.7547884    ,   0.7007620    ,   0.6525006    
     +,   0.6077012    ,   0.5622063    ,   0.5142164    
     +,   0.4658303    ,   0.4210378    ,   0.3825121    
     +,   0.3501019    ,   0.3217437    ,   0.2953567    
     +,   0.2700366    ,   0.2460469    ,   0.2241406    
     +,   0.2049248    ,   0.1885858    ,   0.1749159    
     +,   0.1634756    ,   0.1537502    ,   0.1452494    
     +,   0.1375584    ,   0.1303553    ,   0.1234132    
     +,   0.1165914    ,   0.1098234    ,   0.1031011    
     +,   9.6456662E-02,   8.9943856E-02,   8.3622836E-02
     +,   7.7549592E-02,   7.1770296E-02,   6.6317409E-02
     +,   6.1209749E-02,   5.6453936E-02,   5.2045733E-02
     +,   4.7971871E-02,   4.4213168E-02,   4.0746838E-02
     +,   3.7548397E-02,   3.4593336E-02,   3.1858522E-02
     +,   2.9323174E-02,   2.6968976E-02,   2.4780015E-02
     +,   2.2742810E-02,   2.0846188E-02,   1.9080509E-02
     +,   1.7437575E-02,   1.5910354E-02,   1.4492569E-02
     +,   1.3178399E-02,   1.1962403E-02,   1.0839437E-02
     +,   9.8044844E-03,   8.8525489E-03,   7.9787169E-03
     +,   7.1781995E-03,   6.4462852E-03,   5.7783294E-03
     +,   5.1698349E-03,   4.6165278E-03,   4.1142739E-03
     +,   3.6591506E-03,   3.2474848E-03,   2.8758300E-03
     +,   2.5409313E-03,   2.2397591E-03,   1.9695105E-03
     +,   1.7275693E-03,   1.5114866E-03,   1.3189835E-03
     +,   1.1479545E-03,   9.9641504E-04,   8.6253730E-04
     +,   7.4460299E-04,   6.4103096E-04,   5.5034249E-04
     +,   4.7118319E-04,   4.0229509E-04,   3.4253314E-04
     +,   2.9084360E-04,   2.4627487E-04,   2.0796055E-04
     +,   1.7512061E-04,   1.4705841E-04,   1.2314809E-04
     +,   1.0283662E-04,   8.5631771E-05,   7.1102048E-05
     +,   5.8866714E-05,   4.8594538E-05,   3.9995597E-05
     +,   3.2819396E-05,   2.6848327E-05,   2.1895597E-05
     +,   1.7800103E-05,   1.4424420E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_ashz_ttz95_mass = Yx/7.08120954545454
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_ashz_hatt100_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.5873347E-03,   2.6723149E-03
     +,   2.7581253E-03,   2.8447218E-03,   2.9320712E-03
     +,   3.0201524E-03,   3.1089552E-03,   3.1984877E-03
     +,   3.2887731E-03,   3.3798590E-03,   3.4718090E-03
     +,   3.5647105E-03,   3.6586793E-03,   3.7538563E-03
     +,   3.8504095E-03,   3.9485400E-03,   4.0484802E-03
     +,   4.1504917E-03,   4.2548748E-03,   4.3619592E-03
     +,   4.4721100E-03,   4.5857257E-03,   4.7032372E-03
     +,   4.8251152E-03,   4.9518435E-03,   5.0839470E-03
     +,   5.2219699E-03,   5.3664781E-03,   5.5180532E-03
     +,   5.6772805E-03,   5.8447625E-03,   6.0210945E-03
     +,   6.2068603E-03,   6.4026313E-03,   6.6089556E-03
     +,   6.8263412E-03,   7.0552616E-03,   7.2961343E-03
     +,   7.5493217E-03,   7.8150956E-03,   8.0936765E-03
     +,   8.3851740E-03,   8.6896066E-03,   9.0068830E-03
     +,   9.3368068E-03,   9.6790455E-03,   1.0033160E-02
     +,   1.0398570E-02,   1.0774558E-02,   1.1160297E-02
     +,   1.1554805E-02,   1.1956986E-02,   1.2365611E-02
     +,   1.2779357E-02,   1.3196755E-02,   1.3616278E-02
     +,   1.4036288E-02,   1.4455092E-02,   1.4870940E-02
     +,   1.5282031E-02,   1.5686572E-02,   1.6082760E-02
     +,   1.6468789E-02,   1.6842941E-02,   1.7203549E-02
     +,   1.7548993E-02,   1.7877819E-02,   1.8188637E-02
     +,   1.8480241E-02,   1.8751565E-02,   1.9001728E-02
     +,   1.9230003E-02,   1.9435927E-02,   1.9619159E-02
     +,   1.9779634E-02,   1.9917486E-02,   2.0033058E-02
     +,   2.0126898E-02,   2.0199796E-02,   2.0252720E-02
     +,   2.0286851E-02,   2.0303551E-02,   2.0304365E-02
     +,   2.0290988E-02,   2.0265287E-02,   2.0229246E-02
     +,   2.0184983E-02,   2.0134712E-02,   2.0080766E-02
     +,   2.0025520E-02,   1.9971453E-02,   1.9921098E-02
     +,   1.9877011E-02,   1.9841827E-02,   1.9818213E-02
     +,   1.9808834E-02,   1.9816421E-02,   1.9843724E-02
     +,   1.9893514E-02,   1.9968560E-02,   2.0071700E-02
     +,   2.0205734E-02,   2.0373493E-02,   2.0577783E-02
     +,   2.0821370E-02,   2.1107003E-02,   2.1437306E-02
     +,   2.1814803E-02,   2.2241853E-02,   2.2720601E-02
     +,   2.3252867E-02,   2.3840202E-02,   2.4483670E-02
     +,   2.5183929E-02,   2.5940977E-02,   2.6754312E-02
     +,   2.7622610E-02,   2.8543962E-02,   2.9515518E-02
     +,   3.0533751E-02,   3.1594343E-02,   3.2692097E-02
     +,   3.3821136E-02,   3.4974899E-02,   3.6146335E-02
     +,   3.7327792E-02,   3.8511410E-02,   3.9689019E-02
     +,   4.0852528E-02,   4.1993883E-02,   4.3105397E-02
     +,   4.4179708E-02,   4.5210022E-02,   4.6190143E-02
     +,   4.7114640E-02,   4.7978841E-02,   4.8778694E-02
     +,   4.9510974E-02,   5.0173145E-02,   5.0763164E-02
     +,   5.1279578E-02,   5.1721275E-02,   5.2087381E-02
     +,   5.2377239E-02,   5.2590232E-02,   5.2725878E-02
     +,   5.2783456E-02,   5.2762385E-02,   5.2662041E-02
     +,   5.2481860E-02,   5.2221440E-02,   5.1880680E-02
     +,   5.1459957E-02,   5.0960228E-02,   5.0383240E-02
     +,   4.9731735E-02,   4.9009603E-02,   4.8221905E-02
     +,   4.7375072E-02,   4.6477046E-02,   4.5537207E-02
     +,   4.4566404E-02,   4.3576881E-02,   4.2582452E-02
     +,   4.1597944E-02,   4.0639363E-02,   3.9723784E-02
     +,   3.8868986E-02,   3.8093284E-02,   3.7415378E-02
     +,   3.6854092E-02,   3.6428228E-02,   3.6156140E-02
     +,   3.6055744E-02,   3.6144130E-02,   3.6437381E-02
     +,   3.6950409E-02,   3.7696671E-02,   3.8688071E-02
     +,   3.9934814E-02,   4.1445475E-02,   4.3226749E-02
     +,   4.5283806E-02,   4.7620632E-02,   5.0240733E-02
     +,   5.3147294E-02,   5.6344643E-02,   5.9839543E-02
     +,   6.3642584E-02,   6.7769110E-02,   7.2241440E-02
     +,   7.7089623E-02,   8.2351439E-02,   8.8071927E-02
     +,   9.4301850E-02,   0.1010935    ,   0.1084956    
     +,   0.1165463    ,   0.1252663    ,   0.1346514    
     +,   0.1446657    ,   0.1552385    ,   0.1662673    
     +,   0.1776247    ,   0.1891728    ,   0.2007883    
     +,   0.2123917    ,   0.2239775    ,   0.2356430    
     +,   0.2475998    ,   0.2601532    ,   0.2736514    
     +,   0.2884034    ,   0.3046015    ,   0.3222843    
     +,   0.3413998    ,   0.3619937    ,   0.3845061    
     +,   0.4100754    ,   0.4407149    ,   0.4792467    
     +,   0.5289510    ,   0.5929474    ,   0.6733187    
     +,   0.7700966    ,   0.8808600    ,    1.002959    
     +,    1.140051    ,    1.309749    ,    1.542135    
     +,    1.860874    ,    2.257864    ,    2.691840    
     +,    3.118995    ,    3.514319    ,    3.855980    
     +,    4.108159    ,    4.237536    ,    4.242497    
     +,    4.152873    ,    3.994418    ,    3.763194    
     +,    3.445238    ,    3.054501    ,    2.638785    
     +,    2.250808    ,    1.918605    ,    1.637987    
     +,    1.388468    ,    1.154969    ,   0.9364191    
     +,   0.7405831    ,   0.5751196    ,   0.4424016    
     +,   0.3394422    ,   0.2605752    ,   0.2000708    
     +,   0.1534051    ,   0.1173625    ,   8.9649290E-02
     +,   6.8511188E-02,   5.2516513E-02,   4.0474441E-02
     +,   3.1413801E-02,   2.4570037E-02,   1.9361205E-02
     +,   1.5357984E-02,   1.2249669E-02,   9.8130479E-03
     +,   7.8875208E-03,   6.3567152E-03,   5.1350510E-03
     +,   4.1580852E-03,   3.3760234E-03,   2.7495567E-03
     +,   2.2471861E-03,   1.8433948E-03,   1.5176581E-03
     +,   1.2535215E-03,   1.0380186E-03,   8.6100021E-04
     +,   7.1465102E-04,   5.9295492E-04,   4.9131532E-04
     +,   4.0617483E-04,   3.3476853E-04,   2.7489392E-04
     +,   2.2476808E-04,   1.8292191E-04,   1.4811428E-04
     +,   1.1929103E-04,   9.5541051E-05,   7.6079203E-05
     +,   6.0222745E-05,   4.7383077E-05,   3.7050988E-05
     +,   2.8791057E-05,   2.2230897E-05,   1.7056045E-05
     +,   1.3001464E-05,   9.8466753E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_ashz_hatt100_mass = Yx/19.51153806
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_ashz_hatt105_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  9.3394844E-03,   9.8489607E-03
     +,   1.0382536E-02,   1.0940842E-02,   1.1524431E-02
     +,   1.2133771E-02,   1.2769207E-02,   1.3431009E-02
     +,   1.4119259E-02,   1.4833968E-02,   1.5574943E-02
     +,   1.6341835E-02,   1.7134134E-02,   1.7951157E-02
     +,   1.8792015E-02,   1.9655639E-02,   2.0540796E-02
     +,   2.1446066E-02,   2.2369837E-02,   2.3310356E-02
     +,   2.4265716E-02,   2.5233874E-02,   2.6212651E-02
     +,   2.7199816E-02,   2.8193003E-02,   2.9189881E-02
     +,   3.0188039E-02,   3.1185089E-02,   3.2178685E-02
     +,   3.3166528E-02,   3.4146473E-02,   3.5116419E-02
     +,   3.6074478E-02,   3.7018940E-02,   3.7948254E-02
     +,   3.8861182E-02,   3.9756659E-02,   4.0633965E-02
     +,   4.1492689E-02,   4.2332619E-02,   4.3154024E-02
     +,   4.3957412E-02,   4.4743665E-02,   4.5513973E-02
     +,   4.6269927E-02,   4.7013443E-02,   4.7746725E-02
     +,   4.8472282E-02,   4.9192987E-02,   4.9911857E-02
     +,   5.0632272E-02,   5.1357578E-02,   5.2091446E-02
     +,   5.2837562E-02,   5.3599633E-02,   5.4381311E-02
     +,   5.5186301E-02,   5.6017898E-02,   5.6879532E-02
     +,   5.7774171E-02,   5.8704510E-02,   5.9673056E-02
     +,   6.0681790E-02,   6.1732542E-02,   6.2826641E-02
     +,   6.3965224E-02,   6.5149263E-02,   6.6379175E-02
     +,   6.7655735E-02,   6.8979360E-02,   7.0350930E-02
     +,   7.1771190E-02,   7.3241763E-02,   7.4764535E-02
     +,   7.6342285E-02,   7.7978894E-02,   7.9678923E-02
     +,   8.1448384E-02,   8.3294585E-02,   8.5226104E-02
     +,   8.7252572E-02,   8.9385048E-02,   9.1634966E-02
     +,   9.4014734E-02,   9.6536160E-02,   9.9210724E-02
     +,   0.1020480    ,   0.1050559    ,   0.1082384    
     +,   0.1115960    ,   0.1151249    ,   0.1188156    
     +,   0.1226539    ,   0.1266204    ,   0.1306916    
     +,   0.1348399    ,   0.1390362    ,   0.1432494    
     +,   0.1474500    ,   0.1516095    ,   0.1557029    
     +,   0.1597086    ,   0.1636090    ,   0.1673907    
     +,   0.1710430    ,   0.1745584    ,   0.1779308    
     +,   0.1811549    ,   0.1842260    ,   0.1871404    
     +,   0.1898944    ,   0.1924870    ,   0.1949187    
     +,   0.1971945    ,   0.1993235    ,   0.2013202    
     +,   0.2032025    ,   0.2049930    ,   0.2067167    
     +,   0.2083974    ,   0.2100580    ,   0.2117156    
     +,   0.2133804    ,   0.2150545    ,   0.2167290    
     +,   0.2183853    ,   0.2199958    ,   0.2215238    
     +,   0.2229272    ,   0.2241603    ,   0.2251773    
     +,   0.2259350    ,   0.2263953    ,   0.2265301    
     +,   0.2263193    ,   0.2257558    ,   0.2248419    
     +,   0.2235917    ,   0.2220273    ,   0.2201771    
     +,   0.2180741    ,   0.2157512    ,   0.2132406    
     +,   0.2105706    ,   0.2077650    ,   0.2048418    
     +,   0.2018132    ,   0.1986861    ,   0.1954638    
     +,   0.1921456    ,   0.1887291    ,   0.1852108    
     +,   0.1815869    ,   0.1778528    ,   0.1740061    
     +,   0.1700443    ,   0.1659669    ,   0.1617756    
     +,   0.1574747    ,   0.1530727    ,   0.1485823    
     +,   0.1440229    ,   0.1394205    ,   0.1348091    
     +,   0.1302302    ,   0.1257335    ,   0.1213764    
     +,   0.1172223    ,   0.1133405    ,   0.1098033    
     +,   0.1066857    ,   0.1040634    ,   0.1020113    
     +,   0.1006027    ,   9.9909008E-02,   9.9998519E-02
     +,   0.1009361    ,   0.1027825    ,   0.1055918    
     +,   0.1094107    ,   0.1142744    ,   0.1202026    
     +,   0.1271946    ,   0.1352252    ,   0.1442398    
     +,   0.1541508    ,   0.1648381    ,   0.1761528    
     +,   0.1879246    ,   0.1999725    ,   0.2121252    
     +,   0.2242389    ,   0.2362183    ,   0.2480368    
     +,   0.2597482    ,   0.2714907    ,   0.2834773    
     +,   0.2959735    ,   0.3092637    ,   0.3236103    
     +,   0.3392072    ,   0.3561451    ,   0.3743842    
     +,   0.3937529    ,   0.4139530    ,   0.4345999    
     +,   0.4552625    ,   0.4755061    ,   0.4949352    
     +,   0.5132166    ,   0.5300867    ,   0.5453414    
     +,   0.5588171    ,   0.5703747    ,   0.5798855    
     +,   0.5872297    ,   0.5923082    ,   0.5950582    
     +,   0.5954720    ,   0.5936041    ,   0.5895663    
     +,   0.5835165    ,   0.5756363    ,   0.5661084    
     +,   0.5551003    ,   0.5427569    ,   0.5292008    
     +,   0.5145429    ,   0.4988848    ,   0.4823346    
     +,   0.4650100    ,   0.4470364    ,   0.4285442    
     +,   0.4096624    ,   0.3905158    ,   0.3712150    
     +,   0.3518577    ,   0.3325281    ,   0.3132987    
     +,   0.2942341    ,   0.2753945    ,   0.2568420    
     +,   0.2386419    ,   0.2208626    ,   0.2035767    
     +,   0.1868596    ,   0.1707852    ,   0.1554217    
     +,   0.1408289    ,   0.1270574    ,   0.1141429    
     +,   0.1021076    ,   9.0960965E-02,   8.0699258E-02
     +,   7.1306735E-02,   6.2758192E-02,   5.5020906E-02
     +,   4.8055883E-02,   4.1818917E-02,   3.6262441E-02
     +,   3.1337254E-02,   2.6992969E-02,   2.3178780E-02
     +,   1.9844843E-02,   1.6943127E-02,   1.4427464E-02
     +,   1.2254438E-02,   1.0383838E-02,   8.7786643E-03
     +,   7.4052252E-03,   6.2332051E-03,   5.2356254E-03
     +,   4.3885922E-03,   3.6710158E-03,   3.0644538E-03
     +,   2.5528977E-03,   2.1223768E-03,   1.7608696E-03
     +,   1.4579527E-03,   1.2046992E-03,   9.9341164E-04
     +,   8.1752829E-04,   6.7141990E-04,   5.5031019E-04
     +,   4.5012470E-04,   3.6742428E-04,   2.9929332E-04
     +,   2.4327653E-04,   1.9731527E-04,   1.5967774E-04
     +,   1.2892121E-04,   1.0383790E-04,   8.3426341E-05
     +,   6.6851753E-05,   5.3424574E-05,   4.2572439E-05
     +,   3.3824133E-05,   2.6789994E-05,   2.1150207E-05
     +,   1.6641354E-05,   1.3047977E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_ashz_hatt105_mass = Yx/10.8309394565217
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_ashz_hatt107_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  5.8105937E-03,   6.1386018E-03
     +,   6.4872163E-03,   6.8574562E-03,   7.2503276E-03
     +,   7.6668207E-03,   8.1078857E-03,   8.5744224E-03
     +,   9.0672821E-03,   9.5872534E-03,   1.0135054E-02
     +,   1.0711285E-02,   1.1316468E-02,   1.1951013E-02
     +,   1.2615220E-02,   1.3309236E-02,   1.4033097E-02
     +,   1.4786688E-02,   1.5569740E-02,   1.6381839E-02
     +,   1.7222451E-02,   1.8090852E-02,   1.8986186E-02
     +,   1.9907543E-02,   2.0853754E-02,   2.1823682E-02
     +,   2.2816045E-02,   2.3829509E-02,   2.4862725E-02
     +,   2.5914347E-02,   2.6983041E-02,   2.8067591E-02
     +,   2.9166859E-02,   3.0279877E-02,   3.1405866E-02
     +,   3.2544252E-02,   3.3694763E-02,   3.4857363E-02
     +,   3.6032431E-02,   3.7220515E-02,   3.8422622E-02
     +,   3.9639972E-02,   4.0874250E-02,   4.2127207E-02
     +,   4.3400932E-02,   4.4697717E-02,   4.6019871E-02
     +,   4.7369812E-02,   4.8749875E-02,   5.0162338E-02
     +,   5.1609196E-02,   5.3092215E-02,   5.4612882E-02
     +,   5.6172270E-02,   5.7770863E-02,   5.9408907E-02
     +,   6.1085984E-02,   6.2801175E-02,   6.4553067E-02
     +,   6.6339731E-02,   6.8158686E-02,   7.0006937E-02
     +,   7.1880795E-02,   7.3776342E-02,   7.5688839E-02
     +,   7.7612899E-02,   7.9542778E-02,   8.1471756E-02
     +,   8.3392963E-02,   8.5298546E-02,   8.7180458E-02
     +,   8.9030176E-02,   9.0839237E-02,   9.2599072E-02
     +,   9.4301902E-02,   9.5940866E-02,   9.7510114E-02
     +,   9.9005789E-02,   0.1004264    ,   0.1017728    
     +,   0.1030492    ,   0.1042628    ,   0.1054245    
     +,   0.1065485    ,   0.1076526    ,   0.1087578    
     +,   0.1098876    ,   0.1110685    ,   0.1123283    
     +,   0.1136962    ,   0.1152014    ,   0.1168730    
     +,   0.1187376    ,   0.1208191    ,   0.1231377    
     +,   0.1257068    ,   0.1285334    ,   0.1316153    
     +,   0.1349403    ,   0.1384854    ,   0.1422155    
     +,   0.1460845    ,   0.1500351    ,   0.1540005    
     +,   0.1579078    ,   0.1616801    ,   0.1652410    
     +,   0.1685183    ,   0.1714491    ,   0.1739834    
     +,   0.1760869    ,   0.1777446    ,   0.1789612    
     +,   0.1797601    ,   0.1801838    ,   0.1802879    
     +,   0.1801401    ,   0.1798130    ,   0.1793805    
     +,   0.1789127    ,   0.1784721    ,   0.1781095    
     +,   0.1778630    ,   0.1777562    ,   0.1777985    
     +,   0.1779865    ,   0.1783049    ,   0.1787292    
     +,   0.1792274    ,   0.1797624    ,   0.1802936    
     +,   0.1807781    ,   0.1811729    ,   0.1814357    
     +,   0.1815255    ,   0.1814046    ,   0.1810390    
     +,   0.1803998    ,   0.1794640    ,   0.1782156    
     +,   0.1766460    ,   0.1747546    ,   0.1725484    
     +,   0.1700412    ,   0.1672529    ,   0.1642084    
     +,   0.1609361    ,   0.1574655    ,   0.1538284    
     +,   0.1500545    ,   0.1461732    ,   0.1422124    
     +,   0.1381988    ,   0.1341579    ,   0.1301145    
     +,   0.1260940    ,   0.1221232    ,   0.1182292    
     +,   0.1144413    ,   0.1107911    ,   0.1073107    
     +,   0.1040339    ,   0.1009949    ,   9.8227367E-02
     +,   9.5763855E-02,   9.3635276E-02,   9.1870464E-02
     +,   9.0495393E-02,   8.9533225E-02,   8.9004599E-02
     +,   8.8927269E-02,   8.9316539E-02,   9.0185754E-02
     +,   9.1545291E-02,   9.3403436E-02,   9.5764838E-02
     +,   9.8630704E-02,   0.1019969    ,   0.1058540    
     +,   0.1101865    ,   0.1149728    ,   0.1201865    
     +,   0.1257986    ,   0.1317825    ,   0.1381192    
     +,   0.1448027    ,   0.1518487    ,   0.1593007    
     +,   0.1672346    ,   0.1757577    ,   0.1850058    
     +,   0.1951322    ,   0.2062880    ,   0.2186013    
     +,   0.2321498    ,   0.2469366    ,   0.2628662    
     +,   0.2797356    ,   0.2972399    ,   0.3149897    
     +,   0.3325441    ,   0.3494615    ,   0.3653496    
     +,   0.3799116    ,   0.3929781    ,   0.4045240    
     +,   0.4146569    ,   0.4235793    ,   0.4315468    
     +,   0.4388036    ,   0.4455313    ,   0.4518073    
     +,   0.4575851    ,   0.4626964    ,   0.4668773    
     +,   0.4698165    ,   0.4712036    ,   0.4707836    
     +,   0.4683983    ,   0.4640126    ,   0.4577157    
     +,   0.4497089    ,   0.4402757    ,   0.4297444    
     +,   0.4184502    ,   0.4067016    ,   0.3947605    
     +,   0.3828255    ,   0.3710281    ,   0.3594359    
     +,   0.3480573    ,   0.3368521    ,   0.3257386    
     +,   0.3146082    ,   0.3033375    ,   0.2918009    
     +,   0.2798857    ,   0.2675072    ,   0.2546166    
     +,   0.2412102    ,   0.2273310    ,   0.2130687    
     +,   0.1985510    ,   0.1839343    ,   0.1693901    
     +,   0.1550943    ,   0.1412139    ,   0.1278953    
     +,   0.1152596    ,   0.1033980    ,   9.2369765E-02
     +,   8.2204603E-02,   7.2906598E-02,   6.4458296E-02
     +,   5.6825094E-02,   4.9960960E-02,   4.3813139E-02
     +,   3.8325291E-02,   3.3440214E-02,   2.9102257E-02
     +,   2.5259014E-02,   2.1861713E-02,   1.8865410E-02
     +,   1.6229255E-02,   1.3916468E-02,   1.1893487E-02
     +,   1.0129915E-02,   8.5981982E-03,   7.2731678E-03
     +,   6.1317012E-03,   5.1526143E-03,   4.3165619E-03
     +,   3.6058428E-03,   3.0042825E-03,   2.4972444E-03
     +,   2.0716039E-03,   1.7155814E-03,   1.4187937E-03
     +,   1.1720839E-03,   9.6751406E-04,   7.9820625E-04
     +,   6.5829779E-04,   5.4279092E-04,   4.4748952E-04
     +,   3.6886794E-04,   3.0400223E-04,   2.5046436E-04
     +,   2.0625292E-04,   1.6972661E-04,   1.3953366E-04
     +,   1.1457023E-04,   9.3927905E-05,   7.6864031E-05
     +,   6.2765692E-05,   5.1129591E-05,   4.1538220E-05
     +,   3.3646716E-05,   2.7167349E-05,   2.1861124E-05
     +,   1.7527746E-05,   1.4000284E-05
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_ashz_hatt107_mass = Yx/9.2492176
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_ashz_hatt110_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  9.2481887E-03,   9.7364588E-03
     +,   1.0244918E-02,   1.0773977E-02,   1.1323998E-02
     +,   1.1895267E-02,   1.2488018E-02,   1.3102389E-02
     +,   1.3738419E-02,   1.4396064E-02,   1.5075147E-02
     +,   1.5775366E-02,   1.6496288E-02,   1.7237345E-02
     +,   1.7997812E-02,   1.8776810E-02,   1.9573318E-02
     +,   2.0386148E-02,   2.1213995E-02,   2.2055393E-02
     +,   2.2908742E-02,   2.3772333E-02,   2.4644356E-02
     +,   2.5522979E-02,   2.6406195E-02,   2.7292125E-02
     +,   2.8178776E-02,   2.9064264E-02,   2.9946728E-02
     +,   3.0824462E-02,   3.1695839E-02,   3.2559443E-02
     +,   3.3414077E-02,   3.4258727E-02,   3.5092700E-02
     +,   3.5915550E-02,   3.6727175E-02,   3.7527774E-02
     +,   3.8317908E-02,   3.9098497E-02,   3.9870787E-02
     +,   4.0636454E-02,   4.1397396E-02,   4.2156015E-02
     +,   4.2914893E-02,   4.3677069E-02,   4.4445697E-02
     +,   4.5224279E-02,   4.6016525E-02,   4.6826322E-02
     +,   4.7657643E-02,   4.8514556E-02,   4.9401186E-02
     +,   5.0321605E-02,   5.1279847E-02,   5.2279633E-02
     +,   5.3324863E-02,   5.4418866E-02,   5.5564806E-02
     +,   5.6765597E-02,   5.8023777E-02,   5.9341513E-02
     +,   6.0720544E-02,   6.2162258E-02,   6.3667715E-02
     +,   6.5237284E-02,   6.6871136E-02,   6.8568662E-02
     +,   7.0328832E-02,   7.2149724E-02,   7.4028812E-02
     +,   7.5962313E-02,   7.7945799E-02,   7.9973236E-02
     +,   8.2037479E-02,   8.4129967E-02,   8.6240731E-02
     +,   8.8358186E-02,   9.0470046E-02,   9.2562824E-02
     +,   9.4622493E-02,   9.6635111E-02,   9.8587036E-02
     +,   0.1004659    ,   0.1022610    ,   0.1039640    
     +,   0.1055695    ,   0.1070751    ,   0.1084818    
     +,   0.1097943    ,   0.1110199    ,   0.1121688    
     +,   0.1132531    ,   0.1142855    ,   0.1152791    
     +,   0.1162454    ,   0.1171940    ,   0.1181319    
     +,   0.1190617    ,   0.1199831    ,   0.1208910    
     +,   0.1217776    ,   0.1226320    ,   0.1234426    
     +,   0.1241971    ,   0.1248855    ,   0.1255008    
     +,   0.1260410    ,   0.1265105    ,   0.1269210    
     +,   0.1272916    ,   0.1276494    ,   0.1280276    
     +,   0.1284651    ,   0.1290034    ,   0.1296850    
     +,   0.1305500    ,   0.1316329    ,   0.1329604    
     +,   0.1345484    ,   0.1364003    ,   0.1385059    
     +,   0.1408408    ,   0.1433675    ,   0.1460366    
     +,   0.1487893    ,   0.1515598    ,   0.1542789    
     +,   0.1568775    ,   0.1592889    ,   0.1614527    
     +,   0.1633157    ,   0.1648349    ,   0.1659768    
     +,   0.1667187    ,   0.1670475    ,   0.1669592    
     +,   0.1664576    ,   0.1655528    ,   0.1642599    
     +,   0.1625980    ,   0.1605890    ,   0.1582571    
     +,   0.1556270    ,   0.1527259    ,   0.1495807    
     +,   0.1462194    ,   0.1426699    ,   0.1389610    
     +,   0.1351206    ,   0.1311761    ,   0.1271543    
     +,   0.1230809    ,   0.1189795    ,   0.1148721    
     +,   0.1107792    ,   0.1067191    ,   0.1027083    
     +,   9.8761871E-02,   9.4893709E-02,   9.1116570E-02
     +,   8.7442853E-02,   8.3884947E-02,   8.0455258E-02
     +,   7.7166259E-02,   7.4031271E-02,   7.1064495E-02
     +,   6.8281077E-02,   6.5696694E-02,   6.3328370E-02
     +,   6.1194465E-02,   5.9314575E-02,   5.7709686E-02
     +,   5.6402460E-02,   5.5417549E-02,   5.4781456E-02
     +,   5.4522894E-02,   5.4672714E-02,   5.5263717E-02
     +,   5.6330390E-02,   5.7908341E-02,   6.0033012E-02
     +,   6.2738769E-02,   6.6056840E-02,   7.0013709E-02
     +,   7.4628025E-02,   7.9908565E-02,   8.5852042E-02
     +,   9.2440821E-02,   9.9640951E-02,   0.1074028    
     +,   0.1156616    ,   0.1243397    ,   0.1333507    
     +,   0.1426069    ,   0.1520248    ,   0.1615329    
     +,   0.1710790    ,   0.1806367    ,   0.1902079    
     +,   0.1998215    ,   0.2095297    ,   0.2194001    
     +,   0.2295020    ,   0.2398914    ,   0.2505971    
     +,   0.2616051    ,   0.2728486    ,   0.2842011    
     +,   0.2954808    ,   0.3064567    ,   0.3168651    
     +,   0.3264336    ,   0.3349046    ,   0.3420644    
     +,   0.3477635    ,   0.3519356    ,   0.3546012    
     +,   0.3558652    ,   0.3558998    ,   0.3549191    
     +,   0.3531483    ,   0.3507934    ,   0.3480147    
     +,   0.3449056    ,   0.3414870    ,   0.3377097    
     +,   0.3334671    ,   0.3286156    ,   0.3229983    
     +,   0.3164683    ,   0.3089091    ,   0.3002489    
     +,   0.2904696    ,   0.2796088    ,   0.2677572    
     +,   0.2550491    ,   0.2416549    ,   0.2277669    
     +,   0.2135872    ,   0.1993159    ,   0.1851434    
     +,   0.1712405    ,   0.1577531    ,   0.1447992    
     +,   0.1324695    ,   0.1208270    ,   0.1099093    
     +,   9.9732444E-02,   9.0295754E-02,   8.1583768E-02
     +,   7.3571227E-02,   6.6226453E-02,   5.9513528E-02
     +,   5.3394049E-02,   4.7828984E-02,   4.2780224E-02
     +,   3.8210478E-02,   3.4083664E-02,   3.0365255E-02
     +,   2.7022578E-02,   2.4024475E-02,   2.1341126E-02
     +,   1.8944258E-02,   1.6807385E-02,   1.4905296E-02
     +,   1.3214427E-02,   1.1712953E-02,   1.0380668E-02
     +,   9.1989608E-03,   8.1508989E-03,   7.2212676E-03
     +,   6.3964082E-03,   5.6640953E-03,   5.0135208E-03
     +,   4.4352221E-03,   3.9208154E-03,   3.4630287E-03
     +,   3.0554475E-03,   2.6925183E-03,   2.3693319E-03
     +,   2.0816335E-03,   1.8256420E-03,   1.5980551E-03
     +,   1.3959187E-03,   1.2166318E-03,   1.0578526E-03
     +,   9.1748359E-04,   7.9364848E-04,   6.8463705E-04
     +,   5.8891560E-04,   5.0507899E-04,   4.3186208E-04
     +,   3.6810478E-04,   3.1276085E-04,   2.6487216E-04
     +,   2.2357573E-04,   1.8808444E-04,   1.5769187E-04
     +,   1.3175751E-04,   1.0970987E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_ashz_hatt110_mass = Yx/7.39518770454545
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_ashz_hatt115_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  6.3564782E-03,   6.7225867E-03
     +,   7.1114227E-03,   7.5248317E-03,   7.9648197E-03
     +,   8.4334975E-03,   8.9331046E-03,   9.4659599E-03
     +,   1.0034442E-02,   1.0641000E-02,   1.1288047E-02
     +,   1.1977958E-02,   1.2713019E-02,   1.3495364E-02
     +,   1.4326911E-02,   1.5209324E-02,   1.6143935E-02
     +,   1.7131671E-02,   1.8173015E-02,   1.9267919E-02
     +,   2.0415789E-02,   2.1615399E-02,   2.2864848E-02
     +,   2.4161693E-02,   2.5502594E-02,   2.6883746E-02
     +,   2.8300546E-02,   2.9747818E-02,   3.1219793E-02
     +,   3.2710236E-02,   3.4212448E-02,   3.5719424E-02
     +,   3.7223976E-02,   3.8718779E-02,   4.0196557E-02
     +,   4.1650213E-02,   4.3072917E-02,   4.4458255E-02
     +,   4.5800388E-02,   4.7094006E-02,   4.8334617E-02
     +,   4.9518488E-02,   5.0642751E-02,   5.1705401E-02
     +,   5.2705321E-02,   5.3642225E-02,   5.4516710E-02
     +,   5.5330127E-02,   5.6084502E-02,   5.6782477E-02
     +,   5.7427190E-02,   5.8022123E-02,   5.8571044E-02
     +,   5.9077989E-02,   5.9546821E-02,   5.9981577E-02
     +,   6.0386132E-02,   6.0764238E-02,   6.1119366E-02
     +,   6.1454974E-02,   6.1774261E-02,   6.2080353E-02
     +,   6.2376235E-02,   6.2665060E-02,   6.2949955E-02
     +,   6.3234180E-02,   6.3521415E-02,   6.3815266E-02
     +,   6.4119935E-02,   6.4439751E-02,   6.4779378E-02
     +,   6.5143526E-02,   6.5537199E-02,   6.5965213E-02
     +,   6.6432238E-02,   6.6942587E-02,   6.7500003E-02
     +,   6.8107665E-02,   6.8767808E-02,   6.9481738E-02
     +,   7.0249774E-02,   7.1071073E-02,   7.1943924E-02
     +,   7.2865397E-02,   7.3831923E-02,   7.4839063E-02
     +,   7.5882077E-02,   7.6955877E-02,   7.8055277E-02
     +,   7.9175614E-02,   8.0312639E-02,   8.1462502E-02
     +,   8.2622409E-02,   8.3790429E-02,   8.4965229E-02
     +,   8.6146399E-02,   8.7334059E-02,   8.8528380E-02
     +,   8.9729793E-02,   9.0938151E-02,   9.2152633E-02
     +,   9.3371190E-02,   9.4590589E-02,   9.5805921E-02
     +,   9.7010240E-02,   9.8195188E-02,   9.9350594E-02
     +,   0.1004646    ,   0.1015245    ,   0.1025170    
     +,   0.1034284    ,   0.1042458    ,   0.1049570    
     +,   0.1055517    ,   0.1060217    ,   0.1063616    
     +,   0.1065687    ,   0.1066437    ,   0.1065902    
     +,   0.1064152    ,   0.1061285    ,   0.1057420    
     +,   0.1052702    ,   0.1047282    ,   0.1041325    
     +,   0.1034994    ,   0.1028446    ,   0.1021827    
     +,   0.1015266    ,   0.1008867    ,   0.1002711    
     +,   9.9685073E-02,   9.9130586E-02,   9.8606527E-02
     +,   9.8109066E-02,   9.7631246E-02,   9.7163521E-02
     +,   9.6694186E-02,   9.6209608E-02,   9.5694944E-02
     +,   9.5134646E-02,   9.4512910E-02,   9.3814313E-02
     +,   9.3024805E-02,   9.2131786E-02,   9.1125026E-02
     +,   8.9996763E-02,   8.8742577E-02,   8.7361358E-02
     +,   8.5855305E-02,   8.4230214E-02,   8.2495458E-02
     +,   8.0663353E-02,   7.8748845E-02,   7.6769233E-02
     +,   7.4743599E-02,   7.2692119E-02,   7.0635349E-02
     +,   6.8593830E-02,   6.6587575E-02,   6.4635403E-02
     +,   6.2754653E-02,   6.0960997E-02,   5.9268430E-02
     +,   5.7688877E-02,   5.6232475E-02,   5.4908060E-02
     +,   5.3723004E-02,   5.2683666E-02,   5.1795803E-02
     +,   5.1064875E-02,   5.0496340E-02,   5.0095644E-02
     +,   4.9868666E-02,   4.9821470E-02,   4.9960293E-02
     +,   5.0291229E-02,   5.0819822E-02,   5.1550865E-02
     +,   5.2487511E-02,   5.3631201E-02,   5.4980885E-02
     +,   5.6532547E-02,   5.8279656E-02,   6.0212422E-02
     +,   6.2318496E-02,   6.4583234E-02,   6.6990681E-02
     +,   6.9524497E-02,   7.2168872E-02,   7.4910164E-02
     +,   7.7738121E-02,   8.0646746E-02,   8.3635554E-02
     +,   8.6710103E-02,   8.9882739E-02,   9.3171529E-02
     +,   9.6600413E-02,   0.1001984    ,   0.1039977    
     +,   0.1080322    ,   0.1123364    ,   0.1169429    
     +,   0.1218805    ,   0.1271724    ,   0.1328346    
     +,   0.1388737    ,   0.1452847    ,   0.1520498    
     +,   0.1591374    ,   0.1665005    ,   0.1740761    
     +,   0.1817863    ,   0.1895400    ,   0.1972351    
     +,   0.2047624    ,   0.2120101    ,   0.2188706    
     +,   0.2252439    ,   0.2310447    ,   0.2362054    
     +,   0.2406802    ,   0.2444446    ,   0.2474948    
     +,   0.2498449    ,   0.2515220    ,   0.2525585    
     +,   0.2529867    ,   0.2528331    ,   0.2521112    
     +,   0.2508193    ,   0.2489392    ,   0.2464371    
     +,   0.2432674    ,   0.2393797    ,   0.2347233    
     +,   0.2292573    ,   0.2229575    ,   0.2158218    
     +,   0.2078749    ,   0.1991694    ,   0.1897866    
     +,   0.1798331    ,   0.1694342    ,   0.1587294    
     +,   0.1478653    ,   0.1369878    ,   0.1262351    
     +,   0.1157330    ,   0.1055914    ,   9.5900327E-02
     +,   8.6729109E-02,   7.8127801E-02,   7.0127144E-02
     +,   6.2740542E-02,   5.5966679E-02,   4.9792904E-02
     +,   4.4197161E-02,   3.9150208E-02,   3.4618281E-02
     +,   3.0565070E-02,   2.6952954E-02,   2.3744000E-02
     +,   2.0901142E-02,   1.8388970E-02,   1.6173709E-02
     +,   1.4223810E-02,   1.2510146E-02,   1.1005952E-02
     +,   9.6867187E-03,   8.5302945E-03,   7.5168246E-03
     +,   6.6285413E-03,   5.8496012E-03,   5.1659979E-03
     +,   4.5654732E-03,   4.0372247E-03,   3.5718980E-03
     +,   3.1613230E-03,   2.7984825E-03,   2.4772801E-03
     +,   2.1925152E-03,   1.9396823E-03,   1.7149483E-03
     +,   1.5149891E-03,   1.3369716E-03,   1.1784317E-03
     +,   1.0372361E-03,   9.1153861E-04,   7.9970621E-04
     +,   7.0031232E-04,   6.1207905E-04,   5.3387554E-04
     +,   4.6467746E-04,   4.0356864E-04,   3.4971198E-04
     +,   3.0235425E-04,   2.6080463E-04,   2.2443976E-04
     +,   1.9268841E-04,   1.6503583E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_ashz_hatt115_mass = Yx/5.5778045
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_ashz_hatt120_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.3691224E-03,   4.5802346E-03
     +,   4.7988244E-03,   5.0250278E-03,   5.2589867E-03
     +,   5.5008428E-03,   5.7507413E-03,   6.0088350E-03
     +,   6.2752729E-03,   6.5502310E-03,   6.8338718E-03
     +,   7.1263756E-03,   7.4279336E-03,   7.7387458E-03
     +,   8.0590220E-03,   8.3889868E-03,   8.7288842E-03
     +,   9.0789581E-03,   9.4394805E-03,   9.8107215E-03
     +,   1.0192979E-02,   1.0586556E-02,   1.0991762E-02
     +,   1.1408941E-02,   1.1838389E-02,   1.2280471E-02
     +,   1.2735523E-02,   1.3203888E-02,   1.3685905E-02
     +,   1.4181929E-02,   1.4692282E-02,   1.5217323E-02
     +,   1.5757378E-02,   1.6312791E-02,   1.6883904E-02
     +,   1.7471066E-02,   1.8074639E-02,   1.8695002E-02
     +,   1.9332603E-02,   1.9987836E-02,   2.0661246E-02
     +,   2.1353344E-02,   2.2064779E-02,   2.2796214E-02
     +,   2.3548409E-02,   2.4322202E-02,   2.5118485E-02
     +,   2.5938233E-02,   2.6782455E-02,   2.7652217E-02
     +,   2.8548533E-02,   2.9472457E-02,   3.0424921E-02
     +,   3.1406838E-02,   3.2418858E-02,   3.3461548E-02
     +,   3.4535170E-02,   3.5639782E-02,   3.6775101E-02
     +,   3.7940539E-02,   3.9135180E-02,   4.0357806E-02
     +,   4.1606877E-02,   4.2880602E-02,   4.4177052E-02
     +,   4.5494039E-02,   4.6829425E-02,   4.8180997E-02
     +,   4.9546707E-02,   5.0924629E-02,   5.2313074E-02
     +,   5.3710625E-02,   5.5116169E-02,   5.6528673E-02
     +,   5.7947513E-02,   5.9371956E-02,   6.0801256E-02
     +,   6.2234379E-02,   6.3669808E-02,   6.5105423E-02
     +,   6.6538051E-02,   6.7963466E-02,   6.9376081E-02
     +,   7.0769019E-02,   7.2133690E-02,   7.3460355E-02
     +,   7.4737757E-02,   7.5953700E-02,   7.7095367E-02
     +,   7.8149512E-02,   7.9103336E-02,   7.9944789E-02
     +,   8.0663420E-02,   8.1250526E-02,   8.1700414E-02
     +,   8.2010046E-02,   8.2180001E-02,   8.2214430E-02
     +,   8.2120851E-02,   8.1910558E-02,   8.1597641E-02
     +,   8.1198879E-02,   8.0732860E-02,   8.0219291E-02
     +,   7.9678290E-02,   7.9128884E-02,   7.8588955E-02
     +,   7.8073896E-02,   7.7596158E-02,   7.7164426E-02
     +,   7.6783709E-02,   7.6455139E-02,   7.6175898E-02
     +,   7.5939581E-02,   7.5737141E-02,   7.5557038E-02
     +,   7.5386532E-02,   7.5212471E-02,   7.5022072E-02
     +,   7.4804105E-02,   7.4549392E-02,   7.4251838E-02
     +,   7.3908463E-02,   7.3520035E-02,   7.3090792E-02
     +,   7.2628416E-02,   7.2143368E-02,   7.1648598E-02
     +,   7.1158260E-02,   7.0687242E-02,   7.0250019E-02
     +,   6.9859855E-02,   6.9527566E-02,   6.9261461E-02
     +,   6.9066092E-02,   6.8942279E-02,   6.8886757E-02
     +,   6.8892375E-02,   6.8948150E-02,   6.9039956E-02
     +,   6.9151007E-02,   6.9262631E-02,   6.9355026E-02
     +,   6.9408201E-02,   6.9402874E-02,   6.9321103E-02
     +,   6.9147117E-02,   6.8867914E-02,   6.8473667E-02
     +,   6.7958027E-02,   6.7318186E-02,   6.6555150E-02
     +,   6.5673180E-02,   6.4679727E-02,   6.3585021E-02
     +,   6.2401582E-02,   6.1143722E-02,   5.9826922E-02
     +,   5.8467250E-02,   5.7081115E-02,   5.5684529E-02
     +,   5.4292768E-02,   5.2920207E-02,   5.1580038E-02
     +,   5.0283909E-02,   4.9042128E-02,   4.7863595E-02
     +,   4.6755895E-02,   4.5725185E-02,   4.4776611E-02
     +,   4.3914348E-02,   4.3141723E-02,   4.2461429E-02
     +,   4.1875590E-02,   4.1385915E-02,   4.0993799E-02
     +,   4.0700480E-02,   4.0507015E-02,   4.0414464E-02
     +,   4.0423881E-02,   4.0536504E-02,   4.0753879E-02
     +,   4.1077867E-02,   4.1510906E-02,   4.2056061E-02
     +,   4.2717159E-02,   4.3498825E-02,   4.4406582E-02
     +,   4.5446891E-02,   4.6626847E-02,   4.7954161E-02
     +,   4.9436949E-02,   5.1083166E-02,   5.2900262E-02
     +,   5.4894842E-02,   5.7071920E-02,   5.9434321E-02
     +,   6.1982159E-02,   6.4712517E-02,   6.7618944E-02
     +,   7.0691168E-02,   7.3914945E-02,   7.7272840E-02
     +,   8.0744125E-02,   8.4305532E-02,   8.7932348E-02
     +,   9.1600060E-02,   9.5284522E-02,   9.8964386E-02
     +,   0.1026222    ,   0.1062455    ,   0.1098276    
     +,   0.1133686    ,   0.1168753    ,   0.1203608    
     +,   0.1238431    ,   0.1273438    ,   0.1308858    
     +,   0.1344900    ,   0.1381729    ,   0.1419425    
     +,   0.1457960    ,   0.1497165    ,   0.1536711    
     +,   0.1576105    ,   0.1614691    ,   0.1651665    
     +,   0.1686103    ,   0.1717015    ,   0.1743388    
     +,   0.1764248    ,   0.1778714    ,   0.1786062    
     +,   0.1785762    ,   0.1777512    ,   0.1761253    
     +,   0.1737167    ,   0.1705660    ,   0.1667328    
     +,   0.1622913    ,   0.1573251    ,   0.1519231    
     +,   0.1461745    ,   0.1401636    ,   0.1339686    
     +,   0.1276589    ,   0.1212947    ,   0.1149262    
     +,   0.1085948    ,   0.1023354    ,   9.6176326E-02
     +,   9.0141170E-02,   8.4251113E-02,   7.8524783E-02
     +,   7.2978996E-02,   6.7629203E-02,   6.2489938E-02
     +,   5.7574037E-02,   5.2892387E-02,   4.8453752E-02
     +,   4.4264846E-02,   4.0329698E-02,   3.6649499E-02
     +,   3.3222873E-02,   3.0046280E-02,   2.7113633E-02
     +,   2.4416953E-02,   2.1946836E-02,   1.9692581E-02
     +,   1.7642412E-02,   1.5783932E-02,   1.4104557E-02
     +,   1.2591556E-02,   1.1232204E-02,   1.0014060E-02
     +,   8.9251865E-03,   7.9540154E-03,   7.0896717E-03
     +,   6.3217925E-03,   5.6407871E-03,   5.0376477E-03
     +,   4.5041386E-03,   4.0326165E-03,   3.6161707E-03
     +,   3.2484636E-03,   2.9238181E-03,   2.6370953E-03
     +,   2.3836938E-03,   2.1595412E-03,   1.9609886E-03
     +,   1.7848390E-03,   1.6282522E-03,   1.4887567E-03
     +,   1.3641717E-03,   1.2526112E-03,   1.1524203E-03
     +,   1.0621753E-03,   9.8063191E-04,   9.0672536E-04
     +,   8.3952578E-04,   7.7824108E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_ashz_hatt120_mass = Yx/4.137163275
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_ashz_hatt60_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  9.2423946E-02,   0.1060128    
     +,   0.1205199    ,   0.1358050    ,   0.1517021    
     +,   0.1680382    ,   0.1846620    ,   0.2014813    
     +,   0.2185029    ,   0.2358694    ,   0.2538711    
     +,   0.2729292    ,   0.2935287    ,   0.3161029    
     +,   0.3408826    ,   0.3677482    ,   0.3961437    
     +,   0.4251231    ,   0.4535721    ,   0.4805918    
     +,   0.5059509    ,   0.5304126    ,   0.5557394    
     +,   0.5842637    ,   0.6180828    ,   0.6581760    
     +,   0.7038273    ,   0.7526568    ,   0.8012781    
     +,   0.8462968    ,   0.8851960    ,   0.9167768    
     +,   0.9410777    ,   0.9589702    ,   0.9716705    
     +,   0.9803297    ,   0.9857560    ,   0.9881961    
     +,   0.9872423    ,   0.9818980    ,   0.9708356    
     +,   0.9528153    ,   0.9271339    ,   0.8939592    
     +,   0.8544129    ,   0.8103290    ,   0.7637966    
     +,   0.7166377    ,   0.6700649    ,   0.6246547    
     +,   0.5806057    ,   0.5381020    ,   0.4975679    
     +,   0.4596798    ,   0.4251833    ,   0.3946230    
     +,   0.3681647    ,   0.3455646    ,   0.3262911    
     +,   0.3097059    ,   0.2952320    ,   0.2824414    
     +,   0.2710649    ,   0.2609410    ,   0.2519466    
     +,   0.2439427    ,   0.2367427    ,   0.2301207    
     +,   0.2238324    ,   0.2176490    ,   0.2113857    
     +,   0.2049198    ,   0.1981918    ,   0.1912001    
     +,   0.1839828    ,   0.1766014    ,   0.1691261    
     +,   0.1616249    ,   0.1541569    ,   0.1467731    
     +,   0.1395185    ,   0.1324343    ,   0.1255631    
     +,   0.1189481    ,   0.1126359    ,   0.1066724    
     +,   0.1011019    ,   9.5962346E-02,   9.1283590E-02
     +,   8.7083459E-02,   8.3367102E-02,   8.0126666E-02
     +,   7.7341855E-02,   7.4981272E-02,   7.3005006E-02
     +,   7.1367428E-02,   7.0019200E-02,   6.8910226E-02
     +,   6.7991644E-02,   6.7217276E-02,   6.6545106E-02
     +,   6.5937944E-02,   6.5363795E-02,   6.4795889E-02
     +,   6.4212672E-02,   6.3597247E-02,   6.2937230E-02
     +,   6.2223982E-02,   6.1452422E-02,   6.0620204E-02
     +,   5.9727583E-02,   5.8776766E-02,   5.7771880E-02
     +,   5.6718107E-02,   5.5621848E-02,   5.4490019E-02
     +,   5.3330269E-02,   5.2150283E-02,   5.0957806E-02
     +,   4.9760357E-02,   4.8565123E-02,   4.7378775E-02
     +,   4.6207462E-02,   4.5056518E-02,   4.3930475E-02
     +,   4.2833257E-02,   4.1767772E-02,   4.0736306E-02
     +,   3.9740242E-02,   3.8780328E-02,   3.7856583E-02
     +,   3.6968566E-02,   3.6115151E-02,   3.5294943E-02
     +,   3.4506083E-02,   3.3746477E-02,   3.3013817E-02
     +,   3.2305807E-02,   3.1619858E-02,   3.0953581E-02
     +,   3.0304560E-02,   2.9670563E-02,   2.9049419E-02
     +,   2.8439183E-02,   2.7838165E-02,   2.7244819E-02
     +,   2.6657958E-02,   2.6076561E-02,   2.5499985E-02
     +,   2.4927748E-02,   2.4359647E-02,   2.3795791E-02
     +,   2.3236506E-02,   2.2682285E-02,   2.2133833E-02
     +,   2.1592055E-02,   2.1058012E-02,   2.0532846E-02
     +,   2.0017782E-02,   1.9514170E-02,   1.9023351E-02
     +,   1.8546661E-02,   1.8085487E-02,   1.7641136E-02
     +,   1.7214896E-02,   1.6807921E-02,   1.6421346E-02
     +,   1.6056208E-02,   1.5713412E-02,   1.5393754E-02
     +,   1.5097916E-02,   1.4826512E-02,   1.4579970E-02
     +,   1.4358650E-02,   1.4162795E-02,   1.3992539E-02
     +,   1.3847897E-02,   1.3728835E-02,   1.3635204E-02
     +,   1.3566771E-02,   1.3523228E-02,   1.3504206E-02
     +,   1.3509268E-02,   1.3537908E-02,   1.3589573E-02
     +,   1.3663640E-02,   1.3759451E-02,   1.3876289E-02
     +,   1.4013384E-02,   1.4169906E-02,   1.4345000E-02
     +,   1.4537746E-02,   1.4747169E-02,   1.4972239E-02
     +,   1.5211871E-02,   1.5464957E-02,   1.5730280E-02
     +,   1.6006596E-02,   1.6292604E-02,   1.6586959E-02
     +,   1.6888238E-02,   1.7194966E-02,   1.7505646E-02
     +,   1.7818717E-02,   1.8132567E-02,   1.8445576E-02
     +,   1.8756097E-02,   1.9062426E-02,   1.9362865E-02
     +,   1.9655732E-02,   1.9939337E-02,   2.0212008E-02
     +,   2.0472089E-02,   2.0717990E-02,   2.0948151E-02
     +,   2.1161087E-02,   2.1355366E-02,   2.1529673E-02
     +,   2.1682777E-02,   2.1813534E-02,   2.1920949E-02
     +,   2.2004114E-02,   2.2062290E-02,   2.2094855E-02
     +,   2.2101346E-02,   2.2081414E-02,   2.2034911E-02
     +,   2.1961797E-02,   2.1862203E-02,   2.1736395E-02
     +,   2.1584811E-02,   2.1407986E-02,   2.1206627E-02
     +,   2.0981541E-02,   2.0733671E-02,   2.0464059E-02
     +,   2.0173823E-02,   1.9864209E-02,   1.9536505E-02
     +,   1.9192070E-02,   1.8832289E-02,   1.8458616E-02
     +,   1.8072532E-02,   1.7675497E-02,   1.7268965E-02
     +,   1.6854411E-02,   1.6433293E-02,   1.6006997E-02
     +,   1.5576879E-02,   1.5144276E-02,   1.4710438E-02
     +,   1.4276546E-02,   1.3843739E-02,   1.3413098E-02
     +,   1.2985581E-02,   1.2562090E-02,   1.2143473E-02
     +,   1.1730489E-02,   1.1323804E-02,   1.0924013E-02
     +,   1.0531652E-02,   1.0147197E-02,   9.7710267E-03
     +,   9.4034551E-03,   9.0447785E-03,   8.6951945E-03
     +,   8.3548492E-03,   8.0238692E-03,   7.7023334E-03
     +,   7.3902551E-03,   7.0876265E-03,   6.7944131E-03
     +,   6.5105557E-03,   6.2359590E-03,   5.9704971E-03
     +,   5.7140617E-03,   5.4664877E-03,   5.2276319E-03
     +,   4.9973102E-03,   4.7753607E-03,   4.5615826E-03
     +,   4.3558003E-03,   4.1578067E-03,   3.9674174E-03
     +,   3.7844228E-03,   3.6086354E-03,   3.4398490E-03
     +,   3.2778617E-03,   3.1224845E-03,   2.9735127E-03
     +,   2.8307606E-03,   2.6940282E-03,   2.5631315E-03
     +,   2.4378763E-03,   2.3180835E-03,   2.2035649E-03
     +,   2.0941468E-03,   1.9896447E-03,   1.8898932E-03
     +,   1.7947133E-03,   1.7039442E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_ashz_hatt60_mass = Yx/10.466713173913
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_ashz_hatt65_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.6873035E-02,   4.1657951E-02
     +,   4.6802320E-02,   5.2290834E-02,   5.8102254E-02
     +,   6.4209864E-02,   7.0582971E-02,   7.7188574E-02
     +,   8.3994053E-02,   9.0970851E-02,   9.8098196E-02
     +,   0.1053681    ,   0.1127905    ,   0.1203974    
     +,   0.1282477    ,   0.1364273    ,   0.1450504    
     +,   0.1542545    ,   0.1641958    ,   0.1750413    
     +,   0.1869617    ,   0.2001225    ,   0.2146756    
     +,   0.2307501    ,   0.2484348    ,   0.2677637    
     +,   0.2886902    ,   0.3110650    ,   0.3346200    
     +,   0.3589631    ,   0.3836156    ,   0.4081010    
     +,   0.4321083    ,   0.4557194    ,   0.4796262    
     +,   0.5052067    ,   0.5343234    ,   0.5687674    
     +,   0.6095030    ,   0.6560271    ,   0.7063086    
     +,   0.7574869    ,   0.8071668    ,   0.8545715    
     +,   0.9007963    ,   0.9477630    ,   0.9964165    
     +,    1.045372    ,    1.091237    ,    1.130643    
     +,    1.162554    ,    1.188849    ,    1.212458    
     +,    1.234424    ,    1.252389    ,    1.261876    
     +,    1.259184    ,    1.243572    ,    1.217162    
     +,    1.183064    ,    1.143423    ,    1.098696    
     +,    1.048311    ,   0.9918765    ,   0.9301054    
     +,   0.8650612    ,   0.7997505    ,   0.7373762    
     +,   0.6805351    ,   0.6307248    ,   0.5882394    
     +,   0.5524897    ,   0.5224621    ,   0.4970997    
     +,   0.4754470    ,   0.4566241    ,   0.4397297    
     +,   0.4238185    ,   0.4079792    ,   0.3914782    
     +,   0.3738937    ,   0.3551671    ,   0.3355681    
     +,   0.3155781    ,   0.2957508    ,   0.2765864    
     +,   0.2584589    ,   0.2415863    ,   0.2260524    
     +,   0.2118420    ,   0.1988852    ,   0.1870928    
     +,   0.1763750    ,   0.1666505    ,   0.1578471    
     +,   0.1498981    ,   0.1427350    ,   0.1362872    
     +,   0.1304785    ,   0.1252295    ,   0.1204604    
     +,   0.1160938    ,   0.1120576    ,   0.1082889    
     +,   0.1047340    ,   0.1013504    ,   9.8106079E-02
     +,   9.4979189E-02,   9.1956086E-02,   8.9030184E-02
     +,   8.6200692E-02,   8.3469994E-02,   8.0842987E-02
     +,   7.8325108E-02,   7.5921409E-02,   7.3635601E-02
     +,   7.1469389E-02,   6.9421999E-02,   6.7490444E-02
     +,   6.5669186E-02,   6.3950688E-02,   6.2325910E-02
     +,   6.0784664E-02,   5.9316002E-02,   5.7908945E-02
     +,   5.6552760E-02,   5.5237241E-02,   5.3953238E-02
     +,   5.2692462E-02,   5.1448002E-02,   5.0213985E-02
     +,   4.8985891E-02,   4.7760289E-02,   4.6534900E-02
     +,   4.5308493E-02,   4.4080686E-02,   4.2851932E-02
     +,   4.1623466E-02,   4.0397026E-02,   3.9174806E-02
     +,   3.7959393E-02,   3.6753755E-02,   3.5560858E-02
     +,   3.4383807E-02,   3.3225704E-02,   3.2089595E-02
     +,   3.0978354E-02,   2.9894682E-02,   2.8841130E-02
     +,   2.7819952E-02,   2.6833143E-02,   2.5882483E-02
     +,   2.4969576E-02,   2.4095682E-02,   2.3261929E-02
     +,   2.2469254E-02,   2.1718452E-02,   2.1010144E-02
     +,   2.0344827E-02,   1.9722993E-02,   1.9144963E-02
     +,   1.8611036E-02,   1.8121490E-02,   1.7676566E-02
     +,   1.7276421E-02,   1.6921228E-02,   1.6611109E-02
     +,   1.6346194E-02,   1.6126493E-02,   1.5952030E-02
     +,   1.5822731E-02,   1.5738463E-02,   1.5698992E-02
     +,   1.5703971E-02,   1.5752940E-02,   1.5845312E-02
     +,   1.5980313E-02,   1.6157039E-02,   1.6374344E-02
     +,   1.6630933E-02,   1.6925266E-02,   1.7255599E-02
     +,   1.7619906E-02,   1.8015992E-02,   1.8441381E-02
     +,   1.8893337E-02,   1.9368915E-02,   1.9864921E-02
     +,   2.0377988E-02,   2.0904472E-02,   2.1440603E-02
     +,   2.1982467E-02,   2.2525972E-02,   2.3066955E-02
     +,   2.3601199E-02,   2.4124505E-02,   2.4632635E-02
     +,   2.5121426E-02,   2.5586862E-02,   2.6025070E-02
     +,   2.6432350E-02,   2.6805246E-02,   2.7140601E-02
     +,   2.7435558E-02,   2.7687596E-02,   2.7894586E-02
     +,   2.8054787E-02,   2.8166851E-02,   2.8229890E-02
     +,   2.8243415E-02,   2.8207371E-02,   2.8122110E-02
     +,   2.7988423E-02,   2.7807441E-02,   2.7580686E-02
     +,   2.7309997E-02,   2.6997525E-02,   2.6645694E-02
     +,   2.6257090E-02,   2.5834581E-02,   2.5381098E-02
     +,   2.4899703E-02,   2.4393538E-02,   2.3865759E-02
     +,   2.3319500E-02,   2.2757832E-02,   2.2183796E-02
     +,   2.1600327E-02,   2.1010173E-02,   2.0415958E-02
     +,   1.9820163E-02,   1.9225115E-02,   1.8632878E-02
     +,   1.8045349E-02,   1.7464278E-02,   1.6891180E-02
     +,   1.6327349E-02,   1.5773967E-02,   1.5232019E-02
     +,   1.4702285E-02,   1.4185402E-02,   1.3681888E-02
     +,   1.3192135E-02,   1.2716369E-02,   1.2254733E-02
     +,   1.1807282E-02,   1.1374002E-02,   1.0954774E-02
     +,   1.0549424E-02,   1.0157757E-02,   9.7795054E-03
     +,   9.4143618E-03,   9.0620248E-03,   8.7221656E-03
     +,   8.3944211E-03,   8.0784196E-03,   7.7738049E-03
     +,   7.4802190E-03,   7.1972823E-03,   6.9246232E-03
     +,   6.6618924E-03,   6.4087445E-03,   6.1648292E-03
     +,   5.9298011E-03,   5.7033482E-03,   5.4851491E-03
     +,   5.2748881E-03,   5.0722780E-03,   4.8770388E-03
     +,   4.6888869E-03,   4.5075528E-03,   4.3327822E-03
     +,   4.1643376E-03,   4.0019774E-03,   3.8454686E-03
     +,   3.6946051E-03,   3.5491688E-03,   3.4089698E-03
     +,   3.2738082E-03,   3.1435115E-03,   3.0178961E-03
     +,   2.8968058E-03,   2.7800738E-03,   2.6675561E-03
     +,   2.5591035E-03,   2.4545842E-03,   2.3538643E-03
     +,   2.2568174E-03,   2.1633301E-03,   2.0732828E-03
     +,   1.9865725E-03,   1.9030900E-03,   1.8227415E-03
     +,   1.7454250E-03,   1.6710553E-03,   1.5995367E-03
     +,   1.5307887E-03,   1.4647242E-03,   1.4012664E-03
     +,   1.3403324E-03,   1.2818504E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_ashz_hatt65_mass = Yx/12.81075425
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_ashz_hatt70_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.6778000E-02,   1.8234812E-02
     +,   1.9800672E-02,   2.1483334E-02,   2.3291536E-02
     +,   2.5235152E-02,   2.7325382E-02,   2.9574901E-02
     +,   3.1998016E-02,   3.4610983E-02,   3.7431851E-02
     +,   4.0480703E-02,   4.3779597E-02,   4.7352266E-02
     +,   5.1223885E-02,   5.5420443E-02,   5.9967723E-02
     +,   6.4890675E-02,   7.0211694E-02,   7.5949699E-02
     +,   8.2118735E-02,   8.8727139E-02,   9.5777176E-02
     +,   0.1032660    ,   0.1111852    ,   0.1195251    
     +,   0.1282755    ,   0.1374294    ,   0.1469852    
     +,   0.1569480    ,   0.1673298    ,   0.1781478    
     +,   0.1894213    ,   0.2011706    ,   0.2134162    
     +,   0.2261833    ,   0.2395119    ,   0.2534714    
     +,   0.2681759    ,   0.2837897    ,   0.3005221    
     +,   0.3185932    ,   0.3381820    ,   0.3593600    
     +,   0.3820376    ,   0.4059551    ,   0.4307495    
     +,   0.4561097    ,   0.4820050    ,   0.5089010    
     +,   0.5378357    ,   0.5702169    ,   0.6073021    
     +,   0.6495101    ,   0.6958926    ,   0.7441986    
     +,   0.7916437    ,   0.8361382    ,   0.8772574    
     +,   0.9163464    ,   0.9556530    ,   0.9971472    
     +,    1.041917    ,    1.090502    ,    1.143620    
     +,    1.202248    ,    1.266553    ,    1.334250    
     +,    1.400097    ,    1.457670    ,    1.502608    
     +,    1.534530    ,    1.555762    ,    1.568202    
     +,    1.571617    ,    1.564596    ,    1.546332    
     +,    1.517306    ,    1.479157    ,    1.434674    
     +,    1.387394    ,    1.340007    ,    1.292431    
     +,    1.241564    ,    1.183370    ,    1.115846    
     +,    1.040685    ,   0.9626412    ,   0.8873027    
     +,   0.8187680    ,   0.7584653    ,   0.7054093    
     +,   0.6573591    ,   0.6120926    ,   0.5682073    
     +,   0.5252672    ,   0.4835002    ,   0.4434109    
     +,   0.4054854    ,   0.3700804    ,   0.3374043    
     +,   0.3075613    ,   0.2805711    ,   0.2563988    
     +,   0.2349598    ,   0.2161294    ,   0.1997472    
     +,   0.1856197    ,   0.1735230    ,   0.1632114    
     +,   0.1544250    ,   0.1468989    ,   0.1403778    
     +,   0.1346239    ,   0.1294298    ,   0.1246231    
     +,   0.1200703    ,   0.1156755    ,   0.1113774    
     +,   0.1071426    ,   0.1029597    ,   9.8832838E-02
     +,   9.4775431E-02,   9.0805486E-02,   8.6941496E-02
     +,   8.3201163E-02,   7.9598427E-02,   7.6144166E-02
     +,   7.2844818E-02,   6.9704108E-02,   6.6722527E-02
     +,   6.3899048E-02,   6.1230935E-02,   5.8715269E-02
     +,   5.6348730E-02,   5.4128319E-02,   5.2051339E-02
     +,   5.0115619E-02,   4.8319012E-02,   4.6659332E-02
     +,   4.5134343E-02,   4.3741353E-02,   4.2476807E-02
     +,   4.1336399E-02,   4.0314905E-02,   3.9406125E-02
     +,   3.8602754E-02,   3.7896831E-02,   3.7279516E-02
     +,   3.6741324E-02,   3.6272395E-02,   3.5862632E-02
     +,   3.5501894E-02,   3.5180155E-02,   3.4887638E-02
     +,   3.4615155E-02,   3.4354039E-02,   3.4096465E-02
     +,   3.3835337E-02,   3.3564616E-02,   3.3279173E-02
     +,   3.2974944E-02,   3.2648891E-02,   3.2299083E-02
     +,   3.1924538E-02,   3.1525265E-02,   3.1102173E-02
     +,   3.0657036E-02,   3.0192351E-02,   2.9711219E-02
     +,   2.9217351E-02,   2.8714847E-02,   2.8208150E-02
     +,   2.7701868E-02,   2.7200790E-02,   2.6709646E-02
     +,   2.6233101E-02,   2.5775667E-02,   2.5341647E-02
     +,   2.4934998E-02,   2.4559293E-02,   2.4217803E-02
     +,   2.3913307E-02,   2.3648173E-02,   2.3424257E-02
     +,   2.3243023E-02,   2.3105470E-02,   2.3012117E-02
     +,   2.2963058E-02,   2.2958010E-02,   2.2996278E-02
     +,   2.3076823E-02,   2.3198251E-02,   2.3358874E-02
     +,   2.3556706E-02,   2.3789559E-02,   2.4054952E-02
     +,   2.4350228E-02,   2.4672559E-02,   2.5018966E-02
     +,   2.5386292E-02,   2.5771296E-02,   2.6170617E-02
     +,   2.6580831E-02,   2.6998423E-02,   2.7419847E-02
     +,   2.7841520E-02,   2.8259816E-02,   2.8671140E-02
     +,   2.9071894E-02,   2.9458541E-02,   2.9827587E-02
     +,   3.0175608E-02,   3.0499289E-02,   3.0795485E-02
     +,   3.1061133E-02,   3.1293381E-02,   3.1489603E-02
     +,   3.1647377E-02,   3.1764518E-02,   3.1839140E-02
     +,   3.1869669E-02,   3.1854793E-02,   3.1793617E-02
     +,   3.1685475E-02,   3.1530175E-02,   3.1327795E-02
     +,   3.1078802E-02,   3.0784048E-02,   3.0444629E-02
     +,   3.0062072E-02,   2.9638162E-02,   2.9174989E-02
     +,   2.8674839E-02,   2.8140340E-02,   2.7574215E-02
     +,   2.6979357E-02,   2.6358830E-02,   2.5715780E-02
     +,   2.5053360E-02,   2.4374710E-02,   2.3683051E-02
     +,   2.2981485E-02,   2.2273008E-02,   2.1560526E-02
     +,   2.0846810E-02,   2.0134512E-02,   1.9426027E-02
     +,   1.8723588E-02,   1.8029306E-02,   1.7344989E-02
     +,   1.6672282E-02,   1.6012637E-02,   1.5367319E-02
     +,   1.4737358E-02,   1.4123601E-02,   1.3526761E-02
     +,   1.2947390E-02,   1.2385836E-02,   1.1842337E-02
     +,   1.1317028E-02,   1.0809938E-02,   1.0320970E-02
     +,   9.8499386E-03,   9.3966378E-03,   8.9607667E-03
     +,   8.5419537E-03,   8.1398459E-03,   7.7540390E-03
     +,   7.3840800E-03,   7.0295152E-03,   6.6898945E-03
     +,   6.3647600E-03,   6.0536354E-03,   5.7560457E-03
     +,   5.4715471E-03,   5.1996661E-03,   4.9399706E-03
     +,   4.6920050E-03,   4.4553583E-03,   4.2295922E-03
     +,   4.0143118E-03,   3.8091009E-03,   3.6135856E-03
     +,   3.4273718E-03,   3.2501016E-03,   3.0814086E-03
     +,   2.9209370E-03,   2.7683547E-03,   2.6233208E-03
     +,   2.4855207E-03,   2.3546312E-03,   2.2303588E-03
     +,   2.1123963E-03,   2.0004665E-03,   1.8942839E-03
     +,   1.7935873E-03,   1.6981097E-03,   1.6076075E-03
     +,   1.5218323E-03,   1.4405580E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_ashz_hatt70_mass = Yx/15.9025915714286
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_ashz_hatt75_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.7102079E-02,   1.8610325E-02
     +,   2.0181756E-02,   2.1808492E-02,   2.3481464E-02
     +,   2.5190558E-02,   2.6924834E-02,   2.8672788E-02
     +,   3.0422624E-02,   3.2162685E-02,   3.3881698E-02
     +,   3.5569228E-02,   3.7216090E-02,   3.8814649E-02
     +,   4.0359307E-02,   4.1846730E-02,   4.3276183E-02
     +,   4.4649851E-02,   4.5972869E-02,   4.7253583E-02
     +,   4.8503559E-02,   4.9737543E-02,   5.0973371E-02
     +,   5.2232038E-02,   5.3537119E-02,   5.4915000E-02
     +,   5.6394383E-02,   5.8006249E-02,   5.9783496E-02
     +,   6.1760906E-02,   6.3974954E-02,   6.6463552E-02
     +,   6.9265865E-02,   7.2421633E-02,   7.5970337E-02
     +,   7.9950012E-02,   8.4395237E-02,   8.9334615E-02
     +,   9.4788305E-02,   0.1007644    ,   0.1072574    
     +,   0.1142463    ,   0.1216960    ,   0.1295609    
     +,   0.1377929    ,   0.1463527    ,   0.1552241    
     +,   0.1644302    ,   0.1740479    ,   0.1842168    
     +,   0.1951392    ,   0.2070647    ,   0.2202593    
     +,   0.2349610    ,   0.2513282    ,   0.2693993    
     +,   0.2890722    ,   0.3101261    ,   0.3322760    
     +,   0.3552594    ,   0.3789266    ,   0.4033210    
     +,   0.4287308    ,   0.4557317    ,   0.4852045    
     +,   0.5183199    ,   0.5564581    ,   0.6009679    
     +,   0.6527941    ,   0.7120007    ,   0.7774071    
     +,   0.8464867    ,   0.9157284    ,   0.9815781    
     +,    1.041977    ,    1.097803    ,    1.152870    
     +,    1.211432    ,    1.274600    ,    1.339350    
     +,    1.402374    ,    1.465053    ,    1.532824    
     +,    1.608205    ,    1.685660    ,    1.755795    
     +,    1.814424    ,    1.866045    ,    1.918551    
     +,    1.975335    ,    2.030866    ,    2.072880    
     +,    2.091701    ,    2.089411    ,    2.077229    
     +,    2.062011    ,    2.037510    ,    1.990242    
     +,    1.911992    ,    1.805454    ,    1.680214    
     +,    1.546068    ,    1.409924    ,    1.276433    
     +,    1.149412    ,    1.032250    ,   0.9272640    
     +,   0.8348789    ,   0.7536485    ,   0.6812521    
     +,   0.6156802    ,   0.5558113    ,   0.5012860    
     +,   0.4520451    ,   0.4080159    ,   0.3690032    
     +,   0.3347222    ,   0.3048138    ,   0.2788570    
     +,   0.2563603    ,   0.2367831    ,   0.2195753    
     +,   0.2042218    ,   0.1902814    ,   0.1774162    
     +,   0.1654013    ,   0.1541130    ,   0.1435099    
     +,   0.1336000    ,   0.1244149    ,   0.1159822    
     +,   0.1083136    ,   0.1013951    ,   9.5190160E-02
     +,   8.9642718E-02,   8.4685154E-02,   8.0245450E-02
     +,   7.6252781E-02,   7.2641142E-02,   6.9352336E-02
     +,   6.6336833E-02,   6.3553743E-02,   6.0969878E-02
     +,   5.8559224E-02,   5.6301691E-02,   5.4181881E-02
     +,   5.2188236E-02,   5.0312128E-02,   4.8547182E-02
     +,   4.6888378E-02,   4.5331690E-02,   4.3873828E-02
     +,   4.2511832E-02,   4.1242734E-02,   4.0063526E-02
     +,   3.8971197E-02,   3.7962586E-02,   3.7034340E-02
     +,   3.6183015E-02,   3.5405219E-02,   3.4697518E-02
     +,   3.4056582E-02,   3.3479247E-02,   3.2962520E-02
     +,   3.2503616E-02,   3.2099970E-02,   3.1749286E-02
     +,   3.1449448E-02,   3.1198574E-02,   3.0994885E-02
     +,   3.0836778E-02,   3.0722635E-02,   3.0650906E-02
     +,   3.0619973E-02,   3.0628100E-02,   3.0673385E-02
     +,   3.0753739E-02,   3.0866789E-02,   3.1009898E-02
     +,   3.1180112E-02,   3.1374168E-02,   3.1588420E-02
     +,   3.1818993E-02,   3.2061625E-02,   3.2311868E-02
     +,   3.2565046E-02,   3.2816291E-02,   3.3060662E-02
     +,   3.3293247E-02,   3.3509154E-02,   3.3703640E-02
     +,   3.3872269E-02,   3.4010842E-02,   3.4115616E-02
     +,   3.4183327E-02,   3.4211248E-02,   3.4197275E-02
     +,   3.4140006E-02,   3.4038607E-02,   3.3893052E-02
     +,   3.3704016E-02,   3.3472802E-02,   3.3201430E-02
     +,   3.2892466E-02,   3.2549091E-02,   3.2174930E-02
     +,   3.1773973E-02,   3.1350601E-02,   3.0909283E-02
     +,   3.0454703E-02,   2.9991440E-02,   2.9524062E-02
     +,   2.9056877E-02,   2.8593976E-02,   2.8139018E-02
     +,   2.7695291E-02,   2.7265592E-02,   2.6852163E-02
     +,   2.6456671E-02,   2.6080279E-02,   2.5723526E-02
     +,   2.5386333E-02,   2.5068184E-02,   2.4767971E-02
     +,   2.4484158E-02,   2.4214778E-02,   2.3957530E-02
     +,   2.3709839E-02,   2.3468891E-02,   2.3231715E-02
     +,   2.2995315E-02,   2.2756664E-02,   2.2512807E-02
     +,   2.2260882E-02,   2.1998288E-02,   2.1722605E-02
     +,   2.1431673E-02,   2.1123709E-02,   2.0797236E-02
     +,   2.0451147E-02,   2.0084679E-02,   1.9697497E-02
     +,   1.9289613E-02,   1.8861391E-02,   1.8413527E-02
     +,   1.7947054E-02,   1.7463304E-02,   1.6963836E-02
     +,   1.6450403E-02,   1.5925024E-02,   1.5389775E-02
     +,   1.4846844E-02,   1.4298523E-02,   1.3747127E-02
     +,   1.3194916E-02,   1.2644111E-02,   1.2096895E-02
     +,   1.1555340E-02,   1.1021380E-02,   1.0496772E-02
     +,   9.9831857E-03,   9.4820959E-03,   8.9947684E-03
     +,   8.5223038E-03,   8.0656540E-03,   7.6255435E-03
     +,   7.2025363E-03,   6.7970464E-03,   6.4093336E-03
     +,   6.0394877E-03,   5.6874566E-03,   5.3531011E-03
     +,   5.0361636E-03,   4.7362749E-03,   4.4529894E-03
     +,   4.1858116E-03,   3.9341720E-03,   3.6974759E-03
     +,   3.4750712E-03,   3.2663168E-03,   3.0705256E-03
     +,   2.8870357E-03,   2.7151634E-03,   2.5542572E-03
     +,   2.4036577E-03,   2.2627430E-03,   2.1309017E-03
     +,   2.0075457E-03,   1.8921252E-03,   1.7841042E-03
     +,   1.6829877E-03,   1.5882971E-03,   1.4995957E-03
     +,   1.4164618E-03,   1.3385123E-03,   1.2653799E-03
     +,   1.1967336E-03,   1.1322558E-03,   1.0716610E-03
     +,   1.0146770E-03,   9.6105912E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_ashz_hatt75_mass = Yx/18.92366406
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_ashz_hatt80_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.7760038E-03,   5.0119171E-03
     +,   5.2599390E-03,   5.5208178E-03,   5.7953484E-03
     +,   6.0843728E-03,   6.3887881E-03,   6.7095398E-03
     +,   7.0476299E-03,   7.4041318E-03,   7.7801626E-03
     +,   8.1769228E-03,   8.5956817E-03,   9.0377936E-03
     +,   9.5047243E-03,   9.9980440E-03,   1.0519484E-02
     +,   1.1070944E-02,   1.1654544E-02,   1.2272694E-02
     +,   1.2928126E-02,   1.3624044E-02,   1.4364146E-02
     +,   1.5152848E-02,   1.5995298E-02,   1.6897721E-02
     +,   1.7867420E-02,   1.8913096E-02,   2.0044973E-02
     +,   2.1274967E-02,   2.2616865E-02,   2.4086311E-02
     +,   2.5700858E-02,   2.7479714E-02,   2.9443476E-02
     +,   3.1613626E-02,   3.4011751E-02,   3.6658611E-02
     +,   3.9573226E-02,   4.2771071E-02,   4.6263259E-02
     +,   5.0054874E-02,   5.4143623E-02,   5.8519002E-02
     +,   6.3161597E-02,   6.8043053E-02,   7.3126882E-02
     +,   7.8369692E-02,   8.3723858E-02,   8.9140363E-02
     +,   9.4572671E-02,   9.9981055E-02,   0.1053361    
     +,   0.1106237    ,   0.1158471    ,   0.1210302    
     +,   0.1262184    ,   0.1314799    ,   0.1369044    
     +,   0.1426020    ,   0.1486978    ,   0.1553249    
     +,   0.1626107    ,   0.1706570    ,   0.1795172    
     +,   0.1891666    ,   0.1994808    ,   0.2102240    
     +,   0.2210605    ,   0.2315883    ,   0.2414082    
     +,   0.2502064    ,   0.2578501    ,   0.2644659    
     +,   0.2704884    ,   0.2766674    ,   0.2840334    
     +,   0.2938376    ,   0.3074759    ,   0.3263914    
     +,   0.3519203    ,   0.3850417    ,   0.4259869    
     +,   0.4738252    ,   0.5262026    ,   0.5796272    
     +,   0.6305035    ,   0.6769173    ,   0.7204409    
     +,   0.7668849    ,   0.8248639    ,   0.9019388    
     +,   0.9997265    ,    1.110932    ,    1.221156    
     +,    1.315535    ,    1.386890    ,    1.440637    
     +,    1.492991    ,    1.561811    ,    1.655739    
     +,    1.771590    ,    1.902065    ,    2.041270    
     +,    2.179296    ,    2.299088    ,    2.388756    
     +,    2.453750    ,    2.511423    ,    2.576069    
     +,    2.650297    ,    2.726331    ,    2.784381    
     +,    2.799223    ,    2.769460    ,    2.718406    
     +,    2.649287    ,    2.532324    ,    2.348465    
     +,    2.118992    ,    1.882168    ,    1.659442    
     +,    1.453369    ,    1.263915    ,    1.094785    
     +,   0.9485049    ,   0.8232176    ,   0.7151903    
     +,   0.6219425    ,   0.5426599    ,   0.4767599    
     +,   0.4228848    ,   0.3789414    ,   0.3427053    
     +,   0.3122743    ,   0.2862220    ,   0.2635428    
     +,   0.2435341    ,   0.2256925    ,   0.2096397    
     +,   0.1950794    ,   0.1817695    ,   0.1695108    
     +,   0.1581458    ,   0.1475600    ,   0.1376781    
     +,   0.1284591    ,   0.1198866    ,   0.1119574    
     +,   0.1046692    ,   9.8012380E-02,   9.1966085E-02
     +,   8.6495303E-02,   8.1552252E-02,   7.7080332E-02
     +,   7.3018953E-02,   6.9307595E-02,   6.5889612E-02
     +,   6.2715575E-02,   5.9745282E-02,   5.6947507E-02
     +,   5.4300252E-02,   5.1789496E-02,   4.9407832E-02
     +,   4.7152273E-02,   4.5023199E-02,   4.3022860E-02
     +,   4.1154087E-02,   3.9419405E-02,   3.7820693E-02
     +,   3.6358815E-02,   3.5033546E-02,   3.3843510E-02
     +,   3.2786362E-02,   3.1859025E-02,   3.1057721E-02
     +,   3.0378088E-02,   2.9815406E-02,   2.9364550E-02
     +,   2.9020052E-02,   2.8776109E-02,   2.8626667E-02
     +,   2.8565342E-02,   2.8585441E-02,   2.8679969E-02
     +,   2.8841712E-02,   2.9063124E-02,   2.9336505E-02
     +,   2.9653937E-02,   3.0007401E-02,   3.0388759E-02
     +,   3.0789874E-02,   3.1202612E-02,   3.1618845E-02
     +,   3.2030713E-02,   3.2430481E-02,   3.2810647E-02
     +,   3.3164017E-02,   3.3483818E-02,   3.3763744E-02
     +,   3.3997942E-02,   3.4181144E-02,   3.4308739E-02
     +,   3.4376767E-02,   3.4382086E-02,   3.4322236E-02
     +,   3.4195609E-02,   3.4001414E-02,   3.3739720E-02
     +,   3.3411391E-02,   3.3018053E-02,   3.2562140E-02
     +,   3.2046817E-02,   3.1475801E-02,   3.0853417E-02
     +,   3.0184448E-02,   2.9474108E-02,   2.8727805E-02
     +,   2.7951119E-02,   2.7149776E-02,   2.6329396E-02
     +,   2.5495460E-02,   2.4653293E-02,   2.3807911E-02
     +,   2.2963932E-02,   2.2125529E-02,   2.1296525E-02
     +,   2.0480236E-02,   1.9679423E-02,   1.8896373E-02
     +,   1.8132942E-02,   1.7390514E-02,   1.6670028E-02
     +,   1.5972013E-02,   1.5296742E-02,   1.4644130E-02
     +,   1.4013831E-02,   1.3405364E-02,   1.2818093E-02
     +,   1.2251248E-02,   1.1704001E-02,   1.1175527E-02
     +,   1.0665029E-02,   1.0171696E-02,   9.6947709E-03
     +,   9.2336098E-03,   8.7876329E-03,   8.3563197E-03
     +,   7.9392344E-03,   7.5360560E-03,   7.1464968E-03
     +,   6.7703403E-03,   6.4074392E-03,   6.0576978E-03
     +,   5.7210205E-03,   5.3973352E-03,   5.0866040E-03
     +,   4.7887787E-03,   4.5037856E-03,   4.2315358E-03
     +,   3.9719334E-03,   3.7248526E-03,   3.4901171E-03
     +,   3.2675234E-03,   3.0568480E-03,   2.8578204E-03
     +,   2.6701314E-03,   2.4934593E-03,   2.3274508E-03
     +,   2.1717199E-03,   2.0258615E-03,   1.8894617E-03
     +,   1.7620982E-03,   1.6433290E-03,   1.5327106E-03
     +,   1.4298094E-03,   1.3341808E-03,   1.2453996E-03
     +,   1.1630381E-03,   1.0866906E-03,   1.0159540E-03
     +,   9.5045008E-04,   8.8980829E-04,   8.3368324E-04
     +,   7.8173965E-04,   7.3366781E-04,   6.8917114E-04
     +,   6.4797152E-04,   6.0981361E-04,   5.7445327E-04
     +,   5.4166926E-04,   5.1125174E-04,   4.8301078E-04
     +,   4.5676710E-04,   4.3235955E-04,   4.0963659E-04
     +,   3.8846157E-04,   3.6870741E-04,   3.5025951E-04
     +,   3.3301109E-04,   3.1686664E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_ashz_hatt80_mass = Yx/21.4458740588235
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_ashz_hatt85_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.4516159E-03,   2.5291450E-03
     +,   2.6092958E-03,   2.6922580E-03,   2.7782300E-03
     +,   2.8674188E-03,   2.9600414E-03,   3.0563213E-03
     +,   3.1564871E-03,   3.2607790E-03,   3.3694389E-03
     +,   3.4827110E-03,   3.6008463E-03,   3.7240949E-03
     +,   3.8527076E-03,   3.9869323E-03,   4.1270177E-03
     +,   4.2732009E-03,   4.4257157E-03,   4.5847823E-03
     +,   4.7506113E-03,   4.9233944E-03,   5.1033013E-03
     +,   5.2904906E-03,   5.4850732E-03,   5.6871492E-03
     +,   5.8967723E-03,   6.1139599E-03,   6.3386830E-03
     +,   6.5708705E-03,   6.8103941E-03,   7.0570717E-03
     +,   7.3106727E-03,   7.5708986E-03,   7.8374017E-03
     +,   8.1097744E-03,   8.3875591E-03,   8.6702658E-03
     +,   8.9573711E-03,   9.2483191E-03,   9.5425798E-03
     +,   9.8396447E-03,   1.0139056E-02,   1.0440463E-02
     +,   1.0743631E-02,   1.1048512E-02,   1.1355290E-02
     +,   1.1664430E-02,   1.1976736E-02,   1.2293419E-02
     +,   1.2616136E-02,   1.2947083E-02,   1.3289017E-02
     +,   1.3645335E-02,   1.4020090E-02,   1.4418107E-02
     +,   1.4844968E-02,   1.5307105E-02,   1.5811874E-02
     +,   1.6367629E-02,   1.6983854E-02,   1.7671300E-02
     +,   1.8442124E-02,   1.9310161E-02,   2.0291090E-02
     +,   2.1402543E-02,   2.2664452E-02,   2.4098875E-02
     +,   2.5730211E-02,   2.7584611E-02,   2.9689999E-02
     +,   3.2074783E-02,   3.4767494E-02,   3.7794851E-02
     +,   4.1180782E-02,   4.4944495E-02,   4.9098361E-02
     +,   5.3646091E-02,   5.8581680E-02,   6.3888162E-02
     +,   6.9536857E-02,   7.5490363E-02,   8.1704400E-02
     +,   8.8134862E-02,   9.4744258E-02,   0.1015127    
     +,   0.1084468    ,   0.1155900    ,   0.1230276    
     +,   0.1308901    ,   0.1393497    ,   0.1486113    
     +,   0.1589025    ,   0.1704605    ,   0.1835165    
     +,   0.1982705    ,   0.2148604    ,   0.2333080    
     +,   0.2534658    ,   0.2749747    ,   0.2972997    
     +,   0.3198672    ,   0.3423444    ,   0.3649696    
     +,   0.3888035    ,   0.4156816    ,   0.4477578    
     +,   0.4867471    ,   0.5332460    ,   0.5866237    
     +,   0.6456941    ,   0.7097209    ,   0.7787850    
     +,   0.8530614    ,   0.9317687    ,    1.013564    
     +,    1.098994    ,    1.192814    ,    1.301859    
     +,    1.428210    ,    1.564393    ,    1.697484    
     +,    1.821853    ,    1.954128    ,    2.132479    
     +,    2.378702    ,    2.652431    ,    2.874480    
     +,    3.009536    ,    3.103097    ,    3.236619    
     +,    3.432016    ,    3.596826    ,    3.625163    
     +,    3.529883    ,    3.381253    ,    3.204280    
     +,    3.024438    ,    2.878144    ,    2.726583    
     +,    2.496820    ,    2.192604    ,    1.874844    
     +,    1.590998    ,    1.356893    ,    1.166137    
     +,    1.004801    ,   0.8637723    ,   0.7405944    
     +,   0.6354538    ,   0.5483755    ,   0.4781408    
     +,   0.4220996    ,   0.3768382    ,   0.3392233    
     +,   0.3070357    ,   0.2789860    ,   0.2543879    
     +,   0.2328247    ,   0.2139426    ,   0.1973583    
     +,   0.1826472    ,   0.1693739    ,   0.1571427    
     +,   0.1456417    ,   0.1346735    ,   0.1241542    
     +,   0.1140909    ,   0.1045482    ,   9.5614173E-02
     +,   8.7375641E-02,   7.9900153E-02,   7.3229000E-02
     +,   6.7376770E-02,   6.2334821E-02,   5.8074374E-02
     +,   5.4551642E-02,   5.1711541E-02,   4.9490791E-02
     +,   4.7820345E-02,   4.6628218E-02,   4.5841515E-02
     +,   4.5388453E-02,   4.5199949E-02,   4.5211282E-02
     +,   4.5363143E-02,   4.5602512E-02,   4.5883179E-02
     +,   4.6165951E-02,   4.6418846E-02,   4.6616718E-02
     +,   4.6740890E-02,   4.6778869E-02,   4.6723608E-02
     +,   4.6572831E-02,   4.6328377E-02,   4.5995444E-02
     +,   4.5581810E-02,   4.5097023E-02,   4.4551749E-02
     +,   4.3957021E-02,   4.3323655E-02,   4.2661712E-02
     +,   4.1979987E-02,   4.1285895E-02,   4.0585060E-02
     +,   3.9881315E-02,   3.9176747E-02,   3.8471892E-02
     +,   3.7765805E-02,   3.7056420E-02,   3.6340978E-02
     +,   3.5616267E-02,   3.4878954E-02,   3.4125928E-02
     +,   3.3354718E-02,   3.2563545E-02,   3.1751566E-02
     +,   3.0918917E-02,   3.0066941E-02,   2.9197868E-02
     +,   2.8314900E-02,   2.7422076E-02,   2.6524058E-02
     +,   2.5625868E-02,   2.4732726E-02,   2.3849959E-02
     +,   2.2982631E-02,   2.2135388E-02,   2.1312373E-02
     +,   2.0517100E-02,   1.9752380E-02,   1.9020211E-02
     +,   1.8321753E-02,   1.7657526E-02,   1.7027233E-02
     +,   1.6429931E-02,   1.5864164E-02,   1.5327998E-02
     +,   1.4819099E-02,   1.4334884E-02,   1.3872640E-02
     +,   1.3429598E-02,   1.3002998E-02,   1.2590168E-02
     +,   1.2188640E-02,   1.1796180E-02,   1.1410762E-02
     +,   1.1030669E-02,   1.0654507E-02,   1.0281147E-02
     +,   9.9097798E-03,   9.5398789E-03,   9.1712112E-03
     +,   8.8037495E-03,   8.4376996E-03,   8.0734612E-03
     +,   7.7116089E-03,   7.3528108E-03,   6.9978256E-03
     +,   6.6475207E-03,   6.3027837E-03,   5.9645008E-03
     +,   5.6335428E-03,   5.3107836E-03,   4.9970141E-03
     +,   4.6929615E-03,   4.3992908E-03,   4.1165887E-03
     +,   3.8453199E-03,   3.5858566E-03,   3.3384904E-03
     +,   3.1034099E-03,   2.8806941E-03,   2.6703284E-03
     +,   2.4722342E-03,   2.2862235E-03,   2.1120631E-03
     +,   1.9494310E-03,   1.7979690E-03,   1.6572536E-03
     +,   1.5268396E-03,   1.4062359E-03,   1.2949442E-03
     +,   1.1924364E-03,   1.0981919E-03,   1.0116786E-03
     +,   9.3237025E-04,   8.5975818E-04,   7.9333724E-04
     +,   7.3263026E-04,   6.7717134E-04,   6.2652573E-04
     +,   5.8027578E-04,   5.3803576E-04,   4.9944030E-04
     +,   4.6415551E-04,   4.3186819E-04,   4.0229523E-04
     +,   3.7517361E-04,   3.5026742E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_ashz_hatt85_mass = Yx/22.3853197647059
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_ashz_hatt90_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.1992440E-03,   2.2415756E-03
     +,   2.2831825E-03,   2.3240580E-03,   2.3642017E-03
     +,   2.4036220E-03,   2.4423359E-03,   2.4803695E-03
     +,   2.5177565E-03,   2.5545422E-03,   2.5907801E-03
     +,   2.6265322E-03,   2.6618715E-03,   2.6968790E-03
     +,   2.7316485E-03,   2.7662788E-03,   2.8008849E-03
     +,   2.8355869E-03,   2.8705162E-03,   2.9058147E-03
     +,   2.9416340E-03,   2.9781363E-03,   3.0154926E-03
     +,   3.0538870E-03,   3.0935081E-03,   3.1345570E-03
     +,   3.1772461E-03,   3.2217954E-03,   3.2684316E-03
     +,   3.3173936E-03,   3.3689258E-03,   3.4232801E-03
     +,   3.4807150E-03,   3.5414963E-03,   3.6058933E-03
     +,   3.6741795E-03,   3.7466318E-03,   3.8235274E-03
     +,   3.9051489E-03,   3.9917724E-03,   4.0836767E-03
     +,   4.1811368E-03,   4.2844252E-03,   4.3938109E-03
     +,   4.5095580E-03,   4.6319254E-03,   4.7611678E-03
     +,   4.8975362E-03,   5.0412789E-03,   5.1926421E-03
     +,   5.3518699E-03,   5.5192076E-03,   5.6949048E-03
     +,   5.8792252E-03,   6.0724188E-03,   6.2747714E-03
     +,   6.4865733E-03,   6.7081270E-03,   6.9397502E-03
     +,   7.1817902E-03,   7.4346093E-03,   7.6985885E-03
     +,   7.9741077E-03,   8.2615847E-03,   8.5614379E-03
     +,   8.8740671E-03,   9.1998922E-03,   9.5392792E-03
     +,   9.8926025E-03,   1.0260137E-02,   1.0642163E-02
     +,   1.1038820E-02,   1.1450225E-02,   1.1876322E-02
     +,   1.2317002E-02,   1.2772013E-02,   1.3240958E-02
     +,   1.3723314E-02,   1.4218456E-02,   1.4725645E-02
     +,   1.5244026E-02,   1.5772721E-02,   1.6310807E-02
     +,   1.6857419E-02,   1.7411748E-02,   1.7973229E-02
     +,   1.8541494E-02,   1.9116627E-02,   1.9699126E-02
     +,   2.0290185E-02,   2.0891782E-02,   2.1506771E-02
     +,   2.2139139E-02,   2.2794118E-02,   2.3478420E-02
     +,   2.4200233E-02,   2.4969516E-02,   2.5797898E-02
     +,   2.6698997E-02,   2.7688036E-02,   2.8782211E-02
     +,   3.0000146E-02,   3.1362083E-02,   3.2889288E-02
     +,   3.4604158E-02,   3.6529992E-02,   3.8690675E-02
     +,   4.1110836E-02,   4.3816406E-02,   4.6835013E-02
     +,   5.0196368E-02,   5.3933818E-02,   5.8084309E-02
     +,   6.2689625E-02,   6.7794912E-02,   7.3448166E-02
     +,   7.9696164E-02,   8.6581886E-02,   9.4138928E-02
     +,   0.1023911    ,   0.1113535    ,   0.1210412    
     +,   0.1314865    ,   0.1427653    ,   0.1550250    
     +,   0.1685088    ,   0.1835728    ,   0.2006758    
     +,   0.2203468    ,   0.2431114    ,   0.2693923    
     +,   0.2993800    ,   0.3329410    ,   0.3696046    
     +,   0.4087046    ,   0.4496233    ,   0.4920423    
     +,   0.5361198    ,   0.5826267    ,   0.6330735    
     +,   0.6896210    ,   0.7545561    ,   0.8298525    
     +,   0.9179823    ,    1.023624    ,    1.152671    
     +,    1.306180    ,    1.476553    ,    1.656562    
     +,    1.851751    ,    2.075270    ,    2.329636    
     +,    2.595882    ,    2.855565    ,    3.134562    
     +,    3.460884    ,    3.761679    ,    3.914887    
     +,    3.927124    ,    3.905415    ,    3.890461    
     +,    3.859980    ,    3.752257    ,    3.499255    
     +,    3.122815    ,    2.710495    ,    2.317472    
     +,    1.945049    ,    1.598515    ,    1.300599    
     +,    1.059834    ,   0.8690463    ,   0.7198495    
     +,   0.6056550    ,   0.5199606    ,   0.4570668    
     +,   0.4129676    ,   0.3845662    ,   0.3685920    
     +,   0.3614483    ,   0.3597654    ,   0.3609232    
     +,   0.3631884    ,   0.3655169    ,   0.3672324    
     +,   0.3677510    ,   0.3664657    ,   0.3627825    
     +,   0.3562656    ,   0.3467754    ,   0.3345398    
     +,   0.3201225    ,   0.3043124    ,   0.2879758    
     +,   0.2719184    ,   0.2567860    ,   0.2430108    
     +,   0.2307971    ,   0.2201390    ,   0.2108638    
     +,   0.2026914    ,   0.1952951    ,   0.1883608    
     +,   0.1816311    ,   0.1749306    ,   0.1681674    
     +,   0.1613211    ,   0.1544206    ,   0.1475172    
     +,   0.1406635    ,   0.1338995    ,   0.1272470    
     +,   0.1207110    ,   0.1142849    ,   0.1079583    
     +,   0.1017246    ,   9.5585667E-02,   8.9553438E-02
     +,   8.3650090E-02,   7.7907071E-02,   7.2360098E-02
     +,   6.7046121E-02,   6.2000368E-02,   5.7252735E-02
     +,   5.2825686E-02,   4.8733134E-02,   4.4980682E-02
     +,   4.1565508E-02,   3.8477175E-02,   3.5699245E-02
     +,   3.3210807E-02,   3.0987836E-02,   2.9004322E-02
     +,   2.7233822E-02,   2.5650457E-02,   2.4229450E-02
     +,   2.2947768E-02,   2.1784613E-02,   2.0721449E-02
     +,   1.9742001E-02,   1.8832274E-02,   1.7980468E-02
     +,   1.7176745E-02,   1.6412964E-02,   1.5682546E-02
     +,   1.4980292E-02,   1.4302170E-02,   1.3645031E-02
     +,   1.3006568E-02,   1.2385178E-02,   1.1779743E-02
     +,   1.1189559E-02,   1.0614316E-02,   1.0053960E-02
     +,   9.5085921E-03,   8.9784628E-03,   8.4639499E-03
     +,   7.9654958E-03,   7.4835331E-03,   7.0184926E-03
     +,   6.5708184E-03,   6.1409068E-03,   5.7290704E-03
     +,   5.3355540E-03,   4.9605570E-03,   4.6041603E-03
     +,   4.2663524E-03,   3.9470568E-03,   3.6461011E-03
     +,   3.3632047E-03,   3.0980050E-03,   2.8500785E-03
     +,   2.6189305E-03,   2.4039864E-03,   2.2046180E-03
     +,   2.0201737E-03,   1.8499384E-03,   1.6931947E-03
     +,   1.5491870E-03,   1.4171700E-03,   1.2963782E-03
     +,   1.1860699E-03,   1.0855013E-03,   9.9396077E-04
     +,   9.1074704E-04,   8.3519891E-04,   7.6667685E-04
     +,   7.0457556E-04,   6.4833090E-04,   5.9740641E-04
     +,   5.5130909E-04,   5.0957606E-04,   4.7178537E-04
     +,   4.3754434E-04,   4.0649856E-04,   3.7832119E-04
     +,   3.5271898E-04,   3.2942349E-04,   3.0819574E-04
     +,   2.8881818E-04,   2.7109822E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_ashz_hatt90_mass = Yx/22.3103946470588
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_ashz_hatt95_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.8332247E-03,   1.9046834E-03
     +,   1.9770944E-03,   2.0503439E-03,   2.1243126E-03
     +,   2.1988736E-03,   2.2738948E-03,   2.3492407E-03
     +,   2.4247682E-03,   2.5003357E-03,   2.5757963E-03
     +,   2.6510016E-03,   2.7258049E-03,   2.8000602E-03
     +,   2.8736237E-03,   2.9463584E-03,   3.0181308E-03
     +,   3.0888186E-03,   3.1583060E-03,   3.2264921E-03
     +,   3.2932882E-03,   3.3586242E-03,   3.4224454E-03
     +,   3.4847227E-03,   3.5454431E-03,   3.6046247E-03
     +,   3.6623117E-03,   3.7185755E-03,   3.7735156E-03
     +,   3.8272727E-03,   3.8800125E-03,   3.9319415E-03
     +,   3.9832979E-03,   4.0343548E-03,   4.0854239E-03
     +,   4.1368506E-03,   4.1890102E-03,   4.2423122E-03
     +,   4.2971973E-03,   4.3541193E-03,   4.4135707E-03
     +,   4.4760467E-03,   4.5420611E-03,   4.6121296E-03
     +,   4.6867668E-03,   4.7664810E-03,   4.8517627E-03
     +,   4.9430788E-03,   5.0408621E-03,   5.1455065E-03
     +,   5.2573555E-03,   5.3766961E-03,   5.5037430E-03
     +,   5.6386515E-03,   5.7814778E-03,   5.9322044E-03
     +,   6.0907160E-03,   6.2568039E-03,   6.4301593E-03
     +,   6.6103679E-03,   6.7969286E-03,   6.9892313E-03
     +,   7.1865697E-03,   7.3881592E-03,   7.5931419E-03
     +,   7.8005665E-03,   8.0094421E-03,   8.2187206E-03
     +,   8.4273396E-03,   8.6341975E-03,   8.8382270E-03
     +,   9.0383552E-03,   9.2335828E-03,   9.4229458E-03
     +,   9.6055875E-03,   9.7807581E-03,   9.9478234E-03
     +,   1.0106301E-02,   1.0255884E-02,   1.0396456E-02
     +,   1.0528080E-02,   1.0651059E-02,   1.0765908E-02
     +,   1.0873376E-02,   1.0974448E-02,   1.1070359E-02
     +,   1.1162543E-02,   1.1252686E-02,   1.1342663E-02
     +,   1.1434541E-02,   1.1530540E-02,   1.1633012E-02
     +,   1.1744392E-02,   1.1867178E-02,   1.2003865E-02
     +,   1.2156904E-02,   1.2328657E-02,   1.2521324E-02
     +,   1.2736908E-02,   1.2977165E-02,   1.3243543E-02
     +,   1.3537111E-02,   1.3858581E-02,   1.4208203E-02
     +,   1.4585804E-02,   1.4990730E-02,   1.5421851E-02
     +,   1.5877558E-02,   1.6355829E-02,   1.6854236E-02
     +,   1.7369939E-02,   1.7899888E-02,   1.8440718E-02
     +,   1.8989017E-02,   1.9541260E-02,   2.0094082E-02
     +,   2.0644234E-02,   2.1188855E-02,   2.1725507E-02
     +,   2.2252360E-02,   2.2768358E-02,   2.3273276E-02
     +,   2.3767982E-02,   2.4254503E-02,   2.4736231E-02
     +,   2.5217939E-02,   2.5706075E-02,   2.6208611E-02
     +,   2.6735282E-02,   2.7297458E-02,   2.7908148E-02
     +,   2.8581712E-02,   2.9333794E-02,   3.0180704E-02
     +,   3.1139255E-02,   3.2226026E-02,   3.3456814E-02
     +,   3.4845799E-02,   3.6405202E-02,   3.8144458E-02
     +,   4.0069532E-02,   4.2182691E-02,   4.4482417E-02
     +,   4.6963196E-02,   4.9615685E-02,   5.2427504E-02
     +,   5.5383593E-02,   5.8466837E-02,   6.1658949E-02
     +,   6.4941317E-02,   6.8295270E-02,   7.1702279E-02
     +,   7.5143568E-02,   7.8600436E-02,   8.2052790E-02
     +,   8.5478239E-02,   8.8851772E-02,   9.2145085E-02
     +,   9.5327929E-02,   9.8368950E-02,   0.1012407    
     +,   0.1039244    ,   0.1064181    ,   0.1087447    
     +,   0.1109608    ,   0.1131627    ,   0.1154875    
     +,   0.1181073    ,   0.1212141    ,   0.1249945    
     +,   0.1295970    ,   0.1350994    ,   0.1414865    
     +,   0.1486519    ,   0.1564375    ,   0.1647241    
     +,   0.1735597    ,   0.1833009    ,   0.1947215    
     +,   0.2090517    ,   0.2279668    ,   0.2536232    
     +,   0.2888552    ,   0.3374725    ,   0.4041932    
     +,   0.4935451    ,   0.6079974    ,   0.7477161    
     +,   0.9144117    ,    1.116145    ,    1.364123    
     +,    1.658438    ,    1.977250    ,    2.289047    
     +,    2.582588    ,    2.887030    ,    3.223162    
     +,    3.524196    ,    3.764776    ,    4.022399    
     +,    4.236212    ,    4.256107    ,    4.050059    
     +,    3.757167    ,    3.562237    ,    3.432128    
     +,    3.208774    ,    2.903279    ,    2.615852    
     +,    2.367990    ,    2.144127    ,    1.934006    
     +,    1.726463    ,    1.518628    ,    1.318585    
     +,    1.137473    ,   0.9828364    ,   0.8551551    
     +,   0.7490951    ,   0.6577295    ,   0.5763061    
     +,   0.5035239    ,   0.4401997    ,   0.3871073    
     +,   0.3438178    ,   0.3088811    ,   0.2805404    
     +,   0.2572368    ,   0.2377019    ,   0.2208426    
     +,   0.2056570    ,   0.1912619    ,   0.1769926    
     +,   0.1624820    ,   0.1476720    ,   0.1327497    
     +,   0.1180480    ,   0.1039412    ,   9.0759695E-02
     +,   7.8739934E-02,   6.8008274E-02,   5.8590543E-02
     +,   5.0434180E-02,   4.3434743E-02,   3.7462004E-02
     +,   3.2379214E-02,   2.8055230E-02,   2.4371296E-02
     +,   2.1224299E-02,   1.8527316E-02,   1.6207743E-02
     +,   1.4205892E-02,   1.2473137E-02,   1.0969746E-02
     +,   9.6631162E-03,   8.5263466E-03,   7.5370497E-03
     +,   6.6762553E-03,   5.9275841E-03,   5.2767727E-03
     +,   4.7113104E-03,   4.2201192E-03,   3.7933444E-03
     +,   3.4222761E-03,   3.0992830E-03,   2.8176503E-03
     +,   2.5715451E-03,   2.3559481E-03,   2.1665469E-03
     +,   1.9996490E-03,   1.8521115E-03,   1.7212757E-03
     +,   1.6048831E-03,   1.5010062E-03,   1.4080039E-03
     +,   1.3244807E-03,   1.2492278E-03,   1.1812105E-03
     +,   1.1195240E-03,   1.0633876E-03,   1.0121124E-03
     +,   9.6510054E-04,   9.2182285E-04,   8.8181888E-04
     +,   8.4468076E-04,   8.1005477E-04,   7.7762874E-04
     +,   7.4713019E-04,   7.1832555E-04,   6.9100800E-04
     +,   6.6500326E-04,   6.4015784E-04,   6.1634387E-04
     +,   5.9344934E-04,   5.7138206E-04,   5.5006210E-04
     +,   5.2942475E-04,   5.0941377E-04,   4.8998505E-04
     +,   4.7110001E-04,   4.5272967E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_ashz_hatt95_mass = Yx/21.3075507647059
      RETURN
      END
C 
C---- New file --- 
C 
      DOUBLE PRECISION FUNCTION A202_tt_haonly_htt100_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.4124610E-04,   1.4955238E-04
     +,   1.5816293E-04,   1.6707470E-04,   1.7628333E-04
     +,   1.8578320E-04,   1.9556725E-04,   2.0562713E-04
     +,   2.1595287E-04,   2.2653352E-04,   2.3735622E-04
     +,   2.4840666E-04,   2.5966924E-04,   2.7112672E-04
     +,   2.8276048E-04,   2.9455041E-04,   3.0647512E-04
     +,   3.1851171E-04,   3.3063602E-04,   3.4282260E-04
     +,   3.5504496E-04,   3.6727541E-04,   3.7948508E-04
     +,   3.9164498E-04,   4.0372403E-04,   4.1569184E-04
     +,   4.2751653E-04,   4.3916624E-04,   4.5060867E-04
     +,   4.6181155E-04,   4.7274239E-04,   4.8336922E-04
     +,   4.9366005E-04,   5.0358375E-04,   5.1310949E-04
     +,   5.2220753E-04,   5.3084880E-04,   5.3900568E-04
     +,   5.4665201E-04,   5.5376225E-04,   5.6031335E-04
     +,   5.6628347E-04,   5.7165296E-04,   5.7640410E-04
     +,   5.8052124E-04,   5.8399118E-04,   5.8680342E-04
     +,   5.8894960E-04,   5.9042446E-04,   5.9122581E-04
     +,   5.9135439E-04,   5.9081468E-04,   5.8961444E-04
     +,   5.8776571E-04,   5.8528478E-04,   5.8219285E-04
     +,   5.7851593E-04,   5.7428650E-04,   5.6954334E-04
     +,   5.6433264E-04,   5.5870909E-04,   5.5273663E-04
     +,   5.4649037E-04,   5.4005731E-04,   5.3353806E-04
     +,   5.2704947E-04,   5.2072527E-04,   5.1471946E-04
     +,   5.0920731E-04,   5.0438911E-04,   5.0049083E-04
     +,   4.9776799E-04,   4.9650739E-04,   4.9702905E-04
     +,   4.9968791E-04,   5.0487579E-04,   5.1302178E-04
     +,   5.2459195E-04,   5.4009003E-04,   5.6005525E-04
     +,   5.8505707E-04,   6.1569636E-04,   6.5259269E-04
     +,   6.9638580E-04,   7.4771675E-04,   8.0722896E-04
     +,   8.7554369E-04,   9.5326093E-04,   1.0409274E-03
     +,   1.1390364E-03,   1.2480061E-03,   1.3681529E-03
     +,   1.4996786E-03,   1.6426631E-03,   1.7970421E-03
     +,   1.9625728E-03,   2.1388594E-03,   2.3252983E-03
     +,   2.5211168E-03,   2.7253220E-03,   2.9367520E-03
     +,   3.1540282E-03,   3.3756206E-03,   3.5998062E-03
     +,   3.8247411E-03,   4.0484606E-03,   4.2688982E-03
     +,   4.4839303E-03,   4.6914280E-03,   4.8892791E-03
     +,   5.0754133E-03,   5.2478821E-03,   5.4048551E-03
     +,   5.5447016E-03,   5.6659817E-03,   5.7675196E-03
     +,   5.8483952E-03,   5.9079947E-03,   5.9460043E-03
     +,   5.9624314E-03,   5.9576049E-03,   5.9321676E-03
     +,   5.8870763E-03,   5.8235726E-03,   5.7431674E-03
     +,   5.6476239E-03,   5.5389074E-03,   5.4191784E-03
     +,   5.2907290E-03,   5.1559764E-03,   5.0173947E-03
     +,   4.8775119E-03,   4.7388356E-03,   4.6038600E-03
     +,   4.4749975E-03,   4.3545575E-03,   4.2447317E-03
     +,   4.1475529E-03,   4.0648631E-03,   3.9982968E-03
     +,   3.9492641E-03,   3.9189178E-03,   3.9081331E-03
     +,   3.9174929E-03,   3.9472636E-03,   3.9973781E-03
     +,   4.0674233E-03,   4.1566156E-03,   4.2637954E-03
     +,   4.3874243E-03,   4.5255804E-03,   4.6759527E-03
     +,   4.8358617E-03,   5.0022937E-03,   5.1719244E-03
     +,   5.3411582E-03,   5.5061956E-03,   5.6631262E-03
     +,   5.8080070E-03,   5.9369691E-03,   6.0463804E-03
     +,   6.1330111E-03,   6.1942386E-03,   6.2283380E-03
     +,   6.2348205E-03,   6.2148441E-03,   6.1716987E-03
     +,   6.1113075E-03,   6.0426742E-03,   5.9781573E-03
     +,   5.9334482E-03,   5.9271273E-03,   5.9798257E-03
     +,   6.1132475E-03,   6.3495585E-03,   6.7120800E-03
     +,   7.2282250E-03,   7.9353992E-03,   8.8898055E-03
     +,   1.0176602E-02,   1.1917896E-02,   1.4274053E-02
     +,   1.7434439E-02,   2.1596380E-02,   2.6935473E-02
     +,   3.3576000E-02,   4.1573945E-02,   5.0921280E-02
     +,   6.1568301E-02,   7.3449701E-02,   8.6493358E-02
     +,   0.1005816    ,   0.1154610    ,   0.1306268    
     +,   0.1452342    ,   0.1581046    ,   0.1678760    
     +,   0.1732933    ,   0.1735547    ,   0.1685856    
     +,   0.1591194    ,   0.1465299    ,   0.1324659    
     +,   0.1184296    ,   0.1054522    ,   9.3964964E-02
     +,   8.3880506E-02,   7.4807137E-02,   6.6289842E-02
     +,   5.7992570E-02,   4.9782883E-02,   4.1725211E-02
     +,   3.4015231E-02,   2.6895678E-02,   2.0583685E-02
     +,   1.5223627E-02,   1.0867646E-02,   7.4804812E-03
     +,   4.9604378E-03,   3.1666190E-03,   1.9447878E-03
     +,   1.1484192E-03,   6.5174932E-04,   3.5534360E-04
     +,   1.8606140E-04,   9.3538059E-05,   4.5143170E-05
     +,   2.0916048E-05,   9.3057361E-06,   3.9784172E-06
     +,   1.6372533E-06,   6.5110083E-07,   2.5231847E-07
     +,   9.7005675E-08,   3.8332214E-08,   1.6486421E-08
     +,   8.2010168E-09,   4.8075623E-09,   3.1964340E-09
     +,   2.2805347E-09,   1.6790941E-09,   1.2505912E-09
     +,   9.3411112E-10,   6.9730655E-10,   5.1953708E-10
     +,   3.8615963E-10,   2.8627997E-10,   2.1166278E-10
     +,   1.5606300E-10,   1.1474889E-10,   8.4134408E-11
     +,   6.1511865E-11,   4.4843483E-11,   3.2598160E-11
     +,   2.3628096E-11,   1.7076356E-11,   1.2305369E-11
     +,   8.8415004E-12,   6.3340852E-12,   4.5243843E-12
     +,   3.2222395E-12,   2.2881263E-12,   1.6200287E-12
     +,   1.1436128E-12,   8.0493289E-13,   5.6488484E-13
     +,   3.9525322E-13,   2.7574739E-13,   1.9181165E-13
     +,   1.3303409E-13,   9.1996743E-14,   6.3432163E-14
     +,   4.3609850E-14,   2.9894805E-14,   2.0433440E-14
     +,   1.3926394E-14,   9.4641380E-15,   6.4133985E-15
     +,   4.3336814E-15,   2.9201700E-15,   1.9622005E-15
     +,   1.3148805E-15,   8.7870377E-16,   5.8565446E-16
     +,   3.8931024E-16,   2.5813141E-16,   1.7072754E-16
     +,   1.1264609E-16,   7.4153036E-17,   4.8706178E-17
     +,   3.1926445E-17,   2.0887563E-17,   1.3642265E-17
     +,   8.8967187E-18,   5.7948225E-18,   3.7707802E-18
     +,   2.4522299E-18,   1.5943481E-18,   1.0368029E-18
     +,   6.7468066E-19,   4.3957582E-19
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_haonly_htt100_mass = Yx/0.820996448275862
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_haonly_htt105_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.6289715E-07,   3.1405762E-07
     +,   3.7443354E-07,   4.4553542E-07,   5.2909297E-07
     +,   6.2708091E-07,   7.4174937E-07,   8.7565547E-07
     +,   1.0316921E-06,   1.2131375E-06,   1.4236795E-06
     +,   1.6674638E-06,   1.9491392E-06,   2.2738986E-06
     +,   2.6475334E-06,   3.0764793E-06,   3.5678663E-06
     +,   4.1295757E-06,   4.7702847E-06,   5.4995253E-06
     +,   6.3277325E-06,   7.2662961E-06,   8.3275891E-06
     +,   9.5251007E-06,   1.0873260E-05,   1.2387771E-05
     +,   1.4085384E-05,   1.5984029E-05,   1.8102806E-05
     +,   2.0461977E-05,   2.3082956E-05,   2.5988269E-05
     +,   2.9201507E-05,   3.2747292E-05,   3.6651134E-05
     +,   4.0939427E-05,   4.5639201E-05,   5.0777999E-05
     +,   5.6384124E-05,   6.2485429E-05,   6.9110385E-05
     +,   7.6286924E-05,   8.4042476E-05,   9.2403789E-05
     +,   1.0139646E-04,   1.1104470E-04,   1.2137100E-04
     +,   1.3239580E-04,   1.4413698E-04,   1.5660979E-04
     +,   1.6982607E-04,   1.8379424E-04,   1.9851852E-04
     +,   2.1399977E-04,   2.3023247E-04,   2.4720799E-04
     +,   2.6491130E-04,   2.8332215E-04,   3.0241458E-04
     +,   3.2215653E-04,   3.4251003E-04,   3.6343109E-04
     +,   3.8486833E-04,   4.0676570E-04,   4.2906133E-04
     +,   4.5168513E-04,   4.7456418E-04,   4.9761741E-04
     +,   5.2076153E-04,   5.4390583E-04,   5.6695839E-04
     +,   5.8982096E-04,   6.1239552E-04,   6.3457835E-04
     +,   6.5626734E-04,   6.7735912E-04,   6.9774914E-04
     +,   7.1733427E-04,   7.3601451E-04,   7.5369200E-04
     +,   7.7027164E-04,   7.8566460E-04,   7.9978531E-04
     +,   8.1255671E-04,   8.2390697E-04,   8.3377369E-04
     +,   8.4210164E-04,   8.4884634E-04,   8.5397233E-04
     +,   8.5745583E-04,   8.5928402E-04,   8.5945666E-04
     +,   8.5798599E-04,   8.5489836E-04,   8.5023406E-04
     +,   8.4404933E-04,   8.3641615E-04,   8.2742487E-04
     +,   8.1718352E-04,   8.0582168E-04,   7.9348986E-04
     +,   7.8036421E-04,   7.6664530E-04,   7.5256522E-04
     +,   7.3838572E-04,   7.2440365E-04,   7.1095472E-04
     +,   6.9841620E-04,   6.8720902E-04,   6.7780219E-04
     +,   6.7071663E-04,   6.6652527E-04,   6.6585693E-04
     +,   6.6939584E-04,   6.7788071E-04,   6.9210428E-04
     +,   7.1290607E-04,   7.4117008E-04,   7.7781011E-04
     +,   8.2376302E-04,   8.7997277E-04,   9.4736693E-04
     +,   1.0268373E-03,   1.1192197E-03,   1.2252647E-03
     +,   1.3455930E-03,   1.4806892E-03,   1.6308364E-03
     +,   1.7961175E-03,   1.9763440E-03,   2.1710685E-03
     +,   2.3795106E-03,   2.6005884E-03,   2.8328488E-03
     +,   3.0745133E-03,   3.3234586E-03,   3.5772179E-03
     +,   3.8330199E-03,   4.0878444E-03,   4.3384540E-03
     +,   4.5814379E-03,   4.8132995E-03,   5.0305435E-03
     +,   5.2297460E-03,   5.4076184E-03,   5.5611324E-03
     +,   5.6875790E-03,   5.7846387E-03,   5.8504594E-03
     +,   5.8837146E-03,   5.8836327E-03,   5.8500264E-03
     +,   5.7833041E-03,   5.6844554E-03,   5.5550202E-03
     +,   5.3970609E-03,   5.2130981E-03,   5.0060283E-03
     +,   4.7790515E-03,   4.5356136E-03,   4.2792717E-03
     +,   4.0136306E-03,   3.7422713E-03,   3.4686662E-03
     +,   3.1960928E-03,   2.9276060E-03,   2.6660308E-03
     +,   2.4139436E-03,   2.1736964E-03,   1.9475099E-03
     +,   1.7376132E-03,   1.5463959E-03,   1.3766069E-03
     +,   1.2316013E-03,   1.1155749E-03,   1.0337096E-03
     +,   9.9228183E-04,   9.9864579E-04,   1.0611275E-03
     +,   1.1889517E-03,   1.3923639E-03,   1.6831917E-03
     +,   2.0761811E-03,   2.5913522E-03,   3.2572786E-03
     +,   4.1147931E-03,   5.2201222E-03,   6.6457991E-03
     +,   8.4774001E-03,   1.0805053E-02,   1.3711482E-02
     +,   1.7259091E-02,   2.1481996E-02,   2.6388619E-02
     +,   3.1975992E-02,   3.8248666E-02,   4.5230418E-02
     +,   5.2955158E-02,   6.1430272E-02,   7.0579380E-02
     +,   8.0188997E-02,   8.9889154E-02,   9.9183328E-02
     +,   0.1075186    ,   0.1143677    ,   0.1192928    
     +,   0.1219691    ,   0.1221818    ,   0.1198214    
     +,   0.1148928    ,   0.1075430    ,   9.8087654E-02
     +,   8.7015063E-02,   7.4951679E-02,   6.2594578E-02
     +,   5.0624505E-02,   3.9619248E-02,   2.9989673E-02
     +,   2.1953074E-02,   1.5543266E-02,   1.0647222E-02
     +,   7.0585539E-03,   4.5298785E-03,   2.8142256E-03
     +,   1.6919614E-03,   9.8373613E-04,   5.5256311E-04
     +,   2.9945560E-04,   1.5633485E-04,   7.8492849E-05
     +,   3.7839684E-05,   1.7487682E-05,   7.7364075E-06
     +,   3.2718160E-06,   1.3213232E-06,   5.0905538E-07
     +,   1.8693345E-07,   6.5387518E-08,   2.1775444E-08
     +,   6.9007982E-09,   2.0803395E-09,   5.9648858E-10
     +,   1.6267843E-10,   4.2221841E-11,   1.0449916E-11
     +,   2.4840093E-12,   5.8055736E-13,   1.4329983E-13
     +,   4.3912136E-14,   1.9506869E-14,   1.1717511E-14
     +,   8.0290939E-15,   5.7256086E-15,   4.1236520E-15
     +,   2.9750336E-15,   2.1453608E-15,   1.5453387E-15
     +,   1.1115950E-15,   7.9835343E-16,   5.7242058E-16
     +,   4.0970949E-16,   2.9272310E-16,   2.0875257E-16
     +,   1.4858792E-16,   1.0556251E-16,   7.4850879E-17
     +,   5.2970833E-17,   3.7413459E-17,   2.6373860E-17
     +,   1.8555233E-17,   1.3028655E-17,   9.1301326E-18
     +,   6.3856565E-18,   4.4573363E-18,   3.1051525E-18
     +,   2.1589265E-18,   1.4980683E-18,   1.0374626E-18
     +,   7.1705144E-19,   4.9462397E-19,   3.4051552E-19
     +,   2.3396207E-19,   1.6043258E-19,   1.0979601E-19
     +,   7.4992427E-20,   5.1120298E-20,   3.4778660E-20
     +,   2.3614069E-20,   1.6002050E-20,   1.0822244E-20
     +,   7.3047294E-21,   4.9207290E-21,   3.3082747E-21
     +,   2.2197913E-21,   1.4865104E-21,   9.9348330E-22
     +,   6.6267916E-22,   4.4114319E-22,   2.9309227E-22
     +,   1.9434168E-22,   1.2860987E-22
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_haonly_htt105_mass = Yx/0.553958192307692
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_haonly_htt107_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   2.1050193E-38
     +,   6.6783654E-38,   2.1011935E-37,   6.5559720E-37
     +,   2.0285381E-36,   6.2245002E-36,   1.8940768E-35
     +,   5.7156530E-35,   1.7104453E-34,   5.0760711E-34
     +,   1.4938880E-33,   4.3599699E-33,   1.2618976E-32
     +,   3.6219282E-32,   1.0309258E-31,   2.9099363E-31
     +,   8.1457216E-31,   2.2611670E-30,   6.2247094E-30
     +,   1.6993350E-29,   4.6005952E-29,   1.2351582E-28
     +,   3.2885639E-28,   8.6828722E-28,   2.2735041E-27
     +,   5.9033901E-27,   1.5201360E-26,   3.8818326E-26
     +,   9.8302903E-26,   2.4687059E-25,   6.1480994E-25
     +,   1.5184452E-24,   3.7189404E-24,   9.0327043E-24
     +,   2.1756708E-23,   5.1968923E-23,   1.2310274E-22
     +,   2.8917684E-22,   6.7365278E-22,   1.5562662E-21
     +,   3.5653601E-21,   8.1002752E-21,   1.8250212E-20
     +,   4.0776779E-20,   9.0350321E-20,   1.9852567E-19
     +,   4.3260217E-19,   9.3481191E-19,   2.0032722E-18
     +,   4.2572331E-18,   8.9720509E-18,   1.8751222E-17
     +,   3.8863622E-17,   7.9878456E-17,   1.6281565E-16
     +,   3.2909874E-16,   6.5967582E-16,   1.3113515E-15
     +,   2.5850738E-15,   5.0536980E-15,   9.7974200E-15
     +,   1.8836420E-14,   3.5912811E-14,   6.7902193E-14
     +,   1.2731567E-13,   2.3673630E-13,   4.3652904E-13
     +,   7.9824558E-13,   1.4475771E-12,   2.6032820E-12
     +,   4.6426587E-12,   8.2108374E-12,   1.4400908E-11
     +,   2.5047204E-11,   4.3202657E-11,   7.3897152E-11
     +,   1.2535097E-10,   2.1086018E-10,   3.5175760E-10
     +,   5.8191429E-10,   9.5467734E-10,   1.5531806E-09
     +,   2.5058911E-09,   4.0094461E-09,   6.3618288E-09
     +,   1.0010321E-08,   1.5620325E-08,   2.4172168E-08
     +,   3.7094679E-08,   5.6453615E-08,   8.5200980E-08
     +,   1.2752152E-07,   1.8927720E-07,   2.7861415E-07
     +,   4.0671353E-07,   5.8880079E-07,   8.4534980E-07
     +,   1.2036566E-06,   1.6997193E-06,   2.3804673E-06
     +,   3.3064466E-06,   4.5550132E-06,   6.2239119E-06
     +,   8.4350731E-06,   1.1339426E-05,   1.5121081E-05
     +,   2.0003055E-05,   2.6251339E-05,   3.4181357E-05
     +,   4.4161217E-05,   5.6618464E-05,   7.2041767E-05
     +,   9.0987538E-05,   1.1408269E-04,   1.4202637E-04
     +,   1.7559386E-04,   2.1564313E-04,   2.6311810E-04
     +,   3.1904900E-04,   3.8457062E-04,   4.6091678E-04
     +,   5.4944732E-04,   6.5163895E-04,   7.6911796E-04
     +,   9.0364041E-04,   1.0571243E-03,   1.2316052E-03
     +,   1.4292465E-03,   1.6522885E-03,   1.9029664E-03
     +,   2.1834315E-03,   2.4956539E-03,   2.8412635E-03
     +,   3.2213589E-03,   3.6363346E-03,   4.0857228E-03
     +,   4.5679891E-03,   5.0803199E-03,   5.6186044E-03
     +,   6.1773327E-03,   6.7495815E-03,   7.3271520E-03
     +,   7.9008108E-03,   8.4605319E-03,   8.9958245E-03
     +,   9.4961841E-03,   9.9515719E-03,   1.0352814E-02
     +,   1.0691985E-02,   1.0962784E-02,   1.1160806E-02
     +,   1.1283642E-02,   1.1330923E-02,   1.1304240E-02
     +,   1.1206953E-02,   1.1043930E-02,   1.0821237E-02
     +,   1.0545772E-02,   1.0224926E-02,   9.8663038E-03
     +,   9.4774216E-03,   9.0654735E-03,   8.6371889E-03
     +,   8.1987558E-03,   7.7557522E-03,   7.3130936E-03
     +,   6.8750856E-03,   6.4455117E-03,   6.0276194E-03
     +,   5.6242575E-03,   5.2380539E-03,   4.8715803E-03
     +,   4.5276107E-03,   4.2095040E-03,   3.9216443E-03
     +,   3.6698603E-03,   3.4618066E-03,   3.3072734E-03
     +,   3.2183344E-03,   3.2093911E-03,   3.2972908E-03
     +,   3.5016669E-03,   3.8453687E-03,   4.3547018E-03
     +,   5.0586443E-03,   5.9865071E-03,   7.1648317E-03
     +,   8.6161904E-03,   1.0363789E-02,   1.2445281E-02
     +,   1.4935607E-02,   1.7973093E-02,   2.1780780E-02
     +,   2.6677560E-02,   3.3076685E-02,   4.1461390E-02
     +,   5.2310284E-02,   6.5939277E-02,   8.2265131E-02
     +,   0.1005561    ,   0.1193098    ,   0.1363908    
     +,   0.1494475    ,   0.1564812    ,   0.1563574    
     +,   0.1490732    ,   0.1357036    ,   0.1180817    
     +,   9.8345794E-02,   7.8500204E-02,   6.0105260E-02
     +,   4.4150010E-02,   3.1082921E-02,   2.0928750E-02
     +,   1.3433216E-02,   8.1866616E-03,   4.7170618E-03
     +,   2.5589170E-03,   1.3020250E-03,   6.1943819E-04
     +,   2.7487928E-04,   1.1359138E-04,   4.3692296E-05
     +,   1.5668602E-05,   5.2702717E-06,   1.6897717E-06
     +,   5.3701910E-07,   1.8305727E-07,   7.4214384E-08
     +,   3.7296850E-08,   2.1836639E-08,   1.3700681E-08
     +,   8.7763201E-09,   5.6291283E-09,   3.5918211E-09
     +,   2.2756248E-09,   1.4307462E-09,   8.9255997E-10
     +,   5.5248106E-10,   3.3931868E-10,   2.0677628E-10
     +,   1.2502267E-10,   7.5004405E-11,   4.4646446E-11
     +,   2.6368276E-11,   1.5451812E-11,   8.9843324E-12
     +,   5.1831768E-12,   2.9668806E-12,   1.6850243E-12
     +,   9.4956248E-13,   5.3093695E-13,   2.9454810E-13
     +,   1.6213308E-13,   8.8551792E-14,   4.7987273E-14
     +,   2.5801716E-14,   1.3765166E-14,   7.2864722E-15
     +,   3.8268915E-15,   1.9942423E-15,   1.0311477E-15
     +,   5.2901252E-16,   2.6928046E-16,   1.3600165E-16
     +,   6.8154925E-17,   3.3888442E-17,   1.6718530E-17
     +,   8.1838768E-18,   3.9747571E-18,   1.9154647E-18
     +,   9.1586523E-19,   4.3451125E-19,   2.0453186E-19
     +,   9.5528859E-20,   4.4269071E-20,   2.0355336E-20
     +,   9.2864546E-21,   4.2037028E-21,   1.8880688E-21
     +,   8.4138384E-22,   3.7203531E-22,   1.6321737E-22
     +,   7.1049698E-23,   3.0686475E-23,   1.3150696E-23
     +,   5.5916204E-24,   2.3590765E-24,   9.8749943E-25
     +,   4.1015405E-25,   1.6902375E-25,   6.9113373E-26
     +,   2.8039180E-26,   1.1287141E-26
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_haonly_htt107_mass = Yx/0.553958192307692
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_haonly_htt110_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  5.2080672E-05,   5.7408084E-05
     +,   6.3188352E-05,   6.9449547E-05,   7.6220262E-05
     +,   8.3529681E-05,   9.1407361E-05,   9.9883080E-05
     +,   1.0898660E-04,   1.1874801E-04,   1.2919687E-04
     +,   1.4036224E-04,   1.5227273E-04,   1.6495584E-04
     +,   1.7843822E-04,   1.9274505E-04,   2.0789995E-04
     +,   2.2392465E-04,   2.4083878E-04,   2.5865951E-04
     +,   2.7740153E-04,   2.9707636E-04,   3.1769209E-04
     +,   3.3925459E-04,   3.6176373E-04,   3.8521769E-04
     +,   4.0960906E-04,   4.3492645E-04,   4.6115354E-04
     +,   4.8826929E-04,   5.1624788E-04,   5.4505805E-04
     +,   5.7466351E-04,   6.0502271E-04,   6.3608855E-04
     +,   6.6780881E-04,   7.0012605E-04,   7.3297700E-04
     +,   7.6629547E-04,   8.0000667E-04,   8.3403505E-04
     +,   8.6829829E-04,   9.0271060E-04,   9.3718217E-04
     +,   9.7162026E-04,   1.0059290E-03,   1.0400098E-03
     +,   1.0737622E-03,   1.1070846E-03,   1.1398739E-03
     +,   1.1720270E-03,   1.2034411E-03,   1.2340136E-03
     +,   1.2636454E-03,   1.2922364E-03,   1.3196925E-03
     +,   1.3459207E-03,   1.3708333E-03,   1.3943467E-03
     +,   1.4163824E-03,   1.4368681E-03,   1.4557381E-03
     +,   1.4729317E-03,   1.4883976E-03,   1.5020919E-03
     +,   1.5139771E-03,   1.5240256E-03,   1.5322173E-03
     +,   1.5385416E-03,   1.5429964E-03,   1.5455885E-03
     +,   1.5463334E-03,   1.5452555E-03,   1.5423885E-03
     +,   1.5377734E-03,   1.5314601E-03,   1.5235065E-03
     +,   1.5139779E-03,   1.5029464E-03,   1.4904902E-03
     +,   1.4766947E-03,   1.4616495E-03,   1.4454502E-03
     +,   1.4281950E-03,   1.4099876E-03,   1.3909318E-03
     +,   1.3711363E-03,   1.3507085E-03,   1.3297589E-03
     +,   1.3083956E-03,   1.2867261E-03,   1.2648578E-03
     +,   1.2428957E-03,   1.2209399E-03,   1.1990882E-03
     +,   1.1774350E-03,   1.1560682E-03,   1.1350728E-03
     +,   1.1145258E-03,   1.0945004E-03,   1.0750615E-03
     +,   1.0562694E-03,   1.0381752E-03,   1.0208257E-03
     +,   1.0042591E-03,   9.8850625E-04,   9.7359292E-04
     +,   9.5953763E-04,   9.4635232E-04,   9.3404262E-04
     +,   9.2261005E-04,   9.1205025E-04,   9.0235635E-04
     +,   8.9351612E-04,   8.8551745E-04,   8.7834580E-04
     +,   8.7198749E-04,   8.6643017E-04,   8.6166529E-04
     +,   8.5768843E-04,   8.5450261E-04,   8.5211959E-04
     +,   8.5056172E-04,   8.4986479E-04,   8.5008016E-04
     +,   8.5127656E-04,   8.5354369E-04,   8.5699320E-04
     +,   8.6176203E-04,   8.6801365E-04,   8.7594154E-04
     +,   8.8576786E-04,   8.9774857E-04,   9.1216952E-04
     +,   9.2935091E-04,   9.4964477E-04,   9.7343279E-04
     +,   1.0011242E-03,   1.0331556E-03,   1.0699851E-03
     +,   1.1120854E-03,   1.1599384E-03,   1.2140330E-03
     +,   1.2748548E-03,   1.3428698E-03,   1.4185287E-03
     +,   1.5022508E-03,   1.5944100E-03,   1.6953261E-03
     +,   1.8052651E-03,   1.9244216E-03,   2.0529046E-03
     +,   2.1907317E-03,   2.3378343E-03,   2.4940423E-03
     +,   2.6590663E-03,   2.8325024E-03,   3.0138365E-03
     +,   3.2024330E-03,   3.3975060E-03,   3.5981520E-03
     +,   3.8033293E-03,   4.0118350E-03,   4.2223153E-03
     +,   4.4332827E-03,   4.6430998E-03,   4.8499857E-03
     +,   5.0520482E-03,   5.2473396E-03,   5.4338994E-03
     +,   5.6098206E-03,   5.7733660E-03,   5.9231026E-03
     +,   6.0580322E-03,   6.1777248E-03,   6.2825084E-03
     +,   6.3735829E-03,   6.4531211E-03,   6.5243333E-03
     +,   6.5914621E-03,   6.6596847E-03,   6.7349579E-03
     +,   6.8237945E-03,   6.9330153E-03,   7.0694974E-03
     +,   7.2399820E-03,   7.4510206E-03,   7.7091204E-03
     +,   8.0211041E-03,   8.3947051E-03,   8.8395188E-03
     +,   9.3680834E-03,   9.9971192E-03,   1.0748857E-02
     +,   1.1652317E-02,   1.2744301E-02,   1.4069945E-02
     +,   1.5682697E-02,   1.7643539E-02,   2.0018736E-02
     +,   2.2875771E-02,   2.6277445E-02,   3.0273817E-02
     +,   3.4891456E-02,   4.0120643E-02,   4.5903668E-02
     +,   5.2123465E-02,   5.8596384E-02,   6.5072708E-02
     +,   7.1246140E-02,   7.6772548E-02,   8.1297733E-02
     +,   8.4492788E-02,   8.6090773E-02,   8.5919365E-02
     +,   8.3924755E-02,   8.0182314E-02,   7.4890807E-02
     +,   6.8352029E-02,   6.0939148E-02,   5.3056281E-02
     +,   4.5099080E-02,   3.7420280E-02,   3.0303234E-02
     +,   2.3947205E-02,   1.8465171E-02,   1.3891475E-02
     +,   1.0195559E-02,   7.2997673E-03,   5.0981548E-03
     +,   3.4730243E-03,   2.3077289E-03,   1.4956525E-03
     +,   9.4545662E-04,   5.8297679E-04,   3.5067354E-04
     +,   2.0582143E-04,   1.1792674E-04,   6.6012806E-05
     +,   3.6154994E-05,   1.9425644E-05,   1.0287742E-05
     +,   5.4154020E-06,   2.8732213E-06,   1.5697003E-06
     +,   9.0769510E-07,   5.7003012E-07,   3.9307045E-07
     +,   2.9474114E-07,   2.3493206E-07,   1.9446701E-07
     +,   1.6432197E-07,   1.4025908E-07,   1.2024093E-07
     +,   1.0322283E-07,   8.8608303E-08,   7.6007410E-08
     +,   6.5131012E-08,   5.5745215E-08,   4.7652701E-08
     +,   4.0683481E-08,   3.4689414E-08,   2.9540558E-08
     +,   2.5123569E-08,   2.1339666E-08,   1.8102389E-08
     +,   1.5336393E-08,   1.2976317E-08,   1.0965370E-08
     +,   9.2541441E-09,   7.7998692E-09,   6.5656822E-09
     +,   5.5196989E-09,   4.6343867E-09,   3.8860390E-09
     +,   3.2543592E-09,   2.7218319E-09,   2.2735334E-09
     +,   1.8966178E-09,   1.5801606E-09,   1.3148026E-09
     +,   1.0926064E-09,   9.0678609E-10,   7.5160511E-10
     +,   6.2217498E-10,   5.1437310E-10,   4.2470347E-10
     +,   3.5021147E-10,   2.8841615E-10,   2.3721705E-10
     +,   1.9485717E-10,   1.5985434E-10,   1.3097134E-10
     +,   1.0716824E-10,   8.7578923E-11,   7.1477789E-11
     +,   5.8262076E-11,   4.7428481E-11,   3.8559819E-11
     +,   3.1308994E-11,   2.5389107E-11
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_haonly_htt110_mass = Yx/0.45854172
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_haonly_htt115_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.5250860E-04,   1.6283903E-04
     +,   1.7370365E-04,   1.8511905E-04,   1.9710185E-04
     +,   2.0966858E-04,   2.2283573E-04,   2.3661989E-04
     +,   2.5103730E-04,   2.6610485E-04,   2.8183879E-04
     +,   2.9825533E-04,   3.1537097E-04,   3.3320190E-04
     +,   3.5176441E-04,   3.7107460E-04,   3.9114867E-04
     +,   4.1200244E-04,   4.3365205E-04,   4.5611290E-04
     +,   4.7940071E-04,   5.0353061E-04,   5.2851724E-04
     +,   5.5437617E-04,   5.8111991E-04,   6.0876308E-04
     +,   6.3731783E-04,   6.6679606E-04,   6.9720834E-04
     +,   7.2856445E-04,   7.6087221E-04,   7.9413812E-04
     +,   8.2836684E-04,   8.6356053E-04,   8.9971942E-04
     +,   9.3684078E-04,   9.7491941E-04,   1.0139456E-03
     +,   1.0539094E-03,   1.0947920E-03,   1.1365762E-03
     +,   1.1792373E-03,   1.2227471E-03,   1.2670736E-03
     +,   1.3121797E-03,   1.3580251E-03,   1.4045641E-03
     +,   1.4517488E-03,   1.4995255E-03,   1.5478394E-03
     +,   1.5966330E-03,   1.6458464E-03,   1.6954191E-03
     +,   1.7452943E-03,   1.7954110E-03,   1.8457164E-03
     +,   1.8961603E-03,   1.9466992E-03,   1.9972986E-03
     +,   2.0479325E-03,   2.0985892E-03,   2.1492711E-03
     +,   2.1999932E-03,   2.2507936E-03,   2.3017297E-03
     +,   2.3528775E-03,   2.4043405E-03,   2.4562427E-03
     +,   2.5087378E-03,   2.5619990E-03,   2.6162339E-03
     +,   2.6716660E-03,   2.7285505E-03,   2.7871574E-03
     +,   2.8477816E-03,   2.9107342E-03,   2.9763354E-03
     +,   3.0449112E-03,   3.1167965E-03,   3.1923207E-03
     +,   3.2717979E-03,   3.3555345E-03,   3.4438022E-03
     +,   3.5368509E-03,   3.6348819E-03,   3.7380585E-03
     +,   3.8464805E-03,   3.9601983E-03,   4.0791794E-03
     +,   4.2033317E-03,   4.3324842E-03,   4.4663753E-03
     +,   4.6046651E-03,   4.7469325E-03,   4.8926780E-03
     +,   5.0413064E-03,   5.1921657E-03,   5.3445157E-03
     +,   5.4975748E-03,   5.6504901E-03,   5.8023883E-03
     +,   5.9523508E-03,   6.0994653E-03,   6.2428075E-03
     +,   6.3814856E-03,   6.5146480E-03,   6.6414909E-03
     +,   6.7612845E-03,   6.8734041E-03,   6.9773295E-03
     +,   7.0726611E-03,   7.1591479E-03,   7.2366833E-03
     +,   7.3053329E-03,   7.3653255E-03,   7.4170679E-03
     +,   7.4611390E-03,   7.4982941E-03,   7.5294459E-03
     +,   7.5556668E-03,   7.5781653E-03,   7.5982637E-03
     +,   7.6173781E-03,   7.6369946E-03,   7.6586273E-03
     +,   7.6837894E-03,   7.7139582E-03,   7.7505289E-03
     +,   7.7947793E-03,   7.8478260E-03,   7.9105925E-03
     +,   7.9837581E-03,   8.0677420E-03,   8.1626531E-03
     +,   8.2682902E-03,   8.3841113E-03,   8.5092261E-03
     +,   8.6423922E-03,   8.7820459E-03,   8.9263096E-03
     +,   9.0730106E-03,   9.2197368E-03,   9.3638934E-03
     +,   9.5027508E-03,   9.6335029E-03,   9.7533586E-03
     +,   9.8596038E-03,   9.9496758E-03,   1.0021243E-02
     +,   1.0072280E-02,   1.0101122E-02,   1.0106523E-02
     +,   1.0087701E-02,   1.0044373E-02,   9.9767651E-03
     +,   9.8856119E-03,   9.7721545E-03,   9.6380962E-03
     +,   9.4855623E-03,   9.3170637E-03,   9.1354093E-03
     +,   8.9436425E-03,   8.7449998E-03,   8.5428115E-03
     +,   8.3404351E-03,   8.1412243E-03,   7.9484843E-03
     +,   7.7654435E-03,   7.5952229E-03,   7.4408650E-03
     +,   7.3053432E-03,   7.1915993E-03,   7.1025598E-03
     +,   7.0411908E-03,   7.0105456E-03,   7.0137745E-03
     +,   7.0541608E-03,   7.1351058E-03,   7.2601116E-03
     +,   7.4327434E-03,   7.6565533E-03,   7.9349792E-03
     +,   8.2712192E-03,   8.6681470E-03,   9.1281394E-03
     +,   9.6529061E-03,   1.0243374E-02,   1.0899571E-02
     +,   1.1620508E-02,   1.2403997E-02,   1.3246690E-02
     +,   1.4143989E-02,   1.5089949E-02,   1.6077308E-02
     +,   1.7097592E-02,   1.8141106E-02,   1.9196888E-02
     +,   2.0252917E-02,   2.1296266E-02,   2.2313165E-02
     +,   2.3289155E-02,   2.4209326E-02,   2.5058664E-02
     +,   2.5822246E-02,   2.6485521E-02,   2.7034795E-02
     +,   2.7457554E-02,   2.7742798E-02,   2.7881511E-02
     +,   2.7866984E-02,   2.7695112E-02,   2.7364666E-02
     +,   2.6877442E-02,   2.6238302E-02,   2.5455132E-02
     +,   2.4538752E-02,   2.3502607E-02,   2.2362327E-02
     +,   2.1135351E-02,   1.9840507E-02,   1.8497245E-02
     +,   1.7125186E-02,   1.5743639E-02,   1.4371018E-02
     +,   1.3024270E-02,   1.1718593E-02,   1.0467233E-02
     +,   9.2811771E-03,   8.1689777E-03,   7.1368432E-03
     +,   6.1887624E-03,   5.3265719E-03,   4.5501138E-03
     +,   3.8575546E-03,   3.2457137E-03,   2.7102118E-03
     +,   2.2458374E-03,   1.8468357E-03,   1.5071171E-03
     +,   1.2204594E-03,   9.8072202E-04,   7.8200619E-04
     +,   6.1874563E-04,   4.8578213E-04,   3.7843231E-04
     +,   2.9251553E-04,   2.2434768E-04,   1.7072479E-04
     +,   1.2890330E-04,   9.6566531E-05,   7.1775321E-05
     +,   5.2929783E-05,   3.8725851E-05,   2.8111072E-05
     +,   2.0245152E-05,   1.4465136E-05,   1.0253742E-05
     +,   7.2111125E-06,   5.0312210E-06,   3.4824675E-06
     +,   2.3913610E-06,   1.6291086E-06,   1.1010161E-06
     +,   7.3818927E-07,   4.9099930E-07,   3.2398518E-07
     +,   2.1207640E-07,   1.3771653E-07,   8.8717883E-08
     +,   5.6696940E-08,   3.5943746E-08,   2.2605121E-08
     +,   1.4103140E-08,   8.7285557E-09,   5.3589351E-09
     +,   3.2638987E-09,   1.9719768E-09,   1.1819177E-09
     +,   7.0271311E-10,   4.1446466E-10,   2.4249378E-10
     +,   1.4074436E-10,   8.1033229E-11,   4.6281940E-11
     +,   2.6221643E-11,   1.4737505E-11,   8.2166409E-12
     +,   4.5442560E-12,   2.4931253E-12,   1.3568206E-12
     +,   7.3250883E-13,   3.9228140E-13,   2.0839831E-13
     +,   1.0982040E-13,   5.7409223E-14,   2.9769518E-14
     +,   1.5313371E-14,   7.8137451E-15,   3.9550869E-15
     +,   1.9858209E-15,   9.8908249E-16
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_haonly_htt115_mass = Yx/0.41641075
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_haonly_htt120_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.9880041E-05,   3.3491720E-05
     +,   3.7474867E-05,   4.1859104E-05,   4.6675428E-05
     +,   5.1956122E-05,   5.7734658E-05,   6.4045635E-05
     +,   7.0924572E-05,   7.8408186E-05,   8.6533633E-05
     +,   9.5338757E-05,   1.0486181E-04,   1.1514138E-04
     +,   1.2621589E-04,   1.3812372E-04,   1.5090276E-04
     +,   1.6459028E-04,   1.7922260E-04,   1.9483492E-04
     +,   2.1146095E-04,   2.2913273E-04,   2.4788009E-04
     +,   2.6773193E-04,   2.8871244E-04,   3.1084550E-04
     +,   3.3415062E-04,   3.5864493E-04,   3.8434178E-04
     +,   4.1125153E-04,   4.3938079E-04,   4.6873256E-04
     +,   4.9930601E-04,   5.3109659E-04,   5.6409580E-04
     +,   5.9829117E-04,   6.3366670E-04,   6.7020161E-04
     +,   7.0787373E-04,   7.4665336E-04,   7.8651088E-04
     +,   8.2741096E-04,   8.6931518E-04,   9.1218221E-04
     +,   9.5596700E-04,   1.0006212E-03,   1.0460940E-03
     +,   1.0923310E-03,   1.1392750E-03,   1.1868662E-03
     +,   1.2350417E-03,   1.2837360E-03,   1.3328798E-03
     +,   1.3824052E-03,   1.4322355E-03,   1.4822977E-03
     +,   1.5325125E-03,   1.5828002E-03,   1.6330788E-03
     +,   1.6832643E-03,   1.7332720E-03,   1.7830160E-03
     +,   1.8324077E-03,   1.8813618E-03,   1.9297926E-03
     +,   1.9776123E-03,   2.0247397E-03,   2.0710900E-03
     +,   2.1165877E-03,   2.1611557E-03,   2.2047262E-03
     +,   2.2472320E-03,   2.2886172E-03,   2.3288266E-03
     +,   2.3678169E-03,   2.4055515E-03,   2.4420000E-03
     +,   2.4771402E-03,   2.5109593E-03,   2.5434524E-03
     +,   2.5746196E-03,   2.6044706E-03,   2.6330180E-03
     +,   2.6602831E-03,   2.6862870E-03,   2.7110579E-03
     +,   2.7346206E-03,   2.7570054E-03,   2.7782379E-03
     +,   2.7983433E-03,   2.8173453E-03,   2.8352628E-03
     +,   2.8521118E-03,   2.8679059E-03,   2.8826557E-03
     +,   2.8963715E-03,   2.9090634E-03,   2.9207447E-03
     +,   2.9314347E-03,   2.9411633E-03,   2.9499724E-03
     +,   2.9579222E-03,   2.9650955E-03,   2.9716026E-03
     +,   2.9775857E-03,   2.9832260E-03,   2.9887443E-03
     +,   2.9944091E-03,   3.0005367E-03,   3.0074969E-03
     +,   3.0157124E-03,   3.0256584E-03,   3.0378634E-03
     +,   3.0529052E-03,   3.0714052E-03,   3.0940254E-03
     +,   3.1214585E-03,   3.1544177E-03,   3.1936257E-03
     +,   3.2398037E-03,   3.2936584E-03,   3.3558628E-03
     +,   3.4270405E-03,   3.5077573E-03,   3.5985024E-03
     +,   3.6996601E-03,   3.8115203E-03,   3.9342367E-03
     +,   4.0678433E-03,   4.2122141E-03,   4.3670926E-03
     +,   4.5320438E-03,   4.7064982E-03,   4.8897085E-03
     +,   5.0807926E-03,   5.2787215E-03,   5.4823249E-03
     +,   5.6903055E-03,   5.9012757E-03,   6.1137611E-03
     +,   6.3262023E-03,   6.5369890E-03,   6.7445021E-03
     +,   6.9471095E-03,   7.1431776E-03,   7.3311245E-03
     +,   7.5094230E-03,   7.6766028E-03,   7.8312866E-03
     +,   7.9722069E-03,   8.0982149E-03,   8.2082748E-03
     +,   8.3014928E-03,   8.3771273E-03,   8.4345862E-03
     +,   8.4734326E-03,   8.4933955E-03,   8.4943734E-03
     +,   8.4764352E-03,   8.4398258E-03,   8.3849654E-03
     +,   8.3124451E-03,   8.2230456E-03,   8.1177149E-03
     +,   7.9975678E-03,   7.8638792E-03,   7.7180830E-03
     +,   7.5617563E-03,   7.3965876E-03,   7.2243679E-03
     +,   7.0469799E-03,   6.8663601E-03,   6.6844583E-03
     +,   6.5032165E-03,   6.3245571E-03,   6.1503155E-03
     +,   5.9822183E-03,   5.8218716E-03,   5.6707109E-03
     +,   5.5299732E-03,   5.4006814E-03,   5.2836346E-03
     +,   5.1793884E-03,   5.0882408E-03,   5.0102351E-03
     +,   4.9451804E-03,   4.8926426E-03,   4.8519662E-03
     +,   4.8222952E-03,   4.8026000E-03,   4.7917007E-03
     +,   4.7882963E-03,   4.7909967E-03,   4.7983555E-03
     +,   4.8088976E-03,   4.8211492E-03,   4.8336657E-03
     +,   4.8450567E-03,   4.8540086E-03,   4.8593031E-03
     +,   4.8598326E-03,   4.8546111E-03,   4.8427870E-03
     +,   4.8236423E-03,   4.7966023E-03,   4.7612293E-03
     +,   4.7172201E-03,   4.6644094E-03,   4.6027550E-03
     +,   4.5323297E-03,   4.4533154E-03,   4.3659969E-03
     +,   4.2707492E-03,   4.1680206E-03,   4.0583261E-03
     +,   3.9422465E-03,   3.8204107E-03,   3.6934782E-03
     +,   3.5621349E-03,   3.4271015E-03,   3.2890940E-03
     +,   3.1488335E-03,   3.0070432E-03,   2.8644348E-03
     +,   2.7216927E-03,   2.5794760E-03,   2.4384237E-03
     +,   2.2991393E-03,   2.1621780E-03,   2.0280527E-03
     +,   1.8972394E-03,   1.7701659E-03,   1.6472014E-03
     +,   1.5286655E-03,   1.4148384E-03,   1.3059372E-03
     +,   1.2021303E-03,   1.1035448E-03,   1.0102601E-03
     +,   9.2230545E-04,   8.3966961E-04,   7.6230831E-04
     +,   6.9014233E-04,   6.2305579E-04,   5.6090608E-04
     +,   5.0353084E-04,   4.5074726E-04,   4.0235245E-04
     +,   3.5813122E-04,   3.1786322E-04,   2.8131780E-04
     +,   2.4826112E-04,   2.1846117E-04,   1.9168766E-04
     +,   1.6771215E-04,   1.4631264E-04,   1.2727591E-04
     +,   1.1039730E-04,   9.5480573E-05,   8.2340295E-05
     +,   7.0802947E-05,   6.0706141E-05,   5.1898285E-05
     +,   4.4239354E-05,   3.7601338E-05,   3.1866406E-05
     +,   2.6927408E-05,   2.2687602E-05,   1.9059706E-05
     +,   1.5965186E-05,   1.3333923E-05,   1.1103736E-05
     +,   9.2195332E-06,   7.6326105E-06,   6.3002444E-06
     +,   5.1852080E-06,   4.2549250E-06,   3.4812790E-06
     +,   2.8398790E-06,   2.3098246E-06,   1.8731338E-06
     +,   1.5145147E-06,   1.2209147E-06,   9.8131613E-07
     +,   7.8638658E-07,   6.2830719E-07,   5.0050824E-07
     +,   3.9751103E-07,   3.1476796E-07,   2.4850010E-07
     +,   1.9559739E-07,   1.5349383E-07,   1.2009249E-07
     +,   9.3676100E-08,   7.2851073E-08,   5.6484261E-08
     +,   4.3662599E-08,   3.3649087E-08,   2.5853801E-08
     +,   1.9804055E-08,   1.5124044E-08
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_haonly_htt120_mass = Yx/0.190194529411765
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_haonly_htt60_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.0536447E-03,   2.1386363E-03
     +,   2.2252526E-03,   2.3134204E-03,   2.4031007E-03
     +,   2.4943014E-03,   2.5870833E-03,   2.6815734E-03
     +,   2.7779704E-03,   2.8765579E-03,   2.9777035E-03
     +,   3.0818712E-03,   3.1896194E-03,   3.3016093E-03
     +,   3.4186018E-03,   3.5414561E-03,   3.6711325E-03
     +,   3.8086865E-03,   3.9552702E-03,   4.1121324E-03
     +,   4.2806179E-03,   4.4621704E-03,   4.6583405E-03
     +,   4.8708040E-03,   5.1013376E-03,   5.3518759E-03
     +,   5.6244852E-03,   5.9213797E-03,   6.2449165E-03
     +,   6.5975836E-03,   6.9819689E-03,   7.4007092E-03
     +,   7.8564296E-03,   8.3516361E-03,   8.8886088E-03
     +,   9.4692456E-03,   1.0094920E-02,   1.0766266E-02
     +,   1.1483073E-02,   1.2243972E-02,   1.3046446E-02
     +,   1.3886577E-02,   1.4759041E-02,   1.5657080E-02
     +,   1.6572578E-02,   1.7496197E-02,   1.8417655E-02
     +,   1.9326013E-02,   2.0210082E-02,   2.1058898E-02
     +,   2.1862177E-02,   2.2610798E-02,   2.3297248E-02
     +,   2.3916055E-02,   2.4463937E-02,   2.4940109E-02
     +,   2.5346151E-02,   2.5685955E-02,   2.5965383E-02
     +,   2.6191870E-02,   2.6373897E-02,   2.6520463E-02
     +,   2.6640426E-02,   2.6742086E-02,   2.6832636E-02
     +,   2.6917906E-02,   2.7002187E-02,   2.7088227E-02
     +,   2.7177427E-02,   2.7270177E-02,   2.7366275E-02
     +,   2.7465444E-02,   2.7567921E-02,   2.7674902E-02
     +,   2.7788997E-02,   2.7914543E-02,   2.8057707E-02
     +,   2.8226508E-02,   2.8430536E-02,   2.8680617E-02
     +,   2.8988235E-02,   2.9364940E-02,   2.9821502E-02
     +,   3.0367225E-02,   3.1009015E-02,   3.1750649E-02
     +,   3.2591876E-02,   3.3527967E-02,   3.4548946E-02
     +,   3.5639487E-02,   3.6778826E-02,   3.7940938E-02
     +,   3.9095350E-02,   4.0208273E-02,   4.1244037E-02
     +,   4.2166796E-02,   4.2942818E-02,   4.3542314E-02
     +,   4.3941617E-02,   4.4124771E-02,   4.4084717E-02
     +,   4.3823857E-02,   4.3353848E-02,   4.2694818E-02
     +,   4.1873682E-02,   4.0922232E-02,   3.9874826E-02
     +,   3.8766082E-02,   3.7628379E-02,   3.6490269E-02
     +,   3.5375070E-02,   3.4299843E-02,   3.3275522E-02
     +,   3.2306865E-02,   3.1393506E-02,   3.0530721E-02
     +,   2.9710766E-02,   2.8923946E-02,   2.8159853E-02
     +,   2.7408166E-02,   2.6659453E-02,   2.5905771E-02
     +,   2.5140978E-02,   2.4360793E-02,   2.3562955E-02
     +,   2.2747183E-02,   2.1914825E-02,   2.1068888E-02
     +,   2.0213522E-02,   1.9353980E-02,   1.8496053E-02
     +,   1.7646004E-02,   1.6810019E-02,   1.5994152E-02
     +,   1.5203912E-02,   1.4444117E-02,   1.3718836E-02
     +,   1.3031254E-02,   1.2383608E-02,   1.1777293E-02
     +,   1.1212967E-02,   1.0690616E-02,   1.0209651E-02
     +,   9.7690821E-03,   9.3676606E-03,   9.0039121E-03
     +,   8.6762495E-03,   8.3830608E-03,   8.1227059E-03
     +,   7.8935185E-03,   7.6938272E-03,   7.5219502E-03
     +,   7.3761647E-03,   7.2546680E-03,   7.1555809E-03
     +,   7.0769419E-03,   7.0166858E-03,   6.9726468E-03
     +,   6.9425837E-03,   6.9241868E-03,   6.9151074E-03
     +,   6.9129816E-03,   6.9154692E-03,   6.9202855E-03
     +,   6.9252299E-03,   6.9282204E-03,   6.9273170E-03
     +,   6.9207614E-03,   6.9069695E-03,   6.8845781E-03
     +,   6.8524280E-03,   6.8095946E-03,   6.7553674E-03
     +,   6.6892565E-03,   6.6109938E-03,   6.5205107E-03
     +,   6.4179264E-03,   6.3035423E-03,   6.1778259E-03
     +,   6.0413759E-03,   5.8949180E-03,   5.7392917E-03
     +,   5.5754222E-03,   5.4042959E-03,   5.2269469E-03
     +,   5.0444519E-03,   4.8579057E-03,   4.6683908E-03
     +,   4.4769761E-03,   4.2847204E-03,   4.0926258E-03
     +,   3.9016460E-03,   3.7126869E-03,   3.5265917E-03
     +,   3.3441177E-03,   3.1659480E-03,   2.9926975E-03
     +,   2.8249021E-03,   2.6630023E-03,   2.5073614E-03
     +,   2.3582734E-03,   2.2159566E-03,   2.0805465E-03
     +,   1.9521113E-03,   1.8306701E-03,   1.7161696E-03
     +,   1.6085067E-03,   1.5075380E-03,   1.4130801E-03
     +,   1.3249082E-03,   1.2427696E-03,   1.1663949E-03
     +,   1.0954958E-03,   1.0297671E-03,   9.6889690E-04
     +,   9.1257371E-04,   8.6048653E-04,   8.1232417E-04
     +,   7.6778355E-04,   7.2657521E-04,   6.8841712E-04
     +,   6.5304083E-04,   6.2019553E-04,   5.8964518E-04
     +,   5.6116818E-04,   5.3455989E-04,   5.0963403E-04
     +,   4.8622023E-04,   4.6416317E-04,   4.4332244E-04
     +,   4.2357453E-04,   4.0480914E-04,   3.8692800E-04
     +,   3.6984519E-04,   3.5348732E-04,   3.3778977E-04
     +,   3.2269704E-04,   3.0816297E-04,   2.9414851E-04
     +,   2.8062024E-04,   2.6755038E-04,   2.5491690E-04
     +,   2.4270180E-04,   2.3088969E-04,   2.1946810E-04
     +,   2.0842777E-04,   1.9776101E-04,   1.8746115E-04
     +,   1.7752242E-04,   1.6794080E-04,   1.5871180E-04
     +,   1.4983123E-04,   1.4129549E-04,   1.3310098E-04
     +,   1.2524318E-04,   1.1771742E-04,   1.1051917E-04
     +,   1.0364340E-04,   9.7084187E-05,   9.0835252E-05
     +,   8.4890256E-05,   7.9242345E-05,   7.3884024E-05
     +,   6.8807334E-05,   6.4004475E-05,   5.9466947E-05
     +,   5.5185945E-05,   5.1152761E-05,   4.7358495E-05
     +,   4.3793854E-05,   4.0449526E-05,   3.7316368E-05
     +,   3.4385215E-05,   3.1646763E-05,   2.9091787E-05
     +,   2.6711450E-05,   2.4496707E-05,   2.2439002E-05
     +,   2.0529691E-05,   1.8760602E-05,   1.7123557E-05
     +,   1.5610849E-05,   1.4214831E-05,   1.2928316E-05
     +,   1.1744246E-05,   1.0655977E-05,   9.6570730E-06
     +,   8.7413864E-06,   7.9031470E-06,   7.1367817E-06
     +,   6.4370988E-06,   5.7990915E-06,   5.2181340E-06
     +,   4.6897835E-06,   4.2099382E-06,   3.7746854E-06
     +,   3.3804240E-06,   3.0237361E-06,   2.7014817E-06
     +,   2.4106946E-06,   2.1486612E-06
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_haonly_htt60_mass = Yx/0.810860689655172
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_haonly_htt65_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.9084028E-03,   2.1248201E-03
     +,   2.3565358E-03,   2.6033535E-03,   2.8648917E-03
     +,   3.1405797E-03,   3.4296585E-03,   3.7311881E-03
     +,   4.0440517E-03,   4.3670041E-03,   4.6986639E-03
     +,   5.0375741E-03,   5.3822491E-03,   5.7312106E-03
     +,   6.0830712E-03,   6.4365813E-03,   6.7907069E-03
     +,   7.1446993E-03,   7.4981693E-03,   7.8511443E-03
     +,   8.2041332E-03,   8.5581699E-03,   8.9148376E-03
     +,   9.2763072E-03,   9.6452711E-03,   1.0024978E-02
     +,   1.0419097E-02,   1.0831675E-02,   1.1266983E-02
     +,   1.1729373E-02,   1.2223103E-02,   1.2752141E-02
     +,   1.3319944E-02,   1.3929267E-02,   1.4581928E-02
     +,   1.5278628E-02,   1.6018771E-02,   1.6800324E-02
     +,   1.7619783E-02,   1.8471995E-02,   1.9350324E-02
     +,   2.0246664E-02,   2.1151535E-02,   2.2054354E-02
     +,   2.2943622E-02,   2.3807289E-02,   2.4633035E-02
     +,   2.5408678E-02,   2.6122559E-02,   2.6763923E-02
     +,   2.7323335E-02,   2.7793031E-02,   2.8167237E-02
     +,   2.8442496E-02,   2.8617805E-02,   2.8694797E-02
     +,   2.8677708E-02,   2.8573347E-02,   2.8390869E-02
     +,   2.8141459E-02,   2.7837977E-02,   2.7494406E-02
     +,   2.7125359E-02,   2.6745481E-02,   2.6368894E-02
     +,   2.6008727E-02,   2.5676608E-02,   2.5382487E-02
     +,   2.5134319E-02,   2.4938164E-02,   2.4798192E-02
     +,   2.4716990E-02,   2.4695776E-02,   2.4734808E-02
     +,   2.4833651E-02,   2.4991466E-02,   2.5207130E-02
     +,   2.5479315E-02,   2.5806297E-02,   2.6185781E-02
     +,   2.6614474E-02,   2.7087744E-02,   2.7599152E-02
     +,   2.8140226E-02,   2.8700141E-02,   2.9265959E-02
     +,   2.9822687E-02,   3.0354010E-02,   3.0842906E-02
     +,   3.1272832E-02,   3.1628683E-02,   3.1898029E-02
     +,   3.2072183E-02,   3.2147128E-02,   3.2124098E-02
     +,   3.2009907E-02,   3.1816762E-02,   3.1561755E-02
     +,   3.1265911E-02,   3.0952955E-02,   3.0647824E-02
     +,   3.0375155E-02,   3.0157620E-02,   3.0014656E-02
     +,   2.9961104E-02,   3.0006574E-02,   3.0154800E-02
     +,   3.0403610E-02,   3.0745283E-02,   3.1167140E-02
     +,   3.1652380E-02,   3.2181289E-02,   3.2732300E-02
     +,   3.3283334E-02,   3.3812776E-02,   3.4300704E-02
     +,   3.4729525E-02,   3.5084795E-02,   3.5355560E-02
     +,   3.5534650E-02,   3.5618637E-02,   3.5607625E-02
     +,   3.5504971E-02,   3.5316635E-02,   3.5050653E-02
     +,   3.4716316E-02,   3.4323353E-02,   3.3881299E-02
     +,   3.3398613E-02,   3.2882154E-02,   3.2336682E-02
     +,   3.1764667E-02,   3.1166181E-02,   3.0539244E-02
     +,   2.9880116E-02,   2.9183941E-02,   2.8445588E-02
     +,   2.7660340E-02,   2.6824616E-02,   2.5936667E-02
     +,   2.4997156E-02,   2.4009377E-02,   2.2979245E-02
     +,   2.1915196E-02,   2.0827916E-02,   1.9729549E-02
     +,   1.8633181E-02,   1.7552219E-02,   1.6499529E-02
     +,   1.5486804E-02,   1.4524101E-02,   1.3619478E-02
     +,   1.2778724E-02,   1.2005199E-02,   1.1299982E-02
     +,   1.0662093E-02,   1.0088720E-02,   9.5755477E-03
     +,   9.1171563E-03,   8.7074731E-03,   8.3400365E-03
     +,   8.0083758E-03,   7.7063013E-03,   7.4280989E-03
     +,   7.1686688E-03,   6.9236523E-03,   6.6894717E-03
     +,   6.4633302E-03,   6.2431470E-03,   6.0275081E-03
     +,   5.8155968E-03,   5.6070783E-03,   5.4019871E-03
     +,   5.2006450E-03,   5.0035883E-03,   4.8114425E-03
     +,   4.6248785E-03,   4.4445647E-03,   4.2711059E-03
     +,   4.1050059E-03,   3.9466545E-03,   3.7963260E-03
     +,   3.6541661E-03,   3.5201856E-03,   3.3942764E-03
     +,   3.2762371E-03,   3.1657703E-03,   3.0624978E-03
     +,   2.9659816E-03,   2.8757481E-03,   2.7912850E-03
     +,   2.7120633E-03,   2.6375544E-03,   2.5672370E-03
     +,   2.5005969E-03,   2.4371434E-03,   2.3764165E-03
     +,   2.3179869E-03,   2.2614561E-03,   2.2064634E-03
     +,   2.1526872E-03,   2.0998467E-03,   2.0476917E-03
     +,   1.9960110E-03,   1.9446338E-03,   1.8934174E-03
     +,   1.8422515E-03,   1.7910579E-03,   1.7397869E-03
     +,   1.6884099E-03,   1.6369213E-03,   1.5853377E-03
     +,   1.5336949E-03,   1.4820396E-03,   1.4304308E-03
     +,   1.3789424E-03,   1.3276555E-03,   1.2766544E-03
     +,   1.2260276E-03,   1.1758704E-03,   1.1262744E-03
     +,   1.0773307E-03,   1.0291304E-03,   9.8176207E-04
     +,   9.3530683E-04,   8.8983995E-04,   8.4543502E-04
     +,   8.0215797E-04,   7.6006597E-04,   7.1920833E-04
     +,   6.7963032E-04,   6.4137002E-04,   6.0445472E-04
     +,   5.6890579E-04,   5.3474051E-04,   5.0196575E-04
     +,   4.7058277E-04,   4.4058863E-04,   4.1197450E-04
     +,   3.8472458E-04,   3.5881856E-04,   3.3423334E-04
     +,   3.1094195E-04,   2.8891242E-04,   2.6810999E-04
     +,   2.4849884E-04,   2.3004084E-04,   2.1269482E-04
     +,   1.9641856E-04,   1.8117038E-04,   1.6690635E-04
     +,   1.5358234E-04,   1.4115502E-04,   1.2958114E-04
     +,   1.1881709E-04,   1.0882000E-04,   9.9548488E-05
     +,   9.0961941E-05,   8.3020335E-05,   7.5684875E-05
     +,   6.8918554E-05,   6.2685678E-05,   5.6951485E-05
     +,   5.1682793E-05,   4.6848327E-05,   4.2417840E-05
     +,   3.8362607E-05,   3.4655659E-05,   3.1271466E-05
     +,   2.8185652E-05,   2.5375350E-05,   2.2819224E-05
     +,   2.0497231E-05,   1.8390458E-05,   1.6481261E-05
     +,   1.4753338E-05,   1.3191311E-05,   1.1781073E-05
     +,   1.0509365E-05,   9.3640547E-06,   8.3337873E-06
     +,   7.4082118E-06,   6.5776576E-06,   5.8333458E-06
     +,   5.1671000E-06,   4.5715178E-06,   4.0397454E-06
     +,   3.5655303E-06,   3.1431946E-06,   2.7675189E-06
     +,   2.4337876E-06,   2.1376761E-06,   1.8752939E-06
     +,   1.6430818E-06,   1.4378475E-06,   1.2566794E-06
     +,   1.0969708E-06,   9.5635517E-07,   8.3271777E-07
     +,   7.2414497E-07,   6.2893207E-07
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_haonly_htt65_mass = Yx/0.8916089
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_haonly_htt70_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  7.4980245E-04,   8.0299465E-04
     +,   8.5886003E-04,   9.1743458E-04,   9.7874878E-04
     +,   1.0428260E-03,   1.1096842E-03,   1.1793373E-03
     +,   1.2517927E-03,   1.3270603E-03,   1.4051453E-03
     +,   1.4860545E-03,   1.5697994E-03,   1.6563945E-03
     +,   1.7458636E-03,   1.8382403E-03,   1.9335706E-03
     +,   2.0319151E-03,   2.1333520E-03,   2.2379772E-03
     +,   2.3459061E-03,   2.4572765E-03,   2.5722450E-03
     +,   2.6909944E-03,   2.8137164E-03,   2.9406312E-03
     +,   3.0719652E-03,   3.2079585E-03,   3.3488537E-03
     +,   3.4948953E-03,   3.6463202E-03,   3.8033512E-03
     +,   3.9661899E-03,   4.1350066E-03,   4.3099374E-03
     +,   4.4910708E-03,   4.6784426E-03,   4.8720255E-03
     +,   5.0717397E-03,   5.2774115E-03,   5.4888166E-03
     +,   5.7056416E-03,   5.9274998E-03,   6.1539318E-03
     +,   6.3844114E-03,   6.6183470E-03,   6.8550999E-03
     +,   7.0939916E-03,   7.3343161E-03,   7.5753629E-03
     +,   7.8164358E-03,   8.0568725E-03,   8.2960650E-03
     +,   8.5335020E-03,   8.7687531E-03,   9.0015410E-03
     +,   9.2317229E-03,   9.4593307E-03,   9.6845804E-03
     +,   9.9078724E-03,   1.0129804E-02,   1.0351160E-02
     +,   1.0572886E-02,   1.0796080E-02,   1.1021963E-02
     +,   1.1251788E-02,   1.1486849E-02,   1.1728357E-02
     +,   1.1977439E-02,   1.2234985E-02,   1.2501664E-02
     +,   1.2777773E-02,   1.3063259E-02,   1.3357604E-02
     +,   1.3659865E-02,   1.3968631E-02,   1.4282063E-02
     +,   1.4597935E-02,   1.4913765E-02,   1.5226901E-02
     +,   1.5534627E-02,   1.5834413E-02,   1.6123995E-02
     +,   1.6401632E-02,   1.6666172E-02,   1.6917326E-02
     +,   1.7155627E-02,   1.7382586E-02,   1.7600631E-02
     +,   1.7813073E-02,   1.8023930E-02,   1.8237738E-02
     +,   1.8459279E-02,   1.8693306E-02,   1.8944187E-02
     +,   1.9215552E-02,   1.9510059E-02,   1.9829033E-02
     +,   2.0172397E-02,   2.0538451E-02,   2.0924006E-02
     +,   2.1324411E-02,   2.1733841E-02,   2.2145594E-02
     +,   2.2552518E-02,   2.2947460E-02,   2.3323700E-02
     +,   2.3675406E-02,   2.3998044E-02,   2.4288645E-02
     +,   2.4545938E-02,   2.4770465E-02,   2.4964403E-02
     +,   2.5131401E-02,   2.5276184E-02,   2.5404153E-02
     +,   2.5520924E-02,   2.5631817E-02,   2.5741460E-02
     +,   2.5853409E-02,   2.5969870E-02,   2.6091585E-02
     +,   2.6217809E-02,   2.6346415E-02,   2.6474148E-02
     +,   2.6596855E-02,   2.6709883E-02,   2.6808374E-02
     +,   2.6887642E-02,   2.6943401E-02,   2.6972000E-02
     +,   2.6970465E-02,   2.6936661E-02,   2.6869137E-02
     +,   2.6767110E-02,   2.6630297E-02,   2.6458854E-02
     +,   2.6253186E-02,   2.6013937E-02,   2.5741858E-02
     +,   2.5437914E-02,   2.5103262E-02,   2.4739269E-02
     +,   2.4347721E-02,   2.3930797E-02,   2.3491174E-02
     +,   2.3031997E-02,   2.2556955E-02,   2.2070142E-02
     +,   2.1575961E-02,   2.1078980E-02,   2.0583790E-02
     +,   2.0094827E-02,   1.9616149E-02,   1.9151334E-02
     +,   1.8703384E-02,   1.8274628E-02,   1.7866665E-02
     +,   1.7480420E-02,   1.7116208E-02,   1.6773760E-02
     +,   1.6452372E-02,   1.6151018E-02,   1.5868442E-02
     +,   1.5603221E-02,   1.5353887E-02,   1.5118978E-02
     +,   1.4897064E-02,   1.4686736E-02,   1.4486616E-02
     +,   1.4295362E-02,   1.4111622E-02,   1.3934005E-02
     +,   1.3761048E-02,   1.3591262E-02,   1.3423054E-02
     +,   1.3254774E-02,   1.3084758E-02,   1.2911308E-02
     +,   1.2732753E-02,   1.2547478E-02,   1.2354000E-02
     +,   1.2150970E-02,   1.1937234E-02,   1.1711834E-02
     +,   1.1474084E-02,   1.1223552E-02,   1.0960057E-02
     +,   1.0683690E-02,   1.0394821E-02,   1.0094041E-02
     +,   9.7821625E-03,   9.4602210E-03,   9.1294227E-03
     +,   8.7910919E-03,   8.4466664E-03,   8.0976915E-03
     +,   7.7457498E-03,   7.3924349E-03,   7.0393276E-03
     +,   6.6880039E-03,   6.3399849E-03,   5.9967013E-03
     +,   5.6594908E-03,   5.3296308E-03,   5.0082472E-03
     +,   4.6963505E-03,   4.3948437E-03,   4.1045053E-03
     +,   3.8259642E-03,   3.5597205E-03,   3.3061730E-03
     +,   3.0655945E-03,   2.8381310E-03,   2.6238225E-03
     +,   2.4226245E-03,   2.2343991E-03,   2.0589149E-03
     +,   1.8958693E-03,   1.7449113E-03,   1.6056210E-03
     +,   1.4775327E-03,   1.3601539E-03,   1.2529623E-03
     +,   1.1554075E-03,   1.0669273E-03,   9.8695897E-04
     +,   9.1493782E-04,   8.5029984E-04,   7.9249113E-04
     +,   7.4097601E-04,   6.9523550E-04,   6.5476744E-04
     +,   6.1909290E-04,   5.8776152E-04,   5.6034426E-04
     +,   5.3643924E-04,   5.1567308E-04,   4.9769907E-04
     +,   4.8219541E-04,   4.6886693E-04,   4.5744420E-04
     +,   4.4768202E-04,   4.3935713E-04,   4.3226854E-04
     +,   4.2623602E-04,   4.2109835E-04,   4.1671144E-04
     +,   4.1294782E-04,   4.0969517E-04,   4.0685441E-04
     +,   4.0433914E-04,   4.0207393E-04,   3.9999356E-04
     +,   3.9804165E-04,   3.9616981E-04,   3.9433691E-04
     +,   3.9250794E-04,   3.9065367E-04,   3.8874926E-04
     +,   3.8677460E-04,   3.8471306E-04,   3.8255134E-04
     +,   3.8027862E-04,   3.7788693E-04,   3.7537015E-04
     +,   3.7272362E-04,   3.6994490E-04,   3.6703245E-04
     +,   3.6398586E-04,   3.6080563E-04,   3.5749329E-04
     +,   3.5405098E-04,   3.5048148E-04,   3.4678780E-04
     +,   3.4297377E-04,   3.3904327E-04,   3.3500083E-04
     +,   3.3085077E-04,   3.2659815E-04,   3.2224771E-04
     +,   3.1780486E-04,   3.1327450E-04,   3.0866245E-04
     +,   3.0397365E-04,   2.9921404E-04,   2.9438891E-04
     +,   2.8950378E-04,   2.8456436E-04,   2.7957596E-04
     +,   2.7454447E-04,   2.6947507E-04,   2.6437355E-04
     +,   2.5924493E-04,   2.5409498E-04,   2.4892858E-04
     +,   2.4375132E-04,   2.3856791E-04,   2.3338373E-04
     +,   2.2820335E-04,   2.2303184E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_haonly_htt70_mass = Yx/0.68235375
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_haonly_htt75_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  9.8709692E-04,   1.0341916E-03
     +,   1.0849687E-03,   1.1397116E-03,   1.1987177E-03
     +,   1.2622987E-03,   1.3307782E-03,   1.4044924E-03
     +,   1.4837853E-03,   1.5690144E-03,   1.6605388E-03
     +,   1.7587231E-03,   1.8639346E-03,   1.9765384E-03
     +,   2.0968977E-03,   2.2253704E-03,   2.3623048E-03
     +,   2.5080405E-03,   2.6629020E-03,   2.8272008E-03
     +,   3.0012287E-03,   3.1852599E-03,   3.3795408E-03
     +,   3.5843062E-03,   3.7997400E-03,   4.0260162E-03
     +,   4.2632581E-03,   4.5115496E-03,   4.7709285E-03
     +,   5.0413711E-03,   5.3227907E-03,   5.6150225E-03
     +,   5.9178136E-03,   6.2308107E-03,   6.5535423E-03
     +,   6.8854098E-03,   7.2256704E-03,   7.5734165E-03
     +,   7.9275928E-03,   8.2869213E-03,   8.6499779E-03
     +,   9.0151187E-03,   9.3805213E-03,   9.7441701E-03
     +,   1.0103886E-02,   1.0457334E-02,   1.0802066E-02
     +,   1.1135546E-02,   1.1455202E-02,   1.1758478E-02
     +,   1.2042891E-02,   1.2306102E-02,   1.2545971E-02
     +,   1.2760660E-02,   1.2948652E-02,   1.3108867E-02
     +,   1.3240685E-02,   1.3344010E-02,   1.3419304E-02
     +,   1.3467603E-02,   1.3490522E-02,   1.3490233E-02
     +,   1.3469420E-02,   1.3431229E-02,   1.3379167E-02
     +,   1.3317034E-02,   1.3248755E-02,   1.3178319E-02
     +,   1.3109573E-02,   1.3046158E-02,   1.2991309E-02
     +,   1.2947802E-02,   1.2917819E-02,   1.2902878E-02
     +,   1.2903798E-02,   1.2920702E-02,   1.2953032E-02
     +,   1.2999629E-02,   1.3058851E-02,   1.3128704E-02
     +,   1.3207057E-02,   1.3291809E-02,   1.3381134E-02
     +,   1.3473722E-02,   1.3568971E-02,   1.3667212E-02
     +,   1.3769879E-02,   1.3879636E-02,   1.4000451E-02
     +,   1.4137609E-02,   1.4297658E-02,   1.4488262E-02
     +,   1.4717989E-02,   1.4996044E-02,   1.5331904E-02
     +,   1.5734874E-02,   1.6213678E-02,   1.6775867E-02
     +,   1.7427426E-02,   1.8172089E-02,   1.9011084E-02
     +,   1.9942472E-02,   2.0961031E-02,   2.2057854E-02
     +,   2.3220455E-02,   2.4432825E-02,   2.5675640E-02
     +,   2.6926802E-02,   2.8162234E-02,   2.9356660E-02
     +,   3.0484451E-02,   3.1521019E-02,   3.2443617E-02
     +,   3.3232760E-02,   3.3872906E-02,   3.4353513E-02
     +,   3.4669466E-02,   3.4821451E-02,   3.4815837E-02
     +,   3.4664441E-02,   3.4383718E-02,   3.3993948E-02
     +,   3.3518028E-02,   3.2980219E-02,   3.2404829E-02
     +,   3.1815149E-02,   3.1232193E-02,   3.0674132E-02
     +,   3.0155595E-02,   2.9687708E-02,   2.9278001E-02
     +,   2.8931022E-02,   2.8648799E-02,   2.8431643E-02
     +,   2.8278807E-02,   2.8189166E-02,   2.8161557E-02
     +,   2.8195139E-02,   2.8289204E-02,   2.8442910E-02
     +,   2.8654803E-02,   2.8922126E-02,   2.9240217E-02
     +,   2.9601926E-02,   2.9997131E-02,   3.0412722E-02
     +,   3.0832667E-02,   3.1238487E-02,   3.1609967E-02
     +,   3.1926226E-02,   3.2166667E-02,   3.2312110E-02
     +,   3.2345835E-02,   3.2254472E-02,   3.2028563E-02
     +,   3.1662948E-02,   3.1156819E-02,   3.0513560E-02
     +,   2.9740268E-02,   2.8847253E-02,   2.7847268E-02
     +,   2.6754810E-02,   2.5585508E-02,   2.4355425E-02
     +,   2.3080414E-02,   2.1775799E-02,   2.0456072E-02
     +,   1.9134663E-02,   1.7823650E-02,   1.6533852E-02
     +,   1.5274850E-02,   1.4054967E-02,   1.2881202E-02
     +,   1.1759389E-02,   1.0694357E-02,   9.6897511E-03
     +,   8.7482203E-03,   7.8715133E-03,   7.0604621E-03
     +,   6.3149910E-03,   5.6342431E-03,   5.0166911E-03
     +,   4.4601606E-03,   3.9618886E-03,   3.5186626E-03
     +,   3.1269430E-03,   2.7829239E-03,   2.4826140E-03
     +,   2.2219580E-03,   1.9969419E-03,   1.8036171E-03
     +,   1.6381918E-03,   1.4970928E-03,   1.3769873E-03
     +,   1.2748063E-03,   1.1877695E-03,   1.1133950E-03
     +,   1.0494891E-03,   9.9413272E-04,   9.4567332E-04
     +,   9.0270705E-04,   8.6405454E-04,   8.2873594E-04
     +,   7.9595105E-04,   7.6506101E-04,   7.3555921E-04
     +,   7.0705585E-04,   6.7926123E-04,   6.5196742E-04
     +,   6.2503212E-04,   5.9836783E-04,   5.7193183E-04
     +,   5.4571568E-04,   5.1973492E-04,   4.9402396E-04
     +,   4.6863221E-04,   4.4361723E-04,   4.1903992E-04
     +,   3.9496252E-04,   3.7144858E-04,   3.4855658E-04
     +,   3.2634044E-04,   3.0485028E-04,   2.8412987E-04
     +,   2.6421496E-04,   2.4513455E-04,   2.2691196E-04
     +,   2.0956347E-04,   1.9309763E-04,   1.7751681E-04
     +,   1.6281848E-04,   1.4899464E-04,   1.3603125E-04
     +,   1.2390997E-04,   1.1260968E-04,   1.0210470E-04
     +,   9.2366572E-05,   8.3365121E-05,   7.5068150E-05
     +,   6.7441535E-05,   6.0450206E-05,   5.4059063E-05
     +,   4.8232661E-05,   4.2935262E-05,   3.8131649E-05
     +,   3.3787612E-05,   2.9869720E-05,   2.6345429E-05
     +,   2.3183440E-05,   2.0354131E-05,   1.7829023E-05
     +,   1.5581198E-05,   1.3585463E-05,   1.1818174E-05
     +,   1.0257139E-05,   8.8817933E-06,   7.6731785E-06
     +,   6.6138191E-06,   5.6876038E-06,   4.8798302E-06
     +,   4.1771532E-06,   3.5674557E-06,   3.0397421E-06
     +,   2.5841232E-06,   2.1917567E-06,   1.8546899E-06
     +,   1.5658441E-06,   1.3189426E-06,   1.1084246E-06
     +,   9.2936568E-07,   7.7743590E-07,   6.4884824E-07
     +,   5.4028675E-07,   4.4885485E-07,   3.7203600E-07
     +,   3.0765713E-07,   2.5383227E-07,   2.0894373E-07
     +,   1.7159694E-07,   1.4060245E-07,   1.1494069E-07
     +,   9.3747019E-08,   7.6284870E-08,   6.1933108E-08
     +,   5.0165433E-08,   4.0540524E-08,   3.2686980E-08
     +,   2.6294046E-08,   2.1102949E-08,   1.6897646E-08
     +,   1.3499346E-08,   1.0759589E-08,   8.5562402E-09
     +,   6.7883890E-09,   5.3734692E-09,   4.2436437E-09
     +,   3.3437002E-09,   2.6285258E-09,   2.0615838E-09
     +,   1.6131928E-09,   1.2594352E-09
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_haonly_htt75_mass = Yx/0.7348425
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_haonly_htt80_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  8.6389593E-04,   8.7494485E-04
     +,   8.8645297E-04,   8.9846482E-04,   9.1102684E-04
     +,   9.2418725E-04,   9.3799701E-04,   9.5250912E-04
     +,   9.6777960E-04,   9.8386779E-04,   1.0008365E-03
     +,   1.0187528E-03,   1.0376893E-03,   1.0577246E-03
     +,   1.0789447E-03,   1.1014441E-03,   1.1253278E-03
     +,   1.1507123E-03,   1.1777281E-03,   1.2065219E-03
     +,   1.2372585E-03,   1.2701240E-03,   1.3053271E-03
     +,   1.3431046E-03,   1.3837197E-03,   1.4274709E-03
     +,   1.4746888E-03,   1.5257426E-03,   1.5810400E-03
     +,   1.6410309E-03,   1.7062065E-03,   1.7771014E-03
     +,   1.8542911E-03,   1.9383925E-03,   2.0300590E-03
     +,   2.1299755E-03,   2.2388529E-03,   2.3574182E-03
     +,   2.4864129E-03,   2.6265585E-03,   2.7785720E-03
     +,   2.9431237E-03,   3.1208335E-03,   3.3122434E-03
     +,   3.5177995E-03,   3.7378301E-03,   3.9725187E-03
     +,   4.2218855E-03,   4.4857641E-03,   4.7637769E-03
     +,   5.0553284E-03,   5.3595770E-03,   5.6754290E-03
     +,   6.0015582E-03,   6.3363449E-03,   6.6779596E-03
     +,   7.0243175E-03,   7.3731262E-03,   7.7219093E-03
     +,   8.0680419E-03,   8.4087942E-03,   8.7413816E-03
     +,   9.0629943E-03,   9.3709147E-03,   9.6625360E-03
     +,   9.9354060E-03,   1.0187359E-02,   1.0416504E-02
     +,   1.0621355E-02,   1.0800809E-02,   1.0954266E-02
     +,   1.1081615E-02,   1.1183288E-02,   1.1260258E-02
     +,   1.1314067E-02,   1.1346793E-02,   1.1361039E-02
     +,   1.1359895E-02,   1.1346882E-02,   1.1325900E-02
     +,   1.1301148E-02,   1.1277035E-02,   1.1258102E-02
     +,   1.1248904E-02,   1.1253914E-02,   1.1277417E-02
     +,   1.1323406E-02,   1.1395470E-02,   1.1496682E-02
     +,   1.1629521E-02,   1.1795789E-02,   1.1996510E-02
     +,   1.2231885E-02,   1.2501260E-02,   1.2803099E-02
     +,   1.3134929E-02,   1.3493448E-02,   1.3874478E-02
     +,   1.4273113E-02,   1.4683756E-02,   1.5100311E-02
     +,   1.5516246E-02,   1.5924878E-02,   1.6319469E-02
     +,   1.6693521E-02,   1.7040981E-02,   1.7356414E-02
     +,   1.7635282E-02,   1.7874168E-02,   1.8070918E-02
     +,   1.8224774E-02,   1.8336542E-02,   1.8408589E-02
     +,   1.8444853E-02,   1.8450797E-02,   1.8433252E-02
     +,   1.8400233E-02,   1.8360732E-02,   1.8324383E-02
     +,   1.8301189E-02,   1.8301196E-02,   1.8334150E-02
     +,   1.8409200E-02,   1.8534655E-02,   1.8717736E-02
     +,   1.8964386E-02,   1.9279219E-02,   1.9665359E-02
     +,   2.0124499E-02,   2.0656796E-02,   2.1261010E-02
     +,   2.1934342E-02,   2.2672623E-02,   2.3470107E-02
     +,   2.4319606E-02,   2.5212416E-02,   2.6138246E-02
     +,   2.7085325E-02,   2.8040592E-02,   2.8989818E-02
     +,   2.9917922E-02,   3.0809401E-02,   3.1648908E-02
     +,   3.2421805E-02,   3.3114672E-02,   3.3716030E-02
     +,   3.4216780E-02,   3.4610514E-02,   3.4893822E-02
     +,   3.5066258E-02,   3.5130132E-02,   3.5090163E-02
     +,   3.4953009E-02,   3.4726620E-02,   3.4419615E-02
     +,   3.4040738E-02,   3.3598352E-02,   3.3100005E-02
     +,   3.2552257E-02,   3.1960644E-02,   3.1329714E-02
     +,   3.0663207E-02,   2.9964363E-02,   2.9236207E-02
     +,   2.8481744E-02,   2.7704166E-02,   2.6907109E-02
     +,   2.6094565E-02,   2.5270831E-02,   2.4440411E-02
     +,   2.3607928E-02,   2.2777840E-02,   2.1954248E-02
     +,   2.1140734E-02,   2.0340379E-02,   1.9555505E-02
     +,   1.8787758E-02,   1.8038219E-02,   1.7307406E-02
     +,   1.6595379E-02,   1.5901875E-02,   1.5226521E-02
     +,   1.4568856E-02,   1.3928403E-02,   1.3304789E-02
     +,   1.2697792E-02,   1.2107332E-02,   1.1533424E-02
     +,   1.0976180E-02,   1.0435835E-02,   9.9125840E-03
     +,   9.4066188E-03,   8.9181028E-03,   8.4471088E-03
     +,   7.9935845E-03,   7.5573623E-03,   7.1381927E-03
     +,   6.7357249E-03,   6.3494896E-03,   5.9789591E-03
     +,   5.6235860E-03,   5.2828030E-03,   4.9560238E-03
     +,   4.6426896E-03,   4.3423180E-03,   4.0544402E-03
     +,   3.7786576E-03,   3.5146545E-03,   3.2621727E-03
     +,   3.0209972E-03,   2.7909623E-03,   2.5719556E-03
     +,   2.3638937E-03,   2.1666894E-03,   1.9802616E-03
     +,   1.8045333E-03,   1.6394041E-03,   1.4847378E-03
     +,   1.3403648E-03,   1.2060918E-03,   1.0816709E-03
     +,   9.6681493E-04,   8.6120551E-04,   7.6448673E-04
     +,   6.7626365E-04,   5.9611496E-04,   5.2360300E-04
     +,   4.5827290E-04,   3.9965552E-04,   3.4727823E-04
     +,   3.0067321E-04,   2.5937840E-04,   2.2293987E-04
     +,   1.9091950E-04,   1.6290027E-04,   1.3848310E-04
     +,   1.1729247E-04,   9.8978548E-05,   8.3216619E-05
     +,   6.9706308E-05,   5.8173155E-05,   4.8368453E-05
     +,   4.0067418E-05,   3.3067827E-05,   2.7189468E-05
     +,   2.2272907E-05,   1.8177550E-05,   1.4779896E-05
     +,   1.1972368E-05,   9.6619597E-06,   7.7682207E-06
     +,   6.2222011E-06,   4.9651635E-06,   3.9472166E-06
     +,   3.1261568E-06,   2.4665330E-06,   1.9387442E-06
     +,   1.5181417E-06,   1.1842851E-06,   9.2033605E-07
     +,   7.1249701E-07,   5.4950004E-07,   4.2217621E-07
     +,   3.2311300E-07,   2.4635114E-07,   1.8710617E-07
     +,   1.4156215E-07,   1.0669246E-07,   8.0102865E-08
     +,   5.9907940E-08,   4.4630870E-08,   3.3120838E-08
     +,   2.4484141E-08,   1.8029262E-08,   1.3224349E-08
     +,   9.6622879E-09,   7.0320598E-09,   5.0978710E-09
     +,   3.6811800E-09,   2.6477889E-09,   1.8969988E-09
     +,   1.3537654E-09,   9.6228014E-10,   6.8131595E-10
     +,   4.8047594E-10,   3.3750447E-10,   2.3613694E-10
     +,   1.6455769E-10,   1.1422237E-10,   7.8967707E-11
     +,   5.4377999E-11,   3.7295732E-11,   2.5478094E-11
     +,   1.7335463E-11,   1.1748283E-11,   7.9300073E-12
     +,   5.3314293E-12,   3.5700566E-12,   2.3811248E-12
     +,   1.5818232E-12,   1.0466903E-12
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_haonly_htt80_mass = Yx/0.671856
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_haonly_htt85_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  8.7803515E-04,   9.0228021E-04
     +,   9.2733593E-04,   9.5320446E-04,   9.7988732E-04
     +,   1.0073853E-03,   1.0356982E-03,   1.0648262E-03
     +,   1.0947678E-03,   1.1255238E-03,   1.1570927E-03
     +,   1.1894740E-03,   1.2226673E-03,   1.2566722E-03
     +,   1.2914893E-03,   1.3271185E-03,   1.3635614E-03
     +,   1.4008188E-03,   1.4388924E-03,   1.4777837E-03
     +,   1.5174947E-03,   1.5580265E-03,   1.5993799E-03
     +,   1.6415579E-03,   1.6845564E-03,   1.7283761E-03
     +,   1.7730132E-03,   1.8184620E-03,   1.8647155E-03
     +,   1.9117621E-03,   1.9595891E-03,   2.0081783E-03
     +,   2.0575095E-03,   2.1075567E-03,   2.1582902E-03
     +,   2.2096748E-03,   2.2616717E-03,   2.3142351E-03
     +,   2.3673184E-03,   2.4208636E-03,   2.4748158E-03
     +,   2.5291105E-03,   2.5836816E-03,   2.6384590E-03
     +,   2.6933718E-03,   2.7483455E-03,   2.8033070E-03
     +,   2.8581824E-03,   2.9128992E-03,   2.9673893E-03
     +,   3.0215862E-03,   3.0754313E-03,   3.1288699E-03
     +,   3.1818585E-03,   3.2343587E-03,   3.2863473E-03
     +,   3.3378094E-03,   3.3887427E-03,   3.4391598E-03
     +,   3.4890876E-03,   3.5385673E-03,   3.5876578E-03
     +,   3.6364291E-03,   3.6849719E-03,   3.7333942E-03
     +,   3.7818130E-03,   3.8303696E-03,   3.8792109E-03
     +,   3.9285081E-03,   3.9784377E-03,   4.0291962E-03
     +,   4.0809852E-03,   4.1340217E-03,   4.1885301E-03
     +,   4.2447452E-03,   4.3029101E-03,   4.3632723E-03
     +,   4.4260835E-03,   4.4916044E-03,   4.5600990E-03
     +,   4.6318294E-03,   4.7070677E-03,   4.7860774E-03
     +,   4.8691351E-03,   4.9565048E-03,   5.0484599E-03
     +,   5.1452615E-03,   5.2471790E-03,   5.3544613E-03
     +,   5.4673608E-03,   5.5861194E-03,   5.7109576E-03
     +,   5.8420738E-03,   5.9796534E-03,   6.1238478E-03
     +,   6.2747593E-03,   6.4324606E-03,   6.5969485E-03
     +,   6.7681698E-03,   6.9459756E-03,   7.1301432E-03
     +,   7.3203244E-03,   7.5160787E-03,   7.7168127E-03
     +,   7.9218084E-03,   8.1302095E-03,   8.3409911E-03
     +,   8.5529741E-03,   8.7648509E-03,   8.9751780E-03
     +,   9.1823749E-03,   9.3848025E-03,   9.5807407E-03
     +,   9.7685009E-03,   9.9464133E-03,   1.0112962E-02
     +,   1.0266798E-02,   1.0406875E-02,   1.0532484E-02
     +,   1.0643383E-02,   1.0739849E-02,   1.0822751E-02
     +,   1.0893615E-02,   1.0954650E-02,   1.1008762E-02
     +,   1.1059512E-02,   1.1111077E-02,   1.1168137E-02
     +,   1.1235761E-02,   1.1319248E-02,   1.1423977E-02
     +,   1.1555227E-02,   1.1718065E-02,   1.1917211E-02
     +,   1.2157041E-02,   1.2441603E-02,   1.2774717E-02
     +,   1.3160178E-02,   1.3602066E-02,   1.4104998E-02
     +,   1.4674427E-02,   1.5316878E-02,   1.6040156E-02
     +,   1.6853333E-02,   1.7766455E-02,   1.8790305E-02
     +,   1.9935757E-02,   2.1212926E-02,   2.2630369E-02
     +,   2.4194214E-02,   2.5907237E-02,   2.7767915E-02
     +,   2.9769853E-02,   3.1901516E-02,   3.4145851E-02
     +,   3.6480106E-02,   3.8876131E-02,   4.1300889E-02
     +,   4.3716926E-02,   4.6082821E-02,   4.8354723E-02
     +,   5.0487429E-02,   5.2435856E-02,   5.4157149E-02
     +,   5.5612929E-02,   5.6771420E-02,   5.7609592E-02
     +,   5.8114979E-02,   5.8287043E-02,   5.8137469E-02
     +,   5.7689600E-02,   5.6976885E-02,   5.6040399E-02
     +,   5.4925580E-02,   5.3678829E-02,   5.2343752E-02
     +,   5.0958019E-02,   4.9551062E-02,   4.8142578E-02
     +,   4.6741903E-02,   4.5349002E-02,   4.3955993E-02
     +,   4.2549528E-02,   4.1113161E-02,   3.9630294E-02
     +,   3.8086507E-02,   3.6471512E-02,   3.4780223E-02
     +,   3.3013448E-02,   3.1177970E-02,   2.9285569E-02
     +,   2.7352130E-02,   2.5396520E-02,   2.3439141E-02
     +,   2.1500498E-02,   1.9600304E-02,   1.7756697E-02
     +,   1.5985563E-02,   1.4300041E-02,   1.2710519E-02
     +,   1.1224749E-02,   9.8478589E-03,   8.5824868E-03
     +,   7.4291439E-03,   6.3865674E-03,   5.4517835E-03
     +,   4.6204925E-03,   3.8873677E-03,   3.2462359E-03
     +,   2.6902731E-03,   2.2122783E-03,   1.8048966E-03
     +,   1.4607571E-03,   1.1726167E-03,   9.3352800E-04
     +,   7.3695288E-04,   5.7682360E-04,   4.4759057E-04
     +,   3.4426912E-04,   2.6245243E-04,   1.9828272E-04
     +,   1.4843886E-04,   1.1010181E-04,   8.0906480E-05
     +,   5.8893074E-05,   4.2460812E-05,   3.0319205E-05
     +,   2.1439613E-05,   1.5012120E-05,   1.0407613E-05
     +,   7.1435584E-06,   4.8540569E-06,   3.2650244E-06
     +,   2.1738251E-06,   1.4325329E-06,   9.3432118E-07
     +,   6.0307394E-07,   3.8522367E-07,   2.4350680E-07
     +,   1.5231483E-07,   9.4272323E-08,   5.7733949E-08
     +,   3.4984801E-08,   2.0975609E-08,   1.2442975E-08
     +,   7.3032549E-09,   4.2413748E-09,   2.4372819E-09
     +,   1.3859331E-09,   7.8000245E-10,   4.3457871E-10
     +,   2.3979385E-10,   1.3113793E-10,   7.1166607E-11
     +,   3.8402569E-11,   2.0674740E-11,   1.1166435E-11
     +,   6.1028413E-12,   3.4177843E-12,   1.9935277E-12
     +,   1.2321597E-12,   8.1720362E-13,   5.8287088E-13
     +,   4.4311806E-13,   3.5363574E-13,   2.9168608E-13
     +,   2.4558583E-13,   2.0927634E-13,   1.7953206E-13
     +,   1.5455944E-13,   1.3328578E-13,   1.1501985E-13
     +,   9.9270838E-14,   8.5665565E-14,   7.3900704E-14
     +,   6.3726029E-14,   5.4927817E-14,   4.7322884E-14
     +,   4.0751053E-14,   3.5074913E-14,   3.0174681E-14
     +,   2.5946806E-14,   2.2300182E-14,   1.9156750E-14
     +,   1.6448352E-14,   1.4116166E-14,   1.2108604E-14
     +,   1.0381521E-14,   8.8965183E-15,   7.6201388E-15
     +,   6.5236957E-15,   5.5823008E-15,   4.7744761E-15
     +,   4.0815130E-15,   3.4874295E-15,   2.9783627E-15
     +,   2.5423929E-15,   2.1691599E-15,   1.8498189E-15
     +,   1.5767207E-15,   1.3433011E-15
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_haonly_htt85_mass = Yx/0.713847
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_haonly_htt90_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  7.2242168E-04,   7.4250653E-04
     +,   7.6236052E-04,   7.8193727E-04,   8.0119137E-04
     +,   8.2007673E-04,   8.3854853E-04,   8.5656240E-04
     +,   8.7407505E-04,   8.9104514E-04,   9.0743235E-04
     +,   9.2319882E-04,   9.3830866E-04,   9.5272926E-04
     +,   9.6643023E-04,   9.7938499E-04,   9.9157100E-04
     +,   1.0029689E-03,   1.0135642E-03,   1.0233473E-03
     +,   1.0323131E-03,   1.0404623E-03,   1.0478012E-03
     +,   1.0543424E-03,   1.0601040E-03,   1.0651120E-03
     +,   1.0693981E-03,   1.0730017E-03,   1.0759694E-03
     +,   1.0783558E-03,   1.0802228E-03,   1.0816405E-03
     +,   1.0826862E-03,   1.0834464E-03,   1.0840151E-03
     +,   1.0844941E-03,   1.0849932E-03,   1.0856304E-03
     +,   1.0865306E-03,   1.0878267E-03,   1.0896581E-03
     +,   1.0921711E-03,   1.0955178E-03,   1.0998563E-03
     +,   1.1053493E-03,   1.1121638E-03,   1.1204706E-03
     +,   1.1304433E-03,   1.1422572E-03,   1.1560888E-03
     +,   1.1721138E-03,   1.1905076E-03,   1.2114418E-03
     +,   1.2350869E-03,   1.2616053E-03,   1.2911559E-03
     +,   1.3238884E-03,   1.3599440E-03,   1.3994531E-03
     +,   1.4425336E-03,   1.4892899E-03,   1.5398116E-03
     +,   1.5941685E-03,   1.6524148E-03,   1.7145851E-03
     +,   1.7806861E-03,   1.8507082E-03,   1.9246086E-03
     +,   2.0023258E-03,   2.0837609E-03,   2.1687953E-03
     +,   2.2572679E-03,   2.3489988E-03,   2.4437606E-03
     +,   2.5413046E-03,   2.6413465E-03,   2.7435634E-03
     +,   2.8475977E-03,   2.9530670E-03,   3.0595583E-03
     +,   3.1666181E-03,   3.2737798E-03,   3.3805396E-03
     +,   3.4863849E-03,   3.5907745E-03,   3.6931678E-03
     +,   3.7930026E-03,   3.8897293E-03,   3.9827917E-03
     +,   4.0716524E-03,   4.1557946E-03,   4.2347228E-03
     +,   4.3079769E-03,   4.3751472E-03,   4.4358755E-03
     +,   4.4898614E-03,   4.5368820E-03,   4.5767911E-03
     +,   4.6095378E-03,   4.6351664E-03,   4.6538338E-03
     +,   4.6658097E-03,   4.6714926E-03,   4.6714102E-03
     +,   4.6662292E-03,   4.6567572E-03,   4.6439469E-03
     +,   4.6289004E-03,   4.6128607E-03,   4.5972159E-03
     +,   4.5834887E-03,   4.5733280E-03,   4.5684930E-03
     +,   4.5708390E-03,   4.5822882E-03,   4.6048081E-03
     +,   4.6403711E-03,   4.6909195E-03,   4.7583161E-03
     +,   4.8442907E-03,   4.9503902E-03,   5.0778952E-03
     +,   5.2277655E-03,   5.4005720E-03,   5.5964165E-03
     +,   5.8148503E-03,   6.0548517E-03,   6.3147270E-03
     +,   6.5921443E-03,   6.8840720E-03,   7.1869013E-03
     +,   7.4964510E-03,   7.8082043E-03,   8.1174616E-03
     +,   8.4196944E-03,   8.7109227E-03,   8.9881839E-03
     +,   9.2501557E-03,   9.4978800E-03,   9.7355479E-03
     +,   9.9713570E-03,   1.0218376E-02,   1.0495303E-02
     +,   1.0826885E-02,   1.1243813E-02,   1.1782008E-02
     +,   1.2480890E-02,   1.3380612E-02,   1.4518443E-02
     +,   1.5924677E-02,   1.7618507E-02,   1.9604748E-02
     +,   2.1872832E-02,   2.4399089E-02,   2.7152868E-02
     +,   3.0106960E-02,   3.3252366E-02,   3.6615185E-02
     +,   4.0271629E-02,   4.4356272E-02,   4.9058884E-02
     +,   5.4602638E-02,   6.1202530E-02,   6.9008492E-02
     +,   7.8042559E-02,   8.8144444E-02,   9.8943450E-02
     +,   0.1098718    ,   0.1202249    ,   0.1292596    
     +,   0.1363157    ,   0.1409343    ,   0.1429439    
     +,   0.1424881    ,   0.1399886    ,   0.1360495    
     +,   0.1313256    ,   0.1263933    ,   0.1216536    
     +,   0.1172894    ,   0.1132800    ,   0.1094589    
     +,   0.1055909    ,   0.1014465    ,   9.6857347E-02
     +,   9.1745041E-02,   8.6124480E-02,   8.0088444E-02
     +,   7.3782109E-02,   6.7376055E-02,   6.1039574E-02
     +,   5.4922458E-02,   4.9143273E-02,   4.3783672E-02
     +,   3.8888708E-02,   3.4472000E-02,   3.0523410E-02
     +,   2.7016524E-02,   2.3915689E-02,   2.1181908E-02
     +,   1.8776720E-02,   1.6663989E-02,   1.4810689E-02
     +,   1.3187225E-02,   1.1767390E-02,   1.0527739E-02
     +,   9.4473921E-03,   8.5077034E-03,   7.6917438E-03
     +,   6.9839153E-03,   6.3697034E-03,   5.8355550E-03
     +,   5.3687776E-03,   4.9576191E-03,   4.5914524E-03
     +,   4.2609735E-03,   3.9583119E-03,   3.6770864E-03
     +,   3.4124118E-03,   3.1608215E-03,   2.9200464E-03
     +,   2.6888319E-03,   2.4667145E-03,   2.2537797E-03
     +,   2.0504359E-03,   1.8572563E-03,   1.6748484E-03
     +,   1.5037410E-03,   1.3443077E-03,   1.1967435E-03
     +,   1.0610654E-03,   9.3710568E-04,   8.2452665E-04
     +,   7.2285632E-04,   6.3152780E-04,   5.4988905E-04
     +,   4.7724301E-04,   4.1287570E-04,   3.5607177E-04
     +,   3.0612727E-04,   2.6236728E-04,   2.2415693E-04
     +,   1.9090253E-04,   1.6205340E-04,   1.3710547E-04
     +,   1.1560156E-04,   9.7127784E-05,   8.1310194E-05
     +,   6.7813678E-05,   5.6339977E-05,   4.6622190E-05
     +,   3.8423350E-05,   3.1534175E-05,   2.5769865E-05
     +,   2.0967347E-05,   1.6983819E-05,   1.3694817E-05
     +,   1.0992024E-05,   8.7814878E-06,   6.9823009E-06
     +,   5.5252176E-06,   4.3511400E-06,   3.4098759E-06
     +,   2.6591099E-06,   2.0634263E-06,   1.5932410E-06
     +,   1.2240491E-06,   9.3569821E-07,   7.1168625E-07
     +,   5.3857485E-07,   4.0550736E-07,   3.0377052E-07
     +,   2.2640516E-07,   1.6788560E-07,   1.2385691E-07
     +,   9.0910000E-08,   6.6386100E-08,   4.8230820E-08
     +,   3.4861223E-08,   2.5069166E-08,   1.7935166E-08
     +,   1.2765809E-08,   9.0397831E-09,   6.3685919E-09
     +,   4.4637001E-09,   3.1125869E-09,   2.1593289E-09
     +,   1.4903221E-09,   1.0233309E-09,   6.9906314E-10
     +,   4.7510751E-10,   3.2124056E-10,   2.1609474E-10
     +,   1.4461751E-10,   9.6288040E-11,   6.3780370E-11
     +,   4.2031607E-11,   2.7556785E-11,   1.7974473E-11
     +,   1.1663973E-11,   7.5302941E-12
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_haonly_htt90_mass = Yx/1.06196593548387
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_haonly_htt95_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.4765142E-04,   2.5870174E-04
     +,   2.6996442E-04,   2.8142775E-04,   2.9307982E-04
     +,   3.0490826E-04,   3.1690064E-04,   3.2904459E-04
     +,   3.4132754E-04,   3.5373808E-04,   3.6626469E-04
     +,   3.7889686E-04,   3.9162501E-04,   4.0444097E-04
     +,   4.1733796E-04,   4.3031093E-04,   4.4335696E-04
     +,   4.5647542E-04,   4.6966795E-04,   4.8293953E-04
     +,   4.9629749E-04,   5.0975342E-04,   5.2332127E-04
     +,   5.3702050E-04,   5.5087218E-04,   5.6490401E-04
     +,   5.7914644E-04,   5.9363473E-04,   6.0840847E-04
     +,   6.2351243E-04,   6.3899514E-04,   6.5490988E-04
     +,   6.7131413E-04,   6.8826939E-04,   7.0584117E-04
     +,   7.2409835E-04,   7.4311282E-04,   7.6295860E-04
     +,   7.8371342E-04,   8.0545375E-04,   8.2825875E-04
     +,   8.5220666E-04,   8.7737438E-04,   9.0383721E-04
     +,   9.3166711E-04,   9.6093211E-04,   9.9169498E-04
     +,   1.0240118E-03,   1.0579315E-03,   1.0934940E-03
     +,   1.1307291E-03,   1.1696556E-03,   1.2102794E-03
     +,   1.2525953E-03,   1.2965796E-03,   1.3421974E-03
     +,   1.3893954E-03,   1.4381044E-03,   1.4882369E-03
     +,   1.5396889E-03,   1.5923379E-03,   1.6460444E-03
     +,   1.7006486E-03,   1.7559772E-03,   1.8118412E-03
     +,   1.8680302E-03,   1.9243273E-03,   1.9804952E-03
     +,   2.0362923E-03,   2.0914611E-03,   2.1457435E-03
     +,   2.1988677E-03,   2.2505682E-03,   2.3005705E-03
     +,   2.3486076E-03,   2.3944168E-03,   2.4377389E-03
     +,   2.4783260E-03,   2.5159444E-03,   2.5503743E-03
     +,   2.5814106E-03,   2.6088704E-03,   2.6325881E-03
     +,   2.6524256E-03,   2.6682655E-03,   2.6800174E-03
     +,   2.6876167E-03,   2.6910268E-03,   2.6902375E-03
     +,   2.6852665E-03,   2.6761598E-03,   2.6629877E-03
     +,   2.6458502E-03,   2.6248693E-03,   2.6001921E-03
     +,   2.5719902E-03,   2.5404540E-03,   2.5057986E-03
     +,   2.4682537E-03,   2.4280732E-03,   2.3855239E-03
     +,   2.3408958E-03,   2.2944920E-03,   2.2466392E-03
     +,   2.1976817E-03,   2.1479847E-03,   2.0979431E-03
     +,   2.0479790E-03,   1.9985454E-03,   1.9501307E-03
     +,   1.9032717E-03,   1.8585452E-03,   1.8165872E-03
     +,   1.7780835E-03,   1.7437871E-03,   1.7145090E-03
     +,   1.6911271E-03,   1.6745793E-03,   1.6658648E-03
     +,   1.6660314E-03,   1.6761704E-03,   1.6974006E-03
     +,   1.7308509E-03,   1.7776446E-03,   1.8388766E-03
     +,   1.9155827E-03,   2.0087303E-03,   2.1191731E-03
     +,   2.2476520E-03,   2.3947444E-03,   2.5608770E-03
     +,   2.7462712E-03,   2.9509747E-03,   3.1748030E-03
     +,   3.4173813E-03,   3.6781337E-03,   3.9562727E-03
     +,   4.2508394E-03,   4.5607677E-03,   4.8849266E-03
     +,   5.2221841E-03,   5.5715479E-03,   5.9323385E-03
     +,   6.3043535E-03,   6.6880342E-03,   7.0847552E-03
     +,   7.4969856E-03,   7.9284236E-03,   8.3840759E-03
     +,   8.8702645E-03,   9.3944073E-03,   9.9646961E-03
     +,   1.0589728E-02,   1.1278168E-02,   1.2038440E-02
     +,   1.2878648E-02,   1.3806857E-02,   1.4831683E-02
     +,   1.5962727E-02,   1.7210467E-02,   1.8585382E-02
     +,   2.0094868E-02,   2.1738080E-02,   2.3498969E-02
     +,   2.5338894E-02,   2.7191017E-02,   2.8959963E-02
     +,   3.0530974E-02,   3.1790417E-02,   3.2657936E-02
     +,   3.3127189E-02,   3.3308752E-02,   3.3465464E-02
     +,   3.4030605E-02,   3.5599139E-02,   3.8883884E-02
     +,   4.4629831E-02,   5.3482797E-02,   6.5821059E-02
     +,   8.1578806E-02,   0.1001114    ,   0.1201708    
     +,   0.1400492    ,   0.1578882    ,   0.1720737    
     +,   0.1815836    ,   0.1861540    ,   0.1861971    
     +,   0.1825198    ,   0.1759837    ,   0.1672529    
     +,   0.1567172    ,   0.1445821    ,   0.1310366    
     +,   0.1164013    ,   0.1011878    ,   8.6056389E-02
     +,   7.1700074E-02,   5.8711663E-02,   4.7483820E-02
     +,   3.8168736E-02,   3.0697601E-02,   2.4844777E-02
     +,   2.0309113E-02,   1.6785903E-02,   1.4013632E-02
     +,   1.1794843E-02,   9.9945208E-03,   8.5256714E-03
     +,   7.3314533E-03,   6.3700965E-03,   5.6050797E-03
     +,   5.0005824E-03,   4.5210253E-03,   4.1327728E-03
     +,   3.8063009E-03,   3.5177884E-03,   3.2498136E-03
     +,   2.9911445E-03,   2.7358797E-03,   2.4821742E-03
     +,   2.2309774E-03,   1.9848952E-03,   1.7472394E-03
     +,   1.5213358E-03,   1.3100955E-03,   1.1157760E-03
     +,   9.3985902E-04,   7.8304217E-04,   6.4532226E-04
     +,   5.2611297E-04,   4.2436188E-04,   3.3867825E-04
     +,   2.6746606E-04,   2.0903868E-04,   1.6169426E-04
     +,   1.2379505E-04,   9.3818438E-05,   7.0385300E-05
     +,   5.2276420E-05,   3.8439510E-05,   2.7984674E-05
     +,   2.0172207E-05,   1.4397425E-05,   1.0174645E-05
     +,   7.1198206E-06,   4.9333971E-06,   3.3849458E-06
     +,   2.2997890E-06,   1.5473092E-06,   1.0309343E-06
     +,   6.8025167E-07,   4.4456993E-07,   2.8781210E-07
     +,   1.8461304E-07,   1.1736228E-07,   7.3979116E-08
     +,   4.6269111E-08,   2.8738869E-08,   1.7750271E-08
     +,   1.0921781E-08,   6.7115957E-09,   4.1327888E-09
     +,   2.5609472E-09,   1.6053836E-09,   1.0240496E-09
     +,   6.6860950E-10,   4.4902762E-10,   3.1109348E-10
     +,   2.2239684E-10,   1.6366543E-10,   1.2346485E-10
     +,   9.4992264E-11,   7.4168331E-11,   5.8512008E-11
     +,   4.6480063E-11,   3.7080582E-11,   2.9653634E-11
     +,   2.3740333E-11,   1.9010737E-11,   1.5217747E-11
     +,   1.2172590E-11,   9.7270733E-12,   7.7640186E-12
     +,   6.1893975E-12,   4.9277006E-12,   3.9179437E-12
     +,   3.1108215E-12,   2.4665834E-12,   1.9530386E-12
     +,   1.5442695E-12,   1.2193447E-12,   9.6145054E-13
     +,   7.5703604E-13,   5.9525328E-13,   4.6738703E-13
     +,   3.6647641E-13,   2.8694923E-13,   2.2436802E-13
     +,   1.7518784E-13,   1.3659787E-13
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_haonly_htt95_mass = Yx/0.9503963
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_haonly_ttz100_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  7.0173643E-04,   7.0782949E-04
     +,   7.1389583E-04,   7.1994099E-04,   7.2597113E-04
     +,   7.3199190E-04,   7.3800964E-04,   7.4403052E-04
     +,   7.5006066E-04,   7.5610651E-04,   7.6217443E-04
     +,   7.6827075E-04,   7.7440176E-04,   7.8057399E-04
     +,   7.8679324E-04,   7.9306611E-04,   7.9939858E-04
     +,   8.0579653E-04,   8.1226591E-04,   8.1881235E-04
     +,   8.2544144E-04,   8.3215837E-04,   8.3896826E-04
     +,   8.4587623E-04,   8.5288665E-04,   8.6000410E-04
     +,   8.6723262E-04,   8.7457587E-04,   8.8203757E-04
     +,   8.8962063E-04,   8.9732790E-04,   9.0516190E-04
     +,   9.1312476E-04,   9.2121790E-04,   9.2944258E-04
     +,   9.3779975E-04,   9.4628974E-04,   9.5491234E-04
     +,   9.6366729E-04,   9.7255316E-04,   9.8156859E-04
     +,   9.9071162E-04,   9.9997956E-04,   1.0093694E-03
     +,   1.0188773E-03,   1.0284989E-03,   1.0382299E-03
     +,   1.0480647E-03,   1.0579972E-03,   1.0680209E-03
     +,   1.0781288E-03,   1.0883132E-03,   1.0985651E-03
     +,   1.1088765E-03,   1.1192370E-03,   1.1296369E-03
     +,   1.1400651E-03,   1.1505102E-03,   1.1609601E-03
     +,   1.1714021E-03,   1.1818233E-03,   1.1922097E-03
     +,   1.2025465E-03,   1.2128192E-03,   1.2230129E-03
     +,   1.2331108E-03,   1.2430976E-03,   1.2529555E-03
     +,   1.2626682E-03,   1.2722177E-03,   1.2815871E-03
     +,   1.2907579E-03,   1.2997128E-03,   1.3084335E-03
     +,   1.3169019E-03,   1.3251009E-03,   1.3330129E-03
     +,   1.3406206E-03,   1.3479076E-03,   1.3548585E-03
     +,   1.3614582E-03,   1.3676927E-03,   1.3735495E-03
     +,   1.3790169E-03,   1.3840859E-03,   1.3887482E-03
     +,   1.3929978E-03,   1.3968317E-03,   1.4002483E-03
     +,   1.4032498E-03,   1.4058410E-03,   1.4080296E-03
     +,   1.4098270E-03,   1.4112486E-03,   1.4123131E-03
     +,   1.4130438E-03,   1.4134677E-03,   1.4136165E-03
     +,   1.4135258E-03,   1.4132358E-03,   1.4127912E-03
     +,   1.4122402E-03,   1.4116355E-03,   1.4110336E-03
     +,   1.4104940E-03,   1.4100788E-03,   1.4098532E-03
     +,   1.4098833E-03,   1.4102369E-03,   1.4109812E-03
     +,   1.4121828E-03,   1.4139067E-03,   1.4162151E-03
     +,   1.4191655E-03,   1.4228107E-03,   1.4271971E-03
     +,   1.4323632E-03,   1.4383388E-03,   1.4451434E-03
     +,   1.4527858E-03,   1.4612633E-03,   1.4705593E-03
     +,   1.4806449E-03,   1.4914777E-03,   1.5030022E-03
     +,   1.5151493E-03,   1.5278397E-03,   1.5409831E-03
     +,   1.5544823E-03,   1.5682351E-03,   1.5821396E-03
     +,   1.5960982E-03,   1.6100241E-03,   1.6238471E-03
     +,   1.6375225E-03,   1.6510403E-03,   1.6644306E-03
     +,   1.6777768E-03,   1.6912217E-03,   1.7049770E-03
     +,   1.7193268E-03,   1.7346326E-03,   1.7513331E-03
     +,   1.7699390E-03,   1.7910220E-03,   1.8152007E-03
     +,   1.8431197E-03,   1.8754173E-03,   1.9126949E-03
     +,   1.9554840E-03,   2.0042073E-03,   2.0591393E-03
     +,   2.1203826E-03,   2.1878569E-03,   2.2612989E-03
     +,   2.3402821E-03,   2.4242841E-03,   2.5127842E-03
     +,   2.6053982E-03,   2.7020480E-03,   2.8032095E-03
     +,   2.9101733E-03,   3.0253434E-03,   3.1525751E-03
     +,   3.2975308E-03,   3.4680131E-03,   3.6742673E-03
     +,   3.9292541E-03,   4.2488519E-03,   4.6519591E-03
     +,   5.1604295E-03,   5.7989219E-03,   6.5946374E-03
     +,   7.5768181E-03,   8.7759746E-03,   1.0223222E-02
     +,   1.1949222E-02,   1.3982800E-02,   1.6349608E-02
     +,   1.9070668E-02,   2.2160465E-02,   2.5624668E-02
     +,   2.9458089E-02,   3.3642650E-02,   3.8145002E-02
     +,   4.2914007E-02,   4.7879539E-02,   5.2951857E-02
     +,   5.8021769E-02,   6.2961735E-02,   6.7630485E-02
     +,   7.1877658E-02,   7.5550780E-02,   7.8503959E-02
     +,   8.0607556E-02,   8.1757069E-02,   8.1881665E-02
     +,   8.0951095E-02,   7.8979485E-02,   7.6025851E-02
     +,   7.2191626E-02,   6.7614533E-02,   6.2459156E-02
     +,   5.6906413E-02,   5.1142465E-02,   4.5346312E-02
     +,   3.9680287E-02,   3.4282576E-02,   2.9261624E-02
     +,   2.4693457E-02,   2.0622460E-02,   1.7064260E-02
     +,   1.4009673E-02,   1.1429973E-02,   9.2828711E-03
     +,   7.5181462E-03,   6.0823248E-03,   4.9225641E-03
     +,   3.9896988E-03,   3.2401313E-03,   2.6365742E-03
     +,   2.1483267E-03,   1.7508928E-03,   1.4252050E-03
     +,   1.1566952E-03,   9.3438657E-04,   7.5002812E-04
     +,   5.9732853E-04,   4.7135775E-04,   3.6812626E-04
     +,   2.8428310E-04,   2.1691722E-04,   1.6344429E-04
     +,   1.2155787E-04,   8.9208377E-05,   6.4586900E-05
     +,   4.6126454E-05,   3.2495875E-05,   2.2585735E-05
     +,   1.5490783E-05,   1.0488799E-05,   7.0159363E-06
     +,   4.6407940E-06,   3.0400138E-06,   1.9762724E-06
     +,   1.2788363E-06,   8.2716019E-07,   5.3773118E-07
     +,   3.5379324E-07,   2.3747079E-07,   1.6390695E-07
     +,   1.1707866E-07,   8.6824578E-08,   6.6796403E-08
     +,   5.3082353E-08,   4.3301913E-08,   3.6019244E-08
     +,   3.0371520E-08,   2.5838425E-08,   2.2102711E-08
     +,   1.8966260E-08,   1.6300360E-08,   1.4016976E-08
     +,   1.2052519E-08,   1.0358679E-08,   8.8967695E-09
     +,   7.6348332E-09,   6.5459611E-09,   5.6070739E-09
     +,   4.7981539E-09,   4.1018335E-09,   3.5030527E-09
     +,   2.9886886E-09,   2.5472708E-09,   2.1688458E-09
     +,   1.8447771E-09,   1.5675309E-09,   1.3306102E-09
     +,   1.1283433E-09,   9.5585806E-10,   8.0891371E-10
     +,   6.8386680E-10,   5.7756017E-10,   4.8728527E-10
     +,   4.1070083E-10,   3.4580244E-10,   2.9086339E-10
     +,   2.4440266E-10,   2.0515535E-10,   1.7203436E-10
     +,   1.4411469E-10,   1.2060249E-10,   1.0082433E-10
     +,   8.4203346E-11,   7.0251159E-11,   5.8550748E-11
     +,   4.8749699E-11,   4.0547767E-11,   3.3691602E-11
     +,   2.7966098E-11,   2.3190101E-11
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_haonly_ttz100_mass = Yx/0.50557164
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_haonly_ttz105_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   1.2747566E-38,   4.5740238E-37,   1.5234890E-35
     +,   4.6651840E-34,   1.3194520E-32,   3.4465116E-31
     +,   8.3138348E-30,   1.8523479E-28,   3.8124792E-27
     +,   7.2482746E-26,   1.2728846E-24,   2.0650892E-23
     +,   3.0956520E-22,   4.2872678E-21,   5.4864499E-20
     +,   6.4886643E-19,   7.0918652E-18,   7.1632604E-17
     +,   6.6875459E-16,   5.7714746E-15,   4.6042817E-14
     +,   3.3953724E-13,   2.3147619E-12,   1.4590065E-11
     +,   8.5019089E-11,   4.5799287E-10,   2.2808748E-09
     +,   1.0501427E-08,   4.4692335E-08,   1.7581129E-07
     +,   6.3924659E-07,   2.1479943E-06,   6.6692000E-06
     +,   1.9131619E-05,   5.0701245E-05,   1.2410629E-04
     +,   2.8054244E-04,   5.8556732E-04,   1.1284089E-03
     +,   2.0071794E-03,   3.2950325E-03,   4.9914620E-03
     +,   6.9764112E-03,   8.9955125E-03,   1.0703479E-02
     +,   1.1776352E-02,   1.2099086E-02,   1.2042877E-02
     +,   1.2771553E-02,   1.6179942E-02,   2.3752593E-02
     +,   3.4602653E-02,   4.5333456E-02,   5.3626284E-02
     +,   6.0845256E-02,   6.8308376E-02,   7.4440852E-02
     +,   8.1160434E-02,   9.7394943E-02,   0.1255869    
     +,   0.1496634    ,   0.1484064    ,   0.1210387    
     +,   9.1016240E-02,   7.8223959E-02,   7.7107973E-02
     +,   7.2551392E-02,   6.0898874E-02,   4.5966376E-02
     +,   3.0989056E-02,   1.8339595E-02,   9.4882213E-03
     +,   4.3136748E-03,   1.7219167E-03,   5.9582532E-04
     +,   1.7541417E-04,   4.3214830E-05,   8.8082988E-06
     +,   1.4755474E-06,   2.0244502E-07,   2.2713280E-08
     +,   2.0825890E-09,   1.5600039E-10,   9.5446246E-12
     +,   4.7700347E-13,   1.9474019E-14,   6.4940857E-16
     +,   1.7687112E-17,   3.9352358E-19,   7.1518189E-21
     +,   1.0615150E-22,   1.2869430E-24,   1.2746199E-26
     +,   1.0311667E-28,   6.8129635E-31,   3.6767450E-33
     +,   1.6210225E-35,   5.8378066E-38,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_haonly_ttz105_mass = Yx/0.391916
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_haonly_ttz107_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.5898269E-05,   3.9809380E-05
     +,   4.4072145E-05,   4.8709066E-05,   5.3743028E-05
     +,   5.9197220E-05,   6.5094966E-05,   7.1459530E-05
     +,   7.8313969E-05,   8.5681218E-05,   9.3583403E-05
     +,   1.0204199E-04,   1.1107740E-04,   1.2070894E-04
     +,   1.3095437E-04,   1.4182976E-04,   1.5334919E-04
     +,   1.6552453E-04,   1.7836520E-04,   1.9187777E-04
     +,   2.0606586E-04,   2.2092977E-04,   2.3646600E-04
     +,   2.5266845E-04,   2.6952507E-04,   2.8702160E-04
     +,   3.0513841E-04,   3.2385145E-04,   3.4313239E-04
     +,   3.6294799E-04,   3.8326034E-04,   4.0402682E-04
     +,   4.2520004E-04,   4.4672805E-04,   4.6855430E-04
     +,   4.9061800E-04,   5.1285408E-04,   5.3519331E-04
     +,   5.5756426E-04,   5.7988975E-04,   6.0209224E-04
     +,   6.2409032E-04,   6.4580096E-04,   6.6713960E-04
     +,   6.8802078E-04,   7.0835865E-04,   7.2806748E-04
     +,   7.4706250E-04,   7.6525996E-04,   7.8257854E-04
     +,   7.9893897E-04,   8.1426569E-04,   8.2848623E-04
     +,   8.4153377E-04,   8.5334462E-04,   8.6386164E-04
     +,   8.7303319E-04,   8.8081392E-04,   8.8716496E-04
     +,   8.9205452E-04,   8.9545787E-04,   8.9735829E-04
     +,   8.9774560E-04,   8.9661818E-04,   8.9398166E-04
     +,   8.8984938E-04,   8.8424195E-04,   8.7718799E-04
     +,   8.6872216E-04,   8.5888727E-04,   8.4773084E-04
     +,   8.3530846E-04,   8.2167913E-04,   8.0690940E-04
     +,   7.9106848E-04,   7.7422988E-04,   7.5647142E-04
     +,   7.3787424E-04,   7.1852014E-04,   6.9849292E-04
     +,   6.7787914E-04,   6.5676332E-04,   6.3523260E-04
     +,   6.1337068E-04,   5.9126277E-04,   5.6898972E-04
     +,   5.4663268E-04,   5.2426761E-04,   5.0197012E-04
     +,   4.7981029E-04,   4.5785439E-04,   4.3616618E-04
     +,   4.1480514E-04,   3.9382483E-04,   3.7327432E-04
     +,   3.5320001E-04,   3.3364096E-04,   3.1463400E-04
     +,   2.9620875E-04,   2.7839266E-04,   2.6120627E-04
     +,   2.4466793E-04,   2.2878972E-04,   2.1358154E-04
     +,   1.9904795E-04,   1.8519002E-04,   1.7200621E-04
     +,   1.5949189E-04,   1.4763862E-04,   1.3643537E-04
     +,   1.2586992E-04,   1.1592644E-04,   1.0658868E-04
     +,   9.7837488E-05,   8.9653586E-05,   8.2015395E-05
     +,   7.4901625E-05,   6.8289301E-05,   6.2155894E-05
     +,   5.6477915E-05,   5.1231898E-05,   4.6394769E-05
     +,   4.1943607E-05,   3.7855545E-05,   3.4108172E-05
     +,   3.0680039E-05,   2.7549799E-05,   2.4697296E-05
     +,   2.2102711E-05,   1.9747411E-05,   1.7613267E-05
     +,   1.5683325E-05,   1.3941246E-05,   1.2371819E-05
     +,   1.0960547E-05,   9.6938484E-06,   8.5590700E-06
     +,   7.5444195E-06,   6.6388352E-06,   5.8320716E-06
     +,   5.1147040E-06,   4.4780290E-06,   3.9139945E-06
     +,   3.4152179E-06,   2.9749890E-06,   2.5871357E-06
     +,   2.2460422E-06,   1.9466295E-06,   1.6842923E-06
     +,   1.4548510E-06,   1.2545391E-06,   1.0799829E-06
     +,   9.2815060E-07,   7.9631877E-07,   6.8205583E-07
     +,   5.8320268E-07,   4.9783836E-07,   4.2425219E-07
     +,   3.6093104E-07,   3.0654437E-07,   2.5991397E-07
     +,   2.2000383E-07,   1.8590819E-07,   1.5683283E-07
     +,   1.3208341E-07,   1.1105727E-07,   9.3238711E-08
     +,   7.8200713E-08,   6.5629997E-08,   5.5408311E-08
     +,   4.7822418E-08,   4.4070276E-08,   4.7426404E-08
     +,   6.5801657E-08,   1.1711541E-07,   2.4011217E-07
     +,   5.1518600E-07,   1.1026367E-06,   2.3097280E-06
     +,   4.7026383E-06,   9.2834343E-06,   1.7753460E-05
     +,   3.2881169E-05,   5.8979855E-05,   1.0247075E-04
     +,   1.7246458E-04,   2.8125852E-04,   4.4461430E-04
     +,   6.8166782E-04,   1.0143862E-03,   1.4668168E-03
     +,   2.0644092E-03,   2.8341413E-03,   3.8064921E-03
     +,   5.0200759E-03,   6.5290513E-03,   8.4123192E-03
     +,   1.0782223E-02,   1.3788599E-02,   1.7612899E-02
     +,   2.2448163E-02,   2.8464168E-02,   3.5760768E-02
     +,   4.4316761E-02,   5.3946149E-02,   6.4278461E-02
     +,   7.4767932E-02,   8.4737159E-02,   9.3451641E-02
     +,   0.1002109    ,   0.1044382    ,   0.1057546    
     +,   0.1040266    ,   9.9378236E-02,   9.2171036E-02
     +,   8.2956977E-02,   7.2411098E-02,   6.1253048E-02
     +,   5.0170492E-02,   3.9753158E-02,   3.0442353E-02
     +,   2.2508539E-02,   1.6053859E-02,   1.1035734E-02
     +,   7.3056649E-03,   4.6540899E-03,   2.8513754E-03
     +,   1.6791313E-03,   9.4997277E-04,   5.1611767E-04
     +,   2.6918907E-04,   1.3474877E-04,   6.4720516E-05
     +,   2.9820605E-05,   1.3179702E-05,   5.5866130E-06
     +,   2.2708768E-06,   8.8516373E-07,   3.3085075E-07
     +,   1.1857457E-07,   4.0745299E-08,   1.3424514E-08
     +,   4.2410147E-09,   1.2846203E-09,   3.7307646E-10
     +,   1.0388598E-10,   2.7737933E-11,   7.1012870E-12
     +,   1.7431653E-12,   4.1035580E-13,   9.2667146E-14
     +,   2.0096406E-14,   4.2035069E-15,   8.6155834E-16
     +,   1.8299744E-16,   4.7151151E-17,   1.8271440E-17
     +,   1.0365296E-17,   6.9753246E-18,   4.9269756E-18
     +,   3.5165259E-18,   2.5124116E-18,   1.7930041E-18
     +,   1.2775602E-18,   9.0879397E-19,   6.4538544E-19
     +,   4.5754374E-19,   3.2382761E-19,   2.2880537E-19
     +,   1.6139357E-19,   1.1364990E-19,   7.9894396E-20
     +,   5.6070948E-20,   3.9284746E-20,   2.7477324E-20
     +,   1.9186433E-20,   1.3374480E-20,   9.3074468E-21
     +,   6.4661682E-21,   4.4847116E-21,   3.1051771E-21
     +,   2.1463772E-21,   1.4811195E-21,   1.0203408E-21
     +,   7.0171891E-22,   4.8178368E-22,   3.3022285E-22
     +,   2.2595652E-22,   1.5435254E-22,   1.0526047E-22
     +,   7.1661854E-23,   4.8704806E-23,   3.3046841E-23
     +,   2.2384507E-23,   1.5136933E-23,   1.0218550E-23
     +,   6.8867352E-24,   4.6334053E-24,   3.1121217E-24
     +,   2.0867749E-24,   1.3969067E-24
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_haonly_ttz107_mass = Yx/0.383396086956522
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_haonly_ttz110_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   3.5460488E-38
     +,   2.4505217E-37,   1.6542844E-36,   1.0907788E-35
     +,   7.0254011E-35,   4.4201806E-34,   2.7165449E-33
     +,   1.6306920E-32,   9.5616967E-32,   5.4768703E-31
     +,   3.0641480E-30,   1.6746400E-29,   8.9395300E-29
     +,   4.6616436E-28,   2.3743600E-27,   1.1813637E-26
     +,   5.7412360E-26,   2.7255660E-25,   1.2638418E-24
     +,   5.7244895E-24,   2.5328456E-23,   1.0946835E-22
     +,   4.6211835E-22,   1.9055812E-21,   7.6758459E-21
     +,   3.0200432E-20,   1.1607166E-19,   4.3574163E-19
     +,   1.5979190E-18,   5.7236556E-18,   2.0026888E-17
     +,   6.8445245E-17,   2.2850638E-16,   7.4514912E-16
     +,   2.3735460E-15,   7.3853743E-15,   2.2446847E-14
     +,   6.6639172E-14,   1.9324585E-13,   5.4741210E-13
     +,   1.5146915E-12,   4.0938030E-12,   1.0807810E-11
     +,   2.7871996E-11,   7.0209054E-11,   1.7275290E-10
     +,   4.1521928E-10,   9.7484598E-10,   2.2355766E-09
     +,   5.0078386E-09,   1.0957974E-08,   2.3421597E-08
     +,   4.8898851E-08,   9.9721511E-08,   1.9865342E-07
     +,   3.8655349E-07,   7.3471887E-07,   1.3640800E-06
     +,   2.4738572E-06,   4.3823579E-06,   7.5831367E-06
     +,   1.2817529E-05,   2.1162494E-05,   3.4129465E-05
     +,   5.3765078E-05,   8.2734339E-05,   1.2436004E-04
     +,   1.8259275E-04,   2.6188206E-04,   3.6691426E-04
     +,   5.0220091E-04,   6.7155733E-04,   8.7752903E-04
     +,   1.1208500E-03,   1.4000890E-03,   1.7117901E-03
     +,   2.0511684E-03,   2.4135557E-03,   2.7966111E-03
     +,   3.2029306E-03,   3.6423011E-03,   4.1326084E-03
     +,   4.6982886E-03,   5.3654741E-03,   6.1538280E-03
     +,   7.0666056E-03,   8.0820881E-03,   9.1501838E-03
     +,   1.0197283E-02,   1.1140254E-02,   1.1907215E-02
     +,   1.2458557E-02,   1.2802294E-02,   1.3000067E-02
     +,   1.3163952E-02,   1.3445103E-02,   1.4010937E-02
     +,   1.5004509E-02,   1.6493399E-02,   1.8448142E-02
     +,   2.0806978E-02,   2.3622075E-02,   2.7149471E-02
     +,   3.1712536E-02,   3.7393164E-02,   4.3853011E-02
     +,   5.0386693E-02,   5.5921551E-02,   5.9062786E-02
     +,   5.9105143E-02,   5.8035247E-02,   6.0903288E-02
     +,   7.1963370E-02,   8.9112617E-02,   0.1032517    
     +,   0.1048422    ,   9.1379762E-02,   6.8383336E-02
     +,   4.4234101E-02,   2.4874065E-02,   1.2170717E-02
     +,   5.1590959E-03,   1.8800867E-03,   5.8403990E-04
     +,   1.5349989E-04,   3.3938388E-05,   6.2880372E-06
     +,   9.7388806E-07,   1.2588009E-07,   1.3563835E-08
     +,   1.2176292E-09,   9.1029205E-11,   5.6654334E-12
     +,   2.9372403E-13,   1.2789074E-14,   5.0104789E-16
     +,   2.7716028E-17,   4.3841449E-18,   1.1307520E-18
     +,   3.0465936E-19,   8.0604227E-20,   2.0838008E-20
     +,   5.2624815E-21,   1.2981706E-21,   3.1279587E-22
     +,   7.3620116E-23,   1.6926216E-23,   3.8012773E-24
     +,   8.3384590E-25,   1.7867812E-25,   3.7399288E-26
     +,   7.6461021E-27,   1.5269497E-27,   2.9787723E-28
     +,   5.6762235E-29,   1.0564886E-29,   1.9207672E-30
     +,   3.4112681E-31,   5.9179082E-32,   1.0027641E-32
     +,   1.6597420E-33,   2.6835535E-34,   4.2382957E-35
     +,   6.5380818E-36,   9.8524430E-37,   1.4502477E-37
     +,   2.0850918E-38,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00,   0.0000000E+00
     +,   0.0000000E+00,   0.0000000E+00
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_haonly_ttz110_mass = Yx/0.320658545454545
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_haonly_ttz115_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.2150230E-08,   1.5642390E-08
     +,   2.0083254E-08,   2.5714540E-08,   3.2835135E-08
     +,   4.1813433E-08,   5.3101896E-08,   6.7255051E-08
     +,   8.4949257E-08,   1.0700886E-07,   1.3443264E-07
     +,   1.6842939E-07,   2.1045548E-07,   2.6226135E-07
     +,   3.2594406E-07,   4.0400661E-07,   4.9942878E-07
     +,   6.1574514E-07,   7.5713513E-07,   9.2852599E-07
     +,   1.1357071E-06,   1.3854567E-06,   1.6856869E-06
     +,   2.0456212E-06,   2.4759179E-06,   2.9889461E-06
     +,   3.5989308E-06,   4.3222190E-06,   5.1775232E-06
     +,   6.1861956E-06,   7.3725319E-06,   8.7640628E-06
     +,   1.0391906E-05,   1.2291104E-05,   1.4500974E-05
     +,   1.7065544E-05,   2.0033856E-05,   2.3460379E-05
     +,   2.7405658E-05,   3.1936081E-05,   3.7125119E-05
     +,   4.3053042E-05,   4.9807553E-05,   5.7484107E-05
     +,   6.6186163E-05,   7.6025499E-05,   8.7122367E-05
     +,   9.9605597E-05,   1.1361283E-04,   1.2929019E-04
     +,   1.4679250E-04,   1.6628276E-04,   1.8793152E-04
     +,   2.1191823E-04,   2.3842650E-04,   2.6764849E-04
     +,   2.9977958E-04,   3.3501949E-04,   3.7357007E-04
     +,   4.1563396E-04,   4.6141254E-04,   5.1110488E-04
     +,   5.6490139E-04,   6.2298850E-04,   6.8554276E-04
     +,   7.5272092E-04,   8.2467176E-04,   9.0151513E-04
     +,   9.8335766E-04,   1.0702692E-03,   1.1623002E-03
     +,   1.2594560E-03,   1.3617182E-03,   1.4690134E-03
     +,   1.5812364E-03,   1.6982350E-03,   1.8198008E-03
     +,   1.9456741E-03,   2.0755490E-03,   2.2090671E-03
     +,   2.3458002E-03,   2.4852846E-03,   2.6269830E-03
     +,   2.7703240E-03,   2.9146676E-03,   3.0593444E-03
     +,   3.2036244E-03,   3.3467573E-03,   3.4879404E-03
     +,   3.6263608E-03,   3.7611863E-03,   3.8915635E-03
     +,   4.0166387E-03,   4.1355724E-03,   4.2475415E-03
     +,   4.3517356E-03,   4.4473941E-03,   4.5337887E-03
     +,   4.6102549E-03,   4.6761818E-03,   4.7310363E-03
     +,   4.7743567E-03,   4.8057707E-03,   4.8249904E-03
     +,   4.8318282E-03,   4.8261886E-03,   4.8080748E-03
     +,   4.7775935E-03,   4.7349464E-03,   4.6804301E-03
     +,   4.6144389E-03,   4.5374469E-03,   4.4500194E-03
     +,   4.3527870E-03,   4.2464565E-03,   4.1317814E-03
     +,   4.0095774E-03,   3.8806836E-03,   3.7459850E-03
     +,   3.6063718E-03,   3.4627418E-03,   3.3160020E-03
     +,   3.1670472E-03,   3.0167431E-03,   2.8659273E-03
     +,   2.7154151E-03,   2.5659604E-03,   2.4182878E-03
     +,   2.2730490E-03,   2.1308567E-03,   1.9922457E-03
     +,   1.8577061E-03,   1.7276475E-03,   1.6024327E-03
     +,   1.4823498E-03,   1.3676268E-03,   1.2584402E-03
     +,   1.1549104E-03,   1.0570993E-03,   9.6502085E-04
     +,   8.7865203E-04,   7.9793110E-04,   7.2275713E-04
     +,   6.5300410E-04,   5.8853050E-04,   5.2917516E-04
     +,   4.7477143E-04,   4.2515839E-04,   3.8018651E-04
     +,   3.3972590E-04,   3.0368278E-04,   2.7201505E-04
     +,   2.4474651E-04,   2.2198458E-04,   2.0394463E-04
     +,   1.9097682E-04,   1.8359187E-04,   1.8249337E-04
     +,   1.8861414E-04,   2.0315172E-04,   2.2760844E-04
     +,   2.6383114E-04,   3.1404488E-04,   3.8088564E-04
     +,   4.6743051E-04,   5.7721126E-04,   7.1420294E-04
     +,   8.8280620E-04,   1.0878127E-03,   1.3343265E-03
     +,   1.6276356E-03,   1.9730763E-03,   2.3758800E-03
     +,   2.8409434E-03,   3.3725312E-03,   3.9740927E-03
     +,   4.6479474E-03,   5.3949570E-03,   6.2142918E-03
     +,   7.1032736E-03,   8.0571724E-03,   9.0690646E-03
     +,   1.0129899E-02,   1.1228715E-02,   1.2352832E-02
     +,   1.3488155E-02,   1.4619727E-02,   1.5732409E-02
     +,   1.6811429E-02,   1.7842948E-02,   1.8814916E-02
     +,   1.9717528E-02,   2.0543618E-02,   2.1289011E-02
     +,   2.1952637E-02,   2.2536369E-02,   2.3044605E-02
     +,   2.3483800E-02,   2.3861744E-02,   2.4186715E-02
     +,   2.4466587E-02,   2.4708018E-02,   2.4915701E-02
     +,   2.5091780E-02,   2.5235508E-02,   2.5343115E-02
     +,   2.5408022E-02,   2.5421225E-02,   2.5371959E-02
     +,   2.5248544E-02,   2.5039239E-02,   2.4733249E-02
     +,   2.4321612E-02,   2.3797963E-02,   2.3159113E-02
     +,   2.2405561E-02,   2.1541573E-02,   2.0575067E-02
     +,   1.9517349E-02,   1.8382734E-02,   1.7187705E-02
     +,   1.5950277E-02,   1.4689295E-02,   1.3423593E-02
     +,   1.2171189E-02,   1.0948730E-02,   9.7710760E-03
     +,   8.6508300E-03,   7.5980388E-03,   6.6201813E-03
     +,   5.7222522E-03,   4.9068308E-03,   4.1742530E-03
     +,   3.5229616E-03,   2.9498870E-03,   2.4506485E-03
     +,   2.0199686E-03,   1.6520020E-03,   1.3405787E-03
     +,   1.0794339E-03,   8.6243282E-04,   6.8373315E-04
     +,   5.3787901E-04,   4.1986845E-04,   3.2520923E-04
     +,   2.4993502E-04,   1.9058835E-04,   1.4419475E-04
     +,   1.0823344E-04,   8.0596532E-05,   5.9536465E-05
     +,   4.3624117E-05,   3.1704392E-05,   2.2852391E-05
     +,   1.6335163E-05,   1.1578508E-05,   8.1374146E-06
     +,   5.6701260E-06,   3.9167726E-06,   2.6819525E-06
     +,   1.8202429E-06,   1.2244284E-06,   8.1625046E-07
     +,   5.3921389E-07,   3.5296060E-07,   2.2891957E-07
     +,   1.4709451E-07,   9.3637084E-08,   5.9049658E-08
     +,   3.6887300E-08,   2.2824267E-08,   1.3988291E-08
     +,   8.4911935E-09,   5.1048845E-09,   3.0394363E-09
     +,   1.7922197E-09,   1.0465320E-09,   6.0517308E-10
     +,   3.4653574E-10,   1.9650022E-10,   1.1033150E-10
     +,   6.1343354E-11,   3.3770840E-11,   1.8409184E-11
     +,   9.9362341E-12,   5.3102830E-12,   2.8100040E-12
     +,   1.4722356E-12,   7.6373684E-13,   3.9226960E-13
     +,   1.9948782E-13,   1.0044232E-13,   5.0072976E-14
     +,   2.4714705E-14,   1.2077822E-14,   5.8436596E-15
     +,   2.7993651E-15,   1.3276823E-15,   6.2345971E-16
     +,   2.8985322E-16,   1.3342106E-16
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_haonly_ttz115_mass = Yx/0.293937
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_haonly_ttz120_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.5549045E-06,   5.2992850E-06
     +,   6.1536080E-06,   7.1321410E-06,   8.2506913E-06
     +,   9.5267251E-06,   1.0979516E-05,   1.2630241E-05
     +,   1.4502124E-05,   1.6620641E-05,   1.9013523E-05
     +,   2.1710974E-05,   2.4745796E-05,   2.8153489E-05
     +,   3.1972420E-05,   3.6243873E-05,   4.1012212E-05
     +,   4.6324942E-05,   5.2232823E-05,   5.8789901E-05
     +,   6.6053559E-05,   7.4084594E-05,   8.2947023E-05
     +,   9.2708782E-05,   1.0344012E-04,   1.1521558E-04
     +,   1.2811221E-04,   1.4221021E-04,   1.5759253E-04
     +,   1.7434469E-04,   1.9255457E-04,   2.1231193E-04
     +,   2.3370821E-04,   2.5683609E-04,   2.8178899E-04
     +,   3.0866059E-04,   3.3754410E-04,   3.6853168E-04
     +,   4.0171560E-04,   4.3718255E-04,   4.7501971E-04
     +,   5.1530841E-04,   5.5812602E-04,   6.0354429E-04
     +,   6.5162877E-04,   7.0243777E-04,   7.5602136E-04
     +,   8.1242062E-04,   8.7166682E-04,   9.3378010E-04
     +,   9.9876919E-04,   1.0666301E-03,   1.1373443E-03
     +,   1.2108844E-03,   1.2871992E-03,   1.3662316E-03
     +,   1.4479036E-03,   1.5321223E-03,   1.6187791E-03
     +,   1.7077491E-03,   1.7988911E-03,   1.8920491E-03
     +,   1.9870470E-03,   2.0836995E-03,   2.1818092E-03
     +,   2.2811543E-03,   2.3815145E-03,   2.4826454E-03
     +,   2.5843058E-03,   2.6862342E-03,   2.7881735E-03
     +,   2.8898509E-03,   2.9910028E-03,   3.0913514E-03
     +,   3.1906283E-03,   3.2885685E-03,   3.3849059E-03
     +,   3.4793781E-03,   3.5717392E-03,   3.6617504E-03
     +,   3.7491769E-03,   3.8338064E-03,   3.9154291E-03
     +,   3.9938623E-03,   4.0689255E-03,   4.1404660E-03
     +,   4.2083375E-03,   4.2724200E-03,   4.3326006E-03
     +,   4.3887920E-03,   4.4409204E-03,   4.4889264E-03
     +,   4.5327656E-03,   4.5724129E-03,   4.6078567E-03
     +,   4.6390961E-03,   4.6661468E-03,   4.6890341E-03
     +,   4.7077984E-03,   4.7224867E-03,   4.7331597E-03
     +,   4.7398871E-03,   4.7427472E-03,   4.7418275E-03
     +,   4.7372235E-03,   4.7290400E-03,   4.7173877E-03
     +,   4.7023883E-03,   4.6841670E-03,   4.6628583E-03
     +,   4.6386044E-03,   4.6115532E-03,   4.5818598E-03
     +,   4.5496845E-03,   4.5151948E-03,   4.4785603E-03
     +,   4.4399593E-03,   4.3995678E-03,   4.3575712E-03
     +,   4.3141493E-03,   4.2694844E-03,   4.2237593E-03
     +,   4.1771545E-03,   4.1298438E-03,   4.0819966E-03
     +,   4.0337807E-03,   3.9853496E-03,   3.9368547E-03
     +,   3.8884345E-03,   3.8402244E-03,   3.7923444E-03
     +,   3.7449142E-03,   3.6980403E-03,   3.6518292E-03
     +,   3.6063823E-03,   3.5617985E-03,   3.5181821E-03
     +,   3.4756439E-03,   3.4343018E-03,   3.3942850E-03
     +,   3.3557443E-03,   3.3188504E-03,   3.2837964E-03
     +,   3.2508019E-03,   3.2201209E-03,   3.1920348E-03
     +,   3.1668588E-03,   3.1449390E-03,   3.1266531E-03
     +,   3.1124039E-03,   3.1026159E-03,   3.0977307E-03
     +,   3.0981952E-03,   3.1044565E-03,   3.1169532E-03
     +,   3.1360991E-03,   3.1622741E-03,   3.1958185E-03
     +,   3.2370144E-03,   3.2860802E-03,   3.3431672E-03
     +,   3.4083498E-03,   3.4816258E-03,   3.5629170E-03
     +,   3.6520856E-03,   3.7489424E-03,   3.8532601E-03
     +,   3.9648023E-03,   4.0833624E-03,   4.2087953E-03
     +,   4.3410542E-03,   4.4802418E-03,   4.6266736E-03
     +,   4.7809226E-03,   4.9438598E-03,   5.1167314E-03
     +,   5.3011961E-03,   5.4993466E-03,   5.7137473E-03
     +,   5.9474530E-03,   6.2039904E-03,   6.4873034E-03
     +,   6.8017007E-03,   7.1517825E-03,   7.5422945E-03
     +,   7.9779476E-03,   8.4632328E-03,   9.0022432E-03
     +,   9.5984004E-03,   1.0254133E-02,   1.0970728E-02
     +,   1.1748016E-02,   1.2584092E-02,   1.3475134E-02
     +,   1.4415338E-02,   1.5396758E-02,   1.6409233E-02
     +,   1.7440526E-02,   1.8476535E-02,   1.9501522E-02
     +,   2.0498358E-02,   2.1449039E-02,   2.2335237E-02
     +,   2.3138778E-02,   2.3842139E-02,   2.4429187E-02
     +,   2.4885627E-02,   2.5199499E-02,   2.5361642E-02
     +,   2.5366055E-02,   2.5210047E-02,   2.4894411E-02
     +,   2.4423406E-02,   2.3804532E-02,   2.3048325E-02
     +,   2.2168035E-02,   2.1179140E-02,   2.0098777E-02
     +,   1.8945234E-02,   1.7737510E-02,   1.6494529E-02
     +,   1.5234752E-02,   1.3975768E-02,   1.2733824E-02
     +,   1.1523409E-02,   1.0357104E-02,   9.2455111E-03
     +,   8.1970757E-03,   7.2180475E-03,   6.3126297E-03
     +,   5.4831677E-03,   4.7302544E-03,   4.0529030E-03
     +,   3.4488416E-03,   2.9147998E-03,   2.4466342E-03
     +,   2.0396223E-03,   1.6886960E-03,   1.3885919E-03
     +,   1.1340035E-03,   9.1973948E-04,   7.4084260E-04
     +,   5.9264904E-04,   4.7084011E-04,   3.7148938E-04
     +,   2.9108219E-04,   2.2650637E-04,   1.7503832E-04
     +,   1.3432761E-04,   1.0237160E-04,   7.7476012E-05
     +,   5.8226258E-05,   4.3454354E-05,   3.2203949E-05
     +,   2.3699369E-05,   1.7318322E-05,   1.2566517E-05
     +,   9.0544636E-06,   6.4779701E-06,   4.6018476E-06
     +,   3.2459484E-06,   2.2733466E-06,   1.5808606E-06
     +,   1.0914747E-06,   7.4822225E-07,   5.0925166E-07
     +,   3.4411826E-07,   2.3086366E-07,   1.5377157E-07
     +,   1.0168493E-07,   6.6755405E-08,   4.3507519E-08
     +,   2.8150801E-08,   1.8082329E-08,   1.1530337E-08
     +,   7.2989756E-09,   4.5866342E-09,   2.8611942E-09
     +,   1.7717489E-09,   1.0890981E-09,   6.6454275E-10
     +,   4.0251136E-10,   2.4199887E-10,   1.4442378E-10
     +,   8.5552856E-11,   5.0304920E-11,   2.9359883E-11
     +,   1.7008048E-11,   9.7795990E-12,   5.5812889E-12
     +,   3.1615969E-12,   1.7775269E-12,   9.9192041E-13
     +,   5.4937229E-13,   3.0199571E-13,   1.6476191E-13
     +,   8.9217452E-14,   4.7946513E-14,   2.5573802E-14
     +,   1.3537624E-14,   7.1123815E-15
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_haonly_ttz120_mass = Yx/0.307934
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_haonly_ttz60_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.4447364E-04,   4.8937142E-04
     +,   5.3775497E-04,   5.8980146E-04,   6.4569054E-04
     +,   7.0560485E-04,   7.6972903E-04,   8.3824946E-04
     +,   9.1135240E-04,   9.8922849E-04,   1.0720646E-03
     +,   1.1600475E-03,   1.2533618E-03,   1.3521888E-03
     +,   1.4567048E-03,   1.5670806E-03,   1.6834775E-03
     +,   1.8060476E-03,   1.9349289E-03,   2.0702435E-03
     +,   2.2120927E-03,   2.3605544E-03,   2.5156701E-03
     +,   2.6774581E-03,   2.8458708E-03,   3.0208267E-03
     +,   3.2021690E-03,   3.3896719E-03,   3.5830243E-03
     +,   3.7818237E-03,   3.9855698E-03,   4.1936589E-03
     +,   4.4053895E-03,   4.6199709E-03,   4.8365444E-03
     +,   5.0542071E-03,   5.2720644E-03,   5.4892725E-03
     +,   5.7051317E-03,   5.9191179E-03,   6.1310222E-03
     +,   6.3410001E-03,   6.5496708E-03,   6.7581986E-03
     +,   6.9683446E-03,   7.1825199E-03,   7.4038026E-03
     +,   7.6359352E-03,   7.8833131E-03,   8.1509519E-03
     +,   8.4444629E-03,   8.7700281E-03,   9.1343904E-03
     +,   9.5448978E-03,   1.0009437E-02,   1.0536527E-02
     +,   1.1135193E-02,   1.1814836E-02,   1.2584921E-02
     +,   1.3454488E-02,   1.4431424E-02,   1.5521537E-02
     +,   1.6727334E-02,   1.8046990E-02,   1.9473065E-02
     +,   2.0991364E-02,   2.2580678E-02,   2.4212275E-02
     +,   2.5850875E-02,   2.7455483E-02,   2.8981691E-02
     +,   3.0383738E-02,   3.1617519E-02,   3.2643124E-02
     +,   3.3427693E-02,   3.3947345E-02,   3.4188692E-02
     +,   3.4149673E-02,   3.3839561E-02,   3.3278197E-02
     +,   3.2494914E-02,   3.1526685E-02,   3.0416472E-02
     +,   2.9210929E-02,   2.7958583E-02,   2.6707528E-02
     +,   2.5503783E-02,   2.4389179E-02,   2.3400042E-02
     +,   2.2565551E-02,   2.1906849E-02,   2.1436423E-02
     +,   2.1157842E-02,   2.1066125E-02,   2.1148521E-02
     +,   2.1385748E-02,   2.1753537E-02,   2.2224288E-02
     +,   2.2768905E-02,   2.3358267E-02,   2.3964671E-02
     +,   2.4562716E-02,   2.5130024E-02,   2.5647268E-02
     +,   2.6098290E-02,   2.6469706E-02,   2.6750496E-02
     +,   2.6931735E-02,   2.7006321E-02,   2.6968848E-02
     +,   2.6815733E-02,   2.6545385E-02,   2.6158515E-02
     +,   2.5658345E-02,   2.5050795E-02,   2.4344388E-02
     +,   2.3550162E-02,   2.2681070E-02,   2.1751570E-02
     +,   2.0776752E-02,   1.9771688E-02,   1.8750792E-02
     +,   1.7727232E-02,   1.6712397E-02,   1.5715810E-02
     +,   1.4745127E-02,   1.3806074E-02,   1.2902910E-02
     +,   1.2038495E-02,   1.1214870E-02,   1.0433308E-02
     +,   9.6948193E-03,   9.0001160E-03,   8.3499253E-03
     +,   7.7448781E-03,   7.1855583E-03,   6.6724764E-03
     +,   6.2059518E-03,   5.7859812E-03,   5.4121986E-03
     +,   5.0838226E-03,   4.7995858E-03,   4.5576994E-03
     +,   4.3558949E-03,   4.1914759E-03,   4.0613404E-03
     +,   3.9620828E-03,   3.8900820E-03,   3.8415869E-03
     +,   3.8128060E-03,   3.8000005E-03,   3.7995612E-03
     +,   3.8080707E-03,   3.8223616E-03,   3.8395552E-03
     +,   3.8570871E-03,   3.8727270E-03,   3.8845784E-03
     +,   3.8910788E-03,   3.8909817E-03,   3.8833437E-03
     +,   3.8675000E-03,   3.8430421E-03,   3.8097892E-03
     +,   3.7677595E-03,   3.7171473E-03,   3.6582961E-03
     +,   3.5916767E-03,   3.5178531E-03,   3.4374681E-03
     +,   3.3512278E-03,   3.2598774E-03,   3.1641792E-03
     +,   3.0649004E-03,   2.9628137E-03,   2.8586623E-03
     +,   2.7531611E-03,   2.6469945E-03,   2.5408033E-03
     +,   2.4351710E-03,   2.3306271E-03,   2.2276528E-03
     +,   2.1266697E-03,   2.0280362E-03,   1.9320511E-03
     +,   1.8389669E-03,   1.7489800E-03,   1.6622319E-03
     +,   1.5788177E-03,   1.4987983E-03,   1.4221884E-03
     +,   1.3489696E-03,   1.2790995E-03,   1.2125100E-03
     +,   1.1491093E-03,   1.0887891E-03,   1.0314333E-03
     +,   9.7691698E-04,   9.2510524E-04,   8.7586197E-04
     +,   8.2905334E-04,   7.8454812E-04,   7.4221491E-04
     +,   7.0192810E-04,   6.6357246E-04,   6.2703539E-04
     +,   5.9221196E-04,   5.5900752E-04,   5.2733510E-04
     +,   4.9711252E-04,   4.6826596E-04,   4.4073013E-04
     +,   4.1444594E-04,   3.8935855E-04,   3.6541861E-04
     +,   3.4258311E-04,   3.2081283E-04,   3.0007068E-04
     +,   2.8032277E-04,   2.6153924E-04,   2.4369040E-04
     +,   2.2674796E-04,   2.1068600E-04,   1.9547906E-04
     +,   1.8110116E-04,   1.6752662E-04,   1.5473081E-04
     +,   1.4268860E-04,   1.3137414E-04,   1.2076127E-04
     +,   1.1082428E-04,   1.0153717E-04,   9.2872993E-05
     +,   8.4804793E-05,   7.7306213E-05,   7.0350121E-05
     +,   6.3909509E-05,   5.7958037E-05,   5.2469448E-05
     +,   4.7417576E-05,   4.2776726E-05,   3.8522066E-05
     +,   3.4629404E-05,   3.1074895E-05,   2.7835578E-05
     +,   2.4889514E-05,   2.2215618E-05,   1.9793526E-05
     +,   1.7603861E-05,   1.5628413E-05,   1.3849735E-05
     +,   1.2251385E-05,   1.0817997E-05,   9.5351561E-06
     +,   8.3893001E-06,   7.3678084E-06,   6.4590208E-06
     +,   5.6521376E-06,   4.9371256E-06,   4.3047548E-06
     +,   3.7466034E-06,   3.2549460E-06,   2.8226957E-06
     +,   2.4434103E-06,   2.1112771E-06,   1.8209922E-06
     +,   1.5677714E-06,   1.3473215E-06,   1.1557814E-06
     +,   9.8967780E-07,   8.4590863E-07,   7.2171684E-07
     +,   6.1464721E-07,   5.2251460E-07,   4.4338614E-07
     +,   3.7556217E-07,   3.1753592E-07,   2.6799057E-07
     +,   2.2576523E-07,   1.8985023E-07,   1.5935852E-07
     +,   1.3352293E-07,   1.1167273E-07,   9.3229801E-08
     +,   7.7691332E-08,   6.4625922E-08,   5.3660472E-08
     +,   4.4474685E-08,   3.6794887E-08,   3.0385952E-08
     +,   2.5048061E-08,   2.0610360E-08,   1.6928318E-08
     +,   1.3878822E-08,   1.1358145E-08,   9.2783932E-09
     +,   7.5657942E-09,   6.1580967E-09,   5.0032845E-09
     +,   4.0576453E-09,   3.2848033E-09
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_haonly_ttz60_mass = Yx/0.520042384615385
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_haonly_ttz65_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.7503298E-04,   5.0245470E-04
     +,   5.3063041E-04,   5.5957818E-04,   5.8933406E-04
     +,   6.1995635E-04,   6.5153051E-04,   6.8417349E-04
     +,   7.1803894E-04,   7.5332390E-04,   7.9027115E-04
     +,   8.2917599E-04,   8.7038986E-04,   9.1432460E-04
     +,   9.6145476E-04,   1.0123190E-03,   1.0675209E-03
     +,   1.1277259E-03,   1.1936590E-03,   1.2660973E-03
     +,   1.3458616E-03,   1.4338058E-03,   1.5308007E-03
     +,   1.6377263E-03,   1.7554336E-03,   1.8847499E-03
     +,   2.0264345E-03,   2.1811661E-03,   2.3495168E-03
     +,   2.5319280E-03,   2.7286862E-03,   2.9399050E-03
     +,   3.1655026E-03,   3.4051856E-03,   3.6584386E-03
     +,   3.9245109E-03,   4.2024129E-03,   4.4909124E-03
     +,   4.7885645E-03,   5.0936709E-03,   5.4043727E-03
     +,   5.7186321E-03,   6.0342960E-03,   6.3491617E-03
     +,   6.6610454E-03,   6.9678794E-03,   7.2678165E-03
     +,   7.5593516E-03,   7.8414418E-03,   8.1136273E-03
     +,   8.3761439E-03,   8.6299879E-03,   8.8769514E-03
     +,   9.1196075E-03,   9.3611646E-03,   9.6053332E-03
     +,   9.8560136E-03,   1.0116986E-02,   1.0391516E-02
     +,   1.0681958E-02,   1.0989409E-02,   1.1313464E-02
     +,   1.1652077E-02,   1.2001740E-02,   1.2357838E-02
     +,   1.2715272E-02,   1.3069523E-02,   1.3417752E-02
     +,   1.3760365E-02,   1.4102374E-02,   1.4455033E-02
     +,   1.4836939E-02,   1.5274910E-02,   1.5803928E-02
     +,   1.6466267E-02,   1.7309239E-02,   1.8381465E-02
     +,   1.9727765E-02,   2.1382958E-02,   2.3364818E-02
     +,   2.5667092E-02,   2.8254598E-02,   3.1059930E-02
     +,   3.3985157E-02,   3.6906701E-02,   3.9686117E-02
     +,   4.2183023E-02,   4.4271391E-02,   4.5854084E-02
     +,   4.6875667E-02,   4.7329590E-02,   4.7259439E-02
     +,   4.6753865E-02,   4.5935955E-02,   4.4948731E-02
     +,   4.3939114E-02,   4.3041620E-02,   4.2364538E-02
     +,   4.1978888E-02,   4.1912012E-02,   4.2145893E-02
     +,   4.2620778E-02,   4.3243863E-02,   4.3901868E-02
     +,   4.4476204E-02,   4.4858024E-02,   4.4961050E-02
     +,   4.4729970E-02,   4.4143274E-02,   4.3210641E-02
     +,   4.1966312E-02,   4.0459998E-02,   3.8748413E-02
     +,   3.6887906E-02,   3.4930740E-02,   3.2923352E-02
     +,   3.0907527E-02,   2.8921338E-02,   2.7000971E-02
     +,   2.5180276E-02,   2.3489783E-02,   2.1954563E-02
     +,   2.0591436E-02,   1.9406728E-02,   1.8395282E-02
     +,   1.7540865E-02,   1.6817765E-02,   1.6193999E-02
     +,   1.5634755E-02,   1.5106263E-02,   1.4578876E-02
     +,   1.4029579E-02,   1.3443177E-02,   1.2812694E-02
     +,   1.2138576E-02,   1.1427429E-02,   1.0690347E-02
     +,   9.9410480E-03,   9.1941124E-03,   8.4635764E-03
     +,   7.7618849E-03,   7.0991367E-03,   6.4826803E-03
     +,   5.9171221E-03,   5.4045604E-03,   4.9448288E-03
     +,   4.5359889E-03,   4.1748211E-03,   3.8572373E-03
     +,   3.5786643E-03,   3.3344007E-03,   3.1198815E-03
     +,   2.9308370E-03,   2.7633943E-03,   2.6141456E-03
     +,   2.4801714E-03,   2.3589998E-03,   2.2485692E-03
     +,   2.1471793E-03,   2.0534529E-03,   1.9662594E-03
     +,   1.8846812E-03,   1.8079797E-03,   1.7355541E-03
     +,   1.6669108E-03,   1.6016485E-03,   1.5394428E-03
     +,   1.4800295E-03,   1.4231883E-03,   1.3687393E-03
     +,   1.3165366E-03,   1.2664580E-03,   1.2183957E-03
     +,   1.1722535E-03,   1.1279496E-03,   1.0854001E-03
     +,   1.0445248E-03,   1.0052447E-03,   9.6747972E-04
     +,   9.3114609E-04,   8.9615805E-04,   8.6243154E-04
     +,   8.2988263E-04,   7.9842587E-04,   7.6797901E-04
     +,   7.3846505E-04,   7.0981181E-04,   6.8195141E-04
     +,   6.5482216E-04,   6.2837260E-04,   6.0255628E-04
     +,   5.7733449E-04,   5.5267755E-04,   5.2856363E-04
     +,   5.0497579E-04,   4.8190352E-04,   4.5934375E-04
     +,   4.3729803E-04,   4.1577080E-04,   3.9476951E-04
     +,   3.7430591E-04,   3.5439312E-04,   3.3504414E-04
     +,   3.1627211E-04,   2.9809208E-04,   2.8051616E-04
     +,   2.6355553E-04,   2.4722074E-04,   2.3152027E-04
     +,   2.1645959E-04,   2.0204186E-04,   1.8826879E-04
     +,   1.7513962E-04,   1.6265028E-04,   1.5079441E-04
     +,   1.3956417E-04,   1.2894953E-04,   1.1893771E-04
     +,   1.0951427E-04,   1.0066396E-04,   9.2369213E-05
     +,   8.4611253E-05,   7.7370816E-05,   7.0627691E-05
     +,   6.4360545E-05,   5.8547681E-05,   5.3167416E-05
     +,   4.8197999E-05,   4.3617205E-05,   3.9403123E-05
     +,   3.5534384E-05,   3.1989945E-05,   2.8749024E-05
     +,   2.5791478E-05,   2.3098080E-05,   2.0650012E-05
     +,   1.8429260E-05,   1.6418757E-05,   1.4602223E-05
     +,   1.2964103E-05,   1.1489708E-05,   1.0165300E-05
     +,   8.9779605E-06,   7.9155279E-06,   6.9666680E-06
     +,   6.1208934E-06,   5.3684748E-06,   4.7003696E-06
     +,   4.1082362E-06,   3.5844751E-06,   3.1220550E-06
     +,   2.7145520E-06,   2.3561361E-06,   2.0414989E-06
     +,   1.7658049E-06,   1.5246809E-06,   1.3141947E-06
     +,   1.1308028E-06,   9.7131317E-07,   8.3286358E-07
     +,   7.1290719E-07,   6.0917102E-07,   5.1962462E-07
     +,   4.4246912E-07,   3.7611721E-07,   3.1915948E-07
     +,   2.7035523E-07,   2.2861599E-07,   1.9298585E-07
     +,   1.6262555E-07,   1.3680243E-07,   1.1488005E-07
     +,   9.6303403E-08,   8.0590446E-08,   6.7323640E-08
     +,   5.6143392E-08,   4.6738215E-08,   3.8841240E-08
     +,   3.2222207E-08,   2.6684887E-08,   2.2060584E-08
     +,   1.8206068E-08,   1.4998831E-08,   1.2335194E-08
     +,   1.0126905E-08,   8.2995477E-09,   6.7901080E-09
     +,   5.5455041E-09,   4.5211910E-09,   3.6796477E-09
     +,   2.9895617E-09,   2.4246554E-09,   1.9630908E-09
     +,   1.5866197E-09,   1.2801246E-09,   1.0310358E-09
     +,   8.2897750E-10,   6.6535544E-10,   5.3310384E-10
     +,   4.2639436E-10,   3.4045475E-10
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_haonly_ttz65_mass = Yx/0.599179269230769
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_haonly_ttz70_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  7.5080636E-04,   7.7952334E-04
     +,   8.0893317E-04,   8.3903974E-04,   8.6984504E-04
     +,   9.0134918E-04,   9.3354977E-04,   9.6644158E-04
     +,   1.0000153E-03,   1.0342598E-03,   1.0691584E-03
     +,   1.1046907E-03,   1.1408317E-03,   1.1775516E-03
     +,   1.2148155E-03,   1.2525837E-03,   1.2908115E-03
     +,   1.3294491E-03,   1.3684422E-03,   1.4077320E-03
     +,   1.4472564E-03,   1.4869495E-03,   1.5267426E-03
     +,   1.5665682E-03,   1.6063534E-03,   1.6460303E-03
     +,   1.6855306E-03,   1.7247893E-03,   1.7637453E-03
     +,   1.8023438E-03,   1.8405362E-03,   1.8782821E-03
     +,   1.9155497E-03,   1.9523182E-03,   1.9885781E-03
     +,   2.0243307E-03,   2.0595915E-03,   2.0943880E-03
     +,   2.1287650E-03,   2.1627783E-03,   2.1965047E-03
     +,   2.2300363E-03,   2.2634862E-03,   2.2969902E-03
     +,   2.3307092E-03,   2.3648369E-03,   2.3996020E-03
     +,   2.4352774E-03,   2.4721855E-03,   2.5107120E-03
     +,   2.5513109E-03,   2.5945201E-03,   2.6409680E-03
     +,   2.6913895E-03,   2.7466258E-03,   2.8076400E-03
     +,   2.8755104E-03,   2.9514285E-03,   3.0366869E-03
     +,   3.1326583E-03,   3.2407660E-03,   3.3624484E-03
     +,   3.4991056E-03,   3.6520674E-03,   3.8225427E-03
     +,   4.0115635E-03,   4.2200033E-03,   4.4485279E-03
     +,   4.6976916E-03,   4.9679368E-03,   5.2597709E-03
     +,   5.5738259E-03,   5.9110909E-03,   6.2729716E-03
     +,   6.6614905E-03,   7.0793363E-03,   7.5298054E-03
     +,   8.0167232E-03,   8.5442644E-03,   9.1166124E-03
     +,   9.7375372E-03,   1.0410128E-02,   1.1136311E-02
     +,   1.1916787E-02,   1.2750818E-02,   1.3636618E-02
     +,   1.4571616E-02,   1.5553373E-02,   1.6580267E-02
     +,   1.7652657E-02,   1.8773697E-02,   1.9949844E-02
     +,   2.1190962E-02,   2.2509793E-02,   2.3920489E-02
     +,   2.5436437E-02,   2.7068065E-02,   2.8820086E-02
     +,   3.0690024E-02,   3.2666910E-02,   3.4732189E-02
     +,   3.6860734E-02,   3.9023723E-02,   4.1190431E-02
     +,   4.3330397E-02,   4.5413718E-02,   4.7410075E-02
     +,   4.9287159E-02,   5.1009033E-02,   5.2534878E-02
     +,   5.3819552E-02,   5.4816525E-02,   5.5482056E-02
     +,   5.5781078E-02,   5.5692822E-02,   5.5215582E-02
     +,   5.4369576E-02,   5.3196937E-02,   5.1759623E-02
     +,   5.0134599E-02,   4.8407748E-02,   4.6667259E-02
     +,   4.4996928E-02,   4.3470144E-02,   4.2145476E-02
     +,   4.1063476E-02,   4.0244572E-02,   3.9688773E-02
     +,   3.9376121E-02,   3.9268862E-02,   3.9314423E-02
     +,   3.9449677E-02,   3.9606001E-02,   3.9714627E-02
     +,   3.9712064E-02,   3.9544605E-02,   3.9171848E-02
     +,   3.8568493E-02,   3.7724692E-02,   3.6644753E-02
     +,   3.5345115E-02,   3.3851393E-02,   3.2195274E-02
     +,   3.0411845E-02,   2.8537506E-02,   2.6607919E-02
     +,   2.4657020E-02,   2.2716364E-02,   2.0814523E-02
     +,   1.8976588E-02,   1.7223988E-02,   1.5574345E-02
     +,   1.4041128E-02,   1.2633441E-02,   1.1356222E-02
     +,   1.0210551E-02,   9.1939699E-03,   8.3010178E-03
     +,   7.5239879E-03,   6.8536806E-03,   6.2799067E-03
     +,   5.7921377E-03,   5.3799702E-03,   5.0333901E-03
     +,   4.7429609E-03,   4.4999523E-03,   4.2963889E-03
     +,   4.1250284E-03,   3.9793374E-03,   3.8534857E-03
     +,   3.7423356E-03,   3.6414210E-03,   3.5469290E-03
     +,   3.4556983E-03,   3.3652021E-03,   3.2735004E-03
     +,   3.1792070E-03,   3.0814393E-03,   2.9797519E-03
     +,   2.8740647E-03,   2.7645952E-03,   2.6518020E-03
     +,   2.5363143E-03,   2.4188641E-03,   2.3002462E-03
     +,   2.1812825E-03,   2.0627785E-03,   1.9454933E-03
     +,   1.8301242E-03,   1.7173049E-03,   1.6075765E-03
     +,   1.5013944E-03,   1.3991356E-03,   1.3010921E-03
     +,   1.2074724E-03,   1.1184125E-03,   1.0339898E-03
     +,   9.5422391E-04,   8.7908009E-04,   8.0848299E-04
     +,   7.4232754E-04,   6.8048231E-04,   6.2278984E-04
     +,   5.6907890E-04,   5.1917339E-04,   4.7288541E-04
     +,   4.3002566E-04,   3.9040743E-04,   3.5384632E-04
     +,   3.2015966E-04,   2.8917033E-04,   2.6070970E-04
     +,   2.3461565E-04,   2.1073113E-04,   1.8890672E-04
     +,   1.6900164E-04,   1.5088184E-04,   1.3441891E-04
     +,   1.1949127E-04,   1.0598511E-04,   9.3791416E-05
     +,   8.2807113E-05,   7.2935742E-05,   6.4086104E-05
     +,   5.6171793E-05,   4.9111663E-05,   4.2830081E-05
     +,   3.7256181E-05,   3.2323409E-05,   2.7969867E-05
     +,   2.4138402E-05,   2.0776035E-05,   1.7833685E-05
     +,   1.5266252E-05,   1.3032646E-05,   1.1095124E-05
     +,   9.4193738E-06,   7.9744013E-06,   6.7322053E-06
     +,   5.6675108E-06,   4.7576905E-06,   3.9826077E-06
     +,   3.3243355E-06,   2.7669580E-06,   2.2964412E-06
     +,   1.9004776E-06,   1.5682879E-06,   1.2904453E-06
     +,   1.0587655E-06,   8.6618326E-07,   7.0658729E-07
     +,   5.7473017E-07,   4.6612894E-07,   3.7695855E-07
     +,   3.0396478E-07,   2.4439410E-07,   1.9592920E-07
     +,   1.5662134E-07,   1.2483670E-07,   9.9213281E-08
     +,   7.8620474E-08,   6.2121828E-08,   4.8942994E-08
     +,   3.8447844E-08,   3.0115810E-08,   2.3520945E-08
     +,   1.8316801E-08,   1.4222681E-08,   1.1011699E-08
     +,   8.5008969E-09,   6.5434782E-09,   5.0221538E-09
     +,   3.8433692E-09,   2.9327243E-09,   2.2313267E-09
     +,   1.6927645E-09,   1.2804502E-09,   9.6576314E-10
     +,   7.2629064E-10,   5.4461713E-10,   4.0719836E-10
     +,   3.0357142E-10,   2.2565680E-10,   1.6725461E-10
     +,   1.2360603E-10,   9.1084008E-11,   6.6924043E-11
     +,   4.9029114E-11,   3.5815292E-11,   2.6086387E-11
     +,   1.8945321E-11,   1.3718950E-11,   9.9056562E-12
     +,   7.1314166E-12,   5.1193030E-12,   3.6641944E-12
     +,   2.6150935E-12,   1.8609231E-12,   1.3204150E-12
     +,   9.3416854E-13,   6.5899445E-13
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_haonly_ttz70_mass = Yx/0.68235375
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_haonly_ttz75_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  8.5904154E-05,   9.3397837E-05
     +,   1.0137632E-04,   1.0985335E-04,   1.1884120E-04
     +,   1.2835057E-04,   1.3839030E-04,   1.4896714E-04
     +,   1.6008544E-04,   1.7174761E-04,   1.8395290E-04
     +,   1.9669786E-04,   2.0997596E-04,   2.2377755E-04
     +,   2.3808965E-04,   2.5289576E-04,   2.6817582E-04
     +,   2.8390606E-04,   3.0005907E-04,   3.1660360E-04
     +,   3.3350472E-04,   3.5072380E-04,   3.6821802E-04
     +,   3.8594252E-04,   4.0384676E-04,   4.2187897E-04
     +,   4.3998350E-04,   4.5810165E-04,   4.7617275E-04
     +,   4.9413368E-04,   5.1191956E-04,   5.2946410E-04
     +,   5.4669997E-04,   5.6355947E-04,   5.7997496E-04
     +,   5.9587933E-04,   6.1120687E-04,   6.2589382E-04
     +,   6.3988019E-04,   6.5310870E-04,   6.6552864E-04
     +,   6.7709549E-04,   6.8777346E-04,   6.9753820E-04
     +,   7.0637884E-04,   7.1430200E-04,   7.2133611E-04
     +,   7.2753651E-04,   7.3299219E-04,   7.3783298E-04
     +,   7.4223819E-04,   7.4644777E-04,   7.5077283E-04
     +,   7.5560843E-04,   7.6144753E-04,   7.6889386E-04
     +,   7.7867607E-04,   7.9165923E-04,   8.0885476E-04
     +,   8.3142682E-04,   8.6069317E-04,   8.9812168E-04
     +,   9.4531249E-04,   1.0039837E-03,   1.0759379E-03
     +,   1.1630127E-03,   1.2670475E-03,   1.3898036E-03
     +,   1.5329272E-03,   1.6978483E-03,   1.8857566E-03
     +,   2.0974921E-03,   2.3335491E-03,   2.5939806E-03
     +,   2.8784350E-03,   3.1861390E-03,   3.5159059E-03
     +,   3.8662090E-03,   4.2352891E-03,   4.6212436E-03
     +,   5.0221225E-03,   5.4361704E-03,   5.8618924E-03
     +,   6.2983353E-03,   6.7451340E-03,   7.2027496E-03
     +,   7.6724272E-03,   8.1562689E-03,   8.6569590E-03
     +,   9.1775460E-03,   9.7209038E-03,   1.0289038E-02
     +,   1.0882345E-02,   1.1498902E-02,   1.2133789E-02
     +,   1.2778738E-02,   1.3422530E-02,   1.4051802E-02
     +,   1.4653045E-02,   1.5215096E-02,   1.5732650E-02
     +,   1.6209722E-02,   1.6663158E-02,   1.7124882E-02
     +,   1.7642563E-02,   1.8277697E-02,   1.9100728E-02
     +,   2.0183159E-02,   2.1587405E-02,   2.3355279E-02
     +,   2.5496926E-02,   2.7983261E-02,   3.0742384E-02
     +,   3.3663794E-02,   3.6608011E-02,   3.9423585E-02
     +,   4.1965906E-02,   4.4117585E-02,   4.5804419E-02
     +,   4.7007155E-02,   4.7765817E-02,   4.8178125E-02
     +,   4.8391912E-02,   4.8591796E-02,   4.8979845E-02
     +,   4.9750119E-02,   5.1057838E-02,   5.2986246E-02
     +,   5.5517752E-02,   5.8516577E-02,   6.1732773E-02
     +,   6.4830378E-02,   6.7441165E-02,   6.9231801E-02
     +,   6.9971636E-02,   6.9579460E-02,   6.8136476E-02
     +,   6.5859810E-02,   6.3043848E-02,   5.9988197E-02
     +,   5.6934383E-02,   5.4027885E-02,   5.1314175E-02
     +,   4.8763100E-02,   4.6308730E-02,   4.3887205E-02
     +,   4.1462582E-02,   3.9034653E-02,   3.6631189E-02
     +,   3.4291953E-02,   3.2052837E-02,   2.9935408E-02
     +,   2.7943952E-02,   2.6069168E-02,   2.4295570E-02
     +,   2.2608994E-02,   2.1001287E-02,   1.9471709E-02
     +,   1.8025415E-02,   1.6670331E-02,   1.5413285E-02
     +,   1.4257551E-02,   1.3201725E-02,   1.2239869E-02
     +,   1.1362785E-02,   1.0559800E-02,   9.8204920E-03
     +,   9.1358963E-03,   8.4991315E-03,   7.9055941E-03
     +,   7.3526818E-03,   6.8391855E-03,   6.3646175E-03
     +,   5.9286542E-03,   5.5306936E-03,   5.1694848E-03
     +,   4.8430474E-03,   4.5487154E-03,   4.2832512E-03
     +,   4.0430357E-03,   3.8243160E-03,   3.6234478E-03
     +,   3.4370599E-03,   3.2621948E-03,   3.0964080E-03
     +,   2.9378140E-03,   2.7850706E-03,   2.6373183E-03
     +,   2.4941240E-03,   2.3554091E-03,   2.2213284E-03
     +,   2.0922022E-03,   1.9684394E-03,   1.8504659E-03
     +,   1.7386604E-03,   1.6333277E-03,   1.5346778E-03
     +,   1.4428060E-03,   1.3576833E-03,   1.2791710E-03
     +,   1.2070342E-03,   1.1409520E-03,   1.0805319E-03
     +,   1.0253316E-03,   9.7488333E-04,   9.2869927E-04
     +,   8.8629243E-04,   8.4719172E-04,   8.1094989E-04
     +,   7.7714829E-04,   7.4540643E-04,   7.1538670E-04
     +,   6.8679417E-04,   6.5937446E-04,   6.3291506E-04
     +,   6.0724415E-04,   5.8222632E-04,   5.5775727E-04
     +,   5.3376151E-04,   5.1019102E-04,   4.8701657E-04
     +,   4.6422658E-04,   4.4182496E-04,   4.1982610E-04
     +,   3.9825143E-04,   3.7712781E-04,   3.5648662E-04
     +,   3.3636088E-04,   3.1678230E-04,   2.9778146E-04
     +,   2.7938790E-04,   2.6162816E-04,   2.4452424E-04
     +,   2.2809420E-04,   2.1235381E-04,   1.9731288E-04
     +,   1.8297735E-04,   1.6934991E-04,   1.5642935E-04
     +,   1.4420987E-04,   1.3268244E-04,   1.2183555E-04
     +,   1.1165485E-04,   1.0212279E-04,   9.3219685E-05
     +,   8.4924592E-05,   7.7214994E-05,   7.0066526E-05
     +,   6.3453983E-05,   5.7352070E-05,   5.1734471E-05
     +,   4.6574707E-05,   4.1846633E-05,   3.7524354E-05
     +,   3.3582000E-05,   2.9994289E-05,   2.6736914E-05
     +,   2.3786255E-05,   2.1119393E-05,   1.8714385E-05
     +,   1.6550466E-05,   1.4607879E-05,   1.2867804E-05
     +,   1.1312555E-05,   9.9256522E-06,   8.6915688E-06
     +,   7.5958360E-06,   6.6251205E-06,   5.7670600E-06
     +,   5.0102030E-06,   4.3440527E-06,   3.7590250E-06
     +,   3.2463679E-06,   2.7980852E-06,   2.4069254E-06
     +,   2.0663638E-06,   1.7704725E-06,   1.5139606E-06
     +,   1.2920466E-06,   1.1004857E-06,   9.3546777E-07
     +,   7.9362673E-07,   6.7195759E-07,   5.6781937E-07
     +,   4.7886903E-07,   4.0305684E-07,   3.3857609E-07
     +,   2.8384687E-07,   2.3749534E-07,   1.9831900E-07
     +,   1.6527844E-07,   1.3746944E-07,   1.1411409E-07
     +,   9.4538777E-08,   7.8167140E-08,   6.4502444E-08
     +,   5.3121649E-08,   4.3662066E-08,   3.5816306E-08
     +,   2.9322074E-08,   2.3958082E-08
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_haonly_ttz75_mass = Yx/0.68235375
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_haonly_ttz80_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.0509831E-04,   3.2700761E-04
     +,   3.5001000E-04,   3.7412081E-04,   3.9935249E-04
     +,   4.2571445E-04,   4.5321320E-04,   4.8185181E-04
     +,   5.1162962E-04,   5.4254406E-04,   5.7458773E-04
     +,   6.0774985E-04,   6.4201694E-04,   6.7737140E-04
     +,   7.1379251E-04,   7.5125683E-04,   7.8973686E-04
     +,   8.2920311E-04,   8.6962275E-04,   9.1096037E-04
     +,   9.5317891E-04,   9.9623867E-04,   1.0400973E-03
     +,   1.0847141E-03,   1.1300415E-03,   1.1760364E-03
     +,   1.2226513E-03,   1.2698390E-03,   1.3175515E-03
     +,   1.3657401E-03,   1.4143557E-03,   1.4633486E-03
     +,   1.5126680E-03,   1.5622628E-03,   1.6120804E-03
     +,   1.6620667E-03,   1.7121658E-03,   1.7623194E-03
     +,   1.8124689E-03,   1.8625465E-03,   1.9124871E-03
     +,   1.9622170E-03,   2.0116589E-03,   2.0607293E-03
     +,   2.1093385E-03,   2.1573906E-03,   2.2047819E-03
     +,   2.2514027E-03,   2.2971344E-03,   2.3418537E-03
     +,   2.3854286E-03,   2.4277226E-03,   2.4685930E-03
     +,   2.5078966E-03,   2.5454846E-03,   2.5812127E-03
     +,   2.6149377E-03,   2.6465226E-03,   2.6758416E-03
     +,   2.7027817E-03,   2.7272494E-03,   2.7491737E-03
     +,   2.7685117E-03,   2.7852564E-03,   2.7994411E-03
     +,   2.8111429E-03,   2.8204953E-03,   2.8276879E-03
     +,   2.8329778E-03,   2.8366910E-03,   2.8392321E-03
     +,   2.8410864E-03,   2.8428226E-03,   2.8450990E-03
     +,   2.8486613E-03,   2.8543444E-03,   2.8630679E-03
     +,   2.8758314E-03,   2.8937077E-03,   2.9178320E-03
     +,   2.9493840E-03,   2.9895776E-03,   3.0396294E-03
     +,   3.1007447E-03,   3.1740740E-03,   3.2606984E-03
     +,   3.3615704E-03,   3.4775001E-03,   3.6090862E-03
     +,   3.7566996E-03,   3.9204308E-03,   4.1000391E-03
     +,   4.2949226E-03,   4.5041009E-03,   4.7261780E-03
     +,   4.9593076E-03,   5.2012368E-03,   5.4492569E-03
     +,   5.7002851E-03,   5.9508421E-03,   6.1971680E-03
     +,   6.4352280E-03,   6.6608563E-03,   6.8697901E-03
     +,   7.0578312E-03,   7.2209248E-03,   7.3552728E-03
     +,   7.4574575E-03,   7.5245565E-03,   7.5542312E-03
     +,   7.5448174E-03,   7.4954075E-03,   7.4059162E-03
     +,   7.2771339E-03,   7.1108043E-03,   6.9096754E-03
     +,   6.6776564E-03,   6.4199511E-03,   6.1433772E-03
     +,   5.8567184E-03,   5.5713281E-03,   5.3019114E-03
     +,   5.0674942E-03,   4.8925891E-03,   4.8085223E-03
     +,   4.8547499E-03,   5.0798976E-03,   5.5422462E-03
     +,   6.3093612E-03,   7.4561308E-03,   9.0614455E-03
     +,   1.1202450E-02,   1.3947720E-02,   1.7348185E-02
     +,   2.1428715E-02,   2.6179662E-02,   3.1550240E-02
     +,   3.7445430E-02,   4.3727007E-02,   5.0217692E-02
     +,   5.6708731E-02,   6.2971421E-02,   6.8770789E-02
     +,   7.3880285E-02,   7.8097865E-02,   8.1264727E-02
     +,   8.3282247E-02,   8.4127583E-02,   8.3864167E-02
     +,   8.2642235E-02,   8.0686659E-02,   7.8271054E-02
     +,   7.5679757E-02,   7.3163606E-02,   7.0899315E-02
     +,   6.8961047E-02,   6.7311279E-02,   6.5814652E-02
     +,   6.4271174E-02,   6.2461704E-02,   6.0194191E-02
     +,   5.7341520E-02,   5.3863432E-02,   4.9809463E-02
     +,   4.5304898E-02,   4.0525895E-02,   3.5670191E-02
     +,   3.0928850E-02,   2.6464233E-02,   2.2396997E-02
     +,   1.8801577E-02,   1.5708031E-02,   1.3108948E-02
     +,   1.0969407E-02,   9.2372335E-03,   7.8518065E-03
     +,   6.7517082E-03,   5.8799591E-03,   5.1869857E-03
     +,   4.6318732E-03,   4.1823881E-03,   3.8140561E-03
     +,   3.5087934E-03,   3.2534327E-03,   3.0384124E-03
     +,   2.8566630E-03,   2.7027288E-03,   2.5721593E-03
     +,   2.4611307E-03,   2.3662280E-03,   2.2843264E-03
     +,   2.2125698E-03,   2.1483900E-03,   2.0895314E-03
     +,   2.0340739E-03,   1.9804533E-03,   1.9274614E-03
     +,   1.8742274E-03,   1.8201815E-03,   1.7650154E-03
     +,   1.7086421E-03,   1.6511421E-03,   1.5927157E-03
     +,   1.5336449E-03,   1.4742638E-03,   1.4149196E-03
     +,   1.3559540E-03,   1.2976922E-03,   1.2404263E-03
     +,   1.1844052E-03,   1.1298344E-03,   1.0768794E-03
     +,   1.0256621E-03,   9.7626122E-04,   9.2871953E-04
     +,   8.8305160E-04,   8.3924527E-04,   7.9726335E-04
     +,   7.5705239E-04,   7.1855076E-04,   6.8168441E-04
     +,   6.4637541E-04,   6.1254652E-04,   5.8012194E-04
     +,   5.4902676E-04,   5.1919126E-04,   4.9055321E-04
     +,   4.6305708E-04,   4.3665175E-04,   4.1129297E-04
     +,   3.8694439E-04,   3.6357503E-04,   3.4115755E-04
     +,   3.1966867E-04,   2.9909084E-04,   2.7940702E-04
     +,   2.6060196E-04,   2.4266315E-04,   2.2557820E-04
     +,   2.0933367E-04,   1.9391574E-04,   1.7931069E-04
     +,   1.6550365E-04,   1.5247735E-04,   1.4021329E-04
     +,   1.2869209E-04,   1.1789298E-04,   1.0779290E-04
     +,   9.8367578E-05,   8.9592526E-05,   8.1441271E-05
     +,   7.3886622E-05,   6.6901222E-05,   6.0457303E-05
     +,   5.4526379E-05,   4.9080008E-05,   4.4090291E-05
     +,   3.9529576E-05,   3.5370394E-05,   3.1585932E-05
     +,   2.8150404E-05,   2.5038833E-05,   2.2226943E-05
     +,   1.9691548E-05,   1.7410752E-05,   1.5363523E-05
     +,   1.3530006E-05,   1.1891594E-05,   1.0430844E-05
     +,   9.1313295E-06,   7.9777737E-06,   6.9560811E-06
     +,   6.0531938E-06,   5.2570181E-06,   4.5564539E-06
     +,   3.9414122E-06,   3.4025888E-06,   2.9315966E-06
     +,   2.5207610E-06,   2.1631977E-06,   1.8526513E-06
     +,   1.5835357E-06,   1.3508126E-06,   1.1500036E-06
     +,   9.7709392E-07,   8.2853387E-07,   7.0116363E-07
     +,   5.9218962E-07,   4.9915968E-07,   4.1990492E-07
     +,   3.5253294E-07,   2.9537986E-07,   2.4700125E-07
     +,   2.0613416E-07,   1.7168740E-07,   1.4271158E-07
     +,   1.1839060E-07,   9.8018397E-08,   8.0990873E-08
     +,   6.6787628E-08,   5.4965987E-08
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_haonly_ttz80_mass = Yx/0.642306777777778
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_haonly_ttz85_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.6723275E-05,   3.0357534E-05
     +,   3.4408935E-05,   3.8913968E-05,   4.3910783E-05
     +,   4.9439044E-05,   5.5539727E-05,   6.2255072E-05
     +,   6.9628019E-05,   7.7702622E-05,   8.6522945E-05
     +,   9.6133183E-05,   1.0657716E-04,   1.1789811E-04
     +,   1.3013803E-04,   1.4333734E-04,   1.5753436E-04
     +,   1.7276494E-04,   1.8906173E-04,   2.0645394E-04
     +,   2.2496660E-04,   2.4462014E-04,   2.6542964E-04
     +,   2.8740597E-04,   3.1055138E-04,   3.3486445E-04
     +,   3.6033543E-04,   3.8694788E-04,   4.1467787E-04
     +,   4.4349395E-04,   4.7335707E-04,   5.0422031E-04
     +,   5.3602905E-04,   5.6872098E-04,   6.0222636E-04
     +,   6.3646788E-04,   6.7136198E-04,   7.0681726E-04
     +,   7.4273883E-04,   7.7902229E-04,   8.1556221E-04
     +,   8.5224642E-04,   8.8895968E-04,   9.2558394E-04
     +,   9.6199871E-04,   9.9808211E-04,   1.0337116E-03
     +,   1.0687644E-03,   1.1031189E-03,   1.1366544E-03
     +,   1.1692528E-03,   1.2007989E-03,   1.2311799E-03
     +,   1.2602893E-03,   1.2880223E-03,   1.3142814E-03
     +,   1.3389732E-03,   1.3620105E-03,   1.3833122E-03
     +,   1.4028038E-03,   1.4204171E-03,   1.4360914E-03
     +,   1.4497716E-03,   1.4614111E-03,   1.4709709E-03
     +,   1.4784177E-03,   1.4837270E-03,   1.4868808E-03
     +,   1.4878705E-03,   1.4866933E-03,   1.4833556E-03
     +,   1.4778719E-03,   1.4702643E-03,   1.4605648E-03
     +,   1.4488137E-03,   1.4350605E-03,   1.4193663E-03
     +,   1.4018026E-03,   1.3824527E-03,   1.3614118E-03
     +,   1.3387919E-03,   1.3147183E-03,   1.2893360E-03
     +,   1.2628076E-03,   1.2353201E-03,   1.2070815E-03
     +,   1.1783306E-03,   1.1493328E-03,   1.1203903E-03
     +,   1.0918385E-03,   1.0640528E-03,   1.0374531E-03
     +,   1.0125046E-03,   9.8971836E-04,   9.6965651E-04
     +,   9.5293333E-04,   9.4021228E-04,   9.3220774E-04
     +,   9.2967943E-04,   9.3342905E-04,   9.4429159E-04
     +,   9.6312398E-04,   9.9079474E-04,   1.0281621E-03
     +,   1.0760600E-03,   1.1352749E-03,   1.2065185E-03
     +,   1.2904052E-03,   1.3874363E-03,   1.4979797E-03
     +,   1.6222423E-03,   1.7602928E-03,   1.9120306E-03
     +,   2.0772405E-03,   2.2555753E-03,   2.4466398E-03
     +,   2.6499990E-03,   2.8652940E-03,   3.0922901E-03
     +,   3.3310549E-03,   3.5821185E-03,   3.8467024E-03
     +,   4.1270619E-03,   4.4269124E-03,   4.7518909E-03
     +,   5.1100086E-03,   5.5121453E-03,   5.9721568E-03
     +,   6.5067951E-03,   7.1348678E-03,   7.8759603E-03
     +,   8.7481579E-03,   9.7655999E-03,   1.0935379E-02
     +,   1.2255264E-02,   1.3712022E-02,   1.5281102E-02
     +,   1.6928187E-02,   1.8612189E-02,   2.0289090E-02
     +,   2.1916255E-02,   2.3457415E-02,   2.4888465E-02
     +,   2.6204661E-02,   2.7429685E-02,   2.8625475E-02
     +,   2.9898074E-02,   3.1394105E-02,   3.3282720E-02
     +,   3.5722785E-02,   3.8823124E-02,   4.2611532E-02
     +,   4.7030479E-02,   5.1967740E-02,   5.7311945E-02
     +,   6.3006543E-02,   6.9071427E-02,   7.5572357E-02
     +,   8.2542762E-02,   8.9887314E-02,   9.7305708E-02
     +,   0.1042642    ,   0.1100317    ,   0.1137856    
     +,   0.1147742    ,   0.1125033    ,   0.1068954    
     +,   9.8357908E-02,   8.7718882E-02,   7.6043896E-02
     +,   6.4397424E-02,   5.3631451E-02,   4.4268638E-02
     +,   3.6497608E-02,   3.0249063E-02,   2.5301445E-02
     +,   2.1378966E-02,   1.8218109E-02,   1.5601960E-02
     +,   1.3371127E-02,   1.1420654E-02,   9.6893264E-03
     +,   8.1459675E-03,   6.7763929E-03,   5.5733561E-03
     +,   4.5302454E-03,   3.6381343E-03,   2.8853700E-03
     +,   2.2584905E-03,   1.7433455E-03,   1.3258144E-03
     +,   9.9237508E-04,   7.3035707E-04,   5.2802963E-04
     +,   3.7468542E-04,   2.6074579E-04,   1.7783203E-04
     +,   1.1878928E-04,   7.7672630E-05,   4.9688497E-05
     +,   3.1085041E-05,   1.9010373E-05,   1.1361036E-05
     +,   6.6328325E-06,   3.7821787E-06,   2.1059664E-06
     +,   1.1448458E-06,   6.0754570E-07,   3.1471126E-07
     +,   1.5911202E-07,   7.8508258E-08,   3.7804071E-08
     +,   1.7765313E-08,   8.1470457E-09,   3.6459553E-09
     +,   1.5923087E-09,   6.7871547E-10,   2.8238170E-10
     +,   1.1470280E-10,   4.5514547E-11,   1.7660517E-11
     +,   6.7148036E-12,   2.5125720E-12,   9.3334780E-13
     +,   3.5006243E-13,   1.3660896E-13,   5.7954394E-14
     +,   2.7886332E-14,   1.5407345E-14,   9.5154919E-15
     +,   6.2979991E-15,   4.3190938E-15,   3.0086515E-15
     +,   2.1077013E-15,   1.4781787E-15,   1.0357436E-15
     +,   7.2446479E-16,   5.0568349E-16,   3.5219352E-16
     +,   2.4473476E-16,   1.6967170E-16,   1.1736115E-16
     +,   8.0992576E-17,   5.5765288E-17,   3.8306996E-17
     +,   2.6253717E-17,   1.7951829E-17,   1.2246849E-17
     +,   8.3355693E-18,   5.6604238E-18,   3.8349843E-18
     +,   2.5922054E-18,   1.7481401E-18,   1.1762169E-18
     +,   7.8958334E-19,   5.2881196E-19,   3.5335046E-19
     +,   2.3556607E-19,   1.5668261E-19,   1.0397325E-19
     +,   6.8836723E-20,   4.5469979E-20,   2.9965991E-20
     +,   1.9702756E-20,   1.2924924E-20,   8.4592142E-21
     +,   5.5236116E-21,   3.5984647E-21,   2.3389222E-21
     +,   1.5167486E-21,   9.8130540E-22,   6.3342098E-22
     +,   4.0793260E-22,   2.6210904E-22,   1.6802351E-22
     +,   1.0746344E-22,   6.8572107E-23,   4.3655462E-23
     +,   2.7728139E-23,   1.7571569E-23,   1.1109463E-23
     +,   7.0077717E-24,   4.4102125E-24,   2.7691412E-24
     +,   1.7347028E-24,   1.0841957E-24,   6.7606696E-25
     +,   4.2059687E-25,   2.6106385E-25,   1.6166717E-25
     +,   9.9885229E-26,   6.1570366E-26,   3.7866038E-26
     +,   2.3233739E-26,   1.4223153E-26,   8.6868793E-27
     +,   5.2934366E-27,   3.2181477E-27,   1.9519945E-27
     +,   1.1812512E-27,   7.1320364E-28
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_haonly_ttz85_mass = Yx/0.609647111111111
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_haonly_ttz90_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.3462336E-09,   5.9051324E-09
     +,   7.9936058E-09,   1.0780882E-08,   1.4486635E-08
     +,   1.9394715E-08,   2.5870571E-08,   3.4382417E-08
     +,   4.5527710E-08,   6.0066334E-08,   7.8959253E-08
     +,   1.0341776E-07,   1.3496148E-07,   1.7548942E-07
     +,   2.2736397E-07,   2.9351150E-07,   3.7754216E-07
     +,   4.8388944E-07,   6.1797545E-07,   7.8640164E-07
     +,   9.9717204E-07,   1.2599463E-06,   1.5863283E-06
     +,   1.9902245E-06,   2.4881545E-06,   3.0997592E-06
     +,   3.8481930E-06,   4.7606723E-06,   5.8690366E-06
     +,   7.2103626E-06,   8.8276165E-06,   1.0770367E-05
     +,   1.3095515E-05,   1.5868067E-05,   1.9161918E-05
     +,   2.3060657E-05,   2.7658340E-05,   3.3060165E-05
     +,   3.9383627E-05,   4.6758112E-05,   5.5326800E-05
     +,   6.5245964E-05,   7.6685581E-05,   8.9829446E-05
     +,   1.0487475E-04,   1.2203163E-04,   1.4152232E-04
     +,   1.6357988E-04,   1.8844672E-04,   2.1637233E-04
     +,   2.4761105E-04,   2.8241871E-04,   3.2104884E-04
     +,   3.6375181E-04,   4.1076314E-04,   4.6230800E-04
     +,   5.1858841E-04,   5.7978102E-04,   6.4603059E-04
     +,   7.1744382E-04,   7.9408305E-04,   8.7596214E-04
     +,   9.6303318E-04,   1.0551936E-03,   1.1522748E-03
     +,   1.2540282E-03,   1.3601438E-03,   1.4702231E-03
     +,   1.5838023E-03,   1.7003284E-03,   1.8191868E-03
     +,   1.9396758E-03,   2.0610425E-03,   2.1824581E-03
     +,   2.3030525E-03,   2.4219132E-03,   2.5380889E-03
     +,   2.6506078E-03,   2.7585011E-03,   2.8608053E-03
     +,   2.9565708E-03,   3.0448977E-03,   3.1249258E-03
     +,   3.1958714E-03,   3.2570206E-03,   3.3077598E-03
     +,   3.3475691E-03,   3.3760450E-03,   3.3929001E-03
     +,   3.3979702E-03,   3.3912181E-03,   3.3727307E-03
     +,   3.3427221E-03,   3.3015239E-03,   3.2495814E-03
     +,   3.1874499E-03,   3.1157730E-03,   3.0352878E-03
     +,   2.9467929E-03,   2.8511547E-03,   2.7492729E-03
     +,   2.6420886E-03,   2.5305441E-03,   2.4155984E-03
     +,   2.2981870E-03,   2.1792203E-03,   2.0595824E-03
     +,   1.9401114E-03,   1.8215842E-03,   1.7047172E-03
     +,   1.5901726E-03,   1.4785279E-03,   1.3703036E-03
     +,   1.2659333E-03,   1.1657939E-03,   1.0701796E-03
     +,   9.7933295E-04,   8.9342589E-04,   8.1259164E-04
     +,   7.3691312E-04,   6.6644611E-04,   6.0123764E-04
     +,   5.4133957E-04,   4.8682556E-04,   4.3782243E-04
     +,   3.9454110E-04,   3.5729690E-04,   3.2655112E-04
     +,   3.0292946E-04,   2.8725309E-04,   2.8054416E-04
     +,   2.8402644E-04,   2.9909905E-04,   3.2728526E-04
     +,   3.7015707E-04,   4.2923159E-04,   5.0584058E-04
     +,   6.0100161E-04,   7.1531045E-04,   8.4887253E-04
     +,   1.0013151E-03,   1.1719534E-03,   1.3601569E-03
     +,   1.5659378E-03,   1.7908133E-03,   2.0390584E-03
     +,   2.3192251E-03,   2.6459428E-03,   3.0418895E-03
     +,   3.5396642E-03,   4.1830302E-03,   5.0268988E-03
     +,   6.1353305E-03,   7.5768651E-03,   9.4167143E-03
     +,   1.1706350E-02,   1.4472700E-02,   1.7710151E-02
     +,   2.1378975E-02,   2.5413843E-02,   2.9745368E-02
     +,   3.4329608E-02,   3.9178267E-02,   4.4377234E-02
     +,   5.0078809E-02,   5.6457613E-02,   6.3633472E-02
     +,   7.1580380E-02,   8.0053806E-02,   8.8568926E-02
     +,   9.6452683E-02,   0.1029654    ,   0.1074556    
     +,   0.1094972    ,   0.1089649    ,   0.1060300    
     +,   0.1010874    ,   9.4650775E-02,   8.7253086E-02
     +,   7.9376444E-02,   7.1418129E-02,   6.3683853E-02
     +,   5.6393184E-02,   4.9688455E-02,   4.3644678E-02
     +,   3.8279660E-02,   3.3565678E-02,   2.9444601E-02
     +,   2.5844743E-02,   2.2695912E-02,   1.9938750E-02
     +,   1.7529128E-02,   1.5436888E-02,   1.3640810E-02
     +,   1.2123042E-02,   1.0864850E-02,   9.8444661E-03
     +,   9.0367422E-03,   8.4142024E-03,   7.9486696E-03
     +,   7.6126498E-03,   7.3801996E-03,   7.2273873E-03
     +,   7.1324655E-03,   7.0759123E-03,   7.0404103E-03
     +,   7.0109256E-03,   6.9747870E-03,   6.9217673E-03
     +,   6.8441113E-03,   6.7364830E-03,   6.5958383E-03
     +,   6.4212042E-03,   6.2133847E-03,   5.9746397E-03
     +,   5.7083820E-03,   5.4188329E-03,   5.1107090E-03
     +,   4.7889696E-03,   4.4586319E-03,   4.1245227E-03
     +,   3.7911690E-03,   3.4627169E-03,   3.1428332E-03
     +,   2.8346404E-03,   2.5407185E-03,   2.2631229E-03
     +,   2.0033761E-03,   1.7624833E-03,   1.5409897E-03
     +,   1.3390410E-03,   1.1564178E-03,   9.9258008E-04
     +,   8.4673829E-04,   7.1791944E-04,   6.0499104E-04
     +,   5.0672493E-04,   4.2184684E-04,   3.4906479E-04
     +,   2.8709817E-04,   2.3471021E-04,   1.9073048E-04
     +,   1.5406508E-04,   1.2370512E-04,   9.8735203E-05
     +,   7.8336634E-05,   6.1783561E-05,   4.8438982E-05
     +,   3.7751000E-05,   2.9246912E-05,   2.2523938E-05
     +,   1.7243063E-05,   1.3121670E-05,   9.9258332E-06
     +,   7.4633999E-06,   5.5780934E-06,   4.1438984E-06
     +,   3.0598467E-06,   2.2456541E-06,   1.6380295E-06
     +,   1.1874838E-06,   8.5556474E-07,   6.1260249E-07
     +,   4.3590077E-07,   3.0822949E-07,   2.1658136E-07
     +,   1.5121978E-07,   1.0491306E-07,   7.2322798E-08
     +,   4.9536819E-08,   3.3710858E-08,   2.2792660E-08
     +,   1.5310775E-08,   1.0217867E-08,   6.7743531E-09
     +,   4.4619304E-09,   2.9194627E-09,   1.8976312E-09
     +,   1.2252656E-09,   7.8589008E-10,   5.0071236E-10
     +,   3.1689462E-10,   1.9921534E-10,   1.2440016E-10
     +,   7.7159265E-11,   4.7537474E-11,   2.9090586E-11
     +,   1.7681806E-11,   1.0675029E-11,   6.4011916E-12
     +,   3.8125492E-12,   2.2553578E-12,   1.3251700E-12
     +,   7.7333506E-13,   4.4824791E-13,   2.5804969E-13
     +,   1.4755009E-13,   8.3793046E-14,   4.7263300E-14
     +,   2.6477125E-14,   1.4732048E-14
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_haonly_ttz90_mass = Yx/0.599179269230769
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_haonly_ttz95_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  7.8689173E-04,   8.0281682E-04
     +,   8.1854814E-04,   8.3406555E-04,   8.4934972E-04
     +,   8.6438155E-04,   8.7914243E-04,   8.9361443E-04
     +,   9.0777967E-04,   9.2162186E-04,   9.3512476E-04
     +,   9.4827276E-04,   9.6105150E-04,   9.7344705E-04
     +,   9.8544685E-04,   9.9703867E-04,   1.0082120E-03
     +,   1.0189565E-03,   1.0292636E-03,   1.0391254E-03
     +,   1.0485351E-03,   1.0574870E-03,   1.0659768E-03
     +,   1.0740013E-03,   1.0815579E-03,   1.0886457E-03
     +,   1.0952649E-03,   1.1014165E-03,   1.1071031E-03
     +,   1.1123278E-03,   1.1170952E-03,   1.1214111E-03
     +,   1.1252819E-03,   1.1287151E-03,   1.1317196E-03
     +,   1.1343047E-03,   1.1364809E-03,   1.1382595E-03
     +,   1.1396522E-03,   1.1406724E-03,   1.1413335E-03
     +,   1.1416494E-03,   1.1416351E-03,   1.1413061E-03
     +,   1.1406783E-03,   1.1397679E-03,   1.1385923E-03
     +,   1.1371681E-03,   1.1355132E-03,   1.1336455E-03
     +,   1.1315836E-03,   1.1293455E-03,   1.1269505E-03
     +,   1.1244173E-03,   1.1217654E-03,   1.1190141E-03
     +,   1.1161832E-03,   1.1132928E-03,   1.1103632E-03
     +,   1.1074144E-03,   1.1044674E-03,   1.1015433E-03
     +,   1.0986634E-03,   1.0958496E-03,   1.0931232E-03
     +,   1.0905073E-03,   1.0880242E-03,   1.0856974E-03
     +,   1.0835505E-03,   1.0816072E-03,   1.0798918E-03
     +,   1.0784295E-03,   1.0772449E-03,   1.0763637E-03
     +,   1.0758116E-03,   1.0756140E-03,   1.0757975E-03
     +,   1.0763878E-03,   1.0774110E-03,   1.0788927E-03
     +,   1.0808585E-03,   1.0833337E-03,   1.0863430E-03
     +,   1.0899104E-03,   1.0940597E-03,   1.0988135E-03
     +,   1.1041939E-03,   1.1102227E-03,   1.1169203E-03
     +,   1.1243069E-03,   1.1324037E-03,   1.1412296E-03
     +,   1.1508052E-03,   1.1611511E-03,   1.1722908E-03
     +,   1.1842473E-03,   1.1970488E-03,   1.2107244E-03
     +,   1.2253099E-03,   1.2408452E-03,   1.2573774E-03
     +,   1.2749603E-03,   1.2936579E-03,   1.3135421E-03
     +,   1.3346975E-03,   1.3572198E-03,   1.3812165E-03
     +,   1.4068075E-03,   1.4341272E-03,   1.4633231E-03
     +,   1.4945519E-03,   1.5279838E-03,   1.5637950E-03
     +,   1.6021716E-03,   1.6432973E-03,   1.6873598E-03
     +,   1.7345351E-03,   1.7849928E-03,   1.8388778E-03
     +,   1.8963141E-03,   1.9573923E-03,   2.0221591E-03
     +,   2.0906092E-03,   2.1626845E-03,   2.2382615E-03
     +,   2.3171345E-03,   2.3990290E-03,   2.4835726E-03
     +,   2.5703157E-03,   2.6587052E-03,   2.7481075E-03
     +,   2.8377881E-03,   2.9269406E-03,   3.0146702E-03
     +,   3.1000259E-03,   3.1820028E-03,   3.2595554E-03
     +,   3.3316209E-03,   3.3971455E-03,   3.4551045E-03
     +,   3.5045233E-03,   3.5445136E-03,   3.5743071E-03
     +,   3.5932905E-03,   3.6010437E-03,   3.5973962E-03
     +,   3.5824776E-03,   3.5567929E-03,   3.5212983E-03
     +,   3.4774987E-03,   3.4275609E-03,   3.3744446E-03
     +,   3.3220509E-03,   3.2753667E-03,   3.2406433E-03
     +,   3.2255605E-03,   3.2393781E-03,   3.2930805E-03
     +,   3.3994908E-03,   3.5733234E-03,   3.8312241E-03
     +,   4.1917241E-03,   4.6750843E-03,   5.3030862E-03
     +,   6.0987510E-03,   7.0858770E-03,   8.2883360E-03
     +,   9.7293062E-03,   1.1430375E-02,   1.3410238E-02
     +,   1.5683072E-02,   1.8256905E-02,   2.1131968E-02
     +,   2.4298592E-02,   2.7734978E-02,   3.1406157E-02
     +,   3.5262432E-02,   3.9238606E-02,   4.3254565E-02
     +,   4.7217030E-02,   5.1022165E-02,   5.4559242E-02
     +,   5.7716332E-02,   6.0386572E-02,   6.2474567E-02
     +,   6.3902818E-02,   6.4617813E-02,   6.4594336E-02
     +,   6.3837923E-02,   6.2385127E-02,   6.0301203E-02
     +,   5.7675548E-02,   5.4615524E-02,   5.1238801E-02
     +,   4.7665082E-02,   4.4008508E-02,   4.0371545E-02
     +,   3.6839616E-02,   3.3478096E-02,   3.0331602E-02
     +,   2.7425215E-02,   2.4766698E-02,   2.2349853E-02
     +,   2.0158758E-02,   1.8171873E-02,   1.6365197E-02
     +,   1.4715306E-02,   1.3201448E-02,   1.1806550E-02
     +,   1.0517490E-02,   9.3249809E-03,   8.2230009E-03
     +,   7.2078560E-03,   6.2772194E-03,   5.4294225E-03
     +,   4.6628388E-03,   3.9753774E-03,   3.3641870E-03
     +,   2.8256334E-03,   2.3553923E-03,   1.9484785E-03
     +,   1.5994959E-03,   1.3028485E-03,   1.0528979E-03
     +,   8.4411300E-04,   6.7121844E-04,   5.2929536E-04
     +,   4.1382341E-04,   3.2070931E-04,   2.4630749E-04
     +,   1.8741633E-04,   1.4125208E-04,   1.0542102E-04
     +,   7.7892335E-05,   5.6964742E-05,   4.1225325E-05
     +,   2.9517474E-05,   2.0906466E-05,   1.4645651E-05
     +,   1.0146293E-05,   6.9507673E-06,   4.7083640E-06
     +,   3.1537400E-06,   2.0889267E-06,   1.3684270E-06
     +,   8.8683595E-07,   5.6883141E-07,   3.6134838E-07
     +,   2.2756383E-07,   1.4229042E-07,   8.8528182E-08
     +,   5.4974752E-08,   3.4221813E-08,   2.1478444E-08
     +,   1.3688917E-08,   8.9313383E-09,   6.0127845E-09
     +,   4.2018895E-09,   3.0555098E-09,   2.3081510E-09
     +,   1.8021974E-09,   1.4446190E-09,   1.1806439E-09
     +,   9.7792530E-10,   8.1715484E-10,   6.8652711E-10
     +,   5.7857852E-10,   4.8838411E-10,   4.1250675E-10
     +,   3.4841849E-10,   2.9417421E-10,   2.4822347E-10
     +,   2.0929378E-10,   1.7632218E-10,   1.4841268E-10
     +,   1.2480711E-10,   1.0485783E-10,   8.8014561E-11
     +,   7.3806149E-11,   6.1832643E-11,   5.1751770E-11
     +,   4.3273003E-11,   3.6148411E-11,   3.0167861E-11
     +,   2.5152319E-11,   2.0950500E-11,   1.7433744E-11
     +,   1.4493190E-11,   1.2037020E-11,   9.9873356E-12
     +,   8.2787024E-12,   6.8556727E-12,   5.6717690E-12
     +,   4.6877389E-12,   3.8706855E-12,   3.1929173E-12
     +,   2.6312826E-12,   2.1663151E-12,   1.7817898E-12
     +,   1.4640846E-12,   1.2018649E-12
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_haonly_ttz95_mass = Yx/0.45854172
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_haonly_hatt100_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  6.1982282E-04,   6.5028039E-04
     +,   6.8151439E-04,   7.1349746E-04,   7.4619974E-04
     +,   7.7958836E-04,   8.1362738E-04,   8.4827875E-04
     +,   8.8350114E-04,   9.1925281E-04,   9.5548795E-04
     +,   9.9216041E-04,   1.0292216E-03,   1.0666223E-03
     +,   1.1043123E-03,   1.1422411E-03,   1.1803576E-03
     +,   1.2186114E-03,   1.2569525E-03,   1.2953321E-03
     +,   1.3337026E-03,   1.3720179E-03,   1.4102345E-03
     +,   1.4483129E-03,   1.4862131E-03,   1.5239018E-03
     +,   1.5613480E-03,   1.5985245E-03,   1.6354085E-03
     +,   1.6719816E-03,   1.7082301E-03,   1.7441452E-03
     +,   1.7797229E-03,   1.8149636E-03,   1.8498730E-03
     +,   1.8844616E-03,   1.9187444E-03,   1.9527401E-03
     +,   1.9864738E-03,   2.0199707E-03,   2.0532627E-03
     +,   2.0863826E-03,   2.1193663E-03,   2.1522513E-03
     +,   2.1850760E-03,   2.2178795E-03,   2.2507012E-03
     +,   2.2835785E-03,   2.3165473E-03,   2.3496423E-03
     +,   2.3828933E-03,   2.4163274E-03,   2.4499660E-03
     +,   2.4838280E-03,   2.5179219E-03,   2.5522541E-03
     +,   2.5868223E-03,   2.6216165E-03,   2.6566207E-03
     +,   2.6918107E-03,   2.7271539E-03,   2.7626129E-03
     +,   2.7981384E-03,   2.8336777E-03,   2.8691734E-03
     +,   2.9045562E-03,   2.9397591E-03,   2.9747048E-03
     +,   3.0093181E-03,   3.0435182E-03,   3.0772272E-03
     +,   3.1103648E-03,   3.1428565E-03,   3.1746281E-03
     +,   3.2056139E-03,   3.2357553E-03,   3.2649997E-03
     +,   3.2933052E-03,   3.3206427E-03,   3.3469968E-03
     +,   3.3723626E-03,   3.3967535E-03,   3.4201967E-03
     +,   3.4427377E-03,   3.4644371E-03,   3.4853746E-03
     +,   3.5056449E-03,   3.5253605E-03,   3.5446491E-03
     +,   3.5636530E-03,   3.5825286E-03,   3.6014433E-03
     +,   3.6205729E-03,   3.6401025E-03,   3.6602225E-03
     +,   3.6811223E-03,   3.7029940E-03,   3.7260219E-03
     +,   3.7503859E-03,   3.7762537E-03,   3.8037796E-03
     +,   3.8330990E-03,   3.8643298E-03,   3.8975629E-03
     +,   3.9328635E-03,   3.9702700E-03,   4.0097870E-03
     +,   4.0513854E-03,   4.0950030E-03,   4.1405428E-03
     +,   4.1878708E-03,   4.2368164E-03,   4.2871726E-03
     +,   4.3387045E-03,   4.3911366E-03,   4.4441707E-03
     +,   4.4974759E-03,   4.5507052E-03,   4.6034823E-03
     +,   4.6554236E-03,   4.7061318E-03,   4.7552027E-03
     +,   4.8022280E-03,   4.8468099E-03,   4.8885569E-03
     +,   4.9270885E-03,   4.9620485E-03,   4.9930974E-03
     +,   5.0199288E-03,   5.0422666E-03,   5.0598648E-03
     +,   5.0725220E-03,   5.0800685E-03,   5.0823810E-03
     +,   5.0793751E-03,   5.0710072E-03,   5.0572772E-03
     +,   5.0382228E-03,   5.0139190E-03,   4.9844752E-03
     +,   4.9500358E-03,   4.9107722E-03,   4.8668790E-03
     +,   4.8185717E-03,   4.7660852E-03,   4.7096624E-03
     +,   4.6495544E-03,   4.5860144E-03,   4.5193015E-03
     +,   4.4496614E-03,   4.3773311E-03,   4.3025445E-03
     +,   4.2255195E-03,   4.1464558E-03,   4.0655355E-03
     +,   3.9829267E-03,   3.8987831E-03,   3.8132358E-03
     +,   3.7263976E-03,   3.6383795E-03,   3.5492687E-03
     +,   3.4591467E-03,   3.3680943E-03,   3.2761949E-03
     +,   3.1835353E-03,   3.0902249E-03,   2.9964161E-03
     +,   2.9023290E-03,   2.8082787E-03,   2.7147352E-03
     +,   2.6223978E-03,   2.5322761E-03,   2.4457858E-03
     +,   2.3648657E-03,   2.2920973E-03,   2.2307734E-03
     +,   2.1849647E-03,   2.1595450E-03,   2.1601617E-03
     +,   2.1932547E-03,   2.2661653E-03,   2.3874782E-03
     +,   2.5677457E-03,   2.8207535E-03,   3.1653775E-03
     +,   3.6279545E-03,   4.2450540E-03,   5.0663655E-03
     +,   6.1573638E-03,   7.6016961E-03,   9.5042530E-03
     +,   1.1995355E-02,   1.5237330E-02,   1.9434575E-02
     +,   2.4845887E-02,   3.1794209E-02,   4.0665753E-02
     +,   5.1889047E-02,   6.5883763E-02,   8.2972601E-02
     +,   0.1032609    ,   0.1265071    ,   0.1520142    
     +,   0.1785769    ,   0.2045183    ,   0.2278435    
     +,   0.2464804    ,   0.2585804    ,   0.2628190    
     +,   0.2586235    ,   0.2462779    ,   0.2268824    
     +,   0.2021751    ,   0.1742565    ,   0.1452825    
     +,   0.1171878    ,   9.1481172E-02,   6.9143035E-02
     +,   5.0627198E-02,   3.5939872E-02,   2.4758777E-02
     +,   1.6569909E-02,   1.0787185E-02,   6.8407771E-03
     +,   4.2318758E-03,   2.5573850E-03,   1.5116901E-03
     +,   8.7503082E-04,   4.9645541E-04,   2.7632507E-04
     +,   1.5106874E-04,   8.1296625E-05,   4.3237902E-05
     +,   2.2898308E-05,   1.2231808E-05,   6.7200617E-06
     +,   3.8902781E-06,   2.4248698E-06,   1.6410228E-06
     +,   1.1947911E-06,   9.1753361E-07,   7.2830602E-07
     +,   5.8859308E-07,   4.7979370E-07,   3.9244645E-07
     +,   3.2125286E-07,   2.6284775E-07,   2.1483152E-07
     +,   1.7535395E-07,   1.4292809E-07,   1.1632765E-07
     +,   9.4536873E-08,   7.6713519E-08,   6.2157724E-08
     +,   5.0288005E-08,   4.0623085E-08,   3.2765708E-08
     +,   2.6387683E-08,   2.1218282E-08,   1.7034768E-08
     +,   1.3654502E-08,   1.0927610E-08,   8.7311811E-09
     +,   6.9647945E-09,   5.5466387E-09,   4.4098774E-09
     +,   3.5001404E-09,   2.7733422E-09,   2.1936879E-09
     +,   1.7321617E-09,   1.3653172E-09,   1.0742478E-09
     +,   8.4371965E-10,   6.6146061E-10,   5.1761961E-10
     +,   4.0431458E-10,   3.1522168E-10,   2.4530264E-10
     +,   1.9053037E-10,   1.4770794E-10,   1.1429019E-10
     +,   8.8263563E-11,   6.8031400E-11,   5.2335445E-11
     +,   4.0181775E-11,   3.0790266E-11,   2.3547247E-11
     +,   1.7972297E-11,   1.3690117E-11,   1.0407379E-11
     +,   7.8960579E-12,   5.9786707E-12,   4.5178197E-12
     +,   3.4070108E-12,   2.5641572E-12,   1.9258943E-12
     +,   1.4435884E-12,   1.0798609E-12,   8.0614221E-13
     +,   6.0057374E-13,   4.4651785E-13
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_haonly_hatt100_mass = Yx/1.0287795
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_haonly_hatt105_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.3815143E-03,   2.5230094E-03
     +,   2.6721836E-03,   2.8291605E-03,   2.9940291E-03
     +,   3.1668362E-03,   3.3475847E-03,   3.5362293E-03
     +,   3.7326694E-03,   3.9367587E-03,   4.1482830E-03
     +,   4.3669720E-03,   4.5924918E-03,   4.8244470E-03
     +,   5.0623743E-03,   5.3057498E-03,   5.5539845E-03
     +,   5.8064279E-03,   6.0623707E-03,   6.3210474E-03
     +,   6.5816389E-03,   6.8432828E-03,   7.1050702E-03
     +,   7.3660738E-03,   7.6253102E-03,   7.8818053E-03
     +,   8.1345625E-03,   8.3825868E-03,   8.6248890E-03
     +,   8.8605015E-03,   9.0884808E-03,   9.3079377E-03
     +,   9.5180171E-03,   9.7179320E-03,   9.9069597E-03
     +,   1.0084465E-02,   1.0249893E-02,   1.0402784E-02
     +,   1.0542797E-02,   1.0669671E-02,   1.0783288E-02
     +,   1.0883627E-02,   1.0970790E-02,   1.1045004E-02
     +,   1.1106612E-02,   1.1156065E-02,   1.1193929E-02
     +,   1.1220880E-02,   1.1237686E-02,   1.1245202E-02
     +,   1.1244365E-02,   1.1236174E-02,   1.1221690E-02
     +,   1.1201998E-02,   1.1178226E-02,   1.1151505E-02
     +,   1.1122965E-02,   1.1093719E-02,   1.1064850E-02
     +,   1.1037393E-02,   1.1012334E-02,   1.0990589E-02
     +,   1.0973002E-02,   1.0960327E-02,   1.0953244E-02
     +,   1.0952325E-02,   1.0958068E-02,   1.0970874E-02
     +,   1.0991061E-02,   1.1018855E-02,   1.1054425E-02
     +,   1.1097855E-02,   1.1149194E-02,   1.1208429E-02
     +,   1.1275522E-02,   1.1350420E-02,   1.1433042E-02
     +,   1.1523311E-02,   1.1621173E-02,   1.1726575E-02
     +,   1.1839485E-02,   1.1959919E-02,   1.2087896E-02
     +,   1.2223492E-02,   1.2366788E-02,   1.2517910E-02
     +,   1.2676982E-02,   1.2844174E-02,   1.3019618E-02
     +,   1.3203464E-02,   1.3395847E-02,   1.3596849E-02
     +,   1.3806505E-02,   1.4024802E-02,   1.4251652E-02
     +,   1.4486844E-02,   1.4730093E-02,   1.4980962E-02
     +,   1.5238905E-02,   1.5503209E-02,   1.5773043E-02
     +,   1.6047390E-02,   1.6325131E-02,   1.6604977E-02
     +,   1.6885549E-02,   1.7165391E-02,   1.7442992E-02
     +,   1.7716818E-02,   1.7985405E-02,   1.8247427E-02
     +,   1.8501649E-02,   1.8747132E-02,   1.8983200E-02
     +,   1.9209508E-02,   1.9426109E-02,   1.9633491E-02
     +,   1.9832505E-02,   2.0024480E-02,   2.0211089E-02
     +,   2.0394364E-02,   2.0576594E-02,   2.0760210E-02
     +,   2.0947730E-02,   2.1141589E-02,   2.1344069E-02
     +,   2.1557126E-02,   2.1782357E-02,   2.2020819E-02
     +,   2.2273092E-02,   2.2539135E-02,   2.2818400E-02
     +,   2.3109784E-02,   2.3411799E-02,   2.3722598E-02
     +,   2.4040157E-02,   2.4362460E-02,   2.4687540E-02
     +,   2.5013689E-02,   2.5339555E-02,   2.5664279E-02
     +,   2.5987383E-02,   2.6308874E-02,   2.6629131E-02
     +,   2.6948763E-02,   2.7268376E-02,   2.7588459E-02
     +,   2.7909001E-02,   2.8229354E-02,   2.8547872E-02
     +,   2.8861783E-02,   2.9167056E-02,   2.9458236E-02
     +,   2.9728601E-02,   2.9970223E-02,   3.0174224E-02
     +,   3.0331150E-02,   3.0431384E-02,   3.0465722E-02
     +,   3.0425875E-02,   3.0305084E-02,   3.0098705E-02
     +,   2.9804623E-02,   2.9423738E-02,   2.8960241E-02
     +,   2.8421693E-02,   2.7819034E-02,   2.7166381E-02
     +,   2.6480693E-02,   2.5781160E-02,   2.5088575E-02
     +,   2.4424685E-02,   2.3811251E-02,   2.3269188E-02
     +,   2.2817794E-02,   2.2473989E-02,   2.2251522E-02
     +,   2.2160502E-02,   2.2206914E-02,   2.2392370E-02
     +,   2.2714019E-02,   2.3164630E-02,   2.3732791E-02
     +,   2.4403300E-02,   2.5157744E-02,   2.5975058E-02
     +,   2.6832208E-02,   2.7704895E-02,   2.8568480E-02
     +,   2.9398568E-02,   3.0171685E-02,   3.0866142E-02
     +,   3.1462379E-02,   3.1943522E-02,   3.2295734E-02
     +,   3.2508474E-02,   3.2574628E-02,   3.2490410E-02
     +,   3.2255471E-02,   3.1872522E-02,   3.1347115E-02
     +,   3.0687369E-02,   2.9903561E-02,   2.9007602E-02
     +,   2.8012723E-02,   2.6933087E-02,   2.5783233E-02
     +,   2.4577789E-02,   2.3331206E-02,   2.2057412E-02
     +,   2.0769477E-02,   1.9479528E-02,   1.8198691E-02
     +,   1.6936934E-02,   1.5702905E-02,   1.4504070E-02
     +,   1.3346763E-02,   1.2236172E-02,   1.1176340E-02
     +,   1.0170302E-02,   9.2202853E-03,   8.3275922E-03
     +,   7.4927812E-03,   6.7158230E-03,   5.9961076E-03
     +,   5.3324797E-03,   4.7233761E-03,   4.1669151E-03
     +,   3.6609189E-03,   3.2029431E-03,   2.7903696E-03
     +,   2.4204771E-03,   2.0904567E-03,   1.7974337E-03
     +,   1.5385334E-03,   1.3109376E-03,   1.1118627E-03
     +,   9.3861757E-04,   7.8863162E-04,   6.5946160E-04
     +,   5.4879789E-04,   4.5448763E-04,   3.7454488E-04
     +,   3.0714597E-04,   2.5062711E-04,   2.0348714E-04
     +,   1.6438513E-04,   1.3212849E-04,   1.0566370E-04
     +,   8.4069499E-05,   6.6547560E-05,   5.2407901E-05
     +,   4.1060262E-05,   3.2004024E-05,   2.4816682E-05
     +,   1.9143912E-05,   1.4691211E-05,   1.1215644E-05
     +,   8.5178699E-06,   6.4353394E-06,   4.8365837E-06
     +,   3.6160468E-06,   2.6894302E-06,   1.9898064E-06
     +,   1.4644684E-06,   1.0721971E-06,   7.8088908E-07
     +,   5.6574152E-07,   4.0772224E-07,   2.9230222E-07
     +,   2.0845638E-07,   1.4787955E-07,   1.0435539E-07
     +,   7.3255492E-08,   5.1153858E-08,   3.5532352E-08
     +,   2.4552012E-08,   1.6875559E-08,   1.1538468E-08
     +,   7.8477989E-09,   5.3097140E-09,   3.5736367E-09
     +,   2.3926743E-09,   1.5936297E-09,   1.0559563E-09
     +,   6.9609141E-10,   4.5654786E-10,   2.9794592E-10
     +,   1.9349340E-10,   1.2507231E-10,   8.0485667E-11
     +,   5.1582523E-11,   3.2939904E-11,   2.0974888E-11
     +,   1.3330937E-11,   8.4690371E-12,   5.3883798E-12
     +,   3.4427012E-12,   2.2164974E-12,   1.4444038E-12
     +,   9.5768565E-13,   6.4972344E-13
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_haonly_hatt105_mass = Yx/0.9308005
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_haonly_hatt107_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  5.3327443E-04,   5.9572369E-04
     +,   6.6391291E-04,   7.3815760E-04,   8.1876415E-04
     +,   9.0602587E-04,   1.0002180E-03,   1.1015949E-03
     +,   1.2103824E-03,   1.3267819E-03,   1.4509544E-03
     +,   1.5830244E-03,   1.7230725E-03,   1.8711352E-03
     +,   2.0271975E-03,   2.1911934E-03,   2.3630036E-03
     +,   2.5424527E-03,   2.7293097E-03,   2.9232886E-03
     +,   3.1240499E-03,   3.3312002E-03,   3.5442952E-03
     +,   3.7628589E-03,   3.9863493E-03,   4.2142146E-03
     +,   4.4458592E-03,   4.6806694E-03,   4.9180123E-03
     +,   5.1572500E-03,   5.3977380E-03,   5.6388401E-03
     +,   5.8799293E-03,   6.1203935E-03,   6.3596424E-03
     +,   6.5971105E-03,   6.8322606E-03,   7.0645795E-03
     +,   7.2935936E-03,   7.5188344E-03,   7.7398787E-03
     +,   7.9563120E-03,   8.1677344E-03,   8.3737513E-03
     +,   8.5739708E-03,   8.7679904E-03,   8.9553911E-03
     +,   9.1357324E-03,   9.3085393E-03,   9.4732987E-03
     +,   9.6294573E-03,   9.7764190E-03,   9.9135311E-03
     +,   1.0040116E-02,   1.0155434E-02,   1.0258735E-02
     +,   1.0349235E-02,   1.0426151E-02,   1.0488708E-02
     +,   1.0536169E-02,   1.0567840E-02,   1.0583123E-02
     +,   1.0581520E-02,   1.0562673E-02,   1.0526386E-02
     +,   1.0472661E-02,   1.0401727E-02,   1.0314060E-02
     +,   1.0210412E-02,   1.0091827E-02,   9.9596623E-03
     +,   9.8156016E-03,   9.6616391E-03,   9.5001161E-03
     +,   9.3336748E-03,   9.1652554E-03,   8.9980820E-03
     +,   8.8356193E-03,   8.6815264E-03,   8.5396189E-03
     +,   8.4138112E-03,   8.3080484E-03,   8.2262484E-03
     +,   8.1722168E-03,   8.1495829E-03,   8.1617199E-03
     +,   8.2116537E-03,   8.3020143E-03,   8.4349373E-03
     +,   8.6120144E-03,   8.8342363E-03,   9.1019273E-03
     +,   9.4147045E-03,   9.7714821E-03,   1.0170437E-02
     +,   1.0608980E-02,   1.1083847E-02,   1.1591032E-02
     +,   1.2125951E-02,   1.2683382E-02,   1.3257677E-02
     +,   1.3842730E-02,   1.4432214E-02,   1.5019581E-02
     +,   1.5598308E-02,   1.6162006E-02,   1.6704507E-02
     +,   1.7220078E-02,   1.7703606E-02,   1.8150670E-02
     +,   1.8557668E-02,   1.8922022E-02,   1.9242132E-02
     +,   1.9517580E-02,   1.9749027E-02,   1.9938331E-02
     +,   2.0088393E-02,   2.0203160E-02,   2.0287443E-02
     +,   2.0346787E-02,   2.0387262E-02,   2.0415287E-02
     +,   2.0437347E-02,   2.0459767E-02,   2.0488514E-02
     +,   2.0528905E-02,   2.0585459E-02,   2.0661702E-02
     +,   2.0760085E-02,   2.0881858E-02,   2.1027133E-02
     +,   2.1194868E-02,   2.1383058E-02,   2.1588797E-02
     +,   2.1808602E-02,   2.2038598E-02,   2.2274783E-02
     +,   2.2513337E-02,   2.2750871E-02,   2.2984643E-02
     +,   2.3212722E-02,   2.3434130E-02,   2.3648858E-02
     +,   2.3857897E-02,   2.4062999E-02,   2.4266642E-02
     +,   2.4471685E-02,   2.4681170E-02,   2.4897963E-02
     +,   2.5124541E-02,   2.5362724E-02,   2.5613397E-02
     +,   2.5876453E-02,   2.6150728E-02,   2.6433988E-02
     +,   2.6723038E-02,   2.7013863E-02,   2.7301980E-02
     +,   2.7582610E-02,   2.7851006E-02,   2.8102839E-02
     +,   2.8334450E-02,   2.8543139E-02,   2.8727408E-02
     +,   2.8887168E-02,   2.9023819E-02,   2.9140282E-02
     +,   2.9240917E-02,   2.9331442E-02,   2.9418638E-02
     +,   2.9509997E-02,   2.9613374E-02,   2.9736463E-02
     +,   2.9886320E-02,   3.0068748E-02,   3.0287890E-02
     +,   3.0545658E-02,   3.0841399E-02,   3.1171596E-02
     +,   3.1529795E-02,   3.1906605E-02,   3.2289937E-02
     +,   3.2665398E-02,   3.3016872E-02,   3.3327185E-02
     +,   3.3578835E-02,   3.3754855E-02,   3.3839606E-02
     +,   3.3819512E-02,   3.3683695E-02,   3.3424471E-02
     +,   3.3037640E-02,   3.2522716E-02,   3.1882770E-02
     +,   3.1124227E-02,   3.0256456E-02,   2.9291339E-02
     +,   2.8242623E-02,   2.7125195E-02,   2.5954520E-02
     +,   2.4746103E-02,   2.3514846E-02,   2.2274543E-02
     +,   2.1037616E-02,   1.9814983E-02,   1.8615713E-02
     +,   1.7447112E-02,   1.6314909E-02,   1.5223260E-02
     +,   1.4174921E-02,   1.3171495E-02,   1.2213765E-02
     +,   1.1301811E-02,   1.0435167E-02,   9.6130567E-03
     +,   8.8345734E-03,   8.0987317E-03,   7.4044829E-03
     +,   6.7508095E-03,   6.1367983E-03,   5.5614994E-03
     +,   5.0239852E-03,   4.5233513E-03,   4.0586521E-03
     +,   3.6288458E-03,   3.2328167E-03,   2.8693751E-03
     +,   2.5372317E-03,   2.2349725E-03,   1.9610999E-03
     +,   1.7140531E-03,   1.4922109E-03,   1.2938958E-03
     +,   1.1174124E-03,   9.6108502E-04,   8.2324119E-04
     +,   7.0224941E-04,   5.9654145E-04,   5.0461554E-04
     +,   4.2504145E-04,   3.5647713E-04,   2.9767692E-04
     +,   2.4748823E-04,   2.0485032E-04,   1.6879824E-04
     +,   1.3846169E-04,   1.1305855E-04,   9.1889313E-05
     +,   7.4334450E-05,   5.9849983E-05,   4.7958212E-05
     +,   3.8244056E-05,   3.0349438E-05,   2.3966684E-05
     +,   1.8832798E-05,   1.4724851E-05,   1.1455220E-05
     +,   8.8666829E-06,   6.8281997E-06,   5.2314426E-06
     +,   3.9874762E-06,   3.0236317E-06,   2.2808624E-06
     +,   1.7115725E-06,   1.2776620E-06,   9.4874440E-07
     +,   7.0078255E-07,   5.1489081E-07,   3.7630778E-07
     +,   2.7356305E-07,   1.9780997E-07,   1.4227051E-07
     +,   1.0177921E-07,   7.2422139E-08,   5.1255949E-08
     +,   3.6081428E-08,   2.5262613E-08,   1.7592795E-08
     +,   1.2185446E-08,   8.3947151E-09,   5.7519753E-09
     +,   3.9199732E-09,   2.6570037E-09,   1.7912426E-09
     +,   1.2010389E-09,   8.0096002E-10,   5.3126203E-10
     +,   3.5046493E-10,   2.2994752E-10,   1.5005434E-10
     +,   9.7390367E-11,   6.2866205E-11,   4.0361343E-11
     +,   2.5771853E-11,   1.6367088E-11,   1.0337801E-11
     +,   6.4942340E-12,   4.0574957E-12,   2.5213397E-12
     +,   1.5582314E-12,   9.5779884E-13
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_haonly_hatt107_mass = Yx/0.831132206896552
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_haonly_hatt110_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.2179657E-03,   1.2541654E-03
     +,   1.2910269E-03,   1.3286473E-03,   1.3671393E-03
     +,   1.4066296E-03,   1.4472591E-03,   1.4891841E-03
     +,   1.5325730E-03,   1.5776099E-03,   1.6244885E-03
     +,   1.6734134E-03,   1.7245978E-03,   1.7782622E-03
     +,   1.8346311E-03,   1.8939312E-03,   1.9563881E-03
     +,   2.0222242E-03,   2.0916527E-03,   2.1648782E-03
     +,   2.2420911E-03,   2.3234622E-03,   2.4091424E-03
     +,   2.4992626E-03,   2.5939159E-03,   2.6931737E-03
     +,   2.7970702E-03,   2.9056035E-03,   3.0187352E-03
     +,   3.1363878E-03,   3.2584441E-03,   3.3847506E-03
     +,   3.5151129E-03,   3.6493049E-03,   3.7870652E-03
     +,   3.9281081E-03,   4.0721246E-03,   4.2187888E-03
     +,   4.3677781E-03,   4.5187525E-03,   4.6714041E-03
     +,   4.8254365E-03,   4.9805949E-03,   5.1366664E-03
     +,   5.2935043E-03,   5.4510329E-03,   5.6092599E-03
     +,   5.7682903E-03,   5.9283404E-03,   6.0897325E-03
     +,   6.2529161E-03,   6.4184614E-03,   6.5870560E-03
     +,   6.7595164E-03,   6.9367522E-03,   7.1197837E-03
     +,   7.3096962E-03,   7.5076367E-03,   7.7147745E-03
     +,   7.9322737E-03,   8.1612589E-03,   8.4027788E-03
     +,   8.6577386E-03,   8.9269010E-03,   9.2108222E-03
     +,   9.5097795E-03,   9.8237917E-03,   1.0152515E-02
     +,   1.0495281E-02,   1.0851000E-02,   1.1218214E-02
     +,   1.1595022E-02,   1.1979154E-02,   1.2367890E-02
     +,   1.2758174E-02,   1.3146616E-02,   1.3529488E-02
     +,   1.3902832E-02,   1.4262534E-02,   1.4604370E-02
     +,   1.4924052E-02,   1.5217392E-02,   1.5480304E-02
     +,   1.5708961E-02,   1.5899828E-02,   1.6049780E-02
     +,   1.6156152E-02,   1.6216813E-02,   1.6230233E-02
     +,   1.6195513E-02,   1.6112426E-02,   1.5981426E-02
     +,   1.5803665E-02,   1.5580952E-02,   1.5315738E-02
     +,   1.5011098E-02,   1.4670618E-02,   1.4298395E-02
     +,   1.3898887E-02,   1.3476907E-02,   1.3037437E-02
     +,   1.2585655E-02,   1.2126695E-02,   1.1665714E-02
     +,   1.1207675E-02,   1.0757317E-02,   1.0319124E-02
     +,   9.8972265E-03,   9.4953291E-03,   9.1166999E-03
     +,   8.7641980E-03,   8.4401648E-03,   8.1465188E-03
     +,   7.8846989E-03,   7.6557444E-03,   7.4602752E-03
     +,   7.2985846E-03,   7.1706222E-03,   7.0760986E-03
     +,   7.0144809E-03,   6.9850683E-03,   6.9870288E-03
     +,   7.0194169E-03,   7.0812292E-03,   7.1714143E-03
     +,   7.2888862E-03,   7.4325437E-03,   7.6012569E-03
     +,   7.7938871E-03,   8.0092354E-03,   8.2460754E-03
     +,   8.5030878E-03,   8.7788822E-03,   9.0719340E-03
     +,   9.3806097E-03,   9.7031407E-03,   1.0037583E-02
     +,   1.0381843E-02,   1.0733698E-02,   1.1090803E-02
     +,   1.1450675E-02,   1.1810756E-02,   1.2168469E-02
     +,   1.2521247E-02,   1.2866543E-02,   1.3201954E-02
     +,   1.3525231E-02,   1.3834342E-02,   1.4127508E-02
     +,   1.4403293E-02,   1.4660624E-02,   1.4898804E-02
     +,   1.5117552E-02,   1.5317054E-02,   1.5497923E-02
     +,   1.5661212E-02,   1.5808405E-02,   1.5941391E-02
     +,   1.6062438E-02,   1.6174123E-02,   1.6279295E-02
     +,   1.6381023E-02,   1.6482497E-02,   1.6586937E-02
     +,   1.6697550E-02,   1.6817383E-02,   1.6949238E-02
     +,   1.7095555E-02,   1.7258324E-02,   1.7438967E-02
     +,   1.7638223E-02,   1.7856097E-02,   1.8091746E-02
     +,   1.8343482E-02,   1.8608689E-02,   1.8883862E-02
     +,   1.9164642E-02,   1.9445859E-02,   1.9721655E-02
     +,   1.9985624E-02,   2.0230971E-02,   2.0450674E-02
     +,   2.0637710E-02,   2.0785289E-02,   2.0887015E-02
     +,   2.0937143E-02,   2.0930737E-02,   2.0863831E-02
     +,   2.0733586E-02,   2.0538345E-02,   2.0277718E-02
     +,   1.9952539E-02,   1.9564897E-02,   1.9118004E-02
     +,   1.8616071E-02,   1.8064193E-02,   1.7468199E-02
     +,   1.6834453E-02,   1.6169615E-02,   1.5480503E-02
     +,   1.4773948E-02,   1.4056610E-02,   1.3334769E-02
     +,   1.2614265E-02,   1.1900483E-02,   1.1198135E-02
     +,   1.0511307E-02,   9.8434901E-03,   9.1975369E-03
     +,   8.5756481E-03,   7.9794675E-03,   7.4101603E-03
     +,   6.8684388E-03,   6.3545890E-03,   5.8685616E-03
     +,   5.4100766E-03,   4.9786298E-03,   4.5735235E-03
     +,   4.1939383E-03,   3.8390036E-03,   3.5077496E-03
     +,   3.1991778E-03,   2.9122906E-03,   2.6460828E-03
     +,   2.3995361E-03,   2.1716445E-03,   1.9614331E-03
     +,   1.7679433E-03,   1.5902218E-03,   1.4273386E-03
     +,   1.2783968E-03,   1.1425208E-03,   1.0188501E-03
     +,   9.0655236E-04,   8.0483261E-04,   7.1291398E-04
     +,   6.3005200E-04,   5.5553950E-04,   4.8870186E-04
     +,   4.2889398E-04,   3.7550743E-04,   3.2797272E-04
     +,   2.8575546E-04,   2.4835361E-04,   2.1530098E-04
     +,   1.8616766E-04,   1.6055624E-04,   1.3809939E-04
     +,   1.1846048E-04,   1.0133375E-04,   8.6438697E-05
     +,   7.3520656E-05,   6.2349922E-05,   5.2718900E-05
     +,   4.4440036E-05,   3.7345115E-05,   3.1284118E-05
     +,   2.6123094E-05,   2.1742602E-05,   1.8036861E-05
     +,   1.4912661E-05,   1.2287887E-05,   1.0090361E-05
     +,   8.2570077E-06,   6.7330925E-06,   5.4709735E-06
     +,   4.4295020E-06,   3.5733465E-06,   2.8722070E-06
     +,   2.3001830E-06,   1.8352750E-06,   1.4589012E-06
     +,   1.1553935E-06,   9.1159649E-07,   7.1652744E-07
     +,   5.6107427E-07,   4.3767582E-07,   3.4011862E-07
     +,   2.6329442E-07,   2.0304360E-07,   1.5597735E-07
     +,   1.1936100E-07,   9.0987427E-08,   6.9091122E-08
     +,   5.2260670E-08,   3.9377305E-08,   2.9554753E-08
     +,   2.2096074E-08,   1.6455619E-08,   1.2207196E-08
     +,   9.0204253E-09,   6.6395294E-09,   4.8680535E-09
     +,   3.5552585E-09,   2.5863844E-09,   1.8741766E-09
     +,   1.3527971E-09,   9.7263642E-10,   6.9658124E-10
     +,   4.9692017E-10,   3.5310588E-10
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_haonly_hatt110_mass = Yx/0.553958192307692
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_haonly_hatt115_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.7117244E-03,   3.8128654E-03
     +,   3.9146845E-03,   4.0171403E-03,   4.1201804E-03
     +,   4.2237453E-03,   4.3277680E-03,   4.4321674E-03
     +,   4.5368518E-03,   4.6417252E-03,   4.7466741E-03
     +,   4.8515745E-03,   4.9562948E-03,   5.0606937E-03
     +,   5.1646219E-03,   5.2679251E-03,   5.3704432E-03
     +,   5.4720165E-03,   5.5724862E-03,   5.6716949E-03
     +,   5.7694963E-03,   5.8657527E-03,   5.9603383E-03
     +,   6.0531511E-03,   6.1440985E-03,   6.2331241E-03
     +,   6.3201897E-03,   6.4052884E-03,   6.4884447E-03
     +,   6.5697161E-03,   6.6491924E-03,   6.7269974E-03
     +,   6.8032891E-03,   6.8782563E-03,   6.9521181E-03
     +,   7.0251226E-03,   7.0975334E-03,   7.1696420E-03
     +,   7.2417483E-03,   7.3141549E-03,   7.3871696E-03
     +,   7.4610934E-03,   7.5362111E-03,   7.6127821E-03
     +,   7.6910402E-03,   7.7711786E-03,   7.8533459E-03
     +,   7.9376390E-03,   8.0240956E-03,   8.1126867E-03
     +,   8.2033193E-03,   8.2958248E-03,   8.3899619E-03
     +,   8.4854169E-03,   8.5817985E-03,   8.6786449E-03
     +,   8.7754289E-03,   8.8715581E-03,   8.9663891E-03
     +,   9.0592243E-03,   9.1493372E-03,   9.2359688E-03
     +,   9.3183490E-03,   9.3957065E-03,   9.4672814E-03
     +,   9.5323399E-03,   9.5901899E-03,   9.6401870E-03
     +,   9.6817650E-03,   9.7144190E-03,   9.7377561E-03
     +,   9.7514717E-03,   9.7553777E-03,   9.7494060E-03
     +,   9.7336043E-03,   9.7081577E-03,   9.6733756E-03
     +,   9.6297003E-03,   9.5776953E-03,   9.5180431E-03
     +,   9.4515542E-03,   9.3791271E-03,   9.3017630E-03
     +,   9.2205377E-03,   9.1366041E-03,   9.0511516E-03
     +,   8.9654122E-03,   8.8806311E-03,   8.7980498E-03
     +,   8.7188827E-03,   8.6443108E-03,   8.5754497E-03
     +,   8.5133417E-03,   8.4589301E-03,   8.4130494E-03
     +,   8.3764093E-03,   8.3495751E-03,   8.3329706E-03
     +,   8.3268555E-03,   8.3313230E-03,   8.3462978E-03
     +,   8.3715254E-03,   8.4065869E-03,   8.4508853E-03
     +,   8.5036624E-03,   8.5640028E-03,   8.6308448E-03
     +,   8.7029869E-03,   8.7791169E-03,   8.8578174E-03
     +,   8.9375852E-03,   9.0168621E-03,   9.0940464E-03
     +,   9.1675241E-03,   9.2356866E-03,   9.2969649E-03
     +,   9.3498416E-03,   9.3929023E-03,   9.4248196E-03
     +,   9.4444156E-03,   9.4506657E-03,   9.4427215E-03
     +,   9.4199320E-03,   9.3818586E-03,   9.3282852E-03
     +,   9.2592388E-03,   9.1749867E-03,   9.0760533E-03
     +,   8.9631937E-03,   8.8374298E-03,   8.7000029E-03
     +,   8.5523976E-03,   8.3962940E-03,   8.2335826E-03
     +,   8.0663180E-03,   7.8966944E-03,   7.7270460E-03
     +,   7.5597973E-03,   7.3974198E-03,   7.2424156E-03
     +,   7.0972964E-03,   6.9645336E-03,   6.8465192E-03
     +,   6.7455424E-03,   6.6637755E-03,   6.6032200E-03
     +,   6.5656891E-03,   6.5527991E-03,   6.5659266E-03
     +,   6.6062100E-03,   6.6745384E-03,   6.7715277E-03
     +,   6.8975342E-03,   7.0526474E-03,   7.2367019E-03
     +,   7.4492660E-03,   7.6896651E-03,   7.9570059E-03
     +,   8.2501806E-03,   8.5678622E-03,   8.9085661E-03
     +,   9.2706485E-03,   9.6523026E-03,   1.0051588E-02
     +,   1.0466481E-02,   1.0894862E-02,   1.1334497E-02
     +,   1.1783082E-02,   1.2238271E-02,   1.2697666E-02
     +,   1.3158779E-02,   1.3619075E-02,   1.4076003E-02
     +,   1.4526972E-02,   1.4969303E-02,   1.5400329E-02
     +,   1.5817350E-02,   1.6217627E-02,   1.6598407E-02
     +,   1.6956970E-02,   1.7290631E-02,   1.7596718E-02
     +,   1.7872632E-02,   1.8115908E-02,   1.8324191E-02
     +,   1.8495278E-02,   1.8627176E-02,   1.8718131E-02
     +,   1.8766632E-02,   1.8771479E-02,   1.8731788E-02
     +,   1.8647024E-02,   1.8517021E-02,   1.8342009E-02
     +,   1.8122591E-02,   1.7859761E-02,   1.7554924E-02
     +,   1.7209858E-02,   1.6826682E-02,   1.6407840E-02
     +,   1.5956104E-02,   1.5474516E-02,   1.4966303E-02
     +,   1.4434876E-02,   1.3883817E-02,   1.3316748E-02
     +,   1.2737313E-02,   1.2149194E-02,   1.1555995E-02
     +,   1.0961189E-02,   1.0368106E-02,   9.7799310E-03
     +,   9.1996426E-03,   8.6299470E-03,   8.0732983E-03
     +,   7.5319195E-03,   7.0077511E-03,   6.5024230E-03
     +,   6.0172826E-03,   5.5534514E-03,   5.1117376E-03
     +,   4.6926951E-03,   4.2966725E-03,   3.9237924E-03
     +,   3.5739525E-03,   3.2468708E-03,   2.9421293E-03
     +,   2.6591672E-03,   2.3972867E-03,   2.1556958E-03
     +,   1.9335401E-03,   1.7299032E-03,   1.5438107E-03
     +,   1.3742631E-03,   1.2202638E-03,   1.0807969E-03
     +,   9.5485814E-04,   8.4146991E-04,   7.3967892E-04
     +,   6.4855762E-04,   5.6721736E-04,   4.9481657E-04
     +,   4.3055665E-04,   3.7368087E-04,   3.2348081E-04
     +,   2.7929904E-04,   2.4052450E-04,   2.0659012E-04
     +,   1.7697457E-04,   1.5120301E-04,   1.2883935E-04
     +,   1.0948765E-04,   9.2790709E-05,   7.8426201E-05
     +,   6.6103545E-05,   5.5562847E-05,   4.6573070E-05
     +,   3.8928716E-05,   3.2447388E-05,   2.6968266E-05
     +,   2.2350376E-05,   1.8470115E-05,   1.5219392E-05
     +,   1.2504245E-05,   1.0243494E-05,   8.3667956E-06
     +,   6.8136601E-06,   5.5323258E-06,   4.4785497E-06
     +,   3.6145957E-06,   2.9084727E-06,   2.3331884E-06
     +,   1.8659985E-06,   1.4877851E-06,   1.1825709E-06
     +,   9.3707303E-07,   7.4022938E-07,   5.8291761E-07
     +,   4.5759791E-07,   3.5809529E-07,   2.7934394E-07
     +,   2.1722353E-07,   1.6838028E-07,   1.3010498E-07
     +,   1.0020818E-07,   7.6934768E-08,   5.8876740E-08
     +,   4.4911612E-08,   3.4148485E-08,   2.5880325E-08
     +,   1.9550509E-08,   1.4720575E-08,   1.1047756E-08
     +,   8.2640819E-09,   6.1615593E-09,   4.5788022E-09
     +,   3.3914249E-09,   2.5036351E-09,   1.8421428E-09
     +,   1.3509142E-09,   9.8739295E-10
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_haonly_hatt115_mass = Yx/0.51732912
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_haonly_hatt120_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.0622098E-03,   3.1672278E-03
     +,   3.2752077E-03,   3.3860398E-03,   3.4995899E-03
     +,   3.6156967E-03,   3.7341681E-03,   3.8547886E-03
     +,   3.9773067E-03,   4.1014529E-03,   4.2269207E-03
     +,   4.3533798E-03,   4.4804746E-03,   4.6078241E-03
     +,   4.7350251E-03,   4.8616566E-03,   4.9872776E-03
     +,   5.1114350E-03,   5.2336659E-03,   5.3535011E-03
     +,   5.4704677E-03,   5.5840965E-03,   5.6939232E-03
     +,   5.7995017E-03,   5.9003895E-03,   5.9961788E-03
     +,   6.0864785E-03,   6.1709331E-03,   6.2492169E-03
     +,   6.3210516E-03,   6.3861930E-03,   6.4444509E-03
     +,   6.4956811E-03,   6.5397932E-03,   6.5767518E-03
     +,   6.6065788E-03,   6.6293492E-03,   6.6452008E-03
     +,   6.6543254E-03,   6.6569727E-03,   6.6534486E-03
     +,   6.6441093E-03,   6.6293646E-03,   6.6096717E-03
     +,   6.5855286E-03,   6.5574790E-03,   6.5260986E-03
     +,   6.4919954E-03,   6.4558103E-03,   6.4181956E-03
     +,   6.3798320E-03,   6.3414061E-03,   6.3036182E-03
     +,   6.2671667E-03,   6.2327534E-03,   6.2010740E-03
     +,   6.1728102E-03,   6.1486424E-03,   6.1292201E-03
     +,   6.1151842E-03,   6.1071478E-03,   6.1056991E-03
     +,   6.1113979E-03,   6.1247712E-03,   6.1463118E-03
     +,   6.1764792E-03,   6.2156878E-03,   6.2643159E-03
     +,   6.3226935E-03,   6.3911024E-03,   6.4697778E-03
     +,   6.5588946E-03,   6.6585797E-03,   6.7688893E-03
     +,   6.8898238E-03,   7.0213219E-03,   7.1632415E-03
     +,   7.3153693E-03,   7.4774255E-03,   7.6490529E-03
     +,   7.8298030E-03,   8.0191679E-03,   8.2165319E-03
     +,   8.4212339E-03,   8.6324923E-03,   8.8494886E-03
     +,   9.0712970E-03,   9.2969462E-03,   9.5253754E-03
     +,   9.7554829E-03,   9.9861119E-03,   1.0216049E-02
     +,   1.0444039E-02,   1.0668810E-02,   1.0889083E-02
     +,   1.1103537E-02,   1.1310888E-02,   1.1509835E-02
     +,   1.1699130E-02,   1.1877535E-02,   1.2043882E-02
     +,   1.2197036E-02,   1.2335959E-02,   1.2459661E-02
     +,   1.2567258E-02,   1.2657953E-02,   1.2731047E-02
     +,   1.2785957E-02,   1.2822201E-02,   1.2839424E-02
     +,   1.2837385E-02,   1.2815963E-02,   1.2775160E-02
     +,   1.2715100E-02,   1.2636029E-02,   1.2538303E-02
     +,   1.2422401E-02,   1.2288905E-02,   1.2138510E-02
     +,   1.1972001E-02,   1.1790262E-02,   1.1594266E-02
     +,   1.1385072E-02,   1.1163805E-02,   1.0931646E-02
     +,   1.0689858E-02,   1.0439729E-02,   1.0182614E-02
     +,   9.9198781E-03,   9.6529378E-03,   9.3831941E-03
     +,   9.1120908E-03,   8.8410368E-03,   8.5714748E-03
     +,   8.3047990E-03,   8.0423793E-03,   7.7855755E-03
     +,   7.5357091E-03,   7.2940337E-03,   7.0617581E-03
     +,   6.8400456E-03,   6.6299993E-03,   6.4326371E-03
     +,   6.2489086E-03,   6.0797073E-03,   5.9258305E-03
     +,   5.7880068E-03,   5.6668865E-03,   5.5630421E-03
     +,   5.4769609E-03,   5.4090545E-03,   5.3596641E-03
     +,   5.3290487E-03,   5.3174011E-03,   5.3248345E-03
     +,   5.3513977E-03,   5.3970637E-03,   5.4617450E-03
     +,   5.5452813E-03,   5.6474376E-03,   5.7679145E-03
     +,   5.9063439E-03,   6.0622734E-03,   6.2351641E-03
     +,   6.4244103E-03,   6.6293189E-03,   6.8490943E-03
     +,   7.0828372E-03,   7.3295697E-03,   7.5882054E-03
     +,   7.8575341E-03,   8.1362426E-03,   8.4229158E-03
     +,   8.7160403E-03,   9.0139639E-03,   9.3149627E-03
     +,   9.6172197E-03,   9.9188145E-03,   1.0217756E-02
     +,   1.0512011E-02,   1.0799501E-02,   1.1078111E-02
     +,   1.1345710E-02,   1.1600212E-02,   1.1839561E-02
     +,   1.2061744E-02,   1.2264840E-02,   1.2447044E-02
     +,   1.2606680E-02,   1.2742211E-02,   1.2852279E-02
     +,   1.2935727E-02,   1.2991585E-02,   1.3019113E-02
     +,   1.3017799E-02,   1.2987370E-02,   1.2927791E-02
     +,   1.2839275E-02,   1.2722268E-02,   1.2577447E-02
     +,   1.2405717E-02,   1.2208204E-02,   1.1986209E-02
     +,   1.1741211E-02,   1.1474871E-02,   1.1188962E-02
     +,   1.0885363E-02,   1.0566062E-02,   1.0233112E-02
     +,   9.8885857E-03,   9.5345648E-03,   9.1731446E-03
     +,   8.8063944E-03,   8.4362999E-03,   8.0647822E-03
     +,   7.6936954E-03,   7.3247859E-03,   6.9596656E-03
     +,   6.5998170E-03,   6.2466254E-03,   5.9013008E-03
     +,   5.5649085E-03,   5.2383980E-03,   4.9225674E-03
     +,   4.6180603E-03,   4.3253819E-03,   4.0449300E-03
     +,   3.7769780E-03,   3.5216666E-03,   3.2790345E-03
     +,   3.0490409E-03,   2.8315575E-03,   2.6263674E-03
     +,   2.4331873E-03,   2.2516998E-03,   2.0815213E-03
     +,   1.9222319E-03,   1.7733945E-03,   1.6345499E-03
     +,   1.5052158E-03,   1.3849031E-03,   1.2731306E-03
     +,   1.1694189E-03,   1.0732885E-03,   9.8427327E-04
     +,   9.0192631E-04,   8.2581694E-04,   7.5552717E-04
     +,   6.9065898E-04,   6.3084124E-04,   5.7571667E-04
     +,   5.2494887E-04,   4.7822591E-04,   4.3525491E-04
     +,   3.9575933E-04,   3.5948143E-04,   3.2618406E-04
     +,   2.9564567E-04,   2.6765867E-04,   2.4203055E-04
     +,   2.1858404E-04,   1.9715441E-04,   1.7758711E-04
     +,   1.5973904E-04,   1.4347871E-04,   1.2868235E-04
     +,   1.1523486E-04,   1.0303017E-04,   9.1969414E-05
     +,   8.1959843E-05,   7.2915318E-05,   6.4756161E-05
     +,   5.7408208E-05,   5.0801969E-05,   4.4872966E-05
     +,   3.9561841E-05,   3.4812856E-05,   3.0574916E-05
     +,   2.6800224E-05,   2.3445105E-05,   2.0468837E-05
     +,   1.7834263E-05,   1.5506939E-05,   1.3455544E-05
     +,   1.1651172E-05,   1.0067640E-05,   8.6809487E-06
     +,   7.4692998E-06,   6.4130463E-06,   5.4942843E-06
     +,   4.6969908E-06,   4.0066470E-06,   3.4103268E-06
     +,   2.8963821E-06,   2.4544925E-06,   2.0754192E-06
     +,   1.7510154E-06,   1.4740315E-06,   1.2381083E-06
     +,   1.0376190E-06,   8.6765669E-07
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_haonly_hatt120_mass = Yx/0.46540025
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_haonly_hatt60_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  9.0722414E-03,   1.0165532E-02
     +,   1.1407614E-02,   1.2808241E-02,   1.4374268E-02
     +,   1.6108923E-02,   1.8011231E-02,   2.0075755E-02
     +,   2.2292733E-02,   2.4649007E-02,   2.7129775E-02
     +,   2.9722245E-02,   3.2421425E-02,   3.5238922E-02
     +,   3.8214669E-02,   4.1431837E-02,   4.5034759E-02
     +,   4.9251586E-02,   5.4425064E-02,   6.1054841E-02
     +,   6.9847047E-02,   8.1752494E-02,   9.7957306E-02
     +,   0.1197870    ,   0.1484929    ,   0.1850124    
     +,   0.2299635    ,   0.2842629    ,   0.3500809    
     +,   0.4311019    ,   0.5324355    ,   0.6613663    
     +,   0.8233652    ,    1.009879    ,    1.198177    
     +,    1.371080    ,    1.535437    ,    1.725918    
     +,    1.944046    ,    2.146983    ,    2.337262    
     +,    2.437862    ,    2.332280    ,    2.162220    
     +,    2.089051    ,    2.013549    ,    1.876702    
     +,    1.731077    ,    1.588224    ,    1.427103    
     +,    1.238957    ,    1.050647    ,   0.8974935    
     +,   0.7837744    ,   0.6915671    ,   0.6066172    
     +,   0.5265923    ,   0.4532520    ,   0.3868281    
     +,   0.3276120    ,   0.2771559    ,   0.2366596    
     +,   0.2056817    ,   0.1824868    ,   0.1650035    
     +,   0.1514737    ,   0.1406584    ,   0.1317707    
     +,   0.1242887    ,   0.1177919    ,   0.1118841    
     +,   0.1062066    ,   0.1004895    ,   9.4596997E-02
     +,   8.8537119E-02,   8.2436636E-02,   7.6491721E-02
     +,   7.0910960E-02,   6.5866232E-02,   6.1461739E-02
     +,   5.7723455E-02,   5.4605026E-02,   5.2007567E-02
     +,   4.9802832E-02,   4.7857188E-02,   4.6049871E-02
     +,   4.4285748E-02,   4.2500459E-02,   4.0660921E-02
     +,   3.8760815E-02,   3.6814235E-02,   3.4848444E-02
     +,   3.2896653E-02,   3.0991968E-02,   2.9163087E-02
     +,   2.7431784E-02,   2.5811365E-02,   2.4307275E-02
     +,   2.2917725E-02,   2.1635758E-02,   2.0450646E-02
     +,   1.9350046E-02,   1.8321166E-02,   1.7352214E-02
     +,   1.6432980E-02,   1.5555287E-02,   1.4713228E-02
     +,   1.3902939E-02,   1.3122289E-02,   1.2370558E-02
     +,   1.1648126E-02,   1.0955899E-02,   1.0295178E-02
     +,   9.6671777E-03,   9.0729957E-03,   8.5133035E-03
     +,   7.9884101E-03,   7.4980999E-03,   7.0417742E-03
     +,   6.6183764E-03,   6.2265219E-03,   5.8646002E-03
     +,   5.5308011E-03,   5.2231979E-03,   4.9398351E-03
     +,   4.6788072E-03,   4.4382443E-03,   4.2164125E-03
     +,   4.0116729E-03,   3.8225523E-03,   3.6476881E-03
     +,   3.4858764E-03,   3.3360117E-03,   3.1971203E-03
     +,   3.0683114E-03,   2.9487752E-03,   2.8377799E-03
     +,   2.7346476E-03,   2.6387419E-03,   2.5494664E-03
     +,   2.4662623E-03,   2.3886014E-03,   2.3159774E-03
     +,   2.2479105E-03,   2.1839542E-03,   2.1236837E-03
     +,   2.0667007E-03,   2.0126412E-03,   1.9611709E-03
     +,   1.9119828E-03,   1.8647995E-03,   1.8193796E-03
     +,   1.7755094E-03,   1.7330026E-03,   1.6916991E-03
     +,   1.6514696E-03,   1.6122059E-03,   1.5738200E-03
     +,   1.5362434E-03,   1.4994270E-03,   1.4633342E-03
     +,   1.4279394E-03,   1.3932306E-03,   1.3592029E-03
     +,   1.3258567E-03,   1.2931962E-03,   1.2612313E-03
     +,   1.2299737E-03,   1.1994336E-03,   1.1696218E-03
     +,   1.1405491E-03,   1.1122255E-03,   1.0846563E-03
     +,   1.0578455E-03,   1.0317962E-03,   1.0065062E-03
     +,   9.8197092E-04,   9.5818425E-04,   9.3513710E-04
     +,   9.1281661E-04,   8.9120673E-04,   8.7029114E-04
     +,   8.5005112E-04,   8.3046459E-04,   8.1150763E-04
     +,   7.9315656E-04,   7.7538594E-04,   7.5816864E-04
     +,   7.4147631E-04,   7.2528201E-04,   7.0955657E-04
     +,   6.9427112E-04,   6.7939743E-04,   6.6490780E-04
     +,   6.5077387E-04,   6.3696789E-04,   6.2346406E-04
     +,   6.1023689E-04,   5.9726130E-04,   5.8451365E-04
     +,   5.7197164E-04,   5.5961515E-04,   5.4742367E-04
     +,   5.3537893E-04,   5.2346505E-04,   5.1166629E-04
     +,   4.9996865E-04,   4.8836076E-04,   4.7683239E-04
     +,   4.6537421E-04,   4.5397872E-04,   4.4264048E-04
     +,   4.3135541E-04,   4.2012046E-04,   4.0893370E-04
     +,   3.9779549E-04,   3.8670734E-04,   3.7567102E-04
     +,   3.6468991E-04,   3.5376896E-04,   3.4291318E-04
     +,   3.3212852E-04,   3.2142224E-04,   3.1080219E-04
     +,   3.0027621E-04,   2.8985247E-04,   2.7954011E-04
     +,   2.6934876E-04,   2.5928707E-04,   2.4936424E-04
     +,   2.3958969E-04,   2.2997300E-04,   2.2052263E-04
     +,   2.1124702E-04,   2.0215502E-04,   1.9325422E-04
     +,   1.8455171E-04,   1.7605467E-04,   1.6776971E-04
     +,   1.5970228E-04,   1.5185712E-04,   1.4423898E-04
     +,   1.3685184E-04,   1.2969850E-04,   1.2278107E-04
     +,   1.1610147E-04,   1.0966090E-04,   1.0345946E-04
     +,   9.7496595E-05,   9.1771682E-05,   8.6282933E-05
     +,   8.1027960E-05,   7.6004224E-05,   7.1208575E-05
     +,   6.6637069E-05,   6.2285348E-05,   5.8148915E-05
     +,   5.4222888E-05,   5.0501771E-05,   4.6979796E-05
     +,   4.3651173E-05,   4.0509884E-05,   3.7549511E-05
     +,   3.4763507E-05,   3.2145501E-05,   2.9688756E-05
     +,   2.7386535E-05,   2.5232241E-05,   2.3219271E-05
     +,   2.1340946E-05,   1.9590663E-05,   1.7962033E-05
     +,   1.6448777E-05,   1.5044634E-05,   1.3743508E-05
     +,   1.2539608E-05,   1.1427139E-05,   1.0400650E-05
     +,   9.4547459E-06,   8.5843621E-06,   7.7845170E-06
     +,   7.0505575E-06,   6.3779376E-06,   5.7624202E-06
     +,   5.1998863E-06,   4.6865125E-06,   4.2186298E-06
     +,   3.7927728E-06,   3.4057168E-06,   3.0543856E-06
     +,   2.7359329E-06,   2.4476533E-06,   2.1870594E-06
     +,   1.9517920E-06,   1.7396926E-06,   1.5487236E-06
     +,   1.3770218E-06,   1.2228408E-06,   1.0845873E-06
     +,   9.6077281E-07,   8.5004604E-07
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_haonly_hatt60_mass = Yx/10.8181595869565
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_haonly_hatt65_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.7540787E-03,   3.0320804E-03
     +,   3.3273748E-03,   3.6394368E-03,   3.9674519E-03
     +,   4.3103094E-03,   4.6665980E-03,   5.0346297E-03
     +,   5.4124719E-03,   5.7980316E-03,   6.1891298E-03
     +,   6.5836469E-03,   6.9797034E-03,   7.3758722E-03
     +,   7.7714487E-03,   8.1667667E-03,   8.5635465E-03
     +,   8.9652706E-03,   9.3776016E-03,   9.8087983E-03
     +,   1.0270139E-02,   1.0776388E-02,   1.1346271E-02
     +,   1.2003098E-02,   1.2775331E-02,   1.3697566E-02
     +,   1.4811351E-02,   1.6166212E-02,   1.7820444E-02
     +,   1.9841183E-02,   2.2303117E-02,   2.5284804E-02
     +,   2.8861584E-02,   3.3094741E-02,   3.8018219E-02
     +,   4.3626413E-02,   4.9870271E-02,   5.6669220E-02
     +,   6.3943811E-02,   7.1660072E-02,   7.9872087E-02
     +,   8.8739179E-02,   9.8544635E-02,   0.1098171    
     +,   0.1237136    ,   0.1426538    ,   0.1706288    
     +,   0.2120653    ,   0.2688357    ,   0.3376504    
     +,   0.4118208    ,   0.4871985    ,   0.5648116    
     +,   0.6468242    ,   0.7374312    ,   0.8520051    
     +,    1.011217    ,    1.224542    ,    1.487470    
     +,    1.778186    ,    2.059436    ,    2.265933    
     +,    2.309890    ,    2.234602    ,    2.135158    
     +,    2.093584    ,    2.021417    ,    1.805768    
     +,    1.618958    ,    1.476776    ,    1.268801    
     +,    1.033056    ,   0.8596126    ,   0.7617266    
     +,   0.6866091    ,   0.5973289    ,   0.4998794    
     +,   0.4126590    ,   0.3440813    ,   0.2931989    
     +,   0.2562148    ,   0.2296480    ,   0.2104516    
     +,   0.1956298    ,   0.1825036    ,   0.1692116    
     +,   0.1549595    ,   0.1399036    ,   0.1247957    
     +,   0.1105382    ,   9.7826302E-02,   8.6971715E-02
     +,   7.7916488E-02,   7.0364125E-02,   6.3935794E-02
     +,   5.8285590E-02,   5.3155310E-02,   4.8384890E-02
     +,   4.3895014E-02,   3.9664105E-02,   3.5704508E-02
     +,   3.2045301E-02,   2.8717775E-02,   2.5747014E-02
     +,   2.3145337E-02,   2.0910133E-02,   1.9024311E-02
     +,   1.7458532E-02,   1.6174886E-02,   1.5131248E-02
     +,   1.4285102E-02,   1.3596318E-02,   1.3029284E-02
     +,   1.2553627E-02,   1.2144498E-02,   1.1782015E-02
     +,   1.1450666E-02,   1.1138448E-02,   1.0836191E-02
     +,   1.0536898E-02,   1.0235290E-02,   9.9274898E-03
     +,   9.6107516E-03,   9.2832949E-03,   8.9442013E-03
     +,   8.5933665E-03,   8.2313363E-03,   7.8593297E-03
     +,   7.4790413E-03,   7.0926570E-03,   6.7026382E-03
     +,   6.3117142E-03,   5.9226705E-03,   5.5383462E-03
     +,   5.1614395E-03,   4.7944584E-03,   4.4396766E-03
     +,   4.0990547E-03,   3.7741745E-03,   3.4662504E-03
     +,   3.1761420E-03,   2.9043502E-03,   2.6510207E-03
     +,   2.4160026E-03,   2.1989089E-03,   1.9991165E-03
     +,   1.8158379E-03,   1.6481758E-03,   1.4951499E-03
     +,   1.3557277E-03,   1.2288669E-03,   1.1135484E-03
     +,   1.0087889E-03,   9.1364718E-04,   8.2724442E-04
     +,   7.4877444E-04,   6.7749806E-04,   6.1273918E-04
     +,   5.5388769E-04,   5.0039985E-04,   4.5178176E-04
     +,   4.0759097E-04,   3.6743245E-04,   3.3095048E-04
     +,   2.9782168E-04,   2.6775364E-04,   2.4048264E-04
     +,   2.1576816E-04,   1.9338865E-04,   1.7314135E-04
     +,   1.5484137E-04,   1.3831856E-04,   1.2341529E-04
     +,   1.0998661E-04,   9.7900454E-05,   8.7034154E-05
     +,   7.7275065E-05,   6.8520560E-05,   6.0676441E-05
     +,   5.3656015E-05,   4.7380086E-05,   4.1776802E-05
     +,   3.6780562E-05,   3.2331300E-05,   2.8374401E-05
     +,   2.4860488E-05,   2.1744665E-05,   1.8985967E-05
     +,   1.6547288E-05,   1.4395227E-05,   1.2499302E-05
     +,   1.0831973E-05,   9.3684403E-06,   8.0862965E-06
     +,   6.9652319E-06,   5.9869731E-06,   5.1351362E-06
     +,   4.3949940E-06,   3.7532814E-06,   3.1981303E-06
     +,   2.7189726E-06,   2.3063719E-06,   1.9519014E-06
     +,   1.6480869E-06,   1.3883300E-06,   1.1667736E-06
     +,   9.7825728E-07,   8.1825522E-07,   6.8279684E-07
     +,   5.6840014E-07,   4.7203005E-07,   3.9105478E-07
     +,   3.2318923E-07,   2.6645421E-07,   2.1914374E-07
     +,   1.7979488E-07,   1.4715252E-07,   1.2014240E-07
     +,   9.7849529E-08,   7.9498449E-08,   6.4430751E-08
     +,   5.2090368E-08,   4.2010146E-08,   3.3797555E-08
     +,   2.7123635E-08,   2.1713880E-08,   1.7340307E-08
     +,   1.3813663E-08,   1.0977179E-08,   8.7015728E-09
     +,   6.8807169E-09,   5.4275189E-09,   4.2706843E-09
     +,   3.3521106E-09,   2.6246489E-09,   2.0499866E-09
     +,   1.5971869E-09,   1.2413333E-09,   9.6239194E-10
     +,   7.4429296E-10,   5.7419475E-10,   4.4187831E-10
     +,   3.3921652E-10,   2.5976404E-10,   1.9842882E-10
     +,   1.5120209E-10,   1.1493260E-10,   8.7147518E-11
     +,   6.5915960E-11,   4.9734567E-11,   3.7432855E-11
     +,   2.8104174E-11,   2.1048286E-11,   1.5725126E-11
     +,   1.1719224E-11,   8.7121759E-12,   6.4607451E-12
     +,   4.7793540E-12,   3.5268316E-12,   2.5961067E-12
     +,   1.9062844E-12,   1.3963203E-12,   1.0202553E-12
     +,   7.4362955E-13,   5.4067449E-13,   3.9214267E-13
     +,   2.8370942E-13,   2.0475321E-13,   1.4740788E-13
     +,   1.0586130E-13,   7.5836249E-14,   5.4193178E-14
     +,   3.8631692E-14,   2.7470730E-14,   1.9485873E-14
     +,   1.3788040E-14,   9.7321036E-15,   6.8524068E-15
     +,   4.8128548E-15,   3.3720543E-15,   2.3567239E-15
     +,   1.6430664E-15,   1.1426801E-15,   7.9273062E-16
     +,   5.4859338E-16,   3.7871010E-16,   2.6078982E-16
     +,   1.7914199E-16,   1.2275424E-16,   8.3906760E-17
     +,   5.7212463E-17,   3.8914136E-17,   2.6403192E-17
     +,   1.7870099E-17,   1.2065113E-17,   8.1256342E-18
     +,   5.4590401E-18,   3.6584470E-18,   2.4457406E-18
     +,   1.6309740E-18,   1.0849637E-18
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_haonly_hatt65_mass = Yx/9.62963171739131
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_haonly_hatt70_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.4050499E-03,   1.4560249E-03
     +,   1.5072548E-03,   1.5587943E-03,   1.6107301E-03
     +,   1.6631813E-03,   1.7163077E-03,   1.7703079E-03
     +,   1.8254265E-03,   1.8819571E-03,   1.9402454E-03
     +,   2.0006925E-03,   2.0637643E-03,   2.1299906E-03
     +,   2.1999772E-03,   2.2744087E-03,   2.3540568E-03
     +,   2.4397890E-03,   2.5325746E-03,   2.6334939E-03
     +,   2.7437431E-03,   2.8646411E-03,   2.9976289E-03
     +,   3.1442791E-03,   3.3062699E-03,   3.4854007E-03
     +,   3.6835549E-03,   3.9026793E-03,   4.1447529E-03
     +,   4.4117360E-03,   4.7055203E-03,   5.0278604E-03
     +,   5.3802985E-03,   5.7640895E-03,   6.1801169E-03
     +,   6.6288179E-03,   7.1101310E-03,   7.6234522E-03
     +,   8.1676897E-03,   8.7412391E-03,   9.3422364E-03
     +,   9.9686785E-03,   1.0618765E-02,   1.1291257E-02
     +,   1.1985943E-02,   1.2704171E-02,   1.3449462E-02
     +,   1.4228291E-02,   1.5051116E-02,   1.5933914E-02
     +,   1.6900536E-02,   1.7986409E-02,   1.9244060E-02
     +,   2.0751227E-02,   2.2621151E-02,   2.5015444E-02
     +,   2.8155910E-02,   3.2331955E-02,   3.7896063E-02
     +,   4.5240894E-02,   5.4755673E-02,   6.6768423E-02
     +,   8.1485614E-02,   9.8942921E-02,   0.1189564    
     +,   0.1410714    ,   0.1645807    ,   0.1887924    
     +,   0.2137913    ,   0.2414624    ,   0.2757924    
     +,   0.3211071    ,   0.3787254    ,   0.4470797    
     +,   0.5305486    ,   0.6451970    ,   0.8062272    
     +,    1.013439    ,    1.233500    ,    1.408526    
     +,    1.546008    ,    1.745431    ,    2.000359    
     +,    2.135207    ,    2.138113    ,    2.095009    
     +,    1.941717    ,    1.644057    ,    1.395425    
     +,    1.303465    ,    1.235995    ,    1.096050    
     +,   0.9184335    ,   0.7632886    ,   0.6493312    
     +,   0.5601192    ,   0.4739619    ,   0.3876508    
     +,   0.3127226    ,   0.2575974    ,   0.2206261    
     +,   0.1949468    ,   0.1743013    ,   0.1552958    
     +,   0.1370915    ,   0.1202123    ,   0.1054205    
     +,   9.3074545E-02,   8.3003536E-02,   7.4700192E-02
     +,   6.7589819E-02,   6.1220527E-02,   5.5337619E-02
     +,   4.9861167E-02,   4.4822119E-02,   4.0291253E-02
     +,   3.6328536E-02,   3.2954510E-02,   3.0145438E-02
     +,   2.7840517E-02,   2.5956947E-02,   2.4405036E-02
     +,   2.3100102E-02,   2.1969989E-02,   2.0958502E-02
     +,   2.0025427E-02,   1.9144222E-02,   1.8299200E-02
     +,   1.7482094E-02,   1.6689507E-02,   1.5920592E-02
     +,   1.5175816E-02,   1.4455909E-02,   1.3761654E-02
     +,   1.3093578E-02,   1.2452044E-02,   1.1837346E-02
     +,   1.1249681E-02,   1.0689144E-02,   1.0155705E-02
     +,   9.6491743E-03,   9.1691203E-03,   8.7147662E-03
     +,   8.2850019E-03,   7.8784442E-03,   7.4934019E-03
     +,   7.1279840E-03,   6.7802351E-03,   6.4482000E-03
     +,   6.1300187E-03,   5.8240267E-03,   5.5288482E-03
     +,   5.2434122E-03,   4.9669547E-03,   4.6990332E-03
     +,   4.4395104E-03,   4.1884966E-03,   3.9462759E-03
     +,   3.7132674E-03,   3.4899856E-03,   3.2769353E-03
     +,   3.0745948E-03,   2.8833777E-03,   2.7035938E-03
     +,   2.5354135E-03,   2.3788752E-03,   2.2338869E-03
     +,   2.1002218E-03,   1.9775217E-03,   1.8653212E-03
     +,   1.7630730E-03,   1.6701585E-03,   1.5859021E-03
     +,   1.5095972E-03,   1.4405313E-03,   1.3779865E-03
     +,   1.3212608E-03,   1.2696830E-03,   1.2226168E-03
     +,   1.1794650E-03,   1.1396772E-03,   1.1027550E-03
     +,   1.0682491E-03,   1.0357583E-03,   1.0049290E-03
     +,   9.7545621E-04,   9.4707782E-04,   9.1956952E-04
     +,   8.9274388E-04,   8.6644926E-04,   8.4056088E-04
     +,   8.1498065E-04,   7.8963517E-04,   7.6447148E-04
     +,   7.3945266E-04,   7.1455649E-04,   6.8977574E-04
     +,   6.6511385E-04,   6.4058154E-04,   6.1619695E-04
     +,   5.9198565E-04,   5.6797796E-04,   5.4420583E-04
     +,   5.2070379E-04,   4.9750978E-04,   4.7466063E-04
     +,   4.5219276E-04,   4.3014350E-04,   4.0854886E-04
     +,   3.8744175E-04,   3.6685308E-04,   3.4681265E-04
     +,   3.2734749E-04,   3.0848055E-04,   2.9023169E-04
     +,   2.7261881E-04,   2.5565672E-04,   2.3935564E-04
     +,   2.2372279E-04,   2.0876371E-04,   1.9447941E-04
     +,   1.8086805E-04,   1.6792589E-04,   1.5564638E-04
     +,   1.4401991E-04,   1.3303453E-04,   1.2267703E-04
     +,   1.1293230E-04,   1.0378289E-04,   9.5210067E-05
     +,   8.7194407E-05,   7.9715472E-05,   7.2751463E-05
     +,   6.6280045E-05,   6.0279155E-05,   5.4725733E-05
     +,   4.9596776E-05,   4.4869634E-05,   4.0521802E-05
     +,   3.6530819E-05,   3.2874708E-05,   2.9532219E-05
     +,   2.6482710E-05,   2.3705990E-05,   2.1182655E-05
     +,   1.8894250E-05,   1.6823114E-05,   1.4952303E-05
     +,   1.3265752E-05,   1.1748433E-05,   1.0386030E-05
     +,   9.1651218E-06,   8.0732170E-06,   7.0986466E-06
     +,   6.2304925E-06,   5.4586367E-06,   4.7737763E-06
     +,   4.1673225E-06,   3.6313356E-06,   3.1585475E-06
     +,   2.7423380E-06,   2.3766686E-06,   2.0560201E-06
     +,   1.7753947E-06,   1.5302908E-06,   1.3166252E-06
     +,   1.1307239E-06,   9.6930057E-07,   8.2941136E-07
     +,   7.0841503E-07,   6.0396104E-07,   5.1396705E-07
     +,   4.3658488E-07,   3.7017404E-07,   3.1328852E-07
     +,   2.6466014E-07,   2.2316813E-07,   1.8783658E-07
     +,   1.5780736E-07,   1.3233600E-07,   1.1077108E-07
     +,   9.2550138E-08,   7.7183657E-08,   6.4250280E-08
     +,   5.3385168E-08,   4.4275879E-08,   3.6653191E-08
     +,   3.0286621E-08,   2.4979862E-08,   2.0564741E-08
     +,   1.6898785E-08,   1.3860572E-08,   1.1347632E-08
     +,   9.2730446E-09,   7.5637372E-09,   6.1580514E-09
     +,   5.0043476E-09,   4.0592201E-09,   3.2865084E-09
     +,   2.6559348E-09,   2.1423805E-09
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_haonly_hatt70_mass = Yx/8.38047046666667
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_haonly_hatt75_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  7.0961233E-04,   7.2308880E-04
     +,   7.3926704E-04,   7.5854012E-04,   7.8131736E-04
     +,   8.0802228E-04,   8.3908782E-04,   8.7495113E-04
     +,   9.1604720E-04,   9.6280401E-04,   1.0156300E-03
     +,   1.0749076E-03,   1.1409832E-03,   1.2141544E-03
     +,   1.2946601E-03,   1.3826679E-03,   1.4782622E-03
     +,   1.5814335E-03,   1.6920668E-03,   1.8099325E-03
     +,   1.9346777E-03,   2.0658216E-03,   2.2027486E-03
     +,   2.3447175E-03,   2.4908429E-03,   2.6401284E-03
     +,   2.7914541E-03,   2.9436012E-03,   3.0952655E-03
     +,   3.2450843E-03,   3.3916601E-03,   3.5335906E-03
     +,   3.6695171E-03,   3.7981537E-03,   3.9183456E-03
     +,   4.0291208E-03,   4.1297544E-03,   4.2198324E-03
     +,   4.2993310E-03,   4.3686829E-03,   4.4288635E-03
     +,   4.4814586E-03,   4.5287297E-03,   4.5736614E-03
     +,   4.6199830E-03,   4.6721539E-03,   4.7353054E-03
     +,   4.8151184E-03,   4.9176537E-03,   5.0490997E-03
     +,   5.2154670E-03,   5.4222234E-03,   5.6738984E-03
     +,   5.9737004E-03,   6.3231043E-03,   6.7216465E-03
     +,   7.1667302E-03,   7.6537137E-03,   8.1762299E-03
     +,   8.7267952E-03,   9.2977202E-03,   9.8823477E-03
     +,   1.0476433E-02,   1.1079819E-02,   1.1697913E-02
     +,   1.2343011E-02,   1.3035468E-02,   1.3804125E-02
     +,   1.4686697E-02,   1.5729379E-02,   1.6986627E-02
     +,   1.8520057E-02,   2.0397082E-02,   2.2686964E-02
     +,   2.5454547E-02,   2.8749134E-02,   3.2589339E-02
     +,   3.6947791E-02,   4.1743387E-02,   4.6852097E-02
     +,   5.2147739E-02,   5.7577871E-02,   6.3257650E-02
     +,   6.9559924E-02,   7.7172294E-02,   8.7119877E-02
     +,   0.1007353    ,   0.1195039    ,   0.1446081    
     +,   0.1761842    ,   0.2129428    ,   0.2534185    
     +,   0.2985374    ,   0.3511798    ,   0.4112023    
     +,   0.4793182    ,   0.5728892    ,   0.7138072    
     +,   0.8947621    ,    1.084070    ,    1.256794    
     +,    1.405848    ,    1.474682    ,    1.429682    
     +,    1.353361    ,    1.295729    ,    1.266510    
     +,    1.237517    ,    1.147025    ,    1.012116    
     +,   0.8895285    ,   0.7736972    ,   0.6335776    
     +,   0.4820089    ,   0.3537651    ,   0.2623384    
     +,   0.2004297    ,   0.1575443    ,   0.1270077    
     +,   0.1048536    ,   8.8378988E-02,   7.5732127E-02
     +,   6.5704614E-02,   5.7483573E-02,   5.0487313E-02
     +,   4.4314284E-02,   3.8732495E-02,   3.3654578E-02
     +,   2.9085208E-02,   2.5065526E-02,   2.1628346E-02
     +,   1.8776922E-02,   1.6480777E-02,   1.4684733E-02
     +,   1.3320464E-02,   1.2317380E-02,   1.1609439E-02
     +,   1.1138096E-02,   1.0852701E-02,   1.0709547E-02
     +,   1.0670433E-02,   1.0701374E-02,   1.0771774E-02
     +,   1.0854032E-02,   1.0923509E-02,   1.0958785E-02
     +,   1.0942019E-02,   1.0859336E-02,   1.0701151E-02
     +,   1.0462321E-02,   1.0142088E-02,   9.7438619E-03
     +,   9.2747537E-03,   8.7448852E-03,   8.1666671E-03
     +,   7.5539877E-03,   6.9213519E-03,   6.2830201E-03
     +,   5.6523588E-03,   5.0413245E-03,   4.4599320E-03
     +,   3.9160610E-03,   3.4154048E-03,   2.9614726E-03
     +,   2.5557321E-03,   2.1979008E-03,   1.8862714E-03
     +,   1.6180173E-03,   1.3895072E-03,   1.1966430E-03
     +,   1.0351343E-03,   9.0070581E-04,   7.8926387E-04
     +,   6.9702981E-04,   6.2062294E-04,   5.5707904E-04
     +,   5.0386740E-04,   4.5887561E-04,   4.2037177E-04
     +,   3.8696057E-04,   3.5753963E-04,   3.3125468E-04
     +,   3.0745249E-04,   2.8564048E-04,   2.6545339E-04
     +,   2.4662577E-04,   2.2896616E-04,   2.1233695E-04
     +,   1.9664064E-04,   1.8180958E-04,   1.6779425E-04
     +,   1.5455825E-04,   1.4207448E-04,   1.3032056E-04
     +,   1.1927594E-04,   1.0892103E-04,   9.9236917E-05
     +,   9.0203772E-05,   8.1800070E-05,   7.4003074E-05
     +,   6.6789406E-05,   6.0134378E-05,   5.4011904E-05
     +,   4.8395243E-05,   4.3257594E-05,   3.8571339E-05
     +,   3.4308869E-05,   3.0442998E-05,   2.6946873E-05
     +,   2.3793957E-05,   2.0958472E-05,   1.8415722E-05
     +,   1.6141925E-05,   1.4114223E-05,   1.2310952E-05
     +,   1.0711768E-05,   9.2975197E-06,   8.0502168E-06
     +,   6.9531247E-06,   5.9908584E-06,   5.1491124E-06
     +,   4.4147660E-06,   3.7758684E-06,   3.2215316E-06
     +,   2.7418407E-06,   2.3278424E-06,   1.9715098E-06
     +,   1.6656385E-06,   1.4037724E-06,   1.1801692E-06
     +,   9.8975045E-07,   8.2802575E-07,   6.9102839E-07
     +,   5.7528007E-07,   4.7774853E-07,   3.9577989E-07
     +,   3.2706899E-07,   2.6962411E-07,   2.2172507E-07
     +,   1.8188851E-07,   1.4884250E-07,   1.2150163E-07
     +,   9.8940596E-08,   8.0371350E-08,   6.5126621E-08
     +,   5.2644115E-08,   4.2450054E-08,   3.4146094E-08
     +,   2.7398983E-08,   2.1931331E-08,   1.7511750E-08
     +,   1.3948422E-08,   1.1082930E-08,   8.7845846E-09
     +,   6.9457995E-09,   5.4784008E-09,   4.3104134E-09
     +,   3.3831566E-09,   2.6488558E-09,   2.0688355E-09
     +,   1.6118594E-09,   1.2527556E-09,   9.7126884E-10
     +,   7.5117718E-10,   5.7954047E-10,   4.4602480E-10
     +,   3.4242423E-10,   2.6224298E-10,   2.0034628E-10
     +,   1.5268339E-10,   1.1607369E-10,   8.8025642E-11
     +,   6.6592031E-11,   5.0253839E-11,   3.7830915E-11
     +,   2.8409431E-11,   2.1281778E-11,   1.5903421E-11
     +,   1.1855084E-11,   8.8156817E-12,   6.5393862E-12
     +,   4.8390146E-12,   3.5719537E-12,   2.6302341E-12
     +,   1.9320177E-12,   1.4156853E-12,   1.0347995E-12
     +,   7.5452822E-13,   5.4882471E-13,   3.9821789E-13
     +,   2.8823501E-13,   2.0811417E-13,   1.4989816E-13
     +,   1.0770082E-13,   7.7193643E-14,   5.5191488E-14
     +,   3.9364288E-14,   2.8006733E-14,   1.9877407E-14
     +,   1.4073030E-14,   9.9392489E-15
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_haonly_hatt75_mass = Yx/5.73877
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_haonly_hatt80_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.0712234E-03,   1.0865267E-03
     +,   1.1018611E-03,   1.1172233E-03,   1.1326089E-03
     +,   1.1480140E-03,   1.1634347E-03,   1.1788674E-03
     +,   1.1943096E-03,   1.2097602E-03,   1.2252193E-03
     +,   1.2406895E-03,   1.2561753E-03,   1.2716851E-03
     +,   1.2872303E-03,   1.3028271E-03,   1.3184955E-03
     +,   1.3342616E-03,   1.3501572E-03,   1.3662199E-03
     +,   1.3824946E-03,   1.3990329E-03,   1.4158934E-03
     +,   1.4331437E-03,   1.4508566E-03,   1.4691140E-03
     +,   1.4880038E-03,   1.5076204E-03,   1.5280632E-03
     +,   1.5494362E-03,   1.5718469E-03,   1.5954030E-03
     +,   1.6202121E-03,   1.6463801E-03,   1.6740069E-03
     +,   1.7031879E-03,   1.7340089E-03,   1.7665453E-03
     +,   1.8008661E-03,   1.8370263E-03,   1.8750785E-03
     +,   1.9150706E-03,   1.9570587E-03,   2.0011154E-03
     +,   2.0473504E-03,   2.0959300E-03,   2.1471092E-03
     +,   2.2012668E-03,   2.2589520E-03,   2.3209371E-03
     +,   2.3882769E-03,   2.4623743E-03,   2.5450494E-03
     +,   2.6386110E-03,   2.7459038E-03,   2.8703767E-03
     +,   3.0160935E-03,   3.1877377E-03,   3.3905727E-03
     +,   3.6303578E-03,   3.9132074E-03,   4.2454069E-03
     +,   4.6331333E-03,   5.0822003E-03,   5.5976938E-03
     +,   6.1835321E-03,   6.8422002E-03,   7.5742183E-03
     +,   8.3779749E-03,   9.2492728E-03,   1.0181354E-02
     +,   1.1164661E-02,   1.2187188E-02,   1.3234544E-02
     +,   1.4290697E-02,   1.5338593E-02,   1.6361067E-02
     +,   1.7342022E-02,   1.8267808E-02,   1.9128563E-02
     +,   1.9919572E-02,   2.0642780E-02,   2.1307766E-02
     +,   2.1932708E-02,   2.2544608E-02,   2.3179226E-02
     +,   2.3880074E-02,   2.4697037E-02,   2.5683716E-02
     +,   2.6894297E-02,   2.8378958E-02,   3.0178010E-02
     +,   3.2315295E-02,   3.4791227E-02,   3.7576735E-02
     +,   4.0610209E-02,   4.3800779E-02,   4.7037467E-02
     +,   5.0206840E-02,   5.3213060E-02,   5.5997517E-02
     +,   5.8547433E-02,   6.0890321E-02,   6.3070655E-02
     +,   6.5121509E-02,   6.7052066E-02,   6.8885803E-02
     +,   7.0773043E-02,   7.3156573E-02,   7.6901585E-02
     +,   8.3266012E-02,   9.3663611E-02,   0.1093127    
     +,   0.1309434    ,   0.1586402    ,   0.1919519    
     +,   0.2305625    ,   0.2754366    ,   0.3288466    
     +,   0.3916690    ,   0.4597304    ,   0.5237685    
     +,   0.5736243    ,   0.6017541    ,   0.6035366    
     +,   0.5774010    ,   0.5264447    ,   0.4590078    
     +,   0.3863952    ,   0.3190759    ,   0.2634256    
     +,   0.2205976    ,   0.1878805    ,   0.1614350    
     +,   0.1384428    ,   0.1177044    ,   9.9089086E-02
     +,   8.2768284E-02,   6.8781242E-02,   5.6960527E-02
     +,   4.7023948E-02,   3.8680375E-02,   3.1694308E-02
     +,   2.5902659E-02,   2.1195224E-02,   1.7479213E-02
     +,   1.4652271E-02,   1.2592263E-02,   1.1162596E-02
     +,   1.0225164E-02,   9.6528260E-03,   9.3370192E-03
     +,   9.1902753E-03,   9.1454266E-03,   9.1530029E-03
     +,   9.1780256E-03,   9.1969054E-03,   9.1946889E-03
     +,   9.1627613E-03,   9.0970239E-03,   8.9964755E-03
     +,   8.8621872E-03,   8.6965626E-03,   8.5028224E-03
     +,   8.2846303E-03,   8.0458522E-03,   7.7903988E-03
     +,   7.5220843E-03,   7.2445255E-03,   6.9610821E-03
     +,   6.6748327E-03,   6.3885283E-03,   6.1045578E-03
     +,   5.8249589E-03,   5.5514527E-03,   5.2854042E-03
     +,   5.0278688E-03,   4.7796397E-03,   4.5412532E-03
     +,   4.3130126E-03,   4.0950296E-03,   3.8872797E-03
     +,   3.6896076E-03,   3.5017522E-03,   3.3233790E-03
     +,   3.1541202E-03,   2.9935776E-03,   2.8413283E-03
     +,   2.6969505E-03,   2.5600439E-03,   2.4302104E-03
     +,   2.3070704E-03,   2.1902749E-03,   2.0794943E-03
     +,   1.9744134E-03,   1.8747369E-03,   1.7801920E-03
     +,   1.6905223E-03,   1.6054780E-03,   1.5248201E-03
     +,   1.4483251E-03,   1.3757765E-03,   1.3069616E-03
     +,   1.2416731E-03,   1.1797186E-03,   1.1209039E-03
     +,   1.0650434E-03,   1.0119623E-03,   9.6149306E-04
     +,   9.1347302E-04,   8.6774887E-04,   8.2417903E-04
     +,   7.8263151E-04,   7.4298086E-04,   7.0511148E-04
     +,   6.6891970E-04,   6.3431094E-04,   6.0119724E-04
     +,   5.6949910E-04,   5.3914782E-04,   5.1007920E-04
     +,   4.8223545E-04,   4.5556677E-04,   4.3002825E-04
     +,   4.0557794E-04,   3.8217806E-04,   3.5979555E-04
     +,   3.3839987E-04,   3.1796141E-04,   2.9845239E-04
     +,   2.7984753E-04,   2.6212254E-04,   2.4525254E-04
     +,   2.2921310E-04,   2.1398166E-04,   1.9953416E-04
     +,   1.8584644E-04,   1.7289528E-04,   1.6065710E-04
     +,   1.4910738E-04,   1.3822151E-04,   1.2797547E-04
     +,   1.1834498E-04,   1.0930523E-04,   1.0083138E-04
     +,   9.2899296E-05,   8.5484899E-05,   7.8563899E-05
     +,   7.2112256E-05,   6.6107044E-05,   6.0525053E-05
     +,   5.5343618E-05,   5.0540977E-05,   4.6095884E-05
     +,   4.1987427E-05,   3.8195412E-05,   3.4700584E-05
     +,   3.1484338E-05,   2.8528628E-05,   2.5816153E-05
     +,   2.3330578E-05,   2.1056274E-05,   1.8978231E-05
     +,   1.7082210E-05,   1.5354886E-05,   1.3783510E-05
     +,   1.2356047E-05,   1.1061265E-05,   9.8885866E-06
     +,   8.8280476E-06,   7.8703042E-06,   7.0067154E-06
     +,   6.2292074E-06,   5.5302207E-06,   4.9027485E-06
     +,   4.3403620E-06,   3.8370313E-06,   3.3872705E-06
     +,   2.9859591E-06,   2.6284436E-06,   2.3104133E-06
     +,   2.0279538E-06,   1.7774554E-06,   1.5556573E-06
     +,   1.3595590E-06,   1.1864610E-06,   1.0338969E-06
     +,   8.9963356E-07,   7.8166602E-07,   6.7817138E-07
     +,   5.8751937E-07,   5.0823570E-07,   4.3900621E-07
     +,   3.7864649E-07,   3.2610549E-07,   2.8043888E-07
     +,   2.4081140E-07,   2.0647623E-07,   1.7677499E-07
     +,   1.5112063E-07,   1.2899801E-07
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_haonly_hatt80_mass = Yx/2.47396975
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_haonly_hatt85_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.7709522E-04,   4.9840129E-04
     +,   5.2038679E-04,   5.4306537E-04,   5.6644977E-04
     +,   5.9055240E-04,   6.1538408E-04,   6.4095447E-04
     +,   6.6727091E-04,   6.9434015E-04,   7.2216499E-04
     +,   7.5074629E-04,   7.8008126E-04,   8.1016438E-04
     +,   8.4098574E-04,   8.7253208E-04,   9.0478512E-04
     +,   9.3772262E-04,   9.7131700E-04,   1.0055363E-03
     +,   1.0403434E-03,   1.0756961E-03,   1.1115471E-03
     +,   1.1478463E-03,   1.1845356E-03,   1.2215561E-03
     +,   1.2588433E-03,   1.2963306E-03,   1.3339480E-03
     +,   1.3716243E-03,   1.4092877E-03,   1.4468660E-03
     +,   1.4842881E-03,   1.5214856E-03,   1.5583935E-03
     +,   1.5949515E-03,   1.6311054E-03,   1.6668079E-03
     +,   1.7020236E-03,   1.7367229E-03,   1.7708929E-03
     +,   1.8045314E-03,   1.8376528E-03,   1.8702879E-03
     +,   1.9024860E-03,   1.9343172E-03,   1.9658734E-03
     +,   1.9972711E-03,   2.0286539E-03,   2.0601926E-03
     +,   2.0920921E-03,   2.1245924E-03,   2.1579724E-03
     +,   2.1925562E-03,   2.2287148E-03,   2.2668785E-03
     +,   2.3075361E-03,   2.3512484E-03,   2.3986516E-03
     +,   2.4504669E-03,   2.5075073E-03,   2.5706848E-03
     +,   2.6410096E-03,   2.7196009E-03,   2.8076828E-03
     +,   2.9065672E-03,   3.0176628E-03,   3.1424377E-03
     +,   3.2824194E-03,   3.4391375E-03,   3.6141204E-03
     +,   3.8088150E-03,   4.0245880E-03,   4.2626220E-03
     +,   4.5239171E-03,   4.8092245E-03,   5.1189805E-03
     +,   5.4532834E-03,   5.8118878E-03,   6.1941743E-03
     +,   6.5990970E-03,   7.0252768E-03,   7.4709216E-03
     +,   7.9339501E-03,   8.4119225E-03,   8.9021903E-03
     +,   9.4018113E-03,   9.9077085E-03,   1.0416568E-02
     +,   1.0924987E-02,   1.1429412E-02,   1.1926134E-02
     +,   1.2411316E-02,   1.2881046E-02,   1.3331315E-02
     +,   1.3758036E-02,   1.4157232E-02,   1.4525054E-02
     +,   1.4858059E-02,   1.5153361E-02,   1.5408990E-02
     +,   1.5624145E-02,   1.5799569E-02,   1.5937809E-02
     +,   1.6043488E-02,   1.6123427E-02,   1.6186621E-02
     +,   1.6243998E-02,   1.6307971E-02,   1.6391706E-02
     +,   1.6508095E-02,   1.6668610E-02,   1.6881799E-02
     +,   1.7151980E-02,   1.7477887E-02,   1.7851954E-02
     +,   1.8260313E-02,   1.8684335E-02,   1.9103929E-02
     +,   1.9503374E-02,   1.9879462E-02,   2.0251464E-02
     +,   2.0671275E-02,   2.1230809E-02,   2.2063119E-02
     +,   2.3333726E-02,   2.5220955E-02,   2.7885837E-02
     +,   3.1438816E-02,   3.5910707E-02,   4.1243602E-02
     +,   4.7311701E-02,   5.3987112E-02,   6.1244596E-02
     +,   6.9289871E-02,   7.8653581E-02,   9.0177245E-02
     +,   0.1048231    ,   0.1233046    ,   0.1456396    
     +,   0.1708226    ,   0.1968118    ,   0.2208915    
     +,   0.2402811    ,   0.2527586    ,   0.2570894    
     +,   0.2531694    ,   0.2419267    ,   0.2250679    
     +,   0.2047252    ,   0.1830679    ,   0.1619414    
     +,   0.1426198    ,   0.1257399    ,   0.1114086    
     +,   9.9400006E-02,   8.9343488E-02,   8.0846786E-02
     +,   7.3553056E-02,   6.7156956E-02,   6.1406799E-02
     +,   5.6106932E-02,   5.1117677E-02,   4.6349965E-02
     +,   4.1757103E-02,   3.7327003E-02,   3.3076067E-02
     +,   2.9042747E-02,   2.5279066E-02,   2.1840312E-02
     +,   1.8773558E-02,   1.6107811E-02,   1.3848711E-02
     +,   1.1978818E-02,   1.0462100E-02,   9.2502460E-03
     +,   8.2899695E-03,   7.5289761E-03,   6.9200080E-03
     +,   6.4230459E-03,   6.0060089E-03,   5.6443531E-03
     +,   5.3200298E-03,   5.0202687E-03,   4.7364365E-03
     +,   4.4630361E-03,   4.1968753E-03,   3.9364011E-03
     +,   3.6812294E-03,   3.4317817E-03,   3.1889374E-03
     +,   2.9538255E-03,   2.7276583E-03,   2.5115781E-03
     +,   2.3065505E-03,   2.1133199E-03,   1.9323915E-03
     +,   1.7640115E-03,   1.6081688E-03,   1.4646382E-03
     +,   1.3330174E-03,   1.2127581E-03,   1.1031958E-03
     +,   1.0035961E-03,   9.1319496E-04,   8.3120790E-04
     +,   7.5686339E-04,   6.8942521E-04,   6.2819896E-04
     +,   5.7253783E-04,   5.2185304E-04,   4.7561777E-04
     +,   4.3336354E-04,   3.9467498E-04,   3.5919005E-04
     +,   3.2659670E-04,   2.9662554E-04,   2.6904250E-04
     +,   2.4364624E-04,   2.2026479E-04,   1.9874635E-04
     +,   1.7895781E-04,   1.6078210E-04,   1.4411376E-04
     +,   1.2885517E-04,   1.1491621E-04,   1.0221311E-04
     +,   9.0666384E-05,   8.0199155E-05,   7.0737660E-05
     +,   6.2211358E-05,   5.4552071E-05,   4.7693378E-05
     +,   4.1571555E-05,   3.6125955E-05,   3.1297997E-05
     +,   2.7032038E-05,   2.3275670E-05,   1.9979487E-05
     +,   1.7096972E-05,   1.4584831E-05,   1.2403110E-05
     +,   1.0514949E-05,   8.8864308E-06,   7.4866448E-06
     +,   6.2876429E-06,   5.2641890E-06,   4.3935447E-06
     +,   3.6554004E-06,   3.0317724E-06,   2.5066661E-06
     +,   2.0660073E-06,   1.6974832E-06,   1.3903355E-06
     +,   1.1351992E-06,   9.2397232E-07,   7.4969375E-07
     +,   6.0638627E-07,   4.8893651E-07,   3.9299806E-07
     +,   3.1489463E-07,   2.5152494E-07,   2.0027876E-07
     +,   1.5897295E-07,   1.2579164E-07,   9.9224224E-08
     +,   7.8022190E-08,   6.1158431E-08,   4.7789847E-08
     +,   3.7226510E-08,   2.8906973E-08,   2.2376424E-08
     +,   1.7267116E-08,   1.3282726E-08,   1.0185628E-08
     +,   7.7862783E-09,   5.9334213E-09,   4.5073616E-09
     +,   3.4132908E-09,   2.5767106E-09,   1.9390600E-09
     +,   1.4546507E-09,   1.0878261E-09,   8.1096502E-10
     +,   6.0266780E-10,   4.4647358E-10,   3.2972428E-10
     +,   2.4273883E-10,   1.7814332E-10,   1.3032672E-10
     +,   9.5047199E-11,   6.9099865E-11,   5.0079284E-11
     +,   3.6180243E-11,   2.6057169E-11,   1.8707516E-11
     +,   1.3388951E-11,   9.5523511E-12,   6.7938541E-12
     +,   4.8167646E-12,   3.4043649E-12
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_haonly_hatt85_mass = Yx/1.35027309375
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_haonly_hatt90_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  6.9763546E-04,   7.2411791E-04
     +,   7.5102953E-04,   7.7835540E-04,   8.0608000E-04
     +,   8.3418854E-04,   8.6266536E-04,   8.9149550E-04
     +,   9.2066347E-04,   9.5015502E-04,   9.7995566E-04
     +,   1.0100508E-03,   1.0404259E-03,   1.0710678E-03
     +,   1.1019622E-03,   1.1330961E-03,   1.1644560E-03
     +,   1.1960282E-03,   1.2277997E-03,   1.2597566E-03
     +,   1.2918854E-03,   1.3241718E-03,   1.3566011E-03
     +,   1.3891591E-03,   1.4218289E-03,   1.4545947E-03
     +,   1.4874394E-03,   1.5203437E-03,   1.5532892E-03
     +,   1.5862557E-03,   1.6192219E-03,   1.6521661E-03
     +,   1.6850653E-03,   1.7178964E-03,   1.7506354E-03
     +,   1.7832587E-03,   1.8157427E-03,   1.8480631E-03
     +,   1.8802007E-03,   1.9121324E-03,   1.9438424E-03
     +,   1.9753149E-03,   2.0065391E-03,   2.0375086E-03
     +,   2.0682230E-03,   2.0986872E-03,   2.1289161E-03
     +,   2.1589308E-03,   2.1887631E-03,   2.2184560E-03
     +,   2.2480641E-03,   2.2776539E-03,   2.3073058E-03
     +,   2.3371163E-03,   2.3671933E-03,   2.3976632E-03
     +,   2.4286669E-03,   2.4603591E-03,   2.4929100E-03
     +,   2.5265049E-03,   2.5613399E-03,   2.5976242E-03
     +,   2.6355723E-03,   2.6754085E-03,   2.7173606E-03
     +,   2.7616520E-03,   2.8085075E-03,   2.8581368E-03
     +,   2.9107439E-03,   2.9665066E-03,   3.0255856E-03
     +,   3.0881069E-03,   3.1541670E-03,   3.2238157E-03
     +,   3.2970633E-03,   3.3738692E-03,   3.4541343E-03
     +,   3.5376989E-03,   3.6243477E-03,   3.7138008E-03
     +,   3.8057044E-03,   3.8996495E-03,   3.9951513E-03
     +,   4.0916754E-03,   4.1886140E-03,   4.2853178E-03
     +,   4.3810788E-03,   4.4751582E-03,   4.5667738E-03
     +,   4.6551283E-03,   4.7394116E-03,   4.8188060E-03
     +,   4.8925029E-03,   4.9597202E-03,   5.0197090E-03
     +,   5.0717541E-03,   5.1152064E-03,   5.1494716E-03
     +,   5.1740375E-03,   5.1884693E-03,   5.1924218E-03
     +,   5.1856437E-03,   5.1679825E-03,   5.1393844E-03
     +,   5.0998977E-03,   5.0496650E-03,   4.9889307E-03
     +,   4.9180314E-03,   4.8373858E-03,   4.7474909E-03
     +,   4.6489215E-03,   4.5423070E-03,   4.4283401E-03
     +,   4.3077404E-03,   4.1812770E-03,   4.0497249E-03
     +,   3.9138901E-03,   3.7745598E-03,   3.6325392E-03
     +,   3.4886061E-03,   3.3435242E-03,   3.1980497E-03
     +,   3.0529283E-03,   2.9088946E-03,   2.7667028E-03
     +,   2.6271692E-03,   2.4911838E-03,   2.3598052E-03
     +,   2.2342934E-03,   2.1162278E-03,   2.0075578E-03
     +,   1.9107183E-03,   1.8286683E-03,   1.7649762E-03
     +,   1.7238500E-03,   1.7102297E-03,   1.7299487E-03
     +,   1.7900559E-03,   1.8993992E-03,   2.0695098E-03
     +,   2.3157399E-03,   2.6585187E-03,   3.1244305E-03
     +,   3.7466201E-03,   4.5641004E-03,   5.6201047E-03
     +,   6.9594714E-03,   8.6260987E-03,   1.0662139E-02
     +,   1.3110651E-02,   1.6022531E-02,   1.9468056E-02
     +,   2.3551710E-02,   2.8426411E-02,   3.4300715E-02
     +,   4.1433033E-02,   5.0109405E-02,   6.0604960E-02
     +,   7.3133111E-02,   8.7791763E-02,   0.1045190    
     +,   0.1230526    ,   0.1428922    ,   0.1632632    
     +,   0.1830915    ,   0.2010149    ,   0.2154808    
     +,   0.2249534    ,   0.2282095    ,   0.2246387    
     +,   0.2144415    ,   0.1986323    ,   0.1788330    
     +,   0.1569275    ,   0.1347028    ,   0.1135761    
     +,   9.4478801E-02,   7.7877887E-02,   6.3878544E-02
     +,   5.2352071E-02,   4.3046821E-02,   3.5663888E-02
     +,   2.9899208E-02,   2.5464624E-02,   2.2097176E-02
     +,   1.9562364E-02,   1.7654883E-02,   1.6199211E-02
     +,   1.5050526E-02,   1.4094968E-02,   1.3248586E-02
     +,   1.2454974E-02,   1.1681163E-02,   1.0912281E-02
     +,   1.0145967E-02,   9.3872920E-03,   8.6447941E-03
     +,   7.9275975E-03,   7.2436985E-03,   6.5992209E-03
     +,   5.9982426E-03,   5.4428685E-03,   4.9334667E-03
     +,   4.4690287E-03,   4.0475209E-03,   3.6660866E-03
     +,   3.3213715E-03,   3.0097817E-03,   2.7276743E-03
     +,   2.4715180E-03,   2.2380608E-03,   2.0244315E-03
     +,   1.8281782E-03,   1.6472709E-03,   1.4800956E-03
     +,   1.3254199E-03,   1.1823205E-03,   1.0501057E-03
     +,   9.2826039E-04,   8.1639236E-04,   7.1415567E-04
     +,   6.2122144E-04,   5.3725264E-04,   4.6187636E-04
     +,   3.9467154E-04,   3.3517249E-04,   2.8287736E-04
     +,   2.3725130E-04,   1.9773554E-04,   1.6376332E-04
     +,   1.3477328E-04,   1.1021704E-04,   8.9567649E-05
     +,   7.2328927E-05,   5.8042006E-05,   4.6285542E-05
     +,   3.6679572E-05,   2.8886119E-05,   2.2607403E-05
     +,   1.7583803E-05,   1.3591844E-05,   1.0441389E-05
     +,   7.9719211E-06,   6.0491598E-06,   4.5620131E-06
     +,   3.4194568E-06,   2.5474533E-06,   1.8862751E-06
     +,   1.3882043E-06,   1.0154635E-06,   7.3830665E-07
     +,   5.3354307E-07,   3.8323950E-07,   2.7361824E-07
     +,   1.9417449E-07,   1.3696426E-07,   9.6027676E-08
     +,   6.6921373E-08,   4.6356281E-08,   3.1916905E-08
     +,   2.1842730E-08,   1.4858382E-08,   1.0046308E-08
     +,   6.7515855E-09,   4.5100186E-09,   2.9944427E-09
     +,   1.9761046E-09,   1.2961764E-09,   8.4504725E-10
     +,   5.4758548E-10,   3.5266887E-10,   2.2575079E-10
     +,   1.4362872E-10,   9.0822530E-11,   5.7078755E-11
     +,   3.5653040E-11,   2.2132978E-11,   1.3655748E-11
     +,   8.3734729E-12,   5.1029541E-12,   3.0906100E-12
     +,   1.8603112E-12,   1.1128241E-12,   6.6157409E-13
     +,   3.9086274E-13,   2.2949622E-13,   1.3391266E-13
     +,   7.7651786E-14,   4.4748436E-14,   2.5626086E-14
     +,   1.4584040E-14,   8.2479427E-15,   4.6355500E-15
     +,   2.5889496E-15,   1.4369070E-15,   7.9249753E-16
     +,   4.3435627E-16,   2.3656691E-16,   1.2803738E-16
     +,   6.8861595E-17,   3.6803601E-17
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_haonly_hatt90_mass = Yx/1.02403858064516
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_haonly_hatt95_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.4039715E-03,   1.4585770E-03
     +,   1.5129562E-03,   1.5669349E-03,   1.6203348E-03
     +,   1.6729772E-03,   1.7246816E-03,   1.7752689E-03
     +,   1.8245612E-03,   1.8723859E-03,   1.9185733E-03
     +,   1.9629598E-03,   2.0053904E-03,   2.0457183E-03
     +,   2.0838061E-03,   2.1195286E-03,   2.1527722E-03
     +,   2.1834376E-03,   2.2114387E-03,   2.2367062E-03
     +,   2.2591839E-03,   2.2788353E-03,   2.2956394E-03
     +,   2.3095917E-03,   2.3207059E-03,   2.3290119E-03
     +,   2.3345589E-03,   2.3374103E-03,   2.3376471E-03
     +,   2.3353663E-03,   2.3306780E-03,   2.3237085E-03
     +,   2.3145953E-03,   2.3034886E-03,   2.2905483E-03
     +,   2.2759447E-03,   2.2598549E-03,   2.2424625E-03
     +,   2.2239548E-03,   2.2045253E-03,   2.1843659E-03
     +,   2.1636705E-03,   2.1426312E-03,   2.1214371E-03
     +,   2.1002733E-03,   2.0793192E-03,   2.0587461E-03
     +,   2.0387189E-03,   2.0193926E-03,   2.0009107E-03
     +,   1.9834067E-03,   1.9670022E-03,   1.9518053E-03
     +,   1.9379113E-03,   1.9254024E-03,   1.9143460E-03
     +,   1.9047965E-03,   1.8967937E-03,   1.8903634E-03
     +,   1.8855181E-03,   1.8822566E-03,   1.8805653E-03
     +,   1.8804173E-03,   1.8817749E-03,   1.8845890E-03
     +,   1.8887996E-03,   1.8943384E-03,   1.9011277E-03
     +,   1.9090825E-03,   1.9181103E-03,   1.9281147E-03
     +,   1.9389925E-03,   1.9506390E-03,   1.9629444E-03
     +,   1.9757997E-03,   1.9890938E-03,   2.0027158E-03
     +,   2.0165560E-03,   2.0305072E-03,   2.0444652E-03
     +,   2.0583284E-03,   2.0720009E-03,   2.0853896E-03
     +,   2.0984097E-03,   2.1109802E-03,   2.1230278E-03
     +,   2.1344852E-03,   2.1452934E-03,   2.1553989E-03
     +,   2.1647576E-03,   2.1733323E-03,   2.1810923E-03
     +,   2.1880150E-03,   2.1940856E-03,   2.1992961E-03
     +,   2.2036443E-03,   2.2071349E-03,   2.2097786E-03
     +,   2.2115922E-03,   2.2125959E-03,   2.2128164E-03
     +,   2.2122820E-03,   2.2110255E-03,   2.2090820E-03
     +,   2.2064880E-03,   2.2032824E-03,   2.1995031E-03
     +,   2.1951897E-03,   2.1903794E-03,   2.1851084E-03
     +,   2.1794126E-03,   2.1733227E-03,   2.1668689E-03
     +,   2.1600761E-03,   2.1529661E-03,   2.1455567E-03
     +,   2.1378603E-03,   2.1298847E-03,   2.1216339E-03
     +,   2.1131055E-03,   2.1042917E-03,   2.0951810E-03
     +,   2.0857570E-03,   2.0759969E-03,   2.0658744E-03
     +,   2.0553598E-03,   2.0444177E-03,   2.0330115E-03
     +,   2.0210999E-03,   2.0086407E-03,   1.9955884E-03
     +,   1.9818977E-03,   1.9675219E-03,   1.9524151E-03
     +,   1.9365319E-03,   1.9198267E-03,   1.9022581E-03
     +,   1.8837877E-03,   1.8643785E-03,   1.8439977E-03
     +,   1.8226196E-03,   1.8002251E-03,   1.7768013E-03
     +,   1.7523486E-03,   1.7268866E-03,   1.7004638E-03
     +,   1.6731734E-03,   1.6451880E-03,   1.6168010E-03
     +,   1.5884970E-03,   1.5610486E-03,   1.5356578E-03
     +,   1.5141260E-03,   1.4990586E-03,   1.4940884E-03
     +,   1.5040789E-03,   1.5352569E-03,   1.5952175E-03
     +,   1.6927299E-03,   1.8372702E-03,   2.0383270E-03
     +,   2.3044618E-03,   2.6422762E-03,   3.0555481E-03
     +,   3.5448403E-03,   4.1078446E-03,   4.7407746E-03
     +,   5.4411823E-03,   6.2123346E-03,   7.0691262E-03
     +,   8.0457740E-03,   9.2056263E-03,   1.0653286E-02
     +,   1.2549222E-02,   1.5126441E-02,   1.8708477E-02
     +,   2.3723925E-02,   3.0710621E-02,   4.0300094E-02
     +,   5.3170610E-02,   6.9956519E-02,   9.1109462E-02
     +,   0.1167229    ,   0.1463469    ,   0.1788335    
     +,   0.2122761    ,   0.2441072    ,   0.2713852    
     +,   0.2912477    ,   0.3014520    ,   0.3008670    
     +,   0.2897452    ,   0.2696837    ,   0.2432632    
     +,   0.2134723    ,   0.1831082    ,   0.1543258    
     +,   0.1284365    ,   0.1059579    ,   8.6833857E-02
     +,   7.0702910E-02,   5.7120237E-02,   4.5689840E-02
     +,   3.6111217E-02,   2.8167022E-02,   2.1685332E-02
     +,   1.6507097E-02,   1.2466854E-02,   9.3882121E-03
     +,   7.0905103E-03,   5.4006651E-03,   4.1643335E-03
     +,   3.2533642E-03,   2.5687467E-03,   2.0393860E-03
     +,   1.6177846E-03,   1.2742756E-03,   9.9126366E-04
     +,   7.5839349E-04,   5.6901277E-04,   4.1789966E-04
     +,   3.0015124E-04,   2.1080510E-04,   1.4487524E-04
     +,   9.7579163E-05,   6.4586020E-05,   4.2186832E-05
     +,   2.7363963E-05,   1.7778404E-05,   1.1698155E-05
     +,   7.8936882E-06,   5.5255159E-06,   4.0414357E-06
     +,   3.0909059E-06,   2.4585734E-06,   2.0158843E-06
     +,   1.6880643E-06,   1.4324288E-06,   1.2247847E-06
     +,   1.0512855E-06,   9.0375329E-07,   7.7707523E-07
     +,   6.6777864E-07,   5.7329555E-07,   4.9159422E-07
     +,   4.2099148E-07,   3.6004633E-07,   3.0750400E-07
     +,   2.6226752E-07,   2.2337943E-07,   1.8999658E-07
     +,   1.6138020E-07,   1.3688673E-07,   1.1595310E-07
     +,   9.8087334E-08,   8.2861376E-08,   6.9904324E-08
     +,   5.8894173E-08,   4.9551449E-08,   4.1634657E-08
     +,   3.4935955E-08,   2.9276062E-08,   2.4500483E-08
     +,   2.0476550E-08,   1.7090942E-08,   1.4246253E-08
     +,   1.1859323E-08,   9.8593222E-09,   8.1858973E-09
     +,   6.7875967E-09,   5.6207510E-09,   4.6484221E-09
     +,   3.8393053E-09,   3.1669025E-09,   2.6088502E-09
     +,   2.1463609E-09,   1.7635612E-09,   1.4471682E-09
     +,   1.1859973E-09,   9.7070985E-10,   7.9347329E-10
     +,   6.4776623E-10,   5.2813148E-10,   4.3004103E-10
     +,   3.4971667E-10,   2.8403205E-10,   2.3038844E-10
     +,   1.8663519E-10,   1.5099813E-10,   1.2200825E-10
     +,   9.8458353E-11,   7.9351560E-11,   6.3871047E-11
     +,   5.1344352E-11,   4.1221752E-11,   3.3052162E-11
     +,   2.6467821E-11,   2.1167776E-11,   1.6907410E-11
     +,   1.3487077E-11,   1.0744916E-11
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_haonly_hatt95_mass = Yx/1.12833880645161
      RETURN
      END
C 
C---- New file --- 
C 
      DOUBLE PRECISION FUNCTION A202_tt_hzonly_htt100_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.8302265E-04,   4.9740187E-04
     +,   5.1242689E-04,   5.2815169E-04,   5.4463372E-04
     +,   5.6193402E-04,   5.8011722E-04,   5.9925119E-04
     +,   6.1940675E-04,   6.4065895E-04,   6.6308485E-04
     +,   6.8676454E-04,   7.1178086E-04,   7.3821878E-04
     +,   7.6616526E-04,   7.9570897E-04,   8.2693942E-04
     +,   8.5994729E-04,   8.9482294E-04,   9.3165686E-04
     +,   9.7053876E-04,   1.0115564E-03,   1.0547951E-03
     +,   1.1003403E-03,   1.1482686E-03,   1.1986584E-03
     +,   1.2515797E-03,   1.3070984E-03,   1.3652737E-03
     +,   1.4261584E-03,   1.4897980E-03,   1.5562300E-03
     +,   1.6254835E-03,   1.6975787E-03,   1.7725257E-03
     +,   1.8503261E-03,   1.9309705E-03,   2.0144375E-03
     +,   2.1007028E-03,   2.1897205E-03,   2.2814439E-03
     +,   2.3758125E-03,   2.4727557E-03,   2.5721940E-03
     +,   2.6740390E-03,   2.7781946E-03,   2.8845561E-03
     +,   2.9930125E-03,   3.1034464E-03,   3.2157346E-03
     +,   3.3297522E-03,   3.4453673E-03,   3.5624460E-03
     +,   3.6808581E-03,   3.8004629E-03,   3.9211302E-03
     +,   4.0427241E-03,   4.1651139E-03,   4.2881686E-03
     +,   4.4117612E-03,   4.5357672E-03,   4.6600690E-03
     +,   4.7845431E-03,   4.9090805E-03,   5.0335727E-03
     +,   5.1579042E-03,   5.2819806E-03,   5.4056859E-03
     +,   5.5289268E-03,   5.6515904E-03,   5.7735844E-03
     +,   5.8947909E-03,   6.0151117E-03,   6.1344272E-03
     +,   6.2526241E-03,   6.3695866E-03,   6.4851865E-03
     +,   6.5992908E-03,   6.7117698E-03,   6.8224892E-03
     +,   6.9313035E-03,   7.0380843E-03,   7.1426868E-03
     +,   7.2449883E-03,   7.3448708E-03,   7.4422271E-03
     +,   7.5369729E-03,   7.6290597E-03,   7.7184513E-03
     +,   7.8051770E-03,   7.8893034E-03,   7.9709478E-03
     +,   8.0503011E-03,   8.1276316E-03,   8.2032904E-03
     +,   8.2777152E-03,   8.3514554E-03,   8.4251575E-03
     +,   8.4995991E-03,   8.5756592E-03,   8.6543635E-03
     +,   8.7368479E-03,   8.8243848E-03,   8.9183645E-03
     +,   9.0203080E-03,   9.1318460E-03,   9.2547052E-03
     +,   9.3906969E-03,   9.5417192E-03,   9.7097121E-03
     +,   9.8966341E-03,   1.0104454E-02,   1.0335081E-02
     +,   1.0590394E-02,   1.0872109E-02,   1.1181843E-02
     +,   1.1520973E-02,   1.1890661E-02,   1.2291733E-02
     +,   1.2724714E-02,   1.3189726E-02,   1.3686415E-02
     +,   1.4213946E-02,   1.4770971E-02,   1.5355597E-02
     +,   1.5965270E-02,   1.6596919E-02,   1.7246796E-02
     +,   1.7910646E-02,   1.8583579E-02,   1.9260317E-02
     +,   1.9935057E-02,   2.0601772E-02,   2.1254139E-02
     +,   2.1885846E-02,   2.2490641E-02,   2.3062505E-02
     +,   2.3595842E-02,   2.4085682E-02,   2.4527846E-02
     +,   2.4919054E-02,   2.5257088E-02,   2.5541022E-02
     +,   2.5771158E-02,   2.5949180E-02,   2.6078142E-02
     +,   2.6162434E-02,   2.6207736E-02,   2.6220905E-02
     +,   2.6209835E-02,   2.6183249E-02,   2.6150558E-02
     +,   2.6121611E-02,   2.6106484E-02,   2.6115239E-02
     +,   2.6157778E-02,   2.6243584E-02,   2.6381629E-02
     +,   2.6580192E-02,   2.6846815E-02,   2.7188266E-02
     +,   2.7610529E-02,   2.8118908E-02,   2.8718116E-02
     +,   2.9412558E-02,   3.0206664E-02,   3.1105081E-02
     +,   3.2113288E-02,   3.3238184E-02,   3.4488659E-02
     +,   3.5876084E-02,   3.7414841E-02,   3.9122842E-02
     +,   4.1021381E-02,   4.3134417E-02,   4.5487996E-02
     +,   4.8108861E-02,   5.1022835E-02,   5.4254156E-02
     +,   5.7826400E-02,   6.1764911E-02,   6.6101566E-02
     +,   7.0882224E-02,   7.6175168E-02,   8.2076922E-02
     +,   8.8714652E-02,   9.6242830E-02,   0.1048342    
     +,   0.1146670    ,   0.1259117    ,   0.1387257    
     +,   0.1532517    ,   0.1696192    ,   0.1879449    
     +,   0.2083277    ,   0.2308338    ,   0.2554792    
     +,   0.2822145    ,   0.3109070    ,   0.3413058    
     +,   0.3729821    ,   0.4052601    ,   0.4371660    
     +,   0.4674641    ,   0.4948631    ,   0.5184159    
     +,   0.5379655    ,   0.5543995    ,   0.5694681    
     +,   0.5851532    ,   0.6028672    ,   0.6228578    
     +,   0.6440547    ,   0.6643736    ,   0.6814200    
     +,   0.6934385    ,   0.7001448    ,   0.7028091    
     +,   0.7032755    ,   0.7023978    ,   0.6990339    
     +,   0.6904795    ,   0.6740848    ,   0.6489255    
     +,   0.6164008    ,   0.5794807    ,   0.5412453    
     +,   0.5037256    ,   0.4677167    ,   0.4334038    
     +,   0.4010936    ,   0.3714873    ,   0.3454688    
     +,   0.3237158    ,   0.3064036    ,   0.2930891    
     +,   0.2827778    ,   0.2741469    ,   0.2658675    
     +,   0.2569153    ,   0.2467513    ,   0.2353193    
     +,   0.2228988    ,   0.2099102    ,   0.1967573    
     +,   0.1837461    ,   0.1710715    ,   0.1588427    
     +,   0.1471175    ,   0.1359280    ,   0.1252898    
     +,   0.1152051    ,   0.1056642    ,   9.6648350E-02
     +,   8.8134542E-02,   8.0102831E-02,   7.2541714E-02
     +,   6.5448821E-02,   5.8828410E-02,   5.2687917E-02
     +,   4.7033671E-02,   4.1866660E-02,   3.7180241E-02
     +,   3.2960221E-02,   2.9186059E-02,   2.5831727E-02
     +,   2.2867879E-02,   2.0263528E-02,   1.7987002E-02
     +,   1.6006613E-02,   1.4291420E-02,   1.2811705E-02
     +,   1.1539060E-02,   1.0446654E-02,   9.5095355E-03
     +,   8.7049352E-03,   8.0121960E-03,   7.4130739E-03
     +,   6.8915845E-03,   6.4340569E-03,   6.0289111E-03
     +,   5.6665638E-03,   5.3391308E-03,   5.0402796E-03
     +,   4.7649280E-03,   4.5091086E-03,   4.2697028E-03
     +,   4.0443046E-03,   3.8310941E-03,   3.6286595E-03
     +,   3.4359565E-03,   3.2521747E-03,   3.0767219E-03
     +,   2.9091269E-03,   2.7490461E-03,   2.5961881E-03
     +,   2.4503346E-03,   2.3112807E-03,   2.1788604E-03
     +,   2.0529013E-03,   1.9332505E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_hzonly_htt100_mass = Yx/6.84071563636364
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_hzonly_htt105_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  7.0065493E-04,   7.1470853E-04
     +,   7.2874816E-04,   7.4277510E-04,   7.5679127E-04
     +,   7.7080127E-04,   7.8481040E-04,   7.9882605E-04
     +,   8.1285724E-04,   8.2691491E-04,   8.4101252E-04
     +,   8.5516454E-04,   8.6938858E-04,   8.8370370E-04
     +,   8.9813187E-04,   9.1269700E-04,   9.2742575E-04
     +,   9.4234734E-04,   9.5749344E-04,   9.7289868E-04
     +,   9.8860054E-04,   1.0046392E-03,   1.0210575E-03
     +,   1.0379027E-03,   1.0552229E-03,   1.0730716E-03
     +,   1.0915048E-03,   1.1105813E-03,   1.1303636E-03
     +,   1.1509177E-03,   1.1723132E-03,   1.1946225E-03
     +,   1.2179220E-03,   1.2422912E-03,   1.2678130E-03
     +,   1.2945737E-03,   1.3226622E-03,   1.3521708E-03
     +,   1.3831952E-03,   1.4158313E-03,   1.4501804E-03
     +,   1.4863436E-03,   1.5244234E-03,   1.5645248E-03
     +,   1.6067517E-03,   1.6512085E-03,   1.6979988E-03
     +,   1.7472249E-03,   1.7989872E-03,   1.8533814E-03
     +,   1.9105008E-03,   1.9704325E-03,   2.0332572E-03
     +,   2.0990518E-03,   2.1678780E-03,   2.2397959E-03
     +,   2.3148498E-03,   2.3930725E-03,   2.4744859E-03
     +,   2.5590966E-03,   2.6468956E-03,   2.7378588E-03
     +,   2.8319415E-03,   2.9290847E-03,   3.0292133E-03
     +,   3.1322236E-03,   3.2380028E-03,   3.3464085E-03
     +,   3.4572890E-03,   3.5704614E-03,   3.6857370E-03
     +,   3.8028955E-03,   3.9217132E-03,   4.0419372E-03
     +,   4.1633113E-03,   4.2855684E-03,   4.4084224E-03
     +,   4.5315833E-03,   4.6547633E-03,   4.7776722E-03
     +,   4.9000145E-03,   5.0215125E-03,   5.1418878E-03
     +,   5.2608862E-03,   5.3782593E-03,   5.4937927E-03
     +,   5.6072879E-03,   5.7185874E-03,   5.8275508E-03
     +,   5.9340908E-03,   6.0381545E-03,   6.1397273E-03
     +,   6.2388373E-03,   6.3355700E-03,   6.4300536E-03
     +,   6.5224594E-03,   6.6130119E-03,   6.7019761E-03
     +,   6.7896661E-03,   6.8764295E-03,   6.9626626E-03
     +,   7.0487792E-03,   7.1352306E-03,   7.2224769E-03
     +,   7.3109944E-03,   7.4012652E-03,   7.4937618E-03
     +,   7.5889369E-03,   7.6872194E-03,   7.7890120E-03
     +,   7.8946501E-03,   8.0044391E-03,   8.1185885E-03
     +,   8.2372585E-03,   8.3605070E-03,   8.4883105E-03
     +,   8.6205443E-03,   8.7569878E-03,   8.8973064E-03
     +,   9.0410719E-03,   9.1877468E-03,   9.3366969E-03
     +,   9.4871866E-03,   9.6384063E-03,   9.7894659E-03
     +,   9.9394070E-03,   1.0087239E-02,   1.0231916E-02
     +,   1.0372408E-02,   1.0507660E-02,   1.0636675E-02
     +,   1.0758480E-02,   1.0872188E-02,   1.0976993E-02
     +,   1.1072217E-02,   1.1157296E-02,   1.1231834E-02
     +,   1.1295593E-02,   1.1348533E-02,   1.1390797E-02
     +,   1.1422746E-02,   1.1444959E-02,   1.1458213E-02
     +,   1.1463531E-02,   1.1462140E-02,   1.1455481E-02
     +,   1.1445200E-02,   1.1433136E-02,   1.1421307E-02
     +,   1.1411894E-02,   1.1407224E-02,   1.1409745E-02
     +,   1.1422017E-02,   1.1446686E-02,   1.1486480E-02
     +,   1.1544159E-02,   1.1622536E-02,   1.1724467E-02
     +,   1.1852827E-02,   1.2010517E-02,   1.2200483E-02
     +,   1.2425734E-02,   1.2689342E-02,   1.2994489E-02
     +,   1.3344512E-02,   1.3742965E-02,   1.4193638E-02
     +,   1.4700640E-02,   1.5268511E-02,   1.5902270E-02
     +,   1.6607463E-02,   1.7390238E-02,   1.8257458E-02
     +,   1.9216675E-02,   2.0275999E-02,   2.1444183E-02
     +,   2.2730371E-02,   2.4143791E-02,   2.5693435E-02
     +,   2.7387816E-02,   2.9234426E-02,   3.1239083E-02
     +,   3.3405628E-02,   3.5735726E-02,   3.8228460E-02
     +,   4.0880237E-02,   4.3685175E-02,   4.6636026E-02
     +,   4.9725197E-02,   5.2945979E-02,   5.6295410E-02
     +,   5.9776533E-02,   6.3401036E-02,   6.7192197E-02
     +,   7.1187600E-02,   7.5440831E-02,   8.0022193E-02
     +,   8.5019343E-02,   9.0537779E-02,   9.6700512E-02
     +,   0.1036466    ,   0.1115280    ,   0.1205027    
     +,   0.1307173    ,   0.1422838    ,   0.1552538    
     +,   0.1695959    ,   0.1851841    ,   0.2018034    
     +,   0.2191705    ,   0.2369634    ,   0.2548697    
     +,   0.2726675    ,   0.2903354    ,   0.3081569    
     +,   0.3267312    ,   0.3467984    ,   0.3688526    
     +,   0.3926719    ,   0.4170777    ,   0.4402983    
     +,   0.4610474    ,   0.4798760    ,   0.4998224    
     +,   0.5255111    ,   0.5609743    ,   0.6077313    
     +,   0.6645571    ,   0.7286951    ,   0.7968213    
     +,   0.8649468    ,   0.9283077    ,   0.9824142    
     +,    1.024350    ,    1.052619    ,    1.065916    
     +,    1.062804    ,    1.042760    ,    1.007133    
     +,   0.9589009    ,   0.9016899    ,   0.8389707    
     +,   0.7739308    ,   0.7097534    ,   0.6496588    
     +,   0.5963870    ,   0.5512576    ,   0.5134249    
     +,   0.4801368    ,   0.4480620    ,   0.4147635    
     +,   0.3793406    ,   0.3421352    ,   0.3041186    
     +,   0.2664791    ,   0.2304505    ,   0.1971825    
     +,   0.1675582    ,   0.1420322    ,   0.1205955    
     +,   0.1028722    ,   8.8286713E-02,   7.6224044E-02
     +,   6.6138685E-02,   5.7600323E-02,   5.0292853E-02
     +,   4.3993849E-02,   3.8547389E-02,   3.3838883E-02
     +,   2.9776864E-02,   2.6282040E-02,   2.3281867E-02
     +,   2.0708380E-02,   1.8498363E-02,   1.6594652E-02
     +,   1.4947219E-02,   1.3513138E-02,   1.2256876E-02
     +,   1.1149278E-02,   1.0167014E-02,   9.2912968E-03
     +,   8.5072098E-03,   7.8026382E-03,   7.1678124E-03
     +,   6.5945596E-03,   6.0760817E-03,   5.6065056E-03
     +,   5.1807365E-03,   4.7943294E-03,   4.4432906E-03
     +,   4.1241003E-03,   3.8335589E-03,   3.5688269E-03
     +,   3.3273087E-03,   3.1066982E-03,   2.9048817E-03
     +,   2.7199776E-03,   2.5502576E-03,   2.3941821E-03
     +,   2.2503354E-03,   2.1174550E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_hzonly_htt105_mass = Yx/7.65572277272727
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_hzonly_htt107_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.0972182E-03,   1.1237743E-03
     +,   1.1507785E-03,   1.1782385E-03,   1.2061630E-03
     +,   1.2345598E-03,   1.2634384E-03,   1.2928060E-03
     +,   1.3226713E-03,   1.3530438E-03,   1.3839309E-03
     +,   1.4153405E-03,   1.4472802E-03,   1.4797566E-03
     +,   1.5127760E-03,   1.5463441E-03,   1.5804652E-03
     +,   1.6151430E-03,   1.6503801E-03,   1.6861776E-03
     +,   1.7225349E-03,   1.7594506E-03,   1.7969208E-03
     +,   1.8349423E-03,   1.8735054E-03,   1.9126041E-03
     +,   1.9522263E-03,   1.9923600E-03,   2.0329899E-03
     +,   2.0741005E-03,   2.1156720E-03,   2.1576849E-03
     +,   2.2001157E-03,   2.2429414E-03,   2.2861348E-03
     +,   2.3296699E-03,   2.3735180E-03,   2.4176475E-03
     +,   2.4620316E-03,   2.5066349E-03,   2.5514299E-03
     +,   2.5963837E-03,   2.6414662E-03,   2.6866477E-03
     +,   2.7319000E-03,   2.7771962E-03,   2.8225137E-03
     +,   2.8678295E-03,   2.9131265E-03,   2.9583888E-03
     +,   3.0036087E-03,   3.0487785E-03,   3.0938988E-03
     +,   3.1389762E-03,   3.1840194E-03,   3.2290474E-03
     +,   3.2740852E-03,   3.3191626E-03,   3.3643187E-03
     +,   3.4095983E-03,   3.4550538E-03,   3.5007468E-03
     +,   3.5467399E-03,   3.5931084E-03,   3.6399339E-03
     +,   3.6872989E-03,   3.7352969E-03,   3.7840202E-03
     +,   3.8335698E-03,   3.8840452E-03,   3.9355531E-03
     +,   3.9881947E-03,   4.0420759E-03,   4.0972964E-03
     +,   4.1539543E-03,   4.2121476E-03,   4.2719631E-03
     +,   4.3334761E-03,   4.3967636E-03,   4.4618868E-03
     +,   4.5288932E-03,   4.5978217E-03,   4.6686917E-03
     +,   4.7415160E-03,   4.8162807E-03,   4.8929648E-03
     +,   4.9715205E-03,   5.0518918E-03,   5.1339949E-03
     +,   5.2177347E-03,   5.3029992E-03,   5.3896536E-03
     +,   5.4775472E-03,   5.5665192E-03,   5.6563918E-03
     +,   5.7469690E-03,   5.8380566E-03,   5.9294333E-03
     +,   6.0208878E-03,   6.1121890E-03,   6.2031155E-03
     +,   6.2934323E-03,   6.3829194E-03,   6.4713475E-03
     +,   6.5585012E-03,   6.6441740E-03,   6.7281621E-03
     +,   6.8102763E-03,   6.8903458E-03,   6.9682118E-03
     +,   7.0437272E-03,   7.1167676E-03,   7.1872175E-03
     +,   7.2549894E-03,   7.3200008E-03,   7.3821987E-03
     +,   7.4415333E-03,   7.4979798E-03,   7.5515187E-03
     +,   7.6021492E-03,   7.6498776E-03,   7.6947161E-03
     +,   7.7366885E-03,   7.7758161E-03,   7.8121289E-03
     +,   7.8456514E-03,   7.8764129E-03,   7.9044318E-03
     +,   7.9297265E-03,   7.9523092E-03,   7.9721808E-03
     +,   7.9893358E-03,   8.0037657E-03,   8.0154426E-03
     +,   8.0243470E-03,   8.0304341E-03,   8.0336677E-03
     +,   8.0339964E-03,   8.0313832E-03,   8.0257766E-03
     +,   8.0171321E-03,   8.0054188E-03,   7.9906099E-03
     +,   7.9726968E-03,   7.9516890E-03,   7.9276226E-03
     +,   7.9005621E-03,   7.8706071E-03,   7.8379037E-03
     +,   7.8026466E-03,   7.7650873E-03,   7.7255475E-03
     +,   7.6844268E-03,   7.6422142E-03,   7.5994967E-03
     +,   7.5569879E-03,   7.5155264E-03,   7.4761016E-03
     +,   7.4398718E-03,   7.4081910E-03,   7.3826141E-03
     +,   7.3649422E-03,   7.3572318E-03,   7.3618256E-03
     +,   7.3813777E-03,   7.4188733E-03,   7.4776569E-03
     +,   7.5614359E-03,   7.6743104E-03,   7.8207757E-03
     +,   8.0056973E-03,   8.2343062E-03,   8.5121766E-03
     +,   8.8451831E-03,   9.2393886E-03,   9.7010126E-03
     +,   1.0236342E-02,   1.0851556E-02,   1.1552638E-02
     +,   1.2345356E-02,   1.3235105E-02,   1.4226846E-02
     +,   1.5325136E-02,   1.6534325E-02,   1.7858688E-02
     +,   1.9302638E-02,   2.0871170E-02,   2.2570454E-02
     +,   2.4408299E-02,   2.6394429E-02,   2.8541291E-02
     +,   3.0864228E-02,   3.3381280E-02,   3.6113281E-02
     +,   3.9083622E-02,   4.2317886E-02,   4.5843389E-02
     +,   4.9689721E-02,   5.3890049E-02,   5.8482572E-02
     +,   6.3511752E-02,   6.9029719E-02,   7.5094879E-02
     +,   8.1766069E-02,   8.9090817E-02,   9.7091101E-02
     +,   0.1057453    ,   0.1149740    ,   0.1246399    
     +,   0.1345675    ,   0.1445858    ,   0.1545901    
     +,   0.1646106    ,   0.1748593    ,   0.1857329    
     +,   0.1977545    ,   0.2114606    ,   0.2272628    
     +,   0.2453228    ,   0.2654882    ,   0.2873274    
     +,   0.3102598    ,   0.3337668    ,   0.3576275    
     +,   0.3820946    ,   0.4079174    ,   0.4361825    
     +,   0.4680044    ,   0.5040790    ,   0.5440993    
     +,   0.5862553    ,   0.6275047    ,   0.6652212    
     +,   0.6995040    ,   0.7340271    ,   0.7740166    
     +,   0.8227185    ,   0.8793216    ,   0.9395180    
     +,   0.9974517    ,    1.047674    ,    1.086659    
     +,    1.113497    ,    1.129021    ,    1.133471    
     +,    1.124416    ,    1.097276    ,    1.048801    
     +,   0.9806642    ,   0.8998684    ,   0.8157359    
     +,   0.7360047    ,   0.6642361    ,   0.5994609    
     +,   0.5379736    ,   0.4762650    ,   0.4133145    
     +,   0.3509654    ,   0.2925670    ,   0.2411314    
     +,   0.1981736    ,   0.1635825    ,   0.1361808    
     +,   0.1144292    ,   9.6919991E-02,   8.2581706E-02
     +,   7.0685543E-02,   6.0756184E-02,   5.2467622E-02
     +,   4.5566339E-02,   3.9829522E-02,   3.5050359E-02
     +,   3.1038960E-02,   2.7629040E-02,   2.4684204E-02
     +,   2.2099750E-02,   1.9799493E-02,   1.7731335E-02
     +,   1.5860448E-02,   1.4164136E-02,   1.2626726E-02
     +,   1.1236744E-02,   9.9844187E-03,   8.8608824E-03
     +,   7.8572705E-03,   6.9648456E-03,   6.1747660E-03
     +,   5.4783025E-03,   4.8669996E-03,   4.3326328E-03
     +,   3.8674525E-03,   3.4641037E-03,   3.1157869E-03
     +,   2.8161730E-03,   2.5595000E-03,   2.3404849E-03
     +,   2.1543731E-03,   1.9968559E-03,   1.8640923E-03
     +,   1.7526330E-03,   1.6594242E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_hzonly_htt107_mass = Yx/7.81605204545455
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_hzonly_htt110_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  9.8904443E-04,   1.0343862E-03
     +,   1.0811812E-03,   1.1293918E-03,   1.1789720E-03
     +,   1.2298662E-03,   1.2820117E-03,   1.3353351E-03
     +,   1.3897545E-03,   1.4451805E-03,   1.5015138E-03
     +,   1.5586460E-03,   1.6164610E-03,   1.6748344E-03
     +,   1.7336340E-03,   1.7927212E-03,   1.8519501E-03
     +,   1.9111692E-03,   1.9702215E-03,   2.0289463E-03
     +,   2.0871782E-03,   2.1447502E-03,   2.2014922E-03
     +,   2.2572372E-03,   2.3118129E-03,   2.3650532E-03
     +,   2.4167926E-03,   2.4668693E-03,   2.5151267E-03
     +,   2.5614130E-03,   2.6055875E-03,   2.6475112E-03
     +,   2.6870591E-03,   2.7241150E-03,   2.7585735E-03
     +,   2.7903421E-03,   2.8193388E-03,   2.8454966E-03
     +,   2.8687639E-03,   2.8891005E-03,   2.9064850E-03
     +,   2.9209072E-03,   2.9323765E-03,   2.9409151E-03
     +,   2.9465621E-03,   2.9493724E-03,   2.9494143E-03
     +,   2.9467773E-03,   2.9415567E-03,   2.9338680E-03
     +,   2.9238404E-03,   2.9116143E-03,   2.8973438E-03
     +,   2.8811917E-03,   2.8633354E-03,   2.8439607E-03
     +,   2.8232613E-03,   2.8014404E-03,   2.7787089E-03
     +,   2.7552836E-03,   2.7313852E-03,   2.7072413E-03
     +,   2.6830833E-03,   2.6591434E-03,   2.6356571E-03
     +,   2.6128637E-03,   2.5910002E-03,   2.5703069E-03
     +,   2.5510241E-03,   2.5333897E-03,   2.5176422E-03
     +,   2.5040205E-03,   2.4927622E-03,   2.4841030E-03
     +,   2.4782785E-03,   2.4755234E-03,   2.4760722E-03
     +,   2.4801570E-03,   2.4880113E-03,   2.4998672E-03
     +,   2.5159558E-03,   2.5365099E-03,   2.5617566E-03
     +,   2.5919296E-03,   2.6272528E-03,   2.6679568E-03
     +,   2.7142616E-03,   2.7663913E-03,   2.8245572E-03
     +,   2.8889708E-03,   2.9598332E-03,   3.0373372E-03
     +,   3.1216557E-03,   3.2129560E-03,   3.3113875E-03
     +,   3.4170677E-03,   3.5301053E-03,   3.6505649E-03
     +,   3.7784942E-03,   3.9138896E-03,   4.0567266E-03
     +,   4.2069182E-03,   4.3643480E-03,   4.5288280E-03
     +,   4.7001373E-03,   4.8779901E-03,   5.0620330E-03
     +,   5.2518519E-03,   5.4469816E-03,   5.6468882E-03
     +,   5.8509605E-03,   6.0585500E-03,   6.2689180E-03
     +,   6.4812982E-03,   6.6948407E-03,   6.9086798E-03
     +,   7.1218745E-03,   7.3334826E-03,   7.5425045E-03
     +,   7.7479458E-03,   7.9488037E-03,   8.1440704E-03
     +,   8.3327554E-03,   8.5139088E-03,   8.6866254E-03
     +,   8.8500399E-03,   9.0033757E-03,   9.1459258E-03
     +,   9.2771035E-03,   9.3964133E-03,   9.5035043E-03
     +,   9.5981546E-03,   9.6803075E-03,   9.7500635E-03
     +,   9.8077077E-03,   9.8537104E-03,   9.8887403E-03
     +,   9.9136736E-03,   9.9295964E-03,   9.9378182E-03
     +,   9.9398587E-03,   9.9374652E-03,   9.9326000E-03
     +,   9.9274432E-03,   9.9243764E-03,   9.9259671E-03
     +,   9.9349637E-03,   9.9542690E-03,   9.9869082E-03
     +,   1.0036008E-02,   1.0104756E-02,   1.0196366E-02
     +,   1.0314015E-02,   1.0460824E-02,   1.0639789E-02
     +,   1.0853727E-02,   1.1105221E-02,   1.1396592E-02
     +,   1.1729841E-02,   1.2106578E-02,   1.2528017E-02
     +,   1.2994983E-02,   1.3507822E-02,   1.4066441E-02
     +,   1.4670355E-02,   1.5318711E-02,   1.6010277E-02
     +,   1.6743535E-02,   1.7516835E-02,   1.8328438E-02
     +,   1.9176563E-02,   2.0059539E-02,   2.0976003E-02
     +,   2.1924974E-02,   2.2905832E-02,   2.3918618E-02
     +,   2.4964064E-02,   2.6043572E-02,   2.7159339E-02
     +,   2.8314512E-02,   2.9513165E-02,   3.0760288E-02
     +,   3.2061972E-02,   3.3425678E-02,   3.4860376E-02
     +,   3.6376767E-02,   3.7987854E-02,   3.9709508E-02
     +,   4.1560806E-02,   4.3564405E-02,   4.5746952E-02
     +,   4.8138861E-02,   5.0773181E-02,   5.3684283E-02
     +,   5.6905616E-02,   6.0466263E-02,   6.4387031E-02
     +,   6.8676792E-02,   7.3330201E-02,   7.8326680E-02
     +,   8.3632901E-02,   8.9209847E-02,   9.5024489E-02
     +,   0.1010636    ,   0.1073481    ,   0.1139440    
     +,   0.1209639    ,   0.1285540    ,   0.1368689    
     +,   0.1460356    ,   0.1561161    ,   0.1670826    
     +,   0.1788157    ,   0.1911329    ,   0.2038336    
     +,   0.2167464    ,   0.2297574    ,   0.2428075    
     +,   0.2558681    ,   0.2689261    ,   0.2820254    
     +,   0.2953694    ,   0.3094447    ,   0.3250580    
     +,   0.3431532    ,   0.3643459    ,   0.3883347    
     +,   0.4135456    ,   0.4374561    ,   0.4577174    
     +,   0.4736562    ,   0.4872057    ,   0.5023882    
     +,   0.5232710    ,   0.5514554    ,   0.5847162    
     +,   0.6178747    ,   0.6456650    ,   0.6661476    
     +,   0.6825765    ,   0.7021858    ,   0.7322596    
     +,   0.7762794    ,   0.8330572    ,   0.8988019    
     +,   0.9691247    ,    1.038814    ,    1.100514    
     +,    1.145288    ,    1.166432    ,    1.163743    
     +,    1.143404    ,    1.112465    ,    1.073036    
     +,    1.022041    ,   0.9561637    ,   0.8763698    
     +,   0.7880075    ,   0.6974966    ,   0.6093144    
     +,   0.5255059    ,   0.4470416    ,   0.3750481    
     +,   0.3109008    ,   0.2556035    ,   0.2093168    
     +,   0.1714186    ,   0.1408394    ,   0.1163710    
     +,   9.6846476E-02,   8.1222370E-02,   6.8616696E-02
     +,   5.8323622E-02,   4.9809519E-02,   4.2690665E-02
     +,   3.6698010E-02,   3.1638630E-02,   2.7367221E-02
     +,   2.3765160E-02,   2.0731384E-02,   1.8177193E-02
     +,   1.6025916E-02,   1.4211779E-02,   1.2679609E-02
     +,   1.1383177E-02,   1.0283988E-02,   9.3495417E-03
     +,   8.5522775E-03,   7.8687929E-03,   7.2790938E-03
     +,   6.7664338E-03,   6.3168332E-03,   5.9189643E-03
     +,   5.5637052E-03,   5.2439258E-03,   4.9540317E-03
     +,   4.6897260E-03,   4.4476232E-03,   4.2250608E-03
     +,   4.0198360E-03,   3.8301200E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_hzonly_htt110_mass = Yx/8.6025562
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_hzonly_htt115_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.1226893E-03,   2.1687127E-03
     +,   2.2152073E-03,   2.2621786E-03,   2.3096346E-03
     +,   2.3575849E-03,   2.4060388E-03,   2.4550089E-03
     +,   2.5045078E-03,   2.5545510E-03,   2.6051544E-03
     +,   2.6563350E-03,   2.7081133E-03,   2.7605079E-03
     +,   2.8135413E-03,   2.8672377E-03,   2.9216211E-03
     +,   2.9767170E-03,   3.0325532E-03,   3.0891579E-03
     +,   3.1465592E-03,   3.2047865E-03,   3.2638698E-03
     +,   3.3238418E-03,   3.3847305E-03,   3.4465669E-03
     +,   3.5093830E-03,   3.5732051E-03,   3.6380633E-03
     +,   3.7039833E-03,   3.7709894E-03,   3.8391047E-03
     +,   3.9083483E-03,   3.9787372E-03,   4.0502837E-03
     +,   4.1229967E-03,   4.1968790E-03,   4.2719296E-03
     +,   4.3481444E-03,   4.4255047E-03,   4.5039947E-03
     +,   4.5835860E-03,   4.6642441E-03,   4.7459262E-03
     +,   4.8285774E-03,   4.9121412E-03,   4.9965447E-03
     +,   5.0817123E-03,   5.1675499E-03,   5.2539608E-03
     +,   5.3408360E-03,   5.4280572E-03,   5.5154921E-03
     +,   5.6030075E-03,   5.6904508E-03,   5.7776659E-03
     +,   5.8644898E-03,   5.9507461E-03,   6.0362583E-03
     +,   6.1208364E-03,   6.2042894E-03,   6.2864227E-03
     +,   6.3670320E-03,   6.4459187E-03,   6.5228846E-03
     +,   6.5977206E-03,   6.6702357E-03,   6.7402269E-03
     +,   6.8075135E-03,   6.8719052E-03,   6.9332328E-03
     +,   6.9913333E-03,   7.0460574E-03,   7.0972620E-03
     +,   7.1448321E-03,   7.1886661E-03,   7.2286748E-03
     +,   7.2647980E-03,   7.2969943E-03,   7.3252446E-03
     +,   7.3495558E-03,   7.3699621E-03,   7.3865261E-03
     +,   7.3993364E-03,   7.4085095E-03,   7.4141938E-03
     +,   7.4165748E-03,   7.4158576E-03,   7.4122846E-03
     +,   7.4061295E-03,   7.3977029E-03,   7.3873345E-03
     +,   7.3753982E-03,   7.3622889E-03,   7.3484369E-03
     +,   7.3343045E-03,   7.3203701E-03,   7.3071495E-03
     +,   7.2951810E-03,   7.2850212E-03,   7.2772540E-03
     +,   7.2724782E-03,   7.2713136E-03,   7.2743837E-03
     +,   7.2823316E-03,   7.2958022E-03,   7.3154494E-03
     +,   7.3419185E-03,   7.3758615E-03,   7.4179079E-03
     +,   7.4686902E-03,   7.5288182E-03,   7.5988788E-03
     +,   7.6794364E-03,   7.7710263E-03,   7.8741573E-03
     +,   7.9892892E-03,   8.1168590E-03,   8.2572456E-03
     +,   8.4107900E-03,   8.5777985E-03,   8.7585114E-03
     +,   8.9531224E-03,   9.1617834E-03,   9.3846051E-03
     +,   9.6216258E-03,   9.8728715E-03,   1.0138283E-02
     +,   1.0417802E-02,   1.0711292E-02,   1.1018618E-02
     +,   1.1339586E-02,   1.1673981E-02,   1.2021557E-02
     +,   1.2382057E-02,   1.2755219E-02,   1.3140718E-02
     +,   1.3538242E-02,   1.3947478E-02,   1.4368097E-02
     +,   1.4799751E-02,   1.5242066E-02,   1.5694689E-02
     +,   1.6157273E-02,   1.6629407E-02,   1.7110724E-02
     +,   1.7600847E-02,   1.8099386E-02,   1.8605931E-02
     +,   1.9120146E-02,   1.9641720E-02,   2.0170338E-02
     +,   2.0705784E-02,   2.1247948E-02,   2.1796854E-02
     +,   2.2352682E-02,   2.2915816E-02,   2.3486948E-02
     +,   2.4067074E-02,   2.4657540E-02,   2.5260145E-02
     +,   2.5877209E-02,   2.6511453E-02,   2.7166164E-02
     +,   2.7845161E-02,   2.8552778E-02,   2.9293712E-02
     +,   3.0073002E-02,   3.0895958E-02,   3.1767968E-02
     +,   3.2694325E-02,   3.3680070E-02,   3.4729961E-02
     +,   3.5848312E-02,   3.7038840E-02,   3.8304746E-02
     +,   3.9648958E-02,   4.1073900E-02,   4.2581957E-02
     +,   4.4175792E-02,   4.5858517E-02,   4.7633998E-02
     +,   4.9507070E-02,   5.1484223E-02,   5.3573571E-02
     +,   5.5785161E-02,   5.8131423E-02,   6.0627490E-02
     +,   6.3291565E-02,   6.6144377E-02,   6.9210239E-02
     +,   7.2515577E-02,   7.6088101E-02,   7.9955332E-02
     +,   8.4142618E-02,   8.8670388E-02,   9.3552217E-02
     +,   9.8792650E-02,   0.1043880    ,   0.1103277    
     +,   0.1165978    ,   0.1231885    ,   0.1301027    
     +,   0.1373653    ,   0.1450313    ,   0.1531920    
     +,   0.1619738    ,   0.1715248    ,   0.1819945    
     +,   0.1934994    ,   0.2060833    ,   0.2196837    
     +,   0.2341178    ,   0.2491028    ,   0.2643176    
     +,   0.2794953    ,   0.2945204    ,   0.3094889    
     +,   0.3246771    ,   0.3404204    ,   0.3569289    
     +,   0.3741426    ,   0.3917372    ,   0.4093387    
     +,   0.4268798    ,   0.4448823    ,   0.4644472    
     +,   0.4868489    ,   0.5128866    ,   0.5423353    
     +,   0.5738112    ,   0.6051011    ,   0.6337484    
     +,   0.6576172    ,   0.6753722    ,   0.6869290    
     +,   0.6938206    ,   0.6991074    ,   0.7064882    
     +,   0.7188083    ,   0.7368144    ,   0.7590637    
     +,   0.7830305    ,   0.8065478    ,   0.8285506    
     +,   0.8488798    ,   0.8676217    ,   0.8845092    
     +,   0.8984707    ,   0.9073520    ,   0.9081814    
     +,   0.8981814    ,   0.8761420    ,   0.8431228    
     +,   0.8019041    ,   0.7556567    ,   0.7068085    
     +,   0.6567330    ,   0.6061049    ,   0.5553670    
     +,   0.5049568    ,   0.4552869    ,   0.4067013    
     +,   0.3595307    ,   0.3142120    ,   0.2713396    
     +,   0.2316183    ,   0.1957240    ,   0.1641404    
     +,   0.1370542    ,   0.1143396    ,   9.5616505E-02
     +,   8.0348969E-02,   6.7947872E-02,   5.7854768E-02
     +,   4.9590781E-02,   4.2771827E-02,   3.7105866E-02
     +,   3.2374293E-02,   2.8413698E-02,   2.5096785E-02
     +,   2.2320393E-02,   1.9996151E-02,   1.8046945E-02
     +,   1.6404437E-02,   1.5009199E-02,   1.3810343E-02
     +,   1.2765624E-02,   1.1841153E-02,   1.1010403E-02
     +,   1.0253471E-02,   9.5557533E-03,   8.9070471E-03
     +,   8.3003473E-03,   7.7311369E-03,   7.1965056E-03
     +,   6.6946982E-03,   6.2245540E-03,   5.7852976E-03
     +,   5.3761974E-03,   4.9965344E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_hzonly_htt115_mass = Yx/9.02059993333333
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_hzonly_htt120_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.6679024E-03,   3.7842693E-03
     +,   3.9007864E-03,   4.0172720E-03,   4.1335425E-03
     +,   4.2494135E-03,   4.3647047E-03,   4.4792383E-03
     +,   4.5928387E-03,   4.7053369E-03,   4.8165680E-03
     +,   4.9263742E-03,   5.0346032E-03,   5.1411116E-03
     +,   5.2457685E-03,   5.3484454E-03,   5.4490264E-03
     +,   5.5474075E-03,   5.6434958E-03,   5.7372060E-03
     +,   5.8284672E-03,   5.9172176E-03,   6.0034054E-03
     +,   6.0869968E-03,   6.1679576E-03,   6.2462762E-03
     +,   6.3219434E-03,   6.3949632E-03,   6.4653470E-03
     +,   6.5331156E-03,   6.5983017E-03,   6.6609387E-03
     +,   6.7210733E-03,   6.7787515E-03,   6.8340311E-03
     +,   6.8869730E-03,   6.9376370E-03,   6.9860904E-03
     +,   7.0324042E-03,   7.0766434E-03,   7.1188826E-03
     +,   7.1591926E-03,   7.1976413E-03,   7.2343000E-03
     +,   7.2692330E-03,   7.3025087E-03,   7.3341927E-03
     +,   7.3643425E-03,   7.3930221E-03,   7.4202796E-03
     +,   7.4461750E-03,   7.4707535E-03,   7.4940654E-03
     +,   7.5161583E-03,   7.5370721E-03,   7.5568454E-03
     +,   7.5755208E-03,   7.5931326E-03,   7.6097203E-03
     +,   7.6253195E-03,   7.6399646E-03,   7.6536918E-03
     +,   7.6665352E-03,   7.6785334E-03,   7.6897233E-03
     +,   7.7001452E-03,   7.7098412E-03,   7.7188485E-03
     +,   7.7272174E-03,   7.7349907E-03,   7.7422191E-03
     +,   7.7489493E-03,   7.7552367E-03,   7.7611362E-03
     +,   7.7666994E-03,   7.7719823E-03,   7.7770441E-03
     +,   7.7819363E-03,   7.7867182E-03,   7.7914475E-03
     +,   7.7961697E-03,   7.8009441E-03,   7.8058145E-03
     +,   7.8108269E-03,   7.8160223E-03,   7.8214370E-03
     +,   7.8271031E-03,   7.8330459E-03,   7.8392858E-03
     +,   7.8458339E-03,   7.8526977E-03,   7.8598773E-03
     +,   7.8673633E-03,   7.8751473E-03,   7.8832051E-03
     +,   7.8915078E-03,   7.9000266E-03,   7.9087224E-03
     +,   7.9175504E-03,   7.9264650E-03,   7.9354206E-03
     +,   7.9443622E-03,   7.9532405E-03,   7.9620052E-03
     +,   7.9706050E-03,   7.9790056E-03,   7.9871584E-03
     +,   7.9950355E-03,   8.0026118E-03,   8.0098780E-03
     +,   8.0168257E-03,   8.0234706E-03,   8.0298362E-03
     +,   8.0359643E-03,   8.0419090E-03,   8.0477493E-03
     +,   8.0535728E-03,   8.0594961E-03,   8.0656465E-03
     +,   8.0721760E-03,   8.0792550E-03,   8.0870707E-03
     +,   8.0958242E-03,   8.1057465E-03,   8.1170779E-03
     +,   8.1300745E-03,   8.1450082E-03,   8.1621604E-03
     +,   8.1818402E-03,   8.2043493E-03,   8.2300128E-03
     +,   8.2591716E-03,   8.2921628E-03,   8.3293440E-03
     +,   8.3710970E-03,   8.4178029E-03,   8.4698703E-03
     +,   8.5277250E-03,   8.5918354E-03,   8.6626867E-03
     +,   8.7408200E-03,   8.8268230E-03,   8.9213420E-03
     +,   9.0251137E-03,   9.1389371E-03,   9.2637334E-03
     +,   9.4005326E-03,   9.5504932E-03,   9.7149201E-03
     +,   9.8952791E-03,   1.0093231E-02,   1.0310589E-02
     +,   1.0549377E-02,   1.0811826E-02,   1.1100377E-02
     +,   1.1417646E-02,   1.1766435E-02,   1.2149718E-02
     +,   1.2570617E-02,   1.3032299E-02,   1.3538017E-02
     +,   1.4091017E-02,   1.4694407E-02,   1.5351115E-02
     +,   1.6063860E-02,   1.6834985E-02,   1.7666351E-02
     +,   1.8559230E-02,   1.9514337E-02,   2.0531626E-02
     +,   2.1610230E-02,   2.2748442E-02,   2.3943795E-02
     +,   2.5193058E-02,   2.6492141E-02,   2.7836528E-02
     +,   2.9221281E-02,   3.0641241E-02,   3.2091349E-02
     +,   3.3567112E-02,   3.5064887E-02,   3.6582123E-02
     +,   3.8117923E-02,   3.9673392E-02,   4.1252024E-02
     +,   4.2859592E-02,   4.4504542E-02,   4.6197847E-02
     +,   4.7952779E-02,   4.9784161E-02,   5.1707968E-02
     +,   5.3740390E-02,   5.5896509E-02,   5.8189481E-02
     +,   6.0629442E-02,   6.3222781E-02,   6.5971270E-02
     +,   6.8872221E-02,   7.1919203E-02,   7.5103045E-02
     +,   7.8413025E-02,   8.1838913E-02,   8.5373163E-02
     +,   8.9012116E-02,   9.2756204E-02,   9.6610934E-02
     +,   0.1005856    ,   0.1046916    ,   0.1089418    
     +,   0.1133517    ,   0.1179422    ,   0.1227472    
     +,   0.1278257    ,   0.1332770    ,   0.1392570    
     +,   0.1459896    ,   0.1537680    ,   0.1629390    
     +,   0.1738655    ,   0.1868678    ,   0.2021609    
     +,   0.2197961    ,   0.2396297    ,   0.2613373    
     +,   0.2844657    ,   0.3085030    ,   0.3329390    
     +,   0.3572986    ,   0.3811511    ,   0.4041236    
     +,   0.4259658    ,   0.4466906    ,   0.4667439    
     +,   0.4870989    ,   0.5091642    ,   0.5344539    
     +,   0.5640639    ,   0.5981427    ,   0.6355800    
     +,   0.6740782    ,   0.7106743    ,   0.7425981    
     +,   0.7682164    ,   0.7876644    ,   0.8027680    
     +,   0.8162418    ,   0.8304653    ,   0.8464301    
     +,   0.8633109    ,   0.8788070    ,   0.8900271    
     +,   0.8945982    ,   0.8916085    ,   0.8819706    
     +,   0.8680211    ,   0.8524421    ,   0.8370585    
     +,   0.8221396    ,   0.8064613    ,   0.7879344    
     +,   0.7642990    ,   0.7336550    ,   0.6948534    
     +,   0.6478445    ,   0.5939034    ,   0.5355309    
     +,   0.4759438    ,   0.4183458    ,   0.3652490    
     +,   0.3181220    ,   0.2774055    ,   0.2427738    
     +,   0.2134675    ,   0.1885778    ,   0.1672339    
     +,   0.1486939    ,   0.1323658    ,   0.1178065    
     +,   0.1046979    ,   9.2827551E-02,   8.2059748E-02
     +,   7.2314098E-02,   6.3539296E-02,   5.5697121E-02
     +,   4.8746895E-02,   4.2640455E-02,   3.7318118E-02
     +,   3.2710802E-02,   2.8743556E-02,   2.5338540E-02
     +,   2.2419821E-02,   1.9915605E-02,   1.7761201E-02
     +,   1.5899550E-02,   1.4282184E-02,   1.2868445E-02
     +,   1.1625177E-02,   1.0525368E-02,   9.5474459E-03
     +,   8.6739874E-03,   7.8910487E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_hzonly_htt120_mass = Yx/8.88996126666667
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_hzonly_htt60_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.6793791E-02,   3.0429918E-02
     +,   3.4587357E-02,   3.9325006E-02,   4.4699062E-02
     +,   5.0761737E-02,   5.7561550E-02,   6.5145478E-02
     +,   7.3564120E-02,   8.2879320E-02,   9.3173563E-02
     +,   0.1045619    ,   0.1172028    ,   0.1313099    
     +,   0.1471613    ,   0.1651057    ,   0.1855599    
     +,   0.2089880    ,   0.2358522    ,   0.2665254    
     +,   0.3011781    ,   0.3396705    ,   0.3815089    
     +,   0.4259288    ,   0.4721003    ,   0.5194256    
     +,   0.5677422    ,   0.6173030    ,   0.6684551    
     +,   0.7211463    ,   0.7745828    ,   0.8273549    
     +,   0.8780943    ,   0.9263698    ,   0.9732184    
     +,    1.020890    ,    1.071751    ,    1.126832    
     +,    1.184707    ,    1.241300    ,    1.290899    
     +,    1.327973    ,    1.348888    ,    1.352489    
     +,    1.339312    ,    1.310343    ,    1.266470    
     +,    1.209069    ,    1.140848    ,    1.065920    
     +,   0.9888108    ,   0.9131716    ,   0.8410836    
     +,   0.7732071    ,   0.7093995    ,   0.6492449    
     +,   0.5923615    ,   0.5385486    ,   0.4878994    
     +,   0.4408526    ,   0.3981103    ,   0.3604123    
     +,   0.3282800    ,   0.3018347    ,   0.2807629    
     +,   0.2644062    ,   0.2518988    ,   0.2423164    
     +,   0.2347830    ,   0.2285446    ,   0.2230008    
     +,   0.2177136    ,   0.2123940    ,   0.2068775    
     +,   0.2010925    ,   0.1950330    ,   0.1887343    
     +,   0.1822558    ,   0.1756677    ,   0.1690450    
     +,   0.1624613    ,   0.1559844    ,   0.1496740    
     +,   0.1435767    ,   0.1377264    ,   0.1321414    
     +,   0.1268272    ,   0.1217755    ,   0.1169695    
     +,   0.1123851    ,   0.1079955    ,   0.1037742    
     +,   9.9697866E-02,   9.5748156E-02,   9.1913007E-02
     +,   8.8187024E-02,   8.4570765E-02,   8.1070274E-02
     +,   7.7694848E-02,   7.4456431E-02,   7.1367301E-02
     +,   6.8439208E-02,   6.5681808E-02,   6.3102469E-02
     +,   6.0705140E-02,   5.8490418E-02,   5.6455869E-02
     +,   5.4596141E-02,   5.2902952E-02,   5.1366169E-02
     +,   4.9973942E-02,   4.8713401E-02,   4.7571007E-02
     +,   4.6533026E-02,   4.5585912E-02,   4.4716541E-02
     +,   4.3912631E-02,   4.3162689E-02,   4.2456456E-02
     +,   4.1784715E-02,   4.1139513E-02,   4.0514294E-02
     +,   3.9903656E-02,   3.9303526E-02,   3.8710982E-02
     +,   3.8124338E-02,   3.7542872E-02,   3.6966916E-02
     +,   3.6397532E-02,   3.5836618E-02,   3.5286542E-02
     +,   3.4750253E-02,   3.4230940E-02,   3.3731975E-02
     +,   3.3256933E-02,   3.2809138E-02,   3.2391928E-02
     +,   3.2008350E-02,   3.1661108E-02,   3.1352501E-02
     +,   3.1084428E-02,   3.0858295E-02,   3.0674987E-02
     +,   3.0534882E-02,   3.0437814E-02,   3.0383127E-02
     +,   3.0369680E-02,   3.0395873E-02,   3.0459683E-02
     +,   3.0558687E-02,   3.0690156E-02,   3.0851100E-02
     +,   3.1038260E-02,   3.1248238E-02,   3.1477563E-02
     +,   3.1722661E-02,   3.1979982E-02,   3.2246046E-02
     +,   3.2517470E-02,   3.2791048E-02,   3.3063769E-02
     +,   3.3332855E-02,   3.3595789E-02,   3.3850379E-02
     +,   3.4094702E-02,   3.4327224E-02,   3.4546677E-02
     +,   3.4752149E-02,   3.4943044E-02,   3.5119094E-02
     +,   3.5280228E-02,   3.5426721E-02,   3.5558980E-02
     +,   3.5677698E-02,   3.5783604E-02,   3.5877626E-02
     +,   3.5960630E-02,   3.6033634E-02,   3.6097541E-02
     +,   3.6153216E-02,   3.6201447E-02,   3.6242861E-02
     +,   3.6277939E-02,   3.6306985E-02,   3.6330085E-02
     +,   3.6347140E-02,   3.6357820E-02,   3.6361597E-02
     +,   3.6357690E-02,   3.6345154E-02,   3.6322843E-02
     +,   3.6289446E-02,   3.6243502E-02,   3.6183435E-02
     +,   3.6107607E-02,   3.6014255E-02,   3.5901692E-02
     +,   3.5768155E-02,   3.5611954E-02,   3.5431474E-02
     +,   3.5225194E-02,   3.4991752E-02,   3.4729920E-02
     +,   3.4438651E-02,   3.4117151E-02,   3.3764824E-02
     +,   3.3381265E-02,   3.2966439E-02,   3.2520477E-02
     +,   3.2043770E-02,   3.1536978E-02,   3.1001056E-02
     +,   3.0437173E-02,   2.9846739E-02,   2.9231329E-02
     +,   2.8592786E-02,   2.7933111E-02,   2.7254434E-02
     +,   2.6558973E-02,   2.5849162E-02,   2.5127411E-02
     +,   2.4396148E-02,   2.3657916E-02,   2.2915225E-02
     +,   2.2170495E-02,   2.1426078E-02,   2.0684315E-02
     +,   1.9947438E-02,   1.9217508E-02,   1.8496469E-02
     +,   1.7786134E-02,   1.7088201E-02,   1.6404128E-02
     +,   1.5735241E-02,   1.5082730E-02,   1.4447572E-02
     +,   1.3830589E-02,   1.3232483E-02,   1.2653792E-02
     +,   1.2094884E-02,   1.1555976E-02,   1.1037222E-02
     +,   1.0538636E-02,   1.0060101E-02,   9.6014002E-03
     +,   9.1622723E-03,   8.7423911E-03,   8.3413050E-03
     +,   7.9585379E-03,   7.5935982E-03,   7.2459057E-03
     +,   6.9148778E-03,   6.5999115E-03,   6.3004009E-03
     +,   6.0156905E-03,   5.7451422E-03,   5.4881289E-03
     +,   5.2440204E-03,   5.0121858E-03,   4.7920006E-03
     +,   4.5828768E-03,   4.3842294E-03,   4.1954890E-03
     +,   4.0160990E-03,   3.8455455E-03,   3.6833182E-03
     +,   3.5289256E-03,   3.3819156E-03,   3.2418529E-03
     +,   3.1083184E-03,   2.9809184E-03,   2.8592870E-03
     +,   2.7430826E-03,   2.6319756E-03,   2.5256625E-03
     +,   2.4238660E-03,   2.3263171E-03,   2.2327797E-03
     +,   2.1430219E-03,   2.0568417E-03,   1.9740418E-03
     +,   1.8944511E-03,   1.8179019E-03,   1.7442500E-03
     +,   1.6733543E-03,   1.6050939E-03,   1.5393504E-03
     +,   1.4760176E-03,   1.4150016E-03,   1.3562093E-03
     +,   1.2995624E-03,   1.2449810E-03,   1.1923979E-03
     +,   1.1417443E-03,   1.0929616E-03,   1.0459895E-03
     +,   1.0007762E-03,   9.5726748E-04,   9.1541704E-04
     +,   8.7517488E-04,   8.3649851E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_hzonly_htt60_mass = Yx/11.4760509574468
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_hzonly_htt65_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  9.6348282E-03,   1.0434943E-02
     +,   1.1302447E-02,   1.2242115E-02,   1.3258814E-02
     +,   1.4357473E-02,   1.5543080E-02,   1.6820638E-02
     +,   1.8195152E-02,   1.9671710E-02,   2.1255376E-02
     +,   2.2951355E-02,   2.4764992E-02,   2.6701933E-02
     +,   2.8768329E-02,   3.0971115E-02,   3.3318408E-02
     +,   3.5820216E-02,   3.8489282E-02,   4.1342173E-02
     +,   4.4400860E-02,   4.7694240E-02,   5.1260032E-02
     +,   5.5146981E-02,   5.9415955E-02,   6.4142585E-02
     +,   6.9417723E-02,   7.5348929E-02,   8.2060643E-02
     +,   8.9693874E-02,   9.8404437E-02,   0.1083592    
     +,   0.1197293    ,   0.1326798    ,   0.1473570    
     +,   0.1638739    ,   0.1822971    ,   0.2026362    
     +,   0.2248382    ,   0.2487770    ,   0.2742518    
     +,   0.3009790    ,   0.3286118    ,   0.3568016    
     +,   0.3853234    ,   0.4142491    ,   0.4441080    
     +,   0.4759334    ,   0.5110955    ,   0.5508972    
     +,   0.5960233    ,   0.6460548    ,   0.6992846    
     +,   0.7530105    ,   0.8042825    ,   0.8508750    
     +,   0.8920736    ,   0.9289187    ,   0.9636732    
     +,   0.9986361    ,    1.034703    ,    1.070275    
     +,    1.101182    ,    1.121789    ,    1.126920    
     +,    1.113677    ,    1.082248    ,    1.035462    
     +,   0.9774914    ,   0.9126021    ,   0.8444251    
     +,   0.7758996    ,   0.7094582    ,   0.6471531    
     +,   0.5905292    ,   0.5404007    ,   0.4967453    
     +,   0.4588372    ,   0.4255830    ,   0.3959083    
     +,   0.3690124    ,   0.3444237    ,   0.3219171    
     +,   0.3013591    ,   0.2826029    ,   0.2654398    
     +,   0.2496211    ,   0.2348968    ,   0.2210584    
     +,   0.2079522    ,   0.1954828    ,   0.1836033    
     +,   0.1723031    ,   0.1615996    ,   0.1515297    
     +,   0.1421443    ,   0.1334964    ,   0.1256334    
     +,   0.1185846    ,   0.1123573    ,   0.1069310    
     +,   0.1022596    ,   9.8275088E-02,   9.4894096E-02
     +,   9.2024460E-02,   8.9572474E-02,   8.7448210E-02
     +,   8.5569568E-02,   8.3864801E-02,   8.2273573E-02
     +,   8.0747351E-02,   7.9248503E-02,   7.7749781E-02
     +,   7.6232255E-02,   7.4684933E-02,   7.3102802E-02
     +,   7.1486145E-02,   6.9838919E-02,   6.8168424E-02
     +,   6.6483907E-02,   6.4795904E-02,   6.3115932E-02
     +,   6.1455637E-02,   5.9826177E-02,   5.8238078E-02
     +,   5.6701150E-02,   5.5223662E-02,   5.3812906E-02
     +,   5.2474417E-02,   5.1212661E-02,   5.0030336E-02
     +,   4.8928998E-02,   4.7908679E-02,   4.6968393E-02
     +,   4.6105970E-02,   4.5318183E-02,   4.4601239E-02
     +,   4.3950602E-02,   4.3361269E-02,   4.2828016E-02
     +,   4.2345427E-02,   4.1908324E-02,   4.1511543E-02
     +,   4.1150343E-02,   4.0820505E-02,   4.0518239E-02
     +,   4.0240396E-02,   3.9984498E-02,   3.9748684E-02
     +,   3.9531667E-02,   3.9332788E-02,   3.9151892E-02
     +,   3.8989246E-02,   3.8845509E-02,   3.8721468E-02
     +,   3.8618159E-02,   3.8536634E-02,   3.8477767E-02
     +,   3.8442418E-02,   3.8431082E-02,   3.8443901E-02
     +,   3.8480729E-02,   3.8540855E-02,   3.8623121E-02
     +,   3.8725890E-02,   3.8846966E-02,   3.8983725E-02
     +,   3.9133009E-02,   3.9291311E-02,   3.9454736E-02
     +,   3.9619103E-02,   3.9779998E-02,   3.9932966E-02
     +,   4.0073462E-02,   4.0197007E-02,   4.0299360E-02
     +,   4.0376455E-02,   4.0424645E-02,   4.0440653E-02
     +,   4.0421769E-02,   4.0365763E-02,   4.0271007E-02
     +,   4.0136594E-02,   3.9962105E-02,   3.9747860E-02
     +,   3.9494712E-02,   3.9204150E-02,   3.8878135E-02
     +,   3.8519084E-02,   3.8129855E-02,   3.7713598E-02
     +,   3.7273638E-02,   3.6813546E-02,   3.6336906E-02
     +,   3.5847269E-02,   3.5348106E-02,   3.4842703E-02
     +,   3.4334175E-02,   3.3825308E-02,   3.3318542E-02
     +,   3.2816034E-02,   3.2319557E-02,   3.1830467E-02
     +,   3.1349748E-02,   3.0878015E-02,   3.0415621E-02
     +,   2.9962426E-02,   2.9518131E-02,   2.9082200E-02
     +,   2.8653804E-02,   2.8231939E-02,   2.7815547E-02
     +,   2.7403438E-02,   2.6994361E-02,   2.6587091E-02
     +,   2.6180396E-02,   2.5773151E-02,   2.5364250E-02
     +,   2.4952710E-02,   2.4537731E-02,   2.4118569E-02
     +,   2.3694659E-02,   2.3265619E-02,   2.2831187E-02
     +,   2.2391271E-02,   2.1945894E-02,   2.1495262E-02
     +,   2.1039709E-02,   2.0579644E-02,   2.0115603E-02
     +,   1.9648228E-02,   1.9178258E-02,   1.8706428E-02
     +,   1.8233553E-02,   1.7760498E-02,   1.7288124E-02
     +,   1.6817285E-02,   1.6348863E-02,   1.5883703E-02
     +,   1.5422619E-02,   1.4966375E-02,   1.4515715E-02
     +,   1.4071341E-02,   1.3633859E-02,   1.3203839E-02
     +,   1.2781787E-02,   1.2368176E-02,   1.1963366E-02
     +,   1.1567671E-02,   1.1181368E-02,   1.0804649E-02
     +,   1.0437647E-02,   1.0080465E-02,   9.7331600E-03
     +,   9.3957121E-03,   9.0680672E-03,   8.7501602E-03
     +,   8.4418776E-03,   8.1430729E-03,   7.8535648E-03
     +,   7.5731734E-03,   7.3017054E-03,   7.0389300E-03
     +,   6.7846095E-03,   6.5385243E-03,   6.3004224E-03
     +,   6.0700593E-03,   5.8471956E-03,   5.6315986E-03
     +,   5.4230257E-03,   5.2212384E-03,   5.0260173E-03
     +,   4.8371512E-03,   4.6544238E-03,   4.4776252E-03
     +,   4.3065744E-03,   4.1410765E-03,   3.9809635E-03
     +,   3.8260578E-03,   3.6762082E-03,   3.5312544E-03
     +,   3.3910617E-03,   3.2554823E-03,   3.1243952E-03
     +,   2.9976666E-03,   2.8751860E-03,   2.7568364E-03
     +,   2.6425039E-03,   2.5320917E-03,   2.4254911E-03
     +,   2.3226130E-03,   2.2233557E-03,   2.1276320E-03
     +,   2.0353491E-03,   1.9464234E-03,   1.8607642E-03
     +,   1.7782926E-03,   1.6989207E-03,   1.6225721E-03
     +,   1.5491613E-03,   1.4786132E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_hzonly_htt65_mass = Yx/9.84049956521739
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_hzonly_htt70_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  6.4956346E-03,   6.7792088E-03
     +,   7.0652785E-03,   7.3533081E-03,   7.6427832E-03
     +,   7.9332516E-03,   8.2243290E-03,   8.5157333E-03
     +,   8.8073062E-03,   9.0990718E-03,   9.3912445E-03
     +,   9.6842851E-03,   9.9789416E-03,   1.0276305E-02
     +,   1.0577851E-02,   1.0885471E-02,   1.1201545E-02
     +,   1.1528966E-02,   1.1871166E-02,   1.2232152E-02
     +,   1.2616497E-02,   1.3029365E-02,   1.3476445E-02
     +,   1.3963962E-02,   1.4498543E-02,   1.5087217E-02
     +,   1.5737267E-02,   1.6456135E-02,   1.7251341E-02
     +,   1.8130379E-02,   1.9100681E-02,   2.0169580E-02
     +,   2.1344462E-02,   2.2632916E-02,   2.4043011E-02
     +,   2.5583800E-02,   2.7265867E-02,   2.9101919E-02
     +,   3.1107653E-02,   3.3302043E-02,   3.5708178E-02
     +,   3.8353294E-02,   4.1268673E-02,   4.4489391E-02
     +,   4.8053876E-02,   5.2003443E-02,   5.6382291E-02
     +,   6.1238039E-02,   6.6622615E-02,   7.2593369E-02
     +,   7.9213113E-02,   8.6548567E-02,   9.4665103E-02
     +,   0.1036190    ,   0.1134449    ,   0.1241454    
     +,   0.1356823    ,   0.1479763    ,   0.1609205    
     +,   0.1744081    ,   0.1883763    ,   0.2028604    
     +,   0.2180461    ,   0.2343117    ,   0.2522340    
     +,   0.2725475    ,   0.2960537    ,   0.3234810    
     +,   0.3553357    ,   0.3917650    ,   0.4324908    
     +,   0.4768037    ,   0.5236554    ,   0.5717731    
     +,   0.6198037    ,   0.6664082    ,   0.7103003    
     +,   0.7502245    ,   0.7849049    ,   0.8130286    
     +,   0.8332971    ,   0.8446122    ,   0.8463103    
     +,   0.8384039    ,   0.8217000    ,   0.7977475    
     +,   0.7685971    ,   0.7364406    ,   0.7032386    
     +,   0.6704388    ,   0.6388412    ,   0.6086152    
     +,   0.5794289    ,   0.5506572    ,   0.5216313    
     +,   0.4918889    ,   0.4613461    ,   0.4303570    
     +,   0.3996131    ,   0.3699502    ,   0.3421153    
     +,   0.3166032    ,   0.2935847    ,   0.2729461    
     +,   0.2543849    ,   0.2375306    ,   0.2220439    
     +,   0.2076768    ,   0.1942901    ,   0.1818409    
     +,   0.1703514    ,   0.1598679    ,   0.1504305    
     +,   0.1420494    ,   0.1346972    ,   0.1283060    
     +,   0.1227771    ,   0.1179891    ,   0.1138107    
     +,   0.1101108    ,   0.1067678    ,   0.1036765    
     +,   0.1007523    ,   9.7932033E-02,   9.5173083E-02
     +,   9.2451021E-02,   8.9755103E-02,   8.7084688E-02
     +,   8.4445268E-02,   8.1845827E-02,   7.9296499E-02
     +,   7.6808110E-02,   7.4390680E-02,   7.2054312E-02
     +,   6.9808535E-02,   6.7662664E-02,   6.5625712E-02
     +,   6.3706510E-02,   6.1913021E-02,   6.0252272E-02
     +,   5.8730282E-02,   5.7351701E-02,   5.6119211E-02
     +,   5.5034101E-02,   5.4095864E-02,   5.3302195E-02
     +,   5.2649114E-02,   5.2131042E-02,   5.1740978E-02
     +,   5.1470499E-02,   5.1310048E-02,   5.1248908E-02
     +,   5.1275637E-02,   5.1378146E-02,   5.1543903E-02
     +,   5.1760305E-02,   5.2014839E-02,   5.2295391E-02
     +,   5.2590460E-02,   5.2889384E-02,   5.3182494E-02
     +,   5.3461250E-02,   5.3718317E-02,   5.3947605E-02
     +,   5.4144148E-02,   5.4304164E-02,   5.4424778E-02
     +,   5.4504015E-02,   5.4540537E-02,   5.4533508E-02
     +,   5.4482482E-02,   5.4387119E-02,   5.4247193E-02
     +,   5.4062378E-02,   5.3832442E-02,   5.3556874E-02
     +,   5.3235162E-02,   5.2866723E-02,   5.2451160E-02
     +,   5.1988091E-02,   5.1477373E-02,   5.0919332E-02
     +,   5.0314661E-02,   4.9664617E-02,   4.8971046E-02
     +,   4.8236411E-02,   4.7463961E-02,   4.6657439E-02
     +,   4.5821220E-02,   4.4960313E-02,   4.4080097E-02
     +,   4.3186296E-02,   4.2284925E-02,   4.1382108E-02
     +,   4.0483963E-02,   3.9596461E-02,   3.8725410E-02
     +,   3.7876278E-02,   3.7054066E-02,   3.6263309E-02
     +,   3.5508044E-02,   3.4791674E-02,   3.4116950E-02
     +,   3.3485994E-02,   3.2900311E-02,   3.2360729E-02
     +,   3.1867448E-02,   3.1420082E-02,   3.1017700E-02
     +,   3.0658733E-02,   3.0341208E-02,   3.0062634E-02
     +,   2.9820230E-02,   2.9610725E-02,   2.9430605E-02
     +,   2.9276071E-02,   2.9143183E-02,   2.9027812E-02
     +,   2.8925704E-02,   2.8832598E-02,   2.8744223E-02
     +,   2.8656352E-02,   2.8564880E-02,   2.8465813E-02
     +,   2.8355367E-02,   2.8229978E-02,   2.8086333E-02
     +,   2.7921464E-02,   2.7732681E-02,   2.7517669E-02
     +,   2.7274491E-02,   2.7001599E-02,   2.6697833E-02
     +,   2.6362445E-02,   2.5995124E-02,   2.5595911E-02
     +,   2.5165224E-02,   2.4703929E-02,   2.4213195E-02
     +,   2.3694502E-02,   2.3149619E-02,   2.2580611E-02
     +,   2.1989776E-02,   2.1379557E-02,   2.0752536E-02
     +,   2.0111449E-02,   1.9459100E-02,   1.8798281E-02
     +,   1.8131766E-02,   1.7462363E-02,   1.6792735E-02
     +,   1.6125444E-02,   1.5462962E-02,   1.4807612E-02
     +,   1.4161501E-02,   1.3526560E-02,   1.2904563E-02
     +,   1.2297091E-02,   1.1705476E-02,   1.1130855E-02
     +,   1.0574202E-02,   1.0036298E-02,   9.5177041E-03
     +,   9.0188123E-03,   8.5398965E-03,   8.0810385E-03
     +,   7.6421862E-03,   7.2231907E-03,   6.8237977E-03
     +,   6.4436290E-03,   6.0822275E-03,   5.7390998E-03
     +,   5.4136910E-03,   5.1053762E-03,   4.8135105E-03
     +,   4.5374469E-03,   4.2764856E-03,   4.0299627E-03
     +,   3.7971723E-03,   3.5774533E-03,   3.3701221E-03
     +,   3.1745401E-03,   2.9900596E-03,   2.8160783E-03
     +,   2.6519974E-03,   2.4972614E-03,   2.3513262E-03
     +,   2.2136760E-03,   2.0838338E-03,   1.9613316E-03
     +,   1.8457453E-03,   1.7366604E-03,   1.6337017E-03
     +,   1.5365034E-03,   1.4447365E-03,   1.3580815E-03
     +,   1.2762498E-03,   1.1989622E-03,   1.1259682E-03
     +,   1.0570232E-03,   9.9190860E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_hzonly_htt70_mass = Yx/8.0832675
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_hzonly_htt75_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.8746699E-03,   1.9842165E-03
     +,   2.1002148E-03,   2.2229550E-03,   2.3527290E-03
     +,   2.4898248E-03,   2.6345318E-03,   2.7871344E-03
     +,   2.9479116E-03,   3.1171453E-03,   3.2951084E-03
     +,   3.4820708E-03,   3.6782990E-03,   3.8840619E-03
     +,   4.0996275E-03,   4.3252702E-03,   4.5612687E-03
     +,   4.8079207E-03,   5.0655319E-03,   5.3344397E-03
     +,   5.6150011E-03,   5.9076101E-03,   6.2126946E-03
     +,   6.5307454E-03,   6.8622655E-03,   7.2078449E-03
     +,   7.5681126E-03,   7.9437466E-03,   8.3354879E-03
     +,   8.7441197E-03,   9.1704754E-03,   9.6154213E-03
     +,   1.0079859E-02,   1.0564698E-02,   1.1070863E-02
     +,   1.1599275E-02,   1.2150844E-02,   1.2726427E-02
     +,   1.3326918E-02,   1.3953101E-02,   1.4605820E-02
     +,   1.5285870E-02,   1.5994087E-02,   1.6731396E-02
     +,   1.7498855E-02,   1.8297762E-02,   1.9129731E-02
     +,   1.9996874E-02,   2.0901911E-02,   2.1848347E-02
     +,   2.2840658E-02,   2.3884423E-02,   2.4986472E-02
     +,   2.6155004E-02,   2.7399456E-02,   2.8730582E-02
     +,   3.0160073E-02,   3.1700384E-02,   3.3364262E-02
     +,   3.5164379E-02,   3.7112944E-02,   3.9221574E-02
     +,   4.1501120E-02,   4.3962236E-02,   4.6616010E-02
     +,   4.9474638E-02,   5.2553494E-02,   5.5871874E-02
     +,   5.9455853E-02,   6.3339360E-02,   6.7567363E-02
     +,   7.2196998E-02,   7.7300034E-02,   8.2961775E-02
     +,   8.9279629E-02,   9.6356876E-02,   0.1042930    
     +,   0.1131733    ,   0.1230613    ,   0.1339992    
     +,   0.1460207    ,   0.1591881    ,   0.1736390    
     +,   0.1896434    ,   0.2076407    ,   0.2282359    
     +,   0.2521177    ,   0.2799001    ,   0.3118879    
     +,   0.3478460    ,   0.3868481    ,   0.4273007    
     +,   0.4672028    ,   0.5045922    ,   0.5380406    
     +,   0.5670040    ,   0.5918783    ,   0.6136738    
     +,   0.6334438    ,   0.6516603    ,   0.6678114    
     +,   0.6804054    ,   0.6873822    ,   0.6867983    
     +,   0.6775106    ,   0.6595958    ,   0.6343558    
     +,   0.6039407    ,   0.5707601    ,   0.5369331    
     +,   0.5039537    ,   0.4726226    ,   0.4431975    
     +,   0.4156233    ,   0.3897582    ,   0.3655021    
     +,   0.3428546    ,   0.3218883    ,   0.3027029    
     +,   0.2853613    ,   0.2698486    ,   0.2560603    
     +,   0.2438167    ,   0.2329019    ,   0.2231056    
     +,   0.2142543    ,   0.2062226    ,   0.1989268    
     +,   0.1923041    ,   0.1862968    ,   0.1808350    
     +,   0.1758346    ,   0.1711983    ,   0.1668239    
     +,   0.1626123    ,   0.1584744    ,   0.1543371    
     +,   0.1501468    ,   0.1458711    ,   0.1415022    
     +,   0.1370563    ,   0.1325740    ,   0.1281164    
     +,   0.1237611    ,   0.1195960    ,   0.1157103    
     +,   0.1121865    ,   0.1090937    ,   0.1064805    
     +,   0.1043703    ,   0.1027610    ,   0.1016243    
     +,   0.1009088    ,   0.1005439    ,   0.1004455    
     +,   0.1005218    ,   0.1006786    ,   0.1008259    
     +,   0.1008818    ,   0.1007771    ,   0.1004575    
     +,   9.9885359E-02,   9.9040262E-02,   9.7917959E-02
     +,   9.6528880E-02,   9.4895601E-02,   9.3050085E-02
     +,   9.1031045E-02,   8.8880047E-02,   8.6639449E-02
     +,   8.4349878E-02,   8.2048684E-02,   7.9767972E-02
     +,   7.7534705E-02,   7.5370274E-02,   7.3290333E-02
     +,   7.1305647E-02,   6.9422625E-02,   6.7644075E-02
     +,   6.5969758E-02,   6.4397000E-02,   6.2921621E-02
     +,   6.1538029E-02,   6.0239635E-02,   5.9019230E-02
     +,   5.7869196E-02,   5.6781884E-02,   5.5749558E-02
     +,   5.4764643E-02,   5.3820278E-02,   5.2910089E-02
     +,   5.2028637E-02,   5.1171508E-02,   5.0335590E-02
     +,   4.9518876E-02,   4.8720662E-02,   4.7941599E-02
     +,   4.7183324E-02,   4.6448555E-02,   4.5740698E-02
     +,   4.5063645E-02,   4.4421542E-02,   4.3818489E-02
     +,   4.3258198E-02,   4.2743891E-02,   4.2277940E-02
     +,   4.1861832E-02,   4.1496031E-02,   4.1179884E-02
     +,   4.0911593E-02,   4.0688410E-02,   4.0506579E-02
     +,   4.0361568E-02,   4.0248148E-02,   4.0160637E-02
     +,   4.0093012E-02,   4.0039148E-02,   3.9992888E-02
     +,   3.9948344E-02,   3.9899822E-02,   3.9842114E-02
     +,   3.9770391E-02,   3.9680392E-02,   3.9568312E-02
     +,   3.9430939E-02,   3.9265499E-02,   3.9069731E-02
     +,   3.8841769E-02,   3.8580105E-02,   3.8283594E-02
     +,   3.7951328E-02,   3.7582722E-02,   3.7177306E-02
     +,   3.6734827E-02,   3.6255237E-02,   3.5738628E-02
     +,   3.5185222E-02,   3.4595463E-02,   3.3969991E-02
     +,   3.3309598E-02,   3.2615233E-02,   3.1888183E-02
     +,   3.1129917E-02,   3.0342110E-02,   2.9526643E-02
     +,   2.8685734E-02,   2.7821761E-02,   2.6937306E-02
     +,   2.6035085E-02,   2.5118105E-02,   2.4189381E-02
     +,   2.3252018E-02,   2.2309273E-02,   2.1364423E-02
     +,   2.0420674E-02,   1.9481173E-02,   1.8549077E-02
     +,   1.7627411E-02,   1.6719034E-02,   1.5826624E-02
     +,   1.4952725E-02,   1.4099702E-02,   1.3269623E-02
     +,   1.2464343E-02,   1.1685557E-02,   1.0934629E-02
     +,   1.0212692E-02,   9.5206890E-03,   8.8593159E-03
     +,   8.2290042E-03,   7.6299617E-03,   7.0622396E-03
     +,   6.5256860E-03,   6.0199322E-03,   5.5444585E-03
     +,   5.0986395E-03,   4.6816645E-03,   4.2926655E-03
     +,   3.9306250E-03,   3.5945012E-03,   3.2831414E-03
     +,   2.9953909E-03,   2.7300229E-03,   2.4858296E-03
     +,   2.2615620E-03,   2.0560098E-03,   1.8679550E-03
     +,   1.6962056E-03,   1.5396198E-03,   1.3970701E-03
     +,   1.2674953E-03,   1.1498622E-03,   1.0432053E-03
     +,   9.4659708E-04,   8.5917814E-04,   7.8013097E-04
     +,   7.0870452E-04,   6.4419105E-04,   5.8594474E-04
     +,   5.3336227E-04,   4.8589677E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_hzonly_htt75_mass = Yx/7.28162113636364
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_hzonly_htt80_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.6416117E-03,   2.7246124E-03
     +,   2.8088570E-03,   2.8943089E-03,   2.9809331E-03
     +,   3.0686948E-03,   3.1575635E-03,   3.2475071E-03
     +,   3.3384990E-03,   3.4305193E-03,   3.5235512E-03
     +,   3.6175861E-03,   3.7126218E-03,   3.8086686E-03
     +,   3.9057466E-03,   4.0038899E-03,   4.1031474E-03
     +,   4.2035845E-03,   4.3052854E-03,   4.4083544E-03
     +,   4.5129200E-03,   4.6191337E-03,   4.7271736E-03
     +,   4.8372522E-03,   4.9495981E-03,   5.0644884E-03
     +,   5.1822215E-03,   5.3031328E-03,   5.4275910E-03
     +,   5.5560013E-03,   5.6888014E-03,   5.8264588E-03
     +,   5.9694755E-03,   6.1183795E-03,   6.2737251E-03
     +,   6.4360849E-03,   6.6060461E-03,   6.7842086E-03
     +,   6.9711790E-03,   7.1675442E-03,   7.3738988E-03
     +,   7.5908001E-03,   7.8187827E-03,   8.0583431E-03
     +,   8.3099278E-03,   8.5739223E-03,   8.8506583E-03
     +,   9.1403890E-03,   9.4432924E-03,   9.7594662E-03
     +,   1.0088922E-02,   1.0431594E-02,   1.0787323E-02
     +,   1.1155892E-02,   1.1536981E-02,   1.1930237E-02
     +,   1.2335231E-02,   1.2751510E-02,   1.3178584E-02
     +,   1.3615970E-02,   1.4063184E-02,   1.4519816E-02
     +,   1.4985490E-02,   1.5459968E-02,   1.5943209E-02
     +,   1.6435331E-02,   1.6936818E-02,   1.7448490E-02
     +,   1.7971737E-02,   1.8508526E-02,   1.9061709E-02
     +,   1.9635057E-02,   2.0233590E-02,   2.0863723E-02
     +,   2.1533547E-02,   2.2253089E-02,   2.3034465E-02
     +,   2.3892144E-02,   2.4843231E-02,   2.5907513E-02
     +,   2.7107520E-02,   2.8468693E-02,   3.0019177E-02
     +,   3.1789891E-02,   3.3814002E-02,   3.6126949E-02
     +,   3.8765345E-02,   4.1767046E-02,   4.5169458E-02
     +,   4.9009129E-02,   5.3320400E-02,   5.8133788E-02
     +,   6.3475199E-02,   6.9365673E-02,   7.5821146E-02
     +,   8.2852766E-02,   9.0470351E-02,   9.8683558E-02
     +,   0.1075075    ,   0.1169642    ,   0.1270885    
     +,   0.1379280    ,   0.1495467    ,   0.1620228    
     +,   0.1754502    ,   0.1899344    ,   0.2055858    
     +,   0.2225096    ,   0.2407843    ,   0.2604275    
     +,   0.2813441    ,   0.3032777    ,   0.3257621    
     +,   0.3481218    ,   0.3695263    ,   0.3891209    
     +,   0.4062012    ,   0.4203813    ,   0.4316817    
     +,   0.4404899    ,   0.4473937    ,   0.4529506    
     +,   0.4574897    ,   0.4610266    ,   0.4633186    
     +,   0.4640143    ,   0.4628211    ,   0.4596114    
     +,   0.4544452    ,   0.4475234    ,   0.4391239    
     +,   0.4295490    ,   0.4190997    ,   0.4080679    
     +,   0.3967164    ,   0.3852591    ,   0.3738326    
     +,   0.3624792    ,   0.3511578    ,   0.3397793    
     +,   0.3282575    ,   0.3165496    ,   0.3046732    
     +,   0.2926968    ,   0.2807097    ,   0.2687905    
     +,   0.2569906    ,   0.2453392    ,   0.2338607    
     +,   0.2225981    ,   0.2116293    ,   0.2010691    
     +,   0.1910572    ,   0.1817347    ,   0.1732226    
     +,   0.1656015    ,   0.1588999    ,   0.1530903    
     +,   0.1480940    ,   0.1437915    ,   0.1400356    
     +,   0.1366674    ,   0.1335311    ,   0.1304876    
     +,   0.1274234    ,   0.1242574    ,   0.1209423    
     +,   0.1174618    ,   0.1138257    ,   0.1100626    
     +,   0.1062132    ,   0.1023231    ,   9.8437570E-02
     +,   9.4598323E-02,   9.0841815E-02,   8.7198377E-02
     +,   8.3692931E-02,   8.0346420E-02,   7.7176914E-02
     +,   7.4200444E-02,   7.1431644E-02,   6.8884656E-02
     +,   6.6572435E-02,   6.4506322E-02,   6.2695600E-02
     +,   6.1146971E-02,   5.9863776E-02,   5.8845758E-02
     +,   5.8088817E-02,   5.7585396E-02,   5.7324369E-02
     +,   5.7291921E-02,   5.7471883E-02,   5.7846431E-02
     +,   5.8396511E-02,   5.9102528E-02,   5.9944481E-02
     +,   6.0902249E-02,   6.1955903E-02,   6.3085362E-02
     +,   6.4270623E-02,   6.5491244E-02,   6.6726759E-02
     +,   6.7956127E-02,   6.9157846E-02,   7.0310131E-02
     +,   7.1390912E-02,   7.2378226E-02,   7.3250577E-02
     +,   7.3987529E-02,   7.4570149E-02,   7.4981555E-02
     +,   7.5207710E-02,   7.5237684E-02,   7.5064108E-02
     +,   7.4683666E-02,   7.4096948E-02,   7.3308572E-02
     +,   7.2326884E-02,   7.1163654E-02,   6.9833592E-02
     +,   6.8353593E-02,   6.6742383E-02,   6.5019600E-02
     +,   6.3205130E-02,   6.1318591E-02,   5.9378792E-02
     +,   5.7403449E-02,   5.5408463E-02,   5.3408030E-02
     +,   5.1414561E-02,   4.9438611E-02,   4.7488805E-02
     +,   4.5572057E-02,   4.3693997E-02,   4.1858710E-02
     +,   4.0069286E-02,   3.8327895E-02,   3.6636062E-02
     +,   3.4994632E-02,   3.3403989E-02,   3.1864334E-02
     +,   3.0375609E-02,   2.8937494E-02,   2.7549567E-02
     +,   2.6211359E-02,   2.4922326E-02,   2.3681790E-02
     +,   2.2488995E-02,   2.1343250E-02,   2.0243710E-02
     +,   1.9189462E-02,   1.8179640E-02,   1.7213320E-02
     +,   1.6289502E-02,   1.5407124E-02,   1.4565203E-02
     +,   1.3762716E-02,   1.2998570E-02,   1.2271672E-02
     +,   1.1580970E-02,   1.0925386E-02,   1.0303817E-02
     +,   9.7151324E-03,   9.1582602E-03,   8.6320769E-03
     +,   8.1354231E-03,   7.6671932E-03,   7.2262501E-03
     +,   6.8114316E-03,   6.4215763E-03,   6.0555367E-03
     +,   5.7121739E-03,   5.3903270E-03,   5.0888420E-03
     +,   4.8066154E-03,   4.5425207E-03,   4.2954902E-03
     +,   4.0644528E-03,   3.8483934E-03,   3.6463134E-03
     +,   3.4572773E-03,   3.2803640E-03,   3.1147245E-03
     +,   2.9595327E-03,   2.8140312E-03,   2.6774977E-03
     +,   2.5492571E-03,   2.4286970E-03,   2.3152323E-03
     +,   2.2083421E-03,   2.1075304E-03,   2.0123599E-03
     +,   1.9224164E-03,   1.8373345E-03,   1.7567722E-03
     +,   1.6804275E-03,   1.6080168E-03,   1.5392926E-03
     +,   1.4740202E-03,   1.4119948E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_hzonly_htt80_mass = Yx/6.31622762790698
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_hzonly_htt85_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.1808054E-03,   2.2111908E-03
     +,   2.2407973E-03,   2.2696371E-03,   2.2977302E-03
     +,   2.3251087E-03,   2.3518133E-03,   2.3778973E-03
     +,   2.4034260E-03,   2.4284786E-03,   2.4531449E-03
     +,   2.4775336E-03,   2.5017650E-03,   2.5259769E-03
     +,   2.5503235E-03,   2.5749768E-03,   2.6001248E-03
     +,   2.6259760E-03,   2.6527564E-03,   2.6807121E-03
     +,   2.7101082E-03,   2.7412288E-03,   2.7743771E-03
     +,   2.8098789E-03,   2.8480741E-03,   2.8893240E-03
     +,   2.9340072E-03,   2.9825175E-03,   3.0352648E-03
     +,   3.0926722E-03,   3.1551749E-03,   3.2232166E-03
     +,   3.2972484E-03,   3.3777244E-03,   3.4651007E-03
     +,   3.5598322E-03,   3.6623639E-03,   3.7731314E-03
     +,   3.8925610E-03,   4.0210467E-03,   4.1589732E-03
     +,   4.3066884E-03,   4.4645057E-03,   4.6327012E-03
     +,   4.8115067E-03,   5.0011049E-03,   5.2016252E-03
     +,   5.4131374E-03,   5.6356518E-03,   5.8691096E-03
     +,   6.1133881E-03,   6.3682874E-03,   6.6335378E-03
     +,   6.9088102E-03,   7.1936687E-03,   7.4876412E-03
     +,   7.7901720E-03,   8.1006326E-03,   8.4183486E-03
     +,   8.7425793E-03,   9.0725403E-03,   9.4074188E-03
     +,   9.7463476E-03,   1.0088469E-02,   1.0432922E-02
     +,   1.0778829E-02,   1.1125376E-02,   1.1471751E-02
     +,   1.1817262E-02,   1.2161240E-02,   1.2503187E-02
     +,   1.2842703E-02,   1.3179595E-02,   1.3513844E-02
     +,   1.3845712E-02,   1.4175764E-02,   1.4504907E-02
     +,   1.4834451E-02,   1.5166224E-02,   1.5502606E-02
     +,   1.5846556E-02,   1.6201820E-02,   1.6572824E-02
     +,   1.6964892E-02,   1.7384179E-02,   1.7837740E-02
     +,   1.8333461E-02,   1.8880075E-02,   1.9486928E-02
     +,   2.0163972E-02,   2.0921448E-02,   2.1769596E-02
     +,   2.2718359E-02,   2.3777081E-02,   2.4954138E-02
     +,   2.6256334E-02,   2.7688896E-02,   2.9254725E-02
     +,   3.0954616E-02,   3.2786462E-02,   3.4745812E-02
     +,   3.6825240E-02,   3.9015155E-02,   4.1303456E-02
     +,   4.3676879E-02,   4.6121426E-02,   4.8623752E-02
     +,   5.1173091E-02,   5.3763930E-02,   5.6398962E-02
     +,   5.9092510E-02,   6.1875079E-02,   6.4796224E-02
     +,   6.7928530E-02,   7.1367249E-02,   7.5229332E-02
     +,   7.9646699E-02,   8.4757537E-02,   9.0691186E-02
     +,   9.7553328E-02,   0.1054099    ,   0.1142733    
     +,   0.1240956    ,   0.1347726    ,   0.1461541    
     +,   0.1580664    ,   0.1703441    ,   0.1828619    
     +,   0.1955688    ,   0.2085069    ,   0.2218196    
     +,   0.2357307    ,   0.2505027    ,   0.2663709    
     +,   0.2834713    ,   0.3017735    ,   0.3210384    
     +,   0.3408118    ,   0.3604598    ,   0.3792292    
     +,   0.3963259    ,   0.4110016    ,   0.4226398    
     +,   0.4308361    ,   0.4354598    ,   0.4366889    
     +,   0.4349853    ,   0.4310069    ,   0.4254688    
     +,   0.4189919    ,   0.4119865    ,   0.4046130    
     +,   0.3968163    ,   0.3884182    ,   0.3792126    
     +,   0.3690361    ,   0.3577883    ,   0.3454262    
     +,   0.3319528    ,   0.3174207    ,   0.3019516    
     +,   0.2857611    ,   0.2691705    ,   0.2525901    
     +,   0.2364745    ,   0.2212679    ,   0.2073523    
     +,   0.1950074    ,   0.1843944    ,   0.1755591    
     +,   0.1684484    ,   0.1629289    ,   0.1588080    
     +,   0.1558543    ,   0.1538171    ,   0.1524433    
     +,   0.1514973    ,   0.1507774    ,   0.1501292    
     +,   0.1494521    ,   0.1486982    ,   0.1478655    
     +,   0.1469838    ,   0.1460993    ,   0.1452587    
     +,   0.1444978    ,   0.1438338    ,   0.1432631    
     +,   0.1427635    ,   0.1423009    ,   0.1418346    
     +,   0.1413249    ,   0.1407373    ,   0.1400446    
     +,   0.1392280    ,   0.1382750    ,   0.1371776    
     +,   0.1359294    ,   0.1345241    ,   0.1329535    
     +,   0.1312079    ,   0.1292752    ,   0.1271427    
     +,   0.1247976    ,   0.1222290    ,   0.1194293    
     +,   0.1163954    ,   0.1131308    ,   0.1096466    
     +,   0.1059625    ,   0.1021070    ,   9.8118216E-02
     +,   9.4042942E-02,   8.9934684E-02,   8.5852265E-02
     +,   8.1857532E-02,   7.8012206E-02,   7.4374177E-02
     +,   7.0995525E-02,   6.7919530E-02,   6.5178312E-02
     +,   6.2791422E-02,   6.0765788E-02,   5.9095100E-02
     +,   5.7761166E-02,   5.6735169E-02,   5.5979934E-02
     +,   5.5451989E-02,   5.5103995E-02,   5.4886997E-02
     +,   5.4752663E-02,   5.4655023E-02,   5.4551911E-02
     +,   5.4406174E-02,   5.4186329E-02,   5.3866994E-02
     +,   5.3428926E-02,   5.2858934E-02,   5.2149639E-02
     +,   5.1298767E-02,   5.0308805E-02,   4.9186211E-02
     +,   4.7940936E-02,   4.6585601E-02,   4.5134775E-02
     +,   4.3604605E-02,   4.2012073E-02,   4.0374275E-02
     +,   3.8708117E-02,   3.7029989E-02,   3.5355061E-02
     +,   3.3697121E-02,   3.2068513E-02,   3.0479813E-02
     +,   2.8939677E-02,   2.7454926E-02,   2.6030686E-02
     +,   2.4670362E-02,   2.3375748E-02,   2.2147242E-02
     +,   2.0984184E-02,   1.9884910E-02,   1.8846959E-02
     +,   1.7867304E-02,   1.6942680E-02,   1.6069513E-02
     +,   1.5244198E-02,   1.4463250E-02,   1.3723341E-02
     +,   1.3021323E-02,   1.2354308E-02,   1.1719759E-02
     +,   1.1115404E-02,   1.0539239E-02,   9.9895122E-03
     +,   9.4647659E-03,   8.9636901E-03,   8.4852027E-03
     +,   8.0283182E-03,   7.5922194E-03,   7.1761180E-03
     +,   6.7793643E-03,   6.4012837E-03,   6.0412930E-03
     +,   5.6987829E-03,   5.3731981E-03,   5.0639533E-03
     +,   4.7704661E-03,   4.4921893E-03,   4.2285277E-03
     +,   3.9789253E-03,   3.7427943E-03,   3.5195795E-03
     +,   3.3087004E-03,   3.1096127E-03,   2.9217545E-03
     +,   2.7445978E-03,   2.5776064E-03,   2.4202785E-03
     +,   2.2721072E-03,   2.1326228E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_hzonly_htt85_mass = Yx/5.9812761627907
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_hzonly_htt90_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.9930223E-03,   4.1325171E-03
     +,   4.2715552E-03,   4.4097560E-03,   4.5467382E-03
     +,   4.6821171E-03,   4.8155095E-03,   4.9465410E-03
     +,   5.0748363E-03,   5.2000401E-03,   5.3218016E-03
     +,   5.4397928E-03,   5.5536977E-03,   5.6632259E-03
     +,   5.7681096E-03,   5.8681075E-03,   5.9630084E-03
     +,   6.0526268E-03,   6.1368127E-03,   6.2154490E-03
     +,   6.2884544E-03,   6.3557820E-03,   6.4174212E-03
     +,   6.4734002E-03,   6.5237801E-03,   6.5686642E-03
     +,   6.6081844E-03,   6.6425144E-03,   6.6718576E-03
     +,   6.6964515E-03,   6.7165638E-03,   6.7324899E-03
     +,   6.7445538E-03,   6.7531005E-03,   6.7584980E-03
     +,   6.7611318E-03,   6.7614056E-03,   6.7597330E-03
     +,   6.7565357E-03,   6.7522428E-03,   6.7472886E-03
     +,   6.7421030E-03,   6.7371139E-03,   6.7327456E-03
     +,   6.7294040E-03,   6.7274882E-03,   6.7273821E-03
     +,   6.7294468E-03,   6.7340229E-03,   6.7414287E-03
     +,   6.7519546E-03,   6.7658643E-03,   6.7833867E-03
     +,   6.8047270E-03,   6.8300474E-03,   6.8594818E-03
     +,   6.8931296E-03,   6.9310493E-03,   6.9732685E-03
     +,   7.0197764E-03,   7.0705269E-03,   7.1254391E-03
     +,   7.1844002E-03,   7.2472640E-03,   7.3138587E-03
     +,   7.3839813E-03,   7.4574114E-03,   7.5338995E-03
     +,   7.6131956E-03,   7.6950262E-03,   7.7791270E-03
     +,   7.8652231E-03,   7.9530636E-03,   8.0424072E-03
     +,   8.1330473E-03,   8.2248142E-03,   8.3175879E-03
     +,   8.4113060E-03,   8.5059805E-03,   8.6017177E-03
     +,   8.6987121E-03,   8.7972805E-03,   8.8978596E-03
     +,   9.0010315E-03,   9.1075134E-03,   9.2182076E-03
     +,   9.3341628E-03,   9.4566196E-03,   9.5869750E-03
     +,   9.7268252E-03,   9.8779267E-03,   1.0042197E-02
     +,   1.0221688E-02,   1.0418606E-02,   1.0635244E-02
     +,   1.0873962E-02,   1.1137197E-02,   1.1427352E-02
     +,   1.1746864E-02,   1.2098080E-02,   1.2483312E-02
     +,   1.2904745E-02,   1.3364513E-02,   1.3864597E-02
     +,   1.4406951E-02,   1.4993471E-02,   1.5625972E-02
     +,   1.6306309E-02,   1.7036401E-02,   1.7818270E-02
     +,   1.8653968E-02,   1.9545726E-02,   2.0495791E-02
     +,   2.1506561E-02,   2.2580309E-02,   2.3719434E-02
     +,   2.4926027E-02,   2.6202286E-02,   2.7550135E-02
     +,   2.8971693E-02,   3.0469297E-02,   3.2045655E-02
     +,   3.3704340E-02,   3.5450336E-02,   3.7290361E-02
     +,   3.9233241E-02,   4.1290957E-02,   4.3478508E-02
     +,   4.5815211E-02,   4.8324525E-02,   5.1035121E-02
     +,   5.3980578E-02,   5.7200190E-02,   6.0737912E-02
     +,   6.4642422E-02,   6.8966150E-02,   7.3763736E-02
     +,   7.9091348E-02,   8.5006595E-02,   9.1568276E-02
     +,   9.8836362E-02,   0.1068726    ,   0.1157393    
     +,   0.1254946    ,   0.1361804    ,   0.1478085    
     +,   0.1603367    ,   0.1736456    ,   0.1875229    
     +,   0.2016658    ,   0.2157104    ,   0.2292928    
     +,   0.2421383    ,   0.2541554    ,   0.2655018    
     +,   0.2765937    ,   0.2880419    ,   0.3005139    
     +,   0.3145548    ,   0.3304138    ,   0.3479241    
     +,   0.3664657    ,   0.3850224    ,   0.4023256    
     +,   0.4170589    ,   0.4280832    ,   0.4346415    
     +,   0.4364949    ,   0.4339492    ,   0.4277623    
     +,   0.4189698    ,   0.4086744    ,   0.3978724    
     +,   0.3873491    ,   0.3776432    ,   0.3690546    
     +,   0.3616841    ,   0.3554851    ,   0.3503438    
     +,   0.3461642    ,   0.3429377    ,   0.3407526    
     +,   0.3397305    ,   0.3398978    ,   0.3410601    
     +,   0.3427301    ,   0.3441539    ,   0.3444311    
     +,   0.3426907    ,   0.3382666    ,   0.3308196    
     +,   0.3203780    ,   0.3072997    ,   0.2921788    
     +,   0.2757297    ,   0.2586807    ,   0.2417031    
     +,   0.2253640    ,   0.2101072    ,   0.1962501    
     +,   0.1839883    ,   0.1734031    ,   0.1644761    
     +,   0.1571098    ,   0.1511558    ,   0.1464402    
     +,   0.1427876    ,   0.1400397    ,   0.1380605    
     +,   0.1367372    ,   0.1359718    ,   0.1356723    
     +,   0.1357438    ,   0.1360814    ,   0.1365692    
     +,   0.1370807    ,   0.1374846    ,   0.1376516    
     +,   0.1374618    ,   0.1368117    ,   0.1356207    
     +,   0.1338335    ,   0.1314236    ,   0.1283924    
     +,   0.1247676    ,   0.1206001    ,   0.1159606    
     +,   0.1109348    ,   0.1056183    ,   0.1001119    
     +,   9.4517641E-02,   8.8933900E-02,   8.3451234E-02
     +,   7.8149661E-02,   7.3096544E-02,   6.8344124E-02
     +,   6.3929357E-02,   5.9874013E-02,   5.6185573E-02
     +,   5.2858487E-02,   4.9876492E-02,   4.7215324E-02
     +,   4.4844821E-02,   4.2731252E-02,   4.0839680E-02
     +,   3.9135717E-02,   3.7586875E-02,   3.6163379E-02
     +,   3.4838811E-02,   3.3590589E-02,   3.2399580E-02
     +,   3.1250183E-02,   3.0129997E-02,   2.9029565E-02
     +,   2.7941776E-02,   2.6861779E-02,   2.5786579E-02
     +,   2.4714777E-02,   2.3646200E-02,   2.2581784E-02
     +,   2.1523338E-02,   2.0473367E-02,   1.9434778E-02
     +,   1.8410802E-02,   1.7404934E-02,   1.6420573E-02
     +,   1.5461066E-02,   1.4529590E-02,   1.3629065E-02
     +,   1.2761990E-02,   1.1930478E-02,   1.1136262E-02
     +,   1.0380626E-02,   9.6643623E-03,   8.9878375E-03
     +,   8.3510606E-03,   7.7535878E-03,   7.1947123E-03
     +,   6.6733551E-03,   6.1882595E-03,   5.7378965E-03
     +,   5.3206407E-03,   4.9347016E-03,   4.5782649E-03
     +,   4.2494354E-03,   3.9463611E-03,   3.6671876E-03
     +,   3.4101137E-03,   3.1734298E-03,   2.9554837E-03
     +,   2.7547455E-03,   2.5697595E-03,   2.3992001E-03
     +,   2.2418234E-03,   2.0965089E-03,   1.9622163E-03
     +,   1.8380181E-03,   1.7230561E-03,   1.6165704E-03
     +,   1.5178600E-03,   1.4263041E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_hzonly_htt90_mass = Yx/6.11799104651163
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_hzonly_htt95_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.5943310E-03,   2.6791280E-03
     +,   2.7645673E-03,   2.8505498E-03,   2.9369742E-03
     +,   3.0237378E-03,   3.1107371E-03,   3.1978688E-03
     +,   3.2850257E-03,   3.3721081E-03,   3.4590110E-03
     +,   3.5456328E-03,   3.6318756E-03,   3.7176404E-03
     +,   3.8028371E-03,   3.8873735E-03,   3.9711664E-03
     +,   4.0541342E-03,   4.1362043E-03,   4.2173071E-03
     +,   4.2973827E-03,   4.3763760E-03,   4.4542388E-03
     +,   4.5309416E-03,   4.6064458E-03,   4.6807388E-03
     +,   4.7538127E-03,   4.8256665E-03,   4.8963157E-03
     +,   4.9657845E-03,   5.0341114E-03,   5.1013459E-03
     +,   5.1675509E-03,   5.2328045E-03,   5.2971947E-03
     +,   5.3608282E-03,   5.4238238E-03,   5.4863156E-03
     +,   5.5484539E-03,   5.6103980E-03,   5.6723291E-03
     +,   5.7344385E-03,   5.7969363E-03,   5.8600409E-03
     +,   5.9239860E-03,   5.9890184E-03,   6.0553965E-03
     +,   6.1233896E-03,   6.1932751E-03,   6.2653385E-03
     +,   6.3398690E-03,   6.4171655E-03,   6.4975191E-03
     +,   6.5812343E-03,   6.6686007E-03,   6.7599034E-03
     +,   6.8554282E-03,   6.9554374E-03,   7.0601911E-03
     +,   7.1699242E-03,   7.2848541E-03,   7.4051744E-03
     +,   7.5310539E-03,   7.6626330E-03,   7.8000301E-03
     +,   7.9433089E-03,   8.0925282E-03,   8.2476838E-03
     +,   8.4087579E-03,   8.5756732E-03,   8.7483404E-03
     +,   8.9266151E-03,   9.1103278E-03,   9.2992643E-03
     +,   9.4931889E-03,   9.6918456E-03,   9.8949252E-03
     +,   1.0102109E-02,   1.0313064E-02,   1.0527439E-02
     +,   1.0744850E-02,   1.0964941E-02,   1.1187300E-02
     +,   1.1411563E-02,   1.1637315E-02,   1.1864193E-02
     +,   1.2091785E-02,   1.2319737E-02,   1.2547657E-02
     +,   1.2775180E-02,   1.3001962E-02,   1.3227630E-02
     +,   1.3451830E-02,   1.3674232E-02,   1.3894496E-02
     +,   1.4112268E-02,   1.4327244E-02,   1.4539071E-02
     +,   1.4747458E-02,   1.4952083E-02,   1.5152677E-02
     +,   1.5348979E-02,   1.5540789E-02,   1.5727933E-02
     +,   1.5910346E-02,   1.6088035E-02,   1.6261136E-02
     +,   1.6429920E-02,   1.6594866E-02,   1.6756656E-02
     +,   1.6916204E-02,   1.7074754E-02,   1.7233858E-02
     +,   1.7395422E-02,   1.7561788E-02,   1.7735722E-02
     +,   1.7920462E-02,   1.8119751E-02,   1.8337784E-02
     +,   1.8579330E-02,   1.8849637E-02,   1.9154429E-02
     +,   1.9499870E-02,   1.9892566E-02,   2.0339465E-02
     +,   2.0847762E-02,   2.1424936E-02,   2.2078510E-02
     +,   2.2816135E-02,   2.3645325E-02,   2.4573514E-02
     +,   2.5607837E-02,   2.6755154E-02,   2.8021699E-02
     +,   2.9413057E-02,   3.0934047E-02,   3.2588076E-02
     +,   3.4377109E-02,   3.6301281E-02,   3.8358524E-02
     +,   4.0543970E-02,   4.2849947E-02,   4.5266088E-02
     +,   4.7779571E-02,   5.0375547E-02,   5.3038929E-02
     +,   5.5755824E-02,   5.8515545E-02,   6.1313257E-02
     +,   6.4152576E-02,   6.7047328E-02,   7.0022821E-02
     +,   7.3116012E-02,   7.6374404E-02,   7.9852909E-02
     +,   8.3609439E-02,   8.7699488E-02,   9.2170991E-02
     +,   9.7059123E-02,   0.1023820    ,   0.1081402    
     +,   0.1143170    ,   0.1208815    ,   0.1277932    
     +,   0.1350079    ,   0.1424811    ,   0.1501694    
     +,   0.1580281    ,   0.1660063    ,   0.1740374    
     +,   0.1820306    ,   0.1898708    ,   0.1974292    
     +,   0.2045902    ,   0.2112936    ,   0.2175901    
     +,   0.2236906    ,   0.2300027    ,   0.2371401    
     +,   0.2458998    ,   0.2572061    ,   0.2720318    
     +,   0.2913000    ,   0.3157682    ,   0.3458750    
     +,   0.3815495    ,   0.4220080    ,   0.4656263    
     +,   0.5099720    ,   0.5520717    ,   0.5888786    
     +,   0.6177997    ,   0.6371574    ,   0.6464737    
     +,   0.6464968    ,   0.6388992    ,   0.6256957    
     +,   0.6085697    ,   0.5884566    ,   0.5656603    
     +,   0.5404126    ,   0.5134705    ,   0.4862872    
     +,   0.4606279    ,   0.4378749    ,   0.4184888    
     +,   0.4019375    ,   0.3870672    ,   0.3726522    
     +,   0.3578257    ,   0.3422452    ,   0.3260127    
     +,   0.3094680    ,   0.2929821    ,   0.2768249    
     +,   0.2611161    ,   0.2458491    ,   0.2309521    
     +,   0.2163634    ,   0.2020923    ,   0.1882455    
     +,   0.1750216    ,   0.1626777    ,   0.1514733    
     +,   0.1416175    ,   0.1332310    ,   0.1263300    
     +,   0.1208301    ,   0.1165686    ,   0.1133342    
     +,   0.1108961    ,   0.1090273    ,   0.1075195    
     +,   0.1061905    ,   0.1048869    ,   0.1034834    
     +,   0.1018811    ,   0.1000077    ,   9.7815879E-02
     +,   9.5283486E-02,   9.2412293E-02,   8.9226231E-02
     +,   8.5768066E-02,   8.2094543E-02,   7.8271262E-02
     +,   7.4367501E-02,   7.0450597E-02,   6.6581368E-02
     +,   6.2811263E-02,   5.9180617E-02,   5.5717390E-02
     +,   5.2438129E-02,   4.9349330E-02,   4.6449255E-02
     +,   4.3729838E-02,   4.1179042E-02,   3.8782921E-02
     +,   3.6526978E-02,   3.4397267E-02,   3.2381371E-02
     +,   3.0468866E-02,   2.8651340E-02,   2.6922179E-02
     +,   2.5276467E-02,   2.3710759E-02,   2.2222495E-02
     +,   2.0809716E-02,   1.9470958E-02,   1.8204875E-02
     +,   1.7009983E-02,   1.5884625E-02,   1.4827022E-02
     +,   1.3835112E-02,   1.2906532E-02,   1.2038695E-02
     +,   1.1228930E-02,   1.0474342E-02,   9.7720316E-03
     +,   9.1189863E-03,   8.5122818E-03,   7.9489583E-03
     +,   7.4261916E-03,   6.9411849E-03,   6.4913137E-03
     +,   6.0740095E-03,   5.6868875E-03,   5.3276471E-03
     +,   4.9941293E-03,   4.6843369E-03,   4.3963604E-03
     +,   4.1284594E-03,   3.8789806E-03,   3.6464278E-03
     +,   3.4293914E-03,   3.2266013E-03,   3.0368718E-03
     +,   2.8591440E-03,   2.6924321E-03,   2.5358640E-03
     +,   2.3886338E-03,   2.2500311E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_hzonly_htt95_mass = Yx/6.466614
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_hzonly_ttz100_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.5621322E-03,   2.6286806E-03
     +,   2.6936925E-03,   2.7570059E-03,   2.8184685E-03
     +,   2.8779379E-03,   2.9352854E-03,   2.9903927E-03
     +,   3.0431591E-03,   3.0934988E-03,   3.1413415E-03
     +,   3.1866366E-03,   3.2293524E-03,   3.2694764E-03
     +,   3.3070161E-03,   3.3420001E-03,   3.3744797E-03
     +,   3.4045258E-03,   3.4322315E-03,   3.4577118E-03
     +,   3.4811043E-03,   3.5025640E-03,   3.5222711E-03
     +,   3.5404214E-03,   3.5572313E-03,   3.5729359E-03
     +,   3.5877852E-03,   3.6020449E-03,   3.6159975E-03
     +,   3.6299343E-03,   3.6441584E-03,   3.6589839E-03
     +,   3.6747276E-03,   3.6917147E-03,   3.7102727E-03
     +,   3.7307283E-03,   3.7534076E-03,   3.7786297E-03
     +,   3.8067128E-03,   3.8379573E-03,   3.8726600E-03
     +,   3.9110971E-03,   3.9535332E-03,   4.0002083E-03
     +,   4.0513435E-03,   4.1071344E-03,   4.1677491E-03
     +,   4.2333291E-03,   4.3039802E-03,   4.3797791E-03
     +,   4.4607660E-03,   4.5469445E-03,   4.6382770E-03
     +,   4.7346987E-03,   4.8360904E-03,   4.9423045E-03
     +,   5.0531495E-03,   5.1683984E-03,   5.2877818E-03
     +,   5.4109986E-03,   5.5377129E-03,   5.6675561E-03
     +,   5.8001275E-03,   5.9350100E-03,   6.0717664E-03
     +,   6.2099285E-03,   6.3490388E-03,   6.4886101E-03
     +,   6.6281790E-03,   6.7672660E-03,   6.9054249E-03
     +,   7.0422138E-03,   7.1772258E-03,   7.3100785E-03
     +,   7.4404371E-03,   7.5680153E-03,   7.6925689E-03
     +,   7.8139128E-03,   7.9319319E-03,   8.0465795E-03
     +,   8.1578754E-03,   8.2659172E-03,   8.3708744E-03
     +,   8.4730079E-03,   8.5726408E-03,   8.6701829E-03
     +,   8.7661063E-03,   8.8609662E-03,   8.9553669E-03
     +,   9.0499753E-03,   9.1455122E-03,   9.2427209E-03
     +,   9.3423780E-03,   9.4452780E-03,   9.5522134E-03
     +,   9.6639525E-03,   9.7812507E-03,   9.9048074E-03
     +,   1.0035265E-02,   1.0173184E-02,   1.0319051E-02
     +,   1.0473224E-02,   1.0635970E-02,   1.0807397E-02
     +,   1.0987493E-02,   1.1176101E-02,   1.1372896E-02
     +,   1.1577400E-02,   1.1788991E-02,   1.2006893E-02
     +,   1.2230169E-02,   1.2457770E-02,   1.2688499E-02
     +,   1.2921091E-02,   1.3154139E-02,   1.3386240E-02
     +,   1.3615897E-02,   1.3841636E-02,   1.4061986E-02
     +,   1.4275538E-02,   1.4480954E-02,   1.4677024E-02
     +,   1.4862656E-02,   1.5036956E-02,   1.5199225E-02
     +,   1.5348995E-02,   1.5486034E-02,   1.5610390E-02
     +,   1.5722413E-02,   1.5822707E-02,   1.5912209E-02
     +,   1.5992140E-02,   1.6064024E-02,   1.6129674E-02
     +,   1.6191173E-02,   1.6250875E-02,   1.6311372E-02
     +,   1.6375463E-02,   1.6446181E-02,   1.6526736E-02
     +,   1.6620515E-02,   1.6731057E-02,   1.6862074E-02
     +,   1.7017445E-02,   1.7201195E-02,   1.7417563E-02
     +,   1.7670967E-02,   1.7966053E-02,   1.8307719E-02
     +,   1.8701108E-02,   1.9151675E-02,   1.9665074E-02
     +,   2.0247180E-02,   2.0904064E-02,   2.1641815E-02
     +,   2.2466414E-02,   2.3383453E-02,   2.4398042E-02
     +,   2.5514446E-02,   2.6735619E-02,   2.8063141E-02
     +,   2.9496823E-02,   3.1034440E-02,   3.2671612E-02
     +,   3.4402113E-02,   3.6218047E-02,   3.8110252E-02
     +,   4.0069204E-02,   4.2086363E-02,   4.4155192E-02
     +,   4.6272829E-02,   4.8441585E-02,   5.0671089E-02
     +,   5.2979674E-02,   5.5395860E-02,   5.7960272E-02
     +,   6.0726583E-02,   6.3761905E-02,   6.7147061E-02
     +,   7.0975348E-02,   7.5350367E-02,   8.0382660E-02
     +,   8.6186707E-02,   9.2880592E-02,   0.1005874    
     +,   0.1094409    ,   0.1195933    ,   0.1312211    
     +,   0.1445200    ,   0.1596837    ,   0.1768696    
     +,   0.1961558    ,   0.2175122    ,   0.2408072    
     +,   0.2658644    ,   0.2925462    ,   0.3208448    
     +,   0.3510062    ,   0.3837801    ,   0.4208214    
     +,   0.4650188    ,   0.5202905    ,   0.5906716    
     +,   0.6790883    ,   0.7861076    ,   0.9082569    
     +,    1.036584    ,    1.158855    ,    1.267103    
     +,    1.363767    ,    1.457451    ,    1.551753    
     +,    1.641276    ,    1.719230    ,    1.783798    
     +,    1.833292    ,    1.860212    ,    1.856936    
     +,    1.824789    ,    1.772376    ,    1.705324    
     +,    1.620639    ,    1.514298    ,    1.394855    
     +,    1.282944    ,    1.192625    ,    1.117851    
     +,    1.041605    ,   0.9544576    ,   0.8608963    
     +,   0.7711582    ,   0.6913648    ,   0.6209115    
     +,   0.5560085    ,   0.4940633    ,   0.4354467    
     +,   0.3825110    ,   0.3375538    ,   0.3014012    
     +,   0.2732214    ,   0.2511657    ,   0.2331670    
     +,   0.2174735    ,   0.2028498    ,   0.1885553    
     +,   0.1742333    ,   0.1597916    ,   0.1453078    
     +,   0.1309611    ,   0.1169802    ,   0.1035993    
     +,   9.1027670E-02,   7.9429433E-02,   6.8912297E-02
     +,   5.9525147E-02,   5.1263612E-02,   4.4080060E-02
     +,   3.7894502E-02,   3.2606430E-02,   2.8106680E-02
     +,   2.4286699E-02,   2.1044711E-02,   1.8289465E-02
     +,   1.5942074E-02,   1.3936163E-02,   1.2216276E-02
     +,   1.0736618E-02,   9.4594536E-03,   8.3535248E-03
     +,   7.3927450E-03,   6.5553160E-03,   5.8230110E-03
     +,   5.1804888E-03,   4.6148081E-03,   4.1150884E-03
     +,   3.6722301E-03,   3.2785356E-03,   2.9275871E-03
     +,   2.6139454E-03,   2.3330708E-03,   2.0810915E-03
     +,   1.8547578E-03,   1.6512664E-03,   1.4682389E-03
     +,   1.3035939E-03,   1.1555374E-03,   1.0224776E-03
     +,   9.0300426E-04,   7.9586770E-04,   6.9992914E-04
     +,   6.1416952E-04,   5.3764920E-04,   4.6951903E-04
     +,   4.0899060E-04,   3.5534686E-04,   3.0792074E-04
     +,   2.6610389E-04,   2.2933062E-04,   1.9708546E-04
     +,   1.6889060E-04,   1.4431177E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_hzonly_ttz100_mass = Yx/12.2953221702128
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_hzonly_ttz105_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.5098394E-03,   2.5896945E-03
     +,   2.6718962E-03,   2.7565046E-03,   2.8435765E-03
     +,   2.9331665E-03,   3.0253239E-03,   3.1200985E-03
     +,   3.2175281E-03,   3.3176532E-03,   3.4205061E-03
     +,   3.5261104E-03,   3.6344859E-03,   3.7456446E-03
     +,   3.8595931E-03,   3.9763288E-03,   4.0958421E-03
     +,   4.2181145E-03,   4.3431194E-03,   4.4708261E-03
     +,   4.6011908E-03,   4.7341636E-03,   4.8696860E-03
     +,   5.0076977E-03,   5.1481174E-03,   5.2908715E-03
     +,   5.4358714E-03,   5.5830241E-03,   5.7322253E-03
     +,   5.8833733E-03,   6.0363538E-03,   6.1910478E-03
     +,   6.3473331E-03,   6.5050786E-03,   6.6641527E-03
     +,   6.8244124E-03,   6.9857109E-03,   7.1478966E-03
     +,   7.3108128E-03,   7.4742874E-03,   7.6381536E-03
     +,   7.8022270E-03,   7.9663126E-03,   8.1302123E-03
     +,   8.2937116E-03,   8.4565859E-03,   8.6185932E-03
     +,   8.7794829E-03,   8.9389933E-03,   9.0968329E-03
     +,   9.2527093E-03,   9.4062993E-03,   9.5572714E-03
     +,   9.7052837E-03,   9.8499572E-03,   9.9909203E-03
     +,   1.0127765E-02,   1.0260089E-02,   1.0387470E-02
     +,   1.0509475E-02,   1.0625668E-02,   1.0735601E-02
     +,   1.0838845E-02,   1.0934959E-02,   1.1023520E-02
     +,   1.1104108E-02,   1.1176339E-02,   1.1239845E-02
     +,   1.1294285E-02,   1.1339346E-02,   1.1374779E-02
     +,   1.1400364E-02,   1.1415943E-02,   1.1421405E-02
     +,   1.1416721E-02,   1.1401912E-02,   1.1377084E-02
     +,   1.1342415E-02,   1.1298167E-02,   1.1244677E-02
     +,   1.1182377E-02,   1.1111781E-02,   1.1033492E-02
     +,   1.0948198E-02,   1.0856668E-02,   1.0759762E-02
     +,   1.0658414E-02,   1.0553628E-02,   1.0446494E-02
     +,   1.0338150E-02,   1.0229792E-02,   1.0122663E-02
     +,   1.0018054E-02,   9.9172713E-03,   9.8216394E-03
     +,   9.7324932E-03,   9.6511487E-03,   9.5789125E-03
     +,   9.5170457E-03,   9.4667645E-03,   9.4292210E-03
     +,   9.4054807E-03,   9.3965298E-03,   9.4032343E-03
     +,   9.4263563E-03,   9.4665149E-03,   9.5241833E-03
     +,   9.5996959E-03,   9.6932119E-03,   9.8047303E-03
     +,   9.9340826E-03,   1.0080921E-02,   1.0244716E-02
     +,   1.0424786E-02,   1.0620262E-02,   1.0830141E-02
     +,   1.1053246E-02,   1.1288295E-02,   1.1533856E-02
     +,   1.1788418E-02,   1.2050396E-02,   1.2318112E-02
     +,   1.2589869E-02,   1.2863957E-02,   1.3138687E-02
     +,   1.3412368E-02,   1.3683408E-02,   1.3950247E-02
     +,   1.4211473E-02,   1.4465752E-02,   1.4711928E-02
     +,   1.4948949E-02,   1.5175972E-02,   1.5392288E-02
     +,   1.5597387E-02,   1.5790947E-02,   1.5972804E-02
     +,   1.6142976E-02,   1.6301669E-02,   1.6449247E-02
     +,   1.6586214E-02,   1.6713217E-02,   1.6831052E-02
     +,   1.6940616E-02,   1.7042896E-02,   1.7138978E-02
     +,   1.7230015E-02,   1.7317239E-02,   1.7401915E-02
     +,   1.7485343E-02,   1.7568879E-02,   1.7653892E-02
     +,   1.7741768E-02,   1.7833941E-02,   1.7931849E-02
     +,   1.8036947E-02,   1.8150732E-02,   1.8274698E-02
     +,   1.8410398E-02,   1.8559372E-02,   1.8723218E-02
     +,   1.8903546E-02,   1.9101970E-02,   1.9320130E-02
     +,   1.9559702E-02,   1.9822350E-02,   2.0109745E-02
     +,   2.0423554E-02,   2.0765509E-02,   2.1137342E-02
     +,   2.1540873E-02,   2.1977983E-02,   2.2450771E-02
     +,   2.2961583E-02,   2.3513084E-02,   2.4108486E-02
     +,   2.4751712E-02,   2.5447562E-02,   2.6202029E-02
     +,   2.7022665E-02,   2.7918914E-02,   2.8902339E-02
     +,   2.9987257E-02,   3.1190850E-02,   3.2533601E-02
     +,   3.4039218E-02,   3.5734646E-02,   3.7650034E-02
     +,   3.9817978E-02,   4.2272788E-02,   4.5049828E-02
     +,   4.8184130E-02,   5.1708780E-02,   5.5653326E-02
     +,   6.0042392E-02,   6.4893551E-02,   7.0215382E-02
     +,   7.6007470E-02,   8.2260974E-02,   8.8961624E-02
     +,   9.6094854E-02,   0.1036544    ,   0.1116544    
     +,   0.1201428    ,   0.1292143    ,   0.1390269    
     +,   0.1498108    ,   0.1618719    ,   0.1755850    
     +,   0.1913736    ,   0.2096698    ,   0.2308552    
     +,   0.2551883    ,   0.2827240    ,   0.3132393    
     +,   0.3461917    ,   0.3807666    ,   0.4161128    
     +,   0.4518708    ,   0.4889834    ,   0.5303906    
     +,   0.5807593    ,   0.6445888    ,   0.7233646    
     +,   0.8140288    ,   0.9108165    ,    1.009537    
     +,    1.110449    ,    1.217086    ,    1.332568    
     +,    1.456461    ,    1.582654    ,    1.699413    
     +,    1.795634    ,    1.870405    ,    1.932628    
     +,    1.986679    ,    2.021082    ,    2.015522    
     +,    1.958333    ,    1.856944    ,    1.734692    
     +,    1.617428    ,    1.518346    ,    1.432937    
     +,    1.347934    ,    1.253687    ,    1.148697    
     +,    1.036346    ,   0.9205390    ,   0.8044010    
     +,   0.6911051    ,   0.5842618    ,   0.4871563    
     +,   0.4018388    ,   0.3288732    ,   0.2676699    
     +,   0.2169834    ,   0.1753166    ,   0.1411866    
     +,   0.1132735    ,   9.0482257E-02,   7.1938634E-02
     +,   5.6944769E-02,   4.4923589E-02,   3.5371739E-02
     +,   2.7840918E-02,   2.1935515E-02,   1.7316220E-02
     +,   1.3702865E-02,   1.0872525E-02,   8.6524570E-03
     +,   6.9103637E-03,   5.5447407E-03,   4.4768881E-03
     +,   3.6448014E-03,   2.9986720E-03,   2.4982928E-03
     +,   2.1110366E-03,   1.8107058E-03,   1.5764185E-03
     +,   1.3918405E-03,   1.2443458E-03,   1.1243687E-03
     +,   1.0247364E-03,   9.4017171E-04,   8.6681824E-04
     +,   8.0189668E-04,   7.4342790E-04,   6.9000520E-04
     +,   6.4064784E-04,   5.9466786E-04,   5.5159593E-04
     +,   5.1110476E-04,   4.7297403E-04,   4.3704669E-04
     +,   4.0321401E-04,   3.7138996E-04,   3.4150734E-04
     +,   3.1350201E-04,   2.8731514E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_hzonly_ttz105_mass = Yx/12.5079574468085
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_hzonly_ttz107_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.1195358E-03,   2.1726170E-03
     +,   2.2264239E-03,   2.2809708E-03,   2.3362723E-03
     +,   2.3923467E-03,   2.4492140E-03,   2.5068962E-03
     +,   2.5654151E-03,   2.6247986E-03,   2.6850724E-03
     +,   2.7462649E-03,   2.8084046E-03,   2.8715222E-03
     +,   2.9356463E-03,   3.0008082E-03,   3.0670364E-03
     +,   3.1343596E-03,   3.2028039E-03,   3.2723942E-03
     +,   3.3431523E-03,   3.4150972E-03,   3.4882408E-03
     +,   3.5625985E-03,   3.6381704E-03,   3.7149596E-03
     +,   3.7929567E-03,   3.8721513E-03,   3.9525232E-03
     +,   4.0340424E-03,   4.1166772E-03,   4.2003836E-03
     +,   4.2851102E-03,   4.3707970E-03,   4.4573802E-03
     +,   4.5447848E-03,   4.6329279E-03,   4.7217212E-03
     +,   4.8110751E-03,   4.9008811E-03,   4.9910410E-03
     +,   5.0814427E-03,   5.1719765E-03,   5.2625299E-03
     +,   5.3529865E-03,   5.4432359E-03,   5.5331676E-03
     +,   5.6226715E-03,   5.7116477E-03,   5.8000009E-03
     +,   5.8876383E-03,   5.9744827E-03,   6.0604620E-03
     +,   6.1455145E-03,   6.2295897E-03,   6.3126548E-03
     +,   6.3946829E-03,   6.4756596E-03,   6.5555880E-03
     +,   6.6344808E-03,   6.7123612E-03,   6.7892694E-03
     +,   6.8652453E-03,   6.9403499E-03,   7.0146457E-03
     +,   7.0882016E-03,   7.1610906E-03,   7.2333878E-03
     +,   7.3051676E-03,   7.3765055E-03,   7.4474663E-03
     +,   7.5181131E-03,   7.5884950E-03,   7.6586488E-03
     +,   7.7285995E-03,   7.7983583E-03,   7.8679090E-03
     +,   7.9372237E-03,   8.0062421E-03,   8.0748945E-03
     +,   8.1430795E-03,   8.2106665E-03,   8.2775084E-03
     +,   8.3434358E-03,   8.4082382E-03,   8.4717097E-03
     +,   8.5335989E-03,   8.5936515E-03,   8.6515835E-03
     +,   8.7071136E-03,   8.7599326E-03,   8.8097304E-03
     +,   8.8561978E-03,   8.8990191E-03,   8.9378832E-03
     +,   8.9724865E-03,   9.0025393E-03,   9.0277633E-03
     +,   9.0479041E-03,   9.0627316E-03,   9.0720402E-03
     +,   9.0756565E-03,   9.0734409E-03,   9.0652946E-03
     +,   9.0511488E-03,   9.0309922E-03,   9.0048453E-03
     +,   8.9727789E-03,   8.9349113E-03,   8.8914046E-03
     +,   8.8424794E-03,   8.7883957E-03,   8.7294625E-03
     +,   8.6660385E-03,   8.5985325E-03,   8.5273935E-03
     +,   8.4531223E-03,   8.3762584E-03,   8.2973838E-03
     +,   8.2171215E-03,   8.1361327E-03,   8.0551151E-03
     +,   7.9748137E-03,   7.8959875E-03,   7.8194384E-03
     +,   7.7459998E-03,   7.6765367E-03,   7.6119285E-03
     +,   7.5530889E-03,   7.5009582E-03,   7.4564866E-03
     +,   7.4206502E-03,   7.3944386E-03,   7.3788520E-03
     +,   7.3748957E-03,   7.3835850E-03,   7.4059232E-03
     +,   7.4429102E-03,   7.4955295E-03,   7.5647435E-03
     +,   7.6514785E-03,   7.7566206E-03,   7.8809969E-03
     +,   8.0253836E-03,   8.1904782E-03,   8.3768899E-03
     +,   8.5851429E-03,   8.8156462E-03,   9.0686809E-03
     +,   9.3444334E-03,   9.6429568E-03,   9.9641643E-03
     +,   1.0307834E-02,   1.0673639E-02,   1.1061169E-02
     +,   1.1469865E-02,   1.1899142E-02,   1.2348372E-02
     +,   1.2816974E-02,   1.3304373E-02,   1.3810181E-02
     +,   1.4334185E-02,   1.4876449E-02,   1.5437365E-02
     +,   1.6017841E-02,   1.6619284E-02,   1.7243708E-02
     +,   1.7893802E-02,   1.8573012E-02,   1.9285567E-02
     +,   2.0036368E-02,   2.0831022E-02,   2.1675784E-02
     +,   2.2577351E-02,   2.3542600E-02,   2.4578499E-02
     +,   2.5691759E-02,   2.6888454E-02,   2.8173739E-02
     +,   2.9551730E-02,   3.1025019E-02,   3.2594539E-02
     +,   3.4259453E-02,   3.6017273E-02,   3.7863903E-02
     +,   3.9793715E-02,   4.1800033E-02,   4.3875653E-02
     +,   4.6013251E-02,   4.8205543E-02,   5.0446227E-02
     +,   5.2729934E-02,   5.5052534E-02,   5.7411261E-02
     +,   5.9805043E-02,   6.2234361E-02,   6.4701214E-02
     +,   6.7209981E-02,   6.9768131E-02,   7.2387472E-02
     +,   7.5085737E-02,   7.7888601E-02,   8.0832042E-02
     +,   8.3964050E-02,   8.7345719E-02,   9.1052443E-02
     +,   9.5173612E-02,   9.9812798E-02,   0.1050888    
     +,   0.1111380    ,   0.1181181    ,   0.1262093    
     +,   0.1356140    ,   0.1465490    ,   0.1592295    
     +,   0.1738463    ,   0.1905444    ,   0.2094081    
     +,   0.2304578    ,   0.2536645    ,   0.2789947    
     +,   0.3064622    ,   0.3361532    ,   0.3681906    
     +,   0.4026462    ,   0.4394861    ,   0.4787094    
     +,   0.5207577    ,   0.5671564    ,   0.6211050    
     +,   0.6873366    ,   0.7704728    ,   0.8720742    
     +,   0.9884369    ,    1.111740    ,    1.235081    
     +,    1.358613    ,    1.491804    ,    1.646247    
     +,    1.818659    ,    1.979797    ,    2.092345    
     +,    2.147159    ,    2.170297    ,    2.187493    
     +,    2.193269    ,    2.161509    ,    2.079089    
     +,    1.962851    ,    1.843890    ,    1.738104    
     +,    1.632842    ,    1.501128    ,    1.328236    
     +,    1.124707    ,   0.9166840    ,   0.7278095    
     +,   0.5694528    ,   0.4421475    ,   0.3413830    
     +,   0.2619254    ,   0.1994811    ,   0.1508266    
     +,   0.1134465    ,   8.5189819E-02,   6.4117692E-02
     +,   4.8525266E-02,   3.7001312E-02,   2.8445682E-02
     +,   2.2037989E-02,   1.7183220E-02,   1.3456478E-02
     +,   1.0557014E-02,   8.2735354E-03,   6.4584659E-03
     +,   5.0085080E-03,   3.8497464E-03,   2.9276400E-03
     +,   2.1996971E-03,   1.6313618E-03,   1.1933735E-03
     +,   8.6068694E-04,   6.1178365E-04,   4.2847122E-04
     +,   2.9559428E-04,   2.0082682E-04,   1.3433304E-04
     +,   8.8442699E-05,   5.7301135E-05,   3.6523652E-05
     +,   2.2899174E-05,   1.4119458E-05,   8.5612473E-06
     +,   5.1044581E-06,   2.9929740E-06,   1.7261559E-06
     +,   9.7971292E-07,   5.4766139E-07,   3.0198200E-07
     +,   1.6466124E-07,   8.9169717E-08
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_hzonly_ttz107_mass = Yx/12.541312
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_hzonly_ttz110_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.7317735E-03,   3.8873646E-03
     +,   4.0474231E-03,   4.2118649E-03,   4.3805763E-03
     +,   4.5534284E-03,   4.7302661E-03,   4.9109091E-03
     +,   5.0951531E-03,   5.2827764E-03,   5.4735239E-03
     +,   5.6671230E-03,   5.8632744E-03,   6.0616550E-03
     +,   6.2619206E-03,   6.4637065E-03,   6.6666296E-03
     +,   6.8702847E-03,   7.0742513E-03,   7.2780987E-03
     +,   7.4813780E-03,   7.6836343E-03,   7.8843990E-03
     +,   8.0832113E-03,   8.2795909E-03,   8.4730769E-03
     +,   8.6632064E-03,   8.8495156E-03,   9.0315640E-03
     +,   9.2089167E-03,   9.3811629E-03,   9.5479107E-03
     +,   9.7087855E-03,   9.8634567E-03,   1.0011607E-02
     +,   1.0152960E-02,   1.0287276E-02,   1.0414347E-02
     +,   1.0534022E-02,   1.0646167E-02,   1.0750716E-02
     +,   1.0847628E-02,   1.0936926E-02,   1.1018665E-02
     +,   1.1092953E-02,   1.1159943E-02,   1.1219835E-02
     +,   1.1272871E-02,   1.1319339E-02,   1.1359563E-02
     +,   1.1393911E-02,   1.1422787E-02,   1.1446625E-02
     +,   1.1465893E-02,   1.1481088E-02,   1.1492723E-02
     +,   1.1501337E-02,   1.1507482E-02,   1.1511717E-02
     +,   1.1514611E-02,   1.1516733E-02,   1.1518650E-02
     +,   1.1520919E-02,   1.1524091E-02,   1.1528690E-02
     +,   1.1535229E-02,   1.1544177E-02,   1.1555999E-02
     +,   1.1571101E-02,   1.1589864E-02,   1.1612629E-02
     +,   1.1639685E-02,   1.1671272E-02,   1.1707595E-02
     +,   1.1748786E-02,   1.1794944E-02,   1.1846098E-02
     +,   1.1902224E-02,   1.1963254E-02,   1.2029053E-02
     +,   1.2099425E-02,   1.2174147E-02,   1.2252925E-02
     +,   1.2335414E-02,   1.2421228E-02,   1.2509945E-02
     +,   1.2601094E-02,   1.2694176E-02,   1.2788648E-02
     +,   1.2883956E-02,   1.2979527E-02,   1.3074752E-02
     +,   1.3169037E-02,   1.3261758E-02,   1.3352317E-02
     +,   1.3440109E-02,   1.3524542E-02,   1.3605043E-02
     +,   1.3681066E-02,   1.3752082E-02,   1.3817622E-02
     +,   1.3877217E-02,   1.3930478E-02,   1.3977027E-02
     +,   1.4016566E-02,   1.4048832E-02,   1.4073611E-02
     +,   1.4090763E-02,   1.4100193E-02,   1.4101851E-02
     +,   1.4095767E-02,   1.4082016E-02,   1.4060720E-02
     +,   1.4032071E-02,   1.3996307E-02,   1.3953690E-02
     +,   1.3904571E-02,   1.3849299E-02,   1.3788288E-02
     +,   1.3721976E-02,   1.3650822E-02,   1.3575324E-02
     +,   1.3495996E-02,   1.3413368E-02,   1.3327972E-02
     +,   1.3240361E-02,   1.3151076E-02,   1.3060678E-02
     +,   1.2969702E-02,   1.2878691E-02,   1.2788174E-02
     +,   1.2698673E-02,   1.2610680E-02,   1.2524698E-02
     +,   1.2441195E-02,   1.2360631E-02,   1.2283456E-02
     +,   1.2210096E-02,   1.2140983E-02,   1.2076518E-02
     +,   1.2017116E-02,   1.1963171E-02,   1.1915095E-02
     +,   1.1873284E-02,   1.1838166E-02,   1.1810161E-02
     +,   1.1789712E-02,   1.1777295E-02,   1.1773407E-02
     +,   1.1778562E-02,   1.1793333E-02,   1.1818330E-02
     +,   1.1854196E-02,   1.1901636E-02,   1.1961414E-02
     +,   1.2034353E-02,   1.2121343E-02,   1.2223358E-02
     +,   1.2341471E-02,   1.2476825E-02,   1.2630702E-02
     +,   1.2804522E-02,   1.2999848E-02,   1.3218404E-02
     +,   1.3462158E-02,   1.3733310E-02,   1.4034342E-02
     +,   1.4368020E-02,   1.4737539E-02,   1.5146456E-02
     +,   1.5598772E-02,   1.6098954E-02,   1.6651994E-02
     +,   1.7263407E-02,   1.7939165E-02,   1.8685745E-02
     +,   1.9510118E-02,   2.0419536E-02,   2.1421505E-02
     +,   2.2523735E-02,   2.3733903E-02,   2.5059443E-02
     +,   2.6507325E-02,   2.8084006E-02,   2.9795147E-02
     +,   3.1645183E-02,   3.3637296E-02,   3.5773285E-02
     +,   3.8053323E-02,   4.0475599E-02,   4.3036584E-02
     +,   4.5730952E-02,   4.8551291E-02,   5.1488597E-02
     +,   5.4532737E-02,   5.7672739E-02,   6.0897235E-02
     +,   6.4195536E-02,   6.7558706E-02,   7.0980474E-02
     +,   7.4457876E-02,   7.7992417E-02,   8.1590578E-02
     +,   8.5263595E-02,   8.9026675E-02,   9.2898518E-02
     +,   9.6899465E-02,   0.1010504    ,   0.1053718    
     +,   0.1098854    ,   0.1146150    ,   0.1195913    
     +,   0.1248558    ,   0.1304676    ,   0.1365064    
     +,   0.1430738    ,   0.1502920    ,   0.1583025    
     +,   0.1672627    ,   0.1773491    ,   0.1887657    
     +,   0.2017549    ,   0.2165983    ,   0.2335987    
     +,   0.2530238    ,   0.2750036    ,   0.2993972    
     +,   0.3256738    ,   0.3528771    ,   0.3797526    
     +,   0.4050734    ,   0.4281105    ,   0.4490601    
     +,   0.4691780    ,   0.4905073    ,   0.5153451    
     +,   0.5457898    ,   0.5836465    ,   0.6305815    
     +,   0.6881520    ,   0.7574644    ,   0.8387205    
     +,   0.9311527    ,    1.033698    ,    1.146272    
     +,    1.270721    ,    1.410124    ,    1.565866    
     +,    1.733626    ,    1.901414    ,    2.052961    
     +,    2.176388    ,    2.270734    ,    2.340224    
     +,    2.379197    ,    2.365943    ,    2.275899    
     +,    2.100916    ,    1.855847    ,    1.570493    
     +,    1.277635    ,    1.004326    ,   0.7675077    
     +,   0.5735359    ,   0.4210041    ,   0.3047100    
     +,   0.2184954    ,   0.1562879    ,   0.1123339    
     +,   8.1495926E-02,   5.9649639E-02,   4.3859974E-02
     +,   3.2231987E-02,   2.3591226E-02,   1.7181192E-02
     +,   1.2465571E-02,   9.0294974E-03,   6.5436694E-03
     +,   4.7502485E-03,   3.4549746E-03,   2.5162206E-03
     +,   1.8333937E-03,   1.3353794E-03,   9.7169145E-04
     +,   7.0591999E-04,   5.1160838E-04,   3.6942895E-04
     +,   2.6532909E-04,   1.8914801E-04,   1.3353299E-04
     +,   9.3150877E-05,   6.4077532E-05,   4.3391388E-05
     +,   2.8884138E-05,   1.8880379E-05,   1.2108495E-05
     +,   7.6146684E-06,   4.6934911E-06,   2.8347231E-06
     +,   1.6772349E-06,   9.7208147E-07
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_hzonly_ttz110_mass = Yx/12.2390363617021
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_hzonly_ttz115_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  7.1786419E-03,   7.4742348E-03
     +,   7.7772834E-03,   8.0877850E-03,   8.4057124E-03
     +,   8.7310616E-03,   9.0638073E-03,   9.4039300E-03
     +,   9.7513963E-03,   1.0106187E-02,   1.0468263E-02
     +,   1.0837587E-02,   1.1214124E-02,   1.1597828E-02
     +,   1.1988651E-02,   1.2386530E-02,   1.2791413E-02
     +,   1.3203231E-02,   1.3621898E-02,   1.4047327E-02
     +,   1.4479415E-02,   1.4918039E-02,   1.5363050E-02
     +,   1.5814291E-02,   1.6271554E-02,   1.6734632E-02
     +,   1.7203247E-02,   1.7677097E-02,   1.8155830E-02
     +,   1.8639049E-02,   1.9126277E-02,   1.9617004E-02
     +,   2.0110622E-02,   2.0606490E-02,   2.1103838E-02
     +,   2.1601854E-02,   2.2099640E-02,   2.2596182E-02
     +,   2.3090433E-02,   2.3581214E-02,   2.4067281E-02
     +,   2.4547337E-02,   2.5019987E-02,   2.5483759E-02
     +,   2.5937168E-02,   2.6378639E-02,   2.6806621E-02
     +,   2.7219512E-02,   2.7615724E-02,   2.7993705E-02
     +,   2.8351923E-02,   2.8688913E-02,   2.9003305E-02
     +,   2.9293818E-02,   2.9559314E-02,   2.9798776E-02
     +,   3.0011402E-02,   3.0196523E-02,   3.0353691E-02
     +,   3.0482702E-02,   3.0583531E-02,   3.0656451E-02
     +,   3.0701941E-02,   3.0720731E-02,   3.0713839E-02
     +,   3.0682504E-02,   3.0628219E-02,   3.0552698E-02
     +,   3.0457895E-02,   3.0345958E-02,   3.0219218E-02
     +,   3.0080175E-02,   2.9931448E-02,   2.9775804E-02
     +,   2.9616054E-02,   2.9455094E-02,   2.9295804E-02
     +,   2.9141074E-02,   2.8993735E-02,   2.8856557E-02
     +,   2.8732177E-02,   2.8623115E-02,   2.8531654E-02
     +,   2.8459938E-02,   2.8409820E-02,   2.8382974E-02
     +,   2.8380694E-02,   2.8404035E-02,   2.8453715E-02
     +,   2.8530112E-02,   2.8633272E-02,   2.8762875E-02
     +,   2.8918287E-02,   2.9098507E-02,   2.9302204E-02
     +,   2.9527744E-02,   2.9773133E-02,   3.0036198E-02
     +,   3.0314455E-02,   3.0605195E-02,   3.0905602E-02
     +,   3.1212643E-02,   3.1523269E-02,   3.1834338E-02
     +,   3.2142740E-02,   3.2445427E-02,   3.2739457E-02
     +,   3.3022001E-02,   3.3290502E-02,   3.3542622E-02
     +,   3.3776294E-02,   3.3989783E-02,   3.4181688E-02
     +,   3.4351021E-02,   3.4497123E-02,   3.4619808E-02
     +,   3.4719221E-02,   3.4795895E-02,   3.4850810E-02
     +,   3.4885202E-02,   3.4900673E-02,   3.4899138E-02
     +,   3.4882691E-02,   3.4853674E-02,   3.4814525E-02
     +,   3.4767851E-02,   3.4716215E-02,   3.4662228E-02
     +,   3.4608413E-02,   3.4557141E-02,   3.4510672E-02
     +,   3.4471072E-02,   3.4440104E-02,   3.4419265E-02
     +,   3.4409840E-02,   3.4412671E-02,   3.4428399E-02
     +,   3.4457255E-02,   3.4499176E-02,   3.4553800E-02
     +,   3.4620441E-02,   3.4698188E-02,   3.4785863E-02
     +,   3.4882151E-02,   3.4985498E-02,   3.5094284E-02
     +,   3.5206825E-02,   3.5321437E-02,   3.5436392E-02
     +,   3.5550129E-02,   3.5661206E-02,   3.5768330E-02
     +,   3.5870444E-02,   3.5966810E-02,   3.6056928E-02
     +,   3.6140718E-02,   3.6218464E-02,   3.6290877E-02
     +,   3.6359079E-02,   3.6424741E-02,   3.6489960E-02
     +,   3.6557350E-02,   3.6630105E-02,   3.6711890E-02
     +,   3.6806826E-02,   3.6919702E-02,   3.7055615E-02
     +,   3.7220247E-02,   3.7419621E-02,   3.7660129E-02
     +,   3.7948422E-02,   3.8291309E-02,   3.8695667E-02
     +,   3.9168324E-02,   3.9715774E-02,   4.0344238E-02
     +,   4.1059215E-02,   4.1865479E-02,   4.2766809E-02
     +,   4.3765832E-02,   4.4864021E-02,   4.6061315E-02
     +,   4.7356367E-02,   4.8746616E-02,   5.0228320E-02
     +,   5.1796984E-02,   5.3447753E-02,   5.5176094E-02
     +,   5.6978475E-02,   5.8853049E-02,   6.0800709E-02
     +,   6.2826164E-02,   6.4938344E-02,   6.7151472E-02
     +,   6.9485798E-02,   7.1967781E-02,   7.4630052E-02
     +,   7.7510849E-02,   8.0653667E-02,   8.4105499E-02
     +,   8.7915353E-02,   9.2131883E-02,   9.6801616E-02
     +,   0.1019664    ,   0.1076609    ,   0.1139116    
     +,   0.1207353    ,   0.1281382    ,   0.1361160    
     +,   0.1446556    ,   0.1537352    ,   0.1633250    
     +,   0.1733893    ,   0.1838885    ,   0.1947806    
     +,   0.2060237    ,   0.2175821    ,   0.2294327    
     +,   0.2415738    ,   0.2540324    ,   0.2668748    
     +,   0.2802097    ,   0.2941903    ,   0.3090123    
     +,   0.3249078    ,   0.3421385    ,   0.3609733    
     +,   0.3816652    ,   0.4044107    ,   0.4293022    
     +,   0.4562860    ,   0.4851523    ,   0.5155646    
     +,   0.5471289    ,   0.5794722    ,   0.6123149    
     +,   0.6454735    ,   0.6788114    ,   0.7121598    
     +,   0.7452386    ,   0.7776358    ,   0.8088343    
     +,   0.8383068    ,   0.8656566    ,   0.8907703    
     +,   0.9139531    ,   0.9359679    ,   0.9579102    
     +,   0.9808461    ,    1.005278    ,    1.030620    
     +,    1.054883    ,    1.074770    ,    1.086189    
     +,    1.085031    ,    1.067971    ,    1.033093    
     +,   0.9801940    ,   0.9108032    ,   0.8279482    
     +,   0.7357635    ,   0.6389700    ,   0.5423163    
     +,   0.4500546    ,   0.3655418    ,   0.2909880    
     +,   0.2274438    ,   0.1749465    ,   0.1327676    
     +,   9.9697992E-02,   7.4313000E-02,   5.5172089E-02
     +,   4.0946178E-02,   3.0485971E-02,   2.2846026E-02
     +,   1.7278932E-02,   1.3211831E-02,   1.0219443E-02
     +,   7.9934094E-03,   6.3156635E-03,   5.0340942E-03
     +,   4.0437109E-03,   3.2715211E-03,   2.6660236E-03
     +,   2.1896532E-03,   1.8141544E-03,   1.5175019E-03
     +,   1.2822005E-03,   1.0942508E-03,   9.4245240E-04
     +,   8.1800547E-04,   7.1410643E-04,   6.2565610E-04
     +,   5.4892473E-04,   4.8128853E-04,   4.2094901E-04
     +,   3.6672363E-04,   3.1784142E-04,   2.7380892E-04
     +,   2.3428505E-04,   1.9901489E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_hzonly_ttz115_mass = Yx/9.83410963043478
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_hzonly_ttz120_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  8.7395459E-03,   9.1334814E-03
     +,   9.5353965E-03,   9.9447379E-03,   1.0360925E-02
     +,   1.0783341E-02,   1.1211352E-02,   1.1644306E-02
     +,   1.2081510E-02,   1.2522305E-02,   1.2965999E-02
     +,   1.3411907E-02,   1.3859377E-02,   1.4307737E-02
     +,   1.4756373E-02,   1.5204701E-02,   1.5652144E-02
     +,   1.6098207E-02,   1.6542416E-02,   1.6984366E-02
     +,   1.7423727E-02,   1.7860206E-02,   1.8293582E-02
     +,   1.8723737E-02,   1.9150585E-02,   1.9574160E-02
     +,   1.9994531E-02,   2.0411849E-02,   2.0826371E-02
     +,   2.1238409E-02,   2.1648321E-02,   2.2056563E-02
     +,   2.2463655E-02,   2.2870118E-02,   2.3276608E-02
     +,   2.3683751E-02,   2.4092253E-02,   2.4502818E-02
     +,   2.4916174E-02,   2.5333062E-02,   2.5754213E-02
     +,   2.6180336E-02,   2.6612142E-02,   2.7050270E-02
     +,   2.7495308E-02,   2.7947811E-02,   2.8408241E-02
     +,   2.8876983E-02,   2.9354278E-02,   2.9840305E-02
     +,   3.0335087E-02,   3.0838536E-02,   3.1350374E-02
     +,   3.1870212E-02,   3.2397468E-02,   3.2931395E-02
     +,   3.3471059E-02,   3.4015346E-02,   3.4562971E-02
     +,   3.5112429E-02,   3.5662107E-02,   3.6210120E-02
     +,   3.6754448E-02,   3.7292976E-02,   3.7823398E-02
     +,   3.8343277E-02,   3.8850110E-02,   3.9341286E-02
     +,   3.9814174E-02,   4.0266111E-02,   4.0694434E-02
     +,   4.1096549E-02,   4.1469995E-02,   4.1812312E-02
     +,   4.2121314E-02,   4.2394951E-02,   4.2631429E-02
     +,   4.2829189E-02,   4.2987071E-02,   4.3104120E-02
     +,   4.3179795E-02,   4.3213941E-02,   4.3206796E-02
     +,   4.3158982E-02,   4.3071538E-02,   4.2945936E-02
     +,   4.2784005E-02,   4.2587999E-02,   4.2360574E-02
     +,   4.2104639E-02,   4.1823473E-02,   4.1520633E-02
     +,   4.1199878E-02,   4.0865224E-02,   4.0520664E-02
     +,   4.0170461E-02,   3.9818782E-02,   3.9469797E-02
     +,   3.9127585E-02,   3.8796082E-02,   3.8479019E-02
     +,   3.8179878E-02,   3.7901834E-02,   3.7647694E-02
     +,   3.7419945E-02,   3.7220530E-02,   3.7051048E-02
     +,   3.6912609E-02,   3.6805760E-02,   3.6730636E-02
     +,   3.6686774E-02,   3.6673266E-02,   3.6688719E-02
     +,   3.6731284E-02,   3.6798649E-02,   3.6888096E-02
     +,   3.6996547E-02,   3.7120655E-02,   3.7256680E-02
     +,   3.7400782E-02,   3.7548944E-02,   3.7697002E-02
     +,   3.7840813E-02,   3.7976239E-02,   3.8099203E-02
     +,   3.8205866E-02,   3.8292553E-02,   3.8355898E-02
     +,   3.8392793E-02,   3.8400568E-02,   3.8377006E-02
     +,   3.8320296E-02,   3.8229175E-02,   3.8102828E-02
     +,   3.7941061E-02,   3.7744179E-02,   3.7513103E-02
     +,   3.7249245E-02,   3.6954533E-02,   3.6631469E-02
     +,   3.6283035E-02,   3.5912625E-02,   3.5524059E-02
     +,   3.5121489E-02,   3.4709416E-02,   3.4292523E-02
     +,   3.3875730E-02,   3.3464022E-02,   3.3062465E-02
     +,   3.2676052E-02,   3.2309733E-02,   3.1968217E-02
     +,   3.1656049E-02,   3.1377409E-02,   3.1136123E-02
     +,   3.0935645E-02,   3.0778894E-02,   3.0668303E-02
     +,   3.0605776E-02,   3.0592617E-02,   3.0629562E-02
     +,   3.0716736E-02,   3.0853758E-02,   3.1039605E-02
     +,   3.1272784E-02,   3.1551383E-02,   3.1872991E-02
     +,   3.2234952E-02,   3.2634337E-02,   3.3068068E-02
     +,   3.3533089E-02,   3.4026403E-02,   3.4545198E-02
     +,   3.5087161E-02,   3.5650309E-02,   3.6233399E-02
     +,   3.6835987E-02,   3.7458509E-02,   3.8102433E-02
     +,   3.8770482E-02,   3.9466728E-02,   4.0196642E-02
     +,   4.0967125E-02,   4.1786883E-02,   4.2666372E-02
     +,   4.3617588E-02,   4.4654500E-02,   4.5792814E-02
     +,   4.7050022E-02,   4.8445113E-02,   4.9998473E-02
     +,   5.1731586E-02,   5.3666200E-02,   5.5823870E-02
     +,   5.8225013E-02,   6.0887825E-02,   6.3826732E-02
     +,   6.7050911E-02,   7.0563309E-02,   7.4358627E-02
     +,   7.8422301E-02,   8.2729712E-02,   8.7246813E-02
     +,   9.1930524E-02,   9.6730426E-02,   0.1015930    
     +,   0.1064653    ,   0.1113003    ,   0.1160628    
     +,   0.1207359    ,   0.1253257    ,   0.1298650    
     +,   0.1344149    ,   0.1390654    ,   0.1439298    
     +,   0.1491391    ,   0.1548329    ,   0.1611508    
     +,   0.1682211    ,   0.1761521    ,   0.1850259    
     +,   0.1948940    ,   0.2057736    ,   0.2176478    
     +,   0.2304659    ,   0.2441416    ,   0.2585526    
     +,   0.2735400    ,   0.2889193    ,   0.3044904    
     +,   0.3200621    ,   0.3354868    ,   0.3506954    
     +,   0.3657263    ,   0.3807326    ,   0.3959729    
     +,   0.4117710    ,   0.4284621    ,   0.4463463    
     +,   0.4656570    ,   0.4865561    ,   0.5091478    
     +,   0.5335045    ,   0.5596771    ,   0.5876753    
     +,   0.6174096    ,   0.6486182    ,   0.6807916    
     +,   0.7131095    ,   0.7444218    ,   0.7732855    
     +,   0.7980400    ,   0.8169267    ,   0.8282505    
     +,   0.8305345    ,   0.8226779    ,   0.8040811    
     +,   0.7747363    ,   0.7352606    ,   0.6868688    
     +,   0.6313006    ,   0.5706758    ,   0.5073181    
     +,   0.4435573    ,   0.3815474    ,   0.3230958    
     +,   0.2695643    ,   0.2218332    ,   0.1803088    
     +,   0.1449893    ,   0.1155575    ,   9.1483027E-02
     +,   7.2113864E-02,   5.6753729E-02,   4.4721775E-02
     +,   3.5391971E-02,   2.8211683E-02,   2.2712521E-02
     +,   1.8507417E-02,   1.5285872E-02,   1.2803206E-02
     +,   1.0871170E-02,   9.3469219E-03,   8.1242416E-03
     +,   7.1250480E-03,   6.2928959E-03,   5.5872803E-03
     +,   4.9793669E-03,   4.4486881E-03,   3.9805043E-03
     +,   3.5641191E-03,   3.1914792E-03,   2.8564185E-03
     +,   2.5539997E-03,   2.2802521E-03,   2.0318693E-03
     +,   1.8061483E-03,   1.6008252E-03,   1.4140565E-03
     +,   1.2442967E-03,   1.0902815E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_hzonly_ttz120_mass = Yx/7.92961861363636
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_hzonly_ttz60_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.2311148E-02,   1.3897278E-02
     +,   1.5714779E-02,   1.7806694E-02,   2.0223873E-02
     +,   2.3025529E-02,   2.6279427E-02,   3.0061327E-02
     +,   3.4453560E-02,   3.9542805E-02,   4.5416124E-02
     +,   5.2156620E-02,   5.9838317E-02,   6.8521939E-02
     +,   7.8252286E-02,   8.9059256E-02,   0.1009633    
     +,   0.1139850    ,   0.1281571    ,   0.1435361    
     +,   0.1602098    ,   0.1783008    ,   0.1979686    
     +,   0.2194221    ,   0.2429392    ,   0.2689100    
     +,   0.2978704    ,   0.3305146    ,   0.3676383    
     +,   0.4100081    ,   0.4581579    ,   0.5121777    
     +,   0.5715566    ,   0.6351479    ,   0.7012537    
     +,   0.7677993    ,   0.8325409    ,   0.8932976    
     +,   0.9482235    ,   0.9960749    ,    1.036448    
     +,    1.069739    ,    1.096807    ,    1.118342    
     +,    1.134284    ,    1.143599    ,    1.144609    
     +,    1.135674    ,    1.115889    ,    1.085402    
     +,    1.045336    ,   0.9974340    ,   0.9437310    
     +,   0.8863136    ,   0.8271806    ,   0.7680880    
     +,   0.7104130    ,   0.6550874    ,   0.6026368    
     +,   0.5533392    ,   0.5073928    ,   0.4650144    
     +,   0.4264432    ,   0.3918464    ,   0.3612253    
     +,   0.3343499    ,   0.3107601    ,   0.2898362    
     +,   0.2709034    ,   0.2533413    ,   0.2366649    
     +,   0.2205652    ,   0.2049030    ,   0.1896795    
     +,   0.1749843    ,   0.1609496    ,   0.1477145    
     +,   0.1353983    ,   0.1240880    ,   0.1138357    
     +,   0.1046608    ,   9.6551895E-02,   8.9472629E-02
     +,   8.3364807E-02,   7.8153782E-02,   7.3751494E-02
     +,   7.0062116E-02,   6.6985704E-02,   6.4423606E-02
     +,   6.2281635E-02,   6.0473733E-02,   5.8924112E-02
     +,   5.7568241E-02,   5.6353066E-02,   5.5236746E-02
     +,   5.4187465E-02,   5.3181961E-02,   5.2204411E-02
     +,   5.1244520E-02,   5.0296579E-02,   4.9357861E-02
     +,   4.8428059E-02,   4.7508188E-02,   4.6600137E-02
     +,   4.5706183E-02,   4.4828728E-02,   4.3970104E-02
     +,   4.3132652E-02,   4.2318393E-02,   4.1529272E-02
     +,   4.0767249E-02,   4.0034041E-02,   3.9331548E-02
     +,   3.8661532E-02,   3.8025830E-02,   3.7426297E-02
     +,   3.6864795E-02,   3.6343101E-02,   3.5862930E-02
     +,   3.5425868E-02,   3.5033245E-02,   3.4686167E-02
     +,   3.4385480E-02,   3.4131531E-02,   3.3924393E-02
     +,   3.3763610E-02,   3.3648282E-02,   3.3577032E-02
     +,   3.3548005E-02,   3.3558842E-02,   3.3606738E-02
     +,   3.3688411E-02,   3.3800252E-02,   3.3938196E-02
     +,   3.4097932E-02,   3.4274865E-02,   3.4464188E-02
     +,   3.4661010E-02,   3.4860294E-02,   3.5057146E-02
     +,   3.5246633E-02,   3.5424002E-02,   3.5584826E-02
     +,   3.5724822E-02,   3.5840195E-02,   3.5927508E-02
     +,   3.5983808E-02,   3.6006697E-02,   3.5994302E-02
     +,   3.5945367E-02,   3.5859264E-02,   3.5735954E-02
     +,   3.5576086E-02,   3.5380851E-02,   3.5152052E-02
     +,   3.4892101E-02,   3.4603912E-02,   3.4290813E-02
     +,   3.3956580E-02,   3.3605348E-02,   3.3241492E-02
     +,   3.2869589E-02,   3.2494318E-02,   3.2120433E-02
     +,   3.1752534E-02,   3.1395219E-02,   3.1052809E-02
     +,   3.0729380E-02,   3.0428663E-02,   3.0153967E-02
     +,   2.9908238E-02,   2.9693905E-02,   2.9512854E-02
     +,   2.9366497E-02,   2.9255679E-02,   2.9180750E-02
     +,   2.9141473E-02,   2.9137155E-02,   2.9166600E-02
     +,   2.9228151E-02,   2.9319767E-02,   2.9439010E-02
     +,   2.9583121E-02,   2.9749086E-02,   2.9933691E-02
     +,   3.0133497E-02,   3.0344995E-02,   3.0564571E-02
     +,   3.0788703E-02,   3.1013744E-02,   3.1236239E-02
     +,   3.1452823E-02,   3.1660251E-02,   3.1855471E-02
     +,   3.2035664E-02,   3.2198220E-02,   3.2340761E-02
     +,   3.2461185E-02,   3.2557659E-02,   3.2628633E-02
     +,   3.2672796E-02,   3.2689136E-02,   3.2676905E-02
     +,   3.2635577E-02,   3.2564923E-02,   3.2464921E-02
     +,   3.2335762E-02,   3.2177866E-02,   3.1991828E-02
     +,   3.1778391E-02,   3.1538498E-02,   3.1273171E-02
     +,   3.0983632E-02,   3.0671123E-02,   3.0336963E-02
     +,   2.9982643E-02,   2.9609598E-02,   2.9219320E-02
     +,   2.8813342E-02,   2.8393215E-02,   2.7960438E-02
     +,   2.7516475E-02,   2.7062856E-02,   2.6600964E-02
     +,   2.6132202E-02,   2.5657851E-02,   2.5179159E-02
     +,   2.4697363E-02,   2.4213511E-02,   2.3728644E-02
     +,   2.3243699E-02,   2.2759544E-02,   2.2276975E-02
     +,   2.1796631E-02,   2.1319201E-02,   2.0845171E-02
     +,   2.0375028E-02,   1.9909168E-02,   1.9447930E-02
     +,   1.8991590E-02,   1.8540325E-02,   1.8094335E-02
     +,   1.7653750E-02,   1.7218646E-02,   1.6789041E-02
     +,   1.6365005E-02,   1.5946526E-02,   1.5533600E-02
     +,   1.5126165E-02,   1.4724240E-02,   1.4327755E-02
     +,   1.3936669E-02,   1.3550964E-02,   1.3170610E-02
     +,   1.2795590E-02,   1.2425860E-02,   1.2061442E-02
     +,   1.1702350E-02,   1.1348586E-02,   1.1000175E-02
     +,   1.0657154E-02,   1.0319601E-02,   9.9875536E-03
     +,   9.6610701E-03,   9.3402499E-03,   9.0251537E-03
     +,   8.7158643E-03,   8.4124804E-03,   8.1150951E-03
     +,   7.8237895E-03,   7.5386418E-03,   7.2597461E-03
     +,   6.9871936E-03,   6.7210500E-03,   6.4613754E-03
     +,   6.2082503E-03,   5.9617106E-03,   5.7218121E-03
     +,   5.4885778E-03,   5.2620480E-03,   5.0422163E-03
     +,   4.8290985E-03,   4.6226722E-03,   4.4229282E-03
     +,   4.2298199E-03,   4.0433155E-03,   3.8633542E-03
     +,   3.6898619E-03,   3.5227714E-03,   3.3619863E-03
     +,   3.2074181E-03,   3.0589525E-03,   2.9164834E-03
     +,   2.7798791E-03,   2.6490206E-03,   2.5237615E-03
     +,   2.4039710E-03,   2.2894926E-03,   2.1801842E-03
     +,   2.0758847E-03,   1.9764437E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_hzonly_ttz60_mass = Yx/9.81493982608696
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_hzonly_ttz65_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  5.3414684E-03,   5.6529720E-03
     +,   5.9847087E-03,   6.3379626E-03,   6.7140264E-03
     +,   7.1141776E-03,   7.5396909E-03,   7.9918448E-03
     +,   8.4719304E-03,   8.9813275E-03,   9.5215049E-03
     +,   1.0094146E-02,   1.0701252E-02,   1.1345245E-02
     +,   1.2029171E-02,   1.2756828E-02,   1.3532993E-02
     +,   1.4363629E-02,   1.5256080E-02,   1.6219364E-02
     +,   1.7264402E-02,   1.8404460E-02,   1.9655555E-02
     +,   2.1037284E-02,   2.2573497E-02,   2.4293723E-02
     +,   2.6234468E-02,   2.8440885E-02,   3.0968502E-02
     +,   3.3884954E-02,   3.7271254E-02,   4.1222781E-02
     +,   4.5849349E-02,   5.1274490E-02,   5.7633661E-02
     +,   6.5071389E-02,   7.3737942E-02,   8.3786100E-02
     +,   9.5370807E-02,   0.1086497    ,   0.1237922    
     +,   0.1409862    ,   0.1604463    ,   0.1824117    
     +,   0.2071325    ,   0.2348486    ,   0.2657764    
     +,   0.3001272    ,   0.3381718    ,   0.3803291    
     +,   0.4272298    ,   0.4796730    ,   0.5384312    
     +,   0.6039370    ,   0.6759146    ,   0.7531131    
     +,   0.8331551    ,   0.9126719    ,   0.9877990    
     +,    1.055175    ,    1.113165    ,    1.162646    
     +,    1.206534    ,    1.247861    ,    1.287271    
     +,    1.321559    ,    1.344359    ,    1.348775    
     +,    1.330534    ,    1.289942    ,    1.231717    
     +,    1.162984    ,    1.090584    ,    1.019112    
     +,   0.9504181    ,   0.8844818    ,   0.8208218    
     +,   0.7595657    ,   0.7017149    ,   0.6486556    
     +,   0.6013525    ,   0.5597053    ,   0.5224876    
     +,   0.4878201    ,   0.4539558    ,   0.4199274    
     +,   0.3858061    ,   0.3524883    ,   0.3212250    
     +,   0.2931139    ,   0.2687834    ,   0.2483059    
     +,   0.2312945    ,   0.2170901    ,   0.2049486    
     +,   0.1941822    ,   0.1842369    ,   0.1747254    
     +,   0.1654205    ,   0.1562329    ,   0.1471754    
     +,   0.1383289    ,   0.1298054    ,   0.1217228    
     +,   0.1141819    ,   0.1072552    ,   0.1009814    
     +,   9.5366262E-02,   9.0386562E-02,   8.5997671E-02
     +,   8.2141124E-02,   7.8750730E-02,   7.5759530E-02
     +,   7.3103338E-02,   7.0724644E-02,   6.8573773E-02
     +,   6.6610105E-02,   6.4801462E-02,   6.3123822E-02
     +,   6.1559744E-02,   6.0097177E-02,   5.8728203E-02
     +,   5.7447527E-02,   5.6251619E-02,   5.5137590E-02
     +,   5.4102909E-02,   5.3144637E-02,   5.2259512E-02
     +,   5.1443569E-02,   5.0692402E-02,   5.0000966E-02
     +,   4.9363960E-02,   4.8775639E-02,   4.8230194E-02
     +,   4.7721691E-02,   4.7244150E-02,   4.6791811E-02
     +,   4.6359051E-02,   4.5940552E-02,   4.5531280E-02
     +,   4.5126654E-02,   4.4722613E-02,   4.4315491E-02
     +,   4.3902270E-02,   4.3480501E-02,   4.3048270E-02
     +,   4.2604282E-02,   4.2147797E-02,   4.1678682E-02
     +,   4.1197158E-02,   4.0703986E-02,   4.0200304E-02
     +,   3.9687622E-02,   3.9167639E-02,   3.8642265E-02
     +,   3.8113646E-02,   3.7583999E-02,   3.7055627E-02
     +,   3.6530755E-02,   3.6011782E-02,   3.5500906E-02
     +,   3.5000395E-02,   3.4512341E-02,   3.4038886E-02
     +,   3.3581942E-02,   3.3143390E-02,   3.2724939E-02
     +,   3.2328278E-02,   3.1954851E-02,   3.1605937E-02
     +,   3.1282742E-02,   3.0986276E-02,   3.0717306E-02
     +,   3.0476423E-02,   3.0264065E-02,   3.0080371E-02
     +,   2.9925324E-02,   2.9798660E-02,   2.9699873E-02
     +,   2.9628314E-02,   2.9583035E-02,   2.9562991E-02
     +,   2.9566886E-02,   2.9593280E-02,   2.9640647E-02
     +,   2.9707294E-02,   2.9791422E-02,   2.9891256E-02
     +,   3.0004825E-02,   3.0130269E-02,   3.0265624E-02
     +,   3.0408952E-02,   3.0558355E-02,   3.0711934E-02
     +,   3.0867802E-02,   3.1024154E-02,   3.1179193E-02
     +,   3.1331144E-02,   3.1478290E-02,   3.1618942E-02
     +,   3.1751417E-02,   3.1874090E-02,   3.1985339E-02
     +,   3.2083582E-02,   3.2167297E-02,   3.2234944E-02
     +,   3.2285061E-02,   3.2316234E-02,   3.2327089E-02
     +,   3.2316402E-02,   3.2282967E-02,   3.2225717E-02
     +,   3.2143719E-02,   3.2036185E-02,   3.1902473E-02
     +,   3.1742088E-02,   3.1554732E-02,   3.1340290E-02
     +,   3.1098841E-02,   3.0830653E-02,   3.0536151E-02
     +,   3.0215967E-02,   2.9870909E-02,   2.9501937E-02
     +,   2.9110152E-02,   2.8696759E-02,   2.8263133E-02
     +,   2.7810665E-02,   2.7340850E-02,   2.6855201E-02
     +,   2.6355300E-02,   2.5842717E-02,   2.5318986E-02
     +,   2.4785630E-02,   2.4244133E-02,   2.3695944E-02
     +,   2.3142396E-02,   2.2584803E-02,   2.2024423E-02
     +,   2.1462394E-02,   2.0899767E-02,   2.0337583E-02
     +,   1.9776804E-02,   1.9218277E-02,   1.8662801E-02
     +,   1.8111151E-02,   1.7564064E-02,   1.7022187E-02
     +,   1.6486129E-02,   1.5956510E-02,   1.5433895E-02
     +,   1.4918779E-02,   1.4411693E-02,   1.3913135E-02
     +,   1.3423553E-02,   1.2943360E-02,   1.2472969E-02
     +,   1.2012789E-02,   1.1563159E-02,   1.1124372E-02
     +,   1.0696745E-02,   1.0280539E-02,   9.8759579E-03
     +,   9.4831688E-03,   9.1023389E-03,   8.7335529E-03
     +,   8.3768535E-03,   8.0322707E-03,   7.6997899E-03
     +,   7.3793312E-03,   7.0707863E-03,   6.7740194E-03
     +,   6.4888629E-03,   6.2151002E-03,   5.9524830E-03
     +,   5.7007610E-03,   5.4596346E-03,   5.2288063E-03
     +,   5.0079366E-03,   4.7967024E-03,   4.5947381E-03
     +,   4.4017024E-03,   4.2172214E-03,   4.0409453E-03
     +,   3.8725024E-03,   3.7115449E-03,   3.5577212E-03
     +,   3.4106746E-03,   3.2700880E-03,   3.1356218E-03
     +,   3.0069766E-03,   2.8838434E-03,   2.7659405E-03
     +,   2.6529913E-03,   2.5447423E-03,   2.4409411E-03
     +,   2.3413643E-03,   2.2457880E-03,   2.1540159E-03
     +,   2.0658497E-03,   1.9811199E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_hzonly_ttz65_mass = Yx/10.6903608913043
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_hzonly_ttz70_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.5111408E-03,   3.6679194E-03
     +,   3.8309798E-03,   4.0005296E-03,   4.1767750E-03
     +,   4.3599210E-03,   4.5501748E-03,   4.7477377E-03
     +,   4.9528135E-03,   5.1656128E-03,   5.3863376E-03
     +,   5.6151962E-03,   5.8523999E-03,   6.0981656E-03
     +,   6.3527133E-03,   6.6162818E-03,   6.8891188E-03
     +,   7.1714888E-03,   7.4636792E-03,   7.7660009E-03
     +,   8.0788136E-03,   8.4025050E-03,   8.7375259E-03
     +,   9.0844119E-03,   9.4437515E-03,   9.8162796E-03
     +,   1.0202847E-02,   1.0604468E-02,   1.1022369E-02
     +,   1.1458023E-02,   1.1913195E-02,   1.2390023E-02
     +,   1.2891067E-02,   1.3419424E-02,   1.3978808E-02
     +,   1.4573717E-02,   1.5209577E-02,   1.5892962E-02
     +,   1.6631929E-02,   1.7436231E-02,   1.8317891E-02
     +,   1.9291649E-02,   2.0375559E-02,   2.1591682E-02
     +,   2.2966856E-02,   2.4533458E-02,   2.6330164E-02
     +,   2.8402681E-02,   3.0804401E-02,   3.3596918E-02
     +,   3.6850553E-02,   4.0644757E-02,   4.5068663E-02
     +,   5.0222237E-02,   5.6216586E-02,   6.3176274E-02
     +,   7.1239635E-02,   8.0559835E-02,   9.1305360E-02
     +,   0.1036601    ,   0.1178245    ,   0.1340171    
     +,   0.1524706    ,   0.1734194    ,   0.1970643    
     +,   0.2235137    ,   0.2527294    ,   0.2844890    
     +,   0.3184366    ,   0.3542146    ,   0.3917043    
     +,   0.4313091    ,   0.4742415    ,   0.5226717    
     +,   0.5795658    ,   0.6479738    ,   0.7297372    
     +,   0.8240656    ,   0.9268753    ,    1.031586    
     +,    1.131035    ,    1.219226    ,    1.291723    
     +,    1.345235    ,    1.377619    ,    1.388855    
     +,    1.381808    ,    1.361546    ,    1.333345    
     +,    1.300639    ,    1.264231    ,    1.223104    
     +,    1.176163    ,    1.123777    ,    1.068068    
     +,    1.011824    ,   0.9568372    ,   0.9029063    
     +,   0.8482667    ,   0.7911555    ,   0.7313492    
     +,   0.6706856    ,   0.6122702    ,   0.5590668    
     +,   0.5126792    ,   0.4729412    ,   0.4383332    
     +,   0.4068476    ,   0.3768428    ,   0.3475043    
     +,   0.3188304    ,   0.2912996    ,   0.2654945    
     +,   0.2418339    ,   0.2204939    ,   0.2014437    
     +,   0.1845378    ,   0.1695910    ,   0.1564293    
     +,   0.1449014    ,   0.1348759    ,   0.1262295    
     +,   0.1188356    ,   0.1125575    ,   0.1072488    
     +,   0.1027575    ,   9.8932222E-02,   9.5629185E-02
     +,   9.2717700E-02,   9.0084963E-02,   8.7637208E-02
     +,   8.5300557E-02,   8.3020084E-02,   8.0757819E-02
     +,   7.8490630E-02,   7.6207593E-02,   7.3907882E-02
     +,   7.1597859E-02,   6.9288835E-02,   6.6995397E-02
     +,   6.4733312E-02,   6.2518366E-02,   6.0365092E-02
     +,   5.8286000E-02,   5.6291416E-02,   5.4388948E-02
     +,   5.2583642E-02,   5.0878257E-02,   4.9273431E-02
     +,   4.7767948E-02,   4.6359219E-02,   4.5043670E-02
     +,   4.3817114E-02,   4.2674821E-02,   4.1611936E-02
     +,   4.0623717E-02,   3.9705589E-02,   3.8853224E-02
     +,   3.8062673E-02,   3.7330519E-02,   3.6653712E-02
     +,   3.6029611E-02,   3.5456136E-02,   3.4931589E-02
     +,   3.4454603E-02,   3.4024134E-02,   3.3639416E-02
     +,   3.3299867E-02,   3.3004962E-02,   3.2754175E-02
     +,   3.2546945E-02,   3.2382544E-02,   3.2260001E-02
     +,   3.2178041E-02,   3.2135133E-02,   3.2129332E-02
     +,   3.2158367E-02,   3.2219511E-02,   3.2309856E-02
     +,   3.2426067E-02,   3.2564614E-02,   3.2721691E-02
     +,   3.2893460E-02,   3.3075955E-02,   3.3265192E-02
     +,   3.3457261E-02,   3.3648390E-02,   3.3834923E-02
     +,   3.4013491E-02,   3.4180906E-02,   3.4334354E-02
     +,   3.4471266E-02,   3.4589421E-02,   3.4686964E-02
     +,   3.4762319E-02,   3.4814287E-02,   3.4842007E-02
     +,   3.4844901E-02,   3.4822710E-02,   3.4775477E-02
     +,   3.4703456E-02,   3.4607202E-02,   3.4487426E-02
     +,   3.4345090E-02,   3.4181286E-02,   3.3997234E-02
     +,   3.3794273E-02,   3.3573806E-02,   3.3337306E-02
     +,   3.3086181E-02,   3.2821897E-02,   3.2545809E-02
     +,   3.2259237E-02,   3.1963356E-02,   3.1659197E-02
     +,   3.1347703E-02,   3.1029576E-02,   3.0705409E-02
     +,   3.0375561E-02,   3.0040247E-02,   2.9699488E-02
     +,   2.9353172E-02,   2.9001020E-02,   2.8642669E-02
     +,   2.8277623E-02,   2.7905304E-02,   2.7525142E-02
     +,   2.7136544E-02,   2.6738930E-02,   2.6331710E-02
     +,   2.5914468E-02,   2.5486831E-02,   2.5048539E-02
     +,   2.4599463E-02,   2.4139604E-02,   2.3669146E-02
     +,   2.3188367E-02,   2.2697739E-02,   2.2197887E-02
     +,   2.1689512E-02,   2.1173453E-02,   2.0650681E-02
     +,   2.0122252E-02,   1.9589258E-02,   1.9052861E-02
     +,   1.8514270E-02,   1.7974721E-02,   1.7435411E-02
     +,   1.6897529E-02,   1.6362283E-02,   1.5830778E-02
     +,   1.5304079E-02,   1.4783205E-02,   1.4269127E-02
     +,   1.3762707E-02,   1.3264710E-02,   1.2775858E-02
     +,   1.2296810E-02,   1.1828106E-02,   1.1370200E-02
     +,   1.0923510E-02,   1.0488385E-02,   1.0065065E-02
     +,   9.6537303E-03,   9.2545580E-03,   8.8676121E-03
     +,   8.4929112E-03,   8.1304535E-03,   7.7802064E-03
     +,   7.4420501E-03,   7.1158628E-03,   6.8014939E-03
     +,   6.4987750E-03,   6.2074880E-03,   5.9273997E-03
     +,   5.6582941E-03,   5.3998870E-03,   5.1519326E-03
     +,   4.9141347E-03,   4.6862243E-03,   4.4678897E-03
     +,   4.2588497E-03,   4.0587904E-03,   3.8674222E-03
     +,   3.6844302E-03,   3.5095240E-03,   3.3423977E-03
     +,   3.1827528E-03,   3.0303050E-03,   2.8847582E-03
     +,   2.7458391E-03,   2.6132644E-03,   2.4867733E-03
     +,   2.3660969E-03,   2.2509897E-03,   2.1411986E-03
     +,   2.0364930E-03,   1.9366390E-03,   1.8414224E-03
     +,   1.7506265E-03,   1.6640547E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_hzonly_ttz70_mass = Yx/10.9203985434783
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_hzonly_ttz75_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  3.5727459E-03,   3.7003190E-03
     +,   3.8288368E-03,   3.9580455E-03,   4.0876782E-03
     +,   4.2174519E-03,   4.3470715E-03,   4.4762315E-03
     +,   4.6046120E-03,   4.7318893E-03,   4.8577273E-03
     +,   4.9817860E-03,   5.1037171E-03,   5.2231746E-03
     +,   5.3398134E-03,   5.4532862E-03,   5.5632540E-03
     +,   5.6693857E-03,   5.7713604E-03,   5.8688731E-03
     +,   5.9616361E-03,   6.0493848E-03,   6.1318777E-03
     +,   6.2089129E-03,   6.2803123E-03,   6.3459519E-03
     +,   6.4057466E-03,   6.4596715E-03,   6.5077604E-03
     +,   6.5501207E-03,   6.5869326E-03,   6.6184741E-03
     +,   6.6451132E-03,   6.6673318E-03,   6.6857366E-03
     +,   6.7010573E-03,   6.7141792E-03,   6.7261411E-03
     +,   6.7381533E-03,   6.7516020E-03,   6.7680725E-03
     +,   6.7893458E-03,   6.8174209E-03,   6.8545095E-03
     +,   6.9030547E-03,   6.9657401E-03,   7.0454972E-03
     +,   7.1455245E-03,   7.2693210E-03,   7.4207201E-03
     +,   7.6039531E-03,   7.8237094E-03,   8.0852583E-03
     +,   8.3946045E-03,   8.7586045E-03,   9.1852322E-03
     +,   9.6837776E-03,   1.0265105E-02,   1.0941911E-02
     +,   1.1728972E-02,   1.2643339E-02,   1.3704476E-02
     +,   1.4934227E-02,   1.6356859E-02,   1.7998824E-02
     +,   1.9888222E-02,   2.2054821E-02,   2.4529101E-02
     +,   2.7342556E-02,   3.0526852E-02,   3.4114823E-02
     +,   3.8140234E-02,   4.2639852E-02,   4.7654044E-02
     +,   5.3229954E-02,   5.9423763E-02,   6.6303194E-02
     +,   7.3950782E-02,   8.2466632E-02,   9.1967784E-02
     +,   0.1025836    ,   0.1144497    ,   0.1276945    
     +,   0.1424363    ,   0.1587870    ,   0.1768851    
     +,   0.1969476    ,   0.2193453    ,   0.2446686    
     +,   0.2737786    ,   0.3077905    ,   0.3479413    
     +,   0.3953042    ,   0.4503763    ,   0.5127168    
     +,   0.5809335    ,   0.6531865    ,   0.7279262    
     +,   0.8044372    ,   0.8827525    ,   0.9631417    
     +,    1.045432    ,    1.128573    ,    1.210442    
     +,    1.287630    ,    1.354817    ,    1.404579    
     +,    1.429592    ,    1.426991    ,    1.400784    
     +,    1.359025    ,    1.308606    ,    1.253312    
     +,    1.195574    ,    1.137731    ,    1.080749    
     +,    1.023170    ,   0.9625799    ,   0.8982214    
     +,   0.8318343    ,   0.7663062    ,   0.7039733    
     +,   0.6460411    ,   0.5929813    ,   0.5449964    
     +,   0.5021266    ,   0.4642077    ,   0.4309277    
     +,   0.4019114    ,   0.3767532    ,   0.3549615    
     +,   0.3359583    ,   0.3191493    ,   0.3040412    
     +,   0.2902980    ,   0.2777135    ,   0.2661311    
     +,   0.2553668    ,   0.2451866    ,   0.2353343    
     +,   0.2255885    ,   0.2158085    ,   0.2059558    
     +,   0.1960795    ,   0.1862852    ,   0.1766911    
     +,   0.1673968    ,   0.1584669    ,   0.1499268    
     +,   0.1417710    ,   0.1339774    ,   0.1265195    
     +,   0.1193775    ,   0.1125406    ,   0.1060097    
     +,   9.9794254E-02,   9.3908705E-02,   8.8367157E-02
     +,   8.3180942E-02,   7.8356870E-02,   7.3895447E-02
     +,   6.9791421E-02,   6.6034824E-02,   6.2611848E-02
     +,   5.9505515E-02,   5.6697015E-02,   5.4166589E-02
     +,   5.1893793E-02,   4.9858063E-02,   4.8039187E-02
     +,   4.6417788E-02,   4.4975679E-02,   4.3695956E-02
     +,   4.2563286E-02,   4.1564438E-02,   4.0687822E-02
     +,   3.9923657E-02,   3.9263833E-02,   3.8701668E-02
     +,   3.8231403E-02,   3.7848134E-02,   3.7547365E-02
     +,   3.7324697E-02,   3.7175570E-02,   3.7095059E-02
     +,   3.7077766E-02,   3.7117604E-02,   3.7207883E-02
     +,   3.7341259E-02,   3.7509859E-02,   3.7705284E-02
     +,   3.7918884E-02,   3.8141768E-02,   3.8365126E-02
     +,   3.8580257E-02,   3.8778938E-02,   3.8953427E-02
     +,   3.9096680E-02,   3.9202623E-02,   3.9266076E-02
     +,   3.9283011E-02,   3.9250568E-02,   3.9167073E-02
     +,   3.9032079E-02,   3.8846381E-02,   3.8611814E-02
     +,   3.8331319E-02,   3.8008742E-02,   3.7648682E-02
     +,   3.7256312E-02,   3.6837280E-02,   3.6397453E-02
     +,   3.5942744E-02,   3.5478879E-02,   3.5011265E-02
     +,   3.4544878E-02,   3.4084037E-02,   3.3632293E-02
     +,   3.3192389E-02,   3.2766212E-02,   3.2354731E-02
     +,   3.1958017E-02,   3.1575285E-02,   3.1204987E-02
     +,   3.0844843E-02,   3.0491991E-02,   3.0143134E-02
     +,   2.9794622E-02,   2.9442644E-02,   2.9083325E-02
     +,   2.8712898E-02,   2.8327854E-02,   2.7924992E-02
     +,   2.7501535E-02,   2.7055299E-02,   2.6584622E-02
     +,   2.6088433E-02,   2.5566395E-02,   2.5018729E-02
     +,   2.4446247E-02,   2.3850376E-02,   2.3232976E-02
     +,   2.2596437E-02,   2.1943392E-02,   2.1276794E-02
     +,   2.0599775E-02,   1.9915607E-02,   1.9227482E-02
     +,   1.8538579E-02,   1.7851984E-02,   1.7170534E-02
     +,   1.6496850E-02,   1.5833288E-02,   1.5181976E-02
     +,   1.4544616E-02,   1.3922658E-02,   1.3317267E-02
     +,   1.2729321E-02,   1.2159390E-02,   1.1607801E-02
     +,   1.1074712E-02,   1.0560085E-02,   1.0063698E-02
     +,   9.5852194E-03,   9.1242632E-03,   8.6803352E-03
     +,   8.2529038E-03,   7.8414474E-03,   7.4454392E-03
     +,   7.0643430E-03,   6.6976435E-03,   6.3448818E-03
     +,   6.0056346E-03,   5.6794868E-03,   5.3660697E-03
     +,   5.0650714E-03,   4.7761775E-03,   4.4991337E-03
     +,   4.2336727E-03,   3.9795800E-03,   3.7366173E-03
     +,   3.5045852E-03,   3.2832574E-03,   3.0724325E-03
     +,   2.8718798E-03,   2.6813841E-03,   2.5007033E-03
     +,   2.3295835E-03,   2.1677788E-03,   2.0150060E-03
     +,   1.8709957E-03,   1.7354442E-03,   1.6080593E-03
     +,   1.4885233E-03,   1.3765270E-03,   1.2717434E-03
     +,   1.1738550E-03,   1.0825308E-03,   9.9745288E-04
     +,   9.1829424E-04,   8.4474258E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_hzonly_ttz75_mass = Yx/11.0070025531915
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_hzonly_ttz80_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.2829308E-03,   2.3564016E-03
     +,   2.4306362E-03,   2.5055257E-03,   2.5809603E-03
     +,   2.6568254E-03,   2.7330052E-03,   2.8093827E-03
     +,   2.8858418E-03,   2.9622712E-03,   3.0385603E-03
     +,   3.1146060E-03,   3.1903109E-03,   3.2655883E-03
     +,   3.3403623E-03,   3.4145718E-03,   3.4881709E-03
     +,   3.5611319E-03,   3.6334503E-03,   3.7051428E-03
     +,   3.7762537E-03,   3.8468535E-03,   3.9170454E-03
     +,   3.9869677E-03,   4.0567890E-03,   4.1267211E-03
     +,   4.1970070E-03,   4.2679366E-03,   4.3398356E-03
     +,   4.4130757E-03,   4.4880621E-03,   4.5652441E-03
     +,   4.6451092E-03,   4.7281766E-03,   4.8150034E-03
     +,   4.9061687E-03,   5.0022793E-03,   5.1039564E-03
     +,   5.2118399E-03,   5.3265612E-03,   5.4487605E-03
     +,   5.5790595E-03,   5.7180617E-03,   5.8663413E-03
     +,   6.0244328E-03,   6.1928239E-03,   6.3719563E-03
     +,   6.5621994E-03,   6.7638652E-03,   6.9771875E-03
     +,   7.2023347E-03,   7.4393940E-03,   7.6883864E-03
     +,   7.9492759E-03,   8.2219420E-03,   8.5062515E-03
     +,   8.8020153E-03,   9.1090314E-03,   9.4271097E-03
     +,   9.7560780E-03,   1.0095824E-02,   1.0446315E-02
     +,   1.0807601E-02,   1.1179904E-02,   1.1563612E-02
     +,   1.1959290E-02,   1.2367783E-02,   1.2790175E-02
     +,   1.3227925E-02,   1.3682826E-02,   1.4157169E-02
     +,   1.4653723E-02,   1.5175931E-02,   1.5727948E-02
     +,   1.6314847E-02,   1.6942790E-02,   1.7619157E-02
     +,   1.8352790E-02,   1.9154279E-02,   2.0036137E-02
     +,   2.1012897E-02,   2.2101521E-02,   2.3321286E-02
     +,   2.4694152E-02,   2.6244629E-02,   2.8000206E-02
     +,   2.9991211E-02,   3.2251582E-02,   3.4818787E-02
     +,   3.7735000E-02,   4.1047651E-02,   4.4809911E-02
     +,   4.9081679E-02,   5.3930495E-02,   5.9432205E-02
     +,   6.5670997E-02,   7.2741576E-02,   8.0747873E-02
     +,   8.9804620E-02,   0.1000329    ,   0.1115589    
     +,   0.1245067    ,   0.1389998    ,   0.1551647    
     +,   0.1731550    ,   0.1931877    ,   0.2155928    
     +,   0.2408620    ,   0.2696722    ,   0.3028431    
     +,   0.3412119    ,   0.3854472    ,   0.4358098    
     +,   0.4919733    ,   0.5529155    ,   0.6170095    
     +,   0.6823590    ,   0.7474733    ,   0.8120361    
     +,   0.8773819    ,   0.9459871    ,    1.019600    
     +,    1.096774    ,    1.172078    ,    1.239189    
     +,    1.295844    ,    1.344637    ,    1.387035    
     +,    1.417421    ,    1.425733    ,    1.406986    
     +,    1.366828    ,    1.317213    ,    1.267431    
     +,    1.219053    ,    1.167937    ,    1.110261    
     +,    1.047335    ,   0.9852784    ,   0.9302703    
     +,   0.8840467    ,   0.8435831    ,   0.8041834    
     +,   0.7625187    ,   0.7175666    ,   0.6700081    
     +,   0.6213328    ,   0.5731711    ,   0.5268473    
     +,   0.4831551    ,   0.4424132    ,   0.4046917    
     +,   0.3700268    ,   0.3385004    ,   0.3102027    
     +,   0.2851596    ,   0.2632817    ,   0.2443558    
     +,   0.2280648    ,   0.2140184    ,   0.2017834    
     +,   0.1909269    ,   0.1810566    ,   0.1718530    
     +,   0.1630883    ,   0.1546290    ,   0.1464252    
     +,   0.1384907    ,   0.1308806    ,   0.1236716    
     +,   0.1169433    ,   0.1107639    ,   0.1051796    
     +,   0.1002093    ,   9.5843427E-02,   9.2045940E-02
     +,   8.8760898E-02,   8.5920095E-02,   8.3450586E-02
     +,   8.1281878E-02,   7.9351470E-02,   7.7607982E-02
     +,   7.6012522E-02,   7.4537776E-02,   7.3166959E-02
     +,   7.1891293E-02,   7.0707820E-02,   6.9617242E-02
     +,   6.8622030E-02,   6.7725353E-02,   6.6929862E-02
     +,   6.6237122E-02,   6.5647386E-02,   6.5159194E-02
     +,   6.4768948E-02,   6.4471096E-02,   6.4257875E-02
     +,   6.4119227E-02,   6.4042591E-02,   6.4013630E-02
     +,   6.4015873E-02,   6.4031444E-02,   6.4041592E-02
     +,   6.4027347E-02,   6.3970156E-02,   6.3852973E-02
     +,   6.3660689E-02,   6.3381344E-02,   6.3006029E-02
     +,   6.2530018E-02,   6.1952457E-02,   6.1276533E-02
     +,   6.0509179E-02,   5.9660651E-02,   5.8743808E-02
     +,   5.7773374E-02,   5.6765091E-02,   5.5734772E-02
     +,   5.4697540E-02,   5.3667132E-02,   5.2655149E-02
     +,   5.1670667E-02,   5.0720081E-02,   4.9806863E-02
     +,   4.8931710E-02,   4.8092812E-02,   4.7286149E-02
     +,   4.6506044E-02,   4.5745585E-02,   4.4997122E-02
     +,   4.4252884E-02,   4.3505393E-02,   4.2747799E-02
     +,   4.1974172E-02,   4.1179892E-02,   4.0361557E-02
     +,   3.9517093E-02,   3.8645763E-02,   3.7748035E-02
     +,   3.6825322E-02,   3.5879847E-02,   3.4914508E-02
     +,   3.3932593E-02,   3.2937530E-02,   3.1932775E-02
     +,   3.0921653E-02,   2.9907342E-02,   2.8892551E-02
     +,   2.7879687E-02,   2.6870824E-02,   2.5867628E-02
     +,   2.4871478E-02,   2.3883501E-02,   2.2904694E-02
     +,   2.1935839E-02,   2.0977678E-02,   2.0031020E-02
     +,   1.9096721E-02,   1.8175671E-02,   1.7268896E-02
     +,   1.6377587E-02,   1.5503038E-02,   1.4646615E-02
     +,   1.3809756E-02,   1.2994045E-02,   1.2200968E-02
     +,   1.1432002E-02,   1.0688609E-02,   9.9721402E-03
     +,   9.2837662E-03,   8.6244866E-03,   7.9951556E-03
     +,   7.3964274E-03,   6.8286853E-03,   6.2920973E-03
     +,   5.7866657E-03,   5.3121084E-03,   4.8680142E-03
     +,   4.4537126E-03,   4.0684333E-03,   3.7112022E-03
     +,   3.3809757E-03,   3.0765575E-03,   2.7967219E-03
     +,   2.5401432E-03,   2.3054981E-03,   2.0914220E-03
     +,   1.8965504E-03,   1.7195573E-03,   1.5591192E-03
     +,   1.4139747E-03,   1.2828911E-03,   1.1647098E-03
     +,   1.0583159E-03,   9.6267328E-04,   8.7679864E-04
     +,   7.9978659E-04,   7.3078775E-04,   6.6902657E-04
     +,   6.1378180E-04,   5.6439993E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_hzonly_ttz80_mass = Yx/11.7637339787234
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_hzonly_ttz85_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.9891555E-03,   2.0545016E-03
     +,   2.1209330E-03,   2.1884155E-03,   2.2569110E-03
     +,   2.3263777E-03,   2.3967728E-03,   2.4680507E-03
     +,   2.5401611E-03,   2.6130553E-03,   2.6866794E-03
     +,   2.7609775E-03,   2.8358921E-03,   2.9113663E-03
     +,   2.9873371E-03,   3.0637442E-03,   3.1405264E-03
     +,   3.2176196E-03,   3.2949606E-03,   3.3724885E-03
     +,   3.4501397E-03,   3.5278574E-03,   3.6055781E-03
     +,   3.6832520E-03,   3.7608210E-03,   3.8382381E-03
     +,   3.9154580E-03,   3.9924434E-03,   4.0691574E-03
     +,   4.1455748E-03,   4.2216755E-03,   4.2974488E-03
     +,   4.3728910E-03,   4.4480138E-03,   4.5228321E-03
     +,   4.5973780E-03,   4.6716942E-03,   4.7458359E-03
     +,   4.8198779E-03,   4.8938990E-03,   4.9680043E-03
     +,   5.0423075E-03,   5.1169428E-03,   5.1920582E-03
     +,   5.2678203E-03,   5.3444114E-03,   5.4220324E-03
     +,   5.5008992E-03,   5.5812444E-03,   5.6633176E-03
     +,   5.7473783E-03,   5.8337040E-03,   5.9225839E-03
     +,   6.0143187E-03,   6.1092111E-03,   6.2075844E-03
     +,   6.3097570E-03,   6.4160554E-03,   6.5267994E-03
     +,   6.6423169E-03,   6.7629316E-03,   6.8889568E-03
     +,   7.0206993E-03,   7.1584615E-03,   7.3025431E-03
     +,   7.4532153E-03,   7.6107699E-03,   7.7754622E-03
     +,   7.9475725E-03,   8.1273634E-03,   8.3151245E-03
     +,   8.5111475E-03,   8.7157749E-03,   8.9293653E-03
     +,   9.1523603E-03,   9.3852906E-03,   9.6287550E-03
     +,   9.8834885E-03,   1.0150391E-02,   1.0430536E-02
     +,   1.0725185E-02,   1.1035858E-02,   1.1364300E-02
     +,   1.1712583E-02,   1.2083040E-02,   1.2478362E-02
     +,   1.2901532E-02,   1.3355912E-02,   1.3845129E-02
     +,   1.4373172E-02,   1.4944321E-02,   1.5563071E-02
     +,   1.6234124E-02,   1.6962362E-02,   1.7752813E-02
     +,   1.8610422E-02,   1.9540232E-02,   2.0547044E-02
     +,   2.1635618E-02,   2.2810353E-02,   2.4075463E-02
     +,   2.5434675E-02,   2.6891470E-02,   2.8448660E-02
     +,   3.0108826E-02,   3.1874094E-02,   3.3746339E-02
     +,   3.5727534E-02,   3.7820715E-02,   4.0031105E-02
     +,   4.2367849E-02,   4.4847578E-02,   4.7497746E-02
     +,   5.0362468E-02,   5.3508066E-02,   5.7030600E-02
     +,   6.1062079E-02,   6.5777592E-02,   7.1398221E-02
     +,   7.8191966E-02,   8.6466029E-02,   9.6548408E-02
     +,   0.1087567    ,   0.1233538    ,   0.1404955    
     +,   0.1601801    ,   0.1822327    ,   0.2063280    
     +,   0.2320946    ,   0.2592669    ,   0.2878827    
     +,   0.3184261    ,   0.3518620    ,   0.3894621    
     +,   0.4324591    ,   0.4816432    ,   0.5371541    
     +,   0.5986585    ,   0.6658551    ,   0.7389848    
     +,   0.8189659    ,   0.9069020    ,    1.003009    
     +,    1.105383    ,    1.208964    ,    1.305021    
     +,    1.382115    ,    1.430469    ,    1.448625    
     +,    1.445942    ,    1.435668    ,    1.424058    
     +,    1.406915    ,    1.376295    ,    1.328749    
     +,    1.267795    ,    1.201121    ,    1.135922    
     +,    1.074784    ,    1.014445    ,   0.9489661    
     +,   0.8753171    ,   0.7966689    ,   0.7204848    
     +,   0.6533332    ,   0.5970393    ,   0.5488459    
     +,   0.5043903    ,   0.4606246    ,   0.4169165    
     +,   0.3744913    ,   0.3352316    ,   0.3006905    
     +,   0.2716189    ,   0.2479527    ,   0.2290588    
     +,   0.2140691    ,   0.2021520    ,   0.1926585    
     +,   0.1851483    ,   0.1793428    ,   0.1750519    
     +,   0.1721104    ,   0.1703421    ,   0.1695463    
     +,   0.1695011    ,   0.1699742    ,   0.1707366    
     +,   0.1715734    ,   0.1722926    ,   0.1727314    
     +,   0.1727581    ,   0.1722739    ,   0.1712129    
     +,   0.1695414    ,   0.1672561    ,   0.1643822    
     +,   0.1609688    ,   0.1570837    ,   0.1528070    
     +,   0.1482241    ,   0.1434197    ,   0.1384719    
     +,   0.1334497    ,   0.1284131    ,   0.1234122    
     +,   0.1184905    ,   0.1136863    ,   0.1090354    
     +,   0.1045701    ,   0.1003203    ,   9.6312508E-02
     +,   9.2567436E-02,   8.9098975E-02,   8.5912943E-02
     +,   8.3006747E-02,   8.0369577E-02,   7.7983096E-02
     +,   7.5823411E-02,   7.3862717E-02,   7.2070979E-02
     +,   7.0417695E-02,   6.8873204E-02,   6.7409948E-02
     +,   6.6002749E-02,   6.4628974E-02,   6.3269310E-02
     +,   6.1907116E-02,   6.0528390E-02,   5.9121616E-02
     +,   5.7677876E-02,   5.6190409E-02,   5.4654639E-02
     +,   5.3068180E-02,   5.1430807E-02,   4.9744178E-02
     +,   4.8011873E-02,   4.6239156E-02,   4.4432860E-02
     +,   4.2600919E-02,   4.0752146E-02,   3.8896158E-02
     +,   3.7042808E-02,   3.5201874E-02,   3.3382844E-02
     +,   3.1594820E-02,   2.9846175E-02,   2.8144294E-02
     +,   2.6495557E-02,   2.4905490E-02,   2.3378337E-02
     +,   2.1917315E-02,   2.0524684E-02,   1.9201767E-02
     +,   1.7948892E-02,   1.6765630E-02,   1.5650969E-02
     +,   1.4603329E-02,   1.3620589E-02,   1.2700303E-02
     +,   1.1839819E-02,   1.1036312E-02,   1.0286799E-02
     +,   9.5882816E-03,   8.9378357E-03,   8.3325338E-03
     +,   7.7695437E-03,   7.2461832E-03,   6.7598834E-03
     +,   6.3081803E-03,   5.8887494E-03,   5.4994188E-03
     +,   5.1381504E-03,   4.8029968E-03,   4.4921315E-03
     +,   4.2038690E-03,   3.9365846E-03,   3.6887862E-03
     +,   3.4590391E-03,   3.2460245E-03,   3.0484751E-03
     +,   2.8652330E-03,   2.6951858E-03,   2.5373176E-03
     +,   2.3906615E-03,   2.2543364E-03,   2.1275133E-03
     +,   2.0094237E-03,   1.8993708E-03,   1.7966998E-03
     +,   1.7008230E-03,   1.6111895E-03,   1.5273087E-03
     +,   1.4487223E-03,   1.3750233E-03,   1.3058330E-03
     +,   1.2408160E-03,   1.1796600E-03,   1.1220896E-03
     +,   1.0678478E-03,   1.0167079E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_hzonly_ttz85_mass = Yx/11.4823049361702
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_hzonly_ttz90_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.1914493E-03,   2.2675092E-03
     +,   2.3449620E-03,   2.4237393E-03,   2.5037660E-03
     +,   2.5849610E-03,   2.6672396E-03,   2.7505110E-03
     +,   2.8346770E-03,   2.9196420E-03,   3.0053002E-03
     +,   3.0915448E-03,   3.1782661E-03,   3.2653508E-03
     +,   3.3526856E-03,   3.4401531E-03,   3.5276385E-03
     +,   3.6150250E-03,   3.7021949E-03,   3.7890379E-03
     +,   3.8754377E-03,   3.9612865E-03,   4.0464755E-03
     +,   4.1309083E-03,   4.2144805E-03,   4.2971051E-03
     +,   4.3786964E-03,   4.4591767E-03,   4.5384755E-03
     +,   4.6165353E-03,   4.6933014E-03,   4.7687367E-03
     +,   4.8428131E-03,   4.9155154E-03,   4.9868398E-03
     +,   5.0568017E-03,   5.1254304E-03,   5.1927706E-03
     +,   5.2588880E-03,   5.3238631E-03,   5.3878026E-03
     +,   5.4508299E-03,   5.5130916E-03,   5.5747614E-03
     +,   5.6360336E-03,   5.6971256E-03,   5.7582892E-03
     +,   5.8197919E-03,   5.8819363E-03,   5.9450455E-03
     +,   6.0094702E-03,   6.0755834E-03,   6.1437828E-03
     +,   6.2144911E-03,   6.2881373E-03,   6.3651819E-03
     +,   6.4460835E-03,   6.5313121E-03,   6.6213422E-03
     +,   6.7166435E-03,   6.8176705E-03,   6.9248723E-03
     +,   7.0386585E-03,   7.1594208E-03,   7.2875116E-03
     +,   7.4232253E-03,   7.5668204E-03,   7.7184755E-03
     +,   7.8783249E-03,   8.0463998E-03,   8.2226899E-03
     +,   8.4070722E-03,   8.5993670E-03,   8.7992884E-03
     +,   9.0064900E-03,   9.2205433E-03,   9.4409408E-03
     +,   9.6671069E-03,   9.8984214E-03,   1.0134232E-02
     +,   1.0373827E-02,   1.0616519E-02,   1.0861585E-02
     +,   1.1108361E-02,   1.1356191E-02,   1.1604515E-02
     +,   1.1852806E-02,   1.2100694E-02,   1.2347872E-02
     +,   1.2594203E-02,   1.2839708E-02,   1.3084540E-02
     +,   1.3329040E-02,   1.3573760E-02,   1.3819424E-02
     +,   1.4066949E-02,   1.4317470E-02,   1.4572280E-02
     +,   1.4832916E-02,   1.5101043E-02,   1.5378543E-02
     +,   1.5667435E-02,   1.5969913E-02,   1.6288271E-02
     +,   1.6624976E-02,   1.6982602E-02,   1.7363815E-02
     +,   1.7771391E-02,   1.8208254E-02,   1.8677458E-02
     +,   1.9182198E-02,   1.9725932E-02,   2.0312391E-02
     +,   2.0945750E-02,   2.1630686E-02,   2.2372702E-02
     +,   2.3178162E-02,   2.4054831E-02,   2.5011888E-02
     +,   2.6060594E-02,   2.7214482E-02,   2.8489681E-02
     +,   2.9905315E-02,   3.1483766E-02,   3.3250734E-02
     +,   3.5234883E-02,   3.7467778E-02,   3.9982695E-02
     +,   4.2813931E-02,   4.5994468E-02,   4.9554694E-02
     +,   5.3518984E-02,   5.7904247E-02,   6.2716275E-02
     +,   6.7949757E-02,   7.3588513E-02,   7.9608843E-02
     +,   8.5988201E-02,   9.2718437E-02,   9.9822775E-02
     +,   0.1073750    ,   0.1155203    ,   0.1244901    
     +,   0.1346127    ,   0.1463113    ,   0.1600981    
     +,   0.1765550    ,   0.1962993    ,   0.2199273    
     +,   0.2479235    ,   0.2805250    ,   0.3175553    
     +,   0.3582876    ,   0.4014355    ,   0.4453721    
     +,   0.4886148    ,   0.5304499    ,   0.5713625    
     +,   0.6129746    ,   0.6574455    ,   0.7066532    
     +,   0.7614692    ,   0.8212891    ,   0.8839785    
     +,   0.9465667    ,    1.006631    ,    1.063157    
     +,    1.115374    ,    1.160094    ,    1.190560    
     +,    1.199064    ,    1.181642    ,    1.140679    
     +,    1.083463    ,    1.018945    ,   0.9560888    
     +,   0.9040476    ,   0.8711964    ,   0.8615543    
     +,   0.8713270    ,   0.8893338    ,   0.9017919    
     +,   0.8981910    ,   0.8747083    ,   0.8340257    
     +,   0.7827818    ,   0.7285899    ,   0.6778857    
     +,   0.6348360    ,   0.6010528    ,   0.5758252    
     +,   0.5568043    ,   0.5408936    ,   0.5250905    
     +,   0.5070881    ,   0.4856121    ,   0.4605049    
     +,   0.4325628    ,   0.4031563    ,   0.3737853    
     +,   0.3457161    ,   0.3197993    ,   0.2964558    
     +,   0.2757548    ,   0.2575126    ,   0.2413837    
     +,   0.2269588    ,   0.2138668    ,   0.2018602    
     +,   0.1908595    ,   0.1809442    ,   0.1722942    
     +,   0.1651019    ,   0.1594923    ,   0.1554696    
     +,   0.1528983    ,   0.1515192    ,   0.1509859    
     +,   0.1509137    ,   0.1509263    ,   0.1506955    
     +,   0.1499677    ,   0.1485762    ,   0.1464417    
     +,   0.1435606    ,   0.1399879    ,   0.1358176    
     +,   0.1311632    ,   0.1261414    ,   0.1208614    
     +,   0.1154180    ,   0.1098895    ,   0.1043379    
     +,   9.8811522E-02,   9.3348853E-02,   8.7980747E-02
     +,   8.2733236E-02,   7.7629820E-02,   7.2691761E-02
     +,   6.7938067E-02,   6.3385688E-02,   5.9049033E-02
     +,   5.4939121E-02,   5.1063027E-02,   4.7423657E-02
     +,   4.4020060E-02,   4.0847354E-02,   3.7897095E-02
     +,   3.5158109E-02,   3.2617588E-02,   3.0261222E-02
     +,   2.8074302E-02,   2.6042454E-02,   2.4151994E-02
     +,   2.2390161E-02,   2.0745479E-02,   1.9207949E-02
     +,   1.7768905E-02,   1.6420839E-02,   1.5157375E-02
     +,   1.3973203E-02,   1.2863771E-02,   1.1825106E-02
     +,   1.0853717E-02,   9.9465679E-03,   9.1007762E-03
     +,   8.3136419E-03,   7.5826165E-03,   6.9052149E-03
     +,   6.2789153E-03,   5.7012360E-03,   5.1697162E-03
     +,   4.6818983E-03,   4.2352900E-03,   3.8274161E-03
     +,   3.4558603E-03,   3.1181863E-03,   2.8120484E-03
     +,   2.5351157E-03,   2.2851625E-03,   2.0600078E-03
     +,   1.8575910E-03,   1.6759196E-03,   1.5131303E-03
     +,   1.3674457E-03,   1.2372223E-03,   1.1209152E-03
     +,   1.0170959E-03,   9.2445937E-04,   8.4179913E-04
     +,   7.6802628E-04,   7.0214563E-04,   6.4326741E-04
     +,   5.9058622E-04,   5.4338848E-04,   5.0103286E-04
     +,   4.6295658E-04,   4.2865638E-04,   3.9769345E-04
     +,   3.6967735E-04,   3.4426985E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_hzonly_ttz90_mass = Yx/11.2571617021277
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_hzonly_ttz95_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.8883084E-03,   1.9501437E-03
     +,   2.0144088E-03,   2.0811791E-03,   2.1505221E-03
     +,   2.2224984E-03,   2.2971574E-03,   2.3745380E-03
     +,   2.4546636E-03,   2.5375504E-03,   2.6231923E-03
     +,   2.7115706E-03,   2.8026467E-03,   2.8963645E-03
     +,   2.9926472E-03,   3.0913996E-03,   3.1924997E-03
     +,   3.2958097E-03,   3.4011661E-03,   3.5083846E-03
     +,   3.6172573E-03,   3.7275550E-03,   3.8390257E-03
     +,   3.9514070E-03,   4.0643988E-03,   4.1777021E-03
     +,   4.2909929E-03,   4.4039330E-03,   4.5161759E-03
     +,   4.6273666E-03,   4.7371420E-03,   4.8451358E-03
     +,   4.9509839E-03,   5.0543258E-03,   5.1548081E-03
     +,   5.2520866E-03,   5.3458358E-03,   5.4357443E-03
     +,   5.5215321E-03,   5.6029330E-03,   5.6797224E-03
     +,   5.7517076E-03,   5.8187307E-03,   5.8806790E-03
     +,   5.9374855E-03,   5.9891269E-03,   6.0356380E-03
     +,   6.0771038E-03,   6.1136698E-03,   6.1455346E-03
     +,   6.1729630E-03,   6.1962809E-03,   6.2158774E-03
     +,   6.2322053E-03,   6.2457812E-03,   6.2571862E-03
     +,   6.2670675E-03,   6.2761316E-03,   6.2851459E-03
     +,   6.2949318E-03,   6.3063707E-03,   6.3203946E-03
     +,   6.3379747E-03,   6.3601295E-03,   6.3879080E-03
     +,   6.4223930E-03,   6.4646793E-03,   6.5158755E-03
     +,   6.5770978E-03,   6.6494471E-03,   6.7340122E-03
     +,   6.8318420E-03,   6.9439611E-03,   7.0713186E-03
     +,   7.2148065E-03,   7.3752552E-03,   7.5533721E-03
     +,   7.7497773E-03,   7.9649743E-03,   8.1993509E-03
     +,   8.4531391E-03,   8.7264525E-03,   9.0192296E-03
     +,   9.3312906E-03,   9.6622603E-03,   1.0011665E-02
     +,   1.0378828E-02,   1.0762987E-02,   1.1163199E-02
     +,   1.1578459E-02,   1.2007648E-02,   1.2449558E-02
     +,   1.2902931E-02,   1.3366512E-02,   1.3839047E-02
     +,   1.4319276E-02,   1.4806069E-02,   1.5298311E-02
     +,   1.5795076E-02,   1.6295528E-02,   1.6799035E-02
     +,   1.7305102E-02,   1.7813448E-02,   1.8323962E-02
     +,   1.8836699E-02,   1.9351931E-02,   1.9869996E-02
     +,   2.0391349E-02,   2.0916566E-02,   2.1446232E-02
     +,   2.1980902E-02,   2.2521114E-02,   2.3067275E-02
     +,   2.3619739E-02,   2.4178676E-02,   2.4744162E-02
     +,   2.5316127E-02,   2.5894493E-02,   2.6479021E-02
     +,   2.7069679E-02,   2.7666563E-02,   2.8270014E-02
     +,   2.8880816E-02,   2.9500410E-02,   3.0130984E-02
     +,   3.0775605E-02,   3.1438526E-02,   3.2125186E-02
     +,   3.2842468E-02,   3.3598691E-02,   3.4403730E-02
     +,   3.5268892E-02,   3.6206912E-02,   3.7231579E-02
     +,   3.8357675E-02,   3.9600346E-02,   4.0974516E-02
     +,   4.2494409E-02,   4.4172835E-02,   4.6020392E-02
     +,   4.8044730E-02,   5.0250109E-02,   5.2637130E-02
     +,   5.5202626E-02,   5.7939723E-02,   6.0839038E-02
     +,   6.3889399E-02,   6.7079306E-02,   7.0398122E-02
     +,   7.3838100E-02,   7.7395245E-02,   8.1069350E-02
     +,   8.4864743E-02,   8.8789545E-02,   9.2854768E-02
     +,   9.7072966E-02,   0.1014581    ,   0.1060262    
     +,   0.1107956    ,   0.1157888    ,   0.1210338    
     +,   0.1265625    ,   0.1324080    ,   0.1385982    
     +,   0.1451490    ,   0.1520594    ,   0.1593106    
     +,   0.1668779    ,   0.1747518    ,   0.1829711    
     +,   0.1916610    ,   0.2010795    ,   0.2116703    
     +,   0.2241179    ,   0.2393880    ,   0.2587066    
     +,   0.2834051    ,   0.3145969    ,   0.3527933    
     +,   0.3977255    ,   0.4487247    ,   0.5057953    
     +,   0.5708920    ,   0.6481403    ,   0.7417189    
     +,   0.8517703    ,   0.9712766    ,    1.087744    
     +,    1.190181    ,    1.276154    ,    1.351703    
     +,    1.423222    ,    1.489359    ,    1.540786    
     +,    1.566625    ,    1.561704    ,    1.531209    
     +,    1.490404    ,    1.456952    ,    1.439120    
     +,    1.430258    ,    1.415225    ,    1.381174    
     +,    1.322050    ,    1.237087    ,    1.130295    
     +,    1.011939    ,   0.8970183    ,   0.7991607    
     +,   0.7245694    ,   0.6706749    ,   0.6297217    
     +,   0.5939639    ,   0.5590305    ,   0.5241919    
     +,   0.4906108    ,   0.4594044    ,   0.4306912    
     +,   0.4037015    ,   0.3773988    ,   0.3510627    
     +,   0.3245734    ,   0.2983911    ,   0.2733312    
     +,   0.2502736    ,   0.2299118    ,   0.2125998    
     +,   0.1983099    ,   0.1866921    ,   0.1771946    
     +,   0.1691963    ,   0.1621169    ,   0.1554880    
     +,   0.1489811    ,   0.1424024    ,   0.1356667    
     +,   0.1287657    ,   0.1217397    ,   0.1146540    
     +,   0.1075833    ,   0.1006021    ,   9.3779959E-02
     +,   8.7177098E-02,   8.0842324E-02,   7.4812666E-02
     +,   6.9113374E-02,   6.3758031E-02,   5.8749609E-02
     +,   5.4082420E-02,   4.9744647E-02,   4.5719516E-02
     +,   4.1987702E-02,   3.8529187E-02,   3.5324235E-02
     +,   3.2353930E-02,   2.9600982E-02,   2.7049910E-02
     +,   2.4686804E-02,   2.2499047E-02,   2.0475188E-02
     +,   1.8604945E-02,   1.6878795E-02,   1.5287772E-02
     +,   1.3823506E-02,   1.2478253E-02,   1.1244587E-02
     +,   1.0115482E-02,   9.0843504E-03,   8.1448955E-03
     +,   7.2910241E-03,   6.5168794E-03,   5.8168531E-03
     +,   5.1855110E-03,   4.6175378E-03,   4.1078078E-03
     +,   3.6514155E-03,   3.2436042E-03,   2.8798897E-03
     +,   2.5559815E-03,   2.2679013E-03,   2.0119068E-03
     +,   1.7845809E-03,   1.5827675E-03,   1.4036294E-03
     +,   1.2445860E-03,   1.1033488E-03,   9.7786658E-04
     +,   8.6632546E-04,   7.6713448E-04,   6.7888177E-04
     +,   6.0033915E-04,   5.3041877E-04,   4.6817452E-04
     +,   4.1276705E-04,   3.6346421E-04,   3.1961309E-04
     +,   2.8064111E-04,   2.4603427E-04,   2.1533883E-04
     +,   1.8814491E-04,   1.6408844E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_hzonly_ttz95_mass = Yx/12.2077664680851
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_hzonly_hatt100_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  6.9135414E-03,   7.2013889E-03
     +,   7.4940696E-03,   7.7910046E-03,   8.0915568E-03
     +,   8.3950283E-03,   8.7006819E-03,   9.0077361E-03
     +,   9.3153557E-03,   9.6226940E-03,   9.9288421E-03
     +,   1.0232876E-02,   1.0533861E-02,   1.0830838E-02
     +,   1.1122839E-02,   1.1408908E-02,   1.1688086E-02
     +,   1.1959445E-02,   1.2222067E-02,   1.2475076E-02
     +,   1.2717642E-02,   1.2948968E-02,   1.3168323E-02
     +,   1.3375059E-02,   1.3568556E-02,   1.3748310E-02
     +,   1.3913897E-02,   1.4064942E-02,   1.4201217E-02
     +,   1.4322562E-02,   1.4428913E-02,   1.4520323E-02
     +,   1.4596937E-02,   1.4659010E-02,   1.4706904E-02
     +,   1.4741079E-02,   1.4762093E-02,   1.4770605E-02
     +,   1.4767390E-02,   1.4753287E-02,   1.4729246E-02
     +,   1.4696282E-02,   1.4655527E-02,   1.4608140E-02
     +,   1.4555395E-02,   1.4498592E-02,   1.4439114E-02
     +,   1.4378398E-02,   1.4317893E-02,   1.4259133E-02
     +,   1.4203636E-02,   1.4152986E-02,   1.4108745E-02
     +,   1.4072500E-02,   1.4045823E-02,   1.4030289E-02
     +,   1.4027435E-02,   1.4038773E-02,   1.4065751E-02
     +,   1.4109777E-02,   1.4172188E-02,   1.4254209E-02
     +,   1.4356999E-02,   1.4481585E-02,   1.4628870E-02
     +,   1.4799602E-02,   1.4994402E-02,   1.5213689E-02
     +,   1.5457713E-02,   1.5726527E-02,   1.6019978E-02
     +,   1.6337676E-02,   1.6679045E-02,   1.7043231E-02
     +,   1.7429193E-02,   1.7835645E-02,   1.8261047E-02
     +,   1.8703654E-02,   1.9161506E-02,   1.9632448E-02
     +,   2.0114105E-02,   2.0603988E-02,   2.1099392E-02
     +,   2.1597547E-02,   2.2095550E-02,   2.2590449E-02
     +,   2.3079207E-02,   2.3558863E-02,   2.4026368E-02
     +,   2.4478821E-02,   2.4913345E-02,   2.5327217E-02
     +,   2.5717810E-02,   2.6082683E-02,   2.6419610E-02
     +,   2.6726551E-02,   2.7001692E-02,   2.7243473E-02
     +,   2.7450608E-02,   2.7622040E-02,   2.7757015E-02
     +,   2.7855011E-02,   2.7915822E-02,   2.7939474E-02
     +,   2.7926238E-02,   2.7876658E-02,   2.7791508E-02
     +,   2.7671756E-02,   2.7518608E-02,   2.7333410E-02
     +,   2.7117729E-02,   2.6873240E-02,   2.6601780E-02
     +,   2.6305273E-02,   2.5985772E-02,   2.5645368E-02
     +,   2.5286250E-02,   2.4910625E-02,   2.4520760E-02
     +,   2.4118902E-02,   2.3707321E-02,   2.3288259E-02
     +,   2.2863967E-02,   2.2436641E-02,   2.2008387E-02
     +,   2.1581342E-02,   2.1157499E-02,   2.0738846E-02
     +,   2.0327225E-02,   1.9924456E-02,   1.9532211E-02
     +,   1.9152125E-02,   1.8785674E-02,   1.8434308E-02
     +,   1.8099319E-02,   1.7781924E-02,   1.7483259E-02
     +,   1.7204365E-02,   1.6946206E-02,   1.6709648E-02
     +,   1.6495530E-02,   1.6304620E-02,   1.6137641E-02
     +,   1.5995290E-02,   1.5878269E-02,   1.5787233E-02
     +,   1.5722880E-02,   1.5685940E-02,   1.5677171E-02
     +,   1.5697364E-02,   1.5747385E-02,   1.5828181E-02
     +,   1.5940746E-02,   1.6086172E-02,   1.6265646E-02
     +,   1.6480420E-02,   1.6731849E-02,   1.7021371E-02
     +,   1.7350530E-02,   1.7720908E-02,   1.8134195E-02
     +,   1.8592194E-02,   1.9096702E-02,   1.9649630E-02
     +,   2.0252939E-02,   2.0908698E-02,   2.1618947E-02
     +,   2.2385780E-02,   2.3211345E-02,   2.4097813E-02
     +,   2.5047252E-02,   2.6061643E-02,   2.7142905E-02
     +,   2.8292701E-02,   2.9512284E-02,   3.0802544E-02
     +,   3.2163799E-02,   3.3595506E-02,   3.5096150E-02
     +,   3.6663190E-02,   3.8292751E-02,   3.9979551E-02
     +,   4.1716728E-02,   4.3495998E-02,   4.5307811E-02
     +,   4.7141280E-02,   4.8984867E-02,   5.0826978E-02
     +,   5.2656632E-02,   5.4464109E-02,   5.6242459E-02
     +,   5.7988342E-02,   5.9702937E-02,   6.1393052E-02
     +,   6.3072078E-02,   6.4760186E-02,   6.6484578E-02
     +,   6.8279356E-02,   7.0185244E-02,   7.2249435E-02
     +,   7.4525602E-02,   7.7074446E-02,   7.9966180E-02
     +,   8.3282977E-02,   8.7121993E-02,   9.1599390E-02
     +,   9.6851557E-02,   0.1030331    ,   0.1103110    
     +,   0.1188520    ,   0.1288058    ,   0.1402822    
     +,   0.1533304    ,   0.1679212    ,   0.1839345    
     +,   0.2011576    ,   0.2192966    ,   0.2380067    
     +,   0.2569432    ,   0.2758365    ,   0.2945966    
     +,   0.3134157    ,   0.3328365    ,   0.3537500    
     +,   0.3772819    ,   0.4045710    ,   0.4364877    
     +,   0.4733870    ,   0.5149819    ,   0.5603722    
     +,   0.6082244    ,   0.6570050    ,   0.7051759    
     +,   0.7512583    ,   0.7937815    ,   0.8312092    
     +,   0.8619148    ,   0.8842951    ,   0.8970076    
     +,   0.8992432    ,   0.8908956    ,   0.8725845    
     +,   0.8454733    ,   0.8109598    ,   0.7703646    
     +,   0.7247170    ,   0.6747231    ,   0.6209227    
     +,   0.5639493    ,   0.5047821    ,   0.4448353    
     +,   0.3858753    ,   0.3297753    ,   0.2781984    
     +,   0.2323304    ,   0.1927510    ,   0.1594486    
     +,   0.1319481    ,   0.1094915    ,   9.1221832E-02
     +,   7.6320618E-02,   6.4084195E-02,   5.3952210E-02
     +,   4.5500349E-02,   3.8414948E-02,   3.2460887E-02
     +,   2.7456475E-02,   2.3254566E-02,   1.9730730E-02
     +,   1.6777115E-02,   1.4300132E-02,   1.2219636E-02
     +,   1.0467932E-02,   8.9887604E-03,   7.7361655E-03
     +,   6.6729635E-03,   5.7688393E-03,   4.9991272E-03
     +,   4.3433183E-03,   3.7842628E-03,   3.3072981E-03
     +,   2.8998978E-03,   2.5512080E-03,   2.2519291E-03
     +,   1.9940538E-03,   1.7708082E-03,   1.5764683E-03
     +,   1.4062637E-03,   1.2562753E-03,   1.1232814E-03
     +,   1.0046877E-03,   8.9839089E-04,   8.0271810E-04
     +,   7.1631925E-04,   6.3812250E-04,   5.6725385E-04
     +,   5.0300959E-04,   4.4479815E-04,   3.9212647E-04
     +,   3.4456007E-04,   3.0171825E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_hzonly_hatt100_mass = Yx/6.89726588372093
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_hzonly_hatt105_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  6.7777827E-02,   7.2277434E-02
     +,   7.6801084E-02,   8.1319414E-02,   8.5801996E-02
     +,   9.0217352E-02,   9.4533905E-02,   9.8719984E-02
     +,   0.1027449    ,   0.1065796    ,   0.1101965    
     +,   0.1135715    ,   0.1166830    ,   0.1195138    
     +,   0.1220506    ,   0.1242848    ,   0.1262126    
     +,   0.1278346    ,   0.1291566    ,   0.1301883    
     +,   0.1309432    ,   0.1314385    ,   0.1316931    
     +,   0.1317287    ,   0.1315670    ,   0.1312303    
     +,   0.1307402    ,   0.1301169    ,   0.1293789    
     +,   0.1285427    ,   0.1276221    ,   0.1266291    
     +,   0.1255732    ,   0.1244622    ,   0.1233027    
     +,   0.1221003    ,   0.1208601    ,   0.1195877    
     +,   0.1182889    ,   0.1169709    ,   0.1156416    
     +,   0.1143103    ,   0.1129876    ,   0.1116847    
     +,   0.1104135    ,   0.1091859    ,   0.1080134    
     +,   0.1069064    ,   0.1058739    ,   0.1049232    
     +,   0.1040588    ,   0.1032835    ,   0.1025969    
     +,   0.1019965    ,   0.1014771    ,   0.1010324    
     +,   0.1006538    ,   0.1003323    ,   0.1000584    
     +,   9.9822536E-02,   9.9616401E-02,   9.9432342E-02
     +,   9.9264570E-02,   9.9109024E-02,   9.8963164E-02
     +,   9.8826773E-02,   9.8701000E-02,   9.8588593E-02
     +,   9.8493114E-02,   9.8418802E-02,   9.8370053E-02
     +,   9.8351061E-02,   9.8364778E-02,   9.8413400E-02
     +,   9.8497413E-02,   9.8615445E-02,   9.8764494E-02
     +,   9.8939523E-02,   9.9133924E-02,   9.9339485E-02
     +,   9.9546969E-02,   9.9746071E-02,   9.9926271E-02
     +,   0.1000773    ,   0.1001892    ,   0.1002530    
     +,   0.1002611    ,   0.1002078    ,   0.1000891    
     +,   9.9903338E-02,   9.9650666E-02,   9.9333860E-02
     +,   9.8957509E-02,   9.8527923E-02,   9.8053373E-02
     +,   9.7543240E-02,   9.7007968E-02,   9.6458487E-02
     +,   9.5906049E-02,   9.5361933E-02,   9.4836518E-02
     +,   9.4339743E-02,   9.3880281E-02,   9.3465902E-02
     +,   9.3102582E-02,   9.2795178E-02,   9.2546865E-02
     +,   9.2359483E-02,   9.2233546E-02,   9.2168301E-02
     +,   9.2162199E-02,   9.2212461E-02,   9.2315897E-02
     +,   9.2468917E-02,   9.2667408E-02,   9.2907302E-02
     +,   9.3184285E-02,   9.3494236E-02,   9.3833037E-02
     +,   9.4196580E-02,   9.4580956E-02,   9.4982103E-02
     +,   9.5396057E-02,   9.5818572E-02,   9.6245326E-02
     +,   9.6671604E-02,   9.7092591E-02,   9.7503036E-02
     +,   9.7897172E-02,   9.8269135E-02,   9.8612696E-02
     +,   9.8921277E-02,   9.9188335E-02,   9.9407099E-02
     +,   9.9570908E-02,   9.9673025E-02,   9.9707268E-02
     +,   9.9667430E-02,   9.9547952E-02,   9.9343717E-02
     +,   9.9050067E-02,   9.8663285E-02,   9.8180316E-02
     +,   9.7599156E-02,   9.6918695E-02,   9.6139267E-02
     +,   9.5262006E-02,   9.4289988E-02,   9.3227573E-02
     +,   9.2080802E-02,   9.0857528E-02,   8.9567520E-02
     +,   8.8222221E-02,   8.6835213E-02,   8.5421860E-02
     +,   8.3999202E-02,   8.2586206E-02,   8.1203140E-02
     +,   7.9871655E-02,   7.8614667E-02,   7.7455878E-02
     +,   7.6419629E-02,   7.5530939E-02,   7.4814893E-02
     +,   7.4296750E-02,   7.4001685E-02,   7.3954716E-02
     +,   7.4180551E-02,   7.4703328E-02,   7.5546697E-02
     +,   7.6733381E-02,   7.8284636E-02,   8.0220520E-02
     +,   8.2558617E-02,   8.5313462E-02,   8.8496163E-02
     +,   9.2113003E-02,   9.6164770E-02,   0.1006454    
     +,   0.1055419    ,   0.1108335    ,   0.1164911    
     +,   0.1224771    ,   0.1287481    ,   0.1352547    
     +,   0.1419433    ,   0.1487596    ,   0.1556514    
     +,   0.1625720    ,   0.1694820    ,   0.1763542    
     +,   0.1831744    ,   0.1899423    ,   0.1966722    
     +,   0.2033907    ,   0.2101351    ,   0.2169464    
     +,   0.2238657    ,   0.2309283    ,   0.2381572    
     +,   0.2455568    ,   0.2531085    ,   0.2607697    
     +,   0.2684712    ,   0.2761175    ,   0.2835933    
     +,   0.2907651    ,   0.2974899    ,   0.3036216    
     +,   0.3090180    ,   0.3135483    ,   0.3170994    
     +,   0.3195799    ,   0.3209237    ,   0.3210938    
     +,   0.3200796    ,   0.3178987    ,   0.3145943    
     +,   0.3102314    ,   0.3048941    ,   0.2986806    
     +,   0.2917001    ,   0.2840659    ,   0.2758942    
     +,   0.2672955    ,   0.2583751    ,   0.2492287    
     +,   0.2399405    ,   0.2305827    ,   0.2212142    
     +,   0.2118841    ,   0.2026317    ,   0.1934875    
     +,   0.1844762    ,   0.1756193    ,   0.1669352    
     +,   0.1584405    ,   0.1501521    ,   0.1420863    
     +,   0.1342586    ,   0.1266833    ,   0.1193737    
     +,   0.1123413    ,   0.1055942    ,   9.9138156E-02
     +,   9.2975423E-02,   8.7106116E-02,   8.1526585E-02
     +,   7.6231211E-02,   7.1212806E-02,   6.6462360E-02
     +,   6.1970104E-02,   5.7726182E-02,   5.3720694E-02
     +,   4.9943935E-02,   4.6386577E-02,   4.3040283E-02
     +,   3.9897151E-02,   3.6949575E-02,   3.4190483E-02
     +,   3.1613126E-02,   2.9210947E-02,   2.6977113E-02
     +,   2.4904732E-02,   2.2986904E-02,   2.1216294E-02
     +,   1.9585310E-02,   1.8086340E-02,   1.6711531E-02
     +,   1.5452890E-02,   1.4302437E-02,   1.3252344E-02
     +,   1.2294960E-02,   1.1422802E-02,   1.0628700E-02
     +,   9.9059306E-03,   9.2480723E-03,   8.6492086E-03
     +,   8.1037730E-03,   7.6067159E-03,   7.1533443E-03
     +,   6.7394404E-03,   6.3611181E-03,   6.0149133E-03
     +,   5.6976555E-03,   5.4065241E-03,   5.1389537E-03
     +,   4.8926445E-03,   4.6655433E-03,   4.4557825E-03
     +,   4.2617037E-03,   4.0817908E-03,   3.9147004E-03
     +,   3.7591984E-03,   3.6141919E-03,   3.4786735E-03
     +,   3.3517510E-03,   3.2325999E-03,   3.1204908E-03
     +,   3.0147498E-03,   2.9147814E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_hzonly_hatt105_mass = Yx/8.01646363636364
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_hzonly_hatt107_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  6.8622373E-02,   7.3527262E-02
     +,   7.8475021E-02,   8.3433062E-02,   8.8367589E-02
     +,   9.3244560E-02,   9.8030061E-02,   0.1026912    
     +,   0.1071964    ,   0.1115164    ,   0.1156247    
     +,   0.1194977    ,   0.1231155    ,   0.1264619    
     +,   0.1295245    ,   0.1322951    ,   0.1347690    
     +,   0.1369449    ,   0.1388253    ,   0.1404149    
     +,   0.1417211    ,   0.1427531    ,   0.1435215    
     +,   0.1440383    ,   0.1443157    ,   0.1443669    
     +,   0.1442053    ,   0.1438440    ,   0.1432967    
     +,   0.1425773    ,   0.1416996    ,   0.1406780    
     +,   0.1395276    ,   0.1382633    ,   0.1369012    
     +,   0.1354579    ,   0.1339501    ,   0.1323950    
     +,   0.1308098    ,   0.1292115    ,   0.1276165    
     +,   0.1260403    ,   0.1244971    ,   0.1229995    
     +,   0.1215581    ,   0.1201817    ,   0.1188766    
     +,   0.1176464    ,   0.1164930    ,   0.1154156    
     +,   0.1144115    ,   0.1134763    ,   0.1126044    
     +,   0.1117885    ,   0.1110214    ,   0.1102953    
     +,   0.1096028    ,   0.1089366    ,   0.1082907    
     +,   0.1076601    ,   0.1070406    ,   0.1064298    
     +,   0.1058265    ,   0.1052307    ,   0.1046434    
     +,   0.1040672    ,   0.1035051    ,   0.1029604    
     +,   0.1024377    ,   0.1019411    ,   0.1014749    
     +,   0.1010433    ,   0.1006502    ,   0.1002991    
     +,   9.9993266E-02,   9.9735424E-02,   9.9527851E-02
     +,   9.9372514E-02,   9.9271059E-02,   9.9224709E-02
     +,   9.9234574E-02,   9.9301353E-02,   9.9425472E-02
     +,   9.9607356E-02,   9.9846728E-02,   0.1001429    
     +,   0.1004951    ,   0.1009015    ,   0.1013597    
     +,   0.1018665    ,   0.1024175    ,   0.1030077    
     +,   0.1036304    ,   0.1042783    ,   0.1049423    
     +,   0.1056129    ,   0.1062789    ,   0.1069287    
     +,   0.1075496    ,   0.1081288    ,   0.1086529    
     +,   0.1091089    ,   0.1094840    ,   0.1097662    
     +,   0.1099447    ,   0.1100098    ,   0.1099536    
     +,   0.1097702    ,   0.1094559    ,   0.1090087    
     +,   0.1084296    ,   0.1077217    ,   0.1068900    
     +,   0.1059423    ,   0.1048876    ,   0.1037368    
     +,   0.1025024    ,   0.1011975    ,   9.9835962E-02
     +,   9.8431937E-02,   9.6999340E-02,   9.5551752E-02
     +,   9.4102174E-02,   9.2662476E-02,   9.1243491E-02
     +,   8.9854740E-02,   8.8504389E-02,   8.7199524E-02
     +,   8.5945494E-02,   8.4746875E-02,   8.3606727E-02
     +,   8.2527369E-02,   8.1510149E-02,   8.0555826E-02
     +,   7.9664499E-02,   7.8835897E-02,   7.8069508E-02
     +,   7.7364616E-02,   7.6720461E-02,   7.6136135E-02
     +,   7.5610898E-02,   7.5144291E-02,   7.4735612E-02
     +,   7.4384637E-02,   7.4091278E-02,   7.3855594E-02
     +,   7.3678024E-02,   7.3559090E-02,   7.3499642E-02
     +,   7.3500834E-02,   7.3564008E-02,   7.3690504E-02
     +,   7.3882177E-02,   7.4140750E-02,   7.4468091E-02
     +,   7.4866034E-02,   7.5336292E-02,   7.5880639E-02
     +,   7.6500468E-02,   7.7197120E-02,   7.7971488E-02
     +,   7.8824431E-02,   7.9756498E-02,   8.0767922E-02
     +,   8.1858985E-02,   8.3029702E-02,   8.4280111E-02
     +,   8.5610271E-02,   8.7020315E-02,   8.8510536E-02
     +,   9.0081446E-02,   9.1733634E-02,   9.3468308E-02
     +,   9.5286943E-02,   9.7191416E-02,   9.9184394E-02
     +,   0.1012697    ,   0.1034515    ,   0.1057356    
     +,   0.1081292    ,   0.1106407    ,   0.1132804    
     +,   0.1160596    ,   0.1189916    ,   0.1220902    
     +,   0.1253698    ,   0.1288446    ,   0.1325281    
     +,   0.1364327    ,   0.1405681    ,   0.1449418    
     +,   0.1495584    ,   0.1544189    ,   0.1595219    
     +,   0.1648641    ,   0.1704403    ,   0.1762452    
     +,   0.1822731    ,   0.1885210    ,   0.1949874    
     +,   0.2016723    ,   0.2085776    ,   0.2157069    
     +,   0.2230621    ,   0.2306413    ,   0.2384374    
     +,   0.2464341    ,   0.2546016    ,   0.2628947    
     +,   0.2712512    ,   0.2795878    ,   0.2878005    
     +,   0.2957644    ,   0.3033366    ,   0.3103592    
     +,   0.3166639    ,   0.3220782    ,   0.3264335    
     +,   0.3295743    ,   0.3313628    ,   0.3316927    
     +,   0.3304900    ,   0.3277225    ,   0.3233995    
     +,   0.3175754    ,   0.3103432    ,   0.3018343    
     +,   0.2922081    ,   0.2816446    ,   0.2703355    
     +,   0.2584754    ,   0.2462530    ,   0.2338431    
     +,   0.2214017    ,   0.2090649    ,   0.1969430    
     +,   0.1851241    ,   0.1736748    ,   0.1626436    
     +,   0.1520617    ,   0.1419484    ,   0.1323139    
     +,   0.1231613    ,   0.1144887    ,   0.1062903    
     +,   9.8558821E-02,   9.1284767E-02,   8.4456600E-02
     +,   7.8061260E-02,   7.2084665E-02,   6.6510834E-02
     +,   6.1322380E-02,   5.6501303E-02,   5.2028548E-02
     +,   4.7884442E-02,   4.4049181E-02,   4.0503446E-02
     +,   3.7228335E-02,   3.4205493E-02,   3.1417400E-02
     +,   2.8847842E-02,   2.6481470E-02,   2.4303822E-02
     +,   2.2301456E-02,   2.0461917E-02,   1.8773437E-02
     +,   1.7224971E-02,   1.5806220E-02,   1.4507496E-02
     +,   1.3319572E-02,   1.2233749E-02,   1.1241910E-02
     +,   1.0336395E-02,   9.5099732E-03,   8.7558813E-03
     +,   8.0678863E-03,   7.4401181E-03,   6.8672230E-03
     +,   6.3442052E-03,   5.8665518E-03,   5.4300674E-03
     +,   5.0309855E-03,   4.6658390E-03,   4.3315254E-03
     +,   4.0251813E-03,   3.7442644E-03,   3.4864452E-03
     +,   3.2496178E-03,   3.0318962E-03,   2.8315473E-03
     +,   2.6470278E-03,   2.4769139E-03,   2.3199383E-03
     +,   2.1749288E-03,   2.0408425E-03,   1.9167139E-03
     +,   1.8016831E-03,   1.6949552E-03,   1.5958206E-03
     +,   1.5036261E-03,   1.4177883E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_hzonly_hatt107_mass = Yx/8.0734696
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_hzonly_hatt110_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  5.8086604E-02,   6.2004834E-02
     +,   6.6013917E-02,   7.0103295E-02,   7.4261576E-02
     +,   7.8476466E-02,   8.2734555E-02,   8.7021329E-02
     +,   9.1320723E-02,   9.5615871E-02,   9.9887975E-02
     +,   0.1041171    ,   0.1082821    ,   0.1123606    
     +,   0.1163296    ,   0.1201660    ,   0.1238463    
     +,   0.1273484    ,   0.1306513    ,   0.1337360    
     +,   0.1365866    ,   0.1391905    ,   0.1415385    
     +,   0.1436268    ,   0.1454553    ,   0.1470293    
     +,   0.1483583    ,   0.1494562    ,   0.1503409    
     +,   0.1510331    ,   0.1515560    ,   0.1519341    
     +,   0.1521925    ,   0.1523557    ,   0.1524465    
     +,   0.1524861    ,   0.1524923    ,   0.1524798    
     +,   0.1524593    ,   0.1524382    ,   0.1524197    
     +,   0.1524033    ,   0.1523859    ,   0.1523612    
     +,   0.1523206    ,   0.1522537    ,   0.1521492    
     +,   0.1519946    ,   0.1517775    ,   0.1514854    
     +,   0.1511064    ,   0.1506293    ,   0.1500437    
     +,   0.1493411    ,   0.1485133    ,   0.1475544    
     +,   0.1464595    ,   0.1452261    ,   0.1438530    
     +,   0.1423410    ,   0.1406937    ,   0.1389161    
     +,   0.1370159    ,   0.1350031    ,   0.1328896    
     +,   0.1306900    ,   0.1284209    ,   0.1261007    
     +,   0.1237490    ,   0.1213872    ,   0.1190369    
     +,   0.1167206    ,   0.1144599    ,   0.1122764    
     +,   0.1101897    ,   0.1082181    ,   0.1063777    
     +,   0.1046818    ,   0.1031410    ,   0.1017623    
     +,   0.1005501    ,   9.9504963E-02,   9.8624557E-02
     +,   9.7903542E-02,   9.7333491E-02,   9.6903920E-02
     +,   9.6602105E-02,   9.6413702E-02,   9.6323110E-02
     +,   9.6314341E-02,   9.6370831E-02,   9.6476100E-02
     +,   9.6614487E-02,   9.6770786E-02,   9.6931137E-02
     +,   9.7082958E-02,   9.7214766E-02,   9.7316861E-02
     +,   9.7381026E-02,   9.7400352E-02,   9.7369492E-02
     +,   9.7284518E-02,   9.7142689E-02,   9.6941963E-02
     +,   9.6681915E-02,   9.6362382E-02,   9.5984280E-02
     +,   9.5548972E-02,   9.5058218E-02,   9.4514236E-02
     +,   9.3919642E-02,   9.3277074E-02,   9.2589401E-02
     +,   9.1859885E-02,   9.1091461E-02,   9.0287238E-02
     +,   8.9450173E-02,   8.8583395E-02,   8.7689668E-02
     +,   8.6771645E-02,   8.5831724E-02,   8.4872313E-02
     +,   8.3895355E-02,   8.2902379E-02,   8.1894830E-02
     +,   8.0873810E-02,   7.9839975E-02,   7.8793846E-02
     +,   7.7735513E-02,   7.6665089E-02,   7.5582266E-02
     +,   7.4486807E-02,   7.3378347E-02,   7.2256573E-02
     +,   7.1121342E-02,   6.9972649E-02,   6.8810686E-02
     +,   6.7636259E-02,   6.6450372E-02,   6.5254539E-02
     +,   6.4050868E-02,   6.2842049E-02,   6.1631367E-02
     +,   6.0422614E-02,   5.9220392E-02,   5.8029711E-02
     +,   5.6856234E-02,   5.5706136E-02,   5.4586142E-02
     +,   5.3503204E-02,   5.2464768E-02,   5.1478423E-02
     +,   5.0552052E-02,   4.9693536E-02,   4.8910771E-02
     +,   4.8211511E-02,   4.7603581E-02,   4.7094360E-02
     +,   4.6690941E-02,   4.6400100E-02,   4.6228312E-02
     +,   4.6181273E-02,   4.6264462E-02,   4.6482712E-02
     +,   4.6840131E-02,   4.7340419E-02,   4.7986485E-02
     +,   4.8780549E-02,   4.9724150E-02,   5.0818142E-02
     +,   5.2062560E-02,   5.3456694E-02,   5.4999128E-02
     +,   5.6687795E-02,   5.8519993E-02,   6.0492568E-02
     +,   6.2602237E-02,   6.4845562E-02,   6.7219615E-02
     +,   6.9722183E-02,   7.2352707E-02,   7.5112030E-02
     +,   7.8003854E-02,   8.1035070E-02,   8.4216408E-02
     +,   8.7562665E-02,   9.1093592E-02,   9.4833761E-02
     +,   9.8812744E-02,   0.1030642    ,   0.1076255    
     +,   0.1125364    ,   0.1178374    ,   0.1235672    
     +,   0.1297613    ,   0.1364489    ,   0.1436505    
     +,   0.1513751    ,   0.1596190    ,   0.1683642    
     +,   0.1775763    ,   0.1872053    ,   0.1971875    
     +,   0.2074460    ,   0.2178920    ,   0.2284294    
     +,   0.2389580    ,   0.2493738    ,   0.2595744    
     +,   0.2694604    ,   0.2789372    ,   0.2879152    
     +,   0.2963118    ,   0.3040508    ,   0.3110631    
     +,   0.3172863    ,   0.3226640    ,   0.3271491    
     +,   0.3307031    ,   0.3332956    ,   0.3349098    
     +,   0.3355407    ,   0.3351955    ,   0.3338956    
     +,   0.3316746    ,   0.3285780    ,   0.3246600    
     +,   0.3199826    ,   0.3146108    ,   0.3086115    
     +,   0.3020498    ,   0.2949890    ,   0.2874857    
     +,   0.2795921    ,   0.2713564    ,   0.2628207    
     +,   0.2540238    ,   0.2450029    ,   0.2357937    
     +,   0.2264314    ,   0.2169514    ,   0.2073906    
     +,   0.1977876    ,   0.1881810    ,   0.1786094    
     +,   0.1691130    ,   0.1597310    ,   0.1505016    
     +,   0.1414606    ,   0.1326434    ,   0.1240816    
     +,   0.1158042    ,   0.1078380    ,   0.1002059    
     +,   9.2926964E-02,   8.6016111E-02,   7.9484843E-02
     +,   7.3340312E-02,   6.7585066E-02,   6.2217455E-02
     +,   5.7232298E-02,   5.2620653E-02,   4.8369929E-02
     +,   4.4464860E-02,   4.0888306E-02,   3.7620969E-02
     +,   3.4642633E-02,   3.1932611E-02,   2.9470138E-02
     +,   2.7234668E-02,   2.5206350E-02,   2.3366477E-02
     +,   2.1697383E-02,   2.0182623E-02,   1.8806998E-02
     +,   1.7556773E-02,   1.6419273E-02,   1.5383149E-02
     +,   1.4438008E-02,   1.3574597E-02,   1.2784455E-02
     +,   1.2060064E-02,   1.1394542E-02,   1.0781804E-02
     +,   1.0216278E-02,   9.6930424E-03,   9.2076426E-03
     +,   8.7560872E-03,   8.3348723E-03,   7.9408232E-03
     +,   7.5711873E-03,   7.2234850E-03,   6.8955827E-03
     +,   6.5855645E-03,   6.2917983E-03,   6.0128188E-03
     +,   5.7473853E-03,   5.4943818E-03,   5.2528637E-03
     +,   5.0219791E-03,   4.8010042E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_hzonly_hatt110_mass = Yx/8.29555533333333
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_hzonly_hatt115_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  5.5120025E-02,   5.8832597E-02
     +,   6.2642127E-02,   6.6539258E-02,   7.0513785E-02
     +,   7.4554220E-02,   7.8648046E-02,   8.2781337E-02
     +,   8.6938784E-02,   9.1103986E-02,   9.5258839E-02
     +,   9.9384211E-02,   0.1034596    ,   0.1074636    
     +,   0.1113739    ,   0.1151679    ,   0.1188229    
     +,   0.1223165    ,   0.1256273    ,   0.1287349    
     +,   0.1316210    ,   0.1342695    ,   0.1366670    
     +,   0.1388035    ,   0.1406715    ,   0.1422683    
     +,   0.1435940    ,   0.1446525    ,   0.1454519    
     +,   0.1460028    ,   0.1463196    ,   0.1464190    
     +,   0.1463203    ,   0.1460443    ,   0.1456137    
     +,   0.1450520    ,   0.1443828    ,   0.1436304    
     +,   0.1428182    ,   0.1419691    ,   0.1411047    
     +,   0.1402454    ,   0.1394098    ,   0.1386144    
     +,   0.1378735    ,   0.1371991    ,   0.1366001    
     +,   0.1360833    ,   0.1356525    ,   0.1353085    
     +,   0.1350497    ,   0.1348716    ,   0.1347678    
     +,   0.1347292    ,   0.1347455    ,   0.1348047    
     +,   0.1348937    ,   0.1349995    ,   0.1351082    
     +,   0.1352067    ,   0.1352825    ,   0.1353239    
     +,   0.1353207    ,   0.1352638    ,   0.1351460    
     +,   0.1349613    ,   0.1347056    ,   0.1343758    
     +,   0.1339703    ,   0.1334886    ,   0.1329312    
     +,   0.1322993    ,   0.1315945    ,   0.1308191    
     +,   0.1299753    ,   0.1290658    ,   0.1280930    
     +,   0.1270596    ,   0.1259683    ,   0.1248216    
     +,   0.1236222    ,   0.1223727    ,   0.1210759    
     +,   0.1197348    ,   0.1183522    ,   0.1169313    
     +,   0.1154757    ,   0.1139887    ,   0.1124742    
     +,   0.1109360    ,   0.1093777    ,   0.1078036    
     +,   0.1062174    ,   0.1046231    ,   0.1030243    
     +,   0.1014244    ,   9.9826969E-02,   9.8234929E-02
     +,   9.6651137E-02,   9.5078066E-02,   9.3517996E-02
     +,   9.1972977E-02,   9.0444736E-02,   8.8934936E-02
     +,   8.7444946E-02,   8.5976146E-02,   8.4529772E-02
     +,   8.3107233E-02,   8.1709631E-02,   8.0338284E-02
     +,   7.8994662E-02,   7.7680148E-02,   7.6396383E-02
     +,   7.5144805E-02,   7.3927201E-02,   7.2745085E-02
     +,   7.1600251E-02,   7.0494182E-02,   6.9428183E-02
     +,   6.8403631E-02,   6.7421384E-02,   6.6482194E-02
     +,   6.5586478E-02,   6.4734131E-02,   6.3924782E-02
     +,   6.3157603E-02,   6.2431231E-02,   6.1744057E-02
     +,   6.1093874E-02,   6.0478259E-02,   5.9894294E-02
     +,   5.9338953E-02,   5.8808807E-02,   5.8300309E-02
     +,   5.7809856E-02,   5.7333782E-02,   5.6868419E-02
     +,   5.6410346E-02,   5.5956211E-02,   5.5502936E-02
     +,   5.5047803E-02,   5.4588430E-02,   5.4122832E-02
     +,   5.3649444E-02,   5.3167339E-02,   5.2675903E-02
     +,   5.2175134E-02,   5.1665504E-02,   5.1148053E-02
     +,   5.0624348E-02,   5.0096344E-02,   4.9566608E-02
     +,   4.9038127E-02,   4.8514284E-02,   4.7998838E-02
     +,   4.7496002E-02,   4.7010366E-02,   4.6546664E-02
     +,   4.6110142E-02,   4.5706086E-02,   4.5340106E-02
     +,   4.5017973E-02,   4.4745639E-02,   4.4529140E-02
     +,   4.4374540E-02,   4.4288088E-02,   4.4275928E-02
     +,   4.4344191E-02,   4.4498906E-02,   4.4746064E-02
     +,   4.5091357E-02,   4.5540433E-02,   4.6098571E-02
     +,   4.6770860E-02,   4.7562085E-02,   4.8476681E-02
     +,   4.9519014E-02,   5.0692916E-02,   5.2002113E-02
     +,   5.3450104E-02,   5.5040449E-02,   5.6776460E-02
     +,   5.8661483E-02,   6.0699139E-02,   6.2893182E-02
     +,   6.5247774E-02,   6.7767330E-02,   7.0456780E-02
     +,   7.3321760E-02,   7.6368071E-02,   7.9602316E-02
     +,   8.3031639E-02,   8.6663328E-02,   9.0505287E-02
     +,   9.4565667E-02,   9.8852903E-02,   0.1033750    
     +,   0.1081397    ,   0.1131545    ,   0.1184262    
     +,   0.1239598    ,   0.1297589    ,   0.1358252    
     +,   0.1421579    ,   0.1487522    ,   0.1556005    
     +,   0.1626900    ,   0.1700028    ,   0.1775153    
     +,   0.1851971    ,   0.1930124    ,   0.2009165    
     +,   0.2088580    ,   0.2167795    ,   0.2246163    
     +,   0.2322983    ,   0.2397518    ,   0.2469007    
     +,   0.2536691    ,   0.2599843    ,   0.2657779    
     +,   0.2709915    ,   0.2755773    ,   0.2795001    
     +,   0.2827412    ,   0.2852975    ,   0.2871824    
     +,   0.2884234    ,   0.2890607    ,   0.2891442    
     +,   0.2887285    ,   0.2878697    ,   0.2866189    
     +,   0.2850206    ,   0.2831081    ,   0.2808996    
     +,   0.2783994    ,   0.2755972    ,   0.2724693    
     +,   0.2689816    ,   0.2650947    ,   0.2607654    
     +,   0.2559542    ,   0.2506282    ,   0.2447646    
     +,   0.2383545    ,   0.2314044    ,   0.2239365    
     +,   0.2159885    ,   0.2076126    ,   0.1988730    
     +,   0.1898419    ,   0.1805989    ,   0.1712260    
     +,   0.1618042    ,   0.1524117    ,   0.1431222    
     +,   0.1340024    ,   0.1251107    ,   0.1164971    
     +,   0.1082032    ,   0.1002623    ,   9.2698991E-02
     +,   8.5530825E-02,   7.8769155E-02,   7.2418883E-02
     +,   6.6479690E-02,   6.0947321E-02,   5.5813584E-02
     +,   5.1066838E-02,   4.6692792E-02,   4.2675257E-02
     +,   3.8996350E-02,   3.5636652E-02,   3.2575898E-02
     +,   2.9793629E-02,   2.7268827E-02,   2.4981072E-02
     +,   2.2910045E-02,   2.1036394E-02,   1.9341456E-02
     +,   1.7807847E-02,   1.6419172E-02,   1.5160482E-02
     +,   1.4017950E-02,   1.2979203E-02,   1.2033015E-02
     +,   1.1169386E-02,   1.0379532E-02,   9.6556125E-03
     +,   8.9908382E-03,   8.3791791E-03,   7.8154597E-03
     +,   7.2950837E-03,   6.8140994E-03,   6.3689924E-03
     +,   5.9567112E-03,   5.5745263E-03,   5.2200425E-03
     +,   4.8910771E-03,   4.5856996E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_hzonly_hatt115_mass = Yx/7.96302054545454
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_hzonly_hatt120_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  5.9065927E-02,   6.2661842E-02
     +,   6.6295639E-02,   6.9952495E-02,   7.3617518E-02
     +,   7.7275530E-02,   8.0911689E-02,   8.4511183E-02
     +,   8.8059954E-02,   9.1544390E-02,   9.4951570E-02
     +,   9.8269276E-02,   0.1014862    ,   0.1045918    
     +,   0.1075765    ,   0.1104313    ,   0.1131482    
     +,   0.1157198    ,   0.1181395    ,   0.1204013    
     +,   0.1224998    ,   0.1244304    ,   0.1261890    
     +,   0.1277726    ,   0.1291789    ,   0.1304062    
     +,   0.1314545    ,   0.1323245    ,   0.1330184    
     +,   0.1335397    ,   0.1338934    ,   0.1340859    
     +,   0.1341250    ,   0.1340201    ,   0.1337815    
     +,   0.1334206    ,   0.1329495    ,   0.1323813    
     +,   0.1317289    ,   0.1310054    ,   0.1302233    
     +,   0.1293951    ,   0.1285321    ,   0.1276447    
     +,   0.1267425    ,   0.1258340    ,   0.1249261    
     +,   0.1240257    ,   0.1231379    ,   0.1222678    
     +,   0.1214194    ,   0.1205963    ,   0.1198025    
     +,   0.1190412    ,   0.1183158    ,   0.1176297    
     +,   0.1169862    ,   0.1163885    ,   0.1158394    
     +,   0.1153416    ,   0.1148966    ,   0.1145056    
     +,   0.1141684    ,   0.1138837    ,   0.1136488    
     +,   0.1134592    ,   0.1133097    ,   0.1131932    
     +,   0.1131011    ,   0.1130238    ,   0.1129514    
     +,   0.1128729    ,   0.1127772    ,   0.1126534    
     +,   0.1124913    ,   0.1122816    ,   0.1120160    
     +,   0.1116879    ,   0.1112924    ,   0.1108264    
     +,   0.1102887    ,   0.1096798    ,   0.1090024    
     +,   0.1082604    ,   0.1074594    ,   0.1066061    
     +,   0.1057079    ,   0.1047728    ,   0.1038091    
     +,   0.1028249    ,   0.1018280    ,   0.1008254    
     +,   9.9823512E-02,   9.8827414E-02,   9.7841404E-02
     +,   9.6868441E-02,   9.5910437E-02,   9.4968013E-02
     +,   9.4040833E-02,   9.3127728E-02,   9.2226453E-02
     +,   9.1334455E-02,   9.0448514E-02,   8.9565195E-02
     +,   8.8680781E-02,   8.7791637E-02,   8.6894371E-02
     +,   8.5985690E-02,   8.5062712E-02,   8.4123008E-02
     +,   8.3164722E-02,   8.2186282E-02,   8.1187069E-02
     +,   8.0166668E-02,   7.9125330E-02,   7.8064054E-02
     +,   7.6983936E-02,   7.5886711E-02,   7.4774683E-02
     +,   7.3650181E-02,   7.2515942E-02,   7.1375079E-02
     +,   7.0230596E-02,   6.9085702E-02,   6.7943618E-02
     +,   6.6807590E-02,   6.5680623E-02,   6.4565800E-02
     +,   6.3465692E-02,   6.2382966E-02,   6.1319768E-02
     +,   6.0278077E-02,   5.9259459E-02,   5.8265254E-02
     +,   5.7296388E-02,   5.6353446E-02,   5.5436820E-02
     +,   5.4546542E-02,   5.3682309E-02,   5.2843705E-02
     +,   5.2030098E-02,   5.1240712E-02,   5.0474703E-02
     +,   4.9731061E-02,   4.9009051E-02,   4.8307691E-02
     +,   4.7626324E-02,   4.6964332E-02,   4.6321336E-02
     +,   4.5697179E-02,   4.5091845E-02,   4.4505760E-02
     +,   4.3939542E-02,   4.3394126E-02,   4.2870730E-02
     +,   4.2370908E-02,   4.1896526E-02,   4.1449662E-02
     +,   4.1032672E-02,   4.0648270E-02,   4.0299248E-02
     +,   3.9988626E-02,   3.9719611E-02,   3.9495587E-02
     +,   3.9319862E-02,   3.9195996E-02,   3.9127477E-02
     +,   3.9117794E-02,   3.9170377E-02,   3.9288584E-02
     +,   3.9475638E-02,   3.9734576E-02,   4.0068198E-02
     +,   4.0479068E-02,   4.0969446E-02,   4.1541234E-02
     +,   4.2195939E-02,   4.2934641E-02,   4.3757919E-02
     +,   4.4665907E-02,   4.5658208E-02,   4.6733961E-02
     +,   4.7891755E-02,   4.9129672E-02,   5.0445605E-02
     +,   5.1836830E-02,   5.3300381E-02,   5.4833341E-02
     +,   5.6432616E-02,   5.8095135E-02,   5.9818134E-02
     +,   6.1599195E-02,   6.3436411E-02,   6.5328211E-02
     +,   6.7273945E-02,   6.9273673E-02,   7.1328051E-02
     +,   7.3438518E-02,   7.5607300E-02,   7.7837311E-02
     +,   8.0131784E-02,   8.2494453E-02,   8.4929258E-02
     +,   8.7440431E-02,   9.0031669E-02,   9.2706844E-02
     +,   9.5469356E-02,   9.8321974E-02,   0.1012668    
     +,   0.1043054    ,   0.1074388    ,   0.1106665    
     +,   0.1139877    ,   0.1174007    ,   0.1209031    
     +,   0.1244916    ,   0.1281617    ,   0.1319088    
     +,   0.1357273    ,   0.1396108    ,   0.1435526    
     +,   0.1475451    ,   0.1515803    ,   0.1556497    
     +,   0.1597446    ,   0.1638560    ,   0.1679745    
     +,   0.1720906    ,   0.1761948    ,   0.1802771    
     +,   0.1843275    ,   0.1883354    ,   0.1922894    
     +,   0.1961779    ,   0.1999868    ,   0.2037016    
     +,   0.2073048    ,   0.2107768    ,   0.2140949    
     +,   0.2172337    ,   0.2201642    ,   0.2228549    
     +,   0.2252708    ,   0.2273749    ,   0.2291289    
     +,   0.2304941    ,   0.2314322    ,   0.2319073    
     +,   0.2318876    ,   0.2313455    ,   0.2302598    
     +,   0.2286174    ,   0.2264132    ,   0.2236511    
     +,   0.2203442    ,   0.2165145    ,   0.2121921    
     +,   0.2074150    ,   0.2022272    ,   0.1966770    
     +,   0.1908166    ,   0.1846997    ,   0.1783795    
     +,   0.1719085    ,   0.1653363    ,   0.1587092    
     +,   0.1520688    ,   0.1454530    ,   0.1388942    
     +,   0.1324202    ,   0.1260543    ,   0.1198158    
     +,   0.1137208    ,   0.1077816    ,   0.1020084    
     +,   9.6409321E-02,   9.0990618E-02,   8.5757740E-02
     +,   8.0714285E-02,   7.5863823E-02,   7.1208470E-02
     +,   6.6750199E-02,   6.2489744E-02,   5.8427542E-02
     +,   5.4562829E-02,   5.0894454E-02,   4.7420181E-02
     +,   4.4136852E-02,   4.1040890E-02,   3.8127460E-02
     +,   3.5391536E-02,   3.2826960E-02,   3.0427497E-02
     +,   2.8186096E-02,   2.6095696E-02,   2.4148727E-02
     +,   2.2337776E-02,   2.0655120E-02,   1.9093318E-02
     +,   1.7644830E-02,   1.6302511E-02
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_hzonly_hatt120_mass = Yx/7.38182693181818
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_hzonly_hatt60_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.6804498E-02,   1.8085735E-02
     +,   1.9441927E-02,   2.0877309E-02,   2.2396270E-02
     +,   2.4003251E-02,   2.5702536E-02,   2.7498176E-02
     +,   2.9393623E-02,   3.1391677E-02,   3.3493988E-02
     +,   3.5700902E-02,   3.8011063E-02,   4.0421095E-02
     +,   4.2925414E-02,   4.5515794E-02,   4.8181325E-02
     +,   5.0908167E-02,   5.3679552E-02,   5.6475949E-02
     +,   5.9275169E-02,   6.2052686E-02,   6.4782098E-02
     +,   6.7435987E-02,   6.9985941E-02,   7.2404087E-02
     +,   7.4663177E-02,   7.6738000E-02,   7.8605630E-02
     +,   8.0246434E-02,   8.1644639E-02,   8.2788624E-02
     +,   8.3671473E-02,   8.4290750E-02,   8.4648907E-02
     +,   8.4752582E-02,   8.4612675E-02,   8.4243596E-02
     +,   8.3662607E-02,   8.2889587E-02,   8.1945844E-02
     +,   8.0853835E-02,   7.9636380E-02,   7.8316063E-02
     +,   7.6914690E-02,   7.5453043E-02,   7.3950239E-02
     +,   7.2423674E-02,   7.0888713E-02,   6.9358647E-02
     +,   6.7844465E-02,   6.6355027E-02,   6.4897098E-02
     +,   6.3475274E-02,   6.2092394E-02,   6.0749527E-02
     +,   5.9446417E-02,   5.8181658E-02,   5.6953099E-02
     +,   5.5758081E-02,   5.4593872E-02,   5.3458028E-02
     +,   5.2348673E-02,   5.1264752E-02,   5.0206125E-02
     +,   4.9174022E-02,   4.8170604E-02,   4.7199443E-02
     +,   4.6264816E-02,   4.5372169E-02,   4.4527143E-02
     +,   4.3735784E-02,   4.3003857E-02,   4.2336695E-02
     +,   4.1738801E-02,   4.1213404E-02,   4.0762499E-02
     +,   4.0386371E-02,   4.0083710E-02,   3.9851364E-02
     +,   3.9684623E-02,   3.9577171E-02,   3.9521400E-02
     +,   3.9508551E-02,   3.9529063E-02,   3.9572839E-02
     +,   3.9629668E-02,   3.9689355E-02,   3.9742161E-02
     +,   3.9779007E-02,   3.9791699E-02,   3.9773069E-02
     +,   3.9717220E-02,   3.9619427E-02,   3.9476361E-02
     +,   3.9286017E-02,   3.9047491E-02,   3.8761262E-02
     +,   3.8428735E-02,   3.8052317E-02,   3.7635189E-02
     +,   3.7181269E-02,   3.6694925E-02,   3.6180940E-02
     +,   3.5644326E-02,   3.5090193E-02,   3.4523666E-02
     +,   3.3949818E-02,   3.3373464E-02,   3.2799195E-02
     +,   3.2231320E-02,   3.1673670E-02,   3.1129850E-02
     +,   3.0602882E-02,   3.0095458E-02,   2.9609725E-02
     +,   2.9147482E-02,   2.8710000E-02,   2.8298201E-02
     +,   2.7912518E-02,   2.7553027E-02,   2.7219424E-02
     +,   2.6911106E-02,   2.6627073E-02,   2.6366105E-02
     +,   2.6126742E-02,   2.5907269E-02,   2.5705844E-02
     +,   2.5520470E-02,   2.5349054E-02,   2.5189470E-02
     +,   2.5039561E-02,   2.4897171E-02,   2.4760209E-02
     +,   2.4626670E-02,   2.4494663E-02,   2.4362417E-02
     +,   2.4228338E-02,   2.4091003E-02,   2.3949197E-02
     +,   2.3801869E-02,   2.3648228E-02,   2.3487667E-02
     +,   2.3319786E-02,   2.3144444E-02,   2.2961667E-02
     +,   2.2771679E-02,   2.2574920E-02,   2.2372009E-02
     +,   2.2163728E-02,   2.1950990E-02,   2.1734906E-02
     +,   2.1516675E-02,   2.1297621E-02,   2.1079158E-02
     +,   2.0862812E-02,   2.0650165E-02,   2.0442873E-02
     +,   2.0242568E-02,   2.0051003E-02,   1.9869870E-02
     +,   1.9700881E-02,   1.9545717E-02,   1.9406034E-02
     +,   1.9283408E-02,   1.9179342E-02,   1.9095249E-02
     +,   1.9032411E-02,   1.8992001E-02,   1.8975012E-02
     +,   1.8982260E-02,   1.9014388E-02,   1.9071812E-02
     +,   1.9154742E-02,   1.9263122E-02,   1.9396672E-02
     +,   1.9554833E-02,   1.9736787E-02,   1.9941432E-02
     +,   2.0167422E-02,   2.0413134E-02,   2.0676717E-02
     +,   2.0955998E-02,   2.1248680E-02,   2.1552209E-02
     +,   2.1863855E-02,   2.2180719E-02,   2.2499818E-02
     +,   2.2818085E-02,   2.3132334E-02,   2.3439454E-02
     +,   2.3736317E-02,   2.4019854E-02,   2.4287108E-02
     +,   2.4535261E-02,   2.4761699E-02,   2.4963975E-02
     +,   2.5139920E-02,   2.5287595E-02,   2.5405418E-02
     +,   2.5492027E-02,   2.5546445E-02,   2.5568020E-02
     +,   2.5556413E-02,   2.5511635E-02,   2.5434026E-02
     +,   2.5324227E-02,   2.5183180E-02,   2.5012091E-02
     +,   2.4812456E-02,   2.4585972E-02,   2.4334507E-02
     +,   2.4060169E-02,   2.3765128E-02,   2.3451658E-02
     +,   2.3122108E-02,   2.2778882E-02,   2.2424335E-02
     +,   2.2060802E-02,   2.1690587E-02,   2.1315843E-02
     +,   2.0938633E-02,   2.0560911E-02,   2.0184452E-02
     +,   1.9810872E-02,   1.9441586E-02,   1.9077841E-02
     +,   1.8720731E-02,   1.8371096E-02,   1.8029613E-02
     +,   1.7696789E-02,   1.7372955E-02,   1.7058259E-02
     +,   1.6752688E-02,   1.6456127E-02,   1.6168296E-02
     +,   1.5888806E-02,   1.5617192E-02,   1.5352906E-02
     +,   1.5095320E-02,   1.4843751E-02,   1.4597503E-02
     +,   1.4355866E-02,   1.4118098E-02,   1.3883457E-02
     +,   1.3651259E-02,   1.3420817E-02,   1.3191489E-02
     +,   1.2962659E-02,   1.2733800E-02,   1.2504405E-02
     +,   1.2274034E-02,   1.2042305E-02,   1.1808934E-02
     +,   1.1573649E-02,   1.1336273E-02,   1.1096680E-02
     +,   1.0854821E-02,   1.0610689E-02,   1.0364325E-02
     +,   1.0115841E-02,   9.8653985E-03,   9.6131843E-03
     +,   9.3594268E-03,   9.1044186E-03,   8.8484455E-03
     +,   8.5918289E-03,   8.3349291E-03,   8.0781197E-03
     +,   7.8217695E-03,   7.5662611E-03,   7.3119942E-03
     +,   7.0593716E-03,   6.8087736E-03,   6.5605799E-03
     +,   6.3151787E-03,   6.0729203E-03,   5.8341674E-03
     +,   5.5992398E-03,   5.3684642E-03,   5.1421188E-03
     +,   4.9204901E-03,   4.7038118E-03,   4.4923248E-03
     +,   4.2862119E-03,   4.0856618E-03,   3.8908178E-03
     +,   3.7017986E-03,   3.5187155E-03,   3.3416336E-03
     +,   3.1706151E-03,   3.0056767E-03,   2.8468366E-03
     +,   2.6940703E-03,   2.5473542E-03,   2.4066262E-03
     +,   2.2718261E-03,   2.1428582E-03,   2.0196324E-03
     +,   1.9020275E-03,   1.7899269E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_hzonly_hatt60_mass = Yx/2.16370291666667
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_hzonly_hatt65_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.1731103E-02,   1.2565948E-02
     +,   1.3427828E-02,   1.4315697E-02,   1.5228515E-02
     +,   1.6165296E-02,   1.7125113E-02,   1.8107088E-02
     +,   1.9110424E-02,   2.0134408E-02,   2.1178346E-02
     +,   2.2241643E-02,   2.3323724E-02,   2.4424063E-02
     +,   2.5542183E-02,   2.6677677E-02,   2.7830150E-02
     +,   2.8999366E-02,   3.0185180E-02,   3.1387657E-02
     +,   3.2607060E-02,   3.3843983E-02,   3.5099365E-02
     +,   3.6374621E-02,   3.7671506E-02,   3.8992438E-02
     +,   4.0340245E-02,   4.1718263E-02,   4.3130282E-02
     +,   4.4580448E-02,   4.6073105E-02,   4.7612693E-02
     +,   4.9203485E-02,   5.0849408E-02,   5.2553788E-02
     +,   5.4319054E-02,   5.6146584E-02,   5.8036242E-02
     +,   5.9986416E-02,   6.1993483E-02,   6.4052023E-02
     +,   6.6154301E-02,   6.8290368E-02,   7.0448078E-02
     +,   7.2613090E-02,   7.4768990E-02,   7.6897569E-02
     +,   7.8978933E-02,   8.0992110E-02,   8.2915299E-02
     +,   8.4726445E-02,   8.6403944E-02,   8.7926827E-02
     +,   8.9275829E-02,   9.0433605E-02,   9.1385424E-02
     +,   9.2119619E-02,   9.2627726E-02,   9.2904963E-02
     +,   9.2950128E-02,   9.2765741E-02,   9.2357427E-02
     +,   9.1734134E-02,   9.0907224E-02,   8.9890346E-02
     +,   8.8698626E-02,   8.7348476E-02,   8.5856654E-02
     +,   8.4240131E-02,   8.2515828E-02,   8.0699980E-02
     +,   7.8808397E-02,   7.6855853E-02,   7.4856788E-02
     +,   7.2824508E-02,   7.0771918E-02,   6.8711333E-02
     +,   6.6654690E-02,   6.4613111E-02,   6.2597387E-02
     +,   6.0617920E-02,   5.8684167E-02,   5.6805037E-02
     +,   5.4988313E-02,   5.3240947E-02,   5.1568504E-02
     +,   4.9975377E-02,   4.8464559E-02,   4.7037739E-02
     +,   4.5695238E-02,   4.4436093E-02,   4.3258268E-02
     +,   4.2158879E-02,   4.1134100E-02,   4.0179554E-02
     +,   3.9290495E-02,   3.8461849E-02,   3.7688561E-02
     +,   3.6965512E-02,   3.6287788E-02,   3.5650630E-02
     +,   3.5049625E-02,   3.4480561E-02,   3.3939686E-02
     +,   3.3423439E-02,   3.2928620E-02,   3.2452431E-02
     +,   3.1992331E-02,   3.1546127E-02,   3.1111889E-02
     +,   3.0688137E-02,   3.0273590E-02,   2.9867385E-02
     +,   2.9468926E-02,   2.9077977E-02,   2.8694546E-02
     +,   2.8318988E-02,   2.7951818E-02,   2.7593873E-02
     +,   2.7246077E-02,   2.6909484E-02,   2.6585244E-02
     +,   2.6274532E-02,   2.5978506E-02,   2.5698164E-02
     +,   2.5434470E-02,   2.5188165E-02,   2.4959829E-02
     +,   2.4749808E-02,   2.4558218E-02,   2.4384916E-02
     +,   2.4229525E-02,   2.4091424E-02,   2.3969753E-02
     +,   2.3863466E-02,   2.3771310E-02,   2.3691868E-02
     +,   2.3623597E-02,   2.3564873E-02,   2.3513967E-02
     +,   2.3469150E-02,   2.3428649E-02,   2.3390757E-02
     +,   2.3353798E-02,   2.3316164E-02,   2.3276392E-02
     +,   2.3233110E-02,   2.3185104E-02,   2.3131348E-02
     +,   2.3070950E-02,   2.3003215E-02,   2.2927662E-02
     +,   2.2843951E-02,   2.2751985E-02,   2.2651777E-02
     +,   2.2543576E-02,   2.2427771E-02,   2.2304865E-02
     +,   2.2175526E-02,   2.2040483E-02,   2.1900581E-02
     +,   2.1756701E-02,   2.1609774E-02,   2.1460742E-02
     +,   2.1310549E-02,   2.1160088E-02,   2.1010222E-02
     +,   2.0861778E-02,   2.0715490E-02,   2.0571997E-02
     +,   2.0431908E-02,   2.0295741E-02,   2.0163909E-02
     +,   2.0036774E-02,   1.9914640E-02,   1.9797787E-02
     +,   1.9686406E-02,   1.9580727E-02,   1.9480979E-02
     +,   1.9387381E-02,   1.9300217E-02,   1.9219816E-02
     +,   1.9146575E-02,   1.9080976E-02,   1.9023595E-02
     +,   1.8975083E-02,   1.8936209E-02,   1.8907845E-02
     +,   1.8890925E-02,   1.8886479E-02,   1.8895609E-02
     +,   1.8919453E-02,   1.8959189E-02,   1.9015979E-02
     +,   1.9090980E-02,   1.9185290E-02,   1.9299906E-02
     +,   1.9435735E-02,   1.9593513E-02,   1.9773830E-02
     +,   1.9977046E-02,   2.0203289E-02,   2.0452444E-02
     +,   2.0724116E-02,   2.1017596E-02,   2.1331878E-02
     +,   2.1665664E-02,   2.2017330E-02,   2.2384888E-02
     +,   2.2766124E-02,   2.3158489E-02,   2.3559172E-02
     +,   2.3965113E-02,   2.4373056E-02,   2.4779560E-02
     +,   2.5181029E-02,   2.5573771E-02,   2.5954045E-02
     +,   2.6318138E-02,   2.6662325E-02,   2.6982978E-02
     +,   2.7276646E-02,   2.7540017E-02,   2.7769996E-02
     +,   2.7963797E-02,   2.8118884E-02,   2.8233098E-02
     +,   2.8304581E-02,   2.8331900E-02,   2.8313983E-02
     +,   2.8250173E-02,   2.8140202E-02,   2.7984198E-02
     +,   2.7782680E-02,   2.7536556E-02,   2.7247062E-02
     +,   2.6915748E-02,   2.6544509E-02,   2.6135493E-02
     +,   2.5691053E-02,   2.5213754E-02,   2.4706345E-02
     +,   2.4171682E-02,   2.3612713E-02,   2.3032408E-02
     +,   2.2433791E-02,   2.1819891E-02,   2.1193631E-02
     +,   2.0557879E-02,   1.9915463E-02,   1.9269029E-02
     +,   1.8621095E-02,   1.7974062E-02,   1.7330185E-02
     +,   1.6691495E-02,   1.6059855E-02,   1.5437003E-02
     +,   1.4824481E-02,   1.4223621E-02,   1.3635591E-02
     +,   1.3061426E-02,   1.2502001E-02,   1.1957997E-02
     +,   1.1429965E-02,   1.0918365E-02,   1.0423474E-02
     +,   9.9454680E-03,   9.4844475E-03,   9.0404116E-03
     +,   8.6132539E-03,   8.2027791E-03,   7.8087733E-03
     +,   7.4309437E-03,   7.0689335E-03,   6.7223487E-03
     +,   6.3907881E-03,   6.0737859E-03,   5.7708942E-03
     +,   5.4816091E-03,   5.2054590E-03,   4.9419296E-03
     +,   4.6905368E-03,   4.4507682E-03,   4.2221542E-03
     +,   4.0041972E-03,   3.7964429E-03,   3.5984290E-03
     +,   3.4097079E-03,   3.2298663E-03,   3.0584855E-03
     +,   2.8951848E-03,   2.7395803E-03,   2.5913278E-03
     +,   2.4500787E-03,   2.3155226E-03,   2.1873470E-03
     +,   2.0652739E-03,   1.9490228E-03,   1.8383448E-03
     +,   1.7329903E-03,   1.6327359E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_hzonly_hatt65_mass = Yx/2.253517
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_hzonly_hatt70_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  9.3234908E-03,   9.7619956E-03
     +,   1.0208625E-02,   1.0663490E-02,   1.1126901E-02
     +,   1.1599397E-02,   1.2081788E-02,   1.2575162E-02
     +,   1.3080915E-02,   1.3600793E-02,   1.4136827E-02
     +,   1.4691392E-02,   1.5267150E-02,   1.5867030E-02
     +,   1.6494177E-02,   1.7151898E-02,   1.7843584E-02
     +,   1.8572625E-02,   1.9342348E-02,   2.0155888E-02
     +,   2.1016138E-02,   2.1925632E-02,   2.2886517E-02
     +,   2.3900531E-02,   2.4968790E-02,   2.6092054E-02
     +,   2.7270520E-02,   2.8503971E-02,   2.9791808E-02
     +,   3.1133134E-02,   3.2526802E-02,   3.3971582E-02
     +,   3.5466179E-02,   3.7009306E-02,   3.8599763E-02
     +,   4.0236354E-02,   4.1917931E-02,   4.3643318E-02
     +,   4.5411143E-02,   4.7219656E-02,   4.9066715E-02
     +,   5.0949406E-02,   5.2864015E-02,   5.4805823E-02
     +,   5.6769025E-02,   5.8746688E-02,   6.0730886E-02
     +,   6.2712669E-02,   6.4682491E-02,   6.6630311E-02
     +,   6.8546213E-02,   7.0420608E-02,   7.2244629E-02
     +,   7.4010819E-02,   7.5713016E-02,   7.7347003E-02
     +,   7.8910381E-02,   8.0402523E-02,   8.1824541E-02
     +,   8.3178751E-02,   8.4468387E-02,   8.5696965E-02
     +,   8.6867630E-02,   8.7982714E-02,   8.9043111E-02
     +,   9.0047576E-02,   9.0992883E-02,   9.1873161E-02
     +,   9.2680149E-02,   9.3403481E-02,   9.4030537E-02
     +,   9.4547465E-02,   9.4939314E-02,   9.5190674E-02
     +,   9.5286503E-02,   9.5212616E-02,   9.4956242E-02
     +,   9.4506651E-02,   9.3855880E-02,   9.2998661E-02
     +,   9.1933534E-02,   9.0662517E-02,   8.9191876E-02
     +,   8.7531775E-02,   8.5696571E-02,   8.3704762E-02
     +,   8.1578352E-02,   7.9342566E-02,   7.7025257E-02
     +,   7.4655965E-02,   7.2264887E-02,   6.9882266E-02
     +,   6.7537174E-02,   6.5256193E-02,   6.3062869E-02
     +,   6.0977124E-02,   5.9014205E-02,   5.7185143E-02
     +,   5.5495836E-02,   5.3947844E-02,   5.2538518E-02
     +,   5.1261727E-02,   5.0108340E-02,   4.9067233E-02
     +,   4.8125796E-02,   4.7270864E-02,   4.6489261E-02
     +,   4.5768548E-02,   4.5097157E-02,   4.4464789E-02
     +,   4.3862637E-02,   4.3283392E-02,   4.2721171E-02
     +,   4.2171266E-02,   4.1630223E-02,   4.1095354E-02
     +,   4.0564794E-02,   4.0037125E-02,   3.9511301E-02
     +,   3.8986493E-02,   3.8461998E-02,   3.7937216E-02
     +,   3.7411615E-02,   3.6884688E-02,   3.6355939E-02
     +,   3.5825096E-02,   3.5291847E-02,   3.4756180E-02
     +,   3.4218114E-02,   3.3677973E-02,   3.3136129E-02
     +,   3.2593295E-02,   3.2050196E-02,   3.1507861E-02
     +,   3.0967370E-02,   3.0429894E-02,   2.9896744E-02
     +,   2.9369278E-02,   2.8848840E-02,   2.8336799E-02
     +,   2.7834523E-02,   2.7343351E-02,   2.6864536E-02
     +,   2.6399264E-02,   2.5948692E-02,   2.5513828E-02
     +,   2.5095608E-02,   2.4694897E-02,   2.4312437E-02
     +,   2.3948854E-02,   2.3604661E-02,   2.3280341E-02
     +,   2.2976231E-02,   2.2692613E-02,   2.2429666E-02
     +,   2.2187557E-02,   2.1966392E-02,   2.1766240E-02
     +,   2.1587154E-02,   2.1429176E-02,   2.1292379E-02
     +,   2.1176828E-02,   2.1082638E-02,   2.1009961E-02
     +,   2.0958947E-02,   2.0929819E-02,   2.0922815E-02
     +,   2.0938193E-02,   2.0976219E-02,   2.1037167E-02
     +,   2.1121273E-02,   2.1228734E-02,   2.1359688E-02
     +,   2.1514181E-02,   2.1692134E-02,   2.1893347E-02
     +,   2.2117460E-02,   2.2363914E-02,   2.2631947E-02
     +,   2.2920592E-02,   2.3228666E-02,   2.3554724E-02
     +,   2.3897087E-02,   2.4253827E-02,   2.4622835E-02
     +,   2.5001738E-02,   2.5387995E-02,   2.5778908E-02
     +,   2.6171647E-02,   2.6563276E-02,   2.6950780E-02
     +,   2.7331190E-02,   2.7701521E-02,   2.8058875E-02
     +,   2.8400496E-02,   2.8723804E-02,   2.9026402E-02
     +,   2.9306155E-02,   2.9561237E-02,   2.9790124E-02
     +,   2.9991623E-02,   3.0164886E-02,   3.0309461E-02
     +,   3.0425223E-02,   3.0512406E-02,   3.0571600E-02
     +,   3.0603718E-02,   3.0609932E-02,   3.0591704E-02
     +,   3.0550694E-02,   3.0488715E-02,   3.0407775E-02
     +,   3.0309914E-02,   3.0197216E-02,   3.0071758E-02
     +,   2.9935578E-02,   2.9790586E-02,   2.9638572E-02
     +,   2.9481154E-02,   2.9319739E-02,   2.9155511E-02
     +,   2.8989406E-02,   2.8822100E-02,   2.8654037E-02
     +,   2.8485334E-02,   2.8315896E-02,   2.8145362E-02
     +,   2.7973140E-02,   2.7798396E-02,   2.7620152E-02
     +,   2.7437240E-02,   2.7248358E-02,   2.7052110E-02
     +,   2.6847007E-02,   2.6631579E-02,   2.6404295E-02
     +,   2.6163695E-02,   2.5908351E-02,   2.5636978E-02
     +,   2.5348341E-02,   2.5041401E-02,   2.4715260E-02
     +,   2.4369230E-02,   2.4002781E-02,   2.3615615E-02
     +,   2.3207618E-02,   2.2778971E-02,   2.2329973E-02
     +,   2.1861175E-02,   2.1373365E-02,   2.0867486E-02
     +,   2.0344632E-02,   1.9806135E-02,   1.9253450E-02
     +,   1.8688133E-02,   1.8111838E-02,   1.7526355E-02
     +,   1.6933531E-02,   1.6335221E-02,   1.5733305E-02
     +,   1.5129689E-02,   1.4526281E-02,   1.3924893E-02
     +,   1.3327298E-02,   1.2735243E-02,   1.2150348E-02
     +,   1.1574127E-02,   1.1008028E-02,   1.0453393E-02
     +,   9.9113900E-03,   9.3830787E-03,   8.8694263E-03
     +,   8.3712637E-03,   7.8892643E-03,   7.4239825E-03
     +,   6.9758967E-03,   6.5453011E-03,   6.1324458E-03
     +,   5.7374192E-03,   5.3602629E-03,   5.0008735E-03
     +,   4.6591233E-03,   4.3347529E-03,   4.0274896E-03
     +,   3.7369502E-03,   3.4627460E-03,   3.2044125E-03
     +,   2.9614512E-03,   2.7333545E-03,   2.5195617E-03
     +,   2.3195227E-03,   2.1326449E-03,   1.9583553E-03
     +,   1.7960531E-03,   1.6451601E-03,   1.5050807E-03
     +,   1.3752481E-03,   1.2550836E-03,   1.1440404E-03
     +,   1.0415701E-03,   9.4715430E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_hzonly_hatt70_mass = Yx/2.46271540540541
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_hzonly_hatt75_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  5.4730354E-03,   5.6965668E-03
     +,   5.9241406E-03,   6.1558853E-03,   6.3919844E-03
     +,   6.6327024E-03,   6.8783876E-03,   7.1294708E-03
     +,   7.3864851E-03,   7.6500829E-03,   7.9210168E-03
     +,   8.2001770E-03,   8.4885824E-03,   8.7874141E-03
     +,   9.0980008E-03,   9.4218608E-03,   9.7607113E-03
     +,   1.0116472E-02,   1.0491302E-02,   1.0887610E-02
     +,   1.1308067E-02,   1.1755619E-02,   1.2233485E-02
     +,   1.2745180E-02,   1.3294412E-02,   1.3885145E-02
     +,   1.4521444E-02,   1.5207430E-02,   1.5947144E-02
     +,   1.6744399E-02,   1.7602600E-02,   1.8524557E-02
     +,   1.9512255E-02,   2.0566657E-02,   2.1687461E-02
     +,   2.2872962E-02,   2.4119910E-02,   2.5423424E-02
     +,   2.6777141E-02,   2.8173082E-02,   2.9602310E-02
     +,   3.1054955E-02,   3.2520954E-02,   3.3990610E-02
     +,   3.5455395E-02,   3.6908746E-02,   3.8346887E-02
     +,   3.9769772E-02,   4.1181780E-02,   4.2592335E-02
     +,   4.4016492E-02,   4.5474879E-02,   4.6993796E-02
     +,   4.8604712E-02,   5.0343085E-02,   5.2247684E-02
     +,   5.4358751E-02,   5.6716241E-02,   5.9358146E-02
     +,   6.2318567E-02,   6.5626025E-02,   6.9302112E-02
     +,   7.3360033E-02,   7.7804171E-02,   8.2629584E-02
     +,   8.7820739E-02,   9.3352348E-02,   9.9187419E-02
     +,   0.1052779    ,   0.1115621    ,   0.1179656    
     +,   0.1243987    ,   0.1307585    ,   0.1369281    
     +,   0.1427816    ,   0.1481880    ,   0.1530178    
     +,   0.1571521    ,   0.1604920    ,   0.1629670    
     +,   0.1645435    ,   0.1652298    ,   0.1650774    
     +,   0.1641789    ,   0.1626611    ,   0.1606737    
     +,   0.1583770    ,   0.1559275    ,   0.1534647    
     +,   0.1511001    ,   0.1489104    ,   0.1469341    
     +,   0.1451737    ,   0.1435990    ,   0.1421562    
     +,   0.1407756    ,   0.1393806    ,   0.1378955    
     +,   0.1362507    ,   0.1343881    ,   0.1322626    
     +,   0.1298437    ,   0.1271152    ,   0.1240749    
     +,   0.1207338    ,   0.1171140    ,   0.1132488    
     +,   0.1091810    ,   0.1049596    ,   0.1006394    
     +,   9.6278273E-02,   9.1934048E-02,   8.7662749E-02
     +,   8.3515324E-02,   7.9536736E-02,   7.5762987E-02
     +,   7.2221301E-02,   6.8928517E-02,   6.5892085E-02
     +,   6.3109972E-02,   6.0571991E-02,   5.8261372E-02
     +,   5.6156274E-02,   5.4231293E-02,   5.2459326E-02
     +,   5.0813377E-02,   4.9267448E-02,   4.7798086E-02
     +,   4.6384722E-02,   4.5010708E-02,   4.3662995E-02
     +,   4.2332537E-02,   4.1013632E-02,   3.9703935E-02
     +,   3.8403649E-02,   3.7115052E-02,   3.5842054E-02
     +,   3.4589622E-02,   3.3363197E-02,   3.2168355E-02
     +,   3.1010646E-02,   2.9895168E-02,   2.8826429E-02
     +,   2.7808273E-02,   2.6843993E-02,   2.5936041E-02
     +,   2.5086306E-02,   2.4296116E-02,   2.3566319E-02
     +,   2.2897212E-02,   2.2288773E-02,   2.1740664E-02
     +,   2.1252265E-02,   2.0822650E-02,   2.0450642E-02
     +,   2.0134887E-02,   1.9873757E-02,   1.9665377E-02
     +,   1.9507645E-02,   1.9398201E-02,   1.9334473E-02
     +,   1.9313643E-02,   1.9332714E-02,   1.9388447E-02
     +,   1.9477485E-02,   1.9596318E-02,   1.9741338E-02
     +,   1.9908872E-02,   2.0095231E-02,   2.0296736E-02
     +,   2.0509720E-02,   2.0730603E-02,   2.0955937E-02
     +,   2.1182386E-02,   2.1406744E-02,   2.1626011E-02
     +,   2.1837395E-02,   2.2038260E-02,   2.2226237E-02
     +,   2.2399159E-02,   2.2555141E-02,   2.2692507E-02
     +,   2.2809844E-02,   2.2905994E-02,   2.2980062E-02
     +,   2.3031376E-02,   2.3059543E-02,   2.3064397E-02
     +,   2.3045998E-02,   2.3004636E-02,   2.2940800E-02
     +,   2.2855185E-02,   2.2748655E-02,   2.2622237E-02
     +,   2.2477098E-02,   2.2314517E-02,   2.2135884E-02
     +,   2.1942666E-02,   2.1736367E-02,   2.1518541E-02
     +,   2.1290749E-02,   2.1054560E-02,   2.0811502E-02
     +,   2.0563062E-02,   2.0310685E-02,   2.0055728E-02
     +,   1.9799469E-02,   1.9543104E-02,   1.9287737E-02
     +,   1.9034348E-02,   1.8783815E-02,   1.8536918E-02
     +,   1.8294338E-02,   1.8056618E-02,   1.7824221E-02
     +,   1.7597497E-02,   1.7376732E-02,   1.7162081E-02
     +,   1.6953638E-02,   1.6751450E-02,   1.6555451E-02
     +,   1.6365528E-02,   1.6181536E-02,   1.6003260E-02
     +,   1.5830452E-02,   1.5662812E-02,   1.5500034E-02
     +,   1.5341781E-02,   1.5187691E-02,   1.5037364E-02
     +,   1.4890433E-02,   1.4746479E-02,   1.4605111E-02
     +,   1.4465903E-02,   1.4328440E-02,   1.4192320E-02
     +,   1.4057132E-02,   1.3922477E-02,   1.3787966E-02
     +,   1.3653216E-02,   1.3517861E-02,   1.3381541E-02
     +,   1.3243936E-02,   1.3104723E-02,   1.2963599E-02
     +,   1.2820298E-02,   1.2674585E-02,   1.2526222E-02
     +,   1.2375016E-02,   1.2220806E-02,   1.2063452E-02
     +,   1.1902835E-02,   1.1738881E-02,   1.1571551E-02
     +,   1.1400811E-02,   1.1226671E-02,   1.1049162E-02
     +,   1.0868359E-02,   1.0684351E-02,   1.0497238E-02
     +,   1.0307170E-02,   1.0114310E-02,   9.9188425E-03
     +,   9.7209476E-03,   9.5208650E-03,   9.3188128E-03
     +,   9.1150338E-03,   8.9097917E-03,   8.7033585E-03
     +,   8.4959995E-03,   8.2879905E-03,   8.0796210E-03
     +,   7.8711770E-03,   7.6629496E-03,   7.4552083E-03
     +,   7.2482517E-03,   7.0423456E-03,   6.8377717E-03
     +,   6.6347891E-03,   6.4336671E-03,   6.2346403E-03
     +,   6.0379631E-03,   5.8438475E-03,   5.6525269E-03
     +,   5.4641864E-03,   5.2790344E-03,   5.0972383E-03
     +,   4.9189539E-03,   4.7443402E-03,   4.5735221E-03
     +,   4.4066249E-03,   4.2437422E-03,   4.0849727E-03
     +,   3.9303787E-03,   3.7800283E-03,   3.6339583E-03
     +,   3.4922063E-03,   3.3547808E-03,   3.2216953E-03
     +,   3.0929323E-03,   2.9684794E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_hzonly_hatt75_mass = Yx/2.86201815789474
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_hzonly_hatt80_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  4.3906048E-03,   4.6188133E-03
     +,   4.8580188E-03,   5.1084906E-03,   5.3704660E-03
     +,   5.6441426E-03,   5.9296726E-03,   6.2271594E-03
     +,   6.5366533E-03,   6.8581658E-03,   7.1916403E-03
     +,   7.5369682E-03,   7.8939898E-03,   8.2624955E-03
     +,   8.6422330E-03,   9.0328995E-03,   9.4341636E-03
     +,   9.8456563E-03,   1.0266990E-02,   1.0697756E-02
     +,   1.1137540E-02,   1.1585913E-02,   1.2042444E-02
     +,   1.2506723E-02,   1.2978299E-02,   1.3456772E-02
     +,   1.3941709E-02,   1.4432692E-02,   1.4929296E-02
     +,   1.5431083E-02,   1.5937647E-02,   1.6448561E-02
     +,   1.6963435E-02,   1.7481925E-02,   1.8003758E-02
     +,   1.8528784E-02,   1.9057011E-02,   1.9588670E-02
     +,   2.0124344E-02,   2.0664902E-02,   2.1211743E-02
     +,   2.1766780E-02,   2.2332478E-02,   2.2911981E-02
     +,   2.3509055E-02,   2.4128145E-02,   2.4774250E-02
     +,   2.5452916E-02,   2.6170004E-02,   2.6931591E-02
     +,   2.7743768E-02,   2.8612373E-02,   2.9542852E-02
     +,   3.0540105E-02,   3.1608284E-02,   3.2750927E-02
     +,   3.3970915E-02,   3.5270702E-02,   3.6652632E-02
     +,   3.8119283E-02,   3.9673813E-02,   4.1320425E-02
     +,   4.3064468E-02,   4.4912819E-02,   4.6873678E-02
     +,   4.8956268E-02,   5.1170751E-02,   5.3527433E-02
     +,   5.6036826E-02,   5.8709003E-02,   6.1554242E-02
     +,   6.4582877E-02,   6.7806691E-02,   7.1238905E-02
     +,   7.4895427E-02,   7.8794345E-02,   8.2954407E-02
     +,   8.7392531E-02,   9.2119917E-02,   9.7136647E-02
     +,   0.1024262    ,   0.1079522    ,   0.1136559    
     +,   0.1194600    ,   0.1252750    ,   0.1310117    
     +,   0.1365953    ,   0.1419806    ,   0.1471628    
     +,   0.1521845    ,   0.1571309    ,   0.1621204    
     +,   0.1672851    ,   0.1727516    ,   0.1786209    
     +,   0.1849546    ,   0.1917694    ,   0.1990359    
     +,   0.2066868    ,   0.2146227    ,   0.2227208    
     +,   0.2308376    ,   0.2388146    ,   0.2464805    
     +,   0.2536617    ,   0.2601932    ,   0.2659359    
     +,   0.2707912    ,   0.2747133    ,   0.2777058    
     +,   0.2798104    ,   0.2810808    ,   0.2815547    
     +,   0.2812253    ,   0.2800264    ,   0.2778325    
     +,   0.2744752    ,   0.2697743    ,   0.2635766    
     +,   0.2557899    ,   0.2464129    ,   0.2355482    
     +,   0.2234018    ,   0.2102667    ,   0.1964964    
     +,   0.1824741    ,   0.1685756    ,   0.1551412    
     +,   0.1424489    ,   0.1307028    ,   0.1200248    
     +,   0.1104622    ,   0.1019963    ,   9.4562218E-02
     +,   8.8063337E-02,   8.2390495E-02,   7.7435344E-02
     +,   7.3099583E-02,   6.9299422E-02,   6.5967128E-02
     +,   6.3049018E-02,   6.0501177E-02,   5.8285594E-02
     +,   5.6366317E-02,   5.4707345E-02,   5.3271253E-02
     +,   5.2019317E-02,   5.0912905E-02,   4.9915049E-02
     +,   4.8992012E-02,   4.8114866E-02,   4.7260538E-02
     +,   4.6412215E-02,   4.5558944E-02,   4.4695113E-02
     +,   4.3819621E-02,   4.2934585E-02,   4.2044211E-02
     +,   4.1153975E-02,   4.0269643E-02,   3.9396629E-02
     +,   3.8539704E-02,   3.7702687E-02,   3.6888432E-02
     +,   3.6098842E-02,   3.5334967E-02,   3.4597319E-02
     +,   3.3885986E-02,   3.3200718E-02,   3.2541234E-02
     +,   3.1907320E-02,   3.1298909E-02,   3.0716129E-02
     +,   3.0159302E-02,   2.9629063E-02,   2.9126238E-02
     +,   2.8651759E-02,   2.8206756E-02,   2.7792403E-02
     +,   2.7409825E-02,   2.7060051E-02,   2.6744032E-02
     +,   2.6462518E-02,   2.6215965E-02,   2.6004594E-02
     +,   2.5828341E-02,   2.5686797E-02,   2.5579257E-02
     +,   2.5504697E-02,   2.5461795E-02,   2.5448954E-02
     +,   2.5464302E-02,   2.5505766E-02,   2.5571015E-02
     +,   2.5657574E-02,   2.5762811E-02,   2.5883943E-02
     +,   2.6018044E-02,   2.6162120E-02,   2.6313070E-02
     +,   2.6467705E-02,   2.6622755E-02,   2.6774924E-02
     +,   2.6920820E-02,   2.7057029E-02,   2.7180120E-02
     +,   2.7286690E-02,   2.7373319E-02,   2.7436666E-02
     +,   2.7473517E-02,   2.7480770E-02,   2.7455509E-02
     +,   2.7395105E-02,   2.7297152E-02,   2.7159633E-02
     +,   2.6980899E-02,   2.6759751E-02,   2.6495444E-02
     +,   2.6187744E-02,   2.5836939E-02,   2.5443839E-02
     +,   2.5009800E-02,   2.4536682E-02,   2.4026893E-02
     +,   2.3483265E-02,   2.2909021E-02,   2.2307806E-02
     +,   2.1683577E-02,   2.1040441E-02,   2.0382719E-02
     +,   1.9714804E-02,   1.9041151E-02,   1.8366069E-02
     +,   1.7693743E-02,   1.7028231E-02,   1.6373258E-02
     +,   1.5732242E-02,   1.5108305E-02,   1.4504174E-02
     +,   1.3922139E-02,   1.3364074E-02,   1.2831480E-02
     +,   1.2325424E-02,   1.1846556E-02,   1.1395140E-02
     +,   1.0971118E-02,   1.0574112E-02,   1.0203417E-02
     +,   9.8580904E-03,   9.5370067E-03,   9.2388373E-03
     +,   8.9621143E-03,   8.7052938E-03,   8.4667709E-03
     +,   8.2448889E-03,   8.0379946E-03,   7.8444770E-03
     +,   7.6627643E-03,   7.4913497E-03,   7.3288023E-03
     +,   7.1738036E-03,   7.0251399E-03,   6.8816901E-03
     +,   6.7424555E-03,   6.6065625E-03,   6.4732395E-03
     +,   6.3418243E-03,   6.2117726E-03,   6.0826386E-03
     +,   5.9540616E-03,   5.8257668E-03,   5.6975726E-03
     +,   5.5693607E-03,   5.4410743E-03,   5.3127045E-03
     +,   5.1843082E-03,   5.0559631E-03,   4.9277935E-03
     +,   4.7999383E-03,   4.6725678E-03,   4.5458521E-03
     +,   4.4199880E-03,   4.2951587E-03,   4.1715628E-03
     +,   4.0493831E-03,   3.9288113E-03,   3.8100178E-03
     +,   3.6931618E-03,   3.5784037E-03,   3.4658737E-03
     +,   3.3557038E-03,   3.2479935E-03,   3.1428435E-03
     +,   3.0403249E-03,   2.9405057E-03,   2.8434247E-03
     +,   2.7491227E-03,   2.6576112E-03,   2.5689001E-03
     +,   2.4829765E-03,   2.3998278E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_hzonly_hatt80_mass = Yx/3.990194775
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_hzonly_hatt85_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  2.4170289E-03,   2.4840175E-03
     +,   2.5516853E-03,   2.6200104E-03,   2.6889767E-03
     +,   2.7585749E-03,   2.8288024E-03,   2.8996649E-03
     +,   2.9711772E-03,   3.0433682E-03,   3.1162756E-03
     +,   3.1899509E-03,   3.2644607E-03,   3.3398864E-03
     +,   3.4163257E-03,   3.4938918E-03,   3.5727152E-03
     +,   3.6529433E-03,   3.7347411E-03,   3.8182866E-03
     +,   3.9037769E-03,   3.9914185E-03,   4.0814327E-03
     +,   4.1740551E-03,   4.2695166E-03,   4.3680682E-03
     +,   4.4699521E-03,   4.5754164E-03,   4.6847058E-03
     +,   4.7980524E-03,   4.9156882E-03,   5.0378325E-03
     +,   5.1646912E-03,   5.2964641E-03,   5.4333387E-03
     +,   5.5754962E-03,   5.7231197E-03,   5.8763917E-03
     +,   6.0355165E-03,   6.2007112E-03,   6.3722464E-03
     +,   6.5504340E-03,   6.7356550E-03,   6.9283871E-03
     +,   7.1292124E-03,   7.3388363E-03,   7.5581218E-03
     +,   7.7880886E-03,   8.0299433E-03,   8.2850931E-03
     +,   8.5551497E-03,   8.8419495E-03,   9.1475267E-03
     +,   9.4741620E-03,   9.8243048E-03,   1.0200635E-02
     +,   1.0605991E-02,   1.1043356E-02,   1.1515872E-02
     +,   1.2026761E-02,   1.2579327E-02,   1.3176938E-02
     +,   1.3822947E-02,   1.4520741E-02,   1.5273705E-02
     +,   1.6085088E-02,   1.6958201E-02,   1.7896140E-02
     +,   1.8902054E-02,   1.9978825E-02,   2.1129344E-02
     +,   2.2356179E-02,   2.3661822E-02,   2.5048327E-02
     +,   2.6517484E-02,   2.8070604E-02,   2.9708268E-02
     +,   3.1430334E-02,   3.3235751E-02,   3.5122517E-02
     +,   3.7087202E-02,   3.9125357E-02,   4.1231114E-02
     +,   4.3397684E-02,   4.5617215E-02,   4.7881518E-02
     +,   5.0182167E-02,   5.2511428E-02,   5.4862358E-02
     +,   5.7229787E-02,   5.9610501E-02,   6.2003288E-02
     +,   6.4409070E-02,   6.6830620E-02,   6.9271900E-02
     +,   7.1736932E-02,   7.4229576E-02,   7.6752603E-02
     +,   7.9308435E-02,   8.1900664E-02,   8.4538266E-02
     +,   8.7241769E-02,   9.0053469E-02,   9.3048356E-02
     +,   9.6347831E-02,   0.1001299    ,   0.1046336    
     +,   0.1101523    ,   0.1170135    ,   0.1255417    
     +,   0.1360069    ,   0.1485714    ,   0.1632385    
     +,   0.1798284    ,   0.1979781    ,   0.2171868    
     +,   0.2368802    ,   0.2564992    ,   0.2755764    
     +,   0.2938041    ,   0.3110705    ,   0.3274664    
     +,   0.3432543    ,   0.3587909    ,   0.3743966    
     +,   0.3902043    ,   0.4060355    ,   0.4213662    
     +,   0.4354267    ,   0.4474020    ,   0.4566516    
     +,   0.4628168    ,   0.4657607    ,   0.4653661    
     +,   0.4613358    ,   0.4531496    ,   0.4402492    
     +,   0.4223826    ,   0.3999243    ,   0.3739909    
     +,   0.3462835    ,   0.3187114    ,   0.2929647    
     +,   0.2702042    ,   0.2509393    ,   0.2350881    
     +,   0.2221497    ,   0.2114095    ,   0.2021110    
     +,   0.1935793    ,   0.1852917    ,   0.1769042    
     +,   0.1682475    ,   0.1593013    ,   0.1501577    
     +,   0.1409808    ,   0.1319656    ,   0.1233019    
     +,   0.1151479    ,   0.1076135    ,   0.1007522    
     +,   9.4566084E-02,   8.9016095E-02,   8.4035732E-02
     +,   7.9545043E-02,   7.5462967E-02,   7.1715683E-02
     +,   6.8241447E-02,   6.4992346E-02,   6.1934635E-02
     +,   5.9047777E-02,   5.6322232E-02,   5.3756859E-02
     +,   5.1356498E-02,   4.9129352E-02,   4.7084201E-02
     +,   4.5228269E-02,   4.3565828E-02,   4.2096894E-02
     +,   4.0816694E-02,   3.9716005E-02,   3.8781505E-02
     +,   3.7996650E-02,   3.7342474E-02,   3.6798533E-02
     +,   3.6343906E-02,   3.5957884E-02,   3.5620503E-02
     +,   3.5313219E-02,   3.5019197E-02,   3.4723610E-02
     +,   3.4413822E-02,   3.4079593E-02,   3.3713058E-02
     +,   3.3308759E-02,   3.2863591E-02,   3.2376707E-02
     +,   3.1849369E-02,   3.1284627E-02,   3.0687166E-02
     +,   3.0063007E-02,   2.9419150E-02,   2.8763235E-02
     +,   2.8103190E-02,   2.7447067E-02,   2.6802551E-02
     +,   2.6176764E-02,   2.5576157E-02,   2.5006250E-02
     +,   2.4471458E-02,   2.3975093E-02,   2.3519365E-02
     +,   2.3105342E-02,   2.2732994E-02,   2.2401283E-02
     +,   2.2108309E-02,   2.1851426E-02,   2.1627286E-02
     +,   2.1432064E-02,   2.1261556E-02,   2.1111313E-02
     +,   2.0976726E-02,   2.0853171E-02,   2.0736093E-02
     +,   2.0621063E-02,   2.0503864E-02,   2.0380553E-02
     +,   2.0247502E-02,   2.0101398E-02,   1.9939341E-02
     +,   1.9758793E-02,   1.9557629E-02,   1.9334136E-02
     +,   1.9086987E-02,   1.8815294E-02,   1.8518526E-02
     +,   1.8196553E-02,   1.7849607E-02,   1.7478289E-02
     +,   1.7083485E-02,   1.6666375E-02,   1.6228445E-02
     +,   1.5771400E-02,   1.5297147E-02,   1.4807732E-02
     +,   1.4305383E-02,   1.3792435E-02,   1.3271234E-02
     +,   1.2744180E-02,   1.2213703E-02,   1.1682162E-02
     +,   1.1151844E-02,   1.0624990E-02,   1.0103732E-02
     +,   9.5900334E-03,   9.0857083E-03,   8.5924482E-03
     +,   8.1117740E-03,   7.6449923E-03,   7.1932385E-03
     +,   6.7574931E-03,   6.3385484E-03,   5.9370045E-03
     +,   5.5532875E-03,   5.1877070E-03,   4.8403814E-03
     +,   4.5112902E-03,   4.2003118E-03,   3.9072065E-03
     +,   3.6316121E-03,   3.3730827E-03,   3.1311123E-03
     +,   2.9051304E-03,   2.6945011E-03,   2.4985501E-03
     +,   2.3165948E-03,   2.1479086E-03,   1.9917761E-03
     +,   1.8474632E-03,   1.7142582E-03,   1.5914445E-03
     +,   1.4783379E-03,   1.3742622E-03,   1.2785791E-03
     +,   1.1906653E-03,   1.1099407E-03,   1.0358460E-03
     +,   9.6785632E-04,   9.0548483E-04,   8.4826892E-04
     +,   7.9578580E-04,   7.4763526E-04,   7.0345448E-04
     +,   6.6290272E-04,   6.2567118E-04,   5.9147249E-04
     +,   5.6004716E-04,   5.3115381E-04,   5.0457538E-04
     +,   4.8011099E-04,   4.5757968E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_hzonly_hatt85_mass = Yx/4.79619153658537
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_hzonly_hatt90_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.5762242E-03,   1.6480515E-03
     +,   1.7217961E-03,   1.7974296E-03,   1.8749215E-03
     +,   1.9542419E-03,   2.0353592E-03,   2.1182457E-03
     +,   2.2028743E-03,   2.2892267E-03,   2.3772870E-03
     +,   2.4670481E-03,   2.5585121E-03,   2.6516938E-03
     +,   2.7466207E-03,   2.8433371E-03,   2.9419011E-03
     +,   3.0423938E-03,   3.1449148E-03,   3.2495863E-03
     +,   3.3565555E-03,   3.4659931E-03,   3.5780924E-03
     +,   3.6930812E-03,   3.8111976E-03,   3.9327182E-03
     +,   4.0579350E-03,   4.1871620E-03,   4.3207291E-03
     +,   4.4589820E-03,   4.6022744E-03,   4.7509633E-03
     +,   4.9054045E-03,   5.0659436E-03,   5.2329097E-03
     +,   5.4066046E-03,   5.5872970E-03,   5.7752091E-03
     +,   5.9705232E-03,   6.1733378E-03,   6.3836970E-03
     +,   6.6015548E-03,   6.8267807E-03,   7.0591462E-03
     +,   7.2983205E-03,   7.5438633E-03,   7.7952286E-03
     +,   8.0517521E-03,   8.3126668E-03,   8.5770916E-03
     +,   8.8440459E-03,   9.1124568E-03,   9.3811592E-03
     +,   9.6489349E-03,   9.9144829E-03,   1.0176497E-02
     +,   1.0433625E-02,   1.0684530E-02,   1.0927889E-02
     +,   1.1162435E-02,   1.1386969E-02,   1.1600384E-02
     +,   1.1801670E-02,   1.1989984E-02,   1.2164627E-02
     +,   1.2325061E-02,   1.2470949E-02,   1.2602144E-02
     +,   1.2718723E-02,   1.2820939E-02,   1.2909299E-02
     +,   1.2984484E-02,   1.3047399E-02,   1.3099121E-02
     +,   1.3140909E-02,   1.3174184E-02,   1.3200508E-02
     +,   1.3221554E-02,   1.3239120E-02,   1.3255067E-02
     +,   1.3271364E-02,   1.3290008E-02,   1.3313097E-02
     +,   1.3342793E-02,   1.3381334E-02,   1.3431077E-02
     +,   1.3494513E-02,   1.3574340E-02,   1.3673469E-02
     +,   1.3795120E-02,   1.3942872E-02,   1.4120709E-02
     +,   1.4333107E-02,   1.4585090E-02,   1.4882258E-02
     +,   1.5230816E-02,   1.5637618E-02,   1.6110042E-02
     +,   1.6656065E-02,   1.7284021E-02,   1.8002581E-02
     +,   1.8820388E-02,   1.9745998E-02,   2.0787347E-02
     +,   2.1951625E-02,   2.3244796E-02,   2.4671147E-02
     +,   2.6232893E-02,   2.7929984E-02,   2.9759681E-02
     +,   3.1716082E-02,   3.3790465E-02,   3.5970718E-02
     +,   3.8242053E-02,   4.0586781E-02,   4.2985413E-02
     +,   4.5416914E-02,   4.7860246E-02,   5.0295115E-02
     +,   5.2703958E-02,   5.5073235E-02,   5.7395007E-02
     +,   5.9668701E-02,   6.1903130E-02,   6.4117692E-02
     +,   6.6344492E-02,   6.8631180E-02,   7.1043588E-02
     +,   7.3670179E-02,   7.6625817E-02,   8.0055363E-02
     +,   8.4133320E-02,   8.9059703E-02,   9.5046617E-02
     +,   0.1022987    ,   0.1109870    ,   0.1212208    
     +,   0.1330276    ,   0.1463487    ,   0.1610552    
     +,   0.1769878    ,   0.1940131    ,   0.2120799    
     +,   0.2312425    ,   0.2516315    ,   0.2733653    
     +,   0.2964158    ,   0.3204885    ,   0.3449783    
     +,   0.3690454    ,   0.3918028    ,   0.4125688    
     +,   0.4311031    ,   0.4477125    ,   0.4631100    
     +,   0.4780112    ,   0.4925830    ,   0.5060336    
     +,   0.5166526    ,   0.5223916    ,   0.5217364    
     +,   0.5143602    ,   0.5011770    ,   0.4837636    
     +,   0.4635714    ,   0.4414134    ,   0.4174912    
     +,   0.3918182    ,   0.3646892    ,   0.3369062    
     +,   0.3096810    ,   0.2843340    ,   0.2619657    
     +,   0.2432325    ,   0.2282718    ,   0.2167613    
     +,   0.2080828    ,   0.2015121    ,   0.1963780    
     +,   0.1921428    ,   0.1884030    ,   0.1848379    
     +,   0.1811536    ,   0.1770556    ,   0.1722649    
     +,   0.1665628    ,   0.1598373    ,   0.1521117    
     +,   0.1435411    ,   0.1343830    ,   0.1249483    
     +,   0.1155521    ,   0.1064734    ,   9.7929195E-02
     +,   9.0063140E-02,   8.2949698E-02,   7.6606207E-02
     +,   7.1007676E-02,   6.6102922E-02,   6.1828855E-02
     +,   5.8121037E-02,   5.4919712E-02,   5.2172441E-02
     +,   4.9834449E-02,   4.7867235E-02,   4.6235651E-02
     +,   4.4905927E-02,   4.3844011E-02,   4.3014448E-02
     +,   4.2380322E-02,   4.1903637E-02,   4.1546416E-02
     +,   4.1271646E-02,   4.1044302E-02,   4.0832501E-02
     +,   4.0608246E-02,   4.0347889E-02,   4.0032506E-02
     +,   3.9647978E-02,   3.9184917E-02,   3.8638383E-02
     +,   3.8007438E-02,   3.7294783E-02,   3.6506135E-02
     +,   3.5649527E-02,   3.4734756E-02,   3.3772815E-02
     +,   3.2775261E-02,   3.1753633E-02,   3.0718975E-02
     +,   2.9681634E-02,   2.8650818E-02,   2.7634343E-02
     +,   2.6638646E-02,   2.5668757E-02,   2.4728218E-02
     +,   2.3819258E-02,   2.2943011E-02,   2.2099607E-02
     +,   2.1288333E-02,   2.0507865E-02,   1.9756537E-02
     +,   1.9032445E-02,   1.8333517E-02,   1.7657742E-02
     +,   1.7003268E-02,   1.6368428E-02,   1.5751738E-02
     +,   1.5151978E-02,   1.4568202E-02,   1.3999652E-02
     +,   1.3445755E-02,   1.2906155E-02,   1.2380616E-02
     +,   1.1868960E-02,   1.1371085E-02,   1.0886954E-02
     +,   1.0416539E-02,   9.9597853E-03,   9.5166201E-03
     +,   9.0869814E-03,   8.6707771E-03,   8.2678609E-03
     +,   7.8780698E-03,   7.5012571E-03,   7.1372231E-03
     +,   6.7857583E-03,   6.4466712E-03,   6.1197658E-03
     +,   5.8048293E-03,   5.5016428E-03,   5.2100196E-03
     +,   4.9297726E-03,   4.6606958E-03,   4.4025891E-03
     +,   4.1552749E-03,   3.9185449E-03,   3.6922137E-03
     +,   3.4760637E-03,   3.2698978E-03,   3.0734853E-03
     +,   2.8866113E-03,   2.7090276E-03,   2.5405008E-03
     +,   2.3807639E-03,   2.2295644E-03,   2.0866250E-03
     +,   1.9516638E-03,   1.8244046E-03,   1.7045501E-03
     +,   1.5918170E-03,   1.4859032E-03,   1.3865215E-03
     +,   1.2933713E-03,   1.2061672E-03,   1.1246147E-03
     +,   1.0484352E-03,   9.7734411E-04,   9.1107312E-04
     +,   8.4935117E-04,   7.9192326E-04
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_hzonly_hatt90_mass = Yx/5.1159035
      RETURN
      END
      DOUBLE PRECISION FUNCTION A202_tt_hzonly_hatt95_mass(V)
      DOUBLE PRECISION V
      DOUBLE PRECISION Yx, LBOUND, UBOUND, RANGE
      DOUBLE PRECISION Y(301 )
      INTEGER NBINS, I
      DATA NBINS  / 300 /
      DATA LBOUND, UBOUND / 50., 120./
      DATA y /  1.6550103E-03,   1.7234329E-03
     +,   1.7948279E-03,   1.8693104E-03,   1.9469928E-03
     +,   2.0279842E-03,   2.1123851E-03,   2.2002892E-03
     +,   2.2917788E-03,   2.3869302E-03,   2.4857998E-03
     +,   2.5884314E-03,   2.6948510E-03,   2.8050668E-03
     +,   2.9190637E-03,   3.0368043E-03,   3.1582266E-03
     +,   3.2832429E-03,   3.4117352E-03,   3.5435599E-03
     +,   3.6785386E-03,   3.8164649E-03,   3.9570979E-03
     +,   4.1001746E-03,   4.2453809E-03,   4.3923911E-03
     +,   4.5408374E-03,   4.6903286E-03,   4.8404406E-03
     +,   4.9907290E-03,   5.1407223E-03,   5.2899336E-03
     +,   5.4378537E-03,   5.5839652E-03,   5.7277377E-03
     +,   5.8686407E-03,   6.0061356E-03,   6.1396938E-03
     +,   6.2688016E-03,   6.3929418E-03,   6.5116365E-03
     +,   6.6244206E-03,   6.7308596E-03,   6.8305568E-03
     +,   6.9231559E-03,   7.0083342E-03,   7.0858281E-03
     +,   7.1554175E-03,   7.2169402E-03,   7.2702938E-03
     +,   7.3154275E-03,   7.3523629E-03,   7.3811770E-03
     +,   7.4020107E-03,   7.4150776E-03,   7.4206446E-03
     +,   7.4190451E-03,   7.4106762E-03,   7.3959930E-03
     +,   7.3755090E-03,   7.3497933E-03,   7.3194643E-03
     +,   7.2851926E-03,   7.2476957E-03,   7.2077219E-03
     +,   7.1660769E-03,   7.1235858E-03,   7.0811147E-03
     +,   7.0395479E-03,   6.9998074E-03,   6.9628232E-03
     +,   6.9295540E-03,   6.9009657E-03,   6.8780473E-03
     +,   6.8617938E-03,   6.8532010E-03,   6.8532820E-03
     +,   6.8630474E-03,   6.8835076E-03,   6.9156787E-03
     +,   6.9605601E-03,   7.0191566E-03,   7.0924452E-03
     +,   7.1814018E-03,   7.2869668E-03,   7.4100625E-03
     +,   7.5515583E-03,   7.7122995E-03,   7.8930510E-03
     +,   8.0945268E-03,   8.3173672E-03,   8.5620983E-03
     +,   8.8291373E-03,   9.1187982E-03,   9.4312476E-03
     +,   9.7664632E-03,   1.0124290E-02,   1.0504338E-02
     +,   1.0906043E-02,   1.1328581E-02,   1.1770919E-02
     +,   1.2231737E-02,   1.2709508E-02,   1.3202385E-02
     +,   1.3708295E-02,   1.4224928E-02,   1.4749685E-02
     +,   1.5279736E-02,   1.5812069E-02,   1.6343532E-02
     +,   1.6870748E-02,   1.7390309E-02,   1.7898716E-02
     +,   1.8392507E-02,   1.8868228E-02,   1.9322602E-02
     +,   1.9752471E-02,   2.0154966E-02,   2.0527493E-02
     +,   2.0867826E-02,   2.1174191E-02,   2.1445246E-02
     +,   2.1680174E-02,   2.1878731E-02,   2.2041267E-02
     +,   2.2168728E-02,   2.2262683E-02,   2.2325367E-02
     +,   2.2359602E-02,   2.2368873E-02,   2.2357242E-02
     +,   2.2329373E-02,   2.2290511E-02,   2.2246439E-02
     +,   2.2203451E-02,   2.2168364E-02,   2.2148479E-02
     +,   2.2151567E-02,   2.2185870E-02,   2.2260074E-02
     +,   2.2383308E-02,   2.2565117E-02,   2.2815544E-02
     +,   2.3145020E-02,   2.3564413E-02,   2.4085015E-02
     +,   2.4718560E-02,   2.5477178E-02,   2.6373368E-02
     +,   2.7419981E-02,   2.8630117E-02,   3.0016804E-02
     +,   3.1592686E-02,   3.3369690E-02,   3.5358157E-02
     +,   3.7565790E-02,   3.9996482E-02,   4.2649150E-02
     +,   4.5516085E-02,   4.8581354E-02,   5.1820390E-02
     +,   5.5199482E-02,   5.8676723E-02,   6.2204890E-02
     +,   6.5735966E-02,   6.9227524E-02,   7.2650440E-02
     +,   7.5997703E-02,   7.9293258E-02,   8.2598627E-02
     +,   8.6017206E-02,   8.9697041E-02,   9.3830235E-02
     +,   9.8651215E-02,   0.1044309    ,   0.1114673    
     +,   0.1200624    ,   0.1304802    ,   0.1428884    
     +,   0.1572938    ,   0.1734989    ,   0.1911151    
     +,   0.2096684    ,   0.2287926    ,   0.2484655    
     +,   0.2692112    ,   0.2921680    ,   0.3189400    
     +,   0.3512022    ,   0.3900998    ,   0.4356039    
     +,   0.4860390    ,   0.5380974    ,   0.5875880    
     +,   0.6308243    ,   0.6660732    ,   0.6941255    
     +,   0.7173617    ,   0.7376541    ,   0.7544969    
     +,   0.7648208    ,   0.7647287    ,   0.7518326    
     +,   0.7265212    ,   0.6914798    ,   0.6502891    
     +,   0.6063052    ,   0.5622935    ,   0.5204598    
     +,   0.4824235    ,   0.4490718    ,   0.4204980    
     +,   0.3961354    ,   0.3750175    ,   0.3560414    
     +,   0.3381710    ,   0.3205658    ,   0.3026462    
     +,   0.2841048    ,   0.2648772    ,   0.2450978    
     +,   0.2250604    ,   0.2051748    ,   0.1859129    
     +,   0.1677401    ,   0.1510524    ,   0.1361266    
     +,   0.1230911    ,   0.1119241    ,   0.1024771    
     +,   9.4512880E-02,   8.7750018E-02,   8.1904516E-02
     +,   7.6723300E-02,   7.2004125E-02,   6.7600377E-02
     +,   6.3417248E-02,   5.9401631E-02,   5.5529259E-02
     +,   5.1793527E-02,   4.8197523E-02,   4.4748750E-02
     +,   4.1455965E-02,   3.8327355E-02,   3.5370067E-02
     +,   3.2589890E-02,   2.9990623E-02,   2.7573530E-02
     +,   2.5337381E-02,   2.3278551E-02,   2.1390758E-02
     +,   1.9665649E-02,   1.8093389E-02,   1.6663050E-02
     +,   1.5363079E-02,   1.4181885E-02,   1.3108313E-02
     +,   1.2131826E-02,   1.1242648E-02,   1.0431916E-02
     +,   9.6917646E-03,   9.0152109E-03,   8.3960434E-03
     +,   7.8287879E-03,   7.3086699E-03,   6.8313945E-03
     +,   6.3931327E-03,   5.9904698E-03,   5.6203138E-03
     +,   5.2798260E-03,   4.9664075E-03,   4.6776934E-03
     +,   4.4114990E-03,   4.1657947E-03,   3.9387122E-03
     +,   3.7285485E-03,   3.5337149E-03,   3.3527797E-03
     +,   3.1844145E-03,   3.0274300E-03,   2.8807337E-03
     +,   2.7433545E-03,   2.6144043E-03,   2.4931047E-03
     +,   2.3787445E-03,   2.2707062E-03,   2.1684295E-03
     +,   2.0714195E-03,   1.9792470E-03,   1.8915175E-03
     +,   1.8078961E-03,   1.7280726E-03,   1.6517838E-03
     +,   1.5787842E-03,   1.5088660E-03,   1.4418339E-03
     +,   1.3775222E-03,   1.3157738E-03,   1.2564559E-03
     +,   1.1994410E-03,   1.1446218E-03
     +/
      If((V.lt.Lbound).or.(V.ge.UBound)) THEN
      Yx = 0.0
      ELSE
      RANGE = UBOUND - LBOUND
      i = 1 + INT(NBINS*(V - LBOUND)/RANGE)
      Xi = (i-1)*RANGE/NBINS + LBOUND
      Yx = (y(i+1) - y(i))*NBINS*(V - Xi)/RANGE + y(i)
      END IF
      A202_tt_hzonly_hatt95_mass = Yx/6.0257085
      RETURN
      END
